#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 9775
#define LARGE_STATE_COUNT 2807
#define SYMBOL_COUNT 528
#define ALIAS_COUNT 5
#define TOKEN_COUNT 217
#define EXTERNAL_TOKEN_COUNT 2
#define FIELD_COUNT 50
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 214

enum ts_symbol_identifiers {
  sym_identifier = 1,
  aux_sym_preproc_include_token1 = 2,
  aux_sym_preproc_include_token2 = 3,
  aux_sym_preproc_def_token1 = 4,
  anon_sym_LPAREN = 5,
  anon_sym_DOT_DOT_DOT = 6,
  anon_sym_COMMA = 7,
  anon_sym_RPAREN = 8,
  aux_sym_preproc_if_token1 = 9,
  anon_sym_LF = 10,
  aux_sym_preproc_if_token2 = 11,
  aux_sym_preproc_ifdef_token1 = 12,
  aux_sym_preproc_ifdef_token2 = 13,
  aux_sym_preproc_else_token1 = 14,
  aux_sym_preproc_elif_token1 = 15,
  aux_sym_preproc_elifdef_token1 = 16,
  aux_sym_preproc_elifdef_token2 = 17,
  sym_preproc_arg = 18,
  sym_preproc_directive = 19,
  anon_sym_LPAREN2 = 20,
  anon_sym_defined = 21,
  anon_sym_BANG = 22,
  anon_sym_TILDE = 23,
  anon_sym_DASH = 24,
  anon_sym_PLUS = 25,
  anon_sym_STAR = 26,
  anon_sym_SLASH = 27,
  anon_sym_PERCENT = 28,
  anon_sym_PIPE_PIPE = 29,
  anon_sym_AMP_AMP = 30,
  anon_sym_PIPE = 31,
  anon_sym_CARET = 32,
  anon_sym_AMP = 33,
  anon_sym_EQ_EQ = 34,
  anon_sym_BANG_EQ = 35,
  anon_sym_GT = 36,
  anon_sym_GT_EQ = 37,
  anon_sym_LT_EQ = 38,
  anon_sym_LT = 39,
  anon_sym_LT_LT = 40,
  anon_sym_GT_GT = 41,
  anon_sym_SEMI = 42,
  anon_sym___extension__ = 43,
  anon_sym_typedef = 44,
  anon_sym_extern = 45,
  anon_sym___attribute__ = 46,
  anon_sym_COLON_COLON = 47,
  anon_sym_LBRACK_LBRACK = 48,
  anon_sym_RBRACK_RBRACK = 49,
  anon_sym___declspec = 50,
  anon_sym___based = 51,
  anon_sym___cdecl = 52,
  anon_sym___clrcall = 53,
  anon_sym___stdcall = 54,
  anon_sym___fastcall = 55,
  anon_sym___thiscall = 56,
  anon_sym___vectorcall = 57,
  sym_ms_restrict_modifier = 58,
  sym_ms_unsigned_ptr_modifier = 59,
  sym_ms_signed_ptr_modifier = 60,
  anon_sym__unaligned = 61,
  anon_sym___unaligned = 62,
  anon_sym_LBRACE = 63,
  anon_sym_RBRACE = 64,
  anon_sym_signed = 65,
  anon_sym_unsigned = 66,
  anon_sym_long = 67,
  anon_sym_short = 68,
  anon_sym_LBRACK = 69,
  anon_sym_RBRACK = 70,
  anon_sym_EQ = 71,
  anon_sym_static = 72,
  anon_sym_register = 73,
  anon_sym_inline = 74,
  anon_sym___inline = 75,
  anon_sym___inline__ = 76,
  anon_sym___forceinline = 77,
  anon_sym_thread_local = 78,
  anon_sym___thread = 79,
  anon_sym_const = 80,
  anon_sym_constexpr = 81,
  anon_sym_volatile = 82,
  anon_sym_restrict = 83,
  anon_sym___restrict__ = 84,
  anon_sym__Atomic = 85,
  anon_sym__Noreturn = 86,
  anon_sym_noreturn = 87,
  anon_sym_mutable = 88,
  anon_sym_constinit = 89,
  anon_sym_consteval = 90,
  anon_sym_PROGMEM = 91,
  aux_sym_primitive_type_token1 = 92,
  anon_sym_byte = 93,
  anon_sym_word = 94,
  anon_sym_enum = 95,
  anon_sym_class = 96,
  anon_sym_struct = 97,
  anon_sym_union = 98,
  anon_sym_COLON = 99,
  anon_sym_if = 100,
  anon_sym_else = 101,
  anon_sym_switch = 102,
  anon_sym_case = 103,
  anon_sym_default = 104,
  anon_sym_while = 105,
  anon_sym_do = 106,
  anon_sym_for = 107,
  anon_sym_return = 108,
  anon_sym_break = 109,
  anon_sym_continue = 110,
  anon_sym_goto = 111,
  anon_sym___try = 112,
  anon_sym___except = 113,
  anon_sym___finally = 114,
  anon_sym___leave = 115,
  anon_sym_QMARK = 116,
  anon_sym_STAR_EQ = 117,
  anon_sym_SLASH_EQ = 118,
  anon_sym_PERCENT_EQ = 119,
  anon_sym_PLUS_EQ = 120,
  anon_sym_DASH_EQ = 121,
  anon_sym_LT_LT_EQ = 122,
  anon_sym_GT_GT_EQ = 123,
  anon_sym_AMP_EQ = 124,
  anon_sym_CARET_EQ = 125,
  anon_sym_PIPE_EQ = 126,
  anon_sym_and_eq = 127,
  anon_sym_or_eq = 128,
  anon_sym_xor_eq = 129,
  anon_sym_not = 130,
  anon_sym_compl = 131,
  anon_sym_LT_EQ_GT = 132,
  anon_sym_or = 133,
  anon_sym_and = 134,
  anon_sym_bitor = 135,
  anon_sym_xor = 136,
  anon_sym_bitand = 137,
  anon_sym_not_eq = 138,
  anon_sym_DASH_DASH = 139,
  anon_sym_PLUS_PLUS = 140,
  anon_sym_sizeof = 141,
  anon_sym___alignof__ = 142,
  anon_sym___alignof = 143,
  anon_sym__alignof = 144,
  anon_sym_alignof = 145,
  anon_sym__Alignof = 146,
  anon_sym_offsetof = 147,
  anon_sym__Generic = 148,
  anon_sym_asm = 149,
  anon_sym___asm__ = 150,
  anon_sym_DOT = 151,
  anon_sym_DOT_STAR = 152,
  anon_sym_DASH_GT = 153,
  aux_sym_number_literal_token1 = 154,
  aux_sym_number_literal_token2 = 155,
  anon_sym_L_SQUOTE = 156,
  anon_sym_u_SQUOTE = 157,
  anon_sym_U_SQUOTE = 158,
  anon_sym_u8_SQUOTE = 159,
  anon_sym_SQUOTE = 160,
  aux_sym_char_literal_token1 = 161,
  anon_sym_L_DQUOTE = 162,
  anon_sym_u_DQUOTE = 163,
  anon_sym_U_DQUOTE = 164,
  anon_sym_u8_DQUOTE = 165,
  anon_sym_DQUOTE = 166,
  aux_sym_string_literal_token1 = 167,
  sym_escape_sequence = 168,
  sym_system_lib_string = 169,
  sym_true = 170,
  sym_false = 171,
  anon_sym_NULL = 172,
  anon_sym_nullptr = 173,
  sym_comment = 174,
  sym_auto = 175,
  anon_sym_decltype = 176,
  anon_sym_final = 177,
  anon_sym_override = 178,
  anon_sym_virtual = 179,
  anon_sym_alignas = 180,
  anon_sym_explicit = 181,
  anon_sym_typename = 182,
  anon_sym_template = 183,
  anon_sym_GT2 = 184,
  anon_sym_operator = 185,
  anon_sym_try = 186,
  anon_sym_delete = 187,
  anon_sym_friend = 188,
  anon_sym_public = 189,
  anon_sym_private = 190,
  anon_sym_protected = 191,
  anon_sym_noexcept = 192,
  anon_sym_throw = 193,
  anon_sym_namespace = 194,
  anon_sym_using = 195,
  anon_sym_static_assert = 196,
  anon_sym_concept = 197,
  anon_sym_co_return = 198,
  anon_sym_co_yield = 199,
  anon_sym_catch = 200,
  anon_sym_R_DQUOTE = 201,
  anon_sym_LR_DQUOTE = 202,
  anon_sym_uR_DQUOTE = 203,
  anon_sym_UR_DQUOTE = 204,
  anon_sym_u8R_DQUOTE = 205,
  anon_sym_co_await = 206,
  anon_sym_new = 207,
  anon_sym_requires = 208,
  anon_sym_DASH_GT_STAR = 209,
  anon_sym_LPAREN_RPAREN = 210,
  anon_sym_LBRACK_RBRACK = 211,
  anon_sym_DQUOTE_DQUOTE = 212,
  sym_this = 213,
  sym_literal_suffix = 214,
  sym_raw_string_delimiter = 215,
  sym_raw_string_content = 216,
  sym_translation_unit = 217,
  sym_preproc_include = 218,
  sym_preproc_def = 219,
  sym_preproc_function_def = 220,
  sym_preproc_params = 221,
  sym_preproc_call = 222,
  sym_preproc_if = 223,
  sym_preproc_ifdef = 224,
  sym_preproc_else = 225,
  sym_preproc_elif = 226,
  sym_preproc_elifdef = 227,
  sym_preproc_if_in_field_declaration_list = 228,
  sym_preproc_ifdef_in_field_declaration_list = 229,
  sym_preproc_else_in_field_declaration_list = 230,
  sym_preproc_elif_in_field_declaration_list = 231,
  sym_preproc_elifdef_in_field_declaration_list = 232,
  sym_preproc_if_in_enumerator_list = 233,
  sym_preproc_ifdef_in_enumerator_list = 234,
  sym_preproc_else_in_enumerator_list = 235,
  sym_preproc_elif_in_enumerator_list = 236,
  sym_preproc_elifdef_in_enumerator_list = 237,
  sym_preproc_if_in_enumerator_list_no_comma = 238,
  sym_preproc_ifdef_in_enumerator_list_no_comma = 239,
  sym_preproc_else_in_enumerator_list_no_comma = 240,
  sym_preproc_elif_in_enumerator_list_no_comma = 241,
  sym_preproc_elifdef_in_enumerator_list_no_comma = 242,
  sym__preproc_expression = 243,
  sym_preproc_parenthesized_expression = 244,
  sym_preproc_defined = 245,
  sym_preproc_unary_expression = 246,
  sym_preproc_call_expression = 247,
  sym_preproc_argument_list = 248,
  sym_preproc_binary_expression = 249,
  sym_function_definition = 250,
  sym_declaration = 251,
  sym_type_definition = 252,
  sym__type_definition_type = 253,
  sym__type_definition_declarators = 254,
  sym__declaration_modifiers = 255,
  sym__declaration_specifiers = 256,
  sym_linkage_specification = 257,
  sym_attribute_specifier = 258,
  sym_attribute = 259,
  sym_attribute_declaration = 260,
  sym_ms_declspec_modifier = 261,
  sym_ms_based_modifier = 262,
  sym_ms_call_modifier = 263,
  sym_ms_unaligned_ptr_modifier = 264,
  sym_ms_pointer_modifier = 265,
  sym_declaration_list = 266,
  sym__declarator = 267,
  sym__field_declarator = 268,
  sym__type_declarator = 269,
  sym__abstract_declarator = 270,
  sym_parenthesized_declarator = 271,
  sym_parenthesized_field_declarator = 272,
  sym_parenthesized_type_declarator = 273,
  sym_abstract_parenthesized_declarator = 274,
  sym_attributed_declarator = 275,
  sym_attributed_field_declarator = 276,
  sym_attributed_type_declarator = 277,
  sym_pointer_declarator = 278,
  sym_pointer_field_declarator = 279,
  sym_pointer_type_declarator = 280,
  sym_abstract_pointer_declarator = 281,
  sym_function_declarator = 282,
  sym_function_field_declarator = 283,
  sym_function_type_declarator = 284,
  sym_abstract_function_declarator = 285,
  sym_array_declarator = 286,
  sym_array_field_declarator = 287,
  sym_array_type_declarator = 288,
  sym_abstract_array_declarator = 289,
  sym_init_declarator = 290,
  sym_compound_statement = 291,
  sym_storage_class_specifier = 292,
  sym_type_qualifier = 293,
  sym__type_specifier = 294,
  sym_sized_type_specifier = 295,
  sym_primitive_type = 296,
  sym_enum_specifier = 297,
  sym_enumerator_list = 298,
  sym_struct_specifier = 299,
  sym_union_specifier = 300,
  sym_field_declaration_list = 301,
  sym__field_declaration_list_item = 302,
  sym_field_declaration = 303,
  sym_bitfield_clause = 304,
  sym_enumerator = 305,
  sym_parameter_list = 306,
  sym_parameter_declaration = 307,
  sym_attributed_statement = 308,
  sym_labeled_statement = 309,
  sym__top_level_expression_statement = 310,
  sym_expression_statement = 311,
  sym_if_statement = 312,
  sym_else_clause = 313,
  sym_switch_statement = 314,
  sym_case_statement = 315,
  sym_while_statement = 316,
  sym_do_statement = 317,
  sym_for_statement = 318,
  sym__for_statement_body = 319,
  sym_return_statement = 320,
  sym_break_statement = 321,
  sym_continue_statement = 322,
  sym_goto_statement = 323,
  sym_seh_try_statement = 324,
  sym_seh_except_clause = 325,
  sym_seh_finally_clause = 326,
  sym_seh_leave_statement = 327,
  sym__expression = 328,
  sym__expression_not_binary = 329,
  sym__string = 330,
  sym_comma_expression = 331,
  sym_conditional_expression = 332,
  sym_assignment_expression = 333,
  sym_pointer_expression = 334,
  sym_unary_expression = 335,
  sym_binary_expression = 336,
  sym_update_expression = 337,
  sym_cast_expression = 338,
  sym_type_descriptor = 339,
  sym_sizeof_expression = 340,
  sym_alignof_expression = 341,
  sym_offsetof_expression = 342,
  sym_generic_expression = 343,
  sym_subscript_expression = 344,
  sym_call_expression = 345,
  sym_gnu_asm_expression = 346,
  sym_gnu_asm_qualifier = 347,
  sym_gnu_asm_output_operand_list = 348,
  sym_gnu_asm_output_operand = 349,
  sym_gnu_asm_input_operand_list = 350,
  sym_gnu_asm_input_operand = 351,
  sym_gnu_asm_clobber_list = 352,
  sym_gnu_asm_goto_list = 353,
  sym_argument_list = 354,
  sym_field_expression = 355,
  sym_compound_literal_expression = 356,
  sym_parenthesized_expression = 357,
  sym_initializer_list = 358,
  sym_initializer_pair = 359,
  sym_subscript_designator = 360,
  sym_subscript_range_designator = 361,
  sym_field_designator = 362,
  sym_number_literal = 363,
  sym_char_literal = 364,
  sym_concatenated_string = 365,
  sym_string_literal = 366,
  sym_null = 367,
  sym__empty_declaration = 368,
  sym_placeholder_type_specifier = 369,
  sym_decltype_auto = 370,
  sym_decltype = 371,
  sym__class_declaration = 372,
  sym__class_declaration_item = 373,
  sym_class_specifier = 374,
  sym__class_name = 375,
  sym_virtual_specifier = 376,
  sym_virtual = 377,
  sym_alignas_specifier = 378,
  sym_explicit_function_specifier = 379,
  sym_base_class_clause = 380,
  sym__enum_base_clause = 381,
  sym_dependent_type = 382,
  sym_template_declaration = 383,
  sym_template_instantiation = 384,
  sym_template_parameter_list = 385,
  sym_type_parameter_declaration = 386,
  sym_variadic_type_parameter_declaration = 387,
  sym_optional_type_parameter_declaration = 388,
  sym_template_template_parameter_declaration = 389,
  sym_optional_parameter_declaration = 390,
  sym_variadic_parameter_declaration = 391,
  sym_variadic_declarator = 392,
  sym_variadic_reference_declarator = 393,
  sym_operator_cast = 394,
  sym_field_initializer_list = 395,
  sym_field_initializer = 396,
  sym_inline_method_definition = 397,
  sym__constructor_specifiers = 398,
  sym_operator_cast_definition = 399,
  sym_operator_cast_declaration = 400,
  sym_constructor_try_statement = 401,
  sym_constructor_or_destructor_definition = 402,
  sym_constructor_or_destructor_declaration = 403,
  sym_default_method_clause = 404,
  sym_delete_method_clause = 405,
  sym_friend_declaration = 406,
  sym_access_specifier = 407,
  sym_reference_declarator = 408,
  sym_reference_field_declarator = 409,
  sym_abstract_reference_declarator = 410,
  sym_structured_binding_declarator = 411,
  sym_ref_qualifier = 412,
  sym__function_declarator_seq = 413,
  sym__function_attributes_start = 414,
  sym__function_exception_specification = 415,
  sym__function_attributes_end = 416,
  sym__function_postfix = 417,
  sym_trailing_return_type = 418,
  sym_noexcept = 419,
  sym_throw_specifier = 420,
  sym_template_type = 421,
  sym_template_method = 422,
  sym_template_function = 423,
  sym_template_argument_list = 424,
  sym_namespace_definition = 425,
  sym_namespace_alias_definition = 426,
  sym__namespace_specifier = 427,
  sym_nested_namespace_specifier = 428,
  sym_using_declaration = 429,
  sym_alias_declaration = 430,
  sym_static_assert_declaration = 431,
  sym_concept_definition = 432,
  sym_for_range_loop = 433,
  sym__for_range_loop_body = 434,
  sym_init_statement = 435,
  sym_condition_clause = 436,
  sym_condition_declaration = 437,
  sym_co_return_statement = 438,
  sym_co_yield_statement = 439,
  sym_throw_statement = 440,
  sym_try_statement = 441,
  sym_catch_clause = 442,
  sym_raw_string_literal = 443,
  sym_subscript_argument_list = 444,
  sym_co_await_expression = 445,
  sym_new_expression = 446,
  sym_new_declarator = 447,
  sym_delete_expression = 448,
  sym_type_requirement = 449,
  sym_compound_requirement = 450,
  sym__requirement = 451,
  sym_requirement_seq = 452,
  sym_constraint_conjunction = 453,
  sym_constraint_disjunction = 454,
  sym__requirement_clause_constraint = 455,
  sym_requires_clause = 456,
  sym_requires_parameter_list = 457,
  sym_requires_expression = 458,
  sym_lambda_expression = 459,
  sym_lambda_capture_specifier = 460,
  sym_lambda_default_capture = 461,
  sym__fold_operator = 462,
  sym__binary_fold_operator = 463,
  sym__unary_left_fold = 464,
  sym__unary_right_fold = 465,
  sym__binary_fold = 466,
  sym_fold_expression = 467,
  sym_parameter_pack_expansion = 468,
  sym_type_parameter_pack_expansion = 469,
  sym_destructor_name = 470,
  sym_dependent_identifier = 471,
  sym_dependent_field_identifier = 472,
  sym_dependent_type_identifier = 473,
  sym__scope_resolution = 474,
  sym_qualified_field_identifier = 475,
  sym_qualified_identifier = 476,
  sym_qualified_type_identifier = 477,
  sym_qualified_operator_cast_identifier = 478,
  sym__assignment_expression_lhs = 479,
  sym_operator_name = 480,
  sym_user_defined_literal = 481,
  aux_sym_translation_unit_repeat1 = 482,
  aux_sym_preproc_params_repeat1 = 483,
  aux_sym_preproc_if_repeat1 = 484,
  aux_sym_preproc_if_in_field_declaration_list_repeat1 = 485,
  aux_sym_preproc_if_in_enumerator_list_repeat1 = 486,
  aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1 = 487,
  aux_sym_preproc_argument_list_repeat1 = 488,
  aux_sym_declaration_repeat1 = 489,
  aux_sym_type_definition_repeat1 = 490,
  aux_sym__type_definition_type_repeat1 = 491,
  aux_sym__type_definition_declarators_repeat1 = 492,
  aux_sym__declaration_specifiers_repeat1 = 493,
  aux_sym_attribute_declaration_repeat1 = 494,
  aux_sym_attributed_declarator_repeat1 = 495,
  aux_sym_pointer_declarator_repeat1 = 496,
  aux_sym_sized_type_specifier_repeat1 = 497,
  aux_sym_enumerator_list_repeat1 = 498,
  aux_sym_field_declaration_repeat1 = 499,
  aux_sym_parameter_list_repeat1 = 500,
  aux_sym_case_statement_repeat1 = 501,
  aux_sym_generic_expression_repeat1 = 502,
  aux_sym_gnu_asm_expression_repeat1 = 503,
  aux_sym_gnu_asm_output_operand_list_repeat1 = 504,
  aux_sym_gnu_asm_input_operand_list_repeat1 = 505,
  aux_sym_gnu_asm_clobber_list_repeat1 = 506,
  aux_sym_gnu_asm_goto_list_repeat1 = 507,
  aux_sym_argument_list_repeat1 = 508,
  aux_sym_initializer_list_repeat1 = 509,
  aux_sym_initializer_pair_repeat1 = 510,
  aux_sym_char_literal_repeat1 = 511,
  aux_sym_concatenated_string_repeat1 = 512,
  aux_sym_string_literal_repeat1 = 513,
  aux_sym__class_declaration_repeat1 = 514,
  aux_sym_base_class_clause_repeat1 = 515,
  aux_sym_template_parameter_list_repeat1 = 516,
  aux_sym_field_initializer_list_repeat1 = 517,
  aux_sym_operator_cast_definition_repeat1 = 518,
  aux_sym_constructor_try_statement_repeat1 = 519,
  aux_sym_structured_binding_declarator_repeat1 = 520,
  aux_sym__function_postfix_repeat1 = 521,
  aux_sym_throw_specifier_repeat1 = 522,
  aux_sym_template_argument_list_repeat1 = 523,
  aux_sym_subscript_argument_list_repeat1 = 524,
  aux_sym_requirement_seq_repeat1 = 525,
  aux_sym_requires_parameter_list_repeat1 = 526,
  aux_sym_lambda_capture_specifier_repeat1 = 527,
  alias_sym_field_identifier = 528,
  alias_sym_namespace_identifier = 529,
  alias_sym_simple_requirement = 530,
  alias_sym_statement_identifier = 531,
  alias_sym_type_identifier = 532,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [aux_sym_preproc_include_token1] = "#include",
  [aux_sym_preproc_include_token2] = "preproc_include_token2",
  [aux_sym_preproc_def_token1] = "#define",
  [anon_sym_LPAREN] = "(",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [aux_sym_preproc_if_token1] = "#if",
  [anon_sym_LF] = "\n",
  [aux_sym_preproc_if_token2] = "#endif",
  [aux_sym_preproc_ifdef_token1] = "#ifdef",
  [aux_sym_preproc_ifdef_token2] = "#ifndef",
  [aux_sym_preproc_else_token1] = "#else",
  [aux_sym_preproc_elif_token1] = "#elif",
  [aux_sym_preproc_elifdef_token1] = "#elifdef",
  [aux_sym_preproc_elifdef_token2] = "#elifndef",
  [sym_preproc_arg] = "preproc_arg",
  [sym_preproc_directive] = "preproc_directive",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_defined] = "defined",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS] = "+",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_AMP] = "&",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_SEMI] = ";",
  [anon_sym___extension__] = "__extension__",
  [anon_sym_typedef] = "typedef",
  [anon_sym_extern] = "extern",
  [anon_sym___attribute__] = "__attribute__",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym___declspec] = "__declspec",
  [anon_sym___based] = "__based",
  [anon_sym___cdecl] = "__cdecl",
  [anon_sym___clrcall] = "__clrcall",
  [anon_sym___stdcall] = "__stdcall",
  [anon_sym___fastcall] = "__fastcall",
  [anon_sym___thiscall] = "__thiscall",
  [anon_sym___vectorcall] = "__vectorcall",
  [sym_ms_restrict_modifier] = "ms_restrict_modifier",
  [sym_ms_unsigned_ptr_modifier] = "ms_unsigned_ptr_modifier",
  [sym_ms_signed_ptr_modifier] = "ms_signed_ptr_modifier",
  [anon_sym__unaligned] = "_unaligned",
  [anon_sym___unaligned] = "__unaligned",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_signed] = "signed",
  [anon_sym_unsigned] = "unsigned",
  [anon_sym_long] = "long",
  [anon_sym_short] = "short",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_EQ] = "=",
  [anon_sym_static] = "static",
  [anon_sym_register] = "register",
  [anon_sym_inline] = "inline",
  [anon_sym___inline] = "__inline",
  [anon_sym___inline__] = "__inline__",
  [anon_sym___forceinline] = "__forceinline",
  [anon_sym_thread_local] = "thread_local",
  [anon_sym___thread] = "__thread",
  [anon_sym_const] = "const",
  [anon_sym_constexpr] = "constexpr",
  [anon_sym_volatile] = "volatile",
  [anon_sym_restrict] = "restrict",
  [anon_sym___restrict__] = "__restrict__",
  [anon_sym__Atomic] = "_Atomic",
  [anon_sym__Noreturn] = "_Noreturn",
  [anon_sym_noreturn] = "noreturn",
  [anon_sym_mutable] = "mutable",
  [anon_sym_constinit] = "constinit",
  [anon_sym_consteval] = "consteval",
  [anon_sym_PROGMEM] = "PROGMEM",
  [aux_sym_primitive_type_token1] = "primitive_type_token1",
  [anon_sym_byte] = "byte",
  [anon_sym_word] = "word",
  [anon_sym_enum] = "enum",
  [anon_sym_class] = "class",
  [anon_sym_struct] = "struct",
  [anon_sym_union] = "union",
  [anon_sym_COLON] = ":",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_for] = "for",
  [anon_sym_return] = "return",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_goto] = "goto",
  [anon_sym___try] = "__try",
  [anon_sym___except] = "__except",
  [anon_sym___finally] = "__finally",
  [anon_sym___leave] = "__leave",
  [anon_sym_QMARK] = "\?",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_and_eq] = "and_eq",
  [anon_sym_or_eq] = "or_eq",
  [anon_sym_xor_eq] = "xor_eq",
  [anon_sym_not] = "not",
  [anon_sym_compl] = "compl",
  [anon_sym_LT_EQ_GT] = "<=>",
  [anon_sym_or] = "or",
  [anon_sym_and] = "and",
  [anon_sym_bitor] = "bitor",
  [anon_sym_xor] = "xor",
  [anon_sym_bitand] = "bitand",
  [anon_sym_not_eq] = "not_eq",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_sizeof] = "sizeof",
  [anon_sym___alignof__] = "__alignof__",
  [anon_sym___alignof] = "__alignof",
  [anon_sym__alignof] = "_alignof",
  [anon_sym_alignof] = "alignof",
  [anon_sym__Alignof] = "_Alignof",
  [anon_sym_offsetof] = "offsetof",
  [anon_sym__Generic] = "_Generic",
  [anon_sym_asm] = "asm",
  [anon_sym___asm__] = "__asm__",
  [anon_sym_DOT] = ".",
  [anon_sym_DOT_STAR] = ".*",
  [anon_sym_DASH_GT] = "->",
  [aux_sym_number_literal_token1] = "number_literal_token1",
  [aux_sym_number_literal_token2] = "number_literal_token2",
  [anon_sym_L_SQUOTE] = "L'",
  [anon_sym_u_SQUOTE] = "u'",
  [anon_sym_U_SQUOTE] = "U'",
  [anon_sym_u8_SQUOTE] = "u8'",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_char_literal_token1] = "character",
  [anon_sym_L_DQUOTE] = "L\"",
  [anon_sym_u_DQUOTE] = "u\"",
  [anon_sym_U_DQUOTE] = "U\"",
  [anon_sym_u8_DQUOTE] = "u8\"",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_literal_token1] = "string_content",
  [sym_escape_sequence] = "escape_sequence",
  [sym_system_lib_string] = "system_lib_string",
  [sym_true] = "true",
  [sym_false] = "false",
  [anon_sym_NULL] = "NULL",
  [anon_sym_nullptr] = "nullptr",
  [sym_comment] = "comment",
  [sym_auto] = "auto",
  [anon_sym_decltype] = "decltype",
  [anon_sym_final] = "final",
  [anon_sym_override] = "override",
  [anon_sym_virtual] = "virtual",
  [anon_sym_alignas] = "alignas",
  [anon_sym_explicit] = "explicit",
  [anon_sym_typename] = "typename",
  [anon_sym_template] = "template",
  [anon_sym_GT2] = ">",
  [anon_sym_operator] = "operator",
  [anon_sym_try] = "try",
  [anon_sym_delete] = "delete",
  [anon_sym_friend] = "friend",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_noexcept] = "noexcept",
  [anon_sym_throw] = "throw",
  [anon_sym_namespace] = "namespace",
  [anon_sym_using] = "using",
  [anon_sym_static_assert] = "static_assert",
  [anon_sym_concept] = "concept",
  [anon_sym_co_return] = "co_return",
  [anon_sym_co_yield] = "co_yield",
  [anon_sym_catch] = "catch",
  [anon_sym_R_DQUOTE] = "R\"",
  [anon_sym_LR_DQUOTE] = "LR\"",
  [anon_sym_uR_DQUOTE] = "uR\"",
  [anon_sym_UR_DQUOTE] = "UR\"",
  [anon_sym_u8R_DQUOTE] = "u8R\"",
  [anon_sym_co_await] = "co_await",
  [anon_sym_new] = "new",
  [anon_sym_requires] = "requires",
  [anon_sym_DASH_GT_STAR] = "->*",
  [anon_sym_LPAREN_RPAREN] = "()",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_DQUOTE_DQUOTE] = "\"\"",
  [sym_this] = "this",
  [sym_literal_suffix] = "literal_suffix",
  [sym_raw_string_delimiter] = "raw_string_delimiter",
  [sym_raw_string_content] = "raw_string_content",
  [sym_translation_unit] = "translation_unit",
  [sym_preproc_include] = "preproc_include",
  [sym_preproc_def] = "preproc_def",
  [sym_preproc_function_def] = "preproc_function_def",
  [sym_preproc_params] = "preproc_params",
  [sym_preproc_call] = "preproc_call",
  [sym_preproc_if] = "preproc_if",
  [sym_preproc_ifdef] = "preproc_ifdef",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_elif] = "preproc_elif",
  [sym_preproc_elifdef] = "preproc_elifdef",
  [sym_preproc_if_in_field_declaration_list] = "preproc_if",
  [sym_preproc_ifdef_in_field_declaration_list] = "preproc_ifdef",
  [sym_preproc_else_in_field_declaration_list] = "preproc_else",
  [sym_preproc_elif_in_field_declaration_list] = "preproc_elif",
  [sym_preproc_elifdef_in_field_declaration_list] = "preproc_elifdef",
  [sym_preproc_if_in_enumerator_list] = "preproc_if",
  [sym_preproc_ifdef_in_enumerator_list] = "preproc_ifdef",
  [sym_preproc_else_in_enumerator_list] = "preproc_else",
  [sym_preproc_elif_in_enumerator_list] = "preproc_elif",
  [sym_preproc_elifdef_in_enumerator_list] = "preproc_elifdef",
  [sym_preproc_if_in_enumerator_list_no_comma] = "preproc_if",
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = "preproc_ifdef",
  [sym_preproc_else_in_enumerator_list_no_comma] = "preproc_else",
  [sym_preproc_elif_in_enumerator_list_no_comma] = "preproc_elif",
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = "preproc_elifdef",
  [sym__preproc_expression] = "_preproc_expression",
  [sym_preproc_parenthesized_expression] = "parenthesized_expression",
  [sym_preproc_defined] = "preproc_defined",
  [sym_preproc_unary_expression] = "unary_expression",
  [sym_preproc_call_expression] = "call_expression",
  [sym_preproc_argument_list] = "argument_list",
  [sym_preproc_binary_expression] = "binary_expression",
  [sym_function_definition] = "function_definition",
  [sym_declaration] = "declaration",
  [sym_type_definition] = "type_definition",
  [sym__type_definition_type] = "_type_definition_type",
  [sym__type_definition_declarators] = "_type_definition_declarators",
  [sym__declaration_modifiers] = "_declaration_modifiers",
  [sym__declaration_specifiers] = "_declaration_specifiers",
  [sym_linkage_specification] = "linkage_specification",
  [sym_attribute_specifier] = "attribute_specifier",
  [sym_attribute] = "attribute",
  [sym_attribute_declaration] = "attribute_declaration",
  [sym_ms_declspec_modifier] = "ms_declspec_modifier",
  [sym_ms_based_modifier] = "ms_based_modifier",
  [sym_ms_call_modifier] = "ms_call_modifier",
  [sym_ms_unaligned_ptr_modifier] = "ms_unaligned_ptr_modifier",
  [sym_ms_pointer_modifier] = "ms_pointer_modifier",
  [sym_declaration_list] = "declaration_list",
  [sym__declarator] = "_declarator",
  [sym__field_declarator] = "_field_declarator",
  [sym__type_declarator] = "_type_declarator",
  [sym__abstract_declarator] = "_abstract_declarator",
  [sym_parenthesized_declarator] = "parenthesized_declarator",
  [sym_parenthesized_field_declarator] = "parenthesized_declarator",
  [sym_parenthesized_type_declarator] = "parenthesized_declarator",
  [sym_abstract_parenthesized_declarator] = "abstract_parenthesized_declarator",
  [sym_attributed_declarator] = "attributed_declarator",
  [sym_attributed_field_declarator] = "attributed_declarator",
  [sym_attributed_type_declarator] = "attributed_declarator",
  [sym_pointer_declarator] = "pointer_declarator",
  [sym_pointer_field_declarator] = "pointer_declarator",
  [sym_pointer_type_declarator] = "pointer_type_declarator",
  [sym_abstract_pointer_declarator] = "abstract_pointer_declarator",
  [sym_function_declarator] = "function_declarator",
  [sym_function_field_declarator] = "function_declarator",
  [sym_function_type_declarator] = "function_declarator",
  [sym_abstract_function_declarator] = "abstract_function_declarator",
  [sym_array_declarator] = "array_declarator",
  [sym_array_field_declarator] = "array_declarator",
  [sym_array_type_declarator] = "array_declarator",
  [sym_abstract_array_declarator] = "abstract_array_declarator",
  [sym_init_declarator] = "init_declarator",
  [sym_compound_statement] = "compound_statement",
  [sym_storage_class_specifier] = "storage_class_specifier",
  [sym_type_qualifier] = "type_qualifier",
  [sym__type_specifier] = "_type_specifier",
  [sym_sized_type_specifier] = "sized_type_specifier",
  [sym_primitive_type] = "primitive_type",
  [sym_enum_specifier] = "enum_specifier",
  [sym_enumerator_list] = "enumerator_list",
  [sym_struct_specifier] = "struct_specifier",
  [sym_union_specifier] = "union_specifier",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym__field_declaration_list_item] = "_field_declaration_list_item",
  [sym_field_declaration] = "field_declaration",
  [sym_bitfield_clause] = "bitfield_clause",
  [sym_enumerator] = "enumerator",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_attributed_statement] = "attributed_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym__top_level_expression_statement] = "expression_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym_else_clause] = "else_clause",
  [sym_switch_statement] = "switch_statement",
  [sym_case_statement] = "case_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym__for_statement_body] = "_for_statement_body",
  [sym_return_statement] = "return_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_goto_statement] = "goto_statement",
  [sym_seh_try_statement] = "seh_try_statement",
  [sym_seh_except_clause] = "seh_except_clause",
  [sym_seh_finally_clause] = "seh_finally_clause",
  [sym_seh_leave_statement] = "seh_leave_statement",
  [sym__expression] = "_expression",
  [sym__expression_not_binary] = "_expression_not_binary",
  [sym__string] = "_string",
  [sym_comma_expression] = "comma_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_pointer_expression] = "pointer_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_update_expression] = "update_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_type_descriptor] = "type_descriptor",
  [sym_sizeof_expression] = "sizeof_expression",
  [sym_alignof_expression] = "alignof_expression",
  [sym_offsetof_expression] = "offsetof_expression",
  [sym_generic_expression] = "generic_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_call_expression] = "call_expression",
  [sym_gnu_asm_expression] = "gnu_asm_expression",
  [sym_gnu_asm_qualifier] = "gnu_asm_qualifier",
  [sym_gnu_asm_output_operand_list] = "gnu_asm_output_operand_list",
  [sym_gnu_asm_output_operand] = "gnu_asm_output_operand",
  [sym_gnu_asm_input_operand_list] = "gnu_asm_input_operand_list",
  [sym_gnu_asm_input_operand] = "gnu_asm_input_operand",
  [sym_gnu_asm_clobber_list] = "gnu_asm_clobber_list",
  [sym_gnu_asm_goto_list] = "gnu_asm_goto_list",
  [sym_argument_list] = "argument_list",
  [sym_field_expression] = "field_expression",
  [sym_compound_literal_expression] = "compound_literal_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_initializer_list] = "initializer_list",
  [sym_initializer_pair] = "initializer_pair",
  [sym_subscript_designator] = "subscript_designator",
  [sym_subscript_range_designator] = "subscript_range_designator",
  [sym_field_designator] = "field_designator",
  [sym_number_literal] = "number_literal",
  [sym_char_literal] = "char_literal",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string_literal] = "string_literal",
  [sym_null] = "null",
  [sym__empty_declaration] = "_empty_declaration",
  [sym_placeholder_type_specifier] = "placeholder_type_specifier",
  [sym_decltype_auto] = "decltype",
  [sym_decltype] = "decltype",
  [sym__class_declaration] = "_class_declaration",
  [sym__class_declaration_item] = "_class_declaration_item",
  [sym_class_specifier] = "class_specifier",
  [sym__class_name] = "_class_name",
  [sym_virtual_specifier] = "virtual_specifier",
  [sym_virtual] = "virtual",
  [sym_alignas_specifier] = "alignas_specifier",
  [sym_explicit_function_specifier] = "explicit_function_specifier",
  [sym_base_class_clause] = "base_class_clause",
  [sym__enum_base_clause] = "_enum_base_clause",
  [sym_dependent_type] = "dependent_type",
  [sym_template_declaration] = "template_declaration",
  [sym_template_instantiation] = "template_instantiation",
  [sym_template_parameter_list] = "template_parameter_list",
  [sym_type_parameter_declaration] = "type_parameter_declaration",
  [sym_variadic_type_parameter_declaration] = "variadic_type_parameter_declaration",
  [sym_optional_type_parameter_declaration] = "optional_type_parameter_declaration",
  [sym_template_template_parameter_declaration] = "template_template_parameter_declaration",
  [sym_optional_parameter_declaration] = "optional_parameter_declaration",
  [sym_variadic_parameter_declaration] = "variadic_parameter_declaration",
  [sym_variadic_declarator] = "variadic_declarator",
  [sym_variadic_reference_declarator] = "reference_declarator",
  [sym_operator_cast] = "operator_cast",
  [sym_field_initializer_list] = "field_initializer_list",
  [sym_field_initializer] = "field_initializer",
  [sym_inline_method_definition] = "function_definition",
  [sym__constructor_specifiers] = "_constructor_specifiers",
  [sym_operator_cast_definition] = "function_definition",
  [sym_operator_cast_declaration] = "declaration",
  [sym_constructor_try_statement] = "try_statement",
  [sym_constructor_or_destructor_definition] = "function_definition",
  [sym_constructor_or_destructor_declaration] = "declaration",
  [sym_default_method_clause] = "default_method_clause",
  [sym_delete_method_clause] = "delete_method_clause",
  [sym_friend_declaration] = "friend_declaration",
  [sym_access_specifier] = "access_specifier",
  [sym_reference_declarator] = "reference_declarator",
  [sym_reference_field_declarator] = "reference_declarator",
  [sym_abstract_reference_declarator] = "abstract_reference_declarator",
  [sym_structured_binding_declarator] = "structured_binding_declarator",
  [sym_ref_qualifier] = "ref_qualifier",
  [sym__function_declarator_seq] = "_function_declarator_seq",
  [sym__function_attributes_start] = "_function_attributes_start",
  [sym__function_exception_specification] = "_function_exception_specification",
  [sym__function_attributes_end] = "_function_attributes_end",
  [sym__function_postfix] = "_function_postfix",
  [sym_trailing_return_type] = "trailing_return_type",
  [sym_noexcept] = "noexcept",
  [sym_throw_specifier] = "throw_specifier",
  [sym_template_type] = "template_type",
  [sym_template_method] = "template_method",
  [sym_template_function] = "template_function",
  [sym_template_argument_list] = "template_argument_list",
  [sym_namespace_definition] = "namespace_definition",
  [sym_namespace_alias_definition] = "namespace_alias_definition",
  [sym__namespace_specifier] = "_namespace_specifier",
  [sym_nested_namespace_specifier] = "nested_namespace_specifier",
  [sym_using_declaration] = "using_declaration",
  [sym_alias_declaration] = "alias_declaration",
  [sym_static_assert_declaration] = "static_assert_declaration",
  [sym_concept_definition] = "concept_definition",
  [sym_for_range_loop] = "for_range_loop",
  [sym__for_range_loop_body] = "_for_range_loop_body",
  [sym_init_statement] = "init_statement",
  [sym_condition_clause] = "condition_clause",
  [sym_condition_declaration] = "declaration",
  [sym_co_return_statement] = "co_return_statement",
  [sym_co_yield_statement] = "co_yield_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_raw_string_literal] = "raw_string_literal",
  [sym_subscript_argument_list] = "subscript_argument_list",
  [sym_co_await_expression] = "co_await_expression",
  [sym_new_expression] = "new_expression",
  [sym_new_declarator] = "new_declarator",
  [sym_delete_expression] = "delete_expression",
  [sym_type_requirement] = "type_requirement",
  [sym_compound_requirement] = "compound_requirement",
  [sym__requirement] = "_requirement",
  [sym_requirement_seq] = "requirement_seq",
  [sym_constraint_conjunction] = "constraint_conjunction",
  [sym_constraint_disjunction] = "constraint_disjunction",
  [sym__requirement_clause_constraint] = "_requirement_clause_constraint",
  [sym_requires_clause] = "requires_clause",
  [sym_requires_parameter_list] = "parameter_list",
  [sym_requires_expression] = "requires_expression",
  [sym_lambda_expression] = "lambda_expression",
  [sym_lambda_capture_specifier] = "lambda_capture_specifier",
  [sym_lambda_default_capture] = "lambda_default_capture",
  [sym__fold_operator] = "_fold_operator",
  [sym__binary_fold_operator] = "_binary_fold_operator",
  [sym__unary_left_fold] = "_unary_left_fold",
  [sym__unary_right_fold] = "_unary_right_fold",
  [sym__binary_fold] = "_binary_fold",
  [sym_fold_expression] = "fold_expression",
  [sym_parameter_pack_expansion] = "parameter_pack_expansion",
  [sym_type_parameter_pack_expansion] = "parameter_pack_expansion",
  [sym_destructor_name] = "destructor_name",
  [sym_dependent_identifier] = "dependent_name",
  [sym_dependent_field_identifier] = "dependent_name",
  [sym_dependent_type_identifier] = "dependent_name",
  [sym__scope_resolution] = "_scope_resolution",
  [sym_qualified_field_identifier] = "qualified_identifier",
  [sym_qualified_identifier] = "qualified_identifier",
  [sym_qualified_type_identifier] = "qualified_identifier",
  [sym_qualified_operator_cast_identifier] = "qualified_identifier",
  [sym__assignment_expression_lhs] = "assignment_expression",
  [sym_operator_name] = "operator_name",
  [sym_user_defined_literal] = "user_defined_literal",
  [aux_sym_translation_unit_repeat1] = "translation_unit_repeat1",
  [aux_sym_preproc_params_repeat1] = "preproc_params_repeat1",
  [aux_sym_preproc_if_repeat1] = "preproc_if_repeat1",
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = "preproc_if_in_field_declaration_list_repeat1",
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = "preproc_if_in_enumerator_list_repeat1",
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = "preproc_if_in_enumerator_list_no_comma_repeat1",
  [aux_sym_preproc_argument_list_repeat1] = "preproc_argument_list_repeat1",
  [aux_sym_declaration_repeat1] = "declaration_repeat1",
  [aux_sym_type_definition_repeat1] = "type_definition_repeat1",
  [aux_sym__type_definition_type_repeat1] = "_type_definition_type_repeat1",
  [aux_sym__type_definition_declarators_repeat1] = "_type_definition_declarators_repeat1",
  [aux_sym__declaration_specifiers_repeat1] = "_declaration_specifiers_repeat1",
  [aux_sym_attribute_declaration_repeat1] = "attribute_declaration_repeat1",
  [aux_sym_attributed_declarator_repeat1] = "attributed_declarator_repeat1",
  [aux_sym_pointer_declarator_repeat1] = "pointer_declarator_repeat1",
  [aux_sym_sized_type_specifier_repeat1] = "sized_type_specifier_repeat1",
  [aux_sym_enumerator_list_repeat1] = "enumerator_list_repeat1",
  [aux_sym_field_declaration_repeat1] = "field_declaration_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_generic_expression_repeat1] = "generic_expression_repeat1",
  [aux_sym_gnu_asm_expression_repeat1] = "gnu_asm_expression_repeat1",
  [aux_sym_gnu_asm_output_operand_list_repeat1] = "gnu_asm_output_operand_list_repeat1",
  [aux_sym_gnu_asm_input_operand_list_repeat1] = "gnu_asm_input_operand_list_repeat1",
  [aux_sym_gnu_asm_clobber_list_repeat1] = "gnu_asm_clobber_list_repeat1",
  [aux_sym_gnu_asm_goto_list_repeat1] = "gnu_asm_goto_list_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_initializer_list_repeat1] = "initializer_list_repeat1",
  [aux_sym_initializer_pair_repeat1] = "initializer_pair_repeat1",
  [aux_sym_char_literal_repeat1] = "char_literal_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [aux_sym__class_declaration_repeat1] = "_class_declaration_repeat1",
  [aux_sym_base_class_clause_repeat1] = "base_class_clause_repeat1",
  [aux_sym_template_parameter_list_repeat1] = "template_parameter_list_repeat1",
  [aux_sym_field_initializer_list_repeat1] = "field_initializer_list_repeat1",
  [aux_sym_operator_cast_definition_repeat1] = "operator_cast_definition_repeat1",
  [aux_sym_constructor_try_statement_repeat1] = "constructor_try_statement_repeat1",
  [aux_sym_structured_binding_declarator_repeat1] = "structured_binding_declarator_repeat1",
  [aux_sym__function_postfix_repeat1] = "_function_postfix_repeat1",
  [aux_sym_throw_specifier_repeat1] = "throw_specifier_repeat1",
  [aux_sym_template_argument_list_repeat1] = "template_argument_list_repeat1",
  [aux_sym_subscript_argument_list_repeat1] = "subscript_argument_list_repeat1",
  [aux_sym_requirement_seq_repeat1] = "requirement_seq_repeat1",
  [aux_sym_requires_parameter_list_repeat1] = "requires_parameter_list_repeat1",
  [aux_sym_lambda_capture_specifier_repeat1] = "lambda_capture_specifier_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_namespace_identifier] = "namespace_identifier",
  [alias_sym_simple_requirement] = "simple_requirement",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [aux_sym_preproc_include_token1] = aux_sym_preproc_include_token1,
  [aux_sym_preproc_include_token2] = aux_sym_preproc_include_token2,
  [aux_sym_preproc_def_token1] = aux_sym_preproc_def_token1,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [aux_sym_preproc_if_token1] = aux_sym_preproc_if_token1,
  [anon_sym_LF] = anon_sym_LF,
  [aux_sym_preproc_if_token2] = aux_sym_preproc_if_token2,
  [aux_sym_preproc_ifdef_token1] = aux_sym_preproc_ifdef_token1,
  [aux_sym_preproc_ifdef_token2] = aux_sym_preproc_ifdef_token2,
  [aux_sym_preproc_else_token1] = aux_sym_preproc_else_token1,
  [aux_sym_preproc_elif_token1] = aux_sym_preproc_elif_token1,
  [aux_sym_preproc_elifdef_token1] = aux_sym_preproc_elifdef_token1,
  [aux_sym_preproc_elifdef_token2] = aux_sym_preproc_elifdef_token2,
  [sym_preproc_arg] = sym_preproc_arg,
  [sym_preproc_directive] = sym_preproc_directive,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [anon_sym_defined] = anon_sym_defined,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym___extension__] = anon_sym___extension__,
  [anon_sym_typedef] = anon_sym_typedef,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym___attribute__] = anon_sym___attribute__,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_LBRACK_LBRACK] = anon_sym_LBRACK_LBRACK,
  [anon_sym_RBRACK_RBRACK] = anon_sym_RBRACK_RBRACK,
  [anon_sym___declspec] = anon_sym___declspec,
  [anon_sym___based] = anon_sym___based,
  [anon_sym___cdecl] = anon_sym___cdecl,
  [anon_sym___clrcall] = anon_sym___clrcall,
  [anon_sym___stdcall] = anon_sym___stdcall,
  [anon_sym___fastcall] = anon_sym___fastcall,
  [anon_sym___thiscall] = anon_sym___thiscall,
  [anon_sym___vectorcall] = anon_sym___vectorcall,
  [sym_ms_restrict_modifier] = sym_ms_restrict_modifier,
  [sym_ms_unsigned_ptr_modifier] = sym_ms_unsigned_ptr_modifier,
  [sym_ms_signed_ptr_modifier] = sym_ms_signed_ptr_modifier,
  [anon_sym__unaligned] = anon_sym__unaligned,
  [anon_sym___unaligned] = anon_sym___unaligned,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_signed] = anon_sym_signed,
  [anon_sym_unsigned] = anon_sym_unsigned,
  [anon_sym_long] = anon_sym_long,
  [anon_sym_short] = anon_sym_short,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_register] = anon_sym_register,
  [anon_sym_inline] = anon_sym_inline,
  [anon_sym___inline] = anon_sym___inline,
  [anon_sym___inline__] = anon_sym___inline__,
  [anon_sym___forceinline] = anon_sym___forceinline,
  [anon_sym_thread_local] = anon_sym_thread_local,
  [anon_sym___thread] = anon_sym___thread,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_constexpr] = anon_sym_constexpr,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_restrict] = anon_sym_restrict,
  [anon_sym___restrict__] = anon_sym___restrict__,
  [anon_sym__Atomic] = anon_sym__Atomic,
  [anon_sym__Noreturn] = anon_sym__Noreturn,
  [anon_sym_noreturn] = anon_sym_noreturn,
  [anon_sym_mutable] = anon_sym_mutable,
  [anon_sym_constinit] = anon_sym_constinit,
  [anon_sym_consteval] = anon_sym_consteval,
  [anon_sym_PROGMEM] = anon_sym_PROGMEM,
  [aux_sym_primitive_type_token1] = aux_sym_primitive_type_token1,
  [anon_sym_byte] = anon_sym_byte,
  [anon_sym_word] = anon_sym_word,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym___try] = anon_sym___try,
  [anon_sym___except] = anon_sym___except,
  [anon_sym___finally] = anon_sym___finally,
  [anon_sym___leave] = anon_sym___leave,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_and_eq] = anon_sym_and_eq,
  [anon_sym_or_eq] = anon_sym_or_eq,
  [anon_sym_xor_eq] = anon_sym_xor_eq,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_compl] = anon_sym_compl,
  [anon_sym_LT_EQ_GT] = anon_sym_LT_EQ_GT,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_bitor] = anon_sym_bitor,
  [anon_sym_xor] = anon_sym_xor,
  [anon_sym_bitand] = anon_sym_bitand,
  [anon_sym_not_eq] = anon_sym_not_eq,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_sizeof] = anon_sym_sizeof,
  [anon_sym___alignof__] = anon_sym___alignof__,
  [anon_sym___alignof] = anon_sym___alignof,
  [anon_sym__alignof] = anon_sym__alignof,
  [anon_sym_alignof] = anon_sym_alignof,
  [anon_sym__Alignof] = anon_sym__Alignof,
  [anon_sym_offsetof] = anon_sym_offsetof,
  [anon_sym__Generic] = anon_sym__Generic,
  [anon_sym_asm] = anon_sym_asm,
  [anon_sym___asm__] = anon_sym___asm__,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DOT_STAR] = anon_sym_DOT_STAR,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [aux_sym_number_literal_token1] = aux_sym_number_literal_token1,
  [aux_sym_number_literal_token2] = aux_sym_number_literal_token2,
  [anon_sym_L_SQUOTE] = anon_sym_L_SQUOTE,
  [anon_sym_u_SQUOTE] = anon_sym_u_SQUOTE,
  [anon_sym_U_SQUOTE] = anon_sym_U_SQUOTE,
  [anon_sym_u8_SQUOTE] = anon_sym_u8_SQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_char_literal_token1] = aux_sym_char_literal_token1,
  [anon_sym_L_DQUOTE] = anon_sym_L_DQUOTE,
  [anon_sym_u_DQUOTE] = anon_sym_u_DQUOTE,
  [anon_sym_U_DQUOTE] = anon_sym_U_DQUOTE,
  [anon_sym_u8_DQUOTE] = anon_sym_u8_DQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_literal_token1] = aux_sym_string_literal_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_system_lib_string] = sym_system_lib_string,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [anon_sym_NULL] = anon_sym_NULL,
  [anon_sym_nullptr] = anon_sym_nullptr,
  [sym_comment] = sym_comment,
  [sym_auto] = sym_auto,
  [anon_sym_decltype] = anon_sym_decltype,
  [anon_sym_final] = anon_sym_final,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_virtual] = anon_sym_virtual,
  [anon_sym_alignas] = anon_sym_alignas,
  [anon_sym_explicit] = anon_sym_explicit,
  [anon_sym_typename] = anon_sym_typename,
  [anon_sym_template] = anon_sym_template,
  [anon_sym_GT2] = anon_sym_GT,
  [anon_sym_operator] = anon_sym_operator,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_friend] = anon_sym_friend,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_noexcept] = anon_sym_noexcept,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_static_assert] = anon_sym_static_assert,
  [anon_sym_concept] = anon_sym_concept,
  [anon_sym_co_return] = anon_sym_co_return,
  [anon_sym_co_yield] = anon_sym_co_yield,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_R_DQUOTE] = anon_sym_R_DQUOTE,
  [anon_sym_LR_DQUOTE] = anon_sym_LR_DQUOTE,
  [anon_sym_uR_DQUOTE] = anon_sym_uR_DQUOTE,
  [anon_sym_UR_DQUOTE] = anon_sym_UR_DQUOTE,
  [anon_sym_u8R_DQUOTE] = anon_sym_u8R_DQUOTE,
  [anon_sym_co_await] = anon_sym_co_await,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_requires] = anon_sym_requires,
  [anon_sym_DASH_GT_STAR] = anon_sym_DASH_GT_STAR,
  [anon_sym_LPAREN_RPAREN] = anon_sym_LPAREN_RPAREN,
  [anon_sym_LBRACK_RBRACK] = anon_sym_LBRACK_RBRACK,
  [anon_sym_DQUOTE_DQUOTE] = anon_sym_DQUOTE_DQUOTE,
  [sym_this] = sym_this,
  [sym_literal_suffix] = sym_literal_suffix,
  [sym_raw_string_delimiter] = sym_raw_string_delimiter,
  [sym_raw_string_content] = sym_raw_string_content,
  [sym_translation_unit] = sym_translation_unit,
  [sym_preproc_include] = sym_preproc_include,
  [sym_preproc_def] = sym_preproc_def,
  [sym_preproc_function_def] = sym_preproc_function_def,
  [sym_preproc_params] = sym_preproc_params,
  [sym_preproc_call] = sym_preproc_call,
  [sym_preproc_if] = sym_preproc_if,
  [sym_preproc_ifdef] = sym_preproc_ifdef,
  [sym_preproc_else] = sym_preproc_else,
  [sym_preproc_elif] = sym_preproc_elif,
  [sym_preproc_elifdef] = sym_preproc_elifdef,
  [sym_preproc_if_in_field_declaration_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_field_declaration_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_field_declaration_list] = sym_preproc_else,
  [sym_preproc_elif_in_field_declaration_list] = sym_preproc_elif,
  [sym_preproc_elifdef_in_field_declaration_list] = sym_preproc_elifdef,
  [sym_preproc_if_in_enumerator_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_enumerator_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_enumerator_list] = sym_preproc_else,
  [sym_preproc_elif_in_enumerator_list] = sym_preproc_elif,
  [sym_preproc_elifdef_in_enumerator_list] = sym_preproc_elifdef,
  [sym_preproc_if_in_enumerator_list_no_comma] = sym_preproc_if,
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = sym_preproc_ifdef,
  [sym_preproc_else_in_enumerator_list_no_comma] = sym_preproc_else,
  [sym_preproc_elif_in_enumerator_list_no_comma] = sym_preproc_elif,
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = sym_preproc_elifdef,
  [sym__preproc_expression] = sym__preproc_expression,
  [sym_preproc_parenthesized_expression] = sym_parenthesized_expression,
  [sym_preproc_defined] = sym_preproc_defined,
  [sym_preproc_unary_expression] = sym_unary_expression,
  [sym_preproc_call_expression] = sym_call_expression,
  [sym_preproc_argument_list] = sym_argument_list,
  [sym_preproc_binary_expression] = sym_binary_expression,
  [sym_function_definition] = sym_function_definition,
  [sym_declaration] = sym_declaration,
  [sym_type_definition] = sym_type_definition,
  [sym__type_definition_type] = sym__type_definition_type,
  [sym__type_definition_declarators] = sym__type_definition_declarators,
  [sym__declaration_modifiers] = sym__declaration_modifiers,
  [sym__declaration_specifiers] = sym__declaration_specifiers,
  [sym_linkage_specification] = sym_linkage_specification,
  [sym_attribute_specifier] = sym_attribute_specifier,
  [sym_attribute] = sym_attribute,
  [sym_attribute_declaration] = sym_attribute_declaration,
  [sym_ms_declspec_modifier] = sym_ms_declspec_modifier,
  [sym_ms_based_modifier] = sym_ms_based_modifier,
  [sym_ms_call_modifier] = sym_ms_call_modifier,
  [sym_ms_unaligned_ptr_modifier] = sym_ms_unaligned_ptr_modifier,
  [sym_ms_pointer_modifier] = sym_ms_pointer_modifier,
  [sym_declaration_list] = sym_declaration_list,
  [sym__declarator] = sym__declarator,
  [sym__field_declarator] = sym__field_declarator,
  [sym__type_declarator] = sym__type_declarator,
  [sym__abstract_declarator] = sym__abstract_declarator,
  [sym_parenthesized_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_field_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_type_declarator] = sym_parenthesized_declarator,
  [sym_abstract_parenthesized_declarator] = sym_abstract_parenthesized_declarator,
  [sym_attributed_declarator] = sym_attributed_declarator,
  [sym_attributed_field_declarator] = sym_attributed_declarator,
  [sym_attributed_type_declarator] = sym_attributed_declarator,
  [sym_pointer_declarator] = sym_pointer_declarator,
  [sym_pointer_field_declarator] = sym_pointer_declarator,
  [sym_pointer_type_declarator] = sym_pointer_type_declarator,
  [sym_abstract_pointer_declarator] = sym_abstract_pointer_declarator,
  [sym_function_declarator] = sym_function_declarator,
  [sym_function_field_declarator] = sym_function_declarator,
  [sym_function_type_declarator] = sym_function_declarator,
  [sym_abstract_function_declarator] = sym_abstract_function_declarator,
  [sym_array_declarator] = sym_array_declarator,
  [sym_array_field_declarator] = sym_array_declarator,
  [sym_array_type_declarator] = sym_array_declarator,
  [sym_abstract_array_declarator] = sym_abstract_array_declarator,
  [sym_init_declarator] = sym_init_declarator,
  [sym_compound_statement] = sym_compound_statement,
  [sym_storage_class_specifier] = sym_storage_class_specifier,
  [sym_type_qualifier] = sym_type_qualifier,
  [sym__type_specifier] = sym__type_specifier,
  [sym_sized_type_specifier] = sym_sized_type_specifier,
  [sym_primitive_type] = sym_primitive_type,
  [sym_enum_specifier] = sym_enum_specifier,
  [sym_enumerator_list] = sym_enumerator_list,
  [sym_struct_specifier] = sym_struct_specifier,
  [sym_union_specifier] = sym_union_specifier,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym__field_declaration_list_item] = sym__field_declaration_list_item,
  [sym_field_declaration] = sym_field_declaration,
  [sym_bitfield_clause] = sym_bitfield_clause,
  [sym_enumerator] = sym_enumerator,
  [sym_parameter_list] = sym_parameter_list,
  [sym_parameter_declaration] = sym_parameter_declaration,
  [sym_attributed_statement] = sym_attributed_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym__top_level_expression_statement] = sym_expression_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_else_clause] = sym_else_clause,
  [sym_switch_statement] = sym_switch_statement,
  [sym_case_statement] = sym_case_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_for_statement] = sym_for_statement,
  [sym__for_statement_body] = sym__for_statement_body,
  [sym_return_statement] = sym_return_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym_seh_try_statement] = sym_seh_try_statement,
  [sym_seh_except_clause] = sym_seh_except_clause,
  [sym_seh_finally_clause] = sym_seh_finally_clause,
  [sym_seh_leave_statement] = sym_seh_leave_statement,
  [sym__expression] = sym__expression,
  [sym__expression_not_binary] = sym__expression_not_binary,
  [sym__string] = sym__string,
  [sym_comma_expression] = sym_comma_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_pointer_expression] = sym_pointer_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_type_descriptor] = sym_type_descriptor,
  [sym_sizeof_expression] = sym_sizeof_expression,
  [sym_alignof_expression] = sym_alignof_expression,
  [sym_offsetof_expression] = sym_offsetof_expression,
  [sym_generic_expression] = sym_generic_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_gnu_asm_expression] = sym_gnu_asm_expression,
  [sym_gnu_asm_qualifier] = sym_gnu_asm_qualifier,
  [sym_gnu_asm_output_operand_list] = sym_gnu_asm_output_operand_list,
  [sym_gnu_asm_output_operand] = sym_gnu_asm_output_operand,
  [sym_gnu_asm_input_operand_list] = sym_gnu_asm_input_operand_list,
  [sym_gnu_asm_input_operand] = sym_gnu_asm_input_operand,
  [sym_gnu_asm_clobber_list] = sym_gnu_asm_clobber_list,
  [sym_gnu_asm_goto_list] = sym_gnu_asm_goto_list,
  [sym_argument_list] = sym_argument_list,
  [sym_field_expression] = sym_field_expression,
  [sym_compound_literal_expression] = sym_compound_literal_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_initializer_list] = sym_initializer_list,
  [sym_initializer_pair] = sym_initializer_pair,
  [sym_subscript_designator] = sym_subscript_designator,
  [sym_subscript_range_designator] = sym_subscript_range_designator,
  [sym_field_designator] = sym_field_designator,
  [sym_number_literal] = sym_number_literal,
  [sym_char_literal] = sym_char_literal,
  [sym_concatenated_string] = sym_concatenated_string,
  [sym_string_literal] = sym_string_literal,
  [sym_null] = sym_null,
  [sym__empty_declaration] = sym__empty_declaration,
  [sym_placeholder_type_specifier] = sym_placeholder_type_specifier,
  [sym_decltype_auto] = sym_decltype,
  [sym_decltype] = sym_decltype,
  [sym__class_declaration] = sym__class_declaration,
  [sym__class_declaration_item] = sym__class_declaration_item,
  [sym_class_specifier] = sym_class_specifier,
  [sym__class_name] = sym__class_name,
  [sym_virtual_specifier] = sym_virtual_specifier,
  [sym_virtual] = sym_virtual,
  [sym_alignas_specifier] = sym_alignas_specifier,
  [sym_explicit_function_specifier] = sym_explicit_function_specifier,
  [sym_base_class_clause] = sym_base_class_clause,
  [sym__enum_base_clause] = sym__enum_base_clause,
  [sym_dependent_type] = sym_dependent_type,
  [sym_template_declaration] = sym_template_declaration,
  [sym_template_instantiation] = sym_template_instantiation,
  [sym_template_parameter_list] = sym_template_parameter_list,
  [sym_type_parameter_declaration] = sym_type_parameter_declaration,
  [sym_variadic_type_parameter_declaration] = sym_variadic_type_parameter_declaration,
  [sym_optional_type_parameter_declaration] = sym_optional_type_parameter_declaration,
  [sym_template_template_parameter_declaration] = sym_template_template_parameter_declaration,
  [sym_optional_parameter_declaration] = sym_optional_parameter_declaration,
  [sym_variadic_parameter_declaration] = sym_variadic_parameter_declaration,
  [sym_variadic_declarator] = sym_variadic_declarator,
  [sym_variadic_reference_declarator] = sym_reference_declarator,
  [sym_operator_cast] = sym_operator_cast,
  [sym_field_initializer_list] = sym_field_initializer_list,
  [sym_field_initializer] = sym_field_initializer,
  [sym_inline_method_definition] = sym_function_definition,
  [sym__constructor_specifiers] = sym__constructor_specifiers,
  [sym_operator_cast_definition] = sym_function_definition,
  [sym_operator_cast_declaration] = sym_declaration,
  [sym_constructor_try_statement] = sym_try_statement,
  [sym_constructor_or_destructor_definition] = sym_function_definition,
  [sym_constructor_or_destructor_declaration] = sym_declaration,
  [sym_default_method_clause] = sym_default_method_clause,
  [sym_delete_method_clause] = sym_delete_method_clause,
  [sym_friend_declaration] = sym_friend_declaration,
  [sym_access_specifier] = sym_access_specifier,
  [sym_reference_declarator] = sym_reference_declarator,
  [sym_reference_field_declarator] = sym_reference_declarator,
  [sym_abstract_reference_declarator] = sym_abstract_reference_declarator,
  [sym_structured_binding_declarator] = sym_structured_binding_declarator,
  [sym_ref_qualifier] = sym_ref_qualifier,
  [sym__function_declarator_seq] = sym__function_declarator_seq,
  [sym__function_attributes_start] = sym__function_attributes_start,
  [sym__function_exception_specification] = sym__function_exception_specification,
  [sym__function_attributes_end] = sym__function_attributes_end,
  [sym__function_postfix] = sym__function_postfix,
  [sym_trailing_return_type] = sym_trailing_return_type,
  [sym_noexcept] = sym_noexcept,
  [sym_throw_specifier] = sym_throw_specifier,
  [sym_template_type] = sym_template_type,
  [sym_template_method] = sym_template_method,
  [sym_template_function] = sym_template_function,
  [sym_template_argument_list] = sym_template_argument_list,
  [sym_namespace_definition] = sym_namespace_definition,
  [sym_namespace_alias_definition] = sym_namespace_alias_definition,
  [sym__namespace_specifier] = sym__namespace_specifier,
  [sym_nested_namespace_specifier] = sym_nested_namespace_specifier,
  [sym_using_declaration] = sym_using_declaration,
  [sym_alias_declaration] = sym_alias_declaration,
  [sym_static_assert_declaration] = sym_static_assert_declaration,
  [sym_concept_definition] = sym_concept_definition,
  [sym_for_range_loop] = sym_for_range_loop,
  [sym__for_range_loop_body] = sym__for_range_loop_body,
  [sym_init_statement] = sym_init_statement,
  [sym_condition_clause] = sym_condition_clause,
  [sym_condition_declaration] = sym_declaration,
  [sym_co_return_statement] = sym_co_return_statement,
  [sym_co_yield_statement] = sym_co_yield_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_raw_string_literal] = sym_raw_string_literal,
  [sym_subscript_argument_list] = sym_subscript_argument_list,
  [sym_co_await_expression] = sym_co_await_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_new_declarator] = sym_new_declarator,
  [sym_delete_expression] = sym_delete_expression,
  [sym_type_requirement] = sym_type_requirement,
  [sym_compound_requirement] = sym_compound_requirement,
  [sym__requirement] = sym__requirement,
  [sym_requirement_seq] = sym_requirement_seq,
  [sym_constraint_conjunction] = sym_constraint_conjunction,
  [sym_constraint_disjunction] = sym_constraint_disjunction,
  [sym__requirement_clause_constraint] = sym__requirement_clause_constraint,
  [sym_requires_clause] = sym_requires_clause,
  [sym_requires_parameter_list] = sym_parameter_list,
  [sym_requires_expression] = sym_requires_expression,
  [sym_lambda_expression] = sym_lambda_expression,
  [sym_lambda_capture_specifier] = sym_lambda_capture_specifier,
  [sym_lambda_default_capture] = sym_lambda_default_capture,
  [sym__fold_operator] = sym__fold_operator,
  [sym__binary_fold_operator] = sym__binary_fold_operator,
  [sym__unary_left_fold] = sym__unary_left_fold,
  [sym__unary_right_fold] = sym__unary_right_fold,
  [sym__binary_fold] = sym__binary_fold,
  [sym_fold_expression] = sym_fold_expression,
  [sym_parameter_pack_expansion] = sym_parameter_pack_expansion,
  [sym_type_parameter_pack_expansion] = sym_parameter_pack_expansion,
  [sym_destructor_name] = sym_destructor_name,
  [sym_dependent_identifier] = sym_dependent_identifier,
  [sym_dependent_field_identifier] = sym_dependent_identifier,
  [sym_dependent_type_identifier] = sym_dependent_identifier,
  [sym__scope_resolution] = sym__scope_resolution,
  [sym_qualified_field_identifier] = sym_qualified_identifier,
  [sym_qualified_identifier] = sym_qualified_identifier,
  [sym_qualified_type_identifier] = sym_qualified_identifier,
  [sym_qualified_operator_cast_identifier] = sym_qualified_identifier,
  [sym__assignment_expression_lhs] = sym_assignment_expression,
  [sym_operator_name] = sym_operator_name,
  [sym_user_defined_literal] = sym_user_defined_literal,
  [aux_sym_translation_unit_repeat1] = aux_sym_translation_unit_repeat1,
  [aux_sym_preproc_params_repeat1] = aux_sym_preproc_params_repeat1,
  [aux_sym_preproc_if_repeat1] = aux_sym_preproc_if_repeat1,
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = aux_sym_preproc_if_in_enumerator_list_repeat1,
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [aux_sym_preproc_argument_list_repeat1] = aux_sym_preproc_argument_list_repeat1,
  [aux_sym_declaration_repeat1] = aux_sym_declaration_repeat1,
  [aux_sym_type_definition_repeat1] = aux_sym_type_definition_repeat1,
  [aux_sym__type_definition_type_repeat1] = aux_sym__type_definition_type_repeat1,
  [aux_sym__type_definition_declarators_repeat1] = aux_sym__type_definition_declarators_repeat1,
  [aux_sym__declaration_specifiers_repeat1] = aux_sym__declaration_specifiers_repeat1,
  [aux_sym_attribute_declaration_repeat1] = aux_sym_attribute_declaration_repeat1,
  [aux_sym_attributed_declarator_repeat1] = aux_sym_attributed_declarator_repeat1,
  [aux_sym_pointer_declarator_repeat1] = aux_sym_pointer_declarator_repeat1,
  [aux_sym_sized_type_specifier_repeat1] = aux_sym_sized_type_specifier_repeat1,
  [aux_sym_enumerator_list_repeat1] = aux_sym_enumerator_list_repeat1,
  [aux_sym_field_declaration_repeat1] = aux_sym_field_declaration_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym_case_statement_repeat1] = aux_sym_case_statement_repeat1,
  [aux_sym_generic_expression_repeat1] = aux_sym_generic_expression_repeat1,
  [aux_sym_gnu_asm_expression_repeat1] = aux_sym_gnu_asm_expression_repeat1,
  [aux_sym_gnu_asm_output_operand_list_repeat1] = aux_sym_gnu_asm_output_operand_list_repeat1,
  [aux_sym_gnu_asm_input_operand_list_repeat1] = aux_sym_gnu_asm_input_operand_list_repeat1,
  [aux_sym_gnu_asm_clobber_list_repeat1] = aux_sym_gnu_asm_clobber_list_repeat1,
  [aux_sym_gnu_asm_goto_list_repeat1] = aux_sym_gnu_asm_goto_list_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_initializer_list_repeat1] = aux_sym_initializer_list_repeat1,
  [aux_sym_initializer_pair_repeat1] = aux_sym_initializer_pair_repeat1,
  [aux_sym_char_literal_repeat1] = aux_sym_char_literal_repeat1,
  [aux_sym_concatenated_string_repeat1] = aux_sym_concatenated_string_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [aux_sym__class_declaration_repeat1] = aux_sym__class_declaration_repeat1,
  [aux_sym_base_class_clause_repeat1] = aux_sym_base_class_clause_repeat1,
  [aux_sym_template_parameter_list_repeat1] = aux_sym_template_parameter_list_repeat1,
  [aux_sym_field_initializer_list_repeat1] = aux_sym_field_initializer_list_repeat1,
  [aux_sym_operator_cast_definition_repeat1] = aux_sym_operator_cast_definition_repeat1,
  [aux_sym_constructor_try_statement_repeat1] = aux_sym_constructor_try_statement_repeat1,
  [aux_sym_structured_binding_declarator_repeat1] = aux_sym_structured_binding_declarator_repeat1,
  [aux_sym__function_postfix_repeat1] = aux_sym__function_postfix_repeat1,
  [aux_sym_throw_specifier_repeat1] = aux_sym_throw_specifier_repeat1,
  [aux_sym_template_argument_list_repeat1] = aux_sym_template_argument_list_repeat1,
  [aux_sym_subscript_argument_list_repeat1] = aux_sym_subscript_argument_list_repeat1,
  [aux_sym_requirement_seq_repeat1] = aux_sym_requirement_seq_repeat1,
  [aux_sym_requires_parameter_list_repeat1] = aux_sym_requires_parameter_list_repeat1,
  [aux_sym_lambda_capture_specifier_repeat1] = aux_sym_lambda_capture_specifier_repeat1,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_namespace_identifier] = alias_sym_namespace_identifier,
  [alias_sym_simple_requirement] = alias_sym_simple_requirement,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_preproc_include_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_include_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_def_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_else_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elif_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [sym_preproc_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_directive] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defined] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___extension__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typedef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___attribute__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___declspec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___based] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___cdecl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___clrcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___stdcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___fastcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thiscall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___vectorcall] = {
    .visible = true,
    .named = false,
  },
  [sym_ms_restrict_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unsigned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_signed_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_signed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsigned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_register] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___inline__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___forceinline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_thread_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thread] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constexpr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_restrict] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___restrict__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Atomic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mutable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constinit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_consteval] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PROGMEM] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_primitive_type_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_byte] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_word] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___except] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___leave] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_compl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bitor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bitand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sizeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___alignof__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_offsetof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Generic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___asm__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_number_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_number_literal_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_L_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_char_literal_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_L_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_literal_token1] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_system_lib_string] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_NULL] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nullptr] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_auto] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_decltype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_final] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_virtual] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alignas] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_explicit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typename] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_template] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_operator] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_friend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noexcept] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_concept] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_co_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_co_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_R_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_UR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8R_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_co_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_requires] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_suffix] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_delimiter] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_translation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_include] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_function_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_params] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym__preproc_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_defined] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__type_definition_type] = {
    .visible = false,
    .named = true,
  },
  [sym__type_definition_declarators] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_modifiers] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_linkage_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_declspec_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_based_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_call_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unaligned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_pointer_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__field_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__type_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__abstract_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_init_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_storage_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym__type_specifier] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_sized_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_union_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__field_declaration_list_item] = {
    .visible = false,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_bitfield_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_statement_body] = {
    .visible = false,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_except_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_leave_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__expression_not_binary] = {
    .visible = false,
    .named = true,
  },
  [sym__string] = {
    .visible = false,
    .named = true,
  },
  [sym_comma_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym_sizeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_alignof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_offsetof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_output_operand_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_output_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_input_operand_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_input_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_clobber_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_goto_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_literal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_range_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_field_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_placeholder_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_decltype_auto] = {
    .visible = true,
    .named = true,
  },
  [sym_decltype] = {
    .visible = true,
    .named = true,
  },
  [sym__class_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym__class_declaration_item] = {
    .visible = false,
    .named = true,
  },
  [sym_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym__class_name] = {
    .visible = false,
    .named = true,
  },
  [sym_virtual_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_virtual] = {
    .visible = true,
    .named = true,
  },
  [sym_alignas_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_explicit_function_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_base_class_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__enum_base_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_dependent_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_instantiation] = {
    .visible = true,
    .named = true,
  },
  [sym_template_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_template_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_cast] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__constructor_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_operator_cast_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_cast_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_or_destructor_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_or_destructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_default_method_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_method_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_friend_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_access_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_structured_binding_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym__function_declarator_seq] = {
    .visible = false,
    .named = true,
  },
  [sym__function_attributes_start] = {
    .visible = false,
    .named = true,
  },
  [sym__function_exception_specification] = {
    .visible = false,
    .named = true,
  },
  [sym__function_attributes_end] = {
    .visible = false,
    .named = true,
  },
  [sym__function_postfix] = {
    .visible = false,
    .named = true,
  },
  [sym_trailing_return_type] = {
    .visible = true,
    .named = true,
  },
  [sym_noexcept] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_template_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_method] = {
    .visible = true,
    .named = true,
  },
  [sym_template_function] = {
    .visible = true,
    .named = true,
  },
  [sym_template_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_alias_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__namespace_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym_nested_namespace_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_using_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_static_assert_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_concept_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_for_range_loop] = {
    .visible = true,
    .named = true,
  },
  [sym__for_range_loop_body] = {
    .visible = false,
    .named = true,
  },
  [sym_init_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_condition_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_condition_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_co_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_co_yield_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_co_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_requirement] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_requirement] = {
    .visible = true,
    .named = true,
  },
  [sym__requirement] = {
    .visible = false,
    .named = true,
  },
  [sym_requirement_seq] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_conjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_disjunction] = {
    .visible = true,
    .named = true,
  },
  [sym__requirement_clause_constraint] = {
    .visible = false,
    .named = true,
  },
  [sym_requires_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_requires_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_requires_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_capture_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_default_capture] = {
    .visible = true,
    .named = true,
  },
  [sym__fold_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__binary_fold_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_left_fold] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_right_fold] = {
    .visible = false,
    .named = true,
  },
  [sym__binary_fold] = {
    .visible = false,
    .named = true,
  },
  [sym_fold_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_pack_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_pack_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_destructor_name] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__scope_resolution] = {
    .visible = false,
    .named = true,
  },
  [sym_qualified_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_operator_cast_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__assignment_expression_lhs] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_name] = {
    .visible = true,
    .named = true,
  },
  [sym_user_defined_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_translation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_params_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_definition_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_definition_declarators_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declaration_specifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attributed_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pointer_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sized_type_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_generic_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_output_operand_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_input_operand_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_clobber_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_goto_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_pair_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_char_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__class_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_base_class_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_operator_cast_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constructor_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_structured_binding_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__function_postfix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_throw_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subscript_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_requirement_seq_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_requires_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_lambda_capture_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_namespace_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_simple_requirement] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_argument = 2,
  field_arguments = 3,
  field_assembly_code = 4,
  field_base = 5,
  field_body = 6,
  field_captures = 7,
  field_clobbers = 8,
  field_condition = 9,
  field_consequence = 10,
  field_constraint = 11,
  field_declarator = 12,
  field_default_type = 13,
  field_default_value = 14,
  field_delimiter = 15,
  field_designator = 16,
  field_directive = 17,
  field_end = 18,
  field_field = 19,
  field_filter = 20,
  field_function = 21,
  field_goto_labels = 22,
  field_indices = 23,
  field_initializer = 24,
  field_input_operands = 25,
  field_label = 26,
  field_left = 27,
  field_length = 28,
  field_member = 29,
  field_message = 30,
  field_name = 31,
  field_operand = 32,
  field_operator = 33,
  field_output_operands = 34,
  field_parameters = 35,
  field_path = 36,
  field_pattern = 37,
  field_placement = 38,
  field_prefix = 39,
  field_register = 40,
  field_requirements = 41,
  field_right = 42,
  field_scope = 43,
  field_size = 44,
  field_start = 45,
  field_symbol = 46,
  field_template_parameters = 47,
  field_type = 48,
  field_update = 49,
  field_value = 50,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_assembly_code] = "assembly_code",
  [field_base] = "base",
  [field_body] = "body",
  [field_captures] = "captures",
  [field_clobbers] = "clobbers",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constraint] = "constraint",
  [field_declarator] = "declarator",
  [field_default_type] = "default_type",
  [field_default_value] = "default_value",
  [field_delimiter] = "delimiter",
  [field_designator] = "designator",
  [field_directive] = "directive",
  [field_end] = "end",
  [field_field] = "field",
  [field_filter] = "filter",
  [field_function] = "function",
  [field_goto_labels] = "goto_labels",
  [field_indices] = "indices",
  [field_initializer] = "initializer",
  [field_input_operands] = "input_operands",
  [field_label] = "label",
  [field_left] = "left",
  [field_length] = "length",
  [field_member] = "member",
  [field_message] = "message",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_output_operands] = "output_operands",
  [field_parameters] = "parameters",
  [field_path] = "path",
  [field_pattern] = "pattern",
  [field_placement] = "placement",
  [field_prefix] = "prefix",
  [field_register] = "register",
  [field_requirements] = "requirements",
  [field_right] = "right",
  [field_scope] = "scope",
  [field_size] = "size",
  [field_start] = "start",
  [field_symbol] = "symbol",
  [field_template_parameters] = "template_parameters",
  [field_type] = "type",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 2},
  [5] = {.index = 4, .length = 1},
  [6] = {.index = 5, .length = 1},
  [7] = {.index = 6, .length = 1},
  [8] = {.index = 7, .length = 1},
  [9] = {.index = 8, .length = 1},
  [10] = {.index = 9, .length = 2},
  [11] = {.index = 11, .length = 2},
  [12] = {.index = 13, .length = 1},
  [13] = {.index = 14, .length = 1},
  [14] = {.index = 15, .length = 2},
  [15] = {.index = 15, .length = 2},
  [16] = {.index = 0, .length = 1},
  [18] = {.index = 17, .length = 1},
  [19] = {.index = 18, .length = 1},
  [20] = {.index = 19, .length = 1},
  [21] = {.index = 20, .length = 1},
  [22] = {.index = 21, .length = 2},
  [23] = {.index = 23, .length = 2},
  [24] = {.index = 25, .length = 1},
  [25] = {.index = 26, .length = 1},
  [26] = {.index = 27, .length = 2},
  [27] = {.index = 29, .length = 2},
  [28] = {.index = 31, .length = 1},
  [29] = {.index = 32, .length = 2},
  [30] = {.index = 34, .length = 2},
  [31] = {.index = 14, .length = 1},
  [32] = {.index = 36, .length = 2},
  [33] = {.index = 38, .length = 1},
  [34] = {.index = 39, .length = 2},
  [35] = {.index = 39, .length = 2},
  [36] = {.index = 17, .length = 1},
  [37] = {.index = 41, .length = 1},
  [38] = {.index = 42, .length = 2},
  [39] = {.index = 44, .length = 2},
  [40] = {.index = 46, .length = 3},
  [41] = {.index = 49, .length = 1},
  [44] = {.index = 50, .length = 2},
  [45] = {.index = 52, .length = 1},
  [46] = {.index = 53, .length = 1},
  [47] = {.index = 54, .length = 1},
  [48] = {.index = 55, .length = 2},
  [49] = {.index = 57, .length = 2},
  [50] = {.index = 59, .length = 2},
  [51] = {.index = 61, .length = 2},
  [52] = {.index = 63, .length = 2},
  [53] = {.index = 65, .length = 1},
  [54] = {.index = 66, .length = 3},
  [55] = {.index = 69, .length = 1},
  [56] = {.index = 70, .length = 1},
  [57] = {.index = 71, .length = 1},
  [58] = {.index = 72, .length = 2},
  [60] = {.index = 55, .length = 2},
  [61] = {.index = 74, .length = 2},
  [62] = {.index = 76, .length = 2},
  [63] = {.index = 78, .length = 2},
  [65] = {.index = 80, .length = 2},
  [66] = {.index = 82, .length = 2},
  [67] = {.index = 84, .length = 3},
  [68] = {.index = 87, .length = 2},
  [69] = {.index = 89, .length = 2},
  [70] = {.index = 91, .length = 3},
  [71] = {.index = 91, .length = 3},
  [72] = {.index = 94, .length = 3},
  [73] = {.index = 97, .length = 3},
  [74] = {.index = 100, .length = 3},
  [75] = {.index = 103, .length = 2},
  [76] = {.index = 105, .length = 2},
  [77] = {.index = 107, .length = 2},
  [78] = {.index = 109, .length = 1},
  [79] = {.index = 110, .length = 2},
  [80] = {.index = 112, .length = 2},
  [81] = {.index = 114, .length = 2},
  [82] = {.index = 116, .length = 3},
  [83] = {.index = 119, .length = 2},
  [84] = {.index = 121, .length = 1},
  [85] = {.index = 122, .length = 2},
  [86] = {.index = 124, .length = 2},
  [87] = {.index = 126, .length = 2},
  [88] = {.index = 128, .length = 2},
  [89] = {.index = 130, .length = 2},
  [90] = {.index = 132, .length = 2},
  [91] = {.index = 134, .length = 2},
  [92] = {.index = 136, .length = 2},
  [93] = {.index = 136, .length = 2},
  [94] = {.index = 138, .length = 2},
  [95] = {.index = 140, .length = 1},
  [96] = {.index = 140, .length = 1},
  [97] = {.index = 141, .length = 3},
  [99] = {.index = 144, .length = 2},
  [100] = {.index = 146, .length = 2},
  [101] = {.index = 148, .length = 2},
  [102] = {.index = 150, .length = 3},
  [103] = {.index = 153, .length = 1},
  [105] = {.index = 154, .length = 1},
  [107] = {.index = 155, .length = 3},
  [108] = {.index = 158, .length = 3},
  [109] = {.index = 161, .length = 3},
  [110] = {.index = 164, .length = 3},
  [111] = {.index = 167, .length = 2},
  [112] = {.index = 169, .length = 3},
  [113] = {.index = 172, .length = 3},
  [114] = {.index = 175, .length = 2},
  [115] = {.index = 177, .length = 3},
  [116] = {.index = 180, .length = 2},
  [117] = {.index = 15, .length = 2},
  [118] = {.index = 39, .length = 2},
  [119] = {.index = 182, .length = 2},
  [120] = {.index = 184, .length = 2},
  [121] = {.index = 186, .length = 1},
  [122] = {.index = 187, .length = 4},
  [123] = {.index = 191, .length = 4},
  [124] = {.index = 195, .length = 2},
  [125] = {.index = 197, .length = 3},
  [126] = {.index = 200, .length = 2},
  [127] = {.index = 202, .length = 2},
  [128] = {.index = 204, .length = 1},
  [129] = {.index = 205, .length = 2},
  [130] = {.index = 207, .length = 2},
  [131] = {.index = 209, .length = 3},
  [132] = {.index = 212, .length = 3},
  [133] = {.index = 215, .length = 3},
  [134] = {.index = 218, .length = 2},
  [135] = {.index = 220, .length = 3},
  [136] = {.index = 223, .length = 2},
  [137] = {.index = 225, .length = 2},
  [138] = {.index = 227, .length = 3},
  [139] = {.index = 230, .length = 2},
  [140] = {.index = 232, .length = 3},
  [141] = {.index = 235, .length = 2},
  [142] = {.index = 237, .length = 1},
  [143] = {.index = 238, .length = 2},
  [144] = {.index = 240, .length = 2},
  [145] = {.index = 242, .length = 4},
  [146] = {.index = 246, .length = 5},
  [147] = {.index = 251, .length = 2},
  [148] = {.index = 251, .length = 2},
  [149] = {.index = 253, .length = 1},
  [150] = {.index = 254, .length = 1},
  [151] = {.index = 255, .length = 2},
  [152] = {.index = 257, .length = 1},
  [154] = {.index = 258, .length = 1},
  [155] = {.index = 259, .length = 2},
  [156] = {.index = 261, .length = 2},
  [157] = {.index = 7, .length = 1},
  [158] = {.index = 7, .length = 1},
  [159] = {.index = 263, .length = 2},
  [160] = {.index = 265, .length = 1},
  [161] = {.index = 266, .length = 1},
  [162] = {.index = 267, .length = 4},
  [163] = {.index = 271, .length = 2},
  [164] = {.index = 273, .length = 4},
  [165] = {.index = 277, .length = 1},
  [166] = {.index = 278, .length = 3},
  [167] = {.index = 281, .length = 2},
  [168] = {.index = 283, .length = 3},
  [169] = {.index = 286, .length = 1},
  [170] = {.index = 287, .length = 5},
  [171] = {.index = 292, .length = 2},
  [172] = {.index = 294, .length = 2},
  [173] = {.index = 296, .length = 4},
  [174] = {.index = 300, .length = 2},
  [175] = {.index = 302, .length = 3},
  [176] = {.index = 305, .length = 4},
  [177] = {.index = 309, .length = 4},
  [178] = {.index = 313, .length = 3},
  [179] = {.index = 316, .length = 2},
  [180] = {.index = 318, .length = 3},
  [181] = {.index = 321, .length = 3},
  [182] = {.index = 324, .length = 2},
  [183] = {.index = 326, .length = 2},
  [184] = {.index = 328, .length = 2},
  [185] = {.index = 330, .length = 2},
  [186] = {.index = 332, .length = 3},
  [187] = {.index = 335, .length = 2},
  [188] = {.index = 337, .length = 2},
  [189] = {.index = 339, .length = 3},
  [190] = {.index = 342, .length = 2},
  [191] = {.index = 344, .length = 2},
  [192] = {.index = 346, .length = 4},
  [193] = {.index = 350, .length = 5},
  [194] = {.index = 355, .length = 3},
  [195] = {.index = 358, .length = 4},
  [196] = {.index = 362, .length = 2},
  [197] = {.index = 364, .length = 2},
  [198] = {.index = 366, .length = 1},
  [199] = {.index = 367, .length = 4},
  [200] = {.index = 371, .length = 3},
  [201] = {.index = 374, .length = 2},
  [202] = {.index = 376, .length = 1},
  [203] = {.index = 377, .length = 5},
  [204] = {.index = 382, .length = 2},
  [205] = {.index = 384, .length = 2},
  [206] = {.index = 65, .length = 1},
  [207] = {.index = 386, .length = 5},
  [208] = {.index = 391, .length = 4},
  [209] = {.index = 395, .length = 2},
  [210] = {.index = 397, .length = 2},
  [211] = {.index = 399, .length = 5},
  [212] = {.index = 404, .length = 2},
  [213] = {.index = 406, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_type, 0},
  [1] =
    {field_directive, 0},
  [2] =
    {field_argument, 1},
    {field_operator, 0},
  [4] =
    {field_declarator, 1},
  [5] =
    {field_name, 0},
  [6] =
    {field_body, 1},
  [7] =
    {field_name, 1},
  [8] =
    {field_body, 0},
  [9] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [11] =
    {field_body, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [13] =
    {field_value, 1},
  [14] =
    {field_scope, 0},
  [15] =
    {field_arguments, 1},
    {field_name, 0},
  [17] =
    {field_type, 1},
  [18] =
    {field_requirements, 1},
  [19] =
    {field_constraint, 1},
  [20] =
    {field_parameters, 0},
  [21] =
    {field_declarator, 0},
    {field_parameters, 1, .inherited = true},
  [23] =
    {field_body, 1},
    {field_declarator, 0},
  [25] =
    {field_declarator, 0},
  [26] =
    {field_constraint, 0},
  [27] =
    {field_arguments, 1},
    {field_function, 0},
  [29] =
    {field_type, 0},
    {field_value, 1},
  [31] =
    {field_pattern, 0},
  [32] =
    {field_argument, 0},
    {field_operator, 1},
  [34] =
    {field_argument, 0},
    {field_indices, 1},
  [36] =
    {field_body, 1},
    {field_captures, 0},
  [38] =
    {field_parameters, 0, .inherited = true},
  [39] =
    {field_name, 1},
    {field_scope, 0, .inherited = true},
  [41] =
    {field_path, 1},
  [42] =
    {field_argument, 1},
    {field_directive, 0},
  [44] =
    {field_declarator, 1},
    {field_type, 0},
  [46] =
    {field_left, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [49] =
    {field_declarator, 2},
  [50] =
    {field_body, 2},
    {field_value, 1},
  [52] =
    {field_type, 2},
  [53] =
    {field_body, 2},
  [54] =
    {field_name, 2},
  [55] =
    {field_body, 2},
    {field_name, 1},
  [57] =
    {field_base, 2, .inherited = true},
    {field_name, 1},
  [59] =
    {field_body, 1},
    {field_name, 0},
  [61] =
    {field_condition, 1},
    {field_consequence, 2},
  [63] =
    {field_body, 2},
    {field_condition, 1},
  [65] =
    {field_label, 1},
  [66] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [69] =
    {field_label, 0},
  [70] =
    {field_type, 0, .inherited = true},
  [71] =
    {field_parameters, 1},
  [72] =
    {field_declarator, 2},
    {field_type, 1, .inherited = true},
  [74] =
    {field_arguments, 2},
    {field_type, 1},
  [76] =
    {field_declarator, 2},
    {field_type, 1},
  [78] =
    {field_placement, 1},
    {field_type, 2},
  [80] =
    {field_parameters, 1},
    {field_requirements, 2},
  [82] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [84] =
    {field_body, 2},
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [87] =
    {field_declarator, 0},
    {field_value, 1},
  [89] =
    {field_body, 2},
    {field_declarator, 0},
  [91] =
    {field_argument, 0},
    {field_field, 2},
    {field_operator, 1},
  [94] =
    {field_body, 2},
    {field_captures, 0},
    {field_declarator, 1},
  [97] =
    {field_body, 2},
    {field_captures, 0},
    {field_template_parameters, 1},
  [100] =
    {field_name, 1},
    {field_name, 2},
    {field_scope, 0, .inherited = true},
  [103] =
    {field_body, 2},
    {field_declarator, 1},
  [105] =
    {field_name, 1},
    {field_value, 2},
  [107] =
    {field_name, 1},
    {field_parameters, 2},
  [109] =
    {field_condition, 1},
  [110] =
    {field_alternative, 2},
    {field_name, 1},
  [112] =
    {field_declarator, 2},
    {field_type, 0},
  [114] =
    {field_left, 0},
    {field_right, 2},
  [116] =
    {field_left, 0},
    {field_operator, 1, .inherited = true},
    {field_right, 2},
  [119] =
    {field_type, 1},
    {field_value, 3},
  [121] =
    {field_declarator, 3},
  [122] =
    {field_declarator, 2, .inherited = true},
    {field_type, 1, .inherited = true},
  [124] =
    {field_declarator, 0},
    {field_parameters, 1},
  [126] =
    {field_declarator, 0},
    {field_declarator, 1, .inherited = true},
  [128] =
    {field_arguments, 3},
    {field_type, 2},
  [130] =
    {field_declarator, 3},
    {field_type, 2},
  [132] =
    {field_placement, 2},
    {field_type, 3},
  [134] =
    {field_name, 2},
    {field_prefix, 0},
  [136] =
    {field_body, 3},
    {field_name, 2},
  [138] =
    {field_base, 3, .inherited = true},
    {field_name, 2},
  [140] =
    {field_base, 1},
  [141] =
    {field_base, 2, .inherited = true},
    {field_body, 3},
    {field_name, 1},
  [144] =
    {field_body, 2, .inherited = true},
    {field_name, 2, .inherited = true},
  [146] =
    {field_body, 2},
    {field_name, 0},
  [148] =
    {field_condition, 2},
    {field_consequence, 3},
  [150] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [153] =
    {field_initializer, 0},
  [154] =
    {field_assembly_code, 2},
  [155] =
    {field_arguments, 3},
    {field_declarator, 2},
    {field_type, 1},
  [158] =
    {field_arguments, 3},
    {field_placement, 1},
    {field_type, 2},
  [161] =
    {field_declarator, 3},
    {field_placement, 1},
    {field_type, 2},
  [164] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 0, .inherited = true},
  [167] =
    {field_declarator, 0},
    {field_value, 2},
  [169] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_type, 0, .inherited = true},
  [172] =
    {field_declarator, 1},
    {field_declarator, 2, .inherited = true},
    {field_type, 0, .inherited = true},
  [175] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
  [177] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 1, .inherited = true},
  [180] =
    {field_declarator, 0},
    {field_size, 2},
  [182] =
    {field_alternative, 3},
    {field_condition, 0},
  [184] =
    {field_declarator, 0},
    {field_default_value, 2},
  [186] =
    {field_size, 1},
  [187] =
    {field_body, 3},
    {field_captures, 0},
    {field_declarator, 2},
    {field_template_parameters, 1},
  [191] =
    {field_body, 3},
    {field_captures, 0},
    {field_constraint, 2},
    {field_template_parameters, 1},
  [195] =
    {field_body, 3},
    {field_declarator, 1},
  [197] =
    {field_name, 1},
    {field_parameters, 2},
    {field_value, 3},
  [200] =
    {field_alternative, 3},
    {field_condition, 1},
  [202] =
    {field_alternative, 3},
    {field_name, 1},
  [204] =
    {field_operator, 0},
  [205] =
    {field_declarator, 3},
    {field_type, 1},
  [207] =
    {field_declarator, 3, .inherited = true},
    {field_type, 2, .inherited = true},
  [209] =
    {field_arguments, 4},
    {field_declarator, 3},
    {field_type, 2},
  [212] =
    {field_arguments, 4},
    {field_placement, 2},
    {field_type, 3},
  [215] =
    {field_declarator, 4},
    {field_placement, 2},
    {field_type, 3},
  [218] =
    {field_name, 0},
    {field_value, 2},
  [220] =
    {field_base, 3, .inherited = true},
    {field_body, 4},
    {field_name, 2},
  [223] =
    {field_body, 3},
    {field_name, 0},
  [225] =
    {field_body, 3, .inherited = true},
    {field_name, 3, .inherited = true},
  [227] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
    {field_value, 2},
  [230] =
    {field_initializer, 1},
    {field_value, 2},
  [232] =
    {field_alternative, 4},
    {field_condition, 2},
    {field_consequence, 3},
  [235] =
    {field_body, 1},
    {field_condition, 3},
  [237] =
    {field_update, 2},
  [238] =
    {field_initializer, 0},
    {field_update, 2},
  [240] =
    {field_condition, 1},
    {field_initializer, 0},
  [242] =
    {field_body, 4},
    {field_condition, 2, .inherited = true},
    {field_initializer, 2, .inherited = true},
    {field_update, 2, .inherited = true},
  [246] =
    {field_body, 4},
    {field_declarator, 2, .inherited = true},
    {field_initializer, 2, .inherited = true},
    {field_right, 2, .inherited = true},
    {field_type, 2, .inherited = true},
  [251] =
    {field_designator, 0},
    {field_value, 2},
  [253] =
    {field_value, 3},
  [254] =
    {field_operand, 1},
  [255] =
    {field_assembly_code, 2},
    {field_output_operands, 3},
  [257] =
    {field_assembly_code, 3},
  [258] =
    {field_default_type, 2},
  [259] =
    {field_default_value, 2},
    {field_type, 0, .inherited = true},
  [261] =
    {field_body, 2},
    {field_parameters, 1},
  [263] =
    {field_name, 1},
    {field_type, 3},
  [265] =
    {field_condition, 2},
  [266] =
    {field_length, 1},
  [267] =
    {field_arguments, 4},
    {field_declarator, 3},
    {field_placement, 1},
    {field_type, 2},
  [271] =
    {field_declarator, 1},
    {field_declarator, 2},
  [273] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3, .inherited = true},
    {field_type, 0, .inherited = true},
  [277] =
    {field_declarator, 4},
  [278] =
    {field_body, 4},
    {field_declarator, 3},
    {field_type, 1, .inherited = true},
  [281] =
    {field_declarator, 0},
    {field_size, 3},
  [283] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [286] =
    {field_size, 2},
  [287] =
    {field_body, 4},
    {field_captures, 0},
    {field_constraint, 2},
    {field_declarator, 3},
    {field_template_parameters, 1},
  [292] =
    {field_declarator, 1},
    {field_default_value, 3},
  [294] =
    {field_alternative, 4},
    {field_condition, 1},
  [296] =
    {field_arguments, 5},
    {field_declarator, 4},
    {field_placement, 2},
    {field_type, 3},
  [300] =
    {field_body, 2},
    {field_filter, 1},
  [302] =
    {field_declarator, 1},
    {field_default_value, 2},
    {field_type, 0, .inherited = true},
  [305] =
    {field_declarator, 1},
    {field_declarator, 2, .inherited = true},
    {field_default_value, 2, .inherited = true},
    {field_type, 0, .inherited = true},
  [309] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
    {field_default_value, 0, .inherited = true},
    {field_default_value, 1, .inherited = true},
  [313] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
    {field_value, 3},
  [316] =
    {field_condition, 1},
    {field_update, 3},
  [318] =
    {field_condition, 1},
    {field_initializer, 0},
    {field_update, 3},
  [321] =
    {field_declarator, 1},
    {field_right, 3},
    {field_type, 0, .inherited = true},
  [324] =
    {field_initializer, 0},
    {field_update, 3},
  [326] =
    {field_condition, 2},
    {field_initializer, 0},
  [328] =
    {field_member, 4},
    {field_type, 2},
  [330] =
    {field_operand, 1},
    {field_operand, 2, .inherited = true},
  [332] =
    {field_assembly_code, 2},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [335] =
    {field_assembly_code, 3},
    {field_output_operands, 4},
  [337] =
    {field_default_type, 3},
    {field_name, 1},
  [339] =
    {field_declarator, 1},
    {field_default_value, 3},
    {field_type, 0, .inherited = true},
  [342] =
    {field_name, 1},
    {field_type, 4},
  [344] =
    {field_declarator, 1},
    {field_default_value, 2},
  [346] =
    {field_declarator, 1},
    {field_declarator, 3, .inherited = true},
    {field_default_value, 3, .inherited = true},
    {field_type, 0, .inherited = true},
  [350] =
    {field_declarator, 1},
    {field_declarator, 3, .inherited = true},
    {field_default_value, 2},
    {field_default_value, 3, .inherited = true},
    {field_type, 0, .inherited = true},
  [355] =
    {field_condition, 2},
    {field_initializer, 0},
    {field_update, 4},
  [358] =
    {field_declarator, 2},
    {field_initializer, 0},
    {field_right, 4},
    {field_type, 1, .inherited = true},
  [362] =
    {field_end, 3},
    {field_start, 1},
  [364] =
    {field_operand, 0, .inherited = true},
    {field_operand, 1, .inherited = true},
  [366] =
    {field_register, 1},
  [367] =
    {field_assembly_code, 2},
    {field_clobbers, 5},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [371] =
    {field_assembly_code, 3},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [374] =
    {field_condition, 2},
    {field_message, 4},
  [376] =
    {field_delimiter, 1},
  [377] =
    {field_declarator, 1},
    {field_declarator, 4, .inherited = true},
    {field_default_value, 3},
    {field_default_value, 4, .inherited = true},
    {field_type, 0, .inherited = true},
  [382] =
    {field_constraint, 0},
    {field_value, 2},
  [384] =
    {field_register, 1},
    {field_register, 2, .inherited = true},
  [386] =
    {field_assembly_code, 2},
    {field_clobbers, 5},
    {field_goto_labels, 6},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [391] =
    {field_assembly_code, 3},
    {field_clobbers, 6},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [395] =
    {field_register, 0, .inherited = true},
    {field_register, 1, .inherited = true},
  [397] =
    {field_label, 1},
    {field_label, 2, .inherited = true},
  [399] =
    {field_assembly_code, 3},
    {field_clobbers, 6},
    {field_goto_labels, 7},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [404] =
    {field_label, 0, .inherited = true},
    {field_label, 1, .inherited = true},
  [406] =
    {field_constraint, 3},
    {field_symbol, 1},
    {field_value, 5},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [13] = {
    [0] = alias_sym_namespace_identifier,
  },
  [14] = {
    [0] = alias_sym_type_identifier,
  },
  [16] = {
    [0] = alias_sym_type_identifier,
  },
  [17] = {
    [0] = alias_sym_namespace_identifier,
  },
  [35] = {
    [1] = alias_sym_type_identifier,
  },
  [36] = {
    [1] = alias_sym_type_identifier,
  },
  [42] = {
    [0] = sym_primitive_type,
  },
  [43] = {
    [0] = sym_pointer_declarator,
  },
  [53] = {
    [1] = alias_sym_statement_identifier,
  },
  [55] = {
    [0] = alias_sym_statement_identifier,
  },
  [59] = {
    [1] = alias_sym_namespace_identifier,
  },
  [60] = {
    [1] = alias_sym_namespace_identifier,
  },
  [64] = {
    [0] = alias_sym_simple_requirement,
  },
  [70] = {
    [2] = alias_sym_field_identifier,
  },
  [92] = {
    [2] = alias_sym_namespace_identifier,
  },
  [95] = {
    [1] = alias_sym_type_identifier,
  },
  [98] = {
    [0] = alias_sym_field_identifier,
  },
  [104] = {
    [1] = alias_sym_field_identifier,
  },
  [106] = {
    [1] = alias_sym_type_identifier,
  },
  [117] = {
    [0] = alias_sym_field_identifier,
  },
  [118] = {
    [1] = alias_sym_field_identifier,
  },
  [147] = {
    [0] = alias_sym_field_identifier,
  },
  [153] = {
    [2] = alias_sym_type_identifier,
  },
  [157] = {
    [1] = alias_sym_namespace_identifier,
    [3] = alias_sym_namespace_identifier,
  },
  [158] = {
    [1] = alias_sym_namespace_identifier,
  },
  [159] = {
    [1] = alias_sym_type_identifier,
  },
  [184] = {
    [4] = alias_sym_field_identifier,
  },
  [188] = {
    [1] = alias_sym_type_identifier,
  },
  [190] = {
    [1] = alias_sym_type_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_pointer_type_declarator, 2,
    sym_pointer_type_declarator,
    sym_pointer_declarator,
  sym_expression_statement, 2,
    sym_expression_statement,
    alias_sym_simple_requirement,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 2,
  [5] = 2,
  [6] = 2,
  [7] = 2,
  [8] = 2,
  [9] = 2,
  [10] = 2,
  [11] = 2,
  [12] = 2,
  [13] = 2,
  [14] = 2,
  [15] = 2,
  [16] = 16,
  [17] = 17,
  [18] = 16,
  [19] = 16,
  [20] = 17,
  [21] = 16,
  [22] = 17,
  [23] = 17,
  [24] = 16,
  [25] = 17,
  [26] = 26,
  [27] = 27,
  [28] = 26,
  [29] = 29,
  [30] = 27,
  [31] = 26,
  [32] = 32,
  [33] = 33,
  [34] = 26,
  [35] = 35,
  [36] = 27,
  [37] = 27,
  [38] = 26,
  [39] = 27,
  [40] = 40,
  [41] = 32,
  [42] = 42,
  [43] = 43,
  [44] = 43,
  [45] = 42,
  [46] = 43,
  [47] = 42,
  [48] = 43,
  [49] = 43,
  [50] = 42,
  [51] = 43,
  [52] = 42,
  [53] = 53,
  [54] = 32,
  [55] = 43,
  [56] = 42,
  [57] = 43,
  [58] = 42,
  [59] = 43,
  [60] = 42,
  [61] = 43,
  [62] = 62,
  [63] = 42,
  [64] = 43,
  [65] = 42,
  [66] = 53,
  [67] = 62,
  [68] = 43,
  [69] = 42,
  [70] = 43,
  [71] = 42,
  [72] = 42,
  [73] = 43,
  [74] = 42,
  [75] = 43,
  [76] = 53,
  [77] = 42,
  [78] = 53,
  [79] = 32,
  [80] = 42,
  [81] = 43,
  [82] = 42,
  [83] = 62,
  [84] = 62,
  [85] = 42,
  [86] = 43,
  [87] = 87,
  [88] = 43,
  [89] = 42,
  [90] = 43,
  [91] = 43,
  [92] = 62,
  [93] = 42,
  [94] = 94,
  [95] = 42,
  [96] = 53,
  [97] = 43,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 100,
  [106] = 102,
  [107] = 101,
  [108] = 104,
  [109] = 103,
  [110] = 101,
  [111] = 102,
  [112] = 103,
  [113] = 101,
  [114] = 104,
  [115] = 100,
  [116] = 102,
  [117] = 100,
  [118] = 103,
  [119] = 104,
  [120] = 101,
  [121] = 103,
  [122] = 104,
  [123] = 102,
  [124] = 100,
  [125] = 100,
  [126] = 103,
  [127] = 101,
  [128] = 104,
  [129] = 102,
  [130] = 130,
  [131] = 130,
  [132] = 130,
  [133] = 130,
  [134] = 130,
  [135] = 130,
  [136] = 130,
  [137] = 137,
  [138] = 138,
  [139] = 138,
  [140] = 138,
  [141] = 138,
  [142] = 142,
  [143] = 138,
  [144] = 138,
  [145] = 138,
  [146] = 138,
  [147] = 147,
  [148] = 147,
  [149] = 147,
  [150] = 150,
  [151] = 151,
  [152] = 151,
  [153] = 153,
  [154] = 151,
  [155] = 155,
  [156] = 156,
  [157] = 151,
  [158] = 151,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 160,
  [163] = 163,
  [164] = 159,
  [165] = 160,
  [166] = 159,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 170,
  [172] = 168,
  [173] = 160,
  [174] = 170,
  [175] = 159,
  [176] = 176,
  [177] = 168,
  [178] = 178,
  [179] = 163,
  [180] = 176,
  [181] = 167,
  [182] = 178,
  [183] = 176,
  [184] = 169,
  [185] = 161,
  [186] = 170,
  [187] = 160,
  [188] = 168,
  [189] = 170,
  [190] = 163,
  [191] = 178,
  [192] = 169,
  [193] = 161,
  [194] = 161,
  [195] = 176,
  [196] = 167,
  [197] = 176,
  [198] = 169,
  [199] = 151,
  [200] = 159,
  [201] = 160,
  [202] = 178,
  [203] = 176,
  [204] = 168,
  [205] = 163,
  [206] = 163,
  [207] = 170,
  [208] = 178,
  [209] = 163,
  [210] = 169,
  [211] = 151,
  [212] = 159,
  [213] = 163,
  [214] = 168,
  [215] = 170,
  [216] = 160,
  [217] = 161,
  [218] = 161,
  [219] = 167,
  [220] = 167,
  [221] = 169,
  [222] = 178,
  [223] = 169,
  [224] = 161,
  [225] = 168,
  [226] = 159,
  [227] = 178,
  [228] = 167,
  [229] = 167,
  [230] = 230,
  [231] = 230,
  [232] = 230,
  [233] = 233,
  [234] = 233,
  [235] = 233,
  [236] = 233,
  [237] = 230,
  [238] = 233,
  [239] = 233,
  [240] = 230,
  [241] = 233,
  [242] = 230,
  [243] = 230,
  [244] = 230,
  [245] = 233,
  [246] = 233,
  [247] = 230,
  [248] = 230,
  [249] = 230,
  [250] = 233,
  [251] = 230,
  [252] = 233,
  [253] = 233,
  [254] = 233,
  [255] = 233,
  [256] = 230,
  [257] = 230,
  [258] = 230,
  [259] = 151,
  [260] = 233,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 262,
  [267] = 153,
  [268] = 155,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 261,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 285,
  [290] = 290,
  [291] = 285,
  [292] = 292,
  [293] = 285,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 285,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 285,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 285,
  [320] = 320,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 285,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 285,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 285,
  [338] = 338,
  [339] = 339,
  [340] = 340,
  [341] = 285,
  [342] = 342,
  [343] = 343,
  [344] = 344,
  [345] = 285,
  [346] = 285,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 285,
  [352] = 285,
  [353] = 353,
  [354] = 354,
  [355] = 285,
  [356] = 356,
  [357] = 357,
  [358] = 285,
  [359] = 264,
  [360] = 360,
  [361] = 285,
  [362] = 362,
  [363] = 363,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 285,
  [368] = 368,
  [369] = 369,
  [370] = 263,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 262,
  [377] = 377,
  [378] = 378,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 382,
  [383] = 383,
  [384] = 384,
  [385] = 378,
  [386] = 386,
  [387] = 387,
  [388] = 261,
  [389] = 389,
  [390] = 389,
  [391] = 378,
  [392] = 392,
  [393] = 393,
  [394] = 394,
  [395] = 395,
  [396] = 261,
  [397] = 272,
  [398] = 398,
  [399] = 399,
  [400] = 400,
  [401] = 401,
  [402] = 402,
  [403] = 403,
  [404] = 404,
  [405] = 389,
  [406] = 378,
  [407] = 262,
  [408] = 408,
  [409] = 409,
  [410] = 261,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 389,
  [415] = 415,
  [416] = 416,
  [417] = 417,
  [418] = 269,
  [419] = 419,
  [420] = 420,
  [421] = 421,
  [422] = 422,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 436,
  [437] = 437,
  [438] = 438,
  [439] = 439,
  [440] = 270,
  [441] = 423,
  [442] = 442,
  [443] = 155,
  [444] = 444,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 153,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 452,
  [453] = 453,
  [454] = 262,
  [455] = 455,
  [456] = 456,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 316,
  [462] = 365,
  [463] = 371,
  [464] = 368,
  [465] = 336,
  [466] = 333,
  [467] = 334,
  [468] = 364,
  [469] = 353,
  [470] = 369,
  [471] = 324,
  [472] = 363,
  [473] = 332,
  [474] = 331,
  [475] = 338,
  [476] = 335,
  [477] = 330,
  [478] = 328,
  [479] = 326,
  [480] = 264,
  [481] = 349,
  [482] = 339,
  [483] = 309,
  [484] = 321,
  [485] = 320,
  [486] = 275,
  [487] = 317,
  [488] = 314,
  [489] = 340,
  [490] = 342,
  [491] = 327,
  [492] = 315,
  [493] = 343,
  [494] = 264,
  [495] = 322,
  [496] = 323,
  [497] = 344,
  [498] = 308,
  [499] = 305,
  [500] = 302,
  [501] = 300,
  [502] = 313,
  [503] = 298,
  [504] = 297,
  [505] = 312,
  [506] = 311,
  [507] = 307,
  [508] = 306,
  [509] = 304,
  [510] = 301,
  [511] = 299,
  [512] = 296,
  [513] = 295,
  [514] = 294,
  [515] = 263,
  [516] = 276,
  [517] = 292,
  [518] = 362,
  [519] = 318,
  [520] = 290,
  [521] = 357,
  [522] = 288,
  [523] = 286,
  [524] = 282,
  [525] = 372,
  [526] = 283,
  [527] = 281,
  [528] = 280,
  [529] = 366,
  [530] = 279,
  [531] = 263,
  [532] = 278,
  [533] = 284,
  [534] = 277,
  [535] = 350,
  [536] = 356,
  [537] = 348,
  [538] = 287,
  [539] = 347,
  [540] = 360,
  [541] = 354,
  [542] = 428,
  [543] = 420,
  [544] = 377,
  [545] = 449,
  [546] = 421,
  [547] = 270,
  [548] = 447,
  [549] = 446,
  [550] = 450,
  [551] = 373,
  [552] = 398,
  [553] = 399,
  [554] = 452,
  [555] = 272,
  [556] = 409,
  [557] = 459,
  [558] = 380,
  [559] = 436,
  [560] = 451,
  [561] = 435,
  [562] = 434,
  [563] = 155,
  [564] = 433,
  [565] = 155,
  [566] = 270,
  [567] = 437,
  [568] = 403,
  [569] = 272,
  [570] = 153,
  [571] = 456,
  [572] = 374,
  [573] = 411,
  [574] = 379,
  [575] = 402,
  [576] = 401,
  [577] = 395,
  [578] = 394,
  [579] = 392,
  [580] = 387,
  [581] = 381,
  [582] = 382,
  [583] = 383,
  [584] = 457,
  [585] = 430,
  [586] = 269,
  [587] = 384,
  [588] = 424,
  [589] = 386,
  [590] = 429,
  [591] = 272,
  [592] = 375,
  [593] = 432,
  [594] = 438,
  [595] = 439,
  [596] = 442,
  [597] = 444,
  [598] = 404,
  [599] = 408,
  [600] = 270,
  [601] = 458,
  [602] = 445,
  [603] = 416,
  [604] = 460,
  [605] = 455,
  [606] = 412,
  [607] = 413,
  [608] = 453,
  [609] = 415,
  [610] = 417,
  [611] = 431,
  [612] = 419,
  [613] = 269,
  [614] = 426,
  [615] = 425,
  [616] = 422,
  [617] = 269,
  [618] = 427,
  [619] = 153,
  [620] = 296,
  [621] = 301,
  [622] = 331,
  [623] = 350,
  [624] = 327,
  [625] = 348,
  [626] = 347,
  [627] = 344,
  [628] = 356,
  [629] = 343,
  [630] = 342,
  [631] = 340,
  [632] = 339,
  [633] = 338,
  [634] = 336,
  [635] = 334,
  [636] = 333,
  [637] = 332,
  [638] = 366,
  [639] = 331,
  [640] = 300,
  [641] = 330,
  [642] = 328,
  [643] = 326,
  [644] = 349,
  [645] = 309,
  [646] = 330,
  [647] = 321,
  [648] = 320,
  [649] = 275,
  [650] = 328,
  [651] = 317,
  [652] = 314,
  [653] = 313,
  [654] = 312,
  [655] = 311,
  [656] = 298,
  [657] = 297,
  [658] = 326,
  [659] = 307,
  [660] = 353,
  [661] = 306,
  [662] = 304,
  [663] = 327,
  [664] = 301,
  [665] = 299,
  [666] = 322,
  [667] = 296,
  [668] = 295,
  [669] = 294,
  [670] = 349,
  [671] = 309,
  [672] = 321,
  [673] = 276,
  [674] = 292,
  [675] = 320,
  [676] = 275,
  [677] = 287,
  [678] = 357,
  [679] = 290,
  [680] = 288,
  [681] = 317,
  [682] = 314,
  [683] = 333,
  [684] = 284,
  [685] = 286,
  [686] = 283,
  [687] = 313,
  [688] = 312,
  [689] = 311,
  [690] = 281,
  [691] = 307,
  [692] = 306,
  [693] = 280,
  [694] = 278,
  [695] = 277,
  [696] = 304,
  [697] = 302,
  [698] = 301,
  [699] = 334,
  [700] = 357,
  [701] = 299,
  [702] = 336,
  [703] = 338,
  [704] = 295,
  [705] = 324,
  [706] = 339,
  [707] = 350,
  [708] = 348,
  [709] = 347,
  [710] = 344,
  [711] = 294,
  [712] = 343,
  [713] = 342,
  [714] = 340,
  [715] = 339,
  [716] = 338,
  [717] = 276,
  [718] = 292,
  [719] = 336,
  [720] = 334,
  [721] = 333,
  [722] = 332,
  [723] = 331,
  [724] = 330,
  [725] = 328,
  [726] = 326,
  [727] = 349,
  [728] = 309,
  [729] = 321,
  [730] = 320,
  [731] = 275,
  [732] = 282,
  [733] = 317,
  [734] = 314,
  [735] = 313,
  [736] = 312,
  [737] = 311,
  [738] = 307,
  [739] = 288,
  [740] = 306,
  [741] = 286,
  [742] = 304,
  [743] = 332,
  [744] = 299,
  [745] = 296,
  [746] = 295,
  [747] = 294,
  [748] = 363,
  [749] = 276,
  [750] = 292,
  [751] = 290,
  [752] = 288,
  [753] = 286,
  [754] = 283,
  [755] = 281,
  [756] = 369,
  [757] = 315,
  [758] = 280,
  [759] = 283,
  [760] = 278,
  [761] = 277,
  [762] = 340,
  [763] = 281,
  [764] = 151,
  [765] = 323,
  [766] = 308,
  [767] = 305,
  [768] = 335,
  [769] = 290,
  [770] = 770,
  [771] = 771,
  [772] = 280,
  [773] = 278,
  [774] = 277,
  [775] = 302,
  [776] = 776,
  [777] = 324,
  [778] = 343,
  [779] = 354,
  [780] = 344,
  [781] = 324,
  [782] = 354,
  [783] = 279,
  [784] = 360,
  [785] = 369,
  [786] = 347,
  [787] = 364,
  [788] = 305,
  [789] = 308,
  [790] = 348,
  [791] = 350,
  [792] = 363,
  [793] = 353,
  [794] = 776,
  [795] = 300,
  [796] = 282,
  [797] = 770,
  [798] = 298,
  [799] = 335,
  [800] = 362,
  [801] = 322,
  [802] = 316,
  [803] = 318,
  [804] = 297,
  [805] = 364,
  [806] = 360,
  [807] = 287,
  [808] = 360,
  [809] = 335,
  [810] = 284,
  [811] = 365,
  [812] = 371,
  [813] = 368,
  [814] = 354,
  [815] = 356,
  [816] = 357,
  [817] = 369,
  [818] = 372,
  [819] = 356,
  [820] = 363,
  [821] = 368,
  [822] = 364,
  [823] = 323,
  [824] = 371,
  [825] = 770,
  [826] = 365,
  [827] = 279,
  [828] = 362,
  [829] = 776,
  [830] = 353,
  [831] = 776,
  [832] = 365,
  [833] = 316,
  [834] = 318,
  [835] = 371,
  [836] = 315,
  [837] = 770,
  [838] = 279,
  [839] = 368,
  [840] = 327,
  [841] = 322,
  [842] = 342,
  [843] = 843,
  [844] = 297,
  [845] = 298,
  [846] = 846,
  [847] = 284,
  [848] = 848,
  [849] = 849,
  [850] = 300,
  [851] = 366,
  [852] = 372,
  [853] = 318,
  [854] = 302,
  [855] = 305,
  [856] = 308,
  [857] = 366,
  [858] = 323,
  [859] = 372,
  [860] = 287,
  [861] = 282,
  [862] = 316,
  [863] = 315,
  [864] = 362,
  [865] = 403,
  [866] = 382,
  [867] = 377,
  [868] = 380,
  [869] = 379,
  [870] = 381,
  [871] = 419,
  [872] = 374,
  [873] = 383,
  [874] = 433,
  [875] = 434,
  [876] = 384,
  [877] = 381,
  [878] = 382,
  [879] = 372,
  [880] = 435,
  [881] = 436,
  [882] = 411,
  [883] = 386,
  [884] = 387,
  [885] = 392,
  [886] = 394,
  [887] = 395,
  [888] = 401,
  [889] = 402,
  [890] = 379,
  [891] = 375,
  [892] = 374,
  [893] = 263,
  [894] = 383,
  [895] = 384,
  [896] = 446,
  [897] = 432,
  [898] = 433,
  [899] = 434,
  [900] = 435,
  [901] = 436,
  [902] = 447,
  [903] = 438,
  [904] = 439,
  [905] = 403,
  [906] = 449,
  [907] = 398,
  [908] = 417,
  [909] = 399,
  [910] = 442,
  [911] = 264,
  [912] = 444,
  [913] = 415,
  [914] = 404,
  [915] = 413,
  [916] = 412,
  [917] = 408,
  [918] = 445,
  [919] = 446,
  [920] = 447,
  [921] = 449,
  [922] = 386,
  [923] = 450,
  [924] = 409,
  [925] = 412,
  [926] = 413,
  [927] = 415,
  [928] = 431,
  [929] = 428,
  [930] = 373,
  [931] = 417,
  [932] = 451,
  [933] = 455,
  [934] = 420,
  [935] = 419,
  [936] = 420,
  [937] = 456,
  [938] = 425,
  [939] = 421,
  [940] = 422,
  [941] = 457,
  [942] = 422,
  [943] = 460,
  [944] = 450,
  [945] = 424,
  [946] = 451,
  [947] = 408,
  [948] = 425,
  [949] = 404,
  [950] = 411,
  [951] = 452,
  [952] = 453,
  [953] = 455,
  [954] = 437,
  [955] = 380,
  [956] = 377,
  [957] = 456,
  [958] = 457,
  [959] = 430,
  [960] = 429,
  [961] = 416,
  [962] = 460,
  [963] = 427,
  [964] = 426,
  [965] = 452,
  [966] = 426,
  [967] = 427,
  [968] = 459,
  [969] = 424,
  [970] = 458,
  [971] = 421,
  [972] = 428,
  [973] = 429,
  [974] = 430,
  [975] = 458,
  [976] = 459,
  [977] = 398,
  [978] = 399,
  [979] = 431,
  [980] = 416,
  [981] = 373,
  [982] = 453,
  [983] = 409,
  [984] = 437,
  [985] = 402,
  [986] = 401,
  [987] = 395,
  [988] = 394,
  [989] = 392,
  [990] = 445,
  [991] = 444,
  [992] = 442,
  [993] = 439,
  [994] = 438,
  [995] = 387,
  [996] = 375,
  [997] = 432,
  [998] = 421,
  [999] = 437,
  [1000] = 151,
  [1001] = 151,
  [1002] = 848,
  [1003] = 444,
  [1004] = 402,
  [1005] = 403,
  [1006] = 151,
  [1007] = 430,
  [1008] = 409,
  [1009] = 394,
  [1010] = 1010,
  [1011] = 446,
  [1012] = 1012,
  [1013] = 419,
  [1014] = 1010,
  [1015] = 455,
  [1016] = 447,
  [1017] = 445,
  [1018] = 1010,
  [1019] = 1010,
  [1020] = 1010,
  [1021] = 1010,
  [1022] = 1012,
  [1023] = 1023,
  [1024] = 1012,
  [1025] = 1025,
  [1026] = 449,
  [1027] = 386,
  [1028] = 379,
  [1029] = 1012,
  [1030] = 375,
  [1031] = 151,
  [1032] = 425,
  [1033] = 427,
  [1034] = 374,
  [1035] = 411,
  [1036] = 1012,
  [1037] = 848,
  [1038] = 459,
  [1039] = 432,
  [1040] = 420,
  [1041] = 387,
  [1042] = 426,
  [1043] = 392,
  [1044] = 1012,
  [1045] = 1012,
  [1046] = 1046,
  [1047] = 1012,
  [1048] = 1048,
  [1049] = 431,
  [1050] = 1010,
  [1051] = 1010,
  [1052] = 442,
  [1053] = 399,
  [1054] = 1012,
  [1055] = 401,
  [1056] = 848,
  [1057] = 398,
  [1058] = 428,
  [1059] = 380,
  [1060] = 1012,
  [1061] = 377,
  [1062] = 429,
  [1063] = 460,
  [1064] = 416,
  [1065] = 1065,
  [1066] = 1010,
  [1067] = 417,
  [1068] = 373,
  [1069] = 424,
  [1070] = 422,
  [1071] = 433,
  [1072] = 434,
  [1073] = 415,
  [1074] = 1074,
  [1075] = 413,
  [1076] = 1010,
  [1077] = 412,
  [1078] = 151,
  [1079] = 457,
  [1080] = 456,
  [1081] = 382,
  [1082] = 395,
  [1083] = 1010,
  [1084] = 151,
  [1085] = 453,
  [1086] = 435,
  [1087] = 436,
  [1088] = 383,
  [1089] = 452,
  [1090] = 451,
  [1091] = 450,
  [1092] = 408,
  [1093] = 404,
  [1094] = 1012,
  [1095] = 1010,
  [1096] = 1012,
  [1097] = 1097,
  [1098] = 458,
  [1099] = 384,
  [1100] = 438,
  [1101] = 439,
  [1102] = 381,
  [1103] = 1103,
  [1104] = 1104,
  [1105] = 1104,
  [1106] = 1106,
  [1107] = 1106,
  [1108] = 1106,
  [1109] = 1106,
  [1110] = 1106,
  [1111] = 1106,
  [1112] = 1106,
  [1113] = 1106,
  [1114] = 1106,
  [1115] = 1115,
  [1116] = 1116,
  [1117] = 1117,
  [1118] = 1117,
  [1119] = 1117,
  [1120] = 1117,
  [1121] = 1117,
  [1122] = 1117,
  [1123] = 1117,
  [1124] = 1117,
  [1125] = 1117,
  [1126] = 1126,
  [1127] = 1127,
  [1128] = 1128,
  [1129] = 1129,
  [1130] = 1130,
  [1131] = 1126,
  [1132] = 1126,
  [1133] = 1133,
  [1134] = 1130,
  [1135] = 1126,
  [1136] = 1136,
  [1137] = 1137,
  [1138] = 1138,
  [1139] = 1139,
  [1140] = 1130,
  [1141] = 1141,
  [1142] = 1128,
  [1143] = 1133,
  [1144] = 1130,
  [1145] = 1141,
  [1146] = 1130,
  [1147] = 1127,
  [1148] = 1126,
  [1149] = 1149,
  [1150] = 1150,
  [1151] = 261,
  [1152] = 1150,
  [1153] = 262,
  [1154] = 270,
  [1155] = 1155,
  [1156] = 269,
  [1157] = 272,
  [1158] = 155,
  [1159] = 153,
  [1160] = 369,
  [1161] = 306,
  [1162] = 297,
  [1163] = 1115,
  [1164] = 360,
  [1165] = 1165,
  [1166] = 322,
  [1167] = 287,
  [1168] = 353,
  [1169] = 357,
  [1170] = 350,
  [1171] = 298,
  [1172] = 348,
  [1173] = 300,
  [1174] = 347,
  [1175] = 302,
  [1176] = 305,
  [1177] = 308,
  [1178] = 323,
  [1179] = 344,
  [1180] = 315,
  [1181] = 343,
  [1182] = 342,
  [1183] = 340,
  [1184] = 339,
  [1185] = 327,
  [1186] = 338,
  [1187] = 335,
  [1188] = 336,
  [1189] = 334,
  [1190] = 333,
  [1191] = 363,
  [1192] = 364,
  [1193] = 332,
  [1194] = 331,
  [1195] = 366,
  [1196] = 282,
  [1197] = 279,
  [1198] = 330,
  [1199] = 318,
  [1200] = 328,
  [1201] = 316,
  [1202] = 324,
  [1203] = 1116,
  [1204] = 326,
  [1205] = 362,
  [1206] = 349,
  [1207] = 277,
  [1208] = 278,
  [1209] = 1165,
  [1210] = 280,
  [1211] = 281,
  [1212] = 283,
  [1213] = 286,
  [1214] = 309,
  [1215] = 288,
  [1216] = 290,
  [1217] = 292,
  [1218] = 284,
  [1219] = 321,
  [1220] = 320,
  [1221] = 365,
  [1222] = 371,
  [1223] = 368,
  [1224] = 276,
  [1225] = 1165,
  [1226] = 275,
  [1227] = 317,
  [1228] = 314,
  [1229] = 1229,
  [1230] = 313,
  [1231] = 1149,
  [1232] = 294,
  [1233] = 312,
  [1234] = 295,
  [1235] = 311,
  [1236] = 296,
  [1237] = 299,
  [1238] = 301,
  [1239] = 304,
  [1240] = 1165,
  [1241] = 307,
  [1242] = 354,
  [1243] = 356,
  [1244] = 1165,
  [1245] = 1245,
  [1246] = 1246,
  [1247] = 1247,
  [1248] = 1246,
  [1249] = 1245,
  [1250] = 1247,
  [1251] = 1245,
  [1252] = 1247,
  [1253] = 1246,
  [1254] = 1246,
  [1255] = 1246,
  [1256] = 1247,
  [1257] = 1246,
  [1258] = 1247,
  [1259] = 1259,
  [1260] = 1247,
  [1261] = 1245,
  [1262] = 1246,
  [1263] = 1247,
  [1264] = 1247,
  [1265] = 1245,
  [1266] = 1246,
  [1267] = 1246,
  [1268] = 1247,
  [1269] = 1245,
  [1270] = 1247,
  [1271] = 1247,
  [1272] = 1245,
  [1273] = 1245,
  [1274] = 1274,
  [1275] = 1246,
  [1276] = 1246,
  [1277] = 1277,
  [1278] = 1278,
  [1279] = 1277,
  [1280] = 1277,
  [1281] = 1278,
  [1282] = 1277,
  [1283] = 1278,
  [1284] = 1277,
  [1285] = 1278,
  [1286] = 1278,
  [1287] = 1277,
  [1288] = 1277,
  [1289] = 1278,
  [1290] = 1278,
  [1291] = 1277,
  [1292] = 1278,
  [1293] = 1293,
  [1294] = 1294,
  [1295] = 1295,
  [1296] = 1295,
  [1297] = 1295,
  [1298] = 1298,
  [1299] = 1298,
  [1300] = 1298,
  [1301] = 1294,
  [1302] = 1298,
  [1303] = 1298,
  [1304] = 1295,
  [1305] = 1298,
  [1306] = 1298,
  [1307] = 1298,
  [1308] = 1298,
  [1309] = 1295,
  [1310] = 1295,
  [1311] = 1311,
  [1312] = 1312,
  [1313] = 1312,
  [1314] = 1312,
  [1315] = 1312,
  [1316] = 1311,
  [1317] = 1311,
  [1318] = 1312,
  [1319] = 1311,
  [1320] = 1312,
  [1321] = 1311,
  [1322] = 1312,
  [1323] = 1323,
  [1324] = 1311,
  [1325] = 1312,
  [1326] = 1294,
  [1327] = 1312,
  [1328] = 1312,
  [1329] = 1312,
  [1330] = 1330,
  [1331] = 1331,
  [1332] = 1332,
  [1333] = 1333,
  [1334] = 1330,
  [1335] = 1330,
  [1336] = 1332,
  [1337] = 1332,
  [1338] = 1333,
  [1339] = 1330,
  [1340] = 1331,
  [1341] = 1332,
  [1342] = 1333,
  [1343] = 1330,
  [1344] = 1331,
  [1345] = 1345,
  [1346] = 1333,
  [1347] = 1347,
  [1348] = 1331,
  [1349] = 1331,
  [1350] = 1333,
  [1351] = 1330,
  [1352] = 1331,
  [1353] = 1330,
  [1354] = 1354,
  [1355] = 1333,
  [1356] = 1356,
  [1357] = 1331,
  [1358] = 1358,
  [1359] = 1359,
  [1360] = 1333,
  [1361] = 1332,
  [1362] = 1332,
  [1363] = 1332,
  [1364] = 1333,
  [1365] = 1365,
  [1366] = 1366,
  [1367] = 1332,
  [1368] = 1333,
  [1369] = 1365,
  [1370] = 1331,
  [1371] = 1371,
  [1372] = 1330,
  [1373] = 1373,
  [1374] = 1365,
  [1375] = 1375,
  [1376] = 1345,
  [1377] = 1333,
  [1378] = 1378,
  [1379] = 1333,
  [1380] = 1330,
  [1381] = 1333,
  [1382] = 1330,
  [1383] = 1332,
  [1384] = 1384,
  [1385] = 1331,
  [1386] = 1332,
  [1387] = 1387,
  [1388] = 1388,
  [1389] = 1389,
  [1390] = 1345,
  [1391] = 1331,
  [1392] = 1330,
  [1393] = 1365,
  [1394] = 1333,
  [1395] = 1333,
  [1396] = 1330,
  [1397] = 1332,
  [1398] = 1331,
  [1399] = 1332,
  [1400] = 1331,
  [1401] = 1330,
  [1402] = 1331,
  [1403] = 1332,
  [1404] = 1332,
  [1405] = 1331,
  [1406] = 1331,
  [1407] = 1332,
  [1408] = 1408,
  [1409] = 1333,
  [1410] = 1330,
  [1411] = 1330,
  [1412] = 1345,
  [1413] = 1413,
  [1414] = 1414,
  [1415] = 1414,
  [1416] = 1414,
  [1417] = 1417,
  [1418] = 1414,
  [1419] = 1417,
  [1420] = 1420,
  [1421] = 1414,
  [1422] = 1414,
  [1423] = 1423,
  [1424] = 1417,
  [1425] = 1414,
  [1426] = 1414,
  [1427] = 1417,
  [1428] = 1428,
  [1429] = 1429,
  [1430] = 1417,
  [1431] = 1431,
  [1432] = 1414,
  [1433] = 1417,
  [1434] = 1414,
  [1435] = 1435,
  [1436] = 1436,
  [1437] = 1437,
  [1438] = 1417,
  [1439] = 1439,
  [1440] = 1440,
  [1441] = 1417,
  [1442] = 1431,
  [1443] = 1443,
  [1444] = 1444,
  [1445] = 1417,
  [1446] = 1446,
  [1447] = 1447,
  [1448] = 1431,
  [1449] = 1417,
  [1450] = 1450,
  [1451] = 1431,
  [1452] = 1417,
  [1453] = 1417,
  [1454] = 1414,
  [1455] = 1414,
  [1456] = 1431,
  [1457] = 1457,
  [1458] = 1417,
  [1459] = 1431,
  [1460] = 1460,
  [1461] = 1431,
  [1462] = 1417,
  [1463] = 1414,
  [1464] = 1431,
  [1465] = 1414,
  [1466] = 1417,
  [1467] = 1467,
  [1468] = 1414,
  [1469] = 1469,
  [1470] = 1470,
  [1471] = 1471,
  [1472] = 1469,
  [1473] = 1473,
  [1474] = 1474,
  [1475] = 1473,
  [1476] = 1470,
  [1477] = 1477,
  [1478] = 1478,
  [1479] = 1479,
  [1480] = 1470,
  [1481] = 1470,
  [1482] = 1482,
  [1483] = 1471,
  [1484] = 1484,
  [1485] = 1485,
  [1486] = 1486,
  [1487] = 1470,
  [1488] = 1471,
  [1489] = 1471,
  [1490] = 1490,
  [1491] = 1471,
  [1492] = 1469,
  [1493] = 1471,
  [1494] = 1486,
  [1495] = 1474,
  [1496] = 1485,
  [1497] = 1497,
  [1498] = 1471,
  [1499] = 1473,
  [1500] = 1490,
  [1501] = 1501,
  [1502] = 1474,
  [1503] = 1503,
  [1504] = 1504,
  [1505] = 1505,
  [1506] = 1473,
  [1507] = 1470,
  [1508] = 1470,
  [1509] = 1503,
  [1510] = 1471,
  [1511] = 1511,
  [1512] = 1504,
  [1513] = 1511,
  [1514] = 1471,
  [1515] = 1471,
  [1516] = 1516,
  [1517] = 1516,
  [1518] = 1518,
  [1519] = 1519,
  [1520] = 1520,
  [1521] = 1474,
  [1522] = 1522,
  [1523] = 1518,
  [1524] = 1520,
  [1525] = 1522,
  [1526] = 1471,
  [1527] = 1490,
  [1528] = 1484,
  [1529] = 1484,
  [1530] = 1474,
  [1531] = 1531,
  [1532] = 1469,
  [1533] = 1471,
  [1534] = 1531,
  [1535] = 1519,
  [1536] = 1536,
  [1537] = 1537,
  [1538] = 1538,
  [1539] = 1473,
  [1540] = 1490,
  [1541] = 1537,
  [1542] = 1542,
  [1543] = 1470,
  [1544] = 1470,
  [1545] = 1470,
  [1546] = 1546,
  [1547] = 1547,
  [1548] = 1548,
  [1549] = 1471,
  [1550] = 1469,
  [1551] = 1473,
  [1552] = 1552,
  [1553] = 1553,
  [1554] = 1553,
  [1555] = 1484,
  [1556] = 1471,
  [1557] = 1471,
  [1558] = 1501,
  [1559] = 1477,
  [1560] = 1478,
  [1561] = 1482,
  [1562] = 1562,
  [1563] = 1563,
  [1564] = 1470,
  [1565] = 1565,
  [1566] = 1566,
  [1567] = 1538,
  [1568] = 1546,
  [1569] = 1484,
  [1570] = 1479,
  [1571] = 1571,
  [1572] = 1562,
  [1573] = 1563,
  [1574] = 1565,
  [1575] = 1575,
  [1576] = 1576,
  [1577] = 1547,
  [1578] = 1548,
  [1579] = 1552,
  [1580] = 1566,
  [1581] = 1576,
  [1582] = 1536,
  [1583] = 1469,
  [1584] = 1470,
  [1585] = 1585,
  [1586] = 1586,
  [1587] = 1587,
  [1588] = 1587,
  [1589] = 1586,
  [1590] = 1590,
  [1591] = 1585,
  [1592] = 1592,
  [1593] = 1593,
  [1594] = 1594,
  [1595] = 1595,
  [1596] = 1586,
  [1597] = 1597,
  [1598] = 1597,
  [1599] = 1599,
  [1600] = 1600,
  [1601] = 1601,
  [1602] = 1601,
  [1603] = 1603,
  [1604] = 1604,
  [1605] = 1599,
  [1606] = 1606,
  [1607] = 1607,
  [1608] = 1608,
  [1609] = 1609,
  [1610] = 1609,
  [1611] = 1585,
  [1612] = 1612,
  [1613] = 1607,
  [1614] = 1614,
  [1615] = 1615,
  [1616] = 1608,
  [1617] = 1617,
  [1618] = 1601,
  [1619] = 1600,
  [1620] = 1620,
  [1621] = 1606,
  [1622] = 1622,
  [1623] = 1594,
  [1624] = 1624,
  [1625] = 1600,
  [1626] = 1590,
  [1627] = 1599,
  [1628] = 1628,
  [1629] = 1629,
  [1630] = 1595,
  [1631] = 1606,
  [1632] = 1622,
  [1633] = 1608,
  [1634] = 1606,
  [1635] = 1594,
  [1636] = 1636,
  [1637] = 1593,
  [1638] = 1638,
  [1639] = 1639,
  [1640] = 1620,
  [1641] = 1641,
  [1642] = 1642,
  [1643] = 1585,
  [1644] = 1636,
  [1645] = 1645,
  [1646] = 1639,
  [1647] = 1587,
  [1648] = 1642,
  [1649] = 1629,
  [1650] = 1622,
  [1651] = 1636,
  [1652] = 1614,
  [1653] = 1620,
  [1654] = 1593,
  [1655] = 1609,
  [1656] = 1597,
  [1657] = 1594,
  [1658] = 1639,
  [1659] = 1597,
  [1660] = 1660,
  [1661] = 1600,
  [1662] = 1586,
  [1663] = 1615,
  [1664] = 1608,
  [1665] = 1597,
  [1666] = 1639,
  [1667] = 1624,
  [1668] = 1592,
  [1669] = 1597,
  [1670] = 1595,
  [1671] = 1671,
  [1672] = 1586,
  [1673] = 1612,
  [1674] = 1617,
  [1675] = 1624,
  [1676] = 1603,
  [1677] = 1609,
  [1678] = 1593,
  [1679] = 1595,
  [1680] = 1601,
  [1681] = 1587,
  [1682] = 1599,
  [1683] = 1590,
  [1684] = 1590,
  [1685] = 1609,
  [1686] = 1622,
  [1687] = 1599,
  [1688] = 1606,
  [1689] = 1620,
  [1690] = 1587,
  [1691] = 1609,
  [1692] = 1608,
  [1693] = 1597,
  [1694] = 1594,
  [1695] = 1608,
  [1696] = 1600,
  [1697] = 1608,
  [1698] = 1601,
  [1699] = 1641,
  [1700] = 1636,
  [1701] = 1629,
  [1702] = 1622,
  [1703] = 1590,
  [1704] = 1609,
  [1705] = 1629,
  [1706] = 1599,
  [1707] = 1587,
  [1708] = 1609,
  [1709] = 1592,
  [1710] = 1710,
  [1711] = 1593,
  [1712] = 1595,
  [1713] = 1615,
  [1714] = 1606,
  [1715] = 1608,
  [1716] = 1641,
  [1717] = 1592,
  [1718] = 1636,
  [1719] = 1615,
  [1720] = 1617,
  [1721] = 1603,
  [1722] = 1585,
  [1723] = 1615,
  [1724] = 1606,
  [1725] = 1725,
  [1726] = 1636,
  [1727] = 1727,
  [1728] = 1636,
  [1729] = 1615,
  [1730] = 1615,
  [1731] = 1585,
  [1732] = 1641,
  [1733] = 1733,
  [1734] = 1592,
  [1735] = 1592,
  [1736] = 1585,
  [1737] = 1641,
  [1738] = 1615,
  [1739] = 1601,
  [1740] = 1600,
  [1741] = 1594,
  [1742] = 1620,
  [1743] = 1615,
  [1744] = 1585,
  [1745] = 1608,
  [1746] = 1622,
  [1747] = 1590,
  [1748] = 1710,
  [1749] = 1599,
  [1750] = 1587,
  [1751] = 1593,
  [1752] = 1595,
  [1753] = 1601,
  [1754] = 1600,
  [1755] = 1594,
  [1756] = 1592,
  [1757] = 1620,
  [1758] = 1622,
  [1759] = 1759,
  [1760] = 1585,
  [1761] = 1590,
  [1762] = 1641,
  [1763] = 1608,
  [1764] = 1599,
  [1765] = 1606,
  [1766] = 1601,
  [1767] = 1600,
  [1768] = 1594,
  [1769] = 1620,
  [1770] = 1622,
  [1771] = 1628,
  [1772] = 1587,
  [1773] = 1597,
  [1774] = 1592,
  [1775] = 1595,
  [1776] = 1606,
  [1777] = 1593,
  [1778] = 1592,
  [1779] = 1587,
  [1780] = 1599,
  [1781] = 1590,
  [1782] = 1622,
  [1783] = 1593,
  [1784] = 1595,
  [1785] = 1620,
  [1786] = 1594,
  [1787] = 1600,
  [1788] = 1601,
  [1789] = 1592,
  [1790] = 1641,
  [1791] = 1590,
  [1792] = 1606,
  [1793] = 1608,
  [1794] = 1620,
  [1795] = 1710,
  [1796] = 1604,
  [1797] = 1595,
  [1798] = 1585,
  [1799] = 1615,
  [1800] = 1599,
  [1801] = 1593,
  [1802] = 1595,
  [1803] = 1594,
  [1804] = 1804,
  [1805] = 1612,
  [1806] = 1636,
  [1807] = 1639,
  [1808] = 1641,
  [1809] = 1585,
  [1810] = 1608,
  [1811] = 1592,
  [1812] = 1603,
  [1813] = 1624,
  [1814] = 1615,
  [1815] = 1592,
  [1816] = 1710,
  [1817] = 1615,
  [1818] = 1603,
  [1819] = 1593,
  [1820] = 1641,
  [1821] = 1585,
  [1822] = 1592,
  [1823] = 1595,
  [1824] = 1636,
  [1825] = 1585,
  [1826] = 1826,
  [1827] = 1595,
  [1828] = 1593,
  [1829] = 1587,
  [1830] = 1599,
  [1831] = 1590,
  [1832] = 1622,
  [1833] = 1620,
  [1834] = 1594,
  [1835] = 1600,
  [1836] = 1601,
  [1837] = 1641,
  [1838] = 1642,
  [1839] = 1612,
  [1840] = 1606,
  [1841] = 1641,
  [1842] = 1615,
  [1843] = 1617,
  [1844] = 1608,
  [1845] = 1592,
  [1846] = 1614,
  [1847] = 1639,
  [1848] = 1607,
  [1849] = 1606,
  [1850] = 1607,
  [1851] = 1601,
  [1852] = 1609,
  [1853] = 1609,
  [1854] = 1607,
  [1855] = 1855,
  [1856] = 1624,
  [1857] = 1857,
  [1858] = 1636,
  [1859] = 1600,
  [1860] = 1594,
  [1861] = 1710,
  [1862] = 1624,
  [1863] = 1620,
  [1864] = 1622,
  [1865] = 1612,
  [1866] = 1636,
  [1867] = 1590,
  [1868] = 1641,
  [1869] = 1599,
  [1870] = 1609,
  [1871] = 1615,
  [1872] = 1872,
  [1873] = 1595,
  [1874] = 1855,
  [1875] = 1857,
  [1876] = 1624,
  [1877] = 1642,
  [1878] = 1710,
  [1879] = 1617,
  [1880] = 1606,
  [1881] = 1620,
  [1882] = 1593,
  [1883] = 1587,
  [1884] = 1607,
  [1885] = 1636,
  [1886] = 1603,
  [1887] = 1710,
  [1888] = 1587,
  [1889] = 1599,
  [1890] = 1603,
  [1891] = 1609,
  [1892] = 1590,
  [1893] = 1639,
  [1894] = 1593,
  [1895] = 1595,
  [1896] = 1612,
  [1897] = 1601,
  [1898] = 1898,
  [1899] = 1609,
  [1900] = 1900,
  [1901] = 1609,
  [1902] = 1607,
  [1903] = 1629,
  [1904] = 1622,
  [1905] = 1641,
  [1906] = 1600,
  [1907] = 1907,
  [1908] = 1601,
  [1909] = 1641,
  [1910] = 1590,
  [1911] = 1642,
  [1912] = 1629,
  [1913] = 1620,
  [1914] = 1594,
  [1915] = 1620,
  [1916] = 1622,
  [1917] = 1590,
  [1918] = 1599,
  [1919] = 1612,
  [1920] = 1587,
  [1921] = 1594,
  [1922] = 1586,
  [1923] = 1642,
  [1924] = 1593,
  [1925] = 1595,
  [1926] = 1608,
  [1927] = 1622,
  [1928] = 1606,
  [1929] = 1601,
  [1930] = 1600,
  [1931] = 1594,
  [1932] = 1620,
  [1933] = 1617,
  [1934] = 1622,
  [1935] = 1590,
  [1936] = 1585,
  [1937] = 1636,
  [1938] = 1599,
  [1939] = 1587,
  [1940] = 1593,
  [1941] = 1639,
  [1942] = 1587,
  [1943] = 1636,
  [1944] = 1612,
  [1945] = 1624,
  [1946] = 1597,
  [1947] = 1606,
  [1948] = 1586,
  [1949] = 1604,
  [1950] = 1617,
  [1951] = 1603,
  [1952] = 1607,
  [1953] = 1617,
  [1954] = 1636,
  [1955] = 1607,
  [1956] = 1612,
  [1957] = 1710,
  [1958] = 1600,
  [1959] = 1608,
  [1960] = 1617,
  [1961] = 1601,
  [1962] = 1615,
  [1963] = 1585,
  [1964] = 1592,
  [1965] = 1641,
  [1966] = 1966,
  [1967] = 1671,
  [1968] = 1603,
  [1969] = 1600,
  [1970] = 1609,
  [1971] = 1971,
  [1972] = 1971,
  [1973] = 1973,
  [1974] = 1974,
  [1975] = 1975,
  [1976] = 1976,
  [1977] = 1977,
  [1978] = 1978,
  [1979] = 1979,
  [1980] = 1980,
  [1981] = 1981,
  [1982] = 1981,
  [1983] = 1983,
  [1984] = 1981,
  [1985] = 1981,
  [1986] = 1981,
  [1987] = 1987,
  [1988] = 452,
  [1989] = 459,
  [1990] = 1978,
  [1991] = 1978,
  [1992] = 1975,
  [1993] = 1978,
  [1994] = 1979,
  [1995] = 1995,
  [1996] = 1973,
  [1997] = 1980,
  [1998] = 1974,
  [1999] = 1976,
  [2000] = 1977,
  [2001] = 1983,
  [2002] = 1983,
  [2003] = 1974,
  [2004] = 1973,
  [2005] = 1975,
  [2006] = 1294,
  [2007] = 1976,
  [2008] = 1977,
  [2009] = 1980,
  [2010] = 1983,
  [2011] = 1979,
  [2012] = 1294,
  [2013] = 1974,
  [2014] = 1980,
  [2015] = 1975,
  [2016] = 1977,
  [2017] = 1976,
  [2018] = 1983,
  [2019] = 1979,
  [2020] = 1973,
  [2021] = 2021,
  [2022] = 2021,
  [2023] = 2021,
  [2024] = 2021,
  [2025] = 2021,
  [2026] = 2026,
  [2027] = 2026,
  [2028] = 2026,
  [2029] = 2026,
  [2030] = 2026,
  [2031] = 2026,
  [2032] = 2026,
  [2033] = 2026,
  [2034] = 2026,
  [2035] = 1983,
  [2036] = 2036,
  [2037] = 2037,
  [2038] = 2037,
  [2039] = 2039,
  [2040] = 2040,
  [2041] = 2041,
  [2042] = 2042,
  [2043] = 2043,
  [2044] = 2044,
  [2045] = 2045,
  [2046] = 2046,
  [2047] = 2047,
  [2048] = 2048,
  [2049] = 2049,
  [2050] = 2050,
  [2051] = 2051,
  [2052] = 2052,
  [2053] = 2053,
  [2054] = 2054,
  [2055] = 2055,
  [2056] = 2055,
  [2057] = 2057,
  [2058] = 2055,
  [2059] = 2059,
  [2060] = 2055,
  [2061] = 2055,
  [2062] = 2062,
  [2063] = 2063,
  [2064] = 2064,
  [2065] = 2065,
  [2066] = 2066,
  [2067] = 2067,
  [2068] = 2068,
  [2069] = 261,
  [2070] = 262,
  [2071] = 2071,
  [2072] = 1983,
  [2073] = 263,
  [2074] = 264,
  [2075] = 1983,
  [2076] = 153,
  [2077] = 1975,
  [2078] = 1977,
  [2079] = 2063,
  [2080] = 1976,
  [2081] = 372,
  [2082] = 372,
  [2083] = 1973,
  [2084] = 1979,
  [2085] = 1980,
  [2086] = 1974,
  [2087] = 155,
  [2088] = 402,
  [2089] = 1975,
  [2090] = 403,
  [2091] = 1980,
  [2092] = 2092,
  [2093] = 263,
  [2094] = 2094,
  [2095] = 2095,
  [2096] = 1974,
  [2097] = 1977,
  [2098] = 264,
  [2099] = 430,
  [2100] = 261,
  [2101] = 2101,
  [2102] = 262,
  [2103] = 444,
  [2104] = 1976,
  [2105] = 1973,
  [2106] = 2106,
  [2107] = 1979,
  [2108] = 269,
  [2109] = 2109,
  [2110] = 287,
  [2111] = 318,
  [2112] = 458,
  [2113] = 2113,
  [2114] = 1025,
  [2115] = 459,
  [2116] = 2116,
  [2117] = 356,
  [2118] = 2118,
  [2119] = 2113,
  [2120] = 155,
  [2121] = 2121,
  [2122] = 442,
  [2123] = 2113,
  [2124] = 153,
  [2125] = 1979,
  [2126] = 1074,
  [2127] = 439,
  [2128] = 438,
  [2129] = 436,
  [2130] = 435,
  [2131] = 452,
  [2132] = 2113,
  [2133] = 354,
  [2134] = 360,
  [2135] = 380,
  [2136] = 377,
  [2137] = 366,
  [2138] = 2138,
  [2139] = 434,
  [2140] = 433,
  [2141] = 432,
  [2142] = 2142,
  [2143] = 375,
  [2144] = 2138,
  [2145] = 2145,
  [2146] = 398,
  [2147] = 399,
  [2148] = 2148,
  [2149] = 2113,
  [2150] = 2138,
  [2151] = 2138,
  [2152] = 2113,
  [2153] = 1983,
  [2154] = 372,
  [2155] = 2113,
  [2156] = 1973,
  [2157] = 2157,
  [2158] = 411,
  [2159] = 2159,
  [2160] = 416,
  [2161] = 394,
  [2162] = 395,
  [2163] = 401,
  [2164] = 1065,
  [2165] = 457,
  [2166] = 2059,
  [2167] = 1976,
  [2168] = 372,
  [2169] = 2116,
  [2170] = 2170,
  [2171] = 2138,
  [2172] = 2172,
  [2173] = 437,
  [2174] = 2138,
  [2175] = 2175,
  [2176] = 445,
  [2177] = 392,
  [2178] = 1097,
  [2179] = 456,
  [2180] = 2180,
  [2181] = 2181,
  [2182] = 404,
  [2183] = 408,
  [2184] = 2184,
  [2185] = 2185,
  [2186] = 2186,
  [2187] = 2187,
  [2188] = 1977,
  [2189] = 2189,
  [2190] = 2190,
  [2191] = 2191,
  [2192] = 2192,
  [2193] = 387,
  [2194] = 2194,
  [2195] = 2195,
  [2196] = 2196,
  [2197] = 2197,
  [2198] = 2198,
  [2199] = 2199,
  [2200] = 2200,
  [2201] = 2201,
  [2202] = 2202,
  [2203] = 284,
  [2204] = 2204,
  [2205] = 2205,
  [2206] = 2113,
  [2207] = 2207,
  [2208] = 353,
  [2209] = 2209,
  [2210] = 2138,
  [2211] = 429,
  [2212] = 424,
  [2213] = 1974,
  [2214] = 2214,
  [2215] = 1978,
  [2216] = 2216,
  [2217] = 2217,
  [2218] = 409,
  [2219] = 2219,
  [2220] = 2220,
  [2221] = 316,
  [2222] = 1980,
  [2223] = 362,
  [2224] = 455,
  [2225] = 2225,
  [2226] = 2226,
  [2227] = 1975,
  [2228] = 2113,
  [2229] = 453,
  [2230] = 2116,
  [2231] = 2231,
  [2232] = 2116,
  [2233] = 2233,
  [2234] = 2138,
  [2235] = 2235,
  [2236] = 426,
  [2237] = 2237,
  [2238] = 2116,
  [2239] = 2138,
  [2240] = 373,
  [2241] = 427,
  [2242] = 421,
  [2243] = 428,
  [2244] = 2244,
  [2245] = 2245,
  [2246] = 2246,
  [2247] = 2247,
  [2248] = 2248,
  [2249] = 1978,
  [2250] = 2250,
  [2251] = 2251,
  [2252] = 2252,
  [2253] = 2253,
  [2254] = 2254,
  [2255] = 2255,
  [2256] = 2256,
  [2257] = 263,
  [2258] = 2258,
  [2259] = 2259,
  [2260] = 269,
  [2261] = 261,
  [2262] = 430,
  [2263] = 264,
  [2264] = 2264,
  [2265] = 2255,
  [2266] = 2266,
  [2267] = 2267,
  [2268] = 2268,
  [2269] = 2269,
  [2270] = 2270,
  [2271] = 2271,
  [2272] = 2272,
  [2273] = 2273,
  [2274] = 2274,
  [2275] = 262,
  [2276] = 2276,
  [2277] = 2277,
  [2278] = 2278,
  [2279] = 262,
  [2280] = 2274,
  [2281] = 2281,
  [2282] = 2255,
  [2283] = 2255,
  [2284] = 2284,
  [2285] = 2285,
  [2286] = 261,
  [2287] = 2287,
  [2288] = 263,
  [2289] = 2289,
  [2290] = 2290,
  [2291] = 2291,
  [2292] = 2292,
  [2293] = 444,
  [2294] = 2294,
  [2295] = 403,
  [2296] = 2296,
  [2297] = 402,
  [2298] = 2298,
  [2299] = 2299,
  [2300] = 2300,
  [2301] = 264,
  [2302] = 2302,
  [2303] = 2303,
  [2304] = 2304,
  [2305] = 2198,
  [2306] = 1074,
  [2307] = 316,
  [2308] = 401,
  [2309] = 318,
  [2310] = 2310,
  [2311] = 1025,
  [2312] = 426,
  [2313] = 459,
  [2314] = 445,
  [2315] = 356,
  [2316] = 433,
  [2317] = 377,
  [2318] = 380,
  [2319] = 2216,
  [2320] = 2217,
  [2321] = 155,
  [2322] = 452,
  [2323] = 284,
  [2324] = 2220,
  [2325] = 2225,
  [2326] = 2226,
  [2327] = 153,
  [2328] = 453,
  [2329] = 455,
  [2330] = 2231,
  [2331] = 2233,
  [2332] = 2145,
  [2333] = 2207,
  [2334] = 2205,
  [2335] = 395,
  [2336] = 354,
  [2337] = 287,
  [2338] = 1097,
  [2339] = 404,
  [2340] = 360,
  [2341] = 2204,
  [2342] = 456,
  [2343] = 457,
  [2344] = 2202,
  [2345] = 2345,
  [2346] = 408,
  [2347] = 2201,
  [2348] = 2200,
  [2349] = 2059,
  [2350] = 2199,
  [2351] = 362,
  [2352] = 2197,
  [2353] = 2190,
  [2354] = 1065,
  [2355] = 2355,
  [2356] = 394,
  [2357] = 2186,
  [2358] = 2185,
  [2359] = 409,
  [2360] = 416,
  [2361] = 373,
  [2362] = 2184,
  [2363] = 458,
  [2364] = 2181,
  [2365] = 2365,
  [2366] = 2180,
  [2367] = 372,
  [2368] = 392,
  [2369] = 2187,
  [2370] = 2109,
  [2371] = 2209,
  [2372] = 387,
  [2373] = 2192,
  [2374] = 2175,
  [2375] = 2172,
  [2376] = 2170,
  [2377] = 153,
  [2378] = 427,
  [2379] = 434,
  [2380] = 2251,
  [2381] = 411,
  [2382] = 442,
  [2383] = 428,
  [2384] = 366,
  [2385] = 2385,
  [2386] = 429,
  [2387] = 439,
  [2388] = 438,
  [2389] = 436,
  [2390] = 2191,
  [2391] = 435,
  [2392] = 372,
  [2393] = 2159,
  [2394] = 2194,
  [2395] = 432,
  [2396] = 2195,
  [2397] = 375,
  [2398] = 421,
  [2399] = 2196,
  [2400] = 2400,
  [2401] = 2145,
  [2402] = 372,
  [2403] = 353,
  [2404] = 155,
  [2405] = 1978,
  [2406] = 399,
  [2407] = 2407,
  [2408] = 1983,
  [2409] = 2059,
  [2410] = 424,
  [2411] = 2411,
  [2412] = 372,
  [2413] = 437,
  [2414] = 398,
  [2415] = 2189,
  [2416] = 2068,
  [2417] = 1983,
  [2418] = 269,
  [2419] = 430,
  [2420] = 2420,
  [2421] = 402,
  [2422] = 2219,
  [2423] = 1973,
  [2424] = 1976,
  [2425] = 2235,
  [2426] = 2237,
  [2427] = 2281,
  [2428] = 1977,
  [2429] = 2429,
  [2430] = 430,
  [2431] = 2036,
  [2432] = 2067,
  [2433] = 2148,
  [2434] = 2434,
  [2435] = 2434,
  [2436] = 2036,
  [2437] = 2434,
  [2438] = 2059,
  [2439] = 403,
  [2440] = 2355,
  [2441] = 2365,
  [2442] = 2310,
  [2443] = 2065,
  [2444] = 1974,
  [2445] = 444,
  [2446] = 2446,
  [2447] = 402,
  [2448] = 2420,
  [2449] = 2400,
  [2450] = 2063,
  [2451] = 269,
  [2452] = 444,
  [2453] = 2281,
  [2454] = 403,
  [2455] = 1979,
  [2456] = 1975,
  [2457] = 1980,
  [2458] = 2201,
  [2459] = 366,
  [2460] = 2068,
  [2461] = 2191,
  [2462] = 373,
  [2463] = 2205,
  [2464] = 2192,
  [2465] = 409,
  [2466] = 408,
  [2467] = 404,
  [2468] = 1097,
  [2469] = 2159,
  [2470] = 2194,
  [2471] = 2195,
  [2472] = 2196,
  [2473] = 2059,
  [2474] = 380,
  [2475] = 1097,
  [2476] = 2175,
  [2477] = 2202,
  [2478] = 401,
  [2479] = 395,
  [2480] = 394,
  [2481] = 392,
  [2482] = 387,
  [2483] = 318,
  [2484] = 316,
  [2485] = 399,
  [2486] = 398,
  [2487] = 2170,
  [2488] = 2172,
  [2489] = 409,
  [2490] = 2065,
  [2491] = 362,
  [2492] = 373,
  [2493] = 375,
  [2494] = 2200,
  [2495] = 428,
  [2496] = 432,
  [2497] = 456,
  [2498] = 434,
  [2499] = 435,
  [2500] = 436,
  [2501] = 438,
  [2502] = 439,
  [2503] = 1074,
  [2504] = 442,
  [2505] = 1025,
  [2506] = 2175,
  [2507] = 2109,
  [2508] = 445,
  [2509] = 2180,
  [2510] = 2429,
  [2511] = 2196,
  [2512] = 2181,
  [2513] = 436,
  [2514] = 435,
  [2515] = 2184,
  [2516] = 2195,
  [2517] = 287,
  [2518] = 2185,
  [2519] = 2194,
  [2520] = 434,
  [2521] = 433,
  [2522] = 2522,
  [2523] = 377,
  [2524] = 380,
  [2525] = 2186,
  [2526] = 2199,
  [2527] = 2159,
  [2528] = 2429,
  [2529] = 2207,
  [2530] = 453,
  [2531] = 2192,
  [2532] = 421,
  [2533] = 377,
  [2534] = 2189,
  [2535] = 2198,
  [2536] = 2197,
  [2537] = 2190,
  [2538] = 455,
  [2539] = 459,
  [2540] = 458,
  [2541] = 2186,
  [2542] = 2199,
  [2543] = 457,
  [2544] = 2185,
  [2545] = 424,
  [2546] = 1065,
  [2547] = 416,
  [2548] = 2184,
  [2549] = 411,
  [2550] = 366,
  [2551] = 2065,
  [2552] = 2191,
  [2553] = 426,
  [2554] = 2233,
  [2555] = 427,
  [2556] = 2059,
  [2557] = 2557,
  [2558] = 2231,
  [2559] = 2181,
  [2560] = 458,
  [2561] = 401,
  [2562] = 2189,
  [2563] = 2429,
  [2564] = 428,
  [2565] = 2226,
  [2566] = 2180,
  [2567] = 2225,
  [2568] = 360,
  [2569] = 395,
  [2570] = 354,
  [2571] = 2571,
  [2572] = 429,
  [2573] = 354,
  [2574] = 411,
  [2575] = 2067,
  [2576] = 421,
  [2577] = 424,
  [2578] = 2220,
  [2579] = 2294,
  [2580] = 2145,
  [2581] = 394,
  [2582] = 392,
  [2583] = 387,
  [2584] = 426,
  [2585] = 427,
  [2586] = 2109,
  [2587] = 2217,
  [2588] = 2059,
  [2589] = 452,
  [2590] = 429,
  [2591] = 356,
  [2592] = 2059,
  [2593] = 2522,
  [2594] = 360,
  [2595] = 2291,
  [2596] = 2231,
  [2597] = 437,
  [2598] = 2216,
  [2599] = 2233,
  [2600] = 404,
  [2601] = 353,
  [2602] = 2172,
  [2603] = 445,
  [2604] = 2604,
  [2605] = 2190,
  [2606] = 353,
  [2607] = 1025,
  [2608] = 408,
  [2609] = 442,
  [2610] = 2197,
  [2611] = 2429,
  [2612] = 2198,
  [2613] = 287,
  [2614] = 1074,
  [2615] = 433,
  [2616] = 2067,
  [2617] = 439,
  [2618] = 2200,
  [2619] = 284,
  [2620] = 438,
  [2621] = 399,
  [2622] = 2201,
  [2623] = 437,
  [2624] = 2226,
  [2625] = 2202,
  [2626] = 2209,
  [2627] = 398,
  [2628] = 2170,
  [2629] = 2225,
  [2630] = 2220,
  [2631] = 459,
  [2632] = 2209,
  [2633] = 2217,
  [2634] = 2310,
  [2635] = 2216,
  [2636] = 455,
  [2637] = 2187,
  [2638] = 456,
  [2639] = 457,
  [2640] = 2187,
  [2641] = 452,
  [2642] = 356,
  [2643] = 2429,
  [2644] = 453,
  [2645] = 2068,
  [2646] = 2204,
  [2647] = 2365,
  [2648] = 375,
  [2649] = 2429,
  [2650] = 2205,
  [2651] = 2145,
  [2652] = 2207,
  [2653] = 416,
  [2654] = 1065,
  [2655] = 362,
  [2656] = 432,
  [2657] = 316,
  [2658] = 284,
  [2659] = 2204,
  [2660] = 318,
  [2661] = 2661,
  [2662] = 2662,
  [2663] = 2663,
  [2664] = 2235,
  [2665] = 2237,
  [2666] = 2666,
  [2667] = 2092,
  [2668] = 2118,
  [2669] = 2669,
  [2670] = 2670,
  [2671] = 2671,
  [2672] = 2063,
  [2673] = 2142,
  [2674] = 2067,
  [2675] = 2571,
  [2676] = 2059,
  [2677] = 2677,
  [2678] = 2059,
  [2679] = 2679,
  [2680] = 2680,
  [2681] = 2681,
  [2682] = 2682,
  [2683] = 2683,
  [2684] = 2106,
  [2685] = 2281,
  [2686] = 2157,
  [2687] = 2687,
  [2688] = 2148,
  [2689] = 2687,
  [2690] = 2690,
  [2691] = 2691,
  [2692] = 2145,
  [2693] = 2219,
  [2694] = 2094,
  [2695] = 2281,
  [2696] = 2095,
  [2697] = 153,
  [2698] = 155,
  [2699] = 2063,
  [2700] = 2700,
  [2701] = 2059,
  [2702] = 2702,
  [2703] = 2703,
  [2704] = 2059,
  [2705] = 2294,
  [2706] = 2068,
  [2707] = 2707,
  [2708] = 2708,
  [2709] = 2709,
  [2710] = 2710,
  [2711] = 2711,
  [2712] = 2065,
  [2713] = 1979,
  [2714] = 2714,
  [2715] = 1973,
  [2716] = 2716,
  [2717] = 1976,
  [2718] = 1977,
  [2719] = 1975,
  [2720] = 2720,
  [2721] = 1980,
  [2722] = 1974,
  [2723] = 2723,
  [2724] = 2724,
  [2725] = 2702,
  [2726] = 2726,
  [2727] = 1116,
  [2728] = 2285,
  [2729] = 2729,
  [2730] = 2671,
  [2731] = 2731,
  [2732] = 2269,
  [2733] = 2733,
  [2734] = 2734,
  [2735] = 2270,
  [2736] = 2736,
  [2737] = 2303,
  [2738] = 2246,
  [2739] = 2247,
  [2740] = 2666,
  [2741] = 2248,
  [2742] = 1978,
  [2743] = 2661,
  [2744] = 2744,
  [2745] = 2250,
  [2746] = 2252,
  [2747] = 2244,
  [2748] = 2748,
  [2749] = 2276,
  [2750] = 2302,
  [2751] = 2145,
  [2752] = 2266,
  [2753] = 2267,
  [2754] = 2300,
  [2755] = 2268,
  [2756] = 2708,
  [2757] = 2256,
  [2758] = 2299,
  [2759] = 2271,
  [2760] = 2714,
  [2761] = 2063,
  [2762] = 2121,
  [2763] = 2707,
  [2764] = 2764,
  [2765] = 2095,
  [2766] = 2292,
  [2767] = 2677,
  [2768] = 2259,
  [2769] = 2272,
  [2770] = 2254,
  [2771] = 2273,
  [2772] = 2277,
  [2773] = 2094,
  [2774] = 2365,
  [2775] = 2289,
  [2776] = 2258,
  [2777] = 2777,
  [2778] = 2278,
  [2779] = 2106,
  [2780] = 2253,
  [2781] = 2781,
  [2782] = 2365,
  [2783] = 2571,
  [2784] = 2784,
  [2785] = 2785,
  [2786] = 2092,
  [2787] = 2284,
  [2788] = 2296,
  [2789] = 2304,
  [2790] = 2290,
  [2791] = 1115,
  [2792] = 2281,
  [2793] = 2063,
  [2794] = 2794,
  [2795] = 2795,
  [2796] = 2796,
  [2797] = 2310,
  [2798] = 2121,
  [2799] = 2298,
  [2800] = 2245,
  [2801] = 2287,
  [2802] = 2264,
  [2803] = 2310,
  [2804] = 2804,
  [2805] = 2805,
  [2806] = 2291,
  [2807] = 2807,
  [2808] = 2808,
  [2809] = 2281,
  [2810] = 2810,
  [2811] = 2106,
  [2812] = 2812,
  [2813] = 2679,
  [2814] = 2814,
  [2815] = 2677,
  [2816] = 2679,
  [2817] = 2708,
  [2818] = 2068,
  [2819] = 2687,
  [2820] = 2094,
  [2821] = 2065,
  [2822] = 2063,
  [2823] = 2094,
  [2824] = 2824,
  [2825] = 2237,
  [2826] = 2095,
  [2827] = 2106,
  [2828] = 2235,
  [2829] = 2219,
  [2830] = 2702,
  [2831] = 2365,
  [2832] = 2310,
  [2833] = 2714,
  [2834] = 2294,
  [2835] = 2835,
  [2836] = 2148,
  [2837] = 2067,
  [2838] = 2838,
  [2839] = 2671,
  [2840] = 1983,
  [2841] = 2841,
  [2842] = 2095,
  [2843] = 2092,
  [2844] = 2666,
  [2845] = 2707,
  [2846] = 2092,
  [2847] = 2251,
  [2848] = 2714,
  [2849] = 2849,
  [2850] = 2850,
  [2851] = 2777,
  [2852] = 2852,
  [2853] = 2853,
  [2854] = 2854,
  [2855] = 2855,
  [2856] = 2095,
  [2857] = 2708,
  [2858] = 1115,
  [2859] = 2859,
  [2860] = 2860,
  [2861] = 2666,
  [2862] = 2862,
  [2863] = 2671,
  [2864] = 1116,
  [2865] = 2865,
  [2866] = 2866,
  [2867] = 2063,
  [2868] = 2106,
  [2869] = 2781,
  [2870] = 2707,
  [2871] = 2702,
  [2872] = 2571,
  [2873] = 2677,
  [2874] = 2094,
  [2875] = 2092,
  [2876] = 2876,
  [2877] = 2106,
  [2878] = 2092,
  [2879] = 2094,
  [2880] = 2095,
  [2881] = 2400,
  [2882] = 2092,
  [2883] = 2883,
  [2884] = 2884,
  [2885] = 2885,
  [2886] = 2886,
  [2887] = 2095,
  [2888] = 2888,
  [2889] = 2781,
  [2890] = 2890,
  [2891] = 2891,
  [2892] = 2892,
  [2893] = 2893,
  [2894] = 2894,
  [2895] = 2557,
  [2896] = 2145,
  [2897] = 2355,
  [2898] = 2121,
  [2899] = 2145,
  [2900] = 2251,
  [2901] = 2604,
  [2902] = 2106,
  [2903] = 2094,
  [2904] = 2777,
  [2905] = 2905,
  [2906] = 2906,
  [2907] = 2907,
  [2908] = 2908,
  [2909] = 2909,
  [2910] = 2094,
  [2911] = 2838,
  [2912] = 2036,
  [2913] = 2663,
  [2914] = 2777,
  [2915] = 2039,
  [2916] = 2219,
  [2917] = 2063,
  [2918] = 2235,
  [2919] = 2237,
  [2920] = 2920,
  [2921] = 2106,
  [2922] = 2808,
  [2923] = 2400,
  [2924] = 2924,
  [2925] = 2925,
  [2926] = 2926,
  [2927] = 2703,
  [2928] = 2928,
  [2929] = 2929,
  [2930] = 2930,
  [2931] = 2931,
  [2932] = 2932,
  [2933] = 2781,
  [2934] = 2049,
  [2935] = 2838,
  [2936] = 2936,
  [2937] = 2937,
  [2938] = 2938,
  [2939] = 2939,
  [2940] = 2940,
  [2941] = 2808,
  [2942] = 2700,
  [2943] = 2943,
  [2944] = 2944,
  [2945] = 2945,
  [2946] = 2946,
  [2947] = 2052,
  [2948] = 2040,
  [2949] = 2949,
  [2950] = 2950,
  [2951] = 2951,
  [2952] = 2952,
  [2953] = 2953,
  [2954] = 2954,
  [2955] = 2051,
  [2956] = 2956,
  [2957] = 2714,
  [2958] = 2708,
  [2959] = 2054,
  [2960] = 2960,
  [2961] = 2961,
  [2962] = 2962,
  [2963] = 2963,
  [2964] = 2964,
  [2965] = 2690,
  [2966] = 2045,
  [2967] = 2967,
  [2968] = 2048,
  [2969] = 2251,
  [2970] = 2709,
  [2971] = 2095,
  [2972] = 2121,
  [2973] = 2973,
  [2974] = 2679,
  [2975] = 153,
  [2976] = 1974,
  [2977] = 2681,
  [2978] = 2092,
  [2979] = 1980,
  [2980] = 2980,
  [2981] = 1975,
  [2982] = 2982,
  [2983] = 2710,
  [2984] = 1977,
  [2985] = 1976,
  [2986] = 2047,
  [2987] = 1973,
  [2988] = 155,
  [2989] = 2044,
  [2990] = 2711,
  [2991] = 2682,
  [2992] = 2720,
  [2993] = 2993,
  [2994] = 1979,
  [2995] = 2995,
  [2996] = 2046,
  [2997] = 2997,
  [2998] = 2050,
  [2999] = 2043,
  [3000] = 2121,
  [3001] = 3001,
  [3002] = 3002,
  [3003] = 3003,
  [3004] = 3004,
  [3005] = 2671,
  [3006] = 3006,
  [3007] = 3007,
  [3008] = 2707,
  [3009] = 2702,
  [3010] = 2571,
  [3011] = 2677,
  [3012] = 2355,
  [3013] = 2281,
  [3014] = 3014,
  [3015] = 2148,
  [3016] = 2666,
  [3017] = 3017,
  [3018] = 2669,
  [3019] = 2670,
  [3020] = 2680,
  [3021] = 2683,
  [3022] = 2041,
  [3023] = 2042,
  [3024] = 2310,
  [3025] = 2365,
  [3026] = 3026,
  [3027] = 2281,
  [3028] = 2687,
  [3029] = 3029,
  [3030] = 3030,
  [3031] = 3031,
  [3032] = 3032,
  [3033] = 3033,
  [3034] = 2068,
  [3035] = 2707,
  [3036] = 2687,
  [3037] = 2355,
  [3038] = 2094,
  [3039] = 2142,
  [3040] = 2106,
  [3041] = 2118,
  [3042] = 2121,
  [3043] = 2411,
  [3044] = 2671,
  [3045] = 2345,
  [3046] = 2666,
  [3047] = 2407,
  [3048] = 2708,
  [3049] = 2714,
  [3050] = 2065,
  [3051] = 3051,
  [3052] = 2677,
  [3053] = 3053,
  [3054] = 2157,
  [3055] = 2400,
  [3056] = 2702,
  [3057] = 2067,
  [3058] = 2385,
  [3059] = 2679,
  [3060] = 2251,
  [3061] = 2092,
  [3062] = 2571,
  [3063] = 3063,
  [3064] = 2294,
  [3065] = 2095,
  [3066] = 2094,
  [3067] = 3067,
  [3068] = 2106,
  [3069] = 2671,
  [3070] = 1974,
  [3071] = 2219,
  [3072] = 2284,
  [3073] = 2299,
  [3074] = 2300,
  [3075] = 2268,
  [3076] = 2302,
  [3077] = 2267,
  [3078] = 3078,
  [3079] = 2266,
  [3080] = 2298,
  [3081] = 2235,
  [3082] = 2235,
  [3083] = 2666,
  [3084] = 2708,
  [3085] = 2237,
  [3086] = 2219,
  [3087] = 2258,
  [3088] = 3078,
  [3089] = 322,
  [3090] = 2714,
  [3091] = 2355,
  [3092] = 2296,
  [3093] = 2304,
  [3094] = 2290,
  [3095] = 2287,
  [3096] = 2251,
  [3097] = 2808,
  [3098] = 2277,
  [3099] = 2237,
  [3100] = 2400,
  [3101] = 2707,
  [3102] = 2702,
  [3103] = 1979,
  [3104] = 2276,
  [3105] = 3078,
  [3106] = 2273,
  [3107] = 2571,
  [3108] = 2677,
  [3109] = 3078,
  [3110] = 1973,
  [3111] = 2278,
  [3112] = 3112,
  [3113] = 2259,
  [3114] = 2264,
  [3115] = 2285,
  [3116] = 1976,
  [3117] = 2289,
  [3118] = 2036,
  [3119] = 2244,
  [3120] = 2303,
  [3121] = 2246,
  [3122] = 2247,
  [3123] = 2248,
  [3124] = 2121,
  [3125] = 3125,
  [3126] = 2250,
  [3127] = 2252,
  [3128] = 2254,
  [3129] = 2256,
  [3130] = 1977,
  [3131] = 1975,
  [3132] = 2271,
  [3133] = 3133,
  [3134] = 3134,
  [3135] = 2036,
  [3136] = 2292,
  [3137] = 2148,
  [3138] = 2604,
  [3139] = 2272,
  [3140] = 2253,
  [3141] = 1980,
  [3142] = 2294,
  [3143] = 2092,
  [3144] = 3144,
  [3145] = 2557,
  [3146] = 2245,
  [3147] = 3078,
  [3148] = 2148,
  [3149] = 2269,
  [3150] = 2270,
  [3151] = 2679,
  [3152] = 369,
  [3153] = 2838,
  [3154] = 2095,
  [3155] = 3029,
  [3156] = 2251,
  [3157] = 2385,
  [3158] = 2720,
  [3159] = 2036,
  [3160] = 2666,
  [3161] = 2345,
  [3162] = 2411,
  [3163] = 2148,
  [3164] = 2148,
  [3165] = 2687,
  [3166] = 2063,
  [3167] = 2938,
  [3168] = 2237,
  [3169] = 2681,
  [3170] = 2682,
  [3171] = 3006,
  [3172] = 2669,
  [3173] = 2235,
  [3174] = 2679,
  [3175] = 2707,
  [3176] = 2702,
  [3177] = 2219,
  [3178] = 2294,
  [3179] = 2407,
  [3180] = 2670,
  [3181] = 2710,
  [3182] = 1973,
  [3183] = 2700,
  [3184] = 2671,
  [3185] = 2680,
  [3186] = 1979,
  [3187] = 2709,
  [3188] = 1976,
  [3189] = 2703,
  [3190] = 1977,
  [3191] = 2838,
  [3192] = 2557,
  [3193] = 2683,
  [3194] = 2219,
  [3195] = 2036,
  [3196] = 2711,
  [3197] = 2036,
  [3198] = 1974,
  [3199] = 1980,
  [3200] = 2677,
  [3201] = 2604,
  [3202] = 2962,
  [3203] = 2235,
  [3204] = 1975,
  [3205] = 2708,
  [3206] = 2237,
  [3207] = 2808,
  [3208] = 2714,
  [3209] = 3209,
  [3210] = 2294,
  [3211] = 1979,
  [3212] = 3212,
  [3213] = 3213,
  [3214] = 3214,
  [3215] = 2671,
  [3216] = 2666,
  [3217] = 3217,
  [3218] = 3218,
  [3219] = 3219,
  [3220] = 2708,
  [3221] = 2714,
  [3222] = 3219,
  [3223] = 1975,
  [3224] = 2385,
  [3225] = 2355,
  [3226] = 1980,
  [3227] = 1974,
  [3228] = 2092,
  [3229] = 2142,
  [3230] = 2245,
  [3231] = 3231,
  [3232] = 3232,
  [3233] = 2700,
  [3234] = 2709,
  [3235] = 3235,
  [3236] = 2278,
  [3237] = 2710,
  [3238] = 3238,
  [3239] = 2252,
  [3240] = 2711,
  [3241] = 2407,
  [3242] = 2400,
  [3243] = 3243,
  [3244] = 3244,
  [3245] = 3245,
  [3246] = 2662,
  [3247] = 2557,
  [3248] = 3219,
  [3249] = 2604,
  [3250] = 2682,
  [3251] = 2272,
  [3252] = 2259,
  [3253] = 2691,
  [3254] = 3219,
  [3255] = 1977,
  [3256] = 2716,
  [3257] = 1976,
  [3258] = 2677,
  [3259] = 1973,
  [3260] = 2670,
  [3261] = 2723,
  [3262] = 2094,
  [3263] = 3219,
  [3264] = 2294,
  [3265] = 2287,
  [3266] = 2680,
  [3267] = 2683,
  [3268] = 3268,
  [3269] = 3219,
  [3270] = 2106,
  [3271] = 3219,
  [3272] = 2669,
  [3273] = 3273,
  [3274] = 3274,
  [3275] = 2118,
  [3276] = 3219,
  [3277] = 2681,
  [3278] = 2703,
  [3279] = 2720,
  [3280] = 2291,
  [3281] = 3219,
  [3282] = 2679,
  [3283] = 2345,
  [3284] = 2157,
  [3285] = 3285,
  [3286] = 2411,
  [3287] = 2702,
  [3288] = 2707,
  [3289] = 2095,
  [3290] = 1977,
  [3291] = 2289,
  [3292] = 2838,
  [3293] = 2258,
  [3294] = 2299,
  [3295] = 2808,
  [3296] = 2300,
  [3297] = 2764,
  [3298] = 2302,
  [3299] = 2296,
  [3300] = 2292,
  [3301] = 2287,
  [3302] = 2950,
  [3303] = 2253,
  [3304] = 2219,
  [3305] = 2304,
  [3306] = 2290,
  [3307] = 3307,
  [3308] = 2272,
  [3309] = 2669,
  [3310] = 3310,
  [3311] = 2264,
  [3312] = 3312,
  [3313] = 2235,
  [3314] = 2237,
  [3315] = 2670,
  [3316] = 2744,
  [3317] = 2266,
  [3318] = 2278,
  [3319] = 2269,
  [3320] = 2736,
  [3321] = 2680,
  [3322] = 2267,
  [3323] = 2936,
  [3324] = 2268,
  [3325] = 2949,
  [3326] = 2271,
  [3327] = 2245,
  [3328] = 2036,
  [3329] = 2273,
  [3330] = 2277,
  [3331] = 2145,
  [3332] = 2683,
  [3333] = 2952,
  [3334] = 2748,
  [3335] = 2604,
  [3336] = 2252,
  [3337] = 2284,
  [3338] = 3338,
  [3339] = 2960,
  [3340] = 2298,
  [3341] = 1983,
  [3342] = 2961,
  [3343] = 2259,
  [3344] = 2270,
  [3345] = 2291,
  [3346] = 2303,
  [3347] = 2963,
  [3348] = 2246,
  [3349] = 2557,
  [3350] = 3350,
  [3351] = 3351,
  [3352] = 2247,
  [3353] = 1979,
  [3354] = 2248,
  [3355] = 2724,
  [3356] = 1973,
  [3357] = 2250,
  [3358] = 1976,
  [3359] = 1975,
  [3360] = 1980,
  [3361] = 1974,
  [3362] = 2157,
  [3363] = 2661,
  [3364] = 1978,
  [3365] = 2679,
  [3366] = 2711,
  [3367] = 3367,
  [3368] = 2254,
  [3369] = 2256,
  [3370] = 2710,
  [3371] = 2709,
  [3372] = 2700,
  [3373] = 2118,
  [3374] = 2661,
  [3375] = 2148,
  [3376] = 2720,
  [3377] = 2251,
  [3378] = 2285,
  [3379] = 2703,
  [3380] = 3380,
  [3381] = 2729,
  [3382] = 2682,
  [3383] = 2142,
  [3384] = 2276,
  [3385] = 2681,
  [3386] = 3386,
  [3387] = 2244,
  [3388] = 3268,
  [3389] = 2292,
  [3390] = 3390,
  [3391] = 2276,
  [3392] = 2244,
  [3393] = 2270,
  [3394] = 2269,
  [3395] = 2814,
  [3396] = 2669,
  [3397] = 2258,
  [3398] = 2253,
  [3399] = 3217,
  [3400] = 2670,
  [3401] = 2680,
  [3402] = 2285,
  [3403] = 3403,
  [3404] = 3404,
  [3405] = 2703,
  [3406] = 2720,
  [3407] = 2683,
  [3408] = 2835,
  [3409] = 2691,
  [3410] = 2256,
  [3411] = 3218,
  [3412] = 2254,
  [3413] = 2250,
  [3414] = 2287,
  [3415] = 2248,
  [3416] = 3390,
  [3417] = 2247,
  [3418] = 2246,
  [3419] = 3390,
  [3420] = 3214,
  [3421] = 2303,
  [3422] = 3217,
  [3423] = 3213,
  [3424] = 2891,
  [3425] = 2118,
  [3426] = 3214,
  [3427] = 2723,
  [3428] = 2298,
  [3429] = 2284,
  [3430] = 2277,
  [3431] = 2273,
  [3432] = 2271,
  [3433] = 2411,
  [3434] = 2268,
  [3435] = 2267,
  [3436] = 2266,
  [3437] = 2711,
  [3438] = 3213,
  [3439] = 2264,
  [3440] = 2290,
  [3441] = 2304,
  [3442] = 2296,
  [3443] = 2862,
  [3444] = 2865,
  [3445] = 2302,
  [3446] = 2300,
  [3447] = 2299,
  [3448] = 2710,
  [3449] = 2291,
  [3450] = 1983,
  [3451] = 3274,
  [3452] = 2289,
  [3453] = 3245,
  [3454] = 3285,
  [3455] = 3212,
  [3456] = 3231,
  [3457] = 3218,
  [3458] = 3232,
  [3459] = 2890,
  [3460] = 3235,
  [3461] = 3238,
  [3462] = 2709,
  [3463] = 3403,
  [3464] = 3209,
  [3465] = 3243,
  [3466] = 3273,
  [3467] = 2385,
  [3468] = 2700,
  [3469] = 2272,
  [3470] = 2662,
  [3471] = 3351,
  [3472] = 3403,
  [3473] = 3244,
  [3474] = 2294,
  [3475] = 2604,
  [3476] = 3403,
  [3477] = 1978,
  [3478] = 2281,
  [3479] = 2557,
  [3480] = 3245,
  [3481] = 2278,
  [3482] = 3403,
  [3483] = 2345,
  [3484] = 3484,
  [3485] = 2245,
  [3486] = 2716,
  [3487] = 3403,
  [3488] = 3390,
  [3489] = 1978,
  [3490] = 2682,
  [3491] = 3285,
  [3492] = 2681,
  [3493] = 3403,
  [3494] = 2661,
  [3495] = 3310,
  [3496] = 3268,
  [3497] = 2876,
  [3498] = 3212,
  [3499] = 3231,
  [3500] = 3232,
  [3501] = 3235,
  [3502] = 3238,
  [3503] = 3243,
  [3504] = 3350,
  [3505] = 3273,
  [3506] = 3209,
  [3507] = 2894,
  [3508] = 3312,
  [3509] = 3244,
  [3510] = 2142,
  [3511] = 3403,
  [3512] = 2157,
  [3513] = 3274,
  [3514] = 2407,
  [3515] = 2859,
  [3516] = 3403,
  [3517] = 2252,
  [3518] = 2810,
  [3519] = 2259,
  [3520] = 3520,
  [3521] = 2250,
  [3522] = 1973,
  [3523] = 2254,
  [3524] = 2256,
  [3525] = 1976,
  [3526] = 2731,
  [3527] = 2733,
  [3528] = 2734,
  [3529] = 3307,
  [3530] = 1977,
  [3531] = 2812,
  [3532] = 3532,
  [3533] = 3380,
  [3534] = 3520,
  [3535] = 2285,
  [3536] = 2248,
  [3537] = 2247,
  [3538] = 2246,
  [3539] = 3539,
  [3540] = 1975,
  [3541] = 1980,
  [3542] = 1974,
  [3543] = 2691,
  [3544] = 3310,
  [3545] = 3312,
  [3546] = 2886,
  [3547] = 2883,
  [3548] = 2855,
  [3549] = 2276,
  [3550] = 2244,
  [3551] = 2270,
  [3552] = 3552,
  [3553] = 2269,
  [3554] = 3532,
  [3555] = 2661,
  [3556] = 3520,
  [3557] = 3552,
  [3558] = 2303,
  [3559] = 2118,
  [3560] = 2805,
  [3561] = 2557,
  [3562] = 3520,
  [3563] = 2142,
  [3564] = 2736,
  [3565] = 2258,
  [3566] = 2253,
  [3567] = 2687,
  [3568] = 1983,
  [3569] = 1979,
  [3570] = 2292,
  [3571] = 2289,
  [3572] = 2157,
  [3573] = 2298,
  [3574] = 2284,
  [3575] = 2866,
  [3576] = 2796,
  [3577] = 3520,
  [3578] = 3520,
  [3579] = 2795,
  [3580] = 2794,
  [3581] = 3581,
  [3582] = 2571,
  [3583] = 3520,
  [3584] = 2785,
  [3585] = 1116,
  [3586] = 2764,
  [3587] = 2784,
  [3588] = 3307,
  [3589] = 2291,
  [3590] = 2277,
  [3591] = 2259,
  [3592] = 2273,
  [3593] = 2271,
  [3594] = 2145,
  [3595] = 3552,
  [3596] = 2268,
  [3597] = 2252,
  [3598] = 2662,
  [3599] = 3520,
  [3600] = 3350,
  [3601] = 1115,
  [3602] = 3532,
  [3603] = 2267,
  [3604] = 2604,
  [3605] = 2266,
  [3606] = 2804,
  [3607] = 2264,
  [3608] = 2365,
  [3609] = 2310,
  [3610] = 2726,
  [3611] = 3552,
  [3612] = 3520,
  [3613] = 2716,
  [3614] = 2724,
  [3615] = 3351,
  [3616] = 2290,
  [3617] = 2251,
  [3618] = 3552,
  [3619] = 2860,
  [3620] = 3552,
  [3621] = 3380,
  [3622] = 2245,
  [3623] = 2729,
  [3624] = 3532,
  [3625] = 2299,
  [3626] = 1978,
  [3627] = 2278,
  [3628] = 2744,
  [3629] = 2723,
  [3630] = 2893,
  [3631] = 2300,
  [3632] = 3552,
  [3633] = 3532,
  [3634] = 2287,
  [3635] = 2272,
  [3636] = 2748,
  [3637] = 2302,
  [3638] = 2296,
  [3639] = 2304,
  [3640] = 2926,
  [3641] = 153,
  [3642] = 2264,
  [3643] = 3214,
  [3644] = 2266,
  [3645] = 2937,
  [3646] = 3273,
  [3647] = 2267,
  [3648] = 2932,
  [3649] = 2268,
  [3650] = 2271,
  [3651] = 155,
  [3652] = 3213,
  [3653] = 2290,
  [3654] = 2304,
  [3655] = 2273,
  [3656] = 2277,
  [3657] = 2296,
  [3658] = 2302,
  [3659] = 2284,
  [3660] = 2298,
  [3661] = 2300,
  [3662] = 2852,
  [3663] = 2299,
  [3664] = 2720,
  [3665] = 2894,
  [3666] = 2936,
  [3667] = 2289,
  [3668] = 3217,
  [3669] = 2292,
  [3670] = 2669,
  [3671] = 2670,
  [3672] = 2973,
  [3673] = 1978,
  [3674] = 1983,
  [3675] = 2810,
  [3676] = 3063,
  [3677] = 3007,
  [3678] = 3026,
  [3679] = 2303,
  [3680] = 2680,
  [3681] = 2246,
  [3682] = 2860,
  [3683] = 2683,
  [3684] = 2247,
  [3685] = 2248,
  [3686] = 2250,
  [3687] = 1983,
  [3688] = 2729,
  [3689] = 2254,
  [3690] = 2703,
  [3691] = 2690,
  [3692] = 2256,
  [3693] = 2906,
  [3694] = 2814,
  [3695] = 2720,
  [3696] = 3218,
  [3697] = 2703,
  [3698] = 2920,
  [3699] = 3386,
  [3700] = 2925,
  [3701] = 3285,
  [3702] = 2683,
  [3703] = 2930,
  [3704] = 2963,
  [3705] = 1115,
  [3706] = 1116,
  [3707] = 2961,
  [3708] = 3268,
  [3709] = 2960,
  [3710] = 2952,
  [3711] = 2950,
  [3712] = 3212,
  [3713] = 2949,
  [3714] = 2680,
  [3715] = 3231,
  [3716] = 2884,
  [3717] = 3232,
  [3718] = 2700,
  [3719] = 3235,
  [3720] = 2885,
  [3721] = 2285,
  [3722] = 3238,
  [3723] = 3209,
  [3724] = 3017,
  [3725] = 2709,
  [3726] = 3243,
  [3727] = 2400,
  [3728] = 2876,
  [3729] = 3307,
  [3730] = 2276,
  [3731] = 2995,
  [3732] = 2244,
  [3733] = 2270,
  [3734] = 2669,
  [3735] = 2997,
  [3736] = 2905,
  [3737] = 2993,
  [3738] = 3380,
  [3739] = 2269,
  [3740] = 2938,
  [3741] = 3014,
  [3742] = 2982,
  [3743] = 2681,
  [3744] = 2682,
  [3745] = 3404,
  [3746] = 2258,
  [3747] = 2253,
  [3748] = 2710,
  [3749] = 3033,
  [3750] = 2860,
  [3751] = 3031,
  [3752] = 2711,
  [3753] = 3244,
  [3754] = 2907,
  [3755] = 2291,
  [3756] = 3245,
  [3757] = 2909,
  [3758] = 2355,
  [3759] = 3029,
  [3760] = 2908,
  [3761] = 2943,
  [3762] = 2945,
  [3763] = 2946,
  [3764] = 2044,
  [3765] = 2860,
  [3766] = 2043,
  [3767] = 2050,
  [3768] = 3032,
  [3769] = 3030,
  [3770] = 3006,
  [3771] = 3004,
  [3772] = 3003,
  [3773] = 2724,
  [3774] = 2853,
  [3775] = 2849,
  [3776] = 2850,
  [3777] = 2045,
  [3778] = 2040,
  [3779] = 2670,
  [3780] = 2967,
  [3781] = 2052,
  [3782] = 2067,
  [3783] = 2980,
  [3784] = 2962,
  [3785] = 2956,
  [3786] = 2860,
  [3787] = 2954,
  [3788] = 2748,
  [3789] = 2890,
  [3790] = 3274,
  [3791] = 3274,
  [3792] = 2931,
  [3793] = 3245,
  [3794] = 2854,
  [3795] = 3244,
  [3796] = 2764,
  [3797] = 3273,
  [3798] = 3243,
  [3799] = 3209,
  [3800] = 3238,
  [3801] = 3235,
  [3802] = 3232,
  [3803] = 2862,
  [3804] = 3231,
  [3805] = 3212,
  [3806] = 3268,
  [3807] = 2711,
  [3808] = 3285,
  [3809] = 2710,
  [3810] = 3213,
  [3811] = 3214,
  [3812] = 2865,
  [3813] = 2051,
  [3814] = 2054,
  [3815] = 2041,
  [3816] = 2709,
  [3817] = 2744,
  [3818] = 2042,
  [3819] = 2700,
  [3820] = 2859,
  [3821] = 3217,
  [3822] = 3218,
  [3823] = 2736,
  [3824] = 3367,
  [3825] = 2661,
  [3826] = 2891,
  [3827] = 2046,
  [3828] = 2047,
  [3829] = 2048,
  [3830] = 2281,
  [3831] = 2049,
  [3832] = 2663,
  [3833] = 2039,
  [3834] = 2365,
  [3835] = 2964,
  [3836] = 2294,
  [3837] = 2944,
  [3838] = 2065,
  [3839] = 2866,
  [3840] = 3840,
  [3841] = 2068,
  [3842] = 3002,
  [3843] = 3001,
  [3844] = 2310,
  [3845] = 2953,
  [3846] = 2682,
  [3847] = 2951,
  [3848] = 2681,
  [3849] = 2940,
  [3850] = 2866,
  [3851] = 2835,
  [3852] = 2939,
  [3853] = 2929,
  [3854] = 2928,
  [3855] = 2924,
  [3856] = 3856,
  [3857] = 3244,
  [3858] = 3217,
  [3859] = 2862,
  [3860] = 2865,
  [3861] = 2883,
  [3862] = 2142,
  [3863] = 3863,
  [3864] = 3017,
  [3865] = 3274,
  [3866] = 2890,
  [3867] = 3867,
  [3868] = 3868,
  [3869] = 3863,
  [3870] = 3870,
  [3871] = 3871,
  [3872] = 2365,
  [3873] = 2310,
  [3874] = 2859,
  [3875] = 3867,
  [3876] = 3404,
  [3877] = 3877,
  [3878] = 2157,
  [3879] = 3017,
  [3880] = 3880,
  [3881] = 3350,
  [3882] = 3868,
  [3883] = 3856,
  [3884] = 3338,
  [3885] = 2920,
  [3886] = 3310,
  [3887] = 3312,
  [3888] = 3868,
  [3889] = 3889,
  [3890] = 3877,
  [3891] = 2259,
  [3892] = 3351,
  [3893] = 2661,
  [3894] = 2252,
  [3895] = 3312,
  [3896] = 2920,
  [3897] = 3310,
  [3898] = 3218,
  [3899] = 3245,
  [3900] = 3217,
  [3901] = 3214,
  [3902] = 3867,
  [3903] = 3213,
  [3904] = 2894,
  [3905] = 3905,
  [3906] = 3285,
  [3907] = 3871,
  [3908] = 3868,
  [3909] = 3268,
  [3910] = 3212,
  [3911] = 3007,
  [3912] = 2835,
  [3913] = 2949,
  [3914] = 2950,
  [3915] = 2952,
  [3916] = 2960,
  [3917] = 2893,
  [3918] = 2961,
  [3919] = 2963,
  [3920] = 3231,
  [3921] = 3232,
  [3922] = 3868,
  [3923] = 3235,
  [3924] = 3863,
  [3925] = 3238,
  [3926] = 3209,
  [3927] = 2145,
  [3928] = 3243,
  [3929] = 2065,
  [3930] = 3244,
  [3931] = 2785,
  [3932] = 2876,
  [3933] = 2795,
  [3934] = 2796,
  [3935] = 3273,
  [3936] = 3007,
  [3937] = 2794,
  [3938] = 3938,
  [3939] = 3245,
  [3940] = 2890,
  [3941] = 2571,
  [3942] = 2068,
  [3943] = 3868,
  [3944] = 3274,
  [3945] = 2865,
  [3946] = 2862,
  [3947] = 2860,
  [3948] = 2891,
  [3949] = 3868,
  [3950] = 2838,
  [3951] = 3868,
  [3952] = 2067,
  [3953] = 2121,
  [3954] = 2278,
  [3955] = 2936,
  [3956] = 2860,
  [3957] = 2272,
  [3958] = 3867,
  [3959] = 3868,
  [3960] = 3273,
  [3961] = 2876,
  [3962] = 3243,
  [3963] = 3209,
  [3964] = 3238,
  [3965] = 3235,
  [3966] = 3232,
  [3967] = 3231,
  [3968] = 3212,
  [3969] = 3268,
  [3970] = 2118,
  [3971] = 3285,
  [3972] = 2245,
  [3973] = 1983,
  [3974] = 2784,
  [3975] = 2812,
  [3976] = 3863,
  [3977] = 3905,
  [3978] = 3871,
  [3979] = 3871,
  [3980] = 3980,
  [3981] = 1115,
  [3982] = 3863,
  [3983] = 3125,
  [3984] = 2726,
  [3985] = 2804,
  [3986] = 2814,
  [3987] = 2894,
  [3988] = 3905,
  [3989] = 3871,
  [3990] = 2891,
  [3991] = 3871,
  [3992] = 2287,
  [3993] = 3863,
  [3994] = 1116,
  [3995] = 2734,
  [3996] = 2733,
  [3997] = 2731,
  [3998] = 2855,
  [3999] = 2805,
  [4000] = 2808,
  [4001] = 3938,
  [4002] = 2860,
  [4003] = 2274,
  [4004] = 3350,
  [4005] = 3868,
  [4006] = 3905,
  [4007] = 3867,
  [4008] = 3905,
  [4009] = 3218,
  [4010] = 2886,
  [4011] = 2251,
  [4012] = 2860,
  [4013] = 3889,
  [4014] = 3877,
  [4015] = 2810,
  [4016] = 3213,
  [4017] = 3905,
  [4018] = 3351,
  [4019] = 3868,
  [4020] = 2866,
  [4021] = 3214,
  [4022] = 2687,
  [4023] = 3867,
  [4024] = 2859,
  [4025] = 2068,
  [4026] = 2248,
  [4027] = 3938,
  [4028] = 2092,
  [4029] = 3006,
  [4030] = 2253,
  [4031] = 2251,
  [4032] = 2661,
  [4033] = 155,
  [4034] = 2258,
  [4035] = 3404,
  [4036] = 2269,
  [4037] = 2270,
  [4038] = 2244,
  [4039] = 2276,
  [4040] = 2106,
  [4041] = 3007,
  [4042] = 2805,
  [4043] = 2067,
  [4044] = 2041,
  [4045] = 2285,
  [4046] = 2731,
  [4047] = 2949,
  [4048] = 2734,
  [4049] = 2950,
  [4050] = 2952,
  [4051] = 2960,
  [4052] = 2961,
  [4053] = 2963,
  [4054] = 2042,
  [4055] = 2883,
  [4056] = 2687,
  [4057] = 2355,
  [4058] = 2973,
  [4059] = 3026,
  [4060] = 2812,
  [4061] = 153,
  [4062] = 2292,
  [4063] = 2054,
  [4064] = 2289,
  [4065] = 2256,
  [4066] = 2254,
  [4067] = 2250,
  [4068] = 2247,
  [4069] = 2733,
  [4070] = 2303,
  [4071] = 2804,
  [4072] = 2726,
  [4073] = 2039,
  [4074] = 2039,
  [4075] = 2671,
  [4076] = 2094,
  [4077] = 153,
  [4078] = 2663,
  [4079] = 2051,
  [4080] = 2246,
  [4081] = 2982,
  [4082] = 2906,
  [4083] = 2938,
  [4084] = 2925,
  [4085] = 2930,
  [4086] = 2993,
  [4087] = 2905,
  [4088] = 2997,
  [4089] = 2049,
  [4090] = 2094,
  [4091] = 2736,
  [4092] = 2893,
  [4093] = 2920,
  [4094] = 2885,
  [4095] = 2048,
  [4096] = 2047,
  [4097] = 2046,
  [4098] = 2884,
  [4099] = 4099,
  [4100] = 1115,
  [4101] = 3014,
  [4102] = 2281,
  [4103] = 3033,
  [4104] = 3031,
  [4105] = 2063,
  [4106] = 2042,
  [4107] = 3029,
  [4108] = 2041,
  [4109] = 3351,
  [4110] = 1116,
  [4111] = 2936,
  [4112] = 2677,
  [4113] = 3017,
  [4114] = 2937,
  [4115] = 2744,
  [4116] = 2932,
  [4117] = 2044,
  [4118] = 2784,
  [4119] = 2298,
  [4120] = 2284,
  [4121] = 2106,
  [4122] = 2121,
  [4123] = 2571,
  [4124] = 2054,
  [4125] = 2051,
  [4126] = 2860,
  [4127] = 2277,
  [4128] = 155,
  [4129] = 2273,
  [4130] = 2679,
  [4131] = 2702,
  [4132] = 3938,
  [4133] = 2271,
  [4134] = 2268,
  [4135] = 2687,
  [4136] = 2956,
  [4137] = 2050,
  [4138] = 3350,
  [4139] = 2267,
  [4140] = 2095,
  [4141] = 2266,
  [4142] = 2707,
  [4143] = 2907,
  [4144] = 2909,
  [4145] = 2065,
  [4146] = 2264,
  [4147] = 2046,
  [4148] = 2047,
  [4149] = 2043,
  [4150] = 2908,
  [4151] = 2943,
  [4152] = 2944,
  [4153] = 2048,
  [4154] = 2945,
  [4155] = 2946,
  [4156] = 2052,
  [4157] = 2040,
  [4158] = 2690,
  [4159] = 2866,
  [4160] = 2045,
  [4161] = 2040,
  [4162] = 2052,
  [4163] = 2860,
  [4164] = 2853,
  [4165] = 2748,
  [4166] = 2849,
  [4167] = 2850,
  [4168] = 2855,
  [4169] = 2852,
  [4170] = 2967,
  [4171] = 2854,
  [4172] = 2291,
  [4173] = 2050,
  [4174] = 2400,
  [4175] = 2043,
  [4176] = 2962,
  [4177] = 3404,
  [4178] = 3032,
  [4179] = 2886,
  [4180] = 4180,
  [4181] = 3004,
  [4182] = 3003,
  [4183] = 3002,
  [4184] = 3001,
  [4185] = 2995,
  [4186] = 3539,
  [4187] = 2724,
  [4188] = 2290,
  [4189] = 2964,
  [4190] = 2304,
  [4191] = 2296,
  [4192] = 2302,
  [4193] = 2300,
  [4194] = 2299,
  [4195] = 3030,
  [4196] = 2924,
  [4197] = 2926,
  [4198] = 2049,
  [4199] = 2044,
  [4200] = 2928,
  [4201] = 2860,
  [4202] = 2929,
  [4203] = 2931,
  [4204] = 3312,
  [4205] = 3310,
  [4206] = 2939,
  [4207] = 2940,
  [4208] = 2980,
  [4209] = 2796,
  [4210] = 2795,
  [4211] = 2666,
  [4212] = 2794,
  [4213] = 2785,
  [4214] = 2954,
  [4215] = 2953,
  [4216] = 2714,
  [4217] = 2951,
  [4218] = 2045,
  [4219] = 2708,
  [4220] = 1983,
  [4221] = 2039,
  [4222] = 2906,
  [4223] = 2891,
  [4224] = 2925,
  [4225] = 2908,
  [4226] = 2943,
  [4227] = 2993,
  [4228] = 2930,
  [4229] = 2862,
  [4230] = 2865,
  [4231] = 3938,
  [4232] = 2355,
  [4233] = 2049,
  [4234] = 2949,
  [4235] = 2063,
  [4236] = 3274,
  [4237] = 2890,
  [4238] = 3938,
  [4239] = 2690,
  [4240] = 2945,
  [4241] = 2946,
  [4242] = 2962,
  [4243] = 3404,
  [4244] = 2040,
  [4245] = 2952,
  [4246] = 2920,
  [4247] = 3026,
  [4248] = 3404,
  [4249] = 2960,
  [4250] = 2671,
  [4251] = 2961,
  [4252] = 2666,
  [4253] = 2938,
  [4254] = 2963,
  [4255] = 4255,
  [4256] = 2708,
  [4257] = 2714,
  [4258] = 3245,
  [4259] = 2854,
  [4260] = 2967,
  [4261] = 2850,
  [4262] = 3006,
  [4263] = 2849,
  [4264] = 2048,
  [4265] = 2365,
  [4266] = 2050,
  [4267] = 2121,
  [4268] = 2047,
  [4269] = 2937,
  [4270] = 2043,
  [4271] = 2046,
  [4272] = 2707,
  [4273] = 2310,
  [4274] = 2853,
  [4275] = 2950,
  [4276] = 3007,
  [4277] = 2702,
  [4278] = 2677,
  [4279] = 3032,
  [4280] = 3030,
  [4281] = 2355,
  [4282] = 2852,
  [4283] = 3938,
  [4284] = 3014,
  [4285] = 2964,
  [4286] = 2045,
  [4287] = 2052,
  [4288] = 3217,
  [4289] = 3938,
  [4290] = 2884,
  [4291] = 3033,
  [4292] = 2885,
  [4293] = 3244,
  [4294] = 4294,
  [4295] = 2876,
  [4296] = 2400,
  [4297] = 3243,
  [4298] = 3209,
  [4299] = 3238,
  [4300] = 3235,
  [4301] = 3232,
  [4302] = 3231,
  [4303] = 3212,
  [4304] = 3268,
  [4305] = 3285,
  [4306] = 2997,
  [4307] = 2909,
  [4308] = 2905,
  [4309] = 3031,
  [4310] = 2982,
  [4311] = 2042,
  [4312] = 2041,
  [4313] = 155,
  [4314] = 3938,
  [4315] = 153,
  [4316] = 3218,
  [4317] = 2926,
  [4318] = 3029,
  [4319] = 2894,
  [4320] = 2571,
  [4321] = 3938,
  [4322] = 2663,
  [4323] = 3273,
  [4324] = 3404,
  [4325] = 4325,
  [4326] = 2400,
  [4327] = 2810,
  [4328] = 3004,
  [4329] = 3003,
  [4330] = 2808,
  [4331] = 2924,
  [4332] = 2907,
  [4333] = 2928,
  [4334] = 2929,
  [4335] = 2939,
  [4336] = 2940,
  [4337] = 2951,
  [4338] = 2932,
  [4339] = 2931,
  [4340] = 2953,
  [4341] = 3938,
  [4342] = 3938,
  [4343] = 2995,
  [4344] = 3001,
  [4345] = 2973,
  [4346] = 3002,
  [4347] = 2054,
  [4348] = 2044,
  [4349] = 3017,
  [4350] = 2051,
  [4351] = 2980,
  [4352] = 2095,
  [4353] = 2092,
  [4354] = 2106,
  [4355] = 2936,
  [4356] = 2838,
  [4357] = 3214,
  [4358] = 2954,
  [4359] = 2956,
  [4360] = 2944,
  [4361] = 2094,
  [4362] = 3213,
  [4363] = 2106,
  [4364] = 4364,
  [4365] = 4365,
  [4366] = 4366,
  [4367] = 4367,
  [4368] = 4366,
  [4369] = 4369,
  [4370] = 4365,
  [4371] = 4366,
  [4372] = 4365,
  [4373] = 2148,
  [4374] = 4369,
  [4375] = 4367,
  [4376] = 4367,
  [4377] = 4369,
  [4378] = 3938,
  [4379] = 4365,
  [4380] = 4366,
  [4381] = 4381,
  [4382] = 4382,
  [4383] = 3310,
  [4384] = 4365,
  [4385] = 4367,
  [4386] = 4369,
  [4387] = 4367,
  [4388] = 4366,
  [4389] = 4365,
  [4390] = 4366,
  [4391] = 4391,
  [4392] = 4365,
  [4393] = 4366,
  [4394] = 4365,
  [4395] = 4366,
  [4396] = 4396,
  [4397] = 4364,
  [4398] = 3312,
  [4399] = 4365,
  [4400] = 4381,
  [4401] = 4382,
  [4402] = 4381,
  [4403] = 4382,
  [4404] = 4364,
  [4405] = 4366,
  [4406] = 2855,
  [4407] = 2251,
  [4408] = 4382,
  [4409] = 2679,
  [4410] = 4381,
  [4411] = 4411,
  [4412] = 4396,
  [4413] = 2838,
  [4414] = 4369,
  [4415] = 4365,
  [4416] = 4382,
  [4417] = 4396,
  [4418] = 4364,
  [4419] = 4369,
  [4420] = 2219,
  [4421] = 4369,
  [4422] = 2235,
  [4423] = 2094,
  [4424] = 2237,
  [4425] = 3938,
  [4426] = 4396,
  [4427] = 4367,
  [4428] = 2808,
  [4429] = 4382,
  [4430] = 4396,
  [4431] = 4364,
  [4432] = 4396,
  [4433] = 4367,
  [4434] = 3938,
  [4435] = 2310,
  [4436] = 2365,
  [4437] = 4364,
  [4438] = 4369,
  [4439] = 2687,
  [4440] = 3351,
  [4441] = 4365,
  [4442] = 4367,
  [4443] = 4381,
  [4444] = 4369,
  [4445] = 4381,
  [4446] = 4396,
  [4447] = 2092,
  [4448] = 2095,
  [4449] = 1978,
  [4450] = 4367,
  [4451] = 4382,
  [4452] = 4369,
  [4453] = 1974,
  [4454] = 1980,
  [4455] = 1975,
  [4456] = 1977,
  [4457] = 1976,
  [4458] = 1973,
  [4459] = 2687,
  [4460] = 1979,
  [4461] = 3350,
  [4462] = 4367,
  [4463] = 4367,
  [4464] = 4396,
  [4465] = 4382,
  [4466] = 4369,
  [4467] = 4396,
  [4468] = 3938,
  [4469] = 4366,
  [4470] = 4367,
  [4471] = 1983,
  [4472] = 4364,
  [4473] = 4396,
  [4474] = 4381,
  [4475] = 4364,
  [4476] = 4396,
  [4477] = 4381,
  [4478] = 2810,
  [4479] = 4366,
  [4480] = 2048,
  [4481] = 2945,
  [4482] = 2042,
  [4483] = 2050,
  [4484] = 3031,
  [4485] = 2043,
  [4486] = 3006,
  [4487] = 2041,
  [4488] = 2557,
  [4489] = 2663,
  [4490] = 2944,
  [4491] = 2931,
  [4492] = 4492,
  [4493] = 2943,
  [4494] = 2095,
  [4495] = 4492,
  [4496] = 4492,
  [4497] = 2092,
  [4498] = 3033,
  [4499] = 3030,
  [4500] = 2385,
  [4501] = 2407,
  [4502] = 3032,
  [4503] = 4492,
  [4504] = 2995,
  [4505] = 2908,
  [4506] = 2928,
  [4507] = 2973,
  [4508] = 2939,
  [4509] = 3014,
  [4510] = 4492,
  [4511] = 2891,
  [4512] = 2095,
  [4513] = 2345,
  [4514] = 4492,
  [4515] = 2294,
  [4516] = 2940,
  [4517] = 3014,
  [4518] = 3001,
  [4519] = 2894,
  [4520] = 4492,
  [4521] = 2926,
  [4522] = 2092,
  [4523] = 4523,
  [4524] = 2962,
  [4525] = 2040,
  [4526] = 3026,
  [4527] = 4492,
  [4528] = 155,
  [4529] = 2929,
  [4530] = 2063,
  [4531] = 3029,
  [4532] = 2400,
  [4533] = 2862,
  [4534] = 4492,
  [4535] = 2865,
  [4536] = 2946,
  [4537] = 3938,
  [4538] = 2604,
  [4539] = 2876,
  [4540] = 3938,
  [4541] = 2909,
  [4542] = 2890,
  [4543] = 3004,
  [4544] = 2956,
  [4545] = 2094,
  [4546] = 2907,
  [4547] = 2039,
  [4548] = 3002,
  [4549] = 4492,
  [4550] = 2956,
  [4551] = 4492,
  [4552] = 2908,
  [4553] = 2355,
  [4554] = 2671,
  [4555] = 2938,
  [4556] = 4492,
  [4557] = 2666,
  [4558] = 2106,
  [4559] = 2924,
  [4560] = 2906,
  [4561] = 2980,
  [4562] = 2925,
  [4563] = 2708,
  [4564] = 2044,
  [4565] = 2930,
  [4566] = 3003,
  [4567] = 2049,
  [4568] = 3004,
  [4569] = 2046,
  [4570] = 2714,
  [4571] = 2052,
  [4572] = 2047,
  [4573] = 4492,
  [4574] = 153,
  [4575] = 2855,
  [4576] = 2690,
  [4577] = 2094,
  [4578] = 3539,
  [4579] = 2400,
  [4580] = 2707,
  [4581] = 2045,
  [4582] = 2702,
  [4583] = 2054,
  [4584] = 2951,
  [4585] = 4492,
  [4586] = 2677,
  [4587] = 2953,
  [4588] = 2411,
  [4589] = 2954,
  [4590] = 2051,
  [4591] = 2106,
  [4592] = 2355,
  [4593] = 2148,
  [4594] = 1980,
  [4595] = 4595,
  [4596] = 2930,
  [4597] = 2700,
  [4598] = 3001,
  [4599] = 3002,
  [4600] = 2092,
  [4601] = 2709,
  [4602] = 2946,
  [4603] = 2995,
  [4604] = 2940,
  [4605] = 2924,
  [4606] = 2669,
  [4607] = 2557,
  [4608] = 2710,
  [4609] = 2670,
  [4610] = 2925,
  [4611] = 2680,
  [4612] = 2808,
  [4613] = 2939,
  [4614] = 4614,
  [4615] = 4615,
  [4616] = 2944,
  [4617] = 2094,
  [4618] = 3031,
  [4619] = 2251,
  [4620] = 2943,
  [4621] = 2703,
  [4622] = 2571,
  [4623] = 2036,
  [4624] = 2926,
  [4625] = 2235,
  [4626] = 3033,
  [4627] = 3003,
  [4628] = 2095,
  [4629] = 2683,
  [4630] = 2980,
  [4631] = 2720,
  [4632] = 2681,
  [4633] = 2951,
  [4634] = 1983,
  [4635] = 2219,
  [4636] = 1979,
  [4637] = 4615,
  [4638] = 2953,
  [4639] = 1974,
  [4640] = 2954,
  [4641] = 2928,
  [4642] = 3030,
  [4643] = 2929,
  [4644] = 1977,
  [4645] = 4645,
  [4646] = 4646,
  [4647] = 3880,
  [4648] = 2711,
  [4649] = 2604,
  [4650] = 2237,
  [4651] = 2973,
  [4652] = 2909,
  [4653] = 3032,
  [4654] = 1975,
  [4655] = 1976,
  [4656] = 2106,
  [4657] = 4615,
  [4658] = 2838,
  [4659] = 2931,
  [4660] = 2906,
  [4661] = 4595,
  [4662] = 3026,
  [4663] = 1973,
  [4664] = 3870,
  [4665] = 4595,
  [4666] = 2808,
  [4667] = 2945,
  [4668] = 2679,
  [4669] = 2838,
  [4670] = 2682,
  [4671] = 2907,
  [4672] = 2748,
  [4673] = 2345,
  [4674] = 2411,
  [4675] = 2682,
  [4676] = 2669,
  [4677] = 2670,
  [4678] = 2345,
  [4679] = 2681,
  [4680] = 4615,
  [4681] = 2680,
  [4682] = 3539,
  [4683] = 2687,
  [4684] = 2683,
  [4685] = 1978,
  [4686] = 2736,
  [4687] = 3938,
  [4688] = 2744,
  [4689] = 2385,
  [4690] = 2724,
  [4691] = 2294,
  [4692] = 4595,
  [4693] = 2700,
  [4694] = 2407,
  [4695] = 3938,
  [4696] = 3938,
  [4697] = 2709,
  [4698] = 2710,
  [4699] = 2711,
  [4700] = 2411,
  [4701] = 2703,
  [4702] = 2385,
  [4703] = 2720,
  [4704] = 2407,
  [4705] = 3938,
  [4706] = 4595,
  [4707] = 2355,
  [4708] = 2808,
  [4709] = 2157,
  [4710] = 4595,
  [4711] = 1983,
  [4712] = 2118,
  [4713] = 2259,
  [4714] = 2604,
  [4715] = 2252,
  [4716] = 3520,
  [4717] = 4615,
  [4718] = 2121,
  [4719] = 2287,
  [4720] = 2557,
  [4721] = 2245,
  [4722] = 2272,
  [4723] = 2838,
  [4724] = 2142,
  [4725] = 2400,
  [4726] = 4615,
  [4727] = 2278,
  [4728] = 3520,
  [4729] = 356,
  [4730] = 4615,
  [4731] = 2296,
  [4732] = 4732,
  [4733] = 2345,
  [4734] = 2302,
  [4735] = 2300,
  [4736] = 2299,
  [4737] = 366,
  [4738] = 4738,
  [4739] = 2711,
  [4740] = 2710,
  [4741] = 2709,
  [4742] = 4732,
  [4743] = 2700,
  [4744] = 4732,
  [4745] = 4745,
  [4746] = 4738,
  [4747] = 2669,
  [4748] = 4738,
  [4749] = 452,
  [4750] = 4732,
  [4751] = 4745,
  [4752] = 4732,
  [4753] = 4738,
  [4754] = 2253,
  [4755] = 2670,
  [4756] = 2290,
  [4757] = 4732,
  [4758] = 2258,
  [4759] = 1987,
  [4760] = 2276,
  [4761] = 2289,
  [4762] = 2720,
  [4763] = 2292,
  [4764] = 4738,
  [4765] = 2808,
  [4766] = 2838,
  [4767] = 2680,
  [4768] = 2273,
  [4769] = 2407,
  [4770] = 4294,
  [4771] = 2264,
  [4772] = 4738,
  [4773] = 2703,
  [4774] = 2285,
  [4775] = 354,
  [4776] = 2683,
  [4777] = 2892,
  [4778] = 360,
  [4779] = 2244,
  [4780] = 2888,
  [4781] = 2270,
  [4782] = 4745,
  [4783] = 2298,
  [4784] = 2284,
  [4785] = 2256,
  [4786] = 2277,
  [4787] = 2411,
  [4788] = 4745,
  [4789] = 459,
  [4790] = 2303,
  [4791] = 4745,
  [4792] = 2266,
  [4793] = 2254,
  [4794] = 2304,
  [4795] = 2267,
  [4796] = 2268,
  [4797] = 4745,
  [4798] = 2681,
  [4799] = 2271,
  [4800] = 2682,
  [4801] = 2250,
  [4802] = 2248,
  [4803] = 2247,
  [4804] = 2385,
  [4805] = 2246,
  [4806] = 4595,
  [4807] = 2269,
  [4808] = 4808,
  [4809] = 2157,
  [4810] = 2385,
  [4811] = 2145,
  [4812] = 1978,
  [4813] = 3243,
  [4814] = 2962,
  [4815] = 4808,
  [4816] = 2245,
  [4817] = 2938,
  [4818] = 3235,
  [4819] = 2287,
  [4820] = 2407,
  [4821] = 2411,
  [4822] = 3268,
  [4823] = 2118,
  [4824] = 2278,
  [4825] = 3212,
  [4826] = 2142,
  [4827] = 3274,
  [4828] = 3006,
  [4829] = 4595,
  [4830] = 3238,
  [4831] = 3232,
  [4832] = 4832,
  [4833] = 2345,
  [4834] = 2272,
  [4835] = 3231,
  [4836] = 4615,
  [4837] = 3029,
  [4838] = 2259,
  [4839] = 3273,
  [4840] = 3218,
  [4841] = 4841,
  [4842] = 3217,
  [4843] = 3285,
  [4844] = 2252,
  [4845] = 3209,
  [4846] = 3244,
  [4847] = 3245,
  [4848] = 3214,
  [4849] = 3213,
  [4850] = 2253,
  [4851] = 2250,
  [4852] = 2246,
  [4853] = 2303,
  [4854] = 2248,
  [4855] = 4855,
  [4856] = 2254,
  [4857] = 4595,
  [4858] = 4858,
  [4859] = 2736,
  [4860] = 4615,
  [4861] = 2748,
  [4862] = 4862,
  [4863] = 2299,
  [4864] = 2300,
  [4865] = 4855,
  [4866] = 2808,
  [4867] = 2302,
  [4868] = 2289,
  [4869] = 4855,
  [4870] = 4870,
  [4871] = 3351,
  [4872] = 4872,
  [4873] = 4870,
  [4874] = 2281,
  [4875] = 2736,
  [4876] = 4872,
  [4877] = 2744,
  [4878] = 2063,
  [4879] = 2296,
  [4880] = 4870,
  [4881] = 2304,
  [4882] = 2290,
  [4883] = 2247,
  [4884] = 2256,
  [4885] = 2298,
  [4886] = 4858,
  [4887] = 4887,
  [4888] = 2292,
  [4889] = 4872,
  [4890] = 2285,
  [4891] = 2724,
  [4892] = 4870,
  [4893] = 4870,
  [4894] = 2276,
  [4895] = 2244,
  [4896] = 2270,
  [4897] = 2269,
  [4898] = 4855,
  [4899] = 4870,
  [4900] = 4858,
  [4901] = 4855,
  [4902] = 4862,
  [4903] = 2258,
  [4904] = 3350,
  [4905] = 2661,
  [4906] = 2284,
  [4907] = 4872,
  [4908] = 2838,
  [4909] = 4855,
  [4910] = 2744,
  [4911] = 4872,
  [4912] = 2277,
  [4913] = 2273,
  [4914] = 4887,
  [4915] = 3312,
  [4916] = 4887,
  [4917] = 3310,
  [4918] = 2271,
  [4919] = 2268,
  [4920] = 4870,
  [4921] = 2267,
  [4922] = 4855,
  [4923] = 2266,
  [4924] = 4872,
  [4925] = 4855,
  [4926] = 4862,
  [4927] = 2264,
  [4928] = 4887,
  [4929] = 4872,
  [4930] = 2724,
  [4931] = 4887,
  [4932] = 4887,
  [4933] = 4870,
  [4934] = 4872,
  [4935] = 4887,
  [4936] = 2748,
  [4937] = 2291,
  [4938] = 4887,
  [4939] = 2862,
  [4940] = 4595,
  [4941] = 3350,
  [4942] = 3063,
  [4943] = 4943,
  [4944] = 3245,
  [4945] = 2876,
  [4946] = 3218,
  [4947] = 3051,
  [4948] = 4948,
  [4949] = 2355,
  [4950] = 2145,
  [4951] = 4951,
  [4952] = 3213,
  [4953] = 4943,
  [4954] = 4943,
  [4955] = 2690,
  [4956] = 3053,
  [4957] = 3217,
  [4958] = 2687,
  [4959] = 4841,
  [4960] = 2687,
  [4961] = 2663,
  [4962] = 4858,
  [4963] = 2810,
  [4964] = 2865,
  [4965] = 3274,
  [4966] = 3214,
  [4967] = 4862,
  [4968] = 2890,
  [4969] = 3244,
  [4970] = 4615,
  [4971] = 2663,
  [4972] = 2690,
  [4973] = 1978,
  [4974] = 3351,
  [4975] = 3273,
  [4976] = 3243,
  [4977] = 3209,
  [4978] = 3238,
  [4979] = 3235,
  [4980] = 3232,
  [4981] = 2571,
  [4982] = 2894,
  [4983] = 3310,
  [4984] = 1983,
  [4985] = 2891,
  [4986] = 3312,
  [4987] = 3231,
  [4988] = 3212,
  [4989] = 2400,
  [4990] = 3268,
  [4991] = 3285,
  [4992] = 4943,
  [4993] = 4645,
  [4994] = 4646,
  [4995] = 3218,
  [4996] = 4996,
  [4997] = 3273,
  [4998] = 3213,
  [4999] = 4999,
  [5000] = 4862,
  [5001] = 2855,
  [5002] = 4858,
  [5003] = 3351,
  [5004] = 3285,
  [5005] = 4615,
  [5006] = 5006,
  [5007] = 3268,
  [5008] = 3212,
  [5009] = 5009,
  [5010] = 5010,
  [5011] = 5011,
  [5012] = 3231,
  [5013] = 4862,
  [5014] = 3310,
  [5015] = 3312,
  [5016] = 4595,
  [5017] = 3214,
  [5018] = 5010,
  [5019] = 3245,
  [5020] = 3217,
  [5021] = 2281,
  [5022] = 5011,
  [5023] = 5023,
  [5024] = 2063,
  [5025] = 3235,
  [5026] = 5023,
  [5027] = 4615,
  [5028] = 3232,
  [5029] = 3243,
  [5030] = 4595,
  [5031] = 3209,
  [5032] = 3350,
  [5033] = 5033,
  [5034] = 3238,
  [5035] = 5009,
  [5036] = 3244,
  [5037] = 3274,
  [5038] = 4858,
  [5039] = 5039,
  [5040] = 5040,
  [5041] = 5041,
  [5042] = 5042,
  [5043] = 5043,
  [5044] = 2042,
  [5045] = 5041,
  [5046] = 4595,
  [5047] = 2039,
  [5048] = 2663,
  [5049] = 2049,
  [5050] = 2571,
  [5051] = 5051,
  [5052] = 5052,
  [5053] = 2048,
  [5054] = 2047,
  [5055] = 2046,
  [5056] = 2690,
  [5057] = 5039,
  [5058] = 2962,
  [5059] = 2973,
  [5060] = 3026,
  [5061] = 2724,
  [5062] = 5062,
  [5063] = 5042,
  [5064] = 2736,
  [5065] = 5065,
  [5066] = 5052,
  [5067] = 5039,
  [5068] = 5051,
  [5069] = 5062,
  [5070] = 5042,
  [5071] = 2041,
  [5072] = 5042,
  [5073] = 5073,
  [5074] = 5041,
  [5075] = 5040,
  [5076] = 5062,
  [5077] = 3006,
  [5078] = 5041,
  [5079] = 5039,
  [5080] = 2042,
  [5081] = 5042,
  [5082] = 5041,
  [5083] = 2041,
  [5084] = 5084,
  [5085] = 5085,
  [5086] = 5041,
  [5087] = 5042,
  [5088] = 5088,
  [5089] = 2054,
  [5090] = 2051,
  [5091] = 4858,
  [5092] = 2744,
  [5093] = 2926,
  [5094] = 4948,
  [5095] = 2931,
  [5096] = 5051,
  [5097] = 5042,
  [5098] = 2043,
  [5099] = 5039,
  [5100] = 2954,
  [5101] = 2050,
  [5102] = 2956,
  [5103] = 5103,
  [5104] = 2980,
  [5105] = 5042,
  [5106] = 2906,
  [5107] = 5062,
  [5108] = 5042,
  [5109] = 2925,
  [5110] = 5042,
  [5111] = 2930,
  [5112] = 3218,
  [5113] = 2051,
  [5114] = 2047,
  [5115] = 5042,
  [5116] = 2046,
  [5117] = 5062,
  [5118] = 2995,
  [5119] = 5041,
  [5120] = 5040,
  [5121] = 2054,
  [5122] = 2052,
  [5123] = 2040,
  [5124] = 5062,
  [5125] = 2045,
  [5126] = 5042,
  [5127] = 5052,
  [5128] = 5052,
  [5129] = 5039,
  [5130] = 5039,
  [5131] = 2050,
  [5132] = 2043,
  [5133] = 3003,
  [5134] = 5084,
  [5135] = 3004,
  [5136] = 2048,
  [5137] = 5042,
  [5138] = 3030,
  [5139] = 5062,
  [5140] = 5042,
  [5141] = 3245,
  [5142] = 4862,
  [5143] = 5085,
  [5144] = 5062,
  [5145] = 5042,
  [5146] = 4951,
  [5147] = 1983,
  [5148] = 3032,
  [5149] = 3029,
  [5150] = 5150,
  [5151] = 5042,
  [5152] = 2044,
  [5153] = 3217,
  [5154] = 5154,
  [5155] = 2045,
  [5156] = 5039,
  [5157] = 3214,
  [5158] = 5042,
  [5159] = 3274,
  [5160] = 2944,
  [5161] = 5154,
  [5162] = 5041,
  [5163] = 5041,
  [5164] = 155,
  [5165] = 3014,
  [5166] = 5052,
  [5167] = 153,
  [5168] = 2946,
  [5169] = 5169,
  [5170] = 5052,
  [5171] = 3244,
  [5172] = 155,
  [5173] = 2945,
  [5174] = 4615,
  [5175] = 3213,
  [5176] = 2943,
  [5177] = 5177,
  [5178] = 2039,
  [5179] = 3002,
  [5180] = 2908,
  [5181] = 3033,
  [5182] = 3001,
  [5183] = 5051,
  [5184] = 5052,
  [5185] = 4595,
  [5186] = 2044,
  [5187] = 5042,
  [5188] = 4951,
  [5189] = 2953,
  [5190] = 2951,
  [5191] = 5042,
  [5192] = 5084,
  [5193] = 2940,
  [5194] = 5085,
  [5195] = 5154,
  [5196] = 2939,
  [5197] = 5197,
  [5198] = 2938,
  [5199] = 2929,
  [5200] = 2928,
  [5201] = 5039,
  [5202] = 2748,
  [5203] = 3031,
  [5204] = 2909,
  [5205] = 2924,
  [5206] = 153,
  [5207] = 5207,
  [5208] = 2907,
  [5209] = 2052,
  [5210] = 2049,
  [5211] = 4615,
  [5212] = 3285,
  [5213] = 3268,
  [5214] = 3212,
  [5215] = 3231,
  [5216] = 2040,
  [5217] = 3232,
  [5218] = 5218,
  [5219] = 5052,
  [5220] = 3235,
  [5221] = 3238,
  [5222] = 3209,
  [5223] = 3273,
  [5224] = 3243,
  [5225] = 3212,
  [5226] = 3217,
  [5227] = 5227,
  [5228] = 2666,
  [5229] = 3209,
  [5230] = 2679,
  [5231] = 3245,
  [5232] = 3244,
  [5233] = 3273,
  [5234] = 2400,
  [5235] = 5235,
  [5236] = 3243,
  [5237] = 3209,
  [5238] = 5238,
  [5239] = 5197,
  [5240] = 5240,
  [5241] = 3274,
  [5242] = 5242,
  [5243] = 2708,
  [5244] = 5244,
  [5245] = 3274,
  [5246] = 3238,
  [5247] = 3350,
  [5248] = 2714,
  [5249] = 5227,
  [5250] = 3235,
  [5251] = 5235,
  [5252] = 5252,
  [5253] = 3351,
  [5254] = 3232,
  [5255] = 3231,
  [5256] = 3238,
  [5257] = 5257,
  [5258] = 2671,
  [5259] = 5259,
  [5260] = 3235,
  [5261] = 5261,
  [5262] = 3232,
  [5263] = 3218,
  [5264] = 5264,
  [5265] = 3212,
  [5266] = 3268,
  [5267] = 5267,
  [5268] = 5235,
  [5269] = 3231,
  [5270] = 2876,
  [5271] = 3285,
  [5272] = 5235,
  [5273] = 3285,
  [5274] = 3213,
  [5275] = 2890,
  [5276] = 5154,
  [5277] = 2876,
  [5278] = 3213,
  [5279] = 3268,
  [5280] = 5280,
  [5281] = 2894,
  [5282] = 5267,
  [5283] = 3212,
  [5284] = 4862,
  [5285] = 3231,
  [5286] = 3232,
  [5287] = 3235,
  [5288] = 5267,
  [5289] = 3238,
  [5290] = 3209,
  [5291] = 3243,
  [5292] = 5292,
  [5293] = 5227,
  [5294] = 5294,
  [5295] = 3245,
  [5296] = 3273,
  [5297] = 5297,
  [5298] = 5227,
  [5299] = 3214,
  [5300] = 5300,
  [5301] = 2894,
  [5302] = 3268,
  [5303] = 5297,
  [5304] = 3244,
  [5305] = 2810,
  [5306] = 3214,
  [5307] = 5307,
  [5308] = 5267,
  [5309] = 3217,
  [5310] = 5227,
  [5311] = 5297,
  [5312] = 3218,
  [5313] = 2707,
  [5314] = 5314,
  [5315] = 2702,
  [5316] = 5267,
  [5317] = 2865,
  [5318] = 1983,
  [5319] = 2355,
  [5320] = 3274,
  [5321] = 3285,
  [5322] = 2677,
  [5323] = 3217,
  [5324] = 3218,
  [5325] = 4858,
  [5326] = 5227,
  [5327] = 2862,
  [5328] = 2838,
  [5329] = 5297,
  [5330] = 5297,
  [5331] = 4841,
  [5332] = 5297,
  [5333] = 2891,
  [5334] = 5334,
  [5335] = 3213,
  [5336] = 5336,
  [5337] = 3243,
  [5338] = 5227,
  [5339] = 5339,
  [5340] = 5340,
  [5341] = 5235,
  [5342] = 4951,
  [5343] = 5267,
  [5344] = 2101,
  [5345] = 5345,
  [5346] = 5252,
  [5347] = 5259,
  [5348] = 3214,
  [5349] = 5297,
  [5350] = 5261,
  [5351] = 3245,
  [5352] = 5267,
  [5353] = 3273,
  [5354] = 5267,
  [5355] = 5085,
  [5356] = 3244,
  [5357] = 5084,
  [5358] = 5040,
  [5359] = 5267,
  [5360] = 5267,
  [5361] = 5361,
  [5362] = 5297,
  [5363] = 5267,
  [5364] = 5267,
  [5365] = 3312,
  [5366] = 3310,
  [5367] = 5367,
  [5368] = 2865,
  [5369] = 2862,
  [5370] = 2890,
  [5371] = 5267,
  [5372] = 3889,
  [5373] = 5235,
  [5374] = 2808,
  [5375] = 5267,
  [5376] = 5376,
  [5377] = 2891,
  [5378] = 5297,
  [5379] = 2687,
  [5380] = 5267,
  [5381] = 5381,
  [5382] = 5382,
  [5383] = 5154,
  [5384] = 5384,
  [5385] = 5385,
  [5386] = 5386,
  [5387] = 5384,
  [5388] = 5388,
  [5389] = 5389,
  [5390] = 5390,
  [5391] = 5384,
  [5392] = 5392,
  [5393] = 5384,
  [5394] = 5384,
  [5395] = 5395,
  [5396] = 5396,
  [5397] = 5397,
  [5398] = 5398,
  [5399] = 3351,
  [5400] = 5400,
  [5401] = 5398,
  [5402] = 5395,
  [5403] = 5389,
  [5404] = 5395,
  [5405] = 5384,
  [5406] = 5384,
  [5407] = 3312,
  [5408] = 5392,
  [5409] = 5397,
  [5410] = 5410,
  [5411] = 3350,
  [5412] = 5412,
  [5413] = 5395,
  [5414] = 5392,
  [5415] = 5392,
  [5416] = 5416,
  [5417] = 5389,
  [5418] = 5389,
  [5419] = 5397,
  [5420] = 5420,
  [5421] = 5398,
  [5422] = 5422,
  [5423] = 5423,
  [5424] = 5424,
  [5425] = 5425,
  [5426] = 5426,
  [5427] = 5420,
  [5428] = 5428,
  [5429] = 5395,
  [5430] = 5397,
  [5431] = 5410,
  [5432] = 5432,
  [5433] = 5386,
  [5434] = 5412,
  [5435] = 5398,
  [5436] = 5397,
  [5437] = 5398,
  [5438] = 5423,
  [5439] = 5395,
  [5440] = 5388,
  [5441] = 5441,
  [5442] = 5410,
  [5443] = 5392,
  [5444] = 5397,
  [5445] = 5424,
  [5446] = 5446,
  [5447] = 5085,
  [5448] = 5398,
  [5449] = 5395,
  [5450] = 5385,
  [5451] = 5416,
  [5452] = 5410,
  [5453] = 4595,
  [5454] = 5412,
  [5455] = 5398,
  [5456] = 5389,
  [5457] = 5392,
  [5458] = 5410,
  [5459] = 5410,
  [5460] = 5392,
  [5461] = 5425,
  [5462] = 5397,
  [5463] = 5423,
  [5464] = 5464,
  [5465] = 5424,
  [5466] = 5389,
  [5467] = 5441,
  [5468] = 5425,
  [5469] = 4858,
  [5470] = 5420,
  [5471] = 5412,
  [5472] = 5472,
  [5473] = 5473,
  [5474] = 5474,
  [5475] = 5400,
  [5476] = 5389,
  [5477] = 5477,
  [5478] = 5395,
  [5479] = 5388,
  [5480] = 5480,
  [5481] = 2855,
  [5482] = 3310,
  [5483] = 5420,
  [5484] = 5423,
  [5485] = 5424,
  [5486] = 5486,
  [5487] = 5423,
  [5488] = 5424,
  [5489] = 5489,
  [5490] = 2251,
  [5491] = 5410,
  [5492] = 5154,
  [5493] = 5425,
  [5494] = 4615,
  [5495] = 5388,
  [5496] = 5425,
  [5497] = 5392,
  [5498] = 5498,
  [5499] = 5395,
  [5500] = 5040,
  [5501] = 5397,
  [5502] = 5425,
  [5503] = 5392,
  [5504] = 5084,
  [5505] = 5424,
  [5506] = 5423,
  [5507] = 5040,
  [5508] = 5388,
  [5509] = 5395,
  [5510] = 5510,
  [5511] = 5085,
  [5512] = 5389,
  [5513] = 5388,
  [5514] = 5514,
  [5515] = 5410,
  [5516] = 5398,
  [5517] = 5420,
  [5518] = 5397,
  [5519] = 5384,
  [5520] = 5520,
  [5521] = 5389,
  [5522] = 2121,
  [5523] = 4862,
  [5524] = 5395,
  [5525] = 5525,
  [5526] = 5410,
  [5527] = 5412,
  [5528] = 5084,
  [5529] = 2571,
  [5530] = 5530,
  [5531] = 5531,
  [5532] = 2702,
  [5533] = 2924,
  [5534] = 2946,
  [5535] = 4862,
  [5536] = 2907,
  [5537] = 2928,
  [5538] = 2954,
  [5539] = 2953,
  [5540] = 2925,
  [5541] = 2951,
  [5542] = 5531,
  [5543] = 2291,
  [5544] = 5084,
  [5545] = 2906,
  [5546] = 5546,
  [5547] = 5531,
  [5548] = 3004,
  [5549] = 4858,
  [5550] = 2883,
  [5551] = 2036,
  [5552] = 3026,
  [5553] = 3006,
  [5554] = 2909,
  [5555] = 2980,
  [5556] = 3003,
  [5557] = 3031,
  [5558] = 3002,
  [5559] = 2571,
  [5560] = 2973,
  [5561] = 2808,
  [5562] = 2121,
  [5563] = 5563,
  [5564] = 5040,
  [5565] = 5531,
  [5566] = 2663,
  [5567] = 2148,
  [5568] = 2690,
  [5569] = 2274,
  [5570] = 2940,
  [5571] = 2101,
  [5572] = 2237,
  [5573] = 2235,
  [5574] = 5531,
  [5575] = 2893,
  [5576] = 2219,
  [5577] = 5577,
  [5578] = 1974,
  [5579] = 2930,
  [5580] = 5577,
  [5581] = 1980,
  [5582] = 3001,
  [5583] = 3033,
  [5584] = 5531,
  [5585] = 2838,
  [5586] = 1975,
  [5587] = 2931,
  [5588] = 2995,
  [5589] = 1977,
  [5590] = 1976,
  [5591] = 2939,
  [5592] = 2926,
  [5593] = 1973,
  [5594] = 2908,
  [5595] = 2677,
  [5596] = 3014,
  [5597] = 2943,
  [5598] = 2945,
  [5599] = 5531,
  [5600] = 2707,
  [5601] = 5531,
  [5602] = 2886,
  [5603] = 2944,
  [5604] = 2929,
  [5605] = 2938,
  [5606] = 3032,
  [5607] = 3030,
  [5608] = 1979,
  [5609] = 2956,
  [5610] = 2687,
  [5611] = 5154,
  [5612] = 2962,
  [5613] = 2714,
  [5614] = 3029,
  [5615] = 2708,
  [5616] = 5085,
  [5617] = 5531,
  [5618] = 2666,
  [5619] = 2671,
  [5620] = 5620,
  [5621] = 5040,
  [5622] = 5620,
  [5623] = 5623,
  [5624] = 2557,
  [5625] = 2101,
  [5626] = 5623,
  [5627] = 5623,
  [5628] = 5620,
  [5629] = 5620,
  [5630] = 5525,
  [5631] = 5382,
  [5632] = 5154,
  [5633] = 5577,
  [5634] = 2121,
  [5635] = 2679,
  [5636] = 4858,
  [5637] = 5620,
  [5638] = 5620,
  [5639] = 4862,
  [5640] = 2294,
  [5641] = 2400,
  [5642] = 5428,
  [5643] = 2838,
  [5644] = 5623,
  [5645] = 5623,
  [5646] = 2604,
  [5647] = 5623,
  [5648] = 2808,
  [5649] = 2251,
  [5650] = 5620,
  [5651] = 5623,
  [5652] = 5084,
  [5653] = 5620,
  [5654] = 5623,
  [5655] = 2400,
  [5656] = 5623,
  [5657] = 5577,
  [5658] = 5658,
  [5659] = 5623,
  [5660] = 5085,
  [5661] = 5620,
  [5662] = 5620,
  [5663] = 2355,
  [5664] = 2355,
  [5665] = 5620,
  [5666] = 5623,
  [5667] = 4862,
  [5668] = 5668,
  [5669] = 2355,
  [5670] = 2274,
  [5671] = 4858,
  [5672] = 2703,
  [5673] = 5673,
  [5674] = 2710,
  [5675] = 2711,
  [5676] = 2669,
  [5677] = 5668,
  [5678] = 2687,
  [5679] = 5577,
  [5680] = 5577,
  [5681] = 5040,
  [5682] = 5682,
  [5683] = 5577,
  [5684] = 5084,
  [5685] = 5577,
  [5686] = 2680,
  [5687] = 5673,
  [5688] = 5673,
  [5689] = 5682,
  [5690] = 5085,
  [5691] = 2400,
  [5692] = 5682,
  [5693] = 5668,
  [5694] = 5668,
  [5695] = 5154,
  [5696] = 2720,
  [5697] = 5577,
  [5698] = 2157,
  [5699] = 5577,
  [5700] = 2670,
  [5701] = 5668,
  [5702] = 5577,
  [5703] = 4858,
  [5704] = 5577,
  [5705] = 5673,
  [5706] = 5673,
  [5707] = 2681,
  [5708] = 5673,
  [5709] = 2683,
  [5710] = 5673,
  [5711] = 5673,
  [5712] = 5682,
  [5713] = 2709,
  [5714] = 5668,
  [5715] = 5682,
  [5716] = 5682,
  [5717] = 5682,
  [5718] = 5668,
  [5719] = 5682,
  [5720] = 2682,
  [5721] = 5668,
  [5722] = 2700,
  [5723] = 4862,
  [5724] = 5724,
  [5725] = 5725,
  [5726] = 2272,
  [5727] = 5727,
  [5728] = 2287,
  [5729] = 2284,
  [5730] = 5730,
  [5731] = 5725,
  [5732] = 5727,
  [5733] = 5733,
  [5734] = 2298,
  [5735] = 2300,
  [5736] = 2299,
  [5737] = 5733,
  [5738] = 2271,
  [5739] = 5085,
  [5740] = 5725,
  [5741] = 2245,
  [5742] = 5733,
  [5743] = 2259,
  [5744] = 5733,
  [5745] = 5733,
  [5746] = 5746,
  [5747] = 5733,
  [5748] = 5748,
  [5749] = 2254,
  [5750] = 5733,
  [5751] = 5733,
  [5752] = 5752,
  [5753] = 2253,
  [5754] = 2687,
  [5755] = 5084,
  [5756] = 2604,
  [5757] = 5733,
  [5758] = 2269,
  [5759] = 2270,
  [5760] = 2557,
  [5761] = 2250,
  [5762] = 5725,
  [5763] = 5725,
  [5764] = 5725,
  [5765] = 5727,
  [5766] = 5727,
  [5767] = 2304,
  [5768] = 2248,
  [5769] = 5733,
  [5770] = 5748,
  [5771] = 2247,
  [5772] = 2264,
  [5773] = 5733,
  [5774] = 2276,
  [5775] = 5727,
  [5776] = 5733,
  [5777] = 5724,
  [5778] = 5725,
  [5779] = 5733,
  [5780] = 5577,
  [5781] = 5725,
  [5782] = 2244,
  [5783] = 2296,
  [5784] = 2285,
  [5785] = 5733,
  [5786] = 2246,
  [5787] = 5733,
  [5788] = 5727,
  [5789] = 2303,
  [5790] = 5733,
  [5791] = 2267,
  [5792] = 2302,
  [5793] = 2258,
  [5794] = 5727,
  [5795] = 2277,
  [5796] = 5040,
  [5797] = 5725,
  [5798] = 2252,
  [5799] = 2289,
  [5800] = 2266,
  [5801] = 2268,
  [5802] = 5733,
  [5803] = 5733,
  [5804] = 5727,
  [5805] = 5727,
  [5806] = 2290,
  [5807] = 5733,
  [5808] = 5577,
  [5809] = 2278,
  [5810] = 5727,
  [5811] = 5733,
  [5812] = 5727,
  [5813] = 5577,
  [5814] = 2292,
  [5815] = 5725,
  [5816] = 2256,
  [5817] = 2273,
  [5818] = 5725,
  [5819] = 5819,
  [5820] = 5577,
  [5821] = 5154,
  [5822] = 5733,
  [5823] = 2670,
  [5824] = 2838,
  [5825] = 2710,
  [5826] = 5826,
  [5827] = 2700,
  [5828] = 5577,
  [5829] = 5577,
  [5830] = 5748,
  [5831] = 2682,
  [5832] = 5040,
  [5833] = 2808,
  [5834] = 5084,
  [5835] = 2681,
  [5836] = 2571,
  [5837] = 5837,
  [5838] = 2669,
  [5839] = 5826,
  [5840] = 5085,
  [5841] = 2720,
  [5842] = 2703,
  [5843] = 5154,
  [5844] = 5837,
  [5845] = 2680,
  [5846] = 2808,
  [5847] = 2709,
  [5848] = 5848,
  [5849] = 5748,
  [5850] = 4858,
  [5851] = 2838,
  [5852] = 2838,
  [5853] = 5085,
  [5854] = 2711,
  [5855] = 5724,
  [5856] = 5040,
  [5857] = 5724,
  [5858] = 5848,
  [5859] = 2683,
  [5860] = 4862,
  [5861] = 2808,
  [5862] = 5724,
  [5863] = 5724,
  [5864] = 5748,
  [5865] = 5724,
  [5866] = 2157,
  [5867] = 5724,
  [5868] = 5085,
  [5869] = 2287,
  [5870] = 5724,
  [5871] = 5748,
  [5872] = 5748,
  [5873] = 2272,
  [5874] = 2278,
  [5875] = 2245,
  [5876] = 2101,
  [5877] = 5724,
  [5878] = 5748,
  [5879] = 5748,
  [5880] = 2252,
  [5881] = 5724,
  [5882] = 2259,
  [5883] = 5748,
  [5884] = 5748,
  [5885] = 5084,
  [5886] = 2101,
  [5887] = 5724,
  [5888] = 5154,
  [5889] = 5040,
  [5890] = 2142,
  [5891] = 5084,
  [5892] = 5085,
  [5893] = 3125,
  [5894] = 5040,
  [5895] = 2118,
  [5896] = 5748,
  [5897] = 5154,
  [5898] = 5577,
  [5899] = 4294,
  [5900] = 2604,
  [5901] = 2557,
  [5902] = 5902,
  [5903] = 2289,
  [5904] = 2299,
  [5905] = 5902,
  [5906] = 2300,
  [5907] = 5902,
  [5908] = 5748,
  [5909] = 2302,
  [5910] = 2296,
  [5911] = 2304,
  [5912] = 2290,
  [5913] = 2264,
  [5914] = 5748,
  [5915] = 2266,
  [5916] = 5577,
  [5917] = 2267,
  [5918] = 2268,
  [5919] = 2271,
  [5920] = 2145,
  [5921] = 2661,
  [5922] = 2273,
  [5923] = 2277,
  [5924] = 5577,
  [5925] = 5748,
  [5926] = 2284,
  [5927] = 2292,
  [5928] = 2298,
  [5929] = 2291,
  [5930] = 5724,
  [5931] = 2303,
  [5932] = 5748,
  [5933] = 2246,
  [5934] = 2247,
  [5935] = 2248,
  [5936] = 2250,
  [5937] = 5724,
  [5938] = 5938,
  [5939] = 2254,
  [5940] = 2256,
  [5941] = 5941,
  [5942] = 5724,
  [5943] = 2285,
  [5944] = 2276,
  [5945] = 2244,
  [5946] = 5902,
  [5947] = 5947,
  [5948] = 2270,
  [5949] = 2269,
  [5950] = 5902,
  [5951] = 2808,
  [5952] = 5724,
  [5953] = 5577,
  [5954] = 5902,
  [5955] = 2687,
  [5956] = 2258,
  [5957] = 2253,
  [5958] = 2838,
  [5959] = 5959,
  [5960] = 5960,
  [5961] = 5959,
  [5962] = 5962,
  [5963] = 5963,
  [5964] = 5964,
  [5965] = 5965,
  [5966] = 2671,
  [5967] = 5967,
  [5968] = 2666,
  [5969] = 5960,
  [5970] = 5959,
  [5971] = 5959,
  [5972] = 5960,
  [5973] = 5973,
  [5974] = 5748,
  [5975] = 5960,
  [5976] = 5967,
  [5977] = 5965,
  [5978] = 5978,
  [5979] = 5979,
  [5980] = 5964,
  [5981] = 5724,
  [5982] = 5963,
  [5983] = 5962,
  [5984] = 5963,
  [5985] = 2708,
  [5986] = 2714,
  [5987] = 5973,
  [5988] = 5978,
  [5989] = 2281,
  [5990] = 2702,
  [5991] = 5085,
  [5992] = 5960,
  [5993] = 5965,
  [5994] = 5960,
  [5995] = 5959,
  [5996] = 5978,
  [5997] = 5965,
  [5998] = 5960,
  [5999] = 2707,
  [6000] = 5963,
  [6001] = 5965,
  [6002] = 5960,
  [6003] = 5959,
  [6004] = 5959,
  [6005] = 5963,
  [6006] = 6006,
  [6007] = 5963,
  [6008] = 5965,
  [6009] = 5960,
  [6010] = 5959,
  [6011] = 5960,
  [6012] = 5962,
  [6013] = 5965,
  [6014] = 5967,
  [6015] = 5960,
  [6016] = 5964,
  [6017] = 5959,
  [6018] = 5962,
  [6019] = 5973,
  [6020] = 5963,
  [6021] = 5964,
  [6022] = 5967,
  [6023] = 5965,
  [6024] = 5084,
  [6025] = 5965,
  [6026] = 5964,
  [6027] = 5154,
  [6028] = 5973,
  [6029] = 5962,
  [6030] = 6006,
  [6031] = 5973,
  [6032] = 5978,
  [6033] = 5964,
  [6034] = 5964,
  [6035] = 5967,
  [6036] = 5962,
  [6037] = 5973,
  [6038] = 5962,
  [6039] = 5964,
  [6040] = 5973,
  [6041] = 5965,
  [6042] = 5960,
  [6043] = 6043,
  [6044] = 3125,
  [6045] = 5959,
  [6046] = 5040,
  [6047] = 5963,
  [6048] = 5973,
  [6049] = 5965,
  [6050] = 5959,
  [6051] = 5959,
  [6052] = 6006,
  [6053] = 5959,
  [6054] = 5959,
  [6055] = 5962,
  [6056] = 5967,
  [6057] = 5960,
  [6058] = 5964,
  [6059] = 5963,
  [6060] = 5965,
  [6061] = 6061,
  [6062] = 5965,
  [6063] = 5978,
  [6064] = 6006,
  [6065] = 6065,
  [6066] = 6006,
  [6067] = 5959,
  [6068] = 5960,
  [6069] = 5962,
  [6070] = 5973,
  [6071] = 5959,
  [6072] = 5965,
  [6073] = 5960,
  [6074] = 5965,
  [6075] = 5960,
  [6076] = 6006,
  [6077] = 5960,
  [6078] = 5959,
  [6079] = 5959,
  [6080] = 5965,
  [6081] = 5965,
  [6082] = 5967,
  [6083] = 5959,
  [6084] = 5960,
  [6085] = 5967,
  [6086] = 5965,
  [6087] = 5960,
  [6088] = 5959,
  [6089] = 5967,
  [6090] = 5960,
  [6091] = 5965,
  [6092] = 5724,
  [6093] = 5748,
  [6094] = 5965,
  [6095] = 2677,
  [6096] = 6096,
  [6097] = 2682,
  [6098] = 6098,
  [6099] = 2720,
  [6100] = 2703,
  [6101] = 2669,
  [6102] = 6102,
  [6103] = 2670,
  [6104] = 2680,
  [6105] = 6105,
  [6106] = 6105,
  [6107] = 6105,
  [6108] = 6105,
  [6109] = 6105,
  [6110] = 6110,
  [6111] = 6105,
  [6112] = 6105,
  [6113] = 6105,
  [6114] = 6105,
  [6115] = 6105,
  [6116] = 2681,
  [6117] = 6105,
  [6118] = 6110,
  [6119] = 2683,
  [6120] = 6105,
  [6121] = 6105,
  [6122] = 6105,
  [6123] = 6105,
  [6124] = 2764,
  [6125] = 6105,
  [6126] = 6105,
  [6127] = 2700,
  [6128] = 2709,
  [6129] = 6105,
  [6130] = 2710,
  [6131] = 6105,
  [6132] = 6102,
  [6133] = 2711,
  [6134] = 6098,
  [6135] = 6105,
  [6136] = 2679,
  [6137] = 5748,
  [6138] = 6098,
  [6139] = 6110,
  [6140] = 6102,
  [6141] = 6102,
  [6142] = 5724,
  [6143] = 5748,
  [6144] = 4646,
  [6145] = 6098,
  [6146] = 6110,
  [6147] = 5724,
  [6148] = 4645,
  [6149] = 5748,
  [6150] = 5724,
  [6151] = 5724,
  [6152] = 5748,
  [6153] = 6110,
  [6154] = 6102,
  [6155] = 6102,
  [6156] = 6098,
  [6157] = 6098,
  [6158] = 6102,
  [6159] = 6159,
  [6160] = 6159,
  [6161] = 6161,
  [6162] = 6110,
  [6163] = 6098,
  [6164] = 6098,
  [6165] = 6110,
  [6166] = 6110,
  [6167] = 6110,
  [6168] = 6102,
  [6169] = 6102,
  [6170] = 6098,
  [6171] = 6098,
  [6172] = 6102,
  [6173] = 6159,
  [6174] = 6098,
  [6175] = 6102,
  [6176] = 6110,
  [6177] = 6159,
  [6178] = 6178,
  [6179] = 6102,
  [6180] = 6098,
  [6181] = 6110,
  [6182] = 3870,
  [6183] = 6110,
  [6184] = 6159,
  [6185] = 6185,
  [6186] = 6102,
  [6187] = 6185,
  [6188] = 6102,
  [6189] = 6098,
  [6190] = 6098,
  [6191] = 6185,
  [6192] = 6102,
  [6193] = 6185,
  [6194] = 6098,
  [6195] = 6185,
  [6196] = 6110,
  [6197] = 6185,
  [6198] = 6185,
  [6199] = 6110,
  [6200] = 6110,
  [6201] = 6110,
  [6202] = 6185,
  [6203] = 6185,
  [6204] = 6102,
  [6205] = 6098,
  [6206] = 3880,
  [6207] = 6110,
  [6208] = 6208,
  [6209] = 6209,
  [6210] = 6102,
  [6211] = 6098,
  [6212] = 6208,
  [6213] = 6102,
  [6214] = 2101,
  [6215] = 6208,
  [6216] = 6098,
  [6217] = 6110,
  [6218] = 6218,
  [6219] = 6218,
  [6220] = 6218,
  [6221] = 6208,
  [6222] = 6222,
  [6223] = 6223,
  [6224] = 6224,
  [6225] = 6102,
  [6226] = 6110,
  [6227] = 6227,
  [6228] = 6098,
  [6229] = 6229,
  [6230] = 6230,
  [6231] = 6102,
  [6232] = 6232,
  [6233] = 6233,
  [6234] = 6229,
  [6235] = 6222,
  [6236] = 6232,
  [6237] = 6237,
  [6238] = 6222,
  [6239] = 6229,
  [6240] = 6232,
  [6241] = 6208,
  [6242] = 6229,
  [6243] = 6222,
  [6244] = 6244,
  [6245] = 6229,
  [6246] = 6246,
  [6247] = 6222,
  [6248] = 6248,
  [6249] = 6249,
  [6250] = 6250,
  [6251] = 6222,
  [6252] = 6252,
  [6253] = 6098,
  [6254] = 6250,
  [6255] = 6232,
  [6256] = 6227,
  [6257] = 6233,
  [6258] = 6110,
  [6259] = 6259,
  [6260] = 6260,
  [6261] = 6229,
  [6262] = 6227,
  [6263] = 6098,
  [6264] = 6222,
  [6265] = 6265,
  [6266] = 6252,
  [6267] = 6232,
  [6268] = 6232,
  [6269] = 6222,
  [6270] = 6252,
  [6271] = 6102,
  [6272] = 6229,
  [6273] = 6273,
  [6274] = 6274,
  [6275] = 6222,
  [6276] = 6259,
  [6277] = 6252,
  [6278] = 6250,
  [6279] = 6259,
  [6280] = 6274,
  [6281] = 6273,
  [6282] = 6282,
  [6283] = 6283,
  [6284] = 6249,
  [6285] = 6229,
  [6286] = 6229,
  [6287] = 6248,
  [6288] = 6110,
  [6289] = 6224,
  [6290] = 6222,
  [6291] = 6252,
  [6292] = 6102,
  [6293] = 6246,
  [6294] = 6244,
  [6295] = 6232,
  [6296] = 6222,
  [6297] = 6110,
  [6298] = 6237,
  [6299] = 2274,
  [6300] = 6230,
  [6301] = 6265,
  [6302] = 6222,
  [6303] = 6229,
  [6304] = 6304,
  [6305] = 6229,
  [6306] = 6259,
  [6307] = 6098,
  [6308] = 6222,
  [6309] = 6309,
  [6310] = 6229,
  [6311] = 6232,
  [6312] = 6232,
  [6313] = 6208,
  [6314] = 6304,
  [6315] = 6222,
  [6316] = 6229,
  [6317] = 6229,
  [6318] = 6318,
  [6319] = 6229,
  [6320] = 6320,
  [6321] = 6222,
  [6322] = 6322,
  [6323] = 6229,
  [6324] = 6229,
  [6325] = 6222,
  [6326] = 6222,
  [6327] = 6327,
  [6328] = 6222,
  [6329] = 6229,
  [6330] = 6330,
  [6331] = 6331,
  [6332] = 6227,
  [6333] = 6333,
  [6334] = 6334,
  [6335] = 6335,
  [6336] = 6335,
  [6337] = 6337,
  [6338] = 6338,
  [6339] = 6334,
  [6340] = 6338,
  [6341] = 6335,
  [6342] = 6334,
  [6343] = 6338,
  [6344] = 6333,
  [6345] = 6337,
  [6346] = 6333,
  [6347] = 6335,
  [6348] = 6333,
  [6349] = 6337,
  [6350] = 6337,
  [6351] = 6338,
  [6352] = 6338,
  [6353] = 6338,
  [6354] = 6334,
  [6355] = 6333,
  [6356] = 6335,
  [6357] = 6337,
  [6358] = 6338,
  [6359] = 6334,
  [6360] = 6337,
  [6361] = 6338,
  [6362] = 6333,
  [6363] = 6333,
  [6364] = 6337,
  [6365] = 6335,
  [6366] = 6334,
  [6367] = 6337,
  [6368] = 6334,
  [6369] = 6338,
  [6370] = 6337,
  [6371] = 6335,
  [6372] = 6334,
  [6373] = 6335,
  [6374] = 6333,
  [6375] = 6333,
  [6376] = 6335,
  [6377] = 6338,
  [6378] = 6334,
  [6379] = 6333,
  [6380] = 6335,
  [6381] = 6334,
  [6382] = 6333,
  [6383] = 6383,
  [6384] = 6335,
  [6385] = 6335,
  [6386] = 6337,
  [6387] = 6208,
  [6388] = 6338,
  [6389] = 6337,
  [6390] = 6333,
  [6391] = 6333,
  [6392] = 6338,
  [6393] = 6338,
  [6394] = 6335,
  [6395] = 6337,
  [6396] = 6334,
  [6397] = 6337,
  [6398] = 6338,
  [6399] = 6335,
  [6400] = 6333,
  [6401] = 6320,
  [6402] = 6338,
  [6403] = 6333,
  [6404] = 6337,
  [6405] = 6335,
  [6406] = 6333,
  [6407] = 6337,
  [6408] = 6337,
  [6409] = 6334,
  [6410] = 6410,
  [6411] = 6334,
  [6412] = 6338,
  [6413] = 6338,
  [6414] = 6334,
  [6415] = 6410,
  [6416] = 6338,
  [6417] = 6337,
  [6418] = 6334,
  [6419] = 6333,
  [6420] = 6335,
  [6421] = 6421,
  [6422] = 6333,
  [6423] = 6335,
  [6424] = 6334,
  [6425] = 6335,
  [6426] = 6333,
  [6427] = 6337,
  [6428] = 6334,
  [6429] = 6338,
  [6430] = 6334,
  [6431] = 6410,
  [6432] = 6334,
  [6433] = 6337,
  [6434] = 6333,
  [6435] = 6335,
  [6436] = 6335,
  [6437] = 6334,
  [6438] = 6338,
  [6439] = 6337,
  [6440] = 6440,
  [6441] = 6441,
  [6442] = 6440,
  [6443] = 6443,
  [6444] = 6444,
  [6445] = 6445,
  [6446] = 6443,
  [6447] = 6444,
  [6448] = 6445,
  [6449] = 6443,
  [6450] = 6444,
  [6451] = 3350,
  [6452] = 6444,
  [6453] = 6443,
  [6454] = 6445,
  [6455] = 6440,
  [6456] = 6456,
  [6457] = 6443,
  [6458] = 6444,
  [6459] = 6443,
  [6460] = 6456,
  [6461] = 6445,
  [6462] = 6444,
  [6463] = 6445,
  [6464] = 6464,
  [6465] = 6445,
  [6466] = 6444,
  [6467] = 6445,
  [6468] = 6456,
  [6469] = 6444,
  [6470] = 6445,
  [6471] = 6443,
  [6472] = 6444,
  [6473] = 6443,
  [6474] = 6443,
  [6475] = 6443,
  [6476] = 6456,
  [6477] = 6477,
  [6478] = 6327,
  [6479] = 6330,
  [6480] = 6456,
  [6481] = 6445,
  [6482] = 6443,
  [6483] = 6444,
  [6484] = 6484,
  [6485] = 6485,
  [6486] = 6456,
  [6487] = 6445,
  [6488] = 6488,
  [6489] = 6489,
  [6490] = 6490,
  [6491] = 6444,
  [6492] = 6492,
  [6493] = 6493,
  [6494] = 6445,
  [6495] = 6495,
  [6496] = 3351,
  [6497] = 6443,
  [6498] = 6498,
  [6499] = 6456,
  [6500] = 6500,
  [6501] = 6501,
  [6502] = 6502,
  [6503] = 6443,
  [6504] = 6504,
  [6505] = 6505,
  [6506] = 6456,
  [6507] = 6440,
  [6508] = 6456,
  [6509] = 6208,
  [6510] = 6510,
  [6511] = 6443,
  [6512] = 6512,
  [6513] = 6513,
  [6514] = 6514,
  [6515] = 6515,
  [6516] = 6516,
  [6517] = 6517,
  [6518] = 6515,
  [6519] = 6485,
  [6520] = 6488,
  [6521] = 6484,
  [6522] = 6522,
  [6523] = 6516,
  [6524] = 6489,
  [6525] = 6477,
  [6526] = 6526,
  [6527] = 6527,
  [6528] = 6490,
  [6529] = 6529,
  [6530] = 6530,
  [6531] = 2690,
  [6532] = 6532,
  [6533] = 6533,
  [6534] = 2044,
  [6535] = 6535,
  [6536] = 6514,
  [6537] = 6535,
  [6538] = 6533,
  [6539] = 6492,
  [6540] = 6513,
  [6541] = 6527,
  [6542] = 6542,
  [6543] = 6533,
  [6544] = 6516,
  [6545] = 6464,
  [6546] = 6542,
  [6547] = 2043,
  [6548] = 6527,
  [6549] = 6533,
  [6550] = 6493,
  [6551] = 6551,
  [6552] = 6514,
  [6553] = 2050,
  [6554] = 6515,
  [6555] = 6515,
  [6556] = 6556,
  [6557] = 6557,
  [6558] = 6495,
  [6559] = 6559,
  [6560] = 2040,
  [6561] = 2049,
  [6562] = 6562,
  [6563] = 6515,
  [6564] = 6564,
  [6565] = 2051,
  [6566] = 6564,
  [6567] = 2054,
  [6568] = 6568,
  [6569] = 6569,
  [6570] = 3351,
  [6571] = 2663,
  [6572] = 2663,
  [6573] = 6504,
  [6574] = 6498,
  [6575] = 2041,
  [6576] = 2042,
  [6577] = 6577,
  [6578] = 6578,
  [6579] = 6579,
  [6580] = 6515,
  [6581] = 6510,
  [6582] = 2046,
  [6583] = 2047,
  [6584] = 6584,
  [6585] = 6515,
  [6586] = 6515,
  [6587] = 2048,
  [6588] = 6564,
  [6589] = 2039,
  [6590] = 6516,
  [6591] = 6591,
  [6592] = 6208,
  [6593] = 6535,
  [6594] = 6591,
  [6595] = 6500,
  [6596] = 6564,
  [6597] = 6514,
  [6598] = 6515,
  [6599] = 6527,
  [6600] = 6515,
  [6601] = 6513,
  [6602] = 6535,
  [6603] = 6502,
  [6604] = 6604,
  [6605] = 6605,
  [6606] = 6551,
  [6607] = 6501,
  [6608] = 6608,
  [6609] = 6516,
  [6610] = 6535,
  [6611] = 2052,
  [6612] = 6591,
  [6613] = 6613,
  [6614] = 2690,
  [6615] = 6615,
  [6616] = 6577,
  [6617] = 6527,
  [6618] = 6529,
  [6619] = 6542,
  [6620] = 6533,
  [6621] = 6621,
  [6622] = 6542,
  [6623] = 2045,
  [6624] = 155,
  [6625] = 6522,
  [6626] = 6515,
  [6627] = 6577,
  [6628] = 6535,
  [6629] = 6515,
  [6630] = 6564,
  [6631] = 6515,
  [6632] = 6515,
  [6633] = 6591,
  [6634] = 6551,
  [6635] = 6513,
  [6636] = 6441,
  [6637] = 6529,
  [6638] = 6522,
  [6639] = 6639,
  [6640] = 6515,
  [6641] = 6515,
  [6642] = 6577,
  [6643] = 6564,
  [6644] = 6644,
  [6645] = 6551,
  [6646] = 6577,
  [6647] = 153,
  [6648] = 6512,
  [6649] = 6649,
  [6650] = 6515,
  [6651] = 6516,
  [6652] = 3350,
  [6653] = 6515,
  [6654] = 6654,
  [6655] = 6605,
  [6656] = 6551,
  [6657] = 6577,
  [6658] = 6515,
  [6659] = 6527,
  [6660] = 6529,
  [6661] = 6522,
  [6662] = 6515,
  [6663] = 6663,
  [6664] = 6664,
  [6665] = 6516,
  [6666] = 6516,
  [6667] = 6535,
  [6668] = 6527,
  [6669] = 2764,
  [6670] = 6621,
  [6671] = 6527,
  [6672] = 6564,
  [6673] = 6530,
  [6674] = 6208,
  [6675] = 6649,
  [6676] = 6535,
  [6677] = 6564,
  [6678] = 6678,
  [6679] = 6679,
  [6680] = 2068,
  [6681] = 6208,
  [6682] = 6682,
  [6683] = 6683,
  [6684] = 6684,
  [6685] = 6685,
  [6686] = 6686,
  [6687] = 6687,
  [6688] = 6684,
  [6689] = 2355,
  [6690] = 6684,
  [6691] = 6516,
  [6692] = 6535,
  [6693] = 6535,
  [6694] = 6684,
  [6695] = 6679,
  [6696] = 2400,
  [6697] = 6527,
  [6698] = 6564,
  [6699] = 6679,
  [6700] = 6700,
  [6701] = 6701,
  [6702] = 6702,
  [6703] = 6683,
  [6704] = 6535,
  [6705] = 6705,
  [6706] = 6516,
  [6707] = 6208,
  [6708] = 6683,
  [6709] = 6709,
  [6710] = 6710,
  [6711] = 6711,
  [6712] = 6564,
  [6713] = 6713,
  [6714] = 6679,
  [6715] = 6715,
  [6716] = 6527,
  [6717] = 6717,
  [6718] = 6718,
  [6719] = 6719,
  [6720] = 6683,
  [6721] = 2065,
  [6722] = 6722,
  [6723] = 6535,
  [6724] = 6683,
  [6725] = 6683,
  [6726] = 6527,
  [6727] = 6727,
  [6728] = 6728,
  [6729] = 6683,
  [6730] = 6679,
  [6731] = 6683,
  [6732] = 6679,
  [6733] = 6564,
  [6734] = 6684,
  [6735] = 6679,
  [6736] = 6736,
  [6737] = 6683,
  [6738] = 6683,
  [6739] = 6679,
  [6740] = 6740,
  [6741] = 6701,
  [6742] = 6742,
  [6743] = 6679,
  [6744] = 6744,
  [6745] = 6679,
  [6746] = 6516,
  [6747] = 6747,
  [6748] = 6748,
  [6749] = 6684,
  [6750] = 6683,
  [6751] = 2067,
  [6752] = 6679,
  [6753] = 6564,
  [6754] = 6679,
  [6755] = 6683,
  [6756] = 6527,
  [6757] = 6516,
  [6758] = 2866,
  [6759] = 2048,
  [6760] = 6564,
  [6761] = 6208,
  [6762] = 6522,
  [6763] = 2051,
  [6764] = 2054,
  [6765] = 6513,
  [6766] = 6766,
  [6767] = 1115,
  [6768] = 2044,
  [6769] = 6562,
  [6770] = 6564,
  [6771] = 6591,
  [6772] = 6522,
  [6773] = 6527,
  [6774] = 6516,
  [6775] = 6775,
  [6776] = 6529,
  [6777] = 6777,
  [6778] = 6778,
  [6779] = 2043,
  [6780] = 6529,
  [6781] = 6514,
  [6782] = 6514,
  [6783] = 6535,
  [6784] = 6568,
  [6785] = 153,
  [6786] = 155,
  [6787] = 6208,
  [6788] = 6535,
  [6789] = 6591,
  [6790] = 1116,
  [6791] = 2663,
  [6792] = 2039,
  [6793] = 2041,
  [6794] = 2050,
  [6795] = 2049,
  [6796] = 2042,
  [6797] = 2047,
  [6798] = 2046,
  [6799] = 6513,
  [6800] = 2690,
  [6801] = 2052,
  [6802] = 6516,
  [6803] = 2045,
  [6804] = 2040,
  [6805] = 6527,
  [6806] = 6806,
  [6807] = 6807,
  [6808] = 6808,
  [6809] = 6809,
  [6810] = 6808,
  [6811] = 3017,
  [6812] = 2860,
  [6813] = 6813,
  [6814] = 6814,
  [6815] = 6815,
  [6816] = 6816,
  [6817] = 6817,
  [6818] = 6818,
  [6819] = 6819,
  [6820] = 6820,
  [6821] = 6807,
  [6822] = 2764,
  [6823] = 6823,
  [6824] = 6807,
  [6825] = 6814,
  [6826] = 6815,
  [6827] = 6823,
  [6828] = 6813,
  [6829] = 6816,
  [6830] = 6830,
  [6831] = 6817,
  [6832] = 6808,
  [6833] = 6818,
  [6834] = 6819,
  [6835] = 6820,
  [6836] = 6808,
  [6837] = 6807,
  [6838] = 3007,
  [6839] = 6806,
  [6840] = 6807,
  [6841] = 6813,
  [6842] = 6564,
  [6843] = 6808,
  [6844] = 6813,
  [6845] = 6814,
  [6846] = 6813,
  [6847] = 6564,
  [6848] = 6807,
  [6849] = 6535,
  [6850] = 6535,
  [6851] = 6808,
  [6852] = 6808,
  [6853] = 6853,
  [6854] = 2662,
  [6855] = 2723,
  [6856] = 2691,
  [6857] = 6808,
  [6858] = 6823,
  [6859] = 6807,
  [6860] = 6813,
  [6861] = 6807,
  [6862] = 6813,
  [6863] = 6823,
  [6864] = 6516,
  [6865] = 6807,
  [6866] = 6866,
  [6867] = 6867,
  [6868] = 6813,
  [6869] = 6806,
  [6870] = 6527,
  [6871] = 6820,
  [6872] = 6808,
  [6873] = 6807,
  [6874] = 6813,
  [6875] = 6807,
  [6876] = 6819,
  [6877] = 6807,
  [6878] = 2716,
  [6879] = 6818,
  [6880] = 6823,
  [6881] = 6817,
  [6882] = 6516,
  [6883] = 6816,
  [6884] = 6815,
  [6885] = 6527,
  [6886] = 6591,
  [6887] = 6713,
  [6888] = 2092,
  [6889] = 6564,
  [6890] = 6890,
  [6891] = 6890,
  [6892] = 6890,
  [6893] = 6522,
  [6894] = 2095,
  [6895] = 6895,
  [6896] = 6890,
  [6897] = 6890,
  [6898] = 6529,
  [6899] = 6742,
  [6900] = 6535,
  [6901] = 6901,
  [6902] = 6902,
  [6903] = 6890,
  [6904] = 6904,
  [6905] = 6516,
  [6906] = 6522,
  [6907] = 6890,
  [6908] = 6529,
  [6909] = 6904,
  [6910] = 6748,
  [6911] = 6904,
  [6912] = 2106,
  [6913] = 6514,
  [6914] = 6522,
  [6915] = 6529,
  [6916] = 6514,
  [6917] = 6904,
  [6918] = 6904,
  [6919] = 2094,
  [6920] = 6747,
  [6921] = 6904,
  [6922] = 6564,
  [6923] = 6686,
  [6924] = 6513,
  [6925] = 6925,
  [6926] = 6527,
  [6927] = 6535,
  [6928] = 6516,
  [6929] = 6929,
  [6930] = 6208,
  [6931] = 6904,
  [6932] = 6925,
  [6933] = 6527,
  [6934] = 6814,
  [6935] = 6935,
  [6936] = 6715,
  [6937] = 2690,
  [6938] = 6591,
  [6939] = 6939,
  [6940] = 6815,
  [6941] = 1983,
  [6942] = 6816,
  [6943] = 6943,
  [6944] = 6740,
  [6945] = 6727,
  [6946] = 6591,
  [6947] = 6719,
  [6948] = 6948,
  [6949] = 6718,
  [6950] = 6711,
  [6951] = 6722,
  [6952] = 6702,
  [6953] = 6687,
  [6954] = 6817,
  [6955] = 6818,
  [6956] = 6819,
  [6957] = 6904,
  [6958] = 6904,
  [6959] = 6820,
  [6960] = 6904,
  [6961] = 6904,
  [6962] = 6890,
  [6963] = 6904,
  [6964] = 6904,
  [6965] = 6705,
  [6966] = 2729,
  [6967] = 6736,
  [6968] = 2663,
  [6969] = 6522,
  [6970] = 6678,
  [6971] = 6529,
  [6972] = 6514,
  [6973] = 2663,
  [6974] = 6513,
  [6975] = 6890,
  [6976] = 6901,
  [6977] = 6806,
  [6978] = 6717,
  [6979] = 6728,
  [6980] = 6904,
  [6981] = 6513,
  [6982] = 6904,
  [6983] = 6709,
  [6984] = 6513,
  [6985] = 2690,
  [6986] = 6904,
  [6987] = 6904,
  [6988] = 6904,
  [6989] = 6948,
  [6990] = 6943,
  [6991] = 6591,
  [6992] = 6904,
  [6993] = 6929,
  [6994] = 6904,
  [6995] = 6685,
  [6996] = 6904,
  [6997] = 6997,
  [6998] = 6998,
  [6999] = 6514,
  [7000] = 2734,
  [7001] = 6527,
  [7002] = 2795,
  [7003] = 7003,
  [7004] = 7004,
  [7005] = 7005,
  [7006] = 7006,
  [7007] = 7006,
  [7008] = 7008,
  [7009] = 7009,
  [7010] = 7006,
  [7011] = 7009,
  [7012] = 7009,
  [7013] = 7005,
  [7014] = 7009,
  [7015] = 7015,
  [7016] = 7004,
  [7017] = 7003,
  [7018] = 7018,
  [7019] = 6527,
  [7020] = 2796,
  [7021] = 7005,
  [7022] = 2785,
  [7023] = 7009,
  [7024] = 7015,
  [7025] = 7025,
  [7026] = 7004,
  [7027] = 7004,
  [7028] = 7028,
  [7029] = 7029,
  [7030] = 7015,
  [7031] = 7004,
  [7032] = 7032,
  [7033] = 7003,
  [7034] = 7003,
  [7035] = 7006,
  [7036] = 7006,
  [7037] = 7009,
  [7038] = 6516,
  [7039] = 7005,
  [7040] = 7040,
  [7041] = 7009,
  [7042] = 7004,
  [7043] = 7015,
  [7044] = 7044,
  [7045] = 7009,
  [7046] = 2805,
  [7047] = 7004,
  [7048] = 7003,
  [7049] = 2733,
  [7050] = 7050,
  [7051] = 6806,
  [7052] = 6820,
  [7053] = 6819,
  [7054] = 6818,
  [7055] = 6817,
  [7056] = 6816,
  [7057] = 7050,
  [7058] = 6815,
  [7059] = 2936,
  [7060] = 7005,
  [7061] = 7009,
  [7062] = 7004,
  [7063] = 6815,
  [7064] = 7004,
  [7065] = 7005,
  [7066] = 6814,
  [7067] = 7067,
  [7068] = 2949,
  [7069] = 2952,
  [7070] = 6516,
  [7071] = 2960,
  [7072] = 6535,
  [7073] = 7009,
  [7074] = 7006,
  [7075] = 2961,
  [7076] = 7004,
  [7077] = 7006,
  [7078] = 6816,
  [7079] = 7079,
  [7080] = 2804,
  [7081] = 7003,
  [7082] = 7082,
  [7083] = 2963,
  [7084] = 7003,
  [7085] = 6806,
  [7086] = 2726,
  [7087] = 6820,
  [7088] = 2794,
  [7089] = 7004,
  [7090] = 7003,
  [7091] = 2920,
  [7092] = 7003,
  [7093] = 2716,
  [7094] = 6564,
  [7095] = 2723,
  [7096] = 6819,
  [7097] = 7015,
  [7098] = 6564,
  [7099] = 7099,
  [7100] = 7015,
  [7101] = 2731,
  [7102] = 6814,
  [7103] = 7005,
  [7104] = 7005,
  [7105] = 6535,
  [7106] = 7004,
  [7107] = 2784,
  [7108] = 7108,
  [7109] = 7005,
  [7110] = 6818,
  [7111] = 6817,
  [7112] = 2691,
  [7113] = 2662,
  [7114] = 7006,
  [7115] = 2950,
  [7116] = 7009,
  [7117] = 7006,
  [7118] = 7009,
  [7119] = 7119,
  [7120] = 2663,
  [7121] = 7121,
  [7122] = 7122,
  [7123] = 7122,
  [7124] = 7121,
  [7125] = 7121,
  [7126] = 6929,
  [7127] = 6522,
  [7128] = 6939,
  [7129] = 7129,
  [7130] = 6529,
  [7131] = 7121,
  [7132] = 7122,
  [7133] = 2729,
  [7134] = 7134,
  [7135] = 6514,
  [7136] = 6513,
  [7137] = 7121,
  [7138] = 7121,
  [7139] = 7139,
  [7140] = 7121,
  [7141] = 6591,
  [7142] = 2662,
  [7143] = 7121,
  [7144] = 7121,
  [7145] = 6564,
  [7146] = 6591,
  [7147] = 6527,
  [7148] = 7121,
  [7149] = 2723,
  [7150] = 6513,
  [7151] = 6516,
  [7152] = 6535,
  [7153] = 6527,
  [7154] = 7122,
  [7155] = 6564,
  [7156] = 6535,
  [7157] = 6514,
  [7158] = 4614,
  [7159] = 7121,
  [7160] = 7160,
  [7161] = 6529,
  [7162] = 7162,
  [7163] = 7134,
  [7164] = 6516,
  [7165] = 6522,
  [7166] = 7121,
  [7167] = 7121,
  [7168] = 7134,
  [7169] = 7169,
  [7170] = 7121,
  [7171] = 7134,
  [7172] = 7121,
  [7173] = 6948,
  [7174] = 2690,
  [7175] = 6943,
  [7176] = 6820,
  [7177] = 2691,
  [7178] = 6901,
  [7179] = 7134,
  [7180] = 7122,
  [7181] = 7181,
  [7182] = 6817,
  [7183] = 2716,
  [7184] = 6814,
  [7185] = 7121,
  [7186] = 6815,
  [7187] = 7121,
  [7188] = 6818,
  [7189] = 7121,
  [7190] = 7121,
  [7191] = 6925,
  [7192] = 6806,
  [7193] = 7193,
  [7194] = 7121,
  [7195] = 6819,
  [7196] = 7121,
  [7197] = 6816,
  [7198] = 7198,
  [7199] = 2690,
  [7200] = 7198,
  [7201] = 6820,
  [7202] = 6591,
  [7203] = 7203,
  [7204] = 7198,
  [7205] = 6820,
  [7206] = 7203,
  [7207] = 7207,
  [7208] = 7207,
  [7209] = 7207,
  [7210] = 6591,
  [7211] = 6819,
  [7212] = 7212,
  [7213] = 7213,
  [7214] = 6514,
  [7215] = 7198,
  [7216] = 7203,
  [7217] = 7217,
  [7218] = 7218,
  [7219] = 6529,
  [7220] = 7207,
  [7221] = 7221,
  [7222] = 7222,
  [7223] = 7203,
  [7224] = 6943,
  [7225] = 7218,
  [7226] = 6818,
  [7227] = 7218,
  [7228] = 7218,
  [7229] = 6817,
  [7230] = 2729,
  [7231] = 6514,
  [7232] = 6814,
  [7233] = 7218,
  [7234] = 7207,
  [7235] = 7235,
  [7236] = 7236,
  [7237] = 6901,
  [7238] = 7238,
  [7239] = 7239,
  [7240] = 7198,
  [7241] = 6513,
  [7242] = 6529,
  [7243] = 7243,
  [7244] = 7218,
  [7245] = 7207,
  [7246] = 6513,
  [7247] = 7247,
  [7248] = 6522,
  [7249] = 7203,
  [7250] = 6819,
  [7251] = 7203,
  [7252] = 7252,
  [7253] = 6816,
  [7254] = 6814,
  [7255] = 6948,
  [7256] = 7198,
  [7257] = 2852,
  [7258] = 7207,
  [7259] = 6522,
  [7260] = 7260,
  [7261] = 7203,
  [7262] = 6806,
  [7263] = 7218,
  [7264] = 7264,
  [7265] = 7265,
  [7266] = 7203,
  [7267] = 7198,
  [7268] = 6815,
  [7269] = 2663,
  [7270] = 6929,
  [7271] = 7218,
  [7272] = 6925,
  [7273] = 7207,
  [7274] = 7198,
  [7275] = 7218,
  [7276] = 6816,
  [7277] = 7277,
  [7278] = 7203,
  [7279] = 7198,
  [7280] = 7207,
  [7281] = 7281,
  [7282] = 6817,
  [7283] = 7281,
  [7284] = 6806,
  [7285] = 7285,
  [7286] = 7281,
  [7287] = 7287,
  [7288] = 1979,
  [7289] = 6814,
  [7290] = 7290,
  [7291] = 7291,
  [7292] = 7281,
  [7293] = 7293,
  [7294] = 7281,
  [7295] = 6815,
  [7296] = 7281,
  [7297] = 7281,
  [7298] = 7281,
  [7299] = 7281,
  [7300] = 6816,
  [7301] = 7281,
  [7302] = 7302,
  [7303] = 6818,
  [7304] = 7287,
  [7305] = 7305,
  [7306] = 1973,
  [7307] = 7281,
  [7308] = 7308,
  [7309] = 1974,
  [7310] = 1976,
  [7311] = 1980,
  [7312] = 1977,
  [7313] = 1975,
  [7314] = 6820,
  [7315] = 7281,
  [7316] = 7281,
  [7317] = 7281,
  [7318] = 6819,
  [7319] = 7281,
  [7320] = 7320,
  [7321] = 7321,
  [7322] = 7322,
  [7323] = 7323,
  [7324] = 7324,
  [7325] = 7322,
  [7326] = 7322,
  [7327] = 7327,
  [7328] = 7322,
  [7329] = 7322,
  [7330] = 7322,
  [7331] = 6806,
  [7332] = 7324,
  [7333] = 7324,
  [7334] = 7322,
  [7335] = 7322,
  [7336] = 7324,
  [7337] = 7322,
  [7338] = 7322,
  [7339] = 7322,
  [7340] = 7322,
  [7341] = 7327,
  [7342] = 7327,
  [7343] = 7322,
  [7344] = 7327,
  [7345] = 7324,
  [7346] = 7322,
  [7347] = 7322,
  [7348] = 6775,
  [7349] = 7322,
  [7350] = 7322,
  [7351] = 7351,
  [7352] = 7322,
  [7353] = 6820,
  [7354] = 7324,
  [7355] = 6819,
  [7356] = 6814,
  [7357] = 7322,
  [7358] = 7324,
  [7359] = 7322,
  [7360] = 2690,
  [7361] = 7322,
  [7362] = 6815,
  [7363] = 6816,
  [7364] = 6766,
  [7365] = 7322,
  [7366] = 7327,
  [7367] = 7324,
  [7368] = 2663,
  [7369] = 7324,
  [7370] = 6817,
  [7371] = 7322,
  [7372] = 6818,
  [7373] = 7373,
  [7374] = 7374,
  [7375] = 2860,
  [7376] = 7376,
  [7377] = 7377,
  [7378] = 7378,
  [7379] = 7378,
  [7380] = 7380,
  [7381] = 7381,
  [7382] = 7382,
  [7383] = 7383,
  [7384] = 6901,
  [7385] = 7385,
  [7386] = 7386,
  [7387] = 7387,
  [7388] = 7388,
  [7389] = 7389,
  [7390] = 7390,
  [7391] = 7391,
  [7392] = 7392,
  [7393] = 7393,
  [7394] = 7394,
  [7395] = 7395,
  [7396] = 7393,
  [7397] = 7397,
  [7398] = 7378,
  [7399] = 7393,
  [7400] = 7378,
  [7401] = 7401,
  [7402] = 7393,
  [7403] = 7378,
  [7404] = 6998,
  [7405] = 6997,
  [7406] = 6925,
  [7407] = 6766,
  [7408] = 7376,
  [7409] = 6929,
  [7410] = 6806,
  [7411] = 6814,
  [7412] = 7412,
  [7413] = 6948,
  [7414] = 7393,
  [7415] = 6935,
  [7416] = 7376,
  [7417] = 7417,
  [7418] = 6775,
  [7419] = 6820,
  [7420] = 6819,
  [7421] = 6902,
  [7422] = 7378,
  [7423] = 7376,
  [7424] = 7424,
  [7425] = 6818,
  [7426] = 6817,
  [7427] = 7427,
  [7428] = 6895,
  [7429] = 7378,
  [7430] = 7378,
  [7431] = 7378,
  [7432] = 7376,
  [7433] = 6815,
  [7434] = 7434,
  [7435] = 6943,
  [7436] = 6816,
  [7437] = 7437,
  [7438] = 7438,
  [7439] = 6815,
  [7440] = 7440,
  [7441] = 7437,
  [7442] = 7442,
  [7443] = 6816,
  [7444] = 7442,
  [7445] = 7445,
  [7446] = 7438,
  [7447] = 7447,
  [7448] = 6820,
  [7449] = 7449,
  [7450] = 7445,
  [7451] = 7451,
  [7452] = 7445,
  [7453] = 7442,
  [7454] = 7454,
  [7455] = 6806,
  [7456] = 2807,
  [7457] = 7438,
  [7458] = 2841,
  [7459] = 7437,
  [7460] = 6806,
  [7461] = 7461,
  [7462] = 7437,
  [7463] = 2716,
  [7464] = 6814,
  [7465] = 2824,
  [7466] = 2662,
  [7467] = 6816,
  [7468] = 6815,
  [7469] = 6819,
  [7470] = 6817,
  [7471] = 7442,
  [7472] = 2691,
  [7473] = 6819,
  [7474] = 6820,
  [7475] = 7475,
  [7476] = 7476,
  [7477] = 7437,
  [7478] = 6818,
  [7479] = 6818,
  [7480] = 7438,
  [7481] = 6817,
  [7482] = 2723,
  [7483] = 6814,
  [7484] = 7438,
  [7485] = 7485,
  [7486] = 2860,
  [7487] = 7445,
  [7488] = 7442,
  [7489] = 7489,
  [7490] = 7445,
  [7491] = 7491,
  [7492] = 7492,
  [7493] = 7493,
  [7494] = 7494,
  [7495] = 7495,
  [7496] = 7495,
  [7497] = 7497,
  [7498] = 7498,
  [7499] = 7498,
  [7500] = 7497,
  [7501] = 7493,
  [7502] = 7162,
  [7503] = 7119,
  [7504] = 7493,
  [7505] = 7505,
  [7506] = 7498,
  [7507] = 7493,
  [7508] = 7497,
  [7509] = 7509,
  [7510] = 7498,
  [7511] = 7495,
  [7512] = 7497,
  [7513] = 7495,
  [7514] = 7493,
  [7515] = 2729,
  [7516] = 7129,
  [7517] = 7495,
  [7518] = 7518,
  [7519] = 7519,
  [7520] = 7498,
  [7521] = 7497,
  [7522] = 7505,
  [7523] = 7523,
  [7524] = 7497,
  [7525] = 7493,
  [7526] = 7493,
  [7527] = 7424,
  [7528] = 7389,
  [7529] = 7493,
  [7530] = 7498,
  [7531] = 7495,
  [7532] = 7523,
  [7533] = 7533,
  [7534] = 7534,
  [7535] = 7535,
  [7536] = 7497,
  [7537] = 7495,
  [7538] = 7538,
  [7539] = 7495,
  [7540] = 7540,
  [7541] = 7541,
  [7542] = 7497,
  [7543] = 7498,
  [7544] = 7495,
  [7545] = 7545,
  [7546] = 7498,
  [7547] = 7493,
  [7548] = 2860,
  [7549] = 7498,
  [7550] = 7550,
  [7551] = 2860,
  [7552] = 7552,
  [7553] = 7497,
  [7554] = 7390,
  [7555] = 2860,
  [7556] = 7556,
  [7557] = 7557,
  [7558] = 7454,
  [7559] = 7559,
  [7560] = 7560,
  [7561] = 7561,
  [7562] = 7562,
  [7563] = 7557,
  [7564] = 6806,
  [7565] = 7565,
  [7566] = 7561,
  [7567] = 7556,
  [7568] = 7568,
  [7569] = 7569,
  [7570] = 2835,
  [7571] = 7571,
  [7572] = 7572,
  [7573] = 7573,
  [7574] = 7574,
  [7575] = 7575,
  [7576] = 7576,
  [7577] = 7577,
  [7578] = 7577,
  [7579] = 6818,
  [7580] = 6817,
  [7581] = 7576,
  [7582] = 7557,
  [7583] = 7575,
  [7584] = 7584,
  [7585] = 7574,
  [7586] = 7586,
  [7587] = 7587,
  [7588] = 7573,
  [7589] = 7560,
  [7590] = 6819,
  [7591] = 7591,
  [7592] = 7565,
  [7593] = 6820,
  [7594] = 7568,
  [7595] = 6814,
  [7596] = 7577,
  [7597] = 7556,
  [7598] = 7569,
  [7599] = 7576,
  [7600] = 7557,
  [7601] = 7569,
  [7602] = 7568,
  [7603] = 7557,
  [7604] = 7565,
  [7605] = 2860,
  [7606] = 7575,
  [7607] = 7574,
  [7608] = 7572,
  [7609] = 7556,
  [7610] = 7556,
  [7611] = 7573,
  [7612] = 6815,
  [7613] = 7575,
  [7614] = 7574,
  [7615] = 7569,
  [7616] = 7577,
  [7617] = 7568,
  [7618] = 7573,
  [7619] = 7565,
  [7620] = 7556,
  [7621] = 7559,
  [7622] = 6816,
  [7623] = 7623,
  [7624] = 7624,
  [7625] = 7576,
  [7626] = 7626,
  [7627] = 7627,
  [7628] = 7628,
  [7629] = 7629,
  [7630] = 7630,
  [7631] = 7631,
  [7632] = 7632,
  [7633] = 7633,
  [7634] = 7634,
  [7635] = 7630,
  [7636] = 7636,
  [7637] = 7637,
  [7638] = 7638,
  [7639] = 7639,
  [7640] = 7640,
  [7641] = 7630,
  [7642] = 7642,
  [7643] = 7643,
  [7644] = 7644,
  [7645] = 7645,
  [7646] = 7636,
  [7647] = 7647,
  [7648] = 7640,
  [7649] = 7631,
  [7650] = 7650,
  [7651] = 7651,
  [7652] = 7644,
  [7653] = 7653,
  [7654] = 7642,
  [7655] = 7655,
  [7656] = 7630,
  [7657] = 7651,
  [7658] = 7633,
  [7659] = 7651,
  [7660] = 7632,
  [7661] = 7651,
  [7662] = 7629,
  [7663] = 7640,
  [7664] = 7642,
  [7665] = 7644,
  [7666] = 7633,
  [7667] = 7632,
  [7668] = 7629,
  [7669] = 7669,
  [7670] = 7670,
  [7671] = 7671,
  [7672] = 7655,
  [7673] = 7644,
  [7674] = 7674,
  [7675] = 7675,
  [7676] = 7655,
  [7677] = 7634,
  [7678] = 7651,
  [7679] = 7653,
  [7680] = 7633,
  [7681] = 7681,
  [7682] = 7651,
  [7683] = 7632,
  [7684] = 7640,
  [7685] = 7634,
  [7686] = 7634,
  [7687] = 7627,
  [7688] = 7629,
  [7689] = 7689,
  [7690] = 7670,
  [7691] = 7691,
  [7692] = 7642,
  [7693] = 7630,
  [7694] = 7651,
  [7695] = 7643,
  [7696] = 7655,
  [7697] = 7697,
  [7698] = 7653,
  [7699] = 7630,
  [7700] = 7636,
  [7701] = 7653,
  [7702] = 7640,
  [7703] = 7703,
  [7704] = 7669,
  [7705] = 7651,
  [7706] = 7636,
  [7707] = 7707,
  [7708] = 7631,
  [7709] = 7650,
  [7710] = 7627,
  [7711] = 7711,
  [7712] = 7629,
  [7713] = 7713,
  [7714] = 7655,
  [7715] = 7711,
  [7716] = 7669,
  [7717] = 7711,
  [7718] = 7640,
  [7719] = 7703,
  [7720] = 7650,
  [7721] = 7643,
  [7722] = 7655,
  [7723] = 7631,
  [7724] = 7636,
  [7725] = 7655,
  [7726] = 7703,
  [7727] = 7651,
  [7728] = 7728,
  [7729] = 7630,
  [7730] = 7730,
  [7731] = 7638,
  [7732] = 7653,
  [7733] = 7703,
  [7734] = 7734,
  [7735] = 7735,
  [7736] = 7629,
  [7737] = 7653,
  [7738] = 7738,
  [7739] = 7643,
  [7740] = 7670,
  [7741] = 7741,
  [7742] = 7742,
  [7743] = 7650,
  [7744] = 7640,
  [7745] = 7636,
  [7746] = 7650,
  [7747] = 7630,
  [7748] = 7669,
  [7749] = 7711,
  [7750] = 7634,
  [7751] = 7651,
  [7752] = 7655,
  [7753] = 7634,
  [7754] = 7640,
  [7755] = 7636,
  [7756] = 7655,
  [7757] = 7711,
  [7758] = 7644,
  [7759] = 7631,
  [7760] = 7634,
  [7761] = 7650,
  [7762] = 7642,
  [7763] = 7631,
  [7764] = 7670,
  [7765] = 7644,
  [7766] = 7636,
  [7767] = 7651,
  [7768] = 7655,
  [7769] = 7769,
  [7770] = 7655,
  [7771] = 7642,
  [7772] = 7650,
  [7773] = 7650,
  [7774] = 7644,
  [7775] = 7669,
  [7776] = 7633,
  [7777] = 7735,
  [7778] = 7650,
  [7779] = 7627,
  [7780] = 7632,
  [7781] = 7629,
  [7782] = 7711,
  [7783] = 7638,
  [7784] = 7703,
  [7785] = 7634,
  [7786] = 7633,
  [7787] = 7711,
  [7788] = 7788,
  [7789] = 7643,
  [7790] = 7655,
  [7791] = 7629,
  [7792] = 7792,
  [7793] = 7629,
  [7794] = 7651,
  [7795] = 7632,
  [7796] = 7633,
  [7797] = 7797,
  [7798] = 7653,
  [7799] = 7631,
  [7800] = 7634,
  [7801] = 7801,
  [7802] = 7634,
  [7803] = 7638,
  [7804] = 7703,
  [7805] = 7669,
  [7806] = 7670,
  [7807] = 7636,
  [7808] = 7808,
  [7809] = 7627,
  [7810] = 7651,
  [7811] = 7703,
  [7812] = 7643,
  [7813] = 7636,
  [7814] = 7703,
  [7815] = 7655,
  [7816] = 7638,
  [7817] = 7643,
  [7818] = 7801,
  [7819] = 7801,
  [7820] = 7636,
  [7821] = 7644,
  [7822] = 7822,
  [7823] = 7642,
  [7824] = 7631,
  [7825] = 6766,
  [7826] = 7627,
  [7827] = 7703,
  [7828] = 7828,
  [7829] = 7650,
  [7830] = 7633,
  [7831] = 7735,
  [7832] = 7632,
  [7833] = 7801,
  [7834] = 7642,
  [7835] = 7670,
  [7836] = 7801,
  [7837] = 7837,
  [7838] = 7631,
  [7839] = 7633,
  [7840] = 7735,
  [7841] = 7670,
  [7842] = 7638,
  [7843] = 7636,
  [7844] = 7632,
  [7845] = 7801,
  [7846] = 7651,
  [7847] = 7651,
  [7848] = 7848,
  [7849] = 7634,
  [7850] = 7651,
  [7851] = 7851,
  [7852] = 7636,
  [7853] = 7644,
  [7854] = 7735,
  [7855] = 7655,
  [7856] = 7629,
  [7857] = 7627,
  [7858] = 7801,
  [7859] = 7650,
  [7860] = 7640,
  [7861] = 7861,
  [7862] = 7636,
  [7863] = 7631,
  [7864] = 7627,
  [7865] = 7650,
  [7866] = 7638,
  [7867] = 7651,
  [7868] = 7632,
  [7869] = 7630,
  [7870] = 7669,
  [7871] = 7636,
  [7872] = 7650,
  [7873] = 7653,
  [7874] = 7627,
  [7875] = 7642,
  [7876] = 7644,
  [7877] = 7703,
  [7878] = 7643,
  [7879] = 7655,
  [7880] = 7651,
  [7881] = 7640,
  [7882] = 7640,
  [7883] = 7631,
  [7884] = 7630,
  [7885] = 7627,
  [7886] = 7629,
  [7887] = 7887,
  [7888] = 7642,
  [7889] = 7711,
  [7890] = 7650,
  [7891] = 7801,
  [7892] = 7631,
  [7893] = 7636,
  [7894] = 7643,
  [7895] = 7895,
  [7896] = 7651,
  [7897] = 7669,
  [7898] = 7638,
  [7899] = 7632,
  [7900] = 7636,
  [7901] = 7703,
  [7902] = 7633,
  [7903] = 7636,
  [7904] = 7655,
  [7905] = 7643,
  [7906] = 7636,
  [7907] = 7644,
  [7908] = 7627,
  [7909] = 7909,
  [7910] = 7653,
  [7911] = 7643,
  [7912] = 7634,
  [7913] = 7634,
  [7914] = 7655,
  [7915] = 7636,
  [7916] = 7643,
  [7917] = 7655,
  [7918] = 7631,
  [7919] = 7669,
  [7920] = 7634,
  [7921] = 7651,
  [7922] = 7636,
  [7923] = 7923,
  [7924] = 7631,
  [7925] = 7630,
  [7926] = 7644,
  [7927] = 7629,
  [7928] = 7655,
  [7929] = 7519,
  [7930] = 7801,
  [7931] = 7632,
  [7932] = 7633,
  [7933] = 7651,
  [7934] = 7642,
  [7935] = 7638,
  [7936] = 7936,
  [7937] = 7937,
  [7938] = 7938,
  [7939] = 7939,
  [7940] = 7940,
  [7941] = 7941,
  [7942] = 7942,
  [7943] = 7943,
  [7944] = 7944,
  [7945] = 7945,
  [7946] = 7946,
  [7947] = 7947,
  [7948] = 7948,
  [7949] = 7949,
  [7950] = 7950,
  [7951] = 7936,
  [7952] = 7952,
  [7953] = 7953,
  [7954] = 7947,
  [7955] = 7955,
  [7956] = 7956,
  [7957] = 7957,
  [7958] = 7958,
  [7959] = 7959,
  [7960] = 7960,
  [7961] = 7961,
  [7962] = 7962,
  [7963] = 7957,
  [7964] = 7964,
  [7965] = 7965,
  [7966] = 272,
  [7967] = 7967,
  [7968] = 7968,
  [7969] = 7937,
  [7970] = 7950,
  [7971] = 7952,
  [7972] = 7953,
  [7973] = 7965,
  [7974] = 7956,
  [7975] = 7975,
  [7976] = 7955,
  [7977] = 7975,
  [7978] = 7978,
  [7979] = 7939,
  [7980] = 7942,
  [7981] = 7943,
  [7982] = 7958,
  [7983] = 7949,
  [7984] = 7984,
  [7985] = 7968,
  [7986] = 7986,
  [7987] = 7986,
  [7988] = 7988,
  [7989] = 7988,
  [7990] = 7990,
  [7991] = 7991,
  [7992] = 7956,
  [7993] = 7958,
  [7994] = 7943,
  [7995] = 7995,
  [7996] = 7961,
  [7997] = 7946,
  [7998] = 7998,
  [7999] = 7945,
  [8000] = 8000,
  [8001] = 8001,
  [8002] = 8002,
  [8003] = 7424,
  [8004] = 8004,
  [8005] = 7967,
  [8006] = 7990,
  [8007] = 7991,
  [8008] = 8008,
  [8009] = 7962,
  [8010] = 8004,
  [8011] = 270,
  [8012] = 7958,
  [8013] = 8004,
  [8014] = 7995,
  [8015] = 8015,
  [8016] = 7944,
  [8017] = 7995,
  [8018] = 8008,
  [8019] = 8008,
  [8020] = 8020,
  [8021] = 7995,
  [8022] = 7941,
  [8023] = 8023,
  [8024] = 7960,
  [8025] = 7939,
  [8026] = 7940,
  [8027] = 7991,
  [8028] = 7990,
  [8029] = 7988,
  [8030] = 7986,
  [8031] = 7968,
  [8032] = 7943,
  [8033] = 7956,
  [8034] = 7968,
  [8035] = 7939,
  [8036] = 7958,
  [8037] = 7942,
  [8038] = 8038,
  [8039] = 7960,
  [8040] = 7961,
  [8041] = 8041,
  [8042] = 8042,
  [8043] = 7942,
  [8044] = 7965,
  [8045] = 7953,
  [8046] = 7958,
  [8047] = 7991,
  [8048] = 7990,
  [8049] = 7952,
  [8050] = 7961,
  [8051] = 7950,
  [8052] = 7937,
  [8053] = 8053,
  [8054] = 7959,
  [8055] = 7960,
  [8056] = 7948,
  [8057] = 8057,
  [8058] = 7957,
  [8059] = 7975,
  [8060] = 7967,
  [8061] = 7942,
  [8062] = 7975,
  [8063] = 7958,
  [8064] = 7936,
  [8065] = 7945,
  [8066] = 7946,
  [8067] = 7947,
  [8068] = 7964,
  [8069] = 7975,
  [8070] = 7960,
  [8071] = 7947,
  [8072] = 8072,
  [8073] = 7946,
  [8074] = 7945,
  [8075] = 7956,
  [8076] = 8076,
  [8077] = 7962,
  [8078] = 7952,
  [8079] = 7953,
  [8080] = 7965,
  [8081] = 7940,
  [8082] = 7967,
  [8083] = 7944,
  [8084] = 7939,
  [8085] = 7962,
  [8086] = 7936,
  [8087] = 7958,
  [8088] = 8015,
  [8089] = 7958,
  [8090] = 7944,
  [8091] = 7940,
  [8092] = 7958,
  [8093] = 7988,
  [8094] = 7986,
  [8095] = 7958,
  [8096] = 7958,
  [8097] = 8097,
  [8098] = 7942,
  [8099] = 8099,
  [8100] = 7956,
  [8101] = 8101,
  [8102] = 7960,
  [8103] = 8004,
  [8104] = 7948,
  [8105] = 7957,
  [8106] = 7965,
  [8107] = 7956,
  [8108] = 7960,
  [8109] = 7953,
  [8110] = 7952,
  [8111] = 7962,
  [8112] = 7942,
  [8113] = 7950,
  [8114] = 8114,
  [8115] = 7968,
  [8116] = 7937,
  [8117] = 7975,
  [8118] = 7945,
  [8119] = 7940,
  [8120] = 7946,
  [8121] = 7947,
  [8122] = 8122,
  [8123] = 8015,
  [8124] = 8124,
  [8125] = 8125,
  [8126] = 7944,
  [8127] = 7961,
  [8128] = 7984,
  [8129] = 8129,
  [8130] = 7942,
  [8131] = 7953,
  [8132] = 7986,
  [8133] = 8015,
  [8134] = 8134,
  [8135] = 7988,
  [8136] = 8136,
  [8137] = 8137,
  [8138] = 8004,
  [8139] = 7962,
  [8140] = 8002,
  [8141] = 7957,
  [8142] = 7967,
  [8143] = 8143,
  [8144] = 8144,
  [8145] = 8145,
  [8146] = 7967,
  [8147] = 7959,
  [8148] = 8148,
  [8149] = 8149,
  [8150] = 8150,
  [8151] = 8151,
  [8152] = 7949,
  [8153] = 7945,
  [8154] = 8154,
  [8155] = 7943,
  [8156] = 8008,
  [8157] = 7995,
  [8158] = 7946,
  [8159] = 7947,
  [8160] = 7984,
  [8161] = 7952,
  [8162] = 7953,
  [8163] = 7965,
  [8164] = 7936,
  [8165] = 7978,
  [8166] = 8166,
  [8167] = 8167,
  [8168] = 8168,
  [8169] = 7991,
  [8170] = 7941,
  [8171] = 7939,
  [8172] = 7990,
  [8173] = 8173,
  [8174] = 7988,
  [8175] = 7986,
  [8176] = 8176,
  [8177] = 7957,
  [8178] = 7944,
  [8179] = 7965,
  [8180] = 7953,
  [8181] = 7952,
  [8182] = 7950,
  [8183] = 7959,
  [8184] = 7940,
  [8185] = 7968,
  [8186] = 7937,
  [8187] = 7937,
  [8188] = 7950,
  [8189] = 7952,
  [8190] = 7953,
  [8191] = 7959,
  [8192] = 7965,
  [8193] = 7939,
  [8194] = 7944,
  [8195] = 7941,
  [8196] = 7943,
  [8197] = 7943,
  [8198] = 7959,
  [8199] = 7939,
  [8200] = 7949,
  [8201] = 7937,
  [8202] = 7965,
  [8203] = 7956,
  [8204] = 7955,
  [8205] = 7942,
  [8206] = 7952,
  [8207] = 7950,
  [8208] = 7968,
  [8209] = 7937,
  [8210] = 7959,
  [8211] = 7967,
  [8212] = 7950,
  [8213] = 7986,
  [8214] = 7957,
  [8215] = 7988,
  [8216] = 7952,
  [8217] = 7953,
  [8218] = 7965,
  [8219] = 7936,
  [8220] = 7967,
  [8221] = 8221,
  [8222] = 8222,
  [8223] = 7947,
  [8224] = 7990,
  [8225] = 7946,
  [8226] = 7991,
  [8227] = 7945,
  [8228] = 8228,
  [8229] = 8229,
  [8230] = 7952,
  [8231] = 7953,
  [8232] = 7965,
  [8233] = 7995,
  [8234] = 7967,
  [8235] = 8008,
  [8236] = 7967,
  [8237] = 7947,
  [8238] = 7962,
  [8239] = 8004,
  [8240] = 7939,
  [8241] = 7990,
  [8242] = 7991,
  [8243] = 7941,
  [8244] = 8244,
  [8245] = 7943,
  [8246] = 8246,
  [8247] = 8247,
  [8248] = 8248,
  [8249] = 7944,
  [8250] = 7942,
  [8251] = 7940,
  [8252] = 7942,
  [8253] = 7960,
  [8254] = 7968,
  [8255] = 7967,
  [8256] = 7952,
  [8257] = 7953,
  [8258] = 7965,
  [8259] = 8259,
  [8260] = 8260,
  [8261] = 8261,
  [8262] = 8262,
  [8263] = 2860,
  [8264] = 7986,
  [8265] = 7988,
  [8266] = 7990,
  [8267] = 7991,
  [8268] = 8268,
  [8269] = 7975,
  [8270] = 7978,
  [8271] = 8271,
  [8272] = 7995,
  [8273] = 8273,
  [8274] = 7942,
  [8275] = 8008,
  [8276] = 8276,
  [8277] = 7936,
  [8278] = 7948,
  [8279] = 7967,
  [8280] = 7952,
  [8281] = 7953,
  [8282] = 7965,
  [8283] = 7978,
  [8284] = 8284,
  [8285] = 7942,
  [8286] = 8286,
  [8287] = 7942,
  [8288] = 7984,
  [8289] = 7960,
  [8290] = 8290,
  [8291] = 7946,
  [8292] = 7945,
  [8293] = 7945,
  [8294] = 8294,
  [8295] = 8295,
  [8296] = 7942,
  [8297] = 7946,
  [8298] = 7947,
  [8299] = 7936,
  [8300] = 7967,
  [8301] = 7952,
  [8302] = 7953,
  [8303] = 7965,
  [8304] = 7984,
  [8305] = 8305,
  [8306] = 7975,
  [8307] = 7948,
  [8308] = 8308,
  [8309] = 8008,
  [8310] = 7967,
  [8311] = 7995,
  [8312] = 7991,
  [8313] = 7962,
  [8314] = 7957,
  [8315] = 7990,
  [8316] = 7988,
  [8317] = 7942,
  [8318] = 7986,
  [8319] = 8004,
  [8320] = 7995,
  [8321] = 7967,
  [8322] = 7952,
  [8323] = 7953,
  [8324] = 7965,
  [8325] = 8325,
  [8326] = 8326,
  [8327] = 7968,
  [8328] = 7943,
  [8329] = 7939,
  [8330] = 8330,
  [8331] = 7965,
  [8332] = 7953,
  [8333] = 7952,
  [8334] = 7950,
  [8335] = 7937,
  [8336] = 7959,
  [8337] = 7956,
  [8338] = 7942,
  [8339] = 7958,
  [8340] = 8340,
  [8341] = 7967,
  [8342] = 7952,
  [8343] = 7953,
  [8344] = 7965,
  [8345] = 8345,
  [8346] = 7961,
  [8347] = 8008,
  [8348] = 7940,
  [8349] = 8349,
  [8350] = 8015,
  [8351] = 8351,
  [8352] = 7957,
  [8353] = 7944,
  [8354] = 7958,
  [8355] = 7940,
  [8356] = 8356,
  [8357] = 7936,
  [8358] = 7942,
  [8359] = 7975,
  [8360] = 7961,
  [8361] = 7967,
  [8362] = 7952,
  [8363] = 7953,
  [8364] = 7965,
  [8365] = 7960,
  [8366] = 7956,
  [8367] = 8367,
  [8368] = 7947,
  [8369] = 7946,
  [8370] = 7945,
  [8371] = 8371,
  [8372] = 8372,
  [8373] = 8373,
  [8374] = 8374,
  [8375] = 7942,
  [8376] = 7967,
  [8377] = 8377,
  [8378] = 7942,
  [8379] = 7962,
  [8380] = 8380,
  [8381] = 7967,
  [8382] = 7952,
  [8383] = 7953,
  [8384] = 7965,
  [8385] = 8004,
  [8386] = 7942,
  [8387] = 8387,
  [8388] = 8388,
  [8389] = 8389,
  [8390] = 8390,
  [8391] = 8391,
  [8392] = 8392,
  [8393] = 3002,
  [8394] = 3001,
  [8395] = 8389,
  [8396] = 2944,
  [8397] = 2951,
  [8398] = 2940,
  [8399] = 8387,
  [8400] = 2939,
  [8401] = 2929,
  [8402] = 2928,
  [8403] = 8403,
  [8404] = 2924,
  [8405] = 8405,
  [8406] = 8406,
  [8407] = 8405,
  [8408] = 8405,
  [8409] = 8409,
  [8410] = 8410,
  [8411] = 8390,
  [8412] = 8405,
  [8413] = 8413,
  [8414] = 8405,
  [8415] = 8388,
  [8416] = 8405,
  [8417] = 8405,
  [8418] = 8405,
  [8419] = 8405,
  [8420] = 8405,
  [8421] = 8421,
  [8422] = 8405,
  [8423] = 8387,
  [8424] = 2953,
  [8425] = 8425,
  [8426] = 8405,
  [8427] = 8427,
  [8428] = 8428,
  [8429] = 8425,
  [8430] = 8430,
  [8431] = 8431,
  [8432] = 8427,
  [8433] = 8433,
  [8434] = 8405,
  [8435] = 8405,
  [8436] = 8405,
  [8437] = 8437,
  [8438] = 8438,
  [8439] = 8405,
  [8440] = 8406,
  [8441] = 8391,
  [8442] = 8442,
  [8443] = 8405,
  [8444] = 8444,
  [8445] = 8389,
  [8446] = 8389,
  [8447] = 8403,
  [8448] = 8448,
  [8449] = 8449,
  [8450] = 8413,
  [8451] = 8388,
  [8452] = 8452,
  [8453] = 8453,
  [8454] = 8454,
  [8455] = 8421,
  [8456] = 8391,
  [8457] = 8431,
  [8458] = 8458,
  [8459] = 8459,
  [8460] = 8405,
  [8461] = 8430,
  [8462] = 8462,
  [8463] = 8463,
  [8464] = 8464,
  [8465] = 8458,
  [8466] = 8427,
  [8467] = 8425,
  [8468] = 8468,
  [8469] = 8453,
  [8470] = 8428,
  [8471] = 8468,
  [8472] = 8430,
  [8473] = 8473,
  [8474] = 8389,
  [8475] = 8475,
  [8476] = 8476,
  [8477] = 8405,
  [8478] = 8478,
  [8479] = 8479,
  [8480] = 8431,
  [8481] = 8479,
  [8482] = 8392,
  [8483] = 8483,
  [8484] = 8468,
  [8485] = 8485,
  [8486] = 8392,
  [8487] = 8468,
  [8488] = 8392,
  [8489] = 8389,
  [8490] = 8431,
  [8491] = 8430,
  [8492] = 8454,
  [8493] = 8493,
  [8494] = 8452,
  [8495] = 8475,
  [8496] = 8403,
  [8497] = 8387,
  [8498] = 8391,
  [8499] = 8499,
  [8500] = 8389,
  [8501] = 8431,
  [8502] = 8502,
  [8503] = 8390,
  [8504] = 8504,
  [8505] = 8505,
  [8506] = 8427,
  [8507] = 8458,
  [8508] = 8427,
  [8509] = 8425,
  [8510] = 8389,
  [8511] = 8430,
  [8512] = 8431,
  [8513] = 8513,
  [8514] = 8514,
  [8515] = 8464,
  [8516] = 8452,
  [8517] = 8453,
  [8518] = 8454,
  [8519] = 8458,
  [8520] = 8504,
  [8521] = 8425,
  [8522] = 8464,
  [8523] = 8475,
  [8524] = 8458,
  [8525] = 8525,
  [8526] = 8526,
  [8527] = 8527,
  [8528] = 8458,
  [8529] = 8529,
  [8530] = 8454,
  [8531] = 8453,
  [8532] = 8532,
  [8533] = 8533,
  [8534] = 8534,
  [8535] = 8454,
  [8536] = 8536,
  [8537] = 8454,
  [8538] = 8505,
  [8539] = 8458,
  [8540] = 8459,
  [8541] = 8541,
  [8542] = 8453,
  [8543] = 8543,
  [8544] = 8544,
  [8545] = 8392,
  [8546] = 8427,
  [8547] = 8547,
  [8548] = 8425,
  [8549] = 8549,
  [8550] = 8452,
  [8551] = 8479,
  [8552] = 8552,
  [8553] = 8553,
  [8554] = 8390,
  [8555] = 8555,
  [8556] = 8468,
  [8557] = 8475,
  [8558] = 8392,
  [8559] = 8431,
  [8560] = 8560,
  [8561] = 8388,
  [8562] = 8430,
  [8563] = 8389,
  [8564] = 8468,
  [8565] = 8442,
  [8566] = 8458,
  [8567] = 8403,
  [8568] = 8493,
  [8569] = 8502,
  [8570] = 8387,
  [8571] = 8431,
  [8572] = 8430,
  [8573] = 8391,
  [8574] = 8389,
  [8575] = 8438,
  [8576] = 8427,
  [8577] = 8425,
  [8578] = 8390,
  [8579] = 8513,
  [8580] = 8464,
  [8581] = 8438,
  [8582] = 8390,
  [8583] = 8583,
  [8584] = 8584,
  [8585] = 8505,
  [8586] = 8410,
  [8587] = 8438,
  [8588] = 8431,
  [8589] = 8427,
  [8590] = 8421,
  [8591] = 8430,
  [8592] = 8458,
  [8593] = 8448,
  [8594] = 8428,
  [8595] = 8504,
  [8596] = 8454,
  [8597] = 8453,
  [8598] = 8505,
  [8599] = 8464,
  [8600] = 8513,
  [8601] = 8452,
  [8602] = 8409,
  [8603] = 8389,
  [8604] = 8463,
  [8605] = 8403,
  [8606] = 8452,
  [8607] = 8438,
  [8608] = 8387,
  [8609] = 8421,
  [8610] = 8406,
  [8611] = 8425,
  [8612] = 8391,
  [8613] = 8438,
  [8614] = 8479,
  [8615] = 8452,
  [8616] = 8391,
  [8617] = 8504,
  [8618] = 8458,
  [8619] = 8454,
  [8620] = 8454,
  [8621] = 8389,
  [8622] = 8505,
  [8623] = 8458,
  [8624] = 8502,
  [8625] = 8442,
  [8626] = 8463,
  [8627] = 8464,
  [8628] = 8427,
  [8629] = 8425,
  [8630] = 8438,
  [8631] = 8475,
  [8632] = 8421,
  [8633] = 8633,
  [8634] = 8406,
  [8635] = 8635,
  [8636] = 8387,
  [8637] = 8637,
  [8638] = 8427,
  [8639] = 8425,
  [8640] = 8459,
  [8641] = 8504,
  [8642] = 8642,
  [8643] = 8505,
  [8644] = 8390,
  [8645] = 8410,
  [8646] = 8390,
  [8647] = 8647,
  [8648] = 8389,
  [8649] = 8403,
  [8650] = 8403,
  [8651] = 8430,
  [8652] = 8389,
  [8653] = 8463,
  [8654] = 8410,
  [8655] = 8391,
  [8656] = 8390,
  [8657] = 8438,
  [8658] = 8421,
  [8659] = 8406,
  [8660] = 8475,
  [8661] = 8410,
  [8662] = 8425,
  [8663] = 8663,
  [8664] = 8387,
  [8665] = 8427,
  [8666] = 8459,
  [8667] = 8403,
  [8668] = 8504,
  [8669] = 8409,
  [8670] = 8392,
  [8671] = 8431,
  [8672] = 8409,
  [8673] = 8431,
  [8674] = 8390,
  [8675] = 8505,
  [8676] = 8499,
  [8677] = 8389,
  [8678] = 8428,
  [8679] = 8463,
  [8680] = 8479,
  [8681] = 8463,
  [8682] = 8430,
  [8683] = 8499,
  [8684] = 8684,
  [8685] = 8685,
  [8686] = 8442,
  [8687] = 8438,
  [8688] = 8431,
  [8689] = 8421,
  [8690] = 8413,
  [8691] = 8428,
  [8692] = 8406,
  [8693] = 8448,
  [8694] = 8430,
  [8695] = 8464,
  [8696] = 8458,
  [8697] = 8479,
  [8698] = 8454,
  [8699] = 8448,
  [8700] = 8428,
  [8701] = 8459,
  [8702] = 8702,
  [8703] = 8504,
  [8704] = 8452,
  [8705] = 8430,
  [8706] = 8505,
  [8707] = 8499,
  [8708] = 8513,
  [8709] = 8463,
  [8710] = 8403,
  [8711] = 8387,
  [8712] = 8453,
  [8713] = 8454,
  [8714] = 8448,
  [8715] = 8431,
  [8716] = 8442,
  [8717] = 8438,
  [8718] = 8431,
  [8719] = 8458,
  [8720] = 8391,
  [8721] = 8427,
  [8722] = 8425,
  [8723] = 8723,
  [8724] = 8421,
  [8725] = 8389,
  [8726] = 8388,
  [8727] = 8468,
  [8728] = 8403,
  [8729] = 8406,
  [8730] = 8413,
  [8731] = 8427,
  [8732] = 8413,
  [8733] = 8390,
  [8734] = 8388,
  [8735] = 8406,
  [8736] = 8390,
  [8737] = 8425,
  [8738] = 8389,
  [8739] = 8421,
  [8740] = 8425,
  [8741] = 8427,
  [8742] = 8468,
  [8743] = 8464,
  [8744] = 8464,
  [8745] = 8388,
  [8746] = 8431,
  [8747] = 8513,
  [8748] = 8431,
  [8749] = 8459,
  [8750] = 8392,
  [8751] = 8504,
  [8752] = 8438,
  [8753] = 8442,
  [8754] = 8448,
  [8755] = 8502,
  [8756] = 8452,
  [8757] = 8505,
  [8758] = 8499,
  [8759] = 8454,
  [8760] = 8430,
  [8761] = 8463,
  [8762] = 8458,
  [8763] = 8403,
  [8764] = 8464,
  [8765] = 8463,
  [8766] = 8475,
  [8767] = 8502,
  [8768] = 8448,
  [8769] = 8442,
  [8770] = 8438,
  [8771] = 8431,
  [8772] = 8392,
  [8773] = 8421,
  [8774] = 8499,
  [8775] = 8505,
  [8776] = 8776,
  [8777] = 8777,
  [8778] = 8430,
  [8779] = 8504,
  [8780] = 8459,
  [8781] = 8409,
  [8782] = 8431,
  [8783] = 8389,
  [8784] = 8406,
  [8785] = 8413,
  [8786] = 8786,
  [8787] = 8787,
  [8788] = 8788,
  [8789] = 8789,
  [8790] = 8790,
  [8791] = 8791,
  [8792] = 8792,
  [8793] = 8793,
  [8794] = 8794,
  [8795] = 8795,
  [8796] = 8796,
  [8797] = 8797,
  [8798] = 8798,
  [8799] = 8799,
  [8800] = 8786,
  [8801] = 8801,
  [8802] = 8802,
  [8803] = 8803,
  [8804] = 8791,
  [8805] = 8805,
  [8806] = 8806,
  [8807] = 8790,
  [8808] = 8808,
  [8809] = 8809,
  [8810] = 8789,
  [8811] = 8811,
  [8812] = 8812,
  [8813] = 8788,
  [8814] = 8798,
  [8815] = 8815,
  [8816] = 8816,
  [8817] = 8817,
  [8818] = 8797,
  [8819] = 8794,
  [8820] = 8820,
  [8821] = 8821,
  [8822] = 8822,
  [8823] = 8823,
  [8824] = 8824,
  [8825] = 8825,
  [8826] = 8826,
  [8827] = 8827,
  [8828] = 8828,
  [8829] = 7562,
  [8830] = 8815,
  [8831] = 8831,
  [8832] = 8832,
  [8833] = 8833,
  [8834] = 8834,
  [8835] = 8835,
  [8836] = 8836,
  [8837] = 8837,
  [8838] = 8838,
  [8839] = 8839,
  [8840] = 8840,
  [8841] = 8841,
  [8842] = 8794,
  [8843] = 8843,
  [8844] = 8844,
  [8845] = 8803,
  [8846] = 8816,
  [8847] = 8817,
  [8848] = 8848,
  [8849] = 8839,
  [8850] = 8850,
  [8851] = 8851,
  [8852] = 8852,
  [8853] = 8853,
  [8854] = 8854,
  [8855] = 8855,
  [8856] = 8856,
  [8857] = 8857,
  [8858] = 8803,
  [8859] = 8859,
  [8860] = 8860,
  [8861] = 8861,
  [8862] = 8862,
  [8863] = 8863,
  [8864] = 8864,
  [8865] = 8796,
  [8866] = 8866,
  [8867] = 8867,
  [8868] = 8854,
  [8869] = 8869,
  [8870] = 8870,
  [8871] = 8871,
  [8872] = 8867,
  [8873] = 8873,
  [8874] = 8874,
  [8875] = 8875,
  [8876] = 8876,
  [8877] = 8854,
  [8878] = 8878,
  [8879] = 8821,
  [8880] = 8880,
  [8881] = 8838,
  [8882] = 8882,
  [8883] = 8792,
  [8884] = 8884,
  [8885] = 8885,
  [8886] = 8886,
  [8887] = 8887,
  [8888] = 8888,
  [8889] = 8787,
  [8890] = 8843,
  [8891] = 8891,
  [8892] = 8892,
  [8893] = 8893,
  [8894] = 8894,
  [8895] = 8816,
  [8896] = 8896,
  [8897] = 8897,
  [8898] = 8898,
  [8899] = 8899,
  [8900] = 8900,
  [8901] = 8857,
  [8902] = 8863,
  [8903] = 8786,
  [8904] = 8864,
  [8905] = 8905,
  [8906] = 8857,
  [8907] = 8907,
  [8908] = 8806,
  [8909] = 8812,
  [8910] = 8808,
  [8911] = 8911,
  [8912] = 8852,
  [8913] = 8913,
  [8914] = 8887,
  [8915] = 8888,
  [8916] = 8863,
  [8917] = 8917,
  [8918] = 8918,
  [8919] = 8834,
  [8920] = 8835,
  [8921] = 8921,
  [8922] = 8922,
  [8923] = 8820,
  [8924] = 8924,
  [8925] = 8844,
  [8926] = 8918,
  [8927] = 8921,
  [8928] = 8864,
  [8929] = 8844,
  [8930] = 8822,
  [8931] = 8931,
  [8932] = 8835,
  [8933] = 8834,
  [8934] = 8934,
  [8935] = 8917,
  [8936] = 8852,
  [8937] = 8937,
  [8938] = 8938,
  [8939] = 8913,
  [8940] = 8874,
  [8941] = 8875,
  [8942] = 8911,
  [8943] = 8905,
  [8944] = 8937,
  [8945] = 8945,
  [8946] = 8811,
  [8947] = 8947,
  [8948] = 8809,
  [8949] = 8811,
  [8950] = 8802,
  [8951] = 8809,
  [8952] = 8799,
  [8953] = 8802,
  [8954] = 8867,
  [8955] = 8841,
  [8956] = 8799,
  [8957] = 8957,
  [8958] = 8958,
  [8959] = 8959,
  [8960] = 8960,
  [8961] = 8961,
  [8962] = 8838,
  [8963] = 8882,
  [8964] = 8792,
  [8965] = 8965,
  [8966] = 8824,
  [8967] = 8967,
  [8968] = 8968,
  [8969] = 8821,
  [8970] = 8871,
  [8971] = 8843,
  [8972] = 8972,
  [8973] = 8811,
  [8974] = 8892,
  [8975] = 8827,
  [8976] = 8976,
  [8977] = 8787,
  [8978] = 8957,
  [8979] = 8787,
  [8980] = 8980,
  [8981] = 8786,
  [8982] = 8982,
  [8983] = 8892,
  [8984] = 8806,
  [8985] = 8985,
  [8986] = 8808,
  [8987] = 8980,
  [8988] = 8834,
  [8989] = 8985,
  [8990] = 8875,
  [8991] = 8864,
  [8992] = 8894,
  [8993] = 8844,
  [8994] = 8799,
  [8995] = 8857,
  [8996] = 8896,
  [8997] = 8802,
  [8998] = 8809,
  [8999] = 8852,
  [9000] = 8918,
  [9001] = 8787,
  [9002] = 8921,
  [9003] = 8839,
  [9004] = 8958,
  [9005] = 8816,
  [9006] = 8900,
  [9007] = 8937,
  [9008] = 8833,
  [9009] = 8839,
  [9010] = 8851,
  [9011] = 9011,
  [9012] = 8862,
  [9013] = 8867,
  [9014] = 8960,
  [9015] = 8838,
  [9016] = 8958,
  [9017] = 8850,
  [9018] = 8911,
  [9019] = 8850,
  [9020] = 8792,
  [9021] = 9021,
  [9022] = 9022,
  [9023] = 8918,
  [9024] = 8965,
  [9025] = 9025,
  [9026] = 8843,
  [9027] = 8913,
  [9028] = 8841,
  [9029] = 8811,
  [9030] = 9030,
  [9031] = 8809,
  [9032] = 8882,
  [9033] = 8838,
  [9034] = 8882,
  [9035] = 8786,
  [9036] = 8884,
  [9037] = 8802,
  [9038] = 8806,
  [9039] = 8799,
  [9040] = 8808,
  [9041] = 9030,
  [9042] = 8834,
  [9043] = 9043,
  [9044] = 9044,
  [9045] = 9045,
  [9046] = 9046,
  [9047] = 8793,
  [9048] = 6504,
  [9049] = 9049,
  [9050] = 9050,
  [9051] = 9051,
  [9052] = 9052,
  [9053] = 8792,
  [9054] = 8934,
  [9055] = 8913,
  [9056] = 9056,
  [9057] = 9025,
  [9058] = 8867,
  [9059] = 8968,
  [9060] = 8841,
  [9061] = 9061,
  [9062] = 8794,
  [9063] = 8921,
  [9064] = 8792,
  [9065] = 8803,
  [9066] = 8892,
  [9067] = 9067,
  [9068] = 8816,
  [9069] = 8817,
  [9070] = 8843,
  [9071] = 8918,
  [9072] = 8921,
  [9073] = 8786,
  [9074] = 8839,
  [9075] = 8793,
  [9076] = 8851,
  [9077] = 9077,
  [9078] = 6502,
  [9079] = 8816,
  [9080] = 8985,
  [9081] = 8918,
  [9082] = 8806,
  [9083] = 8924,
  [9084] = 8808,
  [9085] = 8884,
  [9086] = 8834,
  [9087] = 8838,
  [9088] = 8882,
  [9089] = 9030,
  [9090] = 8857,
  [9091] = 9091,
  [9092] = 8863,
  [9093] = 8913,
  [9094] = 8864,
  [9095] = 9025,
  [9096] = 8980,
  [9097] = 8924,
  [9098] = 9098,
  [9099] = 9099,
  [9100] = 8817,
  [9101] = 9045,
  [9102] = 8867,
  [9103] = 8911,
  [9104] = 9104,
  [9105] = 9105,
  [9106] = 8911,
  [9107] = 9107,
  [9108] = 8792,
  [9109] = 8874,
  [9110] = 8892,
  [9111] = 8875,
  [9112] = 8787,
  [9113] = 8900,
  [9114] = 8843,
  [9115] = 8821,
  [9116] = 9061,
  [9117] = 8875,
  [9118] = 8913,
  [9119] = 8934,
  [9120] = 8896,
  [9121] = 9045,
  [9122] = 8786,
  [9123] = 8960,
  [9124] = 8934,
  [9125] = 8806,
  [9126] = 8857,
  [9127] = 8808,
  [9128] = 8921,
  [9129] = 8834,
  [9130] = 8839,
  [9131] = 9061,
  [9132] = 8894,
  [9133] = 9133,
  [9134] = 8816,
  [9135] = 8892,
  [9136] = 8857,
  [9137] = 8863,
  [9138] = 8894,
  [9139] = 9139,
  [9140] = 8796,
  [9141] = 8841,
  [9142] = 8821,
  [9143] = 8896,
  [9144] = 8867,
  [9145] = 8965,
  [9146] = 8957,
  [9147] = 8921,
  [9148] = 8864,
  [9149] = 8905,
  [9150] = 8850,
  [9151] = 8900,
  [9152] = 8911,
  [9153] = 8843,
  [9154] = 9025,
  [9155] = 9067,
  [9156] = 8913,
  [9157] = 8958,
  [9158] = 8960,
  [9159] = 8875,
  [9160] = 8862,
  [9161] = 8874,
  [9162] = 8806,
  [9163] = 8938,
  [9164] = 8808,
  [9165] = 9030,
  [9166] = 9166,
  [9167] = 8931,
  [9168] = 9168,
  [9169] = 8811,
  [9170] = 8867,
  [9171] = 8924,
  [9172] = 8811,
  [9173] = 8924,
  [9174] = 8843,
  [9175] = 8985,
  [9176] = 8980,
  [9177] = 8808,
  [9178] = 8918,
  [9179] = 8918,
  [9180] = 9180,
  [9181] = 8812,
  [9182] = 8867,
  [9183] = 8871,
  [9184] = 8931,
  [9185] = 8843,
  [9186] = 8905,
  [9187] = 8808,
  [9188] = 8864,
  [9189] = 8863,
  [9190] = 9190,
  [9191] = 8867,
  [9192] = 8843,
  [9193] = 8808,
  [9194] = 8921,
  [9195] = 8843,
  [9196] = 8808,
  [9197] = 8857,
  [9198] = 8843,
  [9199] = 8808,
  [9200] = 8843,
  [9201] = 8808,
  [9202] = 8843,
  [9203] = 8808,
  [9204] = 8843,
  [9205] = 8808,
  [9206] = 8843,
  [9207] = 8808,
  [9208] = 8843,
  [9209] = 8808,
  [9210] = 9210,
  [9211] = 8934,
  [9212] = 8961,
  [9213] = 9213,
  [9214] = 8799,
  [9215] = 9215,
  [9216] = 9216,
  [9217] = 8871,
  [9218] = 8802,
  [9219] = 9219,
  [9220] = 9030,
  [9221] = 9221,
  [9222] = 9222,
  [9223] = 8809,
  [9224] = 8811,
  [9225] = 8945,
  [9226] = 9226,
  [9227] = 8811,
  [9228] = 8937,
  [9229] = 9229,
  [9230] = 8931,
  [9231] = 9231,
  [9232] = 8913,
  [9233] = 8808,
  [9234] = 8917,
  [9235] = 9025,
  [9236] = 8806,
  [9237] = 8972,
  [9238] = 8841,
  [9239] = 8947,
  [9240] = 8867,
  [9241] = 8911,
  [9242] = 8911,
  [9243] = 9243,
  [9244] = 8801,
  [9245] = 8893,
  [9246] = 8900,
  [9247] = 8799,
  [9248] = 8802,
  [9249] = 9045,
  [9250] = 8809,
  [9251] = 8961,
  [9252] = 8888,
  [9253] = 8887,
  [9254] = 8884,
  [9255] = 8787,
  [9256] = 8924,
  [9257] = 9257,
  [9258] = 9258,
  [9259] = 8959,
  [9260] = 8913,
  [9261] = 9077,
  [9262] = 8921,
  [9263] = 9263,
  [9264] = 9264,
  [9265] = 8937,
  [9266] = 8787,
  [9267] = 8938,
  [9268] = 8796,
  [9269] = 8862,
  [9270] = 8896,
  [9271] = 8918,
  [9272] = 8851,
  [9273] = 9273,
  [9274] = 9274,
  [9275] = 8894,
  [9276] = 8811,
  [9277] = 8874,
  [9278] = 8873,
  [9279] = 9279,
  [9280] = 8892,
  [9281] = 8882,
  [9282] = 8786,
  [9283] = 9273,
  [9284] = 8799,
  [9285] = 8802,
  [9286] = 8851,
  [9287] = 8821,
  [9288] = 8809,
  [9289] = 9289,
  [9290] = 8965,
  [9291] = 9291,
  [9292] = 8913,
  [9293] = 8957,
  [9294] = 8839,
  [9295] = 8875,
  [9296] = 8839,
  [9297] = 8806,
  [9298] = 8808,
  [9299] = 8833,
  [9300] = 9300,
  [9301] = 8827,
  [9302] = 8911,
  [9303] = 8824,
  [9304] = 8892,
  [9305] = 8875,
  [9306] = 8874,
  [9307] = 8822,
  [9308] = 8787,
  [9309] = 8794,
  [9310] = 8803,
  [9311] = 8820,
  [9312] = 8817,
  [9313] = 8816,
  [9314] = 6510,
  [9315] = 8817,
  [9316] = 8816,
  [9317] = 8875,
  [9318] = 8839,
  [9319] = 9319,
  [9320] = 9320,
  [9321] = 8833,
  [9322] = 8851,
  [9323] = 8815,
  [9324] = 9324,
  [9325] = 9325,
  [9326] = 8931,
  [9327] = 8788,
  [9328] = 8924,
  [9329] = 8857,
  [9330] = 8863,
  [9331] = 9331,
  [9332] = 8864,
  [9333] = 8789,
  [9334] = 8857,
  [9335] = 9335,
  [9336] = 9336,
  [9337] = 9337,
  [9338] = 8790,
  [9339] = 9339,
  [9340] = 8874,
  [9341] = 9341,
  [9342] = 9342,
  [9343] = 8875,
  [9344] = 8791,
  [9345] = 8816,
  [9346] = 8821,
  [9347] = 8824,
  [9348] = 8816,
  [9349] = 8822,
  [9350] = 8787,
  [9351] = 8820,
  [9352] = 8798,
  [9353] = 8797,
  [9354] = 8892,
  [9355] = 8894,
  [9356] = 8896,
  [9357] = 9357,
  [9358] = 8905,
  [9359] = 9359,
  [9360] = 9360,
  [9361] = 9361,
  [9362] = 8864,
  [9363] = 8794,
  [9364] = 8900,
  [9365] = 8843,
  [9366] = 8957,
  [9367] = 9367,
  [9368] = 9368,
  [9369] = 8945,
  [9370] = 9370,
  [9371] = 8827,
  [9372] = 8913,
  [9373] = 8863,
  [9374] = 9374,
  [9375] = 8911,
  [9376] = 9025,
  [9377] = 9377,
  [9378] = 9378,
  [9379] = 8913,
  [9380] = 9380,
  [9381] = 9030,
  [9382] = 8857,
  [9383] = 9383,
  [9384] = 8900,
  [9385] = 8817,
  [9386] = 8816,
  [9387] = 8918,
  [9388] = 9388,
  [9389] = 8965,
  [9390] = 9390,
  [9391] = 9291,
  [9392] = 9392,
  [9393] = 8884,
  [9394] = 9213,
  [9395] = 9216,
  [9396] = 9219,
  [9397] = 8921,
  [9398] = 9221,
  [9399] = 8792,
  [9400] = 8811,
  [9401] = 9401,
  [9402] = 9402,
  [9403] = 8972,
  [9404] = 8937,
  [9405] = 8947,
  [9406] = 8882,
  [9407] = 9407,
  [9408] = 9408,
  [9409] = 8801,
  [9410] = 8893,
  [9411] = 9411,
  [9412] = 8913,
  [9413] = 9077,
  [9414] = 8838,
  [9415] = 8934,
  [9416] = 9045,
  [9417] = 8873,
  [9418] = 9273,
  [9419] = 8938,
  [9420] = 8874,
  [9421] = 9213,
  [9422] = 9219,
  [9423] = 9423,
  [9424] = 9221,
  [9425] = 8843,
  [9426] = 8841,
  [9427] = 8972,
  [9428] = 9428,
  [9429] = 8947,
  [9430] = 8875,
  [9431] = 8821,
  [9432] = 8801,
  [9433] = 8893,
  [9434] = 8850,
  [9435] = 9077,
  [9436] = 8851,
  [9437] = 9437,
  [9438] = 8854,
  [9439] = 8873,
  [9440] = 9273,
  [9441] = 8815,
  [9442] = 9442,
  [9443] = 9213,
  [9444] = 9219,
  [9445] = 8839,
  [9446] = 9221,
  [9447] = 8985,
  [9448] = 8817,
  [9449] = 8972,
  [9450] = 8816,
  [9451] = 8947,
  [9452] = 8803,
  [9453] = 8871,
  [9454] = 8801,
  [9455] = 8893,
  [9456] = 9077,
  [9457] = 8794,
  [9458] = 8799,
  [9459] = 8788,
  [9460] = 8873,
  [9461] = 9273,
  [9462] = 8802,
  [9463] = 9213,
  [9464] = 9219,
  [9465] = 8809,
  [9466] = 9221,
  [9467] = 8917,
  [9468] = 8789,
  [9469] = 8972,
  [9470] = 8947,
  [9471] = 8811,
  [9472] = 8787,
  [9473] = 8801,
  [9474] = 8893,
  [9475] = 9077,
  [9476] = 8787,
  [9477] = 8937,
  [9478] = 8790,
  [9479] = 8873,
  [9480] = 9273,
  [9481] = 8791,
  [9482] = 9213,
  [9483] = 9219,
  [9484] = 8864,
  [9485] = 9221,
  [9486] = 8803,
  [9487] = 8857,
  [9488] = 8947,
  [9489] = 8812,
  [9490] = 8887,
  [9491] = 8801,
  [9492] = 8893,
  [9493] = 9077,
  [9494] = 8888,
  [9495] = 8892,
  [9496] = 8887,
  [9497] = 8873,
  [9498] = 9273,
  [9499] = 9499,
  [9500] = 9213,
  [9501] = 9219,
  [9502] = 8937,
  [9503] = 9221,
  [9504] = 9504,
  [9505] = 9505,
  [9506] = 8947,
  [9507] = 8888,
  [9508] = 8816,
  [9509] = 8801,
  [9510] = 8893,
  [9511] = 9077,
  [9512] = 8894,
  [9513] = 8961,
  [9514] = 8811,
  [9515] = 8873,
  [9516] = 9273,
  [9517] = 8809,
  [9518] = 9213,
  [9519] = 8802,
  [9520] = 9221,
  [9521] = 8799,
  [9522] = 9522,
  [9523] = 8894,
  [9524] = 9524,
  [9525] = 8801,
  [9526] = 8893,
  [9527] = 8871,
  [9528] = 8980,
  [9529] = 8985,
  [9530] = 8873,
  [9531] = 8794,
  [9532] = 9213,
  [9533] = 9221,
  [9534] = 9534,
  [9535] = 8893,
  [9536] = 8803,
  [9537] = 8816,
  [9538] = 8873,
  [9539] = 8896,
  [9540] = 9213,
  [9541] = 9221,
  [9542] = 8803,
  [9543] = 8893,
  [9544] = 8817,
  [9545] = 8873,
  [9546] = 9213,
  [9547] = 9221,
  [9548] = 8893,
  [9549] = 8873,
  [9550] = 8893,
  [9551] = 8873,
  [9552] = 8893,
  [9553] = 8873,
  [9554] = 8893,
  [9555] = 8873,
  [9556] = 8893,
  [9557] = 8873,
  [9558] = 8893,
  [9559] = 8873,
  [9560] = 8893,
  [9561] = 8873,
  [9562] = 8893,
  [9563] = 8873,
  [9564] = 8839,
  [9565] = 9565,
  [9566] = 9216,
  [9567] = 9567,
  [9568] = 9568,
  [9569] = 8921,
  [9570] = 8851,
  [9571] = 9045,
  [9572] = 8857,
  [9573] = 9573,
  [9574] = 8900,
  [9575] = 8857,
  [9576] = 8816,
  [9577] = 9577,
  [9578] = 9578,
  [9579] = 9579,
  [9580] = 8894,
  [9581] = 6464,
  [9582] = 9582,
  [9583] = 8959,
  [9584] = 9423,
  [9585] = 8934,
  [9586] = 8960,
  [9587] = 8857,
  [9588] = 9588,
  [9589] = 9589,
  [9590] = 8958,
  [9591] = 8863,
  [9592] = 9592,
  [9593] = 9593,
  [9594] = 8864,
  [9595] = 8798,
  [9596] = 8867,
  [9597] = 8852,
  [9598] = 8797,
  [9599] = 9599,
  [9600] = 9600,
  [9601] = 8924,
  [9602] = 8917,
  [9603] = 8911,
  [9604] = 9568,
  [9605] = 9567,
  [9606] = 8931,
  [9607] = 8811,
  [9608] = 9608,
  [9609] = 9025,
  [9610] = 8937,
  [9611] = 8874,
  [9612] = 8875,
  [9613] = 8945,
  [9614] = 8787,
  [9615] = 9222,
  [9616] = 9221,
  [9617] = 9383,
  [9618] = 8896,
  [9619] = 8821,
  [9620] = 8811,
  [9621] = 8921,
  [9622] = 9622,
  [9623] = 9623,
  [9624] = 9219,
  [9625] = 8844,
  [9626] = 8888,
  [9627] = 8887,
  [9628] = 9216,
  [9629] = 8809,
  [9630] = 8812,
  [9631] = 8802,
  [9632] = 8787,
  [9633] = 8892,
  [9634] = 8794,
  [9635] = 9635,
  [9636] = 9636,
  [9637] = 9637,
  [9638] = 8799,
  [9639] = 9061,
  [9640] = 8896,
  [9641] = 2106,
  [9642] = 9642,
  [9643] = 8787,
  [9644] = 8913,
  [9645] = 8857,
  [9646] = 9216,
  [9647] = 9567,
  [9648] = 9568,
  [9649] = 8871,
  [9650] = 9215,
  [9651] = 8816,
  [9652] = 8959,
  [9653] = 9423,
  [9654] = 9654,
  [9655] = 9655,
  [9656] = 9107,
  [9657] = 9216,
  [9658] = 9567,
  [9659] = 9568,
  [9660] = 8812,
  [9661] = 8934,
  [9662] = 8959,
  [9663] = 9423,
  [9664] = 9664,
  [9665] = 9665,
  [9666] = 8900,
  [9667] = 9216,
  [9668] = 9567,
  [9669] = 9568,
  [9670] = 8980,
  [9671] = 8911,
  [9672] = 8959,
  [9673] = 9423,
  [9674] = 9045,
  [9675] = 9675,
  [9676] = 9213,
  [9677] = 9567,
  [9678] = 9568,
  [9679] = 8985,
  [9680] = 9025,
  [9681] = 8959,
  [9682] = 9423,
  [9683] = 8913,
  [9684] = 2094,
  [9685] = 9567,
  [9686] = 9568,
  [9687] = 9030,
  [9688] = 9030,
  [9689] = 8959,
  [9690] = 9423,
  [9691] = 8850,
  [9692] = 9692,
  [9693] = 9567,
  [9694] = 9568,
  [9695] = 8960,
  [9696] = 8852,
  [9697] = 8959,
  [9698] = 9423,
  [9699] = 8958,
  [9700] = 9700,
  [9701] = 9567,
  [9702] = 9568,
  [9703] = 8793,
  [9704] = 8959,
  [9705] = 9423,
  [9706] = 9337,
  [9707] = 9707,
  [9708] = 8959,
  [9709] = 9423,
  [9710] = 8841,
  [9711] = 9711,
  [9712] = 9423,
  [9713] = 8850,
  [9714] = 9423,
  [9715] = 8918,
  [9716] = 9423,
  [9717] = 8857,
  [9718] = 9423,
  [9719] = 8844,
  [9720] = 9423,
  [9721] = 8816,
  [9722] = 9423,
  [9723] = 9723,
  [9724] = 9423,
  [9725] = 9725,
  [9726] = 9423,
  [9727] = 8841,
  [9728] = 9423,
  [9729] = 9623,
  [9730] = 8880,
  [9731] = 8918,
  [9732] = 9623,
  [9733] = 8880,
  [9734] = 9734,
  [9735] = 9623,
  [9736] = 8880,
  [9737] = 8857,
  [9738] = 9623,
  [9739] = 8880,
  [9740] = 8835,
  [9741] = 9623,
  [9742] = 8880,
  [9743] = 8834,
  [9744] = 9623,
  [9745] = 8880,
  [9746] = 8892,
  [9747] = 9623,
  [9748] = 8880,
  [9749] = 9749,
  [9750] = 8880,
  [9751] = 8880,
  [9752] = 8880,
  [9753] = 8880,
  [9754] = 8880,
  [9755] = 8880,
  [9756] = 8880,
  [9757] = 8880,
  [9758] = 8880,
  [9759] = 8880,
  [9760] = 8880,
  [9761] = 9061,
  [9762] = 9045,
  [9763] = 8816,
  [9764] = 8857,
  [9765] = 8835,
  [9766] = 8934,
  [9767] = 8834,
  [9768] = 9622,
  [9769] = 9622,
  [9770] = 9622,
  [9771] = 9622,
  [9772] = 9622,
  [9773] = 9622,
  [9774] = 9622,
};

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 43312
    ? (c < 3804
      ? (c < 2575
        ? (c < 1568
          ? (c < 248
            ? (c < 'g'
              ? (c < 'S'
                ? (c < 'C'
                  ? (c < 'A'
                    ? c == '$'
                    : c <= 'A')
                  : (c <= 'E' || (c < 'M'
                    ? (c >= 'G' && c <= 'K')
                    : c <= 'Q')))
                : (c <= 'S' || (c < 'a'
                  ? (c < '_'
                    ? (c >= 'V' && c <= 'Z')
                    : c <= '_')
                  : (c <= 'a' || c == 'e'))))
              : (c <= 'h' || (c < 170
                ? (c < 'q'
                  ? (c < 'o'
                    ? (c >= 'j' && c <= 'l')
                    : c <= 'o')
                  : (c <= 'r' || (c >= 'w' && c <= 'z')))
                : (c <= 170 || (c < 192
                  ? (c < 186
                    ? c == 181
                    : c <= 186)
                  : (c <= 214 || (c >= 216 && c <= 246)))))))
            : (c <= 705 || (c < 908
              ? (c < 886
                ? (c < 748
                  ? (c < 736
                    ? (c >= 710 && c <= 721)
                    : c <= 740)
                  : (c <= 748 || (c < 880
                    ? c == 750
                    : c <= 884)))
                : (c <= 887 || (c < 902
                  ? (c < 895
                    ? (c >= 891 && c <= 893)
                    : c <= 895)
                  : (c <= 902 || (c >= 904 && c <= 906)))))
              : (c <= 908 || (c < 1329
                ? (c < 1015
                  ? (c < 931
                    ? (c >= 910 && c <= 929)
                    : c <= 1013)
                  : (c <= 1153 || (c >= 1162 && c <= 1327)))
                : (c <= 1366 || (c < 1488
                  ? (c < 1376
                    ? c == 1369
                    : c <= 1416)
                  : (c <= 1514 || (c >= 1519 && c <= 1522)))))))))
          : (c <= 1610 || (c < 2160
            ? (c < 1969
              ? (c < 1786
                ? (c < 1749
                  ? (c < 1649
                    ? (c >= 1646 && c <= 1647)
                    : c <= 1747)
                  : (c <= 1749 || (c < 1774
                    ? (c >= 1765 && c <= 1766)
                    : c <= 1775)))
                : (c <= 1788 || (c < 1810
                  ? (c < 1808
                    ? c == 1791
                    : c <= 1808)
                  : (c <= 1839 || (c >= 1869 && c <= 1957)))))
              : (c <= 1969 || (c < 2074
                ? (c < 2042
                  ? (c < 2036
                    ? (c >= 1994 && c <= 2026)
                    : c <= 2037)
                  : (c <= 2042 || (c >= 2048 && c <= 2069)))
                : (c <= 2074 || (c < 2112
                  ? (c < 2088
                    ? c == 2084
                    : c <= 2088)
                  : (c <= 2136 || (c >= 2144 && c <= 2154)))))))
            : (c <= 2183 || (c < 2474
              ? (c < 2392
                ? (c < 2308
                  ? (c < 2208
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2249)
                  : (c <= 2361 || (c < 2384
                    ? c == 2365
                    : c <= 2384)))
                : (c <= 2401 || (c < 2447
                  ? (c < 2437
                    ? (c >= 2417 && c <= 2432)
                    : c <= 2444)
                  : (c <= 2448 || (c >= 2451 && c <= 2472)))))
              : (c <= 2480 || (c < 2524
                ? (c < 2493
                  ? (c < 2486
                    ? c == 2482
                    : c <= 2489)
                  : (c <= 2493 || c == 2510))
                : (c <= 2525 || (c < 2556
                  ? (c < 2544
                    ? (c >= 2527 && c <= 2529)
                    : c <= 2545)
                  : (c <= 2556 || (c >= 2565 && c <= 2570)))))))))))
        : (c <= 2576 || (c < 3090
          ? (c < 2835
            ? (c < 2707
              ? (c < 2649
                ? (c < 2610
                  ? (c < 2602
                    ? (c >= 2579 && c <= 2600)
                    : c <= 2608)
                  : (c <= 2611 || (c < 2616
                    ? (c >= 2613 && c <= 2614)
                    : c <= 2617)))
                : (c <= 2652 || (c < 2693
                  ? (c < 2674
                    ? c == 2654
                    : c <= 2676)
                  : (c <= 2701 || (c >= 2703 && c <= 2705)))))
              : (c <= 2728 || (c < 2768
                ? (c < 2741
                  ? (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)
                  : (c <= 2745 || c == 2749))
                : (c <= 2768 || (c < 2821
                  ? (c < 2809
                    ? (c >= 2784 && c <= 2785)
                    : c <= 2809)
                  : (c <= 2828 || (c >= 2831 && c <= 2832)))))))
            : (c <= 2856 || (c < 2962
              ? (c < 2911
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2908
                    ? c == 2877
                    : c <= 2909)))
                : (c <= 2913 || (c < 2949
                  ? (c < 2947
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c >= 2958 && c <= 2960)))))
              : (c <= 2965 || (c < 2984
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c >= 2979 && c <= 2980)))
                : (c <= 2986 || (c < 3077
                  ? (c < 3024
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3024)
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))))))))
          : (c <= 3112 || (c < 3412
            ? (c < 3253
              ? (c < 3200
                ? (c < 3160
                  ? (c < 3133
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3133)
                  : (c <= 3162 || (c < 3168
                    ? c == 3165
                    : c <= 3169)))
                : (c <= 3200 || (c < 3218
                  ? (c < 3214
                    ? (c >= 3205 && c <= 3212)
                    : c <= 3216)
                  : (c <= 3240 || (c >= 3242 && c <= 3251)))))
              : (c <= 3257 || (c < 3332
                ? (c < 3296
                  ? (c < 3293
                    ? c == 3261
                    : c <= 3294)
                  : (c <= 3297 || (c >= 3313 && c <= 3314)))
                : (c <= 3340 || (c < 3389
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3386)
                  : (c <= 3389 || c == 3406))))))
            : (c <= 3414 || (c < 3713
              ? (c < 3517
                ? (c < 3461
                  ? (c < 3450
                    ? (c >= 3423 && c <= 3425)
                    : c <= 3455)
                  : (c <= 3478 || (c < 3507
                    ? (c >= 3482 && c <= 3505)
                    : c <= 3515)))
                : (c <= 3517 || (c < 3634
                  ? (c < 3585
                    ? (c >= 3520 && c <= 3526)
                    : c <= 3632)
                  : (c <= 3634 || (c >= 3648 && c <= 3654)))))
              : (c <= 3714 || (c < 3751
                ? (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || c == 3749))
                : (c <= 3760 || (c < 3776
                  ? (c < 3773
                    ? c == 3762
                    : c <= 3773)
                  : (c <= 3780 || c == 3782))))))))))))
      : (c <= 3807 || (c < 8027
        ? (c < 5888
          ? (c < 4696
            ? (c < 4206
              ? (c < 4159
                ? (c < 3913
                  ? (c < 3904
                    ? c == 3840
                    : c <= 3911)
                  : (c <= 3948 || (c < 4096
                    ? (c >= 3976 && c <= 3980)
                    : c <= 4138)))
                : (c <= 4159 || (c < 4193
                  ? (c < 4186
                    ? (c >= 4176 && c <= 4181)
                    : c <= 4189)
                  : (c <= 4193 || (c >= 4197 && c <= 4198)))))
              : (c <= 4208 || (c < 4301
                ? (c < 4256
                  ? (c < 4238
                    ? (c >= 4213 && c <= 4225)
                    : c <= 4238)
                  : (c <= 4293 || c == 4295))
                : (c <= 4301 || (c < 4682
                  ? (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)
                  : (c <= 4685 || (c >= 4688 && c <= 4694)))))))
            : (c <= 4696 || (c < 4882
              ? (c < 4792
                ? (c < 4746
                  ? (c < 4704
                    ? (c >= 4698 && c <= 4701)
                    : c <= 4744)
                  : (c <= 4749 || (c < 4786
                    ? (c >= 4752 && c <= 4784)
                    : c <= 4789)))
                : (c <= 4798 || (c < 4808
                  ? (c < 4802
                    ? c == 4800
                    : c <= 4805)
                  : (c <= 4822 || (c >= 4824 && c <= 4880)))))
              : (c <= 4885 || (c < 5121
                ? (c < 5024
                  ? (c < 4992
                    ? (c >= 4888 && c <= 4954)
                    : c <= 5007)
                  : (c <= 5109 || (c >= 5112 && c <= 5117)))
                : (c <= 5740 || (c < 5792
                  ? (c < 5761
                    ? (c >= 5743 && c <= 5759)
                    : c <= 5786)
                  : (c <= 5866 || (c >= 5870 && c <= 5880)))))))))
          : (c <= 5905 || (c < 6981
            ? (c < 6320
              ? (c < 6103
                ? (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5937)
                    : c <= 5969)
                  : (c <= 5996 || (c < 6016
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6067)))
                : (c <= 6103 || (c < 6272
                  ? (c < 6176
                    ? c == 6108
                    : c <= 6264)
                  : (c <= 6312 || c == 6314))))
              : (c <= 6389 || (c < 6576
                ? (c < 6512
                  ? (c < 6480
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6509)
                  : (c <= 6516 || (c >= 6528 && c <= 6571)))
                : (c <= 6601 || (c < 6823
                  ? (c < 6688
                    ? (c >= 6656 && c <= 6678)
                    : c <= 6740)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))))))
            : (c <= 6988 || (c < 7406
              ? (c < 7258
                ? (c < 7098
                  ? (c < 7086
                    ? (c >= 7043 && c <= 7072)
                    : c <= 7087)
                  : (c <= 7141 || (c < 7245
                    ? (c >= 7168 && c <= 7203)
                    : c <= 7247)))
                : (c <= 7293 || (c < 7357
                  ? (c < 7312
                    ? (c >= 7296 && c <= 7304)
                    : c <= 7354)
                  : (c <= 7359 || (c >= 7401 && c <= 7404)))))
              : (c <= 7411 || (c < 7960
                ? (c < 7424
                  ? (c < 7418
                    ? (c >= 7413 && c <= 7414)
                    : c <= 7418)
                  : (c <= 7615 || (c >= 7680 && c <= 7957)))
                : (c <= 7965 || (c < 8016
                  ? (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)
                  : (c <= 8023 || c == 8025))))))))))
        : (c <= 8027 || (c < 11712
          ? (c < 8484
            ? (c < 8178
              ? (c < 8130
                ? (c < 8064
                  ? (c < 8031
                    ? c == 8029
                    : c <= 8061)
                  : (c <= 8116 || (c < 8126
                    ? (c >= 8118 && c <= 8124)
                    : c <= 8126)))
                : (c <= 8132 || (c < 8150
                  ? (c < 8144
                    ? (c >= 8134 && c <= 8140)
                    : c <= 8147)
                  : (c <= 8155 || (c >= 8160 && c <= 8172)))))
              : (c <= 8180 || (c < 8450
                ? (c < 8319
                  ? (c < 8305
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8305)
                  : (c <= 8319 || (c >= 8336 && c <= 8348)))
                : (c <= 8450 || (c < 8469
                  ? (c < 8458
                    ? c == 8455
                    : c <= 8467)
                  : (c <= 8469 || (c >= 8472 && c <= 8477)))))))
            : (c <= 8484 || (c < 11520
              ? (c < 8526
                ? (c < 8490
                  ? (c < 8488
                    ? c == 8486
                    : c <= 8488)
                  : (c <= 8505 || (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)))
                : (c <= 8526 || (c < 11499
                  ? (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)
                  : (c <= 11502 || (c >= 11506 && c <= 11507)))))
              : (c <= 11557 || (c < 11648
                ? (c < 11568
                  ? (c < 11565
                    ? c == 11559
                    : c <= 11565)
                  : (c <= 11623 || c == 11631))
                : (c <= 11670 || (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c >= 11704 && c <= 11710)))))))))
          : (c <= 11718 || (c < 42538
            ? (c < 12540
              ? (c < 12337
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12329)))
                : (c <= 12341 || (c < 12445
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12447 || (c >= 12449 && c <= 12538)))))
              : (c <= 12543 || (c < 13312
                ? (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c >= 12784 && c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c >= 42512 && c <= 42527)))))))
            : (c <= 42539 || (c < 42994
              ? (c < 42786
                ? (c < 42656
                  ? (c < 42623
                    ? (c >= 42560 && c <= 42606)
                    : c <= 42653)
                  : (c <= 42735 || (c >= 42775 && c <= 42783)))
                : (c <= 42888 || (c < 42963
                  ? (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)
                  : (c <= 42963 || (c >= 42965 && c <= 42969)))))
              : (c <= 43009 || (c < 43138
                ? (c < 43020
                  ? (c < 43015
                    ? (c >= 43011 && c <= 43013)
                    : c <= 43018)
                  : (c <= 43042 || (c >= 43072 && c <= 43123)))
                : (c <= 43187 || (c < 43261
                  ? (c < 43259
                    ? (c >= 43250 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43262 || (c >= 43274 && c <= 43301)))))))))))))))
    : (c <= 43334 || (c < 70480
      ? (c < 66816
        ? (c < 64323
          ? (c < 43777
            ? (c < 43642
              ? (c < 43514
                ? (c < 43471
                  ? (c < 43396
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43442)
                  : (c <= 43471 || (c < 43494
                    ? (c >= 43488 && c <= 43492)
                    : c <= 43503)))
                : (c <= 43518 || (c < 43588
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43560)
                    : c <= 43586)
                  : (c <= 43595 || (c >= 43616 && c <= 43638)))))
              : (c <= 43642 || (c < 43712
                ? (c < 43701
                  ? (c < 43697
                    ? (c >= 43646 && c <= 43695)
                    : c <= 43697)
                  : (c <= 43702 || (c >= 43705 && c <= 43709)))
                : (c <= 43712 || (c < 43744
                  ? (c < 43739
                    ? c == 43714
                    : c <= 43741)
                  : (c <= 43754 || (c >= 43762 && c <= 43764)))))))
            : (c <= 43782 || (c < 63744
              ? (c < 43868
                ? (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))
                : (c <= 43881 || (c < 55216
                  ? (c < 44032
                    ? (c >= 43888 && c <= 44002)
                    : c <= 55203)
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))))
              : (c <= 64109 || (c < 64287
                ? (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))
                : (c <= 64296 || (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))))))))
          : (c <= 64324 || (c < 65498
            ? (c < 65147
              ? (c < 65008
                ? (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c < 64914
                    ? (c >= 64848 && c <= 64911)
                    : c <= 64967)))
                : (c <= 65017 || (c < 65143
                  ? (c < 65139
                    ? c == 65137
                    : c <= 65139)
                  : (c <= 65143 || c == 65145))))
              : (c <= 65147 || (c < 65382
                ? (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))
                : (c <= 65437 || (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))))))
            : (c <= 65500 || (c < 66304
              ? (c < 65616
                ? (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))
                : (c <= 65629 || (c < 66176
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66204 || (c >= 66208 && c <= 66256)))))
              : (c <= 66335 || (c < 66504
                ? (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66421)
                  : (c <= 66461 || (c >= 66464 && c <= 66499)))
                : (c <= 66511 || (c < 66736
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66771 || (c >= 66776 && c <= 66811)))))))))))
        : (c <= 66855 || (c < 68608
          ? (c < 67647
            ? (c < 67392
              ? (c < 66967
                ? (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))
                : (c <= 66977 || (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c >= 67072 && c <= 67382)))))
              : (c <= 67413 || (c < 67584
                ? (c < 67463
                  ? (c < 67456
                    ? (c >= 67424 && c <= 67431)
                    : c <= 67461)
                  : (c <= 67504 || (c >= 67506 && c <= 67514)))
                : (c <= 67589 || (c < 67639
                  ? (c < 67594
                    ? c == 67592
                    : c <= 67637)
                  : (c <= 67640 || c == 67644))))))
            : (c <= 67669 || (c < 68117
              ? (c < 67872
                ? (c < 67808
                  ? (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)
                  : (c <= 67826 || (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)))
                : (c <= 67897 || (c < 68096
                  ? (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)
                  : (c <= 68096 || (c >= 68112 && c <= 68115)))))
              : (c <= 68119 || (c < 68297
                ? (c < 68224
                  ? (c < 68192
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68220)
                  : (c <= 68252 || (c >= 68288 && c <= 68295)))
                : (c <= 68324 || (c < 68448
                  ? (c < 68416
                    ? (c >= 68352 && c <= 68405)
                    : c <= 68437)
                  : (c <= 68466 || (c >= 68480 && c <= 68497)))))))))
          : (c <= 68680 || (c < 70006
            ? (c < 69600
              ? (c < 69376
                ? (c < 68864
                  ? (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)
                  : (c <= 68899 || (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)))
                : (c <= 69404 || (c < 69488
                  ? (c < 69424
                    ? c == 69415
                    : c <= 69445)
                  : (c <= 69505 || (c >= 69552 && c <= 69572)))))
              : (c <= 69622 || (c < 69840
                ? (c < 69749
                  ? (c < 69745
                    ? (c >= 69635 && c <= 69687)
                    : c <= 69746)
                  : (c <= 69749 || (c >= 69763 && c <= 69807)))
                : (c <= 69864 || (c < 69959
                  ? (c < 69956
                    ? (c >= 69891 && c <= 69926)
                    : c <= 69956)
                  : (c <= 69959 || (c >= 69968 && c <= 70002)))))))
            : (c <= 70006 || (c < 70287
              ? (c < 70144
                ? (c < 70106
                  ? (c < 70081
                    ? (c >= 70019 && c <= 70066)
                    : c <= 70084)
                  : (c <= 70106 || c == 70108))
                : (c <= 70161 || (c < 70280
                  ? (c < 70272
                    ? (c >= 70163 && c <= 70187)
                    : c <= 70278)
                  : (c <= 70280 || (c >= 70282 && c <= 70285)))))
              : (c <= 70301 || (c < 70419
                ? (c < 70405
                  ? (c < 70320
                    ? (c >= 70303 && c <= 70312)
                    : c <= 70366)
                  : (c <= 70412 || (c >= 70415 && c <= 70416)))
                : (c <= 70440 || (c < 70453
                  ? (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)
                  : (c <= 70457 || c == 70461))))))))))))
      : (c <= 70480 || (c < 119808
        ? (c < 72971
          ? (c < 71957
            ? (c < 71236
              ? (c < 70852
                ? (c < 70727
                  ? (c < 70656
                    ? (c >= 70493 && c <= 70497)
                    : c <= 70708)
                  : (c <= 70730 || (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)))
                : (c <= 70853 || (c < 71128
                  ? (c < 71040
                    ? c == 70855
                    : c <= 71086)
                  : (c <= 71131 || (c >= 71168 && c <= 71215)))))
              : (c <= 71236 || (c < 71680
                ? (c < 71424
                  ? (c < 71352
                    ? (c >= 71296 && c <= 71338)
                    : c <= 71352)
                  : (c <= 71450 || (c >= 71488 && c <= 71494)))
                : (c <= 71723 || (c < 71945
                  ? (c < 71935
                    ? (c >= 71840 && c <= 71903)
                    : c <= 71942)
                  : (c <= 71945 || (c >= 71948 && c <= 71955)))))))
            : (c <= 71958 || (c < 72272
              ? (c < 72161
                ? (c < 72001
                  ? (c < 71999
                    ? (c >= 71960 && c <= 71983)
                    : c <= 71999)
                  : (c <= 72001 || (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)))
                : (c <= 72161 || (c < 72203
                  ? (c < 72192
                    ? c == 72163
                    : c <= 72192)
                  : (c <= 72242 || c == 72250))))
              : (c <= 72272 || (c < 72714
                ? (c < 72368
                  ? (c < 72349
                    ? (c >= 72284 && c <= 72329)
                    : c <= 72349)
                  : (c <= 72440 || (c >= 72704 && c <= 72712)))
                : (c <= 72750 || (c < 72960
                  ? (c < 72818
                    ? c == 72768
                    : c <= 72847)
                  : (c <= 72966 || (c >= 72968 && c <= 72969)))))))))
          : (c <= 73008 || (c < 93053
            ? (c < 77712
              ? (c < 73440
                ? (c < 73063
                  ? (c < 73056
                    ? c == 73030
                    : c <= 73061)
                  : (c <= 73064 || (c < 73112
                    ? (c >= 73066 && c <= 73097)
                    : c <= 73112)))
                : (c <= 73458 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c >= 74880 && c <= 75075)))))
              : (c <= 77808 || (c < 92784
                ? (c < 92160
                  ? (c < 82944
                    ? (c >= 77824 && c <= 78894)
                    : c <= 83526)
                  : (c <= 92728 || (c >= 92736 && c <= 92766)))
                : (c <= 92862 || (c < 92992
                  ? (c < 92928
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92975)
                  : (c <= 92995 || (c >= 93027 && c <= 93047)))))))
            : (c <= 93071 || (c < 110581
              ? (c < 94179
                ? (c < 94032
                  ? (c < 93952
                    ? (c >= 93760 && c <= 93823)
                    : c <= 94026)
                  : (c <= 94032 || (c < 94176
                    ? (c >= 94099 && c <= 94111)
                    : c <= 94177)))
                : (c <= 94179 || (c < 101632
                  ? (c < 100352
                    ? (c >= 94208 && c <= 100343)
                    : c <= 101589)
                  : (c <= 101640 || (c >= 110576 && c <= 110579)))))
              : (c <= 110587 || (c < 110960
                ? (c < 110928
                  ? (c < 110592
                    ? (c >= 110589 && c <= 110590)
                    : c <= 110882)
                  : (c <= 110930 || (c >= 110948 && c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c >= 113808 && c <= 113817)))))))))))
        : (c <= 119892 || (c < 125259
          ? (c < 120540
            ? (c < 120077
              ? (c < 119982
                ? (c < 119970
                  ? (c < 119966
                    ? (c >= 119894 && c <= 119964)
                    : c <= 119967)
                  : (c <= 119970 || (c < 119977
                    ? (c >= 119973 && c <= 119974)
                    : c <= 119980)))
                : (c <= 119993 || (c < 120005
                  ? (c < 119997
                    ? c == 119995
                    : c <= 120003)
                  : (c <= 120069 || (c >= 120071 && c <= 120074)))))
              : (c <= 120084 || (c < 120134
                ? (c < 120123
                  ? (c < 120094
                    ? (c >= 120086 && c <= 120092)
                    : c <= 120121)
                  : (c <= 120126 || (c >= 120128 && c <= 120132)))
                : (c <= 120134 || (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c >= 120514 && c <= 120538)))))))
            : (c <= 120570 || (c < 123191
              ? (c < 120714
                ? (c < 120630
                  ? (c < 120598
                    ? (c >= 120572 && c <= 120596)
                    : c <= 120628)
                  : (c <= 120654 || (c < 120688
                    ? (c >= 120656 && c <= 120686)
                    : c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 43396
    ? (c < 3913
      ? (c < 2613
        ? (c < 1765
          ? (c < 750
            ? (c < 'w'
              ? (c < 'g'
                ? (c < '_'
                  ? (c < 'A'
                    ? c == '$'
                    : c <= 'Z')
                  : (c <= '_' || (c < 'e'
                    ? c == 'a'
                    : c <= 'e')))
                : (c <= 'h' || (c < 'q'
                  ? (c < 'o'
                    ? (c >= 'j' && c <= 'l')
                    : c <= 'o')
                  : (c <= 'r' || c == 't'))))
              : (c <= 'z' || (c < 216
                ? (c < 186
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 186 || (c >= 192 && c <= 214)))
                : (c <= 246 || (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || c == 748))))))
            : (c <= 750 || (c < 1162
              ? (c < 904
                ? (c < 891
                  ? (c < 886
                    ? (c >= 880 && c <= 884)
                    : c <= 887)
                  : (c <= 893 || (c < 902
                    ? c == 895
                    : c <= 902)))
                : (c <= 906 || (c < 931
                  ? (c < 910
                    ? c == 908
                    : c <= 929)
                  : (c <= 1013 || (c >= 1015 && c <= 1153)))))
              : (c <= 1327 || (c < 1519
                ? (c < 1376
                  ? (c < 1369
                    ? (c >= 1329 && c <= 1366)
                    : c <= 1369)
                  : (c <= 1416 || (c >= 1488 && c <= 1514)))
                : (c <= 1522 || (c < 1649
                  ? (c < 1646
                    ? (c >= 1568 && c <= 1610)
                    : c <= 1647)
                  : (c <= 1747 || c == 1749))))))))
          : (c <= 1766 || (c < 2365
            ? (c < 2048
              ? (c < 1869
                ? (c < 1791
                  ? (c < 1786
                    ? (c >= 1774 && c <= 1775)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1810
                    ? c == 1808
                    : c <= 1839)))
                : (c <= 1957 || (c < 2036
                  ? (c < 1994
                    ? c == 1969
                    : c <= 2026)
                  : (c <= 2037 || c == 2042))))
              : (c <= 2069 || (c < 2144
                ? (c < 2088
                  ? (c < 2084
                    ? c == 2074
                    : c <= 2084)
                  : (c <= 2088 || (c >= 2112 && c <= 2136)))
                : (c <= 2154 || (c < 2208
                  ? (c < 2185
                    ? (c >= 2160 && c <= 2183)
                    : c <= 2190)
                  : (c <= 2249 || (c >= 2308 && c <= 2361)))))))
            : (c <= 2365 || (c < 2510
              ? (c < 2451
                ? (c < 2417
                  ? (c < 2392
                    ? c == 2384
                    : c <= 2401)
                  : (c <= 2432 || (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)))
                : (c <= 2472 || (c < 2486
                  ? (c < 2482
                    ? (c >= 2474 && c <= 2480)
                    : c <= 2482)
                  : (c <= 2489 || c == 2493))))
              : (c <= 2510 || (c < 2565
                ? (c < 2544
                  ? (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2529)
                  : (c <= 2545 || c == 2556))
                : (c <= 2570 || (c < 2602
                  ? (c < 2579
                    ? (c >= 2575 && c <= 2576)
                    : c <= 2600)
                  : (c <= 2608 || (c >= 2610 && c <= 2611)))))))))))
        : (c <= 2614 || (c < 3165
          ? (c < 2877
            ? (c < 2749
              ? (c < 2703
                ? (c < 2654
                  ? (c < 2649
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2652)
                  : (c <= 2654 || (c < 2693
                    ? (c >= 2674 && c <= 2676)
                    : c <= 2701)))
                : (c <= 2705 || (c < 2738
                  ? (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)
                  : (c <= 2739 || (c >= 2741 && c <= 2745)))))
              : (c <= 2749 || (c < 2831
                ? (c < 2809
                  ? (c < 2784
                    ? c == 2768
                    : c <= 2785)
                  : (c <= 2809 || (c >= 2821 && c <= 2828)))
                : (c <= 2832 || (c < 2866
                  ? (c < 2858
                    ? (c >= 2835 && c <= 2856)
                    : c <= 2864)
                  : (c <= 2867 || (c >= 2869 && c <= 2873)))))))
            : (c <= 2877 || (c < 2979
              ? (c < 2958
                ? (c < 2929
                  ? (c < 2911
                    ? (c >= 2908 && c <= 2909)
                    : c <= 2913)
                  : (c <= 2929 || (c < 2949
                    ? c == 2947
                    : c <= 2954)))
                : (c <= 2960 || (c < 2972
                  ? (c < 2969
                    ? (c >= 2962 && c <= 2965)
                    : c <= 2970)
                  : (c <= 2972 || (c >= 2974 && c <= 2975)))))
              : (c <= 2980 || (c < 3086
                ? (c < 3024
                  ? (c < 2990
                    ? (c >= 2984 && c <= 2986)
                    : c <= 3001)
                  : (c <= 3024 || (c >= 3077 && c <= 3084)))
                : (c <= 3088 || (c < 3133
                  ? (c < 3114
                    ? (c >= 3090 && c <= 3112)
                    : c <= 3129)
                  : (c <= 3133 || (c >= 3160 && c <= 3162)))))))))
          : (c <= 3165 || (c < 3482
            ? (c < 3313
              ? (c < 3242
                ? (c < 3205
                  ? (c < 3200
                    ? (c >= 3168 && c <= 3169)
                    : c <= 3200)
                  : (c <= 3212 || (c < 3218
                    ? (c >= 3214 && c <= 3216)
                    : c <= 3240)))
                : (c <= 3251 || (c < 3293
                  ? (c < 3261
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3261)
                  : (c <= 3294 || (c >= 3296 && c <= 3297)))))
              : (c <= 3314 || (c < 3406
                ? (c < 3346
                  ? (c < 3342
                    ? (c >= 3332 && c <= 3340)
                    : c <= 3344)
                  : (c <= 3386 || c == 3389))
                : (c <= 3406 || (c < 3450
                  ? (c < 3423
                    ? (c >= 3412 && c <= 3414)
                    : c <= 3425)
                  : (c <= 3455 || (c >= 3461 && c <= 3478)))))))
            : (c <= 3505 || (c < 3724
              ? (c < 3634
                ? (c < 3520
                  ? (c < 3517
                    ? (c >= 3507 && c <= 3515)
                    : c <= 3517)
                  : (c <= 3526 || (c >= 3585 && c <= 3632)))
                : (c <= 3634 || (c < 3716
                  ? (c < 3713
                    ? (c >= 3648 && c <= 3654)
                    : c <= 3714)
                  : (c <= 3716 || (c >= 3718 && c <= 3722)))))
              : (c <= 3747 || (c < 3776
                ? (c < 3762
                  ? (c < 3751
                    ? c == 3749
                    : c <= 3760)
                  : (c <= 3762 || c == 3773))
                : (c <= 3780 || (c < 3840
                  ? (c < 3804
                    ? c == 3782
                    : c <= 3807)
                  : (c <= 3840 || (c >= 3904 && c <= 3911)))))))))))))
      : (c <= 3948 || (c < 8031
        ? (c < 5984
          ? (c < 4746
            ? (c < 4256
              ? (c < 4193
                ? (c < 4159
                  ? (c < 4096
                    ? (c >= 3976 && c <= 3980)
                    : c <= 4138)
                  : (c <= 4159 || (c < 4186
                    ? (c >= 4176 && c <= 4181)
                    : c <= 4189)))
                : (c <= 4193 || (c < 4213
                  ? (c < 4206
                    ? (c >= 4197 && c <= 4198)
                    : c <= 4208)
                  : (c <= 4225 || c == 4238))))
              : (c <= 4293 || (c < 4682
                ? (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c >= 4348 && c <= 4680)))
                : (c <= 4685 || (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c >= 4704 && c <= 4744)))))))
            : (c <= 4749 || (c < 5024
              ? (c < 4808
                ? (c < 4792
                  ? (c < 4786
                    ? (c >= 4752 && c <= 4784)
                    : c <= 4789)
                  : (c <= 4798 || (c < 4802
                    ? c == 4800
                    : c <= 4805)))
                : (c <= 4822 || (c < 4888
                  ? (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)
                  : (c <= 4954 || (c >= 4992 && c <= 5007)))))
              : (c <= 5109 || (c < 5792
                ? (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))
                : (c <= 5866 || (c < 5919
                  ? (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))))))))
          : (c <= 5996 || (c < 7098
            ? (c < 6512
              ? (c < 6272
                ? (c < 6103
                  ? (c < 6016
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6067)
                  : (c <= 6103 || (c < 6176
                    ? c == 6108
                    : c <= 6264)))
                : (c <= 6312 || (c < 6400
                  ? (c < 6320
                    ? c == 6314
                    : c <= 6389)
                  : (c <= 6430 || (c >= 6480 && c <= 6509)))))
              : (c <= 6516 || (c < 6823
                ? (c < 6656
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))
                : (c <= 6823 || (c < 7043
                  ? (c < 6981
                    ? (c >= 6917 && c <= 6963)
                    : c <= 6988)
                  : (c <= 7072 || (c >= 7086 && c <= 7087)))))))
            : (c <= 7141 || (c < 7418
              ? (c < 7312
                ? (c < 7258
                  ? (c < 7245
                    ? (c >= 7168 && c <= 7203)
                    : c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))
                : (c <= 7354 || (c < 7406
                  ? (c < 7401
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))))
              : (c <= 7418 || (c < 8008
                ? (c < 7960
                  ? (c < 7680
                    ? (c >= 7424 && c <= 7615)
                    : c <= 7957)
                  : (c <= 7965 || (c >= 7968 && c <= 8005)))
                : (c <= 8013 || (c < 8027
                  ? (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)
                  : (c <= 8027 || c == 8029))))))))))
        : (c <= 8061 || (c < 11728
          ? (c < 8488
            ? (c < 8305
              ? (c < 8144
                ? (c < 8126
                  ? (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)
                  : (c <= 8126 || (c < 8134
                    ? (c >= 8130 && c <= 8132)
                    : c <= 8140)))
                : (c <= 8147 || (c < 8178
                  ? (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)
                  : (c <= 8180 || (c >= 8182 && c <= 8188)))))
              : (c <= 8305 || (c < 8458
                ? (c < 8450
                  ? (c < 8336
                    ? c == 8319
                    : c <= 8348)
                  : (c <= 8450 || c == 8455))
                : (c <= 8467 || (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || c == 8486))))))
            : (c <= 8488 || (c < 11565
              ? (c < 11264
                ? (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))
                : (c <= 11492 || (c < 11520
                  ? (c < 11506
                    ? (c >= 11499 && c <= 11502)
                    : c <= 11507)
                  : (c <= 11557 || c == 11559))))
              : (c <= 11565 || (c < 11688
                ? (c < 11648
                  ? (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)
                  : (c <= 11670 || (c >= 11680 && c <= 11686)))
                : (c <= 11694 || (c < 11712
                  ? (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)
                  : (c <= 11718 || (c >= 11720 && c <= 11726)))))))))
          : (c <= 11734 || (c < 42623
            ? (c < 12593
              ? (c < 12353
                ? (c < 12321
                  ? (c < 12293
                    ? (c >= 11736 && c <= 11742)
                    : c <= 12295)
                  : (c <= 12329 || (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)))
                : (c <= 12438 || (c < 12540
                  ? (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)
                  : (c <= 12543 || (c >= 12549 && c <= 12591)))))
              : (c <= 12686 || (c < 42192
                ? (c < 13312
                  ? (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)
                  : (c <= 19903 || (c >= 19968 && c <= 42124)))
                : (c <= 42237 || (c < 42538
                  ? (c < 42512
                    ? (c >= 42240 && c <= 42508)
                    : c <= 42527)
                  : (c <= 42539 || (c >= 42560 && c <= 42606)))))))
            : (c <= 42653 || (c < 43015
              ? (c < 42960
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42656 && c <= 42735)
                    : c <= 42783)
                  : (c <= 42888 || (c >= 42891 && c <= 42954)))
                : (c <= 42961 || (c < 42994
                  ? (c < 42965
                    ? c == 42963
                    : c <= 42969)
                  : (c <= 43009 || (c >= 43011 && c <= 43013)))))
              : (c <= 43018 || (c < 43259
                ? (c < 43138
                  ? (c < 43072
                    ? (c >= 43020 && c <= 43042)
                    : c <= 43123)
                  : (c <= 43187 || (c >= 43250 && c <= 43255)))
                : (c <= 43259 || (c < 43312
                  ? (c < 43274
                    ? (c >= 43261 && c <= 43262)
                    : c <= 43301)
                  : (c <= 43334 || (c >= 43360 && c <= 43388)))))))))))))))
    : (c <= 43442 || (c < 70493
      ? (c < 66864
        ? (c < 64467
          ? (c < 43793
            ? (c < 43697
              ? (c < 43584
                ? (c < 43494
                  ? (c < 43488
                    ? c == 43471
                    : c <= 43492)
                  : (c <= 43503 || (c < 43520
                    ? (c >= 43514 && c <= 43518)
                    : c <= 43560)))
                : (c <= 43586 || (c < 43642
                  ? (c < 43616
                    ? (c >= 43588 && c <= 43595)
                    : c <= 43638)
                  : (c <= 43642 || (c >= 43646 && c <= 43695)))))
              : (c <= 43697 || (c < 43739
                ? (c < 43712
                  ? (c < 43705
                    ? (c >= 43701 && c <= 43702)
                    : c <= 43709)
                  : (c <= 43712 || c == 43714))
                : (c <= 43741 || (c < 43777
                  ? (c < 43762
                    ? (c >= 43744 && c <= 43754)
                    : c <= 43764)
                  : (c <= 43782 || (c >= 43785 && c <= 43790)))))))
            : (c <= 43798 || (c < 64256
              ? (c < 44032
                ? (c < 43824
                  ? (c < 43816
                    ? (c >= 43808 && c <= 43814)
                    : c <= 43822)
                  : (c <= 43866 || (c < 43888
                    ? (c >= 43868 && c <= 43881)
                    : c <= 44002)))
                : (c <= 55203 || (c < 63744
                  ? (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)
                  : (c <= 64109 || (c >= 64112 && c <= 64217)))))
              : (c <= 64262 || (c < 64312
                ? (c < 64287
                  ? (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64285)
                  : (c <= 64296 || (c >= 64298 && c <= 64310)))
                : (c <= 64316 || (c < 64323
                  ? (c < 64320
                    ? c == 64318
                    : c <= 64321)
                  : (c <= 64324 || (c >= 64326 && c <= 64433)))))))))
          : (c <= 64605 || (c < 65549
            ? (c < 65151
              ? (c < 65139
                ? (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)))
                : (c <= 65139 || (c < 65147
                  ? (c < 65145
                    ? c == 65143
                    : c <= 65145)
                  : (c <= 65147 || c == 65149))))
              : (c <= 65276 || (c < 65474
                ? (c < 65382
                  ? (c < 65345
                    ? (c >= 65313 && c <= 65338)
                    : c <= 65370)
                  : (c <= 65437 || (c >= 65440 && c <= 65470)))
                : (c <= 65479 || (c < 65498
                  ? (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)
                  : (c <= 65500 || (c >= 65536 && c <= 65547)))))))
            : (c <= 65574 || (c < 66349
              ? (c < 65664
                ? (c < 65599
                  ? (c < 65596
                    ? (c >= 65576 && c <= 65594)
                    : c <= 65597)
                  : (c <= 65613 || (c >= 65616 && c <= 65629)))
                : (c <= 65786 || (c < 66208
                  ? (c < 66176
                    ? (c >= 65856 && c <= 65908)
                    : c <= 66204)
                  : (c <= 66256 || (c >= 66304 && c <= 66335)))))
              : (c <= 66378 || (c < 66513
                ? (c < 66464
                  ? (c < 66432
                    ? (c >= 66384 && c <= 66421)
                    : c <= 66461)
                  : (c <= 66499 || (c >= 66504 && c <= 66511)))
                : (c <= 66517 || (c < 66776
                  ? (c < 66736
                    ? (c >= 66560 && c <= 66717)
                    : c <= 66771)
                  : (c <= 66811 || (c >= 66816 && c <= 66855)))))))))))
        : (c <= 66915 || (c < 68736
          ? (c < 67680
            ? (c < 67424
              ? (c < 66979
                ? (c < 66956
                  ? (c < 66940
                    ? (c >= 66928 && c <= 66938)
                    : c <= 66954)
                  : (c <= 66962 || (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)))
                : (c <= 66993 || (c < 67072
                  ? (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))))
              : (c <= 67431 || (c < 67592
                ? (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c >= 67584 && c <= 67589)))
                : (c <= 67592 || (c < 67644
                  ? (c < 67639
                    ? (c >= 67594 && c <= 67637)
                    : c <= 67640)
                  : (c <= 67644 || (c >= 67647 && c <= 67669)))))))
            : (c <= 67702 || (c < 68121
              ? (c < 67968
                ? (c < 67828
                  ? (c < 67808
                    ? (c >= 67712 && c <= 67742)
                    : c <= 67826)
                  : (c <= 67829 || (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)))
                : (c <= 68023 || (c < 68112
                  ? (c < 68096
                    ? (c >= 68030 && c <= 68031)
                    : c <= 68096)
                  : (c <= 68115 || (c >= 68117 && c <= 68119)))))
              : (c <= 68149 || (c < 68352
                ? (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c >= 68297 && c <= 68324)))
                : (c <= 68405 || (c < 68480
                  ? (c < 68448
                    ? (c >= 68416 && c <= 68437)
                    : c <= 68466)
                  : (c <= 68497 || (c >= 68608 && c <= 68680)))))))))
          : (c <= 68786 || (c < 70019
            ? (c < 69635
              ? (c < 69415
                ? (c < 69248
                  ? (c < 68864
                    ? (c >= 68800 && c <= 68850)
                    : c <= 68899)
                  : (c <= 69289 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))
                : (c <= 69415 || (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69445)
                    : c <= 69505)
                  : (c <= 69572 || (c >= 69600 && c <= 69622)))))
              : (c <= 69687 || (c < 69891
                ? (c < 69763
                  ? (c < 69749
                    ? (c >= 69745 && c <= 69746)
                    : c <= 69749)
                  : (c <= 69807 || (c >= 69840 && c <= 69864)))
                : (c <= 69926 || (c < 69968
                  ? (c < 69959
                    ? c == 69956
                    : c <= 69959)
                  : (c <= 70002 || c == 70006))))))
            : (c <= 70066 || (c < 70303
              ? (c < 70163
                ? (c < 70108
                  ? (c < 70106
                    ? (c >= 70081 && c <= 70084)
                    : c <= 70106)
                  : (c <= 70108 || (c >= 70144 && c <= 70161)))
                : (c <= 70187 || (c < 70282
                  ? (c < 70280
                    ? (c >= 70272 && c <= 70278)
                    : c <= 70280)
                  : (c <= 70285 || (c >= 70287 && c <= 70301)))))
              : (c <= 70312 || (c < 70442
                ? (c < 70415
                  ? (c < 70405
                    ? (c >= 70320 && c <= 70366)
                    : c <= 70412)
                  : (c <= 70416 || (c >= 70419 && c <= 70440)))
                : (c <= 70448 || (c < 70461
                  ? (c < 70453
                    ? (c >= 70450 && c <= 70451)
                    : c <= 70457)
                  : (c <= 70461 || c == 70480))))))))))))
      : (c <= 70497 || (c < 119808
        ? (c < 73030
          ? (c < 71960
            ? (c < 71296
              ? (c < 70855
                ? (c < 70751
                  ? (c < 70727
                    ? (c >= 70656 && c <= 70708)
                    : c <= 70730)
                  : (c <= 70753 || (c < 70852
                    ? (c >= 70784 && c <= 70831)
                    : c <= 70853)))
                : (c <= 70855 || (c < 71168
                  ? (c < 71128
                    ? (c >= 71040 && c <= 71086)
                    : c <= 71131)
                  : (c <= 71215 || c == 71236))))
              : (c <= 71338 || (c < 71840
                ? (c < 71488
                  ? (c < 71424
                    ? c == 71352
                    : c <= 71450)
                  : (c <= 71494 || (c >= 71680 && c <= 71723)))
                : (c <= 71903 || (c < 71948
                  ? (c < 71945
                    ? (c >= 71935 && c <= 71942)
                    : c <= 71945)
                  : (c <= 71955 || (c >= 71957 && c <= 71958)))))))
            : (c <= 71983 || (c < 72284
              ? (c < 72163
                ? (c < 72096
                  ? (c < 72001
                    ? c == 71999
                    : c <= 72001)
                  : (c <= 72103 || (c < 72161
                    ? (c >= 72106 && c <= 72144)
                    : c <= 72161)))
                : (c <= 72163 || (c < 72250
                  ? (c < 72203
                    ? c == 72192
                    : c <= 72242)
                  : (c <= 72250 || c == 72272))))
              : (c <= 72329 || (c < 72768
                ? (c < 72704
                  ? (c < 72368
                    ? c == 72349
                    : c <= 72440)
                  : (c <= 72712 || (c >= 72714 && c <= 72750)))
                : (c <= 72768 || (c < 72968
                  ? (c < 72960
                    ? (c >= 72818 && c <= 72847)
                    : c <= 72966)
                  : (c <= 72969 || (c >= 72971 && c <= 73008)))))))))
          : (c <= 73030 || (c < 93760
            ? (c < 77824
              ? (c < 73648
                ? (c < 73066
                  ? (c < 73063
                    ? (c >= 73056 && c <= 73061)
                    : c <= 73064)
                  : (c <= 73097 || (c < 73440
                    ? c == 73112
                    : c <= 73458)))
                : (c <= 73648 || (c < 74880
                  ? (c < 74752
                    ? (c >= 73728 && c <= 74649)
                    : c <= 74862)
                  : (c <= 75075 || (c >= 77712 && c <= 77808)))))
              : (c <= 78894 || (c < 92880
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c >= 92784 && c <= 92862)))
                : (c <= 92909 || (c < 93027
                  ? (c < 92992
                    ? (c >= 92928 && c <= 92975)
                    : c <= 92995)
                  : (c <= 93047 || (c >= 93053 && c <= 93071)))))))
            : (c <= 93823 || (c < 110581
              ? (c < 94179
                ? (c < 94099
                  ? (c < 94032
                    ? (c >= 93952 && c <= 94026)
                    : c <= 94032)
                  : (c <= 94111 || (c >= 94176 && c <= 94177)))
                : (c <= 94179 || (c < 101632
                  ? (c < 100352
                    ? (c >= 94208 && c <= 100343)
                    : c <= 101589)
                  : (c <= 101640 || (c >= 110576 && c <= 110579)))))
              : (c <= 110587 || (c < 110960
                ? (c < 110928
                  ? (c < 110592
                    ? (c >= 110589 && c <= 110590)
                    : c <= 110882)
                  : (c <= 110930 || (c >= 110948 && c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c >= 113808 && c <= 113817)))))))))))
        : (c <= 119892 || (c < 125259
          ? (c < 120540
            ? (c < 120077
              ? (c < 119982
                ? (c < 119970
                  ? (c < 119966
                    ? (c >= 119894 && c <= 119964)
                    : c <= 119967)
                  : (c <= 119970 || (c < 119977
                    ? (c >= 119973 && c <= 119974)
                    : c <= 119980)))
                : (c <= 119993 || (c < 120005
                  ? (c < 119997
                    ? c == 119995
                    : c <= 120003)
                  : (c <= 120069 || (c >= 120071 && c <= 120074)))))
              : (c <= 120084 || (c < 120134
                ? (c < 120123
                  ? (c < 120094
                    ? (c >= 120086 && c <= 120092)
                    : c <= 120121)
                  : (c <= 120126 || (c >= 120128 && c <= 120132)))
                : (c <= 120134 || (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c >= 120514 && c <= 120538)))))))
            : (c <= 120570 || (c < 123191
              ? (c < 120714
                ? (c < 120630
                  ? (c < 120598
                    ? (c >= 120572 && c <= 120596)
                    : c <= 120628)
                  : (c <= 120654 || (c < 120688
                    ? (c >= 120656 && c <= 120686)
                    : c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 43494
    ? (c < 4186
      ? (c < 2703
        ? (c < 1969
          ? (c < 908
            ? (c < 710
              ? (c < 181
                ? (c < '_'
                  ? (c < 'A'
                    ? c == '$'
                    : c <= 'Z')
                  : (c <= '_' || (c < 170
                    ? (c >= 'a' && c <= 'z')
                    : c <= 170)))
                : (c <= 181 || (c < 216
                  ? (c < 192
                    ? c == 186
                    : c <= 214)
                  : (c <= 246 || (c >= 248 && c <= 705)))))
              : (c <= 721 || (c < 886
                ? (c < 750
                  ? (c < 748
                    ? (c >= 736 && c <= 740)
                    : c <= 748)
                  : (c <= 750 || (c >= 880 && c <= 884)))
                : (c <= 887 || (c < 902
                  ? (c < 895
                    ? (c >= 891 && c <= 893)
                    : c <= 895)
                  : (c <= 902 || (c >= 904 && c <= 906)))))))
            : (c <= 908 || (c < 1646
              ? (c < 1369
                ? (c < 1015
                  ? (c < 931
                    ? (c >= 910 && c <= 929)
                    : c <= 1013)
                  : (c <= 1153 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1519
                  ? (c < 1488
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1514)
                  : (c <= 1522 || (c >= 1568 && c <= 1610)))))
              : (c <= 1647 || (c < 1786
                ? (c < 1765
                  ? (c < 1749
                    ? (c >= 1649 && c <= 1747)
                    : c <= 1749)
                  : (c <= 1766 || (c >= 1774 && c <= 1775)))
                : (c <= 1788 || (c < 1810
                  ? (c < 1808
                    ? c == 1791
                    : c <= 1808)
                  : (c <= 1839 || (c >= 1869 && c <= 1957)))))))))
          : (c <= 1969 || (c < 2474
            ? (c < 2185
              ? (c < 2084
                ? (c < 2042
                  ? (c < 2036
                    ? (c >= 1994 && c <= 2026)
                    : c <= 2037)
                  : (c <= 2042 || (c < 2074
                    ? (c >= 2048 && c <= 2069)
                    : c <= 2074)))
                : (c <= 2084 || (c < 2144
                  ? (c < 2112
                    ? c == 2088
                    : c <= 2136)
                  : (c <= 2154 || (c >= 2160 && c <= 2183)))))
              : (c <= 2190 || (c < 2392
                ? (c < 2365
                  ? (c < 2308
                    ? (c >= 2208 && c <= 2249)
                    : c <= 2361)
                  : (c <= 2365 || c == 2384))
                : (c <= 2401 || (c < 2447
                  ? (c < 2437
                    ? (c >= 2417 && c <= 2432)
                    : c <= 2444)
                  : (c <= 2448 || (c >= 2451 && c <= 2472)))))))
            : (c <= 2480 || (c < 2575
              ? (c < 2524
                ? (c < 2493
                  ? (c < 2486
                    ? c == 2482
                    : c <= 2489)
                  : (c <= 2493 || c == 2510))
                : (c <= 2525 || (c < 2556
                  ? (c < 2544
                    ? (c >= 2527 && c <= 2529)
                    : c <= 2545)
                  : (c <= 2556 || (c >= 2565 && c <= 2570)))))
              : (c <= 2576 || (c < 2616
                ? (c < 2610
                  ? (c < 2602
                    ? (c >= 2579 && c <= 2600)
                    : c <= 2608)
                  : (c <= 2611 || (c >= 2613 && c <= 2614)))
                : (c <= 2617 || (c < 2674
                  ? (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)
                  : (c <= 2676 || (c >= 2693 && c <= 2701)))))))))))
        : (c <= 2705 || (c < 3218
          ? (c < 2958
            ? (c < 2835
              ? (c < 2768
                ? (c < 2738
                  ? (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)
                  : (c <= 2739 || (c < 2749
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2749)))
                : (c <= 2768 || (c < 2821
                  ? (c < 2809
                    ? (c >= 2784 && c <= 2785)
                    : c <= 2809)
                  : (c <= 2828 || (c >= 2831 && c <= 2832)))))
              : (c <= 2856 || (c < 2908
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || c == 2877))
                : (c <= 2909 || (c < 2947
                  ? (c < 2929
                    ? (c >= 2911 && c <= 2913)
                    : c <= 2929)
                  : (c <= 2947 || (c >= 2949 && c <= 2954)))))))
            : (c <= 2960 || (c < 3086
              ? (c < 2979
                ? (c < 2972
                  ? (c < 2969
                    ? (c >= 2962 && c <= 2965)
                    : c <= 2970)
                  : (c <= 2972 || (c >= 2974 && c <= 2975)))
                : (c <= 2980 || (c < 3024
                  ? (c < 2990
                    ? (c >= 2984 && c <= 2986)
                    : c <= 3001)
                  : (c <= 3024 || (c >= 3077 && c <= 3084)))))
              : (c <= 3088 || (c < 3165
                ? (c < 3133
                  ? (c < 3114
                    ? (c >= 3090 && c <= 3112)
                    : c <= 3129)
                  : (c <= 3133 || (c >= 3160 && c <= 3162)))
                : (c <= 3165 || (c < 3205
                  ? (c < 3200
                    ? (c >= 3168 && c <= 3169)
                    : c <= 3200)
                  : (c <= 3212 || (c >= 3214 && c <= 3216)))))))))
          : (c <= 3240 || (c < 3634
            ? (c < 3406
              ? (c < 3313
                ? (c < 3261
                  ? (c < 3253
                    ? (c >= 3242 && c <= 3251)
                    : c <= 3257)
                  : (c <= 3261 || (c < 3296
                    ? (c >= 3293 && c <= 3294)
                    : c <= 3297)))
                : (c <= 3314 || (c < 3346
                  ? (c < 3342
                    ? (c >= 3332 && c <= 3340)
                    : c <= 3344)
                  : (c <= 3386 || c == 3389))))
              : (c <= 3406 || (c < 3482
                ? (c < 3450
                  ? (c < 3423
                    ? (c >= 3412 && c <= 3414)
                    : c <= 3425)
                  : (c <= 3455 || (c >= 3461 && c <= 3478)))
                : (c <= 3505 || (c < 3520
                  ? (c < 3517
                    ? (c >= 3507 && c <= 3515)
                    : c <= 3517)
                  : (c <= 3526 || (c >= 3585 && c <= 3632)))))))
            : (c <= 3634 || (c < 3776
              ? (c < 3724
                ? (c < 3716
                  ? (c < 3713
                    ? (c >= 3648 && c <= 3654)
                    : c <= 3714)
                  : (c <= 3716 || (c >= 3718 && c <= 3722)))
                : (c <= 3747 || (c < 3762
                  ? (c < 3751
                    ? c == 3749
                    : c <= 3760)
                  : (c <= 3762 || c == 3773))))
              : (c <= 3780 || (c < 3913
                ? (c < 3840
                  ? (c < 3804
                    ? c == 3782
                    : c <= 3807)
                  : (c <= 3840 || (c >= 3904 && c <= 3911)))
                : (c <= 3948 || (c < 4159
                  ? (c < 4096
                    ? (c >= 3976 && c <= 3980)
                    : c <= 4138)
                  : (c <= 4159 || (c >= 4176 && c <= 4181)))))))))))))
      : (c <= 4189 || (c < 8130
        ? (c < 6108
          ? (c < 4802
            ? (c < 4682
              ? (c < 4256
                ? (c < 4206
                  ? (c < 4197
                    ? c == 4193
                    : c <= 4198)
                  : (c <= 4208 || (c < 4238
                    ? (c >= 4213 && c <= 4225)
                    : c <= 4238)))
                : (c <= 4293 || (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c >= 4348 && c <= 4680)))))
              : (c <= 4685 || (c < 4746
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c >= 4704 && c <= 4744)))
                : (c <= 4749 || (c < 4792
                  ? (c < 4786
                    ? (c >= 4752 && c <= 4784)
                    : c <= 4789)
                  : (c <= 4798 || c == 4800))))))
            : (c <= 4805 || (c < 5761
              ? (c < 4992
                ? (c < 4882
                  ? (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)
                  : (c <= 4885 || (c >= 4888 && c <= 4954)))
                : (c <= 5007 || (c < 5121
                  ? (c < 5112
                    ? (c >= 5024 && c <= 5109)
                    : c <= 5117)
                  : (c <= 5740 || (c >= 5743 && c <= 5759)))))
              : (c <= 5786 || (c < 5952
                ? (c < 5888
                  ? (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)
                  : (c <= 5905 || (c >= 5919 && c <= 5937)))
                : (c <= 5969 || (c < 6016
                  ? (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)
                  : (c <= 6067 || c == 6103))))))))
          : (c <= 6108 || (c < 7296
            ? (c < 6688
              ? (c < 6480
                ? (c < 6314
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6312)
                  : (c <= 6314 || (c < 6400
                    ? (c >= 6320 && c <= 6389)
                    : c <= 6430)))
                : (c <= 6509 || (c < 6576
                  ? (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)
                  : (c <= 6601 || (c >= 6656 && c <= 6678)))))
              : (c <= 6740 || (c < 7086
                ? (c < 6981
                  ? (c < 6917
                    ? c == 6823
                    : c <= 6963)
                  : (c <= 6988 || (c >= 7043 && c <= 7072)))
                : (c <= 7087 || (c < 7245
                  ? (c < 7168
                    ? (c >= 7098 && c <= 7141)
                    : c <= 7203)
                  : (c <= 7247 || (c >= 7258 && c <= 7293)))))))
            : (c <= 7304 || (c < 7968
              ? (c < 7413
                ? (c < 7401
                  ? (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)
                  : (c <= 7404 || (c >= 7406 && c <= 7411)))
                : (c <= 7414 || (c < 7680
                  ? (c < 7424
                    ? c == 7418
                    : c <= 7615)
                  : (c <= 7957 || (c >= 7960 && c <= 7965)))))
              : (c <= 8005 || (c < 8029
                ? (c < 8025
                  ? (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)
                  : (c <= 8025 || c == 8027))
                : (c <= 8029 || (c < 8118
                  ? (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)
                  : (c <= 8124 || c == 8126))))))))))
        : (c <= 8132 || (c < 12321
          ? (c < 8526
            ? (c < 8455
              ? (c < 8182
                ? (c < 8150
                  ? (c < 8144
                    ? (c >= 8134 && c <= 8140)
                    : c <= 8147)
                  : (c <= 8155 || (c < 8178
                    ? (c >= 8160 && c <= 8172)
                    : c <= 8180)))
                : (c <= 8188 || (c < 8336
                  ? (c < 8319
                    ? c == 8305
                    : c <= 8319)
                  : (c <= 8348 || c == 8450))))
              : (c <= 8455 || (c < 8486
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || c == 8484))
                : (c <= 8486 || (c < 8508
                  ? (c < 8490
                    ? c == 8488
                    : c <= 8505)
                  : (c <= 8511 || (c >= 8517 && c <= 8521)))))))
            : (c <= 8526 || (c < 11648
              ? (c < 11520
                ? (c < 11499
                  ? (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)
                  : (c <= 11502 || (c >= 11506 && c <= 11507)))
                : (c <= 11557 || (c < 11568
                  ? (c < 11565
                    ? c == 11559
                    : c <= 11565)
                  : (c <= 11623 || c == 11631))))
              : (c <= 11670 || (c < 11712
                ? (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c >= 11704 && c <= 11710)))
                : (c <= 11718 || (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c >= 12293 && c <= 12295)))))))))
          : (c <= 12329 || (c < 42786
            ? (c < 13312
              ? (c < 12540
                ? (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)))
                : (c <= 12543 || (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c >= 12784 && c <= 12799)))))
              : (c <= 19903 || (c < 42538
                ? (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c >= 42512 && c <= 42527)))
                : (c <= 42539 || (c < 42656
                  ? (c < 42623
                    ? (c >= 42560 && c <= 42606)
                    : c <= 42653)
                  : (c <= 42735 || (c >= 42775 && c <= 42783)))))))
            : (c <= 42888 || (c < 43138
              ? (c < 42994
                ? (c < 42963
                  ? (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)
                  : (c <= 42963 || (c >= 42965 && c <= 42969)))
                : (c <= 43009 || (c < 43020
                  ? (c < 43015
                    ? (c >= 43011 && c <= 43013)
                    : c <= 43018)
                  : (c <= 43042 || (c >= 43072 && c <= 43123)))))
              : (c <= 43187 || (c < 43312
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43250 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43262 || (c >= 43274 && c <= 43301)))
                : (c <= 43334 || (c < 43471
                  ? (c < 43396
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43442)
                  : (c <= 43471 || (c >= 43488 && c <= 43492)))))))))))))))
    : (c <= 43503 || (c < 70727
      ? (c < 66956
        ? (c < 64914
          ? (c < 43824
            ? (c < 43712
              ? (c < 43642
                ? (c < 43584
                  ? (c < 43520
                    ? (c >= 43514 && c <= 43518)
                    : c <= 43560)
                  : (c <= 43586 || (c < 43616
                    ? (c >= 43588 && c <= 43595)
                    : c <= 43638)))
                : (c <= 43642 || (c < 43701
                  ? (c < 43697
                    ? (c >= 43646 && c <= 43695)
                    : c <= 43697)
                  : (c <= 43702 || (c >= 43705 && c <= 43709)))))
              : (c <= 43712 || (c < 43777
                ? (c < 43744
                  ? (c < 43739
                    ? c == 43714
                    : c <= 43741)
                  : (c <= 43754 || (c >= 43762 && c <= 43764)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c >= 43816 && c <= 43822)))))))
            : (c <= 43866 || (c < 64287
              ? (c < 63744
                ? (c < 44032
                  ? (c < 43888
                    ? (c >= 43868 && c <= 43881)
                    : c <= 44002)
                  : (c <= 55203 || (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))))
              : (c <= 64296 || (c < 64323
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))))))))
          : (c <= 64967 || (c < 65599
            ? (c < 65382
              ? (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))))
              : (c <= 65437 || (c < 65498
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))))))
            : (c <= 65613 || (c < 66464
              ? (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c >= 66176 && c <= 66204)))
                : (c <= 66256 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66421 || (c >= 66432 && c <= 66461)))))
              : (c <= 66499 || (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c >= 66736 && c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))))))))))
        : (c <= 66962 || (c < 68864
          ? (c < 67828
            ? (c < 67506
              ? (c < 67072
                ? (c < 66979
                  ? (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)
                  : (c <= 66993 || (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)))
                : (c <= 67382 || (c < 67456
                  ? (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)
                  : (c <= 67461 || (c >= 67463 && c <= 67504)))))
              : (c <= 67514 || (c < 67644
                ? (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))
                : (c <= 67644 || (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))))))
            : (c <= 67829 || (c < 68224
              ? (c < 68096
                ? (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68096 || (c < 68121
                  ? (c < 68117
                    ? (c >= 68112 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c >= 68192 && c <= 68220)))))
              : (c <= 68252 || (c < 68448
                ? (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68324)
                  : (c <= 68405 || (c >= 68416 && c <= 68437)))
                : (c <= 68466 || (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c >= 68800 && c <= 68850)))))))))
          : (c <= 68899 || (c < 70106
            ? (c < 69749
              ? (c < 69488
                ? (c < 69376
                  ? (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69445)))
                : (c <= 69505 || (c < 69635
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69687 || (c >= 69745 && c <= 69746)))))
              : (c <= 69749 || (c < 69959
                ? (c < 69891
                  ? (c < 69840
                    ? (c >= 69763 && c <= 69807)
                    : c <= 69864)
                  : (c <= 69926 || c == 69956))
                : (c <= 69959 || (c < 70019
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70002)
                    : c <= 70006)
                  : (c <= 70066 || (c >= 70081 && c <= 70084)))))))
            : (c <= 70106 || (c < 70405
              ? (c < 70280
                ? (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70187 || (c >= 70272 && c <= 70278)))
                : (c <= 70280 || (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c >= 70320 && c <= 70366)))))
              : (c <= 70412 || (c < 70453
                ? (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c >= 70450 && c <= 70451)))
                : (c <= 70457 || (c < 70493
                  ? (c < 70480
                    ? c == 70461
                    : c <= 70480)
                  : (c <= 70497 || (c >= 70656 && c <= 70708)))))))))))))
      : (c <= 70730 || (c < 119894
        ? (c < 73056
          ? (c < 72001
            ? (c < 71424
              ? (c < 71128
                ? (c < 70852
                  ? (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)
                  : (c <= 70853 || (c < 71040
                    ? c == 70855
                    : c <= 71086)))
                : (c <= 71131 || (c < 71296
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71215)
                    : c <= 71236)
                  : (c <= 71338 || c == 71352))))
              : (c <= 71450 || (c < 71945
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71723)
                  : (c <= 71903 || (c >= 71935 && c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71983 || c == 71999))))))
            : (c <= 72001 || (c < 72349
              ? (c < 72192
                ? (c < 72161
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)
                  : (c <= 72161 || c == 72163))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_4(int32_t c) {
  return (c < 43471
    ? (c < 4096
      ? (c < 2649
        ? (c < 1791
          ? (c < 891
            ? (c < 186
              ? (c < '_'
                ? (c < 'C'
                  ? (c < 'A'
                    ? c == '$'
                    : c <= 'A')
                  : (c <= 'K' || (c < 'V'
                    ? (c >= 'M' && c <= 'T')
                    : c <= 'Z')))
                : (c <= '_' || (c < 170
                  ? (c < 'v'
                    ? (c >= 'a' && c <= 't')
                    : c <= 'z')
                  : (c <= 170 || c == 181))))
              : (c <= 186 || (c < 736
                ? (c < 248
                  ? (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))
                : (c <= 740 || (c < 880
                  ? (c < 750
                    ? c == 748
                    : c <= 750)
                  : (c <= 884 || (c >= 886 && c <= 887)))))))
            : (c <= 893 || (c < 1376
              ? (c < 931
                ? (c < 904
                  ? (c < 902
                    ? c == 895
                    : c <= 902)
                  : (c <= 906 || (c < 910
                    ? c == 908
                    : c <= 929)))
                : (c <= 1013 || (c < 1329
                  ? (c < 1162
                    ? (c >= 1015 && c <= 1153)
                    : c <= 1327)
                  : (c <= 1366 || c == 1369))))
              : (c <= 1416 || (c < 1649
                ? (c < 1568
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))
                : (c <= 1747 || (c < 1774
                  ? (c < 1765
                    ? c == 1749
                    : c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))))))))
          : (c <= 1791 || (c < 2417
            ? (c < 2088
              ? (c < 2036
                ? (c < 1869
                  ? (c < 1810
                    ? c == 1808
                    : c <= 1839)
                  : (c <= 1957 || (c < 1994
                    ? c == 1969
                    : c <= 2026)))
                : (c <= 2037 || (c < 2074
                  ? (c < 2048
                    ? c == 2042
                    : c <= 2069)
                  : (c <= 2074 || c == 2084))))
              : (c <= 2088 || (c < 2208
                ? (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2136)
                    : c <= 2154)
                  : (c <= 2183 || (c >= 2185 && c <= 2190)))
                : (c <= 2249 || (c < 2384
                  ? (c < 2365
                    ? (c >= 2308 && c <= 2361)
                    : c <= 2365)
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))))))
            : (c <= 2432 || (c < 2527
              ? (c < 2482
                ? (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c >= 2474 && c <= 2480)))
                : (c <= 2482 || (c < 2510
                  ? (c < 2493
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2493)
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))))
              : (c <= 2529 || (c < 2579
                ? (c < 2565
                  ? (c < 2556
                    ? (c >= 2544 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c >= 2616 && c <= 2617)))))))))))
        : (c <= 2652 || (c < 3200
          ? (c < 2911
            ? (c < 2784
              ? (c < 2730
                ? (c < 2693
                  ? (c < 2674
                    ? c == 2654
                    : c <= 2676)
                  : (c <= 2701 || (c < 2707
                    ? (c >= 2703 && c <= 2705)
                    : c <= 2728)))
                : (c <= 2736 || (c < 2749
                  ? (c < 2741
                    ? (c >= 2738 && c <= 2739)
                    : c <= 2745)
                  : (c <= 2749 || c == 2768))))
              : (c <= 2785 || (c < 2858
                ? (c < 2831
                  ? (c < 2821
                    ? c == 2809
                    : c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))
                : (c <= 2864 || (c < 2877
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))))))
            : (c <= 2913 || (c < 2990
              ? (c < 2969
                ? (c < 2949
                  ? (c < 2947
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c < 2962
                    ? (c >= 2958 && c <= 2960)
                    : c <= 2965)))
                : (c <= 2970 || (c < 2979
                  ? (c < 2974
                    ? c == 2972
                    : c <= 2975)
                  : (c <= 2980 || (c >= 2984 && c <= 2986)))))
              : (c <= 3001 || (c < 3114
                ? (c < 3086
                  ? (c < 3077
                    ? c == 3024
                    : c <= 3084)
                  : (c <= 3088 || (c >= 3090 && c <= 3112)))
                : (c <= 3129 || (c < 3165
                  ? (c < 3160
                    ? c == 3133
                    : c <= 3162)
                  : (c <= 3165 || (c >= 3168 && c <= 3169)))))))))
          : (c <= 3200 || (c < 3517
            ? (c < 3342
              ? (c < 3261
                ? (c < 3218
                  ? (c < 3214
                    ? (c >= 3205 && c <= 3212)
                    : c <= 3216)
                  : (c <= 3240 || (c < 3253
                    ? (c >= 3242 && c <= 3251)
                    : c <= 3257)))
                : (c <= 3261 || (c < 3313
                  ? (c < 3296
                    ? (c >= 3293 && c <= 3294)
                    : c <= 3297)
                  : (c <= 3314 || (c >= 3332 && c <= 3340)))))
              : (c <= 3344 || (c < 3423
                ? (c < 3406
                  ? (c < 3389
                    ? (c >= 3346 && c <= 3386)
                    : c <= 3389)
                  : (c <= 3406 || (c >= 3412 && c <= 3414)))
                : (c <= 3425 || (c < 3482
                  ? (c < 3461
                    ? (c >= 3450 && c <= 3455)
                    : c <= 3478)
                  : (c <= 3505 || (c >= 3507 && c <= 3515)))))))
            : (c <= 3517 || (c < 3751
              ? (c < 3713
                ? (c < 3634
                  ? (c < 3585
                    ? (c >= 3520 && c <= 3526)
                    : c <= 3632)
                  : (c <= 3634 || (c >= 3648 && c <= 3654)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || c == 3749))))
              : (c <= 3760 || (c < 3804
                ? (c < 3776
                  ? (c < 3773
                    ? c == 3762
                    : c <= 3773)
                  : (c <= 3780 || c == 3782))
                : (c <= 3807 || (c < 3913
                  ? (c < 3904
                    ? c == 3840
                    : c <= 3911)
                  : (c <= 3948 || (c >= 3976 && c <= 3980)))))))))))))
      : (c <= 4138 || (c < 8118
        ? (c < 6016
          ? (c < 4786
            ? (c < 4301
              ? (c < 4206
                ? (c < 4186
                  ? (c < 4176
                    ? c == 4159
                    : c <= 4181)
                  : (c <= 4189 || (c < 4197
                    ? c == 4193
                    : c <= 4198)))
                : (c <= 4208 || (c < 4256
                  ? (c < 4238
                    ? (c >= 4213 && c <= 4225)
                    : c <= 4238)
                  : (c <= 4293 || c == 4295))))
              : (c <= 4301 || (c < 4696
                ? (c < 4682
                  ? (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)
                  : (c <= 4685 || (c >= 4688 && c <= 4694)))
                : (c <= 4696 || (c < 4746
                  ? (c < 4704
                    ? (c >= 4698 && c <= 4701)
                    : c <= 4744)
                  : (c <= 4749 || (c >= 4752 && c <= 4784)))))))
            : (c <= 4789 || (c < 5121
              ? (c < 4882
                ? (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)))
                : (c <= 4885 || (c < 5024
                  ? (c < 4992
                    ? (c >= 4888 && c <= 4954)
                    : c <= 5007)
                  : (c <= 5109 || (c >= 5112 && c <= 5117)))))
              : (c <= 5740 || (c < 5888
                ? (c < 5792
                  ? (c < 5761
                    ? (c >= 5743 && c <= 5759)
                    : c <= 5786)
                  : (c <= 5866 || (c >= 5870 && c <= 5880)))
                : (c <= 5905 || (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5937)
                    : c <= 5969)
                  : (c <= 5996 || (c >= 5998 && c <= 6000)))))))))
          : (c <= 6067 || (c < 7245
            ? (c < 6576
              ? (c < 6320
                ? (c < 6176
                  ? (c < 6108
                    ? c == 6103
                    : c <= 6108)
                  : (c <= 6264 || (c < 6314
                    ? (c >= 6272 && c <= 6312)
                    : c <= 6314)))
                : (c <= 6389 || (c < 6512
                  ? (c < 6480
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6509)
                  : (c <= 6516 || (c >= 6528 && c <= 6571)))))
              : (c <= 6601 || (c < 6981
                ? (c < 6823
                  ? (c < 6688
                    ? (c >= 6656 && c <= 6678)
                    : c <= 6740)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))
                : (c <= 6988 || (c < 7098
                  ? (c < 7086
                    ? (c >= 7043 && c <= 7072)
                    : c <= 7087)
                  : (c <= 7141 || (c >= 7168 && c <= 7203)))))))
            : (c <= 7247 || (c < 7680
              ? (c < 7401
                ? (c < 7312
                  ? (c < 7296
                    ? (c >= 7258 && c <= 7293)
                    : c <= 7304)
                  : (c <= 7354 || (c >= 7357 && c <= 7359)))
                : (c <= 7404 || (c < 7418
                  ? (c < 7413
                    ? (c >= 7406 && c <= 7411)
                    : c <= 7414)
                  : (c <= 7418 || (c >= 7424 && c <= 7615)))))
              : (c <= 7957 || (c < 8025
                ? (c < 8008
                  ? (c < 7968
                    ? (c >= 7960 && c <= 7965)
                    : c <= 8005)
                  : (c <= 8013 || (c >= 8016 && c <= 8023)))
                : (c <= 8025 || (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8061 || (c >= 8064 && c <= 8116)))))))))))
        : (c <= 8124 || (c < 11736
          ? (c < 8508
            ? (c < 8336
              ? (c < 8160
                ? (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))
                : (c <= 8172 || (c < 8305
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8305 || c == 8319))))
              : (c <= 8348 || (c < 8472
                ? (c < 8458
                  ? (c < 8455
                    ? c == 8450
                    : c <= 8455)
                  : (c <= 8467 || c == 8469))
                : (c <= 8477 || (c < 8488
                  ? (c < 8486
                    ? c == 8484
                    : c <= 8486)
                  : (c <= 8488 || (c >= 8490 && c <= 8505)))))))
            : (c <= 8511 || (c < 11568
              ? (c < 11499
                ? (c < 8544
                  ? (c < 8526
                    ? (c >= 8517 && c <= 8521)
                    : c <= 8526)
                  : (c <= 8584 || (c >= 11264 && c <= 11492)))
                : (c <= 11502 || (c < 11559
                  ? (c < 11520
                    ? (c >= 11506 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || c == 11565))))
              : (c <= 11623 || (c < 11696
                ? (c < 11680
                  ? (c < 11648
                    ? c == 11631
                    : c <= 11670)
                  : (c <= 11686 || (c >= 11688 && c <= 11694)))
                : (c <= 11702 || (c < 11720
                  ? (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)
                  : (c <= 11726 || (c >= 11728 && c <= 11734)))))))))
          : (c <= 11742 || (c < 42656
            ? (c < 12704
              ? (c < 12445
                ? (c < 12337
                  ? (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12329)
                  : (c <= 12341 || (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)))
                : (c <= 12447 || (c < 12549
                  ? (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)
                  : (c <= 12591 || (c >= 12593 && c <= 12686)))))
              : (c <= 12735 || (c < 42240
                ? (c < 19968
                  ? (c < 13312
                    ? (c >= 12784 && c <= 12799)
                    : c <= 19903)
                  : (c <= 42124 || (c >= 42192 && c <= 42237)))
                : (c <= 42508 || (c < 42560
                  ? (c < 42538
                    ? (c >= 42512 && c <= 42527)
                    : c <= 42539)
                  : (c <= 42606 || (c >= 42623 && c <= 42653)))))))
            : (c <= 42735 || (c < 43020
              ? (c < 42963
                ? (c < 42891
                  ? (c < 42786
                    ? (c >= 42775 && c <= 42783)
                    : c <= 42888)
                  : (c <= 42954 || (c >= 42960 && c <= 42961)))
                : (c <= 42963 || (c < 43011
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43009)
                  : (c <= 43013 || (c >= 43015 && c <= 43018)))))
              : (c <= 43042 || (c < 43261
                ? (c < 43250
                  ? (c < 43138
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43187)
                  : (c <= 43255 || c == 43259))
                : (c <= 43262 || (c < 43360
                  ? (c < 43312
                    ? (c >= 43274 && c <= 43301)
                    : c <= 43334)
                  : (c <= 43388 || (c >= 43396 && c <= 43442)))))))))))))))
    : (c <= 43471 || (c < 70656
      ? (c < 66928
        ? (c < 64612
          ? (c < 43808
            ? (c < 43701
              ? (c < 43588
                ? (c < 43514
                  ? (c < 43494
                    ? (c >= 43488 && c <= 43492)
                    : c <= 43503)
                  : (c <= 43518 || (c < 43584
                    ? (c >= 43520 && c <= 43560)
                    : c <= 43586)))
                : (c <= 43595 || (c < 43646
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43642)
                  : (c <= 43695 || c == 43697))))
              : (c <= 43702 || (c < 43744
                ? (c < 43714
                  ? (c < 43712
                    ? (c >= 43705 && c <= 43709)
                    : c <= 43712)
                  : (c <= 43714 || (c >= 43739 && c <= 43741)))
                : (c <= 43754 || (c < 43785
                  ? (c < 43777
                    ? (c >= 43762 && c <= 43764)
                    : c <= 43782)
                  : (c <= 43790 || (c >= 43793 && c <= 43798)))))))
            : (c <= 43814 || (c < 64275
              ? (c < 55216
                ? (c < 43868
                  ? (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)
                  : (c <= 43881 || (c < 44032
                    ? (c >= 43888 && c <= 44002)
                    : c <= 55203)))
                : (c <= 55238 || (c < 64112
                  ? (c < 63744
                    ? (c >= 55243 && c <= 55291)
                    : c <= 64109)
                  : (c <= 64217 || (c >= 64256 && c <= 64262)))))
              : (c <= 64279 || (c < 64318
                ? (c < 64298
                  ? (c < 64287
                    ? c == 64285
                    : c <= 64296)
                  : (c <= 64310 || (c >= 64312 && c <= 64316)))
                : (c <= 64318 || (c < 64326
                  ? (c < 64323
                    ? (c >= 64320 && c <= 64321)
                    : c <= 64324)
                  : (c <= 64433 || (c >= 64467 && c <= 64605)))))))))
          : (c <= 64829 || (c < 65576
            ? (c < 65313
              ? (c < 65143
                ? (c < 65008
                  ? (c < 64914
                    ? (c >= 64848 && c <= 64911)
                    : c <= 64967)
                  : (c <= 65017 || (c < 65139
                    ? c == 65137
                    : c <= 65139)))
                : (c <= 65143 || (c < 65149
                  ? (c < 65147
                    ? c == 65145
                    : c <= 65147)
                  : (c <= 65149 || (c >= 65151 && c <= 65276)))))
              : (c <= 65338 || (c < 65482
                ? (c < 65440
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65437)
                  : (c <= 65470 || (c >= 65474 && c <= 65479)))
                : (c <= 65487 || (c < 65536
                  ? (c < 65498
                    ? (c >= 65490 && c <= 65495)
                    : c <= 65500)
                  : (c <= 65547 || (c >= 65549 && c <= 65574)))))))
            : (c <= 65594 || (c < 66384
              ? (c < 65856
                ? (c < 65616
                  ? (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)
                  : (c <= 65629 || (c >= 65664 && c <= 65786)))
                : (c <= 65908 || (c < 66304
                  ? (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66378)))))
              : (c <= 66421 || (c < 66560
                ? (c < 66504
                  ? (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)
                  : (c <= 66511 || (c >= 66513 && c <= 66517)))
                : (c <= 66717 || (c < 66816
                  ? (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)
                  : (c <= 66855 || (c >= 66864 && c <= 66915)))))))))))
        : (c <= 66938 || (c < 68800
          ? (c < 67712
            ? (c < 67456
              ? (c < 66995
                ? (c < 66964
                  ? (c < 66956
                    ? (c >= 66940 && c <= 66954)
                    : c <= 66962)
                  : (c <= 66965 || (c < 66979
                    ? (c >= 66967 && c <= 66977)
                    : c <= 66993)))
                : (c <= 67001 || (c < 67392
                  ? (c < 67072
                    ? (c >= 67003 && c <= 67004)
                    : c <= 67382)
                  : (c <= 67413 || (c >= 67424 && c <= 67431)))))
              : (c <= 67461 || (c < 67594
                ? (c < 67584
                  ? (c < 67506
                    ? (c >= 67463 && c <= 67504)
                    : c <= 67514)
                  : (c <= 67589 || c == 67592))
                : (c <= 67637 || (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c >= 67680 && c <= 67702)))))))
            : (c <= 67742 || (c < 68192
              ? (c < 68030
                ? (c < 67840
                  ? (c < 67828
                    ? (c >= 67808 && c <= 67826)
                    : c <= 67829)
                  : (c <= 67861 || (c < 67968
                    ? (c >= 67872 && c <= 67897)
                    : c <= 68023)))
                : (c <= 68031 || (c < 68117
                  ? (c < 68112
                    ? c == 68096
                    : c <= 68115)
                  : (c <= 68119 || (c >= 68121 && c <= 68149)))))
              : (c <= 68220 || (c < 68416
                ? (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68324 || (c >= 68352 && c <= 68405)))
                : (c <= 68437 || (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c >= 68736 && c <= 68786)))))))))
          : (c <= 68850 || (c < 70081
            ? (c < 69745
              ? (c < 69424
                ? (c < 69296
                  ? (c < 69248
                    ? (c >= 68864 && c <= 68899)
                    : c <= 69289)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))
                : (c <= 69445 || (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69505)
                    : c <= 69572)
                  : (c <= 69622 || (c >= 69635 && c <= 69687)))))
              : (c <= 69746 || (c < 69956
                ? (c < 69840
                  ? (c < 69763
                    ? c == 69749
                    : c <= 69807)
                  : (c <= 69864 || (c >= 69891 && c <= 69926)))
                : (c <= 69956 || (c < 70006
                  ? (c < 69968
                    ? c == 69959
                    : c <= 70002)
                  : (c <= 70006 || (c >= 70019 && c <= 70066)))))))
            : (c <= 70084 || (c < 70320
              ? (c < 70272
                ? (c < 70144
                  ? (c < 70108
                    ? c == 70106
                    : c <= 70108)
                  : (c <= 70161 || (c >= 70163 && c <= 70187)))
                : (c <= 70278 || (c < 70287
                  ? (c < 70282
                    ? c == 70280
                    : c <= 70285)
                  : (c <= 70301 || (c >= 70303 && c <= 70312)))))
              : (c <= 70366 || (c < 70450
                ? (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c >= 70442 && c <= 70448)))
                : (c <= 70451 || (c < 70480
                  ? (c < 70461
                    ? (c >= 70453 && c <= 70457)
                    : c <= 70461)
                  : (c <= 70480 || (c >= 70493 && c <= 70497)))))))))))))
      : (c <= 70708 || (c < 119894
        ? (c < 73056
          ? (c < 71999
            ? (c < 71352
              ? (c < 71040
                ? (c < 70784
                  ? (c < 70751
                    ? (c >= 70727 && c <= 70730)
                    : c <= 70753)
                  : (c <= 70831 || (c < 70855
                    ? (c >= 70852 && c <= 70853)
                    : c <= 70855)))
                : (c <= 71086 || (c < 71236
                  ? (c < 71168
                    ? (c >= 71128 && c <= 71131)
                    : c <= 71215)
                  : (c <= 71236 || (c >= 71296 && c <= 71338)))))
              : (c <= 71352 || (c < 71935
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71424 && c <= 71450)
                    : c <= 71494)
                  : (c <= 71723 || (c >= 71840 && c <= 71903)))
                : (c <= 71942 || (c < 71957
                  ? (c < 71948
                    ? c == 71945
                    : c <= 71955)
                  : (c <= 71958 || (c >= 71960 && c <= 71983)))))))
            : (c <= 71999 || (c < 72349
              ? (c < 72192
                ? (c < 72106
                  ? (c < 72096
                    ? c == 72001
                    : c <= 72103)
                  : (c <= 72144 || (c < 72163
                    ? c == 72161
                    : c <= 72163)))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_5(int32_t c) {
  return (c < 43520
    ? (c < 4197
      ? (c < 2730
        ? (c < 2036
          ? (c < 1015
            ? (c < 750
              ? (c < 216
                ? (c < 181
                  ? (c < 170
                    ? c == '$'
                    : c <= 170)
                  : (c <= 181 || (c < 192
                    ? c == 186
                    : c <= 214)))
                : (c <= 246 || (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || c == 748))))
              : (c <= 750 || (c < 902
                ? (c < 891
                  ? (c < 886
                    ? (c >= 880 && c <= 884)
                    : c <= 887)
                  : (c <= 893 || c == 895))
                : (c <= 902 || (c < 910
                  ? (c < 908
                    ? (c >= 904 && c <= 906)
                    : c <= 908)
                  : (c <= 929 || (c >= 931 && c <= 1013)))))))
            : (c <= 1153 || (c < 1749
              ? (c < 1488
                ? (c < 1369
                  ? (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)
                  : (c <= 1369 || (c >= 1376 && c <= 1416)))
                : (c <= 1514 || (c < 1646
                  ? (c < 1568
                    ? (c >= 1519 && c <= 1522)
                    : c <= 1610)
                  : (c <= 1647 || (c >= 1649 && c <= 1747)))))
              : (c <= 1749 || (c < 1808
                ? (c < 1786
                  ? (c < 1774
                    ? (c >= 1765 && c <= 1766)
                    : c <= 1775)
                  : (c <= 1788 || c == 1791))
                : (c <= 1808 || (c < 1969
                  ? (c < 1869
                    ? (c >= 1810 && c <= 1839)
                    : c <= 1957)
                  : (c <= 1969 || (c >= 1994 && c <= 2026)))))))))
          : (c <= 2037 || (c < 2486
            ? (c < 2308
              ? (c < 2112
                ? (c < 2074
                  ? (c < 2048
                    ? c == 2042
                    : c <= 2069)
                  : (c <= 2074 || (c < 2088
                    ? c == 2084
                    : c <= 2088)))
                : (c <= 2136 || (c < 2185
                  ? (c < 2160
                    ? (c >= 2144 && c <= 2154)
                    : c <= 2183)
                  : (c <= 2190 || (c >= 2208 && c <= 2249)))))
              : (c <= 2361 || (c < 2437
                ? (c < 2392
                  ? (c < 2384
                    ? c == 2365
                    : c <= 2384)
                  : (c <= 2401 || (c >= 2417 && c <= 2432)))
                : (c <= 2444 || (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || c == 2482))))))
            : (c <= 2489 || (c < 2602
              ? (c < 2544
                ? (c < 2524
                  ? (c < 2510
                    ? c == 2493
                    : c <= 2510)
                  : (c <= 2525 || (c >= 2527 && c <= 2529)))
                : (c <= 2545 || (c < 2575
                  ? (c < 2565
                    ? c == 2556
                    : c <= 2570)
                  : (c <= 2576 || (c >= 2579 && c <= 2600)))))
              : (c <= 2608 || (c < 2654
                ? (c < 2616
                  ? (c < 2613
                    ? (c >= 2610 && c <= 2611)
                    : c <= 2614)
                  : (c <= 2617 || (c >= 2649 && c <= 2652)))
                : (c <= 2654 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2674 && c <= 2676)
                    : c <= 2701)
                  : (c <= 2705 || (c >= 2707 && c <= 2728)))))))))))
        : (c <= 2736 || (c < 3253
          ? (c < 2969
            ? (c < 2866
              ? (c < 2809
                ? (c < 2749
                  ? (c < 2741
                    ? (c >= 2738 && c <= 2739)
                    : c <= 2745)
                  : (c <= 2749 || (c < 2784
                    ? c == 2768
                    : c <= 2785)))
                : (c <= 2809 || (c < 2835
                  ? (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)
                  : (c <= 2856 || (c >= 2858 && c <= 2864)))))
              : (c <= 2867 || (c < 2929
                ? (c < 2908
                  ? (c < 2877
                    ? (c >= 2869 && c <= 2873)
                    : c <= 2877)
                  : (c <= 2909 || (c >= 2911 && c <= 2913)))
                : (c <= 2929 || (c < 2958
                  ? (c < 2949
                    ? c == 2947
                    : c <= 2954)
                  : (c <= 2960 || (c >= 2962 && c <= 2965)))))))
            : (c <= 2970 || (c < 3114
              ? (c < 2990
                ? (c < 2979
                  ? (c < 2974
                    ? c == 2972
                    : c <= 2975)
                  : (c <= 2980 || (c >= 2984 && c <= 2986)))
                : (c <= 3001 || (c < 3086
                  ? (c < 3077
                    ? c == 3024
                    : c <= 3084)
                  : (c <= 3088 || (c >= 3090 && c <= 3112)))))
              : (c <= 3129 || (c < 3200
                ? (c < 3165
                  ? (c < 3160
                    ? c == 3133
                    : c <= 3162)
                  : (c <= 3165 || (c >= 3168 && c <= 3169)))
                : (c <= 3200 || (c < 3218
                  ? (c < 3214
                    ? (c >= 3205 && c <= 3212)
                    : c <= 3216)
                  : (c <= 3240 || (c >= 3242 && c <= 3251)))))))))
          : (c <= 3257 || (c < 3713
            ? (c < 3423
              ? (c < 3342
                ? (c < 3296
                  ? (c < 3293
                    ? c == 3261
                    : c <= 3294)
                  : (c <= 3297 || (c < 3332
                    ? (c >= 3313 && c <= 3314)
                    : c <= 3340)))
                : (c <= 3344 || (c < 3406
                  ? (c < 3389
                    ? (c >= 3346 && c <= 3386)
                    : c <= 3389)
                  : (c <= 3406 || (c >= 3412 && c <= 3414)))))
              : (c <= 3425 || (c < 3517
                ? (c < 3482
                  ? (c < 3461
                    ? (c >= 3450 && c <= 3455)
                    : c <= 3478)
                  : (c <= 3505 || (c >= 3507 && c <= 3515)))
                : (c <= 3517 || (c < 3634
                  ? (c < 3585
                    ? (c >= 3520 && c <= 3526)
                    : c <= 3632)
                  : (c <= 3634 || (c >= 3648 && c <= 3654)))))))
            : (c <= 3714 || (c < 3804
              ? (c < 3751
                ? (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || c == 3749))
                : (c <= 3760 || (c < 3776
                  ? (c < 3773
                    ? c == 3762
                    : c <= 3773)
                  : (c <= 3780 || c == 3782))))
              : (c <= 3807 || (c < 4096
                ? (c < 3913
                  ? (c < 3904
                    ? c == 3840
                    : c <= 3911)
                  : (c <= 3948 || (c >= 3976 && c <= 3980)))
                : (c <= 4138 || (c < 4186
                  ? (c < 4176
                    ? c == 4159
                    : c <= 4181)
                  : (c <= 4189 || c == 4193))))))))))))
      : (c <= 4198 || (c < 8144
        ? (c < 6272
          ? (c < 4824
            ? (c < 4696
              ? (c < 4301
                ? (c < 4238
                  ? (c < 4213
                    ? (c >= 4206 && c <= 4208)
                    : c <= 4225)
                  : (c <= 4238 || (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)))
                : (c <= 4301 || (c < 4682
                  ? (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)
                  : (c <= 4685 || (c >= 4688 && c <= 4694)))))
              : (c <= 4696 || (c < 4786
                ? (c < 4746
                  ? (c < 4704
                    ? (c >= 4698 && c <= 4701)
                    : c <= 4744)
                  : (c <= 4749 || (c >= 4752 && c <= 4784)))
                : (c <= 4789 || (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c >= 4808 && c <= 4822)))))))
            : (c <= 4880 || (c < 5870
              ? (c < 5112
                ? (c < 4992
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 5007 || (c >= 5024 && c <= 5109)))
                : (c <= 5117 || (c < 5761
                  ? (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)
                  : (c <= 5786 || (c >= 5792 && c <= 5866)))))
              : (c <= 5880 || (c < 5998
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5905)
                    : c <= 5937)
                  : (c <= 5969 || (c >= 5984 && c <= 5996)))
                : (c <= 6000 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6067)
                    : c <= 6103)
                  : (c <= 6108 || (c >= 6176 && c <= 6264)))))))))
          : (c <= 6312 || (c < 7357
            ? (c < 6917
              ? (c < 6528
                ? (c < 6400
                  ? (c < 6320
                    ? c == 6314
                    : c <= 6389)
                  : (c <= 6430 || (c < 6512
                    ? (c >= 6480 && c <= 6509)
                    : c <= 6516)))
                : (c <= 6571 || (c < 6688
                  ? (c < 6656
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6678)
                  : (c <= 6740 || c == 6823))))
              : (c <= 6963 || (c < 7168
                ? (c < 7086
                  ? (c < 7043
                    ? (c >= 6981 && c <= 6988)
                    : c <= 7072)
                  : (c <= 7087 || (c >= 7098 && c <= 7141)))
                : (c <= 7203 || (c < 7296
                  ? (c < 7258
                    ? (c >= 7245 && c <= 7247)
                    : c <= 7293)
                  : (c <= 7304 || (c >= 7312 && c <= 7354)))))))
            : (c <= 7359 || (c < 8016
              ? (c < 7424
                ? (c < 7413
                  ? (c < 7406
                    ? (c >= 7401 && c <= 7404)
                    : c <= 7411)
                  : (c <= 7414 || c == 7418))
                : (c <= 7615 || (c < 7968
                  ? (c < 7960
                    ? (c >= 7680 && c <= 7957)
                    : c <= 7965)
                  : (c <= 8005 || (c >= 8008 && c <= 8013)))))
              : (c <= 8023 || (c < 8064
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c >= 8031 && c <= 8061)))
                : (c <= 8116 || (c < 8130
                  ? (c < 8126
                    ? (c >= 8118 && c <= 8124)
                    : c <= 8126)
                  : (c <= 8132 || (c >= 8134 && c <= 8140)))))))))))
        : (c <= 8147 || (c < 12344
          ? (c < 11264
            ? (c < 8469
              ? (c < 8319
                ? (c < 8178
                  ? (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)
                  : (c <= 8180 || (c < 8305
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8305)))
                : (c <= 8319 || (c < 8455
                  ? (c < 8450
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8450)
                  : (c <= 8455 || (c >= 8458 && c <= 8467)))))
              : (c <= 8469 || (c < 8490
                ? (c < 8486
                  ? (c < 8484
                    ? (c >= 8472 && c <= 8477)
                    : c <= 8484)
                  : (c <= 8486 || c == 8488))
                : (c <= 8505 || (c < 8526
                  ? (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)
                  : (c <= 8526 || (c >= 8544 && c <= 8584)))))))
            : (c <= 11492 || (c < 11688
              ? (c < 11565
                ? (c < 11520
                  ? (c < 11506
                    ? (c >= 11499 && c <= 11502)
                    : c <= 11507)
                  : (c <= 11557 || c == 11559))
                : (c <= 11565 || (c < 11648
                  ? (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)
                  : (c <= 11670 || (c >= 11680 && c <= 11686)))))
              : (c <= 11694 || (c < 11728
                ? (c < 11712
                  ? (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)
                  : (c <= 11718 || (c >= 11720 && c <= 11726)))
                : (c <= 11734 || (c < 12321
                  ? (c < 12293
                    ? (c >= 11736 && c <= 11742)
                    : c <= 12295)
                  : (c <= 12329 || (c >= 12337 && c <= 12341)))))))))
          : (c <= 12348 || (c < 42960
            ? (c < 42192
              ? (c < 12593
                ? (c < 12449
                  ? (c < 12445
                    ? (c >= 12353 && c <= 12438)
                    : c <= 12447)
                  : (c <= 12538 || (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)))
                : (c <= 12686 || (c < 13312
                  ? (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)
                  : (c <= 19903 || (c >= 19968 && c <= 42124)))))
              : (c <= 42237 || (c < 42623
                ? (c < 42538
                  ? (c < 42512
                    ? (c >= 42240 && c <= 42508)
                    : c <= 42527)
                  : (c <= 42539 || (c >= 42560 && c <= 42606)))
                : (c <= 42653 || (c < 42786
                  ? (c < 42775
                    ? (c >= 42656 && c <= 42735)
                    : c <= 42783)
                  : (c <= 42888 || (c >= 42891 && c <= 42954)))))))
            : (c <= 42961 || (c < 43259
              ? (c < 43015
                ? (c < 42994
                  ? (c < 42965
                    ? c == 42963
                    : c <= 42969)
                  : (c <= 43009 || (c >= 43011 && c <= 43013)))
                : (c <= 43018 || (c < 43138
                  ? (c < 43072
                    ? (c >= 43020 && c <= 43042)
                    : c <= 43123)
                  : (c <= 43187 || (c >= 43250 && c <= 43255)))))
              : (c <= 43259 || (c < 43396
                ? (c < 43312
                  ? (c < 43274
                    ? (c >= 43261 && c <= 43262)
                    : c <= 43301)
                  : (c <= 43334 || (c >= 43360 && c <= 43388)))
                : (c <= 43442 || (c < 43494
                  ? (c < 43488
                    ? c == 43471
                    : c <= 43492)
                  : (c <= 43503 || (c >= 43514 && c <= 43518)))))))))))))))
    : (c <= 43560 || (c < 70751
      ? (c < 66964
        ? (c < 65008
          ? (c < 43888
            ? (c < 43739
              ? (c < 43697
                ? (c < 43616
                  ? (c < 43588
                    ? (c >= 43584 && c <= 43586)
                    : c <= 43595)
                  : (c <= 43638 || (c < 43646
                    ? c == 43642
                    : c <= 43695)))
                : (c <= 43697 || (c < 43712
                  ? (c < 43705
                    ? (c >= 43701 && c <= 43702)
                    : c <= 43709)
                  : (c <= 43712 || c == 43714))))
              : (c <= 43741 || (c < 43793
                ? (c < 43777
                  ? (c < 43762
                    ? (c >= 43744 && c <= 43754)
                    : c <= 43764)
                  : (c <= 43782 || (c >= 43785 && c <= 43790)))
                : (c <= 43798 || (c < 43824
                  ? (c < 43816
                    ? (c >= 43808 && c <= 43814)
                    : c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))))))
            : (c <= 44002 || (c < 64298
              ? (c < 64112
                ? (c < 55243
                  ? (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)
                  : (c <= 55291 || (c >= 63744 && c <= 64109)))
                : (c <= 64217 || (c < 64285
                  ? (c < 64275
                    ? (c >= 64256 && c <= 64262)
                    : c <= 64279)
                  : (c <= 64285 || (c >= 64287 && c <= 64296)))))
              : (c <= 64310 || (c < 64326
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c >= 64323 && c <= 64324)))
                : (c <= 64433 || (c < 64848
                  ? (c < 64612
                    ? (c >= 64467 && c <= 64605)
                    : c <= 64829)
                  : (c <= 64911 || (c >= 64914 && c <= 64967)))))))))
          : (c <= 65017 || (c < 65616
            ? (c < 65440
              ? (c < 65149
                ? (c < 65143
                  ? (c < 65139
                    ? c == 65137
                    : c <= 65139)
                  : (c <= 65143 || (c < 65147
                    ? c == 65145
                    : c <= 65147)))
                : (c <= 65149 || (c < 65345
                  ? (c < 65313
                    ? (c >= 65151 && c <= 65276)
                    : c <= 65338)
                  : (c <= 65370 || (c >= 65382 && c <= 65437)))))
              : (c <= 65470 || (c < 65536
                ? (c < 65490
                  ? (c < 65482
                    ? (c >= 65474 && c <= 65479)
                    : c <= 65487)
                  : (c <= 65495 || (c >= 65498 && c <= 65500)))
                : (c <= 65547 || (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c >= 65599 && c <= 65613)))))))
            : (c <= 65629 || (c < 66504
              ? (c < 66304
                ? (c < 66176
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66204 || (c >= 66208 && c <= 66256)))
                : (c <= 66335 || (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66421)
                  : (c <= 66461 || (c >= 66464 && c <= 66499)))))
              : (c <= 66511 || (c < 66816
                ? (c < 66736
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66771 || (c >= 66776 && c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c >= 66956 && c <= 66962)))))))))))
        : (c <= 66965 || (c < 69248
          ? (c < 67840
            ? (c < 67584
              ? (c < 67392
                ? (c < 66995
                  ? (c < 66979
                    ? (c >= 66967 && c <= 66977)
                    : c <= 66993)
                  : (c <= 67001 || (c < 67072
                    ? (c >= 67003 && c <= 67004)
                    : c <= 67382)))
                : (c <= 67413 || (c < 67463
                  ? (c < 67456
                    ? (c >= 67424 && c <= 67431)
                    : c <= 67461)
                  : (c <= 67504 || (c >= 67506 && c <= 67514)))))
              : (c <= 67589 || (c < 67647
                ? (c < 67639
                  ? (c < 67594
                    ? c == 67592
                    : c <= 67637)
                  : (c <= 67640 || c == 67644))
                : (c <= 67669 || (c < 67808
                  ? (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)
                  : (c <= 67826 || (c >= 67828 && c <= 67829)))))))
            : (c <= 67861 || (c < 68288
              ? (c < 68112
                ? (c < 68030
                  ? (c < 67968
                    ? (c >= 67872 && c <= 67897)
                    : c <= 68023)
                  : (c <= 68031 || c == 68096))
                : (c <= 68115 || (c < 68192
                  ? (c < 68121
                    ? (c >= 68117 && c <= 68119)
                    : c <= 68149)
                  : (c <= 68220 || (c >= 68224 && c <= 68252)))))
              : (c <= 68295 || (c < 68480
                ? (c < 68416
                  ? (c < 68352
                    ? (c >= 68297 && c <= 68324)
                    : c <= 68405)
                  : (c <= 68437 || (c >= 68448 && c <= 68466)))
                : (c <= 68497 || (c < 68800
                  ? (c < 68736
                    ? (c >= 68608 && c <= 68680)
                    : c <= 68786)
                  : (c <= 68850 || (c >= 68864 && c <= 68899)))))))))
          : (c <= 69289 || (c < 70108
            ? (c < 69763
              ? (c < 69552
                ? (c < 69415
                  ? (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)
                  : (c <= 69415 || (c < 69488
                    ? (c >= 69424 && c <= 69445)
                    : c <= 69505)))
                : (c <= 69572 || (c < 69745
                  ? (c < 69635
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69687)
                  : (c <= 69746 || c == 69749))))
              : (c <= 69807 || (c < 69968
                ? (c < 69956
                  ? (c < 69891
                    ? (c >= 69840 && c <= 69864)
                    : c <= 69926)
                  : (c <= 69956 || c == 69959))
                : (c <= 70002 || (c < 70081
                  ? (c < 70019
                    ? c == 70006
                    : c <= 70066)
                  : (c <= 70084 || c == 70106))))))
            : (c <= 70108 || (c < 70415
              ? (c < 70282
                ? (c < 70272
                  ? (c < 70163
                    ? (c >= 70144 && c <= 70161)
                    : c <= 70187)
                  : (c <= 70278 || c == 70280))
                : (c <= 70285 || (c < 70320
                  ? (c < 70303
                    ? (c >= 70287 && c <= 70301)
                    : c <= 70312)
                  : (c <= 70366 || (c >= 70405 && c <= 70412)))))
              : (c <= 70416 || (c < 70461
                ? (c < 70450
                  ? (c < 70442
                    ? (c >= 70419 && c <= 70440)
                    : c <= 70448)
                  : (c <= 70451 || (c >= 70453 && c <= 70457)))
                : (c <= 70461 || (c < 70656
                  ? (c < 70493
                    ? c == 70480
                    : c <= 70497)
                  : (c <= 70708 || (c >= 70727 && c <= 70730)))))))))))))
      : (c <= 70753 || (c < 119966
        ? (c < 73063
          ? (c < 72096
            ? (c < 71488
              ? (c < 71168
                ? (c < 70855
                  ? (c < 70852
                    ? (c >= 70784 && c <= 70831)
                    : c <= 70853)
                  : (c <= 70855 || (c < 71128
                    ? (c >= 71040 && c <= 71086)
                    : c <= 71131)))
                : (c <= 71215 || (c < 71352
                  ? (c < 71296
                    ? c == 71236
                    : c <= 71338)
                  : (c <= 71352 || (c >= 71424 && c <= 71450)))))
              : (c <= 71494 || (c < 71948
                ? (c < 71935
                  ? (c < 71840
                    ? (c >= 71680 && c <= 71723)
                    : c <= 71903)
                  : (c <= 71942 || c == 71945))
                : (c <= 71955 || (c < 71999
                  ? (c < 71960
                    ? (c >= 71957 && c <= 71958)
                    : c <= 71983)
                  : (c <= 71999 || c == 72001))))))
            : (c <= 72103 || (c < 72368
              ? (c < 72203
                ? (c < 72163
                  ? (c < 72161
                    ? (c >= 72106 && c <= 72144)
                    : c <= 72161)
                  : (c <= 72163 || c == 72192))
                : (c <= 72242 || (c < 72284
                  ? (c < 72272
                    ? c == 72250
                    : c <= 72272)
                  : (c <= 72329 || c == 72349))))
              : (c <= 72440 || (c < 72960
                ? (c < 72768
                  ? (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72750)
                  : (c <= 72768 || (c >= 72818 && c <= 72847)))
                : (c <= 72966 || (c < 73030
                  ? (c < 72971
                    ? (c >= 72968 && c <= 72969)
                    : c <= 73008)
                  : (c <= 73030 || (c >= 73056 && c <= 73061)))))))))
          : (c <= 73064 || (c < 94032
            ? (c < 92160
              ? (c < 74752
                ? (c < 73440
                  ? (c < 73112
                    ? (c >= 73066 && c <= 73097)
                    : c <= 73112)
                  : (c <= 73458 || (c < 73728
                    ? c == 73648
                    : c <= 74649)))
                : (c <= 74862 || (c < 77824
                  ? (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)
                  : (c <= 78894 || (c >= 82944 && c <= 83526)))))
              : (c <= 92728 || (c < 92992
                ? (c < 92880
                  ? (c < 92784
                    ? (c >= 92736 && c <= 92766)
                    : c <= 92862)
                  : (c <= 92909 || (c >= 92928 && c <= 92975)))
                : (c <= 92995 || (c < 93760
                  ? (c < 93053
                    ? (c >= 93027 && c <= 93047)
                    : c <= 93071)
                  : (c <= 93823 || (c >= 93952 && c <= 94026)))))))
            : (c <= 94032 || (c < 110592
              ? (c < 100352
                ? (c < 94179
                  ? (c < 94176
                    ? (c >= 94099 && c <= 94111)
                    : c <= 94177)
                  : (c <= 94179 || (c >= 94208 && c <= 100343)))
                : (c <= 101589 || (c < 110581
                  ? (c < 110576
                    ? (c >= 101632 && c <= 101640)
                    : c <= 110579)
                  : (c <= 110587 || (c >= 110589 && c <= 110590)))))
              : (c <= 110882 || (c < 113776
                ? (c < 110960
                  ? (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)
                  : (c <= 111355 || (c >= 113664 && c <= 113770)))
                : (c <= 113788 || (c < 119808
                  ? (c < 113808
                    ? (c >= 113792 && c <= 113800)
                    : c <= 113817)
                  : (c <= 119892 || (c >= 119894 && c <= 119964)))))))))))
        : (c <= 119967 || (c < 126464
          ? (c < 120598
            ? (c < 120094
              ? (c < 119997
                ? (c < 119977
                  ? (c < 119973
                    ? c == 119970
                    : c <= 119974)
                  : (c <= 119980 || (c < 119995
                    ? (c >= 119982 && c <= 119993)
                    : c <= 119995)))
                : (c <= 120003 || (c < 120077
                  ? (c < 120071
                    ? (c >= 120005 && c <= 120069)
                    : c <= 120074)
                  : (c <= 120084 || (c >= 120086 && c <= 120092)))))
              : (c <= 120121 || (c < 120146
                ? (c < 120134
                  ? (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)
                  : (c <= 120134 || (c >= 120138 && c <= 120144)))
                : (c <= 120485 || (c < 120540
                  ? (c < 120514
                    ? (c >= 120488 && c <= 120512)
                    : c <= 120538)
                  : (c <= 120570 || (c >= 120572 && c <= 120596)))))))
            : (c <= 120628 || (c < 123214
              ? (c < 120746
                ? (c < 120688
                  ? (c < 120656
                    ? (c >= 120630 && c <= 120654)
                    : c <= 120686)
                  : (c <= 120712 || (c >= 120714 && c <= 120744)))
                : (c <= 120770 || (c < 123136
                  ? (c < 122624
                    ? (c >= 120772 && c <= 120779)
                    : c <= 122654)
                  : (c <= 123180 || (c >= 123191 && c <= 123197)))))
              : (c <= 123214 || (c < 124909
                ? (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123565)
                    : c <= 123627)
                  : (c <= 124902 || (c >= 124904 && c <= 124907)))
                : (c <= 124910 || (c < 125184
                  ? (c < 124928
                    ? (c >= 124912 && c <= 124926)
                    : c <= 125124)
                  : (c <= 125251 || c == 125259))))))))
          : (c <= 126467 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126500
                  ? (c < 126497
                    ? (c >= 126469 && c <= 126495)
                    : c <= 126498)
                  : (c <= 126500 || c == 126503))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_6(int32_t c) {
  return (c < 43471
    ? (c < 4096
      ? (c < 2649
        ? (c < 1791
          ? (c < 891
            ? (c < 186
              ? (c < '_'
                ? (c < 'M'
                  ? (c < 'A'
                    ? c == '$'
                    : c <= 'K')
                  : (c <= 'Q' || (c < 'V'
                    ? (c >= 'S' && c <= 'T')
                    : c <= 'Z')))
                : (c <= '_' || (c < 170
                  ? (c < 'v'
                    ? (c >= 'a' && c <= 't')
                    : c <= 'z')
                  : (c <= 170 || c == 181))))
              : (c <= 186 || (c < 736
                ? (c < 248
                  ? (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))
                : (c <= 740 || (c < 880
                  ? (c < 750
                    ? c == 748
                    : c <= 750)
                  : (c <= 884 || (c >= 886 && c <= 887)))))))
            : (c <= 893 || (c < 1376
              ? (c < 931
                ? (c < 904
                  ? (c < 902
                    ? c == 895
                    : c <= 902)
                  : (c <= 906 || (c < 910
                    ? c == 908
                    : c <= 929)))
                : (c <= 1013 || (c < 1329
                  ? (c < 1162
                    ? (c >= 1015 && c <= 1153)
                    : c <= 1327)
                  : (c <= 1366 || c == 1369))))
              : (c <= 1416 || (c < 1649
                ? (c < 1568
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))
                : (c <= 1747 || (c < 1774
                  ? (c < 1765
                    ? c == 1749
                    : c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))))))))
          : (c <= 1791 || (c < 2417
            ? (c < 2088
              ? (c < 2036
                ? (c < 1869
                  ? (c < 1810
                    ? c == 1808
                    : c <= 1839)
                  : (c <= 1957 || (c < 1994
                    ? c == 1969
                    : c <= 2026)))
                : (c <= 2037 || (c < 2074
                  ? (c < 2048
                    ? c == 2042
                    : c <= 2069)
                  : (c <= 2074 || c == 2084))))
              : (c <= 2088 || (c < 2208
                ? (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2136)
                    : c <= 2154)
                  : (c <= 2183 || (c >= 2185 && c <= 2190)))
                : (c <= 2249 || (c < 2384
                  ? (c < 2365
                    ? (c >= 2308 && c <= 2361)
                    : c <= 2365)
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))))))
            : (c <= 2432 || (c < 2527
              ? (c < 2482
                ? (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c >= 2474 && c <= 2480)))
                : (c <= 2482 || (c < 2510
                  ? (c < 2493
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2493)
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))))
              : (c <= 2529 || (c < 2579
                ? (c < 2565
                  ? (c < 2556
                    ? (c >= 2544 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c >= 2616 && c <= 2617)))))))))))
        : (c <= 2652 || (c < 3200
          ? (c < 2911
            ? (c < 2784
              ? (c < 2730
                ? (c < 2693
                  ? (c < 2674
                    ? c == 2654
                    : c <= 2676)
                  : (c <= 2701 || (c < 2707
                    ? (c >= 2703 && c <= 2705)
                    : c <= 2728)))
                : (c <= 2736 || (c < 2749
                  ? (c < 2741
                    ? (c >= 2738 && c <= 2739)
                    : c <= 2745)
                  : (c <= 2749 || c == 2768))))
              : (c <= 2785 || (c < 2858
                ? (c < 2831
                  ? (c < 2821
                    ? c == 2809
                    : c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))
                : (c <= 2864 || (c < 2877
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))))))
            : (c <= 2913 || (c < 2990
              ? (c < 2969
                ? (c < 2949
                  ? (c < 2947
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c < 2962
                    ? (c >= 2958 && c <= 2960)
                    : c <= 2965)))
                : (c <= 2970 || (c < 2979
                  ? (c < 2974
                    ? c == 2972
                    : c <= 2975)
                  : (c <= 2980 || (c >= 2984 && c <= 2986)))))
              : (c <= 3001 || (c < 3114
                ? (c < 3086
                  ? (c < 3077
                    ? c == 3024
                    : c <= 3084)
                  : (c <= 3088 || (c >= 3090 && c <= 3112)))
                : (c <= 3129 || (c < 3165
                  ? (c < 3160
                    ? c == 3133
                    : c <= 3162)
                  : (c <= 3165 || (c >= 3168 && c <= 3169)))))))))
          : (c <= 3200 || (c < 3517
            ? (c < 3342
              ? (c < 3261
                ? (c < 3218
                  ? (c < 3214
                    ? (c >= 3205 && c <= 3212)
                    : c <= 3216)
                  : (c <= 3240 || (c < 3253
                    ? (c >= 3242 && c <= 3251)
                    : c <= 3257)))
                : (c <= 3261 || (c < 3313
                  ? (c < 3296
                    ? (c >= 3293 && c <= 3294)
                    : c <= 3297)
                  : (c <= 3314 || (c >= 3332 && c <= 3340)))))
              : (c <= 3344 || (c < 3423
                ? (c < 3406
                  ? (c < 3389
                    ? (c >= 3346 && c <= 3386)
                    : c <= 3389)
                  : (c <= 3406 || (c >= 3412 && c <= 3414)))
                : (c <= 3425 || (c < 3482
                  ? (c < 3461
                    ? (c >= 3450 && c <= 3455)
                    : c <= 3478)
                  : (c <= 3505 || (c >= 3507 && c <= 3515)))))))
            : (c <= 3517 || (c < 3751
              ? (c < 3713
                ? (c < 3634
                  ? (c < 3585
                    ? (c >= 3520 && c <= 3526)
                    : c <= 3632)
                  : (c <= 3634 || (c >= 3648 && c <= 3654)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || c == 3749))))
              : (c <= 3760 || (c < 3804
                ? (c < 3776
                  ? (c < 3773
                    ? c == 3762
                    : c <= 3773)
                  : (c <= 3780 || c == 3782))
                : (c <= 3807 || (c < 3913
                  ? (c < 3904
                    ? c == 3840
                    : c <= 3911)
                  : (c <= 3948 || (c >= 3976 && c <= 3980)))))))))))))
      : (c <= 4138 || (c < 8118
        ? (c < 6016
          ? (c < 4786
            ? (c < 4301
              ? (c < 4206
                ? (c < 4186
                  ? (c < 4176
                    ? c == 4159
                    : c <= 4181)
                  : (c <= 4189 || (c < 4197
                    ? c == 4193
                    : c <= 4198)))
                : (c <= 4208 || (c < 4256
                  ? (c < 4238
                    ? (c >= 4213 && c <= 4225)
                    : c <= 4238)
                  : (c <= 4293 || c == 4295))))
              : (c <= 4301 || (c < 4696
                ? (c < 4682
                  ? (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)
                  : (c <= 4685 || (c >= 4688 && c <= 4694)))
                : (c <= 4696 || (c < 4746
                  ? (c < 4704
                    ? (c >= 4698 && c <= 4701)
                    : c <= 4744)
                  : (c <= 4749 || (c >= 4752 && c <= 4784)))))))
            : (c <= 4789 || (c < 5121
              ? (c < 4882
                ? (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)))
                : (c <= 4885 || (c < 5024
                  ? (c < 4992
                    ? (c >= 4888 && c <= 4954)
                    : c <= 5007)
                  : (c <= 5109 || (c >= 5112 && c <= 5117)))))
              : (c <= 5740 || (c < 5888
                ? (c < 5792
                  ? (c < 5761
                    ? (c >= 5743 && c <= 5759)
                    : c <= 5786)
                  : (c <= 5866 || (c >= 5870 && c <= 5880)))
                : (c <= 5905 || (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5937)
                    : c <= 5969)
                  : (c <= 5996 || (c >= 5998 && c <= 6000)))))))))
          : (c <= 6067 || (c < 7245
            ? (c < 6576
              ? (c < 6320
                ? (c < 6176
                  ? (c < 6108
                    ? c == 6103
                    : c <= 6108)
                  : (c <= 6264 || (c < 6314
                    ? (c >= 6272 && c <= 6312)
                    : c <= 6314)))
                : (c <= 6389 || (c < 6512
                  ? (c < 6480
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6509)
                  : (c <= 6516 || (c >= 6528 && c <= 6571)))))
              : (c <= 6601 || (c < 6981
                ? (c < 6823
                  ? (c < 6688
                    ? (c >= 6656 && c <= 6678)
                    : c <= 6740)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))
                : (c <= 6988 || (c < 7098
                  ? (c < 7086
                    ? (c >= 7043 && c <= 7072)
                    : c <= 7087)
                  : (c <= 7141 || (c >= 7168 && c <= 7203)))))))
            : (c <= 7247 || (c < 7680
              ? (c < 7401
                ? (c < 7312
                  ? (c < 7296
                    ? (c >= 7258 && c <= 7293)
                    : c <= 7304)
                  : (c <= 7354 || (c >= 7357 && c <= 7359)))
                : (c <= 7404 || (c < 7418
                  ? (c < 7413
                    ? (c >= 7406 && c <= 7411)
                    : c <= 7414)
                  : (c <= 7418 || (c >= 7424 && c <= 7615)))))
              : (c <= 7957 || (c < 8025
                ? (c < 8008
                  ? (c < 7968
                    ? (c >= 7960 && c <= 7965)
                    : c <= 8005)
                  : (c <= 8013 || (c >= 8016 && c <= 8023)))
                : (c <= 8025 || (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8061 || (c >= 8064 && c <= 8116)))))))))))
        : (c <= 8124 || (c < 11736
          ? (c < 8508
            ? (c < 8336
              ? (c < 8160
                ? (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))
                : (c <= 8172 || (c < 8305
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8305 || c == 8319))))
              : (c <= 8348 || (c < 8472
                ? (c < 8458
                  ? (c < 8455
                    ? c == 8450
                    : c <= 8455)
                  : (c <= 8467 || c == 8469))
                : (c <= 8477 || (c < 8488
                  ? (c < 8486
                    ? c == 8484
                    : c <= 8486)
                  : (c <= 8488 || (c >= 8490 && c <= 8505)))))))
            : (c <= 8511 || (c < 11568
              ? (c < 11499
                ? (c < 8544
                  ? (c < 8526
                    ? (c >= 8517 && c <= 8521)
                    : c <= 8526)
                  : (c <= 8584 || (c >= 11264 && c <= 11492)))
                : (c <= 11502 || (c < 11559
                  ? (c < 11520
                    ? (c >= 11506 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || c == 11565))))
              : (c <= 11623 || (c < 11696
                ? (c < 11680
                  ? (c < 11648
                    ? c == 11631
                    : c <= 11670)
                  : (c <= 11686 || (c >= 11688 && c <= 11694)))
                : (c <= 11702 || (c < 11720
                  ? (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)
                  : (c <= 11726 || (c >= 11728 && c <= 11734)))))))))
          : (c <= 11742 || (c < 42656
            ? (c < 12704
              ? (c < 12445
                ? (c < 12337
                  ? (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12329)
                  : (c <= 12341 || (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)))
                : (c <= 12447 || (c < 12549
                  ? (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)
                  : (c <= 12591 || (c >= 12593 && c <= 12686)))))
              : (c <= 12735 || (c < 42240
                ? (c < 19968
                  ? (c < 13312
                    ? (c >= 12784 && c <= 12799)
                    : c <= 19903)
                  : (c <= 42124 || (c >= 42192 && c <= 42237)))
                : (c <= 42508 || (c < 42560
                  ? (c < 42538
                    ? (c >= 42512 && c <= 42527)
                    : c <= 42539)
                  : (c <= 42606 || (c >= 42623 && c <= 42653)))))))
            : (c <= 42735 || (c < 43020
              ? (c < 42963
                ? (c < 42891
                  ? (c < 42786
                    ? (c >= 42775 && c <= 42783)
                    : c <= 42888)
                  : (c <= 42954 || (c >= 42960 && c <= 42961)))
                : (c <= 42963 || (c < 43011
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43009)
                  : (c <= 43013 || (c >= 43015 && c <= 43018)))))
              : (c <= 43042 || (c < 43261
                ? (c < 43250
                  ? (c < 43138
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43187)
                  : (c <= 43255 || c == 43259))
                : (c <= 43262 || (c < 43360
                  ? (c < 43312
                    ? (c >= 43274 && c <= 43301)
                    : c <= 43334)
                  : (c <= 43388 || (c >= 43396 && c <= 43442)))))))))))))))
    : (c <= 43471 || (c < 70656
      ? (c < 66928
        ? (c < 64612
          ? (c < 43808
            ? (c < 43701
              ? (c < 43588
                ? (c < 43514
                  ? (c < 43494
                    ? (c >= 43488 && c <= 43492)
                    : c <= 43503)
                  : (c <= 43518 || (c < 43584
                    ? (c >= 43520 && c <= 43560)
                    : c <= 43586)))
                : (c <= 43595 || (c < 43646
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43642)
                  : (c <= 43695 || c == 43697))))
              : (c <= 43702 || (c < 43744
                ? (c < 43714
                  ? (c < 43712
                    ? (c >= 43705 && c <= 43709)
                    : c <= 43712)
                  : (c <= 43714 || (c >= 43739 && c <= 43741)))
                : (c <= 43754 || (c < 43785
                  ? (c < 43777
                    ? (c >= 43762 && c <= 43764)
                    : c <= 43782)
                  : (c <= 43790 || (c >= 43793 && c <= 43798)))))))
            : (c <= 43814 || (c < 64275
              ? (c < 55216
                ? (c < 43868
                  ? (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)
                  : (c <= 43881 || (c < 44032
                    ? (c >= 43888 && c <= 44002)
                    : c <= 55203)))
                : (c <= 55238 || (c < 64112
                  ? (c < 63744
                    ? (c >= 55243 && c <= 55291)
                    : c <= 64109)
                  : (c <= 64217 || (c >= 64256 && c <= 64262)))))
              : (c <= 64279 || (c < 64318
                ? (c < 64298
                  ? (c < 64287
                    ? c == 64285
                    : c <= 64296)
                  : (c <= 64310 || (c >= 64312 && c <= 64316)))
                : (c <= 64318 || (c < 64326
                  ? (c < 64323
                    ? (c >= 64320 && c <= 64321)
                    : c <= 64324)
                  : (c <= 64433 || (c >= 64467 && c <= 64605)))))))))
          : (c <= 64829 || (c < 65576
            ? (c < 65313
              ? (c < 65143
                ? (c < 65008
                  ? (c < 64914
                    ? (c >= 64848 && c <= 64911)
                    : c <= 64967)
                  : (c <= 65017 || (c < 65139
                    ? c == 65137
                    : c <= 65139)))
                : (c <= 65143 || (c < 65149
                  ? (c < 65147
                    ? c == 65145
                    : c <= 65147)
                  : (c <= 65149 || (c >= 65151 && c <= 65276)))))
              : (c <= 65338 || (c < 65482
                ? (c < 65440
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65437)
                  : (c <= 65470 || (c >= 65474 && c <= 65479)))
                : (c <= 65487 || (c < 65536
                  ? (c < 65498
                    ? (c >= 65490 && c <= 65495)
                    : c <= 65500)
                  : (c <= 65547 || (c >= 65549 && c <= 65574)))))))
            : (c <= 65594 || (c < 66384
              ? (c < 65856
                ? (c < 65616
                  ? (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)
                  : (c <= 65629 || (c >= 65664 && c <= 65786)))
                : (c <= 65908 || (c < 66304
                  ? (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66378)))))
              : (c <= 66421 || (c < 66560
                ? (c < 66504
                  ? (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)
                  : (c <= 66511 || (c >= 66513 && c <= 66517)))
                : (c <= 66717 || (c < 66816
                  ? (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)
                  : (c <= 66855 || (c >= 66864 && c <= 66915)))))))))))
        : (c <= 66938 || (c < 68800
          ? (c < 67712
            ? (c < 67456
              ? (c < 66995
                ? (c < 66964
                  ? (c < 66956
                    ? (c >= 66940 && c <= 66954)
                    : c <= 66962)
                  : (c <= 66965 || (c < 66979
                    ? (c >= 66967 && c <= 66977)
                    : c <= 66993)))
                : (c <= 67001 || (c < 67392
                  ? (c < 67072
                    ? (c >= 67003 && c <= 67004)
                    : c <= 67382)
                  : (c <= 67413 || (c >= 67424 && c <= 67431)))))
              : (c <= 67461 || (c < 67594
                ? (c < 67584
                  ? (c < 67506
                    ? (c >= 67463 && c <= 67504)
                    : c <= 67514)
                  : (c <= 67589 || c == 67592))
                : (c <= 67637 || (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c >= 67680 && c <= 67702)))))))
            : (c <= 67742 || (c < 68192
              ? (c < 68030
                ? (c < 67840
                  ? (c < 67828
                    ? (c >= 67808 && c <= 67826)
                    : c <= 67829)
                  : (c <= 67861 || (c < 67968
                    ? (c >= 67872 && c <= 67897)
                    : c <= 68023)))
                : (c <= 68031 || (c < 68117
                  ? (c < 68112
                    ? c == 68096
                    : c <= 68115)
                  : (c <= 68119 || (c >= 68121 && c <= 68149)))))
              : (c <= 68220 || (c < 68416
                ? (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68324 || (c >= 68352 && c <= 68405)))
                : (c <= 68437 || (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c >= 68736 && c <= 68786)))))))))
          : (c <= 68850 || (c < 70081
            ? (c < 69745
              ? (c < 69424
                ? (c < 69296
                  ? (c < 69248
                    ? (c >= 68864 && c <= 68899)
                    : c <= 69289)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))
                : (c <= 69445 || (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69505)
                    : c <= 69572)
                  : (c <= 69622 || (c >= 69635 && c <= 69687)))))
              : (c <= 69746 || (c < 69956
                ? (c < 69840
                  ? (c < 69763
                    ? c == 69749
                    : c <= 69807)
                  : (c <= 69864 || (c >= 69891 && c <= 69926)))
                : (c <= 69956 || (c < 70006
                  ? (c < 69968
                    ? c == 69959
                    : c <= 70002)
                  : (c <= 70006 || (c >= 70019 && c <= 70066)))))))
            : (c <= 70084 || (c < 70320
              ? (c < 70272
                ? (c < 70144
                  ? (c < 70108
                    ? c == 70106
                    : c <= 70108)
                  : (c <= 70161 || (c >= 70163 && c <= 70187)))
                : (c <= 70278 || (c < 70287
                  ? (c < 70282
                    ? c == 70280
                    : c <= 70285)
                  : (c <= 70301 || (c >= 70303 && c <= 70312)))))
              : (c <= 70366 || (c < 70450
                ? (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c >= 70442 && c <= 70448)))
                : (c <= 70451 || (c < 70480
                  ? (c < 70461
                    ? (c >= 70453 && c <= 70457)
                    : c <= 70461)
                  : (c <= 70480 || (c >= 70493 && c <= 70497)))))))))))))
      : (c <= 70708 || (c < 119894
        ? (c < 73056
          ? (c < 71999
            ? (c < 71352
              ? (c < 71040
                ? (c < 70784
                  ? (c < 70751
                    ? (c >= 70727 && c <= 70730)
                    : c <= 70753)
                  : (c <= 70831 || (c < 70855
                    ? (c >= 70852 && c <= 70853)
                    : c <= 70855)))
                : (c <= 71086 || (c < 71236
                  ? (c < 71168
                    ? (c >= 71128 && c <= 71131)
                    : c <= 71215)
                  : (c <= 71236 || (c >= 71296 && c <= 71338)))))
              : (c <= 71352 || (c < 71935
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71424 && c <= 71450)
                    : c <= 71494)
                  : (c <= 71723 || (c >= 71840 && c <= 71903)))
                : (c <= 71942 || (c < 71957
                  ? (c < 71948
                    ? c == 71945
                    : c <= 71955)
                  : (c <= 71958 || (c >= 71960 && c <= 71983)))))))
            : (c <= 71999 || (c < 72349
              ? (c < 72192
                ? (c < 72106
                  ? (c < 72096
                    ? c == 72001
                    : c <= 72103)
                  : (c <= 72144 || (c < 72163
                    ? c == 72161
                    : c <= 72163)))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_7(int32_t c) {
  return (c < 43360
    ? (c < 3840
      ? (c < 2602
        ? (c < 1649
          ? (c < 736
            ? (c < 'q'
              ? (c < 'a'
                ? (c < 'M'
                  ? (c < 'A'
                    ? c == '$'
                    : c <= 'K')
                  : (c <= 'T' || (c < '_'
                    ? (c >= 'V' && c <= 'Z')
                    : c <= '_')))
                : (c <= 'a' || (c < 'j'
                  ? (c < 'g'
                    ? c == 'e'
                    : c <= 'h')
                  : (c <= 'l' || c == 'o'))))
              : (c <= 'r' || (c < 186
                ? (c < 170
                  ? (c < 'w'
                    ? c == 't'
                    : c <= 'z')
                  : (c <= 170 || c == 181))
                : (c <= 186 || (c < 248
                  ? (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))))))
            : (c <= 740 || (c < 931
              ? (c < 895
                ? (c < 880
                  ? (c < 750
                    ? c == 748
                    : c <= 750)
                  : (c <= 884 || (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)))
                : (c <= 895 || (c < 908
                  ? (c < 904
                    ? c == 902
                    : c <= 906)
                  : (c <= 908 || (c >= 910 && c <= 929)))))
              : (c <= 1013 || (c < 1376
                ? (c < 1329
                  ? (c < 1162
                    ? (c >= 1015 && c <= 1153)
                    : c <= 1327)
                  : (c <= 1366 || c == 1369))
                : (c <= 1416 || (c < 1568
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))))))))
          : (c <= 1747 || (c < 2208
            ? (c < 2036
              ? (c < 1808
                ? (c < 1774
                  ? (c < 1765
                    ? c == 1749
                    : c <= 1766)
                  : (c <= 1775 || (c < 1791
                    ? (c >= 1786 && c <= 1788)
                    : c <= 1791)))
                : (c <= 1808 || (c < 1969
                  ? (c < 1869
                    ? (c >= 1810 && c <= 1839)
                    : c <= 1957)
                  : (c <= 1969 || (c >= 1994 && c <= 2026)))))
              : (c <= 2037 || (c < 2088
                ? (c < 2074
                  ? (c < 2048
                    ? c == 2042
                    : c <= 2069)
                  : (c <= 2074 || c == 2084))
                : (c <= 2088 || (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2136)
                    : c <= 2154)
                  : (c <= 2183 || (c >= 2185 && c <= 2190)))))))
            : (c <= 2249 || (c < 2486
              ? (c < 2437
                ? (c < 2384
                  ? (c < 2365
                    ? (c >= 2308 && c <= 2361)
                    : c <= 2365)
                  : (c <= 2384 || (c < 2417
                    ? (c >= 2392 && c <= 2401)
                    : c <= 2432)))
                : (c <= 2444 || (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || c == 2482))))
              : (c <= 2489 || (c < 2544
                ? (c < 2524
                  ? (c < 2510
                    ? c == 2493
                    : c <= 2510)
                  : (c <= 2525 || (c >= 2527 && c <= 2529)))
                : (c <= 2545 || (c < 2575
                  ? (c < 2565
                    ? c == 2556
                    : c <= 2570)
                  : (c <= 2576 || (c >= 2579 && c <= 2600)))))))))))
        : (c <= 2608 || (c < 3133
          ? (c < 2866
            ? (c < 2738
              ? (c < 2674
                ? (c < 2616
                  ? (c < 2613
                    ? (c >= 2610 && c <= 2611)
                    : c <= 2614)
                  : (c <= 2617 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2676 || (c < 2707
                  ? (c < 2703
                    ? (c >= 2693 && c <= 2701)
                    : c <= 2705)
                  : (c <= 2728 || (c >= 2730 && c <= 2736)))))
              : (c <= 2739 || (c < 2809
                ? (c < 2768
                  ? (c < 2749
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2749)
                  : (c <= 2768 || (c >= 2784 && c <= 2785)))
                : (c <= 2809 || (c < 2835
                  ? (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)
                  : (c <= 2856 || (c >= 2858 && c <= 2864)))))))
            : (c <= 2867 || (c < 2972
              ? (c < 2947
                ? (c < 2908
                  ? (c < 2877
                    ? (c >= 2869 && c <= 2873)
                    : c <= 2877)
                  : (c <= 2909 || (c < 2929
                    ? (c >= 2911 && c <= 2913)
                    : c <= 2929)))
                : (c <= 2947 || (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c >= 2969 && c <= 2970)))))
              : (c <= 2972 || (c < 3024
                ? (c < 2984
                  ? (c < 2979
                    ? (c >= 2974 && c <= 2975)
                    : c <= 2980)
                  : (c <= 2986 || (c >= 2990 && c <= 3001)))
                : (c <= 3024 || (c < 3090
                  ? (c < 3086
                    ? (c >= 3077 && c <= 3084)
                    : c <= 3088)
                  : (c <= 3112 || (c >= 3114 && c <= 3129)))))))))
          : (c <= 3133 || (c < 3450
            ? (c < 3293
              ? (c < 3214
                ? (c < 3168
                  ? (c < 3165
                    ? (c >= 3160 && c <= 3162)
                    : c <= 3165)
                  : (c <= 3169 || (c < 3205
                    ? c == 3200
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || c == 3261))))
              : (c <= 3294 || (c < 3346
                ? (c < 3332
                  ? (c < 3313
                    ? (c >= 3296 && c <= 3297)
                    : c <= 3314)
                  : (c <= 3340 || (c >= 3342 && c <= 3344)))
                : (c <= 3386 || (c < 3412
                  ? (c < 3406
                    ? c == 3389
                    : c <= 3406)
                  : (c <= 3414 || (c >= 3423 && c <= 3425)))))))
            : (c <= 3455 || (c < 3716
              ? (c < 3520
                ? (c < 3507
                  ? (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)
                  : (c <= 3515 || c == 3517))
                : (c <= 3526 || (c < 3648
                  ? (c < 3634
                    ? (c >= 3585 && c <= 3632)
                    : c <= 3634)
                  : (c <= 3654 || (c >= 3713 && c <= 3714)))))
              : (c <= 3716 || (c < 3762
                ? (c < 3749
                  ? (c < 3724
                    ? (c >= 3718 && c <= 3722)
                    : c <= 3747)
                  : (c <= 3749 || (c >= 3751 && c <= 3760)))
                : (c <= 3762 || (c < 3782
                  ? (c < 3776
                    ? c == 3773
                    : c <= 3780)
                  : (c <= 3782 || (c >= 3804 && c <= 3807)))))))))))))
      : (c <= 3840 || (c < 8029
        ? (c < 5919
          ? (c < 4698
            ? (c < 4213
              ? (c < 4176
                ? (c < 3976
                  ? (c < 3913
                    ? (c >= 3904 && c <= 3911)
                    : c <= 3948)
                  : (c <= 3980 || (c < 4159
                    ? (c >= 4096 && c <= 4138)
                    : c <= 4159)))
                : (c <= 4181 || (c < 4197
                  ? (c < 4193
                    ? (c >= 4186 && c <= 4189)
                    : c <= 4193)
                  : (c <= 4198 || (c >= 4206 && c <= 4208)))))
              : (c <= 4225 || (c < 4304
                ? (c < 4295
                  ? (c < 4256
                    ? c == 4238
                    : c <= 4293)
                  : (c <= 4295 || c == 4301))
                : (c <= 4346 || (c < 4688
                  ? (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)
                  : (c <= 4694 || c == 4696))))))
            : (c <= 4701 || (c < 4888
              ? (c < 4800
                ? (c < 4752
                  ? (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)
                  : (c <= 4784 || (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)))
                : (c <= 4800 || (c < 4824
                  ? (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)
                  : (c <= 4880 || (c >= 4882 && c <= 4885)))))
              : (c <= 4954 || (c < 5743
                ? (c < 5112
                  ? (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)
                  : (c <= 5117 || (c >= 5121 && c <= 5740)))
                : (c <= 5759 || (c < 5870
                  ? (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)
                  : (c <= 5880 || (c >= 5888 && c <= 5905)))))))))
          : (c <= 5937 || (c < 7043
            ? (c < 6400
              ? (c < 6108
                ? (c < 5998
                  ? (c < 5984
                    ? (c >= 5952 && c <= 5969)
                    : c <= 5996)
                  : (c <= 6000 || (c < 6103
                    ? (c >= 6016 && c <= 6067)
                    : c <= 6103)))
                : (c <= 6108 || (c < 6314
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6312)
                  : (c <= 6314 || (c >= 6320 && c <= 6389)))))
              : (c <= 6430 || (c < 6656
                ? (c < 6528
                  ? (c < 6512
                    ? (c >= 6480 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c >= 6576 && c <= 6601)))
                : (c <= 6678 || (c < 6917
                  ? (c < 6823
                    ? (c >= 6688 && c <= 6740)
                    : c <= 6823)
                  : (c <= 6963 || (c >= 6981 && c <= 6988)))))))
            : (c <= 7072 || (c < 7413
              ? (c < 7296
                ? (c < 7168
                  ? (c < 7098
                    ? (c >= 7086 && c <= 7087)
                    : c <= 7141)
                  : (c <= 7203 || (c < 7258
                    ? (c >= 7245 && c <= 7247)
                    : c <= 7293)))
                : (c <= 7304 || (c < 7401
                  ? (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)
                  : (c <= 7404 || (c >= 7406 && c <= 7411)))))
              : (c <= 7414 || (c < 7968
                ? (c < 7680
                  ? (c < 7424
                    ? c == 7418
                    : c <= 7615)
                  : (c <= 7957 || (c >= 7960 && c <= 7965)))
                : (c <= 8005 || (c < 8025
                  ? (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)
                  : (c <= 8025 || c == 8027))))))))))
        : (c <= 8029 || (c < 11720
          ? (c < 8486
            ? (c < 8182
              ? (c < 8134
                ? (c < 8118
                  ? (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)
                  : (c <= 8124 || (c < 8130
                    ? c == 8126
                    : c <= 8132)))
                : (c <= 8140 || (c < 8160
                  ? (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)
                  : (c <= 8172 || (c >= 8178 && c <= 8180)))))
              : (c <= 8188 || (c < 8455
                ? (c < 8336
                  ? (c < 8319
                    ? c == 8305
                    : c <= 8319)
                  : (c <= 8348 || c == 8450))
                : (c <= 8455 || (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || c == 8484))))))
            : (c <= 8486 || (c < 11559
              ? (c < 8544
                ? (c < 8508
                  ? (c < 8490
                    ? c == 8488
                    : c <= 8505)
                  : (c <= 8511 || (c < 8526
                    ? (c >= 8517 && c <= 8521)
                    : c <= 8526)))
                : (c <= 8584 || (c < 11506
                  ? (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11502)
                  : (c <= 11507 || (c >= 11520 && c <= 11557)))))
              : (c <= 11559 || (c < 11680
                ? (c < 11631
                  ? (c < 11568
                    ? c == 11565
                    : c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))
                : (c <= 11686 || (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c >= 11712 && c <= 11718)))))))))
          : (c <= 11726 || (c < 42560
            ? (c < 12549
              ? (c < 12344
                ? (c < 12293
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 12295 || (c < 12337
                    ? (c >= 12321 && c <= 12329)
                    : c <= 12341)))
                : (c <= 12348 || (c < 12449
                  ? (c < 12445
                    ? (c >= 12353 && c <= 12438)
                    : c <= 12447)
                  : (c <= 12538 || (c >= 12540 && c <= 12543)))))
              : (c <= 12591 || (c < 19968
                ? (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c >= 13312 && c <= 19903)))
                : (c <= 42124 || (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))))))
            : (c <= 42606 || (c < 43011
              ? (c < 42891
                ? (c < 42775
                  ? (c < 42656
                    ? (c >= 42623 && c <= 42653)
                    : c <= 42735)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))
                : (c <= 42954 || (c < 42965
                  ? (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)
                  : (c <= 42969 || (c >= 42994 && c <= 43009)))))
              : (c <= 43013 || (c < 43250
                ? (c < 43072
                  ? (c < 43020
                    ? (c >= 43015 && c <= 43018)
                    : c <= 43042)
                  : (c <= 43123 || (c >= 43138 && c <= 43187)))
                : (c <= 43255 || (c < 43274
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))))))))))))))
    : (c <= 43388 || (c < 70493
      ? (c < 66864
        ? (c < 64326
          ? (c < 43785
            ? (c < 43646
              ? (c < 43520
                ? (c < 43488
                  ? (c < 43471
                    ? (c >= 43396 && c <= 43442)
                    : c <= 43471)
                  : (c <= 43492 || (c < 43514
                    ? (c >= 43494 && c <= 43503)
                    : c <= 43518)))
                : (c <= 43560 || (c < 43616
                  ? (c < 43588
                    ? (c >= 43584 && c <= 43586)
                    : c <= 43595)
                  : (c <= 43638 || c == 43642))))
              : (c <= 43695 || (c < 43714
                ? (c < 43705
                  ? (c < 43701
                    ? c == 43697
                    : c <= 43702)
                  : (c <= 43709 || c == 43712))
                : (c <= 43714 || (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43754)
                  : (c <= 43764 || (c >= 43777 && c <= 43782)))))))
            : (c <= 43790 || (c < 64112
              ? (c < 43888
                ? (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c < 43868
                    ? (c >= 43824 && c <= 43866)
                    : c <= 43881)))
                : (c <= 44002 || (c < 55243
                  ? (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)
                  : (c <= 55291 || (c >= 63744 && c <= 64109)))))
              : (c <= 64217 || (c < 64298
                ? (c < 64285
                  ? (c < 64275
                    ? (c >= 64256 && c <= 64262)
                    : c <= 64279)
                  : (c <= 64285 || (c >= 64287 && c <= 64296)))
                : (c <= 64310 || (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c >= 64323 && c <= 64324)))))))))
          : (c <= 64433 || (c < 65536
            ? (c < 65149
              ? (c < 65137
                ? (c < 64848
                  ? (c < 64612
                    ? (c >= 64467 && c <= 64605)
                    : c <= 64829)
                  : (c <= 64911 || (c < 65008
                    ? (c >= 64914 && c <= 64967)
                    : c <= 65017)))
                : (c <= 65137 || (c < 65145
                  ? (c < 65143
                    ? c == 65139
                    : c <= 65143)
                  : (c <= 65145 || c == 65147))))
              : (c <= 65149 || (c < 65440
                ? (c < 65345
                  ? (c < 65313
                    ? (c >= 65151 && c <= 65276)
                    : c <= 65338)
                  : (c <= 65370 || (c >= 65382 && c <= 65437)))
                : (c <= 65470 || (c < 65490
                  ? (c < 65482
                    ? (c >= 65474 && c <= 65479)
                    : c <= 65487)
                  : (c <= 65495 || (c >= 65498 && c <= 65500)))))))
            : (c <= 65547 || (c < 66349
              ? (c < 65664
                ? (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c < 65616
                    ? (c >= 65599 && c <= 65613)
                    : c <= 65629)))
                : (c <= 65786 || (c < 66208
                  ? (c < 66176
                    ? (c >= 65856 && c <= 65908)
                    : c <= 66204)
                  : (c <= 66256 || (c >= 66304 && c <= 66335)))))
              : (c <= 66378 || (c < 66513
                ? (c < 66464
                  ? (c < 66432
                    ? (c >= 66384 && c <= 66421)
                    : c <= 66461)
                  : (c <= 66499 || (c >= 66504 && c <= 66511)))
                : (c <= 66517 || (c < 66776
                  ? (c < 66736
                    ? (c >= 66560 && c <= 66717)
                    : c <= 66771)
                  : (c <= 66811 || (c >= 66816 && c <= 66855)))))))))))
        : (c <= 66915 || (c < 68736
          ? (c < 67680
            ? (c < 67424
              ? (c < 66979
                ? (c < 66956
                  ? (c < 66940
                    ? (c >= 66928 && c <= 66938)
                    : c <= 66954)
                  : (c <= 66962 || (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)))
                : (c <= 66993 || (c < 67072
                  ? (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))))
              : (c <= 67431 || (c < 67592
                ? (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c >= 67584 && c <= 67589)))
                : (c <= 67592 || (c < 67644
                  ? (c < 67639
                    ? (c >= 67594 && c <= 67637)
                    : c <= 67640)
                  : (c <= 67644 || (c >= 67647 && c <= 67669)))))))
            : (c <= 67702 || (c < 68121
              ? (c < 67968
                ? (c < 67828
                  ? (c < 67808
                    ? (c >= 67712 && c <= 67742)
                    : c <= 67826)
                  : (c <= 67829 || (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)))
                : (c <= 68023 || (c < 68112
                  ? (c < 68096
                    ? (c >= 68030 && c <= 68031)
                    : c <= 68096)
                  : (c <= 68115 || (c >= 68117 && c <= 68119)))))
              : (c <= 68149 || (c < 68352
                ? (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c >= 68297 && c <= 68324)))
                : (c <= 68405 || (c < 68480
                  ? (c < 68448
                    ? (c >= 68416 && c <= 68437)
                    : c <= 68466)
                  : (c <= 68497 || (c >= 68608 && c <= 68680)))))))))
          : (c <= 68786 || (c < 70019
            ? (c < 69635
              ? (c < 69415
                ? (c < 69248
                  ? (c < 68864
                    ? (c >= 68800 && c <= 68850)
                    : c <= 68899)
                  : (c <= 69289 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))
                : (c <= 69415 || (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69445)
                    : c <= 69505)
                  : (c <= 69572 || (c >= 69600 && c <= 69622)))))
              : (c <= 69687 || (c < 69891
                ? (c < 69763
                  ? (c < 69749
                    ? (c >= 69745 && c <= 69746)
                    : c <= 69749)
                  : (c <= 69807 || (c >= 69840 && c <= 69864)))
                : (c <= 69926 || (c < 69968
                  ? (c < 69959
                    ? c == 69956
                    : c <= 69959)
                  : (c <= 70002 || c == 70006))))))
            : (c <= 70066 || (c < 70303
              ? (c < 70163
                ? (c < 70108
                  ? (c < 70106
                    ? (c >= 70081 && c <= 70084)
                    : c <= 70106)
                  : (c <= 70108 || (c >= 70144 && c <= 70161)))
                : (c <= 70187 || (c < 70282
                  ? (c < 70280
                    ? (c >= 70272 && c <= 70278)
                    : c <= 70280)
                  : (c <= 70285 || (c >= 70287 && c <= 70301)))))
              : (c <= 70312 || (c < 70442
                ? (c < 70415
                  ? (c < 70405
                    ? (c >= 70320 && c <= 70366)
                    : c <= 70412)
                  : (c <= 70416 || (c >= 70419 && c <= 70440)))
                : (c <= 70448 || (c < 70461
                  ? (c < 70453
                    ? (c >= 70450 && c <= 70451)
                    : c <= 70457)
                  : (c <= 70461 || c == 70480))))))))))))
      : (c <= 70497 || (c < 119808
        ? (c < 73030
          ? (c < 71960
            ? (c < 71296
              ? (c < 70855
                ? (c < 70751
                  ? (c < 70727
                    ? (c >= 70656 && c <= 70708)
                    : c <= 70730)
                  : (c <= 70753 || (c < 70852
                    ? (c >= 70784 && c <= 70831)
                    : c <= 70853)))
                : (c <= 70855 || (c < 71168
                  ? (c < 71128
                    ? (c >= 71040 && c <= 71086)
                    : c <= 71131)
                  : (c <= 71215 || c == 71236))))
              : (c <= 71338 || (c < 71840
                ? (c < 71488
                  ? (c < 71424
                    ? c == 71352
                    : c <= 71450)
                  : (c <= 71494 || (c >= 71680 && c <= 71723)))
                : (c <= 71903 || (c < 71948
                  ? (c < 71945
                    ? (c >= 71935 && c <= 71942)
                    : c <= 71945)
                  : (c <= 71955 || (c >= 71957 && c <= 71958)))))))
            : (c <= 71983 || (c < 72284
              ? (c < 72163
                ? (c < 72096
                  ? (c < 72001
                    ? c == 71999
                    : c <= 72001)
                  : (c <= 72103 || (c < 72161
                    ? (c >= 72106 && c <= 72144)
                    : c <= 72161)))
                : (c <= 72163 || (c < 72250
                  ? (c < 72203
                    ? c == 72192
                    : c <= 72242)
                  : (c <= 72250 || c == 72272))))
              : (c <= 72329 || (c < 72768
                ? (c < 72704
                  ? (c < 72368
                    ? c == 72349
                    : c <= 72440)
                  : (c <= 72712 || (c >= 72714 && c <= 72750)))
                : (c <= 72768 || (c < 72968
                  ? (c < 72960
                    ? (c >= 72818 && c <= 72847)
                    : c <= 72966)
                  : (c <= 72969 || (c >= 72971 && c <= 73008)))))))))
          : (c <= 73030 || (c < 93760
            ? (c < 77824
              ? (c < 73648
                ? (c < 73066
                  ? (c < 73063
                    ? (c >= 73056 && c <= 73061)
                    : c <= 73064)
                  : (c <= 73097 || (c < 73440
                    ? c == 73112
                    : c <= 73458)))
                : (c <= 73648 || (c < 74880
                  ? (c < 74752
                    ? (c >= 73728 && c <= 74649)
                    : c <= 74862)
                  : (c <= 75075 || (c >= 77712 && c <= 77808)))))
              : (c <= 78894 || (c < 92880
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c >= 92784 && c <= 92862)))
                : (c <= 92909 || (c < 93027
                  ? (c < 92992
                    ? (c >= 92928 && c <= 92975)
                    : c <= 92995)
                  : (c <= 93047 || (c >= 93053 && c <= 93071)))))))
            : (c <= 93823 || (c < 110581
              ? (c < 94179
                ? (c < 94099
                  ? (c < 94032
                    ? (c >= 93952 && c <= 94026)
                    : c <= 94032)
                  : (c <= 94111 || (c >= 94176 && c <= 94177)))
                : (c <= 94179 || (c < 101632
                  ? (c < 100352
                    ? (c >= 94208 && c <= 100343)
                    : c <= 101589)
                  : (c <= 101640 || (c >= 110576 && c <= 110579)))))
              : (c <= 110587 || (c < 110960
                ? (c < 110928
                  ? (c < 110592
                    ? (c >= 110589 && c <= 110590)
                    : c <= 110882)
                  : (c <= 110930 || (c >= 110948 && c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c >= 113808 && c <= 113817)))))))))))
        : (c <= 119892 || (c < 125259
          ? (c < 120540
            ? (c < 120077
              ? (c < 119982
                ? (c < 119970
                  ? (c < 119966
                    ? (c >= 119894 && c <= 119964)
                    : c <= 119967)
                  : (c <= 119970 || (c < 119977
                    ? (c >= 119973 && c <= 119974)
                    : c <= 119980)))
                : (c <= 119993 || (c < 120005
                  ? (c < 119997
                    ? c == 119995
                    : c <= 120003)
                  : (c <= 120069 || (c >= 120071 && c <= 120074)))))
              : (c <= 120084 || (c < 120134
                ? (c < 120123
                  ? (c < 120094
                    ? (c >= 120086 && c <= 120092)
                    : c <= 120121)
                  : (c <= 120126 || (c >= 120128 && c <= 120132)))
                : (c <= 120134 || (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c >= 120514 && c <= 120538)))))))
            : (c <= 120570 || (c < 123191
              ? (c < 120714
                ? (c < 120630
                  ? (c < 120598
                    ? (c >= 120572 && c <= 120596)
                    : c <= 120628)
                  : (c <= 120654 || (c < 120688
                    ? (c >= 120656 && c <= 120686)
                    : c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_8(int32_t c) {
  return (c < 43488
    ? (c < 4159
      ? (c < 2654
        ? (c < 1808
          ? (c < 895
            ? (c < 192
              ? (c < 'a'
                ? (c < 'M'
                  ? (c < 'A'
                    ? c == '$'
                    : c <= 'K')
                  : (c <= 'T' || (c < '_'
                    ? (c >= 'V' && c <= 'Z')
                    : c <= '_')))
                : (c <= 't' || (c < 181
                  ? (c < 170
                    ? (c >= 'v' && c <= 'z')
                    : c <= 170)
                  : (c <= 181 || c == 186))))
              : (c <= 214 || (c < 748
                ? (c < 710
                  ? (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)
                  : (c <= 721 || (c >= 736 && c <= 740)))
                : (c <= 748 || (c < 886
                  ? (c < 880
                    ? c == 750
                    : c <= 884)
                  : (c <= 887 || (c >= 891 && c <= 893)))))))
            : (c <= 895 || (c < 1488
              ? (c < 1015
                ? (c < 908
                  ? (c < 904
                    ? c == 902
                    : c <= 906)
                  : (c <= 908 || (c < 931
                    ? (c >= 910 && c <= 929)
                    : c <= 1013)))
                : (c <= 1153 || (c < 1369
                  ? (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)
                  : (c <= 1369 || (c >= 1376 && c <= 1416)))))
              : (c <= 1514 || (c < 1749
                ? (c < 1646
                  ? (c < 1568
                    ? (c >= 1519 && c <= 1522)
                    : c <= 1610)
                  : (c <= 1647 || (c >= 1649 && c <= 1747)))
                : (c <= 1749 || (c < 1786
                  ? (c < 1774
                    ? (c >= 1765 && c <= 1766)
                    : c <= 1775)
                  : (c <= 1788 || c == 1791))))))))
          : (c <= 1808 || (c < 2437
            ? (c < 2112
              ? (c < 2042
                ? (c < 1969
                  ? (c < 1869
                    ? (c >= 1810 && c <= 1839)
                    : c <= 1957)
                  : (c <= 1969 || (c < 2036
                    ? (c >= 1994 && c <= 2026)
                    : c <= 2037)))
                : (c <= 2042 || (c < 2084
                  ? (c < 2074
                    ? (c >= 2048 && c <= 2069)
                    : c <= 2074)
                  : (c <= 2084 || c == 2088))))
              : (c <= 2136 || (c < 2308
                ? (c < 2185
                  ? (c < 2160
                    ? (c >= 2144 && c <= 2154)
                    : c <= 2183)
                  : (c <= 2190 || (c >= 2208 && c <= 2249)))
                : (c <= 2361 || (c < 2392
                  ? (c < 2384
                    ? c == 2365
                    : c <= 2384)
                  : (c <= 2401 || (c >= 2417 && c <= 2432)))))))
            : (c <= 2444 || (c < 2544
              ? (c < 2486
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || c == 2482))
                : (c <= 2489 || (c < 2524
                  ? (c < 2510
                    ? c == 2493
                    : c <= 2510)
                  : (c <= 2525 || (c >= 2527 && c <= 2529)))))
              : (c <= 2545 || (c < 2602
                ? (c < 2575
                  ? (c < 2565
                    ? c == 2556
                    : c <= 2570)
                  : (c <= 2576 || (c >= 2579 && c <= 2600)))
                : (c <= 2608 || (c < 2616
                  ? (c < 2613
                    ? (c >= 2610 && c <= 2611)
                    : c <= 2614)
                  : (c <= 2617 || (c >= 2649 && c <= 2652)))))))))))
        : (c <= 2654 || (c < 3205
          ? (c < 2929
            ? (c < 2809
              ? (c < 2738
                ? (c < 2703
                  ? (c < 2693
                    ? (c >= 2674 && c <= 2676)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))
                : (c <= 2739 || (c < 2768
                  ? (c < 2749
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2749)
                  : (c <= 2768 || (c >= 2784 && c <= 2785)))))
              : (c <= 2809 || (c < 2866
                ? (c < 2835
                  ? (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)
                  : (c <= 2856 || (c >= 2858 && c <= 2864)))
                : (c <= 2867 || (c < 2908
                  ? (c < 2877
                    ? (c >= 2869 && c <= 2873)
                    : c <= 2877)
                  : (c <= 2909 || (c >= 2911 && c <= 2913)))))))
            : (c <= 2929 || (c < 3024
              ? (c < 2972
                ? (c < 2958
                  ? (c < 2949
                    ? c == 2947
                    : c <= 2954)
                  : (c <= 2960 || (c < 2969
                    ? (c >= 2962 && c <= 2965)
                    : c <= 2970)))
                : (c <= 2972 || (c < 2984
                  ? (c < 2979
                    ? (c >= 2974 && c <= 2975)
                    : c <= 2980)
                  : (c <= 2986 || (c >= 2990 && c <= 3001)))))
              : (c <= 3024 || (c < 3133
                ? (c < 3090
                  ? (c < 3086
                    ? (c >= 3077 && c <= 3084)
                    : c <= 3088)
                  : (c <= 3112 || (c >= 3114 && c <= 3129)))
                : (c <= 3133 || (c < 3168
                  ? (c < 3165
                    ? (c >= 3160 && c <= 3162)
                    : c <= 3165)
                  : (c <= 3169 || c == 3200))))))))
          : (c <= 3212 || (c < 3520
            ? (c < 3346
              ? (c < 3293
                ? (c < 3242
                  ? (c < 3218
                    ? (c >= 3214 && c <= 3216)
                    : c <= 3240)
                  : (c <= 3251 || (c < 3261
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3261)))
                : (c <= 3294 || (c < 3332
                  ? (c < 3313
                    ? (c >= 3296 && c <= 3297)
                    : c <= 3314)
                  : (c <= 3340 || (c >= 3342 && c <= 3344)))))
              : (c <= 3386 || (c < 3450
                ? (c < 3412
                  ? (c < 3406
                    ? c == 3389
                    : c <= 3406)
                  : (c <= 3414 || (c >= 3423 && c <= 3425)))
                : (c <= 3455 || (c < 3507
                  ? (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)
                  : (c <= 3515 || c == 3517))))))
            : (c <= 3526 || (c < 3762
              ? (c < 3716
                ? (c < 3648
                  ? (c < 3634
                    ? (c >= 3585 && c <= 3632)
                    : c <= 3634)
                  : (c <= 3654 || (c >= 3713 && c <= 3714)))
                : (c <= 3716 || (c < 3749
                  ? (c < 3724
                    ? (c >= 3718 && c <= 3722)
                    : c <= 3747)
                  : (c <= 3749 || (c >= 3751 && c <= 3760)))))
              : (c <= 3762 || (c < 3840
                ? (c < 3782
                  ? (c < 3776
                    ? c == 3773
                    : c <= 3780)
                  : (c <= 3782 || (c >= 3804 && c <= 3807)))
                : (c <= 3840 || (c < 3976
                  ? (c < 3913
                    ? (c >= 3904 && c <= 3911)
                    : c <= 3948)
                  : (c <= 3980 || (c >= 4096 && c <= 4138)))))))))))))
      : (c <= 4159 || (c < 8126
        ? (c < 6103
          ? (c < 4792
            ? (c < 4304
              ? (c < 4213
                ? (c < 4193
                  ? (c < 4186
                    ? (c >= 4176 && c <= 4181)
                    : c <= 4189)
                  : (c <= 4193 || (c < 4206
                    ? (c >= 4197 && c <= 4198)
                    : c <= 4208)))
                : (c <= 4225 || (c < 4295
                  ? (c < 4256
                    ? c == 4238
                    : c <= 4293)
                  : (c <= 4295 || c == 4301))))
              : (c <= 4346 || (c < 4698
                ? (c < 4688
                  ? (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)
                  : (c <= 4694 || c == 4696))
                : (c <= 4701 || (c < 4752
                  ? (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)
                  : (c <= 4784 || (c >= 4786 && c <= 4789)))))))
            : (c <= 4798 || (c < 5743
              ? (c < 4888
                ? (c < 4808
                  ? (c < 4802
                    ? c == 4800
                    : c <= 4805)
                  : (c <= 4822 || (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)))
                : (c <= 4954 || (c < 5112
                  ? (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)
                  : (c <= 5117 || (c >= 5121 && c <= 5740)))))
              : (c <= 5759 || (c < 5919
                ? (c < 5870
                  ? (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)
                  : (c <= 5880 || (c >= 5888 && c <= 5905)))
                : (c <= 5937 || (c < 5998
                  ? (c < 5984
                    ? (c >= 5952 && c <= 5969)
                    : c <= 5996)
                  : (c <= 6000 || (c >= 6016 && c <= 6067)))))))))
          : (c <= 6103 || (c < 7258
            ? (c < 6656
              ? (c < 6400
                ? (c < 6272
                  ? (c < 6176
                    ? c == 6108
                    : c <= 6264)
                  : (c <= 6312 || (c < 6320
                    ? c == 6314
                    : c <= 6389)))
                : (c <= 6430 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6480 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c >= 6576 && c <= 6601)))))
              : (c <= 6678 || (c < 7043
                ? (c < 6917
                  ? (c < 6823
                    ? (c >= 6688 && c <= 6740)
                    : c <= 6823)
                  : (c <= 6963 || (c >= 6981 && c <= 6988)))
                : (c <= 7072 || (c < 7168
                  ? (c < 7098
                    ? (c >= 7086 && c <= 7087)
                    : c <= 7141)
                  : (c <= 7203 || (c >= 7245 && c <= 7247)))))))
            : (c <= 7293 || (c < 7960
              ? (c < 7406
                ? (c < 7357
                  ? (c < 7312
                    ? (c >= 7296 && c <= 7304)
                    : c <= 7354)
                  : (c <= 7359 || (c >= 7401 && c <= 7404)))
                : (c <= 7411 || (c < 7424
                  ? (c < 7418
                    ? (c >= 7413 && c <= 7414)
                    : c <= 7418)
                  : (c <= 7615 || (c >= 7680 && c <= 7957)))))
              : (c <= 7965 || (c < 8027
                ? (c < 8016
                  ? (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)
                  : (c <= 8023 || c == 8025))
                : (c <= 8027 || (c < 8064
                  ? (c < 8031
                    ? c == 8029
                    : c <= 8061)
                  : (c <= 8116 || (c >= 8118 && c <= 8124)))))))))))
        : (c <= 8126 || (c < 12293
          ? (c < 8517
            ? (c < 8450
              ? (c < 8178
                ? (c < 8144
                  ? (c < 8134
                    ? (c >= 8130 && c <= 8132)
                    : c <= 8140)
                  : (c <= 8147 || (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)))
                : (c <= 8180 || (c < 8319
                  ? (c < 8305
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8305)
                  : (c <= 8319 || (c >= 8336 && c <= 8348)))))
              : (c <= 8450 || (c < 8484
                ? (c < 8469
                  ? (c < 8458
                    ? c == 8455
                    : c <= 8467)
                  : (c <= 8469 || (c >= 8472 && c <= 8477)))
                : (c <= 8484 || (c < 8490
                  ? (c < 8488
                    ? c == 8486
                    : c <= 8488)
                  : (c <= 8505 || (c >= 8508 && c <= 8511)))))))
            : (c <= 8521 || (c < 11631
              ? (c < 11506
                ? (c < 11264
                  ? (c < 8544
                    ? c == 8526
                    : c <= 8584)
                  : (c <= 11492 || (c >= 11499 && c <= 11502)))
                : (c <= 11507 || (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || (c >= 11568 && c <= 11623)))))
              : (c <= 11631 || (c < 11704
                ? (c < 11688
                  ? (c < 11680
                    ? (c >= 11648 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c >= 11696 && c <= 11702)))
                : (c <= 11710 || (c < 11728
                  ? (c < 11720
                    ? (c >= 11712 && c <= 11718)
                    : c <= 11726)
                  : (c <= 11734 || (c >= 11736 && c <= 11742)))))))))
          : (c <= 12295 || (c < 42775
            ? (c < 12784
              ? (c < 12449
                ? (c < 12344
                  ? (c < 12337
                    ? (c >= 12321 && c <= 12329)
                    : c <= 12341)
                  : (c <= 12348 || (c < 12445
                    ? (c >= 12353 && c <= 12438)
                    : c <= 12447)))
                : (c <= 12538 || (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c >= 12704 && c <= 12735)))))
              : (c <= 12799 || (c < 42512
                ? (c < 42192
                  ? (c < 19968
                    ? (c >= 13312 && c <= 19903)
                    : c <= 42124)
                  : (c <= 42237 || (c >= 42240 && c <= 42508)))
                : (c <= 42527 || (c < 42623
                  ? (c < 42560
                    ? (c >= 42538 && c <= 42539)
                    : c <= 42606)
                  : (c <= 42653 || (c >= 42656 && c <= 42735)))))))
            : (c <= 42783 || (c < 43072
              ? (c < 42965
                ? (c < 42960
                  ? (c < 42891
                    ? (c >= 42786 && c <= 42888)
                    : c <= 42954)
                  : (c <= 42961 || c == 42963))
                : (c <= 42969 || (c < 43015
                  ? (c < 43011
                    ? (c >= 42994 && c <= 43009)
                    : c <= 43013)
                  : (c <= 43018 || (c >= 43020 && c <= 43042)))))
              : (c <= 43123 || (c < 43274
                ? (c < 43259
                  ? (c < 43250
                    ? (c >= 43138 && c <= 43187)
                    : c <= 43255)
                  : (c <= 43259 || (c >= 43261 && c <= 43262)))
                : (c <= 43301 || (c < 43396
                  ? (c < 43360
                    ? (c >= 43312 && c <= 43334)
                    : c <= 43388)
                  : (c <= 43442 || c == 43471))))))))))))))
    : (c <= 43492 || (c < 70656
      ? (c < 66940
        ? (c < 64848
          ? (c < 43816
            ? (c < 43705
              ? (c < 43616
                ? (c < 43520
                  ? (c < 43514
                    ? (c >= 43494 && c <= 43503)
                    : c <= 43518)
                  : (c <= 43560 || (c < 43588
                    ? (c >= 43584 && c <= 43586)
                    : c <= 43595)))
                : (c <= 43638 || (c < 43697
                  ? (c < 43646
                    ? c == 43642
                    : c <= 43695)
                  : (c <= 43697 || (c >= 43701 && c <= 43702)))))
              : (c <= 43709 || (c < 43762
                ? (c < 43739
                  ? (c < 43714
                    ? c == 43712
                    : c <= 43714)
                  : (c <= 43741 || (c >= 43744 && c <= 43754)))
                : (c <= 43764 || (c < 43793
                  ? (c < 43785
                    ? (c >= 43777 && c <= 43782)
                    : c <= 43790)
                  : (c <= 43798 || (c >= 43808 && c <= 43814)))))))
            : (c <= 43822 || (c < 64285
              ? (c < 55243
                ? (c < 43888
                  ? (c < 43868
                    ? (c >= 43824 && c <= 43866)
                    : c <= 43881)
                  : (c <= 44002 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c >= 64275 && c <= 64279)))))
              : (c <= 64285 || (c < 64320
                ? (c < 64312
                  ? (c < 64298
                    ? (c >= 64287 && c <= 64296)
                    : c <= 64310)
                  : (c <= 64316 || c == 64318))
                : (c <= 64321 || (c < 64467
                  ? (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)
                  : (c <= 64605 || (c >= 64612 && c <= 64829)))))))))
          : (c <= 64911 || (c < 65596
            ? (c < 65345
              ? (c < 65145
                ? (c < 65137
                  ? (c < 65008
                    ? (c >= 64914 && c <= 64967)
                    : c <= 65017)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c >= 65313 && c <= 65338)))))
              : (c <= 65370 || (c < 65490
                ? (c < 65474
                  ? (c < 65440
                    ? (c >= 65382 && c <= 65437)
                    : c <= 65470)
                  : (c <= 65479 || (c >= 65482 && c <= 65487)))
                : (c <= 65495 || (c < 65549
                  ? (c < 65536
                    ? (c >= 65498 && c <= 65500)
                    : c <= 65547)
                  : (c <= 65574 || (c >= 65576 && c <= 65594)))))))
            : (c <= 65597 || (c < 66432
              ? (c < 66176
                ? (c < 65664
                  ? (c < 65616
                    ? (c >= 65599 && c <= 65613)
                    : c <= 65629)
                  : (c <= 65786 || (c >= 65856 && c <= 65908)))
                : (c <= 66204 || (c < 66349
                  ? (c < 66304
                    ? (c >= 66208 && c <= 66256)
                    : c <= 66335)
                  : (c <= 66378 || (c >= 66384 && c <= 66421)))))
              : (c <= 66461 || (c < 66736
                ? (c < 66513
                  ? (c < 66504
                    ? (c >= 66464 && c <= 66499)
                    : c <= 66511)
                  : (c <= 66517 || (c >= 66560 && c <= 66717)))
                : (c <= 66771 || (c < 66864
                  ? (c < 66816
                    ? (c >= 66776 && c <= 66811)
                    : c <= 66855)
                  : (c <= 66915 || (c >= 66928 && c <= 66938)))))))))))
        : (c <= 66954 || (c < 68800
          ? (c < 67808
            ? (c < 67463
              ? (c < 67003
                ? (c < 66967
                  ? (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)
                  : (c <= 66977 || (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)))
                : (c <= 67004 || (c < 67424
                  ? (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)
                  : (c <= 67431 || (c >= 67456 && c <= 67461)))))
              : (c <= 67504 || (c < 67639
                ? (c < 67592
                  ? (c < 67584
                    ? (c >= 67506 && c <= 67514)
                    : c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67680
                  ? (c < 67647
                    ? c == 67644
                    : c <= 67669)
                  : (c <= 67702 || (c >= 67712 && c <= 67742)))))))
            : (c <= 67826 || (c < 68192
              ? (c < 68030
                ? (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c >= 67968 && c <= 68023)))
                : (c <= 68031 || (c < 68117
                  ? (c < 68112
                    ? c == 68096
                    : c <= 68115)
                  : (c <= 68119 || (c >= 68121 && c <= 68149)))))
              : (c <= 68220 || (c < 68416
                ? (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68324 || (c >= 68352 && c <= 68405)))
                : (c <= 68437 || (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c >= 68736 && c <= 68786)))))))))
          : (c <= 68850 || (c < 70081
            ? (c < 69745
              ? (c < 69424
                ? (c < 69296
                  ? (c < 69248
                    ? (c >= 68864 && c <= 68899)
                    : c <= 69289)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))
                : (c <= 69445 || (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69505)
                    : c <= 69572)
                  : (c <= 69622 || (c >= 69635 && c <= 69687)))))
              : (c <= 69746 || (c < 69956
                ? (c < 69840
                  ? (c < 69763
                    ? c == 69749
                    : c <= 69807)
                  : (c <= 69864 || (c >= 69891 && c <= 69926)))
                : (c <= 69956 || (c < 70006
                  ? (c < 69968
                    ? c == 69959
                    : c <= 70002)
                  : (c <= 70006 || (c >= 70019 && c <= 70066)))))))
            : (c <= 70084 || (c < 70320
              ? (c < 70272
                ? (c < 70144
                  ? (c < 70108
                    ? c == 70106
                    : c <= 70108)
                  : (c <= 70161 || (c >= 70163 && c <= 70187)))
                : (c <= 70278 || (c < 70287
                  ? (c < 70282
                    ? c == 70280
                    : c <= 70285)
                  : (c <= 70301 || (c >= 70303 && c <= 70312)))))
              : (c <= 70366 || (c < 70450
                ? (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c >= 70442 && c <= 70448)))
                : (c <= 70451 || (c < 70480
                  ? (c < 70461
                    ? (c >= 70453 && c <= 70457)
                    : c <= 70461)
                  : (c <= 70480 || (c >= 70493 && c <= 70497)))))))))))))
      : (c <= 70708 || (c < 119894
        ? (c < 73056
          ? (c < 71999
            ? (c < 71352
              ? (c < 71040
                ? (c < 70784
                  ? (c < 70751
                    ? (c >= 70727 && c <= 70730)
                    : c <= 70753)
                  : (c <= 70831 || (c < 70855
                    ? (c >= 70852 && c <= 70853)
                    : c <= 70855)))
                : (c <= 71086 || (c < 71236
                  ? (c < 71168
                    ? (c >= 71128 && c <= 71131)
                    : c <= 71215)
                  : (c <= 71236 || (c >= 71296 && c <= 71338)))))
              : (c <= 71352 || (c < 71935
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71424 && c <= 71450)
                    : c <= 71494)
                  : (c <= 71723 || (c >= 71840 && c <= 71903)))
                : (c <= 71942 || (c < 71957
                  ? (c < 71948
                    ? c == 71945
                    : c <= 71955)
                  : (c <= 71958 || (c >= 71960 && c <= 71983)))))))
            : (c <= 71999 || (c < 72349
              ? (c < 72192
                ? (c < 72106
                  ? (c < 72096
                    ? c == 72001
                    : c <= 72103)
                  : (c <= 72144 || (c < 72163
                    ? c == 72161
                    : c <= 72163)))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_9(int32_t c) {
  return (c < 43471
    ? (c < 4096
      ? (c < 2649
        ? (c < 1791
          ? (c < 891
            ? (c < 186
              ? (c < 'a'
                ? (c < 'G'
                  ? (c < 'A'
                    ? c == '$'
                    : c <= 'E')
                  : (c <= 'S' || (c < '_'
                    ? (c >= 'U' && c <= 'Z')
                    : c <= '_')))
                : (c <= 'e' || (c < 170
                  ? (c < 'u'
                    ? (c >= 'g' && c <= 's')
                    : c <= 'z')
                  : (c <= 170 || c == 181))))
              : (c <= 186 || (c < 736
                ? (c < 248
                  ? (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))
                : (c <= 740 || (c < 880
                  ? (c < 750
                    ? c == 748
                    : c <= 750)
                  : (c <= 884 || (c >= 886 && c <= 887)))))))
            : (c <= 893 || (c < 1376
              ? (c < 931
                ? (c < 904
                  ? (c < 902
                    ? c == 895
                    : c <= 902)
                  : (c <= 906 || (c < 910
                    ? c == 908
                    : c <= 929)))
                : (c <= 1013 || (c < 1329
                  ? (c < 1162
                    ? (c >= 1015 && c <= 1153)
                    : c <= 1327)
                  : (c <= 1366 || c == 1369))))
              : (c <= 1416 || (c < 1649
                ? (c < 1568
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))
                : (c <= 1747 || (c < 1774
                  ? (c < 1765
                    ? c == 1749
                    : c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))))))))
          : (c <= 1791 || (c < 2417
            ? (c < 2088
              ? (c < 2036
                ? (c < 1869
                  ? (c < 1810
                    ? c == 1808
                    : c <= 1839)
                  : (c <= 1957 || (c < 1994
                    ? c == 1969
                    : c <= 2026)))
                : (c <= 2037 || (c < 2074
                  ? (c < 2048
                    ? c == 2042
                    : c <= 2069)
                  : (c <= 2074 || c == 2084))))
              : (c <= 2088 || (c < 2208
                ? (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2136)
                    : c <= 2154)
                  : (c <= 2183 || (c >= 2185 && c <= 2190)))
                : (c <= 2249 || (c < 2384
                  ? (c < 2365
                    ? (c >= 2308 && c <= 2361)
                    : c <= 2365)
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))))))
            : (c <= 2432 || (c < 2527
              ? (c < 2482
                ? (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c >= 2474 && c <= 2480)))
                : (c <= 2482 || (c < 2510
                  ? (c < 2493
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2493)
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))))
              : (c <= 2529 || (c < 2579
                ? (c < 2565
                  ? (c < 2556
                    ? (c >= 2544 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c >= 2616 && c <= 2617)))))))))))
        : (c <= 2652 || (c < 3200
          ? (c < 2911
            ? (c < 2784
              ? (c < 2730
                ? (c < 2693
                  ? (c < 2674
                    ? c == 2654
                    : c <= 2676)
                  : (c <= 2701 || (c < 2707
                    ? (c >= 2703 && c <= 2705)
                    : c <= 2728)))
                : (c <= 2736 || (c < 2749
                  ? (c < 2741
                    ? (c >= 2738 && c <= 2739)
                    : c <= 2745)
                  : (c <= 2749 || c == 2768))))
              : (c <= 2785 || (c < 2858
                ? (c < 2831
                  ? (c < 2821
                    ? c == 2809
                    : c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))
                : (c <= 2864 || (c < 2877
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))))))
            : (c <= 2913 || (c < 2990
              ? (c < 2969
                ? (c < 2949
                  ? (c < 2947
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c < 2962
                    ? (c >= 2958 && c <= 2960)
                    : c <= 2965)))
                : (c <= 2970 || (c < 2979
                  ? (c < 2974
                    ? c == 2972
                    : c <= 2975)
                  : (c <= 2980 || (c >= 2984 && c <= 2986)))))
              : (c <= 3001 || (c < 3114
                ? (c < 3086
                  ? (c < 3077
                    ? c == 3024
                    : c <= 3084)
                  : (c <= 3088 || (c >= 3090 && c <= 3112)))
                : (c <= 3129 || (c < 3165
                  ? (c < 3160
                    ? c == 3133
                    : c <= 3162)
                  : (c <= 3165 || (c >= 3168 && c <= 3169)))))))))
          : (c <= 3200 || (c < 3517
            ? (c < 3342
              ? (c < 3261
                ? (c < 3218
                  ? (c < 3214
                    ? (c >= 3205 && c <= 3212)
                    : c <= 3216)
                  : (c <= 3240 || (c < 3253
                    ? (c >= 3242 && c <= 3251)
                    : c <= 3257)))
                : (c <= 3261 || (c < 3313
                  ? (c < 3296
                    ? (c >= 3293 && c <= 3294)
                    : c <= 3297)
                  : (c <= 3314 || (c >= 3332 && c <= 3340)))))
              : (c <= 3344 || (c < 3423
                ? (c < 3406
                  ? (c < 3389
                    ? (c >= 3346 && c <= 3386)
                    : c <= 3389)
                  : (c <= 3406 || (c >= 3412 && c <= 3414)))
                : (c <= 3425 || (c < 3482
                  ? (c < 3461
                    ? (c >= 3450 && c <= 3455)
                    : c <= 3478)
                  : (c <= 3505 || (c >= 3507 && c <= 3515)))))))
            : (c <= 3517 || (c < 3751
              ? (c < 3713
                ? (c < 3634
                  ? (c < 3585
                    ? (c >= 3520 && c <= 3526)
                    : c <= 3632)
                  : (c <= 3634 || (c >= 3648 && c <= 3654)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || c == 3749))))
              : (c <= 3760 || (c < 3804
                ? (c < 3776
                  ? (c < 3773
                    ? c == 3762
                    : c <= 3773)
                  : (c <= 3780 || c == 3782))
                : (c <= 3807 || (c < 3913
                  ? (c < 3904
                    ? c == 3840
                    : c <= 3911)
                  : (c <= 3948 || (c >= 3976 && c <= 3980)))))))))))))
      : (c <= 4138 || (c < 8118
        ? (c < 6016
          ? (c < 4786
            ? (c < 4301
              ? (c < 4206
                ? (c < 4186
                  ? (c < 4176
                    ? c == 4159
                    : c <= 4181)
                  : (c <= 4189 || (c < 4197
                    ? c == 4193
                    : c <= 4198)))
                : (c <= 4208 || (c < 4256
                  ? (c < 4238
                    ? (c >= 4213 && c <= 4225)
                    : c <= 4238)
                  : (c <= 4293 || c == 4295))))
              : (c <= 4301 || (c < 4696
                ? (c < 4682
                  ? (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)
                  : (c <= 4685 || (c >= 4688 && c <= 4694)))
                : (c <= 4696 || (c < 4746
                  ? (c < 4704
                    ? (c >= 4698 && c <= 4701)
                    : c <= 4744)
                  : (c <= 4749 || (c >= 4752 && c <= 4784)))))))
            : (c <= 4789 || (c < 5121
              ? (c < 4882
                ? (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)))
                : (c <= 4885 || (c < 5024
                  ? (c < 4992
                    ? (c >= 4888 && c <= 4954)
                    : c <= 5007)
                  : (c <= 5109 || (c >= 5112 && c <= 5117)))))
              : (c <= 5740 || (c < 5888
                ? (c < 5792
                  ? (c < 5761
                    ? (c >= 5743 && c <= 5759)
                    : c <= 5786)
                  : (c <= 5866 || (c >= 5870 && c <= 5880)))
                : (c <= 5905 || (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5937)
                    : c <= 5969)
                  : (c <= 5996 || (c >= 5998 && c <= 6000)))))))))
          : (c <= 6067 || (c < 7245
            ? (c < 6576
              ? (c < 6320
                ? (c < 6176
                  ? (c < 6108
                    ? c == 6103
                    : c <= 6108)
                  : (c <= 6264 || (c < 6314
                    ? (c >= 6272 && c <= 6312)
                    : c <= 6314)))
                : (c <= 6389 || (c < 6512
                  ? (c < 6480
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6509)
                  : (c <= 6516 || (c >= 6528 && c <= 6571)))))
              : (c <= 6601 || (c < 6981
                ? (c < 6823
                  ? (c < 6688
                    ? (c >= 6656 && c <= 6678)
                    : c <= 6740)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))
                : (c <= 6988 || (c < 7098
                  ? (c < 7086
                    ? (c >= 7043 && c <= 7072)
                    : c <= 7087)
                  : (c <= 7141 || (c >= 7168 && c <= 7203)))))))
            : (c <= 7247 || (c < 7680
              ? (c < 7401
                ? (c < 7312
                  ? (c < 7296
                    ? (c >= 7258 && c <= 7293)
                    : c <= 7304)
                  : (c <= 7354 || (c >= 7357 && c <= 7359)))
                : (c <= 7404 || (c < 7418
                  ? (c < 7413
                    ? (c >= 7406 && c <= 7411)
                    : c <= 7414)
                  : (c <= 7418 || (c >= 7424 && c <= 7615)))))
              : (c <= 7957 || (c < 8025
                ? (c < 8008
                  ? (c < 7968
                    ? (c >= 7960 && c <= 7965)
                    : c <= 8005)
                  : (c <= 8013 || (c >= 8016 && c <= 8023)))
                : (c <= 8025 || (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8061 || (c >= 8064 && c <= 8116)))))))))))
        : (c <= 8124 || (c < 11736
          ? (c < 8508
            ? (c < 8336
              ? (c < 8160
                ? (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))
                : (c <= 8172 || (c < 8305
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8305 || c == 8319))))
              : (c <= 8348 || (c < 8472
                ? (c < 8458
                  ? (c < 8455
                    ? c == 8450
                    : c <= 8455)
                  : (c <= 8467 || c == 8469))
                : (c <= 8477 || (c < 8488
                  ? (c < 8486
                    ? c == 8484
                    : c <= 8486)
                  : (c <= 8488 || (c >= 8490 && c <= 8505)))))))
            : (c <= 8511 || (c < 11568
              ? (c < 11499
                ? (c < 8544
                  ? (c < 8526
                    ? (c >= 8517 && c <= 8521)
                    : c <= 8526)
                  : (c <= 8584 || (c >= 11264 && c <= 11492)))
                : (c <= 11502 || (c < 11559
                  ? (c < 11520
                    ? (c >= 11506 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || c == 11565))))
              : (c <= 11623 || (c < 11696
                ? (c < 11680
                  ? (c < 11648
                    ? c == 11631
                    : c <= 11670)
                  : (c <= 11686 || (c >= 11688 && c <= 11694)))
                : (c <= 11702 || (c < 11720
                  ? (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)
                  : (c <= 11726 || (c >= 11728 && c <= 11734)))))))))
          : (c <= 11742 || (c < 42656
            ? (c < 12704
              ? (c < 12445
                ? (c < 12337
                  ? (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12329)
                  : (c <= 12341 || (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)))
                : (c <= 12447 || (c < 12549
                  ? (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)
                  : (c <= 12591 || (c >= 12593 && c <= 12686)))))
              : (c <= 12735 || (c < 42240
                ? (c < 19968
                  ? (c < 13312
                    ? (c >= 12784 && c <= 12799)
                    : c <= 19903)
                  : (c <= 42124 || (c >= 42192 && c <= 42237)))
                : (c <= 42508 || (c < 42560
                  ? (c < 42538
                    ? (c >= 42512 && c <= 42527)
                    : c <= 42539)
                  : (c <= 42606 || (c >= 42623 && c <= 42653)))))))
            : (c <= 42735 || (c < 43020
              ? (c < 42963
                ? (c < 42891
                  ? (c < 42786
                    ? (c >= 42775 && c <= 42783)
                    : c <= 42888)
                  : (c <= 42954 || (c >= 42960 && c <= 42961)))
                : (c <= 42963 || (c < 43011
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43009)
                  : (c <= 43013 || (c >= 43015 && c <= 43018)))))
              : (c <= 43042 || (c < 43261
                ? (c < 43250
                  ? (c < 43138
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43187)
                  : (c <= 43255 || c == 43259))
                : (c <= 43262 || (c < 43360
                  ? (c < 43312
                    ? (c >= 43274 && c <= 43301)
                    : c <= 43334)
                  : (c <= 43388 || (c >= 43396 && c <= 43442)))))))))))))))
    : (c <= 43471 || (c < 70656
      ? (c < 66928
        ? (c < 64612
          ? (c < 43808
            ? (c < 43701
              ? (c < 43588
                ? (c < 43514
                  ? (c < 43494
                    ? (c >= 43488 && c <= 43492)
                    : c <= 43503)
                  : (c <= 43518 || (c < 43584
                    ? (c >= 43520 && c <= 43560)
                    : c <= 43586)))
                : (c <= 43595 || (c < 43646
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43642)
                  : (c <= 43695 || c == 43697))))
              : (c <= 43702 || (c < 43744
                ? (c < 43714
                  ? (c < 43712
                    ? (c >= 43705 && c <= 43709)
                    : c <= 43712)
                  : (c <= 43714 || (c >= 43739 && c <= 43741)))
                : (c <= 43754 || (c < 43785
                  ? (c < 43777
                    ? (c >= 43762 && c <= 43764)
                    : c <= 43782)
                  : (c <= 43790 || (c >= 43793 && c <= 43798)))))))
            : (c <= 43814 || (c < 64275
              ? (c < 55216
                ? (c < 43868
                  ? (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)
                  : (c <= 43881 || (c < 44032
                    ? (c >= 43888 && c <= 44002)
                    : c <= 55203)))
                : (c <= 55238 || (c < 64112
                  ? (c < 63744
                    ? (c >= 55243 && c <= 55291)
                    : c <= 64109)
                  : (c <= 64217 || (c >= 64256 && c <= 64262)))))
              : (c <= 64279 || (c < 64318
                ? (c < 64298
                  ? (c < 64287
                    ? c == 64285
                    : c <= 64296)
                  : (c <= 64310 || (c >= 64312 && c <= 64316)))
                : (c <= 64318 || (c < 64326
                  ? (c < 64323
                    ? (c >= 64320 && c <= 64321)
                    : c <= 64324)
                  : (c <= 64433 || (c >= 64467 && c <= 64605)))))))))
          : (c <= 64829 || (c < 65576
            ? (c < 65313
              ? (c < 65143
                ? (c < 65008
                  ? (c < 64914
                    ? (c >= 64848 && c <= 64911)
                    : c <= 64967)
                  : (c <= 65017 || (c < 65139
                    ? c == 65137
                    : c <= 65139)))
                : (c <= 65143 || (c < 65149
                  ? (c < 65147
                    ? c == 65145
                    : c <= 65147)
                  : (c <= 65149 || (c >= 65151 && c <= 65276)))))
              : (c <= 65338 || (c < 65482
                ? (c < 65440
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65437)
                  : (c <= 65470 || (c >= 65474 && c <= 65479)))
                : (c <= 65487 || (c < 65536
                  ? (c < 65498
                    ? (c >= 65490 && c <= 65495)
                    : c <= 65500)
                  : (c <= 65547 || (c >= 65549 && c <= 65574)))))))
            : (c <= 65594 || (c < 66384
              ? (c < 65856
                ? (c < 65616
                  ? (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)
                  : (c <= 65629 || (c >= 65664 && c <= 65786)))
                : (c <= 65908 || (c < 66304
                  ? (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66378)))))
              : (c <= 66421 || (c < 66560
                ? (c < 66504
                  ? (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)
                  : (c <= 66511 || (c >= 66513 && c <= 66517)))
                : (c <= 66717 || (c < 66816
                  ? (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)
                  : (c <= 66855 || (c >= 66864 && c <= 66915)))))))))))
        : (c <= 66938 || (c < 68800
          ? (c < 67712
            ? (c < 67456
              ? (c < 66995
                ? (c < 66964
                  ? (c < 66956
                    ? (c >= 66940 && c <= 66954)
                    : c <= 66962)
                  : (c <= 66965 || (c < 66979
                    ? (c >= 66967 && c <= 66977)
                    : c <= 66993)))
                : (c <= 67001 || (c < 67392
                  ? (c < 67072
                    ? (c >= 67003 && c <= 67004)
                    : c <= 67382)
                  : (c <= 67413 || (c >= 67424 && c <= 67431)))))
              : (c <= 67461 || (c < 67594
                ? (c < 67584
                  ? (c < 67506
                    ? (c >= 67463 && c <= 67504)
                    : c <= 67514)
                  : (c <= 67589 || c == 67592))
                : (c <= 67637 || (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c >= 67680 && c <= 67702)))))))
            : (c <= 67742 || (c < 68192
              ? (c < 68030
                ? (c < 67840
                  ? (c < 67828
                    ? (c >= 67808 && c <= 67826)
                    : c <= 67829)
                  : (c <= 67861 || (c < 67968
                    ? (c >= 67872 && c <= 67897)
                    : c <= 68023)))
                : (c <= 68031 || (c < 68117
                  ? (c < 68112
                    ? c == 68096
                    : c <= 68115)
                  : (c <= 68119 || (c >= 68121 && c <= 68149)))))
              : (c <= 68220 || (c < 68416
                ? (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68324 || (c >= 68352 && c <= 68405)))
                : (c <= 68437 || (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c >= 68736 && c <= 68786)))))))))
          : (c <= 68850 || (c < 70081
            ? (c < 69745
              ? (c < 69424
                ? (c < 69296
                  ? (c < 69248
                    ? (c >= 68864 && c <= 68899)
                    : c <= 69289)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))
                : (c <= 69445 || (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69505)
                    : c <= 69572)
                  : (c <= 69622 || (c >= 69635 && c <= 69687)))))
              : (c <= 69746 || (c < 69956
                ? (c < 69840
                  ? (c < 69763
                    ? c == 69749
                    : c <= 69807)
                  : (c <= 69864 || (c >= 69891 && c <= 69926)))
                : (c <= 69956 || (c < 70006
                  ? (c < 69968
                    ? c == 69959
                    : c <= 70002)
                  : (c <= 70006 || (c >= 70019 && c <= 70066)))))))
            : (c <= 70084 || (c < 70320
              ? (c < 70272
                ? (c < 70144
                  ? (c < 70108
                    ? c == 70106
                    : c <= 70108)
                  : (c <= 70161 || (c >= 70163 && c <= 70187)))
                : (c <= 70278 || (c < 70287
                  ? (c < 70282
                    ? c == 70280
                    : c <= 70285)
                  : (c <= 70301 || (c >= 70303 && c <= 70312)))))
              : (c <= 70366 || (c < 70450
                ? (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c >= 70442 && c <= 70448)))
                : (c <= 70451 || (c < 70480
                  ? (c < 70461
                    ? (c >= 70453 && c <= 70457)
                    : c <= 70461)
                  : (c <= 70480 || (c >= 70493 && c <= 70497)))))))))))))
      : (c <= 70708 || (c < 119894
        ? (c < 73056
          ? (c < 71999
            ? (c < 71352
              ? (c < 71040
                ? (c < 70784
                  ? (c < 70751
                    ? (c >= 70727 && c <= 70730)
                    : c <= 70753)
                  : (c <= 70831 || (c < 70855
                    ? (c >= 70852 && c <= 70853)
                    : c <= 70855)))
                : (c <= 71086 || (c < 71236
                  ? (c < 71168
                    ? (c >= 71128 && c <= 71131)
                    : c <= 71215)
                  : (c <= 71236 || (c >= 71296 && c <= 71338)))))
              : (c <= 71352 || (c < 71935
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71424 && c <= 71450)
                    : c <= 71494)
                  : (c <= 71723 || (c >= 71840 && c <= 71903)))
                : (c <= 71942 || (c < 71957
                  ? (c < 71948
                    ? c == 71945
                    : c <= 71955)
                  : (c <= 71958 || (c >= 71960 && c <= 71983)))))))
            : (c <= 71999 || (c < 72349
              ? (c < 72192
                ? (c < 72106
                  ? (c < 72096
                    ? c == 72001
                    : c <= 72103)
                  : (c <= 72144 || (c < 72163
                    ? c == 72161
                    : c <= 72163)))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_10(int32_t c) {
  return (c < 43520
    ? (c < 3724
      ? (c < 2703
        ? (c < 1791
          ? (c < 895
            ? (c < 183
              ? (c < 'A'
                ? (c < '4'
                  ? (c < '0'
                    ? c == '$'
                    : (c <= '0' || c == '2'))
                  : (c <= '5' || (c < '9'
                    ? c == '7'
                    : c <= '9')))
                : (c <= 'Z' || (c < 'q'
                  ? (c < 'a'
                    ? c == '_'
                    : c <= 'o')
                  : (c <= 'z' || (c < 181
                    ? c == 170
                    : c <= 181)))))
              : (c <= 183 || (c < 736
                ? (c < 216
                  ? (c < 192
                    ? c == 186
                    : c <= 214)
                  : (c <= 246 || (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)))
                : (c <= 740 || (c < 768
                  ? (c < 750
                    ? c == 748
                    : c <= 750)
                  : (c <= 884 || (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)))))))
            : (c <= 895 || (c < 1471
              ? (c < 1155
                ? (c < 910
                  ? (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)
                  : (c <= 929 || (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)))
                : (c <= 1159 || (c < 1369
                  ? (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)
                  : (c <= 1369 || (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)))))
              : (c <= 1471 || (c < 1552
                ? (c < 1479
                  ? (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)
                  : (c <= 1479 || (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)))
                : (c <= 1562 || (c < 1749
                  ? (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)
                  : (c <= 1756 || (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)))))))))
          : (c <= 1791 || (c < 2519
            ? (c < 2275
              ? (c < 2048
                ? (c < 1984
                  ? (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)
                  : (c <= 2037 || (c < 2045
                    ? c == 2042
                    : c <= 2045)))
                : (c <= 2093 || (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)
                  : (c <= 2183 || (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)))))
              : (c <= 2403 || (c < 2474
                ? (c < 2437
                  ? (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)
                  : (c <= 2444 || (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)))
                : (c <= 2480 || (c < 2492
                  ? (c < 2486
                    ? c == 2482
                    : c <= 2489)
                  : (c <= 2500 || (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)))))))
            : (c <= 2519 || (c < 2613
              ? (c < 2561
                ? (c < 2534
                  ? (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)
                  : (c <= 2545 || (c < 2558
                    ? c == 2556
                    : c <= 2558)))
                : (c <= 2563 || (c < 2579
                  ? (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)
                  : (c <= 2600 || (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)))))
              : (c <= 2614 || (c < 2641
                ? (c < 2622
                  ? (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)
                  : (c <= 2626 || (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)))
                : (c <= 2641 || (c < 2662
                  ? (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)
                  : (c <= 2677 || (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)))))))))))
        : (c <= 2705 || (c < 3142
          ? (c < 2911
            ? (c < 2817
              ? (c < 2759
                ? (c < 2738
                  ? (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)
                  : (c <= 2739 || (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)))
                : (c <= 2761 || (c < 2784
                  ? (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)
                  : (c <= 2787 || (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)))))
              : (c <= 2819 || (c < 2869
                ? (c < 2835
                  ? (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)
                  : (c <= 2856 || (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)))
                : (c <= 2873 || (c < 2891
                  ? (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)
                  : (c <= 2893 || (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)))))))
            : (c <= 2915 || (c < 2990
              ? (c < 2962
                ? (c < 2946
                  ? (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)
                  : (c <= 2947 || (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)))
                : (c <= 2965 || (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)))))
              : (c <= 3001 || (c < 3046
                ? (c < 3018
                  ? (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)
                  : (c <= 3021 || (c < 3031
                    ? c == 3024
                    : c <= 3031)))
                : (c <= 3055 || (c < 3090
                  ? (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)
                  : (c <= 3112 || (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)))))))))
          : (c <= 3144 || (c < 3398
            ? (c < 3253
              ? (c < 3174
                ? (c < 3160
                  ? (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)
                  : (c <= 3162 || (c < 3168
                    ? c == 3165
                    : c <= 3171)))
                : (c <= 3183 || (c < 3214
                  ? (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)
                  : (c <= 3216 || (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)))))
              : (c <= 3257 || (c < 3296
                ? (c < 3274
                  ? (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)
                  : (c <= 3277 || (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)))
                : (c <= 3299 || (c < 3328
                  ? (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)
                  : (c <= 3340 || (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)))))))
            : (c <= 3400 || (c < 3530
              ? (c < 3457
                ? (c < 3423
                  ? (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)
                  : (c <= 3427 || (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)))
                : (c <= 3459 || (c < 3507
                  ? (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)
                  : (c <= 3515 || (c < 3520
                    ? c == 3517
                    : c <= 3526)))))
              : (c <= 3530 || (c < 3585
                ? (c < 3544
                  ? (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)
                  : (c <= 3551 || (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)))
                : (c <= 3642 || (c < 3713
                  ? (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)
                  : (c <= 3714 || (c < 3718
                    ? c == 3716
                    : c <= 3722)))))))))))))
      : (c <= 3747 || (c < 7960
        ? (c < 5743
          ? (c < 4301
            ? (c < 3895
              ? (c < 3792
                ? (c < 3776
                  ? (c < 3751
                    ? c == 3749
                    : c <= 3773)
                  : (c <= 3780 || (c < 3784
                    ? c == 3782
                    : c <= 3789)))
                : (c <= 3801 || (c < 3864
                  ? (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)
                  : (c <= 3865 || (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)))))
              : (c <= 3895 || (c < 3993
                ? (c < 3913
                  ? (c < 3902
                    ? c == 3897
                    : c <= 3911)
                  : (c <= 3948 || (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)))
                : (c <= 4028 || (c < 4176
                  ? (c < 4096
                    ? c == 4038
                    : c <= 4169)
                  : (c <= 4253 || (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)))))))
            : (c <= 4301 || (c < 4800
              ? (c < 4698
                ? (c < 4682
                  ? (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)
                  : (c <= 4685 || (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)))
                : (c <= 4701 || (c < 4752
                  ? (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)
                  : (c <= 4784 || (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)))))
              : (c <= 4800 || (c < 4957
                ? (c < 4824
                  ? (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)
                  : (c <= 4880 || (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)))
                : (c <= 4959 || (c < 5024
                  ? (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)
                  : (c <= 5109 || (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)))))))))
          : (c <= 5759 || (c < 6528
            ? (c < 6108
              ? (c < 5952
                ? (c < 5870
                  ? (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)
                  : (c <= 5880 || (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)))
                : (c <= 5971 || (c < 6002
                  ? (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)
                  : (c <= 6003 || (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)))))
              : (c <= 6109 || (c < 6320
                ? (c < 6159
                  ? (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)
                  : (c <= 6169 || (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)))
                : (c <= 6389 || (c < 6448
                  ? (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)
                  : (c <= 6459 || (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)))))))
            : (c <= 6571 || (c < 6992
              ? (c < 6783
                ? (c < 6656
                  ? (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)
                  : (c <= 6683 || (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)))
                : (c <= 6793 || (c < 6832
                  ? (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)
                  : (c <= 6845 || (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)))))
              : (c <= 7001 || (c < 7296
                ? (c < 7168
                  ? (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)
                  : (c <= 7223 || (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)))
                : (c <= 7304 || (c < 7376
                  ? (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)
                  : (c <= 7378 || (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)))))))))))
        : (c <= 7965 || (c < 11688
          ? (c < 8417
            ? (c < 8134
              ? (c < 8029
                ? (c < 8016
                  ? (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)
                  : (c <= 8023 || (c < 8027
                    ? c == 8025
                    : c <= 8027)))
                : (c <= 8029 || (c < 8118
                  ? (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)
                  : (c <= 8124 || (c < 8130
                    ? c == 8126
                    : c <= 8132)))))
              : (c <= 8140 || (c < 8255
                ? (c < 8160
                  ? (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)
                  : (c <= 8172 || (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)))
                : (c <= 8256 || (c < 8319
                  ? (c < 8305
                    ? c == 8276
                    : c <= 8305)
                  : (c <= 8319 || (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)))))))
            : (c <= 8417 || (c < 8517
              ? (c < 8472
                ? (c < 8455
                  ? (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)
                  : (c <= 8455 || (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)))
                : (c <= 8477 || (c < 8488
                  ? (c < 8486
                    ? c == 8484
                    : c <= 8486)
                  : (c <= 8488 || (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)))))
              : (c <= 8521 || (c < 11559
                ? (c < 11264
                  ? (c < 8544
                    ? c == 8526
                    : c <= 8584)
                  : (c <= 11492 || (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)))
                : (c <= 11559 || (c < 11631
                  ? (c < 11568
                    ? c == 11565
                    : c <= 11623)
                  : (c <= 11631 || (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)))))))))
          : (c <= 11694 || (c < 42240
            ? (c < 12353
              ? (c < 11736
                ? (c < 11712
                  ? (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)
                  : (c <= 11718 || (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)))
                : (c <= 11742 || (c < 12321
                  ? (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)
                  : (c <= 12335 || (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)))))
              : (c <= 12438 || (c < 12593
                ? (c < 12449
                  ? (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)
                  : (c <= 12538 || (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)))
                : (c <= 12686 || (c < 13312
                  ? (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)
                  : (c <= 19903 || (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)))))))
            : (c <= 42508 || (c < 43052
              ? (c < 42786
                ? (c < 42612
                  ? (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)
                  : (c <= 42621 || (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)))
                : (c <= 42888 || (c < 42963
                  ? (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)
                  : (c <= 42963 || (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)))))
              : (c <= 43052 || (c < 43261
                ? (c < 43216
                  ? (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)
                  : (c <= 43225 || (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)))
                : (c <= 43309 || (c < 43392
                  ? (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)
                  : (c <= 43456 || (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)))))))))))))))
    : (c <= 43574 || (c < 71424
      ? (c < 67592
        ? (c < 65313
          ? (c < 64285
            ? (c < 43824
              ? (c < 43762
                ? (c < 43642
                  ? (c < 43600
                    ? (c >= 43584 && c <= 43597)
                    : (c <= 43609 || (c >= 43616 && c <= 43638)))
                  : (c <= 43714 || (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43759)))
                : (c <= 43766 || (c < 43793
                  ? (c < 43785
                    ? (c >= 43777 && c <= 43782)
                    : c <= 43790)
                  : (c <= 43798 || (c < 43816
                    ? (c >= 43808 && c <= 43814)
                    : c <= 43822)))))
              : (c <= 43866 || (c < 55216
                ? (c < 44012
                  ? (c < 43888
                    ? (c >= 43868 && c <= 43881)
                    : c <= 44010)
                  : (c <= 44013 || (c < 44032
                    ? (c >= 44016 && c <= 44025)
                    : c <= 55203)))
                : (c <= 55238 || (c < 64112
                  ? (c < 63744
                    ? (c >= 55243 && c <= 55291)
                    : c <= 64109)
                  : (c <= 64217 || (c < 64275
                    ? (c >= 64256 && c <= 64262)
                    : c <= 64279)))))))
            : (c <= 64296 || (c < 65024
              ? (c < 64326
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c < 64323
                    ? (c >= 64320 && c <= 64321)
                    : c <= 64324)))
                : (c <= 64433 || (c < 64848
                  ? (c < 64612
                    ? (c >= 64467 && c <= 64605)
                    : c <= 64829)
                  : (c <= 64911 || (c < 65008
                    ? (c >= 64914 && c <= 64967)
                    : c <= 65017)))))
              : (c <= 65039 || (c < 65143
                ? (c < 65101
                  ? (c < 65075
                    ? (c >= 65056 && c <= 65071)
                    : c <= 65076)
                  : (c <= 65103 || (c < 65139
                    ? c == 65137
                    : c <= 65139)))
                : (c <= 65143 || (c < 65149
                  ? (c < 65147
                    ? c == 65145
                    : c <= 65147)
                  : (c <= 65149 || (c < 65296
                    ? (c >= 65151 && c <= 65276)
                    : c <= 65305)))))))))
          : (c <= 65338 || (c < 66464
            ? (c < 65599
              ? (c < 65490
                ? (c < 65382
                  ? (c < 65345
                    ? c == 65343
                    : c <= 65370)
                  : (c <= 65470 || (c < 65482
                    ? (c >= 65474 && c <= 65479)
                    : c <= 65487)))
                : (c <= 65495 || (c < 65549
                  ? (c < 65536
                    ? (c >= 65498 && c <= 65500)
                    : c <= 65547)
                  : (c <= 65574 || (c < 65596
                    ? (c >= 65576 && c <= 65594)
                    : c <= 65597)))))
              : (c <= 65613 || (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c < 66176
                    ? c == 66045
                    : c <= 66204)))
                : (c <= 66256 || (c < 66349
                  ? (c < 66304
                    ? c == 66272
                    : c <= 66335)
                  : (c <= 66378 || (c < 66432
                    ? (c >= 66384 && c <= 66426)
                    : c <= 66461)))))))
            : (c <= 66499 || (c < 66964
              ? (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c < 66736
                    ? (c >= 66720 && c <= 66729)
                    : c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c < 66956
                    ? (c >= 66940 && c <= 66954)
                    : c <= 66962)))))
              : (c <= 66965 || (c < 67392
                ? (c < 66995
                  ? (c < 66979
                    ? (c >= 66967 && c <= 66977)
                    : c <= 66993)
                  : (c <= 67001 || (c < 67072
                    ? (c >= 67003 && c <= 67004)
                    : c <= 67382)))
                : (c <= 67413 || (c < 67463
                  ? (c < 67456
                    ? (c >= 67424 && c <= 67431)
                    : c <= 67461)
                  : (c <= 67504 || (c < 67584
                    ? (c >= 67506 && c <= 67514)
                    : c <= 67589)))))))))))
        : (c <= 67592 || (c < 69888
          ? (c < 68352
            ? (c < 68030
              ? (c < 67712
                ? (c < 67644
                  ? (c < 67639
                    ? (c >= 67594 && c <= 67637)
                    : c <= 67640)
                  : (c <= 67644 || (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)))
                : (c <= 67742 || (c < 67840
                  ? (c < 67828
                    ? (c >= 67808 && c <= 67826)
                    : c <= 67829)
                  : (c <= 67861 || (c < 67968
                    ? (c >= 67872 && c <= 67897)
                    : c <= 68023)))))
              : (c <= 68031 || (c < 68152
                ? (c < 68108
                  ? (c < 68101
                    ? (c >= 68096 && c <= 68099)
                    : c <= 68102)
                  : (c <= 68115 || (c < 68121
                    ? (c >= 68117 && c <= 68119)
                    : c <= 68149)))
                : (c <= 68154 || (c < 68224
                  ? (c < 68192
                    ? c == 68159
                    : c <= 68220)
                  : (c <= 68252 || (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68326)))))))
            : (c <= 68405 || (c < 69376
              ? (c < 68800
                ? (c < 68480
                  ? (c < 68448
                    ? (c >= 68416 && c <= 68437)
                    : c <= 68466)
                  : (c <= 68497 || (c < 68736
                    ? (c >= 68608 && c <= 68680)
                    : c <= 68786)))
                : (c <= 68850 || (c < 69248
                  ? (c < 68912
                    ? (c >= 68864 && c <= 68903)
                    : c <= 68921)
                  : (c <= 69289 || (c < 69296
                    ? (c >= 69291 && c <= 69292)
                    : c <= 69297)))))
              : (c <= 69404 || (c < 69632
                ? (c < 69488
                  ? (c < 69424
                    ? c == 69415
                    : c <= 69456)
                  : (c <= 69509 || (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)))
                : (c <= 69702 || (c < 69826
                  ? (c < 69759
                    ? (c >= 69734 && c <= 69749)
                    : c <= 69818)
                  : (c <= 69826 || (c < 69872
                    ? (c >= 69840 && c <= 69864)
                    : c <= 69881)))))))))
          : (c <= 69940 || (c < 70450
            ? (c < 70272
              ? (c < 70089
                ? (c < 69968
                  ? (c < 69956
                    ? (c >= 69942 && c <= 69951)
                    : c <= 69959)
                  : (c <= 70003 || (c < 70016
                    ? c == 70006
                    : c <= 70084)))
                : (c <= 70092 || (c < 70144
                  ? (c < 70108
                    ? (c >= 70094 && c <= 70106)
                    : c <= 70108)
                  : (c <= 70161 || (c < 70206
                    ? (c >= 70163 && c <= 70199)
                    : c <= 70206)))))
              : (c <= 70278 || (c < 70384
                ? (c < 70287
                  ? (c < 70282
                    ? c == 70280
                    : c <= 70285)
                  : (c <= 70301 || (c < 70320
                    ? (c >= 70303 && c <= 70312)
                    : c <= 70378)))
                : (c <= 70393 || (c < 70415
                  ? (c < 70405
                    ? (c >= 70400 && c <= 70403)
                    : c <= 70412)
                  : (c <= 70416 || (c < 70442
                    ? (c >= 70419 && c <= 70440)
                    : c <= 70448)))))))
            : (c <= 70451 || (c < 70750
              ? (c < 70487
                ? (c < 70471
                  ? (c < 70459
                    ? (c >= 70453 && c <= 70457)
                    : c <= 70468)
                  : (c <= 70472 || (c < 70480
                    ? (c >= 70475 && c <= 70477)
                    : c <= 70480)))
                : (c <= 70487 || (c < 70512
                  ? (c < 70502
                    ? (c >= 70493 && c <= 70499)
                    : c <= 70508)
                  : (c <= 70516 || (c < 70736
                    ? (c >= 70656 && c <= 70730)
                    : c <= 70745)))))
              : (c <= 70753 || (c < 71128
                ? (c < 70864
                  ? (c < 70855
                    ? (c >= 70784 && c <= 70853)
                    : c <= 70855)
                  : (c <= 70873 || (c < 71096
                    ? (c >= 71040 && c <= 71093)
                    : c <= 71104)))
                : (c <= 71133 || (c < 71248
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71232)
                    : c <= 71236)
                  : (c <= 71257 || (c < 71360
                    ? (c >= 71296 && c <= 71352)
                    : c <= 71369)))))))))))))
      : (c <= 71450 || (c < 119970
        ? (c < 77712
          ? (c < 72714
            ? (c < 71995
              ? (c < 71935
                ? (c < 71488
                  ? (c < 71472
                    ? (c >= 71453 && c <= 71467)
                    : c <= 71481)
                  : (c <= 71494 || (c < 71840
                    ? (c >= 71680 && c <= 71738)
                    : c <= 71913)))
                : (c <= 71942 || (c < 71957
                  ? (c < 71948
                    ? c == 71945
                    : c <= 71955)
                  : (c <= 71958 || (c < 71991
                    ? (c >= 71960 && c <= 71989)
                    : c <= 71992)))))
              : (c <= 72003 || (c < 72192
                ? (c < 72106
                  ? (c < 72096
                    ? (c >= 72016 && c <= 72025)
                    : c <= 72103)
                  : (c <= 72151 || (c < 72163
                    ? (c >= 72154 && c <= 72161)
                    : c <= 72164)))
                : (c <= 72254 || (c < 72349
                  ? (c < 72272
                    ? c == 72263
                    : c <= 72345)
                  : (c <= 72349 || (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)))))))
            : (c <= 72758 || (c < 73040
              ? (c < 72960
                ? (c < 72818
                  ? (c < 72784
                    ? (c >= 72760 && c <= 72768)
                    : c <= 72793)
                  : (c <= 72847 || (c < 72873
                    ? (c >= 72850 && c <= 72871)
                    : c <= 72886)))
                : (c <= 72966 || (c < 73018
                  ? (c < 72971
                    ? (c >= 72968 && c <= 72969)
                    : c <= 73014)
                  : (c <= 73018 || (c < 73023
                    ? (c >= 73020 && c <= 73021)
                    : c <= 73031)))))
              : (c <= 73049 || (c < 73120
                ? (c < 73066
                  ? (c < 73063
                    ? (c >= 73056 && c <= 73061)
                    : c <= 73064)
                  : (c <= 73102 || (c < 73107
                    ? (c >= 73104 && c <= 73105)
                    : c <= 73112)))
                : (c <= 73129 || (c < 73728
                  ? (c < 73648
                    ? (c >= 73440 && c <= 73462)
                    : c <= 73648)
                  : (c <= 74649 || (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)))))))))
          : (c <= 77808 || (c < 101632
            ? (c < 93008
              ? (c < 92784
                ? (c < 92160
                  ? (c < 82944
                    ? (c >= 77824 && c <= 78894)
                    : c <= 83526)
                  : (c <= 92728 || (c < 92768
                    ? (c >= 92736 && c <= 92766)
                    : c <= 92777)))
                : (c <= 92862 || (c < 92912
                  ? (c < 92880
                    ? (c >= 92864 && c <= 92873)
                    : c <= 92909)
                  : (c <= 92916 || (c < 92992
                    ? (c >= 92928 && c <= 92982)
                    : c <= 92995)))))
              : (c <= 93017 || (c < 94095
                ? (c < 93760
                  ? (c < 93053
                    ? (c >= 93027 && c <= 93047)
                    : c <= 93071)
                  : (c <= 93823 || (c < 94031
                    ? (c >= 93952 && c <= 94026)
                    : c <= 94087)))
                : (c <= 94111 || (c < 94192
                  ? (c < 94179
                    ? (c >= 94176 && c <= 94177)
                    : c <= 94180)
                  : (c <= 94193 || (c < 100352
                    ? (c >= 94208 && c <= 100343)
                    : c <= 101589)))))))
            : (c <= 101640 || (c < 113821
              ? (c < 110948
                ? (c < 110589
                  ? (c < 110581
                    ? (c >= 110576 && c <= 110579)
                    : c <= 110587)
                  : (c <= 110590 || (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)))
                : (c <= 110951 || (c < 113776
                  ? (c < 113664
                    ? (c >= 110960 && c <= 111355)
                    : c <= 113770)
                  : (c <= 113788 || (c < 113808
                    ? (c >= 113792 && c <= 113800)
                    : c <= 113817)))))
              : (c <= 113822 || (c < 119173
                ? (c < 119141
                  ? (c < 118576
                    ? (c >= 118528 && c <= 118573)
                    : c <= 118598)
                  : (c <= 119145 || (c < 119163
                    ? (c >= 119149 && c <= 119154)
                    : c <= 119170)))
                : (c <= 119179 || (c < 119808
                  ? (c < 119362
                    ? (c >= 119210 && c <= 119213)
                    : c <= 119364)
                  : (c <= 119892 || (c < 119966
                    ? (c >= 119894 && c <= 119964)
                    : c <= 119967)))))))))))
        : (c <= 119970 || (c < 124909
          ? (c < 120714
            ? (c < 120128
              ? (c < 120005
                ? (c < 119982
                  ? (c < 119977
                    ? (c >= 119973 && c <= 119974)
                    : c <= 119980)
                  : (c <= 119993 || (c < 119997
                    ? c == 119995
                    : c <= 120003)))
                : (c <= 120069 || (c < 120086
                  ? (c < 120077
                    ? (c >= 120071 && c <= 120074)
                    : c <= 120084)
                  : (c <= 120092 || (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)))))
              : (c <= 120132 || (c < 120540
                ? (c < 120146
                  ? (c < 120138
                    ? c == 120134
                    : c <= 120144)
                  : (c <= 120485 || (c < 120514
                    ? (c >= 120488 && c <= 120512)
                    : c <= 120538)))
                : (c <= 120570 || (c < 120630
                  ? (c < 120598
                    ? (c >= 120572 && c <= 120596)
                    : c <= 120628)
                  : (c <= 120654 || (c < 120688
                    ? (c >= 120656 && c <= 120686)
                    : c <= 120712)))))))
            : (c <= 120744 || (c < 122888
              ? (c < 121461
                ? (c < 120782
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 120831 || (c < 121403
                    ? (c >= 121344 && c <= 121398)
                    : c <= 121452)))
                : (c <= 121461 || (c < 121505
                  ? (c < 121499
                    ? c == 121476
                    : c <= 121503)
                  : (c <= 121519 || (c < 122880
                    ? (c >= 122624 && c <= 122654)
                    : c <= 122886)))))
              : (c <= 122904 || (c < 123200
                ? (c < 122918
                  ? (c < 122915
                    ? (c >= 122907 && c <= 122913)
                    : c <= 122916)
                  : (c <= 122922 || (c < 123184
                    ? (c >= 123136 && c <= 123180)
                    : c <= 123197)))
                : (c <= 123209 || (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123566)
                  : (c <= 123641 || (c < 124904
                    ? (c >= 124896 && c <= 124902)
                    : c <= 124907)))))))))
          : (c <= 124910 || (c < 126555
            ? (c < 126516
              ? (c < 126464
                ? (c < 125136
                  ? (c < 124928
                    ? (c >= 124912 && c <= 124926)
                    : c <= 125124)
                  : (c <= 125142 || (c < 125264
                    ? (c >= 125184 && c <= 125259)
                    : c <= 125273)))
                : (c <= 126467 || (c < 126500
                  ? (c < 126497
                    ? (c >= 126469 && c <= 126495)
                    : c <= 126498)
                  : (c <= 126500 || (c < 126505
                    ? c == 126503
                    : c <= 126514)))))
              : (c <= 126519 || (c < 126539
                ? (c < 126530
                  ? (c < 126523
                    ? c == 126521
                    : c <= 126523)
                  : (c <= 126530 || (c < 126537
                    ? c == 126535
                    : c <= 126537)))
                : (c <= 126539 || (c < 126548
                  ? (c < 126545
                    ? (c >= 126541 && c <= 126543)
                    : c <= 126546)
                  : (c <= 126548 || (c < 126553
                    ? c == 126551
                    : c <= 126553)))))))
            : (c <= 126555 || (c < 126625
              ? (c < 126572
                ? (c < 126561
                  ? (c < 126559
                    ? c == 126557
                    : c <= 126559)
                  : (c <= 126562 || (c < 126567
                    ? c == 126564
                    : c <= 126570)))
                : (c <= 126578 || (c < 126590
                  ? (c < 126585
                    ? (c >= 126580 && c <= 126583)
                    : c <= 126588)
                  : (c <= 126590 || (c < 126603
                    ? (c >= 126592 && c <= 126601)
                    : c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 130032
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 130041 || (c < 173824
                    ? (c >= 131072 && c <= 173791)
                    : c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c < 917760
                    ? (c >= 196608 && c <= 201546)
                    : c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_11(int32_t c) {
  return (c < 43616
    ? (c < 3782
      ? (c < 2741
        ? (c < 2042
          ? (c < 931
            ? (c < 248
              ? (c < 170
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'a'
                    ? c == '_'
                    : c <= 'z')))
                : (c <= 170 || (c < 186
                  ? (c < 183
                    ? c == 181
                    : c <= 183)
                  : (c <= 186 || (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)))))
              : (c <= 705 || (c < 886
                ? (c < 748
                  ? (c < 736
                    ? (c >= 710 && c <= 721)
                    : c <= 740)
                  : (c <= 748 || (c < 768
                    ? c == 750
                    : c <= 884)))
                : (c <= 887 || (c < 902
                  ? (c < 895
                    ? (c >= 891 && c <= 893)
                    : c <= 895)
                  : (c <= 906 || (c < 910
                    ? c == 908
                    : c <= 929)))))))
            : (c <= 1013 || (c < 1488
              ? (c < 1376
                ? (c < 1162
                  ? (c < 1155
                    ? (c >= 1015 && c <= 1153)
                    : c <= 1159)
                  : (c <= 1327 || (c < 1369
                    ? (c >= 1329 && c <= 1366)
                    : c <= 1369)))
                : (c <= 1416 || (c < 1473
                  ? (c < 1471
                    ? (c >= 1425 && c <= 1469)
                    : c <= 1471)
                  : (c <= 1474 || (c < 1479
                    ? (c >= 1476 && c <= 1477)
                    : c <= 1479)))))
              : (c <= 1514 || (c < 1759
                ? (c < 1568
                  ? (c < 1552
                    ? (c >= 1519 && c <= 1522)
                    : c <= 1562)
                  : (c <= 1641 || (c < 1749
                    ? (c >= 1646 && c <= 1747)
                    : c <= 1756)))
                : (c <= 1768 || (c < 1808
                  ? (c < 1791
                    ? (c >= 1770 && c <= 1788)
                    : c <= 1791)
                  : (c <= 1866 || (c < 1984
                    ? (c >= 1869 && c <= 1969)
                    : c <= 2037)))))))))
          : (c <= 2042 || (c < 2556
            ? (c < 2447
              ? (c < 2185
                ? (c < 2112
                  ? (c < 2048
                    ? c == 2045
                    : c <= 2093)
                  : (c <= 2139 || (c < 2160
                    ? (c >= 2144 && c <= 2154)
                    : c <= 2183)))
                : (c <= 2190 || (c < 2406
                  ? (c < 2275
                    ? (c >= 2200 && c <= 2273)
                    : c <= 2403)
                  : (c <= 2415 || (c < 2437
                    ? (c >= 2417 && c <= 2435)
                    : c <= 2444)))))
              : (c <= 2448 || (c < 2503
                ? (c < 2482
                  ? (c < 2474
                    ? (c >= 2451 && c <= 2472)
                    : c <= 2480)
                  : (c <= 2482 || (c < 2492
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2500)))
                : (c <= 2504 || (c < 2524
                  ? (c < 2519
                    ? (c >= 2507 && c <= 2510)
                    : c <= 2519)
                  : (c <= 2525 || (c < 2534
                    ? (c >= 2527 && c <= 2531)
                    : c <= 2545)))))))
            : (c <= 2556 || (c < 2631
              ? (c < 2602
                ? (c < 2565
                  ? (c < 2561
                    ? c == 2558
                    : c <= 2563)
                  : (c <= 2570 || (c < 2579
                    ? (c >= 2575 && c <= 2576)
                    : c <= 2600)))
                : (c <= 2608 || (c < 2616
                  ? (c < 2613
                    ? (c >= 2610 && c <= 2611)
                    : c <= 2614)
                  : (c <= 2617 || (c < 2622
                    ? c == 2620
                    : c <= 2626)))))
              : (c <= 2632 || (c < 2689
                ? (c < 2649
                  ? (c < 2641
                    ? (c >= 2635 && c <= 2637)
                    : c <= 2641)
                  : (c <= 2652 || (c < 2662
                    ? c == 2654
                    : c <= 2677)))
                : (c <= 2691 || (c < 2707
                  ? (c < 2703
                    ? (c >= 2693 && c <= 2701)
                    : c <= 2705)
                  : (c <= 2728 || (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)))))))))))
        : (c <= 2745 || (c < 3165
          ? (c < 2949
            ? (c < 2858
              ? (c < 2790
                ? (c < 2763
                  ? (c < 2759
                    ? (c >= 2748 && c <= 2757)
                    : c <= 2761)
                  : (c <= 2765 || (c < 2784
                    ? c == 2768
                    : c <= 2787)))
                : (c <= 2799 || (c < 2821
                  ? (c < 2817
                    ? (c >= 2809 && c <= 2815)
                    : c <= 2819)
                  : (c <= 2828 || (c < 2835
                    ? (c >= 2831 && c <= 2832)
                    : c <= 2856)))))
              : (c <= 2864 || (c < 2901
                ? (c < 2876
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2884 || (c < 2891
                    ? (c >= 2887 && c <= 2888)
                    : c <= 2893)))
                : (c <= 2903 || (c < 2918
                  ? (c < 2911
                    ? (c >= 2908 && c <= 2909)
                    : c <= 2915)
                  : (c <= 2927 || (c < 2946
                    ? c == 2929
                    : c <= 2947)))))))
            : (c <= 2954 || (c < 3024
              ? (c < 2979
                ? (c < 2969
                  ? (c < 2962
                    ? (c >= 2958 && c <= 2960)
                    : c <= 2965)
                  : (c <= 2970 || (c < 2974
                    ? c == 2972
                    : c <= 2975)))
                : (c <= 2980 || (c < 3006
                  ? (c < 2990
                    ? (c >= 2984 && c <= 2986)
                    : c <= 3001)
                  : (c <= 3010 || (c < 3018
                    ? (c >= 3014 && c <= 3016)
                    : c <= 3021)))))
              : (c <= 3024 || (c < 3114
                ? (c < 3072
                  ? (c < 3046
                    ? c == 3031
                    : c <= 3055)
                  : (c <= 3084 || (c < 3090
                    ? (c >= 3086 && c <= 3088)
                    : c <= 3112)))
                : (c <= 3129 || (c < 3146
                  ? (c < 3142
                    ? (c >= 3132 && c <= 3140)
                    : c <= 3144)
                  : (c <= 3149 || (c < 3160
                    ? (c >= 3157 && c <= 3158)
                    : c <= 3162)))))))))
          : (c <= 3165 || (c < 3430
            ? (c < 3285
              ? (c < 3218
                ? (c < 3200
                  ? (c < 3174
                    ? (c >= 3168 && c <= 3171)
                    : c <= 3183)
                  : (c <= 3203 || (c < 3214
                    ? (c >= 3205 && c <= 3212)
                    : c <= 3216)))
                : (c <= 3240 || (c < 3260
                  ? (c < 3253
                    ? (c >= 3242 && c <= 3251)
                    : c <= 3257)
                  : (c <= 3268 || (c < 3274
                    ? (c >= 3270 && c <= 3272)
                    : c <= 3277)))))
              : (c <= 3286 || (c < 3342
                ? (c < 3302
                  ? (c < 3296
                    ? (c >= 3293 && c <= 3294)
                    : c <= 3299)
                  : (c <= 3311 || (c < 3328
                    ? (c >= 3313 && c <= 3314)
                    : c <= 3340)))
                : (c <= 3344 || (c < 3402
                  ? (c < 3398
                    ? (c >= 3346 && c <= 3396)
                    : c <= 3400)
                  : (c <= 3406 || (c < 3423
                    ? (c >= 3412 && c <= 3415)
                    : c <= 3427)))))))
            : (c <= 3439 || (c < 3558
              ? (c < 3517
                ? (c < 3461
                  ? (c < 3457
                    ? (c >= 3450 && c <= 3455)
                    : c <= 3459)
                  : (c <= 3478 || (c < 3507
                    ? (c >= 3482 && c <= 3505)
                    : c <= 3515)))
                : (c <= 3517 || (c < 3535
                  ? (c < 3530
                    ? (c >= 3520 && c <= 3526)
                    : c <= 3530)
                  : (c <= 3540 || (c < 3544
                    ? c == 3542
                    : c <= 3551)))))
              : (c <= 3567 || (c < 3716
                ? (c < 3648
                  ? (c < 3585
                    ? (c >= 3570 && c <= 3571)
                    : c <= 3642)
                  : (c <= 3662 || (c < 3713
                    ? (c >= 3664 && c <= 3673)
                    : c <= 3714)))
                : (c <= 3716 || (c < 3749
                  ? (c < 3724
                    ? (c >= 3718 && c <= 3722)
                    : c <= 3747)
                  : (c <= 3749 || (c < 3776
                    ? (c >= 3751 && c <= 3773)
                    : c <= 3780)))))))))))))
      : (c <= 3782 || (c < 8025
        ? (c < 5888
          ? (c < 4688
            ? (c < 3953
              ? (c < 3872
                ? (c < 3804
                  ? (c < 3792
                    ? (c >= 3784 && c <= 3789)
                    : c <= 3801)
                  : (c <= 3807 || (c < 3864
                    ? c == 3840
                    : c <= 3865)))
                : (c <= 3881 || (c < 3897
                  ? (c < 3895
                    ? c == 3893
                    : c <= 3895)
                  : (c <= 3897 || (c < 3913
                    ? (c >= 3902 && c <= 3911)
                    : c <= 3948)))))
              : (c <= 3972 || (c < 4256
                ? (c < 4038
                  ? (c < 3993
                    ? (c >= 3974 && c <= 3991)
                    : c <= 4028)
                  : (c <= 4038 || (c < 4176
                    ? (c >= 4096 && c <= 4169)
                    : c <= 4253)))
                : (c <= 4293 || (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)))))))
            : (c <= 4694 || (c < 4882
              ? (c < 4786
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c < 4752
                    ? (c >= 4746 && c <= 4749)
                    : c <= 4784)))
                : (c <= 4789 || (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)))))
              : (c <= 4885 || (c < 5112
                ? (c < 4969
                  ? (c < 4957
                    ? (c >= 4888 && c <= 4954)
                    : c <= 4959)
                  : (c <= 4977 || (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)))
                : (c <= 5117 || (c < 5761
                  ? (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)
                  : (c <= 5786 || (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)))))))))
          : (c <= 5909 || (c < 6688
            ? (c < 6176
              ? (c < 6016
                ? (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5940)
                    : c <= 5971)
                  : (c <= 5996 || (c < 6002
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6003)))
                : (c <= 6099 || (c < 6112
                  ? (c < 6108
                    ? c == 6103
                    : c <= 6109)
                  : (c <= 6121 || (c < 6159
                    ? (c >= 6155 && c <= 6157)
                    : c <= 6169)))))
              : (c <= 6264 || (c < 6470
                ? (c < 6400
                  ? (c < 6320
                    ? (c >= 6272 && c <= 6314)
                    : c <= 6389)
                  : (c <= 6430 || (c < 6448
                    ? (c >= 6432 && c <= 6443)
                    : c <= 6459)))
                : (c <= 6509 || (c < 6576
                  ? (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)
                  : (c <= 6601 || (c < 6656
                    ? (c >= 6608 && c <= 6618)
                    : c <= 6683)))))))
            : (c <= 6750 || (c < 7232
              ? (c < 6847
                ? (c < 6800
                  ? (c < 6783
                    ? (c >= 6752 && c <= 6780)
                    : c <= 6793)
                  : (c <= 6809 || (c < 6832
                    ? c == 6823
                    : c <= 6845)))
                : (c <= 6862 || (c < 7019
                  ? (c < 6992
                    ? (c >= 6912 && c <= 6988)
                    : c <= 7001)
                  : (c <= 7027 || (c < 7168
                    ? (c >= 7040 && c <= 7155)
                    : c <= 7223)))))
              : (c <= 7241 || (c < 7380
                ? (c < 7312
                  ? (c < 7296
                    ? (c >= 7245 && c <= 7293)
                    : c <= 7304)
                  : (c <= 7354 || (c < 7376
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7378)))
                : (c <= 7418 || (c < 7968
                  ? (c < 7960
                    ? (c >= 7424 && c <= 7957)
                    : c <= 7965)
                  : (c <= 8005 || (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)))))))))))
        : (c <= 8025 || (c < 11720
          ? (c < 8458
            ? (c < 8178
              ? (c < 8126
                ? (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8061 || (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)))
                : (c <= 8126 || (c < 8144
                  ? (c < 8134
                    ? (c >= 8130 && c <= 8132)
                    : c <= 8140)
                  : (c <= 8147 || (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)))))
              : (c <= 8180 || (c < 8336
                ? (c < 8276
                  ? (c < 8255
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8256)
                  : (c <= 8276 || (c < 8319
                    ? c == 8305
                    : c <= 8319)))
                : (c <= 8348 || (c < 8421
                  ? (c < 8417
                    ? (c >= 8400 && c <= 8412)
                    : c <= 8417)
                  : (c <= 8432 || (c < 8455
                    ? c == 8450
                    : c <= 8455)))))))
            : (c <= 8467 || (c < 11499
              ? (c < 8490
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || (c < 8488
                    ? c == 8486
                    : c <= 8488)))
                : (c <= 8505 || (c < 8526
                  ? (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)
                  : (c <= 8526 || (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)))))
              : (c <= 11507 || (c < 11647
                ? (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)))
                : (c <= 11670 || (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)))))))))
          : (c <= 11726 || (c < 42623
            ? (c < 12540
              ? (c < 12337
                ? (c < 11744
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 11775 || (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12335)))
                : (c <= 12341 || (c < 12441
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12442 || (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)))))
              : (c <= 12543 || (c < 19968
                ? (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c < 13312
                    ? (c >= 12784 && c <= 12799)
                    : c <= 19903)))
                : (c <= 42124 || (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42539 || (c < 42612
                    ? (c >= 42560 && c <= 42607)
                    : c <= 42621)))))))
            : (c <= 42737 || (c < 43232
              ? (c < 42965
                ? (c < 42891
                  ? (c < 42786
                    ? (c >= 42775 && c <= 42783)
                    : c <= 42888)
                  : (c <= 42954 || (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)))
                : (c <= 42969 || (c < 43072
                  ? (c < 43052
                    ? (c >= 42994 && c <= 43047)
                    : c <= 43052)
                  : (c <= 43123 || (c < 43216
                    ? (c >= 43136 && c <= 43205)
                    : c <= 43225)))))
              : (c <= 43255 || (c < 43471
                ? (c < 43312
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43309)
                  : (c <= 43347 || (c < 43392
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43456)))
                : (c <= 43481 || (c < 43584
                  ? (c < 43520
                    ? (c >= 43488 && c <= 43518)
                    : c <= 43574)
                  : (c <= 43597 || (c >= 43600 && c <= 43609)))))))))))))))
    : (c <= 43638 || (c < 71453
      ? (c < 67639
        ? (c < 65345
          ? (c < 64312
            ? (c < 43888
              ? (c < 43785
                ? (c < 43744
                  ? (c < 43739
                    ? (c >= 43642 && c <= 43714)
                    : c <= 43741)
                  : (c <= 43759 || (c < 43777
                    ? (c >= 43762 && c <= 43766)
                    : c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c < 43868
                    ? (c >= 43824 && c <= 43866)
                    : c <= 43881)))))
              : (c <= 44010 || (c < 63744
                ? (c < 44032
                  ? (c < 44016
                    ? (c >= 44012 && c <= 44013)
                    : c <= 44025)
                  : (c <= 55203 || (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || (c < 64298
                    ? (c >= 64285 && c <= 64296)
                    : c <= 64310)))))))
            : (c <= 64316 || (c < 65075
              ? (c < 64612
                ? (c < 64323
                  ? (c < 64320
                    ? c == 64318
                    : c <= 64321)
                  : (c <= 64324 || (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)))
                : (c <= 64829 || (c < 65008
                  ? (c < 64914
                    ? (c >= 64848 && c <= 64911)
                    : c <= 64967)
                  : (c <= 65017 || (c < 65056
                    ? (c >= 65024 && c <= 65039)
                    : c <= 65071)))))
              : (c <= 65076 || (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65101 && c <= 65103)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65296
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65305 || (c < 65343
                    ? (c >= 65313 && c <= 65338)
                    : c <= 65343)))))))))
          : (c <= 65370 || (c < 66513
            ? (c < 65664
              ? (c < 65536
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65382 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c < 65498
                    ? (c >= 65490 && c <= 65495)
                    : c <= 65500)))
                : (c <= 65547 || (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c < 65616
                    ? (c >= 65599 && c <= 65613)
                    : c <= 65629)))))
              : (c <= 65786 || (c < 66304
                ? (c < 66176
                  ? (c < 66045
                    ? (c >= 65856 && c <= 65908)
                    : c <= 66045)
                  : (c <= 66204 || (c < 66272
                    ? (c >= 66208 && c <= 66256)
                    : c <= 66272)))
                : (c <= 66335 || (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66426)
                  : (c <= 66461 || (c < 66504
                    ? (c >= 66464 && c <= 66499)
                    : c <= 66511)))))))
            : (c <= 66517 || (c < 66979
              ? (c < 66864
                ? (c < 66736
                  ? (c < 66720
                    ? (c >= 66560 && c <= 66717)
                    : c <= 66729)
                  : (c <= 66771 || (c < 66816
                    ? (c >= 66776 && c <= 66811)
                    : c <= 66855)))
                : (c <= 66915 || (c < 66956
                  ? (c < 66940
                    ? (c >= 66928 && c <= 66938)
                    : c <= 66954)
                  : (c <= 66962 || (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)))))
              : (c <= 66993 || (c < 67456
                ? (c < 67072
                  ? (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)
                  : (c <= 67382 || (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)))
                : (c <= 67461 || (c < 67584
                  ? (c < 67506
                    ? (c >= 67463 && c <= 67504)
                    : c <= 67514)
                  : (c <= 67589 || (c < 67594
                    ? c == 67592
                    : c <= 67637)))))))))))
        : (c <= 67640 || (c < 69956
          ? (c < 68448
            ? (c < 68101
              ? (c < 67828
                ? (c < 67680
                  ? (c < 67647
                    ? c == 67644
                    : c <= 67669)
                  : (c <= 67702 || (c < 67808
                    ? (c >= 67712 && c <= 67742)
                    : c <= 67826)))
                : (c <= 67829 || (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c < 68096
                    ? (c >= 68030 && c <= 68031)
                    : c <= 68099)))))
              : (c <= 68102 || (c < 68192
                ? (c < 68121
                  ? (c < 68117
                    ? (c >= 68108 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c < 68159
                    ? (c >= 68152 && c <= 68154)
                    : c <= 68159)))
                : (c <= 68220 || (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68326 || (c < 68416
                    ? (c >= 68352 && c <= 68405)
                    : c <= 68437)))))))
            : (c <= 68466 || (c < 69424
              ? (c < 68912
                ? (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c < 68864
                    ? (c >= 68800 && c <= 68850)
                    : c <= 68903)))
                : (c <= 68921 || (c < 69296
                  ? (c < 69291
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69292)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))))
              : (c <= 69456 || (c < 69759
                ? (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69509)
                    : c <= 69572)
                  : (c <= 69622 || (c < 69734
                    ? (c >= 69632 && c <= 69702)
                    : c <= 69749)))
                : (c <= 69818 || (c < 69872
                  ? (c < 69840
                    ? c == 69826
                    : c <= 69864)
                  : (c <= 69881 || (c < 69942
                    ? (c >= 69888 && c <= 69940)
                    : c <= 69951)))))))))
          : (c <= 69959 || (c < 70459
            ? (c < 70282
              ? (c < 70108
                ? (c < 70016
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70003)
                    : c <= 70006)
                  : (c <= 70084 || (c < 70094
                    ? (c >= 70089 && c <= 70092)
                    : c <= 70106)))
                : (c <= 70108 || (c < 70206
                  ? (c < 70163
                    ? (c >= 70144 && c <= 70161)
                    : c <= 70199)
                  : (c <= 70206 || (c < 70280
                    ? (c >= 70272 && c <= 70278)
                    : c <= 70280)))))
              : (c <= 70285 || (c < 70405
                ? (c < 70320
                  ? (c < 70303
                    ? (c >= 70287 && c <= 70301)
                    : c <= 70312)
                  : (c <= 70378 || (c < 70400
                    ? (c >= 70384 && c <= 70393)
                    : c <= 70403)))
                : (c <= 70412 || (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c < 70453
                    ? (c >= 70450 && c <= 70451)
                    : c <= 70457)))))))
            : (c <= 70468 || (c < 70855
              ? (c < 70502
                ? (c < 70480
                  ? (c < 70475
                    ? (c >= 70471 && c <= 70472)
                    : c <= 70477)
                  : (c <= 70480 || (c < 70493
                    ? c == 70487
                    : c <= 70499)))
                : (c <= 70508 || (c < 70736
                  ? (c < 70656
                    ? (c >= 70512 && c <= 70516)
                    : c <= 70730)
                  : (c <= 70745 || (c < 70784
                    ? (c >= 70750 && c <= 70753)
                    : c <= 70853)))))
              : (c <= 70855 || (c < 71236
                ? (c < 71096
                  ? (c < 71040
                    ? (c >= 70864 && c <= 70873)
                    : c <= 71093)
                  : (c <= 71104 || (c < 71168
                    ? (c >= 71128 && c <= 71133)
                    : c <= 71232)))
                : (c <= 71236 || (c < 71360
                  ? (c < 71296
                    ? (c >= 71248 && c <= 71257)
                    : c <= 71352)
                  : (c <= 71369 || (c >= 71424 && c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_12(int32_t c) {
  return (c < 43616
    ? (c < 3782
      ? (c < 2741
        ? (c < 2042
          ? (c < 931
            ? (c < 248
              ? (c < 170
                ? (c < 'A'
                  ? (c < '2'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'a'
                    ? c == '_'
                    : c <= 'z')))
                : (c <= 170 || (c < 186
                  ? (c < 183
                    ? c == 181
                    : c <= 183)
                  : (c <= 186 || (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)))))
              : (c <= 705 || (c < 886
                ? (c < 748
                  ? (c < 736
                    ? (c >= 710 && c <= 721)
                    : c <= 740)
                  : (c <= 748 || (c < 768
                    ? c == 750
                    : c <= 884)))
                : (c <= 887 || (c < 902
                  ? (c < 895
                    ? (c >= 891 && c <= 893)
                    : c <= 895)
                  : (c <= 906 || (c < 910
                    ? c == 908
                    : c <= 929)))))))
            : (c <= 1013 || (c < 1488
              ? (c < 1376
                ? (c < 1162
                  ? (c < 1155
                    ? (c >= 1015 && c <= 1153)
                    : c <= 1159)
                  : (c <= 1327 || (c < 1369
                    ? (c >= 1329 && c <= 1366)
                    : c <= 1369)))
                : (c <= 1416 || (c < 1473
                  ? (c < 1471
                    ? (c >= 1425 && c <= 1469)
                    : c <= 1471)
                  : (c <= 1474 || (c < 1479
                    ? (c >= 1476 && c <= 1477)
                    : c <= 1479)))))
              : (c <= 1514 || (c < 1759
                ? (c < 1568
                  ? (c < 1552
                    ? (c >= 1519 && c <= 1522)
                    : c <= 1562)
                  : (c <= 1641 || (c < 1749
                    ? (c >= 1646 && c <= 1747)
                    : c <= 1756)))
                : (c <= 1768 || (c < 1808
                  ? (c < 1791
                    ? (c >= 1770 && c <= 1788)
                    : c <= 1791)
                  : (c <= 1866 || (c < 1984
                    ? (c >= 1869 && c <= 1969)
                    : c <= 2037)))))))))
          : (c <= 2042 || (c < 2556
            ? (c < 2447
              ? (c < 2185
                ? (c < 2112
                  ? (c < 2048
                    ? c == 2045
                    : c <= 2093)
                  : (c <= 2139 || (c < 2160
                    ? (c >= 2144 && c <= 2154)
                    : c <= 2183)))
                : (c <= 2190 || (c < 2406
                  ? (c < 2275
                    ? (c >= 2200 && c <= 2273)
                    : c <= 2403)
                  : (c <= 2415 || (c < 2437
                    ? (c >= 2417 && c <= 2435)
                    : c <= 2444)))))
              : (c <= 2448 || (c < 2503
                ? (c < 2482
                  ? (c < 2474
                    ? (c >= 2451 && c <= 2472)
                    : c <= 2480)
                  : (c <= 2482 || (c < 2492
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2500)))
                : (c <= 2504 || (c < 2524
                  ? (c < 2519
                    ? (c >= 2507 && c <= 2510)
                    : c <= 2519)
                  : (c <= 2525 || (c < 2534
                    ? (c >= 2527 && c <= 2531)
                    : c <= 2545)))))))
            : (c <= 2556 || (c < 2631
              ? (c < 2602
                ? (c < 2565
                  ? (c < 2561
                    ? c == 2558
                    : c <= 2563)
                  : (c <= 2570 || (c < 2579
                    ? (c >= 2575 && c <= 2576)
                    : c <= 2600)))
                : (c <= 2608 || (c < 2616
                  ? (c < 2613
                    ? (c >= 2610 && c <= 2611)
                    : c <= 2614)
                  : (c <= 2617 || (c < 2622
                    ? c == 2620
                    : c <= 2626)))))
              : (c <= 2632 || (c < 2689
                ? (c < 2649
                  ? (c < 2641
                    ? (c >= 2635 && c <= 2637)
                    : c <= 2641)
                  : (c <= 2652 || (c < 2662
                    ? c == 2654
                    : c <= 2677)))
                : (c <= 2691 || (c < 2707
                  ? (c < 2703
                    ? (c >= 2693 && c <= 2701)
                    : c <= 2705)
                  : (c <= 2728 || (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)))))))))))
        : (c <= 2745 || (c < 3165
          ? (c < 2949
            ? (c < 2858
              ? (c < 2790
                ? (c < 2763
                  ? (c < 2759
                    ? (c >= 2748 && c <= 2757)
                    : c <= 2761)
                  : (c <= 2765 || (c < 2784
                    ? c == 2768
                    : c <= 2787)))
                : (c <= 2799 || (c < 2821
                  ? (c < 2817
                    ? (c >= 2809 && c <= 2815)
                    : c <= 2819)
                  : (c <= 2828 || (c < 2835
                    ? (c >= 2831 && c <= 2832)
                    : c <= 2856)))))
              : (c <= 2864 || (c < 2901
                ? (c < 2876
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2884 || (c < 2891
                    ? (c >= 2887 && c <= 2888)
                    : c <= 2893)))
                : (c <= 2903 || (c < 2918
                  ? (c < 2911
                    ? (c >= 2908 && c <= 2909)
                    : c <= 2915)
                  : (c <= 2927 || (c < 2946
                    ? c == 2929
                    : c <= 2947)))))))
            : (c <= 2954 || (c < 3024
              ? (c < 2979
                ? (c < 2969
                  ? (c < 2962
                    ? (c >= 2958 && c <= 2960)
                    : c <= 2965)
                  : (c <= 2970 || (c < 2974
                    ? c == 2972
                    : c <= 2975)))
                : (c <= 2980 || (c < 3006
                  ? (c < 2990
                    ? (c >= 2984 && c <= 2986)
                    : c <= 3001)
                  : (c <= 3010 || (c < 3018
                    ? (c >= 3014 && c <= 3016)
                    : c <= 3021)))))
              : (c <= 3024 || (c < 3114
                ? (c < 3072
                  ? (c < 3046
                    ? c == 3031
                    : c <= 3055)
                  : (c <= 3084 || (c < 3090
                    ? (c >= 3086 && c <= 3088)
                    : c <= 3112)))
                : (c <= 3129 || (c < 3146
                  ? (c < 3142
                    ? (c >= 3132 && c <= 3140)
                    : c <= 3144)
                  : (c <= 3149 || (c < 3160
                    ? (c >= 3157 && c <= 3158)
                    : c <= 3162)))))))))
          : (c <= 3165 || (c < 3430
            ? (c < 3285
              ? (c < 3218
                ? (c < 3200
                  ? (c < 3174
                    ? (c >= 3168 && c <= 3171)
                    : c <= 3183)
                  : (c <= 3203 || (c < 3214
                    ? (c >= 3205 && c <= 3212)
                    : c <= 3216)))
                : (c <= 3240 || (c < 3260
                  ? (c < 3253
                    ? (c >= 3242 && c <= 3251)
                    : c <= 3257)
                  : (c <= 3268 || (c < 3274
                    ? (c >= 3270 && c <= 3272)
                    : c <= 3277)))))
              : (c <= 3286 || (c < 3342
                ? (c < 3302
                  ? (c < 3296
                    ? (c >= 3293 && c <= 3294)
                    : c <= 3299)
                  : (c <= 3311 || (c < 3328
                    ? (c >= 3313 && c <= 3314)
                    : c <= 3340)))
                : (c <= 3344 || (c < 3402
                  ? (c < 3398
                    ? (c >= 3346 && c <= 3396)
                    : c <= 3400)
                  : (c <= 3406 || (c < 3423
                    ? (c >= 3412 && c <= 3415)
                    : c <= 3427)))))))
            : (c <= 3439 || (c < 3558
              ? (c < 3517
                ? (c < 3461
                  ? (c < 3457
                    ? (c >= 3450 && c <= 3455)
                    : c <= 3459)
                  : (c <= 3478 || (c < 3507
                    ? (c >= 3482 && c <= 3505)
                    : c <= 3515)))
                : (c <= 3517 || (c < 3535
                  ? (c < 3530
                    ? (c >= 3520 && c <= 3526)
                    : c <= 3530)
                  : (c <= 3540 || (c < 3544
                    ? c == 3542
                    : c <= 3551)))))
              : (c <= 3567 || (c < 3716
                ? (c < 3648
                  ? (c < 3585
                    ? (c >= 3570 && c <= 3571)
                    : c <= 3642)
                  : (c <= 3662 || (c < 3713
                    ? (c >= 3664 && c <= 3673)
                    : c <= 3714)))
                : (c <= 3716 || (c < 3749
                  ? (c < 3724
                    ? (c >= 3718 && c <= 3722)
                    : c <= 3747)
                  : (c <= 3749 || (c < 3776
                    ? (c >= 3751 && c <= 3773)
                    : c <= 3780)))))))))))))
      : (c <= 3782 || (c < 8025
        ? (c < 5888
          ? (c < 4688
            ? (c < 3953
              ? (c < 3872
                ? (c < 3804
                  ? (c < 3792
                    ? (c >= 3784 && c <= 3789)
                    : c <= 3801)
                  : (c <= 3807 || (c < 3864
                    ? c == 3840
                    : c <= 3865)))
                : (c <= 3881 || (c < 3897
                  ? (c < 3895
                    ? c == 3893
                    : c <= 3895)
                  : (c <= 3897 || (c < 3913
                    ? (c >= 3902 && c <= 3911)
                    : c <= 3948)))))
              : (c <= 3972 || (c < 4256
                ? (c < 4038
                  ? (c < 3993
                    ? (c >= 3974 && c <= 3991)
                    : c <= 4028)
                  : (c <= 4038 || (c < 4176
                    ? (c >= 4096 && c <= 4169)
                    : c <= 4253)))
                : (c <= 4293 || (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)))))))
            : (c <= 4694 || (c < 4882
              ? (c < 4786
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c < 4752
                    ? (c >= 4746 && c <= 4749)
                    : c <= 4784)))
                : (c <= 4789 || (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)))))
              : (c <= 4885 || (c < 5112
                ? (c < 4969
                  ? (c < 4957
                    ? (c >= 4888 && c <= 4954)
                    : c <= 4959)
                  : (c <= 4977 || (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)))
                : (c <= 5117 || (c < 5761
                  ? (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)
                  : (c <= 5786 || (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)))))))))
          : (c <= 5909 || (c < 6688
            ? (c < 6176
              ? (c < 6016
                ? (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5940)
                    : c <= 5971)
                  : (c <= 5996 || (c < 6002
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6003)))
                : (c <= 6099 || (c < 6112
                  ? (c < 6108
                    ? c == 6103
                    : c <= 6109)
                  : (c <= 6121 || (c < 6159
                    ? (c >= 6155 && c <= 6157)
                    : c <= 6169)))))
              : (c <= 6264 || (c < 6470
                ? (c < 6400
                  ? (c < 6320
                    ? (c >= 6272 && c <= 6314)
                    : c <= 6389)
                  : (c <= 6430 || (c < 6448
                    ? (c >= 6432 && c <= 6443)
                    : c <= 6459)))
                : (c <= 6509 || (c < 6576
                  ? (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)
                  : (c <= 6601 || (c < 6656
                    ? (c >= 6608 && c <= 6618)
                    : c <= 6683)))))))
            : (c <= 6750 || (c < 7232
              ? (c < 6847
                ? (c < 6800
                  ? (c < 6783
                    ? (c >= 6752 && c <= 6780)
                    : c <= 6793)
                  : (c <= 6809 || (c < 6832
                    ? c == 6823
                    : c <= 6845)))
                : (c <= 6862 || (c < 7019
                  ? (c < 6992
                    ? (c >= 6912 && c <= 6988)
                    : c <= 7001)
                  : (c <= 7027 || (c < 7168
                    ? (c >= 7040 && c <= 7155)
                    : c <= 7223)))))
              : (c <= 7241 || (c < 7380
                ? (c < 7312
                  ? (c < 7296
                    ? (c >= 7245 && c <= 7293)
                    : c <= 7304)
                  : (c <= 7354 || (c < 7376
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7378)))
                : (c <= 7418 || (c < 7968
                  ? (c < 7960
                    ? (c >= 7424 && c <= 7957)
                    : c <= 7965)
                  : (c <= 8005 || (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)))))))))))
        : (c <= 8025 || (c < 11720
          ? (c < 8458
            ? (c < 8178
              ? (c < 8126
                ? (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8061 || (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)))
                : (c <= 8126 || (c < 8144
                  ? (c < 8134
                    ? (c >= 8130 && c <= 8132)
                    : c <= 8140)
                  : (c <= 8147 || (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)))))
              : (c <= 8180 || (c < 8336
                ? (c < 8276
                  ? (c < 8255
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8256)
                  : (c <= 8276 || (c < 8319
                    ? c == 8305
                    : c <= 8319)))
                : (c <= 8348 || (c < 8421
                  ? (c < 8417
                    ? (c >= 8400 && c <= 8412)
                    : c <= 8417)
                  : (c <= 8432 || (c < 8455
                    ? c == 8450
                    : c <= 8455)))))))
            : (c <= 8467 || (c < 11499
              ? (c < 8490
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || (c < 8488
                    ? c == 8486
                    : c <= 8488)))
                : (c <= 8505 || (c < 8526
                  ? (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)
                  : (c <= 8526 || (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)))))
              : (c <= 11507 || (c < 11647
                ? (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)))
                : (c <= 11670 || (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)))))))))
          : (c <= 11726 || (c < 42623
            ? (c < 12540
              ? (c < 12337
                ? (c < 11744
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 11775 || (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12335)))
                : (c <= 12341 || (c < 12441
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12442 || (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)))))
              : (c <= 12543 || (c < 19968
                ? (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c < 13312
                    ? (c >= 12784 && c <= 12799)
                    : c <= 19903)))
                : (c <= 42124 || (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42539 || (c < 42612
                    ? (c >= 42560 && c <= 42607)
                    : c <= 42621)))))))
            : (c <= 42737 || (c < 43232
              ? (c < 42965
                ? (c < 42891
                  ? (c < 42786
                    ? (c >= 42775 && c <= 42783)
                    : c <= 42888)
                  : (c <= 42954 || (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)))
                : (c <= 42969 || (c < 43072
                  ? (c < 43052
                    ? (c >= 42994 && c <= 43047)
                    : c <= 43052)
                  : (c <= 43123 || (c < 43216
                    ? (c >= 43136 && c <= 43205)
                    : c <= 43225)))))
              : (c <= 43255 || (c < 43471
                ? (c < 43312
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43309)
                  : (c <= 43347 || (c < 43392
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43456)))
                : (c <= 43481 || (c < 43584
                  ? (c < 43520
                    ? (c >= 43488 && c <= 43518)
                    : c <= 43574)
                  : (c <= 43597 || (c >= 43600 && c <= 43609)))))))))))))))
    : (c <= 43638 || (c < 71453
      ? (c < 67639
        ? (c < 65345
          ? (c < 64312
            ? (c < 43888
              ? (c < 43785
                ? (c < 43744
                  ? (c < 43739
                    ? (c >= 43642 && c <= 43714)
                    : c <= 43741)
                  : (c <= 43759 || (c < 43777
                    ? (c >= 43762 && c <= 43766)
                    : c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c < 43868
                    ? (c >= 43824 && c <= 43866)
                    : c <= 43881)))))
              : (c <= 44010 || (c < 63744
                ? (c < 44032
                  ? (c < 44016
                    ? (c >= 44012 && c <= 44013)
                    : c <= 44025)
                  : (c <= 55203 || (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || (c < 64298
                    ? (c >= 64285 && c <= 64296)
                    : c <= 64310)))))))
            : (c <= 64316 || (c < 65075
              ? (c < 64612
                ? (c < 64323
                  ? (c < 64320
                    ? c == 64318
                    : c <= 64321)
                  : (c <= 64324 || (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)))
                : (c <= 64829 || (c < 65008
                  ? (c < 64914
                    ? (c >= 64848 && c <= 64911)
                    : c <= 64967)
                  : (c <= 65017 || (c < 65056
                    ? (c >= 65024 && c <= 65039)
                    : c <= 65071)))))
              : (c <= 65076 || (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65101 && c <= 65103)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65296
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65305 || (c < 65343
                    ? (c >= 65313 && c <= 65338)
                    : c <= 65343)))))))))
          : (c <= 65370 || (c < 66513
            ? (c < 65664
              ? (c < 65536
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65382 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c < 65498
                    ? (c >= 65490 && c <= 65495)
                    : c <= 65500)))
                : (c <= 65547 || (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c < 65616
                    ? (c >= 65599 && c <= 65613)
                    : c <= 65629)))))
              : (c <= 65786 || (c < 66304
                ? (c < 66176
                  ? (c < 66045
                    ? (c >= 65856 && c <= 65908)
                    : c <= 66045)
                  : (c <= 66204 || (c < 66272
                    ? (c >= 66208 && c <= 66256)
                    : c <= 66272)))
                : (c <= 66335 || (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66426)
                  : (c <= 66461 || (c < 66504
                    ? (c >= 66464 && c <= 66499)
                    : c <= 66511)))))))
            : (c <= 66517 || (c < 66979
              ? (c < 66864
                ? (c < 66736
                  ? (c < 66720
                    ? (c >= 66560 && c <= 66717)
                    : c <= 66729)
                  : (c <= 66771 || (c < 66816
                    ? (c >= 66776 && c <= 66811)
                    : c <= 66855)))
                : (c <= 66915 || (c < 66956
                  ? (c < 66940
                    ? (c >= 66928 && c <= 66938)
                    : c <= 66954)
                  : (c <= 66962 || (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)))))
              : (c <= 66993 || (c < 67456
                ? (c < 67072
                  ? (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)
                  : (c <= 67382 || (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)))
                : (c <= 67461 || (c < 67584
                  ? (c < 67506
                    ? (c >= 67463 && c <= 67504)
                    : c <= 67514)
                  : (c <= 67589 || (c < 67594
                    ? c == 67592
                    : c <= 67637)))))))))))
        : (c <= 67640 || (c < 69956
          ? (c < 68448
            ? (c < 68101
              ? (c < 67828
                ? (c < 67680
                  ? (c < 67647
                    ? c == 67644
                    : c <= 67669)
                  : (c <= 67702 || (c < 67808
                    ? (c >= 67712 && c <= 67742)
                    : c <= 67826)))
                : (c <= 67829 || (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c < 68096
                    ? (c >= 68030 && c <= 68031)
                    : c <= 68099)))))
              : (c <= 68102 || (c < 68192
                ? (c < 68121
                  ? (c < 68117
                    ? (c >= 68108 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c < 68159
                    ? (c >= 68152 && c <= 68154)
                    : c <= 68159)))
                : (c <= 68220 || (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68326 || (c < 68416
                    ? (c >= 68352 && c <= 68405)
                    : c <= 68437)))))))
            : (c <= 68466 || (c < 69424
              ? (c < 68912
                ? (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c < 68864
                    ? (c >= 68800 && c <= 68850)
                    : c <= 68903)))
                : (c <= 68921 || (c < 69296
                  ? (c < 69291
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69292)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))))
              : (c <= 69456 || (c < 69759
                ? (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69509)
                    : c <= 69572)
                  : (c <= 69622 || (c < 69734
                    ? (c >= 69632 && c <= 69702)
                    : c <= 69749)))
                : (c <= 69818 || (c < 69872
                  ? (c < 69840
                    ? c == 69826
                    : c <= 69864)
                  : (c <= 69881 || (c < 69942
                    ? (c >= 69888 && c <= 69940)
                    : c <= 69951)))))))))
          : (c <= 69959 || (c < 70459
            ? (c < 70282
              ? (c < 70108
                ? (c < 70016
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70003)
                    : c <= 70006)
                  : (c <= 70084 || (c < 70094
                    ? (c >= 70089 && c <= 70092)
                    : c <= 70106)))
                : (c <= 70108 || (c < 70206
                  ? (c < 70163
                    ? (c >= 70144 && c <= 70161)
                    : c <= 70199)
                  : (c <= 70206 || (c < 70280
                    ? (c >= 70272 && c <= 70278)
                    : c <= 70280)))))
              : (c <= 70285 || (c < 70405
                ? (c < 70320
                  ? (c < 70303
                    ? (c >= 70287 && c <= 70301)
                    : c <= 70312)
                  : (c <= 70378 || (c < 70400
                    ? (c >= 70384 && c <= 70393)
                    : c <= 70403)))
                : (c <= 70412 || (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c < 70453
                    ? (c >= 70450 && c <= 70451)
                    : c <= 70457)))))))
            : (c <= 70468 || (c < 70855
              ? (c < 70502
                ? (c < 70480
                  ? (c < 70475
                    ? (c >= 70471 && c <= 70472)
                    : c <= 70477)
                  : (c <= 70480 || (c < 70493
                    ? c == 70487
                    : c <= 70499)))
                : (c <= 70508 || (c < 70736
                  ? (c < 70656
                    ? (c >= 70512 && c <= 70516)
                    : c <= 70730)
                  : (c <= 70745 || (c < 70784
                    ? (c >= 70750 && c <= 70753)
                    : c <= 70853)))))
              : (c <= 70855 || (c < 71236
                ? (c < 71096
                  ? (c < 71040
                    ? (c >= 70864 && c <= 70873)
                    : c <= 71093)
                  : (c <= 71104 || (c < 71168
                    ? (c >= 71128 && c <= 71133)
                    : c <= 71232)))
                : (c <= 71236 || (c < 71360
                  ? (c < 71296
                    ? (c >= 71248 && c <= 71257)
                    : c <= 71352)
                  : (c <= 71369 || (c >= 71424 && c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_13(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'a'
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Q' || (c < '_'
                    ? (c >= 'S' && c <= 'Z')
                    : c <= '_')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_14(int32_t c) {
  return (c < 43584
    ? (c < 3749
      ? (c < 2707
        ? (c < 1808
          ? (c < 902
            ? (c < 186
              ? (c < '_'
                ? (c < '9'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '7')
                  : (c <= '9' || (c < 'S'
                    ? (c >= 'A' && c <= 'Q')
                    : c <= 'Z')))
                : (c <= '_' || (c < 170
                  ? (c < 'j'
                    ? (c >= 'a' && c <= 'h')
                    : c <= 'z')
                  : (c <= 170 || (c < 183
                    ? c == 181
                    : c <= 183)))))
              : (c <= 186 || (c < 748
                ? (c < 248
                  ? (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)
                  : (c <= 705 || (c < 736
                    ? (c >= 710 && c <= 721)
                    : c <= 740)))
                : (c <= 748 || (c < 886
                  ? (c < 768
                    ? c == 750
                    : c <= 884)
                  : (c <= 887 || (c < 895
                    ? (c >= 891 && c <= 893)
                    : c <= 895)))))))
            : (c <= 906 || (c < 1473
              ? (c < 1162
                ? (c < 931
                  ? (c < 910
                    ? c == 908
                    : c <= 929)
                  : (c <= 1013 || (c < 1155
                    ? (c >= 1015 && c <= 1153)
                    : c <= 1159)))
                : (c <= 1327 || (c < 1376
                  ? (c < 1369
                    ? (c >= 1329 && c <= 1366)
                    : c <= 1369)
                  : (c <= 1416 || (c < 1471
                    ? (c >= 1425 && c <= 1469)
                    : c <= 1471)))))
              : (c <= 1474 || (c < 1568
                ? (c < 1488
                  ? (c < 1479
                    ? (c >= 1476 && c <= 1477)
                    : c <= 1479)
                  : (c <= 1514 || (c < 1552
                    ? (c >= 1519 && c <= 1522)
                    : c <= 1562)))
                : (c <= 1641 || (c < 1759
                  ? (c < 1749
                    ? (c >= 1646 && c <= 1747)
                    : c <= 1756)
                  : (c <= 1768 || (c < 1791
                    ? (c >= 1770 && c <= 1788)
                    : c <= 1791)))))))))
          : (c <= 1866 || (c < 2524
            ? (c < 2406
              ? (c < 2112
                ? (c < 2042
                  ? (c < 1984
                    ? (c >= 1869 && c <= 1969)
                    : c <= 2037)
                  : (c <= 2042 || (c < 2048
                    ? c == 2045
                    : c <= 2093)))
                : (c <= 2139 || (c < 2185
                  ? (c < 2160
                    ? (c >= 2144 && c <= 2154)
                    : c <= 2183)
                  : (c <= 2190 || (c < 2275
                    ? (c >= 2200 && c <= 2273)
                    : c <= 2403)))))
              : (c <= 2415 || (c < 2482
                ? (c < 2447
                  ? (c < 2437
                    ? (c >= 2417 && c <= 2435)
                    : c <= 2444)
                  : (c <= 2448 || (c < 2474
                    ? (c >= 2451 && c <= 2472)
                    : c <= 2480)))
                : (c <= 2482 || (c < 2503
                  ? (c < 2492
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2500)
                  : (c <= 2504 || (c < 2519
                    ? (c >= 2507 && c <= 2510)
                    : c <= 2519)))))))
            : (c <= 2525 || (c < 2616
              ? (c < 2565
                ? (c < 2556
                  ? (c < 2534
                    ? (c >= 2527 && c <= 2531)
                    : c <= 2545)
                  : (c <= 2556 || (c < 2561
                    ? c == 2558
                    : c <= 2563)))
                : (c <= 2570 || (c < 2602
                  ? (c < 2579
                    ? (c >= 2575 && c <= 2576)
                    : c <= 2600)
                  : (c <= 2608 || (c < 2613
                    ? (c >= 2610 && c <= 2611)
                    : c <= 2614)))))
              : (c <= 2617 || (c < 2649
                ? (c < 2631
                  ? (c < 2622
                    ? c == 2620
                    : c <= 2626)
                  : (c <= 2632 || (c < 2641
                    ? (c >= 2635 && c <= 2637)
                    : c <= 2641)))
                : (c <= 2652 || (c < 2689
                  ? (c < 2662
                    ? c == 2654
                    : c <= 2677)
                  : (c <= 2691 || (c < 2703
                    ? (c >= 2693 && c <= 2701)
                    : c <= 2705)))))))))))
        : (c <= 2728 || (c < 3146
          ? (c < 2918
            ? (c < 2821
              ? (c < 2763
                ? (c < 2741
                  ? (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)
                  : (c <= 2745 || (c < 2759
                    ? (c >= 2748 && c <= 2757)
                    : c <= 2761)))
                : (c <= 2765 || (c < 2790
                  ? (c < 2784
                    ? c == 2768
                    : c <= 2787)
                  : (c <= 2799 || (c < 2817
                    ? (c >= 2809 && c <= 2815)
                    : c <= 2819)))))
              : (c <= 2828 || (c < 2876
                ? (c < 2858
                  ? (c < 2835
                    ? (c >= 2831 && c <= 2832)
                    : c <= 2856)
                  : (c <= 2864 || (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)))
                : (c <= 2884 || (c < 2901
                  ? (c < 2891
                    ? (c >= 2887 && c <= 2888)
                    : c <= 2893)
                  : (c <= 2903 || (c < 2911
                    ? (c >= 2908 && c <= 2909)
                    : c <= 2915)))))))
            : (c <= 2927 || (c < 3006
              ? (c < 2969
                ? (c < 2949
                  ? (c < 2946
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c < 2962
                    ? (c >= 2958 && c <= 2960)
                    : c <= 2965)))
                : (c <= 2970 || (c < 2979
                  ? (c < 2974
                    ? c == 2972
                    : c <= 2975)
                  : (c <= 2980 || (c < 2990
                    ? (c >= 2984 && c <= 2986)
                    : c <= 3001)))))
              : (c <= 3010 || (c < 3072
                ? (c < 3024
                  ? (c < 3018
                    ? (c >= 3014 && c <= 3016)
                    : c <= 3021)
                  : (c <= 3024 || (c < 3046
                    ? c == 3031
                    : c <= 3055)))
                : (c <= 3084 || (c < 3114
                  ? (c < 3090
                    ? (c >= 3086 && c <= 3088)
                    : c <= 3112)
                  : (c <= 3129 || (c < 3142
                    ? (c >= 3132 && c <= 3140)
                    : c <= 3144)))))))))
          : (c <= 3149 || (c < 3402
            ? (c < 3260
              ? (c < 3200
                ? (c < 3165
                  ? (c < 3160
                    ? (c >= 3157 && c <= 3158)
                    : c <= 3162)
                  : (c <= 3165 || (c < 3174
                    ? (c >= 3168 && c <= 3171)
                    : c <= 3183)))
                : (c <= 3203 || (c < 3218
                  ? (c < 3214
                    ? (c >= 3205 && c <= 3212)
                    : c <= 3216)
                  : (c <= 3240 || (c < 3253
                    ? (c >= 3242 && c <= 3251)
                    : c <= 3257)))))
              : (c <= 3268 || (c < 3302
                ? (c < 3285
                  ? (c < 3274
                    ? (c >= 3270 && c <= 3272)
                    : c <= 3277)
                  : (c <= 3286 || (c < 3296
                    ? (c >= 3293 && c <= 3294)
                    : c <= 3299)))
                : (c <= 3311 || (c < 3342
                  ? (c < 3328
                    ? (c >= 3313 && c <= 3314)
                    : c <= 3340)
                  : (c <= 3344 || (c < 3398
                    ? (c >= 3346 && c <= 3396)
                    : c <= 3400)))))))
            : (c <= 3406 || (c < 3535
              ? (c < 3461
                ? (c < 3430
                  ? (c < 3423
                    ? (c >= 3412 && c <= 3415)
                    : c <= 3427)
                  : (c <= 3439 || (c < 3457
                    ? (c >= 3450 && c <= 3455)
                    : c <= 3459)))
                : (c <= 3478 || (c < 3517
                  ? (c < 3507
                    ? (c >= 3482 && c <= 3505)
                    : c <= 3515)
                  : (c <= 3517 || (c < 3530
                    ? (c >= 3520 && c <= 3526)
                    : c <= 3530)))))
              : (c <= 3540 || (c < 3648
                ? (c < 3558
                  ? (c < 3544
                    ? c == 3542
                    : c <= 3551)
                  : (c <= 3567 || (c < 3585
                    ? (c >= 3570 && c <= 3571)
                    : c <= 3642)))
                : (c <= 3662 || (c < 3716
                  ? (c < 3713
                    ? (c >= 3664 && c <= 3673)
                    : c <= 3714)
                  : (c <= 3716 || (c < 3724
                    ? (c >= 3718 && c <= 3722)
                    : c <= 3747)))))))))))))
      : (c <= 3749 || (c < 7968
        ? (c < 5761
          ? (c < 4304
            ? (c < 3897
              ? (c < 3804
                ? (c < 3782
                  ? (c < 3776
                    ? (c >= 3751 && c <= 3773)
                    : c <= 3780)
                  : (c <= 3782 || (c < 3792
                    ? (c >= 3784 && c <= 3789)
                    : c <= 3801)))
                : (c <= 3807 || (c < 3872
                  ? (c < 3864
                    ? c == 3840
                    : c <= 3865)
                  : (c <= 3881 || (c < 3895
                    ? c == 3893
                    : c <= 3895)))))
              : (c <= 3897 || (c < 4038
                ? (c < 3953
                  ? (c < 3913
                    ? (c >= 3902 && c <= 3911)
                    : c <= 3948)
                  : (c <= 3972 || (c < 3993
                    ? (c >= 3974 && c <= 3991)
                    : c <= 4028)))
                : (c <= 4038 || (c < 4256
                  ? (c < 4176
                    ? (c >= 4096 && c <= 4169)
                    : c <= 4253)
                  : (c <= 4293 || (c < 4301
                    ? c == 4295
                    : c <= 4301)))))))
            : (c <= 4346 || (c < 4802
              ? (c < 4704
                ? (c < 4688
                  ? (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)
                  : (c <= 4694 || (c < 4698
                    ? c == 4696
                    : c <= 4701)))
                : (c <= 4744 || (c < 4786
                  ? (c < 4752
                    ? (c >= 4746 && c <= 4749)
                    : c <= 4784)
                  : (c <= 4789 || (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)))))
              : (c <= 4805 || (c < 4969
                ? (c < 4882
                  ? (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)
                  : (c <= 4885 || (c < 4957
                    ? (c >= 4888 && c <= 4954)
                    : c <= 4959)))
                : (c <= 4977 || (c < 5112
                  ? (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)
                  : (c <= 5117 || (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)))))))))
          : (c <= 5786 || (c < 6576
            ? (c < 6112
              ? (c < 5984
                ? (c < 5888
                  ? (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)
                  : (c <= 5909 || (c < 5952
                    ? (c >= 5919 && c <= 5940)
                    : c <= 5971)))
                : (c <= 5996 || (c < 6016
                  ? (c < 6002
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6003)
                  : (c <= 6099 || (c < 6108
                    ? c == 6103
                    : c <= 6109)))))
              : (c <= 6121 || (c < 6400
                ? (c < 6176
                  ? (c < 6159
                    ? (c >= 6155 && c <= 6157)
                    : c <= 6169)
                  : (c <= 6264 || (c < 6320
                    ? (c >= 6272 && c <= 6314)
                    : c <= 6389)))
                : (c <= 6430 || (c < 6470
                  ? (c < 6448
                    ? (c >= 6432 && c <= 6443)
                    : c <= 6459)
                  : (c <= 6509 || (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)))))))
            : (c <= 6601 || (c < 7019
              ? (c < 6800
                ? (c < 6688
                  ? (c < 6656
                    ? (c >= 6608 && c <= 6618)
                    : c <= 6683)
                  : (c <= 6750 || (c < 6783
                    ? (c >= 6752 && c <= 6780)
                    : c <= 6793)))
                : (c <= 6809 || (c < 6847
                  ? (c < 6832
                    ? c == 6823
                    : c <= 6845)
                  : (c <= 6862 || (c < 6992
                    ? (c >= 6912 && c <= 6988)
                    : c <= 7001)))))
              : (c <= 7027 || (c < 7312
                ? (c < 7232
                  ? (c < 7168
                    ? (c >= 7040 && c <= 7155)
                    : c <= 7223)
                  : (c <= 7241 || (c < 7296
                    ? (c >= 7245 && c <= 7293)
                    : c <= 7304)))
                : (c <= 7354 || (c < 7380
                  ? (c < 7376
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7378)
                  : (c <= 7418 || (c < 7960
                    ? (c >= 7424 && c <= 7957)
                    : c <= 7965)))))))))))
        : (c <= 8005 || (c < 11696
          ? (c < 8421
            ? (c < 8144
              ? (c < 8031
                ? (c < 8025
                  ? (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)
                  : (c <= 8025 || (c < 8029
                    ? c == 8027
                    : c <= 8029)))
                : (c <= 8061 || (c < 8126
                  ? (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)
                  : (c <= 8126 || (c < 8134
                    ? (c >= 8130 && c <= 8132)
                    : c <= 8140)))))
              : (c <= 8147 || (c < 8276
                ? (c < 8178
                  ? (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)
                  : (c <= 8180 || (c < 8255
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8256)))
                : (c <= 8276 || (c < 8336
                  ? (c < 8319
                    ? c == 8305
                    : c <= 8319)
                  : (c <= 8348 || (c < 8417
                    ? (c >= 8400 && c <= 8412)
                    : c <= 8417)))))))
            : (c <= 8432 || (c < 8526
              ? (c < 8484
                ? (c < 8458
                  ? (c < 8455
                    ? c == 8450
                    : c <= 8455)
                  : (c <= 8467 || (c < 8472
                    ? c == 8469
                    : c <= 8477)))
                : (c <= 8484 || (c < 8490
                  ? (c < 8488
                    ? c == 8486
                    : c <= 8488)
                  : (c <= 8505 || (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)))))
              : (c <= 8526 || (c < 11565
                ? (c < 11499
                  ? (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)
                  : (c <= 11507 || (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)))
                : (c <= 11565 || (c < 11647
                  ? (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)
                  : (c <= 11670 || (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)))))))))
          : (c <= 11702 || (c < 42512
            ? (c < 12441
              ? (c < 11744
                ? (c < 11720
                  ? (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)
                  : (c <= 11726 || (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)))
                : (c <= 11775 || (c < 12337
                  ? (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12335)
                  : (c <= 12341 || (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)))))
              : (c <= 12442 || (c < 12704
                ? (c < 12540
                  ? (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)
                  : (c <= 12543 || (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)))
                : (c <= 12735 || (c < 19968
                  ? (c < 13312
                    ? (c >= 12784 && c <= 12799)
                    : c <= 19903)
                  : (c <= 42124 || (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)))))))
            : (c <= 42539 || (c < 43072
              ? (c < 42891
                ? (c < 42623
                  ? (c < 42612
                    ? (c >= 42560 && c <= 42607)
                    : c <= 42621)
                  : (c <= 42737 || (c < 42786
                    ? (c >= 42775 && c <= 42783)
                    : c <= 42888)))
                : (c <= 42954 || (c < 42965
                  ? (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)
                  : (c <= 42969 || (c < 43052
                    ? (c >= 42994 && c <= 43047)
                    : c <= 43052)))))
              : (c <= 43123 || (c < 43312
                ? (c < 43232
                  ? (c < 43216
                    ? (c >= 43136 && c <= 43205)
                    : c <= 43225)
                  : (c <= 43255 || (c < 43261
                    ? c == 43259
                    : c <= 43309)))
                : (c <= 43347 || (c < 43471
                  ? (c < 43392
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43456)
                  : (c <= 43481 || (c < 43520
                    ? (c >= 43488 && c <= 43518)
                    : c <= 43574)))))))))))))))
    : (c <= 43597 || (c < 71424
      ? (c < 67592
        ? (c < 65313
          ? (c < 64285
            ? (c < 43824
              ? (c < 43762
                ? (c < 43642
                  ? (c < 43616
                    ? (c >= 43600 && c <= 43609)
                    : c <= 43638)
                  : (c <= 43714 || (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43759)))
                : (c <= 43766 || (c < 43793
                  ? (c < 43785
                    ? (c >= 43777 && c <= 43782)
                    : c <= 43790)
                  : (c <= 43798 || (c < 43816
                    ? (c >= 43808 && c <= 43814)
                    : c <= 43822)))))
              : (c <= 43866 || (c < 55216
                ? (c < 44012
                  ? (c < 43888
                    ? (c >= 43868 && c <= 43881)
                    : c <= 44010)
                  : (c <= 44013 || (c < 44032
                    ? (c >= 44016 && c <= 44025)
                    : c <= 55203)))
                : (c <= 55238 || (c < 64112
                  ? (c < 63744
                    ? (c >= 55243 && c <= 55291)
                    : c <= 64109)
                  : (c <= 64217 || (c < 64275
                    ? (c >= 64256 && c <= 64262)
                    : c <= 64279)))))))
            : (c <= 64296 || (c < 65024
              ? (c < 64326
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c < 64323
                    ? (c >= 64320 && c <= 64321)
                    : c <= 64324)))
                : (c <= 64433 || (c < 64848
                  ? (c < 64612
                    ? (c >= 64467 && c <= 64605)
                    : c <= 64829)
                  : (c <= 64911 || (c < 65008
                    ? (c >= 64914 && c <= 64967)
                    : c <= 65017)))))
              : (c <= 65039 || (c < 65143
                ? (c < 65101
                  ? (c < 65075
                    ? (c >= 65056 && c <= 65071)
                    : c <= 65076)
                  : (c <= 65103 || (c < 65139
                    ? c == 65137
                    : c <= 65139)))
                : (c <= 65143 || (c < 65149
                  ? (c < 65147
                    ? c == 65145
                    : c <= 65147)
                  : (c <= 65149 || (c < 65296
                    ? (c >= 65151 && c <= 65276)
                    : c <= 65305)))))))))
          : (c <= 65338 || (c < 66464
            ? (c < 65599
              ? (c < 65490
                ? (c < 65382
                  ? (c < 65345
                    ? c == 65343
                    : c <= 65370)
                  : (c <= 65470 || (c < 65482
                    ? (c >= 65474 && c <= 65479)
                    : c <= 65487)))
                : (c <= 65495 || (c < 65549
                  ? (c < 65536
                    ? (c >= 65498 && c <= 65500)
                    : c <= 65547)
                  : (c <= 65574 || (c < 65596
                    ? (c >= 65576 && c <= 65594)
                    : c <= 65597)))))
              : (c <= 65613 || (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c < 66176
                    ? c == 66045
                    : c <= 66204)))
                : (c <= 66256 || (c < 66349
                  ? (c < 66304
                    ? c == 66272
                    : c <= 66335)
                  : (c <= 66378 || (c < 66432
                    ? (c >= 66384 && c <= 66426)
                    : c <= 66461)))))))
            : (c <= 66499 || (c < 66964
              ? (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c < 66736
                    ? (c >= 66720 && c <= 66729)
                    : c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c < 66956
                    ? (c >= 66940 && c <= 66954)
                    : c <= 66962)))))
              : (c <= 66965 || (c < 67392
                ? (c < 66995
                  ? (c < 66979
                    ? (c >= 66967 && c <= 66977)
                    : c <= 66993)
                  : (c <= 67001 || (c < 67072
                    ? (c >= 67003 && c <= 67004)
                    : c <= 67382)))
                : (c <= 67413 || (c < 67463
                  ? (c < 67456
                    ? (c >= 67424 && c <= 67431)
                    : c <= 67461)
                  : (c <= 67504 || (c < 67584
                    ? (c >= 67506 && c <= 67514)
                    : c <= 67589)))))))))))
        : (c <= 67592 || (c < 69888
          ? (c < 68352
            ? (c < 68030
              ? (c < 67712
                ? (c < 67644
                  ? (c < 67639
                    ? (c >= 67594 && c <= 67637)
                    : c <= 67640)
                  : (c <= 67644 || (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)))
                : (c <= 67742 || (c < 67840
                  ? (c < 67828
                    ? (c >= 67808 && c <= 67826)
                    : c <= 67829)
                  : (c <= 67861 || (c < 67968
                    ? (c >= 67872 && c <= 67897)
                    : c <= 68023)))))
              : (c <= 68031 || (c < 68152
                ? (c < 68108
                  ? (c < 68101
                    ? (c >= 68096 && c <= 68099)
                    : c <= 68102)
                  : (c <= 68115 || (c < 68121
                    ? (c >= 68117 && c <= 68119)
                    : c <= 68149)))
                : (c <= 68154 || (c < 68224
                  ? (c < 68192
                    ? c == 68159
                    : c <= 68220)
                  : (c <= 68252 || (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68326)))))))
            : (c <= 68405 || (c < 69376
              ? (c < 68800
                ? (c < 68480
                  ? (c < 68448
                    ? (c >= 68416 && c <= 68437)
                    : c <= 68466)
                  : (c <= 68497 || (c < 68736
                    ? (c >= 68608 && c <= 68680)
                    : c <= 68786)))
                : (c <= 68850 || (c < 69248
                  ? (c < 68912
                    ? (c >= 68864 && c <= 68903)
                    : c <= 68921)
                  : (c <= 69289 || (c < 69296
                    ? (c >= 69291 && c <= 69292)
                    : c <= 69297)))))
              : (c <= 69404 || (c < 69632
                ? (c < 69488
                  ? (c < 69424
                    ? c == 69415
                    : c <= 69456)
                  : (c <= 69509 || (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)))
                : (c <= 69702 || (c < 69826
                  ? (c < 69759
                    ? (c >= 69734 && c <= 69749)
                    : c <= 69818)
                  : (c <= 69826 || (c < 69872
                    ? (c >= 69840 && c <= 69864)
                    : c <= 69881)))))))))
          : (c <= 69940 || (c < 70450
            ? (c < 70272
              ? (c < 70089
                ? (c < 69968
                  ? (c < 69956
                    ? (c >= 69942 && c <= 69951)
                    : c <= 69959)
                  : (c <= 70003 || (c < 70016
                    ? c == 70006
                    : c <= 70084)))
                : (c <= 70092 || (c < 70144
                  ? (c < 70108
                    ? (c >= 70094 && c <= 70106)
                    : c <= 70108)
                  : (c <= 70161 || (c < 70206
                    ? (c >= 70163 && c <= 70199)
                    : c <= 70206)))))
              : (c <= 70278 || (c < 70384
                ? (c < 70287
                  ? (c < 70282
                    ? c == 70280
                    : c <= 70285)
                  : (c <= 70301 || (c < 70320
                    ? (c >= 70303 && c <= 70312)
                    : c <= 70378)))
                : (c <= 70393 || (c < 70415
                  ? (c < 70405
                    ? (c >= 70400 && c <= 70403)
                    : c <= 70412)
                  : (c <= 70416 || (c < 70442
                    ? (c >= 70419 && c <= 70440)
                    : c <= 70448)))))))
            : (c <= 70451 || (c < 70750
              ? (c < 70487
                ? (c < 70471
                  ? (c < 70459
                    ? (c >= 70453 && c <= 70457)
                    : c <= 70468)
                  : (c <= 70472 || (c < 70480
                    ? (c >= 70475 && c <= 70477)
                    : c <= 70480)))
                : (c <= 70487 || (c < 70512
                  ? (c < 70502
                    ? (c >= 70493 && c <= 70499)
                    : c <= 70508)
                  : (c <= 70516 || (c < 70736
                    ? (c >= 70656 && c <= 70730)
                    : c <= 70745)))))
              : (c <= 70753 || (c < 71128
                ? (c < 70864
                  ? (c < 70855
                    ? (c >= 70784 && c <= 70853)
                    : c <= 70855)
                  : (c <= 70873 || (c < 71096
                    ? (c >= 71040 && c <= 71093)
                    : c <= 71104)))
                : (c <= 71133 || (c < 71248
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71232)
                    : c <= 71236)
                  : (c <= 71257 || (c < 71360
                    ? (c >= 71296 && c <= 71352)
                    : c <= 71369)))))))))))))
      : (c <= 71450 || (c < 119970
        ? (c < 77712
          ? (c < 72714
            ? (c < 71995
              ? (c < 71935
                ? (c < 71488
                  ? (c < 71472
                    ? (c >= 71453 && c <= 71467)
                    : c <= 71481)
                  : (c <= 71494 || (c < 71840
                    ? (c >= 71680 && c <= 71738)
                    : c <= 71913)))
                : (c <= 71942 || (c < 71957
                  ? (c < 71948
                    ? c == 71945
                    : c <= 71955)
                  : (c <= 71958 || (c < 71991
                    ? (c >= 71960 && c <= 71989)
                    : c <= 71992)))))
              : (c <= 72003 || (c < 72192
                ? (c < 72106
                  ? (c < 72096
                    ? (c >= 72016 && c <= 72025)
                    : c <= 72103)
                  : (c <= 72151 || (c < 72163
                    ? (c >= 72154 && c <= 72161)
                    : c <= 72164)))
                : (c <= 72254 || (c < 72349
                  ? (c < 72272
                    ? c == 72263
                    : c <= 72345)
                  : (c <= 72349 || (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)))))))
            : (c <= 72758 || (c < 73040
              ? (c < 72960
                ? (c < 72818
                  ? (c < 72784
                    ? (c >= 72760 && c <= 72768)
                    : c <= 72793)
                  : (c <= 72847 || (c < 72873
                    ? (c >= 72850 && c <= 72871)
                    : c <= 72886)))
                : (c <= 72966 || (c < 73018
                  ? (c < 72971
                    ? (c >= 72968 && c <= 72969)
                    : c <= 73014)
                  : (c <= 73018 || (c < 73023
                    ? (c >= 73020 && c <= 73021)
                    : c <= 73031)))))
              : (c <= 73049 || (c < 73120
                ? (c < 73066
                  ? (c < 73063
                    ? (c >= 73056 && c <= 73061)
                    : c <= 73064)
                  : (c <= 73102 || (c < 73107
                    ? (c >= 73104 && c <= 73105)
                    : c <= 73112)))
                : (c <= 73129 || (c < 73728
                  ? (c < 73648
                    ? (c >= 73440 && c <= 73462)
                    : c <= 73648)
                  : (c <= 74649 || (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)))))))))
          : (c <= 77808 || (c < 101632
            ? (c < 93008
              ? (c < 92784
                ? (c < 92160
                  ? (c < 82944
                    ? (c >= 77824 && c <= 78894)
                    : c <= 83526)
                  : (c <= 92728 || (c < 92768
                    ? (c >= 92736 && c <= 92766)
                    : c <= 92777)))
                : (c <= 92862 || (c < 92912
                  ? (c < 92880
                    ? (c >= 92864 && c <= 92873)
                    : c <= 92909)
                  : (c <= 92916 || (c < 92992
                    ? (c >= 92928 && c <= 92982)
                    : c <= 92995)))))
              : (c <= 93017 || (c < 94095
                ? (c < 93760
                  ? (c < 93053
                    ? (c >= 93027 && c <= 93047)
                    : c <= 93071)
                  : (c <= 93823 || (c < 94031
                    ? (c >= 93952 && c <= 94026)
                    : c <= 94087)))
                : (c <= 94111 || (c < 94192
                  ? (c < 94179
                    ? (c >= 94176 && c <= 94177)
                    : c <= 94180)
                  : (c <= 94193 || (c < 100352
                    ? (c >= 94208 && c <= 100343)
                    : c <= 101589)))))))
            : (c <= 101640 || (c < 113821
              ? (c < 110948
                ? (c < 110589
                  ? (c < 110581
                    ? (c >= 110576 && c <= 110579)
                    : c <= 110587)
                  : (c <= 110590 || (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)))
                : (c <= 110951 || (c < 113776
                  ? (c < 113664
                    ? (c >= 110960 && c <= 111355)
                    : c <= 113770)
                  : (c <= 113788 || (c < 113808
                    ? (c >= 113792 && c <= 113800)
                    : c <= 113817)))))
              : (c <= 113822 || (c < 119173
                ? (c < 119141
                  ? (c < 118576
                    ? (c >= 118528 && c <= 118573)
                    : c <= 118598)
                  : (c <= 119145 || (c < 119163
                    ? (c >= 119149 && c <= 119154)
                    : c <= 119170)))
                : (c <= 119179 || (c < 119808
                  ? (c < 119362
                    ? (c >= 119210 && c <= 119213)
                    : c <= 119364)
                  : (c <= 119892 || (c < 119966
                    ? (c >= 119894 && c <= 119964)
                    : c <= 119967)))))))))))
        : (c <= 119970 || (c < 124909
          ? (c < 120714
            ? (c < 120128
              ? (c < 120005
                ? (c < 119982
                  ? (c < 119977
                    ? (c >= 119973 && c <= 119974)
                    : c <= 119980)
                  : (c <= 119993 || (c < 119997
                    ? c == 119995
                    : c <= 120003)))
                : (c <= 120069 || (c < 120086
                  ? (c < 120077
                    ? (c >= 120071 && c <= 120074)
                    : c <= 120084)
                  : (c <= 120092 || (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)))))
              : (c <= 120132 || (c < 120540
                ? (c < 120146
                  ? (c < 120138
                    ? c == 120134
                    : c <= 120144)
                  : (c <= 120485 || (c < 120514
                    ? (c >= 120488 && c <= 120512)
                    : c <= 120538)))
                : (c <= 120570 || (c < 120630
                  ? (c < 120598
                    ? (c >= 120572 && c <= 120596)
                    : c <= 120628)
                  : (c <= 120654 || (c < 120688
                    ? (c >= 120656 && c <= 120686)
                    : c <= 120712)))))))
            : (c <= 120744 || (c < 122888
              ? (c < 121461
                ? (c < 120782
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 120831 || (c < 121403
                    ? (c >= 121344 && c <= 121398)
                    : c <= 121452)))
                : (c <= 121461 || (c < 121505
                  ? (c < 121499
                    ? c == 121476
                    : c <= 121503)
                  : (c <= 121519 || (c < 122880
                    ? (c >= 122624 && c <= 122654)
                    : c <= 122886)))))
              : (c <= 122904 || (c < 123200
                ? (c < 122918
                  ? (c < 122915
                    ? (c >= 122907 && c <= 122913)
                    : c <= 122916)
                  : (c <= 122922 || (c < 123184
                    ? (c >= 123136 && c <= 123180)
                    : c <= 123197)))
                : (c <= 123209 || (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123566)
                  : (c <= 123641 || (c < 124904
                    ? (c >= 124896 && c <= 124902)
                    : c <= 124907)))))))))
          : (c <= 124910 || (c < 126555
            ? (c < 126516
              ? (c < 126464
                ? (c < 125136
                  ? (c < 124928
                    ? (c >= 124912 && c <= 124926)
                    : c <= 125124)
                  : (c <= 125142 || (c < 125264
                    ? (c >= 125184 && c <= 125259)
                    : c <= 125273)))
                : (c <= 126467 || (c < 126500
                  ? (c < 126497
                    ? (c >= 126469 && c <= 126495)
                    : c <= 126498)
                  : (c <= 126500 || (c < 126505
                    ? c == 126503
                    : c <= 126514)))))
              : (c <= 126519 || (c < 126539
                ? (c < 126530
                  ? (c < 126523
                    ? c == 126521
                    : c <= 126523)
                  : (c <= 126530 || (c < 126537
                    ? c == 126535
                    : c <= 126537)))
                : (c <= 126539 || (c < 126548
                  ? (c < 126545
                    ? (c >= 126541 && c <= 126543)
                    : c <= 126546)
                  : (c <= 126548 || (c < 126553
                    ? c == 126551
                    : c <= 126553)))))))
            : (c <= 126555 || (c < 126625
              ? (c < 126572
                ? (c < 126561
                  ? (c < 126559
                    ? c == 126557
                    : c <= 126559)
                  : (c <= 126562 || (c < 126567
                    ? c == 126564
                    : c <= 126570)))
                : (c <= 126578 || (c < 126590
                  ? (c < 126585
                    ? (c >= 126580 && c <= 126583)
                    : c <= 126588)
                  : (c <= 126590 || (c < 126603
                    ? (c >= 126592 && c <= 126601)
                    : c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 130032
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 130041 || (c < 173824
                    ? (c >= 131072 && c <= 173791)
                    : c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c < 917760
                    ? (c >= 196608 && c <= 201546)
                    : c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_15(int32_t c) {
  return (c < 43600
    ? (c < 3751
      ? (c < 2730
        ? (c < 1869
          ? (c < 908
            ? (c < 192
              ? (c < '_'
                ? (c < '9'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '7')
                  : (c <= '9' || (c < 'S'
                    ? (c >= 'A' && c <= 'Q')
                    : c <= 'Z')))
                : (c <= '_' || (c < 181
                  ? (c < 170
                    ? (c >= 'a' && c <= 'z')
                    : c <= 170)
                  : (c <= 181 || (c < 186
                    ? c == 183
                    : c <= 186)))))
              : (c <= 214 || (c < 750
                ? (c < 710
                  ? (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)
                  : (c <= 721 || (c < 748
                    ? (c >= 736 && c <= 740)
                    : c <= 748)))
                : (c <= 750 || (c < 891
                  ? (c < 886
                    ? (c >= 768 && c <= 884)
                    : c <= 887)
                  : (c <= 893 || (c < 902
                    ? c == 895
                    : c <= 906)))))))
            : (c <= 908 || (c < 1476
              ? (c < 1329
                ? (c < 1015
                  ? (c < 931
                    ? (c >= 910 && c <= 929)
                    : c <= 1013)
                  : (c <= 1153 || (c < 1162
                    ? (c >= 1155 && c <= 1159)
                    : c <= 1327)))
                : (c <= 1366 || (c < 1425
                  ? (c < 1376
                    ? c == 1369
                    : c <= 1416)
                  : (c <= 1469 || (c < 1473
                    ? c == 1471
                    : c <= 1474)))))
              : (c <= 1477 || (c < 1646
                ? (c < 1519
                  ? (c < 1488
                    ? c == 1479
                    : c <= 1514)
                  : (c <= 1522 || (c < 1568
                    ? (c >= 1552 && c <= 1562)
                    : c <= 1641)))
                : (c <= 1747 || (c < 1770
                  ? (c < 1759
                    ? (c >= 1749 && c <= 1756)
                    : c <= 1768)
                  : (c <= 1788 || (c < 1808
                    ? c == 1791
                    : c <= 1866)))))))))
          : (c <= 1969 || (c < 2527
            ? (c < 2417
              ? (c < 2144
                ? (c < 2045
                  ? (c < 2042
                    ? (c >= 1984 && c <= 2037)
                    : c <= 2042)
                  : (c <= 2045 || (c < 2112
                    ? (c >= 2048 && c <= 2093)
                    : c <= 2139)))
                : (c <= 2154 || (c < 2200
                  ? (c < 2185
                    ? (c >= 2160 && c <= 2183)
                    : c <= 2190)
                  : (c <= 2273 || (c < 2406
                    ? (c >= 2275 && c <= 2403)
                    : c <= 2415)))))
              : (c <= 2435 || (c < 2486
                ? (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c < 2482
                    ? (c >= 2474 && c <= 2480)
                    : c <= 2482)))
                : (c <= 2489 || (c < 2507
                  ? (c < 2503
                    ? (c >= 2492 && c <= 2500)
                    : c <= 2504)
                  : (c <= 2510 || (c < 2524
                    ? c == 2519
                    : c <= 2525)))))))
            : (c <= 2531 || (c < 2620
              ? (c < 2575
                ? (c < 2558
                  ? (c < 2556
                    ? (c >= 2534 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2558 || (c < 2565
                    ? (c >= 2561 && c <= 2563)
                    : c <= 2570)))
                : (c <= 2576 || (c < 2610
                  ? (c < 2602
                    ? (c >= 2579 && c <= 2600)
                    : c <= 2608)
                  : (c <= 2611 || (c < 2616
                    ? (c >= 2613 && c <= 2614)
                    : c <= 2617)))))
              : (c <= 2620 || (c < 2654
                ? (c < 2635
                  ? (c < 2631
                    ? (c >= 2622 && c <= 2626)
                    : c <= 2632)
                  : (c <= 2637 || (c < 2649
                    ? c == 2641
                    : c <= 2652)))
                : (c <= 2654 || (c < 2693
                  ? (c < 2689
                    ? (c >= 2662 && c <= 2677)
                    : c <= 2691)
                  : (c <= 2701 || (c < 2707
                    ? (c >= 2703 && c <= 2705)
                    : c <= 2728)))))))))))
        : (c <= 2736 || (c < 3157
          ? (c < 2929
            ? (c < 2831
              ? (c < 2768
                ? (c < 2748
                  ? (c < 2741
                    ? (c >= 2738 && c <= 2739)
                    : c <= 2745)
                  : (c <= 2757 || (c < 2763
                    ? (c >= 2759 && c <= 2761)
                    : c <= 2765)))
                : (c <= 2768 || (c < 2809
                  ? (c < 2790
                    ? (c >= 2784 && c <= 2787)
                    : c <= 2799)
                  : (c <= 2815 || (c < 2821
                    ? (c >= 2817 && c <= 2819)
                    : c <= 2828)))))
              : (c <= 2832 || (c < 2887
                ? (c < 2866
                  ? (c < 2858
                    ? (c >= 2835 && c <= 2856)
                    : c <= 2864)
                  : (c <= 2867 || (c < 2876
                    ? (c >= 2869 && c <= 2873)
                    : c <= 2884)))
                : (c <= 2888 || (c < 2908
                  ? (c < 2901
                    ? (c >= 2891 && c <= 2893)
                    : c <= 2903)
                  : (c <= 2909 || (c < 2918
                    ? (c >= 2911 && c <= 2915)
                    : c <= 2927)))))))
            : (c <= 2929 || (c < 3014
              ? (c < 2972
                ? (c < 2958
                  ? (c < 2949
                    ? (c >= 2946 && c <= 2947)
                    : c <= 2954)
                  : (c <= 2960 || (c < 2969
                    ? (c >= 2962 && c <= 2965)
                    : c <= 2970)))
                : (c <= 2972 || (c < 2984
                  ? (c < 2979
                    ? (c >= 2974 && c <= 2975)
                    : c <= 2980)
                  : (c <= 2986 || (c < 3006
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3010)))))
              : (c <= 3016 || (c < 3086
                ? (c < 3031
                  ? (c < 3024
                    ? (c >= 3018 && c <= 3021)
                    : c <= 3024)
                  : (c <= 3031 || (c < 3072
                    ? (c >= 3046 && c <= 3055)
                    : c <= 3084)))
                : (c <= 3088 || (c < 3132
                  ? (c < 3114
                    ? (c >= 3090 && c <= 3112)
                    : c <= 3129)
                  : (c <= 3140 || (c < 3146
                    ? (c >= 3142 && c <= 3144)
                    : c <= 3149)))))))))
          : (c <= 3158 || (c < 3412
            ? (c < 3270
              ? (c < 3205
                ? (c < 3168
                  ? (c < 3165
                    ? (c >= 3160 && c <= 3162)
                    : c <= 3165)
                  : (c <= 3171 || (c < 3200
                    ? (c >= 3174 && c <= 3183)
                    : c <= 3203)))
                : (c <= 3212 || (c < 3242
                  ? (c < 3218
                    ? (c >= 3214 && c <= 3216)
                    : c <= 3240)
                  : (c <= 3251 || (c < 3260
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3268)))))
              : (c <= 3272 || (c < 3313
                ? (c < 3293
                  ? (c < 3285
                    ? (c >= 3274 && c <= 3277)
                    : c <= 3286)
                  : (c <= 3294 || (c < 3302
                    ? (c >= 3296 && c <= 3299)
                    : c <= 3311)))
                : (c <= 3314 || (c < 3346
                  ? (c < 3342
                    ? (c >= 3328 && c <= 3340)
                    : c <= 3344)
                  : (c <= 3396 || (c < 3402
                    ? (c >= 3398 && c <= 3400)
                    : c <= 3406)))))))
            : (c <= 3415 || (c < 3542
              ? (c < 3482
                ? (c < 3450
                  ? (c < 3430
                    ? (c >= 3423 && c <= 3427)
                    : c <= 3439)
                  : (c <= 3455 || (c < 3461
                    ? (c >= 3457 && c <= 3459)
                    : c <= 3478)))
                : (c <= 3505 || (c < 3520
                  ? (c < 3517
                    ? (c >= 3507 && c <= 3515)
                    : c <= 3517)
                  : (c <= 3526 || (c < 3535
                    ? c == 3530
                    : c <= 3540)))))
              : (c <= 3542 || (c < 3664
                ? (c < 3570
                  ? (c < 3558
                    ? (c >= 3544 && c <= 3551)
                    : c <= 3567)
                  : (c <= 3571 || (c < 3648
                    ? (c >= 3585 && c <= 3642)
                    : c <= 3662)))
                : (c <= 3673 || (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c < 3749
                    ? (c >= 3724 && c <= 3747)
                    : c <= 3749)))))))))))))
      : (c <= 3773 || (c < 8008
        ? (c < 5792
          ? (c < 4348
            ? (c < 3902
              ? (c < 3840
                ? (c < 3784
                  ? (c < 3782
                    ? (c >= 3776 && c <= 3780)
                    : c <= 3782)
                  : (c <= 3789 || (c < 3804
                    ? (c >= 3792 && c <= 3801)
                    : c <= 3807)))
                : (c <= 3840 || (c < 3893
                  ? (c < 3872
                    ? (c >= 3864 && c <= 3865)
                    : c <= 3881)
                  : (c <= 3893 || (c < 3897
                    ? c == 3895
                    : c <= 3897)))))
              : (c <= 3911 || (c < 4096
                ? (c < 3974
                  ? (c < 3953
                    ? (c >= 3913 && c <= 3948)
                    : c <= 3972)
                  : (c <= 3991 || (c < 4038
                    ? (c >= 3993 && c <= 4028)
                    : c <= 4038)))
                : (c <= 4169 || (c < 4295
                  ? (c < 4256
                    ? (c >= 4176 && c <= 4253)
                    : c <= 4293)
                  : (c <= 4295 || (c < 4304
                    ? c == 4301
                    : c <= 4346)))))))
            : (c <= 4680 || (c < 4808
              ? (c < 4746
                ? (c < 4696
                  ? (c < 4688
                    ? (c >= 4682 && c <= 4685)
                    : c <= 4694)
                  : (c <= 4696 || (c < 4704
                    ? (c >= 4698 && c <= 4701)
                    : c <= 4744)))
                : (c <= 4749 || (c < 4792
                  ? (c < 4786
                    ? (c >= 4752 && c <= 4784)
                    : c <= 4789)
                  : (c <= 4798 || (c < 4802
                    ? c == 4800
                    : c <= 4805)))))
              : (c <= 4822 || (c < 4992
                ? (c < 4888
                  ? (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)
                  : (c <= 4954 || (c < 4969
                    ? (c >= 4957 && c <= 4959)
                    : c <= 4977)))
                : (c <= 5007 || (c < 5121
                  ? (c < 5112
                    ? (c >= 5024 && c <= 5109)
                    : c <= 5117)
                  : (c <= 5740 || (c < 5761
                    ? (c >= 5743 && c <= 5759)
                    : c <= 5786)))))))))
          : (c <= 5866 || (c < 6608
            ? (c < 6155
              ? (c < 5998
                ? (c < 5919
                  ? (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5909)
                  : (c <= 5940 || (c < 5984
                    ? (c >= 5952 && c <= 5971)
                    : c <= 5996)))
                : (c <= 6000 || (c < 6103
                  ? (c < 6016
                    ? (c >= 6002 && c <= 6003)
                    : c <= 6099)
                  : (c <= 6103 || (c < 6112
                    ? (c >= 6108 && c <= 6109)
                    : c <= 6121)))))
              : (c <= 6157 || (c < 6432
                ? (c < 6272
                  ? (c < 6176
                    ? (c >= 6159 && c <= 6169)
                    : c <= 6264)
                  : (c <= 6314 || (c < 6400
                    ? (c >= 6320 && c <= 6389)
                    : c <= 6430)))
                : (c <= 6443 || (c < 6512
                  ? (c < 6470
                    ? (c >= 6448 && c <= 6459)
                    : c <= 6509)
                  : (c <= 6516 || (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)))))))
            : (c <= 6618 || (c < 7040
              ? (c < 6823
                ? (c < 6752
                  ? (c < 6688
                    ? (c >= 6656 && c <= 6683)
                    : c <= 6750)
                  : (c <= 6780 || (c < 6800
                    ? (c >= 6783 && c <= 6793)
                    : c <= 6809)))
                : (c <= 6823 || (c < 6912
                  ? (c < 6847
                    ? (c >= 6832 && c <= 6845)
                    : c <= 6862)
                  : (c <= 6988 || (c < 7019
                    ? (c >= 6992 && c <= 7001)
                    : c <= 7027)))))
              : (c <= 7155 || (c < 7357
                ? (c < 7245
                  ? (c < 7232
                    ? (c >= 7168 && c <= 7223)
                    : c <= 7241)
                  : (c <= 7293 || (c < 7312
                    ? (c >= 7296 && c <= 7304)
                    : c <= 7354)))
                : (c <= 7359 || (c < 7424
                  ? (c < 7380
                    ? (c >= 7376 && c <= 7378)
                    : c <= 7418)
                  : (c <= 7957 || (c < 7968
                    ? (c >= 7960 && c <= 7965)
                    : c <= 8005)))))))))))
        : (c <= 8013 || (c < 11704
          ? (c < 8450
            ? (c < 8150
              ? (c < 8064
                ? (c < 8027
                  ? (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)
                  : (c <= 8027 || (c < 8031
                    ? c == 8029
                    : c <= 8061)))
                : (c <= 8116 || (c < 8130
                  ? (c < 8126
                    ? (c >= 8118 && c <= 8124)
                    : c <= 8126)
                  : (c <= 8132 || (c < 8144
                    ? (c >= 8134 && c <= 8140)
                    : c <= 8147)))))
              : (c <= 8155 || (c < 8305
                ? (c < 8182
                  ? (c < 8178
                    ? (c >= 8160 && c <= 8172)
                    : c <= 8180)
                  : (c <= 8188 || (c < 8276
                    ? (c >= 8255 && c <= 8256)
                    : c <= 8276)))
                : (c <= 8305 || (c < 8400
                  ? (c < 8336
                    ? c == 8319
                    : c <= 8348)
                  : (c <= 8412 || (c < 8421
                    ? c == 8417
                    : c <= 8432)))))))
            : (c <= 8450 || (c < 8544
              ? (c < 8486
                ? (c < 8469
                  ? (c < 8458
                    ? c == 8455
                    : c <= 8467)
                  : (c <= 8469 || (c < 8484
                    ? (c >= 8472 && c <= 8477)
                    : c <= 8484)))
                : (c <= 8486 || (c < 8508
                  ? (c < 8490
                    ? c == 8488
                    : c <= 8505)
                  : (c <= 8511 || (c < 8526
                    ? (c >= 8517 && c <= 8521)
                    : c <= 8526)))))
              : (c <= 8584 || (c < 11568
                ? (c < 11520
                  ? (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11507)
                  : (c <= 11557 || (c < 11565
                    ? c == 11559
                    : c <= 11565)))
                : (c <= 11623 || (c < 11680
                  ? (c < 11647
                    ? c == 11631
                    : c <= 11670)
                  : (c <= 11686 || (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)))))))))
          : (c <= 11710 || (c < 42560
            ? (c < 12445
              ? (c < 12293
                ? (c < 11728
                  ? (c < 11720
                    ? (c >= 11712 && c <= 11718)
                    : c <= 11726)
                  : (c <= 11734 || (c < 11744
                    ? (c >= 11736 && c <= 11742)
                    : c <= 11775)))
                : (c <= 12295 || (c < 12344
                  ? (c < 12337
                    ? (c >= 12321 && c <= 12335)
                    : c <= 12341)
                  : (c <= 12348 || (c < 12441
                    ? (c >= 12353 && c <= 12438)
                    : c <= 12442)))))
              : (c <= 12447 || (c < 12784
                ? (c < 12549
                  ? (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)
                  : (c <= 12591 || (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)))
                : (c <= 12799 || (c < 42192
                  ? (c < 19968
                    ? (c >= 13312 && c <= 19903)
                    : c <= 42124)
                  : (c <= 42237 || (c < 42512
                    ? (c >= 42240 && c <= 42508)
                    : c <= 42539)))))))
            : (c <= 42607 || (c < 43136
              ? (c < 42960
                ? (c < 42775
                  ? (c < 42623
                    ? (c >= 42612 && c <= 42621)
                    : c <= 42737)
                  : (c <= 42783 || (c < 42891
                    ? (c >= 42786 && c <= 42888)
                    : c <= 42954)))
                : (c <= 42961 || (c < 42994
                  ? (c < 42965
                    ? c == 42963
                    : c <= 42969)
                  : (c <= 43047 || (c < 43072
                    ? c == 43052
                    : c <= 43123)))))
              : (c <= 43205 || (c < 43360
                ? (c < 43259
                  ? (c < 43232
                    ? (c >= 43216 && c <= 43225)
                    : c <= 43255)
                  : (c <= 43259 || (c < 43312
                    ? (c >= 43261 && c <= 43309)
                    : c <= 43347)))
                : (c <= 43388 || (c < 43488
                  ? (c < 43471
                    ? (c >= 43392 && c <= 43456)
                    : c <= 43481)
                  : (c <= 43518 || (c < 43584
                    ? (c >= 43520 && c <= 43574)
                    : c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_16(int32_t c) {
  return (c < 43600
    ? (c < 3751
      ? (c < 2730
        ? (c < 1869
          ? (c < 908
            ? (c < 192
              ? (c < 'a'
                ? (c < '9'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '7')
                  : (c <= '9' || (c < '_'
                    ? (c >= 'A' && c <= 'Z')
                    : c <= '_')))
                : (c <= 'h' || (c < 181
                  ? (c < 170
                    ? (c >= 'j' && c <= 'z')
                    : c <= 170)
                  : (c <= 181 || (c < 186
                    ? c == 183
                    : c <= 186)))))
              : (c <= 214 || (c < 750
                ? (c < 710
                  ? (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)
                  : (c <= 721 || (c < 748
                    ? (c >= 736 && c <= 740)
                    : c <= 748)))
                : (c <= 750 || (c < 891
                  ? (c < 886
                    ? (c >= 768 && c <= 884)
                    : c <= 887)
                  : (c <= 893 || (c < 902
                    ? c == 895
                    : c <= 906)))))))
            : (c <= 908 || (c < 1476
              ? (c < 1329
                ? (c < 1015
                  ? (c < 931
                    ? (c >= 910 && c <= 929)
                    : c <= 1013)
                  : (c <= 1153 || (c < 1162
                    ? (c >= 1155 && c <= 1159)
                    : c <= 1327)))
                : (c <= 1366 || (c < 1425
                  ? (c < 1376
                    ? c == 1369
                    : c <= 1416)
                  : (c <= 1469 || (c < 1473
                    ? c == 1471
                    : c <= 1474)))))
              : (c <= 1477 || (c < 1646
                ? (c < 1519
                  ? (c < 1488
                    ? c == 1479
                    : c <= 1514)
                  : (c <= 1522 || (c < 1568
                    ? (c >= 1552 && c <= 1562)
                    : c <= 1641)))
                : (c <= 1747 || (c < 1770
                  ? (c < 1759
                    ? (c >= 1749 && c <= 1756)
                    : c <= 1768)
                  : (c <= 1788 || (c < 1808
                    ? c == 1791
                    : c <= 1866)))))))))
          : (c <= 1969 || (c < 2527
            ? (c < 2417
              ? (c < 2144
                ? (c < 2045
                  ? (c < 2042
                    ? (c >= 1984 && c <= 2037)
                    : c <= 2042)
                  : (c <= 2045 || (c < 2112
                    ? (c >= 2048 && c <= 2093)
                    : c <= 2139)))
                : (c <= 2154 || (c < 2200
                  ? (c < 2185
                    ? (c >= 2160 && c <= 2183)
                    : c <= 2190)
                  : (c <= 2273 || (c < 2406
                    ? (c >= 2275 && c <= 2403)
                    : c <= 2415)))))
              : (c <= 2435 || (c < 2486
                ? (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c < 2482
                    ? (c >= 2474 && c <= 2480)
                    : c <= 2482)))
                : (c <= 2489 || (c < 2507
                  ? (c < 2503
                    ? (c >= 2492 && c <= 2500)
                    : c <= 2504)
                  : (c <= 2510 || (c < 2524
                    ? c == 2519
                    : c <= 2525)))))))
            : (c <= 2531 || (c < 2620
              ? (c < 2575
                ? (c < 2558
                  ? (c < 2556
                    ? (c >= 2534 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2558 || (c < 2565
                    ? (c >= 2561 && c <= 2563)
                    : c <= 2570)))
                : (c <= 2576 || (c < 2610
                  ? (c < 2602
                    ? (c >= 2579 && c <= 2600)
                    : c <= 2608)
                  : (c <= 2611 || (c < 2616
                    ? (c >= 2613 && c <= 2614)
                    : c <= 2617)))))
              : (c <= 2620 || (c < 2654
                ? (c < 2635
                  ? (c < 2631
                    ? (c >= 2622 && c <= 2626)
                    : c <= 2632)
                  : (c <= 2637 || (c < 2649
                    ? c == 2641
                    : c <= 2652)))
                : (c <= 2654 || (c < 2693
                  ? (c < 2689
                    ? (c >= 2662 && c <= 2677)
                    : c <= 2691)
                  : (c <= 2701 || (c < 2707
                    ? (c >= 2703 && c <= 2705)
                    : c <= 2728)))))))))))
        : (c <= 2736 || (c < 3157
          ? (c < 2929
            ? (c < 2831
              ? (c < 2768
                ? (c < 2748
                  ? (c < 2741
                    ? (c >= 2738 && c <= 2739)
                    : c <= 2745)
                  : (c <= 2757 || (c < 2763
                    ? (c >= 2759 && c <= 2761)
                    : c <= 2765)))
                : (c <= 2768 || (c < 2809
                  ? (c < 2790
                    ? (c >= 2784 && c <= 2787)
                    : c <= 2799)
                  : (c <= 2815 || (c < 2821
                    ? (c >= 2817 && c <= 2819)
                    : c <= 2828)))))
              : (c <= 2832 || (c < 2887
                ? (c < 2866
                  ? (c < 2858
                    ? (c >= 2835 && c <= 2856)
                    : c <= 2864)
                  : (c <= 2867 || (c < 2876
                    ? (c >= 2869 && c <= 2873)
                    : c <= 2884)))
                : (c <= 2888 || (c < 2908
                  ? (c < 2901
                    ? (c >= 2891 && c <= 2893)
                    : c <= 2903)
                  : (c <= 2909 || (c < 2918
                    ? (c >= 2911 && c <= 2915)
                    : c <= 2927)))))))
            : (c <= 2929 || (c < 3014
              ? (c < 2972
                ? (c < 2958
                  ? (c < 2949
                    ? (c >= 2946 && c <= 2947)
                    : c <= 2954)
                  : (c <= 2960 || (c < 2969
                    ? (c >= 2962 && c <= 2965)
                    : c <= 2970)))
                : (c <= 2972 || (c < 2984
                  ? (c < 2979
                    ? (c >= 2974 && c <= 2975)
                    : c <= 2980)
                  : (c <= 2986 || (c < 3006
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3010)))))
              : (c <= 3016 || (c < 3086
                ? (c < 3031
                  ? (c < 3024
                    ? (c >= 3018 && c <= 3021)
                    : c <= 3024)
                  : (c <= 3031 || (c < 3072
                    ? (c >= 3046 && c <= 3055)
                    : c <= 3084)))
                : (c <= 3088 || (c < 3132
                  ? (c < 3114
                    ? (c >= 3090 && c <= 3112)
                    : c <= 3129)
                  : (c <= 3140 || (c < 3146
                    ? (c >= 3142 && c <= 3144)
                    : c <= 3149)))))))))
          : (c <= 3158 || (c < 3412
            ? (c < 3270
              ? (c < 3205
                ? (c < 3168
                  ? (c < 3165
                    ? (c >= 3160 && c <= 3162)
                    : c <= 3165)
                  : (c <= 3171 || (c < 3200
                    ? (c >= 3174 && c <= 3183)
                    : c <= 3203)))
                : (c <= 3212 || (c < 3242
                  ? (c < 3218
                    ? (c >= 3214 && c <= 3216)
                    : c <= 3240)
                  : (c <= 3251 || (c < 3260
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3268)))))
              : (c <= 3272 || (c < 3313
                ? (c < 3293
                  ? (c < 3285
                    ? (c >= 3274 && c <= 3277)
                    : c <= 3286)
                  : (c <= 3294 || (c < 3302
                    ? (c >= 3296 && c <= 3299)
                    : c <= 3311)))
                : (c <= 3314 || (c < 3346
                  ? (c < 3342
                    ? (c >= 3328 && c <= 3340)
                    : c <= 3344)
                  : (c <= 3396 || (c < 3402
                    ? (c >= 3398 && c <= 3400)
                    : c <= 3406)))))))
            : (c <= 3415 || (c < 3542
              ? (c < 3482
                ? (c < 3450
                  ? (c < 3430
                    ? (c >= 3423 && c <= 3427)
                    : c <= 3439)
                  : (c <= 3455 || (c < 3461
                    ? (c >= 3457 && c <= 3459)
                    : c <= 3478)))
                : (c <= 3505 || (c < 3520
                  ? (c < 3517
                    ? (c >= 3507 && c <= 3515)
                    : c <= 3517)
                  : (c <= 3526 || (c < 3535
                    ? c == 3530
                    : c <= 3540)))))
              : (c <= 3542 || (c < 3664
                ? (c < 3570
                  ? (c < 3558
                    ? (c >= 3544 && c <= 3551)
                    : c <= 3567)
                  : (c <= 3571 || (c < 3648
                    ? (c >= 3585 && c <= 3642)
                    : c <= 3662)))
                : (c <= 3673 || (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c < 3749
                    ? (c >= 3724 && c <= 3747)
                    : c <= 3749)))))))))))))
      : (c <= 3773 || (c < 8008
        ? (c < 5792
          ? (c < 4348
            ? (c < 3902
              ? (c < 3840
                ? (c < 3784
                  ? (c < 3782
                    ? (c >= 3776 && c <= 3780)
                    : c <= 3782)
                  : (c <= 3789 || (c < 3804
                    ? (c >= 3792 && c <= 3801)
                    : c <= 3807)))
                : (c <= 3840 || (c < 3893
                  ? (c < 3872
                    ? (c >= 3864 && c <= 3865)
                    : c <= 3881)
                  : (c <= 3893 || (c < 3897
                    ? c == 3895
                    : c <= 3897)))))
              : (c <= 3911 || (c < 4096
                ? (c < 3974
                  ? (c < 3953
                    ? (c >= 3913 && c <= 3948)
                    : c <= 3972)
                  : (c <= 3991 || (c < 4038
                    ? (c >= 3993 && c <= 4028)
                    : c <= 4038)))
                : (c <= 4169 || (c < 4295
                  ? (c < 4256
                    ? (c >= 4176 && c <= 4253)
                    : c <= 4293)
                  : (c <= 4295 || (c < 4304
                    ? c == 4301
                    : c <= 4346)))))))
            : (c <= 4680 || (c < 4808
              ? (c < 4746
                ? (c < 4696
                  ? (c < 4688
                    ? (c >= 4682 && c <= 4685)
                    : c <= 4694)
                  : (c <= 4696 || (c < 4704
                    ? (c >= 4698 && c <= 4701)
                    : c <= 4744)))
                : (c <= 4749 || (c < 4792
                  ? (c < 4786
                    ? (c >= 4752 && c <= 4784)
                    : c <= 4789)
                  : (c <= 4798 || (c < 4802
                    ? c == 4800
                    : c <= 4805)))))
              : (c <= 4822 || (c < 4992
                ? (c < 4888
                  ? (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)
                  : (c <= 4954 || (c < 4969
                    ? (c >= 4957 && c <= 4959)
                    : c <= 4977)))
                : (c <= 5007 || (c < 5121
                  ? (c < 5112
                    ? (c >= 5024 && c <= 5109)
                    : c <= 5117)
                  : (c <= 5740 || (c < 5761
                    ? (c >= 5743 && c <= 5759)
                    : c <= 5786)))))))))
          : (c <= 5866 || (c < 6608
            ? (c < 6155
              ? (c < 5998
                ? (c < 5919
                  ? (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5909)
                  : (c <= 5940 || (c < 5984
                    ? (c >= 5952 && c <= 5971)
                    : c <= 5996)))
                : (c <= 6000 || (c < 6103
                  ? (c < 6016
                    ? (c >= 6002 && c <= 6003)
                    : c <= 6099)
                  : (c <= 6103 || (c < 6112
                    ? (c >= 6108 && c <= 6109)
                    : c <= 6121)))))
              : (c <= 6157 || (c < 6432
                ? (c < 6272
                  ? (c < 6176
                    ? (c >= 6159 && c <= 6169)
                    : c <= 6264)
                  : (c <= 6314 || (c < 6400
                    ? (c >= 6320 && c <= 6389)
                    : c <= 6430)))
                : (c <= 6443 || (c < 6512
                  ? (c < 6470
                    ? (c >= 6448 && c <= 6459)
                    : c <= 6509)
                  : (c <= 6516 || (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)))))))
            : (c <= 6618 || (c < 7040
              ? (c < 6823
                ? (c < 6752
                  ? (c < 6688
                    ? (c >= 6656 && c <= 6683)
                    : c <= 6750)
                  : (c <= 6780 || (c < 6800
                    ? (c >= 6783 && c <= 6793)
                    : c <= 6809)))
                : (c <= 6823 || (c < 6912
                  ? (c < 6847
                    ? (c >= 6832 && c <= 6845)
                    : c <= 6862)
                  : (c <= 6988 || (c < 7019
                    ? (c >= 6992 && c <= 7001)
                    : c <= 7027)))))
              : (c <= 7155 || (c < 7357
                ? (c < 7245
                  ? (c < 7232
                    ? (c >= 7168 && c <= 7223)
                    : c <= 7241)
                  : (c <= 7293 || (c < 7312
                    ? (c >= 7296 && c <= 7304)
                    : c <= 7354)))
                : (c <= 7359 || (c < 7424
                  ? (c < 7380
                    ? (c >= 7376 && c <= 7378)
                    : c <= 7418)
                  : (c <= 7957 || (c < 7968
                    ? (c >= 7960 && c <= 7965)
                    : c <= 8005)))))))))))
        : (c <= 8013 || (c < 11704
          ? (c < 8450
            ? (c < 8150
              ? (c < 8064
                ? (c < 8027
                  ? (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)
                  : (c <= 8027 || (c < 8031
                    ? c == 8029
                    : c <= 8061)))
                : (c <= 8116 || (c < 8130
                  ? (c < 8126
                    ? (c >= 8118 && c <= 8124)
                    : c <= 8126)
                  : (c <= 8132 || (c < 8144
                    ? (c >= 8134 && c <= 8140)
                    : c <= 8147)))))
              : (c <= 8155 || (c < 8305
                ? (c < 8182
                  ? (c < 8178
                    ? (c >= 8160 && c <= 8172)
                    : c <= 8180)
                  : (c <= 8188 || (c < 8276
                    ? (c >= 8255 && c <= 8256)
                    : c <= 8276)))
                : (c <= 8305 || (c < 8400
                  ? (c < 8336
                    ? c == 8319
                    : c <= 8348)
                  : (c <= 8412 || (c < 8421
                    ? c == 8417
                    : c <= 8432)))))))
            : (c <= 8450 || (c < 8544
              ? (c < 8486
                ? (c < 8469
                  ? (c < 8458
                    ? c == 8455
                    : c <= 8467)
                  : (c <= 8469 || (c < 8484
                    ? (c >= 8472 && c <= 8477)
                    : c <= 8484)))
                : (c <= 8486 || (c < 8508
                  ? (c < 8490
                    ? c == 8488
                    : c <= 8505)
                  : (c <= 8511 || (c < 8526
                    ? (c >= 8517 && c <= 8521)
                    : c <= 8526)))))
              : (c <= 8584 || (c < 11568
                ? (c < 11520
                  ? (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11507)
                  : (c <= 11557 || (c < 11565
                    ? c == 11559
                    : c <= 11565)))
                : (c <= 11623 || (c < 11680
                  ? (c < 11647
                    ? c == 11631
                    : c <= 11670)
                  : (c <= 11686 || (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)))))))))
          : (c <= 11710 || (c < 42560
            ? (c < 12445
              ? (c < 12293
                ? (c < 11728
                  ? (c < 11720
                    ? (c >= 11712 && c <= 11718)
                    : c <= 11726)
                  : (c <= 11734 || (c < 11744
                    ? (c >= 11736 && c <= 11742)
                    : c <= 11775)))
                : (c <= 12295 || (c < 12344
                  ? (c < 12337
                    ? (c >= 12321 && c <= 12335)
                    : c <= 12341)
                  : (c <= 12348 || (c < 12441
                    ? (c >= 12353 && c <= 12438)
                    : c <= 12442)))))
              : (c <= 12447 || (c < 12784
                ? (c < 12549
                  ? (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)
                  : (c <= 12591 || (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)))
                : (c <= 12799 || (c < 42192
                  ? (c < 19968
                    ? (c >= 13312 && c <= 19903)
                    : c <= 42124)
                  : (c <= 42237 || (c < 42512
                    ? (c >= 42240 && c <= 42508)
                    : c <= 42539)))))))
            : (c <= 42607 || (c < 43136
              ? (c < 42960
                ? (c < 42775
                  ? (c < 42623
                    ? (c >= 42612 && c <= 42621)
                    : c <= 42737)
                  : (c <= 42783 || (c < 42891
                    ? (c >= 42786 && c <= 42888)
                    : c <= 42954)))
                : (c <= 42961 || (c < 42994
                  ? (c < 42965
                    ? c == 42963
                    : c <= 42969)
                  : (c <= 43047 || (c < 43072
                    ? c == 43052
                    : c <= 43123)))))
              : (c <= 43205 || (c < 43360
                ? (c < 43259
                  ? (c < 43232
                    ? (c >= 43216 && c <= 43225)
                    : c <= 43255)
                  : (c <= 43259 || (c < 43312
                    ? (c >= 43261 && c <= 43309)
                    : c <= 43347)))
                : (c <= 43388 || (c < 43488
                  ? (c < 43471
                    ? (c >= 43392 && c <= 43456)
                    : c <= 43481)
                  : (c <= 43518 || (c < 43584
                    ? (c >= 43520 && c <= 43574)
                    : c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_17(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'a'
                ? (c < '9'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '7')
                  : (c <= '9' || (c < '_'
                    ? (c >= 'A' && c <= 'Z')
                    : c <= '_')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_18(int32_t c) {
  return (c < 43600
    ? (c < 3751
      ? (c < 2730
        ? (c < 1869
          ? (c < 908
            ? (c < 192
              ? (c < 'j'
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'a'
                    ? c == '_'
                    : c <= 'h')))
                : (c <= 'r' || (c < 181
                  ? (c < 170
                    ? (c >= 't' && c <= 'z')
                    : c <= 170)
                  : (c <= 181 || (c < 186
                    ? c == 183
                    : c <= 186)))))
              : (c <= 214 || (c < 750
                ? (c < 710
                  ? (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)
                  : (c <= 721 || (c < 748
                    ? (c >= 736 && c <= 740)
                    : c <= 748)))
                : (c <= 750 || (c < 891
                  ? (c < 886
                    ? (c >= 768 && c <= 884)
                    : c <= 887)
                  : (c <= 893 || (c < 902
                    ? c == 895
                    : c <= 906)))))))
            : (c <= 908 || (c < 1476
              ? (c < 1329
                ? (c < 1015
                  ? (c < 931
                    ? (c >= 910 && c <= 929)
                    : c <= 1013)
                  : (c <= 1153 || (c < 1162
                    ? (c >= 1155 && c <= 1159)
                    : c <= 1327)))
                : (c <= 1366 || (c < 1425
                  ? (c < 1376
                    ? c == 1369
                    : c <= 1416)
                  : (c <= 1469 || (c < 1473
                    ? c == 1471
                    : c <= 1474)))))
              : (c <= 1477 || (c < 1646
                ? (c < 1519
                  ? (c < 1488
                    ? c == 1479
                    : c <= 1514)
                  : (c <= 1522 || (c < 1568
                    ? (c >= 1552 && c <= 1562)
                    : c <= 1641)))
                : (c <= 1747 || (c < 1770
                  ? (c < 1759
                    ? (c >= 1749 && c <= 1756)
                    : c <= 1768)
                  : (c <= 1788 || (c < 1808
                    ? c == 1791
                    : c <= 1866)))))))))
          : (c <= 1969 || (c < 2527
            ? (c < 2417
              ? (c < 2144
                ? (c < 2045
                  ? (c < 2042
                    ? (c >= 1984 && c <= 2037)
                    : c <= 2042)
                  : (c <= 2045 || (c < 2112
                    ? (c >= 2048 && c <= 2093)
                    : c <= 2139)))
                : (c <= 2154 || (c < 2200
                  ? (c < 2185
                    ? (c >= 2160 && c <= 2183)
                    : c <= 2190)
                  : (c <= 2273 || (c < 2406
                    ? (c >= 2275 && c <= 2403)
                    : c <= 2415)))))
              : (c <= 2435 || (c < 2486
                ? (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c < 2482
                    ? (c >= 2474 && c <= 2480)
                    : c <= 2482)))
                : (c <= 2489 || (c < 2507
                  ? (c < 2503
                    ? (c >= 2492 && c <= 2500)
                    : c <= 2504)
                  : (c <= 2510 || (c < 2524
                    ? c == 2519
                    : c <= 2525)))))))
            : (c <= 2531 || (c < 2620
              ? (c < 2575
                ? (c < 2558
                  ? (c < 2556
                    ? (c >= 2534 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2558 || (c < 2565
                    ? (c >= 2561 && c <= 2563)
                    : c <= 2570)))
                : (c <= 2576 || (c < 2610
                  ? (c < 2602
                    ? (c >= 2579 && c <= 2600)
                    : c <= 2608)
                  : (c <= 2611 || (c < 2616
                    ? (c >= 2613 && c <= 2614)
                    : c <= 2617)))))
              : (c <= 2620 || (c < 2654
                ? (c < 2635
                  ? (c < 2631
                    ? (c >= 2622 && c <= 2626)
                    : c <= 2632)
                  : (c <= 2637 || (c < 2649
                    ? c == 2641
                    : c <= 2652)))
                : (c <= 2654 || (c < 2693
                  ? (c < 2689
                    ? (c >= 2662 && c <= 2677)
                    : c <= 2691)
                  : (c <= 2701 || (c < 2707
                    ? (c >= 2703 && c <= 2705)
                    : c <= 2728)))))))))))
        : (c <= 2736 || (c < 3157
          ? (c < 2929
            ? (c < 2831
              ? (c < 2768
                ? (c < 2748
                  ? (c < 2741
                    ? (c >= 2738 && c <= 2739)
                    : c <= 2745)
                  : (c <= 2757 || (c < 2763
                    ? (c >= 2759 && c <= 2761)
                    : c <= 2765)))
                : (c <= 2768 || (c < 2809
                  ? (c < 2790
                    ? (c >= 2784 && c <= 2787)
                    : c <= 2799)
                  : (c <= 2815 || (c < 2821
                    ? (c >= 2817 && c <= 2819)
                    : c <= 2828)))))
              : (c <= 2832 || (c < 2887
                ? (c < 2866
                  ? (c < 2858
                    ? (c >= 2835 && c <= 2856)
                    : c <= 2864)
                  : (c <= 2867 || (c < 2876
                    ? (c >= 2869 && c <= 2873)
                    : c <= 2884)))
                : (c <= 2888 || (c < 2908
                  ? (c < 2901
                    ? (c >= 2891 && c <= 2893)
                    : c <= 2903)
                  : (c <= 2909 || (c < 2918
                    ? (c >= 2911 && c <= 2915)
                    : c <= 2927)))))))
            : (c <= 2929 || (c < 3014
              ? (c < 2972
                ? (c < 2958
                  ? (c < 2949
                    ? (c >= 2946 && c <= 2947)
                    : c <= 2954)
                  : (c <= 2960 || (c < 2969
                    ? (c >= 2962 && c <= 2965)
                    : c <= 2970)))
                : (c <= 2972 || (c < 2984
                  ? (c < 2979
                    ? (c >= 2974 && c <= 2975)
                    : c <= 2980)
                  : (c <= 2986 || (c < 3006
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3010)))))
              : (c <= 3016 || (c < 3086
                ? (c < 3031
                  ? (c < 3024
                    ? (c >= 3018 && c <= 3021)
                    : c <= 3024)
                  : (c <= 3031 || (c < 3072
                    ? (c >= 3046 && c <= 3055)
                    : c <= 3084)))
                : (c <= 3088 || (c < 3132
                  ? (c < 3114
                    ? (c >= 3090 && c <= 3112)
                    : c <= 3129)
                  : (c <= 3140 || (c < 3146
                    ? (c >= 3142 && c <= 3144)
                    : c <= 3149)))))))))
          : (c <= 3158 || (c < 3412
            ? (c < 3270
              ? (c < 3205
                ? (c < 3168
                  ? (c < 3165
                    ? (c >= 3160 && c <= 3162)
                    : c <= 3165)
                  : (c <= 3171 || (c < 3200
                    ? (c >= 3174 && c <= 3183)
                    : c <= 3203)))
                : (c <= 3212 || (c < 3242
                  ? (c < 3218
                    ? (c >= 3214 && c <= 3216)
                    : c <= 3240)
                  : (c <= 3251 || (c < 3260
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3268)))))
              : (c <= 3272 || (c < 3313
                ? (c < 3293
                  ? (c < 3285
                    ? (c >= 3274 && c <= 3277)
                    : c <= 3286)
                  : (c <= 3294 || (c < 3302
                    ? (c >= 3296 && c <= 3299)
                    : c <= 3311)))
                : (c <= 3314 || (c < 3346
                  ? (c < 3342
                    ? (c >= 3328 && c <= 3340)
                    : c <= 3344)
                  : (c <= 3396 || (c < 3402
                    ? (c >= 3398 && c <= 3400)
                    : c <= 3406)))))))
            : (c <= 3415 || (c < 3542
              ? (c < 3482
                ? (c < 3450
                  ? (c < 3430
                    ? (c >= 3423 && c <= 3427)
                    : c <= 3439)
                  : (c <= 3455 || (c < 3461
                    ? (c >= 3457 && c <= 3459)
                    : c <= 3478)))
                : (c <= 3505 || (c < 3520
                  ? (c < 3517
                    ? (c >= 3507 && c <= 3515)
                    : c <= 3517)
                  : (c <= 3526 || (c < 3535
                    ? c == 3530
                    : c <= 3540)))))
              : (c <= 3542 || (c < 3664
                ? (c < 3570
                  ? (c < 3558
                    ? (c >= 3544 && c <= 3551)
                    : c <= 3567)
                  : (c <= 3571 || (c < 3648
                    ? (c >= 3585 && c <= 3642)
                    : c <= 3662)))
                : (c <= 3673 || (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c < 3749
                    ? (c >= 3724 && c <= 3747)
                    : c <= 3749)))))))))))))
      : (c <= 3773 || (c < 8008
        ? (c < 5792
          ? (c < 4348
            ? (c < 3902
              ? (c < 3840
                ? (c < 3784
                  ? (c < 3782
                    ? (c >= 3776 && c <= 3780)
                    : c <= 3782)
                  : (c <= 3789 || (c < 3804
                    ? (c >= 3792 && c <= 3801)
                    : c <= 3807)))
                : (c <= 3840 || (c < 3893
                  ? (c < 3872
                    ? (c >= 3864 && c <= 3865)
                    : c <= 3881)
                  : (c <= 3893 || (c < 3897
                    ? c == 3895
                    : c <= 3897)))))
              : (c <= 3911 || (c < 4096
                ? (c < 3974
                  ? (c < 3953
                    ? (c >= 3913 && c <= 3948)
                    : c <= 3972)
                  : (c <= 3991 || (c < 4038
                    ? (c >= 3993 && c <= 4028)
                    : c <= 4038)))
                : (c <= 4169 || (c < 4295
                  ? (c < 4256
                    ? (c >= 4176 && c <= 4253)
                    : c <= 4293)
                  : (c <= 4295 || (c < 4304
                    ? c == 4301
                    : c <= 4346)))))))
            : (c <= 4680 || (c < 4808
              ? (c < 4746
                ? (c < 4696
                  ? (c < 4688
                    ? (c >= 4682 && c <= 4685)
                    : c <= 4694)
                  : (c <= 4696 || (c < 4704
                    ? (c >= 4698 && c <= 4701)
                    : c <= 4744)))
                : (c <= 4749 || (c < 4792
                  ? (c < 4786
                    ? (c >= 4752 && c <= 4784)
                    : c <= 4789)
                  : (c <= 4798 || (c < 4802
                    ? c == 4800
                    : c <= 4805)))))
              : (c <= 4822 || (c < 4992
                ? (c < 4888
                  ? (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)
                  : (c <= 4954 || (c < 4969
                    ? (c >= 4957 && c <= 4959)
                    : c <= 4977)))
                : (c <= 5007 || (c < 5121
                  ? (c < 5112
                    ? (c >= 5024 && c <= 5109)
                    : c <= 5117)
                  : (c <= 5740 || (c < 5761
                    ? (c >= 5743 && c <= 5759)
                    : c <= 5786)))))))))
          : (c <= 5866 || (c < 6608
            ? (c < 6155
              ? (c < 5998
                ? (c < 5919
                  ? (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5909)
                  : (c <= 5940 || (c < 5984
                    ? (c >= 5952 && c <= 5971)
                    : c <= 5996)))
                : (c <= 6000 || (c < 6103
                  ? (c < 6016
                    ? (c >= 6002 && c <= 6003)
                    : c <= 6099)
                  : (c <= 6103 || (c < 6112
                    ? (c >= 6108 && c <= 6109)
                    : c <= 6121)))))
              : (c <= 6157 || (c < 6432
                ? (c < 6272
                  ? (c < 6176
                    ? (c >= 6159 && c <= 6169)
                    : c <= 6264)
                  : (c <= 6314 || (c < 6400
                    ? (c >= 6320 && c <= 6389)
                    : c <= 6430)))
                : (c <= 6443 || (c < 6512
                  ? (c < 6470
                    ? (c >= 6448 && c <= 6459)
                    : c <= 6509)
                  : (c <= 6516 || (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)))))))
            : (c <= 6618 || (c < 7040
              ? (c < 6823
                ? (c < 6752
                  ? (c < 6688
                    ? (c >= 6656 && c <= 6683)
                    : c <= 6750)
                  : (c <= 6780 || (c < 6800
                    ? (c >= 6783 && c <= 6793)
                    : c <= 6809)))
                : (c <= 6823 || (c < 6912
                  ? (c < 6847
                    ? (c >= 6832 && c <= 6845)
                    : c <= 6862)
                  : (c <= 6988 || (c < 7019
                    ? (c >= 6992 && c <= 7001)
                    : c <= 7027)))))
              : (c <= 7155 || (c < 7357
                ? (c < 7245
                  ? (c < 7232
                    ? (c >= 7168 && c <= 7223)
                    : c <= 7241)
                  : (c <= 7293 || (c < 7312
                    ? (c >= 7296 && c <= 7304)
                    : c <= 7354)))
                : (c <= 7359 || (c < 7424
                  ? (c < 7380
                    ? (c >= 7376 && c <= 7378)
                    : c <= 7418)
                  : (c <= 7957 || (c < 7968
                    ? (c >= 7960 && c <= 7965)
                    : c <= 8005)))))))))))
        : (c <= 8013 || (c < 11704
          ? (c < 8450
            ? (c < 8150
              ? (c < 8064
                ? (c < 8027
                  ? (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)
                  : (c <= 8027 || (c < 8031
                    ? c == 8029
                    : c <= 8061)))
                : (c <= 8116 || (c < 8130
                  ? (c < 8126
                    ? (c >= 8118 && c <= 8124)
                    : c <= 8126)
                  : (c <= 8132 || (c < 8144
                    ? (c >= 8134 && c <= 8140)
                    : c <= 8147)))))
              : (c <= 8155 || (c < 8305
                ? (c < 8182
                  ? (c < 8178
                    ? (c >= 8160 && c <= 8172)
                    : c <= 8180)
                  : (c <= 8188 || (c < 8276
                    ? (c >= 8255 && c <= 8256)
                    : c <= 8276)))
                : (c <= 8305 || (c < 8400
                  ? (c < 8336
                    ? c == 8319
                    : c <= 8348)
                  : (c <= 8412 || (c < 8421
                    ? c == 8417
                    : c <= 8432)))))))
            : (c <= 8450 || (c < 8544
              ? (c < 8486
                ? (c < 8469
                  ? (c < 8458
                    ? c == 8455
                    : c <= 8467)
                  : (c <= 8469 || (c < 8484
                    ? (c >= 8472 && c <= 8477)
                    : c <= 8484)))
                : (c <= 8486 || (c < 8508
                  ? (c < 8490
                    ? c == 8488
                    : c <= 8505)
                  : (c <= 8511 || (c < 8526
                    ? (c >= 8517 && c <= 8521)
                    : c <= 8526)))))
              : (c <= 8584 || (c < 11568
                ? (c < 11520
                  ? (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11507)
                  : (c <= 11557 || (c < 11565
                    ? c == 11559
                    : c <= 11565)))
                : (c <= 11623 || (c < 11680
                  ? (c < 11647
                    ? c == 11631
                    : c <= 11670)
                  : (c <= 11686 || (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)))))))))
          : (c <= 11710 || (c < 42560
            ? (c < 12445
              ? (c < 12293
                ? (c < 11728
                  ? (c < 11720
                    ? (c >= 11712 && c <= 11718)
                    : c <= 11726)
                  : (c <= 11734 || (c < 11744
                    ? (c >= 11736 && c <= 11742)
                    : c <= 11775)))
                : (c <= 12295 || (c < 12344
                  ? (c < 12337
                    ? (c >= 12321 && c <= 12335)
                    : c <= 12341)
                  : (c <= 12348 || (c < 12441
                    ? (c >= 12353 && c <= 12438)
                    : c <= 12442)))))
              : (c <= 12447 || (c < 12784
                ? (c < 12549
                  ? (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)
                  : (c <= 12591 || (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)))
                : (c <= 12799 || (c < 42192
                  ? (c < 19968
                    ? (c >= 13312 && c <= 19903)
                    : c <= 42124)
                  : (c <= 42237 || (c < 42512
                    ? (c >= 42240 && c <= 42508)
                    : c <= 42539)))))))
            : (c <= 42607 || (c < 43136
              ? (c < 42960
                ? (c < 42775
                  ? (c < 42623
                    ? (c >= 42612 && c <= 42621)
                    : c <= 42737)
                  : (c <= 42783 || (c < 42891
                    ? (c >= 42786 && c <= 42888)
                    : c <= 42954)))
                : (c <= 42961 || (c < 42994
                  ? (c < 42965
                    ? c == 42963
                    : c <= 42969)
                  : (c <= 43047 || (c < 43072
                    ? c == 43052
                    : c <= 43123)))))
              : (c <= 43205 || (c < 43360
                ? (c < 43259
                  ? (c < 43232
                    ? (c >= 43216 && c <= 43225)
                    : c <= 43255)
                  : (c <= 43259 || (c < 43312
                    ? (c >= 43261 && c <= 43309)
                    : c <= 43347)))
                : (c <= 43388 || (c < 43488
                  ? (c < 43471
                    ? (c >= 43392 && c <= 43456)
                    : c <= 43481)
                  : (c <= 43518 || (c < 43584
                    ? (c >= 43520 && c <= 43574)
                    : c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_19(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'm'
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'b'
                    ? c == '_'
                    : c <= 'k')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_20(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'a'
                ? (c < '3'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '1')
                  : (c <= '9' || (c < '_'
                    ? (c >= 'A' && c <= 'Z')
                    : c <= '_')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_21(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'a'
                ? (c < '5'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '3')
                  : (c <= '9' || (c < '_'
                    ? (c >= 'A' && c <= 'Z')
                    : c <= '_')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_22(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'a'
                ? (c < '7'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '5')
                  : (c <= '9' || (c < '_'
                    ? (c >= 'A' && c <= 'Z')
                    : c <= '_')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_23(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'a'
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'D' || (c < '_'
                    ? (c >= 'F' && c <= 'Z')
                    : c <= '_')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_24(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'a'
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'K' || (c < '_'
                    ? (c >= 'M' && c <= 'Z')
                    : c <= '_')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_25(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'a'
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'R' || (c < '_'
                    ? (c >= 'T' && c <= 'Z')
                    : c <= '_')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_26(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'a'
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'T' || (c < '_'
                    ? (c >= 'V' && c <= 'Z')
                    : c <= '_')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_27(int32_t c) {
  return (c < 43616
    ? (c < 3782
      ? (c < 2741
        ? (c < 2042
          ? (c < 931
            ? (c < 248
              ? (c < 170
                ? (c < 'B'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'a'
                    ? c == '_'
                    : c <= 'z')))
                : (c <= 170 || (c < 186
                  ? (c < 183
                    ? c == 181
                    : c <= 183)
                  : (c <= 186 || (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)))))
              : (c <= 705 || (c < 886
                ? (c < 748
                  ? (c < 736
                    ? (c >= 710 && c <= 721)
                    : c <= 740)
                  : (c <= 748 || (c < 768
                    ? c == 750
                    : c <= 884)))
                : (c <= 887 || (c < 902
                  ? (c < 895
                    ? (c >= 891 && c <= 893)
                    : c <= 895)
                  : (c <= 906 || (c < 910
                    ? c == 908
                    : c <= 929)))))))
            : (c <= 1013 || (c < 1488
              ? (c < 1376
                ? (c < 1162
                  ? (c < 1155
                    ? (c >= 1015 && c <= 1153)
                    : c <= 1159)
                  : (c <= 1327 || (c < 1369
                    ? (c >= 1329 && c <= 1366)
                    : c <= 1369)))
                : (c <= 1416 || (c < 1473
                  ? (c < 1471
                    ? (c >= 1425 && c <= 1469)
                    : c <= 1471)
                  : (c <= 1474 || (c < 1479
                    ? (c >= 1476 && c <= 1477)
                    : c <= 1479)))))
              : (c <= 1514 || (c < 1759
                ? (c < 1568
                  ? (c < 1552
                    ? (c >= 1519 && c <= 1522)
                    : c <= 1562)
                  : (c <= 1641 || (c < 1749
                    ? (c >= 1646 && c <= 1747)
                    : c <= 1756)))
                : (c <= 1768 || (c < 1808
                  ? (c < 1791
                    ? (c >= 1770 && c <= 1788)
                    : c <= 1791)
                  : (c <= 1866 || (c < 1984
                    ? (c >= 1869 && c <= 1969)
                    : c <= 2037)))))))))
          : (c <= 2042 || (c < 2556
            ? (c < 2447
              ? (c < 2185
                ? (c < 2112
                  ? (c < 2048
                    ? c == 2045
                    : c <= 2093)
                  : (c <= 2139 || (c < 2160
                    ? (c >= 2144 && c <= 2154)
                    : c <= 2183)))
                : (c <= 2190 || (c < 2406
                  ? (c < 2275
                    ? (c >= 2200 && c <= 2273)
                    : c <= 2403)
                  : (c <= 2415 || (c < 2437
                    ? (c >= 2417 && c <= 2435)
                    : c <= 2444)))))
              : (c <= 2448 || (c < 2503
                ? (c < 2482
                  ? (c < 2474
                    ? (c >= 2451 && c <= 2472)
                    : c <= 2480)
                  : (c <= 2482 || (c < 2492
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2500)))
                : (c <= 2504 || (c < 2524
                  ? (c < 2519
                    ? (c >= 2507 && c <= 2510)
                    : c <= 2519)
                  : (c <= 2525 || (c < 2534
                    ? (c >= 2527 && c <= 2531)
                    : c <= 2545)))))))
            : (c <= 2556 || (c < 2631
              ? (c < 2602
                ? (c < 2565
                  ? (c < 2561
                    ? c == 2558
                    : c <= 2563)
                  : (c <= 2570 || (c < 2579
                    ? (c >= 2575 && c <= 2576)
                    : c <= 2600)))
                : (c <= 2608 || (c < 2616
                  ? (c < 2613
                    ? (c >= 2610 && c <= 2611)
                    : c <= 2614)
                  : (c <= 2617 || (c < 2622
                    ? c == 2620
                    : c <= 2626)))))
              : (c <= 2632 || (c < 2689
                ? (c < 2649
                  ? (c < 2641
                    ? (c >= 2635 && c <= 2637)
                    : c <= 2641)
                  : (c <= 2652 || (c < 2662
                    ? c == 2654
                    : c <= 2677)))
                : (c <= 2691 || (c < 2707
                  ? (c < 2703
                    ? (c >= 2693 && c <= 2701)
                    : c <= 2705)
                  : (c <= 2728 || (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)))))))))))
        : (c <= 2745 || (c < 3165
          ? (c < 2949
            ? (c < 2858
              ? (c < 2790
                ? (c < 2763
                  ? (c < 2759
                    ? (c >= 2748 && c <= 2757)
                    : c <= 2761)
                  : (c <= 2765 || (c < 2784
                    ? c == 2768
                    : c <= 2787)))
                : (c <= 2799 || (c < 2821
                  ? (c < 2817
                    ? (c >= 2809 && c <= 2815)
                    : c <= 2819)
                  : (c <= 2828 || (c < 2835
                    ? (c >= 2831 && c <= 2832)
                    : c <= 2856)))))
              : (c <= 2864 || (c < 2901
                ? (c < 2876
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2884 || (c < 2891
                    ? (c >= 2887 && c <= 2888)
                    : c <= 2893)))
                : (c <= 2903 || (c < 2918
                  ? (c < 2911
                    ? (c >= 2908 && c <= 2909)
                    : c <= 2915)
                  : (c <= 2927 || (c < 2946
                    ? c == 2929
                    : c <= 2947)))))))
            : (c <= 2954 || (c < 3024
              ? (c < 2979
                ? (c < 2969
                  ? (c < 2962
                    ? (c >= 2958 && c <= 2960)
                    : c <= 2965)
                  : (c <= 2970 || (c < 2974
                    ? c == 2972
                    : c <= 2975)))
                : (c <= 2980 || (c < 3006
                  ? (c < 2990
                    ? (c >= 2984 && c <= 2986)
                    : c <= 3001)
                  : (c <= 3010 || (c < 3018
                    ? (c >= 3014 && c <= 3016)
                    : c <= 3021)))))
              : (c <= 3024 || (c < 3114
                ? (c < 3072
                  ? (c < 3046
                    ? c == 3031
                    : c <= 3055)
                  : (c <= 3084 || (c < 3090
                    ? (c >= 3086 && c <= 3088)
                    : c <= 3112)))
                : (c <= 3129 || (c < 3146
                  ? (c < 3142
                    ? (c >= 3132 && c <= 3140)
                    : c <= 3144)
                  : (c <= 3149 || (c < 3160
                    ? (c >= 3157 && c <= 3158)
                    : c <= 3162)))))))))
          : (c <= 3165 || (c < 3430
            ? (c < 3285
              ? (c < 3218
                ? (c < 3200
                  ? (c < 3174
                    ? (c >= 3168 && c <= 3171)
                    : c <= 3183)
                  : (c <= 3203 || (c < 3214
                    ? (c >= 3205 && c <= 3212)
                    : c <= 3216)))
                : (c <= 3240 || (c < 3260
                  ? (c < 3253
                    ? (c >= 3242 && c <= 3251)
                    : c <= 3257)
                  : (c <= 3268 || (c < 3274
                    ? (c >= 3270 && c <= 3272)
                    : c <= 3277)))))
              : (c <= 3286 || (c < 3342
                ? (c < 3302
                  ? (c < 3296
                    ? (c >= 3293 && c <= 3294)
                    : c <= 3299)
                  : (c <= 3311 || (c < 3328
                    ? (c >= 3313 && c <= 3314)
                    : c <= 3340)))
                : (c <= 3344 || (c < 3402
                  ? (c < 3398
                    ? (c >= 3346 && c <= 3396)
                    : c <= 3400)
                  : (c <= 3406 || (c < 3423
                    ? (c >= 3412 && c <= 3415)
                    : c <= 3427)))))))
            : (c <= 3439 || (c < 3558
              ? (c < 3517
                ? (c < 3461
                  ? (c < 3457
                    ? (c >= 3450 && c <= 3455)
                    : c <= 3459)
                  : (c <= 3478 || (c < 3507
                    ? (c >= 3482 && c <= 3505)
                    : c <= 3515)))
                : (c <= 3517 || (c < 3535
                  ? (c < 3530
                    ? (c >= 3520 && c <= 3526)
                    : c <= 3530)
                  : (c <= 3540 || (c < 3544
                    ? c == 3542
                    : c <= 3551)))))
              : (c <= 3567 || (c < 3716
                ? (c < 3648
                  ? (c < 3585
                    ? (c >= 3570 && c <= 3571)
                    : c <= 3642)
                  : (c <= 3662 || (c < 3713
                    ? (c >= 3664 && c <= 3673)
                    : c <= 3714)))
                : (c <= 3716 || (c < 3749
                  ? (c < 3724
                    ? (c >= 3718 && c <= 3722)
                    : c <= 3747)
                  : (c <= 3749 || (c < 3776
                    ? (c >= 3751 && c <= 3773)
                    : c <= 3780)))))))))))))
      : (c <= 3782 || (c < 8025
        ? (c < 5888
          ? (c < 4688
            ? (c < 3953
              ? (c < 3872
                ? (c < 3804
                  ? (c < 3792
                    ? (c >= 3784 && c <= 3789)
                    : c <= 3801)
                  : (c <= 3807 || (c < 3864
                    ? c == 3840
                    : c <= 3865)))
                : (c <= 3881 || (c < 3897
                  ? (c < 3895
                    ? c == 3893
                    : c <= 3895)
                  : (c <= 3897 || (c < 3913
                    ? (c >= 3902 && c <= 3911)
                    : c <= 3948)))))
              : (c <= 3972 || (c < 4256
                ? (c < 4038
                  ? (c < 3993
                    ? (c >= 3974 && c <= 3991)
                    : c <= 4028)
                  : (c <= 4038 || (c < 4176
                    ? (c >= 4096 && c <= 4169)
                    : c <= 4253)))
                : (c <= 4293 || (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)))))))
            : (c <= 4694 || (c < 4882
              ? (c < 4786
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c < 4752
                    ? (c >= 4746 && c <= 4749)
                    : c <= 4784)))
                : (c <= 4789 || (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)))))
              : (c <= 4885 || (c < 5112
                ? (c < 4969
                  ? (c < 4957
                    ? (c >= 4888 && c <= 4954)
                    : c <= 4959)
                  : (c <= 4977 || (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)))
                : (c <= 5117 || (c < 5761
                  ? (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)
                  : (c <= 5786 || (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)))))))))
          : (c <= 5909 || (c < 6688
            ? (c < 6176
              ? (c < 6016
                ? (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5940)
                    : c <= 5971)
                  : (c <= 5996 || (c < 6002
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6003)))
                : (c <= 6099 || (c < 6112
                  ? (c < 6108
                    ? c == 6103
                    : c <= 6109)
                  : (c <= 6121 || (c < 6159
                    ? (c >= 6155 && c <= 6157)
                    : c <= 6169)))))
              : (c <= 6264 || (c < 6470
                ? (c < 6400
                  ? (c < 6320
                    ? (c >= 6272 && c <= 6314)
                    : c <= 6389)
                  : (c <= 6430 || (c < 6448
                    ? (c >= 6432 && c <= 6443)
                    : c <= 6459)))
                : (c <= 6509 || (c < 6576
                  ? (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)
                  : (c <= 6601 || (c < 6656
                    ? (c >= 6608 && c <= 6618)
                    : c <= 6683)))))))
            : (c <= 6750 || (c < 7232
              ? (c < 6847
                ? (c < 6800
                  ? (c < 6783
                    ? (c >= 6752 && c <= 6780)
                    : c <= 6793)
                  : (c <= 6809 || (c < 6832
                    ? c == 6823
                    : c <= 6845)))
                : (c <= 6862 || (c < 7019
                  ? (c < 6992
                    ? (c >= 6912 && c <= 6988)
                    : c <= 7001)
                  : (c <= 7027 || (c < 7168
                    ? (c >= 7040 && c <= 7155)
                    : c <= 7223)))))
              : (c <= 7241 || (c < 7380
                ? (c < 7312
                  ? (c < 7296
                    ? (c >= 7245 && c <= 7293)
                    : c <= 7304)
                  : (c <= 7354 || (c < 7376
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7378)))
                : (c <= 7418 || (c < 7968
                  ? (c < 7960
                    ? (c >= 7424 && c <= 7957)
                    : c <= 7965)
                  : (c <= 8005 || (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)))))))))))
        : (c <= 8025 || (c < 11720
          ? (c < 8458
            ? (c < 8178
              ? (c < 8126
                ? (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8061 || (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)))
                : (c <= 8126 || (c < 8144
                  ? (c < 8134
                    ? (c >= 8130 && c <= 8132)
                    : c <= 8140)
                  : (c <= 8147 || (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)))))
              : (c <= 8180 || (c < 8336
                ? (c < 8276
                  ? (c < 8255
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8256)
                  : (c <= 8276 || (c < 8319
                    ? c == 8305
                    : c <= 8319)))
                : (c <= 8348 || (c < 8421
                  ? (c < 8417
                    ? (c >= 8400 && c <= 8412)
                    : c <= 8417)
                  : (c <= 8432 || (c < 8455
                    ? c == 8450
                    : c <= 8455)))))))
            : (c <= 8467 || (c < 11499
              ? (c < 8490
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || (c < 8488
                    ? c == 8486
                    : c <= 8488)))
                : (c <= 8505 || (c < 8526
                  ? (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)
                  : (c <= 8526 || (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)))))
              : (c <= 11507 || (c < 11647
                ? (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)))
                : (c <= 11670 || (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)))))))))
          : (c <= 11726 || (c < 42623
            ? (c < 12540
              ? (c < 12337
                ? (c < 11744
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 11775 || (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12335)))
                : (c <= 12341 || (c < 12441
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12442 || (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)))))
              : (c <= 12543 || (c < 19968
                ? (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c < 13312
                    ? (c >= 12784 && c <= 12799)
                    : c <= 19903)))
                : (c <= 42124 || (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42539 || (c < 42612
                    ? (c >= 42560 && c <= 42607)
                    : c <= 42621)))))))
            : (c <= 42737 || (c < 43232
              ? (c < 42965
                ? (c < 42891
                  ? (c < 42786
                    ? (c >= 42775 && c <= 42783)
                    : c <= 42888)
                  : (c <= 42954 || (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)))
                : (c <= 42969 || (c < 43072
                  ? (c < 43052
                    ? (c >= 42994 && c <= 43047)
                    : c <= 43052)
                  : (c <= 43123 || (c < 43216
                    ? (c >= 43136 && c <= 43205)
                    : c <= 43225)))))
              : (c <= 43255 || (c < 43471
                ? (c < 43312
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43309)
                  : (c <= 43347 || (c < 43392
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43456)))
                : (c <= 43481 || (c < 43584
                  ? (c < 43520
                    ? (c >= 43488 && c <= 43518)
                    : c <= 43574)
                  : (c <= 43597 || (c >= 43600 && c <= 43609)))))))))))))))
    : (c <= 43638 || (c < 71453
      ? (c < 67639
        ? (c < 65345
          ? (c < 64312
            ? (c < 43888
              ? (c < 43785
                ? (c < 43744
                  ? (c < 43739
                    ? (c >= 43642 && c <= 43714)
                    : c <= 43741)
                  : (c <= 43759 || (c < 43777
                    ? (c >= 43762 && c <= 43766)
                    : c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c < 43868
                    ? (c >= 43824 && c <= 43866)
                    : c <= 43881)))))
              : (c <= 44010 || (c < 63744
                ? (c < 44032
                  ? (c < 44016
                    ? (c >= 44012 && c <= 44013)
                    : c <= 44025)
                  : (c <= 55203 || (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || (c < 64298
                    ? (c >= 64285 && c <= 64296)
                    : c <= 64310)))))))
            : (c <= 64316 || (c < 65075
              ? (c < 64612
                ? (c < 64323
                  ? (c < 64320
                    ? c == 64318
                    : c <= 64321)
                  : (c <= 64324 || (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)))
                : (c <= 64829 || (c < 65008
                  ? (c < 64914
                    ? (c >= 64848 && c <= 64911)
                    : c <= 64967)
                  : (c <= 65017 || (c < 65056
                    ? (c >= 65024 && c <= 65039)
                    : c <= 65071)))))
              : (c <= 65076 || (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65101 && c <= 65103)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65296
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65305 || (c < 65343
                    ? (c >= 65313 && c <= 65338)
                    : c <= 65343)))))))))
          : (c <= 65370 || (c < 66513
            ? (c < 65664
              ? (c < 65536
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65382 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c < 65498
                    ? (c >= 65490 && c <= 65495)
                    : c <= 65500)))
                : (c <= 65547 || (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c < 65616
                    ? (c >= 65599 && c <= 65613)
                    : c <= 65629)))))
              : (c <= 65786 || (c < 66304
                ? (c < 66176
                  ? (c < 66045
                    ? (c >= 65856 && c <= 65908)
                    : c <= 66045)
                  : (c <= 66204 || (c < 66272
                    ? (c >= 66208 && c <= 66256)
                    : c <= 66272)))
                : (c <= 66335 || (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66426)
                  : (c <= 66461 || (c < 66504
                    ? (c >= 66464 && c <= 66499)
                    : c <= 66511)))))))
            : (c <= 66517 || (c < 66979
              ? (c < 66864
                ? (c < 66736
                  ? (c < 66720
                    ? (c >= 66560 && c <= 66717)
                    : c <= 66729)
                  : (c <= 66771 || (c < 66816
                    ? (c >= 66776 && c <= 66811)
                    : c <= 66855)))
                : (c <= 66915 || (c < 66956
                  ? (c < 66940
                    ? (c >= 66928 && c <= 66938)
                    : c <= 66954)
                  : (c <= 66962 || (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)))))
              : (c <= 66993 || (c < 67456
                ? (c < 67072
                  ? (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)
                  : (c <= 67382 || (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)))
                : (c <= 67461 || (c < 67584
                  ? (c < 67506
                    ? (c >= 67463 && c <= 67504)
                    : c <= 67514)
                  : (c <= 67589 || (c < 67594
                    ? c == 67592
                    : c <= 67637)))))))))))
        : (c <= 67640 || (c < 69956
          ? (c < 68448
            ? (c < 68101
              ? (c < 67828
                ? (c < 67680
                  ? (c < 67647
                    ? c == 67644
                    : c <= 67669)
                  : (c <= 67702 || (c < 67808
                    ? (c >= 67712 && c <= 67742)
                    : c <= 67826)))
                : (c <= 67829 || (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c < 68096
                    ? (c >= 68030 && c <= 68031)
                    : c <= 68099)))))
              : (c <= 68102 || (c < 68192
                ? (c < 68121
                  ? (c < 68117
                    ? (c >= 68108 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c < 68159
                    ? (c >= 68152 && c <= 68154)
                    : c <= 68159)))
                : (c <= 68220 || (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68326 || (c < 68416
                    ? (c >= 68352 && c <= 68405)
                    : c <= 68437)))))))
            : (c <= 68466 || (c < 69424
              ? (c < 68912
                ? (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c < 68864
                    ? (c >= 68800 && c <= 68850)
                    : c <= 68903)))
                : (c <= 68921 || (c < 69296
                  ? (c < 69291
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69292)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))))
              : (c <= 69456 || (c < 69759
                ? (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69509)
                    : c <= 69572)
                  : (c <= 69622 || (c < 69734
                    ? (c >= 69632 && c <= 69702)
                    : c <= 69749)))
                : (c <= 69818 || (c < 69872
                  ? (c < 69840
                    ? c == 69826
                    : c <= 69864)
                  : (c <= 69881 || (c < 69942
                    ? (c >= 69888 && c <= 69940)
                    : c <= 69951)))))))))
          : (c <= 69959 || (c < 70459
            ? (c < 70282
              ? (c < 70108
                ? (c < 70016
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70003)
                    : c <= 70006)
                  : (c <= 70084 || (c < 70094
                    ? (c >= 70089 && c <= 70092)
                    : c <= 70106)))
                : (c <= 70108 || (c < 70206
                  ? (c < 70163
                    ? (c >= 70144 && c <= 70161)
                    : c <= 70199)
                  : (c <= 70206 || (c < 70280
                    ? (c >= 70272 && c <= 70278)
                    : c <= 70280)))))
              : (c <= 70285 || (c < 70405
                ? (c < 70320
                  ? (c < 70303
                    ? (c >= 70287 && c <= 70301)
                    : c <= 70312)
                  : (c <= 70378 || (c < 70400
                    ? (c >= 70384 && c <= 70393)
                    : c <= 70403)))
                : (c <= 70412 || (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c < 70453
                    ? (c >= 70450 && c <= 70451)
                    : c <= 70457)))))))
            : (c <= 70468 || (c < 70855
              ? (c < 70502
                ? (c < 70480
                  ? (c < 70475
                    ? (c >= 70471 && c <= 70472)
                    : c <= 70477)
                  : (c <= 70480 || (c < 70493
                    ? c == 70487
                    : c <= 70499)))
                : (c <= 70508 || (c < 70736
                  ? (c < 70656
                    ? (c >= 70512 && c <= 70516)
                    : c <= 70730)
                  : (c <= 70745 || (c < 70784
                    ? (c >= 70750 && c <= 70753)
                    : c <= 70853)))))
              : (c <= 70855 || (c < 71236
                ? (c < 71096
                  ? (c < 71040
                    ? (c >= 70864 && c <= 70873)
                    : c <= 71093)
                  : (c <= 71104 || (c < 71168
                    ? (c >= 71128 && c <= 71133)
                    : c <= 71232)))
                : (c <= 71236 || (c < 71360
                  ? (c < 71296
                    ? (c >= 71248 && c <= 71257)
                    : c <= 71352)
                  : (c <= 71369 || (c >= 71424 && c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_28(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'c'
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'a'
                    ? c == '_'
                    : c <= 'a')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_29(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'e'
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'a'
                    ? c == '_'
                    : c <= 'c')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_30(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'f'
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'a'
                    ? c == '_'
                    : c <= 'd')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_31(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'g'
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'a'
                    ? c == '_'
                    : c <= 'e')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_32(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'h'
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'a'
                    ? c == '_'
                    : c <= 'f')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_33(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'i'
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'a'
                    ? c == '_'
                    : c <= 'g')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_34(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'j'
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'a'
                    ? c == '_'
                    : c <= 'h')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_35(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'm'
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'a'
                    ? c == '_'
                    : c <= 'k')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_36(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'o'
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'a'
                    ? c == '_'
                    : c <= 'm')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_37(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'p'
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'a'
                    ? c == '_'
                    : c <= 'n')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_38(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'q'
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'a'
                    ? c == '_'
                    : c <= 'o')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_39(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 's'
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'a'
                    ? c == '_'
                    : c <= 'q')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_40(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 't'
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'a'
                    ? c == '_'
                    : c <= 'r')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_41(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'u'
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'a'
                    ? c == '_'
                    : c <= 's')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_42(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'v'
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'a'
                    ? c == '_'
                    : c <= 't')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_43(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'y'
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'a'
                    ? c == '_'
                    : c <= 'w')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_44(int32_t c) {
  return (c < 43616
    ? (c < 3782
      ? (c < 2741
        ? (c < 2042
          ? (c < 931
            ? (c < 248
              ? (c < 170
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'a'
                    ? c == '_'
                    : c <= 'y')))
                : (c <= 170 || (c < 186
                  ? (c < 183
                    ? c == 181
                    : c <= 183)
                  : (c <= 186 || (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)))))
              : (c <= 705 || (c < 886
                ? (c < 748
                  ? (c < 736
                    ? (c >= 710 && c <= 721)
                    : c <= 740)
                  : (c <= 748 || (c < 768
                    ? c == 750
                    : c <= 884)))
                : (c <= 887 || (c < 902
                  ? (c < 895
                    ? (c >= 891 && c <= 893)
                    : c <= 895)
                  : (c <= 906 || (c < 910
                    ? c == 908
                    : c <= 929)))))))
            : (c <= 1013 || (c < 1488
              ? (c < 1376
                ? (c < 1162
                  ? (c < 1155
                    ? (c >= 1015 && c <= 1153)
                    : c <= 1159)
                  : (c <= 1327 || (c < 1369
                    ? (c >= 1329 && c <= 1366)
                    : c <= 1369)))
                : (c <= 1416 || (c < 1473
                  ? (c < 1471
                    ? (c >= 1425 && c <= 1469)
                    : c <= 1471)
                  : (c <= 1474 || (c < 1479
                    ? (c >= 1476 && c <= 1477)
                    : c <= 1479)))))
              : (c <= 1514 || (c < 1759
                ? (c < 1568
                  ? (c < 1552
                    ? (c >= 1519 && c <= 1522)
                    : c <= 1562)
                  : (c <= 1641 || (c < 1749
                    ? (c >= 1646 && c <= 1747)
                    : c <= 1756)))
                : (c <= 1768 || (c < 1808
                  ? (c < 1791
                    ? (c >= 1770 && c <= 1788)
                    : c <= 1791)
                  : (c <= 1866 || (c < 1984
                    ? (c >= 1869 && c <= 1969)
                    : c <= 2037)))))))))
          : (c <= 2042 || (c < 2556
            ? (c < 2447
              ? (c < 2185
                ? (c < 2112
                  ? (c < 2048
                    ? c == 2045
                    : c <= 2093)
                  : (c <= 2139 || (c < 2160
                    ? (c >= 2144 && c <= 2154)
                    : c <= 2183)))
                : (c <= 2190 || (c < 2406
                  ? (c < 2275
                    ? (c >= 2200 && c <= 2273)
                    : c <= 2403)
                  : (c <= 2415 || (c < 2437
                    ? (c >= 2417 && c <= 2435)
                    : c <= 2444)))))
              : (c <= 2448 || (c < 2503
                ? (c < 2482
                  ? (c < 2474
                    ? (c >= 2451 && c <= 2472)
                    : c <= 2480)
                  : (c <= 2482 || (c < 2492
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2500)))
                : (c <= 2504 || (c < 2524
                  ? (c < 2519
                    ? (c >= 2507 && c <= 2510)
                    : c <= 2519)
                  : (c <= 2525 || (c < 2534
                    ? (c >= 2527 && c <= 2531)
                    : c <= 2545)))))))
            : (c <= 2556 || (c < 2631
              ? (c < 2602
                ? (c < 2565
                  ? (c < 2561
                    ? c == 2558
                    : c <= 2563)
                  : (c <= 2570 || (c < 2579
                    ? (c >= 2575 && c <= 2576)
                    : c <= 2600)))
                : (c <= 2608 || (c < 2616
                  ? (c < 2613
                    ? (c >= 2610 && c <= 2611)
                    : c <= 2614)
                  : (c <= 2617 || (c < 2622
                    ? c == 2620
                    : c <= 2626)))))
              : (c <= 2632 || (c < 2689
                ? (c < 2649
                  ? (c < 2641
                    ? (c >= 2635 && c <= 2637)
                    : c <= 2641)
                  : (c <= 2652 || (c < 2662
                    ? c == 2654
                    : c <= 2677)))
                : (c <= 2691 || (c < 2707
                  ? (c < 2703
                    ? (c >= 2693 && c <= 2701)
                    : c <= 2705)
                  : (c <= 2728 || (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)))))))))))
        : (c <= 2745 || (c < 3165
          ? (c < 2949
            ? (c < 2858
              ? (c < 2790
                ? (c < 2763
                  ? (c < 2759
                    ? (c >= 2748 && c <= 2757)
                    : c <= 2761)
                  : (c <= 2765 || (c < 2784
                    ? c == 2768
                    : c <= 2787)))
                : (c <= 2799 || (c < 2821
                  ? (c < 2817
                    ? (c >= 2809 && c <= 2815)
                    : c <= 2819)
                  : (c <= 2828 || (c < 2835
                    ? (c >= 2831 && c <= 2832)
                    : c <= 2856)))))
              : (c <= 2864 || (c < 2901
                ? (c < 2876
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2884 || (c < 2891
                    ? (c >= 2887 && c <= 2888)
                    : c <= 2893)))
                : (c <= 2903 || (c < 2918
                  ? (c < 2911
                    ? (c >= 2908 && c <= 2909)
                    : c <= 2915)
                  : (c <= 2927 || (c < 2946
                    ? c == 2929
                    : c <= 2947)))))))
            : (c <= 2954 || (c < 3024
              ? (c < 2979
                ? (c < 2969
                  ? (c < 2962
                    ? (c >= 2958 && c <= 2960)
                    : c <= 2965)
                  : (c <= 2970 || (c < 2974
                    ? c == 2972
                    : c <= 2975)))
                : (c <= 2980 || (c < 3006
                  ? (c < 2990
                    ? (c >= 2984 && c <= 2986)
                    : c <= 3001)
                  : (c <= 3010 || (c < 3018
                    ? (c >= 3014 && c <= 3016)
                    : c <= 3021)))))
              : (c <= 3024 || (c < 3114
                ? (c < 3072
                  ? (c < 3046
                    ? c == 3031
                    : c <= 3055)
                  : (c <= 3084 || (c < 3090
                    ? (c >= 3086 && c <= 3088)
                    : c <= 3112)))
                : (c <= 3129 || (c < 3146
                  ? (c < 3142
                    ? (c >= 3132 && c <= 3140)
                    : c <= 3144)
                  : (c <= 3149 || (c < 3160
                    ? (c >= 3157 && c <= 3158)
                    : c <= 3162)))))))))
          : (c <= 3165 || (c < 3430
            ? (c < 3285
              ? (c < 3218
                ? (c < 3200
                  ? (c < 3174
                    ? (c >= 3168 && c <= 3171)
                    : c <= 3183)
                  : (c <= 3203 || (c < 3214
                    ? (c >= 3205 && c <= 3212)
                    : c <= 3216)))
                : (c <= 3240 || (c < 3260
                  ? (c < 3253
                    ? (c >= 3242 && c <= 3251)
                    : c <= 3257)
                  : (c <= 3268 || (c < 3274
                    ? (c >= 3270 && c <= 3272)
                    : c <= 3277)))))
              : (c <= 3286 || (c < 3342
                ? (c < 3302
                  ? (c < 3296
                    ? (c >= 3293 && c <= 3294)
                    : c <= 3299)
                  : (c <= 3311 || (c < 3328
                    ? (c >= 3313 && c <= 3314)
                    : c <= 3340)))
                : (c <= 3344 || (c < 3402
                  ? (c < 3398
                    ? (c >= 3346 && c <= 3396)
                    : c <= 3400)
                  : (c <= 3406 || (c < 3423
                    ? (c >= 3412 && c <= 3415)
                    : c <= 3427)))))))
            : (c <= 3439 || (c < 3558
              ? (c < 3517
                ? (c < 3461
                  ? (c < 3457
                    ? (c >= 3450 && c <= 3455)
                    : c <= 3459)
                  : (c <= 3478 || (c < 3507
                    ? (c >= 3482 && c <= 3505)
                    : c <= 3515)))
                : (c <= 3517 || (c < 3535
                  ? (c < 3530
                    ? (c >= 3520 && c <= 3526)
                    : c <= 3530)
                  : (c <= 3540 || (c < 3544
                    ? c == 3542
                    : c <= 3551)))))
              : (c <= 3567 || (c < 3716
                ? (c < 3648
                  ? (c < 3585
                    ? (c >= 3570 && c <= 3571)
                    : c <= 3642)
                  : (c <= 3662 || (c < 3713
                    ? (c >= 3664 && c <= 3673)
                    : c <= 3714)))
                : (c <= 3716 || (c < 3749
                  ? (c < 3724
                    ? (c >= 3718 && c <= 3722)
                    : c <= 3747)
                  : (c <= 3749 || (c < 3776
                    ? (c >= 3751 && c <= 3773)
                    : c <= 3780)))))))))))))
      : (c <= 3782 || (c < 8025
        ? (c < 5888
          ? (c < 4688
            ? (c < 3953
              ? (c < 3872
                ? (c < 3804
                  ? (c < 3792
                    ? (c >= 3784 && c <= 3789)
                    : c <= 3801)
                  : (c <= 3807 || (c < 3864
                    ? c == 3840
                    : c <= 3865)))
                : (c <= 3881 || (c < 3897
                  ? (c < 3895
                    ? c == 3893
                    : c <= 3895)
                  : (c <= 3897 || (c < 3913
                    ? (c >= 3902 && c <= 3911)
                    : c <= 3948)))))
              : (c <= 3972 || (c < 4256
                ? (c < 4038
                  ? (c < 3993
                    ? (c >= 3974 && c <= 3991)
                    : c <= 4028)
                  : (c <= 4038 || (c < 4176
                    ? (c >= 4096 && c <= 4169)
                    : c <= 4253)))
                : (c <= 4293 || (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)))))))
            : (c <= 4694 || (c < 4882
              ? (c < 4786
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c < 4752
                    ? (c >= 4746 && c <= 4749)
                    : c <= 4784)))
                : (c <= 4789 || (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)))))
              : (c <= 4885 || (c < 5112
                ? (c < 4969
                  ? (c < 4957
                    ? (c >= 4888 && c <= 4954)
                    : c <= 4959)
                  : (c <= 4977 || (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)))
                : (c <= 5117 || (c < 5761
                  ? (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)
                  : (c <= 5786 || (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)))))))))
          : (c <= 5909 || (c < 6688
            ? (c < 6176
              ? (c < 6016
                ? (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5940)
                    : c <= 5971)
                  : (c <= 5996 || (c < 6002
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6003)))
                : (c <= 6099 || (c < 6112
                  ? (c < 6108
                    ? c == 6103
                    : c <= 6109)
                  : (c <= 6121 || (c < 6159
                    ? (c >= 6155 && c <= 6157)
                    : c <= 6169)))))
              : (c <= 6264 || (c < 6470
                ? (c < 6400
                  ? (c < 6320
                    ? (c >= 6272 && c <= 6314)
                    : c <= 6389)
                  : (c <= 6430 || (c < 6448
                    ? (c >= 6432 && c <= 6443)
                    : c <= 6459)))
                : (c <= 6509 || (c < 6576
                  ? (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)
                  : (c <= 6601 || (c < 6656
                    ? (c >= 6608 && c <= 6618)
                    : c <= 6683)))))))
            : (c <= 6750 || (c < 7232
              ? (c < 6847
                ? (c < 6800
                  ? (c < 6783
                    ? (c >= 6752 && c <= 6780)
                    : c <= 6793)
                  : (c <= 6809 || (c < 6832
                    ? c == 6823
                    : c <= 6845)))
                : (c <= 6862 || (c < 7019
                  ? (c < 6992
                    ? (c >= 6912 && c <= 6988)
                    : c <= 7001)
                  : (c <= 7027 || (c < 7168
                    ? (c >= 7040 && c <= 7155)
                    : c <= 7223)))))
              : (c <= 7241 || (c < 7380
                ? (c < 7312
                  ? (c < 7296
                    ? (c >= 7245 && c <= 7293)
                    : c <= 7304)
                  : (c <= 7354 || (c < 7376
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7378)))
                : (c <= 7418 || (c < 7968
                  ? (c < 7960
                    ? (c >= 7424 && c <= 7957)
                    : c <= 7965)
                  : (c <= 8005 || (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)))))))))))
        : (c <= 8025 || (c < 11720
          ? (c < 8458
            ? (c < 8178
              ? (c < 8126
                ? (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8061 || (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)))
                : (c <= 8126 || (c < 8144
                  ? (c < 8134
                    ? (c >= 8130 && c <= 8132)
                    : c <= 8140)
                  : (c <= 8147 || (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)))))
              : (c <= 8180 || (c < 8336
                ? (c < 8276
                  ? (c < 8255
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8256)
                  : (c <= 8276 || (c < 8319
                    ? c == 8305
                    : c <= 8319)))
                : (c <= 8348 || (c < 8421
                  ? (c < 8417
                    ? (c >= 8400 && c <= 8412)
                    : c <= 8417)
                  : (c <= 8432 || (c < 8455
                    ? c == 8450
                    : c <= 8455)))))))
            : (c <= 8467 || (c < 11499
              ? (c < 8490
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || (c < 8488
                    ? c == 8486
                    : c <= 8488)))
                : (c <= 8505 || (c < 8526
                  ? (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)
                  : (c <= 8526 || (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)))))
              : (c <= 11507 || (c < 11647
                ? (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)))
                : (c <= 11670 || (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)))))))))
          : (c <= 11726 || (c < 42623
            ? (c < 12540
              ? (c < 12337
                ? (c < 11744
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 11775 || (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12335)))
                : (c <= 12341 || (c < 12441
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12442 || (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)))))
              : (c <= 12543 || (c < 19968
                ? (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c < 13312
                    ? (c >= 12784 && c <= 12799)
                    : c <= 19903)))
                : (c <= 42124 || (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42539 || (c < 42612
                    ? (c >= 42560 && c <= 42607)
                    : c <= 42621)))))))
            : (c <= 42737 || (c < 43232
              ? (c < 42965
                ? (c < 42891
                  ? (c < 42786
                    ? (c >= 42775 && c <= 42783)
                    : c <= 42888)
                  : (c <= 42954 || (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)))
                : (c <= 42969 || (c < 43072
                  ? (c < 43052
                    ? (c >= 42994 && c <= 43047)
                    : c <= 43052)
                  : (c <= 43123 || (c < 43216
                    ? (c >= 43136 && c <= 43205)
                    : c <= 43225)))))
              : (c <= 43255 || (c < 43471
                ? (c < 43312
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43309)
                  : (c <= 43347 || (c < 43392
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43456)))
                : (c <= 43481 || (c < 43584
                  ? (c < 43520
                    ? (c >= 43488 && c <= 43518)
                    : c <= 43574)
                  : (c <= 43597 || (c >= 43600 && c <= 43609)))))))))))))))
    : (c <= 43638 || (c < 71453
      ? (c < 67639
        ? (c < 65345
          ? (c < 64312
            ? (c < 43888
              ? (c < 43785
                ? (c < 43744
                  ? (c < 43739
                    ? (c >= 43642 && c <= 43714)
                    : c <= 43741)
                  : (c <= 43759 || (c < 43777
                    ? (c >= 43762 && c <= 43766)
                    : c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c < 43868
                    ? (c >= 43824 && c <= 43866)
                    : c <= 43881)))))
              : (c <= 44010 || (c < 63744
                ? (c < 44032
                  ? (c < 44016
                    ? (c >= 44012 && c <= 44013)
                    : c <= 44025)
                  : (c <= 55203 || (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || (c < 64298
                    ? (c >= 64285 && c <= 64296)
                    : c <= 64310)))))))
            : (c <= 64316 || (c < 65075
              ? (c < 64612
                ? (c < 64323
                  ? (c < 64320
                    ? c == 64318
                    : c <= 64321)
                  : (c <= 64324 || (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)))
                : (c <= 64829 || (c < 65008
                  ? (c < 64914
                    ? (c >= 64848 && c <= 64911)
                    : c <= 64967)
                  : (c <= 65017 || (c < 65056
                    ? (c >= 65024 && c <= 65039)
                    : c <= 65071)))))
              : (c <= 65076 || (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65101 && c <= 65103)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65296
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65305 || (c < 65343
                    ? (c >= 65313 && c <= 65338)
                    : c <= 65343)))))))))
          : (c <= 65370 || (c < 66513
            ? (c < 65664
              ? (c < 65536
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65382 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c < 65498
                    ? (c >= 65490 && c <= 65495)
                    : c <= 65500)))
                : (c <= 65547 || (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c < 65616
                    ? (c >= 65599 && c <= 65613)
                    : c <= 65629)))))
              : (c <= 65786 || (c < 66304
                ? (c < 66176
                  ? (c < 66045
                    ? (c >= 65856 && c <= 65908)
                    : c <= 66045)
                  : (c <= 66204 || (c < 66272
                    ? (c >= 66208 && c <= 66256)
                    : c <= 66272)))
                : (c <= 66335 || (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66426)
                  : (c <= 66461 || (c < 66504
                    ? (c >= 66464 && c <= 66499)
                    : c <= 66511)))))))
            : (c <= 66517 || (c < 66979
              ? (c < 66864
                ? (c < 66736
                  ? (c < 66720
                    ? (c >= 66560 && c <= 66717)
                    : c <= 66729)
                  : (c <= 66771 || (c < 66816
                    ? (c >= 66776 && c <= 66811)
                    : c <= 66855)))
                : (c <= 66915 || (c < 66956
                  ? (c < 66940
                    ? (c >= 66928 && c <= 66938)
                    : c <= 66954)
                  : (c <= 66962 || (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)))))
              : (c <= 66993 || (c < 67456
                ? (c < 67072
                  ? (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)
                  : (c <= 67382 || (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)))
                : (c <= 67461 || (c < 67584
                  ? (c < 67506
                    ? (c >= 67463 && c <= 67504)
                    : c <= 67514)
                  : (c <= 67589 || (c < 67594
                    ? c == 67592
                    : c <= 67637)))))))))))
        : (c <= 67640 || (c < 69956
          ? (c < 68448
            ? (c < 68101
              ? (c < 67828
                ? (c < 67680
                  ? (c < 67647
                    ? c == 67644
                    : c <= 67669)
                  : (c <= 67702 || (c < 67808
                    ? (c >= 67712 && c <= 67742)
                    : c <= 67826)))
                : (c <= 67829 || (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c < 68096
                    ? (c >= 68030 && c <= 68031)
                    : c <= 68099)))))
              : (c <= 68102 || (c < 68192
                ? (c < 68121
                  ? (c < 68117
                    ? (c >= 68108 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c < 68159
                    ? (c >= 68152 && c <= 68154)
                    : c <= 68159)))
                : (c <= 68220 || (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68326 || (c < 68416
                    ? (c >= 68352 && c <= 68405)
                    : c <= 68437)))))))
            : (c <= 68466 || (c < 69424
              ? (c < 68912
                ? (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c < 68864
                    ? (c >= 68800 && c <= 68850)
                    : c <= 68903)))
                : (c <= 68921 || (c < 69296
                  ? (c < 69291
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69292)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))))
              : (c <= 69456 || (c < 69759
                ? (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69509)
                    : c <= 69572)
                  : (c <= 69622 || (c < 69734
                    ? (c >= 69632 && c <= 69702)
                    : c <= 69749)))
                : (c <= 69818 || (c < 69872
                  ? (c < 69840
                    ? c == 69826
                    : c <= 69864)
                  : (c <= 69881 || (c < 69942
                    ? (c >= 69888 && c <= 69940)
                    : c <= 69951)))))))))
          : (c <= 69959 || (c < 70459
            ? (c < 70282
              ? (c < 70108
                ? (c < 70016
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70003)
                    : c <= 70006)
                  : (c <= 70084 || (c < 70094
                    ? (c >= 70089 && c <= 70092)
                    : c <= 70106)))
                : (c <= 70108 || (c < 70206
                  ? (c < 70163
                    ? (c >= 70144 && c <= 70161)
                    : c <= 70199)
                  : (c <= 70206 || (c < 70280
                    ? (c >= 70272 && c <= 70278)
                    : c <= 70280)))))
              : (c <= 70285 || (c < 70405
                ? (c < 70320
                  ? (c < 70303
                    ? (c >= 70287 && c <= 70301)
                    : c <= 70312)
                  : (c <= 70378 || (c < 70400
                    ? (c >= 70384 && c <= 70393)
                    : c <= 70403)))
                : (c <= 70412 || (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c < 70453
                    ? (c >= 70450 && c <= 70451)
                    : c <= 70457)))))))
            : (c <= 70468 || (c < 70855
              ? (c < 70502
                ? (c < 70480
                  ? (c < 70475
                    ? (c >= 70471 && c <= 70472)
                    : c <= 70477)
                  : (c <= 70480 || (c < 70493
                    ? c == 70487
                    : c <= 70499)))
                : (c <= 70508 || (c < 70736
                  ? (c < 70656
                    ? (c >= 70512 && c <= 70516)
                    : c <= 70730)
                  : (c <= 70745 || (c < 70784
                    ? (c >= 70750 && c <= 70753)
                    : c <= 70853)))))
              : (c <= 70855 || (c < 71236
                ? (c < 71096
                  ? (c < 71040
                    ? (c >= 70864 && c <= 70873)
                    : c <= 71093)
                  : (c <= 71104 || (c < 71168
                    ? (c >= 71128 && c <= 71133)
                    : c <= 71232)))
                : (c <= 71236 || (c < 71360
                  ? (c < 71296
                    ? (c >= 71248 && c <= 71257)
                    : c <= 71352)
                  : (c <= 71369 || (c >= 71424 && c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_45(int32_t c) {
  return (c < 43616
    ? (c < 3782
      ? (c < 2741
        ? (c < 2042
          ? (c < 931
            ? (c < 248
              ? (c < 170
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'b'
                    ? c == '_'
                    : c <= 'z')))
                : (c <= 170 || (c < 186
                  ? (c < 183
                    ? c == 181
                    : c <= 183)
                  : (c <= 186 || (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)))))
              : (c <= 705 || (c < 886
                ? (c < 748
                  ? (c < 736
                    ? (c >= 710 && c <= 721)
                    : c <= 740)
                  : (c <= 748 || (c < 768
                    ? c == 750
                    : c <= 884)))
                : (c <= 887 || (c < 902
                  ? (c < 895
                    ? (c >= 891 && c <= 893)
                    : c <= 895)
                  : (c <= 906 || (c < 910
                    ? c == 908
                    : c <= 929)))))))
            : (c <= 1013 || (c < 1488
              ? (c < 1376
                ? (c < 1162
                  ? (c < 1155
                    ? (c >= 1015 && c <= 1153)
                    : c <= 1159)
                  : (c <= 1327 || (c < 1369
                    ? (c >= 1329 && c <= 1366)
                    : c <= 1369)))
                : (c <= 1416 || (c < 1473
                  ? (c < 1471
                    ? (c >= 1425 && c <= 1469)
                    : c <= 1471)
                  : (c <= 1474 || (c < 1479
                    ? (c >= 1476 && c <= 1477)
                    : c <= 1479)))))
              : (c <= 1514 || (c < 1759
                ? (c < 1568
                  ? (c < 1552
                    ? (c >= 1519 && c <= 1522)
                    : c <= 1562)
                  : (c <= 1641 || (c < 1749
                    ? (c >= 1646 && c <= 1747)
                    : c <= 1756)))
                : (c <= 1768 || (c < 1808
                  ? (c < 1791
                    ? (c >= 1770 && c <= 1788)
                    : c <= 1791)
                  : (c <= 1866 || (c < 1984
                    ? (c >= 1869 && c <= 1969)
                    : c <= 2037)))))))))
          : (c <= 2042 || (c < 2556
            ? (c < 2447
              ? (c < 2185
                ? (c < 2112
                  ? (c < 2048
                    ? c == 2045
                    : c <= 2093)
                  : (c <= 2139 || (c < 2160
                    ? (c >= 2144 && c <= 2154)
                    : c <= 2183)))
                : (c <= 2190 || (c < 2406
                  ? (c < 2275
                    ? (c >= 2200 && c <= 2273)
                    : c <= 2403)
                  : (c <= 2415 || (c < 2437
                    ? (c >= 2417 && c <= 2435)
                    : c <= 2444)))))
              : (c <= 2448 || (c < 2503
                ? (c < 2482
                  ? (c < 2474
                    ? (c >= 2451 && c <= 2472)
                    : c <= 2480)
                  : (c <= 2482 || (c < 2492
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2500)))
                : (c <= 2504 || (c < 2524
                  ? (c < 2519
                    ? (c >= 2507 && c <= 2510)
                    : c <= 2519)
                  : (c <= 2525 || (c < 2534
                    ? (c >= 2527 && c <= 2531)
                    : c <= 2545)))))))
            : (c <= 2556 || (c < 2631
              ? (c < 2602
                ? (c < 2565
                  ? (c < 2561
                    ? c == 2558
                    : c <= 2563)
                  : (c <= 2570 || (c < 2579
                    ? (c >= 2575 && c <= 2576)
                    : c <= 2600)))
                : (c <= 2608 || (c < 2616
                  ? (c < 2613
                    ? (c >= 2610 && c <= 2611)
                    : c <= 2614)
                  : (c <= 2617 || (c < 2622
                    ? c == 2620
                    : c <= 2626)))))
              : (c <= 2632 || (c < 2689
                ? (c < 2649
                  ? (c < 2641
                    ? (c >= 2635 && c <= 2637)
                    : c <= 2641)
                  : (c <= 2652 || (c < 2662
                    ? c == 2654
                    : c <= 2677)))
                : (c <= 2691 || (c < 2707
                  ? (c < 2703
                    ? (c >= 2693 && c <= 2701)
                    : c <= 2705)
                  : (c <= 2728 || (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)))))))))))
        : (c <= 2745 || (c < 3165
          ? (c < 2949
            ? (c < 2858
              ? (c < 2790
                ? (c < 2763
                  ? (c < 2759
                    ? (c >= 2748 && c <= 2757)
                    : c <= 2761)
                  : (c <= 2765 || (c < 2784
                    ? c == 2768
                    : c <= 2787)))
                : (c <= 2799 || (c < 2821
                  ? (c < 2817
                    ? (c >= 2809 && c <= 2815)
                    : c <= 2819)
                  : (c <= 2828 || (c < 2835
                    ? (c >= 2831 && c <= 2832)
                    : c <= 2856)))))
              : (c <= 2864 || (c < 2901
                ? (c < 2876
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2884 || (c < 2891
                    ? (c >= 2887 && c <= 2888)
                    : c <= 2893)))
                : (c <= 2903 || (c < 2918
                  ? (c < 2911
                    ? (c >= 2908 && c <= 2909)
                    : c <= 2915)
                  : (c <= 2927 || (c < 2946
                    ? c == 2929
                    : c <= 2947)))))))
            : (c <= 2954 || (c < 3024
              ? (c < 2979
                ? (c < 2969
                  ? (c < 2962
                    ? (c >= 2958 && c <= 2960)
                    : c <= 2965)
                  : (c <= 2970 || (c < 2974
                    ? c == 2972
                    : c <= 2975)))
                : (c <= 2980 || (c < 3006
                  ? (c < 2990
                    ? (c >= 2984 && c <= 2986)
                    : c <= 3001)
                  : (c <= 3010 || (c < 3018
                    ? (c >= 3014 && c <= 3016)
                    : c <= 3021)))))
              : (c <= 3024 || (c < 3114
                ? (c < 3072
                  ? (c < 3046
                    ? c == 3031
                    : c <= 3055)
                  : (c <= 3084 || (c < 3090
                    ? (c >= 3086 && c <= 3088)
                    : c <= 3112)))
                : (c <= 3129 || (c < 3146
                  ? (c < 3142
                    ? (c >= 3132 && c <= 3140)
                    : c <= 3144)
                  : (c <= 3149 || (c < 3160
                    ? (c >= 3157 && c <= 3158)
                    : c <= 3162)))))))))
          : (c <= 3165 || (c < 3430
            ? (c < 3285
              ? (c < 3218
                ? (c < 3200
                  ? (c < 3174
                    ? (c >= 3168 && c <= 3171)
                    : c <= 3183)
                  : (c <= 3203 || (c < 3214
                    ? (c >= 3205 && c <= 3212)
                    : c <= 3216)))
                : (c <= 3240 || (c < 3260
                  ? (c < 3253
                    ? (c >= 3242 && c <= 3251)
                    : c <= 3257)
                  : (c <= 3268 || (c < 3274
                    ? (c >= 3270 && c <= 3272)
                    : c <= 3277)))))
              : (c <= 3286 || (c < 3342
                ? (c < 3302
                  ? (c < 3296
                    ? (c >= 3293 && c <= 3294)
                    : c <= 3299)
                  : (c <= 3311 || (c < 3328
                    ? (c >= 3313 && c <= 3314)
                    : c <= 3340)))
                : (c <= 3344 || (c < 3402
                  ? (c < 3398
                    ? (c >= 3346 && c <= 3396)
                    : c <= 3400)
                  : (c <= 3406 || (c < 3423
                    ? (c >= 3412 && c <= 3415)
                    : c <= 3427)))))))
            : (c <= 3439 || (c < 3558
              ? (c < 3517
                ? (c < 3461
                  ? (c < 3457
                    ? (c >= 3450 && c <= 3455)
                    : c <= 3459)
                  : (c <= 3478 || (c < 3507
                    ? (c >= 3482 && c <= 3505)
                    : c <= 3515)))
                : (c <= 3517 || (c < 3535
                  ? (c < 3530
                    ? (c >= 3520 && c <= 3526)
                    : c <= 3530)
                  : (c <= 3540 || (c < 3544
                    ? c == 3542
                    : c <= 3551)))))
              : (c <= 3567 || (c < 3716
                ? (c < 3648
                  ? (c < 3585
                    ? (c >= 3570 && c <= 3571)
                    : c <= 3642)
                  : (c <= 3662 || (c < 3713
                    ? (c >= 3664 && c <= 3673)
                    : c <= 3714)))
                : (c <= 3716 || (c < 3749
                  ? (c < 3724
                    ? (c >= 3718 && c <= 3722)
                    : c <= 3747)
                  : (c <= 3749 || (c < 3776
                    ? (c >= 3751 && c <= 3773)
                    : c <= 3780)))))))))))))
      : (c <= 3782 || (c < 8025
        ? (c < 5888
          ? (c < 4688
            ? (c < 3953
              ? (c < 3872
                ? (c < 3804
                  ? (c < 3792
                    ? (c >= 3784 && c <= 3789)
                    : c <= 3801)
                  : (c <= 3807 || (c < 3864
                    ? c == 3840
                    : c <= 3865)))
                : (c <= 3881 || (c < 3897
                  ? (c < 3895
                    ? c == 3893
                    : c <= 3895)
                  : (c <= 3897 || (c < 3913
                    ? (c >= 3902 && c <= 3911)
                    : c <= 3948)))))
              : (c <= 3972 || (c < 4256
                ? (c < 4038
                  ? (c < 3993
                    ? (c >= 3974 && c <= 3991)
                    : c <= 4028)
                  : (c <= 4038 || (c < 4176
                    ? (c >= 4096 && c <= 4169)
                    : c <= 4253)))
                : (c <= 4293 || (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)))))))
            : (c <= 4694 || (c < 4882
              ? (c < 4786
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c < 4752
                    ? (c >= 4746 && c <= 4749)
                    : c <= 4784)))
                : (c <= 4789 || (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)))))
              : (c <= 4885 || (c < 5112
                ? (c < 4969
                  ? (c < 4957
                    ? (c >= 4888 && c <= 4954)
                    : c <= 4959)
                  : (c <= 4977 || (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)))
                : (c <= 5117 || (c < 5761
                  ? (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)
                  : (c <= 5786 || (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)))))))))
          : (c <= 5909 || (c < 6688
            ? (c < 6176
              ? (c < 6016
                ? (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5940)
                    : c <= 5971)
                  : (c <= 5996 || (c < 6002
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6003)))
                : (c <= 6099 || (c < 6112
                  ? (c < 6108
                    ? c == 6103
                    : c <= 6109)
                  : (c <= 6121 || (c < 6159
                    ? (c >= 6155 && c <= 6157)
                    : c <= 6169)))))
              : (c <= 6264 || (c < 6470
                ? (c < 6400
                  ? (c < 6320
                    ? (c >= 6272 && c <= 6314)
                    : c <= 6389)
                  : (c <= 6430 || (c < 6448
                    ? (c >= 6432 && c <= 6443)
                    : c <= 6459)))
                : (c <= 6509 || (c < 6576
                  ? (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)
                  : (c <= 6601 || (c < 6656
                    ? (c >= 6608 && c <= 6618)
                    : c <= 6683)))))))
            : (c <= 6750 || (c < 7232
              ? (c < 6847
                ? (c < 6800
                  ? (c < 6783
                    ? (c >= 6752 && c <= 6780)
                    : c <= 6793)
                  : (c <= 6809 || (c < 6832
                    ? c == 6823
                    : c <= 6845)))
                : (c <= 6862 || (c < 7019
                  ? (c < 6992
                    ? (c >= 6912 && c <= 6988)
                    : c <= 7001)
                  : (c <= 7027 || (c < 7168
                    ? (c >= 7040 && c <= 7155)
                    : c <= 7223)))))
              : (c <= 7241 || (c < 7380
                ? (c < 7312
                  ? (c < 7296
                    ? (c >= 7245 && c <= 7293)
                    : c <= 7304)
                  : (c <= 7354 || (c < 7376
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7378)))
                : (c <= 7418 || (c < 7968
                  ? (c < 7960
                    ? (c >= 7424 && c <= 7957)
                    : c <= 7965)
                  : (c <= 8005 || (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)))))))))))
        : (c <= 8025 || (c < 11720
          ? (c < 8458
            ? (c < 8178
              ? (c < 8126
                ? (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8061 || (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)))
                : (c <= 8126 || (c < 8144
                  ? (c < 8134
                    ? (c >= 8130 && c <= 8132)
                    : c <= 8140)
                  : (c <= 8147 || (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)))))
              : (c <= 8180 || (c < 8336
                ? (c < 8276
                  ? (c < 8255
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8256)
                  : (c <= 8276 || (c < 8319
                    ? c == 8305
                    : c <= 8319)))
                : (c <= 8348 || (c < 8421
                  ? (c < 8417
                    ? (c >= 8400 && c <= 8412)
                    : c <= 8417)
                  : (c <= 8432 || (c < 8455
                    ? c == 8450
                    : c <= 8455)))))))
            : (c <= 8467 || (c < 11499
              ? (c < 8490
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || (c < 8488
                    ? c == 8486
                    : c <= 8488)))
                : (c <= 8505 || (c < 8526
                  ? (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)
                  : (c <= 8526 || (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)))))
              : (c <= 11507 || (c < 11647
                ? (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)))
                : (c <= 11670 || (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)))))))))
          : (c <= 11726 || (c < 42623
            ? (c < 12540
              ? (c < 12337
                ? (c < 11744
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 11775 || (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12335)))
                : (c <= 12341 || (c < 12441
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12442 || (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)))))
              : (c <= 12543 || (c < 19968
                ? (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c < 13312
                    ? (c >= 12784 && c <= 12799)
                    : c <= 19903)))
                : (c <= 42124 || (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42539 || (c < 42612
                    ? (c >= 42560 && c <= 42607)
                    : c <= 42621)))))))
            : (c <= 42737 || (c < 43232
              ? (c < 42965
                ? (c < 42891
                  ? (c < 42786
                    ? (c >= 42775 && c <= 42783)
                    : c <= 42888)
                  : (c <= 42954 || (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)))
                : (c <= 42969 || (c < 43072
                  ? (c < 43052
                    ? (c >= 42994 && c <= 43047)
                    : c <= 43052)
                  : (c <= 43123 || (c < 43216
                    ? (c >= 43136 && c <= 43205)
                    : c <= 43225)))))
              : (c <= 43255 || (c < 43471
                ? (c < 43312
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43309)
                  : (c <= 43347 || (c < 43392
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43456)))
                : (c <= 43481 || (c < 43584
                  ? (c < 43520
                    ? (c >= 43488 && c <= 43518)
                    : c <= 43574)
                  : (c <= 43597 || (c >= 43600 && c <= 43609)))))))))))))))
    : (c <= 43638 || (c < 71453
      ? (c < 67639
        ? (c < 65345
          ? (c < 64312
            ? (c < 43888
              ? (c < 43785
                ? (c < 43744
                  ? (c < 43739
                    ? (c >= 43642 && c <= 43714)
                    : c <= 43741)
                  : (c <= 43759 || (c < 43777
                    ? (c >= 43762 && c <= 43766)
                    : c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c < 43868
                    ? (c >= 43824 && c <= 43866)
                    : c <= 43881)))))
              : (c <= 44010 || (c < 63744
                ? (c < 44032
                  ? (c < 44016
                    ? (c >= 44012 && c <= 44013)
                    : c <= 44025)
                  : (c <= 55203 || (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || (c < 64298
                    ? (c >= 64285 && c <= 64296)
                    : c <= 64310)))))))
            : (c <= 64316 || (c < 65075
              ? (c < 64612
                ? (c < 64323
                  ? (c < 64320
                    ? c == 64318
                    : c <= 64321)
                  : (c <= 64324 || (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)))
                : (c <= 64829 || (c < 65008
                  ? (c < 64914
                    ? (c >= 64848 && c <= 64911)
                    : c <= 64967)
                  : (c <= 65017 || (c < 65056
                    ? (c >= 65024 && c <= 65039)
                    : c <= 65071)))))
              : (c <= 65076 || (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65101 && c <= 65103)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65296
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65305 || (c < 65343
                    ? (c >= 65313 && c <= 65338)
                    : c <= 65343)))))))))
          : (c <= 65370 || (c < 66513
            ? (c < 65664
              ? (c < 65536
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65382 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c < 65498
                    ? (c >= 65490 && c <= 65495)
                    : c <= 65500)))
                : (c <= 65547 || (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c < 65616
                    ? (c >= 65599 && c <= 65613)
                    : c <= 65629)))))
              : (c <= 65786 || (c < 66304
                ? (c < 66176
                  ? (c < 66045
                    ? (c >= 65856 && c <= 65908)
                    : c <= 66045)
                  : (c <= 66204 || (c < 66272
                    ? (c >= 66208 && c <= 66256)
                    : c <= 66272)))
                : (c <= 66335 || (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66426)
                  : (c <= 66461 || (c < 66504
                    ? (c >= 66464 && c <= 66499)
                    : c <= 66511)))))))
            : (c <= 66517 || (c < 66979
              ? (c < 66864
                ? (c < 66736
                  ? (c < 66720
                    ? (c >= 66560 && c <= 66717)
                    : c <= 66729)
                  : (c <= 66771 || (c < 66816
                    ? (c >= 66776 && c <= 66811)
                    : c <= 66855)))
                : (c <= 66915 || (c < 66956
                  ? (c < 66940
                    ? (c >= 66928 && c <= 66938)
                    : c <= 66954)
                  : (c <= 66962 || (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)))))
              : (c <= 66993 || (c < 67456
                ? (c < 67072
                  ? (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)
                  : (c <= 67382 || (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)))
                : (c <= 67461 || (c < 67584
                  ? (c < 67506
                    ? (c >= 67463 && c <= 67504)
                    : c <= 67514)
                  : (c <= 67589 || (c < 67594
                    ? c == 67592
                    : c <= 67637)))))))))))
        : (c <= 67640 || (c < 69956
          ? (c < 68448
            ? (c < 68101
              ? (c < 67828
                ? (c < 67680
                  ? (c < 67647
                    ? c == 67644
                    : c <= 67669)
                  : (c <= 67702 || (c < 67808
                    ? (c >= 67712 && c <= 67742)
                    : c <= 67826)))
                : (c <= 67829 || (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c < 68096
                    ? (c >= 68030 && c <= 68031)
                    : c <= 68099)))))
              : (c <= 68102 || (c < 68192
                ? (c < 68121
                  ? (c < 68117
                    ? (c >= 68108 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c < 68159
                    ? (c >= 68152 && c <= 68154)
                    : c <= 68159)))
                : (c <= 68220 || (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68326 || (c < 68416
                    ? (c >= 68352 && c <= 68405)
                    : c <= 68437)))))))
            : (c <= 68466 || (c < 69424
              ? (c < 68912
                ? (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c < 68864
                    ? (c >= 68800 && c <= 68850)
                    : c <= 68903)))
                : (c <= 68921 || (c < 69296
                  ? (c < 69291
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69292)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))))
              : (c <= 69456 || (c < 69759
                ? (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69509)
                    : c <= 69572)
                  : (c <= 69622 || (c < 69734
                    ? (c >= 69632 && c <= 69702)
                    : c <= 69749)))
                : (c <= 69818 || (c < 69872
                  ? (c < 69840
                    ? c == 69826
                    : c <= 69864)
                  : (c <= 69881 || (c < 69942
                    ? (c >= 69888 && c <= 69940)
                    : c <= 69951)))))))))
          : (c <= 69959 || (c < 70459
            ? (c < 70282
              ? (c < 70108
                ? (c < 70016
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70003)
                    : c <= 70006)
                  : (c <= 70084 || (c < 70094
                    ? (c >= 70089 && c <= 70092)
                    : c <= 70106)))
                : (c <= 70108 || (c < 70206
                  ? (c < 70163
                    ? (c >= 70144 && c <= 70161)
                    : c <= 70199)
                  : (c <= 70206 || (c < 70280
                    ? (c >= 70272 && c <= 70278)
                    : c <= 70280)))))
              : (c <= 70285 || (c < 70405
                ? (c < 70320
                  ? (c < 70303
                    ? (c >= 70287 && c <= 70301)
                    : c <= 70312)
                  : (c <= 70378 || (c < 70400
                    ? (c >= 70384 && c <= 70393)
                    : c <= 70403)))
                : (c <= 70412 || (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c < 70453
                    ? (c >= 70450 && c <= 70451)
                    : c <= 70457)))))))
            : (c <= 70468 || (c < 70855
              ? (c < 70502
                ? (c < 70480
                  ? (c < 70475
                    ? (c >= 70471 && c <= 70472)
                    : c <= 70477)
                  : (c <= 70480 || (c < 70493
                    ? c == 70487
                    : c <= 70499)))
                : (c <= 70508 || (c < 70736
                  ? (c < 70656
                    ? (c >= 70512 && c <= 70516)
                    : c <= 70730)
                  : (c <= 70745 || (c < 70784
                    ? (c >= 70750 && c <= 70753)
                    : c <= 70853)))))
              : (c <= 70855 || (c < 71236
                ? (c < 71096
                  ? (c < 71040
                    ? (c >= 70864 && c <= 70873)
                    : c <= 71093)
                  : (c <= 71104 || (c < 71168
                    ? (c >= 71128 && c <= 71133)
                    : c <= 71232)))
                : (c <= 71236 || (c < 71360
                  ? (c < 71296
                    ? (c >= 71248 && c <= 71257)
                    : c <= 71352)
                  : (c <= 71369 || (c >= 71424 && c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_46(int32_t c) {
  return (c < 43616
    ? (c < 3782
      ? (c < 2748
        ? (c < 2045
          ? (c < 1015
            ? (c < 710
              ? (c < 181
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 170
                    ? (c >= 'a' && c <= 'z')
                    : c <= 170)))
                : (c <= 181 || (c < 192
                  ? (c < 186
                    ? c == 183
                    : c <= 186)
                  : (c <= 214 || (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)))))
              : (c <= 721 || (c < 891
                ? (c < 750
                  ? (c < 748
                    ? (c >= 736 && c <= 740)
                    : c <= 748)
                  : (c <= 750 || (c < 886
                    ? (c >= 768 && c <= 884)
                    : c <= 887)))
                : (c <= 893 || (c < 908
                  ? (c < 902
                    ? c == 895
                    : c <= 906)
                  : (c <= 908 || (c < 931
                    ? (c >= 910 && c <= 929)
                    : c <= 1013)))))))
            : (c <= 1153 || (c < 1519
              ? (c < 1425
                ? (c < 1329
                  ? (c < 1162
                    ? (c >= 1155 && c <= 1159)
                    : c <= 1327)
                  : (c <= 1366 || (c < 1376
                    ? c == 1369
                    : c <= 1416)))
                : (c <= 1469 || (c < 1476
                  ? (c < 1473
                    ? c == 1471
                    : c <= 1474)
                  : (c <= 1477 || (c < 1488
                    ? c == 1479
                    : c <= 1514)))))
              : (c <= 1522 || (c < 1770
                ? (c < 1646
                  ? (c < 1568
                    ? (c >= 1552 && c <= 1562)
                    : c <= 1641)
                  : (c <= 1747 || (c < 1759
                    ? (c >= 1749 && c <= 1756)
                    : c <= 1768)))
                : (c <= 1788 || (c < 1869
                  ? (c < 1808
                    ? c == 1791
                    : c <= 1866)
                  : (c <= 1969 || (c < 2042
                    ? (c >= 1984 && c <= 2037)
                    : c <= 2042)))))))))
          : (c <= 2045 || (c < 2558
            ? (c < 2451
              ? (c < 2200
                ? (c < 2144
                  ? (c < 2112
                    ? (c >= 2048 && c <= 2093)
                    : c <= 2139)
                  : (c <= 2154 || (c < 2185
                    ? (c >= 2160 && c <= 2183)
                    : c <= 2190)))
                : (c <= 2273 || (c < 2417
                  ? (c < 2406
                    ? (c >= 2275 && c <= 2403)
                    : c <= 2415)
                  : (c <= 2435 || (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)))))
              : (c <= 2472 || (c < 2507
                ? (c < 2486
                  ? (c < 2482
                    ? (c >= 2474 && c <= 2480)
                    : c <= 2482)
                  : (c <= 2489 || (c < 2503
                    ? (c >= 2492 && c <= 2500)
                    : c <= 2504)))
                : (c <= 2510 || (c < 2527
                  ? (c < 2524
                    ? c == 2519
                    : c <= 2525)
                  : (c <= 2531 || (c < 2556
                    ? (c >= 2534 && c <= 2545)
                    : c <= 2556)))))))
            : (c <= 2558 || (c < 2635
              ? (c < 2610
                ? (c < 2575
                  ? (c < 2565
                    ? (c >= 2561 && c <= 2563)
                    : c <= 2570)
                  : (c <= 2576 || (c < 2602
                    ? (c >= 2579 && c <= 2600)
                    : c <= 2608)))
                : (c <= 2611 || (c < 2620
                  ? (c < 2616
                    ? (c >= 2613 && c <= 2614)
                    : c <= 2617)
                  : (c <= 2620 || (c < 2631
                    ? (c >= 2622 && c <= 2626)
                    : c <= 2632)))))
              : (c <= 2637 || (c < 2693
                ? (c < 2654
                  ? (c < 2649
                    ? c == 2641
                    : c <= 2652)
                  : (c <= 2654 || (c < 2689
                    ? (c >= 2662 && c <= 2677)
                    : c <= 2691)))
                : (c <= 2701 || (c < 2730
                  ? (c < 2707
                    ? (c >= 2703 && c <= 2705)
                    : c <= 2728)
                  : (c <= 2736 || (c < 2741
                    ? (c >= 2738 && c <= 2739)
                    : c <= 2745)))))))))))
        : (c <= 2757 || (c < 3168
          ? (c < 2958
            ? (c < 2866
              ? (c < 2809
                ? (c < 2768
                  ? (c < 2763
                    ? (c >= 2759 && c <= 2761)
                    : c <= 2765)
                  : (c <= 2768 || (c < 2790
                    ? (c >= 2784 && c <= 2787)
                    : c <= 2799)))
                : (c <= 2815 || (c < 2831
                  ? (c < 2821
                    ? (c >= 2817 && c <= 2819)
                    : c <= 2828)
                  : (c <= 2832 || (c < 2858
                    ? (c >= 2835 && c <= 2856)
                    : c <= 2864)))))
              : (c <= 2867 || (c < 2908
                ? (c < 2887
                  ? (c < 2876
                    ? (c >= 2869 && c <= 2873)
                    : c <= 2884)
                  : (c <= 2888 || (c < 2901
                    ? (c >= 2891 && c <= 2893)
                    : c <= 2903)))
                : (c <= 2909 || (c < 2929
                  ? (c < 2918
                    ? (c >= 2911 && c <= 2915)
                    : c <= 2927)
                  : (c <= 2929 || (c < 2949
                    ? (c >= 2946 && c <= 2947)
                    : c <= 2954)))))))
            : (c <= 2960 || (c < 3031
              ? (c < 2984
                ? (c < 2972
                  ? (c < 2969
                    ? (c >= 2962 && c <= 2965)
                    : c <= 2970)
                  : (c <= 2972 || (c < 2979
                    ? (c >= 2974 && c <= 2975)
                    : c <= 2980)))
                : (c <= 2986 || (c < 3014
                  ? (c < 3006
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3010)
                  : (c <= 3016 || (c < 3024
                    ? (c >= 3018 && c <= 3021)
                    : c <= 3024)))))
              : (c <= 3031 || (c < 3132
                ? (c < 3086
                  ? (c < 3072
                    ? (c >= 3046 && c <= 3055)
                    : c <= 3084)
                  : (c <= 3088 || (c < 3114
                    ? (c >= 3090 && c <= 3112)
                    : c <= 3129)))
                : (c <= 3140 || (c < 3157
                  ? (c < 3146
                    ? (c >= 3142 && c <= 3144)
                    : c <= 3149)
                  : (c <= 3158 || (c < 3165
                    ? (c >= 3160 && c <= 3162)
                    : c <= 3165)))))))))
          : (c <= 3171 || (c < 3450
            ? (c < 3293
              ? (c < 3242
                ? (c < 3205
                  ? (c < 3200
                    ? (c >= 3174 && c <= 3183)
                    : c <= 3203)
                  : (c <= 3212 || (c < 3218
                    ? (c >= 3214 && c <= 3216)
                    : c <= 3240)))
                : (c <= 3251 || (c < 3270
                  ? (c < 3260
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3268)
                  : (c <= 3272 || (c < 3285
                    ? (c >= 3274 && c <= 3277)
                    : c <= 3286)))))
              : (c <= 3294 || (c < 3346
                ? (c < 3313
                  ? (c < 3302
                    ? (c >= 3296 && c <= 3299)
                    : c <= 3311)
                  : (c <= 3314 || (c < 3342
                    ? (c >= 3328 && c <= 3340)
                    : c <= 3344)))
                : (c <= 3396 || (c < 3412
                  ? (c < 3402
                    ? (c >= 3398 && c <= 3400)
                    : c <= 3406)
                  : (c <= 3415 || (c < 3430
                    ? (c >= 3423 && c <= 3427)
                    : c <= 3439)))))))
            : (c <= 3455 || (c < 3570
              ? (c < 3520
                ? (c < 3482
                  ? (c < 3461
                    ? (c >= 3457 && c <= 3459)
                    : c <= 3478)
                  : (c <= 3505 || (c < 3517
                    ? (c >= 3507 && c <= 3515)
                    : c <= 3517)))
                : (c <= 3526 || (c < 3542
                  ? (c < 3535
                    ? c == 3530
                    : c <= 3540)
                  : (c <= 3542 || (c < 3558
                    ? (c >= 3544 && c <= 3551)
                    : c <= 3567)))))
              : (c <= 3571 || (c < 3718
                ? (c < 3664
                  ? (c < 3648
                    ? (c >= 3585 && c <= 3642)
                    : c <= 3662)
                  : (c <= 3673 || (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)))
                : (c <= 3722 || (c < 3751
                  ? (c < 3749
                    ? (c >= 3724 && c <= 3747)
                    : c <= 3749)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))))))))))
      : (c <= 3782 || (c < 8025
        ? (c < 5888
          ? (c < 4688
            ? (c < 3953
              ? (c < 3872
                ? (c < 3804
                  ? (c < 3792
                    ? (c >= 3784 && c <= 3789)
                    : c <= 3801)
                  : (c <= 3807 || (c < 3864
                    ? c == 3840
                    : c <= 3865)))
                : (c <= 3881 || (c < 3897
                  ? (c < 3895
                    ? c == 3893
                    : c <= 3895)
                  : (c <= 3897 || (c < 3913
                    ? (c >= 3902 && c <= 3911)
                    : c <= 3948)))))
              : (c <= 3972 || (c < 4256
                ? (c < 4038
                  ? (c < 3993
                    ? (c >= 3974 && c <= 3991)
                    : c <= 4028)
                  : (c <= 4038 || (c < 4176
                    ? (c >= 4096 && c <= 4169)
                    : c <= 4253)))
                : (c <= 4293 || (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)))))))
            : (c <= 4694 || (c < 4882
              ? (c < 4786
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c < 4752
                    ? (c >= 4746 && c <= 4749)
                    : c <= 4784)))
                : (c <= 4789 || (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)))))
              : (c <= 4885 || (c < 5112
                ? (c < 4969
                  ? (c < 4957
                    ? (c >= 4888 && c <= 4954)
                    : c <= 4959)
                  : (c <= 4977 || (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)))
                : (c <= 5117 || (c < 5761
                  ? (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)
                  : (c <= 5786 || (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)))))))))
          : (c <= 5909 || (c < 6688
            ? (c < 6176
              ? (c < 6016
                ? (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5940)
                    : c <= 5971)
                  : (c <= 5996 || (c < 6002
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6003)))
                : (c <= 6099 || (c < 6112
                  ? (c < 6108
                    ? c == 6103
                    : c <= 6109)
                  : (c <= 6121 || (c < 6159
                    ? (c >= 6155 && c <= 6157)
                    : c <= 6169)))))
              : (c <= 6264 || (c < 6470
                ? (c < 6400
                  ? (c < 6320
                    ? (c >= 6272 && c <= 6314)
                    : c <= 6389)
                  : (c <= 6430 || (c < 6448
                    ? (c >= 6432 && c <= 6443)
                    : c <= 6459)))
                : (c <= 6509 || (c < 6576
                  ? (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)
                  : (c <= 6601 || (c < 6656
                    ? (c >= 6608 && c <= 6618)
                    : c <= 6683)))))))
            : (c <= 6750 || (c < 7232
              ? (c < 6847
                ? (c < 6800
                  ? (c < 6783
                    ? (c >= 6752 && c <= 6780)
                    : c <= 6793)
                  : (c <= 6809 || (c < 6832
                    ? c == 6823
                    : c <= 6845)))
                : (c <= 6862 || (c < 7019
                  ? (c < 6992
                    ? (c >= 6912 && c <= 6988)
                    : c <= 7001)
                  : (c <= 7027 || (c < 7168
                    ? (c >= 7040 && c <= 7155)
                    : c <= 7223)))))
              : (c <= 7241 || (c < 7380
                ? (c < 7312
                  ? (c < 7296
                    ? (c >= 7245 && c <= 7293)
                    : c <= 7304)
                  : (c <= 7354 || (c < 7376
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7378)))
                : (c <= 7418 || (c < 7968
                  ? (c < 7960
                    ? (c >= 7424 && c <= 7957)
                    : c <= 7965)
                  : (c <= 8005 || (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)))))))))))
        : (c <= 8025 || (c < 11720
          ? (c < 8458
            ? (c < 8178
              ? (c < 8126
                ? (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8061 || (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)))
                : (c <= 8126 || (c < 8144
                  ? (c < 8134
                    ? (c >= 8130 && c <= 8132)
                    : c <= 8140)
                  : (c <= 8147 || (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)))))
              : (c <= 8180 || (c < 8336
                ? (c < 8276
                  ? (c < 8255
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8256)
                  : (c <= 8276 || (c < 8319
                    ? c == 8305
                    : c <= 8319)))
                : (c <= 8348 || (c < 8421
                  ? (c < 8417
                    ? (c >= 8400 && c <= 8412)
                    : c <= 8417)
                  : (c <= 8432 || (c < 8455
                    ? c == 8450
                    : c <= 8455)))))))
            : (c <= 8467 || (c < 11499
              ? (c < 8490
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || (c < 8488
                    ? c == 8486
                    : c <= 8488)))
                : (c <= 8505 || (c < 8526
                  ? (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)
                  : (c <= 8526 || (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)))))
              : (c <= 11507 || (c < 11647
                ? (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)))
                : (c <= 11670 || (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)))))))))
          : (c <= 11726 || (c < 42623
            ? (c < 12540
              ? (c < 12337
                ? (c < 11744
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 11775 || (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12335)))
                : (c <= 12341 || (c < 12441
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12442 || (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)))))
              : (c <= 12543 || (c < 19968
                ? (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c < 13312
                    ? (c >= 12784 && c <= 12799)
                    : c <= 19903)))
                : (c <= 42124 || (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42539 || (c < 42612
                    ? (c >= 42560 && c <= 42607)
                    : c <= 42621)))))))
            : (c <= 42737 || (c < 43232
              ? (c < 42965
                ? (c < 42891
                  ? (c < 42786
                    ? (c >= 42775 && c <= 42783)
                    : c <= 42888)
                  : (c <= 42954 || (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)))
                : (c <= 42969 || (c < 43072
                  ? (c < 43052
                    ? (c >= 42994 && c <= 43047)
                    : c <= 43052)
                  : (c <= 43123 || (c < 43216
                    ? (c >= 43136 && c <= 43205)
                    : c <= 43225)))))
              : (c <= 43255 || (c < 43471
                ? (c < 43312
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43309)
                  : (c <= 43347 || (c < 43392
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43456)))
                : (c <= 43481 || (c < 43584
                  ? (c < 43520
                    ? (c >= 43488 && c <= 43518)
                    : c <= 43574)
                  : (c <= 43597 || (c >= 43600 && c <= 43609)))))))))))))))
    : (c <= 43638 || (c < 71453
      ? (c < 67639
        ? (c < 65345
          ? (c < 64312
            ? (c < 43888
              ? (c < 43785
                ? (c < 43744
                  ? (c < 43739
                    ? (c >= 43642 && c <= 43714)
                    : c <= 43741)
                  : (c <= 43759 || (c < 43777
                    ? (c >= 43762 && c <= 43766)
                    : c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c < 43868
                    ? (c >= 43824 && c <= 43866)
                    : c <= 43881)))))
              : (c <= 44010 || (c < 63744
                ? (c < 44032
                  ? (c < 44016
                    ? (c >= 44012 && c <= 44013)
                    : c <= 44025)
                  : (c <= 55203 || (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || (c < 64298
                    ? (c >= 64285 && c <= 64296)
                    : c <= 64310)))))))
            : (c <= 64316 || (c < 65075
              ? (c < 64612
                ? (c < 64323
                  ? (c < 64320
                    ? c == 64318
                    : c <= 64321)
                  : (c <= 64324 || (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)))
                : (c <= 64829 || (c < 65008
                  ? (c < 64914
                    ? (c >= 64848 && c <= 64911)
                    : c <= 64967)
                  : (c <= 65017 || (c < 65056
                    ? (c >= 65024 && c <= 65039)
                    : c <= 65071)))))
              : (c <= 65076 || (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65101 && c <= 65103)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65296
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65305 || (c < 65343
                    ? (c >= 65313 && c <= 65338)
                    : c <= 65343)))))))))
          : (c <= 65370 || (c < 66513
            ? (c < 65664
              ? (c < 65536
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65382 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c < 65498
                    ? (c >= 65490 && c <= 65495)
                    : c <= 65500)))
                : (c <= 65547 || (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c < 65616
                    ? (c >= 65599 && c <= 65613)
                    : c <= 65629)))))
              : (c <= 65786 || (c < 66304
                ? (c < 66176
                  ? (c < 66045
                    ? (c >= 65856 && c <= 65908)
                    : c <= 66045)
                  : (c <= 66204 || (c < 66272
                    ? (c >= 66208 && c <= 66256)
                    : c <= 66272)))
                : (c <= 66335 || (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66426)
                  : (c <= 66461 || (c < 66504
                    ? (c >= 66464 && c <= 66499)
                    : c <= 66511)))))))
            : (c <= 66517 || (c < 66979
              ? (c < 66864
                ? (c < 66736
                  ? (c < 66720
                    ? (c >= 66560 && c <= 66717)
                    : c <= 66729)
                  : (c <= 66771 || (c < 66816
                    ? (c >= 66776 && c <= 66811)
                    : c <= 66855)))
                : (c <= 66915 || (c < 66956
                  ? (c < 66940
                    ? (c >= 66928 && c <= 66938)
                    : c <= 66954)
                  : (c <= 66962 || (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)))))
              : (c <= 66993 || (c < 67456
                ? (c < 67072
                  ? (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)
                  : (c <= 67382 || (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)))
                : (c <= 67461 || (c < 67584
                  ? (c < 67506
                    ? (c >= 67463 && c <= 67504)
                    : c <= 67514)
                  : (c <= 67589 || (c < 67594
                    ? c == 67592
                    : c <= 67637)))))))))))
        : (c <= 67640 || (c < 69956
          ? (c < 68448
            ? (c < 68101
              ? (c < 67828
                ? (c < 67680
                  ? (c < 67647
                    ? c == 67644
                    : c <= 67669)
                  : (c <= 67702 || (c < 67808
                    ? (c >= 67712 && c <= 67742)
                    : c <= 67826)))
                : (c <= 67829 || (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c < 68096
                    ? (c >= 68030 && c <= 68031)
                    : c <= 68099)))))
              : (c <= 68102 || (c < 68192
                ? (c < 68121
                  ? (c < 68117
                    ? (c >= 68108 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c < 68159
                    ? (c >= 68152 && c <= 68154)
                    : c <= 68159)))
                : (c <= 68220 || (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68326 || (c < 68416
                    ? (c >= 68352 && c <= 68405)
                    : c <= 68437)))))))
            : (c <= 68466 || (c < 69424
              ? (c < 68912
                ? (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c < 68864
                    ? (c >= 68800 && c <= 68850)
                    : c <= 68903)))
                : (c <= 68921 || (c < 69296
                  ? (c < 69291
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69292)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))))
              : (c <= 69456 || (c < 69759
                ? (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69509)
                    : c <= 69572)
                  : (c <= 69622 || (c < 69734
                    ? (c >= 69632 && c <= 69702)
                    : c <= 69749)))
                : (c <= 69818 || (c < 69872
                  ? (c < 69840
                    ? c == 69826
                    : c <= 69864)
                  : (c <= 69881 || (c < 69942
                    ? (c >= 69888 && c <= 69940)
                    : c <= 69951)))))))))
          : (c <= 69959 || (c < 70459
            ? (c < 70282
              ? (c < 70108
                ? (c < 70016
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70003)
                    : c <= 70006)
                  : (c <= 70084 || (c < 70094
                    ? (c >= 70089 && c <= 70092)
                    : c <= 70106)))
                : (c <= 70108 || (c < 70206
                  ? (c < 70163
                    ? (c >= 70144 && c <= 70161)
                    : c <= 70199)
                  : (c <= 70206 || (c < 70280
                    ? (c >= 70272 && c <= 70278)
                    : c <= 70280)))))
              : (c <= 70285 || (c < 70405
                ? (c < 70320
                  ? (c < 70303
                    ? (c >= 70287 && c <= 70301)
                    : c <= 70312)
                  : (c <= 70378 || (c < 70400
                    ? (c >= 70384 && c <= 70393)
                    : c <= 70403)))
                : (c <= 70412 || (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c < 70453
                    ? (c >= 70450 && c <= 70451)
                    : c <= 70457)))))))
            : (c <= 70468 || (c < 70855
              ? (c < 70502
                ? (c < 70480
                  ? (c < 70475
                    ? (c >= 70471 && c <= 70472)
                    : c <= 70477)
                  : (c <= 70480 || (c < 70493
                    ? c == 70487
                    : c <= 70499)))
                : (c <= 70508 || (c < 70736
                  ? (c < 70656
                    ? (c >= 70512 && c <= 70516)
                    : c <= 70730)
                  : (c <= 70745 || (c < 70784
                    ? (c >= 70750 && c <= 70753)
                    : c <= 70853)))))
              : (c <= 70855 || (c < 71236
                ? (c < 71096
                  ? (c < 71040
                    ? (c >= 70864 && c <= 70873)
                    : c <= 71093)
                  : (c <= 71104 || (c < 71168
                    ? (c >= 71128 && c <= 71133)
                    : c <= 71232)))
                : (c <= 71236 || (c < 71360
                  ? (c < 71296
                    ? (c >= 71248 && c <= 71257)
                    : c <= 71352)
                  : (c <= 71369 || (c >= 71424 && c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_47(int32_t c) {
  return (c < 43739
    ? (c < 3804
      ? (c < 2768
        ? (c < 2144
          ? (c < 1329
            ? (c < 750
              ? (c < 192
                ? (c < 181
                  ? (c < 170
                    ? c == '$'
                    : c <= 170)
                  : (c <= 181 || (c < 186
                    ? c == 183
                    : c <= 186)))
                : (c <= 214 || (c < 710
                  ? (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)
                  : (c <= 721 || (c < 748
                    ? (c >= 736 && c <= 740)
                    : c <= 748)))))
              : (c <= 750 || (c < 908
                ? (c < 891
                  ? (c < 886
                    ? (c >= 768 && c <= 884)
                    : c <= 887)
                  : (c <= 893 || (c < 902
                    ? c == 895
                    : c <= 906)))
                : (c <= 908 || (c < 1015
                  ? (c < 931
                    ? (c >= 910 && c <= 929)
                    : c <= 1013)
                  : (c <= 1153 || (c < 1162
                    ? (c >= 1155 && c <= 1159)
                    : c <= 1327)))))))
            : (c <= 1366 || (c < 1646
              ? (c < 1476
                ? (c < 1425
                  ? (c < 1376
                    ? c == 1369
                    : c <= 1416)
                  : (c <= 1469 || (c < 1473
                    ? c == 1471
                    : c <= 1474)))
                : (c <= 1477 || (c < 1519
                  ? (c < 1488
                    ? c == 1479
                    : c <= 1514)
                  : (c <= 1522 || (c < 1568
                    ? (c >= 1552 && c <= 1562)
                    : c <= 1641)))))
              : (c <= 1747 || (c < 1869
                ? (c < 1770
                  ? (c < 1759
                    ? (c >= 1749 && c <= 1756)
                    : c <= 1768)
                  : (c <= 1788 || (c < 1808
                    ? c == 1791
                    : c <= 1866)))
                : (c <= 1969 || (c < 2045
                  ? (c < 2042
                    ? (c >= 1984 && c <= 2037)
                    : c <= 2042)
                  : (c <= 2045 || (c < 2112
                    ? (c >= 2048 && c <= 2093)
                    : c <= 2139)))))))))
          : (c <= 2154 || (c < 2575
            ? (c < 2486
              ? (c < 2417
                ? (c < 2200
                  ? (c < 2185
                    ? (c >= 2160 && c <= 2183)
                    : c <= 2190)
                  : (c <= 2273 || (c < 2406
                    ? (c >= 2275 && c <= 2403)
                    : c <= 2415)))
                : (c <= 2435 || (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c < 2482
                    ? (c >= 2474 && c <= 2480)
                    : c <= 2482)))))
              : (c <= 2489 || (c < 2527
                ? (c < 2507
                  ? (c < 2503
                    ? (c >= 2492 && c <= 2500)
                    : c <= 2504)
                  : (c <= 2510 || (c < 2524
                    ? c == 2519
                    : c <= 2525)))
                : (c <= 2531 || (c < 2558
                  ? (c < 2556
                    ? (c >= 2534 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2558 || (c < 2565
                    ? (c >= 2561 && c <= 2563)
                    : c <= 2570)))))))
            : (c <= 2576 || (c < 2654
              ? (c < 2620
                ? (c < 2610
                  ? (c < 2602
                    ? (c >= 2579 && c <= 2600)
                    : c <= 2608)
                  : (c <= 2611 || (c < 2616
                    ? (c >= 2613 && c <= 2614)
                    : c <= 2617)))
                : (c <= 2620 || (c < 2635
                  ? (c < 2631
                    ? (c >= 2622 && c <= 2626)
                    : c <= 2632)
                  : (c <= 2637 || (c < 2649
                    ? c == 2641
                    : c <= 2652)))))
              : (c <= 2654 || (c < 2730
                ? (c < 2693
                  ? (c < 2689
                    ? (c >= 2662 && c <= 2677)
                    : c <= 2691)
                  : (c <= 2701 || (c < 2707
                    ? (c >= 2703 && c <= 2705)
                    : c <= 2728)))
                : (c <= 2736 || (c < 2748
                  ? (c < 2741
                    ? (c >= 2738 && c <= 2739)
                    : c <= 2745)
                  : (c <= 2757 || (c < 2763
                    ? (c >= 2759 && c <= 2761)
                    : c <= 2765)))))))))))
        : (c <= 2768 || (c < 3205
          ? (c < 2972
            ? (c < 2887
              ? (c < 2831
                ? (c < 2809
                  ? (c < 2790
                    ? (c >= 2784 && c <= 2787)
                    : c <= 2799)
                  : (c <= 2815 || (c < 2821
                    ? (c >= 2817 && c <= 2819)
                    : c <= 2828)))
                : (c <= 2832 || (c < 2866
                  ? (c < 2858
                    ? (c >= 2835 && c <= 2856)
                    : c <= 2864)
                  : (c <= 2867 || (c < 2876
                    ? (c >= 2869 && c <= 2873)
                    : c <= 2884)))))
              : (c <= 2888 || (c < 2929
                ? (c < 2908
                  ? (c < 2901
                    ? (c >= 2891 && c <= 2893)
                    : c <= 2903)
                  : (c <= 2909 || (c < 2918
                    ? (c >= 2911 && c <= 2915)
                    : c <= 2927)))
                : (c <= 2929 || (c < 2958
                  ? (c < 2949
                    ? (c >= 2946 && c <= 2947)
                    : c <= 2954)
                  : (c <= 2960 || (c < 2969
                    ? (c >= 2962 && c <= 2965)
                    : c <= 2970)))))))
            : (c <= 2972 || (c < 3086
              ? (c < 3014
                ? (c < 2984
                  ? (c < 2979
                    ? (c >= 2974 && c <= 2975)
                    : c <= 2980)
                  : (c <= 2986 || (c < 3006
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3010)))
                : (c <= 3016 || (c < 3031
                  ? (c < 3024
                    ? (c >= 3018 && c <= 3021)
                    : c <= 3024)
                  : (c <= 3031 || (c < 3072
                    ? (c >= 3046 && c <= 3055)
                    : c <= 3084)))))
              : (c <= 3088 || (c < 3157
                ? (c < 3132
                  ? (c < 3114
                    ? (c >= 3090 && c <= 3112)
                    : c <= 3129)
                  : (c <= 3140 || (c < 3146
                    ? (c >= 3142 && c <= 3144)
                    : c <= 3149)))
                : (c <= 3158 || (c < 3168
                  ? (c < 3165
                    ? (c >= 3160 && c <= 3162)
                    : c <= 3165)
                  : (c <= 3171 || (c < 3200
                    ? (c >= 3174 && c <= 3183)
                    : c <= 3203)))))))))
          : (c <= 3212 || (c < 3482
            ? (c < 3313
              ? (c < 3270
                ? (c < 3242
                  ? (c < 3218
                    ? (c >= 3214 && c <= 3216)
                    : c <= 3240)
                  : (c <= 3251 || (c < 3260
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3268)))
                : (c <= 3272 || (c < 3293
                  ? (c < 3285
                    ? (c >= 3274 && c <= 3277)
                    : c <= 3286)
                  : (c <= 3294 || (c < 3302
                    ? (c >= 3296 && c <= 3299)
                    : c <= 3311)))))
              : (c <= 3314 || (c < 3412
                ? (c < 3346
                  ? (c < 3342
                    ? (c >= 3328 && c <= 3340)
                    : c <= 3344)
                  : (c <= 3396 || (c < 3402
                    ? (c >= 3398 && c <= 3400)
                    : c <= 3406)))
                : (c <= 3415 || (c < 3450
                  ? (c < 3430
                    ? (c >= 3423 && c <= 3427)
                    : c <= 3439)
                  : (c <= 3455 || (c < 3461
                    ? (c >= 3457 && c <= 3459)
                    : c <= 3478)))))))
            : (c <= 3505 || (c < 3664
              ? (c < 3542
                ? (c < 3520
                  ? (c < 3517
                    ? (c >= 3507 && c <= 3515)
                    : c <= 3517)
                  : (c <= 3526 || (c < 3535
                    ? c == 3530
                    : c <= 3540)))
                : (c <= 3542 || (c < 3570
                  ? (c < 3558
                    ? (c >= 3544 && c <= 3551)
                    : c <= 3567)
                  : (c <= 3571 || (c < 3648
                    ? (c >= 3585 && c <= 3642)
                    : c <= 3662)))))
              : (c <= 3673 || (c < 3751
                ? (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c < 3749
                    ? (c >= 3724 && c <= 3747)
                    : c <= 3749)))
                : (c <= 3773 || (c < 3784
                  ? (c < 3782
                    ? (c >= 3776 && c <= 3780)
                    : c <= 3782)
                  : (c <= 3789 || (c >= 3792 && c <= 3801)))))))))))))
      : (c <= 3807 || (c < 8029
        ? (c < 5984
          ? (c < 4704
            ? (c < 4038
              ? (c < 3897
                ? (c < 3872
                  ? (c < 3864
                    ? c == 3840
                    : c <= 3865)
                  : (c <= 3881 || (c < 3895
                    ? c == 3893
                    : c <= 3895)))
                : (c <= 3897 || (c < 3953
                  ? (c < 3913
                    ? (c >= 3902 && c <= 3911)
                    : c <= 3948)
                  : (c <= 3972 || (c < 3993
                    ? (c >= 3974 && c <= 3991)
                    : c <= 4028)))))
              : (c <= 4038 || (c < 4304
                ? (c < 4256
                  ? (c < 4176
                    ? (c >= 4096 && c <= 4169)
                    : c <= 4253)
                  : (c <= 4293 || (c < 4301
                    ? c == 4295
                    : c <= 4301)))
                : (c <= 4346 || (c < 4688
                  ? (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)
                  : (c <= 4694 || (c < 4698
                    ? c == 4696
                    : c <= 4701)))))))
            : (c <= 4744 || (c < 4969
              ? (c < 4802
                ? (c < 4786
                  ? (c < 4752
                    ? (c >= 4746 && c <= 4749)
                    : c <= 4784)
                  : (c <= 4789 || (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)))
                : (c <= 4805 || (c < 4882
                  ? (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)
                  : (c <= 4885 || (c < 4957
                    ? (c >= 4888 && c <= 4954)
                    : c <= 4959)))))
              : (c <= 4977 || (c < 5761
                ? (c < 5112
                  ? (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)
                  : (c <= 5117 || (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)))
                : (c <= 5786 || (c < 5888
                  ? (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)
                  : (c <= 5909 || (c < 5952
                    ? (c >= 5919 && c <= 5940)
                    : c <= 5971)))))))))
          : (c <= 5996 || (c < 6800
            ? (c < 6400
              ? (c < 6112
                ? (c < 6016
                  ? (c < 6002
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6003)
                  : (c <= 6099 || (c < 6108
                    ? c == 6103
                    : c <= 6109)))
                : (c <= 6121 || (c < 6176
                  ? (c < 6159
                    ? (c >= 6155 && c <= 6157)
                    : c <= 6169)
                  : (c <= 6264 || (c < 6320
                    ? (c >= 6272 && c <= 6314)
                    : c <= 6389)))))
              : (c <= 6430 || (c < 6576
                ? (c < 6470
                  ? (c < 6448
                    ? (c >= 6432 && c <= 6443)
                    : c <= 6459)
                  : (c <= 6509 || (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)))
                : (c <= 6601 || (c < 6688
                  ? (c < 6656
                    ? (c >= 6608 && c <= 6618)
                    : c <= 6683)
                  : (c <= 6750 || (c < 6783
                    ? (c >= 6752 && c <= 6780)
                    : c <= 6793)))))))
            : (c <= 6809 || (c < 7312
              ? (c < 7019
                ? (c < 6847
                  ? (c < 6832
                    ? c == 6823
                    : c <= 6845)
                  : (c <= 6862 || (c < 6992
                    ? (c >= 6912 && c <= 6988)
                    : c <= 7001)))
                : (c <= 7027 || (c < 7232
                  ? (c < 7168
                    ? (c >= 7040 && c <= 7155)
                    : c <= 7223)
                  : (c <= 7241 || (c < 7296
                    ? (c >= 7245 && c <= 7293)
                    : c <= 7304)))))
              : (c <= 7354 || (c < 7968
                ? (c < 7380
                  ? (c < 7376
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7378)
                  : (c <= 7418 || (c < 7960
                    ? (c >= 7424 && c <= 7957)
                    : c <= 7965)))
                : (c <= 8005 || (c < 8025
                  ? (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)
                  : (c <= 8025 || c == 8027))))))))))
        : (c <= 8029 || (c < 11736
          ? (c < 8472
            ? (c < 8255
              ? (c < 8134
                ? (c < 8118
                  ? (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)
                  : (c <= 8124 || (c < 8130
                    ? c == 8126
                    : c <= 8132)))
                : (c <= 8140 || (c < 8160
                  ? (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)
                  : (c <= 8172 || (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)))))
              : (c <= 8256 || (c < 8417
                ? (c < 8319
                  ? (c < 8305
                    ? c == 8276
                    : c <= 8305)
                  : (c <= 8319 || (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)))
                : (c <= 8417 || (c < 8455
                  ? (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)
                  : (c <= 8455 || (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)))))))
            : (c <= 8477 || (c < 11559
              ? (c < 8517
                ? (c < 8488
                  ? (c < 8486
                    ? c == 8484
                    : c <= 8486)
                  : (c <= 8488 || (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)))
                : (c <= 8521 || (c < 11264
                  ? (c < 8544
                    ? c == 8526
                    : c <= 8584)
                  : (c <= 11492 || (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)))))
              : (c <= 11559 || (c < 11688
                ? (c < 11631
                  ? (c < 11568
                    ? c == 11565
                    : c <= 11623)
                  : (c <= 11631 || (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)))
                : (c <= 11694 || (c < 11712
                  ? (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)
                  : (c <= 11718 || (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)))))))))
          : (c <= 11742 || (c < 42786
            ? (c < 12593
              ? (c < 12353
                ? (c < 12321
                  ? (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)
                  : (c <= 12335 || (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)))
                : (c <= 12438 || (c < 12449
                  ? (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)
                  : (c <= 12538 || (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)))))
              : (c <= 12686 || (c < 42240
                ? (c < 13312
                  ? (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)
                  : (c <= 19903 || (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)))
                : (c <= 42508 || (c < 42612
                  ? (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)
                  : (c <= 42621 || (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)))))))
            : (c <= 42888 || (c < 43261
              ? (c < 43052
                ? (c < 42963
                  ? (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)
                  : (c <= 42963 || (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)))
                : (c <= 43052 || (c < 43216
                  ? (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)
                  : (c <= 43225 || (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)))))
              : (c <= 43309 || (c < 43520
                ? (c < 43392
                  ? (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)
                  : (c <= 43456 || (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)))
                : (c <= 43574 || (c < 43616
                  ? (c < 43600
                    ? (c >= 43584 && c <= 43597)
                    : c <= 43609)
                  : (c <= 43638 || (c >= 43642 && c <= 43714)))))))))))))))
    : (c <= 43741 || (c < 71472
      ? (c < 67644
        ? (c < 65474
          ? (c < 64320
            ? (c < 44016
              ? (c < 43808
                ? (c < 43777
                  ? (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)
                  : (c <= 43782 || (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)))
                : (c <= 43814 || (c < 43868
                  ? (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)
                  : (c <= 43881 || (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)))))
              : (c <= 44025 || (c < 64256
                ? (c < 55243
                  ? (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)
                  : (c <= 55291 || (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)))
                : (c <= 64262 || (c < 64298
                  ? (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)
                  : (c <= 64310 || (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)))))))
            : (c <= 64321 || (c < 65137
              ? (c < 64914
                ? (c < 64467
                  ? (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)
                  : (c <= 64605 || (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)))
                : (c <= 64967 || (c < 65056
                  ? (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)
                  : (c <= 65071 || (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)))))
              : (c <= 65137 || (c < 65151
                ? (c < 65145
                  ? (c < 65143
                    ? c == 65139
                    : c <= 65143)
                  : (c <= 65145 || (c < 65149
                    ? c == 65147
                    : c <= 65149)))
                : (c <= 65276 || (c < 65343
                  ? (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)
                  : (c <= 65343 || (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)))))))))
          : (c <= 65479 || (c < 66720
            ? (c < 66045
              ? (c < 65576
                ? (c < 65498
                  ? (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)
                  : (c <= 65500 || (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)))
                : (c <= 65594 || (c < 65616
                  ? (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)
                  : (c <= 65629 || (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)))))
              : (c <= 66045 || (c < 66384
                ? (c < 66272
                  ? (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)
                  : (c <= 66272 || (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)))
                : (c <= 66426 || (c < 66504
                  ? (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)
                  : (c <= 66511 || (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)))))))
            : (c <= 66729 || (c < 67003
              ? (c < 66940
                ? (c < 66816
                  ? (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)
                  : (c <= 66855 || (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)))
                : (c <= 66954 || (c < 66967
                  ? (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)
                  : (c <= 66977 || (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)))))
              : (c <= 67004 || (c < 67506
                ? (c < 67424
                  ? (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)
                  : (c <= 67431 || (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)))
                : (c <= 67514 || (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))))))))))
        : (c <= 67644 || (c < 69968
          ? (c < 68480
            ? (c < 68108
              ? (c < 67840
                ? (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c < 67828
                    ? (c >= 67808 && c <= 67826)
                    : c <= 67829)))
                : (c <= 67861 || (c < 68030
                  ? (c < 67968
                    ? (c >= 67872 && c <= 67897)
                    : c <= 68023)
                  : (c <= 68031 || (c < 68101
                    ? (c >= 68096 && c <= 68099)
                    : c <= 68102)))))
              : (c <= 68115 || (c < 68224
                ? (c < 68152
                  ? (c < 68121
                    ? (c >= 68117 && c <= 68119)
                    : c <= 68149)
                  : (c <= 68154 || (c < 68192
                    ? c == 68159
                    : c <= 68220)))
                : (c <= 68252 || (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68326)
                  : (c <= 68405 || (c < 68448
                    ? (c >= 68416 && c <= 68437)
                    : c <= 68466)))))))
            : (c <= 68497 || (c < 69488
              ? (c < 69248
                ? (c < 68800
                  ? (c < 68736
                    ? (c >= 68608 && c <= 68680)
                    : c <= 68786)
                  : (c <= 68850 || (c < 68912
                    ? (c >= 68864 && c <= 68903)
                    : c <= 68921)))
                : (c <= 69289 || (c < 69376
                  ? (c < 69296
                    ? (c >= 69291 && c <= 69292)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69456)))))
              : (c <= 69509 || (c < 69826
                ? (c < 69632
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69702 || (c < 69759
                    ? (c >= 69734 && c <= 69749)
                    : c <= 69818)))
                : (c <= 69826 || (c < 69888
                  ? (c < 69872
                    ? (c >= 69840 && c <= 69864)
                    : c <= 69881)
                  : (c <= 69940 || (c < 69956
                    ? (c >= 69942 && c <= 69951)
                    : c <= 69959)))))))))
          : (c <= 70003 || (c < 70471
            ? (c < 70287
              ? (c < 70144
                ? (c < 70089
                  ? (c < 70016
                    ? c == 70006
                    : c <= 70084)
                  : (c <= 70092 || (c < 70108
                    ? (c >= 70094 && c <= 70106)
                    : c <= 70108)))
                : (c <= 70161 || (c < 70272
                  ? (c < 70206
                    ? (c >= 70163 && c <= 70199)
                    : c <= 70206)
                  : (c <= 70278 || (c < 70282
                    ? c == 70280
                    : c <= 70285)))))
              : (c <= 70301 || (c < 70415
                ? (c < 70384
                  ? (c < 70320
                    ? (c >= 70303 && c <= 70312)
                    : c <= 70378)
                  : (c <= 70393 || (c < 70405
                    ? (c >= 70400 && c <= 70403)
                    : c <= 70412)))
                : (c <= 70416 || (c < 70450
                  ? (c < 70442
                    ? (c >= 70419 && c <= 70440)
                    : c <= 70448)
                  : (c <= 70451 || (c < 70459
                    ? (c >= 70453 && c <= 70457)
                    : c <= 70468)))))))
            : (c <= 70472 || (c < 70864
              ? (c < 70512
                ? (c < 70487
                  ? (c < 70480
                    ? (c >= 70475 && c <= 70477)
                    : c <= 70480)
                  : (c <= 70487 || (c < 70502
                    ? (c >= 70493 && c <= 70499)
                    : c <= 70508)))
                : (c <= 70516 || (c < 70750
                  ? (c < 70736
                    ? (c >= 70656 && c <= 70730)
                    : c <= 70745)
                  : (c <= 70753 || (c < 70855
                    ? (c >= 70784 && c <= 70853)
                    : c <= 70855)))))
              : (c <= 70873 || (c < 71248
                ? (c < 71128
                  ? (c < 71096
                    ? (c >= 71040 && c <= 71093)
                    : c <= 71104)
                  : (c <= 71133 || (c < 71236
                    ? (c >= 71168 && c <= 71232)
                    : c <= 71236)))
                : (c <= 71257 || (c < 71424
                  ? (c < 71360
                    ? (c >= 71296 && c <= 71352)
                    : c <= 71369)
                  : (c <= 71450 || (c >= 71453 && c <= 71467)))))))))))))
      : (c <= 71481 || (c < 119973
        ? (c < 82944
          ? (c < 72784
            ? (c < 72096
              ? (c < 71948
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71738)
                  : (c <= 71913 || (c < 71945
                    ? (c >= 71935 && c <= 71942)
                    : c <= 71945)))
                : (c <= 71955 || (c < 71991
                  ? (c < 71960
                    ? (c >= 71957 && c <= 71958)
                    : c <= 71989)
                  : (c <= 71992 || (c < 72016
                    ? (c >= 71995 && c <= 72003)
                    : c <= 72025)))))
              : (c <= 72103 || (c < 72272
                ? (c < 72163
                  ? (c < 72154
                    ? (c >= 72106 && c <= 72151)
                    : c <= 72161)
                  : (c <= 72164 || (c < 72263
                    ? (c >= 72192 && c <= 72254)
                    : c <= 72263)))
                : (c <= 72345 || (c < 72704
                  ? (c < 72368
                    ? c == 72349
                    : c <= 72440)
                  : (c <= 72712 || (c < 72760
                    ? (c >= 72714 && c <= 72758)
                    : c <= 72768)))))))
            : (c <= 72793 || (c < 73063
              ? (c < 72971
                ? (c < 72873
                  ? (c < 72850
                    ? (c >= 72818 && c <= 72847)
                    : c <= 72871)
                  : (c <= 72886 || (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)))
                : (c <= 73014 || (c < 73023
                  ? (c < 73020
                    ? c == 73018
                    : c <= 73021)
                  : (c <= 73031 || (c < 73056
                    ? (c >= 73040 && c <= 73049)
                    : c <= 73061)))))
              : (c <= 73064 || (c < 73648
                ? (c < 73107
                  ? (c < 73104
                    ? (c >= 73066 && c <= 73102)
                    : c <= 73105)
                  : (c <= 73112 || (c < 73440
                    ? (c >= 73120 && c <= 73129)
                    : c <= 73462)))
                : (c <= 73648 || (c < 74880
                  ? (c < 74752
                    ? (c >= 73728 && c <= 74649)
                    : c <= 74862)
                  : (c <= 75075 || (c < 77824
                    ? (c >= 77712 && c <= 77808)
                    : c <= 78894)))))))))
          : (c <= 83526 || (c < 110581
            ? (c < 93053
              ? (c < 92880
                ? (c < 92768
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92777 || (c < 92864
                    ? (c >= 92784 && c <= 92862)
                    : c <= 92873)))
                : (c <= 92909 || (c < 92992
                  ? (c < 92928
                    ? (c >= 92912 && c <= 92916)
                    : c <= 92982)
                  : (c <= 92995 || (c < 93027
                    ? (c >= 93008 && c <= 93017)
                    : c <= 93047)))))
              : (c <= 93071 || (c < 94179
                ? (c < 94031
                  ? (c < 93952
                    ? (c >= 93760 && c <= 93823)
                    : c <= 94026)
                  : (c <= 94087 || (c < 94176
                    ? (c >= 94095 && c <= 94111)
                    : c <= 94177)))
                : (c <= 94180 || (c < 100352
                  ? (c < 94208
                    ? (c >= 94192 && c <= 94193)
                    : c <= 100343)
                  : (c <= 101589 || (c < 110576
                    ? (c >= 101632 && c <= 101640)
                    : c <= 110579)))))))
            : (c <= 110587 || (c < 118576
              ? (c < 113664
                ? (c < 110928
                  ? (c < 110592
                    ? (c >= 110589 && c <= 110590)
                    : c <= 110882)
                  : (c <= 110930 || (c < 110960
                    ? (c >= 110948 && c <= 110951)
                    : c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c < 118528
                    ? (c >= 113821 && c <= 113822)
                    : c <= 118573)))))
              : (c <= 118598 || (c < 119362
                ? (c < 119163
                  ? (c < 119149
                    ? (c >= 119141 && c <= 119145)
                    : c <= 119154)
                  : (c <= 119170 || (c < 119210
                    ? (c >= 119173 && c <= 119179)
                    : c <= 119213)))
                : (c <= 119364 || (c < 119966
                  ? (c < 119894
                    ? (c >= 119808 && c <= 119892)
                    : c <= 119964)
                  : (c <= 119967 || c == 119970))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(388);
      if (lookahead == '!') ADVANCE(460);
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '#') ADVANCE(322);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '\'') ADVANCE(578);
      if (lookahead == '(') ADVANCE(392);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(474);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(463);
      if (lookahead == '.') ADVANCE(544);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '0') ADVANCE(553);
      if (lookahead == ':') ADVANCE(528);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'B') ADVANCE(620);
      if (lookahead == 'F') ADVANCE(633);
      if (lookahead == 'L') ADVANCE(601);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'T') ADVANCE(630);
      if (lookahead == 'U') ADVANCE(605);
      if (lookahead == '[') ADVANCE(520);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead == ']') ADVANCE(522);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(622);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 't') ADVANCE(669);
      if (lookahead == 'u') ADVANCE(608);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (lookahead == '}') ADVANCE(517);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(386)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(188)
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(188)
      if (lookahead == '\r') SKIP(1)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(199)
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(199)
      if (lookahead == '\r') SKIP(3)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(198)
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(198)
      if (lookahead == '\r') SKIP(5)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(202)
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(202)
      if (lookahead == '\r') SKIP(7)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(200)
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(200)
      if (lookahead == '\r') SKIP(9)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 11:
      if (lookahead == '\n') SKIP(203)
      END_STATE();
    case 12:
      if (lookahead == '\n') SKIP(203)
      if (lookahead == '\r') SKIP(11)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 13:
      if (lookahead == '\n') SKIP(191)
      END_STATE();
    case 14:
      if (lookahead == '\n') SKIP(191)
      if (lookahead == '\r') SKIP(13)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 15:
      if (lookahead == '\n') SKIP(193)
      END_STATE();
    case 16:
      if (lookahead == '\n') SKIP(193)
      if (lookahead == '\r') SKIP(15)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 17:
      if (lookahead == '\n') SKIP(194)
      END_STATE();
    case 18:
      if (lookahead == '\n') SKIP(194)
      if (lookahead == '\r') SKIP(17)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 19:
      if (lookahead == '\n') SKIP(204)
      END_STATE();
    case 20:
      if (lookahead == '\n') SKIP(204)
      if (lookahead == '\r') SKIP(19)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 21:
      if (lookahead == '\n') SKIP(282)
      END_STATE();
    case 22:
      if (lookahead == '\n') SKIP(282)
      if (lookahead == '\r') SKIP(21)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 23:
      if (lookahead == '\n') SKIP(252)
      END_STATE();
    case 24:
      if (lookahead == '\n') SKIP(252)
      if (lookahead == '\r') SKIP(23)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 25:
      if (lookahead == '\n') SKIP(280)
      END_STATE();
    case 26:
      if (lookahead == '\n') SKIP(280)
      if (lookahead == '\r') SKIP(25)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 27:
      if (lookahead == '\n') SKIP(283)
      END_STATE();
    case 28:
      if (lookahead == '\n') SKIP(283)
      if (lookahead == '\r') SKIP(27)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 29:
      if (lookahead == '\n') SKIP(196)
      END_STATE();
    case 30:
      if (lookahead == '\n') SKIP(196)
      if (lookahead == '\r') SKIP(29)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 31:
      if (lookahead == '\n') SKIP(222)
      END_STATE();
    case 32:
      if (lookahead == '\n') SKIP(222)
      if (lookahead == '\r') SKIP(31)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 33:
      if (lookahead == '\n') SKIP(219)
      END_STATE();
    case 34:
      if (lookahead == '\n') SKIP(219)
      if (lookahead == '\r') SKIP(33)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 35:
      if (lookahead == '\n') SKIP(244)
      END_STATE();
    case 36:
      if (lookahead == '\n') SKIP(244)
      if (lookahead == '\r') SKIP(35)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 37:
      if (lookahead == '\n') SKIP(231)
      END_STATE();
    case 38:
      if (lookahead == '\n') SKIP(231)
      if (lookahead == '\r') SKIP(37)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 39:
      if (lookahead == '\n') SKIP(220)
      END_STATE();
    case 40:
      if (lookahead == '\n') SKIP(220)
      if (lookahead == '\r') SKIP(39)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 41:
      if (lookahead == '\n') SKIP(223)
      END_STATE();
    case 42:
      if (lookahead == '\n') SKIP(223)
      if (lookahead == '\r') SKIP(41)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 43:
      if (lookahead == '\n') SKIP(208)
      END_STATE();
    case 44:
      if (lookahead == '\n') SKIP(208)
      if (lookahead == '\r') SKIP(43)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 45:
      if (lookahead == '\n') SKIP(230)
      END_STATE();
    case 46:
      if (lookahead == '\n') SKIP(230)
      if (lookahead == '\r') SKIP(45)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 47:
      if (lookahead == '\n') SKIP(209)
      END_STATE();
    case 48:
      if (lookahead == '\n') SKIP(209)
      if (lookahead == '\r') SKIP(47)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 49:
      if (lookahead == '\n') SKIP(260)
      END_STATE();
    case 50:
      if (lookahead == '\n') SKIP(260)
      if (lookahead == '\r') SKIP(49)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 51:
      if (lookahead == '\n') SKIP(234)
      END_STATE();
    case 52:
      if (lookahead == '\n') SKIP(234)
      if (lookahead == '\r') SKIP(51)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 53:
      if (lookahead == '\n') SKIP(213)
      END_STATE();
    case 54:
      if (lookahead == '\n') SKIP(213)
      if (lookahead == '\r') SKIP(53)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 55:
      if (lookahead == '\n') SKIP(214)
      END_STATE();
    case 56:
      if (lookahead == '\n') SKIP(214)
      if (lookahead == '\r') SKIP(55)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 57:
      if (lookahead == '\n') SKIP(237)
      END_STATE();
    case 58:
      if (lookahead == '\n') SKIP(237)
      if (lookahead == '\r') SKIP(57)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 59:
      if (lookahead == '\n') SKIP(221)
      END_STATE();
    case 60:
      if (lookahead == '\n') SKIP(221)
      if (lookahead == '\r') SKIP(59)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 61:
      if (lookahead == '\n') SKIP(242)
      END_STATE();
    case 62:
      if (lookahead == '\n') SKIP(242)
      if (lookahead == '\r') SKIP(61)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 63:
      if (lookahead == '\n') SKIP(259)
      END_STATE();
    case 64:
      if (lookahead == '\n') SKIP(259)
      if (lookahead == '\r') SKIP(63)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 65:
      if (lookahead == '\n') SKIP(224)
      END_STATE();
    case 66:
      if (lookahead == '\n') SKIP(224)
      if (lookahead == '\r') SKIP(65)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 67:
      if (lookahead == '\n') SKIP(256)
      END_STATE();
    case 68:
      if (lookahead == '\n') SKIP(256)
      if (lookahead == '\r') SKIP(67)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 69:
      if (lookahead == '\n') SKIP(281)
      END_STATE();
    case 70:
      if (lookahead == '\n') SKIP(281)
      if (lookahead == '\r') SKIP(69)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 71:
      if (lookahead == '\n') SKIP(246)
      END_STATE();
    case 72:
      if (lookahead == '\n') SKIP(246)
      if (lookahead == '\r') SKIP(71)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 73:
      if (lookahead == '\n') SKIP(236)
      END_STATE();
    case 74:
      if (lookahead == '\n') SKIP(236)
      if (lookahead == '\r') SKIP(73)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 75:
      if (lookahead == '\n') SKIP(261)
      END_STATE();
    case 76:
      if (lookahead == '\n') SKIP(261)
      if (lookahead == '\r') SKIP(75)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 77:
      if (lookahead == '\n') SKIP(273)
      END_STATE();
    case 78:
      if (lookahead == '\n') SKIP(273)
      if (lookahead == '\r') SKIP(77)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 79:
      if (lookahead == '\n') SKIP(276)
      END_STATE();
    case 80:
      if (lookahead == '\n') SKIP(276)
      if (lookahead == '\r') SKIP(79)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 81:
      if (lookahead == '\n') SKIP(258)
      END_STATE();
    case 82:
      if (lookahead == '\n') SKIP(258)
      if (lookahead == '\r') SKIP(81)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 83:
      if (lookahead == '\n') SKIP(378)
      END_STATE();
    case 84:
      if (lookahead == '\n') SKIP(378)
      if (lookahead == '\r') SKIP(83)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 85:
      if (lookahead == '\n') SKIP(268)
      END_STATE();
    case 86:
      if (lookahead == '\n') SKIP(268)
      if (lookahead == '\r') SKIP(85)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 87:
      if (lookahead == '\n') SKIP(247)
      END_STATE();
    case 88:
      if (lookahead == '\n') SKIP(247)
      if (lookahead == '\r') SKIP(87)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 89:
      if (lookahead == '\n') SKIP(197)
      END_STATE();
    case 90:
      if (lookahead == '\n') SKIP(197)
      if (lookahead == '\r') SKIP(89)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 91:
      if (lookahead == '\n') SKIP(381)
      END_STATE();
    case 92:
      if (lookahead == '\n') SKIP(381)
      if (lookahead == '\r') SKIP(91)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 93:
      if (lookahead == '\n') SKIP(267)
      END_STATE();
    case 94:
      if (lookahead == '\n') SKIP(267)
      if (lookahead == '\r') SKIP(93)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 95:
      if (lookahead == '\n') SKIP(262)
      END_STATE();
    case 96:
      if (lookahead == '\n') SKIP(262)
      if (lookahead == '\r') SKIP(95)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 97:
      if (lookahead == '\n') SKIP(379)
      END_STATE();
    case 98:
      if (lookahead == '\n') SKIP(379)
      if (lookahead == '\r') SKIP(97)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 99:
      if (lookahead == '\n') SKIP(271)
      END_STATE();
    case 100:
      if (lookahead == '\n') SKIP(271)
      if (lookahead == '\r') SKIP(99)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 101:
      if (lookahead == '\n') SKIP(382)
      END_STATE();
    case 102:
      if (lookahead == '\n') SKIP(382)
      if (lookahead == '\r') SKIP(101)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 103:
      if (lookahead == '\n') SKIP(380)
      END_STATE();
    case 104:
      if (lookahead == '\n') SKIP(380)
      if (lookahead == '\r') SKIP(103)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 105:
      if (lookahead == '\n') SKIP(205)
      END_STATE();
    case 106:
      if (lookahead == '\n') SKIP(205)
      if (lookahead == '\r') SKIP(105)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 107:
      if (lookahead == '\n') SKIP(109)
      END_STATE();
    case 108:
      if (lookahead == '\n') SKIP(109)
      if (lookahead == '\r') SKIP(107)
      END_STATE();
    case 109:
      if (lookahead == '\n') ADVANCE(397);
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(472);
      if (lookahead == '-') ADVANCE(462);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == '<') ADVANCE(507);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(498);
      if (lookahead == '\\') SKIP(108)
      if (lookahead == '^') ADVANCE(490);
      if (lookahead == '|') ADVANCE(489);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(109)
      END_STATE();
    case 110:
      if (lookahead == '\n') SKIP(277)
      END_STATE();
    case 111:
      if (lookahead == '\n') SKIP(277)
      if (lookahead == '\r') SKIP(110)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 112:
      if (lookahead == '\n') SKIP(383)
      END_STATE();
    case 113:
      if (lookahead == '\n') SKIP(383)
      if (lookahead == '\r') SKIP(112)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 114:
      if (lookahead == '\n') SKIP(278)
      END_STATE();
    case 115:
      if (lookahead == '\n') SKIP(278)
      if (lookahead == '\r') SKIP(114)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 116:
      if (lookahead == '\n') SKIP(285)
      if (lookahead == '\'') ADVANCE(578);
      if (lookahead == '/') ADVANCE(581);
      if (lookahead == '\\') ADVANCE(580);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(582);
      if (lookahead != 0) ADVANCE(579);
      END_STATE();
    case 117:
      if (lookahead == '\n') ADVANCE(594);
      if (lookahead == '\r') ADVANCE(593);
      if (lookahead == 'U') ADVANCE(377);
      if (lookahead == 'u') ADVANCE(369);
      if (lookahead == 'x') ADVANCE(365);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(596);
      if (lookahead != 0) ADVANCE(593);
      END_STATE();
    case 118:
      if (lookahead == '\n') SKIP(275)
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '/') ADVANCE(588);
      if (lookahead == '\\') ADVANCE(117);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(591);
      if (lookahead != 0) ADVANCE(592);
      END_STATE();
    case 119:
      if (lookahead == '\n') ADVANCE(390);
      if (lookahead == '\r') ADVANCE(123);
      if (lookahead == '(') ADVANCE(392);
      if (lookahead == '/') ADVANCE(417);
      if (lookahead == '\\') ADVANCE(415);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(300)
      if (lookahead != 0) ADVANCE(418);
      END_STATE();
    case 120:
      if (lookahead == '\n') ADVANCE(390);
      if (lookahead == '\r') ADVANCE(123);
      if (lookahead == '/') ADVANCE(417);
      if (lookahead == '\\') ADVANCE(415);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(300)
      if (lookahead != 0) ADVANCE(418);
      END_STATE();
    case 121:
      if (lookahead == '\n') ADVANCE(390);
      if (lookahead == '\r') ADVANCE(122);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == '\\') SKIP(125)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(288)
      END_STATE();
    case 122:
      if (lookahead == '\n') ADVANCE(390);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == '\\') SKIP(125)
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(288)
      END_STATE();
    case 123:
      if (lookahead == '\n') ADVANCE(390);
      if (lookahead == '/') ADVANCE(417);
      if (lookahead == '\\') ADVANCE(415);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(300)
      if (lookahead != 0) ADVANCE(418);
      END_STATE();
    case 124:
      if (lookahead == '\n') SKIP(288)
      END_STATE();
    case 125:
      if (lookahead == '\n') SKIP(288)
      if (lookahead == '\r') SKIP(124)
      END_STATE();
    case 126:
      if (lookahead == '\n') SKIP(189)
      END_STATE();
    case 127:
      if (lookahead == '\n') SKIP(189)
      if (lookahead == '\r') SKIP(126)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 128:
      if (lookahead == '\n') SKIP(201)
      END_STATE();
    case 129:
      if (lookahead == '\n') SKIP(201)
      if (lookahead == '\r') SKIP(128)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 130:
      if (lookahead == '\n') SKIP(192)
      END_STATE();
    case 131:
      if (lookahead == '\n') SKIP(192)
      if (lookahead == '\r') SKIP(130)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 132:
      if (lookahead == '\n') SKIP(195)
      END_STATE();
    case 133:
      if (lookahead == '\n') SKIP(195)
      if (lookahead == '\r') SKIP(132)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 134:
      if (lookahead == '\n') SKIP(226)
      END_STATE();
    case 135:
      if (lookahead == '\n') SKIP(226)
      if (lookahead == '\r') SKIP(134)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 136:
      if (lookahead == '\n') SKIP(229)
      END_STATE();
    case 137:
      if (lookahead == '\n') SKIP(229)
      if (lookahead == '\r') SKIP(136)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 138:
      if (lookahead == '\n') SKIP(210)
      END_STATE();
    case 139:
      if (lookahead == '\n') SKIP(210)
      if (lookahead == '\r') SKIP(138)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 140:
      if (lookahead == '\n') SKIP(265)
      END_STATE();
    case 141:
      if (lookahead == '\n') SKIP(265)
      if (lookahead == '\r') SKIP(140)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 142:
      if (lookahead == '\n') SKIP(232)
      END_STATE();
    case 143:
      if (lookahead == '\n') SKIP(232)
      if (lookahead == '\r') SKIP(142)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 144:
      if (lookahead == '\n') SKIP(215)
      END_STATE();
    case 145:
      if (lookahead == '\n') SKIP(215)
      if (lookahead == '\r') SKIP(144)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 146:
      if (lookahead == '\n') SKIP(257)
      END_STATE();
    case 147:
      if (lookahead == '\n') SKIP(257)
      if (lookahead == '\r') SKIP(146)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 148:
      if (lookahead == '\n') SKIP(225)
      END_STATE();
    case 149:
      if (lookahead == '\n') SKIP(225)
      if (lookahead == '\r') SKIP(148)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 150:
      if (lookahead == '\n') SKIP(284)
      END_STATE();
    case 151:
      if (lookahead == '\n') SKIP(284)
      if (lookahead == '\r') SKIP(150)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 152:
      if (lookahead == '\n') SKIP(245)
      END_STATE();
    case 153:
      if (lookahead == '\n') SKIP(245)
      if (lookahead == '\r') SKIP(152)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 154:
      if (lookahead == '\n') SKIP(235)
      END_STATE();
    case 155:
      if (lookahead == '\n') SKIP(235)
      if (lookahead == '\r') SKIP(154)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 156:
      if (lookahead == '\n') SKIP(266)
      END_STATE();
    case 157:
      if (lookahead == '\n') SKIP(266)
      if (lookahead == '\r') SKIP(156)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 158:
      if (lookahead == '\n') SKIP(269)
      END_STATE();
    case 159:
      if (lookahead == '\n') SKIP(269)
      if (lookahead == '\r') SKIP(158)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 160:
      if (lookahead == '\n') SKIP(248)
      END_STATE();
    case 161:
      if (lookahead == '\n') SKIP(248)
      if (lookahead == '\r') SKIP(160)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 162:
      if (lookahead == '\n') SKIP(263)
      END_STATE();
    case 163:
      if (lookahead == '\n') SKIP(263)
      if (lookahead == '\r') SKIP(162)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 164:
      if (lookahead == '\n') SKIP(190)
      END_STATE();
    case 165:
      if (lookahead == '\n') SKIP(190)
      if (lookahead == '\r') SKIP(164)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 166:
      if (lookahead == '\n') SKIP(243)
      END_STATE();
    case 167:
      if (lookahead == '\n') SKIP(243)
      if (lookahead == '\r') SKIP(166)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 168:
      if (lookahead == '\n') SKIP(238)
      END_STATE();
    case 169:
      if (lookahead == '\n') SKIP(238)
      if (lookahead == '\r') SKIP(168)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 170:
      if (lookahead == '\n') SKIP(250)
      END_STATE();
    case 171:
      if (lookahead == '\n') SKIP(250)
      if (lookahead == '\r') SKIP(170)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 172:
      if (lookahead == '\n') SKIP(239)
      END_STATE();
    case 173:
      if (lookahead == '\n') SKIP(239)
      if (lookahead == '\r') SKIP(172)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 174:
      if (lookahead == '\n') SKIP(272)
      END_STATE();
    case 175:
      if (lookahead == '\n') SKIP(272)
      if (lookahead == '\r') SKIP(174)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 176:
      if (lookahead == '\n') SKIP(270)
      END_STATE();
    case 177:
      if (lookahead == '\n') SKIP(270)
      if (lookahead == '\r') SKIP(176)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 178:
      if (lookahead == '\n') SKIP(251)
      END_STATE();
    case 179:
      if (lookahead == '\n') SKIP(251)
      if (lookahead == '\r') SKIP(178)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 180:
      if (lookahead == '\n') SKIP(264)
      END_STATE();
    case 181:
      if (lookahead == '\n') SKIP(264)
      if (lookahead == '\r') SKIP(180)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 182:
      if (lookahead == '\n') SKIP(233)
      END_STATE();
    case 183:
      if (lookahead == '\n') SKIP(233)
      if (lookahead == '\r') SKIP(182)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 184:
      if (lookahead == '\n') SKIP(249)
      END_STATE();
    case 185:
      if (lookahead == '\n') SKIP(249)
      if (lookahead == '\r') SKIP(184)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 186:
      if (lookahead == '\n') SKIP(274)
      END_STATE();
    case 187:
      if (lookahead == '\n') SKIP(274)
      if (lookahead == '\r') SKIP(186)
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 188:
      if (lookahead == '!') ADVANCE(460);
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '#') ADVANCE(322);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '\'') ADVANCE(578);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(474);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(463);
      if (lookahead == '.') ADVANCE(544);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '0') ADVANCE(553);
      if (lookahead == ':') ADVANCE(528);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'B') ADVANCE(620);
      if (lookahead == 'F') ADVANCE(633);
      if (lookahead == 'L') ADVANCE(601);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'T') ADVANCE(630);
      if (lookahead == 'U') ADVANCE(605);
      if (lookahead == '[') ADVANCE(520);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead == ']') ADVANCE(522);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(622);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 't') ADVANCE(669);
      if (lookahead == 'u') ADVANCE(608);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (lookahead == '}') ADVANCE(517);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(188)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 189:
      if (lookahead == '!') ADVANCE(460);
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '#') ADVANCE(333);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '\'') ADVANCE(578);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(474);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(464);
      if (lookahead == '.') ADVANCE(544);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '0') ADVANCE(553);
      if (lookahead == ':') ADVANCE(528);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'B') ADVANCE(620);
      if (lookahead == 'F') ADVANCE(633);
      if (lookahead == 'L') ADVANCE(601);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'T') ADVANCE(630);
      if (lookahead == 'U') ADVANCE(605);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(127);
      if (lookahead == ']') ADVANCE(522);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(622);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 't') ADVANCE(669);
      if (lookahead == 'u') ADVANCE(608);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (lookahead == '}') ADVANCE(517);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(189)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 190:
      if (lookahead == '!') ADVANCE(460);
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '#') ADVANCE(333);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '\'') ADVANCE(578);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(475);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(465);
      if (lookahead == '.') ADVANCE(544);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == '0') ADVANCE(553);
      if (lookahead == ':') ADVANCE(528);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(498);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'B') ADVANCE(620);
      if (lookahead == 'F') ADVANCE(633);
      if (lookahead == 'L') ADVANCE(601);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'T') ADVANCE(630);
      if (lookahead == 'U') ADVANCE(605);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(165);
      if (lookahead == ']') ADVANCE(522);
      if (lookahead == '^') ADVANCE(490);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(622);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 't') ADVANCE(669);
      if (lookahead == 'u') ADVANCE(608);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(489);
      if (lookahead == '}') ADVANCE(517);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(190)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 191:
      if (lookahead == '!') ADVANCE(460);
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '#') ADVANCE(337);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '\'') ADVANCE(578);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(474);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(464);
      if (lookahead == '.') ADVANCE(544);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '0') ADVANCE(553);
      if (lookahead == ':') ADVANCE(307);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'B') ADVANCE(620);
      if (lookahead == 'F') ADVANCE(633);
      if (lookahead == 'L') ADVANCE(601);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'T') ADVANCE(630);
      if (lookahead == 'U') ADVANCE(605);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(14);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(622);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 't') ADVANCE(669);
      if (lookahead == 'u') ADVANCE(608);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(191)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 192:
      if (lookahead == '!') ADVANCE(460);
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '#') ADVANCE(337);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '\'') ADVANCE(578);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(475);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(465);
      if (lookahead == '.') ADVANCE(544);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == '0') ADVANCE(553);
      if (lookahead == ':') ADVANCE(307);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(498);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'B') ADVANCE(620);
      if (lookahead == 'F') ADVANCE(633);
      if (lookahead == 'L') ADVANCE(601);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'T') ADVANCE(630);
      if (lookahead == 'U') ADVANCE(605);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(131);
      if (lookahead == '^') ADVANCE(490);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(622);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 't') ADVANCE(669);
      if (lookahead == 'u') ADVANCE(608);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(489);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(192)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 193:
      if (lookahead == '!') ADVANCE(460);
      if (lookahead == '"') ADVANCE(587);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '\'') ADVANCE(578);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(474);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(463);
      if (lookahead == '.') ADVANCE(544);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '0') ADVANCE(553);
      if (lookahead == ':') ADVANCE(307);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'B') ADVANCE(620);
      if (lookahead == 'F') ADVANCE(633);
      if (lookahead == 'L') ADVANCE(601);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'T') ADVANCE(630);
      if (lookahead == 'U') ADVANCE(605);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(16);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(622);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 't') ADVANCE(669);
      if (lookahead == 'u') ADVANCE(608);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(193)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 194:
      if (lookahead == '!') ADVANCE(460);
      if (lookahead == '"') ADVANCE(587);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '\'') ADVANCE(578);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(474);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(464);
      if (lookahead == '.') ADVANCE(544);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '0') ADVANCE(553);
      if (lookahead == ':') ADVANCE(307);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'B') ADVANCE(620);
      if (lookahead == 'F') ADVANCE(633);
      if (lookahead == 'L') ADVANCE(601);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'T') ADVANCE(630);
      if (lookahead == 'U') ADVANCE(605);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(18);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(622);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 't') ADVANCE(669);
      if (lookahead == 'u') ADVANCE(608);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(194)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 195:
      if (lookahead == '!') ADVANCE(460);
      if (lookahead == '"') ADVANCE(587);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '\'') ADVANCE(578);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(475);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(465);
      if (lookahead == '.') ADVANCE(544);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == '0') ADVANCE(553);
      if (lookahead == ':') ADVANCE(307);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'B') ADVANCE(620);
      if (lookahead == 'F') ADVANCE(633);
      if (lookahead == 'L') ADVANCE(601);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'T') ADVANCE(630);
      if (lookahead == 'U') ADVANCE(605);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(133);
      if (lookahead == '^') ADVANCE(490);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(622);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 't') ADVANCE(669);
      if (lookahead == 'u') ADVANCE(608);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(489);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(195)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 196:
      if (lookahead == '!') ADVANCE(460);
      if (lookahead == '"') ADVANCE(279);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(289);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(467);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ':') ADVANCE(307);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '[') ADVANCE(319);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(656);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 'u') ADVANCE(649);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '|') ADVANCE(488);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(196)
      END_STATE();
    case 197:
      if (lookahead == '!') ADVANCE(460);
      if (lookahead == '"') ADVANCE(279);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(289);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(467);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '[') ADVANCE(320);
      if (lookahead == '\\') ADVANCE(90);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == '|') ADVANCE(488);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(197)
      END_STATE();
    case 198:
      if (lookahead == '!') ADVANCE(459);
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '#') ADVANCE(322);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(691);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '\'') ADVANCE(578);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(475);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(466);
      if (lookahead == '.') ADVANCE(357);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == '0') ADVANCE(553);
      if (lookahead == ':') ADVANCE(307);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(308);
      if (lookahead == '>') ADVANCE(311);
      if (lookahead == 'B') ADVANCE(620);
      if (lookahead == 'F') ADVANCE(633);
      if (lookahead == 'L') ADVANCE(601);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'T') ADVANCE(630);
      if (lookahead == 'U') ADVANCE(605);
      if (lookahead == '[') ADVANCE(519);
      if (lookahead == '\\') ADVANCE(6);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(622);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 't') ADVANCE(669);
      if (lookahead == 'u') ADVANCE(608);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(487);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(198)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 199:
      if (lookahead == '!') ADVANCE(459);
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '#') ADVANCE(328);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '\'') ADVANCE(578);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(475);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(466);
      if (lookahead == '.') ADVANCE(546);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == '0') ADVANCE(553);
      if (lookahead == ':') ADVANCE(528);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(503);
      if (lookahead == '=') ADVANCE(523);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == 'B') ADVANCE(620);
      if (lookahead == 'F') ADVANCE(633);
      if (lookahead == 'L') ADVANCE(601);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'T') ADVANCE(630);
      if (lookahead == 'U') ADVANCE(605);
      if (lookahead == '[') ADVANCE(519);
      if (lookahead == '\\') ADVANCE(4);
      if (lookahead == ']') ADVANCE(321);
      if (lookahead == '^') ADVANCE(490);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(622);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 't') ADVANCE(669);
      if (lookahead == 'u') ADVANCE(608);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(351);
      if (lookahead == '}') ADVANCE(517);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(199)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 200:
      if (lookahead == '!') ADVANCE(459);
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '#') ADVANCE(332);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(691);
      if (lookahead == '&') ADVANCE(492);
      if (lookahead == '\'') ADVANCE(578);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(475);
      if (lookahead == '-') ADVANCE(466);
      if (lookahead == '.') ADVANCE(297);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == '0') ADVANCE(553);
      if (lookahead == ':') ADVANCE(307);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == 'B') ADVANCE(620);
      if (lookahead == 'F') ADVANCE(633);
      if (lookahead == 'L') ADVANCE(601);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'T') ADVANCE(630);
      if (lookahead == 'U') ADVANCE(605);
      if (lookahead == '[') ADVANCE(519);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(622);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 't') ADVANCE(669);
      if (lookahead == 'u') ADVANCE(608);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(200)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 201:
      if (lookahead == '!') ADVANCE(459);
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '#') ADVANCE(324);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(691);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '\'') ADVANCE(578);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(475);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(466);
      if (lookahead == '.') ADVANCE(357);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == '0') ADVANCE(553);
      if (lookahead == ':') ADVANCE(307);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '>') ADVANCE(313);
      if (lookahead == 'B') ADVANCE(620);
      if (lookahead == 'F') ADVANCE(633);
      if (lookahead == 'L') ADVANCE(601);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'T') ADVANCE(630);
      if (lookahead == 'U') ADVANCE(605);
      if (lookahead == '[') ADVANCE(519);
      if (lookahead == '\\') ADVANCE(129);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(622);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 't') ADVANCE(669);
      if (lookahead == 'u') ADVANCE(608);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(201)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 202:
      if (lookahead == '!') ADVANCE(459);
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '#') ADVANCE(326);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(691);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '\'') ADVANCE(578);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(475);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(466);
      if (lookahead == '.') ADVANCE(357);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == '0') ADVANCE(553);
      if (lookahead == ':') ADVANCE(307);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '>') ADVANCE(497);
      if (lookahead == 'B') ADVANCE(620);
      if (lookahead == 'F') ADVANCE(633);
      if (lookahead == 'L') ADVANCE(601);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'T') ADVANCE(630);
      if (lookahead == 'U') ADVANCE(605);
      if (lookahead == '[') ADVANCE(519);
      if (lookahead == '\\') ADVANCE(8);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(622);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 't') ADVANCE(669);
      if (lookahead == 'u') ADVANCE(608);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(202)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 203:
      if (lookahead == '!') ADVANCE(459);
      if (lookahead == '"') ADVANCE(587);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(691);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '\'') ADVANCE(578);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(475);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(466);
      if (lookahead == '.') ADVANCE(545);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == '0') ADVANCE(553);
      if (lookahead == ':') ADVANCE(307);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(503);
      if (lookahead == '=') ADVANCE(523);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == 'B') ADVANCE(620);
      if (lookahead == 'F') ADVANCE(633);
      if (lookahead == 'L') ADVANCE(601);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'T') ADVANCE(630);
      if (lookahead == 'U') ADVANCE(605);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(12);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(622);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 't') ADVANCE(669);
      if (lookahead == 'u') ADVANCE(608);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(203)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 204:
      if (lookahead == '!') ADVANCE(459);
      if (lookahead == '"') ADVANCE(587);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(691);
      if (lookahead == '&') ADVANCE(492);
      if (lookahead == '\'') ADVANCE(578);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(475);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(466);
      if (lookahead == '.') ADVANCE(545);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == '0') ADVANCE(553);
      if (lookahead == ':') ADVANCE(528);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(503);
      if (lookahead == '=') ADVANCE(523);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == 'B') ADVANCE(620);
      if (lookahead == 'F') ADVANCE(633);
      if (lookahead == 'L') ADVANCE(601);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'T') ADVANCE(630);
      if (lookahead == 'U') ADVANCE(605);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(20);
      if (lookahead == ']') ADVANCE(522);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(622);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 't') ADVANCE(669);
      if (lookahead == 'u') ADVANCE(608);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '}') ADVANCE(517);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(204)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 205:
      if (lookahead == '!') ADVANCE(459);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(691);
      if (lookahead == '\'') ADVANCE(578);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '+') ADVANCE(477);
      if (lookahead == '-') ADVANCE(470);
      if (lookahead == '.') ADVANCE(357);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == '0') ADVANCE(553);
      if (lookahead == 'B') ADVANCE(620);
      if (lookahead == 'L') ADVANCE(688);
      if (lookahead == 'U') ADVANCE(689);
      if (lookahead == '\\') ADVANCE(106);
      if (lookahead == 'u') ADVANCE(626);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(205)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 206:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '#') ADVANCE(333);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ':') ADVANCE(527);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'L') ADVANCE(711);
      if (lookahead == 'R') ADVANCE(712);
      if (lookahead == 'U') ADVANCE(713);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(48);
      if (lookahead == ']') ADVANCE(522);
      if (lookahead == '^') ADVANCE(491);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 't') ||
          ('v' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      if (lookahead == 'u') ADVANCE(714);
      if (lookahead == '|') ADVANCE(488);
      if (lookahead == '}') ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(209)
      END_STATE();
    case 207:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '#') ADVANCE(333);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(473);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(469);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == ':') ADVANCE(527);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(498);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'L') ADVANCE(711);
      if (lookahead == 'R') ADVANCE(712);
      if (lookahead == 'U') ADVANCE(713);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(139);
      if (lookahead == ']') ADVANCE(522);
      if (lookahead == '^') ADVANCE(490);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 't') ||
          ('v' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      if (lookahead == 'u') ADVANCE(714);
      if (lookahead == '|') ADVANCE(489);
      if (lookahead == '}') ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(210)
      END_STATE();
    case 208:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '#') ADVANCE(333);
      if (sym_identifier_character_set_6(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ':') ADVANCE(528);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'L') ADVANCE(602);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'U') ADVANCE(606);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(44);
      if (lookahead == ']') ADVANCE(522);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == 'u') ADVANCE(609);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (lookahead == '}') ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(208)
      END_STATE();
    case 209:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '#') ADVANCE(333);
      if (sym_identifier_character_set_6(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ':') ADVANCE(527);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'L') ADVANCE(602);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'U') ADVANCE(606);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(48);
      if (lookahead == ']') ADVANCE(522);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == 'u') ADVANCE(609);
      if (lookahead == '|') ADVANCE(488);
      if (lookahead == '}') ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(209)
      END_STATE();
    case 210:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '#') ADVANCE(333);
      if (sym_identifier_character_set_6(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(473);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(469);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == ':') ADVANCE(527);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(498);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'L') ADVANCE(602);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'U') ADVANCE(606);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(139);
      if (lookahead == ']') ADVANCE(522);
      if (lookahead == '^') ADVANCE(490);
      if (lookahead == 'u') ADVANCE(609);
      if (lookahead == '|') ADVANCE(489);
      if (lookahead == '}') ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(210)
      END_STATE();
    case 211:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '#') ADVANCE(337);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'L') ADVANCE(711);
      if (lookahead == 'R') ADVANCE(712);
      if (lookahead == 'U') ADVANCE(713);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead == '^') ADVANCE(491);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 't') ||
          ('v' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      if (lookahead == 'u') ADVANCE(714);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(214)
      END_STATE();
    case 212:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '#') ADVANCE(337);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(473);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(469);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(498);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'L') ADVANCE(711);
      if (lookahead == 'R') ADVANCE(712);
      if (lookahead == 'U') ADVANCE(713);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(145);
      if (lookahead == '^') ADVANCE(490);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 't') ||
          ('v' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      if (lookahead == 'u') ADVANCE(714);
      if (lookahead == '|') ADVANCE(489);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(215)
      END_STATE();
    case 213:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '#') ADVANCE(337);
      if (sym_identifier_character_set_6(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ':') ADVANCE(307);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'L') ADVANCE(602);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'U') ADVANCE(606);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(54);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == 'u') ADVANCE(609);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(213)
      END_STATE();
    case 214:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '#') ADVANCE(337);
      if (sym_identifier_character_set_6(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'L') ADVANCE(602);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'U') ADVANCE(606);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == 'u') ADVANCE(609);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(214)
      END_STATE();
    case 215:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '#') ADVANCE(337);
      if (sym_identifier_character_set_6(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(473);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(469);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(498);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'L') ADVANCE(602);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'U') ADVANCE(606);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(145);
      if (lookahead == '^') ADVANCE(490);
      if (lookahead == 'u') ADVANCE(609);
      if (lookahead == '|') ADVANCE(489);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(215)
      END_STATE();
    case 216:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '"') ADVANCE(587);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(467);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'L') ADVANCE(711);
      if (lookahead == 'R') ADVANCE(712);
      if (lookahead == 'U') ADVANCE(713);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(60);
      if (lookahead == '^') ADVANCE(491);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 't') ||
          ('v' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      if (lookahead == 'u') ADVANCE(714);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(221)
      END_STATE();
    case 217:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '"') ADVANCE(587);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'L') ADVANCE(711);
      if (lookahead == 'R') ADVANCE(712);
      if (lookahead == 'U') ADVANCE(713);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(66);
      if (lookahead == '^') ADVANCE(491);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 't') ||
          ('v' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      if (lookahead == 'u') ADVANCE(714);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(224)
      END_STATE();
    case 218:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '"') ADVANCE(587);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(473);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(469);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'L') ADVANCE(711);
      if (lookahead == 'R') ADVANCE(712);
      if (lookahead == 'U') ADVANCE(713);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(149);
      if (lookahead == '^') ADVANCE(490);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 't') ||
          ('v' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      if (lookahead == 'u') ADVANCE(714);
      if (lookahead == '|') ADVANCE(489);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(225)
      END_STATE();
    case 219:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '"') ADVANCE(587);
      if (sym_identifier_character_set_6(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(467);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ':') ADVANCE(307);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'L') ADVANCE(602);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'U') ADVANCE(606);
      if (lookahead == '[') ADVANCE(519);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == 'u') ADVANCE(609);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(219)
      END_STATE();
    case 220:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '"') ADVANCE(587);
      if (sym_identifier_character_set_6(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(467);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ':') ADVANCE(307);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'L') ADVANCE(602);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'U') ADVANCE(606);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(40);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == 'u') ADVANCE(609);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(220)
      END_STATE();
    case 221:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '"') ADVANCE(587);
      if (sym_identifier_character_set_6(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(467);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'L') ADVANCE(602);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'U') ADVANCE(606);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(60);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == 'u') ADVANCE(609);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(221)
      END_STATE();
    case 222:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '"') ADVANCE(587);
      if (sym_identifier_character_set_6(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ':') ADVANCE(528);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'L') ADVANCE(602);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'U') ADVANCE(606);
      if (lookahead == '[') ADVANCE(519);
      if (lookahead == '\\') ADVANCE(32);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == 'u') ADVANCE(609);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (lookahead == '}') ADVANCE(517);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(222)
      END_STATE();
    case 223:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '"') ADVANCE(587);
      if (sym_identifier_character_set_6(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ':') ADVANCE(307);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'L') ADVANCE(602);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'U') ADVANCE(606);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(42);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == 'u') ADVANCE(609);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(223)
      END_STATE();
    case 224:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '"') ADVANCE(587);
      if (sym_identifier_character_set_6(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'L') ADVANCE(602);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'U') ADVANCE(606);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(66);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == 'u') ADVANCE(609);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(224)
      END_STATE();
    case 225:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '"') ADVANCE(587);
      if (sym_identifier_character_set_6(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(473);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(469);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'L') ADVANCE(602);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'U') ADVANCE(606);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(149);
      if (lookahead == '^') ADVANCE(490);
      if (lookahead == 'u') ADVANCE(609);
      if (lookahead == '|') ADVANCE(489);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(225)
      END_STATE();
    case 226:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(347);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(473);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(469);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == ':') ADVANCE(528);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(498);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(519);
      if (lookahead == '\\') ADVANCE(135);
      if (lookahead == '^') ADVANCE(490);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(489);
      if (lookahead == '}') ADVANCE(517);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(226)
      END_STATE();
    case 227:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(333);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ':') ADVANCE(527);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(155);
      if (lookahead == ']') ADVANCE(522);
      if (lookahead == '^') ADVANCE(491);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      if (lookahead == '|') ADVANCE(488);
      if (lookahead == '}') ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(235)
      END_STATE();
    case 228:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(333);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(473);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(469);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == ':') ADVANCE(527);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(498);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(173);
      if (lookahead == ']') ADVANCE(522);
      if (lookahead == '^') ADVANCE(490);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      if (lookahead == '|') ADVANCE(489);
      if (lookahead == '}') ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(239)
      END_STATE();
    case 229:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(333);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ':') ADVANCE(527);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(137);
      if (lookahead == ']') ADVANCE(522);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(656);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 'u') ADVANCE(649);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (lookahead == '}') ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(229)
      END_STATE();
    case 230:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(333);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(473);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(469);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == ':') ADVANCE(527);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(498);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(46);
      if (lookahead == ']') ADVANCE(522);
      if (lookahead == '^') ADVANCE(490);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(656);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 'u') ADVANCE(649);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(489);
      if (lookahead == '}') ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(230)
      END_STATE();
    case 231:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(333);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(467);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ':') ADVANCE(307);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(519);
      if (lookahead == '\\') ADVANCE(38);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(231)
      END_STATE();
    case 232:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(333);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ':') ADVANCE(528);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(143);
      if (lookahead == ']') ADVANCE(522);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (lookahead == '}') ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(232)
      END_STATE();
    case 233:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(333);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ':') ADVANCE(527);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(519);
      if (lookahead == '\\') ADVANCE(183);
      if (lookahead == ']') ADVANCE(522);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (lookahead == '}') ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(233)
      END_STATE();
    case 234:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(333);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ':') ADVANCE(527);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(52);
      if (lookahead == ']') ADVANCE(522);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (lookahead == '}') ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(234)
      END_STATE();
    case 235:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(333);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ':') ADVANCE(527);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(155);
      if (lookahead == ']') ADVANCE(522);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == '|') ADVANCE(488);
      if (lookahead == '}') ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(235)
      END_STATE();
    case 236:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(333);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ':') ADVANCE(527);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(521);
      if (lookahead == '\\') ADVANCE(74);
      if (lookahead == ']') ADVANCE(522);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == '|') ADVANCE(488);
      if (lookahead == '}') ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(236)
      END_STATE();
    case 237:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(333);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(473);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(469);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == ':') ADVANCE(528);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(498);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == ']') ADVANCE(522);
      if (lookahead == '^') ADVANCE(490);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(489);
      if (lookahead == '}') ADVANCE(517);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(237)
      END_STATE();
    case 238:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(333);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(473);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(469);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == ':') ADVANCE(527);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(498);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(169);
      if (lookahead == ']') ADVANCE(522);
      if (lookahead == '^') ADVANCE(490);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(489);
      if (lookahead == '}') ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(238)
      END_STATE();
    case 239:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(333);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(473);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(469);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == ':') ADVANCE(527);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(498);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(173);
      if (lookahead == ']') ADVANCE(522);
      if (lookahead == '^') ADVANCE(490);
      if (lookahead == '|') ADVANCE(489);
      if (lookahead == '}') ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(239)
      END_STATE();
    case 240:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(337);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(88);
      if (lookahead == '^') ADVANCE(491);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(247)
      END_STATE();
    case 241:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(337);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(473);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(469);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(498);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(179);
      if (lookahead == '^') ADVANCE(490);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      if (lookahead == '|') ADVANCE(489);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(251)
      END_STATE();
    case 242:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(337);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(62);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(656);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 'u') ADVANCE(649);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(242)
      END_STATE();
    case 243:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(337);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(473);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(469);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == ':') ADVANCE(528);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(498);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(167);
      if (lookahead == ']') ADVANCE(522);
      if (lookahead == '^') ADVANCE(490);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(656);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 'u') ADVANCE(649);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(489);
      if (lookahead == '}') ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(243)
      END_STATE();
    case 244:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(337);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ':') ADVANCE(528);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(519);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (lookahead == '}') ADVANCE(517);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(244)
      END_STATE();
    case 245:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(337);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ':') ADVANCE(528);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(153);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(245)
      END_STATE();
    case 246:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(337);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ':') ADVANCE(527);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(72);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(246)
      END_STATE();
    case 247:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(337);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(88);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(247)
      END_STATE();
    case 248:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(337);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(521);
      if (lookahead == '\\') ADVANCE(161);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(248)
      END_STATE();
    case 249:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(337);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(473);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(469);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == ':') ADVANCE(528);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(498);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(185);
      if (lookahead == '^') ADVANCE(490);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(489);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(249)
      END_STATE();
    case 250:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(337);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(473);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(469);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == ':') ADVANCE(527);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(498);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(171);
      if (lookahead == '^') ADVANCE(490);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(489);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(250)
      END_STATE();
    case 251:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(337);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(473);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(469);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(498);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(179);
      if (lookahead == '^') ADVANCE(490);
      if (lookahead == '|') ADVANCE(489);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(251)
      END_STATE();
    case 252:
      if (lookahead == '!') ADVANCE(309);
      if (lookahead == '#') ADVANCE(327);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(472);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(462);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == ':') ADVANCE(307);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(507);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(498);
      if (lookahead == '[') ADVANCE(519);
      if (lookahead == '\\') ADVANCE(24);
      if (lookahead == '^') ADVANCE(490);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(656);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 'u') ADVANCE(649);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '|') ADVANCE(489);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(252)
      END_STATE();
    case 253:
      if (lookahead == '!') ADVANCE(309);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(467);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(163);
      if (lookahead == '^') ADVANCE(491);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(263)
      END_STATE();
    case 254:
      if (lookahead == '!') ADVANCE(309);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(159);
      if (lookahead == '^') ADVANCE(491);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(269)
      END_STATE();
    case 255:
      if (lookahead == '!') ADVANCE(309);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(473);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(469);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(187);
      if (lookahead == '^') ADVANCE(490);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      if (lookahead == '|') ADVANCE(489);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(274)
      END_STATE();
    case 256:
      if (lookahead == '!') ADVANCE(309);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(467);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(68);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(656);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 'u') ADVANCE(649);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(256)
      END_STATE();
    case 257:
      if (lookahead == '!') ADVANCE(309);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(147);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(656);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 'u') ADVANCE(649);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(257)
      END_STATE();
    case 258:
      if (lookahead == '!') ADVANCE(309);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(473);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(469);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == ':') ADVANCE(307);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(498);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(82);
      if (lookahead == ']') ADVANCE(321);
      if (lookahead == '^') ADVANCE(490);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(656);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 'u') ADVANCE(649);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(489);
      if (lookahead == '}') ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(258)
      END_STATE();
    case 259:
      if (lookahead == '!') ADVANCE(309);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(473);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(469);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(64);
      if (lookahead == '^') ADVANCE(490);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(656);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 'u') ADVANCE(649);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(489);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(259)
      END_STATE();
    case 260:
      if (lookahead == '!') ADVANCE(309);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(467);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ':') ADVANCE(528);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(50);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(260)
      END_STATE();
    case 261:
      if (lookahead == '!') ADVANCE(309);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(467);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ':') ADVANCE(527);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(261)
      END_STATE();
    case 262:
      if (lookahead == '!') ADVANCE(309);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(467);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(520);
      if (lookahead == '\\') ADVANCE(96);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(262)
      END_STATE();
    case 263:
      if (lookahead == '!') ADVANCE(309);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(467);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(163);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(263)
      END_STATE();
    case 264:
      if (lookahead == '!') ADVANCE(309);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(467);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(521);
      if (lookahead == '\\') ADVANCE(181);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(264)
      END_STATE();
    case 265:
      if (lookahead == '!') ADVANCE(309);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ':') ADVANCE(528);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(141);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(265)
      END_STATE();
    case 266:
      if (lookahead == '!') ADVANCE(309);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ':') ADVANCE(527);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(157);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(266)
      END_STATE();
    case 267:
      if (lookahead == '!') ADVANCE(309);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(520);
      if (lookahead == '\\') ADVANCE(94);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == '|') ADVANCE(488);
      if (lookahead == '}') ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(267)
      END_STATE();
    case 268:
      if (lookahead == '!') ADVANCE(309);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(519);
      if (lookahead == '\\') ADVANCE(86);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(268)
      END_STATE();
    case 269:
      if (lookahead == '!') ADVANCE(309);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(159);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(269)
      END_STATE();
    case 270:
      if (lookahead == '!') ADVANCE(309);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(476);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(468);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(521);
      if (lookahead == '\\') ADVANCE(177);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(270)
      END_STATE();
    case 271:
      if (lookahead == '!') ADVANCE(309);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(478);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(471);
      if (lookahead == '.') ADVANCE(290);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '<') ADVANCE(505);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(499);
      if (lookahead == '\\') ADVANCE(100);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == '|') ADVANCE(488);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(271)
      END_STATE();
    case 272:
      if (lookahead == '!') ADVANCE(309);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(473);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(469);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == ':') ADVANCE(528);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(175);
      if (lookahead == '^') ADVANCE(490);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(489);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(272)
      END_STATE();
    case 273:
      if (lookahead == '!') ADVANCE(309);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(473);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(469);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == ':') ADVANCE(527);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(78);
      if (lookahead == '^') ADVANCE(490);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(489);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(273)
      END_STATE();
    case 274:
      if (lookahead == '!') ADVANCE(309);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(473);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(469);
      if (lookahead == '.') ADVANCE(543);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(310);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(187);
      if (lookahead == '^') ADVANCE(490);
      if (lookahead == '|') ADVANCE(489);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(274)
      END_STATE();
    case 275:
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == '\\') ADVANCE(117);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(275)
      END_STATE();
    case 276:
      if (lookahead == '"') ADVANCE(587);
      if (sym_identifier_character_set_7(lookahead)) ADVANCE(691);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == ':') ADVANCE(307);
      if (lookahead == 'L') ADVANCE(603);
      if (lookahead == 'U') ADVANCE(607);
      if (lookahead == '[') ADVANCE(519);
      if (lookahead == '\\') ADVANCE(80);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(656);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 'u') ADVANCE(610);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(276)
      END_STATE();
    case 277:
      if (lookahead == '"') ADVANCE(587);
      if (sym_identifier_character_set_6(lookahead)) ADVANCE(691);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == ':') ADVANCE(527);
      if (lookahead == 'L') ADVANCE(602);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'U') ADVANCE(606);
      if (lookahead == '\\') ADVANCE(111);
      if (lookahead == 'u') ADVANCE(609);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(277)
      END_STATE();
    case 278:
      if (lookahead == '"') ADVANCE(587);
      if (sym_identifier_character_set_8(lookahead)) ADVANCE(691);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == '<') ADVANCE(315);
      if (lookahead == 'L') ADVANCE(603);
      if (lookahead == 'U') ADVANCE(607);
      if (lookahead == '\\') ADVANCE(115);
      if (lookahead == 'u') ADVANCE(611);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(278)
      END_STATE();
    case 279:
      if (lookahead == '"') ADVANCE(710);
      END_STATE();
    case 280:
      if (lookahead == '#') ADVANCE(329);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(691);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == ':') ADVANCE(307);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '[') ADVANCE(519);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(656);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 'u') ADVANCE(649);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '}') ADVANCE(517);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(280)
      END_STATE();
    case 281:
      if (lookahead == '#') ADVANCE(333);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(314);
      if (lookahead == '.') ADVANCE(296);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == ':') ADVANCE(528);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(503);
      if (lookahead == '=') ADVANCE(523);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '[') ADVANCE(519);
      if (lookahead == '\\') ADVANCE(70);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(351);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(281)
      END_STATE();
    case 282:
      if (lookahead == '#') ADVANCE(323);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(691);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(472);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(314);
      if (lookahead == '.') ADVANCE(296);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == ':') ADVANCE(528);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(503);
      if (lookahead == '=') ADVANCE(523);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '[') ADVANCE(519);
      if (lookahead == '\\') ADVANCE(22);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(656);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 'u') ADVANCE(649);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(351);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(282)
      END_STATE();
    case 283:
      if (lookahead == '#') ADVANCE(325);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(691);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == ':') ADVANCE(307);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '[') ADVANCE(519);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(656);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 'u') ADVANCE(649);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(283)
      END_STATE();
    case 284:
      if (lookahead == '#') ADVANCE(337);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(314);
      if (lookahead == '.') ADVANCE(296);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == ':') ADVANCE(528);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(503);
      if (lookahead == '=') ADVANCE(523);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(151);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(351);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(284)
      END_STATE();
    case 285:
      if (lookahead == '\'') ADVANCE(578);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == '\\') ADVANCE(117);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(285)
      END_STATE();
    case 286:
      if (lookahead == '\'') ADVANCE(362);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(352);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(286);
      END_STATE();
    case 287:
      if (lookahead == '\'') ADVANCE(358);
      if (lookahead == '.') ADVANCE(559);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(352);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(287);
      END_STATE();
    case 288:
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == '\\') SKIP(125)
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(288)
      END_STATE();
    case 289:
      if (lookahead == ')') ADVANCE(708);
      END_STATE();
    case 290:
      if (lookahead == '*') ADVANCE(547);
      END_STATE();
    case 291:
      if (lookahead == '*') ADVANCE(294);
      if (lookahead == '/') ADVANCE(696);
      END_STATE();
    case 292:
      if (lookahead == '*') ADVANCE(707);
      END_STATE();
    case 293:
      if (lookahead == '*') ADVANCE(293);
      if (lookahead == '/') ADVANCE(692);
      if (lookahead != 0) ADVANCE(294);
      END_STATE();
    case 294:
      if (lookahead == '*') ADVANCE(293);
      if (lookahead != 0) ADVANCE(294);
      END_STATE();
    case 295:
      if (lookahead == '*') ADVANCE(293);
      if (lookahead != 0) ADVANCE(413);
      END_STATE();
    case 296:
      if (lookahead == '.') ADVANCE(298);
      END_STATE();
    case 297:
      if (lookahead == '.') ADVANCE(298);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(551);
      END_STATE();
    case 298:
      if (lookahead == '.') ADVANCE(393);
      END_STATE();
    case 299:
      if (lookahead == '.') ADVANCE(362);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(557);
      END_STATE();
    case 300:
      if (lookahead == '/') ADVANCE(417);
      if (lookahead == '\\') ADVANCE(415);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(300)
      if (lookahead != 0) ADVANCE(418);
      END_STATE();
    case 301:
      if (lookahead == '1') ADVANCE(305);
      END_STATE();
    case 302:
      if (lookahead == '2') ADVANCE(550);
      END_STATE();
    case 303:
      if (lookahead == '2') ADVANCE(306);
      if (lookahead == '6') ADVANCE(550);
      END_STATE();
    case 304:
      if (lookahead == '4') ADVANCE(550);
      END_STATE();
    case 305:
      if (lookahead == '6') ADVANCE(550);
      END_STATE();
    case 306:
      if (lookahead == '8') ADVANCE(550);
      END_STATE();
    case 307:
      if (lookahead == ':') ADVANCE(513);
      END_STATE();
    case 308:
      if (lookahead == '<') ADVANCE(508);
      if (lookahead == '=') ADVANCE(501);
      END_STATE();
    case 309:
      if (lookahead == '=') ADVANCE(496);
      END_STATE();
    case 310:
      if (lookahead == '=') ADVANCE(495);
      END_STATE();
    case 311:
      if (lookahead == '=') ADVANCE(500);
      if (lookahead == '>') ADVANCE(510);
      END_STATE();
    case 312:
      if (lookahead == '=') ADVANCE(536);
      END_STATE();
    case 313:
      if (lookahead == '>') ADVANCE(312);
      END_STATE();
    case 314:
      if (lookahead == '>') ADVANCE(548);
      END_STATE();
    case 315:
      if (lookahead == '>') ADVANCE(597);
      if (lookahead == '\\') ADVANCE(316);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(315);
      END_STATE();
    case 316:
      if (lookahead == '>') ADVANCE(598);
      if (lookahead == '\\') ADVANCE(316);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(315);
      END_STATE();
    case 317:
      if (lookahead == 'F') ADVANCE(301);
      END_STATE();
    case 318:
      if (lookahead == 'U') ADVANCE(376);
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 319:
      if (lookahead == '[') ADVANCE(514);
      if (lookahead == ']') ADVANCE(709);
      END_STATE();
    case 320:
      if (lookahead == ']') ADVANCE(709);
      END_STATE();
    case 321:
      if (lookahead == ']') ADVANCE(515);
      END_STATE();
    case 322:
      if (lookahead == 'd') ADVANCE(429);
      if (lookahead == 'e') ADVANCE(451);
      if (lookahead == 'i') ADVANCE(437);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(322);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 323:
      if (lookahead == 'd') ADVANCE(429);
      if (lookahead == 'e') ADVANCE(451);
      if (lookahead == 'i') ADVANCE(438);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(323);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 324:
      if (lookahead == 'd') ADVANCE(429);
      if (lookahead == 'e') ADVANCE(454);
      if (lookahead == 'i') ADVANCE(437);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(324);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 325:
      if (lookahead == 'd') ADVANCE(429);
      if (lookahead == 'e') ADVANCE(454);
      if (lookahead == 'i') ADVANCE(438);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(325);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 326:
      if (lookahead == 'd') ADVANCE(429);
      if (lookahead == 'e') ADVANCE(453);
      if (lookahead == 'i') ADVANCE(437);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(326);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 327:
      if (lookahead == 'd') ADVANCE(429);
      if (lookahead == 'e') ADVANCE(453);
      if (lookahead == 'i') ADVANCE(438);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(327);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 328:
      if (lookahead == 'd') ADVANCE(429);
      if (lookahead == 'i') ADVANCE(437);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(328);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 329:
      if (lookahead == 'd') ADVANCE(429);
      if (lookahead == 'i') ADVANCE(438);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(329);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 330:
      if (lookahead == 'd') ADVANCE(344);
      END_STATE();
    case 331:
      if (lookahead == 'd') ADVANCE(336);
      END_STATE();
    case 332:
      if (lookahead == 'e') ADVANCE(350);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(332);
      END_STATE();
    case 333:
      if (lookahead == 'e') ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(333);
      END_STATE();
    case 334:
      if (lookahead == 'e') ADVANCE(402);
      END_STATE();
    case 335:
      if (lookahead == 'e') ADVANCE(341);
      END_STATE();
    case 336:
      if (lookahead == 'e') ADVANCE(342);
      END_STATE();
    case 337:
      if (lookahead == 'e') ADVANCE(349);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(337);
      END_STATE();
    case 338:
      if (lookahead == 'f') ADVANCE(301);
      END_STATE();
    case 339:
      if (lookahead == 'f') ADVANCE(398);
      END_STATE();
    case 340:
      if (lookahead == 'f') ADVANCE(405);
      END_STATE();
    case 341:
      if (lookahead == 'f') ADVANCE(408);
      END_STATE();
    case 342:
      if (lookahead == 'f') ADVANCE(410);
      END_STATE();
    case 343:
      if (lookahead == 'f') ADVANCE(404);
      END_STATE();
    case 344:
      if (lookahead == 'i') ADVANCE(339);
      END_STATE();
    case 345:
      if (lookahead == 'i') ADVANCE(340);
      if (lookahead == 's') ADVANCE(334);
      END_STATE();
    case 346:
      if (lookahead == 'i') ADVANCE(343);
      if (lookahead == 's') ADVANCE(334);
      END_STATE();
    case 347:
      if (lookahead == 'i') ADVANCE(438);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(347);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 348:
      if (lookahead == 'l') ADVANCE(345);
      if (lookahead == 'n') ADVANCE(330);
      END_STATE();
    case 349:
      if (lookahead == 'l') ADVANCE(346);
      if (lookahead == 'n') ADVANCE(330);
      END_STATE();
    case 350:
      if (lookahead == 'n') ADVANCE(330);
      END_STATE();
    case 351:
      if (lookahead == '|') ADVANCE(485);
      END_STATE();
    case 352:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(359);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(556);
      END_STATE();
    case 353:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(352);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(286);
      END_STATE();
    case 354:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(554);
      END_STATE();
    case 355:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(287);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(552);
      END_STATE();
    case 356:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 357:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(551);
      END_STATE();
    case 358:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(287);
      END_STATE();
    case 359:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(556);
      END_STATE();
    case 360:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(691);
      END_STATE();
    case 361:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(557);
      END_STATE();
    case 362:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(286);
      END_STATE();
    case 363:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(593);
      END_STATE();
    case 364:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(360);
      END_STATE();
    case 365:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(363);
      END_STATE();
    case 366:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(364);
      END_STATE();
    case 367:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(365);
      END_STATE();
    case 368:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(366);
      END_STATE();
    case 369:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(367);
      END_STATE();
    case 370:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(368);
      END_STATE();
    case 371:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(369);
      END_STATE();
    case 372:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(370);
      END_STATE();
    case 373:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(371);
      END_STATE();
    case 374:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(372);
      END_STATE();
    case 375:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(373);
      END_STATE();
    case 376:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(374);
      END_STATE();
    case 377:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(375);
      END_STATE();
    case 378:
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(691);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == ':') ADVANCE(527);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(503);
      if (lookahead == '=') ADVANCE(523);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '[') ADVANCE(519);
      if (lookahead == '\\') ADVANCE(84);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(656);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 'u') ADVANCE(649);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(378)
      END_STATE();
    case 379:
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(691);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '=') ADVANCE(523);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(98);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(656);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 'u') ADVANCE(649);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(379)
      END_STATE();
    case 380:
      if (sym_identifier_character_set_9(lookahead)) ADVANCE(691);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == ':') ADVANCE(307);
      if (lookahead == 'F') ADVANCE(633);
      if (lookahead == 'T') ADVANCE(630);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(104);
      if (lookahead == 'f') ADVANCE(681);
      if (lookahead == 't') ADVANCE(669);
      if (lookahead == '{') ADVANCE(516);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(380)
      END_STATE();
    case 381:
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(314);
      if (lookahead == '.') ADVANCE(296);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == ':') ADVANCE(527);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(503);
      if (lookahead == '=') ADVANCE(523);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '[') ADVANCE(519);
      if (lookahead == '\\') ADVANCE(92);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(381)
      END_STATE();
    case 382:
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '.') ADVANCE(296);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == ':') ADVANCE(527);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '=') ADVANCE(523);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '[') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(102);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(382)
      END_STATE();
    case 383:
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(691);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead == ':') ADVANCE(527);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(503);
      if (lookahead == '=') ADVANCE(523);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '[') ADVANCE(520);
      if (lookahead == '\\') ADVANCE(113);
      if (lookahead == '{') ADVANCE(516);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(383)
      END_STATE();
    case 384:
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '\\') ADVANCE(696);
      if (lookahead == '\r') ADVANCE(700);
      if (lookahead == '\\') ADVANCE(698);
      END_STATE();
    case 385:
      if (lookahead != 0 &&
          lookahead != '*') ADVANCE(418);
      END_STATE();
    case 386:
      if (eof) ADVANCE(388);
      if (lookahead == '!') ADVANCE(460);
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '#') ADVANCE(322);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(484);
      if (lookahead == '&') ADVANCE(494);
      if (lookahead == '\'') ADVANCE(578);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(480);
      if (lookahead == '+') ADVANCE(474);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(463);
      if (lookahead == '.') ADVANCE(544);
      if (lookahead == '/') ADVANCE(482);
      if (lookahead == '0') ADVANCE(553);
      if (lookahead == ':') ADVANCE(528);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(504);
      if (lookahead == '=') ADVANCE(524);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == '?') ADVANCE(529);
      if (lookahead == 'B') ADVANCE(620);
      if (lookahead == 'F') ADVANCE(633);
      if (lookahead == 'L') ADVANCE(601);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'T') ADVANCE(630);
      if (lookahead == 'U') ADVANCE(605);
      if (lookahead == '[') ADVANCE(520);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead == ']') ADVANCE(522);
      if (lookahead == '^') ADVANCE(491);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(622);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 't') ADVANCE(669);
      if (lookahead == 'u') ADVANCE(608);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(488);
      if (lookahead == '}') ADVANCE(517);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(386)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 387:
      if (eof) ADVANCE(388);
      if (lookahead == '!') ADVANCE(459);
      if (lookahead == '"') ADVANCE(587);
      if (lookahead == '#') ADVANCE(328);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(691);
      if (lookahead == '%') ADVANCE(483);
      if (lookahead == '&') ADVANCE(493);
      if (lookahead == '\'') ADVANCE(578);
      if (lookahead == '(') ADVANCE(458);
      if (lookahead == ')') ADVANCE(395);
      if (lookahead == '*') ADVANCE(479);
      if (lookahead == '+') ADVANCE(475);
      if (lookahead == ',') ADVANCE(394);
      if (lookahead == '-') ADVANCE(466);
      if (lookahead == '.') ADVANCE(546);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead == '0') ADVANCE(553);
      if (lookahead == ':') ADVANCE(528);
      if (lookahead == ';') ADVANCE(512);
      if (lookahead == '<') ADVANCE(503);
      if (lookahead == '=') ADVANCE(523);
      if (lookahead == '>') ADVANCE(701);
      if (lookahead == 'B') ADVANCE(620);
      if (lookahead == 'F') ADVANCE(633);
      if (lookahead == 'L') ADVANCE(601);
      if (lookahead == 'R') ADVANCE(604);
      if (lookahead == 'T') ADVANCE(630);
      if (lookahead == 'U') ADVANCE(605);
      if (lookahead == '[') ADVANCE(519);
      if (lookahead == '\\') ADVANCE(4);
      if (lookahead == ']') ADVANCE(321);
      if (lookahead == '^') ADVANCE(490);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(644);
      if (lookahead == 'd') ADVANCE(660);
      if (lookahead == 'f') ADVANCE(622);
      if (lookahead == 'i') ADVANCE(657);
      if (lookahead == 'm') ADVANCE(682);
      if (lookahead == 'n') ADVANCE(677);
      if (lookahead == 'p') ADVANCE(674);
      if (lookahead == 's') ADVANCE(621);
      if (lookahead == 't') ADVANCE(669);
      if (lookahead == 'u') ADVANCE(608);
      if (lookahead == 'v') ADVANCE(661);
      if (lookahead == '{') ADVANCE(516);
      if (lookahead == '|') ADVANCE(351);
      if (lookahead == '}') ADVANCE(517);
      if (lookahead == '~') ADVANCE(461);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(387)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(aux_sym_preproc_include_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(aux_sym_preproc_include_token2);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(aux_sym_preproc_def_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(aux_sym_preproc_if_token1);
      if (lookahead == 'd') ADVANCE(433);
      if (lookahead == 'n') ADVANCE(427);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(397);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (lookahead == 'd') ADVANCE(335);
      if (lookahead == 'n') ADVANCE(331);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (lookahead == 'd') ADVANCE(435);
      if (lookahead == 'n') ADVANCE(428);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token1);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token2);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(294);
      if (lookahead == '*') ADVANCE(412);
      if (lookahead == '/') ADVANCE(692);
      if (lookahead == '\\') ADVANCE(419);
      if (lookahead != 0) ADVANCE(413);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(294);
      if (lookahead == '*') ADVANCE(412);
      if (lookahead == '/') ADVANCE(295);
      if (lookahead == '\\') ADVANCE(419);
      if (lookahead != 0) ADVANCE(413);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(696);
      if (lookahead == '\r') ADVANCE(693);
      if (lookahead == '/') ADVANCE(694);
      if (lookahead == '\\') ADVANCE(697);
      if (lookahead != 0) ADVANCE(695);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(300)
      if (lookahead == '\r') ADVANCE(416);
      if (lookahead == '/') ADVANCE(385);
      if (lookahead == '\\') ADVANCE(420);
      if (lookahead != 0) ADVANCE(418);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(300)
      if (lookahead == '/') ADVANCE(385);
      if (lookahead == '\\') ADVANCE(420);
      if (lookahead != 0) ADVANCE(418);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(413);
      if (lookahead == '/') ADVANCE(694);
      if (lookahead == '\\') ADVANCE(420);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(418);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(385);
      if (lookahead == '\\') ADVANCE(420);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(418);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '*' &&
          lookahead != '/' &&
          lookahead != '\\') ADVANCE(413);
      if (lookahead == '\r') ADVANCE(422);
      if (lookahead == '*') ADVANCE(412);
      if (lookahead == '/') ADVANCE(295);
      if (lookahead == '\\') ADVANCE(419);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '/' &&
          lookahead != '\\') ADVANCE(418);
      if (lookahead == '\r') ADVANCE(423);
      if (lookahead == '/') ADVANCE(385);
      if (lookahead == '\\') ADVANCE(420);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '/' &&
          lookahead != '\\') ADVANCE(695);
      if (lookahead == '\r') ADVANCE(699);
      if (lookahead == '/') ADVANCE(694);
      if (lookahead == '\\') ADVANCE(697);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '/' &&
          lookahead != '\\') ADVANCE(413);
      if (lookahead == '*') ADVANCE(412);
      if (lookahead == '/') ADVANCE(295);
      if (lookahead == '\\') ADVANCE(419);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '/' &&
          lookahead != '\\') ADVANCE(418);
      if (lookahead == '/') ADVANCE(385);
      if (lookahead == '\\') ADVANCE(420);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'c') ADVANCE(452);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(449);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(432);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(434);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(436);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(439);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(403);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(391);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(389);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(442);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(443);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(444);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(445);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(396);
      if (lookahead == 'n') ADVANCE(424);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(396);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(447);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(406);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(399);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(400);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(401);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(409);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(411);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(407);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(455);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(440);
      if (lookahead == 's') ADVANCE(430);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(441);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(446);
      if (lookahead == 's') ADVANCE(430);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(448);
      if (lookahead == 'n') ADVANCE(425);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(456);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(450);
      if (lookahead == 'n') ADVANCE(425);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(425);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(431);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'u') ADVANCE(426);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(496);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(541);
      if (lookahead == '.') ADVANCE(357);
      if (lookahead == '0') ADVANCE(553);
      if (lookahead == '=') ADVANCE(534);
      if (lookahead == '>') ADVANCE(549);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(541);
      if (lookahead == '.') ADVANCE(357);
      if (lookahead == '0') ADVANCE(553);
      if (lookahead == '=') ADVANCE(534);
      if (lookahead == '>') ADVANCE(548);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(541);
      if (lookahead == '.') ADVANCE(357);
      if (lookahead == '0') ADVANCE(553);
      if (lookahead == '>') ADVANCE(548);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(541);
      if (lookahead == '.') ADVANCE(357);
      if (lookahead == '0') ADVANCE(553);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(541);
      if (lookahead == '=') ADVANCE(534);
      if (lookahead == '>') ADVANCE(549);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(541);
      if (lookahead == '=') ADVANCE(534);
      if (lookahead == '>') ADVANCE(548);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(541);
      if (lookahead == '>') ADVANCE(548);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(357);
      if (lookahead == '0') ADVANCE(553);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(534);
      if (lookahead == '>') ADVANCE(292);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(542);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(542);
      if (lookahead == '.') ADVANCE(357);
      if (lookahead == '0') ADVANCE(553);
      if (lookahead == '=') ADVANCE(533);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(542);
      if (lookahead == '.') ADVANCE(357);
      if (lookahead == '0') ADVANCE(553);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(542);
      if (lookahead == '=') ADVANCE(533);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(357);
      if (lookahead == '0') ADVANCE(553);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(533);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(530);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(294);
      if (lookahead == '/') ADVANCE(696);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(294);
      if (lookahead == '/') ADVANCE(696);
      if (lookahead == '=') ADVANCE(531);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(532);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(539);
      if (lookahead == '|') ADVANCE(485);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(485);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(538);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(486);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(486);
      if (lookahead == '=') ADVANCE(537);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(500);
      if (lookahead == '>') ADVANCE(510);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(500);
      if (lookahead == '>') ADVANCE(511);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>') ADVANCE(540);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(509);
      if (lookahead == '=') ADVANCE(502);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(509);
      if (lookahead == '=') ADVANCE(501);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(508);
      if (lookahead == '=') ADVANCE(502);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(508);
      if (lookahead == '=') ADVANCE(501);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(535);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(536);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[') ADVANCE(514);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[') ADVANCE(514);
      if (lookahead == ']') ADVANCE(709);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == ']') ADVANCE(709);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(495);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(aux_sym_primitive_type_token1);
      if (sym_identifier_character_set_10(lookahead)) ADVANCE(691);
      if (lookahead == '1') ADVANCE(625);
      if (lookahead == '3') ADVANCE(623);
      if (lookahead == '6') ADVANCE(624);
      if (lookahead == '8') ADVANCE(687);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'p') ADVANCE(675);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(aux_sym_primitive_type_token1);
      if (sym_identifier_character_set_11(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(513);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(anon_sym_LT_EQ_GT);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '*') ADVANCE(547);
      if (lookahead == '.') ADVANCE(298);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '*') ADVANCE(547);
      if (lookahead == '.') ADVANCE(298);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(551);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(298);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(551);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(551);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(anon_sym_DOT_STAR);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      if (lookahead == '*') ADVANCE(707);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '\'') ADVANCE(357);
      if (lookahead == 'B') ADVANCE(317);
      if (lookahead == 'b') ADVANCE(338);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(352);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(558);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(550);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(551);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '\'') ADVANCE(355);
      if (lookahead == '.') ADVANCE(559);
      if (lookahead == 'L') ADVANCE(560);
      if (lookahead == 'l') ADVANCE(563);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(352);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(562);
      if (lookahead == 'Z' ||
          lookahead == 'z') ADVANCE(565);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(287);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(552);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '\'') ADVANCE(355);
      if (lookahead == '.') ADVANCE(559);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(354);
      if (lookahead == 'L') ADVANCE(560);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(299);
      if (lookahead == 'l') ADVANCE(563);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(352);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(562);
      if (lookahead == 'Z' ||
          lookahead == 'z') ADVANCE(565);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(287);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(552);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '\'') ADVANCE(354);
      if (lookahead == 'L') ADVANCE(560);
      if (lookahead == 'l') ADVANCE(563);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(562);
      if (lookahead == 'Z' ||
          lookahead == 'z') ADVANCE(565);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(554);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '\'') ADVANCE(356);
      if (lookahead == '.') ADVANCE(559);
      if (lookahead == 'L') ADVANCE(560);
      if (lookahead == 'l') ADVANCE(563);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(352);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(562);
      if (lookahead == 'Z' ||
          lookahead == 'z') ADVANCE(565);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(555);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '\'') ADVANCE(359);
      if (lookahead == 'B') ADVANCE(317);
      if (lookahead == 'b') ADVANCE(338);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(558);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(550);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(556);
      END_STATE();
    case 557:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '\'') ADVANCE(361);
      if (lookahead == '.') ADVANCE(353);
      if (lookahead == 'L') ADVANCE(560);
      if (lookahead == 'l') ADVANCE(563);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(352);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(562);
      if (lookahead == 'Z' ||
          lookahead == 'z') ADVANCE(565);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(557);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '1') ADVANCE(303);
      if (lookahead == '3') ADVANCE(302);
      if (lookahead == '6') ADVANCE(304);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == 'B') ADVANCE(317);
      if (lookahead == 'b') ADVANCE(338);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(352);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(558);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(550);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(551);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == 'L') ADVANCE(565);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(550);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == 'L') ADVANCE(550);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == 'L') ADVANCE(561);
      if (lookahead == 'l') ADVANCE(564);
      if (lookahead == 'Z' ||
          lookahead == 'z') ADVANCE(550);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == 'l') ADVANCE(565);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(550);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == 'l') ADVANCE(550);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(550);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (sym_identifier_character_set_12(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(573);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (sym_identifier_character_set_12(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(566);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (sym_identifier_character_set_12(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(567);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (sym_identifier_character_set_12(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(568);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (sym_identifier_character_set_12(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(569);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (sym_identifier_character_set_12(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(570);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (sym_identifier_character_set_12(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(571);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (sym_identifier_character_set_11(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(anon_sym_L_SQUOTE);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(anon_sym_u_SQUOTE);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(anon_sym_U_SQUOTE);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(anon_sym_u8_SQUOTE);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\n') ADVANCE(594);
      if (lookahead == '\r') ADVANCE(593);
      if (lookahead == 'U') ADVANCE(377);
      if (lookahead == 'u') ADVANCE(369);
      if (lookahead == 'x') ADVANCE(365);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(596);
      if (lookahead != 0) ADVANCE(593);
      END_STATE();
    case 581:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '*') ADVANCE(294);
      if (lookahead == '/') ADVANCE(696);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\\') ADVANCE(117);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(anon_sym_L_DQUOTE);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(anon_sym_u_DQUOTE);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(anon_sym_U_DQUOTE);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(anon_sym_u8_DQUOTE);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(590);
      if (lookahead == '/') ADVANCE(592);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(592);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(589);
      if (lookahead == '/') ADVANCE(592);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(590);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(589);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(590);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '/') ADVANCE(588);
      if (lookahead == '\t' ||
          (11 <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(591);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(592);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(592);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(117);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(593);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(595);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(sym_system_lib_string);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(sym_system_lib_string);
      if (lookahead == '>') ADVANCE(597);
      if (lookahead == '\\') ADVANCE(316);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(315);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(sym_true);
      if (sym_identifier_character_set_11(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(sym_false);
      if (sym_identifier_character_set_11(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(583);
      if (sym_identifier_character_set_13(lookahead)) ADVANCE(691);
      if (lookahead == '\'') ADVANCE(574);
      if (lookahead == 'R') ADVANCE(612);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(583);
      if (sym_identifier_character_set_13(lookahead)) ADVANCE(691);
      if (lookahead == 'R') ADVANCE(612);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(583);
      if (sym_identifier_character_set_11(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(702);
      if (sym_identifier_character_set_11(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(585);
      if (sym_identifier_character_set_13(lookahead)) ADVANCE(691);
      if (lookahead == '\'') ADVANCE(576);
      if (lookahead == 'R') ADVANCE(613);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(585);
      if (sym_identifier_character_set_13(lookahead)) ADVANCE(691);
      if (lookahead == 'R') ADVANCE(613);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(585);
      if (sym_identifier_character_set_11(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(584);
      if (sym_identifier_character_set_14(lookahead)) ADVANCE(691);
      if (lookahead == '\'') ADVANCE(575);
      if (lookahead == '8') ADVANCE(614);
      if (lookahead == 'R') ADVANCE(617);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'i') ADVANCE(659);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(584);
      if (sym_identifier_character_set_15(lookahead)) ADVANCE(691);
      if (lookahead == '8') ADVANCE(615);
      if (lookahead == 'R') ADVANCE(617);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(584);
      if (sym_identifier_character_set_16(lookahead)) ADVANCE(691);
      if (lookahead == '8') ADVANCE(616);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'i') ADVANCE(659);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(584);
      if (sym_identifier_character_set_17(lookahead)) ADVANCE(691);
      if (lookahead == '8') ADVANCE(616);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 612:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(703);
      if (sym_identifier_character_set_11(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(705);
      if (sym_identifier_character_set_11(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(586);
      if (sym_identifier_character_set_13(lookahead)) ADVANCE(691);
      if (lookahead == '\'') ADVANCE(577);
      if (lookahead == 'R') ADVANCE(618);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(586);
      if (sym_identifier_character_set_13(lookahead)) ADVANCE(691);
      if (lookahead == 'R') ADVANCE(618);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(586);
      if (sym_identifier_character_set_11(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(704);
      if (sym_identifier_character_set_11(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(706);
      if (sym_identifier_character_set_11(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_10(lookahead)) ADVANCE(691);
      if (lookahead == '1') ADVANCE(625);
      if (lookahead == '3') ADVANCE(623);
      if (lookahead == '6') ADVANCE(624);
      if (lookahead == '8') ADVANCE(687);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'p') ADVANCE(675);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_12(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(572);
      END_STATE();
    case 621:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_18(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'i') ADVANCE(680);
      if (lookahead == 's') ADVANCE(645);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_19(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'a') ADVANCE(650);
      if (lookahead == 'l') ADVANCE(662);
      END_STATE();
    case 623:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_20(lookahead)) ADVANCE(691);
      if (lookahead == '2') ADVANCE(687);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_21(lookahead)) ADVANCE(691);
      if (lookahead == '4') ADVANCE(687);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 625:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_22(lookahead)) ADVANCE(691);
      if (lookahead == '6') ADVANCE(687);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_17(lookahead)) ADVANCE(691);
      if (lookahead == '\'') ADVANCE(575);
      if (lookahead == '8') ADVANCE(690);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 627:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_23(lookahead)) ADVANCE(691);
      if (lookahead == 'E') ADVANCE(599);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_23(lookahead)) ADVANCE(691);
      if (lookahead == 'E') ADVANCE(600);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_24(lookahead)) ADVANCE(691);
      if (lookahead == 'L') ADVANCE(631);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_13(lookahead)) ADVANCE(691);
      if (lookahead == 'R') ADVANCE(632);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_25(lookahead)) ADVANCE(691);
      if (lookahead == 'S') ADVANCE(628);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_26(lookahead)) ADVANCE(691);
      if (lookahead == 'U') ADVANCE(627);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_27(lookahead)) ADVANCE(691);
      if (lookahead == 'A') ADVANCE(629);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 634:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_28(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'b') ADVANCE(655);
      END_STATE();
    case 635:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_29(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'd') ADVANCE(526);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_29(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'd') ADVANCE(646);
      END_STATE();
    case 637:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_30(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'e') ADVANCE(599);
      END_STATE();
    case 638:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_30(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'e') ADVANCE(526);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_30(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'e') ADVANCE(600);
      END_STATE();
    case 640:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_30(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'e') ADVANCE(687);
      END_STATE();
    case 641:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_31(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'f') ADVANCE(687);
      END_STATE();
    case 642:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_31(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'f') ADVANCE(641);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_32(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'g') ADVANCE(658);
      END_STATE();
    case 644:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_33(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'h') ADVANCE(683);
      END_STATE();
    case 645:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_34(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'i') ADVANCE(680);
      END_STATE();
    case 646:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_34(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'i') ADVANCE(642);
      END_STATE();
    case 647:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_34(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'i') ADVANCE(643);
      END_STATE();
    case 648:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_34(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'i') ADVANCE(635);
      END_STATE();
    case 649:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_34(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'i') ADVANCE(659);
      END_STATE();
    case 650:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_35(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'l') ADVANCE(670);
      END_STATE();
    case 651:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_35(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'l') ADVANCE(526);
      END_STATE();
    case 652:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_35(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'l') ADVANCE(665);
      END_STATE();
    case 653:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_35(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'l') ADVANCE(652);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_35(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'l') ADVANCE(647);
      END_STATE();
    case 655:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_35(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'l') ADVANCE(638);
      END_STATE();
    case 656:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_35(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'l') ADVANCE(662);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_36(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'n') ADVANCE(671);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_36(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'n') ADVANCE(687);
      END_STATE();
    case 659:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_36(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'n') ADVANCE(673);
      END_STATE();
    case 660:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_37(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'o') ADVANCE(676);
      END_STATE();
    case 661:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_37(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'o') ADVANCE(648);
      END_STATE();
    case 662:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_37(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'o') ADVANCE(684);
      END_STATE();
    case 663:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_37(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'o') ADVANCE(651);
      END_STATE();
    case 664:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_37(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'o') ADVANCE(663);
      END_STATE();
    case 665:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_38(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'p') ADVANCE(675);
      END_STATE();
    case 666:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_39(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'r') ADVANCE(525);
      END_STATE();
    case 667:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_39(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'r') ADVANCE(636);
      END_STATE();
    case 668:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_39(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'r') ADVANCE(687);
      END_STATE();
    case 669:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_39(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'r') ADVANCE(678);
      END_STATE();
    case 670:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_40(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 's') ADVANCE(639);
      END_STATE();
    case 671:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_41(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 't') ADVANCE(525);
      END_STATE();
    case 672:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_41(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 't') ADVANCE(526);
      END_STATE();
    case 673:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_41(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 't') ADVANCE(619);
      END_STATE();
    case 674:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_41(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 't') ADVANCE(667);
      END_STATE();
    case 675:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_41(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 't') ADVANCE(668);
      END_STATE();
    case 676:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_42(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'u') ADVANCE(634);
      END_STATE();
    case 677:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_42(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'u') ADVANCE(653);
      END_STATE();
    case 678:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_42(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'u') ADVANCE(637);
      END_STATE();
    case 679:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_43(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'x') ADVANCE(686);
      END_STATE();
    case 680:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_44(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'z') ADVANCE(640);
      END_STATE();
    case 681:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_45(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'a') ADVANCE(650);
      END_STATE();
    case 682:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_45(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'a') ADVANCE(679);
      END_STATE();
    case 683:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_45(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'a') ADVANCE(666);
      END_STATE();
    case 684:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_45(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'a') ADVANCE(672);
      END_STATE();
    case 685:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_45(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == 'a') ADVANCE(654);
      END_STATE();
    case 686:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_46(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == '_') ADVANCE(685);
      END_STATE();
    case 687:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_46(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == '_') ADVANCE(672);
      END_STATE();
    case 688:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_11(lookahead)) ADVANCE(691);
      if (lookahead == '\'') ADVANCE(574);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 689:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_11(lookahead)) ADVANCE(691);
      if (lookahead == '\'') ADVANCE(576);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 690:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_11(lookahead)) ADVANCE(691);
      if (lookahead == '\'') ADVANCE(577);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 691:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_11(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      END_STATE();
    case 692:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 693:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n') ADVANCE(696);
      if (lookahead == '/') ADVANCE(694);
      if (lookahead == '\\') ADVANCE(421);
      if (lookahead != 0) ADVANCE(695);
      END_STATE();
    case 694:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '*') ADVANCE(696);
      if (lookahead == '\\') ADVANCE(414);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(695);
      END_STATE();
    case 695:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(694);
      if (lookahead == '\\') ADVANCE(421);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(695);
      END_STATE();
    case 696:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(384);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(696);
      END_STATE();
    case 697:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '/' &&
          lookahead != '\\') ADVANCE(695);
      if (lookahead == '\r') ADVANCE(699);
      if (lookahead == '/') ADVANCE(694);
      if (lookahead == '\\') ADVANCE(697);
      END_STATE();
    case 698:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '\\') ADVANCE(696);
      if (lookahead == '\r') ADVANCE(700);
      if (lookahead == '\\') ADVANCE(698);
      END_STATE();
    case 699:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '/' &&
          lookahead != '\\') ADVANCE(695);
      if (lookahead == '/') ADVANCE(694);
      if (lookahead == '\\') ADVANCE(421);
      END_STATE();
    case 700:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\\') ADVANCE(696);
      if (lookahead == '\\') ADVANCE(384);
      END_STATE();
    case 701:
      ACCEPT_TOKEN(anon_sym_GT2);
      END_STATE();
    case 702:
      ACCEPT_TOKEN(anon_sym_R_DQUOTE);
      END_STATE();
    case 703:
      ACCEPT_TOKEN(anon_sym_LR_DQUOTE);
      END_STATE();
    case 704:
      ACCEPT_TOKEN(anon_sym_uR_DQUOTE);
      END_STATE();
    case 705:
      ACCEPT_TOKEN(anon_sym_UR_DQUOTE);
      END_STATE();
    case 706:
      ACCEPT_TOKEN(anon_sym_u8R_DQUOTE);
      END_STATE();
    case 707:
      ACCEPT_TOKEN(anon_sym_DASH_GT_STAR);
      END_STATE();
    case 708:
      ACCEPT_TOKEN(anon_sym_LPAREN_RPAREN);
      END_STATE();
    case 709:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      END_STATE();
    case 710:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE);
      END_STATE();
    case 711:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(583);
      if (sym_identifier_character_set_47(lookahead)) ADVANCE(691);
      if (lookahead == 'R') ADVANCE(715);
      if (lookahead == '\\') ADVANCE(318);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      END_STATE();
    case 712:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(702);
      if (sym_identifier_character_set_47(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      END_STATE();
    case 713:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(585);
      if (sym_identifier_character_set_47(lookahead)) ADVANCE(691);
      if (lookahead == 'R') ADVANCE(716);
      if (lookahead == '\\') ADVANCE(318);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      END_STATE();
    case 714:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(584);
      if (sym_identifier_character_set_47(lookahead)) ADVANCE(691);
      if (lookahead == '8') ADVANCE(717);
      if (lookahead == 'R') ADVANCE(718);
      if (lookahead == '\\') ADVANCE(318);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      END_STATE();
    case 715:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(703);
      if (sym_identifier_character_set_47(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      END_STATE();
    case 716:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(705);
      if (sym_identifier_character_set_47(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      END_STATE();
    case 717:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(586);
      if (sym_identifier_character_set_47(lookahead)) ADVANCE(691);
      if (lookahead == 'R') ADVANCE(719);
      if (lookahead == '\\') ADVANCE(318);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      END_STATE();
    case 718:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(704);
      if (sym_identifier_character_set_47(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      END_STATE();
    case 719:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(706);
      if (sym_identifier_character_set_47(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      END_STATE();
    case 720:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (sym_identifier_character_set_47(lookahead)) ADVANCE(691);
      if (lookahead == '\\') ADVANCE(318);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'N') ADVANCE(1);
      if (lookahead == 'P') ADVANCE(2);
      if (lookahead == '\\') SKIP(3)
      if (lookahead == '_') ADVANCE(4);
      if (lookahead == 'a') ADVANCE(5);
      if (lookahead == 'b') ADVANCE(6);
      if (lookahead == 'c') ADVANCE(7);
      if (lookahead == 'd') ADVANCE(8);
      if (lookahead == 'e') ADVANCE(9);
      if (lookahead == 'f') ADVANCE(10);
      if (lookahead == 'g') ADVANCE(11);
      if (lookahead == 'i') ADVANCE(12);
      if (lookahead == 'l') ADVANCE(13);
      if (lookahead == 'm') ADVANCE(14);
      if (lookahead == 'n') ADVANCE(15);
      if (lookahead == 'o') ADVANCE(16);
      if (lookahead == 'p') ADVANCE(17);
      if (lookahead == 'r') ADVANCE(18);
      if (lookahead == 's') ADVANCE(19);
      if (lookahead == 't') ADVANCE(20);
      if (lookahead == 'u') ADVANCE(21);
      if (lookahead == 'v') ADVANCE(22);
      if (lookahead == 'w') ADVANCE(23);
      if (lookahead == 'x') ADVANCE(24);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'U') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'R') ADVANCE(26);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(0)
      if (lookahead == '\r') SKIP(27)
      END_STATE();
    case 4:
      if (lookahead == 'A') ADVANCE(28);
      if (lookahead == 'G') ADVANCE(29);
      if (lookahead == 'N') ADVANCE(30);
      if (lookahead == '_') ADVANCE(31);
      if (lookahead == 'a') ADVANCE(32);
      if (lookahead == 'u') ADVANCE(33);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(34);
      if (lookahead == 'n') ADVANCE(35);
      if (lookahead == 's') ADVANCE(36);
      if (lookahead == 'u') ADVANCE(37);
      END_STATE();
    case 6:
      if (lookahead == 'i') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'y') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'a') ADVANCE(41);
      if (lookahead == 'l') ADVANCE(42);
      if (lookahead == 'o') ADVANCE(43);
      END_STATE();
    case 8:
      if (lookahead == 'e') ADVANCE(44);
      if (lookahead == 'o') ADVANCE(45);
      END_STATE();
    case 9:
      if (lookahead == 'l') ADVANCE(46);
      if (lookahead == 'n') ADVANCE(47);
      if (lookahead == 'x') ADVANCE(48);
      END_STATE();
    case 10:
      if (lookahead == 'i') ADVANCE(49);
      if (lookahead == 'o') ADVANCE(50);
      if (lookahead == 'r') ADVANCE(51);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(52);
      END_STATE();
    case 12:
      if (lookahead == 'f') ADVANCE(53);
      if (lookahead == 'n') ADVANCE(54);
      END_STATE();
    case 13:
      if (lookahead == 'o') ADVANCE(55);
      END_STATE();
    case 14:
      if (lookahead == 'u') ADVANCE(56);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(57);
      if (lookahead == 'e') ADVANCE(58);
      if (lookahead == 'o') ADVANCE(59);
      if (lookahead == 'u') ADVANCE(60);
      END_STATE();
    case 16:
      if (lookahead == 'f') ADVANCE(61);
      if (lookahead == 'p') ADVANCE(62);
      if (lookahead == 'r') ADVANCE(63);
      if (lookahead == 'v') ADVANCE(64);
      END_STATE();
    case 17:
      if (lookahead == 'r') ADVANCE(65);
      if (lookahead == 'u') ADVANCE(66);
      END_STATE();
    case 18:
      if (lookahead == 'e') ADVANCE(67);
      END_STATE();
    case 19:
      if (lookahead == 'h') ADVANCE(68);
      if (lookahead == 'i') ADVANCE(69);
      if (lookahead == 't') ADVANCE(70);
      if (lookahead == 'w') ADVANCE(71);
      END_STATE();
    case 20:
      if (lookahead == 'e') ADVANCE(72);
      if (lookahead == 'h') ADVANCE(73);
      if (lookahead == 'r') ADVANCE(74);
      if (lookahead == 'y') ADVANCE(75);
      END_STATE();
    case 21:
      if (lookahead == 'n') ADVANCE(76);
      if (lookahead == 's') ADVANCE(77);
      END_STATE();
    case 22:
      if (lookahead == 'i') ADVANCE(78);
      if (lookahead == 'o') ADVANCE(79);
      END_STATE();
    case 23:
      if (lookahead == 'h') ADVANCE(80);
      if (lookahead == 'o') ADVANCE(81);
      END_STATE();
    case 24:
      if (lookahead == 'o') ADVANCE(82);
      END_STATE();
    case 25:
      if (lookahead == 'L') ADVANCE(83);
      END_STATE();
    case 26:
      if (lookahead == 'O') ADVANCE(84);
      END_STATE();
    case 27:
      if (lookahead == '\n') SKIP(0)
      END_STATE();
    case 28:
      if (lookahead == 'l') ADVANCE(85);
      if (lookahead == 't') ADVANCE(86);
      END_STATE();
    case 29:
      if (lookahead == 'e') ADVANCE(87);
      END_STATE();
    case 30:
      if (lookahead == 'o') ADVANCE(88);
      END_STATE();
    case 31:
      if (lookahead == 'a') ADVANCE(89);
      if (lookahead == 'b') ADVANCE(90);
      if (lookahead == 'c') ADVANCE(91);
      if (lookahead == 'd') ADVANCE(92);
      if (lookahead == 'e') ADVANCE(93);
      if (lookahead == 'f') ADVANCE(94);
      if (lookahead == 'i') ADVANCE(95);
      if (lookahead == 'l') ADVANCE(96);
      if (lookahead == 'r') ADVANCE(97);
      if (lookahead == 's') ADVANCE(98);
      if (lookahead == 't') ADVANCE(99);
      if (lookahead == 'u') ADVANCE(100);
      if (lookahead == 'v') ADVANCE(101);
      END_STATE();
    case 32:
      if (lookahead == 'l') ADVANCE(102);
      END_STATE();
    case 33:
      if (lookahead == 'n') ADVANCE(103);
      END_STATE();
    case 34:
      if (lookahead == 'i') ADVANCE(104);
      END_STATE();
    case 35:
      if (lookahead == 'd') ADVANCE(105);
      END_STATE();
    case 36:
      if (lookahead == 'm') ADVANCE(106);
      END_STATE();
    case 37:
      if (lookahead == 't') ADVANCE(107);
      END_STATE();
    case 38:
      if (lookahead == 't') ADVANCE(108);
      END_STATE();
    case 39:
      if (lookahead == 'e') ADVANCE(109);
      END_STATE();
    case 40:
      if (lookahead == 't') ADVANCE(110);
      END_STATE();
    case 41:
      if (lookahead == 's') ADVANCE(111);
      if (lookahead == 't') ADVANCE(112);
      END_STATE();
    case 42:
      if (lookahead == 'a') ADVANCE(113);
      END_STATE();
    case 43:
      if (lookahead == '_') ADVANCE(114);
      if (lookahead == 'm') ADVANCE(115);
      if (lookahead == 'n') ADVANCE(116);
      END_STATE();
    case 44:
      if (lookahead == 'c') ADVANCE(117);
      if (lookahead == 'f') ADVANCE(118);
      if (lookahead == 'l') ADVANCE(119);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 46:
      if (lookahead == 's') ADVANCE(120);
      END_STATE();
    case 47:
      if (lookahead == 'u') ADVANCE(121);
      END_STATE();
    case 48:
      if (lookahead == 'p') ADVANCE(122);
      if (lookahead == 't') ADVANCE(123);
      END_STATE();
    case 49:
      if (lookahead == 'n') ADVANCE(124);
      END_STATE();
    case 50:
      if (lookahead == 'r') ADVANCE(125);
      END_STATE();
    case 51:
      if (lookahead == 'i') ADVANCE(126);
      END_STATE();
    case 52:
      if (lookahead == 't') ADVANCE(127);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 54:
      if (lookahead == 'l') ADVANCE(128);
      END_STATE();
    case 55:
      if (lookahead == 'n') ADVANCE(129);
      END_STATE();
    case 56:
      if (lookahead == 't') ADVANCE(130);
      END_STATE();
    case 57:
      if (lookahead == 'm') ADVANCE(131);
      END_STATE();
    case 58:
      if (lookahead == 'w') ADVANCE(132);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(133);
      if (lookahead == 'r') ADVANCE(134);
      if (lookahead == 't') ADVANCE(135);
      END_STATE();
    case 60:
      if (lookahead == 'l') ADVANCE(136);
      END_STATE();
    case 61:
      if (lookahead == 'f') ADVANCE(137);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(138);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == '_') ADVANCE(139);
      END_STATE();
    case 64:
      if (lookahead == 'e') ADVANCE(140);
      END_STATE();
    case 65:
      if (lookahead == 'i') ADVANCE(141);
      if (lookahead == 'o') ADVANCE(142);
      END_STATE();
    case 66:
      if (lookahead == 'b') ADVANCE(143);
      END_STATE();
    case 67:
      if (lookahead == 'g') ADVANCE(144);
      if (lookahead == 'q') ADVANCE(145);
      if (lookahead == 's') ADVANCE(146);
      if (lookahead == 't') ADVANCE(147);
      END_STATE();
    case 68:
      if (lookahead == 'o') ADVANCE(148);
      END_STATE();
    case 69:
      if (lookahead == 'g') ADVANCE(149);
      if (lookahead == 'z') ADVANCE(150);
      END_STATE();
    case 70:
      if (lookahead == 'a') ADVANCE(151);
      if (lookahead == 'r') ADVANCE(152);
      END_STATE();
    case 71:
      if (lookahead == 'i') ADVANCE(153);
      END_STATE();
    case 72:
      if (lookahead == 'm') ADVANCE(154);
      END_STATE();
    case 73:
      if (lookahead == 'i') ADVANCE(155);
      if (lookahead == 'r') ADVANCE(156);
      END_STATE();
    case 74:
      if (lookahead == 'y') ADVANCE(157);
      END_STATE();
    case 75:
      if (lookahead == 'p') ADVANCE(158);
      END_STATE();
    case 76:
      if (lookahead == 'i') ADVANCE(159);
      if (lookahead == 's') ADVANCE(160);
      END_STATE();
    case 77:
      if (lookahead == 'i') ADVANCE(161);
      END_STATE();
    case 78:
      if (lookahead == 'r') ADVANCE(162);
      END_STATE();
    case 79:
      if (lookahead == 'l') ADVANCE(163);
      END_STATE();
    case 80:
      if (lookahead == 'i') ADVANCE(164);
      END_STATE();
    case 81:
      if (lookahead == 'r') ADVANCE(165);
      END_STATE();
    case 82:
      if (lookahead == 'r') ADVANCE(166);
      END_STATE();
    case 83:
      if (lookahead == 'L') ADVANCE(167);
      END_STATE();
    case 84:
      if (lookahead == 'G') ADVANCE(168);
      END_STATE();
    case 85:
      if (lookahead == 'i') ADVANCE(169);
      END_STATE();
    case 86:
      if (lookahead == 'o') ADVANCE(170);
      END_STATE();
    case 87:
      if (lookahead == 'n') ADVANCE(171);
      END_STATE();
    case 88:
      if (lookahead == 'r') ADVANCE(172);
      END_STATE();
    case 89:
      if (lookahead == 'l') ADVANCE(173);
      if (lookahead == 's') ADVANCE(174);
      if (lookahead == 't') ADVANCE(175);
      END_STATE();
    case 90:
      if (lookahead == 'a') ADVANCE(176);
      END_STATE();
    case 91:
      if (lookahead == 'd') ADVANCE(177);
      if (lookahead == 'l') ADVANCE(178);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(179);
      END_STATE();
    case 93:
      if (lookahead == 'x') ADVANCE(180);
      END_STATE();
    case 94:
      if (lookahead == 'a') ADVANCE(181);
      if (lookahead == 'i') ADVANCE(182);
      if (lookahead == 'o') ADVANCE(183);
      END_STATE();
    case 95:
      if (lookahead == 'n') ADVANCE(184);
      END_STATE();
    case 96:
      if (lookahead == 'e') ADVANCE(185);
      END_STATE();
    case 97:
      if (lookahead == 'e') ADVANCE(186);
      END_STATE();
    case 98:
      if (lookahead == 'p') ADVANCE(187);
      if (lookahead == 't') ADVANCE(188);
      END_STATE();
    case 99:
      if (lookahead == 'h') ADVANCE(189);
      if (lookahead == 'r') ADVANCE(190);
      END_STATE();
    case 100:
      if (lookahead == 'n') ADVANCE(191);
      if (lookahead == 'p') ADVANCE(192);
      END_STATE();
    case 101:
      if (lookahead == 'e') ADVANCE(193);
      END_STATE();
    case 102:
      if (lookahead == 'i') ADVANCE(194);
      END_STATE();
    case 103:
      if (lookahead == 'a') ADVANCE(195);
      END_STATE();
    case 104:
      if (lookahead == 'g') ADVANCE(196);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_and);
      if (lookahead == '_') ADVANCE(197);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_asm);
      END_STATE();
    case 107:
      if (lookahead == 'o') ADVANCE(198);
      END_STATE();
    case 108:
      if (lookahead == 'a') ADVANCE(199);
      if (lookahead == 'o') ADVANCE(200);
      END_STATE();
    case 109:
      if (lookahead == 'a') ADVANCE(201);
      END_STATE();
    case 110:
      if (lookahead == 'e') ADVANCE(202);
      END_STATE();
    case 111:
      if (lookahead == 'e') ADVANCE(203);
      END_STATE();
    case 112:
      if (lookahead == 'c') ADVANCE(204);
      END_STATE();
    case 113:
      if (lookahead == 's') ADVANCE(205);
      END_STATE();
    case 114:
      if (lookahead == 'a') ADVANCE(206);
      if (lookahead == 'r') ADVANCE(207);
      if (lookahead == 'y') ADVANCE(208);
      END_STATE();
    case 115:
      if (lookahead == 'p') ADVANCE(209);
      END_STATE();
    case 116:
      if (lookahead == 'c') ADVANCE(210);
      if (lookahead == 's') ADVANCE(211);
      if (lookahead == 't') ADVANCE(212);
      END_STATE();
    case 117:
      if (lookahead == 'l') ADVANCE(213);
      END_STATE();
    case 118:
      if (lookahead == 'a') ADVANCE(214);
      if (lookahead == 'i') ADVANCE(215);
      END_STATE();
    case 119:
      if (lookahead == 'e') ADVANCE(216);
      END_STATE();
    case 120:
      if (lookahead == 'e') ADVANCE(217);
      END_STATE();
    case 121:
      if (lookahead == 'm') ADVANCE(218);
      END_STATE();
    case 122:
      if (lookahead == 'l') ADVANCE(219);
      END_STATE();
    case 123:
      if (lookahead == 'e') ADVANCE(220);
      END_STATE();
    case 124:
      if (lookahead == 'a') ADVANCE(221);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 126:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 127:
      if (lookahead == 'o') ADVANCE(223);
      END_STATE();
    case 128:
      if (lookahead == 'i') ADVANCE(224);
      END_STATE();
    case 129:
      if (lookahead == 'g') ADVANCE(225);
      END_STATE();
    case 130:
      if (lookahead == 'a') ADVANCE(226);
      END_STATE();
    case 131:
      if (lookahead == 'e') ADVANCE(227);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 133:
      if (lookahead == 'x') ADVANCE(228);
      END_STATE();
    case 134:
      if (lookahead == 'e') ADVANCE(229);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_not);
      if (lookahead == '_') ADVANCE(230);
      END_STATE();
    case 136:
      if (lookahead == 'l') ADVANCE(231);
      END_STATE();
    case 137:
      if (lookahead == 's') ADVANCE(232);
      END_STATE();
    case 138:
      if (lookahead == 'r') ADVANCE(233);
      END_STATE();
    case 139:
      if (lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 140:
      if (lookahead == 'r') ADVANCE(235);
      END_STATE();
    case 141:
      if (lookahead == 'v') ADVANCE(236);
      END_STATE();
    case 142:
      if (lookahead == 't') ADVANCE(237);
      END_STATE();
    case 143:
      if (lookahead == 'l') ADVANCE(238);
      END_STATE();
    case 144:
      if (lookahead == 'i') ADVANCE(239);
      END_STATE();
    case 145:
      if (lookahead == 'u') ADVANCE(240);
      END_STATE();
    case 146:
      if (lookahead == 't') ADVANCE(241);
      END_STATE();
    case 147:
      if (lookahead == 'u') ADVANCE(242);
      END_STATE();
    case 148:
      if (lookahead == 'r') ADVANCE(243);
      END_STATE();
    case 149:
      if (lookahead == 'n') ADVANCE(244);
      END_STATE();
    case 150:
      if (lookahead == 'e') ADVANCE(245);
      END_STATE();
    case 151:
      if (lookahead == 't') ADVANCE(246);
      END_STATE();
    case 152:
      if (lookahead == 'u') ADVANCE(247);
      END_STATE();
    case 153:
      if (lookahead == 't') ADVANCE(248);
      END_STATE();
    case 154:
      if (lookahead == 'p') ADVANCE(249);
      END_STATE();
    case 155:
      if (lookahead == 's') ADVANCE(250);
      END_STATE();
    case 156:
      if (lookahead == 'e') ADVANCE(251);
      if (lookahead == 'o') ADVANCE(252);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 158:
      if (lookahead == 'e') ADVANCE(253);
      END_STATE();
    case 159:
      if (lookahead == 'o') ADVANCE(254);
      END_STATE();
    case 160:
      if (lookahead == 'i') ADVANCE(255);
      END_STATE();
    case 161:
      if (lookahead == 'n') ADVANCE(256);
      END_STATE();
    case 162:
      if (lookahead == 't') ADVANCE(257);
      END_STATE();
    case 163:
      if (lookahead == 'a') ADVANCE(258);
      END_STATE();
    case 164:
      if (lookahead == 'l') ADVANCE(259);
      END_STATE();
    case 165:
      if (lookahead == 'd') ADVANCE(260);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_xor);
      if (lookahead == '_') ADVANCE(261);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_NULL);
      END_STATE();
    case 168:
      if (lookahead == 'M') ADVANCE(262);
      END_STATE();
    case 169:
      if (lookahead == 'g') ADVANCE(263);
      END_STATE();
    case 170:
      if (lookahead == 'm') ADVANCE(264);
      END_STATE();
    case 171:
      if (lookahead == 'e') ADVANCE(265);
      END_STATE();
    case 172:
      if (lookahead == 'e') ADVANCE(266);
      END_STATE();
    case 173:
      if (lookahead == 'i') ADVANCE(267);
      END_STATE();
    case 174:
      if (lookahead == 'm') ADVANCE(268);
      END_STATE();
    case 175:
      if (lookahead == 't') ADVANCE(269);
      END_STATE();
    case 176:
      if (lookahead == 's') ADVANCE(270);
      END_STATE();
    case 177:
      if (lookahead == 'e') ADVANCE(271);
      END_STATE();
    case 178:
      if (lookahead == 'r') ADVANCE(272);
      END_STATE();
    case 179:
      if (lookahead == 'c') ADVANCE(273);
      END_STATE();
    case 180:
      if (lookahead == 'c') ADVANCE(274);
      if (lookahead == 't') ADVANCE(275);
      END_STATE();
    case 181:
      if (lookahead == 's') ADVANCE(276);
      END_STATE();
    case 182:
      if (lookahead == 'n') ADVANCE(277);
      END_STATE();
    case 183:
      if (lookahead == 'r') ADVANCE(278);
      END_STATE();
    case 184:
      if (lookahead == 'l') ADVANCE(279);
      END_STATE();
    case 185:
      if (lookahead == 'a') ADVANCE(280);
      END_STATE();
    case 186:
      if (lookahead == 's') ADVANCE(281);
      END_STATE();
    case 187:
      if (lookahead == 't') ADVANCE(282);
      END_STATE();
    case 188:
      if (lookahead == 'd') ADVANCE(283);
      END_STATE();
    case 189:
      if (lookahead == 'i') ADVANCE(284);
      if (lookahead == 'r') ADVANCE(285);
      END_STATE();
    case 190:
      if (lookahead == 'y') ADVANCE(286);
      END_STATE();
    case 191:
      if (lookahead == 'a') ADVANCE(287);
      END_STATE();
    case 192:
      if (lookahead == 't') ADVANCE(288);
      END_STATE();
    case 193:
      if (lookahead == 'c') ADVANCE(289);
      END_STATE();
    case 194:
      if (lookahead == 'g') ADVANCE(290);
      END_STATE();
    case 195:
      if (lookahead == 'l') ADVANCE(291);
      END_STATE();
    case 196:
      if (lookahead == 'n') ADVANCE(292);
      END_STATE();
    case 197:
      if (lookahead == 'e') ADVANCE(293);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_auto);
      END_STATE();
    case 199:
      if (lookahead == 'n') ADVANCE(294);
      END_STATE();
    case 200:
      if (lookahead == 'r') ADVANCE(295);
      END_STATE();
    case 201:
      if (lookahead == 'k') ADVANCE(296);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_byte);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 204:
      if (lookahead == 'h') ADVANCE(297);
      END_STATE();
    case 205:
      if (lookahead == 's') ADVANCE(298);
      END_STATE();
    case 206:
      if (lookahead == 'w') ADVANCE(299);
      END_STATE();
    case 207:
      if (lookahead == 'e') ADVANCE(300);
      END_STATE();
    case 208:
      if (lookahead == 'i') ADVANCE(301);
      END_STATE();
    case 209:
      if (lookahead == 'l') ADVANCE(302);
      END_STATE();
    case 210:
      if (lookahead == 'e') ADVANCE(303);
      END_STATE();
    case 211:
      if (lookahead == 't') ADVANCE(304);
      END_STATE();
    case 212:
      if (lookahead == 'i') ADVANCE(305);
      END_STATE();
    case 213:
      if (lookahead == 't') ADVANCE(306);
      END_STATE();
    case 214:
      if (lookahead == 'u') ADVANCE(307);
      END_STATE();
    case 215:
      if (lookahead == 'n') ADVANCE(308);
      END_STATE();
    case 216:
      if (lookahead == 't') ADVANCE(309);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 219:
      if (lookahead == 'i') ADVANCE(310);
      END_STATE();
    case 220:
      if (lookahead == 'r') ADVANCE(311);
      END_STATE();
    case 221:
      if (lookahead == 'l') ADVANCE(312);
      END_STATE();
    case 222:
      if (lookahead == 'n') ADVANCE(313);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 224:
      if (lookahead == 'n') ADVANCE(314);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_long);
      END_STATE();
    case 226:
      if (lookahead == 'b') ADVANCE(315);
      END_STATE();
    case 227:
      if (lookahead == 's') ADVANCE(316);
      END_STATE();
    case 228:
      if (lookahead == 'c') ADVANCE(317);
      END_STATE();
    case 229:
      if (lookahead == 't') ADVANCE(318);
      END_STATE();
    case 230:
      if (lookahead == 'e') ADVANCE(319);
      END_STATE();
    case 231:
      if (lookahead == 'p') ADVANCE(320);
      END_STATE();
    case 232:
      if (lookahead == 'e') ADVANCE(321);
      END_STATE();
    case 233:
      if (lookahead == 'a') ADVANCE(322);
      END_STATE();
    case 234:
      if (lookahead == 'q') ADVANCE(323);
      END_STATE();
    case 235:
      if (lookahead == 'r') ADVANCE(324);
      END_STATE();
    case 236:
      if (lookahead == 'a') ADVANCE(325);
      END_STATE();
    case 237:
      if (lookahead == 'e') ADVANCE(326);
      END_STATE();
    case 238:
      if (lookahead == 'i') ADVANCE(327);
      END_STATE();
    case 239:
      if (lookahead == 's') ADVANCE(328);
      END_STATE();
    case 240:
      if (lookahead == 'i') ADVANCE(329);
      END_STATE();
    case 241:
      if (lookahead == 'r') ADVANCE(330);
      END_STATE();
    case 242:
      if (lookahead == 'r') ADVANCE(331);
      END_STATE();
    case 243:
      if (lookahead == 't') ADVANCE(332);
      END_STATE();
    case 244:
      if (lookahead == 'e') ADVANCE(333);
      END_STATE();
    case 245:
      if (lookahead == 'o') ADVANCE(334);
      END_STATE();
    case 246:
      if (lookahead == 'i') ADVANCE(335);
      END_STATE();
    case 247:
      if (lookahead == 'c') ADVANCE(336);
      END_STATE();
    case 248:
      if (lookahead == 'c') ADVANCE(337);
      END_STATE();
    case 249:
      if (lookahead == 'l') ADVANCE(338);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 251:
      if (lookahead == 'a') ADVANCE(339);
      END_STATE();
    case 252:
      if (lookahead == 'w') ADVANCE(340);
      END_STATE();
    case 253:
      if (lookahead == 'd') ADVANCE(341);
      if (lookahead == 'n') ADVANCE(342);
      END_STATE();
    case 254:
      if (lookahead == 'n') ADVANCE(343);
      END_STATE();
    case 255:
      if (lookahead == 'g') ADVANCE(344);
      END_STATE();
    case 256:
      if (lookahead == 'g') ADVANCE(345);
      END_STATE();
    case 257:
      if (lookahead == 'u') ADVANCE(346);
      END_STATE();
    case 258:
      if (lookahead == 't') ADVANCE(347);
      END_STATE();
    case 259:
      if (lookahead == 'e') ADVANCE(348);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_word);
      END_STATE();
    case 261:
      if (lookahead == 'e') ADVANCE(349);
      END_STATE();
    case 262:
      if (lookahead == 'E') ADVANCE(350);
      END_STATE();
    case 263:
      if (lookahead == 'n') ADVANCE(351);
      END_STATE();
    case 264:
      if (lookahead == 'i') ADVANCE(352);
      END_STATE();
    case 265:
      if (lookahead == 'r') ADVANCE(353);
      END_STATE();
    case 266:
      if (lookahead == 't') ADVANCE(354);
      END_STATE();
    case 267:
      if (lookahead == 'g') ADVANCE(355);
      END_STATE();
    case 268:
      if (lookahead == '_') ADVANCE(356);
      END_STATE();
    case 269:
      if (lookahead == 'r') ADVANCE(357);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(358);
      END_STATE();
    case 271:
      if (lookahead == 'c') ADVANCE(359);
      END_STATE();
    case 272:
      if (lookahead == 'c') ADVANCE(360);
      END_STATE();
    case 273:
      if (lookahead == 'l') ADVANCE(361);
      END_STATE();
    case 274:
      if (lookahead == 'e') ADVANCE(362);
      END_STATE();
    case 275:
      if (lookahead == 'e') ADVANCE(363);
      END_STATE();
    case 276:
      if (lookahead == 't') ADVANCE(364);
      END_STATE();
    case 277:
      if (lookahead == 'a') ADVANCE(365);
      END_STATE();
    case 278:
      if (lookahead == 'c') ADVANCE(366);
      END_STATE();
    case 279:
      if (lookahead == 'i') ADVANCE(367);
      END_STATE();
    case 280:
      if (lookahead == 'v') ADVANCE(368);
      END_STATE();
    case 281:
      if (lookahead == 't') ADVANCE(369);
      END_STATE();
    case 282:
      if (lookahead == 'r') ADVANCE(370);
      END_STATE();
    case 283:
      if (lookahead == 'c') ADVANCE(371);
      END_STATE();
    case 284:
      if (lookahead == 's') ADVANCE(372);
      END_STATE();
    case 285:
      if (lookahead == 'e') ADVANCE(373);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym___try);
      END_STATE();
    case 287:
      if (lookahead == 'l') ADVANCE(374);
      END_STATE();
    case 288:
      if (lookahead == 'r') ADVANCE(375);
      END_STATE();
    case 289:
      if (lookahead == 't') ADVANCE(376);
      END_STATE();
    case 290:
      if (lookahead == 'n') ADVANCE(377);
      END_STATE();
    case 291:
      if (lookahead == 'i') ADVANCE(378);
      END_STATE();
    case 292:
      if (lookahead == 'a') ADVANCE(379);
      if (lookahead == 'o') ADVANCE(380);
      END_STATE();
    case 293:
      if (lookahead == 'q') ADVANCE(381);
      END_STATE();
    case 294:
      if (lookahead == 'd') ADVANCE(382);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_bitor);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 299:
      if (lookahead == 'a') ADVANCE(383);
      END_STATE();
    case 300:
      if (lookahead == 't') ADVANCE(384);
      END_STATE();
    case 301:
      if (lookahead == 'e') ADVANCE(385);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_compl);
      END_STATE();
    case 303:
      if (lookahead == 'p') ADVANCE(386);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_const);
      if (lookahead == 'e') ADVANCE(387);
      if (lookahead == 'i') ADVANCE(388);
      END_STATE();
    case 305:
      if (lookahead == 'n') ADVANCE(389);
      END_STATE();
    case 306:
      if (lookahead == 'y') ADVANCE(390);
      END_STATE();
    case 307:
      if (lookahead == 'l') ADVANCE(391);
      END_STATE();
    case 308:
      if (lookahead == 'e') ADVANCE(392);
      END_STATE();
    case 309:
      if (lookahead == 'e') ADVANCE(393);
      END_STATE();
    case 310:
      if (lookahead == 'c') ADVANCE(394);
      END_STATE();
    case 311:
      if (lookahead == 'n') ADVANCE(395);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_final);
      END_STATE();
    case 313:
      if (lookahead == 'd') ADVANCE(396);
      END_STATE();
    case 314:
      if (lookahead == 'e') ADVANCE(397);
      END_STATE();
    case 315:
      if (lookahead == 'l') ADVANCE(398);
      END_STATE();
    case 316:
      if (lookahead == 'p') ADVANCE(399);
      END_STATE();
    case 317:
      if (lookahead == 'e') ADVANCE(400);
      END_STATE();
    case 318:
      if (lookahead == 'u') ADVANCE(401);
      END_STATE();
    case 319:
      if (lookahead == 'q') ADVANCE(402);
      END_STATE();
    case 320:
      if (lookahead == 't') ADVANCE(403);
      END_STATE();
    case 321:
      if (lookahead == 't') ADVANCE(404);
      END_STATE();
    case 322:
      if (lookahead == 't') ADVANCE(405);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(anon_sym_or_eq);
      END_STATE();
    case 324:
      if (lookahead == 'i') ADVANCE(406);
      END_STATE();
    case 325:
      if (lookahead == 't') ADVANCE(407);
      END_STATE();
    case 326:
      if (lookahead == 'c') ADVANCE(408);
      END_STATE();
    case 327:
      if (lookahead == 'c') ADVANCE(409);
      END_STATE();
    case 328:
      if (lookahead == 't') ADVANCE(410);
      END_STATE();
    case 329:
      if (lookahead == 'r') ADVANCE(411);
      END_STATE();
    case 330:
      if (lookahead == 'i') ADVANCE(412);
      END_STATE();
    case 331:
      if (lookahead == 'n') ADVANCE(413);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(anon_sym_short);
      END_STATE();
    case 333:
      if (lookahead == 'd') ADVANCE(414);
      END_STATE();
    case 334:
      if (lookahead == 'f') ADVANCE(415);
      END_STATE();
    case 335:
      if (lookahead == 'c') ADVANCE(416);
      END_STATE();
    case 336:
      if (lookahead == 't') ADVANCE(417);
      END_STATE();
    case 337:
      if (lookahead == 'h') ADVANCE(418);
      END_STATE();
    case 338:
      if (lookahead == 'a') ADVANCE(419);
      END_STATE();
    case 339:
      if (lookahead == 'd') ADVANCE(420);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 341:
      if (lookahead == 'e') ADVANCE(421);
      END_STATE();
    case 342:
      if (lookahead == 'a') ADVANCE(422);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 344:
      if (lookahead == 'n') ADVANCE(423);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 346:
      if (lookahead == 'a') ADVANCE(424);
      END_STATE();
    case 347:
      if (lookahead == 'i') ADVANCE(425);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 349:
      if (lookahead == 'q') ADVANCE(426);
      END_STATE();
    case 350:
      if (lookahead == 'M') ADVANCE(427);
      END_STATE();
    case 351:
      if (lookahead == 'o') ADVANCE(428);
      END_STATE();
    case 352:
      if (lookahead == 'c') ADVANCE(429);
      END_STATE();
    case 353:
      if (lookahead == 'i') ADVANCE(430);
      END_STATE();
    case 354:
      if (lookahead == 'u') ADVANCE(431);
      END_STATE();
    case 355:
      if (lookahead == 'n') ADVANCE(432);
      END_STATE();
    case 356:
      if (lookahead == '_') ADVANCE(433);
      END_STATE();
    case 357:
      if (lookahead == 'i') ADVANCE(434);
      END_STATE();
    case 358:
      if (lookahead == 'd') ADVANCE(435);
      END_STATE();
    case 359:
      if (lookahead == 'l') ADVANCE(436);
      END_STATE();
    case 360:
      if (lookahead == 'a') ADVANCE(437);
      END_STATE();
    case 361:
      if (lookahead == 's') ADVANCE(438);
      END_STATE();
    case 362:
      if (lookahead == 'p') ADVANCE(439);
      END_STATE();
    case 363:
      if (lookahead == 'n') ADVANCE(440);
      END_STATE();
    case 364:
      if (lookahead == 'c') ADVANCE(441);
      END_STATE();
    case 365:
      if (lookahead == 'l') ADVANCE(442);
      END_STATE();
    case 366:
      if (lookahead == 'e') ADVANCE(443);
      END_STATE();
    case 367:
      if (lookahead == 'n') ADVANCE(444);
      END_STATE();
    case 368:
      if (lookahead == 'e') ADVANCE(445);
      END_STATE();
    case 369:
      if (lookahead == 'r') ADVANCE(446);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(sym_ms_signed_ptr_modifier);
      END_STATE();
    case 371:
      if (lookahead == 'a') ADVANCE(447);
      END_STATE();
    case 372:
      if (lookahead == 'c') ADVANCE(448);
      END_STATE();
    case 373:
      if (lookahead == 'a') ADVANCE(449);
      END_STATE();
    case 374:
      if (lookahead == 'i') ADVANCE(450);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(sym_ms_unsigned_ptr_modifier);
      END_STATE();
    case 376:
      if (lookahead == 'o') ADVANCE(451);
      END_STATE();
    case 377:
      if (lookahead == 'o') ADVANCE(452);
      END_STATE();
    case 378:
      if (lookahead == 'g') ADVANCE(453);
      END_STATE();
    case 379:
      if (lookahead == 's') ADVANCE(454);
      END_STATE();
    case 380:
      if (lookahead == 'f') ADVANCE(455);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(anon_sym_and_eq);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(anon_sym_bitand);
      END_STATE();
    case 383:
      if (lookahead == 'i') ADVANCE(456);
      END_STATE();
    case 384:
      if (lookahead == 'u') ADVANCE(457);
      END_STATE();
    case 385:
      if (lookahead == 'l') ADVANCE(458);
      END_STATE();
    case 386:
      if (lookahead == 't') ADVANCE(459);
      END_STATE();
    case 387:
      if (lookahead == 'v') ADVANCE(460);
      if (lookahead == 'x') ADVANCE(461);
      END_STATE();
    case 388:
      if (lookahead == 'n') ADVANCE(462);
      END_STATE();
    case 389:
      if (lookahead == 'u') ADVANCE(463);
      END_STATE();
    case 390:
      if (lookahead == 'p') ADVANCE(464);
      END_STATE();
    case 391:
      if (lookahead == 't') ADVANCE(465);
      END_STATE();
    case 392:
      if (lookahead == 'd') ADVANCE(466);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 394:
      if (lookahead == 'i') ADVANCE(467);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(anon_sym_friend);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(anon_sym_inline);
      END_STATE();
    case 398:
      if (lookahead == 'e') ADVANCE(468);
      END_STATE();
    case 399:
      if (lookahead == 'a') ADVANCE(469);
      END_STATE();
    case 400:
      if (lookahead == 'p') ADVANCE(470);
      END_STATE();
    case 401:
      if (lookahead == 'r') ADVANCE(471);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(anon_sym_not_eq);
      END_STATE();
    case 403:
      if (lookahead == 'r') ADVANCE(472);
      END_STATE();
    case 404:
      if (lookahead == 'o') ADVANCE(473);
      END_STATE();
    case 405:
      if (lookahead == 'o') ADVANCE(474);
      END_STATE();
    case 406:
      if (lookahead == 'd') ADVANCE(475);
      END_STATE();
    case 407:
      if (lookahead == 'e') ADVANCE(476);
      END_STATE();
    case 408:
      if (lookahead == 't') ADVANCE(477);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 410:
      if (lookahead == 'e') ADVANCE(478);
      END_STATE();
    case 411:
      if (lookahead == 'e') ADVANCE(479);
      END_STATE();
    case 412:
      if (lookahead == 'c') ADVANCE(480);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(anon_sym_signed);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_sizeof);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym_static);
      if (lookahead == '_') ADVANCE(481);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 419:
      if (lookahead == 't') ADVANCE(482);
      END_STATE();
    case 420:
      if (lookahead == '_') ADVANCE(483);
      END_STATE();
    case 421:
      if (lookahead == 'f') ADVANCE(484);
      END_STATE();
    case 422:
      if (lookahead == 'm') ADVANCE(485);
      END_STATE();
    case 423:
      if (lookahead == 'e') ADVANCE(486);
      END_STATE();
    case 424:
      if (lookahead == 'l') ADVANCE(487);
      END_STATE();
    case 425:
      if (lookahead == 'l') ADVANCE(488);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(anon_sym_xor_eq);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(anon_sym_PROGMEM);
      END_STATE();
    case 428:
      if (lookahead == 'f') ADVANCE(489);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(anon_sym__Atomic);
      END_STATE();
    case 430:
      if (lookahead == 'c') ADVANCE(490);
      END_STATE();
    case 431:
      if (lookahead == 'r') ADVANCE(491);
      END_STATE();
    case 432:
      if (lookahead == 'o') ADVANCE(492);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(anon_sym___asm__);
      END_STATE();
    case 434:
      if (lookahead == 'b') ADVANCE(493);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(anon_sym___based);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(anon_sym___cdecl);
      END_STATE();
    case 437:
      if (lookahead == 'l') ADVANCE(494);
      END_STATE();
    case 438:
      if (lookahead == 'p') ADVANCE(495);
      END_STATE();
    case 439:
      if (lookahead == 't') ADVANCE(496);
      END_STATE();
    case 440:
      if (lookahead == 's') ADVANCE(497);
      END_STATE();
    case 441:
      if (lookahead == 'a') ADVANCE(498);
      END_STATE();
    case 442:
      if (lookahead == 'l') ADVANCE(499);
      END_STATE();
    case 443:
      if (lookahead == 'i') ADVANCE(500);
      END_STATE();
    case 444:
      if (lookahead == 'e') ADVANCE(501);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(anon_sym___leave);
      END_STATE();
    case 446:
      if (lookahead == 'i') ADVANCE(502);
      END_STATE();
    case 447:
      if (lookahead == 'l') ADVANCE(503);
      END_STATE();
    case 448:
      if (lookahead == 'a') ADVANCE(504);
      END_STATE();
    case 449:
      if (lookahead == 'd') ADVANCE(505);
      END_STATE();
    case 450:
      if (lookahead == 'g') ADVANCE(506);
      END_STATE();
    case 451:
      if (lookahead == 'r') ADVANCE(507);
      END_STATE();
    case 452:
      if (lookahead == 'f') ADVANCE(508);
      END_STATE();
    case 453:
      if (lookahead == 'n') ADVANCE(509);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(anon_sym_alignas);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym_alignof);
      END_STATE();
    case 456:
      if (lookahead == 't') ADVANCE(510);
      END_STATE();
    case 457:
      if (lookahead == 'r') ADVANCE(511);
      END_STATE();
    case 458:
      if (lookahead == 'd') ADVANCE(512);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_concept);
      END_STATE();
    case 460:
      if (lookahead == 'a') ADVANCE(513);
      END_STATE();
    case 461:
      if (lookahead == 'p') ADVANCE(514);
      END_STATE();
    case 462:
      if (lookahead == 'i') ADVANCE(515);
      END_STATE();
    case 463:
      if (lookahead == 'e') ADVANCE(516);
      END_STATE();
    case 464:
      if (lookahead == 'e') ADVANCE(517);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(anon_sym_defined);
      END_STATE();
    case 467:
      if (lookahead == 't') ADVANCE(518);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_mutable);
      END_STATE();
    case 469:
      if (lookahead == 'c') ADVANCE(519);
      END_STATE();
    case 470:
      if (lookahead == 't') ADVANCE(520);
      END_STATE();
    case 471:
      if (lookahead == 'n') ADVANCE(521);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_nullptr);
      END_STATE();
    case 473:
      if (lookahead == 'f') ADVANCE(522);
      END_STATE();
    case 474:
      if (lookahead == 'r') ADVANCE(523);
      END_STATE();
    case 475:
      if (lookahead == 'e') ADVANCE(524);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 477:
      if (lookahead == 'e') ADVANCE(525);
      END_STATE();
    case 478:
      if (lookahead == 'r') ADVANCE(526);
      END_STATE();
    case 479:
      if (lookahead == 's') ADVANCE(527);
      END_STATE();
    case 480:
      if (lookahead == 't') ADVANCE(528);
      END_STATE();
    case 481:
      if (lookahead == 'a') ADVANCE(529);
      END_STATE();
    case 482:
      if (lookahead == 'e') ADVANCE(530);
      END_STATE();
    case 483:
      if (lookahead == 'l') ADVANCE(531);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym_typedef);
      END_STATE();
    case 485:
      if (lookahead == 'e') ADVANCE(532);
      END_STATE();
    case 486:
      if (lookahead == 'd') ADVANCE(533);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym_virtual);
      END_STATE();
    case 488:
      if (lookahead == 'e') ADVANCE(534);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(anon_sym__Alignof);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym__Generic);
      END_STATE();
    case 491:
      if (lookahead == 'n') ADVANCE(535);
      END_STATE();
    case 492:
      if (lookahead == 'f') ADVANCE(536);
      END_STATE();
    case 493:
      if (lookahead == 'u') ADVANCE(537);
      END_STATE();
    case 494:
      if (lookahead == 'l') ADVANCE(538);
      END_STATE();
    case 495:
      if (lookahead == 'e') ADVANCE(539);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(anon_sym___except);
      END_STATE();
    case 497:
      if (lookahead == 'i') ADVANCE(540);
      END_STATE();
    case 498:
      if (lookahead == 'l') ADVANCE(541);
      END_STATE();
    case 499:
      if (lookahead == 'y') ADVANCE(542);
      END_STATE();
    case 500:
      if (lookahead == 'n') ADVANCE(543);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(anon_sym___inline);
      if (lookahead == '_') ADVANCE(544);
      END_STATE();
    case 502:
      if (lookahead == 'c') ADVANCE(545);
      END_STATE();
    case 503:
      if (lookahead == 'l') ADVANCE(546);
      END_STATE();
    case 504:
      if (lookahead == 'l') ADVANCE(547);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(anon_sym___thread);
      END_STATE();
    case 506:
      if (lookahead == 'n') ADVANCE(548);
      END_STATE();
    case 507:
      if (lookahead == 'c') ADVANCE(549);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(anon_sym__alignof);
      END_STATE();
    case 509:
      if (lookahead == 'e') ADVANCE(550);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(anon_sym_co_await);
      END_STATE();
    case 511:
      if (lookahead == 'n') ADVANCE(551);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(anon_sym_co_yield);
      END_STATE();
    case 513:
      if (lookahead == 'l') ADVANCE(552);
      END_STATE();
    case 514:
      if (lookahead == 'r') ADVANCE(553);
      END_STATE();
    case 515:
      if (lookahead == 't') ADVANCE(554);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(anon_sym_decltype);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(anon_sym_explicit);
      END_STATE();
    case 519:
      if (lookahead == 'e') ADVANCE(555);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym_noexcept);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym_noreturn);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(anon_sym_offsetof);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(anon_sym_operator);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 525:
      if (lookahead == 'd') ADVANCE(556);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(anon_sym_register);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym_requires);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(anon_sym_restrict);
      END_STATE();
    case 529:
      if (lookahead == 's') ADVANCE(557);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(anon_sym_template);
      END_STATE();
    case 531:
      if (lookahead == 'o') ADVANCE(558);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(anon_sym_typename);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(anon_sym_unsigned);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(anon_sym__Noreturn);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(anon_sym___alignof);
      if (lookahead == '_') ADVANCE(559);
      END_STATE();
    case 537:
      if (lookahead == 't') ADVANCE(560);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(anon_sym___clrcall);
      END_STATE();
    case 539:
      if (lookahead == 'c') ADVANCE(561);
      END_STATE();
    case 540:
      if (lookahead == 'o') ADVANCE(562);
      END_STATE();
    case 541:
      if (lookahead == 'l') ADVANCE(563);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(anon_sym___finally);
      END_STATE();
    case 543:
      if (lookahead == 'l') ADVANCE(564);
      END_STATE();
    case 544:
      if (lookahead == '_') ADVANCE(565);
      END_STATE();
    case 545:
      if (lookahead == 't') ADVANCE(566);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(anon_sym___stdcall);
      END_STATE();
    case 547:
      if (lookahead == 'l') ADVANCE(567);
      END_STATE();
    case 548:
      if (lookahead == 'e') ADVANCE(568);
      END_STATE();
    case 549:
      if (lookahead == 'a') ADVANCE(569);
      END_STATE();
    case 550:
      if (lookahead == 'd') ADVANCE(570);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(anon_sym_co_return);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(anon_sym_consteval);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(anon_sym_constexpr);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(anon_sym_constinit);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 557:
      if (lookahead == 's') ADVANCE(571);
      END_STATE();
    case 558:
      if (lookahead == 'c') ADVANCE(572);
      END_STATE();
    case 559:
      if (lookahead == '_') ADVANCE(573);
      END_STATE();
    case 560:
      if (lookahead == 'e') ADVANCE(574);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(anon_sym___declspec);
      END_STATE();
    case 562:
      if (lookahead == 'n') ADVANCE(575);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(anon_sym___fastcall);
      END_STATE();
    case 564:
      if (lookahead == 'i') ADVANCE(576);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(anon_sym___inline__);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(sym_ms_restrict_modifier);
      if (lookahead == '_') ADVANCE(577);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(anon_sym___thiscall);
      END_STATE();
    case 568:
      if (lookahead == 'd') ADVANCE(578);
      END_STATE();
    case 569:
      if (lookahead == 'l') ADVANCE(579);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(anon_sym__unaligned);
      END_STATE();
    case 571:
      if (lookahead == 'e') ADVANCE(580);
      END_STATE();
    case 572:
      if (lookahead == 'a') ADVANCE(581);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(anon_sym___alignof__);
      END_STATE();
    case 574:
      if (lookahead == '_') ADVANCE(582);
      END_STATE();
    case 575:
      if (lookahead == '_') ADVANCE(583);
      END_STATE();
    case 576:
      if (lookahead == 'n') ADVANCE(584);
      END_STATE();
    case 577:
      if (lookahead == '_') ADVANCE(585);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(anon_sym___unaligned);
      END_STATE();
    case 579:
      if (lookahead == 'l') ADVANCE(586);
      END_STATE();
    case 580:
      if (lookahead == 'r') ADVANCE(587);
      END_STATE();
    case 581:
      if (lookahead == 'l') ADVANCE(588);
      END_STATE();
    case 582:
      if (lookahead == '_') ADVANCE(589);
      END_STATE();
    case 583:
      if (lookahead == '_') ADVANCE(590);
      END_STATE();
    case 584:
      if (lookahead == 'e') ADVANCE(591);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(anon_sym___restrict__);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(anon_sym___vectorcall);
      END_STATE();
    case 587:
      if (lookahead == 't') ADVANCE(592);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(anon_sym_thread_local);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(anon_sym___attribute__);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(anon_sym___extension__);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(anon_sym___forceinline);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(anon_sym_static_assert);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 387},
  [2] = {.lex_state = 387},
  [3] = {.lex_state = 387},
  [4] = {.lex_state = 387},
  [5] = {.lex_state = 387},
  [6] = {.lex_state = 387},
  [7] = {.lex_state = 387},
  [8] = {.lex_state = 387},
  [9] = {.lex_state = 387},
  [10] = {.lex_state = 387},
  [11] = {.lex_state = 387},
  [12] = {.lex_state = 387},
  [13] = {.lex_state = 387},
  [14] = {.lex_state = 387},
  [15] = {.lex_state = 387},
  [16] = {.lex_state = 198},
  [17] = {.lex_state = 198},
  [18] = {.lex_state = 198},
  [19] = {.lex_state = 198},
  [20] = {.lex_state = 198},
  [21] = {.lex_state = 198},
  [22] = {.lex_state = 198},
  [23] = {.lex_state = 198},
  [24] = {.lex_state = 198},
  [25] = {.lex_state = 198},
  [26] = {.lex_state = 202},
  [27] = {.lex_state = 202},
  [28] = {.lex_state = 202},
  [29] = {.lex_state = 202},
  [30] = {.lex_state = 202},
  [31] = {.lex_state = 202},
  [32] = {.lex_state = 198},
  [33] = {.lex_state = 202},
  [34] = {.lex_state = 202},
  [35] = {.lex_state = 202},
  [36] = {.lex_state = 202},
  [37] = {.lex_state = 202},
  [38] = {.lex_state = 202},
  [39] = {.lex_state = 202},
  [40] = {.lex_state = 202},
  [41] = {.lex_state = 202},
  [42] = {.lex_state = 387},
  [43] = {.lex_state = 387},
  [44] = {.lex_state = 387},
  [45] = {.lex_state = 387},
  [46] = {.lex_state = 387},
  [47] = {.lex_state = 387},
  [48] = {.lex_state = 387},
  [49] = {.lex_state = 387},
  [50] = {.lex_state = 387},
  [51] = {.lex_state = 387},
  [52] = {.lex_state = 387},
  [53] = {.lex_state = 387},
  [54] = {.lex_state = 387},
  [55] = {.lex_state = 387},
  [56] = {.lex_state = 387},
  [57] = {.lex_state = 387},
  [58] = {.lex_state = 387},
  [59] = {.lex_state = 387},
  [60] = {.lex_state = 387},
  [61] = {.lex_state = 387},
  [62] = {.lex_state = 387},
  [63] = {.lex_state = 387},
  [64] = {.lex_state = 387},
  [65] = {.lex_state = 387},
  [66] = {.lex_state = 387},
  [67] = {.lex_state = 387},
  [68] = {.lex_state = 387},
  [69] = {.lex_state = 387},
  [70] = {.lex_state = 387},
  [71] = {.lex_state = 387},
  [72] = {.lex_state = 387},
  [73] = {.lex_state = 387},
  [74] = {.lex_state = 387},
  [75] = {.lex_state = 387},
  [76] = {.lex_state = 387},
  [77] = {.lex_state = 387},
  [78] = {.lex_state = 387},
  [79] = {.lex_state = 201},
  [80] = {.lex_state = 387},
  [81] = {.lex_state = 387},
  [82] = {.lex_state = 387},
  [83] = {.lex_state = 387},
  [84] = {.lex_state = 387},
  [85] = {.lex_state = 387},
  [86] = {.lex_state = 387},
  [87] = {.lex_state = 201},
  [88] = {.lex_state = 387},
  [89] = {.lex_state = 387},
  [90] = {.lex_state = 387},
  [91] = {.lex_state = 387},
  [92] = {.lex_state = 387},
  [93] = {.lex_state = 387},
  [94] = {.lex_state = 201},
  [95] = {.lex_state = 387},
  [96] = {.lex_state = 387},
  [97] = {.lex_state = 387},
  [98] = {.lex_state = 387},
  [99] = {.lex_state = 387},
  [100] = {.lex_state = 198},
  [101] = {.lex_state = 198},
  [102] = {.lex_state = 198},
  [103] = {.lex_state = 198},
  [104] = {.lex_state = 198},
  [105] = {.lex_state = 202},
  [106] = {.lex_state = 202},
  [107] = {.lex_state = 202},
  [108] = {.lex_state = 202},
  [109] = {.lex_state = 202},
  [110] = {.lex_state = 201},
  [111] = {.lex_state = 387},
  [112] = {.lex_state = 387},
  [113] = {.lex_state = 387},
  [114] = {.lex_state = 387},
  [115] = {.lex_state = 387},
  [116] = {.lex_state = 387},
  [117] = {.lex_state = 387},
  [118] = {.lex_state = 387},
  [119] = {.lex_state = 387},
  [120] = {.lex_state = 387},
  [121] = {.lex_state = 201},
  [122] = {.lex_state = 201},
  [123] = {.lex_state = 201},
  [124] = {.lex_state = 201},
  [125] = {.lex_state = 200},
  [126] = {.lex_state = 200},
  [127] = {.lex_state = 200},
  [128] = {.lex_state = 200},
  [129] = {.lex_state = 200},
  [130] = {.lex_state = 200},
  [131] = {.lex_state = 200},
  [132] = {.lex_state = 200},
  [133] = {.lex_state = 200},
  [134] = {.lex_state = 200},
  [135] = {.lex_state = 200},
  [136] = {.lex_state = 200},
  [137] = {.lex_state = 200},
  [138] = {.lex_state = 200},
  [139] = {.lex_state = 200},
  [140] = {.lex_state = 200},
  [141] = {.lex_state = 200},
  [142] = {.lex_state = 200},
  [143] = {.lex_state = 200},
  [144] = {.lex_state = 200},
  [145] = {.lex_state = 200},
  [146] = {.lex_state = 200},
  [147] = {.lex_state = 203},
  [148] = {.lex_state = 203},
  [149] = {.lex_state = 203},
  [150] = {.lex_state = 200},
  [151] = {.lex_state = 189},
  [152] = {.lex_state = 189},
  [153] = {.lex_state = 387},
  [154] = {.lex_state = 191},
  [155] = {.lex_state = 387},
  [156] = {.lex_state = 200},
  [157] = {.lex_state = 189},
  [158] = {.lex_state = 193},
  [159] = {.lex_state = 200},
  [160] = {.lex_state = 200},
  [161] = {.lex_state = 200},
  [162] = {.lex_state = 200},
  [163] = {.lex_state = 200},
  [164] = {.lex_state = 200},
  [165] = {.lex_state = 200},
  [166] = {.lex_state = 200},
  [167] = {.lex_state = 200},
  [168] = {.lex_state = 200},
  [169] = {.lex_state = 200},
  [170] = {.lex_state = 200},
  [171] = {.lex_state = 200},
  [172] = {.lex_state = 200},
  [173] = {.lex_state = 200},
  [174] = {.lex_state = 200},
  [175] = {.lex_state = 200},
  [176] = {.lex_state = 200},
  [177] = {.lex_state = 200},
  [178] = {.lex_state = 200},
  [179] = {.lex_state = 200},
  [180] = {.lex_state = 200},
  [181] = {.lex_state = 200},
  [182] = {.lex_state = 200},
  [183] = {.lex_state = 200},
  [184] = {.lex_state = 200},
  [185] = {.lex_state = 200},
  [186] = {.lex_state = 200},
  [187] = {.lex_state = 200},
  [188] = {.lex_state = 200},
  [189] = {.lex_state = 200},
  [190] = {.lex_state = 200},
  [191] = {.lex_state = 200},
  [192] = {.lex_state = 200},
  [193] = {.lex_state = 200},
  [194] = {.lex_state = 200},
  [195] = {.lex_state = 200},
  [196] = {.lex_state = 200},
  [197] = {.lex_state = 200},
  [198] = {.lex_state = 200},
  [199] = {.lex_state = 189},
  [200] = {.lex_state = 200},
  [201] = {.lex_state = 200},
  [202] = {.lex_state = 200},
  [203] = {.lex_state = 200},
  [204] = {.lex_state = 200},
  [205] = {.lex_state = 200},
  [206] = {.lex_state = 200},
  [207] = {.lex_state = 200},
  [208] = {.lex_state = 200},
  [209] = {.lex_state = 200},
  [210] = {.lex_state = 200},
  [211] = {.lex_state = 194},
  [212] = {.lex_state = 200},
  [213] = {.lex_state = 200},
  [214] = {.lex_state = 200},
  [215] = {.lex_state = 200},
  [216] = {.lex_state = 200},
  [217] = {.lex_state = 200},
  [218] = {.lex_state = 200},
  [219] = {.lex_state = 200},
  [220] = {.lex_state = 200},
  [221] = {.lex_state = 200},
  [222] = {.lex_state = 200},
  [223] = {.lex_state = 200},
  [224] = {.lex_state = 200},
  [225] = {.lex_state = 200},
  [226] = {.lex_state = 200},
  [227] = {.lex_state = 200},
  [228] = {.lex_state = 200},
  [229] = {.lex_state = 200},
  [230] = {.lex_state = 204},
  [231] = {.lex_state = 204},
  [232] = {.lex_state = 204},
  [233] = {.lex_state = 204},
  [234] = {.lex_state = 204},
  [235] = {.lex_state = 204},
  [236] = {.lex_state = 204},
  [237] = {.lex_state = 204},
  [238] = {.lex_state = 204},
  [239] = {.lex_state = 204},
  [240] = {.lex_state = 204},
  [241] = {.lex_state = 204},
  [242] = {.lex_state = 204},
  [243] = {.lex_state = 204},
  [244] = {.lex_state = 204},
  [245] = {.lex_state = 204},
  [246] = {.lex_state = 204},
  [247] = {.lex_state = 204},
  [248] = {.lex_state = 204},
  [249] = {.lex_state = 204},
  [250] = {.lex_state = 204},
  [251] = {.lex_state = 204},
  [252] = {.lex_state = 204},
  [253] = {.lex_state = 204},
  [254] = {.lex_state = 204},
  [255] = {.lex_state = 204},
  [256] = {.lex_state = 204},
  [257] = {.lex_state = 204},
  [258] = {.lex_state = 204},
  [259] = {.lex_state = 193},
  [260] = {.lex_state = 204},
  [261] = {.lex_state = 198},
  [262] = {.lex_state = 198},
  [263] = {.lex_state = 198},
  [264] = {.lex_state = 198},
  [265] = {.lex_state = 200},
  [266] = {.lex_state = 202},
  [267] = {.lex_state = 198},
  [268] = {.lex_state = 198},
  [269] = {.lex_state = 198},
  [270] = {.lex_state = 198},
  [271] = {.lex_state = 200},
  [272] = {.lex_state = 198},
  [273] = {.lex_state = 200},
  [274] = {.lex_state = 202},
  [275] = {.lex_state = 198},
  [276] = {.lex_state = 198},
  [277] = {.lex_state = 198},
  [278] = {.lex_state = 198},
  [279] = {.lex_state = 198},
  [280] = {.lex_state = 198},
  [281] = {.lex_state = 198},
  [282] = {.lex_state = 198},
  [283] = {.lex_state = 198},
  [284] = {.lex_state = 198},
  [285] = {.lex_state = 204},
  [286] = {.lex_state = 198},
  [287] = {.lex_state = 198},
  [288] = {.lex_state = 198},
  [289] = {.lex_state = 204},
  [290] = {.lex_state = 198},
  [291] = {.lex_state = 204},
  [292] = {.lex_state = 198},
  [293] = {.lex_state = 204},
  [294] = {.lex_state = 198},
  [295] = {.lex_state = 198},
  [296] = {.lex_state = 198},
  [297] = {.lex_state = 198},
  [298] = {.lex_state = 198},
  [299] = {.lex_state = 198},
  [300] = {.lex_state = 198},
  [301] = {.lex_state = 198},
  [302] = {.lex_state = 198},
  [303] = {.lex_state = 204},
  [304] = {.lex_state = 198},
  [305] = {.lex_state = 198},
  [306] = {.lex_state = 198},
  [307] = {.lex_state = 198},
  [308] = {.lex_state = 198},
  [309] = {.lex_state = 198},
  [310] = {.lex_state = 204},
  [311] = {.lex_state = 198},
  [312] = {.lex_state = 198},
  [313] = {.lex_state = 198},
  [314] = {.lex_state = 198},
  [315] = {.lex_state = 198},
  [316] = {.lex_state = 198},
  [317] = {.lex_state = 198},
  [318] = {.lex_state = 198},
  [319] = {.lex_state = 204},
  [320] = {.lex_state = 198},
  [321] = {.lex_state = 198},
  [322] = {.lex_state = 198},
  [323] = {.lex_state = 198},
  [324] = {.lex_state = 198},
  [325] = {.lex_state = 204},
  [326] = {.lex_state = 198},
  [327] = {.lex_state = 198},
  [328] = {.lex_state = 198},
  [329] = {.lex_state = 204},
  [330] = {.lex_state = 198},
  [331] = {.lex_state = 198},
  [332] = {.lex_state = 198},
  [333] = {.lex_state = 198},
  [334] = {.lex_state = 198},
  [335] = {.lex_state = 198},
  [336] = {.lex_state = 198},
  [337] = {.lex_state = 204},
  [338] = {.lex_state = 198},
  [339] = {.lex_state = 198},
  [340] = {.lex_state = 198},
  [341] = {.lex_state = 204},
  [342] = {.lex_state = 198},
  [343] = {.lex_state = 198},
  [344] = {.lex_state = 198},
  [345] = {.lex_state = 204},
  [346] = {.lex_state = 204},
  [347] = {.lex_state = 198},
  [348] = {.lex_state = 198},
  [349] = {.lex_state = 198},
  [350] = {.lex_state = 198},
  [351] = {.lex_state = 204},
  [352] = {.lex_state = 204},
  [353] = {.lex_state = 198},
  [354] = {.lex_state = 198},
  [355] = {.lex_state = 204},
  [356] = {.lex_state = 198},
  [357] = {.lex_state = 198},
  [358] = {.lex_state = 204},
  [359] = {.lex_state = 202},
  [360] = {.lex_state = 198},
  [361] = {.lex_state = 204},
  [362] = {.lex_state = 198},
  [363] = {.lex_state = 198},
  [364] = {.lex_state = 198},
  [365] = {.lex_state = 198},
  [366] = {.lex_state = 198},
  [367] = {.lex_state = 204},
  [368] = {.lex_state = 198},
  [369] = {.lex_state = 198},
  [370] = {.lex_state = 202},
  [371] = {.lex_state = 198},
  [372] = {.lex_state = 198},
  [373] = {.lex_state = 198},
  [374] = {.lex_state = 198},
  [375] = {.lex_state = 198},
  [376] = {.lex_state = 201},
  [377] = {.lex_state = 198},
  [378] = {.lex_state = 282},
  [379] = {.lex_state = 198},
  [380] = {.lex_state = 198},
  [381] = {.lex_state = 198},
  [382] = {.lex_state = 198},
  [383] = {.lex_state = 198},
  [384] = {.lex_state = 198},
  [385] = {.lex_state = 282},
  [386] = {.lex_state = 198},
  [387] = {.lex_state = 198},
  [388] = {.lex_state = 387},
  [389] = {.lex_state = 282},
  [390] = {.lex_state = 282},
  [391] = {.lex_state = 282},
  [392] = {.lex_state = 198},
  [393] = {.lex_state = 204},
  [394] = {.lex_state = 198},
  [395] = {.lex_state = 198},
  [396] = {.lex_state = 387},
  [397] = {.lex_state = 202},
  [398] = {.lex_state = 198},
  [399] = {.lex_state = 198},
  [400] = {.lex_state = 200},
  [401] = {.lex_state = 198},
  [402] = {.lex_state = 198},
  [403] = {.lex_state = 198},
  [404] = {.lex_state = 198},
  [405] = {.lex_state = 282},
  [406] = {.lex_state = 282},
  [407] = {.lex_state = 387},
  [408] = {.lex_state = 198},
  [409] = {.lex_state = 198},
  [410] = {.lex_state = 201},
  [411] = {.lex_state = 198},
  [412] = {.lex_state = 198},
  [413] = {.lex_state = 198},
  [414] = {.lex_state = 282},
  [415] = {.lex_state = 198},
  [416] = {.lex_state = 198},
  [417] = {.lex_state = 198},
  [418] = {.lex_state = 202},
  [419] = {.lex_state = 198},
  [420] = {.lex_state = 198},
  [421] = {.lex_state = 198},
  [422] = {.lex_state = 198},
  [423] = {.lex_state = 203},
  [424] = {.lex_state = 198},
  [425] = {.lex_state = 198},
  [426] = {.lex_state = 198},
  [427] = {.lex_state = 198},
  [428] = {.lex_state = 198},
  [429] = {.lex_state = 198},
  [430] = {.lex_state = 198},
  [431] = {.lex_state = 198},
  [432] = {.lex_state = 198},
  [433] = {.lex_state = 198},
  [434] = {.lex_state = 198},
  [435] = {.lex_state = 198},
  [436] = {.lex_state = 198},
  [437] = {.lex_state = 198},
  [438] = {.lex_state = 198},
  [439] = {.lex_state = 198},
  [440] = {.lex_state = 202},
  [441] = {.lex_state = 203},
  [442] = {.lex_state = 198},
  [443] = {.lex_state = 202},
  [444] = {.lex_state = 198},
  [445] = {.lex_state = 198},
  [446] = {.lex_state = 198},
  [447] = {.lex_state = 198},
  [448] = {.lex_state = 202},
  [449] = {.lex_state = 198},
  [450] = {.lex_state = 198},
  [451] = {.lex_state = 198},
  [452] = {.lex_state = 198},
  [453] = {.lex_state = 198},
  [454] = {.lex_state = 387},
  [455] = {.lex_state = 198},
  [456] = {.lex_state = 198},
  [457] = {.lex_state = 198},
  [458] = {.lex_state = 198},
  [459] = {.lex_state = 198},
  [460] = {.lex_state = 198},
  [461] = {.lex_state = 202},
  [462] = {.lex_state = 202},
  [463] = {.lex_state = 202},
  [464] = {.lex_state = 202},
  [465] = {.lex_state = 202},
  [466] = {.lex_state = 202},
  [467] = {.lex_state = 202},
  [468] = {.lex_state = 202},
  [469] = {.lex_state = 202},
  [470] = {.lex_state = 202},
  [471] = {.lex_state = 202},
  [472] = {.lex_state = 202},
  [473] = {.lex_state = 202},
  [474] = {.lex_state = 202},
  [475] = {.lex_state = 202},
  [476] = {.lex_state = 202},
  [477] = {.lex_state = 202},
  [478] = {.lex_state = 202},
  [479] = {.lex_state = 202},
  [480] = {.lex_state = 387},
  [481] = {.lex_state = 202},
  [482] = {.lex_state = 202},
  [483] = {.lex_state = 202},
  [484] = {.lex_state = 202},
  [485] = {.lex_state = 202},
  [486] = {.lex_state = 202},
  [487] = {.lex_state = 202},
  [488] = {.lex_state = 202},
  [489] = {.lex_state = 202},
  [490] = {.lex_state = 202},
  [491] = {.lex_state = 202},
  [492] = {.lex_state = 202},
  [493] = {.lex_state = 202},
  [494] = {.lex_state = 201},
  [495] = {.lex_state = 202},
  [496] = {.lex_state = 202},
  [497] = {.lex_state = 202},
  [498] = {.lex_state = 202},
  [499] = {.lex_state = 202},
  [500] = {.lex_state = 202},
  [501] = {.lex_state = 202},
  [502] = {.lex_state = 202},
  [503] = {.lex_state = 202},
  [504] = {.lex_state = 202},
  [505] = {.lex_state = 202},
  [506] = {.lex_state = 202},
  [507] = {.lex_state = 202},
  [508] = {.lex_state = 202},
  [509] = {.lex_state = 202},
  [510] = {.lex_state = 202},
  [511] = {.lex_state = 202},
  [512] = {.lex_state = 202},
  [513] = {.lex_state = 202},
  [514] = {.lex_state = 202},
  [515] = {.lex_state = 201},
  [516] = {.lex_state = 202},
  [517] = {.lex_state = 202},
  [518] = {.lex_state = 202},
  [519] = {.lex_state = 202},
  [520] = {.lex_state = 202},
  [521] = {.lex_state = 202},
  [522] = {.lex_state = 202},
  [523] = {.lex_state = 202},
  [524] = {.lex_state = 202},
  [525] = {.lex_state = 202},
  [526] = {.lex_state = 202},
  [527] = {.lex_state = 202},
  [528] = {.lex_state = 202},
  [529] = {.lex_state = 202},
  [530] = {.lex_state = 202},
  [531] = {.lex_state = 387},
  [532] = {.lex_state = 202},
  [533] = {.lex_state = 202},
  [534] = {.lex_state = 202},
  [535] = {.lex_state = 202},
  [536] = {.lex_state = 202},
  [537] = {.lex_state = 202},
  [538] = {.lex_state = 202},
  [539] = {.lex_state = 202},
  [540] = {.lex_state = 202},
  [541] = {.lex_state = 202},
  [542] = {.lex_state = 202},
  [543] = {.lex_state = 202},
  [544] = {.lex_state = 202},
  [545] = {.lex_state = 202},
  [546] = {.lex_state = 202},
  [547] = {.lex_state = 201},
  [548] = {.lex_state = 202},
  [549] = {.lex_state = 202},
  [550] = {.lex_state = 202},
  [551] = {.lex_state = 202},
  [552] = {.lex_state = 202},
  [553] = {.lex_state = 202},
  [554] = {.lex_state = 202},
  [555] = {.lex_state = 387},
  [556] = {.lex_state = 202},
  [557] = {.lex_state = 202},
  [558] = {.lex_state = 202},
  [559] = {.lex_state = 202},
  [560] = {.lex_state = 202},
  [561] = {.lex_state = 202},
  [562] = {.lex_state = 202},
  [563] = {.lex_state = 387},
  [564] = {.lex_state = 202},
  [565] = {.lex_state = 201},
  [566] = {.lex_state = 387},
  [567] = {.lex_state = 202},
  [568] = {.lex_state = 202},
  [569] = {.lex_state = 387},
  [570] = {.lex_state = 201},
  [571] = {.lex_state = 202},
  [572] = {.lex_state = 202},
  [573] = {.lex_state = 202},
  [574] = {.lex_state = 202},
  [575] = {.lex_state = 202},
  [576] = {.lex_state = 202},
  [577] = {.lex_state = 202},
  [578] = {.lex_state = 202},
  [579] = {.lex_state = 202},
  [580] = {.lex_state = 202},
  [581] = {.lex_state = 202},
  [582] = {.lex_state = 202},
  [583] = {.lex_state = 202},
  [584] = {.lex_state = 202},
  [585] = {.lex_state = 202},
  [586] = {.lex_state = 387},
  [587] = {.lex_state = 202},
  [588] = {.lex_state = 202},
  [589] = {.lex_state = 202},
  [590] = {.lex_state = 202},
  [591] = {.lex_state = 201},
  [592] = {.lex_state = 202},
  [593] = {.lex_state = 202},
  [594] = {.lex_state = 202},
  [595] = {.lex_state = 202},
  [596] = {.lex_state = 202},
  [597] = {.lex_state = 202},
  [598] = {.lex_state = 202},
  [599] = {.lex_state = 202},
  [600] = {.lex_state = 387},
  [601] = {.lex_state = 202},
  [602] = {.lex_state = 202},
  [603] = {.lex_state = 202},
  [604] = {.lex_state = 202},
  [605] = {.lex_state = 202},
  [606] = {.lex_state = 202},
  [607] = {.lex_state = 202},
  [608] = {.lex_state = 202},
  [609] = {.lex_state = 202},
  [610] = {.lex_state = 202},
  [611] = {.lex_state = 202},
  [612] = {.lex_state = 202},
  [613] = {.lex_state = 387},
  [614] = {.lex_state = 202},
  [615] = {.lex_state = 202},
  [616] = {.lex_state = 202},
  [617] = {.lex_state = 201},
  [618] = {.lex_state = 202},
  [619] = {.lex_state = 387},
  [620] = {.lex_state = 387},
  [621] = {.lex_state = 387},
  [622] = {.lex_state = 387},
  [623] = {.lex_state = 201},
  [624] = {.lex_state = 201},
  [625] = {.lex_state = 201},
  [626] = {.lex_state = 201},
  [627] = {.lex_state = 201},
  [628] = {.lex_state = 387},
  [629] = {.lex_state = 201},
  [630] = {.lex_state = 201},
  [631] = {.lex_state = 201},
  [632] = {.lex_state = 201},
  [633] = {.lex_state = 201},
  [634] = {.lex_state = 201},
  [635] = {.lex_state = 201},
  [636] = {.lex_state = 201},
  [637] = {.lex_state = 201},
  [638] = {.lex_state = 201},
  [639] = {.lex_state = 201},
  [640] = {.lex_state = 387},
  [641] = {.lex_state = 201},
  [642] = {.lex_state = 201},
  [643] = {.lex_state = 201},
  [644] = {.lex_state = 201},
  [645] = {.lex_state = 201},
  [646] = {.lex_state = 387},
  [647] = {.lex_state = 201},
  [648] = {.lex_state = 201},
  [649] = {.lex_state = 201},
  [650] = {.lex_state = 387},
  [651] = {.lex_state = 201},
  [652] = {.lex_state = 201},
  [653] = {.lex_state = 201},
  [654] = {.lex_state = 201},
  [655] = {.lex_state = 201},
  [656] = {.lex_state = 387},
  [657] = {.lex_state = 387},
  [658] = {.lex_state = 387},
  [659] = {.lex_state = 201},
  [660] = {.lex_state = 387},
  [661] = {.lex_state = 201},
  [662] = {.lex_state = 201},
  [663] = {.lex_state = 387},
  [664] = {.lex_state = 201},
  [665] = {.lex_state = 201},
  [666] = {.lex_state = 387},
  [667] = {.lex_state = 201},
  [668] = {.lex_state = 201},
  [669] = {.lex_state = 201},
  [670] = {.lex_state = 387},
  [671] = {.lex_state = 387},
  [672] = {.lex_state = 387},
  [673] = {.lex_state = 201},
  [674] = {.lex_state = 201},
  [675] = {.lex_state = 387},
  [676] = {.lex_state = 387},
  [677] = {.lex_state = 387},
  [678] = {.lex_state = 201},
  [679] = {.lex_state = 201},
  [680] = {.lex_state = 201},
  [681] = {.lex_state = 387},
  [682] = {.lex_state = 387},
  [683] = {.lex_state = 387},
  [684] = {.lex_state = 387},
  [685] = {.lex_state = 201},
  [686] = {.lex_state = 201},
  [687] = {.lex_state = 387},
  [688] = {.lex_state = 387},
  [689] = {.lex_state = 387},
  [690] = {.lex_state = 201},
  [691] = {.lex_state = 387},
  [692] = {.lex_state = 387},
  [693] = {.lex_state = 201},
  [694] = {.lex_state = 201},
  [695] = {.lex_state = 201},
  [696] = {.lex_state = 387},
  [697] = {.lex_state = 387},
  [698] = {.lex_state = 387},
  [699] = {.lex_state = 387},
  [700] = {.lex_state = 387},
  [701] = {.lex_state = 387},
  [702] = {.lex_state = 387},
  [703] = {.lex_state = 387},
  [704] = {.lex_state = 387},
  [705] = {.lex_state = 201},
  [706] = {.lex_state = 387},
  [707] = {.lex_state = 387},
  [708] = {.lex_state = 387},
  [709] = {.lex_state = 387},
  [710] = {.lex_state = 387},
  [711] = {.lex_state = 387},
  [712] = {.lex_state = 387},
  [713] = {.lex_state = 387},
  [714] = {.lex_state = 387},
  [715] = {.lex_state = 387},
  [716] = {.lex_state = 387},
  [717] = {.lex_state = 387},
  [718] = {.lex_state = 387},
  [719] = {.lex_state = 387},
  [720] = {.lex_state = 387},
  [721] = {.lex_state = 387},
  [722] = {.lex_state = 387},
  [723] = {.lex_state = 387},
  [724] = {.lex_state = 387},
  [725] = {.lex_state = 387},
  [726] = {.lex_state = 387},
  [727] = {.lex_state = 387},
  [728] = {.lex_state = 387},
  [729] = {.lex_state = 387},
  [730] = {.lex_state = 387},
  [731] = {.lex_state = 387},
  [732] = {.lex_state = 387},
  [733] = {.lex_state = 387},
  [734] = {.lex_state = 387},
  [735] = {.lex_state = 387},
  [736] = {.lex_state = 387},
  [737] = {.lex_state = 387},
  [738] = {.lex_state = 387},
  [739] = {.lex_state = 387},
  [740] = {.lex_state = 387},
  [741] = {.lex_state = 387},
  [742] = {.lex_state = 387},
  [743] = {.lex_state = 387},
  [744] = {.lex_state = 387},
  [745] = {.lex_state = 387},
  [746] = {.lex_state = 387},
  [747] = {.lex_state = 387},
  [748] = {.lex_state = 387},
  [749] = {.lex_state = 387},
  [750] = {.lex_state = 387},
  [751] = {.lex_state = 387},
  [752] = {.lex_state = 387},
  [753] = {.lex_state = 387},
  [754] = {.lex_state = 387},
  [755] = {.lex_state = 387},
  [756] = {.lex_state = 387},
  [757] = {.lex_state = 387},
  [758] = {.lex_state = 387},
  [759] = {.lex_state = 387},
  [760] = {.lex_state = 387},
  [761] = {.lex_state = 387},
  [762] = {.lex_state = 387},
  [763] = {.lex_state = 387},
  [764] = {.lex_state = 190},
  [765] = {.lex_state = 387},
  [766] = {.lex_state = 387},
  [767] = {.lex_state = 387},
  [768] = {.lex_state = 201},
  [769] = {.lex_state = 387},
  [770] = {.lex_state = 252},
  [771] = {.lex_state = 252},
  [772] = {.lex_state = 387},
  [773] = {.lex_state = 387},
  [774] = {.lex_state = 387},
  [775] = {.lex_state = 387},
  [776] = {.lex_state = 252},
  [777] = {.lex_state = 387},
  [778] = {.lex_state = 387},
  [779] = {.lex_state = 387},
  [780] = {.lex_state = 387},
  [781] = {.lex_state = 387},
  [782] = {.lex_state = 387},
  [783] = {.lex_state = 201},
  [784] = {.lex_state = 387},
  [785] = {.lex_state = 387},
  [786] = {.lex_state = 387},
  [787] = {.lex_state = 387},
  [788] = {.lex_state = 387},
  [789] = {.lex_state = 387},
  [790] = {.lex_state = 387},
  [791] = {.lex_state = 387},
  [792] = {.lex_state = 201},
  [793] = {.lex_state = 387},
  [794] = {.lex_state = 252},
  [795] = {.lex_state = 387},
  [796] = {.lex_state = 201},
  [797] = {.lex_state = 252},
  [798] = {.lex_state = 387},
  [799] = {.lex_state = 387},
  [800] = {.lex_state = 387},
  [801] = {.lex_state = 201},
  [802] = {.lex_state = 387},
  [803] = {.lex_state = 387},
  [804] = {.lex_state = 387},
  [805] = {.lex_state = 201},
  [806] = {.lex_state = 387},
  [807] = {.lex_state = 387},
  [808] = {.lex_state = 201},
  [809] = {.lex_state = 387},
  [810] = {.lex_state = 387},
  [811] = {.lex_state = 201},
  [812] = {.lex_state = 201},
  [813] = {.lex_state = 201},
  [814] = {.lex_state = 201},
  [815] = {.lex_state = 387},
  [816] = {.lex_state = 387},
  [817] = {.lex_state = 201},
  [818] = {.lex_state = 201},
  [819] = {.lex_state = 201},
  [820] = {.lex_state = 387},
  [821] = {.lex_state = 387},
  [822] = {.lex_state = 387},
  [823] = {.lex_state = 387},
  [824] = {.lex_state = 387},
  [825] = {.lex_state = 252},
  [826] = {.lex_state = 387},
  [827] = {.lex_state = 387},
  [828] = {.lex_state = 387},
  [829] = {.lex_state = 252},
  [830] = {.lex_state = 201},
  [831] = {.lex_state = 252},
  [832] = {.lex_state = 387},
  [833] = {.lex_state = 387},
  [834] = {.lex_state = 387},
  [835] = {.lex_state = 387},
  [836] = {.lex_state = 387},
  [837] = {.lex_state = 252},
  [838] = {.lex_state = 387},
  [839] = {.lex_state = 387},
  [840] = {.lex_state = 387},
  [841] = {.lex_state = 387},
  [842] = {.lex_state = 387},
  [843] = {.lex_state = 252},
  [844] = {.lex_state = 201},
  [845] = {.lex_state = 201},
  [846] = {.lex_state = 252},
  [847] = {.lex_state = 201},
  [848] = {.lex_state = 282},
  [849] = {.lex_state = 252},
  [850] = {.lex_state = 201},
  [851] = {.lex_state = 387},
  [852] = {.lex_state = 387},
  [853] = {.lex_state = 201},
  [854] = {.lex_state = 201},
  [855] = {.lex_state = 201},
  [856] = {.lex_state = 201},
  [857] = {.lex_state = 387},
  [858] = {.lex_state = 201},
  [859] = {.lex_state = 387},
  [860] = {.lex_state = 201},
  [861] = {.lex_state = 387},
  [862] = {.lex_state = 201},
  [863] = {.lex_state = 201},
  [864] = {.lex_state = 201},
  [865] = {.lex_state = 201},
  [866] = {.lex_state = 387},
  [867] = {.lex_state = 201},
  [868] = {.lex_state = 201},
  [869] = {.lex_state = 201},
  [870] = {.lex_state = 387},
  [871] = {.lex_state = 201},
  [872] = {.lex_state = 201},
  [873] = {.lex_state = 387},
  [874] = {.lex_state = 201},
  [875] = {.lex_state = 201},
  [876] = {.lex_state = 387},
  [877] = {.lex_state = 201},
  [878] = {.lex_state = 201},
  [879] = {.lex_state = 387},
  [880] = {.lex_state = 201},
  [881] = {.lex_state = 201},
  [882] = {.lex_state = 201},
  [883] = {.lex_state = 387},
  [884] = {.lex_state = 387},
  [885] = {.lex_state = 387},
  [886] = {.lex_state = 387},
  [887] = {.lex_state = 387},
  [888] = {.lex_state = 387},
  [889] = {.lex_state = 387},
  [890] = {.lex_state = 387},
  [891] = {.lex_state = 387},
  [892] = {.lex_state = 387},
  [893] = {.lex_state = 387},
  [894] = {.lex_state = 201},
  [895] = {.lex_state = 201},
  [896] = {.lex_state = 201},
  [897] = {.lex_state = 387},
  [898] = {.lex_state = 387},
  [899] = {.lex_state = 387},
  [900] = {.lex_state = 387},
  [901] = {.lex_state = 387},
  [902] = {.lex_state = 201},
  [903] = {.lex_state = 387},
  [904] = {.lex_state = 387},
  [905] = {.lex_state = 387},
  [906] = {.lex_state = 201},
  [907] = {.lex_state = 201},
  [908] = {.lex_state = 201},
  [909] = {.lex_state = 201},
  [910] = {.lex_state = 387},
  [911] = {.lex_state = 387},
  [912] = {.lex_state = 387},
  [913] = {.lex_state = 201},
  [914] = {.lex_state = 387},
  [915] = {.lex_state = 201},
  [916] = {.lex_state = 201},
  [917] = {.lex_state = 387},
  [918] = {.lex_state = 387},
  [919] = {.lex_state = 387},
  [920] = {.lex_state = 387},
  [921] = {.lex_state = 387},
  [922] = {.lex_state = 201},
  [923] = {.lex_state = 201},
  [924] = {.lex_state = 387},
  [925] = {.lex_state = 387},
  [926] = {.lex_state = 387},
  [927] = {.lex_state = 387},
  [928] = {.lex_state = 201},
  [929] = {.lex_state = 201},
  [930] = {.lex_state = 387},
  [931] = {.lex_state = 387},
  [932] = {.lex_state = 201},
  [933] = {.lex_state = 201},
  [934] = {.lex_state = 201},
  [935] = {.lex_state = 387},
  [936] = {.lex_state = 387},
  [937] = {.lex_state = 201},
  [938] = {.lex_state = 201},
  [939] = {.lex_state = 387},
  [940] = {.lex_state = 387},
  [941] = {.lex_state = 201},
  [942] = {.lex_state = 201},
  [943] = {.lex_state = 201},
  [944] = {.lex_state = 387},
  [945] = {.lex_state = 387},
  [946] = {.lex_state = 387},
  [947] = {.lex_state = 201},
  [948] = {.lex_state = 387},
  [949] = {.lex_state = 201},
  [950] = {.lex_state = 387},
  [951] = {.lex_state = 387},
  [952] = {.lex_state = 387},
  [953] = {.lex_state = 387},
  [954] = {.lex_state = 201},
  [955] = {.lex_state = 387},
  [956] = {.lex_state = 387},
  [957] = {.lex_state = 387},
  [958] = {.lex_state = 387},
  [959] = {.lex_state = 201},
  [960] = {.lex_state = 201},
  [961] = {.lex_state = 387},
  [962] = {.lex_state = 387},
  [963] = {.lex_state = 201},
  [964] = {.lex_state = 201},
  [965] = {.lex_state = 201},
  [966] = {.lex_state = 387},
  [967] = {.lex_state = 387},
  [968] = {.lex_state = 387},
  [969] = {.lex_state = 201},
  [970] = {.lex_state = 387},
  [971] = {.lex_state = 201},
  [972] = {.lex_state = 387},
  [973] = {.lex_state = 387},
  [974] = {.lex_state = 387},
  [975] = {.lex_state = 201},
  [976] = {.lex_state = 201},
  [977] = {.lex_state = 387},
  [978] = {.lex_state = 387},
  [979] = {.lex_state = 387},
  [980] = {.lex_state = 201},
  [981] = {.lex_state = 201},
  [982] = {.lex_state = 201},
  [983] = {.lex_state = 201},
  [984] = {.lex_state = 387},
  [985] = {.lex_state = 201},
  [986] = {.lex_state = 201},
  [987] = {.lex_state = 201},
  [988] = {.lex_state = 201},
  [989] = {.lex_state = 201},
  [990] = {.lex_state = 201},
  [991] = {.lex_state = 201},
  [992] = {.lex_state = 201},
  [993] = {.lex_state = 201},
  [994] = {.lex_state = 201},
  [995] = {.lex_state = 201},
  [996] = {.lex_state = 201},
  [997] = {.lex_state = 201},
  [998] = {.lex_state = 387},
  [999] = {.lex_state = 387},
  [1000] = {.lex_state = 190},
  [1001] = {.lex_state = 192},
  [1002] = {.lex_state = 252},
  [1003] = {.lex_state = 387},
  [1004] = {.lex_state = 387},
  [1005] = {.lex_state = 387},
  [1006] = {.lex_state = 190},
  [1007] = {.lex_state = 387},
  [1008] = {.lex_state = 387},
  [1009] = {.lex_state = 387},
  [1010] = {.lex_state = 280},
  [1011] = {.lex_state = 387},
  [1012] = {.lex_state = 280},
  [1013] = {.lex_state = 387},
  [1014] = {.lex_state = 280},
  [1015] = {.lex_state = 387},
  [1016] = {.lex_state = 387},
  [1017] = {.lex_state = 387},
  [1018] = {.lex_state = 280},
  [1019] = {.lex_state = 280},
  [1020] = {.lex_state = 280},
  [1021] = {.lex_state = 280},
  [1022] = {.lex_state = 280},
  [1023] = {.lex_state = 387},
  [1024] = {.lex_state = 280},
  [1025] = {.lex_state = 387},
  [1026] = {.lex_state = 387},
  [1027] = {.lex_state = 387},
  [1028] = {.lex_state = 387},
  [1029] = {.lex_state = 280},
  [1030] = {.lex_state = 387},
  [1031] = {.lex_state = 190},
  [1032] = {.lex_state = 387},
  [1033] = {.lex_state = 387},
  [1034] = {.lex_state = 387},
  [1035] = {.lex_state = 387},
  [1036] = {.lex_state = 280},
  [1037] = {.lex_state = 283},
  [1038] = {.lex_state = 387},
  [1039] = {.lex_state = 387},
  [1040] = {.lex_state = 387},
  [1041] = {.lex_state = 387},
  [1042] = {.lex_state = 387},
  [1043] = {.lex_state = 387},
  [1044] = {.lex_state = 280},
  [1045] = {.lex_state = 280},
  [1046] = {.lex_state = 283},
  [1047] = {.lex_state = 280},
  [1048] = {.lex_state = 283},
  [1049] = {.lex_state = 387},
  [1050] = {.lex_state = 280},
  [1051] = {.lex_state = 280},
  [1052] = {.lex_state = 387},
  [1053] = {.lex_state = 387},
  [1054] = {.lex_state = 280},
  [1055] = {.lex_state = 387},
  [1056] = {.lex_state = 280},
  [1057] = {.lex_state = 387},
  [1058] = {.lex_state = 387},
  [1059] = {.lex_state = 387},
  [1060] = {.lex_state = 280},
  [1061] = {.lex_state = 387},
  [1062] = {.lex_state = 387},
  [1063] = {.lex_state = 387},
  [1064] = {.lex_state = 387},
  [1065] = {.lex_state = 387},
  [1066] = {.lex_state = 280},
  [1067] = {.lex_state = 387},
  [1068] = {.lex_state = 387},
  [1069] = {.lex_state = 387},
  [1070] = {.lex_state = 387},
  [1071] = {.lex_state = 387},
  [1072] = {.lex_state = 387},
  [1073] = {.lex_state = 387},
  [1074] = {.lex_state = 387},
  [1075] = {.lex_state = 387},
  [1076] = {.lex_state = 280},
  [1077] = {.lex_state = 387},
  [1078] = {.lex_state = 190},
  [1079] = {.lex_state = 387},
  [1080] = {.lex_state = 387},
  [1081] = {.lex_state = 387},
  [1082] = {.lex_state = 387},
  [1083] = {.lex_state = 280},
  [1084] = {.lex_state = 195},
  [1085] = {.lex_state = 387},
  [1086] = {.lex_state = 387},
  [1087] = {.lex_state = 387},
  [1088] = {.lex_state = 387},
  [1089] = {.lex_state = 387},
  [1090] = {.lex_state = 387},
  [1091] = {.lex_state = 387},
  [1092] = {.lex_state = 387},
  [1093] = {.lex_state = 387},
  [1094] = {.lex_state = 280},
  [1095] = {.lex_state = 280},
  [1096] = {.lex_state = 280},
  [1097] = {.lex_state = 387},
  [1098] = {.lex_state = 387},
  [1099] = {.lex_state = 387},
  [1100] = {.lex_state = 387},
  [1101] = {.lex_state = 387},
  [1102] = {.lex_state = 387},
  [1103] = {.lex_state = 190},
  [1104] = {.lex_state = 196},
  [1105] = {.lex_state = 196},
  [1106] = {.lex_state = 282},
  [1107] = {.lex_state = 282},
  [1108] = {.lex_state = 282},
  [1109] = {.lex_state = 282},
  [1110] = {.lex_state = 282},
  [1111] = {.lex_state = 282},
  [1112] = {.lex_state = 282},
  [1113] = {.lex_state = 282},
  [1114] = {.lex_state = 282},
  [1115] = {.lex_state = 387},
  [1116] = {.lex_state = 387},
  [1117] = {.lex_state = 282},
  [1118] = {.lex_state = 282},
  [1119] = {.lex_state = 282},
  [1120] = {.lex_state = 282},
  [1121] = {.lex_state = 282},
  [1122] = {.lex_state = 282},
  [1123] = {.lex_state = 282},
  [1124] = {.lex_state = 282},
  [1125] = {.lex_state = 282},
  [1126] = {.lex_state = 204},
  [1127] = {.lex_state = 204},
  [1128] = {.lex_state = 204},
  [1129] = {.lex_state = 204},
  [1130] = {.lex_state = 204},
  [1131] = {.lex_state = 204},
  [1132] = {.lex_state = 204},
  [1133] = {.lex_state = 204},
  [1134] = {.lex_state = 204},
  [1135] = {.lex_state = 204},
  [1136] = {.lex_state = 204},
  [1137] = {.lex_state = 204},
  [1138] = {.lex_state = 204},
  [1139] = {.lex_state = 204},
  [1140] = {.lex_state = 204},
  [1141] = {.lex_state = 204},
  [1142] = {.lex_state = 204},
  [1143] = {.lex_state = 204},
  [1144] = {.lex_state = 204},
  [1145] = {.lex_state = 204},
  [1146] = {.lex_state = 204},
  [1147] = {.lex_state = 204},
  [1148] = {.lex_state = 204},
  [1149] = {.lex_state = 387},
  [1150] = {.lex_state = 203},
  [1151] = {.lex_state = 200},
  [1152] = {.lex_state = 203},
  [1153] = {.lex_state = 200},
  [1154] = {.lex_state = 200},
  [1155] = {.lex_state = 222},
  [1156] = {.lex_state = 200},
  [1157] = {.lex_state = 200},
  [1158] = {.lex_state = 200},
  [1159] = {.lex_state = 200},
  [1160] = {.lex_state = 200},
  [1161] = {.lex_state = 200},
  [1162] = {.lex_state = 200},
  [1163] = {.lex_state = 200},
  [1164] = {.lex_state = 200},
  [1165] = {.lex_state = 222},
  [1166] = {.lex_state = 200},
  [1167] = {.lex_state = 200},
  [1168] = {.lex_state = 200},
  [1169] = {.lex_state = 200},
  [1170] = {.lex_state = 200},
  [1171] = {.lex_state = 200},
  [1172] = {.lex_state = 200},
  [1173] = {.lex_state = 200},
  [1174] = {.lex_state = 200},
  [1175] = {.lex_state = 200},
  [1176] = {.lex_state = 200},
  [1177] = {.lex_state = 200},
  [1178] = {.lex_state = 200},
  [1179] = {.lex_state = 200},
  [1180] = {.lex_state = 200},
  [1181] = {.lex_state = 200},
  [1182] = {.lex_state = 200},
  [1183] = {.lex_state = 200},
  [1184] = {.lex_state = 200},
  [1185] = {.lex_state = 200},
  [1186] = {.lex_state = 200},
  [1187] = {.lex_state = 200},
  [1188] = {.lex_state = 200},
  [1189] = {.lex_state = 200},
  [1190] = {.lex_state = 200},
  [1191] = {.lex_state = 200},
  [1192] = {.lex_state = 200},
  [1193] = {.lex_state = 200},
  [1194] = {.lex_state = 200},
  [1195] = {.lex_state = 200},
  [1196] = {.lex_state = 200},
  [1197] = {.lex_state = 200},
  [1198] = {.lex_state = 200},
  [1199] = {.lex_state = 200},
  [1200] = {.lex_state = 200},
  [1201] = {.lex_state = 200},
  [1202] = {.lex_state = 200},
  [1203] = {.lex_state = 200},
  [1204] = {.lex_state = 200},
  [1205] = {.lex_state = 200},
  [1206] = {.lex_state = 200},
  [1207] = {.lex_state = 200},
  [1208] = {.lex_state = 200},
  [1209] = {.lex_state = 222},
  [1210] = {.lex_state = 200},
  [1211] = {.lex_state = 200},
  [1212] = {.lex_state = 200},
  [1213] = {.lex_state = 200},
  [1214] = {.lex_state = 200},
  [1215] = {.lex_state = 200},
  [1216] = {.lex_state = 200},
  [1217] = {.lex_state = 200},
  [1218] = {.lex_state = 200},
  [1219] = {.lex_state = 200},
  [1220] = {.lex_state = 200},
  [1221] = {.lex_state = 200},
  [1222] = {.lex_state = 200},
  [1223] = {.lex_state = 200},
  [1224] = {.lex_state = 200},
  [1225] = {.lex_state = 222},
  [1226] = {.lex_state = 200},
  [1227] = {.lex_state = 200},
  [1228] = {.lex_state = 200},
  [1229] = {.lex_state = 282},
  [1230] = {.lex_state = 200},
  [1231] = {.lex_state = 200},
  [1232] = {.lex_state = 200},
  [1233] = {.lex_state = 200},
  [1234] = {.lex_state = 200},
  [1235] = {.lex_state = 200},
  [1236] = {.lex_state = 200},
  [1237] = {.lex_state = 200},
  [1238] = {.lex_state = 200},
  [1239] = {.lex_state = 200},
  [1240] = {.lex_state = 222},
  [1241] = {.lex_state = 200},
  [1242] = {.lex_state = 200},
  [1243] = {.lex_state = 200},
  [1244] = {.lex_state = 222},
  [1245] = {.lex_state = 204},
  [1246] = {.lex_state = 204},
  [1247] = {.lex_state = 204},
  [1248] = {.lex_state = 204},
  [1249] = {.lex_state = 204},
  [1250] = {.lex_state = 204},
  [1251] = {.lex_state = 204},
  [1252] = {.lex_state = 204},
  [1253] = {.lex_state = 204},
  [1254] = {.lex_state = 204},
  [1255] = {.lex_state = 204},
  [1256] = {.lex_state = 204},
  [1257] = {.lex_state = 204},
  [1258] = {.lex_state = 204},
  [1259] = {.lex_state = 204},
  [1260] = {.lex_state = 204},
  [1261] = {.lex_state = 204},
  [1262] = {.lex_state = 204},
  [1263] = {.lex_state = 204},
  [1264] = {.lex_state = 204},
  [1265] = {.lex_state = 204},
  [1266] = {.lex_state = 204},
  [1267] = {.lex_state = 204},
  [1268] = {.lex_state = 204},
  [1269] = {.lex_state = 204},
  [1270] = {.lex_state = 204},
  [1271] = {.lex_state = 204},
  [1272] = {.lex_state = 204},
  [1273] = {.lex_state = 204},
  [1274] = {.lex_state = 204},
  [1275] = {.lex_state = 204},
  [1276] = {.lex_state = 204},
  [1277] = {.lex_state = 204},
  [1278] = {.lex_state = 204},
  [1279] = {.lex_state = 204},
  [1280] = {.lex_state = 204},
  [1281] = {.lex_state = 204},
  [1282] = {.lex_state = 204},
  [1283] = {.lex_state = 204},
  [1284] = {.lex_state = 204},
  [1285] = {.lex_state = 204},
  [1286] = {.lex_state = 204},
  [1287] = {.lex_state = 204},
  [1288] = {.lex_state = 204},
  [1289] = {.lex_state = 204},
  [1290] = {.lex_state = 204},
  [1291] = {.lex_state = 204},
  [1292] = {.lex_state = 204},
  [1293] = {.lex_state = 204},
  [1294] = {.lex_state = 219},
  [1295] = {.lex_state = 222},
  [1296] = {.lex_state = 222},
  [1297] = {.lex_state = 222},
  [1298] = {.lex_state = 204},
  [1299] = {.lex_state = 204},
  [1300] = {.lex_state = 204},
  [1301] = {.lex_state = 222},
  [1302] = {.lex_state = 204},
  [1303] = {.lex_state = 204},
  [1304] = {.lex_state = 222},
  [1305] = {.lex_state = 204},
  [1306] = {.lex_state = 204},
  [1307] = {.lex_state = 204},
  [1308] = {.lex_state = 204},
  [1309] = {.lex_state = 222},
  [1310] = {.lex_state = 222},
  [1311] = {.lex_state = 204},
  [1312] = {.lex_state = 204},
  [1313] = {.lex_state = 204},
  [1314] = {.lex_state = 204},
  [1315] = {.lex_state = 204},
  [1316] = {.lex_state = 204},
  [1317] = {.lex_state = 204},
  [1318] = {.lex_state = 204},
  [1319] = {.lex_state = 204},
  [1320] = {.lex_state = 204},
  [1321] = {.lex_state = 204},
  [1322] = {.lex_state = 204},
  [1323] = {.lex_state = 204},
  [1324] = {.lex_state = 204},
  [1325] = {.lex_state = 204},
  [1326] = {.lex_state = 222},
  [1327] = {.lex_state = 204},
  [1328] = {.lex_state = 204},
  [1329] = {.lex_state = 204},
  [1330] = {.lex_state = 203},
  [1331] = {.lex_state = 203},
  [1332] = {.lex_state = 204},
  [1333] = {.lex_state = 204},
  [1334] = {.lex_state = 203},
  [1335] = {.lex_state = 203},
  [1336] = {.lex_state = 204},
  [1337] = {.lex_state = 204},
  [1338] = {.lex_state = 204},
  [1339] = {.lex_state = 203},
  [1340] = {.lex_state = 203},
  [1341] = {.lex_state = 204},
  [1342] = {.lex_state = 204},
  [1343] = {.lex_state = 203},
  [1344] = {.lex_state = 203},
  [1345] = {.lex_state = 204},
  [1346] = {.lex_state = 204},
  [1347] = {.lex_state = 204},
  [1348] = {.lex_state = 203},
  [1349] = {.lex_state = 203},
  [1350] = {.lex_state = 204},
  [1351] = {.lex_state = 203},
  [1352] = {.lex_state = 203},
  [1353] = {.lex_state = 203},
  [1354] = {.lex_state = 204},
  [1355] = {.lex_state = 204},
  [1356] = {.lex_state = 204},
  [1357] = {.lex_state = 203},
  [1358] = {.lex_state = 204},
  [1359] = {.lex_state = 204},
  [1360] = {.lex_state = 204},
  [1361] = {.lex_state = 204},
  [1362] = {.lex_state = 204},
  [1363] = {.lex_state = 204},
  [1364] = {.lex_state = 204},
  [1365] = {.lex_state = 204},
  [1366] = {.lex_state = 204},
  [1367] = {.lex_state = 204},
  [1368] = {.lex_state = 204},
  [1369] = {.lex_state = 204},
  [1370] = {.lex_state = 203},
  [1371] = {.lex_state = 204},
  [1372] = {.lex_state = 203},
  [1373] = {.lex_state = 204},
  [1374] = {.lex_state = 204},
  [1375] = {.lex_state = 204},
  [1376] = {.lex_state = 204},
  [1377] = {.lex_state = 204},
  [1378] = {.lex_state = 204},
  [1379] = {.lex_state = 204},
  [1380] = {.lex_state = 203},
  [1381] = {.lex_state = 204},
  [1382] = {.lex_state = 203},
  [1383] = {.lex_state = 204},
  [1384] = {.lex_state = 204},
  [1385] = {.lex_state = 203},
  [1386] = {.lex_state = 204},
  [1387] = {.lex_state = 204},
  [1388] = {.lex_state = 204},
  [1389] = {.lex_state = 204},
  [1390] = {.lex_state = 204},
  [1391] = {.lex_state = 203},
  [1392] = {.lex_state = 203},
  [1393] = {.lex_state = 204},
  [1394] = {.lex_state = 204},
  [1395] = {.lex_state = 204},
  [1396] = {.lex_state = 203},
  [1397] = {.lex_state = 204},
  [1398] = {.lex_state = 203},
  [1399] = {.lex_state = 204},
  [1400] = {.lex_state = 203},
  [1401] = {.lex_state = 203},
  [1402] = {.lex_state = 203},
  [1403] = {.lex_state = 204},
  [1404] = {.lex_state = 204},
  [1405] = {.lex_state = 203},
  [1406] = {.lex_state = 203},
  [1407] = {.lex_state = 204},
  [1408] = {.lex_state = 204},
  [1409] = {.lex_state = 204},
  [1410] = {.lex_state = 203},
  [1411] = {.lex_state = 203},
  [1412] = {.lex_state = 204},
  [1413] = {.lex_state = 204},
  [1414] = {.lex_state = 204},
  [1415] = {.lex_state = 204},
  [1416] = {.lex_state = 204},
  [1417] = {.lex_state = 204},
  [1418] = {.lex_state = 204},
  [1419] = {.lex_state = 204},
  [1420] = {.lex_state = 204},
  [1421] = {.lex_state = 204},
  [1422] = {.lex_state = 204},
  [1423] = {.lex_state = 204},
  [1424] = {.lex_state = 204},
  [1425] = {.lex_state = 204},
  [1426] = {.lex_state = 204},
  [1427] = {.lex_state = 204},
  [1428] = {.lex_state = 204},
  [1429] = {.lex_state = 204},
  [1430] = {.lex_state = 204},
  [1431] = {.lex_state = 204},
  [1432] = {.lex_state = 204},
  [1433] = {.lex_state = 204},
  [1434] = {.lex_state = 204},
  [1435] = {.lex_state = 204},
  [1436] = {.lex_state = 204},
  [1437] = {.lex_state = 204},
  [1438] = {.lex_state = 204},
  [1439] = {.lex_state = 204},
  [1440] = {.lex_state = 204},
  [1441] = {.lex_state = 204},
  [1442] = {.lex_state = 204},
  [1443] = {.lex_state = 204},
  [1444] = {.lex_state = 204},
  [1445] = {.lex_state = 204},
  [1446] = {.lex_state = 204},
  [1447] = {.lex_state = 204},
  [1448] = {.lex_state = 204},
  [1449] = {.lex_state = 204},
  [1450] = {.lex_state = 204},
  [1451] = {.lex_state = 204},
  [1452] = {.lex_state = 204},
  [1453] = {.lex_state = 204},
  [1454] = {.lex_state = 204},
  [1455] = {.lex_state = 204},
  [1456] = {.lex_state = 204},
  [1457] = {.lex_state = 204},
  [1458] = {.lex_state = 204},
  [1459] = {.lex_state = 204},
  [1460] = {.lex_state = 204},
  [1461] = {.lex_state = 204},
  [1462] = {.lex_state = 204},
  [1463] = {.lex_state = 204},
  [1464] = {.lex_state = 204},
  [1465] = {.lex_state = 204},
  [1466] = {.lex_state = 204},
  [1467] = {.lex_state = 204},
  [1468] = {.lex_state = 204},
  [1469] = {.lex_state = 204},
  [1470] = {.lex_state = 204},
  [1471] = {.lex_state = 204},
  [1472] = {.lex_state = 204},
  [1473] = {.lex_state = 204},
  [1474] = {.lex_state = 204},
  [1475] = {.lex_state = 204},
  [1476] = {.lex_state = 204},
  [1477] = {.lex_state = 204},
  [1478] = {.lex_state = 204},
  [1479] = {.lex_state = 204},
  [1480] = {.lex_state = 204},
  [1481] = {.lex_state = 204},
  [1482] = {.lex_state = 204},
  [1483] = {.lex_state = 204},
  [1484] = {.lex_state = 204},
  [1485] = {.lex_state = 204},
  [1486] = {.lex_state = 204},
  [1487] = {.lex_state = 204},
  [1488] = {.lex_state = 204},
  [1489] = {.lex_state = 204},
  [1490] = {.lex_state = 204},
  [1491] = {.lex_state = 204},
  [1492] = {.lex_state = 204},
  [1493] = {.lex_state = 204},
  [1494] = {.lex_state = 204},
  [1495] = {.lex_state = 204},
  [1496] = {.lex_state = 204},
  [1497] = {.lex_state = 204},
  [1498] = {.lex_state = 204},
  [1499] = {.lex_state = 204},
  [1500] = {.lex_state = 204},
  [1501] = {.lex_state = 204},
  [1502] = {.lex_state = 204},
  [1503] = {.lex_state = 204},
  [1504] = {.lex_state = 204},
  [1505] = {.lex_state = 204},
  [1506] = {.lex_state = 204},
  [1507] = {.lex_state = 204},
  [1508] = {.lex_state = 204},
  [1509] = {.lex_state = 204},
  [1510] = {.lex_state = 204},
  [1511] = {.lex_state = 204},
  [1512] = {.lex_state = 204},
  [1513] = {.lex_state = 204},
  [1514] = {.lex_state = 204},
  [1515] = {.lex_state = 204},
  [1516] = {.lex_state = 204},
  [1517] = {.lex_state = 204},
  [1518] = {.lex_state = 204},
  [1519] = {.lex_state = 204},
  [1520] = {.lex_state = 204},
  [1521] = {.lex_state = 204},
  [1522] = {.lex_state = 204},
  [1523] = {.lex_state = 204},
  [1524] = {.lex_state = 204},
  [1525] = {.lex_state = 204},
  [1526] = {.lex_state = 204},
  [1527] = {.lex_state = 204},
  [1528] = {.lex_state = 204},
  [1529] = {.lex_state = 204},
  [1530] = {.lex_state = 204},
  [1531] = {.lex_state = 204},
  [1532] = {.lex_state = 204},
  [1533] = {.lex_state = 204},
  [1534] = {.lex_state = 204},
  [1535] = {.lex_state = 204},
  [1536] = {.lex_state = 204},
  [1537] = {.lex_state = 204},
  [1538] = {.lex_state = 204},
  [1539] = {.lex_state = 204},
  [1540] = {.lex_state = 204},
  [1541] = {.lex_state = 204},
  [1542] = {.lex_state = 204},
  [1543] = {.lex_state = 204},
  [1544] = {.lex_state = 204},
  [1545] = {.lex_state = 204},
  [1546] = {.lex_state = 204},
  [1547] = {.lex_state = 204},
  [1548] = {.lex_state = 204},
  [1549] = {.lex_state = 204},
  [1550] = {.lex_state = 204},
  [1551] = {.lex_state = 204},
  [1552] = {.lex_state = 204},
  [1553] = {.lex_state = 204},
  [1554] = {.lex_state = 204},
  [1555] = {.lex_state = 204},
  [1556] = {.lex_state = 204},
  [1557] = {.lex_state = 204},
  [1558] = {.lex_state = 204},
  [1559] = {.lex_state = 204},
  [1560] = {.lex_state = 204},
  [1561] = {.lex_state = 204},
  [1562] = {.lex_state = 204},
  [1563] = {.lex_state = 204},
  [1564] = {.lex_state = 204},
  [1565] = {.lex_state = 204},
  [1566] = {.lex_state = 204},
  [1567] = {.lex_state = 204},
  [1568] = {.lex_state = 204},
  [1569] = {.lex_state = 204},
  [1570] = {.lex_state = 204},
  [1571] = {.lex_state = 204},
  [1572] = {.lex_state = 204},
  [1573] = {.lex_state = 204},
  [1574] = {.lex_state = 204},
  [1575] = {.lex_state = 204},
  [1576] = {.lex_state = 204},
  [1577] = {.lex_state = 204},
  [1578] = {.lex_state = 204},
  [1579] = {.lex_state = 204},
  [1580] = {.lex_state = 204},
  [1581] = {.lex_state = 204},
  [1582] = {.lex_state = 204},
  [1583] = {.lex_state = 204},
  [1584] = {.lex_state = 204},
  [1585] = {.lex_state = 204},
  [1586] = {.lex_state = 204},
  [1587] = {.lex_state = 204},
  [1588] = {.lex_state = 204},
  [1589] = {.lex_state = 204},
  [1590] = {.lex_state = 204},
  [1591] = {.lex_state = 204},
  [1592] = {.lex_state = 204},
  [1593] = {.lex_state = 204},
  [1594] = {.lex_state = 204},
  [1595] = {.lex_state = 204},
  [1596] = {.lex_state = 204},
  [1597] = {.lex_state = 204},
  [1598] = {.lex_state = 204},
  [1599] = {.lex_state = 204},
  [1600] = {.lex_state = 204},
  [1601] = {.lex_state = 204},
  [1602] = {.lex_state = 204},
  [1603] = {.lex_state = 204},
  [1604] = {.lex_state = 204},
  [1605] = {.lex_state = 204},
  [1606] = {.lex_state = 204},
  [1607] = {.lex_state = 204},
  [1608] = {.lex_state = 204},
  [1609] = {.lex_state = 204},
  [1610] = {.lex_state = 204},
  [1611] = {.lex_state = 204},
  [1612] = {.lex_state = 204},
  [1613] = {.lex_state = 204},
  [1614] = {.lex_state = 204},
  [1615] = {.lex_state = 204},
  [1616] = {.lex_state = 204},
  [1617] = {.lex_state = 204},
  [1618] = {.lex_state = 204},
  [1619] = {.lex_state = 204},
  [1620] = {.lex_state = 204},
  [1621] = {.lex_state = 204},
  [1622] = {.lex_state = 204},
  [1623] = {.lex_state = 204},
  [1624] = {.lex_state = 204},
  [1625] = {.lex_state = 204},
  [1626] = {.lex_state = 204},
  [1627] = {.lex_state = 204},
  [1628] = {.lex_state = 204},
  [1629] = {.lex_state = 204},
  [1630] = {.lex_state = 204},
  [1631] = {.lex_state = 204},
  [1632] = {.lex_state = 204},
  [1633] = {.lex_state = 204},
  [1634] = {.lex_state = 204},
  [1635] = {.lex_state = 204},
  [1636] = {.lex_state = 204},
  [1637] = {.lex_state = 204},
  [1638] = {.lex_state = 204},
  [1639] = {.lex_state = 204},
  [1640] = {.lex_state = 204},
  [1641] = {.lex_state = 204},
  [1642] = {.lex_state = 204},
  [1643] = {.lex_state = 204},
  [1644] = {.lex_state = 204},
  [1645] = {.lex_state = 204},
  [1646] = {.lex_state = 204},
  [1647] = {.lex_state = 204},
  [1648] = {.lex_state = 204},
  [1649] = {.lex_state = 204},
  [1650] = {.lex_state = 204},
  [1651] = {.lex_state = 204},
  [1652] = {.lex_state = 204},
  [1653] = {.lex_state = 204},
  [1654] = {.lex_state = 204},
  [1655] = {.lex_state = 204},
  [1656] = {.lex_state = 204},
  [1657] = {.lex_state = 204},
  [1658] = {.lex_state = 204},
  [1659] = {.lex_state = 204},
  [1660] = {.lex_state = 204},
  [1661] = {.lex_state = 204},
  [1662] = {.lex_state = 204},
  [1663] = {.lex_state = 204},
  [1664] = {.lex_state = 204},
  [1665] = {.lex_state = 204},
  [1666] = {.lex_state = 204},
  [1667] = {.lex_state = 204},
  [1668] = {.lex_state = 204},
  [1669] = {.lex_state = 204},
  [1670] = {.lex_state = 204},
  [1671] = {.lex_state = 204},
  [1672] = {.lex_state = 204},
  [1673] = {.lex_state = 204},
  [1674] = {.lex_state = 204},
  [1675] = {.lex_state = 204},
  [1676] = {.lex_state = 204},
  [1677] = {.lex_state = 204},
  [1678] = {.lex_state = 204},
  [1679] = {.lex_state = 204},
  [1680] = {.lex_state = 204},
  [1681] = {.lex_state = 204},
  [1682] = {.lex_state = 204},
  [1683] = {.lex_state = 204},
  [1684] = {.lex_state = 204},
  [1685] = {.lex_state = 204},
  [1686] = {.lex_state = 204},
  [1687] = {.lex_state = 204},
  [1688] = {.lex_state = 204},
  [1689] = {.lex_state = 204},
  [1690] = {.lex_state = 204},
  [1691] = {.lex_state = 204},
  [1692] = {.lex_state = 204},
  [1693] = {.lex_state = 204},
  [1694] = {.lex_state = 204},
  [1695] = {.lex_state = 204},
  [1696] = {.lex_state = 204},
  [1697] = {.lex_state = 204},
  [1698] = {.lex_state = 204},
  [1699] = {.lex_state = 204},
  [1700] = {.lex_state = 204},
  [1701] = {.lex_state = 204},
  [1702] = {.lex_state = 204},
  [1703] = {.lex_state = 204},
  [1704] = {.lex_state = 204},
  [1705] = {.lex_state = 204},
  [1706] = {.lex_state = 204},
  [1707] = {.lex_state = 204},
  [1708] = {.lex_state = 204},
  [1709] = {.lex_state = 204},
  [1710] = {.lex_state = 204},
  [1711] = {.lex_state = 204},
  [1712] = {.lex_state = 204},
  [1713] = {.lex_state = 204},
  [1714] = {.lex_state = 204},
  [1715] = {.lex_state = 204},
  [1716] = {.lex_state = 204},
  [1717] = {.lex_state = 204},
  [1718] = {.lex_state = 204},
  [1719] = {.lex_state = 204},
  [1720] = {.lex_state = 204},
  [1721] = {.lex_state = 204},
  [1722] = {.lex_state = 204},
  [1723] = {.lex_state = 204},
  [1724] = {.lex_state = 204},
  [1725] = {.lex_state = 204},
  [1726] = {.lex_state = 204},
  [1727] = {.lex_state = 204},
  [1728] = {.lex_state = 204},
  [1729] = {.lex_state = 204},
  [1730] = {.lex_state = 204},
  [1731] = {.lex_state = 204},
  [1732] = {.lex_state = 204},
  [1733] = {.lex_state = 204},
  [1734] = {.lex_state = 204},
  [1735] = {.lex_state = 204},
  [1736] = {.lex_state = 204},
  [1737] = {.lex_state = 204},
  [1738] = {.lex_state = 204},
  [1739] = {.lex_state = 204},
  [1740] = {.lex_state = 204},
  [1741] = {.lex_state = 204},
  [1742] = {.lex_state = 204},
  [1743] = {.lex_state = 204},
  [1744] = {.lex_state = 204},
  [1745] = {.lex_state = 204},
  [1746] = {.lex_state = 204},
  [1747] = {.lex_state = 204},
  [1748] = {.lex_state = 204},
  [1749] = {.lex_state = 204},
  [1750] = {.lex_state = 204},
  [1751] = {.lex_state = 204},
  [1752] = {.lex_state = 204},
  [1753] = {.lex_state = 204},
  [1754] = {.lex_state = 204},
  [1755] = {.lex_state = 204},
  [1756] = {.lex_state = 204},
  [1757] = {.lex_state = 204},
  [1758] = {.lex_state = 204},
  [1759] = {.lex_state = 204},
  [1760] = {.lex_state = 204},
  [1761] = {.lex_state = 204},
  [1762] = {.lex_state = 204},
  [1763] = {.lex_state = 204},
  [1764] = {.lex_state = 204},
  [1765] = {.lex_state = 204},
  [1766] = {.lex_state = 204},
  [1767] = {.lex_state = 204},
  [1768] = {.lex_state = 204},
  [1769] = {.lex_state = 204},
  [1770] = {.lex_state = 204},
  [1771] = {.lex_state = 204},
  [1772] = {.lex_state = 204},
  [1773] = {.lex_state = 204},
  [1774] = {.lex_state = 204},
  [1775] = {.lex_state = 204},
  [1776] = {.lex_state = 204},
  [1777] = {.lex_state = 204},
  [1778] = {.lex_state = 204},
  [1779] = {.lex_state = 204},
  [1780] = {.lex_state = 204},
  [1781] = {.lex_state = 204},
  [1782] = {.lex_state = 204},
  [1783] = {.lex_state = 204},
  [1784] = {.lex_state = 204},
  [1785] = {.lex_state = 204},
  [1786] = {.lex_state = 204},
  [1787] = {.lex_state = 204},
  [1788] = {.lex_state = 204},
  [1789] = {.lex_state = 204},
  [1790] = {.lex_state = 204},
  [1791] = {.lex_state = 204},
  [1792] = {.lex_state = 204},
  [1793] = {.lex_state = 204},
  [1794] = {.lex_state = 204},
  [1795] = {.lex_state = 204},
  [1796] = {.lex_state = 204},
  [1797] = {.lex_state = 204},
  [1798] = {.lex_state = 204},
  [1799] = {.lex_state = 204},
  [1800] = {.lex_state = 204},
  [1801] = {.lex_state = 204},
  [1802] = {.lex_state = 204},
  [1803] = {.lex_state = 204},
  [1804] = {.lex_state = 204},
  [1805] = {.lex_state = 204},
  [1806] = {.lex_state = 204},
  [1807] = {.lex_state = 204},
  [1808] = {.lex_state = 204},
  [1809] = {.lex_state = 204},
  [1810] = {.lex_state = 204},
  [1811] = {.lex_state = 204},
  [1812] = {.lex_state = 204},
  [1813] = {.lex_state = 204},
  [1814] = {.lex_state = 204},
  [1815] = {.lex_state = 204},
  [1816] = {.lex_state = 204},
  [1817] = {.lex_state = 204},
  [1818] = {.lex_state = 204},
  [1819] = {.lex_state = 204},
  [1820] = {.lex_state = 204},
  [1821] = {.lex_state = 204},
  [1822] = {.lex_state = 204},
  [1823] = {.lex_state = 204},
  [1824] = {.lex_state = 204},
  [1825] = {.lex_state = 204},
  [1826] = {.lex_state = 204},
  [1827] = {.lex_state = 204},
  [1828] = {.lex_state = 204},
  [1829] = {.lex_state = 204},
  [1830] = {.lex_state = 204},
  [1831] = {.lex_state = 204},
  [1832] = {.lex_state = 204},
  [1833] = {.lex_state = 204},
  [1834] = {.lex_state = 204},
  [1835] = {.lex_state = 204},
  [1836] = {.lex_state = 204},
  [1837] = {.lex_state = 204},
  [1838] = {.lex_state = 204},
  [1839] = {.lex_state = 204},
  [1840] = {.lex_state = 204},
  [1841] = {.lex_state = 204},
  [1842] = {.lex_state = 204},
  [1843] = {.lex_state = 204},
  [1844] = {.lex_state = 204},
  [1845] = {.lex_state = 204},
  [1846] = {.lex_state = 204},
  [1847] = {.lex_state = 204},
  [1848] = {.lex_state = 204},
  [1849] = {.lex_state = 204},
  [1850] = {.lex_state = 204},
  [1851] = {.lex_state = 204},
  [1852] = {.lex_state = 204},
  [1853] = {.lex_state = 204},
  [1854] = {.lex_state = 204},
  [1855] = {.lex_state = 204},
  [1856] = {.lex_state = 204},
  [1857] = {.lex_state = 204},
  [1858] = {.lex_state = 204},
  [1859] = {.lex_state = 204},
  [1860] = {.lex_state = 204},
  [1861] = {.lex_state = 204},
  [1862] = {.lex_state = 204},
  [1863] = {.lex_state = 204},
  [1864] = {.lex_state = 204},
  [1865] = {.lex_state = 204},
  [1866] = {.lex_state = 204},
  [1867] = {.lex_state = 204},
  [1868] = {.lex_state = 204},
  [1869] = {.lex_state = 204},
  [1870] = {.lex_state = 204},
  [1871] = {.lex_state = 204},
  [1872] = {.lex_state = 204},
  [1873] = {.lex_state = 204},
  [1874] = {.lex_state = 204},
  [1875] = {.lex_state = 204},
  [1876] = {.lex_state = 204},
  [1877] = {.lex_state = 204},
  [1878] = {.lex_state = 204},
  [1879] = {.lex_state = 204},
  [1880] = {.lex_state = 204},
  [1881] = {.lex_state = 204},
  [1882] = {.lex_state = 204},
  [1883] = {.lex_state = 204},
  [1884] = {.lex_state = 204},
  [1885] = {.lex_state = 204},
  [1886] = {.lex_state = 204},
  [1887] = {.lex_state = 204},
  [1888] = {.lex_state = 204},
  [1889] = {.lex_state = 204},
  [1890] = {.lex_state = 204},
  [1891] = {.lex_state = 204},
  [1892] = {.lex_state = 204},
  [1893] = {.lex_state = 204},
  [1894] = {.lex_state = 204},
  [1895] = {.lex_state = 204},
  [1896] = {.lex_state = 204},
  [1897] = {.lex_state = 204},
  [1898] = {.lex_state = 204},
  [1899] = {.lex_state = 204},
  [1900] = {.lex_state = 204},
  [1901] = {.lex_state = 204},
  [1902] = {.lex_state = 204},
  [1903] = {.lex_state = 204},
  [1904] = {.lex_state = 204},
  [1905] = {.lex_state = 204},
  [1906] = {.lex_state = 204},
  [1907] = {.lex_state = 204},
  [1908] = {.lex_state = 204},
  [1909] = {.lex_state = 204},
  [1910] = {.lex_state = 204},
  [1911] = {.lex_state = 204},
  [1912] = {.lex_state = 204},
  [1913] = {.lex_state = 204},
  [1914] = {.lex_state = 204},
  [1915] = {.lex_state = 204},
  [1916] = {.lex_state = 204},
  [1917] = {.lex_state = 204},
  [1918] = {.lex_state = 204},
  [1919] = {.lex_state = 204},
  [1920] = {.lex_state = 204},
  [1921] = {.lex_state = 204},
  [1922] = {.lex_state = 204},
  [1923] = {.lex_state = 204},
  [1924] = {.lex_state = 204},
  [1925] = {.lex_state = 204},
  [1926] = {.lex_state = 204},
  [1927] = {.lex_state = 204},
  [1928] = {.lex_state = 204},
  [1929] = {.lex_state = 204},
  [1930] = {.lex_state = 204},
  [1931] = {.lex_state = 204},
  [1932] = {.lex_state = 204},
  [1933] = {.lex_state = 204},
  [1934] = {.lex_state = 204},
  [1935] = {.lex_state = 204},
  [1936] = {.lex_state = 204},
  [1937] = {.lex_state = 204},
  [1938] = {.lex_state = 204},
  [1939] = {.lex_state = 204},
  [1940] = {.lex_state = 204},
  [1941] = {.lex_state = 204},
  [1942] = {.lex_state = 204},
  [1943] = {.lex_state = 204},
  [1944] = {.lex_state = 204},
  [1945] = {.lex_state = 204},
  [1946] = {.lex_state = 204},
  [1947] = {.lex_state = 204},
  [1948] = {.lex_state = 204},
  [1949] = {.lex_state = 204},
  [1950] = {.lex_state = 204},
  [1951] = {.lex_state = 204},
  [1952] = {.lex_state = 204},
  [1953] = {.lex_state = 204},
  [1954] = {.lex_state = 204},
  [1955] = {.lex_state = 204},
  [1956] = {.lex_state = 204},
  [1957] = {.lex_state = 204},
  [1958] = {.lex_state = 204},
  [1959] = {.lex_state = 204},
  [1960] = {.lex_state = 204},
  [1961] = {.lex_state = 204},
  [1962] = {.lex_state = 204},
  [1963] = {.lex_state = 204},
  [1964] = {.lex_state = 204},
  [1965] = {.lex_state = 204},
  [1966] = {.lex_state = 204},
  [1967] = {.lex_state = 204},
  [1968] = {.lex_state = 204},
  [1969] = {.lex_state = 204},
  [1970] = {.lex_state = 204},
  [1971] = {.lex_state = 282},
  [1972] = {.lex_state = 282},
  [1973] = {.lex_state = 244},
  [1974] = {.lex_state = 244},
  [1975] = {.lex_state = 244},
  [1976] = {.lex_state = 244},
  [1977] = {.lex_state = 244},
  [1978] = {.lex_state = 244},
  [1979] = {.lex_state = 244},
  [1980] = {.lex_state = 244},
  [1981] = {.lex_state = 282},
  [1982] = {.lex_state = 282},
  [1983] = {.lex_state = 244},
  [1984] = {.lex_state = 282},
  [1985] = {.lex_state = 282},
  [1986] = {.lex_state = 282},
  [1987] = {.lex_state = 200},
  [1988] = {.lex_state = 200},
  [1989] = {.lex_state = 200},
  [1990] = {.lex_state = 244},
  [1991] = {.lex_state = 231},
  [1992] = {.lex_state = 231},
  [1993] = {.lex_state = 244},
  [1994] = {.lex_state = 231},
  [1995] = {.lex_state = 219},
  [1996] = {.lex_state = 231},
  [1997] = {.lex_state = 231},
  [1998] = {.lex_state = 231},
  [1999] = {.lex_state = 231},
  [2000] = {.lex_state = 231},
  [2001] = {.lex_state = 244},
  [2002] = {.lex_state = 231},
  [2003] = {.lex_state = 226},
  [2004] = {.lex_state = 226},
  [2005] = {.lex_state = 226},
  [2006] = {.lex_state = 220},
  [2007] = {.lex_state = 226},
  [2008] = {.lex_state = 226},
  [2009] = {.lex_state = 226},
  [2010] = {.lex_state = 244},
  [2011] = {.lex_state = 226},
  [2012] = {.lex_state = 223},
  [2013] = {.lex_state = 231},
  [2014] = {.lex_state = 231},
  [2015] = {.lex_state = 231},
  [2016] = {.lex_state = 231},
  [2017] = {.lex_state = 231},
  [2018] = {.lex_state = 231},
  [2019] = {.lex_state = 231},
  [2020] = {.lex_state = 231},
  [2021] = {.lex_state = 282},
  [2022] = {.lex_state = 282},
  [2023] = {.lex_state = 282},
  [2024] = {.lex_state = 282},
  [2025] = {.lex_state = 282},
  [2026] = {.lex_state = 282},
  [2027] = {.lex_state = 282},
  [2028] = {.lex_state = 282},
  [2029] = {.lex_state = 282},
  [2030] = {.lex_state = 282},
  [2031] = {.lex_state = 282},
  [2032] = {.lex_state = 282},
  [2033] = {.lex_state = 282},
  [2034] = {.lex_state = 282},
  [2035] = {.lex_state = 226},
  [2036] = {.lex_state = 282},
  [2037] = {.lex_state = 282},
  [2038] = {.lex_state = 282},
  [2039] = {.lex_state = 282},
  [2040] = {.lex_state = 282},
  [2041] = {.lex_state = 282},
  [2042] = {.lex_state = 282},
  [2043] = {.lex_state = 282},
  [2044] = {.lex_state = 282},
  [2045] = {.lex_state = 282},
  [2046] = {.lex_state = 282},
  [2047] = {.lex_state = 282},
  [2048] = {.lex_state = 282},
  [2049] = {.lex_state = 282},
  [2050] = {.lex_state = 282},
  [2051] = {.lex_state = 282},
  [2052] = {.lex_state = 282},
  [2053] = {.lex_state = 282},
  [2054] = {.lex_state = 282},
  [2055] = {.lex_state = 282},
  [2056] = {.lex_state = 282},
  [2057] = {.lex_state = 200},
  [2058] = {.lex_state = 282},
  [2059] = {.lex_state = 208},
  [2060] = {.lex_state = 282},
  [2061] = {.lex_state = 282},
  [2062] = {.lex_state = 200},
  [2063] = {.lex_state = 230},
  [2064] = {.lex_state = 282},
  [2065] = {.lex_state = 206},
  [2066] = {.lex_state = 282},
  [2067] = {.lex_state = 206},
  [2068] = {.lex_state = 206},
  [2069] = {.lex_state = 282},
  [2070] = {.lex_state = 282},
  [2071] = {.lex_state = 282},
  [2072] = {.lex_state = 226},
  [2073] = {.lex_state = 282},
  [2074] = {.lex_state = 282},
  [2075] = {.lex_state = 226},
  [2076] = {.lex_state = 282},
  [2077] = {.lex_state = 260},
  [2078] = {.lex_state = 260},
  [2079] = {.lex_state = 229},
  [2080] = {.lex_state = 260},
  [2081] = {.lex_state = 282},
  [2082] = {.lex_state = 282},
  [2083] = {.lex_state = 260},
  [2084] = {.lex_state = 260},
  [2085] = {.lex_state = 260},
  [2086] = {.lex_state = 260},
  [2087] = {.lex_state = 282},
  [2088] = {.lex_state = 282},
  [2089] = {.lex_state = 265},
  [2090] = {.lex_state = 282},
  [2091] = {.lex_state = 265},
  [2092] = {.lex_state = 206},
  [2093] = {.lex_state = 252},
  [2094] = {.lex_state = 206},
  [2095] = {.lex_state = 206},
  [2096] = {.lex_state = 265},
  [2097] = {.lex_state = 265},
  [2098] = {.lex_state = 252},
  [2099] = {.lex_state = 282},
  [2100] = {.lex_state = 252},
  [2101] = {.lex_state = 204},
  [2102] = {.lex_state = 252},
  [2103] = {.lex_state = 282},
  [2104] = {.lex_state = 265},
  [2105] = {.lex_state = 265},
  [2106] = {.lex_state = 206},
  [2107] = {.lex_state = 265},
  [2108] = {.lex_state = 282},
  [2109] = {.lex_state = 282},
  [2110] = {.lex_state = 282},
  [2111] = {.lex_state = 282},
  [2112] = {.lex_state = 282},
  [2113] = {.lex_state = 282},
  [2114] = {.lex_state = 282},
  [2115] = {.lex_state = 282},
  [2116] = {.lex_state = 226},
  [2117] = {.lex_state = 282},
  [2118] = {.lex_state = 243},
  [2119] = {.lex_state = 282},
  [2120] = {.lex_state = 252},
  [2121] = {.lex_state = 234},
  [2122] = {.lex_state = 282},
  [2123] = {.lex_state = 282},
  [2124] = {.lex_state = 252},
  [2125] = {.lex_state = 243},
  [2126] = {.lex_state = 282},
  [2127] = {.lex_state = 282},
  [2128] = {.lex_state = 282},
  [2129] = {.lex_state = 282},
  [2130] = {.lex_state = 282},
  [2131] = {.lex_state = 282},
  [2132] = {.lex_state = 282},
  [2133] = {.lex_state = 282},
  [2134] = {.lex_state = 282},
  [2135] = {.lex_state = 282},
  [2136] = {.lex_state = 282},
  [2137] = {.lex_state = 282},
  [2138] = {.lex_state = 226},
  [2139] = {.lex_state = 282},
  [2140] = {.lex_state = 282},
  [2141] = {.lex_state = 282},
  [2142] = {.lex_state = 243},
  [2143] = {.lex_state = 282},
  [2144] = {.lex_state = 226},
  [2145] = {.lex_state = 230},
  [2146] = {.lex_state = 282},
  [2147] = {.lex_state = 282},
  [2148] = {.lex_state = 243},
  [2149] = {.lex_state = 282},
  [2150] = {.lex_state = 226},
  [2151] = {.lex_state = 226},
  [2152] = {.lex_state = 282},
  [2153] = {.lex_state = 231},
  [2154] = {.lex_state = 252},
  [2155] = {.lex_state = 282},
  [2156] = {.lex_state = 243},
  [2157] = {.lex_state = 230},
  [2158] = {.lex_state = 282},
  [2159] = {.lex_state = 282},
  [2160] = {.lex_state = 282},
  [2161] = {.lex_state = 282},
  [2162] = {.lex_state = 282},
  [2163] = {.lex_state = 282},
  [2164] = {.lex_state = 282},
  [2165] = {.lex_state = 282},
  [2166] = {.lex_state = 208},
  [2167] = {.lex_state = 243},
  [2168] = {.lex_state = 252},
  [2169] = {.lex_state = 226},
  [2170] = {.lex_state = 282},
  [2171] = {.lex_state = 226},
  [2172] = {.lex_state = 282},
  [2173] = {.lex_state = 282},
  [2174] = {.lex_state = 226},
  [2175] = {.lex_state = 282},
  [2176] = {.lex_state = 282},
  [2177] = {.lex_state = 282},
  [2178] = {.lex_state = 282},
  [2179] = {.lex_state = 282},
  [2180] = {.lex_state = 282},
  [2181] = {.lex_state = 282},
  [2182] = {.lex_state = 282},
  [2183] = {.lex_state = 282},
  [2184] = {.lex_state = 282},
  [2185] = {.lex_state = 282},
  [2186] = {.lex_state = 282},
  [2187] = {.lex_state = 282},
  [2188] = {.lex_state = 243},
  [2189] = {.lex_state = 282},
  [2190] = {.lex_state = 282},
  [2191] = {.lex_state = 282},
  [2192] = {.lex_state = 282},
  [2193] = {.lex_state = 282},
  [2194] = {.lex_state = 282},
  [2195] = {.lex_state = 282},
  [2196] = {.lex_state = 282},
  [2197] = {.lex_state = 282},
  [2198] = {.lex_state = 282},
  [2199] = {.lex_state = 282},
  [2200] = {.lex_state = 282},
  [2201] = {.lex_state = 282},
  [2202] = {.lex_state = 282},
  [2203] = {.lex_state = 282},
  [2204] = {.lex_state = 282},
  [2205] = {.lex_state = 282},
  [2206] = {.lex_state = 282},
  [2207] = {.lex_state = 282},
  [2208] = {.lex_state = 282},
  [2209] = {.lex_state = 282},
  [2210] = {.lex_state = 226},
  [2211] = {.lex_state = 282},
  [2212] = {.lex_state = 282},
  [2213] = {.lex_state = 243},
  [2214] = {.lex_state = 282},
  [2215] = {.lex_state = 231},
  [2216] = {.lex_state = 282},
  [2217] = {.lex_state = 282},
  [2218] = {.lex_state = 282},
  [2219] = {.lex_state = 243},
  [2220] = {.lex_state = 282},
  [2221] = {.lex_state = 282},
  [2222] = {.lex_state = 243},
  [2223] = {.lex_state = 282},
  [2224] = {.lex_state = 282},
  [2225] = {.lex_state = 282},
  [2226] = {.lex_state = 282},
  [2227] = {.lex_state = 243},
  [2228] = {.lex_state = 282},
  [2229] = {.lex_state = 282},
  [2230] = {.lex_state = 226},
  [2231] = {.lex_state = 282},
  [2232] = {.lex_state = 226},
  [2233] = {.lex_state = 282},
  [2234] = {.lex_state = 226},
  [2235] = {.lex_state = 243},
  [2236] = {.lex_state = 282},
  [2237] = {.lex_state = 243},
  [2238] = {.lex_state = 226},
  [2239] = {.lex_state = 226},
  [2240] = {.lex_state = 282},
  [2241] = {.lex_state = 282},
  [2242] = {.lex_state = 282},
  [2243] = {.lex_state = 282},
  [2244] = {.lex_state = 230},
  [2245] = {.lex_state = 230},
  [2246] = {.lex_state = 230},
  [2247] = {.lex_state = 230},
  [2248] = {.lex_state = 230},
  [2249] = {.lex_state = 260},
  [2250] = {.lex_state = 230},
  [2251] = {.lex_state = 230},
  [2252] = {.lex_state = 230},
  [2253] = {.lex_state = 230},
  [2254] = {.lex_state = 230},
  [2255] = {.lex_state = 282},
  [2256] = {.lex_state = 230},
  [2257] = {.lex_state = 283},
  [2258] = {.lex_state = 230},
  [2259] = {.lex_state = 230},
  [2260] = {.lex_state = 252},
  [2261] = {.lex_state = 280},
  [2262] = {.lex_state = 252},
  [2263] = {.lex_state = 283},
  [2264] = {.lex_state = 230},
  [2265] = {.lex_state = 282},
  [2266] = {.lex_state = 230},
  [2267] = {.lex_state = 230},
  [2268] = {.lex_state = 230},
  [2269] = {.lex_state = 230},
  [2270] = {.lex_state = 230},
  [2271] = {.lex_state = 230},
  [2272] = {.lex_state = 230},
  [2273] = {.lex_state = 230},
  [2274] = {.lex_state = 282},
  [2275] = {.lex_state = 283},
  [2276] = {.lex_state = 230},
  [2277] = {.lex_state = 230},
  [2278] = {.lex_state = 230},
  [2279] = {.lex_state = 280},
  [2280] = {.lex_state = 204},
  [2281] = {.lex_state = 230},
  [2282] = {.lex_state = 282},
  [2283] = {.lex_state = 282},
  [2284] = {.lex_state = 230},
  [2285] = {.lex_state = 230},
  [2286] = {.lex_state = 283},
  [2287] = {.lex_state = 230},
  [2288] = {.lex_state = 280},
  [2289] = {.lex_state = 230},
  [2290] = {.lex_state = 230},
  [2291] = {.lex_state = 282},
  [2292] = {.lex_state = 230},
  [2293] = {.lex_state = 252},
  [2294] = {.lex_state = 230},
  [2295] = {.lex_state = 252},
  [2296] = {.lex_state = 230},
  [2297] = {.lex_state = 252},
  [2298] = {.lex_state = 230},
  [2299] = {.lex_state = 230},
  [2300] = {.lex_state = 230},
  [2301] = {.lex_state = 280},
  [2302] = {.lex_state = 230},
  [2303] = {.lex_state = 230},
  [2304] = {.lex_state = 230},
  [2305] = {.lex_state = 252},
  [2306] = {.lex_state = 252},
  [2307] = {.lex_state = 252},
  [2308] = {.lex_state = 252},
  [2309] = {.lex_state = 252},
  [2310] = {.lex_state = 206},
  [2311] = {.lex_state = 252},
  [2312] = {.lex_state = 252},
  [2313] = {.lex_state = 252},
  [2314] = {.lex_state = 252},
  [2315] = {.lex_state = 252},
  [2316] = {.lex_state = 252},
  [2317] = {.lex_state = 252},
  [2318] = {.lex_state = 252},
  [2319] = {.lex_state = 252},
  [2320] = {.lex_state = 252},
  [2321] = {.lex_state = 283},
  [2322] = {.lex_state = 252},
  [2323] = {.lex_state = 252},
  [2324] = {.lex_state = 252},
  [2325] = {.lex_state = 252},
  [2326] = {.lex_state = 252},
  [2327] = {.lex_state = 283},
  [2328] = {.lex_state = 252},
  [2329] = {.lex_state = 252},
  [2330] = {.lex_state = 252},
  [2331] = {.lex_state = 252},
  [2332] = {.lex_state = 229},
  [2333] = {.lex_state = 252},
  [2334] = {.lex_state = 252},
  [2335] = {.lex_state = 252},
  [2336] = {.lex_state = 252},
  [2337] = {.lex_state = 252},
  [2338] = {.lex_state = 252},
  [2339] = {.lex_state = 252},
  [2340] = {.lex_state = 252},
  [2341] = {.lex_state = 252},
  [2342] = {.lex_state = 252},
  [2343] = {.lex_state = 252},
  [2344] = {.lex_state = 252},
  [2345] = {.lex_state = 234},
  [2346] = {.lex_state = 252},
  [2347] = {.lex_state = 252},
  [2348] = {.lex_state = 252},
  [2349] = {.lex_state = 213},
  [2350] = {.lex_state = 252},
  [2351] = {.lex_state = 252},
  [2352] = {.lex_state = 252},
  [2353] = {.lex_state = 252},
  [2354] = {.lex_state = 252},
  [2355] = {.lex_state = 232},
  [2356] = {.lex_state = 252},
  [2357] = {.lex_state = 252},
  [2358] = {.lex_state = 252},
  [2359] = {.lex_state = 252},
  [2360] = {.lex_state = 252},
  [2361] = {.lex_state = 252},
  [2362] = {.lex_state = 252},
  [2363] = {.lex_state = 252},
  [2364] = {.lex_state = 252},
  [2365] = {.lex_state = 206},
  [2366] = {.lex_state = 252},
  [2367] = {.lex_state = 283},
  [2368] = {.lex_state = 252},
  [2369] = {.lex_state = 252},
  [2370] = {.lex_state = 252},
  [2371] = {.lex_state = 252},
  [2372] = {.lex_state = 252},
  [2373] = {.lex_state = 252},
  [2374] = {.lex_state = 252},
  [2375] = {.lex_state = 252},
  [2376] = {.lex_state = 252},
  [2377] = {.lex_state = 280},
  [2378] = {.lex_state = 252},
  [2379] = {.lex_state = 252},
  [2380] = {.lex_state = 234},
  [2381] = {.lex_state = 252},
  [2382] = {.lex_state = 252},
  [2383] = {.lex_state = 252},
  [2384] = {.lex_state = 252},
  [2385] = {.lex_state = 234},
  [2386] = {.lex_state = 252},
  [2387] = {.lex_state = 252},
  [2388] = {.lex_state = 252},
  [2389] = {.lex_state = 252},
  [2390] = {.lex_state = 252},
  [2391] = {.lex_state = 252},
  [2392] = {.lex_state = 280},
  [2393] = {.lex_state = 252},
  [2394] = {.lex_state = 252},
  [2395] = {.lex_state = 252},
  [2396] = {.lex_state = 252},
  [2397] = {.lex_state = 252},
  [2398] = {.lex_state = 252},
  [2399] = {.lex_state = 252},
  [2400] = {.lex_state = 232},
  [2401] = {.lex_state = 229},
  [2402] = {.lex_state = 280},
  [2403] = {.lex_state = 252},
  [2404] = {.lex_state = 280},
  [2405] = {.lex_state = 265},
  [2406] = {.lex_state = 252},
  [2407] = {.lex_state = 234},
  [2408] = {.lex_state = 260},
  [2409] = {.lex_state = 213},
  [2410] = {.lex_state = 252},
  [2411] = {.lex_state = 234},
  [2412] = {.lex_state = 283},
  [2413] = {.lex_state = 252},
  [2414] = {.lex_state = 252},
  [2415] = {.lex_state = 252},
  [2416] = {.lex_state = 211},
  [2417] = {.lex_state = 265},
  [2418] = {.lex_state = 280},
  [2419] = {.lex_state = 283},
  [2420] = {.lex_state = 219},
  [2421] = {.lex_state = 280},
  [2422] = {.lex_state = 232},
  [2423] = {.lex_state = 232},
  [2424] = {.lex_state = 232},
  [2425] = {.lex_state = 232},
  [2426] = {.lex_state = 232},
  [2427] = {.lex_state = 229},
  [2428] = {.lex_state = 232},
  [2429] = {.lex_state = 208},
  [2430] = {.lex_state = 280},
  [2431] = {.lex_state = 237},
  [2432] = {.lex_state = 211},
  [2433] = {.lex_state = 232},
  [2434] = {.lex_state = 222},
  [2435] = {.lex_state = 222},
  [2436] = {.lex_state = 232},
  [2437] = {.lex_state = 219},
  [2438] = {.lex_state = 208},
  [2439] = {.lex_state = 280},
  [2440] = {.lex_state = 282},
  [2441] = {.lex_state = 206},
  [2442] = {.lex_state = 206},
  [2443] = {.lex_state = 211},
  [2444] = {.lex_state = 232},
  [2445] = {.lex_state = 283},
  [2446] = {.lex_state = 208},
  [2447] = {.lex_state = 283},
  [2448] = {.lex_state = 222},
  [2449] = {.lex_state = 282},
  [2450] = {.lex_state = 282},
  [2451] = {.lex_state = 283},
  [2452] = {.lex_state = 280},
  [2453] = {.lex_state = 229},
  [2454] = {.lex_state = 283},
  [2455] = {.lex_state = 232},
  [2456] = {.lex_state = 232},
  [2457] = {.lex_state = 232},
  [2458] = {.lex_state = 283},
  [2459] = {.lex_state = 280},
  [2460] = {.lex_state = 206},
  [2461] = {.lex_state = 280},
  [2462] = {.lex_state = 283},
  [2463] = {.lex_state = 283},
  [2464] = {.lex_state = 280},
  [2465] = {.lex_state = 283},
  [2466] = {.lex_state = 283},
  [2467] = {.lex_state = 283},
  [2468] = {.lex_state = 283},
  [2469] = {.lex_state = 280},
  [2470] = {.lex_state = 280},
  [2471] = {.lex_state = 280},
  [2472] = {.lex_state = 280},
  [2473] = {.lex_state = 208},
  [2474] = {.lex_state = 280},
  [2475] = {.lex_state = 280},
  [2476] = {.lex_state = 283},
  [2477] = {.lex_state = 283},
  [2478] = {.lex_state = 283},
  [2479] = {.lex_state = 283},
  [2480] = {.lex_state = 283},
  [2481] = {.lex_state = 283},
  [2482] = {.lex_state = 283},
  [2483] = {.lex_state = 280},
  [2484] = {.lex_state = 280},
  [2485] = {.lex_state = 283},
  [2486] = {.lex_state = 283},
  [2487] = {.lex_state = 280},
  [2488] = {.lex_state = 280},
  [2489] = {.lex_state = 280},
  [2490] = {.lex_state = 206},
  [2491] = {.lex_state = 280},
  [2492] = {.lex_state = 280},
  [2493] = {.lex_state = 283},
  [2494] = {.lex_state = 283},
  [2495] = {.lex_state = 280},
  [2496] = {.lex_state = 283},
  [2497] = {.lex_state = 283},
  [2498] = {.lex_state = 283},
  [2499] = {.lex_state = 283},
  [2500] = {.lex_state = 283},
  [2501] = {.lex_state = 283},
  [2502] = {.lex_state = 283},
  [2503] = {.lex_state = 283},
  [2504] = {.lex_state = 283},
  [2505] = {.lex_state = 283},
  [2506] = {.lex_state = 280},
  [2507] = {.lex_state = 280},
  [2508] = {.lex_state = 283},
  [2509] = {.lex_state = 280},
  [2510] = {.lex_state = 208},
  [2511] = {.lex_state = 283},
  [2512] = {.lex_state = 280},
  [2513] = {.lex_state = 280},
  [2514] = {.lex_state = 280},
  [2515] = {.lex_state = 280},
  [2516] = {.lex_state = 283},
  [2517] = {.lex_state = 280},
  [2518] = {.lex_state = 280},
  [2519] = {.lex_state = 283},
  [2520] = {.lex_state = 280},
  [2521] = {.lex_state = 280},
  [2522] = {.lex_state = 208},
  [2523] = {.lex_state = 283},
  [2524] = {.lex_state = 283},
  [2525] = {.lex_state = 280},
  [2526] = {.lex_state = 283},
  [2527] = {.lex_state = 283},
  [2528] = {.lex_state = 208},
  [2529] = {.lex_state = 283},
  [2530] = {.lex_state = 283},
  [2531] = {.lex_state = 283},
  [2532] = {.lex_state = 283},
  [2533] = {.lex_state = 280},
  [2534] = {.lex_state = 280},
  [2535] = {.lex_state = 283},
  [2536] = {.lex_state = 283},
  [2537] = {.lex_state = 283},
  [2538] = {.lex_state = 283},
  [2539] = {.lex_state = 280},
  [2540] = {.lex_state = 280},
  [2541] = {.lex_state = 283},
  [2542] = {.lex_state = 280},
  [2543] = {.lex_state = 283},
  [2544] = {.lex_state = 283},
  [2545] = {.lex_state = 283},
  [2546] = {.lex_state = 283},
  [2547] = {.lex_state = 283},
  [2548] = {.lex_state = 283},
  [2549] = {.lex_state = 283},
  [2550] = {.lex_state = 283},
  [2551] = {.lex_state = 216},
  [2552] = {.lex_state = 283},
  [2553] = {.lex_state = 283},
  [2554] = {.lex_state = 280},
  [2555] = {.lex_state = 283},
  [2556] = {.lex_state = 220},
  [2557] = {.lex_state = 234},
  [2558] = {.lex_state = 280},
  [2559] = {.lex_state = 283},
  [2560] = {.lex_state = 283},
  [2561] = {.lex_state = 280},
  [2562] = {.lex_state = 283},
  [2563] = {.lex_state = 208},
  [2564] = {.lex_state = 283},
  [2565] = {.lex_state = 280},
  [2566] = {.lex_state = 283},
  [2567] = {.lex_state = 280},
  [2568] = {.lex_state = 283},
  [2569] = {.lex_state = 280},
  [2570] = {.lex_state = 283},
  [2571] = {.lex_state = 232},
  [2572] = {.lex_state = 283},
  [2573] = {.lex_state = 280},
  [2574] = {.lex_state = 280},
  [2575] = {.lex_state = 206},
  [2576] = {.lex_state = 280},
  [2577] = {.lex_state = 280},
  [2578] = {.lex_state = 280},
  [2579] = {.lex_state = 234},
  [2580] = {.lex_state = 242},
  [2581] = {.lex_state = 280},
  [2582] = {.lex_state = 280},
  [2583] = {.lex_state = 280},
  [2584] = {.lex_state = 280},
  [2585] = {.lex_state = 280},
  [2586] = {.lex_state = 283},
  [2587] = {.lex_state = 280},
  [2588] = {.lex_state = 208},
  [2589] = {.lex_state = 283},
  [2590] = {.lex_state = 280},
  [2591] = {.lex_state = 283},
  [2592] = {.lex_state = 220},
  [2593] = {.lex_state = 208},
  [2594] = {.lex_state = 280},
  [2595] = {.lex_state = 238},
  [2596] = {.lex_state = 283},
  [2597] = {.lex_state = 283},
  [2598] = {.lex_state = 280},
  [2599] = {.lex_state = 283},
  [2600] = {.lex_state = 280},
  [2601] = {.lex_state = 280},
  [2602] = {.lex_state = 283},
  [2603] = {.lex_state = 280},
  [2604] = {.lex_state = 234},
  [2605] = {.lex_state = 280},
  [2606] = {.lex_state = 283},
  [2607] = {.lex_state = 280},
  [2608] = {.lex_state = 280},
  [2609] = {.lex_state = 280},
  [2610] = {.lex_state = 280},
  [2611] = {.lex_state = 208},
  [2612] = {.lex_state = 280},
  [2613] = {.lex_state = 283},
  [2614] = {.lex_state = 280},
  [2615] = {.lex_state = 283},
  [2616] = {.lex_state = 216},
  [2617] = {.lex_state = 280},
  [2618] = {.lex_state = 280},
  [2619] = {.lex_state = 283},
  [2620] = {.lex_state = 280},
  [2621] = {.lex_state = 280},
  [2622] = {.lex_state = 280},
  [2623] = {.lex_state = 280},
  [2624] = {.lex_state = 283},
  [2625] = {.lex_state = 280},
  [2626] = {.lex_state = 280},
  [2627] = {.lex_state = 280},
  [2628] = {.lex_state = 283},
  [2629] = {.lex_state = 283},
  [2630] = {.lex_state = 283},
  [2631] = {.lex_state = 283},
  [2632] = {.lex_state = 283},
  [2633] = {.lex_state = 283},
  [2634] = {.lex_state = 211},
  [2635] = {.lex_state = 283},
  [2636] = {.lex_state = 280},
  [2637] = {.lex_state = 283},
  [2638] = {.lex_state = 280},
  [2639] = {.lex_state = 280},
  [2640] = {.lex_state = 280},
  [2641] = {.lex_state = 280},
  [2642] = {.lex_state = 280},
  [2643] = {.lex_state = 208},
  [2644] = {.lex_state = 280},
  [2645] = {.lex_state = 216},
  [2646] = {.lex_state = 280},
  [2647] = {.lex_state = 211},
  [2648] = {.lex_state = 280},
  [2649] = {.lex_state = 208},
  [2650] = {.lex_state = 280},
  [2651] = {.lex_state = 259},
  [2652] = {.lex_state = 280},
  [2653] = {.lex_state = 280},
  [2654] = {.lex_state = 280},
  [2655] = {.lex_state = 283},
  [2656] = {.lex_state = 280},
  [2657] = {.lex_state = 283},
  [2658] = {.lex_state = 280},
  [2659] = {.lex_state = 283},
  [2660] = {.lex_state = 283},
  [2661] = {.lex_state = 238},
  [2662] = {.lex_state = 233},
  [2663] = {.lex_state = 282},
  [2664] = {.lex_state = 282},
  [2665] = {.lex_state = 282},
  [2666] = {.lex_state = 238},
  [2667] = {.lex_state = 206},
  [2668] = {.lex_state = 232},
  [2669] = {.lex_state = 234},
  [2670] = {.lex_state = 234},
  [2671] = {.lex_state = 238},
  [2672] = {.lex_state = 259},
  [2673] = {.lex_state = 232},
  [2674] = {.lex_state = 217},
  [2675] = {.lex_state = 232},
  [2676] = {.lex_state = 223},
  [2677] = {.lex_state = 238},
  [2678] = {.lex_state = 208},
  [2679] = {.lex_state = 238},
  [2680] = {.lex_state = 234},
  [2681] = {.lex_state = 234},
  [2682] = {.lex_state = 234},
  [2683] = {.lex_state = 234},
  [2684] = {.lex_state = 206},
  [2685] = {.lex_state = 259},
  [2686] = {.lex_state = 234},
  [2687] = {.lex_state = 232},
  [2688] = {.lex_state = 282},
  [2689] = {.lex_state = 232},
  [2690] = {.lex_state = 282},
  [2691] = {.lex_state = 233},
  [2692] = {.lex_state = 256},
  [2693] = {.lex_state = 282},
  [2694] = {.lex_state = 206},
  [2695] = {.lex_state = 242},
  [2696] = {.lex_state = 206},
  [2697] = {.lex_state = 282},
  [2698] = {.lex_state = 282},
  [2699] = {.lex_state = 242},
  [2700] = {.lex_state = 234},
  [2701] = {.lex_state = 208},
  [2702] = {.lex_state = 238},
  [2703] = {.lex_state = 234},
  [2704] = {.lex_state = 223},
  [2705] = {.lex_state = 282},
  [2706] = {.lex_state = 217},
  [2707] = {.lex_state = 238},
  [2708] = {.lex_state = 238},
  [2709] = {.lex_state = 234},
  [2710] = {.lex_state = 234},
  [2711] = {.lex_state = 234},
  [2712] = {.lex_state = 217},
  [2713] = {.lex_state = 282},
  [2714] = {.lex_state = 238},
  [2715] = {.lex_state = 282},
  [2716] = {.lex_state = 233},
  [2717] = {.lex_state = 282},
  [2718] = {.lex_state = 282},
  [2719] = {.lex_state = 282},
  [2720] = {.lex_state = 234},
  [2721] = {.lex_state = 282},
  [2722] = {.lex_state = 282},
  [2723] = {.lex_state = 233},
  [2724] = {.lex_state = 234},
  [2725] = {.lex_state = 234},
  [2726] = {.lex_state = 233},
  [2727] = {.lex_state = 281},
  [2728] = {.lex_state = 234},
  [2729] = {.lex_state = 233},
  [2730] = {.lex_state = 234},
  [2731] = {.lex_state = 233},
  [2732] = {.lex_state = 234},
  [2733] = {.lex_state = 233},
  [2734] = {.lex_state = 233},
  [2735] = {.lex_state = 234},
  [2736] = {.lex_state = 234},
  [2737] = {.lex_state = 234},
  [2738] = {.lex_state = 234},
  [2739] = {.lex_state = 234},
  [2740] = {.lex_state = 234},
  [2741] = {.lex_state = 234},
  [2742] = {.lex_state = 232},
  [2743] = {.lex_state = 234},
  [2744] = {.lex_state = 234},
  [2745] = {.lex_state = 234},
  [2746] = {.lex_state = 234},
  [2747] = {.lex_state = 234},
  [2748] = {.lex_state = 234},
  [2749] = {.lex_state = 234},
  [2750] = {.lex_state = 234},
  [2751] = {.lex_state = 257},
  [2752] = {.lex_state = 234},
  [2753] = {.lex_state = 234},
  [2754] = {.lex_state = 234},
  [2755] = {.lex_state = 234},
  [2756] = {.lex_state = 234},
  [2757] = {.lex_state = 234},
  [2758] = {.lex_state = 234},
  [2759] = {.lex_state = 234},
  [2760] = {.lex_state = 234},
  [2761] = {.lex_state = 234},
  [2762] = {.lex_state = 246},
  [2763] = {.lex_state = 234},
  [2764] = {.lex_state = 233},
  [2765] = {.lex_state = 211},
  [2766] = {.lex_state = 234},
  [2767] = {.lex_state = 234},
  [2768] = {.lex_state = 234},
  [2769] = {.lex_state = 234},
  [2770] = {.lex_state = 234},
  [2771] = {.lex_state = 234},
  [2772] = {.lex_state = 234},
  [2773] = {.lex_state = 211},
  [2774] = {.lex_state = 216},
  [2775] = {.lex_state = 234},
  [2776] = {.lex_state = 234},
  [2777] = {.lex_state = 284},
  [2778] = {.lex_state = 234},
  [2779] = {.lex_state = 211},
  [2780] = {.lex_state = 234},
  [2781] = {.lex_state = 284},
  [2782] = {.lex_state = 206},
  [2783] = {.lex_state = 245},
  [2784] = {.lex_state = 233},
  [2785] = {.lex_state = 233},
  [2786] = {.lex_state = 211},
  [2787] = {.lex_state = 234},
  [2788] = {.lex_state = 234},
  [2789] = {.lex_state = 234},
  [2790] = {.lex_state = 234},
  [2791] = {.lex_state = 281},
  [2792] = {.lex_state = 256},
  [2793] = {.lex_state = 256},
  [2794] = {.lex_state = 233},
  [2795] = {.lex_state = 233},
  [2796] = {.lex_state = 233},
  [2797] = {.lex_state = 216},
  [2798] = {.lex_state = 238},
  [2799] = {.lex_state = 234},
  [2800] = {.lex_state = 234},
  [2801] = {.lex_state = 234},
  [2802] = {.lex_state = 234},
  [2803] = {.lex_state = 206},
  [2804] = {.lex_state = 233},
  [2805] = {.lex_state = 233},
  [2806] = {.lex_state = 234},
  [2807] = {.lex_state = 282},
  [2808] = {.lex_state = 234},
  [2809] = {.lex_state = 257},
  [2810] = {.lex_state = 234},
  [2811] = {.lex_state = 206},
  [2812] = {.lex_state = 232},
  [2813] = {.lex_state = 234},
  [2814] = {.lex_state = 232},
  [2815] = {.lex_state = 234},
  [2816] = {.lex_state = 234},
  [2817] = {.lex_state = 234},
  [2818] = {.lex_state = 216},
  [2819] = {.lex_state = 245},
  [2820] = {.lex_state = 206},
  [2821] = {.lex_state = 216},
  [2822] = {.lex_state = 257},
  [2823] = {.lex_state = 216},
  [2824] = {.lex_state = 282},
  [2825] = {.lex_state = 281},
  [2826] = {.lex_state = 216},
  [2827] = {.lex_state = 216},
  [2828] = {.lex_state = 281},
  [2829] = {.lex_state = 281},
  [2830] = {.lex_state = 234},
  [2831] = {.lex_state = 217},
  [2832] = {.lex_state = 217},
  [2833] = {.lex_state = 234},
  [2834] = {.lex_state = 281},
  [2835] = {.lex_state = 232},
  [2836] = {.lex_state = 281},
  [2837] = {.lex_state = 216},
  [2838] = {.lex_state = 234},
  [2839] = {.lex_state = 234},
  [2840] = {.lex_state = 232},
  [2841] = {.lex_state = 282},
  [2842] = {.lex_state = 206},
  [2843] = {.lex_state = 206},
  [2844] = {.lex_state = 234},
  [2845] = {.lex_state = 234},
  [2846] = {.lex_state = 216},
  [2847] = {.lex_state = 281},
  [2848] = {.lex_state = 246},
  [2849] = {.lex_state = 234},
  [2850] = {.lex_state = 234},
  [2851] = {.lex_state = 237},
  [2852] = {.lex_state = 234},
  [2853] = {.lex_state = 234},
  [2854] = {.lex_state = 234},
  [2855] = {.lex_state = 234},
  [2856] = {.lex_state = 217},
  [2857] = {.lex_state = 246},
  [2858] = {.lex_state = 233},
  [2859] = {.lex_state = 234},
  [2860] = {.lex_state = 234},
  [2861] = {.lex_state = 246},
  [2862] = {.lex_state = 234},
  [2863] = {.lex_state = 246},
  [2864] = {.lex_state = 233},
  [2865] = {.lex_state = 234},
  [2866] = {.lex_state = 236},
  [2867] = {.lex_state = 246},
  [2868] = {.lex_state = 216},
  [2869] = {.lex_state = 237},
  [2870] = {.lex_state = 246},
  [2871] = {.lex_state = 246},
  [2872] = {.lex_state = 260},
  [2873] = {.lex_state = 246},
  [2874] = {.lex_state = 216},
  [2875] = {.lex_state = 216},
  [2876] = {.lex_state = 234},
  [2877] = {.lex_state = 217},
  [2878] = {.lex_state = 217},
  [2879] = {.lex_state = 217},
  [2880] = {.lex_state = 206},
  [2881] = {.lex_state = 245},
  [2882] = {.lex_state = 206},
  [2883] = {.lex_state = 233},
  [2884] = {.lex_state = 234},
  [2885] = {.lex_state = 234},
  [2886] = {.lex_state = 233},
  [2887] = {.lex_state = 216},
  [2888] = {.lex_state = 281},
  [2889] = {.lex_state = 284},
  [2890] = {.lex_state = 234},
  [2891] = {.lex_state = 234},
  [2892] = {.lex_state = 281},
  [2893] = {.lex_state = 233},
  [2894] = {.lex_state = 234},
  [2895] = {.lex_state = 238},
  [2896] = {.lex_state = 256},
  [2897] = {.lex_state = 245},
  [2898] = {.lex_state = 261},
  [2899] = {.lex_state = 282},
  [2900] = {.lex_state = 233},
  [2901] = {.lex_state = 238},
  [2902] = {.lex_state = 206},
  [2903] = {.lex_state = 206},
  [2904] = {.lex_state = 284},
  [2905] = {.lex_state = 234},
  [2906] = {.lex_state = 234},
  [2907] = {.lex_state = 234},
  [2908] = {.lex_state = 234},
  [2909] = {.lex_state = 234},
  [2910] = {.lex_state = 217},
  [2911] = {.lex_state = 246},
  [2912] = {.lex_state = 245},
  [2913] = {.lex_state = 234},
  [2914] = {.lex_state = 237},
  [2915] = {.lex_state = 234},
  [2916] = {.lex_state = 245},
  [2917] = {.lex_state = 256},
  [2918] = {.lex_state = 245},
  [2919] = {.lex_state = 245},
  [2920] = {.lex_state = 234},
  [2921] = {.lex_state = 217},
  [2922] = {.lex_state = 246},
  [2923] = {.lex_state = 204},
  [2924] = {.lex_state = 234},
  [2925] = {.lex_state = 234},
  [2926] = {.lex_state = 234},
  [2927] = {.lex_state = 238},
  [2928] = {.lex_state = 234},
  [2929] = {.lex_state = 234},
  [2930] = {.lex_state = 234},
  [2931] = {.lex_state = 234},
  [2932] = {.lex_state = 234},
  [2933] = {.lex_state = 237},
  [2934] = {.lex_state = 234},
  [2935] = {.lex_state = 234},
  [2936] = {.lex_state = 234},
  [2937] = {.lex_state = 234},
  [2938] = {.lex_state = 234},
  [2939] = {.lex_state = 234},
  [2940] = {.lex_state = 234},
  [2941] = {.lex_state = 234},
  [2942] = {.lex_state = 238},
  [2943] = {.lex_state = 234},
  [2944] = {.lex_state = 234},
  [2945] = {.lex_state = 234},
  [2946] = {.lex_state = 234},
  [2947] = {.lex_state = 234},
  [2948] = {.lex_state = 234},
  [2949] = {.lex_state = 234},
  [2950] = {.lex_state = 234},
  [2951] = {.lex_state = 234},
  [2952] = {.lex_state = 234},
  [2953] = {.lex_state = 234},
  [2954] = {.lex_state = 234},
  [2955] = {.lex_state = 234},
  [2956] = {.lex_state = 234},
  [2957] = {.lex_state = 273},
  [2958] = {.lex_state = 273},
  [2959] = {.lex_state = 234},
  [2960] = {.lex_state = 234},
  [2961] = {.lex_state = 234},
  [2962] = {.lex_state = 234},
  [2963] = {.lex_state = 234},
  [2964] = {.lex_state = 234},
  [2965] = {.lex_state = 234},
  [2966] = {.lex_state = 234},
  [2967] = {.lex_state = 234},
  [2968] = {.lex_state = 234},
  [2969] = {.lex_state = 246},
  [2970] = {.lex_state = 238},
  [2971] = {.lex_state = 217},
  [2972] = {.lex_state = 273},
  [2973] = {.lex_state = 234},
  [2974] = {.lex_state = 246},
  [2975] = {.lex_state = 234},
  [2976] = {.lex_state = 245},
  [2977] = {.lex_state = 238},
  [2978] = {.lex_state = 217},
  [2979] = {.lex_state = 245},
  [2980] = {.lex_state = 234},
  [2981] = {.lex_state = 245},
  [2982] = {.lex_state = 234},
  [2983] = {.lex_state = 238},
  [2984] = {.lex_state = 245},
  [2985] = {.lex_state = 245},
  [2986] = {.lex_state = 234},
  [2987] = {.lex_state = 245},
  [2988] = {.lex_state = 234},
  [2989] = {.lex_state = 234},
  [2990] = {.lex_state = 238},
  [2991] = {.lex_state = 238},
  [2992] = {.lex_state = 238},
  [2993] = {.lex_state = 234},
  [2994] = {.lex_state = 245},
  [2995] = {.lex_state = 234},
  [2996] = {.lex_state = 234},
  [2997] = {.lex_state = 234},
  [2998] = {.lex_state = 234},
  [2999] = {.lex_state = 234},
  [3000] = {.lex_state = 266},
  [3001] = {.lex_state = 234},
  [3002] = {.lex_state = 234},
  [3003] = {.lex_state = 234},
  [3004] = {.lex_state = 234},
  [3005] = {.lex_state = 273},
  [3006] = {.lex_state = 234},
  [3007] = {.lex_state = 234},
  [3008] = {.lex_state = 273},
  [3009] = {.lex_state = 273},
  [3010] = {.lex_state = 265},
  [3011] = {.lex_state = 273},
  [3012] = {.lex_state = 204},
  [3013] = {.lex_state = 256},
  [3014] = {.lex_state = 234},
  [3015] = {.lex_state = 245},
  [3016] = {.lex_state = 273},
  [3017] = {.lex_state = 234},
  [3018] = {.lex_state = 238},
  [3019] = {.lex_state = 238},
  [3020] = {.lex_state = 238},
  [3021] = {.lex_state = 238},
  [3022] = {.lex_state = 234},
  [3023] = {.lex_state = 234},
  [3024] = {.lex_state = 216},
  [3025] = {.lex_state = 216},
  [3026] = {.lex_state = 234},
  [3027] = {.lex_state = 282},
  [3028] = {.lex_state = 260},
  [3029] = {.lex_state = 234},
  [3030] = {.lex_state = 234},
  [3031] = {.lex_state = 234},
  [3032] = {.lex_state = 234},
  [3033] = {.lex_state = 234},
  [3034] = {.lex_state = 207},
  [3035] = {.lex_state = 260},
  [3036] = {.lex_state = 265},
  [3037] = {.lex_state = 260},
  [3038] = {.lex_state = 216},
  [3039] = {.lex_state = 281},
  [3040] = {.lex_state = 216},
  [3041] = {.lex_state = 281},
  [3042] = {.lex_state = 281},
  [3043] = {.lex_state = 246},
  [3044] = {.lex_state = 260},
  [3045] = {.lex_state = 246},
  [3046] = {.lex_state = 260},
  [3047] = {.lex_state = 246},
  [3048] = {.lex_state = 260},
  [3049] = {.lex_state = 260},
  [3050] = {.lex_state = 207},
  [3051] = {.lex_state = 281},
  [3052] = {.lex_state = 260},
  [3053] = {.lex_state = 281},
  [3054] = {.lex_state = 281},
  [3055] = {.lex_state = 260},
  [3056] = {.lex_state = 260},
  [3057] = {.lex_state = 207},
  [3058] = {.lex_state = 246},
  [3059] = {.lex_state = 273},
  [3060] = {.lex_state = 273},
  [3061] = {.lex_state = 216},
  [3062] = {.lex_state = 281},
  [3063] = {.lex_state = 281},
  [3064] = {.lex_state = 246},
  [3065] = {.lex_state = 216},
  [3066] = {.lex_state = 216},
  [3067] = {.lex_state = 204},
  [3068] = {.lex_state = 216},
  [3069] = {.lex_state = 265},
  [3070] = {.lex_state = 204},
  [3071] = {.lex_state = 260},
  [3072] = {.lex_state = 281},
  [3073] = {.lex_state = 281},
  [3074] = {.lex_state = 281},
  [3075] = {.lex_state = 281},
  [3076] = {.lex_state = 281},
  [3077] = {.lex_state = 281},
  [3078] = {.lex_state = 276},
  [3079] = {.lex_state = 281},
  [3080] = {.lex_state = 281},
  [3081] = {.lex_state = 260},
  [3082] = {.lex_state = 204},
  [3083] = {.lex_state = 265},
  [3084] = {.lex_state = 265},
  [3085] = {.lex_state = 260},
  [3086] = {.lex_state = 204},
  [3087] = {.lex_state = 281},
  [3088] = {.lex_state = 276},
  [3089] = {.lex_state = 204},
  [3090] = {.lex_state = 265},
  [3091] = {.lex_state = 265},
  [3092] = {.lex_state = 281},
  [3093] = {.lex_state = 281},
  [3094] = {.lex_state = 281},
  [3095] = {.lex_state = 281},
  [3096] = {.lex_state = 260},
  [3097] = {.lex_state = 261},
  [3098] = {.lex_state = 281},
  [3099] = {.lex_state = 204},
  [3100] = {.lex_state = 265},
  [3101] = {.lex_state = 265},
  [3102] = {.lex_state = 265},
  [3103] = {.lex_state = 204},
  [3104] = {.lex_state = 281},
  [3105] = {.lex_state = 276},
  [3106] = {.lex_state = 281},
  [3107] = {.lex_state = 260},
  [3108] = {.lex_state = 265},
  [3109] = {.lex_state = 276},
  [3110] = {.lex_state = 204},
  [3111] = {.lex_state = 281},
  [3112] = {.lex_state = 204},
  [3113] = {.lex_state = 281},
  [3114] = {.lex_state = 281},
  [3115] = {.lex_state = 281},
  [3116] = {.lex_state = 204},
  [3117] = {.lex_state = 281},
  [3118] = {.lex_state = 204},
  [3119] = {.lex_state = 281},
  [3120] = {.lex_state = 281},
  [3121] = {.lex_state = 281},
  [3122] = {.lex_state = 281},
  [3123] = {.lex_state = 281},
  [3124] = {.lex_state = 261},
  [3125] = {.lex_state = 281},
  [3126] = {.lex_state = 281},
  [3127] = {.lex_state = 281},
  [3128] = {.lex_state = 281},
  [3129] = {.lex_state = 281},
  [3130] = {.lex_state = 204},
  [3131] = {.lex_state = 204},
  [3132] = {.lex_state = 281},
  [3133] = {.lex_state = 204},
  [3134] = {.lex_state = 204},
  [3135] = {.lex_state = 260},
  [3136] = {.lex_state = 281},
  [3137] = {.lex_state = 260},
  [3138] = {.lex_state = 246},
  [3139] = {.lex_state = 281},
  [3140] = {.lex_state = 281},
  [3141] = {.lex_state = 204},
  [3142] = {.lex_state = 204},
  [3143] = {.lex_state = 216},
  [3144] = {.lex_state = 204},
  [3145] = {.lex_state = 246},
  [3146] = {.lex_state = 281},
  [3147] = {.lex_state = 276},
  [3148] = {.lex_state = 204},
  [3149] = {.lex_state = 281},
  [3150] = {.lex_state = 281},
  [3151] = {.lex_state = 260},
  [3152] = {.lex_state = 204},
  [3153] = {.lex_state = 261},
  [3154] = {.lex_state = 216},
  [3155] = {.lex_state = 258},
  [3156] = {.lex_state = 265},
  [3157] = {.lex_state = 260},
  [3158] = {.lex_state = 246},
  [3159] = {.lex_state = 260},
  [3160] = {.lex_state = 281},
  [3161] = {.lex_state = 260},
  [3162] = {.lex_state = 260},
  [3163] = {.lex_state = 272},
  [3164] = {.lex_state = 265},
  [3165] = {.lex_state = 260},
  [3166] = {.lex_state = 281},
  [3167] = {.lex_state = 258},
  [3168] = {.lex_state = 272},
  [3169] = {.lex_state = 246},
  [3170] = {.lex_state = 246},
  [3171] = {.lex_state = 258},
  [3172] = {.lex_state = 246},
  [3173] = {.lex_state = 272},
  [3174] = {.lex_state = 265},
  [3175] = {.lex_state = 281},
  [3176] = {.lex_state = 281},
  [3177] = {.lex_state = 272},
  [3178] = {.lex_state = 261},
  [3179] = {.lex_state = 260},
  [3180] = {.lex_state = 246},
  [3181] = {.lex_state = 246},
  [3182] = {.lex_state = 272},
  [3183] = {.lex_state = 246},
  [3184] = {.lex_state = 281},
  [3185] = {.lex_state = 246},
  [3186] = {.lex_state = 272},
  [3187] = {.lex_state = 246},
  [3188] = {.lex_state = 272},
  [3189] = {.lex_state = 246},
  [3190] = {.lex_state = 272},
  [3191] = {.lex_state = 266},
  [3192] = {.lex_state = 273},
  [3193] = {.lex_state = 246},
  [3194] = {.lex_state = 265},
  [3195] = {.lex_state = 272},
  [3196] = {.lex_state = 246},
  [3197] = {.lex_state = 265},
  [3198] = {.lex_state = 272},
  [3199] = {.lex_state = 272},
  [3200] = {.lex_state = 281},
  [3201] = {.lex_state = 273},
  [3202] = {.lex_state = 258},
  [3203] = {.lex_state = 265},
  [3204] = {.lex_state = 272},
  [3205] = {.lex_state = 281},
  [3206] = {.lex_state = 265},
  [3207] = {.lex_state = 266},
  [3208] = {.lex_state = 281},
  [3209] = {.lex_state = 234},
  [3210] = {.lex_state = 273},
  [3211] = {.lex_state = 281},
  [3212] = {.lex_state = 234},
  [3213] = {.lex_state = 234},
  [3214] = {.lex_state = 234},
  [3215] = {.lex_state = 260},
  [3216] = {.lex_state = 260},
  [3217] = {.lex_state = 234},
  [3218] = {.lex_state = 234},
  [3219] = {.lex_state = 226},
  [3220] = {.lex_state = 260},
  [3221] = {.lex_state = 260},
  [3222] = {.lex_state = 226},
  [3223] = {.lex_state = 281},
  [3224] = {.lex_state = 265},
  [3225] = {.lex_state = 260},
  [3226] = {.lex_state = 281},
  [3227] = {.lex_state = 281},
  [3228] = {.lex_state = 207},
  [3229] = {.lex_state = 245},
  [3230] = {.lex_state = 246},
  [3231] = {.lex_state = 234},
  [3232] = {.lex_state = 234},
  [3233] = {.lex_state = 273},
  [3234] = {.lex_state = 273},
  [3235] = {.lex_state = 234},
  [3236] = {.lex_state = 246},
  [3237] = {.lex_state = 273},
  [3238] = {.lex_state = 234},
  [3239] = {.lex_state = 246},
  [3240] = {.lex_state = 273},
  [3241] = {.lex_state = 265},
  [3242] = {.lex_state = 260},
  [3243] = {.lex_state = 234},
  [3244] = {.lex_state = 234},
  [3245] = {.lex_state = 234},
  [3246] = {.lex_state = 244},
  [3247] = {.lex_state = 260},
  [3248] = {.lex_state = 226},
  [3249] = {.lex_state = 260},
  [3250] = {.lex_state = 273},
  [3251] = {.lex_state = 246},
  [3252] = {.lex_state = 246},
  [3253] = {.lex_state = 244},
  [3254] = {.lex_state = 226},
  [3255] = {.lex_state = 281},
  [3256] = {.lex_state = 244},
  [3257] = {.lex_state = 281},
  [3258] = {.lex_state = 260},
  [3259] = {.lex_state = 281},
  [3260] = {.lex_state = 273},
  [3261] = {.lex_state = 244},
  [3262] = {.lex_state = 207},
  [3263] = {.lex_state = 226},
  [3264] = {.lex_state = 266},
  [3265] = {.lex_state = 246},
  [3266] = {.lex_state = 273},
  [3267] = {.lex_state = 273},
  [3268] = {.lex_state = 234},
  [3269] = {.lex_state = 226},
  [3270] = {.lex_state = 207},
  [3271] = {.lex_state = 226},
  [3272] = {.lex_state = 273},
  [3273] = {.lex_state = 234},
  [3274] = {.lex_state = 234},
  [3275] = {.lex_state = 245},
  [3276] = {.lex_state = 226},
  [3277] = {.lex_state = 273},
  [3278] = {.lex_state = 273},
  [3279] = {.lex_state = 273},
  [3280] = {.lex_state = 281},
  [3281] = {.lex_state = 226},
  [3282] = {.lex_state = 281},
  [3283] = {.lex_state = 265},
  [3284] = {.lex_state = 246},
  [3285] = {.lex_state = 234},
  [3286] = {.lex_state = 265},
  [3287] = {.lex_state = 260},
  [3288] = {.lex_state = 260},
  [3289] = {.lex_state = 207},
  [3290] = {.lex_state = 260},
  [3291] = {.lex_state = 246},
  [3292] = {.lex_state = 261},
  [3293] = {.lex_state = 246},
  [3294] = {.lex_state = 246},
  [3295] = {.lex_state = 261},
  [3296] = {.lex_state = 246},
  [3297] = {.lex_state = 244},
  [3298] = {.lex_state = 246},
  [3299] = {.lex_state = 246},
  [3300] = {.lex_state = 246},
  [3301] = {.lex_state = 273},
  [3302] = {.lex_state = 233},
  [3303] = {.lex_state = 246},
  [3304] = {.lex_state = 260},
  [3305] = {.lex_state = 246},
  [3306] = {.lex_state = 246},
  [3307] = {.lex_state = 284},
  [3308] = {.lex_state = 273},
  [3309] = {.lex_state = 260},
  [3310] = {.lex_state = 227},
  [3311] = {.lex_state = 246},
  [3312] = {.lex_state = 227},
  [3313] = {.lex_state = 260},
  [3314] = {.lex_state = 260},
  [3315] = {.lex_state = 260},
  [3316] = {.lex_state = 246},
  [3317] = {.lex_state = 246},
  [3318] = {.lex_state = 273},
  [3319] = {.lex_state = 246},
  [3320] = {.lex_state = 246},
  [3321] = {.lex_state = 260},
  [3322] = {.lex_state = 246},
  [3323] = {.lex_state = 233},
  [3324] = {.lex_state = 246},
  [3325] = {.lex_state = 233},
  [3326] = {.lex_state = 246},
  [3327] = {.lex_state = 273},
  [3328] = {.lex_state = 281},
  [3329] = {.lex_state = 246},
  [3330] = {.lex_state = 246},
  [3331] = {.lex_state = 282},
  [3332] = {.lex_state = 260},
  [3333] = {.lex_state = 233},
  [3334] = {.lex_state = 246},
  [3335] = {.lex_state = 265},
  [3336] = {.lex_state = 273},
  [3337] = {.lex_state = 246},
  [3338] = {.lex_state = 282},
  [3339] = {.lex_state = 233},
  [3340] = {.lex_state = 246},
  [3341] = {.lex_state = 244},
  [3342] = {.lex_state = 233},
  [3343] = {.lex_state = 273},
  [3344] = {.lex_state = 246},
  [3345] = {.lex_state = 246},
  [3346] = {.lex_state = 246},
  [3347] = {.lex_state = 233},
  [3348] = {.lex_state = 246},
  [3349] = {.lex_state = 265},
  [3350] = {.lex_state = 227},
  [3351] = {.lex_state = 227},
  [3352] = {.lex_state = 246},
  [3353] = {.lex_state = 260},
  [3354] = {.lex_state = 246},
  [3355] = {.lex_state = 246},
  [3356] = {.lex_state = 260},
  [3357] = {.lex_state = 246},
  [3358] = {.lex_state = 260},
  [3359] = {.lex_state = 260},
  [3360] = {.lex_state = 260},
  [3361] = {.lex_state = 260},
  [3362] = {.lex_state = 273},
  [3363] = {.lex_state = 246},
  [3364] = {.lex_state = 245},
  [3365] = {.lex_state = 260},
  [3366] = {.lex_state = 260},
  [3367] = {.lex_state = 281},
  [3368] = {.lex_state = 246},
  [3369] = {.lex_state = 246},
  [3370] = {.lex_state = 260},
  [3371] = {.lex_state = 260},
  [3372] = {.lex_state = 260},
  [3373] = {.lex_state = 272},
  [3374] = {.lex_state = 378},
  [3375] = {.lex_state = 260},
  [3376] = {.lex_state = 260},
  [3377] = {.lex_state = 260},
  [3378] = {.lex_state = 246},
  [3379] = {.lex_state = 260},
  [3380] = {.lex_state = 284},
  [3381] = {.lex_state = 244},
  [3382] = {.lex_state = 260},
  [3383] = {.lex_state = 272},
  [3384] = {.lex_state = 246},
  [3385] = {.lex_state = 260},
  [3386] = {.lex_state = 281},
  [3387] = {.lex_state = 246},
  [3388] = {.lex_state = 246},
  [3389] = {.lex_state = 273},
  [3390] = {.lex_state = 260},
  [3391] = {.lex_state = 273},
  [3392] = {.lex_state = 273},
  [3393] = {.lex_state = 273},
  [3394] = {.lex_state = 273},
  [3395] = {.lex_state = 245},
  [3396] = {.lex_state = 265},
  [3397] = {.lex_state = 273},
  [3398] = {.lex_state = 273},
  [3399] = {.lex_state = 234},
  [3400] = {.lex_state = 265},
  [3401] = {.lex_state = 265},
  [3402] = {.lex_state = 273},
  [3403] = {.lex_state = 226},
  [3404] = {.lex_state = 234},
  [3405] = {.lex_state = 265},
  [3406] = {.lex_state = 265},
  [3407] = {.lex_state = 265},
  [3408] = {.lex_state = 245},
  [3409] = {.lex_state = 231},
  [3410] = {.lex_state = 273},
  [3411] = {.lex_state = 246},
  [3412] = {.lex_state = 273},
  [3413] = {.lex_state = 273},
  [3414] = {.lex_state = 260},
  [3415] = {.lex_state = 273},
  [3416] = {.lex_state = 260},
  [3417] = {.lex_state = 273},
  [3418] = {.lex_state = 273},
  [3419] = {.lex_state = 260},
  [3420] = {.lex_state = 234},
  [3421] = {.lex_state = 273},
  [3422] = {.lex_state = 246},
  [3423] = {.lex_state = 234},
  [3424] = {.lex_state = 246},
  [3425] = {.lex_state = 260},
  [3426] = {.lex_state = 246},
  [3427] = {.lex_state = 231},
  [3428] = {.lex_state = 273},
  [3429] = {.lex_state = 273},
  [3430] = {.lex_state = 273},
  [3431] = {.lex_state = 273},
  [3432] = {.lex_state = 273},
  [3433] = {.lex_state = 260},
  [3434] = {.lex_state = 273},
  [3435] = {.lex_state = 273},
  [3436] = {.lex_state = 273},
  [3437] = {.lex_state = 265},
  [3438] = {.lex_state = 246},
  [3439] = {.lex_state = 273},
  [3440] = {.lex_state = 273},
  [3441] = {.lex_state = 273},
  [3442] = {.lex_state = 273},
  [3443] = {.lex_state = 246},
  [3444] = {.lex_state = 246},
  [3445] = {.lex_state = 273},
  [3446] = {.lex_state = 273},
  [3447] = {.lex_state = 273},
  [3448] = {.lex_state = 265},
  [3449] = {.lex_state = 273},
  [3450] = {.lex_state = 245},
  [3451] = {.lex_state = 246},
  [3452] = {.lex_state = 273},
  [3453] = {.lex_state = 234},
  [3454] = {.lex_state = 246},
  [3455] = {.lex_state = 246},
  [3456] = {.lex_state = 246},
  [3457] = {.lex_state = 234},
  [3458] = {.lex_state = 246},
  [3459] = {.lex_state = 246},
  [3460] = {.lex_state = 246},
  [3461] = {.lex_state = 246},
  [3462] = {.lex_state = 265},
  [3463] = {.lex_state = 226},
  [3464] = {.lex_state = 246},
  [3465] = {.lex_state = 246},
  [3466] = {.lex_state = 246},
  [3467] = {.lex_state = 260},
  [3468] = {.lex_state = 265},
  [3469] = {.lex_state = 260},
  [3470] = {.lex_state = 231},
  [3471] = {.lex_state = 227},
  [3472] = {.lex_state = 226},
  [3473] = {.lex_state = 246},
  [3474] = {.lex_state = 261},
  [3475] = {.lex_state = 281},
  [3476] = {.lex_state = 226},
  [3477] = {.lex_state = 231},
  [3478] = {.lex_state = 282},
  [3479] = {.lex_state = 281},
  [3480] = {.lex_state = 246},
  [3481] = {.lex_state = 260},
  [3482] = {.lex_state = 226},
  [3483] = {.lex_state = 260},
  [3484] = {.lex_state = 204},
  [3485] = {.lex_state = 260},
  [3486] = {.lex_state = 231},
  [3487] = {.lex_state = 226},
  [3488] = {.lex_state = 260},
  [3489] = {.lex_state = 244},
  [3490] = {.lex_state = 265},
  [3491] = {.lex_state = 234},
  [3492] = {.lex_state = 265},
  [3493] = {.lex_state = 226},
  [3494] = {.lex_state = 273},
  [3495] = {.lex_state = 227},
  [3496] = {.lex_state = 234},
  [3497] = {.lex_state = 246},
  [3498] = {.lex_state = 234},
  [3499] = {.lex_state = 234},
  [3500] = {.lex_state = 234},
  [3501] = {.lex_state = 234},
  [3502] = {.lex_state = 234},
  [3503] = {.lex_state = 234},
  [3504] = {.lex_state = 227},
  [3505] = {.lex_state = 234},
  [3506] = {.lex_state = 234},
  [3507] = {.lex_state = 246},
  [3508] = {.lex_state = 227},
  [3509] = {.lex_state = 234},
  [3510] = {.lex_state = 260},
  [3511] = {.lex_state = 226},
  [3512] = {.lex_state = 260},
  [3513] = {.lex_state = 234},
  [3514] = {.lex_state = 260},
  [3515] = {.lex_state = 246},
  [3516] = {.lex_state = 226},
  [3517] = {.lex_state = 260},
  [3518] = {.lex_state = 246},
  [3519] = {.lex_state = 260},
  [3520] = {.lex_state = 282},
  [3521] = {.lex_state = 260},
  [3522] = {.lex_state = 246},
  [3523] = {.lex_state = 260},
  [3524] = {.lex_state = 260},
  [3525] = {.lex_state = 246},
  [3526] = {.lex_state = 244},
  [3527] = {.lex_state = 244},
  [3528] = {.lex_state = 244},
  [3529] = {.lex_state = 237},
  [3530] = {.lex_state = 246},
  [3531] = {.lex_state = 245},
  [3532] = {.lex_state = 282},
  [3533] = {.lex_state = 237},
  [3534] = {.lex_state = 282},
  [3535] = {.lex_state = 260},
  [3536] = {.lex_state = 260},
  [3537] = {.lex_state = 260},
  [3538] = {.lex_state = 260},
  [3539] = {.lex_state = 281},
  [3540] = {.lex_state = 246},
  [3541] = {.lex_state = 246},
  [3542] = {.lex_state = 246},
  [3543] = {.lex_state = 268},
  [3544] = {.lex_state = 240},
  [3545] = {.lex_state = 240},
  [3546] = {.lex_state = 244},
  [3547] = {.lex_state = 244},
  [3548] = {.lex_state = 246},
  [3549] = {.lex_state = 260},
  [3550] = {.lex_state = 260},
  [3551] = {.lex_state = 260},
  [3552] = {.lex_state = 197},
  [3553] = {.lex_state = 260},
  [3554] = {.lex_state = 282},
  [3555] = {.lex_state = 260},
  [3556] = {.lex_state = 282},
  [3557] = {.lex_state = 197},
  [3558] = {.lex_state = 260},
  [3559] = {.lex_state = 265},
  [3560] = {.lex_state = 244},
  [3561] = {.lex_state = 260},
  [3562] = {.lex_state = 282},
  [3563] = {.lex_state = 265},
  [3564] = {.lex_state = 260},
  [3565] = {.lex_state = 260},
  [3566] = {.lex_state = 260},
  [3567] = {.lex_state = 281},
  [3568] = {.lex_state = 231},
  [3569] = {.lex_state = 246},
  [3570] = {.lex_state = 260},
  [3571] = {.lex_state = 260},
  [3572] = {.lex_state = 265},
  [3573] = {.lex_state = 260},
  [3574] = {.lex_state = 260},
  [3575] = {.lex_state = 248},
  [3576] = {.lex_state = 244},
  [3577] = {.lex_state = 282},
  [3578] = {.lex_state = 282},
  [3579] = {.lex_state = 244},
  [3580] = {.lex_state = 244},
  [3581] = {.lex_state = 281},
  [3582] = {.lex_state = 281},
  [3583] = {.lex_state = 282},
  [3584] = {.lex_state = 244},
  [3585] = {.lex_state = 244},
  [3586] = {.lex_state = 231},
  [3587] = {.lex_state = 244},
  [3588] = {.lex_state = 284},
  [3589] = {.lex_state = 260},
  [3590] = {.lex_state = 260},
  [3591] = {.lex_state = 265},
  [3592] = {.lex_state = 260},
  [3593] = {.lex_state = 260},
  [3594] = {.lex_state = 230},
  [3595] = {.lex_state = 197},
  [3596] = {.lex_state = 260},
  [3597] = {.lex_state = 265},
  [3598] = {.lex_state = 268},
  [3599] = {.lex_state = 282},
  [3600] = {.lex_state = 240},
  [3601] = {.lex_state = 244},
  [3602] = {.lex_state = 282},
  [3603] = {.lex_state = 260},
  [3604] = {.lex_state = 260},
  [3605] = {.lex_state = 260},
  [3606] = {.lex_state = 244},
  [3607] = {.lex_state = 260},
  [3608] = {.lex_state = 207},
  [3609] = {.lex_state = 207},
  [3610] = {.lex_state = 244},
  [3611] = {.lex_state = 197},
  [3612] = {.lex_state = 282},
  [3613] = {.lex_state = 268},
  [3614] = {.lex_state = 260},
  [3615] = {.lex_state = 240},
  [3616] = {.lex_state = 260},
  [3617] = {.lex_state = 244},
  [3618] = {.lex_state = 197},
  [3619] = {.lex_state = 246},
  [3620] = {.lex_state = 197},
  [3621] = {.lex_state = 284},
  [3622] = {.lex_state = 265},
  [3623] = {.lex_state = 231},
  [3624] = {.lex_state = 282},
  [3625] = {.lex_state = 260},
  [3626] = {.lex_state = 260},
  [3627] = {.lex_state = 265},
  [3628] = {.lex_state = 260},
  [3629] = {.lex_state = 268},
  [3630] = {.lex_state = 244},
  [3631] = {.lex_state = 260},
  [3632] = {.lex_state = 197},
  [3633] = {.lex_state = 282},
  [3634] = {.lex_state = 265},
  [3635] = {.lex_state = 265},
  [3636] = {.lex_state = 260},
  [3637] = {.lex_state = 260},
  [3638] = {.lex_state = 260},
  [3639] = {.lex_state = 260},
  [3640] = {.lex_state = 246},
  [3641] = {.lex_state = 246},
  [3642] = {.lex_state = 265},
  [3643] = {.lex_state = 260},
  [3644] = {.lex_state = 265},
  [3645] = {.lex_state = 246},
  [3646] = {.lex_state = 260},
  [3647] = {.lex_state = 265},
  [3648] = {.lex_state = 246},
  [3649] = {.lex_state = 265},
  [3650] = {.lex_state = 265},
  [3651] = {.lex_state = 246},
  [3652] = {.lex_state = 260},
  [3653] = {.lex_state = 265},
  [3654] = {.lex_state = 265},
  [3655] = {.lex_state = 265},
  [3656] = {.lex_state = 265},
  [3657] = {.lex_state = 265},
  [3658] = {.lex_state = 265},
  [3659] = {.lex_state = 265},
  [3660] = {.lex_state = 265},
  [3661] = {.lex_state = 265},
  [3662] = {.lex_state = 246},
  [3663] = {.lex_state = 265},
  [3664] = {.lex_state = 281},
  [3665] = {.lex_state = 260},
  [3666] = {.lex_state = 246},
  [3667] = {.lex_state = 265},
  [3668] = {.lex_state = 260},
  [3669] = {.lex_state = 265},
  [3670] = {.lex_state = 260},
  [3671] = {.lex_state = 260},
  [3672] = {.lex_state = 246},
  [3673] = {.lex_state = 265},
  [3674] = {.lex_state = 272},
  [3675] = {.lex_state = 260},
  [3676] = {.lex_state = 282},
  [3677] = {.lex_state = 246},
  [3678] = {.lex_state = 246},
  [3679] = {.lex_state = 265},
  [3680] = {.lex_state = 260},
  [3681] = {.lex_state = 265},
  [3682] = {.lex_state = 231},
  [3683] = {.lex_state = 260},
  [3684] = {.lex_state = 265},
  [3685] = {.lex_state = 265},
  [3686] = {.lex_state = 265},
  [3687] = {.lex_state = 260},
  [3688] = {.lex_state = 268},
  [3689] = {.lex_state = 265},
  [3690] = {.lex_state = 260},
  [3691] = {.lex_state = 246},
  [3692] = {.lex_state = 265},
  [3693] = {.lex_state = 246},
  [3694] = {.lex_state = 260},
  [3695] = {.lex_state = 260},
  [3696] = {.lex_state = 260},
  [3697] = {.lex_state = 281},
  [3698] = {.lex_state = 246},
  [3699] = {.lex_state = 282},
  [3700] = {.lex_state = 246},
  [3701] = {.lex_state = 260},
  [3702] = {.lex_state = 281},
  [3703] = {.lex_state = 246},
  [3704] = {.lex_state = 246},
  [3705] = {.lex_state = 282},
  [3706] = {.lex_state = 282},
  [3707] = {.lex_state = 246},
  [3708] = {.lex_state = 260},
  [3709] = {.lex_state = 246},
  [3710] = {.lex_state = 246},
  [3711] = {.lex_state = 246},
  [3712] = {.lex_state = 260},
  [3713] = {.lex_state = 246},
  [3714] = {.lex_state = 281},
  [3715] = {.lex_state = 260},
  [3716] = {.lex_state = 246},
  [3717] = {.lex_state = 260},
  [3718] = {.lex_state = 281},
  [3719] = {.lex_state = 260},
  [3720] = {.lex_state = 246},
  [3721] = {.lex_state = 265},
  [3722] = {.lex_state = 260},
  [3723] = {.lex_state = 260},
  [3724] = {.lex_state = 246},
  [3725] = {.lex_state = 281},
  [3726] = {.lex_state = 260},
  [3727] = {.lex_state = 281},
  [3728] = {.lex_state = 260},
  [3729] = {.lex_state = 237},
  [3730] = {.lex_state = 265},
  [3731] = {.lex_state = 246},
  [3732] = {.lex_state = 265},
  [3733] = {.lex_state = 265},
  [3734] = {.lex_state = 281},
  [3735] = {.lex_state = 246},
  [3736] = {.lex_state = 246},
  [3737] = {.lex_state = 246},
  [3738] = {.lex_state = 237},
  [3739] = {.lex_state = 265},
  [3740] = {.lex_state = 246},
  [3741] = {.lex_state = 246},
  [3742] = {.lex_state = 246},
  [3743] = {.lex_state = 281},
  [3744] = {.lex_state = 281},
  [3745] = {.lex_state = 246},
  [3746] = {.lex_state = 265},
  [3747] = {.lex_state = 265},
  [3748] = {.lex_state = 281},
  [3749] = {.lex_state = 246},
  [3750] = {.lex_state = 244},
  [3751] = {.lex_state = 246},
  [3752] = {.lex_state = 281},
  [3753] = {.lex_state = 260},
  [3754] = {.lex_state = 246},
  [3755] = {.lex_state = 265},
  [3756] = {.lex_state = 260},
  [3757] = {.lex_state = 246},
  [3758] = {.lex_state = 281},
  [3759] = {.lex_state = 246},
  [3760] = {.lex_state = 246},
  [3761] = {.lex_state = 246},
  [3762] = {.lex_state = 246},
  [3763] = {.lex_state = 246},
  [3764] = {.lex_state = 246},
  [3765] = {.lex_state = 244},
  [3766] = {.lex_state = 246},
  [3767] = {.lex_state = 246},
  [3768] = {.lex_state = 246},
  [3769] = {.lex_state = 246},
  [3770] = {.lex_state = 246},
  [3771] = {.lex_state = 246},
  [3772] = {.lex_state = 246},
  [3773] = {.lex_state = 265},
  [3774] = {.lex_state = 246},
  [3775] = {.lex_state = 246},
  [3776] = {.lex_state = 246},
  [3777] = {.lex_state = 246},
  [3778] = {.lex_state = 246},
  [3779] = {.lex_state = 281},
  [3780] = {.lex_state = 246},
  [3781] = {.lex_state = 246},
  [3782] = {.lex_state = 212},
  [3783] = {.lex_state = 246},
  [3784] = {.lex_state = 246},
  [3785] = {.lex_state = 246},
  [3786] = {.lex_state = 231},
  [3787] = {.lex_state = 246},
  [3788] = {.lex_state = 265},
  [3789] = {.lex_state = 260},
  [3790] = {.lex_state = 260},
  [3791] = {.lex_state = 234},
  [3792] = {.lex_state = 246},
  [3793] = {.lex_state = 234},
  [3794] = {.lex_state = 246},
  [3795] = {.lex_state = 234},
  [3796] = {.lex_state = 268},
  [3797] = {.lex_state = 234},
  [3798] = {.lex_state = 234},
  [3799] = {.lex_state = 234},
  [3800] = {.lex_state = 234},
  [3801] = {.lex_state = 234},
  [3802] = {.lex_state = 234},
  [3803] = {.lex_state = 260},
  [3804] = {.lex_state = 234},
  [3805] = {.lex_state = 234},
  [3806] = {.lex_state = 234},
  [3807] = {.lex_state = 260},
  [3808] = {.lex_state = 234},
  [3809] = {.lex_state = 260},
  [3810] = {.lex_state = 234},
  [3811] = {.lex_state = 234},
  [3812] = {.lex_state = 260},
  [3813] = {.lex_state = 246},
  [3814] = {.lex_state = 246},
  [3815] = {.lex_state = 246},
  [3816] = {.lex_state = 260},
  [3817] = {.lex_state = 265},
  [3818] = {.lex_state = 246},
  [3819] = {.lex_state = 260},
  [3820] = {.lex_state = 260},
  [3821] = {.lex_state = 234},
  [3822] = {.lex_state = 234},
  [3823] = {.lex_state = 265},
  [3824] = {.lex_state = 282},
  [3825] = {.lex_state = 265},
  [3826] = {.lex_state = 260},
  [3827] = {.lex_state = 246},
  [3828] = {.lex_state = 246},
  [3829] = {.lex_state = 246},
  [3830] = {.lex_state = 230},
  [3831] = {.lex_state = 246},
  [3832] = {.lex_state = 246},
  [3833] = {.lex_state = 246},
  [3834] = {.lex_state = 207},
  [3835] = {.lex_state = 246},
  [3836] = {.lex_state = 381},
  [3837] = {.lex_state = 246},
  [3838] = {.lex_state = 212},
  [3839] = {.lex_state = 267},
  [3840] = {.lex_state = 282},
  [3841] = {.lex_state = 212},
  [3842] = {.lex_state = 246},
  [3843] = {.lex_state = 246},
  [3844] = {.lex_state = 207},
  [3845] = {.lex_state = 246},
  [3846] = {.lex_state = 260},
  [3847] = {.lex_state = 246},
  [3848] = {.lex_state = 260},
  [3849] = {.lex_state = 246},
  [3850] = {.lex_state = 262},
  [3851] = {.lex_state = 260},
  [3852] = {.lex_state = 246},
  [3853] = {.lex_state = 246},
  [3854] = {.lex_state = 246},
  [3855] = {.lex_state = 246},
  [3856] = {.lex_state = 282},
  [3857] = {.lex_state = 234},
  [3858] = {.lex_state = 265},
  [3859] = {.lex_state = 265},
  [3860] = {.lex_state = 265},
  [3861] = {.lex_state = 231},
  [3862] = {.lex_state = 260},
  [3863] = {.lex_state = 237},
  [3864] = {.lex_state = 231},
  [3865] = {.lex_state = 265},
  [3866] = {.lex_state = 265},
  [3867] = {.lex_state = 237},
  [3868] = {.lex_state = 260},
  [3869] = {.lex_state = 237},
  [3870] = {.lex_state = 281},
  [3871] = {.lex_state = 237},
  [3872] = {.lex_state = 212},
  [3873] = {.lex_state = 212},
  [3874] = {.lex_state = 234},
  [3875] = {.lex_state = 237},
  [3876] = {.lex_state = 234},
  [3877] = {.lex_state = 244},
  [3878] = {.lex_state = 260},
  [3879] = {.lex_state = 244},
  [3880] = {.lex_state = 281},
  [3881] = {.lex_state = 227},
  [3882] = {.lex_state = 260},
  [3883] = {.lex_state = 281},
  [3884] = {.lex_state = 281},
  [3885] = {.lex_state = 244},
  [3886] = {.lex_state = 253},
  [3887] = {.lex_state = 253},
  [3888] = {.lex_state = 260},
  [3889] = {.lex_state = 231},
  [3890] = {.lex_state = 231},
  [3891] = {.lex_state = 260},
  [3892] = {.lex_state = 227},
  [3893] = {.lex_state = 281},
  [3894] = {.lex_state = 260},
  [3895] = {.lex_state = 227},
  [3896] = {.lex_state = 231},
  [3897] = {.lex_state = 227},
  [3898] = {.lex_state = 234},
  [3899] = {.lex_state = 265},
  [3900] = {.lex_state = 234},
  [3901] = {.lex_state = 234},
  [3902] = {.lex_state = 237},
  [3903] = {.lex_state = 234},
  [3904] = {.lex_state = 234},
  [3905] = {.lex_state = 237},
  [3906] = {.lex_state = 234},
  [3907] = {.lex_state = 237},
  [3908] = {.lex_state = 260},
  [3909] = {.lex_state = 234},
  [3910] = {.lex_state = 234},
  [3911] = {.lex_state = 244},
  [3912] = {.lex_state = 265},
  [3913] = {.lex_state = 231},
  [3914] = {.lex_state = 231},
  [3915] = {.lex_state = 231},
  [3916] = {.lex_state = 231},
  [3917] = {.lex_state = 231},
  [3918] = {.lex_state = 231},
  [3919] = {.lex_state = 231},
  [3920] = {.lex_state = 234},
  [3921] = {.lex_state = 234},
  [3922] = {.lex_state = 260},
  [3923] = {.lex_state = 234},
  [3924] = {.lex_state = 237},
  [3925] = {.lex_state = 234},
  [3926] = {.lex_state = 234},
  [3927] = {.lex_state = 243},
  [3928] = {.lex_state = 234},
  [3929] = {.lex_state = 207},
  [3930] = {.lex_state = 265},
  [3931] = {.lex_state = 231},
  [3932] = {.lex_state = 234},
  [3933] = {.lex_state = 231},
  [3934] = {.lex_state = 231},
  [3935] = {.lex_state = 234},
  [3936] = {.lex_state = 231},
  [3937] = {.lex_state = 231},
  [3938] = {.lex_state = 281},
  [3939] = {.lex_state = 234},
  [3940] = {.lex_state = 234},
  [3941] = {.lex_state = 237},
  [3942] = {.lex_state = 207},
  [3943] = {.lex_state = 260},
  [3944] = {.lex_state = 234},
  [3945] = {.lex_state = 234},
  [3946] = {.lex_state = 234},
  [3947] = {.lex_state = 260},
  [3948] = {.lex_state = 234},
  [3949] = {.lex_state = 260},
  [3950] = {.lex_state = 226},
  [3951] = {.lex_state = 260},
  [3952] = {.lex_state = 207},
  [3953] = {.lex_state = 238},
  [3954] = {.lex_state = 260},
  [3955] = {.lex_state = 231},
  [3956] = {.lex_state = 260},
  [3957] = {.lex_state = 260},
  [3958] = {.lex_state = 237},
  [3959] = {.lex_state = 260},
  [3960] = {.lex_state = 265},
  [3961] = {.lex_state = 265},
  [3962] = {.lex_state = 265},
  [3963] = {.lex_state = 265},
  [3964] = {.lex_state = 265},
  [3965] = {.lex_state = 265},
  [3966] = {.lex_state = 265},
  [3967] = {.lex_state = 265},
  [3968] = {.lex_state = 265},
  [3969] = {.lex_state = 265},
  [3970] = {.lex_state = 260},
  [3971] = {.lex_state = 265},
  [3972] = {.lex_state = 260},
  [3973] = {.lex_state = 265},
  [3974] = {.lex_state = 231},
  [3975] = {.lex_state = 260},
  [3976] = {.lex_state = 237},
  [3977] = {.lex_state = 237},
  [3978] = {.lex_state = 237},
  [3979] = {.lex_state = 237},
  [3980] = {.lex_state = 234},
  [3981] = {.lex_state = 231},
  [3982] = {.lex_state = 237},
  [3983] = {.lex_state = 281},
  [3984] = {.lex_state = 231},
  [3985] = {.lex_state = 231},
  [3986] = {.lex_state = 265},
  [3987] = {.lex_state = 265},
  [3988] = {.lex_state = 237},
  [3989] = {.lex_state = 237},
  [3990] = {.lex_state = 265},
  [3991] = {.lex_state = 237},
  [3992] = {.lex_state = 260},
  [3993] = {.lex_state = 237},
  [3994] = {.lex_state = 231},
  [3995] = {.lex_state = 231},
  [3996] = {.lex_state = 231},
  [3997] = {.lex_state = 231},
  [3998] = {.lex_state = 260},
  [3999] = {.lex_state = 231},
  [4000] = {.lex_state = 226},
  [4001] = {.lex_state = 281},
  [4002] = {.lex_state = 234},
  [4003] = {.lex_state = 281},
  [4004] = {.lex_state = 253},
  [4005] = {.lex_state = 260},
  [4006] = {.lex_state = 237},
  [4007] = {.lex_state = 237},
  [4008] = {.lex_state = 237},
  [4009] = {.lex_state = 265},
  [4010] = {.lex_state = 231},
  [4011] = {.lex_state = 231},
  [4012] = {.lex_state = 260},
  [4013] = {.lex_state = 244},
  [4014] = {.lex_state = 244},
  [4015] = {.lex_state = 265},
  [4016] = {.lex_state = 265},
  [4017] = {.lex_state = 237},
  [4018] = {.lex_state = 253},
  [4019] = {.lex_state = 260},
  [4020] = {.lex_state = 264},
  [4021] = {.lex_state = 265},
  [4022] = {.lex_state = 281},
  [4023] = {.lex_state = 237},
  [4024] = {.lex_state = 265},
  [4025] = {.lex_state = 218},
  [4026] = {.lex_state = 260},
  [4027] = {.lex_state = 381},
  [4028] = {.lex_state = 207},
  [4029] = {.lex_state = 260},
  [4030] = {.lex_state = 260},
  [4031] = {.lex_state = 268},
  [4032] = {.lex_state = 260},
  [4033] = {.lex_state = 260},
  [4034] = {.lex_state = 260},
  [4035] = {.lex_state = 260},
  [4036] = {.lex_state = 260},
  [4037] = {.lex_state = 260},
  [4038] = {.lex_state = 260},
  [4039] = {.lex_state = 260},
  [4040] = {.lex_state = 282},
  [4041] = {.lex_state = 260},
  [4042] = {.lex_state = 268},
  [4043] = {.lex_state = 218},
  [4044] = {.lex_state = 238},
  [4045] = {.lex_state = 260},
  [4046] = {.lex_state = 268},
  [4047] = {.lex_state = 260},
  [4048] = {.lex_state = 268},
  [4049] = {.lex_state = 260},
  [4050] = {.lex_state = 260},
  [4051] = {.lex_state = 260},
  [4052] = {.lex_state = 260},
  [4053] = {.lex_state = 260},
  [4054] = {.lex_state = 238},
  [4055] = {.lex_state = 268},
  [4056] = {.lex_state = 237},
  [4057] = {.lex_state = 281},
  [4058] = {.lex_state = 260},
  [4059] = {.lex_state = 260},
  [4060] = {.lex_state = 265},
  [4061] = {.lex_state = 260},
  [4062] = {.lex_state = 260},
  [4063] = {.lex_state = 238},
  [4064] = {.lex_state = 260},
  [4065] = {.lex_state = 260},
  [4066] = {.lex_state = 260},
  [4067] = {.lex_state = 260},
  [4068] = {.lex_state = 260},
  [4069] = {.lex_state = 268},
  [4070] = {.lex_state = 260},
  [4071] = {.lex_state = 268},
  [4072] = {.lex_state = 268},
  [4073] = {.lex_state = 238},
  [4074] = {.lex_state = 260},
  [4075] = {.lex_state = 281},
  [4076] = {.lex_state = 282},
  [4077] = {.lex_state = 238},
  [4078] = {.lex_state = 260},
  [4079] = {.lex_state = 238},
  [4080] = {.lex_state = 260},
  [4081] = {.lex_state = 260},
  [4082] = {.lex_state = 260},
  [4083] = {.lex_state = 260},
  [4084] = {.lex_state = 260},
  [4085] = {.lex_state = 260},
  [4086] = {.lex_state = 260},
  [4087] = {.lex_state = 260},
  [4088] = {.lex_state = 260},
  [4089] = {.lex_state = 260},
  [4090] = {.lex_state = 207},
  [4091] = {.lex_state = 260},
  [4092] = {.lex_state = 268},
  [4093] = {.lex_state = 260},
  [4094] = {.lex_state = 260},
  [4095] = {.lex_state = 260},
  [4096] = {.lex_state = 260},
  [4097] = {.lex_state = 260},
  [4098] = {.lex_state = 260},
  [4099] = {.lex_state = 281},
  [4100] = {.lex_state = 268},
  [4101] = {.lex_state = 260},
  [4102] = {.lex_state = 243},
  [4103] = {.lex_state = 260},
  [4104] = {.lex_state = 260},
  [4105] = {.lex_state = 243},
  [4106] = {.lex_state = 260},
  [4107] = {.lex_state = 260},
  [4108] = {.lex_state = 260},
  [4109] = {.lex_state = 254},
  [4110] = {.lex_state = 268},
  [4111] = {.lex_state = 260},
  [4112] = {.lex_state = 281},
  [4113] = {.lex_state = 260},
  [4114] = {.lex_state = 260},
  [4115] = {.lex_state = 260},
  [4116] = {.lex_state = 260},
  [4117] = {.lex_state = 238},
  [4118] = {.lex_state = 268},
  [4119] = {.lex_state = 260},
  [4120] = {.lex_state = 260},
  [4121] = {.lex_state = 207},
  [4122] = {.lex_state = 381},
  [4123] = {.lex_state = 237},
  [4124] = {.lex_state = 260},
  [4125] = {.lex_state = 260},
  [4126] = {.lex_state = 265},
  [4127] = {.lex_state = 260},
  [4128] = {.lex_state = 238},
  [4129] = {.lex_state = 260},
  [4130] = {.lex_state = 281},
  [4131] = {.lex_state = 281},
  [4132] = {.lex_state = 381},
  [4133] = {.lex_state = 260},
  [4134] = {.lex_state = 260},
  [4135] = {.lex_state = 237},
  [4136] = {.lex_state = 260},
  [4137] = {.lex_state = 238},
  [4138] = {.lex_state = 254},
  [4139] = {.lex_state = 260},
  [4140] = {.lex_state = 207},
  [4141] = {.lex_state = 260},
  [4142] = {.lex_state = 281},
  [4143] = {.lex_state = 260},
  [4144] = {.lex_state = 260},
  [4145] = {.lex_state = 218},
  [4146] = {.lex_state = 260},
  [4147] = {.lex_state = 238},
  [4148] = {.lex_state = 238},
  [4149] = {.lex_state = 238},
  [4150] = {.lex_state = 260},
  [4151] = {.lex_state = 260},
  [4152] = {.lex_state = 260},
  [4153] = {.lex_state = 238},
  [4154] = {.lex_state = 260},
  [4155] = {.lex_state = 260},
  [4156] = {.lex_state = 260},
  [4157] = {.lex_state = 260},
  [4158] = {.lex_state = 260},
  [4159] = {.lex_state = 270},
  [4160] = {.lex_state = 260},
  [4161] = {.lex_state = 238},
  [4162] = {.lex_state = 238},
  [4163] = {.lex_state = 265},
  [4164] = {.lex_state = 260},
  [4165] = {.lex_state = 260},
  [4166] = {.lex_state = 260},
  [4167] = {.lex_state = 260},
  [4168] = {.lex_state = 265},
  [4169] = {.lex_state = 260},
  [4170] = {.lex_state = 260},
  [4171] = {.lex_state = 260},
  [4172] = {.lex_state = 260},
  [4173] = {.lex_state = 260},
  [4174] = {.lex_state = 281},
  [4175] = {.lex_state = 260},
  [4176] = {.lex_state = 260},
  [4177] = {.lex_state = 234},
  [4178] = {.lex_state = 260},
  [4179] = {.lex_state = 268},
  [4180] = {.lex_state = 226},
  [4181] = {.lex_state = 260},
  [4182] = {.lex_state = 260},
  [4183] = {.lex_state = 260},
  [4184] = {.lex_state = 260},
  [4185] = {.lex_state = 260},
  [4186] = {.lex_state = 281},
  [4187] = {.lex_state = 260},
  [4188] = {.lex_state = 260},
  [4189] = {.lex_state = 260},
  [4190] = {.lex_state = 260},
  [4191] = {.lex_state = 260},
  [4192] = {.lex_state = 260},
  [4193] = {.lex_state = 260},
  [4194] = {.lex_state = 260},
  [4195] = {.lex_state = 260},
  [4196] = {.lex_state = 260},
  [4197] = {.lex_state = 260},
  [4198] = {.lex_state = 238},
  [4199] = {.lex_state = 260},
  [4200] = {.lex_state = 260},
  [4201] = {.lex_state = 234},
  [4202] = {.lex_state = 260},
  [4203] = {.lex_state = 260},
  [4204] = {.lex_state = 254},
  [4205] = {.lex_state = 254},
  [4206] = {.lex_state = 260},
  [4207] = {.lex_state = 260},
  [4208] = {.lex_state = 260},
  [4209] = {.lex_state = 268},
  [4210] = {.lex_state = 268},
  [4211] = {.lex_state = 281},
  [4212] = {.lex_state = 268},
  [4213] = {.lex_state = 268},
  [4214] = {.lex_state = 260},
  [4215] = {.lex_state = 260},
  [4216] = {.lex_state = 281},
  [4217] = {.lex_state = 260},
  [4218] = {.lex_state = 238},
  [4219] = {.lex_state = 281},
  [4220] = {.lex_state = 260},
  [4221] = {.lex_state = 265},
  [4222] = {.lex_state = 265},
  [4223] = {.lex_state = 260},
  [4224] = {.lex_state = 265},
  [4225] = {.lex_state = 265},
  [4226] = {.lex_state = 265},
  [4227] = {.lex_state = 265},
  [4228] = {.lex_state = 265},
  [4229] = {.lex_state = 260},
  [4230] = {.lex_state = 260},
  [4231] = {.lex_state = 381},
  [4232] = {.lex_state = 281},
  [4233] = {.lex_state = 265},
  [4234] = {.lex_state = 265},
  [4235] = {.lex_state = 237},
  [4236] = {.lex_state = 260},
  [4237] = {.lex_state = 260},
  [4238] = {.lex_state = 281},
  [4239] = {.lex_state = 265},
  [4240] = {.lex_state = 265},
  [4241] = {.lex_state = 265},
  [4242] = {.lex_state = 265},
  [4243] = {.lex_state = 234},
  [4244] = {.lex_state = 265},
  [4245] = {.lex_state = 265},
  [4246] = {.lex_state = 265},
  [4247] = {.lex_state = 265},
  [4248] = {.lex_state = 265},
  [4249] = {.lex_state = 265},
  [4250] = {.lex_state = 237},
  [4251] = {.lex_state = 265},
  [4252] = {.lex_state = 237},
  [4253] = {.lex_state = 265},
  [4254] = {.lex_state = 265},
  [4255] = {.lex_state = 282},
  [4256] = {.lex_state = 237},
  [4257] = {.lex_state = 237},
  [4258] = {.lex_state = 260},
  [4259] = {.lex_state = 265},
  [4260] = {.lex_state = 265},
  [4261] = {.lex_state = 265},
  [4262] = {.lex_state = 265},
  [4263] = {.lex_state = 265},
  [4264] = {.lex_state = 265},
  [4265] = {.lex_state = 207},
  [4266] = {.lex_state = 265},
  [4267] = {.lex_state = 250},
  [4268] = {.lex_state = 265},
  [4269] = {.lex_state = 265},
  [4270] = {.lex_state = 265},
  [4271] = {.lex_state = 265},
  [4272] = {.lex_state = 237},
  [4273] = {.lex_state = 207},
  [4274] = {.lex_state = 265},
  [4275] = {.lex_state = 265},
  [4276] = {.lex_state = 265},
  [4277] = {.lex_state = 237},
  [4278] = {.lex_state = 237},
  [4279] = {.lex_state = 265},
  [4280] = {.lex_state = 265},
  [4281] = {.lex_state = 237},
  [4282] = {.lex_state = 265},
  [4283] = {.lex_state = 381},
  [4284] = {.lex_state = 265},
  [4285] = {.lex_state = 265},
  [4286] = {.lex_state = 265},
  [4287] = {.lex_state = 265},
  [4288] = {.lex_state = 260},
  [4289] = {.lex_state = 281},
  [4290] = {.lex_state = 265},
  [4291] = {.lex_state = 265},
  [4292] = {.lex_state = 265},
  [4293] = {.lex_state = 260},
  [4294] = {.lex_state = 378},
  [4295] = {.lex_state = 260},
  [4296] = {.lex_state = 281},
  [4297] = {.lex_state = 260},
  [4298] = {.lex_state = 260},
  [4299] = {.lex_state = 260},
  [4300] = {.lex_state = 260},
  [4301] = {.lex_state = 260},
  [4302] = {.lex_state = 260},
  [4303] = {.lex_state = 260},
  [4304] = {.lex_state = 260},
  [4305] = {.lex_state = 260},
  [4306] = {.lex_state = 265},
  [4307] = {.lex_state = 265},
  [4308] = {.lex_state = 265},
  [4309] = {.lex_state = 265},
  [4310] = {.lex_state = 265},
  [4311] = {.lex_state = 265},
  [4312] = {.lex_state = 265},
  [4313] = {.lex_state = 265},
  [4314] = {.lex_state = 281},
  [4315] = {.lex_state = 265},
  [4316] = {.lex_state = 260},
  [4317] = {.lex_state = 265},
  [4318] = {.lex_state = 265},
  [4319] = {.lex_state = 260},
  [4320] = {.lex_state = 249},
  [4321] = {.lex_state = 381},
  [4322] = {.lex_state = 265},
  [4323] = {.lex_state = 260},
  [4324] = {.lex_state = 234},
  [4325] = {.lex_state = 281},
  [4326] = {.lex_state = 237},
  [4327] = {.lex_state = 260},
  [4328] = {.lex_state = 265},
  [4329] = {.lex_state = 265},
  [4330] = {.lex_state = 281},
  [4331] = {.lex_state = 265},
  [4332] = {.lex_state = 265},
  [4333] = {.lex_state = 265},
  [4334] = {.lex_state = 265},
  [4335] = {.lex_state = 265},
  [4336] = {.lex_state = 265},
  [4337] = {.lex_state = 265},
  [4338] = {.lex_state = 265},
  [4339] = {.lex_state = 265},
  [4340] = {.lex_state = 265},
  [4341] = {.lex_state = 381},
  [4342] = {.lex_state = 281},
  [4343] = {.lex_state = 265},
  [4344] = {.lex_state = 265},
  [4345] = {.lex_state = 265},
  [4346] = {.lex_state = 265},
  [4347] = {.lex_state = 265},
  [4348] = {.lex_state = 265},
  [4349] = {.lex_state = 265},
  [4350] = {.lex_state = 265},
  [4351] = {.lex_state = 265},
  [4352] = {.lex_state = 212},
  [4353] = {.lex_state = 212},
  [4354] = {.lex_state = 212},
  [4355] = {.lex_state = 265},
  [4356] = {.lex_state = 281},
  [4357] = {.lex_state = 260},
  [4358] = {.lex_state = 265},
  [4359] = {.lex_state = 265},
  [4360] = {.lex_state = 265},
  [4361] = {.lex_state = 212},
  [4362] = {.lex_state = 260},
  [4363] = {.lex_state = 207},
  [4364] = {.lex_state = 282},
  [4365] = {.lex_state = 282},
  [4366] = {.lex_state = 282},
  [4367] = {.lex_state = 282},
  [4368] = {.lex_state = 282},
  [4369] = {.lex_state = 282},
  [4370] = {.lex_state = 282},
  [4371] = {.lex_state = 282},
  [4372] = {.lex_state = 282},
  [4373] = {.lex_state = 237},
  [4374] = {.lex_state = 282},
  [4375] = {.lex_state = 282},
  [4376] = {.lex_state = 282},
  [4377] = {.lex_state = 282},
  [4378] = {.lex_state = 226},
  [4379] = {.lex_state = 282},
  [4380] = {.lex_state = 282},
  [4381] = {.lex_state = 282},
  [4382] = {.lex_state = 282},
  [4383] = {.lex_state = 253},
  [4384] = {.lex_state = 282},
  [4385] = {.lex_state = 282},
  [4386] = {.lex_state = 282},
  [4387] = {.lex_state = 282},
  [4388] = {.lex_state = 282},
  [4389] = {.lex_state = 282},
  [4390] = {.lex_state = 282},
  [4391] = {.lex_state = 282},
  [4392] = {.lex_state = 282},
  [4393] = {.lex_state = 282},
  [4394] = {.lex_state = 282},
  [4395] = {.lex_state = 282},
  [4396] = {.lex_state = 282},
  [4397] = {.lex_state = 282},
  [4398] = {.lex_state = 253},
  [4399] = {.lex_state = 282},
  [4400] = {.lex_state = 282},
  [4401] = {.lex_state = 282},
  [4402] = {.lex_state = 282},
  [4403] = {.lex_state = 282},
  [4404] = {.lex_state = 282},
  [4405] = {.lex_state = 282},
  [4406] = {.lex_state = 260},
  [4407] = {.lex_state = 237},
  [4408] = {.lex_state = 282},
  [4409] = {.lex_state = 237},
  [4410] = {.lex_state = 282},
  [4411] = {.lex_state = 282},
  [4412] = {.lex_state = 282},
  [4413] = {.lex_state = 238},
  [4414] = {.lex_state = 282},
  [4415] = {.lex_state = 282},
  [4416] = {.lex_state = 282},
  [4417] = {.lex_state = 282},
  [4418] = {.lex_state = 282},
  [4419] = {.lex_state = 282},
  [4420] = {.lex_state = 237},
  [4421] = {.lex_state = 282},
  [4422] = {.lex_state = 237},
  [4423] = {.lex_state = 207},
  [4424] = {.lex_state = 237},
  [4425] = {.lex_state = 226},
  [4426] = {.lex_state = 282},
  [4427] = {.lex_state = 282},
  [4428] = {.lex_state = 238},
  [4429] = {.lex_state = 282},
  [4430] = {.lex_state = 282},
  [4431] = {.lex_state = 282},
  [4432] = {.lex_state = 282},
  [4433] = {.lex_state = 282},
  [4434] = {.lex_state = 226},
  [4435] = {.lex_state = 218},
  [4436] = {.lex_state = 218},
  [4437] = {.lex_state = 282},
  [4438] = {.lex_state = 282},
  [4439] = {.lex_state = 249},
  [4440] = {.lex_state = 253},
  [4441] = {.lex_state = 282},
  [4442] = {.lex_state = 282},
  [4443] = {.lex_state = 282},
  [4444] = {.lex_state = 282},
  [4445] = {.lex_state = 282},
  [4446] = {.lex_state = 282},
  [4447] = {.lex_state = 207},
  [4448] = {.lex_state = 207},
  [4449] = {.lex_state = 281},
  [4450] = {.lex_state = 282},
  [4451] = {.lex_state = 282},
  [4452] = {.lex_state = 282},
  [4453] = {.lex_state = 237},
  [4454] = {.lex_state = 237},
  [4455] = {.lex_state = 237},
  [4456] = {.lex_state = 237},
  [4457] = {.lex_state = 237},
  [4458] = {.lex_state = 237},
  [4459] = {.lex_state = 281},
  [4460] = {.lex_state = 237},
  [4461] = {.lex_state = 253},
  [4462] = {.lex_state = 282},
  [4463] = {.lex_state = 282},
  [4464] = {.lex_state = 282},
  [4465] = {.lex_state = 282},
  [4466] = {.lex_state = 282},
  [4467] = {.lex_state = 282},
  [4468] = {.lex_state = 226},
  [4469] = {.lex_state = 282},
  [4470] = {.lex_state = 282},
  [4471] = {.lex_state = 237},
  [4472] = {.lex_state = 282},
  [4473] = {.lex_state = 282},
  [4474] = {.lex_state = 282},
  [4475] = {.lex_state = 282},
  [4476] = {.lex_state = 282},
  [4477] = {.lex_state = 282},
  [4478] = {.lex_state = 238},
  [4479] = {.lex_state = 282},
  [4480] = {.lex_state = 260},
  [4481] = {.lex_state = 260},
  [4482] = {.lex_state = 260},
  [4483] = {.lex_state = 260},
  [4484] = {.lex_state = 260},
  [4485] = {.lex_state = 260},
  [4486] = {.lex_state = 260},
  [4487] = {.lex_state = 260},
  [4488] = {.lex_state = 281},
  [4489] = {.lex_state = 260},
  [4490] = {.lex_state = 260},
  [4491] = {.lex_state = 260},
  [4492] = {.lex_state = 282},
  [4493] = {.lex_state = 260},
  [4494] = {.lex_state = 218},
  [4495] = {.lex_state = 282},
  [4496] = {.lex_state = 282},
  [4497] = {.lex_state = 218},
  [4498] = {.lex_state = 260},
  [4499] = {.lex_state = 260},
  [4500] = {.lex_state = 237},
  [4501] = {.lex_state = 237},
  [4502] = {.lex_state = 260},
  [4503] = {.lex_state = 282},
  [4504] = {.lex_state = 260},
  [4505] = {.lex_state = 238},
  [4506] = {.lex_state = 260},
  [4507] = {.lex_state = 260},
  [4508] = {.lex_state = 260},
  [4509] = {.lex_state = 238},
  [4510] = {.lex_state = 282},
  [4511] = {.lex_state = 237},
  [4512] = {.lex_state = 207},
  [4513] = {.lex_state = 237},
  [4514] = {.lex_state = 282},
  [4515] = {.lex_state = 238},
  [4516] = {.lex_state = 260},
  [4517] = {.lex_state = 260},
  [4518] = {.lex_state = 260},
  [4519] = {.lex_state = 237},
  [4520] = {.lex_state = 282},
  [4521] = {.lex_state = 260},
  [4522] = {.lex_state = 207},
  [4523] = {.lex_state = 282},
  [4524] = {.lex_state = 260},
  [4525] = {.lex_state = 260},
  [4526] = {.lex_state = 260},
  [4527] = {.lex_state = 282},
  [4528] = {.lex_state = 260},
  [4529] = {.lex_state = 260},
  [4530] = {.lex_state = 250},
  [4531] = {.lex_state = 260},
  [4532] = {.lex_state = 237},
  [4533] = {.lex_state = 237},
  [4534] = {.lex_state = 282},
  [4535] = {.lex_state = 237},
  [4536] = {.lex_state = 260},
  [4537] = {.lex_state = 281},
  [4538] = {.lex_state = 281},
  [4539] = {.lex_state = 237},
  [4540] = {.lex_state = 281},
  [4541] = {.lex_state = 260},
  [4542] = {.lex_state = 237},
  [4543] = {.lex_state = 238},
  [4544] = {.lex_state = 238},
  [4545] = {.lex_state = 218},
  [4546] = {.lex_state = 260},
  [4547] = {.lex_state = 260},
  [4548] = {.lex_state = 260},
  [4549] = {.lex_state = 282},
  [4550] = {.lex_state = 260},
  [4551] = {.lex_state = 282},
  [4552] = {.lex_state = 260},
  [4553] = {.lex_state = 249},
  [4554] = {.lex_state = 250},
  [4555] = {.lex_state = 260},
  [4556] = {.lex_state = 282},
  [4557] = {.lex_state = 250},
  [4558] = {.lex_state = 218},
  [4559] = {.lex_state = 260},
  [4560] = {.lex_state = 260},
  [4561] = {.lex_state = 260},
  [4562] = {.lex_state = 260},
  [4563] = {.lex_state = 250},
  [4564] = {.lex_state = 260},
  [4565] = {.lex_state = 260},
  [4566] = {.lex_state = 260},
  [4567] = {.lex_state = 260},
  [4568] = {.lex_state = 260},
  [4569] = {.lex_state = 260},
  [4570] = {.lex_state = 250},
  [4571] = {.lex_state = 260},
  [4572] = {.lex_state = 260},
  [4573] = {.lex_state = 282},
  [4574] = {.lex_state = 260},
  [4575] = {.lex_state = 238},
  [4576] = {.lex_state = 260},
  [4577] = {.lex_state = 207},
  [4578] = {.lex_state = 281},
  [4579] = {.lex_state = 249},
  [4580] = {.lex_state = 250},
  [4581] = {.lex_state = 260},
  [4582] = {.lex_state = 250},
  [4583] = {.lex_state = 260},
  [4584] = {.lex_state = 260},
  [4585] = {.lex_state = 282},
  [4586] = {.lex_state = 250},
  [4587] = {.lex_state = 260},
  [4588] = {.lex_state = 237},
  [4589] = {.lex_state = 260},
  [4590] = {.lex_state = 260},
  [4591] = {.lex_state = 207},
  [4592] = {.lex_state = 237},
  [4593] = {.lex_state = 249},
  [4594] = {.lex_state = 249},
  [4595] = {.lex_state = 381},
  [4596] = {.lex_state = 238},
  [4597] = {.lex_state = 281},
  [4598] = {.lex_state = 238},
  [4599] = {.lex_state = 238},
  [4600] = {.lex_state = 218},
  [4601] = {.lex_state = 281},
  [4602] = {.lex_state = 238},
  [4603] = {.lex_state = 238},
  [4604] = {.lex_state = 238},
  [4605] = {.lex_state = 238},
  [4606] = {.lex_state = 281},
  [4607] = {.lex_state = 237},
  [4608] = {.lex_state = 281},
  [4609] = {.lex_state = 281},
  [4610] = {.lex_state = 238},
  [4611] = {.lex_state = 281},
  [4612] = {.lex_state = 250},
  [4613] = {.lex_state = 238},
  [4614] = {.lex_state = 282},
  [4615] = {.lex_state = 381},
  [4616] = {.lex_state = 238},
  [4617] = {.lex_state = 218},
  [4618] = {.lex_state = 238},
  [4619] = {.lex_state = 250},
  [4620] = {.lex_state = 238},
  [4621] = {.lex_state = 281},
  [4622] = {.lex_state = 272},
  [4623] = {.lex_state = 249},
  [4624] = {.lex_state = 238},
  [4625] = {.lex_state = 249},
  [4626] = {.lex_state = 238},
  [4627] = {.lex_state = 238},
  [4628] = {.lex_state = 218},
  [4629] = {.lex_state = 281},
  [4630] = {.lex_state = 238},
  [4631] = {.lex_state = 281},
  [4632] = {.lex_state = 281},
  [4633] = {.lex_state = 238},
  [4634] = {.lex_state = 226},
  [4635] = {.lex_state = 249},
  [4636] = {.lex_state = 249},
  [4637] = {.lex_state = 381},
  [4638] = {.lex_state = 238},
  [4639] = {.lex_state = 249},
  [4640] = {.lex_state = 238},
  [4641] = {.lex_state = 238},
  [4642] = {.lex_state = 238},
  [4643] = {.lex_state = 238},
  [4644] = {.lex_state = 249},
  [4645] = {.lex_state = 378},
  [4646] = {.lex_state = 378},
  [4647] = {.lex_state = 226},
  [4648] = {.lex_state = 281},
  [4649] = {.lex_state = 237},
  [4650] = {.lex_state = 249},
  [4651] = {.lex_state = 238},
  [4652] = {.lex_state = 238},
  [4653] = {.lex_state = 238},
  [4654] = {.lex_state = 249},
  [4655] = {.lex_state = 249},
  [4656] = {.lex_state = 218},
  [4657] = {.lex_state = 281},
  [4658] = {.lex_state = 238},
  [4659] = {.lex_state = 238},
  [4660] = {.lex_state = 238},
  [4661] = {.lex_state = 281},
  [4662] = {.lex_state = 238},
  [4663] = {.lex_state = 249},
  [4664] = {.lex_state = 226},
  [4665] = {.lex_state = 381},
  [4666] = {.lex_state = 238},
  [4667] = {.lex_state = 238},
  [4668] = {.lex_state = 250},
  [4669] = {.lex_state = 250},
  [4670] = {.lex_state = 281},
  [4671] = {.lex_state = 238},
  [4672] = {.lex_state = 238},
  [4673] = {.lex_state = 237},
  [4674] = {.lex_state = 250},
  [4675] = {.lex_state = 237},
  [4676] = {.lex_state = 237},
  [4677] = {.lex_state = 237},
  [4678] = {.lex_state = 250},
  [4679] = {.lex_state = 237},
  [4680] = {.lex_state = 284},
  [4681] = {.lex_state = 237},
  [4682] = {.lex_state = 281},
  [4683] = {.lex_state = 272},
  [4684] = {.lex_state = 237},
  [4685] = {.lex_state = 281},
  [4686] = {.lex_state = 238},
  [4687] = {.lex_state = 381},
  [4688] = {.lex_state = 238},
  [4689] = {.lex_state = 237},
  [4690] = {.lex_state = 238},
  [4691] = {.lex_state = 250},
  [4692] = {.lex_state = 284},
  [4693] = {.lex_state = 237},
  [4694] = {.lex_state = 250},
  [4695] = {.lex_state = 381},
  [4696] = {.lex_state = 381},
  [4697] = {.lex_state = 237},
  [4698] = {.lex_state = 237},
  [4699] = {.lex_state = 237},
  [4700] = {.lex_state = 237},
  [4701] = {.lex_state = 237},
  [4702] = {.lex_state = 250},
  [4703] = {.lex_state = 237},
  [4704] = {.lex_state = 237},
  [4705] = {.lex_state = 381},
  [4706] = {.lex_state = 281},
  [4707] = {.lex_state = 272},
  [4708] = {.lex_state = 381},
  [4709] = {.lex_state = 237},
  [4710] = {.lex_state = 381},
  [4711] = {.lex_state = 281},
  [4712] = {.lex_state = 237},
  [4713] = {.lex_state = 237},
  [4714] = {.lex_state = 250},
  [4715] = {.lex_state = 237},
  [4716] = {.lex_state = 282},
  [4717] = {.lex_state = 281},
  [4718] = {.lex_state = 381},
  [4719] = {.lex_state = 237},
  [4720] = {.lex_state = 250},
  [4721] = {.lex_state = 237},
  [4722] = {.lex_state = 237},
  [4723] = {.lex_state = 381},
  [4724] = {.lex_state = 237},
  [4725] = {.lex_state = 272},
  [4726] = {.lex_state = 381},
  [4727] = {.lex_state = 237},
  [4728] = {.lex_state = 282},
  [4729] = {.lex_state = 282},
  [4730] = {.lex_state = 226},
  [4731] = {.lex_state = 237},
  [4732] = {.lex_state = 237},
  [4733] = {.lex_state = 238},
  [4734] = {.lex_state = 237},
  [4735] = {.lex_state = 237},
  [4736] = {.lex_state = 237},
  [4737] = {.lex_state = 282},
  [4738] = {.lex_state = 237},
  [4739] = {.lex_state = 250},
  [4740] = {.lex_state = 250},
  [4741] = {.lex_state = 250},
  [4742] = {.lex_state = 237},
  [4743] = {.lex_state = 250},
  [4744] = {.lex_state = 237},
  [4745] = {.lex_state = 237},
  [4746] = {.lex_state = 237},
  [4747] = {.lex_state = 250},
  [4748] = {.lex_state = 237},
  [4749] = {.lex_state = 282},
  [4750] = {.lex_state = 237},
  [4751] = {.lex_state = 237},
  [4752] = {.lex_state = 237},
  [4753] = {.lex_state = 237},
  [4754] = {.lex_state = 237},
  [4755] = {.lex_state = 250},
  [4756] = {.lex_state = 237},
  [4757] = {.lex_state = 237},
  [4758] = {.lex_state = 237},
  [4759] = {.lex_state = 282},
  [4760] = {.lex_state = 237},
  [4761] = {.lex_state = 237},
  [4762] = {.lex_state = 250},
  [4763] = {.lex_state = 237},
  [4764] = {.lex_state = 237},
  [4765] = {.lex_state = 273},
  [4766] = {.lex_state = 273},
  [4767] = {.lex_state = 250},
  [4768] = {.lex_state = 237},
  [4769] = {.lex_state = 238},
  [4770] = {.lex_state = 284},
  [4771] = {.lex_state = 237},
  [4772] = {.lex_state = 237},
  [4773] = {.lex_state = 250},
  [4774] = {.lex_state = 237},
  [4775] = {.lex_state = 282},
  [4776] = {.lex_state = 250},
  [4777] = {.lex_state = 226},
  [4778] = {.lex_state = 282},
  [4779] = {.lex_state = 237},
  [4780] = {.lex_state = 226},
  [4781] = {.lex_state = 237},
  [4782] = {.lex_state = 237},
  [4783] = {.lex_state = 237},
  [4784] = {.lex_state = 237},
  [4785] = {.lex_state = 237},
  [4786] = {.lex_state = 237},
  [4787] = {.lex_state = 238},
  [4788] = {.lex_state = 237},
  [4789] = {.lex_state = 282},
  [4790] = {.lex_state = 237},
  [4791] = {.lex_state = 237},
  [4792] = {.lex_state = 237},
  [4793] = {.lex_state = 237},
  [4794] = {.lex_state = 237},
  [4795] = {.lex_state = 237},
  [4796] = {.lex_state = 237},
  [4797] = {.lex_state = 237},
  [4798] = {.lex_state = 250},
  [4799] = {.lex_state = 237},
  [4800] = {.lex_state = 250},
  [4801] = {.lex_state = 237},
  [4802] = {.lex_state = 237},
  [4803] = {.lex_state = 237},
  [4804] = {.lex_state = 238},
  [4805] = {.lex_state = 237},
  [4806] = {.lex_state = 226},
  [4807] = {.lex_state = 237},
  [4808] = {.lex_state = 284},
  [4809] = {.lex_state = 250},
  [4810] = {.lex_state = 273},
  [4811] = {.lex_state = 378},
  [4812] = {.lex_state = 281},
  [4813] = {.lex_state = 237},
  [4814] = {.lex_state = 238},
  [4815] = {.lex_state = 284},
  [4816] = {.lex_state = 250},
  [4817] = {.lex_state = 238},
  [4818] = {.lex_state = 237},
  [4819] = {.lex_state = 250},
  [4820] = {.lex_state = 273},
  [4821] = {.lex_state = 273},
  [4822] = {.lex_state = 237},
  [4823] = {.lex_state = 249},
  [4824] = {.lex_state = 250},
  [4825] = {.lex_state = 237},
  [4826] = {.lex_state = 249},
  [4827] = {.lex_state = 237},
  [4828] = {.lex_state = 238},
  [4829] = {.lex_state = 237},
  [4830] = {.lex_state = 237},
  [4831] = {.lex_state = 237},
  [4832] = {.lex_state = 284},
  [4833] = {.lex_state = 273},
  [4834] = {.lex_state = 250},
  [4835] = {.lex_state = 237},
  [4836] = {.lex_state = 237},
  [4837] = {.lex_state = 238},
  [4838] = {.lex_state = 250},
  [4839] = {.lex_state = 237},
  [4840] = {.lex_state = 237},
  [4841] = {.lex_state = 237},
  [4842] = {.lex_state = 237},
  [4843] = {.lex_state = 237},
  [4844] = {.lex_state = 250},
  [4845] = {.lex_state = 237},
  [4846] = {.lex_state = 237},
  [4847] = {.lex_state = 237},
  [4848] = {.lex_state = 237},
  [4849] = {.lex_state = 237},
  [4850] = {.lex_state = 250},
  [4851] = {.lex_state = 250},
  [4852] = {.lex_state = 250},
  [4853] = {.lex_state = 250},
  [4854] = {.lex_state = 250},
  [4855] = {.lex_state = 282},
  [4856] = {.lex_state = 250},
  [4857] = {.lex_state = 284},
  [4858] = {.lex_state = 281},
  [4859] = {.lex_state = 237},
  [4860] = {.lex_state = 284},
  [4861] = {.lex_state = 237},
  [4862] = {.lex_state = 381},
  [4863] = {.lex_state = 250},
  [4864] = {.lex_state = 250},
  [4865] = {.lex_state = 282},
  [4866] = {.lex_state = 381},
  [4867] = {.lex_state = 250},
  [4868] = {.lex_state = 250},
  [4869] = {.lex_state = 282},
  [4870] = {.lex_state = 282},
  [4871] = {.lex_state = 228},
  [4872] = {.lex_state = 282},
  [4873] = {.lex_state = 282},
  [4874] = {.lex_state = 378},
  [4875] = {.lex_state = 250},
  [4876] = {.lex_state = 282},
  [4877] = {.lex_state = 250},
  [4878] = {.lex_state = 378},
  [4879] = {.lex_state = 250},
  [4880] = {.lex_state = 282},
  [4881] = {.lex_state = 250},
  [4882] = {.lex_state = 250},
  [4883] = {.lex_state = 250},
  [4884] = {.lex_state = 250},
  [4885] = {.lex_state = 250},
  [4886] = {.lex_state = 381},
  [4887] = {.lex_state = 282},
  [4888] = {.lex_state = 250},
  [4889] = {.lex_state = 282},
  [4890] = {.lex_state = 250},
  [4891] = {.lex_state = 250},
  [4892] = {.lex_state = 282},
  [4893] = {.lex_state = 282},
  [4894] = {.lex_state = 250},
  [4895] = {.lex_state = 250},
  [4896] = {.lex_state = 250},
  [4897] = {.lex_state = 250},
  [4898] = {.lex_state = 282},
  [4899] = {.lex_state = 282},
  [4900] = {.lex_state = 381},
  [4901] = {.lex_state = 282},
  [4902] = {.lex_state = 281},
  [4903] = {.lex_state = 250},
  [4904] = {.lex_state = 228},
  [4905] = {.lex_state = 250},
  [4906] = {.lex_state = 250},
  [4907] = {.lex_state = 282},
  [4908] = {.lex_state = 381},
  [4909] = {.lex_state = 282},
  [4910] = {.lex_state = 237},
  [4911] = {.lex_state = 282},
  [4912] = {.lex_state = 250},
  [4913] = {.lex_state = 250},
  [4914] = {.lex_state = 282},
  [4915] = {.lex_state = 228},
  [4916] = {.lex_state = 282},
  [4917] = {.lex_state = 228},
  [4918] = {.lex_state = 250},
  [4919] = {.lex_state = 250},
  [4920] = {.lex_state = 282},
  [4921] = {.lex_state = 250},
  [4922] = {.lex_state = 282},
  [4923] = {.lex_state = 250},
  [4924] = {.lex_state = 282},
  [4925] = {.lex_state = 282},
  [4926] = {.lex_state = 381},
  [4927] = {.lex_state = 250},
  [4928] = {.lex_state = 282},
  [4929] = {.lex_state = 282},
  [4930] = {.lex_state = 237},
  [4931] = {.lex_state = 282},
  [4932] = {.lex_state = 282},
  [4933] = {.lex_state = 282},
  [4934] = {.lex_state = 282},
  [4935] = {.lex_state = 282},
  [4936] = {.lex_state = 250},
  [4937] = {.lex_state = 250},
  [4938] = {.lex_state = 282},
  [4939] = {.lex_state = 250},
  [4940] = {.lex_state = 381},
  [4941] = {.lex_state = 228},
  [4942] = {.lex_state = 226},
  [4943] = {.lex_state = 237},
  [4944] = {.lex_state = 250},
  [4945] = {.lex_state = 250},
  [4946] = {.lex_state = 250},
  [4947] = {.lex_state = 226},
  [4948] = {.lex_state = 281},
  [4949] = {.lex_state = 281},
  [4950] = {.lex_state = 379},
  [4951] = {.lex_state = 284},
  [4952] = {.lex_state = 250},
  [4953] = {.lex_state = 237},
  [4954] = {.lex_state = 237},
  [4955] = {.lex_state = 237},
  [4956] = {.lex_state = 226},
  [4957] = {.lex_state = 250},
  [4958] = {.lex_state = 281},
  [4959] = {.lex_state = 250},
  [4960] = {.lex_state = 281},
  [4961] = {.lex_state = 238},
  [4962] = {.lex_state = 284},
  [4963] = {.lex_state = 250},
  [4964] = {.lex_state = 250},
  [4965] = {.lex_state = 250},
  [4966] = {.lex_state = 250},
  [4967] = {.lex_state = 284},
  [4968] = {.lex_state = 250},
  [4969] = {.lex_state = 250},
  [4970] = {.lex_state = 381},
  [4971] = {.lex_state = 237},
  [4972] = {.lex_state = 238},
  [4973] = {.lex_state = 281},
  [4974] = {.lex_state = 228},
  [4975] = {.lex_state = 250},
  [4976] = {.lex_state = 250},
  [4977] = {.lex_state = 250},
  [4978] = {.lex_state = 250},
  [4979] = {.lex_state = 250},
  [4980] = {.lex_state = 250},
  [4981] = {.lex_state = 281},
  [4982] = {.lex_state = 250},
  [4983] = {.lex_state = 228},
  [4984] = {.lex_state = 249},
  [4985] = {.lex_state = 250},
  [4986] = {.lex_state = 228},
  [4987] = {.lex_state = 250},
  [4988] = {.lex_state = 250},
  [4989] = {.lex_state = 281},
  [4990] = {.lex_state = 250},
  [4991] = {.lex_state = 250},
  [4992] = {.lex_state = 237},
  [4993] = {.lex_state = 284},
  [4994] = {.lex_state = 284},
  [4995] = {.lex_state = 237},
  [4996] = {.lex_state = 226},
  [4997] = {.lex_state = 237},
  [4998] = {.lex_state = 237},
  [4999] = {.lex_state = 237},
  [5000] = {.lex_state = 281},
  [5001] = {.lex_state = 250},
  [5002] = {.lex_state = 381},
  [5003] = {.lex_state = 241},
  [5004] = {.lex_state = 237},
  [5005] = {.lex_state = 284},
  [5006] = {.lex_state = 226},
  [5007] = {.lex_state = 237},
  [5008] = {.lex_state = 237},
  [5009] = {.lex_state = 226},
  [5010] = {.lex_state = 226},
  [5011] = {.lex_state = 226},
  [5012] = {.lex_state = 237},
  [5013] = {.lex_state = 381},
  [5014] = {.lex_state = 241},
  [5015] = {.lex_state = 241},
  [5016] = {.lex_state = 284},
  [5017] = {.lex_state = 237},
  [5018] = {.lex_state = 226},
  [5019] = {.lex_state = 237},
  [5020] = {.lex_state = 237},
  [5021] = {.lex_state = 379},
  [5022] = {.lex_state = 226},
  [5023] = {.lex_state = 226},
  [5024] = {.lex_state = 379},
  [5025] = {.lex_state = 237},
  [5026] = {.lex_state = 226},
  [5027] = {.lex_state = 238},
  [5028] = {.lex_state = 237},
  [5029] = {.lex_state = 237},
  [5030] = {.lex_state = 238},
  [5031] = {.lex_state = 237},
  [5032] = {.lex_state = 241},
  [5033] = {.lex_state = 226},
  [5034] = {.lex_state = 237},
  [5035] = {.lex_state = 226},
  [5036] = {.lex_state = 237},
  [5037] = {.lex_state = 237},
  [5038] = {.lex_state = 281},
  [5039] = {.lex_state = 237},
  [5040] = {.lex_state = 381},
  [5041] = {.lex_state = 237},
  [5042] = {.lex_state = 273},
  [5043] = {.lex_state = 237},
  [5044] = {.lex_state = 273},
  [5045] = {.lex_state = 237},
  [5046] = {.lex_state = 237},
  [5047] = {.lex_state = 250},
  [5048] = {.lex_state = 250},
  [5049] = {.lex_state = 250},
  [5050] = {.lex_state = 284},
  [5051] = {.lex_state = 237},
  [5052] = {.lex_state = 237},
  [5053] = {.lex_state = 250},
  [5054] = {.lex_state = 250},
  [5055] = {.lex_state = 250},
  [5056] = {.lex_state = 250},
  [5057] = {.lex_state = 237},
  [5058] = {.lex_state = 250},
  [5059] = {.lex_state = 250},
  [5060] = {.lex_state = 250},
  [5061] = {.lex_state = 273},
  [5062] = {.lex_state = 237},
  [5063] = {.lex_state = 273},
  [5064] = {.lex_state = 273},
  [5065] = {.lex_state = 237},
  [5066] = {.lex_state = 237},
  [5067] = {.lex_state = 237},
  [5068] = {.lex_state = 237},
  [5069] = {.lex_state = 237},
  [5070] = {.lex_state = 273},
  [5071] = {.lex_state = 273},
  [5072] = {.lex_state = 273},
  [5073] = {.lex_state = 237},
  [5074] = {.lex_state = 237},
  [5075] = {.lex_state = 281},
  [5076] = {.lex_state = 237},
  [5077] = {.lex_state = 250},
  [5078] = {.lex_state = 237},
  [5079] = {.lex_state = 237},
  [5080] = {.lex_state = 250},
  [5081] = {.lex_state = 273},
  [5082] = {.lex_state = 237},
  [5083] = {.lex_state = 250},
  [5084] = {.lex_state = 281},
  [5085] = {.lex_state = 281},
  [5086] = {.lex_state = 237},
  [5087] = {.lex_state = 273},
  [5088] = {.lex_state = 237},
  [5089] = {.lex_state = 250},
  [5090] = {.lex_state = 250},
  [5091] = {.lex_state = 226},
  [5092] = {.lex_state = 273},
  [5093] = {.lex_state = 250},
  [5094] = {.lex_state = 381},
  [5095] = {.lex_state = 250},
  [5096] = {.lex_state = 237},
  [5097] = {.lex_state = 273},
  [5098] = {.lex_state = 273},
  [5099] = {.lex_state = 237},
  [5100] = {.lex_state = 250},
  [5101] = {.lex_state = 273},
  [5102] = {.lex_state = 250},
  [5103] = {.lex_state = 237},
  [5104] = {.lex_state = 250},
  [5105] = {.lex_state = 273},
  [5106] = {.lex_state = 250},
  [5107] = {.lex_state = 237},
  [5108] = {.lex_state = 273},
  [5109] = {.lex_state = 250},
  [5110] = {.lex_state = 273},
  [5111] = {.lex_state = 250},
  [5112] = {.lex_state = 237},
  [5113] = {.lex_state = 273},
  [5114] = {.lex_state = 273},
  [5115] = {.lex_state = 273},
  [5116] = {.lex_state = 273},
  [5117] = {.lex_state = 237},
  [5118] = {.lex_state = 250},
  [5119] = {.lex_state = 237},
  [5120] = {.lex_state = 381},
  [5121] = {.lex_state = 273},
  [5122] = {.lex_state = 250},
  [5123] = {.lex_state = 250},
  [5124] = {.lex_state = 237},
  [5125] = {.lex_state = 250},
  [5126] = {.lex_state = 273},
  [5127] = {.lex_state = 237},
  [5128] = {.lex_state = 237},
  [5129] = {.lex_state = 237},
  [5130] = {.lex_state = 237},
  [5131] = {.lex_state = 250},
  [5132] = {.lex_state = 250},
  [5133] = {.lex_state = 250},
  [5134] = {.lex_state = 381},
  [5135] = {.lex_state = 250},
  [5136] = {.lex_state = 273},
  [5137] = {.lex_state = 273},
  [5138] = {.lex_state = 250},
  [5139] = {.lex_state = 237},
  [5140] = {.lex_state = 273},
  [5141] = {.lex_state = 237},
  [5142] = {.lex_state = 226},
  [5143] = {.lex_state = 381},
  [5144] = {.lex_state = 237},
  [5145] = {.lex_state = 273},
  [5146] = {.lex_state = 284},
  [5147] = {.lex_state = 226},
  [5148] = {.lex_state = 250},
  [5149] = {.lex_state = 250},
  [5150] = {.lex_state = 271},
  [5151] = {.lex_state = 273},
  [5152] = {.lex_state = 250},
  [5153] = {.lex_state = 237},
  [5154] = {.lex_state = 281},
  [5155] = {.lex_state = 273},
  [5156] = {.lex_state = 237},
  [5157] = {.lex_state = 237},
  [5158] = {.lex_state = 273},
  [5159] = {.lex_state = 237},
  [5160] = {.lex_state = 250},
  [5161] = {.lex_state = 381},
  [5162] = {.lex_state = 237},
  [5163] = {.lex_state = 237},
  [5164] = {.lex_state = 250},
  [5165] = {.lex_state = 250},
  [5166] = {.lex_state = 237},
  [5167] = {.lex_state = 250},
  [5168] = {.lex_state = 250},
  [5169] = {.lex_state = 237},
  [5170] = {.lex_state = 237},
  [5171] = {.lex_state = 237},
  [5172] = {.lex_state = 273},
  [5173] = {.lex_state = 250},
  [5174] = {.lex_state = 237},
  [5175] = {.lex_state = 237},
  [5176] = {.lex_state = 250},
  [5177] = {.lex_state = 237},
  [5178] = {.lex_state = 273},
  [5179] = {.lex_state = 250},
  [5180] = {.lex_state = 250},
  [5181] = {.lex_state = 250},
  [5182] = {.lex_state = 250},
  [5183] = {.lex_state = 237},
  [5184] = {.lex_state = 237},
  [5185] = {.lex_state = 284},
  [5186] = {.lex_state = 273},
  [5187] = {.lex_state = 273},
  [5188] = {.lex_state = 237},
  [5189] = {.lex_state = 250},
  [5190] = {.lex_state = 250},
  [5191] = {.lex_state = 273},
  [5192] = {.lex_state = 381},
  [5193] = {.lex_state = 250},
  [5194] = {.lex_state = 381},
  [5195] = {.lex_state = 381},
  [5196] = {.lex_state = 250},
  [5197] = {.lex_state = 237},
  [5198] = {.lex_state = 250},
  [5199] = {.lex_state = 250},
  [5200] = {.lex_state = 250},
  [5201] = {.lex_state = 237},
  [5202] = {.lex_state = 273},
  [5203] = {.lex_state = 250},
  [5204] = {.lex_state = 250},
  [5205] = {.lex_state = 250},
  [5206] = {.lex_state = 273},
  [5207] = {.lex_state = 237},
  [5208] = {.lex_state = 250},
  [5209] = {.lex_state = 273},
  [5210] = {.lex_state = 273},
  [5211] = {.lex_state = 284},
  [5212] = {.lex_state = 237},
  [5213] = {.lex_state = 237},
  [5214] = {.lex_state = 237},
  [5215] = {.lex_state = 237},
  [5216] = {.lex_state = 273},
  [5217] = {.lex_state = 237},
  [5218] = {.lex_state = 237},
  [5219] = {.lex_state = 237},
  [5220] = {.lex_state = 237},
  [5221] = {.lex_state = 237},
  [5222] = {.lex_state = 237},
  [5223] = {.lex_state = 237},
  [5224] = {.lex_state = 237},
  [5225] = {.lex_state = 273},
  [5226] = {.lex_state = 273},
  [5227] = {.lex_state = 237},
  [5228] = {.lex_state = 381},
  [5229] = {.lex_state = 273},
  [5230] = {.lex_state = 381},
  [5231] = {.lex_state = 238},
  [5232] = {.lex_state = 238},
  [5233] = {.lex_state = 238},
  [5234] = {.lex_state = 284},
  [5235] = {.lex_state = 237},
  [5236] = {.lex_state = 238},
  [5237] = {.lex_state = 238},
  [5238] = {.lex_state = 237},
  [5239] = {.lex_state = 238},
  [5240] = {.lex_state = 237},
  [5241] = {.lex_state = 237},
  [5242] = {.lex_state = 237},
  [5243] = {.lex_state = 381},
  [5244] = {.lex_state = 237},
  [5245] = {.lex_state = 273},
  [5246] = {.lex_state = 238},
  [5247] = {.lex_state = 228},
  [5248] = {.lex_state = 381},
  [5249] = {.lex_state = 237},
  [5250] = {.lex_state = 238},
  [5251] = {.lex_state = 237},
  [5252] = {.lex_state = 237},
  [5253] = {.lex_state = 228},
  [5254] = {.lex_state = 238},
  [5255] = {.lex_state = 238},
  [5256] = {.lex_state = 273},
  [5257] = {.lex_state = 237},
  [5258] = {.lex_state = 381},
  [5259] = {.lex_state = 273},
  [5260] = {.lex_state = 273},
  [5261] = {.lex_state = 273},
  [5262] = {.lex_state = 273},
  [5263] = {.lex_state = 273},
  [5264] = {.lex_state = 237},
  [5265] = {.lex_state = 238},
  [5266] = {.lex_state = 238},
  [5267] = {.lex_state = 238},
  [5268] = {.lex_state = 237},
  [5269] = {.lex_state = 273},
  [5270] = {.lex_state = 273},
  [5271] = {.lex_state = 238},
  [5272] = {.lex_state = 237},
  [5273] = {.lex_state = 237},
  [5274] = {.lex_state = 237},
  [5275] = {.lex_state = 273},
  [5276] = {.lex_state = 284},
  [5277] = {.lex_state = 238},
  [5278] = {.lex_state = 238},
  [5279] = {.lex_state = 237},
  [5280] = {.lex_state = 237},
  [5281] = {.lex_state = 273},
  [5282] = {.lex_state = 238},
  [5283] = {.lex_state = 237},
  [5284] = {.lex_state = 237},
  [5285] = {.lex_state = 237},
  [5286] = {.lex_state = 237},
  [5287] = {.lex_state = 237},
  [5288] = {.lex_state = 238},
  [5289] = {.lex_state = 237},
  [5290] = {.lex_state = 237},
  [5291] = {.lex_state = 237},
  [5292] = {.lex_state = 237},
  [5293] = {.lex_state = 237},
  [5294] = {.lex_state = 237},
  [5295] = {.lex_state = 237},
  [5296] = {.lex_state = 237},
  [5297] = {.lex_state = 237},
  [5298] = {.lex_state = 237},
  [5299] = {.lex_state = 237},
  [5300] = {.lex_state = 237},
  [5301] = {.lex_state = 238},
  [5302] = {.lex_state = 273},
  [5303] = {.lex_state = 237},
  [5304] = {.lex_state = 237},
  [5305] = {.lex_state = 273},
  [5306] = {.lex_state = 238},
  [5307] = {.lex_state = 237},
  [5308] = {.lex_state = 238},
  [5309] = {.lex_state = 238},
  [5310] = {.lex_state = 237},
  [5311] = {.lex_state = 237},
  [5312] = {.lex_state = 238},
  [5313] = {.lex_state = 381},
  [5314] = {.lex_state = 273},
  [5315] = {.lex_state = 381},
  [5316] = {.lex_state = 238},
  [5317] = {.lex_state = 273},
  [5318] = {.lex_state = 272},
  [5319] = {.lex_state = 284},
  [5320] = {.lex_state = 238},
  [5321] = {.lex_state = 273},
  [5322] = {.lex_state = 381},
  [5323] = {.lex_state = 237},
  [5324] = {.lex_state = 237},
  [5325] = {.lex_state = 237},
  [5326] = {.lex_state = 237},
  [5327] = {.lex_state = 273},
  [5328] = {.lex_state = 381},
  [5329] = {.lex_state = 237},
  [5330] = {.lex_state = 237},
  [5331] = {.lex_state = 237},
  [5332] = {.lex_state = 237},
  [5333] = {.lex_state = 273},
  [5334] = {.lex_state = 237},
  [5335] = {.lex_state = 273},
  [5336] = {.lex_state = 237},
  [5337] = {.lex_state = 273},
  [5338] = {.lex_state = 237},
  [5339] = {.lex_state = 237},
  [5340] = {.lex_state = 237},
  [5341] = {.lex_state = 237},
  [5342] = {.lex_state = 237},
  [5343] = {.lex_state = 238},
  [5344] = {.lex_state = 281},
  [5345] = {.lex_state = 237},
  [5346] = {.lex_state = 273},
  [5347] = {.lex_state = 237},
  [5348] = {.lex_state = 273},
  [5349] = {.lex_state = 237},
  [5350] = {.lex_state = 237},
  [5351] = {.lex_state = 273},
  [5352] = {.lex_state = 238},
  [5353] = {.lex_state = 273},
  [5354] = {.lex_state = 238},
  [5355] = {.lex_state = 284},
  [5356] = {.lex_state = 273},
  [5357] = {.lex_state = 284},
  [5358] = {.lex_state = 284},
  [5359] = {.lex_state = 238},
  [5360] = {.lex_state = 238},
  [5361] = {.lex_state = 237},
  [5362] = {.lex_state = 237},
  [5363] = {.lex_state = 238},
  [5364] = {.lex_state = 238},
  [5365] = {.lex_state = 228},
  [5366] = {.lex_state = 228},
  [5367] = {.lex_state = 237},
  [5368] = {.lex_state = 238},
  [5369] = {.lex_state = 238},
  [5370] = {.lex_state = 238},
  [5371] = {.lex_state = 238},
  [5372] = {.lex_state = 226},
  [5373] = {.lex_state = 237},
  [5374] = {.lex_state = 381},
  [5375] = {.lex_state = 238},
  [5376] = {.lex_state = 237},
  [5377] = {.lex_state = 238},
  [5378] = {.lex_state = 237},
  [5379] = {.lex_state = 284},
  [5380] = {.lex_state = 238},
  [5381] = {.lex_state = 237},
  [5382] = {.lex_state = 281},
  [5383] = {.lex_state = 281},
  [5384] = {.lex_state = 237},
  [5385] = {.lex_state = 237},
  [5386] = {.lex_state = 237},
  [5387] = {.lex_state = 237},
  [5388] = {.lex_state = 238},
  [5389] = {.lex_state = 237},
  [5390] = {.lex_state = 237},
  [5391] = {.lex_state = 237},
  [5392] = {.lex_state = 237},
  [5393] = {.lex_state = 237},
  [5394] = {.lex_state = 237},
  [5395] = {.lex_state = 237},
  [5396] = {.lex_state = 237},
  [5397] = {.lex_state = 237},
  [5398] = {.lex_state = 237},
  [5399] = {.lex_state = 255},
  [5400] = {.lex_state = 237},
  [5401] = {.lex_state = 237},
  [5402] = {.lex_state = 237},
  [5403] = {.lex_state = 237},
  [5404] = {.lex_state = 237},
  [5405] = {.lex_state = 237},
  [5406] = {.lex_state = 237},
  [5407] = {.lex_state = 255},
  [5408] = {.lex_state = 237},
  [5409] = {.lex_state = 237},
  [5410] = {.lex_state = 237},
  [5411] = {.lex_state = 255},
  [5412] = {.lex_state = 237},
  [5413] = {.lex_state = 237},
  [5414] = {.lex_state = 237},
  [5415] = {.lex_state = 237},
  [5416] = {.lex_state = 237},
  [5417] = {.lex_state = 237},
  [5418] = {.lex_state = 237},
  [5419] = {.lex_state = 237},
  [5420] = {.lex_state = 237},
  [5421] = {.lex_state = 237},
  [5422] = {.lex_state = 237},
  [5423] = {.lex_state = 237},
  [5424] = {.lex_state = 237},
  [5425] = {.lex_state = 237},
  [5426] = {.lex_state = 237},
  [5427] = {.lex_state = 237},
  [5428] = {.lex_state = 281},
  [5429] = {.lex_state = 237},
  [5430] = {.lex_state = 237},
  [5431] = {.lex_state = 237},
  [5432] = {.lex_state = 237},
  [5433] = {.lex_state = 237},
  [5434] = {.lex_state = 237},
  [5435] = {.lex_state = 237},
  [5436] = {.lex_state = 237},
  [5437] = {.lex_state = 237},
  [5438] = {.lex_state = 237},
  [5439] = {.lex_state = 237},
  [5440] = {.lex_state = 238},
  [5441] = {.lex_state = 237},
  [5442] = {.lex_state = 237},
  [5443] = {.lex_state = 237},
  [5444] = {.lex_state = 237},
  [5445] = {.lex_state = 237},
  [5446] = {.lex_state = 237},
  [5447] = {.lex_state = 381},
  [5448] = {.lex_state = 237},
  [5449] = {.lex_state = 237},
  [5450] = {.lex_state = 237},
  [5451] = {.lex_state = 237},
  [5452] = {.lex_state = 237},
  [5453] = {.lex_state = 238},
  [5454] = {.lex_state = 237},
  [5455] = {.lex_state = 237},
  [5456] = {.lex_state = 237},
  [5457] = {.lex_state = 237},
  [5458] = {.lex_state = 237},
  [5459] = {.lex_state = 237},
  [5460] = {.lex_state = 237},
  [5461] = {.lex_state = 237},
  [5462] = {.lex_state = 237},
  [5463] = {.lex_state = 237},
  [5464] = {.lex_state = 282},
  [5465] = {.lex_state = 237},
  [5466] = {.lex_state = 237},
  [5467] = {.lex_state = 237},
  [5468] = {.lex_state = 237},
  [5469] = {.lex_state = 284},
  [5470] = {.lex_state = 237},
  [5471] = {.lex_state = 237},
  [5472] = {.lex_state = 237},
  [5473] = {.lex_state = 237},
  [5474] = {.lex_state = 237},
  [5475] = {.lex_state = 237},
  [5476] = {.lex_state = 237},
  [5477] = {.lex_state = 237},
  [5478] = {.lex_state = 237},
  [5479] = {.lex_state = 238},
  [5480] = {.lex_state = 237},
  [5481] = {.lex_state = 273},
  [5482] = {.lex_state = 255},
  [5483] = {.lex_state = 237},
  [5484] = {.lex_state = 237},
  [5485] = {.lex_state = 237},
  [5486] = {.lex_state = 237},
  [5487] = {.lex_state = 237},
  [5488] = {.lex_state = 237},
  [5489] = {.lex_state = 237},
  [5490] = {.lex_state = 381},
  [5491] = {.lex_state = 237},
  [5492] = {.lex_state = 381},
  [5493] = {.lex_state = 237},
  [5494] = {.lex_state = 238},
  [5495] = {.lex_state = 238},
  [5496] = {.lex_state = 237},
  [5497] = {.lex_state = 237},
  [5498] = {.lex_state = 237},
  [5499] = {.lex_state = 237},
  [5500] = {.lex_state = 281},
  [5501] = {.lex_state = 237},
  [5502] = {.lex_state = 237},
  [5503] = {.lex_state = 237},
  [5504] = {.lex_state = 281},
  [5505] = {.lex_state = 237},
  [5506] = {.lex_state = 237},
  [5507] = {.lex_state = 381},
  [5508] = {.lex_state = 238},
  [5509] = {.lex_state = 237},
  [5510] = {.lex_state = 237},
  [5511] = {.lex_state = 281},
  [5512] = {.lex_state = 237},
  [5513] = {.lex_state = 238},
  [5514] = {.lex_state = 237},
  [5515] = {.lex_state = 237},
  [5516] = {.lex_state = 237},
  [5517] = {.lex_state = 237},
  [5518] = {.lex_state = 237},
  [5519] = {.lex_state = 237},
  [5520] = {.lex_state = 237},
  [5521] = {.lex_state = 237},
  [5522] = {.lex_state = 381},
  [5523] = {.lex_state = 284},
  [5524] = {.lex_state = 237},
  [5525] = {.lex_state = 281},
  [5526] = {.lex_state = 237},
  [5527] = {.lex_state = 237},
  [5528] = {.lex_state = 381},
  [5529] = {.lex_state = 284},
  [5530] = {.lex_state = 237},
  [5531] = {.lex_state = 237},
  [5532] = {.lex_state = 284},
  [5533] = {.lex_state = 273},
  [5534] = {.lex_state = 273},
  [5535] = {.lex_state = 381},
  [5536] = {.lex_state = 273},
  [5537] = {.lex_state = 273},
  [5538] = {.lex_state = 273},
  [5539] = {.lex_state = 273},
  [5540] = {.lex_state = 273},
  [5541] = {.lex_state = 273},
  [5542] = {.lex_state = 237},
  [5543] = {.lex_state = 381},
  [5544] = {.lex_state = 226},
  [5545] = {.lex_state = 273},
  [5546] = {.lex_state = 237},
  [5547] = {.lex_state = 237},
  [5548] = {.lex_state = 273},
  [5549] = {.lex_state = 381},
  [5550] = {.lex_state = 381},
  [5551] = {.lex_state = 284},
  [5552] = {.lex_state = 273},
  [5553] = {.lex_state = 273},
  [5554] = {.lex_state = 273},
  [5555] = {.lex_state = 273},
  [5556] = {.lex_state = 273},
  [5557] = {.lex_state = 273},
  [5558] = {.lex_state = 273},
  [5559] = {.lex_state = 284},
  [5560] = {.lex_state = 273},
  [5561] = {.lex_state = 381},
  [5562] = {.lex_state = 382},
  [5563] = {.lex_state = 237},
  [5564] = {.lex_state = 226},
  [5565] = {.lex_state = 237},
  [5566] = {.lex_state = 273},
  [5567] = {.lex_state = 284},
  [5568] = {.lex_state = 273},
  [5569] = {.lex_state = 284},
  [5570] = {.lex_state = 273},
  [5571] = {.lex_state = 381},
  [5572] = {.lex_state = 284},
  [5573] = {.lex_state = 284},
  [5574] = {.lex_state = 237},
  [5575] = {.lex_state = 381},
  [5576] = {.lex_state = 284},
  [5577] = {.lex_state = 281},
  [5578] = {.lex_state = 284},
  [5579] = {.lex_state = 273},
  [5580] = {.lex_state = 281},
  [5581] = {.lex_state = 284},
  [5582] = {.lex_state = 273},
  [5583] = {.lex_state = 273},
  [5584] = {.lex_state = 237},
  [5585] = {.lex_state = 381},
  [5586] = {.lex_state = 284},
  [5587] = {.lex_state = 273},
  [5588] = {.lex_state = 273},
  [5589] = {.lex_state = 284},
  [5590] = {.lex_state = 284},
  [5591] = {.lex_state = 273},
  [5592] = {.lex_state = 273},
  [5593] = {.lex_state = 284},
  [5594] = {.lex_state = 273},
  [5595] = {.lex_state = 284},
  [5596] = {.lex_state = 273},
  [5597] = {.lex_state = 273},
  [5598] = {.lex_state = 273},
  [5599] = {.lex_state = 237},
  [5600] = {.lex_state = 284},
  [5601] = {.lex_state = 237},
  [5602] = {.lex_state = 381},
  [5603] = {.lex_state = 273},
  [5604] = {.lex_state = 273},
  [5605] = {.lex_state = 273},
  [5606] = {.lex_state = 273},
  [5607] = {.lex_state = 273},
  [5608] = {.lex_state = 284},
  [5609] = {.lex_state = 273},
  [5610] = {.lex_state = 284},
  [5611] = {.lex_state = 226},
  [5612] = {.lex_state = 273},
  [5613] = {.lex_state = 284},
  [5614] = {.lex_state = 273},
  [5615] = {.lex_state = 284},
  [5616] = {.lex_state = 226},
  [5617] = {.lex_state = 237},
  [5618] = {.lex_state = 284},
  [5619] = {.lex_state = 284},
  [5620] = {.lex_state = 282},
  [5621] = {.lex_state = 237},
  [5622] = {.lex_state = 282},
  [5623] = {.lex_state = 282},
  [5624] = {.lex_state = 381},
  [5625] = {.lex_state = 282},
  [5626] = {.lex_state = 282},
  [5627] = {.lex_state = 282},
  [5628] = {.lex_state = 282},
  [5629] = {.lex_state = 282},
  [5630] = {.lex_state = 381},
  [5631] = {.lex_state = 381},
  [5632] = {.lex_state = 237},
  [5633] = {.lex_state = 381},
  [5634] = {.lex_state = 230},
  [5635] = {.lex_state = 284},
  [5636] = {.lex_state = 238},
  [5637] = {.lex_state = 282},
  [5638] = {.lex_state = 282},
  [5639] = {.lex_state = 238},
  [5640] = {.lex_state = 382},
  [5641] = {.lex_state = 284},
  [5642] = {.lex_state = 381},
  [5643] = {.lex_state = 382},
  [5644] = {.lex_state = 282},
  [5645] = {.lex_state = 282},
  [5646] = {.lex_state = 381},
  [5647] = {.lex_state = 282},
  [5648] = {.lex_state = 382},
  [5649] = {.lex_state = 284},
  [5650] = {.lex_state = 282},
  [5651] = {.lex_state = 282},
  [5652] = {.lex_state = 237},
  [5653] = {.lex_state = 282},
  [5654] = {.lex_state = 282},
  [5655] = {.lex_state = 284},
  [5656] = {.lex_state = 282},
  [5657] = {.lex_state = 381},
  [5658] = {.lex_state = 237},
  [5659] = {.lex_state = 282},
  [5660] = {.lex_state = 237},
  [5661] = {.lex_state = 282},
  [5662] = {.lex_state = 282},
  [5663] = {.lex_state = 284},
  [5664] = {.lex_state = 284},
  [5665] = {.lex_state = 282},
  [5666] = {.lex_state = 282},
  [5667] = {.lex_state = 284},
  [5668] = {.lex_state = 282},
  [5669] = {.lex_state = 282},
  [5670] = {.lex_state = 381},
  [5671] = {.lex_state = 237},
  [5672] = {.lex_state = 381},
  [5673] = {.lex_state = 282},
  [5674] = {.lex_state = 381},
  [5675] = {.lex_state = 381},
  [5676] = {.lex_state = 381},
  [5677] = {.lex_state = 282},
  [5678] = {.lex_state = 284},
  [5679] = {.lex_state = 381},
  [5680] = {.lex_state = 381},
  [5681] = {.lex_state = 284},
  [5682] = {.lex_state = 282},
  [5683] = {.lex_state = 281},
  [5684] = {.lex_state = 284},
  [5685] = {.lex_state = 381},
  [5686] = {.lex_state = 381},
  [5687] = {.lex_state = 282},
  [5688] = {.lex_state = 282},
  [5689] = {.lex_state = 282},
  [5690] = {.lex_state = 284},
  [5691] = {.lex_state = 282},
  [5692] = {.lex_state = 282},
  [5693] = {.lex_state = 282},
  [5694] = {.lex_state = 282},
  [5695] = {.lex_state = 284},
  [5696] = {.lex_state = 381},
  [5697] = {.lex_state = 281},
  [5698] = {.lex_state = 381},
  [5699] = {.lex_state = 281},
  [5700] = {.lex_state = 381},
  [5701] = {.lex_state = 282},
  [5702] = {.lex_state = 381},
  [5703] = {.lex_state = 284},
  [5704] = {.lex_state = 281},
  [5705] = {.lex_state = 282},
  [5706] = {.lex_state = 282},
  [5707] = {.lex_state = 381},
  [5708] = {.lex_state = 282},
  [5709] = {.lex_state = 381},
  [5710] = {.lex_state = 282},
  [5711] = {.lex_state = 282},
  [5712] = {.lex_state = 282},
  [5713] = {.lex_state = 381},
  [5714] = {.lex_state = 282},
  [5715] = {.lex_state = 282},
  [5716] = {.lex_state = 282},
  [5717] = {.lex_state = 282},
  [5718] = {.lex_state = 282},
  [5719] = {.lex_state = 282},
  [5720] = {.lex_state = 381},
  [5721] = {.lex_state = 282},
  [5722] = {.lex_state = 381},
  [5723] = {.lex_state = 237},
  [5724] = {.lex_state = 281},
  [5725] = {.lex_state = 282},
  [5726] = {.lex_state = 381},
  [5727] = {.lex_state = 282},
  [5728] = {.lex_state = 381},
  [5729] = {.lex_state = 381},
  [5730] = {.lex_state = 281},
  [5731] = {.lex_state = 282},
  [5732] = {.lex_state = 282},
  [5733] = {.lex_state = 282},
  [5734] = {.lex_state = 381},
  [5735] = {.lex_state = 381},
  [5736] = {.lex_state = 381},
  [5737] = {.lex_state = 282},
  [5738] = {.lex_state = 381},
  [5739] = {.lex_state = 381},
  [5740] = {.lex_state = 282},
  [5741] = {.lex_state = 381},
  [5742] = {.lex_state = 282},
  [5743] = {.lex_state = 381},
  [5744] = {.lex_state = 282},
  [5745] = {.lex_state = 282},
  [5746] = {.lex_state = 282},
  [5747] = {.lex_state = 282},
  [5748] = {.lex_state = 281},
  [5749] = {.lex_state = 381},
  [5750] = {.lex_state = 282},
  [5751] = {.lex_state = 282},
  [5752] = {.lex_state = 381},
  [5753] = {.lex_state = 381},
  [5754] = {.lex_state = 281},
  [5755] = {.lex_state = 381},
  [5756] = {.lex_state = 284},
  [5757] = {.lex_state = 282},
  [5758] = {.lex_state = 381},
  [5759] = {.lex_state = 381},
  [5760] = {.lex_state = 284},
  [5761] = {.lex_state = 381},
  [5762] = {.lex_state = 282},
  [5763] = {.lex_state = 282},
  [5764] = {.lex_state = 282},
  [5765] = {.lex_state = 282},
  [5766] = {.lex_state = 282},
  [5767] = {.lex_state = 381},
  [5768] = {.lex_state = 381},
  [5769] = {.lex_state = 282},
  [5770] = {.lex_state = 281},
  [5771] = {.lex_state = 381},
  [5772] = {.lex_state = 381},
  [5773] = {.lex_state = 282},
  [5774] = {.lex_state = 381},
  [5775] = {.lex_state = 282},
  [5776] = {.lex_state = 282},
  [5777] = {.lex_state = 281},
  [5778] = {.lex_state = 282},
  [5779] = {.lex_state = 282},
  [5780] = {.lex_state = 226},
  [5781] = {.lex_state = 282},
  [5782] = {.lex_state = 381},
  [5783] = {.lex_state = 381},
  [5784] = {.lex_state = 381},
  [5785] = {.lex_state = 282},
  [5786] = {.lex_state = 381},
  [5787] = {.lex_state = 282},
  [5788] = {.lex_state = 282},
  [5789] = {.lex_state = 381},
  [5790] = {.lex_state = 282},
  [5791] = {.lex_state = 381},
  [5792] = {.lex_state = 381},
  [5793] = {.lex_state = 381},
  [5794] = {.lex_state = 282},
  [5795] = {.lex_state = 381},
  [5796] = {.lex_state = 381},
  [5797] = {.lex_state = 282},
  [5798] = {.lex_state = 381},
  [5799] = {.lex_state = 381},
  [5800] = {.lex_state = 381},
  [5801] = {.lex_state = 381},
  [5802] = {.lex_state = 282},
  [5803] = {.lex_state = 282},
  [5804] = {.lex_state = 282},
  [5805] = {.lex_state = 282},
  [5806] = {.lex_state = 381},
  [5807] = {.lex_state = 282},
  [5808] = {.lex_state = 226},
  [5809] = {.lex_state = 381},
  [5810] = {.lex_state = 282},
  [5811] = {.lex_state = 282},
  [5812] = {.lex_state = 282},
  [5813] = {.lex_state = 226},
  [5814] = {.lex_state = 381},
  [5815] = {.lex_state = 282},
  [5816] = {.lex_state = 381},
  [5817] = {.lex_state = 381},
  [5818] = {.lex_state = 282},
  [5819] = {.lex_state = 282},
  [5820] = {.lex_state = 226},
  [5821] = {.lex_state = 381},
  [5822] = {.lex_state = 282},
  [5823] = {.lex_state = 284},
  [5824] = {.lex_state = 238},
  [5825] = {.lex_state = 284},
  [5826] = {.lex_state = 226},
  [5827] = {.lex_state = 284},
  [5828] = {.lex_state = 281},
  [5829] = {.lex_state = 281},
  [5830] = {.lex_state = 381},
  [5831] = {.lex_state = 284},
  [5832] = {.lex_state = 238},
  [5833] = {.lex_state = 238},
  [5834] = {.lex_state = 238},
  [5835] = {.lex_state = 284},
  [5836] = {.lex_state = 282},
  [5837] = {.lex_state = 226},
  [5838] = {.lex_state = 284},
  [5839] = {.lex_state = 226},
  [5840] = {.lex_state = 238},
  [5841] = {.lex_state = 284},
  [5842] = {.lex_state = 284},
  [5843] = {.lex_state = 238},
  [5844] = {.lex_state = 226},
  [5845] = {.lex_state = 284},
  [5846] = {.lex_state = 273},
  [5847] = {.lex_state = 284},
  [5848] = {.lex_state = 226},
  [5849] = {.lex_state = 381},
  [5850] = {.lex_state = 238},
  [5851] = {.lex_state = 230},
  [5852] = {.lex_state = 273},
  [5853] = {.lex_state = 284},
  [5854] = {.lex_state = 284},
  [5855] = {.lex_state = 381},
  [5856] = {.lex_state = 284},
  [5857] = {.lex_state = 381},
  [5858] = {.lex_state = 226},
  [5859] = {.lex_state = 284},
  [5860] = {.lex_state = 238},
  [5861] = {.lex_state = 230},
  [5862] = {.lex_state = 281},
  [5863] = {.lex_state = 281},
  [5864] = {.lex_state = 381},
  [5865] = {.lex_state = 381},
  [5866] = {.lex_state = 284},
  [5867] = {.lex_state = 381},
  [5868] = {.lex_state = 237},
  [5869] = {.lex_state = 284},
  [5870] = {.lex_state = 281},
  [5871] = {.lex_state = 281},
  [5872] = {.lex_state = 381},
  [5873] = {.lex_state = 284},
  [5874] = {.lex_state = 284},
  [5875] = {.lex_state = 284},
  [5876] = {.lex_state = 284},
  [5877] = {.lex_state = 281},
  [5878] = {.lex_state = 281},
  [5879] = {.lex_state = 381},
  [5880] = {.lex_state = 284},
  [5881] = {.lex_state = 381},
  [5882] = {.lex_state = 284},
  [5883] = {.lex_state = 281},
  [5884] = {.lex_state = 381},
  [5885] = {.lex_state = 237},
  [5886] = {.lex_state = 284},
  [5887] = {.lex_state = 381},
  [5888] = {.lex_state = 237},
  [5889] = {.lex_state = 237},
  [5890] = {.lex_state = 284},
  [5891] = {.lex_state = 284},
  [5892] = {.lex_state = 284},
  [5893] = {.lex_state = 284},
  [5894] = {.lex_state = 284},
  [5895] = {.lex_state = 284},
  [5896] = {.lex_state = 281},
  [5897] = {.lex_state = 284},
  [5898] = {.lex_state = 381},
  [5899] = {.lex_state = 238},
  [5900] = {.lex_state = 282},
  [5901] = {.lex_state = 282},
  [5902] = {.lex_state = 237},
  [5903] = {.lex_state = 284},
  [5904] = {.lex_state = 284},
  [5905] = {.lex_state = 237},
  [5906] = {.lex_state = 284},
  [5907] = {.lex_state = 237},
  [5908] = {.lex_state = 244},
  [5909] = {.lex_state = 284},
  [5910] = {.lex_state = 284},
  [5911] = {.lex_state = 284},
  [5912] = {.lex_state = 284},
  [5913] = {.lex_state = 284},
  [5914] = {.lex_state = 244},
  [5915] = {.lex_state = 284},
  [5916] = {.lex_state = 381},
  [5917] = {.lex_state = 284},
  [5918] = {.lex_state = 284},
  [5919] = {.lex_state = 284},
  [5920] = {.lex_state = 282},
  [5921] = {.lex_state = 284},
  [5922] = {.lex_state = 284},
  [5923] = {.lex_state = 284},
  [5924] = {.lex_state = 381},
  [5925] = {.lex_state = 244},
  [5926] = {.lex_state = 284},
  [5927] = {.lex_state = 284},
  [5928] = {.lex_state = 284},
  [5929] = {.lex_state = 284},
  [5930] = {.lex_state = 244},
  [5931] = {.lex_state = 284},
  [5932] = {.lex_state = 244},
  [5933] = {.lex_state = 284},
  [5934] = {.lex_state = 284},
  [5935] = {.lex_state = 284},
  [5936] = {.lex_state = 284},
  [5937] = {.lex_state = 244},
  [5938] = {.lex_state = 237},
  [5939] = {.lex_state = 284},
  [5940] = {.lex_state = 284},
  [5941] = {.lex_state = 237},
  [5942] = {.lex_state = 244},
  [5943] = {.lex_state = 284},
  [5944] = {.lex_state = 284},
  [5945] = {.lex_state = 284},
  [5946] = {.lex_state = 237},
  [5947] = {.lex_state = 237},
  [5948] = {.lex_state = 284},
  [5949] = {.lex_state = 284},
  [5950] = {.lex_state = 237},
  [5951] = {.lex_state = 381},
  [5952] = {.lex_state = 244},
  [5953] = {.lex_state = 381},
  [5954] = {.lex_state = 237},
  [5955] = {.lex_state = 282},
  [5956] = {.lex_state = 284},
  [5957] = {.lex_state = 284},
  [5958] = {.lex_state = 381},
  [5959] = {.lex_state = 244},
  [5960] = {.lex_state = 244},
  [5961] = {.lex_state = 244},
  [5962] = {.lex_state = 244},
  [5963] = {.lex_state = 237},
  [5964] = {.lex_state = 244},
  [5965] = {.lex_state = 244},
  [5966] = {.lex_state = 282},
  [5967] = {.lex_state = 237},
  [5968] = {.lex_state = 282},
  [5969] = {.lex_state = 244},
  [5970] = {.lex_state = 244},
  [5971] = {.lex_state = 244},
  [5972] = {.lex_state = 244},
  [5973] = {.lex_state = 244},
  [5974] = {.lex_state = 281},
  [5975] = {.lex_state = 244},
  [5976] = {.lex_state = 237},
  [5977] = {.lex_state = 244},
  [5978] = {.lex_state = 237},
  [5979] = {.lex_state = 237},
  [5980] = {.lex_state = 244},
  [5981] = {.lex_state = 281},
  [5982] = {.lex_state = 237},
  [5983] = {.lex_state = 244},
  [5984] = {.lex_state = 237},
  [5985] = {.lex_state = 282},
  [5986] = {.lex_state = 282},
  [5987] = {.lex_state = 244},
  [5988] = {.lex_state = 237},
  [5989] = {.lex_state = 282},
  [5990] = {.lex_state = 282},
  [5991] = {.lex_state = 238},
  [5992] = {.lex_state = 244},
  [5993] = {.lex_state = 244},
  [5994] = {.lex_state = 244},
  [5995] = {.lex_state = 244},
  [5996] = {.lex_state = 237},
  [5997] = {.lex_state = 244},
  [5998] = {.lex_state = 244},
  [5999] = {.lex_state = 282},
  [6000] = {.lex_state = 237},
  [6001] = {.lex_state = 244},
  [6002] = {.lex_state = 244},
  [6003] = {.lex_state = 244},
  [6004] = {.lex_state = 244},
  [6005] = {.lex_state = 237},
  [6006] = {.lex_state = 237},
  [6007] = {.lex_state = 237},
  [6008] = {.lex_state = 244},
  [6009] = {.lex_state = 244},
  [6010] = {.lex_state = 244},
  [6011] = {.lex_state = 244},
  [6012] = {.lex_state = 244},
  [6013] = {.lex_state = 244},
  [6014] = {.lex_state = 237},
  [6015] = {.lex_state = 244},
  [6016] = {.lex_state = 244},
  [6017] = {.lex_state = 244},
  [6018] = {.lex_state = 244},
  [6019] = {.lex_state = 244},
  [6020] = {.lex_state = 237},
  [6021] = {.lex_state = 244},
  [6022] = {.lex_state = 237},
  [6023] = {.lex_state = 244},
  [6024] = {.lex_state = 238},
  [6025] = {.lex_state = 244},
  [6026] = {.lex_state = 244},
  [6027] = {.lex_state = 238},
  [6028] = {.lex_state = 244},
  [6029] = {.lex_state = 244},
  [6030] = {.lex_state = 237},
  [6031] = {.lex_state = 244},
  [6032] = {.lex_state = 237},
  [6033] = {.lex_state = 244},
  [6034] = {.lex_state = 244},
  [6035] = {.lex_state = 237},
  [6036] = {.lex_state = 244},
  [6037] = {.lex_state = 244},
  [6038] = {.lex_state = 244},
  [6039] = {.lex_state = 244},
  [6040] = {.lex_state = 244},
  [6041] = {.lex_state = 244},
  [6042] = {.lex_state = 244},
  [6043] = {.lex_state = 282},
  [6044] = {.lex_state = 237},
  [6045] = {.lex_state = 244},
  [6046] = {.lex_state = 238},
  [6047] = {.lex_state = 237},
  [6048] = {.lex_state = 244},
  [6049] = {.lex_state = 244},
  [6050] = {.lex_state = 244},
  [6051] = {.lex_state = 244},
  [6052] = {.lex_state = 237},
  [6053] = {.lex_state = 244},
  [6054] = {.lex_state = 244},
  [6055] = {.lex_state = 244},
  [6056] = {.lex_state = 237},
  [6057] = {.lex_state = 244},
  [6058] = {.lex_state = 244},
  [6059] = {.lex_state = 237},
  [6060] = {.lex_state = 244},
  [6061] = {.lex_state = 282},
  [6062] = {.lex_state = 244},
  [6063] = {.lex_state = 237},
  [6064] = {.lex_state = 237},
  [6065] = {.lex_state = 237},
  [6066] = {.lex_state = 237},
  [6067] = {.lex_state = 244},
  [6068] = {.lex_state = 244},
  [6069] = {.lex_state = 244},
  [6070] = {.lex_state = 244},
  [6071] = {.lex_state = 244},
  [6072] = {.lex_state = 244},
  [6073] = {.lex_state = 244},
  [6074] = {.lex_state = 244},
  [6075] = {.lex_state = 244},
  [6076] = {.lex_state = 237},
  [6077] = {.lex_state = 244},
  [6078] = {.lex_state = 244},
  [6079] = {.lex_state = 244},
  [6080] = {.lex_state = 244},
  [6081] = {.lex_state = 244},
  [6082] = {.lex_state = 237},
  [6083] = {.lex_state = 244},
  [6084] = {.lex_state = 244},
  [6085] = {.lex_state = 237},
  [6086] = {.lex_state = 244},
  [6087] = {.lex_state = 244},
  [6088] = {.lex_state = 244},
  [6089] = {.lex_state = 237},
  [6090] = {.lex_state = 244},
  [6091] = {.lex_state = 244},
  [6092] = {.lex_state = 281},
  [6093] = {.lex_state = 281},
  [6094] = {.lex_state = 244},
  [6095] = {.lex_state = 282},
  [6096] = {.lex_state = 237},
  [6097] = {.lex_state = 282},
  [6098] = {.lex_state = 281},
  [6099] = {.lex_state = 282},
  [6100] = {.lex_state = 282},
  [6101] = {.lex_state = 282},
  [6102] = {.lex_state = 281},
  [6103] = {.lex_state = 282},
  [6104] = {.lex_state = 282},
  [6105] = {.lex_state = 244},
  [6106] = {.lex_state = 244},
  [6107] = {.lex_state = 244},
  [6108] = {.lex_state = 244},
  [6109] = {.lex_state = 244},
  [6110] = {.lex_state = 281},
  [6111] = {.lex_state = 244},
  [6112] = {.lex_state = 244},
  [6113] = {.lex_state = 244},
  [6114] = {.lex_state = 244},
  [6115] = {.lex_state = 244},
  [6116] = {.lex_state = 282},
  [6117] = {.lex_state = 244},
  [6118] = {.lex_state = 281},
  [6119] = {.lex_state = 282},
  [6120] = {.lex_state = 244},
  [6121] = {.lex_state = 244},
  [6122] = {.lex_state = 244},
  [6123] = {.lex_state = 244},
  [6124] = {.lex_state = 281},
  [6125] = {.lex_state = 244},
  [6126] = {.lex_state = 244},
  [6127] = {.lex_state = 282},
  [6128] = {.lex_state = 282},
  [6129] = {.lex_state = 244},
  [6130] = {.lex_state = 282},
  [6131] = {.lex_state = 244},
  [6132] = {.lex_state = 281},
  [6133] = {.lex_state = 282},
  [6134] = {.lex_state = 281},
  [6135] = {.lex_state = 244},
  [6136] = {.lex_state = 282},
  [6137] = {.lex_state = 233},
  [6138] = {.lex_state = 381},
  [6139] = {.lex_state = 381},
  [6140] = {.lex_state = 381},
  [6141] = {.lex_state = 381},
  [6142] = {.lex_state = 233},
  [6143] = {.lex_state = 233},
  [6144] = {.lex_state = 238},
  [6145] = {.lex_state = 381},
  [6146] = {.lex_state = 381},
  [6147] = {.lex_state = 233},
  [6148] = {.lex_state = 238},
  [6149] = {.lex_state = 233},
  [6150] = {.lex_state = 233},
  [6151] = {.lex_state = 233},
  [6152] = {.lex_state = 233},
  [6153] = {.lex_state = 381},
  [6154] = {.lex_state = 381},
  [6155] = {.lex_state = 381},
  [6156] = {.lex_state = 281},
  [6157] = {.lex_state = 381},
  [6158] = {.lex_state = 281},
  [6159] = {.lex_state = 282},
  [6160] = {.lex_state = 282},
  [6161] = {.lex_state = 282},
  [6162] = {.lex_state = 281},
  [6163] = {.lex_state = 281},
  [6164] = {.lex_state = 281},
  [6165] = {.lex_state = 381},
  [6166] = {.lex_state = 281},
  [6167] = {.lex_state = 381},
  [6168] = {.lex_state = 281},
  [6169] = {.lex_state = 381},
  [6170] = {.lex_state = 381},
  [6171] = {.lex_state = 281},
  [6172] = {.lex_state = 281},
  [6173] = {.lex_state = 282},
  [6174] = {.lex_state = 381},
  [6175] = {.lex_state = 281},
  [6176] = {.lex_state = 281},
  [6177] = {.lex_state = 282},
  [6178] = {.lex_state = 282},
  [6179] = {.lex_state = 381},
  [6180] = {.lex_state = 381},
  [6181] = {.lex_state = 281},
  [6182] = {.lex_state = 284},
  [6183] = {.lex_state = 381},
  [6184] = {.lex_state = 282},
  [6185] = {.lex_state = 380},
  [6186] = {.lex_state = 244},
  [6187] = {.lex_state = 380},
  [6188] = {.lex_state = 244},
  [6189] = {.lex_state = 244},
  [6190] = {.lex_state = 244},
  [6191] = {.lex_state = 380},
  [6192] = {.lex_state = 244},
  [6193] = {.lex_state = 380},
  [6194] = {.lex_state = 244},
  [6195] = {.lex_state = 380},
  [6196] = {.lex_state = 244},
  [6197] = {.lex_state = 380},
  [6198] = {.lex_state = 380},
  [6199] = {.lex_state = 244},
  [6200] = {.lex_state = 244},
  [6201] = {.lex_state = 244},
  [6202] = {.lex_state = 380},
  [6203] = {.lex_state = 380},
  [6204] = {.lex_state = 244},
  [6205] = {.lex_state = 244},
  [6206] = {.lex_state = 284},
  [6207] = {.lex_state = 281},
  [6208] = {.lex_state = 281},
  [6209] = {.lex_state = 226},
  [6210] = {.lex_state = 281},
  [6211] = {.lex_state = 281},
  [6212] = {.lex_state = 381},
  [6213] = {.lex_state = 281},
  [6214] = {.lex_state = 238},
  [6215] = {.lex_state = 381},
  [6216] = {.lex_state = 281},
  [6217] = {.lex_state = 281},
  [6218] = {.lex_state = 205},
  [6219] = {.lex_state = 205},
  [6220] = {.lex_state = 205},
  [6221] = {.lex_state = 284},
  [6222] = {.lex_state = 380},
  [6223] = {.lex_state = 205},
  [6224] = {.lex_state = 205},
  [6225] = {.lex_state = 233},
  [6226] = {.lex_state = 233},
  [6227] = {.lex_state = 205},
  [6228] = {.lex_state = 233},
  [6229] = {.lex_state = 380},
  [6230] = {.lex_state = 205},
  [6231] = {.lex_state = 233},
  [6232] = {.lex_state = 380},
  [6233] = {.lex_state = 205},
  [6234] = {.lex_state = 380},
  [6235] = {.lex_state = 380},
  [6236] = {.lex_state = 380},
  [6237] = {.lex_state = 205},
  [6238] = {.lex_state = 380},
  [6239] = {.lex_state = 380},
  [6240] = {.lex_state = 380},
  [6241] = {.lex_state = 281},
  [6242] = {.lex_state = 380},
  [6243] = {.lex_state = 380},
  [6244] = {.lex_state = 205},
  [6245] = {.lex_state = 380},
  [6246] = {.lex_state = 205},
  [6247] = {.lex_state = 380},
  [6248] = {.lex_state = 205},
  [6249] = {.lex_state = 205},
  [6250] = {.lex_state = 226},
  [6251] = {.lex_state = 380},
  [6252] = {.lex_state = 205},
  [6253] = {.lex_state = 233},
  [6254] = {.lex_state = 226},
  [6255] = {.lex_state = 380},
  [6256] = {.lex_state = 205},
  [6257] = {.lex_state = 205},
  [6258] = {.lex_state = 233},
  [6259] = {.lex_state = 381},
  [6260] = {.lex_state = 205},
  [6261] = {.lex_state = 380},
  [6262] = {.lex_state = 205},
  [6263] = {.lex_state = 233},
  [6264] = {.lex_state = 380},
  [6265] = {.lex_state = 205},
  [6266] = {.lex_state = 205},
  [6267] = {.lex_state = 380},
  [6268] = {.lex_state = 380},
  [6269] = {.lex_state = 380},
  [6270] = {.lex_state = 205},
  [6271] = {.lex_state = 233},
  [6272] = {.lex_state = 380},
  [6273] = {.lex_state = 205},
  [6274] = {.lex_state = 205},
  [6275] = {.lex_state = 380},
  [6276] = {.lex_state = 381},
  [6277] = {.lex_state = 205},
  [6278] = {.lex_state = 226},
  [6279] = {.lex_state = 381},
  [6280] = {.lex_state = 205},
  [6281] = {.lex_state = 205},
  [6282] = {.lex_state = 205},
  [6283] = {.lex_state = 205},
  [6284] = {.lex_state = 205},
  [6285] = {.lex_state = 380},
  [6286] = {.lex_state = 380},
  [6287] = {.lex_state = 205},
  [6288] = {.lex_state = 233},
  [6289] = {.lex_state = 205},
  [6290] = {.lex_state = 380},
  [6291] = {.lex_state = 205},
  [6292] = {.lex_state = 233},
  [6293] = {.lex_state = 205},
  [6294] = {.lex_state = 205},
  [6295] = {.lex_state = 380},
  [6296] = {.lex_state = 380},
  [6297] = {.lex_state = 233},
  [6298] = {.lex_state = 205},
  [6299] = {.lex_state = 238},
  [6300] = {.lex_state = 205},
  [6301] = {.lex_state = 205},
  [6302] = {.lex_state = 380},
  [6303] = {.lex_state = 380},
  [6304] = {.lex_state = 205},
  [6305] = {.lex_state = 380},
  [6306] = {.lex_state = 381},
  [6307] = {.lex_state = 233},
  [6308] = {.lex_state = 380},
  [6309] = {.lex_state = 205},
  [6310] = {.lex_state = 380},
  [6311] = {.lex_state = 380},
  [6312] = {.lex_state = 380},
  [6313] = {.lex_state = 381},
  [6314] = {.lex_state = 205},
  [6315] = {.lex_state = 380},
  [6316] = {.lex_state = 380},
  [6317] = {.lex_state = 380},
  [6318] = {.lex_state = 205},
  [6319] = {.lex_state = 380},
  [6320] = {.lex_state = 252},
  [6321] = {.lex_state = 380},
  [6322] = {.lex_state = 205},
  [6323] = {.lex_state = 380},
  [6324] = {.lex_state = 380},
  [6325] = {.lex_state = 380},
  [6326] = {.lex_state = 380},
  [6327] = {.lex_state = 281},
  [6328] = {.lex_state = 380},
  [6329] = {.lex_state = 380},
  [6330] = {.lex_state = 281},
  [6331] = {.lex_state = 205},
  [6332] = {.lex_state = 205},
  [6333] = {.lex_state = 244},
  [6334] = {.lex_state = 244},
  [6335] = {.lex_state = 244},
  [6336] = {.lex_state = 244},
  [6337] = {.lex_state = 244},
  [6338] = {.lex_state = 244},
  [6339] = {.lex_state = 244},
  [6340] = {.lex_state = 244},
  [6341] = {.lex_state = 244},
  [6342] = {.lex_state = 244},
  [6343] = {.lex_state = 244},
  [6344] = {.lex_state = 244},
  [6345] = {.lex_state = 244},
  [6346] = {.lex_state = 244},
  [6347] = {.lex_state = 244},
  [6348] = {.lex_state = 244},
  [6349] = {.lex_state = 244},
  [6350] = {.lex_state = 244},
  [6351] = {.lex_state = 244},
  [6352] = {.lex_state = 244},
  [6353] = {.lex_state = 244},
  [6354] = {.lex_state = 244},
  [6355] = {.lex_state = 244},
  [6356] = {.lex_state = 244},
  [6357] = {.lex_state = 244},
  [6358] = {.lex_state = 244},
  [6359] = {.lex_state = 244},
  [6360] = {.lex_state = 244},
  [6361] = {.lex_state = 244},
  [6362] = {.lex_state = 244},
  [6363] = {.lex_state = 244},
  [6364] = {.lex_state = 244},
  [6365] = {.lex_state = 244},
  [6366] = {.lex_state = 244},
  [6367] = {.lex_state = 244},
  [6368] = {.lex_state = 244},
  [6369] = {.lex_state = 244},
  [6370] = {.lex_state = 244},
  [6371] = {.lex_state = 244},
  [6372] = {.lex_state = 244},
  [6373] = {.lex_state = 244},
  [6374] = {.lex_state = 244},
  [6375] = {.lex_state = 244},
  [6376] = {.lex_state = 244},
  [6377] = {.lex_state = 244},
  [6378] = {.lex_state = 244},
  [6379] = {.lex_state = 244},
  [6380] = {.lex_state = 244},
  [6381] = {.lex_state = 244},
  [6382] = {.lex_state = 244},
  [6383] = {.lex_state = 381},
  [6384] = {.lex_state = 244},
  [6385] = {.lex_state = 244},
  [6386] = {.lex_state = 244},
  [6387] = {.lex_state = 226},
  [6388] = {.lex_state = 244},
  [6389] = {.lex_state = 244},
  [6390] = {.lex_state = 244},
  [6391] = {.lex_state = 244},
  [6392] = {.lex_state = 244},
  [6393] = {.lex_state = 244},
  [6394] = {.lex_state = 244},
  [6395] = {.lex_state = 244},
  [6396] = {.lex_state = 244},
  [6397] = {.lex_state = 244},
  [6398] = {.lex_state = 244},
  [6399] = {.lex_state = 244},
  [6400] = {.lex_state = 244},
  [6401] = {.lex_state = 109},
  [6402] = {.lex_state = 244},
  [6403] = {.lex_state = 244},
  [6404] = {.lex_state = 244},
  [6405] = {.lex_state = 244},
  [6406] = {.lex_state = 244},
  [6407] = {.lex_state = 244},
  [6408] = {.lex_state = 244},
  [6409] = {.lex_state = 244},
  [6410] = {.lex_state = 252},
  [6411] = {.lex_state = 244},
  [6412] = {.lex_state = 244},
  [6413] = {.lex_state = 244},
  [6414] = {.lex_state = 244},
  [6415] = {.lex_state = 252},
  [6416] = {.lex_state = 244},
  [6417] = {.lex_state = 244},
  [6418] = {.lex_state = 244},
  [6419] = {.lex_state = 244},
  [6420] = {.lex_state = 244},
  [6421] = {.lex_state = 226},
  [6422] = {.lex_state = 244},
  [6423] = {.lex_state = 244},
  [6424] = {.lex_state = 244},
  [6425] = {.lex_state = 244},
  [6426] = {.lex_state = 244},
  [6427] = {.lex_state = 244},
  [6428] = {.lex_state = 244},
  [6429] = {.lex_state = 244},
  [6430] = {.lex_state = 244},
  [6431] = {.lex_state = 252},
  [6432] = {.lex_state = 244},
  [6433] = {.lex_state = 244},
  [6434] = {.lex_state = 244},
  [6435] = {.lex_state = 244},
  [6436] = {.lex_state = 244},
  [6437] = {.lex_state = 244},
  [6438] = {.lex_state = 244},
  [6439] = {.lex_state = 244},
  [6440] = {.lex_state = 226},
  [6441] = {.lex_state = 252},
  [6442] = {.lex_state = 226},
  [6443] = {.lex_state = 226},
  [6444] = {.lex_state = 282},
  [6445] = {.lex_state = 282},
  [6446] = {.lex_state = 226},
  [6447] = {.lex_state = 282},
  [6448] = {.lex_state = 282},
  [6449] = {.lex_state = 226},
  [6450] = {.lex_state = 282},
  [6451] = {.lex_state = 252},
  [6452] = {.lex_state = 282},
  [6453] = {.lex_state = 226},
  [6454] = {.lex_state = 282},
  [6455] = {.lex_state = 226},
  [6456] = {.lex_state = 281},
  [6457] = {.lex_state = 226},
  [6458] = {.lex_state = 282},
  [6459] = {.lex_state = 226},
  [6460] = {.lex_state = 281},
  [6461] = {.lex_state = 282},
  [6462] = {.lex_state = 282},
  [6463] = {.lex_state = 282},
  [6464] = {.lex_state = 252},
  [6465] = {.lex_state = 282},
  [6466] = {.lex_state = 282},
  [6467] = {.lex_state = 282},
  [6468] = {.lex_state = 281},
  [6469] = {.lex_state = 282},
  [6470] = {.lex_state = 282},
  [6471] = {.lex_state = 226},
  [6472] = {.lex_state = 282},
  [6473] = {.lex_state = 226},
  [6474] = {.lex_state = 226},
  [6475] = {.lex_state = 226},
  [6476] = {.lex_state = 281},
  [6477] = {.lex_state = 252},
  [6478] = {.lex_state = 381},
  [6479] = {.lex_state = 381},
  [6480] = {.lex_state = 281},
  [6481] = {.lex_state = 282},
  [6482] = {.lex_state = 226},
  [6483] = {.lex_state = 282},
  [6484] = {.lex_state = 252},
  [6485] = {.lex_state = 252},
  [6486] = {.lex_state = 281},
  [6487] = {.lex_state = 282},
  [6488] = {.lex_state = 252},
  [6489] = {.lex_state = 252},
  [6490] = {.lex_state = 252},
  [6491] = {.lex_state = 282},
  [6492] = {.lex_state = 252},
  [6493] = {.lex_state = 252},
  [6494] = {.lex_state = 282},
  [6495] = {.lex_state = 252},
  [6496] = {.lex_state = 252},
  [6497] = {.lex_state = 226},
  [6498] = {.lex_state = 252},
  [6499] = {.lex_state = 281},
  [6500] = {.lex_state = 252},
  [6501] = {.lex_state = 252},
  [6502] = {.lex_state = 252},
  [6503] = {.lex_state = 226},
  [6504] = {.lex_state = 252},
  [6505] = {.lex_state = 252},
  [6506] = {.lex_state = 281},
  [6507] = {.lex_state = 226},
  [6508] = {.lex_state = 281},
  [6509] = {.lex_state = 237},
  [6510] = {.lex_state = 252},
  [6511] = {.lex_state = 226},
  [6512] = {.lex_state = 252},
  [6513] = {.lex_state = 381},
  [6514] = {.lex_state = 281},
  [6515] = {.lex_state = 282},
  [6516] = {.lex_state = 281},
  [6517] = {.lex_state = 381},
  [6518] = {.lex_state = 282},
  [6519] = {.lex_state = 109},
  [6520] = {.lex_state = 109},
  [6521] = {.lex_state = 109},
  [6522] = {.lex_state = 281},
  [6523] = {.lex_state = 381},
  [6524] = {.lex_state = 109},
  [6525] = {.lex_state = 109},
  [6526] = {.lex_state = 244},
  [6527] = {.lex_state = 381},
  [6528] = {.lex_state = 109},
  [6529] = {.lex_state = 281},
  [6530] = {.lex_state = 281},
  [6531] = {.lex_state = 281},
  [6532] = {.lex_state = 244},
  [6533] = {.lex_state = 282},
  [6534] = {.lex_state = 381},
  [6535] = {.lex_state = 381},
  [6536] = {.lex_state = 281},
  [6537] = {.lex_state = 381},
  [6538] = {.lex_state = 282},
  [6539] = {.lex_state = 109},
  [6540] = {.lex_state = 281},
  [6541] = {.lex_state = 381},
  [6542] = {.lex_state = 109},
  [6543] = {.lex_state = 282},
  [6544] = {.lex_state = 381},
  [6545] = {.lex_state = 109},
  [6546] = {.lex_state = 109},
  [6547] = {.lex_state = 381},
  [6548] = {.lex_state = 381},
  [6549] = {.lex_state = 282},
  [6550] = {.lex_state = 109},
  [6551] = {.lex_state = 109},
  [6552] = {.lex_state = 381},
  [6553] = {.lex_state = 381},
  [6554] = {.lex_state = 282},
  [6555] = {.lex_state = 282},
  [6556] = {.lex_state = 381},
  [6557] = {.lex_state = 109},
  [6558] = {.lex_state = 109},
  [6559] = {.lex_state = 109},
  [6560] = {.lex_state = 381},
  [6561] = {.lex_state = 381},
  [6562] = {.lex_state = 381},
  [6563] = {.lex_state = 282},
  [6564] = {.lex_state = 381},
  [6565] = {.lex_state = 381},
  [6566] = {.lex_state = 381},
  [6567] = {.lex_state = 381},
  [6568] = {.lex_state = 381},
  [6569] = {.lex_state = 282},
  [6570] = {.lex_state = 109},
  [6571] = {.lex_state = 281},
  [6572] = {.lex_state = 381},
  [6573] = {.lex_state = 109},
  [6574] = {.lex_state = 109},
  [6575] = {.lex_state = 381},
  [6576] = {.lex_state = 381},
  [6577] = {.lex_state = 226},
  [6578] = {.lex_state = 109},
  [6579] = {.lex_state = 109},
  [6580] = {.lex_state = 282},
  [6581] = {.lex_state = 109},
  [6582] = {.lex_state = 381},
  [6583] = {.lex_state = 381},
  [6584] = {.lex_state = 244},
  [6585] = {.lex_state = 282},
  [6586] = {.lex_state = 282},
  [6587] = {.lex_state = 381},
  [6588] = {.lex_state = 281},
  [6589] = {.lex_state = 381},
  [6590] = {.lex_state = 281},
  [6591] = {.lex_state = 281},
  [6592] = {.lex_state = 284},
  [6593] = {.lex_state = 381},
  [6594] = {.lex_state = 381},
  [6595] = {.lex_state = 109},
  [6596] = {.lex_state = 381},
  [6597] = {.lex_state = 381},
  [6598] = {.lex_state = 282},
  [6599] = {.lex_state = 381},
  [6600] = {.lex_state = 282},
  [6601] = {.lex_state = 381},
  [6602] = {.lex_state = 381},
  [6603] = {.lex_state = 109},
  [6604] = {.lex_state = 244},
  [6605] = {.lex_state = 252},
  [6606] = {.lex_state = 109},
  [6607] = {.lex_state = 109},
  [6608] = {.lex_state = 381},
  [6609] = {.lex_state = 381},
  [6610] = {.lex_state = 281},
  [6611] = {.lex_state = 381},
  [6612] = {.lex_state = 381},
  [6613] = {.lex_state = 381},
  [6614] = {.lex_state = 381},
  [6615] = {.lex_state = 381},
  [6616] = {.lex_state = 226},
  [6617] = {.lex_state = 281},
  [6618] = {.lex_state = 381},
  [6619] = {.lex_state = 109},
  [6620] = {.lex_state = 282},
  [6621] = {.lex_state = 281},
  [6622] = {.lex_state = 109},
  [6623] = {.lex_state = 381},
  [6624] = {.lex_state = 381},
  [6625] = {.lex_state = 381},
  [6626] = {.lex_state = 282},
  [6627] = {.lex_state = 226},
  [6628] = {.lex_state = 281},
  [6629] = {.lex_state = 282},
  [6630] = {.lex_state = 381},
  [6631] = {.lex_state = 282},
  [6632] = {.lex_state = 282},
  [6633] = {.lex_state = 281},
  [6634] = {.lex_state = 109},
  [6635] = {.lex_state = 281},
  [6636] = {.lex_state = 109},
  [6637] = {.lex_state = 281},
  [6638] = {.lex_state = 281},
  [6639] = {.lex_state = 109},
  [6640] = {.lex_state = 282},
  [6641] = {.lex_state = 282},
  [6642] = {.lex_state = 226},
  [6643] = {.lex_state = 281},
  [6644] = {.lex_state = 109},
  [6645] = {.lex_state = 109},
  [6646] = {.lex_state = 226},
  [6647] = {.lex_state = 381},
  [6648] = {.lex_state = 109},
  [6649] = {.lex_state = 281},
  [6650] = {.lex_state = 282},
  [6651] = {.lex_state = 381},
  [6652] = {.lex_state = 109},
  [6653] = {.lex_state = 282},
  [6654] = {.lex_state = 109},
  [6655] = {.lex_state = 252},
  [6656] = {.lex_state = 109},
  [6657] = {.lex_state = 226},
  [6658] = {.lex_state = 282},
  [6659] = {.lex_state = 281},
  [6660] = {.lex_state = 381},
  [6661] = {.lex_state = 381},
  [6662] = {.lex_state = 282},
  [6663] = {.lex_state = 381},
  [6664] = {.lex_state = 381},
  [6665] = {.lex_state = 284},
  [6666] = {.lex_state = 284},
  [6667] = {.lex_state = 284},
  [6668] = {.lex_state = 284},
  [6669] = {.lex_state = 381},
  [6670] = {.lex_state = 381},
  [6671] = {.lex_state = 284},
  [6672] = {.lex_state = 284},
  [6673] = {.lex_state = 381},
  [6674] = {.lex_state = 381},
  [6675] = {.lex_state = 381},
  [6676] = {.lex_state = 284},
  [6677] = {.lex_state = 284},
  [6678] = {.lex_state = 381},
  [6679] = {.lex_state = 203},
  [6680] = {.lex_state = 277},
  [6681] = {.lex_state = 238},
  [6682] = {.lex_state = 226},
  [6683] = {.lex_state = 237},
  [6684] = {.lex_state = 281},
  [6685] = {.lex_state = 381},
  [6686] = {.lex_state = 381},
  [6687] = {.lex_state = 381},
  [6688] = {.lex_state = 281},
  [6689] = {.lex_state = 284},
  [6690] = {.lex_state = 281},
  [6691] = {.lex_state = 281},
  [6692] = {.lex_state = 281},
  [6693] = {.lex_state = 281},
  [6694] = {.lex_state = 281},
  [6695] = {.lex_state = 203},
  [6696] = {.lex_state = 284},
  [6697] = {.lex_state = 281},
  [6698] = {.lex_state = 281},
  [6699] = {.lex_state = 203},
  [6700] = {.lex_state = 277},
  [6701] = {.lex_state = 226},
  [6702] = {.lex_state = 381},
  [6703] = {.lex_state = 237},
  [6704] = {.lex_state = 381},
  [6705] = {.lex_state = 381},
  [6706] = {.lex_state = 381},
  [6707] = {.lex_state = 284},
  [6708] = {.lex_state = 237},
  [6709] = {.lex_state = 381},
  [6710] = {.lex_state = 226},
  [6711] = {.lex_state = 381},
  [6712] = {.lex_state = 381},
  [6713] = {.lex_state = 381},
  [6714] = {.lex_state = 203},
  [6715] = {.lex_state = 381},
  [6716] = {.lex_state = 381},
  [6717] = {.lex_state = 381},
  [6718] = {.lex_state = 381},
  [6719] = {.lex_state = 381},
  [6720] = {.lex_state = 237},
  [6721] = {.lex_state = 277},
  [6722] = {.lex_state = 381},
  [6723] = {.lex_state = 381},
  [6724] = {.lex_state = 237},
  [6725] = {.lex_state = 237},
  [6726] = {.lex_state = 381},
  [6727] = {.lex_state = 381},
  [6728] = {.lex_state = 381},
  [6729] = {.lex_state = 237},
  [6730] = {.lex_state = 203},
  [6731] = {.lex_state = 237},
  [6732] = {.lex_state = 203},
  [6733] = {.lex_state = 381},
  [6734] = {.lex_state = 281},
  [6735] = {.lex_state = 203},
  [6736] = {.lex_state = 381},
  [6737] = {.lex_state = 237},
  [6738] = {.lex_state = 237},
  [6739] = {.lex_state = 203},
  [6740] = {.lex_state = 381},
  [6741] = {.lex_state = 226},
  [6742] = {.lex_state = 381},
  [6743] = {.lex_state = 203},
  [6744] = {.lex_state = 281},
  [6745] = {.lex_state = 203},
  [6746] = {.lex_state = 381},
  [6747] = {.lex_state = 381},
  [6748] = {.lex_state = 381},
  [6749] = {.lex_state = 281},
  [6750] = {.lex_state = 237},
  [6751] = {.lex_state = 277},
  [6752] = {.lex_state = 203},
  [6753] = {.lex_state = 281},
  [6754] = {.lex_state = 203},
  [6755] = {.lex_state = 237},
  [6756] = {.lex_state = 281},
  [6757] = {.lex_state = 281},
  [6758] = {.lex_state = 383},
  [6759] = {.lex_state = 284},
  [6760] = {.lex_state = 244},
  [6761] = {.lex_state = 203},
  [6762] = {.lex_state = 284},
  [6763] = {.lex_state = 284},
  [6764] = {.lex_state = 284},
  [6765] = {.lex_state = 284},
  [6766] = {.lex_state = 281},
  [6767] = {.lex_state = 381},
  [6768] = {.lex_state = 284},
  [6769] = {.lex_state = 382},
  [6770] = {.lex_state = 244},
  [6771] = {.lex_state = 284},
  [6772] = {.lex_state = 284},
  [6773] = {.lex_state = 244},
  [6774] = {.lex_state = 244},
  [6775] = {.lex_state = 281},
  [6776] = {.lex_state = 284},
  [6777] = {.lex_state = 281},
  [6778] = {.lex_state = 244},
  [6779] = {.lex_state = 284},
  [6780] = {.lex_state = 284},
  [6781] = {.lex_state = 284},
  [6782] = {.lex_state = 284},
  [6783] = {.lex_state = 244},
  [6784] = {.lex_state = 382},
  [6785] = {.lex_state = 284},
  [6786] = {.lex_state = 284},
  [6787] = {.lex_state = 203},
  [6788] = {.lex_state = 244},
  [6789] = {.lex_state = 284},
  [6790] = {.lex_state = 381},
  [6791] = {.lex_state = 284},
  [6792] = {.lex_state = 284},
  [6793] = {.lex_state = 284},
  [6794] = {.lex_state = 284},
  [6795] = {.lex_state = 284},
  [6796] = {.lex_state = 284},
  [6797] = {.lex_state = 284},
  [6798] = {.lex_state = 284},
  [6799] = {.lex_state = 284},
  [6800] = {.lex_state = 284},
  [6801] = {.lex_state = 284},
  [6802] = {.lex_state = 244},
  [6803] = {.lex_state = 284},
  [6804] = {.lex_state = 284},
  [6805] = {.lex_state = 244},
  [6806] = {.lex_state = 381},
  [6807] = {.lex_state = 203},
  [6808] = {.lex_state = 222},
  [6809] = {.lex_state = 231},
  [6810] = {.lex_state = 222},
  [6811] = {.lex_state = 381},
  [6812] = {.lex_state = 381},
  [6813] = {.lex_state = 222},
  [6814] = {.lex_state = 381},
  [6815] = {.lex_state = 381},
  [6816] = {.lex_state = 381},
  [6817] = {.lex_state = 381},
  [6818] = {.lex_state = 381},
  [6819] = {.lex_state = 381},
  [6820] = {.lex_state = 381},
  [6821] = {.lex_state = 203},
  [6822] = {.lex_state = 281},
  [6823] = {.lex_state = 244},
  [6824] = {.lex_state = 203},
  [6825] = {.lex_state = 281},
  [6826] = {.lex_state = 281},
  [6827] = {.lex_state = 244},
  [6828] = {.lex_state = 222},
  [6829] = {.lex_state = 281},
  [6830] = {.lex_state = 222},
  [6831] = {.lex_state = 281},
  [6832] = {.lex_state = 222},
  [6833] = {.lex_state = 281},
  [6834] = {.lex_state = 281},
  [6835] = {.lex_state = 281},
  [6836] = {.lex_state = 222},
  [6837] = {.lex_state = 203},
  [6838] = {.lex_state = 381},
  [6839] = {.lex_state = 281},
  [6840] = {.lex_state = 203},
  [6841] = {.lex_state = 222},
  [6842] = {.lex_state = 265},
  [6843] = {.lex_state = 222},
  [6844] = {.lex_state = 222},
  [6845] = {.lex_state = 381},
  [6846] = {.lex_state = 222},
  [6847] = {.lex_state = 265},
  [6848] = {.lex_state = 203},
  [6849] = {.lex_state = 265},
  [6850] = {.lex_state = 265},
  [6851] = {.lex_state = 222},
  [6852] = {.lex_state = 222},
  [6853] = {.lex_state = 381},
  [6854] = {.lex_state = 281},
  [6855] = {.lex_state = 281},
  [6856] = {.lex_state = 281},
  [6857] = {.lex_state = 222},
  [6858] = {.lex_state = 244},
  [6859] = {.lex_state = 203},
  [6860] = {.lex_state = 222},
  [6861] = {.lex_state = 203},
  [6862] = {.lex_state = 222},
  [6863] = {.lex_state = 244},
  [6864] = {.lex_state = 265},
  [6865] = {.lex_state = 203},
  [6866] = {.lex_state = 206},
  [6867] = {.lex_state = 244},
  [6868] = {.lex_state = 222},
  [6869] = {.lex_state = 381},
  [6870] = {.lex_state = 265},
  [6871] = {.lex_state = 381},
  [6872] = {.lex_state = 222},
  [6873] = {.lex_state = 203},
  [6874] = {.lex_state = 222},
  [6875] = {.lex_state = 203},
  [6876] = {.lex_state = 381},
  [6877] = {.lex_state = 203},
  [6878] = {.lex_state = 281},
  [6879] = {.lex_state = 381},
  [6880] = {.lex_state = 244},
  [6881] = {.lex_state = 381},
  [6882] = {.lex_state = 265},
  [6883] = {.lex_state = 381},
  [6884] = {.lex_state = 381},
  [6885] = {.lex_state = 265},
  [6886] = {.lex_state = 244},
  [6887] = {.lex_state = 382},
  [6888] = {.lex_state = 277},
  [6889] = {.lex_state = 265},
  [6890] = {.lex_state = 222},
  [6891] = {.lex_state = 222},
  [6892] = {.lex_state = 222},
  [6893] = {.lex_state = 234},
  [6894] = {.lex_state = 277},
  [6895] = {.lex_state = 381},
  [6896] = {.lex_state = 222},
  [6897] = {.lex_state = 222},
  [6898] = {.lex_state = 234},
  [6899] = {.lex_state = 382},
  [6900] = {.lex_state = 265},
  [6901] = {.lex_state = 381},
  [6902] = {.lex_state = 381},
  [6903] = {.lex_state = 222},
  [6904] = {.lex_state = 244},
  [6905] = {.lex_state = 265},
  [6906] = {.lex_state = 234},
  [6907] = {.lex_state = 222},
  [6908] = {.lex_state = 234},
  [6909] = {.lex_state = 244},
  [6910] = {.lex_state = 382},
  [6911] = {.lex_state = 244},
  [6912] = {.lex_state = 277},
  [6913] = {.lex_state = 234},
  [6914] = {.lex_state = 244},
  [6915] = {.lex_state = 244},
  [6916] = {.lex_state = 244},
  [6917] = {.lex_state = 244},
  [6918] = {.lex_state = 244},
  [6919] = {.lex_state = 277},
  [6920] = {.lex_state = 382},
  [6921] = {.lex_state = 244},
  [6922] = {.lex_state = 265},
  [6923] = {.lex_state = 382},
  [6924] = {.lex_state = 244},
  [6925] = {.lex_state = 381},
  [6926] = {.lex_state = 265},
  [6927] = {.lex_state = 265},
  [6928] = {.lex_state = 265},
  [6929] = {.lex_state = 381},
  [6930] = {.lex_state = 230},
  [6931] = {.lex_state = 244},
  [6932] = {.lex_state = 281},
  [6933] = {.lex_state = 265},
  [6934] = {.lex_state = 284},
  [6935] = {.lex_state = 381},
  [6936] = {.lex_state = 382},
  [6937] = {.lex_state = 244},
  [6938] = {.lex_state = 244},
  [6939] = {.lex_state = 281},
  [6940] = {.lex_state = 284},
  [6941] = {.lex_state = 281},
  [6942] = {.lex_state = 284},
  [6943] = {.lex_state = 381},
  [6944] = {.lex_state = 382},
  [6945] = {.lex_state = 382},
  [6946] = {.lex_state = 234},
  [6947] = {.lex_state = 382},
  [6948] = {.lex_state = 381},
  [6949] = {.lex_state = 382},
  [6950] = {.lex_state = 382},
  [6951] = {.lex_state = 382},
  [6952] = {.lex_state = 382},
  [6953] = {.lex_state = 382},
  [6954] = {.lex_state = 284},
  [6955] = {.lex_state = 284},
  [6956] = {.lex_state = 284},
  [6957] = {.lex_state = 244},
  [6958] = {.lex_state = 244},
  [6959] = {.lex_state = 284},
  [6960] = {.lex_state = 244},
  [6961] = {.lex_state = 244},
  [6962] = {.lex_state = 222},
  [6963] = {.lex_state = 244},
  [6964] = {.lex_state = 244},
  [6965] = {.lex_state = 382},
  [6966] = {.lex_state = 281},
  [6967] = {.lex_state = 382},
  [6968] = {.lex_state = 244},
  [6969] = {.lex_state = 244},
  [6970] = {.lex_state = 382},
  [6971] = {.lex_state = 244},
  [6972] = {.lex_state = 244},
  [6973] = {.lex_state = 234},
  [6974] = {.lex_state = 244},
  [6975] = {.lex_state = 222},
  [6976] = {.lex_state = 281},
  [6977] = {.lex_state = 284},
  [6978] = {.lex_state = 382},
  [6979] = {.lex_state = 382},
  [6980] = {.lex_state = 244},
  [6981] = {.lex_state = 234},
  [6982] = {.lex_state = 244},
  [6983] = {.lex_state = 382},
  [6984] = {.lex_state = 234},
  [6985] = {.lex_state = 234},
  [6986] = {.lex_state = 244},
  [6987] = {.lex_state = 244},
  [6988] = {.lex_state = 244},
  [6989] = {.lex_state = 281},
  [6990] = {.lex_state = 281},
  [6991] = {.lex_state = 234},
  [6992] = {.lex_state = 244},
  [6993] = {.lex_state = 281},
  [6994] = {.lex_state = 244},
  [6995] = {.lex_state = 382},
  [6996] = {.lex_state = 244},
  [6997] = {.lex_state = 381},
  [6998] = {.lex_state = 381},
  [6999] = {.lex_state = 234},
  [7000] = {.lex_state = 381},
  [7001] = {.lex_state = 233},
  [7002] = {.lex_state = 381},
  [7003] = {.lex_state = 381},
  [7004] = {.lex_state = 226},
  [7005] = {.lex_state = 0},
  [7006] = {.lex_state = 381},
  [7007] = {.lex_state = 381},
  [7008] = {.lex_state = 381},
  [7009] = {.lex_state = 226},
  [7010] = {.lex_state = 381},
  [7011] = {.lex_state = 226},
  [7012] = {.lex_state = 226},
  [7013] = {.lex_state = 0},
  [7014] = {.lex_state = 226},
  [7015] = {.lex_state = 244},
  [7016] = {.lex_state = 226},
  [7017] = {.lex_state = 381},
  [7018] = {.lex_state = 203},
  [7019] = {.lex_state = 233},
  [7020] = {.lex_state = 381},
  [7021] = {.lex_state = 0},
  [7022] = {.lex_state = 381},
  [7023] = {.lex_state = 226},
  [7024] = {.lex_state = 244},
  [7025] = {.lex_state = 381},
  [7026] = {.lex_state = 226},
  [7027] = {.lex_state = 226},
  [7028] = {.lex_state = 244},
  [7029] = {.lex_state = 381},
  [7030] = {.lex_state = 244},
  [7031] = {.lex_state = 226},
  [7032] = {.lex_state = 381},
  [7033] = {.lex_state = 381},
  [7034] = {.lex_state = 381},
  [7035] = {.lex_state = 381},
  [7036] = {.lex_state = 381},
  [7037] = {.lex_state = 226},
  [7038] = {.lex_state = 233},
  [7039] = {.lex_state = 0},
  [7040] = {.lex_state = 244},
  [7041] = {.lex_state = 226},
  [7042] = {.lex_state = 226},
  [7043] = {.lex_state = 244},
  [7044] = {.lex_state = 381},
  [7045] = {.lex_state = 226},
  [7046] = {.lex_state = 381},
  [7047] = {.lex_state = 226},
  [7048] = {.lex_state = 381},
  [7049] = {.lex_state = 381},
  [7050] = {.lex_state = 203},
  [7051] = {.lex_state = 281},
  [7052] = {.lex_state = 281},
  [7053] = {.lex_state = 281},
  [7054] = {.lex_state = 281},
  [7055] = {.lex_state = 281},
  [7056] = {.lex_state = 281},
  [7057] = {.lex_state = 203},
  [7058] = {.lex_state = 381},
  [7059] = {.lex_state = 381},
  [7060] = {.lex_state = 0},
  [7061] = {.lex_state = 226},
  [7062] = {.lex_state = 226},
  [7063] = {.lex_state = 281},
  [7064] = {.lex_state = 226},
  [7065] = {.lex_state = 0},
  [7066] = {.lex_state = 281},
  [7067] = {.lex_state = 381},
  [7068] = {.lex_state = 381},
  [7069] = {.lex_state = 381},
  [7070] = {.lex_state = 233},
  [7071] = {.lex_state = 381},
  [7072] = {.lex_state = 233},
  [7073] = {.lex_state = 226},
  [7074] = {.lex_state = 381},
  [7075] = {.lex_state = 381},
  [7076] = {.lex_state = 226},
  [7077] = {.lex_state = 381},
  [7078] = {.lex_state = 381},
  [7079] = {.lex_state = 381},
  [7080] = {.lex_state = 381},
  [7081] = {.lex_state = 381},
  [7082] = {.lex_state = 381},
  [7083] = {.lex_state = 381},
  [7084] = {.lex_state = 381},
  [7085] = {.lex_state = 381},
  [7086] = {.lex_state = 381},
  [7087] = {.lex_state = 381},
  [7088] = {.lex_state = 381},
  [7089] = {.lex_state = 226},
  [7090] = {.lex_state = 381},
  [7091] = {.lex_state = 381},
  [7092] = {.lex_state = 381},
  [7093] = {.lex_state = 381},
  [7094] = {.lex_state = 233},
  [7095] = {.lex_state = 381},
  [7096] = {.lex_state = 381},
  [7097] = {.lex_state = 244},
  [7098] = {.lex_state = 233},
  [7099] = {.lex_state = 381},
  [7100] = {.lex_state = 244},
  [7101] = {.lex_state = 381},
  [7102] = {.lex_state = 381},
  [7103] = {.lex_state = 0},
  [7104] = {.lex_state = 0},
  [7105] = {.lex_state = 233},
  [7106] = {.lex_state = 226},
  [7107] = {.lex_state = 381},
  [7108] = {.lex_state = 381},
  [7109] = {.lex_state = 0},
  [7110] = {.lex_state = 381},
  [7111] = {.lex_state = 381},
  [7112] = {.lex_state = 381},
  [7113] = {.lex_state = 381},
  [7114] = {.lex_state = 381},
  [7115] = {.lex_state = 381},
  [7116] = {.lex_state = 226},
  [7117] = {.lex_state = 381},
  [7118] = {.lex_state = 226},
  [7119] = {.lex_state = 381},
  [7120] = {.lex_state = 265},
  [7121] = {.lex_state = 244},
  [7122] = {.lex_state = 381},
  [7123] = {.lex_state = 381},
  [7124] = {.lex_state = 244},
  [7125] = {.lex_state = 244},
  [7126] = {.lex_state = 387},
  [7127] = {.lex_state = 265},
  [7128] = {.lex_state = 381},
  [7129] = {.lex_state = 381},
  [7130] = {.lex_state = 265},
  [7131] = {.lex_state = 244},
  [7132] = {.lex_state = 381},
  [7133] = {.lex_state = 381},
  [7134] = {.lex_state = 381},
  [7135] = {.lex_state = 265},
  [7136] = {.lex_state = 265},
  [7137] = {.lex_state = 244},
  [7138] = {.lex_state = 244},
  [7139] = {.lex_state = 0},
  [7140] = {.lex_state = 244},
  [7141] = {.lex_state = 265},
  [7142] = {.lex_state = 244},
  [7143] = {.lex_state = 244},
  [7144] = {.lex_state = 244},
  [7145] = {.lex_state = 234},
  [7146] = {.lex_state = 265},
  [7147] = {.lex_state = 234},
  [7148] = {.lex_state = 244},
  [7149] = {.lex_state = 244},
  [7150] = {.lex_state = 265},
  [7151] = {.lex_state = 234},
  [7152] = {.lex_state = 234},
  [7153] = {.lex_state = 234},
  [7154] = {.lex_state = 381},
  [7155] = {.lex_state = 234},
  [7156] = {.lex_state = 234},
  [7157] = {.lex_state = 265},
  [7158] = {.lex_state = 237},
  [7159] = {.lex_state = 244},
  [7160] = {.lex_state = 244},
  [7161] = {.lex_state = 265},
  [7162] = {.lex_state = 381},
  [7163] = {.lex_state = 381},
  [7164] = {.lex_state = 234},
  [7165] = {.lex_state = 265},
  [7166] = {.lex_state = 244},
  [7167] = {.lex_state = 244},
  [7168] = {.lex_state = 381},
  [7169] = {.lex_state = 244},
  [7170] = {.lex_state = 244},
  [7171] = {.lex_state = 381},
  [7172] = {.lex_state = 244},
  [7173] = {.lex_state = 387},
  [7174] = {.lex_state = 265},
  [7175] = {.lex_state = 387},
  [7176] = {.lex_state = 244},
  [7177] = {.lex_state = 244},
  [7178] = {.lex_state = 387},
  [7179] = {.lex_state = 381},
  [7180] = {.lex_state = 381},
  [7181] = {.lex_state = 244},
  [7182] = {.lex_state = 244},
  [7183] = {.lex_state = 244},
  [7184] = {.lex_state = 244},
  [7185] = {.lex_state = 244},
  [7186] = {.lex_state = 244},
  [7187] = {.lex_state = 244},
  [7188] = {.lex_state = 244},
  [7189] = {.lex_state = 244},
  [7190] = {.lex_state = 244},
  [7191] = {.lex_state = 387},
  [7192] = {.lex_state = 244},
  [7193] = {.lex_state = 244},
  [7194] = {.lex_state = 244},
  [7195] = {.lex_state = 244},
  [7196] = {.lex_state = 244},
  [7197] = {.lex_state = 244},
  [7198] = {.lex_state = 244},
  [7199] = {.lex_state = 233},
  [7200] = {.lex_state = 244},
  [7201] = {.lex_state = 284},
  [7202] = {.lex_state = 233},
  [7203] = {.lex_state = 244},
  [7204] = {.lex_state = 244},
  [7205] = {.lex_state = 260},
  [7206] = {.lex_state = 244},
  [7207] = {.lex_state = 244},
  [7208] = {.lex_state = 244},
  [7209] = {.lex_state = 244},
  [7210] = {.lex_state = 233},
  [7211] = {.lex_state = 260},
  [7212] = {.lex_state = 381},
  [7213] = {.lex_state = 381},
  [7214] = {.lex_state = 233},
  [7215] = {.lex_state = 244},
  [7216] = {.lex_state = 244},
  [7217] = {.lex_state = 381},
  [7218] = {.lex_state = 244},
  [7219] = {.lex_state = 233},
  [7220] = {.lex_state = 244},
  [7221] = {.lex_state = 244},
  [7222] = {.lex_state = 244},
  [7223] = {.lex_state = 244},
  [7224] = {.lex_state = 244},
  [7225] = {.lex_state = 244},
  [7226] = {.lex_state = 260},
  [7227] = {.lex_state = 244},
  [7228] = {.lex_state = 244},
  [7229] = {.lex_state = 260},
  [7230] = {.lex_state = 244},
  [7231] = {.lex_state = 233},
  [7232] = {.lex_state = 284},
  [7233] = {.lex_state = 244},
  [7234] = {.lex_state = 244},
  [7235] = {.lex_state = 381},
  [7236] = {.lex_state = 381},
  [7237] = {.lex_state = 244},
  [7238] = {.lex_state = 231},
  [7239] = {.lex_state = 381},
  [7240] = {.lex_state = 244},
  [7241] = {.lex_state = 233},
  [7242] = {.lex_state = 233},
  [7243] = {.lex_state = 381},
  [7244] = {.lex_state = 244},
  [7245] = {.lex_state = 244},
  [7246] = {.lex_state = 233},
  [7247] = {.lex_state = 381},
  [7248] = {.lex_state = 233},
  [7249] = {.lex_state = 244},
  [7250] = {.lex_state = 284},
  [7251] = {.lex_state = 244},
  [7252] = {.lex_state = 231},
  [7253] = {.lex_state = 284},
  [7254] = {.lex_state = 260},
  [7255] = {.lex_state = 244},
  [7256] = {.lex_state = 244},
  [7257] = {.lex_state = 381},
  [7258] = {.lex_state = 244},
  [7259] = {.lex_state = 233},
  [7260] = {.lex_state = 244},
  [7261] = {.lex_state = 244},
  [7262] = {.lex_state = 260},
  [7263] = {.lex_state = 244},
  [7264] = {.lex_state = 226},
  [7265] = {.lex_state = 381},
  [7266] = {.lex_state = 244},
  [7267] = {.lex_state = 244},
  [7268] = {.lex_state = 260},
  [7269] = {.lex_state = 233},
  [7270] = {.lex_state = 244},
  [7271] = {.lex_state = 244},
  [7272] = {.lex_state = 244},
  [7273] = {.lex_state = 244},
  [7274] = {.lex_state = 244},
  [7275] = {.lex_state = 244},
  [7276] = {.lex_state = 260},
  [7277] = {.lex_state = 231},
  [7278] = {.lex_state = 244},
  [7279] = {.lex_state = 244},
  [7280] = {.lex_state = 244},
  [7281] = {.lex_state = 226},
  [7282] = {.lex_state = 265},
  [7283] = {.lex_state = 226},
  [7284] = {.lex_state = 265},
  [7285] = {.lex_state = 244},
  [7286] = {.lex_state = 226},
  [7287] = {.lex_state = 387},
  [7288] = {.lex_state = 381},
  [7289] = {.lex_state = 265},
  [7290] = {.lex_state = 244},
  [7291] = {.lex_state = 387},
  [7292] = {.lex_state = 226},
  [7293] = {.lex_state = 244},
  [7294] = {.lex_state = 226},
  [7295] = {.lex_state = 265},
  [7296] = {.lex_state = 226},
  [7297] = {.lex_state = 226},
  [7298] = {.lex_state = 226},
  [7299] = {.lex_state = 226},
  [7300] = {.lex_state = 265},
  [7301] = {.lex_state = 226},
  [7302] = {.lex_state = 244},
  [7303] = {.lex_state = 265},
  [7304] = {.lex_state = 387},
  [7305] = {.lex_state = 206},
  [7306] = {.lex_state = 381},
  [7307] = {.lex_state = 226},
  [7308] = {.lex_state = 244},
  [7309] = {.lex_state = 381},
  [7310] = {.lex_state = 381},
  [7311] = {.lex_state = 381},
  [7312] = {.lex_state = 381},
  [7313] = {.lex_state = 381},
  [7314] = {.lex_state = 265},
  [7315] = {.lex_state = 226},
  [7316] = {.lex_state = 226},
  [7317] = {.lex_state = 226},
  [7318] = {.lex_state = 265},
  [7319] = {.lex_state = 226},
  [7320] = {.lex_state = 206},
  [7321] = {.lex_state = 244},
  [7322] = {.lex_state = 244},
  [7323] = {.lex_state = 203},
  [7324] = {.lex_state = 244},
  [7325] = {.lex_state = 244},
  [7326] = {.lex_state = 244},
  [7327] = {.lex_state = 278},
  [7328] = {.lex_state = 244},
  [7329] = {.lex_state = 244},
  [7330] = {.lex_state = 244},
  [7331] = {.lex_state = 233},
  [7332] = {.lex_state = 244},
  [7333] = {.lex_state = 244},
  [7334] = {.lex_state = 244},
  [7335] = {.lex_state = 244},
  [7336] = {.lex_state = 244},
  [7337] = {.lex_state = 244},
  [7338] = {.lex_state = 244},
  [7339] = {.lex_state = 244},
  [7340] = {.lex_state = 244},
  [7341] = {.lex_state = 278},
  [7342] = {.lex_state = 278},
  [7343] = {.lex_state = 244},
  [7344] = {.lex_state = 278},
  [7345] = {.lex_state = 244},
  [7346] = {.lex_state = 244},
  [7347] = {.lex_state = 244},
  [7348] = {.lex_state = 387},
  [7349] = {.lex_state = 244},
  [7350] = {.lex_state = 244},
  [7351] = {.lex_state = 244},
  [7352] = {.lex_state = 244},
  [7353] = {.lex_state = 233},
  [7354] = {.lex_state = 244},
  [7355] = {.lex_state = 233},
  [7356] = {.lex_state = 233},
  [7357] = {.lex_state = 244},
  [7358] = {.lex_state = 244},
  [7359] = {.lex_state = 244},
  [7360] = {.lex_state = 237},
  [7361] = {.lex_state = 244},
  [7362] = {.lex_state = 233},
  [7363] = {.lex_state = 233},
  [7364] = {.lex_state = 387},
  [7365] = {.lex_state = 244},
  [7366] = {.lex_state = 278},
  [7367] = {.lex_state = 244},
  [7368] = {.lex_state = 237},
  [7369] = {.lex_state = 244},
  [7370] = {.lex_state = 233},
  [7371] = {.lex_state = 244},
  [7372] = {.lex_state = 233},
  [7373] = {.lex_state = 244},
  [7374] = {.lex_state = 387},
  [7375] = {.lex_state = 378},
  [7376] = {.lex_state = 387},
  [7377] = {.lex_state = 244},
  [7378] = {.lex_state = 387},
  [7379] = {.lex_state = 387},
  [7380] = {.lex_state = 244},
  [7381] = {.lex_state = 244},
  [7382] = {.lex_state = 226},
  [7383] = {.lex_state = 244},
  [7384] = {.lex_state = 233},
  [7385] = {.lex_state = 203},
  [7386] = {.lex_state = 387},
  [7387] = {.lex_state = 226},
  [7388] = {.lex_state = 387},
  [7389] = {.lex_state = 231},
  [7390] = {.lex_state = 231},
  [7391] = {.lex_state = 244},
  [7392] = {.lex_state = 244},
  [7393] = {.lex_state = 387},
  [7394] = {.lex_state = 387},
  [7395] = {.lex_state = 284},
  [7396] = {.lex_state = 387},
  [7397] = {.lex_state = 233},
  [7398] = {.lex_state = 387},
  [7399] = {.lex_state = 387},
  [7400] = {.lex_state = 387},
  [7401] = {.lex_state = 203},
  [7402] = {.lex_state = 387},
  [7403] = {.lex_state = 387},
  [7404] = {.lex_state = 387},
  [7405] = {.lex_state = 387},
  [7406] = {.lex_state = 233},
  [7407] = {.lex_state = 281},
  [7408] = {.lex_state = 387},
  [7409] = {.lex_state = 233},
  [7410] = {.lex_state = 234},
  [7411] = {.lex_state = 234},
  [7412] = {.lex_state = 244},
  [7413] = {.lex_state = 233},
  [7414] = {.lex_state = 387},
  [7415] = {.lex_state = 387},
  [7416] = {.lex_state = 387},
  [7417] = {.lex_state = 244},
  [7418] = {.lex_state = 281},
  [7419] = {.lex_state = 234},
  [7420] = {.lex_state = 234},
  [7421] = {.lex_state = 387},
  [7422] = {.lex_state = 387},
  [7423] = {.lex_state = 387},
  [7424] = {.lex_state = 281},
  [7425] = {.lex_state = 234},
  [7426] = {.lex_state = 234},
  [7427] = {.lex_state = 244},
  [7428] = {.lex_state = 387},
  [7429] = {.lex_state = 387},
  [7430] = {.lex_state = 387},
  [7431] = {.lex_state = 387},
  [7432] = {.lex_state = 387},
  [7433] = {.lex_state = 234},
  [7434] = {.lex_state = 244},
  [7435] = {.lex_state = 233},
  [7436] = {.lex_state = 234},
  [7437] = {.lex_state = 244},
  [7438] = {.lex_state = 387},
  [7439] = {.lex_state = 203},
  [7440] = {.lex_state = 203},
  [7441] = {.lex_state = 244},
  [7442] = {.lex_state = 387},
  [7443] = {.lex_state = 203},
  [7444] = {.lex_state = 387},
  [7445] = {.lex_state = 244},
  [7446] = {.lex_state = 387},
  [7447] = {.lex_state = 203},
  [7448] = {.lex_state = 203},
  [7449] = {.lex_state = 203},
  [7450] = {.lex_state = 244},
  [7451] = {.lex_state = 387},
  [7452] = {.lex_state = 244},
  [7453] = {.lex_state = 387},
  [7454] = {.lex_state = 231},
  [7455] = {.lex_state = 203},
  [7456] = {.lex_state = 237},
  [7457] = {.lex_state = 387},
  [7458] = {.lex_state = 237},
  [7459] = {.lex_state = 244},
  [7460] = {.lex_state = 203},
  [7461] = {.lex_state = 387},
  [7462] = {.lex_state = 244},
  [7463] = {.lex_state = 233},
  [7464] = {.lex_state = 203},
  [7465] = {.lex_state = 237},
  [7466] = {.lex_state = 233},
  [7467] = {.lex_state = 203},
  [7468] = {.lex_state = 203},
  [7469] = {.lex_state = 203},
  [7470] = {.lex_state = 203},
  [7471] = {.lex_state = 387},
  [7472] = {.lex_state = 233},
  [7473] = {.lex_state = 203},
  [7474] = {.lex_state = 203},
  [7475] = {.lex_state = 203},
  [7476] = {.lex_state = 203},
  [7477] = {.lex_state = 244},
  [7478] = {.lex_state = 203},
  [7479] = {.lex_state = 203},
  [7480] = {.lex_state = 387},
  [7481] = {.lex_state = 203},
  [7482] = {.lex_state = 233},
  [7483] = {.lex_state = 203},
  [7484] = {.lex_state = 387},
  [7485] = {.lex_state = 203},
  [7486] = {.lex_state = 281},
  [7487] = {.lex_state = 244},
  [7488] = {.lex_state = 387},
  [7489] = {.lex_state = 203},
  [7490] = {.lex_state = 244},
  [7491] = {.lex_state = 244},
  [7492] = {.lex_state = 226},
  [7493] = {.lex_state = 281},
  [7494] = {.lex_state = 226},
  [7495] = {.lex_state = 281},
  [7496] = {.lex_state = 281},
  [7497] = {.lex_state = 244},
  [7498] = {.lex_state = 244},
  [7499] = {.lex_state = 244},
  [7500] = {.lex_state = 244},
  [7501] = {.lex_state = 281},
  [7502] = {.lex_state = 387},
  [7503] = {.lex_state = 387},
  [7504] = {.lex_state = 281},
  [7505] = {.lex_state = 244},
  [7506] = {.lex_state = 244},
  [7507] = {.lex_state = 281},
  [7508] = {.lex_state = 244},
  [7509] = {.lex_state = 226},
  [7510] = {.lex_state = 244},
  [7511] = {.lex_state = 281},
  [7512] = {.lex_state = 244},
  [7513] = {.lex_state = 281},
  [7514] = {.lex_state = 281},
  [7515] = {.lex_state = 233},
  [7516] = {.lex_state = 387},
  [7517] = {.lex_state = 281},
  [7518] = {.lex_state = 226},
  [7519] = {.lex_state = 231},
  [7520] = {.lex_state = 244},
  [7521] = {.lex_state = 244},
  [7522] = {.lex_state = 244},
  [7523] = {.lex_state = 203},
  [7524] = {.lex_state = 244},
  [7525] = {.lex_state = 281},
  [7526] = {.lex_state = 281},
  [7527] = {.lex_state = 284},
  [7528] = {.lex_state = 244},
  [7529] = {.lex_state = 281},
  [7530] = {.lex_state = 244},
  [7531] = {.lex_state = 281},
  [7532] = {.lex_state = 203},
  [7533] = {.lex_state = 226},
  [7534] = {.lex_state = 226},
  [7535] = {.lex_state = 226},
  [7536] = {.lex_state = 244},
  [7537] = {.lex_state = 281},
  [7538] = {.lex_state = 226},
  [7539] = {.lex_state = 281},
  [7540] = {.lex_state = 0},
  [7541] = {.lex_state = 226},
  [7542] = {.lex_state = 244},
  [7543] = {.lex_state = 244},
  [7544] = {.lex_state = 281},
  [7545] = {.lex_state = 226},
  [7546] = {.lex_state = 244},
  [7547] = {.lex_state = 281},
  [7548] = {.lex_state = 387},
  [7549] = {.lex_state = 244},
  [7550] = {.lex_state = 0},
  [7551] = {.lex_state = 387},
  [7552] = {.lex_state = 226},
  [7553] = {.lex_state = 244},
  [7554] = {.lex_state = 244},
  [7555] = {.lex_state = 387},
  [7556] = {.lex_state = 244},
  [7557] = {.lex_state = 244},
  [7558] = {.lex_state = 244},
  [7559] = {.lex_state = 203},
  [7560] = {.lex_state = 203},
  [7561] = {.lex_state = 203},
  [7562] = {.lex_state = 244},
  [7563] = {.lex_state = 244},
  [7564] = {.lex_state = 230},
  [7565] = {.lex_state = 244},
  [7566] = {.lex_state = 203},
  [7567] = {.lex_state = 244},
  [7568] = {.lex_state = 244},
  [7569] = {.lex_state = 244},
  [7570] = {.lex_state = 387},
  [7571] = {.lex_state = 244},
  [7572] = {.lex_state = 387},
  [7573] = {.lex_state = 244},
  [7574] = {.lex_state = 244},
  [7575] = {.lex_state = 244},
  [7576] = {.lex_state = 244},
  [7577] = {.lex_state = 244},
  [7578] = {.lex_state = 244},
  [7579] = {.lex_state = 230},
  [7580] = {.lex_state = 230},
  [7581] = {.lex_state = 244},
  [7582] = {.lex_state = 244},
  [7583] = {.lex_state = 244},
  [7584] = {.lex_state = 244},
  [7585] = {.lex_state = 244},
  [7586] = {.lex_state = 387},
  [7587] = {.lex_state = 244},
  [7588] = {.lex_state = 244},
  [7589] = {.lex_state = 203},
  [7590] = {.lex_state = 230},
  [7591] = {.lex_state = 244},
  [7592] = {.lex_state = 244},
  [7593] = {.lex_state = 230},
  [7594] = {.lex_state = 244},
  [7595] = {.lex_state = 230},
  [7596] = {.lex_state = 244},
  [7597] = {.lex_state = 244},
  [7598] = {.lex_state = 244},
  [7599] = {.lex_state = 244},
  [7600] = {.lex_state = 244},
  [7601] = {.lex_state = 244},
  [7602] = {.lex_state = 244},
  [7603] = {.lex_state = 244},
  [7604] = {.lex_state = 244},
  [7605] = {.lex_state = 387},
  [7606] = {.lex_state = 244},
  [7607] = {.lex_state = 244},
  [7608] = {.lex_state = 387},
  [7609] = {.lex_state = 244},
  [7610] = {.lex_state = 244},
  [7611] = {.lex_state = 244},
  [7612] = {.lex_state = 230},
  [7613] = {.lex_state = 244},
  [7614] = {.lex_state = 244},
  [7615] = {.lex_state = 244},
  [7616] = {.lex_state = 244},
  [7617] = {.lex_state = 244},
  [7618] = {.lex_state = 244},
  [7619] = {.lex_state = 244},
  [7620] = {.lex_state = 244},
  [7621] = {.lex_state = 203},
  [7622] = {.lex_state = 230},
  [7623] = {.lex_state = 281},
  [7624] = {.lex_state = 265},
  [7625] = {.lex_state = 244},
  [7626] = {.lex_state = 265},
  [7627] = {.lex_state = 244},
  [7628] = {.lex_state = 230},
  [7629] = {.lex_state = 203},
  [7630] = {.lex_state = 387},
  [7631] = {.lex_state = 116},
  [7632] = {.lex_state = 244},
  [7633] = {.lex_state = 244},
  [7634] = {.lex_state = 230},
  [7635] = {.lex_state = 387},
  [7636] = {.lex_state = 118},
  [7637] = {.lex_state = 244},
  [7638] = {.lex_state = 230},
  [7639] = {.lex_state = 244},
  [7640] = {.lex_state = 387},
  [7641] = {.lex_state = 387},
  [7642] = {.lex_state = 244},
  [7643] = {.lex_state = 203},
  [7644] = {.lex_state = 203},
  [7645] = {.lex_state = 244},
  [7646] = {.lex_state = 118},
  [7647] = {.lex_state = 244},
  [7648] = {.lex_state = 387},
  [7649] = {.lex_state = 116},
  [7650] = {.lex_state = 230},
  [7651] = {.lex_state = 118},
  [7652] = {.lex_state = 203},
  [7653] = {.lex_state = 119},
  [7654] = {.lex_state = 244},
  [7655] = {.lex_state = 0},
  [7656] = {.lex_state = 387},
  [7657] = {.lex_state = 118},
  [7658] = {.lex_state = 244},
  [7659] = {.lex_state = 118},
  [7660] = {.lex_state = 244},
  [7661] = {.lex_state = 118},
  [7662] = {.lex_state = 203},
  [7663] = {.lex_state = 387},
  [7664] = {.lex_state = 244},
  [7665] = {.lex_state = 203},
  [7666] = {.lex_state = 244},
  [7667] = {.lex_state = 244},
  [7668] = {.lex_state = 203},
  [7669] = {.lex_state = 387},
  [7670] = {.lex_state = 244},
  [7671] = {.lex_state = 244},
  [7672] = {.lex_state = 0},
  [7673] = {.lex_state = 203},
  [7674] = {.lex_state = 281},
  [7675] = {.lex_state = 281},
  [7676] = {.lex_state = 0},
  [7677] = {.lex_state = 230},
  [7678] = {.lex_state = 118},
  [7679] = {.lex_state = 119},
  [7680] = {.lex_state = 244},
  [7681] = {.lex_state = 281},
  [7682] = {.lex_state = 118},
  [7683] = {.lex_state = 244},
  [7684] = {.lex_state = 387},
  [7685] = {.lex_state = 230},
  [7686] = {.lex_state = 230},
  [7687] = {.lex_state = 244},
  [7688] = {.lex_state = 203},
  [7689] = {.lex_state = 244},
  [7690] = {.lex_state = 244},
  [7691] = {.lex_state = 230},
  [7692] = {.lex_state = 244},
  [7693] = {.lex_state = 387},
  [7694] = {.lex_state = 118},
  [7695] = {.lex_state = 203},
  [7696] = {.lex_state = 0},
  [7697] = {.lex_state = 244},
  [7698] = {.lex_state = 119},
  [7699] = {.lex_state = 387},
  [7700] = {.lex_state = 118},
  [7701] = {.lex_state = 119},
  [7702] = {.lex_state = 387},
  [7703] = {.lex_state = 387},
  [7704] = {.lex_state = 387},
  [7705] = {.lex_state = 118},
  [7706] = {.lex_state = 118},
  [7707] = {.lex_state = 230},
  [7708] = {.lex_state = 116},
  [7709] = {.lex_state = 230},
  [7710] = {.lex_state = 244},
  [7711] = {.lex_state = 387},
  [7712] = {.lex_state = 203},
  [7713] = {.lex_state = 0},
  [7714] = {.lex_state = 0},
  [7715] = {.lex_state = 387},
  [7716] = {.lex_state = 387},
  [7717] = {.lex_state = 387},
  [7718] = {.lex_state = 387},
  [7719] = {.lex_state = 387},
  [7720] = {.lex_state = 230},
  [7721] = {.lex_state = 203},
  [7722] = {.lex_state = 0},
  [7723] = {.lex_state = 116},
  [7724] = {.lex_state = 118},
  [7725] = {.lex_state = 0},
  [7726] = {.lex_state = 387},
  [7727] = {.lex_state = 118},
  [7728] = {.lex_state = 118},
  [7729] = {.lex_state = 387},
  [7730] = {.lex_state = 387},
  [7731] = {.lex_state = 230},
  [7732] = {.lex_state = 119},
  [7733] = {.lex_state = 387},
  [7734] = {.lex_state = 244},
  [7735] = {.lex_state = 387},
  [7736] = {.lex_state = 203},
  [7737] = {.lex_state = 119},
  [7738] = {.lex_state = 116},
  [7739] = {.lex_state = 203},
  [7740] = {.lex_state = 244},
  [7741] = {.lex_state = 0},
  [7742] = {.lex_state = 230},
  [7743] = {.lex_state = 230},
  [7744] = {.lex_state = 387},
  [7745] = {.lex_state = 118},
  [7746] = {.lex_state = 230},
  [7747] = {.lex_state = 387},
  [7748] = {.lex_state = 387},
  [7749] = {.lex_state = 387},
  [7750] = {.lex_state = 230},
  [7751] = {.lex_state = 118},
  [7752] = {.lex_state = 0},
  [7753] = {.lex_state = 230},
  [7754] = {.lex_state = 387},
  [7755] = {.lex_state = 118},
  [7756] = {.lex_state = 0},
  [7757] = {.lex_state = 387},
  [7758] = {.lex_state = 203},
  [7759] = {.lex_state = 116},
  [7760] = {.lex_state = 230},
  [7761] = {.lex_state = 230},
  [7762] = {.lex_state = 244},
  [7763] = {.lex_state = 116},
  [7764] = {.lex_state = 244},
  [7765] = {.lex_state = 203},
  [7766] = {.lex_state = 118},
  [7767] = {.lex_state = 118},
  [7768] = {.lex_state = 0},
  [7769] = {.lex_state = 265},
  [7770] = {.lex_state = 0},
  [7771] = {.lex_state = 244},
  [7772] = {.lex_state = 230},
  [7773] = {.lex_state = 230},
  [7774] = {.lex_state = 203},
  [7775] = {.lex_state = 387},
  [7776] = {.lex_state = 244},
  [7777] = {.lex_state = 387},
  [7778] = {.lex_state = 230},
  [7779] = {.lex_state = 244},
  [7780] = {.lex_state = 244},
  [7781] = {.lex_state = 203},
  [7782] = {.lex_state = 387},
  [7783] = {.lex_state = 230},
  [7784] = {.lex_state = 387},
  [7785] = {.lex_state = 230},
  [7786] = {.lex_state = 244},
  [7787] = {.lex_state = 387},
  [7788] = {.lex_state = 230},
  [7789] = {.lex_state = 203},
  [7790] = {.lex_state = 0},
  [7791] = {.lex_state = 203},
  [7792] = {.lex_state = 230},
  [7793] = {.lex_state = 203},
  [7794] = {.lex_state = 118},
  [7795] = {.lex_state = 244},
  [7796] = {.lex_state = 244},
  [7797] = {.lex_state = 387},
  [7798] = {.lex_state = 119},
  [7799] = {.lex_state = 116},
  [7800] = {.lex_state = 230},
  [7801] = {.lex_state = 281},
  [7802] = {.lex_state = 230},
  [7803] = {.lex_state = 230},
  [7804] = {.lex_state = 387},
  [7805] = {.lex_state = 387},
  [7806] = {.lex_state = 244},
  [7807] = {.lex_state = 118},
  [7808] = {.lex_state = 244},
  [7809] = {.lex_state = 244},
  [7810] = {.lex_state = 118},
  [7811] = {.lex_state = 387},
  [7812] = {.lex_state = 203},
  [7813] = {.lex_state = 118},
  [7814] = {.lex_state = 387},
  [7815] = {.lex_state = 0},
  [7816] = {.lex_state = 230},
  [7817] = {.lex_state = 203},
  [7818] = {.lex_state = 281},
  [7819] = {.lex_state = 281},
  [7820] = {.lex_state = 118},
  [7821] = {.lex_state = 203},
  [7822] = {.lex_state = 244},
  [7823] = {.lex_state = 244},
  [7824] = {.lex_state = 116},
  [7825] = {.lex_state = 387},
  [7826] = {.lex_state = 244},
  [7827] = {.lex_state = 387},
  [7828] = {.lex_state = 203},
  [7829] = {.lex_state = 230},
  [7830] = {.lex_state = 244},
  [7831] = {.lex_state = 387},
  [7832] = {.lex_state = 244},
  [7833] = {.lex_state = 281},
  [7834] = {.lex_state = 244},
  [7835] = {.lex_state = 244},
  [7836] = {.lex_state = 281},
  [7837] = {.lex_state = 230},
  [7838] = {.lex_state = 116},
  [7839] = {.lex_state = 244},
  [7840] = {.lex_state = 387},
  [7841] = {.lex_state = 244},
  [7842] = {.lex_state = 230},
  [7843] = {.lex_state = 118},
  [7844] = {.lex_state = 244},
  [7845] = {.lex_state = 281},
  [7846] = {.lex_state = 118},
  [7847] = {.lex_state = 118},
  [7848] = {.lex_state = 0},
  [7849] = {.lex_state = 230},
  [7850] = {.lex_state = 118},
  [7851] = {.lex_state = 244},
  [7852] = {.lex_state = 118},
  [7853] = {.lex_state = 203},
  [7854] = {.lex_state = 387},
  [7855] = {.lex_state = 0},
  [7856] = {.lex_state = 203},
  [7857] = {.lex_state = 244},
  [7858] = {.lex_state = 281},
  [7859] = {.lex_state = 230},
  [7860] = {.lex_state = 387},
  [7861] = {.lex_state = 230},
  [7862] = {.lex_state = 118},
  [7863] = {.lex_state = 116},
  [7864] = {.lex_state = 244},
  [7865] = {.lex_state = 230},
  [7866] = {.lex_state = 230},
  [7867] = {.lex_state = 118},
  [7868] = {.lex_state = 244},
  [7869] = {.lex_state = 387},
  [7870] = {.lex_state = 387},
  [7871] = {.lex_state = 118},
  [7872] = {.lex_state = 230},
  [7873] = {.lex_state = 119},
  [7874] = {.lex_state = 244},
  [7875] = {.lex_state = 244},
  [7876] = {.lex_state = 203},
  [7877] = {.lex_state = 387},
  [7878] = {.lex_state = 203},
  [7879] = {.lex_state = 0},
  [7880] = {.lex_state = 118},
  [7881] = {.lex_state = 387},
  [7882] = {.lex_state = 387},
  [7883] = {.lex_state = 116},
  [7884] = {.lex_state = 387},
  [7885] = {.lex_state = 244},
  [7886] = {.lex_state = 203},
  [7887] = {.lex_state = 244},
  [7888] = {.lex_state = 244},
  [7889] = {.lex_state = 387},
  [7890] = {.lex_state = 230},
  [7891] = {.lex_state = 281},
  [7892] = {.lex_state = 116},
  [7893] = {.lex_state = 118},
  [7894] = {.lex_state = 203},
  [7895] = {.lex_state = 230},
  [7896] = {.lex_state = 118},
  [7897] = {.lex_state = 387},
  [7898] = {.lex_state = 230},
  [7899] = {.lex_state = 244},
  [7900] = {.lex_state = 118},
  [7901] = {.lex_state = 387},
  [7902] = {.lex_state = 244},
  [7903] = {.lex_state = 118},
  [7904] = {.lex_state = 0},
  [7905] = {.lex_state = 203},
  [7906] = {.lex_state = 118},
  [7907] = {.lex_state = 203},
  [7908] = {.lex_state = 244},
  [7909] = {.lex_state = 244},
  [7910] = {.lex_state = 119},
  [7911] = {.lex_state = 203},
  [7912] = {.lex_state = 230},
  [7913] = {.lex_state = 230},
  [7914] = {.lex_state = 0},
  [7915] = {.lex_state = 118},
  [7916] = {.lex_state = 203},
  [7917] = {.lex_state = 0},
  [7918] = {.lex_state = 116},
  [7919] = {.lex_state = 387},
  [7920] = {.lex_state = 230},
  [7921] = {.lex_state = 118},
  [7922] = {.lex_state = 118},
  [7923] = {.lex_state = 0},
  [7924] = {.lex_state = 116},
  [7925] = {.lex_state = 387},
  [7926] = {.lex_state = 203},
  [7927] = {.lex_state = 203},
  [7928] = {.lex_state = 0},
  [7929] = {.lex_state = 244},
  [7930] = {.lex_state = 281},
  [7931] = {.lex_state = 244},
  [7932] = {.lex_state = 244},
  [7933] = {.lex_state = 118},
  [7934] = {.lex_state = 244},
  [7935] = {.lex_state = 230},
  [7936] = {.lex_state = 244},
  [7937] = {.lex_state = 230},
  [7938] = {.lex_state = 230},
  [7939] = {.lex_state = 0},
  [7940] = {.lex_state = 387},
  [7941] = {.lex_state = 0},
  [7942] = {.lex_state = 244},
  [7943] = {.lex_state = 244},
  [7944] = {.lex_state = 0},
  [7945] = {.lex_state = 0},
  [7946] = {.lex_state = 0},
  [7947] = {.lex_state = 0},
  [7948] = {.lex_state = 121},
  [7949] = {.lex_state = 0},
  [7950] = {.lex_state = 230},
  [7951] = {.lex_state = 244},
  [7952] = {.lex_state = 0},
  [7953] = {.lex_state = 0},
  [7954] = {.lex_state = 0},
  [7955] = {.lex_state = 0},
  [7956] = {.lex_state = 244},
  [7957] = {.lex_state = 0},
  [7958] = {.lex_state = 116},
  [7959] = {.lex_state = 0},
  [7960] = {.lex_state = 0},
  [7961] = {.lex_state = 244},
  [7962] = {.lex_state = 230},
  [7963] = {.lex_state = 0},
  [7964] = {.lex_state = 0},
  [7965] = {.lex_state = 0},
  [7966] = {.lex_state = 244},
  [7967] = {.lex_state = 0},
  [7968] = {.lex_state = 0},
  [7969] = {.lex_state = 230},
  [7970] = {.lex_state = 230},
  [7971] = {.lex_state = 0},
  [7972] = {.lex_state = 0},
  [7973] = {.lex_state = 0},
  [7974] = {.lex_state = 244},
  [7975] = {.lex_state = 387},
  [7976] = {.lex_state = 0},
  [7977] = {.lex_state = 387},
  [7978] = {.lex_state = 0},
  [7979] = {.lex_state = 0},
  [7980] = {.lex_state = 244},
  [7981] = {.lex_state = 244},
  [7982] = {.lex_state = 116},
  [7983] = {.lex_state = 0},
  [7984] = {.lex_state = 0},
  [7985] = {.lex_state = 0},
  [7986] = {.lex_state = 230},
  [7987] = {.lex_state = 230},
  [7988] = {.lex_state = 230},
  [7989] = {.lex_state = 230},
  [7990] = {.lex_state = 230},
  [7991] = {.lex_state = 230},
  [7992] = {.lex_state = 244},
  [7993] = {.lex_state = 116},
  [7994] = {.lex_state = 244},
  [7995] = {.lex_state = 230},
  [7996] = {.lex_state = 244},
  [7997] = {.lex_state = 0},
  [7998] = {.lex_state = 0},
  [7999] = {.lex_state = 0},
  [8000] = {.lex_state = 0},
  [8001] = {.lex_state = 0},
  [8002] = {.lex_state = 0},
  [8003] = {.lex_state = 387},
  [8004] = {.lex_state = 0},
  [8005] = {.lex_state = 0},
  [8006] = {.lex_state = 230},
  [8007] = {.lex_state = 230},
  [8008] = {.lex_state = 0},
  [8009] = {.lex_state = 230},
  [8010] = {.lex_state = 0},
  [8011] = {.lex_state = 244},
  [8012] = {.lex_state = 116},
  [8013] = {.lex_state = 0},
  [8014] = {.lex_state = 230},
  [8015] = {.lex_state = 0},
  [8016] = {.lex_state = 0},
  [8017] = {.lex_state = 230},
  [8018] = {.lex_state = 0},
  [8019] = {.lex_state = 0},
  [8020] = {.lex_state = 0},
  [8021] = {.lex_state = 230},
  [8022] = {.lex_state = 0},
  [8023] = {.lex_state = 0},
  [8024] = {.lex_state = 0},
  [8025] = {.lex_state = 0},
  [8026] = {.lex_state = 387},
  [8027] = {.lex_state = 230},
  [8028] = {.lex_state = 230},
  [8029] = {.lex_state = 230},
  [8030] = {.lex_state = 230},
  [8031] = {.lex_state = 0},
  [8032] = {.lex_state = 244},
  [8033] = {.lex_state = 244},
  [8034] = {.lex_state = 0},
  [8035] = {.lex_state = 0},
  [8036] = {.lex_state = 116},
  [8037] = {.lex_state = 244},
  [8038] = {.lex_state = 0},
  [8039] = {.lex_state = 0},
  [8040] = {.lex_state = 244},
  [8041] = {.lex_state = 0},
  [8042] = {.lex_state = 0},
  [8043] = {.lex_state = 244},
  [8044] = {.lex_state = 0},
  [8045] = {.lex_state = 0},
  [8046] = {.lex_state = 116},
  [8047] = {.lex_state = 230},
  [8048] = {.lex_state = 230},
  [8049] = {.lex_state = 0},
  [8050] = {.lex_state = 244},
  [8051] = {.lex_state = 230},
  [8052] = {.lex_state = 230},
  [8053] = {.lex_state = 0},
  [8054] = {.lex_state = 0},
  [8055] = {.lex_state = 0},
  [8056] = {.lex_state = 121},
  [8057] = {.lex_state = 0},
  [8058] = {.lex_state = 0},
  [8059] = {.lex_state = 387},
  [8060] = {.lex_state = 0},
  [8061] = {.lex_state = 244},
  [8062] = {.lex_state = 387},
  [8063] = {.lex_state = 116},
  [8064] = {.lex_state = 244},
  [8065] = {.lex_state = 0},
  [8066] = {.lex_state = 0},
  [8067] = {.lex_state = 0},
  [8068] = {.lex_state = 0},
  [8069] = {.lex_state = 387},
  [8070] = {.lex_state = 0},
  [8071] = {.lex_state = 0},
  [8072] = {.lex_state = 0},
  [8073] = {.lex_state = 0},
  [8074] = {.lex_state = 0},
  [8075] = {.lex_state = 244},
  [8076] = {.lex_state = 0},
  [8077] = {.lex_state = 230},
  [8078] = {.lex_state = 0},
  [8079] = {.lex_state = 0},
  [8080] = {.lex_state = 0},
  [8081] = {.lex_state = 387},
  [8082] = {.lex_state = 0},
  [8083] = {.lex_state = 0},
  [8084] = {.lex_state = 0},
  [8085] = {.lex_state = 230},
  [8086] = {.lex_state = 244},
  [8087] = {.lex_state = 116},
  [8088] = {.lex_state = 0},
  [8089] = {.lex_state = 116},
  [8090] = {.lex_state = 0},
  [8091] = {.lex_state = 387},
  [8092] = {.lex_state = 116},
  [8093] = {.lex_state = 230},
  [8094] = {.lex_state = 230},
  [8095] = {.lex_state = 116},
  [8096] = {.lex_state = 116},
  [8097] = {.lex_state = 0},
  [8098] = {.lex_state = 244},
  [8099] = {.lex_state = 0},
  [8100] = {.lex_state = 244},
  [8101] = {.lex_state = 265},
  [8102] = {.lex_state = 0},
  [8103] = {.lex_state = 0},
  [8104] = {.lex_state = 121},
  [8105] = {.lex_state = 0},
  [8106] = {.lex_state = 0},
  [8107] = {.lex_state = 244},
  [8108] = {.lex_state = 0},
  [8109] = {.lex_state = 0},
  [8110] = {.lex_state = 0},
  [8111] = {.lex_state = 230},
  [8112] = {.lex_state = 244},
  [8113] = {.lex_state = 230},
  [8114] = {.lex_state = 0},
  [8115] = {.lex_state = 0},
  [8116] = {.lex_state = 230},
  [8117] = {.lex_state = 387},
  [8118] = {.lex_state = 0},
  [8119] = {.lex_state = 387},
  [8120] = {.lex_state = 0},
  [8121] = {.lex_state = 0},
  [8122] = {.lex_state = 0},
  [8123] = {.lex_state = 0},
  [8124] = {.lex_state = 0},
  [8125] = {.lex_state = 0},
  [8126] = {.lex_state = 0},
  [8127] = {.lex_state = 244},
  [8128] = {.lex_state = 0},
  [8129] = {.lex_state = 0},
  [8130] = {.lex_state = 244},
  [8131] = {.lex_state = 0},
  [8132] = {.lex_state = 230},
  [8133] = {.lex_state = 0},
  [8134] = {.lex_state = 0},
  [8135] = {.lex_state = 230},
  [8136] = {.lex_state = 0},
  [8137] = {.lex_state = 0},
  [8138] = {.lex_state = 0},
  [8139] = {.lex_state = 230},
  [8140] = {.lex_state = 0},
  [8141] = {.lex_state = 0},
  [8142] = {.lex_state = 0},
  [8143] = {.lex_state = 0},
  [8144] = {.lex_state = 0},
  [8145] = {.lex_state = 0},
  [8146] = {.lex_state = 0},
  [8147] = {.lex_state = 0},
  [8148] = {.lex_state = 0},
  [8149] = {.lex_state = 203},
  [8150] = {.lex_state = 0},
  [8151] = {.lex_state = 0},
  [8152] = {.lex_state = 0},
  [8153] = {.lex_state = 0},
  [8154] = {.lex_state = 0},
  [8155] = {.lex_state = 244},
  [8156] = {.lex_state = 0},
  [8157] = {.lex_state = 230},
  [8158] = {.lex_state = 0},
  [8159] = {.lex_state = 0},
  [8160] = {.lex_state = 0},
  [8161] = {.lex_state = 0},
  [8162] = {.lex_state = 0},
  [8163] = {.lex_state = 0},
  [8164] = {.lex_state = 244},
  [8165] = {.lex_state = 0},
  [8166] = {.lex_state = 0},
  [8167] = {.lex_state = 0},
  [8168] = {.lex_state = 0},
  [8169] = {.lex_state = 230},
  [8170] = {.lex_state = 0},
  [8171] = {.lex_state = 0},
  [8172] = {.lex_state = 230},
  [8173] = {.lex_state = 0},
  [8174] = {.lex_state = 230},
  [8175] = {.lex_state = 230},
  [8176] = {.lex_state = 0},
  [8177] = {.lex_state = 0},
  [8178] = {.lex_state = 0},
  [8179] = {.lex_state = 0},
  [8180] = {.lex_state = 0},
  [8181] = {.lex_state = 0},
  [8182] = {.lex_state = 230},
  [8183] = {.lex_state = 0},
  [8184] = {.lex_state = 387},
  [8185] = {.lex_state = 0},
  [8186] = {.lex_state = 230},
  [8187] = {.lex_state = 230},
  [8188] = {.lex_state = 230},
  [8189] = {.lex_state = 0},
  [8190] = {.lex_state = 0},
  [8191] = {.lex_state = 0},
  [8192] = {.lex_state = 0},
  [8193] = {.lex_state = 0},
  [8194] = {.lex_state = 0},
  [8195] = {.lex_state = 0},
  [8196] = {.lex_state = 244},
  [8197] = {.lex_state = 244},
  [8198] = {.lex_state = 0},
  [8199] = {.lex_state = 0},
  [8200] = {.lex_state = 0},
  [8201] = {.lex_state = 230},
  [8202] = {.lex_state = 0},
  [8203] = {.lex_state = 244},
  [8204] = {.lex_state = 0},
  [8205] = {.lex_state = 244},
  [8206] = {.lex_state = 0},
  [8207] = {.lex_state = 230},
  [8208] = {.lex_state = 0},
  [8209] = {.lex_state = 230},
  [8210] = {.lex_state = 0},
  [8211] = {.lex_state = 0},
  [8212] = {.lex_state = 230},
  [8213] = {.lex_state = 230},
  [8214] = {.lex_state = 0},
  [8215] = {.lex_state = 230},
  [8216] = {.lex_state = 0},
  [8217] = {.lex_state = 0},
  [8218] = {.lex_state = 0},
  [8219] = {.lex_state = 244},
  [8220] = {.lex_state = 0},
  [8221] = {.lex_state = 0},
  [8222] = {.lex_state = 0},
  [8223] = {.lex_state = 0},
  [8224] = {.lex_state = 230},
  [8225] = {.lex_state = 0},
  [8226] = {.lex_state = 230},
  [8227] = {.lex_state = 0},
  [8228] = {.lex_state = 0},
  [8229] = {.lex_state = 0},
  [8230] = {.lex_state = 0},
  [8231] = {.lex_state = 0},
  [8232] = {.lex_state = 0},
  [8233] = {.lex_state = 230},
  [8234] = {.lex_state = 0},
  [8235] = {.lex_state = 0},
  [8236] = {.lex_state = 0},
  [8237] = {.lex_state = 0},
  [8238] = {.lex_state = 230},
  [8239] = {.lex_state = 0},
  [8240] = {.lex_state = 0},
  [8241] = {.lex_state = 230},
  [8242] = {.lex_state = 230},
  [8243] = {.lex_state = 0},
  [8244] = {.lex_state = 203},
  [8245] = {.lex_state = 244},
  [8246] = {.lex_state = 387},
  [8247] = {.lex_state = 189},
  [8248] = {.lex_state = 0},
  [8249] = {.lex_state = 0},
  [8250] = {.lex_state = 244},
  [8251] = {.lex_state = 387},
  [8252] = {.lex_state = 244},
  [8253] = {.lex_state = 0},
  [8254] = {.lex_state = 0},
  [8255] = {.lex_state = 0},
  [8256] = {.lex_state = 0},
  [8257] = {.lex_state = 0},
  [8258] = {.lex_state = 0},
  [8259] = {.lex_state = 0},
  [8260] = {.lex_state = 0},
  [8261] = {.lex_state = 0},
  [8262] = {.lex_state = 0},
  [8263] = {.lex_state = 387},
  [8264] = {.lex_state = 230},
  [8265] = {.lex_state = 230},
  [8266] = {.lex_state = 230},
  [8267] = {.lex_state = 230},
  [8268] = {.lex_state = 244},
  [8269] = {.lex_state = 387},
  [8270] = {.lex_state = 0},
  [8271] = {.lex_state = 244},
  [8272] = {.lex_state = 230},
  [8273] = {.lex_state = 0},
  [8274] = {.lex_state = 244},
  [8275] = {.lex_state = 0},
  [8276] = {.lex_state = 0},
  [8277] = {.lex_state = 244},
  [8278] = {.lex_state = 121},
  [8279] = {.lex_state = 0},
  [8280] = {.lex_state = 0},
  [8281] = {.lex_state = 0},
  [8282] = {.lex_state = 0},
  [8283] = {.lex_state = 0},
  [8284] = {.lex_state = 0},
  [8285] = {.lex_state = 244},
  [8286] = {.lex_state = 0},
  [8287] = {.lex_state = 244},
  [8288] = {.lex_state = 0},
  [8289] = {.lex_state = 0},
  [8290] = {.lex_state = 0},
  [8291] = {.lex_state = 0},
  [8292] = {.lex_state = 0},
  [8293] = {.lex_state = 0},
  [8294] = {.lex_state = 203},
  [8295] = {.lex_state = 230},
  [8296] = {.lex_state = 244},
  [8297] = {.lex_state = 0},
  [8298] = {.lex_state = 0},
  [8299] = {.lex_state = 244},
  [8300] = {.lex_state = 0},
  [8301] = {.lex_state = 0},
  [8302] = {.lex_state = 0},
  [8303] = {.lex_state = 0},
  [8304] = {.lex_state = 0},
  [8305] = {.lex_state = 244},
  [8306] = {.lex_state = 387},
  [8307] = {.lex_state = 121},
  [8308] = {.lex_state = 0},
  [8309] = {.lex_state = 0},
  [8310] = {.lex_state = 0},
  [8311] = {.lex_state = 230},
  [8312] = {.lex_state = 230},
  [8313] = {.lex_state = 230},
  [8314] = {.lex_state = 0},
  [8315] = {.lex_state = 230},
  [8316] = {.lex_state = 230},
  [8317] = {.lex_state = 244},
  [8318] = {.lex_state = 230},
  [8319] = {.lex_state = 0},
  [8320] = {.lex_state = 230},
  [8321] = {.lex_state = 0},
  [8322] = {.lex_state = 0},
  [8323] = {.lex_state = 0},
  [8324] = {.lex_state = 0},
  [8325] = {.lex_state = 0},
  [8326] = {.lex_state = 387},
  [8327] = {.lex_state = 0},
  [8328] = {.lex_state = 244},
  [8329] = {.lex_state = 0},
  [8330] = {.lex_state = 244},
  [8331] = {.lex_state = 0},
  [8332] = {.lex_state = 0},
  [8333] = {.lex_state = 0},
  [8334] = {.lex_state = 230},
  [8335] = {.lex_state = 230},
  [8336] = {.lex_state = 0},
  [8337] = {.lex_state = 244},
  [8338] = {.lex_state = 244},
  [8339] = {.lex_state = 116},
  [8340] = {.lex_state = 0},
  [8341] = {.lex_state = 0},
  [8342] = {.lex_state = 0},
  [8343] = {.lex_state = 0},
  [8344] = {.lex_state = 0},
  [8345] = {.lex_state = 0},
  [8346] = {.lex_state = 244},
  [8347] = {.lex_state = 0},
  [8348] = {.lex_state = 387},
  [8349] = {.lex_state = 230},
  [8350] = {.lex_state = 0},
  [8351] = {.lex_state = 230},
  [8352] = {.lex_state = 0},
  [8353] = {.lex_state = 0},
  [8354] = {.lex_state = 116},
  [8355] = {.lex_state = 387},
  [8356] = {.lex_state = 0},
  [8357] = {.lex_state = 244},
  [8358] = {.lex_state = 244},
  [8359] = {.lex_state = 387},
  [8360] = {.lex_state = 244},
  [8361] = {.lex_state = 0},
  [8362] = {.lex_state = 0},
  [8363] = {.lex_state = 0},
  [8364] = {.lex_state = 0},
  [8365] = {.lex_state = 0},
  [8366] = {.lex_state = 244},
  [8367] = {.lex_state = 0},
  [8368] = {.lex_state = 0},
  [8369] = {.lex_state = 0},
  [8370] = {.lex_state = 0},
  [8371] = {.lex_state = 230},
  [8372] = {.lex_state = 230},
  [8373] = {.lex_state = 0},
  [8374] = {.lex_state = 0},
  [8375] = {.lex_state = 244},
  [8376] = {.lex_state = 0},
  [8377] = {.lex_state = 230},
  [8378] = {.lex_state = 244},
  [8379] = {.lex_state = 230},
  [8380] = {.lex_state = 230},
  [8381] = {.lex_state = 0},
  [8382] = {.lex_state = 0},
  [8383] = {.lex_state = 0},
  [8384] = {.lex_state = 0},
  [8385] = {.lex_state = 0},
  [8386] = {.lex_state = 244},
  [8387] = {.lex_state = 0},
  [8388] = {.lex_state = 387},
  [8389] = {.lex_state = 387},
  [8390] = {.lex_state = 0},
  [8391] = {.lex_state = 120},
  [8392] = {.lex_state = 120},
  [8393] = {.lex_state = 244},
  [8394] = {.lex_state = 244},
  [8395] = {.lex_state = 387},
  [8396] = {.lex_state = 244},
  [8397] = {.lex_state = 244},
  [8398] = {.lex_state = 244},
  [8399] = {.lex_state = 0},
  [8400] = {.lex_state = 244},
  [8401] = {.lex_state = 244},
  [8402] = {.lex_state = 244},
  [8403] = {.lex_state = 0},
  [8404] = {.lex_state = 244},
  [8405] = {.lex_state = 387, .external_lex_state = 2},
  [8406] = {.lex_state = 244},
  [8407] = {.lex_state = 387, .external_lex_state = 2},
  [8408] = {.lex_state = 387, .external_lex_state = 2},
  [8409] = {.lex_state = 0},
  [8410] = {.lex_state = 0},
  [8411] = {.lex_state = 0},
  [8412] = {.lex_state = 387, .external_lex_state = 2},
  [8413] = {.lex_state = 387},
  [8414] = {.lex_state = 387, .external_lex_state = 2},
  [8415] = {.lex_state = 387},
  [8416] = {.lex_state = 387, .external_lex_state = 2},
  [8417] = {.lex_state = 387, .external_lex_state = 2},
  [8418] = {.lex_state = 387, .external_lex_state = 2},
  [8419] = {.lex_state = 387, .external_lex_state = 2},
  [8420] = {.lex_state = 387, .external_lex_state = 2},
  [8421] = {.lex_state = 0},
  [8422] = {.lex_state = 387, .external_lex_state = 2},
  [8423] = {.lex_state = 0},
  [8424] = {.lex_state = 244},
  [8425] = {.lex_state = 0},
  [8426] = {.lex_state = 387, .external_lex_state = 2},
  [8427] = {.lex_state = 0},
  [8428] = {.lex_state = 0},
  [8429] = {.lex_state = 0},
  [8430] = {.lex_state = 0},
  [8431] = {.lex_state = 244},
  [8432] = {.lex_state = 0},
  [8433] = {.lex_state = 387},
  [8434] = {.lex_state = 387, .external_lex_state = 2},
  [8435] = {.lex_state = 387, .external_lex_state = 2},
  [8436] = {.lex_state = 387, .external_lex_state = 2},
  [8437] = {.lex_state = 0},
  [8438] = {.lex_state = 387},
  [8439] = {.lex_state = 387, .external_lex_state = 2},
  [8440] = {.lex_state = 244},
  [8441] = {.lex_state = 120},
  [8442] = {.lex_state = 0},
  [8443] = {.lex_state = 387, .external_lex_state = 2},
  [8444] = {.lex_state = 387},
  [8445] = {.lex_state = 387},
  [8446] = {.lex_state = 387},
  [8447] = {.lex_state = 0},
  [8448] = {.lex_state = 387},
  [8449] = {.lex_state = 0},
  [8450] = {.lex_state = 387},
  [8451] = {.lex_state = 387},
  [8452] = {.lex_state = 0},
  [8453] = {.lex_state = 0},
  [8454] = {.lex_state = 0},
  [8455] = {.lex_state = 0},
  [8456] = {.lex_state = 120},
  [8457] = {.lex_state = 244},
  [8458] = {.lex_state = 0},
  [8459] = {.lex_state = 387},
  [8460] = {.lex_state = 387, .external_lex_state = 2},
  [8461] = {.lex_state = 0},
  [8462] = {.lex_state = 0},
  [8463] = {.lex_state = 244},
  [8464] = {.lex_state = 0},
  [8465] = {.lex_state = 0},
  [8466] = {.lex_state = 0},
  [8467] = {.lex_state = 0},
  [8468] = {.lex_state = 0},
  [8469] = {.lex_state = 0},
  [8470] = {.lex_state = 0},
  [8471] = {.lex_state = 0},
  [8472] = {.lex_state = 0},
  [8473] = {.lex_state = 0},
  [8474] = {.lex_state = 387},
  [8475] = {.lex_state = 0},
  [8476] = {.lex_state = 0},
  [8477] = {.lex_state = 387, .external_lex_state = 2},
  [8478] = {.lex_state = 244},
  [8479] = {.lex_state = 387},
  [8480] = {.lex_state = 244},
  [8481] = {.lex_state = 387},
  [8482] = {.lex_state = 120},
  [8483] = {.lex_state = 0},
  [8484] = {.lex_state = 0},
  [8485] = {.lex_state = 0},
  [8486] = {.lex_state = 120},
  [8487] = {.lex_state = 0},
  [8488] = {.lex_state = 120},
  [8489] = {.lex_state = 387},
  [8490] = {.lex_state = 244},
  [8491] = {.lex_state = 0},
  [8492] = {.lex_state = 0},
  [8493] = {.lex_state = 244},
  [8494] = {.lex_state = 0},
  [8495] = {.lex_state = 0},
  [8496] = {.lex_state = 0},
  [8497] = {.lex_state = 0},
  [8498] = {.lex_state = 120},
  [8499] = {.lex_state = 387},
  [8500] = {.lex_state = 387},
  [8501] = {.lex_state = 244},
  [8502] = {.lex_state = 387},
  [8503] = {.lex_state = 0},
  [8504] = {.lex_state = 0},
  [8505] = {.lex_state = 387},
  [8506] = {.lex_state = 0},
  [8507] = {.lex_state = 0},
  [8508] = {.lex_state = 0},
  [8509] = {.lex_state = 0},
  [8510] = {.lex_state = 387},
  [8511] = {.lex_state = 0},
  [8512] = {.lex_state = 244},
  [8513] = {.lex_state = 0},
  [8514] = {.lex_state = 0},
  [8515] = {.lex_state = 0},
  [8516] = {.lex_state = 0},
  [8517] = {.lex_state = 0},
  [8518] = {.lex_state = 0},
  [8519] = {.lex_state = 0},
  [8520] = {.lex_state = 0},
  [8521] = {.lex_state = 0},
  [8522] = {.lex_state = 0},
  [8523] = {.lex_state = 0},
  [8524] = {.lex_state = 0},
  [8525] = {.lex_state = 0},
  [8526] = {.lex_state = 120},
  [8527] = {.lex_state = 0},
  [8528] = {.lex_state = 0},
  [8529] = {.lex_state = 0},
  [8530] = {.lex_state = 0},
  [8531] = {.lex_state = 0},
  [8532] = {.lex_state = 0},
  [8533] = {.lex_state = 0},
  [8534] = {.lex_state = 0},
  [8535] = {.lex_state = 0},
  [8536] = {.lex_state = 0},
  [8537] = {.lex_state = 0},
  [8538] = {.lex_state = 387},
  [8539] = {.lex_state = 0},
  [8540] = {.lex_state = 387},
  [8541] = {.lex_state = 0},
  [8542] = {.lex_state = 0},
  [8543] = {.lex_state = 0},
  [8544] = {.lex_state = 0},
  [8545] = {.lex_state = 120},
  [8546] = {.lex_state = 0},
  [8547] = {.lex_state = 0},
  [8548] = {.lex_state = 0},
  [8549] = {.lex_state = 0},
  [8550] = {.lex_state = 0},
  [8551] = {.lex_state = 387},
  [8552] = {.lex_state = 0},
  [8553] = {.lex_state = 0},
  [8554] = {.lex_state = 0},
  [8555] = {.lex_state = 0},
  [8556] = {.lex_state = 0},
  [8557] = {.lex_state = 0},
  [8558] = {.lex_state = 120},
  [8559] = {.lex_state = 244},
  [8560] = {.lex_state = 0},
  [8561] = {.lex_state = 387},
  [8562] = {.lex_state = 0},
  [8563] = {.lex_state = 387},
  [8564] = {.lex_state = 0},
  [8565] = {.lex_state = 0},
  [8566] = {.lex_state = 0},
  [8567] = {.lex_state = 0},
  [8568] = {.lex_state = 244},
  [8569] = {.lex_state = 387},
  [8570] = {.lex_state = 0},
  [8571] = {.lex_state = 244},
  [8572] = {.lex_state = 0},
  [8573] = {.lex_state = 120},
  [8574] = {.lex_state = 387},
  [8575] = {.lex_state = 387},
  [8576] = {.lex_state = 0},
  [8577] = {.lex_state = 0},
  [8578] = {.lex_state = 0},
  [8579] = {.lex_state = 0},
  [8580] = {.lex_state = 0},
  [8581] = {.lex_state = 387},
  [8582] = {.lex_state = 0},
  [8583] = {.lex_state = 387},
  [8584] = {.lex_state = 244},
  [8585] = {.lex_state = 387},
  [8586] = {.lex_state = 0},
  [8587] = {.lex_state = 387},
  [8588] = {.lex_state = 244},
  [8589] = {.lex_state = 0},
  [8590] = {.lex_state = 0},
  [8591] = {.lex_state = 0},
  [8592] = {.lex_state = 0},
  [8593] = {.lex_state = 387},
  [8594] = {.lex_state = 0},
  [8595] = {.lex_state = 0},
  [8596] = {.lex_state = 0},
  [8597] = {.lex_state = 0},
  [8598] = {.lex_state = 387},
  [8599] = {.lex_state = 0},
  [8600] = {.lex_state = 0},
  [8601] = {.lex_state = 0},
  [8602] = {.lex_state = 0},
  [8603] = {.lex_state = 387},
  [8604] = {.lex_state = 244},
  [8605] = {.lex_state = 0},
  [8606] = {.lex_state = 0},
  [8607] = {.lex_state = 387},
  [8608] = {.lex_state = 0},
  [8609] = {.lex_state = 0},
  [8610] = {.lex_state = 244},
  [8611] = {.lex_state = 0},
  [8612] = {.lex_state = 120},
  [8613] = {.lex_state = 387},
  [8614] = {.lex_state = 387},
  [8615] = {.lex_state = 0},
  [8616] = {.lex_state = 120},
  [8617] = {.lex_state = 0},
  [8618] = {.lex_state = 0},
  [8619] = {.lex_state = 0},
  [8620] = {.lex_state = 0},
  [8621] = {.lex_state = 387},
  [8622] = {.lex_state = 387},
  [8623] = {.lex_state = 0},
  [8624] = {.lex_state = 387},
  [8625] = {.lex_state = 0},
  [8626] = {.lex_state = 244},
  [8627] = {.lex_state = 0},
  [8628] = {.lex_state = 0},
  [8629] = {.lex_state = 0},
  [8630] = {.lex_state = 387},
  [8631] = {.lex_state = 0},
  [8632] = {.lex_state = 0},
  [8633] = {.lex_state = 120},
  [8634] = {.lex_state = 244},
  [8635] = {.lex_state = 0},
  [8636] = {.lex_state = 0},
  [8637] = {.lex_state = 387},
  [8638] = {.lex_state = 0},
  [8639] = {.lex_state = 0},
  [8640] = {.lex_state = 387},
  [8641] = {.lex_state = 0},
  [8642] = {.lex_state = 0},
  [8643] = {.lex_state = 387},
  [8644] = {.lex_state = 0},
  [8645] = {.lex_state = 0},
  [8646] = {.lex_state = 0},
  [8647] = {.lex_state = 0},
  [8648] = {.lex_state = 387},
  [8649] = {.lex_state = 0},
  [8650] = {.lex_state = 0},
  [8651] = {.lex_state = 0},
  [8652] = {.lex_state = 387},
  [8653] = {.lex_state = 244},
  [8654] = {.lex_state = 0},
  [8655] = {.lex_state = 120},
  [8656] = {.lex_state = 0},
  [8657] = {.lex_state = 387},
  [8658] = {.lex_state = 0},
  [8659] = {.lex_state = 244},
  [8660] = {.lex_state = 0},
  [8661] = {.lex_state = 0},
  [8662] = {.lex_state = 0},
  [8663] = {.lex_state = 0},
  [8664] = {.lex_state = 0},
  [8665] = {.lex_state = 0},
  [8666] = {.lex_state = 387},
  [8667] = {.lex_state = 0},
  [8668] = {.lex_state = 0},
  [8669] = {.lex_state = 0},
  [8670] = {.lex_state = 120},
  [8671] = {.lex_state = 244},
  [8672] = {.lex_state = 0},
  [8673] = {.lex_state = 244},
  [8674] = {.lex_state = 0},
  [8675] = {.lex_state = 387},
  [8676] = {.lex_state = 387},
  [8677] = {.lex_state = 387},
  [8678] = {.lex_state = 0},
  [8679] = {.lex_state = 244},
  [8680] = {.lex_state = 387},
  [8681] = {.lex_state = 244},
  [8682] = {.lex_state = 0},
  [8683] = {.lex_state = 387},
  [8684] = {.lex_state = 120},
  [8685] = {.lex_state = 244},
  [8686] = {.lex_state = 0},
  [8687] = {.lex_state = 387},
  [8688] = {.lex_state = 244},
  [8689] = {.lex_state = 0},
  [8690] = {.lex_state = 387},
  [8691] = {.lex_state = 0},
  [8692] = {.lex_state = 244},
  [8693] = {.lex_state = 387},
  [8694] = {.lex_state = 0},
  [8695] = {.lex_state = 0},
  [8696] = {.lex_state = 0},
  [8697] = {.lex_state = 387},
  [8698] = {.lex_state = 0},
  [8699] = {.lex_state = 387},
  [8700] = {.lex_state = 0},
  [8701] = {.lex_state = 387},
  [8702] = {.lex_state = 0},
  [8703] = {.lex_state = 0},
  [8704] = {.lex_state = 0},
  [8705] = {.lex_state = 0},
  [8706] = {.lex_state = 387},
  [8707] = {.lex_state = 387},
  [8708] = {.lex_state = 0},
  [8709] = {.lex_state = 244},
  [8710] = {.lex_state = 0},
  [8711] = {.lex_state = 0},
  [8712] = {.lex_state = 0},
  [8713] = {.lex_state = 0},
  [8714] = {.lex_state = 387},
  [8715] = {.lex_state = 244},
  [8716] = {.lex_state = 0},
  [8717] = {.lex_state = 387},
  [8718] = {.lex_state = 244},
  [8719] = {.lex_state = 0},
  [8720] = {.lex_state = 120},
  [8721] = {.lex_state = 0},
  [8722] = {.lex_state = 0},
  [8723] = {.lex_state = 0},
  [8724] = {.lex_state = 0},
  [8725] = {.lex_state = 387},
  [8726] = {.lex_state = 387},
  [8727] = {.lex_state = 0},
  [8728] = {.lex_state = 0},
  [8729] = {.lex_state = 244},
  [8730] = {.lex_state = 387},
  [8731] = {.lex_state = 0},
  [8732] = {.lex_state = 387},
  [8733] = {.lex_state = 0},
  [8734] = {.lex_state = 387},
  [8735] = {.lex_state = 244},
  [8736] = {.lex_state = 0},
  [8737] = {.lex_state = 0},
  [8738] = {.lex_state = 387},
  [8739] = {.lex_state = 0},
  [8740] = {.lex_state = 0},
  [8741] = {.lex_state = 0},
  [8742] = {.lex_state = 0},
  [8743] = {.lex_state = 0},
  [8744] = {.lex_state = 0},
  [8745] = {.lex_state = 387},
  [8746] = {.lex_state = 244},
  [8747] = {.lex_state = 0},
  [8748] = {.lex_state = 244},
  [8749] = {.lex_state = 387},
  [8750] = {.lex_state = 120},
  [8751] = {.lex_state = 0},
  [8752] = {.lex_state = 387},
  [8753] = {.lex_state = 0},
  [8754] = {.lex_state = 387},
  [8755] = {.lex_state = 387},
  [8756] = {.lex_state = 0},
  [8757] = {.lex_state = 387},
  [8758] = {.lex_state = 387},
  [8759] = {.lex_state = 0},
  [8760] = {.lex_state = 0},
  [8761] = {.lex_state = 244},
  [8762] = {.lex_state = 0},
  [8763] = {.lex_state = 0},
  [8764] = {.lex_state = 0},
  [8765] = {.lex_state = 244},
  [8766] = {.lex_state = 0},
  [8767] = {.lex_state = 387},
  [8768] = {.lex_state = 387},
  [8769] = {.lex_state = 0},
  [8770] = {.lex_state = 387},
  [8771] = {.lex_state = 244},
  [8772] = {.lex_state = 120},
  [8773] = {.lex_state = 0},
  [8774] = {.lex_state = 387},
  [8775] = {.lex_state = 387},
  [8776] = {.lex_state = 0},
  [8777] = {.lex_state = 0},
  [8778] = {.lex_state = 0},
  [8779] = {.lex_state = 0},
  [8780] = {.lex_state = 387},
  [8781] = {.lex_state = 0},
  [8782] = {.lex_state = 244},
  [8783] = {.lex_state = 387},
  [8784] = {.lex_state = 244},
  [8785] = {.lex_state = 387},
  [8786] = {.lex_state = 244},
  [8787] = {.lex_state = 230},
  [8788] = {.lex_state = 0},
  [8789] = {.lex_state = 0},
  [8790] = {.lex_state = 0},
  [8791] = {.lex_state = 0},
  [8792] = {.lex_state = 244},
  [8793] = {.lex_state = 230},
  [8794] = {.lex_state = 0},
  [8795] = {.lex_state = 0},
  [8796] = {.lex_state = 200},
  [8797] = {.lex_state = 0},
  [8798] = {.lex_state = 0},
  [8799] = {.lex_state = 0},
  [8800] = {.lex_state = 244},
  [8801] = {.lex_state = 387},
  [8802] = {.lex_state = 0},
  [8803] = {.lex_state = 0},
  [8804] = {.lex_state = 0},
  [8805] = {.lex_state = 0},
  [8806] = {.lex_state = 0},
  [8807] = {.lex_state = 0},
  [8808] = {.lex_state = 0, .external_lex_state = 2},
  [8809] = {.lex_state = 0},
  [8810] = {.lex_state = 0},
  [8811] = {.lex_state = 0},
  [8812] = {.lex_state = 230},
  [8813] = {.lex_state = 0},
  [8814] = {.lex_state = 0},
  [8815] = {.lex_state = 200},
  [8816] = {.lex_state = 0},
  [8817] = {.lex_state = 0},
  [8818] = {.lex_state = 0},
  [8819] = {.lex_state = 0},
  [8820] = {.lex_state = 0},
  [8821] = {.lex_state = 121},
  [8822] = {.lex_state = 0},
  [8823] = {.lex_state = 387},
  [8824] = {.lex_state = 0},
  [8825] = {.lex_state = 198},
  [8826] = {.lex_state = 198},
  [8827] = {.lex_state = 200},
  [8828] = {.lex_state = 202},
  [8829] = {.lex_state = 230},
  [8830] = {.lex_state = 200},
  [8831] = {.lex_state = 244},
  [8832] = {.lex_state = 0},
  [8833] = {.lex_state = 200},
  [8834] = {.lex_state = 244},
  [8835] = {.lex_state = 244},
  [8836] = {.lex_state = 0},
  [8837] = {.lex_state = 200},
  [8838] = {.lex_state = 0},
  [8839] = {.lex_state = 0},
  [8840] = {.lex_state = 387},
  [8841] = {.lex_state = 0},
  [8842] = {.lex_state = 0},
  [8843] = {.lex_state = 0},
  [8844] = {.lex_state = 244},
  [8845] = {.lex_state = 0},
  [8846] = {.lex_state = 0},
  [8847] = {.lex_state = 0},
  [8848] = {.lex_state = 0},
  [8849] = {.lex_state = 0},
  [8850] = {.lex_state = 244},
  [8851] = {.lex_state = 0},
  [8852] = {.lex_state = 387},
  [8853] = {.lex_state = 198},
  [8854] = {.lex_state = 244},
  [8855] = {.lex_state = 0},
  [8856] = {.lex_state = 0},
  [8857] = {.lex_state = 0},
  [8858] = {.lex_state = 0},
  [8859] = {.lex_state = 0},
  [8860] = {.lex_state = 0},
  [8861] = {.lex_state = 0},
  [8862] = {.lex_state = 0},
  [8863] = {.lex_state = 0},
  [8864] = {.lex_state = 0},
  [8865] = {.lex_state = 200},
  [8866] = {.lex_state = 0},
  [8867] = {.lex_state = 387},
  [8868] = {.lex_state = 244},
  [8869] = {.lex_state = 0},
  [8870] = {.lex_state = 0},
  [8871] = {.lex_state = 244},
  [8872] = {.lex_state = 387},
  [8873] = {.lex_state = 0},
  [8874] = {.lex_state = 0},
  [8875] = {.lex_state = 0},
  [8876] = {.lex_state = 0},
  [8877] = {.lex_state = 244},
  [8878] = {.lex_state = 387},
  [8879] = {.lex_state = 121},
  [8880] = {.lex_state = 387},
  [8881] = {.lex_state = 0},
  [8882] = {.lex_state = 0},
  [8883] = {.lex_state = 244},
  [8884] = {.lex_state = 200},
  [8885] = {.lex_state = 0},
  [8886] = {.lex_state = 0},
  [8887] = {.lex_state = 0},
  [8888] = {.lex_state = 0},
  [8889] = {.lex_state = 230},
  [8890] = {.lex_state = 0},
  [8891] = {.lex_state = 387},
  [8892] = {.lex_state = 244},
  [8893] = {.lex_state = 0, .external_lex_state = 3},
  [8894] = {.lex_state = 0},
  [8895] = {.lex_state = 0},
  [8896] = {.lex_state = 0},
  [8897] = {.lex_state = 387},
  [8898] = {.lex_state = 0},
  [8899] = {.lex_state = 282},
  [8900] = {.lex_state = 0},
  [8901] = {.lex_state = 0},
  [8902] = {.lex_state = 0},
  [8903] = {.lex_state = 244},
  [8904] = {.lex_state = 0},
  [8905] = {.lex_state = 0},
  [8906] = {.lex_state = 0},
  [8907] = {.lex_state = 252},
  [8908] = {.lex_state = 0},
  [8909] = {.lex_state = 230},
  [8910] = {.lex_state = 0, .external_lex_state = 2},
  [8911] = {.lex_state = 0},
  [8912] = {.lex_state = 387},
  [8913] = {.lex_state = 0},
  [8914] = {.lex_state = 0},
  [8915] = {.lex_state = 0},
  [8916] = {.lex_state = 0},
  [8917] = {.lex_state = 121},
  [8918] = {.lex_state = 0},
  [8919] = {.lex_state = 244},
  [8920] = {.lex_state = 244},
  [8921] = {.lex_state = 0},
  [8922] = {.lex_state = 0},
  [8923] = {.lex_state = 0},
  [8924] = {.lex_state = 0},
  [8925] = {.lex_state = 244},
  [8926] = {.lex_state = 0},
  [8927] = {.lex_state = 0},
  [8928] = {.lex_state = 0},
  [8929] = {.lex_state = 244},
  [8930] = {.lex_state = 0},
  [8931] = {.lex_state = 0},
  [8932] = {.lex_state = 244},
  [8933] = {.lex_state = 244},
  [8934] = {.lex_state = 121},
  [8935] = {.lex_state = 121},
  [8936] = {.lex_state = 387},
  [8937] = {.lex_state = 121},
  [8938] = {.lex_state = 0},
  [8939] = {.lex_state = 0},
  [8940] = {.lex_state = 0},
  [8941] = {.lex_state = 0},
  [8942] = {.lex_state = 0},
  [8943] = {.lex_state = 0},
  [8944] = {.lex_state = 121},
  [8945] = {.lex_state = 0},
  [8946] = {.lex_state = 0},
  [8947] = {.lex_state = 387},
  [8948] = {.lex_state = 0},
  [8949] = {.lex_state = 0},
  [8950] = {.lex_state = 0},
  [8951] = {.lex_state = 0},
  [8952] = {.lex_state = 0},
  [8953] = {.lex_state = 0},
  [8954] = {.lex_state = 387},
  [8955] = {.lex_state = 0},
  [8956] = {.lex_state = 0},
  [8957] = {.lex_state = 200},
  [8958] = {.lex_state = 0},
  [8959] = {.lex_state = 244},
  [8960] = {.lex_state = 0},
  [8961] = {.lex_state = 0},
  [8962] = {.lex_state = 0},
  [8963] = {.lex_state = 0},
  [8964] = {.lex_state = 244},
  [8965] = {.lex_state = 200},
  [8966] = {.lex_state = 0},
  [8967] = {.lex_state = 198},
  [8968] = {.lex_state = 0},
  [8969] = {.lex_state = 121},
  [8970] = {.lex_state = 244},
  [8971] = {.lex_state = 0},
  [8972] = {.lex_state = 244},
  [8973] = {.lex_state = 0},
  [8974] = {.lex_state = 244},
  [8975] = {.lex_state = 200},
  [8976] = {.lex_state = 0},
  [8977] = {.lex_state = 230},
  [8978] = {.lex_state = 200},
  [8979] = {.lex_state = 230},
  [8980] = {.lex_state = 0},
  [8981] = {.lex_state = 244},
  [8982] = {.lex_state = 387},
  [8983] = {.lex_state = 244},
  [8984] = {.lex_state = 0},
  [8985] = {.lex_state = 0},
  [8986] = {.lex_state = 0, .external_lex_state = 2},
  [8987] = {.lex_state = 0},
  [8988] = {.lex_state = 244},
  [8989] = {.lex_state = 0},
  [8990] = {.lex_state = 0},
  [8991] = {.lex_state = 0},
  [8992] = {.lex_state = 0},
  [8993] = {.lex_state = 244},
  [8994] = {.lex_state = 0},
  [8995] = {.lex_state = 0},
  [8996] = {.lex_state = 0},
  [8997] = {.lex_state = 0},
  [8998] = {.lex_state = 0},
  [8999] = {.lex_state = 387},
  [9000] = {.lex_state = 0},
  [9001] = {.lex_state = 230},
  [9002] = {.lex_state = 0},
  [9003] = {.lex_state = 0},
  [9004] = {.lex_state = 0},
  [9005] = {.lex_state = 0},
  [9006] = {.lex_state = 0},
  [9007] = {.lex_state = 121},
  [9008] = {.lex_state = 200},
  [9009] = {.lex_state = 0},
  [9010] = {.lex_state = 0},
  [9011] = {.lex_state = 0},
  [9012] = {.lex_state = 0},
  [9013] = {.lex_state = 387},
  [9014] = {.lex_state = 0},
  [9015] = {.lex_state = 0},
  [9016] = {.lex_state = 0},
  [9017] = {.lex_state = 244},
  [9018] = {.lex_state = 0},
  [9019] = {.lex_state = 244},
  [9020] = {.lex_state = 244},
  [9021] = {.lex_state = 0},
  [9022] = {.lex_state = 0},
  [9023] = {.lex_state = 0},
  [9024] = {.lex_state = 200},
  [9025] = {.lex_state = 0},
  [9026] = {.lex_state = 0},
  [9027] = {.lex_state = 0},
  [9028] = {.lex_state = 0},
  [9029] = {.lex_state = 0},
  [9030] = {.lex_state = 0},
  [9031] = {.lex_state = 0},
  [9032] = {.lex_state = 0},
  [9033] = {.lex_state = 0},
  [9034] = {.lex_state = 0},
  [9035] = {.lex_state = 244},
  [9036] = {.lex_state = 200},
  [9037] = {.lex_state = 0},
  [9038] = {.lex_state = 0},
  [9039] = {.lex_state = 0},
  [9040] = {.lex_state = 0, .external_lex_state = 2},
  [9041] = {.lex_state = 0},
  [9042] = {.lex_state = 244},
  [9043] = {.lex_state = 0},
  [9044] = {.lex_state = 244},
  [9045] = {.lex_state = 387},
  [9046] = {.lex_state = 200},
  [9047] = {.lex_state = 230},
  [9048] = {.lex_state = 121},
  [9049] = {.lex_state = 244},
  [9050] = {.lex_state = 0},
  [9051] = {.lex_state = 244},
  [9052] = {.lex_state = 0},
  [9053] = {.lex_state = 244},
  [9054] = {.lex_state = 121},
  [9055] = {.lex_state = 0},
  [9056] = {.lex_state = 0},
  [9057] = {.lex_state = 0},
  [9058] = {.lex_state = 387},
  [9059] = {.lex_state = 0},
  [9060] = {.lex_state = 0},
  [9061] = {.lex_state = 200},
  [9062] = {.lex_state = 0},
  [9063] = {.lex_state = 0},
  [9064] = {.lex_state = 244},
  [9065] = {.lex_state = 0},
  [9066] = {.lex_state = 244},
  [9067] = {.lex_state = 0},
  [9068] = {.lex_state = 0},
  [9069] = {.lex_state = 0},
  [9070] = {.lex_state = 0},
  [9071] = {.lex_state = 0},
  [9072] = {.lex_state = 0},
  [9073] = {.lex_state = 244},
  [9074] = {.lex_state = 0},
  [9075] = {.lex_state = 230},
  [9076] = {.lex_state = 0},
  [9077] = {.lex_state = 0},
  [9078] = {.lex_state = 121},
  [9079] = {.lex_state = 0},
  [9080] = {.lex_state = 0},
  [9081] = {.lex_state = 0},
  [9082] = {.lex_state = 0},
  [9083] = {.lex_state = 0},
  [9084] = {.lex_state = 0, .external_lex_state = 2},
  [9085] = {.lex_state = 200},
  [9086] = {.lex_state = 244},
  [9087] = {.lex_state = 0},
  [9088] = {.lex_state = 0},
  [9089] = {.lex_state = 0},
  [9090] = {.lex_state = 0},
  [9091] = {.lex_state = 244},
  [9092] = {.lex_state = 0},
  [9093] = {.lex_state = 0},
  [9094] = {.lex_state = 0},
  [9095] = {.lex_state = 0},
  [9096] = {.lex_state = 0},
  [9097] = {.lex_state = 0},
  [9098] = {.lex_state = 244},
  [9099] = {.lex_state = 200},
  [9100] = {.lex_state = 0},
  [9101] = {.lex_state = 387},
  [9102] = {.lex_state = 387},
  [9103] = {.lex_state = 0},
  [9104] = {.lex_state = 200},
  [9105] = {.lex_state = 387},
  [9106] = {.lex_state = 0},
  [9107] = {.lex_state = 244},
  [9108] = {.lex_state = 244},
  [9109] = {.lex_state = 0},
  [9110] = {.lex_state = 244},
  [9111] = {.lex_state = 0},
  [9112] = {.lex_state = 230},
  [9113] = {.lex_state = 0},
  [9114] = {.lex_state = 0},
  [9115] = {.lex_state = 121},
  [9116] = {.lex_state = 200},
  [9117] = {.lex_state = 0},
  [9118] = {.lex_state = 0},
  [9119] = {.lex_state = 121},
  [9120] = {.lex_state = 0},
  [9121] = {.lex_state = 387},
  [9122] = {.lex_state = 244},
  [9123] = {.lex_state = 0},
  [9124] = {.lex_state = 121},
  [9125] = {.lex_state = 0},
  [9126] = {.lex_state = 0},
  [9127] = {.lex_state = 0, .external_lex_state = 2},
  [9128] = {.lex_state = 0},
  [9129] = {.lex_state = 244},
  [9130] = {.lex_state = 0},
  [9131] = {.lex_state = 200},
  [9132] = {.lex_state = 0},
  [9133] = {.lex_state = 0},
  [9134] = {.lex_state = 0},
  [9135] = {.lex_state = 244},
  [9136] = {.lex_state = 0},
  [9137] = {.lex_state = 0},
  [9138] = {.lex_state = 0},
  [9139] = {.lex_state = 244},
  [9140] = {.lex_state = 200},
  [9141] = {.lex_state = 0},
  [9142] = {.lex_state = 121},
  [9143] = {.lex_state = 0},
  [9144] = {.lex_state = 387},
  [9145] = {.lex_state = 200},
  [9146] = {.lex_state = 200},
  [9147] = {.lex_state = 0},
  [9148] = {.lex_state = 0},
  [9149] = {.lex_state = 0},
  [9150] = {.lex_state = 244},
  [9151] = {.lex_state = 0},
  [9152] = {.lex_state = 0},
  [9153] = {.lex_state = 0},
  [9154] = {.lex_state = 0},
  [9155] = {.lex_state = 0},
  [9156] = {.lex_state = 0},
  [9157] = {.lex_state = 0},
  [9158] = {.lex_state = 0},
  [9159] = {.lex_state = 0},
  [9160] = {.lex_state = 0},
  [9161] = {.lex_state = 0},
  [9162] = {.lex_state = 0},
  [9163] = {.lex_state = 0},
  [9164] = {.lex_state = 0, .external_lex_state = 2},
  [9165] = {.lex_state = 0},
  [9166] = {.lex_state = 0},
  [9167] = {.lex_state = 0},
  [9168] = {.lex_state = 0},
  [9169] = {.lex_state = 0},
  [9170] = {.lex_state = 387},
  [9171] = {.lex_state = 0},
  [9172] = {.lex_state = 0},
  [9173] = {.lex_state = 0},
  [9174] = {.lex_state = 0},
  [9175] = {.lex_state = 0},
  [9176] = {.lex_state = 0},
  [9177] = {.lex_state = 0, .external_lex_state = 2},
  [9178] = {.lex_state = 0},
  [9179] = {.lex_state = 0},
  [9180] = {.lex_state = 0},
  [9181] = {.lex_state = 230},
  [9182] = {.lex_state = 387},
  [9183] = {.lex_state = 244},
  [9184] = {.lex_state = 0},
  [9185] = {.lex_state = 0},
  [9186] = {.lex_state = 0},
  [9187] = {.lex_state = 0, .external_lex_state = 2},
  [9188] = {.lex_state = 0},
  [9189] = {.lex_state = 0},
  [9190] = {.lex_state = 244},
  [9191] = {.lex_state = 387},
  [9192] = {.lex_state = 0},
  [9193] = {.lex_state = 0, .external_lex_state = 2},
  [9194] = {.lex_state = 0},
  [9195] = {.lex_state = 0},
  [9196] = {.lex_state = 0, .external_lex_state = 2},
  [9197] = {.lex_state = 0},
  [9198] = {.lex_state = 0},
  [9199] = {.lex_state = 0, .external_lex_state = 2},
  [9200] = {.lex_state = 0},
  [9201] = {.lex_state = 0, .external_lex_state = 2},
  [9202] = {.lex_state = 0},
  [9203] = {.lex_state = 0, .external_lex_state = 2},
  [9204] = {.lex_state = 0},
  [9205] = {.lex_state = 0, .external_lex_state = 2},
  [9206] = {.lex_state = 0},
  [9207] = {.lex_state = 0, .external_lex_state = 2},
  [9208] = {.lex_state = 0},
  [9209] = {.lex_state = 0, .external_lex_state = 2},
  [9210] = {.lex_state = 0},
  [9211] = {.lex_state = 121},
  [9212] = {.lex_state = 0},
  [9213] = {.lex_state = 387},
  [9214] = {.lex_state = 0},
  [9215] = {.lex_state = 387},
  [9216] = {.lex_state = 387},
  [9217] = {.lex_state = 244},
  [9218] = {.lex_state = 0},
  [9219] = {.lex_state = 387},
  [9220] = {.lex_state = 0},
  [9221] = {.lex_state = 387},
  [9222] = {.lex_state = 387},
  [9223] = {.lex_state = 0},
  [9224] = {.lex_state = 0},
  [9225] = {.lex_state = 0},
  [9226] = {.lex_state = 244},
  [9227] = {.lex_state = 0},
  [9228] = {.lex_state = 121},
  [9229] = {.lex_state = 201},
  [9230] = {.lex_state = 0},
  [9231] = {.lex_state = 0},
  [9232] = {.lex_state = 0},
  [9233] = {.lex_state = 0, .external_lex_state = 2},
  [9234] = {.lex_state = 121},
  [9235] = {.lex_state = 0},
  [9236] = {.lex_state = 0},
  [9237] = {.lex_state = 244},
  [9238] = {.lex_state = 0},
  [9239] = {.lex_state = 387},
  [9240] = {.lex_state = 387},
  [9241] = {.lex_state = 0},
  [9242] = {.lex_state = 0},
  [9243] = {.lex_state = 387},
  [9244] = {.lex_state = 387},
  [9245] = {.lex_state = 0, .external_lex_state = 3},
  [9246] = {.lex_state = 0},
  [9247] = {.lex_state = 0},
  [9248] = {.lex_state = 0},
  [9249] = {.lex_state = 387},
  [9250] = {.lex_state = 0},
  [9251] = {.lex_state = 0},
  [9252] = {.lex_state = 0},
  [9253] = {.lex_state = 0},
  [9254] = {.lex_state = 200},
  [9255] = {.lex_state = 230},
  [9256] = {.lex_state = 0},
  [9257] = {.lex_state = 0},
  [9258] = {.lex_state = 0},
  [9259] = {.lex_state = 244},
  [9260] = {.lex_state = 0},
  [9261] = {.lex_state = 0},
  [9262] = {.lex_state = 0},
  [9263] = {.lex_state = 0},
  [9264] = {.lex_state = 0},
  [9265] = {.lex_state = 121},
  [9266] = {.lex_state = 230},
  [9267] = {.lex_state = 0},
  [9268] = {.lex_state = 200},
  [9269] = {.lex_state = 0},
  [9270] = {.lex_state = 0},
  [9271] = {.lex_state = 0},
  [9272] = {.lex_state = 0},
  [9273] = {.lex_state = 230},
  [9274] = {.lex_state = 244},
  [9275] = {.lex_state = 0},
  [9276] = {.lex_state = 0},
  [9277] = {.lex_state = 0},
  [9278] = {.lex_state = 0},
  [9279] = {.lex_state = 387},
  [9280] = {.lex_state = 244},
  [9281] = {.lex_state = 0},
  [9282] = {.lex_state = 244},
  [9283] = {.lex_state = 230},
  [9284] = {.lex_state = 0},
  [9285] = {.lex_state = 0},
  [9286] = {.lex_state = 0},
  [9287] = {.lex_state = 121},
  [9288] = {.lex_state = 0},
  [9289] = {.lex_state = 0},
  [9290] = {.lex_state = 200},
  [9291] = {.lex_state = 387},
  [9292] = {.lex_state = 0},
  [9293] = {.lex_state = 200},
  [9294] = {.lex_state = 0},
  [9295] = {.lex_state = 0},
  [9296] = {.lex_state = 0},
  [9297] = {.lex_state = 0},
  [9298] = {.lex_state = 0, .external_lex_state = 2},
  [9299] = {.lex_state = 200},
  [9300] = {.lex_state = 0},
  [9301] = {.lex_state = 200},
  [9302] = {.lex_state = 0},
  [9303] = {.lex_state = 0},
  [9304] = {.lex_state = 244},
  [9305] = {.lex_state = 0},
  [9306] = {.lex_state = 0},
  [9307] = {.lex_state = 0},
  [9308] = {.lex_state = 230},
  [9309] = {.lex_state = 0},
  [9310] = {.lex_state = 0},
  [9311] = {.lex_state = 0},
  [9312] = {.lex_state = 0},
  [9313] = {.lex_state = 0},
  [9314] = {.lex_state = 121},
  [9315] = {.lex_state = 0},
  [9316] = {.lex_state = 0},
  [9317] = {.lex_state = 0},
  [9318] = {.lex_state = 0},
  [9319] = {.lex_state = 200},
  [9320] = {.lex_state = 200},
  [9321] = {.lex_state = 200},
  [9322] = {.lex_state = 0},
  [9323] = {.lex_state = 200},
  [9324] = {.lex_state = 200},
  [9325] = {.lex_state = 200},
  [9326] = {.lex_state = 0},
  [9327] = {.lex_state = 0},
  [9328] = {.lex_state = 0},
  [9329] = {.lex_state = 0},
  [9330] = {.lex_state = 0},
  [9331] = {.lex_state = 0},
  [9332] = {.lex_state = 0},
  [9333] = {.lex_state = 0},
  [9334] = {.lex_state = 0},
  [9335] = {.lex_state = 244},
  [9336] = {.lex_state = 200},
  [9337] = {.lex_state = 0},
  [9338] = {.lex_state = 0},
  [9339] = {.lex_state = 0},
  [9340] = {.lex_state = 0},
  [9341] = {.lex_state = 244},
  [9342] = {.lex_state = 200},
  [9343] = {.lex_state = 0},
  [9344] = {.lex_state = 0},
  [9345] = {.lex_state = 0},
  [9346] = {.lex_state = 121},
  [9347] = {.lex_state = 0},
  [9348] = {.lex_state = 0},
  [9349] = {.lex_state = 0},
  [9350] = {.lex_state = 230},
  [9351] = {.lex_state = 0},
  [9352] = {.lex_state = 0},
  [9353] = {.lex_state = 0},
  [9354] = {.lex_state = 244},
  [9355] = {.lex_state = 0},
  [9356] = {.lex_state = 0},
  [9357] = {.lex_state = 0},
  [9358] = {.lex_state = 0},
  [9359] = {.lex_state = 0},
  [9360] = {.lex_state = 0},
  [9361] = {.lex_state = 0},
  [9362] = {.lex_state = 0},
  [9363] = {.lex_state = 0},
  [9364] = {.lex_state = 0},
  [9365] = {.lex_state = 0},
  [9366] = {.lex_state = 200},
  [9367] = {.lex_state = 0},
  [9368] = {.lex_state = 198},
  [9369] = {.lex_state = 0},
  [9370] = {.lex_state = 0},
  [9371] = {.lex_state = 200},
  [9372] = {.lex_state = 0},
  [9373] = {.lex_state = 0},
  [9374] = {.lex_state = 0},
  [9375] = {.lex_state = 0},
  [9376] = {.lex_state = 0},
  [9377] = {.lex_state = 244},
  [9378] = {.lex_state = 244},
  [9379] = {.lex_state = 0},
  [9380] = {.lex_state = 387},
  [9381] = {.lex_state = 0},
  [9382] = {.lex_state = 0},
  [9383] = {.lex_state = 244},
  [9384] = {.lex_state = 0},
  [9385] = {.lex_state = 0},
  [9386] = {.lex_state = 0},
  [9387] = {.lex_state = 0},
  [9388] = {.lex_state = 0},
  [9389] = {.lex_state = 200},
  [9390] = {.lex_state = 200},
  [9391] = {.lex_state = 387},
  [9392] = {.lex_state = 0},
  [9393] = {.lex_state = 200},
  [9394] = {.lex_state = 387},
  [9395] = {.lex_state = 387},
  [9396] = {.lex_state = 387},
  [9397] = {.lex_state = 0},
  [9398] = {.lex_state = 387},
  [9399] = {.lex_state = 244},
  [9400] = {.lex_state = 0},
  [9401] = {.lex_state = 200},
  [9402] = {.lex_state = 0},
  [9403] = {.lex_state = 244},
  [9404] = {.lex_state = 121},
  [9405] = {.lex_state = 387},
  [9406] = {.lex_state = 0},
  [9407] = {.lex_state = 200},
  [9408] = {.lex_state = 200},
  [9409] = {.lex_state = 387},
  [9410] = {.lex_state = 0, .external_lex_state = 3},
  [9411] = {.lex_state = 200},
  [9412] = {.lex_state = 0},
  [9413] = {.lex_state = 0},
  [9414] = {.lex_state = 0},
  [9415] = {.lex_state = 121},
  [9416] = {.lex_state = 387},
  [9417] = {.lex_state = 0},
  [9418] = {.lex_state = 230},
  [9419] = {.lex_state = 0},
  [9420] = {.lex_state = 0},
  [9421] = {.lex_state = 387},
  [9422] = {.lex_state = 387},
  [9423] = {.lex_state = 0, .external_lex_state = 3},
  [9424] = {.lex_state = 387},
  [9425] = {.lex_state = 0},
  [9426] = {.lex_state = 0},
  [9427] = {.lex_state = 244},
  [9428] = {.lex_state = 0},
  [9429] = {.lex_state = 387},
  [9430] = {.lex_state = 0},
  [9431] = {.lex_state = 121},
  [9432] = {.lex_state = 387},
  [9433] = {.lex_state = 0, .external_lex_state = 3},
  [9434] = {.lex_state = 244},
  [9435] = {.lex_state = 0},
  [9436] = {.lex_state = 0},
  [9437] = {.lex_state = 0},
  [9438] = {.lex_state = 244},
  [9439] = {.lex_state = 0},
  [9440] = {.lex_state = 230},
  [9441] = {.lex_state = 200},
  [9442] = {.lex_state = 200},
  [9443] = {.lex_state = 387},
  [9444] = {.lex_state = 387},
  [9445] = {.lex_state = 0},
  [9446] = {.lex_state = 387},
  [9447] = {.lex_state = 0},
  [9448] = {.lex_state = 0},
  [9449] = {.lex_state = 244},
  [9450] = {.lex_state = 0},
  [9451] = {.lex_state = 387},
  [9452] = {.lex_state = 0},
  [9453] = {.lex_state = 244},
  [9454] = {.lex_state = 387},
  [9455] = {.lex_state = 0, .external_lex_state = 3},
  [9456] = {.lex_state = 0},
  [9457] = {.lex_state = 0},
  [9458] = {.lex_state = 0},
  [9459] = {.lex_state = 0},
  [9460] = {.lex_state = 0},
  [9461] = {.lex_state = 230},
  [9462] = {.lex_state = 0},
  [9463] = {.lex_state = 387},
  [9464] = {.lex_state = 387},
  [9465] = {.lex_state = 0},
  [9466] = {.lex_state = 387},
  [9467] = {.lex_state = 121},
  [9468] = {.lex_state = 0},
  [9469] = {.lex_state = 244},
  [9470] = {.lex_state = 387},
  [9471] = {.lex_state = 0},
  [9472] = {.lex_state = 230},
  [9473] = {.lex_state = 387},
  [9474] = {.lex_state = 0, .external_lex_state = 3},
  [9475] = {.lex_state = 0},
  [9476] = {.lex_state = 230},
  [9477] = {.lex_state = 121},
  [9478] = {.lex_state = 0},
  [9479] = {.lex_state = 0},
  [9480] = {.lex_state = 230},
  [9481] = {.lex_state = 0},
  [9482] = {.lex_state = 387},
  [9483] = {.lex_state = 387},
  [9484] = {.lex_state = 0},
  [9485] = {.lex_state = 387},
  [9486] = {.lex_state = 0},
  [9487] = {.lex_state = 0},
  [9488] = {.lex_state = 387},
  [9489] = {.lex_state = 230},
  [9490] = {.lex_state = 0},
  [9491] = {.lex_state = 387},
  [9492] = {.lex_state = 0, .external_lex_state = 3},
  [9493] = {.lex_state = 0},
  [9494] = {.lex_state = 0},
  [9495] = {.lex_state = 244},
  [9496] = {.lex_state = 0},
  [9497] = {.lex_state = 0},
  [9498] = {.lex_state = 230},
  [9499] = {.lex_state = 0},
  [9500] = {.lex_state = 387},
  [9501] = {.lex_state = 387},
  [9502] = {.lex_state = 121},
  [9503] = {.lex_state = 387},
  [9504] = {.lex_state = 0},
  [9505] = {.lex_state = 0},
  [9506] = {.lex_state = 387},
  [9507] = {.lex_state = 0},
  [9508] = {.lex_state = 0},
  [9509] = {.lex_state = 387},
  [9510] = {.lex_state = 0, .external_lex_state = 3},
  [9511] = {.lex_state = 0},
  [9512] = {.lex_state = 0},
  [9513] = {.lex_state = 0},
  [9514] = {.lex_state = 0},
  [9515] = {.lex_state = 0},
  [9516] = {.lex_state = 230},
  [9517] = {.lex_state = 0},
  [9518] = {.lex_state = 387},
  [9519] = {.lex_state = 0},
  [9520] = {.lex_state = 387},
  [9521] = {.lex_state = 0},
  [9522] = {.lex_state = 0},
  [9523] = {.lex_state = 0},
  [9524] = {.lex_state = 0},
  [9525] = {.lex_state = 387},
  [9526] = {.lex_state = 0, .external_lex_state = 3},
  [9527] = {.lex_state = 244},
  [9528] = {.lex_state = 0},
  [9529] = {.lex_state = 0},
  [9530] = {.lex_state = 0},
  [9531] = {.lex_state = 0},
  [9532] = {.lex_state = 387},
  [9533] = {.lex_state = 387},
  [9534] = {.lex_state = 230},
  [9535] = {.lex_state = 0, .external_lex_state = 3},
  [9536] = {.lex_state = 0},
  [9537] = {.lex_state = 0},
  [9538] = {.lex_state = 0},
  [9539] = {.lex_state = 0},
  [9540] = {.lex_state = 387},
  [9541] = {.lex_state = 387},
  [9542] = {.lex_state = 0},
  [9543] = {.lex_state = 0, .external_lex_state = 3},
  [9544] = {.lex_state = 0},
  [9545] = {.lex_state = 0},
  [9546] = {.lex_state = 387},
  [9547] = {.lex_state = 387},
  [9548] = {.lex_state = 0, .external_lex_state = 3},
  [9549] = {.lex_state = 0},
  [9550] = {.lex_state = 0, .external_lex_state = 3},
  [9551] = {.lex_state = 0},
  [9552] = {.lex_state = 0, .external_lex_state = 3},
  [9553] = {.lex_state = 0},
  [9554] = {.lex_state = 0, .external_lex_state = 3},
  [9555] = {.lex_state = 0},
  [9556] = {.lex_state = 0, .external_lex_state = 3},
  [9557] = {.lex_state = 0},
  [9558] = {.lex_state = 0, .external_lex_state = 3},
  [9559] = {.lex_state = 0},
  [9560] = {.lex_state = 0, .external_lex_state = 3},
  [9561] = {.lex_state = 0},
  [9562] = {.lex_state = 0, .external_lex_state = 3},
  [9563] = {.lex_state = 0},
  [9564] = {.lex_state = 0},
  [9565] = {.lex_state = 0},
  [9566] = {.lex_state = 387},
  [9567] = {.lex_state = 387},
  [9568] = {.lex_state = 244},
  [9569] = {.lex_state = 0},
  [9570] = {.lex_state = 0},
  [9571] = {.lex_state = 387},
  [9572] = {.lex_state = 0},
  [9573] = {.lex_state = 244},
  [9574] = {.lex_state = 0},
  [9575] = {.lex_state = 0},
  [9576] = {.lex_state = 0},
  [9577] = {.lex_state = 0},
  [9578] = {.lex_state = 200},
  [9579] = {.lex_state = 200},
  [9580] = {.lex_state = 0},
  [9581] = {.lex_state = 121},
  [9582] = {.lex_state = 244},
  [9583] = {.lex_state = 244},
  [9584] = {.lex_state = 0, .external_lex_state = 3},
  [9585] = {.lex_state = 121},
  [9586] = {.lex_state = 0},
  [9587] = {.lex_state = 0},
  [9588] = {.lex_state = 200},
  [9589] = {.lex_state = 200},
  [9590] = {.lex_state = 0},
  [9591] = {.lex_state = 0},
  [9592] = {.lex_state = 200},
  [9593] = {.lex_state = 200},
  [9594] = {.lex_state = 0},
  [9595] = {.lex_state = 0},
  [9596] = {.lex_state = 387},
  [9597] = {.lex_state = 387},
  [9598] = {.lex_state = 0},
  [9599] = {.lex_state = 244},
  [9600] = {.lex_state = 0},
  [9601] = {.lex_state = 0},
  [9602] = {.lex_state = 121},
  [9603] = {.lex_state = 0},
  [9604] = {.lex_state = 244},
  [9605] = {.lex_state = 387},
  [9606] = {.lex_state = 0},
  [9607] = {.lex_state = 0},
  [9608] = {.lex_state = 387},
  [9609] = {.lex_state = 0},
  [9610] = {.lex_state = 121},
  [9611] = {.lex_state = 0},
  [9612] = {.lex_state = 0},
  [9613] = {.lex_state = 0},
  [9614] = {.lex_state = 230},
  [9615] = {.lex_state = 387},
  [9616] = {.lex_state = 387},
  [9617] = {.lex_state = 244},
  [9618] = {.lex_state = 0},
  [9619] = {.lex_state = 121},
  [9620] = {.lex_state = 0},
  [9621] = {.lex_state = 0},
  [9622] = {.lex_state = 387},
  [9623] = {.lex_state = 387},
  [9624] = {.lex_state = 387},
  [9625] = {.lex_state = 244},
  [9626] = {.lex_state = 0},
  [9627] = {.lex_state = 0},
  [9628] = {.lex_state = 387},
  [9629] = {.lex_state = 0},
  [9630] = {.lex_state = 230},
  [9631] = {.lex_state = 0},
  [9632] = {.lex_state = 230},
  [9633] = {.lex_state = 244},
  [9634] = {.lex_state = 0},
  [9635] = {.lex_state = 200},
  [9636] = {.lex_state = 200},
  [9637] = {.lex_state = 200},
  [9638] = {.lex_state = 0},
  [9639] = {.lex_state = 200},
  [9640] = {.lex_state = 0},
  [9641] = {.lex_state = 121},
  [9642] = {.lex_state = 387},
  [9643] = {.lex_state = 230},
  [9644] = {.lex_state = 0},
  [9645] = {.lex_state = 0},
  [9646] = {.lex_state = 387},
  [9647] = {.lex_state = 387},
  [9648] = {.lex_state = 244},
  [9649] = {.lex_state = 244},
  [9650] = {.lex_state = 387},
  [9651] = {.lex_state = 0},
  [9652] = {.lex_state = 244},
  [9653] = {.lex_state = 0, .external_lex_state = 3},
  [9654] = {.lex_state = 387},
  [9655] = {.lex_state = 244},
  [9656] = {.lex_state = 244},
  [9657] = {.lex_state = 387},
  [9658] = {.lex_state = 387},
  [9659] = {.lex_state = 244},
  [9660] = {.lex_state = 230},
  [9661] = {.lex_state = 121},
  [9662] = {.lex_state = 244},
  [9663] = {.lex_state = 0, .external_lex_state = 3},
  [9664] = {.lex_state = 0},
  [9665] = {.lex_state = 244},
  [9666] = {.lex_state = 0},
  [9667] = {.lex_state = 387},
  [9668] = {.lex_state = 387},
  [9669] = {.lex_state = 244},
  [9670] = {.lex_state = 0},
  [9671] = {.lex_state = 0},
  [9672] = {.lex_state = 244},
  [9673] = {.lex_state = 0, .external_lex_state = 3},
  [9674] = {.lex_state = 387},
  [9675] = {.lex_state = 244},
  [9676] = {.lex_state = 387},
  [9677] = {.lex_state = 387},
  [9678] = {.lex_state = 244},
  [9679] = {.lex_state = 0},
  [9680] = {.lex_state = 0},
  [9681] = {.lex_state = 244},
  [9682] = {.lex_state = 0, .external_lex_state = 3},
  [9683] = {.lex_state = 0},
  [9684] = {.lex_state = 121},
  [9685] = {.lex_state = 387},
  [9686] = {.lex_state = 244},
  [9687] = {.lex_state = 0},
  [9688] = {.lex_state = 0},
  [9689] = {.lex_state = 244},
  [9690] = {.lex_state = 0, .external_lex_state = 3},
  [9691] = {.lex_state = 244},
  [9692] = {.lex_state = 244},
  [9693] = {.lex_state = 387},
  [9694] = {.lex_state = 244},
  [9695] = {.lex_state = 0},
  [9696] = {.lex_state = 387},
  [9697] = {.lex_state = 244},
  [9698] = {.lex_state = 0, .external_lex_state = 3},
  [9699] = {.lex_state = 0},
  [9700] = {.lex_state = 244},
  [9701] = {.lex_state = 387},
  [9702] = {.lex_state = 244},
  [9703] = {.lex_state = 230},
  [9704] = {.lex_state = 244},
  [9705] = {.lex_state = 0, .external_lex_state = 3},
  [9706] = {.lex_state = 0},
  [9707] = {.lex_state = 0},
  [9708] = {.lex_state = 244},
  [9709] = {.lex_state = 0, .external_lex_state = 3},
  [9710] = {.lex_state = 0},
  [9711] = {.lex_state = 0},
  [9712] = {.lex_state = 0, .external_lex_state = 3},
  [9713] = {.lex_state = 244},
  [9714] = {.lex_state = 0, .external_lex_state = 3},
  [9715] = {.lex_state = 0},
  [9716] = {.lex_state = 0, .external_lex_state = 3},
  [9717] = {.lex_state = 0},
  [9718] = {.lex_state = 0, .external_lex_state = 3},
  [9719] = {.lex_state = 244},
  [9720] = {.lex_state = 0, .external_lex_state = 3},
  [9721] = {.lex_state = 0},
  [9722] = {.lex_state = 0, .external_lex_state = 3},
  [9723] = {.lex_state = 0},
  [9724] = {.lex_state = 0, .external_lex_state = 3},
  [9725] = {.lex_state = 0},
  [9726] = {.lex_state = 0, .external_lex_state = 3},
  [9727] = {.lex_state = 0},
  [9728] = {.lex_state = 0, .external_lex_state = 3},
  [9729] = {.lex_state = 387},
  [9730] = {.lex_state = 387},
  [9731] = {.lex_state = 0},
  [9732] = {.lex_state = 387},
  [9733] = {.lex_state = 387},
  [9734] = {.lex_state = 0},
  [9735] = {.lex_state = 387},
  [9736] = {.lex_state = 387},
  [9737] = {.lex_state = 0},
  [9738] = {.lex_state = 387},
  [9739] = {.lex_state = 387},
  [9740] = {.lex_state = 244},
  [9741] = {.lex_state = 387},
  [9742] = {.lex_state = 387},
  [9743] = {.lex_state = 244},
  [9744] = {.lex_state = 387},
  [9745] = {.lex_state = 387},
  [9746] = {.lex_state = 244},
  [9747] = {.lex_state = 387},
  [9748] = {.lex_state = 387},
  [9749] = {.lex_state = 244},
  [9750] = {.lex_state = 387},
  [9751] = {.lex_state = 387},
  [9752] = {.lex_state = 387},
  [9753] = {.lex_state = 387},
  [9754] = {.lex_state = 387},
  [9755] = {.lex_state = 387},
  [9756] = {.lex_state = 387},
  [9757] = {.lex_state = 387},
  [9758] = {.lex_state = 387},
  [9759] = {.lex_state = 387},
  [9760] = {.lex_state = 387},
  [9761] = {.lex_state = 200},
  [9762] = {.lex_state = 387},
  [9763] = {.lex_state = 0},
  [9764] = {.lex_state = 0},
  [9765] = {.lex_state = 244},
  [9766] = {.lex_state = 121},
  [9767] = {.lex_state = 244},
  [9768] = {.lex_state = 387},
  [9769] = {.lex_state = 387},
  [9770] = {.lex_state = 387},
  [9771] = {.lex_state = 387},
  [9772] = {.lex_state = 387},
  [9773] = {.lex_state = 387},
  [9774] = {.lex_state = 387},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [aux_sym_preproc_include_token1] = ACTIONS(1),
    [aux_sym_preproc_def_token1] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [aux_sym_preproc_if_token1] = ACTIONS(1),
    [aux_sym_preproc_if_token2] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1),
    [aux_sym_preproc_else_token1] = ACTIONS(1),
    [aux_sym_preproc_elif_token1] = ACTIONS(1),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1),
    [sym_preproc_directive] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_defined] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym___extension__] = ACTIONS(1),
    [anon_sym_typedef] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym___attribute__] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym___declspec] = ACTIONS(1),
    [anon_sym___based] = ACTIONS(1),
    [anon_sym___cdecl] = ACTIONS(1),
    [anon_sym___clrcall] = ACTIONS(1),
    [anon_sym___stdcall] = ACTIONS(1),
    [anon_sym___fastcall] = ACTIONS(1),
    [anon_sym___thiscall] = ACTIONS(1),
    [anon_sym___vectorcall] = ACTIONS(1),
    [sym_ms_restrict_modifier] = ACTIONS(1),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(1),
    [sym_ms_signed_ptr_modifier] = ACTIONS(1),
    [anon_sym__unaligned] = ACTIONS(1),
    [anon_sym___unaligned] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_signed] = ACTIONS(1),
    [anon_sym_unsigned] = ACTIONS(1),
    [anon_sym_long] = ACTIONS(1),
    [anon_sym_short] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_register] = ACTIONS(1),
    [anon_sym_inline] = ACTIONS(1),
    [anon_sym___inline] = ACTIONS(1),
    [anon_sym___inline__] = ACTIONS(1),
    [anon_sym___forceinline] = ACTIONS(1),
    [anon_sym_thread_local] = ACTIONS(1),
    [anon_sym___thread] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_constexpr] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_restrict] = ACTIONS(1),
    [anon_sym___restrict__] = ACTIONS(1),
    [anon_sym__Atomic] = ACTIONS(1),
    [anon_sym__Noreturn] = ACTIONS(1),
    [anon_sym_noreturn] = ACTIONS(1),
    [anon_sym_mutable] = ACTIONS(1),
    [anon_sym_constinit] = ACTIONS(1),
    [anon_sym_consteval] = ACTIONS(1),
    [anon_sym_PROGMEM] = ACTIONS(1),
    [aux_sym_primitive_type_token1] = ACTIONS(1),
    [anon_sym_byte] = ACTIONS(1),
    [anon_sym_word] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym___try] = ACTIONS(1),
    [anon_sym___except] = ACTIONS(1),
    [anon_sym___finally] = ACTIONS(1),
    [anon_sym___leave] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_and_eq] = ACTIONS(1),
    [anon_sym_or_eq] = ACTIONS(1),
    [anon_sym_xor_eq] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_compl] = ACTIONS(1),
    [anon_sym_LT_EQ_GT] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_bitor] = ACTIONS(1),
    [anon_sym_xor] = ACTIONS(1),
    [anon_sym_bitand] = ACTIONS(1),
    [anon_sym_not_eq] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_sizeof] = ACTIONS(1),
    [anon_sym___alignof__] = ACTIONS(1),
    [anon_sym___alignof] = ACTIONS(1),
    [anon_sym__alignof] = ACTIONS(1),
    [anon_sym_alignof] = ACTIONS(1),
    [anon_sym__Alignof] = ACTIONS(1),
    [anon_sym_offsetof] = ACTIONS(1),
    [anon_sym__Generic] = ACTIONS(1),
    [anon_sym_asm] = ACTIONS(1),
    [anon_sym___asm__] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DOT_STAR] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [aux_sym_number_literal_token1] = ACTIONS(1),
    [aux_sym_number_literal_token2] = ACTIONS(1),
    [anon_sym_L_SQUOTE] = ACTIONS(1),
    [anon_sym_u_SQUOTE] = ACTIONS(1),
    [anon_sym_U_SQUOTE] = ACTIONS(1),
    [anon_sym_u8_SQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_L_DQUOTE] = ACTIONS(1),
    [anon_sym_u_DQUOTE] = ACTIONS(1),
    [anon_sym_U_DQUOTE] = ACTIONS(1),
    [anon_sym_u8_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [anon_sym_NULL] = ACTIONS(1),
    [anon_sym_nullptr] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1),
    [anon_sym_decltype] = ACTIONS(1),
    [anon_sym_final] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_virtual] = ACTIONS(1),
    [anon_sym_alignas] = ACTIONS(1),
    [anon_sym_explicit] = ACTIONS(1),
    [anon_sym_typename] = ACTIONS(1),
    [anon_sym_template] = ACTIONS(1),
    [anon_sym_GT2] = ACTIONS(1),
    [anon_sym_operator] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_friend] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_noexcept] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_static_assert] = ACTIONS(1),
    [anon_sym_concept] = ACTIONS(1),
    [anon_sym_co_return] = ACTIONS(1),
    [anon_sym_co_yield] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_R_DQUOTE] = ACTIONS(1),
    [anon_sym_LR_DQUOTE] = ACTIONS(1),
    [anon_sym_uR_DQUOTE] = ACTIONS(1),
    [anon_sym_UR_DQUOTE] = ACTIONS(1),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1),
    [anon_sym_co_await] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_requires] = ACTIONS(1),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_raw_string_delimiter] = ACTIONS(1),
    [sym_raw_string_content] = ACTIONS(1),
  },
  [1] = {
    [sym_translation_unit] = STATE(9600),
    [sym_preproc_include] = STATE(99),
    [sym_preproc_def] = STATE(99),
    [sym_preproc_function_def] = STATE(99),
    [sym_preproc_call] = STATE(99),
    [sym_preproc_if] = STATE(99),
    [sym_preproc_ifdef] = STATE(99),
    [sym_function_definition] = STATE(99),
    [sym_declaration] = STATE(99),
    [sym_type_definition] = STATE(99),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5408),
    [sym_linkage_specification] = STATE(99),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2149),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7122),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(99),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3271),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(99),
    [sym_labeled_statement] = STATE(99),
    [sym__top_level_expression_statement] = STATE(99),
    [sym_if_statement] = STATE(99),
    [sym_switch_statement] = STATE(99),
    [sym_case_statement] = STATE(99),
    [sym_while_statement] = STATE(99),
    [sym_do_statement] = STATE(99),
    [sym_for_statement] = STATE(99),
    [sym_return_statement] = STATE(99),
    [sym_break_statement] = STATE(99),
    [sym_continue_statement] = STATE(99),
    [sym_goto_statement] = STATE(99),
    [sym__expression] = STATE(5546),
    [sym__expression_not_binary] = STATE(5658),
    [sym__string] = STATE(5658),
    [sym_conditional_expression] = STATE(5658),
    [sym_assignment_expression] = STATE(5658),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(5658),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(5658),
    [sym_cast_expression] = STATE(5658),
    [sym_sizeof_expression] = STATE(5658),
    [sym_alignof_expression] = STATE(5658),
    [sym_offsetof_expression] = STATE(5658),
    [sym_generic_expression] = STATE(5658),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(5658),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(5658),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(5658),
    [sym__empty_declaration] = STATE(99),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2116),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(99),
    [sym_template_instantiation] = STATE(99),
    [sym_operator_cast] = STATE(7529),
    [sym__constructor_specifiers] = STATE(2116),
    [sym_operator_cast_definition] = STATE(99),
    [sym_operator_cast_declaration] = STATE(99),
    [sym_constructor_or_destructor_definition] = STATE(99),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(99),
    [sym_namespace_alias_definition] = STATE(99),
    [sym_using_declaration] = STATE(99),
    [sym_alias_declaration] = STATE(99),
    [sym_static_assert_declaration] = STATE(99),
    [sym_concept_definition] = STATE(99),
    [sym_for_range_loop] = STATE(99),
    [sym_co_return_statement] = STATE(99),
    [sym_co_yield_statement] = STATE(99),
    [sym_throw_statement] = STATE(99),
    [sym_try_statement] = STATE(99),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(5658),
    [sym_new_expression] = STATE(5658),
    [sym_delete_expression] = STATE(5658),
    [sym_requires_clause] = STATE(5658),
    [sym_requires_expression] = STATE(5658),
    [sym_lambda_expression] = STATE(5658),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(5658),
    [sym_parameter_pack_expansion] = STATE(5658),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7529),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_translation_unit_repeat1] = STATE(99),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(228),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2116),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(37),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(77),
    [anon_sym_default] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(131),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(141),
    [anon_sym_using] = ACTIONS(143),
    [anon_sym_static_assert] = ACTIONS(145),
    [anon_sym_concept] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(115),
  },
  [2] = {
    [sym_preproc_include] = STATE(59),
    [sym_preproc_def] = STATE(59),
    [sym_preproc_function_def] = STATE(59),
    [sym_preproc_call] = STATE(59),
    [sym_preproc_if] = STATE(59),
    [sym_preproc_ifdef] = STATE(59),
    [sym_function_definition] = STATE(59),
    [sym_declaration] = STATE(59),
    [sym_type_definition] = STATE(59),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(59),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(59),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(59),
    [sym_labeled_statement] = STATE(59),
    [sym_expression_statement] = STATE(59),
    [sym_if_statement] = STATE(59),
    [sym_switch_statement] = STATE(59),
    [sym_case_statement] = STATE(59),
    [sym_while_statement] = STATE(59),
    [sym_do_statement] = STATE(59),
    [sym_for_statement] = STATE(59),
    [sym_return_statement] = STATE(59),
    [sym_break_statement] = STATE(59),
    [sym_continue_statement] = STATE(59),
    [sym_goto_statement] = STATE(59),
    [sym_seh_try_statement] = STATE(59),
    [sym_seh_leave_statement] = STATE(59),
    [sym__expression] = STATE(4999),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8013),
    [sym_initializer_pair] = STATE(8013),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(59),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(59),
    [sym_template_instantiation] = STATE(59),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(59),
    [sym_operator_cast_declaration] = STATE(59),
    [sym_constructor_or_destructor_definition] = STATE(59),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(59),
    [sym_namespace_alias_definition] = STATE(59),
    [sym_using_declaration] = STATE(59),
    [sym_alias_declaration] = STATE(59),
    [sym_static_assert_declaration] = STATE(59),
    [sym_concept_definition] = STATE(59),
    [sym_for_range_loop] = STATE(59),
    [sym_co_return_statement] = STATE(59),
    [sym_co_yield_statement] = STATE(59),
    [sym_throw_statement] = STATE(59),
    [sym_try_statement] = STATE(59),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(59),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(185),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [3] = {
    [sym_preproc_include] = STATE(44),
    [sym_preproc_def] = STATE(44),
    [sym_preproc_function_def] = STATE(44),
    [sym_preproc_call] = STATE(44),
    [sym_preproc_if] = STATE(44),
    [sym_preproc_ifdef] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_declaration] = STATE(44),
    [sym_type_definition] = STATE(44),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(44),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(44),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(44),
    [sym_labeled_statement] = STATE(44),
    [sym_expression_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_switch_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_do_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_return_statement] = STATE(44),
    [sym_break_statement] = STATE(44),
    [sym_continue_statement] = STATE(44),
    [sym_goto_statement] = STATE(44),
    [sym_seh_try_statement] = STATE(44),
    [sym_seh_leave_statement] = STATE(44),
    [sym__expression] = STATE(4999),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8013),
    [sym_initializer_pair] = STATE(8013),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(44),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(44),
    [sym_template_instantiation] = STATE(44),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(44),
    [sym_operator_cast_declaration] = STATE(44),
    [sym_constructor_or_destructor_definition] = STATE(44),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(44),
    [sym_namespace_alias_definition] = STATE(44),
    [sym_using_declaration] = STATE(44),
    [sym_alias_declaration] = STATE(44),
    [sym_static_assert_declaration] = STATE(44),
    [sym_concept_definition] = STATE(44),
    [sym_for_range_loop] = STATE(44),
    [sym_co_return_statement] = STATE(44),
    [sym_co_yield_statement] = STATE(44),
    [sym_throw_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(44),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(239),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [4] = {
    [sym_preproc_include] = STATE(70),
    [sym_preproc_def] = STATE(70),
    [sym_preproc_function_def] = STATE(70),
    [sym_preproc_call] = STATE(70),
    [sym_preproc_if] = STATE(70),
    [sym_preproc_ifdef] = STATE(70),
    [sym_function_definition] = STATE(70),
    [sym_declaration] = STATE(70),
    [sym_type_definition] = STATE(70),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(70),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(70),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(70),
    [sym_labeled_statement] = STATE(70),
    [sym_expression_statement] = STATE(70),
    [sym_if_statement] = STATE(70),
    [sym_switch_statement] = STATE(70),
    [sym_case_statement] = STATE(70),
    [sym_while_statement] = STATE(70),
    [sym_do_statement] = STATE(70),
    [sym_for_statement] = STATE(70),
    [sym_return_statement] = STATE(70),
    [sym_break_statement] = STATE(70),
    [sym_continue_statement] = STATE(70),
    [sym_goto_statement] = STATE(70),
    [sym_seh_try_statement] = STATE(70),
    [sym_seh_leave_statement] = STATE(70),
    [sym__expression] = STATE(4999),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8013),
    [sym_initializer_pair] = STATE(8013),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(70),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(70),
    [sym_template_instantiation] = STATE(70),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(70),
    [sym_operator_cast_declaration] = STATE(70),
    [sym_constructor_or_destructor_definition] = STATE(70),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(70),
    [sym_namespace_alias_definition] = STATE(70),
    [sym_using_declaration] = STATE(70),
    [sym_alias_declaration] = STATE(70),
    [sym_static_assert_declaration] = STATE(70),
    [sym_concept_definition] = STATE(70),
    [sym_for_range_loop] = STATE(70),
    [sym_co_return_statement] = STATE(70),
    [sym_co_yield_statement] = STATE(70),
    [sym_throw_statement] = STATE(70),
    [sym_try_statement] = STATE(70),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(70),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(241),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [5] = {
    [sym_preproc_include] = STATE(59),
    [sym_preproc_def] = STATE(59),
    [sym_preproc_function_def] = STATE(59),
    [sym_preproc_call] = STATE(59),
    [sym_preproc_if] = STATE(59),
    [sym_preproc_ifdef] = STATE(59),
    [sym_function_definition] = STATE(59),
    [sym_declaration] = STATE(59),
    [sym_type_definition] = STATE(59),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(59),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(59),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(59),
    [sym_labeled_statement] = STATE(59),
    [sym_expression_statement] = STATE(59),
    [sym_if_statement] = STATE(59),
    [sym_switch_statement] = STATE(59),
    [sym_case_statement] = STATE(59),
    [sym_while_statement] = STATE(59),
    [sym_do_statement] = STATE(59),
    [sym_for_statement] = STATE(59),
    [sym_return_statement] = STATE(59),
    [sym_break_statement] = STATE(59),
    [sym_continue_statement] = STATE(59),
    [sym_goto_statement] = STATE(59),
    [sym_seh_try_statement] = STATE(59),
    [sym_seh_leave_statement] = STATE(59),
    [sym__expression] = STATE(4999),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8013),
    [sym_initializer_pair] = STATE(8013),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(59),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(59),
    [sym_template_instantiation] = STATE(59),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(59),
    [sym_operator_cast_declaration] = STATE(59),
    [sym_constructor_or_destructor_definition] = STATE(59),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(59),
    [sym_namespace_alias_definition] = STATE(59),
    [sym_using_declaration] = STATE(59),
    [sym_alias_declaration] = STATE(59),
    [sym_static_assert_declaration] = STATE(59),
    [sym_concept_definition] = STATE(59),
    [sym_for_range_loop] = STATE(59),
    [sym_co_return_statement] = STATE(59),
    [sym_co_yield_statement] = STATE(59),
    [sym_throw_statement] = STATE(59),
    [sym_try_statement] = STATE(59),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(59),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(243),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [6] = {
    [sym_preproc_include] = STATE(88),
    [sym_preproc_def] = STATE(88),
    [sym_preproc_function_def] = STATE(88),
    [sym_preproc_call] = STATE(88),
    [sym_preproc_if] = STATE(88),
    [sym_preproc_ifdef] = STATE(88),
    [sym_function_definition] = STATE(88),
    [sym_declaration] = STATE(88),
    [sym_type_definition] = STATE(88),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(88),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(88),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(88),
    [sym_labeled_statement] = STATE(88),
    [sym_expression_statement] = STATE(88),
    [sym_if_statement] = STATE(88),
    [sym_switch_statement] = STATE(88),
    [sym_case_statement] = STATE(88),
    [sym_while_statement] = STATE(88),
    [sym_do_statement] = STATE(88),
    [sym_for_statement] = STATE(88),
    [sym_return_statement] = STATE(88),
    [sym_break_statement] = STATE(88),
    [sym_continue_statement] = STATE(88),
    [sym_goto_statement] = STATE(88),
    [sym_seh_try_statement] = STATE(88),
    [sym_seh_leave_statement] = STATE(88),
    [sym__expression] = STATE(4999),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8013),
    [sym_initializer_pair] = STATE(8013),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(88),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(88),
    [sym_template_instantiation] = STATE(88),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(88),
    [sym_operator_cast_declaration] = STATE(88),
    [sym_constructor_or_destructor_definition] = STATE(88),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(88),
    [sym_namespace_alias_definition] = STATE(88),
    [sym_using_declaration] = STATE(88),
    [sym_alias_declaration] = STATE(88),
    [sym_static_assert_declaration] = STATE(88),
    [sym_concept_definition] = STATE(88),
    [sym_for_range_loop] = STATE(88),
    [sym_co_return_statement] = STATE(88),
    [sym_co_yield_statement] = STATE(88),
    [sym_throw_statement] = STATE(88),
    [sym_try_statement] = STATE(88),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(88),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(245),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [7] = {
    [sym_preproc_include] = STATE(97),
    [sym_preproc_def] = STATE(97),
    [sym_preproc_function_def] = STATE(97),
    [sym_preproc_call] = STATE(97),
    [sym_preproc_if] = STATE(97),
    [sym_preproc_ifdef] = STATE(97),
    [sym_function_definition] = STATE(97),
    [sym_declaration] = STATE(97),
    [sym_type_definition] = STATE(97),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(97),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(97),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(97),
    [sym_labeled_statement] = STATE(97),
    [sym_expression_statement] = STATE(97),
    [sym_if_statement] = STATE(97),
    [sym_switch_statement] = STATE(97),
    [sym_case_statement] = STATE(97),
    [sym_while_statement] = STATE(97),
    [sym_do_statement] = STATE(97),
    [sym_for_statement] = STATE(97),
    [sym_return_statement] = STATE(97),
    [sym_break_statement] = STATE(97),
    [sym_continue_statement] = STATE(97),
    [sym_goto_statement] = STATE(97),
    [sym_seh_try_statement] = STATE(97),
    [sym_seh_leave_statement] = STATE(97),
    [sym__expression] = STATE(4999),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8013),
    [sym_initializer_pair] = STATE(8013),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(97),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(97),
    [sym_template_instantiation] = STATE(97),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(97),
    [sym_operator_cast_declaration] = STATE(97),
    [sym_constructor_or_destructor_definition] = STATE(97),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(97),
    [sym_namespace_alias_definition] = STATE(97),
    [sym_using_declaration] = STATE(97),
    [sym_alias_declaration] = STATE(97),
    [sym_static_assert_declaration] = STATE(97),
    [sym_concept_definition] = STATE(97),
    [sym_for_range_loop] = STATE(97),
    [sym_co_return_statement] = STATE(97),
    [sym_co_yield_statement] = STATE(97),
    [sym_throw_statement] = STATE(97),
    [sym_try_statement] = STATE(97),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(97),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(247),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [8] = {
    [sym_preproc_include] = STATE(97),
    [sym_preproc_def] = STATE(97),
    [sym_preproc_function_def] = STATE(97),
    [sym_preproc_call] = STATE(97),
    [sym_preproc_if] = STATE(97),
    [sym_preproc_ifdef] = STATE(97),
    [sym_function_definition] = STATE(97),
    [sym_declaration] = STATE(97),
    [sym_type_definition] = STATE(97),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(97),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(97),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(97),
    [sym_labeled_statement] = STATE(97),
    [sym_expression_statement] = STATE(97),
    [sym_if_statement] = STATE(97),
    [sym_switch_statement] = STATE(97),
    [sym_case_statement] = STATE(97),
    [sym_while_statement] = STATE(97),
    [sym_do_statement] = STATE(97),
    [sym_for_statement] = STATE(97),
    [sym_return_statement] = STATE(97),
    [sym_break_statement] = STATE(97),
    [sym_continue_statement] = STATE(97),
    [sym_goto_statement] = STATE(97),
    [sym_seh_try_statement] = STATE(97),
    [sym_seh_leave_statement] = STATE(97),
    [sym__expression] = STATE(4999),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8013),
    [sym_initializer_pair] = STATE(8013),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(97),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(97),
    [sym_template_instantiation] = STATE(97),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(97),
    [sym_operator_cast_declaration] = STATE(97),
    [sym_constructor_or_destructor_definition] = STATE(97),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(97),
    [sym_namespace_alias_definition] = STATE(97),
    [sym_using_declaration] = STATE(97),
    [sym_alias_declaration] = STATE(97),
    [sym_static_assert_declaration] = STATE(97),
    [sym_concept_definition] = STATE(97),
    [sym_for_range_loop] = STATE(97),
    [sym_co_return_statement] = STATE(97),
    [sym_co_yield_statement] = STATE(97),
    [sym_throw_statement] = STATE(97),
    [sym_try_statement] = STATE(97),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(97),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(249),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [9] = {
    [sym_preproc_include] = STATE(44),
    [sym_preproc_def] = STATE(44),
    [sym_preproc_function_def] = STATE(44),
    [sym_preproc_call] = STATE(44),
    [sym_preproc_if] = STATE(44),
    [sym_preproc_ifdef] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_declaration] = STATE(44),
    [sym_type_definition] = STATE(44),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(44),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(44),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(44),
    [sym_labeled_statement] = STATE(44),
    [sym_expression_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_switch_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_do_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_return_statement] = STATE(44),
    [sym_break_statement] = STATE(44),
    [sym_continue_statement] = STATE(44),
    [sym_goto_statement] = STATE(44),
    [sym_seh_try_statement] = STATE(44),
    [sym_seh_leave_statement] = STATE(44),
    [sym__expression] = STATE(4999),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8013),
    [sym_initializer_pair] = STATE(8013),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(44),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(44),
    [sym_template_instantiation] = STATE(44),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(44),
    [sym_operator_cast_declaration] = STATE(44),
    [sym_constructor_or_destructor_definition] = STATE(44),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(44),
    [sym_namespace_alias_definition] = STATE(44),
    [sym_using_declaration] = STATE(44),
    [sym_alias_declaration] = STATE(44),
    [sym_static_assert_declaration] = STATE(44),
    [sym_concept_definition] = STATE(44),
    [sym_for_range_loop] = STATE(44),
    [sym_co_return_statement] = STATE(44),
    [sym_co_yield_statement] = STATE(44),
    [sym_throw_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(44),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(251),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [10] = {
    [sym_preproc_include] = STATE(68),
    [sym_preproc_def] = STATE(68),
    [sym_preproc_function_def] = STATE(68),
    [sym_preproc_call] = STATE(68),
    [sym_preproc_if] = STATE(68),
    [sym_preproc_ifdef] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_declaration] = STATE(68),
    [sym_type_definition] = STATE(68),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(68),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(68),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(68),
    [sym_labeled_statement] = STATE(68),
    [sym_expression_statement] = STATE(68),
    [sym_if_statement] = STATE(68),
    [sym_switch_statement] = STATE(68),
    [sym_case_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_do_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_return_statement] = STATE(68),
    [sym_break_statement] = STATE(68),
    [sym_continue_statement] = STATE(68),
    [sym_goto_statement] = STATE(68),
    [sym_seh_try_statement] = STATE(68),
    [sym_seh_leave_statement] = STATE(68),
    [sym__expression] = STATE(4999),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8013),
    [sym_initializer_pair] = STATE(8013),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(68),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(68),
    [sym_template_instantiation] = STATE(68),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(68),
    [sym_operator_cast_declaration] = STATE(68),
    [sym_constructor_or_destructor_definition] = STATE(68),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(68),
    [sym_namespace_alias_definition] = STATE(68),
    [sym_using_declaration] = STATE(68),
    [sym_alias_declaration] = STATE(68),
    [sym_static_assert_declaration] = STATE(68),
    [sym_concept_definition] = STATE(68),
    [sym_for_range_loop] = STATE(68),
    [sym_co_return_statement] = STATE(68),
    [sym_co_yield_statement] = STATE(68),
    [sym_throw_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(68),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(253),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [11] = {
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(43),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(43),
    [sym_labeled_statement] = STATE(43),
    [sym_expression_statement] = STATE(43),
    [sym_if_statement] = STATE(43),
    [sym_switch_statement] = STATE(43),
    [sym_case_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_do_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_return_statement] = STATE(43),
    [sym_break_statement] = STATE(43),
    [sym_continue_statement] = STATE(43),
    [sym_goto_statement] = STATE(43),
    [sym_seh_try_statement] = STATE(43),
    [sym_seh_leave_statement] = STATE(43),
    [sym__expression] = STATE(4999),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8013),
    [sym_initializer_pair] = STATE(8013),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(43),
    [sym_co_return_statement] = STATE(43),
    [sym_co_yield_statement] = STATE(43),
    [sym_throw_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [12] = {
    [sym_preproc_include] = STATE(64),
    [sym_preproc_def] = STATE(64),
    [sym_preproc_function_def] = STATE(64),
    [sym_preproc_call] = STATE(64),
    [sym_preproc_if] = STATE(64),
    [sym_preproc_ifdef] = STATE(64),
    [sym_function_definition] = STATE(64),
    [sym_declaration] = STATE(64),
    [sym_type_definition] = STATE(64),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(64),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(64),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(64),
    [sym_labeled_statement] = STATE(64),
    [sym_expression_statement] = STATE(64),
    [sym_if_statement] = STATE(64),
    [sym_switch_statement] = STATE(64),
    [sym_case_statement] = STATE(64),
    [sym_while_statement] = STATE(64),
    [sym_do_statement] = STATE(64),
    [sym_for_statement] = STATE(64),
    [sym_return_statement] = STATE(64),
    [sym_break_statement] = STATE(64),
    [sym_continue_statement] = STATE(64),
    [sym_goto_statement] = STATE(64),
    [sym_seh_try_statement] = STATE(64),
    [sym_seh_leave_statement] = STATE(64),
    [sym__expression] = STATE(4999),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8013),
    [sym_initializer_pair] = STATE(8013),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(64),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(64),
    [sym_template_instantiation] = STATE(64),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(64),
    [sym_operator_cast_declaration] = STATE(64),
    [sym_constructor_or_destructor_definition] = STATE(64),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(64),
    [sym_namespace_alias_definition] = STATE(64),
    [sym_using_declaration] = STATE(64),
    [sym_alias_declaration] = STATE(64),
    [sym_static_assert_declaration] = STATE(64),
    [sym_concept_definition] = STATE(64),
    [sym_for_range_loop] = STATE(64),
    [sym_co_return_statement] = STATE(64),
    [sym_co_yield_statement] = STATE(64),
    [sym_throw_statement] = STATE(64),
    [sym_try_statement] = STATE(64),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(64),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(257),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [13] = {
    [sym_preproc_include] = STATE(88),
    [sym_preproc_def] = STATE(88),
    [sym_preproc_function_def] = STATE(88),
    [sym_preproc_call] = STATE(88),
    [sym_preproc_if] = STATE(88),
    [sym_preproc_ifdef] = STATE(88),
    [sym_function_definition] = STATE(88),
    [sym_declaration] = STATE(88),
    [sym_type_definition] = STATE(88),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(88),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(88),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(88),
    [sym_labeled_statement] = STATE(88),
    [sym_expression_statement] = STATE(88),
    [sym_if_statement] = STATE(88),
    [sym_switch_statement] = STATE(88),
    [sym_case_statement] = STATE(88),
    [sym_while_statement] = STATE(88),
    [sym_do_statement] = STATE(88),
    [sym_for_statement] = STATE(88),
    [sym_return_statement] = STATE(88),
    [sym_break_statement] = STATE(88),
    [sym_continue_statement] = STATE(88),
    [sym_goto_statement] = STATE(88),
    [sym_seh_try_statement] = STATE(88),
    [sym_seh_leave_statement] = STATE(88),
    [sym__expression] = STATE(4999),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8013),
    [sym_initializer_pair] = STATE(8013),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(88),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(88),
    [sym_template_instantiation] = STATE(88),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(88),
    [sym_operator_cast_declaration] = STATE(88),
    [sym_constructor_or_destructor_definition] = STATE(88),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(88),
    [sym_namespace_alias_definition] = STATE(88),
    [sym_using_declaration] = STATE(88),
    [sym_alias_declaration] = STATE(88),
    [sym_static_assert_declaration] = STATE(88),
    [sym_concept_definition] = STATE(88),
    [sym_for_range_loop] = STATE(88),
    [sym_co_return_statement] = STATE(88),
    [sym_co_yield_statement] = STATE(88),
    [sym_throw_statement] = STATE(88),
    [sym_try_statement] = STATE(88),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(88),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(259),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [14] = {
    [sym_preproc_include] = STATE(61),
    [sym_preproc_def] = STATE(61),
    [sym_preproc_function_def] = STATE(61),
    [sym_preproc_call] = STATE(61),
    [sym_preproc_if] = STATE(61),
    [sym_preproc_ifdef] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_declaration] = STATE(61),
    [sym_type_definition] = STATE(61),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(61),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(61),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(61),
    [sym_labeled_statement] = STATE(61),
    [sym_expression_statement] = STATE(61),
    [sym_if_statement] = STATE(61),
    [sym_switch_statement] = STATE(61),
    [sym_case_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_do_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_return_statement] = STATE(61),
    [sym_break_statement] = STATE(61),
    [sym_continue_statement] = STATE(61),
    [sym_goto_statement] = STATE(61),
    [sym_seh_try_statement] = STATE(61),
    [sym_seh_leave_statement] = STATE(61),
    [sym__expression] = STATE(4999),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8013),
    [sym_initializer_pair] = STATE(8013),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(61),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(61),
    [sym_template_instantiation] = STATE(61),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(61),
    [sym_operator_cast_declaration] = STATE(61),
    [sym_constructor_or_destructor_definition] = STATE(61),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(61),
    [sym_namespace_alias_definition] = STATE(61),
    [sym_using_declaration] = STATE(61),
    [sym_alias_declaration] = STATE(61),
    [sym_static_assert_declaration] = STATE(61),
    [sym_concept_definition] = STATE(61),
    [sym_for_range_loop] = STATE(61),
    [sym_co_return_statement] = STATE(61),
    [sym_co_yield_statement] = STATE(61),
    [sym_throw_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(61),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(261),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [15] = {
    [sym_preproc_include] = STATE(70),
    [sym_preproc_def] = STATE(70),
    [sym_preproc_function_def] = STATE(70),
    [sym_preproc_call] = STATE(70),
    [sym_preproc_if] = STATE(70),
    [sym_preproc_ifdef] = STATE(70),
    [sym_function_definition] = STATE(70),
    [sym_declaration] = STATE(70),
    [sym_type_definition] = STATE(70),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(70),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(70),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(70),
    [sym_labeled_statement] = STATE(70),
    [sym_expression_statement] = STATE(70),
    [sym_if_statement] = STATE(70),
    [sym_switch_statement] = STATE(70),
    [sym_case_statement] = STATE(70),
    [sym_while_statement] = STATE(70),
    [sym_do_statement] = STATE(70),
    [sym_for_statement] = STATE(70),
    [sym_return_statement] = STATE(70),
    [sym_break_statement] = STATE(70),
    [sym_continue_statement] = STATE(70),
    [sym_goto_statement] = STATE(70),
    [sym_seh_try_statement] = STATE(70),
    [sym_seh_leave_statement] = STATE(70),
    [sym__expression] = STATE(4999),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8013),
    [sym_initializer_pair] = STATE(8013),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(70),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(70),
    [sym_template_instantiation] = STATE(70),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(70),
    [sym_operator_cast_declaration] = STATE(70),
    [sym_constructor_or_destructor_definition] = STATE(70),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(70),
    [sym_namespace_alias_definition] = STATE(70),
    [sym_using_declaration] = STATE(70),
    [sym_alias_declaration] = STATE(70),
    [sym_static_assert_declaration] = STATE(70),
    [sym_concept_definition] = STATE(70),
    [sym_for_range_loop] = STATE(70),
    [sym_co_return_statement] = STATE(70),
    [sym_co_yield_statement] = STATE(70),
    [sym_throw_statement] = STATE(70),
    [sym_try_statement] = STATE(70),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(70),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [16] = {
    [sym_preproc_include] = STATE(32),
    [sym_preproc_def] = STATE(32),
    [sym_preproc_function_def] = STATE(32),
    [sym_preproc_call] = STATE(32),
    [sym_preproc_if] = STATE(32),
    [sym_preproc_ifdef] = STATE(32),
    [sym_preproc_else] = STATE(9293),
    [sym_preproc_elif] = STATE(9293),
    [sym_preproc_elifdef] = STATE(9293),
    [sym_function_definition] = STATE(32),
    [sym_declaration] = STATE(32),
    [sym_type_definition] = STATE(32),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5497),
    [sym_linkage_specification] = STATE(32),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2132),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7154),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(32),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3222),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(32),
    [sym_labeled_statement] = STATE(32),
    [sym_expression_statement] = STATE(32),
    [sym_if_statement] = STATE(32),
    [sym_switch_statement] = STATE(32),
    [sym_case_statement] = STATE(32),
    [sym_while_statement] = STATE(32),
    [sym_do_statement] = STATE(32),
    [sym_for_statement] = STATE(32),
    [sym_return_statement] = STATE(32),
    [sym_break_statement] = STATE(32),
    [sym_continue_statement] = STATE(32),
    [sym_goto_statement] = STATE(32),
    [sym_seh_try_statement] = STATE(32),
    [sym_seh_leave_statement] = STATE(32),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(32),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2232),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(32),
    [sym_template_instantiation] = STATE(32),
    [sym_operator_cast] = STATE(7547),
    [sym__constructor_specifiers] = STATE(2232),
    [sym_operator_cast_definition] = STATE(32),
    [sym_operator_cast_declaration] = STATE(32),
    [sym_constructor_or_destructor_definition] = STATE(32),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(32),
    [sym_namespace_alias_definition] = STATE(32),
    [sym_using_declaration] = STATE(32),
    [sym_alias_declaration] = STATE(32),
    [sym_static_assert_declaration] = STATE(32),
    [sym_concept_definition] = STATE(32),
    [sym_for_range_loop] = STATE(32),
    [sym_co_return_statement] = STATE(32),
    [sym_co_yield_statement] = STATE(32),
    [sym_throw_statement] = STATE(32),
    [sym_try_statement] = STATE(32),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7547),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(32),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2232),
    [sym_identifier] = ACTIONS(265),
    [aux_sym_preproc_include_token1] = ACTIONS(267),
    [aux_sym_preproc_def_token1] = ACTIONS(269),
    [aux_sym_preproc_if_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token2] = ACTIONS(273),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(275),
    [aux_sym_preproc_else_token1] = ACTIONS(277),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(281),
    [sym_preproc_directive] = ACTIONS(283),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(285),
    [anon_sym___extension__] = ACTIONS(287),
    [anon_sym_typedef] = ACTIONS(289),
    [anon_sym_extern] = ACTIONS(291),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(295),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_switch] = ACTIONS(299),
    [anon_sym_case] = ACTIONS(301),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_continue] = ACTIONS(315),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym___try] = ACTIONS(319),
    [anon_sym___leave] = ACTIONS(321),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(323),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(327),
    [anon_sym_namespace] = ACTIONS(329),
    [anon_sym_using] = ACTIONS(331),
    [anon_sym_static_assert] = ACTIONS(333),
    [anon_sym_concept] = ACTIONS(335),
    [anon_sym_co_return] = ACTIONS(337),
    [anon_sym_co_yield] = ACTIONS(339),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [17] = {
    [sym_preproc_include] = STATE(19),
    [sym_preproc_def] = STATE(19),
    [sym_preproc_function_def] = STATE(19),
    [sym_preproc_call] = STATE(19),
    [sym_preproc_if] = STATE(19),
    [sym_preproc_ifdef] = STATE(19),
    [sym_preproc_else] = STATE(9761),
    [sym_preproc_elif] = STATE(9761),
    [sym_preproc_elifdef] = STATE(9761),
    [sym_function_definition] = STATE(19),
    [sym_declaration] = STATE(19),
    [sym_type_definition] = STATE(19),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5497),
    [sym_linkage_specification] = STATE(19),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2132),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7154),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(19),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3222),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_goto_statement] = STATE(19),
    [sym_seh_try_statement] = STATE(19),
    [sym_seh_leave_statement] = STATE(19),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(19),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2232),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(19),
    [sym_template_instantiation] = STATE(19),
    [sym_operator_cast] = STATE(7547),
    [sym__constructor_specifiers] = STATE(2232),
    [sym_operator_cast_definition] = STATE(19),
    [sym_operator_cast_declaration] = STATE(19),
    [sym_constructor_or_destructor_definition] = STATE(19),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(19),
    [sym_namespace_alias_definition] = STATE(19),
    [sym_using_declaration] = STATE(19),
    [sym_alias_declaration] = STATE(19),
    [sym_static_assert_declaration] = STATE(19),
    [sym_concept_definition] = STATE(19),
    [sym_for_range_loop] = STATE(19),
    [sym_co_return_statement] = STATE(19),
    [sym_co_yield_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7547),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(19),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2232),
    [sym_identifier] = ACTIONS(265),
    [aux_sym_preproc_include_token1] = ACTIONS(267),
    [aux_sym_preproc_def_token1] = ACTIONS(269),
    [aux_sym_preproc_if_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token2] = ACTIONS(341),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(275),
    [aux_sym_preproc_else_token1] = ACTIONS(277),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(281),
    [sym_preproc_directive] = ACTIONS(283),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(285),
    [anon_sym___extension__] = ACTIONS(287),
    [anon_sym_typedef] = ACTIONS(289),
    [anon_sym_extern] = ACTIONS(291),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(295),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_switch] = ACTIONS(299),
    [anon_sym_case] = ACTIONS(301),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_continue] = ACTIONS(315),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym___try] = ACTIONS(319),
    [anon_sym___leave] = ACTIONS(321),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(323),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(327),
    [anon_sym_namespace] = ACTIONS(329),
    [anon_sym_using] = ACTIONS(331),
    [anon_sym_static_assert] = ACTIONS(333),
    [anon_sym_concept] = ACTIONS(335),
    [anon_sym_co_return] = ACTIONS(337),
    [anon_sym_co_yield] = ACTIONS(339),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [18] = {
    [sym_preproc_include] = STATE(32),
    [sym_preproc_def] = STATE(32),
    [sym_preproc_function_def] = STATE(32),
    [sym_preproc_call] = STATE(32),
    [sym_preproc_if] = STATE(32),
    [sym_preproc_ifdef] = STATE(32),
    [sym_preproc_else] = STATE(8957),
    [sym_preproc_elif] = STATE(8957),
    [sym_preproc_elifdef] = STATE(8957),
    [sym_function_definition] = STATE(32),
    [sym_declaration] = STATE(32),
    [sym_type_definition] = STATE(32),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5497),
    [sym_linkage_specification] = STATE(32),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2132),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7154),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(32),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3222),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(32),
    [sym_labeled_statement] = STATE(32),
    [sym_expression_statement] = STATE(32),
    [sym_if_statement] = STATE(32),
    [sym_switch_statement] = STATE(32),
    [sym_case_statement] = STATE(32),
    [sym_while_statement] = STATE(32),
    [sym_do_statement] = STATE(32),
    [sym_for_statement] = STATE(32),
    [sym_return_statement] = STATE(32),
    [sym_break_statement] = STATE(32),
    [sym_continue_statement] = STATE(32),
    [sym_goto_statement] = STATE(32),
    [sym_seh_try_statement] = STATE(32),
    [sym_seh_leave_statement] = STATE(32),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(32),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2232),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(32),
    [sym_template_instantiation] = STATE(32),
    [sym_operator_cast] = STATE(7547),
    [sym__constructor_specifiers] = STATE(2232),
    [sym_operator_cast_definition] = STATE(32),
    [sym_operator_cast_declaration] = STATE(32),
    [sym_constructor_or_destructor_definition] = STATE(32),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(32),
    [sym_namespace_alias_definition] = STATE(32),
    [sym_using_declaration] = STATE(32),
    [sym_alias_declaration] = STATE(32),
    [sym_static_assert_declaration] = STATE(32),
    [sym_concept_definition] = STATE(32),
    [sym_for_range_loop] = STATE(32),
    [sym_co_return_statement] = STATE(32),
    [sym_co_yield_statement] = STATE(32),
    [sym_throw_statement] = STATE(32),
    [sym_try_statement] = STATE(32),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7547),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(32),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2232),
    [sym_identifier] = ACTIONS(265),
    [aux_sym_preproc_include_token1] = ACTIONS(267),
    [aux_sym_preproc_def_token1] = ACTIONS(269),
    [aux_sym_preproc_if_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token2] = ACTIONS(343),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(275),
    [aux_sym_preproc_else_token1] = ACTIONS(277),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(281),
    [sym_preproc_directive] = ACTIONS(283),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(285),
    [anon_sym___extension__] = ACTIONS(287),
    [anon_sym_typedef] = ACTIONS(289),
    [anon_sym_extern] = ACTIONS(291),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(295),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_switch] = ACTIONS(299),
    [anon_sym_case] = ACTIONS(301),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_continue] = ACTIONS(315),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym___try] = ACTIONS(319),
    [anon_sym___leave] = ACTIONS(321),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(323),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(327),
    [anon_sym_namespace] = ACTIONS(329),
    [anon_sym_using] = ACTIONS(331),
    [anon_sym_static_assert] = ACTIONS(333),
    [anon_sym_concept] = ACTIONS(335),
    [anon_sym_co_return] = ACTIONS(337),
    [anon_sym_co_yield] = ACTIONS(339),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [19] = {
    [sym_preproc_include] = STATE(32),
    [sym_preproc_def] = STATE(32),
    [sym_preproc_function_def] = STATE(32),
    [sym_preproc_call] = STATE(32),
    [sym_preproc_if] = STATE(32),
    [sym_preproc_ifdef] = STATE(32),
    [sym_preproc_else] = STATE(8978),
    [sym_preproc_elif] = STATE(8978),
    [sym_preproc_elifdef] = STATE(8978),
    [sym_function_definition] = STATE(32),
    [sym_declaration] = STATE(32),
    [sym_type_definition] = STATE(32),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5497),
    [sym_linkage_specification] = STATE(32),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2132),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7154),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(32),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3222),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(32),
    [sym_labeled_statement] = STATE(32),
    [sym_expression_statement] = STATE(32),
    [sym_if_statement] = STATE(32),
    [sym_switch_statement] = STATE(32),
    [sym_case_statement] = STATE(32),
    [sym_while_statement] = STATE(32),
    [sym_do_statement] = STATE(32),
    [sym_for_statement] = STATE(32),
    [sym_return_statement] = STATE(32),
    [sym_break_statement] = STATE(32),
    [sym_continue_statement] = STATE(32),
    [sym_goto_statement] = STATE(32),
    [sym_seh_try_statement] = STATE(32),
    [sym_seh_leave_statement] = STATE(32),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(32),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2232),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(32),
    [sym_template_instantiation] = STATE(32),
    [sym_operator_cast] = STATE(7547),
    [sym__constructor_specifiers] = STATE(2232),
    [sym_operator_cast_definition] = STATE(32),
    [sym_operator_cast_declaration] = STATE(32),
    [sym_constructor_or_destructor_definition] = STATE(32),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(32),
    [sym_namespace_alias_definition] = STATE(32),
    [sym_using_declaration] = STATE(32),
    [sym_alias_declaration] = STATE(32),
    [sym_static_assert_declaration] = STATE(32),
    [sym_concept_definition] = STATE(32),
    [sym_for_range_loop] = STATE(32),
    [sym_co_return_statement] = STATE(32),
    [sym_co_yield_statement] = STATE(32),
    [sym_throw_statement] = STATE(32),
    [sym_try_statement] = STATE(32),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7547),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(32),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2232),
    [sym_identifier] = ACTIONS(265),
    [aux_sym_preproc_include_token1] = ACTIONS(267),
    [aux_sym_preproc_def_token1] = ACTIONS(269),
    [aux_sym_preproc_if_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token2] = ACTIONS(345),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(275),
    [aux_sym_preproc_else_token1] = ACTIONS(277),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(281),
    [sym_preproc_directive] = ACTIONS(283),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(285),
    [anon_sym___extension__] = ACTIONS(287),
    [anon_sym_typedef] = ACTIONS(289),
    [anon_sym_extern] = ACTIONS(291),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(295),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_switch] = ACTIONS(299),
    [anon_sym_case] = ACTIONS(301),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_continue] = ACTIONS(315),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym___try] = ACTIONS(319),
    [anon_sym___leave] = ACTIONS(321),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(323),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(327),
    [anon_sym_namespace] = ACTIONS(329),
    [anon_sym_using] = ACTIONS(331),
    [anon_sym_static_assert] = ACTIONS(333),
    [anon_sym_concept] = ACTIONS(335),
    [anon_sym_co_return] = ACTIONS(337),
    [anon_sym_co_yield] = ACTIONS(339),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [20] = {
    [sym_preproc_include] = STATE(18),
    [sym_preproc_def] = STATE(18),
    [sym_preproc_function_def] = STATE(18),
    [sym_preproc_call] = STATE(18),
    [sym_preproc_if] = STATE(18),
    [sym_preproc_ifdef] = STATE(18),
    [sym_preproc_else] = STATE(9116),
    [sym_preproc_elif] = STATE(9116),
    [sym_preproc_elifdef] = STATE(9116),
    [sym_function_definition] = STATE(18),
    [sym_declaration] = STATE(18),
    [sym_type_definition] = STATE(18),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5497),
    [sym_linkage_specification] = STATE(18),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2132),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7154),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(18),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3222),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(18),
    [sym_labeled_statement] = STATE(18),
    [sym_expression_statement] = STATE(18),
    [sym_if_statement] = STATE(18),
    [sym_switch_statement] = STATE(18),
    [sym_case_statement] = STATE(18),
    [sym_while_statement] = STATE(18),
    [sym_do_statement] = STATE(18),
    [sym_for_statement] = STATE(18),
    [sym_return_statement] = STATE(18),
    [sym_break_statement] = STATE(18),
    [sym_continue_statement] = STATE(18),
    [sym_goto_statement] = STATE(18),
    [sym_seh_try_statement] = STATE(18),
    [sym_seh_leave_statement] = STATE(18),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(18),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2232),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(18),
    [sym_template_instantiation] = STATE(18),
    [sym_operator_cast] = STATE(7547),
    [sym__constructor_specifiers] = STATE(2232),
    [sym_operator_cast_definition] = STATE(18),
    [sym_operator_cast_declaration] = STATE(18),
    [sym_constructor_or_destructor_definition] = STATE(18),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(18),
    [sym_namespace_alias_definition] = STATE(18),
    [sym_using_declaration] = STATE(18),
    [sym_alias_declaration] = STATE(18),
    [sym_static_assert_declaration] = STATE(18),
    [sym_concept_definition] = STATE(18),
    [sym_for_range_loop] = STATE(18),
    [sym_co_return_statement] = STATE(18),
    [sym_co_yield_statement] = STATE(18),
    [sym_throw_statement] = STATE(18),
    [sym_try_statement] = STATE(18),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7547),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(18),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2232),
    [sym_identifier] = ACTIONS(265),
    [aux_sym_preproc_include_token1] = ACTIONS(267),
    [aux_sym_preproc_def_token1] = ACTIONS(269),
    [aux_sym_preproc_if_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token2] = ACTIONS(347),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(275),
    [aux_sym_preproc_else_token1] = ACTIONS(277),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(281),
    [sym_preproc_directive] = ACTIONS(283),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(285),
    [anon_sym___extension__] = ACTIONS(287),
    [anon_sym_typedef] = ACTIONS(289),
    [anon_sym_extern] = ACTIONS(291),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(295),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_switch] = ACTIONS(299),
    [anon_sym_case] = ACTIONS(301),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_continue] = ACTIONS(315),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym___try] = ACTIONS(319),
    [anon_sym___leave] = ACTIONS(321),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(323),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(327),
    [anon_sym_namespace] = ACTIONS(329),
    [anon_sym_using] = ACTIONS(331),
    [anon_sym_static_assert] = ACTIONS(333),
    [anon_sym_concept] = ACTIONS(335),
    [anon_sym_co_return] = ACTIONS(337),
    [anon_sym_co_yield] = ACTIONS(339),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [21] = {
    [sym_preproc_include] = STATE(32),
    [sym_preproc_def] = STATE(32),
    [sym_preproc_function_def] = STATE(32),
    [sym_preproc_call] = STATE(32),
    [sym_preproc_if] = STATE(32),
    [sym_preproc_ifdef] = STATE(32),
    [sym_preproc_else] = STATE(9146),
    [sym_preproc_elif] = STATE(9146),
    [sym_preproc_elifdef] = STATE(9146),
    [sym_function_definition] = STATE(32),
    [sym_declaration] = STATE(32),
    [sym_type_definition] = STATE(32),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5497),
    [sym_linkage_specification] = STATE(32),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2132),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7154),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(32),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3222),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(32),
    [sym_labeled_statement] = STATE(32),
    [sym_expression_statement] = STATE(32),
    [sym_if_statement] = STATE(32),
    [sym_switch_statement] = STATE(32),
    [sym_case_statement] = STATE(32),
    [sym_while_statement] = STATE(32),
    [sym_do_statement] = STATE(32),
    [sym_for_statement] = STATE(32),
    [sym_return_statement] = STATE(32),
    [sym_break_statement] = STATE(32),
    [sym_continue_statement] = STATE(32),
    [sym_goto_statement] = STATE(32),
    [sym_seh_try_statement] = STATE(32),
    [sym_seh_leave_statement] = STATE(32),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(32),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2232),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(32),
    [sym_template_instantiation] = STATE(32),
    [sym_operator_cast] = STATE(7547),
    [sym__constructor_specifiers] = STATE(2232),
    [sym_operator_cast_definition] = STATE(32),
    [sym_operator_cast_declaration] = STATE(32),
    [sym_constructor_or_destructor_definition] = STATE(32),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(32),
    [sym_namespace_alias_definition] = STATE(32),
    [sym_using_declaration] = STATE(32),
    [sym_alias_declaration] = STATE(32),
    [sym_static_assert_declaration] = STATE(32),
    [sym_concept_definition] = STATE(32),
    [sym_for_range_loop] = STATE(32),
    [sym_co_return_statement] = STATE(32),
    [sym_co_yield_statement] = STATE(32),
    [sym_throw_statement] = STATE(32),
    [sym_try_statement] = STATE(32),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7547),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(32),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2232),
    [sym_identifier] = ACTIONS(265),
    [aux_sym_preproc_include_token1] = ACTIONS(267),
    [aux_sym_preproc_def_token1] = ACTIONS(269),
    [aux_sym_preproc_if_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token2] = ACTIONS(349),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(275),
    [aux_sym_preproc_else_token1] = ACTIONS(277),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(281),
    [sym_preproc_directive] = ACTIONS(283),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(285),
    [anon_sym___extension__] = ACTIONS(287),
    [anon_sym_typedef] = ACTIONS(289),
    [anon_sym_extern] = ACTIONS(291),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(295),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_switch] = ACTIONS(299),
    [anon_sym_case] = ACTIONS(301),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_continue] = ACTIONS(315),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym___try] = ACTIONS(319),
    [anon_sym___leave] = ACTIONS(321),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(323),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(327),
    [anon_sym_namespace] = ACTIONS(329),
    [anon_sym_using] = ACTIONS(331),
    [anon_sym_static_assert] = ACTIONS(333),
    [anon_sym_concept] = ACTIONS(335),
    [anon_sym_co_return] = ACTIONS(337),
    [anon_sym_co_yield] = ACTIONS(339),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [22] = {
    [sym_preproc_include] = STATE(21),
    [sym_preproc_def] = STATE(21),
    [sym_preproc_function_def] = STATE(21),
    [sym_preproc_call] = STATE(21),
    [sym_preproc_if] = STATE(21),
    [sym_preproc_ifdef] = STATE(21),
    [sym_preproc_else] = STATE(9061),
    [sym_preproc_elif] = STATE(9061),
    [sym_preproc_elifdef] = STATE(9061),
    [sym_function_definition] = STATE(21),
    [sym_declaration] = STATE(21),
    [sym_type_definition] = STATE(21),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5497),
    [sym_linkage_specification] = STATE(21),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2132),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7154),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(21),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3222),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(21),
    [sym_labeled_statement] = STATE(21),
    [sym_expression_statement] = STATE(21),
    [sym_if_statement] = STATE(21),
    [sym_switch_statement] = STATE(21),
    [sym_case_statement] = STATE(21),
    [sym_while_statement] = STATE(21),
    [sym_do_statement] = STATE(21),
    [sym_for_statement] = STATE(21),
    [sym_return_statement] = STATE(21),
    [sym_break_statement] = STATE(21),
    [sym_continue_statement] = STATE(21),
    [sym_goto_statement] = STATE(21),
    [sym_seh_try_statement] = STATE(21),
    [sym_seh_leave_statement] = STATE(21),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(21),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2232),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(21),
    [sym_template_instantiation] = STATE(21),
    [sym_operator_cast] = STATE(7547),
    [sym__constructor_specifiers] = STATE(2232),
    [sym_operator_cast_definition] = STATE(21),
    [sym_operator_cast_declaration] = STATE(21),
    [sym_constructor_or_destructor_definition] = STATE(21),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(21),
    [sym_namespace_alias_definition] = STATE(21),
    [sym_using_declaration] = STATE(21),
    [sym_alias_declaration] = STATE(21),
    [sym_static_assert_declaration] = STATE(21),
    [sym_concept_definition] = STATE(21),
    [sym_for_range_loop] = STATE(21),
    [sym_co_return_statement] = STATE(21),
    [sym_co_yield_statement] = STATE(21),
    [sym_throw_statement] = STATE(21),
    [sym_try_statement] = STATE(21),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7547),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(21),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2232),
    [sym_identifier] = ACTIONS(265),
    [aux_sym_preproc_include_token1] = ACTIONS(267),
    [aux_sym_preproc_def_token1] = ACTIONS(269),
    [aux_sym_preproc_if_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token2] = ACTIONS(351),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(275),
    [aux_sym_preproc_else_token1] = ACTIONS(277),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(281),
    [sym_preproc_directive] = ACTIONS(283),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(285),
    [anon_sym___extension__] = ACTIONS(287),
    [anon_sym_typedef] = ACTIONS(289),
    [anon_sym_extern] = ACTIONS(291),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(295),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_switch] = ACTIONS(299),
    [anon_sym_case] = ACTIONS(301),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_continue] = ACTIONS(315),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym___try] = ACTIONS(319),
    [anon_sym___leave] = ACTIONS(321),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(323),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(327),
    [anon_sym_namespace] = ACTIONS(329),
    [anon_sym_using] = ACTIONS(331),
    [anon_sym_static_assert] = ACTIONS(333),
    [anon_sym_concept] = ACTIONS(335),
    [anon_sym_co_return] = ACTIONS(337),
    [anon_sym_co_yield] = ACTIONS(339),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [23] = {
    [sym_preproc_include] = STATE(24),
    [sym_preproc_def] = STATE(24),
    [sym_preproc_function_def] = STATE(24),
    [sym_preproc_call] = STATE(24),
    [sym_preproc_if] = STATE(24),
    [sym_preproc_ifdef] = STATE(24),
    [sym_preproc_else] = STATE(9639),
    [sym_preproc_elif] = STATE(9639),
    [sym_preproc_elifdef] = STATE(9639),
    [sym_function_definition] = STATE(24),
    [sym_declaration] = STATE(24),
    [sym_type_definition] = STATE(24),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5497),
    [sym_linkage_specification] = STATE(24),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2132),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7154),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(24),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3222),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(24),
    [sym_labeled_statement] = STATE(24),
    [sym_expression_statement] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_switch_statement] = STATE(24),
    [sym_case_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_do_statement] = STATE(24),
    [sym_for_statement] = STATE(24),
    [sym_return_statement] = STATE(24),
    [sym_break_statement] = STATE(24),
    [sym_continue_statement] = STATE(24),
    [sym_goto_statement] = STATE(24),
    [sym_seh_try_statement] = STATE(24),
    [sym_seh_leave_statement] = STATE(24),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(24),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2232),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(24),
    [sym_template_instantiation] = STATE(24),
    [sym_operator_cast] = STATE(7547),
    [sym__constructor_specifiers] = STATE(2232),
    [sym_operator_cast_definition] = STATE(24),
    [sym_operator_cast_declaration] = STATE(24),
    [sym_constructor_or_destructor_definition] = STATE(24),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(24),
    [sym_namespace_alias_definition] = STATE(24),
    [sym_using_declaration] = STATE(24),
    [sym_alias_declaration] = STATE(24),
    [sym_static_assert_declaration] = STATE(24),
    [sym_concept_definition] = STATE(24),
    [sym_for_range_loop] = STATE(24),
    [sym_co_return_statement] = STATE(24),
    [sym_co_yield_statement] = STATE(24),
    [sym_throw_statement] = STATE(24),
    [sym_try_statement] = STATE(24),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7547),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(24),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2232),
    [sym_identifier] = ACTIONS(265),
    [aux_sym_preproc_include_token1] = ACTIONS(267),
    [aux_sym_preproc_def_token1] = ACTIONS(269),
    [aux_sym_preproc_if_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token2] = ACTIONS(353),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(275),
    [aux_sym_preproc_else_token1] = ACTIONS(277),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(281),
    [sym_preproc_directive] = ACTIONS(283),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(285),
    [anon_sym___extension__] = ACTIONS(287),
    [anon_sym_typedef] = ACTIONS(289),
    [anon_sym_extern] = ACTIONS(291),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(295),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_switch] = ACTIONS(299),
    [anon_sym_case] = ACTIONS(301),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_continue] = ACTIONS(315),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym___try] = ACTIONS(319),
    [anon_sym___leave] = ACTIONS(321),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(323),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(327),
    [anon_sym_namespace] = ACTIONS(329),
    [anon_sym_using] = ACTIONS(331),
    [anon_sym_static_assert] = ACTIONS(333),
    [anon_sym_concept] = ACTIONS(335),
    [anon_sym_co_return] = ACTIONS(337),
    [anon_sym_co_yield] = ACTIONS(339),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [24] = {
    [sym_preproc_include] = STATE(32),
    [sym_preproc_def] = STATE(32),
    [sym_preproc_function_def] = STATE(32),
    [sym_preproc_call] = STATE(32),
    [sym_preproc_if] = STATE(32),
    [sym_preproc_ifdef] = STATE(32),
    [sym_preproc_else] = STATE(9366),
    [sym_preproc_elif] = STATE(9366),
    [sym_preproc_elifdef] = STATE(9366),
    [sym_function_definition] = STATE(32),
    [sym_declaration] = STATE(32),
    [sym_type_definition] = STATE(32),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5497),
    [sym_linkage_specification] = STATE(32),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2132),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7154),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(32),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3222),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(32),
    [sym_labeled_statement] = STATE(32),
    [sym_expression_statement] = STATE(32),
    [sym_if_statement] = STATE(32),
    [sym_switch_statement] = STATE(32),
    [sym_case_statement] = STATE(32),
    [sym_while_statement] = STATE(32),
    [sym_do_statement] = STATE(32),
    [sym_for_statement] = STATE(32),
    [sym_return_statement] = STATE(32),
    [sym_break_statement] = STATE(32),
    [sym_continue_statement] = STATE(32),
    [sym_goto_statement] = STATE(32),
    [sym_seh_try_statement] = STATE(32),
    [sym_seh_leave_statement] = STATE(32),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(32),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2232),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(32),
    [sym_template_instantiation] = STATE(32),
    [sym_operator_cast] = STATE(7547),
    [sym__constructor_specifiers] = STATE(2232),
    [sym_operator_cast_definition] = STATE(32),
    [sym_operator_cast_declaration] = STATE(32),
    [sym_constructor_or_destructor_definition] = STATE(32),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(32),
    [sym_namespace_alias_definition] = STATE(32),
    [sym_using_declaration] = STATE(32),
    [sym_alias_declaration] = STATE(32),
    [sym_static_assert_declaration] = STATE(32),
    [sym_concept_definition] = STATE(32),
    [sym_for_range_loop] = STATE(32),
    [sym_co_return_statement] = STATE(32),
    [sym_co_yield_statement] = STATE(32),
    [sym_throw_statement] = STATE(32),
    [sym_try_statement] = STATE(32),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7547),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(32),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2232),
    [sym_identifier] = ACTIONS(265),
    [aux_sym_preproc_include_token1] = ACTIONS(267),
    [aux_sym_preproc_def_token1] = ACTIONS(269),
    [aux_sym_preproc_if_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token2] = ACTIONS(355),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(275),
    [aux_sym_preproc_else_token1] = ACTIONS(277),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(281),
    [sym_preproc_directive] = ACTIONS(283),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(285),
    [anon_sym___extension__] = ACTIONS(287),
    [anon_sym_typedef] = ACTIONS(289),
    [anon_sym_extern] = ACTIONS(291),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(295),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_switch] = ACTIONS(299),
    [anon_sym_case] = ACTIONS(301),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_continue] = ACTIONS(315),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym___try] = ACTIONS(319),
    [anon_sym___leave] = ACTIONS(321),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(323),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(327),
    [anon_sym_namespace] = ACTIONS(329),
    [anon_sym_using] = ACTIONS(331),
    [anon_sym_static_assert] = ACTIONS(333),
    [anon_sym_concept] = ACTIONS(335),
    [anon_sym_co_return] = ACTIONS(337),
    [anon_sym_co_yield] = ACTIONS(339),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [25] = {
    [sym_preproc_include] = STATE(16),
    [sym_preproc_def] = STATE(16),
    [sym_preproc_function_def] = STATE(16),
    [sym_preproc_call] = STATE(16),
    [sym_preproc_if] = STATE(16),
    [sym_preproc_ifdef] = STATE(16),
    [sym_preproc_else] = STATE(9131),
    [sym_preproc_elif] = STATE(9131),
    [sym_preproc_elifdef] = STATE(9131),
    [sym_function_definition] = STATE(16),
    [sym_declaration] = STATE(16),
    [sym_type_definition] = STATE(16),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5497),
    [sym_linkage_specification] = STATE(16),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2132),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7154),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(16),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3222),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_case_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_goto_statement] = STATE(16),
    [sym_seh_try_statement] = STATE(16),
    [sym_seh_leave_statement] = STATE(16),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(16),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2232),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(16),
    [sym_template_instantiation] = STATE(16),
    [sym_operator_cast] = STATE(7547),
    [sym__constructor_specifiers] = STATE(2232),
    [sym_operator_cast_definition] = STATE(16),
    [sym_operator_cast_declaration] = STATE(16),
    [sym_constructor_or_destructor_definition] = STATE(16),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(16),
    [sym_namespace_alias_definition] = STATE(16),
    [sym_using_declaration] = STATE(16),
    [sym_alias_declaration] = STATE(16),
    [sym_static_assert_declaration] = STATE(16),
    [sym_concept_definition] = STATE(16),
    [sym_for_range_loop] = STATE(16),
    [sym_co_return_statement] = STATE(16),
    [sym_co_yield_statement] = STATE(16),
    [sym_throw_statement] = STATE(16),
    [sym_try_statement] = STATE(16),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7547),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(16),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2232),
    [sym_identifier] = ACTIONS(265),
    [aux_sym_preproc_include_token1] = ACTIONS(267),
    [aux_sym_preproc_def_token1] = ACTIONS(269),
    [aux_sym_preproc_if_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token2] = ACTIONS(357),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(275),
    [aux_sym_preproc_else_token1] = ACTIONS(277),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(281),
    [sym_preproc_directive] = ACTIONS(283),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(285),
    [anon_sym___extension__] = ACTIONS(287),
    [anon_sym_typedef] = ACTIONS(289),
    [anon_sym_extern] = ACTIONS(291),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(295),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_switch] = ACTIONS(299),
    [anon_sym_case] = ACTIONS(301),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_continue] = ACTIONS(315),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym___try] = ACTIONS(319),
    [anon_sym___leave] = ACTIONS(321),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(323),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(327),
    [anon_sym_namespace] = ACTIONS(329),
    [anon_sym_using] = ACTIONS(331),
    [anon_sym_static_assert] = ACTIONS(333),
    [anon_sym_concept] = ACTIONS(335),
    [anon_sym_co_return] = ACTIONS(337),
    [anon_sym_co_yield] = ACTIONS(339),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [26] = {
    [sym_preproc_include] = STATE(37),
    [sym_preproc_def] = STATE(37),
    [sym_preproc_function_def] = STATE(37),
    [sym_preproc_call] = STATE(37),
    [sym_preproc_if] = STATE(37),
    [sym_preproc_ifdef] = STATE(37),
    [sym_preproc_else] = STATE(8965),
    [sym_preproc_elif] = STATE(8965),
    [sym_function_definition] = STATE(37),
    [sym_declaration] = STATE(37),
    [sym_type_definition] = STATE(37),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5457),
    [sym_linkage_specification] = STATE(37),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2123),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7132),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(37),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3219),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(37),
    [sym_labeled_statement] = STATE(37),
    [sym_expression_statement] = STATE(37),
    [sym_if_statement] = STATE(37),
    [sym_switch_statement] = STATE(37),
    [sym_case_statement] = STATE(37),
    [sym_while_statement] = STATE(37),
    [sym_do_statement] = STATE(37),
    [sym_for_statement] = STATE(37),
    [sym_return_statement] = STATE(37),
    [sym_break_statement] = STATE(37),
    [sym_continue_statement] = STATE(37),
    [sym_goto_statement] = STATE(37),
    [sym_seh_try_statement] = STATE(37),
    [sym_seh_leave_statement] = STATE(37),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(37),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2230),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(37),
    [sym_template_instantiation] = STATE(37),
    [sym_operator_cast] = STATE(7525),
    [sym__constructor_specifiers] = STATE(2230),
    [sym_operator_cast_definition] = STATE(37),
    [sym_operator_cast_declaration] = STATE(37),
    [sym_constructor_or_destructor_definition] = STATE(37),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(37),
    [sym_namespace_alias_definition] = STATE(37),
    [sym_using_declaration] = STATE(37),
    [sym_alias_declaration] = STATE(37),
    [sym_static_assert_declaration] = STATE(37),
    [sym_concept_definition] = STATE(37),
    [sym_for_range_loop] = STATE(37),
    [sym_co_return_statement] = STATE(37),
    [sym_co_yield_statement] = STATE(37),
    [sym_throw_statement] = STATE(37),
    [sym_try_statement] = STATE(37),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7525),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(37),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2230),
    [sym_identifier] = ACTIONS(359),
    [aux_sym_preproc_include_token1] = ACTIONS(361),
    [aux_sym_preproc_def_token1] = ACTIONS(363),
    [aux_sym_preproc_if_token1] = ACTIONS(365),
    [aux_sym_preproc_if_token2] = ACTIONS(367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(369),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(369),
    [aux_sym_preproc_else_token1] = ACTIONS(277),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [sym_preproc_directive] = ACTIONS(371),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym___extension__] = ACTIONS(375),
    [anon_sym_typedef] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(379),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(383),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(389),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(411),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_namespace] = ACTIONS(417),
    [anon_sym_using] = ACTIONS(419),
    [anon_sym_static_assert] = ACTIONS(421),
    [anon_sym_concept] = ACTIONS(423),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [27] = {
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_preproc_else] = STATE(9085),
    [sym_preproc_elif] = STATE(9085),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5457),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2123),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7132),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(41),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3219),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(41),
    [sym_labeled_statement] = STATE(41),
    [sym_expression_statement] = STATE(41),
    [sym_if_statement] = STATE(41),
    [sym_switch_statement] = STATE(41),
    [sym_case_statement] = STATE(41),
    [sym_while_statement] = STATE(41),
    [sym_do_statement] = STATE(41),
    [sym_for_statement] = STATE(41),
    [sym_return_statement] = STATE(41),
    [sym_break_statement] = STATE(41),
    [sym_continue_statement] = STATE(41),
    [sym_goto_statement] = STATE(41),
    [sym_seh_try_statement] = STATE(41),
    [sym_seh_leave_statement] = STATE(41),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2230),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(7525),
    [sym__constructor_specifiers] = STATE(2230),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(41),
    [sym_co_return_statement] = STATE(41),
    [sym_co_yield_statement] = STATE(41),
    [sym_throw_statement] = STATE(41),
    [sym_try_statement] = STATE(41),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7525),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2230),
    [sym_identifier] = ACTIONS(359),
    [aux_sym_preproc_include_token1] = ACTIONS(361),
    [aux_sym_preproc_def_token1] = ACTIONS(363),
    [aux_sym_preproc_if_token1] = ACTIONS(365),
    [aux_sym_preproc_if_token2] = ACTIONS(429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(369),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(369),
    [aux_sym_preproc_else_token1] = ACTIONS(277),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [sym_preproc_directive] = ACTIONS(371),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym___extension__] = ACTIONS(375),
    [anon_sym_typedef] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(379),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(383),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(389),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(411),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_namespace] = ACTIONS(417),
    [anon_sym_using] = ACTIONS(419),
    [anon_sym_static_assert] = ACTIONS(421),
    [anon_sym_concept] = ACTIONS(423),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [28] = {
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(9389),
    [sym_preproc_elif] = STATE(9389),
    [sym_function_definition] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5457),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2123),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7132),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(27),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3219),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_goto_statement] = STATE(27),
    [sym_seh_try_statement] = STATE(27),
    [sym_seh_leave_statement] = STATE(27),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(27),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2230),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(27),
    [sym_template_instantiation] = STATE(27),
    [sym_operator_cast] = STATE(7525),
    [sym__constructor_specifiers] = STATE(2230),
    [sym_operator_cast_definition] = STATE(27),
    [sym_operator_cast_declaration] = STATE(27),
    [sym_constructor_or_destructor_definition] = STATE(27),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(27),
    [sym_namespace_alias_definition] = STATE(27),
    [sym_using_declaration] = STATE(27),
    [sym_alias_declaration] = STATE(27),
    [sym_static_assert_declaration] = STATE(27),
    [sym_concept_definition] = STATE(27),
    [sym_for_range_loop] = STATE(27),
    [sym_co_return_statement] = STATE(27),
    [sym_co_yield_statement] = STATE(27),
    [sym_throw_statement] = STATE(27),
    [sym_try_statement] = STATE(27),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7525),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2230),
    [sym_identifier] = ACTIONS(359),
    [aux_sym_preproc_include_token1] = ACTIONS(361),
    [aux_sym_preproc_def_token1] = ACTIONS(363),
    [aux_sym_preproc_if_token1] = ACTIONS(365),
    [aux_sym_preproc_if_token2] = ACTIONS(431),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(369),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(369),
    [aux_sym_preproc_else_token1] = ACTIONS(277),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [sym_preproc_directive] = ACTIONS(371),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym___extension__] = ACTIONS(375),
    [anon_sym_typedef] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(379),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(383),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(389),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(411),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_namespace] = ACTIONS(417),
    [anon_sym_using] = ACTIONS(419),
    [anon_sym_static_assert] = ACTIONS(421),
    [anon_sym_concept] = ACTIONS(423),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [29] = {
    [sym_preproc_include] = STATE(40),
    [sym_preproc_def] = STATE(40),
    [sym_preproc_function_def] = STATE(40),
    [sym_preproc_call] = STATE(40),
    [sym_preproc_if] = STATE(40),
    [sym_preproc_ifdef] = STATE(40),
    [sym_preproc_else] = STATE(9046),
    [sym_preproc_elif] = STATE(9046),
    [sym_function_definition] = STATE(40),
    [sym_declaration] = STATE(40),
    [sym_type_definition] = STATE(40),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5457),
    [sym_linkage_specification] = STATE(40),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2123),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7132),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(40),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3219),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(40),
    [sym_labeled_statement] = STATE(40),
    [sym_expression_statement] = STATE(40),
    [sym_if_statement] = STATE(40),
    [sym_switch_statement] = STATE(40),
    [sym_case_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_do_statement] = STATE(40),
    [sym_for_statement] = STATE(40),
    [sym_return_statement] = STATE(40),
    [sym_break_statement] = STATE(40),
    [sym_continue_statement] = STATE(40),
    [sym_goto_statement] = STATE(40),
    [sym_seh_try_statement] = STATE(40),
    [sym_seh_leave_statement] = STATE(40),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(40),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2230),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(40),
    [sym_template_instantiation] = STATE(40),
    [sym_operator_cast] = STATE(7525),
    [sym__constructor_specifiers] = STATE(2230),
    [sym_operator_cast_definition] = STATE(40),
    [sym_operator_cast_declaration] = STATE(40),
    [sym_constructor_or_destructor_definition] = STATE(40),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(40),
    [sym_namespace_alias_definition] = STATE(40),
    [sym_using_declaration] = STATE(40),
    [sym_alias_declaration] = STATE(40),
    [sym_static_assert_declaration] = STATE(40),
    [sym_concept_definition] = STATE(40),
    [sym_for_range_loop] = STATE(40),
    [sym_co_return_statement] = STATE(40),
    [sym_co_yield_statement] = STATE(40),
    [sym_throw_statement] = STATE(40),
    [sym_try_statement] = STATE(40),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7525),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(40),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2230),
    [sym_identifier] = ACTIONS(359),
    [aux_sym_preproc_include_token1] = ACTIONS(361),
    [aux_sym_preproc_def_token1] = ACTIONS(363),
    [aux_sym_preproc_if_token1] = ACTIONS(365),
    [aux_sym_preproc_if_token2] = ACTIONS(433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(369),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(369),
    [aux_sym_preproc_else_token1] = ACTIONS(277),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [sym_preproc_directive] = ACTIONS(371),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym___extension__] = ACTIONS(375),
    [anon_sym_typedef] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(379),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(383),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(389),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(411),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_namespace] = ACTIONS(417),
    [anon_sym_using] = ACTIONS(419),
    [anon_sym_static_assert] = ACTIONS(421),
    [anon_sym_concept] = ACTIONS(423),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [30] = {
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_preproc_else] = STATE(9254),
    [sym_preproc_elif] = STATE(9254),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5457),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2123),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7132),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(41),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3219),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(41),
    [sym_labeled_statement] = STATE(41),
    [sym_expression_statement] = STATE(41),
    [sym_if_statement] = STATE(41),
    [sym_switch_statement] = STATE(41),
    [sym_case_statement] = STATE(41),
    [sym_while_statement] = STATE(41),
    [sym_do_statement] = STATE(41),
    [sym_for_statement] = STATE(41),
    [sym_return_statement] = STATE(41),
    [sym_break_statement] = STATE(41),
    [sym_continue_statement] = STATE(41),
    [sym_goto_statement] = STATE(41),
    [sym_seh_try_statement] = STATE(41),
    [sym_seh_leave_statement] = STATE(41),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2230),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(7525),
    [sym__constructor_specifiers] = STATE(2230),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(41),
    [sym_co_return_statement] = STATE(41),
    [sym_co_yield_statement] = STATE(41),
    [sym_throw_statement] = STATE(41),
    [sym_try_statement] = STATE(41),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7525),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2230),
    [sym_identifier] = ACTIONS(359),
    [aux_sym_preproc_include_token1] = ACTIONS(361),
    [aux_sym_preproc_def_token1] = ACTIONS(363),
    [aux_sym_preproc_if_token1] = ACTIONS(365),
    [aux_sym_preproc_if_token2] = ACTIONS(435),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(369),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(369),
    [aux_sym_preproc_else_token1] = ACTIONS(277),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [sym_preproc_directive] = ACTIONS(371),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym___extension__] = ACTIONS(375),
    [anon_sym_typedef] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(379),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(383),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(389),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(411),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_namespace] = ACTIONS(417),
    [anon_sym_using] = ACTIONS(419),
    [anon_sym_static_assert] = ACTIONS(421),
    [anon_sym_concept] = ACTIONS(423),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [31] = {
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_preproc_else] = STATE(9145),
    [sym_preproc_elif] = STATE(9145),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5457),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2123),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7132),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(30),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3219),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(30),
    [sym_labeled_statement] = STATE(30),
    [sym_expression_statement] = STATE(30),
    [sym_if_statement] = STATE(30),
    [sym_switch_statement] = STATE(30),
    [sym_case_statement] = STATE(30),
    [sym_while_statement] = STATE(30),
    [sym_do_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_return_statement] = STATE(30),
    [sym_break_statement] = STATE(30),
    [sym_continue_statement] = STATE(30),
    [sym_goto_statement] = STATE(30),
    [sym_seh_try_statement] = STATE(30),
    [sym_seh_leave_statement] = STATE(30),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(30),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2230),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(30),
    [sym_template_instantiation] = STATE(30),
    [sym_operator_cast] = STATE(7525),
    [sym__constructor_specifiers] = STATE(2230),
    [sym_operator_cast_definition] = STATE(30),
    [sym_operator_cast_declaration] = STATE(30),
    [sym_constructor_or_destructor_definition] = STATE(30),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_alias_definition] = STATE(30),
    [sym_using_declaration] = STATE(30),
    [sym_alias_declaration] = STATE(30),
    [sym_static_assert_declaration] = STATE(30),
    [sym_concept_definition] = STATE(30),
    [sym_for_range_loop] = STATE(30),
    [sym_co_return_statement] = STATE(30),
    [sym_co_yield_statement] = STATE(30),
    [sym_throw_statement] = STATE(30),
    [sym_try_statement] = STATE(30),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7525),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2230),
    [sym_identifier] = ACTIONS(359),
    [aux_sym_preproc_include_token1] = ACTIONS(361),
    [aux_sym_preproc_def_token1] = ACTIONS(363),
    [aux_sym_preproc_if_token1] = ACTIONS(365),
    [aux_sym_preproc_if_token2] = ACTIONS(437),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(369),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(369),
    [aux_sym_preproc_else_token1] = ACTIONS(277),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [sym_preproc_directive] = ACTIONS(371),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym___extension__] = ACTIONS(375),
    [anon_sym_typedef] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(379),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(383),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(389),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(411),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_namespace] = ACTIONS(417),
    [anon_sym_using] = ACTIONS(419),
    [anon_sym_static_assert] = ACTIONS(421),
    [anon_sym_concept] = ACTIONS(423),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [32] = {
    [sym_preproc_include] = STATE(32),
    [sym_preproc_def] = STATE(32),
    [sym_preproc_function_def] = STATE(32),
    [sym_preproc_call] = STATE(32),
    [sym_preproc_if] = STATE(32),
    [sym_preproc_ifdef] = STATE(32),
    [sym_function_definition] = STATE(32),
    [sym_declaration] = STATE(32),
    [sym_type_definition] = STATE(32),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5497),
    [sym_linkage_specification] = STATE(32),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2132),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7154),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(32),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3222),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(32),
    [sym_labeled_statement] = STATE(32),
    [sym_expression_statement] = STATE(32),
    [sym_if_statement] = STATE(32),
    [sym_switch_statement] = STATE(32),
    [sym_case_statement] = STATE(32),
    [sym_while_statement] = STATE(32),
    [sym_do_statement] = STATE(32),
    [sym_for_statement] = STATE(32),
    [sym_return_statement] = STATE(32),
    [sym_break_statement] = STATE(32),
    [sym_continue_statement] = STATE(32),
    [sym_goto_statement] = STATE(32),
    [sym_seh_try_statement] = STATE(32),
    [sym_seh_leave_statement] = STATE(32),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(32),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2232),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(32),
    [sym_template_instantiation] = STATE(32),
    [sym_operator_cast] = STATE(7547),
    [sym__constructor_specifiers] = STATE(2232),
    [sym_operator_cast_definition] = STATE(32),
    [sym_operator_cast_declaration] = STATE(32),
    [sym_constructor_or_destructor_definition] = STATE(32),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(32),
    [sym_namespace_alias_definition] = STATE(32),
    [sym_using_declaration] = STATE(32),
    [sym_alias_declaration] = STATE(32),
    [sym_static_assert_declaration] = STATE(32),
    [sym_concept_definition] = STATE(32),
    [sym_for_range_loop] = STATE(32),
    [sym_co_return_statement] = STATE(32),
    [sym_co_yield_statement] = STATE(32),
    [sym_throw_statement] = STATE(32),
    [sym_try_statement] = STATE(32),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7547),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(32),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2232),
    [sym_identifier] = ACTIONS(439),
    [aux_sym_preproc_include_token1] = ACTIONS(442),
    [aux_sym_preproc_def_token1] = ACTIONS(445),
    [aux_sym_preproc_if_token1] = ACTIONS(448),
    [aux_sym_preproc_if_token2] = ACTIONS(451),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(453),
    [aux_sym_preproc_else_token1] = ACTIONS(451),
    [aux_sym_preproc_elif_token1] = ACTIONS(451),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(451),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(451),
    [sym_preproc_directive] = ACTIONS(456),
    [anon_sym_LPAREN2] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(462),
    [anon_sym_TILDE] = ACTIONS(465),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(474),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_SEMI] = ACTIONS(480),
    [anon_sym___extension__] = ACTIONS(483),
    [anon_sym_typedef] = ACTIONS(486),
    [anon_sym_extern] = ACTIONS(489),
    [anon_sym___attribute__] = ACTIONS(492),
    [anon_sym_COLON_COLON] = ACTIONS(495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(498),
    [anon_sym___declspec] = ACTIONS(501),
    [anon_sym___based] = ACTIONS(504),
    [anon_sym___cdecl] = ACTIONS(507),
    [anon_sym___clrcall] = ACTIONS(507),
    [anon_sym___stdcall] = ACTIONS(507),
    [anon_sym___fastcall] = ACTIONS(507),
    [anon_sym___thiscall] = ACTIONS(507),
    [anon_sym___vectorcall] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(510),
    [anon_sym_signed] = ACTIONS(513),
    [anon_sym_unsigned] = ACTIONS(513),
    [anon_sym_long] = ACTIONS(513),
    [anon_sym_short] = ACTIONS(513),
    [anon_sym_LBRACK] = ACTIONS(516),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_register] = ACTIONS(519),
    [anon_sym_inline] = ACTIONS(522),
    [anon_sym___inline] = ACTIONS(519),
    [anon_sym___inline__] = ACTIONS(519),
    [anon_sym___forceinline] = ACTIONS(519),
    [anon_sym_thread_local] = ACTIONS(519),
    [anon_sym___thread] = ACTIONS(519),
    [anon_sym_const] = ACTIONS(525),
    [anon_sym_constexpr] = ACTIONS(525),
    [anon_sym_volatile] = ACTIONS(525),
    [anon_sym_restrict] = ACTIONS(525),
    [anon_sym___restrict__] = ACTIONS(525),
    [anon_sym__Atomic] = ACTIONS(525),
    [anon_sym__Noreturn] = ACTIONS(525),
    [anon_sym_noreturn] = ACTIONS(525),
    [anon_sym_mutable] = ACTIONS(525),
    [anon_sym_constinit] = ACTIONS(525),
    [anon_sym_consteval] = ACTIONS(525),
    [anon_sym_PROGMEM] = ACTIONS(525),
    [aux_sym_primitive_type_token1] = ACTIONS(528),
    [anon_sym_byte] = ACTIONS(528),
    [anon_sym_word] = ACTIONS(528),
    [anon_sym_enum] = ACTIONS(531),
    [anon_sym_class] = ACTIONS(534),
    [anon_sym_struct] = ACTIONS(537),
    [anon_sym_union] = ACTIONS(540),
    [anon_sym_if] = ACTIONS(543),
    [anon_sym_switch] = ACTIONS(546),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(558),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_return] = ACTIONS(564),
    [anon_sym_break] = ACTIONS(567),
    [anon_sym_continue] = ACTIONS(570),
    [anon_sym_goto] = ACTIONS(573),
    [anon_sym___try] = ACTIONS(576),
    [anon_sym___leave] = ACTIONS(579),
    [anon_sym_not] = ACTIONS(468),
    [anon_sym_compl] = ACTIONS(468),
    [anon_sym_DASH_DASH] = ACTIONS(582),
    [anon_sym_PLUS_PLUS] = ACTIONS(582),
    [anon_sym_sizeof] = ACTIONS(585),
    [anon_sym___alignof__] = ACTIONS(588),
    [anon_sym___alignof] = ACTIONS(588),
    [anon_sym__alignof] = ACTIONS(588),
    [anon_sym_alignof] = ACTIONS(588),
    [anon_sym__Alignof] = ACTIONS(588),
    [anon_sym_offsetof] = ACTIONS(591),
    [anon_sym__Generic] = ACTIONS(594),
    [anon_sym_asm] = ACTIONS(597),
    [anon_sym___asm__] = ACTIONS(597),
    [aux_sym_number_literal_token1] = ACTIONS(600),
    [aux_sym_number_literal_token2] = ACTIONS(603),
    [anon_sym_L_SQUOTE] = ACTIONS(606),
    [anon_sym_u_SQUOTE] = ACTIONS(606),
    [anon_sym_U_SQUOTE] = ACTIONS(606),
    [anon_sym_u8_SQUOTE] = ACTIONS(606),
    [anon_sym_SQUOTE] = ACTIONS(606),
    [anon_sym_L_DQUOTE] = ACTIONS(609),
    [anon_sym_u_DQUOTE] = ACTIONS(609),
    [anon_sym_U_DQUOTE] = ACTIONS(609),
    [anon_sym_u8_DQUOTE] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(609),
    [sym_true] = ACTIONS(612),
    [sym_false] = ACTIONS(612),
    [anon_sym_NULL] = ACTIONS(615),
    [anon_sym_nullptr] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(618),
    [anon_sym_decltype] = ACTIONS(621),
    [anon_sym_virtual] = ACTIONS(624),
    [anon_sym_alignas] = ACTIONS(627),
    [anon_sym_explicit] = ACTIONS(630),
    [anon_sym_typename] = ACTIONS(633),
    [anon_sym_template] = ACTIONS(636),
    [anon_sym_operator] = ACTIONS(639),
    [anon_sym_try] = ACTIONS(642),
    [anon_sym_delete] = ACTIONS(645),
    [anon_sym_throw] = ACTIONS(648),
    [anon_sym_namespace] = ACTIONS(651),
    [anon_sym_using] = ACTIONS(654),
    [anon_sym_static_assert] = ACTIONS(657),
    [anon_sym_concept] = ACTIONS(660),
    [anon_sym_co_return] = ACTIONS(663),
    [anon_sym_co_yield] = ACTIONS(666),
    [anon_sym_R_DQUOTE] = ACTIONS(669),
    [anon_sym_LR_DQUOTE] = ACTIONS(669),
    [anon_sym_uR_DQUOTE] = ACTIONS(669),
    [anon_sym_UR_DQUOTE] = ACTIONS(669),
    [anon_sym_u8R_DQUOTE] = ACTIONS(669),
    [anon_sym_co_await] = ACTIONS(672),
    [anon_sym_new] = ACTIONS(675),
    [anon_sym_requires] = ACTIONS(678),
    [sym_this] = ACTIONS(612),
  },
  [33] = {
    [sym_preproc_include] = STATE(35),
    [sym_preproc_def] = STATE(35),
    [sym_preproc_function_def] = STATE(35),
    [sym_preproc_call] = STATE(35),
    [sym_preproc_if] = STATE(35),
    [sym_preproc_ifdef] = STATE(35),
    [sym_preproc_else] = STATE(9319),
    [sym_preproc_elif] = STATE(9319),
    [sym_function_definition] = STATE(35),
    [sym_declaration] = STATE(35),
    [sym_type_definition] = STATE(35),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5457),
    [sym_linkage_specification] = STATE(35),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2123),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7132),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(35),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3219),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(35),
    [sym_labeled_statement] = STATE(35),
    [sym_expression_statement] = STATE(35),
    [sym_if_statement] = STATE(35),
    [sym_switch_statement] = STATE(35),
    [sym_case_statement] = STATE(35),
    [sym_while_statement] = STATE(35),
    [sym_do_statement] = STATE(35),
    [sym_for_statement] = STATE(35),
    [sym_return_statement] = STATE(35),
    [sym_break_statement] = STATE(35),
    [sym_continue_statement] = STATE(35),
    [sym_goto_statement] = STATE(35),
    [sym_seh_try_statement] = STATE(35),
    [sym_seh_leave_statement] = STATE(35),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(35),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2230),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(35),
    [sym_template_instantiation] = STATE(35),
    [sym_operator_cast] = STATE(7525),
    [sym__constructor_specifiers] = STATE(2230),
    [sym_operator_cast_definition] = STATE(35),
    [sym_operator_cast_declaration] = STATE(35),
    [sym_constructor_or_destructor_definition] = STATE(35),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(35),
    [sym_namespace_alias_definition] = STATE(35),
    [sym_using_declaration] = STATE(35),
    [sym_alias_declaration] = STATE(35),
    [sym_static_assert_declaration] = STATE(35),
    [sym_concept_definition] = STATE(35),
    [sym_for_range_loop] = STATE(35),
    [sym_co_return_statement] = STATE(35),
    [sym_co_yield_statement] = STATE(35),
    [sym_throw_statement] = STATE(35),
    [sym_try_statement] = STATE(35),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7525),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(35),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2230),
    [sym_identifier] = ACTIONS(359),
    [aux_sym_preproc_include_token1] = ACTIONS(361),
    [aux_sym_preproc_def_token1] = ACTIONS(363),
    [aux_sym_preproc_if_token1] = ACTIONS(365),
    [aux_sym_preproc_if_token2] = ACTIONS(681),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(369),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(369),
    [aux_sym_preproc_else_token1] = ACTIONS(277),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [sym_preproc_directive] = ACTIONS(371),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym___extension__] = ACTIONS(375),
    [anon_sym_typedef] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(379),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(383),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(389),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(411),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_namespace] = ACTIONS(417),
    [anon_sym_using] = ACTIONS(419),
    [anon_sym_static_assert] = ACTIONS(421),
    [anon_sym_concept] = ACTIONS(423),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [34] = {
    [sym_preproc_include] = STATE(36),
    [sym_preproc_def] = STATE(36),
    [sym_preproc_function_def] = STATE(36),
    [sym_preproc_call] = STATE(36),
    [sym_preproc_if] = STATE(36),
    [sym_preproc_ifdef] = STATE(36),
    [sym_preproc_else] = STATE(9024),
    [sym_preproc_elif] = STATE(9024),
    [sym_function_definition] = STATE(36),
    [sym_declaration] = STATE(36),
    [sym_type_definition] = STATE(36),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5457),
    [sym_linkage_specification] = STATE(36),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2123),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7132),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(36),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3219),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(36),
    [sym_labeled_statement] = STATE(36),
    [sym_expression_statement] = STATE(36),
    [sym_if_statement] = STATE(36),
    [sym_switch_statement] = STATE(36),
    [sym_case_statement] = STATE(36),
    [sym_while_statement] = STATE(36),
    [sym_do_statement] = STATE(36),
    [sym_for_statement] = STATE(36),
    [sym_return_statement] = STATE(36),
    [sym_break_statement] = STATE(36),
    [sym_continue_statement] = STATE(36),
    [sym_goto_statement] = STATE(36),
    [sym_seh_try_statement] = STATE(36),
    [sym_seh_leave_statement] = STATE(36),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(36),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2230),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(36),
    [sym_template_instantiation] = STATE(36),
    [sym_operator_cast] = STATE(7525),
    [sym__constructor_specifiers] = STATE(2230),
    [sym_operator_cast_definition] = STATE(36),
    [sym_operator_cast_declaration] = STATE(36),
    [sym_constructor_or_destructor_definition] = STATE(36),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(36),
    [sym_namespace_alias_definition] = STATE(36),
    [sym_using_declaration] = STATE(36),
    [sym_alias_declaration] = STATE(36),
    [sym_static_assert_declaration] = STATE(36),
    [sym_concept_definition] = STATE(36),
    [sym_for_range_loop] = STATE(36),
    [sym_co_return_statement] = STATE(36),
    [sym_co_yield_statement] = STATE(36),
    [sym_throw_statement] = STATE(36),
    [sym_try_statement] = STATE(36),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7525),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(36),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2230),
    [sym_identifier] = ACTIONS(359),
    [aux_sym_preproc_include_token1] = ACTIONS(361),
    [aux_sym_preproc_def_token1] = ACTIONS(363),
    [aux_sym_preproc_if_token1] = ACTIONS(365),
    [aux_sym_preproc_if_token2] = ACTIONS(683),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(369),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(369),
    [aux_sym_preproc_else_token1] = ACTIONS(277),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [sym_preproc_directive] = ACTIONS(371),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym___extension__] = ACTIONS(375),
    [anon_sym_typedef] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(379),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(383),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(389),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(411),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_namespace] = ACTIONS(417),
    [anon_sym_using] = ACTIONS(419),
    [anon_sym_static_assert] = ACTIONS(421),
    [anon_sym_concept] = ACTIONS(423),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [35] = {
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_preproc_else] = STATE(9390),
    [sym_preproc_elif] = STATE(9390),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5457),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2123),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7132),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(41),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3219),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(41),
    [sym_labeled_statement] = STATE(41),
    [sym_expression_statement] = STATE(41),
    [sym_if_statement] = STATE(41),
    [sym_switch_statement] = STATE(41),
    [sym_case_statement] = STATE(41),
    [sym_while_statement] = STATE(41),
    [sym_do_statement] = STATE(41),
    [sym_for_statement] = STATE(41),
    [sym_return_statement] = STATE(41),
    [sym_break_statement] = STATE(41),
    [sym_continue_statement] = STATE(41),
    [sym_goto_statement] = STATE(41),
    [sym_seh_try_statement] = STATE(41),
    [sym_seh_leave_statement] = STATE(41),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2230),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(7525),
    [sym__constructor_specifiers] = STATE(2230),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(41),
    [sym_co_return_statement] = STATE(41),
    [sym_co_yield_statement] = STATE(41),
    [sym_throw_statement] = STATE(41),
    [sym_try_statement] = STATE(41),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7525),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2230),
    [sym_identifier] = ACTIONS(359),
    [aux_sym_preproc_include_token1] = ACTIONS(361),
    [aux_sym_preproc_def_token1] = ACTIONS(363),
    [aux_sym_preproc_if_token1] = ACTIONS(365),
    [aux_sym_preproc_if_token2] = ACTIONS(685),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(369),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(369),
    [aux_sym_preproc_else_token1] = ACTIONS(277),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [sym_preproc_directive] = ACTIONS(371),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym___extension__] = ACTIONS(375),
    [anon_sym_typedef] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(379),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(383),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(389),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(411),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_namespace] = ACTIONS(417),
    [anon_sym_using] = ACTIONS(419),
    [anon_sym_static_assert] = ACTIONS(421),
    [anon_sym_concept] = ACTIONS(423),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [36] = {
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_preproc_else] = STATE(9036),
    [sym_preproc_elif] = STATE(9036),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5457),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2123),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7132),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(41),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3219),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(41),
    [sym_labeled_statement] = STATE(41),
    [sym_expression_statement] = STATE(41),
    [sym_if_statement] = STATE(41),
    [sym_switch_statement] = STATE(41),
    [sym_case_statement] = STATE(41),
    [sym_while_statement] = STATE(41),
    [sym_do_statement] = STATE(41),
    [sym_for_statement] = STATE(41),
    [sym_return_statement] = STATE(41),
    [sym_break_statement] = STATE(41),
    [sym_continue_statement] = STATE(41),
    [sym_goto_statement] = STATE(41),
    [sym_seh_try_statement] = STATE(41),
    [sym_seh_leave_statement] = STATE(41),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2230),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(7525),
    [sym__constructor_specifiers] = STATE(2230),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(41),
    [sym_co_return_statement] = STATE(41),
    [sym_co_yield_statement] = STATE(41),
    [sym_throw_statement] = STATE(41),
    [sym_try_statement] = STATE(41),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7525),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2230),
    [sym_identifier] = ACTIONS(359),
    [aux_sym_preproc_include_token1] = ACTIONS(361),
    [aux_sym_preproc_def_token1] = ACTIONS(363),
    [aux_sym_preproc_if_token1] = ACTIONS(365),
    [aux_sym_preproc_if_token2] = ACTIONS(687),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(369),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(369),
    [aux_sym_preproc_else_token1] = ACTIONS(277),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [sym_preproc_directive] = ACTIONS(371),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym___extension__] = ACTIONS(375),
    [anon_sym_typedef] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(379),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(383),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(389),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(411),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_namespace] = ACTIONS(417),
    [anon_sym_using] = ACTIONS(419),
    [anon_sym_static_assert] = ACTIONS(421),
    [anon_sym_concept] = ACTIONS(423),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [37] = {
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_preproc_else] = STATE(8884),
    [sym_preproc_elif] = STATE(8884),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5457),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2123),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7132),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(41),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3219),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(41),
    [sym_labeled_statement] = STATE(41),
    [sym_expression_statement] = STATE(41),
    [sym_if_statement] = STATE(41),
    [sym_switch_statement] = STATE(41),
    [sym_case_statement] = STATE(41),
    [sym_while_statement] = STATE(41),
    [sym_do_statement] = STATE(41),
    [sym_for_statement] = STATE(41),
    [sym_return_statement] = STATE(41),
    [sym_break_statement] = STATE(41),
    [sym_continue_statement] = STATE(41),
    [sym_goto_statement] = STATE(41),
    [sym_seh_try_statement] = STATE(41),
    [sym_seh_leave_statement] = STATE(41),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2230),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(7525),
    [sym__constructor_specifiers] = STATE(2230),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(41),
    [sym_co_return_statement] = STATE(41),
    [sym_co_yield_statement] = STATE(41),
    [sym_throw_statement] = STATE(41),
    [sym_try_statement] = STATE(41),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7525),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2230),
    [sym_identifier] = ACTIONS(359),
    [aux_sym_preproc_include_token1] = ACTIONS(361),
    [aux_sym_preproc_def_token1] = ACTIONS(363),
    [aux_sym_preproc_if_token1] = ACTIONS(365),
    [aux_sym_preproc_if_token2] = ACTIONS(689),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(369),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(369),
    [aux_sym_preproc_else_token1] = ACTIONS(277),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [sym_preproc_directive] = ACTIONS(371),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym___extension__] = ACTIONS(375),
    [anon_sym_typedef] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(379),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(383),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(389),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(411),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_namespace] = ACTIONS(417),
    [anon_sym_using] = ACTIONS(419),
    [anon_sym_static_assert] = ACTIONS(421),
    [anon_sym_concept] = ACTIONS(423),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [38] = {
    [sym_preproc_include] = STATE(39),
    [sym_preproc_def] = STATE(39),
    [sym_preproc_function_def] = STATE(39),
    [sym_preproc_call] = STATE(39),
    [sym_preproc_if] = STATE(39),
    [sym_preproc_ifdef] = STATE(39),
    [sym_preproc_else] = STATE(9290),
    [sym_preproc_elif] = STATE(9290),
    [sym_function_definition] = STATE(39),
    [sym_declaration] = STATE(39),
    [sym_type_definition] = STATE(39),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5457),
    [sym_linkage_specification] = STATE(39),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2123),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7132),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(39),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3219),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(39),
    [sym_labeled_statement] = STATE(39),
    [sym_expression_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_switch_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_do_statement] = STATE(39),
    [sym_for_statement] = STATE(39),
    [sym_return_statement] = STATE(39),
    [sym_break_statement] = STATE(39),
    [sym_continue_statement] = STATE(39),
    [sym_goto_statement] = STATE(39),
    [sym_seh_try_statement] = STATE(39),
    [sym_seh_leave_statement] = STATE(39),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(39),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2230),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(39),
    [sym_template_instantiation] = STATE(39),
    [sym_operator_cast] = STATE(7525),
    [sym__constructor_specifiers] = STATE(2230),
    [sym_operator_cast_definition] = STATE(39),
    [sym_operator_cast_declaration] = STATE(39),
    [sym_constructor_or_destructor_definition] = STATE(39),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(39),
    [sym_namespace_alias_definition] = STATE(39),
    [sym_using_declaration] = STATE(39),
    [sym_alias_declaration] = STATE(39),
    [sym_static_assert_declaration] = STATE(39),
    [sym_concept_definition] = STATE(39),
    [sym_for_range_loop] = STATE(39),
    [sym_co_return_statement] = STATE(39),
    [sym_co_yield_statement] = STATE(39),
    [sym_throw_statement] = STATE(39),
    [sym_try_statement] = STATE(39),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7525),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(39),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2230),
    [sym_identifier] = ACTIONS(359),
    [aux_sym_preproc_include_token1] = ACTIONS(361),
    [aux_sym_preproc_def_token1] = ACTIONS(363),
    [aux_sym_preproc_if_token1] = ACTIONS(365),
    [aux_sym_preproc_if_token2] = ACTIONS(691),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(369),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(369),
    [aux_sym_preproc_else_token1] = ACTIONS(277),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [sym_preproc_directive] = ACTIONS(371),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym___extension__] = ACTIONS(375),
    [anon_sym_typedef] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(379),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(383),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(389),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(411),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_namespace] = ACTIONS(417),
    [anon_sym_using] = ACTIONS(419),
    [anon_sym_static_assert] = ACTIONS(421),
    [anon_sym_concept] = ACTIONS(423),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [39] = {
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_preproc_else] = STATE(9393),
    [sym_preproc_elif] = STATE(9393),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5457),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2123),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7132),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(41),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3219),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(41),
    [sym_labeled_statement] = STATE(41),
    [sym_expression_statement] = STATE(41),
    [sym_if_statement] = STATE(41),
    [sym_switch_statement] = STATE(41),
    [sym_case_statement] = STATE(41),
    [sym_while_statement] = STATE(41),
    [sym_do_statement] = STATE(41),
    [sym_for_statement] = STATE(41),
    [sym_return_statement] = STATE(41),
    [sym_break_statement] = STATE(41),
    [sym_continue_statement] = STATE(41),
    [sym_goto_statement] = STATE(41),
    [sym_seh_try_statement] = STATE(41),
    [sym_seh_leave_statement] = STATE(41),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2230),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(7525),
    [sym__constructor_specifiers] = STATE(2230),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(41),
    [sym_co_return_statement] = STATE(41),
    [sym_co_yield_statement] = STATE(41),
    [sym_throw_statement] = STATE(41),
    [sym_try_statement] = STATE(41),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7525),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2230),
    [sym_identifier] = ACTIONS(359),
    [aux_sym_preproc_include_token1] = ACTIONS(361),
    [aux_sym_preproc_def_token1] = ACTIONS(363),
    [aux_sym_preproc_if_token1] = ACTIONS(365),
    [aux_sym_preproc_if_token2] = ACTIONS(693),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(369),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(369),
    [aux_sym_preproc_else_token1] = ACTIONS(277),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [sym_preproc_directive] = ACTIONS(371),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym___extension__] = ACTIONS(375),
    [anon_sym_typedef] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(379),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(383),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(389),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(411),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_namespace] = ACTIONS(417),
    [anon_sym_using] = ACTIONS(419),
    [anon_sym_static_assert] = ACTIONS(421),
    [anon_sym_concept] = ACTIONS(423),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [40] = {
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_preproc_else] = STATE(9320),
    [sym_preproc_elif] = STATE(9320),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5457),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2123),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7132),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(41),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3219),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(41),
    [sym_labeled_statement] = STATE(41),
    [sym_expression_statement] = STATE(41),
    [sym_if_statement] = STATE(41),
    [sym_switch_statement] = STATE(41),
    [sym_case_statement] = STATE(41),
    [sym_while_statement] = STATE(41),
    [sym_do_statement] = STATE(41),
    [sym_for_statement] = STATE(41),
    [sym_return_statement] = STATE(41),
    [sym_break_statement] = STATE(41),
    [sym_continue_statement] = STATE(41),
    [sym_goto_statement] = STATE(41),
    [sym_seh_try_statement] = STATE(41),
    [sym_seh_leave_statement] = STATE(41),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2230),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(7525),
    [sym__constructor_specifiers] = STATE(2230),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(41),
    [sym_co_return_statement] = STATE(41),
    [sym_co_yield_statement] = STATE(41),
    [sym_throw_statement] = STATE(41),
    [sym_try_statement] = STATE(41),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7525),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2230),
    [sym_identifier] = ACTIONS(359),
    [aux_sym_preproc_include_token1] = ACTIONS(361),
    [aux_sym_preproc_def_token1] = ACTIONS(363),
    [aux_sym_preproc_if_token1] = ACTIONS(365),
    [aux_sym_preproc_if_token2] = ACTIONS(695),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(369),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(369),
    [aux_sym_preproc_else_token1] = ACTIONS(277),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [sym_preproc_directive] = ACTIONS(371),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym___extension__] = ACTIONS(375),
    [anon_sym_typedef] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(379),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(383),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(389),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(411),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_namespace] = ACTIONS(417),
    [anon_sym_using] = ACTIONS(419),
    [anon_sym_static_assert] = ACTIONS(421),
    [anon_sym_concept] = ACTIONS(423),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [41] = {
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5457),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2123),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7132),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(41),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3219),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(41),
    [sym_labeled_statement] = STATE(41),
    [sym_expression_statement] = STATE(41),
    [sym_if_statement] = STATE(41),
    [sym_switch_statement] = STATE(41),
    [sym_case_statement] = STATE(41),
    [sym_while_statement] = STATE(41),
    [sym_do_statement] = STATE(41),
    [sym_for_statement] = STATE(41),
    [sym_return_statement] = STATE(41),
    [sym_break_statement] = STATE(41),
    [sym_continue_statement] = STATE(41),
    [sym_goto_statement] = STATE(41),
    [sym_seh_try_statement] = STATE(41),
    [sym_seh_leave_statement] = STATE(41),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2230),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(7525),
    [sym__constructor_specifiers] = STATE(2230),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(41),
    [sym_co_return_statement] = STATE(41),
    [sym_co_yield_statement] = STATE(41),
    [sym_throw_statement] = STATE(41),
    [sym_try_statement] = STATE(41),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7525),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2230),
    [sym_identifier] = ACTIONS(697),
    [aux_sym_preproc_include_token1] = ACTIONS(700),
    [aux_sym_preproc_def_token1] = ACTIONS(703),
    [aux_sym_preproc_if_token1] = ACTIONS(706),
    [aux_sym_preproc_if_token2] = ACTIONS(451),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(709),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(709),
    [aux_sym_preproc_else_token1] = ACTIONS(451),
    [aux_sym_preproc_elif_token1] = ACTIONS(451),
    [sym_preproc_directive] = ACTIONS(712),
    [anon_sym_LPAREN2] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(462),
    [anon_sym_TILDE] = ACTIONS(465),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(474),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_SEMI] = ACTIONS(715),
    [anon_sym___extension__] = ACTIONS(718),
    [anon_sym_typedef] = ACTIONS(721),
    [anon_sym_extern] = ACTIONS(724),
    [anon_sym___attribute__] = ACTIONS(492),
    [anon_sym_COLON_COLON] = ACTIONS(495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(498),
    [anon_sym___declspec] = ACTIONS(501),
    [anon_sym___based] = ACTIONS(504),
    [anon_sym___cdecl] = ACTIONS(507),
    [anon_sym___clrcall] = ACTIONS(507),
    [anon_sym___stdcall] = ACTIONS(507),
    [anon_sym___fastcall] = ACTIONS(507),
    [anon_sym___thiscall] = ACTIONS(507),
    [anon_sym___vectorcall] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_signed] = ACTIONS(513),
    [anon_sym_unsigned] = ACTIONS(513),
    [anon_sym_long] = ACTIONS(513),
    [anon_sym_short] = ACTIONS(513),
    [anon_sym_LBRACK] = ACTIONS(516),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_register] = ACTIONS(519),
    [anon_sym_inline] = ACTIONS(730),
    [anon_sym___inline] = ACTIONS(519),
    [anon_sym___inline__] = ACTIONS(519),
    [anon_sym___forceinline] = ACTIONS(519),
    [anon_sym_thread_local] = ACTIONS(519),
    [anon_sym___thread] = ACTIONS(519),
    [anon_sym_const] = ACTIONS(525),
    [anon_sym_constexpr] = ACTIONS(525),
    [anon_sym_volatile] = ACTIONS(525),
    [anon_sym_restrict] = ACTIONS(525),
    [anon_sym___restrict__] = ACTIONS(525),
    [anon_sym__Atomic] = ACTIONS(525),
    [anon_sym__Noreturn] = ACTIONS(525),
    [anon_sym_noreturn] = ACTIONS(525),
    [anon_sym_mutable] = ACTIONS(525),
    [anon_sym_constinit] = ACTIONS(525),
    [anon_sym_consteval] = ACTIONS(525),
    [anon_sym_PROGMEM] = ACTIONS(525),
    [aux_sym_primitive_type_token1] = ACTIONS(528),
    [anon_sym_byte] = ACTIONS(528),
    [anon_sym_word] = ACTIONS(528),
    [anon_sym_enum] = ACTIONS(531),
    [anon_sym_class] = ACTIONS(534),
    [anon_sym_struct] = ACTIONS(537),
    [anon_sym_union] = ACTIONS(540),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_switch] = ACTIONS(736),
    [anon_sym_case] = ACTIONS(739),
    [anon_sym_default] = ACTIONS(742),
    [anon_sym_while] = ACTIONS(745),
    [anon_sym_do] = ACTIONS(748),
    [anon_sym_for] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(754),
    [anon_sym_break] = ACTIONS(757),
    [anon_sym_continue] = ACTIONS(760),
    [anon_sym_goto] = ACTIONS(763),
    [anon_sym___try] = ACTIONS(766),
    [anon_sym___leave] = ACTIONS(769),
    [anon_sym_not] = ACTIONS(468),
    [anon_sym_compl] = ACTIONS(468),
    [anon_sym_DASH_DASH] = ACTIONS(582),
    [anon_sym_PLUS_PLUS] = ACTIONS(582),
    [anon_sym_sizeof] = ACTIONS(585),
    [anon_sym___alignof__] = ACTIONS(588),
    [anon_sym___alignof] = ACTIONS(588),
    [anon_sym__alignof] = ACTIONS(588),
    [anon_sym_alignof] = ACTIONS(588),
    [anon_sym__Alignof] = ACTIONS(588),
    [anon_sym_offsetof] = ACTIONS(591),
    [anon_sym__Generic] = ACTIONS(594),
    [anon_sym_asm] = ACTIONS(597),
    [anon_sym___asm__] = ACTIONS(597),
    [aux_sym_number_literal_token1] = ACTIONS(600),
    [aux_sym_number_literal_token2] = ACTIONS(603),
    [anon_sym_L_SQUOTE] = ACTIONS(606),
    [anon_sym_u_SQUOTE] = ACTIONS(606),
    [anon_sym_U_SQUOTE] = ACTIONS(606),
    [anon_sym_u8_SQUOTE] = ACTIONS(606),
    [anon_sym_SQUOTE] = ACTIONS(606),
    [anon_sym_L_DQUOTE] = ACTIONS(609),
    [anon_sym_u_DQUOTE] = ACTIONS(609),
    [anon_sym_U_DQUOTE] = ACTIONS(609),
    [anon_sym_u8_DQUOTE] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(609),
    [sym_true] = ACTIONS(612),
    [sym_false] = ACTIONS(612),
    [anon_sym_NULL] = ACTIONS(615),
    [anon_sym_nullptr] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(618),
    [anon_sym_decltype] = ACTIONS(621),
    [anon_sym_virtual] = ACTIONS(624),
    [anon_sym_alignas] = ACTIONS(627),
    [anon_sym_explicit] = ACTIONS(630),
    [anon_sym_typename] = ACTIONS(633),
    [anon_sym_template] = ACTIONS(772),
    [anon_sym_operator] = ACTIONS(639),
    [anon_sym_try] = ACTIONS(775),
    [anon_sym_delete] = ACTIONS(645),
    [anon_sym_throw] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(781),
    [anon_sym_using] = ACTIONS(784),
    [anon_sym_static_assert] = ACTIONS(787),
    [anon_sym_concept] = ACTIONS(790),
    [anon_sym_co_return] = ACTIONS(793),
    [anon_sym_co_yield] = ACTIONS(796),
    [anon_sym_R_DQUOTE] = ACTIONS(669),
    [anon_sym_LR_DQUOTE] = ACTIONS(669),
    [anon_sym_uR_DQUOTE] = ACTIONS(669),
    [anon_sym_UR_DQUOTE] = ACTIONS(669),
    [anon_sym_u8R_DQUOTE] = ACTIONS(669),
    [anon_sym_co_await] = ACTIONS(672),
    [anon_sym_new] = ACTIONS(675),
    [anon_sym_requires] = ACTIONS(678),
    [sym_this] = ACTIONS(612),
  },
  [42] = {
    [sym_preproc_include] = STATE(48),
    [sym_preproc_def] = STATE(48),
    [sym_preproc_function_def] = STATE(48),
    [sym_preproc_call] = STATE(48),
    [sym_preproc_if] = STATE(48),
    [sym_preproc_ifdef] = STATE(48),
    [sym_function_definition] = STATE(48),
    [sym_declaration] = STATE(48),
    [sym_type_definition] = STATE(48),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(48),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(48),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(48),
    [sym_labeled_statement] = STATE(48),
    [sym_expression_statement] = STATE(48),
    [sym_if_statement] = STATE(48),
    [sym_switch_statement] = STATE(48),
    [sym_case_statement] = STATE(48),
    [sym_while_statement] = STATE(48),
    [sym_do_statement] = STATE(48),
    [sym_for_statement] = STATE(48),
    [sym_return_statement] = STATE(48),
    [sym_break_statement] = STATE(48),
    [sym_continue_statement] = STATE(48),
    [sym_goto_statement] = STATE(48),
    [sym_seh_try_statement] = STATE(48),
    [sym_seh_leave_statement] = STATE(48),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(48),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(48),
    [sym_template_instantiation] = STATE(48),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(48),
    [sym_operator_cast_declaration] = STATE(48),
    [sym_constructor_or_destructor_definition] = STATE(48),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(48),
    [sym_namespace_alias_definition] = STATE(48),
    [sym_using_declaration] = STATE(48),
    [sym_alias_declaration] = STATE(48),
    [sym_static_assert_declaration] = STATE(48),
    [sym_concept_definition] = STATE(48),
    [sym_for_range_loop] = STATE(48),
    [sym_co_return_statement] = STATE(48),
    [sym_co_yield_statement] = STATE(48),
    [sym_throw_statement] = STATE(48),
    [sym_try_statement] = STATE(48),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(48),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(803),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [43] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(805),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [44] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(807),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [45] = {
    [sym_preproc_include] = STATE(44),
    [sym_preproc_def] = STATE(44),
    [sym_preproc_function_def] = STATE(44),
    [sym_preproc_call] = STATE(44),
    [sym_preproc_if] = STATE(44),
    [sym_preproc_ifdef] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_declaration] = STATE(44),
    [sym_type_definition] = STATE(44),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(44),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(44),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(44),
    [sym_labeled_statement] = STATE(44),
    [sym_expression_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_switch_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_do_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_return_statement] = STATE(44),
    [sym_break_statement] = STATE(44),
    [sym_continue_statement] = STATE(44),
    [sym_goto_statement] = STATE(44),
    [sym_seh_try_statement] = STATE(44),
    [sym_seh_leave_statement] = STATE(44),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(44),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(44),
    [sym_template_instantiation] = STATE(44),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(44),
    [sym_operator_cast_declaration] = STATE(44),
    [sym_constructor_or_destructor_definition] = STATE(44),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(44),
    [sym_namespace_alias_definition] = STATE(44),
    [sym_using_declaration] = STATE(44),
    [sym_alias_declaration] = STATE(44),
    [sym_static_assert_declaration] = STATE(44),
    [sym_concept_definition] = STATE(44),
    [sym_for_range_loop] = STATE(44),
    [sym_co_return_statement] = STATE(44),
    [sym_co_yield_statement] = STATE(44),
    [sym_throw_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(44),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(809),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [46] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(811),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [47] = {
    [sym_preproc_include] = STATE(46),
    [sym_preproc_def] = STATE(46),
    [sym_preproc_function_def] = STATE(46),
    [sym_preproc_call] = STATE(46),
    [sym_preproc_if] = STATE(46),
    [sym_preproc_ifdef] = STATE(46),
    [sym_function_definition] = STATE(46),
    [sym_declaration] = STATE(46),
    [sym_type_definition] = STATE(46),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(46),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(46),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(46),
    [sym_labeled_statement] = STATE(46),
    [sym_expression_statement] = STATE(46),
    [sym_if_statement] = STATE(46),
    [sym_switch_statement] = STATE(46),
    [sym_case_statement] = STATE(46),
    [sym_while_statement] = STATE(46),
    [sym_do_statement] = STATE(46),
    [sym_for_statement] = STATE(46),
    [sym_return_statement] = STATE(46),
    [sym_break_statement] = STATE(46),
    [sym_continue_statement] = STATE(46),
    [sym_goto_statement] = STATE(46),
    [sym_seh_try_statement] = STATE(46),
    [sym_seh_leave_statement] = STATE(46),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(46),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(46),
    [sym_template_instantiation] = STATE(46),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(46),
    [sym_operator_cast_declaration] = STATE(46),
    [sym_constructor_or_destructor_definition] = STATE(46),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(46),
    [sym_namespace_alias_definition] = STATE(46),
    [sym_using_declaration] = STATE(46),
    [sym_alias_declaration] = STATE(46),
    [sym_static_assert_declaration] = STATE(46),
    [sym_concept_definition] = STATE(46),
    [sym_for_range_loop] = STATE(46),
    [sym_co_return_statement] = STATE(46),
    [sym_co_yield_statement] = STATE(46),
    [sym_throw_statement] = STATE(46),
    [sym_try_statement] = STATE(46),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(46),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(813),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [48] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [49] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(817),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [50] = {
    [sym_preproc_include] = STATE(49),
    [sym_preproc_def] = STATE(49),
    [sym_preproc_function_def] = STATE(49),
    [sym_preproc_call] = STATE(49),
    [sym_preproc_if] = STATE(49),
    [sym_preproc_ifdef] = STATE(49),
    [sym_function_definition] = STATE(49),
    [sym_declaration] = STATE(49),
    [sym_type_definition] = STATE(49),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(49),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(49),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(49),
    [sym_labeled_statement] = STATE(49),
    [sym_expression_statement] = STATE(49),
    [sym_if_statement] = STATE(49),
    [sym_switch_statement] = STATE(49),
    [sym_case_statement] = STATE(49),
    [sym_while_statement] = STATE(49),
    [sym_do_statement] = STATE(49),
    [sym_for_statement] = STATE(49),
    [sym_return_statement] = STATE(49),
    [sym_break_statement] = STATE(49),
    [sym_continue_statement] = STATE(49),
    [sym_goto_statement] = STATE(49),
    [sym_seh_try_statement] = STATE(49),
    [sym_seh_leave_statement] = STATE(49),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(49),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(49),
    [sym_template_instantiation] = STATE(49),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(49),
    [sym_operator_cast_declaration] = STATE(49),
    [sym_constructor_or_destructor_definition] = STATE(49),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(49),
    [sym_namespace_alias_definition] = STATE(49),
    [sym_using_declaration] = STATE(49),
    [sym_alias_declaration] = STATE(49),
    [sym_static_assert_declaration] = STATE(49),
    [sym_concept_definition] = STATE(49),
    [sym_for_range_loop] = STATE(49),
    [sym_co_return_statement] = STATE(49),
    [sym_co_yield_statement] = STATE(49),
    [sym_throw_statement] = STATE(49),
    [sym_try_statement] = STATE(49),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(49),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(819),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [51] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(821),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [52] = {
    [sym_preproc_include] = STATE(51),
    [sym_preproc_def] = STATE(51),
    [sym_preproc_function_def] = STATE(51),
    [sym_preproc_call] = STATE(51),
    [sym_preproc_if] = STATE(51),
    [sym_preproc_ifdef] = STATE(51),
    [sym_function_definition] = STATE(51),
    [sym_declaration] = STATE(51),
    [sym_type_definition] = STATE(51),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(51),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(51),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(51),
    [sym_labeled_statement] = STATE(51),
    [sym_expression_statement] = STATE(51),
    [sym_if_statement] = STATE(51),
    [sym_switch_statement] = STATE(51),
    [sym_case_statement] = STATE(51),
    [sym_while_statement] = STATE(51),
    [sym_do_statement] = STATE(51),
    [sym_for_statement] = STATE(51),
    [sym_return_statement] = STATE(51),
    [sym_break_statement] = STATE(51),
    [sym_continue_statement] = STATE(51),
    [sym_goto_statement] = STATE(51),
    [sym_seh_try_statement] = STATE(51),
    [sym_seh_leave_statement] = STATE(51),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(51),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(51),
    [sym_template_instantiation] = STATE(51),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(51),
    [sym_operator_cast_declaration] = STATE(51),
    [sym_constructor_or_destructor_definition] = STATE(51),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(51),
    [sym_namespace_alias_definition] = STATE(51),
    [sym_using_declaration] = STATE(51),
    [sym_alias_declaration] = STATE(51),
    [sym_static_assert_declaration] = STATE(51),
    [sym_concept_definition] = STATE(51),
    [sym_for_range_loop] = STATE(51),
    [sym_co_return_statement] = STATE(51),
    [sym_co_yield_statement] = STATE(51),
    [sym_throw_statement] = STATE(51),
    [sym_try_statement] = STATE(51),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(51),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(823),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [53] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(825),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [54] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(827),
    [aux_sym_preproc_include_token1] = ACTIONS(830),
    [aux_sym_preproc_def_token1] = ACTIONS(833),
    [aux_sym_preproc_if_token1] = ACTIONS(836),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(839),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(839),
    [sym_preproc_directive] = ACTIONS(842),
    [anon_sym_LPAREN2] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(462),
    [anon_sym_TILDE] = ACTIONS(465),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(474),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_SEMI] = ACTIONS(845),
    [anon_sym___extension__] = ACTIONS(848),
    [anon_sym_typedef] = ACTIONS(851),
    [anon_sym_extern] = ACTIONS(854),
    [anon_sym___attribute__] = ACTIONS(492),
    [anon_sym_COLON_COLON] = ACTIONS(495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(498),
    [anon_sym___declspec] = ACTIONS(501),
    [anon_sym___based] = ACTIONS(504),
    [anon_sym___cdecl] = ACTIONS(507),
    [anon_sym___clrcall] = ACTIONS(507),
    [anon_sym___stdcall] = ACTIONS(507),
    [anon_sym___fastcall] = ACTIONS(507),
    [anon_sym___thiscall] = ACTIONS(507),
    [anon_sym___vectorcall] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(857),
    [anon_sym_RBRACE] = ACTIONS(860),
    [anon_sym_signed] = ACTIONS(513),
    [anon_sym_unsigned] = ACTIONS(513),
    [anon_sym_long] = ACTIONS(513),
    [anon_sym_short] = ACTIONS(513),
    [anon_sym_LBRACK] = ACTIONS(516),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_register] = ACTIONS(519),
    [anon_sym_inline] = ACTIONS(862),
    [anon_sym___inline] = ACTIONS(519),
    [anon_sym___inline__] = ACTIONS(519),
    [anon_sym___forceinline] = ACTIONS(519),
    [anon_sym_thread_local] = ACTIONS(519),
    [anon_sym___thread] = ACTIONS(519),
    [anon_sym_const] = ACTIONS(525),
    [anon_sym_constexpr] = ACTIONS(525),
    [anon_sym_volatile] = ACTIONS(525),
    [anon_sym_restrict] = ACTIONS(525),
    [anon_sym___restrict__] = ACTIONS(525),
    [anon_sym__Atomic] = ACTIONS(525),
    [anon_sym__Noreturn] = ACTIONS(525),
    [anon_sym_noreturn] = ACTIONS(525),
    [anon_sym_mutable] = ACTIONS(525),
    [anon_sym_constinit] = ACTIONS(525),
    [anon_sym_consteval] = ACTIONS(525),
    [anon_sym_PROGMEM] = ACTIONS(525),
    [aux_sym_primitive_type_token1] = ACTIONS(528),
    [anon_sym_byte] = ACTIONS(528),
    [anon_sym_word] = ACTIONS(528),
    [anon_sym_enum] = ACTIONS(531),
    [anon_sym_class] = ACTIONS(534),
    [anon_sym_struct] = ACTIONS(537),
    [anon_sym_union] = ACTIONS(540),
    [anon_sym_if] = ACTIONS(865),
    [anon_sym_switch] = ACTIONS(868),
    [anon_sym_case] = ACTIONS(871),
    [anon_sym_default] = ACTIONS(874),
    [anon_sym_while] = ACTIONS(877),
    [anon_sym_do] = ACTIONS(880),
    [anon_sym_for] = ACTIONS(883),
    [anon_sym_return] = ACTIONS(886),
    [anon_sym_break] = ACTIONS(889),
    [anon_sym_continue] = ACTIONS(892),
    [anon_sym_goto] = ACTIONS(895),
    [anon_sym___try] = ACTIONS(898),
    [anon_sym___leave] = ACTIONS(901),
    [anon_sym_not] = ACTIONS(468),
    [anon_sym_compl] = ACTIONS(468),
    [anon_sym_DASH_DASH] = ACTIONS(582),
    [anon_sym_PLUS_PLUS] = ACTIONS(582),
    [anon_sym_sizeof] = ACTIONS(585),
    [anon_sym___alignof__] = ACTIONS(588),
    [anon_sym___alignof] = ACTIONS(588),
    [anon_sym__alignof] = ACTIONS(588),
    [anon_sym_alignof] = ACTIONS(588),
    [anon_sym__Alignof] = ACTIONS(588),
    [anon_sym_offsetof] = ACTIONS(591),
    [anon_sym__Generic] = ACTIONS(594),
    [anon_sym_asm] = ACTIONS(597),
    [anon_sym___asm__] = ACTIONS(597),
    [aux_sym_number_literal_token1] = ACTIONS(600),
    [aux_sym_number_literal_token2] = ACTIONS(603),
    [anon_sym_L_SQUOTE] = ACTIONS(606),
    [anon_sym_u_SQUOTE] = ACTIONS(606),
    [anon_sym_U_SQUOTE] = ACTIONS(606),
    [anon_sym_u8_SQUOTE] = ACTIONS(606),
    [anon_sym_SQUOTE] = ACTIONS(606),
    [anon_sym_L_DQUOTE] = ACTIONS(609),
    [anon_sym_u_DQUOTE] = ACTIONS(609),
    [anon_sym_U_DQUOTE] = ACTIONS(609),
    [anon_sym_u8_DQUOTE] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(609),
    [sym_true] = ACTIONS(612),
    [sym_false] = ACTIONS(612),
    [anon_sym_NULL] = ACTIONS(615),
    [anon_sym_nullptr] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(618),
    [anon_sym_decltype] = ACTIONS(621),
    [anon_sym_virtual] = ACTIONS(624),
    [anon_sym_alignas] = ACTIONS(627),
    [anon_sym_explicit] = ACTIONS(630),
    [anon_sym_typename] = ACTIONS(633),
    [anon_sym_template] = ACTIONS(904),
    [anon_sym_operator] = ACTIONS(639),
    [anon_sym_try] = ACTIONS(907),
    [anon_sym_delete] = ACTIONS(645),
    [anon_sym_throw] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(913),
    [anon_sym_using] = ACTIONS(916),
    [anon_sym_static_assert] = ACTIONS(919),
    [anon_sym_concept] = ACTIONS(922),
    [anon_sym_co_return] = ACTIONS(925),
    [anon_sym_co_yield] = ACTIONS(928),
    [anon_sym_R_DQUOTE] = ACTIONS(669),
    [anon_sym_LR_DQUOTE] = ACTIONS(669),
    [anon_sym_uR_DQUOTE] = ACTIONS(669),
    [anon_sym_UR_DQUOTE] = ACTIONS(669),
    [anon_sym_u8R_DQUOTE] = ACTIONS(669),
    [anon_sym_co_await] = ACTIONS(672),
    [anon_sym_new] = ACTIONS(675),
    [anon_sym_requires] = ACTIONS(678),
    [sym_this] = ACTIONS(612),
  },
  [55] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(931),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [56] = {
    [sym_preproc_include] = STATE(55),
    [sym_preproc_def] = STATE(55),
    [sym_preproc_function_def] = STATE(55),
    [sym_preproc_call] = STATE(55),
    [sym_preproc_if] = STATE(55),
    [sym_preproc_ifdef] = STATE(55),
    [sym_function_definition] = STATE(55),
    [sym_declaration] = STATE(55),
    [sym_type_definition] = STATE(55),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(55),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(55),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(55),
    [sym_labeled_statement] = STATE(55),
    [sym_expression_statement] = STATE(55),
    [sym_if_statement] = STATE(55),
    [sym_switch_statement] = STATE(55),
    [sym_case_statement] = STATE(55),
    [sym_while_statement] = STATE(55),
    [sym_do_statement] = STATE(55),
    [sym_for_statement] = STATE(55),
    [sym_return_statement] = STATE(55),
    [sym_break_statement] = STATE(55),
    [sym_continue_statement] = STATE(55),
    [sym_goto_statement] = STATE(55),
    [sym_seh_try_statement] = STATE(55),
    [sym_seh_leave_statement] = STATE(55),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(55),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(55),
    [sym_template_instantiation] = STATE(55),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(55),
    [sym_operator_cast_declaration] = STATE(55),
    [sym_constructor_or_destructor_definition] = STATE(55),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(55),
    [sym_namespace_alias_definition] = STATE(55),
    [sym_using_declaration] = STATE(55),
    [sym_alias_declaration] = STATE(55),
    [sym_static_assert_declaration] = STATE(55),
    [sym_concept_definition] = STATE(55),
    [sym_for_range_loop] = STATE(55),
    [sym_co_return_statement] = STATE(55),
    [sym_co_yield_statement] = STATE(55),
    [sym_throw_statement] = STATE(55),
    [sym_try_statement] = STATE(55),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(55),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(933),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [57] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [58] = {
    [sym_preproc_include] = STATE(57),
    [sym_preproc_def] = STATE(57),
    [sym_preproc_function_def] = STATE(57),
    [sym_preproc_call] = STATE(57),
    [sym_preproc_if] = STATE(57),
    [sym_preproc_ifdef] = STATE(57),
    [sym_function_definition] = STATE(57),
    [sym_declaration] = STATE(57),
    [sym_type_definition] = STATE(57),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(57),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(57),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(57),
    [sym_labeled_statement] = STATE(57),
    [sym_expression_statement] = STATE(57),
    [sym_if_statement] = STATE(57),
    [sym_switch_statement] = STATE(57),
    [sym_case_statement] = STATE(57),
    [sym_while_statement] = STATE(57),
    [sym_do_statement] = STATE(57),
    [sym_for_statement] = STATE(57),
    [sym_return_statement] = STATE(57),
    [sym_break_statement] = STATE(57),
    [sym_continue_statement] = STATE(57),
    [sym_goto_statement] = STATE(57),
    [sym_seh_try_statement] = STATE(57),
    [sym_seh_leave_statement] = STATE(57),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(57),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(57),
    [sym_template_instantiation] = STATE(57),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(57),
    [sym_operator_cast_declaration] = STATE(57),
    [sym_constructor_or_destructor_definition] = STATE(57),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(57),
    [sym_namespace_alias_definition] = STATE(57),
    [sym_using_declaration] = STATE(57),
    [sym_alias_declaration] = STATE(57),
    [sym_static_assert_declaration] = STATE(57),
    [sym_concept_definition] = STATE(57),
    [sym_for_range_loop] = STATE(57),
    [sym_co_return_statement] = STATE(57),
    [sym_co_yield_statement] = STATE(57),
    [sym_throw_statement] = STATE(57),
    [sym_try_statement] = STATE(57),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(57),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(937),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [59] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [60] = {
    [sym_preproc_include] = STATE(61),
    [sym_preproc_def] = STATE(61),
    [sym_preproc_function_def] = STATE(61),
    [sym_preproc_call] = STATE(61),
    [sym_preproc_if] = STATE(61),
    [sym_preproc_ifdef] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_declaration] = STATE(61),
    [sym_type_definition] = STATE(61),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(61),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(61),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(61),
    [sym_labeled_statement] = STATE(61),
    [sym_expression_statement] = STATE(61),
    [sym_if_statement] = STATE(61),
    [sym_switch_statement] = STATE(61),
    [sym_case_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_do_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_return_statement] = STATE(61),
    [sym_break_statement] = STATE(61),
    [sym_continue_statement] = STATE(61),
    [sym_goto_statement] = STATE(61),
    [sym_seh_try_statement] = STATE(61),
    [sym_seh_leave_statement] = STATE(61),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(61),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(61),
    [sym_template_instantiation] = STATE(61),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(61),
    [sym_operator_cast_declaration] = STATE(61),
    [sym_constructor_or_destructor_definition] = STATE(61),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(61),
    [sym_namespace_alias_definition] = STATE(61),
    [sym_using_declaration] = STATE(61),
    [sym_alias_declaration] = STATE(61),
    [sym_static_assert_declaration] = STATE(61),
    [sym_concept_definition] = STATE(61),
    [sym_for_range_loop] = STATE(61),
    [sym_co_return_statement] = STATE(61),
    [sym_co_yield_statement] = STATE(61),
    [sym_throw_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(61),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(941),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [61] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(943),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [62] = {
    [sym_preproc_include] = STATE(96),
    [sym_preproc_def] = STATE(96),
    [sym_preproc_function_def] = STATE(96),
    [sym_preproc_call] = STATE(96),
    [sym_preproc_if] = STATE(96),
    [sym_preproc_ifdef] = STATE(96),
    [sym_function_definition] = STATE(96),
    [sym_declaration] = STATE(96),
    [sym_type_definition] = STATE(96),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(96),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(96),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(96),
    [sym_labeled_statement] = STATE(96),
    [sym_expression_statement] = STATE(96),
    [sym_if_statement] = STATE(96),
    [sym_switch_statement] = STATE(96),
    [sym_case_statement] = STATE(96),
    [sym_while_statement] = STATE(96),
    [sym_do_statement] = STATE(96),
    [sym_for_statement] = STATE(96),
    [sym_return_statement] = STATE(96),
    [sym_break_statement] = STATE(96),
    [sym_continue_statement] = STATE(96),
    [sym_goto_statement] = STATE(96),
    [sym_seh_try_statement] = STATE(96),
    [sym_seh_leave_statement] = STATE(96),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(96),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(96),
    [sym_template_instantiation] = STATE(96),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(96),
    [sym_operator_cast_declaration] = STATE(96),
    [sym_constructor_or_destructor_definition] = STATE(96),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(96),
    [sym_namespace_alias_definition] = STATE(96),
    [sym_using_declaration] = STATE(96),
    [sym_alias_declaration] = STATE(96),
    [sym_static_assert_declaration] = STATE(96),
    [sym_concept_definition] = STATE(96),
    [sym_for_range_loop] = STATE(96),
    [sym_co_return_statement] = STATE(96),
    [sym_co_yield_statement] = STATE(96),
    [sym_throw_statement] = STATE(96),
    [sym_try_statement] = STATE(96),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(945),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [63] = {
    [sym_preproc_include] = STATE(59),
    [sym_preproc_def] = STATE(59),
    [sym_preproc_function_def] = STATE(59),
    [sym_preproc_call] = STATE(59),
    [sym_preproc_if] = STATE(59),
    [sym_preproc_ifdef] = STATE(59),
    [sym_function_definition] = STATE(59),
    [sym_declaration] = STATE(59),
    [sym_type_definition] = STATE(59),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(59),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(59),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(59),
    [sym_labeled_statement] = STATE(59),
    [sym_expression_statement] = STATE(59),
    [sym_if_statement] = STATE(59),
    [sym_switch_statement] = STATE(59),
    [sym_case_statement] = STATE(59),
    [sym_while_statement] = STATE(59),
    [sym_do_statement] = STATE(59),
    [sym_for_statement] = STATE(59),
    [sym_return_statement] = STATE(59),
    [sym_break_statement] = STATE(59),
    [sym_continue_statement] = STATE(59),
    [sym_goto_statement] = STATE(59),
    [sym_seh_try_statement] = STATE(59),
    [sym_seh_leave_statement] = STATE(59),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(59),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(59),
    [sym_template_instantiation] = STATE(59),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(59),
    [sym_operator_cast_declaration] = STATE(59),
    [sym_constructor_or_destructor_definition] = STATE(59),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(59),
    [sym_namespace_alias_definition] = STATE(59),
    [sym_using_declaration] = STATE(59),
    [sym_alias_declaration] = STATE(59),
    [sym_static_assert_declaration] = STATE(59),
    [sym_concept_definition] = STATE(59),
    [sym_for_range_loop] = STATE(59),
    [sym_co_return_statement] = STATE(59),
    [sym_co_yield_statement] = STATE(59),
    [sym_throw_statement] = STATE(59),
    [sym_try_statement] = STATE(59),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(59),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [64] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [65] = {
    [sym_preproc_include] = STATE(64),
    [sym_preproc_def] = STATE(64),
    [sym_preproc_function_def] = STATE(64),
    [sym_preproc_call] = STATE(64),
    [sym_preproc_if] = STATE(64),
    [sym_preproc_ifdef] = STATE(64),
    [sym_function_definition] = STATE(64),
    [sym_declaration] = STATE(64),
    [sym_type_definition] = STATE(64),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(64),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(64),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(64),
    [sym_labeled_statement] = STATE(64),
    [sym_expression_statement] = STATE(64),
    [sym_if_statement] = STATE(64),
    [sym_switch_statement] = STATE(64),
    [sym_case_statement] = STATE(64),
    [sym_while_statement] = STATE(64),
    [sym_do_statement] = STATE(64),
    [sym_for_statement] = STATE(64),
    [sym_return_statement] = STATE(64),
    [sym_break_statement] = STATE(64),
    [sym_continue_statement] = STATE(64),
    [sym_goto_statement] = STATE(64),
    [sym_seh_try_statement] = STATE(64),
    [sym_seh_leave_statement] = STATE(64),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(64),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(64),
    [sym_template_instantiation] = STATE(64),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(64),
    [sym_operator_cast_declaration] = STATE(64),
    [sym_constructor_or_destructor_definition] = STATE(64),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(64),
    [sym_namespace_alias_definition] = STATE(64),
    [sym_using_declaration] = STATE(64),
    [sym_alias_declaration] = STATE(64),
    [sym_static_assert_declaration] = STATE(64),
    [sym_concept_definition] = STATE(64),
    [sym_for_range_loop] = STATE(64),
    [sym_co_return_statement] = STATE(64),
    [sym_co_yield_statement] = STATE(64),
    [sym_throw_statement] = STATE(64),
    [sym_try_statement] = STATE(64),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(64),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(951),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [66] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(953),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [67] = {
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(53),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(53),
    [sym_labeled_statement] = STATE(53),
    [sym_expression_statement] = STATE(53),
    [sym_if_statement] = STATE(53),
    [sym_switch_statement] = STATE(53),
    [sym_case_statement] = STATE(53),
    [sym_while_statement] = STATE(53),
    [sym_do_statement] = STATE(53),
    [sym_for_statement] = STATE(53),
    [sym_return_statement] = STATE(53),
    [sym_break_statement] = STATE(53),
    [sym_continue_statement] = STATE(53),
    [sym_goto_statement] = STATE(53),
    [sym_seh_try_statement] = STATE(53),
    [sym_seh_leave_statement] = STATE(53),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(53),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(53),
    [sym_template_instantiation] = STATE(53),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(53),
    [sym_operator_cast_declaration] = STATE(53),
    [sym_constructor_or_destructor_definition] = STATE(53),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(53),
    [sym_namespace_alias_definition] = STATE(53),
    [sym_using_declaration] = STATE(53),
    [sym_alias_declaration] = STATE(53),
    [sym_static_assert_declaration] = STATE(53),
    [sym_concept_definition] = STATE(53),
    [sym_for_range_loop] = STATE(53),
    [sym_co_return_statement] = STATE(53),
    [sym_co_yield_statement] = STATE(53),
    [sym_throw_statement] = STATE(53),
    [sym_try_statement] = STATE(53),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(955),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [68] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(957),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [69] = {
    [sym_preproc_include] = STATE(68),
    [sym_preproc_def] = STATE(68),
    [sym_preproc_function_def] = STATE(68),
    [sym_preproc_call] = STATE(68),
    [sym_preproc_if] = STATE(68),
    [sym_preproc_ifdef] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_declaration] = STATE(68),
    [sym_type_definition] = STATE(68),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(68),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(68),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(68),
    [sym_labeled_statement] = STATE(68),
    [sym_expression_statement] = STATE(68),
    [sym_if_statement] = STATE(68),
    [sym_switch_statement] = STATE(68),
    [sym_case_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_do_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_return_statement] = STATE(68),
    [sym_break_statement] = STATE(68),
    [sym_continue_statement] = STATE(68),
    [sym_goto_statement] = STATE(68),
    [sym_seh_try_statement] = STATE(68),
    [sym_seh_leave_statement] = STATE(68),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(68),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(68),
    [sym_template_instantiation] = STATE(68),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(68),
    [sym_operator_cast_declaration] = STATE(68),
    [sym_constructor_or_destructor_definition] = STATE(68),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(68),
    [sym_namespace_alias_definition] = STATE(68),
    [sym_using_declaration] = STATE(68),
    [sym_alias_declaration] = STATE(68),
    [sym_static_assert_declaration] = STATE(68),
    [sym_concept_definition] = STATE(68),
    [sym_for_range_loop] = STATE(68),
    [sym_co_return_statement] = STATE(68),
    [sym_co_yield_statement] = STATE(68),
    [sym_throw_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(68),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(959),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [70] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(961),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [71] = {
    [sym_preproc_include] = STATE(73),
    [sym_preproc_def] = STATE(73),
    [sym_preproc_function_def] = STATE(73),
    [sym_preproc_call] = STATE(73),
    [sym_preproc_if] = STATE(73),
    [sym_preproc_ifdef] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_declaration] = STATE(73),
    [sym_type_definition] = STATE(73),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(73),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(73),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(73),
    [sym_labeled_statement] = STATE(73),
    [sym_expression_statement] = STATE(73),
    [sym_if_statement] = STATE(73),
    [sym_switch_statement] = STATE(73),
    [sym_case_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_do_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_return_statement] = STATE(73),
    [sym_break_statement] = STATE(73),
    [sym_continue_statement] = STATE(73),
    [sym_goto_statement] = STATE(73),
    [sym_seh_try_statement] = STATE(73),
    [sym_seh_leave_statement] = STATE(73),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(73),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(73),
    [sym_template_instantiation] = STATE(73),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(73),
    [sym_operator_cast_declaration] = STATE(73),
    [sym_constructor_or_destructor_definition] = STATE(73),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(73),
    [sym_namespace_alias_definition] = STATE(73),
    [sym_using_declaration] = STATE(73),
    [sym_alias_declaration] = STATE(73),
    [sym_static_assert_declaration] = STATE(73),
    [sym_concept_definition] = STATE(73),
    [sym_for_range_loop] = STATE(73),
    [sym_co_return_statement] = STATE(73),
    [sym_co_yield_statement] = STATE(73),
    [sym_throw_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(73),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(963),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [72] = {
    [sym_preproc_include] = STATE(70),
    [sym_preproc_def] = STATE(70),
    [sym_preproc_function_def] = STATE(70),
    [sym_preproc_call] = STATE(70),
    [sym_preproc_if] = STATE(70),
    [sym_preproc_ifdef] = STATE(70),
    [sym_function_definition] = STATE(70),
    [sym_declaration] = STATE(70),
    [sym_type_definition] = STATE(70),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(70),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(70),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(70),
    [sym_labeled_statement] = STATE(70),
    [sym_expression_statement] = STATE(70),
    [sym_if_statement] = STATE(70),
    [sym_switch_statement] = STATE(70),
    [sym_case_statement] = STATE(70),
    [sym_while_statement] = STATE(70),
    [sym_do_statement] = STATE(70),
    [sym_for_statement] = STATE(70),
    [sym_return_statement] = STATE(70),
    [sym_break_statement] = STATE(70),
    [sym_continue_statement] = STATE(70),
    [sym_goto_statement] = STATE(70),
    [sym_seh_try_statement] = STATE(70),
    [sym_seh_leave_statement] = STATE(70),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(70),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(70),
    [sym_template_instantiation] = STATE(70),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(70),
    [sym_operator_cast_declaration] = STATE(70),
    [sym_constructor_or_destructor_definition] = STATE(70),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(70),
    [sym_namespace_alias_definition] = STATE(70),
    [sym_using_declaration] = STATE(70),
    [sym_alias_declaration] = STATE(70),
    [sym_static_assert_declaration] = STATE(70),
    [sym_concept_definition] = STATE(70),
    [sym_for_range_loop] = STATE(70),
    [sym_co_return_statement] = STATE(70),
    [sym_co_yield_statement] = STATE(70),
    [sym_throw_statement] = STATE(70),
    [sym_try_statement] = STATE(70),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(70),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(965),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [73] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(967),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [74] = {
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(43),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(43),
    [sym_labeled_statement] = STATE(43),
    [sym_expression_statement] = STATE(43),
    [sym_if_statement] = STATE(43),
    [sym_switch_statement] = STATE(43),
    [sym_case_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_do_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_return_statement] = STATE(43),
    [sym_break_statement] = STATE(43),
    [sym_continue_statement] = STATE(43),
    [sym_goto_statement] = STATE(43),
    [sym_seh_try_statement] = STATE(43),
    [sym_seh_leave_statement] = STATE(43),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(43),
    [sym_co_return_statement] = STATE(43),
    [sym_co_yield_statement] = STATE(43),
    [sym_throw_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(969),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [75] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(971),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [76] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [77] = {
    [sym_preproc_include] = STATE(75),
    [sym_preproc_def] = STATE(75),
    [sym_preproc_function_def] = STATE(75),
    [sym_preproc_call] = STATE(75),
    [sym_preproc_if] = STATE(75),
    [sym_preproc_ifdef] = STATE(75),
    [sym_function_definition] = STATE(75),
    [sym_declaration] = STATE(75),
    [sym_type_definition] = STATE(75),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(75),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(75),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(75),
    [sym_labeled_statement] = STATE(75),
    [sym_expression_statement] = STATE(75),
    [sym_if_statement] = STATE(75),
    [sym_switch_statement] = STATE(75),
    [sym_case_statement] = STATE(75),
    [sym_while_statement] = STATE(75),
    [sym_do_statement] = STATE(75),
    [sym_for_statement] = STATE(75),
    [sym_return_statement] = STATE(75),
    [sym_break_statement] = STATE(75),
    [sym_continue_statement] = STATE(75),
    [sym_goto_statement] = STATE(75),
    [sym_seh_try_statement] = STATE(75),
    [sym_seh_leave_statement] = STATE(75),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(75),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(75),
    [sym_template_instantiation] = STATE(75),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(75),
    [sym_operator_cast_declaration] = STATE(75),
    [sym_constructor_or_destructor_definition] = STATE(75),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(75),
    [sym_namespace_alias_definition] = STATE(75),
    [sym_using_declaration] = STATE(75),
    [sym_alias_declaration] = STATE(75),
    [sym_static_assert_declaration] = STATE(75),
    [sym_concept_definition] = STATE(75),
    [sym_for_range_loop] = STATE(75),
    [sym_co_return_statement] = STATE(75),
    [sym_co_yield_statement] = STATE(75),
    [sym_throw_statement] = STATE(75),
    [sym_try_statement] = STATE(75),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(75),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [78] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(977),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [79] = {
    [sym_preproc_include] = STATE(79),
    [sym_preproc_def] = STATE(79),
    [sym_preproc_function_def] = STATE(79),
    [sym_preproc_call] = STATE(79),
    [sym_preproc_if] = STATE(79),
    [sym_preproc_ifdef] = STATE(79),
    [sym_function_definition] = STATE(79),
    [sym_declaration] = STATE(79),
    [sym_type_definition] = STATE(79),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5414),
    [sym_linkage_specification] = STATE(79),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2119),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7123),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(79),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3248),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(79),
    [sym_labeled_statement] = STATE(79),
    [sym_expression_statement] = STATE(79),
    [sym_if_statement] = STATE(79),
    [sym_switch_statement] = STATE(79),
    [sym_case_statement] = STATE(79),
    [sym_while_statement] = STATE(79),
    [sym_do_statement] = STATE(79),
    [sym_for_statement] = STATE(79),
    [sym_return_statement] = STATE(79),
    [sym_break_statement] = STATE(79),
    [sym_continue_statement] = STATE(79),
    [sym_goto_statement] = STATE(79),
    [sym_seh_try_statement] = STATE(79),
    [sym_seh_leave_statement] = STATE(79),
    [sym__expression] = STATE(5326),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9529),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(79),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2238),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(79),
    [sym_template_instantiation] = STATE(79),
    [sym_operator_cast] = STATE(7504),
    [sym__constructor_specifiers] = STATE(2238),
    [sym_operator_cast_definition] = STATE(79),
    [sym_operator_cast_declaration] = STATE(79),
    [sym_constructor_or_destructor_definition] = STATE(79),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(79),
    [sym_namespace_alias_definition] = STATE(79),
    [sym_using_declaration] = STATE(79),
    [sym_alias_declaration] = STATE(79),
    [sym_static_assert_declaration] = STATE(79),
    [sym_concept_definition] = STATE(79),
    [sym_for_range_loop] = STATE(79),
    [sym_co_return_statement] = STATE(79),
    [sym_co_yield_statement] = STATE(79),
    [sym_throw_statement] = STATE(79),
    [sym_try_statement] = STATE(79),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7504),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(79),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2238),
    [sym_identifier] = ACTIONS(979),
    [aux_sym_preproc_include_token1] = ACTIONS(982),
    [aux_sym_preproc_def_token1] = ACTIONS(985),
    [aux_sym_preproc_if_token1] = ACTIONS(988),
    [aux_sym_preproc_if_token2] = ACTIONS(451),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(991),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(991),
    [sym_preproc_directive] = ACTIONS(994),
    [anon_sym_LPAREN2] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(462),
    [anon_sym_TILDE] = ACTIONS(465),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(474),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym___extension__] = ACTIONS(1000),
    [anon_sym_typedef] = ACTIONS(1003),
    [anon_sym_extern] = ACTIONS(1006),
    [anon_sym___attribute__] = ACTIONS(492),
    [anon_sym_COLON_COLON] = ACTIONS(495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(498),
    [anon_sym___declspec] = ACTIONS(501),
    [anon_sym___based] = ACTIONS(504),
    [anon_sym___cdecl] = ACTIONS(507),
    [anon_sym___clrcall] = ACTIONS(507),
    [anon_sym___stdcall] = ACTIONS(507),
    [anon_sym___fastcall] = ACTIONS(507),
    [anon_sym___thiscall] = ACTIONS(507),
    [anon_sym___vectorcall] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(1009),
    [anon_sym_signed] = ACTIONS(513),
    [anon_sym_unsigned] = ACTIONS(513),
    [anon_sym_long] = ACTIONS(513),
    [anon_sym_short] = ACTIONS(513),
    [anon_sym_LBRACK] = ACTIONS(516),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_register] = ACTIONS(519),
    [anon_sym_inline] = ACTIONS(1012),
    [anon_sym___inline] = ACTIONS(519),
    [anon_sym___inline__] = ACTIONS(519),
    [anon_sym___forceinline] = ACTIONS(519),
    [anon_sym_thread_local] = ACTIONS(519),
    [anon_sym___thread] = ACTIONS(519),
    [anon_sym_const] = ACTIONS(525),
    [anon_sym_constexpr] = ACTIONS(525),
    [anon_sym_volatile] = ACTIONS(525),
    [anon_sym_restrict] = ACTIONS(525),
    [anon_sym___restrict__] = ACTIONS(525),
    [anon_sym__Atomic] = ACTIONS(525),
    [anon_sym__Noreturn] = ACTIONS(525),
    [anon_sym_noreturn] = ACTIONS(525),
    [anon_sym_mutable] = ACTIONS(525),
    [anon_sym_constinit] = ACTIONS(525),
    [anon_sym_consteval] = ACTIONS(525),
    [anon_sym_PROGMEM] = ACTIONS(525),
    [aux_sym_primitive_type_token1] = ACTIONS(528),
    [anon_sym_byte] = ACTIONS(528),
    [anon_sym_word] = ACTIONS(528),
    [anon_sym_enum] = ACTIONS(531),
    [anon_sym_class] = ACTIONS(534),
    [anon_sym_struct] = ACTIONS(537),
    [anon_sym_union] = ACTIONS(540),
    [anon_sym_if] = ACTIONS(1015),
    [anon_sym_switch] = ACTIONS(1018),
    [anon_sym_case] = ACTIONS(1021),
    [anon_sym_default] = ACTIONS(1024),
    [anon_sym_while] = ACTIONS(1027),
    [anon_sym_do] = ACTIONS(1030),
    [anon_sym_for] = ACTIONS(1033),
    [anon_sym_return] = ACTIONS(1036),
    [anon_sym_break] = ACTIONS(1039),
    [anon_sym_continue] = ACTIONS(1042),
    [anon_sym_goto] = ACTIONS(1045),
    [anon_sym___try] = ACTIONS(1048),
    [anon_sym___leave] = ACTIONS(1051),
    [anon_sym_not] = ACTIONS(468),
    [anon_sym_compl] = ACTIONS(468),
    [anon_sym_DASH_DASH] = ACTIONS(582),
    [anon_sym_PLUS_PLUS] = ACTIONS(582),
    [anon_sym_sizeof] = ACTIONS(585),
    [anon_sym___alignof__] = ACTIONS(588),
    [anon_sym___alignof] = ACTIONS(588),
    [anon_sym__alignof] = ACTIONS(588),
    [anon_sym_alignof] = ACTIONS(588),
    [anon_sym__Alignof] = ACTIONS(588),
    [anon_sym_offsetof] = ACTIONS(591),
    [anon_sym__Generic] = ACTIONS(594),
    [anon_sym_asm] = ACTIONS(597),
    [anon_sym___asm__] = ACTIONS(597),
    [aux_sym_number_literal_token1] = ACTIONS(600),
    [aux_sym_number_literal_token2] = ACTIONS(603),
    [anon_sym_L_SQUOTE] = ACTIONS(606),
    [anon_sym_u_SQUOTE] = ACTIONS(606),
    [anon_sym_U_SQUOTE] = ACTIONS(606),
    [anon_sym_u8_SQUOTE] = ACTIONS(606),
    [anon_sym_SQUOTE] = ACTIONS(606),
    [anon_sym_L_DQUOTE] = ACTIONS(609),
    [anon_sym_u_DQUOTE] = ACTIONS(609),
    [anon_sym_U_DQUOTE] = ACTIONS(609),
    [anon_sym_u8_DQUOTE] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(609),
    [sym_true] = ACTIONS(612),
    [sym_false] = ACTIONS(612),
    [anon_sym_NULL] = ACTIONS(615),
    [anon_sym_nullptr] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(618),
    [anon_sym_decltype] = ACTIONS(621),
    [anon_sym_virtual] = ACTIONS(624),
    [anon_sym_alignas] = ACTIONS(627),
    [anon_sym_explicit] = ACTIONS(630),
    [anon_sym_typename] = ACTIONS(633),
    [anon_sym_template] = ACTIONS(1054),
    [anon_sym_operator] = ACTIONS(639),
    [anon_sym_try] = ACTIONS(1057),
    [anon_sym_delete] = ACTIONS(645),
    [anon_sym_throw] = ACTIONS(1060),
    [anon_sym_namespace] = ACTIONS(1063),
    [anon_sym_using] = ACTIONS(1066),
    [anon_sym_static_assert] = ACTIONS(1069),
    [anon_sym_concept] = ACTIONS(1072),
    [anon_sym_co_return] = ACTIONS(1075),
    [anon_sym_co_yield] = ACTIONS(1078),
    [anon_sym_R_DQUOTE] = ACTIONS(669),
    [anon_sym_LR_DQUOTE] = ACTIONS(669),
    [anon_sym_uR_DQUOTE] = ACTIONS(669),
    [anon_sym_UR_DQUOTE] = ACTIONS(669),
    [anon_sym_u8R_DQUOTE] = ACTIONS(669),
    [anon_sym_co_await] = ACTIONS(672),
    [anon_sym_new] = ACTIONS(675),
    [anon_sym_requires] = ACTIONS(678),
    [sym_this] = ACTIONS(612),
  },
  [80] = {
    [sym_preproc_include] = STATE(81),
    [sym_preproc_def] = STATE(81),
    [sym_preproc_function_def] = STATE(81),
    [sym_preproc_call] = STATE(81),
    [sym_preproc_if] = STATE(81),
    [sym_preproc_ifdef] = STATE(81),
    [sym_function_definition] = STATE(81),
    [sym_declaration] = STATE(81),
    [sym_type_definition] = STATE(81),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(81),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(81),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(81),
    [sym_labeled_statement] = STATE(81),
    [sym_expression_statement] = STATE(81),
    [sym_if_statement] = STATE(81),
    [sym_switch_statement] = STATE(81),
    [sym_case_statement] = STATE(81),
    [sym_while_statement] = STATE(81),
    [sym_do_statement] = STATE(81),
    [sym_for_statement] = STATE(81),
    [sym_return_statement] = STATE(81),
    [sym_break_statement] = STATE(81),
    [sym_continue_statement] = STATE(81),
    [sym_goto_statement] = STATE(81),
    [sym_seh_try_statement] = STATE(81),
    [sym_seh_leave_statement] = STATE(81),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(81),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(81),
    [sym_template_instantiation] = STATE(81),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(81),
    [sym_operator_cast_declaration] = STATE(81),
    [sym_constructor_or_destructor_definition] = STATE(81),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(81),
    [sym_namespace_alias_definition] = STATE(81),
    [sym_using_declaration] = STATE(81),
    [sym_alias_declaration] = STATE(81),
    [sym_static_assert_declaration] = STATE(81),
    [sym_concept_definition] = STATE(81),
    [sym_for_range_loop] = STATE(81),
    [sym_co_return_statement] = STATE(81),
    [sym_co_yield_statement] = STATE(81),
    [sym_throw_statement] = STATE(81),
    [sym_try_statement] = STATE(81),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(81),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [81] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(1083),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [82] = {
    [sym_preproc_include] = STATE(91),
    [sym_preproc_def] = STATE(91),
    [sym_preproc_function_def] = STATE(91),
    [sym_preproc_call] = STATE(91),
    [sym_preproc_if] = STATE(91),
    [sym_preproc_ifdef] = STATE(91),
    [sym_function_definition] = STATE(91),
    [sym_declaration] = STATE(91),
    [sym_type_definition] = STATE(91),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(91),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(91),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(91),
    [sym_labeled_statement] = STATE(91),
    [sym_expression_statement] = STATE(91),
    [sym_if_statement] = STATE(91),
    [sym_switch_statement] = STATE(91),
    [sym_case_statement] = STATE(91),
    [sym_while_statement] = STATE(91),
    [sym_do_statement] = STATE(91),
    [sym_for_statement] = STATE(91),
    [sym_return_statement] = STATE(91),
    [sym_break_statement] = STATE(91),
    [sym_continue_statement] = STATE(91),
    [sym_goto_statement] = STATE(91),
    [sym_seh_try_statement] = STATE(91),
    [sym_seh_leave_statement] = STATE(91),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(91),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(91),
    [sym_template_instantiation] = STATE(91),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(91),
    [sym_operator_cast_declaration] = STATE(91),
    [sym_constructor_or_destructor_definition] = STATE(91),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(91),
    [sym_namespace_alias_definition] = STATE(91),
    [sym_using_declaration] = STATE(91),
    [sym_alias_declaration] = STATE(91),
    [sym_static_assert_declaration] = STATE(91),
    [sym_concept_definition] = STATE(91),
    [sym_for_range_loop] = STATE(91),
    [sym_co_return_statement] = STATE(91),
    [sym_co_yield_statement] = STATE(91),
    [sym_throw_statement] = STATE(91),
    [sym_try_statement] = STATE(91),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(91),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(1085),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [83] = {
    [sym_preproc_include] = STATE(66),
    [sym_preproc_def] = STATE(66),
    [sym_preproc_function_def] = STATE(66),
    [sym_preproc_call] = STATE(66),
    [sym_preproc_if] = STATE(66),
    [sym_preproc_ifdef] = STATE(66),
    [sym_function_definition] = STATE(66),
    [sym_declaration] = STATE(66),
    [sym_type_definition] = STATE(66),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(66),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(66),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(66),
    [sym_labeled_statement] = STATE(66),
    [sym_expression_statement] = STATE(66),
    [sym_if_statement] = STATE(66),
    [sym_switch_statement] = STATE(66),
    [sym_case_statement] = STATE(66),
    [sym_while_statement] = STATE(66),
    [sym_do_statement] = STATE(66),
    [sym_for_statement] = STATE(66),
    [sym_return_statement] = STATE(66),
    [sym_break_statement] = STATE(66),
    [sym_continue_statement] = STATE(66),
    [sym_goto_statement] = STATE(66),
    [sym_seh_try_statement] = STATE(66),
    [sym_seh_leave_statement] = STATE(66),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(66),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(66),
    [sym_template_instantiation] = STATE(66),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(66),
    [sym_operator_cast_declaration] = STATE(66),
    [sym_constructor_or_destructor_definition] = STATE(66),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(66),
    [sym_namespace_alias_definition] = STATE(66),
    [sym_using_declaration] = STATE(66),
    [sym_alias_declaration] = STATE(66),
    [sym_static_assert_declaration] = STATE(66),
    [sym_concept_definition] = STATE(66),
    [sym_for_range_loop] = STATE(66),
    [sym_co_return_statement] = STATE(66),
    [sym_co_yield_statement] = STATE(66),
    [sym_throw_statement] = STATE(66),
    [sym_try_statement] = STATE(66),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(66),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(1087),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [84] = {
    [sym_preproc_include] = STATE(78),
    [sym_preproc_def] = STATE(78),
    [sym_preproc_function_def] = STATE(78),
    [sym_preproc_call] = STATE(78),
    [sym_preproc_if] = STATE(78),
    [sym_preproc_ifdef] = STATE(78),
    [sym_function_definition] = STATE(78),
    [sym_declaration] = STATE(78),
    [sym_type_definition] = STATE(78),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(78),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(78),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(78),
    [sym_labeled_statement] = STATE(78),
    [sym_expression_statement] = STATE(78),
    [sym_if_statement] = STATE(78),
    [sym_switch_statement] = STATE(78),
    [sym_case_statement] = STATE(78),
    [sym_while_statement] = STATE(78),
    [sym_do_statement] = STATE(78),
    [sym_for_statement] = STATE(78),
    [sym_return_statement] = STATE(78),
    [sym_break_statement] = STATE(78),
    [sym_continue_statement] = STATE(78),
    [sym_goto_statement] = STATE(78),
    [sym_seh_try_statement] = STATE(78),
    [sym_seh_leave_statement] = STATE(78),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(78),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(78),
    [sym_template_instantiation] = STATE(78),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(78),
    [sym_operator_cast_declaration] = STATE(78),
    [sym_constructor_or_destructor_definition] = STATE(78),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(78),
    [sym_namespace_alias_definition] = STATE(78),
    [sym_using_declaration] = STATE(78),
    [sym_alias_declaration] = STATE(78),
    [sym_static_assert_declaration] = STATE(78),
    [sym_concept_definition] = STATE(78),
    [sym_for_range_loop] = STATE(78),
    [sym_co_return_statement] = STATE(78),
    [sym_co_yield_statement] = STATE(78),
    [sym_throw_statement] = STATE(78),
    [sym_try_statement] = STATE(78),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(78),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [85] = {
    [sym_preproc_include] = STATE(88),
    [sym_preproc_def] = STATE(88),
    [sym_preproc_function_def] = STATE(88),
    [sym_preproc_call] = STATE(88),
    [sym_preproc_if] = STATE(88),
    [sym_preproc_ifdef] = STATE(88),
    [sym_function_definition] = STATE(88),
    [sym_declaration] = STATE(88),
    [sym_type_definition] = STATE(88),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(88),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(88),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(88),
    [sym_labeled_statement] = STATE(88),
    [sym_expression_statement] = STATE(88),
    [sym_if_statement] = STATE(88),
    [sym_switch_statement] = STATE(88),
    [sym_case_statement] = STATE(88),
    [sym_while_statement] = STATE(88),
    [sym_do_statement] = STATE(88),
    [sym_for_statement] = STATE(88),
    [sym_return_statement] = STATE(88),
    [sym_break_statement] = STATE(88),
    [sym_continue_statement] = STATE(88),
    [sym_goto_statement] = STATE(88),
    [sym_seh_try_statement] = STATE(88),
    [sym_seh_leave_statement] = STATE(88),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(88),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(88),
    [sym_template_instantiation] = STATE(88),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(88),
    [sym_operator_cast_declaration] = STATE(88),
    [sym_constructor_or_destructor_definition] = STATE(88),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(88),
    [sym_namespace_alias_definition] = STATE(88),
    [sym_using_declaration] = STATE(88),
    [sym_alias_declaration] = STATE(88),
    [sym_static_assert_declaration] = STATE(88),
    [sym_concept_definition] = STATE(88),
    [sym_for_range_loop] = STATE(88),
    [sym_co_return_statement] = STATE(88),
    [sym_co_yield_statement] = STATE(88),
    [sym_throw_statement] = STATE(88),
    [sym_try_statement] = STATE(88),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(88),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(1091),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [86] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [87] = {
    [sym_preproc_include] = STATE(79),
    [sym_preproc_def] = STATE(79),
    [sym_preproc_function_def] = STATE(79),
    [sym_preproc_call] = STATE(79),
    [sym_preproc_if] = STATE(79),
    [sym_preproc_ifdef] = STATE(79),
    [sym_function_definition] = STATE(79),
    [sym_declaration] = STATE(79),
    [sym_type_definition] = STATE(79),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5414),
    [sym_linkage_specification] = STATE(79),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2119),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7123),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(79),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3248),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(79),
    [sym_labeled_statement] = STATE(79),
    [sym_expression_statement] = STATE(79),
    [sym_if_statement] = STATE(79),
    [sym_switch_statement] = STATE(79),
    [sym_case_statement] = STATE(79),
    [sym_while_statement] = STATE(79),
    [sym_do_statement] = STATE(79),
    [sym_for_statement] = STATE(79),
    [sym_return_statement] = STATE(79),
    [sym_break_statement] = STATE(79),
    [sym_continue_statement] = STATE(79),
    [sym_goto_statement] = STATE(79),
    [sym_seh_try_statement] = STATE(79),
    [sym_seh_leave_statement] = STATE(79),
    [sym__expression] = STATE(5326),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9529),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(79),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2238),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(79),
    [sym_template_instantiation] = STATE(79),
    [sym_operator_cast] = STATE(7504),
    [sym__constructor_specifiers] = STATE(2238),
    [sym_operator_cast_definition] = STATE(79),
    [sym_operator_cast_declaration] = STATE(79),
    [sym_constructor_or_destructor_definition] = STATE(79),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(79),
    [sym_namespace_alias_definition] = STATE(79),
    [sym_using_declaration] = STATE(79),
    [sym_alias_declaration] = STATE(79),
    [sym_static_assert_declaration] = STATE(79),
    [sym_concept_definition] = STATE(79),
    [sym_for_range_loop] = STATE(79),
    [sym_co_return_statement] = STATE(79),
    [sym_co_yield_statement] = STATE(79),
    [sym_throw_statement] = STATE(79),
    [sym_try_statement] = STATE(79),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7504),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(79),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2238),
    [sym_identifier] = ACTIONS(1095),
    [aux_sym_preproc_include_token1] = ACTIONS(1097),
    [aux_sym_preproc_def_token1] = ACTIONS(1099),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_if_token2] = ACTIONS(1103),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1105),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1105),
    [sym_preproc_directive] = ACTIONS(1107),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym___extension__] = ACTIONS(1111),
    [anon_sym_typedef] = ACTIONS(1113),
    [anon_sym_extern] = ACTIONS(1115),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(1117),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(1119),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(1121),
    [anon_sym_switch] = ACTIONS(1123),
    [anon_sym_case] = ACTIONS(1125),
    [anon_sym_default] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(1129),
    [anon_sym_do] = ACTIONS(1131),
    [anon_sym_for] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1139),
    [anon_sym_goto] = ACTIONS(1141),
    [anon_sym___try] = ACTIONS(1143),
    [anon_sym___leave] = ACTIONS(1145),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1147),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(1149),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1151),
    [anon_sym_namespace] = ACTIONS(1153),
    [anon_sym_using] = ACTIONS(1155),
    [anon_sym_static_assert] = ACTIONS(1157),
    [anon_sym_concept] = ACTIONS(1159),
    [anon_sym_co_return] = ACTIONS(1161),
    [anon_sym_co_yield] = ACTIONS(1163),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [88] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(1165),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [89] = {
    [sym_preproc_include] = STATE(97),
    [sym_preproc_def] = STATE(97),
    [sym_preproc_function_def] = STATE(97),
    [sym_preproc_call] = STATE(97),
    [sym_preproc_if] = STATE(97),
    [sym_preproc_ifdef] = STATE(97),
    [sym_function_definition] = STATE(97),
    [sym_declaration] = STATE(97),
    [sym_type_definition] = STATE(97),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(97),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(97),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(97),
    [sym_labeled_statement] = STATE(97),
    [sym_expression_statement] = STATE(97),
    [sym_if_statement] = STATE(97),
    [sym_switch_statement] = STATE(97),
    [sym_case_statement] = STATE(97),
    [sym_while_statement] = STATE(97),
    [sym_do_statement] = STATE(97),
    [sym_for_statement] = STATE(97),
    [sym_return_statement] = STATE(97),
    [sym_break_statement] = STATE(97),
    [sym_continue_statement] = STATE(97),
    [sym_goto_statement] = STATE(97),
    [sym_seh_try_statement] = STATE(97),
    [sym_seh_leave_statement] = STATE(97),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(97),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(97),
    [sym_template_instantiation] = STATE(97),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(97),
    [sym_operator_cast_declaration] = STATE(97),
    [sym_constructor_or_destructor_definition] = STATE(97),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(97),
    [sym_namespace_alias_definition] = STATE(97),
    [sym_using_declaration] = STATE(97),
    [sym_alias_declaration] = STATE(97),
    [sym_static_assert_declaration] = STATE(97),
    [sym_concept_definition] = STATE(97),
    [sym_for_range_loop] = STATE(97),
    [sym_co_return_statement] = STATE(97),
    [sym_co_yield_statement] = STATE(97),
    [sym_throw_statement] = STATE(97),
    [sym_try_statement] = STATE(97),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(97),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(1167),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [90] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(1169),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [91] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(1171),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [92] = {
    [sym_preproc_include] = STATE(76),
    [sym_preproc_def] = STATE(76),
    [sym_preproc_function_def] = STATE(76),
    [sym_preproc_call] = STATE(76),
    [sym_preproc_if] = STATE(76),
    [sym_preproc_ifdef] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_declaration] = STATE(76),
    [sym_type_definition] = STATE(76),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(76),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(76),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(76),
    [sym_labeled_statement] = STATE(76),
    [sym_expression_statement] = STATE(76),
    [sym_if_statement] = STATE(76),
    [sym_switch_statement] = STATE(76),
    [sym_case_statement] = STATE(76),
    [sym_while_statement] = STATE(76),
    [sym_do_statement] = STATE(76),
    [sym_for_statement] = STATE(76),
    [sym_return_statement] = STATE(76),
    [sym_break_statement] = STATE(76),
    [sym_continue_statement] = STATE(76),
    [sym_goto_statement] = STATE(76),
    [sym_seh_try_statement] = STATE(76),
    [sym_seh_leave_statement] = STATE(76),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(76),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(76),
    [sym_template_instantiation] = STATE(76),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(76),
    [sym_operator_cast_declaration] = STATE(76),
    [sym_constructor_or_destructor_definition] = STATE(76),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(76),
    [sym_namespace_alias_definition] = STATE(76),
    [sym_using_declaration] = STATE(76),
    [sym_alias_declaration] = STATE(76),
    [sym_static_assert_declaration] = STATE(76),
    [sym_concept_definition] = STATE(76),
    [sym_for_range_loop] = STATE(76),
    [sym_co_return_statement] = STATE(76),
    [sym_co_yield_statement] = STATE(76),
    [sym_throw_statement] = STATE(76),
    [sym_try_statement] = STATE(76),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(76),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(1173),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [93] = {
    [sym_preproc_include] = STATE(86),
    [sym_preproc_def] = STATE(86),
    [sym_preproc_function_def] = STATE(86),
    [sym_preproc_call] = STATE(86),
    [sym_preproc_if] = STATE(86),
    [sym_preproc_ifdef] = STATE(86),
    [sym_function_definition] = STATE(86),
    [sym_declaration] = STATE(86),
    [sym_type_definition] = STATE(86),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(86),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(86),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(86),
    [sym_labeled_statement] = STATE(86),
    [sym_expression_statement] = STATE(86),
    [sym_if_statement] = STATE(86),
    [sym_switch_statement] = STATE(86),
    [sym_case_statement] = STATE(86),
    [sym_while_statement] = STATE(86),
    [sym_do_statement] = STATE(86),
    [sym_for_statement] = STATE(86),
    [sym_return_statement] = STATE(86),
    [sym_break_statement] = STATE(86),
    [sym_continue_statement] = STATE(86),
    [sym_goto_statement] = STATE(86),
    [sym_seh_try_statement] = STATE(86),
    [sym_seh_leave_statement] = STATE(86),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(86),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(86),
    [sym_template_instantiation] = STATE(86),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(86),
    [sym_operator_cast_declaration] = STATE(86),
    [sym_constructor_or_destructor_definition] = STATE(86),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(86),
    [sym_namespace_alias_definition] = STATE(86),
    [sym_using_declaration] = STATE(86),
    [sym_alias_declaration] = STATE(86),
    [sym_static_assert_declaration] = STATE(86),
    [sym_concept_definition] = STATE(86),
    [sym_for_range_loop] = STATE(86),
    [sym_co_return_statement] = STATE(86),
    [sym_co_yield_statement] = STATE(86),
    [sym_throw_statement] = STATE(86),
    [sym_try_statement] = STATE(86),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(86),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(1175),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [94] = {
    [sym_preproc_include] = STATE(87),
    [sym_preproc_def] = STATE(87),
    [sym_preproc_function_def] = STATE(87),
    [sym_preproc_call] = STATE(87),
    [sym_preproc_if] = STATE(87),
    [sym_preproc_ifdef] = STATE(87),
    [sym_function_definition] = STATE(87),
    [sym_declaration] = STATE(87),
    [sym_type_definition] = STATE(87),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5414),
    [sym_linkage_specification] = STATE(87),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2119),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7123),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(87),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3248),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(87),
    [sym_labeled_statement] = STATE(87),
    [sym_expression_statement] = STATE(87),
    [sym_if_statement] = STATE(87),
    [sym_switch_statement] = STATE(87),
    [sym_case_statement] = STATE(87),
    [sym_while_statement] = STATE(87),
    [sym_do_statement] = STATE(87),
    [sym_for_statement] = STATE(87),
    [sym_return_statement] = STATE(87),
    [sym_break_statement] = STATE(87),
    [sym_continue_statement] = STATE(87),
    [sym_goto_statement] = STATE(87),
    [sym_seh_try_statement] = STATE(87),
    [sym_seh_leave_statement] = STATE(87),
    [sym__expression] = STATE(5326),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9529),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(87),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2238),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(87),
    [sym_template_instantiation] = STATE(87),
    [sym_operator_cast] = STATE(7504),
    [sym__constructor_specifiers] = STATE(2238),
    [sym_operator_cast_definition] = STATE(87),
    [sym_operator_cast_declaration] = STATE(87),
    [sym_constructor_or_destructor_definition] = STATE(87),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(87),
    [sym_namespace_alias_definition] = STATE(87),
    [sym_using_declaration] = STATE(87),
    [sym_alias_declaration] = STATE(87),
    [sym_static_assert_declaration] = STATE(87),
    [sym_concept_definition] = STATE(87),
    [sym_for_range_loop] = STATE(87),
    [sym_co_return_statement] = STATE(87),
    [sym_co_yield_statement] = STATE(87),
    [sym_throw_statement] = STATE(87),
    [sym_try_statement] = STATE(87),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7504),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(87),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2238),
    [sym_identifier] = ACTIONS(1095),
    [aux_sym_preproc_include_token1] = ACTIONS(1097),
    [aux_sym_preproc_def_token1] = ACTIONS(1099),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_if_token2] = ACTIONS(1177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1105),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1105),
    [sym_preproc_directive] = ACTIONS(1107),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym___extension__] = ACTIONS(1111),
    [anon_sym_typedef] = ACTIONS(1113),
    [anon_sym_extern] = ACTIONS(1115),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(1117),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(1119),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(1121),
    [anon_sym_switch] = ACTIONS(1123),
    [anon_sym_case] = ACTIONS(1125),
    [anon_sym_default] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(1129),
    [anon_sym_do] = ACTIONS(1131),
    [anon_sym_for] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1139),
    [anon_sym_goto] = ACTIONS(1141),
    [anon_sym___try] = ACTIONS(1143),
    [anon_sym___leave] = ACTIONS(1145),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1147),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(1149),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1151),
    [anon_sym_namespace] = ACTIONS(1153),
    [anon_sym_using] = ACTIONS(1155),
    [anon_sym_static_assert] = ACTIONS(1157),
    [anon_sym_concept] = ACTIONS(1159),
    [anon_sym_co_return] = ACTIONS(1161),
    [anon_sym_co_yield] = ACTIONS(1163),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [95] = {
    [sym_preproc_include] = STATE(90),
    [sym_preproc_def] = STATE(90),
    [sym_preproc_function_def] = STATE(90),
    [sym_preproc_call] = STATE(90),
    [sym_preproc_if] = STATE(90),
    [sym_preproc_ifdef] = STATE(90),
    [sym_function_definition] = STATE(90),
    [sym_declaration] = STATE(90),
    [sym_type_definition] = STATE(90),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(90),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(90),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(90),
    [sym_labeled_statement] = STATE(90),
    [sym_expression_statement] = STATE(90),
    [sym_if_statement] = STATE(90),
    [sym_switch_statement] = STATE(90),
    [sym_case_statement] = STATE(90),
    [sym_while_statement] = STATE(90),
    [sym_do_statement] = STATE(90),
    [sym_for_statement] = STATE(90),
    [sym_return_statement] = STATE(90),
    [sym_break_statement] = STATE(90),
    [sym_continue_statement] = STATE(90),
    [sym_goto_statement] = STATE(90),
    [sym_seh_try_statement] = STATE(90),
    [sym_seh_leave_statement] = STATE(90),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(90),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(90),
    [sym_template_instantiation] = STATE(90),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(90),
    [sym_operator_cast_declaration] = STATE(90),
    [sym_constructor_or_destructor_definition] = STATE(90),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(90),
    [sym_namespace_alias_definition] = STATE(90),
    [sym_using_declaration] = STATE(90),
    [sym_alias_declaration] = STATE(90),
    [sym_static_assert_declaration] = STATE(90),
    [sym_concept_definition] = STATE(90),
    [sym_for_range_loop] = STATE(90),
    [sym_co_return_statement] = STATE(90),
    [sym_co_yield_statement] = STATE(90),
    [sym_throw_statement] = STATE(90),
    [sym_try_statement] = STATE(90),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(90),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(1179),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [96] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [97] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7180),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2169),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2169),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(799),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(1183),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [98] = {
    [sym_preproc_include] = STATE(98),
    [sym_preproc_def] = STATE(98),
    [sym_preproc_function_def] = STATE(98),
    [sym_preproc_call] = STATE(98),
    [sym_preproc_if] = STATE(98),
    [sym_preproc_ifdef] = STATE(98),
    [sym_function_definition] = STATE(98),
    [sym_declaration] = STATE(98),
    [sym_type_definition] = STATE(98),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5408),
    [sym_linkage_specification] = STATE(98),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2149),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7122),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(98),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3271),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(98),
    [sym_labeled_statement] = STATE(98),
    [sym__top_level_expression_statement] = STATE(98),
    [sym_if_statement] = STATE(98),
    [sym_switch_statement] = STATE(98),
    [sym_case_statement] = STATE(98),
    [sym_while_statement] = STATE(98),
    [sym_do_statement] = STATE(98),
    [sym_for_statement] = STATE(98),
    [sym_return_statement] = STATE(98),
    [sym_break_statement] = STATE(98),
    [sym_continue_statement] = STATE(98),
    [sym_goto_statement] = STATE(98),
    [sym__expression] = STATE(5546),
    [sym__expression_not_binary] = STATE(5658),
    [sym__string] = STATE(5658),
    [sym_conditional_expression] = STATE(5658),
    [sym_assignment_expression] = STATE(5658),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(5658),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(5658),
    [sym_cast_expression] = STATE(5658),
    [sym_sizeof_expression] = STATE(5658),
    [sym_alignof_expression] = STATE(5658),
    [sym_offsetof_expression] = STATE(5658),
    [sym_generic_expression] = STATE(5658),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(5658),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(5658),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(5658),
    [sym__empty_declaration] = STATE(98),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2116),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(98),
    [sym_template_instantiation] = STATE(98),
    [sym_operator_cast] = STATE(7529),
    [sym__constructor_specifiers] = STATE(2116),
    [sym_operator_cast_definition] = STATE(98),
    [sym_operator_cast_declaration] = STATE(98),
    [sym_constructor_or_destructor_definition] = STATE(98),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(98),
    [sym_namespace_alias_definition] = STATE(98),
    [sym_using_declaration] = STATE(98),
    [sym_alias_declaration] = STATE(98),
    [sym_static_assert_declaration] = STATE(98),
    [sym_concept_definition] = STATE(98),
    [sym_for_range_loop] = STATE(98),
    [sym_co_return_statement] = STATE(98),
    [sym_co_yield_statement] = STATE(98),
    [sym_throw_statement] = STATE(98),
    [sym_try_statement] = STATE(98),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(5658),
    [sym_new_expression] = STATE(5658),
    [sym_delete_expression] = STATE(5658),
    [sym_requires_clause] = STATE(5658),
    [sym_requires_expression] = STATE(5658),
    [sym_lambda_expression] = STATE(5658),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(5658),
    [sym_parameter_pack_expansion] = STATE(5658),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7529),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_translation_unit_repeat1] = STATE(98),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(228),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2116),
    [ts_builtin_sym_end] = ACTIONS(1185),
    [sym_identifier] = ACTIONS(1187),
    [aux_sym_preproc_include_token1] = ACTIONS(1190),
    [aux_sym_preproc_def_token1] = ACTIONS(1193),
    [aux_sym_preproc_if_token1] = ACTIONS(1196),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1199),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1199),
    [sym_preproc_directive] = ACTIONS(1202),
    [anon_sym_LPAREN2] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1208),
    [anon_sym_TILDE] = ACTIONS(1211),
    [anon_sym_DASH] = ACTIONS(1214),
    [anon_sym_PLUS] = ACTIONS(1214),
    [anon_sym_STAR] = ACTIONS(1217),
    [anon_sym_AMP_AMP] = ACTIONS(1220),
    [anon_sym_AMP] = ACTIONS(1223),
    [anon_sym___extension__] = ACTIONS(1226),
    [anon_sym_typedef] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(1232),
    [anon_sym___attribute__] = ACTIONS(1235),
    [anon_sym_COLON_COLON] = ACTIONS(1238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1241),
    [anon_sym___declspec] = ACTIONS(1244),
    [anon_sym___based] = ACTIONS(1247),
    [anon_sym___cdecl] = ACTIONS(1250),
    [anon_sym___clrcall] = ACTIONS(1250),
    [anon_sym___stdcall] = ACTIONS(1250),
    [anon_sym___fastcall] = ACTIONS(1250),
    [anon_sym___thiscall] = ACTIONS(1250),
    [anon_sym___vectorcall] = ACTIONS(1250),
    [anon_sym_LBRACE] = ACTIONS(1253),
    [anon_sym_signed] = ACTIONS(1256),
    [anon_sym_unsigned] = ACTIONS(1256),
    [anon_sym_long] = ACTIONS(1256),
    [anon_sym_short] = ACTIONS(1256),
    [anon_sym_LBRACK] = ACTIONS(1259),
    [anon_sym_static] = ACTIONS(1262),
    [anon_sym_register] = ACTIONS(1262),
    [anon_sym_inline] = ACTIONS(1265),
    [anon_sym___inline] = ACTIONS(1262),
    [anon_sym___inline__] = ACTIONS(1262),
    [anon_sym___forceinline] = ACTIONS(1262),
    [anon_sym_thread_local] = ACTIONS(1262),
    [anon_sym___thread] = ACTIONS(1262),
    [anon_sym_const] = ACTIONS(1268),
    [anon_sym_constexpr] = ACTIONS(1268),
    [anon_sym_volatile] = ACTIONS(1268),
    [anon_sym_restrict] = ACTIONS(1268),
    [anon_sym___restrict__] = ACTIONS(1268),
    [anon_sym__Atomic] = ACTIONS(1268),
    [anon_sym__Noreturn] = ACTIONS(1268),
    [anon_sym_noreturn] = ACTIONS(1268),
    [anon_sym_mutable] = ACTIONS(1268),
    [anon_sym_constinit] = ACTIONS(1268),
    [anon_sym_consteval] = ACTIONS(1268),
    [anon_sym_PROGMEM] = ACTIONS(1268),
    [aux_sym_primitive_type_token1] = ACTIONS(1271),
    [anon_sym_byte] = ACTIONS(1271),
    [anon_sym_word] = ACTIONS(1271),
    [anon_sym_enum] = ACTIONS(1274),
    [anon_sym_class] = ACTIONS(1277),
    [anon_sym_struct] = ACTIONS(1280),
    [anon_sym_union] = ACTIONS(1283),
    [anon_sym_if] = ACTIONS(1286),
    [anon_sym_switch] = ACTIONS(1289),
    [anon_sym_case] = ACTIONS(1292),
    [anon_sym_default] = ACTIONS(1295),
    [anon_sym_while] = ACTIONS(1298),
    [anon_sym_do] = ACTIONS(1301),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_break] = ACTIONS(1310),
    [anon_sym_continue] = ACTIONS(1313),
    [anon_sym_goto] = ACTIONS(1316),
    [anon_sym_not] = ACTIONS(1214),
    [anon_sym_compl] = ACTIONS(1214),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_sizeof] = ACTIONS(1322),
    [anon_sym___alignof__] = ACTIONS(1325),
    [anon_sym___alignof] = ACTIONS(1325),
    [anon_sym__alignof] = ACTIONS(1325),
    [anon_sym_alignof] = ACTIONS(1325),
    [anon_sym__Alignof] = ACTIONS(1325),
    [anon_sym_offsetof] = ACTIONS(1328),
    [anon_sym__Generic] = ACTIONS(1331),
    [anon_sym_asm] = ACTIONS(1334),
    [anon_sym___asm__] = ACTIONS(1334),
    [aux_sym_number_literal_token1] = ACTIONS(1337),
    [aux_sym_number_literal_token2] = ACTIONS(1340),
    [anon_sym_L_SQUOTE] = ACTIONS(1343),
    [anon_sym_u_SQUOTE] = ACTIONS(1343),
    [anon_sym_U_SQUOTE] = ACTIONS(1343),
    [anon_sym_u8_SQUOTE] = ACTIONS(1343),
    [anon_sym_SQUOTE] = ACTIONS(1343),
    [anon_sym_L_DQUOTE] = ACTIONS(1346),
    [anon_sym_u_DQUOTE] = ACTIONS(1346),
    [anon_sym_U_DQUOTE] = ACTIONS(1346),
    [anon_sym_u8_DQUOTE] = ACTIONS(1346),
    [anon_sym_DQUOTE] = ACTIONS(1346),
    [sym_true] = ACTIONS(1349),
    [sym_false] = ACTIONS(1349),
    [anon_sym_NULL] = ACTIONS(1352),
    [anon_sym_nullptr] = ACTIONS(1352),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1355),
    [anon_sym_decltype] = ACTIONS(1358),
    [anon_sym_virtual] = ACTIONS(1361),
    [anon_sym_alignas] = ACTIONS(1364),
    [anon_sym_explicit] = ACTIONS(1367),
    [anon_sym_typename] = ACTIONS(1370),
    [anon_sym_template] = ACTIONS(1373),
    [anon_sym_operator] = ACTIONS(1376),
    [anon_sym_try] = ACTIONS(1379),
    [anon_sym_delete] = ACTIONS(1382),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_namespace] = ACTIONS(1388),
    [anon_sym_using] = ACTIONS(1391),
    [anon_sym_static_assert] = ACTIONS(1394),
    [anon_sym_concept] = ACTIONS(1397),
    [anon_sym_co_return] = ACTIONS(1400),
    [anon_sym_co_yield] = ACTIONS(1403),
    [anon_sym_R_DQUOTE] = ACTIONS(1406),
    [anon_sym_LR_DQUOTE] = ACTIONS(1406),
    [anon_sym_uR_DQUOTE] = ACTIONS(1406),
    [anon_sym_UR_DQUOTE] = ACTIONS(1406),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1406),
    [anon_sym_co_await] = ACTIONS(1409),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_requires] = ACTIONS(1415),
    [sym_this] = ACTIONS(1349),
  },
  [99] = {
    [sym_preproc_include] = STATE(98),
    [sym_preproc_def] = STATE(98),
    [sym_preproc_function_def] = STATE(98),
    [sym_preproc_call] = STATE(98),
    [sym_preproc_if] = STATE(98),
    [sym_preproc_ifdef] = STATE(98),
    [sym_function_definition] = STATE(98),
    [sym_declaration] = STATE(98),
    [sym_type_definition] = STATE(98),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5408),
    [sym_linkage_specification] = STATE(98),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(1149),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2149),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7122),
    [sym_array_declarator] = STATE(7008),
    [sym_compound_statement] = STATE(98),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3271),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(98),
    [sym_labeled_statement] = STATE(98),
    [sym__top_level_expression_statement] = STATE(98),
    [sym_if_statement] = STATE(98),
    [sym_switch_statement] = STATE(98),
    [sym_case_statement] = STATE(98),
    [sym_while_statement] = STATE(98),
    [sym_do_statement] = STATE(98),
    [sym_for_statement] = STATE(98),
    [sym_return_statement] = STATE(98),
    [sym_break_statement] = STATE(98),
    [sym_continue_statement] = STATE(98),
    [sym_goto_statement] = STATE(98),
    [sym__expression] = STATE(5546),
    [sym__expression_not_binary] = STATE(5658),
    [sym__string] = STATE(5658),
    [sym_conditional_expression] = STATE(5658),
    [sym_assignment_expression] = STATE(5658),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(5658),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(5658),
    [sym_cast_expression] = STATE(5658),
    [sym_sizeof_expression] = STATE(5658),
    [sym_alignof_expression] = STATE(5658),
    [sym_offsetof_expression] = STATE(5658),
    [sym_generic_expression] = STATE(5658),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(5658),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(5658),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(5658),
    [sym__empty_declaration] = STATE(98),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2116),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(98),
    [sym_template_instantiation] = STATE(98),
    [sym_operator_cast] = STATE(7529),
    [sym__constructor_specifiers] = STATE(2116),
    [sym_operator_cast_definition] = STATE(98),
    [sym_operator_cast_declaration] = STATE(98),
    [sym_constructor_or_destructor_definition] = STATE(98),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(5372),
    [sym_namespace_definition] = STATE(98),
    [sym_namespace_alias_definition] = STATE(98),
    [sym_using_declaration] = STATE(98),
    [sym_alias_declaration] = STATE(98),
    [sym_static_assert_declaration] = STATE(98),
    [sym_concept_definition] = STATE(98),
    [sym_for_range_loop] = STATE(98),
    [sym_co_return_statement] = STATE(98),
    [sym_co_yield_statement] = STATE(98),
    [sym_throw_statement] = STATE(98),
    [sym_try_statement] = STATE(98),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(5658),
    [sym_new_expression] = STATE(5658),
    [sym_delete_expression] = STATE(5658),
    [sym_requires_clause] = STATE(5658),
    [sym_requires_expression] = STATE(5658),
    [sym_lambda_expression] = STATE(5658),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(5658),
    [sym_parameter_pack_expansion] = STATE(5658),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6278),
    [sym_qualified_identifier] = STATE(3877),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_qualified_operator_cast_identifier] = STATE(7529),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_translation_unit_repeat1] = STATE(98),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(228),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2116),
    [ts_builtin_sym_end] = ACTIONS(1418),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(37),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(77),
    [anon_sym_default] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(131),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(141),
    [anon_sym_using] = ACTIONS(143),
    [anon_sym_static_assert] = ACTIONS(145),
    [anon_sym_concept] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(115),
  },
  [100] = {
    [sym_declaration] = STATE(104),
    [sym_type_definition] = STATE(104),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5954),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(104),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(104),
    [sym_labeled_statement] = STATE(104),
    [sym_expression_statement] = STATE(104),
    [sym_if_statement] = STATE(104),
    [sym_switch_statement] = STATE(104),
    [sym_while_statement] = STATE(104),
    [sym_do_statement] = STATE(104),
    [sym_for_statement] = STATE(104),
    [sym_return_statement] = STATE(104),
    [sym_break_statement] = STATE(104),
    [sym_continue_statement] = STATE(104),
    [sym_goto_statement] = STATE(104),
    [sym_seh_try_statement] = STATE(104),
    [sym_seh_leave_statement] = STATE(104),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(104),
    [sym_co_return_statement] = STATE(104),
    [sym_co_yield_statement] = STATE(104),
    [sym_throw_statement] = STATE(104),
    [sym_try_statement] = STATE(104),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(104),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_preproc_include_token1] = ACTIONS(1422),
    [aux_sym_preproc_def_token1] = ACTIONS(1422),
    [aux_sym_preproc_if_token1] = ACTIONS(1422),
    [aux_sym_preproc_if_token2] = ACTIONS(1422),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1422),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1422),
    [aux_sym_preproc_else_token1] = ACTIONS(1422),
    [aux_sym_preproc_elif_token1] = ACTIONS(1422),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1422),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1422),
    [sym_preproc_directive] = ACTIONS(1422),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP_AMP] = ACTIONS(1428),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(285),
    [anon_sym___extension__] = ACTIONS(287),
    [anon_sym_typedef] = ACTIONS(289),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1422),
    [anon_sym___cdecl] = ACTIONS(1422),
    [anon_sym___clrcall] = ACTIONS(1422),
    [anon_sym___stdcall] = ACTIONS(1422),
    [anon_sym___fastcall] = ACTIONS(1422),
    [anon_sym___thiscall] = ACTIONS(1422),
    [anon_sym___vectorcall] = ACTIONS(1422),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(1422),
    [anon_sym_switch] = ACTIONS(299),
    [anon_sym_case] = ACTIONS(1422),
    [anon_sym_default] = ACTIONS(1422),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_continue] = ACTIONS(315),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym___try] = ACTIONS(319),
    [anon_sym___leave] = ACTIONS(321),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1422),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(1422),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(327),
    [anon_sym_namespace] = ACTIONS(1422),
    [anon_sym_using] = ACTIONS(1422),
    [anon_sym_static_assert] = ACTIONS(1422),
    [anon_sym_concept] = ACTIONS(1422),
    [anon_sym_co_return] = ACTIONS(337),
    [anon_sym_co_yield] = ACTIONS(339),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [101] = {
    [sym_declaration] = STATE(102),
    [sym_type_definition] = STATE(102),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5954),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(102),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(102),
    [sym_labeled_statement] = STATE(102),
    [sym_expression_statement] = STATE(102),
    [sym_if_statement] = STATE(102),
    [sym_switch_statement] = STATE(102),
    [sym_while_statement] = STATE(102),
    [sym_do_statement] = STATE(102),
    [sym_for_statement] = STATE(102),
    [sym_return_statement] = STATE(102),
    [sym_break_statement] = STATE(102),
    [sym_continue_statement] = STATE(102),
    [sym_goto_statement] = STATE(102),
    [sym_seh_try_statement] = STATE(102),
    [sym_seh_leave_statement] = STATE(102),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(102),
    [sym_co_return_statement] = STATE(102),
    [sym_co_yield_statement] = STATE(102),
    [sym_throw_statement] = STATE(102),
    [sym_try_statement] = STATE(102),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(102),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_preproc_include_token1] = ACTIONS(1438),
    [aux_sym_preproc_def_token1] = ACTIONS(1438),
    [aux_sym_preproc_if_token1] = ACTIONS(1438),
    [aux_sym_preproc_if_token2] = ACTIONS(1438),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1438),
    [aux_sym_preproc_else_token1] = ACTIONS(1438),
    [aux_sym_preproc_elif_token1] = ACTIONS(1438),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1438),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1438),
    [sym_preproc_directive] = ACTIONS(1438),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(285),
    [anon_sym___extension__] = ACTIONS(287),
    [anon_sym_typedef] = ACTIONS(289),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1438),
    [anon_sym___cdecl] = ACTIONS(1438),
    [anon_sym___clrcall] = ACTIONS(1438),
    [anon_sym___stdcall] = ACTIONS(1438),
    [anon_sym___fastcall] = ACTIONS(1438),
    [anon_sym___thiscall] = ACTIONS(1438),
    [anon_sym___vectorcall] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(1438),
    [anon_sym_switch] = ACTIONS(299),
    [anon_sym_case] = ACTIONS(1438),
    [anon_sym_default] = ACTIONS(1438),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_continue] = ACTIONS(315),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym___try] = ACTIONS(319),
    [anon_sym___leave] = ACTIONS(321),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1438),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(1438),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(327),
    [anon_sym_namespace] = ACTIONS(1438),
    [anon_sym_using] = ACTIONS(1438),
    [anon_sym_static_assert] = ACTIONS(1438),
    [anon_sym_concept] = ACTIONS(1438),
    [anon_sym_co_return] = ACTIONS(337),
    [anon_sym_co_yield] = ACTIONS(339),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [102] = {
    [sym_declaration] = STATE(102),
    [sym_type_definition] = STATE(102),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5954),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(102),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(102),
    [sym_labeled_statement] = STATE(102),
    [sym_expression_statement] = STATE(102),
    [sym_if_statement] = STATE(102),
    [sym_switch_statement] = STATE(102),
    [sym_while_statement] = STATE(102),
    [sym_do_statement] = STATE(102),
    [sym_for_statement] = STATE(102),
    [sym_return_statement] = STATE(102),
    [sym_break_statement] = STATE(102),
    [sym_continue_statement] = STATE(102),
    [sym_goto_statement] = STATE(102),
    [sym_seh_try_statement] = STATE(102),
    [sym_seh_leave_statement] = STATE(102),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(102),
    [sym_co_return_statement] = STATE(102),
    [sym_co_yield_statement] = STATE(102),
    [sym_throw_statement] = STATE(102),
    [sym_try_statement] = STATE(102),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(102),
    [sym_identifier] = ACTIONS(1442),
    [aux_sym_preproc_include_token1] = ACTIONS(1445),
    [aux_sym_preproc_def_token1] = ACTIONS(1445),
    [aux_sym_preproc_if_token1] = ACTIONS(1445),
    [aux_sym_preproc_if_token2] = ACTIONS(1445),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1445),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1445),
    [aux_sym_preproc_else_token1] = ACTIONS(1445),
    [aux_sym_preproc_elif_token1] = ACTIONS(1445),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1445),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1445),
    [sym_preproc_directive] = ACTIONS(1445),
    [anon_sym_LPAREN2] = ACTIONS(1447),
    [anon_sym_BANG] = ACTIONS(1450),
    [anon_sym_TILDE] = ACTIONS(1450),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_STAR] = ACTIONS(1456),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1464),
    [anon_sym___extension__] = ACTIONS(1467),
    [anon_sym_typedef] = ACTIONS(1470),
    [anon_sym_extern] = ACTIONS(1473),
    [anon_sym___attribute__] = ACTIONS(1476),
    [anon_sym_COLON_COLON] = ACTIONS(1479),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1482),
    [anon_sym___declspec] = ACTIONS(1485),
    [anon_sym___based] = ACTIONS(1445),
    [anon_sym___cdecl] = ACTIONS(1445),
    [anon_sym___clrcall] = ACTIONS(1445),
    [anon_sym___stdcall] = ACTIONS(1445),
    [anon_sym___fastcall] = ACTIONS(1445),
    [anon_sym___thiscall] = ACTIONS(1445),
    [anon_sym___vectorcall] = ACTIONS(1445),
    [anon_sym_LBRACE] = ACTIONS(1488),
    [anon_sym_signed] = ACTIONS(1491),
    [anon_sym_unsigned] = ACTIONS(1491),
    [anon_sym_long] = ACTIONS(1491),
    [anon_sym_short] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(1494),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_register] = ACTIONS(1473),
    [anon_sym_inline] = ACTIONS(1473),
    [anon_sym___inline] = ACTIONS(1473),
    [anon_sym___inline__] = ACTIONS(1473),
    [anon_sym___forceinline] = ACTIONS(1473),
    [anon_sym_thread_local] = ACTIONS(1473),
    [anon_sym___thread] = ACTIONS(1473),
    [anon_sym_const] = ACTIONS(1497),
    [anon_sym_constexpr] = ACTIONS(1497),
    [anon_sym_volatile] = ACTIONS(1497),
    [anon_sym_restrict] = ACTIONS(1497),
    [anon_sym___restrict__] = ACTIONS(1497),
    [anon_sym__Atomic] = ACTIONS(1497),
    [anon_sym__Noreturn] = ACTIONS(1497),
    [anon_sym_noreturn] = ACTIONS(1497),
    [anon_sym_mutable] = ACTIONS(1497),
    [anon_sym_constinit] = ACTIONS(1497),
    [anon_sym_consteval] = ACTIONS(1497),
    [anon_sym_PROGMEM] = ACTIONS(1497),
    [aux_sym_primitive_type_token1] = ACTIONS(1500),
    [anon_sym_byte] = ACTIONS(1500),
    [anon_sym_word] = ACTIONS(1500),
    [anon_sym_enum] = ACTIONS(1503),
    [anon_sym_class] = ACTIONS(1506),
    [anon_sym_struct] = ACTIONS(1509),
    [anon_sym_union] = ACTIONS(1512),
    [anon_sym_if] = ACTIONS(1515),
    [anon_sym_else] = ACTIONS(1445),
    [anon_sym_switch] = ACTIONS(1518),
    [anon_sym_case] = ACTIONS(1445),
    [anon_sym_default] = ACTIONS(1445),
    [anon_sym_while] = ACTIONS(1521),
    [anon_sym_do] = ACTIONS(1524),
    [anon_sym_for] = ACTIONS(1527),
    [anon_sym_return] = ACTIONS(1530),
    [anon_sym_break] = ACTIONS(1533),
    [anon_sym_continue] = ACTIONS(1536),
    [anon_sym_goto] = ACTIONS(1539),
    [anon_sym___try] = ACTIONS(1542),
    [anon_sym___leave] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1453),
    [anon_sym_compl] = ACTIONS(1453),
    [anon_sym_DASH_DASH] = ACTIONS(1548),
    [anon_sym_PLUS_PLUS] = ACTIONS(1548),
    [anon_sym_sizeof] = ACTIONS(1551),
    [anon_sym___alignof__] = ACTIONS(1554),
    [anon_sym___alignof] = ACTIONS(1554),
    [anon_sym__alignof] = ACTIONS(1554),
    [anon_sym_alignof] = ACTIONS(1554),
    [anon_sym__Alignof] = ACTIONS(1554),
    [anon_sym_offsetof] = ACTIONS(1557),
    [anon_sym__Generic] = ACTIONS(1560),
    [anon_sym_asm] = ACTIONS(1563),
    [anon_sym___asm__] = ACTIONS(1563),
    [aux_sym_number_literal_token1] = ACTIONS(1566),
    [aux_sym_number_literal_token2] = ACTIONS(1569),
    [anon_sym_L_SQUOTE] = ACTIONS(1572),
    [anon_sym_u_SQUOTE] = ACTIONS(1572),
    [anon_sym_U_SQUOTE] = ACTIONS(1572),
    [anon_sym_u8_SQUOTE] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1572),
    [anon_sym_L_DQUOTE] = ACTIONS(1575),
    [anon_sym_u_DQUOTE] = ACTIONS(1575),
    [anon_sym_U_DQUOTE] = ACTIONS(1575),
    [anon_sym_u8_DQUOTE] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(1575),
    [sym_true] = ACTIONS(1578),
    [sym_false] = ACTIONS(1578),
    [anon_sym_NULL] = ACTIONS(1581),
    [anon_sym_nullptr] = ACTIONS(1581),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1584),
    [anon_sym_decltype] = ACTIONS(1587),
    [anon_sym_virtual] = ACTIONS(1590),
    [anon_sym_alignas] = ACTIONS(1593),
    [anon_sym_explicit] = ACTIONS(1445),
    [anon_sym_typename] = ACTIONS(1596),
    [anon_sym_template] = ACTIONS(1599),
    [anon_sym_operator] = ACTIONS(1445),
    [anon_sym_try] = ACTIONS(1602),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_throw] = ACTIONS(1608),
    [anon_sym_namespace] = ACTIONS(1445),
    [anon_sym_using] = ACTIONS(1445),
    [anon_sym_static_assert] = ACTIONS(1445),
    [anon_sym_concept] = ACTIONS(1445),
    [anon_sym_co_return] = ACTIONS(1611),
    [anon_sym_co_yield] = ACTIONS(1614),
    [anon_sym_R_DQUOTE] = ACTIONS(1617),
    [anon_sym_LR_DQUOTE] = ACTIONS(1617),
    [anon_sym_uR_DQUOTE] = ACTIONS(1617),
    [anon_sym_UR_DQUOTE] = ACTIONS(1617),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1617),
    [anon_sym_co_await] = ACTIONS(1620),
    [anon_sym_new] = ACTIONS(1623),
    [anon_sym_requires] = ACTIONS(1626),
    [sym_this] = ACTIONS(1578),
  },
  [103] = {
    [sym_declaration] = STATE(101),
    [sym_type_definition] = STATE(101),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5954),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(101),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(101),
    [sym_labeled_statement] = STATE(101),
    [sym_expression_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_switch_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_do_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_return_statement] = STATE(101),
    [sym_break_statement] = STATE(101),
    [sym_continue_statement] = STATE(101),
    [sym_goto_statement] = STATE(101),
    [sym_seh_try_statement] = STATE(101),
    [sym_seh_leave_statement] = STATE(101),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(101),
    [sym_co_return_statement] = STATE(101),
    [sym_co_yield_statement] = STATE(101),
    [sym_throw_statement] = STATE(101),
    [sym_try_statement] = STATE(101),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(101),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_preproc_include_token1] = ACTIONS(1629),
    [aux_sym_preproc_def_token1] = ACTIONS(1629),
    [aux_sym_preproc_if_token1] = ACTIONS(1629),
    [aux_sym_preproc_if_token2] = ACTIONS(1629),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1629),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1629),
    [aux_sym_preproc_else_token1] = ACTIONS(1629),
    [aux_sym_preproc_elif_token1] = ACTIONS(1629),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1629),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1629),
    [sym_preproc_directive] = ACTIONS(1629),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP_AMP] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(285),
    [anon_sym___extension__] = ACTIONS(287),
    [anon_sym_typedef] = ACTIONS(289),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1629),
    [anon_sym___cdecl] = ACTIONS(1629),
    [anon_sym___clrcall] = ACTIONS(1629),
    [anon_sym___stdcall] = ACTIONS(1629),
    [anon_sym___fastcall] = ACTIONS(1629),
    [anon_sym___thiscall] = ACTIONS(1629),
    [anon_sym___vectorcall] = ACTIONS(1629),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(1629),
    [anon_sym_switch] = ACTIONS(299),
    [anon_sym_case] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(1629),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_continue] = ACTIONS(315),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym___try] = ACTIONS(319),
    [anon_sym___leave] = ACTIONS(321),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1629),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(1629),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(327),
    [anon_sym_namespace] = ACTIONS(1629),
    [anon_sym_using] = ACTIONS(1629),
    [anon_sym_static_assert] = ACTIONS(1629),
    [anon_sym_concept] = ACTIONS(1629),
    [anon_sym_co_return] = ACTIONS(337),
    [anon_sym_co_yield] = ACTIONS(339),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [104] = {
    [sym_declaration] = STATE(102),
    [sym_type_definition] = STATE(102),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5954),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(102),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(102),
    [sym_labeled_statement] = STATE(102),
    [sym_expression_statement] = STATE(102),
    [sym_if_statement] = STATE(102),
    [sym_switch_statement] = STATE(102),
    [sym_while_statement] = STATE(102),
    [sym_do_statement] = STATE(102),
    [sym_for_statement] = STATE(102),
    [sym_return_statement] = STATE(102),
    [sym_break_statement] = STATE(102),
    [sym_continue_statement] = STATE(102),
    [sym_goto_statement] = STATE(102),
    [sym_seh_try_statement] = STATE(102),
    [sym_seh_leave_statement] = STATE(102),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(102),
    [sym_co_return_statement] = STATE(102),
    [sym_co_yield_statement] = STATE(102),
    [sym_throw_statement] = STATE(102),
    [sym_try_statement] = STATE(102),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(102),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_preproc_include_token1] = ACTIONS(1633),
    [aux_sym_preproc_def_token1] = ACTIONS(1633),
    [aux_sym_preproc_if_token1] = ACTIONS(1633),
    [aux_sym_preproc_if_token2] = ACTIONS(1633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1633),
    [aux_sym_preproc_else_token1] = ACTIONS(1633),
    [aux_sym_preproc_elif_token1] = ACTIONS(1633),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1633),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1633),
    [sym_preproc_directive] = ACTIONS(1633),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP_AMP] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(285),
    [anon_sym___extension__] = ACTIONS(287),
    [anon_sym_typedef] = ACTIONS(289),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1633),
    [anon_sym___cdecl] = ACTIONS(1633),
    [anon_sym___clrcall] = ACTIONS(1633),
    [anon_sym___stdcall] = ACTIONS(1633),
    [anon_sym___fastcall] = ACTIONS(1633),
    [anon_sym___thiscall] = ACTIONS(1633),
    [anon_sym___vectorcall] = ACTIONS(1633),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(1633),
    [anon_sym_switch] = ACTIONS(299),
    [anon_sym_case] = ACTIONS(1633),
    [anon_sym_default] = ACTIONS(1633),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_continue] = ACTIONS(315),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym___try] = ACTIONS(319),
    [anon_sym___leave] = ACTIONS(321),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1633),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(1633),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(327),
    [anon_sym_namespace] = ACTIONS(1633),
    [anon_sym_using] = ACTIONS(1633),
    [anon_sym_static_assert] = ACTIONS(1633),
    [anon_sym_concept] = ACTIONS(1633),
    [anon_sym_co_return] = ACTIONS(337),
    [anon_sym_co_yield] = ACTIONS(339),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [105] = {
    [sym_declaration] = STATE(108),
    [sym_type_definition] = STATE(108),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5902),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(108),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(108),
    [sym_labeled_statement] = STATE(108),
    [sym_expression_statement] = STATE(108),
    [sym_if_statement] = STATE(108),
    [sym_switch_statement] = STATE(108),
    [sym_while_statement] = STATE(108),
    [sym_do_statement] = STATE(108),
    [sym_for_statement] = STATE(108),
    [sym_return_statement] = STATE(108),
    [sym_break_statement] = STATE(108),
    [sym_continue_statement] = STATE(108),
    [sym_goto_statement] = STATE(108),
    [sym_seh_try_statement] = STATE(108),
    [sym_seh_leave_statement] = STATE(108),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(108),
    [sym_co_return_statement] = STATE(108),
    [sym_co_yield_statement] = STATE(108),
    [sym_throw_statement] = STATE(108),
    [sym_try_statement] = STATE(108),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(108),
    [sym_identifier] = ACTIONS(1637),
    [aux_sym_preproc_include_token1] = ACTIONS(1422),
    [aux_sym_preproc_def_token1] = ACTIONS(1422),
    [aux_sym_preproc_if_token1] = ACTIONS(1422),
    [aux_sym_preproc_if_token2] = ACTIONS(1422),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1422),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1422),
    [aux_sym_preproc_else_token1] = ACTIONS(1422),
    [aux_sym_preproc_elif_token1] = ACTIONS(1422),
    [sym_preproc_directive] = ACTIONS(1422),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP_AMP] = ACTIONS(1428),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym___extension__] = ACTIONS(375),
    [anon_sym_typedef] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1422),
    [anon_sym___cdecl] = ACTIONS(1422),
    [anon_sym___clrcall] = ACTIONS(1422),
    [anon_sym___stdcall] = ACTIONS(1422),
    [anon_sym___fastcall] = ACTIONS(1422),
    [anon_sym___thiscall] = ACTIONS(1422),
    [anon_sym___vectorcall] = ACTIONS(1422),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_else] = ACTIONS(1422),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(1422),
    [anon_sym_default] = ACTIONS(1422),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1422),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(1422),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_namespace] = ACTIONS(1422),
    [anon_sym_using] = ACTIONS(1422),
    [anon_sym_static_assert] = ACTIONS(1422),
    [anon_sym_concept] = ACTIONS(1422),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [106] = {
    [sym_declaration] = STATE(106),
    [sym_type_definition] = STATE(106),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5902),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(106),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(106),
    [sym_labeled_statement] = STATE(106),
    [sym_expression_statement] = STATE(106),
    [sym_if_statement] = STATE(106),
    [sym_switch_statement] = STATE(106),
    [sym_while_statement] = STATE(106),
    [sym_do_statement] = STATE(106),
    [sym_for_statement] = STATE(106),
    [sym_return_statement] = STATE(106),
    [sym_break_statement] = STATE(106),
    [sym_continue_statement] = STATE(106),
    [sym_goto_statement] = STATE(106),
    [sym_seh_try_statement] = STATE(106),
    [sym_seh_leave_statement] = STATE(106),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(106),
    [sym_co_return_statement] = STATE(106),
    [sym_co_yield_statement] = STATE(106),
    [sym_throw_statement] = STATE(106),
    [sym_try_statement] = STATE(106),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(106),
    [sym_identifier] = ACTIONS(1639),
    [aux_sym_preproc_include_token1] = ACTIONS(1445),
    [aux_sym_preproc_def_token1] = ACTIONS(1445),
    [aux_sym_preproc_if_token1] = ACTIONS(1445),
    [aux_sym_preproc_if_token2] = ACTIONS(1445),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1445),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1445),
    [aux_sym_preproc_else_token1] = ACTIONS(1445),
    [aux_sym_preproc_elif_token1] = ACTIONS(1445),
    [sym_preproc_directive] = ACTIONS(1445),
    [anon_sym_LPAREN2] = ACTIONS(1447),
    [anon_sym_BANG] = ACTIONS(1450),
    [anon_sym_TILDE] = ACTIONS(1450),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_STAR] = ACTIONS(1456),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1642),
    [anon_sym___extension__] = ACTIONS(1645),
    [anon_sym_typedef] = ACTIONS(1648),
    [anon_sym_extern] = ACTIONS(1473),
    [anon_sym___attribute__] = ACTIONS(1476),
    [anon_sym_COLON_COLON] = ACTIONS(1479),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1482),
    [anon_sym___declspec] = ACTIONS(1485),
    [anon_sym___based] = ACTIONS(1445),
    [anon_sym___cdecl] = ACTIONS(1445),
    [anon_sym___clrcall] = ACTIONS(1445),
    [anon_sym___stdcall] = ACTIONS(1445),
    [anon_sym___fastcall] = ACTIONS(1445),
    [anon_sym___thiscall] = ACTIONS(1445),
    [anon_sym___vectorcall] = ACTIONS(1445),
    [anon_sym_LBRACE] = ACTIONS(1651),
    [anon_sym_signed] = ACTIONS(1491),
    [anon_sym_unsigned] = ACTIONS(1491),
    [anon_sym_long] = ACTIONS(1491),
    [anon_sym_short] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(1494),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_register] = ACTIONS(1473),
    [anon_sym_inline] = ACTIONS(1473),
    [anon_sym___inline] = ACTIONS(1473),
    [anon_sym___inline__] = ACTIONS(1473),
    [anon_sym___forceinline] = ACTIONS(1473),
    [anon_sym_thread_local] = ACTIONS(1473),
    [anon_sym___thread] = ACTIONS(1473),
    [anon_sym_const] = ACTIONS(1497),
    [anon_sym_constexpr] = ACTIONS(1497),
    [anon_sym_volatile] = ACTIONS(1497),
    [anon_sym_restrict] = ACTIONS(1497),
    [anon_sym___restrict__] = ACTIONS(1497),
    [anon_sym__Atomic] = ACTIONS(1497),
    [anon_sym__Noreturn] = ACTIONS(1497),
    [anon_sym_noreturn] = ACTIONS(1497),
    [anon_sym_mutable] = ACTIONS(1497),
    [anon_sym_constinit] = ACTIONS(1497),
    [anon_sym_consteval] = ACTIONS(1497),
    [anon_sym_PROGMEM] = ACTIONS(1497),
    [aux_sym_primitive_type_token1] = ACTIONS(1500),
    [anon_sym_byte] = ACTIONS(1500),
    [anon_sym_word] = ACTIONS(1500),
    [anon_sym_enum] = ACTIONS(1503),
    [anon_sym_class] = ACTIONS(1506),
    [anon_sym_struct] = ACTIONS(1509),
    [anon_sym_union] = ACTIONS(1512),
    [anon_sym_if] = ACTIONS(1654),
    [anon_sym_else] = ACTIONS(1445),
    [anon_sym_switch] = ACTIONS(1657),
    [anon_sym_case] = ACTIONS(1445),
    [anon_sym_default] = ACTIONS(1445),
    [anon_sym_while] = ACTIONS(1660),
    [anon_sym_do] = ACTIONS(1663),
    [anon_sym_for] = ACTIONS(1666),
    [anon_sym_return] = ACTIONS(1669),
    [anon_sym_break] = ACTIONS(1672),
    [anon_sym_continue] = ACTIONS(1675),
    [anon_sym_goto] = ACTIONS(1678),
    [anon_sym___try] = ACTIONS(1681),
    [anon_sym___leave] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1453),
    [anon_sym_compl] = ACTIONS(1453),
    [anon_sym_DASH_DASH] = ACTIONS(1548),
    [anon_sym_PLUS_PLUS] = ACTIONS(1548),
    [anon_sym_sizeof] = ACTIONS(1551),
    [anon_sym___alignof__] = ACTIONS(1554),
    [anon_sym___alignof] = ACTIONS(1554),
    [anon_sym__alignof] = ACTIONS(1554),
    [anon_sym_alignof] = ACTIONS(1554),
    [anon_sym__Alignof] = ACTIONS(1554),
    [anon_sym_offsetof] = ACTIONS(1557),
    [anon_sym__Generic] = ACTIONS(1560),
    [anon_sym_asm] = ACTIONS(1563),
    [anon_sym___asm__] = ACTIONS(1563),
    [aux_sym_number_literal_token1] = ACTIONS(1566),
    [aux_sym_number_literal_token2] = ACTIONS(1569),
    [anon_sym_L_SQUOTE] = ACTIONS(1572),
    [anon_sym_u_SQUOTE] = ACTIONS(1572),
    [anon_sym_U_SQUOTE] = ACTIONS(1572),
    [anon_sym_u8_SQUOTE] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1572),
    [anon_sym_L_DQUOTE] = ACTIONS(1575),
    [anon_sym_u_DQUOTE] = ACTIONS(1575),
    [anon_sym_U_DQUOTE] = ACTIONS(1575),
    [anon_sym_u8_DQUOTE] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(1575),
    [sym_true] = ACTIONS(1578),
    [sym_false] = ACTIONS(1578),
    [anon_sym_NULL] = ACTIONS(1581),
    [anon_sym_nullptr] = ACTIONS(1581),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1584),
    [anon_sym_decltype] = ACTIONS(1587),
    [anon_sym_virtual] = ACTIONS(1590),
    [anon_sym_alignas] = ACTIONS(1593),
    [anon_sym_explicit] = ACTIONS(1445),
    [anon_sym_typename] = ACTIONS(1596),
    [anon_sym_template] = ACTIONS(1599),
    [anon_sym_operator] = ACTIONS(1445),
    [anon_sym_try] = ACTIONS(1687),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_throw] = ACTIONS(1690),
    [anon_sym_namespace] = ACTIONS(1445),
    [anon_sym_using] = ACTIONS(1445),
    [anon_sym_static_assert] = ACTIONS(1445),
    [anon_sym_concept] = ACTIONS(1445),
    [anon_sym_co_return] = ACTIONS(1693),
    [anon_sym_co_yield] = ACTIONS(1696),
    [anon_sym_R_DQUOTE] = ACTIONS(1617),
    [anon_sym_LR_DQUOTE] = ACTIONS(1617),
    [anon_sym_uR_DQUOTE] = ACTIONS(1617),
    [anon_sym_UR_DQUOTE] = ACTIONS(1617),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1617),
    [anon_sym_co_await] = ACTIONS(1620),
    [anon_sym_new] = ACTIONS(1623),
    [anon_sym_requires] = ACTIONS(1626),
    [sym_this] = ACTIONS(1578),
  },
  [107] = {
    [sym_declaration] = STATE(106),
    [sym_type_definition] = STATE(106),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5902),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(106),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(106),
    [sym_labeled_statement] = STATE(106),
    [sym_expression_statement] = STATE(106),
    [sym_if_statement] = STATE(106),
    [sym_switch_statement] = STATE(106),
    [sym_while_statement] = STATE(106),
    [sym_do_statement] = STATE(106),
    [sym_for_statement] = STATE(106),
    [sym_return_statement] = STATE(106),
    [sym_break_statement] = STATE(106),
    [sym_continue_statement] = STATE(106),
    [sym_goto_statement] = STATE(106),
    [sym_seh_try_statement] = STATE(106),
    [sym_seh_leave_statement] = STATE(106),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(106),
    [sym_co_return_statement] = STATE(106),
    [sym_co_yield_statement] = STATE(106),
    [sym_throw_statement] = STATE(106),
    [sym_try_statement] = STATE(106),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(106),
    [sym_identifier] = ACTIONS(1637),
    [aux_sym_preproc_include_token1] = ACTIONS(1438),
    [aux_sym_preproc_def_token1] = ACTIONS(1438),
    [aux_sym_preproc_if_token1] = ACTIONS(1438),
    [aux_sym_preproc_if_token2] = ACTIONS(1438),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1438),
    [aux_sym_preproc_else_token1] = ACTIONS(1438),
    [aux_sym_preproc_elif_token1] = ACTIONS(1438),
    [sym_preproc_directive] = ACTIONS(1438),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym___extension__] = ACTIONS(375),
    [anon_sym_typedef] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1438),
    [anon_sym___cdecl] = ACTIONS(1438),
    [anon_sym___clrcall] = ACTIONS(1438),
    [anon_sym___stdcall] = ACTIONS(1438),
    [anon_sym___fastcall] = ACTIONS(1438),
    [anon_sym___thiscall] = ACTIONS(1438),
    [anon_sym___vectorcall] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_else] = ACTIONS(1438),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(1438),
    [anon_sym_default] = ACTIONS(1438),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1438),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(1438),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_namespace] = ACTIONS(1438),
    [anon_sym_using] = ACTIONS(1438),
    [anon_sym_static_assert] = ACTIONS(1438),
    [anon_sym_concept] = ACTIONS(1438),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [108] = {
    [sym_declaration] = STATE(106),
    [sym_type_definition] = STATE(106),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5902),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(106),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(106),
    [sym_labeled_statement] = STATE(106),
    [sym_expression_statement] = STATE(106),
    [sym_if_statement] = STATE(106),
    [sym_switch_statement] = STATE(106),
    [sym_while_statement] = STATE(106),
    [sym_do_statement] = STATE(106),
    [sym_for_statement] = STATE(106),
    [sym_return_statement] = STATE(106),
    [sym_break_statement] = STATE(106),
    [sym_continue_statement] = STATE(106),
    [sym_goto_statement] = STATE(106),
    [sym_seh_try_statement] = STATE(106),
    [sym_seh_leave_statement] = STATE(106),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(106),
    [sym_co_return_statement] = STATE(106),
    [sym_co_yield_statement] = STATE(106),
    [sym_throw_statement] = STATE(106),
    [sym_try_statement] = STATE(106),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(106),
    [sym_identifier] = ACTIONS(1637),
    [aux_sym_preproc_include_token1] = ACTIONS(1633),
    [aux_sym_preproc_def_token1] = ACTIONS(1633),
    [aux_sym_preproc_if_token1] = ACTIONS(1633),
    [aux_sym_preproc_if_token2] = ACTIONS(1633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1633),
    [aux_sym_preproc_else_token1] = ACTIONS(1633),
    [aux_sym_preproc_elif_token1] = ACTIONS(1633),
    [sym_preproc_directive] = ACTIONS(1633),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP_AMP] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym___extension__] = ACTIONS(375),
    [anon_sym_typedef] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1633),
    [anon_sym___cdecl] = ACTIONS(1633),
    [anon_sym___clrcall] = ACTIONS(1633),
    [anon_sym___stdcall] = ACTIONS(1633),
    [anon_sym___fastcall] = ACTIONS(1633),
    [anon_sym___thiscall] = ACTIONS(1633),
    [anon_sym___vectorcall] = ACTIONS(1633),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_else] = ACTIONS(1633),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(1633),
    [anon_sym_default] = ACTIONS(1633),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1633),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(1633),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_namespace] = ACTIONS(1633),
    [anon_sym_using] = ACTIONS(1633),
    [anon_sym_static_assert] = ACTIONS(1633),
    [anon_sym_concept] = ACTIONS(1633),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [109] = {
    [sym_declaration] = STATE(107),
    [sym_type_definition] = STATE(107),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5902),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(107),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(107),
    [sym_labeled_statement] = STATE(107),
    [sym_expression_statement] = STATE(107),
    [sym_if_statement] = STATE(107),
    [sym_switch_statement] = STATE(107),
    [sym_while_statement] = STATE(107),
    [sym_do_statement] = STATE(107),
    [sym_for_statement] = STATE(107),
    [sym_return_statement] = STATE(107),
    [sym_break_statement] = STATE(107),
    [sym_continue_statement] = STATE(107),
    [sym_goto_statement] = STATE(107),
    [sym_seh_try_statement] = STATE(107),
    [sym_seh_leave_statement] = STATE(107),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(107),
    [sym_co_return_statement] = STATE(107),
    [sym_co_yield_statement] = STATE(107),
    [sym_throw_statement] = STATE(107),
    [sym_try_statement] = STATE(107),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(107),
    [sym_identifier] = ACTIONS(1637),
    [aux_sym_preproc_include_token1] = ACTIONS(1629),
    [aux_sym_preproc_def_token1] = ACTIONS(1629),
    [aux_sym_preproc_if_token1] = ACTIONS(1629),
    [aux_sym_preproc_if_token2] = ACTIONS(1629),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1629),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1629),
    [aux_sym_preproc_else_token1] = ACTIONS(1629),
    [aux_sym_preproc_elif_token1] = ACTIONS(1629),
    [sym_preproc_directive] = ACTIONS(1629),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP_AMP] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym___extension__] = ACTIONS(375),
    [anon_sym_typedef] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1629),
    [anon_sym___cdecl] = ACTIONS(1629),
    [anon_sym___clrcall] = ACTIONS(1629),
    [anon_sym___stdcall] = ACTIONS(1629),
    [anon_sym___fastcall] = ACTIONS(1629),
    [anon_sym___thiscall] = ACTIONS(1629),
    [anon_sym___vectorcall] = ACTIONS(1629),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_else] = ACTIONS(1629),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(1629),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1629),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(1629),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_namespace] = ACTIONS(1629),
    [anon_sym_using] = ACTIONS(1629),
    [anon_sym_static_assert] = ACTIONS(1629),
    [anon_sym_concept] = ACTIONS(1629),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [110] = {
    [sym_declaration] = STATE(123),
    [sym_type_definition] = STATE(123),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5905),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(123),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(123),
    [sym_labeled_statement] = STATE(123),
    [sym_expression_statement] = STATE(123),
    [sym_if_statement] = STATE(123),
    [sym_switch_statement] = STATE(123),
    [sym_while_statement] = STATE(123),
    [sym_do_statement] = STATE(123),
    [sym_for_statement] = STATE(123),
    [sym_return_statement] = STATE(123),
    [sym_break_statement] = STATE(123),
    [sym_continue_statement] = STATE(123),
    [sym_goto_statement] = STATE(123),
    [sym_seh_try_statement] = STATE(123),
    [sym_seh_leave_statement] = STATE(123),
    [sym__expression] = STATE(5326),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9529),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(123),
    [sym_co_return_statement] = STATE(123),
    [sym_co_yield_statement] = STATE(123),
    [sym_throw_statement] = STATE(123),
    [sym_try_statement] = STATE(123),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(123),
    [sym_identifier] = ACTIONS(1699),
    [aux_sym_preproc_include_token1] = ACTIONS(1438),
    [aux_sym_preproc_def_token1] = ACTIONS(1438),
    [aux_sym_preproc_if_token1] = ACTIONS(1438),
    [aux_sym_preproc_if_token2] = ACTIONS(1438),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1438),
    [sym_preproc_directive] = ACTIONS(1438),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym___extension__] = ACTIONS(1111),
    [anon_sym_typedef] = ACTIONS(1113),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1438),
    [anon_sym___cdecl] = ACTIONS(1438),
    [anon_sym___clrcall] = ACTIONS(1438),
    [anon_sym___stdcall] = ACTIONS(1438),
    [anon_sym___fastcall] = ACTIONS(1438),
    [anon_sym___thiscall] = ACTIONS(1438),
    [anon_sym___vectorcall] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(1117),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(1121),
    [anon_sym_else] = ACTIONS(1438),
    [anon_sym_switch] = ACTIONS(1123),
    [anon_sym_case] = ACTIONS(1438),
    [anon_sym_default] = ACTIONS(1438),
    [anon_sym_while] = ACTIONS(1129),
    [anon_sym_do] = ACTIONS(1131),
    [anon_sym_for] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1139),
    [anon_sym_goto] = ACTIONS(1141),
    [anon_sym___try] = ACTIONS(1143),
    [anon_sym___leave] = ACTIONS(1145),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1438),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(1438),
    [anon_sym_try] = ACTIONS(1149),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1151),
    [anon_sym_namespace] = ACTIONS(1438),
    [anon_sym_using] = ACTIONS(1438),
    [anon_sym_static_assert] = ACTIONS(1438),
    [anon_sym_concept] = ACTIONS(1438),
    [anon_sym_co_return] = ACTIONS(1161),
    [anon_sym_co_yield] = ACTIONS(1163),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [111] = {
    [sym_declaration] = STATE(111),
    [sym_type_definition] = STATE(111),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5907),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(111),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(111),
    [sym_labeled_statement] = STATE(111),
    [sym_expression_statement] = STATE(111),
    [sym_if_statement] = STATE(111),
    [sym_switch_statement] = STATE(111),
    [sym_while_statement] = STATE(111),
    [sym_do_statement] = STATE(111),
    [sym_for_statement] = STATE(111),
    [sym_return_statement] = STATE(111),
    [sym_break_statement] = STATE(111),
    [sym_continue_statement] = STATE(111),
    [sym_goto_statement] = STATE(111),
    [sym_seh_try_statement] = STATE(111),
    [sym_seh_leave_statement] = STATE(111),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(111),
    [sym_co_return_statement] = STATE(111),
    [sym_co_yield_statement] = STATE(111),
    [sym_throw_statement] = STATE(111),
    [sym_try_statement] = STATE(111),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(111),
    [sym_identifier] = ACTIONS(1701),
    [aux_sym_preproc_include_token1] = ACTIONS(1445),
    [aux_sym_preproc_def_token1] = ACTIONS(1445),
    [aux_sym_preproc_if_token1] = ACTIONS(1445),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1445),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1445),
    [sym_preproc_directive] = ACTIONS(1445),
    [anon_sym_LPAREN2] = ACTIONS(1447),
    [anon_sym_BANG] = ACTIONS(1450),
    [anon_sym_TILDE] = ACTIONS(1450),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_STAR] = ACTIONS(1456),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1704),
    [anon_sym___extension__] = ACTIONS(1707),
    [anon_sym_typedef] = ACTIONS(1710),
    [anon_sym_extern] = ACTIONS(1473),
    [anon_sym___attribute__] = ACTIONS(1476),
    [anon_sym_COLON_COLON] = ACTIONS(1479),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1482),
    [anon_sym___declspec] = ACTIONS(1485),
    [anon_sym___based] = ACTIONS(1445),
    [anon_sym___cdecl] = ACTIONS(1445),
    [anon_sym___clrcall] = ACTIONS(1445),
    [anon_sym___stdcall] = ACTIONS(1445),
    [anon_sym___fastcall] = ACTIONS(1445),
    [anon_sym___thiscall] = ACTIONS(1445),
    [anon_sym___vectorcall] = ACTIONS(1445),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_RBRACE] = ACTIONS(1459),
    [anon_sym_signed] = ACTIONS(1491),
    [anon_sym_unsigned] = ACTIONS(1491),
    [anon_sym_long] = ACTIONS(1491),
    [anon_sym_short] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(1494),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_register] = ACTIONS(1473),
    [anon_sym_inline] = ACTIONS(1473),
    [anon_sym___inline] = ACTIONS(1473),
    [anon_sym___inline__] = ACTIONS(1473),
    [anon_sym___forceinline] = ACTIONS(1473),
    [anon_sym_thread_local] = ACTIONS(1473),
    [anon_sym___thread] = ACTIONS(1473),
    [anon_sym_const] = ACTIONS(1497),
    [anon_sym_constexpr] = ACTIONS(1497),
    [anon_sym_volatile] = ACTIONS(1497),
    [anon_sym_restrict] = ACTIONS(1497),
    [anon_sym___restrict__] = ACTIONS(1497),
    [anon_sym__Atomic] = ACTIONS(1497),
    [anon_sym__Noreturn] = ACTIONS(1497),
    [anon_sym_noreturn] = ACTIONS(1497),
    [anon_sym_mutable] = ACTIONS(1497),
    [anon_sym_constinit] = ACTIONS(1497),
    [anon_sym_consteval] = ACTIONS(1497),
    [anon_sym_PROGMEM] = ACTIONS(1497),
    [aux_sym_primitive_type_token1] = ACTIONS(1500),
    [anon_sym_byte] = ACTIONS(1500),
    [anon_sym_word] = ACTIONS(1500),
    [anon_sym_enum] = ACTIONS(1503),
    [anon_sym_class] = ACTIONS(1506),
    [anon_sym_struct] = ACTIONS(1509),
    [anon_sym_union] = ACTIONS(1512),
    [anon_sym_if] = ACTIONS(1716),
    [anon_sym_else] = ACTIONS(1445),
    [anon_sym_switch] = ACTIONS(1719),
    [anon_sym_case] = ACTIONS(1445),
    [anon_sym_default] = ACTIONS(1445),
    [anon_sym_while] = ACTIONS(1722),
    [anon_sym_do] = ACTIONS(1725),
    [anon_sym_for] = ACTIONS(1728),
    [anon_sym_return] = ACTIONS(1731),
    [anon_sym_break] = ACTIONS(1734),
    [anon_sym_continue] = ACTIONS(1737),
    [anon_sym_goto] = ACTIONS(1740),
    [anon_sym___try] = ACTIONS(1743),
    [anon_sym___leave] = ACTIONS(1746),
    [anon_sym_not] = ACTIONS(1453),
    [anon_sym_compl] = ACTIONS(1453),
    [anon_sym_DASH_DASH] = ACTIONS(1548),
    [anon_sym_PLUS_PLUS] = ACTIONS(1548),
    [anon_sym_sizeof] = ACTIONS(1551),
    [anon_sym___alignof__] = ACTIONS(1554),
    [anon_sym___alignof] = ACTIONS(1554),
    [anon_sym__alignof] = ACTIONS(1554),
    [anon_sym_alignof] = ACTIONS(1554),
    [anon_sym__Alignof] = ACTIONS(1554),
    [anon_sym_offsetof] = ACTIONS(1557),
    [anon_sym__Generic] = ACTIONS(1560),
    [anon_sym_asm] = ACTIONS(1563),
    [anon_sym___asm__] = ACTIONS(1563),
    [aux_sym_number_literal_token1] = ACTIONS(1566),
    [aux_sym_number_literal_token2] = ACTIONS(1569),
    [anon_sym_L_SQUOTE] = ACTIONS(1572),
    [anon_sym_u_SQUOTE] = ACTIONS(1572),
    [anon_sym_U_SQUOTE] = ACTIONS(1572),
    [anon_sym_u8_SQUOTE] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1572),
    [anon_sym_L_DQUOTE] = ACTIONS(1575),
    [anon_sym_u_DQUOTE] = ACTIONS(1575),
    [anon_sym_U_DQUOTE] = ACTIONS(1575),
    [anon_sym_u8_DQUOTE] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(1575),
    [sym_true] = ACTIONS(1578),
    [sym_false] = ACTIONS(1578),
    [anon_sym_NULL] = ACTIONS(1581),
    [anon_sym_nullptr] = ACTIONS(1581),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1584),
    [anon_sym_decltype] = ACTIONS(1587),
    [anon_sym_virtual] = ACTIONS(1590),
    [anon_sym_alignas] = ACTIONS(1593),
    [anon_sym_explicit] = ACTIONS(1445),
    [anon_sym_typename] = ACTIONS(1596),
    [anon_sym_template] = ACTIONS(1599),
    [anon_sym_operator] = ACTIONS(1445),
    [anon_sym_try] = ACTIONS(1749),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_throw] = ACTIONS(1752),
    [anon_sym_namespace] = ACTIONS(1445),
    [anon_sym_using] = ACTIONS(1445),
    [anon_sym_static_assert] = ACTIONS(1445),
    [anon_sym_concept] = ACTIONS(1445),
    [anon_sym_co_return] = ACTIONS(1755),
    [anon_sym_co_yield] = ACTIONS(1758),
    [anon_sym_R_DQUOTE] = ACTIONS(1617),
    [anon_sym_LR_DQUOTE] = ACTIONS(1617),
    [anon_sym_uR_DQUOTE] = ACTIONS(1617),
    [anon_sym_UR_DQUOTE] = ACTIONS(1617),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1617),
    [anon_sym_co_await] = ACTIONS(1620),
    [anon_sym_new] = ACTIONS(1623),
    [anon_sym_requires] = ACTIONS(1626),
    [sym_this] = ACTIONS(1578),
  },
  [112] = {
    [sym_declaration] = STATE(113),
    [sym_type_definition] = STATE(113),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5946),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(113),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(113),
    [sym_labeled_statement] = STATE(113),
    [sym_expression_statement] = STATE(113),
    [sym_if_statement] = STATE(113),
    [sym_switch_statement] = STATE(113),
    [sym_while_statement] = STATE(113),
    [sym_do_statement] = STATE(113),
    [sym_for_statement] = STATE(113),
    [sym_return_statement] = STATE(113),
    [sym_break_statement] = STATE(113),
    [sym_continue_statement] = STATE(113),
    [sym_goto_statement] = STATE(113),
    [sym_seh_try_statement] = STATE(113),
    [sym_seh_leave_statement] = STATE(113),
    [sym__expression] = STATE(5249),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9175),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(113),
    [sym_co_return_statement] = STATE(113),
    [sym_co_yield_statement] = STATE(113),
    [sym_throw_statement] = STATE(113),
    [sym_try_statement] = STATE(113),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(228),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(113),
    [ts_builtin_sym_end] = ACTIONS(1631),
    [sym_identifier] = ACTIONS(1761),
    [aux_sym_preproc_include_token1] = ACTIONS(1629),
    [aux_sym_preproc_def_token1] = ACTIONS(1629),
    [aux_sym_preproc_if_token1] = ACTIONS(1629),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1629),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1629),
    [sym_preproc_directive] = ACTIONS(1629),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP_AMP] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1629),
    [anon_sym___cdecl] = ACTIONS(1629),
    [anon_sym___clrcall] = ACTIONS(1629),
    [anon_sym___stdcall] = ACTIONS(1629),
    [anon_sym___fastcall] = ACTIONS(1629),
    [anon_sym___thiscall] = ACTIONS(1629),
    [anon_sym___vectorcall] = ACTIONS(1629),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_else] = ACTIONS(1629),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(1629),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(1765),
    [anon_sym___leave] = ACTIONS(1767),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1629),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(1629),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1629),
    [anon_sym_using] = ACTIONS(1629),
    [anon_sym_static_assert] = ACTIONS(1629),
    [anon_sym_concept] = ACTIONS(1629),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [113] = {
    [sym_declaration] = STATE(116),
    [sym_type_definition] = STATE(116),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5946),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(116),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(116),
    [sym_labeled_statement] = STATE(116),
    [sym_expression_statement] = STATE(116),
    [sym_if_statement] = STATE(116),
    [sym_switch_statement] = STATE(116),
    [sym_while_statement] = STATE(116),
    [sym_do_statement] = STATE(116),
    [sym_for_statement] = STATE(116),
    [sym_return_statement] = STATE(116),
    [sym_break_statement] = STATE(116),
    [sym_continue_statement] = STATE(116),
    [sym_goto_statement] = STATE(116),
    [sym_seh_try_statement] = STATE(116),
    [sym_seh_leave_statement] = STATE(116),
    [sym__expression] = STATE(5249),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9175),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(116),
    [sym_co_return_statement] = STATE(116),
    [sym_co_yield_statement] = STATE(116),
    [sym_throw_statement] = STATE(116),
    [sym_try_statement] = STATE(116),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(228),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(116),
    [ts_builtin_sym_end] = ACTIONS(1440),
    [sym_identifier] = ACTIONS(1761),
    [aux_sym_preproc_include_token1] = ACTIONS(1438),
    [aux_sym_preproc_def_token1] = ACTIONS(1438),
    [aux_sym_preproc_if_token1] = ACTIONS(1438),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1438),
    [sym_preproc_directive] = ACTIONS(1438),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1438),
    [anon_sym___cdecl] = ACTIONS(1438),
    [anon_sym___clrcall] = ACTIONS(1438),
    [anon_sym___stdcall] = ACTIONS(1438),
    [anon_sym___fastcall] = ACTIONS(1438),
    [anon_sym___thiscall] = ACTIONS(1438),
    [anon_sym___vectorcall] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_else] = ACTIONS(1438),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(1438),
    [anon_sym_default] = ACTIONS(1438),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(1765),
    [anon_sym___leave] = ACTIONS(1767),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1438),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(1438),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1438),
    [anon_sym_using] = ACTIONS(1438),
    [anon_sym_static_assert] = ACTIONS(1438),
    [anon_sym_concept] = ACTIONS(1438),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [114] = {
    [sym_declaration] = STATE(116),
    [sym_type_definition] = STATE(116),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5946),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(116),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(116),
    [sym_labeled_statement] = STATE(116),
    [sym_expression_statement] = STATE(116),
    [sym_if_statement] = STATE(116),
    [sym_switch_statement] = STATE(116),
    [sym_while_statement] = STATE(116),
    [sym_do_statement] = STATE(116),
    [sym_for_statement] = STATE(116),
    [sym_return_statement] = STATE(116),
    [sym_break_statement] = STATE(116),
    [sym_continue_statement] = STATE(116),
    [sym_goto_statement] = STATE(116),
    [sym_seh_try_statement] = STATE(116),
    [sym_seh_leave_statement] = STATE(116),
    [sym__expression] = STATE(5249),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9175),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(116),
    [sym_co_return_statement] = STATE(116),
    [sym_co_yield_statement] = STATE(116),
    [sym_throw_statement] = STATE(116),
    [sym_try_statement] = STATE(116),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(228),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(116),
    [ts_builtin_sym_end] = ACTIONS(1635),
    [sym_identifier] = ACTIONS(1761),
    [aux_sym_preproc_include_token1] = ACTIONS(1633),
    [aux_sym_preproc_def_token1] = ACTIONS(1633),
    [aux_sym_preproc_if_token1] = ACTIONS(1633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1633),
    [sym_preproc_directive] = ACTIONS(1633),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP_AMP] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1633),
    [anon_sym___cdecl] = ACTIONS(1633),
    [anon_sym___clrcall] = ACTIONS(1633),
    [anon_sym___stdcall] = ACTIONS(1633),
    [anon_sym___fastcall] = ACTIONS(1633),
    [anon_sym___thiscall] = ACTIONS(1633),
    [anon_sym___vectorcall] = ACTIONS(1633),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_else] = ACTIONS(1633),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(1633),
    [anon_sym_default] = ACTIONS(1633),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(1765),
    [anon_sym___leave] = ACTIONS(1767),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1633),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(1633),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1633),
    [anon_sym_using] = ACTIONS(1633),
    [anon_sym_static_assert] = ACTIONS(1633),
    [anon_sym_concept] = ACTIONS(1633),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [115] = {
    [sym_declaration] = STATE(114),
    [sym_type_definition] = STATE(114),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5946),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(114),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(114),
    [sym_labeled_statement] = STATE(114),
    [sym_expression_statement] = STATE(114),
    [sym_if_statement] = STATE(114),
    [sym_switch_statement] = STATE(114),
    [sym_while_statement] = STATE(114),
    [sym_do_statement] = STATE(114),
    [sym_for_statement] = STATE(114),
    [sym_return_statement] = STATE(114),
    [sym_break_statement] = STATE(114),
    [sym_continue_statement] = STATE(114),
    [sym_goto_statement] = STATE(114),
    [sym_seh_try_statement] = STATE(114),
    [sym_seh_leave_statement] = STATE(114),
    [sym__expression] = STATE(5249),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9175),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(114),
    [sym_co_return_statement] = STATE(114),
    [sym_co_yield_statement] = STATE(114),
    [sym_throw_statement] = STATE(114),
    [sym_try_statement] = STATE(114),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(228),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(114),
    [ts_builtin_sym_end] = ACTIONS(1428),
    [sym_identifier] = ACTIONS(1761),
    [aux_sym_preproc_include_token1] = ACTIONS(1422),
    [aux_sym_preproc_def_token1] = ACTIONS(1422),
    [aux_sym_preproc_if_token1] = ACTIONS(1422),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1422),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1422),
    [sym_preproc_directive] = ACTIONS(1422),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP_AMP] = ACTIONS(1428),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1422),
    [anon_sym___cdecl] = ACTIONS(1422),
    [anon_sym___clrcall] = ACTIONS(1422),
    [anon_sym___stdcall] = ACTIONS(1422),
    [anon_sym___fastcall] = ACTIONS(1422),
    [anon_sym___thiscall] = ACTIONS(1422),
    [anon_sym___vectorcall] = ACTIONS(1422),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_else] = ACTIONS(1422),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(1422),
    [anon_sym_default] = ACTIONS(1422),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(1765),
    [anon_sym___leave] = ACTIONS(1767),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1422),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(1422),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1422),
    [anon_sym_using] = ACTIONS(1422),
    [anon_sym_static_assert] = ACTIONS(1422),
    [anon_sym_concept] = ACTIONS(1422),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [116] = {
    [sym_declaration] = STATE(116),
    [sym_type_definition] = STATE(116),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5946),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(116),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(116),
    [sym_labeled_statement] = STATE(116),
    [sym_expression_statement] = STATE(116),
    [sym_if_statement] = STATE(116),
    [sym_switch_statement] = STATE(116),
    [sym_while_statement] = STATE(116),
    [sym_do_statement] = STATE(116),
    [sym_for_statement] = STATE(116),
    [sym_return_statement] = STATE(116),
    [sym_break_statement] = STATE(116),
    [sym_continue_statement] = STATE(116),
    [sym_goto_statement] = STATE(116),
    [sym_seh_try_statement] = STATE(116),
    [sym_seh_leave_statement] = STATE(116),
    [sym__expression] = STATE(5249),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9175),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(116),
    [sym_co_return_statement] = STATE(116),
    [sym_co_yield_statement] = STATE(116),
    [sym_throw_statement] = STATE(116),
    [sym_try_statement] = STATE(116),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(228),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(116),
    [ts_builtin_sym_end] = ACTIONS(1459),
    [sym_identifier] = ACTIONS(1769),
    [aux_sym_preproc_include_token1] = ACTIONS(1445),
    [aux_sym_preproc_def_token1] = ACTIONS(1445),
    [aux_sym_preproc_if_token1] = ACTIONS(1445),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1445),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1445),
    [sym_preproc_directive] = ACTIONS(1445),
    [anon_sym_LPAREN2] = ACTIONS(1447),
    [anon_sym_BANG] = ACTIONS(1450),
    [anon_sym_TILDE] = ACTIONS(1450),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_STAR] = ACTIONS(1456),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1772),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_typedef] = ACTIONS(1778),
    [anon_sym_extern] = ACTIONS(1473),
    [anon_sym___attribute__] = ACTIONS(1476),
    [anon_sym_COLON_COLON] = ACTIONS(1479),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1482),
    [anon_sym___declspec] = ACTIONS(1485),
    [anon_sym___based] = ACTIONS(1445),
    [anon_sym___cdecl] = ACTIONS(1445),
    [anon_sym___clrcall] = ACTIONS(1445),
    [anon_sym___stdcall] = ACTIONS(1445),
    [anon_sym___fastcall] = ACTIONS(1445),
    [anon_sym___thiscall] = ACTIONS(1445),
    [anon_sym___vectorcall] = ACTIONS(1445),
    [anon_sym_LBRACE] = ACTIONS(1781),
    [anon_sym_signed] = ACTIONS(1491),
    [anon_sym_unsigned] = ACTIONS(1491),
    [anon_sym_long] = ACTIONS(1491),
    [anon_sym_short] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(1494),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_register] = ACTIONS(1473),
    [anon_sym_inline] = ACTIONS(1473),
    [anon_sym___inline] = ACTIONS(1473),
    [anon_sym___inline__] = ACTIONS(1473),
    [anon_sym___forceinline] = ACTIONS(1473),
    [anon_sym_thread_local] = ACTIONS(1473),
    [anon_sym___thread] = ACTIONS(1473),
    [anon_sym_const] = ACTIONS(1497),
    [anon_sym_constexpr] = ACTIONS(1497),
    [anon_sym_volatile] = ACTIONS(1497),
    [anon_sym_restrict] = ACTIONS(1497),
    [anon_sym___restrict__] = ACTIONS(1497),
    [anon_sym__Atomic] = ACTIONS(1497),
    [anon_sym__Noreturn] = ACTIONS(1497),
    [anon_sym_noreturn] = ACTIONS(1497),
    [anon_sym_mutable] = ACTIONS(1497),
    [anon_sym_constinit] = ACTIONS(1497),
    [anon_sym_consteval] = ACTIONS(1497),
    [anon_sym_PROGMEM] = ACTIONS(1497),
    [aux_sym_primitive_type_token1] = ACTIONS(1500),
    [anon_sym_byte] = ACTIONS(1500),
    [anon_sym_word] = ACTIONS(1500),
    [anon_sym_enum] = ACTIONS(1503),
    [anon_sym_class] = ACTIONS(1506),
    [anon_sym_struct] = ACTIONS(1509),
    [anon_sym_union] = ACTIONS(1512),
    [anon_sym_if] = ACTIONS(1784),
    [anon_sym_else] = ACTIONS(1445),
    [anon_sym_switch] = ACTIONS(1787),
    [anon_sym_case] = ACTIONS(1445),
    [anon_sym_default] = ACTIONS(1445),
    [anon_sym_while] = ACTIONS(1790),
    [anon_sym_do] = ACTIONS(1793),
    [anon_sym_for] = ACTIONS(1796),
    [anon_sym_return] = ACTIONS(1799),
    [anon_sym_break] = ACTIONS(1802),
    [anon_sym_continue] = ACTIONS(1805),
    [anon_sym_goto] = ACTIONS(1808),
    [anon_sym___try] = ACTIONS(1811),
    [anon_sym___leave] = ACTIONS(1814),
    [anon_sym_not] = ACTIONS(1453),
    [anon_sym_compl] = ACTIONS(1453),
    [anon_sym_DASH_DASH] = ACTIONS(1548),
    [anon_sym_PLUS_PLUS] = ACTIONS(1548),
    [anon_sym_sizeof] = ACTIONS(1551),
    [anon_sym___alignof__] = ACTIONS(1554),
    [anon_sym___alignof] = ACTIONS(1554),
    [anon_sym__alignof] = ACTIONS(1554),
    [anon_sym_alignof] = ACTIONS(1554),
    [anon_sym__Alignof] = ACTIONS(1554),
    [anon_sym_offsetof] = ACTIONS(1557),
    [anon_sym__Generic] = ACTIONS(1560),
    [anon_sym_asm] = ACTIONS(1563),
    [anon_sym___asm__] = ACTIONS(1563),
    [aux_sym_number_literal_token1] = ACTIONS(1566),
    [aux_sym_number_literal_token2] = ACTIONS(1569),
    [anon_sym_L_SQUOTE] = ACTIONS(1572),
    [anon_sym_u_SQUOTE] = ACTIONS(1572),
    [anon_sym_U_SQUOTE] = ACTIONS(1572),
    [anon_sym_u8_SQUOTE] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1572),
    [anon_sym_L_DQUOTE] = ACTIONS(1575),
    [anon_sym_u_DQUOTE] = ACTIONS(1575),
    [anon_sym_U_DQUOTE] = ACTIONS(1575),
    [anon_sym_u8_DQUOTE] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(1575),
    [sym_true] = ACTIONS(1578),
    [sym_false] = ACTIONS(1578),
    [anon_sym_NULL] = ACTIONS(1581),
    [anon_sym_nullptr] = ACTIONS(1581),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1584),
    [anon_sym_decltype] = ACTIONS(1587),
    [anon_sym_virtual] = ACTIONS(1590),
    [anon_sym_alignas] = ACTIONS(1593),
    [anon_sym_explicit] = ACTIONS(1445),
    [anon_sym_typename] = ACTIONS(1596),
    [anon_sym_template] = ACTIONS(1599),
    [anon_sym_operator] = ACTIONS(1445),
    [anon_sym_try] = ACTIONS(1817),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_throw] = ACTIONS(1820),
    [anon_sym_namespace] = ACTIONS(1445),
    [anon_sym_using] = ACTIONS(1445),
    [anon_sym_static_assert] = ACTIONS(1445),
    [anon_sym_concept] = ACTIONS(1445),
    [anon_sym_co_return] = ACTIONS(1823),
    [anon_sym_co_yield] = ACTIONS(1826),
    [anon_sym_R_DQUOTE] = ACTIONS(1617),
    [anon_sym_LR_DQUOTE] = ACTIONS(1617),
    [anon_sym_uR_DQUOTE] = ACTIONS(1617),
    [anon_sym_UR_DQUOTE] = ACTIONS(1617),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1617),
    [anon_sym_co_await] = ACTIONS(1620),
    [anon_sym_new] = ACTIONS(1623),
    [anon_sym_requires] = ACTIONS(1626),
    [sym_this] = ACTIONS(1578),
  },
  [117] = {
    [sym_declaration] = STATE(119),
    [sym_type_definition] = STATE(119),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5907),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(119),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(119),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(119),
    [sym_co_return_statement] = STATE(119),
    [sym_co_yield_statement] = STATE(119),
    [sym_throw_statement] = STATE(119),
    [sym_try_statement] = STATE(119),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(119),
    [sym_identifier] = ACTIONS(1829),
    [aux_sym_preproc_include_token1] = ACTIONS(1422),
    [aux_sym_preproc_def_token1] = ACTIONS(1422),
    [aux_sym_preproc_if_token1] = ACTIONS(1422),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1422),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1422),
    [sym_preproc_directive] = ACTIONS(1422),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP_AMP] = ACTIONS(1428),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1422),
    [anon_sym___cdecl] = ACTIONS(1422),
    [anon_sym___clrcall] = ACTIONS(1422),
    [anon_sym___stdcall] = ACTIONS(1422),
    [anon_sym___fastcall] = ACTIONS(1422),
    [anon_sym___thiscall] = ACTIONS(1422),
    [anon_sym___vectorcall] = ACTIONS(1422),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(1428),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_else] = ACTIONS(1422),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(1422),
    [anon_sym_default] = ACTIONS(1422),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1422),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(1422),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(1422),
    [anon_sym_using] = ACTIONS(1422),
    [anon_sym_static_assert] = ACTIONS(1422),
    [anon_sym_concept] = ACTIONS(1422),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [118] = {
    [sym_declaration] = STATE(120),
    [sym_type_definition] = STATE(120),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5907),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(120),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(120),
    [sym_labeled_statement] = STATE(120),
    [sym_expression_statement] = STATE(120),
    [sym_if_statement] = STATE(120),
    [sym_switch_statement] = STATE(120),
    [sym_while_statement] = STATE(120),
    [sym_do_statement] = STATE(120),
    [sym_for_statement] = STATE(120),
    [sym_return_statement] = STATE(120),
    [sym_break_statement] = STATE(120),
    [sym_continue_statement] = STATE(120),
    [sym_goto_statement] = STATE(120),
    [sym_seh_try_statement] = STATE(120),
    [sym_seh_leave_statement] = STATE(120),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(120),
    [sym_co_return_statement] = STATE(120),
    [sym_co_yield_statement] = STATE(120),
    [sym_throw_statement] = STATE(120),
    [sym_try_statement] = STATE(120),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(120),
    [sym_identifier] = ACTIONS(1829),
    [aux_sym_preproc_include_token1] = ACTIONS(1629),
    [aux_sym_preproc_def_token1] = ACTIONS(1629),
    [aux_sym_preproc_if_token1] = ACTIONS(1629),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1629),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1629),
    [sym_preproc_directive] = ACTIONS(1629),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP_AMP] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1629),
    [anon_sym___cdecl] = ACTIONS(1629),
    [anon_sym___clrcall] = ACTIONS(1629),
    [anon_sym___stdcall] = ACTIONS(1629),
    [anon_sym___fastcall] = ACTIONS(1629),
    [anon_sym___thiscall] = ACTIONS(1629),
    [anon_sym___vectorcall] = ACTIONS(1629),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(1631),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_else] = ACTIONS(1629),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(1629),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1629),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(1629),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(1629),
    [anon_sym_using] = ACTIONS(1629),
    [anon_sym_static_assert] = ACTIONS(1629),
    [anon_sym_concept] = ACTIONS(1629),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [119] = {
    [sym_declaration] = STATE(111),
    [sym_type_definition] = STATE(111),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5907),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(111),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(111),
    [sym_labeled_statement] = STATE(111),
    [sym_expression_statement] = STATE(111),
    [sym_if_statement] = STATE(111),
    [sym_switch_statement] = STATE(111),
    [sym_while_statement] = STATE(111),
    [sym_do_statement] = STATE(111),
    [sym_for_statement] = STATE(111),
    [sym_return_statement] = STATE(111),
    [sym_break_statement] = STATE(111),
    [sym_continue_statement] = STATE(111),
    [sym_goto_statement] = STATE(111),
    [sym_seh_try_statement] = STATE(111),
    [sym_seh_leave_statement] = STATE(111),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(111),
    [sym_co_return_statement] = STATE(111),
    [sym_co_yield_statement] = STATE(111),
    [sym_throw_statement] = STATE(111),
    [sym_try_statement] = STATE(111),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(111),
    [sym_identifier] = ACTIONS(1829),
    [aux_sym_preproc_include_token1] = ACTIONS(1633),
    [aux_sym_preproc_def_token1] = ACTIONS(1633),
    [aux_sym_preproc_if_token1] = ACTIONS(1633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1633),
    [sym_preproc_directive] = ACTIONS(1633),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP_AMP] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1633),
    [anon_sym___cdecl] = ACTIONS(1633),
    [anon_sym___clrcall] = ACTIONS(1633),
    [anon_sym___stdcall] = ACTIONS(1633),
    [anon_sym___fastcall] = ACTIONS(1633),
    [anon_sym___thiscall] = ACTIONS(1633),
    [anon_sym___vectorcall] = ACTIONS(1633),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(1635),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_else] = ACTIONS(1633),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(1633),
    [anon_sym_default] = ACTIONS(1633),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1633),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(1633),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(1633),
    [anon_sym_using] = ACTIONS(1633),
    [anon_sym_static_assert] = ACTIONS(1633),
    [anon_sym_concept] = ACTIONS(1633),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [120] = {
    [sym_declaration] = STATE(111),
    [sym_type_definition] = STATE(111),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5907),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(111),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(111),
    [sym_labeled_statement] = STATE(111),
    [sym_expression_statement] = STATE(111),
    [sym_if_statement] = STATE(111),
    [sym_switch_statement] = STATE(111),
    [sym_while_statement] = STATE(111),
    [sym_do_statement] = STATE(111),
    [sym_for_statement] = STATE(111),
    [sym_return_statement] = STATE(111),
    [sym_break_statement] = STATE(111),
    [sym_continue_statement] = STATE(111),
    [sym_goto_statement] = STATE(111),
    [sym_seh_try_statement] = STATE(111),
    [sym_seh_leave_statement] = STATE(111),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(111),
    [sym_co_return_statement] = STATE(111),
    [sym_co_yield_statement] = STATE(111),
    [sym_throw_statement] = STATE(111),
    [sym_try_statement] = STATE(111),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(111),
    [sym_identifier] = ACTIONS(1829),
    [aux_sym_preproc_include_token1] = ACTIONS(1438),
    [aux_sym_preproc_def_token1] = ACTIONS(1438),
    [aux_sym_preproc_if_token1] = ACTIONS(1438),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1438),
    [sym_preproc_directive] = ACTIONS(1438),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1438),
    [anon_sym___cdecl] = ACTIONS(1438),
    [anon_sym___clrcall] = ACTIONS(1438),
    [anon_sym___stdcall] = ACTIONS(1438),
    [anon_sym___fastcall] = ACTIONS(1438),
    [anon_sym___thiscall] = ACTIONS(1438),
    [anon_sym___vectorcall] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(1440),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_else] = ACTIONS(1438),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(1438),
    [anon_sym_default] = ACTIONS(1438),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1438),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(1438),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(1438),
    [anon_sym_using] = ACTIONS(1438),
    [anon_sym_static_assert] = ACTIONS(1438),
    [anon_sym_concept] = ACTIONS(1438),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [121] = {
    [sym_declaration] = STATE(110),
    [sym_type_definition] = STATE(110),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5905),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(110),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(110),
    [sym_labeled_statement] = STATE(110),
    [sym_expression_statement] = STATE(110),
    [sym_if_statement] = STATE(110),
    [sym_switch_statement] = STATE(110),
    [sym_while_statement] = STATE(110),
    [sym_do_statement] = STATE(110),
    [sym_for_statement] = STATE(110),
    [sym_return_statement] = STATE(110),
    [sym_break_statement] = STATE(110),
    [sym_continue_statement] = STATE(110),
    [sym_goto_statement] = STATE(110),
    [sym_seh_try_statement] = STATE(110),
    [sym_seh_leave_statement] = STATE(110),
    [sym__expression] = STATE(5326),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9529),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(110),
    [sym_co_return_statement] = STATE(110),
    [sym_co_yield_statement] = STATE(110),
    [sym_throw_statement] = STATE(110),
    [sym_try_statement] = STATE(110),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(110),
    [sym_identifier] = ACTIONS(1699),
    [aux_sym_preproc_include_token1] = ACTIONS(1629),
    [aux_sym_preproc_def_token1] = ACTIONS(1629),
    [aux_sym_preproc_if_token1] = ACTIONS(1629),
    [aux_sym_preproc_if_token2] = ACTIONS(1629),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1629),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1629),
    [sym_preproc_directive] = ACTIONS(1629),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP_AMP] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym___extension__] = ACTIONS(1111),
    [anon_sym_typedef] = ACTIONS(1113),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1629),
    [anon_sym___cdecl] = ACTIONS(1629),
    [anon_sym___clrcall] = ACTIONS(1629),
    [anon_sym___stdcall] = ACTIONS(1629),
    [anon_sym___fastcall] = ACTIONS(1629),
    [anon_sym___thiscall] = ACTIONS(1629),
    [anon_sym___vectorcall] = ACTIONS(1629),
    [anon_sym_LBRACE] = ACTIONS(1117),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(1121),
    [anon_sym_else] = ACTIONS(1629),
    [anon_sym_switch] = ACTIONS(1123),
    [anon_sym_case] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(1629),
    [anon_sym_while] = ACTIONS(1129),
    [anon_sym_do] = ACTIONS(1131),
    [anon_sym_for] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1139),
    [anon_sym_goto] = ACTIONS(1141),
    [anon_sym___try] = ACTIONS(1143),
    [anon_sym___leave] = ACTIONS(1145),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1629),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(1629),
    [anon_sym_try] = ACTIONS(1149),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1151),
    [anon_sym_namespace] = ACTIONS(1629),
    [anon_sym_using] = ACTIONS(1629),
    [anon_sym_static_assert] = ACTIONS(1629),
    [anon_sym_concept] = ACTIONS(1629),
    [anon_sym_co_return] = ACTIONS(1161),
    [anon_sym_co_yield] = ACTIONS(1163),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [122] = {
    [sym_declaration] = STATE(123),
    [sym_type_definition] = STATE(123),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5905),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(123),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(123),
    [sym_labeled_statement] = STATE(123),
    [sym_expression_statement] = STATE(123),
    [sym_if_statement] = STATE(123),
    [sym_switch_statement] = STATE(123),
    [sym_while_statement] = STATE(123),
    [sym_do_statement] = STATE(123),
    [sym_for_statement] = STATE(123),
    [sym_return_statement] = STATE(123),
    [sym_break_statement] = STATE(123),
    [sym_continue_statement] = STATE(123),
    [sym_goto_statement] = STATE(123),
    [sym_seh_try_statement] = STATE(123),
    [sym_seh_leave_statement] = STATE(123),
    [sym__expression] = STATE(5326),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9529),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(123),
    [sym_co_return_statement] = STATE(123),
    [sym_co_yield_statement] = STATE(123),
    [sym_throw_statement] = STATE(123),
    [sym_try_statement] = STATE(123),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(123),
    [sym_identifier] = ACTIONS(1699),
    [aux_sym_preproc_include_token1] = ACTIONS(1633),
    [aux_sym_preproc_def_token1] = ACTIONS(1633),
    [aux_sym_preproc_if_token1] = ACTIONS(1633),
    [aux_sym_preproc_if_token2] = ACTIONS(1633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1633),
    [sym_preproc_directive] = ACTIONS(1633),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP_AMP] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym___extension__] = ACTIONS(1111),
    [anon_sym_typedef] = ACTIONS(1113),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1633),
    [anon_sym___cdecl] = ACTIONS(1633),
    [anon_sym___clrcall] = ACTIONS(1633),
    [anon_sym___stdcall] = ACTIONS(1633),
    [anon_sym___fastcall] = ACTIONS(1633),
    [anon_sym___thiscall] = ACTIONS(1633),
    [anon_sym___vectorcall] = ACTIONS(1633),
    [anon_sym_LBRACE] = ACTIONS(1117),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(1121),
    [anon_sym_else] = ACTIONS(1633),
    [anon_sym_switch] = ACTIONS(1123),
    [anon_sym_case] = ACTIONS(1633),
    [anon_sym_default] = ACTIONS(1633),
    [anon_sym_while] = ACTIONS(1129),
    [anon_sym_do] = ACTIONS(1131),
    [anon_sym_for] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1139),
    [anon_sym_goto] = ACTIONS(1141),
    [anon_sym___try] = ACTIONS(1143),
    [anon_sym___leave] = ACTIONS(1145),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1633),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(1633),
    [anon_sym_try] = ACTIONS(1149),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1151),
    [anon_sym_namespace] = ACTIONS(1633),
    [anon_sym_using] = ACTIONS(1633),
    [anon_sym_static_assert] = ACTIONS(1633),
    [anon_sym_concept] = ACTIONS(1633),
    [anon_sym_co_return] = ACTIONS(1161),
    [anon_sym_co_yield] = ACTIONS(1163),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [123] = {
    [sym_declaration] = STATE(123),
    [sym_type_definition] = STATE(123),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5905),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(123),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(123),
    [sym_labeled_statement] = STATE(123),
    [sym_expression_statement] = STATE(123),
    [sym_if_statement] = STATE(123),
    [sym_switch_statement] = STATE(123),
    [sym_while_statement] = STATE(123),
    [sym_do_statement] = STATE(123),
    [sym_for_statement] = STATE(123),
    [sym_return_statement] = STATE(123),
    [sym_break_statement] = STATE(123),
    [sym_continue_statement] = STATE(123),
    [sym_goto_statement] = STATE(123),
    [sym_seh_try_statement] = STATE(123),
    [sym_seh_leave_statement] = STATE(123),
    [sym__expression] = STATE(5326),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9529),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(123),
    [sym_co_return_statement] = STATE(123),
    [sym_co_yield_statement] = STATE(123),
    [sym_throw_statement] = STATE(123),
    [sym_try_statement] = STATE(123),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(123),
    [sym_identifier] = ACTIONS(1831),
    [aux_sym_preproc_include_token1] = ACTIONS(1445),
    [aux_sym_preproc_def_token1] = ACTIONS(1445),
    [aux_sym_preproc_if_token1] = ACTIONS(1445),
    [aux_sym_preproc_if_token2] = ACTIONS(1445),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1445),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1445),
    [sym_preproc_directive] = ACTIONS(1445),
    [anon_sym_LPAREN2] = ACTIONS(1447),
    [anon_sym_BANG] = ACTIONS(1450),
    [anon_sym_TILDE] = ACTIONS(1450),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_STAR] = ACTIONS(1456),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym___extension__] = ACTIONS(1837),
    [anon_sym_typedef] = ACTIONS(1840),
    [anon_sym_extern] = ACTIONS(1473),
    [anon_sym___attribute__] = ACTIONS(1476),
    [anon_sym_COLON_COLON] = ACTIONS(1479),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1482),
    [anon_sym___declspec] = ACTIONS(1485),
    [anon_sym___based] = ACTIONS(1445),
    [anon_sym___cdecl] = ACTIONS(1445),
    [anon_sym___clrcall] = ACTIONS(1445),
    [anon_sym___stdcall] = ACTIONS(1445),
    [anon_sym___fastcall] = ACTIONS(1445),
    [anon_sym___thiscall] = ACTIONS(1445),
    [anon_sym___vectorcall] = ACTIONS(1445),
    [anon_sym_LBRACE] = ACTIONS(1843),
    [anon_sym_signed] = ACTIONS(1491),
    [anon_sym_unsigned] = ACTIONS(1491),
    [anon_sym_long] = ACTIONS(1491),
    [anon_sym_short] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(1494),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_register] = ACTIONS(1473),
    [anon_sym_inline] = ACTIONS(1473),
    [anon_sym___inline] = ACTIONS(1473),
    [anon_sym___inline__] = ACTIONS(1473),
    [anon_sym___forceinline] = ACTIONS(1473),
    [anon_sym_thread_local] = ACTIONS(1473),
    [anon_sym___thread] = ACTIONS(1473),
    [anon_sym_const] = ACTIONS(1497),
    [anon_sym_constexpr] = ACTIONS(1497),
    [anon_sym_volatile] = ACTIONS(1497),
    [anon_sym_restrict] = ACTIONS(1497),
    [anon_sym___restrict__] = ACTIONS(1497),
    [anon_sym__Atomic] = ACTIONS(1497),
    [anon_sym__Noreturn] = ACTIONS(1497),
    [anon_sym_noreturn] = ACTIONS(1497),
    [anon_sym_mutable] = ACTIONS(1497),
    [anon_sym_constinit] = ACTIONS(1497),
    [anon_sym_consteval] = ACTIONS(1497),
    [anon_sym_PROGMEM] = ACTIONS(1497),
    [aux_sym_primitive_type_token1] = ACTIONS(1500),
    [anon_sym_byte] = ACTIONS(1500),
    [anon_sym_word] = ACTIONS(1500),
    [anon_sym_enum] = ACTIONS(1503),
    [anon_sym_class] = ACTIONS(1506),
    [anon_sym_struct] = ACTIONS(1509),
    [anon_sym_union] = ACTIONS(1512),
    [anon_sym_if] = ACTIONS(1846),
    [anon_sym_else] = ACTIONS(1445),
    [anon_sym_switch] = ACTIONS(1849),
    [anon_sym_case] = ACTIONS(1445),
    [anon_sym_default] = ACTIONS(1445),
    [anon_sym_while] = ACTIONS(1852),
    [anon_sym_do] = ACTIONS(1855),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_return] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1864),
    [anon_sym_continue] = ACTIONS(1867),
    [anon_sym_goto] = ACTIONS(1870),
    [anon_sym___try] = ACTIONS(1873),
    [anon_sym___leave] = ACTIONS(1876),
    [anon_sym_not] = ACTIONS(1453),
    [anon_sym_compl] = ACTIONS(1453),
    [anon_sym_DASH_DASH] = ACTIONS(1548),
    [anon_sym_PLUS_PLUS] = ACTIONS(1548),
    [anon_sym_sizeof] = ACTIONS(1551),
    [anon_sym___alignof__] = ACTIONS(1554),
    [anon_sym___alignof] = ACTIONS(1554),
    [anon_sym__alignof] = ACTIONS(1554),
    [anon_sym_alignof] = ACTIONS(1554),
    [anon_sym__Alignof] = ACTIONS(1554),
    [anon_sym_offsetof] = ACTIONS(1557),
    [anon_sym__Generic] = ACTIONS(1560),
    [anon_sym_asm] = ACTIONS(1563),
    [anon_sym___asm__] = ACTIONS(1563),
    [aux_sym_number_literal_token1] = ACTIONS(1566),
    [aux_sym_number_literal_token2] = ACTIONS(1569),
    [anon_sym_L_SQUOTE] = ACTIONS(1572),
    [anon_sym_u_SQUOTE] = ACTIONS(1572),
    [anon_sym_U_SQUOTE] = ACTIONS(1572),
    [anon_sym_u8_SQUOTE] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1572),
    [anon_sym_L_DQUOTE] = ACTIONS(1575),
    [anon_sym_u_DQUOTE] = ACTIONS(1575),
    [anon_sym_U_DQUOTE] = ACTIONS(1575),
    [anon_sym_u8_DQUOTE] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(1575),
    [sym_true] = ACTIONS(1578),
    [sym_false] = ACTIONS(1578),
    [anon_sym_NULL] = ACTIONS(1581),
    [anon_sym_nullptr] = ACTIONS(1581),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1584),
    [anon_sym_decltype] = ACTIONS(1587),
    [anon_sym_virtual] = ACTIONS(1590),
    [anon_sym_alignas] = ACTIONS(1593),
    [anon_sym_explicit] = ACTIONS(1445),
    [anon_sym_typename] = ACTIONS(1596),
    [anon_sym_template] = ACTIONS(1599),
    [anon_sym_operator] = ACTIONS(1445),
    [anon_sym_try] = ACTIONS(1879),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_throw] = ACTIONS(1882),
    [anon_sym_namespace] = ACTIONS(1445),
    [anon_sym_using] = ACTIONS(1445),
    [anon_sym_static_assert] = ACTIONS(1445),
    [anon_sym_concept] = ACTIONS(1445),
    [anon_sym_co_return] = ACTIONS(1885),
    [anon_sym_co_yield] = ACTIONS(1888),
    [anon_sym_R_DQUOTE] = ACTIONS(1617),
    [anon_sym_LR_DQUOTE] = ACTIONS(1617),
    [anon_sym_uR_DQUOTE] = ACTIONS(1617),
    [anon_sym_UR_DQUOTE] = ACTIONS(1617),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1617),
    [anon_sym_co_await] = ACTIONS(1620),
    [anon_sym_new] = ACTIONS(1623),
    [anon_sym_requires] = ACTIONS(1626),
    [sym_this] = ACTIONS(1578),
  },
  [124] = {
    [sym_declaration] = STATE(122),
    [sym_type_definition] = STATE(122),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5905),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(122),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(122),
    [sym_labeled_statement] = STATE(122),
    [sym_expression_statement] = STATE(122),
    [sym_if_statement] = STATE(122),
    [sym_switch_statement] = STATE(122),
    [sym_while_statement] = STATE(122),
    [sym_do_statement] = STATE(122),
    [sym_for_statement] = STATE(122),
    [sym_return_statement] = STATE(122),
    [sym_break_statement] = STATE(122),
    [sym_continue_statement] = STATE(122),
    [sym_goto_statement] = STATE(122),
    [sym_seh_try_statement] = STATE(122),
    [sym_seh_leave_statement] = STATE(122),
    [sym__expression] = STATE(5326),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9529),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(122),
    [sym_co_return_statement] = STATE(122),
    [sym_co_yield_statement] = STATE(122),
    [sym_throw_statement] = STATE(122),
    [sym_try_statement] = STATE(122),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(122),
    [sym_identifier] = ACTIONS(1699),
    [aux_sym_preproc_include_token1] = ACTIONS(1422),
    [aux_sym_preproc_def_token1] = ACTIONS(1422),
    [aux_sym_preproc_if_token1] = ACTIONS(1422),
    [aux_sym_preproc_if_token2] = ACTIONS(1422),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1422),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1422),
    [sym_preproc_directive] = ACTIONS(1422),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP_AMP] = ACTIONS(1428),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym___extension__] = ACTIONS(1111),
    [anon_sym_typedef] = ACTIONS(1113),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1422),
    [anon_sym___cdecl] = ACTIONS(1422),
    [anon_sym___clrcall] = ACTIONS(1422),
    [anon_sym___stdcall] = ACTIONS(1422),
    [anon_sym___fastcall] = ACTIONS(1422),
    [anon_sym___thiscall] = ACTIONS(1422),
    [anon_sym___vectorcall] = ACTIONS(1422),
    [anon_sym_LBRACE] = ACTIONS(1117),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(1121),
    [anon_sym_else] = ACTIONS(1422),
    [anon_sym_switch] = ACTIONS(1123),
    [anon_sym_case] = ACTIONS(1422),
    [anon_sym_default] = ACTIONS(1422),
    [anon_sym_while] = ACTIONS(1129),
    [anon_sym_do] = ACTIONS(1131),
    [anon_sym_for] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1139),
    [anon_sym_goto] = ACTIONS(1141),
    [anon_sym___try] = ACTIONS(1143),
    [anon_sym___leave] = ACTIONS(1145),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1422),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(1422),
    [anon_sym_try] = ACTIONS(1149),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1151),
    [anon_sym_namespace] = ACTIONS(1422),
    [anon_sym_using] = ACTIONS(1422),
    [anon_sym_static_assert] = ACTIONS(1422),
    [anon_sym_concept] = ACTIONS(1422),
    [anon_sym_co_return] = ACTIONS(1161),
    [anon_sym_co_yield] = ACTIONS(1163),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [125] = {
    [sym_declaration] = STATE(128),
    [sym_type_definition] = STATE(128),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5950),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(128),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(128),
    [sym_labeled_statement] = STATE(128),
    [sym_expression_statement] = STATE(128),
    [sym_if_statement] = STATE(128),
    [sym_switch_statement] = STATE(128),
    [sym_while_statement] = STATE(128),
    [sym_do_statement] = STATE(128),
    [sym_for_statement] = STATE(128),
    [sym_return_statement] = STATE(128),
    [sym_break_statement] = STATE(128),
    [sym_continue_statement] = STATE(128),
    [sym_goto_statement] = STATE(128),
    [sym_seh_try_statement] = STATE(128),
    [sym_seh_leave_statement] = STATE(128),
    [sym__expression] = STATE(5293),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9447),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(128),
    [sym_co_return_statement] = STATE(128),
    [sym_co_yield_statement] = STATE(128),
    [sym_throw_statement] = STATE(128),
    [sym_try_statement] = STATE(128),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(220),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(128),
    [sym_identifier] = ACTIONS(1891),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1893),
    [anon_sym___extension__] = ACTIONS(1895),
    [anon_sym_typedef] = ACTIONS(1897),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_else] = ACTIONS(1422),
    [anon_sym_switch] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_do] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1911),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1915),
    [anon_sym_goto] = ACTIONS(1917),
    [anon_sym___try] = ACTIONS(1919),
    [anon_sym___leave] = ACTIONS(1921),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1923),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1925),
    [anon_sym_co_return] = ACTIONS(1927),
    [anon_sym_co_yield] = ACTIONS(1929),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [126] = {
    [sym_declaration] = STATE(127),
    [sym_type_definition] = STATE(127),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5950),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(127),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(127),
    [sym_labeled_statement] = STATE(127),
    [sym_expression_statement] = STATE(127),
    [sym_if_statement] = STATE(127),
    [sym_switch_statement] = STATE(127),
    [sym_while_statement] = STATE(127),
    [sym_do_statement] = STATE(127),
    [sym_for_statement] = STATE(127),
    [sym_return_statement] = STATE(127),
    [sym_break_statement] = STATE(127),
    [sym_continue_statement] = STATE(127),
    [sym_goto_statement] = STATE(127),
    [sym_seh_try_statement] = STATE(127),
    [sym_seh_leave_statement] = STATE(127),
    [sym__expression] = STATE(5293),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9447),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(127),
    [sym_co_return_statement] = STATE(127),
    [sym_co_yield_statement] = STATE(127),
    [sym_throw_statement] = STATE(127),
    [sym_try_statement] = STATE(127),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(220),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(127),
    [sym_identifier] = ACTIONS(1891),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1893),
    [anon_sym___extension__] = ACTIONS(1895),
    [anon_sym_typedef] = ACTIONS(1897),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_else] = ACTIONS(1629),
    [anon_sym_switch] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_do] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1911),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1915),
    [anon_sym_goto] = ACTIONS(1917),
    [anon_sym___try] = ACTIONS(1919),
    [anon_sym___leave] = ACTIONS(1921),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1923),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1925),
    [anon_sym_co_return] = ACTIONS(1927),
    [anon_sym_co_yield] = ACTIONS(1929),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [127] = {
    [sym_declaration] = STATE(129),
    [sym_type_definition] = STATE(129),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5950),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(129),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(129),
    [sym_labeled_statement] = STATE(129),
    [sym_expression_statement] = STATE(129),
    [sym_if_statement] = STATE(129),
    [sym_switch_statement] = STATE(129),
    [sym_while_statement] = STATE(129),
    [sym_do_statement] = STATE(129),
    [sym_for_statement] = STATE(129),
    [sym_return_statement] = STATE(129),
    [sym_break_statement] = STATE(129),
    [sym_continue_statement] = STATE(129),
    [sym_goto_statement] = STATE(129),
    [sym_seh_try_statement] = STATE(129),
    [sym_seh_leave_statement] = STATE(129),
    [sym__expression] = STATE(5293),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9447),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(129),
    [sym_co_return_statement] = STATE(129),
    [sym_co_yield_statement] = STATE(129),
    [sym_throw_statement] = STATE(129),
    [sym_try_statement] = STATE(129),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(220),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(129),
    [sym_identifier] = ACTIONS(1891),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1893),
    [anon_sym___extension__] = ACTIONS(1895),
    [anon_sym_typedef] = ACTIONS(1897),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_else] = ACTIONS(1438),
    [anon_sym_switch] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_do] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1911),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1915),
    [anon_sym_goto] = ACTIONS(1917),
    [anon_sym___try] = ACTIONS(1919),
    [anon_sym___leave] = ACTIONS(1921),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1923),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1925),
    [anon_sym_co_return] = ACTIONS(1927),
    [anon_sym_co_yield] = ACTIONS(1929),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [128] = {
    [sym_declaration] = STATE(129),
    [sym_type_definition] = STATE(129),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5950),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(129),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(129),
    [sym_labeled_statement] = STATE(129),
    [sym_expression_statement] = STATE(129),
    [sym_if_statement] = STATE(129),
    [sym_switch_statement] = STATE(129),
    [sym_while_statement] = STATE(129),
    [sym_do_statement] = STATE(129),
    [sym_for_statement] = STATE(129),
    [sym_return_statement] = STATE(129),
    [sym_break_statement] = STATE(129),
    [sym_continue_statement] = STATE(129),
    [sym_goto_statement] = STATE(129),
    [sym_seh_try_statement] = STATE(129),
    [sym_seh_leave_statement] = STATE(129),
    [sym__expression] = STATE(5293),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9447),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(129),
    [sym_co_return_statement] = STATE(129),
    [sym_co_yield_statement] = STATE(129),
    [sym_throw_statement] = STATE(129),
    [sym_try_statement] = STATE(129),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(220),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(129),
    [sym_identifier] = ACTIONS(1891),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1893),
    [anon_sym___extension__] = ACTIONS(1895),
    [anon_sym_typedef] = ACTIONS(1897),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_else] = ACTIONS(1633),
    [anon_sym_switch] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_do] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1911),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1915),
    [anon_sym_goto] = ACTIONS(1917),
    [anon_sym___try] = ACTIONS(1919),
    [anon_sym___leave] = ACTIONS(1921),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1923),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1925),
    [anon_sym_co_return] = ACTIONS(1927),
    [anon_sym_co_yield] = ACTIONS(1929),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [129] = {
    [sym_declaration] = STATE(129),
    [sym_type_definition] = STATE(129),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5950),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(1231),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_compound_statement] = STATE(129),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_attributed_statement] = STATE(129),
    [sym_labeled_statement] = STATE(129),
    [sym_expression_statement] = STATE(129),
    [sym_if_statement] = STATE(129),
    [sym_switch_statement] = STATE(129),
    [sym_while_statement] = STATE(129),
    [sym_do_statement] = STATE(129),
    [sym_for_statement] = STATE(129),
    [sym_return_statement] = STATE(129),
    [sym_break_statement] = STATE(129),
    [sym_continue_statement] = STATE(129),
    [sym_goto_statement] = STATE(129),
    [sym_seh_try_statement] = STATE(129),
    [sym_seh_leave_statement] = STATE(129),
    [sym__expression] = STATE(5293),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9447),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(129),
    [sym_co_return_statement] = STATE(129),
    [sym_co_yield_statement] = STATE(129),
    [sym_throw_statement] = STATE(129),
    [sym_try_statement] = STATE(129),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_attributed_declarator_repeat1] = STATE(220),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_case_statement_repeat1] = STATE(129),
    [sym_identifier] = ACTIONS(1931),
    [anon_sym_LPAREN2] = ACTIONS(1447),
    [anon_sym_BANG] = ACTIONS(1450),
    [anon_sym_TILDE] = ACTIONS(1450),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_STAR] = ACTIONS(1456),
    [anon_sym_AMP] = ACTIONS(1456),
    [anon_sym_SEMI] = ACTIONS(1934),
    [anon_sym___extension__] = ACTIONS(1937),
    [anon_sym_typedef] = ACTIONS(1940),
    [anon_sym_extern] = ACTIONS(1473),
    [anon_sym___attribute__] = ACTIONS(1476),
    [anon_sym_COLON_COLON] = ACTIONS(1479),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1482),
    [anon_sym___declspec] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(1943),
    [anon_sym_signed] = ACTIONS(1491),
    [anon_sym_unsigned] = ACTIONS(1491),
    [anon_sym_long] = ACTIONS(1491),
    [anon_sym_short] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(1494),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_register] = ACTIONS(1473),
    [anon_sym_inline] = ACTIONS(1473),
    [anon_sym___inline] = ACTIONS(1473),
    [anon_sym___inline__] = ACTIONS(1473),
    [anon_sym___forceinline] = ACTIONS(1473),
    [anon_sym_thread_local] = ACTIONS(1473),
    [anon_sym___thread] = ACTIONS(1473),
    [anon_sym_const] = ACTIONS(1497),
    [anon_sym_constexpr] = ACTIONS(1497),
    [anon_sym_volatile] = ACTIONS(1497),
    [anon_sym_restrict] = ACTIONS(1497),
    [anon_sym___restrict__] = ACTIONS(1497),
    [anon_sym__Atomic] = ACTIONS(1497),
    [anon_sym__Noreturn] = ACTIONS(1497),
    [anon_sym_noreturn] = ACTIONS(1497),
    [anon_sym_mutable] = ACTIONS(1497),
    [anon_sym_constinit] = ACTIONS(1497),
    [anon_sym_consteval] = ACTIONS(1497),
    [anon_sym_PROGMEM] = ACTIONS(1497),
    [aux_sym_primitive_type_token1] = ACTIONS(1500),
    [anon_sym_byte] = ACTIONS(1500),
    [anon_sym_word] = ACTIONS(1500),
    [anon_sym_enum] = ACTIONS(1503),
    [anon_sym_class] = ACTIONS(1506),
    [anon_sym_struct] = ACTIONS(1509),
    [anon_sym_union] = ACTIONS(1512),
    [anon_sym_if] = ACTIONS(1946),
    [anon_sym_else] = ACTIONS(1445),
    [anon_sym_switch] = ACTIONS(1949),
    [anon_sym_while] = ACTIONS(1952),
    [anon_sym_do] = ACTIONS(1955),
    [anon_sym_for] = ACTIONS(1958),
    [anon_sym_return] = ACTIONS(1961),
    [anon_sym_break] = ACTIONS(1964),
    [anon_sym_continue] = ACTIONS(1967),
    [anon_sym_goto] = ACTIONS(1970),
    [anon_sym___try] = ACTIONS(1973),
    [anon_sym___leave] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1453),
    [anon_sym_compl] = ACTIONS(1453),
    [anon_sym_DASH_DASH] = ACTIONS(1548),
    [anon_sym_PLUS_PLUS] = ACTIONS(1548),
    [anon_sym_sizeof] = ACTIONS(1551),
    [anon_sym___alignof__] = ACTIONS(1554),
    [anon_sym___alignof] = ACTIONS(1554),
    [anon_sym__alignof] = ACTIONS(1554),
    [anon_sym_alignof] = ACTIONS(1554),
    [anon_sym__Alignof] = ACTIONS(1554),
    [anon_sym_offsetof] = ACTIONS(1557),
    [anon_sym__Generic] = ACTIONS(1560),
    [anon_sym_asm] = ACTIONS(1563),
    [anon_sym___asm__] = ACTIONS(1563),
    [aux_sym_number_literal_token1] = ACTIONS(1566),
    [aux_sym_number_literal_token2] = ACTIONS(1569),
    [anon_sym_L_SQUOTE] = ACTIONS(1572),
    [anon_sym_u_SQUOTE] = ACTIONS(1572),
    [anon_sym_U_SQUOTE] = ACTIONS(1572),
    [anon_sym_u8_SQUOTE] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1572),
    [anon_sym_L_DQUOTE] = ACTIONS(1575),
    [anon_sym_u_DQUOTE] = ACTIONS(1575),
    [anon_sym_U_DQUOTE] = ACTIONS(1575),
    [anon_sym_u8_DQUOTE] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(1575),
    [sym_true] = ACTIONS(1578),
    [sym_false] = ACTIONS(1578),
    [anon_sym_NULL] = ACTIONS(1581),
    [anon_sym_nullptr] = ACTIONS(1581),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1584),
    [anon_sym_decltype] = ACTIONS(1587),
    [anon_sym_virtual] = ACTIONS(1590),
    [anon_sym_alignas] = ACTIONS(1593),
    [anon_sym_typename] = ACTIONS(1596),
    [anon_sym_template] = ACTIONS(1599),
    [anon_sym_try] = ACTIONS(1979),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_throw] = ACTIONS(1982),
    [anon_sym_co_return] = ACTIONS(1985),
    [anon_sym_co_yield] = ACTIONS(1988),
    [anon_sym_R_DQUOTE] = ACTIONS(1617),
    [anon_sym_LR_DQUOTE] = ACTIONS(1617),
    [anon_sym_uR_DQUOTE] = ACTIONS(1617),
    [anon_sym_UR_DQUOTE] = ACTIONS(1617),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1617),
    [anon_sym_co_await] = ACTIONS(1620),
    [anon_sym_new] = ACTIONS(1623),
    [anon_sym_requires] = ACTIONS(1626),
    [sym_this] = ACTIONS(1578),
  },
  [130] = {
    [sym_declaration] = STATE(271),
    [sym_type_definition] = STATE(4759),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5938),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_expression_statement] = STATE(4759),
    [sym__for_statement_body] = STATE(8838),
    [sym__expression] = STATE(5240),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9021),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_alias_declaration] = STATE(4759),
    [sym__for_range_loop_body] = STATE(9281),
    [sym_init_statement] = STATE(2214),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1993),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_typedef] = ACTIONS(1997),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(2001),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [131] = {
    [sym_declaration] = STATE(271),
    [sym_type_definition] = STATE(4759),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5938),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_expression_statement] = STATE(4759),
    [sym__for_statement_body] = STATE(9087),
    [sym__expression] = STATE(5240),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9021),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_alias_declaration] = STATE(4759),
    [sym__for_range_loop_body] = STATE(9088),
    [sym_init_statement] = STATE(2214),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1993),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_typedef] = ACTIONS(1997),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(2001),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [132] = {
    [sym_declaration] = STATE(271),
    [sym_type_definition] = STATE(4759),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5938),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_expression_statement] = STATE(4759),
    [sym__for_statement_body] = STATE(9015),
    [sym__expression] = STATE(5240),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9021),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_alias_declaration] = STATE(4759),
    [sym__for_range_loop_body] = STATE(9034),
    [sym_init_statement] = STATE(2214),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1993),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_typedef] = ACTIONS(1997),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(2001),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [133] = {
    [sym_declaration] = STATE(271),
    [sym_type_definition] = STATE(4759),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5938),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_expression_statement] = STATE(4759),
    [sym__for_statement_body] = STATE(8881),
    [sym__expression] = STATE(5240),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9021),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_alias_declaration] = STATE(4759),
    [sym__for_range_loop_body] = STATE(8882),
    [sym_init_statement] = STATE(2214),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1993),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_typedef] = ACTIONS(1997),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(2001),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [134] = {
    [sym_declaration] = STATE(271),
    [sym_type_definition] = STATE(4759),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5938),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_expression_statement] = STATE(4759),
    [sym__for_statement_body] = STATE(9033),
    [sym__expression] = STATE(5240),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9021),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_alias_declaration] = STATE(4759),
    [sym__for_range_loop_body] = STATE(9032),
    [sym_init_statement] = STATE(2214),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1993),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_typedef] = ACTIONS(1997),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(2001),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [135] = {
    [sym_declaration] = STATE(271),
    [sym_type_definition] = STATE(4759),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5938),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_expression_statement] = STATE(4759),
    [sym__for_statement_body] = STATE(8962),
    [sym__expression] = STATE(5240),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9021),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_alias_declaration] = STATE(4759),
    [sym__for_range_loop_body] = STATE(8963),
    [sym_init_statement] = STATE(2214),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1993),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_typedef] = ACTIONS(1997),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(2001),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [136] = {
    [sym_declaration] = STATE(271),
    [sym_type_definition] = STATE(4759),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5938),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_expression_statement] = STATE(4759),
    [sym__for_statement_body] = STATE(9414),
    [sym__expression] = STATE(5240),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9021),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_alias_declaration] = STATE(4759),
    [sym__for_range_loop_body] = STATE(9406),
    [sym_init_statement] = STATE(2214),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1993),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_typedef] = ACTIONS(1997),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(2001),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [137] = {
    [sym_declaration] = STATE(1987),
    [sym_type_definition] = STATE(1987),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5947),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_expression_statement] = STATE(1987),
    [sym__expression] = STATE(5218),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8702),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_alias_declaration] = STATE(1987),
    [sym_init_statement] = STATE(150),
    [sym_condition_declaration] = STATE(8976),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1893),
    [anon_sym___extension__] = ACTIONS(1895),
    [anon_sym_typedef] = ACTIONS(1897),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(2003),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [138] = {
    [sym__declaration_modifiers] = STATE(2282),
    [sym__declaration_specifiers] = STATE(4808),
    [sym_attribute_specifier] = STATE(2282),
    [sym_attribute_declaration] = STATE(2282),
    [sym_ms_declspec_modifier] = STATE(2282),
    [sym_storage_class_specifier] = STATE(2282),
    [sym_type_qualifier] = STATE(2282),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3983),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_parameter_declaration] = STATE(8262),
    [sym__expression] = STATE(3882),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8742),
    [sym_virtual] = STATE(2282),
    [sym_alignas_specifier] = STATE(2282),
    [sym_dependent_type] = STATE(3087),
    [sym_optional_parameter_declaration] = STATE(8262),
    [sym_variadic_parameter_declaration] = STATE(8262),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym__unary_left_fold] = STATE(9288),
    [sym__unary_right_fold] = STATE(9285),
    [sym__binary_fold] = STATE(9284),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6457),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(4035),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2282),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(2005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_RPAREN] = ACTIONS(2009),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2023),
    [anon_sym_struct] = ACTIONS(2025),
    [anon_sym_union] = ACTIONS(2027),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2053),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [139] = {
    [sym__declaration_modifiers] = STATE(2282),
    [sym__declaration_specifiers] = STATE(4808),
    [sym_attribute_specifier] = STATE(2282),
    [sym_attribute_declaration] = STATE(2282),
    [sym_ms_declspec_modifier] = STATE(2282),
    [sym_storage_class_specifier] = STATE(2282),
    [sym_type_qualifier] = STATE(2282),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3983),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_parameter_declaration] = STATE(8262),
    [sym__expression] = STATE(3959),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8742),
    [sym_virtual] = STATE(2282),
    [sym_alignas_specifier] = STATE(2282),
    [sym_dependent_type] = STATE(3087),
    [sym_optional_parameter_declaration] = STATE(8262),
    [sym_variadic_parameter_declaration] = STATE(8262),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym__unary_left_fold] = STATE(9629),
    [sym__unary_right_fold] = STATE(9631),
    [sym__binary_fold] = STATE(9638),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6457),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(4035),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2282),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(2005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_RPAREN] = ACTIONS(2009),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2023),
    [anon_sym_struct] = ACTIONS(2025),
    [anon_sym_union] = ACTIONS(2027),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2053),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [140] = {
    [sym__declaration_modifiers] = STATE(2282),
    [sym__declaration_specifiers] = STATE(4808),
    [sym_attribute_specifier] = STATE(2282),
    [sym_attribute_declaration] = STATE(2282),
    [sym_ms_declspec_modifier] = STATE(2282),
    [sym_storage_class_specifier] = STATE(2282),
    [sym_type_qualifier] = STATE(2282),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3983),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_parameter_declaration] = STATE(8262),
    [sym__expression] = STATE(4019),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8742),
    [sym_virtual] = STATE(2282),
    [sym_alignas_specifier] = STATE(2282),
    [sym_dependent_type] = STATE(3087),
    [sym_optional_parameter_declaration] = STATE(8262),
    [sym_variadic_parameter_declaration] = STATE(8262),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym__unary_left_fold] = STATE(8948),
    [sym__unary_right_fold] = STATE(8950),
    [sym__binary_fold] = STATE(8952),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6457),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(4035),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2282),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(2005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_RPAREN] = ACTIONS(2009),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2023),
    [anon_sym_struct] = ACTIONS(2025),
    [anon_sym_union] = ACTIONS(2027),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2053),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [141] = {
    [sym__declaration_modifiers] = STATE(2282),
    [sym__declaration_specifiers] = STATE(4808),
    [sym_attribute_specifier] = STATE(2282),
    [sym_attribute_declaration] = STATE(2282),
    [sym_ms_declspec_modifier] = STATE(2282),
    [sym_storage_class_specifier] = STATE(2282),
    [sym_type_qualifier] = STATE(2282),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3983),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_parameter_declaration] = STATE(8262),
    [sym__expression] = STATE(3922),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8742),
    [sym_virtual] = STATE(2282),
    [sym_alignas_specifier] = STATE(2282),
    [sym_dependent_type] = STATE(3087),
    [sym_optional_parameter_declaration] = STATE(8262),
    [sym_variadic_parameter_declaration] = STATE(8262),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym__unary_left_fold] = STATE(9517),
    [sym__unary_right_fold] = STATE(9519),
    [sym__binary_fold] = STATE(9521),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6457),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(4035),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2282),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(2005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_RPAREN] = ACTIONS(2009),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2023),
    [anon_sym_struct] = ACTIONS(2025),
    [anon_sym_union] = ACTIONS(2027),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2053),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [142] = {
    [sym__declaration_modifiers] = STATE(2282),
    [sym__declaration_specifiers] = STATE(4808),
    [sym_attribute_specifier] = STATE(2282),
    [sym_attribute_declaration] = STATE(2282),
    [sym_ms_declspec_modifier] = STATE(2282),
    [sym_compound_statement] = STATE(8178),
    [sym_storage_class_specifier] = STATE(2282),
    [sym_type_qualifier] = STATE(2282),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_parameter_declaration] = STATE(8304),
    [sym__expression] = STATE(5057),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8178),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2282),
    [sym_alignas_specifier] = STATE(2282),
    [sym_dependent_type] = STATE(3087),
    [sym_optional_parameter_declaration] = STATE(8304),
    [sym_variadic_parameter_declaration] = STATE(8304),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6446),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2282),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(2065),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2067),
    [anon_sym_RPAREN] = ACTIONS(2069),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(2071),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(2073),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2023),
    [anon_sym_struct] = ACTIONS(2025),
    [anon_sym_union] = ACTIONS(2027),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2053),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [143] = {
    [sym__declaration_modifiers] = STATE(2282),
    [sym__declaration_specifiers] = STATE(4808),
    [sym_attribute_specifier] = STATE(2282),
    [sym_attribute_declaration] = STATE(2282),
    [sym_ms_declspec_modifier] = STATE(2282),
    [sym_storage_class_specifier] = STATE(2282),
    [sym_type_qualifier] = STATE(2282),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3983),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_parameter_declaration] = STATE(8262),
    [sym__expression] = STATE(3951),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8742),
    [sym_virtual] = STATE(2282),
    [sym_alignas_specifier] = STATE(2282),
    [sym_dependent_type] = STATE(3087),
    [sym_optional_parameter_declaration] = STATE(8262),
    [sym_variadic_parameter_declaration] = STATE(8262),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym__unary_left_fold] = STATE(9031),
    [sym__unary_right_fold] = STATE(9037),
    [sym__binary_fold] = STATE(9039),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6457),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(4035),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2282),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(2005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_RPAREN] = ACTIONS(2009),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2023),
    [anon_sym_struct] = ACTIONS(2025),
    [anon_sym_union] = ACTIONS(2027),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2053),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [144] = {
    [sym__declaration_modifiers] = STATE(2282),
    [sym__declaration_specifiers] = STATE(4808),
    [sym_attribute_specifier] = STATE(2282),
    [sym_attribute_declaration] = STATE(2282),
    [sym_ms_declspec_modifier] = STATE(2282),
    [sym_storage_class_specifier] = STATE(2282),
    [sym_type_qualifier] = STATE(2282),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3983),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_parameter_declaration] = STATE(8262),
    [sym__expression] = STATE(4005),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8742),
    [sym_virtual] = STATE(2282),
    [sym_alignas_specifier] = STATE(2282),
    [sym_dependent_type] = STATE(3087),
    [sym_optional_parameter_declaration] = STATE(8262),
    [sym_variadic_parameter_declaration] = STATE(8262),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym__unary_left_fold] = STATE(9223),
    [sym__unary_right_fold] = STATE(9218),
    [sym__binary_fold] = STATE(9214),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6457),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(4035),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2282),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(2005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_RPAREN] = ACTIONS(2009),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2023),
    [anon_sym_struct] = ACTIONS(2025),
    [anon_sym_union] = ACTIONS(2027),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2053),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [145] = {
    [sym__declaration_modifiers] = STATE(2282),
    [sym__declaration_specifiers] = STATE(4808),
    [sym_attribute_specifier] = STATE(2282),
    [sym_attribute_declaration] = STATE(2282),
    [sym_ms_declspec_modifier] = STATE(2282),
    [sym_storage_class_specifier] = STATE(2282),
    [sym_type_qualifier] = STATE(2282),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3983),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_parameter_declaration] = STATE(8262),
    [sym__expression] = STATE(3949),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8742),
    [sym_virtual] = STATE(2282),
    [sym_alignas_specifier] = STATE(2282),
    [sym_dependent_type] = STATE(3087),
    [sym_optional_parameter_declaration] = STATE(8262),
    [sym_variadic_parameter_declaration] = STATE(8262),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym__unary_left_fold] = STATE(8809),
    [sym__unary_right_fold] = STATE(8802),
    [sym__binary_fold] = STATE(8799),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6457),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(4035),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2282),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(2005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_RPAREN] = ACTIONS(2009),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2023),
    [anon_sym_struct] = ACTIONS(2025),
    [anon_sym_union] = ACTIONS(2027),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2053),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [146] = {
    [sym__declaration_modifiers] = STATE(2282),
    [sym__declaration_specifiers] = STATE(4808),
    [sym_attribute_specifier] = STATE(2282),
    [sym_attribute_declaration] = STATE(2282),
    [sym_ms_declspec_modifier] = STATE(2282),
    [sym_storage_class_specifier] = STATE(2282),
    [sym_type_qualifier] = STATE(2282),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3983),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_parameter_declaration] = STATE(8262),
    [sym__expression] = STATE(3868),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8742),
    [sym_virtual] = STATE(2282),
    [sym_alignas_specifier] = STATE(2282),
    [sym_dependent_type] = STATE(3087),
    [sym_optional_parameter_declaration] = STATE(8262),
    [sym_variadic_parameter_declaration] = STATE(8262),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym__unary_left_fold] = STATE(8951),
    [sym__unary_right_fold] = STATE(8953),
    [sym__binary_fold] = STATE(8956),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6457),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(4035),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2282),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(2005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_RPAREN] = ACTIONS(2009),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2023),
    [anon_sym_struct] = ACTIONS(2025),
    [anon_sym_union] = ACTIONS(2027),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2053),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [147] = {
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(5979),
    [sym__declarator] = STATE(7386),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7008),
    [sym_array_declarator] = STATE(7008),
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3416),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9225),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9224),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(9223),
    [sym__unary_right_fold] = STATE(9218),
    [sym__binary_fold] = STATE(9214),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6459),
    [sym_qualified_identifier] = STATE(3890),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9212),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2077),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2085),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2087),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(2091),
    [anon_sym___clrcall] = ACTIONS(2091),
    [anon_sym___stdcall] = ACTIONS(2091),
    [anon_sym___fastcall] = ACTIONS(2091),
    [anon_sym___thiscall] = ACTIONS(2091),
    [anon_sym___vectorcall] = ACTIONS(2091),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2095),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(2137),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [148] = {
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(5979),
    [sym__declarator] = STATE(7386),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7008),
    [sym_array_declarator] = STATE(7008),
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3488),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9369),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(8946),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(8948),
    [sym__unary_right_fold] = STATE(8950),
    [sym__binary_fold] = STATE(8952),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6459),
    [sym_qualified_identifier] = STATE(3890),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9251),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2077),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2085),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2087),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(2091),
    [anon_sym___clrcall] = ACTIONS(2091),
    [anon_sym___stdcall] = ACTIONS(2091),
    [anon_sym___fastcall] = ACTIONS(2091),
    [anon_sym___thiscall] = ACTIONS(2091),
    [anon_sym___vectorcall] = ACTIONS(2091),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2095),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(2137),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [149] = {
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(5979),
    [sym__declarator] = STATE(7386),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7008),
    [sym_array_declarator] = STATE(7008),
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3488),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9369),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9276),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(9288),
    [sym__unary_right_fold] = STATE(9285),
    [sym__binary_fold] = STATE(9284),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6459),
    [sym_qualified_identifier] = STATE(3890),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9251),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2077),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2085),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2087),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(2091),
    [anon_sym___clrcall] = ACTIONS(2091),
    [anon_sym___stdcall] = ACTIONS(2091),
    [anon_sym___fastcall] = ACTIONS(2091),
    [anon_sym___thiscall] = ACTIONS(2091),
    [anon_sym___vectorcall] = ACTIONS(2091),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2095),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(2137),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [150] = {
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(6065),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3125),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__expression] = STATE(5292),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9263),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8468),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3870),
    [sym_template_function] = STATE(4662),
    [sym_condition_declaration] = STATE(9263),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6497),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(3880),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [151] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2894),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_initializer_list] = STATE(2907),
    [sym_number_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_concatenated_string] = STATE(3312),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2365),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2149),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2151),
    [anon_sym_COMMA] = ACTIONS(2151),
    [aux_sym_preproc_if_token2] = ACTIONS(2151),
    [aux_sym_preproc_else_token1] = ACTIONS(2151),
    [aux_sym_preproc_elif_token1] = ACTIONS(2149),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2151),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2151),
    [anon_sym_LPAREN2] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_PERCENT] = ACTIONS(2149),
    [anon_sym_PIPE_PIPE] = ACTIONS(2151),
    [anon_sym_AMP_AMP] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(2149),
    [anon_sym_CARET] = ACTIONS(2149),
    [anon_sym_AMP] = ACTIONS(2149),
    [anon_sym_EQ_EQ] = ACTIONS(2151),
    [anon_sym_BANG_EQ] = ACTIONS(2151),
    [anon_sym_GT] = ACTIONS(2149),
    [anon_sym_GT_EQ] = ACTIONS(2151),
    [anon_sym_LT_EQ] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_LT_LT] = ACTIONS(2149),
    [anon_sym_GT_GT] = ACTIONS(2149),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACE] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [anon_sym_EQ] = ACTIONS(2149),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(2151),
    [anon_sym_STAR_EQ] = ACTIONS(2151),
    [anon_sym_SLASH_EQ] = ACTIONS(2151),
    [anon_sym_PERCENT_EQ] = ACTIONS(2151),
    [anon_sym_PLUS_EQ] = ACTIONS(2151),
    [anon_sym_DASH_EQ] = ACTIONS(2151),
    [anon_sym_LT_LT_EQ] = ACTIONS(2151),
    [anon_sym_GT_GT_EQ] = ACTIONS(2151),
    [anon_sym_AMP_EQ] = ACTIONS(2151),
    [anon_sym_CARET_EQ] = ACTIONS(2151),
    [anon_sym_PIPE_EQ] = ACTIONS(2151),
    [anon_sym_and_eq] = ACTIONS(2149),
    [anon_sym_or_eq] = ACTIONS(2149),
    [anon_sym_xor_eq] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2153),
    [anon_sym_compl] = ACTIONS(2153),
    [anon_sym_LT_EQ_GT] = ACTIONS(2151),
    [anon_sym_or] = ACTIONS(2149),
    [anon_sym_and] = ACTIONS(2149),
    [anon_sym_bitor] = ACTIONS(2149),
    [anon_sym_xor] = ACTIONS(2149),
    [anon_sym_bitand] = ACTIONS(2149),
    [anon_sym_not_eq] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_sizeof] = ACTIONS(2161),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2149),
    [anon_sym_DOT_STAR] = ACTIONS(2151),
    [anon_sym_DASH_GT] = ACTIONS(2151),
    [aux_sym_number_literal_token1] = ACTIONS(2171),
    [aux_sym_number_literal_token2] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2175),
    [anon_sym_u_SQUOTE] = ACTIONS(2175),
    [anon_sym_U_SQUOTE] = ACTIONS(2175),
    [anon_sym_u8_SQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [152] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2894),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_initializer_list] = STATE(2907),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2151),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_RPAREN] = ACTIONS(2151),
    [anon_sym_LPAREN2] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2197),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_PERCENT] = ACTIONS(2149),
    [anon_sym_PIPE_PIPE] = ACTIONS(2151),
    [anon_sym_AMP_AMP] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(2149),
    [anon_sym_CARET] = ACTIONS(2149),
    [anon_sym_AMP] = ACTIONS(2149),
    [anon_sym_EQ_EQ] = ACTIONS(2151),
    [anon_sym_BANG_EQ] = ACTIONS(2151),
    [anon_sym_GT] = ACTIONS(2149),
    [anon_sym_GT_EQ] = ACTIONS(2151),
    [anon_sym_LT_EQ] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_LT_LT] = ACTIONS(2149),
    [anon_sym_GT_GT] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(2151),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACE] = ACTIONS(2159),
    [anon_sym_RBRACE] = ACTIONS(2151),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [anon_sym_RBRACK] = ACTIONS(2151),
    [anon_sym_EQ] = ACTIONS(2149),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(2151),
    [anon_sym_STAR_EQ] = ACTIONS(2151),
    [anon_sym_SLASH_EQ] = ACTIONS(2151),
    [anon_sym_PERCENT_EQ] = ACTIONS(2151),
    [anon_sym_PLUS_EQ] = ACTIONS(2151),
    [anon_sym_DASH_EQ] = ACTIONS(2151),
    [anon_sym_LT_LT_EQ] = ACTIONS(2151),
    [anon_sym_GT_GT_EQ] = ACTIONS(2151),
    [anon_sym_AMP_EQ] = ACTIONS(2151),
    [anon_sym_CARET_EQ] = ACTIONS(2151),
    [anon_sym_PIPE_EQ] = ACTIONS(2151),
    [anon_sym_and_eq] = ACTIONS(2149),
    [anon_sym_or_eq] = ACTIONS(2149),
    [anon_sym_xor_eq] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_LT_EQ_GT] = ACTIONS(2151),
    [anon_sym_or] = ACTIONS(2149),
    [anon_sym_and] = ACTIONS(2149),
    [anon_sym_bitor] = ACTIONS(2149),
    [anon_sym_xor] = ACTIONS(2149),
    [anon_sym_bitand] = ACTIONS(2149),
    [anon_sym_not_eq] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2149),
    [anon_sym_DOT_STAR] = ACTIONS(2151),
    [anon_sym_DASH_GT] = ACTIONS(2151),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [153] = {
    [ts_builtin_sym_end] = ACTIONS(2221),
    [sym_identifier] = ACTIONS(2223),
    [aux_sym_preproc_include_token1] = ACTIONS(2223),
    [aux_sym_preproc_def_token1] = ACTIONS(2223),
    [anon_sym_COMMA] = ACTIONS(2221),
    [anon_sym_RPAREN] = ACTIONS(2221),
    [aux_sym_preproc_if_token1] = ACTIONS(2223),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2223),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2223),
    [sym_preproc_directive] = ACTIONS(2223),
    [anon_sym_LPAREN2] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2223),
    [anon_sym_PLUS] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(2221),
    [anon_sym_PIPE_PIPE] = ACTIONS(2221),
    [anon_sym_AMP_AMP] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym___extension__] = ACTIONS(2223),
    [anon_sym_typedef] = ACTIONS(2223),
    [anon_sym_extern] = ACTIONS(2223),
    [anon_sym___attribute__] = ACTIONS(2223),
    [anon_sym_COLON_COLON] = ACTIONS(2221),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym___declspec] = ACTIONS(2223),
    [anon_sym___based] = ACTIONS(2223),
    [anon_sym___cdecl] = ACTIONS(2223),
    [anon_sym___clrcall] = ACTIONS(2223),
    [anon_sym___stdcall] = ACTIONS(2223),
    [anon_sym___fastcall] = ACTIONS(2223),
    [anon_sym___thiscall] = ACTIONS(2223),
    [anon_sym___vectorcall] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_signed] = ACTIONS(2223),
    [anon_sym_unsigned] = ACTIONS(2223),
    [anon_sym_long] = ACTIONS(2223),
    [anon_sym_short] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(2223),
    [anon_sym_EQ] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2223),
    [anon_sym_register] = ACTIONS(2223),
    [anon_sym_inline] = ACTIONS(2223),
    [anon_sym___inline] = ACTIONS(2223),
    [anon_sym___inline__] = ACTIONS(2223),
    [anon_sym___forceinline] = ACTIONS(2223),
    [anon_sym_thread_local] = ACTIONS(2223),
    [anon_sym___thread] = ACTIONS(2223),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_constexpr] = ACTIONS(2223),
    [anon_sym_volatile] = ACTIONS(2223),
    [anon_sym_restrict] = ACTIONS(2223),
    [anon_sym___restrict__] = ACTIONS(2223),
    [anon_sym__Atomic] = ACTIONS(2223),
    [anon_sym__Noreturn] = ACTIONS(2223),
    [anon_sym_noreturn] = ACTIONS(2223),
    [anon_sym_mutable] = ACTIONS(2223),
    [anon_sym_constinit] = ACTIONS(2223),
    [anon_sym_consteval] = ACTIONS(2223),
    [anon_sym_PROGMEM] = ACTIONS(2223),
    [aux_sym_primitive_type_token1] = ACTIONS(2223),
    [anon_sym_byte] = ACTIONS(2223),
    [anon_sym_word] = ACTIONS(2223),
    [anon_sym_enum] = ACTIONS(2223),
    [anon_sym_class] = ACTIONS(2223),
    [anon_sym_struct] = ACTIONS(2223),
    [anon_sym_union] = ACTIONS(2223),
    [anon_sym_if] = ACTIONS(2223),
    [anon_sym_else] = ACTIONS(2223),
    [anon_sym_switch] = ACTIONS(2223),
    [anon_sym_case] = ACTIONS(2223),
    [anon_sym_default] = ACTIONS(2223),
    [anon_sym_while] = ACTIONS(2223),
    [anon_sym_do] = ACTIONS(2223),
    [anon_sym_for] = ACTIONS(2223),
    [anon_sym_return] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2223),
    [anon_sym_continue] = ACTIONS(2223),
    [anon_sym_goto] = ACTIONS(2223),
    [anon_sym___try] = ACTIONS(2223),
    [anon_sym___except] = ACTIONS(2223),
    [anon_sym___finally] = ACTIONS(2223),
    [anon_sym___leave] = ACTIONS(2223),
    [anon_sym_not] = ACTIONS(2223),
    [anon_sym_compl] = ACTIONS(2223),
    [anon_sym_or] = ACTIONS(2223),
    [anon_sym_and] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_sizeof] = ACTIONS(2223),
    [anon_sym___alignof__] = ACTIONS(2223),
    [anon_sym___alignof] = ACTIONS(2223),
    [anon_sym__alignof] = ACTIONS(2223),
    [anon_sym_alignof] = ACTIONS(2223),
    [anon_sym__Alignof] = ACTIONS(2223),
    [anon_sym_offsetof] = ACTIONS(2223),
    [anon_sym__Generic] = ACTIONS(2223),
    [anon_sym_asm] = ACTIONS(2223),
    [anon_sym___asm__] = ACTIONS(2223),
    [aux_sym_number_literal_token1] = ACTIONS(2221),
    [aux_sym_number_literal_token2] = ACTIONS(2223),
    [anon_sym_L_SQUOTE] = ACTIONS(2221),
    [anon_sym_u_SQUOTE] = ACTIONS(2221),
    [anon_sym_U_SQUOTE] = ACTIONS(2221),
    [anon_sym_u8_SQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_L_DQUOTE] = ACTIONS(2221),
    [anon_sym_u_DQUOTE] = ACTIONS(2221),
    [anon_sym_U_DQUOTE] = ACTIONS(2221),
    [anon_sym_u8_DQUOTE] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [sym_true] = ACTIONS(2223),
    [sym_false] = ACTIONS(2223),
    [anon_sym_NULL] = ACTIONS(2223),
    [anon_sym_nullptr] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2223),
    [anon_sym_decltype] = ACTIONS(2223),
    [anon_sym_final] = ACTIONS(2223),
    [anon_sym_override] = ACTIONS(2223),
    [anon_sym_virtual] = ACTIONS(2223),
    [anon_sym_alignas] = ACTIONS(2223),
    [anon_sym_explicit] = ACTIONS(2223),
    [anon_sym_typename] = ACTIONS(2223),
    [anon_sym_template] = ACTIONS(2223),
    [anon_sym_GT2] = ACTIONS(2221),
    [anon_sym_operator] = ACTIONS(2223),
    [anon_sym_try] = ACTIONS(2223),
    [anon_sym_delete] = ACTIONS(2223),
    [anon_sym_throw] = ACTIONS(2223),
    [anon_sym_namespace] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_static_assert] = ACTIONS(2223),
    [anon_sym_concept] = ACTIONS(2223),
    [anon_sym_co_return] = ACTIONS(2223),
    [anon_sym_co_yield] = ACTIONS(2223),
    [anon_sym_catch] = ACTIONS(2223),
    [anon_sym_R_DQUOTE] = ACTIONS(2221),
    [anon_sym_LR_DQUOTE] = ACTIONS(2221),
    [anon_sym_uR_DQUOTE] = ACTIONS(2221),
    [anon_sym_UR_DQUOTE] = ACTIONS(2221),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2221),
    [anon_sym_co_await] = ACTIONS(2223),
    [anon_sym_new] = ACTIONS(2223),
    [anon_sym_requires] = ACTIONS(2223),
    [sym_this] = ACTIONS(2223),
  },
  [154] = {
    [sym_primitive_type] = STATE(7711),
    [sym__expression] = STATE(3507),
    [sym__expression_not_binary] = STATE(3678),
    [sym__string] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_alignof_expression] = STATE(3678),
    [sym_offsetof_expression] = STATE(3678),
    [sym_generic_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_initializer_list] = STATE(3754),
    [sym_number_literal] = STATE(3544),
    [sym_char_literal] = STATE(3544),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(2634),
    [sym_null] = STATE(3678),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8556),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3678),
    [sym_raw_string_literal] = STATE(2647),
    [sym_co_await_expression] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_requires_clause] = STATE(3678),
    [sym_requires_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(6739),
    [sym_fold_expression] = STATE(3678),
    [sym_parameter_pack_expansion] = STATE(3678),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(8556),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(2149),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2151),
    [anon_sym_COMMA] = ACTIONS(2151),
    [aux_sym_preproc_if_token2] = ACTIONS(2151),
    [aux_sym_preproc_else_token1] = ACTIONS(2151),
    [aux_sym_preproc_elif_token1] = ACTIONS(2151),
    [anon_sym_LPAREN2] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2225),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_PERCENT] = ACTIONS(2149),
    [anon_sym_PIPE_PIPE] = ACTIONS(2151),
    [anon_sym_AMP_AMP] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(2149),
    [anon_sym_CARET] = ACTIONS(2149),
    [anon_sym_AMP] = ACTIONS(2149),
    [anon_sym_EQ_EQ] = ACTIONS(2151),
    [anon_sym_BANG_EQ] = ACTIONS(2151),
    [anon_sym_GT] = ACTIONS(2149),
    [anon_sym_GT_EQ] = ACTIONS(2151),
    [anon_sym_LT_EQ] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_LT_LT] = ACTIONS(2149),
    [anon_sym_GT_GT] = ACTIONS(2149),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACE] = ACTIONS(2231),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [anon_sym_EQ] = ACTIONS(2149),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(2151),
    [anon_sym_STAR_EQ] = ACTIONS(2151),
    [anon_sym_SLASH_EQ] = ACTIONS(2151),
    [anon_sym_PERCENT_EQ] = ACTIONS(2151),
    [anon_sym_PLUS_EQ] = ACTIONS(2151),
    [anon_sym_DASH_EQ] = ACTIONS(2151),
    [anon_sym_LT_LT_EQ] = ACTIONS(2151),
    [anon_sym_GT_GT_EQ] = ACTIONS(2151),
    [anon_sym_AMP_EQ] = ACTIONS(2151),
    [anon_sym_CARET_EQ] = ACTIONS(2151),
    [anon_sym_PIPE_EQ] = ACTIONS(2151),
    [anon_sym_and_eq] = ACTIONS(2149),
    [anon_sym_or_eq] = ACTIONS(2149),
    [anon_sym_xor_eq] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2225),
    [anon_sym_compl] = ACTIONS(2225),
    [anon_sym_LT_EQ_GT] = ACTIONS(2151),
    [anon_sym_or] = ACTIONS(2149),
    [anon_sym_and] = ACTIONS(2149),
    [anon_sym_bitor] = ACTIONS(2149),
    [anon_sym_xor] = ACTIONS(2149),
    [anon_sym_bitand] = ACTIONS(2149),
    [anon_sym_not_eq] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_sizeof] = ACTIONS(2233),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2237),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2241),
    [anon_sym___asm__] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2149),
    [anon_sym_DOT_STAR] = ACTIONS(2151),
    [anon_sym_DASH_GT] = ACTIONS(2151),
    [aux_sym_number_literal_token1] = ACTIONS(2243),
    [aux_sym_number_literal_token2] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2247),
    [anon_sym_u_SQUOTE] = ACTIONS(2247),
    [anon_sym_U_SQUOTE] = ACTIONS(2247),
    [anon_sym_u8_SQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2253),
    [anon_sym_nullptr] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_requires] = ACTIONS(2263),
    [sym_this] = ACTIONS(2251),
  },
  [155] = {
    [ts_builtin_sym_end] = ACTIONS(2265),
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_include_token1] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [anon_sym_COMMA] = ACTIONS(2265),
    [anon_sym_RPAREN] = ACTIONS(2265),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_BANG] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_PIPE_PIPE] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(2265),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym___cdecl] = ACTIONS(2267),
    [anon_sym___clrcall] = ACTIONS(2267),
    [anon_sym___stdcall] = ACTIONS(2267),
    [anon_sym___fastcall] = ACTIONS(2267),
    [anon_sym___thiscall] = ACTIONS(2267),
    [anon_sym___vectorcall] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2265),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_EQ] = ACTIONS(2265),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_else] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_case] = ACTIONS(2267),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_return] = ACTIONS(2267),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_continue] = ACTIONS(2267),
    [anon_sym_goto] = ACTIONS(2267),
    [anon_sym___try] = ACTIONS(2267),
    [anon_sym___except] = ACTIONS(2267),
    [anon_sym___finally] = ACTIONS(2267),
    [anon_sym___leave] = ACTIONS(2267),
    [anon_sym_not] = ACTIONS(2267),
    [anon_sym_compl] = ACTIONS(2267),
    [anon_sym_or] = ACTIONS(2267),
    [anon_sym_and] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2265),
    [anon_sym_PLUS_PLUS] = ACTIONS(2265),
    [anon_sym_sizeof] = ACTIONS(2267),
    [anon_sym___alignof__] = ACTIONS(2267),
    [anon_sym___alignof] = ACTIONS(2267),
    [anon_sym__alignof] = ACTIONS(2267),
    [anon_sym_alignof] = ACTIONS(2267),
    [anon_sym__Alignof] = ACTIONS(2267),
    [anon_sym_offsetof] = ACTIONS(2267),
    [anon_sym__Generic] = ACTIONS(2267),
    [anon_sym_asm] = ACTIONS(2267),
    [anon_sym___asm__] = ACTIONS(2267),
    [aux_sym_number_literal_token1] = ACTIONS(2265),
    [aux_sym_number_literal_token2] = ACTIONS(2267),
    [anon_sym_L_SQUOTE] = ACTIONS(2265),
    [anon_sym_u_SQUOTE] = ACTIONS(2265),
    [anon_sym_U_SQUOTE] = ACTIONS(2265),
    [anon_sym_u8_SQUOTE] = ACTIONS(2265),
    [anon_sym_SQUOTE] = ACTIONS(2265),
    [anon_sym_L_DQUOTE] = ACTIONS(2265),
    [anon_sym_u_DQUOTE] = ACTIONS(2265),
    [anon_sym_U_DQUOTE] = ACTIONS(2265),
    [anon_sym_u8_DQUOTE] = ACTIONS(2265),
    [anon_sym_DQUOTE] = ACTIONS(2265),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [anon_sym_NULL] = ACTIONS(2267),
    [anon_sym_nullptr] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_final] = ACTIONS(2267),
    [anon_sym_override] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_GT2] = ACTIONS(2265),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_try] = ACTIONS(2267),
    [anon_sym_delete] = ACTIONS(2267),
    [anon_sym_throw] = ACTIONS(2267),
    [anon_sym_namespace] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym_concept] = ACTIONS(2267),
    [anon_sym_co_return] = ACTIONS(2267),
    [anon_sym_co_yield] = ACTIONS(2267),
    [anon_sym_catch] = ACTIONS(2267),
    [anon_sym_R_DQUOTE] = ACTIONS(2265),
    [anon_sym_LR_DQUOTE] = ACTIONS(2265),
    [anon_sym_uR_DQUOTE] = ACTIONS(2265),
    [anon_sym_UR_DQUOTE] = ACTIONS(2265),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2265),
    [anon_sym_co_await] = ACTIONS(2267),
    [anon_sym_new] = ACTIONS(2267),
    [anon_sym_requires] = ACTIONS(2267),
    [sym_this] = ACTIONS(2267),
  },
  [156] = {
    [sym_attribute_declaration] = STATE(167),
    [sym_compound_statement] = STATE(775),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(775),
    [sym_labeled_statement] = STATE(775),
    [sym_expression_statement] = STATE(775),
    [sym_if_statement] = STATE(775),
    [sym_switch_statement] = STATE(775),
    [sym_case_statement] = STATE(775),
    [sym_while_statement] = STATE(775),
    [sym_do_statement] = STATE(775),
    [sym_for_statement] = STATE(775),
    [sym_return_statement] = STATE(775),
    [sym_break_statement] = STATE(775),
    [sym_continue_statement] = STATE(775),
    [sym_goto_statement] = STATE(775),
    [sym_seh_try_statement] = STATE(775),
    [sym_seh_leave_statement] = STATE(775),
    [sym__expression] = STATE(5169),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8555),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(775),
    [sym_co_return_statement] = STATE(775),
    [sym_co_yield_statement] = STATE(775),
    [sym_throw_statement] = STATE(775),
    [sym_try_statement] = STATE(775),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [sym_identifier] = ACTIONS(2269),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [157] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2894),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_initializer_list] = STATE(2907),
    [sym_number_literal] = STATE(3897),
    [sym_char_literal] = STATE(3897),
    [sym_concatenated_string] = STATE(3895),
    [sym_string_literal] = STATE(2803),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2782),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2271),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2151),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_LPAREN2] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2273),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_PERCENT] = ACTIONS(2149),
    [anon_sym_PIPE_PIPE] = ACTIONS(2151),
    [anon_sym_AMP_AMP] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(2149),
    [anon_sym_CARET] = ACTIONS(2149),
    [anon_sym_AMP] = ACTIONS(2149),
    [anon_sym_EQ_EQ] = ACTIONS(2151),
    [anon_sym_BANG_EQ] = ACTIONS(2151),
    [anon_sym_GT] = ACTIONS(2149),
    [anon_sym_GT_EQ] = ACTIONS(2151),
    [anon_sym_LT_EQ] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_LT_LT] = ACTIONS(2149),
    [anon_sym_GT_GT] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(2151),
    [anon_sym___attribute__] = ACTIONS(2149),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [anon_sym_EQ] = ACTIONS(2149),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(2151),
    [anon_sym_STAR_EQ] = ACTIONS(2151),
    [anon_sym_SLASH_EQ] = ACTIONS(2151),
    [anon_sym_PERCENT_EQ] = ACTIONS(2151),
    [anon_sym_PLUS_EQ] = ACTIONS(2151),
    [anon_sym_DASH_EQ] = ACTIONS(2151),
    [anon_sym_LT_LT_EQ] = ACTIONS(2151),
    [anon_sym_GT_GT_EQ] = ACTIONS(2151),
    [anon_sym_AMP_EQ] = ACTIONS(2151),
    [anon_sym_CARET_EQ] = ACTIONS(2151),
    [anon_sym_PIPE_EQ] = ACTIONS(2151),
    [anon_sym_and_eq] = ACTIONS(2149),
    [anon_sym_or_eq] = ACTIONS(2149),
    [anon_sym_xor_eq] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_compl] = ACTIONS(2273),
    [anon_sym_LT_EQ_GT] = ACTIONS(2151),
    [anon_sym_or] = ACTIONS(2149),
    [anon_sym_and] = ACTIONS(2149),
    [anon_sym_bitor] = ACTIONS(2149),
    [anon_sym_xor] = ACTIONS(2149),
    [anon_sym_bitand] = ACTIONS(2149),
    [anon_sym_not_eq] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_sizeof] = ACTIONS(2279),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2149),
    [anon_sym_DOT_STAR] = ACTIONS(2151),
    [anon_sym_DASH_GT] = ACTIONS(2151),
    [aux_sym_number_literal_token1] = ACTIONS(2281),
    [aux_sym_number_literal_token2] = ACTIONS(2283),
    [anon_sym_L_SQUOTE] = ACTIONS(2285),
    [anon_sym_u_SQUOTE] = ACTIONS(2285),
    [anon_sym_U_SQUOTE] = ACTIONS(2285),
    [anon_sym_u8_SQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_L_DQUOTE] = ACTIONS(2287),
    [anon_sym_u_DQUOTE] = ACTIONS(2287),
    [anon_sym_U_DQUOTE] = ACTIONS(2287),
    [anon_sym_u8_DQUOTE] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_R_DQUOTE] = ACTIONS(2291),
    [anon_sym_LR_DQUOTE] = ACTIONS(2291),
    [anon_sym_uR_DQUOTE] = ACTIONS(2291),
    [anon_sym_UR_DQUOTE] = ACTIONS(2291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2291),
    [anon_sym_co_await] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [158] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3665),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_initializer_list] = STATE(4143),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2151),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_RPAREN] = ACTIONS(2151),
    [anon_sym_LPAREN2] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_PERCENT] = ACTIONS(2149),
    [anon_sym_PIPE_PIPE] = ACTIONS(2151),
    [anon_sym_AMP_AMP] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(2149),
    [anon_sym_CARET] = ACTIONS(2149),
    [anon_sym_AMP] = ACTIONS(2149),
    [anon_sym_EQ_EQ] = ACTIONS(2151),
    [anon_sym_BANG_EQ] = ACTIONS(2151),
    [anon_sym_GT] = ACTIONS(2149),
    [anon_sym_GT_EQ] = ACTIONS(2151),
    [anon_sym_LT_EQ] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_LT_LT] = ACTIONS(2149),
    [anon_sym_GT_GT] = ACTIONS(2149),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACE] = ACTIONS(2297),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [anon_sym_EQ] = ACTIONS(2149),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(2151),
    [anon_sym_STAR_EQ] = ACTIONS(2151),
    [anon_sym_SLASH_EQ] = ACTIONS(2151),
    [anon_sym_PERCENT_EQ] = ACTIONS(2151),
    [anon_sym_PLUS_EQ] = ACTIONS(2151),
    [anon_sym_DASH_EQ] = ACTIONS(2151),
    [anon_sym_LT_LT_EQ] = ACTIONS(2151),
    [anon_sym_GT_GT_EQ] = ACTIONS(2151),
    [anon_sym_AMP_EQ] = ACTIONS(2151),
    [anon_sym_CARET_EQ] = ACTIONS(2151),
    [anon_sym_PIPE_EQ] = ACTIONS(2151),
    [anon_sym_and_eq] = ACTIONS(2149),
    [anon_sym_or_eq] = ACTIONS(2149),
    [anon_sym_xor_eq] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_LT_EQ_GT] = ACTIONS(2151),
    [anon_sym_or] = ACTIONS(2149),
    [anon_sym_and] = ACTIONS(2149),
    [anon_sym_bitor] = ACTIONS(2149),
    [anon_sym_xor] = ACTIONS(2149),
    [anon_sym_bitand] = ACTIONS(2149),
    [anon_sym_not_eq] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2149),
    [anon_sym_DOT_STAR] = ACTIONS(2151),
    [anon_sym_DASH_GT] = ACTIONS(2149),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2151),
    [sym_this] = ACTIONS(2127),
  },
  [159] = {
    [sym_attribute_declaration] = STATE(196),
    [sym_compound_statement] = STATE(8011),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(8011),
    [sym_labeled_statement] = STATE(8011),
    [sym_expression_statement] = STATE(8011),
    [sym_if_statement] = STATE(8011),
    [sym_switch_statement] = STATE(8011),
    [sym_case_statement] = STATE(8011),
    [sym_while_statement] = STATE(8011),
    [sym_do_statement] = STATE(8011),
    [sym_for_statement] = STATE(8011),
    [sym_return_statement] = STATE(8011),
    [sym_break_statement] = STATE(8011),
    [sym_continue_statement] = STATE(8011),
    [sym_goto_statement] = STATE(8011),
    [sym_seh_try_statement] = STATE(8011),
    [sym_seh_leave_statement] = STATE(8011),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(8011),
    [sym_co_return_statement] = STATE(8011),
    [sym_co_yield_statement] = STATE(8011),
    [sym_throw_statement] = STATE(8011),
    [sym_try_statement] = STATE(8011),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(196),
    [sym_identifier] = ACTIONS(2299),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(2303),
    [anon_sym_default] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2309),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2311),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [160] = {
    [sym_attribute_declaration] = STATE(219),
    [sym_compound_statement] = STATE(858),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(858),
    [sym_labeled_statement] = STATE(858),
    [sym_expression_statement] = STATE(858),
    [sym_if_statement] = STATE(858),
    [sym_switch_statement] = STATE(858),
    [sym_case_statement] = STATE(858),
    [sym_while_statement] = STATE(858),
    [sym_do_statement] = STATE(858),
    [sym_for_statement] = STATE(858),
    [sym_return_statement] = STATE(858),
    [sym_break_statement] = STATE(858),
    [sym_continue_statement] = STATE(858),
    [sym_goto_statement] = STATE(858),
    [sym_seh_try_statement] = STATE(858),
    [sym_seh_leave_statement] = STATE(858),
    [sym__expression] = STATE(5326),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9529),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(858),
    [sym_co_return_statement] = STATE(858),
    [sym_co_yield_statement] = STATE(858),
    [sym_throw_statement] = STATE(858),
    [sym_try_statement] = STATE(858),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [sym_identifier] = ACTIONS(2313),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1121),
    [anon_sym_switch] = ACTIONS(1123),
    [anon_sym_case] = ACTIONS(1125),
    [anon_sym_default] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(1129),
    [anon_sym_do] = ACTIONS(1131),
    [anon_sym_for] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1139),
    [anon_sym_goto] = ACTIONS(1141),
    [anon_sym___try] = ACTIONS(1143),
    [anon_sym___leave] = ACTIONS(1145),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1149),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1151),
    [anon_sym_co_return] = ACTIONS(1161),
    [anon_sym_co_yield] = ACTIONS(1163),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [161] = {
    [sym_attribute_declaration] = STATE(167),
    [sym_compound_statement] = STATE(675),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(672),
    [sym_labeled_statement] = STATE(671),
    [sym_expression_statement] = STATE(670),
    [sym_if_statement] = STATE(658),
    [sym_switch_statement] = STATE(650),
    [sym_case_statement] = STATE(646),
    [sym_while_statement] = STATE(622),
    [sym_do_statement] = STATE(743),
    [sym_for_statement] = STATE(683),
    [sym_return_statement] = STATE(699),
    [sym_break_statement] = STATE(702),
    [sym_continue_statement] = STATE(703),
    [sym_goto_statement] = STATE(706),
    [sym_seh_try_statement] = STATE(762),
    [sym_seh_leave_statement] = STATE(842),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(778),
    [sym_co_return_statement] = STATE(780),
    [sym_co_yield_statement] = STATE(786),
    [sym_throw_statement] = STATE(790),
    [sym_try_statement] = STATE(791),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [sym_identifier] = ACTIONS(2269),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [162] = {
    [sym_attribute_declaration] = STATE(220),
    [sym_compound_statement] = STATE(1178),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(1178),
    [sym_labeled_statement] = STATE(1178),
    [sym_expression_statement] = STATE(1178),
    [sym_if_statement] = STATE(1178),
    [sym_switch_statement] = STATE(1178),
    [sym_case_statement] = STATE(1178),
    [sym_while_statement] = STATE(1178),
    [sym_do_statement] = STATE(1178),
    [sym_for_statement] = STATE(1178),
    [sym_return_statement] = STATE(1178),
    [sym_break_statement] = STATE(1178),
    [sym_continue_statement] = STATE(1178),
    [sym_goto_statement] = STATE(1178),
    [sym_seh_try_statement] = STATE(1178),
    [sym_seh_leave_statement] = STATE(1178),
    [sym__expression] = STATE(5293),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9447),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(1178),
    [sym_co_return_statement] = STATE(1178),
    [sym_co_yield_statement] = STATE(1178),
    [sym_throw_statement] = STATE(1178),
    [sym_try_statement] = STATE(1178),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(220),
    [sym_identifier] = ACTIONS(2315),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1893),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_switch] = ACTIONS(1903),
    [anon_sym_case] = ACTIONS(2303),
    [anon_sym_default] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_do] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1911),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1915),
    [anon_sym_goto] = ACTIONS(1917),
    [anon_sym___try] = ACTIONS(1919),
    [anon_sym___leave] = ACTIONS(1921),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1923),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1925),
    [anon_sym_co_return] = ACTIONS(1927),
    [anon_sym_co_yield] = ACTIONS(1929),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [163] = {
    [sym_attribute_declaration] = STATE(167),
    [sym_compound_statement] = STATE(555),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(555),
    [sym_labeled_statement] = STATE(555),
    [sym_expression_statement] = STATE(555),
    [sym_if_statement] = STATE(555),
    [sym_switch_statement] = STATE(555),
    [sym_case_statement] = STATE(555),
    [sym_while_statement] = STATE(555),
    [sym_do_statement] = STATE(555),
    [sym_for_statement] = STATE(555),
    [sym_return_statement] = STATE(555),
    [sym_break_statement] = STATE(555),
    [sym_continue_statement] = STATE(555),
    [sym_goto_statement] = STATE(555),
    [sym_seh_try_statement] = STATE(555),
    [sym_seh_leave_statement] = STATE(555),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(555),
    [sym_co_return_statement] = STATE(555),
    [sym_co_yield_statement] = STATE(555),
    [sym_throw_statement] = STATE(555),
    [sym_try_statement] = STATE(555),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [sym_identifier] = ACTIONS(2269),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [164] = {
    [sym_attribute_declaration] = STATE(229),
    [sym_compound_statement] = STATE(270),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(270),
    [sym_labeled_statement] = STATE(270),
    [sym_expression_statement] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_switch_statement] = STATE(270),
    [sym_case_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_do_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_goto_statement] = STATE(270),
    [sym_seh_try_statement] = STATE(270),
    [sym_seh_leave_statement] = STATE(270),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(270),
    [sym_co_return_statement] = STATE(270),
    [sym_co_yield_statement] = STATE(270),
    [sym_throw_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(229),
    [sym_identifier] = ACTIONS(2317),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(285),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_switch] = ACTIONS(299),
    [anon_sym_case] = ACTIONS(301),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_continue] = ACTIONS(315),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym___try] = ACTIONS(319),
    [anon_sym___leave] = ACTIONS(321),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(327),
    [anon_sym_co_return] = ACTIONS(337),
    [anon_sym_co_yield] = ACTIONS(339),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [165] = {
    [sym_attribute_declaration] = STATE(229),
    [sym_compound_statement] = STATE(323),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(323),
    [sym_labeled_statement] = STATE(323),
    [sym_expression_statement] = STATE(323),
    [sym_if_statement] = STATE(323),
    [sym_switch_statement] = STATE(323),
    [sym_case_statement] = STATE(323),
    [sym_while_statement] = STATE(323),
    [sym_do_statement] = STATE(323),
    [sym_for_statement] = STATE(323),
    [sym_return_statement] = STATE(323),
    [sym_break_statement] = STATE(323),
    [sym_continue_statement] = STATE(323),
    [sym_goto_statement] = STATE(323),
    [sym_seh_try_statement] = STATE(323),
    [sym_seh_leave_statement] = STATE(323),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(323),
    [sym_co_return_statement] = STATE(323),
    [sym_co_yield_statement] = STATE(323),
    [sym_throw_statement] = STATE(323),
    [sym_try_statement] = STATE(323),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(229),
    [sym_identifier] = ACTIONS(2317),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(285),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_switch] = ACTIONS(299),
    [anon_sym_case] = ACTIONS(301),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_continue] = ACTIONS(315),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym___try] = ACTIONS(319),
    [anon_sym___leave] = ACTIONS(321),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(327),
    [anon_sym_co_return] = ACTIONS(337),
    [anon_sym_co_yield] = ACTIONS(339),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [166] = {
    [sym_attribute_declaration] = STATE(220),
    [sym_compound_statement] = STATE(1154),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(1154),
    [sym_labeled_statement] = STATE(1154),
    [sym_expression_statement] = STATE(1154),
    [sym_if_statement] = STATE(1154),
    [sym_switch_statement] = STATE(1154),
    [sym_case_statement] = STATE(1154),
    [sym_while_statement] = STATE(1154),
    [sym_do_statement] = STATE(1154),
    [sym_for_statement] = STATE(1154),
    [sym_return_statement] = STATE(1154),
    [sym_break_statement] = STATE(1154),
    [sym_continue_statement] = STATE(1154),
    [sym_goto_statement] = STATE(1154),
    [sym_seh_try_statement] = STATE(1154),
    [sym_seh_leave_statement] = STATE(1154),
    [sym__expression] = STATE(5293),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9447),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(1154),
    [sym_co_return_statement] = STATE(1154),
    [sym_co_yield_statement] = STATE(1154),
    [sym_throw_statement] = STATE(1154),
    [sym_try_statement] = STATE(1154),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(220),
    [sym_identifier] = ACTIONS(2315),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1893),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_switch] = ACTIONS(1903),
    [anon_sym_case] = ACTIONS(2303),
    [anon_sym_default] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_do] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1911),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1915),
    [anon_sym_goto] = ACTIONS(1917),
    [anon_sym___try] = ACTIONS(1919),
    [anon_sym___leave] = ACTIONS(1921),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1923),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1925),
    [anon_sym_co_return] = ACTIONS(1927),
    [anon_sym_co_yield] = ACTIONS(1929),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [167] = {
    [sym_attribute_declaration] = STATE(170),
    [sym_compound_statement] = STATE(799),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(799),
    [sym_labeled_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_if_statement] = STATE(799),
    [sym_switch_statement] = STATE(799),
    [sym_case_statement] = STATE(799),
    [sym_while_statement] = STATE(799),
    [sym_do_statement] = STATE(799),
    [sym_for_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_goto_statement] = STATE(799),
    [sym_seh_try_statement] = STATE(799),
    [sym_seh_leave_statement] = STATE(799),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(799),
    [sym_co_return_statement] = STATE(799),
    [sym_co_yield_statement] = STATE(799),
    [sym_throw_statement] = STATE(799),
    [sym_try_statement] = STATE(799),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [sym_identifier] = ACTIONS(2269),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [168] = {
    [sym_attribute_declaration] = STATE(229),
    [sym_compound_statement] = STATE(302),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(302),
    [sym_labeled_statement] = STATE(302),
    [sym_expression_statement] = STATE(302),
    [sym_if_statement] = STATE(302),
    [sym_switch_statement] = STATE(302),
    [sym_case_statement] = STATE(302),
    [sym_while_statement] = STATE(302),
    [sym_do_statement] = STATE(302),
    [sym_for_statement] = STATE(302),
    [sym_return_statement] = STATE(302),
    [sym_break_statement] = STATE(302),
    [sym_continue_statement] = STATE(302),
    [sym_goto_statement] = STATE(302),
    [sym_seh_try_statement] = STATE(302),
    [sym_seh_leave_statement] = STATE(302),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(302),
    [sym_co_return_statement] = STATE(302),
    [sym_co_yield_statement] = STATE(302),
    [sym_throw_statement] = STATE(302),
    [sym_try_statement] = STATE(302),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(229),
    [sym_identifier] = ACTIONS(2317),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(285),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_switch] = ACTIONS(299),
    [anon_sym_case] = ACTIONS(301),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_continue] = ACTIONS(315),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym___try] = ACTIONS(319),
    [anon_sym___leave] = ACTIONS(321),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(327),
    [anon_sym_co_return] = ACTIONS(337),
    [anon_sym_co_yield] = ACTIONS(339),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [169] = {
    [sym_attribute_declaration] = STATE(167),
    [sym_compound_statement] = STATE(763),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(759),
    [sym_labeled_statement] = STATE(741),
    [sym_expression_statement] = STATE(739),
    [sym_if_statement] = STATE(769),
    [sym_switch_statement] = STATE(718),
    [sym_case_statement] = STATE(717),
    [sym_while_statement] = STATE(711),
    [sym_do_statement] = STATE(704),
    [sym_for_statement] = STATE(620),
    [sym_return_statement] = STATE(701),
    [sym_break_statement] = STATE(698),
    [sym_continue_statement] = STATE(696),
    [sym_goto_statement] = STATE(692),
    [sym_seh_try_statement] = STATE(691),
    [sym_seh_leave_statement] = STATE(689),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(688),
    [sym_co_return_statement] = STATE(687),
    [sym_co_yield_statement] = STATE(682),
    [sym_throw_statement] = STATE(681),
    [sym_try_statement] = STATE(676),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [sym_identifier] = ACTIONS(2269),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [170] = {
    [sym_attribute_declaration] = STATE(170),
    [sym_compound_statement] = STATE(799),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(799),
    [sym_labeled_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_if_statement] = STATE(799),
    [sym_switch_statement] = STATE(799),
    [sym_case_statement] = STATE(799),
    [sym_while_statement] = STATE(799),
    [sym_do_statement] = STATE(799),
    [sym_for_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_goto_statement] = STATE(799),
    [sym_seh_try_statement] = STATE(799),
    [sym_seh_leave_statement] = STATE(799),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(799),
    [sym_co_return_statement] = STATE(799),
    [sym_co_yield_statement] = STATE(799),
    [sym_throw_statement] = STATE(799),
    [sym_try_statement] = STATE(799),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [sym_identifier] = ACTIONS(2319),
    [anon_sym_LPAREN2] = ACTIONS(2322),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2325),
    [anon_sym_DASH] = ACTIONS(2328),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_STAR] = ACTIONS(2331),
    [anon_sym_AMP] = ACTIONS(2331),
    [anon_sym_SEMI] = ACTIONS(2334),
    [anon_sym_COLON_COLON] = ACTIONS(2337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2343),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [aux_sym_primitive_type_token1] = ACTIONS(2349),
    [anon_sym_byte] = ACTIONS(2349),
    [anon_sym_word] = ACTIONS(2349),
    [anon_sym_if] = ACTIONS(2352),
    [anon_sym_switch] = ACTIONS(2355),
    [anon_sym_case] = ACTIONS(2358),
    [anon_sym_default] = ACTIONS(2361),
    [anon_sym_while] = ACTIONS(2364),
    [anon_sym_do] = ACTIONS(2367),
    [anon_sym_for] = ACTIONS(2370),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2376),
    [anon_sym_continue] = ACTIONS(2379),
    [anon_sym_goto] = ACTIONS(2382),
    [anon_sym___try] = ACTIONS(2385),
    [anon_sym___leave] = ACTIONS(2388),
    [anon_sym_not] = ACTIONS(2328),
    [anon_sym_compl] = ACTIONS(2328),
    [anon_sym_DASH_DASH] = ACTIONS(2391),
    [anon_sym_PLUS_PLUS] = ACTIONS(2391),
    [anon_sym_sizeof] = ACTIONS(2394),
    [anon_sym___alignof__] = ACTIONS(2397),
    [anon_sym___alignof] = ACTIONS(2397),
    [anon_sym__alignof] = ACTIONS(2397),
    [anon_sym_alignof] = ACTIONS(2397),
    [anon_sym__Alignof] = ACTIONS(2397),
    [anon_sym_offsetof] = ACTIONS(2400),
    [anon_sym__Generic] = ACTIONS(2403),
    [anon_sym_asm] = ACTIONS(2406),
    [anon_sym___asm__] = ACTIONS(2406),
    [aux_sym_number_literal_token1] = ACTIONS(2409),
    [aux_sym_number_literal_token2] = ACTIONS(2412),
    [anon_sym_L_SQUOTE] = ACTIONS(2415),
    [anon_sym_u_SQUOTE] = ACTIONS(2415),
    [anon_sym_U_SQUOTE] = ACTIONS(2415),
    [anon_sym_u8_SQUOTE] = ACTIONS(2415),
    [anon_sym_SQUOTE] = ACTIONS(2415),
    [anon_sym_L_DQUOTE] = ACTIONS(2418),
    [anon_sym_u_DQUOTE] = ACTIONS(2418),
    [anon_sym_U_DQUOTE] = ACTIONS(2418),
    [anon_sym_u8_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [sym_true] = ACTIONS(2421),
    [sym_false] = ACTIONS(2421),
    [anon_sym_NULL] = ACTIONS(2424),
    [anon_sym_nullptr] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2427),
    [anon_sym_template] = ACTIONS(2430),
    [anon_sym_try] = ACTIONS(2433),
    [anon_sym_delete] = ACTIONS(2436),
    [anon_sym_throw] = ACTIONS(2439),
    [anon_sym_co_return] = ACTIONS(2442),
    [anon_sym_co_yield] = ACTIONS(2445),
    [anon_sym_R_DQUOTE] = ACTIONS(2448),
    [anon_sym_LR_DQUOTE] = ACTIONS(2448),
    [anon_sym_uR_DQUOTE] = ACTIONS(2448),
    [anon_sym_UR_DQUOTE] = ACTIONS(2448),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2448),
    [anon_sym_co_await] = ACTIONS(2451),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_requires] = ACTIONS(2457),
    [sym_this] = ACTIONS(2421),
  },
  [171] = {
    [sym_attribute_declaration] = STATE(171),
    [sym_compound_statement] = STATE(335),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(335),
    [sym_labeled_statement] = STATE(335),
    [sym_expression_statement] = STATE(335),
    [sym_if_statement] = STATE(335),
    [sym_switch_statement] = STATE(335),
    [sym_case_statement] = STATE(335),
    [sym_while_statement] = STATE(335),
    [sym_do_statement] = STATE(335),
    [sym_for_statement] = STATE(335),
    [sym_return_statement] = STATE(335),
    [sym_break_statement] = STATE(335),
    [sym_continue_statement] = STATE(335),
    [sym_goto_statement] = STATE(335),
    [sym_seh_try_statement] = STATE(335),
    [sym_seh_leave_statement] = STATE(335),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(335),
    [sym_co_return_statement] = STATE(335),
    [sym_co_yield_statement] = STATE(335),
    [sym_throw_statement] = STATE(335),
    [sym_try_statement] = STATE(335),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(171),
    [sym_identifier] = ACTIONS(2460),
    [anon_sym_LPAREN2] = ACTIONS(2322),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2325),
    [anon_sym_DASH] = ACTIONS(2328),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_STAR] = ACTIONS(2331),
    [anon_sym_AMP] = ACTIONS(2331),
    [anon_sym_SEMI] = ACTIONS(2463),
    [anon_sym_COLON_COLON] = ACTIONS(2337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [aux_sym_primitive_type_token1] = ACTIONS(2349),
    [anon_sym_byte] = ACTIONS(2349),
    [anon_sym_word] = ACTIONS(2349),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2472),
    [anon_sym_case] = ACTIONS(2475),
    [anon_sym_default] = ACTIONS(2478),
    [anon_sym_while] = ACTIONS(2481),
    [anon_sym_do] = ACTIONS(2484),
    [anon_sym_for] = ACTIONS(2487),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_break] = ACTIONS(2493),
    [anon_sym_continue] = ACTIONS(2496),
    [anon_sym_goto] = ACTIONS(2499),
    [anon_sym___try] = ACTIONS(2502),
    [anon_sym___leave] = ACTIONS(2505),
    [anon_sym_not] = ACTIONS(2328),
    [anon_sym_compl] = ACTIONS(2328),
    [anon_sym_DASH_DASH] = ACTIONS(2391),
    [anon_sym_PLUS_PLUS] = ACTIONS(2391),
    [anon_sym_sizeof] = ACTIONS(2394),
    [anon_sym___alignof__] = ACTIONS(2397),
    [anon_sym___alignof] = ACTIONS(2397),
    [anon_sym__alignof] = ACTIONS(2397),
    [anon_sym_alignof] = ACTIONS(2397),
    [anon_sym__Alignof] = ACTIONS(2397),
    [anon_sym_offsetof] = ACTIONS(2400),
    [anon_sym__Generic] = ACTIONS(2403),
    [anon_sym_asm] = ACTIONS(2406),
    [anon_sym___asm__] = ACTIONS(2406),
    [aux_sym_number_literal_token1] = ACTIONS(2409),
    [aux_sym_number_literal_token2] = ACTIONS(2412),
    [anon_sym_L_SQUOTE] = ACTIONS(2415),
    [anon_sym_u_SQUOTE] = ACTIONS(2415),
    [anon_sym_U_SQUOTE] = ACTIONS(2415),
    [anon_sym_u8_SQUOTE] = ACTIONS(2415),
    [anon_sym_SQUOTE] = ACTIONS(2415),
    [anon_sym_L_DQUOTE] = ACTIONS(2418),
    [anon_sym_u_DQUOTE] = ACTIONS(2418),
    [anon_sym_U_DQUOTE] = ACTIONS(2418),
    [anon_sym_u8_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [sym_true] = ACTIONS(2421),
    [sym_false] = ACTIONS(2421),
    [anon_sym_NULL] = ACTIONS(2424),
    [anon_sym_nullptr] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2427),
    [anon_sym_template] = ACTIONS(2430),
    [anon_sym_try] = ACTIONS(2508),
    [anon_sym_delete] = ACTIONS(2436),
    [anon_sym_throw] = ACTIONS(2511),
    [anon_sym_co_return] = ACTIONS(2514),
    [anon_sym_co_yield] = ACTIONS(2517),
    [anon_sym_R_DQUOTE] = ACTIONS(2448),
    [anon_sym_LR_DQUOTE] = ACTIONS(2448),
    [anon_sym_uR_DQUOTE] = ACTIONS(2448),
    [anon_sym_UR_DQUOTE] = ACTIONS(2448),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2448),
    [anon_sym_co_await] = ACTIONS(2451),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_requires] = ACTIONS(2457),
    [sym_this] = ACTIONS(2421),
  },
  [172] = {
    [sym_attribute_declaration] = STATE(167),
    [sym_compound_statement] = STATE(775),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(775),
    [sym_labeled_statement] = STATE(775),
    [sym_expression_statement] = STATE(775),
    [sym_if_statement] = STATE(775),
    [sym_switch_statement] = STATE(775),
    [sym_case_statement] = STATE(775),
    [sym_while_statement] = STATE(775),
    [sym_do_statement] = STATE(775),
    [sym_for_statement] = STATE(775),
    [sym_return_statement] = STATE(775),
    [sym_break_statement] = STATE(775),
    [sym_continue_statement] = STATE(775),
    [sym_goto_statement] = STATE(775),
    [sym_seh_try_statement] = STATE(775),
    [sym_seh_leave_statement] = STATE(775),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(775),
    [sym_co_return_statement] = STATE(775),
    [sym_co_yield_statement] = STATE(775),
    [sym_throw_statement] = STATE(775),
    [sym_try_statement] = STATE(775),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [sym_identifier] = ACTIONS(2269),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [173] = {
    [sym_attribute_declaration] = STATE(167),
    [sym_compound_statement] = STATE(765),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(765),
    [sym_labeled_statement] = STATE(765),
    [sym_expression_statement] = STATE(765),
    [sym_if_statement] = STATE(765),
    [sym_switch_statement] = STATE(765),
    [sym_case_statement] = STATE(765),
    [sym_while_statement] = STATE(765),
    [sym_do_statement] = STATE(765),
    [sym_for_statement] = STATE(765),
    [sym_return_statement] = STATE(765),
    [sym_break_statement] = STATE(765),
    [sym_continue_statement] = STATE(765),
    [sym_goto_statement] = STATE(765),
    [sym_seh_try_statement] = STATE(765),
    [sym_seh_leave_statement] = STATE(765),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(765),
    [sym_co_return_statement] = STATE(765),
    [sym_co_yield_statement] = STATE(765),
    [sym_throw_statement] = STATE(765),
    [sym_try_statement] = STATE(765),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [sym_identifier] = ACTIONS(2269),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [174] = {
    [sym_attribute_declaration] = STATE(174),
    [sym_compound_statement] = STATE(809),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(809),
    [sym_labeled_statement] = STATE(809),
    [sym_expression_statement] = STATE(809),
    [sym_if_statement] = STATE(809),
    [sym_switch_statement] = STATE(809),
    [sym_case_statement] = STATE(809),
    [sym_while_statement] = STATE(809),
    [sym_do_statement] = STATE(809),
    [sym_for_statement] = STATE(809),
    [sym_return_statement] = STATE(809),
    [sym_break_statement] = STATE(809),
    [sym_continue_statement] = STATE(809),
    [sym_goto_statement] = STATE(809),
    [sym_seh_try_statement] = STATE(809),
    [sym_seh_leave_statement] = STATE(809),
    [sym__expression] = STATE(5249),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9175),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(809),
    [sym_co_return_statement] = STATE(809),
    [sym_co_yield_statement] = STATE(809),
    [sym_throw_statement] = STATE(809),
    [sym_try_statement] = STATE(809),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(174),
    [sym_identifier] = ACTIONS(2520),
    [anon_sym_LPAREN2] = ACTIONS(2322),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2325),
    [anon_sym_DASH] = ACTIONS(2328),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_STAR] = ACTIONS(2331),
    [anon_sym_AMP] = ACTIONS(2331),
    [anon_sym_SEMI] = ACTIONS(2523),
    [anon_sym_COLON_COLON] = ACTIONS(2337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [aux_sym_primitive_type_token1] = ACTIONS(2349),
    [anon_sym_byte] = ACTIONS(2349),
    [anon_sym_word] = ACTIONS(2349),
    [anon_sym_if] = ACTIONS(2529),
    [anon_sym_switch] = ACTIONS(2532),
    [anon_sym_case] = ACTIONS(2535),
    [anon_sym_default] = ACTIONS(2538),
    [anon_sym_while] = ACTIONS(2541),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2547),
    [anon_sym_return] = ACTIONS(2550),
    [anon_sym_break] = ACTIONS(2553),
    [anon_sym_continue] = ACTIONS(2556),
    [anon_sym_goto] = ACTIONS(2559),
    [anon_sym___try] = ACTIONS(2562),
    [anon_sym___leave] = ACTIONS(2565),
    [anon_sym_not] = ACTIONS(2328),
    [anon_sym_compl] = ACTIONS(2328),
    [anon_sym_DASH_DASH] = ACTIONS(2391),
    [anon_sym_PLUS_PLUS] = ACTIONS(2391),
    [anon_sym_sizeof] = ACTIONS(2394),
    [anon_sym___alignof__] = ACTIONS(2397),
    [anon_sym___alignof] = ACTIONS(2397),
    [anon_sym__alignof] = ACTIONS(2397),
    [anon_sym_alignof] = ACTIONS(2397),
    [anon_sym__Alignof] = ACTIONS(2397),
    [anon_sym_offsetof] = ACTIONS(2400),
    [anon_sym__Generic] = ACTIONS(2403),
    [anon_sym_asm] = ACTIONS(2406),
    [anon_sym___asm__] = ACTIONS(2406),
    [aux_sym_number_literal_token1] = ACTIONS(2409),
    [aux_sym_number_literal_token2] = ACTIONS(2412),
    [anon_sym_L_SQUOTE] = ACTIONS(2415),
    [anon_sym_u_SQUOTE] = ACTIONS(2415),
    [anon_sym_U_SQUOTE] = ACTIONS(2415),
    [anon_sym_u8_SQUOTE] = ACTIONS(2415),
    [anon_sym_SQUOTE] = ACTIONS(2415),
    [anon_sym_L_DQUOTE] = ACTIONS(2418),
    [anon_sym_u_DQUOTE] = ACTIONS(2418),
    [anon_sym_U_DQUOTE] = ACTIONS(2418),
    [anon_sym_u8_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [sym_true] = ACTIONS(2421),
    [sym_false] = ACTIONS(2421),
    [anon_sym_NULL] = ACTIONS(2424),
    [anon_sym_nullptr] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2427),
    [anon_sym_template] = ACTIONS(2430),
    [anon_sym_try] = ACTIONS(2568),
    [anon_sym_delete] = ACTIONS(2436),
    [anon_sym_throw] = ACTIONS(2571),
    [anon_sym_co_return] = ACTIONS(2574),
    [anon_sym_co_yield] = ACTIONS(2577),
    [anon_sym_R_DQUOTE] = ACTIONS(2448),
    [anon_sym_LR_DQUOTE] = ACTIONS(2448),
    [anon_sym_uR_DQUOTE] = ACTIONS(2448),
    [anon_sym_UR_DQUOTE] = ACTIONS(2448),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2448),
    [anon_sym_co_await] = ACTIONS(2451),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_requires] = ACTIONS(2457),
    [sym_this] = ACTIONS(2421),
  },
  [175] = {
    [sym_attribute_declaration] = STATE(167),
    [sym_compound_statement] = STATE(600),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(600),
    [sym_labeled_statement] = STATE(600),
    [sym_expression_statement] = STATE(600),
    [sym_if_statement] = STATE(600),
    [sym_switch_statement] = STATE(600),
    [sym_case_statement] = STATE(600),
    [sym_while_statement] = STATE(600),
    [sym_do_statement] = STATE(600),
    [sym_for_statement] = STATE(600),
    [sym_return_statement] = STATE(600),
    [sym_break_statement] = STATE(600),
    [sym_continue_statement] = STATE(600),
    [sym_goto_statement] = STATE(600),
    [sym_seh_try_statement] = STATE(600),
    [sym_seh_leave_statement] = STATE(600),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(600),
    [sym_co_return_statement] = STATE(600),
    [sym_co_yield_statement] = STATE(600),
    [sym_throw_statement] = STATE(600),
    [sym_try_statement] = STATE(600),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [sym_identifier] = ACTIONS(2269),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [176] = {
    [sym_attribute_declaration] = STATE(196),
    [sym_compound_statement] = STATE(9469),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(9469),
    [sym_labeled_statement] = STATE(9469),
    [sym_expression_statement] = STATE(9469),
    [sym_if_statement] = STATE(9469),
    [sym_switch_statement] = STATE(9469),
    [sym_case_statement] = STATE(9469),
    [sym_while_statement] = STATE(9469),
    [sym_do_statement] = STATE(9469),
    [sym_for_statement] = STATE(9469),
    [sym_return_statement] = STATE(9469),
    [sym_break_statement] = STATE(9469),
    [sym_continue_statement] = STATE(9469),
    [sym_goto_statement] = STATE(9469),
    [sym_seh_try_statement] = STATE(9469),
    [sym_seh_leave_statement] = STATE(9469),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(9469),
    [sym_co_return_statement] = STATE(9469),
    [sym_co_yield_statement] = STATE(9469),
    [sym_throw_statement] = STATE(9469),
    [sym_try_statement] = STATE(9469),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(196),
    [sym_identifier] = ACTIONS(2299),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(2303),
    [anon_sym_default] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2309),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2311),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [177] = {
    [sym_attribute_declaration] = STATE(220),
    [sym_compound_statement] = STATE(1175),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(1175),
    [sym_labeled_statement] = STATE(1175),
    [sym_expression_statement] = STATE(1175),
    [sym_if_statement] = STATE(1175),
    [sym_switch_statement] = STATE(1175),
    [sym_case_statement] = STATE(1175),
    [sym_while_statement] = STATE(1175),
    [sym_do_statement] = STATE(1175),
    [sym_for_statement] = STATE(1175),
    [sym_return_statement] = STATE(1175),
    [sym_break_statement] = STATE(1175),
    [sym_continue_statement] = STATE(1175),
    [sym_goto_statement] = STATE(1175),
    [sym_seh_try_statement] = STATE(1175),
    [sym_seh_leave_statement] = STATE(1175),
    [sym__expression] = STATE(5293),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9447),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(1175),
    [sym_co_return_statement] = STATE(1175),
    [sym_co_yield_statement] = STATE(1175),
    [sym_throw_statement] = STATE(1175),
    [sym_try_statement] = STATE(1175),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(220),
    [sym_identifier] = ACTIONS(2315),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1893),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_switch] = ACTIONS(1903),
    [anon_sym_case] = ACTIONS(2303),
    [anon_sym_default] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_do] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1911),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1915),
    [anon_sym_goto] = ACTIONS(1917),
    [anon_sym___try] = ACTIONS(1919),
    [anon_sym___leave] = ACTIONS(1921),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1923),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1925),
    [anon_sym_co_return] = ACTIONS(1927),
    [anon_sym_co_yield] = ACTIONS(1929),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [178] = {
    [sym_attribute_declaration] = STATE(167),
    [sym_compound_statement] = STATE(773),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(773),
    [sym_labeled_statement] = STATE(773),
    [sym_expression_statement] = STATE(773),
    [sym_if_statement] = STATE(773),
    [sym_switch_statement] = STATE(773),
    [sym_case_statement] = STATE(773),
    [sym_while_statement] = STATE(773),
    [sym_do_statement] = STATE(773),
    [sym_for_statement] = STATE(773),
    [sym_return_statement] = STATE(773),
    [sym_break_statement] = STATE(773),
    [sym_continue_statement] = STATE(773),
    [sym_goto_statement] = STATE(773),
    [sym_seh_try_statement] = STATE(773),
    [sym_seh_leave_statement] = STATE(773),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(773),
    [sym_co_return_statement] = STATE(773),
    [sym_co_yield_statement] = STATE(773),
    [sym_throw_statement] = STATE(773),
    [sym_try_statement] = STATE(773),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(167),
    [sym_identifier] = ACTIONS(2269),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [179] = {
    [sym_attribute_declaration] = STATE(229),
    [sym_compound_statement] = STATE(272),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(272),
    [sym_labeled_statement] = STATE(272),
    [sym_expression_statement] = STATE(272),
    [sym_if_statement] = STATE(272),
    [sym_switch_statement] = STATE(272),
    [sym_case_statement] = STATE(272),
    [sym_while_statement] = STATE(272),
    [sym_do_statement] = STATE(272),
    [sym_for_statement] = STATE(272),
    [sym_return_statement] = STATE(272),
    [sym_break_statement] = STATE(272),
    [sym_continue_statement] = STATE(272),
    [sym_goto_statement] = STATE(272),
    [sym_seh_try_statement] = STATE(272),
    [sym_seh_leave_statement] = STATE(272),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(272),
    [sym_co_return_statement] = STATE(272),
    [sym_co_yield_statement] = STATE(272),
    [sym_throw_statement] = STATE(272),
    [sym_try_statement] = STATE(272),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(229),
    [sym_identifier] = ACTIONS(2317),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(285),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_switch] = ACTIONS(299),
    [anon_sym_case] = ACTIONS(301),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_continue] = ACTIONS(315),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym___try] = ACTIONS(319),
    [anon_sym___leave] = ACTIONS(321),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(327),
    [anon_sym_co_return] = ACTIONS(337),
    [anon_sym_co_yield] = ACTIONS(339),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [180] = {
    [sym_attribute_declaration] = STATE(196),
    [sym_compound_statement] = STATE(9449),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(9449),
    [sym_labeled_statement] = STATE(9449),
    [sym_expression_statement] = STATE(9449),
    [sym_if_statement] = STATE(9449),
    [sym_switch_statement] = STATE(9449),
    [sym_case_statement] = STATE(9449),
    [sym_while_statement] = STATE(9449),
    [sym_do_statement] = STATE(9449),
    [sym_for_statement] = STATE(9449),
    [sym_return_statement] = STATE(9449),
    [sym_break_statement] = STATE(9449),
    [sym_continue_statement] = STATE(9449),
    [sym_goto_statement] = STATE(9449),
    [sym_seh_try_statement] = STATE(9449),
    [sym_seh_leave_statement] = STATE(9449),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(9449),
    [sym_co_return_statement] = STATE(9449),
    [sym_co_yield_statement] = STATE(9449),
    [sym_throw_statement] = STATE(9449),
    [sym_try_statement] = STATE(9449),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(196),
    [sym_identifier] = ACTIONS(2299),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(2303),
    [anon_sym_default] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2309),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2311),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [181] = {
    [sym_attribute_declaration] = STATE(207),
    [sym_compound_statement] = STATE(476),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(476),
    [sym_labeled_statement] = STATE(476),
    [sym_expression_statement] = STATE(476),
    [sym_if_statement] = STATE(476),
    [sym_switch_statement] = STATE(476),
    [sym_case_statement] = STATE(476),
    [sym_while_statement] = STATE(476),
    [sym_do_statement] = STATE(476),
    [sym_for_statement] = STATE(476),
    [sym_return_statement] = STATE(476),
    [sym_break_statement] = STATE(476),
    [sym_continue_statement] = STATE(476),
    [sym_goto_statement] = STATE(476),
    [sym_seh_try_statement] = STATE(476),
    [sym_seh_leave_statement] = STATE(476),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(476),
    [sym_co_return_statement] = STATE(476),
    [sym_co_yield_statement] = STATE(476),
    [sym_throw_statement] = STATE(476),
    [sym_try_statement] = STATE(476),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(207),
    [sym_identifier] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(389),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [182] = {
    [sym_attribute_declaration] = STATE(229),
    [sym_compound_statement] = STATE(278),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(278),
    [sym_labeled_statement] = STATE(278),
    [sym_expression_statement] = STATE(278),
    [sym_if_statement] = STATE(278),
    [sym_switch_statement] = STATE(278),
    [sym_case_statement] = STATE(278),
    [sym_while_statement] = STATE(278),
    [sym_do_statement] = STATE(278),
    [sym_for_statement] = STATE(278),
    [sym_return_statement] = STATE(278),
    [sym_break_statement] = STATE(278),
    [sym_continue_statement] = STATE(278),
    [sym_goto_statement] = STATE(278),
    [sym_seh_try_statement] = STATE(278),
    [sym_seh_leave_statement] = STATE(278),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(278),
    [sym_co_return_statement] = STATE(278),
    [sym_co_yield_statement] = STATE(278),
    [sym_throw_statement] = STATE(278),
    [sym_try_statement] = STATE(278),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(229),
    [sym_identifier] = ACTIONS(2317),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(285),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_switch] = ACTIONS(299),
    [anon_sym_case] = ACTIONS(301),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_continue] = ACTIONS(315),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym___try] = ACTIONS(319),
    [anon_sym___leave] = ACTIONS(321),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(327),
    [anon_sym_co_return] = ACTIONS(337),
    [anon_sym_co_yield] = ACTIONS(339),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [183] = {
    [sym_attribute_declaration] = STATE(196),
    [sym_compound_statement] = STATE(9427),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(9427),
    [sym_labeled_statement] = STATE(9427),
    [sym_expression_statement] = STATE(9427),
    [sym_if_statement] = STATE(9427),
    [sym_switch_statement] = STATE(9427),
    [sym_case_statement] = STATE(9427),
    [sym_while_statement] = STATE(9427),
    [sym_do_statement] = STATE(9427),
    [sym_for_statement] = STATE(9427),
    [sym_return_statement] = STATE(9427),
    [sym_break_statement] = STATE(9427),
    [sym_continue_statement] = STATE(9427),
    [sym_goto_statement] = STATE(9427),
    [sym_seh_try_statement] = STATE(9427),
    [sym_seh_leave_statement] = STATE(9427),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(9427),
    [sym_co_return_statement] = STATE(9427),
    [sym_co_yield_statement] = STATE(9427),
    [sym_throw_statement] = STATE(9427),
    [sym_try_statement] = STATE(9427),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(196),
    [sym_identifier] = ACTIONS(2299),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(2303),
    [anon_sym_default] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2309),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2311),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [184] = {
    [sym_attribute_declaration] = STATE(229),
    [sym_compound_statement] = STATE(281),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(283),
    [sym_labeled_statement] = STATE(286),
    [sym_expression_statement] = STATE(288),
    [sym_if_statement] = STATE(290),
    [sym_switch_statement] = STATE(292),
    [sym_case_statement] = STATE(276),
    [sym_while_statement] = STATE(294),
    [sym_do_statement] = STATE(295),
    [sym_for_statement] = STATE(296),
    [sym_return_statement] = STATE(299),
    [sym_break_statement] = STATE(301),
    [sym_continue_statement] = STATE(304),
    [sym_goto_statement] = STATE(306),
    [sym_seh_try_statement] = STATE(307),
    [sym_seh_leave_statement] = STATE(311),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(312),
    [sym_co_return_statement] = STATE(313),
    [sym_co_yield_statement] = STATE(314),
    [sym_throw_statement] = STATE(317),
    [sym_try_statement] = STATE(275),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(229),
    [sym_identifier] = ACTIONS(2317),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(285),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_switch] = ACTIONS(299),
    [anon_sym_case] = ACTIONS(301),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_continue] = ACTIONS(315),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym___try] = ACTIONS(319),
    [anon_sym___leave] = ACTIONS(321),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(327),
    [anon_sym_co_return] = ACTIONS(337),
    [anon_sym_co_yield] = ACTIONS(339),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [185] = {
    [sym_attribute_declaration] = STATE(229),
    [sym_compound_statement] = STATE(320),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(321),
    [sym_labeled_statement] = STATE(309),
    [sym_expression_statement] = STATE(349),
    [sym_if_statement] = STATE(326),
    [sym_switch_statement] = STATE(328),
    [sym_case_statement] = STATE(330),
    [sym_while_statement] = STATE(331),
    [sym_do_statement] = STATE(332),
    [sym_for_statement] = STATE(333),
    [sym_return_statement] = STATE(334),
    [sym_break_statement] = STATE(336),
    [sym_continue_statement] = STATE(338),
    [sym_goto_statement] = STATE(339),
    [sym_seh_try_statement] = STATE(340),
    [sym_seh_leave_statement] = STATE(342),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(343),
    [sym_co_return_statement] = STATE(344),
    [sym_co_yield_statement] = STATE(347),
    [sym_throw_statement] = STATE(348),
    [sym_try_statement] = STATE(350),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(229),
    [sym_identifier] = ACTIONS(2317),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(285),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_switch] = ACTIONS(299),
    [anon_sym_case] = ACTIONS(301),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_continue] = ACTIONS(315),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym___try] = ACTIONS(319),
    [anon_sym___leave] = ACTIONS(321),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(327),
    [anon_sym_co_return] = ACTIONS(337),
    [anon_sym_co_yield] = ACTIONS(339),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [186] = {
    [sym_attribute_declaration] = STATE(186),
    [sym_compound_statement] = STATE(1187),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(1187),
    [sym_labeled_statement] = STATE(1187),
    [sym_expression_statement] = STATE(1187),
    [sym_if_statement] = STATE(1187),
    [sym_switch_statement] = STATE(1187),
    [sym_case_statement] = STATE(1187),
    [sym_while_statement] = STATE(1187),
    [sym_do_statement] = STATE(1187),
    [sym_for_statement] = STATE(1187),
    [sym_return_statement] = STATE(1187),
    [sym_break_statement] = STATE(1187),
    [sym_continue_statement] = STATE(1187),
    [sym_goto_statement] = STATE(1187),
    [sym_seh_try_statement] = STATE(1187),
    [sym_seh_leave_statement] = STATE(1187),
    [sym__expression] = STATE(5293),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9447),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(1187),
    [sym_co_return_statement] = STATE(1187),
    [sym_co_yield_statement] = STATE(1187),
    [sym_throw_statement] = STATE(1187),
    [sym_try_statement] = STATE(1187),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(186),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LPAREN2] = ACTIONS(2322),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2325),
    [anon_sym_DASH] = ACTIONS(2328),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_STAR] = ACTIONS(2331),
    [anon_sym_AMP] = ACTIONS(2331),
    [anon_sym_SEMI] = ACTIONS(2585),
    [anon_sym_COLON_COLON] = ACTIONS(2337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [aux_sym_primitive_type_token1] = ACTIONS(2349),
    [anon_sym_byte] = ACTIONS(2349),
    [anon_sym_word] = ACTIONS(2349),
    [anon_sym_if] = ACTIONS(2591),
    [anon_sym_switch] = ACTIONS(2594),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_default] = ACTIONS(2600),
    [anon_sym_while] = ACTIONS(2603),
    [anon_sym_do] = ACTIONS(2606),
    [anon_sym_for] = ACTIONS(2609),
    [anon_sym_return] = ACTIONS(2612),
    [anon_sym_break] = ACTIONS(2615),
    [anon_sym_continue] = ACTIONS(2618),
    [anon_sym_goto] = ACTIONS(2621),
    [anon_sym___try] = ACTIONS(2624),
    [anon_sym___leave] = ACTIONS(2627),
    [anon_sym_not] = ACTIONS(2328),
    [anon_sym_compl] = ACTIONS(2328),
    [anon_sym_DASH_DASH] = ACTIONS(2391),
    [anon_sym_PLUS_PLUS] = ACTIONS(2391),
    [anon_sym_sizeof] = ACTIONS(2394),
    [anon_sym___alignof__] = ACTIONS(2397),
    [anon_sym___alignof] = ACTIONS(2397),
    [anon_sym__alignof] = ACTIONS(2397),
    [anon_sym_alignof] = ACTIONS(2397),
    [anon_sym__Alignof] = ACTIONS(2397),
    [anon_sym_offsetof] = ACTIONS(2400),
    [anon_sym__Generic] = ACTIONS(2403),
    [anon_sym_asm] = ACTIONS(2406),
    [anon_sym___asm__] = ACTIONS(2406),
    [aux_sym_number_literal_token1] = ACTIONS(2409),
    [aux_sym_number_literal_token2] = ACTIONS(2412),
    [anon_sym_L_SQUOTE] = ACTIONS(2415),
    [anon_sym_u_SQUOTE] = ACTIONS(2415),
    [anon_sym_U_SQUOTE] = ACTIONS(2415),
    [anon_sym_u8_SQUOTE] = ACTIONS(2415),
    [anon_sym_SQUOTE] = ACTIONS(2415),
    [anon_sym_L_DQUOTE] = ACTIONS(2418),
    [anon_sym_u_DQUOTE] = ACTIONS(2418),
    [anon_sym_U_DQUOTE] = ACTIONS(2418),
    [anon_sym_u8_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [sym_true] = ACTIONS(2421),
    [sym_false] = ACTIONS(2421),
    [anon_sym_NULL] = ACTIONS(2424),
    [anon_sym_nullptr] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2427),
    [anon_sym_template] = ACTIONS(2430),
    [anon_sym_try] = ACTIONS(2630),
    [anon_sym_delete] = ACTIONS(2436),
    [anon_sym_throw] = ACTIONS(2633),
    [anon_sym_co_return] = ACTIONS(2636),
    [anon_sym_co_yield] = ACTIONS(2639),
    [anon_sym_R_DQUOTE] = ACTIONS(2448),
    [anon_sym_LR_DQUOTE] = ACTIONS(2448),
    [anon_sym_uR_DQUOTE] = ACTIONS(2448),
    [anon_sym_UR_DQUOTE] = ACTIONS(2448),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2448),
    [anon_sym_co_await] = ACTIONS(2451),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_requires] = ACTIONS(2457),
    [sym_this] = ACTIONS(2421),
  },
  [187] = {
    [sym_attribute_declaration] = STATE(196),
    [sym_compound_statement] = STATE(823),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(823),
    [sym_labeled_statement] = STATE(823),
    [sym_expression_statement] = STATE(823),
    [sym_if_statement] = STATE(823),
    [sym_switch_statement] = STATE(823),
    [sym_case_statement] = STATE(823),
    [sym_while_statement] = STATE(823),
    [sym_do_statement] = STATE(823),
    [sym_for_statement] = STATE(823),
    [sym_return_statement] = STATE(823),
    [sym_break_statement] = STATE(823),
    [sym_continue_statement] = STATE(823),
    [sym_goto_statement] = STATE(823),
    [sym_seh_try_statement] = STATE(823),
    [sym_seh_leave_statement] = STATE(823),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(823),
    [sym_co_return_statement] = STATE(823),
    [sym_co_yield_statement] = STATE(823),
    [sym_throw_statement] = STATE(823),
    [sym_try_statement] = STATE(823),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(196),
    [sym_identifier] = ACTIONS(2299),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(2303),
    [anon_sym_default] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2309),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2311),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [188] = {
    [sym_attribute_declaration] = STATE(196),
    [sym_compound_statement] = STATE(697),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(697),
    [sym_labeled_statement] = STATE(697),
    [sym_expression_statement] = STATE(697),
    [sym_if_statement] = STATE(697),
    [sym_switch_statement] = STATE(697),
    [sym_case_statement] = STATE(697),
    [sym_while_statement] = STATE(697),
    [sym_do_statement] = STATE(697),
    [sym_for_statement] = STATE(697),
    [sym_return_statement] = STATE(697),
    [sym_break_statement] = STATE(697),
    [sym_continue_statement] = STATE(697),
    [sym_goto_statement] = STATE(697),
    [sym_seh_try_statement] = STATE(697),
    [sym_seh_leave_statement] = STATE(697),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(697),
    [sym_co_return_statement] = STATE(697),
    [sym_co_yield_statement] = STATE(697),
    [sym_throw_statement] = STATE(697),
    [sym_try_statement] = STATE(697),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(196),
    [sym_identifier] = ACTIONS(2299),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(2303),
    [anon_sym_default] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2309),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2311),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [189] = {
    [sym_attribute_declaration] = STATE(189),
    [sym_compound_statement] = STATE(809),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(809),
    [sym_labeled_statement] = STATE(809),
    [sym_expression_statement] = STATE(809),
    [sym_if_statement] = STATE(809),
    [sym_switch_statement] = STATE(809),
    [sym_case_statement] = STATE(809),
    [sym_while_statement] = STATE(809),
    [sym_do_statement] = STATE(809),
    [sym_for_statement] = STATE(809),
    [sym_return_statement] = STATE(809),
    [sym_break_statement] = STATE(809),
    [sym_continue_statement] = STATE(809),
    [sym_goto_statement] = STATE(809),
    [sym_seh_try_statement] = STATE(809),
    [sym_seh_leave_statement] = STATE(809),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(809),
    [sym_co_return_statement] = STATE(809),
    [sym_co_yield_statement] = STATE(809),
    [sym_throw_statement] = STATE(809),
    [sym_try_statement] = STATE(809),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(189),
    [sym_identifier] = ACTIONS(2642),
    [anon_sym_LPAREN2] = ACTIONS(2322),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2325),
    [anon_sym_DASH] = ACTIONS(2328),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_STAR] = ACTIONS(2331),
    [anon_sym_AMP] = ACTIONS(2331),
    [anon_sym_SEMI] = ACTIONS(2334),
    [anon_sym_COLON_COLON] = ACTIONS(2337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [aux_sym_primitive_type_token1] = ACTIONS(2349),
    [anon_sym_byte] = ACTIONS(2349),
    [anon_sym_word] = ACTIONS(2349),
    [anon_sym_if] = ACTIONS(2645),
    [anon_sym_switch] = ACTIONS(2532),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_default] = ACTIONS(2600),
    [anon_sym_while] = ACTIONS(2648),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2651),
    [anon_sym_return] = ACTIONS(2550),
    [anon_sym_break] = ACTIONS(2553),
    [anon_sym_continue] = ACTIONS(2556),
    [anon_sym_goto] = ACTIONS(2559),
    [anon_sym___try] = ACTIONS(2654),
    [anon_sym___leave] = ACTIONS(2388),
    [anon_sym_not] = ACTIONS(2328),
    [anon_sym_compl] = ACTIONS(2328),
    [anon_sym_DASH_DASH] = ACTIONS(2391),
    [anon_sym_PLUS_PLUS] = ACTIONS(2391),
    [anon_sym_sizeof] = ACTIONS(2394),
    [anon_sym___alignof__] = ACTIONS(2397),
    [anon_sym___alignof] = ACTIONS(2397),
    [anon_sym__alignof] = ACTIONS(2397),
    [anon_sym_alignof] = ACTIONS(2397),
    [anon_sym__Alignof] = ACTIONS(2397),
    [anon_sym_offsetof] = ACTIONS(2400),
    [anon_sym__Generic] = ACTIONS(2403),
    [anon_sym_asm] = ACTIONS(2406),
    [anon_sym___asm__] = ACTIONS(2406),
    [aux_sym_number_literal_token1] = ACTIONS(2409),
    [aux_sym_number_literal_token2] = ACTIONS(2412),
    [anon_sym_L_SQUOTE] = ACTIONS(2415),
    [anon_sym_u_SQUOTE] = ACTIONS(2415),
    [anon_sym_U_SQUOTE] = ACTIONS(2415),
    [anon_sym_u8_SQUOTE] = ACTIONS(2415),
    [anon_sym_SQUOTE] = ACTIONS(2415),
    [anon_sym_L_DQUOTE] = ACTIONS(2418),
    [anon_sym_u_DQUOTE] = ACTIONS(2418),
    [anon_sym_U_DQUOTE] = ACTIONS(2418),
    [anon_sym_u8_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [sym_true] = ACTIONS(2421),
    [sym_false] = ACTIONS(2421),
    [anon_sym_NULL] = ACTIONS(2424),
    [anon_sym_nullptr] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2427),
    [anon_sym_template] = ACTIONS(2430),
    [anon_sym_try] = ACTIONS(2568),
    [anon_sym_delete] = ACTIONS(2436),
    [anon_sym_throw] = ACTIONS(2571),
    [anon_sym_co_return] = ACTIONS(2574),
    [anon_sym_co_yield] = ACTIONS(2577),
    [anon_sym_R_DQUOTE] = ACTIONS(2448),
    [anon_sym_LR_DQUOTE] = ACTIONS(2448),
    [anon_sym_uR_DQUOTE] = ACTIONS(2448),
    [anon_sym_UR_DQUOTE] = ACTIONS(2448),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2448),
    [anon_sym_co_await] = ACTIONS(2451),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_requires] = ACTIONS(2457),
    [sym_this] = ACTIONS(2421),
  },
  [190] = {
    [sym_attribute_declaration] = STATE(196),
    [sym_compound_statement] = STATE(7966),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(7966),
    [sym_labeled_statement] = STATE(7966),
    [sym_expression_statement] = STATE(7966),
    [sym_if_statement] = STATE(7966),
    [sym_switch_statement] = STATE(7966),
    [sym_case_statement] = STATE(7966),
    [sym_while_statement] = STATE(7966),
    [sym_do_statement] = STATE(7966),
    [sym_for_statement] = STATE(7966),
    [sym_return_statement] = STATE(7966),
    [sym_break_statement] = STATE(7966),
    [sym_continue_statement] = STATE(7966),
    [sym_goto_statement] = STATE(7966),
    [sym_seh_try_statement] = STATE(7966),
    [sym_seh_leave_statement] = STATE(7966),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(7966),
    [sym_co_return_statement] = STATE(7966),
    [sym_co_yield_statement] = STATE(7966),
    [sym_throw_statement] = STATE(7966),
    [sym_try_statement] = STATE(7966),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(196),
    [sym_identifier] = ACTIONS(2299),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(2303),
    [anon_sym_default] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2309),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2311),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [191] = {
    [sym_attribute_declaration] = STATE(196),
    [sym_compound_statement] = STATE(760),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(760),
    [sym_labeled_statement] = STATE(760),
    [sym_expression_statement] = STATE(760),
    [sym_if_statement] = STATE(760),
    [sym_switch_statement] = STATE(760),
    [sym_case_statement] = STATE(760),
    [sym_while_statement] = STATE(760),
    [sym_do_statement] = STATE(760),
    [sym_for_statement] = STATE(760),
    [sym_return_statement] = STATE(760),
    [sym_break_statement] = STATE(760),
    [sym_continue_statement] = STATE(760),
    [sym_goto_statement] = STATE(760),
    [sym_seh_try_statement] = STATE(760),
    [sym_seh_leave_statement] = STATE(760),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(760),
    [sym_co_return_statement] = STATE(760),
    [sym_co_yield_statement] = STATE(760),
    [sym_throw_statement] = STATE(760),
    [sym_try_statement] = STATE(760),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(196),
    [sym_identifier] = ACTIONS(2299),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(2303),
    [anon_sym_default] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2309),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2311),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [192] = {
    [sym_attribute_declaration] = STATE(196),
    [sym_compound_statement] = STATE(755),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(754),
    [sym_labeled_statement] = STATE(753),
    [sym_expression_statement] = STATE(752),
    [sym_if_statement] = STATE(751),
    [sym_switch_statement] = STATE(750),
    [sym_case_statement] = STATE(749),
    [sym_while_statement] = STATE(747),
    [sym_do_statement] = STATE(746),
    [sym_for_statement] = STATE(745),
    [sym_return_statement] = STATE(744),
    [sym_break_statement] = STATE(621),
    [sym_continue_statement] = STATE(742),
    [sym_goto_statement] = STATE(740),
    [sym_seh_try_statement] = STATE(738),
    [sym_seh_leave_statement] = STATE(737),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(736),
    [sym_co_return_statement] = STATE(735),
    [sym_co_yield_statement] = STATE(734),
    [sym_throw_statement] = STATE(733),
    [sym_try_statement] = STATE(731),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(196),
    [sym_identifier] = ACTIONS(2299),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(2303),
    [anon_sym_default] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2309),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2311),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [193] = {
    [sym_attribute_declaration] = STATE(196),
    [sym_compound_statement] = STATE(730),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(729),
    [sym_labeled_statement] = STATE(728),
    [sym_expression_statement] = STATE(727),
    [sym_if_statement] = STATE(726),
    [sym_switch_statement] = STATE(725),
    [sym_case_statement] = STATE(724),
    [sym_while_statement] = STATE(723),
    [sym_do_statement] = STATE(722),
    [sym_for_statement] = STATE(721),
    [sym_return_statement] = STATE(720),
    [sym_break_statement] = STATE(719),
    [sym_continue_statement] = STATE(716),
    [sym_goto_statement] = STATE(715),
    [sym_seh_try_statement] = STATE(714),
    [sym_seh_leave_statement] = STATE(713),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(712),
    [sym_co_return_statement] = STATE(710),
    [sym_co_yield_statement] = STATE(709),
    [sym_throw_statement] = STATE(708),
    [sym_try_statement] = STATE(707),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(196),
    [sym_identifier] = ACTIONS(2299),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(2303),
    [anon_sym_default] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2309),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2311),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [194] = {
    [sym_attribute_declaration] = STATE(219),
    [sym_compound_statement] = STATE(648),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(647),
    [sym_labeled_statement] = STATE(645),
    [sym_expression_statement] = STATE(644),
    [sym_if_statement] = STATE(643),
    [sym_switch_statement] = STATE(642),
    [sym_case_statement] = STATE(641),
    [sym_while_statement] = STATE(639),
    [sym_do_statement] = STATE(637),
    [sym_for_statement] = STATE(636),
    [sym_return_statement] = STATE(635),
    [sym_break_statement] = STATE(634),
    [sym_continue_statement] = STATE(633),
    [sym_goto_statement] = STATE(632),
    [sym_seh_try_statement] = STATE(631),
    [sym_seh_leave_statement] = STATE(630),
    [sym__expression] = STATE(5326),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9529),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(629),
    [sym_co_return_statement] = STATE(627),
    [sym_co_yield_statement] = STATE(626),
    [sym_throw_statement] = STATE(625),
    [sym_try_statement] = STATE(623),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [sym_identifier] = ACTIONS(2313),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1121),
    [anon_sym_switch] = ACTIONS(1123),
    [anon_sym_case] = ACTIONS(1125),
    [anon_sym_default] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(1129),
    [anon_sym_do] = ACTIONS(1131),
    [anon_sym_for] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1139),
    [anon_sym_goto] = ACTIONS(1141),
    [anon_sym___try] = ACTIONS(1143),
    [anon_sym___leave] = ACTIONS(1145),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1149),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1151),
    [anon_sym_co_return] = ACTIONS(1161),
    [anon_sym_co_yield] = ACTIONS(1163),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [195] = {
    [sym_attribute_declaration] = STATE(196),
    [sym_compound_statement] = STATE(9403),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(9403),
    [sym_labeled_statement] = STATE(9403),
    [sym_expression_statement] = STATE(9403),
    [sym_if_statement] = STATE(9403),
    [sym_switch_statement] = STATE(9403),
    [sym_case_statement] = STATE(9403),
    [sym_while_statement] = STATE(9403),
    [sym_do_statement] = STATE(9403),
    [sym_for_statement] = STATE(9403),
    [sym_return_statement] = STATE(9403),
    [sym_break_statement] = STATE(9403),
    [sym_continue_statement] = STATE(9403),
    [sym_goto_statement] = STATE(9403),
    [sym_seh_try_statement] = STATE(9403),
    [sym_seh_leave_statement] = STATE(9403),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(9403),
    [sym_co_return_statement] = STATE(9403),
    [sym_co_yield_statement] = STATE(9403),
    [sym_throw_statement] = STATE(9403),
    [sym_try_statement] = STATE(9403),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(196),
    [sym_identifier] = ACTIONS(2299),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(2303),
    [anon_sym_default] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2309),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2311),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [196] = {
    [sym_attribute_declaration] = STATE(189),
    [sym_compound_statement] = STATE(809),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(809),
    [sym_labeled_statement] = STATE(809),
    [sym_expression_statement] = STATE(809),
    [sym_if_statement] = STATE(809),
    [sym_switch_statement] = STATE(809),
    [sym_case_statement] = STATE(809),
    [sym_while_statement] = STATE(809),
    [sym_do_statement] = STATE(809),
    [sym_for_statement] = STATE(809),
    [sym_return_statement] = STATE(809),
    [sym_break_statement] = STATE(809),
    [sym_continue_statement] = STATE(809),
    [sym_goto_statement] = STATE(809),
    [sym_seh_try_statement] = STATE(809),
    [sym_seh_leave_statement] = STATE(809),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(809),
    [sym_co_return_statement] = STATE(809),
    [sym_co_yield_statement] = STATE(809),
    [sym_throw_statement] = STATE(809),
    [sym_try_statement] = STATE(809),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(189),
    [sym_identifier] = ACTIONS(2299),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(2303),
    [anon_sym_default] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2309),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2311),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [197] = {
    [sym_attribute_declaration] = STATE(196),
    [sym_compound_statement] = STATE(8972),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(8972),
    [sym_labeled_statement] = STATE(8972),
    [sym_expression_statement] = STATE(8972),
    [sym_if_statement] = STATE(8972),
    [sym_switch_statement] = STATE(8972),
    [sym_case_statement] = STATE(8972),
    [sym_while_statement] = STATE(8972),
    [sym_do_statement] = STATE(8972),
    [sym_for_statement] = STATE(8972),
    [sym_return_statement] = STATE(8972),
    [sym_break_statement] = STATE(8972),
    [sym_continue_statement] = STATE(8972),
    [sym_goto_statement] = STATE(8972),
    [sym_seh_try_statement] = STATE(8972),
    [sym_seh_leave_statement] = STATE(8972),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(8972),
    [sym_co_return_statement] = STATE(8972),
    [sym_co_yield_statement] = STATE(8972),
    [sym_throw_statement] = STATE(8972),
    [sym_try_statement] = STATE(8972),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(196),
    [sym_identifier] = ACTIONS(2299),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(2303),
    [anon_sym_default] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2309),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2311),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [198] = {
    [sym_attribute_declaration] = STATE(219),
    [sym_compound_statement] = STATE(690),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(686),
    [sym_labeled_statement] = STATE(685),
    [sym_expression_statement] = STATE(680),
    [sym_if_statement] = STATE(679),
    [sym_switch_statement] = STATE(674),
    [sym_case_statement] = STATE(673),
    [sym_while_statement] = STATE(669),
    [sym_do_statement] = STATE(668),
    [sym_for_statement] = STATE(667),
    [sym_return_statement] = STATE(665),
    [sym_break_statement] = STATE(664),
    [sym_continue_statement] = STATE(662),
    [sym_goto_statement] = STATE(661),
    [sym_seh_try_statement] = STATE(659),
    [sym_seh_leave_statement] = STATE(655),
    [sym__expression] = STATE(5326),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9529),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(654),
    [sym_co_return_statement] = STATE(653),
    [sym_co_yield_statement] = STATE(652),
    [sym_throw_statement] = STATE(651),
    [sym_try_statement] = STATE(649),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [sym_identifier] = ACTIONS(2313),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1121),
    [anon_sym_switch] = ACTIONS(1123),
    [anon_sym_case] = ACTIONS(1125),
    [anon_sym_default] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(1129),
    [anon_sym_do] = ACTIONS(1131),
    [anon_sym_for] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1139),
    [anon_sym_goto] = ACTIONS(1141),
    [anon_sym___try] = ACTIONS(1143),
    [anon_sym___leave] = ACTIONS(1145),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1149),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1151),
    [anon_sym_co_return] = ACTIONS(1161),
    [anon_sym_co_yield] = ACTIONS(1163),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [199] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3904),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_initializer_list] = STATE(2907),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2151),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_LPAREN2] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2657),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_PERCENT] = ACTIONS(2149),
    [anon_sym_PIPE_PIPE] = ACTIONS(2151),
    [anon_sym_AMP_AMP] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(2149),
    [anon_sym_CARET] = ACTIONS(2149),
    [anon_sym_AMP] = ACTIONS(2149),
    [anon_sym_EQ_EQ] = ACTIONS(2151),
    [anon_sym_BANG_EQ] = ACTIONS(2151),
    [anon_sym_GT] = ACTIONS(2149),
    [anon_sym_GT_EQ] = ACTIONS(2151),
    [anon_sym_LT_EQ] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_LT_LT] = ACTIONS(2149),
    [anon_sym_GT_GT] = ACTIONS(2149),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACE] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [anon_sym_EQ] = ACTIONS(2149),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(2149),
    [anon_sym_QMARK] = ACTIONS(2151),
    [anon_sym_STAR_EQ] = ACTIONS(2151),
    [anon_sym_SLASH_EQ] = ACTIONS(2151),
    [anon_sym_PERCENT_EQ] = ACTIONS(2151),
    [anon_sym_PLUS_EQ] = ACTIONS(2151),
    [anon_sym_DASH_EQ] = ACTIONS(2151),
    [anon_sym_LT_LT_EQ] = ACTIONS(2151),
    [anon_sym_GT_GT_EQ] = ACTIONS(2151),
    [anon_sym_AMP_EQ] = ACTIONS(2151),
    [anon_sym_CARET_EQ] = ACTIONS(2151),
    [anon_sym_PIPE_EQ] = ACTIONS(2151),
    [anon_sym_and_eq] = ACTIONS(2149),
    [anon_sym_or_eq] = ACTIONS(2149),
    [anon_sym_xor_eq] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_LT_EQ_GT] = ACTIONS(2151),
    [anon_sym_or] = ACTIONS(2149),
    [anon_sym_and] = ACTIONS(2149),
    [anon_sym_bitor] = ACTIONS(2149),
    [anon_sym_xor] = ACTIONS(2149),
    [anon_sym_bitand] = ACTIONS(2149),
    [anon_sym_not_eq] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_sizeof] = ACTIONS(2663),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2149),
    [anon_sym_DOT_STAR] = ACTIONS(2151),
    [anon_sym_DASH_GT] = ACTIONS(2151),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [200] = {
    [sym_attribute_declaration] = STATE(181),
    [sym_compound_statement] = STATE(440),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_if_statement] = STATE(440),
    [sym_switch_statement] = STATE(440),
    [sym_case_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_goto_statement] = STATE(440),
    [sym_seh_try_statement] = STATE(440),
    [sym_seh_leave_statement] = STATE(440),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(440),
    [sym_co_return_statement] = STATE(440),
    [sym_co_yield_statement] = STATE(440),
    [sym_throw_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [sym_identifier] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(389),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [201] = {
    [sym_attribute_declaration] = STATE(181),
    [sym_compound_statement] = STATE(496),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(496),
    [sym_labeled_statement] = STATE(496),
    [sym_expression_statement] = STATE(496),
    [sym_if_statement] = STATE(496),
    [sym_switch_statement] = STATE(496),
    [sym_case_statement] = STATE(496),
    [sym_while_statement] = STATE(496),
    [sym_do_statement] = STATE(496),
    [sym_for_statement] = STATE(496),
    [sym_return_statement] = STATE(496),
    [sym_break_statement] = STATE(496),
    [sym_continue_statement] = STATE(496),
    [sym_goto_statement] = STATE(496),
    [sym_seh_try_statement] = STATE(496),
    [sym_seh_leave_statement] = STATE(496),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(496),
    [sym_co_return_statement] = STATE(496),
    [sym_co_yield_statement] = STATE(496),
    [sym_throw_statement] = STATE(496),
    [sym_try_statement] = STATE(496),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [sym_identifier] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(389),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [202] = {
    [sym_attribute_declaration] = STATE(219),
    [sym_compound_statement] = STATE(694),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(694),
    [sym_labeled_statement] = STATE(694),
    [sym_expression_statement] = STATE(694),
    [sym_if_statement] = STATE(694),
    [sym_switch_statement] = STATE(694),
    [sym_case_statement] = STATE(694),
    [sym_while_statement] = STATE(694),
    [sym_do_statement] = STATE(694),
    [sym_for_statement] = STATE(694),
    [sym_return_statement] = STATE(694),
    [sym_break_statement] = STATE(694),
    [sym_continue_statement] = STATE(694),
    [sym_goto_statement] = STATE(694),
    [sym_seh_try_statement] = STATE(694),
    [sym_seh_leave_statement] = STATE(694),
    [sym__expression] = STATE(5326),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9529),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(694),
    [sym_co_return_statement] = STATE(694),
    [sym_co_yield_statement] = STATE(694),
    [sym_throw_statement] = STATE(694),
    [sym_try_statement] = STATE(694),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [sym_identifier] = ACTIONS(2313),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1121),
    [anon_sym_switch] = ACTIONS(1123),
    [anon_sym_case] = ACTIONS(1125),
    [anon_sym_default] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(1129),
    [anon_sym_do] = ACTIONS(1131),
    [anon_sym_for] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1139),
    [anon_sym_goto] = ACTIONS(1141),
    [anon_sym___try] = ACTIONS(1143),
    [anon_sym___leave] = ACTIONS(1145),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1149),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1151),
    [anon_sym_co_return] = ACTIONS(1161),
    [anon_sym_co_yield] = ACTIONS(1163),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [203] = {
    [sym_attribute_declaration] = STATE(196),
    [sym_compound_statement] = STATE(9237),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(9237),
    [sym_labeled_statement] = STATE(9237),
    [sym_expression_statement] = STATE(9237),
    [sym_if_statement] = STATE(9237),
    [sym_switch_statement] = STATE(9237),
    [sym_case_statement] = STATE(9237),
    [sym_while_statement] = STATE(9237),
    [sym_do_statement] = STATE(9237),
    [sym_for_statement] = STATE(9237),
    [sym_return_statement] = STATE(9237),
    [sym_break_statement] = STATE(9237),
    [sym_continue_statement] = STATE(9237),
    [sym_goto_statement] = STATE(9237),
    [sym_seh_try_statement] = STATE(9237),
    [sym_seh_leave_statement] = STATE(9237),
    [sym__expression] = STATE(5338),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9080),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(9237),
    [sym_co_return_statement] = STATE(9237),
    [sym_co_yield_statement] = STATE(9237),
    [sym_throw_statement] = STATE(9237),
    [sym_try_statement] = STATE(9237),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(196),
    [sym_identifier] = ACTIONS(2299),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(2303),
    [anon_sym_default] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2309),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2311),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [204] = {
    [sym_attribute_declaration] = STATE(181),
    [sym_compound_statement] = STATE(500),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(500),
    [sym_labeled_statement] = STATE(500),
    [sym_expression_statement] = STATE(500),
    [sym_if_statement] = STATE(500),
    [sym_switch_statement] = STATE(500),
    [sym_case_statement] = STATE(500),
    [sym_while_statement] = STATE(500),
    [sym_do_statement] = STATE(500),
    [sym_for_statement] = STATE(500),
    [sym_return_statement] = STATE(500),
    [sym_break_statement] = STATE(500),
    [sym_continue_statement] = STATE(500),
    [sym_goto_statement] = STATE(500),
    [sym_seh_try_statement] = STATE(500),
    [sym_seh_leave_statement] = STATE(500),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(500),
    [sym_co_return_statement] = STATE(500),
    [sym_co_yield_statement] = STATE(500),
    [sym_throw_statement] = STATE(500),
    [sym_try_statement] = STATE(500),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [sym_identifier] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(389),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [205] = {
    [sym_attribute_declaration] = STATE(220),
    [sym_compound_statement] = STATE(1157),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(1157),
    [sym_labeled_statement] = STATE(1157),
    [sym_expression_statement] = STATE(1157),
    [sym_if_statement] = STATE(1157),
    [sym_switch_statement] = STATE(1157),
    [sym_case_statement] = STATE(1157),
    [sym_while_statement] = STATE(1157),
    [sym_do_statement] = STATE(1157),
    [sym_for_statement] = STATE(1157),
    [sym_return_statement] = STATE(1157),
    [sym_break_statement] = STATE(1157),
    [sym_continue_statement] = STATE(1157),
    [sym_goto_statement] = STATE(1157),
    [sym_seh_try_statement] = STATE(1157),
    [sym_seh_leave_statement] = STATE(1157),
    [sym__expression] = STATE(5293),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9447),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(1157),
    [sym_co_return_statement] = STATE(1157),
    [sym_co_yield_statement] = STATE(1157),
    [sym_throw_statement] = STATE(1157),
    [sym_try_statement] = STATE(1157),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(220),
    [sym_identifier] = ACTIONS(2315),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1893),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_switch] = ACTIONS(1903),
    [anon_sym_case] = ACTIONS(2303),
    [anon_sym_default] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_do] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1911),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1915),
    [anon_sym_goto] = ACTIONS(1917),
    [anon_sym___try] = ACTIONS(1919),
    [anon_sym___leave] = ACTIONS(1921),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1923),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1925),
    [anon_sym_co_return] = ACTIONS(1927),
    [anon_sym_co_yield] = ACTIONS(1929),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [206] = {
    [sym_attribute_declaration] = STATE(219),
    [sym_compound_statement] = STATE(591),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(591),
    [sym_labeled_statement] = STATE(591),
    [sym_expression_statement] = STATE(591),
    [sym_if_statement] = STATE(591),
    [sym_switch_statement] = STATE(591),
    [sym_case_statement] = STATE(591),
    [sym_while_statement] = STATE(591),
    [sym_do_statement] = STATE(591),
    [sym_for_statement] = STATE(591),
    [sym_return_statement] = STATE(591),
    [sym_break_statement] = STATE(591),
    [sym_continue_statement] = STATE(591),
    [sym_goto_statement] = STATE(591),
    [sym_seh_try_statement] = STATE(591),
    [sym_seh_leave_statement] = STATE(591),
    [sym__expression] = STATE(5326),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9529),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(591),
    [sym_co_return_statement] = STATE(591),
    [sym_co_yield_statement] = STATE(591),
    [sym_throw_statement] = STATE(591),
    [sym_try_statement] = STATE(591),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [sym_identifier] = ACTIONS(2313),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1121),
    [anon_sym_switch] = ACTIONS(1123),
    [anon_sym_case] = ACTIONS(1125),
    [anon_sym_default] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(1129),
    [anon_sym_do] = ACTIONS(1131),
    [anon_sym_for] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1139),
    [anon_sym_goto] = ACTIONS(1141),
    [anon_sym___try] = ACTIONS(1143),
    [anon_sym___leave] = ACTIONS(1145),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1149),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1151),
    [anon_sym_co_return] = ACTIONS(1161),
    [anon_sym_co_yield] = ACTIONS(1163),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [207] = {
    [sym_attribute_declaration] = STATE(207),
    [sym_compound_statement] = STATE(476),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(476),
    [sym_labeled_statement] = STATE(476),
    [sym_expression_statement] = STATE(476),
    [sym_if_statement] = STATE(476),
    [sym_switch_statement] = STATE(476),
    [sym_case_statement] = STATE(476),
    [sym_while_statement] = STATE(476),
    [sym_do_statement] = STATE(476),
    [sym_for_statement] = STATE(476),
    [sym_return_statement] = STATE(476),
    [sym_break_statement] = STATE(476),
    [sym_continue_statement] = STATE(476),
    [sym_goto_statement] = STATE(476),
    [sym_seh_try_statement] = STATE(476),
    [sym_seh_leave_statement] = STATE(476),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(476),
    [sym_co_return_statement] = STATE(476),
    [sym_co_yield_statement] = STATE(476),
    [sym_throw_statement] = STATE(476),
    [sym_try_statement] = STATE(476),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(207),
    [sym_identifier] = ACTIONS(2669),
    [anon_sym_LPAREN2] = ACTIONS(2322),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2325),
    [anon_sym_DASH] = ACTIONS(2328),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_STAR] = ACTIONS(2331),
    [anon_sym_AMP] = ACTIONS(2331),
    [anon_sym_SEMI] = ACTIONS(2672),
    [anon_sym_COLON_COLON] = ACTIONS(2337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2675),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [aux_sym_primitive_type_token1] = ACTIONS(2349),
    [anon_sym_byte] = ACTIONS(2349),
    [anon_sym_word] = ACTIONS(2349),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2681),
    [anon_sym_case] = ACTIONS(2684),
    [anon_sym_default] = ACTIONS(2687),
    [anon_sym_while] = ACTIONS(2690),
    [anon_sym_do] = ACTIONS(2693),
    [anon_sym_for] = ACTIONS(2696),
    [anon_sym_return] = ACTIONS(2699),
    [anon_sym_break] = ACTIONS(2702),
    [anon_sym_continue] = ACTIONS(2705),
    [anon_sym_goto] = ACTIONS(2708),
    [anon_sym___try] = ACTIONS(2711),
    [anon_sym___leave] = ACTIONS(2714),
    [anon_sym_not] = ACTIONS(2328),
    [anon_sym_compl] = ACTIONS(2328),
    [anon_sym_DASH_DASH] = ACTIONS(2391),
    [anon_sym_PLUS_PLUS] = ACTIONS(2391),
    [anon_sym_sizeof] = ACTIONS(2394),
    [anon_sym___alignof__] = ACTIONS(2397),
    [anon_sym___alignof] = ACTIONS(2397),
    [anon_sym__alignof] = ACTIONS(2397),
    [anon_sym_alignof] = ACTIONS(2397),
    [anon_sym__Alignof] = ACTIONS(2397),
    [anon_sym_offsetof] = ACTIONS(2400),
    [anon_sym__Generic] = ACTIONS(2403),
    [anon_sym_asm] = ACTIONS(2406),
    [anon_sym___asm__] = ACTIONS(2406),
    [aux_sym_number_literal_token1] = ACTIONS(2409),
    [aux_sym_number_literal_token2] = ACTIONS(2412),
    [anon_sym_L_SQUOTE] = ACTIONS(2415),
    [anon_sym_u_SQUOTE] = ACTIONS(2415),
    [anon_sym_U_SQUOTE] = ACTIONS(2415),
    [anon_sym_u8_SQUOTE] = ACTIONS(2415),
    [anon_sym_SQUOTE] = ACTIONS(2415),
    [anon_sym_L_DQUOTE] = ACTIONS(2418),
    [anon_sym_u_DQUOTE] = ACTIONS(2418),
    [anon_sym_U_DQUOTE] = ACTIONS(2418),
    [anon_sym_u8_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [sym_true] = ACTIONS(2421),
    [sym_false] = ACTIONS(2421),
    [anon_sym_NULL] = ACTIONS(2424),
    [anon_sym_nullptr] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2427),
    [anon_sym_template] = ACTIONS(2430),
    [anon_sym_try] = ACTIONS(2717),
    [anon_sym_delete] = ACTIONS(2436),
    [anon_sym_throw] = ACTIONS(2720),
    [anon_sym_co_return] = ACTIONS(2723),
    [anon_sym_co_yield] = ACTIONS(2726),
    [anon_sym_R_DQUOTE] = ACTIONS(2448),
    [anon_sym_LR_DQUOTE] = ACTIONS(2448),
    [anon_sym_uR_DQUOTE] = ACTIONS(2448),
    [anon_sym_UR_DQUOTE] = ACTIONS(2448),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2448),
    [anon_sym_co_await] = ACTIONS(2451),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_requires] = ACTIONS(2457),
    [sym_this] = ACTIONS(2421),
  },
  [208] = {
    [sym_attribute_declaration] = STATE(220),
    [sym_compound_statement] = STATE(1208),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(1208),
    [sym_labeled_statement] = STATE(1208),
    [sym_expression_statement] = STATE(1208),
    [sym_if_statement] = STATE(1208),
    [sym_switch_statement] = STATE(1208),
    [sym_case_statement] = STATE(1208),
    [sym_while_statement] = STATE(1208),
    [sym_do_statement] = STATE(1208),
    [sym_for_statement] = STATE(1208),
    [sym_return_statement] = STATE(1208),
    [sym_break_statement] = STATE(1208),
    [sym_continue_statement] = STATE(1208),
    [sym_goto_statement] = STATE(1208),
    [sym_seh_try_statement] = STATE(1208),
    [sym_seh_leave_statement] = STATE(1208),
    [sym__expression] = STATE(5293),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9447),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(1208),
    [sym_co_return_statement] = STATE(1208),
    [sym_co_yield_statement] = STATE(1208),
    [sym_throw_statement] = STATE(1208),
    [sym_try_statement] = STATE(1208),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(220),
    [sym_identifier] = ACTIONS(2315),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1893),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_switch] = ACTIONS(1903),
    [anon_sym_case] = ACTIONS(2303),
    [anon_sym_default] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_do] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1911),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1915),
    [anon_sym_goto] = ACTIONS(1917),
    [anon_sym___try] = ACTIONS(1919),
    [anon_sym___leave] = ACTIONS(1921),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1923),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1925),
    [anon_sym_co_return] = ACTIONS(1927),
    [anon_sym_co_yield] = ACTIONS(1929),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [209] = {
    [sym_attribute_declaration] = STATE(228),
    [sym_compound_statement] = STATE(569),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(569),
    [sym_labeled_statement] = STATE(569),
    [sym_expression_statement] = STATE(569),
    [sym_if_statement] = STATE(569),
    [sym_switch_statement] = STATE(569),
    [sym_case_statement] = STATE(569),
    [sym_while_statement] = STATE(569),
    [sym_do_statement] = STATE(569),
    [sym_for_statement] = STATE(569),
    [sym_return_statement] = STATE(569),
    [sym_break_statement] = STATE(569),
    [sym_continue_statement] = STATE(569),
    [sym_goto_statement] = STATE(569),
    [sym_seh_try_statement] = STATE(569),
    [sym_seh_leave_statement] = STATE(569),
    [sym__expression] = STATE(5249),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9175),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(569),
    [sym_co_return_statement] = STATE(569),
    [sym_co_yield_statement] = STATE(569),
    [sym_throw_statement] = STATE(569),
    [sym_try_statement] = STATE(569),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(228),
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(77),
    [anon_sym_default] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(1765),
    [anon_sym___leave] = ACTIONS(1767),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [210] = {
    [sym_attribute_declaration] = STATE(220),
    [sym_compound_statement] = STATE(1211),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(1212),
    [sym_labeled_statement] = STATE(1213),
    [sym_expression_statement] = STATE(1215),
    [sym_if_statement] = STATE(1216),
    [sym_switch_statement] = STATE(1217),
    [sym_case_statement] = STATE(1224),
    [sym_while_statement] = STATE(1232),
    [sym_do_statement] = STATE(1234),
    [sym_for_statement] = STATE(1236),
    [sym_return_statement] = STATE(1237),
    [sym_break_statement] = STATE(1238),
    [sym_continue_statement] = STATE(1239),
    [sym_goto_statement] = STATE(1161),
    [sym_seh_try_statement] = STATE(1241),
    [sym_seh_leave_statement] = STATE(1235),
    [sym__expression] = STATE(5293),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9447),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(1233),
    [sym_co_return_statement] = STATE(1230),
    [sym_co_yield_statement] = STATE(1228),
    [sym_throw_statement] = STATE(1227),
    [sym_try_statement] = STATE(1226),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(220),
    [sym_identifier] = ACTIONS(2315),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1893),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_switch] = ACTIONS(1903),
    [anon_sym_case] = ACTIONS(2303),
    [anon_sym_default] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_do] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1911),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1915),
    [anon_sym_goto] = ACTIONS(1917),
    [anon_sym___try] = ACTIONS(1919),
    [anon_sym___leave] = ACTIONS(1921),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1923),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1925),
    [anon_sym_co_return] = ACTIONS(1927),
    [anon_sym_co_yield] = ACTIONS(1929),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [211] = {
    [sym_primitive_type] = STATE(7889),
    [sym__expression] = STATE(3987),
    [sym__expression_not_binary] = STATE(4247),
    [sym__string] = STATE(4247),
    [sym_conditional_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4247),
    [sym_pointer_expression] = STATE(4247),
    [sym_unary_expression] = STATE(4247),
    [sym_binary_expression] = STATE(4247),
    [sym_update_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_alignof_expression] = STATE(4247),
    [sym_offsetof_expression] = STATE(4247),
    [sym_generic_expression] = STATE(4247),
    [sym_subscript_expression] = STATE(4247),
    [sym_call_expression] = STATE(4247),
    [sym_gnu_asm_expression] = STATE(4247),
    [sym_field_expression] = STATE(4247),
    [sym_compound_literal_expression] = STATE(4247),
    [sym_parenthesized_expression] = STATE(4247),
    [sym_initializer_list] = STATE(4332),
    [sym_number_literal] = STATE(4205),
    [sym_char_literal] = STATE(4205),
    [sym_concatenated_string] = STATE(4204),
    [sym_string_literal] = STATE(2832),
    [sym_null] = STATE(4247),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8484),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4247),
    [sym_raw_string_literal] = STATE(2831),
    [sym_co_await_expression] = STATE(4247),
    [sym_new_expression] = STATE(4247),
    [sym_delete_expression] = STATE(4247),
    [sym_requires_clause] = STATE(4247),
    [sym_requires_expression] = STATE(4247),
    [sym_lambda_expression] = STATE(4247),
    [sym_lambda_capture_specifier] = STATE(6732),
    [sym_fold_expression] = STATE(4247),
    [sym_parameter_pack_expansion] = STATE(4247),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4247),
    [sym_qualified_type_identifier] = STATE(8484),
    [sym_user_defined_literal] = STATE(4247),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2151),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_LPAREN2] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_PERCENT] = ACTIONS(2149),
    [anon_sym_PIPE_PIPE] = ACTIONS(2151),
    [anon_sym_AMP_AMP] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(2149),
    [anon_sym_CARET] = ACTIONS(2149),
    [anon_sym_AMP] = ACTIONS(2149),
    [anon_sym_EQ_EQ] = ACTIONS(2151),
    [anon_sym_BANG_EQ] = ACTIONS(2151),
    [anon_sym_GT] = ACTIONS(2149),
    [anon_sym_GT_EQ] = ACTIONS(2149),
    [anon_sym_LT_EQ] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_LT_LT] = ACTIONS(2149),
    [anon_sym_GT_GT] = ACTIONS(2149),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACE] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [anon_sym_EQ] = ACTIONS(2149),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(2151),
    [anon_sym_STAR_EQ] = ACTIONS(2151),
    [anon_sym_SLASH_EQ] = ACTIONS(2151),
    [anon_sym_PERCENT_EQ] = ACTIONS(2151),
    [anon_sym_PLUS_EQ] = ACTIONS(2151),
    [anon_sym_DASH_EQ] = ACTIONS(2151),
    [anon_sym_LT_LT_EQ] = ACTIONS(2151),
    [anon_sym_GT_GT_EQ] = ACTIONS(2149),
    [anon_sym_AMP_EQ] = ACTIONS(2151),
    [anon_sym_CARET_EQ] = ACTIONS(2151),
    [anon_sym_PIPE_EQ] = ACTIONS(2151),
    [anon_sym_and_eq] = ACTIONS(2149),
    [anon_sym_or_eq] = ACTIONS(2149),
    [anon_sym_xor_eq] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2733),
    [anon_sym_compl] = ACTIONS(2733),
    [anon_sym_LT_EQ_GT] = ACTIONS(2151),
    [anon_sym_or] = ACTIONS(2149),
    [anon_sym_and] = ACTIONS(2149),
    [anon_sym_bitor] = ACTIONS(2149),
    [anon_sym_xor] = ACTIONS(2149),
    [anon_sym_bitand] = ACTIONS(2149),
    [anon_sym_not_eq] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2745),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2749),
    [anon_sym___asm__] = ACTIONS(2749),
    [anon_sym_DOT] = ACTIONS(2149),
    [anon_sym_DOT_STAR] = ACTIONS(2151),
    [anon_sym_DASH_GT] = ACTIONS(2151),
    [aux_sym_number_literal_token1] = ACTIONS(2751),
    [aux_sym_number_literal_token2] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2755),
    [anon_sym_u_SQUOTE] = ACTIONS(2755),
    [anon_sym_U_SQUOTE] = ACTIONS(2755),
    [anon_sym_u8_SQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_GT2] = ACTIONS(2151),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2759),
  },
  [212] = {
    [sym_attribute_declaration] = STATE(228),
    [sym_compound_statement] = STATE(566),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(566),
    [sym_labeled_statement] = STATE(566),
    [sym_expression_statement] = STATE(566),
    [sym_if_statement] = STATE(566),
    [sym_switch_statement] = STATE(566),
    [sym_case_statement] = STATE(566),
    [sym_while_statement] = STATE(566),
    [sym_do_statement] = STATE(566),
    [sym_for_statement] = STATE(566),
    [sym_return_statement] = STATE(566),
    [sym_break_statement] = STATE(566),
    [sym_continue_statement] = STATE(566),
    [sym_goto_statement] = STATE(566),
    [sym_seh_try_statement] = STATE(566),
    [sym_seh_leave_statement] = STATE(566),
    [sym__expression] = STATE(5249),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9175),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(566),
    [sym_co_return_statement] = STATE(566),
    [sym_co_yield_statement] = STATE(566),
    [sym_throw_statement] = STATE(566),
    [sym_try_statement] = STATE(566),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(228),
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(77),
    [anon_sym_default] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(1765),
    [anon_sym___leave] = ACTIONS(1767),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [213] = {
    [sym_attribute_declaration] = STATE(181),
    [sym_compound_statement] = STATE(397),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(397),
    [sym_labeled_statement] = STATE(397),
    [sym_expression_statement] = STATE(397),
    [sym_if_statement] = STATE(397),
    [sym_switch_statement] = STATE(397),
    [sym_case_statement] = STATE(397),
    [sym_while_statement] = STATE(397),
    [sym_do_statement] = STATE(397),
    [sym_for_statement] = STATE(397),
    [sym_return_statement] = STATE(397),
    [sym_break_statement] = STATE(397),
    [sym_continue_statement] = STATE(397),
    [sym_goto_statement] = STATE(397),
    [sym_seh_try_statement] = STATE(397),
    [sym_seh_leave_statement] = STATE(397),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(397),
    [sym_co_return_statement] = STATE(397),
    [sym_co_yield_statement] = STATE(397),
    [sym_throw_statement] = STATE(397),
    [sym_try_statement] = STATE(397),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [sym_identifier] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(389),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [214] = {
    [sym_attribute_declaration] = STATE(228),
    [sym_compound_statement] = STATE(697),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(697),
    [sym_labeled_statement] = STATE(697),
    [sym_expression_statement] = STATE(697),
    [sym_if_statement] = STATE(697),
    [sym_switch_statement] = STATE(697),
    [sym_case_statement] = STATE(697),
    [sym_while_statement] = STATE(697),
    [sym_do_statement] = STATE(697),
    [sym_for_statement] = STATE(697),
    [sym_return_statement] = STATE(697),
    [sym_break_statement] = STATE(697),
    [sym_continue_statement] = STATE(697),
    [sym_goto_statement] = STATE(697),
    [sym_seh_try_statement] = STATE(697),
    [sym_seh_leave_statement] = STATE(697),
    [sym__expression] = STATE(5249),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9175),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(697),
    [sym_co_return_statement] = STATE(697),
    [sym_co_yield_statement] = STATE(697),
    [sym_throw_statement] = STATE(697),
    [sym_try_statement] = STATE(697),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(228),
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(77),
    [anon_sym_default] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(1765),
    [anon_sym___leave] = ACTIONS(1767),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [215] = {
    [sym_attribute_declaration] = STATE(215),
    [sym_compound_statement] = STATE(768),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(768),
    [sym_labeled_statement] = STATE(768),
    [sym_expression_statement] = STATE(768),
    [sym_if_statement] = STATE(768),
    [sym_switch_statement] = STATE(768),
    [sym_case_statement] = STATE(768),
    [sym_while_statement] = STATE(768),
    [sym_do_statement] = STATE(768),
    [sym_for_statement] = STATE(768),
    [sym_return_statement] = STATE(768),
    [sym_break_statement] = STATE(768),
    [sym_continue_statement] = STATE(768),
    [sym_goto_statement] = STATE(768),
    [sym_seh_try_statement] = STATE(768),
    [sym_seh_leave_statement] = STATE(768),
    [sym__expression] = STATE(5326),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9529),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(768),
    [sym_co_return_statement] = STATE(768),
    [sym_co_yield_statement] = STATE(768),
    [sym_throw_statement] = STATE(768),
    [sym_try_statement] = STATE(768),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(215),
    [sym_identifier] = ACTIONS(2773),
    [anon_sym_LPAREN2] = ACTIONS(2322),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2325),
    [anon_sym_DASH] = ACTIONS(2328),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_STAR] = ACTIONS(2331),
    [anon_sym_AMP] = ACTIONS(2331),
    [anon_sym_SEMI] = ACTIONS(2776),
    [anon_sym_COLON_COLON] = ACTIONS(2337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2779),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [aux_sym_primitive_type_token1] = ACTIONS(2349),
    [anon_sym_byte] = ACTIONS(2349),
    [anon_sym_word] = ACTIONS(2349),
    [anon_sym_if] = ACTIONS(2782),
    [anon_sym_switch] = ACTIONS(2785),
    [anon_sym_case] = ACTIONS(2788),
    [anon_sym_default] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2794),
    [anon_sym_do] = ACTIONS(2797),
    [anon_sym_for] = ACTIONS(2800),
    [anon_sym_return] = ACTIONS(2803),
    [anon_sym_break] = ACTIONS(2806),
    [anon_sym_continue] = ACTIONS(2809),
    [anon_sym_goto] = ACTIONS(2812),
    [anon_sym___try] = ACTIONS(2815),
    [anon_sym___leave] = ACTIONS(2818),
    [anon_sym_not] = ACTIONS(2328),
    [anon_sym_compl] = ACTIONS(2328),
    [anon_sym_DASH_DASH] = ACTIONS(2391),
    [anon_sym_PLUS_PLUS] = ACTIONS(2391),
    [anon_sym_sizeof] = ACTIONS(2394),
    [anon_sym___alignof__] = ACTIONS(2397),
    [anon_sym___alignof] = ACTIONS(2397),
    [anon_sym__alignof] = ACTIONS(2397),
    [anon_sym_alignof] = ACTIONS(2397),
    [anon_sym__Alignof] = ACTIONS(2397),
    [anon_sym_offsetof] = ACTIONS(2400),
    [anon_sym__Generic] = ACTIONS(2403),
    [anon_sym_asm] = ACTIONS(2406),
    [anon_sym___asm__] = ACTIONS(2406),
    [aux_sym_number_literal_token1] = ACTIONS(2409),
    [aux_sym_number_literal_token2] = ACTIONS(2412),
    [anon_sym_L_SQUOTE] = ACTIONS(2415),
    [anon_sym_u_SQUOTE] = ACTIONS(2415),
    [anon_sym_U_SQUOTE] = ACTIONS(2415),
    [anon_sym_u8_SQUOTE] = ACTIONS(2415),
    [anon_sym_SQUOTE] = ACTIONS(2415),
    [anon_sym_L_DQUOTE] = ACTIONS(2418),
    [anon_sym_u_DQUOTE] = ACTIONS(2418),
    [anon_sym_U_DQUOTE] = ACTIONS(2418),
    [anon_sym_u8_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [sym_true] = ACTIONS(2421),
    [sym_false] = ACTIONS(2421),
    [anon_sym_NULL] = ACTIONS(2424),
    [anon_sym_nullptr] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2427),
    [anon_sym_template] = ACTIONS(2430),
    [anon_sym_try] = ACTIONS(2821),
    [anon_sym_delete] = ACTIONS(2436),
    [anon_sym_throw] = ACTIONS(2824),
    [anon_sym_co_return] = ACTIONS(2827),
    [anon_sym_co_yield] = ACTIONS(2830),
    [anon_sym_R_DQUOTE] = ACTIONS(2448),
    [anon_sym_LR_DQUOTE] = ACTIONS(2448),
    [anon_sym_uR_DQUOTE] = ACTIONS(2448),
    [anon_sym_UR_DQUOTE] = ACTIONS(2448),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2448),
    [anon_sym_co_await] = ACTIONS(2451),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_requires] = ACTIONS(2457),
    [sym_this] = ACTIONS(2421),
  },
  [216] = {
    [sym_attribute_declaration] = STATE(228),
    [sym_compound_statement] = STATE(823),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(823),
    [sym_labeled_statement] = STATE(823),
    [sym_expression_statement] = STATE(823),
    [sym_if_statement] = STATE(823),
    [sym_switch_statement] = STATE(823),
    [sym_case_statement] = STATE(823),
    [sym_while_statement] = STATE(823),
    [sym_do_statement] = STATE(823),
    [sym_for_statement] = STATE(823),
    [sym_return_statement] = STATE(823),
    [sym_break_statement] = STATE(823),
    [sym_continue_statement] = STATE(823),
    [sym_goto_statement] = STATE(823),
    [sym_seh_try_statement] = STATE(823),
    [sym_seh_leave_statement] = STATE(823),
    [sym__expression] = STATE(5249),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9175),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(823),
    [sym_co_return_statement] = STATE(823),
    [sym_co_yield_statement] = STATE(823),
    [sym_throw_statement] = STATE(823),
    [sym_try_statement] = STATE(823),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(228),
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(77),
    [anon_sym_default] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(1765),
    [anon_sym___leave] = ACTIONS(1767),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [217] = {
    [sym_attribute_declaration] = STATE(220),
    [sym_compound_statement] = STATE(1220),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(1219),
    [sym_labeled_statement] = STATE(1214),
    [sym_expression_statement] = STATE(1206),
    [sym_if_statement] = STATE(1204),
    [sym_switch_statement] = STATE(1200),
    [sym_case_statement] = STATE(1198),
    [sym_while_statement] = STATE(1194),
    [sym_do_statement] = STATE(1193),
    [sym_for_statement] = STATE(1190),
    [sym_return_statement] = STATE(1189),
    [sym_break_statement] = STATE(1188),
    [sym_continue_statement] = STATE(1186),
    [sym_goto_statement] = STATE(1184),
    [sym_seh_try_statement] = STATE(1183),
    [sym_seh_leave_statement] = STATE(1182),
    [sym__expression] = STATE(5293),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9447),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(1181),
    [sym_co_return_statement] = STATE(1179),
    [sym_co_yield_statement] = STATE(1174),
    [sym_throw_statement] = STATE(1172),
    [sym_try_statement] = STATE(1170),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(220),
    [sym_identifier] = ACTIONS(2315),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1893),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_switch] = ACTIONS(1903),
    [anon_sym_case] = ACTIONS(2303),
    [anon_sym_default] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_do] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1911),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1915),
    [anon_sym_goto] = ACTIONS(1917),
    [anon_sym___try] = ACTIONS(1919),
    [anon_sym___leave] = ACTIONS(1921),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1923),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1925),
    [anon_sym_co_return] = ACTIONS(1927),
    [anon_sym_co_yield] = ACTIONS(1929),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [218] = {
    [sym_attribute_declaration] = STATE(228),
    [sym_compound_statement] = STATE(730),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(729),
    [sym_labeled_statement] = STATE(728),
    [sym_expression_statement] = STATE(727),
    [sym_if_statement] = STATE(726),
    [sym_switch_statement] = STATE(725),
    [sym_case_statement] = STATE(724),
    [sym_while_statement] = STATE(723),
    [sym_do_statement] = STATE(722),
    [sym_for_statement] = STATE(721),
    [sym_return_statement] = STATE(720),
    [sym_break_statement] = STATE(719),
    [sym_continue_statement] = STATE(716),
    [sym_goto_statement] = STATE(715),
    [sym_seh_try_statement] = STATE(714),
    [sym_seh_leave_statement] = STATE(713),
    [sym__expression] = STATE(5249),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9175),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(712),
    [sym_co_return_statement] = STATE(710),
    [sym_co_yield_statement] = STATE(709),
    [sym_throw_statement] = STATE(708),
    [sym_try_statement] = STATE(707),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(228),
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(77),
    [anon_sym_default] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(1765),
    [anon_sym___leave] = ACTIONS(1767),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [219] = {
    [sym_attribute_declaration] = STATE(215),
    [sym_compound_statement] = STATE(768),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(768),
    [sym_labeled_statement] = STATE(768),
    [sym_expression_statement] = STATE(768),
    [sym_if_statement] = STATE(768),
    [sym_switch_statement] = STATE(768),
    [sym_case_statement] = STATE(768),
    [sym_while_statement] = STATE(768),
    [sym_do_statement] = STATE(768),
    [sym_for_statement] = STATE(768),
    [sym_return_statement] = STATE(768),
    [sym_break_statement] = STATE(768),
    [sym_continue_statement] = STATE(768),
    [sym_goto_statement] = STATE(768),
    [sym_seh_try_statement] = STATE(768),
    [sym_seh_leave_statement] = STATE(768),
    [sym__expression] = STATE(5326),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9529),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(768),
    [sym_co_return_statement] = STATE(768),
    [sym_co_yield_statement] = STATE(768),
    [sym_throw_statement] = STATE(768),
    [sym_try_statement] = STATE(768),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(215),
    [sym_identifier] = ACTIONS(2313),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1121),
    [anon_sym_switch] = ACTIONS(1123),
    [anon_sym_case] = ACTIONS(1125),
    [anon_sym_default] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(1129),
    [anon_sym_do] = ACTIONS(1131),
    [anon_sym_for] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1139),
    [anon_sym_goto] = ACTIONS(1141),
    [anon_sym___try] = ACTIONS(1143),
    [anon_sym___leave] = ACTIONS(1145),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1149),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1151),
    [anon_sym_co_return] = ACTIONS(1161),
    [anon_sym_co_yield] = ACTIONS(1163),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [220] = {
    [sym_attribute_declaration] = STATE(186),
    [sym_compound_statement] = STATE(1187),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(1187),
    [sym_labeled_statement] = STATE(1187),
    [sym_expression_statement] = STATE(1187),
    [sym_if_statement] = STATE(1187),
    [sym_switch_statement] = STATE(1187),
    [sym_case_statement] = STATE(1187),
    [sym_while_statement] = STATE(1187),
    [sym_do_statement] = STATE(1187),
    [sym_for_statement] = STATE(1187),
    [sym_return_statement] = STATE(1187),
    [sym_break_statement] = STATE(1187),
    [sym_continue_statement] = STATE(1187),
    [sym_goto_statement] = STATE(1187),
    [sym_seh_try_statement] = STATE(1187),
    [sym_seh_leave_statement] = STATE(1187),
    [sym__expression] = STATE(5293),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9447),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(1187),
    [sym_co_return_statement] = STATE(1187),
    [sym_co_yield_statement] = STATE(1187),
    [sym_throw_statement] = STATE(1187),
    [sym_try_statement] = STATE(1187),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(186),
    [sym_identifier] = ACTIONS(2315),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1893),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_switch] = ACTIONS(1903),
    [anon_sym_case] = ACTIONS(2303),
    [anon_sym_default] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_do] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1911),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1915),
    [anon_sym_goto] = ACTIONS(1917),
    [anon_sym___try] = ACTIONS(1919),
    [anon_sym___leave] = ACTIONS(1921),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1923),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1925),
    [anon_sym_co_return] = ACTIONS(1927),
    [anon_sym_co_yield] = ACTIONS(1929),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [221] = {
    [sym_attribute_declaration] = STATE(228),
    [sym_compound_statement] = STATE(755),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(754),
    [sym_labeled_statement] = STATE(753),
    [sym_expression_statement] = STATE(752),
    [sym_if_statement] = STATE(751),
    [sym_switch_statement] = STATE(750),
    [sym_case_statement] = STATE(749),
    [sym_while_statement] = STATE(747),
    [sym_do_statement] = STATE(746),
    [sym_for_statement] = STATE(745),
    [sym_return_statement] = STATE(744),
    [sym_break_statement] = STATE(621),
    [sym_continue_statement] = STATE(742),
    [sym_goto_statement] = STATE(740),
    [sym_seh_try_statement] = STATE(738),
    [sym_seh_leave_statement] = STATE(737),
    [sym__expression] = STATE(5249),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9175),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(736),
    [sym_co_return_statement] = STATE(735),
    [sym_co_yield_statement] = STATE(734),
    [sym_throw_statement] = STATE(733),
    [sym_try_statement] = STATE(731),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(228),
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(77),
    [anon_sym_default] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(1765),
    [anon_sym___leave] = ACTIONS(1767),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [222] = {
    [sym_attribute_declaration] = STATE(181),
    [sym_compound_statement] = STATE(532),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(532),
    [sym_labeled_statement] = STATE(532),
    [sym_expression_statement] = STATE(532),
    [sym_if_statement] = STATE(532),
    [sym_switch_statement] = STATE(532),
    [sym_case_statement] = STATE(532),
    [sym_while_statement] = STATE(532),
    [sym_do_statement] = STATE(532),
    [sym_for_statement] = STATE(532),
    [sym_return_statement] = STATE(532),
    [sym_break_statement] = STATE(532),
    [sym_continue_statement] = STATE(532),
    [sym_goto_statement] = STATE(532),
    [sym_seh_try_statement] = STATE(532),
    [sym_seh_leave_statement] = STATE(532),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(532),
    [sym_co_return_statement] = STATE(532),
    [sym_co_yield_statement] = STATE(532),
    [sym_throw_statement] = STATE(532),
    [sym_try_statement] = STATE(532),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [sym_identifier] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(389),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [223] = {
    [sym_attribute_declaration] = STATE(181),
    [sym_compound_statement] = STATE(527),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(526),
    [sym_labeled_statement] = STATE(523),
    [sym_expression_statement] = STATE(522),
    [sym_if_statement] = STATE(520),
    [sym_switch_statement] = STATE(517),
    [sym_case_statement] = STATE(516),
    [sym_while_statement] = STATE(514),
    [sym_do_statement] = STATE(513),
    [sym_for_statement] = STATE(512),
    [sym_return_statement] = STATE(511),
    [sym_break_statement] = STATE(510),
    [sym_continue_statement] = STATE(509),
    [sym_goto_statement] = STATE(508),
    [sym_seh_try_statement] = STATE(507),
    [sym_seh_leave_statement] = STATE(506),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(505),
    [sym_co_return_statement] = STATE(502),
    [sym_co_yield_statement] = STATE(488),
    [sym_throw_statement] = STATE(487),
    [sym_try_statement] = STATE(486),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [sym_identifier] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(389),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [224] = {
    [sym_attribute_declaration] = STATE(181),
    [sym_compound_statement] = STATE(485),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(484),
    [sym_labeled_statement] = STATE(483),
    [sym_expression_statement] = STATE(481),
    [sym_if_statement] = STATE(479),
    [sym_switch_statement] = STATE(478),
    [sym_case_statement] = STATE(477),
    [sym_while_statement] = STATE(474),
    [sym_do_statement] = STATE(473),
    [sym_for_statement] = STATE(466),
    [sym_return_statement] = STATE(467),
    [sym_break_statement] = STATE(465),
    [sym_continue_statement] = STATE(475),
    [sym_goto_statement] = STATE(482),
    [sym_seh_try_statement] = STATE(489),
    [sym_seh_leave_statement] = STATE(490),
    [sym__expression] = STATE(5227),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8985),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(493),
    [sym_co_return_statement] = STATE(497),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(537),
    [sym_try_statement] = STATE(535),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(181),
    [sym_identifier] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(389),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_goto] = ACTIONS(405),
    [anon_sym___try] = ACTIONS(407),
    [anon_sym___leave] = ACTIONS(409),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_co_return] = ACTIONS(425),
    [anon_sym_co_yield] = ACTIONS(427),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [225] = {
    [sym_attribute_declaration] = STATE(219),
    [sym_compound_statement] = STATE(854),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(854),
    [sym_labeled_statement] = STATE(854),
    [sym_expression_statement] = STATE(854),
    [sym_if_statement] = STATE(854),
    [sym_switch_statement] = STATE(854),
    [sym_case_statement] = STATE(854),
    [sym_while_statement] = STATE(854),
    [sym_do_statement] = STATE(854),
    [sym_for_statement] = STATE(854),
    [sym_return_statement] = STATE(854),
    [sym_break_statement] = STATE(854),
    [sym_continue_statement] = STATE(854),
    [sym_goto_statement] = STATE(854),
    [sym_seh_try_statement] = STATE(854),
    [sym_seh_leave_statement] = STATE(854),
    [sym__expression] = STATE(5326),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9529),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(854),
    [sym_co_return_statement] = STATE(854),
    [sym_co_yield_statement] = STATE(854),
    [sym_throw_statement] = STATE(854),
    [sym_try_statement] = STATE(854),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [sym_identifier] = ACTIONS(2313),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1121),
    [anon_sym_switch] = ACTIONS(1123),
    [anon_sym_case] = ACTIONS(1125),
    [anon_sym_default] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(1129),
    [anon_sym_do] = ACTIONS(1131),
    [anon_sym_for] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1139),
    [anon_sym_goto] = ACTIONS(1141),
    [anon_sym___try] = ACTIONS(1143),
    [anon_sym___leave] = ACTIONS(1145),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1149),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1151),
    [anon_sym_co_return] = ACTIONS(1161),
    [anon_sym_co_yield] = ACTIONS(1163),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [226] = {
    [sym_attribute_declaration] = STATE(219),
    [sym_compound_statement] = STATE(547),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(547),
    [sym_labeled_statement] = STATE(547),
    [sym_expression_statement] = STATE(547),
    [sym_if_statement] = STATE(547),
    [sym_switch_statement] = STATE(547),
    [sym_case_statement] = STATE(547),
    [sym_while_statement] = STATE(547),
    [sym_do_statement] = STATE(547),
    [sym_for_statement] = STATE(547),
    [sym_return_statement] = STATE(547),
    [sym_break_statement] = STATE(547),
    [sym_continue_statement] = STATE(547),
    [sym_goto_statement] = STATE(547),
    [sym_seh_try_statement] = STATE(547),
    [sym_seh_leave_statement] = STATE(547),
    [sym__expression] = STATE(5326),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9529),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(547),
    [sym_co_return_statement] = STATE(547),
    [sym_co_yield_statement] = STATE(547),
    [sym_throw_statement] = STATE(547),
    [sym_try_statement] = STATE(547),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [sym_identifier] = ACTIONS(2313),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1121),
    [anon_sym_switch] = ACTIONS(1123),
    [anon_sym_case] = ACTIONS(1125),
    [anon_sym_default] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(1129),
    [anon_sym_do] = ACTIONS(1131),
    [anon_sym_for] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1139),
    [anon_sym_goto] = ACTIONS(1141),
    [anon_sym___try] = ACTIONS(1143),
    [anon_sym___leave] = ACTIONS(1145),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1149),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1151),
    [anon_sym_co_return] = ACTIONS(1161),
    [anon_sym_co_yield] = ACTIONS(1163),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [227] = {
    [sym_attribute_declaration] = STATE(228),
    [sym_compound_statement] = STATE(760),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(760),
    [sym_labeled_statement] = STATE(760),
    [sym_expression_statement] = STATE(760),
    [sym_if_statement] = STATE(760),
    [sym_switch_statement] = STATE(760),
    [sym_case_statement] = STATE(760),
    [sym_while_statement] = STATE(760),
    [sym_do_statement] = STATE(760),
    [sym_for_statement] = STATE(760),
    [sym_return_statement] = STATE(760),
    [sym_break_statement] = STATE(760),
    [sym_continue_statement] = STATE(760),
    [sym_goto_statement] = STATE(760),
    [sym_seh_try_statement] = STATE(760),
    [sym_seh_leave_statement] = STATE(760),
    [sym__expression] = STATE(5249),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9175),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(760),
    [sym_co_return_statement] = STATE(760),
    [sym_co_yield_statement] = STATE(760),
    [sym_throw_statement] = STATE(760),
    [sym_try_statement] = STATE(760),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(228),
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(77),
    [anon_sym_default] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(1765),
    [anon_sym___leave] = ACTIONS(1767),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [228] = {
    [sym_attribute_declaration] = STATE(174),
    [sym_compound_statement] = STATE(809),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(809),
    [sym_labeled_statement] = STATE(809),
    [sym_expression_statement] = STATE(809),
    [sym_if_statement] = STATE(809),
    [sym_switch_statement] = STATE(809),
    [sym_case_statement] = STATE(809),
    [sym_while_statement] = STATE(809),
    [sym_do_statement] = STATE(809),
    [sym_for_statement] = STATE(809),
    [sym_return_statement] = STATE(809),
    [sym_break_statement] = STATE(809),
    [sym_continue_statement] = STATE(809),
    [sym_goto_statement] = STATE(809),
    [sym_seh_try_statement] = STATE(809),
    [sym_seh_leave_statement] = STATE(809),
    [sym__expression] = STATE(5249),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9175),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(809),
    [sym_co_return_statement] = STATE(809),
    [sym_co_yield_statement] = STATE(809),
    [sym_throw_statement] = STATE(809),
    [sym_try_statement] = STATE(809),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(174),
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(77),
    [anon_sym_default] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(1765),
    [anon_sym___leave] = ACTIONS(1767),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [229] = {
    [sym_attribute_declaration] = STATE(171),
    [sym_compound_statement] = STATE(335),
    [sym_primitive_type] = STATE(7715),
    [sym_attributed_statement] = STATE(335),
    [sym_labeled_statement] = STATE(335),
    [sym_expression_statement] = STATE(335),
    [sym_if_statement] = STATE(335),
    [sym_switch_statement] = STATE(335),
    [sym_case_statement] = STATE(335),
    [sym_while_statement] = STATE(335),
    [sym_do_statement] = STATE(335),
    [sym_for_statement] = STATE(335),
    [sym_return_statement] = STATE(335),
    [sym_break_statement] = STATE(335),
    [sym_continue_statement] = STATE(335),
    [sym_goto_statement] = STATE(335),
    [sym_seh_try_statement] = STATE(335),
    [sym_seh_leave_statement] = STATE(335),
    [sym__expression] = STATE(5298),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8989),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_for_range_loop] = STATE(335),
    [sym_co_return_statement] = STATE(335),
    [sym_co_yield_statement] = STATE(335),
    [sym_throw_statement] = STATE(335),
    [sym_try_statement] = STATE(335),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_attributed_declarator_repeat1] = STATE(171),
    [sym_identifier] = ACTIONS(2317),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(285),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_switch] = ACTIONS(299),
    [anon_sym_case] = ACTIONS(301),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_continue] = ACTIONS(315),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym___try] = ACTIONS(319),
    [anon_sym___leave] = ACTIONS(321),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(327),
    [anon_sym_co_return] = ACTIONS(337),
    [anon_sym_co_yield] = ACTIONS(339),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [230] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3488),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9369),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9227),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(9288),
    [sym__unary_right_fold] = STATE(9285),
    [sym__binary_fold] = STATE(9284),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9251),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [231] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3419),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9613),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(8811),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(8809),
    [sym__unary_right_fold] = STATE(8802),
    [sym__binary_fold] = STATE(8799),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9513),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [232] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3390),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(8945),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9620),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(9629),
    [sym__unary_right_fold] = STATE(9631),
    [sym__binary_fold] = STATE(9638),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(8961),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [233] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3419),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9613),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9292),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(9031),
    [sym__unary_right_fold] = STATE(9037),
    [sym__binary_fold] = STATE(9039),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9513),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [234] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3488),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9369),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(8913),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(8948),
    [sym__unary_right_fold] = STATE(8950),
    [sym__binary_fold] = STATE(8952),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9251),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [235] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3488),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9369),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9118),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(8948),
    [sym__unary_right_fold] = STATE(8950),
    [sym__binary_fold] = STATE(8952),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9251),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [236] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3390),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(8945),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9644),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(9629),
    [sym__unary_right_fold] = STATE(9631),
    [sym__binary_fold] = STATE(9638),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(8961),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [237] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3390),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(8945),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9514),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(9517),
    [sym__unary_right_fold] = STATE(9519),
    [sym__binary_fold] = STATE(9521),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(8961),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [238] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3416),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9225),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9232),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(8951),
    [sym__unary_right_fold] = STATE(8953),
    [sym__binary_fold] = STATE(8956),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9212),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [239] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3488),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9369),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9156),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(9288),
    [sym__unary_right_fold] = STATE(9285),
    [sym__binary_fold] = STATE(9284),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9251),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [240] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3488),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9369),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9471),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(9288),
    [sym__unary_right_fold] = STATE(9285),
    [sym__binary_fold] = STATE(9284),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9251),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [241] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3419),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9613),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(8939),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(8809),
    [sym__unary_right_fold] = STATE(8802),
    [sym__binary_fold] = STATE(8799),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9513),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [242] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3488),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9369),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9607),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(8948),
    [sym__unary_right_fold] = STATE(8950),
    [sym__binary_fold] = STATE(8952),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9251),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [243] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3488),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9369),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9169),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(9288),
    [sym__unary_right_fold] = STATE(9285),
    [sym__binary_fold] = STATE(9284),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9251),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [244] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3488),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9369),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9400),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(9288),
    [sym__unary_right_fold] = STATE(9285),
    [sym__binary_fold] = STATE(9284),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9251),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [245] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3488),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9369),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9372),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(8948),
    [sym__unary_right_fold] = STATE(8950),
    [sym__binary_fold] = STATE(8952),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9251),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [246] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3390),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(8945),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9683),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(9517),
    [sym__unary_right_fold] = STATE(9519),
    [sym__binary_fold] = STATE(9521),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(8961),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [247] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3488),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9369),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9029),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(8948),
    [sym__unary_right_fold] = STATE(8950),
    [sym__binary_fold] = STATE(8952),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9251),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [248] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3488),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9369),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(8973),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(8948),
    [sym__unary_right_fold] = STATE(8950),
    [sym__binary_fold] = STATE(8952),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9251),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [249] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3419),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9613),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9172),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(9031),
    [sym__unary_right_fold] = STATE(9037),
    [sym__binary_fold] = STATE(9039),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9513),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [250] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3488),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9369),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9093),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(8948),
    [sym__unary_right_fold] = STATE(8950),
    [sym__binary_fold] = STATE(8952),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9251),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [251] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3488),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9369),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(8946),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(8948),
    [sym__unary_right_fold] = STATE(8950),
    [sym__binary_fold] = STATE(8952),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9251),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [252] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3488),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9369),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9412),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(9288),
    [sym__unary_right_fold] = STATE(9285),
    [sym__binary_fold] = STATE(9284),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9251),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [253] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3488),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9369),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9379),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(9288),
    [sym__unary_right_fold] = STATE(9285),
    [sym__binary_fold] = STATE(9284),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9251),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [254] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3488),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9369),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9055),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(9288),
    [sym__unary_right_fold] = STATE(9285),
    [sym__binary_fold] = STATE(9284),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9251),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [255] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3488),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9369),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9260),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(9288),
    [sym__unary_right_fold] = STATE(9285),
    [sym__binary_fold] = STATE(9284),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9251),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [256] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3416),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9225),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(8949),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(8951),
    [sym__unary_right_fold] = STATE(8953),
    [sym__binary_fold] = STATE(8956),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9212),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [257] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3416),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9225),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9224),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(9223),
    [sym__unary_right_fold] = STATE(9218),
    [sym__binary_fold] = STATE(9214),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9212),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [258] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3488),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9369),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9276),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(9288),
    [sym__unary_right_fold] = STATE(9285),
    [sym__binary_fold] = STATE(9284),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9251),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [259] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4319),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_initializer_list] = STATE(4546),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2151),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_RPAREN] = ACTIONS(2151),
    [anon_sym_LPAREN2] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2015),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_PERCENT] = ACTIONS(2149),
    [anon_sym_PIPE_PIPE] = ACTIONS(2151),
    [anon_sym_AMP_AMP] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(2149),
    [anon_sym_CARET] = ACTIONS(2149),
    [anon_sym_AMP] = ACTIONS(2149),
    [anon_sym_EQ_EQ] = ACTIONS(2151),
    [anon_sym_BANG_EQ] = ACTIONS(2151),
    [anon_sym_GT] = ACTIONS(2149),
    [anon_sym_GT_EQ] = ACTIONS(2151),
    [anon_sym_LT_EQ] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_LT_LT] = ACTIONS(2149),
    [anon_sym_GT_GT] = ACTIONS(2149),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [anon_sym_EQ] = ACTIONS(2149),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(2151),
    [anon_sym_STAR_EQ] = ACTIONS(2151),
    [anon_sym_SLASH_EQ] = ACTIONS(2151),
    [anon_sym_PERCENT_EQ] = ACTIONS(2151),
    [anon_sym_PLUS_EQ] = ACTIONS(2151),
    [anon_sym_DASH_EQ] = ACTIONS(2151),
    [anon_sym_LT_LT_EQ] = ACTIONS(2151),
    [anon_sym_GT_GT_EQ] = ACTIONS(2151),
    [anon_sym_AMP_EQ] = ACTIONS(2151),
    [anon_sym_CARET_EQ] = ACTIONS(2151),
    [anon_sym_PIPE_EQ] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_LT_EQ_GT] = ACTIONS(2151),
    [anon_sym_or] = ACTIONS(2149),
    [anon_sym_and] = ACTIONS(2149),
    [anon_sym_bitor] = ACTIONS(2149),
    [anon_sym_xor] = ACTIONS(2149),
    [anon_sym_bitand] = ACTIONS(2149),
    [anon_sym_not_eq] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [anon_sym_DOT] = ACTIONS(2149),
    [anon_sym_DOT_STAR] = ACTIONS(2151),
    [anon_sym_DASH_GT] = ACTIONS(2149),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2151),
    [sym_this] = ACTIONS(2049),
  },
  [260] = {
    [sym_type_qualifier] = STATE(4573),
    [sym__type_specifier] = STATE(5671),
    [sym_sized_type_specifier] = STATE(2258),
    [sym_primitive_type] = STATE(6044),
    [sym_enum_specifier] = STATE(2258),
    [sym_struct_specifier] = STATE(2258),
    [sym_union_specifier] = STATE(2258),
    [sym__expression] = STATE(3416),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_comma_expression] = STATE(9225),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_type_descriptor] = STATE(9027),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_placeholder_type_specifier] = STATE(2258),
    [sym_decltype_auto] = STATE(2253),
    [sym_decltype] = STATE(2142),
    [sym_class_specifier] = STATE(2258),
    [sym__class_name] = STATE(8564),
    [sym_dependent_type] = STATE(2258),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym__unary_left_fold] = STATE(9223),
    [sym__unary_right_fold] = STATE(9218),
    [sym__binary_fold] = STATE(9214),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym__assignment_expression_lhs] = STATE(9212),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4573),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2145),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_signed] = ACTIONS(2093),
    [anon_sym_unsigned] = ACTIONS(2093),
    [anon_sym_long] = ACTIONS(2093),
    [anon_sym_short] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_struct] = ACTIONS(2103),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2131),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2135),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [261] = {
    [sym_catch_clause] = STATE(261),
    [aux_sym_constructor_try_statement_repeat1] = STATE(261),
    [sym_identifier] = ACTIONS(2843),
    [aux_sym_preproc_include_token1] = ACTIONS(2843),
    [aux_sym_preproc_def_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token2] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2843),
    [aux_sym_preproc_else_token1] = ACTIONS(2843),
    [aux_sym_preproc_elif_token1] = ACTIONS(2843),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2843),
    [sym_preproc_directive] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2845),
    [anon_sym_BANG] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym___extension__] = ACTIONS(2843),
    [anon_sym_typedef] = ACTIONS(2843),
    [anon_sym_extern] = ACTIONS(2843),
    [anon_sym___attribute__] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2845),
    [anon_sym___declspec] = ACTIONS(2843),
    [anon_sym___based] = ACTIONS(2843),
    [anon_sym___cdecl] = ACTIONS(2843),
    [anon_sym___clrcall] = ACTIONS(2843),
    [anon_sym___stdcall] = ACTIONS(2843),
    [anon_sym___fastcall] = ACTIONS(2843),
    [anon_sym___thiscall] = ACTIONS(2843),
    [anon_sym___vectorcall] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(2845),
    [anon_sym_signed] = ACTIONS(2843),
    [anon_sym_unsigned] = ACTIONS(2843),
    [anon_sym_long] = ACTIONS(2843),
    [anon_sym_short] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_register] = ACTIONS(2843),
    [anon_sym_inline] = ACTIONS(2843),
    [anon_sym___inline] = ACTIONS(2843),
    [anon_sym___inline__] = ACTIONS(2843),
    [anon_sym___forceinline] = ACTIONS(2843),
    [anon_sym_thread_local] = ACTIONS(2843),
    [anon_sym___thread] = ACTIONS(2843),
    [anon_sym_const] = ACTIONS(2843),
    [anon_sym_constexpr] = ACTIONS(2843),
    [anon_sym_volatile] = ACTIONS(2843),
    [anon_sym_restrict] = ACTIONS(2843),
    [anon_sym___restrict__] = ACTIONS(2843),
    [anon_sym__Atomic] = ACTIONS(2843),
    [anon_sym__Noreturn] = ACTIONS(2843),
    [anon_sym_noreturn] = ACTIONS(2843),
    [anon_sym_mutable] = ACTIONS(2843),
    [anon_sym_constinit] = ACTIONS(2843),
    [anon_sym_consteval] = ACTIONS(2843),
    [anon_sym_PROGMEM] = ACTIONS(2843),
    [aux_sym_primitive_type_token1] = ACTIONS(2843),
    [anon_sym_byte] = ACTIONS(2843),
    [anon_sym_word] = ACTIONS(2843),
    [anon_sym_enum] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2843),
    [anon_sym_union] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_else] = ACTIONS(2843),
    [anon_sym_switch] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2843),
    [anon_sym_default] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_break] = ACTIONS(2843),
    [anon_sym_continue] = ACTIONS(2843),
    [anon_sym_goto] = ACTIONS(2843),
    [anon_sym___try] = ACTIONS(2843),
    [anon_sym___leave] = ACTIONS(2843),
    [anon_sym_not] = ACTIONS(2843),
    [anon_sym_compl] = ACTIONS(2843),
    [anon_sym_DASH_DASH] = ACTIONS(2845),
    [anon_sym_PLUS_PLUS] = ACTIONS(2845),
    [anon_sym_sizeof] = ACTIONS(2843),
    [anon_sym___alignof__] = ACTIONS(2843),
    [anon_sym___alignof] = ACTIONS(2843),
    [anon_sym__alignof] = ACTIONS(2843),
    [anon_sym_alignof] = ACTIONS(2843),
    [anon_sym__Alignof] = ACTIONS(2843),
    [anon_sym_offsetof] = ACTIONS(2843),
    [anon_sym__Generic] = ACTIONS(2843),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [aux_sym_number_literal_token1] = ACTIONS(2845),
    [aux_sym_number_literal_token2] = ACTIONS(2843),
    [anon_sym_L_SQUOTE] = ACTIONS(2845),
    [anon_sym_u_SQUOTE] = ACTIONS(2845),
    [anon_sym_U_SQUOTE] = ACTIONS(2845),
    [anon_sym_u8_SQUOTE] = ACTIONS(2845),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_L_DQUOTE] = ACTIONS(2845),
    [anon_sym_u_DQUOTE] = ACTIONS(2845),
    [anon_sym_U_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(2845),
    [sym_true] = ACTIONS(2843),
    [sym_false] = ACTIONS(2843),
    [anon_sym_NULL] = ACTIONS(2843),
    [anon_sym_nullptr] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2843),
    [anon_sym_decltype] = ACTIONS(2843),
    [anon_sym_virtual] = ACTIONS(2843),
    [anon_sym_alignas] = ACTIONS(2843),
    [anon_sym_explicit] = ACTIONS(2843),
    [anon_sym_typename] = ACTIONS(2843),
    [anon_sym_template] = ACTIONS(2843),
    [anon_sym_operator] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_delete] = ACTIONS(2843),
    [anon_sym_throw] = ACTIONS(2843),
    [anon_sym_namespace] = ACTIONS(2843),
    [anon_sym_using] = ACTIONS(2843),
    [anon_sym_static_assert] = ACTIONS(2843),
    [anon_sym_concept] = ACTIONS(2843),
    [anon_sym_co_return] = ACTIONS(2843),
    [anon_sym_co_yield] = ACTIONS(2843),
    [anon_sym_catch] = ACTIONS(2847),
    [anon_sym_R_DQUOTE] = ACTIONS(2845),
    [anon_sym_LR_DQUOTE] = ACTIONS(2845),
    [anon_sym_uR_DQUOTE] = ACTIONS(2845),
    [anon_sym_UR_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2845),
    [anon_sym_co_await] = ACTIONS(2843),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_requires] = ACTIONS(2843),
    [sym_this] = ACTIONS(2843),
  },
  [262] = {
    [sym_catch_clause] = STATE(261),
    [aux_sym_constructor_try_statement_repeat1] = STATE(261),
    [sym_identifier] = ACTIONS(2850),
    [aux_sym_preproc_include_token1] = ACTIONS(2850),
    [aux_sym_preproc_def_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token2] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2850),
    [aux_sym_preproc_else_token1] = ACTIONS(2850),
    [aux_sym_preproc_elif_token1] = ACTIONS(2850),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2850),
    [sym_preproc_directive] = ACTIONS(2850),
    [anon_sym_LPAREN2] = ACTIONS(2852),
    [anon_sym_BANG] = ACTIONS(2852),
    [anon_sym_TILDE] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(2850),
    [anon_sym_PLUS] = ACTIONS(2850),
    [anon_sym_STAR] = ACTIONS(2852),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_AMP] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2852),
    [anon_sym___extension__] = ACTIONS(2850),
    [anon_sym_typedef] = ACTIONS(2850),
    [anon_sym_extern] = ACTIONS(2850),
    [anon_sym___attribute__] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2852),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2852),
    [anon_sym___declspec] = ACTIONS(2850),
    [anon_sym___based] = ACTIONS(2850),
    [anon_sym___cdecl] = ACTIONS(2850),
    [anon_sym___clrcall] = ACTIONS(2850),
    [anon_sym___stdcall] = ACTIONS(2850),
    [anon_sym___fastcall] = ACTIONS(2850),
    [anon_sym___thiscall] = ACTIONS(2850),
    [anon_sym___vectorcall] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2852),
    [anon_sym_signed] = ACTIONS(2850),
    [anon_sym_unsigned] = ACTIONS(2850),
    [anon_sym_long] = ACTIONS(2850),
    [anon_sym_short] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2850),
    [anon_sym_register] = ACTIONS(2850),
    [anon_sym_inline] = ACTIONS(2850),
    [anon_sym___inline] = ACTIONS(2850),
    [anon_sym___inline__] = ACTIONS(2850),
    [anon_sym___forceinline] = ACTIONS(2850),
    [anon_sym_thread_local] = ACTIONS(2850),
    [anon_sym___thread] = ACTIONS(2850),
    [anon_sym_const] = ACTIONS(2850),
    [anon_sym_constexpr] = ACTIONS(2850),
    [anon_sym_volatile] = ACTIONS(2850),
    [anon_sym_restrict] = ACTIONS(2850),
    [anon_sym___restrict__] = ACTIONS(2850),
    [anon_sym__Atomic] = ACTIONS(2850),
    [anon_sym__Noreturn] = ACTIONS(2850),
    [anon_sym_noreturn] = ACTIONS(2850),
    [anon_sym_mutable] = ACTIONS(2850),
    [anon_sym_constinit] = ACTIONS(2850),
    [anon_sym_consteval] = ACTIONS(2850),
    [anon_sym_PROGMEM] = ACTIONS(2850),
    [aux_sym_primitive_type_token1] = ACTIONS(2850),
    [anon_sym_byte] = ACTIONS(2850),
    [anon_sym_word] = ACTIONS(2850),
    [anon_sym_enum] = ACTIONS(2850),
    [anon_sym_class] = ACTIONS(2850),
    [anon_sym_struct] = ACTIONS(2850),
    [anon_sym_union] = ACTIONS(2850),
    [anon_sym_if] = ACTIONS(2850),
    [anon_sym_else] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2850),
    [anon_sym_case] = ACTIONS(2850),
    [anon_sym_default] = ACTIONS(2850),
    [anon_sym_while] = ACTIONS(2850),
    [anon_sym_do] = ACTIONS(2850),
    [anon_sym_for] = ACTIONS(2850),
    [anon_sym_return] = ACTIONS(2850),
    [anon_sym_break] = ACTIONS(2850),
    [anon_sym_continue] = ACTIONS(2850),
    [anon_sym_goto] = ACTIONS(2850),
    [anon_sym___try] = ACTIONS(2850),
    [anon_sym___leave] = ACTIONS(2850),
    [anon_sym_not] = ACTIONS(2850),
    [anon_sym_compl] = ACTIONS(2850),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_sizeof] = ACTIONS(2850),
    [anon_sym___alignof__] = ACTIONS(2850),
    [anon_sym___alignof] = ACTIONS(2850),
    [anon_sym__alignof] = ACTIONS(2850),
    [anon_sym_alignof] = ACTIONS(2850),
    [anon_sym__Alignof] = ACTIONS(2850),
    [anon_sym_offsetof] = ACTIONS(2850),
    [anon_sym__Generic] = ACTIONS(2850),
    [anon_sym_asm] = ACTIONS(2850),
    [anon_sym___asm__] = ACTIONS(2850),
    [aux_sym_number_literal_token1] = ACTIONS(2852),
    [aux_sym_number_literal_token2] = ACTIONS(2850),
    [anon_sym_L_SQUOTE] = ACTIONS(2852),
    [anon_sym_u_SQUOTE] = ACTIONS(2852),
    [anon_sym_U_SQUOTE] = ACTIONS(2852),
    [anon_sym_u8_SQUOTE] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2852),
    [anon_sym_L_DQUOTE] = ACTIONS(2852),
    [anon_sym_u_DQUOTE] = ACTIONS(2852),
    [anon_sym_U_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8_DQUOTE] = ACTIONS(2852),
    [anon_sym_DQUOTE] = ACTIONS(2852),
    [sym_true] = ACTIONS(2850),
    [sym_false] = ACTIONS(2850),
    [anon_sym_NULL] = ACTIONS(2850),
    [anon_sym_nullptr] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2850),
    [anon_sym_decltype] = ACTIONS(2850),
    [anon_sym_virtual] = ACTIONS(2850),
    [anon_sym_alignas] = ACTIONS(2850),
    [anon_sym_explicit] = ACTIONS(2850),
    [anon_sym_typename] = ACTIONS(2850),
    [anon_sym_template] = ACTIONS(2850),
    [anon_sym_operator] = ACTIONS(2850),
    [anon_sym_try] = ACTIONS(2850),
    [anon_sym_delete] = ACTIONS(2850),
    [anon_sym_throw] = ACTIONS(2850),
    [anon_sym_namespace] = ACTIONS(2850),
    [anon_sym_using] = ACTIONS(2850),
    [anon_sym_static_assert] = ACTIONS(2850),
    [anon_sym_concept] = ACTIONS(2850),
    [anon_sym_co_return] = ACTIONS(2850),
    [anon_sym_co_yield] = ACTIONS(2850),
    [anon_sym_catch] = ACTIONS(2854),
    [anon_sym_R_DQUOTE] = ACTIONS(2852),
    [anon_sym_LR_DQUOTE] = ACTIONS(2852),
    [anon_sym_uR_DQUOTE] = ACTIONS(2852),
    [anon_sym_UR_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2852),
    [anon_sym_co_await] = ACTIONS(2850),
    [anon_sym_new] = ACTIONS(2850),
    [anon_sym_requires] = ACTIONS(2850),
    [sym_this] = ACTIONS(2850),
  },
  [263] = {
    [sym_catch_clause] = STATE(261),
    [aux_sym_constructor_try_statement_repeat1] = STATE(261),
    [sym_identifier] = ACTIONS(2856),
    [aux_sym_preproc_include_token1] = ACTIONS(2856),
    [aux_sym_preproc_def_token1] = ACTIONS(2856),
    [aux_sym_preproc_if_token1] = ACTIONS(2856),
    [aux_sym_preproc_if_token2] = ACTIONS(2856),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2856),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2856),
    [aux_sym_preproc_else_token1] = ACTIONS(2856),
    [aux_sym_preproc_elif_token1] = ACTIONS(2856),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2856),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2856),
    [sym_preproc_directive] = ACTIONS(2856),
    [anon_sym_LPAREN2] = ACTIONS(2858),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2856),
    [anon_sym_PLUS] = ACTIONS(2856),
    [anon_sym_STAR] = ACTIONS(2858),
    [anon_sym_AMP_AMP] = ACTIONS(2858),
    [anon_sym_AMP] = ACTIONS(2856),
    [anon_sym_SEMI] = ACTIONS(2858),
    [anon_sym___extension__] = ACTIONS(2856),
    [anon_sym_typedef] = ACTIONS(2856),
    [anon_sym_extern] = ACTIONS(2856),
    [anon_sym___attribute__] = ACTIONS(2856),
    [anon_sym_COLON_COLON] = ACTIONS(2858),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2858),
    [anon_sym___declspec] = ACTIONS(2856),
    [anon_sym___based] = ACTIONS(2856),
    [anon_sym___cdecl] = ACTIONS(2856),
    [anon_sym___clrcall] = ACTIONS(2856),
    [anon_sym___stdcall] = ACTIONS(2856),
    [anon_sym___fastcall] = ACTIONS(2856),
    [anon_sym___thiscall] = ACTIONS(2856),
    [anon_sym___vectorcall] = ACTIONS(2856),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_signed] = ACTIONS(2856),
    [anon_sym_unsigned] = ACTIONS(2856),
    [anon_sym_long] = ACTIONS(2856),
    [anon_sym_short] = ACTIONS(2856),
    [anon_sym_LBRACK] = ACTIONS(2856),
    [anon_sym_static] = ACTIONS(2856),
    [anon_sym_register] = ACTIONS(2856),
    [anon_sym_inline] = ACTIONS(2856),
    [anon_sym___inline] = ACTIONS(2856),
    [anon_sym___inline__] = ACTIONS(2856),
    [anon_sym___forceinline] = ACTIONS(2856),
    [anon_sym_thread_local] = ACTIONS(2856),
    [anon_sym___thread] = ACTIONS(2856),
    [anon_sym_const] = ACTIONS(2856),
    [anon_sym_constexpr] = ACTIONS(2856),
    [anon_sym_volatile] = ACTIONS(2856),
    [anon_sym_restrict] = ACTIONS(2856),
    [anon_sym___restrict__] = ACTIONS(2856),
    [anon_sym__Atomic] = ACTIONS(2856),
    [anon_sym__Noreturn] = ACTIONS(2856),
    [anon_sym_noreturn] = ACTIONS(2856),
    [anon_sym_mutable] = ACTIONS(2856),
    [anon_sym_constinit] = ACTIONS(2856),
    [anon_sym_consteval] = ACTIONS(2856),
    [anon_sym_PROGMEM] = ACTIONS(2856),
    [aux_sym_primitive_type_token1] = ACTIONS(2856),
    [anon_sym_byte] = ACTIONS(2856),
    [anon_sym_word] = ACTIONS(2856),
    [anon_sym_enum] = ACTIONS(2856),
    [anon_sym_class] = ACTIONS(2856),
    [anon_sym_struct] = ACTIONS(2856),
    [anon_sym_union] = ACTIONS(2856),
    [anon_sym_if] = ACTIONS(2856),
    [anon_sym_switch] = ACTIONS(2856),
    [anon_sym_case] = ACTIONS(2856),
    [anon_sym_default] = ACTIONS(2856),
    [anon_sym_while] = ACTIONS(2856),
    [anon_sym_do] = ACTIONS(2856),
    [anon_sym_for] = ACTIONS(2856),
    [anon_sym_return] = ACTIONS(2856),
    [anon_sym_break] = ACTIONS(2856),
    [anon_sym_continue] = ACTIONS(2856),
    [anon_sym_goto] = ACTIONS(2856),
    [anon_sym___try] = ACTIONS(2856),
    [anon_sym___leave] = ACTIONS(2856),
    [anon_sym_not] = ACTIONS(2856),
    [anon_sym_compl] = ACTIONS(2856),
    [anon_sym_DASH_DASH] = ACTIONS(2858),
    [anon_sym_PLUS_PLUS] = ACTIONS(2858),
    [anon_sym_sizeof] = ACTIONS(2856),
    [anon_sym___alignof__] = ACTIONS(2856),
    [anon_sym___alignof] = ACTIONS(2856),
    [anon_sym__alignof] = ACTIONS(2856),
    [anon_sym_alignof] = ACTIONS(2856),
    [anon_sym__Alignof] = ACTIONS(2856),
    [anon_sym_offsetof] = ACTIONS(2856),
    [anon_sym__Generic] = ACTIONS(2856),
    [anon_sym_asm] = ACTIONS(2856),
    [anon_sym___asm__] = ACTIONS(2856),
    [aux_sym_number_literal_token1] = ACTIONS(2858),
    [aux_sym_number_literal_token2] = ACTIONS(2856),
    [anon_sym_L_SQUOTE] = ACTIONS(2858),
    [anon_sym_u_SQUOTE] = ACTIONS(2858),
    [anon_sym_U_SQUOTE] = ACTIONS(2858),
    [anon_sym_u8_SQUOTE] = ACTIONS(2858),
    [anon_sym_SQUOTE] = ACTIONS(2858),
    [anon_sym_L_DQUOTE] = ACTIONS(2858),
    [anon_sym_u_DQUOTE] = ACTIONS(2858),
    [anon_sym_U_DQUOTE] = ACTIONS(2858),
    [anon_sym_u8_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE] = ACTIONS(2858),
    [sym_true] = ACTIONS(2856),
    [sym_false] = ACTIONS(2856),
    [anon_sym_NULL] = ACTIONS(2856),
    [anon_sym_nullptr] = ACTIONS(2856),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2856),
    [anon_sym_decltype] = ACTIONS(2856),
    [anon_sym_virtual] = ACTIONS(2856),
    [anon_sym_alignas] = ACTIONS(2856),
    [anon_sym_explicit] = ACTIONS(2856),
    [anon_sym_typename] = ACTIONS(2856),
    [anon_sym_template] = ACTIONS(2856),
    [anon_sym_operator] = ACTIONS(2856),
    [anon_sym_try] = ACTIONS(2856),
    [anon_sym_delete] = ACTIONS(2856),
    [anon_sym_throw] = ACTIONS(2856),
    [anon_sym_namespace] = ACTIONS(2856),
    [anon_sym_using] = ACTIONS(2856),
    [anon_sym_static_assert] = ACTIONS(2856),
    [anon_sym_concept] = ACTIONS(2856),
    [anon_sym_co_return] = ACTIONS(2856),
    [anon_sym_co_yield] = ACTIONS(2856),
    [anon_sym_catch] = ACTIONS(2854),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_LR_DQUOTE] = ACTIONS(2858),
    [anon_sym_uR_DQUOTE] = ACTIONS(2858),
    [anon_sym_UR_DQUOTE] = ACTIONS(2858),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2858),
    [anon_sym_co_await] = ACTIONS(2856),
    [anon_sym_new] = ACTIONS(2856),
    [anon_sym_requires] = ACTIONS(2856),
    [sym_this] = ACTIONS(2856),
  },
  [264] = {
    [sym_catch_clause] = STATE(261),
    [aux_sym_constructor_try_statement_repeat1] = STATE(261),
    [sym_identifier] = ACTIONS(2860),
    [aux_sym_preproc_include_token1] = ACTIONS(2860),
    [aux_sym_preproc_def_token1] = ACTIONS(2860),
    [aux_sym_preproc_if_token1] = ACTIONS(2860),
    [aux_sym_preproc_if_token2] = ACTIONS(2860),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2860),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2860),
    [aux_sym_preproc_else_token1] = ACTIONS(2860),
    [aux_sym_preproc_elif_token1] = ACTIONS(2860),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2860),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2860),
    [sym_preproc_directive] = ACTIONS(2860),
    [anon_sym_LPAREN2] = ACTIONS(2862),
    [anon_sym_BANG] = ACTIONS(2862),
    [anon_sym_TILDE] = ACTIONS(2862),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP_AMP] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2860),
    [anon_sym_SEMI] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2860),
    [anon_sym_typedef] = ACTIONS(2860),
    [anon_sym_extern] = ACTIONS(2860),
    [anon_sym___attribute__] = ACTIONS(2860),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2862),
    [anon_sym___declspec] = ACTIONS(2860),
    [anon_sym___based] = ACTIONS(2860),
    [anon_sym___cdecl] = ACTIONS(2860),
    [anon_sym___clrcall] = ACTIONS(2860),
    [anon_sym___stdcall] = ACTIONS(2860),
    [anon_sym___fastcall] = ACTIONS(2860),
    [anon_sym___thiscall] = ACTIONS(2860),
    [anon_sym___vectorcall] = ACTIONS(2860),
    [anon_sym_LBRACE] = ACTIONS(2862),
    [anon_sym_signed] = ACTIONS(2860),
    [anon_sym_unsigned] = ACTIONS(2860),
    [anon_sym_long] = ACTIONS(2860),
    [anon_sym_short] = ACTIONS(2860),
    [anon_sym_LBRACK] = ACTIONS(2860),
    [anon_sym_static] = ACTIONS(2860),
    [anon_sym_register] = ACTIONS(2860),
    [anon_sym_inline] = ACTIONS(2860),
    [anon_sym___inline] = ACTIONS(2860),
    [anon_sym___inline__] = ACTIONS(2860),
    [anon_sym___forceinline] = ACTIONS(2860),
    [anon_sym_thread_local] = ACTIONS(2860),
    [anon_sym___thread] = ACTIONS(2860),
    [anon_sym_const] = ACTIONS(2860),
    [anon_sym_constexpr] = ACTIONS(2860),
    [anon_sym_volatile] = ACTIONS(2860),
    [anon_sym_restrict] = ACTIONS(2860),
    [anon_sym___restrict__] = ACTIONS(2860),
    [anon_sym__Atomic] = ACTIONS(2860),
    [anon_sym__Noreturn] = ACTIONS(2860),
    [anon_sym_noreturn] = ACTIONS(2860),
    [anon_sym_mutable] = ACTIONS(2860),
    [anon_sym_constinit] = ACTIONS(2860),
    [anon_sym_consteval] = ACTIONS(2860),
    [anon_sym_PROGMEM] = ACTIONS(2860),
    [aux_sym_primitive_type_token1] = ACTIONS(2860),
    [anon_sym_byte] = ACTIONS(2860),
    [anon_sym_word] = ACTIONS(2860),
    [anon_sym_enum] = ACTIONS(2860),
    [anon_sym_class] = ACTIONS(2860),
    [anon_sym_struct] = ACTIONS(2860),
    [anon_sym_union] = ACTIONS(2860),
    [anon_sym_if] = ACTIONS(2860),
    [anon_sym_switch] = ACTIONS(2860),
    [anon_sym_case] = ACTIONS(2860),
    [anon_sym_default] = ACTIONS(2860),
    [anon_sym_while] = ACTIONS(2860),
    [anon_sym_do] = ACTIONS(2860),
    [anon_sym_for] = ACTIONS(2860),
    [anon_sym_return] = ACTIONS(2860),
    [anon_sym_break] = ACTIONS(2860),
    [anon_sym_continue] = ACTIONS(2860),
    [anon_sym_goto] = ACTIONS(2860),
    [anon_sym___try] = ACTIONS(2860),
    [anon_sym___leave] = ACTIONS(2860),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2862),
    [anon_sym_PLUS_PLUS] = ACTIONS(2862),
    [anon_sym_sizeof] = ACTIONS(2860),
    [anon_sym___alignof__] = ACTIONS(2860),
    [anon_sym___alignof] = ACTIONS(2860),
    [anon_sym__alignof] = ACTIONS(2860),
    [anon_sym_alignof] = ACTIONS(2860),
    [anon_sym__Alignof] = ACTIONS(2860),
    [anon_sym_offsetof] = ACTIONS(2860),
    [anon_sym__Generic] = ACTIONS(2860),
    [anon_sym_asm] = ACTIONS(2860),
    [anon_sym___asm__] = ACTIONS(2860),
    [aux_sym_number_literal_token1] = ACTIONS(2862),
    [aux_sym_number_literal_token2] = ACTIONS(2860),
    [anon_sym_L_SQUOTE] = ACTIONS(2862),
    [anon_sym_u_SQUOTE] = ACTIONS(2862),
    [anon_sym_U_SQUOTE] = ACTIONS(2862),
    [anon_sym_u8_SQUOTE] = ACTIONS(2862),
    [anon_sym_SQUOTE] = ACTIONS(2862),
    [anon_sym_L_DQUOTE] = ACTIONS(2862),
    [anon_sym_u_DQUOTE] = ACTIONS(2862),
    [anon_sym_U_DQUOTE] = ACTIONS(2862),
    [anon_sym_u8_DQUOTE] = ACTIONS(2862),
    [anon_sym_DQUOTE] = ACTIONS(2862),
    [sym_true] = ACTIONS(2860),
    [sym_false] = ACTIONS(2860),
    [anon_sym_NULL] = ACTIONS(2860),
    [anon_sym_nullptr] = ACTIONS(2860),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2860),
    [anon_sym_decltype] = ACTIONS(2860),
    [anon_sym_virtual] = ACTIONS(2860),
    [anon_sym_alignas] = ACTIONS(2860),
    [anon_sym_explicit] = ACTIONS(2860),
    [anon_sym_typename] = ACTIONS(2860),
    [anon_sym_template] = ACTIONS(2860),
    [anon_sym_operator] = ACTIONS(2860),
    [anon_sym_try] = ACTIONS(2860),
    [anon_sym_delete] = ACTIONS(2860),
    [anon_sym_throw] = ACTIONS(2860),
    [anon_sym_namespace] = ACTIONS(2860),
    [anon_sym_using] = ACTIONS(2860),
    [anon_sym_static_assert] = ACTIONS(2860),
    [anon_sym_concept] = ACTIONS(2860),
    [anon_sym_co_return] = ACTIONS(2860),
    [anon_sym_co_yield] = ACTIONS(2860),
    [anon_sym_catch] = ACTIONS(2854),
    [anon_sym_R_DQUOTE] = ACTIONS(2862),
    [anon_sym_LR_DQUOTE] = ACTIONS(2862),
    [anon_sym_uR_DQUOTE] = ACTIONS(2862),
    [anon_sym_UR_DQUOTE] = ACTIONS(2862),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2862),
    [anon_sym_co_await] = ACTIONS(2860),
    [anon_sym_new] = ACTIONS(2860),
    [anon_sym_requires] = ACTIONS(2860),
    [sym_this] = ACTIONS(2860),
  },
  [265] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5334),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9264),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(2864),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym___extension__] = ACTIONS(2869),
    [anon_sym_extern] = ACTIONS(2869),
    [anon_sym___attribute__] = ACTIONS(2869),
    [anon_sym_COLON_COLON] = ACTIONS(2871),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2874),
    [anon_sym___declspec] = ACTIONS(2869),
    [anon_sym_signed] = ACTIONS(2869),
    [anon_sym_unsigned] = ACTIONS(2869),
    [anon_sym_long] = ACTIONS(2869),
    [anon_sym_short] = ACTIONS(2869),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(2869),
    [anon_sym_register] = ACTIONS(2869),
    [anon_sym_inline] = ACTIONS(2869),
    [anon_sym___inline] = ACTIONS(2869),
    [anon_sym___inline__] = ACTIONS(2869),
    [anon_sym___forceinline] = ACTIONS(2869),
    [anon_sym_thread_local] = ACTIONS(2869),
    [anon_sym___thread] = ACTIONS(2869),
    [anon_sym_const] = ACTIONS(2869),
    [anon_sym_constexpr] = ACTIONS(2869),
    [anon_sym_volatile] = ACTIONS(2869),
    [anon_sym_restrict] = ACTIONS(2869),
    [anon_sym___restrict__] = ACTIONS(2869),
    [anon_sym__Atomic] = ACTIONS(2869),
    [anon_sym__Noreturn] = ACTIONS(2869),
    [anon_sym_noreturn] = ACTIONS(2869),
    [anon_sym_mutable] = ACTIONS(2869),
    [anon_sym_constinit] = ACTIONS(2869),
    [anon_sym_consteval] = ACTIONS(2869),
    [anon_sym_PROGMEM] = ACTIONS(2869),
    [aux_sym_primitive_type_token1] = ACTIONS(2876),
    [anon_sym_byte] = ACTIONS(2876),
    [anon_sym_word] = ACTIONS(2876),
    [anon_sym_enum] = ACTIONS(2869),
    [anon_sym_class] = ACTIONS(2869),
    [anon_sym_struct] = ACTIONS(2869),
    [anon_sym_union] = ACTIONS(2869),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2869),
    [anon_sym_decltype] = ACTIONS(2879),
    [anon_sym_virtual] = ACTIONS(2869),
    [anon_sym_alignas] = ACTIONS(2869),
    [anon_sym_typename] = ACTIONS(2869),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [266] = {
    [sym_catch_clause] = STATE(274),
    [aux_sym_constructor_try_statement_repeat1] = STATE(274),
    [sym_identifier] = ACTIONS(2850),
    [aux_sym_preproc_include_token1] = ACTIONS(2850),
    [aux_sym_preproc_def_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token2] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2850),
    [aux_sym_preproc_else_token1] = ACTIONS(2850),
    [aux_sym_preproc_elif_token1] = ACTIONS(2850),
    [sym_preproc_directive] = ACTIONS(2850),
    [anon_sym_LPAREN2] = ACTIONS(2852),
    [anon_sym_BANG] = ACTIONS(2852),
    [anon_sym_TILDE] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(2850),
    [anon_sym_PLUS] = ACTIONS(2850),
    [anon_sym_STAR] = ACTIONS(2852),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_AMP] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2852),
    [anon_sym___extension__] = ACTIONS(2850),
    [anon_sym_typedef] = ACTIONS(2850),
    [anon_sym_extern] = ACTIONS(2850),
    [anon_sym___attribute__] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2852),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2852),
    [anon_sym___declspec] = ACTIONS(2850),
    [anon_sym___based] = ACTIONS(2850),
    [anon_sym___cdecl] = ACTIONS(2850),
    [anon_sym___clrcall] = ACTIONS(2850),
    [anon_sym___stdcall] = ACTIONS(2850),
    [anon_sym___fastcall] = ACTIONS(2850),
    [anon_sym___thiscall] = ACTIONS(2850),
    [anon_sym___vectorcall] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2852),
    [anon_sym_signed] = ACTIONS(2850),
    [anon_sym_unsigned] = ACTIONS(2850),
    [anon_sym_long] = ACTIONS(2850),
    [anon_sym_short] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2850),
    [anon_sym_register] = ACTIONS(2850),
    [anon_sym_inline] = ACTIONS(2850),
    [anon_sym___inline] = ACTIONS(2850),
    [anon_sym___inline__] = ACTIONS(2850),
    [anon_sym___forceinline] = ACTIONS(2850),
    [anon_sym_thread_local] = ACTIONS(2850),
    [anon_sym___thread] = ACTIONS(2850),
    [anon_sym_const] = ACTIONS(2850),
    [anon_sym_constexpr] = ACTIONS(2850),
    [anon_sym_volatile] = ACTIONS(2850),
    [anon_sym_restrict] = ACTIONS(2850),
    [anon_sym___restrict__] = ACTIONS(2850),
    [anon_sym__Atomic] = ACTIONS(2850),
    [anon_sym__Noreturn] = ACTIONS(2850),
    [anon_sym_noreturn] = ACTIONS(2850),
    [anon_sym_mutable] = ACTIONS(2850),
    [anon_sym_constinit] = ACTIONS(2850),
    [anon_sym_consteval] = ACTIONS(2850),
    [anon_sym_PROGMEM] = ACTIONS(2850),
    [aux_sym_primitive_type_token1] = ACTIONS(2850),
    [anon_sym_byte] = ACTIONS(2850),
    [anon_sym_word] = ACTIONS(2850),
    [anon_sym_enum] = ACTIONS(2850),
    [anon_sym_class] = ACTIONS(2850),
    [anon_sym_struct] = ACTIONS(2850),
    [anon_sym_union] = ACTIONS(2850),
    [anon_sym_if] = ACTIONS(2850),
    [anon_sym_else] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2850),
    [anon_sym_case] = ACTIONS(2850),
    [anon_sym_default] = ACTIONS(2850),
    [anon_sym_while] = ACTIONS(2850),
    [anon_sym_do] = ACTIONS(2850),
    [anon_sym_for] = ACTIONS(2850),
    [anon_sym_return] = ACTIONS(2850),
    [anon_sym_break] = ACTIONS(2850),
    [anon_sym_continue] = ACTIONS(2850),
    [anon_sym_goto] = ACTIONS(2850),
    [anon_sym___try] = ACTIONS(2850),
    [anon_sym___leave] = ACTIONS(2850),
    [anon_sym_not] = ACTIONS(2850),
    [anon_sym_compl] = ACTIONS(2850),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_sizeof] = ACTIONS(2850),
    [anon_sym___alignof__] = ACTIONS(2850),
    [anon_sym___alignof] = ACTIONS(2850),
    [anon_sym__alignof] = ACTIONS(2850),
    [anon_sym_alignof] = ACTIONS(2850),
    [anon_sym__Alignof] = ACTIONS(2850),
    [anon_sym_offsetof] = ACTIONS(2850),
    [anon_sym__Generic] = ACTIONS(2850),
    [anon_sym_asm] = ACTIONS(2850),
    [anon_sym___asm__] = ACTIONS(2850),
    [aux_sym_number_literal_token1] = ACTIONS(2852),
    [aux_sym_number_literal_token2] = ACTIONS(2850),
    [anon_sym_L_SQUOTE] = ACTIONS(2852),
    [anon_sym_u_SQUOTE] = ACTIONS(2852),
    [anon_sym_U_SQUOTE] = ACTIONS(2852),
    [anon_sym_u8_SQUOTE] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2852),
    [anon_sym_L_DQUOTE] = ACTIONS(2852),
    [anon_sym_u_DQUOTE] = ACTIONS(2852),
    [anon_sym_U_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8_DQUOTE] = ACTIONS(2852),
    [anon_sym_DQUOTE] = ACTIONS(2852),
    [sym_true] = ACTIONS(2850),
    [sym_false] = ACTIONS(2850),
    [anon_sym_NULL] = ACTIONS(2850),
    [anon_sym_nullptr] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2850),
    [anon_sym_decltype] = ACTIONS(2850),
    [anon_sym_virtual] = ACTIONS(2850),
    [anon_sym_alignas] = ACTIONS(2850),
    [anon_sym_explicit] = ACTIONS(2850),
    [anon_sym_typename] = ACTIONS(2850),
    [anon_sym_template] = ACTIONS(2850),
    [anon_sym_operator] = ACTIONS(2850),
    [anon_sym_try] = ACTIONS(2850),
    [anon_sym_delete] = ACTIONS(2850),
    [anon_sym_throw] = ACTIONS(2850),
    [anon_sym_namespace] = ACTIONS(2850),
    [anon_sym_using] = ACTIONS(2850),
    [anon_sym_static_assert] = ACTIONS(2850),
    [anon_sym_concept] = ACTIONS(2850),
    [anon_sym_co_return] = ACTIONS(2850),
    [anon_sym_co_yield] = ACTIONS(2850),
    [anon_sym_catch] = ACTIONS(2885),
    [anon_sym_R_DQUOTE] = ACTIONS(2852),
    [anon_sym_LR_DQUOTE] = ACTIONS(2852),
    [anon_sym_uR_DQUOTE] = ACTIONS(2852),
    [anon_sym_UR_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2852),
    [anon_sym_co_await] = ACTIONS(2850),
    [anon_sym_new] = ACTIONS(2850),
    [anon_sym_requires] = ACTIONS(2850),
    [sym_this] = ACTIONS(2850),
  },
  [267] = {
    [sym_identifier] = ACTIONS(2223),
    [aux_sym_preproc_include_token1] = ACTIONS(2223),
    [aux_sym_preproc_def_token1] = ACTIONS(2223),
    [aux_sym_preproc_if_token1] = ACTIONS(2223),
    [aux_sym_preproc_if_token2] = ACTIONS(2223),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2223),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2223),
    [aux_sym_preproc_else_token1] = ACTIONS(2223),
    [aux_sym_preproc_elif_token1] = ACTIONS(2223),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2223),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2223),
    [sym_preproc_directive] = ACTIONS(2223),
    [anon_sym_LPAREN2] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2223),
    [anon_sym_PLUS] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(2221),
    [anon_sym_AMP_AMP] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym___extension__] = ACTIONS(2223),
    [anon_sym_typedef] = ACTIONS(2223),
    [anon_sym_extern] = ACTIONS(2223),
    [anon_sym___attribute__] = ACTIONS(2223),
    [anon_sym_COLON_COLON] = ACTIONS(2221),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym___declspec] = ACTIONS(2223),
    [anon_sym___based] = ACTIONS(2223),
    [anon_sym___cdecl] = ACTIONS(2223),
    [anon_sym___clrcall] = ACTIONS(2223),
    [anon_sym___stdcall] = ACTIONS(2223),
    [anon_sym___fastcall] = ACTIONS(2223),
    [anon_sym___thiscall] = ACTIONS(2223),
    [anon_sym___vectorcall] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_signed] = ACTIONS(2223),
    [anon_sym_unsigned] = ACTIONS(2223),
    [anon_sym_long] = ACTIONS(2223),
    [anon_sym_short] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(2223),
    [anon_sym_static] = ACTIONS(2223),
    [anon_sym_register] = ACTIONS(2223),
    [anon_sym_inline] = ACTIONS(2223),
    [anon_sym___inline] = ACTIONS(2223),
    [anon_sym___inline__] = ACTIONS(2223),
    [anon_sym___forceinline] = ACTIONS(2223),
    [anon_sym_thread_local] = ACTIONS(2223),
    [anon_sym___thread] = ACTIONS(2223),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_constexpr] = ACTIONS(2223),
    [anon_sym_volatile] = ACTIONS(2223),
    [anon_sym_restrict] = ACTIONS(2223),
    [anon_sym___restrict__] = ACTIONS(2223),
    [anon_sym__Atomic] = ACTIONS(2223),
    [anon_sym__Noreturn] = ACTIONS(2223),
    [anon_sym_noreturn] = ACTIONS(2223),
    [anon_sym_mutable] = ACTIONS(2223),
    [anon_sym_constinit] = ACTIONS(2223),
    [anon_sym_consteval] = ACTIONS(2223),
    [anon_sym_PROGMEM] = ACTIONS(2223),
    [aux_sym_primitive_type_token1] = ACTIONS(2223),
    [anon_sym_byte] = ACTIONS(2223),
    [anon_sym_word] = ACTIONS(2223),
    [anon_sym_enum] = ACTIONS(2223),
    [anon_sym_class] = ACTIONS(2223),
    [anon_sym_struct] = ACTIONS(2223),
    [anon_sym_union] = ACTIONS(2223),
    [anon_sym_if] = ACTIONS(2223),
    [anon_sym_else] = ACTIONS(2223),
    [anon_sym_switch] = ACTIONS(2223),
    [anon_sym_case] = ACTIONS(2223),
    [anon_sym_default] = ACTIONS(2223),
    [anon_sym_while] = ACTIONS(2223),
    [anon_sym_do] = ACTIONS(2223),
    [anon_sym_for] = ACTIONS(2223),
    [anon_sym_return] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2223),
    [anon_sym_continue] = ACTIONS(2223),
    [anon_sym_goto] = ACTIONS(2223),
    [anon_sym___try] = ACTIONS(2223),
    [anon_sym___leave] = ACTIONS(2223),
    [anon_sym_not] = ACTIONS(2223),
    [anon_sym_compl] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_sizeof] = ACTIONS(2223),
    [anon_sym___alignof__] = ACTIONS(2223),
    [anon_sym___alignof] = ACTIONS(2223),
    [anon_sym__alignof] = ACTIONS(2223),
    [anon_sym_alignof] = ACTIONS(2223),
    [anon_sym__Alignof] = ACTIONS(2223),
    [anon_sym_offsetof] = ACTIONS(2223),
    [anon_sym__Generic] = ACTIONS(2223),
    [anon_sym_asm] = ACTIONS(2223),
    [anon_sym___asm__] = ACTIONS(2223),
    [aux_sym_number_literal_token1] = ACTIONS(2221),
    [aux_sym_number_literal_token2] = ACTIONS(2223),
    [anon_sym_L_SQUOTE] = ACTIONS(2221),
    [anon_sym_u_SQUOTE] = ACTIONS(2221),
    [anon_sym_U_SQUOTE] = ACTIONS(2221),
    [anon_sym_u8_SQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_L_DQUOTE] = ACTIONS(2221),
    [anon_sym_u_DQUOTE] = ACTIONS(2221),
    [anon_sym_U_DQUOTE] = ACTIONS(2221),
    [anon_sym_u8_DQUOTE] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [sym_true] = ACTIONS(2223),
    [sym_false] = ACTIONS(2223),
    [anon_sym_NULL] = ACTIONS(2223),
    [anon_sym_nullptr] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2223),
    [anon_sym_decltype] = ACTIONS(2223),
    [anon_sym_virtual] = ACTIONS(2223),
    [anon_sym_alignas] = ACTIONS(2223),
    [anon_sym_explicit] = ACTIONS(2223),
    [anon_sym_typename] = ACTIONS(2223),
    [anon_sym_template] = ACTIONS(2223),
    [anon_sym_operator] = ACTIONS(2223),
    [anon_sym_try] = ACTIONS(2223),
    [anon_sym_delete] = ACTIONS(2223),
    [anon_sym_throw] = ACTIONS(2223),
    [anon_sym_namespace] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_static_assert] = ACTIONS(2223),
    [anon_sym_concept] = ACTIONS(2223),
    [anon_sym_co_return] = ACTIONS(2223),
    [anon_sym_co_yield] = ACTIONS(2223),
    [anon_sym_catch] = ACTIONS(2223),
    [anon_sym_R_DQUOTE] = ACTIONS(2221),
    [anon_sym_LR_DQUOTE] = ACTIONS(2221),
    [anon_sym_uR_DQUOTE] = ACTIONS(2221),
    [anon_sym_UR_DQUOTE] = ACTIONS(2221),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2221),
    [anon_sym_co_await] = ACTIONS(2223),
    [anon_sym_new] = ACTIONS(2223),
    [anon_sym_requires] = ACTIONS(2223),
    [sym_this] = ACTIONS(2223),
  },
  [268] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_include_token1] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token2] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [aux_sym_preproc_else_token1] = ACTIONS(2267),
    [aux_sym_preproc_elif_token1] = ACTIONS(2267),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_BANG] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(2265),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym___cdecl] = ACTIONS(2267),
    [anon_sym___clrcall] = ACTIONS(2267),
    [anon_sym___stdcall] = ACTIONS(2267),
    [anon_sym___fastcall] = ACTIONS(2267),
    [anon_sym___thiscall] = ACTIONS(2267),
    [anon_sym___vectorcall] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2265),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_else] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_case] = ACTIONS(2267),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_return] = ACTIONS(2267),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_continue] = ACTIONS(2267),
    [anon_sym_goto] = ACTIONS(2267),
    [anon_sym___try] = ACTIONS(2267),
    [anon_sym___leave] = ACTIONS(2267),
    [anon_sym_not] = ACTIONS(2267),
    [anon_sym_compl] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2265),
    [anon_sym_PLUS_PLUS] = ACTIONS(2265),
    [anon_sym_sizeof] = ACTIONS(2267),
    [anon_sym___alignof__] = ACTIONS(2267),
    [anon_sym___alignof] = ACTIONS(2267),
    [anon_sym__alignof] = ACTIONS(2267),
    [anon_sym_alignof] = ACTIONS(2267),
    [anon_sym__Alignof] = ACTIONS(2267),
    [anon_sym_offsetof] = ACTIONS(2267),
    [anon_sym__Generic] = ACTIONS(2267),
    [anon_sym_asm] = ACTIONS(2267),
    [anon_sym___asm__] = ACTIONS(2267),
    [aux_sym_number_literal_token1] = ACTIONS(2265),
    [aux_sym_number_literal_token2] = ACTIONS(2267),
    [anon_sym_L_SQUOTE] = ACTIONS(2265),
    [anon_sym_u_SQUOTE] = ACTIONS(2265),
    [anon_sym_U_SQUOTE] = ACTIONS(2265),
    [anon_sym_u8_SQUOTE] = ACTIONS(2265),
    [anon_sym_SQUOTE] = ACTIONS(2265),
    [anon_sym_L_DQUOTE] = ACTIONS(2265),
    [anon_sym_u_DQUOTE] = ACTIONS(2265),
    [anon_sym_U_DQUOTE] = ACTIONS(2265),
    [anon_sym_u8_DQUOTE] = ACTIONS(2265),
    [anon_sym_DQUOTE] = ACTIONS(2265),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [anon_sym_NULL] = ACTIONS(2267),
    [anon_sym_nullptr] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_try] = ACTIONS(2267),
    [anon_sym_delete] = ACTIONS(2267),
    [anon_sym_throw] = ACTIONS(2267),
    [anon_sym_namespace] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym_concept] = ACTIONS(2267),
    [anon_sym_co_return] = ACTIONS(2267),
    [anon_sym_co_yield] = ACTIONS(2267),
    [anon_sym_catch] = ACTIONS(2267),
    [anon_sym_R_DQUOTE] = ACTIONS(2265),
    [anon_sym_LR_DQUOTE] = ACTIONS(2265),
    [anon_sym_uR_DQUOTE] = ACTIONS(2265),
    [anon_sym_UR_DQUOTE] = ACTIONS(2265),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2265),
    [anon_sym_co_await] = ACTIONS(2267),
    [anon_sym_new] = ACTIONS(2267),
    [anon_sym_requires] = ACTIONS(2267),
    [sym_this] = ACTIONS(2267),
  },
  [269] = {
    [sym_identifier] = ACTIONS(2887),
    [aux_sym_preproc_include_token1] = ACTIONS(2887),
    [aux_sym_preproc_def_token1] = ACTIONS(2887),
    [aux_sym_preproc_if_token1] = ACTIONS(2887),
    [aux_sym_preproc_if_token2] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2887),
    [aux_sym_preproc_else_token1] = ACTIONS(2887),
    [aux_sym_preproc_elif_token1] = ACTIONS(2887),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2887),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2887),
    [sym_preproc_directive] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2889),
    [anon_sym_BANG] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2887),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_SEMI] = ACTIONS(2889),
    [anon_sym___extension__] = ACTIONS(2887),
    [anon_sym_typedef] = ACTIONS(2887),
    [anon_sym_extern] = ACTIONS(2887),
    [anon_sym___attribute__] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2889),
    [anon_sym___declspec] = ACTIONS(2887),
    [anon_sym___based] = ACTIONS(2887),
    [anon_sym___cdecl] = ACTIONS(2887),
    [anon_sym___clrcall] = ACTIONS(2887),
    [anon_sym___stdcall] = ACTIONS(2887),
    [anon_sym___fastcall] = ACTIONS(2887),
    [anon_sym___thiscall] = ACTIONS(2887),
    [anon_sym___vectorcall] = ACTIONS(2887),
    [anon_sym_LBRACE] = ACTIONS(2889),
    [anon_sym_signed] = ACTIONS(2887),
    [anon_sym_unsigned] = ACTIONS(2887),
    [anon_sym_long] = ACTIONS(2887),
    [anon_sym_short] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_static] = ACTIONS(2887),
    [anon_sym_register] = ACTIONS(2887),
    [anon_sym_inline] = ACTIONS(2887),
    [anon_sym___inline] = ACTIONS(2887),
    [anon_sym___inline__] = ACTIONS(2887),
    [anon_sym___forceinline] = ACTIONS(2887),
    [anon_sym_thread_local] = ACTIONS(2887),
    [anon_sym___thread] = ACTIONS(2887),
    [anon_sym_const] = ACTIONS(2887),
    [anon_sym_constexpr] = ACTIONS(2887),
    [anon_sym_volatile] = ACTIONS(2887),
    [anon_sym_restrict] = ACTIONS(2887),
    [anon_sym___restrict__] = ACTIONS(2887),
    [anon_sym__Atomic] = ACTIONS(2887),
    [anon_sym__Noreturn] = ACTIONS(2887),
    [anon_sym_noreturn] = ACTIONS(2887),
    [anon_sym_mutable] = ACTIONS(2887),
    [anon_sym_constinit] = ACTIONS(2887),
    [anon_sym_consteval] = ACTIONS(2887),
    [anon_sym_PROGMEM] = ACTIONS(2887),
    [aux_sym_primitive_type_token1] = ACTIONS(2887),
    [anon_sym_byte] = ACTIONS(2887),
    [anon_sym_word] = ACTIONS(2887),
    [anon_sym_enum] = ACTIONS(2887),
    [anon_sym_class] = ACTIONS(2887),
    [anon_sym_struct] = ACTIONS(2887),
    [anon_sym_union] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_else] = ACTIONS(2887),
    [anon_sym_switch] = ACTIONS(2887),
    [anon_sym_case] = ACTIONS(2887),
    [anon_sym_default] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2887),
    [anon_sym_for] = ACTIONS(2887),
    [anon_sym_return] = ACTIONS(2887),
    [anon_sym_break] = ACTIONS(2887),
    [anon_sym_continue] = ACTIONS(2887),
    [anon_sym_goto] = ACTIONS(2887),
    [anon_sym___try] = ACTIONS(2887),
    [anon_sym___leave] = ACTIONS(2887),
    [anon_sym_not] = ACTIONS(2887),
    [anon_sym_compl] = ACTIONS(2887),
    [anon_sym_DASH_DASH] = ACTIONS(2889),
    [anon_sym_PLUS_PLUS] = ACTIONS(2889),
    [anon_sym_sizeof] = ACTIONS(2887),
    [anon_sym___alignof__] = ACTIONS(2887),
    [anon_sym___alignof] = ACTIONS(2887),
    [anon_sym__alignof] = ACTIONS(2887),
    [anon_sym_alignof] = ACTIONS(2887),
    [anon_sym__Alignof] = ACTIONS(2887),
    [anon_sym_offsetof] = ACTIONS(2887),
    [anon_sym__Generic] = ACTIONS(2887),
    [anon_sym_asm] = ACTIONS(2887),
    [anon_sym___asm__] = ACTIONS(2887),
    [aux_sym_number_literal_token1] = ACTIONS(2889),
    [aux_sym_number_literal_token2] = ACTIONS(2887),
    [anon_sym_L_SQUOTE] = ACTIONS(2889),
    [anon_sym_u_SQUOTE] = ACTIONS(2889),
    [anon_sym_U_SQUOTE] = ACTIONS(2889),
    [anon_sym_u8_SQUOTE] = ACTIONS(2889),
    [anon_sym_SQUOTE] = ACTIONS(2889),
    [anon_sym_L_DQUOTE] = ACTIONS(2889),
    [anon_sym_u_DQUOTE] = ACTIONS(2889),
    [anon_sym_U_DQUOTE] = ACTIONS(2889),
    [anon_sym_u8_DQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE] = ACTIONS(2889),
    [sym_true] = ACTIONS(2887),
    [sym_false] = ACTIONS(2887),
    [anon_sym_NULL] = ACTIONS(2887),
    [anon_sym_nullptr] = ACTIONS(2887),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2887),
    [anon_sym_decltype] = ACTIONS(2887),
    [anon_sym_virtual] = ACTIONS(2887),
    [anon_sym_alignas] = ACTIONS(2887),
    [anon_sym_explicit] = ACTIONS(2887),
    [anon_sym_typename] = ACTIONS(2887),
    [anon_sym_template] = ACTIONS(2887),
    [anon_sym_operator] = ACTIONS(2887),
    [anon_sym_try] = ACTIONS(2887),
    [anon_sym_delete] = ACTIONS(2887),
    [anon_sym_throw] = ACTIONS(2887),
    [anon_sym_namespace] = ACTIONS(2887),
    [anon_sym_using] = ACTIONS(2887),
    [anon_sym_static_assert] = ACTIONS(2887),
    [anon_sym_concept] = ACTIONS(2887),
    [anon_sym_co_return] = ACTIONS(2887),
    [anon_sym_co_yield] = ACTIONS(2887),
    [anon_sym_catch] = ACTIONS(2887),
    [anon_sym_R_DQUOTE] = ACTIONS(2889),
    [anon_sym_LR_DQUOTE] = ACTIONS(2889),
    [anon_sym_uR_DQUOTE] = ACTIONS(2889),
    [anon_sym_UR_DQUOTE] = ACTIONS(2889),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2889),
    [anon_sym_co_await] = ACTIONS(2887),
    [anon_sym_new] = ACTIONS(2887),
    [anon_sym_requires] = ACTIONS(2887),
    [sym_this] = ACTIONS(2887),
  },
  [270] = {
    [sym_else_clause] = STATE(279),
    [sym_identifier] = ACTIONS(2891),
    [aux_sym_preproc_include_token1] = ACTIONS(2891),
    [aux_sym_preproc_def_token1] = ACTIONS(2891),
    [aux_sym_preproc_if_token1] = ACTIONS(2891),
    [aux_sym_preproc_if_token2] = ACTIONS(2891),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2891),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2891),
    [aux_sym_preproc_else_token1] = ACTIONS(2891),
    [aux_sym_preproc_elif_token1] = ACTIONS(2891),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2891),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2891),
    [sym_preproc_directive] = ACTIONS(2891),
    [anon_sym_LPAREN2] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_AMP_AMP] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym___extension__] = ACTIONS(2891),
    [anon_sym_typedef] = ACTIONS(2891),
    [anon_sym_extern] = ACTIONS(2891),
    [anon_sym___attribute__] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2893),
    [anon_sym___declspec] = ACTIONS(2891),
    [anon_sym___based] = ACTIONS(2891),
    [anon_sym___cdecl] = ACTIONS(2891),
    [anon_sym___clrcall] = ACTIONS(2891),
    [anon_sym___stdcall] = ACTIONS(2891),
    [anon_sym___fastcall] = ACTIONS(2891),
    [anon_sym___thiscall] = ACTIONS(2891),
    [anon_sym___vectorcall] = ACTIONS(2891),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_signed] = ACTIONS(2891),
    [anon_sym_unsigned] = ACTIONS(2891),
    [anon_sym_long] = ACTIONS(2891),
    [anon_sym_short] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_static] = ACTIONS(2891),
    [anon_sym_register] = ACTIONS(2891),
    [anon_sym_inline] = ACTIONS(2891),
    [anon_sym___inline] = ACTIONS(2891),
    [anon_sym___inline__] = ACTIONS(2891),
    [anon_sym___forceinline] = ACTIONS(2891),
    [anon_sym_thread_local] = ACTIONS(2891),
    [anon_sym___thread] = ACTIONS(2891),
    [anon_sym_const] = ACTIONS(2891),
    [anon_sym_constexpr] = ACTIONS(2891),
    [anon_sym_volatile] = ACTIONS(2891),
    [anon_sym_restrict] = ACTIONS(2891),
    [anon_sym___restrict__] = ACTIONS(2891),
    [anon_sym__Atomic] = ACTIONS(2891),
    [anon_sym__Noreturn] = ACTIONS(2891),
    [anon_sym_noreturn] = ACTIONS(2891),
    [anon_sym_mutable] = ACTIONS(2891),
    [anon_sym_constinit] = ACTIONS(2891),
    [anon_sym_consteval] = ACTIONS(2891),
    [anon_sym_PROGMEM] = ACTIONS(2891),
    [aux_sym_primitive_type_token1] = ACTIONS(2891),
    [anon_sym_byte] = ACTIONS(2891),
    [anon_sym_word] = ACTIONS(2891),
    [anon_sym_enum] = ACTIONS(2891),
    [anon_sym_class] = ACTIONS(2891),
    [anon_sym_struct] = ACTIONS(2891),
    [anon_sym_union] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_else] = ACTIONS(2895),
    [anon_sym_switch] = ACTIONS(2891),
    [anon_sym_case] = ACTIONS(2891),
    [anon_sym_default] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2891),
    [anon_sym_for] = ACTIONS(2891),
    [anon_sym_return] = ACTIONS(2891),
    [anon_sym_break] = ACTIONS(2891),
    [anon_sym_continue] = ACTIONS(2891),
    [anon_sym_goto] = ACTIONS(2891),
    [anon_sym___try] = ACTIONS(2891),
    [anon_sym___leave] = ACTIONS(2891),
    [anon_sym_not] = ACTIONS(2891),
    [anon_sym_compl] = ACTIONS(2891),
    [anon_sym_DASH_DASH] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2893),
    [anon_sym_sizeof] = ACTIONS(2891),
    [anon_sym___alignof__] = ACTIONS(2891),
    [anon_sym___alignof] = ACTIONS(2891),
    [anon_sym__alignof] = ACTIONS(2891),
    [anon_sym_alignof] = ACTIONS(2891),
    [anon_sym__Alignof] = ACTIONS(2891),
    [anon_sym_offsetof] = ACTIONS(2891),
    [anon_sym__Generic] = ACTIONS(2891),
    [anon_sym_asm] = ACTIONS(2891),
    [anon_sym___asm__] = ACTIONS(2891),
    [aux_sym_number_literal_token1] = ACTIONS(2893),
    [aux_sym_number_literal_token2] = ACTIONS(2891),
    [anon_sym_L_SQUOTE] = ACTIONS(2893),
    [anon_sym_u_SQUOTE] = ACTIONS(2893),
    [anon_sym_U_SQUOTE] = ACTIONS(2893),
    [anon_sym_u8_SQUOTE] = ACTIONS(2893),
    [anon_sym_SQUOTE] = ACTIONS(2893),
    [anon_sym_L_DQUOTE] = ACTIONS(2893),
    [anon_sym_u_DQUOTE] = ACTIONS(2893),
    [anon_sym_U_DQUOTE] = ACTIONS(2893),
    [anon_sym_u8_DQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(2893),
    [sym_true] = ACTIONS(2891),
    [sym_false] = ACTIONS(2891),
    [anon_sym_NULL] = ACTIONS(2891),
    [anon_sym_nullptr] = ACTIONS(2891),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2891),
    [anon_sym_decltype] = ACTIONS(2891),
    [anon_sym_virtual] = ACTIONS(2891),
    [anon_sym_alignas] = ACTIONS(2891),
    [anon_sym_explicit] = ACTIONS(2891),
    [anon_sym_typename] = ACTIONS(2891),
    [anon_sym_template] = ACTIONS(2891),
    [anon_sym_operator] = ACTIONS(2891),
    [anon_sym_try] = ACTIONS(2891),
    [anon_sym_delete] = ACTIONS(2891),
    [anon_sym_throw] = ACTIONS(2891),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_using] = ACTIONS(2891),
    [anon_sym_static_assert] = ACTIONS(2891),
    [anon_sym_concept] = ACTIONS(2891),
    [anon_sym_co_return] = ACTIONS(2891),
    [anon_sym_co_yield] = ACTIONS(2891),
    [anon_sym_R_DQUOTE] = ACTIONS(2893),
    [anon_sym_LR_DQUOTE] = ACTIONS(2893),
    [anon_sym_uR_DQUOTE] = ACTIONS(2893),
    [anon_sym_UR_DQUOTE] = ACTIONS(2893),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2893),
    [anon_sym_co_await] = ACTIONS(2891),
    [anon_sym_new] = ACTIONS(2891),
    [anon_sym_requires] = ACTIONS(2891),
    [sym_this] = ACTIONS(2891),
  },
  [271] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5345),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9166),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(2897),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(2900),
    [anon_sym___extension__] = ACTIONS(2902),
    [anon_sym_extern] = ACTIONS(2902),
    [anon_sym___attribute__] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(2904),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2907),
    [anon_sym___declspec] = ACTIONS(2902),
    [anon_sym_signed] = ACTIONS(2902),
    [anon_sym_unsigned] = ACTIONS(2902),
    [anon_sym_long] = ACTIONS(2902),
    [anon_sym_short] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(2902),
    [anon_sym_register] = ACTIONS(2902),
    [anon_sym_inline] = ACTIONS(2902),
    [anon_sym___inline] = ACTIONS(2902),
    [anon_sym___inline__] = ACTIONS(2902),
    [anon_sym___forceinline] = ACTIONS(2902),
    [anon_sym_thread_local] = ACTIONS(2902),
    [anon_sym___thread] = ACTIONS(2902),
    [anon_sym_const] = ACTIONS(2902),
    [anon_sym_constexpr] = ACTIONS(2902),
    [anon_sym_volatile] = ACTIONS(2902),
    [anon_sym_restrict] = ACTIONS(2902),
    [anon_sym___restrict__] = ACTIONS(2902),
    [anon_sym__Atomic] = ACTIONS(2902),
    [anon_sym__Noreturn] = ACTIONS(2902),
    [anon_sym_noreturn] = ACTIONS(2902),
    [anon_sym_mutable] = ACTIONS(2902),
    [anon_sym_constinit] = ACTIONS(2902),
    [anon_sym_consteval] = ACTIONS(2902),
    [anon_sym_PROGMEM] = ACTIONS(2902),
    [aux_sym_primitive_type_token1] = ACTIONS(2909),
    [anon_sym_byte] = ACTIONS(2909),
    [anon_sym_word] = ACTIONS(2909),
    [anon_sym_enum] = ACTIONS(2902),
    [anon_sym_class] = ACTIONS(2902),
    [anon_sym_struct] = ACTIONS(2902),
    [anon_sym_union] = ACTIONS(2902),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2912),
    [anon_sym_virtual] = ACTIONS(2902),
    [anon_sym_alignas] = ACTIONS(2902),
    [anon_sym_typename] = ACTIONS(2902),
    [anon_sym_template] = ACTIONS(2915),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [272] = {
    [sym_else_clause] = STATE(277),
    [sym_identifier] = ACTIONS(2918),
    [aux_sym_preproc_include_token1] = ACTIONS(2918),
    [aux_sym_preproc_def_token1] = ACTIONS(2918),
    [aux_sym_preproc_if_token1] = ACTIONS(2918),
    [aux_sym_preproc_if_token2] = ACTIONS(2918),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2918),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2918),
    [aux_sym_preproc_else_token1] = ACTIONS(2918),
    [aux_sym_preproc_elif_token1] = ACTIONS(2918),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2918),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2918),
    [sym_preproc_directive] = ACTIONS(2918),
    [anon_sym_LPAREN2] = ACTIONS(2920),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2920),
    [anon_sym_DASH] = ACTIONS(2918),
    [anon_sym_PLUS] = ACTIONS(2918),
    [anon_sym_STAR] = ACTIONS(2920),
    [anon_sym_AMP_AMP] = ACTIONS(2920),
    [anon_sym_AMP] = ACTIONS(2918),
    [anon_sym_SEMI] = ACTIONS(2920),
    [anon_sym___extension__] = ACTIONS(2918),
    [anon_sym_typedef] = ACTIONS(2918),
    [anon_sym_extern] = ACTIONS(2918),
    [anon_sym___attribute__] = ACTIONS(2918),
    [anon_sym_COLON_COLON] = ACTIONS(2920),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2920),
    [anon_sym___declspec] = ACTIONS(2918),
    [anon_sym___based] = ACTIONS(2918),
    [anon_sym___cdecl] = ACTIONS(2918),
    [anon_sym___clrcall] = ACTIONS(2918),
    [anon_sym___stdcall] = ACTIONS(2918),
    [anon_sym___fastcall] = ACTIONS(2918),
    [anon_sym___thiscall] = ACTIONS(2918),
    [anon_sym___vectorcall] = ACTIONS(2918),
    [anon_sym_LBRACE] = ACTIONS(2920),
    [anon_sym_signed] = ACTIONS(2918),
    [anon_sym_unsigned] = ACTIONS(2918),
    [anon_sym_long] = ACTIONS(2918),
    [anon_sym_short] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(2918),
    [anon_sym_static] = ACTIONS(2918),
    [anon_sym_register] = ACTIONS(2918),
    [anon_sym_inline] = ACTIONS(2918),
    [anon_sym___inline] = ACTIONS(2918),
    [anon_sym___inline__] = ACTIONS(2918),
    [anon_sym___forceinline] = ACTIONS(2918),
    [anon_sym_thread_local] = ACTIONS(2918),
    [anon_sym___thread] = ACTIONS(2918),
    [anon_sym_const] = ACTIONS(2918),
    [anon_sym_constexpr] = ACTIONS(2918),
    [anon_sym_volatile] = ACTIONS(2918),
    [anon_sym_restrict] = ACTIONS(2918),
    [anon_sym___restrict__] = ACTIONS(2918),
    [anon_sym__Atomic] = ACTIONS(2918),
    [anon_sym__Noreturn] = ACTIONS(2918),
    [anon_sym_noreturn] = ACTIONS(2918),
    [anon_sym_mutable] = ACTIONS(2918),
    [anon_sym_constinit] = ACTIONS(2918),
    [anon_sym_consteval] = ACTIONS(2918),
    [anon_sym_PROGMEM] = ACTIONS(2918),
    [aux_sym_primitive_type_token1] = ACTIONS(2918),
    [anon_sym_byte] = ACTIONS(2918),
    [anon_sym_word] = ACTIONS(2918),
    [anon_sym_enum] = ACTIONS(2918),
    [anon_sym_class] = ACTIONS(2918),
    [anon_sym_struct] = ACTIONS(2918),
    [anon_sym_union] = ACTIONS(2918),
    [anon_sym_if] = ACTIONS(2918),
    [anon_sym_else] = ACTIONS(2895),
    [anon_sym_switch] = ACTIONS(2918),
    [anon_sym_case] = ACTIONS(2918),
    [anon_sym_default] = ACTIONS(2918),
    [anon_sym_while] = ACTIONS(2918),
    [anon_sym_do] = ACTIONS(2918),
    [anon_sym_for] = ACTIONS(2918),
    [anon_sym_return] = ACTIONS(2918),
    [anon_sym_break] = ACTIONS(2918),
    [anon_sym_continue] = ACTIONS(2918),
    [anon_sym_goto] = ACTIONS(2918),
    [anon_sym___try] = ACTIONS(2918),
    [anon_sym___leave] = ACTIONS(2918),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_compl] = ACTIONS(2918),
    [anon_sym_DASH_DASH] = ACTIONS(2920),
    [anon_sym_PLUS_PLUS] = ACTIONS(2920),
    [anon_sym_sizeof] = ACTIONS(2918),
    [anon_sym___alignof__] = ACTIONS(2918),
    [anon_sym___alignof] = ACTIONS(2918),
    [anon_sym__alignof] = ACTIONS(2918),
    [anon_sym_alignof] = ACTIONS(2918),
    [anon_sym__Alignof] = ACTIONS(2918),
    [anon_sym_offsetof] = ACTIONS(2918),
    [anon_sym__Generic] = ACTIONS(2918),
    [anon_sym_asm] = ACTIONS(2918),
    [anon_sym___asm__] = ACTIONS(2918),
    [aux_sym_number_literal_token1] = ACTIONS(2920),
    [aux_sym_number_literal_token2] = ACTIONS(2918),
    [anon_sym_L_SQUOTE] = ACTIONS(2920),
    [anon_sym_u_SQUOTE] = ACTIONS(2920),
    [anon_sym_U_SQUOTE] = ACTIONS(2920),
    [anon_sym_u8_SQUOTE] = ACTIONS(2920),
    [anon_sym_SQUOTE] = ACTIONS(2920),
    [anon_sym_L_DQUOTE] = ACTIONS(2920),
    [anon_sym_u_DQUOTE] = ACTIONS(2920),
    [anon_sym_U_DQUOTE] = ACTIONS(2920),
    [anon_sym_u8_DQUOTE] = ACTIONS(2920),
    [anon_sym_DQUOTE] = ACTIONS(2920),
    [sym_true] = ACTIONS(2918),
    [sym_false] = ACTIONS(2918),
    [anon_sym_NULL] = ACTIONS(2918),
    [anon_sym_nullptr] = ACTIONS(2918),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2918),
    [anon_sym_decltype] = ACTIONS(2918),
    [anon_sym_virtual] = ACTIONS(2918),
    [anon_sym_alignas] = ACTIONS(2918),
    [anon_sym_explicit] = ACTIONS(2918),
    [anon_sym_typename] = ACTIONS(2918),
    [anon_sym_template] = ACTIONS(2918),
    [anon_sym_operator] = ACTIONS(2918),
    [anon_sym_try] = ACTIONS(2918),
    [anon_sym_delete] = ACTIONS(2918),
    [anon_sym_throw] = ACTIONS(2918),
    [anon_sym_namespace] = ACTIONS(2918),
    [anon_sym_using] = ACTIONS(2918),
    [anon_sym_static_assert] = ACTIONS(2918),
    [anon_sym_concept] = ACTIONS(2918),
    [anon_sym_co_return] = ACTIONS(2918),
    [anon_sym_co_yield] = ACTIONS(2918),
    [anon_sym_R_DQUOTE] = ACTIONS(2920),
    [anon_sym_LR_DQUOTE] = ACTIONS(2920),
    [anon_sym_uR_DQUOTE] = ACTIONS(2920),
    [anon_sym_UR_DQUOTE] = ACTIONS(2920),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2920),
    [anon_sym_co_await] = ACTIONS(2918),
    [anon_sym_new] = ACTIONS(2918),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2918),
  },
  [273] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5339),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9168),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(2922),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(2925),
    [anon_sym___extension__] = ACTIONS(2927),
    [anon_sym_extern] = ACTIONS(2927),
    [anon_sym___attribute__] = ACTIONS(2927),
    [anon_sym_COLON_COLON] = ACTIONS(2929),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2932),
    [anon_sym___declspec] = ACTIONS(2927),
    [anon_sym_signed] = ACTIONS(2927),
    [anon_sym_unsigned] = ACTIONS(2927),
    [anon_sym_long] = ACTIONS(2927),
    [anon_sym_short] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(2927),
    [anon_sym_register] = ACTIONS(2927),
    [anon_sym_inline] = ACTIONS(2927),
    [anon_sym___inline] = ACTIONS(2927),
    [anon_sym___inline__] = ACTIONS(2927),
    [anon_sym___forceinline] = ACTIONS(2927),
    [anon_sym_thread_local] = ACTIONS(2927),
    [anon_sym___thread] = ACTIONS(2927),
    [anon_sym_const] = ACTIONS(2927),
    [anon_sym_constexpr] = ACTIONS(2927),
    [anon_sym_volatile] = ACTIONS(2927),
    [anon_sym_restrict] = ACTIONS(2927),
    [anon_sym___restrict__] = ACTIONS(2927),
    [anon_sym__Atomic] = ACTIONS(2927),
    [anon_sym__Noreturn] = ACTIONS(2927),
    [anon_sym_noreturn] = ACTIONS(2927),
    [anon_sym_mutable] = ACTIONS(2927),
    [anon_sym_constinit] = ACTIONS(2927),
    [anon_sym_consteval] = ACTIONS(2927),
    [anon_sym_PROGMEM] = ACTIONS(2927),
    [aux_sym_primitive_type_token1] = ACTIONS(2934),
    [anon_sym_byte] = ACTIONS(2934),
    [anon_sym_word] = ACTIONS(2934),
    [anon_sym_enum] = ACTIONS(2927),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_struct] = ACTIONS(2927),
    [anon_sym_union] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2927),
    [anon_sym_decltype] = ACTIONS(2937),
    [anon_sym_virtual] = ACTIONS(2927),
    [anon_sym_alignas] = ACTIONS(2927),
    [anon_sym_typename] = ACTIONS(2927),
    [anon_sym_template] = ACTIONS(2940),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [274] = {
    [sym_catch_clause] = STATE(274),
    [aux_sym_constructor_try_statement_repeat1] = STATE(274),
    [sym_identifier] = ACTIONS(2843),
    [aux_sym_preproc_include_token1] = ACTIONS(2843),
    [aux_sym_preproc_def_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token2] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2843),
    [aux_sym_preproc_else_token1] = ACTIONS(2843),
    [aux_sym_preproc_elif_token1] = ACTIONS(2843),
    [sym_preproc_directive] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2845),
    [anon_sym_BANG] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym___extension__] = ACTIONS(2843),
    [anon_sym_typedef] = ACTIONS(2843),
    [anon_sym_extern] = ACTIONS(2843),
    [anon_sym___attribute__] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2845),
    [anon_sym___declspec] = ACTIONS(2843),
    [anon_sym___based] = ACTIONS(2843),
    [anon_sym___cdecl] = ACTIONS(2843),
    [anon_sym___clrcall] = ACTIONS(2843),
    [anon_sym___stdcall] = ACTIONS(2843),
    [anon_sym___fastcall] = ACTIONS(2843),
    [anon_sym___thiscall] = ACTIONS(2843),
    [anon_sym___vectorcall] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(2845),
    [anon_sym_signed] = ACTIONS(2843),
    [anon_sym_unsigned] = ACTIONS(2843),
    [anon_sym_long] = ACTIONS(2843),
    [anon_sym_short] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_register] = ACTIONS(2843),
    [anon_sym_inline] = ACTIONS(2843),
    [anon_sym___inline] = ACTIONS(2843),
    [anon_sym___inline__] = ACTIONS(2843),
    [anon_sym___forceinline] = ACTIONS(2843),
    [anon_sym_thread_local] = ACTIONS(2843),
    [anon_sym___thread] = ACTIONS(2843),
    [anon_sym_const] = ACTIONS(2843),
    [anon_sym_constexpr] = ACTIONS(2843),
    [anon_sym_volatile] = ACTIONS(2843),
    [anon_sym_restrict] = ACTIONS(2843),
    [anon_sym___restrict__] = ACTIONS(2843),
    [anon_sym__Atomic] = ACTIONS(2843),
    [anon_sym__Noreturn] = ACTIONS(2843),
    [anon_sym_noreturn] = ACTIONS(2843),
    [anon_sym_mutable] = ACTIONS(2843),
    [anon_sym_constinit] = ACTIONS(2843),
    [anon_sym_consteval] = ACTIONS(2843),
    [anon_sym_PROGMEM] = ACTIONS(2843),
    [aux_sym_primitive_type_token1] = ACTIONS(2843),
    [anon_sym_byte] = ACTIONS(2843),
    [anon_sym_word] = ACTIONS(2843),
    [anon_sym_enum] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2843),
    [anon_sym_union] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_else] = ACTIONS(2843),
    [anon_sym_switch] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2843),
    [anon_sym_default] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_break] = ACTIONS(2843),
    [anon_sym_continue] = ACTIONS(2843),
    [anon_sym_goto] = ACTIONS(2843),
    [anon_sym___try] = ACTIONS(2843),
    [anon_sym___leave] = ACTIONS(2843),
    [anon_sym_not] = ACTIONS(2843),
    [anon_sym_compl] = ACTIONS(2843),
    [anon_sym_DASH_DASH] = ACTIONS(2845),
    [anon_sym_PLUS_PLUS] = ACTIONS(2845),
    [anon_sym_sizeof] = ACTIONS(2843),
    [anon_sym___alignof__] = ACTIONS(2843),
    [anon_sym___alignof] = ACTIONS(2843),
    [anon_sym__alignof] = ACTIONS(2843),
    [anon_sym_alignof] = ACTIONS(2843),
    [anon_sym__Alignof] = ACTIONS(2843),
    [anon_sym_offsetof] = ACTIONS(2843),
    [anon_sym__Generic] = ACTIONS(2843),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [aux_sym_number_literal_token1] = ACTIONS(2845),
    [aux_sym_number_literal_token2] = ACTIONS(2843),
    [anon_sym_L_SQUOTE] = ACTIONS(2845),
    [anon_sym_u_SQUOTE] = ACTIONS(2845),
    [anon_sym_U_SQUOTE] = ACTIONS(2845),
    [anon_sym_u8_SQUOTE] = ACTIONS(2845),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_L_DQUOTE] = ACTIONS(2845),
    [anon_sym_u_DQUOTE] = ACTIONS(2845),
    [anon_sym_U_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(2845),
    [sym_true] = ACTIONS(2843),
    [sym_false] = ACTIONS(2843),
    [anon_sym_NULL] = ACTIONS(2843),
    [anon_sym_nullptr] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2843),
    [anon_sym_decltype] = ACTIONS(2843),
    [anon_sym_virtual] = ACTIONS(2843),
    [anon_sym_alignas] = ACTIONS(2843),
    [anon_sym_explicit] = ACTIONS(2843),
    [anon_sym_typename] = ACTIONS(2843),
    [anon_sym_template] = ACTIONS(2843),
    [anon_sym_operator] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_delete] = ACTIONS(2843),
    [anon_sym_throw] = ACTIONS(2843),
    [anon_sym_namespace] = ACTIONS(2843),
    [anon_sym_using] = ACTIONS(2843),
    [anon_sym_static_assert] = ACTIONS(2843),
    [anon_sym_concept] = ACTIONS(2843),
    [anon_sym_co_return] = ACTIONS(2843),
    [anon_sym_co_yield] = ACTIONS(2843),
    [anon_sym_catch] = ACTIONS(2943),
    [anon_sym_R_DQUOTE] = ACTIONS(2845),
    [anon_sym_LR_DQUOTE] = ACTIONS(2845),
    [anon_sym_uR_DQUOTE] = ACTIONS(2845),
    [anon_sym_UR_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2845),
    [anon_sym_co_await] = ACTIONS(2843),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_requires] = ACTIONS(2843),
    [sym_this] = ACTIONS(2843),
  },
  [275] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [276] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [277] = {
    [sym_identifier] = ACTIONS(2950),
    [aux_sym_preproc_include_token1] = ACTIONS(2950),
    [aux_sym_preproc_def_token1] = ACTIONS(2950),
    [aux_sym_preproc_if_token1] = ACTIONS(2950),
    [aux_sym_preproc_if_token2] = ACTIONS(2950),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2950),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2950),
    [aux_sym_preproc_else_token1] = ACTIONS(2950),
    [aux_sym_preproc_elif_token1] = ACTIONS(2950),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2950),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2950),
    [sym_preproc_directive] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2952),
    [anon_sym_BANG] = ACTIONS(2952),
    [anon_sym_TILDE] = ACTIONS(2952),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_STAR] = ACTIONS(2952),
    [anon_sym_AMP_AMP] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_SEMI] = ACTIONS(2952),
    [anon_sym___extension__] = ACTIONS(2950),
    [anon_sym_typedef] = ACTIONS(2950),
    [anon_sym_extern] = ACTIONS(2950),
    [anon_sym___attribute__] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2952),
    [anon_sym___declspec] = ACTIONS(2950),
    [anon_sym___based] = ACTIONS(2950),
    [anon_sym___cdecl] = ACTIONS(2950),
    [anon_sym___clrcall] = ACTIONS(2950),
    [anon_sym___stdcall] = ACTIONS(2950),
    [anon_sym___fastcall] = ACTIONS(2950),
    [anon_sym___thiscall] = ACTIONS(2950),
    [anon_sym___vectorcall] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2952),
    [anon_sym_signed] = ACTIONS(2950),
    [anon_sym_unsigned] = ACTIONS(2950),
    [anon_sym_long] = ACTIONS(2950),
    [anon_sym_short] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_static] = ACTIONS(2950),
    [anon_sym_register] = ACTIONS(2950),
    [anon_sym_inline] = ACTIONS(2950),
    [anon_sym___inline] = ACTIONS(2950),
    [anon_sym___inline__] = ACTIONS(2950),
    [anon_sym___forceinline] = ACTIONS(2950),
    [anon_sym_thread_local] = ACTIONS(2950),
    [anon_sym___thread] = ACTIONS(2950),
    [anon_sym_const] = ACTIONS(2950),
    [anon_sym_constexpr] = ACTIONS(2950),
    [anon_sym_volatile] = ACTIONS(2950),
    [anon_sym_restrict] = ACTIONS(2950),
    [anon_sym___restrict__] = ACTIONS(2950),
    [anon_sym__Atomic] = ACTIONS(2950),
    [anon_sym__Noreturn] = ACTIONS(2950),
    [anon_sym_noreturn] = ACTIONS(2950),
    [anon_sym_mutable] = ACTIONS(2950),
    [anon_sym_constinit] = ACTIONS(2950),
    [anon_sym_consteval] = ACTIONS(2950),
    [anon_sym_PROGMEM] = ACTIONS(2950),
    [aux_sym_primitive_type_token1] = ACTIONS(2950),
    [anon_sym_byte] = ACTIONS(2950),
    [anon_sym_word] = ACTIONS(2950),
    [anon_sym_enum] = ACTIONS(2950),
    [anon_sym_class] = ACTIONS(2950),
    [anon_sym_struct] = ACTIONS(2950),
    [anon_sym_union] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_else] = ACTIONS(2950),
    [anon_sym_switch] = ACTIONS(2950),
    [anon_sym_case] = ACTIONS(2950),
    [anon_sym_default] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_break] = ACTIONS(2950),
    [anon_sym_continue] = ACTIONS(2950),
    [anon_sym_goto] = ACTIONS(2950),
    [anon_sym___try] = ACTIONS(2950),
    [anon_sym___leave] = ACTIONS(2950),
    [anon_sym_not] = ACTIONS(2950),
    [anon_sym_compl] = ACTIONS(2950),
    [anon_sym_DASH_DASH] = ACTIONS(2952),
    [anon_sym_PLUS_PLUS] = ACTIONS(2952),
    [anon_sym_sizeof] = ACTIONS(2950),
    [anon_sym___alignof__] = ACTIONS(2950),
    [anon_sym___alignof] = ACTIONS(2950),
    [anon_sym__alignof] = ACTIONS(2950),
    [anon_sym_alignof] = ACTIONS(2950),
    [anon_sym__Alignof] = ACTIONS(2950),
    [anon_sym_offsetof] = ACTIONS(2950),
    [anon_sym__Generic] = ACTIONS(2950),
    [anon_sym_asm] = ACTIONS(2950),
    [anon_sym___asm__] = ACTIONS(2950),
    [aux_sym_number_literal_token1] = ACTIONS(2952),
    [aux_sym_number_literal_token2] = ACTIONS(2950),
    [anon_sym_L_SQUOTE] = ACTIONS(2952),
    [anon_sym_u_SQUOTE] = ACTIONS(2952),
    [anon_sym_U_SQUOTE] = ACTIONS(2952),
    [anon_sym_u8_SQUOTE] = ACTIONS(2952),
    [anon_sym_SQUOTE] = ACTIONS(2952),
    [anon_sym_L_DQUOTE] = ACTIONS(2952),
    [anon_sym_u_DQUOTE] = ACTIONS(2952),
    [anon_sym_U_DQUOTE] = ACTIONS(2952),
    [anon_sym_u8_DQUOTE] = ACTIONS(2952),
    [anon_sym_DQUOTE] = ACTIONS(2952),
    [sym_true] = ACTIONS(2950),
    [sym_false] = ACTIONS(2950),
    [anon_sym_NULL] = ACTIONS(2950),
    [anon_sym_nullptr] = ACTIONS(2950),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2950),
    [anon_sym_decltype] = ACTIONS(2950),
    [anon_sym_virtual] = ACTIONS(2950),
    [anon_sym_alignas] = ACTIONS(2950),
    [anon_sym_explicit] = ACTIONS(2950),
    [anon_sym_typename] = ACTIONS(2950),
    [anon_sym_template] = ACTIONS(2950),
    [anon_sym_operator] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_delete] = ACTIONS(2950),
    [anon_sym_throw] = ACTIONS(2950),
    [anon_sym_namespace] = ACTIONS(2950),
    [anon_sym_using] = ACTIONS(2950),
    [anon_sym_static_assert] = ACTIONS(2950),
    [anon_sym_concept] = ACTIONS(2950),
    [anon_sym_co_return] = ACTIONS(2950),
    [anon_sym_co_yield] = ACTIONS(2950),
    [anon_sym_R_DQUOTE] = ACTIONS(2952),
    [anon_sym_LR_DQUOTE] = ACTIONS(2952),
    [anon_sym_uR_DQUOTE] = ACTIONS(2952),
    [anon_sym_UR_DQUOTE] = ACTIONS(2952),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2952),
    [anon_sym_co_await] = ACTIONS(2950),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_requires] = ACTIONS(2950),
    [sym_this] = ACTIONS(2950),
  },
  [278] = {
    [sym_identifier] = ACTIONS(2954),
    [aux_sym_preproc_include_token1] = ACTIONS(2954),
    [aux_sym_preproc_def_token1] = ACTIONS(2954),
    [aux_sym_preproc_if_token1] = ACTIONS(2954),
    [aux_sym_preproc_if_token2] = ACTIONS(2954),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2954),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2954),
    [aux_sym_preproc_else_token1] = ACTIONS(2954),
    [aux_sym_preproc_elif_token1] = ACTIONS(2954),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2954),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2954),
    [sym_preproc_directive] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2956),
    [anon_sym_BANG] = ACTIONS(2956),
    [anon_sym_TILDE] = ACTIONS(2956),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_STAR] = ACTIONS(2956),
    [anon_sym_AMP_AMP] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2954),
    [anon_sym_SEMI] = ACTIONS(2956),
    [anon_sym___extension__] = ACTIONS(2954),
    [anon_sym_typedef] = ACTIONS(2954),
    [anon_sym_extern] = ACTIONS(2954),
    [anon_sym___attribute__] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2956),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2956),
    [anon_sym___declspec] = ACTIONS(2954),
    [anon_sym___based] = ACTIONS(2954),
    [anon_sym___cdecl] = ACTIONS(2954),
    [anon_sym___clrcall] = ACTIONS(2954),
    [anon_sym___stdcall] = ACTIONS(2954),
    [anon_sym___fastcall] = ACTIONS(2954),
    [anon_sym___thiscall] = ACTIONS(2954),
    [anon_sym___vectorcall] = ACTIONS(2954),
    [anon_sym_LBRACE] = ACTIONS(2956),
    [anon_sym_signed] = ACTIONS(2954),
    [anon_sym_unsigned] = ACTIONS(2954),
    [anon_sym_long] = ACTIONS(2954),
    [anon_sym_short] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_static] = ACTIONS(2954),
    [anon_sym_register] = ACTIONS(2954),
    [anon_sym_inline] = ACTIONS(2954),
    [anon_sym___inline] = ACTIONS(2954),
    [anon_sym___inline__] = ACTIONS(2954),
    [anon_sym___forceinline] = ACTIONS(2954),
    [anon_sym_thread_local] = ACTIONS(2954),
    [anon_sym___thread] = ACTIONS(2954),
    [anon_sym_const] = ACTIONS(2954),
    [anon_sym_constexpr] = ACTIONS(2954),
    [anon_sym_volatile] = ACTIONS(2954),
    [anon_sym_restrict] = ACTIONS(2954),
    [anon_sym___restrict__] = ACTIONS(2954),
    [anon_sym__Atomic] = ACTIONS(2954),
    [anon_sym__Noreturn] = ACTIONS(2954),
    [anon_sym_noreturn] = ACTIONS(2954),
    [anon_sym_mutable] = ACTIONS(2954),
    [anon_sym_constinit] = ACTIONS(2954),
    [anon_sym_consteval] = ACTIONS(2954),
    [anon_sym_PROGMEM] = ACTIONS(2954),
    [aux_sym_primitive_type_token1] = ACTIONS(2954),
    [anon_sym_byte] = ACTIONS(2954),
    [anon_sym_word] = ACTIONS(2954),
    [anon_sym_enum] = ACTIONS(2954),
    [anon_sym_class] = ACTIONS(2954),
    [anon_sym_struct] = ACTIONS(2954),
    [anon_sym_union] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_else] = ACTIONS(2954),
    [anon_sym_switch] = ACTIONS(2954),
    [anon_sym_case] = ACTIONS(2954),
    [anon_sym_default] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_break] = ACTIONS(2954),
    [anon_sym_continue] = ACTIONS(2954),
    [anon_sym_goto] = ACTIONS(2954),
    [anon_sym___try] = ACTIONS(2954),
    [anon_sym___leave] = ACTIONS(2954),
    [anon_sym_not] = ACTIONS(2954),
    [anon_sym_compl] = ACTIONS(2954),
    [anon_sym_DASH_DASH] = ACTIONS(2956),
    [anon_sym_PLUS_PLUS] = ACTIONS(2956),
    [anon_sym_sizeof] = ACTIONS(2954),
    [anon_sym___alignof__] = ACTIONS(2954),
    [anon_sym___alignof] = ACTIONS(2954),
    [anon_sym__alignof] = ACTIONS(2954),
    [anon_sym_alignof] = ACTIONS(2954),
    [anon_sym__Alignof] = ACTIONS(2954),
    [anon_sym_offsetof] = ACTIONS(2954),
    [anon_sym__Generic] = ACTIONS(2954),
    [anon_sym_asm] = ACTIONS(2954),
    [anon_sym___asm__] = ACTIONS(2954),
    [aux_sym_number_literal_token1] = ACTIONS(2956),
    [aux_sym_number_literal_token2] = ACTIONS(2954),
    [anon_sym_L_SQUOTE] = ACTIONS(2956),
    [anon_sym_u_SQUOTE] = ACTIONS(2956),
    [anon_sym_U_SQUOTE] = ACTIONS(2956),
    [anon_sym_u8_SQUOTE] = ACTIONS(2956),
    [anon_sym_SQUOTE] = ACTIONS(2956),
    [anon_sym_L_DQUOTE] = ACTIONS(2956),
    [anon_sym_u_DQUOTE] = ACTIONS(2956),
    [anon_sym_U_DQUOTE] = ACTIONS(2956),
    [anon_sym_u8_DQUOTE] = ACTIONS(2956),
    [anon_sym_DQUOTE] = ACTIONS(2956),
    [sym_true] = ACTIONS(2954),
    [sym_false] = ACTIONS(2954),
    [anon_sym_NULL] = ACTIONS(2954),
    [anon_sym_nullptr] = ACTIONS(2954),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2954),
    [anon_sym_decltype] = ACTIONS(2954),
    [anon_sym_virtual] = ACTIONS(2954),
    [anon_sym_alignas] = ACTIONS(2954),
    [anon_sym_explicit] = ACTIONS(2954),
    [anon_sym_typename] = ACTIONS(2954),
    [anon_sym_template] = ACTIONS(2954),
    [anon_sym_operator] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_delete] = ACTIONS(2954),
    [anon_sym_throw] = ACTIONS(2954),
    [anon_sym_namespace] = ACTIONS(2954),
    [anon_sym_using] = ACTIONS(2954),
    [anon_sym_static_assert] = ACTIONS(2954),
    [anon_sym_concept] = ACTIONS(2954),
    [anon_sym_co_return] = ACTIONS(2954),
    [anon_sym_co_yield] = ACTIONS(2954),
    [anon_sym_R_DQUOTE] = ACTIONS(2956),
    [anon_sym_LR_DQUOTE] = ACTIONS(2956),
    [anon_sym_uR_DQUOTE] = ACTIONS(2956),
    [anon_sym_UR_DQUOTE] = ACTIONS(2956),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2956),
    [anon_sym_co_await] = ACTIONS(2954),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_requires] = ACTIONS(2954),
    [sym_this] = ACTIONS(2954),
  },
  [279] = {
    [sym_identifier] = ACTIONS(2958),
    [aux_sym_preproc_include_token1] = ACTIONS(2958),
    [aux_sym_preproc_def_token1] = ACTIONS(2958),
    [aux_sym_preproc_if_token1] = ACTIONS(2958),
    [aux_sym_preproc_if_token2] = ACTIONS(2958),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2958),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2958),
    [aux_sym_preproc_else_token1] = ACTIONS(2958),
    [aux_sym_preproc_elif_token1] = ACTIONS(2958),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2958),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2958),
    [sym_preproc_directive] = ACTIONS(2958),
    [anon_sym_LPAREN2] = ACTIONS(2960),
    [anon_sym_BANG] = ACTIONS(2960),
    [anon_sym_TILDE] = ACTIONS(2960),
    [anon_sym_DASH] = ACTIONS(2958),
    [anon_sym_PLUS] = ACTIONS(2958),
    [anon_sym_STAR] = ACTIONS(2960),
    [anon_sym_AMP_AMP] = ACTIONS(2960),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_SEMI] = ACTIONS(2960),
    [anon_sym___extension__] = ACTIONS(2958),
    [anon_sym_typedef] = ACTIONS(2958),
    [anon_sym_extern] = ACTIONS(2958),
    [anon_sym___attribute__] = ACTIONS(2958),
    [anon_sym_COLON_COLON] = ACTIONS(2960),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2960),
    [anon_sym___declspec] = ACTIONS(2958),
    [anon_sym___based] = ACTIONS(2958),
    [anon_sym___cdecl] = ACTIONS(2958),
    [anon_sym___clrcall] = ACTIONS(2958),
    [anon_sym___stdcall] = ACTIONS(2958),
    [anon_sym___fastcall] = ACTIONS(2958),
    [anon_sym___thiscall] = ACTIONS(2958),
    [anon_sym___vectorcall] = ACTIONS(2958),
    [anon_sym_LBRACE] = ACTIONS(2960),
    [anon_sym_signed] = ACTIONS(2958),
    [anon_sym_unsigned] = ACTIONS(2958),
    [anon_sym_long] = ACTIONS(2958),
    [anon_sym_short] = ACTIONS(2958),
    [anon_sym_LBRACK] = ACTIONS(2958),
    [anon_sym_static] = ACTIONS(2958),
    [anon_sym_register] = ACTIONS(2958),
    [anon_sym_inline] = ACTIONS(2958),
    [anon_sym___inline] = ACTIONS(2958),
    [anon_sym___inline__] = ACTIONS(2958),
    [anon_sym___forceinline] = ACTIONS(2958),
    [anon_sym_thread_local] = ACTIONS(2958),
    [anon_sym___thread] = ACTIONS(2958),
    [anon_sym_const] = ACTIONS(2958),
    [anon_sym_constexpr] = ACTIONS(2958),
    [anon_sym_volatile] = ACTIONS(2958),
    [anon_sym_restrict] = ACTIONS(2958),
    [anon_sym___restrict__] = ACTIONS(2958),
    [anon_sym__Atomic] = ACTIONS(2958),
    [anon_sym__Noreturn] = ACTIONS(2958),
    [anon_sym_noreturn] = ACTIONS(2958),
    [anon_sym_mutable] = ACTIONS(2958),
    [anon_sym_constinit] = ACTIONS(2958),
    [anon_sym_consteval] = ACTIONS(2958),
    [anon_sym_PROGMEM] = ACTIONS(2958),
    [aux_sym_primitive_type_token1] = ACTIONS(2958),
    [anon_sym_byte] = ACTIONS(2958),
    [anon_sym_word] = ACTIONS(2958),
    [anon_sym_enum] = ACTIONS(2958),
    [anon_sym_class] = ACTIONS(2958),
    [anon_sym_struct] = ACTIONS(2958),
    [anon_sym_union] = ACTIONS(2958),
    [anon_sym_if] = ACTIONS(2958),
    [anon_sym_else] = ACTIONS(2958),
    [anon_sym_switch] = ACTIONS(2958),
    [anon_sym_case] = ACTIONS(2958),
    [anon_sym_default] = ACTIONS(2958),
    [anon_sym_while] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2958),
    [anon_sym_for] = ACTIONS(2958),
    [anon_sym_return] = ACTIONS(2958),
    [anon_sym_break] = ACTIONS(2958),
    [anon_sym_continue] = ACTIONS(2958),
    [anon_sym_goto] = ACTIONS(2958),
    [anon_sym___try] = ACTIONS(2958),
    [anon_sym___leave] = ACTIONS(2958),
    [anon_sym_not] = ACTIONS(2958),
    [anon_sym_compl] = ACTIONS(2958),
    [anon_sym_DASH_DASH] = ACTIONS(2960),
    [anon_sym_PLUS_PLUS] = ACTIONS(2960),
    [anon_sym_sizeof] = ACTIONS(2958),
    [anon_sym___alignof__] = ACTIONS(2958),
    [anon_sym___alignof] = ACTIONS(2958),
    [anon_sym__alignof] = ACTIONS(2958),
    [anon_sym_alignof] = ACTIONS(2958),
    [anon_sym__Alignof] = ACTIONS(2958),
    [anon_sym_offsetof] = ACTIONS(2958),
    [anon_sym__Generic] = ACTIONS(2958),
    [anon_sym_asm] = ACTIONS(2958),
    [anon_sym___asm__] = ACTIONS(2958),
    [aux_sym_number_literal_token1] = ACTIONS(2960),
    [aux_sym_number_literal_token2] = ACTIONS(2958),
    [anon_sym_L_SQUOTE] = ACTIONS(2960),
    [anon_sym_u_SQUOTE] = ACTIONS(2960),
    [anon_sym_U_SQUOTE] = ACTIONS(2960),
    [anon_sym_u8_SQUOTE] = ACTIONS(2960),
    [anon_sym_SQUOTE] = ACTIONS(2960),
    [anon_sym_L_DQUOTE] = ACTIONS(2960),
    [anon_sym_u_DQUOTE] = ACTIONS(2960),
    [anon_sym_U_DQUOTE] = ACTIONS(2960),
    [anon_sym_u8_DQUOTE] = ACTIONS(2960),
    [anon_sym_DQUOTE] = ACTIONS(2960),
    [sym_true] = ACTIONS(2958),
    [sym_false] = ACTIONS(2958),
    [anon_sym_NULL] = ACTIONS(2958),
    [anon_sym_nullptr] = ACTIONS(2958),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2958),
    [anon_sym_decltype] = ACTIONS(2958),
    [anon_sym_virtual] = ACTIONS(2958),
    [anon_sym_alignas] = ACTIONS(2958),
    [anon_sym_explicit] = ACTIONS(2958),
    [anon_sym_typename] = ACTIONS(2958),
    [anon_sym_template] = ACTIONS(2958),
    [anon_sym_operator] = ACTIONS(2958),
    [anon_sym_try] = ACTIONS(2958),
    [anon_sym_delete] = ACTIONS(2958),
    [anon_sym_throw] = ACTIONS(2958),
    [anon_sym_namespace] = ACTIONS(2958),
    [anon_sym_using] = ACTIONS(2958),
    [anon_sym_static_assert] = ACTIONS(2958),
    [anon_sym_concept] = ACTIONS(2958),
    [anon_sym_co_return] = ACTIONS(2958),
    [anon_sym_co_yield] = ACTIONS(2958),
    [anon_sym_R_DQUOTE] = ACTIONS(2960),
    [anon_sym_LR_DQUOTE] = ACTIONS(2960),
    [anon_sym_uR_DQUOTE] = ACTIONS(2960),
    [anon_sym_UR_DQUOTE] = ACTIONS(2960),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2960),
    [anon_sym_co_await] = ACTIONS(2958),
    [anon_sym_new] = ACTIONS(2958),
    [anon_sym_requires] = ACTIONS(2958),
    [sym_this] = ACTIONS(2958),
  },
  [280] = {
    [sym_identifier] = ACTIONS(2962),
    [aux_sym_preproc_include_token1] = ACTIONS(2962),
    [aux_sym_preproc_def_token1] = ACTIONS(2962),
    [aux_sym_preproc_if_token1] = ACTIONS(2962),
    [aux_sym_preproc_if_token2] = ACTIONS(2962),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2962),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2962),
    [aux_sym_preproc_else_token1] = ACTIONS(2962),
    [aux_sym_preproc_elif_token1] = ACTIONS(2962),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2962),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2962),
    [sym_preproc_directive] = ACTIONS(2962),
    [anon_sym_LPAREN2] = ACTIONS(2964),
    [anon_sym_BANG] = ACTIONS(2964),
    [anon_sym_TILDE] = ACTIONS(2964),
    [anon_sym_DASH] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_STAR] = ACTIONS(2964),
    [anon_sym_AMP_AMP] = ACTIONS(2964),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_SEMI] = ACTIONS(2964),
    [anon_sym___extension__] = ACTIONS(2962),
    [anon_sym_typedef] = ACTIONS(2962),
    [anon_sym_extern] = ACTIONS(2962),
    [anon_sym___attribute__] = ACTIONS(2962),
    [anon_sym_COLON_COLON] = ACTIONS(2964),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2964),
    [anon_sym___declspec] = ACTIONS(2962),
    [anon_sym___based] = ACTIONS(2962),
    [anon_sym___cdecl] = ACTIONS(2962),
    [anon_sym___clrcall] = ACTIONS(2962),
    [anon_sym___stdcall] = ACTIONS(2962),
    [anon_sym___fastcall] = ACTIONS(2962),
    [anon_sym___thiscall] = ACTIONS(2962),
    [anon_sym___vectorcall] = ACTIONS(2962),
    [anon_sym_LBRACE] = ACTIONS(2964),
    [anon_sym_signed] = ACTIONS(2962),
    [anon_sym_unsigned] = ACTIONS(2962),
    [anon_sym_long] = ACTIONS(2962),
    [anon_sym_short] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_static] = ACTIONS(2962),
    [anon_sym_register] = ACTIONS(2962),
    [anon_sym_inline] = ACTIONS(2962),
    [anon_sym___inline] = ACTIONS(2962),
    [anon_sym___inline__] = ACTIONS(2962),
    [anon_sym___forceinline] = ACTIONS(2962),
    [anon_sym_thread_local] = ACTIONS(2962),
    [anon_sym___thread] = ACTIONS(2962),
    [anon_sym_const] = ACTIONS(2962),
    [anon_sym_constexpr] = ACTIONS(2962),
    [anon_sym_volatile] = ACTIONS(2962),
    [anon_sym_restrict] = ACTIONS(2962),
    [anon_sym___restrict__] = ACTIONS(2962),
    [anon_sym__Atomic] = ACTIONS(2962),
    [anon_sym__Noreturn] = ACTIONS(2962),
    [anon_sym_noreturn] = ACTIONS(2962),
    [anon_sym_mutable] = ACTIONS(2962),
    [anon_sym_constinit] = ACTIONS(2962),
    [anon_sym_consteval] = ACTIONS(2962),
    [anon_sym_PROGMEM] = ACTIONS(2962),
    [aux_sym_primitive_type_token1] = ACTIONS(2962),
    [anon_sym_byte] = ACTIONS(2962),
    [anon_sym_word] = ACTIONS(2962),
    [anon_sym_enum] = ACTIONS(2962),
    [anon_sym_class] = ACTIONS(2962),
    [anon_sym_struct] = ACTIONS(2962),
    [anon_sym_union] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_else] = ACTIONS(2962),
    [anon_sym_switch] = ACTIONS(2962),
    [anon_sym_case] = ACTIONS(2962),
    [anon_sym_default] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_for] = ACTIONS(2962),
    [anon_sym_return] = ACTIONS(2962),
    [anon_sym_break] = ACTIONS(2962),
    [anon_sym_continue] = ACTIONS(2962),
    [anon_sym_goto] = ACTIONS(2962),
    [anon_sym___try] = ACTIONS(2962),
    [anon_sym___leave] = ACTIONS(2962),
    [anon_sym_not] = ACTIONS(2962),
    [anon_sym_compl] = ACTIONS(2962),
    [anon_sym_DASH_DASH] = ACTIONS(2964),
    [anon_sym_PLUS_PLUS] = ACTIONS(2964),
    [anon_sym_sizeof] = ACTIONS(2962),
    [anon_sym___alignof__] = ACTIONS(2962),
    [anon_sym___alignof] = ACTIONS(2962),
    [anon_sym__alignof] = ACTIONS(2962),
    [anon_sym_alignof] = ACTIONS(2962),
    [anon_sym__Alignof] = ACTIONS(2962),
    [anon_sym_offsetof] = ACTIONS(2962),
    [anon_sym__Generic] = ACTIONS(2962),
    [anon_sym_asm] = ACTIONS(2962),
    [anon_sym___asm__] = ACTIONS(2962),
    [aux_sym_number_literal_token1] = ACTIONS(2964),
    [aux_sym_number_literal_token2] = ACTIONS(2962),
    [anon_sym_L_SQUOTE] = ACTIONS(2964),
    [anon_sym_u_SQUOTE] = ACTIONS(2964),
    [anon_sym_U_SQUOTE] = ACTIONS(2964),
    [anon_sym_u8_SQUOTE] = ACTIONS(2964),
    [anon_sym_SQUOTE] = ACTIONS(2964),
    [anon_sym_L_DQUOTE] = ACTIONS(2964),
    [anon_sym_u_DQUOTE] = ACTIONS(2964),
    [anon_sym_U_DQUOTE] = ACTIONS(2964),
    [anon_sym_u8_DQUOTE] = ACTIONS(2964),
    [anon_sym_DQUOTE] = ACTIONS(2964),
    [sym_true] = ACTIONS(2962),
    [sym_false] = ACTIONS(2962),
    [anon_sym_NULL] = ACTIONS(2962),
    [anon_sym_nullptr] = ACTIONS(2962),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2962),
    [anon_sym_decltype] = ACTIONS(2962),
    [anon_sym_virtual] = ACTIONS(2962),
    [anon_sym_alignas] = ACTIONS(2962),
    [anon_sym_explicit] = ACTIONS(2962),
    [anon_sym_typename] = ACTIONS(2962),
    [anon_sym_template] = ACTIONS(2962),
    [anon_sym_operator] = ACTIONS(2962),
    [anon_sym_try] = ACTIONS(2962),
    [anon_sym_delete] = ACTIONS(2962),
    [anon_sym_throw] = ACTIONS(2962),
    [anon_sym_namespace] = ACTIONS(2962),
    [anon_sym_using] = ACTIONS(2962),
    [anon_sym_static_assert] = ACTIONS(2962),
    [anon_sym_concept] = ACTIONS(2962),
    [anon_sym_co_return] = ACTIONS(2962),
    [anon_sym_co_yield] = ACTIONS(2962),
    [anon_sym_R_DQUOTE] = ACTIONS(2964),
    [anon_sym_LR_DQUOTE] = ACTIONS(2964),
    [anon_sym_uR_DQUOTE] = ACTIONS(2964),
    [anon_sym_UR_DQUOTE] = ACTIONS(2964),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2964),
    [anon_sym_co_await] = ACTIONS(2962),
    [anon_sym_new] = ACTIONS(2962),
    [anon_sym_requires] = ACTIONS(2962),
    [sym_this] = ACTIONS(2962),
  },
  [281] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [282] = {
    [sym_identifier] = ACTIONS(2966),
    [aux_sym_preproc_include_token1] = ACTIONS(2966),
    [aux_sym_preproc_def_token1] = ACTIONS(2966),
    [aux_sym_preproc_if_token1] = ACTIONS(2966),
    [aux_sym_preproc_if_token2] = ACTIONS(2966),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2966),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2966),
    [aux_sym_preproc_else_token1] = ACTIONS(2966),
    [aux_sym_preproc_elif_token1] = ACTIONS(2966),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2966),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2966),
    [sym_preproc_directive] = ACTIONS(2966),
    [anon_sym_LPAREN2] = ACTIONS(2968),
    [anon_sym_BANG] = ACTIONS(2968),
    [anon_sym_TILDE] = ACTIONS(2968),
    [anon_sym_DASH] = ACTIONS(2966),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_STAR] = ACTIONS(2968),
    [anon_sym_AMP_AMP] = ACTIONS(2968),
    [anon_sym_AMP] = ACTIONS(2966),
    [anon_sym_SEMI] = ACTIONS(2968),
    [anon_sym___extension__] = ACTIONS(2966),
    [anon_sym_typedef] = ACTIONS(2966),
    [anon_sym_extern] = ACTIONS(2966),
    [anon_sym___attribute__] = ACTIONS(2966),
    [anon_sym_COLON_COLON] = ACTIONS(2968),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2968),
    [anon_sym___declspec] = ACTIONS(2966),
    [anon_sym___based] = ACTIONS(2966),
    [anon_sym___cdecl] = ACTIONS(2966),
    [anon_sym___clrcall] = ACTIONS(2966),
    [anon_sym___stdcall] = ACTIONS(2966),
    [anon_sym___fastcall] = ACTIONS(2966),
    [anon_sym___thiscall] = ACTIONS(2966),
    [anon_sym___vectorcall] = ACTIONS(2966),
    [anon_sym_LBRACE] = ACTIONS(2968),
    [anon_sym_signed] = ACTIONS(2966),
    [anon_sym_unsigned] = ACTIONS(2966),
    [anon_sym_long] = ACTIONS(2966),
    [anon_sym_short] = ACTIONS(2966),
    [anon_sym_LBRACK] = ACTIONS(2966),
    [anon_sym_static] = ACTIONS(2966),
    [anon_sym_register] = ACTIONS(2966),
    [anon_sym_inline] = ACTIONS(2966),
    [anon_sym___inline] = ACTIONS(2966),
    [anon_sym___inline__] = ACTIONS(2966),
    [anon_sym___forceinline] = ACTIONS(2966),
    [anon_sym_thread_local] = ACTIONS(2966),
    [anon_sym___thread] = ACTIONS(2966),
    [anon_sym_const] = ACTIONS(2966),
    [anon_sym_constexpr] = ACTIONS(2966),
    [anon_sym_volatile] = ACTIONS(2966),
    [anon_sym_restrict] = ACTIONS(2966),
    [anon_sym___restrict__] = ACTIONS(2966),
    [anon_sym__Atomic] = ACTIONS(2966),
    [anon_sym__Noreturn] = ACTIONS(2966),
    [anon_sym_noreturn] = ACTIONS(2966),
    [anon_sym_mutable] = ACTIONS(2966),
    [anon_sym_constinit] = ACTIONS(2966),
    [anon_sym_consteval] = ACTIONS(2966),
    [anon_sym_PROGMEM] = ACTIONS(2966),
    [aux_sym_primitive_type_token1] = ACTIONS(2966),
    [anon_sym_byte] = ACTIONS(2966),
    [anon_sym_word] = ACTIONS(2966),
    [anon_sym_enum] = ACTIONS(2966),
    [anon_sym_class] = ACTIONS(2966),
    [anon_sym_struct] = ACTIONS(2966),
    [anon_sym_union] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_else] = ACTIONS(2966),
    [anon_sym_switch] = ACTIONS(2966),
    [anon_sym_case] = ACTIONS(2966),
    [anon_sym_default] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_for] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2966),
    [anon_sym_break] = ACTIONS(2966),
    [anon_sym_continue] = ACTIONS(2966),
    [anon_sym_goto] = ACTIONS(2966),
    [anon_sym___try] = ACTIONS(2966),
    [anon_sym___leave] = ACTIONS(2966),
    [anon_sym_not] = ACTIONS(2966),
    [anon_sym_compl] = ACTIONS(2966),
    [anon_sym_DASH_DASH] = ACTIONS(2968),
    [anon_sym_PLUS_PLUS] = ACTIONS(2968),
    [anon_sym_sizeof] = ACTIONS(2966),
    [anon_sym___alignof__] = ACTIONS(2966),
    [anon_sym___alignof] = ACTIONS(2966),
    [anon_sym__alignof] = ACTIONS(2966),
    [anon_sym_alignof] = ACTIONS(2966),
    [anon_sym__Alignof] = ACTIONS(2966),
    [anon_sym_offsetof] = ACTIONS(2966),
    [anon_sym__Generic] = ACTIONS(2966),
    [anon_sym_asm] = ACTIONS(2966),
    [anon_sym___asm__] = ACTIONS(2966),
    [aux_sym_number_literal_token1] = ACTIONS(2968),
    [aux_sym_number_literal_token2] = ACTIONS(2966),
    [anon_sym_L_SQUOTE] = ACTIONS(2968),
    [anon_sym_u_SQUOTE] = ACTIONS(2968),
    [anon_sym_U_SQUOTE] = ACTIONS(2968),
    [anon_sym_u8_SQUOTE] = ACTIONS(2968),
    [anon_sym_SQUOTE] = ACTIONS(2968),
    [anon_sym_L_DQUOTE] = ACTIONS(2968),
    [anon_sym_u_DQUOTE] = ACTIONS(2968),
    [anon_sym_U_DQUOTE] = ACTIONS(2968),
    [anon_sym_u8_DQUOTE] = ACTIONS(2968),
    [anon_sym_DQUOTE] = ACTIONS(2968),
    [sym_true] = ACTIONS(2966),
    [sym_false] = ACTIONS(2966),
    [anon_sym_NULL] = ACTIONS(2966),
    [anon_sym_nullptr] = ACTIONS(2966),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2966),
    [anon_sym_decltype] = ACTIONS(2966),
    [anon_sym_virtual] = ACTIONS(2966),
    [anon_sym_alignas] = ACTIONS(2966),
    [anon_sym_explicit] = ACTIONS(2966),
    [anon_sym_typename] = ACTIONS(2966),
    [anon_sym_template] = ACTIONS(2966),
    [anon_sym_operator] = ACTIONS(2966),
    [anon_sym_try] = ACTIONS(2966),
    [anon_sym_delete] = ACTIONS(2966),
    [anon_sym_throw] = ACTIONS(2966),
    [anon_sym_namespace] = ACTIONS(2966),
    [anon_sym_using] = ACTIONS(2966),
    [anon_sym_static_assert] = ACTIONS(2966),
    [anon_sym_concept] = ACTIONS(2966),
    [anon_sym_co_return] = ACTIONS(2966),
    [anon_sym_co_yield] = ACTIONS(2966),
    [anon_sym_R_DQUOTE] = ACTIONS(2968),
    [anon_sym_LR_DQUOTE] = ACTIONS(2968),
    [anon_sym_uR_DQUOTE] = ACTIONS(2968),
    [anon_sym_UR_DQUOTE] = ACTIONS(2968),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2968),
    [anon_sym_co_await] = ACTIONS(2966),
    [anon_sym_new] = ACTIONS(2966),
    [anon_sym_requires] = ACTIONS(2966),
    [sym_this] = ACTIONS(2966),
  },
  [283] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [284] = {
    [sym_identifier] = ACTIONS(2970),
    [aux_sym_preproc_include_token1] = ACTIONS(2970),
    [aux_sym_preproc_def_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token2] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2970),
    [aux_sym_preproc_else_token1] = ACTIONS(2970),
    [aux_sym_preproc_elif_token1] = ACTIONS(2970),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2970),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2970),
    [sym_preproc_directive] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_BANG] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym___extension__] = ACTIONS(2970),
    [anon_sym_typedef] = ACTIONS(2970),
    [anon_sym_extern] = ACTIONS(2970),
    [anon_sym___attribute__] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2970),
    [anon_sym___based] = ACTIONS(2970),
    [anon_sym___cdecl] = ACTIONS(2970),
    [anon_sym___clrcall] = ACTIONS(2970),
    [anon_sym___stdcall] = ACTIONS(2970),
    [anon_sym___fastcall] = ACTIONS(2970),
    [anon_sym___thiscall] = ACTIONS(2970),
    [anon_sym___vectorcall] = ACTIONS(2970),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_signed] = ACTIONS(2970),
    [anon_sym_unsigned] = ACTIONS(2970),
    [anon_sym_long] = ACTIONS(2970),
    [anon_sym_short] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_register] = ACTIONS(2970),
    [anon_sym_inline] = ACTIONS(2970),
    [anon_sym___inline] = ACTIONS(2970),
    [anon_sym___inline__] = ACTIONS(2970),
    [anon_sym___forceinline] = ACTIONS(2970),
    [anon_sym_thread_local] = ACTIONS(2970),
    [anon_sym___thread] = ACTIONS(2970),
    [anon_sym_const] = ACTIONS(2970),
    [anon_sym_constexpr] = ACTIONS(2970),
    [anon_sym_volatile] = ACTIONS(2970),
    [anon_sym_restrict] = ACTIONS(2970),
    [anon_sym___restrict__] = ACTIONS(2970),
    [anon_sym__Atomic] = ACTIONS(2970),
    [anon_sym__Noreturn] = ACTIONS(2970),
    [anon_sym_noreturn] = ACTIONS(2970),
    [anon_sym_mutable] = ACTIONS(2970),
    [anon_sym_constinit] = ACTIONS(2970),
    [anon_sym_consteval] = ACTIONS(2970),
    [anon_sym_PROGMEM] = ACTIONS(2970),
    [aux_sym_primitive_type_token1] = ACTIONS(2970),
    [anon_sym_byte] = ACTIONS(2970),
    [anon_sym_word] = ACTIONS(2970),
    [anon_sym_enum] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_struct] = ACTIONS(2970),
    [anon_sym_union] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_else] = ACTIONS(2970),
    [anon_sym_switch] = ACTIONS(2970),
    [anon_sym_case] = ACTIONS(2970),
    [anon_sym_default] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_break] = ACTIONS(2970),
    [anon_sym_continue] = ACTIONS(2970),
    [anon_sym_goto] = ACTIONS(2970),
    [anon_sym___try] = ACTIONS(2970),
    [anon_sym___leave] = ACTIONS(2970),
    [anon_sym_not] = ACTIONS(2970),
    [anon_sym_compl] = ACTIONS(2970),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_sizeof] = ACTIONS(2970),
    [anon_sym___alignof__] = ACTIONS(2970),
    [anon_sym___alignof] = ACTIONS(2970),
    [anon_sym__alignof] = ACTIONS(2970),
    [anon_sym_alignof] = ACTIONS(2970),
    [anon_sym__Alignof] = ACTIONS(2970),
    [anon_sym_offsetof] = ACTIONS(2970),
    [anon_sym__Generic] = ACTIONS(2970),
    [anon_sym_asm] = ACTIONS(2970),
    [anon_sym___asm__] = ACTIONS(2970),
    [aux_sym_number_literal_token1] = ACTIONS(2972),
    [aux_sym_number_literal_token2] = ACTIONS(2970),
    [anon_sym_L_SQUOTE] = ACTIONS(2972),
    [anon_sym_u_SQUOTE] = ACTIONS(2972),
    [anon_sym_U_SQUOTE] = ACTIONS(2972),
    [anon_sym_u8_SQUOTE] = ACTIONS(2972),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [anon_sym_L_DQUOTE] = ACTIONS(2972),
    [anon_sym_u_DQUOTE] = ACTIONS(2972),
    [anon_sym_U_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE] = ACTIONS(2972),
    [sym_true] = ACTIONS(2970),
    [sym_false] = ACTIONS(2970),
    [anon_sym_NULL] = ACTIONS(2970),
    [anon_sym_nullptr] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2970),
    [anon_sym_decltype] = ACTIONS(2970),
    [anon_sym_virtual] = ACTIONS(2970),
    [anon_sym_alignas] = ACTIONS(2970),
    [anon_sym_explicit] = ACTIONS(2970),
    [anon_sym_typename] = ACTIONS(2970),
    [anon_sym_template] = ACTIONS(2970),
    [anon_sym_operator] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_delete] = ACTIONS(2970),
    [anon_sym_throw] = ACTIONS(2970),
    [anon_sym_namespace] = ACTIONS(2970),
    [anon_sym_using] = ACTIONS(2970),
    [anon_sym_static_assert] = ACTIONS(2970),
    [anon_sym_concept] = ACTIONS(2970),
    [anon_sym_co_return] = ACTIONS(2970),
    [anon_sym_co_yield] = ACTIONS(2970),
    [anon_sym_R_DQUOTE] = ACTIONS(2972),
    [anon_sym_LR_DQUOTE] = ACTIONS(2972),
    [anon_sym_uR_DQUOTE] = ACTIONS(2972),
    [anon_sym_UR_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2972),
    [anon_sym_co_await] = ACTIONS(2970),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_requires] = ACTIONS(2970),
    [sym_this] = ACTIONS(2970),
  },
  [285] = {
    [sym_type_qualifier] = STATE(4556),
    [sym__type_specifier] = STATE(5703),
    [sym_sized_type_specifier] = STATE(3397),
    [sym_primitive_type] = STATE(5893),
    [sym_enum_specifier] = STATE(3397),
    [sym_struct_specifier] = STATE(3397),
    [sym_union_specifier] = STATE(3397),
    [sym__expression] = STATE(5108),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_type_descriptor] = STATE(7725),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_placeholder_type_specifier] = STATE(3397),
    [sym_decltype_auto] = STATE(3398),
    [sym_decltype] = STATE(3383),
    [sym_class_specifier] = STATE(3397),
    [sym__class_name] = STATE(8471),
    [sym_dependent_type] = STATE(3397),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_type_parameter_pack_expansion] = STATE(8211),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6473),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym_user_defined_literal] = STATE(4248),
    [aux_sym__type_definition_type_repeat1] = STATE(4556),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2986),
    [anon_sym_unsigned] = ACTIONS(2986),
    [anon_sym_long] = ACTIONS(2986),
    [anon_sym_short] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2988),
    [anon_sym_byte] = ACTIONS(2988),
    [anon_sym_word] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2990),
    [anon_sym_class] = ACTIONS(2992),
    [anon_sym_struct] = ACTIONS(2994),
    [anon_sym_union] = ACTIONS(2996),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_GT2] = ACTIONS(3028),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [286] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [287] = {
    [sym_identifier] = ACTIONS(2970),
    [aux_sym_preproc_include_token1] = ACTIONS(2970),
    [aux_sym_preproc_def_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token2] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2970),
    [aux_sym_preproc_else_token1] = ACTIONS(2970),
    [aux_sym_preproc_elif_token1] = ACTIONS(2970),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2970),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2970),
    [sym_preproc_directive] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_BANG] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym___extension__] = ACTIONS(2970),
    [anon_sym_typedef] = ACTIONS(2970),
    [anon_sym_extern] = ACTIONS(2970),
    [anon_sym___attribute__] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2970),
    [anon_sym___based] = ACTIONS(2970),
    [anon_sym___cdecl] = ACTIONS(2970),
    [anon_sym___clrcall] = ACTIONS(2970),
    [anon_sym___stdcall] = ACTIONS(2970),
    [anon_sym___fastcall] = ACTIONS(2970),
    [anon_sym___thiscall] = ACTIONS(2970),
    [anon_sym___vectorcall] = ACTIONS(2970),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_signed] = ACTIONS(2970),
    [anon_sym_unsigned] = ACTIONS(2970),
    [anon_sym_long] = ACTIONS(2970),
    [anon_sym_short] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_register] = ACTIONS(2970),
    [anon_sym_inline] = ACTIONS(2970),
    [anon_sym___inline] = ACTIONS(2970),
    [anon_sym___inline__] = ACTIONS(2970),
    [anon_sym___forceinline] = ACTIONS(2970),
    [anon_sym_thread_local] = ACTIONS(2970),
    [anon_sym___thread] = ACTIONS(2970),
    [anon_sym_const] = ACTIONS(2970),
    [anon_sym_constexpr] = ACTIONS(2970),
    [anon_sym_volatile] = ACTIONS(2970),
    [anon_sym_restrict] = ACTIONS(2970),
    [anon_sym___restrict__] = ACTIONS(2970),
    [anon_sym__Atomic] = ACTIONS(2970),
    [anon_sym__Noreturn] = ACTIONS(2970),
    [anon_sym_noreturn] = ACTIONS(2970),
    [anon_sym_mutable] = ACTIONS(2970),
    [anon_sym_constinit] = ACTIONS(2970),
    [anon_sym_consteval] = ACTIONS(2970),
    [anon_sym_PROGMEM] = ACTIONS(2970),
    [aux_sym_primitive_type_token1] = ACTIONS(2970),
    [anon_sym_byte] = ACTIONS(2970),
    [anon_sym_word] = ACTIONS(2970),
    [anon_sym_enum] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_struct] = ACTIONS(2970),
    [anon_sym_union] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_else] = ACTIONS(2970),
    [anon_sym_switch] = ACTIONS(2970),
    [anon_sym_case] = ACTIONS(2970),
    [anon_sym_default] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_break] = ACTIONS(2970),
    [anon_sym_continue] = ACTIONS(2970),
    [anon_sym_goto] = ACTIONS(2970),
    [anon_sym___try] = ACTIONS(2970),
    [anon_sym___leave] = ACTIONS(2970),
    [anon_sym_not] = ACTIONS(2970),
    [anon_sym_compl] = ACTIONS(2970),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_sizeof] = ACTIONS(2970),
    [anon_sym___alignof__] = ACTIONS(2970),
    [anon_sym___alignof] = ACTIONS(2970),
    [anon_sym__alignof] = ACTIONS(2970),
    [anon_sym_alignof] = ACTIONS(2970),
    [anon_sym__Alignof] = ACTIONS(2970),
    [anon_sym_offsetof] = ACTIONS(2970),
    [anon_sym__Generic] = ACTIONS(2970),
    [anon_sym_asm] = ACTIONS(2970),
    [anon_sym___asm__] = ACTIONS(2970),
    [aux_sym_number_literal_token1] = ACTIONS(2972),
    [aux_sym_number_literal_token2] = ACTIONS(2970),
    [anon_sym_L_SQUOTE] = ACTIONS(2972),
    [anon_sym_u_SQUOTE] = ACTIONS(2972),
    [anon_sym_U_SQUOTE] = ACTIONS(2972),
    [anon_sym_u8_SQUOTE] = ACTIONS(2972),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [anon_sym_L_DQUOTE] = ACTIONS(2972),
    [anon_sym_u_DQUOTE] = ACTIONS(2972),
    [anon_sym_U_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE] = ACTIONS(2972),
    [sym_true] = ACTIONS(2970),
    [sym_false] = ACTIONS(2970),
    [anon_sym_NULL] = ACTIONS(2970),
    [anon_sym_nullptr] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2970),
    [anon_sym_decltype] = ACTIONS(2970),
    [anon_sym_virtual] = ACTIONS(2970),
    [anon_sym_alignas] = ACTIONS(2970),
    [anon_sym_explicit] = ACTIONS(2970),
    [anon_sym_typename] = ACTIONS(2970),
    [anon_sym_template] = ACTIONS(2970),
    [anon_sym_operator] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_delete] = ACTIONS(2970),
    [anon_sym_throw] = ACTIONS(2970),
    [anon_sym_namespace] = ACTIONS(2970),
    [anon_sym_using] = ACTIONS(2970),
    [anon_sym_static_assert] = ACTIONS(2970),
    [anon_sym_concept] = ACTIONS(2970),
    [anon_sym_co_return] = ACTIONS(2970),
    [anon_sym_co_yield] = ACTIONS(2970),
    [anon_sym_R_DQUOTE] = ACTIONS(2972),
    [anon_sym_LR_DQUOTE] = ACTIONS(2972),
    [anon_sym_uR_DQUOTE] = ACTIONS(2972),
    [anon_sym_UR_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2972),
    [anon_sym_co_await] = ACTIONS(2970),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_requires] = ACTIONS(2970),
    [sym_this] = ACTIONS(2970),
  },
  [288] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [289] = {
    [sym_type_qualifier] = STATE(4556),
    [sym__type_specifier] = STATE(5703),
    [sym_sized_type_specifier] = STATE(3397),
    [sym_primitive_type] = STATE(5893),
    [sym_enum_specifier] = STATE(3397),
    [sym_struct_specifier] = STATE(3397),
    [sym_union_specifier] = STATE(3397),
    [sym__expression] = STATE(5137),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_type_descriptor] = STATE(7752),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_placeholder_type_specifier] = STATE(3397),
    [sym_decltype_auto] = STATE(3398),
    [sym_decltype] = STATE(3383),
    [sym_class_specifier] = STATE(3397),
    [sym__class_name] = STATE(8471),
    [sym_dependent_type] = STATE(3397),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_type_parameter_pack_expansion] = STATE(8310),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6473),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym_user_defined_literal] = STATE(4248),
    [aux_sym__type_definition_type_repeat1] = STATE(4556),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2986),
    [anon_sym_unsigned] = ACTIONS(2986),
    [anon_sym_long] = ACTIONS(2986),
    [anon_sym_short] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2988),
    [anon_sym_byte] = ACTIONS(2988),
    [anon_sym_word] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2990),
    [anon_sym_class] = ACTIONS(2992),
    [anon_sym_struct] = ACTIONS(2994),
    [anon_sym_union] = ACTIONS(2996),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_GT2] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [290] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [291] = {
    [sym_type_qualifier] = STATE(4556),
    [sym__type_specifier] = STATE(5703),
    [sym_sized_type_specifier] = STATE(3397),
    [sym_primitive_type] = STATE(5893),
    [sym_enum_specifier] = STATE(3397),
    [sym_struct_specifier] = STATE(3397),
    [sym_union_specifier] = STATE(3397),
    [sym__expression] = STATE(5063),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_type_descriptor] = STATE(7904),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_placeholder_type_specifier] = STATE(3397),
    [sym_decltype_auto] = STATE(3398),
    [sym_decltype] = STATE(3383),
    [sym_class_specifier] = STATE(3397),
    [sym__class_name] = STATE(8471),
    [sym_dependent_type] = STATE(3397),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_type_parameter_pack_expansion] = STATE(8376),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6473),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym_user_defined_literal] = STATE(4248),
    [aux_sym__type_definition_type_repeat1] = STATE(4556),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2986),
    [anon_sym_unsigned] = ACTIONS(2986),
    [anon_sym_long] = ACTIONS(2986),
    [anon_sym_short] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2988),
    [anon_sym_byte] = ACTIONS(2988),
    [anon_sym_word] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2990),
    [anon_sym_class] = ACTIONS(2992),
    [anon_sym_struct] = ACTIONS(2994),
    [anon_sym_union] = ACTIONS(2996),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_GT2] = ACTIONS(3042),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [292] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [293] = {
    [sym_type_qualifier] = STATE(4556),
    [sym__type_specifier] = STATE(5703),
    [sym_sized_type_specifier] = STATE(3397),
    [sym_primitive_type] = STATE(5893),
    [sym_enum_specifier] = STATE(3397),
    [sym_struct_specifier] = STATE(3397),
    [sym_union_specifier] = STATE(3397),
    [sym__expression] = STATE(5115),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_type_descriptor] = STATE(7790),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_placeholder_type_specifier] = STATE(3397),
    [sym_decltype_auto] = STATE(3398),
    [sym_decltype] = STATE(3383),
    [sym_class_specifier] = STATE(3397),
    [sym__class_name] = STATE(8471),
    [sym_dependent_type] = STATE(3397),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_type_parameter_pack_expansion] = STATE(8060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6473),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym_user_defined_literal] = STATE(4248),
    [aux_sym__type_definition_type_repeat1] = STATE(4556),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2986),
    [anon_sym_unsigned] = ACTIONS(2986),
    [anon_sym_long] = ACTIONS(2986),
    [anon_sym_short] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2988),
    [anon_sym_byte] = ACTIONS(2988),
    [anon_sym_word] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2990),
    [anon_sym_class] = ACTIONS(2992),
    [anon_sym_struct] = ACTIONS(2994),
    [anon_sym_union] = ACTIONS(2996),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_GT2] = ACTIONS(3044),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [294] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [295] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [296] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [297] = {
    [sym_identifier] = ACTIONS(3046),
    [aux_sym_preproc_include_token1] = ACTIONS(3046),
    [aux_sym_preproc_def_token1] = ACTIONS(3046),
    [aux_sym_preproc_if_token1] = ACTIONS(3046),
    [aux_sym_preproc_if_token2] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3046),
    [aux_sym_preproc_else_token1] = ACTIONS(3046),
    [aux_sym_preproc_elif_token1] = ACTIONS(3046),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3046),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3046),
    [sym_preproc_directive] = ACTIONS(3046),
    [anon_sym_LPAREN2] = ACTIONS(3048),
    [anon_sym_BANG] = ACTIONS(3048),
    [anon_sym_TILDE] = ACTIONS(3048),
    [anon_sym_DASH] = ACTIONS(3046),
    [anon_sym_PLUS] = ACTIONS(3046),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_AMP_AMP] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3046),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym___extension__] = ACTIONS(3046),
    [anon_sym_typedef] = ACTIONS(3046),
    [anon_sym_extern] = ACTIONS(3046),
    [anon_sym___attribute__] = ACTIONS(3046),
    [anon_sym_COLON_COLON] = ACTIONS(3048),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3048),
    [anon_sym___declspec] = ACTIONS(3046),
    [anon_sym___based] = ACTIONS(3046),
    [anon_sym___cdecl] = ACTIONS(3046),
    [anon_sym___clrcall] = ACTIONS(3046),
    [anon_sym___stdcall] = ACTIONS(3046),
    [anon_sym___fastcall] = ACTIONS(3046),
    [anon_sym___thiscall] = ACTIONS(3046),
    [anon_sym___vectorcall] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3048),
    [anon_sym_signed] = ACTIONS(3046),
    [anon_sym_unsigned] = ACTIONS(3046),
    [anon_sym_long] = ACTIONS(3046),
    [anon_sym_short] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_static] = ACTIONS(3046),
    [anon_sym_register] = ACTIONS(3046),
    [anon_sym_inline] = ACTIONS(3046),
    [anon_sym___inline] = ACTIONS(3046),
    [anon_sym___inline__] = ACTIONS(3046),
    [anon_sym___forceinline] = ACTIONS(3046),
    [anon_sym_thread_local] = ACTIONS(3046),
    [anon_sym___thread] = ACTIONS(3046),
    [anon_sym_const] = ACTIONS(3046),
    [anon_sym_constexpr] = ACTIONS(3046),
    [anon_sym_volatile] = ACTIONS(3046),
    [anon_sym_restrict] = ACTIONS(3046),
    [anon_sym___restrict__] = ACTIONS(3046),
    [anon_sym__Atomic] = ACTIONS(3046),
    [anon_sym__Noreturn] = ACTIONS(3046),
    [anon_sym_noreturn] = ACTIONS(3046),
    [anon_sym_mutable] = ACTIONS(3046),
    [anon_sym_constinit] = ACTIONS(3046),
    [anon_sym_consteval] = ACTIONS(3046),
    [anon_sym_PROGMEM] = ACTIONS(3046),
    [aux_sym_primitive_type_token1] = ACTIONS(3046),
    [anon_sym_byte] = ACTIONS(3046),
    [anon_sym_word] = ACTIONS(3046),
    [anon_sym_enum] = ACTIONS(3046),
    [anon_sym_class] = ACTIONS(3046),
    [anon_sym_struct] = ACTIONS(3046),
    [anon_sym_union] = ACTIONS(3046),
    [anon_sym_if] = ACTIONS(3046),
    [anon_sym_else] = ACTIONS(3046),
    [anon_sym_switch] = ACTIONS(3046),
    [anon_sym_case] = ACTIONS(3046),
    [anon_sym_default] = ACTIONS(3046),
    [anon_sym_while] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_for] = ACTIONS(3046),
    [anon_sym_return] = ACTIONS(3046),
    [anon_sym_break] = ACTIONS(3046),
    [anon_sym_continue] = ACTIONS(3046),
    [anon_sym_goto] = ACTIONS(3046),
    [anon_sym___try] = ACTIONS(3046),
    [anon_sym___leave] = ACTIONS(3046),
    [anon_sym_not] = ACTIONS(3046),
    [anon_sym_compl] = ACTIONS(3046),
    [anon_sym_DASH_DASH] = ACTIONS(3048),
    [anon_sym_PLUS_PLUS] = ACTIONS(3048),
    [anon_sym_sizeof] = ACTIONS(3046),
    [anon_sym___alignof__] = ACTIONS(3046),
    [anon_sym___alignof] = ACTIONS(3046),
    [anon_sym__alignof] = ACTIONS(3046),
    [anon_sym_alignof] = ACTIONS(3046),
    [anon_sym__Alignof] = ACTIONS(3046),
    [anon_sym_offsetof] = ACTIONS(3046),
    [anon_sym__Generic] = ACTIONS(3046),
    [anon_sym_asm] = ACTIONS(3046),
    [anon_sym___asm__] = ACTIONS(3046),
    [aux_sym_number_literal_token1] = ACTIONS(3048),
    [aux_sym_number_literal_token2] = ACTIONS(3046),
    [anon_sym_L_SQUOTE] = ACTIONS(3048),
    [anon_sym_u_SQUOTE] = ACTIONS(3048),
    [anon_sym_U_SQUOTE] = ACTIONS(3048),
    [anon_sym_u8_SQUOTE] = ACTIONS(3048),
    [anon_sym_SQUOTE] = ACTIONS(3048),
    [anon_sym_L_DQUOTE] = ACTIONS(3048),
    [anon_sym_u_DQUOTE] = ACTIONS(3048),
    [anon_sym_U_DQUOTE] = ACTIONS(3048),
    [anon_sym_u8_DQUOTE] = ACTIONS(3048),
    [anon_sym_DQUOTE] = ACTIONS(3048),
    [sym_true] = ACTIONS(3046),
    [sym_false] = ACTIONS(3046),
    [anon_sym_NULL] = ACTIONS(3046),
    [anon_sym_nullptr] = ACTIONS(3046),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3046),
    [anon_sym_decltype] = ACTIONS(3046),
    [anon_sym_virtual] = ACTIONS(3046),
    [anon_sym_alignas] = ACTIONS(3046),
    [anon_sym_explicit] = ACTIONS(3046),
    [anon_sym_typename] = ACTIONS(3046),
    [anon_sym_template] = ACTIONS(3046),
    [anon_sym_operator] = ACTIONS(3046),
    [anon_sym_try] = ACTIONS(3046),
    [anon_sym_delete] = ACTIONS(3046),
    [anon_sym_throw] = ACTIONS(3046),
    [anon_sym_namespace] = ACTIONS(3046),
    [anon_sym_using] = ACTIONS(3046),
    [anon_sym_static_assert] = ACTIONS(3046),
    [anon_sym_concept] = ACTIONS(3046),
    [anon_sym_co_return] = ACTIONS(3046),
    [anon_sym_co_yield] = ACTIONS(3046),
    [anon_sym_R_DQUOTE] = ACTIONS(3048),
    [anon_sym_LR_DQUOTE] = ACTIONS(3048),
    [anon_sym_uR_DQUOTE] = ACTIONS(3048),
    [anon_sym_UR_DQUOTE] = ACTIONS(3048),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3048),
    [anon_sym_co_await] = ACTIONS(3046),
    [anon_sym_new] = ACTIONS(3046),
    [anon_sym_requires] = ACTIONS(3046),
    [sym_this] = ACTIONS(3046),
  },
  [298] = {
    [sym_identifier] = ACTIONS(3050),
    [aux_sym_preproc_include_token1] = ACTIONS(3050),
    [aux_sym_preproc_def_token1] = ACTIONS(3050),
    [aux_sym_preproc_if_token1] = ACTIONS(3050),
    [aux_sym_preproc_if_token2] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3050),
    [aux_sym_preproc_else_token1] = ACTIONS(3050),
    [aux_sym_preproc_elif_token1] = ACTIONS(3050),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3050),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3050),
    [sym_preproc_directive] = ACTIONS(3050),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3050),
    [anon_sym_PLUS] = ACTIONS(3050),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3050),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3050),
    [anon_sym_typedef] = ACTIONS(3050),
    [anon_sym_extern] = ACTIONS(3050),
    [anon_sym___attribute__] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3052),
    [anon_sym___declspec] = ACTIONS(3050),
    [anon_sym___based] = ACTIONS(3050),
    [anon_sym___cdecl] = ACTIONS(3050),
    [anon_sym___clrcall] = ACTIONS(3050),
    [anon_sym___stdcall] = ACTIONS(3050),
    [anon_sym___fastcall] = ACTIONS(3050),
    [anon_sym___thiscall] = ACTIONS(3050),
    [anon_sym___vectorcall] = ACTIONS(3050),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_signed] = ACTIONS(3050),
    [anon_sym_unsigned] = ACTIONS(3050),
    [anon_sym_long] = ACTIONS(3050),
    [anon_sym_short] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_static] = ACTIONS(3050),
    [anon_sym_register] = ACTIONS(3050),
    [anon_sym_inline] = ACTIONS(3050),
    [anon_sym___inline] = ACTIONS(3050),
    [anon_sym___inline__] = ACTIONS(3050),
    [anon_sym___forceinline] = ACTIONS(3050),
    [anon_sym_thread_local] = ACTIONS(3050),
    [anon_sym___thread] = ACTIONS(3050),
    [anon_sym_const] = ACTIONS(3050),
    [anon_sym_constexpr] = ACTIONS(3050),
    [anon_sym_volatile] = ACTIONS(3050),
    [anon_sym_restrict] = ACTIONS(3050),
    [anon_sym___restrict__] = ACTIONS(3050),
    [anon_sym__Atomic] = ACTIONS(3050),
    [anon_sym__Noreturn] = ACTIONS(3050),
    [anon_sym_noreturn] = ACTIONS(3050),
    [anon_sym_mutable] = ACTIONS(3050),
    [anon_sym_constinit] = ACTIONS(3050),
    [anon_sym_consteval] = ACTIONS(3050),
    [anon_sym_PROGMEM] = ACTIONS(3050),
    [aux_sym_primitive_type_token1] = ACTIONS(3050),
    [anon_sym_byte] = ACTIONS(3050),
    [anon_sym_word] = ACTIONS(3050),
    [anon_sym_enum] = ACTIONS(3050),
    [anon_sym_class] = ACTIONS(3050),
    [anon_sym_struct] = ACTIONS(3050),
    [anon_sym_union] = ACTIONS(3050),
    [anon_sym_if] = ACTIONS(3050),
    [anon_sym_else] = ACTIONS(3050),
    [anon_sym_switch] = ACTIONS(3050),
    [anon_sym_case] = ACTIONS(3050),
    [anon_sym_default] = ACTIONS(3050),
    [anon_sym_while] = ACTIONS(3050),
    [anon_sym_do] = ACTIONS(3050),
    [anon_sym_for] = ACTIONS(3050),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_break] = ACTIONS(3050),
    [anon_sym_continue] = ACTIONS(3050),
    [anon_sym_goto] = ACTIONS(3050),
    [anon_sym___try] = ACTIONS(3050),
    [anon_sym___leave] = ACTIONS(3050),
    [anon_sym_not] = ACTIONS(3050),
    [anon_sym_compl] = ACTIONS(3050),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_sizeof] = ACTIONS(3050),
    [anon_sym___alignof__] = ACTIONS(3050),
    [anon_sym___alignof] = ACTIONS(3050),
    [anon_sym__alignof] = ACTIONS(3050),
    [anon_sym_alignof] = ACTIONS(3050),
    [anon_sym__Alignof] = ACTIONS(3050),
    [anon_sym_offsetof] = ACTIONS(3050),
    [anon_sym__Generic] = ACTIONS(3050),
    [anon_sym_asm] = ACTIONS(3050),
    [anon_sym___asm__] = ACTIONS(3050),
    [aux_sym_number_literal_token1] = ACTIONS(3052),
    [aux_sym_number_literal_token2] = ACTIONS(3050),
    [anon_sym_L_SQUOTE] = ACTIONS(3052),
    [anon_sym_u_SQUOTE] = ACTIONS(3052),
    [anon_sym_U_SQUOTE] = ACTIONS(3052),
    [anon_sym_u8_SQUOTE] = ACTIONS(3052),
    [anon_sym_SQUOTE] = ACTIONS(3052),
    [anon_sym_L_DQUOTE] = ACTIONS(3052),
    [anon_sym_u_DQUOTE] = ACTIONS(3052),
    [anon_sym_U_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8_DQUOTE] = ACTIONS(3052),
    [anon_sym_DQUOTE] = ACTIONS(3052),
    [sym_true] = ACTIONS(3050),
    [sym_false] = ACTIONS(3050),
    [anon_sym_NULL] = ACTIONS(3050),
    [anon_sym_nullptr] = ACTIONS(3050),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3050),
    [anon_sym_decltype] = ACTIONS(3050),
    [anon_sym_virtual] = ACTIONS(3050),
    [anon_sym_alignas] = ACTIONS(3050),
    [anon_sym_explicit] = ACTIONS(3050),
    [anon_sym_typename] = ACTIONS(3050),
    [anon_sym_template] = ACTIONS(3050),
    [anon_sym_operator] = ACTIONS(3050),
    [anon_sym_try] = ACTIONS(3050),
    [anon_sym_delete] = ACTIONS(3050),
    [anon_sym_throw] = ACTIONS(3050),
    [anon_sym_namespace] = ACTIONS(3050),
    [anon_sym_using] = ACTIONS(3050),
    [anon_sym_static_assert] = ACTIONS(3050),
    [anon_sym_concept] = ACTIONS(3050),
    [anon_sym_co_return] = ACTIONS(3050),
    [anon_sym_co_yield] = ACTIONS(3050),
    [anon_sym_R_DQUOTE] = ACTIONS(3052),
    [anon_sym_LR_DQUOTE] = ACTIONS(3052),
    [anon_sym_uR_DQUOTE] = ACTIONS(3052),
    [anon_sym_UR_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3052),
    [anon_sym_co_await] = ACTIONS(3050),
    [anon_sym_new] = ACTIONS(3050),
    [anon_sym_requires] = ACTIONS(3050),
    [sym_this] = ACTIONS(3050),
  },
  [299] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [300] = {
    [sym_identifier] = ACTIONS(3054),
    [aux_sym_preproc_include_token1] = ACTIONS(3054),
    [aux_sym_preproc_def_token1] = ACTIONS(3054),
    [aux_sym_preproc_if_token1] = ACTIONS(3054),
    [aux_sym_preproc_if_token2] = ACTIONS(3054),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3054),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3054),
    [aux_sym_preproc_else_token1] = ACTIONS(3054),
    [aux_sym_preproc_elif_token1] = ACTIONS(3054),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3054),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3054),
    [sym_preproc_directive] = ACTIONS(3054),
    [anon_sym_LPAREN2] = ACTIONS(3056),
    [anon_sym_BANG] = ACTIONS(3056),
    [anon_sym_TILDE] = ACTIONS(3056),
    [anon_sym_DASH] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3056),
    [anon_sym_AMP_AMP] = ACTIONS(3056),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym___extension__] = ACTIONS(3054),
    [anon_sym_typedef] = ACTIONS(3054),
    [anon_sym_extern] = ACTIONS(3054),
    [anon_sym___attribute__] = ACTIONS(3054),
    [anon_sym_COLON_COLON] = ACTIONS(3056),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3056),
    [anon_sym___declspec] = ACTIONS(3054),
    [anon_sym___based] = ACTIONS(3054),
    [anon_sym___cdecl] = ACTIONS(3054),
    [anon_sym___clrcall] = ACTIONS(3054),
    [anon_sym___stdcall] = ACTIONS(3054),
    [anon_sym___fastcall] = ACTIONS(3054),
    [anon_sym___thiscall] = ACTIONS(3054),
    [anon_sym___vectorcall] = ACTIONS(3054),
    [anon_sym_LBRACE] = ACTIONS(3056),
    [anon_sym_signed] = ACTIONS(3054),
    [anon_sym_unsigned] = ACTIONS(3054),
    [anon_sym_long] = ACTIONS(3054),
    [anon_sym_short] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3054),
    [anon_sym_static] = ACTIONS(3054),
    [anon_sym_register] = ACTIONS(3054),
    [anon_sym_inline] = ACTIONS(3054),
    [anon_sym___inline] = ACTIONS(3054),
    [anon_sym___inline__] = ACTIONS(3054),
    [anon_sym___forceinline] = ACTIONS(3054),
    [anon_sym_thread_local] = ACTIONS(3054),
    [anon_sym___thread] = ACTIONS(3054),
    [anon_sym_const] = ACTIONS(3054),
    [anon_sym_constexpr] = ACTIONS(3054),
    [anon_sym_volatile] = ACTIONS(3054),
    [anon_sym_restrict] = ACTIONS(3054),
    [anon_sym___restrict__] = ACTIONS(3054),
    [anon_sym__Atomic] = ACTIONS(3054),
    [anon_sym__Noreturn] = ACTIONS(3054),
    [anon_sym_noreturn] = ACTIONS(3054),
    [anon_sym_mutable] = ACTIONS(3054),
    [anon_sym_constinit] = ACTIONS(3054),
    [anon_sym_consteval] = ACTIONS(3054),
    [anon_sym_PROGMEM] = ACTIONS(3054),
    [aux_sym_primitive_type_token1] = ACTIONS(3054),
    [anon_sym_byte] = ACTIONS(3054),
    [anon_sym_word] = ACTIONS(3054),
    [anon_sym_enum] = ACTIONS(3054),
    [anon_sym_class] = ACTIONS(3054),
    [anon_sym_struct] = ACTIONS(3054),
    [anon_sym_union] = ACTIONS(3054),
    [anon_sym_if] = ACTIONS(3054),
    [anon_sym_else] = ACTIONS(3054),
    [anon_sym_switch] = ACTIONS(3054),
    [anon_sym_case] = ACTIONS(3054),
    [anon_sym_default] = ACTIONS(3054),
    [anon_sym_while] = ACTIONS(3054),
    [anon_sym_do] = ACTIONS(3054),
    [anon_sym_for] = ACTIONS(3054),
    [anon_sym_return] = ACTIONS(3054),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_continue] = ACTIONS(3054),
    [anon_sym_goto] = ACTIONS(3054),
    [anon_sym___try] = ACTIONS(3054),
    [anon_sym___leave] = ACTIONS(3054),
    [anon_sym_not] = ACTIONS(3054),
    [anon_sym_compl] = ACTIONS(3054),
    [anon_sym_DASH_DASH] = ACTIONS(3056),
    [anon_sym_PLUS_PLUS] = ACTIONS(3056),
    [anon_sym_sizeof] = ACTIONS(3054),
    [anon_sym___alignof__] = ACTIONS(3054),
    [anon_sym___alignof] = ACTIONS(3054),
    [anon_sym__alignof] = ACTIONS(3054),
    [anon_sym_alignof] = ACTIONS(3054),
    [anon_sym__Alignof] = ACTIONS(3054),
    [anon_sym_offsetof] = ACTIONS(3054),
    [anon_sym__Generic] = ACTIONS(3054),
    [anon_sym_asm] = ACTIONS(3054),
    [anon_sym___asm__] = ACTIONS(3054),
    [aux_sym_number_literal_token1] = ACTIONS(3056),
    [aux_sym_number_literal_token2] = ACTIONS(3054),
    [anon_sym_L_SQUOTE] = ACTIONS(3056),
    [anon_sym_u_SQUOTE] = ACTIONS(3056),
    [anon_sym_U_SQUOTE] = ACTIONS(3056),
    [anon_sym_u8_SQUOTE] = ACTIONS(3056),
    [anon_sym_SQUOTE] = ACTIONS(3056),
    [anon_sym_L_DQUOTE] = ACTIONS(3056),
    [anon_sym_u_DQUOTE] = ACTIONS(3056),
    [anon_sym_U_DQUOTE] = ACTIONS(3056),
    [anon_sym_u8_DQUOTE] = ACTIONS(3056),
    [anon_sym_DQUOTE] = ACTIONS(3056),
    [sym_true] = ACTIONS(3054),
    [sym_false] = ACTIONS(3054),
    [anon_sym_NULL] = ACTIONS(3054),
    [anon_sym_nullptr] = ACTIONS(3054),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3054),
    [anon_sym_decltype] = ACTIONS(3054),
    [anon_sym_virtual] = ACTIONS(3054),
    [anon_sym_alignas] = ACTIONS(3054),
    [anon_sym_explicit] = ACTIONS(3054),
    [anon_sym_typename] = ACTIONS(3054),
    [anon_sym_template] = ACTIONS(3054),
    [anon_sym_operator] = ACTIONS(3054),
    [anon_sym_try] = ACTIONS(3054),
    [anon_sym_delete] = ACTIONS(3054),
    [anon_sym_throw] = ACTIONS(3054),
    [anon_sym_namespace] = ACTIONS(3054),
    [anon_sym_using] = ACTIONS(3054),
    [anon_sym_static_assert] = ACTIONS(3054),
    [anon_sym_concept] = ACTIONS(3054),
    [anon_sym_co_return] = ACTIONS(3054),
    [anon_sym_co_yield] = ACTIONS(3054),
    [anon_sym_R_DQUOTE] = ACTIONS(3056),
    [anon_sym_LR_DQUOTE] = ACTIONS(3056),
    [anon_sym_uR_DQUOTE] = ACTIONS(3056),
    [anon_sym_UR_DQUOTE] = ACTIONS(3056),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3056),
    [anon_sym_co_await] = ACTIONS(3054),
    [anon_sym_new] = ACTIONS(3054),
    [anon_sym_requires] = ACTIONS(3054),
    [sym_this] = ACTIONS(3054),
  },
  [301] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [302] = {
    [sym_identifier] = ACTIONS(3058),
    [aux_sym_preproc_include_token1] = ACTIONS(3058),
    [aux_sym_preproc_def_token1] = ACTIONS(3058),
    [aux_sym_preproc_if_token1] = ACTIONS(3058),
    [aux_sym_preproc_if_token2] = ACTIONS(3058),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3058),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3058),
    [aux_sym_preproc_else_token1] = ACTIONS(3058),
    [aux_sym_preproc_elif_token1] = ACTIONS(3058),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3058),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3058),
    [sym_preproc_directive] = ACTIONS(3058),
    [anon_sym_LPAREN2] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3060),
    [anon_sym_TILDE] = ACTIONS(3060),
    [anon_sym_DASH] = ACTIONS(3058),
    [anon_sym_PLUS] = ACTIONS(3058),
    [anon_sym_STAR] = ACTIONS(3060),
    [anon_sym_AMP_AMP] = ACTIONS(3060),
    [anon_sym_AMP] = ACTIONS(3058),
    [anon_sym_SEMI] = ACTIONS(3060),
    [anon_sym___extension__] = ACTIONS(3058),
    [anon_sym_typedef] = ACTIONS(3058),
    [anon_sym_extern] = ACTIONS(3058),
    [anon_sym___attribute__] = ACTIONS(3058),
    [anon_sym_COLON_COLON] = ACTIONS(3060),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3060),
    [anon_sym___declspec] = ACTIONS(3058),
    [anon_sym___based] = ACTIONS(3058),
    [anon_sym___cdecl] = ACTIONS(3058),
    [anon_sym___clrcall] = ACTIONS(3058),
    [anon_sym___stdcall] = ACTIONS(3058),
    [anon_sym___fastcall] = ACTIONS(3058),
    [anon_sym___thiscall] = ACTIONS(3058),
    [anon_sym___vectorcall] = ACTIONS(3058),
    [anon_sym_LBRACE] = ACTIONS(3060),
    [anon_sym_signed] = ACTIONS(3058),
    [anon_sym_unsigned] = ACTIONS(3058),
    [anon_sym_long] = ACTIONS(3058),
    [anon_sym_short] = ACTIONS(3058),
    [anon_sym_LBRACK] = ACTIONS(3058),
    [anon_sym_static] = ACTIONS(3058),
    [anon_sym_register] = ACTIONS(3058),
    [anon_sym_inline] = ACTIONS(3058),
    [anon_sym___inline] = ACTIONS(3058),
    [anon_sym___inline__] = ACTIONS(3058),
    [anon_sym___forceinline] = ACTIONS(3058),
    [anon_sym_thread_local] = ACTIONS(3058),
    [anon_sym___thread] = ACTIONS(3058),
    [anon_sym_const] = ACTIONS(3058),
    [anon_sym_constexpr] = ACTIONS(3058),
    [anon_sym_volatile] = ACTIONS(3058),
    [anon_sym_restrict] = ACTIONS(3058),
    [anon_sym___restrict__] = ACTIONS(3058),
    [anon_sym__Atomic] = ACTIONS(3058),
    [anon_sym__Noreturn] = ACTIONS(3058),
    [anon_sym_noreturn] = ACTIONS(3058),
    [anon_sym_mutable] = ACTIONS(3058),
    [anon_sym_constinit] = ACTIONS(3058),
    [anon_sym_consteval] = ACTIONS(3058),
    [anon_sym_PROGMEM] = ACTIONS(3058),
    [aux_sym_primitive_type_token1] = ACTIONS(3058),
    [anon_sym_byte] = ACTIONS(3058),
    [anon_sym_word] = ACTIONS(3058),
    [anon_sym_enum] = ACTIONS(3058),
    [anon_sym_class] = ACTIONS(3058),
    [anon_sym_struct] = ACTIONS(3058),
    [anon_sym_union] = ACTIONS(3058),
    [anon_sym_if] = ACTIONS(3058),
    [anon_sym_else] = ACTIONS(3058),
    [anon_sym_switch] = ACTIONS(3058),
    [anon_sym_case] = ACTIONS(3058),
    [anon_sym_default] = ACTIONS(3058),
    [anon_sym_while] = ACTIONS(3058),
    [anon_sym_do] = ACTIONS(3058),
    [anon_sym_for] = ACTIONS(3058),
    [anon_sym_return] = ACTIONS(3058),
    [anon_sym_break] = ACTIONS(3058),
    [anon_sym_continue] = ACTIONS(3058),
    [anon_sym_goto] = ACTIONS(3058),
    [anon_sym___try] = ACTIONS(3058),
    [anon_sym___leave] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3058),
    [anon_sym_compl] = ACTIONS(3058),
    [anon_sym_DASH_DASH] = ACTIONS(3060),
    [anon_sym_PLUS_PLUS] = ACTIONS(3060),
    [anon_sym_sizeof] = ACTIONS(3058),
    [anon_sym___alignof__] = ACTIONS(3058),
    [anon_sym___alignof] = ACTIONS(3058),
    [anon_sym__alignof] = ACTIONS(3058),
    [anon_sym_alignof] = ACTIONS(3058),
    [anon_sym__Alignof] = ACTIONS(3058),
    [anon_sym_offsetof] = ACTIONS(3058),
    [anon_sym__Generic] = ACTIONS(3058),
    [anon_sym_asm] = ACTIONS(3058),
    [anon_sym___asm__] = ACTIONS(3058),
    [aux_sym_number_literal_token1] = ACTIONS(3060),
    [aux_sym_number_literal_token2] = ACTIONS(3058),
    [anon_sym_L_SQUOTE] = ACTIONS(3060),
    [anon_sym_u_SQUOTE] = ACTIONS(3060),
    [anon_sym_U_SQUOTE] = ACTIONS(3060),
    [anon_sym_u8_SQUOTE] = ACTIONS(3060),
    [anon_sym_SQUOTE] = ACTIONS(3060),
    [anon_sym_L_DQUOTE] = ACTIONS(3060),
    [anon_sym_u_DQUOTE] = ACTIONS(3060),
    [anon_sym_U_DQUOTE] = ACTIONS(3060),
    [anon_sym_u8_DQUOTE] = ACTIONS(3060),
    [anon_sym_DQUOTE] = ACTIONS(3060),
    [sym_true] = ACTIONS(3058),
    [sym_false] = ACTIONS(3058),
    [anon_sym_NULL] = ACTIONS(3058),
    [anon_sym_nullptr] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3058),
    [anon_sym_decltype] = ACTIONS(3058),
    [anon_sym_virtual] = ACTIONS(3058),
    [anon_sym_alignas] = ACTIONS(3058),
    [anon_sym_explicit] = ACTIONS(3058),
    [anon_sym_typename] = ACTIONS(3058),
    [anon_sym_template] = ACTIONS(3058),
    [anon_sym_operator] = ACTIONS(3058),
    [anon_sym_try] = ACTIONS(3058),
    [anon_sym_delete] = ACTIONS(3058),
    [anon_sym_throw] = ACTIONS(3058),
    [anon_sym_namespace] = ACTIONS(3058),
    [anon_sym_using] = ACTIONS(3058),
    [anon_sym_static_assert] = ACTIONS(3058),
    [anon_sym_concept] = ACTIONS(3058),
    [anon_sym_co_return] = ACTIONS(3058),
    [anon_sym_co_yield] = ACTIONS(3058),
    [anon_sym_R_DQUOTE] = ACTIONS(3060),
    [anon_sym_LR_DQUOTE] = ACTIONS(3060),
    [anon_sym_uR_DQUOTE] = ACTIONS(3060),
    [anon_sym_UR_DQUOTE] = ACTIONS(3060),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3060),
    [anon_sym_co_await] = ACTIONS(3058),
    [anon_sym_new] = ACTIONS(3058),
    [anon_sym_requires] = ACTIONS(3058),
    [sym_this] = ACTIONS(3058),
  },
  [303] = {
    [sym_type_qualifier] = STATE(4556),
    [sym__type_specifier] = STATE(5703),
    [sym_sized_type_specifier] = STATE(3397),
    [sym_primitive_type] = STATE(5893),
    [sym_enum_specifier] = STATE(3397),
    [sym_struct_specifier] = STATE(3397),
    [sym_union_specifier] = STATE(3397),
    [sym__expression] = STATE(5042),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_type_descriptor] = STATE(7756),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_placeholder_type_specifier] = STATE(3397),
    [sym_decltype_auto] = STATE(3398),
    [sym_decltype] = STATE(3383),
    [sym_class_specifier] = STATE(3397),
    [sym__class_name] = STATE(8471),
    [sym_dependent_type] = STATE(3397),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_type_parameter_pack_expansion] = STATE(8234),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6473),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym_user_defined_literal] = STATE(4248),
    [aux_sym__type_definition_type_repeat1] = STATE(4556),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2986),
    [anon_sym_unsigned] = ACTIONS(2986),
    [anon_sym_long] = ACTIONS(2986),
    [anon_sym_short] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2988),
    [anon_sym_byte] = ACTIONS(2988),
    [anon_sym_word] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2990),
    [anon_sym_class] = ACTIONS(2992),
    [anon_sym_struct] = ACTIONS(2994),
    [anon_sym_union] = ACTIONS(2996),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_GT2] = ACTIONS(3062),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [304] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [305] = {
    [sym_identifier] = ACTIONS(3064),
    [aux_sym_preproc_include_token1] = ACTIONS(3064),
    [aux_sym_preproc_def_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token2] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [aux_sym_preproc_else_token1] = ACTIONS(3064),
    [aux_sym_preproc_elif_token1] = ACTIONS(3064),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3064),
    [anon_sym_LPAREN2] = ACTIONS(3066),
    [anon_sym_BANG] = ACTIONS(3066),
    [anon_sym_TILDE] = ACTIONS(3066),
    [anon_sym_DASH] = ACTIONS(3064),
    [anon_sym_PLUS] = ACTIONS(3064),
    [anon_sym_STAR] = ACTIONS(3066),
    [anon_sym_AMP_AMP] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3064),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym___extension__] = ACTIONS(3064),
    [anon_sym_typedef] = ACTIONS(3064),
    [anon_sym_extern] = ACTIONS(3064),
    [anon_sym___attribute__] = ACTIONS(3064),
    [anon_sym_COLON_COLON] = ACTIONS(3066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3066),
    [anon_sym___declspec] = ACTIONS(3064),
    [anon_sym___based] = ACTIONS(3064),
    [anon_sym___cdecl] = ACTIONS(3064),
    [anon_sym___clrcall] = ACTIONS(3064),
    [anon_sym___stdcall] = ACTIONS(3064),
    [anon_sym___fastcall] = ACTIONS(3064),
    [anon_sym___thiscall] = ACTIONS(3064),
    [anon_sym___vectorcall] = ACTIONS(3064),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_signed] = ACTIONS(3064),
    [anon_sym_unsigned] = ACTIONS(3064),
    [anon_sym_long] = ACTIONS(3064),
    [anon_sym_short] = ACTIONS(3064),
    [anon_sym_LBRACK] = ACTIONS(3064),
    [anon_sym_static] = ACTIONS(3064),
    [anon_sym_register] = ACTIONS(3064),
    [anon_sym_inline] = ACTIONS(3064),
    [anon_sym___inline] = ACTIONS(3064),
    [anon_sym___inline__] = ACTIONS(3064),
    [anon_sym___forceinline] = ACTIONS(3064),
    [anon_sym_thread_local] = ACTIONS(3064),
    [anon_sym___thread] = ACTIONS(3064),
    [anon_sym_const] = ACTIONS(3064),
    [anon_sym_constexpr] = ACTIONS(3064),
    [anon_sym_volatile] = ACTIONS(3064),
    [anon_sym_restrict] = ACTIONS(3064),
    [anon_sym___restrict__] = ACTIONS(3064),
    [anon_sym__Atomic] = ACTIONS(3064),
    [anon_sym__Noreturn] = ACTIONS(3064),
    [anon_sym_noreturn] = ACTIONS(3064),
    [anon_sym_mutable] = ACTIONS(3064),
    [anon_sym_constinit] = ACTIONS(3064),
    [anon_sym_consteval] = ACTIONS(3064),
    [anon_sym_PROGMEM] = ACTIONS(3064),
    [aux_sym_primitive_type_token1] = ACTIONS(3064),
    [anon_sym_byte] = ACTIONS(3064),
    [anon_sym_word] = ACTIONS(3064),
    [anon_sym_enum] = ACTIONS(3064),
    [anon_sym_class] = ACTIONS(3064),
    [anon_sym_struct] = ACTIONS(3064),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_if] = ACTIONS(3064),
    [anon_sym_else] = ACTIONS(3064),
    [anon_sym_switch] = ACTIONS(3064),
    [anon_sym_case] = ACTIONS(3064),
    [anon_sym_default] = ACTIONS(3064),
    [anon_sym_while] = ACTIONS(3064),
    [anon_sym_do] = ACTIONS(3064),
    [anon_sym_for] = ACTIONS(3064),
    [anon_sym_return] = ACTIONS(3064),
    [anon_sym_break] = ACTIONS(3064),
    [anon_sym_continue] = ACTIONS(3064),
    [anon_sym_goto] = ACTIONS(3064),
    [anon_sym___try] = ACTIONS(3064),
    [anon_sym___leave] = ACTIONS(3064),
    [anon_sym_not] = ACTIONS(3064),
    [anon_sym_compl] = ACTIONS(3064),
    [anon_sym_DASH_DASH] = ACTIONS(3066),
    [anon_sym_PLUS_PLUS] = ACTIONS(3066),
    [anon_sym_sizeof] = ACTIONS(3064),
    [anon_sym___alignof__] = ACTIONS(3064),
    [anon_sym___alignof] = ACTIONS(3064),
    [anon_sym__alignof] = ACTIONS(3064),
    [anon_sym_alignof] = ACTIONS(3064),
    [anon_sym__Alignof] = ACTIONS(3064),
    [anon_sym_offsetof] = ACTIONS(3064),
    [anon_sym__Generic] = ACTIONS(3064),
    [anon_sym_asm] = ACTIONS(3064),
    [anon_sym___asm__] = ACTIONS(3064),
    [aux_sym_number_literal_token1] = ACTIONS(3066),
    [aux_sym_number_literal_token2] = ACTIONS(3064),
    [anon_sym_L_SQUOTE] = ACTIONS(3066),
    [anon_sym_u_SQUOTE] = ACTIONS(3066),
    [anon_sym_U_SQUOTE] = ACTIONS(3066),
    [anon_sym_u8_SQUOTE] = ACTIONS(3066),
    [anon_sym_SQUOTE] = ACTIONS(3066),
    [anon_sym_L_DQUOTE] = ACTIONS(3066),
    [anon_sym_u_DQUOTE] = ACTIONS(3066),
    [anon_sym_U_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8_DQUOTE] = ACTIONS(3066),
    [anon_sym_DQUOTE] = ACTIONS(3066),
    [sym_true] = ACTIONS(3064),
    [sym_false] = ACTIONS(3064),
    [anon_sym_NULL] = ACTIONS(3064),
    [anon_sym_nullptr] = ACTIONS(3064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3064),
    [anon_sym_decltype] = ACTIONS(3064),
    [anon_sym_virtual] = ACTIONS(3064),
    [anon_sym_alignas] = ACTIONS(3064),
    [anon_sym_explicit] = ACTIONS(3064),
    [anon_sym_typename] = ACTIONS(3064),
    [anon_sym_template] = ACTIONS(3064),
    [anon_sym_operator] = ACTIONS(3064),
    [anon_sym_try] = ACTIONS(3064),
    [anon_sym_delete] = ACTIONS(3064),
    [anon_sym_throw] = ACTIONS(3064),
    [anon_sym_namespace] = ACTIONS(3064),
    [anon_sym_using] = ACTIONS(3064),
    [anon_sym_static_assert] = ACTIONS(3064),
    [anon_sym_concept] = ACTIONS(3064),
    [anon_sym_co_return] = ACTIONS(3064),
    [anon_sym_co_yield] = ACTIONS(3064),
    [anon_sym_R_DQUOTE] = ACTIONS(3066),
    [anon_sym_LR_DQUOTE] = ACTIONS(3066),
    [anon_sym_uR_DQUOTE] = ACTIONS(3066),
    [anon_sym_UR_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3066),
    [anon_sym_co_await] = ACTIONS(3064),
    [anon_sym_new] = ACTIONS(3064),
    [anon_sym_requires] = ACTIONS(3064),
    [sym_this] = ACTIONS(3064),
  },
  [306] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [307] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [308] = {
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_include_token1] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token2] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [aux_sym_preproc_else_token1] = ACTIONS(3068),
    [aux_sym_preproc_elif_token1] = ACTIONS(3068),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_BANG] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_DASH] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym___cdecl] = ACTIONS(3068),
    [anon_sym___clrcall] = ACTIONS(3068),
    [anon_sym___stdcall] = ACTIONS(3068),
    [anon_sym___fastcall] = ACTIONS(3068),
    [anon_sym___thiscall] = ACTIONS(3068),
    [anon_sym___vectorcall] = ACTIONS(3068),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_PROGMEM] = ACTIONS(3068),
    [aux_sym_primitive_type_token1] = ACTIONS(3068),
    [anon_sym_byte] = ACTIONS(3068),
    [anon_sym_word] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3068),
    [anon_sym_else] = ACTIONS(3068),
    [anon_sym_switch] = ACTIONS(3068),
    [anon_sym_case] = ACTIONS(3068),
    [anon_sym_default] = ACTIONS(3068),
    [anon_sym_while] = ACTIONS(3068),
    [anon_sym_do] = ACTIONS(3068),
    [anon_sym_for] = ACTIONS(3068),
    [anon_sym_return] = ACTIONS(3068),
    [anon_sym_break] = ACTIONS(3068),
    [anon_sym_continue] = ACTIONS(3068),
    [anon_sym_goto] = ACTIONS(3068),
    [anon_sym___try] = ACTIONS(3068),
    [anon_sym___leave] = ACTIONS(3068),
    [anon_sym_not] = ACTIONS(3068),
    [anon_sym_compl] = ACTIONS(3068),
    [anon_sym_DASH_DASH] = ACTIONS(3070),
    [anon_sym_PLUS_PLUS] = ACTIONS(3070),
    [anon_sym_sizeof] = ACTIONS(3068),
    [anon_sym___alignof__] = ACTIONS(3068),
    [anon_sym___alignof] = ACTIONS(3068),
    [anon_sym__alignof] = ACTIONS(3068),
    [anon_sym_alignof] = ACTIONS(3068),
    [anon_sym__Alignof] = ACTIONS(3068),
    [anon_sym_offsetof] = ACTIONS(3068),
    [anon_sym__Generic] = ACTIONS(3068),
    [anon_sym_asm] = ACTIONS(3068),
    [anon_sym___asm__] = ACTIONS(3068),
    [aux_sym_number_literal_token1] = ACTIONS(3070),
    [aux_sym_number_literal_token2] = ACTIONS(3068),
    [anon_sym_L_SQUOTE] = ACTIONS(3070),
    [anon_sym_u_SQUOTE] = ACTIONS(3070),
    [anon_sym_U_SQUOTE] = ACTIONS(3070),
    [anon_sym_u8_SQUOTE] = ACTIONS(3070),
    [anon_sym_SQUOTE] = ACTIONS(3070),
    [anon_sym_L_DQUOTE] = ACTIONS(3070),
    [anon_sym_u_DQUOTE] = ACTIONS(3070),
    [anon_sym_U_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8_DQUOTE] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3070),
    [sym_true] = ACTIONS(3068),
    [sym_false] = ACTIONS(3068),
    [anon_sym_NULL] = ACTIONS(3068),
    [anon_sym_nullptr] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_try] = ACTIONS(3068),
    [anon_sym_delete] = ACTIONS(3068),
    [anon_sym_throw] = ACTIONS(3068),
    [anon_sym_namespace] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
    [anon_sym_concept] = ACTIONS(3068),
    [anon_sym_co_return] = ACTIONS(3068),
    [anon_sym_co_yield] = ACTIONS(3068),
    [anon_sym_R_DQUOTE] = ACTIONS(3070),
    [anon_sym_LR_DQUOTE] = ACTIONS(3070),
    [anon_sym_uR_DQUOTE] = ACTIONS(3070),
    [anon_sym_UR_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3070),
    [anon_sym_co_await] = ACTIONS(3068),
    [anon_sym_new] = ACTIONS(3068),
    [anon_sym_requires] = ACTIONS(3068),
    [sym_this] = ACTIONS(3068),
  },
  [309] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [310] = {
    [sym_type_qualifier] = STATE(4556),
    [sym__type_specifier] = STATE(5703),
    [sym_sized_type_specifier] = STATE(3397),
    [sym_primitive_type] = STATE(5893),
    [sym_enum_specifier] = STATE(3397),
    [sym_struct_specifier] = STATE(3397),
    [sym_union_specifier] = STATE(3397),
    [sym__expression] = STATE(5151),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_type_descriptor] = STATE(7770),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_placeholder_type_specifier] = STATE(3397),
    [sym_decltype_auto] = STATE(3398),
    [sym_decltype] = STATE(3383),
    [sym_class_specifier] = STATE(3397),
    [sym__class_name] = STATE(8471),
    [sym_dependent_type] = STATE(3397),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_type_parameter_pack_expansion] = STATE(8082),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6473),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym_user_defined_literal] = STATE(4248),
    [aux_sym__type_definition_type_repeat1] = STATE(4556),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2986),
    [anon_sym_unsigned] = ACTIONS(2986),
    [anon_sym_long] = ACTIONS(2986),
    [anon_sym_short] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2988),
    [anon_sym_byte] = ACTIONS(2988),
    [anon_sym_word] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2990),
    [anon_sym_class] = ACTIONS(2992),
    [anon_sym_struct] = ACTIONS(2994),
    [anon_sym_union] = ACTIONS(2996),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_GT2] = ACTIONS(3076),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [311] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [312] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [313] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [314] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [315] = {
    [sym_identifier] = ACTIONS(3078),
    [aux_sym_preproc_include_token1] = ACTIONS(3078),
    [aux_sym_preproc_def_token1] = ACTIONS(3078),
    [aux_sym_preproc_if_token1] = ACTIONS(3078),
    [aux_sym_preproc_if_token2] = ACTIONS(3078),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3078),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3078),
    [aux_sym_preproc_else_token1] = ACTIONS(3078),
    [aux_sym_preproc_elif_token1] = ACTIONS(3078),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3078),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3078),
    [sym_preproc_directive] = ACTIONS(3078),
    [anon_sym_LPAREN2] = ACTIONS(3080),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_TILDE] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3078),
    [anon_sym_PLUS] = ACTIONS(3078),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3080),
    [anon_sym_AMP] = ACTIONS(3078),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym___extension__] = ACTIONS(3078),
    [anon_sym_typedef] = ACTIONS(3078),
    [anon_sym_extern] = ACTIONS(3078),
    [anon_sym___attribute__] = ACTIONS(3078),
    [anon_sym_COLON_COLON] = ACTIONS(3080),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3080),
    [anon_sym___declspec] = ACTIONS(3078),
    [anon_sym___based] = ACTIONS(3078),
    [anon_sym___cdecl] = ACTIONS(3078),
    [anon_sym___clrcall] = ACTIONS(3078),
    [anon_sym___stdcall] = ACTIONS(3078),
    [anon_sym___fastcall] = ACTIONS(3078),
    [anon_sym___thiscall] = ACTIONS(3078),
    [anon_sym___vectorcall] = ACTIONS(3078),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_signed] = ACTIONS(3078),
    [anon_sym_unsigned] = ACTIONS(3078),
    [anon_sym_long] = ACTIONS(3078),
    [anon_sym_short] = ACTIONS(3078),
    [anon_sym_LBRACK] = ACTIONS(3078),
    [anon_sym_static] = ACTIONS(3078),
    [anon_sym_register] = ACTIONS(3078),
    [anon_sym_inline] = ACTIONS(3078),
    [anon_sym___inline] = ACTIONS(3078),
    [anon_sym___inline__] = ACTIONS(3078),
    [anon_sym___forceinline] = ACTIONS(3078),
    [anon_sym_thread_local] = ACTIONS(3078),
    [anon_sym___thread] = ACTIONS(3078),
    [anon_sym_const] = ACTIONS(3078),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(3078),
    [anon_sym_restrict] = ACTIONS(3078),
    [anon_sym___restrict__] = ACTIONS(3078),
    [anon_sym__Atomic] = ACTIONS(3078),
    [anon_sym__Noreturn] = ACTIONS(3078),
    [anon_sym_noreturn] = ACTIONS(3078),
    [anon_sym_mutable] = ACTIONS(3078),
    [anon_sym_constinit] = ACTIONS(3078),
    [anon_sym_consteval] = ACTIONS(3078),
    [anon_sym_PROGMEM] = ACTIONS(3078),
    [aux_sym_primitive_type_token1] = ACTIONS(3078),
    [anon_sym_byte] = ACTIONS(3078),
    [anon_sym_word] = ACTIONS(3078),
    [anon_sym_enum] = ACTIONS(3078),
    [anon_sym_class] = ACTIONS(3078),
    [anon_sym_struct] = ACTIONS(3078),
    [anon_sym_union] = ACTIONS(3078),
    [anon_sym_if] = ACTIONS(3078),
    [anon_sym_else] = ACTIONS(3078),
    [anon_sym_switch] = ACTIONS(3078),
    [anon_sym_case] = ACTIONS(3078),
    [anon_sym_default] = ACTIONS(3078),
    [anon_sym_while] = ACTIONS(3078),
    [anon_sym_do] = ACTIONS(3078),
    [anon_sym_for] = ACTIONS(3078),
    [anon_sym_return] = ACTIONS(3078),
    [anon_sym_break] = ACTIONS(3078),
    [anon_sym_continue] = ACTIONS(3078),
    [anon_sym_goto] = ACTIONS(3078),
    [anon_sym___try] = ACTIONS(3078),
    [anon_sym___leave] = ACTIONS(3078),
    [anon_sym_not] = ACTIONS(3078),
    [anon_sym_compl] = ACTIONS(3078),
    [anon_sym_DASH_DASH] = ACTIONS(3080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3080),
    [anon_sym_sizeof] = ACTIONS(3078),
    [anon_sym___alignof__] = ACTIONS(3078),
    [anon_sym___alignof] = ACTIONS(3078),
    [anon_sym__alignof] = ACTIONS(3078),
    [anon_sym_alignof] = ACTIONS(3078),
    [anon_sym__Alignof] = ACTIONS(3078),
    [anon_sym_offsetof] = ACTIONS(3078),
    [anon_sym__Generic] = ACTIONS(3078),
    [anon_sym_asm] = ACTIONS(3078),
    [anon_sym___asm__] = ACTIONS(3078),
    [aux_sym_number_literal_token1] = ACTIONS(3080),
    [aux_sym_number_literal_token2] = ACTIONS(3078),
    [anon_sym_L_SQUOTE] = ACTIONS(3080),
    [anon_sym_u_SQUOTE] = ACTIONS(3080),
    [anon_sym_U_SQUOTE] = ACTIONS(3080),
    [anon_sym_u8_SQUOTE] = ACTIONS(3080),
    [anon_sym_SQUOTE] = ACTIONS(3080),
    [anon_sym_L_DQUOTE] = ACTIONS(3080),
    [anon_sym_u_DQUOTE] = ACTIONS(3080),
    [anon_sym_U_DQUOTE] = ACTIONS(3080),
    [anon_sym_u8_DQUOTE] = ACTIONS(3080),
    [anon_sym_DQUOTE] = ACTIONS(3080),
    [sym_true] = ACTIONS(3078),
    [sym_false] = ACTIONS(3078),
    [anon_sym_NULL] = ACTIONS(3078),
    [anon_sym_nullptr] = ACTIONS(3078),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3078),
    [anon_sym_decltype] = ACTIONS(3078),
    [anon_sym_virtual] = ACTIONS(3078),
    [anon_sym_alignas] = ACTIONS(3078),
    [anon_sym_explicit] = ACTIONS(3078),
    [anon_sym_typename] = ACTIONS(3078),
    [anon_sym_template] = ACTIONS(3078),
    [anon_sym_operator] = ACTIONS(3078),
    [anon_sym_try] = ACTIONS(3078),
    [anon_sym_delete] = ACTIONS(3078),
    [anon_sym_throw] = ACTIONS(3078),
    [anon_sym_namespace] = ACTIONS(3078),
    [anon_sym_using] = ACTIONS(3078),
    [anon_sym_static_assert] = ACTIONS(3078),
    [anon_sym_concept] = ACTIONS(3078),
    [anon_sym_co_return] = ACTIONS(3078),
    [anon_sym_co_yield] = ACTIONS(3078),
    [anon_sym_R_DQUOTE] = ACTIONS(3080),
    [anon_sym_LR_DQUOTE] = ACTIONS(3080),
    [anon_sym_uR_DQUOTE] = ACTIONS(3080),
    [anon_sym_UR_DQUOTE] = ACTIONS(3080),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3080),
    [anon_sym_co_await] = ACTIONS(3078),
    [anon_sym_new] = ACTIONS(3078),
    [anon_sym_requires] = ACTIONS(3078),
    [sym_this] = ACTIONS(3078),
  },
  [316] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_include_token1] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token2] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [aux_sym_preproc_else_token1] = ACTIONS(3082),
    [aux_sym_preproc_elif_token1] = ACTIONS(3082),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym___cdecl] = ACTIONS(3082),
    [anon_sym___clrcall] = ACTIONS(3082),
    [anon_sym___stdcall] = ACTIONS(3082),
    [anon_sym___fastcall] = ACTIONS(3082),
    [anon_sym___thiscall] = ACTIONS(3082),
    [anon_sym___vectorcall] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_else] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_goto] = ACTIONS(3082),
    [anon_sym___try] = ACTIONS(3082),
    [anon_sym___leave] = ACTIONS(3082),
    [anon_sym_not] = ACTIONS(3082),
    [anon_sym_compl] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_sizeof] = ACTIONS(3082),
    [anon_sym___alignof__] = ACTIONS(3082),
    [anon_sym___alignof] = ACTIONS(3082),
    [anon_sym__alignof] = ACTIONS(3082),
    [anon_sym_alignof] = ACTIONS(3082),
    [anon_sym__Alignof] = ACTIONS(3082),
    [anon_sym_offsetof] = ACTIONS(3082),
    [anon_sym__Generic] = ACTIONS(3082),
    [anon_sym_asm] = ACTIONS(3082),
    [anon_sym___asm__] = ACTIONS(3082),
    [aux_sym_number_literal_token1] = ACTIONS(3084),
    [aux_sym_number_literal_token2] = ACTIONS(3082),
    [anon_sym_L_SQUOTE] = ACTIONS(3084),
    [anon_sym_u_SQUOTE] = ACTIONS(3084),
    [anon_sym_U_SQUOTE] = ACTIONS(3084),
    [anon_sym_u8_SQUOTE] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_L_DQUOTE] = ACTIONS(3084),
    [anon_sym_u_DQUOTE] = ACTIONS(3084),
    [anon_sym_U_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8_DQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [anon_sym_NULL] = ACTIONS(3082),
    [anon_sym_nullptr] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
    [anon_sym_concept] = ACTIONS(3082),
    [anon_sym_co_return] = ACTIONS(3082),
    [anon_sym_co_yield] = ACTIONS(3082),
    [anon_sym_R_DQUOTE] = ACTIONS(3084),
    [anon_sym_LR_DQUOTE] = ACTIONS(3084),
    [anon_sym_uR_DQUOTE] = ACTIONS(3084),
    [anon_sym_UR_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3084),
    [anon_sym_co_await] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_requires] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
  },
  [317] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [318] = {
    [sym_identifier] = ACTIONS(3086),
    [aux_sym_preproc_include_token1] = ACTIONS(3086),
    [aux_sym_preproc_def_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token2] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3086),
    [aux_sym_preproc_else_token1] = ACTIONS(3086),
    [aux_sym_preproc_elif_token1] = ACTIONS(3086),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3086),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3086),
    [sym_preproc_directive] = ACTIONS(3086),
    [anon_sym_LPAREN2] = ACTIONS(3088),
    [anon_sym_BANG] = ACTIONS(3088),
    [anon_sym_TILDE] = ACTIONS(3088),
    [anon_sym_DASH] = ACTIONS(3086),
    [anon_sym_PLUS] = ACTIONS(3086),
    [anon_sym_STAR] = ACTIONS(3088),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym_SEMI] = ACTIONS(3088),
    [anon_sym___extension__] = ACTIONS(3086),
    [anon_sym_typedef] = ACTIONS(3086),
    [anon_sym_extern] = ACTIONS(3086),
    [anon_sym___attribute__] = ACTIONS(3086),
    [anon_sym_COLON_COLON] = ACTIONS(3088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3088),
    [anon_sym___declspec] = ACTIONS(3086),
    [anon_sym___based] = ACTIONS(3086),
    [anon_sym___cdecl] = ACTIONS(3086),
    [anon_sym___clrcall] = ACTIONS(3086),
    [anon_sym___stdcall] = ACTIONS(3086),
    [anon_sym___fastcall] = ACTIONS(3086),
    [anon_sym___thiscall] = ACTIONS(3086),
    [anon_sym___vectorcall] = ACTIONS(3086),
    [anon_sym_LBRACE] = ACTIONS(3088),
    [anon_sym_signed] = ACTIONS(3086),
    [anon_sym_unsigned] = ACTIONS(3086),
    [anon_sym_long] = ACTIONS(3086),
    [anon_sym_short] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(3086),
    [anon_sym_static] = ACTIONS(3086),
    [anon_sym_register] = ACTIONS(3086),
    [anon_sym_inline] = ACTIONS(3086),
    [anon_sym___inline] = ACTIONS(3086),
    [anon_sym___inline__] = ACTIONS(3086),
    [anon_sym___forceinline] = ACTIONS(3086),
    [anon_sym_thread_local] = ACTIONS(3086),
    [anon_sym___thread] = ACTIONS(3086),
    [anon_sym_const] = ACTIONS(3086),
    [anon_sym_constexpr] = ACTIONS(3086),
    [anon_sym_volatile] = ACTIONS(3086),
    [anon_sym_restrict] = ACTIONS(3086),
    [anon_sym___restrict__] = ACTIONS(3086),
    [anon_sym__Atomic] = ACTIONS(3086),
    [anon_sym__Noreturn] = ACTIONS(3086),
    [anon_sym_noreturn] = ACTIONS(3086),
    [anon_sym_mutable] = ACTIONS(3086),
    [anon_sym_constinit] = ACTIONS(3086),
    [anon_sym_consteval] = ACTIONS(3086),
    [anon_sym_PROGMEM] = ACTIONS(3086),
    [aux_sym_primitive_type_token1] = ACTIONS(3086),
    [anon_sym_byte] = ACTIONS(3086),
    [anon_sym_word] = ACTIONS(3086),
    [anon_sym_enum] = ACTIONS(3086),
    [anon_sym_class] = ACTIONS(3086),
    [anon_sym_struct] = ACTIONS(3086),
    [anon_sym_union] = ACTIONS(3086),
    [anon_sym_if] = ACTIONS(3086),
    [anon_sym_else] = ACTIONS(3086),
    [anon_sym_switch] = ACTIONS(3086),
    [anon_sym_case] = ACTIONS(3086),
    [anon_sym_default] = ACTIONS(3086),
    [anon_sym_while] = ACTIONS(3086),
    [anon_sym_do] = ACTIONS(3086),
    [anon_sym_for] = ACTIONS(3086),
    [anon_sym_return] = ACTIONS(3086),
    [anon_sym_break] = ACTIONS(3086),
    [anon_sym_continue] = ACTIONS(3086),
    [anon_sym_goto] = ACTIONS(3086),
    [anon_sym___try] = ACTIONS(3086),
    [anon_sym___leave] = ACTIONS(3086),
    [anon_sym_not] = ACTIONS(3086),
    [anon_sym_compl] = ACTIONS(3086),
    [anon_sym_DASH_DASH] = ACTIONS(3088),
    [anon_sym_PLUS_PLUS] = ACTIONS(3088),
    [anon_sym_sizeof] = ACTIONS(3086),
    [anon_sym___alignof__] = ACTIONS(3086),
    [anon_sym___alignof] = ACTIONS(3086),
    [anon_sym__alignof] = ACTIONS(3086),
    [anon_sym_alignof] = ACTIONS(3086),
    [anon_sym__Alignof] = ACTIONS(3086),
    [anon_sym_offsetof] = ACTIONS(3086),
    [anon_sym__Generic] = ACTIONS(3086),
    [anon_sym_asm] = ACTIONS(3086),
    [anon_sym___asm__] = ACTIONS(3086),
    [aux_sym_number_literal_token1] = ACTIONS(3088),
    [aux_sym_number_literal_token2] = ACTIONS(3086),
    [anon_sym_L_SQUOTE] = ACTIONS(3088),
    [anon_sym_u_SQUOTE] = ACTIONS(3088),
    [anon_sym_U_SQUOTE] = ACTIONS(3088),
    [anon_sym_u8_SQUOTE] = ACTIONS(3088),
    [anon_sym_SQUOTE] = ACTIONS(3088),
    [anon_sym_L_DQUOTE] = ACTIONS(3088),
    [anon_sym_u_DQUOTE] = ACTIONS(3088),
    [anon_sym_U_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8_DQUOTE] = ACTIONS(3088),
    [anon_sym_DQUOTE] = ACTIONS(3088),
    [sym_true] = ACTIONS(3086),
    [sym_false] = ACTIONS(3086),
    [anon_sym_NULL] = ACTIONS(3086),
    [anon_sym_nullptr] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3086),
    [anon_sym_decltype] = ACTIONS(3086),
    [anon_sym_virtual] = ACTIONS(3086),
    [anon_sym_alignas] = ACTIONS(3086),
    [anon_sym_explicit] = ACTIONS(3086),
    [anon_sym_typename] = ACTIONS(3086),
    [anon_sym_template] = ACTIONS(3086),
    [anon_sym_operator] = ACTIONS(3086),
    [anon_sym_try] = ACTIONS(3086),
    [anon_sym_delete] = ACTIONS(3086),
    [anon_sym_throw] = ACTIONS(3086),
    [anon_sym_namespace] = ACTIONS(3086),
    [anon_sym_using] = ACTIONS(3086),
    [anon_sym_static_assert] = ACTIONS(3086),
    [anon_sym_concept] = ACTIONS(3086),
    [anon_sym_co_return] = ACTIONS(3086),
    [anon_sym_co_yield] = ACTIONS(3086),
    [anon_sym_R_DQUOTE] = ACTIONS(3088),
    [anon_sym_LR_DQUOTE] = ACTIONS(3088),
    [anon_sym_uR_DQUOTE] = ACTIONS(3088),
    [anon_sym_UR_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3088),
    [anon_sym_co_await] = ACTIONS(3086),
    [anon_sym_new] = ACTIONS(3086),
    [anon_sym_requires] = ACTIONS(3086),
    [sym_this] = ACTIONS(3086),
  },
  [319] = {
    [sym_type_qualifier] = STATE(4556),
    [sym__type_specifier] = STATE(5703),
    [sym_sized_type_specifier] = STATE(3397),
    [sym_primitive_type] = STATE(5893),
    [sym_enum_specifier] = STATE(3397),
    [sym_struct_specifier] = STATE(3397),
    [sym_union_specifier] = STATE(3397),
    [sym__expression] = STATE(5191),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_type_descriptor] = STATE(7917),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_placeholder_type_specifier] = STATE(3397),
    [sym_decltype_auto] = STATE(3398),
    [sym_decltype] = STATE(3383),
    [sym_class_specifier] = STATE(3397),
    [sym__class_name] = STATE(8471),
    [sym_dependent_type] = STATE(3397),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_type_parameter_pack_expansion] = STATE(7967),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6473),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym_user_defined_literal] = STATE(4248),
    [aux_sym__type_definition_type_repeat1] = STATE(4556),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2986),
    [anon_sym_unsigned] = ACTIONS(2986),
    [anon_sym_long] = ACTIONS(2986),
    [anon_sym_short] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2988),
    [anon_sym_byte] = ACTIONS(2988),
    [anon_sym_word] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2990),
    [anon_sym_class] = ACTIONS(2992),
    [anon_sym_struct] = ACTIONS(2994),
    [anon_sym_union] = ACTIONS(2996),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_GT2] = ACTIONS(3090),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [320] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [321] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [322] = {
    [sym_identifier] = ACTIONS(2869),
    [aux_sym_preproc_include_token1] = ACTIONS(2869),
    [aux_sym_preproc_def_token1] = ACTIONS(2869),
    [aux_sym_preproc_if_token1] = ACTIONS(2869),
    [aux_sym_preproc_if_token2] = ACTIONS(2869),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2869),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2869),
    [aux_sym_preproc_else_token1] = ACTIONS(2869),
    [aux_sym_preproc_elif_token1] = ACTIONS(2869),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2869),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2869),
    [sym_preproc_directive] = ACTIONS(2869),
    [anon_sym_LPAREN2] = ACTIONS(2874),
    [anon_sym_BANG] = ACTIONS(2874),
    [anon_sym_TILDE] = ACTIONS(2874),
    [anon_sym_DASH] = ACTIONS(2869),
    [anon_sym_PLUS] = ACTIONS(2869),
    [anon_sym_STAR] = ACTIONS(2874),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2869),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym___extension__] = ACTIONS(2869),
    [anon_sym_typedef] = ACTIONS(2869),
    [anon_sym_extern] = ACTIONS(2869),
    [anon_sym___attribute__] = ACTIONS(2869),
    [anon_sym_COLON_COLON] = ACTIONS(2874),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2874),
    [anon_sym___declspec] = ACTIONS(2869),
    [anon_sym___based] = ACTIONS(2869),
    [anon_sym___cdecl] = ACTIONS(2869),
    [anon_sym___clrcall] = ACTIONS(2869),
    [anon_sym___stdcall] = ACTIONS(2869),
    [anon_sym___fastcall] = ACTIONS(2869),
    [anon_sym___thiscall] = ACTIONS(2869),
    [anon_sym___vectorcall] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2874),
    [anon_sym_signed] = ACTIONS(2869),
    [anon_sym_unsigned] = ACTIONS(2869),
    [anon_sym_long] = ACTIONS(2869),
    [anon_sym_short] = ACTIONS(2869),
    [anon_sym_LBRACK] = ACTIONS(2869),
    [anon_sym_static] = ACTIONS(2869),
    [anon_sym_register] = ACTIONS(2869),
    [anon_sym_inline] = ACTIONS(2869),
    [anon_sym___inline] = ACTIONS(2869),
    [anon_sym___inline__] = ACTIONS(2869),
    [anon_sym___forceinline] = ACTIONS(2869),
    [anon_sym_thread_local] = ACTIONS(2869),
    [anon_sym___thread] = ACTIONS(2869),
    [anon_sym_const] = ACTIONS(2869),
    [anon_sym_constexpr] = ACTIONS(2869),
    [anon_sym_volatile] = ACTIONS(2869),
    [anon_sym_restrict] = ACTIONS(2869),
    [anon_sym___restrict__] = ACTIONS(2869),
    [anon_sym__Atomic] = ACTIONS(2869),
    [anon_sym__Noreturn] = ACTIONS(2869),
    [anon_sym_noreturn] = ACTIONS(2869),
    [anon_sym_mutable] = ACTIONS(2869),
    [anon_sym_constinit] = ACTIONS(2869),
    [anon_sym_consteval] = ACTIONS(2869),
    [anon_sym_PROGMEM] = ACTIONS(2869),
    [aux_sym_primitive_type_token1] = ACTIONS(2869),
    [anon_sym_byte] = ACTIONS(2869),
    [anon_sym_word] = ACTIONS(2869),
    [anon_sym_enum] = ACTIONS(2869),
    [anon_sym_class] = ACTIONS(2869),
    [anon_sym_struct] = ACTIONS(2869),
    [anon_sym_union] = ACTIONS(2869),
    [anon_sym_if] = ACTIONS(2869),
    [anon_sym_else] = ACTIONS(2869),
    [anon_sym_switch] = ACTIONS(2869),
    [anon_sym_case] = ACTIONS(2869),
    [anon_sym_default] = ACTIONS(2869),
    [anon_sym_while] = ACTIONS(2869),
    [anon_sym_do] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2869),
    [anon_sym_return] = ACTIONS(2869),
    [anon_sym_break] = ACTIONS(2869),
    [anon_sym_continue] = ACTIONS(2869),
    [anon_sym_goto] = ACTIONS(2869),
    [anon_sym___try] = ACTIONS(2869),
    [anon_sym___leave] = ACTIONS(2869),
    [anon_sym_not] = ACTIONS(2869),
    [anon_sym_compl] = ACTIONS(2869),
    [anon_sym_DASH_DASH] = ACTIONS(2874),
    [anon_sym_PLUS_PLUS] = ACTIONS(2874),
    [anon_sym_sizeof] = ACTIONS(2869),
    [anon_sym___alignof__] = ACTIONS(2869),
    [anon_sym___alignof] = ACTIONS(2869),
    [anon_sym__alignof] = ACTIONS(2869),
    [anon_sym_alignof] = ACTIONS(2869),
    [anon_sym__Alignof] = ACTIONS(2869),
    [anon_sym_offsetof] = ACTIONS(2869),
    [anon_sym__Generic] = ACTIONS(2869),
    [anon_sym_asm] = ACTIONS(2869),
    [anon_sym___asm__] = ACTIONS(2869),
    [aux_sym_number_literal_token1] = ACTIONS(2874),
    [aux_sym_number_literal_token2] = ACTIONS(2869),
    [anon_sym_L_SQUOTE] = ACTIONS(2874),
    [anon_sym_u_SQUOTE] = ACTIONS(2874),
    [anon_sym_U_SQUOTE] = ACTIONS(2874),
    [anon_sym_u8_SQUOTE] = ACTIONS(2874),
    [anon_sym_SQUOTE] = ACTIONS(2874),
    [anon_sym_L_DQUOTE] = ACTIONS(2874),
    [anon_sym_u_DQUOTE] = ACTIONS(2874),
    [anon_sym_U_DQUOTE] = ACTIONS(2874),
    [anon_sym_u8_DQUOTE] = ACTIONS(2874),
    [anon_sym_DQUOTE] = ACTIONS(2874),
    [sym_true] = ACTIONS(2869),
    [sym_false] = ACTIONS(2869),
    [anon_sym_NULL] = ACTIONS(2869),
    [anon_sym_nullptr] = ACTIONS(2869),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2869),
    [anon_sym_decltype] = ACTIONS(2869),
    [anon_sym_virtual] = ACTIONS(2869),
    [anon_sym_alignas] = ACTIONS(2869),
    [anon_sym_explicit] = ACTIONS(2869),
    [anon_sym_typename] = ACTIONS(2869),
    [anon_sym_template] = ACTIONS(2869),
    [anon_sym_operator] = ACTIONS(2869),
    [anon_sym_try] = ACTIONS(2869),
    [anon_sym_delete] = ACTIONS(2869),
    [anon_sym_throw] = ACTIONS(2869),
    [anon_sym_namespace] = ACTIONS(2869),
    [anon_sym_using] = ACTIONS(2869),
    [anon_sym_static_assert] = ACTIONS(2869),
    [anon_sym_concept] = ACTIONS(2869),
    [anon_sym_co_return] = ACTIONS(2869),
    [anon_sym_co_yield] = ACTIONS(2869),
    [anon_sym_R_DQUOTE] = ACTIONS(2874),
    [anon_sym_LR_DQUOTE] = ACTIONS(2874),
    [anon_sym_uR_DQUOTE] = ACTIONS(2874),
    [anon_sym_UR_DQUOTE] = ACTIONS(2874),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2874),
    [anon_sym_co_await] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2869),
    [sym_this] = ACTIONS(2869),
  },
  [323] = {
    [sym_identifier] = ACTIONS(3092),
    [aux_sym_preproc_include_token1] = ACTIONS(3092),
    [aux_sym_preproc_def_token1] = ACTIONS(3092),
    [aux_sym_preproc_if_token1] = ACTIONS(3092),
    [aux_sym_preproc_if_token2] = ACTIONS(3092),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3092),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3092),
    [aux_sym_preproc_else_token1] = ACTIONS(3092),
    [aux_sym_preproc_elif_token1] = ACTIONS(3092),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3092),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3092),
    [sym_preproc_directive] = ACTIONS(3092),
    [anon_sym_LPAREN2] = ACTIONS(3094),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_TILDE] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_SEMI] = ACTIONS(3094),
    [anon_sym___extension__] = ACTIONS(3092),
    [anon_sym_typedef] = ACTIONS(3092),
    [anon_sym_extern] = ACTIONS(3092),
    [anon_sym___attribute__] = ACTIONS(3092),
    [anon_sym_COLON_COLON] = ACTIONS(3094),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3094),
    [anon_sym___declspec] = ACTIONS(3092),
    [anon_sym___based] = ACTIONS(3092),
    [anon_sym___cdecl] = ACTIONS(3092),
    [anon_sym___clrcall] = ACTIONS(3092),
    [anon_sym___stdcall] = ACTIONS(3092),
    [anon_sym___fastcall] = ACTIONS(3092),
    [anon_sym___thiscall] = ACTIONS(3092),
    [anon_sym___vectorcall] = ACTIONS(3092),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_signed] = ACTIONS(3092),
    [anon_sym_unsigned] = ACTIONS(3092),
    [anon_sym_long] = ACTIONS(3092),
    [anon_sym_short] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_static] = ACTIONS(3092),
    [anon_sym_register] = ACTIONS(3092),
    [anon_sym_inline] = ACTIONS(3092),
    [anon_sym___inline] = ACTIONS(3092),
    [anon_sym___inline__] = ACTIONS(3092),
    [anon_sym___forceinline] = ACTIONS(3092),
    [anon_sym_thread_local] = ACTIONS(3092),
    [anon_sym___thread] = ACTIONS(3092),
    [anon_sym_const] = ACTIONS(3092),
    [anon_sym_constexpr] = ACTIONS(3092),
    [anon_sym_volatile] = ACTIONS(3092),
    [anon_sym_restrict] = ACTIONS(3092),
    [anon_sym___restrict__] = ACTIONS(3092),
    [anon_sym__Atomic] = ACTIONS(3092),
    [anon_sym__Noreturn] = ACTIONS(3092),
    [anon_sym_noreturn] = ACTIONS(3092),
    [anon_sym_mutable] = ACTIONS(3092),
    [anon_sym_constinit] = ACTIONS(3092),
    [anon_sym_consteval] = ACTIONS(3092),
    [anon_sym_PROGMEM] = ACTIONS(3092),
    [aux_sym_primitive_type_token1] = ACTIONS(3092),
    [anon_sym_byte] = ACTIONS(3092),
    [anon_sym_word] = ACTIONS(3092),
    [anon_sym_enum] = ACTIONS(3092),
    [anon_sym_class] = ACTIONS(3092),
    [anon_sym_struct] = ACTIONS(3092),
    [anon_sym_union] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_switch] = ACTIONS(3092),
    [anon_sym_case] = ACTIONS(3092),
    [anon_sym_default] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_break] = ACTIONS(3092),
    [anon_sym_continue] = ACTIONS(3092),
    [anon_sym_goto] = ACTIONS(3092),
    [anon_sym___try] = ACTIONS(3092),
    [anon_sym___leave] = ACTIONS(3092),
    [anon_sym_not] = ACTIONS(3092),
    [anon_sym_compl] = ACTIONS(3092),
    [anon_sym_DASH_DASH] = ACTIONS(3094),
    [anon_sym_PLUS_PLUS] = ACTIONS(3094),
    [anon_sym_sizeof] = ACTIONS(3092),
    [anon_sym___alignof__] = ACTIONS(3092),
    [anon_sym___alignof] = ACTIONS(3092),
    [anon_sym__alignof] = ACTIONS(3092),
    [anon_sym_alignof] = ACTIONS(3092),
    [anon_sym__Alignof] = ACTIONS(3092),
    [anon_sym_offsetof] = ACTIONS(3092),
    [anon_sym__Generic] = ACTIONS(3092),
    [anon_sym_asm] = ACTIONS(3092),
    [anon_sym___asm__] = ACTIONS(3092),
    [aux_sym_number_literal_token1] = ACTIONS(3094),
    [aux_sym_number_literal_token2] = ACTIONS(3092),
    [anon_sym_L_SQUOTE] = ACTIONS(3094),
    [anon_sym_u_SQUOTE] = ACTIONS(3094),
    [anon_sym_U_SQUOTE] = ACTIONS(3094),
    [anon_sym_u8_SQUOTE] = ACTIONS(3094),
    [anon_sym_SQUOTE] = ACTIONS(3094),
    [anon_sym_L_DQUOTE] = ACTIONS(3094),
    [anon_sym_u_DQUOTE] = ACTIONS(3094),
    [anon_sym_U_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8_DQUOTE] = ACTIONS(3094),
    [anon_sym_DQUOTE] = ACTIONS(3094),
    [sym_true] = ACTIONS(3092),
    [sym_false] = ACTIONS(3092),
    [anon_sym_NULL] = ACTIONS(3092),
    [anon_sym_nullptr] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3092),
    [anon_sym_decltype] = ACTIONS(3092),
    [anon_sym_virtual] = ACTIONS(3092),
    [anon_sym_alignas] = ACTIONS(3092),
    [anon_sym_explicit] = ACTIONS(3092),
    [anon_sym_typename] = ACTIONS(3092),
    [anon_sym_template] = ACTIONS(3092),
    [anon_sym_operator] = ACTIONS(3092),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_delete] = ACTIONS(3092),
    [anon_sym_throw] = ACTIONS(3092),
    [anon_sym_namespace] = ACTIONS(3092),
    [anon_sym_using] = ACTIONS(3092),
    [anon_sym_static_assert] = ACTIONS(3092),
    [anon_sym_concept] = ACTIONS(3092),
    [anon_sym_co_return] = ACTIONS(3092),
    [anon_sym_co_yield] = ACTIONS(3092),
    [anon_sym_R_DQUOTE] = ACTIONS(3094),
    [anon_sym_LR_DQUOTE] = ACTIONS(3094),
    [anon_sym_uR_DQUOTE] = ACTIONS(3094),
    [anon_sym_UR_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3094),
    [anon_sym_co_await] = ACTIONS(3092),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_requires] = ACTIONS(3092),
    [sym_this] = ACTIONS(3092),
  },
  [324] = {
    [sym_identifier] = ACTIONS(3096),
    [aux_sym_preproc_include_token1] = ACTIONS(3096),
    [aux_sym_preproc_def_token1] = ACTIONS(3096),
    [aux_sym_preproc_if_token1] = ACTIONS(3096),
    [aux_sym_preproc_if_token2] = ACTIONS(3096),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3096),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3096),
    [aux_sym_preproc_else_token1] = ACTIONS(3096),
    [aux_sym_preproc_elif_token1] = ACTIONS(3096),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3096),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3096),
    [sym_preproc_directive] = ACTIONS(3096),
    [anon_sym_LPAREN2] = ACTIONS(3098),
    [anon_sym_BANG] = ACTIONS(3098),
    [anon_sym_TILDE] = ACTIONS(3098),
    [anon_sym_DASH] = ACTIONS(3096),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_STAR] = ACTIONS(3098),
    [anon_sym_AMP_AMP] = ACTIONS(3098),
    [anon_sym_AMP] = ACTIONS(3096),
    [anon_sym_SEMI] = ACTIONS(3098),
    [anon_sym___extension__] = ACTIONS(3096),
    [anon_sym_typedef] = ACTIONS(3096),
    [anon_sym_extern] = ACTIONS(3096),
    [anon_sym___attribute__] = ACTIONS(3096),
    [anon_sym_COLON_COLON] = ACTIONS(3098),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3098),
    [anon_sym___declspec] = ACTIONS(3096),
    [anon_sym___based] = ACTIONS(3096),
    [anon_sym___cdecl] = ACTIONS(3096),
    [anon_sym___clrcall] = ACTIONS(3096),
    [anon_sym___stdcall] = ACTIONS(3096),
    [anon_sym___fastcall] = ACTIONS(3096),
    [anon_sym___thiscall] = ACTIONS(3096),
    [anon_sym___vectorcall] = ACTIONS(3096),
    [anon_sym_LBRACE] = ACTIONS(3098),
    [anon_sym_signed] = ACTIONS(3096),
    [anon_sym_unsigned] = ACTIONS(3096),
    [anon_sym_long] = ACTIONS(3096),
    [anon_sym_short] = ACTIONS(3096),
    [anon_sym_LBRACK] = ACTIONS(3096),
    [anon_sym_static] = ACTIONS(3096),
    [anon_sym_register] = ACTIONS(3096),
    [anon_sym_inline] = ACTIONS(3096),
    [anon_sym___inline] = ACTIONS(3096),
    [anon_sym___inline__] = ACTIONS(3096),
    [anon_sym___forceinline] = ACTIONS(3096),
    [anon_sym_thread_local] = ACTIONS(3096),
    [anon_sym___thread] = ACTIONS(3096),
    [anon_sym_const] = ACTIONS(3096),
    [anon_sym_constexpr] = ACTIONS(3096),
    [anon_sym_volatile] = ACTIONS(3096),
    [anon_sym_restrict] = ACTIONS(3096),
    [anon_sym___restrict__] = ACTIONS(3096),
    [anon_sym__Atomic] = ACTIONS(3096),
    [anon_sym__Noreturn] = ACTIONS(3096),
    [anon_sym_noreturn] = ACTIONS(3096),
    [anon_sym_mutable] = ACTIONS(3096),
    [anon_sym_constinit] = ACTIONS(3096),
    [anon_sym_consteval] = ACTIONS(3096),
    [anon_sym_PROGMEM] = ACTIONS(3096),
    [aux_sym_primitive_type_token1] = ACTIONS(3096),
    [anon_sym_byte] = ACTIONS(3096),
    [anon_sym_word] = ACTIONS(3096),
    [anon_sym_enum] = ACTIONS(3096),
    [anon_sym_class] = ACTIONS(3096),
    [anon_sym_struct] = ACTIONS(3096),
    [anon_sym_union] = ACTIONS(3096),
    [anon_sym_if] = ACTIONS(3096),
    [anon_sym_else] = ACTIONS(3096),
    [anon_sym_switch] = ACTIONS(3096),
    [anon_sym_case] = ACTIONS(3096),
    [anon_sym_default] = ACTIONS(3096),
    [anon_sym_while] = ACTIONS(3096),
    [anon_sym_do] = ACTIONS(3096),
    [anon_sym_for] = ACTIONS(3096),
    [anon_sym_return] = ACTIONS(3096),
    [anon_sym_break] = ACTIONS(3096),
    [anon_sym_continue] = ACTIONS(3096),
    [anon_sym_goto] = ACTIONS(3096),
    [anon_sym___try] = ACTIONS(3096),
    [anon_sym___leave] = ACTIONS(3096),
    [anon_sym_not] = ACTIONS(3096),
    [anon_sym_compl] = ACTIONS(3096),
    [anon_sym_DASH_DASH] = ACTIONS(3098),
    [anon_sym_PLUS_PLUS] = ACTIONS(3098),
    [anon_sym_sizeof] = ACTIONS(3096),
    [anon_sym___alignof__] = ACTIONS(3096),
    [anon_sym___alignof] = ACTIONS(3096),
    [anon_sym__alignof] = ACTIONS(3096),
    [anon_sym_alignof] = ACTIONS(3096),
    [anon_sym__Alignof] = ACTIONS(3096),
    [anon_sym_offsetof] = ACTIONS(3096),
    [anon_sym__Generic] = ACTIONS(3096),
    [anon_sym_asm] = ACTIONS(3096),
    [anon_sym___asm__] = ACTIONS(3096),
    [aux_sym_number_literal_token1] = ACTIONS(3098),
    [aux_sym_number_literal_token2] = ACTIONS(3096),
    [anon_sym_L_SQUOTE] = ACTIONS(3098),
    [anon_sym_u_SQUOTE] = ACTIONS(3098),
    [anon_sym_U_SQUOTE] = ACTIONS(3098),
    [anon_sym_u8_SQUOTE] = ACTIONS(3098),
    [anon_sym_SQUOTE] = ACTIONS(3098),
    [anon_sym_L_DQUOTE] = ACTIONS(3098),
    [anon_sym_u_DQUOTE] = ACTIONS(3098),
    [anon_sym_U_DQUOTE] = ACTIONS(3098),
    [anon_sym_u8_DQUOTE] = ACTIONS(3098),
    [anon_sym_DQUOTE] = ACTIONS(3098),
    [sym_true] = ACTIONS(3096),
    [sym_false] = ACTIONS(3096),
    [anon_sym_NULL] = ACTIONS(3096),
    [anon_sym_nullptr] = ACTIONS(3096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3096),
    [anon_sym_decltype] = ACTIONS(3096),
    [anon_sym_virtual] = ACTIONS(3096),
    [anon_sym_alignas] = ACTIONS(3096),
    [anon_sym_explicit] = ACTIONS(3096),
    [anon_sym_typename] = ACTIONS(3096),
    [anon_sym_template] = ACTIONS(3096),
    [anon_sym_operator] = ACTIONS(3096),
    [anon_sym_try] = ACTIONS(3096),
    [anon_sym_delete] = ACTIONS(3096),
    [anon_sym_throw] = ACTIONS(3096),
    [anon_sym_namespace] = ACTIONS(3096),
    [anon_sym_using] = ACTIONS(3096),
    [anon_sym_static_assert] = ACTIONS(3096),
    [anon_sym_concept] = ACTIONS(3096),
    [anon_sym_co_return] = ACTIONS(3096),
    [anon_sym_co_yield] = ACTIONS(3096),
    [anon_sym_R_DQUOTE] = ACTIONS(3098),
    [anon_sym_LR_DQUOTE] = ACTIONS(3098),
    [anon_sym_uR_DQUOTE] = ACTIONS(3098),
    [anon_sym_UR_DQUOTE] = ACTIONS(3098),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3098),
    [anon_sym_co_await] = ACTIONS(3096),
    [anon_sym_new] = ACTIONS(3096),
    [anon_sym_requires] = ACTIONS(3096),
    [sym_this] = ACTIONS(3096),
  },
  [325] = {
    [sym_type_qualifier] = STATE(4556),
    [sym__type_specifier] = STATE(5703),
    [sym_sized_type_specifier] = STATE(3397),
    [sym_primitive_type] = STATE(5893),
    [sym_enum_specifier] = STATE(3397),
    [sym_struct_specifier] = STATE(3397),
    [sym_union_specifier] = STATE(3397),
    [sym__expression] = STATE(5126),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_type_descriptor] = STATE(7714),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_placeholder_type_specifier] = STATE(3397),
    [sym_decltype_auto] = STATE(3398),
    [sym_decltype] = STATE(3383),
    [sym_class_specifier] = STATE(3397),
    [sym__class_name] = STATE(8471),
    [sym_dependent_type] = STATE(3397),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_type_parameter_pack_expansion] = STATE(8300),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6473),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym_user_defined_literal] = STATE(4248),
    [aux_sym__type_definition_type_repeat1] = STATE(4556),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2986),
    [anon_sym_unsigned] = ACTIONS(2986),
    [anon_sym_long] = ACTIONS(2986),
    [anon_sym_short] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2988),
    [anon_sym_byte] = ACTIONS(2988),
    [anon_sym_word] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2990),
    [anon_sym_class] = ACTIONS(2992),
    [anon_sym_struct] = ACTIONS(2994),
    [anon_sym_union] = ACTIONS(2996),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_GT2] = ACTIONS(3100),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [326] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [327] = {
    [sym_identifier] = ACTIONS(3102),
    [aux_sym_preproc_include_token1] = ACTIONS(3102),
    [aux_sym_preproc_def_token1] = ACTIONS(3102),
    [aux_sym_preproc_if_token1] = ACTIONS(3102),
    [aux_sym_preproc_if_token2] = ACTIONS(3102),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3102),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3102),
    [aux_sym_preproc_else_token1] = ACTIONS(3102),
    [aux_sym_preproc_elif_token1] = ACTIONS(3102),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3102),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3102),
    [sym_preproc_directive] = ACTIONS(3102),
    [anon_sym_LPAREN2] = ACTIONS(3104),
    [anon_sym_BANG] = ACTIONS(3104),
    [anon_sym_TILDE] = ACTIONS(3104),
    [anon_sym_DASH] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(3104),
    [anon_sym_AMP_AMP] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3102),
    [anon_sym_SEMI] = ACTIONS(3104),
    [anon_sym___extension__] = ACTIONS(3102),
    [anon_sym_typedef] = ACTIONS(3102),
    [anon_sym_extern] = ACTIONS(3102),
    [anon_sym___attribute__] = ACTIONS(3102),
    [anon_sym_COLON_COLON] = ACTIONS(3104),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3104),
    [anon_sym___declspec] = ACTIONS(3102),
    [anon_sym___based] = ACTIONS(3102),
    [anon_sym___cdecl] = ACTIONS(3102),
    [anon_sym___clrcall] = ACTIONS(3102),
    [anon_sym___stdcall] = ACTIONS(3102),
    [anon_sym___fastcall] = ACTIONS(3102),
    [anon_sym___thiscall] = ACTIONS(3102),
    [anon_sym___vectorcall] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3104),
    [anon_sym_signed] = ACTIONS(3102),
    [anon_sym_unsigned] = ACTIONS(3102),
    [anon_sym_long] = ACTIONS(3102),
    [anon_sym_short] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_static] = ACTIONS(3102),
    [anon_sym_register] = ACTIONS(3102),
    [anon_sym_inline] = ACTIONS(3102),
    [anon_sym___inline] = ACTIONS(3102),
    [anon_sym___inline__] = ACTIONS(3102),
    [anon_sym___forceinline] = ACTIONS(3102),
    [anon_sym_thread_local] = ACTIONS(3102),
    [anon_sym___thread] = ACTIONS(3102),
    [anon_sym_const] = ACTIONS(3102),
    [anon_sym_constexpr] = ACTIONS(3102),
    [anon_sym_volatile] = ACTIONS(3102),
    [anon_sym_restrict] = ACTIONS(3102),
    [anon_sym___restrict__] = ACTIONS(3102),
    [anon_sym__Atomic] = ACTIONS(3102),
    [anon_sym__Noreturn] = ACTIONS(3102),
    [anon_sym_noreturn] = ACTIONS(3102),
    [anon_sym_mutable] = ACTIONS(3102),
    [anon_sym_constinit] = ACTIONS(3102),
    [anon_sym_consteval] = ACTIONS(3102),
    [anon_sym_PROGMEM] = ACTIONS(3102),
    [aux_sym_primitive_type_token1] = ACTIONS(3102),
    [anon_sym_byte] = ACTIONS(3102),
    [anon_sym_word] = ACTIONS(3102),
    [anon_sym_enum] = ACTIONS(3102),
    [anon_sym_class] = ACTIONS(3102),
    [anon_sym_struct] = ACTIONS(3102),
    [anon_sym_union] = ACTIONS(3102),
    [anon_sym_if] = ACTIONS(3102),
    [anon_sym_else] = ACTIONS(3102),
    [anon_sym_switch] = ACTIONS(3102),
    [anon_sym_case] = ACTIONS(3102),
    [anon_sym_default] = ACTIONS(3102),
    [anon_sym_while] = ACTIONS(3102),
    [anon_sym_do] = ACTIONS(3102),
    [anon_sym_for] = ACTIONS(3102),
    [anon_sym_return] = ACTIONS(3102),
    [anon_sym_break] = ACTIONS(3102),
    [anon_sym_continue] = ACTIONS(3102),
    [anon_sym_goto] = ACTIONS(3102),
    [anon_sym___try] = ACTIONS(3102),
    [anon_sym___leave] = ACTIONS(3102),
    [anon_sym_not] = ACTIONS(3102),
    [anon_sym_compl] = ACTIONS(3102),
    [anon_sym_DASH_DASH] = ACTIONS(3104),
    [anon_sym_PLUS_PLUS] = ACTIONS(3104),
    [anon_sym_sizeof] = ACTIONS(3102),
    [anon_sym___alignof__] = ACTIONS(3102),
    [anon_sym___alignof] = ACTIONS(3102),
    [anon_sym__alignof] = ACTIONS(3102),
    [anon_sym_alignof] = ACTIONS(3102),
    [anon_sym__Alignof] = ACTIONS(3102),
    [anon_sym_offsetof] = ACTIONS(3102),
    [anon_sym__Generic] = ACTIONS(3102),
    [anon_sym_asm] = ACTIONS(3102),
    [anon_sym___asm__] = ACTIONS(3102),
    [aux_sym_number_literal_token1] = ACTIONS(3104),
    [aux_sym_number_literal_token2] = ACTIONS(3102),
    [anon_sym_L_SQUOTE] = ACTIONS(3104),
    [anon_sym_u_SQUOTE] = ACTIONS(3104),
    [anon_sym_U_SQUOTE] = ACTIONS(3104),
    [anon_sym_u8_SQUOTE] = ACTIONS(3104),
    [anon_sym_SQUOTE] = ACTIONS(3104),
    [anon_sym_L_DQUOTE] = ACTIONS(3104),
    [anon_sym_u_DQUOTE] = ACTIONS(3104),
    [anon_sym_U_DQUOTE] = ACTIONS(3104),
    [anon_sym_u8_DQUOTE] = ACTIONS(3104),
    [anon_sym_DQUOTE] = ACTIONS(3104),
    [sym_true] = ACTIONS(3102),
    [sym_false] = ACTIONS(3102),
    [anon_sym_NULL] = ACTIONS(3102),
    [anon_sym_nullptr] = ACTIONS(3102),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3102),
    [anon_sym_decltype] = ACTIONS(3102),
    [anon_sym_virtual] = ACTIONS(3102),
    [anon_sym_alignas] = ACTIONS(3102),
    [anon_sym_explicit] = ACTIONS(3102),
    [anon_sym_typename] = ACTIONS(3102),
    [anon_sym_template] = ACTIONS(3102),
    [anon_sym_operator] = ACTIONS(3102),
    [anon_sym_try] = ACTIONS(3102),
    [anon_sym_delete] = ACTIONS(3102),
    [anon_sym_throw] = ACTIONS(3102),
    [anon_sym_namespace] = ACTIONS(3102),
    [anon_sym_using] = ACTIONS(3102),
    [anon_sym_static_assert] = ACTIONS(3102),
    [anon_sym_concept] = ACTIONS(3102),
    [anon_sym_co_return] = ACTIONS(3102),
    [anon_sym_co_yield] = ACTIONS(3102),
    [anon_sym_R_DQUOTE] = ACTIONS(3104),
    [anon_sym_LR_DQUOTE] = ACTIONS(3104),
    [anon_sym_uR_DQUOTE] = ACTIONS(3104),
    [anon_sym_UR_DQUOTE] = ACTIONS(3104),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3104),
    [anon_sym_co_await] = ACTIONS(3102),
    [anon_sym_new] = ACTIONS(3102),
    [anon_sym_requires] = ACTIONS(3102),
    [sym_this] = ACTIONS(3102),
  },
  [328] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [329] = {
    [sym_type_qualifier] = STATE(4556),
    [sym__type_specifier] = STATE(5703),
    [sym_sized_type_specifier] = STATE(3397),
    [sym_primitive_type] = STATE(5893),
    [sym_enum_specifier] = STATE(3397),
    [sym_struct_specifier] = STATE(3397),
    [sym_union_specifier] = STATE(3397),
    [sym__expression] = STATE(5081),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_type_descriptor] = STATE(7672),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_placeholder_type_specifier] = STATE(3397),
    [sym_decltype_auto] = STATE(3398),
    [sym_decltype] = STATE(3383),
    [sym_class_specifier] = STATE(3397),
    [sym__class_name] = STATE(8471),
    [sym_dependent_type] = STATE(3397),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_type_parameter_pack_expansion] = STATE(8146),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6473),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym_user_defined_literal] = STATE(4248),
    [aux_sym__type_definition_type_repeat1] = STATE(4556),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2986),
    [anon_sym_unsigned] = ACTIONS(2986),
    [anon_sym_long] = ACTIONS(2986),
    [anon_sym_short] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2988),
    [anon_sym_byte] = ACTIONS(2988),
    [anon_sym_word] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2990),
    [anon_sym_class] = ACTIONS(2992),
    [anon_sym_struct] = ACTIONS(2994),
    [anon_sym_union] = ACTIONS(2996),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_GT2] = ACTIONS(3106),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [330] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [331] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [332] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [333] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [334] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [335] = {
    [sym_identifier] = ACTIONS(3108),
    [aux_sym_preproc_include_token1] = ACTIONS(3108),
    [aux_sym_preproc_def_token1] = ACTIONS(3108),
    [aux_sym_preproc_if_token1] = ACTIONS(3108),
    [aux_sym_preproc_if_token2] = ACTIONS(3108),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3108),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3108),
    [aux_sym_preproc_else_token1] = ACTIONS(3108),
    [aux_sym_preproc_elif_token1] = ACTIONS(3108),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3108),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3108),
    [sym_preproc_directive] = ACTIONS(3108),
    [anon_sym_LPAREN2] = ACTIONS(3110),
    [anon_sym_BANG] = ACTIONS(3110),
    [anon_sym_TILDE] = ACTIONS(3110),
    [anon_sym_DASH] = ACTIONS(3108),
    [anon_sym_PLUS] = ACTIONS(3108),
    [anon_sym_STAR] = ACTIONS(3110),
    [anon_sym_AMP_AMP] = ACTIONS(3110),
    [anon_sym_AMP] = ACTIONS(3108),
    [anon_sym_SEMI] = ACTIONS(3110),
    [anon_sym___extension__] = ACTIONS(3108),
    [anon_sym_typedef] = ACTIONS(3108),
    [anon_sym_extern] = ACTIONS(3108),
    [anon_sym___attribute__] = ACTIONS(3108),
    [anon_sym_COLON_COLON] = ACTIONS(3110),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3110),
    [anon_sym___declspec] = ACTIONS(3108),
    [anon_sym___based] = ACTIONS(3108),
    [anon_sym___cdecl] = ACTIONS(3108),
    [anon_sym___clrcall] = ACTIONS(3108),
    [anon_sym___stdcall] = ACTIONS(3108),
    [anon_sym___fastcall] = ACTIONS(3108),
    [anon_sym___thiscall] = ACTIONS(3108),
    [anon_sym___vectorcall] = ACTIONS(3108),
    [anon_sym_LBRACE] = ACTIONS(3110),
    [anon_sym_signed] = ACTIONS(3108),
    [anon_sym_unsigned] = ACTIONS(3108),
    [anon_sym_long] = ACTIONS(3108),
    [anon_sym_short] = ACTIONS(3108),
    [anon_sym_LBRACK] = ACTIONS(3108),
    [anon_sym_static] = ACTIONS(3108),
    [anon_sym_register] = ACTIONS(3108),
    [anon_sym_inline] = ACTIONS(3108),
    [anon_sym___inline] = ACTIONS(3108),
    [anon_sym___inline__] = ACTIONS(3108),
    [anon_sym___forceinline] = ACTIONS(3108),
    [anon_sym_thread_local] = ACTIONS(3108),
    [anon_sym___thread] = ACTIONS(3108),
    [anon_sym_const] = ACTIONS(3108),
    [anon_sym_constexpr] = ACTIONS(3108),
    [anon_sym_volatile] = ACTIONS(3108),
    [anon_sym_restrict] = ACTIONS(3108),
    [anon_sym___restrict__] = ACTIONS(3108),
    [anon_sym__Atomic] = ACTIONS(3108),
    [anon_sym__Noreturn] = ACTIONS(3108),
    [anon_sym_noreturn] = ACTIONS(3108),
    [anon_sym_mutable] = ACTIONS(3108),
    [anon_sym_constinit] = ACTIONS(3108),
    [anon_sym_consteval] = ACTIONS(3108),
    [anon_sym_PROGMEM] = ACTIONS(3108),
    [aux_sym_primitive_type_token1] = ACTIONS(3108),
    [anon_sym_byte] = ACTIONS(3108),
    [anon_sym_word] = ACTIONS(3108),
    [anon_sym_enum] = ACTIONS(3108),
    [anon_sym_class] = ACTIONS(3108),
    [anon_sym_struct] = ACTIONS(3108),
    [anon_sym_union] = ACTIONS(3108),
    [anon_sym_if] = ACTIONS(3108),
    [anon_sym_else] = ACTIONS(3108),
    [anon_sym_switch] = ACTIONS(3108),
    [anon_sym_case] = ACTIONS(3108),
    [anon_sym_default] = ACTIONS(3108),
    [anon_sym_while] = ACTIONS(3108),
    [anon_sym_do] = ACTIONS(3108),
    [anon_sym_for] = ACTIONS(3108),
    [anon_sym_return] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3108),
    [anon_sym_continue] = ACTIONS(3108),
    [anon_sym_goto] = ACTIONS(3108),
    [anon_sym___try] = ACTIONS(3108),
    [anon_sym___leave] = ACTIONS(3108),
    [anon_sym_not] = ACTIONS(3108),
    [anon_sym_compl] = ACTIONS(3108),
    [anon_sym_DASH_DASH] = ACTIONS(3110),
    [anon_sym_PLUS_PLUS] = ACTIONS(3110),
    [anon_sym_sizeof] = ACTIONS(3108),
    [anon_sym___alignof__] = ACTIONS(3108),
    [anon_sym___alignof] = ACTIONS(3108),
    [anon_sym__alignof] = ACTIONS(3108),
    [anon_sym_alignof] = ACTIONS(3108),
    [anon_sym__Alignof] = ACTIONS(3108),
    [anon_sym_offsetof] = ACTIONS(3108),
    [anon_sym__Generic] = ACTIONS(3108),
    [anon_sym_asm] = ACTIONS(3108),
    [anon_sym___asm__] = ACTIONS(3108),
    [aux_sym_number_literal_token1] = ACTIONS(3110),
    [aux_sym_number_literal_token2] = ACTIONS(3108),
    [anon_sym_L_SQUOTE] = ACTIONS(3110),
    [anon_sym_u_SQUOTE] = ACTIONS(3110),
    [anon_sym_U_SQUOTE] = ACTIONS(3110),
    [anon_sym_u8_SQUOTE] = ACTIONS(3110),
    [anon_sym_SQUOTE] = ACTIONS(3110),
    [anon_sym_L_DQUOTE] = ACTIONS(3110),
    [anon_sym_u_DQUOTE] = ACTIONS(3110),
    [anon_sym_U_DQUOTE] = ACTIONS(3110),
    [anon_sym_u8_DQUOTE] = ACTIONS(3110),
    [anon_sym_DQUOTE] = ACTIONS(3110),
    [sym_true] = ACTIONS(3108),
    [sym_false] = ACTIONS(3108),
    [anon_sym_NULL] = ACTIONS(3108),
    [anon_sym_nullptr] = ACTIONS(3108),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3108),
    [anon_sym_decltype] = ACTIONS(3108),
    [anon_sym_virtual] = ACTIONS(3108),
    [anon_sym_alignas] = ACTIONS(3108),
    [anon_sym_explicit] = ACTIONS(3108),
    [anon_sym_typename] = ACTIONS(3108),
    [anon_sym_template] = ACTIONS(3108),
    [anon_sym_operator] = ACTIONS(3108),
    [anon_sym_try] = ACTIONS(3108),
    [anon_sym_delete] = ACTIONS(3108),
    [anon_sym_throw] = ACTIONS(3108),
    [anon_sym_namespace] = ACTIONS(3108),
    [anon_sym_using] = ACTIONS(3108),
    [anon_sym_static_assert] = ACTIONS(3108),
    [anon_sym_concept] = ACTIONS(3108),
    [anon_sym_co_return] = ACTIONS(3108),
    [anon_sym_co_yield] = ACTIONS(3108),
    [anon_sym_R_DQUOTE] = ACTIONS(3110),
    [anon_sym_LR_DQUOTE] = ACTIONS(3110),
    [anon_sym_uR_DQUOTE] = ACTIONS(3110),
    [anon_sym_UR_DQUOTE] = ACTIONS(3110),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3110),
    [anon_sym_co_await] = ACTIONS(3108),
    [anon_sym_new] = ACTIONS(3108),
    [anon_sym_requires] = ACTIONS(3108),
    [sym_this] = ACTIONS(3108),
  },
  [336] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [337] = {
    [sym_type_qualifier] = STATE(4556),
    [sym__type_specifier] = STATE(5703),
    [sym_sized_type_specifier] = STATE(3397),
    [sym_primitive_type] = STATE(5893),
    [sym_enum_specifier] = STATE(3397),
    [sym_struct_specifier] = STATE(3397),
    [sym_union_specifier] = STATE(3397),
    [sym__expression] = STATE(5070),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_type_descriptor] = STATE(7696),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_placeholder_type_specifier] = STATE(3397),
    [sym_decltype_auto] = STATE(3398),
    [sym_decltype] = STATE(3383),
    [sym_class_specifier] = STATE(3397),
    [sym__class_name] = STATE(8471),
    [sym_dependent_type] = STATE(3397),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_type_parameter_pack_expansion] = STATE(8220),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6473),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym_user_defined_literal] = STATE(4248),
    [aux_sym__type_definition_type_repeat1] = STATE(4556),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2986),
    [anon_sym_unsigned] = ACTIONS(2986),
    [anon_sym_long] = ACTIONS(2986),
    [anon_sym_short] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2988),
    [anon_sym_byte] = ACTIONS(2988),
    [anon_sym_word] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2990),
    [anon_sym_class] = ACTIONS(2992),
    [anon_sym_struct] = ACTIONS(2994),
    [anon_sym_union] = ACTIONS(2996),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_GT2] = ACTIONS(3112),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [338] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [339] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [340] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [341] = {
    [sym_type_qualifier] = STATE(4556),
    [sym__type_specifier] = STATE(5703),
    [sym_sized_type_specifier] = STATE(3397),
    [sym_primitive_type] = STATE(5893),
    [sym_enum_specifier] = STATE(3397),
    [sym_struct_specifier] = STATE(3397),
    [sym_union_specifier] = STATE(3397),
    [sym__expression] = STATE(5087),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_type_descriptor] = STATE(7928),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_placeholder_type_specifier] = STATE(3397),
    [sym_decltype_auto] = STATE(3398),
    [sym_decltype] = STATE(3383),
    [sym_class_specifier] = STATE(3397),
    [sym__class_name] = STATE(8471),
    [sym_dependent_type] = STATE(3397),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_type_parameter_pack_expansion] = STATE(8255),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6473),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym_user_defined_literal] = STATE(4248),
    [aux_sym__type_definition_type_repeat1] = STATE(4556),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2986),
    [anon_sym_unsigned] = ACTIONS(2986),
    [anon_sym_long] = ACTIONS(2986),
    [anon_sym_short] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2988),
    [anon_sym_byte] = ACTIONS(2988),
    [anon_sym_word] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2990),
    [anon_sym_class] = ACTIONS(2992),
    [anon_sym_struct] = ACTIONS(2994),
    [anon_sym_union] = ACTIONS(2996),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_GT2] = ACTIONS(3114),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [342] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [343] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [344] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [345] = {
    [sym_type_qualifier] = STATE(4556),
    [sym__type_specifier] = STATE(5703),
    [sym_sized_type_specifier] = STATE(3397),
    [sym_primitive_type] = STATE(5893),
    [sym_enum_specifier] = STATE(3397),
    [sym_struct_specifier] = STATE(3397),
    [sym_union_specifier] = STATE(3397),
    [sym__expression] = STATE(5097),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_type_descriptor] = STATE(7655),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_placeholder_type_specifier] = STATE(3397),
    [sym_decltype_auto] = STATE(3398),
    [sym_decltype] = STATE(3383),
    [sym_class_specifier] = STATE(3397),
    [sym__class_name] = STATE(8471),
    [sym_dependent_type] = STATE(3397),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_type_parameter_pack_expansion] = STATE(8279),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6473),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym_user_defined_literal] = STATE(4248),
    [aux_sym__type_definition_type_repeat1] = STATE(4556),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2986),
    [anon_sym_unsigned] = ACTIONS(2986),
    [anon_sym_long] = ACTIONS(2986),
    [anon_sym_short] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2988),
    [anon_sym_byte] = ACTIONS(2988),
    [anon_sym_word] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2990),
    [anon_sym_class] = ACTIONS(2992),
    [anon_sym_struct] = ACTIONS(2994),
    [anon_sym_union] = ACTIONS(2996),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_GT2] = ACTIONS(3116),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [346] = {
    [sym_type_qualifier] = STATE(4556),
    [sym__type_specifier] = STATE(5703),
    [sym_sized_type_specifier] = STATE(3397),
    [sym_primitive_type] = STATE(5893),
    [sym_enum_specifier] = STATE(3397),
    [sym_struct_specifier] = STATE(3397),
    [sym_union_specifier] = STATE(3397),
    [sym__expression] = STATE(5110),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_type_descriptor] = STATE(7676),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_placeholder_type_specifier] = STATE(3397),
    [sym_decltype_auto] = STATE(3398),
    [sym_decltype] = STATE(3383),
    [sym_class_specifier] = STATE(3397),
    [sym__class_name] = STATE(8471),
    [sym_dependent_type] = STATE(3397),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_type_parameter_pack_expansion] = STATE(8142),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6473),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym_user_defined_literal] = STATE(4248),
    [aux_sym__type_definition_type_repeat1] = STATE(4556),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2986),
    [anon_sym_unsigned] = ACTIONS(2986),
    [anon_sym_long] = ACTIONS(2986),
    [anon_sym_short] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2988),
    [anon_sym_byte] = ACTIONS(2988),
    [anon_sym_word] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2990),
    [anon_sym_class] = ACTIONS(2992),
    [anon_sym_struct] = ACTIONS(2994),
    [anon_sym_union] = ACTIONS(2996),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_GT2] = ACTIONS(3118),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [347] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [348] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [349] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [350] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [351] = {
    [sym_type_qualifier] = STATE(4556),
    [sym__type_specifier] = STATE(5703),
    [sym_sized_type_specifier] = STATE(3397),
    [sym_primitive_type] = STATE(5893),
    [sym_enum_specifier] = STATE(3397),
    [sym_struct_specifier] = STATE(3397),
    [sym_union_specifier] = STATE(3397),
    [sym__expression] = STATE(5072),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_type_descriptor] = STATE(7855),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_placeholder_type_specifier] = STATE(3397),
    [sym_decltype_auto] = STATE(3398),
    [sym_decltype] = STATE(3383),
    [sym_class_specifier] = STATE(3397),
    [sym__class_name] = STATE(8471),
    [sym_dependent_type] = STATE(3397),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_type_parameter_pack_expansion] = STATE(8005),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6473),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym_user_defined_literal] = STATE(4248),
    [aux_sym__type_definition_type_repeat1] = STATE(4556),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2986),
    [anon_sym_unsigned] = ACTIONS(2986),
    [anon_sym_long] = ACTIONS(2986),
    [anon_sym_short] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2988),
    [anon_sym_byte] = ACTIONS(2988),
    [anon_sym_word] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2990),
    [anon_sym_class] = ACTIONS(2992),
    [anon_sym_struct] = ACTIONS(2994),
    [anon_sym_union] = ACTIONS(2996),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_GT2] = ACTIONS(3120),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [352] = {
    [sym_type_qualifier] = STATE(4556),
    [sym__type_specifier] = STATE(5703),
    [sym_sized_type_specifier] = STATE(3397),
    [sym_primitive_type] = STATE(5893),
    [sym_enum_specifier] = STATE(3397),
    [sym_struct_specifier] = STATE(3397),
    [sym_union_specifier] = STATE(3397),
    [sym__expression] = STATE(5140),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_type_descriptor] = STATE(7768),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_placeholder_type_specifier] = STATE(3397),
    [sym_decltype_auto] = STATE(3398),
    [sym_decltype] = STATE(3383),
    [sym_class_specifier] = STATE(3397),
    [sym__class_name] = STATE(8471),
    [sym_dependent_type] = STATE(3397),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_type_parameter_pack_expansion] = STATE(8321),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6473),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym_user_defined_literal] = STATE(4248),
    [aux_sym__type_definition_type_repeat1] = STATE(4556),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2986),
    [anon_sym_unsigned] = ACTIONS(2986),
    [anon_sym_long] = ACTIONS(2986),
    [anon_sym_short] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2988),
    [anon_sym_byte] = ACTIONS(2988),
    [anon_sym_word] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2990),
    [anon_sym_class] = ACTIONS(2992),
    [anon_sym_struct] = ACTIONS(2994),
    [anon_sym_union] = ACTIONS(2996),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_GT2] = ACTIONS(3122),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [353] = {
    [sym_identifier] = ACTIONS(3124),
    [aux_sym_preproc_include_token1] = ACTIONS(3124),
    [aux_sym_preproc_def_token1] = ACTIONS(3124),
    [aux_sym_preproc_if_token1] = ACTIONS(3124),
    [aux_sym_preproc_if_token2] = ACTIONS(3124),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3124),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3124),
    [aux_sym_preproc_else_token1] = ACTIONS(3124),
    [aux_sym_preproc_elif_token1] = ACTIONS(3124),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3124),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3124),
    [sym_preproc_directive] = ACTIONS(3124),
    [anon_sym_LPAREN2] = ACTIONS(3126),
    [anon_sym_BANG] = ACTIONS(3126),
    [anon_sym_TILDE] = ACTIONS(3126),
    [anon_sym_DASH] = ACTIONS(3124),
    [anon_sym_PLUS] = ACTIONS(3124),
    [anon_sym_STAR] = ACTIONS(3126),
    [anon_sym_AMP_AMP] = ACTIONS(3126),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym_SEMI] = ACTIONS(3126),
    [anon_sym___extension__] = ACTIONS(3124),
    [anon_sym_typedef] = ACTIONS(3124),
    [anon_sym_extern] = ACTIONS(3124),
    [anon_sym___attribute__] = ACTIONS(3124),
    [anon_sym_COLON_COLON] = ACTIONS(3126),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3126),
    [anon_sym___declspec] = ACTIONS(3124),
    [anon_sym___based] = ACTIONS(3124),
    [anon_sym___cdecl] = ACTIONS(3124),
    [anon_sym___clrcall] = ACTIONS(3124),
    [anon_sym___stdcall] = ACTIONS(3124),
    [anon_sym___fastcall] = ACTIONS(3124),
    [anon_sym___thiscall] = ACTIONS(3124),
    [anon_sym___vectorcall] = ACTIONS(3124),
    [anon_sym_LBRACE] = ACTIONS(3126),
    [anon_sym_signed] = ACTIONS(3124),
    [anon_sym_unsigned] = ACTIONS(3124),
    [anon_sym_long] = ACTIONS(3124),
    [anon_sym_short] = ACTIONS(3124),
    [anon_sym_LBRACK] = ACTIONS(3124),
    [anon_sym_static] = ACTIONS(3124),
    [anon_sym_register] = ACTIONS(3124),
    [anon_sym_inline] = ACTIONS(3124),
    [anon_sym___inline] = ACTIONS(3124),
    [anon_sym___inline__] = ACTIONS(3124),
    [anon_sym___forceinline] = ACTIONS(3124),
    [anon_sym_thread_local] = ACTIONS(3124),
    [anon_sym___thread] = ACTIONS(3124),
    [anon_sym_const] = ACTIONS(3124),
    [anon_sym_constexpr] = ACTIONS(3124),
    [anon_sym_volatile] = ACTIONS(3124),
    [anon_sym_restrict] = ACTIONS(3124),
    [anon_sym___restrict__] = ACTIONS(3124),
    [anon_sym__Atomic] = ACTIONS(3124),
    [anon_sym__Noreturn] = ACTIONS(3124),
    [anon_sym_noreturn] = ACTIONS(3124),
    [anon_sym_mutable] = ACTIONS(3124),
    [anon_sym_constinit] = ACTIONS(3124),
    [anon_sym_consteval] = ACTIONS(3124),
    [anon_sym_PROGMEM] = ACTIONS(3124),
    [aux_sym_primitive_type_token1] = ACTIONS(3124),
    [anon_sym_byte] = ACTIONS(3124),
    [anon_sym_word] = ACTIONS(3124),
    [anon_sym_enum] = ACTIONS(3124),
    [anon_sym_class] = ACTIONS(3124),
    [anon_sym_struct] = ACTIONS(3124),
    [anon_sym_union] = ACTIONS(3124),
    [anon_sym_if] = ACTIONS(3124),
    [anon_sym_else] = ACTIONS(3124),
    [anon_sym_switch] = ACTIONS(3124),
    [anon_sym_case] = ACTIONS(3124),
    [anon_sym_default] = ACTIONS(3124),
    [anon_sym_while] = ACTIONS(3124),
    [anon_sym_do] = ACTIONS(3124),
    [anon_sym_for] = ACTIONS(3124),
    [anon_sym_return] = ACTIONS(3124),
    [anon_sym_break] = ACTIONS(3124),
    [anon_sym_continue] = ACTIONS(3124),
    [anon_sym_goto] = ACTIONS(3124),
    [anon_sym___try] = ACTIONS(3124),
    [anon_sym___leave] = ACTIONS(3124),
    [anon_sym_not] = ACTIONS(3124),
    [anon_sym_compl] = ACTIONS(3124),
    [anon_sym_DASH_DASH] = ACTIONS(3126),
    [anon_sym_PLUS_PLUS] = ACTIONS(3126),
    [anon_sym_sizeof] = ACTIONS(3124),
    [anon_sym___alignof__] = ACTIONS(3124),
    [anon_sym___alignof] = ACTIONS(3124),
    [anon_sym__alignof] = ACTIONS(3124),
    [anon_sym_alignof] = ACTIONS(3124),
    [anon_sym__Alignof] = ACTIONS(3124),
    [anon_sym_offsetof] = ACTIONS(3124),
    [anon_sym__Generic] = ACTIONS(3124),
    [anon_sym_asm] = ACTIONS(3124),
    [anon_sym___asm__] = ACTIONS(3124),
    [aux_sym_number_literal_token1] = ACTIONS(3126),
    [aux_sym_number_literal_token2] = ACTIONS(3124),
    [anon_sym_L_SQUOTE] = ACTIONS(3126),
    [anon_sym_u_SQUOTE] = ACTIONS(3126),
    [anon_sym_U_SQUOTE] = ACTIONS(3126),
    [anon_sym_u8_SQUOTE] = ACTIONS(3126),
    [anon_sym_SQUOTE] = ACTIONS(3126),
    [anon_sym_L_DQUOTE] = ACTIONS(3126),
    [anon_sym_u_DQUOTE] = ACTIONS(3126),
    [anon_sym_U_DQUOTE] = ACTIONS(3126),
    [anon_sym_u8_DQUOTE] = ACTIONS(3126),
    [anon_sym_DQUOTE] = ACTIONS(3126),
    [sym_true] = ACTIONS(3124),
    [sym_false] = ACTIONS(3124),
    [anon_sym_NULL] = ACTIONS(3124),
    [anon_sym_nullptr] = ACTIONS(3124),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3124),
    [anon_sym_decltype] = ACTIONS(3124),
    [anon_sym_virtual] = ACTIONS(3124),
    [anon_sym_alignas] = ACTIONS(3124),
    [anon_sym_explicit] = ACTIONS(3124),
    [anon_sym_typename] = ACTIONS(3124),
    [anon_sym_template] = ACTIONS(3124),
    [anon_sym_operator] = ACTIONS(3124),
    [anon_sym_try] = ACTIONS(3124),
    [anon_sym_delete] = ACTIONS(3124),
    [anon_sym_throw] = ACTIONS(3124),
    [anon_sym_namespace] = ACTIONS(3124),
    [anon_sym_using] = ACTIONS(3124),
    [anon_sym_static_assert] = ACTIONS(3124),
    [anon_sym_concept] = ACTIONS(3124),
    [anon_sym_co_return] = ACTIONS(3124),
    [anon_sym_co_yield] = ACTIONS(3124),
    [anon_sym_R_DQUOTE] = ACTIONS(3126),
    [anon_sym_LR_DQUOTE] = ACTIONS(3126),
    [anon_sym_uR_DQUOTE] = ACTIONS(3126),
    [anon_sym_UR_DQUOTE] = ACTIONS(3126),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3126),
    [anon_sym_co_await] = ACTIONS(3124),
    [anon_sym_new] = ACTIONS(3124),
    [anon_sym_requires] = ACTIONS(3124),
    [sym_this] = ACTIONS(3124),
  },
  [354] = {
    [sym_identifier] = ACTIONS(3128),
    [aux_sym_preproc_include_token1] = ACTIONS(3128),
    [aux_sym_preproc_def_token1] = ACTIONS(3128),
    [aux_sym_preproc_if_token1] = ACTIONS(3128),
    [aux_sym_preproc_if_token2] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3128),
    [aux_sym_preproc_else_token1] = ACTIONS(3128),
    [aux_sym_preproc_elif_token1] = ACTIONS(3128),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3128),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3128),
    [sym_preproc_directive] = ACTIONS(3128),
    [anon_sym_LPAREN2] = ACTIONS(3130),
    [anon_sym_BANG] = ACTIONS(3130),
    [anon_sym_TILDE] = ACTIONS(3130),
    [anon_sym_DASH] = ACTIONS(3128),
    [anon_sym_PLUS] = ACTIONS(3128),
    [anon_sym_STAR] = ACTIONS(3130),
    [anon_sym_AMP_AMP] = ACTIONS(3130),
    [anon_sym_AMP] = ACTIONS(3128),
    [anon_sym_SEMI] = ACTIONS(3130),
    [anon_sym___extension__] = ACTIONS(3128),
    [anon_sym_typedef] = ACTIONS(3128),
    [anon_sym_extern] = ACTIONS(3128),
    [anon_sym___attribute__] = ACTIONS(3128),
    [anon_sym_COLON_COLON] = ACTIONS(3130),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3130),
    [anon_sym___declspec] = ACTIONS(3128),
    [anon_sym___based] = ACTIONS(3128),
    [anon_sym___cdecl] = ACTIONS(3128),
    [anon_sym___clrcall] = ACTIONS(3128),
    [anon_sym___stdcall] = ACTIONS(3128),
    [anon_sym___fastcall] = ACTIONS(3128),
    [anon_sym___thiscall] = ACTIONS(3128),
    [anon_sym___vectorcall] = ACTIONS(3128),
    [anon_sym_LBRACE] = ACTIONS(3130),
    [anon_sym_signed] = ACTIONS(3128),
    [anon_sym_unsigned] = ACTIONS(3128),
    [anon_sym_long] = ACTIONS(3128),
    [anon_sym_short] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3128),
    [anon_sym_static] = ACTIONS(3128),
    [anon_sym_register] = ACTIONS(3128),
    [anon_sym_inline] = ACTIONS(3128),
    [anon_sym___inline] = ACTIONS(3128),
    [anon_sym___inline__] = ACTIONS(3128),
    [anon_sym___forceinline] = ACTIONS(3128),
    [anon_sym_thread_local] = ACTIONS(3128),
    [anon_sym___thread] = ACTIONS(3128),
    [anon_sym_const] = ACTIONS(3128),
    [anon_sym_constexpr] = ACTIONS(3128),
    [anon_sym_volatile] = ACTIONS(3128),
    [anon_sym_restrict] = ACTIONS(3128),
    [anon_sym___restrict__] = ACTIONS(3128),
    [anon_sym__Atomic] = ACTIONS(3128),
    [anon_sym__Noreturn] = ACTIONS(3128),
    [anon_sym_noreturn] = ACTIONS(3128),
    [anon_sym_mutable] = ACTIONS(3128),
    [anon_sym_constinit] = ACTIONS(3128),
    [anon_sym_consteval] = ACTIONS(3128),
    [anon_sym_PROGMEM] = ACTIONS(3128),
    [aux_sym_primitive_type_token1] = ACTIONS(3128),
    [anon_sym_byte] = ACTIONS(3128),
    [anon_sym_word] = ACTIONS(3128),
    [anon_sym_enum] = ACTIONS(3128),
    [anon_sym_class] = ACTIONS(3128),
    [anon_sym_struct] = ACTIONS(3128),
    [anon_sym_union] = ACTIONS(3128),
    [anon_sym_if] = ACTIONS(3128),
    [anon_sym_else] = ACTIONS(3128),
    [anon_sym_switch] = ACTIONS(3128),
    [anon_sym_case] = ACTIONS(3128),
    [anon_sym_default] = ACTIONS(3128),
    [anon_sym_while] = ACTIONS(3128),
    [anon_sym_do] = ACTIONS(3128),
    [anon_sym_for] = ACTIONS(3128),
    [anon_sym_return] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3128),
    [anon_sym_continue] = ACTIONS(3128),
    [anon_sym_goto] = ACTIONS(3128),
    [anon_sym___try] = ACTIONS(3128),
    [anon_sym___leave] = ACTIONS(3128),
    [anon_sym_not] = ACTIONS(3128),
    [anon_sym_compl] = ACTIONS(3128),
    [anon_sym_DASH_DASH] = ACTIONS(3130),
    [anon_sym_PLUS_PLUS] = ACTIONS(3130),
    [anon_sym_sizeof] = ACTIONS(3128),
    [anon_sym___alignof__] = ACTIONS(3128),
    [anon_sym___alignof] = ACTIONS(3128),
    [anon_sym__alignof] = ACTIONS(3128),
    [anon_sym_alignof] = ACTIONS(3128),
    [anon_sym__Alignof] = ACTIONS(3128),
    [anon_sym_offsetof] = ACTIONS(3128),
    [anon_sym__Generic] = ACTIONS(3128),
    [anon_sym_asm] = ACTIONS(3128),
    [anon_sym___asm__] = ACTIONS(3128),
    [aux_sym_number_literal_token1] = ACTIONS(3130),
    [aux_sym_number_literal_token2] = ACTIONS(3128),
    [anon_sym_L_SQUOTE] = ACTIONS(3130),
    [anon_sym_u_SQUOTE] = ACTIONS(3130),
    [anon_sym_U_SQUOTE] = ACTIONS(3130),
    [anon_sym_u8_SQUOTE] = ACTIONS(3130),
    [anon_sym_SQUOTE] = ACTIONS(3130),
    [anon_sym_L_DQUOTE] = ACTIONS(3130),
    [anon_sym_u_DQUOTE] = ACTIONS(3130),
    [anon_sym_U_DQUOTE] = ACTIONS(3130),
    [anon_sym_u8_DQUOTE] = ACTIONS(3130),
    [anon_sym_DQUOTE] = ACTIONS(3130),
    [sym_true] = ACTIONS(3128),
    [sym_false] = ACTIONS(3128),
    [anon_sym_NULL] = ACTIONS(3128),
    [anon_sym_nullptr] = ACTIONS(3128),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3128),
    [anon_sym_decltype] = ACTIONS(3128),
    [anon_sym_virtual] = ACTIONS(3128),
    [anon_sym_alignas] = ACTIONS(3128),
    [anon_sym_explicit] = ACTIONS(3128),
    [anon_sym_typename] = ACTIONS(3128),
    [anon_sym_template] = ACTIONS(3128),
    [anon_sym_operator] = ACTIONS(3128),
    [anon_sym_try] = ACTIONS(3128),
    [anon_sym_delete] = ACTIONS(3128),
    [anon_sym_throw] = ACTIONS(3128),
    [anon_sym_namespace] = ACTIONS(3128),
    [anon_sym_using] = ACTIONS(3128),
    [anon_sym_static_assert] = ACTIONS(3128),
    [anon_sym_concept] = ACTIONS(3128),
    [anon_sym_co_return] = ACTIONS(3128),
    [anon_sym_co_yield] = ACTIONS(3128),
    [anon_sym_R_DQUOTE] = ACTIONS(3130),
    [anon_sym_LR_DQUOTE] = ACTIONS(3130),
    [anon_sym_uR_DQUOTE] = ACTIONS(3130),
    [anon_sym_UR_DQUOTE] = ACTIONS(3130),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3130),
    [anon_sym_co_await] = ACTIONS(3128),
    [anon_sym_new] = ACTIONS(3128),
    [anon_sym_requires] = ACTIONS(3128),
    [sym_this] = ACTIONS(3128),
  },
  [355] = {
    [sym_type_qualifier] = STATE(4556),
    [sym__type_specifier] = STATE(5703),
    [sym_sized_type_specifier] = STATE(3397),
    [sym_primitive_type] = STATE(5893),
    [sym_enum_specifier] = STATE(3397),
    [sym_struct_specifier] = STATE(3397),
    [sym_union_specifier] = STATE(3397),
    [sym__expression] = STATE(5145),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_type_descriptor] = STATE(7815),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_placeholder_type_specifier] = STATE(3397),
    [sym_decltype_auto] = STATE(3398),
    [sym_decltype] = STATE(3383),
    [sym_class_specifier] = STATE(3397),
    [sym__class_name] = STATE(8471),
    [sym_dependent_type] = STATE(3397),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_type_parameter_pack_expansion] = STATE(8341),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6473),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym_user_defined_literal] = STATE(4248),
    [aux_sym__type_definition_type_repeat1] = STATE(4556),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2986),
    [anon_sym_unsigned] = ACTIONS(2986),
    [anon_sym_long] = ACTIONS(2986),
    [anon_sym_short] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2988),
    [anon_sym_byte] = ACTIONS(2988),
    [anon_sym_word] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2990),
    [anon_sym_class] = ACTIONS(2992),
    [anon_sym_struct] = ACTIONS(2994),
    [anon_sym_union] = ACTIONS(2996),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_GT2] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [356] = {
    [sym_identifier] = ACTIONS(3134),
    [aux_sym_preproc_include_token1] = ACTIONS(3134),
    [aux_sym_preproc_def_token1] = ACTIONS(3134),
    [aux_sym_preproc_if_token1] = ACTIONS(3134),
    [aux_sym_preproc_if_token2] = ACTIONS(3134),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3134),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3134),
    [aux_sym_preproc_else_token1] = ACTIONS(3134),
    [aux_sym_preproc_elif_token1] = ACTIONS(3134),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3134),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3134),
    [sym_preproc_directive] = ACTIONS(3134),
    [anon_sym_LPAREN2] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3136),
    [anon_sym_TILDE] = ACTIONS(3136),
    [anon_sym_DASH] = ACTIONS(3134),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_STAR] = ACTIONS(3136),
    [anon_sym_AMP_AMP] = ACTIONS(3136),
    [anon_sym_AMP] = ACTIONS(3134),
    [anon_sym_SEMI] = ACTIONS(3136),
    [anon_sym___extension__] = ACTIONS(3134),
    [anon_sym_typedef] = ACTIONS(3134),
    [anon_sym_extern] = ACTIONS(3134),
    [anon_sym___attribute__] = ACTIONS(3134),
    [anon_sym_COLON_COLON] = ACTIONS(3136),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3136),
    [anon_sym___declspec] = ACTIONS(3134),
    [anon_sym___based] = ACTIONS(3134),
    [anon_sym___cdecl] = ACTIONS(3134),
    [anon_sym___clrcall] = ACTIONS(3134),
    [anon_sym___stdcall] = ACTIONS(3134),
    [anon_sym___fastcall] = ACTIONS(3134),
    [anon_sym___thiscall] = ACTIONS(3134),
    [anon_sym___vectorcall] = ACTIONS(3134),
    [anon_sym_LBRACE] = ACTIONS(3136),
    [anon_sym_signed] = ACTIONS(3134),
    [anon_sym_unsigned] = ACTIONS(3134),
    [anon_sym_long] = ACTIONS(3134),
    [anon_sym_short] = ACTIONS(3134),
    [anon_sym_LBRACK] = ACTIONS(3134),
    [anon_sym_static] = ACTIONS(3134),
    [anon_sym_register] = ACTIONS(3134),
    [anon_sym_inline] = ACTIONS(3134),
    [anon_sym___inline] = ACTIONS(3134),
    [anon_sym___inline__] = ACTIONS(3134),
    [anon_sym___forceinline] = ACTIONS(3134),
    [anon_sym_thread_local] = ACTIONS(3134),
    [anon_sym___thread] = ACTIONS(3134),
    [anon_sym_const] = ACTIONS(3134),
    [anon_sym_constexpr] = ACTIONS(3134),
    [anon_sym_volatile] = ACTIONS(3134),
    [anon_sym_restrict] = ACTIONS(3134),
    [anon_sym___restrict__] = ACTIONS(3134),
    [anon_sym__Atomic] = ACTIONS(3134),
    [anon_sym__Noreturn] = ACTIONS(3134),
    [anon_sym_noreturn] = ACTIONS(3134),
    [anon_sym_mutable] = ACTIONS(3134),
    [anon_sym_constinit] = ACTIONS(3134),
    [anon_sym_consteval] = ACTIONS(3134),
    [anon_sym_PROGMEM] = ACTIONS(3134),
    [aux_sym_primitive_type_token1] = ACTIONS(3134),
    [anon_sym_byte] = ACTIONS(3134),
    [anon_sym_word] = ACTIONS(3134),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3134),
    [anon_sym_struct] = ACTIONS(3134),
    [anon_sym_union] = ACTIONS(3134),
    [anon_sym_if] = ACTIONS(3134),
    [anon_sym_else] = ACTIONS(3134),
    [anon_sym_switch] = ACTIONS(3134),
    [anon_sym_case] = ACTIONS(3134),
    [anon_sym_default] = ACTIONS(3134),
    [anon_sym_while] = ACTIONS(3134),
    [anon_sym_do] = ACTIONS(3134),
    [anon_sym_for] = ACTIONS(3134),
    [anon_sym_return] = ACTIONS(3134),
    [anon_sym_break] = ACTIONS(3134),
    [anon_sym_continue] = ACTIONS(3134),
    [anon_sym_goto] = ACTIONS(3134),
    [anon_sym___try] = ACTIONS(3134),
    [anon_sym___leave] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3134),
    [anon_sym_compl] = ACTIONS(3134),
    [anon_sym_DASH_DASH] = ACTIONS(3136),
    [anon_sym_PLUS_PLUS] = ACTIONS(3136),
    [anon_sym_sizeof] = ACTIONS(3134),
    [anon_sym___alignof__] = ACTIONS(3134),
    [anon_sym___alignof] = ACTIONS(3134),
    [anon_sym__alignof] = ACTIONS(3134),
    [anon_sym_alignof] = ACTIONS(3134),
    [anon_sym__Alignof] = ACTIONS(3134),
    [anon_sym_offsetof] = ACTIONS(3134),
    [anon_sym__Generic] = ACTIONS(3134),
    [anon_sym_asm] = ACTIONS(3134),
    [anon_sym___asm__] = ACTIONS(3134),
    [aux_sym_number_literal_token1] = ACTIONS(3136),
    [aux_sym_number_literal_token2] = ACTIONS(3134),
    [anon_sym_L_SQUOTE] = ACTIONS(3136),
    [anon_sym_u_SQUOTE] = ACTIONS(3136),
    [anon_sym_U_SQUOTE] = ACTIONS(3136),
    [anon_sym_u8_SQUOTE] = ACTIONS(3136),
    [anon_sym_SQUOTE] = ACTIONS(3136),
    [anon_sym_L_DQUOTE] = ACTIONS(3136),
    [anon_sym_u_DQUOTE] = ACTIONS(3136),
    [anon_sym_U_DQUOTE] = ACTIONS(3136),
    [anon_sym_u8_DQUOTE] = ACTIONS(3136),
    [anon_sym_DQUOTE] = ACTIONS(3136),
    [sym_true] = ACTIONS(3134),
    [sym_false] = ACTIONS(3134),
    [anon_sym_NULL] = ACTIONS(3134),
    [anon_sym_nullptr] = ACTIONS(3134),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3134),
    [anon_sym_decltype] = ACTIONS(3134),
    [anon_sym_virtual] = ACTIONS(3134),
    [anon_sym_alignas] = ACTIONS(3134),
    [anon_sym_explicit] = ACTIONS(3134),
    [anon_sym_typename] = ACTIONS(3134),
    [anon_sym_template] = ACTIONS(3134),
    [anon_sym_operator] = ACTIONS(3134),
    [anon_sym_try] = ACTIONS(3134),
    [anon_sym_delete] = ACTIONS(3134),
    [anon_sym_throw] = ACTIONS(3134),
    [anon_sym_namespace] = ACTIONS(3134),
    [anon_sym_using] = ACTIONS(3134),
    [anon_sym_static_assert] = ACTIONS(3134),
    [anon_sym_concept] = ACTIONS(3134),
    [anon_sym_co_return] = ACTIONS(3134),
    [anon_sym_co_yield] = ACTIONS(3134),
    [anon_sym_R_DQUOTE] = ACTIONS(3136),
    [anon_sym_LR_DQUOTE] = ACTIONS(3136),
    [anon_sym_uR_DQUOTE] = ACTIONS(3136),
    [anon_sym_UR_DQUOTE] = ACTIONS(3136),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3136),
    [anon_sym_co_await] = ACTIONS(3134),
    [anon_sym_new] = ACTIONS(3134),
    [anon_sym_requires] = ACTIONS(3134),
    [sym_this] = ACTIONS(3134),
  },
  [357] = {
    [sym_identifier] = ACTIONS(3138),
    [aux_sym_preproc_include_token1] = ACTIONS(3138),
    [aux_sym_preproc_def_token1] = ACTIONS(3138),
    [aux_sym_preproc_if_token1] = ACTIONS(3138),
    [aux_sym_preproc_if_token2] = ACTIONS(3138),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3138),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3138),
    [aux_sym_preproc_else_token1] = ACTIONS(3138),
    [aux_sym_preproc_elif_token1] = ACTIONS(3138),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3138),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3138),
    [sym_preproc_directive] = ACTIONS(3138),
    [anon_sym_LPAREN2] = ACTIONS(3140),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [anon_sym_DASH] = ACTIONS(3138),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_STAR] = ACTIONS(3140),
    [anon_sym_AMP_AMP] = ACTIONS(3140),
    [anon_sym_AMP] = ACTIONS(3138),
    [anon_sym_SEMI] = ACTIONS(3140),
    [anon_sym___extension__] = ACTIONS(3138),
    [anon_sym_typedef] = ACTIONS(3138),
    [anon_sym_extern] = ACTIONS(3138),
    [anon_sym___attribute__] = ACTIONS(3138),
    [anon_sym_COLON_COLON] = ACTIONS(3140),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3140),
    [anon_sym___declspec] = ACTIONS(3138),
    [anon_sym___based] = ACTIONS(3138),
    [anon_sym___cdecl] = ACTIONS(3138),
    [anon_sym___clrcall] = ACTIONS(3138),
    [anon_sym___stdcall] = ACTIONS(3138),
    [anon_sym___fastcall] = ACTIONS(3138),
    [anon_sym___thiscall] = ACTIONS(3138),
    [anon_sym___vectorcall] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [anon_sym_signed] = ACTIONS(3138),
    [anon_sym_unsigned] = ACTIONS(3138),
    [anon_sym_long] = ACTIONS(3138),
    [anon_sym_short] = ACTIONS(3138),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_static] = ACTIONS(3138),
    [anon_sym_register] = ACTIONS(3138),
    [anon_sym_inline] = ACTIONS(3138),
    [anon_sym___inline] = ACTIONS(3138),
    [anon_sym___inline__] = ACTIONS(3138),
    [anon_sym___forceinline] = ACTIONS(3138),
    [anon_sym_thread_local] = ACTIONS(3138),
    [anon_sym___thread] = ACTIONS(3138),
    [anon_sym_const] = ACTIONS(3138),
    [anon_sym_constexpr] = ACTIONS(3138),
    [anon_sym_volatile] = ACTIONS(3138),
    [anon_sym_restrict] = ACTIONS(3138),
    [anon_sym___restrict__] = ACTIONS(3138),
    [anon_sym__Atomic] = ACTIONS(3138),
    [anon_sym__Noreturn] = ACTIONS(3138),
    [anon_sym_noreturn] = ACTIONS(3138),
    [anon_sym_mutable] = ACTIONS(3138),
    [anon_sym_constinit] = ACTIONS(3138),
    [anon_sym_consteval] = ACTIONS(3138),
    [anon_sym_PROGMEM] = ACTIONS(3138),
    [aux_sym_primitive_type_token1] = ACTIONS(3138),
    [anon_sym_byte] = ACTIONS(3138),
    [anon_sym_word] = ACTIONS(3138),
    [anon_sym_enum] = ACTIONS(3138),
    [anon_sym_class] = ACTIONS(3138),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3138),
    [anon_sym_if] = ACTIONS(3138),
    [anon_sym_else] = ACTIONS(3138),
    [anon_sym_switch] = ACTIONS(3138),
    [anon_sym_case] = ACTIONS(3138),
    [anon_sym_default] = ACTIONS(3138),
    [anon_sym_while] = ACTIONS(3138),
    [anon_sym_do] = ACTIONS(3138),
    [anon_sym_for] = ACTIONS(3138),
    [anon_sym_return] = ACTIONS(3138),
    [anon_sym_break] = ACTIONS(3138),
    [anon_sym_continue] = ACTIONS(3138),
    [anon_sym_goto] = ACTIONS(3138),
    [anon_sym___try] = ACTIONS(3138),
    [anon_sym___leave] = ACTIONS(3138),
    [anon_sym_not] = ACTIONS(3138),
    [anon_sym_compl] = ACTIONS(3138),
    [anon_sym_DASH_DASH] = ACTIONS(3140),
    [anon_sym_PLUS_PLUS] = ACTIONS(3140),
    [anon_sym_sizeof] = ACTIONS(3138),
    [anon_sym___alignof__] = ACTIONS(3138),
    [anon_sym___alignof] = ACTIONS(3138),
    [anon_sym__alignof] = ACTIONS(3138),
    [anon_sym_alignof] = ACTIONS(3138),
    [anon_sym__Alignof] = ACTIONS(3138),
    [anon_sym_offsetof] = ACTIONS(3138),
    [anon_sym__Generic] = ACTIONS(3138),
    [anon_sym_asm] = ACTIONS(3138),
    [anon_sym___asm__] = ACTIONS(3138),
    [aux_sym_number_literal_token1] = ACTIONS(3140),
    [aux_sym_number_literal_token2] = ACTIONS(3138),
    [anon_sym_L_SQUOTE] = ACTIONS(3140),
    [anon_sym_u_SQUOTE] = ACTIONS(3140),
    [anon_sym_U_SQUOTE] = ACTIONS(3140),
    [anon_sym_u8_SQUOTE] = ACTIONS(3140),
    [anon_sym_SQUOTE] = ACTIONS(3140),
    [anon_sym_L_DQUOTE] = ACTIONS(3140),
    [anon_sym_u_DQUOTE] = ACTIONS(3140),
    [anon_sym_U_DQUOTE] = ACTIONS(3140),
    [anon_sym_u8_DQUOTE] = ACTIONS(3140),
    [anon_sym_DQUOTE] = ACTIONS(3140),
    [sym_true] = ACTIONS(3138),
    [sym_false] = ACTIONS(3138),
    [anon_sym_NULL] = ACTIONS(3138),
    [anon_sym_nullptr] = ACTIONS(3138),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3138),
    [anon_sym_decltype] = ACTIONS(3138),
    [anon_sym_virtual] = ACTIONS(3138),
    [anon_sym_alignas] = ACTIONS(3138),
    [anon_sym_explicit] = ACTIONS(3138),
    [anon_sym_typename] = ACTIONS(3138),
    [anon_sym_template] = ACTIONS(3138),
    [anon_sym_operator] = ACTIONS(3138),
    [anon_sym_try] = ACTIONS(3138),
    [anon_sym_delete] = ACTIONS(3138),
    [anon_sym_throw] = ACTIONS(3138),
    [anon_sym_namespace] = ACTIONS(3138),
    [anon_sym_using] = ACTIONS(3138),
    [anon_sym_static_assert] = ACTIONS(3138),
    [anon_sym_concept] = ACTIONS(3138),
    [anon_sym_co_return] = ACTIONS(3138),
    [anon_sym_co_yield] = ACTIONS(3138),
    [anon_sym_R_DQUOTE] = ACTIONS(3140),
    [anon_sym_LR_DQUOTE] = ACTIONS(3140),
    [anon_sym_uR_DQUOTE] = ACTIONS(3140),
    [anon_sym_UR_DQUOTE] = ACTIONS(3140),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3140),
    [anon_sym_co_await] = ACTIONS(3138),
    [anon_sym_new] = ACTIONS(3138),
    [anon_sym_requires] = ACTIONS(3138),
    [sym_this] = ACTIONS(3138),
  },
  [358] = {
    [sym_type_qualifier] = STATE(4556),
    [sym__type_specifier] = STATE(5703),
    [sym_sized_type_specifier] = STATE(3397),
    [sym_primitive_type] = STATE(5893),
    [sym_enum_specifier] = STATE(3397),
    [sym_struct_specifier] = STATE(3397),
    [sym_union_specifier] = STATE(3397),
    [sym__expression] = STATE(5158),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_type_descriptor] = STATE(7879),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_placeholder_type_specifier] = STATE(3397),
    [sym_decltype_auto] = STATE(3398),
    [sym_decltype] = STATE(3383),
    [sym_class_specifier] = STATE(3397),
    [sym__class_name] = STATE(8471),
    [sym_dependent_type] = STATE(3397),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_type_parameter_pack_expansion] = STATE(8361),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6473),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym_user_defined_literal] = STATE(4248),
    [aux_sym__type_definition_type_repeat1] = STATE(4556),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2986),
    [anon_sym_unsigned] = ACTIONS(2986),
    [anon_sym_long] = ACTIONS(2986),
    [anon_sym_short] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2988),
    [anon_sym_byte] = ACTIONS(2988),
    [anon_sym_word] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2990),
    [anon_sym_class] = ACTIONS(2992),
    [anon_sym_struct] = ACTIONS(2994),
    [anon_sym_union] = ACTIONS(2996),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_GT2] = ACTIONS(3142),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [359] = {
    [sym_catch_clause] = STATE(274),
    [aux_sym_constructor_try_statement_repeat1] = STATE(274),
    [sym_identifier] = ACTIONS(2860),
    [aux_sym_preproc_include_token1] = ACTIONS(2860),
    [aux_sym_preproc_def_token1] = ACTIONS(2860),
    [aux_sym_preproc_if_token1] = ACTIONS(2860),
    [aux_sym_preproc_if_token2] = ACTIONS(2860),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2860),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2860),
    [aux_sym_preproc_else_token1] = ACTIONS(2860),
    [aux_sym_preproc_elif_token1] = ACTIONS(2860),
    [sym_preproc_directive] = ACTIONS(2860),
    [anon_sym_LPAREN2] = ACTIONS(2862),
    [anon_sym_BANG] = ACTIONS(2862),
    [anon_sym_TILDE] = ACTIONS(2862),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP_AMP] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2860),
    [anon_sym_SEMI] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2860),
    [anon_sym_typedef] = ACTIONS(2860),
    [anon_sym_extern] = ACTIONS(2860),
    [anon_sym___attribute__] = ACTIONS(2860),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2862),
    [anon_sym___declspec] = ACTIONS(2860),
    [anon_sym___based] = ACTIONS(2860),
    [anon_sym___cdecl] = ACTIONS(2860),
    [anon_sym___clrcall] = ACTIONS(2860),
    [anon_sym___stdcall] = ACTIONS(2860),
    [anon_sym___fastcall] = ACTIONS(2860),
    [anon_sym___thiscall] = ACTIONS(2860),
    [anon_sym___vectorcall] = ACTIONS(2860),
    [anon_sym_LBRACE] = ACTIONS(2862),
    [anon_sym_signed] = ACTIONS(2860),
    [anon_sym_unsigned] = ACTIONS(2860),
    [anon_sym_long] = ACTIONS(2860),
    [anon_sym_short] = ACTIONS(2860),
    [anon_sym_LBRACK] = ACTIONS(2860),
    [anon_sym_static] = ACTIONS(2860),
    [anon_sym_register] = ACTIONS(2860),
    [anon_sym_inline] = ACTIONS(2860),
    [anon_sym___inline] = ACTIONS(2860),
    [anon_sym___inline__] = ACTIONS(2860),
    [anon_sym___forceinline] = ACTIONS(2860),
    [anon_sym_thread_local] = ACTIONS(2860),
    [anon_sym___thread] = ACTIONS(2860),
    [anon_sym_const] = ACTIONS(2860),
    [anon_sym_constexpr] = ACTIONS(2860),
    [anon_sym_volatile] = ACTIONS(2860),
    [anon_sym_restrict] = ACTIONS(2860),
    [anon_sym___restrict__] = ACTIONS(2860),
    [anon_sym__Atomic] = ACTIONS(2860),
    [anon_sym__Noreturn] = ACTIONS(2860),
    [anon_sym_noreturn] = ACTIONS(2860),
    [anon_sym_mutable] = ACTIONS(2860),
    [anon_sym_constinit] = ACTIONS(2860),
    [anon_sym_consteval] = ACTIONS(2860),
    [anon_sym_PROGMEM] = ACTIONS(2860),
    [aux_sym_primitive_type_token1] = ACTIONS(2860),
    [anon_sym_byte] = ACTIONS(2860),
    [anon_sym_word] = ACTIONS(2860),
    [anon_sym_enum] = ACTIONS(2860),
    [anon_sym_class] = ACTIONS(2860),
    [anon_sym_struct] = ACTIONS(2860),
    [anon_sym_union] = ACTIONS(2860),
    [anon_sym_if] = ACTIONS(2860),
    [anon_sym_switch] = ACTIONS(2860),
    [anon_sym_case] = ACTIONS(2860),
    [anon_sym_default] = ACTIONS(2860),
    [anon_sym_while] = ACTIONS(2860),
    [anon_sym_do] = ACTIONS(2860),
    [anon_sym_for] = ACTIONS(2860),
    [anon_sym_return] = ACTIONS(2860),
    [anon_sym_break] = ACTIONS(2860),
    [anon_sym_continue] = ACTIONS(2860),
    [anon_sym_goto] = ACTIONS(2860),
    [anon_sym___try] = ACTIONS(2860),
    [anon_sym___leave] = ACTIONS(2860),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2862),
    [anon_sym_PLUS_PLUS] = ACTIONS(2862),
    [anon_sym_sizeof] = ACTIONS(2860),
    [anon_sym___alignof__] = ACTIONS(2860),
    [anon_sym___alignof] = ACTIONS(2860),
    [anon_sym__alignof] = ACTIONS(2860),
    [anon_sym_alignof] = ACTIONS(2860),
    [anon_sym__Alignof] = ACTIONS(2860),
    [anon_sym_offsetof] = ACTIONS(2860),
    [anon_sym__Generic] = ACTIONS(2860),
    [anon_sym_asm] = ACTIONS(2860),
    [anon_sym___asm__] = ACTIONS(2860),
    [aux_sym_number_literal_token1] = ACTIONS(2862),
    [aux_sym_number_literal_token2] = ACTIONS(2860),
    [anon_sym_L_SQUOTE] = ACTIONS(2862),
    [anon_sym_u_SQUOTE] = ACTIONS(2862),
    [anon_sym_U_SQUOTE] = ACTIONS(2862),
    [anon_sym_u8_SQUOTE] = ACTIONS(2862),
    [anon_sym_SQUOTE] = ACTIONS(2862),
    [anon_sym_L_DQUOTE] = ACTIONS(2862),
    [anon_sym_u_DQUOTE] = ACTIONS(2862),
    [anon_sym_U_DQUOTE] = ACTIONS(2862),
    [anon_sym_u8_DQUOTE] = ACTIONS(2862),
    [anon_sym_DQUOTE] = ACTIONS(2862),
    [sym_true] = ACTIONS(2860),
    [sym_false] = ACTIONS(2860),
    [anon_sym_NULL] = ACTIONS(2860),
    [anon_sym_nullptr] = ACTIONS(2860),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2860),
    [anon_sym_decltype] = ACTIONS(2860),
    [anon_sym_virtual] = ACTIONS(2860),
    [anon_sym_alignas] = ACTIONS(2860),
    [anon_sym_explicit] = ACTIONS(2860),
    [anon_sym_typename] = ACTIONS(2860),
    [anon_sym_template] = ACTIONS(2860),
    [anon_sym_operator] = ACTIONS(2860),
    [anon_sym_try] = ACTIONS(2860),
    [anon_sym_delete] = ACTIONS(2860),
    [anon_sym_throw] = ACTIONS(2860),
    [anon_sym_namespace] = ACTIONS(2860),
    [anon_sym_using] = ACTIONS(2860),
    [anon_sym_static_assert] = ACTIONS(2860),
    [anon_sym_concept] = ACTIONS(2860),
    [anon_sym_co_return] = ACTIONS(2860),
    [anon_sym_co_yield] = ACTIONS(2860),
    [anon_sym_catch] = ACTIONS(2885),
    [anon_sym_R_DQUOTE] = ACTIONS(2862),
    [anon_sym_LR_DQUOTE] = ACTIONS(2862),
    [anon_sym_uR_DQUOTE] = ACTIONS(2862),
    [anon_sym_UR_DQUOTE] = ACTIONS(2862),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2862),
    [anon_sym_co_await] = ACTIONS(2860),
    [anon_sym_new] = ACTIONS(2860),
    [anon_sym_requires] = ACTIONS(2860),
    [sym_this] = ACTIONS(2860),
  },
  [360] = {
    [sym_identifier] = ACTIONS(3144),
    [aux_sym_preproc_include_token1] = ACTIONS(3144),
    [aux_sym_preproc_def_token1] = ACTIONS(3144),
    [aux_sym_preproc_if_token1] = ACTIONS(3144),
    [aux_sym_preproc_if_token2] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3144),
    [aux_sym_preproc_else_token1] = ACTIONS(3144),
    [aux_sym_preproc_elif_token1] = ACTIONS(3144),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3144),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3144),
    [sym_preproc_directive] = ACTIONS(3144),
    [anon_sym_LPAREN2] = ACTIONS(3146),
    [anon_sym_BANG] = ACTIONS(3146),
    [anon_sym_TILDE] = ACTIONS(3146),
    [anon_sym_DASH] = ACTIONS(3144),
    [anon_sym_PLUS] = ACTIONS(3144),
    [anon_sym_STAR] = ACTIONS(3146),
    [anon_sym_AMP_AMP] = ACTIONS(3146),
    [anon_sym_AMP] = ACTIONS(3144),
    [anon_sym_SEMI] = ACTIONS(3146),
    [anon_sym___extension__] = ACTIONS(3144),
    [anon_sym_typedef] = ACTIONS(3144),
    [anon_sym_extern] = ACTIONS(3144),
    [anon_sym___attribute__] = ACTIONS(3144),
    [anon_sym_COLON_COLON] = ACTIONS(3146),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3146),
    [anon_sym___declspec] = ACTIONS(3144),
    [anon_sym___based] = ACTIONS(3144),
    [anon_sym___cdecl] = ACTIONS(3144),
    [anon_sym___clrcall] = ACTIONS(3144),
    [anon_sym___stdcall] = ACTIONS(3144),
    [anon_sym___fastcall] = ACTIONS(3144),
    [anon_sym___thiscall] = ACTIONS(3144),
    [anon_sym___vectorcall] = ACTIONS(3144),
    [anon_sym_LBRACE] = ACTIONS(3146),
    [anon_sym_signed] = ACTIONS(3144),
    [anon_sym_unsigned] = ACTIONS(3144),
    [anon_sym_long] = ACTIONS(3144),
    [anon_sym_short] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3144),
    [anon_sym_static] = ACTIONS(3144),
    [anon_sym_register] = ACTIONS(3144),
    [anon_sym_inline] = ACTIONS(3144),
    [anon_sym___inline] = ACTIONS(3144),
    [anon_sym___inline__] = ACTIONS(3144),
    [anon_sym___forceinline] = ACTIONS(3144),
    [anon_sym_thread_local] = ACTIONS(3144),
    [anon_sym___thread] = ACTIONS(3144),
    [anon_sym_const] = ACTIONS(3144),
    [anon_sym_constexpr] = ACTIONS(3144),
    [anon_sym_volatile] = ACTIONS(3144),
    [anon_sym_restrict] = ACTIONS(3144),
    [anon_sym___restrict__] = ACTIONS(3144),
    [anon_sym__Atomic] = ACTIONS(3144),
    [anon_sym__Noreturn] = ACTIONS(3144),
    [anon_sym_noreturn] = ACTIONS(3144),
    [anon_sym_mutable] = ACTIONS(3144),
    [anon_sym_constinit] = ACTIONS(3144),
    [anon_sym_consteval] = ACTIONS(3144),
    [anon_sym_PROGMEM] = ACTIONS(3144),
    [aux_sym_primitive_type_token1] = ACTIONS(3144),
    [anon_sym_byte] = ACTIONS(3144),
    [anon_sym_word] = ACTIONS(3144),
    [anon_sym_enum] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_struct] = ACTIONS(3144),
    [anon_sym_union] = ACTIONS(3144),
    [anon_sym_if] = ACTIONS(3144),
    [anon_sym_else] = ACTIONS(3144),
    [anon_sym_switch] = ACTIONS(3144),
    [anon_sym_case] = ACTIONS(3144),
    [anon_sym_default] = ACTIONS(3144),
    [anon_sym_while] = ACTIONS(3144),
    [anon_sym_do] = ACTIONS(3144),
    [anon_sym_for] = ACTIONS(3144),
    [anon_sym_return] = ACTIONS(3144),
    [anon_sym_break] = ACTIONS(3144),
    [anon_sym_continue] = ACTIONS(3144),
    [anon_sym_goto] = ACTIONS(3144),
    [anon_sym___try] = ACTIONS(3144),
    [anon_sym___leave] = ACTIONS(3144),
    [anon_sym_not] = ACTIONS(3144),
    [anon_sym_compl] = ACTIONS(3144),
    [anon_sym_DASH_DASH] = ACTIONS(3146),
    [anon_sym_PLUS_PLUS] = ACTIONS(3146),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3144),
    [anon_sym___alignof] = ACTIONS(3144),
    [anon_sym__alignof] = ACTIONS(3144),
    [anon_sym_alignof] = ACTIONS(3144),
    [anon_sym__Alignof] = ACTIONS(3144),
    [anon_sym_offsetof] = ACTIONS(3144),
    [anon_sym__Generic] = ACTIONS(3144),
    [anon_sym_asm] = ACTIONS(3144),
    [anon_sym___asm__] = ACTIONS(3144),
    [aux_sym_number_literal_token1] = ACTIONS(3146),
    [aux_sym_number_literal_token2] = ACTIONS(3144),
    [anon_sym_L_SQUOTE] = ACTIONS(3146),
    [anon_sym_u_SQUOTE] = ACTIONS(3146),
    [anon_sym_U_SQUOTE] = ACTIONS(3146),
    [anon_sym_u8_SQUOTE] = ACTIONS(3146),
    [anon_sym_SQUOTE] = ACTIONS(3146),
    [anon_sym_L_DQUOTE] = ACTIONS(3146),
    [anon_sym_u_DQUOTE] = ACTIONS(3146),
    [anon_sym_U_DQUOTE] = ACTIONS(3146),
    [anon_sym_u8_DQUOTE] = ACTIONS(3146),
    [anon_sym_DQUOTE] = ACTIONS(3146),
    [sym_true] = ACTIONS(3144),
    [sym_false] = ACTIONS(3144),
    [anon_sym_NULL] = ACTIONS(3144),
    [anon_sym_nullptr] = ACTIONS(3144),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3144),
    [anon_sym_decltype] = ACTIONS(3144),
    [anon_sym_virtual] = ACTIONS(3144),
    [anon_sym_alignas] = ACTIONS(3144),
    [anon_sym_explicit] = ACTIONS(3144),
    [anon_sym_typename] = ACTIONS(3144),
    [anon_sym_template] = ACTIONS(3144),
    [anon_sym_operator] = ACTIONS(3144),
    [anon_sym_try] = ACTIONS(3144),
    [anon_sym_delete] = ACTIONS(3144),
    [anon_sym_throw] = ACTIONS(3144),
    [anon_sym_namespace] = ACTIONS(3144),
    [anon_sym_using] = ACTIONS(3144),
    [anon_sym_static_assert] = ACTIONS(3144),
    [anon_sym_concept] = ACTIONS(3144),
    [anon_sym_co_return] = ACTIONS(3144),
    [anon_sym_co_yield] = ACTIONS(3144),
    [anon_sym_R_DQUOTE] = ACTIONS(3146),
    [anon_sym_LR_DQUOTE] = ACTIONS(3146),
    [anon_sym_uR_DQUOTE] = ACTIONS(3146),
    [anon_sym_UR_DQUOTE] = ACTIONS(3146),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3146),
    [anon_sym_co_await] = ACTIONS(3144),
    [anon_sym_new] = ACTIONS(3144),
    [anon_sym_requires] = ACTIONS(3144),
    [sym_this] = ACTIONS(3144),
  },
  [361] = {
    [sym_type_qualifier] = STATE(4556),
    [sym__type_specifier] = STATE(5703),
    [sym_sized_type_specifier] = STATE(3397),
    [sym_primitive_type] = STATE(5893),
    [sym_enum_specifier] = STATE(3397),
    [sym_struct_specifier] = STATE(3397),
    [sym_union_specifier] = STATE(3397),
    [sym__expression] = STATE(5187),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_type_descriptor] = STATE(7914),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_placeholder_type_specifier] = STATE(3397),
    [sym_decltype_auto] = STATE(3398),
    [sym_decltype] = STATE(3383),
    [sym_class_specifier] = STATE(3397),
    [sym__class_name] = STATE(8471),
    [sym_dependent_type] = STATE(3397),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_type_parameter_pack_expansion] = STATE(8381),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6473),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym_user_defined_literal] = STATE(4248),
    [aux_sym__type_definition_type_repeat1] = STATE(4556),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2986),
    [anon_sym_unsigned] = ACTIONS(2986),
    [anon_sym_long] = ACTIONS(2986),
    [anon_sym_short] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2988),
    [anon_sym_byte] = ACTIONS(2988),
    [anon_sym_word] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2990),
    [anon_sym_class] = ACTIONS(2992),
    [anon_sym_struct] = ACTIONS(2994),
    [anon_sym_union] = ACTIONS(2996),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_GT2] = ACTIONS(3148),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [362] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_include_token1] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token2] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [aux_sym_preproc_else_token1] = ACTIONS(3082),
    [aux_sym_preproc_elif_token1] = ACTIONS(3082),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym___cdecl] = ACTIONS(3082),
    [anon_sym___clrcall] = ACTIONS(3082),
    [anon_sym___stdcall] = ACTIONS(3082),
    [anon_sym___fastcall] = ACTIONS(3082),
    [anon_sym___thiscall] = ACTIONS(3082),
    [anon_sym___vectorcall] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_else] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_goto] = ACTIONS(3082),
    [anon_sym___try] = ACTIONS(3082),
    [anon_sym___leave] = ACTIONS(3082),
    [anon_sym_not] = ACTIONS(3082),
    [anon_sym_compl] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_sizeof] = ACTIONS(3082),
    [anon_sym___alignof__] = ACTIONS(3082),
    [anon_sym___alignof] = ACTIONS(3082),
    [anon_sym__alignof] = ACTIONS(3082),
    [anon_sym_alignof] = ACTIONS(3082),
    [anon_sym__Alignof] = ACTIONS(3082),
    [anon_sym_offsetof] = ACTIONS(3082),
    [anon_sym__Generic] = ACTIONS(3082),
    [anon_sym_asm] = ACTIONS(3082),
    [anon_sym___asm__] = ACTIONS(3082),
    [aux_sym_number_literal_token1] = ACTIONS(3084),
    [aux_sym_number_literal_token2] = ACTIONS(3082),
    [anon_sym_L_SQUOTE] = ACTIONS(3084),
    [anon_sym_u_SQUOTE] = ACTIONS(3084),
    [anon_sym_U_SQUOTE] = ACTIONS(3084),
    [anon_sym_u8_SQUOTE] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_L_DQUOTE] = ACTIONS(3084),
    [anon_sym_u_DQUOTE] = ACTIONS(3084),
    [anon_sym_U_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8_DQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [anon_sym_NULL] = ACTIONS(3082),
    [anon_sym_nullptr] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
    [anon_sym_concept] = ACTIONS(3082),
    [anon_sym_co_return] = ACTIONS(3082),
    [anon_sym_co_yield] = ACTIONS(3082),
    [anon_sym_R_DQUOTE] = ACTIONS(3084),
    [anon_sym_LR_DQUOTE] = ACTIONS(3084),
    [anon_sym_uR_DQUOTE] = ACTIONS(3084),
    [anon_sym_UR_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3084),
    [anon_sym_co_await] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_requires] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
  },
  [363] = {
    [sym_identifier] = ACTIONS(3150),
    [aux_sym_preproc_include_token1] = ACTIONS(3150),
    [aux_sym_preproc_def_token1] = ACTIONS(3150),
    [aux_sym_preproc_if_token1] = ACTIONS(3150),
    [aux_sym_preproc_if_token2] = ACTIONS(3150),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3150),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3150),
    [aux_sym_preproc_else_token1] = ACTIONS(3150),
    [aux_sym_preproc_elif_token1] = ACTIONS(3150),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3150),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3150),
    [sym_preproc_directive] = ACTIONS(3150),
    [anon_sym_LPAREN2] = ACTIONS(3152),
    [anon_sym_BANG] = ACTIONS(3152),
    [anon_sym_TILDE] = ACTIONS(3152),
    [anon_sym_DASH] = ACTIONS(3150),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_STAR] = ACTIONS(3152),
    [anon_sym_AMP_AMP] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(3152),
    [anon_sym___extension__] = ACTIONS(3150),
    [anon_sym_typedef] = ACTIONS(3150),
    [anon_sym_extern] = ACTIONS(3150),
    [anon_sym___attribute__] = ACTIONS(3150),
    [anon_sym_COLON_COLON] = ACTIONS(3152),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3152),
    [anon_sym___declspec] = ACTIONS(3150),
    [anon_sym___based] = ACTIONS(3150),
    [anon_sym___cdecl] = ACTIONS(3150),
    [anon_sym___clrcall] = ACTIONS(3150),
    [anon_sym___stdcall] = ACTIONS(3150),
    [anon_sym___fastcall] = ACTIONS(3150),
    [anon_sym___thiscall] = ACTIONS(3150),
    [anon_sym___vectorcall] = ACTIONS(3150),
    [anon_sym_LBRACE] = ACTIONS(3152),
    [anon_sym_signed] = ACTIONS(3150),
    [anon_sym_unsigned] = ACTIONS(3150),
    [anon_sym_long] = ACTIONS(3150),
    [anon_sym_short] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3150),
    [anon_sym_static] = ACTIONS(3150),
    [anon_sym_register] = ACTIONS(3150),
    [anon_sym_inline] = ACTIONS(3150),
    [anon_sym___inline] = ACTIONS(3150),
    [anon_sym___inline__] = ACTIONS(3150),
    [anon_sym___forceinline] = ACTIONS(3150),
    [anon_sym_thread_local] = ACTIONS(3150),
    [anon_sym___thread] = ACTIONS(3150),
    [anon_sym_const] = ACTIONS(3150),
    [anon_sym_constexpr] = ACTIONS(3150),
    [anon_sym_volatile] = ACTIONS(3150),
    [anon_sym_restrict] = ACTIONS(3150),
    [anon_sym___restrict__] = ACTIONS(3150),
    [anon_sym__Atomic] = ACTIONS(3150),
    [anon_sym__Noreturn] = ACTIONS(3150),
    [anon_sym_noreturn] = ACTIONS(3150),
    [anon_sym_mutable] = ACTIONS(3150),
    [anon_sym_constinit] = ACTIONS(3150),
    [anon_sym_consteval] = ACTIONS(3150),
    [anon_sym_PROGMEM] = ACTIONS(3150),
    [aux_sym_primitive_type_token1] = ACTIONS(3150),
    [anon_sym_byte] = ACTIONS(3150),
    [anon_sym_word] = ACTIONS(3150),
    [anon_sym_enum] = ACTIONS(3150),
    [anon_sym_class] = ACTIONS(3150),
    [anon_sym_struct] = ACTIONS(3150),
    [anon_sym_union] = ACTIONS(3150),
    [anon_sym_if] = ACTIONS(3150),
    [anon_sym_else] = ACTIONS(3150),
    [anon_sym_switch] = ACTIONS(3150),
    [anon_sym_case] = ACTIONS(3150),
    [anon_sym_default] = ACTIONS(3150),
    [anon_sym_while] = ACTIONS(3150),
    [anon_sym_do] = ACTIONS(3150),
    [anon_sym_for] = ACTIONS(3150),
    [anon_sym_return] = ACTIONS(3150),
    [anon_sym_break] = ACTIONS(3150),
    [anon_sym_continue] = ACTIONS(3150),
    [anon_sym_goto] = ACTIONS(3150),
    [anon_sym___try] = ACTIONS(3150),
    [anon_sym___leave] = ACTIONS(3150),
    [anon_sym_not] = ACTIONS(3150),
    [anon_sym_compl] = ACTIONS(3150),
    [anon_sym_DASH_DASH] = ACTIONS(3152),
    [anon_sym_PLUS_PLUS] = ACTIONS(3152),
    [anon_sym_sizeof] = ACTIONS(3150),
    [anon_sym___alignof__] = ACTIONS(3150),
    [anon_sym___alignof] = ACTIONS(3150),
    [anon_sym__alignof] = ACTIONS(3150),
    [anon_sym_alignof] = ACTIONS(3150),
    [anon_sym__Alignof] = ACTIONS(3150),
    [anon_sym_offsetof] = ACTIONS(3150),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3150),
    [anon_sym___asm__] = ACTIONS(3150),
    [aux_sym_number_literal_token1] = ACTIONS(3152),
    [aux_sym_number_literal_token2] = ACTIONS(3150),
    [anon_sym_L_SQUOTE] = ACTIONS(3152),
    [anon_sym_u_SQUOTE] = ACTIONS(3152),
    [anon_sym_U_SQUOTE] = ACTIONS(3152),
    [anon_sym_u8_SQUOTE] = ACTIONS(3152),
    [anon_sym_SQUOTE] = ACTIONS(3152),
    [anon_sym_L_DQUOTE] = ACTIONS(3152),
    [anon_sym_u_DQUOTE] = ACTIONS(3152),
    [anon_sym_U_DQUOTE] = ACTIONS(3152),
    [anon_sym_u8_DQUOTE] = ACTIONS(3152),
    [anon_sym_DQUOTE] = ACTIONS(3152),
    [sym_true] = ACTIONS(3150),
    [sym_false] = ACTIONS(3150),
    [anon_sym_NULL] = ACTIONS(3150),
    [anon_sym_nullptr] = ACTIONS(3150),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3150),
    [anon_sym_decltype] = ACTIONS(3150),
    [anon_sym_virtual] = ACTIONS(3150),
    [anon_sym_alignas] = ACTIONS(3150),
    [anon_sym_explicit] = ACTIONS(3150),
    [anon_sym_typename] = ACTIONS(3150),
    [anon_sym_template] = ACTIONS(3150),
    [anon_sym_operator] = ACTIONS(3150),
    [anon_sym_try] = ACTIONS(3150),
    [anon_sym_delete] = ACTIONS(3150),
    [anon_sym_throw] = ACTIONS(3150),
    [anon_sym_namespace] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_static_assert] = ACTIONS(3150),
    [anon_sym_concept] = ACTIONS(3150),
    [anon_sym_co_return] = ACTIONS(3150),
    [anon_sym_co_yield] = ACTIONS(3150),
    [anon_sym_R_DQUOTE] = ACTIONS(3152),
    [anon_sym_LR_DQUOTE] = ACTIONS(3152),
    [anon_sym_uR_DQUOTE] = ACTIONS(3152),
    [anon_sym_UR_DQUOTE] = ACTIONS(3152),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3152),
    [anon_sym_co_await] = ACTIONS(3150),
    [anon_sym_new] = ACTIONS(3150),
    [anon_sym_requires] = ACTIONS(3150),
    [sym_this] = ACTIONS(3150),
  },
  [364] = {
    [sym_identifier] = ACTIONS(3154),
    [aux_sym_preproc_include_token1] = ACTIONS(3154),
    [aux_sym_preproc_def_token1] = ACTIONS(3154),
    [aux_sym_preproc_if_token1] = ACTIONS(3154),
    [aux_sym_preproc_if_token2] = ACTIONS(3154),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3154),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3154),
    [aux_sym_preproc_else_token1] = ACTIONS(3154),
    [aux_sym_preproc_elif_token1] = ACTIONS(3154),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3154),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3154),
    [sym_preproc_directive] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3156),
    [anon_sym_BANG] = ACTIONS(3156),
    [anon_sym_TILDE] = ACTIONS(3156),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_STAR] = ACTIONS(3156),
    [anon_sym_AMP_AMP] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3154),
    [anon_sym_SEMI] = ACTIONS(3156),
    [anon_sym___extension__] = ACTIONS(3154),
    [anon_sym_typedef] = ACTIONS(3154),
    [anon_sym_extern] = ACTIONS(3154),
    [anon_sym___attribute__] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3156),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3156),
    [anon_sym___declspec] = ACTIONS(3154),
    [anon_sym___based] = ACTIONS(3154),
    [anon_sym___cdecl] = ACTIONS(3154),
    [anon_sym___clrcall] = ACTIONS(3154),
    [anon_sym___stdcall] = ACTIONS(3154),
    [anon_sym___fastcall] = ACTIONS(3154),
    [anon_sym___thiscall] = ACTIONS(3154),
    [anon_sym___vectorcall] = ACTIONS(3154),
    [anon_sym_LBRACE] = ACTIONS(3156),
    [anon_sym_signed] = ACTIONS(3154),
    [anon_sym_unsigned] = ACTIONS(3154),
    [anon_sym_long] = ACTIONS(3154),
    [anon_sym_short] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_static] = ACTIONS(3154),
    [anon_sym_register] = ACTIONS(3154),
    [anon_sym_inline] = ACTIONS(3154),
    [anon_sym___inline] = ACTIONS(3154),
    [anon_sym___inline__] = ACTIONS(3154),
    [anon_sym___forceinline] = ACTIONS(3154),
    [anon_sym_thread_local] = ACTIONS(3154),
    [anon_sym___thread] = ACTIONS(3154),
    [anon_sym_const] = ACTIONS(3154),
    [anon_sym_constexpr] = ACTIONS(3154),
    [anon_sym_volatile] = ACTIONS(3154),
    [anon_sym_restrict] = ACTIONS(3154),
    [anon_sym___restrict__] = ACTIONS(3154),
    [anon_sym__Atomic] = ACTIONS(3154),
    [anon_sym__Noreturn] = ACTIONS(3154),
    [anon_sym_noreturn] = ACTIONS(3154),
    [anon_sym_mutable] = ACTIONS(3154),
    [anon_sym_constinit] = ACTIONS(3154),
    [anon_sym_consteval] = ACTIONS(3154),
    [anon_sym_PROGMEM] = ACTIONS(3154),
    [aux_sym_primitive_type_token1] = ACTIONS(3154),
    [anon_sym_byte] = ACTIONS(3154),
    [anon_sym_word] = ACTIONS(3154),
    [anon_sym_enum] = ACTIONS(3154),
    [anon_sym_class] = ACTIONS(3154),
    [anon_sym_struct] = ACTIONS(3154),
    [anon_sym_union] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_else] = ACTIONS(3154),
    [anon_sym_switch] = ACTIONS(3154),
    [anon_sym_case] = ACTIONS(3154),
    [anon_sym_default] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_break] = ACTIONS(3154),
    [anon_sym_continue] = ACTIONS(3154),
    [anon_sym_goto] = ACTIONS(3154),
    [anon_sym___try] = ACTIONS(3154),
    [anon_sym___leave] = ACTIONS(3154),
    [anon_sym_not] = ACTIONS(3154),
    [anon_sym_compl] = ACTIONS(3154),
    [anon_sym_DASH_DASH] = ACTIONS(3156),
    [anon_sym_PLUS_PLUS] = ACTIONS(3156),
    [anon_sym_sizeof] = ACTIONS(3154),
    [anon_sym___alignof__] = ACTIONS(3154),
    [anon_sym___alignof] = ACTIONS(3154),
    [anon_sym__alignof] = ACTIONS(3154),
    [anon_sym_alignof] = ACTIONS(3154),
    [anon_sym__Alignof] = ACTIONS(3154),
    [anon_sym_offsetof] = ACTIONS(3154),
    [anon_sym__Generic] = ACTIONS(3154),
    [anon_sym_asm] = ACTIONS(3154),
    [anon_sym___asm__] = ACTIONS(3154),
    [aux_sym_number_literal_token1] = ACTIONS(3156),
    [aux_sym_number_literal_token2] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3156),
    [anon_sym_u_DQUOTE] = ACTIONS(3156),
    [anon_sym_U_DQUOTE] = ACTIONS(3156),
    [anon_sym_u8_DQUOTE] = ACTIONS(3156),
    [anon_sym_DQUOTE] = ACTIONS(3156),
    [sym_true] = ACTIONS(3154),
    [sym_false] = ACTIONS(3154),
    [anon_sym_NULL] = ACTIONS(3154),
    [anon_sym_nullptr] = ACTIONS(3154),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3154),
    [anon_sym_decltype] = ACTIONS(3154),
    [anon_sym_virtual] = ACTIONS(3154),
    [anon_sym_alignas] = ACTIONS(3154),
    [anon_sym_explicit] = ACTIONS(3154),
    [anon_sym_typename] = ACTIONS(3154),
    [anon_sym_template] = ACTIONS(3154),
    [anon_sym_operator] = ACTIONS(3154),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_delete] = ACTIONS(3154),
    [anon_sym_throw] = ACTIONS(3154),
    [anon_sym_namespace] = ACTIONS(3154),
    [anon_sym_using] = ACTIONS(3154),
    [anon_sym_static_assert] = ACTIONS(3154),
    [anon_sym_concept] = ACTIONS(3154),
    [anon_sym_co_return] = ACTIONS(3154),
    [anon_sym_co_yield] = ACTIONS(3154),
    [anon_sym_R_DQUOTE] = ACTIONS(3156),
    [anon_sym_LR_DQUOTE] = ACTIONS(3156),
    [anon_sym_uR_DQUOTE] = ACTIONS(3156),
    [anon_sym_UR_DQUOTE] = ACTIONS(3156),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3156),
    [anon_sym_co_await] = ACTIONS(3154),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_requires] = ACTIONS(3154),
    [sym_this] = ACTIONS(3154),
  },
  [365] = {
    [sym_identifier] = ACTIONS(3158),
    [aux_sym_preproc_include_token1] = ACTIONS(3158),
    [aux_sym_preproc_def_token1] = ACTIONS(3158),
    [aux_sym_preproc_if_token1] = ACTIONS(3158),
    [aux_sym_preproc_if_token2] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3158),
    [aux_sym_preproc_else_token1] = ACTIONS(3158),
    [aux_sym_preproc_elif_token1] = ACTIONS(3158),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3158),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3158),
    [sym_preproc_directive] = ACTIONS(3158),
    [anon_sym_LPAREN2] = ACTIONS(3160),
    [anon_sym_BANG] = ACTIONS(3160),
    [anon_sym_TILDE] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_STAR] = ACTIONS(3160),
    [anon_sym_AMP_AMP] = ACTIONS(3160),
    [anon_sym_AMP] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym___extension__] = ACTIONS(3158),
    [anon_sym_typedef] = ACTIONS(3158),
    [anon_sym_extern] = ACTIONS(3158),
    [anon_sym___attribute__] = ACTIONS(3158),
    [anon_sym_COLON_COLON] = ACTIONS(3160),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3160),
    [anon_sym___declspec] = ACTIONS(3158),
    [anon_sym___based] = ACTIONS(3158),
    [anon_sym___cdecl] = ACTIONS(3158),
    [anon_sym___clrcall] = ACTIONS(3158),
    [anon_sym___stdcall] = ACTIONS(3158),
    [anon_sym___fastcall] = ACTIONS(3158),
    [anon_sym___thiscall] = ACTIONS(3158),
    [anon_sym___vectorcall] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_signed] = ACTIONS(3158),
    [anon_sym_unsigned] = ACTIONS(3158),
    [anon_sym_long] = ACTIONS(3158),
    [anon_sym_short] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_static] = ACTIONS(3158),
    [anon_sym_register] = ACTIONS(3158),
    [anon_sym_inline] = ACTIONS(3158),
    [anon_sym___inline] = ACTIONS(3158),
    [anon_sym___inline__] = ACTIONS(3158),
    [anon_sym___forceinline] = ACTIONS(3158),
    [anon_sym_thread_local] = ACTIONS(3158),
    [anon_sym___thread] = ACTIONS(3158),
    [anon_sym_const] = ACTIONS(3158),
    [anon_sym_constexpr] = ACTIONS(3158),
    [anon_sym_volatile] = ACTIONS(3158),
    [anon_sym_restrict] = ACTIONS(3158),
    [anon_sym___restrict__] = ACTIONS(3158),
    [anon_sym__Atomic] = ACTIONS(3158),
    [anon_sym__Noreturn] = ACTIONS(3158),
    [anon_sym_noreturn] = ACTIONS(3158),
    [anon_sym_mutable] = ACTIONS(3158),
    [anon_sym_constinit] = ACTIONS(3158),
    [anon_sym_consteval] = ACTIONS(3158),
    [anon_sym_PROGMEM] = ACTIONS(3158),
    [aux_sym_primitive_type_token1] = ACTIONS(3158),
    [anon_sym_byte] = ACTIONS(3158),
    [anon_sym_word] = ACTIONS(3158),
    [anon_sym_enum] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(3158),
    [anon_sym_struct] = ACTIONS(3158),
    [anon_sym_union] = ACTIONS(3158),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_else] = ACTIONS(3158),
    [anon_sym_switch] = ACTIONS(3158),
    [anon_sym_case] = ACTIONS(3158),
    [anon_sym_default] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_for] = ACTIONS(3158),
    [anon_sym_return] = ACTIONS(3158),
    [anon_sym_break] = ACTIONS(3158),
    [anon_sym_continue] = ACTIONS(3158),
    [anon_sym_goto] = ACTIONS(3158),
    [anon_sym___try] = ACTIONS(3158),
    [anon_sym___leave] = ACTIONS(3158),
    [anon_sym_not] = ACTIONS(3158),
    [anon_sym_compl] = ACTIONS(3158),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_sizeof] = ACTIONS(3158),
    [anon_sym___alignof__] = ACTIONS(3158),
    [anon_sym___alignof] = ACTIONS(3158),
    [anon_sym__alignof] = ACTIONS(3158),
    [anon_sym_alignof] = ACTIONS(3158),
    [anon_sym__Alignof] = ACTIONS(3158),
    [anon_sym_offsetof] = ACTIONS(3158),
    [anon_sym__Generic] = ACTIONS(3158),
    [anon_sym_asm] = ACTIONS(3158),
    [anon_sym___asm__] = ACTIONS(3158),
    [aux_sym_number_literal_token1] = ACTIONS(3160),
    [aux_sym_number_literal_token2] = ACTIONS(3158),
    [anon_sym_L_SQUOTE] = ACTIONS(3160),
    [anon_sym_u_SQUOTE] = ACTIONS(3160),
    [anon_sym_U_SQUOTE] = ACTIONS(3160),
    [anon_sym_u8_SQUOTE] = ACTIONS(3160),
    [anon_sym_SQUOTE] = ACTIONS(3160),
    [anon_sym_L_DQUOTE] = ACTIONS(3160),
    [anon_sym_u_DQUOTE] = ACTIONS(3160),
    [anon_sym_U_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8_DQUOTE] = ACTIONS(3160),
    [anon_sym_DQUOTE] = ACTIONS(3160),
    [sym_true] = ACTIONS(3158),
    [sym_false] = ACTIONS(3158),
    [anon_sym_NULL] = ACTIONS(3158),
    [anon_sym_nullptr] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3158),
    [anon_sym_decltype] = ACTIONS(3158),
    [anon_sym_virtual] = ACTIONS(3158),
    [anon_sym_alignas] = ACTIONS(3158),
    [anon_sym_explicit] = ACTIONS(3158),
    [anon_sym_typename] = ACTIONS(3158),
    [anon_sym_template] = ACTIONS(3158),
    [anon_sym_operator] = ACTIONS(3158),
    [anon_sym_try] = ACTIONS(3158),
    [anon_sym_delete] = ACTIONS(3158),
    [anon_sym_throw] = ACTIONS(3158),
    [anon_sym_namespace] = ACTIONS(3158),
    [anon_sym_using] = ACTIONS(3158),
    [anon_sym_static_assert] = ACTIONS(3158),
    [anon_sym_concept] = ACTIONS(3158),
    [anon_sym_co_return] = ACTIONS(3158),
    [anon_sym_co_yield] = ACTIONS(3158),
    [anon_sym_R_DQUOTE] = ACTIONS(3160),
    [anon_sym_LR_DQUOTE] = ACTIONS(3160),
    [anon_sym_uR_DQUOTE] = ACTIONS(3160),
    [anon_sym_UR_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3160),
    [anon_sym_co_await] = ACTIONS(3158),
    [anon_sym_new] = ACTIONS(3158),
    [anon_sym_requires] = ACTIONS(3158),
    [sym_this] = ACTIONS(3158),
  },
  [366] = {
    [sym_identifier] = ACTIONS(3162),
    [aux_sym_preproc_include_token1] = ACTIONS(3162),
    [aux_sym_preproc_def_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token2] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3162),
    [aux_sym_preproc_else_token1] = ACTIONS(3162),
    [aux_sym_preproc_elif_token1] = ACTIONS(3162),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3162),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3162),
    [sym_preproc_directive] = ACTIONS(3162),
    [anon_sym_LPAREN2] = ACTIONS(3164),
    [anon_sym_BANG] = ACTIONS(3164),
    [anon_sym_TILDE] = ACTIONS(3164),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_STAR] = ACTIONS(3164),
    [anon_sym_AMP_AMP] = ACTIONS(3164),
    [anon_sym_AMP] = ACTIONS(3162),
    [anon_sym_SEMI] = ACTIONS(3164),
    [anon_sym___extension__] = ACTIONS(3162),
    [anon_sym_typedef] = ACTIONS(3162),
    [anon_sym_extern] = ACTIONS(3162),
    [anon_sym___attribute__] = ACTIONS(3162),
    [anon_sym_COLON_COLON] = ACTIONS(3164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3164),
    [anon_sym___declspec] = ACTIONS(3162),
    [anon_sym___based] = ACTIONS(3162),
    [anon_sym___cdecl] = ACTIONS(3162),
    [anon_sym___clrcall] = ACTIONS(3162),
    [anon_sym___stdcall] = ACTIONS(3162),
    [anon_sym___fastcall] = ACTIONS(3162),
    [anon_sym___thiscall] = ACTIONS(3162),
    [anon_sym___vectorcall] = ACTIONS(3162),
    [anon_sym_LBRACE] = ACTIONS(3164),
    [anon_sym_signed] = ACTIONS(3162),
    [anon_sym_unsigned] = ACTIONS(3162),
    [anon_sym_long] = ACTIONS(3162),
    [anon_sym_short] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_register] = ACTIONS(3162),
    [anon_sym_inline] = ACTIONS(3162),
    [anon_sym___inline] = ACTIONS(3162),
    [anon_sym___inline__] = ACTIONS(3162),
    [anon_sym___forceinline] = ACTIONS(3162),
    [anon_sym_thread_local] = ACTIONS(3162),
    [anon_sym___thread] = ACTIONS(3162),
    [anon_sym_const] = ACTIONS(3162),
    [anon_sym_constexpr] = ACTIONS(3162),
    [anon_sym_volatile] = ACTIONS(3162),
    [anon_sym_restrict] = ACTIONS(3162),
    [anon_sym___restrict__] = ACTIONS(3162),
    [anon_sym__Atomic] = ACTIONS(3162),
    [anon_sym__Noreturn] = ACTIONS(3162),
    [anon_sym_noreturn] = ACTIONS(3162),
    [anon_sym_mutable] = ACTIONS(3162),
    [anon_sym_constinit] = ACTIONS(3162),
    [anon_sym_consteval] = ACTIONS(3162),
    [anon_sym_PROGMEM] = ACTIONS(3162),
    [aux_sym_primitive_type_token1] = ACTIONS(3162),
    [anon_sym_byte] = ACTIONS(3162),
    [anon_sym_word] = ACTIONS(3162),
    [anon_sym_enum] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_struct] = ACTIONS(3162),
    [anon_sym_union] = ACTIONS(3162),
    [anon_sym_if] = ACTIONS(3162),
    [anon_sym_else] = ACTIONS(3162),
    [anon_sym_switch] = ACTIONS(3162),
    [anon_sym_case] = ACTIONS(3162),
    [anon_sym_default] = ACTIONS(3162),
    [anon_sym_while] = ACTIONS(3162),
    [anon_sym_do] = ACTIONS(3162),
    [anon_sym_for] = ACTIONS(3162),
    [anon_sym_return] = ACTIONS(3162),
    [anon_sym_break] = ACTIONS(3162),
    [anon_sym_continue] = ACTIONS(3162),
    [anon_sym_goto] = ACTIONS(3162),
    [anon_sym___try] = ACTIONS(3162),
    [anon_sym___leave] = ACTIONS(3162),
    [anon_sym_not] = ACTIONS(3162),
    [anon_sym_compl] = ACTIONS(3162),
    [anon_sym_DASH_DASH] = ACTIONS(3164),
    [anon_sym_PLUS_PLUS] = ACTIONS(3164),
    [anon_sym_sizeof] = ACTIONS(3162),
    [anon_sym___alignof__] = ACTIONS(3162),
    [anon_sym___alignof] = ACTIONS(3162),
    [anon_sym__alignof] = ACTIONS(3162),
    [anon_sym_alignof] = ACTIONS(3162),
    [anon_sym__Alignof] = ACTIONS(3162),
    [anon_sym_offsetof] = ACTIONS(3162),
    [anon_sym__Generic] = ACTIONS(3162),
    [anon_sym_asm] = ACTIONS(3162),
    [anon_sym___asm__] = ACTIONS(3162),
    [aux_sym_number_literal_token1] = ACTIONS(3164),
    [aux_sym_number_literal_token2] = ACTIONS(3162),
    [anon_sym_L_SQUOTE] = ACTIONS(3164),
    [anon_sym_u_SQUOTE] = ACTIONS(3164),
    [anon_sym_U_SQUOTE] = ACTIONS(3164),
    [anon_sym_u8_SQUOTE] = ACTIONS(3164),
    [anon_sym_SQUOTE] = ACTIONS(3164),
    [anon_sym_L_DQUOTE] = ACTIONS(3164),
    [anon_sym_u_DQUOTE] = ACTIONS(3164),
    [anon_sym_U_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8_DQUOTE] = ACTIONS(3164),
    [anon_sym_DQUOTE] = ACTIONS(3164),
    [sym_true] = ACTIONS(3162),
    [sym_false] = ACTIONS(3162),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3162),
    [anon_sym_decltype] = ACTIONS(3162),
    [anon_sym_virtual] = ACTIONS(3162),
    [anon_sym_alignas] = ACTIONS(3162),
    [anon_sym_explicit] = ACTIONS(3162),
    [anon_sym_typename] = ACTIONS(3162),
    [anon_sym_template] = ACTIONS(3162),
    [anon_sym_operator] = ACTIONS(3162),
    [anon_sym_try] = ACTIONS(3162),
    [anon_sym_delete] = ACTIONS(3162),
    [anon_sym_throw] = ACTIONS(3162),
    [anon_sym_namespace] = ACTIONS(3162),
    [anon_sym_using] = ACTIONS(3162),
    [anon_sym_static_assert] = ACTIONS(3162),
    [anon_sym_concept] = ACTIONS(3162),
    [anon_sym_co_return] = ACTIONS(3162),
    [anon_sym_co_yield] = ACTIONS(3162),
    [anon_sym_R_DQUOTE] = ACTIONS(3164),
    [anon_sym_LR_DQUOTE] = ACTIONS(3164),
    [anon_sym_uR_DQUOTE] = ACTIONS(3164),
    [anon_sym_UR_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3164),
    [anon_sym_co_await] = ACTIONS(3162),
    [anon_sym_new] = ACTIONS(3162),
    [anon_sym_requires] = ACTIONS(3162),
    [sym_this] = ACTIONS(3162),
  },
  [367] = {
    [sym_type_qualifier] = STATE(4556),
    [sym__type_specifier] = STATE(5703),
    [sym_sized_type_specifier] = STATE(3397),
    [sym_primitive_type] = STATE(5893),
    [sym_enum_specifier] = STATE(3397),
    [sym_struct_specifier] = STATE(3397),
    [sym_union_specifier] = STATE(3397),
    [sym__expression] = STATE(5105),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_type_descriptor] = STATE(7722),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_placeholder_type_specifier] = STATE(3397),
    [sym_decltype_auto] = STATE(3398),
    [sym_decltype] = STATE(3383),
    [sym_class_specifier] = STATE(3397),
    [sym__class_name] = STATE(8471),
    [sym_dependent_type] = STATE(3397),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_type_parameter_pack_expansion] = STATE(8236),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6473),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym_user_defined_literal] = STATE(4248),
    [aux_sym__type_definition_type_repeat1] = STATE(4556),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2986),
    [anon_sym_unsigned] = ACTIONS(2986),
    [anon_sym_long] = ACTIONS(2986),
    [anon_sym_short] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2988),
    [anon_sym_byte] = ACTIONS(2988),
    [anon_sym_word] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2990),
    [anon_sym_class] = ACTIONS(2992),
    [anon_sym_struct] = ACTIONS(2994),
    [anon_sym_union] = ACTIONS(2996),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_GT2] = ACTIONS(3166),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [368] = {
    [sym_identifier] = ACTIONS(3168),
    [aux_sym_preproc_include_token1] = ACTIONS(3168),
    [aux_sym_preproc_def_token1] = ACTIONS(3168),
    [aux_sym_preproc_if_token1] = ACTIONS(3168),
    [aux_sym_preproc_if_token2] = ACTIONS(3168),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3168),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3168),
    [aux_sym_preproc_else_token1] = ACTIONS(3168),
    [aux_sym_preproc_elif_token1] = ACTIONS(3168),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3168),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3168),
    [sym_preproc_directive] = ACTIONS(3168),
    [anon_sym_LPAREN2] = ACTIONS(3170),
    [anon_sym_BANG] = ACTIONS(3170),
    [anon_sym_TILDE] = ACTIONS(3170),
    [anon_sym_DASH] = ACTIONS(3168),
    [anon_sym_PLUS] = ACTIONS(3168),
    [anon_sym_STAR] = ACTIONS(3170),
    [anon_sym_AMP_AMP] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3168),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym___extension__] = ACTIONS(3168),
    [anon_sym_typedef] = ACTIONS(3168),
    [anon_sym_extern] = ACTIONS(3168),
    [anon_sym___attribute__] = ACTIONS(3168),
    [anon_sym_COLON_COLON] = ACTIONS(3170),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3170),
    [anon_sym___declspec] = ACTIONS(3168),
    [anon_sym___based] = ACTIONS(3168),
    [anon_sym___cdecl] = ACTIONS(3168),
    [anon_sym___clrcall] = ACTIONS(3168),
    [anon_sym___stdcall] = ACTIONS(3168),
    [anon_sym___fastcall] = ACTIONS(3168),
    [anon_sym___thiscall] = ACTIONS(3168),
    [anon_sym___vectorcall] = ACTIONS(3168),
    [anon_sym_LBRACE] = ACTIONS(3170),
    [anon_sym_signed] = ACTIONS(3168),
    [anon_sym_unsigned] = ACTIONS(3168),
    [anon_sym_long] = ACTIONS(3168),
    [anon_sym_short] = ACTIONS(3168),
    [anon_sym_LBRACK] = ACTIONS(3168),
    [anon_sym_static] = ACTIONS(3168),
    [anon_sym_register] = ACTIONS(3168),
    [anon_sym_inline] = ACTIONS(3168),
    [anon_sym___inline] = ACTIONS(3168),
    [anon_sym___inline__] = ACTIONS(3168),
    [anon_sym___forceinline] = ACTIONS(3168),
    [anon_sym_thread_local] = ACTIONS(3168),
    [anon_sym___thread] = ACTIONS(3168),
    [anon_sym_const] = ACTIONS(3168),
    [anon_sym_constexpr] = ACTIONS(3168),
    [anon_sym_volatile] = ACTIONS(3168),
    [anon_sym_restrict] = ACTIONS(3168),
    [anon_sym___restrict__] = ACTIONS(3168),
    [anon_sym__Atomic] = ACTIONS(3168),
    [anon_sym__Noreturn] = ACTIONS(3168),
    [anon_sym_noreturn] = ACTIONS(3168),
    [anon_sym_mutable] = ACTIONS(3168),
    [anon_sym_constinit] = ACTIONS(3168),
    [anon_sym_consteval] = ACTIONS(3168),
    [anon_sym_PROGMEM] = ACTIONS(3168),
    [aux_sym_primitive_type_token1] = ACTIONS(3168),
    [anon_sym_byte] = ACTIONS(3168),
    [anon_sym_word] = ACTIONS(3168),
    [anon_sym_enum] = ACTIONS(3168),
    [anon_sym_class] = ACTIONS(3168),
    [anon_sym_struct] = ACTIONS(3168),
    [anon_sym_union] = ACTIONS(3168),
    [anon_sym_if] = ACTIONS(3168),
    [anon_sym_else] = ACTIONS(3168),
    [anon_sym_switch] = ACTIONS(3168),
    [anon_sym_case] = ACTIONS(3168),
    [anon_sym_default] = ACTIONS(3168),
    [anon_sym_while] = ACTIONS(3168),
    [anon_sym_do] = ACTIONS(3168),
    [anon_sym_for] = ACTIONS(3168),
    [anon_sym_return] = ACTIONS(3168),
    [anon_sym_break] = ACTIONS(3168),
    [anon_sym_continue] = ACTIONS(3168),
    [anon_sym_goto] = ACTIONS(3168),
    [anon_sym___try] = ACTIONS(3168),
    [anon_sym___leave] = ACTIONS(3168),
    [anon_sym_not] = ACTIONS(3168),
    [anon_sym_compl] = ACTIONS(3168),
    [anon_sym_DASH_DASH] = ACTIONS(3170),
    [anon_sym_PLUS_PLUS] = ACTIONS(3170),
    [anon_sym_sizeof] = ACTIONS(3168),
    [anon_sym___alignof__] = ACTIONS(3168),
    [anon_sym___alignof] = ACTIONS(3168),
    [anon_sym__alignof] = ACTIONS(3168),
    [anon_sym_alignof] = ACTIONS(3168),
    [anon_sym__Alignof] = ACTIONS(3168),
    [anon_sym_offsetof] = ACTIONS(3168),
    [anon_sym__Generic] = ACTIONS(3168),
    [anon_sym_asm] = ACTIONS(3168),
    [anon_sym___asm__] = ACTIONS(3168),
    [aux_sym_number_literal_token1] = ACTIONS(3170),
    [aux_sym_number_literal_token2] = ACTIONS(3168),
    [anon_sym_L_SQUOTE] = ACTIONS(3170),
    [anon_sym_u_SQUOTE] = ACTIONS(3170),
    [anon_sym_U_SQUOTE] = ACTIONS(3170),
    [anon_sym_u8_SQUOTE] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3170),
    [anon_sym_L_DQUOTE] = ACTIONS(3170),
    [anon_sym_u_DQUOTE] = ACTIONS(3170),
    [anon_sym_U_DQUOTE] = ACTIONS(3170),
    [anon_sym_u8_DQUOTE] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3170),
    [sym_true] = ACTIONS(3168),
    [sym_false] = ACTIONS(3168),
    [anon_sym_NULL] = ACTIONS(3168),
    [anon_sym_nullptr] = ACTIONS(3168),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3168),
    [anon_sym_decltype] = ACTIONS(3168),
    [anon_sym_virtual] = ACTIONS(3168),
    [anon_sym_alignas] = ACTIONS(3168),
    [anon_sym_explicit] = ACTIONS(3168),
    [anon_sym_typename] = ACTIONS(3168),
    [anon_sym_template] = ACTIONS(3168),
    [anon_sym_operator] = ACTIONS(3168),
    [anon_sym_try] = ACTIONS(3168),
    [anon_sym_delete] = ACTIONS(3168),
    [anon_sym_throw] = ACTIONS(3168),
    [anon_sym_namespace] = ACTIONS(3168),
    [anon_sym_using] = ACTIONS(3168),
    [anon_sym_static_assert] = ACTIONS(3168),
    [anon_sym_concept] = ACTIONS(3168),
    [anon_sym_co_return] = ACTIONS(3168),
    [anon_sym_co_yield] = ACTIONS(3168),
    [anon_sym_R_DQUOTE] = ACTIONS(3170),
    [anon_sym_LR_DQUOTE] = ACTIONS(3170),
    [anon_sym_uR_DQUOTE] = ACTIONS(3170),
    [anon_sym_UR_DQUOTE] = ACTIONS(3170),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3170),
    [anon_sym_co_await] = ACTIONS(3168),
    [anon_sym_new] = ACTIONS(3168),
    [anon_sym_requires] = ACTIONS(3168),
    [sym_this] = ACTIONS(3168),
  },
  [369] = {
    [sym_identifier] = ACTIONS(2927),
    [aux_sym_preproc_include_token1] = ACTIONS(2927),
    [aux_sym_preproc_def_token1] = ACTIONS(2927),
    [aux_sym_preproc_if_token1] = ACTIONS(2927),
    [aux_sym_preproc_if_token2] = ACTIONS(2927),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2927),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2927),
    [aux_sym_preproc_else_token1] = ACTIONS(2927),
    [aux_sym_preproc_elif_token1] = ACTIONS(2927),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2927),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2927),
    [sym_preproc_directive] = ACTIONS(2927),
    [anon_sym_LPAREN2] = ACTIONS(2932),
    [anon_sym_BANG] = ACTIONS(2932),
    [anon_sym_TILDE] = ACTIONS(2932),
    [anon_sym_DASH] = ACTIONS(2927),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2932),
    [anon_sym_AMP_AMP] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2927),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym___extension__] = ACTIONS(2927),
    [anon_sym_typedef] = ACTIONS(2927),
    [anon_sym_extern] = ACTIONS(2927),
    [anon_sym___attribute__] = ACTIONS(2927),
    [anon_sym_COLON_COLON] = ACTIONS(2932),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2932),
    [anon_sym___declspec] = ACTIONS(2927),
    [anon_sym___based] = ACTIONS(2927),
    [anon_sym___cdecl] = ACTIONS(2927),
    [anon_sym___clrcall] = ACTIONS(2927),
    [anon_sym___stdcall] = ACTIONS(2927),
    [anon_sym___fastcall] = ACTIONS(2927),
    [anon_sym___thiscall] = ACTIONS(2927),
    [anon_sym___vectorcall] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2932),
    [anon_sym_signed] = ACTIONS(2927),
    [anon_sym_unsigned] = ACTIONS(2927),
    [anon_sym_long] = ACTIONS(2927),
    [anon_sym_short] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_static] = ACTIONS(2927),
    [anon_sym_register] = ACTIONS(2927),
    [anon_sym_inline] = ACTIONS(2927),
    [anon_sym___inline] = ACTIONS(2927),
    [anon_sym___inline__] = ACTIONS(2927),
    [anon_sym___forceinline] = ACTIONS(2927),
    [anon_sym_thread_local] = ACTIONS(2927),
    [anon_sym___thread] = ACTIONS(2927),
    [anon_sym_const] = ACTIONS(2927),
    [anon_sym_constexpr] = ACTIONS(2927),
    [anon_sym_volatile] = ACTIONS(2927),
    [anon_sym_restrict] = ACTIONS(2927),
    [anon_sym___restrict__] = ACTIONS(2927),
    [anon_sym__Atomic] = ACTIONS(2927),
    [anon_sym__Noreturn] = ACTIONS(2927),
    [anon_sym_noreturn] = ACTIONS(2927),
    [anon_sym_mutable] = ACTIONS(2927),
    [anon_sym_constinit] = ACTIONS(2927),
    [anon_sym_consteval] = ACTIONS(2927),
    [anon_sym_PROGMEM] = ACTIONS(2927),
    [aux_sym_primitive_type_token1] = ACTIONS(2927),
    [anon_sym_byte] = ACTIONS(2927),
    [anon_sym_word] = ACTIONS(2927),
    [anon_sym_enum] = ACTIONS(2927),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_struct] = ACTIONS(2927),
    [anon_sym_union] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_else] = ACTIONS(2927),
    [anon_sym_switch] = ACTIONS(2927),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_default] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_goto] = ACTIONS(2927),
    [anon_sym___try] = ACTIONS(2927),
    [anon_sym___leave] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2927),
    [anon_sym_compl] = ACTIONS(2927),
    [anon_sym_DASH_DASH] = ACTIONS(2932),
    [anon_sym_PLUS_PLUS] = ACTIONS(2932),
    [anon_sym_sizeof] = ACTIONS(2927),
    [anon_sym___alignof__] = ACTIONS(2927),
    [anon_sym___alignof] = ACTIONS(2927),
    [anon_sym__alignof] = ACTIONS(2927),
    [anon_sym_alignof] = ACTIONS(2927),
    [anon_sym__Alignof] = ACTIONS(2927),
    [anon_sym_offsetof] = ACTIONS(2927),
    [anon_sym__Generic] = ACTIONS(2927),
    [anon_sym_asm] = ACTIONS(2927),
    [anon_sym___asm__] = ACTIONS(2927),
    [aux_sym_number_literal_token1] = ACTIONS(2932),
    [aux_sym_number_literal_token2] = ACTIONS(2927),
    [anon_sym_L_SQUOTE] = ACTIONS(2932),
    [anon_sym_u_SQUOTE] = ACTIONS(2932),
    [anon_sym_U_SQUOTE] = ACTIONS(2932),
    [anon_sym_u8_SQUOTE] = ACTIONS(2932),
    [anon_sym_SQUOTE] = ACTIONS(2932),
    [anon_sym_L_DQUOTE] = ACTIONS(2932),
    [anon_sym_u_DQUOTE] = ACTIONS(2932),
    [anon_sym_U_DQUOTE] = ACTIONS(2932),
    [anon_sym_u8_DQUOTE] = ACTIONS(2932),
    [anon_sym_DQUOTE] = ACTIONS(2932),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [anon_sym_NULL] = ACTIONS(2927),
    [anon_sym_nullptr] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2927),
    [anon_sym_decltype] = ACTIONS(2927),
    [anon_sym_virtual] = ACTIONS(2927),
    [anon_sym_alignas] = ACTIONS(2927),
    [anon_sym_explicit] = ACTIONS(2927),
    [anon_sym_typename] = ACTIONS(2927),
    [anon_sym_template] = ACTIONS(2927),
    [anon_sym_operator] = ACTIONS(2927),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_throw] = ACTIONS(2927),
    [anon_sym_namespace] = ACTIONS(2927),
    [anon_sym_using] = ACTIONS(2927),
    [anon_sym_static_assert] = ACTIONS(2927),
    [anon_sym_concept] = ACTIONS(2927),
    [anon_sym_co_return] = ACTIONS(2927),
    [anon_sym_co_yield] = ACTIONS(2927),
    [anon_sym_R_DQUOTE] = ACTIONS(2932),
    [anon_sym_LR_DQUOTE] = ACTIONS(2932),
    [anon_sym_uR_DQUOTE] = ACTIONS(2932),
    [anon_sym_UR_DQUOTE] = ACTIONS(2932),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2932),
    [anon_sym_co_await] = ACTIONS(2927),
    [anon_sym_new] = ACTIONS(2927),
    [anon_sym_requires] = ACTIONS(2927),
    [sym_this] = ACTIONS(2927),
  },
  [370] = {
    [sym_catch_clause] = STATE(274),
    [aux_sym_constructor_try_statement_repeat1] = STATE(274),
    [sym_identifier] = ACTIONS(2856),
    [aux_sym_preproc_include_token1] = ACTIONS(2856),
    [aux_sym_preproc_def_token1] = ACTIONS(2856),
    [aux_sym_preproc_if_token1] = ACTIONS(2856),
    [aux_sym_preproc_if_token2] = ACTIONS(2856),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2856),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2856),
    [aux_sym_preproc_else_token1] = ACTIONS(2856),
    [aux_sym_preproc_elif_token1] = ACTIONS(2856),
    [sym_preproc_directive] = ACTIONS(2856),
    [anon_sym_LPAREN2] = ACTIONS(2858),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2856),
    [anon_sym_PLUS] = ACTIONS(2856),
    [anon_sym_STAR] = ACTIONS(2858),
    [anon_sym_AMP_AMP] = ACTIONS(2858),
    [anon_sym_AMP] = ACTIONS(2856),
    [anon_sym_SEMI] = ACTIONS(2858),
    [anon_sym___extension__] = ACTIONS(2856),
    [anon_sym_typedef] = ACTIONS(2856),
    [anon_sym_extern] = ACTIONS(2856),
    [anon_sym___attribute__] = ACTIONS(2856),
    [anon_sym_COLON_COLON] = ACTIONS(2858),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2858),
    [anon_sym___declspec] = ACTIONS(2856),
    [anon_sym___based] = ACTIONS(2856),
    [anon_sym___cdecl] = ACTIONS(2856),
    [anon_sym___clrcall] = ACTIONS(2856),
    [anon_sym___stdcall] = ACTIONS(2856),
    [anon_sym___fastcall] = ACTIONS(2856),
    [anon_sym___thiscall] = ACTIONS(2856),
    [anon_sym___vectorcall] = ACTIONS(2856),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_signed] = ACTIONS(2856),
    [anon_sym_unsigned] = ACTIONS(2856),
    [anon_sym_long] = ACTIONS(2856),
    [anon_sym_short] = ACTIONS(2856),
    [anon_sym_LBRACK] = ACTIONS(2856),
    [anon_sym_static] = ACTIONS(2856),
    [anon_sym_register] = ACTIONS(2856),
    [anon_sym_inline] = ACTIONS(2856),
    [anon_sym___inline] = ACTIONS(2856),
    [anon_sym___inline__] = ACTIONS(2856),
    [anon_sym___forceinline] = ACTIONS(2856),
    [anon_sym_thread_local] = ACTIONS(2856),
    [anon_sym___thread] = ACTIONS(2856),
    [anon_sym_const] = ACTIONS(2856),
    [anon_sym_constexpr] = ACTIONS(2856),
    [anon_sym_volatile] = ACTIONS(2856),
    [anon_sym_restrict] = ACTIONS(2856),
    [anon_sym___restrict__] = ACTIONS(2856),
    [anon_sym__Atomic] = ACTIONS(2856),
    [anon_sym__Noreturn] = ACTIONS(2856),
    [anon_sym_noreturn] = ACTIONS(2856),
    [anon_sym_mutable] = ACTIONS(2856),
    [anon_sym_constinit] = ACTIONS(2856),
    [anon_sym_consteval] = ACTIONS(2856),
    [anon_sym_PROGMEM] = ACTIONS(2856),
    [aux_sym_primitive_type_token1] = ACTIONS(2856),
    [anon_sym_byte] = ACTIONS(2856),
    [anon_sym_word] = ACTIONS(2856),
    [anon_sym_enum] = ACTIONS(2856),
    [anon_sym_class] = ACTIONS(2856),
    [anon_sym_struct] = ACTIONS(2856),
    [anon_sym_union] = ACTIONS(2856),
    [anon_sym_if] = ACTIONS(2856),
    [anon_sym_switch] = ACTIONS(2856),
    [anon_sym_case] = ACTIONS(2856),
    [anon_sym_default] = ACTIONS(2856),
    [anon_sym_while] = ACTIONS(2856),
    [anon_sym_do] = ACTIONS(2856),
    [anon_sym_for] = ACTIONS(2856),
    [anon_sym_return] = ACTIONS(2856),
    [anon_sym_break] = ACTIONS(2856),
    [anon_sym_continue] = ACTIONS(2856),
    [anon_sym_goto] = ACTIONS(2856),
    [anon_sym___try] = ACTIONS(2856),
    [anon_sym___leave] = ACTIONS(2856),
    [anon_sym_not] = ACTIONS(2856),
    [anon_sym_compl] = ACTIONS(2856),
    [anon_sym_DASH_DASH] = ACTIONS(2858),
    [anon_sym_PLUS_PLUS] = ACTIONS(2858),
    [anon_sym_sizeof] = ACTIONS(2856),
    [anon_sym___alignof__] = ACTIONS(2856),
    [anon_sym___alignof] = ACTIONS(2856),
    [anon_sym__alignof] = ACTIONS(2856),
    [anon_sym_alignof] = ACTIONS(2856),
    [anon_sym__Alignof] = ACTIONS(2856),
    [anon_sym_offsetof] = ACTIONS(2856),
    [anon_sym__Generic] = ACTIONS(2856),
    [anon_sym_asm] = ACTIONS(2856),
    [anon_sym___asm__] = ACTIONS(2856),
    [aux_sym_number_literal_token1] = ACTIONS(2858),
    [aux_sym_number_literal_token2] = ACTIONS(2856),
    [anon_sym_L_SQUOTE] = ACTIONS(2858),
    [anon_sym_u_SQUOTE] = ACTIONS(2858),
    [anon_sym_U_SQUOTE] = ACTIONS(2858),
    [anon_sym_u8_SQUOTE] = ACTIONS(2858),
    [anon_sym_SQUOTE] = ACTIONS(2858),
    [anon_sym_L_DQUOTE] = ACTIONS(2858),
    [anon_sym_u_DQUOTE] = ACTIONS(2858),
    [anon_sym_U_DQUOTE] = ACTIONS(2858),
    [anon_sym_u8_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE] = ACTIONS(2858),
    [sym_true] = ACTIONS(2856),
    [sym_false] = ACTIONS(2856),
    [anon_sym_NULL] = ACTIONS(2856),
    [anon_sym_nullptr] = ACTIONS(2856),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2856),
    [anon_sym_decltype] = ACTIONS(2856),
    [anon_sym_virtual] = ACTIONS(2856),
    [anon_sym_alignas] = ACTIONS(2856),
    [anon_sym_explicit] = ACTIONS(2856),
    [anon_sym_typename] = ACTIONS(2856),
    [anon_sym_template] = ACTIONS(2856),
    [anon_sym_operator] = ACTIONS(2856),
    [anon_sym_try] = ACTIONS(2856),
    [anon_sym_delete] = ACTIONS(2856),
    [anon_sym_throw] = ACTIONS(2856),
    [anon_sym_namespace] = ACTIONS(2856),
    [anon_sym_using] = ACTIONS(2856),
    [anon_sym_static_assert] = ACTIONS(2856),
    [anon_sym_concept] = ACTIONS(2856),
    [anon_sym_co_return] = ACTIONS(2856),
    [anon_sym_co_yield] = ACTIONS(2856),
    [anon_sym_catch] = ACTIONS(2885),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_LR_DQUOTE] = ACTIONS(2858),
    [anon_sym_uR_DQUOTE] = ACTIONS(2858),
    [anon_sym_UR_DQUOTE] = ACTIONS(2858),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2858),
    [anon_sym_co_await] = ACTIONS(2856),
    [anon_sym_new] = ACTIONS(2856),
    [anon_sym_requires] = ACTIONS(2856),
    [sym_this] = ACTIONS(2856),
  },
  [371] = {
    [sym_identifier] = ACTIONS(3172),
    [aux_sym_preproc_include_token1] = ACTIONS(3172),
    [aux_sym_preproc_def_token1] = ACTIONS(3172),
    [aux_sym_preproc_if_token1] = ACTIONS(3172),
    [aux_sym_preproc_if_token2] = ACTIONS(3172),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3172),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3172),
    [aux_sym_preproc_else_token1] = ACTIONS(3172),
    [aux_sym_preproc_elif_token1] = ACTIONS(3172),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3172),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3172),
    [sym_preproc_directive] = ACTIONS(3172),
    [anon_sym_LPAREN2] = ACTIONS(3174),
    [anon_sym_BANG] = ACTIONS(3174),
    [anon_sym_TILDE] = ACTIONS(3174),
    [anon_sym_DASH] = ACTIONS(3172),
    [anon_sym_PLUS] = ACTIONS(3172),
    [anon_sym_STAR] = ACTIONS(3174),
    [anon_sym_AMP_AMP] = ACTIONS(3174),
    [anon_sym_AMP] = ACTIONS(3172),
    [anon_sym_SEMI] = ACTIONS(3174),
    [anon_sym___extension__] = ACTIONS(3172),
    [anon_sym_typedef] = ACTIONS(3172),
    [anon_sym_extern] = ACTIONS(3172),
    [anon_sym___attribute__] = ACTIONS(3172),
    [anon_sym_COLON_COLON] = ACTIONS(3174),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3174),
    [anon_sym___declspec] = ACTIONS(3172),
    [anon_sym___based] = ACTIONS(3172),
    [anon_sym___cdecl] = ACTIONS(3172),
    [anon_sym___clrcall] = ACTIONS(3172),
    [anon_sym___stdcall] = ACTIONS(3172),
    [anon_sym___fastcall] = ACTIONS(3172),
    [anon_sym___thiscall] = ACTIONS(3172),
    [anon_sym___vectorcall] = ACTIONS(3172),
    [anon_sym_LBRACE] = ACTIONS(3174),
    [anon_sym_signed] = ACTIONS(3172),
    [anon_sym_unsigned] = ACTIONS(3172),
    [anon_sym_long] = ACTIONS(3172),
    [anon_sym_short] = ACTIONS(3172),
    [anon_sym_LBRACK] = ACTIONS(3172),
    [anon_sym_static] = ACTIONS(3172),
    [anon_sym_register] = ACTIONS(3172),
    [anon_sym_inline] = ACTIONS(3172),
    [anon_sym___inline] = ACTIONS(3172),
    [anon_sym___inline__] = ACTIONS(3172),
    [anon_sym___forceinline] = ACTIONS(3172),
    [anon_sym_thread_local] = ACTIONS(3172),
    [anon_sym___thread] = ACTIONS(3172),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_constexpr] = ACTIONS(3172),
    [anon_sym_volatile] = ACTIONS(3172),
    [anon_sym_restrict] = ACTIONS(3172),
    [anon_sym___restrict__] = ACTIONS(3172),
    [anon_sym__Atomic] = ACTIONS(3172),
    [anon_sym__Noreturn] = ACTIONS(3172),
    [anon_sym_noreturn] = ACTIONS(3172),
    [anon_sym_mutable] = ACTIONS(3172),
    [anon_sym_constinit] = ACTIONS(3172),
    [anon_sym_consteval] = ACTIONS(3172),
    [anon_sym_PROGMEM] = ACTIONS(3172),
    [aux_sym_primitive_type_token1] = ACTIONS(3172),
    [anon_sym_byte] = ACTIONS(3172),
    [anon_sym_word] = ACTIONS(3172),
    [anon_sym_enum] = ACTIONS(3172),
    [anon_sym_class] = ACTIONS(3172),
    [anon_sym_struct] = ACTIONS(3172),
    [anon_sym_union] = ACTIONS(3172),
    [anon_sym_if] = ACTIONS(3172),
    [anon_sym_else] = ACTIONS(3172),
    [anon_sym_switch] = ACTIONS(3172),
    [anon_sym_case] = ACTIONS(3172),
    [anon_sym_default] = ACTIONS(3172),
    [anon_sym_while] = ACTIONS(3172),
    [anon_sym_do] = ACTIONS(3172),
    [anon_sym_for] = ACTIONS(3172),
    [anon_sym_return] = ACTIONS(3172),
    [anon_sym_break] = ACTIONS(3172),
    [anon_sym_continue] = ACTIONS(3172),
    [anon_sym_goto] = ACTIONS(3172),
    [anon_sym___try] = ACTIONS(3172),
    [anon_sym___leave] = ACTIONS(3172),
    [anon_sym_not] = ACTIONS(3172),
    [anon_sym_compl] = ACTIONS(3172),
    [anon_sym_DASH_DASH] = ACTIONS(3174),
    [anon_sym_PLUS_PLUS] = ACTIONS(3174),
    [anon_sym_sizeof] = ACTIONS(3172),
    [anon_sym___alignof__] = ACTIONS(3172),
    [anon_sym___alignof] = ACTIONS(3172),
    [anon_sym__alignof] = ACTIONS(3172),
    [anon_sym_alignof] = ACTIONS(3172),
    [anon_sym__Alignof] = ACTIONS(3172),
    [anon_sym_offsetof] = ACTIONS(3172),
    [anon_sym__Generic] = ACTIONS(3172),
    [anon_sym_asm] = ACTIONS(3172),
    [anon_sym___asm__] = ACTIONS(3172),
    [aux_sym_number_literal_token1] = ACTIONS(3174),
    [aux_sym_number_literal_token2] = ACTIONS(3172),
    [anon_sym_L_SQUOTE] = ACTIONS(3174),
    [anon_sym_u_SQUOTE] = ACTIONS(3174),
    [anon_sym_U_SQUOTE] = ACTIONS(3174),
    [anon_sym_u8_SQUOTE] = ACTIONS(3174),
    [anon_sym_SQUOTE] = ACTIONS(3174),
    [anon_sym_L_DQUOTE] = ACTIONS(3174),
    [anon_sym_u_DQUOTE] = ACTIONS(3174),
    [anon_sym_U_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8_DQUOTE] = ACTIONS(3174),
    [anon_sym_DQUOTE] = ACTIONS(3174),
    [sym_true] = ACTIONS(3172),
    [sym_false] = ACTIONS(3172),
    [anon_sym_NULL] = ACTIONS(3172),
    [anon_sym_nullptr] = ACTIONS(3172),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3172),
    [anon_sym_decltype] = ACTIONS(3172),
    [anon_sym_virtual] = ACTIONS(3172),
    [anon_sym_alignas] = ACTIONS(3172),
    [anon_sym_explicit] = ACTIONS(3172),
    [anon_sym_typename] = ACTIONS(3172),
    [anon_sym_template] = ACTIONS(3172),
    [anon_sym_operator] = ACTIONS(3172),
    [anon_sym_try] = ACTIONS(3172),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_throw] = ACTIONS(3172),
    [anon_sym_namespace] = ACTIONS(3172),
    [anon_sym_using] = ACTIONS(3172),
    [anon_sym_static_assert] = ACTIONS(3172),
    [anon_sym_concept] = ACTIONS(3172),
    [anon_sym_co_return] = ACTIONS(3172),
    [anon_sym_co_yield] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3172),
    [anon_sym_new] = ACTIONS(3172),
    [anon_sym_requires] = ACTIONS(3172),
    [sym_this] = ACTIONS(3172),
  },
  [372] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_include_token1] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [anon_sym_COMMA] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token2] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [aux_sym_preproc_else_token1] = ACTIONS(2267),
    [aux_sym_preproc_elif_token1] = ACTIONS(2267),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_BANG] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym___cdecl] = ACTIONS(2267),
    [anon_sym___clrcall] = ACTIONS(2267),
    [anon_sym___stdcall] = ACTIONS(2267),
    [anon_sym___fastcall] = ACTIONS(2267),
    [anon_sym___thiscall] = ACTIONS(2267),
    [anon_sym___vectorcall] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2265),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_case] = ACTIONS(2267),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_return] = ACTIONS(2267),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_continue] = ACTIONS(2267),
    [anon_sym_goto] = ACTIONS(2267),
    [anon_sym___try] = ACTIONS(2267),
    [anon_sym___leave] = ACTIONS(2267),
    [anon_sym_not] = ACTIONS(2267),
    [anon_sym_compl] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2265),
    [anon_sym_PLUS_PLUS] = ACTIONS(2265),
    [anon_sym_sizeof] = ACTIONS(2267),
    [anon_sym___alignof__] = ACTIONS(2267),
    [anon_sym___alignof] = ACTIONS(2267),
    [anon_sym__alignof] = ACTIONS(2267),
    [anon_sym_alignof] = ACTIONS(2267),
    [anon_sym__Alignof] = ACTIONS(2267),
    [anon_sym_offsetof] = ACTIONS(2267),
    [anon_sym__Generic] = ACTIONS(2267),
    [anon_sym_asm] = ACTIONS(2267),
    [anon_sym___asm__] = ACTIONS(2267),
    [aux_sym_number_literal_token1] = ACTIONS(2265),
    [aux_sym_number_literal_token2] = ACTIONS(2267),
    [anon_sym_L_SQUOTE] = ACTIONS(2265),
    [anon_sym_u_SQUOTE] = ACTIONS(2265),
    [anon_sym_U_SQUOTE] = ACTIONS(2265),
    [anon_sym_u8_SQUOTE] = ACTIONS(2265),
    [anon_sym_SQUOTE] = ACTIONS(2265),
    [anon_sym_L_DQUOTE] = ACTIONS(2265),
    [anon_sym_u_DQUOTE] = ACTIONS(2265),
    [anon_sym_U_DQUOTE] = ACTIONS(2265),
    [anon_sym_u8_DQUOTE] = ACTIONS(2265),
    [anon_sym_DQUOTE] = ACTIONS(2265),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [anon_sym_NULL] = ACTIONS(2267),
    [anon_sym_nullptr] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_try] = ACTIONS(2267),
    [anon_sym_delete] = ACTIONS(2267),
    [anon_sym_throw] = ACTIONS(2267),
    [anon_sym_namespace] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym_concept] = ACTIONS(2267),
    [anon_sym_co_return] = ACTIONS(2267),
    [anon_sym_co_yield] = ACTIONS(2267),
    [anon_sym_R_DQUOTE] = ACTIONS(2265),
    [anon_sym_LR_DQUOTE] = ACTIONS(2265),
    [anon_sym_uR_DQUOTE] = ACTIONS(2265),
    [anon_sym_UR_DQUOTE] = ACTIONS(2265),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2265),
    [anon_sym_co_await] = ACTIONS(2267),
    [anon_sym_new] = ACTIONS(2267),
    [anon_sym_requires] = ACTIONS(2267),
    [sym_this] = ACTIONS(2267),
  },
  [373] = {
    [sym_identifier] = ACTIONS(3178),
    [aux_sym_preproc_include_token1] = ACTIONS(3178),
    [aux_sym_preproc_def_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3178),
    [aux_sym_preproc_else_token1] = ACTIONS(3178),
    [aux_sym_preproc_elif_token1] = ACTIONS(3178),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3178),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3178),
    [sym_preproc_directive] = ACTIONS(3178),
    [anon_sym_LPAREN2] = ACTIONS(3180),
    [anon_sym_BANG] = ACTIONS(3180),
    [anon_sym_TILDE] = ACTIONS(3180),
    [anon_sym_DASH] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3178),
    [anon_sym_STAR] = ACTIONS(3180),
    [anon_sym_AMP_AMP] = ACTIONS(3180),
    [anon_sym_AMP] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3180),
    [anon_sym___extension__] = ACTIONS(3178),
    [anon_sym_typedef] = ACTIONS(3178),
    [anon_sym_extern] = ACTIONS(3178),
    [anon_sym___attribute__] = ACTIONS(3178),
    [anon_sym_COLON_COLON] = ACTIONS(3180),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3180),
    [anon_sym___declspec] = ACTIONS(3178),
    [anon_sym___based] = ACTIONS(3178),
    [anon_sym___cdecl] = ACTIONS(3178),
    [anon_sym___clrcall] = ACTIONS(3178),
    [anon_sym___stdcall] = ACTIONS(3178),
    [anon_sym___fastcall] = ACTIONS(3178),
    [anon_sym___thiscall] = ACTIONS(3178),
    [anon_sym___vectorcall] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3180),
    [anon_sym_signed] = ACTIONS(3178),
    [anon_sym_unsigned] = ACTIONS(3178),
    [anon_sym_long] = ACTIONS(3178),
    [anon_sym_short] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_static] = ACTIONS(3178),
    [anon_sym_register] = ACTIONS(3178),
    [anon_sym_inline] = ACTIONS(3178),
    [anon_sym___inline] = ACTIONS(3178),
    [anon_sym___inline__] = ACTIONS(3178),
    [anon_sym___forceinline] = ACTIONS(3178),
    [anon_sym_thread_local] = ACTIONS(3178),
    [anon_sym___thread] = ACTIONS(3178),
    [anon_sym_const] = ACTIONS(3178),
    [anon_sym_constexpr] = ACTIONS(3178),
    [anon_sym_volatile] = ACTIONS(3178),
    [anon_sym_restrict] = ACTIONS(3178),
    [anon_sym___restrict__] = ACTIONS(3178),
    [anon_sym__Atomic] = ACTIONS(3178),
    [anon_sym__Noreturn] = ACTIONS(3178),
    [anon_sym_noreturn] = ACTIONS(3178),
    [anon_sym_mutable] = ACTIONS(3178),
    [anon_sym_constinit] = ACTIONS(3178),
    [anon_sym_consteval] = ACTIONS(3178),
    [anon_sym_PROGMEM] = ACTIONS(3178),
    [aux_sym_primitive_type_token1] = ACTIONS(3178),
    [anon_sym_byte] = ACTIONS(3178),
    [anon_sym_word] = ACTIONS(3178),
    [anon_sym_enum] = ACTIONS(3178),
    [anon_sym_class] = ACTIONS(3178),
    [anon_sym_struct] = ACTIONS(3178),
    [anon_sym_union] = ACTIONS(3178),
    [anon_sym_if] = ACTIONS(3178),
    [anon_sym_switch] = ACTIONS(3178),
    [anon_sym_case] = ACTIONS(3178),
    [anon_sym_default] = ACTIONS(3178),
    [anon_sym_while] = ACTIONS(3178),
    [anon_sym_do] = ACTIONS(3178),
    [anon_sym_for] = ACTIONS(3178),
    [anon_sym_return] = ACTIONS(3178),
    [anon_sym_break] = ACTIONS(3178),
    [anon_sym_continue] = ACTIONS(3178),
    [anon_sym_goto] = ACTIONS(3178),
    [anon_sym___try] = ACTIONS(3178),
    [anon_sym___leave] = ACTIONS(3178),
    [anon_sym_not] = ACTIONS(3178),
    [anon_sym_compl] = ACTIONS(3178),
    [anon_sym_DASH_DASH] = ACTIONS(3180),
    [anon_sym_PLUS_PLUS] = ACTIONS(3180),
    [anon_sym_sizeof] = ACTIONS(3178),
    [anon_sym___alignof__] = ACTIONS(3178),
    [anon_sym___alignof] = ACTIONS(3178),
    [anon_sym__alignof] = ACTIONS(3178),
    [anon_sym_alignof] = ACTIONS(3178),
    [anon_sym__Alignof] = ACTIONS(3178),
    [anon_sym_offsetof] = ACTIONS(3178),
    [anon_sym__Generic] = ACTIONS(3178),
    [anon_sym_asm] = ACTIONS(3178),
    [anon_sym___asm__] = ACTIONS(3178),
    [aux_sym_number_literal_token1] = ACTIONS(3180),
    [aux_sym_number_literal_token2] = ACTIONS(3178),
    [anon_sym_L_SQUOTE] = ACTIONS(3180),
    [anon_sym_u_SQUOTE] = ACTIONS(3180),
    [anon_sym_U_SQUOTE] = ACTIONS(3180),
    [anon_sym_u8_SQUOTE] = ACTIONS(3180),
    [anon_sym_SQUOTE] = ACTIONS(3180),
    [anon_sym_L_DQUOTE] = ACTIONS(3180),
    [anon_sym_u_DQUOTE] = ACTIONS(3180),
    [anon_sym_U_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8_DQUOTE] = ACTIONS(3180),
    [anon_sym_DQUOTE] = ACTIONS(3180),
    [sym_true] = ACTIONS(3178),
    [sym_false] = ACTIONS(3178),
    [anon_sym_NULL] = ACTIONS(3178),
    [anon_sym_nullptr] = ACTIONS(3178),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3178),
    [anon_sym_decltype] = ACTIONS(3178),
    [anon_sym_virtual] = ACTIONS(3178),
    [anon_sym_alignas] = ACTIONS(3178),
    [anon_sym_explicit] = ACTIONS(3178),
    [anon_sym_typename] = ACTIONS(3178),
    [anon_sym_template] = ACTIONS(3178),
    [anon_sym_operator] = ACTIONS(3178),
    [anon_sym_try] = ACTIONS(3178),
    [anon_sym_delete] = ACTIONS(3178),
    [anon_sym_throw] = ACTIONS(3178),
    [anon_sym_namespace] = ACTIONS(3178),
    [anon_sym_using] = ACTIONS(3178),
    [anon_sym_static_assert] = ACTIONS(3178),
    [anon_sym_concept] = ACTIONS(3178),
    [anon_sym_co_return] = ACTIONS(3178),
    [anon_sym_co_yield] = ACTIONS(3178),
    [anon_sym_R_DQUOTE] = ACTIONS(3180),
    [anon_sym_LR_DQUOTE] = ACTIONS(3180),
    [anon_sym_uR_DQUOTE] = ACTIONS(3180),
    [anon_sym_UR_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3180),
    [anon_sym_co_await] = ACTIONS(3178),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3178),
    [sym_this] = ACTIONS(3178),
  },
  [374] = {
    [sym_identifier] = ACTIONS(3182),
    [aux_sym_preproc_include_token1] = ACTIONS(3182),
    [aux_sym_preproc_def_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token2] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [aux_sym_preproc_else_token1] = ACTIONS(3182),
    [aux_sym_preproc_elif_token1] = ACTIONS(3182),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3182),
    [sym_preproc_directive] = ACTIONS(3182),
    [anon_sym_LPAREN2] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym___extension__] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3182),
    [anon_sym_extern] = ACTIONS(3182),
    [anon_sym___attribute__] = ACTIONS(3182),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3184),
    [anon_sym___declspec] = ACTIONS(3182),
    [anon_sym___based] = ACTIONS(3182),
    [anon_sym___cdecl] = ACTIONS(3182),
    [anon_sym___clrcall] = ACTIONS(3182),
    [anon_sym___stdcall] = ACTIONS(3182),
    [anon_sym___fastcall] = ACTIONS(3182),
    [anon_sym___thiscall] = ACTIONS(3182),
    [anon_sym___vectorcall] = ACTIONS(3182),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_signed] = ACTIONS(3182),
    [anon_sym_unsigned] = ACTIONS(3182),
    [anon_sym_long] = ACTIONS(3182),
    [anon_sym_short] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_register] = ACTIONS(3182),
    [anon_sym_inline] = ACTIONS(3182),
    [anon_sym___inline] = ACTIONS(3182),
    [anon_sym___inline__] = ACTIONS(3182),
    [anon_sym___forceinline] = ACTIONS(3182),
    [anon_sym_thread_local] = ACTIONS(3182),
    [anon_sym___thread] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_constexpr] = ACTIONS(3182),
    [anon_sym_volatile] = ACTIONS(3182),
    [anon_sym_restrict] = ACTIONS(3182),
    [anon_sym___restrict__] = ACTIONS(3182),
    [anon_sym__Atomic] = ACTIONS(3182),
    [anon_sym__Noreturn] = ACTIONS(3182),
    [anon_sym_noreturn] = ACTIONS(3182),
    [anon_sym_mutable] = ACTIONS(3182),
    [anon_sym_constinit] = ACTIONS(3182),
    [anon_sym_consteval] = ACTIONS(3182),
    [anon_sym_PROGMEM] = ACTIONS(3182),
    [aux_sym_primitive_type_token1] = ACTIONS(3182),
    [anon_sym_byte] = ACTIONS(3182),
    [anon_sym_word] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_struct] = ACTIONS(3182),
    [anon_sym_union] = ACTIONS(3182),
    [anon_sym_if] = ACTIONS(3182),
    [anon_sym_switch] = ACTIONS(3182),
    [anon_sym_case] = ACTIONS(3182),
    [anon_sym_default] = ACTIONS(3182),
    [anon_sym_while] = ACTIONS(3182),
    [anon_sym_do] = ACTIONS(3182),
    [anon_sym_for] = ACTIONS(3182),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_break] = ACTIONS(3182),
    [anon_sym_continue] = ACTIONS(3182),
    [anon_sym_goto] = ACTIONS(3182),
    [anon_sym___try] = ACTIONS(3182),
    [anon_sym___leave] = ACTIONS(3182),
    [anon_sym_not] = ACTIONS(3182),
    [anon_sym_compl] = ACTIONS(3182),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_sizeof] = ACTIONS(3182),
    [anon_sym___alignof__] = ACTIONS(3182),
    [anon_sym___alignof] = ACTIONS(3182),
    [anon_sym__alignof] = ACTIONS(3182),
    [anon_sym_alignof] = ACTIONS(3182),
    [anon_sym__Alignof] = ACTIONS(3182),
    [anon_sym_offsetof] = ACTIONS(3182),
    [anon_sym__Generic] = ACTIONS(3182),
    [anon_sym_asm] = ACTIONS(3182),
    [anon_sym___asm__] = ACTIONS(3182),
    [aux_sym_number_literal_token1] = ACTIONS(3184),
    [aux_sym_number_literal_token2] = ACTIONS(3182),
    [anon_sym_L_SQUOTE] = ACTIONS(3184),
    [anon_sym_u_SQUOTE] = ACTIONS(3184),
    [anon_sym_U_SQUOTE] = ACTIONS(3184),
    [anon_sym_u8_SQUOTE] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3184),
    [anon_sym_L_DQUOTE] = ACTIONS(3184),
    [anon_sym_u_DQUOTE] = ACTIONS(3184),
    [anon_sym_U_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8_DQUOTE] = ACTIONS(3184),
    [anon_sym_DQUOTE] = ACTIONS(3184),
    [sym_true] = ACTIONS(3182),
    [sym_false] = ACTIONS(3182),
    [anon_sym_NULL] = ACTIONS(3182),
    [anon_sym_nullptr] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3182),
    [anon_sym_decltype] = ACTIONS(3182),
    [anon_sym_virtual] = ACTIONS(3182),
    [anon_sym_alignas] = ACTIONS(3182),
    [anon_sym_explicit] = ACTIONS(3182),
    [anon_sym_typename] = ACTIONS(3182),
    [anon_sym_template] = ACTIONS(3182),
    [anon_sym_operator] = ACTIONS(3182),
    [anon_sym_try] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3182),
    [anon_sym_throw] = ACTIONS(3182),
    [anon_sym_namespace] = ACTIONS(3182),
    [anon_sym_using] = ACTIONS(3182),
    [anon_sym_static_assert] = ACTIONS(3182),
    [anon_sym_concept] = ACTIONS(3182),
    [anon_sym_co_return] = ACTIONS(3182),
    [anon_sym_co_yield] = ACTIONS(3182),
    [anon_sym_R_DQUOTE] = ACTIONS(3184),
    [anon_sym_LR_DQUOTE] = ACTIONS(3184),
    [anon_sym_uR_DQUOTE] = ACTIONS(3184),
    [anon_sym_UR_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3184),
    [anon_sym_co_await] = ACTIONS(3182),
    [anon_sym_new] = ACTIONS(3182),
    [anon_sym_requires] = ACTIONS(3182),
    [sym_this] = ACTIONS(3182),
  },
  [375] = {
    [sym_identifier] = ACTIONS(3186),
    [aux_sym_preproc_include_token1] = ACTIONS(3186),
    [aux_sym_preproc_def_token1] = ACTIONS(3186),
    [aux_sym_preproc_if_token1] = ACTIONS(3186),
    [aux_sym_preproc_if_token2] = ACTIONS(3186),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3186),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3186),
    [aux_sym_preproc_else_token1] = ACTIONS(3186),
    [aux_sym_preproc_elif_token1] = ACTIONS(3186),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3186),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3186),
    [sym_preproc_directive] = ACTIONS(3186),
    [anon_sym_LPAREN2] = ACTIONS(3188),
    [anon_sym_BANG] = ACTIONS(3188),
    [anon_sym_TILDE] = ACTIONS(3188),
    [anon_sym_DASH] = ACTIONS(3186),
    [anon_sym_PLUS] = ACTIONS(3186),
    [anon_sym_STAR] = ACTIONS(3188),
    [anon_sym_AMP_AMP] = ACTIONS(3188),
    [anon_sym_AMP] = ACTIONS(3186),
    [anon_sym_SEMI] = ACTIONS(3188),
    [anon_sym___extension__] = ACTIONS(3186),
    [anon_sym_typedef] = ACTIONS(3186),
    [anon_sym_extern] = ACTIONS(3186),
    [anon_sym___attribute__] = ACTIONS(3186),
    [anon_sym_COLON_COLON] = ACTIONS(3188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3188),
    [anon_sym___declspec] = ACTIONS(3186),
    [anon_sym___based] = ACTIONS(3186),
    [anon_sym___cdecl] = ACTIONS(3186),
    [anon_sym___clrcall] = ACTIONS(3186),
    [anon_sym___stdcall] = ACTIONS(3186),
    [anon_sym___fastcall] = ACTIONS(3186),
    [anon_sym___thiscall] = ACTIONS(3186),
    [anon_sym___vectorcall] = ACTIONS(3186),
    [anon_sym_LBRACE] = ACTIONS(3188),
    [anon_sym_signed] = ACTIONS(3186),
    [anon_sym_unsigned] = ACTIONS(3186),
    [anon_sym_long] = ACTIONS(3186),
    [anon_sym_short] = ACTIONS(3186),
    [anon_sym_LBRACK] = ACTIONS(3186),
    [anon_sym_static] = ACTIONS(3186),
    [anon_sym_register] = ACTIONS(3186),
    [anon_sym_inline] = ACTIONS(3186),
    [anon_sym___inline] = ACTIONS(3186),
    [anon_sym___inline__] = ACTIONS(3186),
    [anon_sym___forceinline] = ACTIONS(3186),
    [anon_sym_thread_local] = ACTIONS(3186),
    [anon_sym___thread] = ACTIONS(3186),
    [anon_sym_const] = ACTIONS(3186),
    [anon_sym_constexpr] = ACTIONS(3186),
    [anon_sym_volatile] = ACTIONS(3186),
    [anon_sym_restrict] = ACTIONS(3186),
    [anon_sym___restrict__] = ACTIONS(3186),
    [anon_sym__Atomic] = ACTIONS(3186),
    [anon_sym__Noreturn] = ACTIONS(3186),
    [anon_sym_noreturn] = ACTIONS(3186),
    [anon_sym_mutable] = ACTIONS(3186),
    [anon_sym_constinit] = ACTIONS(3186),
    [anon_sym_consteval] = ACTIONS(3186),
    [anon_sym_PROGMEM] = ACTIONS(3186),
    [aux_sym_primitive_type_token1] = ACTIONS(3186),
    [anon_sym_byte] = ACTIONS(3186),
    [anon_sym_word] = ACTIONS(3186),
    [anon_sym_enum] = ACTIONS(3186),
    [anon_sym_class] = ACTIONS(3186),
    [anon_sym_struct] = ACTIONS(3186),
    [anon_sym_union] = ACTIONS(3186),
    [anon_sym_if] = ACTIONS(3186),
    [anon_sym_switch] = ACTIONS(3186),
    [anon_sym_case] = ACTIONS(3186),
    [anon_sym_default] = ACTIONS(3186),
    [anon_sym_while] = ACTIONS(3186),
    [anon_sym_do] = ACTIONS(3186),
    [anon_sym_for] = ACTIONS(3186),
    [anon_sym_return] = ACTIONS(3186),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_continue] = ACTIONS(3186),
    [anon_sym_goto] = ACTIONS(3186),
    [anon_sym___try] = ACTIONS(3186),
    [anon_sym___leave] = ACTIONS(3186),
    [anon_sym_not] = ACTIONS(3186),
    [anon_sym_compl] = ACTIONS(3186),
    [anon_sym_DASH_DASH] = ACTIONS(3188),
    [anon_sym_PLUS_PLUS] = ACTIONS(3188),
    [anon_sym_sizeof] = ACTIONS(3186),
    [anon_sym___alignof__] = ACTIONS(3186),
    [anon_sym___alignof] = ACTIONS(3186),
    [anon_sym__alignof] = ACTIONS(3186),
    [anon_sym_alignof] = ACTIONS(3186),
    [anon_sym__Alignof] = ACTIONS(3186),
    [anon_sym_offsetof] = ACTIONS(3186),
    [anon_sym__Generic] = ACTIONS(3186),
    [anon_sym_asm] = ACTIONS(3186),
    [anon_sym___asm__] = ACTIONS(3186),
    [aux_sym_number_literal_token1] = ACTIONS(3188),
    [aux_sym_number_literal_token2] = ACTIONS(3186),
    [anon_sym_L_SQUOTE] = ACTIONS(3188),
    [anon_sym_u_SQUOTE] = ACTIONS(3188),
    [anon_sym_U_SQUOTE] = ACTIONS(3188),
    [anon_sym_u8_SQUOTE] = ACTIONS(3188),
    [anon_sym_SQUOTE] = ACTIONS(3188),
    [anon_sym_L_DQUOTE] = ACTIONS(3188),
    [anon_sym_u_DQUOTE] = ACTIONS(3188),
    [anon_sym_U_DQUOTE] = ACTIONS(3188),
    [anon_sym_u8_DQUOTE] = ACTIONS(3188),
    [anon_sym_DQUOTE] = ACTIONS(3188),
    [sym_true] = ACTIONS(3186),
    [sym_false] = ACTIONS(3186),
    [anon_sym_NULL] = ACTIONS(3186),
    [anon_sym_nullptr] = ACTIONS(3186),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3186),
    [anon_sym_decltype] = ACTIONS(3186),
    [anon_sym_virtual] = ACTIONS(3186),
    [anon_sym_alignas] = ACTIONS(3186),
    [anon_sym_explicit] = ACTIONS(3186),
    [anon_sym_typename] = ACTIONS(3186),
    [anon_sym_template] = ACTIONS(3186),
    [anon_sym_operator] = ACTIONS(3186),
    [anon_sym_try] = ACTIONS(3186),
    [anon_sym_delete] = ACTIONS(3186),
    [anon_sym_throw] = ACTIONS(3186),
    [anon_sym_namespace] = ACTIONS(3186),
    [anon_sym_using] = ACTIONS(3186),
    [anon_sym_static_assert] = ACTIONS(3186),
    [anon_sym_concept] = ACTIONS(3186),
    [anon_sym_co_return] = ACTIONS(3186),
    [anon_sym_co_yield] = ACTIONS(3186),
    [anon_sym_R_DQUOTE] = ACTIONS(3188),
    [anon_sym_LR_DQUOTE] = ACTIONS(3188),
    [anon_sym_uR_DQUOTE] = ACTIONS(3188),
    [anon_sym_UR_DQUOTE] = ACTIONS(3188),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3188),
    [anon_sym_co_await] = ACTIONS(3186),
    [anon_sym_new] = ACTIONS(3186),
    [anon_sym_requires] = ACTIONS(3186),
    [sym_this] = ACTIONS(3186),
  },
  [376] = {
    [sym_catch_clause] = STATE(410),
    [aux_sym_constructor_try_statement_repeat1] = STATE(410),
    [sym_identifier] = ACTIONS(2850),
    [aux_sym_preproc_include_token1] = ACTIONS(2850),
    [aux_sym_preproc_def_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token2] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2850),
    [sym_preproc_directive] = ACTIONS(2850),
    [anon_sym_LPAREN2] = ACTIONS(2852),
    [anon_sym_BANG] = ACTIONS(2852),
    [anon_sym_TILDE] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(2850),
    [anon_sym_PLUS] = ACTIONS(2850),
    [anon_sym_STAR] = ACTIONS(2852),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_AMP] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2852),
    [anon_sym___extension__] = ACTIONS(2850),
    [anon_sym_typedef] = ACTIONS(2850),
    [anon_sym_extern] = ACTIONS(2850),
    [anon_sym___attribute__] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2852),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2852),
    [anon_sym___declspec] = ACTIONS(2850),
    [anon_sym___based] = ACTIONS(2850),
    [anon_sym___cdecl] = ACTIONS(2850),
    [anon_sym___clrcall] = ACTIONS(2850),
    [anon_sym___stdcall] = ACTIONS(2850),
    [anon_sym___fastcall] = ACTIONS(2850),
    [anon_sym___thiscall] = ACTIONS(2850),
    [anon_sym___vectorcall] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2852),
    [anon_sym_signed] = ACTIONS(2850),
    [anon_sym_unsigned] = ACTIONS(2850),
    [anon_sym_long] = ACTIONS(2850),
    [anon_sym_short] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2850),
    [anon_sym_register] = ACTIONS(2850),
    [anon_sym_inline] = ACTIONS(2850),
    [anon_sym___inline] = ACTIONS(2850),
    [anon_sym___inline__] = ACTIONS(2850),
    [anon_sym___forceinline] = ACTIONS(2850),
    [anon_sym_thread_local] = ACTIONS(2850),
    [anon_sym___thread] = ACTIONS(2850),
    [anon_sym_const] = ACTIONS(2850),
    [anon_sym_constexpr] = ACTIONS(2850),
    [anon_sym_volatile] = ACTIONS(2850),
    [anon_sym_restrict] = ACTIONS(2850),
    [anon_sym___restrict__] = ACTIONS(2850),
    [anon_sym__Atomic] = ACTIONS(2850),
    [anon_sym__Noreturn] = ACTIONS(2850),
    [anon_sym_noreturn] = ACTIONS(2850),
    [anon_sym_mutable] = ACTIONS(2850),
    [anon_sym_constinit] = ACTIONS(2850),
    [anon_sym_consteval] = ACTIONS(2850),
    [anon_sym_PROGMEM] = ACTIONS(2850),
    [aux_sym_primitive_type_token1] = ACTIONS(2850),
    [anon_sym_byte] = ACTIONS(2850),
    [anon_sym_word] = ACTIONS(2850),
    [anon_sym_enum] = ACTIONS(2850),
    [anon_sym_class] = ACTIONS(2850),
    [anon_sym_struct] = ACTIONS(2850),
    [anon_sym_union] = ACTIONS(2850),
    [anon_sym_if] = ACTIONS(2850),
    [anon_sym_else] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2850),
    [anon_sym_case] = ACTIONS(2850),
    [anon_sym_default] = ACTIONS(2850),
    [anon_sym_while] = ACTIONS(2850),
    [anon_sym_do] = ACTIONS(2850),
    [anon_sym_for] = ACTIONS(2850),
    [anon_sym_return] = ACTIONS(2850),
    [anon_sym_break] = ACTIONS(2850),
    [anon_sym_continue] = ACTIONS(2850),
    [anon_sym_goto] = ACTIONS(2850),
    [anon_sym___try] = ACTIONS(2850),
    [anon_sym___leave] = ACTIONS(2850),
    [anon_sym_not] = ACTIONS(2850),
    [anon_sym_compl] = ACTIONS(2850),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_sizeof] = ACTIONS(2850),
    [anon_sym___alignof__] = ACTIONS(2850),
    [anon_sym___alignof] = ACTIONS(2850),
    [anon_sym__alignof] = ACTIONS(2850),
    [anon_sym_alignof] = ACTIONS(2850),
    [anon_sym__Alignof] = ACTIONS(2850),
    [anon_sym_offsetof] = ACTIONS(2850),
    [anon_sym__Generic] = ACTIONS(2850),
    [anon_sym_asm] = ACTIONS(2850),
    [anon_sym___asm__] = ACTIONS(2850),
    [aux_sym_number_literal_token1] = ACTIONS(2852),
    [aux_sym_number_literal_token2] = ACTIONS(2850),
    [anon_sym_L_SQUOTE] = ACTIONS(2852),
    [anon_sym_u_SQUOTE] = ACTIONS(2852),
    [anon_sym_U_SQUOTE] = ACTIONS(2852),
    [anon_sym_u8_SQUOTE] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2852),
    [anon_sym_L_DQUOTE] = ACTIONS(2852),
    [anon_sym_u_DQUOTE] = ACTIONS(2852),
    [anon_sym_U_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8_DQUOTE] = ACTIONS(2852),
    [anon_sym_DQUOTE] = ACTIONS(2852),
    [sym_true] = ACTIONS(2850),
    [sym_false] = ACTIONS(2850),
    [anon_sym_NULL] = ACTIONS(2850),
    [anon_sym_nullptr] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2850),
    [anon_sym_decltype] = ACTIONS(2850),
    [anon_sym_virtual] = ACTIONS(2850),
    [anon_sym_alignas] = ACTIONS(2850),
    [anon_sym_explicit] = ACTIONS(2850),
    [anon_sym_typename] = ACTIONS(2850),
    [anon_sym_template] = ACTIONS(2850),
    [anon_sym_operator] = ACTIONS(2850),
    [anon_sym_try] = ACTIONS(2850),
    [anon_sym_delete] = ACTIONS(2850),
    [anon_sym_throw] = ACTIONS(2850),
    [anon_sym_namespace] = ACTIONS(2850),
    [anon_sym_using] = ACTIONS(2850),
    [anon_sym_static_assert] = ACTIONS(2850),
    [anon_sym_concept] = ACTIONS(2850),
    [anon_sym_co_return] = ACTIONS(2850),
    [anon_sym_co_yield] = ACTIONS(2850),
    [anon_sym_catch] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(2852),
    [anon_sym_LR_DQUOTE] = ACTIONS(2852),
    [anon_sym_uR_DQUOTE] = ACTIONS(2852),
    [anon_sym_UR_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2852),
    [anon_sym_co_await] = ACTIONS(2850),
    [anon_sym_new] = ACTIONS(2850),
    [anon_sym_requires] = ACTIONS(2850),
    [sym_this] = ACTIONS(2850),
  },
  [377] = {
    [sym_identifier] = ACTIONS(3192),
    [aux_sym_preproc_include_token1] = ACTIONS(3192),
    [aux_sym_preproc_def_token1] = ACTIONS(3192),
    [aux_sym_preproc_if_token1] = ACTIONS(3192),
    [aux_sym_preproc_if_token2] = ACTIONS(3192),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3192),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3192),
    [aux_sym_preproc_else_token1] = ACTIONS(3192),
    [aux_sym_preproc_elif_token1] = ACTIONS(3192),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3192),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3192),
    [sym_preproc_directive] = ACTIONS(3192),
    [anon_sym_LPAREN2] = ACTIONS(3194),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_DASH] = ACTIONS(3192),
    [anon_sym_PLUS] = ACTIONS(3192),
    [anon_sym_STAR] = ACTIONS(3194),
    [anon_sym_AMP_AMP] = ACTIONS(3194),
    [anon_sym_AMP] = ACTIONS(3192),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym___extension__] = ACTIONS(3192),
    [anon_sym_typedef] = ACTIONS(3192),
    [anon_sym_extern] = ACTIONS(3192),
    [anon_sym___attribute__] = ACTIONS(3192),
    [anon_sym_COLON_COLON] = ACTIONS(3194),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3194),
    [anon_sym___declspec] = ACTIONS(3192),
    [anon_sym___based] = ACTIONS(3192),
    [anon_sym___cdecl] = ACTIONS(3192),
    [anon_sym___clrcall] = ACTIONS(3192),
    [anon_sym___stdcall] = ACTIONS(3192),
    [anon_sym___fastcall] = ACTIONS(3192),
    [anon_sym___thiscall] = ACTIONS(3192),
    [anon_sym___vectorcall] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_signed] = ACTIONS(3192),
    [anon_sym_unsigned] = ACTIONS(3192),
    [anon_sym_long] = ACTIONS(3192),
    [anon_sym_short] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [anon_sym_static] = ACTIONS(3192),
    [anon_sym_register] = ACTIONS(3192),
    [anon_sym_inline] = ACTIONS(3192),
    [anon_sym___inline] = ACTIONS(3192),
    [anon_sym___inline__] = ACTIONS(3192),
    [anon_sym___forceinline] = ACTIONS(3192),
    [anon_sym_thread_local] = ACTIONS(3192),
    [anon_sym___thread] = ACTIONS(3192),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_constexpr] = ACTIONS(3192),
    [anon_sym_volatile] = ACTIONS(3192),
    [anon_sym_restrict] = ACTIONS(3192),
    [anon_sym___restrict__] = ACTIONS(3192),
    [anon_sym__Atomic] = ACTIONS(3192),
    [anon_sym__Noreturn] = ACTIONS(3192),
    [anon_sym_noreturn] = ACTIONS(3192),
    [anon_sym_mutable] = ACTIONS(3192),
    [anon_sym_constinit] = ACTIONS(3192),
    [anon_sym_consteval] = ACTIONS(3192),
    [anon_sym_PROGMEM] = ACTIONS(3192),
    [aux_sym_primitive_type_token1] = ACTIONS(3192),
    [anon_sym_byte] = ACTIONS(3192),
    [anon_sym_word] = ACTIONS(3192),
    [anon_sym_enum] = ACTIONS(3192),
    [anon_sym_class] = ACTIONS(3192),
    [anon_sym_struct] = ACTIONS(3192),
    [anon_sym_union] = ACTIONS(3192),
    [anon_sym_if] = ACTIONS(3192),
    [anon_sym_switch] = ACTIONS(3192),
    [anon_sym_case] = ACTIONS(3192),
    [anon_sym_default] = ACTIONS(3192),
    [anon_sym_while] = ACTIONS(3192),
    [anon_sym_do] = ACTIONS(3192),
    [anon_sym_for] = ACTIONS(3192),
    [anon_sym_return] = ACTIONS(3192),
    [anon_sym_break] = ACTIONS(3192),
    [anon_sym_continue] = ACTIONS(3192),
    [anon_sym_goto] = ACTIONS(3192),
    [anon_sym___try] = ACTIONS(3192),
    [anon_sym___leave] = ACTIONS(3192),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_compl] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3194),
    [anon_sym_PLUS_PLUS] = ACTIONS(3194),
    [anon_sym_sizeof] = ACTIONS(3192),
    [anon_sym___alignof__] = ACTIONS(3192),
    [anon_sym___alignof] = ACTIONS(3192),
    [anon_sym__alignof] = ACTIONS(3192),
    [anon_sym_alignof] = ACTIONS(3192),
    [anon_sym__Alignof] = ACTIONS(3192),
    [anon_sym_offsetof] = ACTIONS(3192),
    [anon_sym__Generic] = ACTIONS(3192),
    [anon_sym_asm] = ACTIONS(3192),
    [anon_sym___asm__] = ACTIONS(3192),
    [aux_sym_number_literal_token1] = ACTIONS(3194),
    [aux_sym_number_literal_token2] = ACTIONS(3192),
    [anon_sym_L_SQUOTE] = ACTIONS(3194),
    [anon_sym_u_SQUOTE] = ACTIONS(3194),
    [anon_sym_U_SQUOTE] = ACTIONS(3194),
    [anon_sym_u8_SQUOTE] = ACTIONS(3194),
    [anon_sym_SQUOTE] = ACTIONS(3194),
    [anon_sym_L_DQUOTE] = ACTIONS(3194),
    [anon_sym_u_DQUOTE] = ACTIONS(3194),
    [anon_sym_U_DQUOTE] = ACTIONS(3194),
    [anon_sym_u8_DQUOTE] = ACTIONS(3194),
    [anon_sym_DQUOTE] = ACTIONS(3194),
    [sym_true] = ACTIONS(3192),
    [sym_false] = ACTIONS(3192),
    [anon_sym_NULL] = ACTIONS(3192),
    [anon_sym_nullptr] = ACTIONS(3192),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3192),
    [anon_sym_decltype] = ACTIONS(3192),
    [anon_sym_virtual] = ACTIONS(3192),
    [anon_sym_alignas] = ACTIONS(3192),
    [anon_sym_explicit] = ACTIONS(3192),
    [anon_sym_typename] = ACTIONS(3192),
    [anon_sym_template] = ACTIONS(3192),
    [anon_sym_operator] = ACTIONS(3192),
    [anon_sym_try] = ACTIONS(3192),
    [anon_sym_delete] = ACTIONS(3192),
    [anon_sym_throw] = ACTIONS(3192),
    [anon_sym_namespace] = ACTIONS(3192),
    [anon_sym_using] = ACTIONS(3192),
    [anon_sym_static_assert] = ACTIONS(3192),
    [anon_sym_concept] = ACTIONS(3192),
    [anon_sym_co_return] = ACTIONS(3192),
    [anon_sym_co_yield] = ACTIONS(3192),
    [anon_sym_R_DQUOTE] = ACTIONS(3194),
    [anon_sym_LR_DQUOTE] = ACTIONS(3194),
    [anon_sym_uR_DQUOTE] = ACTIONS(3194),
    [anon_sym_UR_DQUOTE] = ACTIONS(3194),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3194),
    [anon_sym_co_await] = ACTIONS(3192),
    [anon_sym_new] = ACTIONS(3192),
    [anon_sym_requires] = ACTIONS(3192),
    [sym_this] = ACTIONS(3192),
  },
  [378] = {
    [sym_preproc_def] = STATE(414),
    [sym_preproc_function_def] = STATE(414),
    [sym_preproc_call] = STATE(414),
    [sym_preproc_if_in_field_declaration_list] = STATE(414),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(414),
    [sym_preproc_else_in_field_declaration_list] = STATE(9140),
    [sym_preproc_elif_in_field_declaration_list] = STATE(9140),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(9140),
    [sym_type_definition] = STATE(414),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6442),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7117),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(414),
    [sym_field_declaration] = STATE(414),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2239),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(414),
    [sym_operator_cast] = STATE(7514),
    [sym_inline_method_definition] = STATE(414),
    [sym__constructor_specifiers] = STATE(2239),
    [sym_operator_cast_definition] = STATE(414),
    [sym_operator_cast_declaration] = STATE(414),
    [sym_constructor_or_destructor_definition] = STATE(414),
    [sym_constructor_or_destructor_declaration] = STATE(414),
    [sym_friend_declaration] = STATE(414),
    [sym_access_specifier] = STATE(9047),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(414),
    [sym_alias_declaration] = STATE(414),
    [sym_static_assert_declaration] = STATE(414),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7514),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(414),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2239),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3198),
    [aux_sym_preproc_if_token1] = ACTIONS(3200),
    [aux_sym_preproc_if_token2] = ACTIONS(3202),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3204),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3204),
    [aux_sym_preproc_else_token1] = ACTIONS(3206),
    [aux_sym_preproc_elif_token1] = ACTIONS(3208),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3210),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3210),
    [sym_preproc_directive] = ACTIONS(3212),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3222),
    [anon_sym_typedef] = ACTIONS(3224),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3240),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3242),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3246),
    [anon_sym_static_assert] = ACTIONS(3248),
  },
  [379] = {
    [sym_identifier] = ACTIONS(3250),
    [aux_sym_preproc_include_token1] = ACTIONS(3250),
    [aux_sym_preproc_def_token1] = ACTIONS(3250),
    [aux_sym_preproc_if_token1] = ACTIONS(3250),
    [aux_sym_preproc_if_token2] = ACTIONS(3250),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3250),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3250),
    [aux_sym_preproc_else_token1] = ACTIONS(3250),
    [aux_sym_preproc_elif_token1] = ACTIONS(3250),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3250),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3250),
    [sym_preproc_directive] = ACTIONS(3250),
    [anon_sym_LPAREN2] = ACTIONS(3252),
    [anon_sym_BANG] = ACTIONS(3252),
    [anon_sym_TILDE] = ACTIONS(3252),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_STAR] = ACTIONS(3252),
    [anon_sym_AMP_AMP] = ACTIONS(3252),
    [anon_sym_AMP] = ACTIONS(3250),
    [anon_sym_SEMI] = ACTIONS(3252),
    [anon_sym___extension__] = ACTIONS(3250),
    [anon_sym_typedef] = ACTIONS(3250),
    [anon_sym_extern] = ACTIONS(3250),
    [anon_sym___attribute__] = ACTIONS(3250),
    [anon_sym_COLON_COLON] = ACTIONS(3252),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3252),
    [anon_sym___declspec] = ACTIONS(3250),
    [anon_sym___based] = ACTIONS(3250),
    [anon_sym___cdecl] = ACTIONS(3250),
    [anon_sym___clrcall] = ACTIONS(3250),
    [anon_sym___stdcall] = ACTIONS(3250),
    [anon_sym___fastcall] = ACTIONS(3250),
    [anon_sym___thiscall] = ACTIONS(3250),
    [anon_sym___vectorcall] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3252),
    [anon_sym_signed] = ACTIONS(3250),
    [anon_sym_unsigned] = ACTIONS(3250),
    [anon_sym_long] = ACTIONS(3250),
    [anon_sym_short] = ACTIONS(3250),
    [anon_sym_LBRACK] = ACTIONS(3250),
    [anon_sym_static] = ACTIONS(3250),
    [anon_sym_register] = ACTIONS(3250),
    [anon_sym_inline] = ACTIONS(3250),
    [anon_sym___inline] = ACTIONS(3250),
    [anon_sym___inline__] = ACTIONS(3250),
    [anon_sym___forceinline] = ACTIONS(3250),
    [anon_sym_thread_local] = ACTIONS(3250),
    [anon_sym___thread] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(3250),
    [anon_sym_constexpr] = ACTIONS(3250),
    [anon_sym_volatile] = ACTIONS(3250),
    [anon_sym_restrict] = ACTIONS(3250),
    [anon_sym___restrict__] = ACTIONS(3250),
    [anon_sym__Atomic] = ACTIONS(3250),
    [anon_sym__Noreturn] = ACTIONS(3250),
    [anon_sym_noreturn] = ACTIONS(3250),
    [anon_sym_mutable] = ACTIONS(3250),
    [anon_sym_constinit] = ACTIONS(3250),
    [anon_sym_consteval] = ACTIONS(3250),
    [anon_sym_PROGMEM] = ACTIONS(3250),
    [aux_sym_primitive_type_token1] = ACTIONS(3250),
    [anon_sym_byte] = ACTIONS(3250),
    [anon_sym_word] = ACTIONS(3250),
    [anon_sym_enum] = ACTIONS(3250),
    [anon_sym_class] = ACTIONS(3250),
    [anon_sym_struct] = ACTIONS(3250),
    [anon_sym_union] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_switch] = ACTIONS(3250),
    [anon_sym_case] = ACTIONS(3250),
    [anon_sym_default] = ACTIONS(3250),
    [anon_sym_while] = ACTIONS(3250),
    [anon_sym_do] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_goto] = ACTIONS(3250),
    [anon_sym___try] = ACTIONS(3250),
    [anon_sym___leave] = ACTIONS(3250),
    [anon_sym_not] = ACTIONS(3250),
    [anon_sym_compl] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3252),
    [anon_sym_PLUS_PLUS] = ACTIONS(3252),
    [anon_sym_sizeof] = ACTIONS(3250),
    [anon_sym___alignof__] = ACTIONS(3250),
    [anon_sym___alignof] = ACTIONS(3250),
    [anon_sym__alignof] = ACTIONS(3250),
    [anon_sym_alignof] = ACTIONS(3250),
    [anon_sym__Alignof] = ACTIONS(3250),
    [anon_sym_offsetof] = ACTIONS(3250),
    [anon_sym__Generic] = ACTIONS(3250),
    [anon_sym_asm] = ACTIONS(3250),
    [anon_sym___asm__] = ACTIONS(3250),
    [aux_sym_number_literal_token1] = ACTIONS(3252),
    [aux_sym_number_literal_token2] = ACTIONS(3250),
    [anon_sym_L_SQUOTE] = ACTIONS(3252),
    [anon_sym_u_SQUOTE] = ACTIONS(3252),
    [anon_sym_U_SQUOTE] = ACTIONS(3252),
    [anon_sym_u8_SQUOTE] = ACTIONS(3252),
    [anon_sym_SQUOTE] = ACTIONS(3252),
    [anon_sym_L_DQUOTE] = ACTIONS(3252),
    [anon_sym_u_DQUOTE] = ACTIONS(3252),
    [anon_sym_U_DQUOTE] = ACTIONS(3252),
    [anon_sym_u8_DQUOTE] = ACTIONS(3252),
    [anon_sym_DQUOTE] = ACTIONS(3252),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [anon_sym_NULL] = ACTIONS(3250),
    [anon_sym_nullptr] = ACTIONS(3250),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3250),
    [anon_sym_decltype] = ACTIONS(3250),
    [anon_sym_virtual] = ACTIONS(3250),
    [anon_sym_alignas] = ACTIONS(3250),
    [anon_sym_explicit] = ACTIONS(3250),
    [anon_sym_typename] = ACTIONS(3250),
    [anon_sym_template] = ACTIONS(3250),
    [anon_sym_operator] = ACTIONS(3250),
    [anon_sym_try] = ACTIONS(3250),
    [anon_sym_delete] = ACTIONS(3250),
    [anon_sym_throw] = ACTIONS(3250),
    [anon_sym_namespace] = ACTIONS(3250),
    [anon_sym_using] = ACTIONS(3250),
    [anon_sym_static_assert] = ACTIONS(3250),
    [anon_sym_concept] = ACTIONS(3250),
    [anon_sym_co_return] = ACTIONS(3250),
    [anon_sym_co_yield] = ACTIONS(3250),
    [anon_sym_R_DQUOTE] = ACTIONS(3252),
    [anon_sym_LR_DQUOTE] = ACTIONS(3252),
    [anon_sym_uR_DQUOTE] = ACTIONS(3252),
    [anon_sym_UR_DQUOTE] = ACTIONS(3252),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3252),
    [anon_sym_co_await] = ACTIONS(3250),
    [anon_sym_new] = ACTIONS(3250),
    [anon_sym_requires] = ACTIONS(3250),
    [sym_this] = ACTIONS(3250),
  },
  [380] = {
    [sym_identifier] = ACTIONS(3254),
    [aux_sym_preproc_include_token1] = ACTIONS(3254),
    [aux_sym_preproc_def_token1] = ACTIONS(3254),
    [aux_sym_preproc_if_token1] = ACTIONS(3254),
    [aux_sym_preproc_if_token2] = ACTIONS(3254),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3254),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3254),
    [aux_sym_preproc_else_token1] = ACTIONS(3254),
    [aux_sym_preproc_elif_token1] = ACTIONS(3254),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3254),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3254),
    [sym_preproc_directive] = ACTIONS(3254),
    [anon_sym_LPAREN2] = ACTIONS(3256),
    [anon_sym_BANG] = ACTIONS(3256),
    [anon_sym_TILDE] = ACTIONS(3256),
    [anon_sym_DASH] = ACTIONS(3254),
    [anon_sym_PLUS] = ACTIONS(3254),
    [anon_sym_STAR] = ACTIONS(3256),
    [anon_sym_AMP_AMP] = ACTIONS(3256),
    [anon_sym_AMP] = ACTIONS(3254),
    [anon_sym_SEMI] = ACTIONS(3256),
    [anon_sym___extension__] = ACTIONS(3254),
    [anon_sym_typedef] = ACTIONS(3254),
    [anon_sym_extern] = ACTIONS(3254),
    [anon_sym___attribute__] = ACTIONS(3254),
    [anon_sym_COLON_COLON] = ACTIONS(3256),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3256),
    [anon_sym___declspec] = ACTIONS(3254),
    [anon_sym___based] = ACTIONS(3254),
    [anon_sym___cdecl] = ACTIONS(3254),
    [anon_sym___clrcall] = ACTIONS(3254),
    [anon_sym___stdcall] = ACTIONS(3254),
    [anon_sym___fastcall] = ACTIONS(3254),
    [anon_sym___thiscall] = ACTIONS(3254),
    [anon_sym___vectorcall] = ACTIONS(3254),
    [anon_sym_LBRACE] = ACTIONS(3256),
    [anon_sym_signed] = ACTIONS(3254),
    [anon_sym_unsigned] = ACTIONS(3254),
    [anon_sym_long] = ACTIONS(3254),
    [anon_sym_short] = ACTIONS(3254),
    [anon_sym_LBRACK] = ACTIONS(3254),
    [anon_sym_static] = ACTIONS(3254),
    [anon_sym_register] = ACTIONS(3254),
    [anon_sym_inline] = ACTIONS(3254),
    [anon_sym___inline] = ACTIONS(3254),
    [anon_sym___inline__] = ACTIONS(3254),
    [anon_sym___forceinline] = ACTIONS(3254),
    [anon_sym_thread_local] = ACTIONS(3254),
    [anon_sym___thread] = ACTIONS(3254),
    [anon_sym_const] = ACTIONS(3254),
    [anon_sym_constexpr] = ACTIONS(3254),
    [anon_sym_volatile] = ACTIONS(3254),
    [anon_sym_restrict] = ACTIONS(3254),
    [anon_sym___restrict__] = ACTIONS(3254),
    [anon_sym__Atomic] = ACTIONS(3254),
    [anon_sym__Noreturn] = ACTIONS(3254),
    [anon_sym_noreturn] = ACTIONS(3254),
    [anon_sym_mutable] = ACTIONS(3254),
    [anon_sym_constinit] = ACTIONS(3254),
    [anon_sym_consteval] = ACTIONS(3254),
    [anon_sym_PROGMEM] = ACTIONS(3254),
    [aux_sym_primitive_type_token1] = ACTIONS(3254),
    [anon_sym_byte] = ACTIONS(3254),
    [anon_sym_word] = ACTIONS(3254),
    [anon_sym_enum] = ACTIONS(3254),
    [anon_sym_class] = ACTIONS(3254),
    [anon_sym_struct] = ACTIONS(3254),
    [anon_sym_union] = ACTIONS(3254),
    [anon_sym_if] = ACTIONS(3254),
    [anon_sym_switch] = ACTIONS(3254),
    [anon_sym_case] = ACTIONS(3254),
    [anon_sym_default] = ACTIONS(3254),
    [anon_sym_while] = ACTIONS(3254),
    [anon_sym_do] = ACTIONS(3254),
    [anon_sym_for] = ACTIONS(3254),
    [anon_sym_return] = ACTIONS(3254),
    [anon_sym_break] = ACTIONS(3254),
    [anon_sym_continue] = ACTIONS(3254),
    [anon_sym_goto] = ACTIONS(3254),
    [anon_sym___try] = ACTIONS(3254),
    [anon_sym___leave] = ACTIONS(3254),
    [anon_sym_not] = ACTIONS(3254),
    [anon_sym_compl] = ACTIONS(3254),
    [anon_sym_DASH_DASH] = ACTIONS(3256),
    [anon_sym_PLUS_PLUS] = ACTIONS(3256),
    [anon_sym_sizeof] = ACTIONS(3254),
    [anon_sym___alignof__] = ACTIONS(3254),
    [anon_sym___alignof] = ACTIONS(3254),
    [anon_sym__alignof] = ACTIONS(3254),
    [anon_sym_alignof] = ACTIONS(3254),
    [anon_sym__Alignof] = ACTIONS(3254),
    [anon_sym_offsetof] = ACTIONS(3254),
    [anon_sym__Generic] = ACTIONS(3254),
    [anon_sym_asm] = ACTIONS(3254),
    [anon_sym___asm__] = ACTIONS(3254),
    [aux_sym_number_literal_token1] = ACTIONS(3256),
    [aux_sym_number_literal_token2] = ACTIONS(3254),
    [anon_sym_L_SQUOTE] = ACTIONS(3256),
    [anon_sym_u_SQUOTE] = ACTIONS(3256),
    [anon_sym_U_SQUOTE] = ACTIONS(3256),
    [anon_sym_u8_SQUOTE] = ACTIONS(3256),
    [anon_sym_SQUOTE] = ACTIONS(3256),
    [anon_sym_L_DQUOTE] = ACTIONS(3256),
    [anon_sym_u_DQUOTE] = ACTIONS(3256),
    [anon_sym_U_DQUOTE] = ACTIONS(3256),
    [anon_sym_u8_DQUOTE] = ACTIONS(3256),
    [anon_sym_DQUOTE] = ACTIONS(3256),
    [sym_true] = ACTIONS(3254),
    [sym_false] = ACTIONS(3254),
    [anon_sym_NULL] = ACTIONS(3254),
    [anon_sym_nullptr] = ACTIONS(3254),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3254),
    [anon_sym_decltype] = ACTIONS(3254),
    [anon_sym_virtual] = ACTIONS(3254),
    [anon_sym_alignas] = ACTIONS(3254),
    [anon_sym_explicit] = ACTIONS(3254),
    [anon_sym_typename] = ACTIONS(3254),
    [anon_sym_template] = ACTIONS(3254),
    [anon_sym_operator] = ACTIONS(3254),
    [anon_sym_try] = ACTIONS(3254),
    [anon_sym_delete] = ACTIONS(3254),
    [anon_sym_throw] = ACTIONS(3254),
    [anon_sym_namespace] = ACTIONS(3254),
    [anon_sym_using] = ACTIONS(3254),
    [anon_sym_static_assert] = ACTIONS(3254),
    [anon_sym_concept] = ACTIONS(3254),
    [anon_sym_co_return] = ACTIONS(3254),
    [anon_sym_co_yield] = ACTIONS(3254),
    [anon_sym_R_DQUOTE] = ACTIONS(3256),
    [anon_sym_LR_DQUOTE] = ACTIONS(3256),
    [anon_sym_uR_DQUOTE] = ACTIONS(3256),
    [anon_sym_UR_DQUOTE] = ACTIONS(3256),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3256),
    [anon_sym_co_await] = ACTIONS(3254),
    [anon_sym_new] = ACTIONS(3254),
    [anon_sym_requires] = ACTIONS(3254),
    [sym_this] = ACTIONS(3254),
  },
  [381] = {
    [sym_identifier] = ACTIONS(3258),
    [aux_sym_preproc_include_token1] = ACTIONS(3258),
    [aux_sym_preproc_def_token1] = ACTIONS(3258),
    [aux_sym_preproc_if_token1] = ACTIONS(3258),
    [aux_sym_preproc_if_token2] = ACTIONS(3258),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3258),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3258),
    [aux_sym_preproc_else_token1] = ACTIONS(3258),
    [aux_sym_preproc_elif_token1] = ACTIONS(3258),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3258),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3258),
    [sym_preproc_directive] = ACTIONS(3258),
    [anon_sym_LPAREN2] = ACTIONS(3260),
    [anon_sym_BANG] = ACTIONS(3260),
    [anon_sym_TILDE] = ACTIONS(3260),
    [anon_sym_DASH] = ACTIONS(3258),
    [anon_sym_PLUS] = ACTIONS(3258),
    [anon_sym_STAR] = ACTIONS(3260),
    [anon_sym_AMP_AMP] = ACTIONS(3260),
    [anon_sym_AMP] = ACTIONS(3258),
    [anon_sym_SEMI] = ACTIONS(3260),
    [anon_sym___extension__] = ACTIONS(3258),
    [anon_sym_typedef] = ACTIONS(3258),
    [anon_sym_extern] = ACTIONS(3258),
    [anon_sym___attribute__] = ACTIONS(3258),
    [anon_sym_COLON_COLON] = ACTIONS(3260),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3260),
    [anon_sym___declspec] = ACTIONS(3258),
    [anon_sym___based] = ACTIONS(3258),
    [anon_sym___cdecl] = ACTIONS(3258),
    [anon_sym___clrcall] = ACTIONS(3258),
    [anon_sym___stdcall] = ACTIONS(3258),
    [anon_sym___fastcall] = ACTIONS(3258),
    [anon_sym___thiscall] = ACTIONS(3258),
    [anon_sym___vectorcall] = ACTIONS(3258),
    [anon_sym_LBRACE] = ACTIONS(3260),
    [anon_sym_signed] = ACTIONS(3258),
    [anon_sym_unsigned] = ACTIONS(3258),
    [anon_sym_long] = ACTIONS(3258),
    [anon_sym_short] = ACTIONS(3258),
    [anon_sym_LBRACK] = ACTIONS(3258),
    [anon_sym_static] = ACTIONS(3258),
    [anon_sym_register] = ACTIONS(3258),
    [anon_sym_inline] = ACTIONS(3258),
    [anon_sym___inline] = ACTIONS(3258),
    [anon_sym___inline__] = ACTIONS(3258),
    [anon_sym___forceinline] = ACTIONS(3258),
    [anon_sym_thread_local] = ACTIONS(3258),
    [anon_sym___thread] = ACTIONS(3258),
    [anon_sym_const] = ACTIONS(3258),
    [anon_sym_constexpr] = ACTIONS(3258),
    [anon_sym_volatile] = ACTIONS(3258),
    [anon_sym_restrict] = ACTIONS(3258),
    [anon_sym___restrict__] = ACTIONS(3258),
    [anon_sym__Atomic] = ACTIONS(3258),
    [anon_sym__Noreturn] = ACTIONS(3258),
    [anon_sym_noreturn] = ACTIONS(3258),
    [anon_sym_mutable] = ACTIONS(3258),
    [anon_sym_constinit] = ACTIONS(3258),
    [anon_sym_consteval] = ACTIONS(3258),
    [anon_sym_PROGMEM] = ACTIONS(3258),
    [aux_sym_primitive_type_token1] = ACTIONS(3258),
    [anon_sym_byte] = ACTIONS(3258),
    [anon_sym_word] = ACTIONS(3258),
    [anon_sym_enum] = ACTIONS(3258),
    [anon_sym_class] = ACTIONS(3258),
    [anon_sym_struct] = ACTIONS(3258),
    [anon_sym_union] = ACTIONS(3258),
    [anon_sym_if] = ACTIONS(3258),
    [anon_sym_switch] = ACTIONS(3258),
    [anon_sym_case] = ACTIONS(3258),
    [anon_sym_default] = ACTIONS(3258),
    [anon_sym_while] = ACTIONS(3258),
    [anon_sym_do] = ACTIONS(3258),
    [anon_sym_for] = ACTIONS(3258),
    [anon_sym_return] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3258),
    [anon_sym_continue] = ACTIONS(3258),
    [anon_sym_goto] = ACTIONS(3258),
    [anon_sym___try] = ACTIONS(3258),
    [anon_sym___leave] = ACTIONS(3258),
    [anon_sym_not] = ACTIONS(3258),
    [anon_sym_compl] = ACTIONS(3258),
    [anon_sym_DASH_DASH] = ACTIONS(3260),
    [anon_sym_PLUS_PLUS] = ACTIONS(3260),
    [anon_sym_sizeof] = ACTIONS(3258),
    [anon_sym___alignof__] = ACTIONS(3258),
    [anon_sym___alignof] = ACTIONS(3258),
    [anon_sym__alignof] = ACTIONS(3258),
    [anon_sym_alignof] = ACTIONS(3258),
    [anon_sym__Alignof] = ACTIONS(3258),
    [anon_sym_offsetof] = ACTIONS(3258),
    [anon_sym__Generic] = ACTIONS(3258),
    [anon_sym_asm] = ACTIONS(3258),
    [anon_sym___asm__] = ACTIONS(3258),
    [aux_sym_number_literal_token1] = ACTIONS(3260),
    [aux_sym_number_literal_token2] = ACTIONS(3258),
    [anon_sym_L_SQUOTE] = ACTIONS(3260),
    [anon_sym_u_SQUOTE] = ACTIONS(3260),
    [anon_sym_U_SQUOTE] = ACTIONS(3260),
    [anon_sym_u8_SQUOTE] = ACTIONS(3260),
    [anon_sym_SQUOTE] = ACTIONS(3260),
    [anon_sym_L_DQUOTE] = ACTIONS(3260),
    [anon_sym_u_DQUOTE] = ACTIONS(3260),
    [anon_sym_U_DQUOTE] = ACTIONS(3260),
    [anon_sym_u8_DQUOTE] = ACTIONS(3260),
    [anon_sym_DQUOTE] = ACTIONS(3260),
    [sym_true] = ACTIONS(3258),
    [sym_false] = ACTIONS(3258),
    [anon_sym_NULL] = ACTIONS(3258),
    [anon_sym_nullptr] = ACTIONS(3258),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3258),
    [anon_sym_decltype] = ACTIONS(3258),
    [anon_sym_virtual] = ACTIONS(3258),
    [anon_sym_alignas] = ACTIONS(3258),
    [anon_sym_explicit] = ACTIONS(3258),
    [anon_sym_typename] = ACTIONS(3258),
    [anon_sym_template] = ACTIONS(3258),
    [anon_sym_operator] = ACTIONS(3258),
    [anon_sym_try] = ACTIONS(3258),
    [anon_sym_delete] = ACTIONS(3258),
    [anon_sym_throw] = ACTIONS(3258),
    [anon_sym_namespace] = ACTIONS(3258),
    [anon_sym_using] = ACTIONS(3258),
    [anon_sym_static_assert] = ACTIONS(3258),
    [anon_sym_concept] = ACTIONS(3258),
    [anon_sym_co_return] = ACTIONS(3258),
    [anon_sym_co_yield] = ACTIONS(3258),
    [anon_sym_R_DQUOTE] = ACTIONS(3260),
    [anon_sym_LR_DQUOTE] = ACTIONS(3260),
    [anon_sym_uR_DQUOTE] = ACTIONS(3260),
    [anon_sym_UR_DQUOTE] = ACTIONS(3260),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3260),
    [anon_sym_co_await] = ACTIONS(3258),
    [anon_sym_new] = ACTIONS(3258),
    [anon_sym_requires] = ACTIONS(3258),
    [sym_this] = ACTIONS(3258),
  },
  [382] = {
    [sym_identifier] = ACTIONS(3262),
    [aux_sym_preproc_include_token1] = ACTIONS(3262),
    [aux_sym_preproc_def_token1] = ACTIONS(3262),
    [aux_sym_preproc_if_token1] = ACTIONS(3262),
    [aux_sym_preproc_if_token2] = ACTIONS(3262),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3262),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3262),
    [aux_sym_preproc_else_token1] = ACTIONS(3262),
    [aux_sym_preproc_elif_token1] = ACTIONS(3262),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3262),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3262),
    [sym_preproc_directive] = ACTIONS(3262),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_BANG] = ACTIONS(3264),
    [anon_sym_TILDE] = ACTIONS(3264),
    [anon_sym_DASH] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3262),
    [anon_sym_STAR] = ACTIONS(3264),
    [anon_sym_AMP_AMP] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3262),
    [anon_sym_SEMI] = ACTIONS(3264),
    [anon_sym___extension__] = ACTIONS(3262),
    [anon_sym_typedef] = ACTIONS(3262),
    [anon_sym_extern] = ACTIONS(3262),
    [anon_sym___attribute__] = ACTIONS(3262),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3264),
    [anon_sym___declspec] = ACTIONS(3262),
    [anon_sym___based] = ACTIONS(3262),
    [anon_sym___cdecl] = ACTIONS(3262),
    [anon_sym___clrcall] = ACTIONS(3262),
    [anon_sym___stdcall] = ACTIONS(3262),
    [anon_sym___fastcall] = ACTIONS(3262),
    [anon_sym___thiscall] = ACTIONS(3262),
    [anon_sym___vectorcall] = ACTIONS(3262),
    [anon_sym_LBRACE] = ACTIONS(3264),
    [anon_sym_signed] = ACTIONS(3262),
    [anon_sym_unsigned] = ACTIONS(3262),
    [anon_sym_long] = ACTIONS(3262),
    [anon_sym_short] = ACTIONS(3262),
    [anon_sym_LBRACK] = ACTIONS(3262),
    [anon_sym_static] = ACTIONS(3262),
    [anon_sym_register] = ACTIONS(3262),
    [anon_sym_inline] = ACTIONS(3262),
    [anon_sym___inline] = ACTIONS(3262),
    [anon_sym___inline__] = ACTIONS(3262),
    [anon_sym___forceinline] = ACTIONS(3262),
    [anon_sym_thread_local] = ACTIONS(3262),
    [anon_sym___thread] = ACTIONS(3262),
    [anon_sym_const] = ACTIONS(3262),
    [anon_sym_constexpr] = ACTIONS(3262),
    [anon_sym_volatile] = ACTIONS(3262),
    [anon_sym_restrict] = ACTIONS(3262),
    [anon_sym___restrict__] = ACTIONS(3262),
    [anon_sym__Atomic] = ACTIONS(3262),
    [anon_sym__Noreturn] = ACTIONS(3262),
    [anon_sym_noreturn] = ACTIONS(3262),
    [anon_sym_mutable] = ACTIONS(3262),
    [anon_sym_constinit] = ACTIONS(3262),
    [anon_sym_consteval] = ACTIONS(3262),
    [anon_sym_PROGMEM] = ACTIONS(3262),
    [aux_sym_primitive_type_token1] = ACTIONS(3262),
    [anon_sym_byte] = ACTIONS(3262),
    [anon_sym_word] = ACTIONS(3262),
    [anon_sym_enum] = ACTIONS(3262),
    [anon_sym_class] = ACTIONS(3262),
    [anon_sym_struct] = ACTIONS(3262),
    [anon_sym_union] = ACTIONS(3262),
    [anon_sym_if] = ACTIONS(3262),
    [anon_sym_switch] = ACTIONS(3262),
    [anon_sym_case] = ACTIONS(3262),
    [anon_sym_default] = ACTIONS(3262),
    [anon_sym_while] = ACTIONS(3262),
    [anon_sym_do] = ACTIONS(3262),
    [anon_sym_for] = ACTIONS(3262),
    [anon_sym_return] = ACTIONS(3262),
    [anon_sym_break] = ACTIONS(3262),
    [anon_sym_continue] = ACTIONS(3262),
    [anon_sym_goto] = ACTIONS(3262),
    [anon_sym___try] = ACTIONS(3262),
    [anon_sym___leave] = ACTIONS(3262),
    [anon_sym_not] = ACTIONS(3262),
    [anon_sym_compl] = ACTIONS(3262),
    [anon_sym_DASH_DASH] = ACTIONS(3264),
    [anon_sym_PLUS_PLUS] = ACTIONS(3264),
    [anon_sym_sizeof] = ACTIONS(3262),
    [anon_sym___alignof__] = ACTIONS(3262),
    [anon_sym___alignof] = ACTIONS(3262),
    [anon_sym__alignof] = ACTIONS(3262),
    [anon_sym_alignof] = ACTIONS(3262),
    [anon_sym__Alignof] = ACTIONS(3262),
    [anon_sym_offsetof] = ACTIONS(3262),
    [anon_sym__Generic] = ACTIONS(3262),
    [anon_sym_asm] = ACTIONS(3262),
    [anon_sym___asm__] = ACTIONS(3262),
    [aux_sym_number_literal_token1] = ACTIONS(3264),
    [aux_sym_number_literal_token2] = ACTIONS(3262),
    [anon_sym_L_SQUOTE] = ACTIONS(3264),
    [anon_sym_u_SQUOTE] = ACTIONS(3264),
    [anon_sym_U_SQUOTE] = ACTIONS(3264),
    [anon_sym_u8_SQUOTE] = ACTIONS(3264),
    [anon_sym_SQUOTE] = ACTIONS(3264),
    [anon_sym_L_DQUOTE] = ACTIONS(3264),
    [anon_sym_u_DQUOTE] = ACTIONS(3264),
    [anon_sym_U_DQUOTE] = ACTIONS(3264),
    [anon_sym_u8_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE] = ACTIONS(3264),
    [sym_true] = ACTIONS(3262),
    [sym_false] = ACTIONS(3262),
    [anon_sym_NULL] = ACTIONS(3262),
    [anon_sym_nullptr] = ACTIONS(3262),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3262),
    [anon_sym_decltype] = ACTIONS(3262),
    [anon_sym_virtual] = ACTIONS(3262),
    [anon_sym_alignas] = ACTIONS(3262),
    [anon_sym_explicit] = ACTIONS(3262),
    [anon_sym_typename] = ACTIONS(3262),
    [anon_sym_template] = ACTIONS(3262),
    [anon_sym_operator] = ACTIONS(3262),
    [anon_sym_try] = ACTIONS(3262),
    [anon_sym_delete] = ACTIONS(3262),
    [anon_sym_throw] = ACTIONS(3262),
    [anon_sym_namespace] = ACTIONS(3262),
    [anon_sym_using] = ACTIONS(3262),
    [anon_sym_static_assert] = ACTIONS(3262),
    [anon_sym_concept] = ACTIONS(3262),
    [anon_sym_co_return] = ACTIONS(3262),
    [anon_sym_co_yield] = ACTIONS(3262),
    [anon_sym_R_DQUOTE] = ACTIONS(3264),
    [anon_sym_LR_DQUOTE] = ACTIONS(3264),
    [anon_sym_uR_DQUOTE] = ACTIONS(3264),
    [anon_sym_UR_DQUOTE] = ACTIONS(3264),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3264),
    [anon_sym_co_await] = ACTIONS(3262),
    [anon_sym_new] = ACTIONS(3262),
    [anon_sym_requires] = ACTIONS(3262),
    [sym_this] = ACTIONS(3262),
  },
  [383] = {
    [sym_identifier] = ACTIONS(3266),
    [aux_sym_preproc_include_token1] = ACTIONS(3266),
    [aux_sym_preproc_def_token1] = ACTIONS(3266),
    [aux_sym_preproc_if_token1] = ACTIONS(3266),
    [aux_sym_preproc_if_token2] = ACTIONS(3266),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3266),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3266),
    [aux_sym_preproc_else_token1] = ACTIONS(3266),
    [aux_sym_preproc_elif_token1] = ACTIONS(3266),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3266),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3266),
    [sym_preproc_directive] = ACTIONS(3266),
    [anon_sym_LPAREN2] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3268),
    [anon_sym_TILDE] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3266),
    [anon_sym_STAR] = ACTIONS(3268),
    [anon_sym_AMP_AMP] = ACTIONS(3268),
    [anon_sym_AMP] = ACTIONS(3266),
    [anon_sym_SEMI] = ACTIONS(3268),
    [anon_sym___extension__] = ACTIONS(3266),
    [anon_sym_typedef] = ACTIONS(3266),
    [anon_sym_extern] = ACTIONS(3266),
    [anon_sym___attribute__] = ACTIONS(3266),
    [anon_sym_COLON_COLON] = ACTIONS(3268),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3268),
    [anon_sym___declspec] = ACTIONS(3266),
    [anon_sym___based] = ACTIONS(3266),
    [anon_sym___cdecl] = ACTIONS(3266),
    [anon_sym___clrcall] = ACTIONS(3266),
    [anon_sym___stdcall] = ACTIONS(3266),
    [anon_sym___fastcall] = ACTIONS(3266),
    [anon_sym___thiscall] = ACTIONS(3266),
    [anon_sym___vectorcall] = ACTIONS(3266),
    [anon_sym_LBRACE] = ACTIONS(3268),
    [anon_sym_signed] = ACTIONS(3266),
    [anon_sym_unsigned] = ACTIONS(3266),
    [anon_sym_long] = ACTIONS(3266),
    [anon_sym_short] = ACTIONS(3266),
    [anon_sym_LBRACK] = ACTIONS(3266),
    [anon_sym_static] = ACTIONS(3266),
    [anon_sym_register] = ACTIONS(3266),
    [anon_sym_inline] = ACTIONS(3266),
    [anon_sym___inline] = ACTIONS(3266),
    [anon_sym___inline__] = ACTIONS(3266),
    [anon_sym___forceinline] = ACTIONS(3266),
    [anon_sym_thread_local] = ACTIONS(3266),
    [anon_sym___thread] = ACTIONS(3266),
    [anon_sym_const] = ACTIONS(3266),
    [anon_sym_constexpr] = ACTIONS(3266),
    [anon_sym_volatile] = ACTIONS(3266),
    [anon_sym_restrict] = ACTIONS(3266),
    [anon_sym___restrict__] = ACTIONS(3266),
    [anon_sym__Atomic] = ACTIONS(3266),
    [anon_sym__Noreturn] = ACTIONS(3266),
    [anon_sym_noreturn] = ACTIONS(3266),
    [anon_sym_mutable] = ACTIONS(3266),
    [anon_sym_constinit] = ACTIONS(3266),
    [anon_sym_consteval] = ACTIONS(3266),
    [anon_sym_PROGMEM] = ACTIONS(3266),
    [aux_sym_primitive_type_token1] = ACTIONS(3266),
    [anon_sym_byte] = ACTIONS(3266),
    [anon_sym_word] = ACTIONS(3266),
    [anon_sym_enum] = ACTIONS(3266),
    [anon_sym_class] = ACTIONS(3266),
    [anon_sym_struct] = ACTIONS(3266),
    [anon_sym_union] = ACTIONS(3266),
    [anon_sym_if] = ACTIONS(3266),
    [anon_sym_switch] = ACTIONS(3266),
    [anon_sym_case] = ACTIONS(3266),
    [anon_sym_default] = ACTIONS(3266),
    [anon_sym_while] = ACTIONS(3266),
    [anon_sym_do] = ACTIONS(3266),
    [anon_sym_for] = ACTIONS(3266),
    [anon_sym_return] = ACTIONS(3266),
    [anon_sym_break] = ACTIONS(3266),
    [anon_sym_continue] = ACTIONS(3266),
    [anon_sym_goto] = ACTIONS(3266),
    [anon_sym___try] = ACTIONS(3266),
    [anon_sym___leave] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3266),
    [anon_sym_compl] = ACTIONS(3266),
    [anon_sym_DASH_DASH] = ACTIONS(3268),
    [anon_sym_PLUS_PLUS] = ACTIONS(3268),
    [anon_sym_sizeof] = ACTIONS(3266),
    [anon_sym___alignof__] = ACTIONS(3266),
    [anon_sym___alignof] = ACTIONS(3266),
    [anon_sym__alignof] = ACTIONS(3266),
    [anon_sym_alignof] = ACTIONS(3266),
    [anon_sym__Alignof] = ACTIONS(3266),
    [anon_sym_offsetof] = ACTIONS(3266),
    [anon_sym__Generic] = ACTIONS(3266),
    [anon_sym_asm] = ACTIONS(3266),
    [anon_sym___asm__] = ACTIONS(3266),
    [aux_sym_number_literal_token1] = ACTIONS(3268),
    [aux_sym_number_literal_token2] = ACTIONS(3266),
    [anon_sym_L_SQUOTE] = ACTIONS(3268),
    [anon_sym_u_SQUOTE] = ACTIONS(3268),
    [anon_sym_U_SQUOTE] = ACTIONS(3268),
    [anon_sym_u8_SQUOTE] = ACTIONS(3268),
    [anon_sym_SQUOTE] = ACTIONS(3268),
    [anon_sym_L_DQUOTE] = ACTIONS(3268),
    [anon_sym_u_DQUOTE] = ACTIONS(3268),
    [anon_sym_U_DQUOTE] = ACTIONS(3268),
    [anon_sym_u8_DQUOTE] = ACTIONS(3268),
    [anon_sym_DQUOTE] = ACTIONS(3268),
    [sym_true] = ACTIONS(3266),
    [sym_false] = ACTIONS(3266),
    [anon_sym_NULL] = ACTIONS(3266),
    [anon_sym_nullptr] = ACTIONS(3266),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3266),
    [anon_sym_decltype] = ACTIONS(3266),
    [anon_sym_virtual] = ACTIONS(3266),
    [anon_sym_alignas] = ACTIONS(3266),
    [anon_sym_explicit] = ACTIONS(3266),
    [anon_sym_typename] = ACTIONS(3266),
    [anon_sym_template] = ACTIONS(3266),
    [anon_sym_operator] = ACTIONS(3266),
    [anon_sym_try] = ACTIONS(3266),
    [anon_sym_delete] = ACTIONS(3266),
    [anon_sym_throw] = ACTIONS(3266),
    [anon_sym_namespace] = ACTIONS(3266),
    [anon_sym_using] = ACTIONS(3266),
    [anon_sym_static_assert] = ACTIONS(3266),
    [anon_sym_concept] = ACTIONS(3266),
    [anon_sym_co_return] = ACTIONS(3266),
    [anon_sym_co_yield] = ACTIONS(3266),
    [anon_sym_R_DQUOTE] = ACTIONS(3268),
    [anon_sym_LR_DQUOTE] = ACTIONS(3268),
    [anon_sym_uR_DQUOTE] = ACTIONS(3268),
    [anon_sym_UR_DQUOTE] = ACTIONS(3268),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3268),
    [anon_sym_co_await] = ACTIONS(3266),
    [anon_sym_new] = ACTIONS(3266),
    [anon_sym_requires] = ACTIONS(3266),
    [sym_this] = ACTIONS(3266),
  },
  [384] = {
    [sym_identifier] = ACTIONS(3270),
    [aux_sym_preproc_include_token1] = ACTIONS(3270),
    [aux_sym_preproc_def_token1] = ACTIONS(3270),
    [aux_sym_preproc_if_token1] = ACTIONS(3270),
    [aux_sym_preproc_if_token2] = ACTIONS(3270),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3270),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3270),
    [aux_sym_preproc_else_token1] = ACTIONS(3270),
    [aux_sym_preproc_elif_token1] = ACTIONS(3270),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3270),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3270),
    [sym_preproc_directive] = ACTIONS(3270),
    [anon_sym_LPAREN2] = ACTIONS(3272),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3270),
    [anon_sym_PLUS] = ACTIONS(3270),
    [anon_sym_STAR] = ACTIONS(3272),
    [anon_sym_AMP_AMP] = ACTIONS(3272),
    [anon_sym_AMP] = ACTIONS(3270),
    [anon_sym_SEMI] = ACTIONS(3272),
    [anon_sym___extension__] = ACTIONS(3270),
    [anon_sym_typedef] = ACTIONS(3270),
    [anon_sym_extern] = ACTIONS(3270),
    [anon_sym___attribute__] = ACTIONS(3270),
    [anon_sym_COLON_COLON] = ACTIONS(3272),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3272),
    [anon_sym___declspec] = ACTIONS(3270),
    [anon_sym___based] = ACTIONS(3270),
    [anon_sym___cdecl] = ACTIONS(3270),
    [anon_sym___clrcall] = ACTIONS(3270),
    [anon_sym___stdcall] = ACTIONS(3270),
    [anon_sym___fastcall] = ACTIONS(3270),
    [anon_sym___thiscall] = ACTIONS(3270),
    [anon_sym___vectorcall] = ACTIONS(3270),
    [anon_sym_LBRACE] = ACTIONS(3272),
    [anon_sym_signed] = ACTIONS(3270),
    [anon_sym_unsigned] = ACTIONS(3270),
    [anon_sym_long] = ACTIONS(3270),
    [anon_sym_short] = ACTIONS(3270),
    [anon_sym_LBRACK] = ACTIONS(3270),
    [anon_sym_static] = ACTIONS(3270),
    [anon_sym_register] = ACTIONS(3270),
    [anon_sym_inline] = ACTIONS(3270),
    [anon_sym___inline] = ACTIONS(3270),
    [anon_sym___inline__] = ACTIONS(3270),
    [anon_sym___forceinline] = ACTIONS(3270),
    [anon_sym_thread_local] = ACTIONS(3270),
    [anon_sym___thread] = ACTIONS(3270),
    [anon_sym_const] = ACTIONS(3270),
    [anon_sym_constexpr] = ACTIONS(3270),
    [anon_sym_volatile] = ACTIONS(3270),
    [anon_sym_restrict] = ACTIONS(3270),
    [anon_sym___restrict__] = ACTIONS(3270),
    [anon_sym__Atomic] = ACTIONS(3270),
    [anon_sym__Noreturn] = ACTIONS(3270),
    [anon_sym_noreturn] = ACTIONS(3270),
    [anon_sym_mutable] = ACTIONS(3270),
    [anon_sym_constinit] = ACTIONS(3270),
    [anon_sym_consteval] = ACTIONS(3270),
    [anon_sym_PROGMEM] = ACTIONS(3270),
    [aux_sym_primitive_type_token1] = ACTIONS(3270),
    [anon_sym_byte] = ACTIONS(3270),
    [anon_sym_word] = ACTIONS(3270),
    [anon_sym_enum] = ACTIONS(3270),
    [anon_sym_class] = ACTIONS(3270),
    [anon_sym_struct] = ACTIONS(3270),
    [anon_sym_union] = ACTIONS(3270),
    [anon_sym_if] = ACTIONS(3270),
    [anon_sym_switch] = ACTIONS(3270),
    [anon_sym_case] = ACTIONS(3270),
    [anon_sym_default] = ACTIONS(3270),
    [anon_sym_while] = ACTIONS(3270),
    [anon_sym_do] = ACTIONS(3270),
    [anon_sym_for] = ACTIONS(3270),
    [anon_sym_return] = ACTIONS(3270),
    [anon_sym_break] = ACTIONS(3270),
    [anon_sym_continue] = ACTIONS(3270),
    [anon_sym_goto] = ACTIONS(3270),
    [anon_sym___try] = ACTIONS(3270),
    [anon_sym___leave] = ACTIONS(3270),
    [anon_sym_not] = ACTIONS(3270),
    [anon_sym_compl] = ACTIONS(3270),
    [anon_sym_DASH_DASH] = ACTIONS(3272),
    [anon_sym_PLUS_PLUS] = ACTIONS(3272),
    [anon_sym_sizeof] = ACTIONS(3270),
    [anon_sym___alignof__] = ACTIONS(3270),
    [anon_sym___alignof] = ACTIONS(3270),
    [anon_sym__alignof] = ACTIONS(3270),
    [anon_sym_alignof] = ACTIONS(3270),
    [anon_sym__Alignof] = ACTIONS(3270),
    [anon_sym_offsetof] = ACTIONS(3270),
    [anon_sym__Generic] = ACTIONS(3270),
    [anon_sym_asm] = ACTIONS(3270),
    [anon_sym___asm__] = ACTIONS(3270),
    [aux_sym_number_literal_token1] = ACTIONS(3272),
    [aux_sym_number_literal_token2] = ACTIONS(3270),
    [anon_sym_L_SQUOTE] = ACTIONS(3272),
    [anon_sym_u_SQUOTE] = ACTIONS(3272),
    [anon_sym_U_SQUOTE] = ACTIONS(3272),
    [anon_sym_u8_SQUOTE] = ACTIONS(3272),
    [anon_sym_SQUOTE] = ACTIONS(3272),
    [anon_sym_L_DQUOTE] = ACTIONS(3272),
    [anon_sym_u_DQUOTE] = ACTIONS(3272),
    [anon_sym_U_DQUOTE] = ACTIONS(3272),
    [anon_sym_u8_DQUOTE] = ACTIONS(3272),
    [anon_sym_DQUOTE] = ACTIONS(3272),
    [sym_true] = ACTIONS(3270),
    [sym_false] = ACTIONS(3270),
    [anon_sym_NULL] = ACTIONS(3270),
    [anon_sym_nullptr] = ACTIONS(3270),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3270),
    [anon_sym_decltype] = ACTIONS(3270),
    [anon_sym_virtual] = ACTIONS(3270),
    [anon_sym_alignas] = ACTIONS(3270),
    [anon_sym_explicit] = ACTIONS(3270),
    [anon_sym_typename] = ACTIONS(3270),
    [anon_sym_template] = ACTIONS(3270),
    [anon_sym_operator] = ACTIONS(3270),
    [anon_sym_try] = ACTIONS(3270),
    [anon_sym_delete] = ACTIONS(3270),
    [anon_sym_throw] = ACTIONS(3270),
    [anon_sym_namespace] = ACTIONS(3270),
    [anon_sym_using] = ACTIONS(3270),
    [anon_sym_static_assert] = ACTIONS(3270),
    [anon_sym_concept] = ACTIONS(3270),
    [anon_sym_co_return] = ACTIONS(3270),
    [anon_sym_co_yield] = ACTIONS(3270),
    [anon_sym_R_DQUOTE] = ACTIONS(3272),
    [anon_sym_LR_DQUOTE] = ACTIONS(3272),
    [anon_sym_uR_DQUOTE] = ACTIONS(3272),
    [anon_sym_UR_DQUOTE] = ACTIONS(3272),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3272),
    [anon_sym_co_await] = ACTIONS(3270),
    [anon_sym_new] = ACTIONS(3270),
    [anon_sym_requires] = ACTIONS(3270),
    [sym_this] = ACTIONS(3270),
  },
  [385] = {
    [sym_preproc_def] = STATE(390),
    [sym_preproc_function_def] = STATE(390),
    [sym_preproc_call] = STATE(390),
    [sym_preproc_if_in_field_declaration_list] = STATE(390),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(390),
    [sym_preproc_else_in_field_declaration_list] = STATE(8796),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8796),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8796),
    [sym_type_definition] = STATE(390),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6442),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7117),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(390),
    [sym_field_declaration] = STATE(390),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2239),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(390),
    [sym_operator_cast] = STATE(7514),
    [sym_inline_method_definition] = STATE(390),
    [sym__constructor_specifiers] = STATE(2239),
    [sym_operator_cast_definition] = STATE(390),
    [sym_operator_cast_declaration] = STATE(390),
    [sym_constructor_or_destructor_definition] = STATE(390),
    [sym_constructor_or_destructor_declaration] = STATE(390),
    [sym_friend_declaration] = STATE(390),
    [sym_access_specifier] = STATE(9047),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(390),
    [sym_alias_declaration] = STATE(390),
    [sym_static_assert_declaration] = STATE(390),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7514),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(390),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2239),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3198),
    [aux_sym_preproc_if_token1] = ACTIONS(3200),
    [aux_sym_preproc_if_token2] = ACTIONS(3274),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3204),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3204),
    [aux_sym_preproc_else_token1] = ACTIONS(3206),
    [aux_sym_preproc_elif_token1] = ACTIONS(3208),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3210),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3210),
    [sym_preproc_directive] = ACTIONS(3212),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3222),
    [anon_sym_typedef] = ACTIONS(3224),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3240),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3242),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3246),
    [anon_sym_static_assert] = ACTIONS(3248),
  },
  [386] = {
    [sym_identifier] = ACTIONS(3276),
    [aux_sym_preproc_include_token1] = ACTIONS(3276),
    [aux_sym_preproc_def_token1] = ACTIONS(3276),
    [aux_sym_preproc_if_token1] = ACTIONS(3276),
    [aux_sym_preproc_if_token2] = ACTIONS(3276),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3276),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3276),
    [aux_sym_preproc_else_token1] = ACTIONS(3276),
    [aux_sym_preproc_elif_token1] = ACTIONS(3276),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3276),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3276),
    [sym_preproc_directive] = ACTIONS(3276),
    [anon_sym_LPAREN2] = ACTIONS(3278),
    [anon_sym_BANG] = ACTIONS(3278),
    [anon_sym_TILDE] = ACTIONS(3278),
    [anon_sym_DASH] = ACTIONS(3276),
    [anon_sym_PLUS] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3278),
    [anon_sym_AMP_AMP] = ACTIONS(3278),
    [anon_sym_AMP] = ACTIONS(3276),
    [anon_sym_SEMI] = ACTIONS(3278),
    [anon_sym___extension__] = ACTIONS(3276),
    [anon_sym_typedef] = ACTIONS(3276),
    [anon_sym_extern] = ACTIONS(3276),
    [anon_sym___attribute__] = ACTIONS(3276),
    [anon_sym_COLON_COLON] = ACTIONS(3278),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3278),
    [anon_sym___declspec] = ACTIONS(3276),
    [anon_sym___based] = ACTIONS(3276),
    [anon_sym___cdecl] = ACTIONS(3276),
    [anon_sym___clrcall] = ACTIONS(3276),
    [anon_sym___stdcall] = ACTIONS(3276),
    [anon_sym___fastcall] = ACTIONS(3276),
    [anon_sym___thiscall] = ACTIONS(3276),
    [anon_sym___vectorcall] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3278),
    [anon_sym_signed] = ACTIONS(3276),
    [anon_sym_unsigned] = ACTIONS(3276),
    [anon_sym_long] = ACTIONS(3276),
    [anon_sym_short] = ACTIONS(3276),
    [anon_sym_LBRACK] = ACTIONS(3276),
    [anon_sym_static] = ACTIONS(3276),
    [anon_sym_register] = ACTIONS(3276),
    [anon_sym_inline] = ACTIONS(3276),
    [anon_sym___inline] = ACTIONS(3276),
    [anon_sym___inline__] = ACTIONS(3276),
    [anon_sym___forceinline] = ACTIONS(3276),
    [anon_sym_thread_local] = ACTIONS(3276),
    [anon_sym___thread] = ACTIONS(3276),
    [anon_sym_const] = ACTIONS(3276),
    [anon_sym_constexpr] = ACTIONS(3276),
    [anon_sym_volatile] = ACTIONS(3276),
    [anon_sym_restrict] = ACTIONS(3276),
    [anon_sym___restrict__] = ACTIONS(3276),
    [anon_sym__Atomic] = ACTIONS(3276),
    [anon_sym__Noreturn] = ACTIONS(3276),
    [anon_sym_noreturn] = ACTIONS(3276),
    [anon_sym_mutable] = ACTIONS(3276),
    [anon_sym_constinit] = ACTIONS(3276),
    [anon_sym_consteval] = ACTIONS(3276),
    [anon_sym_PROGMEM] = ACTIONS(3276),
    [aux_sym_primitive_type_token1] = ACTIONS(3276),
    [anon_sym_byte] = ACTIONS(3276),
    [anon_sym_word] = ACTIONS(3276),
    [anon_sym_enum] = ACTIONS(3276),
    [anon_sym_class] = ACTIONS(3276),
    [anon_sym_struct] = ACTIONS(3276),
    [anon_sym_union] = ACTIONS(3276),
    [anon_sym_if] = ACTIONS(3276),
    [anon_sym_switch] = ACTIONS(3276),
    [anon_sym_case] = ACTIONS(3276),
    [anon_sym_default] = ACTIONS(3276),
    [anon_sym_while] = ACTIONS(3276),
    [anon_sym_do] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3276),
    [anon_sym_return] = ACTIONS(3276),
    [anon_sym_break] = ACTIONS(3276),
    [anon_sym_continue] = ACTIONS(3276),
    [anon_sym_goto] = ACTIONS(3276),
    [anon_sym___try] = ACTIONS(3276),
    [anon_sym___leave] = ACTIONS(3276),
    [anon_sym_not] = ACTIONS(3276),
    [anon_sym_compl] = ACTIONS(3276),
    [anon_sym_DASH_DASH] = ACTIONS(3278),
    [anon_sym_PLUS_PLUS] = ACTIONS(3278),
    [anon_sym_sizeof] = ACTIONS(3276),
    [anon_sym___alignof__] = ACTIONS(3276),
    [anon_sym___alignof] = ACTIONS(3276),
    [anon_sym__alignof] = ACTIONS(3276),
    [anon_sym_alignof] = ACTIONS(3276),
    [anon_sym__Alignof] = ACTIONS(3276),
    [anon_sym_offsetof] = ACTIONS(3276),
    [anon_sym__Generic] = ACTIONS(3276),
    [anon_sym_asm] = ACTIONS(3276),
    [anon_sym___asm__] = ACTIONS(3276),
    [aux_sym_number_literal_token1] = ACTIONS(3278),
    [aux_sym_number_literal_token2] = ACTIONS(3276),
    [anon_sym_L_SQUOTE] = ACTIONS(3278),
    [anon_sym_u_SQUOTE] = ACTIONS(3278),
    [anon_sym_U_SQUOTE] = ACTIONS(3278),
    [anon_sym_u8_SQUOTE] = ACTIONS(3278),
    [anon_sym_SQUOTE] = ACTIONS(3278),
    [anon_sym_L_DQUOTE] = ACTIONS(3278),
    [anon_sym_u_DQUOTE] = ACTIONS(3278),
    [anon_sym_U_DQUOTE] = ACTIONS(3278),
    [anon_sym_u8_DQUOTE] = ACTIONS(3278),
    [anon_sym_DQUOTE] = ACTIONS(3278),
    [sym_true] = ACTIONS(3276),
    [sym_false] = ACTIONS(3276),
    [anon_sym_NULL] = ACTIONS(3276),
    [anon_sym_nullptr] = ACTIONS(3276),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3276),
    [anon_sym_decltype] = ACTIONS(3276),
    [anon_sym_virtual] = ACTIONS(3276),
    [anon_sym_alignas] = ACTIONS(3276),
    [anon_sym_explicit] = ACTIONS(3276),
    [anon_sym_typename] = ACTIONS(3276),
    [anon_sym_template] = ACTIONS(3276),
    [anon_sym_operator] = ACTIONS(3276),
    [anon_sym_try] = ACTIONS(3276),
    [anon_sym_delete] = ACTIONS(3276),
    [anon_sym_throw] = ACTIONS(3276),
    [anon_sym_namespace] = ACTIONS(3276),
    [anon_sym_using] = ACTIONS(3276),
    [anon_sym_static_assert] = ACTIONS(3276),
    [anon_sym_concept] = ACTIONS(3276),
    [anon_sym_co_return] = ACTIONS(3276),
    [anon_sym_co_yield] = ACTIONS(3276),
    [anon_sym_R_DQUOTE] = ACTIONS(3278),
    [anon_sym_LR_DQUOTE] = ACTIONS(3278),
    [anon_sym_uR_DQUOTE] = ACTIONS(3278),
    [anon_sym_UR_DQUOTE] = ACTIONS(3278),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3278),
    [anon_sym_co_await] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3276),
    [anon_sym_requires] = ACTIONS(3276),
    [sym_this] = ACTIONS(3276),
  },
  [387] = {
    [sym_identifier] = ACTIONS(3280),
    [aux_sym_preproc_include_token1] = ACTIONS(3280),
    [aux_sym_preproc_def_token1] = ACTIONS(3280),
    [aux_sym_preproc_if_token1] = ACTIONS(3280),
    [aux_sym_preproc_if_token2] = ACTIONS(3280),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3280),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3280),
    [aux_sym_preproc_else_token1] = ACTIONS(3280),
    [aux_sym_preproc_elif_token1] = ACTIONS(3280),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3280),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3280),
    [sym_preproc_directive] = ACTIONS(3280),
    [anon_sym_LPAREN2] = ACTIONS(3282),
    [anon_sym_BANG] = ACTIONS(3282),
    [anon_sym_TILDE] = ACTIONS(3282),
    [anon_sym_DASH] = ACTIONS(3280),
    [anon_sym_PLUS] = ACTIONS(3280),
    [anon_sym_STAR] = ACTIONS(3282),
    [anon_sym_AMP_AMP] = ACTIONS(3282),
    [anon_sym_AMP] = ACTIONS(3280),
    [anon_sym_SEMI] = ACTIONS(3282),
    [anon_sym___extension__] = ACTIONS(3280),
    [anon_sym_typedef] = ACTIONS(3280),
    [anon_sym_extern] = ACTIONS(3280),
    [anon_sym___attribute__] = ACTIONS(3280),
    [anon_sym_COLON_COLON] = ACTIONS(3282),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3282),
    [anon_sym___declspec] = ACTIONS(3280),
    [anon_sym___based] = ACTIONS(3280),
    [anon_sym___cdecl] = ACTIONS(3280),
    [anon_sym___clrcall] = ACTIONS(3280),
    [anon_sym___stdcall] = ACTIONS(3280),
    [anon_sym___fastcall] = ACTIONS(3280),
    [anon_sym___thiscall] = ACTIONS(3280),
    [anon_sym___vectorcall] = ACTIONS(3280),
    [anon_sym_LBRACE] = ACTIONS(3282),
    [anon_sym_signed] = ACTIONS(3280),
    [anon_sym_unsigned] = ACTIONS(3280),
    [anon_sym_long] = ACTIONS(3280),
    [anon_sym_short] = ACTIONS(3280),
    [anon_sym_LBRACK] = ACTIONS(3280),
    [anon_sym_static] = ACTIONS(3280),
    [anon_sym_register] = ACTIONS(3280),
    [anon_sym_inline] = ACTIONS(3280),
    [anon_sym___inline] = ACTIONS(3280),
    [anon_sym___inline__] = ACTIONS(3280),
    [anon_sym___forceinline] = ACTIONS(3280),
    [anon_sym_thread_local] = ACTIONS(3280),
    [anon_sym___thread] = ACTIONS(3280),
    [anon_sym_const] = ACTIONS(3280),
    [anon_sym_constexpr] = ACTIONS(3280),
    [anon_sym_volatile] = ACTIONS(3280),
    [anon_sym_restrict] = ACTIONS(3280),
    [anon_sym___restrict__] = ACTIONS(3280),
    [anon_sym__Atomic] = ACTIONS(3280),
    [anon_sym__Noreturn] = ACTIONS(3280),
    [anon_sym_noreturn] = ACTIONS(3280),
    [anon_sym_mutable] = ACTIONS(3280),
    [anon_sym_constinit] = ACTIONS(3280),
    [anon_sym_consteval] = ACTIONS(3280),
    [anon_sym_PROGMEM] = ACTIONS(3280),
    [aux_sym_primitive_type_token1] = ACTIONS(3280),
    [anon_sym_byte] = ACTIONS(3280),
    [anon_sym_word] = ACTIONS(3280),
    [anon_sym_enum] = ACTIONS(3280),
    [anon_sym_class] = ACTIONS(3280),
    [anon_sym_struct] = ACTIONS(3280),
    [anon_sym_union] = ACTIONS(3280),
    [anon_sym_if] = ACTIONS(3280),
    [anon_sym_switch] = ACTIONS(3280),
    [anon_sym_case] = ACTIONS(3280),
    [anon_sym_default] = ACTIONS(3280),
    [anon_sym_while] = ACTIONS(3280),
    [anon_sym_do] = ACTIONS(3280),
    [anon_sym_for] = ACTIONS(3280),
    [anon_sym_return] = ACTIONS(3280),
    [anon_sym_break] = ACTIONS(3280),
    [anon_sym_continue] = ACTIONS(3280),
    [anon_sym_goto] = ACTIONS(3280),
    [anon_sym___try] = ACTIONS(3280),
    [anon_sym___leave] = ACTIONS(3280),
    [anon_sym_not] = ACTIONS(3280),
    [anon_sym_compl] = ACTIONS(3280),
    [anon_sym_DASH_DASH] = ACTIONS(3282),
    [anon_sym_PLUS_PLUS] = ACTIONS(3282),
    [anon_sym_sizeof] = ACTIONS(3280),
    [anon_sym___alignof__] = ACTIONS(3280),
    [anon_sym___alignof] = ACTIONS(3280),
    [anon_sym__alignof] = ACTIONS(3280),
    [anon_sym_alignof] = ACTIONS(3280),
    [anon_sym__Alignof] = ACTIONS(3280),
    [anon_sym_offsetof] = ACTIONS(3280),
    [anon_sym__Generic] = ACTIONS(3280),
    [anon_sym_asm] = ACTIONS(3280),
    [anon_sym___asm__] = ACTIONS(3280),
    [aux_sym_number_literal_token1] = ACTIONS(3282),
    [aux_sym_number_literal_token2] = ACTIONS(3280),
    [anon_sym_L_SQUOTE] = ACTIONS(3282),
    [anon_sym_u_SQUOTE] = ACTIONS(3282),
    [anon_sym_U_SQUOTE] = ACTIONS(3282),
    [anon_sym_u8_SQUOTE] = ACTIONS(3282),
    [anon_sym_SQUOTE] = ACTIONS(3282),
    [anon_sym_L_DQUOTE] = ACTIONS(3282),
    [anon_sym_u_DQUOTE] = ACTIONS(3282),
    [anon_sym_U_DQUOTE] = ACTIONS(3282),
    [anon_sym_u8_DQUOTE] = ACTIONS(3282),
    [anon_sym_DQUOTE] = ACTIONS(3282),
    [sym_true] = ACTIONS(3280),
    [sym_false] = ACTIONS(3280),
    [anon_sym_NULL] = ACTIONS(3280),
    [anon_sym_nullptr] = ACTIONS(3280),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3280),
    [anon_sym_decltype] = ACTIONS(3280),
    [anon_sym_virtual] = ACTIONS(3280),
    [anon_sym_alignas] = ACTIONS(3280),
    [anon_sym_explicit] = ACTIONS(3280),
    [anon_sym_typename] = ACTIONS(3280),
    [anon_sym_template] = ACTIONS(3280),
    [anon_sym_operator] = ACTIONS(3280),
    [anon_sym_try] = ACTIONS(3280),
    [anon_sym_delete] = ACTIONS(3280),
    [anon_sym_throw] = ACTIONS(3280),
    [anon_sym_namespace] = ACTIONS(3280),
    [anon_sym_using] = ACTIONS(3280),
    [anon_sym_static_assert] = ACTIONS(3280),
    [anon_sym_concept] = ACTIONS(3280),
    [anon_sym_co_return] = ACTIONS(3280),
    [anon_sym_co_yield] = ACTIONS(3280),
    [anon_sym_R_DQUOTE] = ACTIONS(3282),
    [anon_sym_LR_DQUOTE] = ACTIONS(3282),
    [anon_sym_uR_DQUOTE] = ACTIONS(3282),
    [anon_sym_UR_DQUOTE] = ACTIONS(3282),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3282),
    [anon_sym_co_await] = ACTIONS(3280),
    [anon_sym_new] = ACTIONS(3280),
    [anon_sym_requires] = ACTIONS(3280),
    [sym_this] = ACTIONS(3280),
  },
  [388] = {
    [sym_catch_clause] = STATE(388),
    [aux_sym_constructor_try_statement_repeat1] = STATE(388),
    [sym_identifier] = ACTIONS(2843),
    [aux_sym_preproc_include_token1] = ACTIONS(2843),
    [aux_sym_preproc_def_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2843),
    [sym_preproc_directive] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2845),
    [anon_sym_BANG] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym___extension__] = ACTIONS(2843),
    [anon_sym_typedef] = ACTIONS(2843),
    [anon_sym_extern] = ACTIONS(2843),
    [anon_sym___attribute__] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2845),
    [anon_sym___declspec] = ACTIONS(2843),
    [anon_sym___based] = ACTIONS(2843),
    [anon_sym___cdecl] = ACTIONS(2843),
    [anon_sym___clrcall] = ACTIONS(2843),
    [anon_sym___stdcall] = ACTIONS(2843),
    [anon_sym___fastcall] = ACTIONS(2843),
    [anon_sym___thiscall] = ACTIONS(2843),
    [anon_sym___vectorcall] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(2845),
    [anon_sym_RBRACE] = ACTIONS(2845),
    [anon_sym_signed] = ACTIONS(2843),
    [anon_sym_unsigned] = ACTIONS(2843),
    [anon_sym_long] = ACTIONS(2843),
    [anon_sym_short] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_register] = ACTIONS(2843),
    [anon_sym_inline] = ACTIONS(2843),
    [anon_sym___inline] = ACTIONS(2843),
    [anon_sym___inline__] = ACTIONS(2843),
    [anon_sym___forceinline] = ACTIONS(2843),
    [anon_sym_thread_local] = ACTIONS(2843),
    [anon_sym___thread] = ACTIONS(2843),
    [anon_sym_const] = ACTIONS(2843),
    [anon_sym_constexpr] = ACTIONS(2843),
    [anon_sym_volatile] = ACTIONS(2843),
    [anon_sym_restrict] = ACTIONS(2843),
    [anon_sym___restrict__] = ACTIONS(2843),
    [anon_sym__Atomic] = ACTIONS(2843),
    [anon_sym__Noreturn] = ACTIONS(2843),
    [anon_sym_noreturn] = ACTIONS(2843),
    [anon_sym_mutable] = ACTIONS(2843),
    [anon_sym_constinit] = ACTIONS(2843),
    [anon_sym_consteval] = ACTIONS(2843),
    [anon_sym_PROGMEM] = ACTIONS(2843),
    [aux_sym_primitive_type_token1] = ACTIONS(2843),
    [anon_sym_byte] = ACTIONS(2843),
    [anon_sym_word] = ACTIONS(2843),
    [anon_sym_enum] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2843),
    [anon_sym_union] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_else] = ACTIONS(2843),
    [anon_sym_switch] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2843),
    [anon_sym_default] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_break] = ACTIONS(2843),
    [anon_sym_continue] = ACTIONS(2843),
    [anon_sym_goto] = ACTIONS(2843),
    [anon_sym___try] = ACTIONS(2843),
    [anon_sym___leave] = ACTIONS(2843),
    [anon_sym_not] = ACTIONS(2843),
    [anon_sym_compl] = ACTIONS(2843),
    [anon_sym_DASH_DASH] = ACTIONS(2845),
    [anon_sym_PLUS_PLUS] = ACTIONS(2845),
    [anon_sym_sizeof] = ACTIONS(2843),
    [anon_sym___alignof__] = ACTIONS(2843),
    [anon_sym___alignof] = ACTIONS(2843),
    [anon_sym__alignof] = ACTIONS(2843),
    [anon_sym_alignof] = ACTIONS(2843),
    [anon_sym__Alignof] = ACTIONS(2843),
    [anon_sym_offsetof] = ACTIONS(2843),
    [anon_sym__Generic] = ACTIONS(2843),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [aux_sym_number_literal_token1] = ACTIONS(2845),
    [aux_sym_number_literal_token2] = ACTIONS(2843),
    [anon_sym_L_SQUOTE] = ACTIONS(2845),
    [anon_sym_u_SQUOTE] = ACTIONS(2845),
    [anon_sym_U_SQUOTE] = ACTIONS(2845),
    [anon_sym_u8_SQUOTE] = ACTIONS(2845),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_L_DQUOTE] = ACTIONS(2845),
    [anon_sym_u_DQUOTE] = ACTIONS(2845),
    [anon_sym_U_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(2845),
    [sym_true] = ACTIONS(2843),
    [sym_false] = ACTIONS(2843),
    [anon_sym_NULL] = ACTIONS(2843),
    [anon_sym_nullptr] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2843),
    [anon_sym_decltype] = ACTIONS(2843),
    [anon_sym_virtual] = ACTIONS(2843),
    [anon_sym_alignas] = ACTIONS(2843),
    [anon_sym_explicit] = ACTIONS(2843),
    [anon_sym_typename] = ACTIONS(2843),
    [anon_sym_template] = ACTIONS(2843),
    [anon_sym_operator] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_delete] = ACTIONS(2843),
    [anon_sym_throw] = ACTIONS(2843),
    [anon_sym_namespace] = ACTIONS(2843),
    [anon_sym_using] = ACTIONS(2843),
    [anon_sym_static_assert] = ACTIONS(2843),
    [anon_sym_concept] = ACTIONS(2843),
    [anon_sym_co_return] = ACTIONS(2843),
    [anon_sym_co_yield] = ACTIONS(2843),
    [anon_sym_catch] = ACTIONS(3284),
    [anon_sym_R_DQUOTE] = ACTIONS(2845),
    [anon_sym_LR_DQUOTE] = ACTIONS(2845),
    [anon_sym_uR_DQUOTE] = ACTIONS(2845),
    [anon_sym_UR_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2845),
    [anon_sym_co_await] = ACTIONS(2843),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_requires] = ACTIONS(2843),
    [sym_this] = ACTIONS(2843),
  },
  [389] = {
    [sym_preproc_def] = STATE(848),
    [sym_preproc_function_def] = STATE(848),
    [sym_preproc_call] = STATE(848),
    [sym_preproc_if_in_field_declaration_list] = STATE(848),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(848),
    [sym_preproc_else_in_field_declaration_list] = STATE(9301),
    [sym_preproc_elif_in_field_declaration_list] = STATE(9301),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(9301),
    [sym_type_definition] = STATE(848),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6442),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7117),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(848),
    [sym_field_declaration] = STATE(848),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2239),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(848),
    [sym_operator_cast] = STATE(7514),
    [sym_inline_method_definition] = STATE(848),
    [sym__constructor_specifiers] = STATE(2239),
    [sym_operator_cast_definition] = STATE(848),
    [sym_operator_cast_declaration] = STATE(848),
    [sym_constructor_or_destructor_definition] = STATE(848),
    [sym_constructor_or_destructor_declaration] = STATE(848),
    [sym_friend_declaration] = STATE(848),
    [sym_access_specifier] = STATE(9047),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(848),
    [sym_alias_declaration] = STATE(848),
    [sym_static_assert_declaration] = STATE(848),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7514),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(848),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2239),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3198),
    [aux_sym_preproc_if_token1] = ACTIONS(3200),
    [aux_sym_preproc_if_token2] = ACTIONS(3287),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3204),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3204),
    [aux_sym_preproc_else_token1] = ACTIONS(3206),
    [aux_sym_preproc_elif_token1] = ACTIONS(3208),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3210),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3210),
    [sym_preproc_directive] = ACTIONS(3212),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3222),
    [anon_sym_typedef] = ACTIONS(3224),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3240),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3242),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3246),
    [anon_sym_static_assert] = ACTIONS(3248),
  },
  [390] = {
    [sym_preproc_def] = STATE(848),
    [sym_preproc_function_def] = STATE(848),
    [sym_preproc_call] = STATE(848),
    [sym_preproc_if_in_field_declaration_list] = STATE(848),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(848),
    [sym_preproc_else_in_field_declaration_list] = STATE(8975),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8975),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8975),
    [sym_type_definition] = STATE(848),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6442),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7117),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(848),
    [sym_field_declaration] = STATE(848),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2239),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(848),
    [sym_operator_cast] = STATE(7514),
    [sym_inline_method_definition] = STATE(848),
    [sym__constructor_specifiers] = STATE(2239),
    [sym_operator_cast_definition] = STATE(848),
    [sym_operator_cast_declaration] = STATE(848),
    [sym_constructor_or_destructor_definition] = STATE(848),
    [sym_constructor_or_destructor_declaration] = STATE(848),
    [sym_friend_declaration] = STATE(848),
    [sym_access_specifier] = STATE(9047),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(848),
    [sym_alias_declaration] = STATE(848),
    [sym_static_assert_declaration] = STATE(848),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7514),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(848),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2239),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3198),
    [aux_sym_preproc_if_token1] = ACTIONS(3200),
    [aux_sym_preproc_if_token2] = ACTIONS(3289),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3204),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3204),
    [aux_sym_preproc_else_token1] = ACTIONS(3206),
    [aux_sym_preproc_elif_token1] = ACTIONS(3208),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3210),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3210),
    [sym_preproc_directive] = ACTIONS(3212),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3222),
    [anon_sym_typedef] = ACTIONS(3224),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3240),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3242),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3246),
    [anon_sym_static_assert] = ACTIONS(3248),
  },
  [391] = {
    [sym_preproc_def] = STATE(389),
    [sym_preproc_function_def] = STATE(389),
    [sym_preproc_call] = STATE(389),
    [sym_preproc_if_in_field_declaration_list] = STATE(389),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(389),
    [sym_preproc_else_in_field_declaration_list] = STATE(9268),
    [sym_preproc_elif_in_field_declaration_list] = STATE(9268),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(9268),
    [sym_type_definition] = STATE(389),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6442),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7117),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(389),
    [sym_field_declaration] = STATE(389),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2239),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(389),
    [sym_operator_cast] = STATE(7514),
    [sym_inline_method_definition] = STATE(389),
    [sym__constructor_specifiers] = STATE(2239),
    [sym_operator_cast_definition] = STATE(389),
    [sym_operator_cast_declaration] = STATE(389),
    [sym_constructor_or_destructor_definition] = STATE(389),
    [sym_constructor_or_destructor_declaration] = STATE(389),
    [sym_friend_declaration] = STATE(389),
    [sym_access_specifier] = STATE(9047),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(389),
    [sym_alias_declaration] = STATE(389),
    [sym_static_assert_declaration] = STATE(389),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7514),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(389),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2239),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3198),
    [aux_sym_preproc_if_token1] = ACTIONS(3200),
    [aux_sym_preproc_if_token2] = ACTIONS(3291),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3204),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3204),
    [aux_sym_preproc_else_token1] = ACTIONS(3206),
    [aux_sym_preproc_elif_token1] = ACTIONS(3208),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3210),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3210),
    [sym_preproc_directive] = ACTIONS(3212),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3222),
    [anon_sym_typedef] = ACTIONS(3224),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3240),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3242),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3246),
    [anon_sym_static_assert] = ACTIONS(3248),
  },
  [392] = {
    [sym_identifier] = ACTIONS(3293),
    [aux_sym_preproc_include_token1] = ACTIONS(3293),
    [aux_sym_preproc_def_token1] = ACTIONS(3293),
    [aux_sym_preproc_if_token1] = ACTIONS(3293),
    [aux_sym_preproc_if_token2] = ACTIONS(3293),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3293),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3293),
    [aux_sym_preproc_else_token1] = ACTIONS(3293),
    [aux_sym_preproc_elif_token1] = ACTIONS(3293),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3293),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3293),
    [sym_preproc_directive] = ACTIONS(3293),
    [anon_sym_LPAREN2] = ACTIONS(3295),
    [anon_sym_BANG] = ACTIONS(3295),
    [anon_sym_TILDE] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3293),
    [anon_sym_STAR] = ACTIONS(3295),
    [anon_sym_AMP_AMP] = ACTIONS(3295),
    [anon_sym_AMP] = ACTIONS(3293),
    [anon_sym_SEMI] = ACTIONS(3295),
    [anon_sym___extension__] = ACTIONS(3293),
    [anon_sym_typedef] = ACTIONS(3293),
    [anon_sym_extern] = ACTIONS(3293),
    [anon_sym___attribute__] = ACTIONS(3293),
    [anon_sym_COLON_COLON] = ACTIONS(3295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3295),
    [anon_sym___declspec] = ACTIONS(3293),
    [anon_sym___based] = ACTIONS(3293),
    [anon_sym___cdecl] = ACTIONS(3293),
    [anon_sym___clrcall] = ACTIONS(3293),
    [anon_sym___stdcall] = ACTIONS(3293),
    [anon_sym___fastcall] = ACTIONS(3293),
    [anon_sym___thiscall] = ACTIONS(3293),
    [anon_sym___vectorcall] = ACTIONS(3293),
    [anon_sym_LBRACE] = ACTIONS(3295),
    [anon_sym_signed] = ACTIONS(3293),
    [anon_sym_unsigned] = ACTIONS(3293),
    [anon_sym_long] = ACTIONS(3293),
    [anon_sym_short] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_static] = ACTIONS(3293),
    [anon_sym_register] = ACTIONS(3293),
    [anon_sym_inline] = ACTIONS(3293),
    [anon_sym___inline] = ACTIONS(3293),
    [anon_sym___inline__] = ACTIONS(3293),
    [anon_sym___forceinline] = ACTIONS(3293),
    [anon_sym_thread_local] = ACTIONS(3293),
    [anon_sym___thread] = ACTIONS(3293),
    [anon_sym_const] = ACTIONS(3293),
    [anon_sym_constexpr] = ACTIONS(3293),
    [anon_sym_volatile] = ACTIONS(3293),
    [anon_sym_restrict] = ACTIONS(3293),
    [anon_sym___restrict__] = ACTIONS(3293),
    [anon_sym__Atomic] = ACTIONS(3293),
    [anon_sym__Noreturn] = ACTIONS(3293),
    [anon_sym_noreturn] = ACTIONS(3293),
    [anon_sym_mutable] = ACTIONS(3293),
    [anon_sym_constinit] = ACTIONS(3293),
    [anon_sym_consteval] = ACTIONS(3293),
    [anon_sym_PROGMEM] = ACTIONS(3293),
    [aux_sym_primitive_type_token1] = ACTIONS(3293),
    [anon_sym_byte] = ACTIONS(3293),
    [anon_sym_word] = ACTIONS(3293),
    [anon_sym_enum] = ACTIONS(3293),
    [anon_sym_class] = ACTIONS(3293),
    [anon_sym_struct] = ACTIONS(3293),
    [anon_sym_union] = ACTIONS(3293),
    [anon_sym_if] = ACTIONS(3293),
    [anon_sym_switch] = ACTIONS(3293),
    [anon_sym_case] = ACTIONS(3293),
    [anon_sym_default] = ACTIONS(3293),
    [anon_sym_while] = ACTIONS(3293),
    [anon_sym_do] = ACTIONS(3293),
    [anon_sym_for] = ACTIONS(3293),
    [anon_sym_return] = ACTIONS(3293),
    [anon_sym_break] = ACTIONS(3293),
    [anon_sym_continue] = ACTIONS(3293),
    [anon_sym_goto] = ACTIONS(3293),
    [anon_sym___try] = ACTIONS(3293),
    [anon_sym___leave] = ACTIONS(3293),
    [anon_sym_not] = ACTIONS(3293),
    [anon_sym_compl] = ACTIONS(3293),
    [anon_sym_DASH_DASH] = ACTIONS(3295),
    [anon_sym_PLUS_PLUS] = ACTIONS(3295),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3293),
    [anon_sym___alignof] = ACTIONS(3293),
    [anon_sym__alignof] = ACTIONS(3293),
    [anon_sym_alignof] = ACTIONS(3293),
    [anon_sym__Alignof] = ACTIONS(3293),
    [anon_sym_offsetof] = ACTIONS(3293),
    [anon_sym__Generic] = ACTIONS(3293),
    [anon_sym_asm] = ACTIONS(3293),
    [anon_sym___asm__] = ACTIONS(3293),
    [aux_sym_number_literal_token1] = ACTIONS(3295),
    [aux_sym_number_literal_token2] = ACTIONS(3293),
    [anon_sym_L_SQUOTE] = ACTIONS(3295),
    [anon_sym_u_SQUOTE] = ACTIONS(3295),
    [anon_sym_U_SQUOTE] = ACTIONS(3295),
    [anon_sym_u8_SQUOTE] = ACTIONS(3295),
    [anon_sym_SQUOTE] = ACTIONS(3295),
    [anon_sym_L_DQUOTE] = ACTIONS(3295),
    [anon_sym_u_DQUOTE] = ACTIONS(3295),
    [anon_sym_U_DQUOTE] = ACTIONS(3295),
    [anon_sym_u8_DQUOTE] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(3295),
    [sym_true] = ACTIONS(3293),
    [sym_false] = ACTIONS(3293),
    [anon_sym_NULL] = ACTIONS(3293),
    [anon_sym_nullptr] = ACTIONS(3293),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3293),
    [anon_sym_decltype] = ACTIONS(3293),
    [anon_sym_virtual] = ACTIONS(3293),
    [anon_sym_alignas] = ACTIONS(3293),
    [anon_sym_explicit] = ACTIONS(3293),
    [anon_sym_typename] = ACTIONS(3293),
    [anon_sym_template] = ACTIONS(3293),
    [anon_sym_operator] = ACTIONS(3293),
    [anon_sym_try] = ACTIONS(3293),
    [anon_sym_delete] = ACTIONS(3293),
    [anon_sym_throw] = ACTIONS(3293),
    [anon_sym_namespace] = ACTIONS(3293),
    [anon_sym_using] = ACTIONS(3293),
    [anon_sym_static_assert] = ACTIONS(3293),
    [anon_sym_concept] = ACTIONS(3293),
    [anon_sym_co_return] = ACTIONS(3293),
    [anon_sym_co_yield] = ACTIONS(3293),
    [anon_sym_R_DQUOTE] = ACTIONS(3295),
    [anon_sym_LR_DQUOTE] = ACTIONS(3295),
    [anon_sym_uR_DQUOTE] = ACTIONS(3295),
    [anon_sym_UR_DQUOTE] = ACTIONS(3295),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3295),
    [anon_sym_co_await] = ACTIONS(3293),
    [anon_sym_new] = ACTIONS(3293),
    [anon_sym_requires] = ACTIONS(3293),
    [sym_this] = ACTIONS(3293),
  },
  [393] = {
    [sym_type_qualifier] = STATE(4556),
    [sym__type_specifier] = STATE(5703),
    [sym_sized_type_specifier] = STATE(3397),
    [sym_primitive_type] = STATE(5893),
    [sym_enum_specifier] = STATE(3397),
    [sym_struct_specifier] = STATE(3397),
    [sym_union_specifier] = STATE(3397),
    [sym__expression] = STATE(5314),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_type_descriptor] = STATE(8136),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_placeholder_type_specifier] = STATE(3397),
    [sym_decltype_auto] = STATE(3398),
    [sym_decltype] = STATE(3383),
    [sym_class_specifier] = STATE(3397),
    [sym__class_name] = STATE(8471),
    [sym_dependent_type] = STATE(3397),
    [sym_template_type] = STATE(6182),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_type_parameter_pack_expansion] = STATE(8549),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6473),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(6206),
    [sym_user_defined_literal] = STATE(4248),
    [aux_sym__type_definition_type_repeat1] = STATE(4556),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2986),
    [anon_sym_unsigned] = ACTIONS(2986),
    [anon_sym_long] = ACTIONS(2986),
    [anon_sym_short] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2988),
    [anon_sym_byte] = ACTIONS(2988),
    [anon_sym_word] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2990),
    [anon_sym_class] = ACTIONS(2992),
    [anon_sym_struct] = ACTIONS(2994),
    [anon_sym_union] = ACTIONS(2996),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [394] = {
    [sym_identifier] = ACTIONS(3297),
    [aux_sym_preproc_include_token1] = ACTIONS(3297),
    [aux_sym_preproc_def_token1] = ACTIONS(3297),
    [aux_sym_preproc_if_token1] = ACTIONS(3297),
    [aux_sym_preproc_if_token2] = ACTIONS(3297),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3297),
    [aux_sym_preproc_else_token1] = ACTIONS(3297),
    [aux_sym_preproc_elif_token1] = ACTIONS(3297),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3297),
    [sym_preproc_directive] = ACTIONS(3297),
    [anon_sym_LPAREN2] = ACTIONS(3299),
    [anon_sym_BANG] = ACTIONS(3299),
    [anon_sym_TILDE] = ACTIONS(3299),
    [anon_sym_DASH] = ACTIONS(3297),
    [anon_sym_PLUS] = ACTIONS(3297),
    [anon_sym_STAR] = ACTIONS(3299),
    [anon_sym_AMP_AMP] = ACTIONS(3299),
    [anon_sym_AMP] = ACTIONS(3297),
    [anon_sym_SEMI] = ACTIONS(3299),
    [anon_sym___extension__] = ACTIONS(3297),
    [anon_sym_typedef] = ACTIONS(3297),
    [anon_sym_extern] = ACTIONS(3297),
    [anon_sym___attribute__] = ACTIONS(3297),
    [anon_sym_COLON_COLON] = ACTIONS(3299),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3299),
    [anon_sym___declspec] = ACTIONS(3297),
    [anon_sym___based] = ACTIONS(3297),
    [anon_sym___cdecl] = ACTIONS(3297),
    [anon_sym___clrcall] = ACTIONS(3297),
    [anon_sym___stdcall] = ACTIONS(3297),
    [anon_sym___fastcall] = ACTIONS(3297),
    [anon_sym___thiscall] = ACTIONS(3297),
    [anon_sym___vectorcall] = ACTIONS(3297),
    [anon_sym_LBRACE] = ACTIONS(3299),
    [anon_sym_signed] = ACTIONS(3297),
    [anon_sym_unsigned] = ACTIONS(3297),
    [anon_sym_long] = ACTIONS(3297),
    [anon_sym_short] = ACTIONS(3297),
    [anon_sym_LBRACK] = ACTIONS(3297),
    [anon_sym_static] = ACTIONS(3297),
    [anon_sym_register] = ACTIONS(3297),
    [anon_sym_inline] = ACTIONS(3297),
    [anon_sym___inline] = ACTIONS(3297),
    [anon_sym___inline__] = ACTIONS(3297),
    [anon_sym___forceinline] = ACTIONS(3297),
    [anon_sym_thread_local] = ACTIONS(3297),
    [anon_sym___thread] = ACTIONS(3297),
    [anon_sym_const] = ACTIONS(3297),
    [anon_sym_constexpr] = ACTIONS(3297),
    [anon_sym_volatile] = ACTIONS(3297),
    [anon_sym_restrict] = ACTIONS(3297),
    [anon_sym___restrict__] = ACTIONS(3297),
    [anon_sym__Atomic] = ACTIONS(3297),
    [anon_sym__Noreturn] = ACTIONS(3297),
    [anon_sym_noreturn] = ACTIONS(3297),
    [anon_sym_mutable] = ACTIONS(3297),
    [anon_sym_constinit] = ACTIONS(3297),
    [anon_sym_consteval] = ACTIONS(3297),
    [anon_sym_PROGMEM] = ACTIONS(3297),
    [aux_sym_primitive_type_token1] = ACTIONS(3297),
    [anon_sym_byte] = ACTIONS(3297),
    [anon_sym_word] = ACTIONS(3297),
    [anon_sym_enum] = ACTIONS(3297),
    [anon_sym_class] = ACTIONS(3297),
    [anon_sym_struct] = ACTIONS(3297),
    [anon_sym_union] = ACTIONS(3297),
    [anon_sym_if] = ACTIONS(3297),
    [anon_sym_switch] = ACTIONS(3297),
    [anon_sym_case] = ACTIONS(3297),
    [anon_sym_default] = ACTIONS(3297),
    [anon_sym_while] = ACTIONS(3297),
    [anon_sym_do] = ACTIONS(3297),
    [anon_sym_for] = ACTIONS(3297),
    [anon_sym_return] = ACTIONS(3297),
    [anon_sym_break] = ACTIONS(3297),
    [anon_sym_continue] = ACTIONS(3297),
    [anon_sym_goto] = ACTIONS(3297),
    [anon_sym___try] = ACTIONS(3297),
    [anon_sym___leave] = ACTIONS(3297),
    [anon_sym_not] = ACTIONS(3297),
    [anon_sym_compl] = ACTIONS(3297),
    [anon_sym_DASH_DASH] = ACTIONS(3299),
    [anon_sym_PLUS_PLUS] = ACTIONS(3299),
    [anon_sym_sizeof] = ACTIONS(3297),
    [anon_sym___alignof__] = ACTIONS(3297),
    [anon_sym___alignof] = ACTIONS(3297),
    [anon_sym__alignof] = ACTIONS(3297),
    [anon_sym_alignof] = ACTIONS(3297),
    [anon_sym__Alignof] = ACTIONS(3297),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3297),
    [anon_sym_asm] = ACTIONS(3297),
    [anon_sym___asm__] = ACTIONS(3297),
    [aux_sym_number_literal_token1] = ACTIONS(3299),
    [aux_sym_number_literal_token2] = ACTIONS(3297),
    [anon_sym_L_SQUOTE] = ACTIONS(3299),
    [anon_sym_u_SQUOTE] = ACTIONS(3299),
    [anon_sym_U_SQUOTE] = ACTIONS(3299),
    [anon_sym_u8_SQUOTE] = ACTIONS(3299),
    [anon_sym_SQUOTE] = ACTIONS(3299),
    [anon_sym_L_DQUOTE] = ACTIONS(3299),
    [anon_sym_u_DQUOTE] = ACTIONS(3299),
    [anon_sym_U_DQUOTE] = ACTIONS(3299),
    [anon_sym_u8_DQUOTE] = ACTIONS(3299),
    [anon_sym_DQUOTE] = ACTIONS(3299),
    [sym_true] = ACTIONS(3297),
    [sym_false] = ACTIONS(3297),
    [anon_sym_NULL] = ACTIONS(3297),
    [anon_sym_nullptr] = ACTIONS(3297),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3297),
    [anon_sym_decltype] = ACTIONS(3297),
    [anon_sym_virtual] = ACTIONS(3297),
    [anon_sym_alignas] = ACTIONS(3297),
    [anon_sym_explicit] = ACTIONS(3297),
    [anon_sym_typename] = ACTIONS(3297),
    [anon_sym_template] = ACTIONS(3297),
    [anon_sym_operator] = ACTIONS(3297),
    [anon_sym_try] = ACTIONS(3297),
    [anon_sym_delete] = ACTIONS(3297),
    [anon_sym_throw] = ACTIONS(3297),
    [anon_sym_namespace] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3297),
    [anon_sym_static_assert] = ACTIONS(3297),
    [anon_sym_concept] = ACTIONS(3297),
    [anon_sym_co_return] = ACTIONS(3297),
    [anon_sym_co_yield] = ACTIONS(3297),
    [anon_sym_R_DQUOTE] = ACTIONS(3299),
    [anon_sym_LR_DQUOTE] = ACTIONS(3299),
    [anon_sym_uR_DQUOTE] = ACTIONS(3299),
    [anon_sym_UR_DQUOTE] = ACTIONS(3299),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3299),
    [anon_sym_co_await] = ACTIONS(3297),
    [anon_sym_new] = ACTIONS(3297),
    [anon_sym_requires] = ACTIONS(3297),
    [sym_this] = ACTIONS(3297),
  },
  [395] = {
    [sym_identifier] = ACTIONS(3301),
    [aux_sym_preproc_include_token1] = ACTIONS(3301),
    [aux_sym_preproc_def_token1] = ACTIONS(3301),
    [aux_sym_preproc_if_token1] = ACTIONS(3301),
    [aux_sym_preproc_if_token2] = ACTIONS(3301),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3301),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3301),
    [aux_sym_preproc_else_token1] = ACTIONS(3301),
    [aux_sym_preproc_elif_token1] = ACTIONS(3301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3301),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3301),
    [sym_preproc_directive] = ACTIONS(3301),
    [anon_sym_LPAREN2] = ACTIONS(3303),
    [anon_sym_BANG] = ACTIONS(3303),
    [anon_sym_TILDE] = ACTIONS(3303),
    [anon_sym_DASH] = ACTIONS(3301),
    [anon_sym_PLUS] = ACTIONS(3301),
    [anon_sym_STAR] = ACTIONS(3303),
    [anon_sym_AMP_AMP] = ACTIONS(3303),
    [anon_sym_AMP] = ACTIONS(3301),
    [anon_sym_SEMI] = ACTIONS(3303),
    [anon_sym___extension__] = ACTIONS(3301),
    [anon_sym_typedef] = ACTIONS(3301),
    [anon_sym_extern] = ACTIONS(3301),
    [anon_sym___attribute__] = ACTIONS(3301),
    [anon_sym_COLON_COLON] = ACTIONS(3303),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3303),
    [anon_sym___declspec] = ACTIONS(3301),
    [anon_sym___based] = ACTIONS(3301),
    [anon_sym___cdecl] = ACTIONS(3301),
    [anon_sym___clrcall] = ACTIONS(3301),
    [anon_sym___stdcall] = ACTIONS(3301),
    [anon_sym___fastcall] = ACTIONS(3301),
    [anon_sym___thiscall] = ACTIONS(3301),
    [anon_sym___vectorcall] = ACTIONS(3301),
    [anon_sym_LBRACE] = ACTIONS(3303),
    [anon_sym_signed] = ACTIONS(3301),
    [anon_sym_unsigned] = ACTIONS(3301),
    [anon_sym_long] = ACTIONS(3301),
    [anon_sym_short] = ACTIONS(3301),
    [anon_sym_LBRACK] = ACTIONS(3301),
    [anon_sym_static] = ACTIONS(3301),
    [anon_sym_register] = ACTIONS(3301),
    [anon_sym_inline] = ACTIONS(3301),
    [anon_sym___inline] = ACTIONS(3301),
    [anon_sym___inline__] = ACTIONS(3301),
    [anon_sym___forceinline] = ACTIONS(3301),
    [anon_sym_thread_local] = ACTIONS(3301),
    [anon_sym___thread] = ACTIONS(3301),
    [anon_sym_const] = ACTIONS(3301),
    [anon_sym_constexpr] = ACTIONS(3301),
    [anon_sym_volatile] = ACTIONS(3301),
    [anon_sym_restrict] = ACTIONS(3301),
    [anon_sym___restrict__] = ACTIONS(3301),
    [anon_sym__Atomic] = ACTIONS(3301),
    [anon_sym__Noreturn] = ACTIONS(3301),
    [anon_sym_noreturn] = ACTIONS(3301),
    [anon_sym_mutable] = ACTIONS(3301),
    [anon_sym_constinit] = ACTIONS(3301),
    [anon_sym_consteval] = ACTIONS(3301),
    [anon_sym_PROGMEM] = ACTIONS(3301),
    [aux_sym_primitive_type_token1] = ACTIONS(3301),
    [anon_sym_byte] = ACTIONS(3301),
    [anon_sym_word] = ACTIONS(3301),
    [anon_sym_enum] = ACTIONS(3301),
    [anon_sym_class] = ACTIONS(3301),
    [anon_sym_struct] = ACTIONS(3301),
    [anon_sym_union] = ACTIONS(3301),
    [anon_sym_if] = ACTIONS(3301),
    [anon_sym_switch] = ACTIONS(3301),
    [anon_sym_case] = ACTIONS(3301),
    [anon_sym_default] = ACTIONS(3301),
    [anon_sym_while] = ACTIONS(3301),
    [anon_sym_do] = ACTIONS(3301),
    [anon_sym_for] = ACTIONS(3301),
    [anon_sym_return] = ACTIONS(3301),
    [anon_sym_break] = ACTIONS(3301),
    [anon_sym_continue] = ACTIONS(3301),
    [anon_sym_goto] = ACTIONS(3301),
    [anon_sym___try] = ACTIONS(3301),
    [anon_sym___leave] = ACTIONS(3301),
    [anon_sym_not] = ACTIONS(3301),
    [anon_sym_compl] = ACTIONS(3301),
    [anon_sym_DASH_DASH] = ACTIONS(3303),
    [anon_sym_PLUS_PLUS] = ACTIONS(3303),
    [anon_sym_sizeof] = ACTIONS(3301),
    [anon_sym___alignof__] = ACTIONS(3301),
    [anon_sym___alignof] = ACTIONS(3301),
    [anon_sym__alignof] = ACTIONS(3301),
    [anon_sym_alignof] = ACTIONS(3301),
    [anon_sym__Alignof] = ACTIONS(3301),
    [anon_sym_offsetof] = ACTIONS(3301),
    [anon_sym__Generic] = ACTIONS(3301),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [aux_sym_number_literal_token1] = ACTIONS(3303),
    [aux_sym_number_literal_token2] = ACTIONS(3301),
    [anon_sym_L_SQUOTE] = ACTIONS(3303),
    [anon_sym_u_SQUOTE] = ACTIONS(3303),
    [anon_sym_U_SQUOTE] = ACTIONS(3303),
    [anon_sym_u8_SQUOTE] = ACTIONS(3303),
    [anon_sym_SQUOTE] = ACTIONS(3303),
    [anon_sym_L_DQUOTE] = ACTIONS(3303),
    [anon_sym_u_DQUOTE] = ACTIONS(3303),
    [anon_sym_U_DQUOTE] = ACTIONS(3303),
    [anon_sym_u8_DQUOTE] = ACTIONS(3303),
    [anon_sym_DQUOTE] = ACTIONS(3303),
    [sym_true] = ACTIONS(3301),
    [sym_false] = ACTIONS(3301),
    [anon_sym_NULL] = ACTIONS(3301),
    [anon_sym_nullptr] = ACTIONS(3301),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3301),
    [anon_sym_decltype] = ACTIONS(3301),
    [anon_sym_virtual] = ACTIONS(3301),
    [anon_sym_alignas] = ACTIONS(3301),
    [anon_sym_explicit] = ACTIONS(3301),
    [anon_sym_typename] = ACTIONS(3301),
    [anon_sym_template] = ACTIONS(3301),
    [anon_sym_operator] = ACTIONS(3301),
    [anon_sym_try] = ACTIONS(3301),
    [anon_sym_delete] = ACTIONS(3301),
    [anon_sym_throw] = ACTIONS(3301),
    [anon_sym_namespace] = ACTIONS(3301),
    [anon_sym_using] = ACTIONS(3301),
    [anon_sym_static_assert] = ACTIONS(3301),
    [anon_sym_concept] = ACTIONS(3301),
    [anon_sym_co_return] = ACTIONS(3301),
    [anon_sym_co_yield] = ACTIONS(3301),
    [anon_sym_R_DQUOTE] = ACTIONS(3303),
    [anon_sym_LR_DQUOTE] = ACTIONS(3303),
    [anon_sym_uR_DQUOTE] = ACTIONS(3303),
    [anon_sym_UR_DQUOTE] = ACTIONS(3303),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3303),
    [anon_sym_co_await] = ACTIONS(3301),
    [anon_sym_new] = ACTIONS(3301),
    [anon_sym_requires] = ACTIONS(3301),
    [sym_this] = ACTIONS(3301),
  },
  [396] = {
    [sym_catch_clause] = STATE(396),
    [aux_sym_constructor_try_statement_repeat1] = STATE(396),
    [ts_builtin_sym_end] = ACTIONS(2845),
    [sym_identifier] = ACTIONS(2843),
    [aux_sym_preproc_include_token1] = ACTIONS(2843),
    [aux_sym_preproc_def_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2843),
    [sym_preproc_directive] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2845),
    [anon_sym_BANG] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym___extension__] = ACTIONS(2843),
    [anon_sym_typedef] = ACTIONS(2843),
    [anon_sym_extern] = ACTIONS(2843),
    [anon_sym___attribute__] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2845),
    [anon_sym___declspec] = ACTIONS(2843),
    [anon_sym___based] = ACTIONS(2843),
    [anon_sym___cdecl] = ACTIONS(2843),
    [anon_sym___clrcall] = ACTIONS(2843),
    [anon_sym___stdcall] = ACTIONS(2843),
    [anon_sym___fastcall] = ACTIONS(2843),
    [anon_sym___thiscall] = ACTIONS(2843),
    [anon_sym___vectorcall] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(2845),
    [anon_sym_signed] = ACTIONS(2843),
    [anon_sym_unsigned] = ACTIONS(2843),
    [anon_sym_long] = ACTIONS(2843),
    [anon_sym_short] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_register] = ACTIONS(2843),
    [anon_sym_inline] = ACTIONS(2843),
    [anon_sym___inline] = ACTIONS(2843),
    [anon_sym___inline__] = ACTIONS(2843),
    [anon_sym___forceinline] = ACTIONS(2843),
    [anon_sym_thread_local] = ACTIONS(2843),
    [anon_sym___thread] = ACTIONS(2843),
    [anon_sym_const] = ACTIONS(2843),
    [anon_sym_constexpr] = ACTIONS(2843),
    [anon_sym_volatile] = ACTIONS(2843),
    [anon_sym_restrict] = ACTIONS(2843),
    [anon_sym___restrict__] = ACTIONS(2843),
    [anon_sym__Atomic] = ACTIONS(2843),
    [anon_sym__Noreturn] = ACTIONS(2843),
    [anon_sym_noreturn] = ACTIONS(2843),
    [anon_sym_mutable] = ACTIONS(2843),
    [anon_sym_constinit] = ACTIONS(2843),
    [anon_sym_consteval] = ACTIONS(2843),
    [anon_sym_PROGMEM] = ACTIONS(2843),
    [aux_sym_primitive_type_token1] = ACTIONS(2843),
    [anon_sym_byte] = ACTIONS(2843),
    [anon_sym_word] = ACTIONS(2843),
    [anon_sym_enum] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2843),
    [anon_sym_union] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_else] = ACTIONS(2843),
    [anon_sym_switch] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2843),
    [anon_sym_default] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_break] = ACTIONS(2843),
    [anon_sym_continue] = ACTIONS(2843),
    [anon_sym_goto] = ACTIONS(2843),
    [anon_sym___try] = ACTIONS(2843),
    [anon_sym___leave] = ACTIONS(2843),
    [anon_sym_not] = ACTIONS(2843),
    [anon_sym_compl] = ACTIONS(2843),
    [anon_sym_DASH_DASH] = ACTIONS(2845),
    [anon_sym_PLUS_PLUS] = ACTIONS(2845),
    [anon_sym_sizeof] = ACTIONS(2843),
    [anon_sym___alignof__] = ACTIONS(2843),
    [anon_sym___alignof] = ACTIONS(2843),
    [anon_sym__alignof] = ACTIONS(2843),
    [anon_sym_alignof] = ACTIONS(2843),
    [anon_sym__Alignof] = ACTIONS(2843),
    [anon_sym_offsetof] = ACTIONS(2843),
    [anon_sym__Generic] = ACTIONS(2843),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [aux_sym_number_literal_token1] = ACTIONS(2845),
    [aux_sym_number_literal_token2] = ACTIONS(2843),
    [anon_sym_L_SQUOTE] = ACTIONS(2845),
    [anon_sym_u_SQUOTE] = ACTIONS(2845),
    [anon_sym_U_SQUOTE] = ACTIONS(2845),
    [anon_sym_u8_SQUOTE] = ACTIONS(2845),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_L_DQUOTE] = ACTIONS(2845),
    [anon_sym_u_DQUOTE] = ACTIONS(2845),
    [anon_sym_U_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(2845),
    [sym_true] = ACTIONS(2843),
    [sym_false] = ACTIONS(2843),
    [anon_sym_NULL] = ACTIONS(2843),
    [anon_sym_nullptr] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2843),
    [anon_sym_decltype] = ACTIONS(2843),
    [anon_sym_virtual] = ACTIONS(2843),
    [anon_sym_alignas] = ACTIONS(2843),
    [anon_sym_explicit] = ACTIONS(2843),
    [anon_sym_typename] = ACTIONS(2843),
    [anon_sym_template] = ACTIONS(2843),
    [anon_sym_operator] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_delete] = ACTIONS(2843),
    [anon_sym_throw] = ACTIONS(2843),
    [anon_sym_namespace] = ACTIONS(2843),
    [anon_sym_using] = ACTIONS(2843),
    [anon_sym_static_assert] = ACTIONS(2843),
    [anon_sym_concept] = ACTIONS(2843),
    [anon_sym_co_return] = ACTIONS(2843),
    [anon_sym_co_yield] = ACTIONS(2843),
    [anon_sym_catch] = ACTIONS(3305),
    [anon_sym_R_DQUOTE] = ACTIONS(2845),
    [anon_sym_LR_DQUOTE] = ACTIONS(2845),
    [anon_sym_uR_DQUOTE] = ACTIONS(2845),
    [anon_sym_UR_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2845),
    [anon_sym_co_await] = ACTIONS(2843),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_requires] = ACTIONS(2843),
    [sym_this] = ACTIONS(2843),
  },
  [397] = {
    [sym_else_clause] = STATE(534),
    [sym_identifier] = ACTIONS(2918),
    [aux_sym_preproc_include_token1] = ACTIONS(2918),
    [aux_sym_preproc_def_token1] = ACTIONS(2918),
    [aux_sym_preproc_if_token1] = ACTIONS(2918),
    [aux_sym_preproc_if_token2] = ACTIONS(2918),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2918),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2918),
    [aux_sym_preproc_else_token1] = ACTIONS(2918),
    [aux_sym_preproc_elif_token1] = ACTIONS(2918),
    [sym_preproc_directive] = ACTIONS(2918),
    [anon_sym_LPAREN2] = ACTIONS(2920),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2920),
    [anon_sym_DASH] = ACTIONS(2918),
    [anon_sym_PLUS] = ACTIONS(2918),
    [anon_sym_STAR] = ACTIONS(2920),
    [anon_sym_AMP_AMP] = ACTIONS(2920),
    [anon_sym_AMP] = ACTIONS(2918),
    [anon_sym_SEMI] = ACTIONS(2920),
    [anon_sym___extension__] = ACTIONS(2918),
    [anon_sym_typedef] = ACTIONS(2918),
    [anon_sym_extern] = ACTIONS(2918),
    [anon_sym___attribute__] = ACTIONS(2918),
    [anon_sym_COLON_COLON] = ACTIONS(2920),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2920),
    [anon_sym___declspec] = ACTIONS(2918),
    [anon_sym___based] = ACTIONS(2918),
    [anon_sym___cdecl] = ACTIONS(2918),
    [anon_sym___clrcall] = ACTIONS(2918),
    [anon_sym___stdcall] = ACTIONS(2918),
    [anon_sym___fastcall] = ACTIONS(2918),
    [anon_sym___thiscall] = ACTIONS(2918),
    [anon_sym___vectorcall] = ACTIONS(2918),
    [anon_sym_LBRACE] = ACTIONS(2920),
    [anon_sym_signed] = ACTIONS(2918),
    [anon_sym_unsigned] = ACTIONS(2918),
    [anon_sym_long] = ACTIONS(2918),
    [anon_sym_short] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(2918),
    [anon_sym_static] = ACTIONS(2918),
    [anon_sym_register] = ACTIONS(2918),
    [anon_sym_inline] = ACTIONS(2918),
    [anon_sym___inline] = ACTIONS(2918),
    [anon_sym___inline__] = ACTIONS(2918),
    [anon_sym___forceinline] = ACTIONS(2918),
    [anon_sym_thread_local] = ACTIONS(2918),
    [anon_sym___thread] = ACTIONS(2918),
    [anon_sym_const] = ACTIONS(2918),
    [anon_sym_constexpr] = ACTIONS(2918),
    [anon_sym_volatile] = ACTIONS(2918),
    [anon_sym_restrict] = ACTIONS(2918),
    [anon_sym___restrict__] = ACTIONS(2918),
    [anon_sym__Atomic] = ACTIONS(2918),
    [anon_sym__Noreturn] = ACTIONS(2918),
    [anon_sym_noreturn] = ACTIONS(2918),
    [anon_sym_mutable] = ACTIONS(2918),
    [anon_sym_constinit] = ACTIONS(2918),
    [anon_sym_consteval] = ACTIONS(2918),
    [anon_sym_PROGMEM] = ACTIONS(2918),
    [aux_sym_primitive_type_token1] = ACTIONS(2918),
    [anon_sym_byte] = ACTIONS(2918),
    [anon_sym_word] = ACTIONS(2918),
    [anon_sym_enum] = ACTIONS(2918),
    [anon_sym_class] = ACTIONS(2918),
    [anon_sym_struct] = ACTIONS(2918),
    [anon_sym_union] = ACTIONS(2918),
    [anon_sym_if] = ACTIONS(2918),
    [anon_sym_else] = ACTIONS(3308),
    [anon_sym_switch] = ACTIONS(2918),
    [anon_sym_case] = ACTIONS(2918),
    [anon_sym_default] = ACTIONS(2918),
    [anon_sym_while] = ACTIONS(2918),
    [anon_sym_do] = ACTIONS(2918),
    [anon_sym_for] = ACTIONS(2918),
    [anon_sym_return] = ACTIONS(2918),
    [anon_sym_break] = ACTIONS(2918),
    [anon_sym_continue] = ACTIONS(2918),
    [anon_sym_goto] = ACTIONS(2918),
    [anon_sym___try] = ACTIONS(2918),
    [anon_sym___leave] = ACTIONS(2918),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_compl] = ACTIONS(2918),
    [anon_sym_DASH_DASH] = ACTIONS(2920),
    [anon_sym_PLUS_PLUS] = ACTIONS(2920),
    [anon_sym_sizeof] = ACTIONS(2918),
    [anon_sym___alignof__] = ACTIONS(2918),
    [anon_sym___alignof] = ACTIONS(2918),
    [anon_sym__alignof] = ACTIONS(2918),
    [anon_sym_alignof] = ACTIONS(2918),
    [anon_sym__Alignof] = ACTIONS(2918),
    [anon_sym_offsetof] = ACTIONS(2918),
    [anon_sym__Generic] = ACTIONS(2918),
    [anon_sym_asm] = ACTIONS(2918),
    [anon_sym___asm__] = ACTIONS(2918),
    [aux_sym_number_literal_token1] = ACTIONS(2920),
    [aux_sym_number_literal_token2] = ACTIONS(2918),
    [anon_sym_L_SQUOTE] = ACTIONS(2920),
    [anon_sym_u_SQUOTE] = ACTIONS(2920),
    [anon_sym_U_SQUOTE] = ACTIONS(2920),
    [anon_sym_u8_SQUOTE] = ACTIONS(2920),
    [anon_sym_SQUOTE] = ACTIONS(2920),
    [anon_sym_L_DQUOTE] = ACTIONS(2920),
    [anon_sym_u_DQUOTE] = ACTIONS(2920),
    [anon_sym_U_DQUOTE] = ACTIONS(2920),
    [anon_sym_u8_DQUOTE] = ACTIONS(2920),
    [anon_sym_DQUOTE] = ACTIONS(2920),
    [sym_true] = ACTIONS(2918),
    [sym_false] = ACTIONS(2918),
    [anon_sym_NULL] = ACTIONS(2918),
    [anon_sym_nullptr] = ACTIONS(2918),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2918),
    [anon_sym_decltype] = ACTIONS(2918),
    [anon_sym_virtual] = ACTIONS(2918),
    [anon_sym_alignas] = ACTIONS(2918),
    [anon_sym_explicit] = ACTIONS(2918),
    [anon_sym_typename] = ACTIONS(2918),
    [anon_sym_template] = ACTIONS(2918),
    [anon_sym_operator] = ACTIONS(2918),
    [anon_sym_try] = ACTIONS(2918),
    [anon_sym_delete] = ACTIONS(2918),
    [anon_sym_throw] = ACTIONS(2918),
    [anon_sym_namespace] = ACTIONS(2918),
    [anon_sym_using] = ACTIONS(2918),
    [anon_sym_static_assert] = ACTIONS(2918),
    [anon_sym_concept] = ACTIONS(2918),
    [anon_sym_co_return] = ACTIONS(2918),
    [anon_sym_co_yield] = ACTIONS(2918),
    [anon_sym_R_DQUOTE] = ACTIONS(2920),
    [anon_sym_LR_DQUOTE] = ACTIONS(2920),
    [anon_sym_uR_DQUOTE] = ACTIONS(2920),
    [anon_sym_UR_DQUOTE] = ACTIONS(2920),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2920),
    [anon_sym_co_await] = ACTIONS(2918),
    [anon_sym_new] = ACTIONS(2918),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2918),
  },
  [398] = {
    [sym_identifier] = ACTIONS(3310),
    [aux_sym_preproc_include_token1] = ACTIONS(3310),
    [aux_sym_preproc_def_token1] = ACTIONS(3310),
    [aux_sym_preproc_if_token1] = ACTIONS(3310),
    [aux_sym_preproc_if_token2] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3310),
    [aux_sym_preproc_else_token1] = ACTIONS(3310),
    [aux_sym_preproc_elif_token1] = ACTIONS(3310),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3310),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3310),
    [sym_preproc_directive] = ACTIONS(3310),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_AMP_AMP] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3310),
    [anon_sym_SEMI] = ACTIONS(3312),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_typedef] = ACTIONS(3310),
    [anon_sym_extern] = ACTIONS(3310),
    [anon_sym___attribute__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3312),
    [anon_sym___declspec] = ACTIONS(3310),
    [anon_sym___based] = ACTIONS(3310),
    [anon_sym___cdecl] = ACTIONS(3310),
    [anon_sym___clrcall] = ACTIONS(3310),
    [anon_sym___stdcall] = ACTIONS(3310),
    [anon_sym___fastcall] = ACTIONS(3310),
    [anon_sym___thiscall] = ACTIONS(3310),
    [anon_sym___vectorcall] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3312),
    [anon_sym_signed] = ACTIONS(3310),
    [anon_sym_unsigned] = ACTIONS(3310),
    [anon_sym_long] = ACTIONS(3310),
    [anon_sym_short] = ACTIONS(3310),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [anon_sym_static] = ACTIONS(3310),
    [anon_sym_register] = ACTIONS(3310),
    [anon_sym_inline] = ACTIONS(3310),
    [anon_sym___inline] = ACTIONS(3310),
    [anon_sym___inline__] = ACTIONS(3310),
    [anon_sym___forceinline] = ACTIONS(3310),
    [anon_sym_thread_local] = ACTIONS(3310),
    [anon_sym___thread] = ACTIONS(3310),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_constexpr] = ACTIONS(3310),
    [anon_sym_volatile] = ACTIONS(3310),
    [anon_sym_restrict] = ACTIONS(3310),
    [anon_sym___restrict__] = ACTIONS(3310),
    [anon_sym__Atomic] = ACTIONS(3310),
    [anon_sym__Noreturn] = ACTIONS(3310),
    [anon_sym_noreturn] = ACTIONS(3310),
    [anon_sym_mutable] = ACTIONS(3310),
    [anon_sym_constinit] = ACTIONS(3310),
    [anon_sym_consteval] = ACTIONS(3310),
    [anon_sym_PROGMEM] = ACTIONS(3310),
    [aux_sym_primitive_type_token1] = ACTIONS(3310),
    [anon_sym_byte] = ACTIONS(3310),
    [anon_sym_word] = ACTIONS(3310),
    [anon_sym_enum] = ACTIONS(3310),
    [anon_sym_class] = ACTIONS(3310),
    [anon_sym_struct] = ACTIONS(3310),
    [anon_sym_union] = ACTIONS(3310),
    [anon_sym_if] = ACTIONS(3310),
    [anon_sym_switch] = ACTIONS(3310),
    [anon_sym_case] = ACTIONS(3310),
    [anon_sym_default] = ACTIONS(3310),
    [anon_sym_while] = ACTIONS(3310),
    [anon_sym_do] = ACTIONS(3310),
    [anon_sym_for] = ACTIONS(3310),
    [anon_sym_return] = ACTIONS(3310),
    [anon_sym_break] = ACTIONS(3310),
    [anon_sym_continue] = ACTIONS(3310),
    [anon_sym_goto] = ACTIONS(3310),
    [anon_sym___try] = ACTIONS(3310),
    [anon_sym___leave] = ACTIONS(3310),
    [anon_sym_not] = ACTIONS(3310),
    [anon_sym_compl] = ACTIONS(3310),
    [anon_sym_DASH_DASH] = ACTIONS(3312),
    [anon_sym_PLUS_PLUS] = ACTIONS(3312),
    [anon_sym_sizeof] = ACTIONS(3310),
    [anon_sym___alignof__] = ACTIONS(3310),
    [anon_sym___alignof] = ACTIONS(3310),
    [anon_sym__alignof] = ACTIONS(3310),
    [anon_sym_alignof] = ACTIONS(3310),
    [anon_sym__Alignof] = ACTIONS(3310),
    [anon_sym_offsetof] = ACTIONS(3310),
    [anon_sym__Generic] = ACTIONS(3310),
    [anon_sym_asm] = ACTIONS(3310),
    [anon_sym___asm__] = ACTIONS(3310),
    [aux_sym_number_literal_token1] = ACTIONS(3312),
    [aux_sym_number_literal_token2] = ACTIONS(3310),
    [anon_sym_L_SQUOTE] = ACTIONS(3312),
    [anon_sym_u_SQUOTE] = ACTIONS(3312),
    [anon_sym_U_SQUOTE] = ACTIONS(3312),
    [anon_sym_u8_SQUOTE] = ACTIONS(3312),
    [anon_sym_SQUOTE] = ACTIONS(3312),
    [anon_sym_L_DQUOTE] = ACTIONS(3312),
    [anon_sym_u_DQUOTE] = ACTIONS(3312),
    [anon_sym_U_DQUOTE] = ACTIONS(3312),
    [anon_sym_u8_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE] = ACTIONS(3312),
    [sym_true] = ACTIONS(3310),
    [sym_false] = ACTIONS(3310),
    [anon_sym_NULL] = ACTIONS(3310),
    [anon_sym_nullptr] = ACTIONS(3310),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3310),
    [anon_sym_decltype] = ACTIONS(3310),
    [anon_sym_virtual] = ACTIONS(3310),
    [anon_sym_alignas] = ACTIONS(3310),
    [anon_sym_explicit] = ACTIONS(3310),
    [anon_sym_typename] = ACTIONS(3310),
    [anon_sym_template] = ACTIONS(3310),
    [anon_sym_operator] = ACTIONS(3310),
    [anon_sym_try] = ACTIONS(3310),
    [anon_sym_delete] = ACTIONS(3310),
    [anon_sym_throw] = ACTIONS(3310),
    [anon_sym_namespace] = ACTIONS(3310),
    [anon_sym_using] = ACTIONS(3310),
    [anon_sym_static_assert] = ACTIONS(3310),
    [anon_sym_concept] = ACTIONS(3310),
    [anon_sym_co_return] = ACTIONS(3310),
    [anon_sym_co_yield] = ACTIONS(3310),
    [anon_sym_R_DQUOTE] = ACTIONS(3312),
    [anon_sym_LR_DQUOTE] = ACTIONS(3312),
    [anon_sym_uR_DQUOTE] = ACTIONS(3312),
    [anon_sym_UR_DQUOTE] = ACTIONS(3312),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3312),
    [anon_sym_co_await] = ACTIONS(3310),
    [anon_sym_new] = ACTIONS(3310),
    [anon_sym_requires] = ACTIONS(3310),
    [sym_this] = ACTIONS(3310),
  },
  [399] = {
    [sym_identifier] = ACTIONS(3314),
    [aux_sym_preproc_include_token1] = ACTIONS(3314),
    [aux_sym_preproc_def_token1] = ACTIONS(3314),
    [aux_sym_preproc_if_token1] = ACTIONS(3314),
    [aux_sym_preproc_if_token2] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3314),
    [aux_sym_preproc_else_token1] = ACTIONS(3314),
    [aux_sym_preproc_elif_token1] = ACTIONS(3314),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3314),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3314),
    [sym_preproc_directive] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_STAR] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_SEMI] = ACTIONS(3316),
    [anon_sym___extension__] = ACTIONS(3314),
    [anon_sym_typedef] = ACTIONS(3314),
    [anon_sym_extern] = ACTIONS(3314),
    [anon_sym___attribute__] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3316),
    [anon_sym___declspec] = ACTIONS(3314),
    [anon_sym___based] = ACTIONS(3314),
    [anon_sym___cdecl] = ACTIONS(3314),
    [anon_sym___clrcall] = ACTIONS(3314),
    [anon_sym___stdcall] = ACTIONS(3314),
    [anon_sym___fastcall] = ACTIONS(3314),
    [anon_sym___thiscall] = ACTIONS(3314),
    [anon_sym___vectorcall] = ACTIONS(3314),
    [anon_sym_LBRACE] = ACTIONS(3316),
    [anon_sym_signed] = ACTIONS(3314),
    [anon_sym_unsigned] = ACTIONS(3314),
    [anon_sym_long] = ACTIONS(3314),
    [anon_sym_short] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_static] = ACTIONS(3314),
    [anon_sym_register] = ACTIONS(3314),
    [anon_sym_inline] = ACTIONS(3314),
    [anon_sym___inline] = ACTIONS(3314),
    [anon_sym___inline__] = ACTIONS(3314),
    [anon_sym___forceinline] = ACTIONS(3314),
    [anon_sym_thread_local] = ACTIONS(3314),
    [anon_sym___thread] = ACTIONS(3314),
    [anon_sym_const] = ACTIONS(3314),
    [anon_sym_constexpr] = ACTIONS(3314),
    [anon_sym_volatile] = ACTIONS(3314),
    [anon_sym_restrict] = ACTIONS(3314),
    [anon_sym___restrict__] = ACTIONS(3314),
    [anon_sym__Atomic] = ACTIONS(3314),
    [anon_sym__Noreturn] = ACTIONS(3314),
    [anon_sym_noreturn] = ACTIONS(3314),
    [anon_sym_mutable] = ACTIONS(3314),
    [anon_sym_constinit] = ACTIONS(3314),
    [anon_sym_consteval] = ACTIONS(3314),
    [anon_sym_PROGMEM] = ACTIONS(3314),
    [aux_sym_primitive_type_token1] = ACTIONS(3314),
    [anon_sym_byte] = ACTIONS(3314),
    [anon_sym_word] = ACTIONS(3314),
    [anon_sym_enum] = ACTIONS(3314),
    [anon_sym_class] = ACTIONS(3314),
    [anon_sym_struct] = ACTIONS(3314),
    [anon_sym_union] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_switch] = ACTIONS(3314),
    [anon_sym_case] = ACTIONS(3314),
    [anon_sym_default] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_break] = ACTIONS(3314),
    [anon_sym_continue] = ACTIONS(3314),
    [anon_sym_goto] = ACTIONS(3314),
    [anon_sym___try] = ACTIONS(3314),
    [anon_sym___leave] = ACTIONS(3314),
    [anon_sym_not] = ACTIONS(3314),
    [anon_sym_compl] = ACTIONS(3314),
    [anon_sym_DASH_DASH] = ACTIONS(3316),
    [anon_sym_PLUS_PLUS] = ACTIONS(3316),
    [anon_sym_sizeof] = ACTIONS(3314),
    [anon_sym___alignof__] = ACTIONS(3314),
    [anon_sym___alignof] = ACTIONS(3314),
    [anon_sym__alignof] = ACTIONS(3314),
    [anon_sym_alignof] = ACTIONS(3314),
    [anon_sym__Alignof] = ACTIONS(3314),
    [anon_sym_offsetof] = ACTIONS(3314),
    [anon_sym__Generic] = ACTIONS(3314),
    [anon_sym_asm] = ACTIONS(3314),
    [anon_sym___asm__] = ACTIONS(3314),
    [aux_sym_number_literal_token1] = ACTIONS(3316),
    [aux_sym_number_literal_token2] = ACTIONS(3314),
    [anon_sym_L_SQUOTE] = ACTIONS(3316),
    [anon_sym_u_SQUOTE] = ACTIONS(3316),
    [anon_sym_U_SQUOTE] = ACTIONS(3316),
    [anon_sym_u8_SQUOTE] = ACTIONS(3316),
    [anon_sym_SQUOTE] = ACTIONS(3316),
    [anon_sym_L_DQUOTE] = ACTIONS(3316),
    [anon_sym_u_DQUOTE] = ACTIONS(3316),
    [anon_sym_U_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8_DQUOTE] = ACTIONS(3316),
    [anon_sym_DQUOTE] = ACTIONS(3316),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [anon_sym_NULL] = ACTIONS(3314),
    [anon_sym_nullptr] = ACTIONS(3314),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3314),
    [anon_sym_decltype] = ACTIONS(3314),
    [anon_sym_virtual] = ACTIONS(3314),
    [anon_sym_alignas] = ACTIONS(3314),
    [anon_sym_explicit] = ACTIONS(3314),
    [anon_sym_typename] = ACTIONS(3314),
    [anon_sym_template] = ACTIONS(3314),
    [anon_sym_operator] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_delete] = ACTIONS(3314),
    [anon_sym_throw] = ACTIONS(3314),
    [anon_sym_namespace] = ACTIONS(3314),
    [anon_sym_using] = ACTIONS(3314),
    [anon_sym_static_assert] = ACTIONS(3314),
    [anon_sym_concept] = ACTIONS(3314),
    [anon_sym_co_return] = ACTIONS(3314),
    [anon_sym_co_yield] = ACTIONS(3314),
    [anon_sym_R_DQUOTE] = ACTIONS(3316),
    [anon_sym_LR_DQUOTE] = ACTIONS(3316),
    [anon_sym_uR_DQUOTE] = ACTIONS(3316),
    [anon_sym_UR_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3316),
    [anon_sym_co_await] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_requires] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
  },
  [400] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5119),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(3320),
    [anon_sym_extern] = ACTIONS(3320),
    [anon_sym___attribute__] = ACTIONS(3320),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3322),
    [anon_sym___declspec] = ACTIONS(3320),
    [anon_sym_signed] = ACTIONS(3320),
    [anon_sym_unsigned] = ACTIONS(3320),
    [anon_sym_long] = ACTIONS(3320),
    [anon_sym_short] = ACTIONS(3320),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(3320),
    [anon_sym_register] = ACTIONS(3320),
    [anon_sym_inline] = ACTIONS(3320),
    [anon_sym___inline] = ACTIONS(3320),
    [anon_sym___inline__] = ACTIONS(3320),
    [anon_sym___forceinline] = ACTIONS(3320),
    [anon_sym_thread_local] = ACTIONS(3320),
    [anon_sym___thread] = ACTIONS(3320),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_constexpr] = ACTIONS(3320),
    [anon_sym_volatile] = ACTIONS(3320),
    [anon_sym_restrict] = ACTIONS(3320),
    [anon_sym___restrict__] = ACTIONS(3320),
    [anon_sym__Atomic] = ACTIONS(3320),
    [anon_sym__Noreturn] = ACTIONS(3320),
    [anon_sym_noreturn] = ACTIONS(3320),
    [anon_sym_mutable] = ACTIONS(3320),
    [anon_sym_constinit] = ACTIONS(3320),
    [anon_sym_consteval] = ACTIONS(3320),
    [anon_sym_PROGMEM] = ACTIONS(3320),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3320),
    [anon_sym_class] = ACTIONS(3320),
    [anon_sym_struct] = ACTIONS(3320),
    [anon_sym_union] = ACTIONS(3320),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3320),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_virtual] = ACTIONS(3320),
    [anon_sym_alignas] = ACTIONS(3320),
    [anon_sym_typename] = ACTIONS(3320),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [401] = {
    [sym_identifier] = ACTIONS(3324),
    [aux_sym_preproc_include_token1] = ACTIONS(3324),
    [aux_sym_preproc_def_token1] = ACTIONS(3324),
    [aux_sym_preproc_if_token1] = ACTIONS(3324),
    [aux_sym_preproc_if_token2] = ACTIONS(3324),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3324),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3324),
    [aux_sym_preproc_else_token1] = ACTIONS(3324),
    [aux_sym_preproc_elif_token1] = ACTIONS(3324),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3324),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3324),
    [sym_preproc_directive] = ACTIONS(3324),
    [anon_sym_LPAREN2] = ACTIONS(3326),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_DASH] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3326),
    [anon_sym_AMP_AMP] = ACTIONS(3326),
    [anon_sym_AMP] = ACTIONS(3324),
    [anon_sym_SEMI] = ACTIONS(3326),
    [anon_sym___extension__] = ACTIONS(3324),
    [anon_sym_typedef] = ACTIONS(3324),
    [anon_sym_extern] = ACTIONS(3324),
    [anon_sym___attribute__] = ACTIONS(3324),
    [anon_sym_COLON_COLON] = ACTIONS(3326),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3326),
    [anon_sym___declspec] = ACTIONS(3324),
    [anon_sym___based] = ACTIONS(3324),
    [anon_sym___cdecl] = ACTIONS(3324),
    [anon_sym___clrcall] = ACTIONS(3324),
    [anon_sym___stdcall] = ACTIONS(3324),
    [anon_sym___fastcall] = ACTIONS(3324),
    [anon_sym___thiscall] = ACTIONS(3324),
    [anon_sym___vectorcall] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3326),
    [anon_sym_signed] = ACTIONS(3324),
    [anon_sym_unsigned] = ACTIONS(3324),
    [anon_sym_long] = ACTIONS(3324),
    [anon_sym_short] = ACTIONS(3324),
    [anon_sym_LBRACK] = ACTIONS(3324),
    [anon_sym_static] = ACTIONS(3324),
    [anon_sym_register] = ACTIONS(3324),
    [anon_sym_inline] = ACTIONS(3324),
    [anon_sym___inline] = ACTIONS(3324),
    [anon_sym___inline__] = ACTIONS(3324),
    [anon_sym___forceinline] = ACTIONS(3324),
    [anon_sym_thread_local] = ACTIONS(3324),
    [anon_sym___thread] = ACTIONS(3324),
    [anon_sym_const] = ACTIONS(3324),
    [anon_sym_constexpr] = ACTIONS(3324),
    [anon_sym_volatile] = ACTIONS(3324),
    [anon_sym_restrict] = ACTIONS(3324),
    [anon_sym___restrict__] = ACTIONS(3324),
    [anon_sym__Atomic] = ACTIONS(3324),
    [anon_sym__Noreturn] = ACTIONS(3324),
    [anon_sym_noreturn] = ACTIONS(3324),
    [anon_sym_mutable] = ACTIONS(3324),
    [anon_sym_constinit] = ACTIONS(3324),
    [anon_sym_consteval] = ACTIONS(3324),
    [anon_sym_PROGMEM] = ACTIONS(3324),
    [aux_sym_primitive_type_token1] = ACTIONS(3324),
    [anon_sym_byte] = ACTIONS(3324),
    [anon_sym_word] = ACTIONS(3324),
    [anon_sym_enum] = ACTIONS(3324),
    [anon_sym_class] = ACTIONS(3324),
    [anon_sym_struct] = ACTIONS(3324),
    [anon_sym_union] = ACTIONS(3324),
    [anon_sym_if] = ACTIONS(3324),
    [anon_sym_switch] = ACTIONS(3324),
    [anon_sym_case] = ACTIONS(3324),
    [anon_sym_default] = ACTIONS(3324),
    [anon_sym_while] = ACTIONS(3324),
    [anon_sym_do] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3324),
    [anon_sym_return] = ACTIONS(3324),
    [anon_sym_break] = ACTIONS(3324),
    [anon_sym_continue] = ACTIONS(3324),
    [anon_sym_goto] = ACTIONS(3324),
    [anon_sym___try] = ACTIONS(3324),
    [anon_sym___leave] = ACTIONS(3324),
    [anon_sym_not] = ACTIONS(3324),
    [anon_sym_compl] = ACTIONS(3324),
    [anon_sym_DASH_DASH] = ACTIONS(3326),
    [anon_sym_PLUS_PLUS] = ACTIONS(3326),
    [anon_sym_sizeof] = ACTIONS(3324),
    [anon_sym___alignof__] = ACTIONS(3324),
    [anon_sym___alignof] = ACTIONS(3324),
    [anon_sym__alignof] = ACTIONS(3324),
    [anon_sym_alignof] = ACTIONS(3324),
    [anon_sym__Alignof] = ACTIONS(3324),
    [anon_sym_offsetof] = ACTIONS(3324),
    [anon_sym__Generic] = ACTIONS(3324),
    [anon_sym_asm] = ACTIONS(3324),
    [anon_sym___asm__] = ACTIONS(3324),
    [aux_sym_number_literal_token1] = ACTIONS(3326),
    [aux_sym_number_literal_token2] = ACTIONS(3324),
    [anon_sym_L_SQUOTE] = ACTIONS(3326),
    [anon_sym_u_SQUOTE] = ACTIONS(3326),
    [anon_sym_U_SQUOTE] = ACTIONS(3326),
    [anon_sym_u8_SQUOTE] = ACTIONS(3326),
    [anon_sym_SQUOTE] = ACTIONS(3326),
    [anon_sym_L_DQUOTE] = ACTIONS(3326),
    [anon_sym_u_DQUOTE] = ACTIONS(3326),
    [anon_sym_U_DQUOTE] = ACTIONS(3326),
    [anon_sym_u8_DQUOTE] = ACTIONS(3326),
    [anon_sym_DQUOTE] = ACTIONS(3326),
    [sym_true] = ACTIONS(3324),
    [sym_false] = ACTIONS(3324),
    [anon_sym_NULL] = ACTIONS(3324),
    [anon_sym_nullptr] = ACTIONS(3324),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3324),
    [anon_sym_decltype] = ACTIONS(3324),
    [anon_sym_virtual] = ACTIONS(3324),
    [anon_sym_alignas] = ACTIONS(3324),
    [anon_sym_explicit] = ACTIONS(3324),
    [anon_sym_typename] = ACTIONS(3324),
    [anon_sym_template] = ACTIONS(3324),
    [anon_sym_operator] = ACTIONS(3324),
    [anon_sym_try] = ACTIONS(3324),
    [anon_sym_delete] = ACTIONS(3324),
    [anon_sym_throw] = ACTIONS(3324),
    [anon_sym_namespace] = ACTIONS(3324),
    [anon_sym_using] = ACTIONS(3324),
    [anon_sym_static_assert] = ACTIONS(3324),
    [anon_sym_concept] = ACTIONS(3324),
    [anon_sym_co_return] = ACTIONS(3324),
    [anon_sym_co_yield] = ACTIONS(3324),
    [anon_sym_R_DQUOTE] = ACTIONS(3326),
    [anon_sym_LR_DQUOTE] = ACTIONS(3326),
    [anon_sym_uR_DQUOTE] = ACTIONS(3326),
    [anon_sym_UR_DQUOTE] = ACTIONS(3326),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3326),
    [anon_sym_co_await] = ACTIONS(3324),
    [anon_sym_new] = ACTIONS(3324),
    [anon_sym_requires] = ACTIONS(3324),
    [sym_this] = ACTIONS(3324),
  },
  [402] = {
    [sym_identifier] = ACTIONS(3328),
    [aux_sym_preproc_include_token1] = ACTIONS(3328),
    [aux_sym_preproc_def_token1] = ACTIONS(3328),
    [aux_sym_preproc_if_token1] = ACTIONS(3328),
    [aux_sym_preproc_if_token2] = ACTIONS(3328),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3328),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3328),
    [aux_sym_preproc_else_token1] = ACTIONS(3328),
    [aux_sym_preproc_elif_token1] = ACTIONS(3328),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3328),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3328),
    [sym_preproc_directive] = ACTIONS(3328),
    [anon_sym_LPAREN2] = ACTIONS(3330),
    [anon_sym_BANG] = ACTIONS(3330),
    [anon_sym_TILDE] = ACTIONS(3330),
    [anon_sym_DASH] = ACTIONS(3328),
    [anon_sym_PLUS] = ACTIONS(3328),
    [anon_sym_STAR] = ACTIONS(3330),
    [anon_sym_AMP_AMP] = ACTIONS(3330),
    [anon_sym_AMP] = ACTIONS(3328),
    [anon_sym_SEMI] = ACTIONS(3330),
    [anon_sym___extension__] = ACTIONS(3328),
    [anon_sym_typedef] = ACTIONS(3328),
    [anon_sym_extern] = ACTIONS(3328),
    [anon_sym___attribute__] = ACTIONS(3328),
    [anon_sym_COLON_COLON] = ACTIONS(3330),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3330),
    [anon_sym___declspec] = ACTIONS(3328),
    [anon_sym___based] = ACTIONS(3328),
    [anon_sym___cdecl] = ACTIONS(3328),
    [anon_sym___clrcall] = ACTIONS(3328),
    [anon_sym___stdcall] = ACTIONS(3328),
    [anon_sym___fastcall] = ACTIONS(3328),
    [anon_sym___thiscall] = ACTIONS(3328),
    [anon_sym___vectorcall] = ACTIONS(3328),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_signed] = ACTIONS(3328),
    [anon_sym_unsigned] = ACTIONS(3328),
    [anon_sym_long] = ACTIONS(3328),
    [anon_sym_short] = ACTIONS(3328),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_static] = ACTIONS(3328),
    [anon_sym_register] = ACTIONS(3328),
    [anon_sym_inline] = ACTIONS(3328),
    [anon_sym___inline] = ACTIONS(3328),
    [anon_sym___inline__] = ACTIONS(3328),
    [anon_sym___forceinline] = ACTIONS(3328),
    [anon_sym_thread_local] = ACTIONS(3328),
    [anon_sym___thread] = ACTIONS(3328),
    [anon_sym_const] = ACTIONS(3328),
    [anon_sym_constexpr] = ACTIONS(3328),
    [anon_sym_volatile] = ACTIONS(3328),
    [anon_sym_restrict] = ACTIONS(3328),
    [anon_sym___restrict__] = ACTIONS(3328),
    [anon_sym__Atomic] = ACTIONS(3328),
    [anon_sym__Noreturn] = ACTIONS(3328),
    [anon_sym_noreturn] = ACTIONS(3328),
    [anon_sym_mutable] = ACTIONS(3328),
    [anon_sym_constinit] = ACTIONS(3328),
    [anon_sym_consteval] = ACTIONS(3328),
    [anon_sym_PROGMEM] = ACTIONS(3328),
    [aux_sym_primitive_type_token1] = ACTIONS(3328),
    [anon_sym_byte] = ACTIONS(3328),
    [anon_sym_word] = ACTIONS(3328),
    [anon_sym_enum] = ACTIONS(3328),
    [anon_sym_class] = ACTIONS(3328),
    [anon_sym_struct] = ACTIONS(3328),
    [anon_sym_union] = ACTIONS(3328),
    [anon_sym_if] = ACTIONS(3328),
    [anon_sym_switch] = ACTIONS(3328),
    [anon_sym_case] = ACTIONS(3328),
    [anon_sym_default] = ACTIONS(3328),
    [anon_sym_while] = ACTIONS(3328),
    [anon_sym_do] = ACTIONS(3328),
    [anon_sym_for] = ACTIONS(3328),
    [anon_sym_return] = ACTIONS(3328),
    [anon_sym_break] = ACTIONS(3328),
    [anon_sym_continue] = ACTIONS(3328),
    [anon_sym_goto] = ACTIONS(3328),
    [anon_sym___try] = ACTIONS(3328),
    [anon_sym___leave] = ACTIONS(3328),
    [anon_sym_not] = ACTIONS(3328),
    [anon_sym_compl] = ACTIONS(3328),
    [anon_sym_DASH_DASH] = ACTIONS(3330),
    [anon_sym_PLUS_PLUS] = ACTIONS(3330),
    [anon_sym_sizeof] = ACTIONS(3328),
    [anon_sym___alignof__] = ACTIONS(3328),
    [anon_sym___alignof] = ACTIONS(3328),
    [anon_sym__alignof] = ACTIONS(3328),
    [anon_sym_alignof] = ACTIONS(3328),
    [anon_sym__Alignof] = ACTIONS(3328),
    [anon_sym_offsetof] = ACTIONS(3328),
    [anon_sym__Generic] = ACTIONS(3328),
    [anon_sym_asm] = ACTIONS(3328),
    [anon_sym___asm__] = ACTIONS(3328),
    [aux_sym_number_literal_token1] = ACTIONS(3330),
    [aux_sym_number_literal_token2] = ACTIONS(3328),
    [anon_sym_L_SQUOTE] = ACTIONS(3330),
    [anon_sym_u_SQUOTE] = ACTIONS(3330),
    [anon_sym_U_SQUOTE] = ACTIONS(3330),
    [anon_sym_u8_SQUOTE] = ACTIONS(3330),
    [anon_sym_SQUOTE] = ACTIONS(3330),
    [anon_sym_L_DQUOTE] = ACTIONS(3330),
    [anon_sym_u_DQUOTE] = ACTIONS(3330),
    [anon_sym_U_DQUOTE] = ACTIONS(3330),
    [anon_sym_u8_DQUOTE] = ACTIONS(3330),
    [anon_sym_DQUOTE] = ACTIONS(3330),
    [sym_true] = ACTIONS(3328),
    [sym_false] = ACTIONS(3328),
    [anon_sym_NULL] = ACTIONS(3328),
    [anon_sym_nullptr] = ACTIONS(3328),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3328),
    [anon_sym_decltype] = ACTIONS(3328),
    [anon_sym_virtual] = ACTIONS(3328),
    [anon_sym_alignas] = ACTIONS(3328),
    [anon_sym_explicit] = ACTIONS(3328),
    [anon_sym_typename] = ACTIONS(3328),
    [anon_sym_template] = ACTIONS(3328),
    [anon_sym_operator] = ACTIONS(3328),
    [anon_sym_try] = ACTIONS(3328),
    [anon_sym_delete] = ACTIONS(3328),
    [anon_sym_throw] = ACTIONS(3328),
    [anon_sym_namespace] = ACTIONS(3328),
    [anon_sym_using] = ACTIONS(3328),
    [anon_sym_static_assert] = ACTIONS(3328),
    [anon_sym_concept] = ACTIONS(3328),
    [anon_sym_co_return] = ACTIONS(3328),
    [anon_sym_co_yield] = ACTIONS(3328),
    [anon_sym_R_DQUOTE] = ACTIONS(3330),
    [anon_sym_LR_DQUOTE] = ACTIONS(3330),
    [anon_sym_uR_DQUOTE] = ACTIONS(3330),
    [anon_sym_UR_DQUOTE] = ACTIONS(3330),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3330),
    [anon_sym_co_await] = ACTIONS(3328),
    [anon_sym_new] = ACTIONS(3328),
    [anon_sym_requires] = ACTIONS(3328),
    [sym_this] = ACTIONS(3328),
  },
  [403] = {
    [sym_identifier] = ACTIONS(3332),
    [aux_sym_preproc_include_token1] = ACTIONS(3332),
    [aux_sym_preproc_def_token1] = ACTIONS(3332),
    [aux_sym_preproc_if_token1] = ACTIONS(3332),
    [aux_sym_preproc_if_token2] = ACTIONS(3332),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3332),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3332),
    [aux_sym_preproc_else_token1] = ACTIONS(3332),
    [aux_sym_preproc_elif_token1] = ACTIONS(3332),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3332),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3332),
    [sym_preproc_directive] = ACTIONS(3332),
    [anon_sym_LPAREN2] = ACTIONS(3334),
    [anon_sym_BANG] = ACTIONS(3334),
    [anon_sym_TILDE] = ACTIONS(3334),
    [anon_sym_DASH] = ACTIONS(3332),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_STAR] = ACTIONS(3334),
    [anon_sym_AMP_AMP] = ACTIONS(3334),
    [anon_sym_AMP] = ACTIONS(3332),
    [anon_sym_SEMI] = ACTIONS(3334),
    [anon_sym___extension__] = ACTIONS(3332),
    [anon_sym_typedef] = ACTIONS(3332),
    [anon_sym_extern] = ACTIONS(3332),
    [anon_sym___attribute__] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(3334),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3334),
    [anon_sym___declspec] = ACTIONS(3332),
    [anon_sym___based] = ACTIONS(3332),
    [anon_sym___cdecl] = ACTIONS(3332),
    [anon_sym___clrcall] = ACTIONS(3332),
    [anon_sym___stdcall] = ACTIONS(3332),
    [anon_sym___fastcall] = ACTIONS(3332),
    [anon_sym___thiscall] = ACTIONS(3332),
    [anon_sym___vectorcall] = ACTIONS(3332),
    [anon_sym_LBRACE] = ACTIONS(3334),
    [anon_sym_signed] = ACTIONS(3332),
    [anon_sym_unsigned] = ACTIONS(3332),
    [anon_sym_long] = ACTIONS(3332),
    [anon_sym_short] = ACTIONS(3332),
    [anon_sym_LBRACK] = ACTIONS(3332),
    [anon_sym_static] = ACTIONS(3332),
    [anon_sym_register] = ACTIONS(3332),
    [anon_sym_inline] = ACTIONS(3332),
    [anon_sym___inline] = ACTIONS(3332),
    [anon_sym___inline__] = ACTIONS(3332),
    [anon_sym___forceinline] = ACTIONS(3332),
    [anon_sym_thread_local] = ACTIONS(3332),
    [anon_sym___thread] = ACTIONS(3332),
    [anon_sym_const] = ACTIONS(3332),
    [anon_sym_constexpr] = ACTIONS(3332),
    [anon_sym_volatile] = ACTIONS(3332),
    [anon_sym_restrict] = ACTIONS(3332),
    [anon_sym___restrict__] = ACTIONS(3332),
    [anon_sym__Atomic] = ACTIONS(3332),
    [anon_sym__Noreturn] = ACTIONS(3332),
    [anon_sym_noreturn] = ACTIONS(3332),
    [anon_sym_mutable] = ACTIONS(3332),
    [anon_sym_constinit] = ACTIONS(3332),
    [anon_sym_consteval] = ACTIONS(3332),
    [anon_sym_PROGMEM] = ACTIONS(3332),
    [aux_sym_primitive_type_token1] = ACTIONS(3332),
    [anon_sym_byte] = ACTIONS(3332),
    [anon_sym_word] = ACTIONS(3332),
    [anon_sym_enum] = ACTIONS(3332),
    [anon_sym_class] = ACTIONS(3332),
    [anon_sym_struct] = ACTIONS(3332),
    [anon_sym_union] = ACTIONS(3332),
    [anon_sym_if] = ACTIONS(3332),
    [anon_sym_switch] = ACTIONS(3332),
    [anon_sym_case] = ACTIONS(3332),
    [anon_sym_default] = ACTIONS(3332),
    [anon_sym_while] = ACTIONS(3332),
    [anon_sym_do] = ACTIONS(3332),
    [anon_sym_for] = ACTIONS(3332),
    [anon_sym_return] = ACTIONS(3332),
    [anon_sym_break] = ACTIONS(3332),
    [anon_sym_continue] = ACTIONS(3332),
    [anon_sym_goto] = ACTIONS(3332),
    [anon_sym___try] = ACTIONS(3332),
    [anon_sym___leave] = ACTIONS(3332),
    [anon_sym_not] = ACTIONS(3332),
    [anon_sym_compl] = ACTIONS(3332),
    [anon_sym_DASH_DASH] = ACTIONS(3334),
    [anon_sym_PLUS_PLUS] = ACTIONS(3334),
    [anon_sym_sizeof] = ACTIONS(3332),
    [anon_sym___alignof__] = ACTIONS(3332),
    [anon_sym___alignof] = ACTIONS(3332),
    [anon_sym__alignof] = ACTIONS(3332),
    [anon_sym_alignof] = ACTIONS(3332),
    [anon_sym__Alignof] = ACTIONS(3332),
    [anon_sym_offsetof] = ACTIONS(3332),
    [anon_sym__Generic] = ACTIONS(3332),
    [anon_sym_asm] = ACTIONS(3332),
    [anon_sym___asm__] = ACTIONS(3332),
    [aux_sym_number_literal_token1] = ACTIONS(3334),
    [aux_sym_number_literal_token2] = ACTIONS(3332),
    [anon_sym_L_SQUOTE] = ACTIONS(3334),
    [anon_sym_u_SQUOTE] = ACTIONS(3334),
    [anon_sym_U_SQUOTE] = ACTIONS(3334),
    [anon_sym_u8_SQUOTE] = ACTIONS(3334),
    [anon_sym_SQUOTE] = ACTIONS(3334),
    [anon_sym_L_DQUOTE] = ACTIONS(3334),
    [anon_sym_u_DQUOTE] = ACTIONS(3334),
    [anon_sym_U_DQUOTE] = ACTIONS(3334),
    [anon_sym_u8_DQUOTE] = ACTIONS(3334),
    [anon_sym_DQUOTE] = ACTIONS(3334),
    [sym_true] = ACTIONS(3332),
    [sym_false] = ACTIONS(3332),
    [anon_sym_NULL] = ACTIONS(3332),
    [anon_sym_nullptr] = ACTIONS(3332),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3332),
    [anon_sym_decltype] = ACTIONS(3332),
    [anon_sym_virtual] = ACTIONS(3332),
    [anon_sym_alignas] = ACTIONS(3332),
    [anon_sym_explicit] = ACTIONS(3332),
    [anon_sym_typename] = ACTIONS(3332),
    [anon_sym_template] = ACTIONS(3332),
    [anon_sym_operator] = ACTIONS(3332),
    [anon_sym_try] = ACTIONS(3332),
    [anon_sym_delete] = ACTIONS(3332),
    [anon_sym_throw] = ACTIONS(3332),
    [anon_sym_namespace] = ACTIONS(3332),
    [anon_sym_using] = ACTIONS(3332),
    [anon_sym_static_assert] = ACTIONS(3332),
    [anon_sym_concept] = ACTIONS(3332),
    [anon_sym_co_return] = ACTIONS(3332),
    [anon_sym_co_yield] = ACTIONS(3332),
    [anon_sym_R_DQUOTE] = ACTIONS(3334),
    [anon_sym_LR_DQUOTE] = ACTIONS(3334),
    [anon_sym_uR_DQUOTE] = ACTIONS(3334),
    [anon_sym_UR_DQUOTE] = ACTIONS(3334),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3334),
    [anon_sym_co_await] = ACTIONS(3332),
    [anon_sym_new] = ACTIONS(3332),
    [anon_sym_requires] = ACTIONS(3332),
    [sym_this] = ACTIONS(3332),
  },
  [404] = {
    [sym_identifier] = ACTIONS(3336),
    [aux_sym_preproc_include_token1] = ACTIONS(3336),
    [aux_sym_preproc_def_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token2] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3336),
    [aux_sym_preproc_else_token1] = ACTIONS(3336),
    [aux_sym_preproc_elif_token1] = ACTIONS(3336),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3336),
    [sym_preproc_directive] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_BANG] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_SEMI] = ACTIONS(3338),
    [anon_sym___extension__] = ACTIONS(3336),
    [anon_sym_typedef] = ACTIONS(3336),
    [anon_sym_extern] = ACTIONS(3336),
    [anon_sym___attribute__] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3338),
    [anon_sym___declspec] = ACTIONS(3336),
    [anon_sym___based] = ACTIONS(3336),
    [anon_sym___cdecl] = ACTIONS(3336),
    [anon_sym___clrcall] = ACTIONS(3336),
    [anon_sym___stdcall] = ACTIONS(3336),
    [anon_sym___fastcall] = ACTIONS(3336),
    [anon_sym___thiscall] = ACTIONS(3336),
    [anon_sym___vectorcall] = ACTIONS(3336),
    [anon_sym_LBRACE] = ACTIONS(3338),
    [anon_sym_signed] = ACTIONS(3336),
    [anon_sym_unsigned] = ACTIONS(3336),
    [anon_sym_long] = ACTIONS(3336),
    [anon_sym_short] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_static] = ACTIONS(3336),
    [anon_sym_register] = ACTIONS(3336),
    [anon_sym_inline] = ACTIONS(3336),
    [anon_sym___inline] = ACTIONS(3336),
    [anon_sym___inline__] = ACTIONS(3336),
    [anon_sym___forceinline] = ACTIONS(3336),
    [anon_sym_thread_local] = ACTIONS(3336),
    [anon_sym___thread] = ACTIONS(3336),
    [anon_sym_const] = ACTIONS(3336),
    [anon_sym_constexpr] = ACTIONS(3336),
    [anon_sym_volatile] = ACTIONS(3336),
    [anon_sym_restrict] = ACTIONS(3336),
    [anon_sym___restrict__] = ACTIONS(3336),
    [anon_sym__Atomic] = ACTIONS(3336),
    [anon_sym__Noreturn] = ACTIONS(3336),
    [anon_sym_noreturn] = ACTIONS(3336),
    [anon_sym_mutable] = ACTIONS(3336),
    [anon_sym_constinit] = ACTIONS(3336),
    [anon_sym_consteval] = ACTIONS(3336),
    [anon_sym_PROGMEM] = ACTIONS(3336),
    [aux_sym_primitive_type_token1] = ACTIONS(3336),
    [anon_sym_byte] = ACTIONS(3336),
    [anon_sym_word] = ACTIONS(3336),
    [anon_sym_enum] = ACTIONS(3336),
    [anon_sym_class] = ACTIONS(3336),
    [anon_sym_struct] = ACTIONS(3336),
    [anon_sym_union] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_switch] = ACTIONS(3336),
    [anon_sym_case] = ACTIONS(3336),
    [anon_sym_default] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_break] = ACTIONS(3336),
    [anon_sym_continue] = ACTIONS(3336),
    [anon_sym_goto] = ACTIONS(3336),
    [anon_sym___try] = ACTIONS(3336),
    [anon_sym___leave] = ACTIONS(3336),
    [anon_sym_not] = ACTIONS(3336),
    [anon_sym_compl] = ACTIONS(3336),
    [anon_sym_DASH_DASH] = ACTIONS(3338),
    [anon_sym_PLUS_PLUS] = ACTIONS(3338),
    [anon_sym_sizeof] = ACTIONS(3336),
    [anon_sym___alignof__] = ACTIONS(3336),
    [anon_sym___alignof] = ACTIONS(3336),
    [anon_sym__alignof] = ACTIONS(3336),
    [anon_sym_alignof] = ACTIONS(3336),
    [anon_sym__Alignof] = ACTIONS(3336),
    [anon_sym_offsetof] = ACTIONS(3336),
    [anon_sym__Generic] = ACTIONS(3336),
    [anon_sym_asm] = ACTIONS(3336),
    [anon_sym___asm__] = ACTIONS(3336),
    [aux_sym_number_literal_token1] = ACTIONS(3338),
    [aux_sym_number_literal_token2] = ACTIONS(3336),
    [anon_sym_L_SQUOTE] = ACTIONS(3338),
    [anon_sym_u_SQUOTE] = ACTIONS(3338),
    [anon_sym_U_SQUOTE] = ACTIONS(3338),
    [anon_sym_u8_SQUOTE] = ACTIONS(3338),
    [anon_sym_SQUOTE] = ACTIONS(3338),
    [anon_sym_L_DQUOTE] = ACTIONS(3338),
    [anon_sym_u_DQUOTE] = ACTIONS(3338),
    [anon_sym_U_DQUOTE] = ACTIONS(3338),
    [anon_sym_u8_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE] = ACTIONS(3338),
    [sym_true] = ACTIONS(3336),
    [sym_false] = ACTIONS(3336),
    [anon_sym_NULL] = ACTIONS(3336),
    [anon_sym_nullptr] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3336),
    [anon_sym_decltype] = ACTIONS(3336),
    [anon_sym_virtual] = ACTIONS(3336),
    [anon_sym_alignas] = ACTIONS(3336),
    [anon_sym_explicit] = ACTIONS(3336),
    [anon_sym_typename] = ACTIONS(3336),
    [anon_sym_template] = ACTIONS(3336),
    [anon_sym_operator] = ACTIONS(3336),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_delete] = ACTIONS(3336),
    [anon_sym_throw] = ACTIONS(3336),
    [anon_sym_namespace] = ACTIONS(3336),
    [anon_sym_using] = ACTIONS(3336),
    [anon_sym_static_assert] = ACTIONS(3336),
    [anon_sym_concept] = ACTIONS(3336),
    [anon_sym_co_return] = ACTIONS(3336),
    [anon_sym_co_yield] = ACTIONS(3336),
    [anon_sym_R_DQUOTE] = ACTIONS(3338),
    [anon_sym_LR_DQUOTE] = ACTIONS(3338),
    [anon_sym_uR_DQUOTE] = ACTIONS(3338),
    [anon_sym_UR_DQUOTE] = ACTIONS(3338),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3338),
    [anon_sym_co_await] = ACTIONS(3336),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_requires] = ACTIONS(3336),
    [sym_this] = ACTIONS(3336),
  },
  [405] = {
    [sym_preproc_def] = STATE(848),
    [sym_preproc_function_def] = STATE(848),
    [sym_preproc_call] = STATE(848),
    [sym_preproc_if_in_field_declaration_list] = STATE(848),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(848),
    [sym_preproc_else_in_field_declaration_list] = STATE(8827),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8827),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8827),
    [sym_type_definition] = STATE(848),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6442),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7117),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(848),
    [sym_field_declaration] = STATE(848),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2239),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(848),
    [sym_operator_cast] = STATE(7514),
    [sym_inline_method_definition] = STATE(848),
    [sym__constructor_specifiers] = STATE(2239),
    [sym_operator_cast_definition] = STATE(848),
    [sym_operator_cast_declaration] = STATE(848),
    [sym_constructor_or_destructor_definition] = STATE(848),
    [sym_constructor_or_destructor_declaration] = STATE(848),
    [sym_friend_declaration] = STATE(848),
    [sym_access_specifier] = STATE(9047),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(848),
    [sym_alias_declaration] = STATE(848),
    [sym_static_assert_declaration] = STATE(848),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7514),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(848),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2239),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3198),
    [aux_sym_preproc_if_token1] = ACTIONS(3200),
    [aux_sym_preproc_if_token2] = ACTIONS(3340),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3204),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3204),
    [aux_sym_preproc_else_token1] = ACTIONS(3206),
    [aux_sym_preproc_elif_token1] = ACTIONS(3208),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3210),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3210),
    [sym_preproc_directive] = ACTIONS(3212),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3222),
    [anon_sym_typedef] = ACTIONS(3224),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3240),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3242),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3246),
    [anon_sym_static_assert] = ACTIONS(3248),
  },
  [406] = {
    [sym_preproc_def] = STATE(405),
    [sym_preproc_function_def] = STATE(405),
    [sym_preproc_call] = STATE(405),
    [sym_preproc_if_in_field_declaration_list] = STATE(405),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(405),
    [sym_preproc_else_in_field_declaration_list] = STATE(8865),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8865),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8865),
    [sym_type_definition] = STATE(405),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6442),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7117),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(405),
    [sym_field_declaration] = STATE(405),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2239),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(405),
    [sym_operator_cast] = STATE(7514),
    [sym_inline_method_definition] = STATE(405),
    [sym__constructor_specifiers] = STATE(2239),
    [sym_operator_cast_definition] = STATE(405),
    [sym_operator_cast_declaration] = STATE(405),
    [sym_constructor_or_destructor_definition] = STATE(405),
    [sym_constructor_or_destructor_declaration] = STATE(405),
    [sym_friend_declaration] = STATE(405),
    [sym_access_specifier] = STATE(9047),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(405),
    [sym_alias_declaration] = STATE(405),
    [sym_static_assert_declaration] = STATE(405),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7514),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(405),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2239),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3198),
    [aux_sym_preproc_if_token1] = ACTIONS(3200),
    [aux_sym_preproc_if_token2] = ACTIONS(3342),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3204),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3204),
    [aux_sym_preproc_else_token1] = ACTIONS(3206),
    [aux_sym_preproc_elif_token1] = ACTIONS(3208),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3210),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3210),
    [sym_preproc_directive] = ACTIONS(3212),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3222),
    [anon_sym_typedef] = ACTIONS(3224),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3240),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3242),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3246),
    [anon_sym_static_assert] = ACTIONS(3248),
  },
  [407] = {
    [sym_catch_clause] = STATE(388),
    [aux_sym_constructor_try_statement_repeat1] = STATE(388),
    [sym_identifier] = ACTIONS(2850),
    [aux_sym_preproc_include_token1] = ACTIONS(2850),
    [aux_sym_preproc_def_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2850),
    [sym_preproc_directive] = ACTIONS(2850),
    [anon_sym_LPAREN2] = ACTIONS(2852),
    [anon_sym_BANG] = ACTIONS(2852),
    [anon_sym_TILDE] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(2850),
    [anon_sym_PLUS] = ACTIONS(2850),
    [anon_sym_STAR] = ACTIONS(2852),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_AMP] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2852),
    [anon_sym___extension__] = ACTIONS(2850),
    [anon_sym_typedef] = ACTIONS(2850),
    [anon_sym_extern] = ACTIONS(2850),
    [anon_sym___attribute__] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2852),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2852),
    [anon_sym___declspec] = ACTIONS(2850),
    [anon_sym___based] = ACTIONS(2850),
    [anon_sym___cdecl] = ACTIONS(2850),
    [anon_sym___clrcall] = ACTIONS(2850),
    [anon_sym___stdcall] = ACTIONS(2850),
    [anon_sym___fastcall] = ACTIONS(2850),
    [anon_sym___thiscall] = ACTIONS(2850),
    [anon_sym___vectorcall] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2852),
    [anon_sym_RBRACE] = ACTIONS(2852),
    [anon_sym_signed] = ACTIONS(2850),
    [anon_sym_unsigned] = ACTIONS(2850),
    [anon_sym_long] = ACTIONS(2850),
    [anon_sym_short] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2850),
    [anon_sym_register] = ACTIONS(2850),
    [anon_sym_inline] = ACTIONS(2850),
    [anon_sym___inline] = ACTIONS(2850),
    [anon_sym___inline__] = ACTIONS(2850),
    [anon_sym___forceinline] = ACTIONS(2850),
    [anon_sym_thread_local] = ACTIONS(2850),
    [anon_sym___thread] = ACTIONS(2850),
    [anon_sym_const] = ACTIONS(2850),
    [anon_sym_constexpr] = ACTIONS(2850),
    [anon_sym_volatile] = ACTIONS(2850),
    [anon_sym_restrict] = ACTIONS(2850),
    [anon_sym___restrict__] = ACTIONS(2850),
    [anon_sym__Atomic] = ACTIONS(2850),
    [anon_sym__Noreturn] = ACTIONS(2850),
    [anon_sym_noreturn] = ACTIONS(2850),
    [anon_sym_mutable] = ACTIONS(2850),
    [anon_sym_constinit] = ACTIONS(2850),
    [anon_sym_consteval] = ACTIONS(2850),
    [anon_sym_PROGMEM] = ACTIONS(2850),
    [aux_sym_primitive_type_token1] = ACTIONS(2850),
    [anon_sym_byte] = ACTIONS(2850),
    [anon_sym_word] = ACTIONS(2850),
    [anon_sym_enum] = ACTIONS(2850),
    [anon_sym_class] = ACTIONS(2850),
    [anon_sym_struct] = ACTIONS(2850),
    [anon_sym_union] = ACTIONS(2850),
    [anon_sym_if] = ACTIONS(2850),
    [anon_sym_else] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2850),
    [anon_sym_case] = ACTIONS(2850),
    [anon_sym_default] = ACTIONS(2850),
    [anon_sym_while] = ACTIONS(2850),
    [anon_sym_do] = ACTIONS(2850),
    [anon_sym_for] = ACTIONS(2850),
    [anon_sym_return] = ACTIONS(2850),
    [anon_sym_break] = ACTIONS(2850),
    [anon_sym_continue] = ACTIONS(2850),
    [anon_sym_goto] = ACTIONS(2850),
    [anon_sym___try] = ACTIONS(2850),
    [anon_sym___leave] = ACTIONS(2850),
    [anon_sym_not] = ACTIONS(2850),
    [anon_sym_compl] = ACTIONS(2850),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_sizeof] = ACTIONS(2850),
    [anon_sym___alignof__] = ACTIONS(2850),
    [anon_sym___alignof] = ACTIONS(2850),
    [anon_sym__alignof] = ACTIONS(2850),
    [anon_sym_alignof] = ACTIONS(2850),
    [anon_sym__Alignof] = ACTIONS(2850),
    [anon_sym_offsetof] = ACTIONS(2850),
    [anon_sym__Generic] = ACTIONS(2850),
    [anon_sym_asm] = ACTIONS(2850),
    [anon_sym___asm__] = ACTIONS(2850),
    [aux_sym_number_literal_token1] = ACTIONS(2852),
    [aux_sym_number_literal_token2] = ACTIONS(2850),
    [anon_sym_L_SQUOTE] = ACTIONS(2852),
    [anon_sym_u_SQUOTE] = ACTIONS(2852),
    [anon_sym_U_SQUOTE] = ACTIONS(2852),
    [anon_sym_u8_SQUOTE] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2852),
    [anon_sym_L_DQUOTE] = ACTIONS(2852),
    [anon_sym_u_DQUOTE] = ACTIONS(2852),
    [anon_sym_U_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8_DQUOTE] = ACTIONS(2852),
    [anon_sym_DQUOTE] = ACTIONS(2852),
    [sym_true] = ACTIONS(2850),
    [sym_false] = ACTIONS(2850),
    [anon_sym_NULL] = ACTIONS(2850),
    [anon_sym_nullptr] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2850),
    [anon_sym_decltype] = ACTIONS(2850),
    [anon_sym_virtual] = ACTIONS(2850),
    [anon_sym_alignas] = ACTIONS(2850),
    [anon_sym_explicit] = ACTIONS(2850),
    [anon_sym_typename] = ACTIONS(2850),
    [anon_sym_template] = ACTIONS(2850),
    [anon_sym_operator] = ACTIONS(2850),
    [anon_sym_try] = ACTIONS(2850),
    [anon_sym_delete] = ACTIONS(2850),
    [anon_sym_throw] = ACTIONS(2850),
    [anon_sym_namespace] = ACTIONS(2850),
    [anon_sym_using] = ACTIONS(2850),
    [anon_sym_static_assert] = ACTIONS(2850),
    [anon_sym_concept] = ACTIONS(2850),
    [anon_sym_co_return] = ACTIONS(2850),
    [anon_sym_co_yield] = ACTIONS(2850),
    [anon_sym_catch] = ACTIONS(3344),
    [anon_sym_R_DQUOTE] = ACTIONS(2852),
    [anon_sym_LR_DQUOTE] = ACTIONS(2852),
    [anon_sym_uR_DQUOTE] = ACTIONS(2852),
    [anon_sym_UR_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2852),
    [anon_sym_co_await] = ACTIONS(2850),
    [anon_sym_new] = ACTIONS(2850),
    [anon_sym_requires] = ACTIONS(2850),
    [sym_this] = ACTIONS(2850),
  },
  [408] = {
    [sym_identifier] = ACTIONS(3336),
    [aux_sym_preproc_include_token1] = ACTIONS(3336),
    [aux_sym_preproc_def_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token2] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3336),
    [aux_sym_preproc_else_token1] = ACTIONS(3336),
    [aux_sym_preproc_elif_token1] = ACTIONS(3336),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3336),
    [sym_preproc_directive] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_BANG] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_SEMI] = ACTIONS(3338),
    [anon_sym___extension__] = ACTIONS(3336),
    [anon_sym_typedef] = ACTIONS(3336),
    [anon_sym_extern] = ACTIONS(3336),
    [anon_sym___attribute__] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3338),
    [anon_sym___declspec] = ACTIONS(3336),
    [anon_sym___based] = ACTIONS(3336),
    [anon_sym___cdecl] = ACTIONS(3336),
    [anon_sym___clrcall] = ACTIONS(3336),
    [anon_sym___stdcall] = ACTIONS(3336),
    [anon_sym___fastcall] = ACTIONS(3336),
    [anon_sym___thiscall] = ACTIONS(3336),
    [anon_sym___vectorcall] = ACTIONS(3336),
    [anon_sym_LBRACE] = ACTIONS(3338),
    [anon_sym_signed] = ACTIONS(3336),
    [anon_sym_unsigned] = ACTIONS(3336),
    [anon_sym_long] = ACTIONS(3336),
    [anon_sym_short] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_static] = ACTIONS(3336),
    [anon_sym_register] = ACTIONS(3336),
    [anon_sym_inline] = ACTIONS(3336),
    [anon_sym___inline] = ACTIONS(3336),
    [anon_sym___inline__] = ACTIONS(3336),
    [anon_sym___forceinline] = ACTIONS(3336),
    [anon_sym_thread_local] = ACTIONS(3336),
    [anon_sym___thread] = ACTIONS(3336),
    [anon_sym_const] = ACTIONS(3336),
    [anon_sym_constexpr] = ACTIONS(3336),
    [anon_sym_volatile] = ACTIONS(3336),
    [anon_sym_restrict] = ACTIONS(3336),
    [anon_sym___restrict__] = ACTIONS(3336),
    [anon_sym__Atomic] = ACTIONS(3336),
    [anon_sym__Noreturn] = ACTIONS(3336),
    [anon_sym_noreturn] = ACTIONS(3336),
    [anon_sym_mutable] = ACTIONS(3336),
    [anon_sym_constinit] = ACTIONS(3336),
    [anon_sym_consteval] = ACTIONS(3336),
    [anon_sym_PROGMEM] = ACTIONS(3336),
    [aux_sym_primitive_type_token1] = ACTIONS(3336),
    [anon_sym_byte] = ACTIONS(3336),
    [anon_sym_word] = ACTIONS(3336),
    [anon_sym_enum] = ACTIONS(3336),
    [anon_sym_class] = ACTIONS(3336),
    [anon_sym_struct] = ACTIONS(3336),
    [anon_sym_union] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_switch] = ACTIONS(3336),
    [anon_sym_case] = ACTIONS(3336),
    [anon_sym_default] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_break] = ACTIONS(3336),
    [anon_sym_continue] = ACTIONS(3336),
    [anon_sym_goto] = ACTIONS(3336),
    [anon_sym___try] = ACTIONS(3336),
    [anon_sym___leave] = ACTIONS(3336),
    [anon_sym_not] = ACTIONS(3336),
    [anon_sym_compl] = ACTIONS(3336),
    [anon_sym_DASH_DASH] = ACTIONS(3338),
    [anon_sym_PLUS_PLUS] = ACTIONS(3338),
    [anon_sym_sizeof] = ACTIONS(3336),
    [anon_sym___alignof__] = ACTIONS(3336),
    [anon_sym___alignof] = ACTIONS(3336),
    [anon_sym__alignof] = ACTIONS(3336),
    [anon_sym_alignof] = ACTIONS(3336),
    [anon_sym__Alignof] = ACTIONS(3336),
    [anon_sym_offsetof] = ACTIONS(3336),
    [anon_sym__Generic] = ACTIONS(3336),
    [anon_sym_asm] = ACTIONS(3336),
    [anon_sym___asm__] = ACTIONS(3336),
    [aux_sym_number_literal_token1] = ACTIONS(3338),
    [aux_sym_number_literal_token2] = ACTIONS(3336),
    [anon_sym_L_SQUOTE] = ACTIONS(3338),
    [anon_sym_u_SQUOTE] = ACTIONS(3338),
    [anon_sym_U_SQUOTE] = ACTIONS(3338),
    [anon_sym_u8_SQUOTE] = ACTIONS(3338),
    [anon_sym_SQUOTE] = ACTIONS(3338),
    [anon_sym_L_DQUOTE] = ACTIONS(3338),
    [anon_sym_u_DQUOTE] = ACTIONS(3338),
    [anon_sym_U_DQUOTE] = ACTIONS(3338),
    [anon_sym_u8_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE] = ACTIONS(3338),
    [sym_true] = ACTIONS(3336),
    [sym_false] = ACTIONS(3336),
    [anon_sym_NULL] = ACTIONS(3336),
    [anon_sym_nullptr] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3336),
    [anon_sym_decltype] = ACTIONS(3336),
    [anon_sym_virtual] = ACTIONS(3336),
    [anon_sym_alignas] = ACTIONS(3336),
    [anon_sym_explicit] = ACTIONS(3336),
    [anon_sym_typename] = ACTIONS(3336),
    [anon_sym_template] = ACTIONS(3336),
    [anon_sym_operator] = ACTIONS(3336),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_delete] = ACTIONS(3336),
    [anon_sym_throw] = ACTIONS(3336),
    [anon_sym_namespace] = ACTIONS(3336),
    [anon_sym_using] = ACTIONS(3336),
    [anon_sym_static_assert] = ACTIONS(3336),
    [anon_sym_concept] = ACTIONS(3336),
    [anon_sym_co_return] = ACTIONS(3336),
    [anon_sym_co_yield] = ACTIONS(3336),
    [anon_sym_R_DQUOTE] = ACTIONS(3338),
    [anon_sym_LR_DQUOTE] = ACTIONS(3338),
    [anon_sym_uR_DQUOTE] = ACTIONS(3338),
    [anon_sym_UR_DQUOTE] = ACTIONS(3338),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3338),
    [anon_sym_co_await] = ACTIONS(3336),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_requires] = ACTIONS(3336),
    [sym_this] = ACTIONS(3336),
  },
  [409] = {
    [sym_identifier] = ACTIONS(3346),
    [aux_sym_preproc_include_token1] = ACTIONS(3346),
    [aux_sym_preproc_def_token1] = ACTIONS(3346),
    [aux_sym_preproc_if_token1] = ACTIONS(3346),
    [aux_sym_preproc_if_token2] = ACTIONS(3346),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3346),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3346),
    [aux_sym_preproc_else_token1] = ACTIONS(3346),
    [aux_sym_preproc_elif_token1] = ACTIONS(3346),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3346),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3346),
    [sym_preproc_directive] = ACTIONS(3346),
    [anon_sym_LPAREN2] = ACTIONS(3348),
    [anon_sym_BANG] = ACTIONS(3348),
    [anon_sym_TILDE] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3348),
    [anon_sym_AMP_AMP] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym_SEMI] = ACTIONS(3348),
    [anon_sym___extension__] = ACTIONS(3346),
    [anon_sym_typedef] = ACTIONS(3346),
    [anon_sym_extern] = ACTIONS(3346),
    [anon_sym___attribute__] = ACTIONS(3346),
    [anon_sym_COLON_COLON] = ACTIONS(3348),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3348),
    [anon_sym___declspec] = ACTIONS(3346),
    [anon_sym___based] = ACTIONS(3346),
    [anon_sym___cdecl] = ACTIONS(3346),
    [anon_sym___clrcall] = ACTIONS(3346),
    [anon_sym___stdcall] = ACTIONS(3346),
    [anon_sym___fastcall] = ACTIONS(3346),
    [anon_sym___thiscall] = ACTIONS(3346),
    [anon_sym___vectorcall] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3348),
    [anon_sym_signed] = ACTIONS(3346),
    [anon_sym_unsigned] = ACTIONS(3346),
    [anon_sym_long] = ACTIONS(3346),
    [anon_sym_short] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3346),
    [anon_sym_register] = ACTIONS(3346),
    [anon_sym_inline] = ACTIONS(3346),
    [anon_sym___inline] = ACTIONS(3346),
    [anon_sym___inline__] = ACTIONS(3346),
    [anon_sym___forceinline] = ACTIONS(3346),
    [anon_sym_thread_local] = ACTIONS(3346),
    [anon_sym___thread] = ACTIONS(3346),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_constexpr] = ACTIONS(3346),
    [anon_sym_volatile] = ACTIONS(3346),
    [anon_sym_restrict] = ACTIONS(3346),
    [anon_sym___restrict__] = ACTIONS(3346),
    [anon_sym__Atomic] = ACTIONS(3346),
    [anon_sym__Noreturn] = ACTIONS(3346),
    [anon_sym_noreturn] = ACTIONS(3346),
    [anon_sym_mutable] = ACTIONS(3346),
    [anon_sym_constinit] = ACTIONS(3346),
    [anon_sym_consteval] = ACTIONS(3346),
    [anon_sym_PROGMEM] = ACTIONS(3346),
    [aux_sym_primitive_type_token1] = ACTIONS(3346),
    [anon_sym_byte] = ACTIONS(3346),
    [anon_sym_word] = ACTIONS(3346),
    [anon_sym_enum] = ACTIONS(3346),
    [anon_sym_class] = ACTIONS(3346),
    [anon_sym_struct] = ACTIONS(3346),
    [anon_sym_union] = ACTIONS(3346),
    [anon_sym_if] = ACTIONS(3346),
    [anon_sym_switch] = ACTIONS(3346),
    [anon_sym_case] = ACTIONS(3346),
    [anon_sym_default] = ACTIONS(3346),
    [anon_sym_while] = ACTIONS(3346),
    [anon_sym_do] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3346),
    [anon_sym_return] = ACTIONS(3346),
    [anon_sym_break] = ACTIONS(3346),
    [anon_sym_continue] = ACTIONS(3346),
    [anon_sym_goto] = ACTIONS(3346),
    [anon_sym___try] = ACTIONS(3346),
    [anon_sym___leave] = ACTIONS(3346),
    [anon_sym_not] = ACTIONS(3346),
    [anon_sym_compl] = ACTIONS(3346),
    [anon_sym_DASH_DASH] = ACTIONS(3348),
    [anon_sym_PLUS_PLUS] = ACTIONS(3348),
    [anon_sym_sizeof] = ACTIONS(3346),
    [anon_sym___alignof__] = ACTIONS(3346),
    [anon_sym___alignof] = ACTIONS(3346),
    [anon_sym__alignof] = ACTIONS(3346),
    [anon_sym_alignof] = ACTIONS(3346),
    [anon_sym__Alignof] = ACTIONS(3346),
    [anon_sym_offsetof] = ACTIONS(3346),
    [anon_sym__Generic] = ACTIONS(3346),
    [anon_sym_asm] = ACTIONS(3346),
    [anon_sym___asm__] = ACTIONS(3346),
    [aux_sym_number_literal_token1] = ACTIONS(3348),
    [aux_sym_number_literal_token2] = ACTIONS(3346),
    [anon_sym_L_SQUOTE] = ACTIONS(3348),
    [anon_sym_u_SQUOTE] = ACTIONS(3348),
    [anon_sym_U_SQUOTE] = ACTIONS(3348),
    [anon_sym_u8_SQUOTE] = ACTIONS(3348),
    [anon_sym_SQUOTE] = ACTIONS(3348),
    [anon_sym_L_DQUOTE] = ACTIONS(3348),
    [anon_sym_u_DQUOTE] = ACTIONS(3348),
    [anon_sym_U_DQUOTE] = ACTIONS(3348),
    [anon_sym_u8_DQUOTE] = ACTIONS(3348),
    [anon_sym_DQUOTE] = ACTIONS(3348),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [anon_sym_NULL] = ACTIONS(3346),
    [anon_sym_nullptr] = ACTIONS(3346),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3346),
    [anon_sym_decltype] = ACTIONS(3346),
    [anon_sym_virtual] = ACTIONS(3346),
    [anon_sym_alignas] = ACTIONS(3346),
    [anon_sym_explicit] = ACTIONS(3346),
    [anon_sym_typename] = ACTIONS(3346),
    [anon_sym_template] = ACTIONS(3346),
    [anon_sym_operator] = ACTIONS(3346),
    [anon_sym_try] = ACTIONS(3346),
    [anon_sym_delete] = ACTIONS(3346),
    [anon_sym_throw] = ACTIONS(3346),
    [anon_sym_namespace] = ACTIONS(3346),
    [anon_sym_using] = ACTIONS(3346),
    [anon_sym_static_assert] = ACTIONS(3346),
    [anon_sym_concept] = ACTIONS(3346),
    [anon_sym_co_return] = ACTIONS(3346),
    [anon_sym_co_yield] = ACTIONS(3346),
    [anon_sym_R_DQUOTE] = ACTIONS(3348),
    [anon_sym_LR_DQUOTE] = ACTIONS(3348),
    [anon_sym_uR_DQUOTE] = ACTIONS(3348),
    [anon_sym_UR_DQUOTE] = ACTIONS(3348),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3348),
    [anon_sym_co_await] = ACTIONS(3346),
    [anon_sym_new] = ACTIONS(3346),
    [anon_sym_requires] = ACTIONS(3346),
    [sym_this] = ACTIONS(3346),
  },
  [410] = {
    [sym_catch_clause] = STATE(410),
    [aux_sym_constructor_try_statement_repeat1] = STATE(410),
    [sym_identifier] = ACTIONS(2843),
    [aux_sym_preproc_include_token1] = ACTIONS(2843),
    [aux_sym_preproc_def_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token2] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2843),
    [sym_preproc_directive] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2845),
    [anon_sym_BANG] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym___extension__] = ACTIONS(2843),
    [anon_sym_typedef] = ACTIONS(2843),
    [anon_sym_extern] = ACTIONS(2843),
    [anon_sym___attribute__] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2845),
    [anon_sym___declspec] = ACTIONS(2843),
    [anon_sym___based] = ACTIONS(2843),
    [anon_sym___cdecl] = ACTIONS(2843),
    [anon_sym___clrcall] = ACTIONS(2843),
    [anon_sym___stdcall] = ACTIONS(2843),
    [anon_sym___fastcall] = ACTIONS(2843),
    [anon_sym___thiscall] = ACTIONS(2843),
    [anon_sym___vectorcall] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(2845),
    [anon_sym_signed] = ACTIONS(2843),
    [anon_sym_unsigned] = ACTIONS(2843),
    [anon_sym_long] = ACTIONS(2843),
    [anon_sym_short] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_register] = ACTIONS(2843),
    [anon_sym_inline] = ACTIONS(2843),
    [anon_sym___inline] = ACTIONS(2843),
    [anon_sym___inline__] = ACTIONS(2843),
    [anon_sym___forceinline] = ACTIONS(2843),
    [anon_sym_thread_local] = ACTIONS(2843),
    [anon_sym___thread] = ACTIONS(2843),
    [anon_sym_const] = ACTIONS(2843),
    [anon_sym_constexpr] = ACTIONS(2843),
    [anon_sym_volatile] = ACTIONS(2843),
    [anon_sym_restrict] = ACTIONS(2843),
    [anon_sym___restrict__] = ACTIONS(2843),
    [anon_sym__Atomic] = ACTIONS(2843),
    [anon_sym__Noreturn] = ACTIONS(2843),
    [anon_sym_noreturn] = ACTIONS(2843),
    [anon_sym_mutable] = ACTIONS(2843),
    [anon_sym_constinit] = ACTIONS(2843),
    [anon_sym_consteval] = ACTIONS(2843),
    [anon_sym_PROGMEM] = ACTIONS(2843),
    [aux_sym_primitive_type_token1] = ACTIONS(2843),
    [anon_sym_byte] = ACTIONS(2843),
    [anon_sym_word] = ACTIONS(2843),
    [anon_sym_enum] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2843),
    [anon_sym_union] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_else] = ACTIONS(2843),
    [anon_sym_switch] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2843),
    [anon_sym_default] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_break] = ACTIONS(2843),
    [anon_sym_continue] = ACTIONS(2843),
    [anon_sym_goto] = ACTIONS(2843),
    [anon_sym___try] = ACTIONS(2843),
    [anon_sym___leave] = ACTIONS(2843),
    [anon_sym_not] = ACTIONS(2843),
    [anon_sym_compl] = ACTIONS(2843),
    [anon_sym_DASH_DASH] = ACTIONS(2845),
    [anon_sym_PLUS_PLUS] = ACTIONS(2845),
    [anon_sym_sizeof] = ACTIONS(2843),
    [anon_sym___alignof__] = ACTIONS(2843),
    [anon_sym___alignof] = ACTIONS(2843),
    [anon_sym__alignof] = ACTIONS(2843),
    [anon_sym_alignof] = ACTIONS(2843),
    [anon_sym__Alignof] = ACTIONS(2843),
    [anon_sym_offsetof] = ACTIONS(2843),
    [anon_sym__Generic] = ACTIONS(2843),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [aux_sym_number_literal_token1] = ACTIONS(2845),
    [aux_sym_number_literal_token2] = ACTIONS(2843),
    [anon_sym_L_SQUOTE] = ACTIONS(2845),
    [anon_sym_u_SQUOTE] = ACTIONS(2845),
    [anon_sym_U_SQUOTE] = ACTIONS(2845),
    [anon_sym_u8_SQUOTE] = ACTIONS(2845),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_L_DQUOTE] = ACTIONS(2845),
    [anon_sym_u_DQUOTE] = ACTIONS(2845),
    [anon_sym_U_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(2845),
    [sym_true] = ACTIONS(2843),
    [sym_false] = ACTIONS(2843),
    [anon_sym_NULL] = ACTIONS(2843),
    [anon_sym_nullptr] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2843),
    [anon_sym_decltype] = ACTIONS(2843),
    [anon_sym_virtual] = ACTIONS(2843),
    [anon_sym_alignas] = ACTIONS(2843),
    [anon_sym_explicit] = ACTIONS(2843),
    [anon_sym_typename] = ACTIONS(2843),
    [anon_sym_template] = ACTIONS(2843),
    [anon_sym_operator] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_delete] = ACTIONS(2843),
    [anon_sym_throw] = ACTIONS(2843),
    [anon_sym_namespace] = ACTIONS(2843),
    [anon_sym_using] = ACTIONS(2843),
    [anon_sym_static_assert] = ACTIONS(2843),
    [anon_sym_concept] = ACTIONS(2843),
    [anon_sym_co_return] = ACTIONS(2843),
    [anon_sym_co_yield] = ACTIONS(2843),
    [anon_sym_catch] = ACTIONS(3350),
    [anon_sym_R_DQUOTE] = ACTIONS(2845),
    [anon_sym_LR_DQUOTE] = ACTIONS(2845),
    [anon_sym_uR_DQUOTE] = ACTIONS(2845),
    [anon_sym_UR_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2845),
    [anon_sym_co_await] = ACTIONS(2843),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_requires] = ACTIONS(2843),
    [sym_this] = ACTIONS(2843),
  },
  [411] = {
    [sym_identifier] = ACTIONS(3353),
    [aux_sym_preproc_include_token1] = ACTIONS(3353),
    [aux_sym_preproc_def_token1] = ACTIONS(3353),
    [aux_sym_preproc_if_token1] = ACTIONS(3353),
    [aux_sym_preproc_if_token2] = ACTIONS(3353),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3353),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3353),
    [aux_sym_preproc_else_token1] = ACTIONS(3353),
    [aux_sym_preproc_elif_token1] = ACTIONS(3353),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3353),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3353),
    [sym_preproc_directive] = ACTIONS(3353),
    [anon_sym_LPAREN2] = ACTIONS(3355),
    [anon_sym_BANG] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_AMP_AMP] = ACTIONS(3355),
    [anon_sym_AMP] = ACTIONS(3353),
    [anon_sym_SEMI] = ACTIONS(3355),
    [anon_sym___extension__] = ACTIONS(3353),
    [anon_sym_typedef] = ACTIONS(3353),
    [anon_sym_extern] = ACTIONS(3353),
    [anon_sym___attribute__] = ACTIONS(3353),
    [anon_sym_COLON_COLON] = ACTIONS(3355),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3355),
    [anon_sym___declspec] = ACTIONS(3353),
    [anon_sym___based] = ACTIONS(3353),
    [anon_sym___cdecl] = ACTIONS(3353),
    [anon_sym___clrcall] = ACTIONS(3353),
    [anon_sym___stdcall] = ACTIONS(3353),
    [anon_sym___fastcall] = ACTIONS(3353),
    [anon_sym___thiscall] = ACTIONS(3353),
    [anon_sym___vectorcall] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_signed] = ACTIONS(3353),
    [anon_sym_unsigned] = ACTIONS(3353),
    [anon_sym_long] = ACTIONS(3353),
    [anon_sym_short] = ACTIONS(3353),
    [anon_sym_LBRACK] = ACTIONS(3353),
    [anon_sym_static] = ACTIONS(3353),
    [anon_sym_register] = ACTIONS(3353),
    [anon_sym_inline] = ACTIONS(3353),
    [anon_sym___inline] = ACTIONS(3353),
    [anon_sym___inline__] = ACTIONS(3353),
    [anon_sym___forceinline] = ACTIONS(3353),
    [anon_sym_thread_local] = ACTIONS(3353),
    [anon_sym___thread] = ACTIONS(3353),
    [anon_sym_const] = ACTIONS(3353),
    [anon_sym_constexpr] = ACTIONS(3353),
    [anon_sym_volatile] = ACTIONS(3353),
    [anon_sym_restrict] = ACTIONS(3353),
    [anon_sym___restrict__] = ACTIONS(3353),
    [anon_sym__Atomic] = ACTIONS(3353),
    [anon_sym__Noreturn] = ACTIONS(3353),
    [anon_sym_noreturn] = ACTIONS(3353),
    [anon_sym_mutable] = ACTIONS(3353),
    [anon_sym_constinit] = ACTIONS(3353),
    [anon_sym_consteval] = ACTIONS(3353),
    [anon_sym_PROGMEM] = ACTIONS(3353),
    [aux_sym_primitive_type_token1] = ACTIONS(3353),
    [anon_sym_byte] = ACTIONS(3353),
    [anon_sym_word] = ACTIONS(3353),
    [anon_sym_enum] = ACTIONS(3353),
    [anon_sym_class] = ACTIONS(3353),
    [anon_sym_struct] = ACTIONS(3353),
    [anon_sym_union] = ACTIONS(3353),
    [anon_sym_if] = ACTIONS(3353),
    [anon_sym_switch] = ACTIONS(3353),
    [anon_sym_case] = ACTIONS(3353),
    [anon_sym_default] = ACTIONS(3353),
    [anon_sym_while] = ACTIONS(3353),
    [anon_sym_do] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3353),
    [anon_sym_return] = ACTIONS(3353),
    [anon_sym_break] = ACTIONS(3353),
    [anon_sym_continue] = ACTIONS(3353),
    [anon_sym_goto] = ACTIONS(3353),
    [anon_sym___try] = ACTIONS(3353),
    [anon_sym___leave] = ACTIONS(3353),
    [anon_sym_not] = ACTIONS(3353),
    [anon_sym_compl] = ACTIONS(3353),
    [anon_sym_DASH_DASH] = ACTIONS(3355),
    [anon_sym_PLUS_PLUS] = ACTIONS(3355),
    [anon_sym_sizeof] = ACTIONS(3353),
    [anon_sym___alignof__] = ACTIONS(3353),
    [anon_sym___alignof] = ACTIONS(3353),
    [anon_sym__alignof] = ACTIONS(3353),
    [anon_sym_alignof] = ACTIONS(3353),
    [anon_sym__Alignof] = ACTIONS(3353),
    [anon_sym_offsetof] = ACTIONS(3353),
    [anon_sym__Generic] = ACTIONS(3353),
    [anon_sym_asm] = ACTIONS(3353),
    [anon_sym___asm__] = ACTIONS(3353),
    [aux_sym_number_literal_token1] = ACTIONS(3355),
    [aux_sym_number_literal_token2] = ACTIONS(3353),
    [anon_sym_L_SQUOTE] = ACTIONS(3355),
    [anon_sym_u_SQUOTE] = ACTIONS(3355),
    [anon_sym_U_SQUOTE] = ACTIONS(3355),
    [anon_sym_u8_SQUOTE] = ACTIONS(3355),
    [anon_sym_SQUOTE] = ACTIONS(3355),
    [anon_sym_L_DQUOTE] = ACTIONS(3355),
    [anon_sym_u_DQUOTE] = ACTIONS(3355),
    [anon_sym_U_DQUOTE] = ACTIONS(3355),
    [anon_sym_u8_DQUOTE] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [sym_true] = ACTIONS(3353),
    [sym_false] = ACTIONS(3353),
    [anon_sym_NULL] = ACTIONS(3353),
    [anon_sym_nullptr] = ACTIONS(3353),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3353),
    [anon_sym_decltype] = ACTIONS(3353),
    [anon_sym_virtual] = ACTIONS(3353),
    [anon_sym_alignas] = ACTIONS(3353),
    [anon_sym_explicit] = ACTIONS(3353),
    [anon_sym_typename] = ACTIONS(3353),
    [anon_sym_template] = ACTIONS(3353),
    [anon_sym_operator] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3353),
    [anon_sym_delete] = ACTIONS(3353),
    [anon_sym_throw] = ACTIONS(3353),
    [anon_sym_namespace] = ACTIONS(3353),
    [anon_sym_using] = ACTIONS(3353),
    [anon_sym_static_assert] = ACTIONS(3353),
    [anon_sym_concept] = ACTIONS(3353),
    [anon_sym_co_return] = ACTIONS(3353),
    [anon_sym_co_yield] = ACTIONS(3353),
    [anon_sym_R_DQUOTE] = ACTIONS(3355),
    [anon_sym_LR_DQUOTE] = ACTIONS(3355),
    [anon_sym_uR_DQUOTE] = ACTIONS(3355),
    [anon_sym_UR_DQUOTE] = ACTIONS(3355),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3355),
    [anon_sym_co_await] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3353),
    [anon_sym_requires] = ACTIONS(3353),
    [sym_this] = ACTIONS(3353),
  },
  [412] = {
    [sym_identifier] = ACTIONS(3357),
    [aux_sym_preproc_include_token1] = ACTIONS(3357),
    [aux_sym_preproc_def_token1] = ACTIONS(3357),
    [aux_sym_preproc_if_token1] = ACTIONS(3357),
    [aux_sym_preproc_if_token2] = ACTIONS(3357),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3357),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3357),
    [aux_sym_preproc_else_token1] = ACTIONS(3357),
    [aux_sym_preproc_elif_token1] = ACTIONS(3357),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3357),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3357),
    [sym_preproc_directive] = ACTIONS(3357),
    [anon_sym_LPAREN2] = ACTIONS(3359),
    [anon_sym_BANG] = ACTIONS(3359),
    [anon_sym_TILDE] = ACTIONS(3359),
    [anon_sym_DASH] = ACTIONS(3357),
    [anon_sym_PLUS] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(3359),
    [anon_sym_AMP_AMP] = ACTIONS(3359),
    [anon_sym_AMP] = ACTIONS(3357),
    [anon_sym_SEMI] = ACTIONS(3359),
    [anon_sym___extension__] = ACTIONS(3357),
    [anon_sym_typedef] = ACTIONS(3357),
    [anon_sym_extern] = ACTIONS(3357),
    [anon_sym___attribute__] = ACTIONS(3357),
    [anon_sym_COLON_COLON] = ACTIONS(3359),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3359),
    [anon_sym___declspec] = ACTIONS(3357),
    [anon_sym___based] = ACTIONS(3357),
    [anon_sym___cdecl] = ACTIONS(3357),
    [anon_sym___clrcall] = ACTIONS(3357),
    [anon_sym___stdcall] = ACTIONS(3357),
    [anon_sym___fastcall] = ACTIONS(3357),
    [anon_sym___thiscall] = ACTIONS(3357),
    [anon_sym___vectorcall] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3359),
    [anon_sym_signed] = ACTIONS(3357),
    [anon_sym_unsigned] = ACTIONS(3357),
    [anon_sym_long] = ACTIONS(3357),
    [anon_sym_short] = ACTIONS(3357),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_static] = ACTIONS(3357),
    [anon_sym_register] = ACTIONS(3357),
    [anon_sym_inline] = ACTIONS(3357),
    [anon_sym___inline] = ACTIONS(3357),
    [anon_sym___inline__] = ACTIONS(3357),
    [anon_sym___forceinline] = ACTIONS(3357),
    [anon_sym_thread_local] = ACTIONS(3357),
    [anon_sym___thread] = ACTIONS(3357),
    [anon_sym_const] = ACTIONS(3357),
    [anon_sym_constexpr] = ACTIONS(3357),
    [anon_sym_volatile] = ACTIONS(3357),
    [anon_sym_restrict] = ACTIONS(3357),
    [anon_sym___restrict__] = ACTIONS(3357),
    [anon_sym__Atomic] = ACTIONS(3357),
    [anon_sym__Noreturn] = ACTIONS(3357),
    [anon_sym_noreturn] = ACTIONS(3357),
    [anon_sym_mutable] = ACTIONS(3357),
    [anon_sym_constinit] = ACTIONS(3357),
    [anon_sym_consteval] = ACTIONS(3357),
    [anon_sym_PROGMEM] = ACTIONS(3357),
    [aux_sym_primitive_type_token1] = ACTIONS(3357),
    [anon_sym_byte] = ACTIONS(3357),
    [anon_sym_word] = ACTIONS(3357),
    [anon_sym_enum] = ACTIONS(3357),
    [anon_sym_class] = ACTIONS(3357),
    [anon_sym_struct] = ACTIONS(3357),
    [anon_sym_union] = ACTIONS(3357),
    [anon_sym_if] = ACTIONS(3357),
    [anon_sym_switch] = ACTIONS(3357),
    [anon_sym_case] = ACTIONS(3357),
    [anon_sym_default] = ACTIONS(3357),
    [anon_sym_while] = ACTIONS(3357),
    [anon_sym_do] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3357),
    [anon_sym_return] = ACTIONS(3357),
    [anon_sym_break] = ACTIONS(3357),
    [anon_sym_continue] = ACTIONS(3357),
    [anon_sym_goto] = ACTIONS(3357),
    [anon_sym___try] = ACTIONS(3357),
    [anon_sym___leave] = ACTIONS(3357),
    [anon_sym_not] = ACTIONS(3357),
    [anon_sym_compl] = ACTIONS(3357),
    [anon_sym_DASH_DASH] = ACTIONS(3359),
    [anon_sym_PLUS_PLUS] = ACTIONS(3359),
    [anon_sym_sizeof] = ACTIONS(3357),
    [anon_sym___alignof__] = ACTIONS(3357),
    [anon_sym___alignof] = ACTIONS(3357),
    [anon_sym__alignof] = ACTIONS(3357),
    [anon_sym_alignof] = ACTIONS(3357),
    [anon_sym__Alignof] = ACTIONS(3357),
    [anon_sym_offsetof] = ACTIONS(3357),
    [anon_sym__Generic] = ACTIONS(3357),
    [anon_sym_asm] = ACTIONS(3357),
    [anon_sym___asm__] = ACTIONS(3357),
    [aux_sym_number_literal_token1] = ACTIONS(3359),
    [aux_sym_number_literal_token2] = ACTIONS(3357),
    [anon_sym_L_SQUOTE] = ACTIONS(3359),
    [anon_sym_u_SQUOTE] = ACTIONS(3359),
    [anon_sym_U_SQUOTE] = ACTIONS(3359),
    [anon_sym_u8_SQUOTE] = ACTIONS(3359),
    [anon_sym_SQUOTE] = ACTIONS(3359),
    [anon_sym_L_DQUOTE] = ACTIONS(3359),
    [anon_sym_u_DQUOTE] = ACTIONS(3359),
    [anon_sym_U_DQUOTE] = ACTIONS(3359),
    [anon_sym_u8_DQUOTE] = ACTIONS(3359),
    [anon_sym_DQUOTE] = ACTIONS(3359),
    [sym_true] = ACTIONS(3357),
    [sym_false] = ACTIONS(3357),
    [anon_sym_NULL] = ACTIONS(3357),
    [anon_sym_nullptr] = ACTIONS(3357),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3357),
    [anon_sym_decltype] = ACTIONS(3357),
    [anon_sym_virtual] = ACTIONS(3357),
    [anon_sym_alignas] = ACTIONS(3357),
    [anon_sym_explicit] = ACTIONS(3357),
    [anon_sym_typename] = ACTIONS(3357),
    [anon_sym_template] = ACTIONS(3357),
    [anon_sym_operator] = ACTIONS(3357),
    [anon_sym_try] = ACTIONS(3357),
    [anon_sym_delete] = ACTIONS(3357),
    [anon_sym_throw] = ACTIONS(3357),
    [anon_sym_namespace] = ACTIONS(3357),
    [anon_sym_using] = ACTIONS(3357),
    [anon_sym_static_assert] = ACTIONS(3357),
    [anon_sym_concept] = ACTIONS(3357),
    [anon_sym_co_return] = ACTIONS(3357),
    [anon_sym_co_yield] = ACTIONS(3357),
    [anon_sym_R_DQUOTE] = ACTIONS(3359),
    [anon_sym_LR_DQUOTE] = ACTIONS(3359),
    [anon_sym_uR_DQUOTE] = ACTIONS(3359),
    [anon_sym_UR_DQUOTE] = ACTIONS(3359),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3359),
    [anon_sym_co_await] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3357),
    [anon_sym_requires] = ACTIONS(3357),
    [sym_this] = ACTIONS(3357),
  },
  [413] = {
    [sym_identifier] = ACTIONS(3361),
    [aux_sym_preproc_include_token1] = ACTIONS(3361),
    [aux_sym_preproc_def_token1] = ACTIONS(3361),
    [aux_sym_preproc_if_token1] = ACTIONS(3361),
    [aux_sym_preproc_if_token2] = ACTIONS(3361),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3361),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3361),
    [aux_sym_preproc_else_token1] = ACTIONS(3361),
    [aux_sym_preproc_elif_token1] = ACTIONS(3361),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3361),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3361),
    [sym_preproc_directive] = ACTIONS(3361),
    [anon_sym_LPAREN2] = ACTIONS(3363),
    [anon_sym_BANG] = ACTIONS(3363),
    [anon_sym_TILDE] = ACTIONS(3363),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_STAR] = ACTIONS(3363),
    [anon_sym_AMP_AMP] = ACTIONS(3363),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_SEMI] = ACTIONS(3363),
    [anon_sym___extension__] = ACTIONS(3361),
    [anon_sym_typedef] = ACTIONS(3361),
    [anon_sym_extern] = ACTIONS(3361),
    [anon_sym___attribute__] = ACTIONS(3361),
    [anon_sym_COLON_COLON] = ACTIONS(3363),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3363),
    [anon_sym___declspec] = ACTIONS(3361),
    [anon_sym___based] = ACTIONS(3361),
    [anon_sym___cdecl] = ACTIONS(3361),
    [anon_sym___clrcall] = ACTIONS(3361),
    [anon_sym___stdcall] = ACTIONS(3361),
    [anon_sym___fastcall] = ACTIONS(3361),
    [anon_sym___thiscall] = ACTIONS(3361),
    [anon_sym___vectorcall] = ACTIONS(3361),
    [anon_sym_LBRACE] = ACTIONS(3363),
    [anon_sym_signed] = ACTIONS(3361),
    [anon_sym_unsigned] = ACTIONS(3361),
    [anon_sym_long] = ACTIONS(3361),
    [anon_sym_short] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_static] = ACTIONS(3361),
    [anon_sym_register] = ACTIONS(3361),
    [anon_sym_inline] = ACTIONS(3361),
    [anon_sym___inline] = ACTIONS(3361),
    [anon_sym___inline__] = ACTIONS(3361),
    [anon_sym___forceinline] = ACTIONS(3361),
    [anon_sym_thread_local] = ACTIONS(3361),
    [anon_sym___thread] = ACTIONS(3361),
    [anon_sym_const] = ACTIONS(3361),
    [anon_sym_constexpr] = ACTIONS(3361),
    [anon_sym_volatile] = ACTIONS(3361),
    [anon_sym_restrict] = ACTIONS(3361),
    [anon_sym___restrict__] = ACTIONS(3361),
    [anon_sym__Atomic] = ACTIONS(3361),
    [anon_sym__Noreturn] = ACTIONS(3361),
    [anon_sym_noreturn] = ACTIONS(3361),
    [anon_sym_mutable] = ACTIONS(3361),
    [anon_sym_constinit] = ACTIONS(3361),
    [anon_sym_consteval] = ACTIONS(3361),
    [anon_sym_PROGMEM] = ACTIONS(3361),
    [aux_sym_primitive_type_token1] = ACTIONS(3361),
    [anon_sym_byte] = ACTIONS(3361),
    [anon_sym_word] = ACTIONS(3361),
    [anon_sym_enum] = ACTIONS(3361),
    [anon_sym_class] = ACTIONS(3361),
    [anon_sym_struct] = ACTIONS(3361),
    [anon_sym_union] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_switch] = ACTIONS(3361),
    [anon_sym_case] = ACTIONS(3361),
    [anon_sym_default] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_break] = ACTIONS(3361),
    [anon_sym_continue] = ACTIONS(3361),
    [anon_sym_goto] = ACTIONS(3361),
    [anon_sym___try] = ACTIONS(3361),
    [anon_sym___leave] = ACTIONS(3361),
    [anon_sym_not] = ACTIONS(3361),
    [anon_sym_compl] = ACTIONS(3361),
    [anon_sym_DASH_DASH] = ACTIONS(3363),
    [anon_sym_PLUS_PLUS] = ACTIONS(3363),
    [anon_sym_sizeof] = ACTIONS(3361),
    [anon_sym___alignof__] = ACTIONS(3361),
    [anon_sym___alignof] = ACTIONS(3361),
    [anon_sym__alignof] = ACTIONS(3361),
    [anon_sym_alignof] = ACTIONS(3361),
    [anon_sym__Alignof] = ACTIONS(3361),
    [anon_sym_offsetof] = ACTIONS(3361),
    [anon_sym__Generic] = ACTIONS(3361),
    [anon_sym_asm] = ACTIONS(3361),
    [anon_sym___asm__] = ACTIONS(3361),
    [aux_sym_number_literal_token1] = ACTIONS(3363),
    [aux_sym_number_literal_token2] = ACTIONS(3361),
    [anon_sym_L_SQUOTE] = ACTIONS(3363),
    [anon_sym_u_SQUOTE] = ACTIONS(3363),
    [anon_sym_U_SQUOTE] = ACTIONS(3363),
    [anon_sym_u8_SQUOTE] = ACTIONS(3363),
    [anon_sym_SQUOTE] = ACTIONS(3363),
    [anon_sym_L_DQUOTE] = ACTIONS(3363),
    [anon_sym_u_DQUOTE] = ACTIONS(3363),
    [anon_sym_U_DQUOTE] = ACTIONS(3363),
    [anon_sym_u8_DQUOTE] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3363),
    [sym_true] = ACTIONS(3361),
    [sym_false] = ACTIONS(3361),
    [anon_sym_NULL] = ACTIONS(3361),
    [anon_sym_nullptr] = ACTIONS(3361),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3361),
    [anon_sym_decltype] = ACTIONS(3361),
    [anon_sym_virtual] = ACTIONS(3361),
    [anon_sym_alignas] = ACTIONS(3361),
    [anon_sym_explicit] = ACTIONS(3361),
    [anon_sym_typename] = ACTIONS(3361),
    [anon_sym_template] = ACTIONS(3361),
    [anon_sym_operator] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_delete] = ACTIONS(3361),
    [anon_sym_throw] = ACTIONS(3361),
    [anon_sym_namespace] = ACTIONS(3361),
    [anon_sym_using] = ACTIONS(3361),
    [anon_sym_static_assert] = ACTIONS(3361),
    [anon_sym_concept] = ACTIONS(3361),
    [anon_sym_co_return] = ACTIONS(3361),
    [anon_sym_co_yield] = ACTIONS(3361),
    [anon_sym_R_DQUOTE] = ACTIONS(3363),
    [anon_sym_LR_DQUOTE] = ACTIONS(3363),
    [anon_sym_uR_DQUOTE] = ACTIONS(3363),
    [anon_sym_UR_DQUOTE] = ACTIONS(3363),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3363),
    [anon_sym_co_await] = ACTIONS(3361),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_requires] = ACTIONS(3361),
    [sym_this] = ACTIONS(3361),
  },
  [414] = {
    [sym_preproc_def] = STATE(848),
    [sym_preproc_function_def] = STATE(848),
    [sym_preproc_call] = STATE(848),
    [sym_preproc_if_in_field_declaration_list] = STATE(848),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(848),
    [sym_preproc_else_in_field_declaration_list] = STATE(9371),
    [sym_preproc_elif_in_field_declaration_list] = STATE(9371),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(9371),
    [sym_type_definition] = STATE(848),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6442),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7117),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(848),
    [sym_field_declaration] = STATE(848),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2239),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(848),
    [sym_operator_cast] = STATE(7514),
    [sym_inline_method_definition] = STATE(848),
    [sym__constructor_specifiers] = STATE(2239),
    [sym_operator_cast_definition] = STATE(848),
    [sym_operator_cast_declaration] = STATE(848),
    [sym_constructor_or_destructor_definition] = STATE(848),
    [sym_constructor_or_destructor_declaration] = STATE(848),
    [sym_friend_declaration] = STATE(848),
    [sym_access_specifier] = STATE(9047),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(848),
    [sym_alias_declaration] = STATE(848),
    [sym_static_assert_declaration] = STATE(848),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7514),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(848),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2239),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3198),
    [aux_sym_preproc_if_token1] = ACTIONS(3200),
    [aux_sym_preproc_if_token2] = ACTIONS(3365),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3204),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3204),
    [aux_sym_preproc_else_token1] = ACTIONS(3206),
    [aux_sym_preproc_elif_token1] = ACTIONS(3208),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3210),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3210),
    [sym_preproc_directive] = ACTIONS(3212),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3222),
    [anon_sym_typedef] = ACTIONS(3224),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3240),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3242),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3246),
    [anon_sym_static_assert] = ACTIONS(3248),
  },
  [415] = {
    [sym_identifier] = ACTIONS(3367),
    [aux_sym_preproc_include_token1] = ACTIONS(3367),
    [aux_sym_preproc_def_token1] = ACTIONS(3367),
    [aux_sym_preproc_if_token1] = ACTIONS(3367),
    [aux_sym_preproc_if_token2] = ACTIONS(3367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3367),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3367),
    [aux_sym_preproc_else_token1] = ACTIONS(3367),
    [aux_sym_preproc_elif_token1] = ACTIONS(3367),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3367),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3367),
    [sym_preproc_directive] = ACTIONS(3367),
    [anon_sym_LPAREN2] = ACTIONS(3369),
    [anon_sym_BANG] = ACTIONS(3369),
    [anon_sym_TILDE] = ACTIONS(3369),
    [anon_sym_DASH] = ACTIONS(3367),
    [anon_sym_PLUS] = ACTIONS(3367),
    [anon_sym_STAR] = ACTIONS(3369),
    [anon_sym_AMP_AMP] = ACTIONS(3369),
    [anon_sym_AMP] = ACTIONS(3367),
    [anon_sym_SEMI] = ACTIONS(3369),
    [anon_sym___extension__] = ACTIONS(3367),
    [anon_sym_typedef] = ACTIONS(3367),
    [anon_sym_extern] = ACTIONS(3367),
    [anon_sym___attribute__] = ACTIONS(3367),
    [anon_sym_COLON_COLON] = ACTIONS(3369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3369),
    [anon_sym___declspec] = ACTIONS(3367),
    [anon_sym___based] = ACTIONS(3367),
    [anon_sym___cdecl] = ACTIONS(3367),
    [anon_sym___clrcall] = ACTIONS(3367),
    [anon_sym___stdcall] = ACTIONS(3367),
    [anon_sym___fastcall] = ACTIONS(3367),
    [anon_sym___thiscall] = ACTIONS(3367),
    [anon_sym___vectorcall] = ACTIONS(3367),
    [anon_sym_LBRACE] = ACTIONS(3369),
    [anon_sym_signed] = ACTIONS(3367),
    [anon_sym_unsigned] = ACTIONS(3367),
    [anon_sym_long] = ACTIONS(3367),
    [anon_sym_short] = ACTIONS(3367),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_static] = ACTIONS(3367),
    [anon_sym_register] = ACTIONS(3367),
    [anon_sym_inline] = ACTIONS(3367),
    [anon_sym___inline] = ACTIONS(3367),
    [anon_sym___inline__] = ACTIONS(3367),
    [anon_sym___forceinline] = ACTIONS(3367),
    [anon_sym_thread_local] = ACTIONS(3367),
    [anon_sym___thread] = ACTIONS(3367),
    [anon_sym_const] = ACTIONS(3367),
    [anon_sym_constexpr] = ACTIONS(3367),
    [anon_sym_volatile] = ACTIONS(3367),
    [anon_sym_restrict] = ACTIONS(3367),
    [anon_sym___restrict__] = ACTIONS(3367),
    [anon_sym__Atomic] = ACTIONS(3367),
    [anon_sym__Noreturn] = ACTIONS(3367),
    [anon_sym_noreturn] = ACTIONS(3367),
    [anon_sym_mutable] = ACTIONS(3367),
    [anon_sym_constinit] = ACTIONS(3367),
    [anon_sym_consteval] = ACTIONS(3367),
    [anon_sym_PROGMEM] = ACTIONS(3367),
    [aux_sym_primitive_type_token1] = ACTIONS(3367),
    [anon_sym_byte] = ACTIONS(3367),
    [anon_sym_word] = ACTIONS(3367),
    [anon_sym_enum] = ACTIONS(3367),
    [anon_sym_class] = ACTIONS(3367),
    [anon_sym_struct] = ACTIONS(3367),
    [anon_sym_union] = ACTIONS(3367),
    [anon_sym_if] = ACTIONS(3367),
    [anon_sym_switch] = ACTIONS(3367),
    [anon_sym_case] = ACTIONS(3367),
    [anon_sym_default] = ACTIONS(3367),
    [anon_sym_while] = ACTIONS(3367),
    [anon_sym_do] = ACTIONS(3367),
    [anon_sym_for] = ACTIONS(3367),
    [anon_sym_return] = ACTIONS(3367),
    [anon_sym_break] = ACTIONS(3367),
    [anon_sym_continue] = ACTIONS(3367),
    [anon_sym_goto] = ACTIONS(3367),
    [anon_sym___try] = ACTIONS(3367),
    [anon_sym___leave] = ACTIONS(3367),
    [anon_sym_not] = ACTIONS(3367),
    [anon_sym_compl] = ACTIONS(3367),
    [anon_sym_DASH_DASH] = ACTIONS(3369),
    [anon_sym_PLUS_PLUS] = ACTIONS(3369),
    [anon_sym_sizeof] = ACTIONS(3367),
    [anon_sym___alignof__] = ACTIONS(3367),
    [anon_sym___alignof] = ACTIONS(3367),
    [anon_sym__alignof] = ACTIONS(3367),
    [anon_sym_alignof] = ACTIONS(3367),
    [anon_sym__Alignof] = ACTIONS(3367),
    [anon_sym_offsetof] = ACTIONS(3367),
    [anon_sym__Generic] = ACTIONS(3367),
    [anon_sym_asm] = ACTIONS(3367),
    [anon_sym___asm__] = ACTIONS(3367),
    [aux_sym_number_literal_token1] = ACTIONS(3369),
    [aux_sym_number_literal_token2] = ACTIONS(3367),
    [anon_sym_L_SQUOTE] = ACTIONS(3369),
    [anon_sym_u_SQUOTE] = ACTIONS(3369),
    [anon_sym_U_SQUOTE] = ACTIONS(3369),
    [anon_sym_u8_SQUOTE] = ACTIONS(3369),
    [anon_sym_SQUOTE] = ACTIONS(3369),
    [anon_sym_L_DQUOTE] = ACTIONS(3369),
    [anon_sym_u_DQUOTE] = ACTIONS(3369),
    [anon_sym_U_DQUOTE] = ACTIONS(3369),
    [anon_sym_u8_DQUOTE] = ACTIONS(3369),
    [anon_sym_DQUOTE] = ACTIONS(3369),
    [sym_true] = ACTIONS(3367),
    [sym_false] = ACTIONS(3367),
    [anon_sym_NULL] = ACTIONS(3367),
    [anon_sym_nullptr] = ACTIONS(3367),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3367),
    [anon_sym_decltype] = ACTIONS(3367),
    [anon_sym_virtual] = ACTIONS(3367),
    [anon_sym_alignas] = ACTIONS(3367),
    [anon_sym_explicit] = ACTIONS(3367),
    [anon_sym_typename] = ACTIONS(3367),
    [anon_sym_template] = ACTIONS(3367),
    [anon_sym_operator] = ACTIONS(3367),
    [anon_sym_try] = ACTIONS(3367),
    [anon_sym_delete] = ACTIONS(3367),
    [anon_sym_throw] = ACTIONS(3367),
    [anon_sym_namespace] = ACTIONS(3367),
    [anon_sym_using] = ACTIONS(3367),
    [anon_sym_static_assert] = ACTIONS(3367),
    [anon_sym_concept] = ACTIONS(3367),
    [anon_sym_co_return] = ACTIONS(3367),
    [anon_sym_co_yield] = ACTIONS(3367),
    [anon_sym_R_DQUOTE] = ACTIONS(3369),
    [anon_sym_LR_DQUOTE] = ACTIONS(3369),
    [anon_sym_uR_DQUOTE] = ACTIONS(3369),
    [anon_sym_UR_DQUOTE] = ACTIONS(3369),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3369),
    [anon_sym_co_await] = ACTIONS(3367),
    [anon_sym_new] = ACTIONS(3367),
    [anon_sym_requires] = ACTIONS(3367),
    [sym_this] = ACTIONS(3367),
  },
  [416] = {
    [sym_identifier] = ACTIONS(3371),
    [aux_sym_preproc_include_token1] = ACTIONS(3371),
    [aux_sym_preproc_def_token1] = ACTIONS(3371),
    [aux_sym_preproc_if_token1] = ACTIONS(3371),
    [aux_sym_preproc_if_token2] = ACTIONS(3371),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3371),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3371),
    [aux_sym_preproc_else_token1] = ACTIONS(3371),
    [aux_sym_preproc_elif_token1] = ACTIONS(3371),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3371),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3371),
    [sym_preproc_directive] = ACTIONS(3371),
    [anon_sym_LPAREN2] = ACTIONS(3373),
    [anon_sym_BANG] = ACTIONS(3373),
    [anon_sym_TILDE] = ACTIONS(3373),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_STAR] = ACTIONS(3373),
    [anon_sym_AMP_AMP] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3371),
    [anon_sym_SEMI] = ACTIONS(3373),
    [anon_sym___extension__] = ACTIONS(3371),
    [anon_sym_typedef] = ACTIONS(3371),
    [anon_sym_extern] = ACTIONS(3371),
    [anon_sym___attribute__] = ACTIONS(3371),
    [anon_sym_COLON_COLON] = ACTIONS(3373),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3373),
    [anon_sym___declspec] = ACTIONS(3371),
    [anon_sym___based] = ACTIONS(3371),
    [anon_sym___cdecl] = ACTIONS(3371),
    [anon_sym___clrcall] = ACTIONS(3371),
    [anon_sym___stdcall] = ACTIONS(3371),
    [anon_sym___fastcall] = ACTIONS(3371),
    [anon_sym___thiscall] = ACTIONS(3371),
    [anon_sym___vectorcall] = ACTIONS(3371),
    [anon_sym_LBRACE] = ACTIONS(3373),
    [anon_sym_signed] = ACTIONS(3371),
    [anon_sym_unsigned] = ACTIONS(3371),
    [anon_sym_long] = ACTIONS(3371),
    [anon_sym_short] = ACTIONS(3371),
    [anon_sym_LBRACK] = ACTIONS(3371),
    [anon_sym_static] = ACTIONS(3371),
    [anon_sym_register] = ACTIONS(3371),
    [anon_sym_inline] = ACTIONS(3371),
    [anon_sym___inline] = ACTIONS(3371),
    [anon_sym___inline__] = ACTIONS(3371),
    [anon_sym___forceinline] = ACTIONS(3371),
    [anon_sym_thread_local] = ACTIONS(3371),
    [anon_sym___thread] = ACTIONS(3371),
    [anon_sym_const] = ACTIONS(3371),
    [anon_sym_constexpr] = ACTIONS(3371),
    [anon_sym_volatile] = ACTIONS(3371),
    [anon_sym_restrict] = ACTIONS(3371),
    [anon_sym___restrict__] = ACTIONS(3371),
    [anon_sym__Atomic] = ACTIONS(3371),
    [anon_sym__Noreturn] = ACTIONS(3371),
    [anon_sym_noreturn] = ACTIONS(3371),
    [anon_sym_mutable] = ACTIONS(3371),
    [anon_sym_constinit] = ACTIONS(3371),
    [anon_sym_consteval] = ACTIONS(3371),
    [anon_sym_PROGMEM] = ACTIONS(3371),
    [aux_sym_primitive_type_token1] = ACTIONS(3371),
    [anon_sym_byte] = ACTIONS(3371),
    [anon_sym_word] = ACTIONS(3371),
    [anon_sym_enum] = ACTIONS(3371),
    [anon_sym_class] = ACTIONS(3371),
    [anon_sym_struct] = ACTIONS(3371),
    [anon_sym_union] = ACTIONS(3371),
    [anon_sym_if] = ACTIONS(3371),
    [anon_sym_switch] = ACTIONS(3371),
    [anon_sym_case] = ACTIONS(3371),
    [anon_sym_default] = ACTIONS(3371),
    [anon_sym_while] = ACTIONS(3371),
    [anon_sym_do] = ACTIONS(3371),
    [anon_sym_for] = ACTIONS(3371),
    [anon_sym_return] = ACTIONS(3371),
    [anon_sym_break] = ACTIONS(3371),
    [anon_sym_continue] = ACTIONS(3371),
    [anon_sym_goto] = ACTIONS(3371),
    [anon_sym___try] = ACTIONS(3371),
    [anon_sym___leave] = ACTIONS(3371),
    [anon_sym_not] = ACTIONS(3371),
    [anon_sym_compl] = ACTIONS(3371),
    [anon_sym_DASH_DASH] = ACTIONS(3373),
    [anon_sym_PLUS_PLUS] = ACTIONS(3373),
    [anon_sym_sizeof] = ACTIONS(3371),
    [anon_sym___alignof__] = ACTIONS(3371),
    [anon_sym___alignof] = ACTIONS(3371),
    [anon_sym__alignof] = ACTIONS(3371),
    [anon_sym_alignof] = ACTIONS(3371),
    [anon_sym__Alignof] = ACTIONS(3371),
    [anon_sym_offsetof] = ACTIONS(3371),
    [anon_sym__Generic] = ACTIONS(3371),
    [anon_sym_asm] = ACTIONS(3371),
    [anon_sym___asm__] = ACTIONS(3371),
    [aux_sym_number_literal_token1] = ACTIONS(3373),
    [aux_sym_number_literal_token2] = ACTIONS(3371),
    [anon_sym_L_SQUOTE] = ACTIONS(3373),
    [anon_sym_u_SQUOTE] = ACTIONS(3373),
    [anon_sym_U_SQUOTE] = ACTIONS(3373),
    [anon_sym_u8_SQUOTE] = ACTIONS(3373),
    [anon_sym_SQUOTE] = ACTIONS(3373),
    [anon_sym_L_DQUOTE] = ACTIONS(3373),
    [anon_sym_u_DQUOTE] = ACTIONS(3373),
    [anon_sym_U_DQUOTE] = ACTIONS(3373),
    [anon_sym_u8_DQUOTE] = ACTIONS(3373),
    [anon_sym_DQUOTE] = ACTIONS(3373),
    [sym_true] = ACTIONS(3371),
    [sym_false] = ACTIONS(3371),
    [anon_sym_NULL] = ACTIONS(3371),
    [anon_sym_nullptr] = ACTIONS(3371),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3371),
    [anon_sym_decltype] = ACTIONS(3371),
    [anon_sym_virtual] = ACTIONS(3371),
    [anon_sym_alignas] = ACTIONS(3371),
    [anon_sym_explicit] = ACTIONS(3371),
    [anon_sym_typename] = ACTIONS(3371),
    [anon_sym_template] = ACTIONS(3371),
    [anon_sym_operator] = ACTIONS(3371),
    [anon_sym_try] = ACTIONS(3371),
    [anon_sym_delete] = ACTIONS(3371),
    [anon_sym_throw] = ACTIONS(3371),
    [anon_sym_namespace] = ACTIONS(3371),
    [anon_sym_using] = ACTIONS(3371),
    [anon_sym_static_assert] = ACTIONS(3371),
    [anon_sym_concept] = ACTIONS(3371),
    [anon_sym_co_return] = ACTIONS(3371),
    [anon_sym_co_yield] = ACTIONS(3371),
    [anon_sym_R_DQUOTE] = ACTIONS(3373),
    [anon_sym_LR_DQUOTE] = ACTIONS(3373),
    [anon_sym_uR_DQUOTE] = ACTIONS(3373),
    [anon_sym_UR_DQUOTE] = ACTIONS(3373),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3373),
    [anon_sym_co_await] = ACTIONS(3371),
    [anon_sym_new] = ACTIONS(3371),
    [anon_sym_requires] = ACTIONS(3371),
    [sym_this] = ACTIONS(3371),
  },
  [417] = {
    [sym_identifier] = ACTIONS(3375),
    [aux_sym_preproc_include_token1] = ACTIONS(3375),
    [aux_sym_preproc_def_token1] = ACTIONS(3375),
    [aux_sym_preproc_if_token1] = ACTIONS(3375),
    [aux_sym_preproc_if_token2] = ACTIONS(3375),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3375),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3375),
    [aux_sym_preproc_else_token1] = ACTIONS(3375),
    [aux_sym_preproc_elif_token1] = ACTIONS(3375),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3375),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3375),
    [sym_preproc_directive] = ACTIONS(3375),
    [anon_sym_LPAREN2] = ACTIONS(3377),
    [anon_sym_BANG] = ACTIONS(3377),
    [anon_sym_TILDE] = ACTIONS(3377),
    [anon_sym_DASH] = ACTIONS(3375),
    [anon_sym_PLUS] = ACTIONS(3375),
    [anon_sym_STAR] = ACTIONS(3377),
    [anon_sym_AMP_AMP] = ACTIONS(3377),
    [anon_sym_AMP] = ACTIONS(3375),
    [anon_sym_SEMI] = ACTIONS(3377),
    [anon_sym___extension__] = ACTIONS(3375),
    [anon_sym_typedef] = ACTIONS(3375),
    [anon_sym_extern] = ACTIONS(3375),
    [anon_sym___attribute__] = ACTIONS(3375),
    [anon_sym_COLON_COLON] = ACTIONS(3377),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3377),
    [anon_sym___declspec] = ACTIONS(3375),
    [anon_sym___based] = ACTIONS(3375),
    [anon_sym___cdecl] = ACTIONS(3375),
    [anon_sym___clrcall] = ACTIONS(3375),
    [anon_sym___stdcall] = ACTIONS(3375),
    [anon_sym___fastcall] = ACTIONS(3375),
    [anon_sym___thiscall] = ACTIONS(3375),
    [anon_sym___vectorcall] = ACTIONS(3375),
    [anon_sym_LBRACE] = ACTIONS(3377),
    [anon_sym_signed] = ACTIONS(3375),
    [anon_sym_unsigned] = ACTIONS(3375),
    [anon_sym_long] = ACTIONS(3375),
    [anon_sym_short] = ACTIONS(3375),
    [anon_sym_LBRACK] = ACTIONS(3375),
    [anon_sym_static] = ACTIONS(3375),
    [anon_sym_register] = ACTIONS(3375),
    [anon_sym_inline] = ACTIONS(3375),
    [anon_sym___inline] = ACTIONS(3375),
    [anon_sym___inline__] = ACTIONS(3375),
    [anon_sym___forceinline] = ACTIONS(3375),
    [anon_sym_thread_local] = ACTIONS(3375),
    [anon_sym___thread] = ACTIONS(3375),
    [anon_sym_const] = ACTIONS(3375),
    [anon_sym_constexpr] = ACTIONS(3375),
    [anon_sym_volatile] = ACTIONS(3375),
    [anon_sym_restrict] = ACTIONS(3375),
    [anon_sym___restrict__] = ACTIONS(3375),
    [anon_sym__Atomic] = ACTIONS(3375),
    [anon_sym__Noreturn] = ACTIONS(3375),
    [anon_sym_noreturn] = ACTIONS(3375),
    [anon_sym_mutable] = ACTIONS(3375),
    [anon_sym_constinit] = ACTIONS(3375),
    [anon_sym_consteval] = ACTIONS(3375),
    [anon_sym_PROGMEM] = ACTIONS(3375),
    [aux_sym_primitive_type_token1] = ACTIONS(3375),
    [anon_sym_byte] = ACTIONS(3375),
    [anon_sym_word] = ACTIONS(3375),
    [anon_sym_enum] = ACTIONS(3375),
    [anon_sym_class] = ACTIONS(3375),
    [anon_sym_struct] = ACTIONS(3375),
    [anon_sym_union] = ACTIONS(3375),
    [anon_sym_if] = ACTIONS(3375),
    [anon_sym_switch] = ACTIONS(3375),
    [anon_sym_case] = ACTIONS(3375),
    [anon_sym_default] = ACTIONS(3375),
    [anon_sym_while] = ACTIONS(3375),
    [anon_sym_do] = ACTIONS(3375),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_return] = ACTIONS(3375),
    [anon_sym_break] = ACTIONS(3375),
    [anon_sym_continue] = ACTIONS(3375),
    [anon_sym_goto] = ACTIONS(3375),
    [anon_sym___try] = ACTIONS(3375),
    [anon_sym___leave] = ACTIONS(3375),
    [anon_sym_not] = ACTIONS(3375),
    [anon_sym_compl] = ACTIONS(3375),
    [anon_sym_DASH_DASH] = ACTIONS(3377),
    [anon_sym_PLUS_PLUS] = ACTIONS(3377),
    [anon_sym_sizeof] = ACTIONS(3375),
    [anon_sym___alignof__] = ACTIONS(3375),
    [anon_sym___alignof] = ACTIONS(3375),
    [anon_sym__alignof] = ACTIONS(3375),
    [anon_sym_alignof] = ACTIONS(3375),
    [anon_sym__Alignof] = ACTIONS(3375),
    [anon_sym_offsetof] = ACTIONS(3375),
    [anon_sym__Generic] = ACTIONS(3375),
    [anon_sym_asm] = ACTIONS(3375),
    [anon_sym___asm__] = ACTIONS(3375),
    [aux_sym_number_literal_token1] = ACTIONS(3377),
    [aux_sym_number_literal_token2] = ACTIONS(3375),
    [anon_sym_L_SQUOTE] = ACTIONS(3377),
    [anon_sym_u_SQUOTE] = ACTIONS(3377),
    [anon_sym_U_SQUOTE] = ACTIONS(3377),
    [anon_sym_u8_SQUOTE] = ACTIONS(3377),
    [anon_sym_SQUOTE] = ACTIONS(3377),
    [anon_sym_L_DQUOTE] = ACTIONS(3377),
    [anon_sym_u_DQUOTE] = ACTIONS(3377),
    [anon_sym_U_DQUOTE] = ACTIONS(3377),
    [anon_sym_u8_DQUOTE] = ACTIONS(3377),
    [anon_sym_DQUOTE] = ACTIONS(3377),
    [sym_true] = ACTIONS(3375),
    [sym_false] = ACTIONS(3375),
    [anon_sym_NULL] = ACTIONS(3375),
    [anon_sym_nullptr] = ACTIONS(3375),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3375),
    [anon_sym_decltype] = ACTIONS(3375),
    [anon_sym_virtual] = ACTIONS(3375),
    [anon_sym_alignas] = ACTIONS(3375),
    [anon_sym_explicit] = ACTIONS(3375),
    [anon_sym_typename] = ACTIONS(3375),
    [anon_sym_template] = ACTIONS(3375),
    [anon_sym_operator] = ACTIONS(3375),
    [anon_sym_try] = ACTIONS(3375),
    [anon_sym_delete] = ACTIONS(3375),
    [anon_sym_throw] = ACTIONS(3375),
    [anon_sym_namespace] = ACTIONS(3375),
    [anon_sym_using] = ACTIONS(3375),
    [anon_sym_static_assert] = ACTIONS(3375),
    [anon_sym_concept] = ACTIONS(3375),
    [anon_sym_co_return] = ACTIONS(3375),
    [anon_sym_co_yield] = ACTIONS(3375),
    [anon_sym_R_DQUOTE] = ACTIONS(3377),
    [anon_sym_LR_DQUOTE] = ACTIONS(3377),
    [anon_sym_uR_DQUOTE] = ACTIONS(3377),
    [anon_sym_UR_DQUOTE] = ACTIONS(3377),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3377),
    [anon_sym_co_await] = ACTIONS(3375),
    [anon_sym_new] = ACTIONS(3375),
    [anon_sym_requires] = ACTIONS(3375),
    [sym_this] = ACTIONS(3375),
  },
  [418] = {
    [sym_identifier] = ACTIONS(2887),
    [aux_sym_preproc_include_token1] = ACTIONS(2887),
    [aux_sym_preproc_def_token1] = ACTIONS(2887),
    [aux_sym_preproc_if_token1] = ACTIONS(2887),
    [aux_sym_preproc_if_token2] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2887),
    [aux_sym_preproc_else_token1] = ACTIONS(2887),
    [aux_sym_preproc_elif_token1] = ACTIONS(2887),
    [sym_preproc_directive] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2889),
    [anon_sym_BANG] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2887),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_SEMI] = ACTIONS(2889),
    [anon_sym___extension__] = ACTIONS(2887),
    [anon_sym_typedef] = ACTIONS(2887),
    [anon_sym_extern] = ACTIONS(2887),
    [anon_sym___attribute__] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2889),
    [anon_sym___declspec] = ACTIONS(2887),
    [anon_sym___based] = ACTIONS(2887),
    [anon_sym___cdecl] = ACTIONS(2887),
    [anon_sym___clrcall] = ACTIONS(2887),
    [anon_sym___stdcall] = ACTIONS(2887),
    [anon_sym___fastcall] = ACTIONS(2887),
    [anon_sym___thiscall] = ACTIONS(2887),
    [anon_sym___vectorcall] = ACTIONS(2887),
    [anon_sym_LBRACE] = ACTIONS(2889),
    [anon_sym_signed] = ACTIONS(2887),
    [anon_sym_unsigned] = ACTIONS(2887),
    [anon_sym_long] = ACTIONS(2887),
    [anon_sym_short] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_static] = ACTIONS(2887),
    [anon_sym_register] = ACTIONS(2887),
    [anon_sym_inline] = ACTIONS(2887),
    [anon_sym___inline] = ACTIONS(2887),
    [anon_sym___inline__] = ACTIONS(2887),
    [anon_sym___forceinline] = ACTIONS(2887),
    [anon_sym_thread_local] = ACTIONS(2887),
    [anon_sym___thread] = ACTIONS(2887),
    [anon_sym_const] = ACTIONS(2887),
    [anon_sym_constexpr] = ACTIONS(2887),
    [anon_sym_volatile] = ACTIONS(2887),
    [anon_sym_restrict] = ACTIONS(2887),
    [anon_sym___restrict__] = ACTIONS(2887),
    [anon_sym__Atomic] = ACTIONS(2887),
    [anon_sym__Noreturn] = ACTIONS(2887),
    [anon_sym_noreturn] = ACTIONS(2887),
    [anon_sym_mutable] = ACTIONS(2887),
    [anon_sym_constinit] = ACTIONS(2887),
    [anon_sym_consteval] = ACTIONS(2887),
    [anon_sym_PROGMEM] = ACTIONS(2887),
    [aux_sym_primitive_type_token1] = ACTIONS(2887),
    [anon_sym_byte] = ACTIONS(2887),
    [anon_sym_word] = ACTIONS(2887),
    [anon_sym_enum] = ACTIONS(2887),
    [anon_sym_class] = ACTIONS(2887),
    [anon_sym_struct] = ACTIONS(2887),
    [anon_sym_union] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_else] = ACTIONS(2887),
    [anon_sym_switch] = ACTIONS(2887),
    [anon_sym_case] = ACTIONS(2887),
    [anon_sym_default] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2887),
    [anon_sym_for] = ACTIONS(2887),
    [anon_sym_return] = ACTIONS(2887),
    [anon_sym_break] = ACTIONS(2887),
    [anon_sym_continue] = ACTIONS(2887),
    [anon_sym_goto] = ACTIONS(2887),
    [anon_sym___try] = ACTIONS(2887),
    [anon_sym___leave] = ACTIONS(2887),
    [anon_sym_not] = ACTIONS(2887),
    [anon_sym_compl] = ACTIONS(2887),
    [anon_sym_DASH_DASH] = ACTIONS(2889),
    [anon_sym_PLUS_PLUS] = ACTIONS(2889),
    [anon_sym_sizeof] = ACTIONS(2887),
    [anon_sym___alignof__] = ACTIONS(2887),
    [anon_sym___alignof] = ACTIONS(2887),
    [anon_sym__alignof] = ACTIONS(2887),
    [anon_sym_alignof] = ACTIONS(2887),
    [anon_sym__Alignof] = ACTIONS(2887),
    [anon_sym_offsetof] = ACTIONS(2887),
    [anon_sym__Generic] = ACTIONS(2887),
    [anon_sym_asm] = ACTIONS(2887),
    [anon_sym___asm__] = ACTIONS(2887),
    [aux_sym_number_literal_token1] = ACTIONS(2889),
    [aux_sym_number_literal_token2] = ACTIONS(2887),
    [anon_sym_L_SQUOTE] = ACTIONS(2889),
    [anon_sym_u_SQUOTE] = ACTIONS(2889),
    [anon_sym_U_SQUOTE] = ACTIONS(2889),
    [anon_sym_u8_SQUOTE] = ACTIONS(2889),
    [anon_sym_SQUOTE] = ACTIONS(2889),
    [anon_sym_L_DQUOTE] = ACTIONS(2889),
    [anon_sym_u_DQUOTE] = ACTIONS(2889),
    [anon_sym_U_DQUOTE] = ACTIONS(2889),
    [anon_sym_u8_DQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE] = ACTIONS(2889),
    [sym_true] = ACTIONS(2887),
    [sym_false] = ACTIONS(2887),
    [anon_sym_NULL] = ACTIONS(2887),
    [anon_sym_nullptr] = ACTIONS(2887),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2887),
    [anon_sym_decltype] = ACTIONS(2887),
    [anon_sym_virtual] = ACTIONS(2887),
    [anon_sym_alignas] = ACTIONS(2887),
    [anon_sym_explicit] = ACTIONS(2887),
    [anon_sym_typename] = ACTIONS(2887),
    [anon_sym_template] = ACTIONS(2887),
    [anon_sym_operator] = ACTIONS(2887),
    [anon_sym_try] = ACTIONS(2887),
    [anon_sym_delete] = ACTIONS(2887),
    [anon_sym_throw] = ACTIONS(2887),
    [anon_sym_namespace] = ACTIONS(2887),
    [anon_sym_using] = ACTIONS(2887),
    [anon_sym_static_assert] = ACTIONS(2887),
    [anon_sym_concept] = ACTIONS(2887),
    [anon_sym_co_return] = ACTIONS(2887),
    [anon_sym_co_yield] = ACTIONS(2887),
    [anon_sym_catch] = ACTIONS(2887),
    [anon_sym_R_DQUOTE] = ACTIONS(2889),
    [anon_sym_LR_DQUOTE] = ACTIONS(2889),
    [anon_sym_uR_DQUOTE] = ACTIONS(2889),
    [anon_sym_UR_DQUOTE] = ACTIONS(2889),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2889),
    [anon_sym_co_await] = ACTIONS(2887),
    [anon_sym_new] = ACTIONS(2887),
    [anon_sym_requires] = ACTIONS(2887),
    [sym_this] = ACTIONS(2887),
  },
  [419] = {
    [sym_identifier] = ACTIONS(3379),
    [aux_sym_preproc_include_token1] = ACTIONS(3379),
    [aux_sym_preproc_def_token1] = ACTIONS(3379),
    [aux_sym_preproc_if_token1] = ACTIONS(3379),
    [aux_sym_preproc_if_token2] = ACTIONS(3379),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3379),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3379),
    [aux_sym_preproc_else_token1] = ACTIONS(3379),
    [aux_sym_preproc_elif_token1] = ACTIONS(3379),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3379),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3379),
    [sym_preproc_directive] = ACTIONS(3379),
    [anon_sym_LPAREN2] = ACTIONS(3381),
    [anon_sym_BANG] = ACTIONS(3381),
    [anon_sym_TILDE] = ACTIONS(3381),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_STAR] = ACTIONS(3381),
    [anon_sym_AMP_AMP] = ACTIONS(3381),
    [anon_sym_AMP] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3381),
    [anon_sym___extension__] = ACTIONS(3379),
    [anon_sym_typedef] = ACTIONS(3379),
    [anon_sym_extern] = ACTIONS(3379),
    [anon_sym___attribute__] = ACTIONS(3379),
    [anon_sym_COLON_COLON] = ACTIONS(3381),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3381),
    [anon_sym___declspec] = ACTIONS(3379),
    [anon_sym___based] = ACTIONS(3379),
    [anon_sym___cdecl] = ACTIONS(3379),
    [anon_sym___clrcall] = ACTIONS(3379),
    [anon_sym___stdcall] = ACTIONS(3379),
    [anon_sym___fastcall] = ACTIONS(3379),
    [anon_sym___thiscall] = ACTIONS(3379),
    [anon_sym___vectorcall] = ACTIONS(3379),
    [anon_sym_LBRACE] = ACTIONS(3381),
    [anon_sym_signed] = ACTIONS(3379),
    [anon_sym_unsigned] = ACTIONS(3379),
    [anon_sym_long] = ACTIONS(3379),
    [anon_sym_short] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_register] = ACTIONS(3379),
    [anon_sym_inline] = ACTIONS(3379),
    [anon_sym___inline] = ACTIONS(3379),
    [anon_sym___inline__] = ACTIONS(3379),
    [anon_sym___forceinline] = ACTIONS(3379),
    [anon_sym_thread_local] = ACTIONS(3379),
    [anon_sym___thread] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_constexpr] = ACTIONS(3379),
    [anon_sym_volatile] = ACTIONS(3379),
    [anon_sym_restrict] = ACTIONS(3379),
    [anon_sym___restrict__] = ACTIONS(3379),
    [anon_sym__Atomic] = ACTIONS(3379),
    [anon_sym__Noreturn] = ACTIONS(3379),
    [anon_sym_noreturn] = ACTIONS(3379),
    [anon_sym_mutable] = ACTIONS(3379),
    [anon_sym_constinit] = ACTIONS(3379),
    [anon_sym_consteval] = ACTIONS(3379),
    [anon_sym_PROGMEM] = ACTIONS(3379),
    [aux_sym_primitive_type_token1] = ACTIONS(3379),
    [anon_sym_byte] = ACTIONS(3379),
    [anon_sym_word] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_struct] = ACTIONS(3379),
    [anon_sym_union] = ACTIONS(3379),
    [anon_sym_if] = ACTIONS(3379),
    [anon_sym_switch] = ACTIONS(3379),
    [anon_sym_case] = ACTIONS(3379),
    [anon_sym_default] = ACTIONS(3379),
    [anon_sym_while] = ACTIONS(3379),
    [anon_sym_do] = ACTIONS(3379),
    [anon_sym_for] = ACTIONS(3379),
    [anon_sym_return] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(3379),
    [anon_sym_continue] = ACTIONS(3379),
    [anon_sym_goto] = ACTIONS(3379),
    [anon_sym___try] = ACTIONS(3379),
    [anon_sym___leave] = ACTIONS(3379),
    [anon_sym_not] = ACTIONS(3379),
    [anon_sym_compl] = ACTIONS(3379),
    [anon_sym_DASH_DASH] = ACTIONS(3381),
    [anon_sym_PLUS_PLUS] = ACTIONS(3381),
    [anon_sym_sizeof] = ACTIONS(3379),
    [anon_sym___alignof__] = ACTIONS(3379),
    [anon_sym___alignof] = ACTIONS(3379),
    [anon_sym__alignof] = ACTIONS(3379),
    [anon_sym_alignof] = ACTIONS(3379),
    [anon_sym__Alignof] = ACTIONS(3379),
    [anon_sym_offsetof] = ACTIONS(3379),
    [anon_sym__Generic] = ACTIONS(3379),
    [anon_sym_asm] = ACTIONS(3379),
    [anon_sym___asm__] = ACTIONS(3379),
    [aux_sym_number_literal_token1] = ACTIONS(3381),
    [aux_sym_number_literal_token2] = ACTIONS(3379),
    [anon_sym_L_SQUOTE] = ACTIONS(3381),
    [anon_sym_u_SQUOTE] = ACTIONS(3381),
    [anon_sym_U_SQUOTE] = ACTIONS(3381),
    [anon_sym_u8_SQUOTE] = ACTIONS(3381),
    [anon_sym_SQUOTE] = ACTIONS(3381),
    [anon_sym_L_DQUOTE] = ACTIONS(3381),
    [anon_sym_u_DQUOTE] = ACTIONS(3381),
    [anon_sym_U_DQUOTE] = ACTIONS(3381),
    [anon_sym_u8_DQUOTE] = ACTIONS(3381),
    [anon_sym_DQUOTE] = ACTIONS(3381),
    [sym_true] = ACTIONS(3379),
    [sym_false] = ACTIONS(3379),
    [anon_sym_NULL] = ACTIONS(3379),
    [anon_sym_nullptr] = ACTIONS(3379),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3379),
    [anon_sym_decltype] = ACTIONS(3379),
    [anon_sym_virtual] = ACTIONS(3379),
    [anon_sym_alignas] = ACTIONS(3379),
    [anon_sym_explicit] = ACTIONS(3379),
    [anon_sym_typename] = ACTIONS(3379),
    [anon_sym_template] = ACTIONS(3379),
    [anon_sym_operator] = ACTIONS(3379),
    [anon_sym_try] = ACTIONS(3379),
    [anon_sym_delete] = ACTIONS(3379),
    [anon_sym_throw] = ACTIONS(3379),
    [anon_sym_namespace] = ACTIONS(3379),
    [anon_sym_using] = ACTIONS(3379),
    [anon_sym_static_assert] = ACTIONS(3379),
    [anon_sym_concept] = ACTIONS(3379),
    [anon_sym_co_return] = ACTIONS(3379),
    [anon_sym_co_yield] = ACTIONS(3379),
    [anon_sym_R_DQUOTE] = ACTIONS(3381),
    [anon_sym_LR_DQUOTE] = ACTIONS(3381),
    [anon_sym_uR_DQUOTE] = ACTIONS(3381),
    [anon_sym_UR_DQUOTE] = ACTIONS(3381),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3381),
    [anon_sym_co_await] = ACTIONS(3379),
    [anon_sym_new] = ACTIONS(3379),
    [anon_sym_requires] = ACTIONS(3379),
    [sym_this] = ACTIONS(3379),
  },
  [420] = {
    [sym_identifier] = ACTIONS(3383),
    [aux_sym_preproc_include_token1] = ACTIONS(3383),
    [aux_sym_preproc_def_token1] = ACTIONS(3383),
    [aux_sym_preproc_if_token1] = ACTIONS(3383),
    [aux_sym_preproc_if_token2] = ACTIONS(3383),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3383),
    [aux_sym_preproc_else_token1] = ACTIONS(3383),
    [aux_sym_preproc_elif_token1] = ACTIONS(3383),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3383),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3383),
    [sym_preproc_directive] = ACTIONS(3383),
    [anon_sym_LPAREN2] = ACTIONS(3385),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_TILDE] = ACTIONS(3385),
    [anon_sym_DASH] = ACTIONS(3383),
    [anon_sym_PLUS] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(3385),
    [anon_sym_AMP_AMP] = ACTIONS(3385),
    [anon_sym_AMP] = ACTIONS(3383),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym___extension__] = ACTIONS(3383),
    [anon_sym_typedef] = ACTIONS(3383),
    [anon_sym_extern] = ACTIONS(3383),
    [anon_sym___attribute__] = ACTIONS(3383),
    [anon_sym_COLON_COLON] = ACTIONS(3385),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3385),
    [anon_sym___declspec] = ACTIONS(3383),
    [anon_sym___based] = ACTIONS(3383),
    [anon_sym___cdecl] = ACTIONS(3383),
    [anon_sym___clrcall] = ACTIONS(3383),
    [anon_sym___stdcall] = ACTIONS(3383),
    [anon_sym___fastcall] = ACTIONS(3383),
    [anon_sym___thiscall] = ACTIONS(3383),
    [anon_sym___vectorcall] = ACTIONS(3383),
    [anon_sym_LBRACE] = ACTIONS(3385),
    [anon_sym_signed] = ACTIONS(3383),
    [anon_sym_unsigned] = ACTIONS(3383),
    [anon_sym_long] = ACTIONS(3383),
    [anon_sym_short] = ACTIONS(3383),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_static] = ACTIONS(3383),
    [anon_sym_register] = ACTIONS(3383),
    [anon_sym_inline] = ACTIONS(3383),
    [anon_sym___inline] = ACTIONS(3383),
    [anon_sym___inline__] = ACTIONS(3383),
    [anon_sym___forceinline] = ACTIONS(3383),
    [anon_sym_thread_local] = ACTIONS(3383),
    [anon_sym___thread] = ACTIONS(3383),
    [anon_sym_const] = ACTIONS(3383),
    [anon_sym_constexpr] = ACTIONS(3383),
    [anon_sym_volatile] = ACTIONS(3383),
    [anon_sym_restrict] = ACTIONS(3383),
    [anon_sym___restrict__] = ACTIONS(3383),
    [anon_sym__Atomic] = ACTIONS(3383),
    [anon_sym__Noreturn] = ACTIONS(3383),
    [anon_sym_noreturn] = ACTIONS(3383),
    [anon_sym_mutable] = ACTIONS(3383),
    [anon_sym_constinit] = ACTIONS(3383),
    [anon_sym_consteval] = ACTIONS(3383),
    [anon_sym_PROGMEM] = ACTIONS(3383),
    [aux_sym_primitive_type_token1] = ACTIONS(3383),
    [anon_sym_byte] = ACTIONS(3383),
    [anon_sym_word] = ACTIONS(3383),
    [anon_sym_enum] = ACTIONS(3383),
    [anon_sym_class] = ACTIONS(3383),
    [anon_sym_struct] = ACTIONS(3383),
    [anon_sym_union] = ACTIONS(3383),
    [anon_sym_if] = ACTIONS(3383),
    [anon_sym_switch] = ACTIONS(3383),
    [anon_sym_case] = ACTIONS(3383),
    [anon_sym_default] = ACTIONS(3383),
    [anon_sym_while] = ACTIONS(3383),
    [anon_sym_do] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3383),
    [anon_sym_return] = ACTIONS(3383),
    [anon_sym_break] = ACTIONS(3383),
    [anon_sym_continue] = ACTIONS(3383),
    [anon_sym_goto] = ACTIONS(3383),
    [anon_sym___try] = ACTIONS(3383),
    [anon_sym___leave] = ACTIONS(3383),
    [anon_sym_not] = ACTIONS(3383),
    [anon_sym_compl] = ACTIONS(3383),
    [anon_sym_DASH_DASH] = ACTIONS(3385),
    [anon_sym_PLUS_PLUS] = ACTIONS(3385),
    [anon_sym_sizeof] = ACTIONS(3383),
    [anon_sym___alignof__] = ACTIONS(3383),
    [anon_sym___alignof] = ACTIONS(3383),
    [anon_sym__alignof] = ACTIONS(3383),
    [anon_sym_alignof] = ACTIONS(3383),
    [anon_sym__Alignof] = ACTIONS(3383),
    [anon_sym_offsetof] = ACTIONS(3383),
    [anon_sym__Generic] = ACTIONS(3383),
    [anon_sym_asm] = ACTIONS(3383),
    [anon_sym___asm__] = ACTIONS(3383),
    [aux_sym_number_literal_token1] = ACTIONS(3385),
    [aux_sym_number_literal_token2] = ACTIONS(3383),
    [anon_sym_L_SQUOTE] = ACTIONS(3385),
    [anon_sym_u_SQUOTE] = ACTIONS(3385),
    [anon_sym_U_SQUOTE] = ACTIONS(3385),
    [anon_sym_u8_SQUOTE] = ACTIONS(3385),
    [anon_sym_SQUOTE] = ACTIONS(3385),
    [anon_sym_L_DQUOTE] = ACTIONS(3385),
    [anon_sym_u_DQUOTE] = ACTIONS(3385),
    [anon_sym_U_DQUOTE] = ACTIONS(3385),
    [anon_sym_u8_DQUOTE] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(3385),
    [sym_true] = ACTIONS(3383),
    [sym_false] = ACTIONS(3383),
    [anon_sym_NULL] = ACTIONS(3383),
    [anon_sym_nullptr] = ACTIONS(3383),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3383),
    [anon_sym_decltype] = ACTIONS(3383),
    [anon_sym_virtual] = ACTIONS(3383),
    [anon_sym_alignas] = ACTIONS(3383),
    [anon_sym_explicit] = ACTIONS(3383),
    [anon_sym_typename] = ACTIONS(3383),
    [anon_sym_template] = ACTIONS(3383),
    [anon_sym_operator] = ACTIONS(3383),
    [anon_sym_try] = ACTIONS(3383),
    [anon_sym_delete] = ACTIONS(3383),
    [anon_sym_throw] = ACTIONS(3383),
    [anon_sym_namespace] = ACTIONS(3383),
    [anon_sym_using] = ACTIONS(3383),
    [anon_sym_static_assert] = ACTIONS(3383),
    [anon_sym_concept] = ACTIONS(3383),
    [anon_sym_co_return] = ACTIONS(3383),
    [anon_sym_co_yield] = ACTIONS(3383),
    [anon_sym_R_DQUOTE] = ACTIONS(3385),
    [anon_sym_LR_DQUOTE] = ACTIONS(3385),
    [anon_sym_uR_DQUOTE] = ACTIONS(3385),
    [anon_sym_UR_DQUOTE] = ACTIONS(3385),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3385),
    [anon_sym_co_await] = ACTIONS(3383),
    [anon_sym_new] = ACTIONS(3383),
    [anon_sym_requires] = ACTIONS(3383),
    [sym_this] = ACTIONS(3383),
  },
  [421] = {
    [sym_identifier] = ACTIONS(3387),
    [aux_sym_preproc_include_token1] = ACTIONS(3387),
    [aux_sym_preproc_def_token1] = ACTIONS(3387),
    [aux_sym_preproc_if_token1] = ACTIONS(3387),
    [aux_sym_preproc_if_token2] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3387),
    [aux_sym_preproc_else_token1] = ACTIONS(3387),
    [aux_sym_preproc_elif_token1] = ACTIONS(3387),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3387),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3387),
    [sym_preproc_directive] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_BANG] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_STAR] = ACTIONS(3389),
    [anon_sym_AMP_AMP] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_SEMI] = ACTIONS(3389),
    [anon_sym___extension__] = ACTIONS(3387),
    [anon_sym_typedef] = ACTIONS(3387),
    [anon_sym_extern] = ACTIONS(3387),
    [anon_sym___attribute__] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3389),
    [anon_sym___declspec] = ACTIONS(3387),
    [anon_sym___based] = ACTIONS(3387),
    [anon_sym___cdecl] = ACTIONS(3387),
    [anon_sym___clrcall] = ACTIONS(3387),
    [anon_sym___stdcall] = ACTIONS(3387),
    [anon_sym___fastcall] = ACTIONS(3387),
    [anon_sym___thiscall] = ACTIONS(3387),
    [anon_sym___vectorcall] = ACTIONS(3387),
    [anon_sym_LBRACE] = ACTIONS(3389),
    [anon_sym_signed] = ACTIONS(3387),
    [anon_sym_unsigned] = ACTIONS(3387),
    [anon_sym_long] = ACTIONS(3387),
    [anon_sym_short] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_register] = ACTIONS(3387),
    [anon_sym_inline] = ACTIONS(3387),
    [anon_sym___inline] = ACTIONS(3387),
    [anon_sym___inline__] = ACTIONS(3387),
    [anon_sym___forceinline] = ACTIONS(3387),
    [anon_sym_thread_local] = ACTIONS(3387),
    [anon_sym___thread] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_constexpr] = ACTIONS(3387),
    [anon_sym_volatile] = ACTIONS(3387),
    [anon_sym_restrict] = ACTIONS(3387),
    [anon_sym___restrict__] = ACTIONS(3387),
    [anon_sym__Atomic] = ACTIONS(3387),
    [anon_sym__Noreturn] = ACTIONS(3387),
    [anon_sym_noreturn] = ACTIONS(3387),
    [anon_sym_mutable] = ACTIONS(3387),
    [anon_sym_constinit] = ACTIONS(3387),
    [anon_sym_consteval] = ACTIONS(3387),
    [anon_sym_PROGMEM] = ACTIONS(3387),
    [aux_sym_primitive_type_token1] = ACTIONS(3387),
    [anon_sym_byte] = ACTIONS(3387),
    [anon_sym_word] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [anon_sym_class] = ACTIONS(3387),
    [anon_sym_struct] = ACTIONS(3387),
    [anon_sym_union] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_switch] = ACTIONS(3387),
    [anon_sym_case] = ACTIONS(3387),
    [anon_sym_default] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_break] = ACTIONS(3387),
    [anon_sym_continue] = ACTIONS(3387),
    [anon_sym_goto] = ACTIONS(3387),
    [anon_sym___try] = ACTIONS(3387),
    [anon_sym___leave] = ACTIONS(3387),
    [anon_sym_not] = ACTIONS(3387),
    [anon_sym_compl] = ACTIONS(3387),
    [anon_sym_DASH_DASH] = ACTIONS(3389),
    [anon_sym_PLUS_PLUS] = ACTIONS(3389),
    [anon_sym_sizeof] = ACTIONS(3387),
    [anon_sym___alignof__] = ACTIONS(3387),
    [anon_sym___alignof] = ACTIONS(3387),
    [anon_sym__alignof] = ACTIONS(3387),
    [anon_sym_alignof] = ACTIONS(3387),
    [anon_sym__Alignof] = ACTIONS(3387),
    [anon_sym_offsetof] = ACTIONS(3387),
    [anon_sym__Generic] = ACTIONS(3387),
    [anon_sym_asm] = ACTIONS(3387),
    [anon_sym___asm__] = ACTIONS(3387),
    [aux_sym_number_literal_token1] = ACTIONS(3389),
    [aux_sym_number_literal_token2] = ACTIONS(3387),
    [anon_sym_L_SQUOTE] = ACTIONS(3389),
    [anon_sym_u_SQUOTE] = ACTIONS(3389),
    [anon_sym_U_SQUOTE] = ACTIONS(3389),
    [anon_sym_u8_SQUOTE] = ACTIONS(3389),
    [anon_sym_SQUOTE] = ACTIONS(3389),
    [anon_sym_L_DQUOTE] = ACTIONS(3389),
    [anon_sym_u_DQUOTE] = ACTIONS(3389),
    [anon_sym_U_DQUOTE] = ACTIONS(3389),
    [anon_sym_u8_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE] = ACTIONS(3389),
    [sym_true] = ACTIONS(3387),
    [sym_false] = ACTIONS(3387),
    [anon_sym_NULL] = ACTIONS(3387),
    [anon_sym_nullptr] = ACTIONS(3387),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3387),
    [anon_sym_decltype] = ACTIONS(3387),
    [anon_sym_virtual] = ACTIONS(3387),
    [anon_sym_alignas] = ACTIONS(3387),
    [anon_sym_explicit] = ACTIONS(3387),
    [anon_sym_typename] = ACTIONS(3387),
    [anon_sym_template] = ACTIONS(3387),
    [anon_sym_operator] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_delete] = ACTIONS(3387),
    [anon_sym_throw] = ACTIONS(3387),
    [anon_sym_namespace] = ACTIONS(3387),
    [anon_sym_using] = ACTIONS(3387),
    [anon_sym_static_assert] = ACTIONS(3387),
    [anon_sym_concept] = ACTIONS(3387),
    [anon_sym_co_return] = ACTIONS(3387),
    [anon_sym_co_yield] = ACTIONS(3387),
    [anon_sym_R_DQUOTE] = ACTIONS(3389),
    [anon_sym_LR_DQUOTE] = ACTIONS(3389),
    [anon_sym_uR_DQUOTE] = ACTIONS(3389),
    [anon_sym_UR_DQUOTE] = ACTIONS(3389),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3389),
    [anon_sym_co_await] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_requires] = ACTIONS(3387),
    [sym_this] = ACTIONS(3387),
  },
  [422] = {
    [sym_identifier] = ACTIONS(3391),
    [aux_sym_preproc_include_token1] = ACTIONS(3391),
    [aux_sym_preproc_def_token1] = ACTIONS(3391),
    [aux_sym_preproc_if_token1] = ACTIONS(3391),
    [aux_sym_preproc_if_token2] = ACTIONS(3391),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3391),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3391),
    [aux_sym_preproc_else_token1] = ACTIONS(3391),
    [aux_sym_preproc_elif_token1] = ACTIONS(3391),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3391),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3391),
    [sym_preproc_directive] = ACTIONS(3391),
    [anon_sym_LPAREN2] = ACTIONS(3393),
    [anon_sym_BANG] = ACTIONS(3393),
    [anon_sym_TILDE] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_STAR] = ACTIONS(3393),
    [anon_sym_AMP_AMP] = ACTIONS(3393),
    [anon_sym_AMP] = ACTIONS(3391),
    [anon_sym_SEMI] = ACTIONS(3393),
    [anon_sym___extension__] = ACTIONS(3391),
    [anon_sym_typedef] = ACTIONS(3391),
    [anon_sym_extern] = ACTIONS(3391),
    [anon_sym___attribute__] = ACTIONS(3391),
    [anon_sym_COLON_COLON] = ACTIONS(3393),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3393),
    [anon_sym___declspec] = ACTIONS(3391),
    [anon_sym___based] = ACTIONS(3391),
    [anon_sym___cdecl] = ACTIONS(3391),
    [anon_sym___clrcall] = ACTIONS(3391),
    [anon_sym___stdcall] = ACTIONS(3391),
    [anon_sym___fastcall] = ACTIONS(3391),
    [anon_sym___thiscall] = ACTIONS(3391),
    [anon_sym___vectorcall] = ACTIONS(3391),
    [anon_sym_LBRACE] = ACTIONS(3393),
    [anon_sym_signed] = ACTIONS(3391),
    [anon_sym_unsigned] = ACTIONS(3391),
    [anon_sym_long] = ACTIONS(3391),
    [anon_sym_short] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(3391),
    [anon_sym_static] = ACTIONS(3391),
    [anon_sym_register] = ACTIONS(3391),
    [anon_sym_inline] = ACTIONS(3391),
    [anon_sym___inline] = ACTIONS(3391),
    [anon_sym___inline__] = ACTIONS(3391),
    [anon_sym___forceinline] = ACTIONS(3391),
    [anon_sym_thread_local] = ACTIONS(3391),
    [anon_sym___thread] = ACTIONS(3391),
    [anon_sym_const] = ACTIONS(3391),
    [anon_sym_constexpr] = ACTIONS(3391),
    [anon_sym_volatile] = ACTIONS(3391),
    [anon_sym_restrict] = ACTIONS(3391),
    [anon_sym___restrict__] = ACTIONS(3391),
    [anon_sym__Atomic] = ACTIONS(3391),
    [anon_sym__Noreturn] = ACTIONS(3391),
    [anon_sym_noreturn] = ACTIONS(3391),
    [anon_sym_mutable] = ACTIONS(3391),
    [anon_sym_constinit] = ACTIONS(3391),
    [anon_sym_consteval] = ACTIONS(3391),
    [anon_sym_PROGMEM] = ACTIONS(3391),
    [aux_sym_primitive_type_token1] = ACTIONS(3391),
    [anon_sym_byte] = ACTIONS(3391),
    [anon_sym_word] = ACTIONS(3391),
    [anon_sym_enum] = ACTIONS(3391),
    [anon_sym_class] = ACTIONS(3391),
    [anon_sym_struct] = ACTIONS(3391),
    [anon_sym_union] = ACTIONS(3391),
    [anon_sym_if] = ACTIONS(3391),
    [anon_sym_switch] = ACTIONS(3391),
    [anon_sym_case] = ACTIONS(3391),
    [anon_sym_default] = ACTIONS(3391),
    [anon_sym_while] = ACTIONS(3391),
    [anon_sym_do] = ACTIONS(3391),
    [anon_sym_for] = ACTIONS(3391),
    [anon_sym_return] = ACTIONS(3391),
    [anon_sym_break] = ACTIONS(3391),
    [anon_sym_continue] = ACTIONS(3391),
    [anon_sym_goto] = ACTIONS(3391),
    [anon_sym___try] = ACTIONS(3391),
    [anon_sym___leave] = ACTIONS(3391),
    [anon_sym_not] = ACTIONS(3391),
    [anon_sym_compl] = ACTIONS(3391),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_sizeof] = ACTIONS(3391),
    [anon_sym___alignof__] = ACTIONS(3391),
    [anon_sym___alignof] = ACTIONS(3391),
    [anon_sym__alignof] = ACTIONS(3391),
    [anon_sym_alignof] = ACTIONS(3391),
    [anon_sym__Alignof] = ACTIONS(3391),
    [anon_sym_offsetof] = ACTIONS(3391),
    [anon_sym__Generic] = ACTIONS(3391),
    [anon_sym_asm] = ACTIONS(3391),
    [anon_sym___asm__] = ACTIONS(3391),
    [aux_sym_number_literal_token1] = ACTIONS(3393),
    [aux_sym_number_literal_token2] = ACTIONS(3391),
    [anon_sym_L_SQUOTE] = ACTIONS(3393),
    [anon_sym_u_SQUOTE] = ACTIONS(3393),
    [anon_sym_U_SQUOTE] = ACTIONS(3393),
    [anon_sym_u8_SQUOTE] = ACTIONS(3393),
    [anon_sym_SQUOTE] = ACTIONS(3393),
    [anon_sym_L_DQUOTE] = ACTIONS(3393),
    [anon_sym_u_DQUOTE] = ACTIONS(3393),
    [anon_sym_U_DQUOTE] = ACTIONS(3393),
    [anon_sym_u8_DQUOTE] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3393),
    [sym_true] = ACTIONS(3391),
    [sym_false] = ACTIONS(3391),
    [anon_sym_NULL] = ACTIONS(3391),
    [anon_sym_nullptr] = ACTIONS(3391),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3391),
    [anon_sym_decltype] = ACTIONS(3391),
    [anon_sym_virtual] = ACTIONS(3391),
    [anon_sym_alignas] = ACTIONS(3391),
    [anon_sym_explicit] = ACTIONS(3391),
    [anon_sym_typename] = ACTIONS(3391),
    [anon_sym_template] = ACTIONS(3391),
    [anon_sym_operator] = ACTIONS(3391),
    [anon_sym_try] = ACTIONS(3391),
    [anon_sym_delete] = ACTIONS(3391),
    [anon_sym_throw] = ACTIONS(3391),
    [anon_sym_namespace] = ACTIONS(3391),
    [anon_sym_using] = ACTIONS(3391),
    [anon_sym_static_assert] = ACTIONS(3391),
    [anon_sym_concept] = ACTIONS(3391),
    [anon_sym_co_return] = ACTIONS(3391),
    [anon_sym_co_yield] = ACTIONS(3391),
    [anon_sym_R_DQUOTE] = ACTIONS(3393),
    [anon_sym_LR_DQUOTE] = ACTIONS(3393),
    [anon_sym_uR_DQUOTE] = ACTIONS(3393),
    [anon_sym_UR_DQUOTE] = ACTIONS(3393),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3393),
    [anon_sym_co_await] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(3391),
    [anon_sym_requires] = ACTIONS(3391),
    [sym_this] = ACTIONS(3391),
  },
  [423] = {
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_unaligned_ptr_modifier] = STATE(4993),
    [sym_ms_pointer_modifier] = STATE(3988),
    [sym__declarator] = STATE(7255),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7008),
    [sym_array_declarator] = STATE(7008),
    [sym_type_qualifier] = STATE(4764),
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3820),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6474),
    [sym_qualified_identifier] = STATE(3890),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(4059),
    [aux_sym__type_definition_type_repeat1] = STATE(4764),
    [aux_sym_pointer_declarator_repeat1] = STATE(3988),
    [sym_identifier] = ACTIONS(3395),
    [anon_sym_LPAREN2] = ACTIONS(2077),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2085),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2087),
    [anon_sym___extension__] = ACTIONS(3397),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym___based] = ACTIONS(47),
    [sym_ms_restrict_modifier] = ACTIONS(3399),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3399),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3399),
    [anon_sym__unaligned] = ACTIONS(3401),
    [anon_sym___unaligned] = ACTIONS(3401),
    [anon_sym_LBRACK] = ACTIONS(2095),
    [anon_sym_const] = ACTIONS(3397),
    [anon_sym_constexpr] = ACTIONS(3397),
    [anon_sym_volatile] = ACTIONS(3397),
    [anon_sym_restrict] = ACTIONS(3397),
    [anon_sym___restrict__] = ACTIONS(3397),
    [anon_sym__Atomic] = ACTIONS(3397),
    [anon_sym__Noreturn] = ACTIONS(3397),
    [anon_sym_noreturn] = ACTIONS(3397),
    [anon_sym_mutable] = ACTIONS(3397),
    [anon_sym_constinit] = ACTIONS(3397),
    [anon_sym_consteval] = ACTIONS(3397),
    [anon_sym_PROGMEM] = ACTIONS(3397),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(2137),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [424] = {
    [sym_identifier] = ACTIONS(3403),
    [aux_sym_preproc_include_token1] = ACTIONS(3403),
    [aux_sym_preproc_def_token1] = ACTIONS(3403),
    [aux_sym_preproc_if_token1] = ACTIONS(3403),
    [aux_sym_preproc_if_token2] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3403),
    [aux_sym_preproc_else_token1] = ACTIONS(3403),
    [aux_sym_preproc_elif_token1] = ACTIONS(3403),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3403),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3403),
    [sym_preproc_directive] = ACTIONS(3403),
    [anon_sym_LPAREN2] = ACTIONS(3405),
    [anon_sym_BANG] = ACTIONS(3405),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_DASH] = ACTIONS(3403),
    [anon_sym_PLUS] = ACTIONS(3403),
    [anon_sym_STAR] = ACTIONS(3405),
    [anon_sym_AMP_AMP] = ACTIONS(3405),
    [anon_sym_AMP] = ACTIONS(3403),
    [anon_sym_SEMI] = ACTIONS(3405),
    [anon_sym___extension__] = ACTIONS(3403),
    [anon_sym_typedef] = ACTIONS(3403),
    [anon_sym_extern] = ACTIONS(3403),
    [anon_sym___attribute__] = ACTIONS(3403),
    [anon_sym_COLON_COLON] = ACTIONS(3405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3405),
    [anon_sym___declspec] = ACTIONS(3403),
    [anon_sym___based] = ACTIONS(3403),
    [anon_sym___cdecl] = ACTIONS(3403),
    [anon_sym___clrcall] = ACTIONS(3403),
    [anon_sym___stdcall] = ACTIONS(3403),
    [anon_sym___fastcall] = ACTIONS(3403),
    [anon_sym___thiscall] = ACTIONS(3403),
    [anon_sym___vectorcall] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3405),
    [anon_sym_signed] = ACTIONS(3403),
    [anon_sym_unsigned] = ACTIONS(3403),
    [anon_sym_long] = ACTIONS(3403),
    [anon_sym_short] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3403),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_register] = ACTIONS(3403),
    [anon_sym_inline] = ACTIONS(3403),
    [anon_sym___inline] = ACTIONS(3403),
    [anon_sym___inline__] = ACTIONS(3403),
    [anon_sym___forceinline] = ACTIONS(3403),
    [anon_sym_thread_local] = ACTIONS(3403),
    [anon_sym___thread] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_constexpr] = ACTIONS(3403),
    [anon_sym_volatile] = ACTIONS(3403),
    [anon_sym_restrict] = ACTIONS(3403),
    [anon_sym___restrict__] = ACTIONS(3403),
    [anon_sym__Atomic] = ACTIONS(3403),
    [anon_sym__Noreturn] = ACTIONS(3403),
    [anon_sym_noreturn] = ACTIONS(3403),
    [anon_sym_mutable] = ACTIONS(3403),
    [anon_sym_constinit] = ACTIONS(3403),
    [anon_sym_consteval] = ACTIONS(3403),
    [anon_sym_PROGMEM] = ACTIONS(3403),
    [aux_sym_primitive_type_token1] = ACTIONS(3403),
    [anon_sym_byte] = ACTIONS(3403),
    [anon_sym_word] = ACTIONS(3403),
    [anon_sym_enum] = ACTIONS(3403),
    [anon_sym_class] = ACTIONS(3403),
    [anon_sym_struct] = ACTIONS(3403),
    [anon_sym_union] = ACTIONS(3403),
    [anon_sym_if] = ACTIONS(3403),
    [anon_sym_switch] = ACTIONS(3403),
    [anon_sym_case] = ACTIONS(3403),
    [anon_sym_default] = ACTIONS(3403),
    [anon_sym_while] = ACTIONS(3403),
    [anon_sym_do] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3403),
    [anon_sym_return] = ACTIONS(3403),
    [anon_sym_break] = ACTIONS(3403),
    [anon_sym_continue] = ACTIONS(3403),
    [anon_sym_goto] = ACTIONS(3403),
    [anon_sym___try] = ACTIONS(3403),
    [anon_sym___leave] = ACTIONS(3403),
    [anon_sym_not] = ACTIONS(3403),
    [anon_sym_compl] = ACTIONS(3403),
    [anon_sym_DASH_DASH] = ACTIONS(3405),
    [anon_sym_PLUS_PLUS] = ACTIONS(3405),
    [anon_sym_sizeof] = ACTIONS(3403),
    [anon_sym___alignof__] = ACTIONS(3403),
    [anon_sym___alignof] = ACTIONS(3403),
    [anon_sym__alignof] = ACTIONS(3403),
    [anon_sym_alignof] = ACTIONS(3403),
    [anon_sym__Alignof] = ACTIONS(3403),
    [anon_sym_offsetof] = ACTIONS(3403),
    [anon_sym__Generic] = ACTIONS(3403),
    [anon_sym_asm] = ACTIONS(3403),
    [anon_sym___asm__] = ACTIONS(3403),
    [aux_sym_number_literal_token1] = ACTIONS(3405),
    [aux_sym_number_literal_token2] = ACTIONS(3403),
    [anon_sym_L_SQUOTE] = ACTIONS(3405),
    [anon_sym_u_SQUOTE] = ACTIONS(3405),
    [anon_sym_U_SQUOTE] = ACTIONS(3405),
    [anon_sym_u8_SQUOTE] = ACTIONS(3405),
    [anon_sym_SQUOTE] = ACTIONS(3405),
    [anon_sym_L_DQUOTE] = ACTIONS(3405),
    [anon_sym_u_DQUOTE] = ACTIONS(3405),
    [anon_sym_U_DQUOTE] = ACTIONS(3405),
    [anon_sym_u8_DQUOTE] = ACTIONS(3405),
    [anon_sym_DQUOTE] = ACTIONS(3405),
    [sym_true] = ACTIONS(3403),
    [sym_false] = ACTIONS(3403),
    [anon_sym_NULL] = ACTIONS(3403),
    [anon_sym_nullptr] = ACTIONS(3403),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3403),
    [anon_sym_decltype] = ACTIONS(3403),
    [anon_sym_virtual] = ACTIONS(3403),
    [anon_sym_alignas] = ACTIONS(3403),
    [anon_sym_explicit] = ACTIONS(3403),
    [anon_sym_typename] = ACTIONS(3403),
    [anon_sym_template] = ACTIONS(3403),
    [anon_sym_operator] = ACTIONS(3403),
    [anon_sym_try] = ACTIONS(3403),
    [anon_sym_delete] = ACTIONS(3403),
    [anon_sym_throw] = ACTIONS(3403),
    [anon_sym_namespace] = ACTIONS(3403),
    [anon_sym_using] = ACTIONS(3403),
    [anon_sym_static_assert] = ACTIONS(3403),
    [anon_sym_concept] = ACTIONS(3403),
    [anon_sym_co_return] = ACTIONS(3403),
    [anon_sym_co_yield] = ACTIONS(3403),
    [anon_sym_R_DQUOTE] = ACTIONS(3405),
    [anon_sym_LR_DQUOTE] = ACTIONS(3405),
    [anon_sym_uR_DQUOTE] = ACTIONS(3405),
    [anon_sym_UR_DQUOTE] = ACTIONS(3405),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3405),
    [anon_sym_co_await] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3403),
    [anon_sym_requires] = ACTIONS(3403),
    [sym_this] = ACTIONS(3403),
  },
  [425] = {
    [sym_identifier] = ACTIONS(3407),
    [aux_sym_preproc_include_token1] = ACTIONS(3407),
    [aux_sym_preproc_def_token1] = ACTIONS(3407),
    [aux_sym_preproc_if_token1] = ACTIONS(3407),
    [aux_sym_preproc_if_token2] = ACTIONS(3407),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3407),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3407),
    [aux_sym_preproc_else_token1] = ACTIONS(3407),
    [aux_sym_preproc_elif_token1] = ACTIONS(3407),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3407),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3407),
    [sym_preproc_directive] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3409),
    [anon_sym_TILDE] = ACTIONS(3409),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_AMP_AMP] = ACTIONS(3409),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_SEMI] = ACTIONS(3409),
    [anon_sym___extension__] = ACTIONS(3407),
    [anon_sym_typedef] = ACTIONS(3407),
    [anon_sym_extern] = ACTIONS(3407),
    [anon_sym___attribute__] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3409),
    [anon_sym___declspec] = ACTIONS(3407),
    [anon_sym___based] = ACTIONS(3407),
    [anon_sym___cdecl] = ACTIONS(3407),
    [anon_sym___clrcall] = ACTIONS(3407),
    [anon_sym___stdcall] = ACTIONS(3407),
    [anon_sym___fastcall] = ACTIONS(3407),
    [anon_sym___thiscall] = ACTIONS(3407),
    [anon_sym___vectorcall] = ACTIONS(3407),
    [anon_sym_LBRACE] = ACTIONS(3409),
    [anon_sym_signed] = ACTIONS(3407),
    [anon_sym_unsigned] = ACTIONS(3407),
    [anon_sym_long] = ACTIONS(3407),
    [anon_sym_short] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_register] = ACTIONS(3407),
    [anon_sym_inline] = ACTIONS(3407),
    [anon_sym___inline] = ACTIONS(3407),
    [anon_sym___inline__] = ACTIONS(3407),
    [anon_sym___forceinline] = ACTIONS(3407),
    [anon_sym_thread_local] = ACTIONS(3407),
    [anon_sym___thread] = ACTIONS(3407),
    [anon_sym_const] = ACTIONS(3407),
    [anon_sym_constexpr] = ACTIONS(3407),
    [anon_sym_volatile] = ACTIONS(3407),
    [anon_sym_restrict] = ACTIONS(3407),
    [anon_sym___restrict__] = ACTIONS(3407),
    [anon_sym__Atomic] = ACTIONS(3407),
    [anon_sym__Noreturn] = ACTIONS(3407),
    [anon_sym_noreturn] = ACTIONS(3407),
    [anon_sym_mutable] = ACTIONS(3407),
    [anon_sym_constinit] = ACTIONS(3407),
    [anon_sym_consteval] = ACTIONS(3407),
    [anon_sym_PROGMEM] = ACTIONS(3407),
    [aux_sym_primitive_type_token1] = ACTIONS(3407),
    [anon_sym_byte] = ACTIONS(3407),
    [anon_sym_word] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3407),
    [anon_sym_class] = ACTIONS(3407),
    [anon_sym_struct] = ACTIONS(3407),
    [anon_sym_union] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_switch] = ACTIONS(3407),
    [anon_sym_case] = ACTIONS(3407),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_break] = ACTIONS(3407),
    [anon_sym_continue] = ACTIONS(3407),
    [anon_sym_goto] = ACTIONS(3407),
    [anon_sym___try] = ACTIONS(3407),
    [anon_sym___leave] = ACTIONS(3407),
    [anon_sym_not] = ACTIONS(3407),
    [anon_sym_compl] = ACTIONS(3407),
    [anon_sym_DASH_DASH] = ACTIONS(3409),
    [anon_sym_PLUS_PLUS] = ACTIONS(3409),
    [anon_sym_sizeof] = ACTIONS(3407),
    [anon_sym___alignof__] = ACTIONS(3407),
    [anon_sym___alignof] = ACTIONS(3407),
    [anon_sym__alignof] = ACTIONS(3407),
    [anon_sym_alignof] = ACTIONS(3407),
    [anon_sym__Alignof] = ACTIONS(3407),
    [anon_sym_offsetof] = ACTIONS(3407),
    [anon_sym__Generic] = ACTIONS(3407),
    [anon_sym_asm] = ACTIONS(3407),
    [anon_sym___asm__] = ACTIONS(3407),
    [aux_sym_number_literal_token1] = ACTIONS(3409),
    [aux_sym_number_literal_token2] = ACTIONS(3407),
    [anon_sym_L_SQUOTE] = ACTIONS(3409),
    [anon_sym_u_SQUOTE] = ACTIONS(3409),
    [anon_sym_U_SQUOTE] = ACTIONS(3409),
    [anon_sym_u8_SQUOTE] = ACTIONS(3409),
    [anon_sym_SQUOTE] = ACTIONS(3409),
    [anon_sym_L_DQUOTE] = ACTIONS(3409),
    [anon_sym_u_DQUOTE] = ACTIONS(3409),
    [anon_sym_U_DQUOTE] = ACTIONS(3409),
    [anon_sym_u8_DQUOTE] = ACTIONS(3409),
    [anon_sym_DQUOTE] = ACTIONS(3409),
    [sym_true] = ACTIONS(3407),
    [sym_false] = ACTIONS(3407),
    [anon_sym_NULL] = ACTIONS(3407),
    [anon_sym_nullptr] = ACTIONS(3407),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3407),
    [anon_sym_decltype] = ACTIONS(3407),
    [anon_sym_virtual] = ACTIONS(3407),
    [anon_sym_alignas] = ACTIONS(3407),
    [anon_sym_explicit] = ACTIONS(3407),
    [anon_sym_typename] = ACTIONS(3407),
    [anon_sym_template] = ACTIONS(3407),
    [anon_sym_operator] = ACTIONS(3407),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_delete] = ACTIONS(3407),
    [anon_sym_throw] = ACTIONS(3407),
    [anon_sym_namespace] = ACTIONS(3407),
    [anon_sym_using] = ACTIONS(3407),
    [anon_sym_static_assert] = ACTIONS(3407),
    [anon_sym_concept] = ACTIONS(3407),
    [anon_sym_co_return] = ACTIONS(3407),
    [anon_sym_co_yield] = ACTIONS(3407),
    [anon_sym_R_DQUOTE] = ACTIONS(3409),
    [anon_sym_LR_DQUOTE] = ACTIONS(3409),
    [anon_sym_uR_DQUOTE] = ACTIONS(3409),
    [anon_sym_UR_DQUOTE] = ACTIONS(3409),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3409),
    [anon_sym_co_await] = ACTIONS(3407),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_requires] = ACTIONS(3407),
    [sym_this] = ACTIONS(3407),
  },
  [426] = {
    [sym_identifier] = ACTIONS(3411),
    [aux_sym_preproc_include_token1] = ACTIONS(3411),
    [aux_sym_preproc_def_token1] = ACTIONS(3411),
    [aux_sym_preproc_if_token1] = ACTIONS(3411),
    [aux_sym_preproc_if_token2] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3411),
    [aux_sym_preproc_else_token1] = ACTIONS(3411),
    [aux_sym_preproc_elif_token1] = ACTIONS(3411),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3411),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3411),
    [sym_preproc_directive] = ACTIONS(3411),
    [anon_sym_LPAREN2] = ACTIONS(3413),
    [anon_sym_BANG] = ACTIONS(3413),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_DASH] = ACTIONS(3411),
    [anon_sym_PLUS] = ACTIONS(3411),
    [anon_sym_STAR] = ACTIONS(3413),
    [anon_sym_AMP_AMP] = ACTIONS(3413),
    [anon_sym_AMP] = ACTIONS(3411),
    [anon_sym_SEMI] = ACTIONS(3413),
    [anon_sym___extension__] = ACTIONS(3411),
    [anon_sym_typedef] = ACTIONS(3411),
    [anon_sym_extern] = ACTIONS(3411),
    [anon_sym___attribute__] = ACTIONS(3411),
    [anon_sym_COLON_COLON] = ACTIONS(3413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3413),
    [anon_sym___declspec] = ACTIONS(3411),
    [anon_sym___based] = ACTIONS(3411),
    [anon_sym___cdecl] = ACTIONS(3411),
    [anon_sym___clrcall] = ACTIONS(3411),
    [anon_sym___stdcall] = ACTIONS(3411),
    [anon_sym___fastcall] = ACTIONS(3411),
    [anon_sym___thiscall] = ACTIONS(3411),
    [anon_sym___vectorcall] = ACTIONS(3411),
    [anon_sym_LBRACE] = ACTIONS(3413),
    [anon_sym_signed] = ACTIONS(3411),
    [anon_sym_unsigned] = ACTIONS(3411),
    [anon_sym_long] = ACTIONS(3411),
    [anon_sym_short] = ACTIONS(3411),
    [anon_sym_LBRACK] = ACTIONS(3411),
    [anon_sym_static] = ACTIONS(3411),
    [anon_sym_register] = ACTIONS(3411),
    [anon_sym_inline] = ACTIONS(3411),
    [anon_sym___inline] = ACTIONS(3411),
    [anon_sym___inline__] = ACTIONS(3411),
    [anon_sym___forceinline] = ACTIONS(3411),
    [anon_sym_thread_local] = ACTIONS(3411),
    [anon_sym___thread] = ACTIONS(3411),
    [anon_sym_const] = ACTIONS(3411),
    [anon_sym_constexpr] = ACTIONS(3411),
    [anon_sym_volatile] = ACTIONS(3411),
    [anon_sym_restrict] = ACTIONS(3411),
    [anon_sym___restrict__] = ACTIONS(3411),
    [anon_sym__Atomic] = ACTIONS(3411),
    [anon_sym__Noreturn] = ACTIONS(3411),
    [anon_sym_noreturn] = ACTIONS(3411),
    [anon_sym_mutable] = ACTIONS(3411),
    [anon_sym_constinit] = ACTIONS(3411),
    [anon_sym_consteval] = ACTIONS(3411),
    [anon_sym_PROGMEM] = ACTIONS(3411),
    [aux_sym_primitive_type_token1] = ACTIONS(3411),
    [anon_sym_byte] = ACTIONS(3411),
    [anon_sym_word] = ACTIONS(3411),
    [anon_sym_enum] = ACTIONS(3411),
    [anon_sym_class] = ACTIONS(3411),
    [anon_sym_struct] = ACTIONS(3411),
    [anon_sym_union] = ACTIONS(3411),
    [anon_sym_if] = ACTIONS(3411),
    [anon_sym_switch] = ACTIONS(3411),
    [anon_sym_case] = ACTIONS(3411),
    [anon_sym_default] = ACTIONS(3411),
    [anon_sym_while] = ACTIONS(3411),
    [anon_sym_do] = ACTIONS(3411),
    [anon_sym_for] = ACTIONS(3411),
    [anon_sym_return] = ACTIONS(3411),
    [anon_sym_break] = ACTIONS(3411),
    [anon_sym_continue] = ACTIONS(3411),
    [anon_sym_goto] = ACTIONS(3411),
    [anon_sym___try] = ACTIONS(3411),
    [anon_sym___leave] = ACTIONS(3411),
    [anon_sym_not] = ACTIONS(3411),
    [anon_sym_compl] = ACTIONS(3411),
    [anon_sym_DASH_DASH] = ACTIONS(3413),
    [anon_sym_PLUS_PLUS] = ACTIONS(3413),
    [anon_sym_sizeof] = ACTIONS(3411),
    [anon_sym___alignof__] = ACTIONS(3411),
    [anon_sym___alignof] = ACTIONS(3411),
    [anon_sym__alignof] = ACTIONS(3411),
    [anon_sym_alignof] = ACTIONS(3411),
    [anon_sym__Alignof] = ACTIONS(3411),
    [anon_sym_offsetof] = ACTIONS(3411),
    [anon_sym__Generic] = ACTIONS(3411),
    [anon_sym_asm] = ACTIONS(3411),
    [anon_sym___asm__] = ACTIONS(3411),
    [aux_sym_number_literal_token1] = ACTIONS(3413),
    [aux_sym_number_literal_token2] = ACTIONS(3411),
    [anon_sym_L_SQUOTE] = ACTIONS(3413),
    [anon_sym_u_SQUOTE] = ACTIONS(3413),
    [anon_sym_U_SQUOTE] = ACTIONS(3413),
    [anon_sym_u8_SQUOTE] = ACTIONS(3413),
    [anon_sym_SQUOTE] = ACTIONS(3413),
    [anon_sym_L_DQUOTE] = ACTIONS(3413),
    [anon_sym_u_DQUOTE] = ACTIONS(3413),
    [anon_sym_U_DQUOTE] = ACTIONS(3413),
    [anon_sym_u8_DQUOTE] = ACTIONS(3413),
    [anon_sym_DQUOTE] = ACTIONS(3413),
    [sym_true] = ACTIONS(3411),
    [sym_false] = ACTIONS(3411),
    [anon_sym_NULL] = ACTIONS(3411),
    [anon_sym_nullptr] = ACTIONS(3411),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3411),
    [anon_sym_decltype] = ACTIONS(3411),
    [anon_sym_virtual] = ACTIONS(3411),
    [anon_sym_alignas] = ACTIONS(3411),
    [anon_sym_explicit] = ACTIONS(3411),
    [anon_sym_typename] = ACTIONS(3411),
    [anon_sym_template] = ACTIONS(3411),
    [anon_sym_operator] = ACTIONS(3411),
    [anon_sym_try] = ACTIONS(3411),
    [anon_sym_delete] = ACTIONS(3411),
    [anon_sym_throw] = ACTIONS(3411),
    [anon_sym_namespace] = ACTIONS(3411),
    [anon_sym_using] = ACTIONS(3411),
    [anon_sym_static_assert] = ACTIONS(3411),
    [anon_sym_concept] = ACTIONS(3411),
    [anon_sym_co_return] = ACTIONS(3411),
    [anon_sym_co_yield] = ACTIONS(3411),
    [anon_sym_R_DQUOTE] = ACTIONS(3413),
    [anon_sym_LR_DQUOTE] = ACTIONS(3413),
    [anon_sym_uR_DQUOTE] = ACTIONS(3413),
    [anon_sym_UR_DQUOTE] = ACTIONS(3413),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3413),
    [anon_sym_co_await] = ACTIONS(3411),
    [anon_sym_new] = ACTIONS(3411),
    [anon_sym_requires] = ACTIONS(3411),
    [sym_this] = ACTIONS(3411),
  },
  [427] = {
    [sym_identifier] = ACTIONS(3415),
    [aux_sym_preproc_include_token1] = ACTIONS(3415),
    [aux_sym_preproc_def_token1] = ACTIONS(3415),
    [aux_sym_preproc_if_token1] = ACTIONS(3415),
    [aux_sym_preproc_if_token2] = ACTIONS(3415),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3415),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3415),
    [aux_sym_preproc_else_token1] = ACTIONS(3415),
    [aux_sym_preproc_elif_token1] = ACTIONS(3415),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3415),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3415),
    [sym_preproc_directive] = ACTIONS(3415),
    [anon_sym_LPAREN2] = ACTIONS(3417),
    [anon_sym_BANG] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_STAR] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3417),
    [anon_sym___extension__] = ACTIONS(3415),
    [anon_sym_typedef] = ACTIONS(3415),
    [anon_sym_extern] = ACTIONS(3415),
    [anon_sym___attribute__] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3417),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3417),
    [anon_sym___declspec] = ACTIONS(3415),
    [anon_sym___based] = ACTIONS(3415),
    [anon_sym___cdecl] = ACTIONS(3415),
    [anon_sym___clrcall] = ACTIONS(3415),
    [anon_sym___stdcall] = ACTIONS(3415),
    [anon_sym___fastcall] = ACTIONS(3415),
    [anon_sym___thiscall] = ACTIONS(3415),
    [anon_sym___vectorcall] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_signed] = ACTIONS(3415),
    [anon_sym_unsigned] = ACTIONS(3415),
    [anon_sym_long] = ACTIONS(3415),
    [anon_sym_short] = ACTIONS(3415),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_static] = ACTIONS(3415),
    [anon_sym_register] = ACTIONS(3415),
    [anon_sym_inline] = ACTIONS(3415),
    [anon_sym___inline] = ACTIONS(3415),
    [anon_sym___inline__] = ACTIONS(3415),
    [anon_sym___forceinline] = ACTIONS(3415),
    [anon_sym_thread_local] = ACTIONS(3415),
    [anon_sym___thread] = ACTIONS(3415),
    [anon_sym_const] = ACTIONS(3415),
    [anon_sym_constexpr] = ACTIONS(3415),
    [anon_sym_volatile] = ACTIONS(3415),
    [anon_sym_restrict] = ACTIONS(3415),
    [anon_sym___restrict__] = ACTIONS(3415),
    [anon_sym__Atomic] = ACTIONS(3415),
    [anon_sym__Noreturn] = ACTIONS(3415),
    [anon_sym_noreturn] = ACTIONS(3415),
    [anon_sym_mutable] = ACTIONS(3415),
    [anon_sym_constinit] = ACTIONS(3415),
    [anon_sym_consteval] = ACTIONS(3415),
    [anon_sym_PROGMEM] = ACTIONS(3415),
    [aux_sym_primitive_type_token1] = ACTIONS(3415),
    [anon_sym_byte] = ACTIONS(3415),
    [anon_sym_word] = ACTIONS(3415),
    [anon_sym_enum] = ACTIONS(3415),
    [anon_sym_class] = ACTIONS(3415),
    [anon_sym_struct] = ACTIONS(3415),
    [anon_sym_union] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_switch] = ACTIONS(3415),
    [anon_sym_case] = ACTIONS(3415),
    [anon_sym_default] = ACTIONS(3415),
    [anon_sym_while] = ACTIONS(3415),
    [anon_sym_do] = ACTIONS(3415),
    [anon_sym_for] = ACTIONS(3415),
    [anon_sym_return] = ACTIONS(3415),
    [anon_sym_break] = ACTIONS(3415),
    [anon_sym_continue] = ACTIONS(3415),
    [anon_sym_goto] = ACTIONS(3415),
    [anon_sym___try] = ACTIONS(3415),
    [anon_sym___leave] = ACTIONS(3415),
    [anon_sym_not] = ACTIONS(3415),
    [anon_sym_compl] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3415),
    [anon_sym___alignof__] = ACTIONS(3415),
    [anon_sym___alignof] = ACTIONS(3415),
    [anon_sym__alignof] = ACTIONS(3415),
    [anon_sym_alignof] = ACTIONS(3415),
    [anon_sym__Alignof] = ACTIONS(3415),
    [anon_sym_offsetof] = ACTIONS(3415),
    [anon_sym__Generic] = ACTIONS(3415),
    [anon_sym_asm] = ACTIONS(3415),
    [anon_sym___asm__] = ACTIONS(3415),
    [aux_sym_number_literal_token1] = ACTIONS(3417),
    [aux_sym_number_literal_token2] = ACTIONS(3415),
    [anon_sym_L_SQUOTE] = ACTIONS(3417),
    [anon_sym_u_SQUOTE] = ACTIONS(3417),
    [anon_sym_U_SQUOTE] = ACTIONS(3417),
    [anon_sym_u8_SQUOTE] = ACTIONS(3417),
    [anon_sym_SQUOTE] = ACTIONS(3417),
    [anon_sym_L_DQUOTE] = ACTIONS(3417),
    [anon_sym_u_DQUOTE] = ACTIONS(3417),
    [anon_sym_U_DQUOTE] = ACTIONS(3417),
    [anon_sym_u8_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [sym_true] = ACTIONS(3415),
    [sym_false] = ACTIONS(3415),
    [anon_sym_NULL] = ACTIONS(3415),
    [anon_sym_nullptr] = ACTIONS(3415),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3415),
    [anon_sym_decltype] = ACTIONS(3415),
    [anon_sym_virtual] = ACTIONS(3415),
    [anon_sym_alignas] = ACTIONS(3415),
    [anon_sym_explicit] = ACTIONS(3415),
    [anon_sym_typename] = ACTIONS(3415),
    [anon_sym_template] = ACTIONS(3415),
    [anon_sym_operator] = ACTIONS(3415),
    [anon_sym_try] = ACTIONS(3415),
    [anon_sym_delete] = ACTIONS(3415),
    [anon_sym_throw] = ACTIONS(3415),
    [anon_sym_namespace] = ACTIONS(3415),
    [anon_sym_using] = ACTIONS(3415),
    [anon_sym_static_assert] = ACTIONS(3415),
    [anon_sym_concept] = ACTIONS(3415),
    [anon_sym_co_return] = ACTIONS(3415),
    [anon_sym_co_yield] = ACTIONS(3415),
    [anon_sym_R_DQUOTE] = ACTIONS(3417),
    [anon_sym_LR_DQUOTE] = ACTIONS(3417),
    [anon_sym_uR_DQUOTE] = ACTIONS(3417),
    [anon_sym_UR_DQUOTE] = ACTIONS(3417),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3417),
    [anon_sym_co_await] = ACTIONS(3415),
    [anon_sym_new] = ACTIONS(3415),
    [anon_sym_requires] = ACTIONS(3415),
    [sym_this] = ACTIONS(3415),
  },
  [428] = {
    [sym_identifier] = ACTIONS(3419),
    [aux_sym_preproc_include_token1] = ACTIONS(3419),
    [aux_sym_preproc_def_token1] = ACTIONS(3419),
    [aux_sym_preproc_if_token1] = ACTIONS(3419),
    [aux_sym_preproc_if_token2] = ACTIONS(3419),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3419),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3419),
    [aux_sym_preproc_else_token1] = ACTIONS(3419),
    [aux_sym_preproc_elif_token1] = ACTIONS(3419),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3419),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3419),
    [sym_preproc_directive] = ACTIONS(3419),
    [anon_sym_LPAREN2] = ACTIONS(3421),
    [anon_sym_BANG] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_SEMI] = ACTIONS(3421),
    [anon_sym___extension__] = ACTIONS(3419),
    [anon_sym_typedef] = ACTIONS(3419),
    [anon_sym_extern] = ACTIONS(3419),
    [anon_sym___attribute__] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3421),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3421),
    [anon_sym___declspec] = ACTIONS(3419),
    [anon_sym___based] = ACTIONS(3419),
    [anon_sym___cdecl] = ACTIONS(3419),
    [anon_sym___clrcall] = ACTIONS(3419),
    [anon_sym___stdcall] = ACTIONS(3419),
    [anon_sym___fastcall] = ACTIONS(3419),
    [anon_sym___thiscall] = ACTIONS(3419),
    [anon_sym___vectorcall] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_signed] = ACTIONS(3419),
    [anon_sym_unsigned] = ACTIONS(3419),
    [anon_sym_long] = ACTIONS(3419),
    [anon_sym_short] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_register] = ACTIONS(3419),
    [anon_sym_inline] = ACTIONS(3419),
    [anon_sym___inline] = ACTIONS(3419),
    [anon_sym___inline__] = ACTIONS(3419),
    [anon_sym___forceinline] = ACTIONS(3419),
    [anon_sym_thread_local] = ACTIONS(3419),
    [anon_sym___thread] = ACTIONS(3419),
    [anon_sym_const] = ACTIONS(3419),
    [anon_sym_constexpr] = ACTIONS(3419),
    [anon_sym_volatile] = ACTIONS(3419),
    [anon_sym_restrict] = ACTIONS(3419),
    [anon_sym___restrict__] = ACTIONS(3419),
    [anon_sym__Atomic] = ACTIONS(3419),
    [anon_sym__Noreturn] = ACTIONS(3419),
    [anon_sym_noreturn] = ACTIONS(3419),
    [anon_sym_mutable] = ACTIONS(3419),
    [anon_sym_constinit] = ACTIONS(3419),
    [anon_sym_consteval] = ACTIONS(3419),
    [anon_sym_PROGMEM] = ACTIONS(3419),
    [aux_sym_primitive_type_token1] = ACTIONS(3419),
    [anon_sym_byte] = ACTIONS(3419),
    [anon_sym_word] = ACTIONS(3419),
    [anon_sym_enum] = ACTIONS(3419),
    [anon_sym_class] = ACTIONS(3419),
    [anon_sym_struct] = ACTIONS(3419),
    [anon_sym_union] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_switch] = ACTIONS(3419),
    [anon_sym_case] = ACTIONS(3419),
    [anon_sym_default] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_break] = ACTIONS(3419),
    [anon_sym_continue] = ACTIONS(3419),
    [anon_sym_goto] = ACTIONS(3419),
    [anon_sym___try] = ACTIONS(3419),
    [anon_sym___leave] = ACTIONS(3419),
    [anon_sym_not] = ACTIONS(3419),
    [anon_sym_compl] = ACTIONS(3419),
    [anon_sym_DASH_DASH] = ACTIONS(3421),
    [anon_sym_PLUS_PLUS] = ACTIONS(3421),
    [anon_sym_sizeof] = ACTIONS(3419),
    [anon_sym___alignof__] = ACTIONS(3419),
    [anon_sym___alignof] = ACTIONS(3419),
    [anon_sym__alignof] = ACTIONS(3419),
    [anon_sym_alignof] = ACTIONS(3419),
    [anon_sym__Alignof] = ACTIONS(3419),
    [anon_sym_offsetof] = ACTIONS(3419),
    [anon_sym__Generic] = ACTIONS(3419),
    [anon_sym_asm] = ACTIONS(3419),
    [anon_sym___asm__] = ACTIONS(3419),
    [aux_sym_number_literal_token1] = ACTIONS(3421),
    [aux_sym_number_literal_token2] = ACTIONS(3419),
    [anon_sym_L_SQUOTE] = ACTIONS(3421),
    [anon_sym_u_SQUOTE] = ACTIONS(3421),
    [anon_sym_U_SQUOTE] = ACTIONS(3421),
    [anon_sym_u8_SQUOTE] = ACTIONS(3421),
    [anon_sym_SQUOTE] = ACTIONS(3421),
    [anon_sym_L_DQUOTE] = ACTIONS(3421),
    [anon_sym_u_DQUOTE] = ACTIONS(3421),
    [anon_sym_U_DQUOTE] = ACTIONS(3421),
    [anon_sym_u8_DQUOTE] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [sym_true] = ACTIONS(3419),
    [sym_false] = ACTIONS(3419),
    [anon_sym_NULL] = ACTIONS(3419),
    [anon_sym_nullptr] = ACTIONS(3419),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3419),
    [anon_sym_decltype] = ACTIONS(3419),
    [anon_sym_virtual] = ACTIONS(3419),
    [anon_sym_alignas] = ACTIONS(3419),
    [anon_sym_explicit] = ACTIONS(3419),
    [anon_sym_typename] = ACTIONS(3419),
    [anon_sym_template] = ACTIONS(3419),
    [anon_sym_operator] = ACTIONS(3419),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_delete] = ACTIONS(3419),
    [anon_sym_throw] = ACTIONS(3419),
    [anon_sym_namespace] = ACTIONS(3419),
    [anon_sym_using] = ACTIONS(3419),
    [anon_sym_static_assert] = ACTIONS(3419),
    [anon_sym_concept] = ACTIONS(3419),
    [anon_sym_co_return] = ACTIONS(3419),
    [anon_sym_co_yield] = ACTIONS(3419),
    [anon_sym_R_DQUOTE] = ACTIONS(3421),
    [anon_sym_LR_DQUOTE] = ACTIONS(3421),
    [anon_sym_uR_DQUOTE] = ACTIONS(3421),
    [anon_sym_UR_DQUOTE] = ACTIONS(3421),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3421),
    [anon_sym_co_await] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_requires] = ACTIONS(3419),
    [sym_this] = ACTIONS(3419),
  },
  [429] = {
    [sym_identifier] = ACTIONS(3423),
    [aux_sym_preproc_include_token1] = ACTIONS(3423),
    [aux_sym_preproc_def_token1] = ACTIONS(3423),
    [aux_sym_preproc_if_token1] = ACTIONS(3423),
    [aux_sym_preproc_if_token2] = ACTIONS(3423),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3423),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3423),
    [aux_sym_preproc_else_token1] = ACTIONS(3423),
    [aux_sym_preproc_elif_token1] = ACTIONS(3423),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3423),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3423),
    [sym_preproc_directive] = ACTIONS(3423),
    [anon_sym_LPAREN2] = ACTIONS(3425),
    [anon_sym_BANG] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [anon_sym_DASH] = ACTIONS(3423),
    [anon_sym_PLUS] = ACTIONS(3423),
    [anon_sym_STAR] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3425),
    [anon_sym___extension__] = ACTIONS(3423),
    [anon_sym_typedef] = ACTIONS(3423),
    [anon_sym_extern] = ACTIONS(3423),
    [anon_sym___attribute__] = ACTIONS(3423),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3425),
    [anon_sym___declspec] = ACTIONS(3423),
    [anon_sym___based] = ACTIONS(3423),
    [anon_sym___cdecl] = ACTIONS(3423),
    [anon_sym___clrcall] = ACTIONS(3423),
    [anon_sym___stdcall] = ACTIONS(3423),
    [anon_sym___fastcall] = ACTIONS(3423),
    [anon_sym___thiscall] = ACTIONS(3423),
    [anon_sym___vectorcall] = ACTIONS(3423),
    [anon_sym_LBRACE] = ACTIONS(3425),
    [anon_sym_signed] = ACTIONS(3423),
    [anon_sym_unsigned] = ACTIONS(3423),
    [anon_sym_long] = ACTIONS(3423),
    [anon_sym_short] = ACTIONS(3423),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_static] = ACTIONS(3423),
    [anon_sym_register] = ACTIONS(3423),
    [anon_sym_inline] = ACTIONS(3423),
    [anon_sym___inline] = ACTIONS(3423),
    [anon_sym___inline__] = ACTIONS(3423),
    [anon_sym___forceinline] = ACTIONS(3423),
    [anon_sym_thread_local] = ACTIONS(3423),
    [anon_sym___thread] = ACTIONS(3423),
    [anon_sym_const] = ACTIONS(3423),
    [anon_sym_constexpr] = ACTIONS(3423),
    [anon_sym_volatile] = ACTIONS(3423),
    [anon_sym_restrict] = ACTIONS(3423),
    [anon_sym___restrict__] = ACTIONS(3423),
    [anon_sym__Atomic] = ACTIONS(3423),
    [anon_sym__Noreturn] = ACTIONS(3423),
    [anon_sym_noreturn] = ACTIONS(3423),
    [anon_sym_mutable] = ACTIONS(3423),
    [anon_sym_constinit] = ACTIONS(3423),
    [anon_sym_consteval] = ACTIONS(3423),
    [anon_sym_PROGMEM] = ACTIONS(3423),
    [aux_sym_primitive_type_token1] = ACTIONS(3423),
    [anon_sym_byte] = ACTIONS(3423),
    [anon_sym_word] = ACTIONS(3423),
    [anon_sym_enum] = ACTIONS(3423),
    [anon_sym_class] = ACTIONS(3423),
    [anon_sym_struct] = ACTIONS(3423),
    [anon_sym_union] = ACTIONS(3423),
    [anon_sym_if] = ACTIONS(3423),
    [anon_sym_switch] = ACTIONS(3423),
    [anon_sym_case] = ACTIONS(3423),
    [anon_sym_default] = ACTIONS(3423),
    [anon_sym_while] = ACTIONS(3423),
    [anon_sym_do] = ACTIONS(3423),
    [anon_sym_for] = ACTIONS(3423),
    [anon_sym_return] = ACTIONS(3423),
    [anon_sym_break] = ACTIONS(3423),
    [anon_sym_continue] = ACTIONS(3423),
    [anon_sym_goto] = ACTIONS(3423),
    [anon_sym___try] = ACTIONS(3423),
    [anon_sym___leave] = ACTIONS(3423),
    [anon_sym_not] = ACTIONS(3423),
    [anon_sym_compl] = ACTIONS(3423),
    [anon_sym_DASH_DASH] = ACTIONS(3425),
    [anon_sym_PLUS_PLUS] = ACTIONS(3425),
    [anon_sym_sizeof] = ACTIONS(3423),
    [anon_sym___alignof__] = ACTIONS(3423),
    [anon_sym___alignof] = ACTIONS(3423),
    [anon_sym__alignof] = ACTIONS(3423),
    [anon_sym_alignof] = ACTIONS(3423),
    [anon_sym__Alignof] = ACTIONS(3423),
    [anon_sym_offsetof] = ACTIONS(3423),
    [anon_sym__Generic] = ACTIONS(3423),
    [anon_sym_asm] = ACTIONS(3423),
    [anon_sym___asm__] = ACTIONS(3423),
    [aux_sym_number_literal_token1] = ACTIONS(3425),
    [aux_sym_number_literal_token2] = ACTIONS(3423),
    [anon_sym_L_SQUOTE] = ACTIONS(3425),
    [anon_sym_u_SQUOTE] = ACTIONS(3425),
    [anon_sym_U_SQUOTE] = ACTIONS(3425),
    [anon_sym_u8_SQUOTE] = ACTIONS(3425),
    [anon_sym_SQUOTE] = ACTIONS(3425),
    [anon_sym_L_DQUOTE] = ACTIONS(3425),
    [anon_sym_u_DQUOTE] = ACTIONS(3425),
    [anon_sym_U_DQUOTE] = ACTIONS(3425),
    [anon_sym_u8_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [sym_true] = ACTIONS(3423),
    [sym_false] = ACTIONS(3423),
    [anon_sym_NULL] = ACTIONS(3423),
    [anon_sym_nullptr] = ACTIONS(3423),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3423),
    [anon_sym_decltype] = ACTIONS(3423),
    [anon_sym_virtual] = ACTIONS(3423),
    [anon_sym_alignas] = ACTIONS(3423),
    [anon_sym_explicit] = ACTIONS(3423),
    [anon_sym_typename] = ACTIONS(3423),
    [anon_sym_template] = ACTIONS(3423),
    [anon_sym_operator] = ACTIONS(3423),
    [anon_sym_try] = ACTIONS(3423),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_throw] = ACTIONS(3423),
    [anon_sym_namespace] = ACTIONS(3423),
    [anon_sym_using] = ACTIONS(3423),
    [anon_sym_static_assert] = ACTIONS(3423),
    [anon_sym_concept] = ACTIONS(3423),
    [anon_sym_co_return] = ACTIONS(3423),
    [anon_sym_co_yield] = ACTIONS(3423),
    [anon_sym_R_DQUOTE] = ACTIONS(3425),
    [anon_sym_LR_DQUOTE] = ACTIONS(3425),
    [anon_sym_uR_DQUOTE] = ACTIONS(3425),
    [anon_sym_UR_DQUOTE] = ACTIONS(3425),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3425),
    [anon_sym_co_await] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3423),
    [anon_sym_requires] = ACTIONS(3423),
    [sym_this] = ACTIONS(3423),
  },
  [430] = {
    [sym_identifier] = ACTIONS(3427),
    [aux_sym_preproc_include_token1] = ACTIONS(3427),
    [aux_sym_preproc_def_token1] = ACTIONS(3427),
    [aux_sym_preproc_if_token1] = ACTIONS(3427),
    [aux_sym_preproc_if_token2] = ACTIONS(3427),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3427),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3427),
    [aux_sym_preproc_else_token1] = ACTIONS(3427),
    [aux_sym_preproc_elif_token1] = ACTIONS(3427),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3427),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3427),
    [sym_preproc_directive] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3429),
    [anon_sym_BANG] = ACTIONS(3429),
    [anon_sym_TILDE] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3429),
    [anon_sym_AMP_AMP] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(3429),
    [anon_sym___extension__] = ACTIONS(3427),
    [anon_sym_typedef] = ACTIONS(3427),
    [anon_sym_extern] = ACTIONS(3427),
    [anon_sym___attribute__] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3429),
    [anon_sym___declspec] = ACTIONS(3427),
    [anon_sym___based] = ACTIONS(3427),
    [anon_sym___cdecl] = ACTIONS(3427),
    [anon_sym___clrcall] = ACTIONS(3427),
    [anon_sym___stdcall] = ACTIONS(3427),
    [anon_sym___fastcall] = ACTIONS(3427),
    [anon_sym___thiscall] = ACTIONS(3427),
    [anon_sym___vectorcall] = ACTIONS(3427),
    [anon_sym_LBRACE] = ACTIONS(3429),
    [anon_sym_signed] = ACTIONS(3427),
    [anon_sym_unsigned] = ACTIONS(3427),
    [anon_sym_long] = ACTIONS(3427),
    [anon_sym_short] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_register] = ACTIONS(3427),
    [anon_sym_inline] = ACTIONS(3427),
    [anon_sym___inline] = ACTIONS(3427),
    [anon_sym___inline__] = ACTIONS(3427),
    [anon_sym___forceinline] = ACTIONS(3427),
    [anon_sym_thread_local] = ACTIONS(3427),
    [anon_sym___thread] = ACTIONS(3427),
    [anon_sym_const] = ACTIONS(3427),
    [anon_sym_constexpr] = ACTIONS(3427),
    [anon_sym_volatile] = ACTIONS(3427),
    [anon_sym_restrict] = ACTIONS(3427),
    [anon_sym___restrict__] = ACTIONS(3427),
    [anon_sym__Atomic] = ACTIONS(3427),
    [anon_sym__Noreturn] = ACTIONS(3427),
    [anon_sym_noreturn] = ACTIONS(3427),
    [anon_sym_mutable] = ACTIONS(3427),
    [anon_sym_constinit] = ACTIONS(3427),
    [anon_sym_consteval] = ACTIONS(3427),
    [anon_sym_PROGMEM] = ACTIONS(3427),
    [aux_sym_primitive_type_token1] = ACTIONS(3427),
    [anon_sym_byte] = ACTIONS(3427),
    [anon_sym_word] = ACTIONS(3427),
    [anon_sym_enum] = ACTIONS(3427),
    [anon_sym_class] = ACTIONS(3427),
    [anon_sym_struct] = ACTIONS(3427),
    [anon_sym_union] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_switch] = ACTIONS(3427),
    [anon_sym_case] = ACTIONS(3427),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_break] = ACTIONS(3427),
    [anon_sym_continue] = ACTIONS(3427),
    [anon_sym_goto] = ACTIONS(3427),
    [anon_sym___try] = ACTIONS(3427),
    [anon_sym___leave] = ACTIONS(3427),
    [anon_sym_not] = ACTIONS(3427),
    [anon_sym_compl] = ACTIONS(3427),
    [anon_sym_DASH_DASH] = ACTIONS(3429),
    [anon_sym_PLUS_PLUS] = ACTIONS(3429),
    [anon_sym_sizeof] = ACTIONS(3427),
    [anon_sym___alignof__] = ACTIONS(3427),
    [anon_sym___alignof] = ACTIONS(3427),
    [anon_sym__alignof] = ACTIONS(3427),
    [anon_sym_alignof] = ACTIONS(3427),
    [anon_sym__Alignof] = ACTIONS(3427),
    [anon_sym_offsetof] = ACTIONS(3427),
    [anon_sym__Generic] = ACTIONS(3427),
    [anon_sym_asm] = ACTIONS(3427),
    [anon_sym___asm__] = ACTIONS(3427),
    [aux_sym_number_literal_token1] = ACTIONS(3429),
    [aux_sym_number_literal_token2] = ACTIONS(3427),
    [anon_sym_L_SQUOTE] = ACTIONS(3429),
    [anon_sym_u_SQUOTE] = ACTIONS(3429),
    [anon_sym_U_SQUOTE] = ACTIONS(3429),
    [anon_sym_u8_SQUOTE] = ACTIONS(3429),
    [anon_sym_SQUOTE] = ACTIONS(3429),
    [anon_sym_L_DQUOTE] = ACTIONS(3429),
    [anon_sym_u_DQUOTE] = ACTIONS(3429),
    [anon_sym_U_DQUOTE] = ACTIONS(3429),
    [anon_sym_u8_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(3429),
    [sym_true] = ACTIONS(3427),
    [sym_false] = ACTIONS(3427),
    [anon_sym_NULL] = ACTIONS(3427),
    [anon_sym_nullptr] = ACTIONS(3427),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3427),
    [anon_sym_decltype] = ACTIONS(3427),
    [anon_sym_virtual] = ACTIONS(3427),
    [anon_sym_alignas] = ACTIONS(3427),
    [anon_sym_explicit] = ACTIONS(3427),
    [anon_sym_typename] = ACTIONS(3427),
    [anon_sym_template] = ACTIONS(3427),
    [anon_sym_operator] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_delete] = ACTIONS(3427),
    [anon_sym_throw] = ACTIONS(3427),
    [anon_sym_namespace] = ACTIONS(3427),
    [anon_sym_using] = ACTIONS(3427),
    [anon_sym_static_assert] = ACTIONS(3427),
    [anon_sym_concept] = ACTIONS(3427),
    [anon_sym_co_return] = ACTIONS(3427),
    [anon_sym_co_yield] = ACTIONS(3427),
    [anon_sym_R_DQUOTE] = ACTIONS(3429),
    [anon_sym_LR_DQUOTE] = ACTIONS(3429),
    [anon_sym_uR_DQUOTE] = ACTIONS(3429),
    [anon_sym_UR_DQUOTE] = ACTIONS(3429),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3429),
    [anon_sym_co_await] = ACTIONS(3427),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_requires] = ACTIONS(3427),
    [sym_this] = ACTIONS(3427),
  },
  [431] = {
    [sym_identifier] = ACTIONS(3431),
    [aux_sym_preproc_include_token1] = ACTIONS(3431),
    [aux_sym_preproc_def_token1] = ACTIONS(3431),
    [aux_sym_preproc_if_token1] = ACTIONS(3431),
    [aux_sym_preproc_if_token2] = ACTIONS(3431),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3431),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3431),
    [aux_sym_preproc_else_token1] = ACTIONS(3431),
    [aux_sym_preproc_elif_token1] = ACTIONS(3431),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3431),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3431),
    [sym_preproc_directive] = ACTIONS(3431),
    [anon_sym_LPAREN2] = ACTIONS(3433),
    [anon_sym_BANG] = ACTIONS(3433),
    [anon_sym_TILDE] = ACTIONS(3433),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3433),
    [anon_sym_AMP_AMP] = ACTIONS(3433),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_SEMI] = ACTIONS(3433),
    [anon_sym___extension__] = ACTIONS(3431),
    [anon_sym_typedef] = ACTIONS(3431),
    [anon_sym_extern] = ACTIONS(3431),
    [anon_sym___attribute__] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3433),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3433),
    [anon_sym___declspec] = ACTIONS(3431),
    [anon_sym___based] = ACTIONS(3431),
    [anon_sym___cdecl] = ACTIONS(3431),
    [anon_sym___clrcall] = ACTIONS(3431),
    [anon_sym___stdcall] = ACTIONS(3431),
    [anon_sym___fastcall] = ACTIONS(3431),
    [anon_sym___thiscall] = ACTIONS(3431),
    [anon_sym___vectorcall] = ACTIONS(3431),
    [anon_sym_LBRACE] = ACTIONS(3433),
    [anon_sym_signed] = ACTIONS(3431),
    [anon_sym_unsigned] = ACTIONS(3431),
    [anon_sym_long] = ACTIONS(3431),
    [anon_sym_short] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_static] = ACTIONS(3431),
    [anon_sym_register] = ACTIONS(3431),
    [anon_sym_inline] = ACTIONS(3431),
    [anon_sym___inline] = ACTIONS(3431),
    [anon_sym___inline__] = ACTIONS(3431),
    [anon_sym___forceinline] = ACTIONS(3431),
    [anon_sym_thread_local] = ACTIONS(3431),
    [anon_sym___thread] = ACTIONS(3431),
    [anon_sym_const] = ACTIONS(3431),
    [anon_sym_constexpr] = ACTIONS(3431),
    [anon_sym_volatile] = ACTIONS(3431),
    [anon_sym_restrict] = ACTIONS(3431),
    [anon_sym___restrict__] = ACTIONS(3431),
    [anon_sym__Atomic] = ACTIONS(3431),
    [anon_sym__Noreturn] = ACTIONS(3431),
    [anon_sym_noreturn] = ACTIONS(3431),
    [anon_sym_mutable] = ACTIONS(3431),
    [anon_sym_constinit] = ACTIONS(3431),
    [anon_sym_consteval] = ACTIONS(3431),
    [anon_sym_PROGMEM] = ACTIONS(3431),
    [aux_sym_primitive_type_token1] = ACTIONS(3431),
    [anon_sym_byte] = ACTIONS(3431),
    [anon_sym_word] = ACTIONS(3431),
    [anon_sym_enum] = ACTIONS(3431),
    [anon_sym_class] = ACTIONS(3431),
    [anon_sym_struct] = ACTIONS(3431),
    [anon_sym_union] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_switch] = ACTIONS(3431),
    [anon_sym_case] = ACTIONS(3431),
    [anon_sym_default] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_break] = ACTIONS(3431),
    [anon_sym_continue] = ACTIONS(3431),
    [anon_sym_goto] = ACTIONS(3431),
    [anon_sym___try] = ACTIONS(3431),
    [anon_sym___leave] = ACTIONS(3431),
    [anon_sym_not] = ACTIONS(3431),
    [anon_sym_compl] = ACTIONS(3431),
    [anon_sym_DASH_DASH] = ACTIONS(3433),
    [anon_sym_PLUS_PLUS] = ACTIONS(3433),
    [anon_sym_sizeof] = ACTIONS(3431),
    [anon_sym___alignof__] = ACTIONS(3431),
    [anon_sym___alignof] = ACTIONS(3431),
    [anon_sym__alignof] = ACTIONS(3431),
    [anon_sym_alignof] = ACTIONS(3431),
    [anon_sym__Alignof] = ACTIONS(3431),
    [anon_sym_offsetof] = ACTIONS(3431),
    [anon_sym__Generic] = ACTIONS(3431),
    [anon_sym_asm] = ACTIONS(3431),
    [anon_sym___asm__] = ACTIONS(3431),
    [aux_sym_number_literal_token1] = ACTIONS(3433),
    [aux_sym_number_literal_token2] = ACTIONS(3431),
    [anon_sym_L_SQUOTE] = ACTIONS(3433),
    [anon_sym_u_SQUOTE] = ACTIONS(3433),
    [anon_sym_U_SQUOTE] = ACTIONS(3433),
    [anon_sym_u8_SQUOTE] = ACTIONS(3433),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [anon_sym_L_DQUOTE] = ACTIONS(3433),
    [anon_sym_u_DQUOTE] = ACTIONS(3433),
    [anon_sym_U_DQUOTE] = ACTIONS(3433),
    [anon_sym_u8_DQUOTE] = ACTIONS(3433),
    [anon_sym_DQUOTE] = ACTIONS(3433),
    [sym_true] = ACTIONS(3431),
    [sym_false] = ACTIONS(3431),
    [anon_sym_NULL] = ACTIONS(3431),
    [anon_sym_nullptr] = ACTIONS(3431),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3431),
    [anon_sym_decltype] = ACTIONS(3431),
    [anon_sym_virtual] = ACTIONS(3431),
    [anon_sym_alignas] = ACTIONS(3431),
    [anon_sym_explicit] = ACTIONS(3431),
    [anon_sym_typename] = ACTIONS(3431),
    [anon_sym_template] = ACTIONS(3431),
    [anon_sym_operator] = ACTIONS(3431),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_delete] = ACTIONS(3431),
    [anon_sym_throw] = ACTIONS(3431),
    [anon_sym_namespace] = ACTIONS(3431),
    [anon_sym_using] = ACTIONS(3431),
    [anon_sym_static_assert] = ACTIONS(3431),
    [anon_sym_concept] = ACTIONS(3431),
    [anon_sym_co_return] = ACTIONS(3431),
    [anon_sym_co_yield] = ACTIONS(3431),
    [anon_sym_R_DQUOTE] = ACTIONS(3433),
    [anon_sym_LR_DQUOTE] = ACTIONS(3433),
    [anon_sym_uR_DQUOTE] = ACTIONS(3433),
    [anon_sym_UR_DQUOTE] = ACTIONS(3433),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3433),
    [anon_sym_co_await] = ACTIONS(3431),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_requires] = ACTIONS(3431),
    [sym_this] = ACTIONS(3431),
  },
  [432] = {
    [sym_identifier] = ACTIONS(3435),
    [aux_sym_preproc_include_token1] = ACTIONS(3435),
    [aux_sym_preproc_def_token1] = ACTIONS(3435),
    [aux_sym_preproc_if_token1] = ACTIONS(3435),
    [aux_sym_preproc_if_token2] = ACTIONS(3435),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3435),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3435),
    [aux_sym_preproc_else_token1] = ACTIONS(3435),
    [aux_sym_preproc_elif_token1] = ACTIONS(3435),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3435),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3435),
    [sym_preproc_directive] = ACTIONS(3435),
    [anon_sym_LPAREN2] = ACTIONS(3437),
    [anon_sym_BANG] = ACTIONS(3437),
    [anon_sym_TILDE] = ACTIONS(3437),
    [anon_sym_DASH] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3435),
    [anon_sym_STAR] = ACTIONS(3437),
    [anon_sym_AMP_AMP] = ACTIONS(3437),
    [anon_sym_AMP] = ACTIONS(3435),
    [anon_sym_SEMI] = ACTIONS(3437),
    [anon_sym___extension__] = ACTIONS(3435),
    [anon_sym_typedef] = ACTIONS(3435),
    [anon_sym_extern] = ACTIONS(3435),
    [anon_sym___attribute__] = ACTIONS(3435),
    [anon_sym_COLON_COLON] = ACTIONS(3437),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3437),
    [anon_sym___declspec] = ACTIONS(3435),
    [anon_sym___based] = ACTIONS(3435),
    [anon_sym___cdecl] = ACTIONS(3435),
    [anon_sym___clrcall] = ACTIONS(3435),
    [anon_sym___stdcall] = ACTIONS(3435),
    [anon_sym___fastcall] = ACTIONS(3435),
    [anon_sym___thiscall] = ACTIONS(3435),
    [anon_sym___vectorcall] = ACTIONS(3435),
    [anon_sym_LBRACE] = ACTIONS(3437),
    [anon_sym_signed] = ACTIONS(3435),
    [anon_sym_unsigned] = ACTIONS(3435),
    [anon_sym_long] = ACTIONS(3435),
    [anon_sym_short] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3435),
    [anon_sym_static] = ACTIONS(3435),
    [anon_sym_register] = ACTIONS(3435),
    [anon_sym_inline] = ACTIONS(3435),
    [anon_sym___inline] = ACTIONS(3435),
    [anon_sym___inline__] = ACTIONS(3435),
    [anon_sym___forceinline] = ACTIONS(3435),
    [anon_sym_thread_local] = ACTIONS(3435),
    [anon_sym___thread] = ACTIONS(3435),
    [anon_sym_const] = ACTIONS(3435),
    [anon_sym_constexpr] = ACTIONS(3435),
    [anon_sym_volatile] = ACTIONS(3435),
    [anon_sym_restrict] = ACTIONS(3435),
    [anon_sym___restrict__] = ACTIONS(3435),
    [anon_sym__Atomic] = ACTIONS(3435),
    [anon_sym__Noreturn] = ACTIONS(3435),
    [anon_sym_noreturn] = ACTIONS(3435),
    [anon_sym_mutable] = ACTIONS(3435),
    [anon_sym_constinit] = ACTIONS(3435),
    [anon_sym_consteval] = ACTIONS(3435),
    [anon_sym_PROGMEM] = ACTIONS(3435),
    [aux_sym_primitive_type_token1] = ACTIONS(3435),
    [anon_sym_byte] = ACTIONS(3435),
    [anon_sym_word] = ACTIONS(3435),
    [anon_sym_enum] = ACTIONS(3435),
    [anon_sym_class] = ACTIONS(3435),
    [anon_sym_struct] = ACTIONS(3435),
    [anon_sym_union] = ACTIONS(3435),
    [anon_sym_if] = ACTIONS(3435),
    [anon_sym_switch] = ACTIONS(3435),
    [anon_sym_case] = ACTIONS(3435),
    [anon_sym_default] = ACTIONS(3435),
    [anon_sym_while] = ACTIONS(3435),
    [anon_sym_do] = ACTIONS(3435),
    [anon_sym_for] = ACTIONS(3435),
    [anon_sym_return] = ACTIONS(3435),
    [anon_sym_break] = ACTIONS(3435),
    [anon_sym_continue] = ACTIONS(3435),
    [anon_sym_goto] = ACTIONS(3435),
    [anon_sym___try] = ACTIONS(3435),
    [anon_sym___leave] = ACTIONS(3435),
    [anon_sym_not] = ACTIONS(3435),
    [anon_sym_compl] = ACTIONS(3435),
    [anon_sym_DASH_DASH] = ACTIONS(3437),
    [anon_sym_PLUS_PLUS] = ACTIONS(3437),
    [anon_sym_sizeof] = ACTIONS(3435),
    [anon_sym___alignof__] = ACTIONS(3435),
    [anon_sym___alignof] = ACTIONS(3435),
    [anon_sym__alignof] = ACTIONS(3435),
    [anon_sym_alignof] = ACTIONS(3435),
    [anon_sym__Alignof] = ACTIONS(3435),
    [anon_sym_offsetof] = ACTIONS(3435),
    [anon_sym__Generic] = ACTIONS(3435),
    [anon_sym_asm] = ACTIONS(3435),
    [anon_sym___asm__] = ACTIONS(3435),
    [aux_sym_number_literal_token1] = ACTIONS(3437),
    [aux_sym_number_literal_token2] = ACTIONS(3435),
    [anon_sym_L_SQUOTE] = ACTIONS(3437),
    [anon_sym_u_SQUOTE] = ACTIONS(3437),
    [anon_sym_U_SQUOTE] = ACTIONS(3437),
    [anon_sym_u8_SQUOTE] = ACTIONS(3437),
    [anon_sym_SQUOTE] = ACTIONS(3437),
    [anon_sym_L_DQUOTE] = ACTIONS(3437),
    [anon_sym_u_DQUOTE] = ACTIONS(3437),
    [anon_sym_U_DQUOTE] = ACTIONS(3437),
    [anon_sym_u8_DQUOTE] = ACTIONS(3437),
    [anon_sym_DQUOTE] = ACTIONS(3437),
    [sym_true] = ACTIONS(3435),
    [sym_false] = ACTIONS(3435),
    [anon_sym_NULL] = ACTIONS(3435),
    [anon_sym_nullptr] = ACTIONS(3435),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3435),
    [anon_sym_decltype] = ACTIONS(3435),
    [anon_sym_virtual] = ACTIONS(3435),
    [anon_sym_alignas] = ACTIONS(3435),
    [anon_sym_explicit] = ACTIONS(3435),
    [anon_sym_typename] = ACTIONS(3435),
    [anon_sym_template] = ACTIONS(3435),
    [anon_sym_operator] = ACTIONS(3435),
    [anon_sym_try] = ACTIONS(3435),
    [anon_sym_delete] = ACTIONS(3435),
    [anon_sym_throw] = ACTIONS(3435),
    [anon_sym_namespace] = ACTIONS(3435),
    [anon_sym_using] = ACTIONS(3435),
    [anon_sym_static_assert] = ACTIONS(3435),
    [anon_sym_concept] = ACTIONS(3435),
    [anon_sym_co_return] = ACTIONS(3435),
    [anon_sym_co_yield] = ACTIONS(3435),
    [anon_sym_R_DQUOTE] = ACTIONS(3437),
    [anon_sym_LR_DQUOTE] = ACTIONS(3437),
    [anon_sym_uR_DQUOTE] = ACTIONS(3437),
    [anon_sym_UR_DQUOTE] = ACTIONS(3437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3437),
    [anon_sym_co_await] = ACTIONS(3435),
    [anon_sym_new] = ACTIONS(3435),
    [anon_sym_requires] = ACTIONS(3435),
    [sym_this] = ACTIONS(3435),
  },
  [433] = {
    [sym_identifier] = ACTIONS(3439),
    [aux_sym_preproc_include_token1] = ACTIONS(3439),
    [aux_sym_preproc_def_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token2] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3439),
    [aux_sym_preproc_else_token1] = ACTIONS(3439),
    [aux_sym_preproc_elif_token1] = ACTIONS(3439),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3439),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3439),
    [sym_preproc_directive] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3441),
    [anon_sym_BANG] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_DASH] = ACTIONS(3439),
    [anon_sym_PLUS] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3439),
    [anon_sym_SEMI] = ACTIONS(3441),
    [anon_sym___extension__] = ACTIONS(3439),
    [anon_sym_typedef] = ACTIONS(3439),
    [anon_sym_extern] = ACTIONS(3439),
    [anon_sym___attribute__] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3441),
    [anon_sym___declspec] = ACTIONS(3439),
    [anon_sym___based] = ACTIONS(3439),
    [anon_sym___cdecl] = ACTIONS(3439),
    [anon_sym___clrcall] = ACTIONS(3439),
    [anon_sym___stdcall] = ACTIONS(3439),
    [anon_sym___fastcall] = ACTIONS(3439),
    [anon_sym___thiscall] = ACTIONS(3439),
    [anon_sym___vectorcall] = ACTIONS(3439),
    [anon_sym_LBRACE] = ACTIONS(3441),
    [anon_sym_signed] = ACTIONS(3439),
    [anon_sym_unsigned] = ACTIONS(3439),
    [anon_sym_long] = ACTIONS(3439),
    [anon_sym_short] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_register] = ACTIONS(3439),
    [anon_sym_inline] = ACTIONS(3439),
    [anon_sym___inline] = ACTIONS(3439),
    [anon_sym___inline__] = ACTIONS(3439),
    [anon_sym___forceinline] = ACTIONS(3439),
    [anon_sym_thread_local] = ACTIONS(3439),
    [anon_sym___thread] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_constexpr] = ACTIONS(3439),
    [anon_sym_volatile] = ACTIONS(3439),
    [anon_sym_restrict] = ACTIONS(3439),
    [anon_sym___restrict__] = ACTIONS(3439),
    [anon_sym__Atomic] = ACTIONS(3439),
    [anon_sym__Noreturn] = ACTIONS(3439),
    [anon_sym_noreturn] = ACTIONS(3439),
    [anon_sym_mutable] = ACTIONS(3439),
    [anon_sym_constinit] = ACTIONS(3439),
    [anon_sym_consteval] = ACTIONS(3439),
    [anon_sym_PROGMEM] = ACTIONS(3439),
    [aux_sym_primitive_type_token1] = ACTIONS(3439),
    [anon_sym_byte] = ACTIONS(3439),
    [anon_sym_word] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_struct] = ACTIONS(3439),
    [anon_sym_union] = ACTIONS(3439),
    [anon_sym_if] = ACTIONS(3439),
    [anon_sym_switch] = ACTIONS(3439),
    [anon_sym_case] = ACTIONS(3439),
    [anon_sym_default] = ACTIONS(3439),
    [anon_sym_while] = ACTIONS(3439),
    [anon_sym_do] = ACTIONS(3439),
    [anon_sym_for] = ACTIONS(3439),
    [anon_sym_return] = ACTIONS(3439),
    [anon_sym_break] = ACTIONS(3439),
    [anon_sym_continue] = ACTIONS(3439),
    [anon_sym_goto] = ACTIONS(3439),
    [anon_sym___try] = ACTIONS(3439),
    [anon_sym___leave] = ACTIONS(3439),
    [anon_sym_not] = ACTIONS(3439),
    [anon_sym_compl] = ACTIONS(3439),
    [anon_sym_DASH_DASH] = ACTIONS(3441),
    [anon_sym_PLUS_PLUS] = ACTIONS(3441),
    [anon_sym_sizeof] = ACTIONS(3439),
    [anon_sym___alignof__] = ACTIONS(3439),
    [anon_sym___alignof] = ACTIONS(3439),
    [anon_sym__alignof] = ACTIONS(3439),
    [anon_sym_alignof] = ACTIONS(3439),
    [anon_sym__Alignof] = ACTIONS(3439),
    [anon_sym_offsetof] = ACTIONS(3439),
    [anon_sym__Generic] = ACTIONS(3439),
    [anon_sym_asm] = ACTIONS(3439),
    [anon_sym___asm__] = ACTIONS(3439),
    [aux_sym_number_literal_token1] = ACTIONS(3441),
    [aux_sym_number_literal_token2] = ACTIONS(3439),
    [anon_sym_L_SQUOTE] = ACTIONS(3441),
    [anon_sym_u_SQUOTE] = ACTIONS(3441),
    [anon_sym_U_SQUOTE] = ACTIONS(3441),
    [anon_sym_u8_SQUOTE] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [anon_sym_L_DQUOTE] = ACTIONS(3441),
    [anon_sym_u_DQUOTE] = ACTIONS(3441),
    [anon_sym_U_DQUOTE] = ACTIONS(3441),
    [anon_sym_u8_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE] = ACTIONS(3441),
    [sym_true] = ACTIONS(3439),
    [sym_false] = ACTIONS(3439),
    [anon_sym_NULL] = ACTIONS(3439),
    [anon_sym_nullptr] = ACTIONS(3439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3439),
    [anon_sym_decltype] = ACTIONS(3439),
    [anon_sym_virtual] = ACTIONS(3439),
    [anon_sym_alignas] = ACTIONS(3439),
    [anon_sym_explicit] = ACTIONS(3439),
    [anon_sym_typename] = ACTIONS(3439),
    [anon_sym_template] = ACTIONS(3439),
    [anon_sym_operator] = ACTIONS(3439),
    [anon_sym_try] = ACTIONS(3439),
    [anon_sym_delete] = ACTIONS(3439),
    [anon_sym_throw] = ACTIONS(3439),
    [anon_sym_namespace] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_static_assert] = ACTIONS(3439),
    [anon_sym_concept] = ACTIONS(3439),
    [anon_sym_co_return] = ACTIONS(3439),
    [anon_sym_co_yield] = ACTIONS(3439),
    [anon_sym_R_DQUOTE] = ACTIONS(3441),
    [anon_sym_LR_DQUOTE] = ACTIONS(3441),
    [anon_sym_uR_DQUOTE] = ACTIONS(3441),
    [anon_sym_UR_DQUOTE] = ACTIONS(3441),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3441),
    [anon_sym_co_await] = ACTIONS(3439),
    [anon_sym_new] = ACTIONS(3439),
    [anon_sym_requires] = ACTIONS(3439),
    [sym_this] = ACTIONS(3439),
  },
  [434] = {
    [sym_identifier] = ACTIONS(3439),
    [aux_sym_preproc_include_token1] = ACTIONS(3439),
    [aux_sym_preproc_def_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token2] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3439),
    [aux_sym_preproc_else_token1] = ACTIONS(3439),
    [aux_sym_preproc_elif_token1] = ACTIONS(3439),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3439),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3439),
    [sym_preproc_directive] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3441),
    [anon_sym_BANG] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_DASH] = ACTIONS(3439),
    [anon_sym_PLUS] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3439),
    [anon_sym_SEMI] = ACTIONS(3441),
    [anon_sym___extension__] = ACTIONS(3439),
    [anon_sym_typedef] = ACTIONS(3439),
    [anon_sym_extern] = ACTIONS(3439),
    [anon_sym___attribute__] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3441),
    [anon_sym___declspec] = ACTIONS(3439),
    [anon_sym___based] = ACTIONS(3439),
    [anon_sym___cdecl] = ACTIONS(3439),
    [anon_sym___clrcall] = ACTIONS(3439),
    [anon_sym___stdcall] = ACTIONS(3439),
    [anon_sym___fastcall] = ACTIONS(3439),
    [anon_sym___thiscall] = ACTIONS(3439),
    [anon_sym___vectorcall] = ACTIONS(3439),
    [anon_sym_LBRACE] = ACTIONS(3441),
    [anon_sym_signed] = ACTIONS(3439),
    [anon_sym_unsigned] = ACTIONS(3439),
    [anon_sym_long] = ACTIONS(3439),
    [anon_sym_short] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_register] = ACTIONS(3439),
    [anon_sym_inline] = ACTIONS(3439),
    [anon_sym___inline] = ACTIONS(3439),
    [anon_sym___inline__] = ACTIONS(3439),
    [anon_sym___forceinline] = ACTIONS(3439),
    [anon_sym_thread_local] = ACTIONS(3439),
    [anon_sym___thread] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_constexpr] = ACTIONS(3439),
    [anon_sym_volatile] = ACTIONS(3439),
    [anon_sym_restrict] = ACTIONS(3439),
    [anon_sym___restrict__] = ACTIONS(3439),
    [anon_sym__Atomic] = ACTIONS(3439),
    [anon_sym__Noreturn] = ACTIONS(3439),
    [anon_sym_noreturn] = ACTIONS(3439),
    [anon_sym_mutable] = ACTIONS(3439),
    [anon_sym_constinit] = ACTIONS(3439),
    [anon_sym_consteval] = ACTIONS(3439),
    [anon_sym_PROGMEM] = ACTIONS(3439),
    [aux_sym_primitive_type_token1] = ACTIONS(3439),
    [anon_sym_byte] = ACTIONS(3439),
    [anon_sym_word] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_struct] = ACTIONS(3439),
    [anon_sym_union] = ACTIONS(3439),
    [anon_sym_if] = ACTIONS(3439),
    [anon_sym_switch] = ACTIONS(3439),
    [anon_sym_case] = ACTIONS(3439),
    [anon_sym_default] = ACTIONS(3439),
    [anon_sym_while] = ACTIONS(3439),
    [anon_sym_do] = ACTIONS(3439),
    [anon_sym_for] = ACTIONS(3439),
    [anon_sym_return] = ACTIONS(3439),
    [anon_sym_break] = ACTIONS(3439),
    [anon_sym_continue] = ACTIONS(3439),
    [anon_sym_goto] = ACTIONS(3439),
    [anon_sym___try] = ACTIONS(3439),
    [anon_sym___leave] = ACTIONS(3439),
    [anon_sym_not] = ACTIONS(3439),
    [anon_sym_compl] = ACTIONS(3439),
    [anon_sym_DASH_DASH] = ACTIONS(3441),
    [anon_sym_PLUS_PLUS] = ACTIONS(3441),
    [anon_sym_sizeof] = ACTIONS(3439),
    [anon_sym___alignof__] = ACTIONS(3439),
    [anon_sym___alignof] = ACTIONS(3439),
    [anon_sym__alignof] = ACTIONS(3439),
    [anon_sym_alignof] = ACTIONS(3439),
    [anon_sym__Alignof] = ACTIONS(3439),
    [anon_sym_offsetof] = ACTIONS(3439),
    [anon_sym__Generic] = ACTIONS(3439),
    [anon_sym_asm] = ACTIONS(3439),
    [anon_sym___asm__] = ACTIONS(3439),
    [aux_sym_number_literal_token1] = ACTIONS(3441),
    [aux_sym_number_literal_token2] = ACTIONS(3439),
    [anon_sym_L_SQUOTE] = ACTIONS(3441),
    [anon_sym_u_SQUOTE] = ACTIONS(3441),
    [anon_sym_U_SQUOTE] = ACTIONS(3441),
    [anon_sym_u8_SQUOTE] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [anon_sym_L_DQUOTE] = ACTIONS(3441),
    [anon_sym_u_DQUOTE] = ACTIONS(3441),
    [anon_sym_U_DQUOTE] = ACTIONS(3441),
    [anon_sym_u8_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE] = ACTIONS(3441),
    [sym_true] = ACTIONS(3439),
    [sym_false] = ACTIONS(3439),
    [anon_sym_NULL] = ACTIONS(3439),
    [anon_sym_nullptr] = ACTIONS(3439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3439),
    [anon_sym_decltype] = ACTIONS(3439),
    [anon_sym_virtual] = ACTIONS(3439),
    [anon_sym_alignas] = ACTIONS(3439),
    [anon_sym_explicit] = ACTIONS(3439),
    [anon_sym_typename] = ACTIONS(3439),
    [anon_sym_template] = ACTIONS(3439),
    [anon_sym_operator] = ACTIONS(3439),
    [anon_sym_try] = ACTIONS(3439),
    [anon_sym_delete] = ACTIONS(3439),
    [anon_sym_throw] = ACTIONS(3439),
    [anon_sym_namespace] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_static_assert] = ACTIONS(3439),
    [anon_sym_concept] = ACTIONS(3439),
    [anon_sym_co_return] = ACTIONS(3439),
    [anon_sym_co_yield] = ACTIONS(3439),
    [anon_sym_R_DQUOTE] = ACTIONS(3441),
    [anon_sym_LR_DQUOTE] = ACTIONS(3441),
    [anon_sym_uR_DQUOTE] = ACTIONS(3441),
    [anon_sym_UR_DQUOTE] = ACTIONS(3441),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3441),
    [anon_sym_co_await] = ACTIONS(3439),
    [anon_sym_new] = ACTIONS(3439),
    [anon_sym_requires] = ACTIONS(3439),
    [sym_this] = ACTIONS(3439),
  },
  [435] = {
    [sym_identifier] = ACTIONS(3443),
    [aux_sym_preproc_include_token1] = ACTIONS(3443),
    [aux_sym_preproc_def_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token2] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3443),
    [aux_sym_preproc_else_token1] = ACTIONS(3443),
    [aux_sym_preproc_elif_token1] = ACTIONS(3443),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3443),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3443),
    [sym_preproc_directive] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3445),
    [anon_sym_BANG] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_AMP_AMP] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_SEMI] = ACTIONS(3445),
    [anon_sym___extension__] = ACTIONS(3443),
    [anon_sym_typedef] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym___attribute__] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3445),
    [anon_sym___declspec] = ACTIONS(3443),
    [anon_sym___based] = ACTIONS(3443),
    [anon_sym___cdecl] = ACTIONS(3443),
    [anon_sym___clrcall] = ACTIONS(3443),
    [anon_sym___stdcall] = ACTIONS(3443),
    [anon_sym___fastcall] = ACTIONS(3443),
    [anon_sym___thiscall] = ACTIONS(3443),
    [anon_sym___vectorcall] = ACTIONS(3443),
    [anon_sym_LBRACE] = ACTIONS(3445),
    [anon_sym_signed] = ACTIONS(3443),
    [anon_sym_unsigned] = ACTIONS(3443),
    [anon_sym_long] = ACTIONS(3443),
    [anon_sym_short] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_register] = ACTIONS(3443),
    [anon_sym_inline] = ACTIONS(3443),
    [anon_sym___inline] = ACTIONS(3443),
    [anon_sym___inline__] = ACTIONS(3443),
    [anon_sym___forceinline] = ACTIONS(3443),
    [anon_sym_thread_local] = ACTIONS(3443),
    [anon_sym___thread] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_constexpr] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_restrict] = ACTIONS(3443),
    [anon_sym___restrict__] = ACTIONS(3443),
    [anon_sym__Atomic] = ACTIONS(3443),
    [anon_sym__Noreturn] = ACTIONS(3443),
    [anon_sym_noreturn] = ACTIONS(3443),
    [anon_sym_mutable] = ACTIONS(3443),
    [anon_sym_constinit] = ACTIONS(3443),
    [anon_sym_consteval] = ACTIONS(3443),
    [anon_sym_PROGMEM] = ACTIONS(3443),
    [aux_sym_primitive_type_token1] = ACTIONS(3443),
    [anon_sym_byte] = ACTIONS(3443),
    [anon_sym_word] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_union] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_switch] = ACTIONS(3443),
    [anon_sym_case] = ACTIONS(3443),
    [anon_sym_default] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_break] = ACTIONS(3443),
    [anon_sym_continue] = ACTIONS(3443),
    [anon_sym_goto] = ACTIONS(3443),
    [anon_sym___try] = ACTIONS(3443),
    [anon_sym___leave] = ACTIONS(3443),
    [anon_sym_not] = ACTIONS(3443),
    [anon_sym_compl] = ACTIONS(3443),
    [anon_sym_DASH_DASH] = ACTIONS(3445),
    [anon_sym_PLUS_PLUS] = ACTIONS(3445),
    [anon_sym_sizeof] = ACTIONS(3443),
    [anon_sym___alignof__] = ACTIONS(3443),
    [anon_sym___alignof] = ACTIONS(3443),
    [anon_sym__alignof] = ACTIONS(3443),
    [anon_sym_alignof] = ACTIONS(3443),
    [anon_sym__Alignof] = ACTIONS(3443),
    [anon_sym_offsetof] = ACTIONS(3443),
    [anon_sym__Generic] = ACTIONS(3443),
    [anon_sym_asm] = ACTIONS(3443),
    [anon_sym___asm__] = ACTIONS(3443),
    [aux_sym_number_literal_token1] = ACTIONS(3445),
    [aux_sym_number_literal_token2] = ACTIONS(3443),
    [anon_sym_L_SQUOTE] = ACTIONS(3445),
    [anon_sym_u_SQUOTE] = ACTIONS(3445),
    [anon_sym_U_SQUOTE] = ACTIONS(3445),
    [anon_sym_u8_SQUOTE] = ACTIONS(3445),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_L_DQUOTE] = ACTIONS(3445),
    [anon_sym_u_DQUOTE] = ACTIONS(3445),
    [anon_sym_U_DQUOTE] = ACTIONS(3445),
    [anon_sym_u8_DQUOTE] = ACTIONS(3445),
    [anon_sym_DQUOTE] = ACTIONS(3445),
    [sym_true] = ACTIONS(3443),
    [sym_false] = ACTIONS(3443),
    [anon_sym_NULL] = ACTIONS(3443),
    [anon_sym_nullptr] = ACTIONS(3443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3443),
    [anon_sym_decltype] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_alignas] = ACTIONS(3443),
    [anon_sym_explicit] = ACTIONS(3443),
    [anon_sym_typename] = ACTIONS(3443),
    [anon_sym_template] = ACTIONS(3443),
    [anon_sym_operator] = ACTIONS(3443),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_delete] = ACTIONS(3443),
    [anon_sym_throw] = ACTIONS(3443),
    [anon_sym_namespace] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_static_assert] = ACTIONS(3443),
    [anon_sym_concept] = ACTIONS(3443),
    [anon_sym_co_return] = ACTIONS(3443),
    [anon_sym_co_yield] = ACTIONS(3443),
    [anon_sym_R_DQUOTE] = ACTIONS(3445),
    [anon_sym_LR_DQUOTE] = ACTIONS(3445),
    [anon_sym_uR_DQUOTE] = ACTIONS(3445),
    [anon_sym_UR_DQUOTE] = ACTIONS(3445),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3445),
    [anon_sym_co_await] = ACTIONS(3443),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_requires] = ACTIONS(3443),
    [sym_this] = ACTIONS(3443),
  },
  [436] = {
    [sym_identifier] = ACTIONS(3443),
    [aux_sym_preproc_include_token1] = ACTIONS(3443),
    [aux_sym_preproc_def_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token2] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3443),
    [aux_sym_preproc_else_token1] = ACTIONS(3443),
    [aux_sym_preproc_elif_token1] = ACTIONS(3443),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3443),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3443),
    [sym_preproc_directive] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3445),
    [anon_sym_BANG] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_AMP_AMP] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_SEMI] = ACTIONS(3445),
    [anon_sym___extension__] = ACTIONS(3443),
    [anon_sym_typedef] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym___attribute__] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3445),
    [anon_sym___declspec] = ACTIONS(3443),
    [anon_sym___based] = ACTIONS(3443),
    [anon_sym___cdecl] = ACTIONS(3443),
    [anon_sym___clrcall] = ACTIONS(3443),
    [anon_sym___stdcall] = ACTIONS(3443),
    [anon_sym___fastcall] = ACTIONS(3443),
    [anon_sym___thiscall] = ACTIONS(3443),
    [anon_sym___vectorcall] = ACTIONS(3443),
    [anon_sym_LBRACE] = ACTIONS(3445),
    [anon_sym_signed] = ACTIONS(3443),
    [anon_sym_unsigned] = ACTIONS(3443),
    [anon_sym_long] = ACTIONS(3443),
    [anon_sym_short] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_register] = ACTIONS(3443),
    [anon_sym_inline] = ACTIONS(3443),
    [anon_sym___inline] = ACTIONS(3443),
    [anon_sym___inline__] = ACTIONS(3443),
    [anon_sym___forceinline] = ACTIONS(3443),
    [anon_sym_thread_local] = ACTIONS(3443),
    [anon_sym___thread] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_constexpr] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_restrict] = ACTIONS(3443),
    [anon_sym___restrict__] = ACTIONS(3443),
    [anon_sym__Atomic] = ACTIONS(3443),
    [anon_sym__Noreturn] = ACTIONS(3443),
    [anon_sym_noreturn] = ACTIONS(3443),
    [anon_sym_mutable] = ACTIONS(3443),
    [anon_sym_constinit] = ACTIONS(3443),
    [anon_sym_consteval] = ACTIONS(3443),
    [anon_sym_PROGMEM] = ACTIONS(3443),
    [aux_sym_primitive_type_token1] = ACTIONS(3443),
    [anon_sym_byte] = ACTIONS(3443),
    [anon_sym_word] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_union] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_switch] = ACTIONS(3443),
    [anon_sym_case] = ACTIONS(3443),
    [anon_sym_default] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_break] = ACTIONS(3443),
    [anon_sym_continue] = ACTIONS(3443),
    [anon_sym_goto] = ACTIONS(3443),
    [anon_sym___try] = ACTIONS(3443),
    [anon_sym___leave] = ACTIONS(3443),
    [anon_sym_not] = ACTIONS(3443),
    [anon_sym_compl] = ACTIONS(3443),
    [anon_sym_DASH_DASH] = ACTIONS(3445),
    [anon_sym_PLUS_PLUS] = ACTIONS(3445),
    [anon_sym_sizeof] = ACTIONS(3443),
    [anon_sym___alignof__] = ACTIONS(3443),
    [anon_sym___alignof] = ACTIONS(3443),
    [anon_sym__alignof] = ACTIONS(3443),
    [anon_sym_alignof] = ACTIONS(3443),
    [anon_sym__Alignof] = ACTIONS(3443),
    [anon_sym_offsetof] = ACTIONS(3443),
    [anon_sym__Generic] = ACTIONS(3443),
    [anon_sym_asm] = ACTIONS(3443),
    [anon_sym___asm__] = ACTIONS(3443),
    [aux_sym_number_literal_token1] = ACTIONS(3445),
    [aux_sym_number_literal_token2] = ACTIONS(3443),
    [anon_sym_L_SQUOTE] = ACTIONS(3445),
    [anon_sym_u_SQUOTE] = ACTIONS(3445),
    [anon_sym_U_SQUOTE] = ACTIONS(3445),
    [anon_sym_u8_SQUOTE] = ACTIONS(3445),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_L_DQUOTE] = ACTIONS(3445),
    [anon_sym_u_DQUOTE] = ACTIONS(3445),
    [anon_sym_U_DQUOTE] = ACTIONS(3445),
    [anon_sym_u8_DQUOTE] = ACTIONS(3445),
    [anon_sym_DQUOTE] = ACTIONS(3445),
    [sym_true] = ACTIONS(3443),
    [sym_false] = ACTIONS(3443),
    [anon_sym_NULL] = ACTIONS(3443),
    [anon_sym_nullptr] = ACTIONS(3443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3443),
    [anon_sym_decltype] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_alignas] = ACTIONS(3443),
    [anon_sym_explicit] = ACTIONS(3443),
    [anon_sym_typename] = ACTIONS(3443),
    [anon_sym_template] = ACTIONS(3443),
    [anon_sym_operator] = ACTIONS(3443),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_delete] = ACTIONS(3443),
    [anon_sym_throw] = ACTIONS(3443),
    [anon_sym_namespace] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_static_assert] = ACTIONS(3443),
    [anon_sym_concept] = ACTIONS(3443),
    [anon_sym_co_return] = ACTIONS(3443),
    [anon_sym_co_yield] = ACTIONS(3443),
    [anon_sym_R_DQUOTE] = ACTIONS(3445),
    [anon_sym_LR_DQUOTE] = ACTIONS(3445),
    [anon_sym_uR_DQUOTE] = ACTIONS(3445),
    [anon_sym_UR_DQUOTE] = ACTIONS(3445),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3445),
    [anon_sym_co_await] = ACTIONS(3443),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_requires] = ACTIONS(3443),
    [sym_this] = ACTIONS(3443),
  },
  [437] = {
    [sym_identifier] = ACTIONS(3447),
    [aux_sym_preproc_include_token1] = ACTIONS(3447),
    [aux_sym_preproc_def_token1] = ACTIONS(3447),
    [aux_sym_preproc_if_token1] = ACTIONS(3447),
    [aux_sym_preproc_if_token2] = ACTIONS(3447),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3447),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3447),
    [aux_sym_preproc_else_token1] = ACTIONS(3447),
    [aux_sym_preproc_elif_token1] = ACTIONS(3447),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3447),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3447),
    [sym_preproc_directive] = ACTIONS(3447),
    [anon_sym_LPAREN2] = ACTIONS(3449),
    [anon_sym_BANG] = ACTIONS(3449),
    [anon_sym_TILDE] = ACTIONS(3449),
    [anon_sym_DASH] = ACTIONS(3447),
    [anon_sym_PLUS] = ACTIONS(3447),
    [anon_sym_STAR] = ACTIONS(3449),
    [anon_sym_AMP_AMP] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3447),
    [anon_sym_SEMI] = ACTIONS(3449),
    [anon_sym___extension__] = ACTIONS(3447),
    [anon_sym_typedef] = ACTIONS(3447),
    [anon_sym_extern] = ACTIONS(3447),
    [anon_sym___attribute__] = ACTIONS(3447),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3449),
    [anon_sym___declspec] = ACTIONS(3447),
    [anon_sym___based] = ACTIONS(3447),
    [anon_sym___cdecl] = ACTIONS(3447),
    [anon_sym___clrcall] = ACTIONS(3447),
    [anon_sym___stdcall] = ACTIONS(3447),
    [anon_sym___fastcall] = ACTIONS(3447),
    [anon_sym___thiscall] = ACTIONS(3447),
    [anon_sym___vectorcall] = ACTIONS(3447),
    [anon_sym_LBRACE] = ACTIONS(3449),
    [anon_sym_signed] = ACTIONS(3447),
    [anon_sym_unsigned] = ACTIONS(3447),
    [anon_sym_long] = ACTIONS(3447),
    [anon_sym_short] = ACTIONS(3447),
    [anon_sym_LBRACK] = ACTIONS(3447),
    [anon_sym_static] = ACTIONS(3447),
    [anon_sym_register] = ACTIONS(3447),
    [anon_sym_inline] = ACTIONS(3447),
    [anon_sym___inline] = ACTIONS(3447),
    [anon_sym___inline__] = ACTIONS(3447),
    [anon_sym___forceinline] = ACTIONS(3447),
    [anon_sym_thread_local] = ACTIONS(3447),
    [anon_sym___thread] = ACTIONS(3447),
    [anon_sym_const] = ACTIONS(3447),
    [anon_sym_constexpr] = ACTIONS(3447),
    [anon_sym_volatile] = ACTIONS(3447),
    [anon_sym_restrict] = ACTIONS(3447),
    [anon_sym___restrict__] = ACTIONS(3447),
    [anon_sym__Atomic] = ACTIONS(3447),
    [anon_sym__Noreturn] = ACTIONS(3447),
    [anon_sym_noreturn] = ACTIONS(3447),
    [anon_sym_mutable] = ACTIONS(3447),
    [anon_sym_constinit] = ACTIONS(3447),
    [anon_sym_consteval] = ACTIONS(3447),
    [anon_sym_PROGMEM] = ACTIONS(3447),
    [aux_sym_primitive_type_token1] = ACTIONS(3447),
    [anon_sym_byte] = ACTIONS(3447),
    [anon_sym_word] = ACTIONS(3447),
    [anon_sym_enum] = ACTIONS(3447),
    [anon_sym_class] = ACTIONS(3447),
    [anon_sym_struct] = ACTIONS(3447),
    [anon_sym_union] = ACTIONS(3447),
    [anon_sym_if] = ACTIONS(3447),
    [anon_sym_switch] = ACTIONS(3447),
    [anon_sym_case] = ACTIONS(3447),
    [anon_sym_default] = ACTIONS(3447),
    [anon_sym_while] = ACTIONS(3447),
    [anon_sym_do] = ACTIONS(3447),
    [anon_sym_for] = ACTIONS(3447),
    [anon_sym_return] = ACTIONS(3447),
    [anon_sym_break] = ACTIONS(3447),
    [anon_sym_continue] = ACTIONS(3447),
    [anon_sym_goto] = ACTIONS(3447),
    [anon_sym___try] = ACTIONS(3447),
    [anon_sym___leave] = ACTIONS(3447),
    [anon_sym_not] = ACTIONS(3447),
    [anon_sym_compl] = ACTIONS(3447),
    [anon_sym_DASH_DASH] = ACTIONS(3449),
    [anon_sym_PLUS_PLUS] = ACTIONS(3449),
    [anon_sym_sizeof] = ACTIONS(3447),
    [anon_sym___alignof__] = ACTIONS(3447),
    [anon_sym___alignof] = ACTIONS(3447),
    [anon_sym__alignof] = ACTIONS(3447),
    [anon_sym_alignof] = ACTIONS(3447),
    [anon_sym__Alignof] = ACTIONS(3447),
    [anon_sym_offsetof] = ACTIONS(3447),
    [anon_sym__Generic] = ACTIONS(3447),
    [anon_sym_asm] = ACTIONS(3447),
    [anon_sym___asm__] = ACTIONS(3447),
    [aux_sym_number_literal_token1] = ACTIONS(3449),
    [aux_sym_number_literal_token2] = ACTIONS(3447),
    [anon_sym_L_SQUOTE] = ACTIONS(3449),
    [anon_sym_u_SQUOTE] = ACTIONS(3449),
    [anon_sym_U_SQUOTE] = ACTIONS(3449),
    [anon_sym_u8_SQUOTE] = ACTIONS(3449),
    [anon_sym_SQUOTE] = ACTIONS(3449),
    [anon_sym_L_DQUOTE] = ACTIONS(3449),
    [anon_sym_u_DQUOTE] = ACTIONS(3449),
    [anon_sym_U_DQUOTE] = ACTIONS(3449),
    [anon_sym_u8_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE] = ACTIONS(3449),
    [sym_true] = ACTIONS(3447),
    [sym_false] = ACTIONS(3447),
    [anon_sym_NULL] = ACTIONS(3447),
    [anon_sym_nullptr] = ACTIONS(3447),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3447),
    [anon_sym_decltype] = ACTIONS(3447),
    [anon_sym_virtual] = ACTIONS(3447),
    [anon_sym_alignas] = ACTIONS(3447),
    [anon_sym_explicit] = ACTIONS(3447),
    [anon_sym_typename] = ACTIONS(3447),
    [anon_sym_template] = ACTIONS(3447),
    [anon_sym_operator] = ACTIONS(3447),
    [anon_sym_try] = ACTIONS(3447),
    [anon_sym_delete] = ACTIONS(3447),
    [anon_sym_throw] = ACTIONS(3447),
    [anon_sym_namespace] = ACTIONS(3447),
    [anon_sym_using] = ACTIONS(3447),
    [anon_sym_static_assert] = ACTIONS(3447),
    [anon_sym_concept] = ACTIONS(3447),
    [anon_sym_co_return] = ACTIONS(3447),
    [anon_sym_co_yield] = ACTIONS(3447),
    [anon_sym_R_DQUOTE] = ACTIONS(3449),
    [anon_sym_LR_DQUOTE] = ACTIONS(3449),
    [anon_sym_uR_DQUOTE] = ACTIONS(3449),
    [anon_sym_UR_DQUOTE] = ACTIONS(3449),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3449),
    [anon_sym_co_await] = ACTIONS(3447),
    [anon_sym_new] = ACTIONS(3447),
    [anon_sym_requires] = ACTIONS(3447),
    [sym_this] = ACTIONS(3447),
  },
  [438] = {
    [sym_identifier] = ACTIONS(3451),
    [aux_sym_preproc_include_token1] = ACTIONS(3451),
    [aux_sym_preproc_def_token1] = ACTIONS(3451),
    [aux_sym_preproc_if_token1] = ACTIONS(3451),
    [aux_sym_preproc_if_token2] = ACTIONS(3451),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3451),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3451),
    [aux_sym_preproc_else_token1] = ACTIONS(3451),
    [aux_sym_preproc_elif_token1] = ACTIONS(3451),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3451),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3451),
    [sym_preproc_directive] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3453),
    [anon_sym_BANG] = ACTIONS(3453),
    [anon_sym_TILDE] = ACTIONS(3453),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(3453),
    [anon_sym_AMP_AMP] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_SEMI] = ACTIONS(3453),
    [anon_sym___extension__] = ACTIONS(3451),
    [anon_sym_typedef] = ACTIONS(3451),
    [anon_sym_extern] = ACTIONS(3451),
    [anon_sym___attribute__] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3453),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3453),
    [anon_sym___declspec] = ACTIONS(3451),
    [anon_sym___based] = ACTIONS(3451),
    [anon_sym___cdecl] = ACTIONS(3451),
    [anon_sym___clrcall] = ACTIONS(3451),
    [anon_sym___stdcall] = ACTIONS(3451),
    [anon_sym___fastcall] = ACTIONS(3451),
    [anon_sym___thiscall] = ACTIONS(3451),
    [anon_sym___vectorcall] = ACTIONS(3451),
    [anon_sym_LBRACE] = ACTIONS(3453),
    [anon_sym_signed] = ACTIONS(3451),
    [anon_sym_unsigned] = ACTIONS(3451),
    [anon_sym_long] = ACTIONS(3451),
    [anon_sym_short] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_register] = ACTIONS(3451),
    [anon_sym_inline] = ACTIONS(3451),
    [anon_sym___inline] = ACTIONS(3451),
    [anon_sym___inline__] = ACTIONS(3451),
    [anon_sym___forceinline] = ACTIONS(3451),
    [anon_sym_thread_local] = ACTIONS(3451),
    [anon_sym___thread] = ACTIONS(3451),
    [anon_sym_const] = ACTIONS(3451),
    [anon_sym_constexpr] = ACTIONS(3451),
    [anon_sym_volatile] = ACTIONS(3451),
    [anon_sym_restrict] = ACTIONS(3451),
    [anon_sym___restrict__] = ACTIONS(3451),
    [anon_sym__Atomic] = ACTIONS(3451),
    [anon_sym__Noreturn] = ACTIONS(3451),
    [anon_sym_noreturn] = ACTIONS(3451),
    [anon_sym_mutable] = ACTIONS(3451),
    [anon_sym_constinit] = ACTIONS(3451),
    [anon_sym_consteval] = ACTIONS(3451),
    [anon_sym_PROGMEM] = ACTIONS(3451),
    [aux_sym_primitive_type_token1] = ACTIONS(3451),
    [anon_sym_byte] = ACTIONS(3451),
    [anon_sym_word] = ACTIONS(3451),
    [anon_sym_enum] = ACTIONS(3451),
    [anon_sym_class] = ACTIONS(3451),
    [anon_sym_struct] = ACTIONS(3451),
    [anon_sym_union] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_switch] = ACTIONS(3451),
    [anon_sym_case] = ACTIONS(3451),
    [anon_sym_default] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_break] = ACTIONS(3451),
    [anon_sym_continue] = ACTIONS(3451),
    [anon_sym_goto] = ACTIONS(3451),
    [anon_sym___try] = ACTIONS(3451),
    [anon_sym___leave] = ACTIONS(3451),
    [anon_sym_not] = ACTIONS(3451),
    [anon_sym_compl] = ACTIONS(3451),
    [anon_sym_DASH_DASH] = ACTIONS(3453),
    [anon_sym_PLUS_PLUS] = ACTIONS(3453),
    [anon_sym_sizeof] = ACTIONS(3451),
    [anon_sym___alignof__] = ACTIONS(3451),
    [anon_sym___alignof] = ACTIONS(3451),
    [anon_sym__alignof] = ACTIONS(3451),
    [anon_sym_alignof] = ACTIONS(3451),
    [anon_sym__Alignof] = ACTIONS(3451),
    [anon_sym_offsetof] = ACTIONS(3451),
    [anon_sym__Generic] = ACTIONS(3451),
    [anon_sym_asm] = ACTIONS(3451),
    [anon_sym___asm__] = ACTIONS(3451),
    [aux_sym_number_literal_token1] = ACTIONS(3453),
    [aux_sym_number_literal_token2] = ACTIONS(3451),
    [anon_sym_L_SQUOTE] = ACTIONS(3453),
    [anon_sym_u_SQUOTE] = ACTIONS(3453),
    [anon_sym_U_SQUOTE] = ACTIONS(3453),
    [anon_sym_u8_SQUOTE] = ACTIONS(3453),
    [anon_sym_SQUOTE] = ACTIONS(3453),
    [anon_sym_L_DQUOTE] = ACTIONS(3453),
    [anon_sym_u_DQUOTE] = ACTIONS(3453),
    [anon_sym_U_DQUOTE] = ACTIONS(3453),
    [anon_sym_u8_DQUOTE] = ACTIONS(3453),
    [anon_sym_DQUOTE] = ACTIONS(3453),
    [sym_true] = ACTIONS(3451),
    [sym_false] = ACTIONS(3451),
    [anon_sym_NULL] = ACTIONS(3451),
    [anon_sym_nullptr] = ACTIONS(3451),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3451),
    [anon_sym_decltype] = ACTIONS(3451),
    [anon_sym_virtual] = ACTIONS(3451),
    [anon_sym_alignas] = ACTIONS(3451),
    [anon_sym_explicit] = ACTIONS(3451),
    [anon_sym_typename] = ACTIONS(3451),
    [anon_sym_template] = ACTIONS(3451),
    [anon_sym_operator] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_delete] = ACTIONS(3451),
    [anon_sym_throw] = ACTIONS(3451),
    [anon_sym_namespace] = ACTIONS(3451),
    [anon_sym_using] = ACTIONS(3451),
    [anon_sym_static_assert] = ACTIONS(3451),
    [anon_sym_concept] = ACTIONS(3451),
    [anon_sym_co_return] = ACTIONS(3451),
    [anon_sym_co_yield] = ACTIONS(3451),
    [anon_sym_R_DQUOTE] = ACTIONS(3453),
    [anon_sym_LR_DQUOTE] = ACTIONS(3453),
    [anon_sym_uR_DQUOTE] = ACTIONS(3453),
    [anon_sym_UR_DQUOTE] = ACTIONS(3453),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3453),
    [anon_sym_co_await] = ACTIONS(3451),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_requires] = ACTIONS(3451),
    [sym_this] = ACTIONS(3451),
  },
  [439] = {
    [sym_identifier] = ACTIONS(3455),
    [aux_sym_preproc_include_token1] = ACTIONS(3455),
    [aux_sym_preproc_def_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token2] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3455),
    [aux_sym_preproc_else_token1] = ACTIONS(3455),
    [aux_sym_preproc_elif_token1] = ACTIONS(3455),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3455),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3455),
    [sym_preproc_directive] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_BANG] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_STAR] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_SEMI] = ACTIONS(3457),
    [anon_sym___extension__] = ACTIONS(3455),
    [anon_sym_typedef] = ACTIONS(3455),
    [anon_sym_extern] = ACTIONS(3455),
    [anon_sym___attribute__] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3457),
    [anon_sym___declspec] = ACTIONS(3455),
    [anon_sym___based] = ACTIONS(3455),
    [anon_sym___cdecl] = ACTIONS(3455),
    [anon_sym___clrcall] = ACTIONS(3455),
    [anon_sym___stdcall] = ACTIONS(3455),
    [anon_sym___fastcall] = ACTIONS(3455),
    [anon_sym___thiscall] = ACTIONS(3455),
    [anon_sym___vectorcall] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_signed] = ACTIONS(3455),
    [anon_sym_unsigned] = ACTIONS(3455),
    [anon_sym_long] = ACTIONS(3455),
    [anon_sym_short] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_static] = ACTIONS(3455),
    [anon_sym_register] = ACTIONS(3455),
    [anon_sym_inline] = ACTIONS(3455),
    [anon_sym___inline] = ACTIONS(3455),
    [anon_sym___inline__] = ACTIONS(3455),
    [anon_sym___forceinline] = ACTIONS(3455),
    [anon_sym_thread_local] = ACTIONS(3455),
    [anon_sym___thread] = ACTIONS(3455),
    [anon_sym_const] = ACTIONS(3455),
    [anon_sym_constexpr] = ACTIONS(3455),
    [anon_sym_volatile] = ACTIONS(3455),
    [anon_sym_restrict] = ACTIONS(3455),
    [anon_sym___restrict__] = ACTIONS(3455),
    [anon_sym__Atomic] = ACTIONS(3455),
    [anon_sym__Noreturn] = ACTIONS(3455),
    [anon_sym_noreturn] = ACTIONS(3455),
    [anon_sym_mutable] = ACTIONS(3455),
    [anon_sym_constinit] = ACTIONS(3455),
    [anon_sym_consteval] = ACTIONS(3455),
    [anon_sym_PROGMEM] = ACTIONS(3455),
    [aux_sym_primitive_type_token1] = ACTIONS(3455),
    [anon_sym_byte] = ACTIONS(3455),
    [anon_sym_word] = ACTIONS(3455),
    [anon_sym_enum] = ACTIONS(3455),
    [anon_sym_class] = ACTIONS(3455),
    [anon_sym_struct] = ACTIONS(3455),
    [anon_sym_union] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_switch] = ACTIONS(3455),
    [anon_sym_case] = ACTIONS(3455),
    [anon_sym_default] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_break] = ACTIONS(3455),
    [anon_sym_continue] = ACTIONS(3455),
    [anon_sym_goto] = ACTIONS(3455),
    [anon_sym___try] = ACTIONS(3455),
    [anon_sym___leave] = ACTIONS(3455),
    [anon_sym_not] = ACTIONS(3455),
    [anon_sym_compl] = ACTIONS(3455),
    [anon_sym_DASH_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_PLUS] = ACTIONS(3457),
    [anon_sym_sizeof] = ACTIONS(3455),
    [anon_sym___alignof__] = ACTIONS(3455),
    [anon_sym___alignof] = ACTIONS(3455),
    [anon_sym__alignof] = ACTIONS(3455),
    [anon_sym_alignof] = ACTIONS(3455),
    [anon_sym__Alignof] = ACTIONS(3455),
    [anon_sym_offsetof] = ACTIONS(3455),
    [anon_sym__Generic] = ACTIONS(3455),
    [anon_sym_asm] = ACTIONS(3455),
    [anon_sym___asm__] = ACTIONS(3455),
    [aux_sym_number_literal_token1] = ACTIONS(3457),
    [aux_sym_number_literal_token2] = ACTIONS(3455),
    [anon_sym_L_SQUOTE] = ACTIONS(3457),
    [anon_sym_u_SQUOTE] = ACTIONS(3457),
    [anon_sym_U_SQUOTE] = ACTIONS(3457),
    [anon_sym_u8_SQUOTE] = ACTIONS(3457),
    [anon_sym_SQUOTE] = ACTIONS(3457),
    [anon_sym_L_DQUOTE] = ACTIONS(3457),
    [anon_sym_u_DQUOTE] = ACTIONS(3457),
    [anon_sym_U_DQUOTE] = ACTIONS(3457),
    [anon_sym_u8_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [sym_true] = ACTIONS(3455),
    [sym_false] = ACTIONS(3455),
    [anon_sym_NULL] = ACTIONS(3455),
    [anon_sym_nullptr] = ACTIONS(3455),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3455),
    [anon_sym_decltype] = ACTIONS(3455),
    [anon_sym_virtual] = ACTIONS(3455),
    [anon_sym_alignas] = ACTIONS(3455),
    [anon_sym_explicit] = ACTIONS(3455),
    [anon_sym_typename] = ACTIONS(3455),
    [anon_sym_template] = ACTIONS(3455),
    [anon_sym_operator] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_delete] = ACTIONS(3455),
    [anon_sym_throw] = ACTIONS(3455),
    [anon_sym_namespace] = ACTIONS(3455),
    [anon_sym_using] = ACTIONS(3455),
    [anon_sym_static_assert] = ACTIONS(3455),
    [anon_sym_concept] = ACTIONS(3455),
    [anon_sym_co_return] = ACTIONS(3455),
    [anon_sym_co_yield] = ACTIONS(3455),
    [anon_sym_R_DQUOTE] = ACTIONS(3457),
    [anon_sym_LR_DQUOTE] = ACTIONS(3457),
    [anon_sym_uR_DQUOTE] = ACTIONS(3457),
    [anon_sym_UR_DQUOTE] = ACTIONS(3457),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3457),
    [anon_sym_co_await] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_requires] = ACTIONS(3455),
    [sym_this] = ACTIONS(3455),
  },
  [440] = {
    [sym_else_clause] = STATE(530),
    [sym_identifier] = ACTIONS(2891),
    [aux_sym_preproc_include_token1] = ACTIONS(2891),
    [aux_sym_preproc_def_token1] = ACTIONS(2891),
    [aux_sym_preproc_if_token1] = ACTIONS(2891),
    [aux_sym_preproc_if_token2] = ACTIONS(2891),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2891),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2891),
    [aux_sym_preproc_else_token1] = ACTIONS(2891),
    [aux_sym_preproc_elif_token1] = ACTIONS(2891),
    [sym_preproc_directive] = ACTIONS(2891),
    [anon_sym_LPAREN2] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_AMP_AMP] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym___extension__] = ACTIONS(2891),
    [anon_sym_typedef] = ACTIONS(2891),
    [anon_sym_extern] = ACTIONS(2891),
    [anon_sym___attribute__] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2893),
    [anon_sym___declspec] = ACTIONS(2891),
    [anon_sym___based] = ACTIONS(2891),
    [anon_sym___cdecl] = ACTIONS(2891),
    [anon_sym___clrcall] = ACTIONS(2891),
    [anon_sym___stdcall] = ACTIONS(2891),
    [anon_sym___fastcall] = ACTIONS(2891),
    [anon_sym___thiscall] = ACTIONS(2891),
    [anon_sym___vectorcall] = ACTIONS(2891),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_signed] = ACTIONS(2891),
    [anon_sym_unsigned] = ACTIONS(2891),
    [anon_sym_long] = ACTIONS(2891),
    [anon_sym_short] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_static] = ACTIONS(2891),
    [anon_sym_register] = ACTIONS(2891),
    [anon_sym_inline] = ACTIONS(2891),
    [anon_sym___inline] = ACTIONS(2891),
    [anon_sym___inline__] = ACTIONS(2891),
    [anon_sym___forceinline] = ACTIONS(2891),
    [anon_sym_thread_local] = ACTIONS(2891),
    [anon_sym___thread] = ACTIONS(2891),
    [anon_sym_const] = ACTIONS(2891),
    [anon_sym_constexpr] = ACTIONS(2891),
    [anon_sym_volatile] = ACTIONS(2891),
    [anon_sym_restrict] = ACTIONS(2891),
    [anon_sym___restrict__] = ACTIONS(2891),
    [anon_sym__Atomic] = ACTIONS(2891),
    [anon_sym__Noreturn] = ACTIONS(2891),
    [anon_sym_noreturn] = ACTIONS(2891),
    [anon_sym_mutable] = ACTIONS(2891),
    [anon_sym_constinit] = ACTIONS(2891),
    [anon_sym_consteval] = ACTIONS(2891),
    [anon_sym_PROGMEM] = ACTIONS(2891),
    [aux_sym_primitive_type_token1] = ACTIONS(2891),
    [anon_sym_byte] = ACTIONS(2891),
    [anon_sym_word] = ACTIONS(2891),
    [anon_sym_enum] = ACTIONS(2891),
    [anon_sym_class] = ACTIONS(2891),
    [anon_sym_struct] = ACTIONS(2891),
    [anon_sym_union] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_else] = ACTIONS(3308),
    [anon_sym_switch] = ACTIONS(2891),
    [anon_sym_case] = ACTIONS(2891),
    [anon_sym_default] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2891),
    [anon_sym_for] = ACTIONS(2891),
    [anon_sym_return] = ACTIONS(2891),
    [anon_sym_break] = ACTIONS(2891),
    [anon_sym_continue] = ACTIONS(2891),
    [anon_sym_goto] = ACTIONS(2891),
    [anon_sym___try] = ACTIONS(2891),
    [anon_sym___leave] = ACTIONS(2891),
    [anon_sym_not] = ACTIONS(2891),
    [anon_sym_compl] = ACTIONS(2891),
    [anon_sym_DASH_DASH] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2893),
    [anon_sym_sizeof] = ACTIONS(2891),
    [anon_sym___alignof__] = ACTIONS(2891),
    [anon_sym___alignof] = ACTIONS(2891),
    [anon_sym__alignof] = ACTIONS(2891),
    [anon_sym_alignof] = ACTIONS(2891),
    [anon_sym__Alignof] = ACTIONS(2891),
    [anon_sym_offsetof] = ACTIONS(2891),
    [anon_sym__Generic] = ACTIONS(2891),
    [anon_sym_asm] = ACTIONS(2891),
    [anon_sym___asm__] = ACTIONS(2891),
    [aux_sym_number_literal_token1] = ACTIONS(2893),
    [aux_sym_number_literal_token2] = ACTIONS(2891),
    [anon_sym_L_SQUOTE] = ACTIONS(2893),
    [anon_sym_u_SQUOTE] = ACTIONS(2893),
    [anon_sym_U_SQUOTE] = ACTIONS(2893),
    [anon_sym_u8_SQUOTE] = ACTIONS(2893),
    [anon_sym_SQUOTE] = ACTIONS(2893),
    [anon_sym_L_DQUOTE] = ACTIONS(2893),
    [anon_sym_u_DQUOTE] = ACTIONS(2893),
    [anon_sym_U_DQUOTE] = ACTIONS(2893),
    [anon_sym_u8_DQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(2893),
    [sym_true] = ACTIONS(2891),
    [sym_false] = ACTIONS(2891),
    [anon_sym_NULL] = ACTIONS(2891),
    [anon_sym_nullptr] = ACTIONS(2891),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2891),
    [anon_sym_decltype] = ACTIONS(2891),
    [anon_sym_virtual] = ACTIONS(2891),
    [anon_sym_alignas] = ACTIONS(2891),
    [anon_sym_explicit] = ACTIONS(2891),
    [anon_sym_typename] = ACTIONS(2891),
    [anon_sym_template] = ACTIONS(2891),
    [anon_sym_operator] = ACTIONS(2891),
    [anon_sym_try] = ACTIONS(2891),
    [anon_sym_delete] = ACTIONS(2891),
    [anon_sym_throw] = ACTIONS(2891),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_using] = ACTIONS(2891),
    [anon_sym_static_assert] = ACTIONS(2891),
    [anon_sym_concept] = ACTIONS(2891),
    [anon_sym_co_return] = ACTIONS(2891),
    [anon_sym_co_yield] = ACTIONS(2891),
    [anon_sym_R_DQUOTE] = ACTIONS(2893),
    [anon_sym_LR_DQUOTE] = ACTIONS(2893),
    [anon_sym_uR_DQUOTE] = ACTIONS(2893),
    [anon_sym_UR_DQUOTE] = ACTIONS(2893),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2893),
    [anon_sym_co_await] = ACTIONS(2891),
    [anon_sym_new] = ACTIONS(2891),
    [anon_sym_requires] = ACTIONS(2891),
    [sym_this] = ACTIONS(2891),
  },
  [441] = {
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_unaligned_ptr_modifier] = STATE(4993),
    [sym_ms_pointer_modifier] = STATE(3988),
    [sym__declarator] = STATE(7255),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7008),
    [sym_array_declarator] = STATE(7008),
    [sym_type_qualifier] = STATE(4764),
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4013),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6503),
    [sym_qualified_identifier] = STATE(4014),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3026),
    [aux_sym__type_definition_type_repeat1] = STATE(4764),
    [aux_sym_pointer_declarator_repeat1] = STATE(3988),
    [sym_identifier] = ACTIONS(3459),
    [anon_sym_LPAREN2] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(3463),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(3397),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym___based] = ACTIONS(47),
    [sym_ms_restrict_modifier] = ACTIONS(3399),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3399),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3399),
    [anon_sym__unaligned] = ACTIONS(3401),
    [anon_sym___unaligned] = ACTIONS(3401),
    [anon_sym_LBRACK] = ACTIONS(2095),
    [anon_sym_const] = ACTIONS(3397),
    [anon_sym_constexpr] = ACTIONS(3397),
    [anon_sym_volatile] = ACTIONS(3397),
    [anon_sym_restrict] = ACTIONS(3397),
    [anon_sym___restrict__] = ACTIONS(3397),
    [anon_sym__Atomic] = ACTIONS(3397),
    [anon_sym__Noreturn] = ACTIONS(3397),
    [anon_sym_noreturn] = ACTIONS(3397),
    [anon_sym_mutable] = ACTIONS(3397),
    [anon_sym_constinit] = ACTIONS(3397),
    [anon_sym_consteval] = ACTIONS(3397),
    [anon_sym_PROGMEM] = ACTIONS(3397),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(2137),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [442] = {
    [sym_identifier] = ACTIONS(3467),
    [aux_sym_preproc_include_token1] = ACTIONS(3467),
    [aux_sym_preproc_def_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token2] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3467),
    [aux_sym_preproc_else_token1] = ACTIONS(3467),
    [aux_sym_preproc_elif_token1] = ACTIONS(3467),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3467),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3467),
    [sym_preproc_directive] = ACTIONS(3467),
    [anon_sym_LPAREN2] = ACTIONS(3469),
    [anon_sym_BANG] = ACTIONS(3469),
    [anon_sym_TILDE] = ACTIONS(3469),
    [anon_sym_DASH] = ACTIONS(3467),
    [anon_sym_PLUS] = ACTIONS(3467),
    [anon_sym_STAR] = ACTIONS(3469),
    [anon_sym_AMP_AMP] = ACTIONS(3469),
    [anon_sym_AMP] = ACTIONS(3467),
    [anon_sym_SEMI] = ACTIONS(3469),
    [anon_sym___extension__] = ACTIONS(3467),
    [anon_sym_typedef] = ACTIONS(3467),
    [anon_sym_extern] = ACTIONS(3467),
    [anon_sym___attribute__] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(3469),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3469),
    [anon_sym___declspec] = ACTIONS(3467),
    [anon_sym___based] = ACTIONS(3467),
    [anon_sym___cdecl] = ACTIONS(3467),
    [anon_sym___clrcall] = ACTIONS(3467),
    [anon_sym___stdcall] = ACTIONS(3467),
    [anon_sym___fastcall] = ACTIONS(3467),
    [anon_sym___thiscall] = ACTIONS(3467),
    [anon_sym___vectorcall] = ACTIONS(3467),
    [anon_sym_LBRACE] = ACTIONS(3469),
    [anon_sym_signed] = ACTIONS(3467),
    [anon_sym_unsigned] = ACTIONS(3467),
    [anon_sym_long] = ACTIONS(3467),
    [anon_sym_short] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [anon_sym_static] = ACTIONS(3467),
    [anon_sym_register] = ACTIONS(3467),
    [anon_sym_inline] = ACTIONS(3467),
    [anon_sym___inline] = ACTIONS(3467),
    [anon_sym___inline__] = ACTIONS(3467),
    [anon_sym___forceinline] = ACTIONS(3467),
    [anon_sym_thread_local] = ACTIONS(3467),
    [anon_sym___thread] = ACTIONS(3467),
    [anon_sym_const] = ACTIONS(3467),
    [anon_sym_constexpr] = ACTIONS(3467),
    [anon_sym_volatile] = ACTIONS(3467),
    [anon_sym_restrict] = ACTIONS(3467),
    [anon_sym___restrict__] = ACTIONS(3467),
    [anon_sym__Atomic] = ACTIONS(3467),
    [anon_sym__Noreturn] = ACTIONS(3467),
    [anon_sym_noreturn] = ACTIONS(3467),
    [anon_sym_mutable] = ACTIONS(3467),
    [anon_sym_constinit] = ACTIONS(3467),
    [anon_sym_consteval] = ACTIONS(3467),
    [anon_sym_PROGMEM] = ACTIONS(3467),
    [aux_sym_primitive_type_token1] = ACTIONS(3467),
    [anon_sym_byte] = ACTIONS(3467),
    [anon_sym_word] = ACTIONS(3467),
    [anon_sym_enum] = ACTIONS(3467),
    [anon_sym_class] = ACTIONS(3467),
    [anon_sym_struct] = ACTIONS(3467),
    [anon_sym_union] = ACTIONS(3467),
    [anon_sym_if] = ACTIONS(3467),
    [anon_sym_switch] = ACTIONS(3467),
    [anon_sym_case] = ACTIONS(3467),
    [anon_sym_default] = ACTIONS(3467),
    [anon_sym_while] = ACTIONS(3467),
    [anon_sym_do] = ACTIONS(3467),
    [anon_sym_for] = ACTIONS(3467),
    [anon_sym_return] = ACTIONS(3467),
    [anon_sym_break] = ACTIONS(3467),
    [anon_sym_continue] = ACTIONS(3467),
    [anon_sym_goto] = ACTIONS(3467),
    [anon_sym___try] = ACTIONS(3467),
    [anon_sym___leave] = ACTIONS(3467),
    [anon_sym_not] = ACTIONS(3467),
    [anon_sym_compl] = ACTIONS(3467),
    [anon_sym_DASH_DASH] = ACTIONS(3469),
    [anon_sym_PLUS_PLUS] = ACTIONS(3469),
    [anon_sym_sizeof] = ACTIONS(3467),
    [anon_sym___alignof__] = ACTIONS(3467),
    [anon_sym___alignof] = ACTIONS(3467),
    [anon_sym__alignof] = ACTIONS(3467),
    [anon_sym_alignof] = ACTIONS(3467),
    [anon_sym__Alignof] = ACTIONS(3467),
    [anon_sym_offsetof] = ACTIONS(3467),
    [anon_sym__Generic] = ACTIONS(3467),
    [anon_sym_asm] = ACTIONS(3467),
    [anon_sym___asm__] = ACTIONS(3467),
    [aux_sym_number_literal_token1] = ACTIONS(3469),
    [aux_sym_number_literal_token2] = ACTIONS(3467),
    [anon_sym_L_SQUOTE] = ACTIONS(3469),
    [anon_sym_u_SQUOTE] = ACTIONS(3469),
    [anon_sym_U_SQUOTE] = ACTIONS(3469),
    [anon_sym_u8_SQUOTE] = ACTIONS(3469),
    [anon_sym_SQUOTE] = ACTIONS(3469),
    [anon_sym_L_DQUOTE] = ACTIONS(3469),
    [anon_sym_u_DQUOTE] = ACTIONS(3469),
    [anon_sym_U_DQUOTE] = ACTIONS(3469),
    [anon_sym_u8_DQUOTE] = ACTIONS(3469),
    [anon_sym_DQUOTE] = ACTIONS(3469),
    [sym_true] = ACTIONS(3467),
    [sym_false] = ACTIONS(3467),
    [anon_sym_NULL] = ACTIONS(3467),
    [anon_sym_nullptr] = ACTIONS(3467),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3467),
    [anon_sym_decltype] = ACTIONS(3467),
    [anon_sym_virtual] = ACTIONS(3467),
    [anon_sym_alignas] = ACTIONS(3467),
    [anon_sym_explicit] = ACTIONS(3467),
    [anon_sym_typename] = ACTIONS(3467),
    [anon_sym_template] = ACTIONS(3467),
    [anon_sym_operator] = ACTIONS(3467),
    [anon_sym_try] = ACTIONS(3467),
    [anon_sym_delete] = ACTIONS(3467),
    [anon_sym_throw] = ACTIONS(3467),
    [anon_sym_namespace] = ACTIONS(3467),
    [anon_sym_using] = ACTIONS(3467),
    [anon_sym_static_assert] = ACTIONS(3467),
    [anon_sym_concept] = ACTIONS(3467),
    [anon_sym_co_return] = ACTIONS(3467),
    [anon_sym_co_yield] = ACTIONS(3467),
    [anon_sym_R_DQUOTE] = ACTIONS(3469),
    [anon_sym_LR_DQUOTE] = ACTIONS(3469),
    [anon_sym_uR_DQUOTE] = ACTIONS(3469),
    [anon_sym_UR_DQUOTE] = ACTIONS(3469),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3469),
    [anon_sym_co_await] = ACTIONS(3467),
    [anon_sym_new] = ACTIONS(3467),
    [anon_sym_requires] = ACTIONS(3467),
    [sym_this] = ACTIONS(3467),
  },
  [443] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_include_token1] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token2] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [aux_sym_preproc_else_token1] = ACTIONS(2267),
    [aux_sym_preproc_elif_token1] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_BANG] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(2265),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym___cdecl] = ACTIONS(2267),
    [anon_sym___clrcall] = ACTIONS(2267),
    [anon_sym___stdcall] = ACTIONS(2267),
    [anon_sym___fastcall] = ACTIONS(2267),
    [anon_sym___thiscall] = ACTIONS(2267),
    [anon_sym___vectorcall] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2265),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_else] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_case] = ACTIONS(2267),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_return] = ACTIONS(2267),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_continue] = ACTIONS(2267),
    [anon_sym_goto] = ACTIONS(2267),
    [anon_sym___try] = ACTIONS(2267),
    [anon_sym___leave] = ACTIONS(2267),
    [anon_sym_not] = ACTIONS(2267),
    [anon_sym_compl] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2265),
    [anon_sym_PLUS_PLUS] = ACTIONS(2265),
    [anon_sym_sizeof] = ACTIONS(2267),
    [anon_sym___alignof__] = ACTIONS(2267),
    [anon_sym___alignof] = ACTIONS(2267),
    [anon_sym__alignof] = ACTIONS(2267),
    [anon_sym_alignof] = ACTIONS(2267),
    [anon_sym__Alignof] = ACTIONS(2267),
    [anon_sym_offsetof] = ACTIONS(2267),
    [anon_sym__Generic] = ACTIONS(2267),
    [anon_sym_asm] = ACTIONS(2267),
    [anon_sym___asm__] = ACTIONS(2267),
    [aux_sym_number_literal_token1] = ACTIONS(2265),
    [aux_sym_number_literal_token2] = ACTIONS(2267),
    [anon_sym_L_SQUOTE] = ACTIONS(2265),
    [anon_sym_u_SQUOTE] = ACTIONS(2265),
    [anon_sym_U_SQUOTE] = ACTIONS(2265),
    [anon_sym_u8_SQUOTE] = ACTIONS(2265),
    [anon_sym_SQUOTE] = ACTIONS(2265),
    [anon_sym_L_DQUOTE] = ACTIONS(2265),
    [anon_sym_u_DQUOTE] = ACTIONS(2265),
    [anon_sym_U_DQUOTE] = ACTIONS(2265),
    [anon_sym_u8_DQUOTE] = ACTIONS(2265),
    [anon_sym_DQUOTE] = ACTIONS(2265),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [anon_sym_NULL] = ACTIONS(2267),
    [anon_sym_nullptr] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_try] = ACTIONS(2267),
    [anon_sym_delete] = ACTIONS(2267),
    [anon_sym_throw] = ACTIONS(2267),
    [anon_sym_namespace] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym_concept] = ACTIONS(2267),
    [anon_sym_co_return] = ACTIONS(2267),
    [anon_sym_co_yield] = ACTIONS(2267),
    [anon_sym_catch] = ACTIONS(2267),
    [anon_sym_R_DQUOTE] = ACTIONS(2265),
    [anon_sym_LR_DQUOTE] = ACTIONS(2265),
    [anon_sym_uR_DQUOTE] = ACTIONS(2265),
    [anon_sym_UR_DQUOTE] = ACTIONS(2265),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2265),
    [anon_sym_co_await] = ACTIONS(2267),
    [anon_sym_new] = ACTIONS(2267),
    [anon_sym_requires] = ACTIONS(2267),
    [sym_this] = ACTIONS(2267),
  },
  [444] = {
    [sym_identifier] = ACTIONS(3471),
    [aux_sym_preproc_include_token1] = ACTIONS(3471),
    [aux_sym_preproc_def_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token2] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3471),
    [aux_sym_preproc_else_token1] = ACTIONS(3471),
    [aux_sym_preproc_elif_token1] = ACTIONS(3471),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3471),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3471),
    [sym_preproc_directive] = ACTIONS(3471),
    [anon_sym_LPAREN2] = ACTIONS(3473),
    [anon_sym_BANG] = ACTIONS(3473),
    [anon_sym_TILDE] = ACTIONS(3473),
    [anon_sym_DASH] = ACTIONS(3471),
    [anon_sym_PLUS] = ACTIONS(3471),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_AMP_AMP] = ACTIONS(3473),
    [anon_sym_AMP] = ACTIONS(3471),
    [anon_sym_SEMI] = ACTIONS(3473),
    [anon_sym___extension__] = ACTIONS(3471),
    [anon_sym_typedef] = ACTIONS(3471),
    [anon_sym_extern] = ACTIONS(3471),
    [anon_sym___attribute__] = ACTIONS(3471),
    [anon_sym_COLON_COLON] = ACTIONS(3473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3473),
    [anon_sym___declspec] = ACTIONS(3471),
    [anon_sym___based] = ACTIONS(3471),
    [anon_sym___cdecl] = ACTIONS(3471),
    [anon_sym___clrcall] = ACTIONS(3471),
    [anon_sym___stdcall] = ACTIONS(3471),
    [anon_sym___fastcall] = ACTIONS(3471),
    [anon_sym___thiscall] = ACTIONS(3471),
    [anon_sym___vectorcall] = ACTIONS(3471),
    [anon_sym_LBRACE] = ACTIONS(3473),
    [anon_sym_signed] = ACTIONS(3471),
    [anon_sym_unsigned] = ACTIONS(3471),
    [anon_sym_long] = ACTIONS(3471),
    [anon_sym_short] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [anon_sym_static] = ACTIONS(3471),
    [anon_sym_register] = ACTIONS(3471),
    [anon_sym_inline] = ACTIONS(3471),
    [anon_sym___inline] = ACTIONS(3471),
    [anon_sym___inline__] = ACTIONS(3471),
    [anon_sym___forceinline] = ACTIONS(3471),
    [anon_sym_thread_local] = ACTIONS(3471),
    [anon_sym___thread] = ACTIONS(3471),
    [anon_sym_const] = ACTIONS(3471),
    [anon_sym_constexpr] = ACTIONS(3471),
    [anon_sym_volatile] = ACTIONS(3471),
    [anon_sym_restrict] = ACTIONS(3471),
    [anon_sym___restrict__] = ACTIONS(3471),
    [anon_sym__Atomic] = ACTIONS(3471),
    [anon_sym__Noreturn] = ACTIONS(3471),
    [anon_sym_noreturn] = ACTIONS(3471),
    [anon_sym_mutable] = ACTIONS(3471),
    [anon_sym_constinit] = ACTIONS(3471),
    [anon_sym_consteval] = ACTIONS(3471),
    [anon_sym_PROGMEM] = ACTIONS(3471),
    [aux_sym_primitive_type_token1] = ACTIONS(3471),
    [anon_sym_byte] = ACTIONS(3471),
    [anon_sym_word] = ACTIONS(3471),
    [anon_sym_enum] = ACTIONS(3471),
    [anon_sym_class] = ACTIONS(3471),
    [anon_sym_struct] = ACTIONS(3471),
    [anon_sym_union] = ACTIONS(3471),
    [anon_sym_if] = ACTIONS(3471),
    [anon_sym_switch] = ACTIONS(3471),
    [anon_sym_case] = ACTIONS(3471),
    [anon_sym_default] = ACTIONS(3471),
    [anon_sym_while] = ACTIONS(3471),
    [anon_sym_do] = ACTIONS(3471),
    [anon_sym_for] = ACTIONS(3471),
    [anon_sym_return] = ACTIONS(3471),
    [anon_sym_break] = ACTIONS(3471),
    [anon_sym_continue] = ACTIONS(3471),
    [anon_sym_goto] = ACTIONS(3471),
    [anon_sym___try] = ACTIONS(3471),
    [anon_sym___leave] = ACTIONS(3471),
    [anon_sym_not] = ACTIONS(3471),
    [anon_sym_compl] = ACTIONS(3471),
    [anon_sym_DASH_DASH] = ACTIONS(3473),
    [anon_sym_PLUS_PLUS] = ACTIONS(3473),
    [anon_sym_sizeof] = ACTIONS(3471),
    [anon_sym___alignof__] = ACTIONS(3471),
    [anon_sym___alignof] = ACTIONS(3471),
    [anon_sym__alignof] = ACTIONS(3471),
    [anon_sym_alignof] = ACTIONS(3471),
    [anon_sym__Alignof] = ACTIONS(3471),
    [anon_sym_offsetof] = ACTIONS(3471),
    [anon_sym__Generic] = ACTIONS(3471),
    [anon_sym_asm] = ACTIONS(3471),
    [anon_sym___asm__] = ACTIONS(3471),
    [aux_sym_number_literal_token1] = ACTIONS(3473),
    [aux_sym_number_literal_token2] = ACTIONS(3471),
    [anon_sym_L_SQUOTE] = ACTIONS(3473),
    [anon_sym_u_SQUOTE] = ACTIONS(3473),
    [anon_sym_U_SQUOTE] = ACTIONS(3473),
    [anon_sym_u8_SQUOTE] = ACTIONS(3473),
    [anon_sym_SQUOTE] = ACTIONS(3473),
    [anon_sym_L_DQUOTE] = ACTIONS(3473),
    [anon_sym_u_DQUOTE] = ACTIONS(3473),
    [anon_sym_U_DQUOTE] = ACTIONS(3473),
    [anon_sym_u8_DQUOTE] = ACTIONS(3473),
    [anon_sym_DQUOTE] = ACTIONS(3473),
    [sym_true] = ACTIONS(3471),
    [sym_false] = ACTIONS(3471),
    [anon_sym_NULL] = ACTIONS(3471),
    [anon_sym_nullptr] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3471),
    [anon_sym_decltype] = ACTIONS(3471),
    [anon_sym_virtual] = ACTIONS(3471),
    [anon_sym_alignas] = ACTIONS(3471),
    [anon_sym_explicit] = ACTIONS(3471),
    [anon_sym_typename] = ACTIONS(3471),
    [anon_sym_template] = ACTIONS(3471),
    [anon_sym_operator] = ACTIONS(3471),
    [anon_sym_try] = ACTIONS(3471),
    [anon_sym_delete] = ACTIONS(3471),
    [anon_sym_throw] = ACTIONS(3471),
    [anon_sym_namespace] = ACTIONS(3471),
    [anon_sym_using] = ACTIONS(3471),
    [anon_sym_static_assert] = ACTIONS(3471),
    [anon_sym_concept] = ACTIONS(3471),
    [anon_sym_co_return] = ACTIONS(3471),
    [anon_sym_co_yield] = ACTIONS(3471),
    [anon_sym_R_DQUOTE] = ACTIONS(3473),
    [anon_sym_LR_DQUOTE] = ACTIONS(3473),
    [anon_sym_uR_DQUOTE] = ACTIONS(3473),
    [anon_sym_UR_DQUOTE] = ACTIONS(3473),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3473),
    [anon_sym_co_await] = ACTIONS(3471),
    [anon_sym_new] = ACTIONS(3471),
    [anon_sym_requires] = ACTIONS(3471),
    [sym_this] = ACTIONS(3471),
  },
  [445] = {
    [sym_identifier] = ACTIONS(3475),
    [aux_sym_preproc_include_token1] = ACTIONS(3475),
    [aux_sym_preproc_def_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token2] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3475),
    [aux_sym_preproc_else_token1] = ACTIONS(3475),
    [aux_sym_preproc_elif_token1] = ACTIONS(3475),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3475),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3475),
    [sym_preproc_directive] = ACTIONS(3475),
    [anon_sym_LPAREN2] = ACTIONS(3477),
    [anon_sym_BANG] = ACTIONS(3477),
    [anon_sym_TILDE] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3475),
    [anon_sym_PLUS] = ACTIONS(3475),
    [anon_sym_STAR] = ACTIONS(3477),
    [anon_sym_AMP_AMP] = ACTIONS(3477),
    [anon_sym_AMP] = ACTIONS(3475),
    [anon_sym_SEMI] = ACTIONS(3477),
    [anon_sym___extension__] = ACTIONS(3475),
    [anon_sym_typedef] = ACTIONS(3475),
    [anon_sym_extern] = ACTIONS(3475),
    [anon_sym___attribute__] = ACTIONS(3475),
    [anon_sym_COLON_COLON] = ACTIONS(3477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3477),
    [anon_sym___declspec] = ACTIONS(3475),
    [anon_sym___based] = ACTIONS(3475),
    [anon_sym___cdecl] = ACTIONS(3475),
    [anon_sym___clrcall] = ACTIONS(3475),
    [anon_sym___stdcall] = ACTIONS(3475),
    [anon_sym___fastcall] = ACTIONS(3475),
    [anon_sym___thiscall] = ACTIONS(3475),
    [anon_sym___vectorcall] = ACTIONS(3475),
    [anon_sym_LBRACE] = ACTIONS(3477),
    [anon_sym_signed] = ACTIONS(3475),
    [anon_sym_unsigned] = ACTIONS(3475),
    [anon_sym_long] = ACTIONS(3475),
    [anon_sym_short] = ACTIONS(3475),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [anon_sym_static] = ACTIONS(3475),
    [anon_sym_register] = ACTIONS(3475),
    [anon_sym_inline] = ACTIONS(3475),
    [anon_sym___inline] = ACTIONS(3475),
    [anon_sym___inline__] = ACTIONS(3475),
    [anon_sym___forceinline] = ACTIONS(3475),
    [anon_sym_thread_local] = ACTIONS(3475),
    [anon_sym___thread] = ACTIONS(3475),
    [anon_sym_const] = ACTIONS(3475),
    [anon_sym_constexpr] = ACTIONS(3475),
    [anon_sym_volatile] = ACTIONS(3475),
    [anon_sym_restrict] = ACTIONS(3475),
    [anon_sym___restrict__] = ACTIONS(3475),
    [anon_sym__Atomic] = ACTIONS(3475),
    [anon_sym__Noreturn] = ACTIONS(3475),
    [anon_sym_noreturn] = ACTIONS(3475),
    [anon_sym_mutable] = ACTIONS(3475),
    [anon_sym_constinit] = ACTIONS(3475),
    [anon_sym_consteval] = ACTIONS(3475),
    [anon_sym_PROGMEM] = ACTIONS(3475),
    [aux_sym_primitive_type_token1] = ACTIONS(3475),
    [anon_sym_byte] = ACTIONS(3475),
    [anon_sym_word] = ACTIONS(3475),
    [anon_sym_enum] = ACTIONS(3475),
    [anon_sym_class] = ACTIONS(3475),
    [anon_sym_struct] = ACTIONS(3475),
    [anon_sym_union] = ACTIONS(3475),
    [anon_sym_if] = ACTIONS(3475),
    [anon_sym_switch] = ACTIONS(3475),
    [anon_sym_case] = ACTIONS(3475),
    [anon_sym_default] = ACTIONS(3475),
    [anon_sym_while] = ACTIONS(3475),
    [anon_sym_do] = ACTIONS(3475),
    [anon_sym_for] = ACTIONS(3475),
    [anon_sym_return] = ACTIONS(3475),
    [anon_sym_break] = ACTIONS(3475),
    [anon_sym_continue] = ACTIONS(3475),
    [anon_sym_goto] = ACTIONS(3475),
    [anon_sym___try] = ACTIONS(3475),
    [anon_sym___leave] = ACTIONS(3475),
    [anon_sym_not] = ACTIONS(3475),
    [anon_sym_compl] = ACTIONS(3475),
    [anon_sym_DASH_DASH] = ACTIONS(3477),
    [anon_sym_PLUS_PLUS] = ACTIONS(3477),
    [anon_sym_sizeof] = ACTIONS(3475),
    [anon_sym___alignof__] = ACTIONS(3475),
    [anon_sym___alignof] = ACTIONS(3475),
    [anon_sym__alignof] = ACTIONS(3475),
    [anon_sym_alignof] = ACTIONS(3475),
    [anon_sym__Alignof] = ACTIONS(3475),
    [anon_sym_offsetof] = ACTIONS(3475),
    [anon_sym__Generic] = ACTIONS(3475),
    [anon_sym_asm] = ACTIONS(3475),
    [anon_sym___asm__] = ACTIONS(3475),
    [aux_sym_number_literal_token1] = ACTIONS(3477),
    [aux_sym_number_literal_token2] = ACTIONS(3475),
    [anon_sym_L_SQUOTE] = ACTIONS(3477),
    [anon_sym_u_SQUOTE] = ACTIONS(3477),
    [anon_sym_U_SQUOTE] = ACTIONS(3477),
    [anon_sym_u8_SQUOTE] = ACTIONS(3477),
    [anon_sym_SQUOTE] = ACTIONS(3477),
    [anon_sym_L_DQUOTE] = ACTIONS(3477),
    [anon_sym_u_DQUOTE] = ACTIONS(3477),
    [anon_sym_U_DQUOTE] = ACTIONS(3477),
    [anon_sym_u8_DQUOTE] = ACTIONS(3477),
    [anon_sym_DQUOTE] = ACTIONS(3477),
    [sym_true] = ACTIONS(3475),
    [sym_false] = ACTIONS(3475),
    [anon_sym_NULL] = ACTIONS(3475),
    [anon_sym_nullptr] = ACTIONS(3475),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3475),
    [anon_sym_decltype] = ACTIONS(3475),
    [anon_sym_virtual] = ACTIONS(3475),
    [anon_sym_alignas] = ACTIONS(3475),
    [anon_sym_explicit] = ACTIONS(3475),
    [anon_sym_typename] = ACTIONS(3475),
    [anon_sym_template] = ACTIONS(3475),
    [anon_sym_operator] = ACTIONS(3475),
    [anon_sym_try] = ACTIONS(3475),
    [anon_sym_delete] = ACTIONS(3475),
    [anon_sym_throw] = ACTIONS(3475),
    [anon_sym_namespace] = ACTIONS(3475),
    [anon_sym_using] = ACTIONS(3475),
    [anon_sym_static_assert] = ACTIONS(3475),
    [anon_sym_concept] = ACTIONS(3475),
    [anon_sym_co_return] = ACTIONS(3475),
    [anon_sym_co_yield] = ACTIONS(3475),
    [anon_sym_R_DQUOTE] = ACTIONS(3477),
    [anon_sym_LR_DQUOTE] = ACTIONS(3477),
    [anon_sym_uR_DQUOTE] = ACTIONS(3477),
    [anon_sym_UR_DQUOTE] = ACTIONS(3477),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3477),
    [anon_sym_co_await] = ACTIONS(3475),
    [anon_sym_new] = ACTIONS(3475),
    [anon_sym_requires] = ACTIONS(3475),
    [sym_this] = ACTIONS(3475),
  },
  [446] = {
    [sym_identifier] = ACTIONS(3479),
    [aux_sym_preproc_include_token1] = ACTIONS(3479),
    [aux_sym_preproc_def_token1] = ACTIONS(3479),
    [aux_sym_preproc_if_token1] = ACTIONS(3479),
    [aux_sym_preproc_if_token2] = ACTIONS(3479),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3479),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3479),
    [aux_sym_preproc_else_token1] = ACTIONS(3479),
    [aux_sym_preproc_elif_token1] = ACTIONS(3479),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3479),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3479),
    [sym_preproc_directive] = ACTIONS(3479),
    [anon_sym_LPAREN2] = ACTIONS(3481),
    [anon_sym_BANG] = ACTIONS(3481),
    [anon_sym_TILDE] = ACTIONS(3481),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_PLUS] = ACTIONS(3479),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_AMP_AMP] = ACTIONS(3481),
    [anon_sym_AMP] = ACTIONS(3479),
    [anon_sym_SEMI] = ACTIONS(3481),
    [anon_sym___extension__] = ACTIONS(3479),
    [anon_sym_typedef] = ACTIONS(3479),
    [anon_sym_extern] = ACTIONS(3479),
    [anon_sym___attribute__] = ACTIONS(3479),
    [anon_sym_COLON_COLON] = ACTIONS(3481),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3481),
    [anon_sym___declspec] = ACTIONS(3479),
    [anon_sym___based] = ACTIONS(3479),
    [anon_sym___cdecl] = ACTIONS(3479),
    [anon_sym___clrcall] = ACTIONS(3479),
    [anon_sym___stdcall] = ACTIONS(3479),
    [anon_sym___fastcall] = ACTIONS(3479),
    [anon_sym___thiscall] = ACTIONS(3479),
    [anon_sym___vectorcall] = ACTIONS(3479),
    [anon_sym_LBRACE] = ACTIONS(3481),
    [anon_sym_signed] = ACTIONS(3479),
    [anon_sym_unsigned] = ACTIONS(3479),
    [anon_sym_long] = ACTIONS(3479),
    [anon_sym_short] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(3479),
    [anon_sym_static] = ACTIONS(3479),
    [anon_sym_register] = ACTIONS(3479),
    [anon_sym_inline] = ACTIONS(3479),
    [anon_sym___inline] = ACTIONS(3479),
    [anon_sym___inline__] = ACTIONS(3479),
    [anon_sym___forceinline] = ACTIONS(3479),
    [anon_sym_thread_local] = ACTIONS(3479),
    [anon_sym___thread] = ACTIONS(3479),
    [anon_sym_const] = ACTIONS(3479),
    [anon_sym_constexpr] = ACTIONS(3479),
    [anon_sym_volatile] = ACTIONS(3479),
    [anon_sym_restrict] = ACTIONS(3479),
    [anon_sym___restrict__] = ACTIONS(3479),
    [anon_sym__Atomic] = ACTIONS(3479),
    [anon_sym__Noreturn] = ACTIONS(3479),
    [anon_sym_noreturn] = ACTIONS(3479),
    [anon_sym_mutable] = ACTIONS(3479),
    [anon_sym_constinit] = ACTIONS(3479),
    [anon_sym_consteval] = ACTIONS(3479),
    [anon_sym_PROGMEM] = ACTIONS(3479),
    [aux_sym_primitive_type_token1] = ACTIONS(3479),
    [anon_sym_byte] = ACTIONS(3479),
    [anon_sym_word] = ACTIONS(3479),
    [anon_sym_enum] = ACTIONS(3479),
    [anon_sym_class] = ACTIONS(3479),
    [anon_sym_struct] = ACTIONS(3479),
    [anon_sym_union] = ACTIONS(3479),
    [anon_sym_if] = ACTIONS(3479),
    [anon_sym_switch] = ACTIONS(3479),
    [anon_sym_case] = ACTIONS(3479),
    [anon_sym_default] = ACTIONS(3479),
    [anon_sym_while] = ACTIONS(3479),
    [anon_sym_do] = ACTIONS(3479),
    [anon_sym_for] = ACTIONS(3479),
    [anon_sym_return] = ACTIONS(3479),
    [anon_sym_break] = ACTIONS(3479),
    [anon_sym_continue] = ACTIONS(3479),
    [anon_sym_goto] = ACTIONS(3479),
    [anon_sym___try] = ACTIONS(3479),
    [anon_sym___leave] = ACTIONS(3479),
    [anon_sym_not] = ACTIONS(3479),
    [anon_sym_compl] = ACTIONS(3479),
    [anon_sym_DASH_DASH] = ACTIONS(3481),
    [anon_sym_PLUS_PLUS] = ACTIONS(3481),
    [anon_sym_sizeof] = ACTIONS(3479),
    [anon_sym___alignof__] = ACTIONS(3479),
    [anon_sym___alignof] = ACTIONS(3479),
    [anon_sym__alignof] = ACTIONS(3479),
    [anon_sym_alignof] = ACTIONS(3479),
    [anon_sym__Alignof] = ACTIONS(3479),
    [anon_sym_offsetof] = ACTIONS(3479),
    [anon_sym__Generic] = ACTIONS(3479),
    [anon_sym_asm] = ACTIONS(3479),
    [anon_sym___asm__] = ACTIONS(3479),
    [aux_sym_number_literal_token1] = ACTIONS(3481),
    [aux_sym_number_literal_token2] = ACTIONS(3479),
    [anon_sym_L_SQUOTE] = ACTIONS(3481),
    [anon_sym_u_SQUOTE] = ACTIONS(3481),
    [anon_sym_U_SQUOTE] = ACTIONS(3481),
    [anon_sym_u8_SQUOTE] = ACTIONS(3481),
    [anon_sym_SQUOTE] = ACTIONS(3481),
    [anon_sym_L_DQUOTE] = ACTIONS(3481),
    [anon_sym_u_DQUOTE] = ACTIONS(3481),
    [anon_sym_U_DQUOTE] = ACTIONS(3481),
    [anon_sym_u8_DQUOTE] = ACTIONS(3481),
    [anon_sym_DQUOTE] = ACTIONS(3481),
    [sym_true] = ACTIONS(3479),
    [sym_false] = ACTIONS(3479),
    [anon_sym_NULL] = ACTIONS(3479),
    [anon_sym_nullptr] = ACTIONS(3479),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3479),
    [anon_sym_decltype] = ACTIONS(3479),
    [anon_sym_virtual] = ACTIONS(3479),
    [anon_sym_alignas] = ACTIONS(3479),
    [anon_sym_explicit] = ACTIONS(3479),
    [anon_sym_typename] = ACTIONS(3479),
    [anon_sym_template] = ACTIONS(3479),
    [anon_sym_operator] = ACTIONS(3479),
    [anon_sym_try] = ACTIONS(3479),
    [anon_sym_delete] = ACTIONS(3479),
    [anon_sym_throw] = ACTIONS(3479),
    [anon_sym_namespace] = ACTIONS(3479),
    [anon_sym_using] = ACTIONS(3479),
    [anon_sym_static_assert] = ACTIONS(3479),
    [anon_sym_concept] = ACTIONS(3479),
    [anon_sym_co_return] = ACTIONS(3479),
    [anon_sym_co_yield] = ACTIONS(3479),
    [anon_sym_R_DQUOTE] = ACTIONS(3481),
    [anon_sym_LR_DQUOTE] = ACTIONS(3481),
    [anon_sym_uR_DQUOTE] = ACTIONS(3481),
    [anon_sym_UR_DQUOTE] = ACTIONS(3481),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3481),
    [anon_sym_co_await] = ACTIONS(3479),
    [anon_sym_new] = ACTIONS(3479),
    [anon_sym_requires] = ACTIONS(3479),
    [sym_this] = ACTIONS(3479),
  },
  [447] = {
    [sym_identifier] = ACTIONS(3483),
    [aux_sym_preproc_include_token1] = ACTIONS(3483),
    [aux_sym_preproc_def_token1] = ACTIONS(3483),
    [aux_sym_preproc_if_token1] = ACTIONS(3483),
    [aux_sym_preproc_if_token2] = ACTIONS(3483),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3483),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3483),
    [aux_sym_preproc_else_token1] = ACTIONS(3483),
    [aux_sym_preproc_elif_token1] = ACTIONS(3483),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3483),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3483),
    [sym_preproc_directive] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_BANG] = ACTIONS(3485),
    [anon_sym_TILDE] = ACTIONS(3485),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_STAR] = ACTIONS(3485),
    [anon_sym_AMP_AMP] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_SEMI] = ACTIONS(3485),
    [anon_sym___extension__] = ACTIONS(3483),
    [anon_sym_typedef] = ACTIONS(3483),
    [anon_sym_extern] = ACTIONS(3483),
    [anon_sym___attribute__] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3485),
    [anon_sym___declspec] = ACTIONS(3483),
    [anon_sym___based] = ACTIONS(3483),
    [anon_sym___cdecl] = ACTIONS(3483),
    [anon_sym___clrcall] = ACTIONS(3483),
    [anon_sym___stdcall] = ACTIONS(3483),
    [anon_sym___fastcall] = ACTIONS(3483),
    [anon_sym___thiscall] = ACTIONS(3483),
    [anon_sym___vectorcall] = ACTIONS(3483),
    [anon_sym_LBRACE] = ACTIONS(3485),
    [anon_sym_signed] = ACTIONS(3483),
    [anon_sym_unsigned] = ACTIONS(3483),
    [anon_sym_long] = ACTIONS(3483),
    [anon_sym_short] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_static] = ACTIONS(3483),
    [anon_sym_register] = ACTIONS(3483),
    [anon_sym_inline] = ACTIONS(3483),
    [anon_sym___inline] = ACTIONS(3483),
    [anon_sym___inline__] = ACTIONS(3483),
    [anon_sym___forceinline] = ACTIONS(3483),
    [anon_sym_thread_local] = ACTIONS(3483),
    [anon_sym___thread] = ACTIONS(3483),
    [anon_sym_const] = ACTIONS(3483),
    [anon_sym_constexpr] = ACTIONS(3483),
    [anon_sym_volatile] = ACTIONS(3483),
    [anon_sym_restrict] = ACTIONS(3483),
    [anon_sym___restrict__] = ACTIONS(3483),
    [anon_sym__Atomic] = ACTIONS(3483),
    [anon_sym__Noreturn] = ACTIONS(3483),
    [anon_sym_noreturn] = ACTIONS(3483),
    [anon_sym_mutable] = ACTIONS(3483),
    [anon_sym_constinit] = ACTIONS(3483),
    [anon_sym_consteval] = ACTIONS(3483),
    [anon_sym_PROGMEM] = ACTIONS(3483),
    [aux_sym_primitive_type_token1] = ACTIONS(3483),
    [anon_sym_byte] = ACTIONS(3483),
    [anon_sym_word] = ACTIONS(3483),
    [anon_sym_enum] = ACTIONS(3483),
    [anon_sym_class] = ACTIONS(3483),
    [anon_sym_struct] = ACTIONS(3483),
    [anon_sym_union] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_switch] = ACTIONS(3483),
    [anon_sym_case] = ACTIONS(3483),
    [anon_sym_default] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_break] = ACTIONS(3483),
    [anon_sym_continue] = ACTIONS(3483),
    [anon_sym_goto] = ACTIONS(3483),
    [anon_sym___try] = ACTIONS(3483),
    [anon_sym___leave] = ACTIONS(3483),
    [anon_sym_not] = ACTIONS(3483),
    [anon_sym_compl] = ACTIONS(3483),
    [anon_sym_DASH_DASH] = ACTIONS(3485),
    [anon_sym_PLUS_PLUS] = ACTIONS(3485),
    [anon_sym_sizeof] = ACTIONS(3483),
    [anon_sym___alignof__] = ACTIONS(3483),
    [anon_sym___alignof] = ACTIONS(3483),
    [anon_sym__alignof] = ACTIONS(3483),
    [anon_sym_alignof] = ACTIONS(3483),
    [anon_sym__Alignof] = ACTIONS(3483),
    [anon_sym_offsetof] = ACTIONS(3483),
    [anon_sym__Generic] = ACTIONS(3483),
    [anon_sym_asm] = ACTIONS(3483),
    [anon_sym___asm__] = ACTIONS(3483),
    [aux_sym_number_literal_token1] = ACTIONS(3485),
    [aux_sym_number_literal_token2] = ACTIONS(3483),
    [anon_sym_L_SQUOTE] = ACTIONS(3485),
    [anon_sym_u_SQUOTE] = ACTIONS(3485),
    [anon_sym_U_SQUOTE] = ACTIONS(3485),
    [anon_sym_u8_SQUOTE] = ACTIONS(3485),
    [anon_sym_SQUOTE] = ACTIONS(3485),
    [anon_sym_L_DQUOTE] = ACTIONS(3485),
    [anon_sym_u_DQUOTE] = ACTIONS(3485),
    [anon_sym_U_DQUOTE] = ACTIONS(3485),
    [anon_sym_u8_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE] = ACTIONS(3485),
    [sym_true] = ACTIONS(3483),
    [sym_false] = ACTIONS(3483),
    [anon_sym_NULL] = ACTIONS(3483),
    [anon_sym_nullptr] = ACTIONS(3483),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3483),
    [anon_sym_decltype] = ACTIONS(3483),
    [anon_sym_virtual] = ACTIONS(3483),
    [anon_sym_alignas] = ACTIONS(3483),
    [anon_sym_explicit] = ACTIONS(3483),
    [anon_sym_typename] = ACTIONS(3483),
    [anon_sym_template] = ACTIONS(3483),
    [anon_sym_operator] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_delete] = ACTIONS(3483),
    [anon_sym_throw] = ACTIONS(3483),
    [anon_sym_namespace] = ACTIONS(3483),
    [anon_sym_using] = ACTIONS(3483),
    [anon_sym_static_assert] = ACTIONS(3483),
    [anon_sym_concept] = ACTIONS(3483),
    [anon_sym_co_return] = ACTIONS(3483),
    [anon_sym_co_yield] = ACTIONS(3483),
    [anon_sym_R_DQUOTE] = ACTIONS(3485),
    [anon_sym_LR_DQUOTE] = ACTIONS(3485),
    [anon_sym_uR_DQUOTE] = ACTIONS(3485),
    [anon_sym_UR_DQUOTE] = ACTIONS(3485),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3485),
    [anon_sym_co_await] = ACTIONS(3483),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_requires] = ACTIONS(3483),
    [sym_this] = ACTIONS(3483),
  },
  [448] = {
    [sym_identifier] = ACTIONS(2223),
    [aux_sym_preproc_include_token1] = ACTIONS(2223),
    [aux_sym_preproc_def_token1] = ACTIONS(2223),
    [aux_sym_preproc_if_token1] = ACTIONS(2223),
    [aux_sym_preproc_if_token2] = ACTIONS(2223),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2223),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2223),
    [aux_sym_preproc_else_token1] = ACTIONS(2223),
    [aux_sym_preproc_elif_token1] = ACTIONS(2223),
    [sym_preproc_directive] = ACTIONS(2223),
    [anon_sym_LPAREN2] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2223),
    [anon_sym_PLUS] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(2221),
    [anon_sym_AMP_AMP] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym___extension__] = ACTIONS(2223),
    [anon_sym_typedef] = ACTIONS(2223),
    [anon_sym_extern] = ACTIONS(2223),
    [anon_sym___attribute__] = ACTIONS(2223),
    [anon_sym_COLON_COLON] = ACTIONS(2221),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym___declspec] = ACTIONS(2223),
    [anon_sym___based] = ACTIONS(2223),
    [anon_sym___cdecl] = ACTIONS(2223),
    [anon_sym___clrcall] = ACTIONS(2223),
    [anon_sym___stdcall] = ACTIONS(2223),
    [anon_sym___fastcall] = ACTIONS(2223),
    [anon_sym___thiscall] = ACTIONS(2223),
    [anon_sym___vectorcall] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_signed] = ACTIONS(2223),
    [anon_sym_unsigned] = ACTIONS(2223),
    [anon_sym_long] = ACTIONS(2223),
    [anon_sym_short] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(2223),
    [anon_sym_static] = ACTIONS(2223),
    [anon_sym_register] = ACTIONS(2223),
    [anon_sym_inline] = ACTIONS(2223),
    [anon_sym___inline] = ACTIONS(2223),
    [anon_sym___inline__] = ACTIONS(2223),
    [anon_sym___forceinline] = ACTIONS(2223),
    [anon_sym_thread_local] = ACTIONS(2223),
    [anon_sym___thread] = ACTIONS(2223),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_constexpr] = ACTIONS(2223),
    [anon_sym_volatile] = ACTIONS(2223),
    [anon_sym_restrict] = ACTIONS(2223),
    [anon_sym___restrict__] = ACTIONS(2223),
    [anon_sym__Atomic] = ACTIONS(2223),
    [anon_sym__Noreturn] = ACTIONS(2223),
    [anon_sym_noreturn] = ACTIONS(2223),
    [anon_sym_mutable] = ACTIONS(2223),
    [anon_sym_constinit] = ACTIONS(2223),
    [anon_sym_consteval] = ACTIONS(2223),
    [anon_sym_PROGMEM] = ACTIONS(2223),
    [aux_sym_primitive_type_token1] = ACTIONS(2223),
    [anon_sym_byte] = ACTIONS(2223),
    [anon_sym_word] = ACTIONS(2223),
    [anon_sym_enum] = ACTIONS(2223),
    [anon_sym_class] = ACTIONS(2223),
    [anon_sym_struct] = ACTIONS(2223),
    [anon_sym_union] = ACTIONS(2223),
    [anon_sym_if] = ACTIONS(2223),
    [anon_sym_else] = ACTIONS(2223),
    [anon_sym_switch] = ACTIONS(2223),
    [anon_sym_case] = ACTIONS(2223),
    [anon_sym_default] = ACTIONS(2223),
    [anon_sym_while] = ACTIONS(2223),
    [anon_sym_do] = ACTIONS(2223),
    [anon_sym_for] = ACTIONS(2223),
    [anon_sym_return] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2223),
    [anon_sym_continue] = ACTIONS(2223),
    [anon_sym_goto] = ACTIONS(2223),
    [anon_sym___try] = ACTIONS(2223),
    [anon_sym___leave] = ACTIONS(2223),
    [anon_sym_not] = ACTIONS(2223),
    [anon_sym_compl] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_sizeof] = ACTIONS(2223),
    [anon_sym___alignof__] = ACTIONS(2223),
    [anon_sym___alignof] = ACTIONS(2223),
    [anon_sym__alignof] = ACTIONS(2223),
    [anon_sym_alignof] = ACTIONS(2223),
    [anon_sym__Alignof] = ACTIONS(2223),
    [anon_sym_offsetof] = ACTIONS(2223),
    [anon_sym__Generic] = ACTIONS(2223),
    [anon_sym_asm] = ACTIONS(2223),
    [anon_sym___asm__] = ACTIONS(2223),
    [aux_sym_number_literal_token1] = ACTIONS(2221),
    [aux_sym_number_literal_token2] = ACTIONS(2223),
    [anon_sym_L_SQUOTE] = ACTIONS(2221),
    [anon_sym_u_SQUOTE] = ACTIONS(2221),
    [anon_sym_U_SQUOTE] = ACTIONS(2221),
    [anon_sym_u8_SQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_L_DQUOTE] = ACTIONS(2221),
    [anon_sym_u_DQUOTE] = ACTIONS(2221),
    [anon_sym_U_DQUOTE] = ACTIONS(2221),
    [anon_sym_u8_DQUOTE] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [sym_true] = ACTIONS(2223),
    [sym_false] = ACTIONS(2223),
    [anon_sym_NULL] = ACTIONS(2223),
    [anon_sym_nullptr] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2223),
    [anon_sym_decltype] = ACTIONS(2223),
    [anon_sym_virtual] = ACTIONS(2223),
    [anon_sym_alignas] = ACTIONS(2223),
    [anon_sym_explicit] = ACTIONS(2223),
    [anon_sym_typename] = ACTIONS(2223),
    [anon_sym_template] = ACTIONS(2223),
    [anon_sym_operator] = ACTIONS(2223),
    [anon_sym_try] = ACTIONS(2223),
    [anon_sym_delete] = ACTIONS(2223),
    [anon_sym_throw] = ACTIONS(2223),
    [anon_sym_namespace] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_static_assert] = ACTIONS(2223),
    [anon_sym_concept] = ACTIONS(2223),
    [anon_sym_co_return] = ACTIONS(2223),
    [anon_sym_co_yield] = ACTIONS(2223),
    [anon_sym_catch] = ACTIONS(2223),
    [anon_sym_R_DQUOTE] = ACTIONS(2221),
    [anon_sym_LR_DQUOTE] = ACTIONS(2221),
    [anon_sym_uR_DQUOTE] = ACTIONS(2221),
    [anon_sym_UR_DQUOTE] = ACTIONS(2221),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2221),
    [anon_sym_co_await] = ACTIONS(2223),
    [anon_sym_new] = ACTIONS(2223),
    [anon_sym_requires] = ACTIONS(2223),
    [sym_this] = ACTIONS(2223),
  },
  [449] = {
    [sym_identifier] = ACTIONS(3487),
    [aux_sym_preproc_include_token1] = ACTIONS(3487),
    [aux_sym_preproc_def_token1] = ACTIONS(3487),
    [aux_sym_preproc_if_token1] = ACTIONS(3487),
    [aux_sym_preproc_if_token2] = ACTIONS(3487),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3487),
    [aux_sym_preproc_else_token1] = ACTIONS(3487),
    [aux_sym_preproc_elif_token1] = ACTIONS(3487),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3487),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3487),
    [sym_preproc_directive] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3489),
    [anon_sym_BANG] = ACTIONS(3489),
    [anon_sym_TILDE] = ACTIONS(3489),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3489),
    [anon_sym_AMP_AMP] = ACTIONS(3489),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_SEMI] = ACTIONS(3489),
    [anon_sym___extension__] = ACTIONS(3487),
    [anon_sym_typedef] = ACTIONS(3487),
    [anon_sym_extern] = ACTIONS(3487),
    [anon_sym___attribute__] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3489),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3489),
    [anon_sym___declspec] = ACTIONS(3487),
    [anon_sym___based] = ACTIONS(3487),
    [anon_sym___cdecl] = ACTIONS(3487),
    [anon_sym___clrcall] = ACTIONS(3487),
    [anon_sym___stdcall] = ACTIONS(3487),
    [anon_sym___fastcall] = ACTIONS(3487),
    [anon_sym___thiscall] = ACTIONS(3487),
    [anon_sym___vectorcall] = ACTIONS(3487),
    [anon_sym_LBRACE] = ACTIONS(3489),
    [anon_sym_signed] = ACTIONS(3487),
    [anon_sym_unsigned] = ACTIONS(3487),
    [anon_sym_long] = ACTIONS(3487),
    [anon_sym_short] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_register] = ACTIONS(3487),
    [anon_sym_inline] = ACTIONS(3487),
    [anon_sym___inline] = ACTIONS(3487),
    [anon_sym___inline__] = ACTIONS(3487),
    [anon_sym___forceinline] = ACTIONS(3487),
    [anon_sym_thread_local] = ACTIONS(3487),
    [anon_sym___thread] = ACTIONS(3487),
    [anon_sym_const] = ACTIONS(3487),
    [anon_sym_constexpr] = ACTIONS(3487),
    [anon_sym_volatile] = ACTIONS(3487),
    [anon_sym_restrict] = ACTIONS(3487),
    [anon_sym___restrict__] = ACTIONS(3487),
    [anon_sym__Atomic] = ACTIONS(3487),
    [anon_sym__Noreturn] = ACTIONS(3487),
    [anon_sym_noreturn] = ACTIONS(3487),
    [anon_sym_mutable] = ACTIONS(3487),
    [anon_sym_constinit] = ACTIONS(3487),
    [anon_sym_consteval] = ACTIONS(3487),
    [anon_sym_PROGMEM] = ACTIONS(3487),
    [aux_sym_primitive_type_token1] = ACTIONS(3487),
    [anon_sym_byte] = ACTIONS(3487),
    [anon_sym_word] = ACTIONS(3487),
    [anon_sym_enum] = ACTIONS(3487),
    [anon_sym_class] = ACTIONS(3487),
    [anon_sym_struct] = ACTIONS(3487),
    [anon_sym_union] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_switch] = ACTIONS(3487),
    [anon_sym_case] = ACTIONS(3487),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_break] = ACTIONS(3487),
    [anon_sym_continue] = ACTIONS(3487),
    [anon_sym_goto] = ACTIONS(3487),
    [anon_sym___try] = ACTIONS(3487),
    [anon_sym___leave] = ACTIONS(3487),
    [anon_sym_not] = ACTIONS(3487),
    [anon_sym_compl] = ACTIONS(3487),
    [anon_sym_DASH_DASH] = ACTIONS(3489),
    [anon_sym_PLUS_PLUS] = ACTIONS(3489),
    [anon_sym_sizeof] = ACTIONS(3487),
    [anon_sym___alignof__] = ACTIONS(3487),
    [anon_sym___alignof] = ACTIONS(3487),
    [anon_sym__alignof] = ACTIONS(3487),
    [anon_sym_alignof] = ACTIONS(3487),
    [anon_sym__Alignof] = ACTIONS(3487),
    [anon_sym_offsetof] = ACTIONS(3487),
    [anon_sym__Generic] = ACTIONS(3487),
    [anon_sym_asm] = ACTIONS(3487),
    [anon_sym___asm__] = ACTIONS(3487),
    [aux_sym_number_literal_token1] = ACTIONS(3489),
    [aux_sym_number_literal_token2] = ACTIONS(3487),
    [anon_sym_L_SQUOTE] = ACTIONS(3489),
    [anon_sym_u_SQUOTE] = ACTIONS(3489),
    [anon_sym_U_SQUOTE] = ACTIONS(3489),
    [anon_sym_u8_SQUOTE] = ACTIONS(3489),
    [anon_sym_SQUOTE] = ACTIONS(3489),
    [anon_sym_L_DQUOTE] = ACTIONS(3489),
    [anon_sym_u_DQUOTE] = ACTIONS(3489),
    [anon_sym_U_DQUOTE] = ACTIONS(3489),
    [anon_sym_u8_DQUOTE] = ACTIONS(3489),
    [anon_sym_DQUOTE] = ACTIONS(3489),
    [sym_true] = ACTIONS(3487),
    [sym_false] = ACTIONS(3487),
    [anon_sym_NULL] = ACTIONS(3487),
    [anon_sym_nullptr] = ACTIONS(3487),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3487),
    [anon_sym_decltype] = ACTIONS(3487),
    [anon_sym_virtual] = ACTIONS(3487),
    [anon_sym_alignas] = ACTIONS(3487),
    [anon_sym_explicit] = ACTIONS(3487),
    [anon_sym_typename] = ACTIONS(3487),
    [anon_sym_template] = ACTIONS(3487),
    [anon_sym_operator] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_delete] = ACTIONS(3487),
    [anon_sym_throw] = ACTIONS(3487),
    [anon_sym_namespace] = ACTIONS(3487),
    [anon_sym_using] = ACTIONS(3487),
    [anon_sym_static_assert] = ACTIONS(3487),
    [anon_sym_concept] = ACTIONS(3487),
    [anon_sym_co_return] = ACTIONS(3487),
    [anon_sym_co_yield] = ACTIONS(3487),
    [anon_sym_R_DQUOTE] = ACTIONS(3489),
    [anon_sym_LR_DQUOTE] = ACTIONS(3489),
    [anon_sym_uR_DQUOTE] = ACTIONS(3489),
    [anon_sym_UR_DQUOTE] = ACTIONS(3489),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3489),
    [anon_sym_co_await] = ACTIONS(3487),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_requires] = ACTIONS(3487),
    [sym_this] = ACTIONS(3487),
  },
  [450] = {
    [sym_identifier] = ACTIONS(3491),
    [aux_sym_preproc_include_token1] = ACTIONS(3491),
    [aux_sym_preproc_def_token1] = ACTIONS(3491),
    [aux_sym_preproc_if_token1] = ACTIONS(3491),
    [aux_sym_preproc_if_token2] = ACTIONS(3491),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3491),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3491),
    [aux_sym_preproc_else_token1] = ACTIONS(3491),
    [aux_sym_preproc_elif_token1] = ACTIONS(3491),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3491),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3491),
    [sym_preproc_directive] = ACTIONS(3491),
    [anon_sym_LPAREN2] = ACTIONS(3493),
    [anon_sym_BANG] = ACTIONS(3493),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(3493),
    [anon_sym_AMP_AMP] = ACTIONS(3493),
    [anon_sym_AMP] = ACTIONS(3491),
    [anon_sym_SEMI] = ACTIONS(3493),
    [anon_sym___extension__] = ACTIONS(3491),
    [anon_sym_typedef] = ACTIONS(3491),
    [anon_sym_extern] = ACTIONS(3491),
    [anon_sym___attribute__] = ACTIONS(3491),
    [anon_sym_COLON_COLON] = ACTIONS(3493),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3493),
    [anon_sym___declspec] = ACTIONS(3491),
    [anon_sym___based] = ACTIONS(3491),
    [anon_sym___cdecl] = ACTIONS(3491),
    [anon_sym___clrcall] = ACTIONS(3491),
    [anon_sym___stdcall] = ACTIONS(3491),
    [anon_sym___fastcall] = ACTIONS(3491),
    [anon_sym___thiscall] = ACTIONS(3491),
    [anon_sym___vectorcall] = ACTIONS(3491),
    [anon_sym_LBRACE] = ACTIONS(3493),
    [anon_sym_signed] = ACTIONS(3491),
    [anon_sym_unsigned] = ACTIONS(3491),
    [anon_sym_long] = ACTIONS(3491),
    [anon_sym_short] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3491),
    [anon_sym_static] = ACTIONS(3491),
    [anon_sym_register] = ACTIONS(3491),
    [anon_sym_inline] = ACTIONS(3491),
    [anon_sym___inline] = ACTIONS(3491),
    [anon_sym___inline__] = ACTIONS(3491),
    [anon_sym___forceinline] = ACTIONS(3491),
    [anon_sym_thread_local] = ACTIONS(3491),
    [anon_sym___thread] = ACTIONS(3491),
    [anon_sym_const] = ACTIONS(3491),
    [anon_sym_constexpr] = ACTIONS(3491),
    [anon_sym_volatile] = ACTIONS(3491),
    [anon_sym_restrict] = ACTIONS(3491),
    [anon_sym___restrict__] = ACTIONS(3491),
    [anon_sym__Atomic] = ACTIONS(3491),
    [anon_sym__Noreturn] = ACTIONS(3491),
    [anon_sym_noreturn] = ACTIONS(3491),
    [anon_sym_mutable] = ACTIONS(3491),
    [anon_sym_constinit] = ACTIONS(3491),
    [anon_sym_consteval] = ACTIONS(3491),
    [anon_sym_PROGMEM] = ACTIONS(3491),
    [aux_sym_primitive_type_token1] = ACTIONS(3491),
    [anon_sym_byte] = ACTIONS(3491),
    [anon_sym_word] = ACTIONS(3491),
    [anon_sym_enum] = ACTIONS(3491),
    [anon_sym_class] = ACTIONS(3491),
    [anon_sym_struct] = ACTIONS(3491),
    [anon_sym_union] = ACTIONS(3491),
    [anon_sym_if] = ACTIONS(3491),
    [anon_sym_switch] = ACTIONS(3491),
    [anon_sym_case] = ACTIONS(3491),
    [anon_sym_default] = ACTIONS(3491),
    [anon_sym_while] = ACTIONS(3491),
    [anon_sym_do] = ACTIONS(3491),
    [anon_sym_for] = ACTIONS(3491),
    [anon_sym_return] = ACTIONS(3491),
    [anon_sym_break] = ACTIONS(3491),
    [anon_sym_continue] = ACTIONS(3491),
    [anon_sym_goto] = ACTIONS(3491),
    [anon_sym___try] = ACTIONS(3491),
    [anon_sym___leave] = ACTIONS(3491),
    [anon_sym_not] = ACTIONS(3491),
    [anon_sym_compl] = ACTIONS(3491),
    [anon_sym_DASH_DASH] = ACTIONS(3493),
    [anon_sym_PLUS_PLUS] = ACTIONS(3493),
    [anon_sym_sizeof] = ACTIONS(3491),
    [anon_sym___alignof__] = ACTIONS(3491),
    [anon_sym___alignof] = ACTIONS(3491),
    [anon_sym__alignof] = ACTIONS(3491),
    [anon_sym_alignof] = ACTIONS(3491),
    [anon_sym__Alignof] = ACTIONS(3491),
    [anon_sym_offsetof] = ACTIONS(3491),
    [anon_sym__Generic] = ACTIONS(3491),
    [anon_sym_asm] = ACTIONS(3491),
    [anon_sym___asm__] = ACTIONS(3491),
    [aux_sym_number_literal_token1] = ACTIONS(3493),
    [aux_sym_number_literal_token2] = ACTIONS(3491),
    [anon_sym_L_SQUOTE] = ACTIONS(3493),
    [anon_sym_u_SQUOTE] = ACTIONS(3493),
    [anon_sym_U_SQUOTE] = ACTIONS(3493),
    [anon_sym_u8_SQUOTE] = ACTIONS(3493),
    [anon_sym_SQUOTE] = ACTIONS(3493),
    [anon_sym_L_DQUOTE] = ACTIONS(3493),
    [anon_sym_u_DQUOTE] = ACTIONS(3493),
    [anon_sym_U_DQUOTE] = ACTIONS(3493),
    [anon_sym_u8_DQUOTE] = ACTIONS(3493),
    [anon_sym_DQUOTE] = ACTIONS(3493),
    [sym_true] = ACTIONS(3491),
    [sym_false] = ACTIONS(3491),
    [anon_sym_NULL] = ACTIONS(3491),
    [anon_sym_nullptr] = ACTIONS(3491),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3491),
    [anon_sym_decltype] = ACTIONS(3491),
    [anon_sym_virtual] = ACTIONS(3491),
    [anon_sym_alignas] = ACTIONS(3491),
    [anon_sym_explicit] = ACTIONS(3491),
    [anon_sym_typename] = ACTIONS(3491),
    [anon_sym_template] = ACTIONS(3491),
    [anon_sym_operator] = ACTIONS(3491),
    [anon_sym_try] = ACTIONS(3491),
    [anon_sym_delete] = ACTIONS(3491),
    [anon_sym_throw] = ACTIONS(3491),
    [anon_sym_namespace] = ACTIONS(3491),
    [anon_sym_using] = ACTIONS(3491),
    [anon_sym_static_assert] = ACTIONS(3491),
    [anon_sym_concept] = ACTIONS(3491),
    [anon_sym_co_return] = ACTIONS(3491),
    [anon_sym_co_yield] = ACTIONS(3491),
    [anon_sym_R_DQUOTE] = ACTIONS(3493),
    [anon_sym_LR_DQUOTE] = ACTIONS(3493),
    [anon_sym_uR_DQUOTE] = ACTIONS(3493),
    [anon_sym_UR_DQUOTE] = ACTIONS(3493),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3493),
    [anon_sym_co_await] = ACTIONS(3491),
    [anon_sym_new] = ACTIONS(3491),
    [anon_sym_requires] = ACTIONS(3491),
    [sym_this] = ACTIONS(3491),
  },
  [451] = {
    [sym_identifier] = ACTIONS(3495),
    [aux_sym_preproc_include_token1] = ACTIONS(3495),
    [aux_sym_preproc_def_token1] = ACTIONS(3495),
    [aux_sym_preproc_if_token1] = ACTIONS(3495),
    [aux_sym_preproc_if_token2] = ACTIONS(3495),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3495),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3495),
    [aux_sym_preproc_else_token1] = ACTIONS(3495),
    [aux_sym_preproc_elif_token1] = ACTIONS(3495),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3495),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3495),
    [sym_preproc_directive] = ACTIONS(3495),
    [anon_sym_LPAREN2] = ACTIONS(3497),
    [anon_sym_BANG] = ACTIONS(3497),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_AMP_AMP] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(3495),
    [anon_sym_SEMI] = ACTIONS(3497),
    [anon_sym___extension__] = ACTIONS(3495),
    [anon_sym_typedef] = ACTIONS(3495),
    [anon_sym_extern] = ACTIONS(3495),
    [anon_sym___attribute__] = ACTIONS(3495),
    [anon_sym_COLON_COLON] = ACTIONS(3497),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3497),
    [anon_sym___declspec] = ACTIONS(3495),
    [anon_sym___based] = ACTIONS(3495),
    [anon_sym___cdecl] = ACTIONS(3495),
    [anon_sym___clrcall] = ACTIONS(3495),
    [anon_sym___stdcall] = ACTIONS(3495),
    [anon_sym___fastcall] = ACTIONS(3495),
    [anon_sym___thiscall] = ACTIONS(3495),
    [anon_sym___vectorcall] = ACTIONS(3495),
    [anon_sym_LBRACE] = ACTIONS(3497),
    [anon_sym_signed] = ACTIONS(3495),
    [anon_sym_unsigned] = ACTIONS(3495),
    [anon_sym_long] = ACTIONS(3495),
    [anon_sym_short] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(3495),
    [anon_sym_static] = ACTIONS(3495),
    [anon_sym_register] = ACTIONS(3495),
    [anon_sym_inline] = ACTIONS(3495),
    [anon_sym___inline] = ACTIONS(3495),
    [anon_sym___inline__] = ACTIONS(3495),
    [anon_sym___forceinline] = ACTIONS(3495),
    [anon_sym_thread_local] = ACTIONS(3495),
    [anon_sym___thread] = ACTIONS(3495),
    [anon_sym_const] = ACTIONS(3495),
    [anon_sym_constexpr] = ACTIONS(3495),
    [anon_sym_volatile] = ACTIONS(3495),
    [anon_sym_restrict] = ACTIONS(3495),
    [anon_sym___restrict__] = ACTIONS(3495),
    [anon_sym__Atomic] = ACTIONS(3495),
    [anon_sym__Noreturn] = ACTIONS(3495),
    [anon_sym_noreturn] = ACTIONS(3495),
    [anon_sym_mutable] = ACTIONS(3495),
    [anon_sym_constinit] = ACTIONS(3495),
    [anon_sym_consteval] = ACTIONS(3495),
    [anon_sym_PROGMEM] = ACTIONS(3495),
    [aux_sym_primitive_type_token1] = ACTIONS(3495),
    [anon_sym_byte] = ACTIONS(3495),
    [anon_sym_word] = ACTIONS(3495),
    [anon_sym_enum] = ACTIONS(3495),
    [anon_sym_class] = ACTIONS(3495),
    [anon_sym_struct] = ACTIONS(3495),
    [anon_sym_union] = ACTIONS(3495),
    [anon_sym_if] = ACTIONS(3495),
    [anon_sym_switch] = ACTIONS(3495),
    [anon_sym_case] = ACTIONS(3495),
    [anon_sym_default] = ACTIONS(3495),
    [anon_sym_while] = ACTIONS(3495),
    [anon_sym_do] = ACTIONS(3495),
    [anon_sym_for] = ACTIONS(3495),
    [anon_sym_return] = ACTIONS(3495),
    [anon_sym_break] = ACTIONS(3495),
    [anon_sym_continue] = ACTIONS(3495),
    [anon_sym_goto] = ACTIONS(3495),
    [anon_sym___try] = ACTIONS(3495),
    [anon_sym___leave] = ACTIONS(3495),
    [anon_sym_not] = ACTIONS(3495),
    [anon_sym_compl] = ACTIONS(3495),
    [anon_sym_DASH_DASH] = ACTIONS(3497),
    [anon_sym_PLUS_PLUS] = ACTIONS(3497),
    [anon_sym_sizeof] = ACTIONS(3495),
    [anon_sym___alignof__] = ACTIONS(3495),
    [anon_sym___alignof] = ACTIONS(3495),
    [anon_sym__alignof] = ACTIONS(3495),
    [anon_sym_alignof] = ACTIONS(3495),
    [anon_sym__Alignof] = ACTIONS(3495),
    [anon_sym_offsetof] = ACTIONS(3495),
    [anon_sym__Generic] = ACTIONS(3495),
    [anon_sym_asm] = ACTIONS(3495),
    [anon_sym___asm__] = ACTIONS(3495),
    [aux_sym_number_literal_token1] = ACTIONS(3497),
    [aux_sym_number_literal_token2] = ACTIONS(3495),
    [anon_sym_L_SQUOTE] = ACTIONS(3497),
    [anon_sym_u_SQUOTE] = ACTIONS(3497),
    [anon_sym_U_SQUOTE] = ACTIONS(3497),
    [anon_sym_u8_SQUOTE] = ACTIONS(3497),
    [anon_sym_SQUOTE] = ACTIONS(3497),
    [anon_sym_L_DQUOTE] = ACTIONS(3497),
    [anon_sym_u_DQUOTE] = ACTIONS(3497),
    [anon_sym_U_DQUOTE] = ACTIONS(3497),
    [anon_sym_u8_DQUOTE] = ACTIONS(3497),
    [anon_sym_DQUOTE] = ACTIONS(3497),
    [sym_true] = ACTIONS(3495),
    [sym_false] = ACTIONS(3495),
    [anon_sym_NULL] = ACTIONS(3495),
    [anon_sym_nullptr] = ACTIONS(3495),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3495),
    [anon_sym_decltype] = ACTIONS(3495),
    [anon_sym_virtual] = ACTIONS(3495),
    [anon_sym_alignas] = ACTIONS(3495),
    [anon_sym_explicit] = ACTIONS(3495),
    [anon_sym_typename] = ACTIONS(3495),
    [anon_sym_template] = ACTIONS(3495),
    [anon_sym_operator] = ACTIONS(3495),
    [anon_sym_try] = ACTIONS(3495),
    [anon_sym_delete] = ACTIONS(3495),
    [anon_sym_throw] = ACTIONS(3495),
    [anon_sym_namespace] = ACTIONS(3495),
    [anon_sym_using] = ACTIONS(3495),
    [anon_sym_static_assert] = ACTIONS(3495),
    [anon_sym_concept] = ACTIONS(3495),
    [anon_sym_co_return] = ACTIONS(3495),
    [anon_sym_co_yield] = ACTIONS(3495),
    [anon_sym_R_DQUOTE] = ACTIONS(3497),
    [anon_sym_LR_DQUOTE] = ACTIONS(3497),
    [anon_sym_uR_DQUOTE] = ACTIONS(3497),
    [anon_sym_UR_DQUOTE] = ACTIONS(3497),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3497),
    [anon_sym_co_await] = ACTIONS(3495),
    [anon_sym_new] = ACTIONS(3495),
    [anon_sym_requires] = ACTIONS(3495),
    [sym_this] = ACTIONS(3495),
  },
  [452] = {
    [sym_identifier] = ACTIONS(3499),
    [aux_sym_preproc_include_token1] = ACTIONS(3499),
    [aux_sym_preproc_def_token1] = ACTIONS(3499),
    [aux_sym_preproc_if_token1] = ACTIONS(3499),
    [aux_sym_preproc_if_token2] = ACTIONS(3499),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3499),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3499),
    [aux_sym_preproc_else_token1] = ACTIONS(3499),
    [aux_sym_preproc_elif_token1] = ACTIONS(3499),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3499),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3499),
    [sym_preproc_directive] = ACTIONS(3499),
    [anon_sym_LPAREN2] = ACTIONS(3501),
    [anon_sym_BANG] = ACTIONS(3501),
    [anon_sym_TILDE] = ACTIONS(3501),
    [anon_sym_DASH] = ACTIONS(3499),
    [anon_sym_PLUS] = ACTIONS(3499),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_AMP_AMP] = ACTIONS(3501),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_SEMI] = ACTIONS(3501),
    [anon_sym___extension__] = ACTIONS(3499),
    [anon_sym_typedef] = ACTIONS(3499),
    [anon_sym_extern] = ACTIONS(3499),
    [anon_sym___attribute__] = ACTIONS(3499),
    [anon_sym_COLON_COLON] = ACTIONS(3501),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3501),
    [anon_sym___declspec] = ACTIONS(3499),
    [anon_sym___based] = ACTIONS(3499),
    [anon_sym___cdecl] = ACTIONS(3499),
    [anon_sym___clrcall] = ACTIONS(3499),
    [anon_sym___stdcall] = ACTIONS(3499),
    [anon_sym___fastcall] = ACTIONS(3499),
    [anon_sym___thiscall] = ACTIONS(3499),
    [anon_sym___vectorcall] = ACTIONS(3499),
    [anon_sym_LBRACE] = ACTIONS(3501),
    [anon_sym_signed] = ACTIONS(3499),
    [anon_sym_unsigned] = ACTIONS(3499),
    [anon_sym_long] = ACTIONS(3499),
    [anon_sym_short] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(3499),
    [anon_sym_static] = ACTIONS(3499),
    [anon_sym_register] = ACTIONS(3499),
    [anon_sym_inline] = ACTIONS(3499),
    [anon_sym___inline] = ACTIONS(3499),
    [anon_sym___inline__] = ACTIONS(3499),
    [anon_sym___forceinline] = ACTIONS(3499),
    [anon_sym_thread_local] = ACTIONS(3499),
    [anon_sym___thread] = ACTIONS(3499),
    [anon_sym_const] = ACTIONS(3499),
    [anon_sym_constexpr] = ACTIONS(3499),
    [anon_sym_volatile] = ACTIONS(3499),
    [anon_sym_restrict] = ACTIONS(3499),
    [anon_sym___restrict__] = ACTIONS(3499),
    [anon_sym__Atomic] = ACTIONS(3499),
    [anon_sym__Noreturn] = ACTIONS(3499),
    [anon_sym_noreturn] = ACTIONS(3499),
    [anon_sym_mutable] = ACTIONS(3499),
    [anon_sym_constinit] = ACTIONS(3499),
    [anon_sym_consteval] = ACTIONS(3499),
    [anon_sym_PROGMEM] = ACTIONS(3499),
    [aux_sym_primitive_type_token1] = ACTIONS(3499),
    [anon_sym_byte] = ACTIONS(3499),
    [anon_sym_word] = ACTIONS(3499),
    [anon_sym_enum] = ACTIONS(3499),
    [anon_sym_class] = ACTIONS(3499),
    [anon_sym_struct] = ACTIONS(3499),
    [anon_sym_union] = ACTIONS(3499),
    [anon_sym_if] = ACTIONS(3499),
    [anon_sym_switch] = ACTIONS(3499),
    [anon_sym_case] = ACTIONS(3499),
    [anon_sym_default] = ACTIONS(3499),
    [anon_sym_while] = ACTIONS(3499),
    [anon_sym_do] = ACTIONS(3499),
    [anon_sym_for] = ACTIONS(3499),
    [anon_sym_return] = ACTIONS(3499),
    [anon_sym_break] = ACTIONS(3499),
    [anon_sym_continue] = ACTIONS(3499),
    [anon_sym_goto] = ACTIONS(3499),
    [anon_sym___try] = ACTIONS(3499),
    [anon_sym___leave] = ACTIONS(3499),
    [anon_sym_not] = ACTIONS(3499),
    [anon_sym_compl] = ACTIONS(3499),
    [anon_sym_DASH_DASH] = ACTIONS(3501),
    [anon_sym_PLUS_PLUS] = ACTIONS(3501),
    [anon_sym_sizeof] = ACTIONS(3499),
    [anon_sym___alignof__] = ACTIONS(3499),
    [anon_sym___alignof] = ACTIONS(3499),
    [anon_sym__alignof] = ACTIONS(3499),
    [anon_sym_alignof] = ACTIONS(3499),
    [anon_sym__Alignof] = ACTIONS(3499),
    [anon_sym_offsetof] = ACTIONS(3499),
    [anon_sym__Generic] = ACTIONS(3499),
    [anon_sym_asm] = ACTIONS(3499),
    [anon_sym___asm__] = ACTIONS(3499),
    [aux_sym_number_literal_token1] = ACTIONS(3501),
    [aux_sym_number_literal_token2] = ACTIONS(3499),
    [anon_sym_L_SQUOTE] = ACTIONS(3501),
    [anon_sym_u_SQUOTE] = ACTIONS(3501),
    [anon_sym_U_SQUOTE] = ACTIONS(3501),
    [anon_sym_u8_SQUOTE] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3501),
    [anon_sym_L_DQUOTE] = ACTIONS(3501),
    [anon_sym_u_DQUOTE] = ACTIONS(3501),
    [anon_sym_U_DQUOTE] = ACTIONS(3501),
    [anon_sym_u8_DQUOTE] = ACTIONS(3501),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [sym_true] = ACTIONS(3499),
    [sym_false] = ACTIONS(3499),
    [anon_sym_NULL] = ACTIONS(3499),
    [anon_sym_nullptr] = ACTIONS(3499),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3499),
    [anon_sym_decltype] = ACTIONS(3499),
    [anon_sym_virtual] = ACTIONS(3499),
    [anon_sym_alignas] = ACTIONS(3499),
    [anon_sym_explicit] = ACTIONS(3499),
    [anon_sym_typename] = ACTIONS(3499),
    [anon_sym_template] = ACTIONS(3499),
    [anon_sym_operator] = ACTIONS(3499),
    [anon_sym_try] = ACTIONS(3499),
    [anon_sym_delete] = ACTIONS(3499),
    [anon_sym_throw] = ACTIONS(3499),
    [anon_sym_namespace] = ACTIONS(3499),
    [anon_sym_using] = ACTIONS(3499),
    [anon_sym_static_assert] = ACTIONS(3499),
    [anon_sym_concept] = ACTIONS(3499),
    [anon_sym_co_return] = ACTIONS(3499),
    [anon_sym_co_yield] = ACTIONS(3499),
    [anon_sym_R_DQUOTE] = ACTIONS(3501),
    [anon_sym_LR_DQUOTE] = ACTIONS(3501),
    [anon_sym_uR_DQUOTE] = ACTIONS(3501),
    [anon_sym_UR_DQUOTE] = ACTIONS(3501),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3501),
    [anon_sym_co_await] = ACTIONS(3499),
    [anon_sym_new] = ACTIONS(3499),
    [anon_sym_requires] = ACTIONS(3499),
    [sym_this] = ACTIONS(3499),
  },
  [453] = {
    [sym_identifier] = ACTIONS(3503),
    [aux_sym_preproc_include_token1] = ACTIONS(3503),
    [aux_sym_preproc_def_token1] = ACTIONS(3503),
    [aux_sym_preproc_if_token1] = ACTIONS(3503),
    [aux_sym_preproc_if_token2] = ACTIONS(3503),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3503),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3503),
    [aux_sym_preproc_else_token1] = ACTIONS(3503),
    [aux_sym_preproc_elif_token1] = ACTIONS(3503),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3503),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3503),
    [sym_preproc_directive] = ACTIONS(3503),
    [anon_sym_LPAREN2] = ACTIONS(3505),
    [anon_sym_BANG] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3503),
    [anon_sym_PLUS] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP] = ACTIONS(3503),
    [anon_sym_SEMI] = ACTIONS(3505),
    [anon_sym___extension__] = ACTIONS(3503),
    [anon_sym_typedef] = ACTIONS(3503),
    [anon_sym_extern] = ACTIONS(3503),
    [anon_sym___attribute__] = ACTIONS(3503),
    [anon_sym_COLON_COLON] = ACTIONS(3505),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3505),
    [anon_sym___declspec] = ACTIONS(3503),
    [anon_sym___based] = ACTIONS(3503),
    [anon_sym___cdecl] = ACTIONS(3503),
    [anon_sym___clrcall] = ACTIONS(3503),
    [anon_sym___stdcall] = ACTIONS(3503),
    [anon_sym___fastcall] = ACTIONS(3503),
    [anon_sym___thiscall] = ACTIONS(3503),
    [anon_sym___vectorcall] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_signed] = ACTIONS(3503),
    [anon_sym_unsigned] = ACTIONS(3503),
    [anon_sym_long] = ACTIONS(3503),
    [anon_sym_short] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3503),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_register] = ACTIONS(3503),
    [anon_sym_inline] = ACTIONS(3503),
    [anon_sym___inline] = ACTIONS(3503),
    [anon_sym___inline__] = ACTIONS(3503),
    [anon_sym___forceinline] = ACTIONS(3503),
    [anon_sym_thread_local] = ACTIONS(3503),
    [anon_sym___thread] = ACTIONS(3503),
    [anon_sym_const] = ACTIONS(3503),
    [anon_sym_constexpr] = ACTIONS(3503),
    [anon_sym_volatile] = ACTIONS(3503),
    [anon_sym_restrict] = ACTIONS(3503),
    [anon_sym___restrict__] = ACTIONS(3503),
    [anon_sym__Atomic] = ACTIONS(3503),
    [anon_sym__Noreturn] = ACTIONS(3503),
    [anon_sym_noreturn] = ACTIONS(3503),
    [anon_sym_mutable] = ACTIONS(3503),
    [anon_sym_constinit] = ACTIONS(3503),
    [anon_sym_consteval] = ACTIONS(3503),
    [anon_sym_PROGMEM] = ACTIONS(3503),
    [aux_sym_primitive_type_token1] = ACTIONS(3503),
    [anon_sym_byte] = ACTIONS(3503),
    [anon_sym_word] = ACTIONS(3503),
    [anon_sym_enum] = ACTIONS(3503),
    [anon_sym_class] = ACTIONS(3503),
    [anon_sym_struct] = ACTIONS(3503),
    [anon_sym_union] = ACTIONS(3503),
    [anon_sym_if] = ACTIONS(3503),
    [anon_sym_switch] = ACTIONS(3503),
    [anon_sym_case] = ACTIONS(3503),
    [anon_sym_default] = ACTIONS(3503),
    [anon_sym_while] = ACTIONS(3503),
    [anon_sym_do] = ACTIONS(3503),
    [anon_sym_for] = ACTIONS(3503),
    [anon_sym_return] = ACTIONS(3503),
    [anon_sym_break] = ACTIONS(3503),
    [anon_sym_continue] = ACTIONS(3503),
    [anon_sym_goto] = ACTIONS(3503),
    [anon_sym___try] = ACTIONS(3503),
    [anon_sym___leave] = ACTIONS(3503),
    [anon_sym_not] = ACTIONS(3503),
    [anon_sym_compl] = ACTIONS(3503),
    [anon_sym_DASH_DASH] = ACTIONS(3505),
    [anon_sym_PLUS_PLUS] = ACTIONS(3505),
    [anon_sym_sizeof] = ACTIONS(3503),
    [anon_sym___alignof__] = ACTIONS(3503),
    [anon_sym___alignof] = ACTIONS(3503),
    [anon_sym__alignof] = ACTIONS(3503),
    [anon_sym_alignof] = ACTIONS(3503),
    [anon_sym__Alignof] = ACTIONS(3503),
    [anon_sym_offsetof] = ACTIONS(3503),
    [anon_sym__Generic] = ACTIONS(3503),
    [anon_sym_asm] = ACTIONS(3503),
    [anon_sym___asm__] = ACTIONS(3503),
    [aux_sym_number_literal_token1] = ACTIONS(3505),
    [aux_sym_number_literal_token2] = ACTIONS(3503),
    [anon_sym_L_SQUOTE] = ACTIONS(3505),
    [anon_sym_u_SQUOTE] = ACTIONS(3505),
    [anon_sym_U_SQUOTE] = ACTIONS(3505),
    [anon_sym_u8_SQUOTE] = ACTIONS(3505),
    [anon_sym_SQUOTE] = ACTIONS(3505),
    [anon_sym_L_DQUOTE] = ACTIONS(3505),
    [anon_sym_u_DQUOTE] = ACTIONS(3505),
    [anon_sym_U_DQUOTE] = ACTIONS(3505),
    [anon_sym_u8_DQUOTE] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [sym_true] = ACTIONS(3503),
    [sym_false] = ACTIONS(3503),
    [anon_sym_NULL] = ACTIONS(3503),
    [anon_sym_nullptr] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3503),
    [anon_sym_decltype] = ACTIONS(3503),
    [anon_sym_virtual] = ACTIONS(3503),
    [anon_sym_alignas] = ACTIONS(3503),
    [anon_sym_explicit] = ACTIONS(3503),
    [anon_sym_typename] = ACTIONS(3503),
    [anon_sym_template] = ACTIONS(3503),
    [anon_sym_operator] = ACTIONS(3503),
    [anon_sym_try] = ACTIONS(3503),
    [anon_sym_delete] = ACTIONS(3503),
    [anon_sym_throw] = ACTIONS(3503),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_using] = ACTIONS(3503),
    [anon_sym_static_assert] = ACTIONS(3503),
    [anon_sym_concept] = ACTIONS(3503),
    [anon_sym_co_return] = ACTIONS(3503),
    [anon_sym_co_yield] = ACTIONS(3503),
    [anon_sym_R_DQUOTE] = ACTIONS(3505),
    [anon_sym_LR_DQUOTE] = ACTIONS(3505),
    [anon_sym_uR_DQUOTE] = ACTIONS(3505),
    [anon_sym_UR_DQUOTE] = ACTIONS(3505),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3505),
    [anon_sym_co_await] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3503),
    [anon_sym_requires] = ACTIONS(3503),
    [sym_this] = ACTIONS(3503),
  },
  [454] = {
    [sym_catch_clause] = STATE(396),
    [aux_sym_constructor_try_statement_repeat1] = STATE(396),
    [ts_builtin_sym_end] = ACTIONS(2852),
    [sym_identifier] = ACTIONS(2850),
    [aux_sym_preproc_include_token1] = ACTIONS(2850),
    [aux_sym_preproc_def_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2850),
    [sym_preproc_directive] = ACTIONS(2850),
    [anon_sym_LPAREN2] = ACTIONS(2852),
    [anon_sym_BANG] = ACTIONS(2852),
    [anon_sym_TILDE] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(2850),
    [anon_sym_PLUS] = ACTIONS(2850),
    [anon_sym_STAR] = ACTIONS(2852),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_AMP] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2852),
    [anon_sym___extension__] = ACTIONS(2850),
    [anon_sym_typedef] = ACTIONS(2850),
    [anon_sym_extern] = ACTIONS(2850),
    [anon_sym___attribute__] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2852),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2852),
    [anon_sym___declspec] = ACTIONS(2850),
    [anon_sym___based] = ACTIONS(2850),
    [anon_sym___cdecl] = ACTIONS(2850),
    [anon_sym___clrcall] = ACTIONS(2850),
    [anon_sym___stdcall] = ACTIONS(2850),
    [anon_sym___fastcall] = ACTIONS(2850),
    [anon_sym___thiscall] = ACTIONS(2850),
    [anon_sym___vectorcall] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2852),
    [anon_sym_signed] = ACTIONS(2850),
    [anon_sym_unsigned] = ACTIONS(2850),
    [anon_sym_long] = ACTIONS(2850),
    [anon_sym_short] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2850),
    [anon_sym_register] = ACTIONS(2850),
    [anon_sym_inline] = ACTIONS(2850),
    [anon_sym___inline] = ACTIONS(2850),
    [anon_sym___inline__] = ACTIONS(2850),
    [anon_sym___forceinline] = ACTIONS(2850),
    [anon_sym_thread_local] = ACTIONS(2850),
    [anon_sym___thread] = ACTIONS(2850),
    [anon_sym_const] = ACTIONS(2850),
    [anon_sym_constexpr] = ACTIONS(2850),
    [anon_sym_volatile] = ACTIONS(2850),
    [anon_sym_restrict] = ACTIONS(2850),
    [anon_sym___restrict__] = ACTIONS(2850),
    [anon_sym__Atomic] = ACTIONS(2850),
    [anon_sym__Noreturn] = ACTIONS(2850),
    [anon_sym_noreturn] = ACTIONS(2850),
    [anon_sym_mutable] = ACTIONS(2850),
    [anon_sym_constinit] = ACTIONS(2850),
    [anon_sym_consteval] = ACTIONS(2850),
    [anon_sym_PROGMEM] = ACTIONS(2850),
    [aux_sym_primitive_type_token1] = ACTIONS(2850),
    [anon_sym_byte] = ACTIONS(2850),
    [anon_sym_word] = ACTIONS(2850),
    [anon_sym_enum] = ACTIONS(2850),
    [anon_sym_class] = ACTIONS(2850),
    [anon_sym_struct] = ACTIONS(2850),
    [anon_sym_union] = ACTIONS(2850),
    [anon_sym_if] = ACTIONS(2850),
    [anon_sym_else] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2850),
    [anon_sym_case] = ACTIONS(2850),
    [anon_sym_default] = ACTIONS(2850),
    [anon_sym_while] = ACTIONS(2850),
    [anon_sym_do] = ACTIONS(2850),
    [anon_sym_for] = ACTIONS(2850),
    [anon_sym_return] = ACTIONS(2850),
    [anon_sym_break] = ACTIONS(2850),
    [anon_sym_continue] = ACTIONS(2850),
    [anon_sym_goto] = ACTIONS(2850),
    [anon_sym___try] = ACTIONS(2850),
    [anon_sym___leave] = ACTIONS(2850),
    [anon_sym_not] = ACTIONS(2850),
    [anon_sym_compl] = ACTIONS(2850),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_sizeof] = ACTIONS(2850),
    [anon_sym___alignof__] = ACTIONS(2850),
    [anon_sym___alignof] = ACTIONS(2850),
    [anon_sym__alignof] = ACTIONS(2850),
    [anon_sym_alignof] = ACTIONS(2850),
    [anon_sym__Alignof] = ACTIONS(2850),
    [anon_sym_offsetof] = ACTIONS(2850),
    [anon_sym__Generic] = ACTIONS(2850),
    [anon_sym_asm] = ACTIONS(2850),
    [anon_sym___asm__] = ACTIONS(2850),
    [aux_sym_number_literal_token1] = ACTIONS(2852),
    [aux_sym_number_literal_token2] = ACTIONS(2850),
    [anon_sym_L_SQUOTE] = ACTIONS(2852),
    [anon_sym_u_SQUOTE] = ACTIONS(2852),
    [anon_sym_U_SQUOTE] = ACTIONS(2852),
    [anon_sym_u8_SQUOTE] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2852),
    [anon_sym_L_DQUOTE] = ACTIONS(2852),
    [anon_sym_u_DQUOTE] = ACTIONS(2852),
    [anon_sym_U_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8_DQUOTE] = ACTIONS(2852),
    [anon_sym_DQUOTE] = ACTIONS(2852),
    [sym_true] = ACTIONS(2850),
    [sym_false] = ACTIONS(2850),
    [anon_sym_NULL] = ACTIONS(2850),
    [anon_sym_nullptr] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2850),
    [anon_sym_decltype] = ACTIONS(2850),
    [anon_sym_virtual] = ACTIONS(2850),
    [anon_sym_alignas] = ACTIONS(2850),
    [anon_sym_explicit] = ACTIONS(2850),
    [anon_sym_typename] = ACTIONS(2850),
    [anon_sym_template] = ACTIONS(2850),
    [anon_sym_operator] = ACTIONS(2850),
    [anon_sym_try] = ACTIONS(2850),
    [anon_sym_delete] = ACTIONS(2850),
    [anon_sym_throw] = ACTIONS(2850),
    [anon_sym_namespace] = ACTIONS(2850),
    [anon_sym_using] = ACTIONS(2850),
    [anon_sym_static_assert] = ACTIONS(2850),
    [anon_sym_concept] = ACTIONS(2850),
    [anon_sym_co_return] = ACTIONS(2850),
    [anon_sym_co_yield] = ACTIONS(2850),
    [anon_sym_catch] = ACTIONS(3507),
    [anon_sym_R_DQUOTE] = ACTIONS(2852),
    [anon_sym_LR_DQUOTE] = ACTIONS(2852),
    [anon_sym_uR_DQUOTE] = ACTIONS(2852),
    [anon_sym_UR_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2852),
    [anon_sym_co_await] = ACTIONS(2850),
    [anon_sym_new] = ACTIONS(2850),
    [anon_sym_requires] = ACTIONS(2850),
    [sym_this] = ACTIONS(2850),
  },
  [455] = {
    [sym_identifier] = ACTIONS(3509),
    [aux_sym_preproc_include_token1] = ACTIONS(3509),
    [aux_sym_preproc_def_token1] = ACTIONS(3509),
    [aux_sym_preproc_if_token1] = ACTIONS(3509),
    [aux_sym_preproc_if_token2] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3509),
    [aux_sym_preproc_else_token1] = ACTIONS(3509),
    [aux_sym_preproc_elif_token1] = ACTIONS(3509),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3509),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3509),
    [sym_preproc_directive] = ACTIONS(3509),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_BANG] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3509),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_SEMI] = ACTIONS(3511),
    [anon_sym___extension__] = ACTIONS(3509),
    [anon_sym_typedef] = ACTIONS(3509),
    [anon_sym_extern] = ACTIONS(3509),
    [anon_sym___attribute__] = ACTIONS(3509),
    [anon_sym_COLON_COLON] = ACTIONS(3511),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3511),
    [anon_sym___declspec] = ACTIONS(3509),
    [anon_sym___based] = ACTIONS(3509),
    [anon_sym___cdecl] = ACTIONS(3509),
    [anon_sym___clrcall] = ACTIONS(3509),
    [anon_sym___stdcall] = ACTIONS(3509),
    [anon_sym___fastcall] = ACTIONS(3509),
    [anon_sym___thiscall] = ACTIONS(3509),
    [anon_sym___vectorcall] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_signed] = ACTIONS(3509),
    [anon_sym_unsigned] = ACTIONS(3509),
    [anon_sym_long] = ACTIONS(3509),
    [anon_sym_short] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(3509),
    [anon_sym_static] = ACTIONS(3509),
    [anon_sym_register] = ACTIONS(3509),
    [anon_sym_inline] = ACTIONS(3509),
    [anon_sym___inline] = ACTIONS(3509),
    [anon_sym___inline__] = ACTIONS(3509),
    [anon_sym___forceinline] = ACTIONS(3509),
    [anon_sym_thread_local] = ACTIONS(3509),
    [anon_sym___thread] = ACTIONS(3509),
    [anon_sym_const] = ACTIONS(3509),
    [anon_sym_constexpr] = ACTIONS(3509),
    [anon_sym_volatile] = ACTIONS(3509),
    [anon_sym_restrict] = ACTIONS(3509),
    [anon_sym___restrict__] = ACTIONS(3509),
    [anon_sym__Atomic] = ACTIONS(3509),
    [anon_sym__Noreturn] = ACTIONS(3509),
    [anon_sym_noreturn] = ACTIONS(3509),
    [anon_sym_mutable] = ACTIONS(3509),
    [anon_sym_constinit] = ACTIONS(3509),
    [anon_sym_consteval] = ACTIONS(3509),
    [anon_sym_PROGMEM] = ACTIONS(3509),
    [aux_sym_primitive_type_token1] = ACTIONS(3509),
    [anon_sym_byte] = ACTIONS(3509),
    [anon_sym_word] = ACTIONS(3509),
    [anon_sym_enum] = ACTIONS(3509),
    [anon_sym_class] = ACTIONS(3509),
    [anon_sym_struct] = ACTIONS(3509),
    [anon_sym_union] = ACTIONS(3509),
    [anon_sym_if] = ACTIONS(3509),
    [anon_sym_switch] = ACTIONS(3509),
    [anon_sym_case] = ACTIONS(3509),
    [anon_sym_default] = ACTIONS(3509),
    [anon_sym_while] = ACTIONS(3509),
    [anon_sym_do] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3509),
    [anon_sym_return] = ACTIONS(3509),
    [anon_sym_break] = ACTIONS(3509),
    [anon_sym_continue] = ACTIONS(3509),
    [anon_sym_goto] = ACTIONS(3509),
    [anon_sym___try] = ACTIONS(3509),
    [anon_sym___leave] = ACTIONS(3509),
    [anon_sym_not] = ACTIONS(3509),
    [anon_sym_compl] = ACTIONS(3509),
    [anon_sym_DASH_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_PLUS] = ACTIONS(3511),
    [anon_sym_sizeof] = ACTIONS(3509),
    [anon_sym___alignof__] = ACTIONS(3509),
    [anon_sym___alignof] = ACTIONS(3509),
    [anon_sym__alignof] = ACTIONS(3509),
    [anon_sym_alignof] = ACTIONS(3509),
    [anon_sym__Alignof] = ACTIONS(3509),
    [anon_sym_offsetof] = ACTIONS(3509),
    [anon_sym__Generic] = ACTIONS(3509),
    [anon_sym_asm] = ACTIONS(3509),
    [anon_sym___asm__] = ACTIONS(3509),
    [aux_sym_number_literal_token1] = ACTIONS(3511),
    [aux_sym_number_literal_token2] = ACTIONS(3509),
    [anon_sym_L_SQUOTE] = ACTIONS(3511),
    [anon_sym_u_SQUOTE] = ACTIONS(3511),
    [anon_sym_U_SQUOTE] = ACTIONS(3511),
    [anon_sym_u8_SQUOTE] = ACTIONS(3511),
    [anon_sym_SQUOTE] = ACTIONS(3511),
    [anon_sym_L_DQUOTE] = ACTIONS(3511),
    [anon_sym_u_DQUOTE] = ACTIONS(3511),
    [anon_sym_U_DQUOTE] = ACTIONS(3511),
    [anon_sym_u8_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [sym_true] = ACTIONS(3509),
    [sym_false] = ACTIONS(3509),
    [anon_sym_NULL] = ACTIONS(3509),
    [anon_sym_nullptr] = ACTIONS(3509),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3509),
    [anon_sym_decltype] = ACTIONS(3509),
    [anon_sym_virtual] = ACTIONS(3509),
    [anon_sym_alignas] = ACTIONS(3509),
    [anon_sym_explicit] = ACTIONS(3509),
    [anon_sym_typename] = ACTIONS(3509),
    [anon_sym_template] = ACTIONS(3509),
    [anon_sym_operator] = ACTIONS(3509),
    [anon_sym_try] = ACTIONS(3509),
    [anon_sym_delete] = ACTIONS(3509),
    [anon_sym_throw] = ACTIONS(3509),
    [anon_sym_namespace] = ACTIONS(3509),
    [anon_sym_using] = ACTIONS(3509),
    [anon_sym_static_assert] = ACTIONS(3509),
    [anon_sym_concept] = ACTIONS(3509),
    [anon_sym_co_return] = ACTIONS(3509),
    [anon_sym_co_yield] = ACTIONS(3509),
    [anon_sym_R_DQUOTE] = ACTIONS(3511),
    [anon_sym_LR_DQUOTE] = ACTIONS(3511),
    [anon_sym_uR_DQUOTE] = ACTIONS(3511),
    [anon_sym_UR_DQUOTE] = ACTIONS(3511),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3511),
    [anon_sym_co_await] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3509),
    [anon_sym_requires] = ACTIONS(3509),
    [sym_this] = ACTIONS(3509),
  },
  [456] = {
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_include_token1] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token2] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [aux_sym_preproc_else_token1] = ACTIONS(3513),
    [aux_sym_preproc_elif_token1] = ACTIONS(3513),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_BANG] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3513),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym_SEMI] = ACTIONS(3515),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym___cdecl] = ACTIONS(3513),
    [anon_sym___clrcall] = ACTIONS(3513),
    [anon_sym___stdcall] = ACTIONS(3513),
    [anon_sym___fastcall] = ACTIONS(3513),
    [anon_sym___thiscall] = ACTIONS(3513),
    [anon_sym___vectorcall] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_PROGMEM] = ACTIONS(3513),
    [aux_sym_primitive_type_token1] = ACTIONS(3513),
    [anon_sym_byte] = ACTIONS(3513),
    [anon_sym_word] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [anon_sym_if] = ACTIONS(3513),
    [anon_sym_switch] = ACTIONS(3513),
    [anon_sym_case] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3513),
    [anon_sym_while] = ACTIONS(3513),
    [anon_sym_do] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3513),
    [anon_sym_return] = ACTIONS(3513),
    [anon_sym_break] = ACTIONS(3513),
    [anon_sym_continue] = ACTIONS(3513),
    [anon_sym_goto] = ACTIONS(3513),
    [anon_sym___try] = ACTIONS(3513),
    [anon_sym___leave] = ACTIONS(3513),
    [anon_sym_not] = ACTIONS(3513),
    [anon_sym_compl] = ACTIONS(3513),
    [anon_sym_DASH_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_PLUS] = ACTIONS(3515),
    [anon_sym_sizeof] = ACTIONS(3513),
    [anon_sym___alignof__] = ACTIONS(3513),
    [anon_sym___alignof] = ACTIONS(3513),
    [anon_sym__alignof] = ACTIONS(3513),
    [anon_sym_alignof] = ACTIONS(3513),
    [anon_sym__Alignof] = ACTIONS(3513),
    [anon_sym_offsetof] = ACTIONS(3513),
    [anon_sym__Generic] = ACTIONS(3513),
    [anon_sym_asm] = ACTIONS(3513),
    [anon_sym___asm__] = ACTIONS(3513),
    [aux_sym_number_literal_token1] = ACTIONS(3515),
    [aux_sym_number_literal_token2] = ACTIONS(3513),
    [anon_sym_L_SQUOTE] = ACTIONS(3515),
    [anon_sym_u_SQUOTE] = ACTIONS(3515),
    [anon_sym_U_SQUOTE] = ACTIONS(3515),
    [anon_sym_u8_SQUOTE] = ACTIONS(3515),
    [anon_sym_SQUOTE] = ACTIONS(3515),
    [anon_sym_L_DQUOTE] = ACTIONS(3515),
    [anon_sym_u_DQUOTE] = ACTIONS(3515),
    [anon_sym_U_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [sym_true] = ACTIONS(3513),
    [sym_false] = ACTIONS(3513),
    [anon_sym_NULL] = ACTIONS(3513),
    [anon_sym_nullptr] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [anon_sym_virtual] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3513),
    [anon_sym_delete] = ACTIONS(3513),
    [anon_sym_throw] = ACTIONS(3513),
    [anon_sym_namespace] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
    [anon_sym_concept] = ACTIONS(3513),
    [anon_sym_co_return] = ACTIONS(3513),
    [anon_sym_co_yield] = ACTIONS(3513),
    [anon_sym_R_DQUOTE] = ACTIONS(3515),
    [anon_sym_LR_DQUOTE] = ACTIONS(3515),
    [anon_sym_uR_DQUOTE] = ACTIONS(3515),
    [anon_sym_UR_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3515),
    [anon_sym_co_await] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3513),
    [anon_sym_requires] = ACTIONS(3513),
    [sym_this] = ACTIONS(3513),
  },
  [457] = {
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_include_token1] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token2] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [aux_sym_preproc_else_token1] = ACTIONS(3513),
    [aux_sym_preproc_elif_token1] = ACTIONS(3513),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_BANG] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3513),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym_SEMI] = ACTIONS(3515),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym___cdecl] = ACTIONS(3513),
    [anon_sym___clrcall] = ACTIONS(3513),
    [anon_sym___stdcall] = ACTIONS(3513),
    [anon_sym___fastcall] = ACTIONS(3513),
    [anon_sym___thiscall] = ACTIONS(3513),
    [anon_sym___vectorcall] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_PROGMEM] = ACTIONS(3513),
    [aux_sym_primitive_type_token1] = ACTIONS(3513),
    [anon_sym_byte] = ACTIONS(3513),
    [anon_sym_word] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [anon_sym_if] = ACTIONS(3513),
    [anon_sym_switch] = ACTIONS(3513),
    [anon_sym_case] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3513),
    [anon_sym_while] = ACTIONS(3513),
    [anon_sym_do] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3513),
    [anon_sym_return] = ACTIONS(3513),
    [anon_sym_break] = ACTIONS(3513),
    [anon_sym_continue] = ACTIONS(3513),
    [anon_sym_goto] = ACTIONS(3513),
    [anon_sym___try] = ACTIONS(3513),
    [anon_sym___leave] = ACTIONS(3513),
    [anon_sym_not] = ACTIONS(3513),
    [anon_sym_compl] = ACTIONS(3513),
    [anon_sym_DASH_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_PLUS] = ACTIONS(3515),
    [anon_sym_sizeof] = ACTIONS(3513),
    [anon_sym___alignof__] = ACTIONS(3513),
    [anon_sym___alignof] = ACTIONS(3513),
    [anon_sym__alignof] = ACTIONS(3513),
    [anon_sym_alignof] = ACTIONS(3513),
    [anon_sym__Alignof] = ACTIONS(3513),
    [anon_sym_offsetof] = ACTIONS(3513),
    [anon_sym__Generic] = ACTIONS(3513),
    [anon_sym_asm] = ACTIONS(3513),
    [anon_sym___asm__] = ACTIONS(3513),
    [aux_sym_number_literal_token1] = ACTIONS(3515),
    [aux_sym_number_literal_token2] = ACTIONS(3513),
    [anon_sym_L_SQUOTE] = ACTIONS(3515),
    [anon_sym_u_SQUOTE] = ACTIONS(3515),
    [anon_sym_U_SQUOTE] = ACTIONS(3515),
    [anon_sym_u8_SQUOTE] = ACTIONS(3515),
    [anon_sym_SQUOTE] = ACTIONS(3515),
    [anon_sym_L_DQUOTE] = ACTIONS(3515),
    [anon_sym_u_DQUOTE] = ACTIONS(3515),
    [anon_sym_U_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [sym_true] = ACTIONS(3513),
    [sym_false] = ACTIONS(3513),
    [anon_sym_NULL] = ACTIONS(3513),
    [anon_sym_nullptr] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [anon_sym_virtual] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3513),
    [anon_sym_delete] = ACTIONS(3513),
    [anon_sym_throw] = ACTIONS(3513),
    [anon_sym_namespace] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
    [anon_sym_concept] = ACTIONS(3513),
    [anon_sym_co_return] = ACTIONS(3513),
    [anon_sym_co_yield] = ACTIONS(3513),
    [anon_sym_R_DQUOTE] = ACTIONS(3515),
    [anon_sym_LR_DQUOTE] = ACTIONS(3515),
    [anon_sym_uR_DQUOTE] = ACTIONS(3515),
    [anon_sym_UR_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3515),
    [anon_sym_co_await] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3513),
    [anon_sym_requires] = ACTIONS(3513),
    [sym_this] = ACTIONS(3513),
  },
  [458] = {
    [sym_identifier] = ACTIONS(3517),
    [aux_sym_preproc_include_token1] = ACTIONS(3517),
    [aux_sym_preproc_def_token1] = ACTIONS(3517),
    [aux_sym_preproc_if_token1] = ACTIONS(3517),
    [aux_sym_preproc_if_token2] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3517),
    [aux_sym_preproc_else_token1] = ACTIONS(3517),
    [aux_sym_preproc_elif_token1] = ACTIONS(3517),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3517),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3517),
    [sym_preproc_directive] = ACTIONS(3517),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_BANG] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3517),
    [anon_sym_PLUS] = ACTIONS(3517),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_SEMI] = ACTIONS(3519),
    [anon_sym___extension__] = ACTIONS(3517),
    [anon_sym_typedef] = ACTIONS(3517),
    [anon_sym_extern] = ACTIONS(3517),
    [anon_sym___attribute__] = ACTIONS(3517),
    [anon_sym_COLON_COLON] = ACTIONS(3519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3519),
    [anon_sym___declspec] = ACTIONS(3517),
    [anon_sym___based] = ACTIONS(3517),
    [anon_sym___cdecl] = ACTIONS(3517),
    [anon_sym___clrcall] = ACTIONS(3517),
    [anon_sym___stdcall] = ACTIONS(3517),
    [anon_sym___fastcall] = ACTIONS(3517),
    [anon_sym___thiscall] = ACTIONS(3517),
    [anon_sym___vectorcall] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_signed] = ACTIONS(3517),
    [anon_sym_unsigned] = ACTIONS(3517),
    [anon_sym_long] = ACTIONS(3517),
    [anon_sym_short] = ACTIONS(3517),
    [anon_sym_LBRACK] = ACTIONS(3517),
    [anon_sym_static] = ACTIONS(3517),
    [anon_sym_register] = ACTIONS(3517),
    [anon_sym_inline] = ACTIONS(3517),
    [anon_sym___inline] = ACTIONS(3517),
    [anon_sym___inline__] = ACTIONS(3517),
    [anon_sym___forceinline] = ACTIONS(3517),
    [anon_sym_thread_local] = ACTIONS(3517),
    [anon_sym___thread] = ACTIONS(3517),
    [anon_sym_const] = ACTIONS(3517),
    [anon_sym_constexpr] = ACTIONS(3517),
    [anon_sym_volatile] = ACTIONS(3517),
    [anon_sym_restrict] = ACTIONS(3517),
    [anon_sym___restrict__] = ACTIONS(3517),
    [anon_sym__Atomic] = ACTIONS(3517),
    [anon_sym__Noreturn] = ACTIONS(3517),
    [anon_sym_noreturn] = ACTIONS(3517),
    [anon_sym_mutable] = ACTIONS(3517),
    [anon_sym_constinit] = ACTIONS(3517),
    [anon_sym_consteval] = ACTIONS(3517),
    [anon_sym_PROGMEM] = ACTIONS(3517),
    [aux_sym_primitive_type_token1] = ACTIONS(3517),
    [anon_sym_byte] = ACTIONS(3517),
    [anon_sym_word] = ACTIONS(3517),
    [anon_sym_enum] = ACTIONS(3517),
    [anon_sym_class] = ACTIONS(3517),
    [anon_sym_struct] = ACTIONS(3517),
    [anon_sym_union] = ACTIONS(3517),
    [anon_sym_if] = ACTIONS(3517),
    [anon_sym_switch] = ACTIONS(3517),
    [anon_sym_case] = ACTIONS(3517),
    [anon_sym_default] = ACTIONS(3517),
    [anon_sym_while] = ACTIONS(3517),
    [anon_sym_do] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3517),
    [anon_sym_return] = ACTIONS(3517),
    [anon_sym_break] = ACTIONS(3517),
    [anon_sym_continue] = ACTIONS(3517),
    [anon_sym_goto] = ACTIONS(3517),
    [anon_sym___try] = ACTIONS(3517),
    [anon_sym___leave] = ACTIONS(3517),
    [anon_sym_not] = ACTIONS(3517),
    [anon_sym_compl] = ACTIONS(3517),
    [anon_sym_DASH_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_PLUS] = ACTIONS(3519),
    [anon_sym_sizeof] = ACTIONS(3517),
    [anon_sym___alignof__] = ACTIONS(3517),
    [anon_sym___alignof] = ACTIONS(3517),
    [anon_sym__alignof] = ACTIONS(3517),
    [anon_sym_alignof] = ACTIONS(3517),
    [anon_sym__Alignof] = ACTIONS(3517),
    [anon_sym_offsetof] = ACTIONS(3517),
    [anon_sym__Generic] = ACTIONS(3517),
    [anon_sym_asm] = ACTIONS(3517),
    [anon_sym___asm__] = ACTIONS(3517),
    [aux_sym_number_literal_token1] = ACTIONS(3519),
    [aux_sym_number_literal_token2] = ACTIONS(3517),
    [anon_sym_L_SQUOTE] = ACTIONS(3519),
    [anon_sym_u_SQUOTE] = ACTIONS(3519),
    [anon_sym_U_SQUOTE] = ACTIONS(3519),
    [anon_sym_u8_SQUOTE] = ACTIONS(3519),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_L_DQUOTE] = ACTIONS(3519),
    [anon_sym_u_DQUOTE] = ACTIONS(3519),
    [anon_sym_U_DQUOTE] = ACTIONS(3519),
    [anon_sym_u8_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [sym_true] = ACTIONS(3517),
    [sym_false] = ACTIONS(3517),
    [anon_sym_NULL] = ACTIONS(3517),
    [anon_sym_nullptr] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3517),
    [anon_sym_decltype] = ACTIONS(3517),
    [anon_sym_virtual] = ACTIONS(3517),
    [anon_sym_alignas] = ACTIONS(3517),
    [anon_sym_explicit] = ACTIONS(3517),
    [anon_sym_typename] = ACTIONS(3517),
    [anon_sym_template] = ACTIONS(3517),
    [anon_sym_operator] = ACTIONS(3517),
    [anon_sym_try] = ACTIONS(3517),
    [anon_sym_delete] = ACTIONS(3517),
    [anon_sym_throw] = ACTIONS(3517),
    [anon_sym_namespace] = ACTIONS(3517),
    [anon_sym_using] = ACTIONS(3517),
    [anon_sym_static_assert] = ACTIONS(3517),
    [anon_sym_concept] = ACTIONS(3517),
    [anon_sym_co_return] = ACTIONS(3517),
    [anon_sym_co_yield] = ACTIONS(3517),
    [anon_sym_R_DQUOTE] = ACTIONS(3519),
    [anon_sym_LR_DQUOTE] = ACTIONS(3519),
    [anon_sym_uR_DQUOTE] = ACTIONS(3519),
    [anon_sym_UR_DQUOTE] = ACTIONS(3519),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3519),
    [anon_sym_co_await] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3517),
    [anon_sym_requires] = ACTIONS(3517),
    [sym_this] = ACTIONS(3517),
  },
  [459] = {
    [sym_identifier] = ACTIONS(3521),
    [aux_sym_preproc_include_token1] = ACTIONS(3521),
    [aux_sym_preproc_def_token1] = ACTIONS(3521),
    [aux_sym_preproc_if_token1] = ACTIONS(3521),
    [aux_sym_preproc_if_token2] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3521),
    [aux_sym_preproc_else_token1] = ACTIONS(3521),
    [aux_sym_preproc_elif_token1] = ACTIONS(3521),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3521),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3521),
    [sym_preproc_directive] = ACTIONS(3521),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_BANG] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3521),
    [anon_sym_PLUS] = ACTIONS(3521),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3521),
    [anon_sym_SEMI] = ACTIONS(3523),
    [anon_sym___extension__] = ACTIONS(3521),
    [anon_sym_typedef] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym___attribute__] = ACTIONS(3521),
    [anon_sym_COLON_COLON] = ACTIONS(3523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3523),
    [anon_sym___declspec] = ACTIONS(3521),
    [anon_sym___based] = ACTIONS(3521),
    [anon_sym___cdecl] = ACTIONS(3521),
    [anon_sym___clrcall] = ACTIONS(3521),
    [anon_sym___stdcall] = ACTIONS(3521),
    [anon_sym___fastcall] = ACTIONS(3521),
    [anon_sym___thiscall] = ACTIONS(3521),
    [anon_sym___vectorcall] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_signed] = ACTIONS(3521),
    [anon_sym_unsigned] = ACTIONS(3521),
    [anon_sym_long] = ACTIONS(3521),
    [anon_sym_short] = ACTIONS(3521),
    [anon_sym_LBRACK] = ACTIONS(3521),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_register] = ACTIONS(3521),
    [anon_sym_inline] = ACTIONS(3521),
    [anon_sym___inline] = ACTIONS(3521),
    [anon_sym___inline__] = ACTIONS(3521),
    [anon_sym___forceinline] = ACTIONS(3521),
    [anon_sym_thread_local] = ACTIONS(3521),
    [anon_sym___thread] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_constexpr] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym_restrict] = ACTIONS(3521),
    [anon_sym___restrict__] = ACTIONS(3521),
    [anon_sym__Atomic] = ACTIONS(3521),
    [anon_sym__Noreturn] = ACTIONS(3521),
    [anon_sym_noreturn] = ACTIONS(3521),
    [anon_sym_mutable] = ACTIONS(3521),
    [anon_sym_constinit] = ACTIONS(3521),
    [anon_sym_consteval] = ACTIONS(3521),
    [anon_sym_PROGMEM] = ACTIONS(3521),
    [aux_sym_primitive_type_token1] = ACTIONS(3521),
    [anon_sym_byte] = ACTIONS(3521),
    [anon_sym_word] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_class] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_union] = ACTIONS(3521),
    [anon_sym_if] = ACTIONS(3521),
    [anon_sym_switch] = ACTIONS(3521),
    [anon_sym_case] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3521),
    [anon_sym_while] = ACTIONS(3521),
    [anon_sym_do] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3521),
    [anon_sym_return] = ACTIONS(3521),
    [anon_sym_break] = ACTIONS(3521),
    [anon_sym_continue] = ACTIONS(3521),
    [anon_sym_goto] = ACTIONS(3521),
    [anon_sym___try] = ACTIONS(3521),
    [anon_sym___leave] = ACTIONS(3521),
    [anon_sym_not] = ACTIONS(3521),
    [anon_sym_compl] = ACTIONS(3521),
    [anon_sym_DASH_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_PLUS] = ACTIONS(3523),
    [anon_sym_sizeof] = ACTIONS(3521),
    [anon_sym___alignof__] = ACTIONS(3521),
    [anon_sym___alignof] = ACTIONS(3521),
    [anon_sym__alignof] = ACTIONS(3521),
    [anon_sym_alignof] = ACTIONS(3521),
    [anon_sym__Alignof] = ACTIONS(3521),
    [anon_sym_offsetof] = ACTIONS(3521),
    [anon_sym__Generic] = ACTIONS(3521),
    [anon_sym_asm] = ACTIONS(3521),
    [anon_sym___asm__] = ACTIONS(3521),
    [aux_sym_number_literal_token1] = ACTIONS(3523),
    [aux_sym_number_literal_token2] = ACTIONS(3521),
    [anon_sym_L_SQUOTE] = ACTIONS(3523),
    [anon_sym_u_SQUOTE] = ACTIONS(3523),
    [anon_sym_U_SQUOTE] = ACTIONS(3523),
    [anon_sym_u8_SQUOTE] = ACTIONS(3523),
    [anon_sym_SQUOTE] = ACTIONS(3523),
    [anon_sym_L_DQUOTE] = ACTIONS(3523),
    [anon_sym_u_DQUOTE] = ACTIONS(3523),
    [anon_sym_U_DQUOTE] = ACTIONS(3523),
    [anon_sym_u8_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [sym_true] = ACTIONS(3521),
    [sym_false] = ACTIONS(3521),
    [anon_sym_NULL] = ACTIONS(3521),
    [anon_sym_nullptr] = ACTIONS(3521),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3521),
    [anon_sym_decltype] = ACTIONS(3521),
    [anon_sym_virtual] = ACTIONS(3521),
    [anon_sym_alignas] = ACTIONS(3521),
    [anon_sym_explicit] = ACTIONS(3521),
    [anon_sym_typename] = ACTIONS(3521),
    [anon_sym_template] = ACTIONS(3521),
    [anon_sym_operator] = ACTIONS(3521),
    [anon_sym_try] = ACTIONS(3521),
    [anon_sym_delete] = ACTIONS(3521),
    [anon_sym_throw] = ACTIONS(3521),
    [anon_sym_namespace] = ACTIONS(3521),
    [anon_sym_using] = ACTIONS(3521),
    [anon_sym_static_assert] = ACTIONS(3521),
    [anon_sym_concept] = ACTIONS(3521),
    [anon_sym_co_return] = ACTIONS(3521),
    [anon_sym_co_yield] = ACTIONS(3521),
    [anon_sym_R_DQUOTE] = ACTIONS(3523),
    [anon_sym_LR_DQUOTE] = ACTIONS(3523),
    [anon_sym_uR_DQUOTE] = ACTIONS(3523),
    [anon_sym_UR_DQUOTE] = ACTIONS(3523),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3523),
    [anon_sym_co_await] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3521),
    [anon_sym_requires] = ACTIONS(3521),
    [sym_this] = ACTIONS(3521),
  },
  [460] = {
    [sym_identifier] = ACTIONS(3525),
    [aux_sym_preproc_include_token1] = ACTIONS(3525),
    [aux_sym_preproc_def_token1] = ACTIONS(3525),
    [aux_sym_preproc_if_token1] = ACTIONS(3525),
    [aux_sym_preproc_if_token2] = ACTIONS(3525),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3525),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3525),
    [aux_sym_preproc_else_token1] = ACTIONS(3525),
    [aux_sym_preproc_elif_token1] = ACTIONS(3525),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3525),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3525),
    [sym_preproc_directive] = ACTIONS(3525),
    [anon_sym_LPAREN2] = ACTIONS(3527),
    [anon_sym_BANG] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3525),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_AMP] = ACTIONS(3525),
    [anon_sym_SEMI] = ACTIONS(3527),
    [anon_sym___extension__] = ACTIONS(3525),
    [anon_sym_typedef] = ACTIONS(3525),
    [anon_sym_extern] = ACTIONS(3525),
    [anon_sym___attribute__] = ACTIONS(3525),
    [anon_sym_COLON_COLON] = ACTIONS(3527),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3527),
    [anon_sym___declspec] = ACTIONS(3525),
    [anon_sym___based] = ACTIONS(3525),
    [anon_sym___cdecl] = ACTIONS(3525),
    [anon_sym___clrcall] = ACTIONS(3525),
    [anon_sym___stdcall] = ACTIONS(3525),
    [anon_sym___fastcall] = ACTIONS(3525),
    [anon_sym___thiscall] = ACTIONS(3525),
    [anon_sym___vectorcall] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_signed] = ACTIONS(3525),
    [anon_sym_unsigned] = ACTIONS(3525),
    [anon_sym_long] = ACTIONS(3525),
    [anon_sym_short] = ACTIONS(3525),
    [anon_sym_LBRACK] = ACTIONS(3525),
    [anon_sym_static] = ACTIONS(3525),
    [anon_sym_register] = ACTIONS(3525),
    [anon_sym_inline] = ACTIONS(3525),
    [anon_sym___inline] = ACTIONS(3525),
    [anon_sym___inline__] = ACTIONS(3525),
    [anon_sym___forceinline] = ACTIONS(3525),
    [anon_sym_thread_local] = ACTIONS(3525),
    [anon_sym___thread] = ACTIONS(3525),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_constexpr] = ACTIONS(3525),
    [anon_sym_volatile] = ACTIONS(3525),
    [anon_sym_restrict] = ACTIONS(3525),
    [anon_sym___restrict__] = ACTIONS(3525),
    [anon_sym__Atomic] = ACTIONS(3525),
    [anon_sym__Noreturn] = ACTIONS(3525),
    [anon_sym_noreturn] = ACTIONS(3525),
    [anon_sym_mutable] = ACTIONS(3525),
    [anon_sym_constinit] = ACTIONS(3525),
    [anon_sym_consteval] = ACTIONS(3525),
    [anon_sym_PROGMEM] = ACTIONS(3525),
    [aux_sym_primitive_type_token1] = ACTIONS(3525),
    [anon_sym_byte] = ACTIONS(3525),
    [anon_sym_word] = ACTIONS(3525),
    [anon_sym_enum] = ACTIONS(3525),
    [anon_sym_class] = ACTIONS(3525),
    [anon_sym_struct] = ACTIONS(3525),
    [anon_sym_union] = ACTIONS(3525),
    [anon_sym_if] = ACTIONS(3525),
    [anon_sym_switch] = ACTIONS(3525),
    [anon_sym_case] = ACTIONS(3525),
    [anon_sym_default] = ACTIONS(3525),
    [anon_sym_while] = ACTIONS(3525),
    [anon_sym_do] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3525),
    [anon_sym_return] = ACTIONS(3525),
    [anon_sym_break] = ACTIONS(3525),
    [anon_sym_continue] = ACTIONS(3525),
    [anon_sym_goto] = ACTIONS(3525),
    [anon_sym___try] = ACTIONS(3525),
    [anon_sym___leave] = ACTIONS(3525),
    [anon_sym_not] = ACTIONS(3525),
    [anon_sym_compl] = ACTIONS(3525),
    [anon_sym_DASH_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_PLUS] = ACTIONS(3527),
    [anon_sym_sizeof] = ACTIONS(3525),
    [anon_sym___alignof__] = ACTIONS(3525),
    [anon_sym___alignof] = ACTIONS(3525),
    [anon_sym__alignof] = ACTIONS(3525),
    [anon_sym_alignof] = ACTIONS(3525),
    [anon_sym__Alignof] = ACTIONS(3525),
    [anon_sym_offsetof] = ACTIONS(3525),
    [anon_sym__Generic] = ACTIONS(3525),
    [anon_sym_asm] = ACTIONS(3525),
    [anon_sym___asm__] = ACTIONS(3525),
    [aux_sym_number_literal_token1] = ACTIONS(3527),
    [aux_sym_number_literal_token2] = ACTIONS(3525),
    [anon_sym_L_SQUOTE] = ACTIONS(3527),
    [anon_sym_u_SQUOTE] = ACTIONS(3527),
    [anon_sym_U_SQUOTE] = ACTIONS(3527),
    [anon_sym_u8_SQUOTE] = ACTIONS(3527),
    [anon_sym_SQUOTE] = ACTIONS(3527),
    [anon_sym_L_DQUOTE] = ACTIONS(3527),
    [anon_sym_u_DQUOTE] = ACTIONS(3527),
    [anon_sym_U_DQUOTE] = ACTIONS(3527),
    [anon_sym_u8_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [sym_true] = ACTIONS(3525),
    [sym_false] = ACTIONS(3525),
    [anon_sym_NULL] = ACTIONS(3525),
    [anon_sym_nullptr] = ACTIONS(3525),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3525),
    [anon_sym_decltype] = ACTIONS(3525),
    [anon_sym_virtual] = ACTIONS(3525),
    [anon_sym_alignas] = ACTIONS(3525),
    [anon_sym_explicit] = ACTIONS(3525),
    [anon_sym_typename] = ACTIONS(3525),
    [anon_sym_template] = ACTIONS(3525),
    [anon_sym_operator] = ACTIONS(3525),
    [anon_sym_try] = ACTIONS(3525),
    [anon_sym_delete] = ACTIONS(3525),
    [anon_sym_throw] = ACTIONS(3525),
    [anon_sym_namespace] = ACTIONS(3525),
    [anon_sym_using] = ACTIONS(3525),
    [anon_sym_static_assert] = ACTIONS(3525),
    [anon_sym_concept] = ACTIONS(3525),
    [anon_sym_co_return] = ACTIONS(3525),
    [anon_sym_co_yield] = ACTIONS(3525),
    [anon_sym_R_DQUOTE] = ACTIONS(3527),
    [anon_sym_LR_DQUOTE] = ACTIONS(3527),
    [anon_sym_uR_DQUOTE] = ACTIONS(3527),
    [anon_sym_UR_DQUOTE] = ACTIONS(3527),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3527),
    [anon_sym_co_await] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3525),
    [anon_sym_requires] = ACTIONS(3525),
    [sym_this] = ACTIONS(3525),
  },
  [461] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_include_token1] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token2] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [aux_sym_preproc_else_token1] = ACTIONS(3082),
    [aux_sym_preproc_elif_token1] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym___cdecl] = ACTIONS(3082),
    [anon_sym___clrcall] = ACTIONS(3082),
    [anon_sym___stdcall] = ACTIONS(3082),
    [anon_sym___fastcall] = ACTIONS(3082),
    [anon_sym___thiscall] = ACTIONS(3082),
    [anon_sym___vectorcall] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_else] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_goto] = ACTIONS(3082),
    [anon_sym___try] = ACTIONS(3082),
    [anon_sym___leave] = ACTIONS(3082),
    [anon_sym_not] = ACTIONS(3082),
    [anon_sym_compl] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_sizeof] = ACTIONS(3082),
    [anon_sym___alignof__] = ACTIONS(3082),
    [anon_sym___alignof] = ACTIONS(3082),
    [anon_sym__alignof] = ACTIONS(3082),
    [anon_sym_alignof] = ACTIONS(3082),
    [anon_sym__Alignof] = ACTIONS(3082),
    [anon_sym_offsetof] = ACTIONS(3082),
    [anon_sym__Generic] = ACTIONS(3082),
    [anon_sym_asm] = ACTIONS(3082),
    [anon_sym___asm__] = ACTIONS(3082),
    [aux_sym_number_literal_token1] = ACTIONS(3084),
    [aux_sym_number_literal_token2] = ACTIONS(3082),
    [anon_sym_L_SQUOTE] = ACTIONS(3084),
    [anon_sym_u_SQUOTE] = ACTIONS(3084),
    [anon_sym_U_SQUOTE] = ACTIONS(3084),
    [anon_sym_u8_SQUOTE] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_L_DQUOTE] = ACTIONS(3084),
    [anon_sym_u_DQUOTE] = ACTIONS(3084),
    [anon_sym_U_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8_DQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [anon_sym_NULL] = ACTIONS(3082),
    [anon_sym_nullptr] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
    [anon_sym_concept] = ACTIONS(3082),
    [anon_sym_co_return] = ACTIONS(3082),
    [anon_sym_co_yield] = ACTIONS(3082),
    [anon_sym_R_DQUOTE] = ACTIONS(3084),
    [anon_sym_LR_DQUOTE] = ACTIONS(3084),
    [anon_sym_uR_DQUOTE] = ACTIONS(3084),
    [anon_sym_UR_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3084),
    [anon_sym_co_await] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_requires] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
  },
  [462] = {
    [sym_identifier] = ACTIONS(3158),
    [aux_sym_preproc_include_token1] = ACTIONS(3158),
    [aux_sym_preproc_def_token1] = ACTIONS(3158),
    [aux_sym_preproc_if_token1] = ACTIONS(3158),
    [aux_sym_preproc_if_token2] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3158),
    [aux_sym_preproc_else_token1] = ACTIONS(3158),
    [aux_sym_preproc_elif_token1] = ACTIONS(3158),
    [sym_preproc_directive] = ACTIONS(3158),
    [anon_sym_LPAREN2] = ACTIONS(3160),
    [anon_sym_BANG] = ACTIONS(3160),
    [anon_sym_TILDE] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_STAR] = ACTIONS(3160),
    [anon_sym_AMP_AMP] = ACTIONS(3160),
    [anon_sym_AMP] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym___extension__] = ACTIONS(3158),
    [anon_sym_typedef] = ACTIONS(3158),
    [anon_sym_extern] = ACTIONS(3158),
    [anon_sym___attribute__] = ACTIONS(3158),
    [anon_sym_COLON_COLON] = ACTIONS(3160),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3160),
    [anon_sym___declspec] = ACTIONS(3158),
    [anon_sym___based] = ACTIONS(3158),
    [anon_sym___cdecl] = ACTIONS(3158),
    [anon_sym___clrcall] = ACTIONS(3158),
    [anon_sym___stdcall] = ACTIONS(3158),
    [anon_sym___fastcall] = ACTIONS(3158),
    [anon_sym___thiscall] = ACTIONS(3158),
    [anon_sym___vectorcall] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_signed] = ACTIONS(3158),
    [anon_sym_unsigned] = ACTIONS(3158),
    [anon_sym_long] = ACTIONS(3158),
    [anon_sym_short] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_static] = ACTIONS(3158),
    [anon_sym_register] = ACTIONS(3158),
    [anon_sym_inline] = ACTIONS(3158),
    [anon_sym___inline] = ACTIONS(3158),
    [anon_sym___inline__] = ACTIONS(3158),
    [anon_sym___forceinline] = ACTIONS(3158),
    [anon_sym_thread_local] = ACTIONS(3158),
    [anon_sym___thread] = ACTIONS(3158),
    [anon_sym_const] = ACTIONS(3158),
    [anon_sym_constexpr] = ACTIONS(3158),
    [anon_sym_volatile] = ACTIONS(3158),
    [anon_sym_restrict] = ACTIONS(3158),
    [anon_sym___restrict__] = ACTIONS(3158),
    [anon_sym__Atomic] = ACTIONS(3158),
    [anon_sym__Noreturn] = ACTIONS(3158),
    [anon_sym_noreturn] = ACTIONS(3158),
    [anon_sym_mutable] = ACTIONS(3158),
    [anon_sym_constinit] = ACTIONS(3158),
    [anon_sym_consteval] = ACTIONS(3158),
    [anon_sym_PROGMEM] = ACTIONS(3158),
    [aux_sym_primitive_type_token1] = ACTIONS(3158),
    [anon_sym_byte] = ACTIONS(3158),
    [anon_sym_word] = ACTIONS(3158),
    [anon_sym_enum] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(3158),
    [anon_sym_struct] = ACTIONS(3158),
    [anon_sym_union] = ACTIONS(3158),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_else] = ACTIONS(3158),
    [anon_sym_switch] = ACTIONS(3158),
    [anon_sym_case] = ACTIONS(3158),
    [anon_sym_default] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_for] = ACTIONS(3158),
    [anon_sym_return] = ACTIONS(3158),
    [anon_sym_break] = ACTIONS(3158),
    [anon_sym_continue] = ACTIONS(3158),
    [anon_sym_goto] = ACTIONS(3158),
    [anon_sym___try] = ACTIONS(3158),
    [anon_sym___leave] = ACTIONS(3158),
    [anon_sym_not] = ACTIONS(3158),
    [anon_sym_compl] = ACTIONS(3158),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_sizeof] = ACTIONS(3158),
    [anon_sym___alignof__] = ACTIONS(3158),
    [anon_sym___alignof] = ACTIONS(3158),
    [anon_sym__alignof] = ACTIONS(3158),
    [anon_sym_alignof] = ACTIONS(3158),
    [anon_sym__Alignof] = ACTIONS(3158),
    [anon_sym_offsetof] = ACTIONS(3158),
    [anon_sym__Generic] = ACTIONS(3158),
    [anon_sym_asm] = ACTIONS(3158),
    [anon_sym___asm__] = ACTIONS(3158),
    [aux_sym_number_literal_token1] = ACTIONS(3160),
    [aux_sym_number_literal_token2] = ACTIONS(3158),
    [anon_sym_L_SQUOTE] = ACTIONS(3160),
    [anon_sym_u_SQUOTE] = ACTIONS(3160),
    [anon_sym_U_SQUOTE] = ACTIONS(3160),
    [anon_sym_u8_SQUOTE] = ACTIONS(3160),
    [anon_sym_SQUOTE] = ACTIONS(3160),
    [anon_sym_L_DQUOTE] = ACTIONS(3160),
    [anon_sym_u_DQUOTE] = ACTIONS(3160),
    [anon_sym_U_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8_DQUOTE] = ACTIONS(3160),
    [anon_sym_DQUOTE] = ACTIONS(3160),
    [sym_true] = ACTIONS(3158),
    [sym_false] = ACTIONS(3158),
    [anon_sym_NULL] = ACTIONS(3158),
    [anon_sym_nullptr] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3158),
    [anon_sym_decltype] = ACTIONS(3158),
    [anon_sym_virtual] = ACTIONS(3158),
    [anon_sym_alignas] = ACTIONS(3158),
    [anon_sym_explicit] = ACTIONS(3158),
    [anon_sym_typename] = ACTIONS(3158),
    [anon_sym_template] = ACTIONS(3158),
    [anon_sym_operator] = ACTIONS(3158),
    [anon_sym_try] = ACTIONS(3158),
    [anon_sym_delete] = ACTIONS(3158),
    [anon_sym_throw] = ACTIONS(3158),
    [anon_sym_namespace] = ACTIONS(3158),
    [anon_sym_using] = ACTIONS(3158),
    [anon_sym_static_assert] = ACTIONS(3158),
    [anon_sym_concept] = ACTIONS(3158),
    [anon_sym_co_return] = ACTIONS(3158),
    [anon_sym_co_yield] = ACTIONS(3158),
    [anon_sym_R_DQUOTE] = ACTIONS(3160),
    [anon_sym_LR_DQUOTE] = ACTIONS(3160),
    [anon_sym_uR_DQUOTE] = ACTIONS(3160),
    [anon_sym_UR_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3160),
    [anon_sym_co_await] = ACTIONS(3158),
    [anon_sym_new] = ACTIONS(3158),
    [anon_sym_requires] = ACTIONS(3158),
    [sym_this] = ACTIONS(3158),
  },
  [463] = {
    [sym_identifier] = ACTIONS(3172),
    [aux_sym_preproc_include_token1] = ACTIONS(3172),
    [aux_sym_preproc_def_token1] = ACTIONS(3172),
    [aux_sym_preproc_if_token1] = ACTIONS(3172),
    [aux_sym_preproc_if_token2] = ACTIONS(3172),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3172),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3172),
    [aux_sym_preproc_else_token1] = ACTIONS(3172),
    [aux_sym_preproc_elif_token1] = ACTIONS(3172),
    [sym_preproc_directive] = ACTIONS(3172),
    [anon_sym_LPAREN2] = ACTIONS(3174),
    [anon_sym_BANG] = ACTIONS(3174),
    [anon_sym_TILDE] = ACTIONS(3174),
    [anon_sym_DASH] = ACTIONS(3172),
    [anon_sym_PLUS] = ACTIONS(3172),
    [anon_sym_STAR] = ACTIONS(3174),
    [anon_sym_AMP_AMP] = ACTIONS(3174),
    [anon_sym_AMP] = ACTIONS(3172),
    [anon_sym_SEMI] = ACTIONS(3174),
    [anon_sym___extension__] = ACTIONS(3172),
    [anon_sym_typedef] = ACTIONS(3172),
    [anon_sym_extern] = ACTIONS(3172),
    [anon_sym___attribute__] = ACTIONS(3172),
    [anon_sym_COLON_COLON] = ACTIONS(3174),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3174),
    [anon_sym___declspec] = ACTIONS(3172),
    [anon_sym___based] = ACTIONS(3172),
    [anon_sym___cdecl] = ACTIONS(3172),
    [anon_sym___clrcall] = ACTIONS(3172),
    [anon_sym___stdcall] = ACTIONS(3172),
    [anon_sym___fastcall] = ACTIONS(3172),
    [anon_sym___thiscall] = ACTIONS(3172),
    [anon_sym___vectorcall] = ACTIONS(3172),
    [anon_sym_LBRACE] = ACTIONS(3174),
    [anon_sym_signed] = ACTIONS(3172),
    [anon_sym_unsigned] = ACTIONS(3172),
    [anon_sym_long] = ACTIONS(3172),
    [anon_sym_short] = ACTIONS(3172),
    [anon_sym_LBRACK] = ACTIONS(3172),
    [anon_sym_static] = ACTIONS(3172),
    [anon_sym_register] = ACTIONS(3172),
    [anon_sym_inline] = ACTIONS(3172),
    [anon_sym___inline] = ACTIONS(3172),
    [anon_sym___inline__] = ACTIONS(3172),
    [anon_sym___forceinline] = ACTIONS(3172),
    [anon_sym_thread_local] = ACTIONS(3172),
    [anon_sym___thread] = ACTIONS(3172),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_constexpr] = ACTIONS(3172),
    [anon_sym_volatile] = ACTIONS(3172),
    [anon_sym_restrict] = ACTIONS(3172),
    [anon_sym___restrict__] = ACTIONS(3172),
    [anon_sym__Atomic] = ACTIONS(3172),
    [anon_sym__Noreturn] = ACTIONS(3172),
    [anon_sym_noreturn] = ACTIONS(3172),
    [anon_sym_mutable] = ACTIONS(3172),
    [anon_sym_constinit] = ACTIONS(3172),
    [anon_sym_consteval] = ACTIONS(3172),
    [anon_sym_PROGMEM] = ACTIONS(3172),
    [aux_sym_primitive_type_token1] = ACTIONS(3172),
    [anon_sym_byte] = ACTIONS(3172),
    [anon_sym_word] = ACTIONS(3172),
    [anon_sym_enum] = ACTIONS(3172),
    [anon_sym_class] = ACTIONS(3172),
    [anon_sym_struct] = ACTIONS(3172),
    [anon_sym_union] = ACTIONS(3172),
    [anon_sym_if] = ACTIONS(3172),
    [anon_sym_else] = ACTIONS(3172),
    [anon_sym_switch] = ACTIONS(3172),
    [anon_sym_case] = ACTIONS(3172),
    [anon_sym_default] = ACTIONS(3172),
    [anon_sym_while] = ACTIONS(3172),
    [anon_sym_do] = ACTIONS(3172),
    [anon_sym_for] = ACTIONS(3172),
    [anon_sym_return] = ACTIONS(3172),
    [anon_sym_break] = ACTIONS(3172),
    [anon_sym_continue] = ACTIONS(3172),
    [anon_sym_goto] = ACTIONS(3172),
    [anon_sym___try] = ACTIONS(3172),
    [anon_sym___leave] = ACTIONS(3172),
    [anon_sym_not] = ACTIONS(3172),
    [anon_sym_compl] = ACTIONS(3172),
    [anon_sym_DASH_DASH] = ACTIONS(3174),
    [anon_sym_PLUS_PLUS] = ACTIONS(3174),
    [anon_sym_sizeof] = ACTIONS(3172),
    [anon_sym___alignof__] = ACTIONS(3172),
    [anon_sym___alignof] = ACTIONS(3172),
    [anon_sym__alignof] = ACTIONS(3172),
    [anon_sym_alignof] = ACTIONS(3172),
    [anon_sym__Alignof] = ACTIONS(3172),
    [anon_sym_offsetof] = ACTIONS(3172),
    [anon_sym__Generic] = ACTIONS(3172),
    [anon_sym_asm] = ACTIONS(3172),
    [anon_sym___asm__] = ACTIONS(3172),
    [aux_sym_number_literal_token1] = ACTIONS(3174),
    [aux_sym_number_literal_token2] = ACTIONS(3172),
    [anon_sym_L_SQUOTE] = ACTIONS(3174),
    [anon_sym_u_SQUOTE] = ACTIONS(3174),
    [anon_sym_U_SQUOTE] = ACTIONS(3174),
    [anon_sym_u8_SQUOTE] = ACTIONS(3174),
    [anon_sym_SQUOTE] = ACTIONS(3174),
    [anon_sym_L_DQUOTE] = ACTIONS(3174),
    [anon_sym_u_DQUOTE] = ACTIONS(3174),
    [anon_sym_U_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8_DQUOTE] = ACTIONS(3174),
    [anon_sym_DQUOTE] = ACTIONS(3174),
    [sym_true] = ACTIONS(3172),
    [sym_false] = ACTIONS(3172),
    [anon_sym_NULL] = ACTIONS(3172),
    [anon_sym_nullptr] = ACTIONS(3172),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3172),
    [anon_sym_decltype] = ACTIONS(3172),
    [anon_sym_virtual] = ACTIONS(3172),
    [anon_sym_alignas] = ACTIONS(3172),
    [anon_sym_explicit] = ACTIONS(3172),
    [anon_sym_typename] = ACTIONS(3172),
    [anon_sym_template] = ACTIONS(3172),
    [anon_sym_operator] = ACTIONS(3172),
    [anon_sym_try] = ACTIONS(3172),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_throw] = ACTIONS(3172),
    [anon_sym_namespace] = ACTIONS(3172),
    [anon_sym_using] = ACTIONS(3172),
    [anon_sym_static_assert] = ACTIONS(3172),
    [anon_sym_concept] = ACTIONS(3172),
    [anon_sym_co_return] = ACTIONS(3172),
    [anon_sym_co_yield] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3172),
    [anon_sym_new] = ACTIONS(3172),
    [anon_sym_requires] = ACTIONS(3172),
    [sym_this] = ACTIONS(3172),
  },
  [464] = {
    [sym_identifier] = ACTIONS(3168),
    [aux_sym_preproc_include_token1] = ACTIONS(3168),
    [aux_sym_preproc_def_token1] = ACTIONS(3168),
    [aux_sym_preproc_if_token1] = ACTIONS(3168),
    [aux_sym_preproc_if_token2] = ACTIONS(3168),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3168),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3168),
    [aux_sym_preproc_else_token1] = ACTIONS(3168),
    [aux_sym_preproc_elif_token1] = ACTIONS(3168),
    [sym_preproc_directive] = ACTIONS(3168),
    [anon_sym_LPAREN2] = ACTIONS(3170),
    [anon_sym_BANG] = ACTIONS(3170),
    [anon_sym_TILDE] = ACTIONS(3170),
    [anon_sym_DASH] = ACTIONS(3168),
    [anon_sym_PLUS] = ACTIONS(3168),
    [anon_sym_STAR] = ACTIONS(3170),
    [anon_sym_AMP_AMP] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3168),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym___extension__] = ACTIONS(3168),
    [anon_sym_typedef] = ACTIONS(3168),
    [anon_sym_extern] = ACTIONS(3168),
    [anon_sym___attribute__] = ACTIONS(3168),
    [anon_sym_COLON_COLON] = ACTIONS(3170),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3170),
    [anon_sym___declspec] = ACTIONS(3168),
    [anon_sym___based] = ACTIONS(3168),
    [anon_sym___cdecl] = ACTIONS(3168),
    [anon_sym___clrcall] = ACTIONS(3168),
    [anon_sym___stdcall] = ACTIONS(3168),
    [anon_sym___fastcall] = ACTIONS(3168),
    [anon_sym___thiscall] = ACTIONS(3168),
    [anon_sym___vectorcall] = ACTIONS(3168),
    [anon_sym_LBRACE] = ACTIONS(3170),
    [anon_sym_signed] = ACTIONS(3168),
    [anon_sym_unsigned] = ACTIONS(3168),
    [anon_sym_long] = ACTIONS(3168),
    [anon_sym_short] = ACTIONS(3168),
    [anon_sym_LBRACK] = ACTIONS(3168),
    [anon_sym_static] = ACTIONS(3168),
    [anon_sym_register] = ACTIONS(3168),
    [anon_sym_inline] = ACTIONS(3168),
    [anon_sym___inline] = ACTIONS(3168),
    [anon_sym___inline__] = ACTIONS(3168),
    [anon_sym___forceinline] = ACTIONS(3168),
    [anon_sym_thread_local] = ACTIONS(3168),
    [anon_sym___thread] = ACTIONS(3168),
    [anon_sym_const] = ACTIONS(3168),
    [anon_sym_constexpr] = ACTIONS(3168),
    [anon_sym_volatile] = ACTIONS(3168),
    [anon_sym_restrict] = ACTIONS(3168),
    [anon_sym___restrict__] = ACTIONS(3168),
    [anon_sym__Atomic] = ACTIONS(3168),
    [anon_sym__Noreturn] = ACTIONS(3168),
    [anon_sym_noreturn] = ACTIONS(3168),
    [anon_sym_mutable] = ACTIONS(3168),
    [anon_sym_constinit] = ACTIONS(3168),
    [anon_sym_consteval] = ACTIONS(3168),
    [anon_sym_PROGMEM] = ACTIONS(3168),
    [aux_sym_primitive_type_token1] = ACTIONS(3168),
    [anon_sym_byte] = ACTIONS(3168),
    [anon_sym_word] = ACTIONS(3168),
    [anon_sym_enum] = ACTIONS(3168),
    [anon_sym_class] = ACTIONS(3168),
    [anon_sym_struct] = ACTIONS(3168),
    [anon_sym_union] = ACTIONS(3168),
    [anon_sym_if] = ACTIONS(3168),
    [anon_sym_else] = ACTIONS(3168),
    [anon_sym_switch] = ACTIONS(3168),
    [anon_sym_case] = ACTIONS(3168),
    [anon_sym_default] = ACTIONS(3168),
    [anon_sym_while] = ACTIONS(3168),
    [anon_sym_do] = ACTIONS(3168),
    [anon_sym_for] = ACTIONS(3168),
    [anon_sym_return] = ACTIONS(3168),
    [anon_sym_break] = ACTIONS(3168),
    [anon_sym_continue] = ACTIONS(3168),
    [anon_sym_goto] = ACTIONS(3168),
    [anon_sym___try] = ACTIONS(3168),
    [anon_sym___leave] = ACTIONS(3168),
    [anon_sym_not] = ACTIONS(3168),
    [anon_sym_compl] = ACTIONS(3168),
    [anon_sym_DASH_DASH] = ACTIONS(3170),
    [anon_sym_PLUS_PLUS] = ACTIONS(3170),
    [anon_sym_sizeof] = ACTIONS(3168),
    [anon_sym___alignof__] = ACTIONS(3168),
    [anon_sym___alignof] = ACTIONS(3168),
    [anon_sym__alignof] = ACTIONS(3168),
    [anon_sym_alignof] = ACTIONS(3168),
    [anon_sym__Alignof] = ACTIONS(3168),
    [anon_sym_offsetof] = ACTIONS(3168),
    [anon_sym__Generic] = ACTIONS(3168),
    [anon_sym_asm] = ACTIONS(3168),
    [anon_sym___asm__] = ACTIONS(3168),
    [aux_sym_number_literal_token1] = ACTIONS(3170),
    [aux_sym_number_literal_token2] = ACTIONS(3168),
    [anon_sym_L_SQUOTE] = ACTIONS(3170),
    [anon_sym_u_SQUOTE] = ACTIONS(3170),
    [anon_sym_U_SQUOTE] = ACTIONS(3170),
    [anon_sym_u8_SQUOTE] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3170),
    [anon_sym_L_DQUOTE] = ACTIONS(3170),
    [anon_sym_u_DQUOTE] = ACTIONS(3170),
    [anon_sym_U_DQUOTE] = ACTIONS(3170),
    [anon_sym_u8_DQUOTE] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3170),
    [sym_true] = ACTIONS(3168),
    [sym_false] = ACTIONS(3168),
    [anon_sym_NULL] = ACTIONS(3168),
    [anon_sym_nullptr] = ACTIONS(3168),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3168),
    [anon_sym_decltype] = ACTIONS(3168),
    [anon_sym_virtual] = ACTIONS(3168),
    [anon_sym_alignas] = ACTIONS(3168),
    [anon_sym_explicit] = ACTIONS(3168),
    [anon_sym_typename] = ACTIONS(3168),
    [anon_sym_template] = ACTIONS(3168),
    [anon_sym_operator] = ACTIONS(3168),
    [anon_sym_try] = ACTIONS(3168),
    [anon_sym_delete] = ACTIONS(3168),
    [anon_sym_throw] = ACTIONS(3168),
    [anon_sym_namespace] = ACTIONS(3168),
    [anon_sym_using] = ACTIONS(3168),
    [anon_sym_static_assert] = ACTIONS(3168),
    [anon_sym_concept] = ACTIONS(3168),
    [anon_sym_co_return] = ACTIONS(3168),
    [anon_sym_co_yield] = ACTIONS(3168),
    [anon_sym_R_DQUOTE] = ACTIONS(3170),
    [anon_sym_LR_DQUOTE] = ACTIONS(3170),
    [anon_sym_uR_DQUOTE] = ACTIONS(3170),
    [anon_sym_UR_DQUOTE] = ACTIONS(3170),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3170),
    [anon_sym_co_await] = ACTIONS(3168),
    [anon_sym_new] = ACTIONS(3168),
    [anon_sym_requires] = ACTIONS(3168),
    [sym_this] = ACTIONS(3168),
  },
  [465] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [466] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [467] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [468] = {
    [sym_identifier] = ACTIONS(3154),
    [aux_sym_preproc_include_token1] = ACTIONS(3154),
    [aux_sym_preproc_def_token1] = ACTIONS(3154),
    [aux_sym_preproc_if_token1] = ACTIONS(3154),
    [aux_sym_preproc_if_token2] = ACTIONS(3154),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3154),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3154),
    [aux_sym_preproc_else_token1] = ACTIONS(3154),
    [aux_sym_preproc_elif_token1] = ACTIONS(3154),
    [sym_preproc_directive] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3156),
    [anon_sym_BANG] = ACTIONS(3156),
    [anon_sym_TILDE] = ACTIONS(3156),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_STAR] = ACTIONS(3156),
    [anon_sym_AMP_AMP] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3154),
    [anon_sym_SEMI] = ACTIONS(3156),
    [anon_sym___extension__] = ACTIONS(3154),
    [anon_sym_typedef] = ACTIONS(3154),
    [anon_sym_extern] = ACTIONS(3154),
    [anon_sym___attribute__] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3156),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3156),
    [anon_sym___declspec] = ACTIONS(3154),
    [anon_sym___based] = ACTIONS(3154),
    [anon_sym___cdecl] = ACTIONS(3154),
    [anon_sym___clrcall] = ACTIONS(3154),
    [anon_sym___stdcall] = ACTIONS(3154),
    [anon_sym___fastcall] = ACTIONS(3154),
    [anon_sym___thiscall] = ACTIONS(3154),
    [anon_sym___vectorcall] = ACTIONS(3154),
    [anon_sym_LBRACE] = ACTIONS(3156),
    [anon_sym_signed] = ACTIONS(3154),
    [anon_sym_unsigned] = ACTIONS(3154),
    [anon_sym_long] = ACTIONS(3154),
    [anon_sym_short] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_static] = ACTIONS(3154),
    [anon_sym_register] = ACTIONS(3154),
    [anon_sym_inline] = ACTIONS(3154),
    [anon_sym___inline] = ACTIONS(3154),
    [anon_sym___inline__] = ACTIONS(3154),
    [anon_sym___forceinline] = ACTIONS(3154),
    [anon_sym_thread_local] = ACTIONS(3154),
    [anon_sym___thread] = ACTIONS(3154),
    [anon_sym_const] = ACTIONS(3154),
    [anon_sym_constexpr] = ACTIONS(3154),
    [anon_sym_volatile] = ACTIONS(3154),
    [anon_sym_restrict] = ACTIONS(3154),
    [anon_sym___restrict__] = ACTIONS(3154),
    [anon_sym__Atomic] = ACTIONS(3154),
    [anon_sym__Noreturn] = ACTIONS(3154),
    [anon_sym_noreturn] = ACTIONS(3154),
    [anon_sym_mutable] = ACTIONS(3154),
    [anon_sym_constinit] = ACTIONS(3154),
    [anon_sym_consteval] = ACTIONS(3154),
    [anon_sym_PROGMEM] = ACTIONS(3154),
    [aux_sym_primitive_type_token1] = ACTIONS(3154),
    [anon_sym_byte] = ACTIONS(3154),
    [anon_sym_word] = ACTIONS(3154),
    [anon_sym_enum] = ACTIONS(3154),
    [anon_sym_class] = ACTIONS(3154),
    [anon_sym_struct] = ACTIONS(3154),
    [anon_sym_union] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_else] = ACTIONS(3154),
    [anon_sym_switch] = ACTIONS(3154),
    [anon_sym_case] = ACTIONS(3154),
    [anon_sym_default] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_break] = ACTIONS(3154),
    [anon_sym_continue] = ACTIONS(3154),
    [anon_sym_goto] = ACTIONS(3154),
    [anon_sym___try] = ACTIONS(3154),
    [anon_sym___leave] = ACTIONS(3154),
    [anon_sym_not] = ACTIONS(3154),
    [anon_sym_compl] = ACTIONS(3154),
    [anon_sym_DASH_DASH] = ACTIONS(3156),
    [anon_sym_PLUS_PLUS] = ACTIONS(3156),
    [anon_sym_sizeof] = ACTIONS(3154),
    [anon_sym___alignof__] = ACTIONS(3154),
    [anon_sym___alignof] = ACTIONS(3154),
    [anon_sym__alignof] = ACTIONS(3154),
    [anon_sym_alignof] = ACTIONS(3154),
    [anon_sym__Alignof] = ACTIONS(3154),
    [anon_sym_offsetof] = ACTIONS(3154),
    [anon_sym__Generic] = ACTIONS(3154),
    [anon_sym_asm] = ACTIONS(3154),
    [anon_sym___asm__] = ACTIONS(3154),
    [aux_sym_number_literal_token1] = ACTIONS(3156),
    [aux_sym_number_literal_token2] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3156),
    [anon_sym_u_DQUOTE] = ACTIONS(3156),
    [anon_sym_U_DQUOTE] = ACTIONS(3156),
    [anon_sym_u8_DQUOTE] = ACTIONS(3156),
    [anon_sym_DQUOTE] = ACTIONS(3156),
    [sym_true] = ACTIONS(3154),
    [sym_false] = ACTIONS(3154),
    [anon_sym_NULL] = ACTIONS(3154),
    [anon_sym_nullptr] = ACTIONS(3154),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3154),
    [anon_sym_decltype] = ACTIONS(3154),
    [anon_sym_virtual] = ACTIONS(3154),
    [anon_sym_alignas] = ACTIONS(3154),
    [anon_sym_explicit] = ACTIONS(3154),
    [anon_sym_typename] = ACTIONS(3154),
    [anon_sym_template] = ACTIONS(3154),
    [anon_sym_operator] = ACTIONS(3154),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_delete] = ACTIONS(3154),
    [anon_sym_throw] = ACTIONS(3154),
    [anon_sym_namespace] = ACTIONS(3154),
    [anon_sym_using] = ACTIONS(3154),
    [anon_sym_static_assert] = ACTIONS(3154),
    [anon_sym_concept] = ACTIONS(3154),
    [anon_sym_co_return] = ACTIONS(3154),
    [anon_sym_co_yield] = ACTIONS(3154),
    [anon_sym_R_DQUOTE] = ACTIONS(3156),
    [anon_sym_LR_DQUOTE] = ACTIONS(3156),
    [anon_sym_uR_DQUOTE] = ACTIONS(3156),
    [anon_sym_UR_DQUOTE] = ACTIONS(3156),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3156),
    [anon_sym_co_await] = ACTIONS(3154),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_requires] = ACTIONS(3154),
    [sym_this] = ACTIONS(3154),
  },
  [469] = {
    [sym_identifier] = ACTIONS(3124),
    [aux_sym_preproc_include_token1] = ACTIONS(3124),
    [aux_sym_preproc_def_token1] = ACTIONS(3124),
    [aux_sym_preproc_if_token1] = ACTIONS(3124),
    [aux_sym_preproc_if_token2] = ACTIONS(3124),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3124),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3124),
    [aux_sym_preproc_else_token1] = ACTIONS(3124),
    [aux_sym_preproc_elif_token1] = ACTIONS(3124),
    [sym_preproc_directive] = ACTIONS(3124),
    [anon_sym_LPAREN2] = ACTIONS(3126),
    [anon_sym_BANG] = ACTIONS(3126),
    [anon_sym_TILDE] = ACTIONS(3126),
    [anon_sym_DASH] = ACTIONS(3124),
    [anon_sym_PLUS] = ACTIONS(3124),
    [anon_sym_STAR] = ACTIONS(3126),
    [anon_sym_AMP_AMP] = ACTIONS(3126),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym_SEMI] = ACTIONS(3126),
    [anon_sym___extension__] = ACTIONS(3124),
    [anon_sym_typedef] = ACTIONS(3124),
    [anon_sym_extern] = ACTIONS(3124),
    [anon_sym___attribute__] = ACTIONS(3124),
    [anon_sym_COLON_COLON] = ACTIONS(3126),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3126),
    [anon_sym___declspec] = ACTIONS(3124),
    [anon_sym___based] = ACTIONS(3124),
    [anon_sym___cdecl] = ACTIONS(3124),
    [anon_sym___clrcall] = ACTIONS(3124),
    [anon_sym___stdcall] = ACTIONS(3124),
    [anon_sym___fastcall] = ACTIONS(3124),
    [anon_sym___thiscall] = ACTIONS(3124),
    [anon_sym___vectorcall] = ACTIONS(3124),
    [anon_sym_LBRACE] = ACTIONS(3126),
    [anon_sym_signed] = ACTIONS(3124),
    [anon_sym_unsigned] = ACTIONS(3124),
    [anon_sym_long] = ACTIONS(3124),
    [anon_sym_short] = ACTIONS(3124),
    [anon_sym_LBRACK] = ACTIONS(3124),
    [anon_sym_static] = ACTIONS(3124),
    [anon_sym_register] = ACTIONS(3124),
    [anon_sym_inline] = ACTIONS(3124),
    [anon_sym___inline] = ACTIONS(3124),
    [anon_sym___inline__] = ACTIONS(3124),
    [anon_sym___forceinline] = ACTIONS(3124),
    [anon_sym_thread_local] = ACTIONS(3124),
    [anon_sym___thread] = ACTIONS(3124),
    [anon_sym_const] = ACTIONS(3124),
    [anon_sym_constexpr] = ACTIONS(3124),
    [anon_sym_volatile] = ACTIONS(3124),
    [anon_sym_restrict] = ACTIONS(3124),
    [anon_sym___restrict__] = ACTIONS(3124),
    [anon_sym__Atomic] = ACTIONS(3124),
    [anon_sym__Noreturn] = ACTIONS(3124),
    [anon_sym_noreturn] = ACTIONS(3124),
    [anon_sym_mutable] = ACTIONS(3124),
    [anon_sym_constinit] = ACTIONS(3124),
    [anon_sym_consteval] = ACTIONS(3124),
    [anon_sym_PROGMEM] = ACTIONS(3124),
    [aux_sym_primitive_type_token1] = ACTIONS(3124),
    [anon_sym_byte] = ACTIONS(3124),
    [anon_sym_word] = ACTIONS(3124),
    [anon_sym_enum] = ACTIONS(3124),
    [anon_sym_class] = ACTIONS(3124),
    [anon_sym_struct] = ACTIONS(3124),
    [anon_sym_union] = ACTIONS(3124),
    [anon_sym_if] = ACTIONS(3124),
    [anon_sym_else] = ACTIONS(3124),
    [anon_sym_switch] = ACTIONS(3124),
    [anon_sym_case] = ACTIONS(3124),
    [anon_sym_default] = ACTIONS(3124),
    [anon_sym_while] = ACTIONS(3124),
    [anon_sym_do] = ACTIONS(3124),
    [anon_sym_for] = ACTIONS(3124),
    [anon_sym_return] = ACTIONS(3124),
    [anon_sym_break] = ACTIONS(3124),
    [anon_sym_continue] = ACTIONS(3124),
    [anon_sym_goto] = ACTIONS(3124),
    [anon_sym___try] = ACTIONS(3124),
    [anon_sym___leave] = ACTIONS(3124),
    [anon_sym_not] = ACTIONS(3124),
    [anon_sym_compl] = ACTIONS(3124),
    [anon_sym_DASH_DASH] = ACTIONS(3126),
    [anon_sym_PLUS_PLUS] = ACTIONS(3126),
    [anon_sym_sizeof] = ACTIONS(3124),
    [anon_sym___alignof__] = ACTIONS(3124),
    [anon_sym___alignof] = ACTIONS(3124),
    [anon_sym__alignof] = ACTIONS(3124),
    [anon_sym_alignof] = ACTIONS(3124),
    [anon_sym__Alignof] = ACTIONS(3124),
    [anon_sym_offsetof] = ACTIONS(3124),
    [anon_sym__Generic] = ACTIONS(3124),
    [anon_sym_asm] = ACTIONS(3124),
    [anon_sym___asm__] = ACTIONS(3124),
    [aux_sym_number_literal_token1] = ACTIONS(3126),
    [aux_sym_number_literal_token2] = ACTIONS(3124),
    [anon_sym_L_SQUOTE] = ACTIONS(3126),
    [anon_sym_u_SQUOTE] = ACTIONS(3126),
    [anon_sym_U_SQUOTE] = ACTIONS(3126),
    [anon_sym_u8_SQUOTE] = ACTIONS(3126),
    [anon_sym_SQUOTE] = ACTIONS(3126),
    [anon_sym_L_DQUOTE] = ACTIONS(3126),
    [anon_sym_u_DQUOTE] = ACTIONS(3126),
    [anon_sym_U_DQUOTE] = ACTIONS(3126),
    [anon_sym_u8_DQUOTE] = ACTIONS(3126),
    [anon_sym_DQUOTE] = ACTIONS(3126),
    [sym_true] = ACTIONS(3124),
    [sym_false] = ACTIONS(3124),
    [anon_sym_NULL] = ACTIONS(3124),
    [anon_sym_nullptr] = ACTIONS(3124),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3124),
    [anon_sym_decltype] = ACTIONS(3124),
    [anon_sym_virtual] = ACTIONS(3124),
    [anon_sym_alignas] = ACTIONS(3124),
    [anon_sym_explicit] = ACTIONS(3124),
    [anon_sym_typename] = ACTIONS(3124),
    [anon_sym_template] = ACTIONS(3124),
    [anon_sym_operator] = ACTIONS(3124),
    [anon_sym_try] = ACTIONS(3124),
    [anon_sym_delete] = ACTIONS(3124),
    [anon_sym_throw] = ACTIONS(3124),
    [anon_sym_namespace] = ACTIONS(3124),
    [anon_sym_using] = ACTIONS(3124),
    [anon_sym_static_assert] = ACTIONS(3124),
    [anon_sym_concept] = ACTIONS(3124),
    [anon_sym_co_return] = ACTIONS(3124),
    [anon_sym_co_yield] = ACTIONS(3124),
    [anon_sym_R_DQUOTE] = ACTIONS(3126),
    [anon_sym_LR_DQUOTE] = ACTIONS(3126),
    [anon_sym_uR_DQUOTE] = ACTIONS(3126),
    [anon_sym_UR_DQUOTE] = ACTIONS(3126),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3126),
    [anon_sym_co_await] = ACTIONS(3124),
    [anon_sym_new] = ACTIONS(3124),
    [anon_sym_requires] = ACTIONS(3124),
    [sym_this] = ACTIONS(3124),
  },
  [470] = {
    [sym_identifier] = ACTIONS(2927),
    [aux_sym_preproc_include_token1] = ACTIONS(2927),
    [aux_sym_preproc_def_token1] = ACTIONS(2927),
    [aux_sym_preproc_if_token1] = ACTIONS(2927),
    [aux_sym_preproc_if_token2] = ACTIONS(2927),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2927),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2927),
    [aux_sym_preproc_else_token1] = ACTIONS(2927),
    [aux_sym_preproc_elif_token1] = ACTIONS(2927),
    [sym_preproc_directive] = ACTIONS(2927),
    [anon_sym_LPAREN2] = ACTIONS(2932),
    [anon_sym_BANG] = ACTIONS(2932),
    [anon_sym_TILDE] = ACTIONS(2932),
    [anon_sym_DASH] = ACTIONS(2927),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2932),
    [anon_sym_AMP_AMP] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2927),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym___extension__] = ACTIONS(2927),
    [anon_sym_typedef] = ACTIONS(2927),
    [anon_sym_extern] = ACTIONS(2927),
    [anon_sym___attribute__] = ACTIONS(2927),
    [anon_sym_COLON_COLON] = ACTIONS(2932),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2932),
    [anon_sym___declspec] = ACTIONS(2927),
    [anon_sym___based] = ACTIONS(2927),
    [anon_sym___cdecl] = ACTIONS(2927),
    [anon_sym___clrcall] = ACTIONS(2927),
    [anon_sym___stdcall] = ACTIONS(2927),
    [anon_sym___fastcall] = ACTIONS(2927),
    [anon_sym___thiscall] = ACTIONS(2927),
    [anon_sym___vectorcall] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2932),
    [anon_sym_signed] = ACTIONS(2927),
    [anon_sym_unsigned] = ACTIONS(2927),
    [anon_sym_long] = ACTIONS(2927),
    [anon_sym_short] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_static] = ACTIONS(2927),
    [anon_sym_register] = ACTIONS(2927),
    [anon_sym_inline] = ACTIONS(2927),
    [anon_sym___inline] = ACTIONS(2927),
    [anon_sym___inline__] = ACTIONS(2927),
    [anon_sym___forceinline] = ACTIONS(2927),
    [anon_sym_thread_local] = ACTIONS(2927),
    [anon_sym___thread] = ACTIONS(2927),
    [anon_sym_const] = ACTIONS(2927),
    [anon_sym_constexpr] = ACTIONS(2927),
    [anon_sym_volatile] = ACTIONS(2927),
    [anon_sym_restrict] = ACTIONS(2927),
    [anon_sym___restrict__] = ACTIONS(2927),
    [anon_sym__Atomic] = ACTIONS(2927),
    [anon_sym__Noreturn] = ACTIONS(2927),
    [anon_sym_noreturn] = ACTIONS(2927),
    [anon_sym_mutable] = ACTIONS(2927),
    [anon_sym_constinit] = ACTIONS(2927),
    [anon_sym_consteval] = ACTIONS(2927),
    [anon_sym_PROGMEM] = ACTIONS(2927),
    [aux_sym_primitive_type_token1] = ACTIONS(2927),
    [anon_sym_byte] = ACTIONS(2927),
    [anon_sym_word] = ACTIONS(2927),
    [anon_sym_enum] = ACTIONS(2927),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_struct] = ACTIONS(2927),
    [anon_sym_union] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_else] = ACTIONS(2927),
    [anon_sym_switch] = ACTIONS(2927),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_default] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_goto] = ACTIONS(2927),
    [anon_sym___try] = ACTIONS(2927),
    [anon_sym___leave] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2927),
    [anon_sym_compl] = ACTIONS(2927),
    [anon_sym_DASH_DASH] = ACTIONS(2932),
    [anon_sym_PLUS_PLUS] = ACTIONS(2932),
    [anon_sym_sizeof] = ACTIONS(2927),
    [anon_sym___alignof__] = ACTIONS(2927),
    [anon_sym___alignof] = ACTIONS(2927),
    [anon_sym__alignof] = ACTIONS(2927),
    [anon_sym_alignof] = ACTIONS(2927),
    [anon_sym__Alignof] = ACTIONS(2927),
    [anon_sym_offsetof] = ACTIONS(2927),
    [anon_sym__Generic] = ACTIONS(2927),
    [anon_sym_asm] = ACTIONS(2927),
    [anon_sym___asm__] = ACTIONS(2927),
    [aux_sym_number_literal_token1] = ACTIONS(2932),
    [aux_sym_number_literal_token2] = ACTIONS(2927),
    [anon_sym_L_SQUOTE] = ACTIONS(2932),
    [anon_sym_u_SQUOTE] = ACTIONS(2932),
    [anon_sym_U_SQUOTE] = ACTIONS(2932),
    [anon_sym_u8_SQUOTE] = ACTIONS(2932),
    [anon_sym_SQUOTE] = ACTIONS(2932),
    [anon_sym_L_DQUOTE] = ACTIONS(2932),
    [anon_sym_u_DQUOTE] = ACTIONS(2932),
    [anon_sym_U_DQUOTE] = ACTIONS(2932),
    [anon_sym_u8_DQUOTE] = ACTIONS(2932),
    [anon_sym_DQUOTE] = ACTIONS(2932),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [anon_sym_NULL] = ACTIONS(2927),
    [anon_sym_nullptr] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2927),
    [anon_sym_decltype] = ACTIONS(2927),
    [anon_sym_virtual] = ACTIONS(2927),
    [anon_sym_alignas] = ACTIONS(2927),
    [anon_sym_explicit] = ACTIONS(2927),
    [anon_sym_typename] = ACTIONS(2927),
    [anon_sym_template] = ACTIONS(2927),
    [anon_sym_operator] = ACTIONS(2927),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_throw] = ACTIONS(2927),
    [anon_sym_namespace] = ACTIONS(2927),
    [anon_sym_using] = ACTIONS(2927),
    [anon_sym_static_assert] = ACTIONS(2927),
    [anon_sym_concept] = ACTIONS(2927),
    [anon_sym_co_return] = ACTIONS(2927),
    [anon_sym_co_yield] = ACTIONS(2927),
    [anon_sym_R_DQUOTE] = ACTIONS(2932),
    [anon_sym_LR_DQUOTE] = ACTIONS(2932),
    [anon_sym_uR_DQUOTE] = ACTIONS(2932),
    [anon_sym_UR_DQUOTE] = ACTIONS(2932),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2932),
    [anon_sym_co_await] = ACTIONS(2927),
    [anon_sym_new] = ACTIONS(2927),
    [anon_sym_requires] = ACTIONS(2927),
    [sym_this] = ACTIONS(2927),
  },
  [471] = {
    [sym_identifier] = ACTIONS(3096),
    [aux_sym_preproc_include_token1] = ACTIONS(3096),
    [aux_sym_preproc_def_token1] = ACTIONS(3096),
    [aux_sym_preproc_if_token1] = ACTIONS(3096),
    [aux_sym_preproc_if_token2] = ACTIONS(3096),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3096),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3096),
    [aux_sym_preproc_else_token1] = ACTIONS(3096),
    [aux_sym_preproc_elif_token1] = ACTIONS(3096),
    [sym_preproc_directive] = ACTIONS(3096),
    [anon_sym_LPAREN2] = ACTIONS(3098),
    [anon_sym_BANG] = ACTIONS(3098),
    [anon_sym_TILDE] = ACTIONS(3098),
    [anon_sym_DASH] = ACTIONS(3096),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_STAR] = ACTIONS(3098),
    [anon_sym_AMP_AMP] = ACTIONS(3098),
    [anon_sym_AMP] = ACTIONS(3096),
    [anon_sym_SEMI] = ACTIONS(3098),
    [anon_sym___extension__] = ACTIONS(3096),
    [anon_sym_typedef] = ACTIONS(3096),
    [anon_sym_extern] = ACTIONS(3096),
    [anon_sym___attribute__] = ACTIONS(3096),
    [anon_sym_COLON_COLON] = ACTIONS(3098),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3098),
    [anon_sym___declspec] = ACTIONS(3096),
    [anon_sym___based] = ACTIONS(3096),
    [anon_sym___cdecl] = ACTIONS(3096),
    [anon_sym___clrcall] = ACTIONS(3096),
    [anon_sym___stdcall] = ACTIONS(3096),
    [anon_sym___fastcall] = ACTIONS(3096),
    [anon_sym___thiscall] = ACTIONS(3096),
    [anon_sym___vectorcall] = ACTIONS(3096),
    [anon_sym_LBRACE] = ACTIONS(3098),
    [anon_sym_signed] = ACTIONS(3096),
    [anon_sym_unsigned] = ACTIONS(3096),
    [anon_sym_long] = ACTIONS(3096),
    [anon_sym_short] = ACTIONS(3096),
    [anon_sym_LBRACK] = ACTIONS(3096),
    [anon_sym_static] = ACTIONS(3096),
    [anon_sym_register] = ACTIONS(3096),
    [anon_sym_inline] = ACTIONS(3096),
    [anon_sym___inline] = ACTIONS(3096),
    [anon_sym___inline__] = ACTIONS(3096),
    [anon_sym___forceinline] = ACTIONS(3096),
    [anon_sym_thread_local] = ACTIONS(3096),
    [anon_sym___thread] = ACTIONS(3096),
    [anon_sym_const] = ACTIONS(3096),
    [anon_sym_constexpr] = ACTIONS(3096),
    [anon_sym_volatile] = ACTIONS(3096),
    [anon_sym_restrict] = ACTIONS(3096),
    [anon_sym___restrict__] = ACTIONS(3096),
    [anon_sym__Atomic] = ACTIONS(3096),
    [anon_sym__Noreturn] = ACTIONS(3096),
    [anon_sym_noreturn] = ACTIONS(3096),
    [anon_sym_mutable] = ACTIONS(3096),
    [anon_sym_constinit] = ACTIONS(3096),
    [anon_sym_consteval] = ACTIONS(3096),
    [anon_sym_PROGMEM] = ACTIONS(3096),
    [aux_sym_primitive_type_token1] = ACTIONS(3096),
    [anon_sym_byte] = ACTIONS(3096),
    [anon_sym_word] = ACTIONS(3096),
    [anon_sym_enum] = ACTIONS(3096),
    [anon_sym_class] = ACTIONS(3096),
    [anon_sym_struct] = ACTIONS(3096),
    [anon_sym_union] = ACTIONS(3096),
    [anon_sym_if] = ACTIONS(3096),
    [anon_sym_else] = ACTIONS(3096),
    [anon_sym_switch] = ACTIONS(3096),
    [anon_sym_case] = ACTIONS(3096),
    [anon_sym_default] = ACTIONS(3096),
    [anon_sym_while] = ACTIONS(3096),
    [anon_sym_do] = ACTIONS(3096),
    [anon_sym_for] = ACTIONS(3096),
    [anon_sym_return] = ACTIONS(3096),
    [anon_sym_break] = ACTIONS(3096),
    [anon_sym_continue] = ACTIONS(3096),
    [anon_sym_goto] = ACTIONS(3096),
    [anon_sym___try] = ACTIONS(3096),
    [anon_sym___leave] = ACTIONS(3096),
    [anon_sym_not] = ACTIONS(3096),
    [anon_sym_compl] = ACTIONS(3096),
    [anon_sym_DASH_DASH] = ACTIONS(3098),
    [anon_sym_PLUS_PLUS] = ACTIONS(3098),
    [anon_sym_sizeof] = ACTIONS(3096),
    [anon_sym___alignof__] = ACTIONS(3096),
    [anon_sym___alignof] = ACTIONS(3096),
    [anon_sym__alignof] = ACTIONS(3096),
    [anon_sym_alignof] = ACTIONS(3096),
    [anon_sym__Alignof] = ACTIONS(3096),
    [anon_sym_offsetof] = ACTIONS(3096),
    [anon_sym__Generic] = ACTIONS(3096),
    [anon_sym_asm] = ACTIONS(3096),
    [anon_sym___asm__] = ACTIONS(3096),
    [aux_sym_number_literal_token1] = ACTIONS(3098),
    [aux_sym_number_literal_token2] = ACTIONS(3096),
    [anon_sym_L_SQUOTE] = ACTIONS(3098),
    [anon_sym_u_SQUOTE] = ACTIONS(3098),
    [anon_sym_U_SQUOTE] = ACTIONS(3098),
    [anon_sym_u8_SQUOTE] = ACTIONS(3098),
    [anon_sym_SQUOTE] = ACTIONS(3098),
    [anon_sym_L_DQUOTE] = ACTIONS(3098),
    [anon_sym_u_DQUOTE] = ACTIONS(3098),
    [anon_sym_U_DQUOTE] = ACTIONS(3098),
    [anon_sym_u8_DQUOTE] = ACTIONS(3098),
    [anon_sym_DQUOTE] = ACTIONS(3098),
    [sym_true] = ACTIONS(3096),
    [sym_false] = ACTIONS(3096),
    [anon_sym_NULL] = ACTIONS(3096),
    [anon_sym_nullptr] = ACTIONS(3096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3096),
    [anon_sym_decltype] = ACTIONS(3096),
    [anon_sym_virtual] = ACTIONS(3096),
    [anon_sym_alignas] = ACTIONS(3096),
    [anon_sym_explicit] = ACTIONS(3096),
    [anon_sym_typename] = ACTIONS(3096),
    [anon_sym_template] = ACTIONS(3096),
    [anon_sym_operator] = ACTIONS(3096),
    [anon_sym_try] = ACTIONS(3096),
    [anon_sym_delete] = ACTIONS(3096),
    [anon_sym_throw] = ACTIONS(3096),
    [anon_sym_namespace] = ACTIONS(3096),
    [anon_sym_using] = ACTIONS(3096),
    [anon_sym_static_assert] = ACTIONS(3096),
    [anon_sym_concept] = ACTIONS(3096),
    [anon_sym_co_return] = ACTIONS(3096),
    [anon_sym_co_yield] = ACTIONS(3096),
    [anon_sym_R_DQUOTE] = ACTIONS(3098),
    [anon_sym_LR_DQUOTE] = ACTIONS(3098),
    [anon_sym_uR_DQUOTE] = ACTIONS(3098),
    [anon_sym_UR_DQUOTE] = ACTIONS(3098),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3098),
    [anon_sym_co_await] = ACTIONS(3096),
    [anon_sym_new] = ACTIONS(3096),
    [anon_sym_requires] = ACTIONS(3096),
    [sym_this] = ACTIONS(3096),
  },
  [472] = {
    [sym_identifier] = ACTIONS(3150),
    [aux_sym_preproc_include_token1] = ACTIONS(3150),
    [aux_sym_preproc_def_token1] = ACTIONS(3150),
    [aux_sym_preproc_if_token1] = ACTIONS(3150),
    [aux_sym_preproc_if_token2] = ACTIONS(3150),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3150),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3150),
    [aux_sym_preproc_else_token1] = ACTIONS(3150),
    [aux_sym_preproc_elif_token1] = ACTIONS(3150),
    [sym_preproc_directive] = ACTIONS(3150),
    [anon_sym_LPAREN2] = ACTIONS(3152),
    [anon_sym_BANG] = ACTIONS(3152),
    [anon_sym_TILDE] = ACTIONS(3152),
    [anon_sym_DASH] = ACTIONS(3150),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_STAR] = ACTIONS(3152),
    [anon_sym_AMP_AMP] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(3152),
    [anon_sym___extension__] = ACTIONS(3150),
    [anon_sym_typedef] = ACTIONS(3150),
    [anon_sym_extern] = ACTIONS(3150),
    [anon_sym___attribute__] = ACTIONS(3150),
    [anon_sym_COLON_COLON] = ACTIONS(3152),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3152),
    [anon_sym___declspec] = ACTIONS(3150),
    [anon_sym___based] = ACTIONS(3150),
    [anon_sym___cdecl] = ACTIONS(3150),
    [anon_sym___clrcall] = ACTIONS(3150),
    [anon_sym___stdcall] = ACTIONS(3150),
    [anon_sym___fastcall] = ACTIONS(3150),
    [anon_sym___thiscall] = ACTIONS(3150),
    [anon_sym___vectorcall] = ACTIONS(3150),
    [anon_sym_LBRACE] = ACTIONS(3152),
    [anon_sym_signed] = ACTIONS(3150),
    [anon_sym_unsigned] = ACTIONS(3150),
    [anon_sym_long] = ACTIONS(3150),
    [anon_sym_short] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3150),
    [anon_sym_static] = ACTIONS(3150),
    [anon_sym_register] = ACTIONS(3150),
    [anon_sym_inline] = ACTIONS(3150),
    [anon_sym___inline] = ACTIONS(3150),
    [anon_sym___inline__] = ACTIONS(3150),
    [anon_sym___forceinline] = ACTIONS(3150),
    [anon_sym_thread_local] = ACTIONS(3150),
    [anon_sym___thread] = ACTIONS(3150),
    [anon_sym_const] = ACTIONS(3150),
    [anon_sym_constexpr] = ACTIONS(3150),
    [anon_sym_volatile] = ACTIONS(3150),
    [anon_sym_restrict] = ACTIONS(3150),
    [anon_sym___restrict__] = ACTIONS(3150),
    [anon_sym__Atomic] = ACTIONS(3150),
    [anon_sym__Noreturn] = ACTIONS(3150),
    [anon_sym_noreturn] = ACTIONS(3150),
    [anon_sym_mutable] = ACTIONS(3150),
    [anon_sym_constinit] = ACTIONS(3150),
    [anon_sym_consteval] = ACTIONS(3150),
    [anon_sym_PROGMEM] = ACTIONS(3150),
    [aux_sym_primitive_type_token1] = ACTIONS(3150),
    [anon_sym_byte] = ACTIONS(3150),
    [anon_sym_word] = ACTIONS(3150),
    [anon_sym_enum] = ACTIONS(3150),
    [anon_sym_class] = ACTIONS(3150),
    [anon_sym_struct] = ACTIONS(3150),
    [anon_sym_union] = ACTIONS(3150),
    [anon_sym_if] = ACTIONS(3150),
    [anon_sym_else] = ACTIONS(3150),
    [anon_sym_switch] = ACTIONS(3150),
    [anon_sym_case] = ACTIONS(3150),
    [anon_sym_default] = ACTIONS(3150),
    [anon_sym_while] = ACTIONS(3150),
    [anon_sym_do] = ACTIONS(3150),
    [anon_sym_for] = ACTIONS(3150),
    [anon_sym_return] = ACTIONS(3150),
    [anon_sym_break] = ACTIONS(3150),
    [anon_sym_continue] = ACTIONS(3150),
    [anon_sym_goto] = ACTIONS(3150),
    [anon_sym___try] = ACTIONS(3150),
    [anon_sym___leave] = ACTIONS(3150),
    [anon_sym_not] = ACTIONS(3150),
    [anon_sym_compl] = ACTIONS(3150),
    [anon_sym_DASH_DASH] = ACTIONS(3152),
    [anon_sym_PLUS_PLUS] = ACTIONS(3152),
    [anon_sym_sizeof] = ACTIONS(3150),
    [anon_sym___alignof__] = ACTIONS(3150),
    [anon_sym___alignof] = ACTIONS(3150),
    [anon_sym__alignof] = ACTIONS(3150),
    [anon_sym_alignof] = ACTIONS(3150),
    [anon_sym__Alignof] = ACTIONS(3150),
    [anon_sym_offsetof] = ACTIONS(3150),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3150),
    [anon_sym___asm__] = ACTIONS(3150),
    [aux_sym_number_literal_token1] = ACTIONS(3152),
    [aux_sym_number_literal_token2] = ACTIONS(3150),
    [anon_sym_L_SQUOTE] = ACTIONS(3152),
    [anon_sym_u_SQUOTE] = ACTIONS(3152),
    [anon_sym_U_SQUOTE] = ACTIONS(3152),
    [anon_sym_u8_SQUOTE] = ACTIONS(3152),
    [anon_sym_SQUOTE] = ACTIONS(3152),
    [anon_sym_L_DQUOTE] = ACTIONS(3152),
    [anon_sym_u_DQUOTE] = ACTIONS(3152),
    [anon_sym_U_DQUOTE] = ACTIONS(3152),
    [anon_sym_u8_DQUOTE] = ACTIONS(3152),
    [anon_sym_DQUOTE] = ACTIONS(3152),
    [sym_true] = ACTIONS(3150),
    [sym_false] = ACTIONS(3150),
    [anon_sym_NULL] = ACTIONS(3150),
    [anon_sym_nullptr] = ACTIONS(3150),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3150),
    [anon_sym_decltype] = ACTIONS(3150),
    [anon_sym_virtual] = ACTIONS(3150),
    [anon_sym_alignas] = ACTIONS(3150),
    [anon_sym_explicit] = ACTIONS(3150),
    [anon_sym_typename] = ACTIONS(3150),
    [anon_sym_template] = ACTIONS(3150),
    [anon_sym_operator] = ACTIONS(3150),
    [anon_sym_try] = ACTIONS(3150),
    [anon_sym_delete] = ACTIONS(3150),
    [anon_sym_throw] = ACTIONS(3150),
    [anon_sym_namespace] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_static_assert] = ACTIONS(3150),
    [anon_sym_concept] = ACTIONS(3150),
    [anon_sym_co_return] = ACTIONS(3150),
    [anon_sym_co_yield] = ACTIONS(3150),
    [anon_sym_R_DQUOTE] = ACTIONS(3152),
    [anon_sym_LR_DQUOTE] = ACTIONS(3152),
    [anon_sym_uR_DQUOTE] = ACTIONS(3152),
    [anon_sym_UR_DQUOTE] = ACTIONS(3152),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3152),
    [anon_sym_co_await] = ACTIONS(3150),
    [anon_sym_new] = ACTIONS(3150),
    [anon_sym_requires] = ACTIONS(3150),
    [sym_this] = ACTIONS(3150),
  },
  [473] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [474] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [475] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [476] = {
    [sym_identifier] = ACTIONS(3108),
    [aux_sym_preproc_include_token1] = ACTIONS(3108),
    [aux_sym_preproc_def_token1] = ACTIONS(3108),
    [aux_sym_preproc_if_token1] = ACTIONS(3108),
    [aux_sym_preproc_if_token2] = ACTIONS(3108),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3108),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3108),
    [aux_sym_preproc_else_token1] = ACTIONS(3108),
    [aux_sym_preproc_elif_token1] = ACTIONS(3108),
    [sym_preproc_directive] = ACTIONS(3108),
    [anon_sym_LPAREN2] = ACTIONS(3110),
    [anon_sym_BANG] = ACTIONS(3110),
    [anon_sym_TILDE] = ACTIONS(3110),
    [anon_sym_DASH] = ACTIONS(3108),
    [anon_sym_PLUS] = ACTIONS(3108),
    [anon_sym_STAR] = ACTIONS(3110),
    [anon_sym_AMP_AMP] = ACTIONS(3110),
    [anon_sym_AMP] = ACTIONS(3108),
    [anon_sym_SEMI] = ACTIONS(3110),
    [anon_sym___extension__] = ACTIONS(3108),
    [anon_sym_typedef] = ACTIONS(3108),
    [anon_sym_extern] = ACTIONS(3108),
    [anon_sym___attribute__] = ACTIONS(3108),
    [anon_sym_COLON_COLON] = ACTIONS(3110),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3110),
    [anon_sym___declspec] = ACTIONS(3108),
    [anon_sym___based] = ACTIONS(3108),
    [anon_sym___cdecl] = ACTIONS(3108),
    [anon_sym___clrcall] = ACTIONS(3108),
    [anon_sym___stdcall] = ACTIONS(3108),
    [anon_sym___fastcall] = ACTIONS(3108),
    [anon_sym___thiscall] = ACTIONS(3108),
    [anon_sym___vectorcall] = ACTIONS(3108),
    [anon_sym_LBRACE] = ACTIONS(3110),
    [anon_sym_signed] = ACTIONS(3108),
    [anon_sym_unsigned] = ACTIONS(3108),
    [anon_sym_long] = ACTIONS(3108),
    [anon_sym_short] = ACTIONS(3108),
    [anon_sym_LBRACK] = ACTIONS(3108),
    [anon_sym_static] = ACTIONS(3108),
    [anon_sym_register] = ACTIONS(3108),
    [anon_sym_inline] = ACTIONS(3108),
    [anon_sym___inline] = ACTIONS(3108),
    [anon_sym___inline__] = ACTIONS(3108),
    [anon_sym___forceinline] = ACTIONS(3108),
    [anon_sym_thread_local] = ACTIONS(3108),
    [anon_sym___thread] = ACTIONS(3108),
    [anon_sym_const] = ACTIONS(3108),
    [anon_sym_constexpr] = ACTIONS(3108),
    [anon_sym_volatile] = ACTIONS(3108),
    [anon_sym_restrict] = ACTIONS(3108),
    [anon_sym___restrict__] = ACTIONS(3108),
    [anon_sym__Atomic] = ACTIONS(3108),
    [anon_sym__Noreturn] = ACTIONS(3108),
    [anon_sym_noreturn] = ACTIONS(3108),
    [anon_sym_mutable] = ACTIONS(3108),
    [anon_sym_constinit] = ACTIONS(3108),
    [anon_sym_consteval] = ACTIONS(3108),
    [anon_sym_PROGMEM] = ACTIONS(3108),
    [aux_sym_primitive_type_token1] = ACTIONS(3108),
    [anon_sym_byte] = ACTIONS(3108),
    [anon_sym_word] = ACTIONS(3108),
    [anon_sym_enum] = ACTIONS(3108),
    [anon_sym_class] = ACTIONS(3108),
    [anon_sym_struct] = ACTIONS(3108),
    [anon_sym_union] = ACTIONS(3108),
    [anon_sym_if] = ACTIONS(3108),
    [anon_sym_else] = ACTIONS(3108),
    [anon_sym_switch] = ACTIONS(3108),
    [anon_sym_case] = ACTIONS(3108),
    [anon_sym_default] = ACTIONS(3108),
    [anon_sym_while] = ACTIONS(3108),
    [anon_sym_do] = ACTIONS(3108),
    [anon_sym_for] = ACTIONS(3108),
    [anon_sym_return] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3108),
    [anon_sym_continue] = ACTIONS(3108),
    [anon_sym_goto] = ACTIONS(3108),
    [anon_sym___try] = ACTIONS(3108),
    [anon_sym___leave] = ACTIONS(3108),
    [anon_sym_not] = ACTIONS(3108),
    [anon_sym_compl] = ACTIONS(3108),
    [anon_sym_DASH_DASH] = ACTIONS(3110),
    [anon_sym_PLUS_PLUS] = ACTIONS(3110),
    [anon_sym_sizeof] = ACTIONS(3108),
    [anon_sym___alignof__] = ACTIONS(3108),
    [anon_sym___alignof] = ACTIONS(3108),
    [anon_sym__alignof] = ACTIONS(3108),
    [anon_sym_alignof] = ACTIONS(3108),
    [anon_sym__Alignof] = ACTIONS(3108),
    [anon_sym_offsetof] = ACTIONS(3108),
    [anon_sym__Generic] = ACTIONS(3108),
    [anon_sym_asm] = ACTIONS(3108),
    [anon_sym___asm__] = ACTIONS(3108),
    [aux_sym_number_literal_token1] = ACTIONS(3110),
    [aux_sym_number_literal_token2] = ACTIONS(3108),
    [anon_sym_L_SQUOTE] = ACTIONS(3110),
    [anon_sym_u_SQUOTE] = ACTIONS(3110),
    [anon_sym_U_SQUOTE] = ACTIONS(3110),
    [anon_sym_u8_SQUOTE] = ACTIONS(3110),
    [anon_sym_SQUOTE] = ACTIONS(3110),
    [anon_sym_L_DQUOTE] = ACTIONS(3110),
    [anon_sym_u_DQUOTE] = ACTIONS(3110),
    [anon_sym_U_DQUOTE] = ACTIONS(3110),
    [anon_sym_u8_DQUOTE] = ACTIONS(3110),
    [anon_sym_DQUOTE] = ACTIONS(3110),
    [sym_true] = ACTIONS(3108),
    [sym_false] = ACTIONS(3108),
    [anon_sym_NULL] = ACTIONS(3108),
    [anon_sym_nullptr] = ACTIONS(3108),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3108),
    [anon_sym_decltype] = ACTIONS(3108),
    [anon_sym_virtual] = ACTIONS(3108),
    [anon_sym_alignas] = ACTIONS(3108),
    [anon_sym_explicit] = ACTIONS(3108),
    [anon_sym_typename] = ACTIONS(3108),
    [anon_sym_template] = ACTIONS(3108),
    [anon_sym_operator] = ACTIONS(3108),
    [anon_sym_try] = ACTIONS(3108),
    [anon_sym_delete] = ACTIONS(3108),
    [anon_sym_throw] = ACTIONS(3108),
    [anon_sym_namespace] = ACTIONS(3108),
    [anon_sym_using] = ACTIONS(3108),
    [anon_sym_static_assert] = ACTIONS(3108),
    [anon_sym_concept] = ACTIONS(3108),
    [anon_sym_co_return] = ACTIONS(3108),
    [anon_sym_co_yield] = ACTIONS(3108),
    [anon_sym_R_DQUOTE] = ACTIONS(3110),
    [anon_sym_LR_DQUOTE] = ACTIONS(3110),
    [anon_sym_uR_DQUOTE] = ACTIONS(3110),
    [anon_sym_UR_DQUOTE] = ACTIONS(3110),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3110),
    [anon_sym_co_await] = ACTIONS(3108),
    [anon_sym_new] = ACTIONS(3108),
    [anon_sym_requires] = ACTIONS(3108),
    [sym_this] = ACTIONS(3108),
  },
  [477] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [478] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [479] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [480] = {
    [sym_catch_clause] = STATE(388),
    [aux_sym_constructor_try_statement_repeat1] = STATE(388),
    [sym_identifier] = ACTIONS(2860),
    [aux_sym_preproc_include_token1] = ACTIONS(2860),
    [aux_sym_preproc_def_token1] = ACTIONS(2860),
    [aux_sym_preproc_if_token1] = ACTIONS(2860),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2860),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2860),
    [sym_preproc_directive] = ACTIONS(2860),
    [anon_sym_LPAREN2] = ACTIONS(2862),
    [anon_sym_BANG] = ACTIONS(2862),
    [anon_sym_TILDE] = ACTIONS(2862),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP_AMP] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2860),
    [anon_sym_SEMI] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2860),
    [anon_sym_typedef] = ACTIONS(2860),
    [anon_sym_extern] = ACTIONS(2860),
    [anon_sym___attribute__] = ACTIONS(2860),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2862),
    [anon_sym___declspec] = ACTIONS(2860),
    [anon_sym___based] = ACTIONS(2860),
    [anon_sym___cdecl] = ACTIONS(2860),
    [anon_sym___clrcall] = ACTIONS(2860),
    [anon_sym___stdcall] = ACTIONS(2860),
    [anon_sym___fastcall] = ACTIONS(2860),
    [anon_sym___thiscall] = ACTIONS(2860),
    [anon_sym___vectorcall] = ACTIONS(2860),
    [anon_sym_LBRACE] = ACTIONS(2862),
    [anon_sym_RBRACE] = ACTIONS(2862),
    [anon_sym_signed] = ACTIONS(2860),
    [anon_sym_unsigned] = ACTIONS(2860),
    [anon_sym_long] = ACTIONS(2860),
    [anon_sym_short] = ACTIONS(2860),
    [anon_sym_LBRACK] = ACTIONS(2860),
    [anon_sym_static] = ACTIONS(2860),
    [anon_sym_register] = ACTIONS(2860),
    [anon_sym_inline] = ACTIONS(2860),
    [anon_sym___inline] = ACTIONS(2860),
    [anon_sym___inline__] = ACTIONS(2860),
    [anon_sym___forceinline] = ACTIONS(2860),
    [anon_sym_thread_local] = ACTIONS(2860),
    [anon_sym___thread] = ACTIONS(2860),
    [anon_sym_const] = ACTIONS(2860),
    [anon_sym_constexpr] = ACTIONS(2860),
    [anon_sym_volatile] = ACTIONS(2860),
    [anon_sym_restrict] = ACTIONS(2860),
    [anon_sym___restrict__] = ACTIONS(2860),
    [anon_sym__Atomic] = ACTIONS(2860),
    [anon_sym__Noreturn] = ACTIONS(2860),
    [anon_sym_noreturn] = ACTIONS(2860),
    [anon_sym_mutable] = ACTIONS(2860),
    [anon_sym_constinit] = ACTIONS(2860),
    [anon_sym_consteval] = ACTIONS(2860),
    [anon_sym_PROGMEM] = ACTIONS(2860),
    [aux_sym_primitive_type_token1] = ACTIONS(2860),
    [anon_sym_byte] = ACTIONS(2860),
    [anon_sym_word] = ACTIONS(2860),
    [anon_sym_enum] = ACTIONS(2860),
    [anon_sym_class] = ACTIONS(2860),
    [anon_sym_struct] = ACTIONS(2860),
    [anon_sym_union] = ACTIONS(2860),
    [anon_sym_if] = ACTIONS(2860),
    [anon_sym_switch] = ACTIONS(2860),
    [anon_sym_case] = ACTIONS(2860),
    [anon_sym_default] = ACTIONS(2860),
    [anon_sym_while] = ACTIONS(2860),
    [anon_sym_do] = ACTIONS(2860),
    [anon_sym_for] = ACTIONS(2860),
    [anon_sym_return] = ACTIONS(2860),
    [anon_sym_break] = ACTIONS(2860),
    [anon_sym_continue] = ACTIONS(2860),
    [anon_sym_goto] = ACTIONS(2860),
    [anon_sym___try] = ACTIONS(2860),
    [anon_sym___leave] = ACTIONS(2860),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2862),
    [anon_sym_PLUS_PLUS] = ACTIONS(2862),
    [anon_sym_sizeof] = ACTIONS(2860),
    [anon_sym___alignof__] = ACTIONS(2860),
    [anon_sym___alignof] = ACTIONS(2860),
    [anon_sym__alignof] = ACTIONS(2860),
    [anon_sym_alignof] = ACTIONS(2860),
    [anon_sym__Alignof] = ACTIONS(2860),
    [anon_sym_offsetof] = ACTIONS(2860),
    [anon_sym__Generic] = ACTIONS(2860),
    [anon_sym_asm] = ACTIONS(2860),
    [anon_sym___asm__] = ACTIONS(2860),
    [aux_sym_number_literal_token1] = ACTIONS(2862),
    [aux_sym_number_literal_token2] = ACTIONS(2860),
    [anon_sym_L_SQUOTE] = ACTIONS(2862),
    [anon_sym_u_SQUOTE] = ACTIONS(2862),
    [anon_sym_U_SQUOTE] = ACTIONS(2862),
    [anon_sym_u8_SQUOTE] = ACTIONS(2862),
    [anon_sym_SQUOTE] = ACTIONS(2862),
    [anon_sym_L_DQUOTE] = ACTIONS(2862),
    [anon_sym_u_DQUOTE] = ACTIONS(2862),
    [anon_sym_U_DQUOTE] = ACTIONS(2862),
    [anon_sym_u8_DQUOTE] = ACTIONS(2862),
    [anon_sym_DQUOTE] = ACTIONS(2862),
    [sym_true] = ACTIONS(2860),
    [sym_false] = ACTIONS(2860),
    [anon_sym_NULL] = ACTIONS(2860),
    [anon_sym_nullptr] = ACTIONS(2860),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2860),
    [anon_sym_decltype] = ACTIONS(2860),
    [anon_sym_virtual] = ACTIONS(2860),
    [anon_sym_alignas] = ACTIONS(2860),
    [anon_sym_explicit] = ACTIONS(2860),
    [anon_sym_typename] = ACTIONS(2860),
    [anon_sym_template] = ACTIONS(2860),
    [anon_sym_operator] = ACTIONS(2860),
    [anon_sym_try] = ACTIONS(2860),
    [anon_sym_delete] = ACTIONS(2860),
    [anon_sym_throw] = ACTIONS(2860),
    [anon_sym_namespace] = ACTIONS(2860),
    [anon_sym_using] = ACTIONS(2860),
    [anon_sym_static_assert] = ACTIONS(2860),
    [anon_sym_concept] = ACTIONS(2860),
    [anon_sym_co_return] = ACTIONS(2860),
    [anon_sym_co_yield] = ACTIONS(2860),
    [anon_sym_catch] = ACTIONS(3344),
    [anon_sym_R_DQUOTE] = ACTIONS(2862),
    [anon_sym_LR_DQUOTE] = ACTIONS(2862),
    [anon_sym_uR_DQUOTE] = ACTIONS(2862),
    [anon_sym_UR_DQUOTE] = ACTIONS(2862),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2862),
    [anon_sym_co_await] = ACTIONS(2860),
    [anon_sym_new] = ACTIONS(2860),
    [anon_sym_requires] = ACTIONS(2860),
    [sym_this] = ACTIONS(2860),
  },
  [481] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [482] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [483] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [484] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [485] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [486] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [487] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [488] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [489] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [490] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [491] = {
    [sym_identifier] = ACTIONS(3102),
    [aux_sym_preproc_include_token1] = ACTIONS(3102),
    [aux_sym_preproc_def_token1] = ACTIONS(3102),
    [aux_sym_preproc_if_token1] = ACTIONS(3102),
    [aux_sym_preproc_if_token2] = ACTIONS(3102),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3102),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3102),
    [aux_sym_preproc_else_token1] = ACTIONS(3102),
    [aux_sym_preproc_elif_token1] = ACTIONS(3102),
    [sym_preproc_directive] = ACTIONS(3102),
    [anon_sym_LPAREN2] = ACTIONS(3104),
    [anon_sym_BANG] = ACTIONS(3104),
    [anon_sym_TILDE] = ACTIONS(3104),
    [anon_sym_DASH] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(3104),
    [anon_sym_AMP_AMP] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3102),
    [anon_sym_SEMI] = ACTIONS(3104),
    [anon_sym___extension__] = ACTIONS(3102),
    [anon_sym_typedef] = ACTIONS(3102),
    [anon_sym_extern] = ACTIONS(3102),
    [anon_sym___attribute__] = ACTIONS(3102),
    [anon_sym_COLON_COLON] = ACTIONS(3104),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3104),
    [anon_sym___declspec] = ACTIONS(3102),
    [anon_sym___based] = ACTIONS(3102),
    [anon_sym___cdecl] = ACTIONS(3102),
    [anon_sym___clrcall] = ACTIONS(3102),
    [anon_sym___stdcall] = ACTIONS(3102),
    [anon_sym___fastcall] = ACTIONS(3102),
    [anon_sym___thiscall] = ACTIONS(3102),
    [anon_sym___vectorcall] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3104),
    [anon_sym_signed] = ACTIONS(3102),
    [anon_sym_unsigned] = ACTIONS(3102),
    [anon_sym_long] = ACTIONS(3102),
    [anon_sym_short] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_static] = ACTIONS(3102),
    [anon_sym_register] = ACTIONS(3102),
    [anon_sym_inline] = ACTIONS(3102),
    [anon_sym___inline] = ACTIONS(3102),
    [anon_sym___inline__] = ACTIONS(3102),
    [anon_sym___forceinline] = ACTIONS(3102),
    [anon_sym_thread_local] = ACTIONS(3102),
    [anon_sym___thread] = ACTIONS(3102),
    [anon_sym_const] = ACTIONS(3102),
    [anon_sym_constexpr] = ACTIONS(3102),
    [anon_sym_volatile] = ACTIONS(3102),
    [anon_sym_restrict] = ACTIONS(3102),
    [anon_sym___restrict__] = ACTIONS(3102),
    [anon_sym__Atomic] = ACTIONS(3102),
    [anon_sym__Noreturn] = ACTIONS(3102),
    [anon_sym_noreturn] = ACTIONS(3102),
    [anon_sym_mutable] = ACTIONS(3102),
    [anon_sym_constinit] = ACTIONS(3102),
    [anon_sym_consteval] = ACTIONS(3102),
    [anon_sym_PROGMEM] = ACTIONS(3102),
    [aux_sym_primitive_type_token1] = ACTIONS(3102),
    [anon_sym_byte] = ACTIONS(3102),
    [anon_sym_word] = ACTIONS(3102),
    [anon_sym_enum] = ACTIONS(3102),
    [anon_sym_class] = ACTIONS(3102),
    [anon_sym_struct] = ACTIONS(3102),
    [anon_sym_union] = ACTIONS(3102),
    [anon_sym_if] = ACTIONS(3102),
    [anon_sym_else] = ACTIONS(3102),
    [anon_sym_switch] = ACTIONS(3102),
    [anon_sym_case] = ACTIONS(3102),
    [anon_sym_default] = ACTIONS(3102),
    [anon_sym_while] = ACTIONS(3102),
    [anon_sym_do] = ACTIONS(3102),
    [anon_sym_for] = ACTIONS(3102),
    [anon_sym_return] = ACTIONS(3102),
    [anon_sym_break] = ACTIONS(3102),
    [anon_sym_continue] = ACTIONS(3102),
    [anon_sym_goto] = ACTIONS(3102),
    [anon_sym___try] = ACTIONS(3102),
    [anon_sym___leave] = ACTIONS(3102),
    [anon_sym_not] = ACTIONS(3102),
    [anon_sym_compl] = ACTIONS(3102),
    [anon_sym_DASH_DASH] = ACTIONS(3104),
    [anon_sym_PLUS_PLUS] = ACTIONS(3104),
    [anon_sym_sizeof] = ACTIONS(3102),
    [anon_sym___alignof__] = ACTIONS(3102),
    [anon_sym___alignof] = ACTIONS(3102),
    [anon_sym__alignof] = ACTIONS(3102),
    [anon_sym_alignof] = ACTIONS(3102),
    [anon_sym__Alignof] = ACTIONS(3102),
    [anon_sym_offsetof] = ACTIONS(3102),
    [anon_sym__Generic] = ACTIONS(3102),
    [anon_sym_asm] = ACTIONS(3102),
    [anon_sym___asm__] = ACTIONS(3102),
    [aux_sym_number_literal_token1] = ACTIONS(3104),
    [aux_sym_number_literal_token2] = ACTIONS(3102),
    [anon_sym_L_SQUOTE] = ACTIONS(3104),
    [anon_sym_u_SQUOTE] = ACTIONS(3104),
    [anon_sym_U_SQUOTE] = ACTIONS(3104),
    [anon_sym_u8_SQUOTE] = ACTIONS(3104),
    [anon_sym_SQUOTE] = ACTIONS(3104),
    [anon_sym_L_DQUOTE] = ACTIONS(3104),
    [anon_sym_u_DQUOTE] = ACTIONS(3104),
    [anon_sym_U_DQUOTE] = ACTIONS(3104),
    [anon_sym_u8_DQUOTE] = ACTIONS(3104),
    [anon_sym_DQUOTE] = ACTIONS(3104),
    [sym_true] = ACTIONS(3102),
    [sym_false] = ACTIONS(3102),
    [anon_sym_NULL] = ACTIONS(3102),
    [anon_sym_nullptr] = ACTIONS(3102),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3102),
    [anon_sym_decltype] = ACTIONS(3102),
    [anon_sym_virtual] = ACTIONS(3102),
    [anon_sym_alignas] = ACTIONS(3102),
    [anon_sym_explicit] = ACTIONS(3102),
    [anon_sym_typename] = ACTIONS(3102),
    [anon_sym_template] = ACTIONS(3102),
    [anon_sym_operator] = ACTIONS(3102),
    [anon_sym_try] = ACTIONS(3102),
    [anon_sym_delete] = ACTIONS(3102),
    [anon_sym_throw] = ACTIONS(3102),
    [anon_sym_namespace] = ACTIONS(3102),
    [anon_sym_using] = ACTIONS(3102),
    [anon_sym_static_assert] = ACTIONS(3102),
    [anon_sym_concept] = ACTIONS(3102),
    [anon_sym_co_return] = ACTIONS(3102),
    [anon_sym_co_yield] = ACTIONS(3102),
    [anon_sym_R_DQUOTE] = ACTIONS(3104),
    [anon_sym_LR_DQUOTE] = ACTIONS(3104),
    [anon_sym_uR_DQUOTE] = ACTIONS(3104),
    [anon_sym_UR_DQUOTE] = ACTIONS(3104),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3104),
    [anon_sym_co_await] = ACTIONS(3102),
    [anon_sym_new] = ACTIONS(3102),
    [anon_sym_requires] = ACTIONS(3102),
    [sym_this] = ACTIONS(3102),
  },
  [492] = {
    [sym_identifier] = ACTIONS(3078),
    [aux_sym_preproc_include_token1] = ACTIONS(3078),
    [aux_sym_preproc_def_token1] = ACTIONS(3078),
    [aux_sym_preproc_if_token1] = ACTIONS(3078),
    [aux_sym_preproc_if_token2] = ACTIONS(3078),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3078),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3078),
    [aux_sym_preproc_else_token1] = ACTIONS(3078),
    [aux_sym_preproc_elif_token1] = ACTIONS(3078),
    [sym_preproc_directive] = ACTIONS(3078),
    [anon_sym_LPAREN2] = ACTIONS(3080),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_TILDE] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3078),
    [anon_sym_PLUS] = ACTIONS(3078),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3080),
    [anon_sym_AMP] = ACTIONS(3078),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym___extension__] = ACTIONS(3078),
    [anon_sym_typedef] = ACTIONS(3078),
    [anon_sym_extern] = ACTIONS(3078),
    [anon_sym___attribute__] = ACTIONS(3078),
    [anon_sym_COLON_COLON] = ACTIONS(3080),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3080),
    [anon_sym___declspec] = ACTIONS(3078),
    [anon_sym___based] = ACTIONS(3078),
    [anon_sym___cdecl] = ACTIONS(3078),
    [anon_sym___clrcall] = ACTIONS(3078),
    [anon_sym___stdcall] = ACTIONS(3078),
    [anon_sym___fastcall] = ACTIONS(3078),
    [anon_sym___thiscall] = ACTIONS(3078),
    [anon_sym___vectorcall] = ACTIONS(3078),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_signed] = ACTIONS(3078),
    [anon_sym_unsigned] = ACTIONS(3078),
    [anon_sym_long] = ACTIONS(3078),
    [anon_sym_short] = ACTIONS(3078),
    [anon_sym_LBRACK] = ACTIONS(3078),
    [anon_sym_static] = ACTIONS(3078),
    [anon_sym_register] = ACTIONS(3078),
    [anon_sym_inline] = ACTIONS(3078),
    [anon_sym___inline] = ACTIONS(3078),
    [anon_sym___inline__] = ACTIONS(3078),
    [anon_sym___forceinline] = ACTIONS(3078),
    [anon_sym_thread_local] = ACTIONS(3078),
    [anon_sym___thread] = ACTIONS(3078),
    [anon_sym_const] = ACTIONS(3078),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(3078),
    [anon_sym_restrict] = ACTIONS(3078),
    [anon_sym___restrict__] = ACTIONS(3078),
    [anon_sym__Atomic] = ACTIONS(3078),
    [anon_sym__Noreturn] = ACTIONS(3078),
    [anon_sym_noreturn] = ACTIONS(3078),
    [anon_sym_mutable] = ACTIONS(3078),
    [anon_sym_constinit] = ACTIONS(3078),
    [anon_sym_consteval] = ACTIONS(3078),
    [anon_sym_PROGMEM] = ACTIONS(3078),
    [aux_sym_primitive_type_token1] = ACTIONS(3078),
    [anon_sym_byte] = ACTIONS(3078),
    [anon_sym_word] = ACTIONS(3078),
    [anon_sym_enum] = ACTIONS(3078),
    [anon_sym_class] = ACTIONS(3078),
    [anon_sym_struct] = ACTIONS(3078),
    [anon_sym_union] = ACTIONS(3078),
    [anon_sym_if] = ACTIONS(3078),
    [anon_sym_else] = ACTIONS(3078),
    [anon_sym_switch] = ACTIONS(3078),
    [anon_sym_case] = ACTIONS(3078),
    [anon_sym_default] = ACTIONS(3078),
    [anon_sym_while] = ACTIONS(3078),
    [anon_sym_do] = ACTIONS(3078),
    [anon_sym_for] = ACTIONS(3078),
    [anon_sym_return] = ACTIONS(3078),
    [anon_sym_break] = ACTIONS(3078),
    [anon_sym_continue] = ACTIONS(3078),
    [anon_sym_goto] = ACTIONS(3078),
    [anon_sym___try] = ACTIONS(3078),
    [anon_sym___leave] = ACTIONS(3078),
    [anon_sym_not] = ACTIONS(3078),
    [anon_sym_compl] = ACTIONS(3078),
    [anon_sym_DASH_DASH] = ACTIONS(3080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3080),
    [anon_sym_sizeof] = ACTIONS(3078),
    [anon_sym___alignof__] = ACTIONS(3078),
    [anon_sym___alignof] = ACTIONS(3078),
    [anon_sym__alignof] = ACTIONS(3078),
    [anon_sym_alignof] = ACTIONS(3078),
    [anon_sym__Alignof] = ACTIONS(3078),
    [anon_sym_offsetof] = ACTIONS(3078),
    [anon_sym__Generic] = ACTIONS(3078),
    [anon_sym_asm] = ACTIONS(3078),
    [anon_sym___asm__] = ACTIONS(3078),
    [aux_sym_number_literal_token1] = ACTIONS(3080),
    [aux_sym_number_literal_token2] = ACTIONS(3078),
    [anon_sym_L_SQUOTE] = ACTIONS(3080),
    [anon_sym_u_SQUOTE] = ACTIONS(3080),
    [anon_sym_U_SQUOTE] = ACTIONS(3080),
    [anon_sym_u8_SQUOTE] = ACTIONS(3080),
    [anon_sym_SQUOTE] = ACTIONS(3080),
    [anon_sym_L_DQUOTE] = ACTIONS(3080),
    [anon_sym_u_DQUOTE] = ACTIONS(3080),
    [anon_sym_U_DQUOTE] = ACTIONS(3080),
    [anon_sym_u8_DQUOTE] = ACTIONS(3080),
    [anon_sym_DQUOTE] = ACTIONS(3080),
    [sym_true] = ACTIONS(3078),
    [sym_false] = ACTIONS(3078),
    [anon_sym_NULL] = ACTIONS(3078),
    [anon_sym_nullptr] = ACTIONS(3078),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3078),
    [anon_sym_decltype] = ACTIONS(3078),
    [anon_sym_virtual] = ACTIONS(3078),
    [anon_sym_alignas] = ACTIONS(3078),
    [anon_sym_explicit] = ACTIONS(3078),
    [anon_sym_typename] = ACTIONS(3078),
    [anon_sym_template] = ACTIONS(3078),
    [anon_sym_operator] = ACTIONS(3078),
    [anon_sym_try] = ACTIONS(3078),
    [anon_sym_delete] = ACTIONS(3078),
    [anon_sym_throw] = ACTIONS(3078),
    [anon_sym_namespace] = ACTIONS(3078),
    [anon_sym_using] = ACTIONS(3078),
    [anon_sym_static_assert] = ACTIONS(3078),
    [anon_sym_concept] = ACTIONS(3078),
    [anon_sym_co_return] = ACTIONS(3078),
    [anon_sym_co_yield] = ACTIONS(3078),
    [anon_sym_R_DQUOTE] = ACTIONS(3080),
    [anon_sym_LR_DQUOTE] = ACTIONS(3080),
    [anon_sym_uR_DQUOTE] = ACTIONS(3080),
    [anon_sym_UR_DQUOTE] = ACTIONS(3080),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3080),
    [anon_sym_co_await] = ACTIONS(3078),
    [anon_sym_new] = ACTIONS(3078),
    [anon_sym_requires] = ACTIONS(3078),
    [sym_this] = ACTIONS(3078),
  },
  [493] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [494] = {
    [sym_catch_clause] = STATE(410),
    [aux_sym_constructor_try_statement_repeat1] = STATE(410),
    [sym_identifier] = ACTIONS(2860),
    [aux_sym_preproc_include_token1] = ACTIONS(2860),
    [aux_sym_preproc_def_token1] = ACTIONS(2860),
    [aux_sym_preproc_if_token1] = ACTIONS(2860),
    [aux_sym_preproc_if_token2] = ACTIONS(2860),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2860),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2860),
    [sym_preproc_directive] = ACTIONS(2860),
    [anon_sym_LPAREN2] = ACTIONS(2862),
    [anon_sym_BANG] = ACTIONS(2862),
    [anon_sym_TILDE] = ACTIONS(2862),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP_AMP] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2860),
    [anon_sym_SEMI] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2860),
    [anon_sym_typedef] = ACTIONS(2860),
    [anon_sym_extern] = ACTIONS(2860),
    [anon_sym___attribute__] = ACTIONS(2860),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2862),
    [anon_sym___declspec] = ACTIONS(2860),
    [anon_sym___based] = ACTIONS(2860),
    [anon_sym___cdecl] = ACTIONS(2860),
    [anon_sym___clrcall] = ACTIONS(2860),
    [anon_sym___stdcall] = ACTIONS(2860),
    [anon_sym___fastcall] = ACTIONS(2860),
    [anon_sym___thiscall] = ACTIONS(2860),
    [anon_sym___vectorcall] = ACTIONS(2860),
    [anon_sym_LBRACE] = ACTIONS(2862),
    [anon_sym_signed] = ACTIONS(2860),
    [anon_sym_unsigned] = ACTIONS(2860),
    [anon_sym_long] = ACTIONS(2860),
    [anon_sym_short] = ACTIONS(2860),
    [anon_sym_LBRACK] = ACTIONS(2860),
    [anon_sym_static] = ACTIONS(2860),
    [anon_sym_register] = ACTIONS(2860),
    [anon_sym_inline] = ACTIONS(2860),
    [anon_sym___inline] = ACTIONS(2860),
    [anon_sym___inline__] = ACTIONS(2860),
    [anon_sym___forceinline] = ACTIONS(2860),
    [anon_sym_thread_local] = ACTIONS(2860),
    [anon_sym___thread] = ACTIONS(2860),
    [anon_sym_const] = ACTIONS(2860),
    [anon_sym_constexpr] = ACTIONS(2860),
    [anon_sym_volatile] = ACTIONS(2860),
    [anon_sym_restrict] = ACTIONS(2860),
    [anon_sym___restrict__] = ACTIONS(2860),
    [anon_sym__Atomic] = ACTIONS(2860),
    [anon_sym__Noreturn] = ACTIONS(2860),
    [anon_sym_noreturn] = ACTIONS(2860),
    [anon_sym_mutable] = ACTIONS(2860),
    [anon_sym_constinit] = ACTIONS(2860),
    [anon_sym_consteval] = ACTIONS(2860),
    [anon_sym_PROGMEM] = ACTIONS(2860),
    [aux_sym_primitive_type_token1] = ACTIONS(2860),
    [anon_sym_byte] = ACTIONS(2860),
    [anon_sym_word] = ACTIONS(2860),
    [anon_sym_enum] = ACTIONS(2860),
    [anon_sym_class] = ACTIONS(2860),
    [anon_sym_struct] = ACTIONS(2860),
    [anon_sym_union] = ACTIONS(2860),
    [anon_sym_if] = ACTIONS(2860),
    [anon_sym_switch] = ACTIONS(2860),
    [anon_sym_case] = ACTIONS(2860),
    [anon_sym_default] = ACTIONS(2860),
    [anon_sym_while] = ACTIONS(2860),
    [anon_sym_do] = ACTIONS(2860),
    [anon_sym_for] = ACTIONS(2860),
    [anon_sym_return] = ACTIONS(2860),
    [anon_sym_break] = ACTIONS(2860),
    [anon_sym_continue] = ACTIONS(2860),
    [anon_sym_goto] = ACTIONS(2860),
    [anon_sym___try] = ACTIONS(2860),
    [anon_sym___leave] = ACTIONS(2860),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2862),
    [anon_sym_PLUS_PLUS] = ACTIONS(2862),
    [anon_sym_sizeof] = ACTIONS(2860),
    [anon_sym___alignof__] = ACTIONS(2860),
    [anon_sym___alignof] = ACTIONS(2860),
    [anon_sym__alignof] = ACTIONS(2860),
    [anon_sym_alignof] = ACTIONS(2860),
    [anon_sym__Alignof] = ACTIONS(2860),
    [anon_sym_offsetof] = ACTIONS(2860),
    [anon_sym__Generic] = ACTIONS(2860),
    [anon_sym_asm] = ACTIONS(2860),
    [anon_sym___asm__] = ACTIONS(2860),
    [aux_sym_number_literal_token1] = ACTIONS(2862),
    [aux_sym_number_literal_token2] = ACTIONS(2860),
    [anon_sym_L_SQUOTE] = ACTIONS(2862),
    [anon_sym_u_SQUOTE] = ACTIONS(2862),
    [anon_sym_U_SQUOTE] = ACTIONS(2862),
    [anon_sym_u8_SQUOTE] = ACTIONS(2862),
    [anon_sym_SQUOTE] = ACTIONS(2862),
    [anon_sym_L_DQUOTE] = ACTIONS(2862),
    [anon_sym_u_DQUOTE] = ACTIONS(2862),
    [anon_sym_U_DQUOTE] = ACTIONS(2862),
    [anon_sym_u8_DQUOTE] = ACTIONS(2862),
    [anon_sym_DQUOTE] = ACTIONS(2862),
    [sym_true] = ACTIONS(2860),
    [sym_false] = ACTIONS(2860),
    [anon_sym_NULL] = ACTIONS(2860),
    [anon_sym_nullptr] = ACTIONS(2860),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2860),
    [anon_sym_decltype] = ACTIONS(2860),
    [anon_sym_virtual] = ACTIONS(2860),
    [anon_sym_alignas] = ACTIONS(2860),
    [anon_sym_explicit] = ACTIONS(2860),
    [anon_sym_typename] = ACTIONS(2860),
    [anon_sym_template] = ACTIONS(2860),
    [anon_sym_operator] = ACTIONS(2860),
    [anon_sym_try] = ACTIONS(2860),
    [anon_sym_delete] = ACTIONS(2860),
    [anon_sym_throw] = ACTIONS(2860),
    [anon_sym_namespace] = ACTIONS(2860),
    [anon_sym_using] = ACTIONS(2860),
    [anon_sym_static_assert] = ACTIONS(2860),
    [anon_sym_concept] = ACTIONS(2860),
    [anon_sym_co_return] = ACTIONS(2860),
    [anon_sym_co_yield] = ACTIONS(2860),
    [anon_sym_catch] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(2862),
    [anon_sym_LR_DQUOTE] = ACTIONS(2862),
    [anon_sym_uR_DQUOTE] = ACTIONS(2862),
    [anon_sym_UR_DQUOTE] = ACTIONS(2862),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2862),
    [anon_sym_co_await] = ACTIONS(2860),
    [anon_sym_new] = ACTIONS(2860),
    [anon_sym_requires] = ACTIONS(2860),
    [sym_this] = ACTIONS(2860),
  },
  [495] = {
    [sym_identifier] = ACTIONS(2869),
    [aux_sym_preproc_include_token1] = ACTIONS(2869),
    [aux_sym_preproc_def_token1] = ACTIONS(2869),
    [aux_sym_preproc_if_token1] = ACTIONS(2869),
    [aux_sym_preproc_if_token2] = ACTIONS(2869),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2869),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2869),
    [aux_sym_preproc_else_token1] = ACTIONS(2869),
    [aux_sym_preproc_elif_token1] = ACTIONS(2869),
    [sym_preproc_directive] = ACTIONS(2869),
    [anon_sym_LPAREN2] = ACTIONS(2874),
    [anon_sym_BANG] = ACTIONS(2874),
    [anon_sym_TILDE] = ACTIONS(2874),
    [anon_sym_DASH] = ACTIONS(2869),
    [anon_sym_PLUS] = ACTIONS(2869),
    [anon_sym_STAR] = ACTIONS(2874),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2869),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym___extension__] = ACTIONS(2869),
    [anon_sym_typedef] = ACTIONS(2869),
    [anon_sym_extern] = ACTIONS(2869),
    [anon_sym___attribute__] = ACTIONS(2869),
    [anon_sym_COLON_COLON] = ACTIONS(2874),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2874),
    [anon_sym___declspec] = ACTIONS(2869),
    [anon_sym___based] = ACTIONS(2869),
    [anon_sym___cdecl] = ACTIONS(2869),
    [anon_sym___clrcall] = ACTIONS(2869),
    [anon_sym___stdcall] = ACTIONS(2869),
    [anon_sym___fastcall] = ACTIONS(2869),
    [anon_sym___thiscall] = ACTIONS(2869),
    [anon_sym___vectorcall] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2874),
    [anon_sym_signed] = ACTIONS(2869),
    [anon_sym_unsigned] = ACTIONS(2869),
    [anon_sym_long] = ACTIONS(2869),
    [anon_sym_short] = ACTIONS(2869),
    [anon_sym_LBRACK] = ACTIONS(2869),
    [anon_sym_static] = ACTIONS(2869),
    [anon_sym_register] = ACTIONS(2869),
    [anon_sym_inline] = ACTIONS(2869),
    [anon_sym___inline] = ACTIONS(2869),
    [anon_sym___inline__] = ACTIONS(2869),
    [anon_sym___forceinline] = ACTIONS(2869),
    [anon_sym_thread_local] = ACTIONS(2869),
    [anon_sym___thread] = ACTIONS(2869),
    [anon_sym_const] = ACTIONS(2869),
    [anon_sym_constexpr] = ACTIONS(2869),
    [anon_sym_volatile] = ACTIONS(2869),
    [anon_sym_restrict] = ACTIONS(2869),
    [anon_sym___restrict__] = ACTIONS(2869),
    [anon_sym__Atomic] = ACTIONS(2869),
    [anon_sym__Noreturn] = ACTIONS(2869),
    [anon_sym_noreturn] = ACTIONS(2869),
    [anon_sym_mutable] = ACTIONS(2869),
    [anon_sym_constinit] = ACTIONS(2869),
    [anon_sym_consteval] = ACTIONS(2869),
    [anon_sym_PROGMEM] = ACTIONS(2869),
    [aux_sym_primitive_type_token1] = ACTIONS(2869),
    [anon_sym_byte] = ACTIONS(2869),
    [anon_sym_word] = ACTIONS(2869),
    [anon_sym_enum] = ACTIONS(2869),
    [anon_sym_class] = ACTIONS(2869),
    [anon_sym_struct] = ACTIONS(2869),
    [anon_sym_union] = ACTIONS(2869),
    [anon_sym_if] = ACTIONS(2869),
    [anon_sym_else] = ACTIONS(2869),
    [anon_sym_switch] = ACTIONS(2869),
    [anon_sym_case] = ACTIONS(2869),
    [anon_sym_default] = ACTIONS(2869),
    [anon_sym_while] = ACTIONS(2869),
    [anon_sym_do] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2869),
    [anon_sym_return] = ACTIONS(2869),
    [anon_sym_break] = ACTIONS(2869),
    [anon_sym_continue] = ACTIONS(2869),
    [anon_sym_goto] = ACTIONS(2869),
    [anon_sym___try] = ACTIONS(2869),
    [anon_sym___leave] = ACTIONS(2869),
    [anon_sym_not] = ACTIONS(2869),
    [anon_sym_compl] = ACTIONS(2869),
    [anon_sym_DASH_DASH] = ACTIONS(2874),
    [anon_sym_PLUS_PLUS] = ACTIONS(2874),
    [anon_sym_sizeof] = ACTIONS(2869),
    [anon_sym___alignof__] = ACTIONS(2869),
    [anon_sym___alignof] = ACTIONS(2869),
    [anon_sym__alignof] = ACTIONS(2869),
    [anon_sym_alignof] = ACTIONS(2869),
    [anon_sym__Alignof] = ACTIONS(2869),
    [anon_sym_offsetof] = ACTIONS(2869),
    [anon_sym__Generic] = ACTIONS(2869),
    [anon_sym_asm] = ACTIONS(2869),
    [anon_sym___asm__] = ACTIONS(2869),
    [aux_sym_number_literal_token1] = ACTIONS(2874),
    [aux_sym_number_literal_token2] = ACTIONS(2869),
    [anon_sym_L_SQUOTE] = ACTIONS(2874),
    [anon_sym_u_SQUOTE] = ACTIONS(2874),
    [anon_sym_U_SQUOTE] = ACTIONS(2874),
    [anon_sym_u8_SQUOTE] = ACTIONS(2874),
    [anon_sym_SQUOTE] = ACTIONS(2874),
    [anon_sym_L_DQUOTE] = ACTIONS(2874),
    [anon_sym_u_DQUOTE] = ACTIONS(2874),
    [anon_sym_U_DQUOTE] = ACTIONS(2874),
    [anon_sym_u8_DQUOTE] = ACTIONS(2874),
    [anon_sym_DQUOTE] = ACTIONS(2874),
    [sym_true] = ACTIONS(2869),
    [sym_false] = ACTIONS(2869),
    [anon_sym_NULL] = ACTIONS(2869),
    [anon_sym_nullptr] = ACTIONS(2869),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2869),
    [anon_sym_decltype] = ACTIONS(2869),
    [anon_sym_virtual] = ACTIONS(2869),
    [anon_sym_alignas] = ACTIONS(2869),
    [anon_sym_explicit] = ACTIONS(2869),
    [anon_sym_typename] = ACTIONS(2869),
    [anon_sym_template] = ACTIONS(2869),
    [anon_sym_operator] = ACTIONS(2869),
    [anon_sym_try] = ACTIONS(2869),
    [anon_sym_delete] = ACTIONS(2869),
    [anon_sym_throw] = ACTIONS(2869),
    [anon_sym_namespace] = ACTIONS(2869),
    [anon_sym_using] = ACTIONS(2869),
    [anon_sym_static_assert] = ACTIONS(2869),
    [anon_sym_concept] = ACTIONS(2869),
    [anon_sym_co_return] = ACTIONS(2869),
    [anon_sym_co_yield] = ACTIONS(2869),
    [anon_sym_R_DQUOTE] = ACTIONS(2874),
    [anon_sym_LR_DQUOTE] = ACTIONS(2874),
    [anon_sym_uR_DQUOTE] = ACTIONS(2874),
    [anon_sym_UR_DQUOTE] = ACTIONS(2874),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2874),
    [anon_sym_co_await] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2869),
    [sym_this] = ACTIONS(2869),
  },
  [496] = {
    [sym_identifier] = ACTIONS(3092),
    [aux_sym_preproc_include_token1] = ACTIONS(3092),
    [aux_sym_preproc_def_token1] = ACTIONS(3092),
    [aux_sym_preproc_if_token1] = ACTIONS(3092),
    [aux_sym_preproc_if_token2] = ACTIONS(3092),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3092),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3092),
    [aux_sym_preproc_else_token1] = ACTIONS(3092),
    [aux_sym_preproc_elif_token1] = ACTIONS(3092),
    [sym_preproc_directive] = ACTIONS(3092),
    [anon_sym_LPAREN2] = ACTIONS(3094),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_TILDE] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_SEMI] = ACTIONS(3094),
    [anon_sym___extension__] = ACTIONS(3092),
    [anon_sym_typedef] = ACTIONS(3092),
    [anon_sym_extern] = ACTIONS(3092),
    [anon_sym___attribute__] = ACTIONS(3092),
    [anon_sym_COLON_COLON] = ACTIONS(3094),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3094),
    [anon_sym___declspec] = ACTIONS(3092),
    [anon_sym___based] = ACTIONS(3092),
    [anon_sym___cdecl] = ACTIONS(3092),
    [anon_sym___clrcall] = ACTIONS(3092),
    [anon_sym___stdcall] = ACTIONS(3092),
    [anon_sym___fastcall] = ACTIONS(3092),
    [anon_sym___thiscall] = ACTIONS(3092),
    [anon_sym___vectorcall] = ACTIONS(3092),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_signed] = ACTIONS(3092),
    [anon_sym_unsigned] = ACTIONS(3092),
    [anon_sym_long] = ACTIONS(3092),
    [anon_sym_short] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_static] = ACTIONS(3092),
    [anon_sym_register] = ACTIONS(3092),
    [anon_sym_inline] = ACTIONS(3092),
    [anon_sym___inline] = ACTIONS(3092),
    [anon_sym___inline__] = ACTIONS(3092),
    [anon_sym___forceinline] = ACTIONS(3092),
    [anon_sym_thread_local] = ACTIONS(3092),
    [anon_sym___thread] = ACTIONS(3092),
    [anon_sym_const] = ACTIONS(3092),
    [anon_sym_constexpr] = ACTIONS(3092),
    [anon_sym_volatile] = ACTIONS(3092),
    [anon_sym_restrict] = ACTIONS(3092),
    [anon_sym___restrict__] = ACTIONS(3092),
    [anon_sym__Atomic] = ACTIONS(3092),
    [anon_sym__Noreturn] = ACTIONS(3092),
    [anon_sym_noreturn] = ACTIONS(3092),
    [anon_sym_mutable] = ACTIONS(3092),
    [anon_sym_constinit] = ACTIONS(3092),
    [anon_sym_consteval] = ACTIONS(3092),
    [anon_sym_PROGMEM] = ACTIONS(3092),
    [aux_sym_primitive_type_token1] = ACTIONS(3092),
    [anon_sym_byte] = ACTIONS(3092),
    [anon_sym_word] = ACTIONS(3092),
    [anon_sym_enum] = ACTIONS(3092),
    [anon_sym_class] = ACTIONS(3092),
    [anon_sym_struct] = ACTIONS(3092),
    [anon_sym_union] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_switch] = ACTIONS(3092),
    [anon_sym_case] = ACTIONS(3092),
    [anon_sym_default] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_break] = ACTIONS(3092),
    [anon_sym_continue] = ACTIONS(3092),
    [anon_sym_goto] = ACTIONS(3092),
    [anon_sym___try] = ACTIONS(3092),
    [anon_sym___leave] = ACTIONS(3092),
    [anon_sym_not] = ACTIONS(3092),
    [anon_sym_compl] = ACTIONS(3092),
    [anon_sym_DASH_DASH] = ACTIONS(3094),
    [anon_sym_PLUS_PLUS] = ACTIONS(3094),
    [anon_sym_sizeof] = ACTIONS(3092),
    [anon_sym___alignof__] = ACTIONS(3092),
    [anon_sym___alignof] = ACTIONS(3092),
    [anon_sym__alignof] = ACTIONS(3092),
    [anon_sym_alignof] = ACTIONS(3092),
    [anon_sym__Alignof] = ACTIONS(3092),
    [anon_sym_offsetof] = ACTIONS(3092),
    [anon_sym__Generic] = ACTIONS(3092),
    [anon_sym_asm] = ACTIONS(3092),
    [anon_sym___asm__] = ACTIONS(3092),
    [aux_sym_number_literal_token1] = ACTIONS(3094),
    [aux_sym_number_literal_token2] = ACTIONS(3092),
    [anon_sym_L_SQUOTE] = ACTIONS(3094),
    [anon_sym_u_SQUOTE] = ACTIONS(3094),
    [anon_sym_U_SQUOTE] = ACTIONS(3094),
    [anon_sym_u8_SQUOTE] = ACTIONS(3094),
    [anon_sym_SQUOTE] = ACTIONS(3094),
    [anon_sym_L_DQUOTE] = ACTIONS(3094),
    [anon_sym_u_DQUOTE] = ACTIONS(3094),
    [anon_sym_U_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8_DQUOTE] = ACTIONS(3094),
    [anon_sym_DQUOTE] = ACTIONS(3094),
    [sym_true] = ACTIONS(3092),
    [sym_false] = ACTIONS(3092),
    [anon_sym_NULL] = ACTIONS(3092),
    [anon_sym_nullptr] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3092),
    [anon_sym_decltype] = ACTIONS(3092),
    [anon_sym_virtual] = ACTIONS(3092),
    [anon_sym_alignas] = ACTIONS(3092),
    [anon_sym_explicit] = ACTIONS(3092),
    [anon_sym_typename] = ACTIONS(3092),
    [anon_sym_template] = ACTIONS(3092),
    [anon_sym_operator] = ACTIONS(3092),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_delete] = ACTIONS(3092),
    [anon_sym_throw] = ACTIONS(3092),
    [anon_sym_namespace] = ACTIONS(3092),
    [anon_sym_using] = ACTIONS(3092),
    [anon_sym_static_assert] = ACTIONS(3092),
    [anon_sym_concept] = ACTIONS(3092),
    [anon_sym_co_return] = ACTIONS(3092),
    [anon_sym_co_yield] = ACTIONS(3092),
    [anon_sym_R_DQUOTE] = ACTIONS(3094),
    [anon_sym_LR_DQUOTE] = ACTIONS(3094),
    [anon_sym_uR_DQUOTE] = ACTIONS(3094),
    [anon_sym_UR_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3094),
    [anon_sym_co_await] = ACTIONS(3092),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_requires] = ACTIONS(3092),
    [sym_this] = ACTIONS(3092),
  },
  [497] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [498] = {
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_include_token1] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token2] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [aux_sym_preproc_else_token1] = ACTIONS(3068),
    [aux_sym_preproc_elif_token1] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_BANG] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_DASH] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym___cdecl] = ACTIONS(3068),
    [anon_sym___clrcall] = ACTIONS(3068),
    [anon_sym___stdcall] = ACTIONS(3068),
    [anon_sym___fastcall] = ACTIONS(3068),
    [anon_sym___thiscall] = ACTIONS(3068),
    [anon_sym___vectorcall] = ACTIONS(3068),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_PROGMEM] = ACTIONS(3068),
    [aux_sym_primitive_type_token1] = ACTIONS(3068),
    [anon_sym_byte] = ACTIONS(3068),
    [anon_sym_word] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3068),
    [anon_sym_else] = ACTIONS(3068),
    [anon_sym_switch] = ACTIONS(3068),
    [anon_sym_case] = ACTIONS(3068),
    [anon_sym_default] = ACTIONS(3068),
    [anon_sym_while] = ACTIONS(3068),
    [anon_sym_do] = ACTIONS(3068),
    [anon_sym_for] = ACTIONS(3068),
    [anon_sym_return] = ACTIONS(3068),
    [anon_sym_break] = ACTIONS(3068),
    [anon_sym_continue] = ACTIONS(3068),
    [anon_sym_goto] = ACTIONS(3068),
    [anon_sym___try] = ACTIONS(3068),
    [anon_sym___leave] = ACTIONS(3068),
    [anon_sym_not] = ACTIONS(3068),
    [anon_sym_compl] = ACTIONS(3068),
    [anon_sym_DASH_DASH] = ACTIONS(3070),
    [anon_sym_PLUS_PLUS] = ACTIONS(3070),
    [anon_sym_sizeof] = ACTIONS(3068),
    [anon_sym___alignof__] = ACTIONS(3068),
    [anon_sym___alignof] = ACTIONS(3068),
    [anon_sym__alignof] = ACTIONS(3068),
    [anon_sym_alignof] = ACTIONS(3068),
    [anon_sym__Alignof] = ACTIONS(3068),
    [anon_sym_offsetof] = ACTIONS(3068),
    [anon_sym__Generic] = ACTIONS(3068),
    [anon_sym_asm] = ACTIONS(3068),
    [anon_sym___asm__] = ACTIONS(3068),
    [aux_sym_number_literal_token1] = ACTIONS(3070),
    [aux_sym_number_literal_token2] = ACTIONS(3068),
    [anon_sym_L_SQUOTE] = ACTIONS(3070),
    [anon_sym_u_SQUOTE] = ACTIONS(3070),
    [anon_sym_U_SQUOTE] = ACTIONS(3070),
    [anon_sym_u8_SQUOTE] = ACTIONS(3070),
    [anon_sym_SQUOTE] = ACTIONS(3070),
    [anon_sym_L_DQUOTE] = ACTIONS(3070),
    [anon_sym_u_DQUOTE] = ACTIONS(3070),
    [anon_sym_U_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8_DQUOTE] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3070),
    [sym_true] = ACTIONS(3068),
    [sym_false] = ACTIONS(3068),
    [anon_sym_NULL] = ACTIONS(3068),
    [anon_sym_nullptr] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_try] = ACTIONS(3068),
    [anon_sym_delete] = ACTIONS(3068),
    [anon_sym_throw] = ACTIONS(3068),
    [anon_sym_namespace] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
    [anon_sym_concept] = ACTIONS(3068),
    [anon_sym_co_return] = ACTIONS(3068),
    [anon_sym_co_yield] = ACTIONS(3068),
    [anon_sym_R_DQUOTE] = ACTIONS(3070),
    [anon_sym_LR_DQUOTE] = ACTIONS(3070),
    [anon_sym_uR_DQUOTE] = ACTIONS(3070),
    [anon_sym_UR_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3070),
    [anon_sym_co_await] = ACTIONS(3068),
    [anon_sym_new] = ACTIONS(3068),
    [anon_sym_requires] = ACTIONS(3068),
    [sym_this] = ACTIONS(3068),
  },
  [499] = {
    [sym_identifier] = ACTIONS(3064),
    [aux_sym_preproc_include_token1] = ACTIONS(3064),
    [aux_sym_preproc_def_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token2] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [aux_sym_preproc_else_token1] = ACTIONS(3064),
    [aux_sym_preproc_elif_token1] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3064),
    [anon_sym_LPAREN2] = ACTIONS(3066),
    [anon_sym_BANG] = ACTIONS(3066),
    [anon_sym_TILDE] = ACTIONS(3066),
    [anon_sym_DASH] = ACTIONS(3064),
    [anon_sym_PLUS] = ACTIONS(3064),
    [anon_sym_STAR] = ACTIONS(3066),
    [anon_sym_AMP_AMP] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3064),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym___extension__] = ACTIONS(3064),
    [anon_sym_typedef] = ACTIONS(3064),
    [anon_sym_extern] = ACTIONS(3064),
    [anon_sym___attribute__] = ACTIONS(3064),
    [anon_sym_COLON_COLON] = ACTIONS(3066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3066),
    [anon_sym___declspec] = ACTIONS(3064),
    [anon_sym___based] = ACTIONS(3064),
    [anon_sym___cdecl] = ACTIONS(3064),
    [anon_sym___clrcall] = ACTIONS(3064),
    [anon_sym___stdcall] = ACTIONS(3064),
    [anon_sym___fastcall] = ACTIONS(3064),
    [anon_sym___thiscall] = ACTIONS(3064),
    [anon_sym___vectorcall] = ACTIONS(3064),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_signed] = ACTIONS(3064),
    [anon_sym_unsigned] = ACTIONS(3064),
    [anon_sym_long] = ACTIONS(3064),
    [anon_sym_short] = ACTIONS(3064),
    [anon_sym_LBRACK] = ACTIONS(3064),
    [anon_sym_static] = ACTIONS(3064),
    [anon_sym_register] = ACTIONS(3064),
    [anon_sym_inline] = ACTIONS(3064),
    [anon_sym___inline] = ACTIONS(3064),
    [anon_sym___inline__] = ACTIONS(3064),
    [anon_sym___forceinline] = ACTIONS(3064),
    [anon_sym_thread_local] = ACTIONS(3064),
    [anon_sym___thread] = ACTIONS(3064),
    [anon_sym_const] = ACTIONS(3064),
    [anon_sym_constexpr] = ACTIONS(3064),
    [anon_sym_volatile] = ACTIONS(3064),
    [anon_sym_restrict] = ACTIONS(3064),
    [anon_sym___restrict__] = ACTIONS(3064),
    [anon_sym__Atomic] = ACTIONS(3064),
    [anon_sym__Noreturn] = ACTIONS(3064),
    [anon_sym_noreturn] = ACTIONS(3064),
    [anon_sym_mutable] = ACTIONS(3064),
    [anon_sym_constinit] = ACTIONS(3064),
    [anon_sym_consteval] = ACTIONS(3064),
    [anon_sym_PROGMEM] = ACTIONS(3064),
    [aux_sym_primitive_type_token1] = ACTIONS(3064),
    [anon_sym_byte] = ACTIONS(3064),
    [anon_sym_word] = ACTIONS(3064),
    [anon_sym_enum] = ACTIONS(3064),
    [anon_sym_class] = ACTIONS(3064),
    [anon_sym_struct] = ACTIONS(3064),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_if] = ACTIONS(3064),
    [anon_sym_else] = ACTIONS(3064),
    [anon_sym_switch] = ACTIONS(3064),
    [anon_sym_case] = ACTIONS(3064),
    [anon_sym_default] = ACTIONS(3064),
    [anon_sym_while] = ACTIONS(3064),
    [anon_sym_do] = ACTIONS(3064),
    [anon_sym_for] = ACTIONS(3064),
    [anon_sym_return] = ACTIONS(3064),
    [anon_sym_break] = ACTIONS(3064),
    [anon_sym_continue] = ACTIONS(3064),
    [anon_sym_goto] = ACTIONS(3064),
    [anon_sym___try] = ACTIONS(3064),
    [anon_sym___leave] = ACTIONS(3064),
    [anon_sym_not] = ACTIONS(3064),
    [anon_sym_compl] = ACTIONS(3064),
    [anon_sym_DASH_DASH] = ACTIONS(3066),
    [anon_sym_PLUS_PLUS] = ACTIONS(3066),
    [anon_sym_sizeof] = ACTIONS(3064),
    [anon_sym___alignof__] = ACTIONS(3064),
    [anon_sym___alignof] = ACTIONS(3064),
    [anon_sym__alignof] = ACTIONS(3064),
    [anon_sym_alignof] = ACTIONS(3064),
    [anon_sym__Alignof] = ACTIONS(3064),
    [anon_sym_offsetof] = ACTIONS(3064),
    [anon_sym__Generic] = ACTIONS(3064),
    [anon_sym_asm] = ACTIONS(3064),
    [anon_sym___asm__] = ACTIONS(3064),
    [aux_sym_number_literal_token1] = ACTIONS(3066),
    [aux_sym_number_literal_token2] = ACTIONS(3064),
    [anon_sym_L_SQUOTE] = ACTIONS(3066),
    [anon_sym_u_SQUOTE] = ACTIONS(3066),
    [anon_sym_U_SQUOTE] = ACTIONS(3066),
    [anon_sym_u8_SQUOTE] = ACTIONS(3066),
    [anon_sym_SQUOTE] = ACTIONS(3066),
    [anon_sym_L_DQUOTE] = ACTIONS(3066),
    [anon_sym_u_DQUOTE] = ACTIONS(3066),
    [anon_sym_U_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8_DQUOTE] = ACTIONS(3066),
    [anon_sym_DQUOTE] = ACTIONS(3066),
    [sym_true] = ACTIONS(3064),
    [sym_false] = ACTIONS(3064),
    [anon_sym_NULL] = ACTIONS(3064),
    [anon_sym_nullptr] = ACTIONS(3064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3064),
    [anon_sym_decltype] = ACTIONS(3064),
    [anon_sym_virtual] = ACTIONS(3064),
    [anon_sym_alignas] = ACTIONS(3064),
    [anon_sym_explicit] = ACTIONS(3064),
    [anon_sym_typename] = ACTIONS(3064),
    [anon_sym_template] = ACTIONS(3064),
    [anon_sym_operator] = ACTIONS(3064),
    [anon_sym_try] = ACTIONS(3064),
    [anon_sym_delete] = ACTIONS(3064),
    [anon_sym_throw] = ACTIONS(3064),
    [anon_sym_namespace] = ACTIONS(3064),
    [anon_sym_using] = ACTIONS(3064),
    [anon_sym_static_assert] = ACTIONS(3064),
    [anon_sym_concept] = ACTIONS(3064),
    [anon_sym_co_return] = ACTIONS(3064),
    [anon_sym_co_yield] = ACTIONS(3064),
    [anon_sym_R_DQUOTE] = ACTIONS(3066),
    [anon_sym_LR_DQUOTE] = ACTIONS(3066),
    [anon_sym_uR_DQUOTE] = ACTIONS(3066),
    [anon_sym_UR_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3066),
    [anon_sym_co_await] = ACTIONS(3064),
    [anon_sym_new] = ACTIONS(3064),
    [anon_sym_requires] = ACTIONS(3064),
    [sym_this] = ACTIONS(3064),
  },
  [500] = {
    [sym_identifier] = ACTIONS(3058),
    [aux_sym_preproc_include_token1] = ACTIONS(3058),
    [aux_sym_preproc_def_token1] = ACTIONS(3058),
    [aux_sym_preproc_if_token1] = ACTIONS(3058),
    [aux_sym_preproc_if_token2] = ACTIONS(3058),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3058),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3058),
    [aux_sym_preproc_else_token1] = ACTIONS(3058),
    [aux_sym_preproc_elif_token1] = ACTIONS(3058),
    [sym_preproc_directive] = ACTIONS(3058),
    [anon_sym_LPAREN2] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3060),
    [anon_sym_TILDE] = ACTIONS(3060),
    [anon_sym_DASH] = ACTIONS(3058),
    [anon_sym_PLUS] = ACTIONS(3058),
    [anon_sym_STAR] = ACTIONS(3060),
    [anon_sym_AMP_AMP] = ACTIONS(3060),
    [anon_sym_AMP] = ACTIONS(3058),
    [anon_sym_SEMI] = ACTIONS(3060),
    [anon_sym___extension__] = ACTIONS(3058),
    [anon_sym_typedef] = ACTIONS(3058),
    [anon_sym_extern] = ACTIONS(3058),
    [anon_sym___attribute__] = ACTIONS(3058),
    [anon_sym_COLON_COLON] = ACTIONS(3060),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3060),
    [anon_sym___declspec] = ACTIONS(3058),
    [anon_sym___based] = ACTIONS(3058),
    [anon_sym___cdecl] = ACTIONS(3058),
    [anon_sym___clrcall] = ACTIONS(3058),
    [anon_sym___stdcall] = ACTIONS(3058),
    [anon_sym___fastcall] = ACTIONS(3058),
    [anon_sym___thiscall] = ACTIONS(3058),
    [anon_sym___vectorcall] = ACTIONS(3058),
    [anon_sym_LBRACE] = ACTIONS(3060),
    [anon_sym_signed] = ACTIONS(3058),
    [anon_sym_unsigned] = ACTIONS(3058),
    [anon_sym_long] = ACTIONS(3058),
    [anon_sym_short] = ACTIONS(3058),
    [anon_sym_LBRACK] = ACTIONS(3058),
    [anon_sym_static] = ACTIONS(3058),
    [anon_sym_register] = ACTIONS(3058),
    [anon_sym_inline] = ACTIONS(3058),
    [anon_sym___inline] = ACTIONS(3058),
    [anon_sym___inline__] = ACTIONS(3058),
    [anon_sym___forceinline] = ACTIONS(3058),
    [anon_sym_thread_local] = ACTIONS(3058),
    [anon_sym___thread] = ACTIONS(3058),
    [anon_sym_const] = ACTIONS(3058),
    [anon_sym_constexpr] = ACTIONS(3058),
    [anon_sym_volatile] = ACTIONS(3058),
    [anon_sym_restrict] = ACTIONS(3058),
    [anon_sym___restrict__] = ACTIONS(3058),
    [anon_sym__Atomic] = ACTIONS(3058),
    [anon_sym__Noreturn] = ACTIONS(3058),
    [anon_sym_noreturn] = ACTIONS(3058),
    [anon_sym_mutable] = ACTIONS(3058),
    [anon_sym_constinit] = ACTIONS(3058),
    [anon_sym_consteval] = ACTIONS(3058),
    [anon_sym_PROGMEM] = ACTIONS(3058),
    [aux_sym_primitive_type_token1] = ACTIONS(3058),
    [anon_sym_byte] = ACTIONS(3058),
    [anon_sym_word] = ACTIONS(3058),
    [anon_sym_enum] = ACTIONS(3058),
    [anon_sym_class] = ACTIONS(3058),
    [anon_sym_struct] = ACTIONS(3058),
    [anon_sym_union] = ACTIONS(3058),
    [anon_sym_if] = ACTIONS(3058),
    [anon_sym_else] = ACTIONS(3058),
    [anon_sym_switch] = ACTIONS(3058),
    [anon_sym_case] = ACTIONS(3058),
    [anon_sym_default] = ACTIONS(3058),
    [anon_sym_while] = ACTIONS(3058),
    [anon_sym_do] = ACTIONS(3058),
    [anon_sym_for] = ACTIONS(3058),
    [anon_sym_return] = ACTIONS(3058),
    [anon_sym_break] = ACTIONS(3058),
    [anon_sym_continue] = ACTIONS(3058),
    [anon_sym_goto] = ACTIONS(3058),
    [anon_sym___try] = ACTIONS(3058),
    [anon_sym___leave] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3058),
    [anon_sym_compl] = ACTIONS(3058),
    [anon_sym_DASH_DASH] = ACTIONS(3060),
    [anon_sym_PLUS_PLUS] = ACTIONS(3060),
    [anon_sym_sizeof] = ACTIONS(3058),
    [anon_sym___alignof__] = ACTIONS(3058),
    [anon_sym___alignof] = ACTIONS(3058),
    [anon_sym__alignof] = ACTIONS(3058),
    [anon_sym_alignof] = ACTIONS(3058),
    [anon_sym__Alignof] = ACTIONS(3058),
    [anon_sym_offsetof] = ACTIONS(3058),
    [anon_sym__Generic] = ACTIONS(3058),
    [anon_sym_asm] = ACTIONS(3058),
    [anon_sym___asm__] = ACTIONS(3058),
    [aux_sym_number_literal_token1] = ACTIONS(3060),
    [aux_sym_number_literal_token2] = ACTIONS(3058),
    [anon_sym_L_SQUOTE] = ACTIONS(3060),
    [anon_sym_u_SQUOTE] = ACTIONS(3060),
    [anon_sym_U_SQUOTE] = ACTIONS(3060),
    [anon_sym_u8_SQUOTE] = ACTIONS(3060),
    [anon_sym_SQUOTE] = ACTIONS(3060),
    [anon_sym_L_DQUOTE] = ACTIONS(3060),
    [anon_sym_u_DQUOTE] = ACTIONS(3060),
    [anon_sym_U_DQUOTE] = ACTIONS(3060),
    [anon_sym_u8_DQUOTE] = ACTIONS(3060),
    [anon_sym_DQUOTE] = ACTIONS(3060),
    [sym_true] = ACTIONS(3058),
    [sym_false] = ACTIONS(3058),
    [anon_sym_NULL] = ACTIONS(3058),
    [anon_sym_nullptr] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3058),
    [anon_sym_decltype] = ACTIONS(3058),
    [anon_sym_virtual] = ACTIONS(3058),
    [anon_sym_alignas] = ACTIONS(3058),
    [anon_sym_explicit] = ACTIONS(3058),
    [anon_sym_typename] = ACTIONS(3058),
    [anon_sym_template] = ACTIONS(3058),
    [anon_sym_operator] = ACTIONS(3058),
    [anon_sym_try] = ACTIONS(3058),
    [anon_sym_delete] = ACTIONS(3058),
    [anon_sym_throw] = ACTIONS(3058),
    [anon_sym_namespace] = ACTIONS(3058),
    [anon_sym_using] = ACTIONS(3058),
    [anon_sym_static_assert] = ACTIONS(3058),
    [anon_sym_concept] = ACTIONS(3058),
    [anon_sym_co_return] = ACTIONS(3058),
    [anon_sym_co_yield] = ACTIONS(3058),
    [anon_sym_R_DQUOTE] = ACTIONS(3060),
    [anon_sym_LR_DQUOTE] = ACTIONS(3060),
    [anon_sym_uR_DQUOTE] = ACTIONS(3060),
    [anon_sym_UR_DQUOTE] = ACTIONS(3060),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3060),
    [anon_sym_co_await] = ACTIONS(3058),
    [anon_sym_new] = ACTIONS(3058),
    [anon_sym_requires] = ACTIONS(3058),
    [sym_this] = ACTIONS(3058),
  },
  [501] = {
    [sym_identifier] = ACTIONS(3054),
    [aux_sym_preproc_include_token1] = ACTIONS(3054),
    [aux_sym_preproc_def_token1] = ACTIONS(3054),
    [aux_sym_preproc_if_token1] = ACTIONS(3054),
    [aux_sym_preproc_if_token2] = ACTIONS(3054),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3054),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3054),
    [aux_sym_preproc_else_token1] = ACTIONS(3054),
    [aux_sym_preproc_elif_token1] = ACTIONS(3054),
    [sym_preproc_directive] = ACTIONS(3054),
    [anon_sym_LPAREN2] = ACTIONS(3056),
    [anon_sym_BANG] = ACTIONS(3056),
    [anon_sym_TILDE] = ACTIONS(3056),
    [anon_sym_DASH] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3056),
    [anon_sym_AMP_AMP] = ACTIONS(3056),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym___extension__] = ACTIONS(3054),
    [anon_sym_typedef] = ACTIONS(3054),
    [anon_sym_extern] = ACTIONS(3054),
    [anon_sym___attribute__] = ACTIONS(3054),
    [anon_sym_COLON_COLON] = ACTIONS(3056),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3056),
    [anon_sym___declspec] = ACTIONS(3054),
    [anon_sym___based] = ACTIONS(3054),
    [anon_sym___cdecl] = ACTIONS(3054),
    [anon_sym___clrcall] = ACTIONS(3054),
    [anon_sym___stdcall] = ACTIONS(3054),
    [anon_sym___fastcall] = ACTIONS(3054),
    [anon_sym___thiscall] = ACTIONS(3054),
    [anon_sym___vectorcall] = ACTIONS(3054),
    [anon_sym_LBRACE] = ACTIONS(3056),
    [anon_sym_signed] = ACTIONS(3054),
    [anon_sym_unsigned] = ACTIONS(3054),
    [anon_sym_long] = ACTIONS(3054),
    [anon_sym_short] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3054),
    [anon_sym_static] = ACTIONS(3054),
    [anon_sym_register] = ACTIONS(3054),
    [anon_sym_inline] = ACTIONS(3054),
    [anon_sym___inline] = ACTIONS(3054),
    [anon_sym___inline__] = ACTIONS(3054),
    [anon_sym___forceinline] = ACTIONS(3054),
    [anon_sym_thread_local] = ACTIONS(3054),
    [anon_sym___thread] = ACTIONS(3054),
    [anon_sym_const] = ACTIONS(3054),
    [anon_sym_constexpr] = ACTIONS(3054),
    [anon_sym_volatile] = ACTIONS(3054),
    [anon_sym_restrict] = ACTIONS(3054),
    [anon_sym___restrict__] = ACTIONS(3054),
    [anon_sym__Atomic] = ACTIONS(3054),
    [anon_sym__Noreturn] = ACTIONS(3054),
    [anon_sym_noreturn] = ACTIONS(3054),
    [anon_sym_mutable] = ACTIONS(3054),
    [anon_sym_constinit] = ACTIONS(3054),
    [anon_sym_consteval] = ACTIONS(3054),
    [anon_sym_PROGMEM] = ACTIONS(3054),
    [aux_sym_primitive_type_token1] = ACTIONS(3054),
    [anon_sym_byte] = ACTIONS(3054),
    [anon_sym_word] = ACTIONS(3054),
    [anon_sym_enum] = ACTIONS(3054),
    [anon_sym_class] = ACTIONS(3054),
    [anon_sym_struct] = ACTIONS(3054),
    [anon_sym_union] = ACTIONS(3054),
    [anon_sym_if] = ACTIONS(3054),
    [anon_sym_else] = ACTIONS(3054),
    [anon_sym_switch] = ACTIONS(3054),
    [anon_sym_case] = ACTIONS(3054),
    [anon_sym_default] = ACTIONS(3054),
    [anon_sym_while] = ACTIONS(3054),
    [anon_sym_do] = ACTIONS(3054),
    [anon_sym_for] = ACTIONS(3054),
    [anon_sym_return] = ACTIONS(3054),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_continue] = ACTIONS(3054),
    [anon_sym_goto] = ACTIONS(3054),
    [anon_sym___try] = ACTIONS(3054),
    [anon_sym___leave] = ACTIONS(3054),
    [anon_sym_not] = ACTIONS(3054),
    [anon_sym_compl] = ACTIONS(3054),
    [anon_sym_DASH_DASH] = ACTIONS(3056),
    [anon_sym_PLUS_PLUS] = ACTIONS(3056),
    [anon_sym_sizeof] = ACTIONS(3054),
    [anon_sym___alignof__] = ACTIONS(3054),
    [anon_sym___alignof] = ACTIONS(3054),
    [anon_sym__alignof] = ACTIONS(3054),
    [anon_sym_alignof] = ACTIONS(3054),
    [anon_sym__Alignof] = ACTIONS(3054),
    [anon_sym_offsetof] = ACTIONS(3054),
    [anon_sym__Generic] = ACTIONS(3054),
    [anon_sym_asm] = ACTIONS(3054),
    [anon_sym___asm__] = ACTIONS(3054),
    [aux_sym_number_literal_token1] = ACTIONS(3056),
    [aux_sym_number_literal_token2] = ACTIONS(3054),
    [anon_sym_L_SQUOTE] = ACTIONS(3056),
    [anon_sym_u_SQUOTE] = ACTIONS(3056),
    [anon_sym_U_SQUOTE] = ACTIONS(3056),
    [anon_sym_u8_SQUOTE] = ACTIONS(3056),
    [anon_sym_SQUOTE] = ACTIONS(3056),
    [anon_sym_L_DQUOTE] = ACTIONS(3056),
    [anon_sym_u_DQUOTE] = ACTIONS(3056),
    [anon_sym_U_DQUOTE] = ACTIONS(3056),
    [anon_sym_u8_DQUOTE] = ACTIONS(3056),
    [anon_sym_DQUOTE] = ACTIONS(3056),
    [sym_true] = ACTIONS(3054),
    [sym_false] = ACTIONS(3054),
    [anon_sym_NULL] = ACTIONS(3054),
    [anon_sym_nullptr] = ACTIONS(3054),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3054),
    [anon_sym_decltype] = ACTIONS(3054),
    [anon_sym_virtual] = ACTIONS(3054),
    [anon_sym_alignas] = ACTIONS(3054),
    [anon_sym_explicit] = ACTIONS(3054),
    [anon_sym_typename] = ACTIONS(3054),
    [anon_sym_template] = ACTIONS(3054),
    [anon_sym_operator] = ACTIONS(3054),
    [anon_sym_try] = ACTIONS(3054),
    [anon_sym_delete] = ACTIONS(3054),
    [anon_sym_throw] = ACTIONS(3054),
    [anon_sym_namespace] = ACTIONS(3054),
    [anon_sym_using] = ACTIONS(3054),
    [anon_sym_static_assert] = ACTIONS(3054),
    [anon_sym_concept] = ACTIONS(3054),
    [anon_sym_co_return] = ACTIONS(3054),
    [anon_sym_co_yield] = ACTIONS(3054),
    [anon_sym_R_DQUOTE] = ACTIONS(3056),
    [anon_sym_LR_DQUOTE] = ACTIONS(3056),
    [anon_sym_uR_DQUOTE] = ACTIONS(3056),
    [anon_sym_UR_DQUOTE] = ACTIONS(3056),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3056),
    [anon_sym_co_await] = ACTIONS(3054),
    [anon_sym_new] = ACTIONS(3054),
    [anon_sym_requires] = ACTIONS(3054),
    [sym_this] = ACTIONS(3054),
  },
  [502] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [503] = {
    [sym_identifier] = ACTIONS(3050),
    [aux_sym_preproc_include_token1] = ACTIONS(3050),
    [aux_sym_preproc_def_token1] = ACTIONS(3050),
    [aux_sym_preproc_if_token1] = ACTIONS(3050),
    [aux_sym_preproc_if_token2] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3050),
    [aux_sym_preproc_else_token1] = ACTIONS(3050),
    [aux_sym_preproc_elif_token1] = ACTIONS(3050),
    [sym_preproc_directive] = ACTIONS(3050),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3050),
    [anon_sym_PLUS] = ACTIONS(3050),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3050),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3050),
    [anon_sym_typedef] = ACTIONS(3050),
    [anon_sym_extern] = ACTIONS(3050),
    [anon_sym___attribute__] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3052),
    [anon_sym___declspec] = ACTIONS(3050),
    [anon_sym___based] = ACTIONS(3050),
    [anon_sym___cdecl] = ACTIONS(3050),
    [anon_sym___clrcall] = ACTIONS(3050),
    [anon_sym___stdcall] = ACTIONS(3050),
    [anon_sym___fastcall] = ACTIONS(3050),
    [anon_sym___thiscall] = ACTIONS(3050),
    [anon_sym___vectorcall] = ACTIONS(3050),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_signed] = ACTIONS(3050),
    [anon_sym_unsigned] = ACTIONS(3050),
    [anon_sym_long] = ACTIONS(3050),
    [anon_sym_short] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_static] = ACTIONS(3050),
    [anon_sym_register] = ACTIONS(3050),
    [anon_sym_inline] = ACTIONS(3050),
    [anon_sym___inline] = ACTIONS(3050),
    [anon_sym___inline__] = ACTIONS(3050),
    [anon_sym___forceinline] = ACTIONS(3050),
    [anon_sym_thread_local] = ACTIONS(3050),
    [anon_sym___thread] = ACTIONS(3050),
    [anon_sym_const] = ACTIONS(3050),
    [anon_sym_constexpr] = ACTIONS(3050),
    [anon_sym_volatile] = ACTIONS(3050),
    [anon_sym_restrict] = ACTIONS(3050),
    [anon_sym___restrict__] = ACTIONS(3050),
    [anon_sym__Atomic] = ACTIONS(3050),
    [anon_sym__Noreturn] = ACTIONS(3050),
    [anon_sym_noreturn] = ACTIONS(3050),
    [anon_sym_mutable] = ACTIONS(3050),
    [anon_sym_constinit] = ACTIONS(3050),
    [anon_sym_consteval] = ACTIONS(3050),
    [anon_sym_PROGMEM] = ACTIONS(3050),
    [aux_sym_primitive_type_token1] = ACTIONS(3050),
    [anon_sym_byte] = ACTIONS(3050),
    [anon_sym_word] = ACTIONS(3050),
    [anon_sym_enum] = ACTIONS(3050),
    [anon_sym_class] = ACTIONS(3050),
    [anon_sym_struct] = ACTIONS(3050),
    [anon_sym_union] = ACTIONS(3050),
    [anon_sym_if] = ACTIONS(3050),
    [anon_sym_else] = ACTIONS(3050),
    [anon_sym_switch] = ACTIONS(3050),
    [anon_sym_case] = ACTIONS(3050),
    [anon_sym_default] = ACTIONS(3050),
    [anon_sym_while] = ACTIONS(3050),
    [anon_sym_do] = ACTIONS(3050),
    [anon_sym_for] = ACTIONS(3050),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_break] = ACTIONS(3050),
    [anon_sym_continue] = ACTIONS(3050),
    [anon_sym_goto] = ACTIONS(3050),
    [anon_sym___try] = ACTIONS(3050),
    [anon_sym___leave] = ACTIONS(3050),
    [anon_sym_not] = ACTIONS(3050),
    [anon_sym_compl] = ACTIONS(3050),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_sizeof] = ACTIONS(3050),
    [anon_sym___alignof__] = ACTIONS(3050),
    [anon_sym___alignof] = ACTIONS(3050),
    [anon_sym__alignof] = ACTIONS(3050),
    [anon_sym_alignof] = ACTIONS(3050),
    [anon_sym__Alignof] = ACTIONS(3050),
    [anon_sym_offsetof] = ACTIONS(3050),
    [anon_sym__Generic] = ACTIONS(3050),
    [anon_sym_asm] = ACTIONS(3050),
    [anon_sym___asm__] = ACTIONS(3050),
    [aux_sym_number_literal_token1] = ACTIONS(3052),
    [aux_sym_number_literal_token2] = ACTIONS(3050),
    [anon_sym_L_SQUOTE] = ACTIONS(3052),
    [anon_sym_u_SQUOTE] = ACTIONS(3052),
    [anon_sym_U_SQUOTE] = ACTIONS(3052),
    [anon_sym_u8_SQUOTE] = ACTIONS(3052),
    [anon_sym_SQUOTE] = ACTIONS(3052),
    [anon_sym_L_DQUOTE] = ACTIONS(3052),
    [anon_sym_u_DQUOTE] = ACTIONS(3052),
    [anon_sym_U_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8_DQUOTE] = ACTIONS(3052),
    [anon_sym_DQUOTE] = ACTIONS(3052),
    [sym_true] = ACTIONS(3050),
    [sym_false] = ACTIONS(3050),
    [anon_sym_NULL] = ACTIONS(3050),
    [anon_sym_nullptr] = ACTIONS(3050),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3050),
    [anon_sym_decltype] = ACTIONS(3050),
    [anon_sym_virtual] = ACTIONS(3050),
    [anon_sym_alignas] = ACTIONS(3050),
    [anon_sym_explicit] = ACTIONS(3050),
    [anon_sym_typename] = ACTIONS(3050),
    [anon_sym_template] = ACTIONS(3050),
    [anon_sym_operator] = ACTIONS(3050),
    [anon_sym_try] = ACTIONS(3050),
    [anon_sym_delete] = ACTIONS(3050),
    [anon_sym_throw] = ACTIONS(3050),
    [anon_sym_namespace] = ACTIONS(3050),
    [anon_sym_using] = ACTIONS(3050),
    [anon_sym_static_assert] = ACTIONS(3050),
    [anon_sym_concept] = ACTIONS(3050),
    [anon_sym_co_return] = ACTIONS(3050),
    [anon_sym_co_yield] = ACTIONS(3050),
    [anon_sym_R_DQUOTE] = ACTIONS(3052),
    [anon_sym_LR_DQUOTE] = ACTIONS(3052),
    [anon_sym_uR_DQUOTE] = ACTIONS(3052),
    [anon_sym_UR_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3052),
    [anon_sym_co_await] = ACTIONS(3050),
    [anon_sym_new] = ACTIONS(3050),
    [anon_sym_requires] = ACTIONS(3050),
    [sym_this] = ACTIONS(3050),
  },
  [504] = {
    [sym_identifier] = ACTIONS(3046),
    [aux_sym_preproc_include_token1] = ACTIONS(3046),
    [aux_sym_preproc_def_token1] = ACTIONS(3046),
    [aux_sym_preproc_if_token1] = ACTIONS(3046),
    [aux_sym_preproc_if_token2] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3046),
    [aux_sym_preproc_else_token1] = ACTIONS(3046),
    [aux_sym_preproc_elif_token1] = ACTIONS(3046),
    [sym_preproc_directive] = ACTIONS(3046),
    [anon_sym_LPAREN2] = ACTIONS(3048),
    [anon_sym_BANG] = ACTIONS(3048),
    [anon_sym_TILDE] = ACTIONS(3048),
    [anon_sym_DASH] = ACTIONS(3046),
    [anon_sym_PLUS] = ACTIONS(3046),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_AMP_AMP] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3046),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym___extension__] = ACTIONS(3046),
    [anon_sym_typedef] = ACTIONS(3046),
    [anon_sym_extern] = ACTIONS(3046),
    [anon_sym___attribute__] = ACTIONS(3046),
    [anon_sym_COLON_COLON] = ACTIONS(3048),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3048),
    [anon_sym___declspec] = ACTIONS(3046),
    [anon_sym___based] = ACTIONS(3046),
    [anon_sym___cdecl] = ACTIONS(3046),
    [anon_sym___clrcall] = ACTIONS(3046),
    [anon_sym___stdcall] = ACTIONS(3046),
    [anon_sym___fastcall] = ACTIONS(3046),
    [anon_sym___thiscall] = ACTIONS(3046),
    [anon_sym___vectorcall] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3048),
    [anon_sym_signed] = ACTIONS(3046),
    [anon_sym_unsigned] = ACTIONS(3046),
    [anon_sym_long] = ACTIONS(3046),
    [anon_sym_short] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_static] = ACTIONS(3046),
    [anon_sym_register] = ACTIONS(3046),
    [anon_sym_inline] = ACTIONS(3046),
    [anon_sym___inline] = ACTIONS(3046),
    [anon_sym___inline__] = ACTIONS(3046),
    [anon_sym___forceinline] = ACTIONS(3046),
    [anon_sym_thread_local] = ACTIONS(3046),
    [anon_sym___thread] = ACTIONS(3046),
    [anon_sym_const] = ACTIONS(3046),
    [anon_sym_constexpr] = ACTIONS(3046),
    [anon_sym_volatile] = ACTIONS(3046),
    [anon_sym_restrict] = ACTIONS(3046),
    [anon_sym___restrict__] = ACTIONS(3046),
    [anon_sym__Atomic] = ACTIONS(3046),
    [anon_sym__Noreturn] = ACTIONS(3046),
    [anon_sym_noreturn] = ACTIONS(3046),
    [anon_sym_mutable] = ACTIONS(3046),
    [anon_sym_constinit] = ACTIONS(3046),
    [anon_sym_consteval] = ACTIONS(3046),
    [anon_sym_PROGMEM] = ACTIONS(3046),
    [aux_sym_primitive_type_token1] = ACTIONS(3046),
    [anon_sym_byte] = ACTIONS(3046),
    [anon_sym_word] = ACTIONS(3046),
    [anon_sym_enum] = ACTIONS(3046),
    [anon_sym_class] = ACTIONS(3046),
    [anon_sym_struct] = ACTIONS(3046),
    [anon_sym_union] = ACTIONS(3046),
    [anon_sym_if] = ACTIONS(3046),
    [anon_sym_else] = ACTIONS(3046),
    [anon_sym_switch] = ACTIONS(3046),
    [anon_sym_case] = ACTIONS(3046),
    [anon_sym_default] = ACTIONS(3046),
    [anon_sym_while] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_for] = ACTIONS(3046),
    [anon_sym_return] = ACTIONS(3046),
    [anon_sym_break] = ACTIONS(3046),
    [anon_sym_continue] = ACTIONS(3046),
    [anon_sym_goto] = ACTIONS(3046),
    [anon_sym___try] = ACTIONS(3046),
    [anon_sym___leave] = ACTIONS(3046),
    [anon_sym_not] = ACTIONS(3046),
    [anon_sym_compl] = ACTIONS(3046),
    [anon_sym_DASH_DASH] = ACTIONS(3048),
    [anon_sym_PLUS_PLUS] = ACTIONS(3048),
    [anon_sym_sizeof] = ACTIONS(3046),
    [anon_sym___alignof__] = ACTIONS(3046),
    [anon_sym___alignof] = ACTIONS(3046),
    [anon_sym__alignof] = ACTIONS(3046),
    [anon_sym_alignof] = ACTIONS(3046),
    [anon_sym__Alignof] = ACTIONS(3046),
    [anon_sym_offsetof] = ACTIONS(3046),
    [anon_sym__Generic] = ACTIONS(3046),
    [anon_sym_asm] = ACTIONS(3046),
    [anon_sym___asm__] = ACTIONS(3046),
    [aux_sym_number_literal_token1] = ACTIONS(3048),
    [aux_sym_number_literal_token2] = ACTIONS(3046),
    [anon_sym_L_SQUOTE] = ACTIONS(3048),
    [anon_sym_u_SQUOTE] = ACTIONS(3048),
    [anon_sym_U_SQUOTE] = ACTIONS(3048),
    [anon_sym_u8_SQUOTE] = ACTIONS(3048),
    [anon_sym_SQUOTE] = ACTIONS(3048),
    [anon_sym_L_DQUOTE] = ACTIONS(3048),
    [anon_sym_u_DQUOTE] = ACTIONS(3048),
    [anon_sym_U_DQUOTE] = ACTIONS(3048),
    [anon_sym_u8_DQUOTE] = ACTIONS(3048),
    [anon_sym_DQUOTE] = ACTIONS(3048),
    [sym_true] = ACTIONS(3046),
    [sym_false] = ACTIONS(3046),
    [anon_sym_NULL] = ACTIONS(3046),
    [anon_sym_nullptr] = ACTIONS(3046),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3046),
    [anon_sym_decltype] = ACTIONS(3046),
    [anon_sym_virtual] = ACTIONS(3046),
    [anon_sym_alignas] = ACTIONS(3046),
    [anon_sym_explicit] = ACTIONS(3046),
    [anon_sym_typename] = ACTIONS(3046),
    [anon_sym_template] = ACTIONS(3046),
    [anon_sym_operator] = ACTIONS(3046),
    [anon_sym_try] = ACTIONS(3046),
    [anon_sym_delete] = ACTIONS(3046),
    [anon_sym_throw] = ACTIONS(3046),
    [anon_sym_namespace] = ACTIONS(3046),
    [anon_sym_using] = ACTIONS(3046),
    [anon_sym_static_assert] = ACTIONS(3046),
    [anon_sym_concept] = ACTIONS(3046),
    [anon_sym_co_return] = ACTIONS(3046),
    [anon_sym_co_yield] = ACTIONS(3046),
    [anon_sym_R_DQUOTE] = ACTIONS(3048),
    [anon_sym_LR_DQUOTE] = ACTIONS(3048),
    [anon_sym_uR_DQUOTE] = ACTIONS(3048),
    [anon_sym_UR_DQUOTE] = ACTIONS(3048),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3048),
    [anon_sym_co_await] = ACTIONS(3046),
    [anon_sym_new] = ACTIONS(3046),
    [anon_sym_requires] = ACTIONS(3046),
    [sym_this] = ACTIONS(3046),
  },
  [505] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [506] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [507] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [508] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [509] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [510] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [511] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [512] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [513] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [514] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [515] = {
    [sym_catch_clause] = STATE(410),
    [aux_sym_constructor_try_statement_repeat1] = STATE(410),
    [sym_identifier] = ACTIONS(2856),
    [aux_sym_preproc_include_token1] = ACTIONS(2856),
    [aux_sym_preproc_def_token1] = ACTIONS(2856),
    [aux_sym_preproc_if_token1] = ACTIONS(2856),
    [aux_sym_preproc_if_token2] = ACTIONS(2856),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2856),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2856),
    [sym_preproc_directive] = ACTIONS(2856),
    [anon_sym_LPAREN2] = ACTIONS(2858),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2856),
    [anon_sym_PLUS] = ACTIONS(2856),
    [anon_sym_STAR] = ACTIONS(2858),
    [anon_sym_AMP_AMP] = ACTIONS(2858),
    [anon_sym_AMP] = ACTIONS(2856),
    [anon_sym_SEMI] = ACTIONS(2858),
    [anon_sym___extension__] = ACTIONS(2856),
    [anon_sym_typedef] = ACTIONS(2856),
    [anon_sym_extern] = ACTIONS(2856),
    [anon_sym___attribute__] = ACTIONS(2856),
    [anon_sym_COLON_COLON] = ACTIONS(2858),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2858),
    [anon_sym___declspec] = ACTIONS(2856),
    [anon_sym___based] = ACTIONS(2856),
    [anon_sym___cdecl] = ACTIONS(2856),
    [anon_sym___clrcall] = ACTIONS(2856),
    [anon_sym___stdcall] = ACTIONS(2856),
    [anon_sym___fastcall] = ACTIONS(2856),
    [anon_sym___thiscall] = ACTIONS(2856),
    [anon_sym___vectorcall] = ACTIONS(2856),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_signed] = ACTIONS(2856),
    [anon_sym_unsigned] = ACTIONS(2856),
    [anon_sym_long] = ACTIONS(2856),
    [anon_sym_short] = ACTIONS(2856),
    [anon_sym_LBRACK] = ACTIONS(2856),
    [anon_sym_static] = ACTIONS(2856),
    [anon_sym_register] = ACTIONS(2856),
    [anon_sym_inline] = ACTIONS(2856),
    [anon_sym___inline] = ACTIONS(2856),
    [anon_sym___inline__] = ACTIONS(2856),
    [anon_sym___forceinline] = ACTIONS(2856),
    [anon_sym_thread_local] = ACTIONS(2856),
    [anon_sym___thread] = ACTIONS(2856),
    [anon_sym_const] = ACTIONS(2856),
    [anon_sym_constexpr] = ACTIONS(2856),
    [anon_sym_volatile] = ACTIONS(2856),
    [anon_sym_restrict] = ACTIONS(2856),
    [anon_sym___restrict__] = ACTIONS(2856),
    [anon_sym__Atomic] = ACTIONS(2856),
    [anon_sym__Noreturn] = ACTIONS(2856),
    [anon_sym_noreturn] = ACTIONS(2856),
    [anon_sym_mutable] = ACTIONS(2856),
    [anon_sym_constinit] = ACTIONS(2856),
    [anon_sym_consteval] = ACTIONS(2856),
    [anon_sym_PROGMEM] = ACTIONS(2856),
    [aux_sym_primitive_type_token1] = ACTIONS(2856),
    [anon_sym_byte] = ACTIONS(2856),
    [anon_sym_word] = ACTIONS(2856),
    [anon_sym_enum] = ACTIONS(2856),
    [anon_sym_class] = ACTIONS(2856),
    [anon_sym_struct] = ACTIONS(2856),
    [anon_sym_union] = ACTIONS(2856),
    [anon_sym_if] = ACTIONS(2856),
    [anon_sym_switch] = ACTIONS(2856),
    [anon_sym_case] = ACTIONS(2856),
    [anon_sym_default] = ACTIONS(2856),
    [anon_sym_while] = ACTIONS(2856),
    [anon_sym_do] = ACTIONS(2856),
    [anon_sym_for] = ACTIONS(2856),
    [anon_sym_return] = ACTIONS(2856),
    [anon_sym_break] = ACTIONS(2856),
    [anon_sym_continue] = ACTIONS(2856),
    [anon_sym_goto] = ACTIONS(2856),
    [anon_sym___try] = ACTIONS(2856),
    [anon_sym___leave] = ACTIONS(2856),
    [anon_sym_not] = ACTIONS(2856),
    [anon_sym_compl] = ACTIONS(2856),
    [anon_sym_DASH_DASH] = ACTIONS(2858),
    [anon_sym_PLUS_PLUS] = ACTIONS(2858),
    [anon_sym_sizeof] = ACTIONS(2856),
    [anon_sym___alignof__] = ACTIONS(2856),
    [anon_sym___alignof] = ACTIONS(2856),
    [anon_sym__alignof] = ACTIONS(2856),
    [anon_sym_alignof] = ACTIONS(2856),
    [anon_sym__Alignof] = ACTIONS(2856),
    [anon_sym_offsetof] = ACTIONS(2856),
    [anon_sym__Generic] = ACTIONS(2856),
    [anon_sym_asm] = ACTIONS(2856),
    [anon_sym___asm__] = ACTIONS(2856),
    [aux_sym_number_literal_token1] = ACTIONS(2858),
    [aux_sym_number_literal_token2] = ACTIONS(2856),
    [anon_sym_L_SQUOTE] = ACTIONS(2858),
    [anon_sym_u_SQUOTE] = ACTIONS(2858),
    [anon_sym_U_SQUOTE] = ACTIONS(2858),
    [anon_sym_u8_SQUOTE] = ACTIONS(2858),
    [anon_sym_SQUOTE] = ACTIONS(2858),
    [anon_sym_L_DQUOTE] = ACTIONS(2858),
    [anon_sym_u_DQUOTE] = ACTIONS(2858),
    [anon_sym_U_DQUOTE] = ACTIONS(2858),
    [anon_sym_u8_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE] = ACTIONS(2858),
    [sym_true] = ACTIONS(2856),
    [sym_false] = ACTIONS(2856),
    [anon_sym_NULL] = ACTIONS(2856),
    [anon_sym_nullptr] = ACTIONS(2856),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2856),
    [anon_sym_decltype] = ACTIONS(2856),
    [anon_sym_virtual] = ACTIONS(2856),
    [anon_sym_alignas] = ACTIONS(2856),
    [anon_sym_explicit] = ACTIONS(2856),
    [anon_sym_typename] = ACTIONS(2856),
    [anon_sym_template] = ACTIONS(2856),
    [anon_sym_operator] = ACTIONS(2856),
    [anon_sym_try] = ACTIONS(2856),
    [anon_sym_delete] = ACTIONS(2856),
    [anon_sym_throw] = ACTIONS(2856),
    [anon_sym_namespace] = ACTIONS(2856),
    [anon_sym_using] = ACTIONS(2856),
    [anon_sym_static_assert] = ACTIONS(2856),
    [anon_sym_concept] = ACTIONS(2856),
    [anon_sym_co_return] = ACTIONS(2856),
    [anon_sym_co_yield] = ACTIONS(2856),
    [anon_sym_catch] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_LR_DQUOTE] = ACTIONS(2858),
    [anon_sym_uR_DQUOTE] = ACTIONS(2858),
    [anon_sym_UR_DQUOTE] = ACTIONS(2858),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2858),
    [anon_sym_co_await] = ACTIONS(2856),
    [anon_sym_new] = ACTIONS(2856),
    [anon_sym_requires] = ACTIONS(2856),
    [sym_this] = ACTIONS(2856),
  },
  [516] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [517] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [518] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_include_token1] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token2] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [aux_sym_preproc_else_token1] = ACTIONS(3082),
    [aux_sym_preproc_elif_token1] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym___cdecl] = ACTIONS(3082),
    [anon_sym___clrcall] = ACTIONS(3082),
    [anon_sym___stdcall] = ACTIONS(3082),
    [anon_sym___fastcall] = ACTIONS(3082),
    [anon_sym___thiscall] = ACTIONS(3082),
    [anon_sym___vectorcall] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_else] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_goto] = ACTIONS(3082),
    [anon_sym___try] = ACTIONS(3082),
    [anon_sym___leave] = ACTIONS(3082),
    [anon_sym_not] = ACTIONS(3082),
    [anon_sym_compl] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_sizeof] = ACTIONS(3082),
    [anon_sym___alignof__] = ACTIONS(3082),
    [anon_sym___alignof] = ACTIONS(3082),
    [anon_sym__alignof] = ACTIONS(3082),
    [anon_sym_alignof] = ACTIONS(3082),
    [anon_sym__Alignof] = ACTIONS(3082),
    [anon_sym_offsetof] = ACTIONS(3082),
    [anon_sym__Generic] = ACTIONS(3082),
    [anon_sym_asm] = ACTIONS(3082),
    [anon_sym___asm__] = ACTIONS(3082),
    [aux_sym_number_literal_token1] = ACTIONS(3084),
    [aux_sym_number_literal_token2] = ACTIONS(3082),
    [anon_sym_L_SQUOTE] = ACTIONS(3084),
    [anon_sym_u_SQUOTE] = ACTIONS(3084),
    [anon_sym_U_SQUOTE] = ACTIONS(3084),
    [anon_sym_u8_SQUOTE] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_L_DQUOTE] = ACTIONS(3084),
    [anon_sym_u_DQUOTE] = ACTIONS(3084),
    [anon_sym_U_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8_DQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [anon_sym_NULL] = ACTIONS(3082),
    [anon_sym_nullptr] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
    [anon_sym_concept] = ACTIONS(3082),
    [anon_sym_co_return] = ACTIONS(3082),
    [anon_sym_co_yield] = ACTIONS(3082),
    [anon_sym_R_DQUOTE] = ACTIONS(3084),
    [anon_sym_LR_DQUOTE] = ACTIONS(3084),
    [anon_sym_uR_DQUOTE] = ACTIONS(3084),
    [anon_sym_UR_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3084),
    [anon_sym_co_await] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_requires] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
  },
  [519] = {
    [sym_identifier] = ACTIONS(3086),
    [aux_sym_preproc_include_token1] = ACTIONS(3086),
    [aux_sym_preproc_def_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token2] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3086),
    [aux_sym_preproc_else_token1] = ACTIONS(3086),
    [aux_sym_preproc_elif_token1] = ACTIONS(3086),
    [sym_preproc_directive] = ACTIONS(3086),
    [anon_sym_LPAREN2] = ACTIONS(3088),
    [anon_sym_BANG] = ACTIONS(3088),
    [anon_sym_TILDE] = ACTIONS(3088),
    [anon_sym_DASH] = ACTIONS(3086),
    [anon_sym_PLUS] = ACTIONS(3086),
    [anon_sym_STAR] = ACTIONS(3088),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym_SEMI] = ACTIONS(3088),
    [anon_sym___extension__] = ACTIONS(3086),
    [anon_sym_typedef] = ACTIONS(3086),
    [anon_sym_extern] = ACTIONS(3086),
    [anon_sym___attribute__] = ACTIONS(3086),
    [anon_sym_COLON_COLON] = ACTIONS(3088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3088),
    [anon_sym___declspec] = ACTIONS(3086),
    [anon_sym___based] = ACTIONS(3086),
    [anon_sym___cdecl] = ACTIONS(3086),
    [anon_sym___clrcall] = ACTIONS(3086),
    [anon_sym___stdcall] = ACTIONS(3086),
    [anon_sym___fastcall] = ACTIONS(3086),
    [anon_sym___thiscall] = ACTIONS(3086),
    [anon_sym___vectorcall] = ACTIONS(3086),
    [anon_sym_LBRACE] = ACTIONS(3088),
    [anon_sym_signed] = ACTIONS(3086),
    [anon_sym_unsigned] = ACTIONS(3086),
    [anon_sym_long] = ACTIONS(3086),
    [anon_sym_short] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(3086),
    [anon_sym_static] = ACTIONS(3086),
    [anon_sym_register] = ACTIONS(3086),
    [anon_sym_inline] = ACTIONS(3086),
    [anon_sym___inline] = ACTIONS(3086),
    [anon_sym___inline__] = ACTIONS(3086),
    [anon_sym___forceinline] = ACTIONS(3086),
    [anon_sym_thread_local] = ACTIONS(3086),
    [anon_sym___thread] = ACTIONS(3086),
    [anon_sym_const] = ACTIONS(3086),
    [anon_sym_constexpr] = ACTIONS(3086),
    [anon_sym_volatile] = ACTIONS(3086),
    [anon_sym_restrict] = ACTIONS(3086),
    [anon_sym___restrict__] = ACTIONS(3086),
    [anon_sym__Atomic] = ACTIONS(3086),
    [anon_sym__Noreturn] = ACTIONS(3086),
    [anon_sym_noreturn] = ACTIONS(3086),
    [anon_sym_mutable] = ACTIONS(3086),
    [anon_sym_constinit] = ACTIONS(3086),
    [anon_sym_consteval] = ACTIONS(3086),
    [anon_sym_PROGMEM] = ACTIONS(3086),
    [aux_sym_primitive_type_token1] = ACTIONS(3086),
    [anon_sym_byte] = ACTIONS(3086),
    [anon_sym_word] = ACTIONS(3086),
    [anon_sym_enum] = ACTIONS(3086),
    [anon_sym_class] = ACTIONS(3086),
    [anon_sym_struct] = ACTIONS(3086),
    [anon_sym_union] = ACTIONS(3086),
    [anon_sym_if] = ACTIONS(3086),
    [anon_sym_else] = ACTIONS(3086),
    [anon_sym_switch] = ACTIONS(3086),
    [anon_sym_case] = ACTIONS(3086),
    [anon_sym_default] = ACTIONS(3086),
    [anon_sym_while] = ACTIONS(3086),
    [anon_sym_do] = ACTIONS(3086),
    [anon_sym_for] = ACTIONS(3086),
    [anon_sym_return] = ACTIONS(3086),
    [anon_sym_break] = ACTIONS(3086),
    [anon_sym_continue] = ACTIONS(3086),
    [anon_sym_goto] = ACTIONS(3086),
    [anon_sym___try] = ACTIONS(3086),
    [anon_sym___leave] = ACTIONS(3086),
    [anon_sym_not] = ACTIONS(3086),
    [anon_sym_compl] = ACTIONS(3086),
    [anon_sym_DASH_DASH] = ACTIONS(3088),
    [anon_sym_PLUS_PLUS] = ACTIONS(3088),
    [anon_sym_sizeof] = ACTIONS(3086),
    [anon_sym___alignof__] = ACTIONS(3086),
    [anon_sym___alignof] = ACTIONS(3086),
    [anon_sym__alignof] = ACTIONS(3086),
    [anon_sym_alignof] = ACTIONS(3086),
    [anon_sym__Alignof] = ACTIONS(3086),
    [anon_sym_offsetof] = ACTIONS(3086),
    [anon_sym__Generic] = ACTIONS(3086),
    [anon_sym_asm] = ACTIONS(3086),
    [anon_sym___asm__] = ACTIONS(3086),
    [aux_sym_number_literal_token1] = ACTIONS(3088),
    [aux_sym_number_literal_token2] = ACTIONS(3086),
    [anon_sym_L_SQUOTE] = ACTIONS(3088),
    [anon_sym_u_SQUOTE] = ACTIONS(3088),
    [anon_sym_U_SQUOTE] = ACTIONS(3088),
    [anon_sym_u8_SQUOTE] = ACTIONS(3088),
    [anon_sym_SQUOTE] = ACTIONS(3088),
    [anon_sym_L_DQUOTE] = ACTIONS(3088),
    [anon_sym_u_DQUOTE] = ACTIONS(3088),
    [anon_sym_U_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8_DQUOTE] = ACTIONS(3088),
    [anon_sym_DQUOTE] = ACTIONS(3088),
    [sym_true] = ACTIONS(3086),
    [sym_false] = ACTIONS(3086),
    [anon_sym_NULL] = ACTIONS(3086),
    [anon_sym_nullptr] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3086),
    [anon_sym_decltype] = ACTIONS(3086),
    [anon_sym_virtual] = ACTIONS(3086),
    [anon_sym_alignas] = ACTIONS(3086),
    [anon_sym_explicit] = ACTIONS(3086),
    [anon_sym_typename] = ACTIONS(3086),
    [anon_sym_template] = ACTIONS(3086),
    [anon_sym_operator] = ACTIONS(3086),
    [anon_sym_try] = ACTIONS(3086),
    [anon_sym_delete] = ACTIONS(3086),
    [anon_sym_throw] = ACTIONS(3086),
    [anon_sym_namespace] = ACTIONS(3086),
    [anon_sym_using] = ACTIONS(3086),
    [anon_sym_static_assert] = ACTIONS(3086),
    [anon_sym_concept] = ACTIONS(3086),
    [anon_sym_co_return] = ACTIONS(3086),
    [anon_sym_co_yield] = ACTIONS(3086),
    [anon_sym_R_DQUOTE] = ACTIONS(3088),
    [anon_sym_LR_DQUOTE] = ACTIONS(3088),
    [anon_sym_uR_DQUOTE] = ACTIONS(3088),
    [anon_sym_UR_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3088),
    [anon_sym_co_await] = ACTIONS(3086),
    [anon_sym_new] = ACTIONS(3086),
    [anon_sym_requires] = ACTIONS(3086),
    [sym_this] = ACTIONS(3086),
  },
  [520] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [521] = {
    [sym_identifier] = ACTIONS(3138),
    [aux_sym_preproc_include_token1] = ACTIONS(3138),
    [aux_sym_preproc_def_token1] = ACTIONS(3138),
    [aux_sym_preproc_if_token1] = ACTIONS(3138),
    [aux_sym_preproc_if_token2] = ACTIONS(3138),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3138),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3138),
    [aux_sym_preproc_else_token1] = ACTIONS(3138),
    [aux_sym_preproc_elif_token1] = ACTIONS(3138),
    [sym_preproc_directive] = ACTIONS(3138),
    [anon_sym_LPAREN2] = ACTIONS(3140),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [anon_sym_DASH] = ACTIONS(3138),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_STAR] = ACTIONS(3140),
    [anon_sym_AMP_AMP] = ACTIONS(3140),
    [anon_sym_AMP] = ACTIONS(3138),
    [anon_sym_SEMI] = ACTIONS(3140),
    [anon_sym___extension__] = ACTIONS(3138),
    [anon_sym_typedef] = ACTIONS(3138),
    [anon_sym_extern] = ACTIONS(3138),
    [anon_sym___attribute__] = ACTIONS(3138),
    [anon_sym_COLON_COLON] = ACTIONS(3140),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3140),
    [anon_sym___declspec] = ACTIONS(3138),
    [anon_sym___based] = ACTIONS(3138),
    [anon_sym___cdecl] = ACTIONS(3138),
    [anon_sym___clrcall] = ACTIONS(3138),
    [anon_sym___stdcall] = ACTIONS(3138),
    [anon_sym___fastcall] = ACTIONS(3138),
    [anon_sym___thiscall] = ACTIONS(3138),
    [anon_sym___vectorcall] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [anon_sym_signed] = ACTIONS(3138),
    [anon_sym_unsigned] = ACTIONS(3138),
    [anon_sym_long] = ACTIONS(3138),
    [anon_sym_short] = ACTIONS(3138),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_static] = ACTIONS(3138),
    [anon_sym_register] = ACTIONS(3138),
    [anon_sym_inline] = ACTIONS(3138),
    [anon_sym___inline] = ACTIONS(3138),
    [anon_sym___inline__] = ACTIONS(3138),
    [anon_sym___forceinline] = ACTIONS(3138),
    [anon_sym_thread_local] = ACTIONS(3138),
    [anon_sym___thread] = ACTIONS(3138),
    [anon_sym_const] = ACTIONS(3138),
    [anon_sym_constexpr] = ACTIONS(3138),
    [anon_sym_volatile] = ACTIONS(3138),
    [anon_sym_restrict] = ACTIONS(3138),
    [anon_sym___restrict__] = ACTIONS(3138),
    [anon_sym__Atomic] = ACTIONS(3138),
    [anon_sym__Noreturn] = ACTIONS(3138),
    [anon_sym_noreturn] = ACTIONS(3138),
    [anon_sym_mutable] = ACTIONS(3138),
    [anon_sym_constinit] = ACTIONS(3138),
    [anon_sym_consteval] = ACTIONS(3138),
    [anon_sym_PROGMEM] = ACTIONS(3138),
    [aux_sym_primitive_type_token1] = ACTIONS(3138),
    [anon_sym_byte] = ACTIONS(3138),
    [anon_sym_word] = ACTIONS(3138),
    [anon_sym_enum] = ACTIONS(3138),
    [anon_sym_class] = ACTIONS(3138),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3138),
    [anon_sym_if] = ACTIONS(3138),
    [anon_sym_else] = ACTIONS(3138),
    [anon_sym_switch] = ACTIONS(3138),
    [anon_sym_case] = ACTIONS(3138),
    [anon_sym_default] = ACTIONS(3138),
    [anon_sym_while] = ACTIONS(3138),
    [anon_sym_do] = ACTIONS(3138),
    [anon_sym_for] = ACTIONS(3138),
    [anon_sym_return] = ACTIONS(3138),
    [anon_sym_break] = ACTIONS(3138),
    [anon_sym_continue] = ACTIONS(3138),
    [anon_sym_goto] = ACTIONS(3138),
    [anon_sym___try] = ACTIONS(3138),
    [anon_sym___leave] = ACTIONS(3138),
    [anon_sym_not] = ACTIONS(3138),
    [anon_sym_compl] = ACTIONS(3138),
    [anon_sym_DASH_DASH] = ACTIONS(3140),
    [anon_sym_PLUS_PLUS] = ACTIONS(3140),
    [anon_sym_sizeof] = ACTIONS(3138),
    [anon_sym___alignof__] = ACTIONS(3138),
    [anon_sym___alignof] = ACTIONS(3138),
    [anon_sym__alignof] = ACTIONS(3138),
    [anon_sym_alignof] = ACTIONS(3138),
    [anon_sym__Alignof] = ACTIONS(3138),
    [anon_sym_offsetof] = ACTIONS(3138),
    [anon_sym__Generic] = ACTIONS(3138),
    [anon_sym_asm] = ACTIONS(3138),
    [anon_sym___asm__] = ACTIONS(3138),
    [aux_sym_number_literal_token1] = ACTIONS(3140),
    [aux_sym_number_literal_token2] = ACTIONS(3138),
    [anon_sym_L_SQUOTE] = ACTIONS(3140),
    [anon_sym_u_SQUOTE] = ACTIONS(3140),
    [anon_sym_U_SQUOTE] = ACTIONS(3140),
    [anon_sym_u8_SQUOTE] = ACTIONS(3140),
    [anon_sym_SQUOTE] = ACTIONS(3140),
    [anon_sym_L_DQUOTE] = ACTIONS(3140),
    [anon_sym_u_DQUOTE] = ACTIONS(3140),
    [anon_sym_U_DQUOTE] = ACTIONS(3140),
    [anon_sym_u8_DQUOTE] = ACTIONS(3140),
    [anon_sym_DQUOTE] = ACTIONS(3140),
    [sym_true] = ACTIONS(3138),
    [sym_false] = ACTIONS(3138),
    [anon_sym_NULL] = ACTIONS(3138),
    [anon_sym_nullptr] = ACTIONS(3138),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3138),
    [anon_sym_decltype] = ACTIONS(3138),
    [anon_sym_virtual] = ACTIONS(3138),
    [anon_sym_alignas] = ACTIONS(3138),
    [anon_sym_explicit] = ACTIONS(3138),
    [anon_sym_typename] = ACTIONS(3138),
    [anon_sym_template] = ACTIONS(3138),
    [anon_sym_operator] = ACTIONS(3138),
    [anon_sym_try] = ACTIONS(3138),
    [anon_sym_delete] = ACTIONS(3138),
    [anon_sym_throw] = ACTIONS(3138),
    [anon_sym_namespace] = ACTIONS(3138),
    [anon_sym_using] = ACTIONS(3138),
    [anon_sym_static_assert] = ACTIONS(3138),
    [anon_sym_concept] = ACTIONS(3138),
    [anon_sym_co_return] = ACTIONS(3138),
    [anon_sym_co_yield] = ACTIONS(3138),
    [anon_sym_R_DQUOTE] = ACTIONS(3140),
    [anon_sym_LR_DQUOTE] = ACTIONS(3140),
    [anon_sym_uR_DQUOTE] = ACTIONS(3140),
    [anon_sym_UR_DQUOTE] = ACTIONS(3140),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3140),
    [anon_sym_co_await] = ACTIONS(3138),
    [anon_sym_new] = ACTIONS(3138),
    [anon_sym_requires] = ACTIONS(3138),
    [sym_this] = ACTIONS(3138),
  },
  [522] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [523] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [524] = {
    [sym_identifier] = ACTIONS(2966),
    [aux_sym_preproc_include_token1] = ACTIONS(2966),
    [aux_sym_preproc_def_token1] = ACTIONS(2966),
    [aux_sym_preproc_if_token1] = ACTIONS(2966),
    [aux_sym_preproc_if_token2] = ACTIONS(2966),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2966),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2966),
    [aux_sym_preproc_else_token1] = ACTIONS(2966),
    [aux_sym_preproc_elif_token1] = ACTIONS(2966),
    [sym_preproc_directive] = ACTIONS(2966),
    [anon_sym_LPAREN2] = ACTIONS(2968),
    [anon_sym_BANG] = ACTIONS(2968),
    [anon_sym_TILDE] = ACTIONS(2968),
    [anon_sym_DASH] = ACTIONS(2966),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_STAR] = ACTIONS(2968),
    [anon_sym_AMP_AMP] = ACTIONS(2968),
    [anon_sym_AMP] = ACTIONS(2966),
    [anon_sym_SEMI] = ACTIONS(2968),
    [anon_sym___extension__] = ACTIONS(2966),
    [anon_sym_typedef] = ACTIONS(2966),
    [anon_sym_extern] = ACTIONS(2966),
    [anon_sym___attribute__] = ACTIONS(2966),
    [anon_sym_COLON_COLON] = ACTIONS(2968),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2968),
    [anon_sym___declspec] = ACTIONS(2966),
    [anon_sym___based] = ACTIONS(2966),
    [anon_sym___cdecl] = ACTIONS(2966),
    [anon_sym___clrcall] = ACTIONS(2966),
    [anon_sym___stdcall] = ACTIONS(2966),
    [anon_sym___fastcall] = ACTIONS(2966),
    [anon_sym___thiscall] = ACTIONS(2966),
    [anon_sym___vectorcall] = ACTIONS(2966),
    [anon_sym_LBRACE] = ACTIONS(2968),
    [anon_sym_signed] = ACTIONS(2966),
    [anon_sym_unsigned] = ACTIONS(2966),
    [anon_sym_long] = ACTIONS(2966),
    [anon_sym_short] = ACTIONS(2966),
    [anon_sym_LBRACK] = ACTIONS(2966),
    [anon_sym_static] = ACTIONS(2966),
    [anon_sym_register] = ACTIONS(2966),
    [anon_sym_inline] = ACTIONS(2966),
    [anon_sym___inline] = ACTIONS(2966),
    [anon_sym___inline__] = ACTIONS(2966),
    [anon_sym___forceinline] = ACTIONS(2966),
    [anon_sym_thread_local] = ACTIONS(2966),
    [anon_sym___thread] = ACTIONS(2966),
    [anon_sym_const] = ACTIONS(2966),
    [anon_sym_constexpr] = ACTIONS(2966),
    [anon_sym_volatile] = ACTIONS(2966),
    [anon_sym_restrict] = ACTIONS(2966),
    [anon_sym___restrict__] = ACTIONS(2966),
    [anon_sym__Atomic] = ACTIONS(2966),
    [anon_sym__Noreturn] = ACTIONS(2966),
    [anon_sym_noreturn] = ACTIONS(2966),
    [anon_sym_mutable] = ACTIONS(2966),
    [anon_sym_constinit] = ACTIONS(2966),
    [anon_sym_consteval] = ACTIONS(2966),
    [anon_sym_PROGMEM] = ACTIONS(2966),
    [aux_sym_primitive_type_token1] = ACTIONS(2966),
    [anon_sym_byte] = ACTIONS(2966),
    [anon_sym_word] = ACTIONS(2966),
    [anon_sym_enum] = ACTIONS(2966),
    [anon_sym_class] = ACTIONS(2966),
    [anon_sym_struct] = ACTIONS(2966),
    [anon_sym_union] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_else] = ACTIONS(2966),
    [anon_sym_switch] = ACTIONS(2966),
    [anon_sym_case] = ACTIONS(2966),
    [anon_sym_default] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_for] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2966),
    [anon_sym_break] = ACTIONS(2966),
    [anon_sym_continue] = ACTIONS(2966),
    [anon_sym_goto] = ACTIONS(2966),
    [anon_sym___try] = ACTIONS(2966),
    [anon_sym___leave] = ACTIONS(2966),
    [anon_sym_not] = ACTIONS(2966),
    [anon_sym_compl] = ACTIONS(2966),
    [anon_sym_DASH_DASH] = ACTIONS(2968),
    [anon_sym_PLUS_PLUS] = ACTIONS(2968),
    [anon_sym_sizeof] = ACTIONS(2966),
    [anon_sym___alignof__] = ACTIONS(2966),
    [anon_sym___alignof] = ACTIONS(2966),
    [anon_sym__alignof] = ACTIONS(2966),
    [anon_sym_alignof] = ACTIONS(2966),
    [anon_sym__Alignof] = ACTIONS(2966),
    [anon_sym_offsetof] = ACTIONS(2966),
    [anon_sym__Generic] = ACTIONS(2966),
    [anon_sym_asm] = ACTIONS(2966),
    [anon_sym___asm__] = ACTIONS(2966),
    [aux_sym_number_literal_token1] = ACTIONS(2968),
    [aux_sym_number_literal_token2] = ACTIONS(2966),
    [anon_sym_L_SQUOTE] = ACTIONS(2968),
    [anon_sym_u_SQUOTE] = ACTIONS(2968),
    [anon_sym_U_SQUOTE] = ACTIONS(2968),
    [anon_sym_u8_SQUOTE] = ACTIONS(2968),
    [anon_sym_SQUOTE] = ACTIONS(2968),
    [anon_sym_L_DQUOTE] = ACTIONS(2968),
    [anon_sym_u_DQUOTE] = ACTIONS(2968),
    [anon_sym_U_DQUOTE] = ACTIONS(2968),
    [anon_sym_u8_DQUOTE] = ACTIONS(2968),
    [anon_sym_DQUOTE] = ACTIONS(2968),
    [sym_true] = ACTIONS(2966),
    [sym_false] = ACTIONS(2966),
    [anon_sym_NULL] = ACTIONS(2966),
    [anon_sym_nullptr] = ACTIONS(2966),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2966),
    [anon_sym_decltype] = ACTIONS(2966),
    [anon_sym_virtual] = ACTIONS(2966),
    [anon_sym_alignas] = ACTIONS(2966),
    [anon_sym_explicit] = ACTIONS(2966),
    [anon_sym_typename] = ACTIONS(2966),
    [anon_sym_template] = ACTIONS(2966),
    [anon_sym_operator] = ACTIONS(2966),
    [anon_sym_try] = ACTIONS(2966),
    [anon_sym_delete] = ACTIONS(2966),
    [anon_sym_throw] = ACTIONS(2966),
    [anon_sym_namespace] = ACTIONS(2966),
    [anon_sym_using] = ACTIONS(2966),
    [anon_sym_static_assert] = ACTIONS(2966),
    [anon_sym_concept] = ACTIONS(2966),
    [anon_sym_co_return] = ACTIONS(2966),
    [anon_sym_co_yield] = ACTIONS(2966),
    [anon_sym_R_DQUOTE] = ACTIONS(2968),
    [anon_sym_LR_DQUOTE] = ACTIONS(2968),
    [anon_sym_uR_DQUOTE] = ACTIONS(2968),
    [anon_sym_UR_DQUOTE] = ACTIONS(2968),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2968),
    [anon_sym_co_await] = ACTIONS(2966),
    [anon_sym_new] = ACTIONS(2966),
    [anon_sym_requires] = ACTIONS(2966),
    [sym_this] = ACTIONS(2966),
  },
  [525] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_include_token1] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [anon_sym_COMMA] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token2] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [aux_sym_preproc_else_token1] = ACTIONS(2267),
    [aux_sym_preproc_elif_token1] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_BANG] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym___cdecl] = ACTIONS(2267),
    [anon_sym___clrcall] = ACTIONS(2267),
    [anon_sym___stdcall] = ACTIONS(2267),
    [anon_sym___fastcall] = ACTIONS(2267),
    [anon_sym___thiscall] = ACTIONS(2267),
    [anon_sym___vectorcall] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2265),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_case] = ACTIONS(2267),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_return] = ACTIONS(2267),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_continue] = ACTIONS(2267),
    [anon_sym_goto] = ACTIONS(2267),
    [anon_sym___try] = ACTIONS(2267),
    [anon_sym___leave] = ACTIONS(2267),
    [anon_sym_not] = ACTIONS(2267),
    [anon_sym_compl] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2265),
    [anon_sym_PLUS_PLUS] = ACTIONS(2265),
    [anon_sym_sizeof] = ACTIONS(2267),
    [anon_sym___alignof__] = ACTIONS(2267),
    [anon_sym___alignof] = ACTIONS(2267),
    [anon_sym__alignof] = ACTIONS(2267),
    [anon_sym_alignof] = ACTIONS(2267),
    [anon_sym__Alignof] = ACTIONS(2267),
    [anon_sym_offsetof] = ACTIONS(2267),
    [anon_sym__Generic] = ACTIONS(2267),
    [anon_sym_asm] = ACTIONS(2267),
    [anon_sym___asm__] = ACTIONS(2267),
    [aux_sym_number_literal_token1] = ACTIONS(2265),
    [aux_sym_number_literal_token2] = ACTIONS(2267),
    [anon_sym_L_SQUOTE] = ACTIONS(2265),
    [anon_sym_u_SQUOTE] = ACTIONS(2265),
    [anon_sym_U_SQUOTE] = ACTIONS(2265),
    [anon_sym_u8_SQUOTE] = ACTIONS(2265),
    [anon_sym_SQUOTE] = ACTIONS(2265),
    [anon_sym_L_DQUOTE] = ACTIONS(2265),
    [anon_sym_u_DQUOTE] = ACTIONS(2265),
    [anon_sym_U_DQUOTE] = ACTIONS(2265),
    [anon_sym_u8_DQUOTE] = ACTIONS(2265),
    [anon_sym_DQUOTE] = ACTIONS(2265),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [anon_sym_NULL] = ACTIONS(2267),
    [anon_sym_nullptr] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_try] = ACTIONS(2267),
    [anon_sym_delete] = ACTIONS(2267),
    [anon_sym_throw] = ACTIONS(2267),
    [anon_sym_namespace] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym_concept] = ACTIONS(2267),
    [anon_sym_co_return] = ACTIONS(2267),
    [anon_sym_co_yield] = ACTIONS(2267),
    [anon_sym_R_DQUOTE] = ACTIONS(2265),
    [anon_sym_LR_DQUOTE] = ACTIONS(2265),
    [anon_sym_uR_DQUOTE] = ACTIONS(2265),
    [anon_sym_UR_DQUOTE] = ACTIONS(2265),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2265),
    [anon_sym_co_await] = ACTIONS(2267),
    [anon_sym_new] = ACTIONS(2267),
    [anon_sym_requires] = ACTIONS(2267),
    [sym_this] = ACTIONS(2267),
  },
  [526] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [527] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [528] = {
    [sym_identifier] = ACTIONS(2962),
    [aux_sym_preproc_include_token1] = ACTIONS(2962),
    [aux_sym_preproc_def_token1] = ACTIONS(2962),
    [aux_sym_preproc_if_token1] = ACTIONS(2962),
    [aux_sym_preproc_if_token2] = ACTIONS(2962),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2962),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2962),
    [aux_sym_preproc_else_token1] = ACTIONS(2962),
    [aux_sym_preproc_elif_token1] = ACTIONS(2962),
    [sym_preproc_directive] = ACTIONS(2962),
    [anon_sym_LPAREN2] = ACTIONS(2964),
    [anon_sym_BANG] = ACTIONS(2964),
    [anon_sym_TILDE] = ACTIONS(2964),
    [anon_sym_DASH] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_STAR] = ACTIONS(2964),
    [anon_sym_AMP_AMP] = ACTIONS(2964),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_SEMI] = ACTIONS(2964),
    [anon_sym___extension__] = ACTIONS(2962),
    [anon_sym_typedef] = ACTIONS(2962),
    [anon_sym_extern] = ACTIONS(2962),
    [anon_sym___attribute__] = ACTIONS(2962),
    [anon_sym_COLON_COLON] = ACTIONS(2964),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2964),
    [anon_sym___declspec] = ACTIONS(2962),
    [anon_sym___based] = ACTIONS(2962),
    [anon_sym___cdecl] = ACTIONS(2962),
    [anon_sym___clrcall] = ACTIONS(2962),
    [anon_sym___stdcall] = ACTIONS(2962),
    [anon_sym___fastcall] = ACTIONS(2962),
    [anon_sym___thiscall] = ACTIONS(2962),
    [anon_sym___vectorcall] = ACTIONS(2962),
    [anon_sym_LBRACE] = ACTIONS(2964),
    [anon_sym_signed] = ACTIONS(2962),
    [anon_sym_unsigned] = ACTIONS(2962),
    [anon_sym_long] = ACTIONS(2962),
    [anon_sym_short] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_static] = ACTIONS(2962),
    [anon_sym_register] = ACTIONS(2962),
    [anon_sym_inline] = ACTIONS(2962),
    [anon_sym___inline] = ACTIONS(2962),
    [anon_sym___inline__] = ACTIONS(2962),
    [anon_sym___forceinline] = ACTIONS(2962),
    [anon_sym_thread_local] = ACTIONS(2962),
    [anon_sym___thread] = ACTIONS(2962),
    [anon_sym_const] = ACTIONS(2962),
    [anon_sym_constexpr] = ACTIONS(2962),
    [anon_sym_volatile] = ACTIONS(2962),
    [anon_sym_restrict] = ACTIONS(2962),
    [anon_sym___restrict__] = ACTIONS(2962),
    [anon_sym__Atomic] = ACTIONS(2962),
    [anon_sym__Noreturn] = ACTIONS(2962),
    [anon_sym_noreturn] = ACTIONS(2962),
    [anon_sym_mutable] = ACTIONS(2962),
    [anon_sym_constinit] = ACTIONS(2962),
    [anon_sym_consteval] = ACTIONS(2962),
    [anon_sym_PROGMEM] = ACTIONS(2962),
    [aux_sym_primitive_type_token1] = ACTIONS(2962),
    [anon_sym_byte] = ACTIONS(2962),
    [anon_sym_word] = ACTIONS(2962),
    [anon_sym_enum] = ACTIONS(2962),
    [anon_sym_class] = ACTIONS(2962),
    [anon_sym_struct] = ACTIONS(2962),
    [anon_sym_union] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_else] = ACTIONS(2962),
    [anon_sym_switch] = ACTIONS(2962),
    [anon_sym_case] = ACTIONS(2962),
    [anon_sym_default] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_for] = ACTIONS(2962),
    [anon_sym_return] = ACTIONS(2962),
    [anon_sym_break] = ACTIONS(2962),
    [anon_sym_continue] = ACTIONS(2962),
    [anon_sym_goto] = ACTIONS(2962),
    [anon_sym___try] = ACTIONS(2962),
    [anon_sym___leave] = ACTIONS(2962),
    [anon_sym_not] = ACTIONS(2962),
    [anon_sym_compl] = ACTIONS(2962),
    [anon_sym_DASH_DASH] = ACTIONS(2964),
    [anon_sym_PLUS_PLUS] = ACTIONS(2964),
    [anon_sym_sizeof] = ACTIONS(2962),
    [anon_sym___alignof__] = ACTIONS(2962),
    [anon_sym___alignof] = ACTIONS(2962),
    [anon_sym__alignof] = ACTIONS(2962),
    [anon_sym_alignof] = ACTIONS(2962),
    [anon_sym__Alignof] = ACTIONS(2962),
    [anon_sym_offsetof] = ACTIONS(2962),
    [anon_sym__Generic] = ACTIONS(2962),
    [anon_sym_asm] = ACTIONS(2962),
    [anon_sym___asm__] = ACTIONS(2962),
    [aux_sym_number_literal_token1] = ACTIONS(2964),
    [aux_sym_number_literal_token2] = ACTIONS(2962),
    [anon_sym_L_SQUOTE] = ACTIONS(2964),
    [anon_sym_u_SQUOTE] = ACTIONS(2964),
    [anon_sym_U_SQUOTE] = ACTIONS(2964),
    [anon_sym_u8_SQUOTE] = ACTIONS(2964),
    [anon_sym_SQUOTE] = ACTIONS(2964),
    [anon_sym_L_DQUOTE] = ACTIONS(2964),
    [anon_sym_u_DQUOTE] = ACTIONS(2964),
    [anon_sym_U_DQUOTE] = ACTIONS(2964),
    [anon_sym_u8_DQUOTE] = ACTIONS(2964),
    [anon_sym_DQUOTE] = ACTIONS(2964),
    [sym_true] = ACTIONS(2962),
    [sym_false] = ACTIONS(2962),
    [anon_sym_NULL] = ACTIONS(2962),
    [anon_sym_nullptr] = ACTIONS(2962),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2962),
    [anon_sym_decltype] = ACTIONS(2962),
    [anon_sym_virtual] = ACTIONS(2962),
    [anon_sym_alignas] = ACTIONS(2962),
    [anon_sym_explicit] = ACTIONS(2962),
    [anon_sym_typename] = ACTIONS(2962),
    [anon_sym_template] = ACTIONS(2962),
    [anon_sym_operator] = ACTIONS(2962),
    [anon_sym_try] = ACTIONS(2962),
    [anon_sym_delete] = ACTIONS(2962),
    [anon_sym_throw] = ACTIONS(2962),
    [anon_sym_namespace] = ACTIONS(2962),
    [anon_sym_using] = ACTIONS(2962),
    [anon_sym_static_assert] = ACTIONS(2962),
    [anon_sym_concept] = ACTIONS(2962),
    [anon_sym_co_return] = ACTIONS(2962),
    [anon_sym_co_yield] = ACTIONS(2962),
    [anon_sym_R_DQUOTE] = ACTIONS(2964),
    [anon_sym_LR_DQUOTE] = ACTIONS(2964),
    [anon_sym_uR_DQUOTE] = ACTIONS(2964),
    [anon_sym_UR_DQUOTE] = ACTIONS(2964),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2964),
    [anon_sym_co_await] = ACTIONS(2962),
    [anon_sym_new] = ACTIONS(2962),
    [anon_sym_requires] = ACTIONS(2962),
    [sym_this] = ACTIONS(2962),
  },
  [529] = {
    [sym_identifier] = ACTIONS(3162),
    [aux_sym_preproc_include_token1] = ACTIONS(3162),
    [aux_sym_preproc_def_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token2] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3162),
    [aux_sym_preproc_else_token1] = ACTIONS(3162),
    [aux_sym_preproc_elif_token1] = ACTIONS(3162),
    [sym_preproc_directive] = ACTIONS(3162),
    [anon_sym_LPAREN2] = ACTIONS(3164),
    [anon_sym_BANG] = ACTIONS(3164),
    [anon_sym_TILDE] = ACTIONS(3164),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_STAR] = ACTIONS(3164),
    [anon_sym_AMP_AMP] = ACTIONS(3164),
    [anon_sym_AMP] = ACTIONS(3162),
    [anon_sym_SEMI] = ACTIONS(3164),
    [anon_sym___extension__] = ACTIONS(3162),
    [anon_sym_typedef] = ACTIONS(3162),
    [anon_sym_extern] = ACTIONS(3162),
    [anon_sym___attribute__] = ACTIONS(3162),
    [anon_sym_COLON_COLON] = ACTIONS(3164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3164),
    [anon_sym___declspec] = ACTIONS(3162),
    [anon_sym___based] = ACTIONS(3162),
    [anon_sym___cdecl] = ACTIONS(3162),
    [anon_sym___clrcall] = ACTIONS(3162),
    [anon_sym___stdcall] = ACTIONS(3162),
    [anon_sym___fastcall] = ACTIONS(3162),
    [anon_sym___thiscall] = ACTIONS(3162),
    [anon_sym___vectorcall] = ACTIONS(3162),
    [anon_sym_LBRACE] = ACTIONS(3164),
    [anon_sym_signed] = ACTIONS(3162),
    [anon_sym_unsigned] = ACTIONS(3162),
    [anon_sym_long] = ACTIONS(3162),
    [anon_sym_short] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_register] = ACTIONS(3162),
    [anon_sym_inline] = ACTIONS(3162),
    [anon_sym___inline] = ACTIONS(3162),
    [anon_sym___inline__] = ACTIONS(3162),
    [anon_sym___forceinline] = ACTIONS(3162),
    [anon_sym_thread_local] = ACTIONS(3162),
    [anon_sym___thread] = ACTIONS(3162),
    [anon_sym_const] = ACTIONS(3162),
    [anon_sym_constexpr] = ACTIONS(3162),
    [anon_sym_volatile] = ACTIONS(3162),
    [anon_sym_restrict] = ACTIONS(3162),
    [anon_sym___restrict__] = ACTIONS(3162),
    [anon_sym__Atomic] = ACTIONS(3162),
    [anon_sym__Noreturn] = ACTIONS(3162),
    [anon_sym_noreturn] = ACTIONS(3162),
    [anon_sym_mutable] = ACTIONS(3162),
    [anon_sym_constinit] = ACTIONS(3162),
    [anon_sym_consteval] = ACTIONS(3162),
    [anon_sym_PROGMEM] = ACTIONS(3162),
    [aux_sym_primitive_type_token1] = ACTIONS(3162),
    [anon_sym_byte] = ACTIONS(3162),
    [anon_sym_word] = ACTIONS(3162),
    [anon_sym_enum] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_struct] = ACTIONS(3162),
    [anon_sym_union] = ACTIONS(3162),
    [anon_sym_if] = ACTIONS(3162),
    [anon_sym_else] = ACTIONS(3162),
    [anon_sym_switch] = ACTIONS(3162),
    [anon_sym_case] = ACTIONS(3162),
    [anon_sym_default] = ACTIONS(3162),
    [anon_sym_while] = ACTIONS(3162),
    [anon_sym_do] = ACTIONS(3162),
    [anon_sym_for] = ACTIONS(3162),
    [anon_sym_return] = ACTIONS(3162),
    [anon_sym_break] = ACTIONS(3162),
    [anon_sym_continue] = ACTIONS(3162),
    [anon_sym_goto] = ACTIONS(3162),
    [anon_sym___try] = ACTIONS(3162),
    [anon_sym___leave] = ACTIONS(3162),
    [anon_sym_not] = ACTIONS(3162),
    [anon_sym_compl] = ACTIONS(3162),
    [anon_sym_DASH_DASH] = ACTIONS(3164),
    [anon_sym_PLUS_PLUS] = ACTIONS(3164),
    [anon_sym_sizeof] = ACTIONS(3162),
    [anon_sym___alignof__] = ACTIONS(3162),
    [anon_sym___alignof] = ACTIONS(3162),
    [anon_sym__alignof] = ACTIONS(3162),
    [anon_sym_alignof] = ACTIONS(3162),
    [anon_sym__Alignof] = ACTIONS(3162),
    [anon_sym_offsetof] = ACTIONS(3162),
    [anon_sym__Generic] = ACTIONS(3162),
    [anon_sym_asm] = ACTIONS(3162),
    [anon_sym___asm__] = ACTIONS(3162),
    [aux_sym_number_literal_token1] = ACTIONS(3164),
    [aux_sym_number_literal_token2] = ACTIONS(3162),
    [anon_sym_L_SQUOTE] = ACTIONS(3164),
    [anon_sym_u_SQUOTE] = ACTIONS(3164),
    [anon_sym_U_SQUOTE] = ACTIONS(3164),
    [anon_sym_u8_SQUOTE] = ACTIONS(3164),
    [anon_sym_SQUOTE] = ACTIONS(3164),
    [anon_sym_L_DQUOTE] = ACTIONS(3164),
    [anon_sym_u_DQUOTE] = ACTIONS(3164),
    [anon_sym_U_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8_DQUOTE] = ACTIONS(3164),
    [anon_sym_DQUOTE] = ACTIONS(3164),
    [sym_true] = ACTIONS(3162),
    [sym_false] = ACTIONS(3162),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3162),
    [anon_sym_decltype] = ACTIONS(3162),
    [anon_sym_virtual] = ACTIONS(3162),
    [anon_sym_alignas] = ACTIONS(3162),
    [anon_sym_explicit] = ACTIONS(3162),
    [anon_sym_typename] = ACTIONS(3162),
    [anon_sym_template] = ACTIONS(3162),
    [anon_sym_operator] = ACTIONS(3162),
    [anon_sym_try] = ACTIONS(3162),
    [anon_sym_delete] = ACTIONS(3162),
    [anon_sym_throw] = ACTIONS(3162),
    [anon_sym_namespace] = ACTIONS(3162),
    [anon_sym_using] = ACTIONS(3162),
    [anon_sym_static_assert] = ACTIONS(3162),
    [anon_sym_concept] = ACTIONS(3162),
    [anon_sym_co_return] = ACTIONS(3162),
    [anon_sym_co_yield] = ACTIONS(3162),
    [anon_sym_R_DQUOTE] = ACTIONS(3164),
    [anon_sym_LR_DQUOTE] = ACTIONS(3164),
    [anon_sym_uR_DQUOTE] = ACTIONS(3164),
    [anon_sym_UR_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3164),
    [anon_sym_co_await] = ACTIONS(3162),
    [anon_sym_new] = ACTIONS(3162),
    [anon_sym_requires] = ACTIONS(3162),
    [sym_this] = ACTIONS(3162),
  },
  [530] = {
    [sym_identifier] = ACTIONS(2958),
    [aux_sym_preproc_include_token1] = ACTIONS(2958),
    [aux_sym_preproc_def_token1] = ACTIONS(2958),
    [aux_sym_preproc_if_token1] = ACTIONS(2958),
    [aux_sym_preproc_if_token2] = ACTIONS(2958),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2958),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2958),
    [aux_sym_preproc_else_token1] = ACTIONS(2958),
    [aux_sym_preproc_elif_token1] = ACTIONS(2958),
    [sym_preproc_directive] = ACTIONS(2958),
    [anon_sym_LPAREN2] = ACTIONS(2960),
    [anon_sym_BANG] = ACTIONS(2960),
    [anon_sym_TILDE] = ACTIONS(2960),
    [anon_sym_DASH] = ACTIONS(2958),
    [anon_sym_PLUS] = ACTIONS(2958),
    [anon_sym_STAR] = ACTIONS(2960),
    [anon_sym_AMP_AMP] = ACTIONS(2960),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_SEMI] = ACTIONS(2960),
    [anon_sym___extension__] = ACTIONS(2958),
    [anon_sym_typedef] = ACTIONS(2958),
    [anon_sym_extern] = ACTIONS(2958),
    [anon_sym___attribute__] = ACTIONS(2958),
    [anon_sym_COLON_COLON] = ACTIONS(2960),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2960),
    [anon_sym___declspec] = ACTIONS(2958),
    [anon_sym___based] = ACTIONS(2958),
    [anon_sym___cdecl] = ACTIONS(2958),
    [anon_sym___clrcall] = ACTIONS(2958),
    [anon_sym___stdcall] = ACTIONS(2958),
    [anon_sym___fastcall] = ACTIONS(2958),
    [anon_sym___thiscall] = ACTIONS(2958),
    [anon_sym___vectorcall] = ACTIONS(2958),
    [anon_sym_LBRACE] = ACTIONS(2960),
    [anon_sym_signed] = ACTIONS(2958),
    [anon_sym_unsigned] = ACTIONS(2958),
    [anon_sym_long] = ACTIONS(2958),
    [anon_sym_short] = ACTIONS(2958),
    [anon_sym_LBRACK] = ACTIONS(2958),
    [anon_sym_static] = ACTIONS(2958),
    [anon_sym_register] = ACTIONS(2958),
    [anon_sym_inline] = ACTIONS(2958),
    [anon_sym___inline] = ACTIONS(2958),
    [anon_sym___inline__] = ACTIONS(2958),
    [anon_sym___forceinline] = ACTIONS(2958),
    [anon_sym_thread_local] = ACTIONS(2958),
    [anon_sym___thread] = ACTIONS(2958),
    [anon_sym_const] = ACTIONS(2958),
    [anon_sym_constexpr] = ACTIONS(2958),
    [anon_sym_volatile] = ACTIONS(2958),
    [anon_sym_restrict] = ACTIONS(2958),
    [anon_sym___restrict__] = ACTIONS(2958),
    [anon_sym__Atomic] = ACTIONS(2958),
    [anon_sym__Noreturn] = ACTIONS(2958),
    [anon_sym_noreturn] = ACTIONS(2958),
    [anon_sym_mutable] = ACTIONS(2958),
    [anon_sym_constinit] = ACTIONS(2958),
    [anon_sym_consteval] = ACTIONS(2958),
    [anon_sym_PROGMEM] = ACTIONS(2958),
    [aux_sym_primitive_type_token1] = ACTIONS(2958),
    [anon_sym_byte] = ACTIONS(2958),
    [anon_sym_word] = ACTIONS(2958),
    [anon_sym_enum] = ACTIONS(2958),
    [anon_sym_class] = ACTIONS(2958),
    [anon_sym_struct] = ACTIONS(2958),
    [anon_sym_union] = ACTIONS(2958),
    [anon_sym_if] = ACTIONS(2958),
    [anon_sym_else] = ACTIONS(2958),
    [anon_sym_switch] = ACTIONS(2958),
    [anon_sym_case] = ACTIONS(2958),
    [anon_sym_default] = ACTIONS(2958),
    [anon_sym_while] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2958),
    [anon_sym_for] = ACTIONS(2958),
    [anon_sym_return] = ACTIONS(2958),
    [anon_sym_break] = ACTIONS(2958),
    [anon_sym_continue] = ACTIONS(2958),
    [anon_sym_goto] = ACTIONS(2958),
    [anon_sym___try] = ACTIONS(2958),
    [anon_sym___leave] = ACTIONS(2958),
    [anon_sym_not] = ACTIONS(2958),
    [anon_sym_compl] = ACTIONS(2958),
    [anon_sym_DASH_DASH] = ACTIONS(2960),
    [anon_sym_PLUS_PLUS] = ACTIONS(2960),
    [anon_sym_sizeof] = ACTIONS(2958),
    [anon_sym___alignof__] = ACTIONS(2958),
    [anon_sym___alignof] = ACTIONS(2958),
    [anon_sym__alignof] = ACTIONS(2958),
    [anon_sym_alignof] = ACTIONS(2958),
    [anon_sym__Alignof] = ACTIONS(2958),
    [anon_sym_offsetof] = ACTIONS(2958),
    [anon_sym__Generic] = ACTIONS(2958),
    [anon_sym_asm] = ACTIONS(2958),
    [anon_sym___asm__] = ACTIONS(2958),
    [aux_sym_number_literal_token1] = ACTIONS(2960),
    [aux_sym_number_literal_token2] = ACTIONS(2958),
    [anon_sym_L_SQUOTE] = ACTIONS(2960),
    [anon_sym_u_SQUOTE] = ACTIONS(2960),
    [anon_sym_U_SQUOTE] = ACTIONS(2960),
    [anon_sym_u8_SQUOTE] = ACTIONS(2960),
    [anon_sym_SQUOTE] = ACTIONS(2960),
    [anon_sym_L_DQUOTE] = ACTIONS(2960),
    [anon_sym_u_DQUOTE] = ACTIONS(2960),
    [anon_sym_U_DQUOTE] = ACTIONS(2960),
    [anon_sym_u8_DQUOTE] = ACTIONS(2960),
    [anon_sym_DQUOTE] = ACTIONS(2960),
    [sym_true] = ACTIONS(2958),
    [sym_false] = ACTIONS(2958),
    [anon_sym_NULL] = ACTIONS(2958),
    [anon_sym_nullptr] = ACTIONS(2958),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2958),
    [anon_sym_decltype] = ACTIONS(2958),
    [anon_sym_virtual] = ACTIONS(2958),
    [anon_sym_alignas] = ACTIONS(2958),
    [anon_sym_explicit] = ACTIONS(2958),
    [anon_sym_typename] = ACTIONS(2958),
    [anon_sym_template] = ACTIONS(2958),
    [anon_sym_operator] = ACTIONS(2958),
    [anon_sym_try] = ACTIONS(2958),
    [anon_sym_delete] = ACTIONS(2958),
    [anon_sym_throw] = ACTIONS(2958),
    [anon_sym_namespace] = ACTIONS(2958),
    [anon_sym_using] = ACTIONS(2958),
    [anon_sym_static_assert] = ACTIONS(2958),
    [anon_sym_concept] = ACTIONS(2958),
    [anon_sym_co_return] = ACTIONS(2958),
    [anon_sym_co_yield] = ACTIONS(2958),
    [anon_sym_R_DQUOTE] = ACTIONS(2960),
    [anon_sym_LR_DQUOTE] = ACTIONS(2960),
    [anon_sym_uR_DQUOTE] = ACTIONS(2960),
    [anon_sym_UR_DQUOTE] = ACTIONS(2960),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2960),
    [anon_sym_co_await] = ACTIONS(2958),
    [anon_sym_new] = ACTIONS(2958),
    [anon_sym_requires] = ACTIONS(2958),
    [sym_this] = ACTIONS(2958),
  },
  [531] = {
    [sym_catch_clause] = STATE(388),
    [aux_sym_constructor_try_statement_repeat1] = STATE(388),
    [sym_identifier] = ACTIONS(2856),
    [aux_sym_preproc_include_token1] = ACTIONS(2856),
    [aux_sym_preproc_def_token1] = ACTIONS(2856),
    [aux_sym_preproc_if_token1] = ACTIONS(2856),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2856),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2856),
    [sym_preproc_directive] = ACTIONS(2856),
    [anon_sym_LPAREN2] = ACTIONS(2858),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2856),
    [anon_sym_PLUS] = ACTIONS(2856),
    [anon_sym_STAR] = ACTIONS(2858),
    [anon_sym_AMP_AMP] = ACTIONS(2858),
    [anon_sym_AMP] = ACTIONS(2856),
    [anon_sym_SEMI] = ACTIONS(2858),
    [anon_sym___extension__] = ACTIONS(2856),
    [anon_sym_typedef] = ACTIONS(2856),
    [anon_sym_extern] = ACTIONS(2856),
    [anon_sym___attribute__] = ACTIONS(2856),
    [anon_sym_COLON_COLON] = ACTIONS(2858),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2858),
    [anon_sym___declspec] = ACTIONS(2856),
    [anon_sym___based] = ACTIONS(2856),
    [anon_sym___cdecl] = ACTIONS(2856),
    [anon_sym___clrcall] = ACTIONS(2856),
    [anon_sym___stdcall] = ACTIONS(2856),
    [anon_sym___fastcall] = ACTIONS(2856),
    [anon_sym___thiscall] = ACTIONS(2856),
    [anon_sym___vectorcall] = ACTIONS(2856),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_RBRACE] = ACTIONS(2858),
    [anon_sym_signed] = ACTIONS(2856),
    [anon_sym_unsigned] = ACTIONS(2856),
    [anon_sym_long] = ACTIONS(2856),
    [anon_sym_short] = ACTIONS(2856),
    [anon_sym_LBRACK] = ACTIONS(2856),
    [anon_sym_static] = ACTIONS(2856),
    [anon_sym_register] = ACTIONS(2856),
    [anon_sym_inline] = ACTIONS(2856),
    [anon_sym___inline] = ACTIONS(2856),
    [anon_sym___inline__] = ACTIONS(2856),
    [anon_sym___forceinline] = ACTIONS(2856),
    [anon_sym_thread_local] = ACTIONS(2856),
    [anon_sym___thread] = ACTIONS(2856),
    [anon_sym_const] = ACTIONS(2856),
    [anon_sym_constexpr] = ACTIONS(2856),
    [anon_sym_volatile] = ACTIONS(2856),
    [anon_sym_restrict] = ACTIONS(2856),
    [anon_sym___restrict__] = ACTIONS(2856),
    [anon_sym__Atomic] = ACTIONS(2856),
    [anon_sym__Noreturn] = ACTIONS(2856),
    [anon_sym_noreturn] = ACTIONS(2856),
    [anon_sym_mutable] = ACTIONS(2856),
    [anon_sym_constinit] = ACTIONS(2856),
    [anon_sym_consteval] = ACTIONS(2856),
    [anon_sym_PROGMEM] = ACTIONS(2856),
    [aux_sym_primitive_type_token1] = ACTIONS(2856),
    [anon_sym_byte] = ACTIONS(2856),
    [anon_sym_word] = ACTIONS(2856),
    [anon_sym_enum] = ACTIONS(2856),
    [anon_sym_class] = ACTIONS(2856),
    [anon_sym_struct] = ACTIONS(2856),
    [anon_sym_union] = ACTIONS(2856),
    [anon_sym_if] = ACTIONS(2856),
    [anon_sym_switch] = ACTIONS(2856),
    [anon_sym_case] = ACTIONS(2856),
    [anon_sym_default] = ACTIONS(2856),
    [anon_sym_while] = ACTIONS(2856),
    [anon_sym_do] = ACTIONS(2856),
    [anon_sym_for] = ACTIONS(2856),
    [anon_sym_return] = ACTIONS(2856),
    [anon_sym_break] = ACTIONS(2856),
    [anon_sym_continue] = ACTIONS(2856),
    [anon_sym_goto] = ACTIONS(2856),
    [anon_sym___try] = ACTIONS(2856),
    [anon_sym___leave] = ACTIONS(2856),
    [anon_sym_not] = ACTIONS(2856),
    [anon_sym_compl] = ACTIONS(2856),
    [anon_sym_DASH_DASH] = ACTIONS(2858),
    [anon_sym_PLUS_PLUS] = ACTIONS(2858),
    [anon_sym_sizeof] = ACTIONS(2856),
    [anon_sym___alignof__] = ACTIONS(2856),
    [anon_sym___alignof] = ACTIONS(2856),
    [anon_sym__alignof] = ACTIONS(2856),
    [anon_sym_alignof] = ACTIONS(2856),
    [anon_sym__Alignof] = ACTIONS(2856),
    [anon_sym_offsetof] = ACTIONS(2856),
    [anon_sym__Generic] = ACTIONS(2856),
    [anon_sym_asm] = ACTIONS(2856),
    [anon_sym___asm__] = ACTIONS(2856),
    [aux_sym_number_literal_token1] = ACTIONS(2858),
    [aux_sym_number_literal_token2] = ACTIONS(2856),
    [anon_sym_L_SQUOTE] = ACTIONS(2858),
    [anon_sym_u_SQUOTE] = ACTIONS(2858),
    [anon_sym_U_SQUOTE] = ACTIONS(2858),
    [anon_sym_u8_SQUOTE] = ACTIONS(2858),
    [anon_sym_SQUOTE] = ACTIONS(2858),
    [anon_sym_L_DQUOTE] = ACTIONS(2858),
    [anon_sym_u_DQUOTE] = ACTIONS(2858),
    [anon_sym_U_DQUOTE] = ACTIONS(2858),
    [anon_sym_u8_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE] = ACTIONS(2858),
    [sym_true] = ACTIONS(2856),
    [sym_false] = ACTIONS(2856),
    [anon_sym_NULL] = ACTIONS(2856),
    [anon_sym_nullptr] = ACTIONS(2856),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2856),
    [anon_sym_decltype] = ACTIONS(2856),
    [anon_sym_virtual] = ACTIONS(2856),
    [anon_sym_alignas] = ACTIONS(2856),
    [anon_sym_explicit] = ACTIONS(2856),
    [anon_sym_typename] = ACTIONS(2856),
    [anon_sym_template] = ACTIONS(2856),
    [anon_sym_operator] = ACTIONS(2856),
    [anon_sym_try] = ACTIONS(2856),
    [anon_sym_delete] = ACTIONS(2856),
    [anon_sym_throw] = ACTIONS(2856),
    [anon_sym_namespace] = ACTIONS(2856),
    [anon_sym_using] = ACTIONS(2856),
    [anon_sym_static_assert] = ACTIONS(2856),
    [anon_sym_concept] = ACTIONS(2856),
    [anon_sym_co_return] = ACTIONS(2856),
    [anon_sym_co_yield] = ACTIONS(2856),
    [anon_sym_catch] = ACTIONS(3344),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_LR_DQUOTE] = ACTIONS(2858),
    [anon_sym_uR_DQUOTE] = ACTIONS(2858),
    [anon_sym_UR_DQUOTE] = ACTIONS(2858),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2858),
    [anon_sym_co_await] = ACTIONS(2856),
    [anon_sym_new] = ACTIONS(2856),
    [anon_sym_requires] = ACTIONS(2856),
    [sym_this] = ACTIONS(2856),
  },
  [532] = {
    [sym_identifier] = ACTIONS(2954),
    [aux_sym_preproc_include_token1] = ACTIONS(2954),
    [aux_sym_preproc_def_token1] = ACTIONS(2954),
    [aux_sym_preproc_if_token1] = ACTIONS(2954),
    [aux_sym_preproc_if_token2] = ACTIONS(2954),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2954),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2954),
    [aux_sym_preproc_else_token1] = ACTIONS(2954),
    [aux_sym_preproc_elif_token1] = ACTIONS(2954),
    [sym_preproc_directive] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2956),
    [anon_sym_BANG] = ACTIONS(2956),
    [anon_sym_TILDE] = ACTIONS(2956),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_STAR] = ACTIONS(2956),
    [anon_sym_AMP_AMP] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2954),
    [anon_sym_SEMI] = ACTIONS(2956),
    [anon_sym___extension__] = ACTIONS(2954),
    [anon_sym_typedef] = ACTIONS(2954),
    [anon_sym_extern] = ACTIONS(2954),
    [anon_sym___attribute__] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2956),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2956),
    [anon_sym___declspec] = ACTIONS(2954),
    [anon_sym___based] = ACTIONS(2954),
    [anon_sym___cdecl] = ACTIONS(2954),
    [anon_sym___clrcall] = ACTIONS(2954),
    [anon_sym___stdcall] = ACTIONS(2954),
    [anon_sym___fastcall] = ACTIONS(2954),
    [anon_sym___thiscall] = ACTIONS(2954),
    [anon_sym___vectorcall] = ACTIONS(2954),
    [anon_sym_LBRACE] = ACTIONS(2956),
    [anon_sym_signed] = ACTIONS(2954),
    [anon_sym_unsigned] = ACTIONS(2954),
    [anon_sym_long] = ACTIONS(2954),
    [anon_sym_short] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_static] = ACTIONS(2954),
    [anon_sym_register] = ACTIONS(2954),
    [anon_sym_inline] = ACTIONS(2954),
    [anon_sym___inline] = ACTIONS(2954),
    [anon_sym___inline__] = ACTIONS(2954),
    [anon_sym___forceinline] = ACTIONS(2954),
    [anon_sym_thread_local] = ACTIONS(2954),
    [anon_sym___thread] = ACTIONS(2954),
    [anon_sym_const] = ACTIONS(2954),
    [anon_sym_constexpr] = ACTIONS(2954),
    [anon_sym_volatile] = ACTIONS(2954),
    [anon_sym_restrict] = ACTIONS(2954),
    [anon_sym___restrict__] = ACTIONS(2954),
    [anon_sym__Atomic] = ACTIONS(2954),
    [anon_sym__Noreturn] = ACTIONS(2954),
    [anon_sym_noreturn] = ACTIONS(2954),
    [anon_sym_mutable] = ACTIONS(2954),
    [anon_sym_constinit] = ACTIONS(2954),
    [anon_sym_consteval] = ACTIONS(2954),
    [anon_sym_PROGMEM] = ACTIONS(2954),
    [aux_sym_primitive_type_token1] = ACTIONS(2954),
    [anon_sym_byte] = ACTIONS(2954),
    [anon_sym_word] = ACTIONS(2954),
    [anon_sym_enum] = ACTIONS(2954),
    [anon_sym_class] = ACTIONS(2954),
    [anon_sym_struct] = ACTIONS(2954),
    [anon_sym_union] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_else] = ACTIONS(2954),
    [anon_sym_switch] = ACTIONS(2954),
    [anon_sym_case] = ACTIONS(2954),
    [anon_sym_default] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_break] = ACTIONS(2954),
    [anon_sym_continue] = ACTIONS(2954),
    [anon_sym_goto] = ACTIONS(2954),
    [anon_sym___try] = ACTIONS(2954),
    [anon_sym___leave] = ACTIONS(2954),
    [anon_sym_not] = ACTIONS(2954),
    [anon_sym_compl] = ACTIONS(2954),
    [anon_sym_DASH_DASH] = ACTIONS(2956),
    [anon_sym_PLUS_PLUS] = ACTIONS(2956),
    [anon_sym_sizeof] = ACTIONS(2954),
    [anon_sym___alignof__] = ACTIONS(2954),
    [anon_sym___alignof] = ACTIONS(2954),
    [anon_sym__alignof] = ACTIONS(2954),
    [anon_sym_alignof] = ACTIONS(2954),
    [anon_sym__Alignof] = ACTIONS(2954),
    [anon_sym_offsetof] = ACTIONS(2954),
    [anon_sym__Generic] = ACTIONS(2954),
    [anon_sym_asm] = ACTIONS(2954),
    [anon_sym___asm__] = ACTIONS(2954),
    [aux_sym_number_literal_token1] = ACTIONS(2956),
    [aux_sym_number_literal_token2] = ACTIONS(2954),
    [anon_sym_L_SQUOTE] = ACTIONS(2956),
    [anon_sym_u_SQUOTE] = ACTIONS(2956),
    [anon_sym_U_SQUOTE] = ACTIONS(2956),
    [anon_sym_u8_SQUOTE] = ACTIONS(2956),
    [anon_sym_SQUOTE] = ACTIONS(2956),
    [anon_sym_L_DQUOTE] = ACTIONS(2956),
    [anon_sym_u_DQUOTE] = ACTIONS(2956),
    [anon_sym_U_DQUOTE] = ACTIONS(2956),
    [anon_sym_u8_DQUOTE] = ACTIONS(2956),
    [anon_sym_DQUOTE] = ACTIONS(2956),
    [sym_true] = ACTIONS(2954),
    [sym_false] = ACTIONS(2954),
    [anon_sym_NULL] = ACTIONS(2954),
    [anon_sym_nullptr] = ACTIONS(2954),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2954),
    [anon_sym_decltype] = ACTIONS(2954),
    [anon_sym_virtual] = ACTIONS(2954),
    [anon_sym_alignas] = ACTIONS(2954),
    [anon_sym_explicit] = ACTIONS(2954),
    [anon_sym_typename] = ACTIONS(2954),
    [anon_sym_template] = ACTIONS(2954),
    [anon_sym_operator] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_delete] = ACTIONS(2954),
    [anon_sym_throw] = ACTIONS(2954),
    [anon_sym_namespace] = ACTIONS(2954),
    [anon_sym_using] = ACTIONS(2954),
    [anon_sym_static_assert] = ACTIONS(2954),
    [anon_sym_concept] = ACTIONS(2954),
    [anon_sym_co_return] = ACTIONS(2954),
    [anon_sym_co_yield] = ACTIONS(2954),
    [anon_sym_R_DQUOTE] = ACTIONS(2956),
    [anon_sym_LR_DQUOTE] = ACTIONS(2956),
    [anon_sym_uR_DQUOTE] = ACTIONS(2956),
    [anon_sym_UR_DQUOTE] = ACTIONS(2956),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2956),
    [anon_sym_co_await] = ACTIONS(2954),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_requires] = ACTIONS(2954),
    [sym_this] = ACTIONS(2954),
  },
  [533] = {
    [sym_identifier] = ACTIONS(2970),
    [aux_sym_preproc_include_token1] = ACTIONS(2970),
    [aux_sym_preproc_def_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token2] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2970),
    [aux_sym_preproc_else_token1] = ACTIONS(2970),
    [aux_sym_preproc_elif_token1] = ACTIONS(2970),
    [sym_preproc_directive] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_BANG] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym___extension__] = ACTIONS(2970),
    [anon_sym_typedef] = ACTIONS(2970),
    [anon_sym_extern] = ACTIONS(2970),
    [anon_sym___attribute__] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2970),
    [anon_sym___based] = ACTIONS(2970),
    [anon_sym___cdecl] = ACTIONS(2970),
    [anon_sym___clrcall] = ACTIONS(2970),
    [anon_sym___stdcall] = ACTIONS(2970),
    [anon_sym___fastcall] = ACTIONS(2970),
    [anon_sym___thiscall] = ACTIONS(2970),
    [anon_sym___vectorcall] = ACTIONS(2970),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_signed] = ACTIONS(2970),
    [anon_sym_unsigned] = ACTIONS(2970),
    [anon_sym_long] = ACTIONS(2970),
    [anon_sym_short] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_register] = ACTIONS(2970),
    [anon_sym_inline] = ACTIONS(2970),
    [anon_sym___inline] = ACTIONS(2970),
    [anon_sym___inline__] = ACTIONS(2970),
    [anon_sym___forceinline] = ACTIONS(2970),
    [anon_sym_thread_local] = ACTIONS(2970),
    [anon_sym___thread] = ACTIONS(2970),
    [anon_sym_const] = ACTIONS(2970),
    [anon_sym_constexpr] = ACTIONS(2970),
    [anon_sym_volatile] = ACTIONS(2970),
    [anon_sym_restrict] = ACTIONS(2970),
    [anon_sym___restrict__] = ACTIONS(2970),
    [anon_sym__Atomic] = ACTIONS(2970),
    [anon_sym__Noreturn] = ACTIONS(2970),
    [anon_sym_noreturn] = ACTIONS(2970),
    [anon_sym_mutable] = ACTIONS(2970),
    [anon_sym_constinit] = ACTIONS(2970),
    [anon_sym_consteval] = ACTIONS(2970),
    [anon_sym_PROGMEM] = ACTIONS(2970),
    [aux_sym_primitive_type_token1] = ACTIONS(2970),
    [anon_sym_byte] = ACTIONS(2970),
    [anon_sym_word] = ACTIONS(2970),
    [anon_sym_enum] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_struct] = ACTIONS(2970),
    [anon_sym_union] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_else] = ACTIONS(2970),
    [anon_sym_switch] = ACTIONS(2970),
    [anon_sym_case] = ACTIONS(2970),
    [anon_sym_default] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_break] = ACTIONS(2970),
    [anon_sym_continue] = ACTIONS(2970),
    [anon_sym_goto] = ACTIONS(2970),
    [anon_sym___try] = ACTIONS(2970),
    [anon_sym___leave] = ACTIONS(2970),
    [anon_sym_not] = ACTIONS(2970),
    [anon_sym_compl] = ACTIONS(2970),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_sizeof] = ACTIONS(2970),
    [anon_sym___alignof__] = ACTIONS(2970),
    [anon_sym___alignof] = ACTIONS(2970),
    [anon_sym__alignof] = ACTIONS(2970),
    [anon_sym_alignof] = ACTIONS(2970),
    [anon_sym__Alignof] = ACTIONS(2970),
    [anon_sym_offsetof] = ACTIONS(2970),
    [anon_sym__Generic] = ACTIONS(2970),
    [anon_sym_asm] = ACTIONS(2970),
    [anon_sym___asm__] = ACTIONS(2970),
    [aux_sym_number_literal_token1] = ACTIONS(2972),
    [aux_sym_number_literal_token2] = ACTIONS(2970),
    [anon_sym_L_SQUOTE] = ACTIONS(2972),
    [anon_sym_u_SQUOTE] = ACTIONS(2972),
    [anon_sym_U_SQUOTE] = ACTIONS(2972),
    [anon_sym_u8_SQUOTE] = ACTIONS(2972),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [anon_sym_L_DQUOTE] = ACTIONS(2972),
    [anon_sym_u_DQUOTE] = ACTIONS(2972),
    [anon_sym_U_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE] = ACTIONS(2972),
    [sym_true] = ACTIONS(2970),
    [sym_false] = ACTIONS(2970),
    [anon_sym_NULL] = ACTIONS(2970),
    [anon_sym_nullptr] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2970),
    [anon_sym_decltype] = ACTIONS(2970),
    [anon_sym_virtual] = ACTIONS(2970),
    [anon_sym_alignas] = ACTIONS(2970),
    [anon_sym_explicit] = ACTIONS(2970),
    [anon_sym_typename] = ACTIONS(2970),
    [anon_sym_template] = ACTIONS(2970),
    [anon_sym_operator] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_delete] = ACTIONS(2970),
    [anon_sym_throw] = ACTIONS(2970),
    [anon_sym_namespace] = ACTIONS(2970),
    [anon_sym_using] = ACTIONS(2970),
    [anon_sym_static_assert] = ACTIONS(2970),
    [anon_sym_concept] = ACTIONS(2970),
    [anon_sym_co_return] = ACTIONS(2970),
    [anon_sym_co_yield] = ACTIONS(2970),
    [anon_sym_R_DQUOTE] = ACTIONS(2972),
    [anon_sym_LR_DQUOTE] = ACTIONS(2972),
    [anon_sym_uR_DQUOTE] = ACTIONS(2972),
    [anon_sym_UR_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2972),
    [anon_sym_co_await] = ACTIONS(2970),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_requires] = ACTIONS(2970),
    [sym_this] = ACTIONS(2970),
  },
  [534] = {
    [sym_identifier] = ACTIONS(2950),
    [aux_sym_preproc_include_token1] = ACTIONS(2950),
    [aux_sym_preproc_def_token1] = ACTIONS(2950),
    [aux_sym_preproc_if_token1] = ACTIONS(2950),
    [aux_sym_preproc_if_token2] = ACTIONS(2950),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2950),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2950),
    [aux_sym_preproc_else_token1] = ACTIONS(2950),
    [aux_sym_preproc_elif_token1] = ACTIONS(2950),
    [sym_preproc_directive] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2952),
    [anon_sym_BANG] = ACTIONS(2952),
    [anon_sym_TILDE] = ACTIONS(2952),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_STAR] = ACTIONS(2952),
    [anon_sym_AMP_AMP] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_SEMI] = ACTIONS(2952),
    [anon_sym___extension__] = ACTIONS(2950),
    [anon_sym_typedef] = ACTIONS(2950),
    [anon_sym_extern] = ACTIONS(2950),
    [anon_sym___attribute__] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2952),
    [anon_sym___declspec] = ACTIONS(2950),
    [anon_sym___based] = ACTIONS(2950),
    [anon_sym___cdecl] = ACTIONS(2950),
    [anon_sym___clrcall] = ACTIONS(2950),
    [anon_sym___stdcall] = ACTIONS(2950),
    [anon_sym___fastcall] = ACTIONS(2950),
    [anon_sym___thiscall] = ACTIONS(2950),
    [anon_sym___vectorcall] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2952),
    [anon_sym_signed] = ACTIONS(2950),
    [anon_sym_unsigned] = ACTIONS(2950),
    [anon_sym_long] = ACTIONS(2950),
    [anon_sym_short] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_static] = ACTIONS(2950),
    [anon_sym_register] = ACTIONS(2950),
    [anon_sym_inline] = ACTIONS(2950),
    [anon_sym___inline] = ACTIONS(2950),
    [anon_sym___inline__] = ACTIONS(2950),
    [anon_sym___forceinline] = ACTIONS(2950),
    [anon_sym_thread_local] = ACTIONS(2950),
    [anon_sym___thread] = ACTIONS(2950),
    [anon_sym_const] = ACTIONS(2950),
    [anon_sym_constexpr] = ACTIONS(2950),
    [anon_sym_volatile] = ACTIONS(2950),
    [anon_sym_restrict] = ACTIONS(2950),
    [anon_sym___restrict__] = ACTIONS(2950),
    [anon_sym__Atomic] = ACTIONS(2950),
    [anon_sym__Noreturn] = ACTIONS(2950),
    [anon_sym_noreturn] = ACTIONS(2950),
    [anon_sym_mutable] = ACTIONS(2950),
    [anon_sym_constinit] = ACTIONS(2950),
    [anon_sym_consteval] = ACTIONS(2950),
    [anon_sym_PROGMEM] = ACTIONS(2950),
    [aux_sym_primitive_type_token1] = ACTIONS(2950),
    [anon_sym_byte] = ACTIONS(2950),
    [anon_sym_word] = ACTIONS(2950),
    [anon_sym_enum] = ACTIONS(2950),
    [anon_sym_class] = ACTIONS(2950),
    [anon_sym_struct] = ACTIONS(2950),
    [anon_sym_union] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_else] = ACTIONS(2950),
    [anon_sym_switch] = ACTIONS(2950),
    [anon_sym_case] = ACTIONS(2950),
    [anon_sym_default] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_break] = ACTIONS(2950),
    [anon_sym_continue] = ACTIONS(2950),
    [anon_sym_goto] = ACTIONS(2950),
    [anon_sym___try] = ACTIONS(2950),
    [anon_sym___leave] = ACTIONS(2950),
    [anon_sym_not] = ACTIONS(2950),
    [anon_sym_compl] = ACTIONS(2950),
    [anon_sym_DASH_DASH] = ACTIONS(2952),
    [anon_sym_PLUS_PLUS] = ACTIONS(2952),
    [anon_sym_sizeof] = ACTIONS(2950),
    [anon_sym___alignof__] = ACTIONS(2950),
    [anon_sym___alignof] = ACTIONS(2950),
    [anon_sym__alignof] = ACTIONS(2950),
    [anon_sym_alignof] = ACTIONS(2950),
    [anon_sym__Alignof] = ACTIONS(2950),
    [anon_sym_offsetof] = ACTIONS(2950),
    [anon_sym__Generic] = ACTIONS(2950),
    [anon_sym_asm] = ACTIONS(2950),
    [anon_sym___asm__] = ACTIONS(2950),
    [aux_sym_number_literal_token1] = ACTIONS(2952),
    [aux_sym_number_literal_token2] = ACTIONS(2950),
    [anon_sym_L_SQUOTE] = ACTIONS(2952),
    [anon_sym_u_SQUOTE] = ACTIONS(2952),
    [anon_sym_U_SQUOTE] = ACTIONS(2952),
    [anon_sym_u8_SQUOTE] = ACTIONS(2952),
    [anon_sym_SQUOTE] = ACTIONS(2952),
    [anon_sym_L_DQUOTE] = ACTIONS(2952),
    [anon_sym_u_DQUOTE] = ACTIONS(2952),
    [anon_sym_U_DQUOTE] = ACTIONS(2952),
    [anon_sym_u8_DQUOTE] = ACTIONS(2952),
    [anon_sym_DQUOTE] = ACTIONS(2952),
    [sym_true] = ACTIONS(2950),
    [sym_false] = ACTIONS(2950),
    [anon_sym_NULL] = ACTIONS(2950),
    [anon_sym_nullptr] = ACTIONS(2950),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2950),
    [anon_sym_decltype] = ACTIONS(2950),
    [anon_sym_virtual] = ACTIONS(2950),
    [anon_sym_alignas] = ACTIONS(2950),
    [anon_sym_explicit] = ACTIONS(2950),
    [anon_sym_typename] = ACTIONS(2950),
    [anon_sym_template] = ACTIONS(2950),
    [anon_sym_operator] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_delete] = ACTIONS(2950),
    [anon_sym_throw] = ACTIONS(2950),
    [anon_sym_namespace] = ACTIONS(2950),
    [anon_sym_using] = ACTIONS(2950),
    [anon_sym_static_assert] = ACTIONS(2950),
    [anon_sym_concept] = ACTIONS(2950),
    [anon_sym_co_return] = ACTIONS(2950),
    [anon_sym_co_yield] = ACTIONS(2950),
    [anon_sym_R_DQUOTE] = ACTIONS(2952),
    [anon_sym_LR_DQUOTE] = ACTIONS(2952),
    [anon_sym_uR_DQUOTE] = ACTIONS(2952),
    [anon_sym_UR_DQUOTE] = ACTIONS(2952),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2952),
    [anon_sym_co_await] = ACTIONS(2950),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_requires] = ACTIONS(2950),
    [sym_this] = ACTIONS(2950),
  },
  [535] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [536] = {
    [sym_identifier] = ACTIONS(3134),
    [aux_sym_preproc_include_token1] = ACTIONS(3134),
    [aux_sym_preproc_def_token1] = ACTIONS(3134),
    [aux_sym_preproc_if_token1] = ACTIONS(3134),
    [aux_sym_preproc_if_token2] = ACTIONS(3134),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3134),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3134),
    [aux_sym_preproc_else_token1] = ACTIONS(3134),
    [aux_sym_preproc_elif_token1] = ACTIONS(3134),
    [sym_preproc_directive] = ACTIONS(3134),
    [anon_sym_LPAREN2] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3136),
    [anon_sym_TILDE] = ACTIONS(3136),
    [anon_sym_DASH] = ACTIONS(3134),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_STAR] = ACTIONS(3136),
    [anon_sym_AMP_AMP] = ACTIONS(3136),
    [anon_sym_AMP] = ACTIONS(3134),
    [anon_sym_SEMI] = ACTIONS(3136),
    [anon_sym___extension__] = ACTIONS(3134),
    [anon_sym_typedef] = ACTIONS(3134),
    [anon_sym_extern] = ACTIONS(3134),
    [anon_sym___attribute__] = ACTIONS(3134),
    [anon_sym_COLON_COLON] = ACTIONS(3136),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3136),
    [anon_sym___declspec] = ACTIONS(3134),
    [anon_sym___based] = ACTIONS(3134),
    [anon_sym___cdecl] = ACTIONS(3134),
    [anon_sym___clrcall] = ACTIONS(3134),
    [anon_sym___stdcall] = ACTIONS(3134),
    [anon_sym___fastcall] = ACTIONS(3134),
    [anon_sym___thiscall] = ACTIONS(3134),
    [anon_sym___vectorcall] = ACTIONS(3134),
    [anon_sym_LBRACE] = ACTIONS(3136),
    [anon_sym_signed] = ACTIONS(3134),
    [anon_sym_unsigned] = ACTIONS(3134),
    [anon_sym_long] = ACTIONS(3134),
    [anon_sym_short] = ACTIONS(3134),
    [anon_sym_LBRACK] = ACTIONS(3134),
    [anon_sym_static] = ACTIONS(3134),
    [anon_sym_register] = ACTIONS(3134),
    [anon_sym_inline] = ACTIONS(3134),
    [anon_sym___inline] = ACTIONS(3134),
    [anon_sym___inline__] = ACTIONS(3134),
    [anon_sym___forceinline] = ACTIONS(3134),
    [anon_sym_thread_local] = ACTIONS(3134),
    [anon_sym___thread] = ACTIONS(3134),
    [anon_sym_const] = ACTIONS(3134),
    [anon_sym_constexpr] = ACTIONS(3134),
    [anon_sym_volatile] = ACTIONS(3134),
    [anon_sym_restrict] = ACTIONS(3134),
    [anon_sym___restrict__] = ACTIONS(3134),
    [anon_sym__Atomic] = ACTIONS(3134),
    [anon_sym__Noreturn] = ACTIONS(3134),
    [anon_sym_noreturn] = ACTIONS(3134),
    [anon_sym_mutable] = ACTIONS(3134),
    [anon_sym_constinit] = ACTIONS(3134),
    [anon_sym_consteval] = ACTIONS(3134),
    [anon_sym_PROGMEM] = ACTIONS(3134),
    [aux_sym_primitive_type_token1] = ACTIONS(3134),
    [anon_sym_byte] = ACTIONS(3134),
    [anon_sym_word] = ACTIONS(3134),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3134),
    [anon_sym_struct] = ACTIONS(3134),
    [anon_sym_union] = ACTIONS(3134),
    [anon_sym_if] = ACTIONS(3134),
    [anon_sym_else] = ACTIONS(3134),
    [anon_sym_switch] = ACTIONS(3134),
    [anon_sym_case] = ACTIONS(3134),
    [anon_sym_default] = ACTIONS(3134),
    [anon_sym_while] = ACTIONS(3134),
    [anon_sym_do] = ACTIONS(3134),
    [anon_sym_for] = ACTIONS(3134),
    [anon_sym_return] = ACTIONS(3134),
    [anon_sym_break] = ACTIONS(3134),
    [anon_sym_continue] = ACTIONS(3134),
    [anon_sym_goto] = ACTIONS(3134),
    [anon_sym___try] = ACTIONS(3134),
    [anon_sym___leave] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3134),
    [anon_sym_compl] = ACTIONS(3134),
    [anon_sym_DASH_DASH] = ACTIONS(3136),
    [anon_sym_PLUS_PLUS] = ACTIONS(3136),
    [anon_sym_sizeof] = ACTIONS(3134),
    [anon_sym___alignof__] = ACTIONS(3134),
    [anon_sym___alignof] = ACTIONS(3134),
    [anon_sym__alignof] = ACTIONS(3134),
    [anon_sym_alignof] = ACTIONS(3134),
    [anon_sym__Alignof] = ACTIONS(3134),
    [anon_sym_offsetof] = ACTIONS(3134),
    [anon_sym__Generic] = ACTIONS(3134),
    [anon_sym_asm] = ACTIONS(3134),
    [anon_sym___asm__] = ACTIONS(3134),
    [aux_sym_number_literal_token1] = ACTIONS(3136),
    [aux_sym_number_literal_token2] = ACTIONS(3134),
    [anon_sym_L_SQUOTE] = ACTIONS(3136),
    [anon_sym_u_SQUOTE] = ACTIONS(3136),
    [anon_sym_U_SQUOTE] = ACTIONS(3136),
    [anon_sym_u8_SQUOTE] = ACTIONS(3136),
    [anon_sym_SQUOTE] = ACTIONS(3136),
    [anon_sym_L_DQUOTE] = ACTIONS(3136),
    [anon_sym_u_DQUOTE] = ACTIONS(3136),
    [anon_sym_U_DQUOTE] = ACTIONS(3136),
    [anon_sym_u8_DQUOTE] = ACTIONS(3136),
    [anon_sym_DQUOTE] = ACTIONS(3136),
    [sym_true] = ACTIONS(3134),
    [sym_false] = ACTIONS(3134),
    [anon_sym_NULL] = ACTIONS(3134),
    [anon_sym_nullptr] = ACTIONS(3134),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3134),
    [anon_sym_decltype] = ACTIONS(3134),
    [anon_sym_virtual] = ACTIONS(3134),
    [anon_sym_alignas] = ACTIONS(3134),
    [anon_sym_explicit] = ACTIONS(3134),
    [anon_sym_typename] = ACTIONS(3134),
    [anon_sym_template] = ACTIONS(3134),
    [anon_sym_operator] = ACTIONS(3134),
    [anon_sym_try] = ACTIONS(3134),
    [anon_sym_delete] = ACTIONS(3134),
    [anon_sym_throw] = ACTIONS(3134),
    [anon_sym_namespace] = ACTIONS(3134),
    [anon_sym_using] = ACTIONS(3134),
    [anon_sym_static_assert] = ACTIONS(3134),
    [anon_sym_concept] = ACTIONS(3134),
    [anon_sym_co_return] = ACTIONS(3134),
    [anon_sym_co_yield] = ACTIONS(3134),
    [anon_sym_R_DQUOTE] = ACTIONS(3136),
    [anon_sym_LR_DQUOTE] = ACTIONS(3136),
    [anon_sym_uR_DQUOTE] = ACTIONS(3136),
    [anon_sym_UR_DQUOTE] = ACTIONS(3136),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3136),
    [anon_sym_co_await] = ACTIONS(3134),
    [anon_sym_new] = ACTIONS(3134),
    [anon_sym_requires] = ACTIONS(3134),
    [sym_this] = ACTIONS(3134),
  },
  [537] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [538] = {
    [sym_identifier] = ACTIONS(2970),
    [aux_sym_preproc_include_token1] = ACTIONS(2970),
    [aux_sym_preproc_def_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token2] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2970),
    [aux_sym_preproc_else_token1] = ACTIONS(2970),
    [aux_sym_preproc_elif_token1] = ACTIONS(2970),
    [sym_preproc_directive] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_BANG] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym___extension__] = ACTIONS(2970),
    [anon_sym_typedef] = ACTIONS(2970),
    [anon_sym_extern] = ACTIONS(2970),
    [anon_sym___attribute__] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2970),
    [anon_sym___based] = ACTIONS(2970),
    [anon_sym___cdecl] = ACTIONS(2970),
    [anon_sym___clrcall] = ACTIONS(2970),
    [anon_sym___stdcall] = ACTIONS(2970),
    [anon_sym___fastcall] = ACTIONS(2970),
    [anon_sym___thiscall] = ACTIONS(2970),
    [anon_sym___vectorcall] = ACTIONS(2970),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_signed] = ACTIONS(2970),
    [anon_sym_unsigned] = ACTIONS(2970),
    [anon_sym_long] = ACTIONS(2970),
    [anon_sym_short] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_register] = ACTIONS(2970),
    [anon_sym_inline] = ACTIONS(2970),
    [anon_sym___inline] = ACTIONS(2970),
    [anon_sym___inline__] = ACTIONS(2970),
    [anon_sym___forceinline] = ACTIONS(2970),
    [anon_sym_thread_local] = ACTIONS(2970),
    [anon_sym___thread] = ACTIONS(2970),
    [anon_sym_const] = ACTIONS(2970),
    [anon_sym_constexpr] = ACTIONS(2970),
    [anon_sym_volatile] = ACTIONS(2970),
    [anon_sym_restrict] = ACTIONS(2970),
    [anon_sym___restrict__] = ACTIONS(2970),
    [anon_sym__Atomic] = ACTIONS(2970),
    [anon_sym__Noreturn] = ACTIONS(2970),
    [anon_sym_noreturn] = ACTIONS(2970),
    [anon_sym_mutable] = ACTIONS(2970),
    [anon_sym_constinit] = ACTIONS(2970),
    [anon_sym_consteval] = ACTIONS(2970),
    [anon_sym_PROGMEM] = ACTIONS(2970),
    [aux_sym_primitive_type_token1] = ACTIONS(2970),
    [anon_sym_byte] = ACTIONS(2970),
    [anon_sym_word] = ACTIONS(2970),
    [anon_sym_enum] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_struct] = ACTIONS(2970),
    [anon_sym_union] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_else] = ACTIONS(2970),
    [anon_sym_switch] = ACTIONS(2970),
    [anon_sym_case] = ACTIONS(2970),
    [anon_sym_default] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_break] = ACTIONS(2970),
    [anon_sym_continue] = ACTIONS(2970),
    [anon_sym_goto] = ACTIONS(2970),
    [anon_sym___try] = ACTIONS(2970),
    [anon_sym___leave] = ACTIONS(2970),
    [anon_sym_not] = ACTIONS(2970),
    [anon_sym_compl] = ACTIONS(2970),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_sizeof] = ACTIONS(2970),
    [anon_sym___alignof__] = ACTIONS(2970),
    [anon_sym___alignof] = ACTIONS(2970),
    [anon_sym__alignof] = ACTIONS(2970),
    [anon_sym_alignof] = ACTIONS(2970),
    [anon_sym__Alignof] = ACTIONS(2970),
    [anon_sym_offsetof] = ACTIONS(2970),
    [anon_sym__Generic] = ACTIONS(2970),
    [anon_sym_asm] = ACTIONS(2970),
    [anon_sym___asm__] = ACTIONS(2970),
    [aux_sym_number_literal_token1] = ACTIONS(2972),
    [aux_sym_number_literal_token2] = ACTIONS(2970),
    [anon_sym_L_SQUOTE] = ACTIONS(2972),
    [anon_sym_u_SQUOTE] = ACTIONS(2972),
    [anon_sym_U_SQUOTE] = ACTIONS(2972),
    [anon_sym_u8_SQUOTE] = ACTIONS(2972),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [anon_sym_L_DQUOTE] = ACTIONS(2972),
    [anon_sym_u_DQUOTE] = ACTIONS(2972),
    [anon_sym_U_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE] = ACTIONS(2972),
    [sym_true] = ACTIONS(2970),
    [sym_false] = ACTIONS(2970),
    [anon_sym_NULL] = ACTIONS(2970),
    [anon_sym_nullptr] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2970),
    [anon_sym_decltype] = ACTIONS(2970),
    [anon_sym_virtual] = ACTIONS(2970),
    [anon_sym_alignas] = ACTIONS(2970),
    [anon_sym_explicit] = ACTIONS(2970),
    [anon_sym_typename] = ACTIONS(2970),
    [anon_sym_template] = ACTIONS(2970),
    [anon_sym_operator] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_delete] = ACTIONS(2970),
    [anon_sym_throw] = ACTIONS(2970),
    [anon_sym_namespace] = ACTIONS(2970),
    [anon_sym_using] = ACTIONS(2970),
    [anon_sym_static_assert] = ACTIONS(2970),
    [anon_sym_concept] = ACTIONS(2970),
    [anon_sym_co_return] = ACTIONS(2970),
    [anon_sym_co_yield] = ACTIONS(2970),
    [anon_sym_R_DQUOTE] = ACTIONS(2972),
    [anon_sym_LR_DQUOTE] = ACTIONS(2972),
    [anon_sym_uR_DQUOTE] = ACTIONS(2972),
    [anon_sym_UR_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2972),
    [anon_sym_co_await] = ACTIONS(2970),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_requires] = ACTIONS(2970),
    [sym_this] = ACTIONS(2970),
  },
  [539] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [540] = {
    [sym_identifier] = ACTIONS(3144),
    [aux_sym_preproc_include_token1] = ACTIONS(3144),
    [aux_sym_preproc_def_token1] = ACTIONS(3144),
    [aux_sym_preproc_if_token1] = ACTIONS(3144),
    [aux_sym_preproc_if_token2] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3144),
    [aux_sym_preproc_else_token1] = ACTIONS(3144),
    [aux_sym_preproc_elif_token1] = ACTIONS(3144),
    [sym_preproc_directive] = ACTIONS(3144),
    [anon_sym_LPAREN2] = ACTIONS(3146),
    [anon_sym_BANG] = ACTIONS(3146),
    [anon_sym_TILDE] = ACTIONS(3146),
    [anon_sym_DASH] = ACTIONS(3144),
    [anon_sym_PLUS] = ACTIONS(3144),
    [anon_sym_STAR] = ACTIONS(3146),
    [anon_sym_AMP_AMP] = ACTIONS(3146),
    [anon_sym_AMP] = ACTIONS(3144),
    [anon_sym_SEMI] = ACTIONS(3146),
    [anon_sym___extension__] = ACTIONS(3144),
    [anon_sym_typedef] = ACTIONS(3144),
    [anon_sym_extern] = ACTIONS(3144),
    [anon_sym___attribute__] = ACTIONS(3144),
    [anon_sym_COLON_COLON] = ACTIONS(3146),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3146),
    [anon_sym___declspec] = ACTIONS(3144),
    [anon_sym___based] = ACTIONS(3144),
    [anon_sym___cdecl] = ACTIONS(3144),
    [anon_sym___clrcall] = ACTIONS(3144),
    [anon_sym___stdcall] = ACTIONS(3144),
    [anon_sym___fastcall] = ACTIONS(3144),
    [anon_sym___thiscall] = ACTIONS(3144),
    [anon_sym___vectorcall] = ACTIONS(3144),
    [anon_sym_LBRACE] = ACTIONS(3146),
    [anon_sym_signed] = ACTIONS(3144),
    [anon_sym_unsigned] = ACTIONS(3144),
    [anon_sym_long] = ACTIONS(3144),
    [anon_sym_short] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3144),
    [anon_sym_static] = ACTIONS(3144),
    [anon_sym_register] = ACTIONS(3144),
    [anon_sym_inline] = ACTIONS(3144),
    [anon_sym___inline] = ACTIONS(3144),
    [anon_sym___inline__] = ACTIONS(3144),
    [anon_sym___forceinline] = ACTIONS(3144),
    [anon_sym_thread_local] = ACTIONS(3144),
    [anon_sym___thread] = ACTIONS(3144),
    [anon_sym_const] = ACTIONS(3144),
    [anon_sym_constexpr] = ACTIONS(3144),
    [anon_sym_volatile] = ACTIONS(3144),
    [anon_sym_restrict] = ACTIONS(3144),
    [anon_sym___restrict__] = ACTIONS(3144),
    [anon_sym__Atomic] = ACTIONS(3144),
    [anon_sym__Noreturn] = ACTIONS(3144),
    [anon_sym_noreturn] = ACTIONS(3144),
    [anon_sym_mutable] = ACTIONS(3144),
    [anon_sym_constinit] = ACTIONS(3144),
    [anon_sym_consteval] = ACTIONS(3144),
    [anon_sym_PROGMEM] = ACTIONS(3144),
    [aux_sym_primitive_type_token1] = ACTIONS(3144),
    [anon_sym_byte] = ACTIONS(3144),
    [anon_sym_word] = ACTIONS(3144),
    [anon_sym_enum] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_struct] = ACTIONS(3144),
    [anon_sym_union] = ACTIONS(3144),
    [anon_sym_if] = ACTIONS(3144),
    [anon_sym_else] = ACTIONS(3144),
    [anon_sym_switch] = ACTIONS(3144),
    [anon_sym_case] = ACTIONS(3144),
    [anon_sym_default] = ACTIONS(3144),
    [anon_sym_while] = ACTIONS(3144),
    [anon_sym_do] = ACTIONS(3144),
    [anon_sym_for] = ACTIONS(3144),
    [anon_sym_return] = ACTIONS(3144),
    [anon_sym_break] = ACTIONS(3144),
    [anon_sym_continue] = ACTIONS(3144),
    [anon_sym_goto] = ACTIONS(3144),
    [anon_sym___try] = ACTIONS(3144),
    [anon_sym___leave] = ACTIONS(3144),
    [anon_sym_not] = ACTIONS(3144),
    [anon_sym_compl] = ACTIONS(3144),
    [anon_sym_DASH_DASH] = ACTIONS(3146),
    [anon_sym_PLUS_PLUS] = ACTIONS(3146),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3144),
    [anon_sym___alignof] = ACTIONS(3144),
    [anon_sym__alignof] = ACTIONS(3144),
    [anon_sym_alignof] = ACTIONS(3144),
    [anon_sym__Alignof] = ACTIONS(3144),
    [anon_sym_offsetof] = ACTIONS(3144),
    [anon_sym__Generic] = ACTIONS(3144),
    [anon_sym_asm] = ACTIONS(3144),
    [anon_sym___asm__] = ACTIONS(3144),
    [aux_sym_number_literal_token1] = ACTIONS(3146),
    [aux_sym_number_literal_token2] = ACTIONS(3144),
    [anon_sym_L_SQUOTE] = ACTIONS(3146),
    [anon_sym_u_SQUOTE] = ACTIONS(3146),
    [anon_sym_U_SQUOTE] = ACTIONS(3146),
    [anon_sym_u8_SQUOTE] = ACTIONS(3146),
    [anon_sym_SQUOTE] = ACTIONS(3146),
    [anon_sym_L_DQUOTE] = ACTIONS(3146),
    [anon_sym_u_DQUOTE] = ACTIONS(3146),
    [anon_sym_U_DQUOTE] = ACTIONS(3146),
    [anon_sym_u8_DQUOTE] = ACTIONS(3146),
    [anon_sym_DQUOTE] = ACTIONS(3146),
    [sym_true] = ACTIONS(3144),
    [sym_false] = ACTIONS(3144),
    [anon_sym_NULL] = ACTIONS(3144),
    [anon_sym_nullptr] = ACTIONS(3144),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3144),
    [anon_sym_decltype] = ACTIONS(3144),
    [anon_sym_virtual] = ACTIONS(3144),
    [anon_sym_alignas] = ACTIONS(3144),
    [anon_sym_explicit] = ACTIONS(3144),
    [anon_sym_typename] = ACTIONS(3144),
    [anon_sym_template] = ACTIONS(3144),
    [anon_sym_operator] = ACTIONS(3144),
    [anon_sym_try] = ACTIONS(3144),
    [anon_sym_delete] = ACTIONS(3144),
    [anon_sym_throw] = ACTIONS(3144),
    [anon_sym_namespace] = ACTIONS(3144),
    [anon_sym_using] = ACTIONS(3144),
    [anon_sym_static_assert] = ACTIONS(3144),
    [anon_sym_concept] = ACTIONS(3144),
    [anon_sym_co_return] = ACTIONS(3144),
    [anon_sym_co_yield] = ACTIONS(3144),
    [anon_sym_R_DQUOTE] = ACTIONS(3146),
    [anon_sym_LR_DQUOTE] = ACTIONS(3146),
    [anon_sym_uR_DQUOTE] = ACTIONS(3146),
    [anon_sym_UR_DQUOTE] = ACTIONS(3146),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3146),
    [anon_sym_co_await] = ACTIONS(3144),
    [anon_sym_new] = ACTIONS(3144),
    [anon_sym_requires] = ACTIONS(3144),
    [sym_this] = ACTIONS(3144),
  },
  [541] = {
    [sym_identifier] = ACTIONS(3128),
    [aux_sym_preproc_include_token1] = ACTIONS(3128),
    [aux_sym_preproc_def_token1] = ACTIONS(3128),
    [aux_sym_preproc_if_token1] = ACTIONS(3128),
    [aux_sym_preproc_if_token2] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3128),
    [aux_sym_preproc_else_token1] = ACTIONS(3128),
    [aux_sym_preproc_elif_token1] = ACTIONS(3128),
    [sym_preproc_directive] = ACTIONS(3128),
    [anon_sym_LPAREN2] = ACTIONS(3130),
    [anon_sym_BANG] = ACTIONS(3130),
    [anon_sym_TILDE] = ACTIONS(3130),
    [anon_sym_DASH] = ACTIONS(3128),
    [anon_sym_PLUS] = ACTIONS(3128),
    [anon_sym_STAR] = ACTIONS(3130),
    [anon_sym_AMP_AMP] = ACTIONS(3130),
    [anon_sym_AMP] = ACTIONS(3128),
    [anon_sym_SEMI] = ACTIONS(3130),
    [anon_sym___extension__] = ACTIONS(3128),
    [anon_sym_typedef] = ACTIONS(3128),
    [anon_sym_extern] = ACTIONS(3128),
    [anon_sym___attribute__] = ACTIONS(3128),
    [anon_sym_COLON_COLON] = ACTIONS(3130),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3130),
    [anon_sym___declspec] = ACTIONS(3128),
    [anon_sym___based] = ACTIONS(3128),
    [anon_sym___cdecl] = ACTIONS(3128),
    [anon_sym___clrcall] = ACTIONS(3128),
    [anon_sym___stdcall] = ACTIONS(3128),
    [anon_sym___fastcall] = ACTIONS(3128),
    [anon_sym___thiscall] = ACTIONS(3128),
    [anon_sym___vectorcall] = ACTIONS(3128),
    [anon_sym_LBRACE] = ACTIONS(3130),
    [anon_sym_signed] = ACTIONS(3128),
    [anon_sym_unsigned] = ACTIONS(3128),
    [anon_sym_long] = ACTIONS(3128),
    [anon_sym_short] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3128),
    [anon_sym_static] = ACTIONS(3128),
    [anon_sym_register] = ACTIONS(3128),
    [anon_sym_inline] = ACTIONS(3128),
    [anon_sym___inline] = ACTIONS(3128),
    [anon_sym___inline__] = ACTIONS(3128),
    [anon_sym___forceinline] = ACTIONS(3128),
    [anon_sym_thread_local] = ACTIONS(3128),
    [anon_sym___thread] = ACTIONS(3128),
    [anon_sym_const] = ACTIONS(3128),
    [anon_sym_constexpr] = ACTIONS(3128),
    [anon_sym_volatile] = ACTIONS(3128),
    [anon_sym_restrict] = ACTIONS(3128),
    [anon_sym___restrict__] = ACTIONS(3128),
    [anon_sym__Atomic] = ACTIONS(3128),
    [anon_sym__Noreturn] = ACTIONS(3128),
    [anon_sym_noreturn] = ACTIONS(3128),
    [anon_sym_mutable] = ACTIONS(3128),
    [anon_sym_constinit] = ACTIONS(3128),
    [anon_sym_consteval] = ACTIONS(3128),
    [anon_sym_PROGMEM] = ACTIONS(3128),
    [aux_sym_primitive_type_token1] = ACTIONS(3128),
    [anon_sym_byte] = ACTIONS(3128),
    [anon_sym_word] = ACTIONS(3128),
    [anon_sym_enum] = ACTIONS(3128),
    [anon_sym_class] = ACTIONS(3128),
    [anon_sym_struct] = ACTIONS(3128),
    [anon_sym_union] = ACTIONS(3128),
    [anon_sym_if] = ACTIONS(3128),
    [anon_sym_else] = ACTIONS(3128),
    [anon_sym_switch] = ACTIONS(3128),
    [anon_sym_case] = ACTIONS(3128),
    [anon_sym_default] = ACTIONS(3128),
    [anon_sym_while] = ACTIONS(3128),
    [anon_sym_do] = ACTIONS(3128),
    [anon_sym_for] = ACTIONS(3128),
    [anon_sym_return] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3128),
    [anon_sym_continue] = ACTIONS(3128),
    [anon_sym_goto] = ACTIONS(3128),
    [anon_sym___try] = ACTIONS(3128),
    [anon_sym___leave] = ACTIONS(3128),
    [anon_sym_not] = ACTIONS(3128),
    [anon_sym_compl] = ACTIONS(3128),
    [anon_sym_DASH_DASH] = ACTIONS(3130),
    [anon_sym_PLUS_PLUS] = ACTIONS(3130),
    [anon_sym_sizeof] = ACTIONS(3128),
    [anon_sym___alignof__] = ACTIONS(3128),
    [anon_sym___alignof] = ACTIONS(3128),
    [anon_sym__alignof] = ACTIONS(3128),
    [anon_sym_alignof] = ACTIONS(3128),
    [anon_sym__Alignof] = ACTIONS(3128),
    [anon_sym_offsetof] = ACTIONS(3128),
    [anon_sym__Generic] = ACTIONS(3128),
    [anon_sym_asm] = ACTIONS(3128),
    [anon_sym___asm__] = ACTIONS(3128),
    [aux_sym_number_literal_token1] = ACTIONS(3130),
    [aux_sym_number_literal_token2] = ACTIONS(3128),
    [anon_sym_L_SQUOTE] = ACTIONS(3130),
    [anon_sym_u_SQUOTE] = ACTIONS(3130),
    [anon_sym_U_SQUOTE] = ACTIONS(3130),
    [anon_sym_u8_SQUOTE] = ACTIONS(3130),
    [anon_sym_SQUOTE] = ACTIONS(3130),
    [anon_sym_L_DQUOTE] = ACTIONS(3130),
    [anon_sym_u_DQUOTE] = ACTIONS(3130),
    [anon_sym_U_DQUOTE] = ACTIONS(3130),
    [anon_sym_u8_DQUOTE] = ACTIONS(3130),
    [anon_sym_DQUOTE] = ACTIONS(3130),
    [sym_true] = ACTIONS(3128),
    [sym_false] = ACTIONS(3128),
    [anon_sym_NULL] = ACTIONS(3128),
    [anon_sym_nullptr] = ACTIONS(3128),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3128),
    [anon_sym_decltype] = ACTIONS(3128),
    [anon_sym_virtual] = ACTIONS(3128),
    [anon_sym_alignas] = ACTIONS(3128),
    [anon_sym_explicit] = ACTIONS(3128),
    [anon_sym_typename] = ACTIONS(3128),
    [anon_sym_template] = ACTIONS(3128),
    [anon_sym_operator] = ACTIONS(3128),
    [anon_sym_try] = ACTIONS(3128),
    [anon_sym_delete] = ACTIONS(3128),
    [anon_sym_throw] = ACTIONS(3128),
    [anon_sym_namespace] = ACTIONS(3128),
    [anon_sym_using] = ACTIONS(3128),
    [anon_sym_static_assert] = ACTIONS(3128),
    [anon_sym_concept] = ACTIONS(3128),
    [anon_sym_co_return] = ACTIONS(3128),
    [anon_sym_co_yield] = ACTIONS(3128),
    [anon_sym_R_DQUOTE] = ACTIONS(3130),
    [anon_sym_LR_DQUOTE] = ACTIONS(3130),
    [anon_sym_uR_DQUOTE] = ACTIONS(3130),
    [anon_sym_UR_DQUOTE] = ACTIONS(3130),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3130),
    [anon_sym_co_await] = ACTIONS(3128),
    [anon_sym_new] = ACTIONS(3128),
    [anon_sym_requires] = ACTIONS(3128),
    [sym_this] = ACTIONS(3128),
  },
  [542] = {
    [sym_identifier] = ACTIONS(3419),
    [aux_sym_preproc_include_token1] = ACTIONS(3419),
    [aux_sym_preproc_def_token1] = ACTIONS(3419),
    [aux_sym_preproc_if_token1] = ACTIONS(3419),
    [aux_sym_preproc_if_token2] = ACTIONS(3419),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3419),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3419),
    [aux_sym_preproc_else_token1] = ACTIONS(3419),
    [aux_sym_preproc_elif_token1] = ACTIONS(3419),
    [sym_preproc_directive] = ACTIONS(3419),
    [anon_sym_LPAREN2] = ACTIONS(3421),
    [anon_sym_BANG] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_SEMI] = ACTIONS(3421),
    [anon_sym___extension__] = ACTIONS(3419),
    [anon_sym_typedef] = ACTIONS(3419),
    [anon_sym_extern] = ACTIONS(3419),
    [anon_sym___attribute__] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3421),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3421),
    [anon_sym___declspec] = ACTIONS(3419),
    [anon_sym___based] = ACTIONS(3419),
    [anon_sym___cdecl] = ACTIONS(3419),
    [anon_sym___clrcall] = ACTIONS(3419),
    [anon_sym___stdcall] = ACTIONS(3419),
    [anon_sym___fastcall] = ACTIONS(3419),
    [anon_sym___thiscall] = ACTIONS(3419),
    [anon_sym___vectorcall] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_signed] = ACTIONS(3419),
    [anon_sym_unsigned] = ACTIONS(3419),
    [anon_sym_long] = ACTIONS(3419),
    [anon_sym_short] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_register] = ACTIONS(3419),
    [anon_sym_inline] = ACTIONS(3419),
    [anon_sym___inline] = ACTIONS(3419),
    [anon_sym___inline__] = ACTIONS(3419),
    [anon_sym___forceinline] = ACTIONS(3419),
    [anon_sym_thread_local] = ACTIONS(3419),
    [anon_sym___thread] = ACTIONS(3419),
    [anon_sym_const] = ACTIONS(3419),
    [anon_sym_constexpr] = ACTIONS(3419),
    [anon_sym_volatile] = ACTIONS(3419),
    [anon_sym_restrict] = ACTIONS(3419),
    [anon_sym___restrict__] = ACTIONS(3419),
    [anon_sym__Atomic] = ACTIONS(3419),
    [anon_sym__Noreturn] = ACTIONS(3419),
    [anon_sym_noreturn] = ACTIONS(3419),
    [anon_sym_mutable] = ACTIONS(3419),
    [anon_sym_constinit] = ACTIONS(3419),
    [anon_sym_consteval] = ACTIONS(3419),
    [anon_sym_PROGMEM] = ACTIONS(3419),
    [aux_sym_primitive_type_token1] = ACTIONS(3419),
    [anon_sym_byte] = ACTIONS(3419),
    [anon_sym_word] = ACTIONS(3419),
    [anon_sym_enum] = ACTIONS(3419),
    [anon_sym_class] = ACTIONS(3419),
    [anon_sym_struct] = ACTIONS(3419),
    [anon_sym_union] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_switch] = ACTIONS(3419),
    [anon_sym_case] = ACTIONS(3419),
    [anon_sym_default] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_break] = ACTIONS(3419),
    [anon_sym_continue] = ACTIONS(3419),
    [anon_sym_goto] = ACTIONS(3419),
    [anon_sym___try] = ACTIONS(3419),
    [anon_sym___leave] = ACTIONS(3419),
    [anon_sym_not] = ACTIONS(3419),
    [anon_sym_compl] = ACTIONS(3419),
    [anon_sym_DASH_DASH] = ACTIONS(3421),
    [anon_sym_PLUS_PLUS] = ACTIONS(3421),
    [anon_sym_sizeof] = ACTIONS(3419),
    [anon_sym___alignof__] = ACTIONS(3419),
    [anon_sym___alignof] = ACTIONS(3419),
    [anon_sym__alignof] = ACTIONS(3419),
    [anon_sym_alignof] = ACTIONS(3419),
    [anon_sym__Alignof] = ACTIONS(3419),
    [anon_sym_offsetof] = ACTIONS(3419),
    [anon_sym__Generic] = ACTIONS(3419),
    [anon_sym_asm] = ACTIONS(3419),
    [anon_sym___asm__] = ACTIONS(3419),
    [aux_sym_number_literal_token1] = ACTIONS(3421),
    [aux_sym_number_literal_token2] = ACTIONS(3419),
    [anon_sym_L_SQUOTE] = ACTIONS(3421),
    [anon_sym_u_SQUOTE] = ACTIONS(3421),
    [anon_sym_U_SQUOTE] = ACTIONS(3421),
    [anon_sym_u8_SQUOTE] = ACTIONS(3421),
    [anon_sym_SQUOTE] = ACTIONS(3421),
    [anon_sym_L_DQUOTE] = ACTIONS(3421),
    [anon_sym_u_DQUOTE] = ACTIONS(3421),
    [anon_sym_U_DQUOTE] = ACTIONS(3421),
    [anon_sym_u8_DQUOTE] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [sym_true] = ACTIONS(3419),
    [sym_false] = ACTIONS(3419),
    [anon_sym_NULL] = ACTIONS(3419),
    [anon_sym_nullptr] = ACTIONS(3419),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3419),
    [anon_sym_decltype] = ACTIONS(3419),
    [anon_sym_virtual] = ACTIONS(3419),
    [anon_sym_alignas] = ACTIONS(3419),
    [anon_sym_explicit] = ACTIONS(3419),
    [anon_sym_typename] = ACTIONS(3419),
    [anon_sym_template] = ACTIONS(3419),
    [anon_sym_operator] = ACTIONS(3419),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_delete] = ACTIONS(3419),
    [anon_sym_throw] = ACTIONS(3419),
    [anon_sym_namespace] = ACTIONS(3419),
    [anon_sym_using] = ACTIONS(3419),
    [anon_sym_static_assert] = ACTIONS(3419),
    [anon_sym_concept] = ACTIONS(3419),
    [anon_sym_co_return] = ACTIONS(3419),
    [anon_sym_co_yield] = ACTIONS(3419),
    [anon_sym_R_DQUOTE] = ACTIONS(3421),
    [anon_sym_LR_DQUOTE] = ACTIONS(3421),
    [anon_sym_uR_DQUOTE] = ACTIONS(3421),
    [anon_sym_UR_DQUOTE] = ACTIONS(3421),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3421),
    [anon_sym_co_await] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_requires] = ACTIONS(3419),
    [sym_this] = ACTIONS(3419),
  },
  [543] = {
    [sym_identifier] = ACTIONS(3383),
    [aux_sym_preproc_include_token1] = ACTIONS(3383),
    [aux_sym_preproc_def_token1] = ACTIONS(3383),
    [aux_sym_preproc_if_token1] = ACTIONS(3383),
    [aux_sym_preproc_if_token2] = ACTIONS(3383),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3383),
    [aux_sym_preproc_else_token1] = ACTIONS(3383),
    [aux_sym_preproc_elif_token1] = ACTIONS(3383),
    [sym_preproc_directive] = ACTIONS(3383),
    [anon_sym_LPAREN2] = ACTIONS(3385),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_TILDE] = ACTIONS(3385),
    [anon_sym_DASH] = ACTIONS(3383),
    [anon_sym_PLUS] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(3385),
    [anon_sym_AMP_AMP] = ACTIONS(3385),
    [anon_sym_AMP] = ACTIONS(3383),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym___extension__] = ACTIONS(3383),
    [anon_sym_typedef] = ACTIONS(3383),
    [anon_sym_extern] = ACTIONS(3383),
    [anon_sym___attribute__] = ACTIONS(3383),
    [anon_sym_COLON_COLON] = ACTIONS(3385),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3385),
    [anon_sym___declspec] = ACTIONS(3383),
    [anon_sym___based] = ACTIONS(3383),
    [anon_sym___cdecl] = ACTIONS(3383),
    [anon_sym___clrcall] = ACTIONS(3383),
    [anon_sym___stdcall] = ACTIONS(3383),
    [anon_sym___fastcall] = ACTIONS(3383),
    [anon_sym___thiscall] = ACTIONS(3383),
    [anon_sym___vectorcall] = ACTIONS(3383),
    [anon_sym_LBRACE] = ACTIONS(3385),
    [anon_sym_signed] = ACTIONS(3383),
    [anon_sym_unsigned] = ACTIONS(3383),
    [anon_sym_long] = ACTIONS(3383),
    [anon_sym_short] = ACTIONS(3383),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_static] = ACTIONS(3383),
    [anon_sym_register] = ACTIONS(3383),
    [anon_sym_inline] = ACTIONS(3383),
    [anon_sym___inline] = ACTIONS(3383),
    [anon_sym___inline__] = ACTIONS(3383),
    [anon_sym___forceinline] = ACTIONS(3383),
    [anon_sym_thread_local] = ACTIONS(3383),
    [anon_sym___thread] = ACTIONS(3383),
    [anon_sym_const] = ACTIONS(3383),
    [anon_sym_constexpr] = ACTIONS(3383),
    [anon_sym_volatile] = ACTIONS(3383),
    [anon_sym_restrict] = ACTIONS(3383),
    [anon_sym___restrict__] = ACTIONS(3383),
    [anon_sym__Atomic] = ACTIONS(3383),
    [anon_sym__Noreturn] = ACTIONS(3383),
    [anon_sym_noreturn] = ACTIONS(3383),
    [anon_sym_mutable] = ACTIONS(3383),
    [anon_sym_constinit] = ACTIONS(3383),
    [anon_sym_consteval] = ACTIONS(3383),
    [anon_sym_PROGMEM] = ACTIONS(3383),
    [aux_sym_primitive_type_token1] = ACTIONS(3383),
    [anon_sym_byte] = ACTIONS(3383),
    [anon_sym_word] = ACTIONS(3383),
    [anon_sym_enum] = ACTIONS(3383),
    [anon_sym_class] = ACTIONS(3383),
    [anon_sym_struct] = ACTIONS(3383),
    [anon_sym_union] = ACTIONS(3383),
    [anon_sym_if] = ACTIONS(3383),
    [anon_sym_switch] = ACTIONS(3383),
    [anon_sym_case] = ACTIONS(3383),
    [anon_sym_default] = ACTIONS(3383),
    [anon_sym_while] = ACTIONS(3383),
    [anon_sym_do] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3383),
    [anon_sym_return] = ACTIONS(3383),
    [anon_sym_break] = ACTIONS(3383),
    [anon_sym_continue] = ACTIONS(3383),
    [anon_sym_goto] = ACTIONS(3383),
    [anon_sym___try] = ACTIONS(3383),
    [anon_sym___leave] = ACTIONS(3383),
    [anon_sym_not] = ACTIONS(3383),
    [anon_sym_compl] = ACTIONS(3383),
    [anon_sym_DASH_DASH] = ACTIONS(3385),
    [anon_sym_PLUS_PLUS] = ACTIONS(3385),
    [anon_sym_sizeof] = ACTIONS(3383),
    [anon_sym___alignof__] = ACTIONS(3383),
    [anon_sym___alignof] = ACTIONS(3383),
    [anon_sym__alignof] = ACTIONS(3383),
    [anon_sym_alignof] = ACTIONS(3383),
    [anon_sym__Alignof] = ACTIONS(3383),
    [anon_sym_offsetof] = ACTIONS(3383),
    [anon_sym__Generic] = ACTIONS(3383),
    [anon_sym_asm] = ACTIONS(3383),
    [anon_sym___asm__] = ACTIONS(3383),
    [aux_sym_number_literal_token1] = ACTIONS(3385),
    [aux_sym_number_literal_token2] = ACTIONS(3383),
    [anon_sym_L_SQUOTE] = ACTIONS(3385),
    [anon_sym_u_SQUOTE] = ACTIONS(3385),
    [anon_sym_U_SQUOTE] = ACTIONS(3385),
    [anon_sym_u8_SQUOTE] = ACTIONS(3385),
    [anon_sym_SQUOTE] = ACTIONS(3385),
    [anon_sym_L_DQUOTE] = ACTIONS(3385),
    [anon_sym_u_DQUOTE] = ACTIONS(3385),
    [anon_sym_U_DQUOTE] = ACTIONS(3385),
    [anon_sym_u8_DQUOTE] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(3385),
    [sym_true] = ACTIONS(3383),
    [sym_false] = ACTIONS(3383),
    [anon_sym_NULL] = ACTIONS(3383),
    [anon_sym_nullptr] = ACTIONS(3383),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3383),
    [anon_sym_decltype] = ACTIONS(3383),
    [anon_sym_virtual] = ACTIONS(3383),
    [anon_sym_alignas] = ACTIONS(3383),
    [anon_sym_explicit] = ACTIONS(3383),
    [anon_sym_typename] = ACTIONS(3383),
    [anon_sym_template] = ACTIONS(3383),
    [anon_sym_operator] = ACTIONS(3383),
    [anon_sym_try] = ACTIONS(3383),
    [anon_sym_delete] = ACTIONS(3383),
    [anon_sym_throw] = ACTIONS(3383),
    [anon_sym_namespace] = ACTIONS(3383),
    [anon_sym_using] = ACTIONS(3383),
    [anon_sym_static_assert] = ACTIONS(3383),
    [anon_sym_concept] = ACTIONS(3383),
    [anon_sym_co_return] = ACTIONS(3383),
    [anon_sym_co_yield] = ACTIONS(3383),
    [anon_sym_R_DQUOTE] = ACTIONS(3385),
    [anon_sym_LR_DQUOTE] = ACTIONS(3385),
    [anon_sym_uR_DQUOTE] = ACTIONS(3385),
    [anon_sym_UR_DQUOTE] = ACTIONS(3385),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3385),
    [anon_sym_co_await] = ACTIONS(3383),
    [anon_sym_new] = ACTIONS(3383),
    [anon_sym_requires] = ACTIONS(3383),
    [sym_this] = ACTIONS(3383),
  },
  [544] = {
    [sym_identifier] = ACTIONS(3192),
    [aux_sym_preproc_include_token1] = ACTIONS(3192),
    [aux_sym_preproc_def_token1] = ACTIONS(3192),
    [aux_sym_preproc_if_token1] = ACTIONS(3192),
    [aux_sym_preproc_if_token2] = ACTIONS(3192),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3192),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3192),
    [aux_sym_preproc_else_token1] = ACTIONS(3192),
    [aux_sym_preproc_elif_token1] = ACTIONS(3192),
    [sym_preproc_directive] = ACTIONS(3192),
    [anon_sym_LPAREN2] = ACTIONS(3194),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_DASH] = ACTIONS(3192),
    [anon_sym_PLUS] = ACTIONS(3192),
    [anon_sym_STAR] = ACTIONS(3194),
    [anon_sym_AMP_AMP] = ACTIONS(3194),
    [anon_sym_AMP] = ACTIONS(3192),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym___extension__] = ACTIONS(3192),
    [anon_sym_typedef] = ACTIONS(3192),
    [anon_sym_extern] = ACTIONS(3192),
    [anon_sym___attribute__] = ACTIONS(3192),
    [anon_sym_COLON_COLON] = ACTIONS(3194),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3194),
    [anon_sym___declspec] = ACTIONS(3192),
    [anon_sym___based] = ACTIONS(3192),
    [anon_sym___cdecl] = ACTIONS(3192),
    [anon_sym___clrcall] = ACTIONS(3192),
    [anon_sym___stdcall] = ACTIONS(3192),
    [anon_sym___fastcall] = ACTIONS(3192),
    [anon_sym___thiscall] = ACTIONS(3192),
    [anon_sym___vectorcall] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_signed] = ACTIONS(3192),
    [anon_sym_unsigned] = ACTIONS(3192),
    [anon_sym_long] = ACTIONS(3192),
    [anon_sym_short] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [anon_sym_static] = ACTIONS(3192),
    [anon_sym_register] = ACTIONS(3192),
    [anon_sym_inline] = ACTIONS(3192),
    [anon_sym___inline] = ACTIONS(3192),
    [anon_sym___inline__] = ACTIONS(3192),
    [anon_sym___forceinline] = ACTIONS(3192),
    [anon_sym_thread_local] = ACTIONS(3192),
    [anon_sym___thread] = ACTIONS(3192),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_constexpr] = ACTIONS(3192),
    [anon_sym_volatile] = ACTIONS(3192),
    [anon_sym_restrict] = ACTIONS(3192),
    [anon_sym___restrict__] = ACTIONS(3192),
    [anon_sym__Atomic] = ACTIONS(3192),
    [anon_sym__Noreturn] = ACTIONS(3192),
    [anon_sym_noreturn] = ACTIONS(3192),
    [anon_sym_mutable] = ACTIONS(3192),
    [anon_sym_constinit] = ACTIONS(3192),
    [anon_sym_consteval] = ACTIONS(3192),
    [anon_sym_PROGMEM] = ACTIONS(3192),
    [aux_sym_primitive_type_token1] = ACTIONS(3192),
    [anon_sym_byte] = ACTIONS(3192),
    [anon_sym_word] = ACTIONS(3192),
    [anon_sym_enum] = ACTIONS(3192),
    [anon_sym_class] = ACTIONS(3192),
    [anon_sym_struct] = ACTIONS(3192),
    [anon_sym_union] = ACTIONS(3192),
    [anon_sym_if] = ACTIONS(3192),
    [anon_sym_switch] = ACTIONS(3192),
    [anon_sym_case] = ACTIONS(3192),
    [anon_sym_default] = ACTIONS(3192),
    [anon_sym_while] = ACTIONS(3192),
    [anon_sym_do] = ACTIONS(3192),
    [anon_sym_for] = ACTIONS(3192),
    [anon_sym_return] = ACTIONS(3192),
    [anon_sym_break] = ACTIONS(3192),
    [anon_sym_continue] = ACTIONS(3192),
    [anon_sym_goto] = ACTIONS(3192),
    [anon_sym___try] = ACTIONS(3192),
    [anon_sym___leave] = ACTIONS(3192),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_compl] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3194),
    [anon_sym_PLUS_PLUS] = ACTIONS(3194),
    [anon_sym_sizeof] = ACTIONS(3192),
    [anon_sym___alignof__] = ACTIONS(3192),
    [anon_sym___alignof] = ACTIONS(3192),
    [anon_sym__alignof] = ACTIONS(3192),
    [anon_sym_alignof] = ACTIONS(3192),
    [anon_sym__Alignof] = ACTIONS(3192),
    [anon_sym_offsetof] = ACTIONS(3192),
    [anon_sym__Generic] = ACTIONS(3192),
    [anon_sym_asm] = ACTIONS(3192),
    [anon_sym___asm__] = ACTIONS(3192),
    [aux_sym_number_literal_token1] = ACTIONS(3194),
    [aux_sym_number_literal_token2] = ACTIONS(3192),
    [anon_sym_L_SQUOTE] = ACTIONS(3194),
    [anon_sym_u_SQUOTE] = ACTIONS(3194),
    [anon_sym_U_SQUOTE] = ACTIONS(3194),
    [anon_sym_u8_SQUOTE] = ACTIONS(3194),
    [anon_sym_SQUOTE] = ACTIONS(3194),
    [anon_sym_L_DQUOTE] = ACTIONS(3194),
    [anon_sym_u_DQUOTE] = ACTIONS(3194),
    [anon_sym_U_DQUOTE] = ACTIONS(3194),
    [anon_sym_u8_DQUOTE] = ACTIONS(3194),
    [anon_sym_DQUOTE] = ACTIONS(3194),
    [sym_true] = ACTIONS(3192),
    [sym_false] = ACTIONS(3192),
    [anon_sym_NULL] = ACTIONS(3192),
    [anon_sym_nullptr] = ACTIONS(3192),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3192),
    [anon_sym_decltype] = ACTIONS(3192),
    [anon_sym_virtual] = ACTIONS(3192),
    [anon_sym_alignas] = ACTIONS(3192),
    [anon_sym_explicit] = ACTIONS(3192),
    [anon_sym_typename] = ACTIONS(3192),
    [anon_sym_template] = ACTIONS(3192),
    [anon_sym_operator] = ACTIONS(3192),
    [anon_sym_try] = ACTIONS(3192),
    [anon_sym_delete] = ACTIONS(3192),
    [anon_sym_throw] = ACTIONS(3192),
    [anon_sym_namespace] = ACTIONS(3192),
    [anon_sym_using] = ACTIONS(3192),
    [anon_sym_static_assert] = ACTIONS(3192),
    [anon_sym_concept] = ACTIONS(3192),
    [anon_sym_co_return] = ACTIONS(3192),
    [anon_sym_co_yield] = ACTIONS(3192),
    [anon_sym_R_DQUOTE] = ACTIONS(3194),
    [anon_sym_LR_DQUOTE] = ACTIONS(3194),
    [anon_sym_uR_DQUOTE] = ACTIONS(3194),
    [anon_sym_UR_DQUOTE] = ACTIONS(3194),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3194),
    [anon_sym_co_await] = ACTIONS(3192),
    [anon_sym_new] = ACTIONS(3192),
    [anon_sym_requires] = ACTIONS(3192),
    [sym_this] = ACTIONS(3192),
  },
  [545] = {
    [sym_identifier] = ACTIONS(3487),
    [aux_sym_preproc_include_token1] = ACTIONS(3487),
    [aux_sym_preproc_def_token1] = ACTIONS(3487),
    [aux_sym_preproc_if_token1] = ACTIONS(3487),
    [aux_sym_preproc_if_token2] = ACTIONS(3487),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3487),
    [aux_sym_preproc_else_token1] = ACTIONS(3487),
    [aux_sym_preproc_elif_token1] = ACTIONS(3487),
    [sym_preproc_directive] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3489),
    [anon_sym_BANG] = ACTIONS(3489),
    [anon_sym_TILDE] = ACTIONS(3489),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3489),
    [anon_sym_AMP_AMP] = ACTIONS(3489),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_SEMI] = ACTIONS(3489),
    [anon_sym___extension__] = ACTIONS(3487),
    [anon_sym_typedef] = ACTIONS(3487),
    [anon_sym_extern] = ACTIONS(3487),
    [anon_sym___attribute__] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3489),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3489),
    [anon_sym___declspec] = ACTIONS(3487),
    [anon_sym___based] = ACTIONS(3487),
    [anon_sym___cdecl] = ACTIONS(3487),
    [anon_sym___clrcall] = ACTIONS(3487),
    [anon_sym___stdcall] = ACTIONS(3487),
    [anon_sym___fastcall] = ACTIONS(3487),
    [anon_sym___thiscall] = ACTIONS(3487),
    [anon_sym___vectorcall] = ACTIONS(3487),
    [anon_sym_LBRACE] = ACTIONS(3489),
    [anon_sym_signed] = ACTIONS(3487),
    [anon_sym_unsigned] = ACTIONS(3487),
    [anon_sym_long] = ACTIONS(3487),
    [anon_sym_short] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_register] = ACTIONS(3487),
    [anon_sym_inline] = ACTIONS(3487),
    [anon_sym___inline] = ACTIONS(3487),
    [anon_sym___inline__] = ACTIONS(3487),
    [anon_sym___forceinline] = ACTIONS(3487),
    [anon_sym_thread_local] = ACTIONS(3487),
    [anon_sym___thread] = ACTIONS(3487),
    [anon_sym_const] = ACTIONS(3487),
    [anon_sym_constexpr] = ACTIONS(3487),
    [anon_sym_volatile] = ACTIONS(3487),
    [anon_sym_restrict] = ACTIONS(3487),
    [anon_sym___restrict__] = ACTIONS(3487),
    [anon_sym__Atomic] = ACTIONS(3487),
    [anon_sym__Noreturn] = ACTIONS(3487),
    [anon_sym_noreturn] = ACTIONS(3487),
    [anon_sym_mutable] = ACTIONS(3487),
    [anon_sym_constinit] = ACTIONS(3487),
    [anon_sym_consteval] = ACTIONS(3487),
    [anon_sym_PROGMEM] = ACTIONS(3487),
    [aux_sym_primitive_type_token1] = ACTIONS(3487),
    [anon_sym_byte] = ACTIONS(3487),
    [anon_sym_word] = ACTIONS(3487),
    [anon_sym_enum] = ACTIONS(3487),
    [anon_sym_class] = ACTIONS(3487),
    [anon_sym_struct] = ACTIONS(3487),
    [anon_sym_union] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_switch] = ACTIONS(3487),
    [anon_sym_case] = ACTIONS(3487),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_break] = ACTIONS(3487),
    [anon_sym_continue] = ACTIONS(3487),
    [anon_sym_goto] = ACTIONS(3487),
    [anon_sym___try] = ACTIONS(3487),
    [anon_sym___leave] = ACTIONS(3487),
    [anon_sym_not] = ACTIONS(3487),
    [anon_sym_compl] = ACTIONS(3487),
    [anon_sym_DASH_DASH] = ACTIONS(3489),
    [anon_sym_PLUS_PLUS] = ACTIONS(3489),
    [anon_sym_sizeof] = ACTIONS(3487),
    [anon_sym___alignof__] = ACTIONS(3487),
    [anon_sym___alignof] = ACTIONS(3487),
    [anon_sym__alignof] = ACTIONS(3487),
    [anon_sym_alignof] = ACTIONS(3487),
    [anon_sym__Alignof] = ACTIONS(3487),
    [anon_sym_offsetof] = ACTIONS(3487),
    [anon_sym__Generic] = ACTIONS(3487),
    [anon_sym_asm] = ACTIONS(3487),
    [anon_sym___asm__] = ACTIONS(3487),
    [aux_sym_number_literal_token1] = ACTIONS(3489),
    [aux_sym_number_literal_token2] = ACTIONS(3487),
    [anon_sym_L_SQUOTE] = ACTIONS(3489),
    [anon_sym_u_SQUOTE] = ACTIONS(3489),
    [anon_sym_U_SQUOTE] = ACTIONS(3489),
    [anon_sym_u8_SQUOTE] = ACTIONS(3489),
    [anon_sym_SQUOTE] = ACTIONS(3489),
    [anon_sym_L_DQUOTE] = ACTIONS(3489),
    [anon_sym_u_DQUOTE] = ACTIONS(3489),
    [anon_sym_U_DQUOTE] = ACTIONS(3489),
    [anon_sym_u8_DQUOTE] = ACTIONS(3489),
    [anon_sym_DQUOTE] = ACTIONS(3489),
    [sym_true] = ACTIONS(3487),
    [sym_false] = ACTIONS(3487),
    [anon_sym_NULL] = ACTIONS(3487),
    [anon_sym_nullptr] = ACTIONS(3487),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3487),
    [anon_sym_decltype] = ACTIONS(3487),
    [anon_sym_virtual] = ACTIONS(3487),
    [anon_sym_alignas] = ACTIONS(3487),
    [anon_sym_explicit] = ACTIONS(3487),
    [anon_sym_typename] = ACTIONS(3487),
    [anon_sym_template] = ACTIONS(3487),
    [anon_sym_operator] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_delete] = ACTIONS(3487),
    [anon_sym_throw] = ACTIONS(3487),
    [anon_sym_namespace] = ACTIONS(3487),
    [anon_sym_using] = ACTIONS(3487),
    [anon_sym_static_assert] = ACTIONS(3487),
    [anon_sym_concept] = ACTIONS(3487),
    [anon_sym_co_return] = ACTIONS(3487),
    [anon_sym_co_yield] = ACTIONS(3487),
    [anon_sym_R_DQUOTE] = ACTIONS(3489),
    [anon_sym_LR_DQUOTE] = ACTIONS(3489),
    [anon_sym_uR_DQUOTE] = ACTIONS(3489),
    [anon_sym_UR_DQUOTE] = ACTIONS(3489),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3489),
    [anon_sym_co_await] = ACTIONS(3487),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_requires] = ACTIONS(3487),
    [sym_this] = ACTIONS(3487),
  },
  [546] = {
    [sym_identifier] = ACTIONS(3387),
    [aux_sym_preproc_include_token1] = ACTIONS(3387),
    [aux_sym_preproc_def_token1] = ACTIONS(3387),
    [aux_sym_preproc_if_token1] = ACTIONS(3387),
    [aux_sym_preproc_if_token2] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3387),
    [aux_sym_preproc_else_token1] = ACTIONS(3387),
    [aux_sym_preproc_elif_token1] = ACTIONS(3387),
    [sym_preproc_directive] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_BANG] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_STAR] = ACTIONS(3389),
    [anon_sym_AMP_AMP] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_SEMI] = ACTIONS(3389),
    [anon_sym___extension__] = ACTIONS(3387),
    [anon_sym_typedef] = ACTIONS(3387),
    [anon_sym_extern] = ACTIONS(3387),
    [anon_sym___attribute__] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3389),
    [anon_sym___declspec] = ACTIONS(3387),
    [anon_sym___based] = ACTIONS(3387),
    [anon_sym___cdecl] = ACTIONS(3387),
    [anon_sym___clrcall] = ACTIONS(3387),
    [anon_sym___stdcall] = ACTIONS(3387),
    [anon_sym___fastcall] = ACTIONS(3387),
    [anon_sym___thiscall] = ACTIONS(3387),
    [anon_sym___vectorcall] = ACTIONS(3387),
    [anon_sym_LBRACE] = ACTIONS(3389),
    [anon_sym_signed] = ACTIONS(3387),
    [anon_sym_unsigned] = ACTIONS(3387),
    [anon_sym_long] = ACTIONS(3387),
    [anon_sym_short] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_register] = ACTIONS(3387),
    [anon_sym_inline] = ACTIONS(3387),
    [anon_sym___inline] = ACTIONS(3387),
    [anon_sym___inline__] = ACTIONS(3387),
    [anon_sym___forceinline] = ACTIONS(3387),
    [anon_sym_thread_local] = ACTIONS(3387),
    [anon_sym___thread] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_constexpr] = ACTIONS(3387),
    [anon_sym_volatile] = ACTIONS(3387),
    [anon_sym_restrict] = ACTIONS(3387),
    [anon_sym___restrict__] = ACTIONS(3387),
    [anon_sym__Atomic] = ACTIONS(3387),
    [anon_sym__Noreturn] = ACTIONS(3387),
    [anon_sym_noreturn] = ACTIONS(3387),
    [anon_sym_mutable] = ACTIONS(3387),
    [anon_sym_constinit] = ACTIONS(3387),
    [anon_sym_consteval] = ACTIONS(3387),
    [anon_sym_PROGMEM] = ACTIONS(3387),
    [aux_sym_primitive_type_token1] = ACTIONS(3387),
    [anon_sym_byte] = ACTIONS(3387),
    [anon_sym_word] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [anon_sym_class] = ACTIONS(3387),
    [anon_sym_struct] = ACTIONS(3387),
    [anon_sym_union] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_switch] = ACTIONS(3387),
    [anon_sym_case] = ACTIONS(3387),
    [anon_sym_default] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_break] = ACTIONS(3387),
    [anon_sym_continue] = ACTIONS(3387),
    [anon_sym_goto] = ACTIONS(3387),
    [anon_sym___try] = ACTIONS(3387),
    [anon_sym___leave] = ACTIONS(3387),
    [anon_sym_not] = ACTIONS(3387),
    [anon_sym_compl] = ACTIONS(3387),
    [anon_sym_DASH_DASH] = ACTIONS(3389),
    [anon_sym_PLUS_PLUS] = ACTIONS(3389),
    [anon_sym_sizeof] = ACTIONS(3387),
    [anon_sym___alignof__] = ACTIONS(3387),
    [anon_sym___alignof] = ACTIONS(3387),
    [anon_sym__alignof] = ACTIONS(3387),
    [anon_sym_alignof] = ACTIONS(3387),
    [anon_sym__Alignof] = ACTIONS(3387),
    [anon_sym_offsetof] = ACTIONS(3387),
    [anon_sym__Generic] = ACTIONS(3387),
    [anon_sym_asm] = ACTIONS(3387),
    [anon_sym___asm__] = ACTIONS(3387),
    [aux_sym_number_literal_token1] = ACTIONS(3389),
    [aux_sym_number_literal_token2] = ACTIONS(3387),
    [anon_sym_L_SQUOTE] = ACTIONS(3389),
    [anon_sym_u_SQUOTE] = ACTIONS(3389),
    [anon_sym_U_SQUOTE] = ACTIONS(3389),
    [anon_sym_u8_SQUOTE] = ACTIONS(3389),
    [anon_sym_SQUOTE] = ACTIONS(3389),
    [anon_sym_L_DQUOTE] = ACTIONS(3389),
    [anon_sym_u_DQUOTE] = ACTIONS(3389),
    [anon_sym_U_DQUOTE] = ACTIONS(3389),
    [anon_sym_u8_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE] = ACTIONS(3389),
    [sym_true] = ACTIONS(3387),
    [sym_false] = ACTIONS(3387),
    [anon_sym_NULL] = ACTIONS(3387),
    [anon_sym_nullptr] = ACTIONS(3387),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3387),
    [anon_sym_decltype] = ACTIONS(3387),
    [anon_sym_virtual] = ACTIONS(3387),
    [anon_sym_alignas] = ACTIONS(3387),
    [anon_sym_explicit] = ACTIONS(3387),
    [anon_sym_typename] = ACTIONS(3387),
    [anon_sym_template] = ACTIONS(3387),
    [anon_sym_operator] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_delete] = ACTIONS(3387),
    [anon_sym_throw] = ACTIONS(3387),
    [anon_sym_namespace] = ACTIONS(3387),
    [anon_sym_using] = ACTIONS(3387),
    [anon_sym_static_assert] = ACTIONS(3387),
    [anon_sym_concept] = ACTIONS(3387),
    [anon_sym_co_return] = ACTIONS(3387),
    [anon_sym_co_yield] = ACTIONS(3387),
    [anon_sym_R_DQUOTE] = ACTIONS(3389),
    [anon_sym_LR_DQUOTE] = ACTIONS(3389),
    [anon_sym_uR_DQUOTE] = ACTIONS(3389),
    [anon_sym_UR_DQUOTE] = ACTIONS(3389),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3389),
    [anon_sym_co_await] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_requires] = ACTIONS(3387),
    [sym_this] = ACTIONS(3387),
  },
  [547] = {
    [sym_else_clause] = STATE(783),
    [sym_identifier] = ACTIONS(2891),
    [aux_sym_preproc_include_token1] = ACTIONS(2891),
    [aux_sym_preproc_def_token1] = ACTIONS(2891),
    [aux_sym_preproc_if_token1] = ACTIONS(2891),
    [aux_sym_preproc_if_token2] = ACTIONS(2891),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2891),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2891),
    [sym_preproc_directive] = ACTIONS(2891),
    [anon_sym_LPAREN2] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_AMP_AMP] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym___extension__] = ACTIONS(2891),
    [anon_sym_typedef] = ACTIONS(2891),
    [anon_sym_extern] = ACTIONS(2891),
    [anon_sym___attribute__] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2893),
    [anon_sym___declspec] = ACTIONS(2891),
    [anon_sym___based] = ACTIONS(2891),
    [anon_sym___cdecl] = ACTIONS(2891),
    [anon_sym___clrcall] = ACTIONS(2891),
    [anon_sym___stdcall] = ACTIONS(2891),
    [anon_sym___fastcall] = ACTIONS(2891),
    [anon_sym___thiscall] = ACTIONS(2891),
    [anon_sym___vectorcall] = ACTIONS(2891),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_signed] = ACTIONS(2891),
    [anon_sym_unsigned] = ACTIONS(2891),
    [anon_sym_long] = ACTIONS(2891),
    [anon_sym_short] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_static] = ACTIONS(2891),
    [anon_sym_register] = ACTIONS(2891),
    [anon_sym_inline] = ACTIONS(2891),
    [anon_sym___inline] = ACTIONS(2891),
    [anon_sym___inline__] = ACTIONS(2891),
    [anon_sym___forceinline] = ACTIONS(2891),
    [anon_sym_thread_local] = ACTIONS(2891),
    [anon_sym___thread] = ACTIONS(2891),
    [anon_sym_const] = ACTIONS(2891),
    [anon_sym_constexpr] = ACTIONS(2891),
    [anon_sym_volatile] = ACTIONS(2891),
    [anon_sym_restrict] = ACTIONS(2891),
    [anon_sym___restrict__] = ACTIONS(2891),
    [anon_sym__Atomic] = ACTIONS(2891),
    [anon_sym__Noreturn] = ACTIONS(2891),
    [anon_sym_noreturn] = ACTIONS(2891),
    [anon_sym_mutable] = ACTIONS(2891),
    [anon_sym_constinit] = ACTIONS(2891),
    [anon_sym_consteval] = ACTIONS(2891),
    [anon_sym_PROGMEM] = ACTIONS(2891),
    [aux_sym_primitive_type_token1] = ACTIONS(2891),
    [anon_sym_byte] = ACTIONS(2891),
    [anon_sym_word] = ACTIONS(2891),
    [anon_sym_enum] = ACTIONS(2891),
    [anon_sym_class] = ACTIONS(2891),
    [anon_sym_struct] = ACTIONS(2891),
    [anon_sym_union] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_else] = ACTIONS(3529),
    [anon_sym_switch] = ACTIONS(2891),
    [anon_sym_case] = ACTIONS(2891),
    [anon_sym_default] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2891),
    [anon_sym_for] = ACTIONS(2891),
    [anon_sym_return] = ACTIONS(2891),
    [anon_sym_break] = ACTIONS(2891),
    [anon_sym_continue] = ACTIONS(2891),
    [anon_sym_goto] = ACTIONS(2891),
    [anon_sym___try] = ACTIONS(2891),
    [anon_sym___leave] = ACTIONS(2891),
    [anon_sym_not] = ACTIONS(2891),
    [anon_sym_compl] = ACTIONS(2891),
    [anon_sym_DASH_DASH] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2893),
    [anon_sym_sizeof] = ACTIONS(2891),
    [anon_sym___alignof__] = ACTIONS(2891),
    [anon_sym___alignof] = ACTIONS(2891),
    [anon_sym__alignof] = ACTIONS(2891),
    [anon_sym_alignof] = ACTIONS(2891),
    [anon_sym__Alignof] = ACTIONS(2891),
    [anon_sym_offsetof] = ACTIONS(2891),
    [anon_sym__Generic] = ACTIONS(2891),
    [anon_sym_asm] = ACTIONS(2891),
    [anon_sym___asm__] = ACTIONS(2891),
    [aux_sym_number_literal_token1] = ACTIONS(2893),
    [aux_sym_number_literal_token2] = ACTIONS(2891),
    [anon_sym_L_SQUOTE] = ACTIONS(2893),
    [anon_sym_u_SQUOTE] = ACTIONS(2893),
    [anon_sym_U_SQUOTE] = ACTIONS(2893),
    [anon_sym_u8_SQUOTE] = ACTIONS(2893),
    [anon_sym_SQUOTE] = ACTIONS(2893),
    [anon_sym_L_DQUOTE] = ACTIONS(2893),
    [anon_sym_u_DQUOTE] = ACTIONS(2893),
    [anon_sym_U_DQUOTE] = ACTIONS(2893),
    [anon_sym_u8_DQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(2893),
    [sym_true] = ACTIONS(2891),
    [sym_false] = ACTIONS(2891),
    [anon_sym_NULL] = ACTIONS(2891),
    [anon_sym_nullptr] = ACTIONS(2891),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2891),
    [anon_sym_decltype] = ACTIONS(2891),
    [anon_sym_virtual] = ACTIONS(2891),
    [anon_sym_alignas] = ACTIONS(2891),
    [anon_sym_explicit] = ACTIONS(2891),
    [anon_sym_typename] = ACTIONS(2891),
    [anon_sym_template] = ACTIONS(2891),
    [anon_sym_operator] = ACTIONS(2891),
    [anon_sym_try] = ACTIONS(2891),
    [anon_sym_delete] = ACTIONS(2891),
    [anon_sym_throw] = ACTIONS(2891),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_using] = ACTIONS(2891),
    [anon_sym_static_assert] = ACTIONS(2891),
    [anon_sym_concept] = ACTIONS(2891),
    [anon_sym_co_return] = ACTIONS(2891),
    [anon_sym_co_yield] = ACTIONS(2891),
    [anon_sym_R_DQUOTE] = ACTIONS(2893),
    [anon_sym_LR_DQUOTE] = ACTIONS(2893),
    [anon_sym_uR_DQUOTE] = ACTIONS(2893),
    [anon_sym_UR_DQUOTE] = ACTIONS(2893),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2893),
    [anon_sym_co_await] = ACTIONS(2891),
    [anon_sym_new] = ACTIONS(2891),
    [anon_sym_requires] = ACTIONS(2891),
    [sym_this] = ACTIONS(2891),
  },
  [548] = {
    [sym_identifier] = ACTIONS(3483),
    [aux_sym_preproc_include_token1] = ACTIONS(3483),
    [aux_sym_preproc_def_token1] = ACTIONS(3483),
    [aux_sym_preproc_if_token1] = ACTIONS(3483),
    [aux_sym_preproc_if_token2] = ACTIONS(3483),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3483),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3483),
    [aux_sym_preproc_else_token1] = ACTIONS(3483),
    [aux_sym_preproc_elif_token1] = ACTIONS(3483),
    [sym_preproc_directive] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_BANG] = ACTIONS(3485),
    [anon_sym_TILDE] = ACTIONS(3485),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_STAR] = ACTIONS(3485),
    [anon_sym_AMP_AMP] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_SEMI] = ACTIONS(3485),
    [anon_sym___extension__] = ACTIONS(3483),
    [anon_sym_typedef] = ACTIONS(3483),
    [anon_sym_extern] = ACTIONS(3483),
    [anon_sym___attribute__] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3485),
    [anon_sym___declspec] = ACTIONS(3483),
    [anon_sym___based] = ACTIONS(3483),
    [anon_sym___cdecl] = ACTIONS(3483),
    [anon_sym___clrcall] = ACTIONS(3483),
    [anon_sym___stdcall] = ACTIONS(3483),
    [anon_sym___fastcall] = ACTIONS(3483),
    [anon_sym___thiscall] = ACTIONS(3483),
    [anon_sym___vectorcall] = ACTIONS(3483),
    [anon_sym_LBRACE] = ACTIONS(3485),
    [anon_sym_signed] = ACTIONS(3483),
    [anon_sym_unsigned] = ACTIONS(3483),
    [anon_sym_long] = ACTIONS(3483),
    [anon_sym_short] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_static] = ACTIONS(3483),
    [anon_sym_register] = ACTIONS(3483),
    [anon_sym_inline] = ACTIONS(3483),
    [anon_sym___inline] = ACTIONS(3483),
    [anon_sym___inline__] = ACTIONS(3483),
    [anon_sym___forceinline] = ACTIONS(3483),
    [anon_sym_thread_local] = ACTIONS(3483),
    [anon_sym___thread] = ACTIONS(3483),
    [anon_sym_const] = ACTIONS(3483),
    [anon_sym_constexpr] = ACTIONS(3483),
    [anon_sym_volatile] = ACTIONS(3483),
    [anon_sym_restrict] = ACTIONS(3483),
    [anon_sym___restrict__] = ACTIONS(3483),
    [anon_sym__Atomic] = ACTIONS(3483),
    [anon_sym__Noreturn] = ACTIONS(3483),
    [anon_sym_noreturn] = ACTIONS(3483),
    [anon_sym_mutable] = ACTIONS(3483),
    [anon_sym_constinit] = ACTIONS(3483),
    [anon_sym_consteval] = ACTIONS(3483),
    [anon_sym_PROGMEM] = ACTIONS(3483),
    [aux_sym_primitive_type_token1] = ACTIONS(3483),
    [anon_sym_byte] = ACTIONS(3483),
    [anon_sym_word] = ACTIONS(3483),
    [anon_sym_enum] = ACTIONS(3483),
    [anon_sym_class] = ACTIONS(3483),
    [anon_sym_struct] = ACTIONS(3483),
    [anon_sym_union] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_switch] = ACTIONS(3483),
    [anon_sym_case] = ACTIONS(3483),
    [anon_sym_default] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_break] = ACTIONS(3483),
    [anon_sym_continue] = ACTIONS(3483),
    [anon_sym_goto] = ACTIONS(3483),
    [anon_sym___try] = ACTIONS(3483),
    [anon_sym___leave] = ACTIONS(3483),
    [anon_sym_not] = ACTIONS(3483),
    [anon_sym_compl] = ACTIONS(3483),
    [anon_sym_DASH_DASH] = ACTIONS(3485),
    [anon_sym_PLUS_PLUS] = ACTIONS(3485),
    [anon_sym_sizeof] = ACTIONS(3483),
    [anon_sym___alignof__] = ACTIONS(3483),
    [anon_sym___alignof] = ACTIONS(3483),
    [anon_sym__alignof] = ACTIONS(3483),
    [anon_sym_alignof] = ACTIONS(3483),
    [anon_sym__Alignof] = ACTIONS(3483),
    [anon_sym_offsetof] = ACTIONS(3483),
    [anon_sym__Generic] = ACTIONS(3483),
    [anon_sym_asm] = ACTIONS(3483),
    [anon_sym___asm__] = ACTIONS(3483),
    [aux_sym_number_literal_token1] = ACTIONS(3485),
    [aux_sym_number_literal_token2] = ACTIONS(3483),
    [anon_sym_L_SQUOTE] = ACTIONS(3485),
    [anon_sym_u_SQUOTE] = ACTIONS(3485),
    [anon_sym_U_SQUOTE] = ACTIONS(3485),
    [anon_sym_u8_SQUOTE] = ACTIONS(3485),
    [anon_sym_SQUOTE] = ACTIONS(3485),
    [anon_sym_L_DQUOTE] = ACTIONS(3485),
    [anon_sym_u_DQUOTE] = ACTIONS(3485),
    [anon_sym_U_DQUOTE] = ACTIONS(3485),
    [anon_sym_u8_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE] = ACTIONS(3485),
    [sym_true] = ACTIONS(3483),
    [sym_false] = ACTIONS(3483),
    [anon_sym_NULL] = ACTIONS(3483),
    [anon_sym_nullptr] = ACTIONS(3483),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3483),
    [anon_sym_decltype] = ACTIONS(3483),
    [anon_sym_virtual] = ACTIONS(3483),
    [anon_sym_alignas] = ACTIONS(3483),
    [anon_sym_explicit] = ACTIONS(3483),
    [anon_sym_typename] = ACTIONS(3483),
    [anon_sym_template] = ACTIONS(3483),
    [anon_sym_operator] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_delete] = ACTIONS(3483),
    [anon_sym_throw] = ACTIONS(3483),
    [anon_sym_namespace] = ACTIONS(3483),
    [anon_sym_using] = ACTIONS(3483),
    [anon_sym_static_assert] = ACTIONS(3483),
    [anon_sym_concept] = ACTIONS(3483),
    [anon_sym_co_return] = ACTIONS(3483),
    [anon_sym_co_yield] = ACTIONS(3483),
    [anon_sym_R_DQUOTE] = ACTIONS(3485),
    [anon_sym_LR_DQUOTE] = ACTIONS(3485),
    [anon_sym_uR_DQUOTE] = ACTIONS(3485),
    [anon_sym_UR_DQUOTE] = ACTIONS(3485),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3485),
    [anon_sym_co_await] = ACTIONS(3483),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_requires] = ACTIONS(3483),
    [sym_this] = ACTIONS(3483),
  },
  [549] = {
    [sym_identifier] = ACTIONS(3479),
    [aux_sym_preproc_include_token1] = ACTIONS(3479),
    [aux_sym_preproc_def_token1] = ACTIONS(3479),
    [aux_sym_preproc_if_token1] = ACTIONS(3479),
    [aux_sym_preproc_if_token2] = ACTIONS(3479),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3479),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3479),
    [aux_sym_preproc_else_token1] = ACTIONS(3479),
    [aux_sym_preproc_elif_token1] = ACTIONS(3479),
    [sym_preproc_directive] = ACTIONS(3479),
    [anon_sym_LPAREN2] = ACTIONS(3481),
    [anon_sym_BANG] = ACTIONS(3481),
    [anon_sym_TILDE] = ACTIONS(3481),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_PLUS] = ACTIONS(3479),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_AMP_AMP] = ACTIONS(3481),
    [anon_sym_AMP] = ACTIONS(3479),
    [anon_sym_SEMI] = ACTIONS(3481),
    [anon_sym___extension__] = ACTIONS(3479),
    [anon_sym_typedef] = ACTIONS(3479),
    [anon_sym_extern] = ACTIONS(3479),
    [anon_sym___attribute__] = ACTIONS(3479),
    [anon_sym_COLON_COLON] = ACTIONS(3481),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3481),
    [anon_sym___declspec] = ACTIONS(3479),
    [anon_sym___based] = ACTIONS(3479),
    [anon_sym___cdecl] = ACTIONS(3479),
    [anon_sym___clrcall] = ACTIONS(3479),
    [anon_sym___stdcall] = ACTIONS(3479),
    [anon_sym___fastcall] = ACTIONS(3479),
    [anon_sym___thiscall] = ACTIONS(3479),
    [anon_sym___vectorcall] = ACTIONS(3479),
    [anon_sym_LBRACE] = ACTIONS(3481),
    [anon_sym_signed] = ACTIONS(3479),
    [anon_sym_unsigned] = ACTIONS(3479),
    [anon_sym_long] = ACTIONS(3479),
    [anon_sym_short] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(3479),
    [anon_sym_static] = ACTIONS(3479),
    [anon_sym_register] = ACTIONS(3479),
    [anon_sym_inline] = ACTIONS(3479),
    [anon_sym___inline] = ACTIONS(3479),
    [anon_sym___inline__] = ACTIONS(3479),
    [anon_sym___forceinline] = ACTIONS(3479),
    [anon_sym_thread_local] = ACTIONS(3479),
    [anon_sym___thread] = ACTIONS(3479),
    [anon_sym_const] = ACTIONS(3479),
    [anon_sym_constexpr] = ACTIONS(3479),
    [anon_sym_volatile] = ACTIONS(3479),
    [anon_sym_restrict] = ACTIONS(3479),
    [anon_sym___restrict__] = ACTIONS(3479),
    [anon_sym__Atomic] = ACTIONS(3479),
    [anon_sym__Noreturn] = ACTIONS(3479),
    [anon_sym_noreturn] = ACTIONS(3479),
    [anon_sym_mutable] = ACTIONS(3479),
    [anon_sym_constinit] = ACTIONS(3479),
    [anon_sym_consteval] = ACTIONS(3479),
    [anon_sym_PROGMEM] = ACTIONS(3479),
    [aux_sym_primitive_type_token1] = ACTIONS(3479),
    [anon_sym_byte] = ACTIONS(3479),
    [anon_sym_word] = ACTIONS(3479),
    [anon_sym_enum] = ACTIONS(3479),
    [anon_sym_class] = ACTIONS(3479),
    [anon_sym_struct] = ACTIONS(3479),
    [anon_sym_union] = ACTIONS(3479),
    [anon_sym_if] = ACTIONS(3479),
    [anon_sym_switch] = ACTIONS(3479),
    [anon_sym_case] = ACTIONS(3479),
    [anon_sym_default] = ACTIONS(3479),
    [anon_sym_while] = ACTIONS(3479),
    [anon_sym_do] = ACTIONS(3479),
    [anon_sym_for] = ACTIONS(3479),
    [anon_sym_return] = ACTIONS(3479),
    [anon_sym_break] = ACTIONS(3479),
    [anon_sym_continue] = ACTIONS(3479),
    [anon_sym_goto] = ACTIONS(3479),
    [anon_sym___try] = ACTIONS(3479),
    [anon_sym___leave] = ACTIONS(3479),
    [anon_sym_not] = ACTIONS(3479),
    [anon_sym_compl] = ACTIONS(3479),
    [anon_sym_DASH_DASH] = ACTIONS(3481),
    [anon_sym_PLUS_PLUS] = ACTIONS(3481),
    [anon_sym_sizeof] = ACTIONS(3479),
    [anon_sym___alignof__] = ACTIONS(3479),
    [anon_sym___alignof] = ACTIONS(3479),
    [anon_sym__alignof] = ACTIONS(3479),
    [anon_sym_alignof] = ACTIONS(3479),
    [anon_sym__Alignof] = ACTIONS(3479),
    [anon_sym_offsetof] = ACTIONS(3479),
    [anon_sym__Generic] = ACTIONS(3479),
    [anon_sym_asm] = ACTIONS(3479),
    [anon_sym___asm__] = ACTIONS(3479),
    [aux_sym_number_literal_token1] = ACTIONS(3481),
    [aux_sym_number_literal_token2] = ACTIONS(3479),
    [anon_sym_L_SQUOTE] = ACTIONS(3481),
    [anon_sym_u_SQUOTE] = ACTIONS(3481),
    [anon_sym_U_SQUOTE] = ACTIONS(3481),
    [anon_sym_u8_SQUOTE] = ACTIONS(3481),
    [anon_sym_SQUOTE] = ACTIONS(3481),
    [anon_sym_L_DQUOTE] = ACTIONS(3481),
    [anon_sym_u_DQUOTE] = ACTIONS(3481),
    [anon_sym_U_DQUOTE] = ACTIONS(3481),
    [anon_sym_u8_DQUOTE] = ACTIONS(3481),
    [anon_sym_DQUOTE] = ACTIONS(3481),
    [sym_true] = ACTIONS(3479),
    [sym_false] = ACTIONS(3479),
    [anon_sym_NULL] = ACTIONS(3479),
    [anon_sym_nullptr] = ACTIONS(3479),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3479),
    [anon_sym_decltype] = ACTIONS(3479),
    [anon_sym_virtual] = ACTIONS(3479),
    [anon_sym_alignas] = ACTIONS(3479),
    [anon_sym_explicit] = ACTIONS(3479),
    [anon_sym_typename] = ACTIONS(3479),
    [anon_sym_template] = ACTIONS(3479),
    [anon_sym_operator] = ACTIONS(3479),
    [anon_sym_try] = ACTIONS(3479),
    [anon_sym_delete] = ACTIONS(3479),
    [anon_sym_throw] = ACTIONS(3479),
    [anon_sym_namespace] = ACTIONS(3479),
    [anon_sym_using] = ACTIONS(3479),
    [anon_sym_static_assert] = ACTIONS(3479),
    [anon_sym_concept] = ACTIONS(3479),
    [anon_sym_co_return] = ACTIONS(3479),
    [anon_sym_co_yield] = ACTIONS(3479),
    [anon_sym_R_DQUOTE] = ACTIONS(3481),
    [anon_sym_LR_DQUOTE] = ACTIONS(3481),
    [anon_sym_uR_DQUOTE] = ACTIONS(3481),
    [anon_sym_UR_DQUOTE] = ACTIONS(3481),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3481),
    [anon_sym_co_await] = ACTIONS(3479),
    [anon_sym_new] = ACTIONS(3479),
    [anon_sym_requires] = ACTIONS(3479),
    [sym_this] = ACTIONS(3479),
  },
  [550] = {
    [sym_identifier] = ACTIONS(3491),
    [aux_sym_preproc_include_token1] = ACTIONS(3491),
    [aux_sym_preproc_def_token1] = ACTIONS(3491),
    [aux_sym_preproc_if_token1] = ACTIONS(3491),
    [aux_sym_preproc_if_token2] = ACTIONS(3491),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3491),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3491),
    [aux_sym_preproc_else_token1] = ACTIONS(3491),
    [aux_sym_preproc_elif_token1] = ACTIONS(3491),
    [sym_preproc_directive] = ACTIONS(3491),
    [anon_sym_LPAREN2] = ACTIONS(3493),
    [anon_sym_BANG] = ACTIONS(3493),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(3493),
    [anon_sym_AMP_AMP] = ACTIONS(3493),
    [anon_sym_AMP] = ACTIONS(3491),
    [anon_sym_SEMI] = ACTIONS(3493),
    [anon_sym___extension__] = ACTIONS(3491),
    [anon_sym_typedef] = ACTIONS(3491),
    [anon_sym_extern] = ACTIONS(3491),
    [anon_sym___attribute__] = ACTIONS(3491),
    [anon_sym_COLON_COLON] = ACTIONS(3493),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3493),
    [anon_sym___declspec] = ACTIONS(3491),
    [anon_sym___based] = ACTIONS(3491),
    [anon_sym___cdecl] = ACTIONS(3491),
    [anon_sym___clrcall] = ACTIONS(3491),
    [anon_sym___stdcall] = ACTIONS(3491),
    [anon_sym___fastcall] = ACTIONS(3491),
    [anon_sym___thiscall] = ACTIONS(3491),
    [anon_sym___vectorcall] = ACTIONS(3491),
    [anon_sym_LBRACE] = ACTIONS(3493),
    [anon_sym_signed] = ACTIONS(3491),
    [anon_sym_unsigned] = ACTIONS(3491),
    [anon_sym_long] = ACTIONS(3491),
    [anon_sym_short] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3491),
    [anon_sym_static] = ACTIONS(3491),
    [anon_sym_register] = ACTIONS(3491),
    [anon_sym_inline] = ACTIONS(3491),
    [anon_sym___inline] = ACTIONS(3491),
    [anon_sym___inline__] = ACTIONS(3491),
    [anon_sym___forceinline] = ACTIONS(3491),
    [anon_sym_thread_local] = ACTIONS(3491),
    [anon_sym___thread] = ACTIONS(3491),
    [anon_sym_const] = ACTIONS(3491),
    [anon_sym_constexpr] = ACTIONS(3491),
    [anon_sym_volatile] = ACTIONS(3491),
    [anon_sym_restrict] = ACTIONS(3491),
    [anon_sym___restrict__] = ACTIONS(3491),
    [anon_sym__Atomic] = ACTIONS(3491),
    [anon_sym__Noreturn] = ACTIONS(3491),
    [anon_sym_noreturn] = ACTIONS(3491),
    [anon_sym_mutable] = ACTIONS(3491),
    [anon_sym_constinit] = ACTIONS(3491),
    [anon_sym_consteval] = ACTIONS(3491),
    [anon_sym_PROGMEM] = ACTIONS(3491),
    [aux_sym_primitive_type_token1] = ACTIONS(3491),
    [anon_sym_byte] = ACTIONS(3491),
    [anon_sym_word] = ACTIONS(3491),
    [anon_sym_enum] = ACTIONS(3491),
    [anon_sym_class] = ACTIONS(3491),
    [anon_sym_struct] = ACTIONS(3491),
    [anon_sym_union] = ACTIONS(3491),
    [anon_sym_if] = ACTIONS(3491),
    [anon_sym_switch] = ACTIONS(3491),
    [anon_sym_case] = ACTIONS(3491),
    [anon_sym_default] = ACTIONS(3491),
    [anon_sym_while] = ACTIONS(3491),
    [anon_sym_do] = ACTIONS(3491),
    [anon_sym_for] = ACTIONS(3491),
    [anon_sym_return] = ACTIONS(3491),
    [anon_sym_break] = ACTIONS(3491),
    [anon_sym_continue] = ACTIONS(3491),
    [anon_sym_goto] = ACTIONS(3491),
    [anon_sym___try] = ACTIONS(3491),
    [anon_sym___leave] = ACTIONS(3491),
    [anon_sym_not] = ACTIONS(3491),
    [anon_sym_compl] = ACTIONS(3491),
    [anon_sym_DASH_DASH] = ACTIONS(3493),
    [anon_sym_PLUS_PLUS] = ACTIONS(3493),
    [anon_sym_sizeof] = ACTIONS(3491),
    [anon_sym___alignof__] = ACTIONS(3491),
    [anon_sym___alignof] = ACTIONS(3491),
    [anon_sym__alignof] = ACTIONS(3491),
    [anon_sym_alignof] = ACTIONS(3491),
    [anon_sym__Alignof] = ACTIONS(3491),
    [anon_sym_offsetof] = ACTIONS(3491),
    [anon_sym__Generic] = ACTIONS(3491),
    [anon_sym_asm] = ACTIONS(3491),
    [anon_sym___asm__] = ACTIONS(3491),
    [aux_sym_number_literal_token1] = ACTIONS(3493),
    [aux_sym_number_literal_token2] = ACTIONS(3491),
    [anon_sym_L_SQUOTE] = ACTIONS(3493),
    [anon_sym_u_SQUOTE] = ACTIONS(3493),
    [anon_sym_U_SQUOTE] = ACTIONS(3493),
    [anon_sym_u8_SQUOTE] = ACTIONS(3493),
    [anon_sym_SQUOTE] = ACTIONS(3493),
    [anon_sym_L_DQUOTE] = ACTIONS(3493),
    [anon_sym_u_DQUOTE] = ACTIONS(3493),
    [anon_sym_U_DQUOTE] = ACTIONS(3493),
    [anon_sym_u8_DQUOTE] = ACTIONS(3493),
    [anon_sym_DQUOTE] = ACTIONS(3493),
    [sym_true] = ACTIONS(3491),
    [sym_false] = ACTIONS(3491),
    [anon_sym_NULL] = ACTIONS(3491),
    [anon_sym_nullptr] = ACTIONS(3491),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3491),
    [anon_sym_decltype] = ACTIONS(3491),
    [anon_sym_virtual] = ACTIONS(3491),
    [anon_sym_alignas] = ACTIONS(3491),
    [anon_sym_explicit] = ACTIONS(3491),
    [anon_sym_typename] = ACTIONS(3491),
    [anon_sym_template] = ACTIONS(3491),
    [anon_sym_operator] = ACTIONS(3491),
    [anon_sym_try] = ACTIONS(3491),
    [anon_sym_delete] = ACTIONS(3491),
    [anon_sym_throw] = ACTIONS(3491),
    [anon_sym_namespace] = ACTIONS(3491),
    [anon_sym_using] = ACTIONS(3491),
    [anon_sym_static_assert] = ACTIONS(3491),
    [anon_sym_concept] = ACTIONS(3491),
    [anon_sym_co_return] = ACTIONS(3491),
    [anon_sym_co_yield] = ACTIONS(3491),
    [anon_sym_R_DQUOTE] = ACTIONS(3493),
    [anon_sym_LR_DQUOTE] = ACTIONS(3493),
    [anon_sym_uR_DQUOTE] = ACTIONS(3493),
    [anon_sym_UR_DQUOTE] = ACTIONS(3493),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3493),
    [anon_sym_co_await] = ACTIONS(3491),
    [anon_sym_new] = ACTIONS(3491),
    [anon_sym_requires] = ACTIONS(3491),
    [sym_this] = ACTIONS(3491),
  },
  [551] = {
    [sym_identifier] = ACTIONS(3178),
    [aux_sym_preproc_include_token1] = ACTIONS(3178),
    [aux_sym_preproc_def_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3178),
    [aux_sym_preproc_else_token1] = ACTIONS(3178),
    [aux_sym_preproc_elif_token1] = ACTIONS(3178),
    [sym_preproc_directive] = ACTIONS(3178),
    [anon_sym_LPAREN2] = ACTIONS(3180),
    [anon_sym_BANG] = ACTIONS(3180),
    [anon_sym_TILDE] = ACTIONS(3180),
    [anon_sym_DASH] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3178),
    [anon_sym_STAR] = ACTIONS(3180),
    [anon_sym_AMP_AMP] = ACTIONS(3180),
    [anon_sym_AMP] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3180),
    [anon_sym___extension__] = ACTIONS(3178),
    [anon_sym_typedef] = ACTIONS(3178),
    [anon_sym_extern] = ACTIONS(3178),
    [anon_sym___attribute__] = ACTIONS(3178),
    [anon_sym_COLON_COLON] = ACTIONS(3180),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3180),
    [anon_sym___declspec] = ACTIONS(3178),
    [anon_sym___based] = ACTIONS(3178),
    [anon_sym___cdecl] = ACTIONS(3178),
    [anon_sym___clrcall] = ACTIONS(3178),
    [anon_sym___stdcall] = ACTIONS(3178),
    [anon_sym___fastcall] = ACTIONS(3178),
    [anon_sym___thiscall] = ACTIONS(3178),
    [anon_sym___vectorcall] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3180),
    [anon_sym_signed] = ACTIONS(3178),
    [anon_sym_unsigned] = ACTIONS(3178),
    [anon_sym_long] = ACTIONS(3178),
    [anon_sym_short] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_static] = ACTIONS(3178),
    [anon_sym_register] = ACTIONS(3178),
    [anon_sym_inline] = ACTIONS(3178),
    [anon_sym___inline] = ACTIONS(3178),
    [anon_sym___inline__] = ACTIONS(3178),
    [anon_sym___forceinline] = ACTIONS(3178),
    [anon_sym_thread_local] = ACTIONS(3178),
    [anon_sym___thread] = ACTIONS(3178),
    [anon_sym_const] = ACTIONS(3178),
    [anon_sym_constexpr] = ACTIONS(3178),
    [anon_sym_volatile] = ACTIONS(3178),
    [anon_sym_restrict] = ACTIONS(3178),
    [anon_sym___restrict__] = ACTIONS(3178),
    [anon_sym__Atomic] = ACTIONS(3178),
    [anon_sym__Noreturn] = ACTIONS(3178),
    [anon_sym_noreturn] = ACTIONS(3178),
    [anon_sym_mutable] = ACTIONS(3178),
    [anon_sym_constinit] = ACTIONS(3178),
    [anon_sym_consteval] = ACTIONS(3178),
    [anon_sym_PROGMEM] = ACTIONS(3178),
    [aux_sym_primitive_type_token1] = ACTIONS(3178),
    [anon_sym_byte] = ACTIONS(3178),
    [anon_sym_word] = ACTIONS(3178),
    [anon_sym_enum] = ACTIONS(3178),
    [anon_sym_class] = ACTIONS(3178),
    [anon_sym_struct] = ACTIONS(3178),
    [anon_sym_union] = ACTIONS(3178),
    [anon_sym_if] = ACTIONS(3178),
    [anon_sym_switch] = ACTIONS(3178),
    [anon_sym_case] = ACTIONS(3178),
    [anon_sym_default] = ACTIONS(3178),
    [anon_sym_while] = ACTIONS(3178),
    [anon_sym_do] = ACTIONS(3178),
    [anon_sym_for] = ACTIONS(3178),
    [anon_sym_return] = ACTIONS(3178),
    [anon_sym_break] = ACTIONS(3178),
    [anon_sym_continue] = ACTIONS(3178),
    [anon_sym_goto] = ACTIONS(3178),
    [anon_sym___try] = ACTIONS(3178),
    [anon_sym___leave] = ACTIONS(3178),
    [anon_sym_not] = ACTIONS(3178),
    [anon_sym_compl] = ACTIONS(3178),
    [anon_sym_DASH_DASH] = ACTIONS(3180),
    [anon_sym_PLUS_PLUS] = ACTIONS(3180),
    [anon_sym_sizeof] = ACTIONS(3178),
    [anon_sym___alignof__] = ACTIONS(3178),
    [anon_sym___alignof] = ACTIONS(3178),
    [anon_sym__alignof] = ACTIONS(3178),
    [anon_sym_alignof] = ACTIONS(3178),
    [anon_sym__Alignof] = ACTIONS(3178),
    [anon_sym_offsetof] = ACTIONS(3178),
    [anon_sym__Generic] = ACTIONS(3178),
    [anon_sym_asm] = ACTIONS(3178),
    [anon_sym___asm__] = ACTIONS(3178),
    [aux_sym_number_literal_token1] = ACTIONS(3180),
    [aux_sym_number_literal_token2] = ACTIONS(3178),
    [anon_sym_L_SQUOTE] = ACTIONS(3180),
    [anon_sym_u_SQUOTE] = ACTIONS(3180),
    [anon_sym_U_SQUOTE] = ACTIONS(3180),
    [anon_sym_u8_SQUOTE] = ACTIONS(3180),
    [anon_sym_SQUOTE] = ACTIONS(3180),
    [anon_sym_L_DQUOTE] = ACTIONS(3180),
    [anon_sym_u_DQUOTE] = ACTIONS(3180),
    [anon_sym_U_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8_DQUOTE] = ACTIONS(3180),
    [anon_sym_DQUOTE] = ACTIONS(3180),
    [sym_true] = ACTIONS(3178),
    [sym_false] = ACTIONS(3178),
    [anon_sym_NULL] = ACTIONS(3178),
    [anon_sym_nullptr] = ACTIONS(3178),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3178),
    [anon_sym_decltype] = ACTIONS(3178),
    [anon_sym_virtual] = ACTIONS(3178),
    [anon_sym_alignas] = ACTIONS(3178),
    [anon_sym_explicit] = ACTIONS(3178),
    [anon_sym_typename] = ACTIONS(3178),
    [anon_sym_template] = ACTIONS(3178),
    [anon_sym_operator] = ACTIONS(3178),
    [anon_sym_try] = ACTIONS(3178),
    [anon_sym_delete] = ACTIONS(3178),
    [anon_sym_throw] = ACTIONS(3178),
    [anon_sym_namespace] = ACTIONS(3178),
    [anon_sym_using] = ACTIONS(3178),
    [anon_sym_static_assert] = ACTIONS(3178),
    [anon_sym_concept] = ACTIONS(3178),
    [anon_sym_co_return] = ACTIONS(3178),
    [anon_sym_co_yield] = ACTIONS(3178),
    [anon_sym_R_DQUOTE] = ACTIONS(3180),
    [anon_sym_LR_DQUOTE] = ACTIONS(3180),
    [anon_sym_uR_DQUOTE] = ACTIONS(3180),
    [anon_sym_UR_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3180),
    [anon_sym_co_await] = ACTIONS(3178),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3178),
    [sym_this] = ACTIONS(3178),
  },
  [552] = {
    [sym_identifier] = ACTIONS(3310),
    [aux_sym_preproc_include_token1] = ACTIONS(3310),
    [aux_sym_preproc_def_token1] = ACTIONS(3310),
    [aux_sym_preproc_if_token1] = ACTIONS(3310),
    [aux_sym_preproc_if_token2] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3310),
    [aux_sym_preproc_else_token1] = ACTIONS(3310),
    [aux_sym_preproc_elif_token1] = ACTIONS(3310),
    [sym_preproc_directive] = ACTIONS(3310),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_AMP_AMP] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3310),
    [anon_sym_SEMI] = ACTIONS(3312),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_typedef] = ACTIONS(3310),
    [anon_sym_extern] = ACTIONS(3310),
    [anon_sym___attribute__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3312),
    [anon_sym___declspec] = ACTIONS(3310),
    [anon_sym___based] = ACTIONS(3310),
    [anon_sym___cdecl] = ACTIONS(3310),
    [anon_sym___clrcall] = ACTIONS(3310),
    [anon_sym___stdcall] = ACTIONS(3310),
    [anon_sym___fastcall] = ACTIONS(3310),
    [anon_sym___thiscall] = ACTIONS(3310),
    [anon_sym___vectorcall] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3312),
    [anon_sym_signed] = ACTIONS(3310),
    [anon_sym_unsigned] = ACTIONS(3310),
    [anon_sym_long] = ACTIONS(3310),
    [anon_sym_short] = ACTIONS(3310),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [anon_sym_static] = ACTIONS(3310),
    [anon_sym_register] = ACTIONS(3310),
    [anon_sym_inline] = ACTIONS(3310),
    [anon_sym___inline] = ACTIONS(3310),
    [anon_sym___inline__] = ACTIONS(3310),
    [anon_sym___forceinline] = ACTIONS(3310),
    [anon_sym_thread_local] = ACTIONS(3310),
    [anon_sym___thread] = ACTIONS(3310),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_constexpr] = ACTIONS(3310),
    [anon_sym_volatile] = ACTIONS(3310),
    [anon_sym_restrict] = ACTIONS(3310),
    [anon_sym___restrict__] = ACTIONS(3310),
    [anon_sym__Atomic] = ACTIONS(3310),
    [anon_sym__Noreturn] = ACTIONS(3310),
    [anon_sym_noreturn] = ACTIONS(3310),
    [anon_sym_mutable] = ACTIONS(3310),
    [anon_sym_constinit] = ACTIONS(3310),
    [anon_sym_consteval] = ACTIONS(3310),
    [anon_sym_PROGMEM] = ACTIONS(3310),
    [aux_sym_primitive_type_token1] = ACTIONS(3310),
    [anon_sym_byte] = ACTIONS(3310),
    [anon_sym_word] = ACTIONS(3310),
    [anon_sym_enum] = ACTIONS(3310),
    [anon_sym_class] = ACTIONS(3310),
    [anon_sym_struct] = ACTIONS(3310),
    [anon_sym_union] = ACTIONS(3310),
    [anon_sym_if] = ACTIONS(3310),
    [anon_sym_switch] = ACTIONS(3310),
    [anon_sym_case] = ACTIONS(3310),
    [anon_sym_default] = ACTIONS(3310),
    [anon_sym_while] = ACTIONS(3310),
    [anon_sym_do] = ACTIONS(3310),
    [anon_sym_for] = ACTIONS(3310),
    [anon_sym_return] = ACTIONS(3310),
    [anon_sym_break] = ACTIONS(3310),
    [anon_sym_continue] = ACTIONS(3310),
    [anon_sym_goto] = ACTIONS(3310),
    [anon_sym___try] = ACTIONS(3310),
    [anon_sym___leave] = ACTIONS(3310),
    [anon_sym_not] = ACTIONS(3310),
    [anon_sym_compl] = ACTIONS(3310),
    [anon_sym_DASH_DASH] = ACTIONS(3312),
    [anon_sym_PLUS_PLUS] = ACTIONS(3312),
    [anon_sym_sizeof] = ACTIONS(3310),
    [anon_sym___alignof__] = ACTIONS(3310),
    [anon_sym___alignof] = ACTIONS(3310),
    [anon_sym__alignof] = ACTIONS(3310),
    [anon_sym_alignof] = ACTIONS(3310),
    [anon_sym__Alignof] = ACTIONS(3310),
    [anon_sym_offsetof] = ACTIONS(3310),
    [anon_sym__Generic] = ACTIONS(3310),
    [anon_sym_asm] = ACTIONS(3310),
    [anon_sym___asm__] = ACTIONS(3310),
    [aux_sym_number_literal_token1] = ACTIONS(3312),
    [aux_sym_number_literal_token2] = ACTIONS(3310),
    [anon_sym_L_SQUOTE] = ACTIONS(3312),
    [anon_sym_u_SQUOTE] = ACTIONS(3312),
    [anon_sym_U_SQUOTE] = ACTIONS(3312),
    [anon_sym_u8_SQUOTE] = ACTIONS(3312),
    [anon_sym_SQUOTE] = ACTIONS(3312),
    [anon_sym_L_DQUOTE] = ACTIONS(3312),
    [anon_sym_u_DQUOTE] = ACTIONS(3312),
    [anon_sym_U_DQUOTE] = ACTIONS(3312),
    [anon_sym_u8_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE] = ACTIONS(3312),
    [sym_true] = ACTIONS(3310),
    [sym_false] = ACTIONS(3310),
    [anon_sym_NULL] = ACTIONS(3310),
    [anon_sym_nullptr] = ACTIONS(3310),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3310),
    [anon_sym_decltype] = ACTIONS(3310),
    [anon_sym_virtual] = ACTIONS(3310),
    [anon_sym_alignas] = ACTIONS(3310),
    [anon_sym_explicit] = ACTIONS(3310),
    [anon_sym_typename] = ACTIONS(3310),
    [anon_sym_template] = ACTIONS(3310),
    [anon_sym_operator] = ACTIONS(3310),
    [anon_sym_try] = ACTIONS(3310),
    [anon_sym_delete] = ACTIONS(3310),
    [anon_sym_throw] = ACTIONS(3310),
    [anon_sym_namespace] = ACTIONS(3310),
    [anon_sym_using] = ACTIONS(3310),
    [anon_sym_static_assert] = ACTIONS(3310),
    [anon_sym_concept] = ACTIONS(3310),
    [anon_sym_co_return] = ACTIONS(3310),
    [anon_sym_co_yield] = ACTIONS(3310),
    [anon_sym_R_DQUOTE] = ACTIONS(3312),
    [anon_sym_LR_DQUOTE] = ACTIONS(3312),
    [anon_sym_uR_DQUOTE] = ACTIONS(3312),
    [anon_sym_UR_DQUOTE] = ACTIONS(3312),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3312),
    [anon_sym_co_await] = ACTIONS(3310),
    [anon_sym_new] = ACTIONS(3310),
    [anon_sym_requires] = ACTIONS(3310),
    [sym_this] = ACTIONS(3310),
  },
  [553] = {
    [sym_identifier] = ACTIONS(3314),
    [aux_sym_preproc_include_token1] = ACTIONS(3314),
    [aux_sym_preproc_def_token1] = ACTIONS(3314),
    [aux_sym_preproc_if_token1] = ACTIONS(3314),
    [aux_sym_preproc_if_token2] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3314),
    [aux_sym_preproc_else_token1] = ACTIONS(3314),
    [aux_sym_preproc_elif_token1] = ACTIONS(3314),
    [sym_preproc_directive] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_STAR] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_SEMI] = ACTIONS(3316),
    [anon_sym___extension__] = ACTIONS(3314),
    [anon_sym_typedef] = ACTIONS(3314),
    [anon_sym_extern] = ACTIONS(3314),
    [anon_sym___attribute__] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3316),
    [anon_sym___declspec] = ACTIONS(3314),
    [anon_sym___based] = ACTIONS(3314),
    [anon_sym___cdecl] = ACTIONS(3314),
    [anon_sym___clrcall] = ACTIONS(3314),
    [anon_sym___stdcall] = ACTIONS(3314),
    [anon_sym___fastcall] = ACTIONS(3314),
    [anon_sym___thiscall] = ACTIONS(3314),
    [anon_sym___vectorcall] = ACTIONS(3314),
    [anon_sym_LBRACE] = ACTIONS(3316),
    [anon_sym_signed] = ACTIONS(3314),
    [anon_sym_unsigned] = ACTIONS(3314),
    [anon_sym_long] = ACTIONS(3314),
    [anon_sym_short] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_static] = ACTIONS(3314),
    [anon_sym_register] = ACTIONS(3314),
    [anon_sym_inline] = ACTIONS(3314),
    [anon_sym___inline] = ACTIONS(3314),
    [anon_sym___inline__] = ACTIONS(3314),
    [anon_sym___forceinline] = ACTIONS(3314),
    [anon_sym_thread_local] = ACTIONS(3314),
    [anon_sym___thread] = ACTIONS(3314),
    [anon_sym_const] = ACTIONS(3314),
    [anon_sym_constexpr] = ACTIONS(3314),
    [anon_sym_volatile] = ACTIONS(3314),
    [anon_sym_restrict] = ACTIONS(3314),
    [anon_sym___restrict__] = ACTIONS(3314),
    [anon_sym__Atomic] = ACTIONS(3314),
    [anon_sym__Noreturn] = ACTIONS(3314),
    [anon_sym_noreturn] = ACTIONS(3314),
    [anon_sym_mutable] = ACTIONS(3314),
    [anon_sym_constinit] = ACTIONS(3314),
    [anon_sym_consteval] = ACTIONS(3314),
    [anon_sym_PROGMEM] = ACTIONS(3314),
    [aux_sym_primitive_type_token1] = ACTIONS(3314),
    [anon_sym_byte] = ACTIONS(3314),
    [anon_sym_word] = ACTIONS(3314),
    [anon_sym_enum] = ACTIONS(3314),
    [anon_sym_class] = ACTIONS(3314),
    [anon_sym_struct] = ACTIONS(3314),
    [anon_sym_union] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_switch] = ACTIONS(3314),
    [anon_sym_case] = ACTIONS(3314),
    [anon_sym_default] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_break] = ACTIONS(3314),
    [anon_sym_continue] = ACTIONS(3314),
    [anon_sym_goto] = ACTIONS(3314),
    [anon_sym___try] = ACTIONS(3314),
    [anon_sym___leave] = ACTIONS(3314),
    [anon_sym_not] = ACTIONS(3314),
    [anon_sym_compl] = ACTIONS(3314),
    [anon_sym_DASH_DASH] = ACTIONS(3316),
    [anon_sym_PLUS_PLUS] = ACTIONS(3316),
    [anon_sym_sizeof] = ACTIONS(3314),
    [anon_sym___alignof__] = ACTIONS(3314),
    [anon_sym___alignof] = ACTIONS(3314),
    [anon_sym__alignof] = ACTIONS(3314),
    [anon_sym_alignof] = ACTIONS(3314),
    [anon_sym__Alignof] = ACTIONS(3314),
    [anon_sym_offsetof] = ACTIONS(3314),
    [anon_sym__Generic] = ACTIONS(3314),
    [anon_sym_asm] = ACTIONS(3314),
    [anon_sym___asm__] = ACTIONS(3314),
    [aux_sym_number_literal_token1] = ACTIONS(3316),
    [aux_sym_number_literal_token2] = ACTIONS(3314),
    [anon_sym_L_SQUOTE] = ACTIONS(3316),
    [anon_sym_u_SQUOTE] = ACTIONS(3316),
    [anon_sym_U_SQUOTE] = ACTIONS(3316),
    [anon_sym_u8_SQUOTE] = ACTIONS(3316),
    [anon_sym_SQUOTE] = ACTIONS(3316),
    [anon_sym_L_DQUOTE] = ACTIONS(3316),
    [anon_sym_u_DQUOTE] = ACTIONS(3316),
    [anon_sym_U_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8_DQUOTE] = ACTIONS(3316),
    [anon_sym_DQUOTE] = ACTIONS(3316),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [anon_sym_NULL] = ACTIONS(3314),
    [anon_sym_nullptr] = ACTIONS(3314),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3314),
    [anon_sym_decltype] = ACTIONS(3314),
    [anon_sym_virtual] = ACTIONS(3314),
    [anon_sym_alignas] = ACTIONS(3314),
    [anon_sym_explicit] = ACTIONS(3314),
    [anon_sym_typename] = ACTIONS(3314),
    [anon_sym_template] = ACTIONS(3314),
    [anon_sym_operator] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_delete] = ACTIONS(3314),
    [anon_sym_throw] = ACTIONS(3314),
    [anon_sym_namespace] = ACTIONS(3314),
    [anon_sym_using] = ACTIONS(3314),
    [anon_sym_static_assert] = ACTIONS(3314),
    [anon_sym_concept] = ACTIONS(3314),
    [anon_sym_co_return] = ACTIONS(3314),
    [anon_sym_co_yield] = ACTIONS(3314),
    [anon_sym_R_DQUOTE] = ACTIONS(3316),
    [anon_sym_LR_DQUOTE] = ACTIONS(3316),
    [anon_sym_uR_DQUOTE] = ACTIONS(3316),
    [anon_sym_UR_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3316),
    [anon_sym_co_await] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_requires] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
  },
  [554] = {
    [sym_identifier] = ACTIONS(3499),
    [aux_sym_preproc_include_token1] = ACTIONS(3499),
    [aux_sym_preproc_def_token1] = ACTIONS(3499),
    [aux_sym_preproc_if_token1] = ACTIONS(3499),
    [aux_sym_preproc_if_token2] = ACTIONS(3499),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3499),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3499),
    [aux_sym_preproc_else_token1] = ACTIONS(3499),
    [aux_sym_preproc_elif_token1] = ACTIONS(3499),
    [sym_preproc_directive] = ACTIONS(3499),
    [anon_sym_LPAREN2] = ACTIONS(3501),
    [anon_sym_BANG] = ACTIONS(3501),
    [anon_sym_TILDE] = ACTIONS(3501),
    [anon_sym_DASH] = ACTIONS(3499),
    [anon_sym_PLUS] = ACTIONS(3499),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_AMP_AMP] = ACTIONS(3501),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_SEMI] = ACTIONS(3501),
    [anon_sym___extension__] = ACTIONS(3499),
    [anon_sym_typedef] = ACTIONS(3499),
    [anon_sym_extern] = ACTIONS(3499),
    [anon_sym___attribute__] = ACTIONS(3499),
    [anon_sym_COLON_COLON] = ACTIONS(3501),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3501),
    [anon_sym___declspec] = ACTIONS(3499),
    [anon_sym___based] = ACTIONS(3499),
    [anon_sym___cdecl] = ACTIONS(3499),
    [anon_sym___clrcall] = ACTIONS(3499),
    [anon_sym___stdcall] = ACTIONS(3499),
    [anon_sym___fastcall] = ACTIONS(3499),
    [anon_sym___thiscall] = ACTIONS(3499),
    [anon_sym___vectorcall] = ACTIONS(3499),
    [anon_sym_LBRACE] = ACTIONS(3501),
    [anon_sym_signed] = ACTIONS(3499),
    [anon_sym_unsigned] = ACTIONS(3499),
    [anon_sym_long] = ACTIONS(3499),
    [anon_sym_short] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(3499),
    [anon_sym_static] = ACTIONS(3499),
    [anon_sym_register] = ACTIONS(3499),
    [anon_sym_inline] = ACTIONS(3499),
    [anon_sym___inline] = ACTIONS(3499),
    [anon_sym___inline__] = ACTIONS(3499),
    [anon_sym___forceinline] = ACTIONS(3499),
    [anon_sym_thread_local] = ACTIONS(3499),
    [anon_sym___thread] = ACTIONS(3499),
    [anon_sym_const] = ACTIONS(3499),
    [anon_sym_constexpr] = ACTIONS(3499),
    [anon_sym_volatile] = ACTIONS(3499),
    [anon_sym_restrict] = ACTIONS(3499),
    [anon_sym___restrict__] = ACTIONS(3499),
    [anon_sym__Atomic] = ACTIONS(3499),
    [anon_sym__Noreturn] = ACTIONS(3499),
    [anon_sym_noreturn] = ACTIONS(3499),
    [anon_sym_mutable] = ACTIONS(3499),
    [anon_sym_constinit] = ACTIONS(3499),
    [anon_sym_consteval] = ACTIONS(3499),
    [anon_sym_PROGMEM] = ACTIONS(3499),
    [aux_sym_primitive_type_token1] = ACTIONS(3499),
    [anon_sym_byte] = ACTIONS(3499),
    [anon_sym_word] = ACTIONS(3499),
    [anon_sym_enum] = ACTIONS(3499),
    [anon_sym_class] = ACTIONS(3499),
    [anon_sym_struct] = ACTIONS(3499),
    [anon_sym_union] = ACTIONS(3499),
    [anon_sym_if] = ACTIONS(3499),
    [anon_sym_switch] = ACTIONS(3499),
    [anon_sym_case] = ACTIONS(3499),
    [anon_sym_default] = ACTIONS(3499),
    [anon_sym_while] = ACTIONS(3499),
    [anon_sym_do] = ACTIONS(3499),
    [anon_sym_for] = ACTIONS(3499),
    [anon_sym_return] = ACTIONS(3499),
    [anon_sym_break] = ACTIONS(3499),
    [anon_sym_continue] = ACTIONS(3499),
    [anon_sym_goto] = ACTIONS(3499),
    [anon_sym___try] = ACTIONS(3499),
    [anon_sym___leave] = ACTIONS(3499),
    [anon_sym_not] = ACTIONS(3499),
    [anon_sym_compl] = ACTIONS(3499),
    [anon_sym_DASH_DASH] = ACTIONS(3501),
    [anon_sym_PLUS_PLUS] = ACTIONS(3501),
    [anon_sym_sizeof] = ACTIONS(3499),
    [anon_sym___alignof__] = ACTIONS(3499),
    [anon_sym___alignof] = ACTIONS(3499),
    [anon_sym__alignof] = ACTIONS(3499),
    [anon_sym_alignof] = ACTIONS(3499),
    [anon_sym__Alignof] = ACTIONS(3499),
    [anon_sym_offsetof] = ACTIONS(3499),
    [anon_sym__Generic] = ACTIONS(3499),
    [anon_sym_asm] = ACTIONS(3499),
    [anon_sym___asm__] = ACTIONS(3499),
    [aux_sym_number_literal_token1] = ACTIONS(3501),
    [aux_sym_number_literal_token2] = ACTIONS(3499),
    [anon_sym_L_SQUOTE] = ACTIONS(3501),
    [anon_sym_u_SQUOTE] = ACTIONS(3501),
    [anon_sym_U_SQUOTE] = ACTIONS(3501),
    [anon_sym_u8_SQUOTE] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3501),
    [anon_sym_L_DQUOTE] = ACTIONS(3501),
    [anon_sym_u_DQUOTE] = ACTIONS(3501),
    [anon_sym_U_DQUOTE] = ACTIONS(3501),
    [anon_sym_u8_DQUOTE] = ACTIONS(3501),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [sym_true] = ACTIONS(3499),
    [sym_false] = ACTIONS(3499),
    [anon_sym_NULL] = ACTIONS(3499),
    [anon_sym_nullptr] = ACTIONS(3499),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3499),
    [anon_sym_decltype] = ACTIONS(3499),
    [anon_sym_virtual] = ACTIONS(3499),
    [anon_sym_alignas] = ACTIONS(3499),
    [anon_sym_explicit] = ACTIONS(3499),
    [anon_sym_typename] = ACTIONS(3499),
    [anon_sym_template] = ACTIONS(3499),
    [anon_sym_operator] = ACTIONS(3499),
    [anon_sym_try] = ACTIONS(3499),
    [anon_sym_delete] = ACTIONS(3499),
    [anon_sym_throw] = ACTIONS(3499),
    [anon_sym_namespace] = ACTIONS(3499),
    [anon_sym_using] = ACTIONS(3499),
    [anon_sym_static_assert] = ACTIONS(3499),
    [anon_sym_concept] = ACTIONS(3499),
    [anon_sym_co_return] = ACTIONS(3499),
    [anon_sym_co_yield] = ACTIONS(3499),
    [anon_sym_R_DQUOTE] = ACTIONS(3501),
    [anon_sym_LR_DQUOTE] = ACTIONS(3501),
    [anon_sym_uR_DQUOTE] = ACTIONS(3501),
    [anon_sym_UR_DQUOTE] = ACTIONS(3501),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3501),
    [anon_sym_co_await] = ACTIONS(3499),
    [anon_sym_new] = ACTIONS(3499),
    [anon_sym_requires] = ACTIONS(3499),
    [sym_this] = ACTIONS(3499),
  },
  [555] = {
    [sym_else_clause] = STATE(774),
    [sym_identifier] = ACTIONS(2918),
    [aux_sym_preproc_include_token1] = ACTIONS(2918),
    [aux_sym_preproc_def_token1] = ACTIONS(2918),
    [aux_sym_preproc_if_token1] = ACTIONS(2918),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2918),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2918),
    [sym_preproc_directive] = ACTIONS(2918),
    [anon_sym_LPAREN2] = ACTIONS(2920),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2920),
    [anon_sym_DASH] = ACTIONS(2918),
    [anon_sym_PLUS] = ACTIONS(2918),
    [anon_sym_STAR] = ACTIONS(2920),
    [anon_sym_AMP_AMP] = ACTIONS(2920),
    [anon_sym_AMP] = ACTIONS(2918),
    [anon_sym_SEMI] = ACTIONS(2920),
    [anon_sym___extension__] = ACTIONS(2918),
    [anon_sym_typedef] = ACTIONS(2918),
    [anon_sym_extern] = ACTIONS(2918),
    [anon_sym___attribute__] = ACTIONS(2918),
    [anon_sym_COLON_COLON] = ACTIONS(2920),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2920),
    [anon_sym___declspec] = ACTIONS(2918),
    [anon_sym___based] = ACTIONS(2918),
    [anon_sym___cdecl] = ACTIONS(2918),
    [anon_sym___clrcall] = ACTIONS(2918),
    [anon_sym___stdcall] = ACTIONS(2918),
    [anon_sym___fastcall] = ACTIONS(2918),
    [anon_sym___thiscall] = ACTIONS(2918),
    [anon_sym___vectorcall] = ACTIONS(2918),
    [anon_sym_LBRACE] = ACTIONS(2920),
    [anon_sym_RBRACE] = ACTIONS(2920),
    [anon_sym_signed] = ACTIONS(2918),
    [anon_sym_unsigned] = ACTIONS(2918),
    [anon_sym_long] = ACTIONS(2918),
    [anon_sym_short] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(2918),
    [anon_sym_static] = ACTIONS(2918),
    [anon_sym_register] = ACTIONS(2918),
    [anon_sym_inline] = ACTIONS(2918),
    [anon_sym___inline] = ACTIONS(2918),
    [anon_sym___inline__] = ACTIONS(2918),
    [anon_sym___forceinline] = ACTIONS(2918),
    [anon_sym_thread_local] = ACTIONS(2918),
    [anon_sym___thread] = ACTIONS(2918),
    [anon_sym_const] = ACTIONS(2918),
    [anon_sym_constexpr] = ACTIONS(2918),
    [anon_sym_volatile] = ACTIONS(2918),
    [anon_sym_restrict] = ACTIONS(2918),
    [anon_sym___restrict__] = ACTIONS(2918),
    [anon_sym__Atomic] = ACTIONS(2918),
    [anon_sym__Noreturn] = ACTIONS(2918),
    [anon_sym_noreturn] = ACTIONS(2918),
    [anon_sym_mutable] = ACTIONS(2918),
    [anon_sym_constinit] = ACTIONS(2918),
    [anon_sym_consteval] = ACTIONS(2918),
    [anon_sym_PROGMEM] = ACTIONS(2918),
    [aux_sym_primitive_type_token1] = ACTIONS(2918),
    [anon_sym_byte] = ACTIONS(2918),
    [anon_sym_word] = ACTIONS(2918),
    [anon_sym_enum] = ACTIONS(2918),
    [anon_sym_class] = ACTIONS(2918),
    [anon_sym_struct] = ACTIONS(2918),
    [anon_sym_union] = ACTIONS(2918),
    [anon_sym_if] = ACTIONS(2918),
    [anon_sym_else] = ACTIONS(3531),
    [anon_sym_switch] = ACTIONS(2918),
    [anon_sym_case] = ACTIONS(2918),
    [anon_sym_default] = ACTIONS(2918),
    [anon_sym_while] = ACTIONS(2918),
    [anon_sym_do] = ACTIONS(2918),
    [anon_sym_for] = ACTIONS(2918),
    [anon_sym_return] = ACTIONS(2918),
    [anon_sym_break] = ACTIONS(2918),
    [anon_sym_continue] = ACTIONS(2918),
    [anon_sym_goto] = ACTIONS(2918),
    [anon_sym___try] = ACTIONS(2918),
    [anon_sym___leave] = ACTIONS(2918),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_compl] = ACTIONS(2918),
    [anon_sym_DASH_DASH] = ACTIONS(2920),
    [anon_sym_PLUS_PLUS] = ACTIONS(2920),
    [anon_sym_sizeof] = ACTIONS(2918),
    [anon_sym___alignof__] = ACTIONS(2918),
    [anon_sym___alignof] = ACTIONS(2918),
    [anon_sym__alignof] = ACTIONS(2918),
    [anon_sym_alignof] = ACTIONS(2918),
    [anon_sym__Alignof] = ACTIONS(2918),
    [anon_sym_offsetof] = ACTIONS(2918),
    [anon_sym__Generic] = ACTIONS(2918),
    [anon_sym_asm] = ACTIONS(2918),
    [anon_sym___asm__] = ACTIONS(2918),
    [aux_sym_number_literal_token1] = ACTIONS(2920),
    [aux_sym_number_literal_token2] = ACTIONS(2918),
    [anon_sym_L_SQUOTE] = ACTIONS(2920),
    [anon_sym_u_SQUOTE] = ACTIONS(2920),
    [anon_sym_U_SQUOTE] = ACTIONS(2920),
    [anon_sym_u8_SQUOTE] = ACTIONS(2920),
    [anon_sym_SQUOTE] = ACTIONS(2920),
    [anon_sym_L_DQUOTE] = ACTIONS(2920),
    [anon_sym_u_DQUOTE] = ACTIONS(2920),
    [anon_sym_U_DQUOTE] = ACTIONS(2920),
    [anon_sym_u8_DQUOTE] = ACTIONS(2920),
    [anon_sym_DQUOTE] = ACTIONS(2920),
    [sym_true] = ACTIONS(2918),
    [sym_false] = ACTIONS(2918),
    [anon_sym_NULL] = ACTIONS(2918),
    [anon_sym_nullptr] = ACTIONS(2918),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2918),
    [anon_sym_decltype] = ACTIONS(2918),
    [anon_sym_virtual] = ACTIONS(2918),
    [anon_sym_alignas] = ACTIONS(2918),
    [anon_sym_explicit] = ACTIONS(2918),
    [anon_sym_typename] = ACTIONS(2918),
    [anon_sym_template] = ACTIONS(2918),
    [anon_sym_operator] = ACTIONS(2918),
    [anon_sym_try] = ACTIONS(2918),
    [anon_sym_delete] = ACTIONS(2918),
    [anon_sym_throw] = ACTIONS(2918),
    [anon_sym_namespace] = ACTIONS(2918),
    [anon_sym_using] = ACTIONS(2918),
    [anon_sym_static_assert] = ACTIONS(2918),
    [anon_sym_concept] = ACTIONS(2918),
    [anon_sym_co_return] = ACTIONS(2918),
    [anon_sym_co_yield] = ACTIONS(2918),
    [anon_sym_R_DQUOTE] = ACTIONS(2920),
    [anon_sym_LR_DQUOTE] = ACTIONS(2920),
    [anon_sym_uR_DQUOTE] = ACTIONS(2920),
    [anon_sym_UR_DQUOTE] = ACTIONS(2920),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2920),
    [anon_sym_co_await] = ACTIONS(2918),
    [anon_sym_new] = ACTIONS(2918),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2918),
  },
  [556] = {
    [sym_identifier] = ACTIONS(3346),
    [aux_sym_preproc_include_token1] = ACTIONS(3346),
    [aux_sym_preproc_def_token1] = ACTIONS(3346),
    [aux_sym_preproc_if_token1] = ACTIONS(3346),
    [aux_sym_preproc_if_token2] = ACTIONS(3346),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3346),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3346),
    [aux_sym_preproc_else_token1] = ACTIONS(3346),
    [aux_sym_preproc_elif_token1] = ACTIONS(3346),
    [sym_preproc_directive] = ACTIONS(3346),
    [anon_sym_LPAREN2] = ACTIONS(3348),
    [anon_sym_BANG] = ACTIONS(3348),
    [anon_sym_TILDE] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3348),
    [anon_sym_AMP_AMP] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym_SEMI] = ACTIONS(3348),
    [anon_sym___extension__] = ACTIONS(3346),
    [anon_sym_typedef] = ACTIONS(3346),
    [anon_sym_extern] = ACTIONS(3346),
    [anon_sym___attribute__] = ACTIONS(3346),
    [anon_sym_COLON_COLON] = ACTIONS(3348),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3348),
    [anon_sym___declspec] = ACTIONS(3346),
    [anon_sym___based] = ACTIONS(3346),
    [anon_sym___cdecl] = ACTIONS(3346),
    [anon_sym___clrcall] = ACTIONS(3346),
    [anon_sym___stdcall] = ACTIONS(3346),
    [anon_sym___fastcall] = ACTIONS(3346),
    [anon_sym___thiscall] = ACTIONS(3346),
    [anon_sym___vectorcall] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3348),
    [anon_sym_signed] = ACTIONS(3346),
    [anon_sym_unsigned] = ACTIONS(3346),
    [anon_sym_long] = ACTIONS(3346),
    [anon_sym_short] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3346),
    [anon_sym_register] = ACTIONS(3346),
    [anon_sym_inline] = ACTIONS(3346),
    [anon_sym___inline] = ACTIONS(3346),
    [anon_sym___inline__] = ACTIONS(3346),
    [anon_sym___forceinline] = ACTIONS(3346),
    [anon_sym_thread_local] = ACTIONS(3346),
    [anon_sym___thread] = ACTIONS(3346),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_constexpr] = ACTIONS(3346),
    [anon_sym_volatile] = ACTIONS(3346),
    [anon_sym_restrict] = ACTIONS(3346),
    [anon_sym___restrict__] = ACTIONS(3346),
    [anon_sym__Atomic] = ACTIONS(3346),
    [anon_sym__Noreturn] = ACTIONS(3346),
    [anon_sym_noreturn] = ACTIONS(3346),
    [anon_sym_mutable] = ACTIONS(3346),
    [anon_sym_constinit] = ACTIONS(3346),
    [anon_sym_consteval] = ACTIONS(3346),
    [anon_sym_PROGMEM] = ACTIONS(3346),
    [aux_sym_primitive_type_token1] = ACTIONS(3346),
    [anon_sym_byte] = ACTIONS(3346),
    [anon_sym_word] = ACTIONS(3346),
    [anon_sym_enum] = ACTIONS(3346),
    [anon_sym_class] = ACTIONS(3346),
    [anon_sym_struct] = ACTIONS(3346),
    [anon_sym_union] = ACTIONS(3346),
    [anon_sym_if] = ACTIONS(3346),
    [anon_sym_switch] = ACTIONS(3346),
    [anon_sym_case] = ACTIONS(3346),
    [anon_sym_default] = ACTIONS(3346),
    [anon_sym_while] = ACTIONS(3346),
    [anon_sym_do] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3346),
    [anon_sym_return] = ACTIONS(3346),
    [anon_sym_break] = ACTIONS(3346),
    [anon_sym_continue] = ACTIONS(3346),
    [anon_sym_goto] = ACTIONS(3346),
    [anon_sym___try] = ACTIONS(3346),
    [anon_sym___leave] = ACTIONS(3346),
    [anon_sym_not] = ACTIONS(3346),
    [anon_sym_compl] = ACTIONS(3346),
    [anon_sym_DASH_DASH] = ACTIONS(3348),
    [anon_sym_PLUS_PLUS] = ACTIONS(3348),
    [anon_sym_sizeof] = ACTIONS(3346),
    [anon_sym___alignof__] = ACTIONS(3346),
    [anon_sym___alignof] = ACTIONS(3346),
    [anon_sym__alignof] = ACTIONS(3346),
    [anon_sym_alignof] = ACTIONS(3346),
    [anon_sym__Alignof] = ACTIONS(3346),
    [anon_sym_offsetof] = ACTIONS(3346),
    [anon_sym__Generic] = ACTIONS(3346),
    [anon_sym_asm] = ACTIONS(3346),
    [anon_sym___asm__] = ACTIONS(3346),
    [aux_sym_number_literal_token1] = ACTIONS(3348),
    [aux_sym_number_literal_token2] = ACTIONS(3346),
    [anon_sym_L_SQUOTE] = ACTIONS(3348),
    [anon_sym_u_SQUOTE] = ACTIONS(3348),
    [anon_sym_U_SQUOTE] = ACTIONS(3348),
    [anon_sym_u8_SQUOTE] = ACTIONS(3348),
    [anon_sym_SQUOTE] = ACTIONS(3348),
    [anon_sym_L_DQUOTE] = ACTIONS(3348),
    [anon_sym_u_DQUOTE] = ACTIONS(3348),
    [anon_sym_U_DQUOTE] = ACTIONS(3348),
    [anon_sym_u8_DQUOTE] = ACTIONS(3348),
    [anon_sym_DQUOTE] = ACTIONS(3348),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [anon_sym_NULL] = ACTIONS(3346),
    [anon_sym_nullptr] = ACTIONS(3346),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3346),
    [anon_sym_decltype] = ACTIONS(3346),
    [anon_sym_virtual] = ACTIONS(3346),
    [anon_sym_alignas] = ACTIONS(3346),
    [anon_sym_explicit] = ACTIONS(3346),
    [anon_sym_typename] = ACTIONS(3346),
    [anon_sym_template] = ACTIONS(3346),
    [anon_sym_operator] = ACTIONS(3346),
    [anon_sym_try] = ACTIONS(3346),
    [anon_sym_delete] = ACTIONS(3346),
    [anon_sym_throw] = ACTIONS(3346),
    [anon_sym_namespace] = ACTIONS(3346),
    [anon_sym_using] = ACTIONS(3346),
    [anon_sym_static_assert] = ACTIONS(3346),
    [anon_sym_concept] = ACTIONS(3346),
    [anon_sym_co_return] = ACTIONS(3346),
    [anon_sym_co_yield] = ACTIONS(3346),
    [anon_sym_R_DQUOTE] = ACTIONS(3348),
    [anon_sym_LR_DQUOTE] = ACTIONS(3348),
    [anon_sym_uR_DQUOTE] = ACTIONS(3348),
    [anon_sym_UR_DQUOTE] = ACTIONS(3348),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3348),
    [anon_sym_co_await] = ACTIONS(3346),
    [anon_sym_new] = ACTIONS(3346),
    [anon_sym_requires] = ACTIONS(3346),
    [sym_this] = ACTIONS(3346),
  },
  [557] = {
    [sym_identifier] = ACTIONS(3521),
    [aux_sym_preproc_include_token1] = ACTIONS(3521),
    [aux_sym_preproc_def_token1] = ACTIONS(3521),
    [aux_sym_preproc_if_token1] = ACTIONS(3521),
    [aux_sym_preproc_if_token2] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3521),
    [aux_sym_preproc_else_token1] = ACTIONS(3521),
    [aux_sym_preproc_elif_token1] = ACTIONS(3521),
    [sym_preproc_directive] = ACTIONS(3521),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_BANG] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3521),
    [anon_sym_PLUS] = ACTIONS(3521),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3521),
    [anon_sym_SEMI] = ACTIONS(3523),
    [anon_sym___extension__] = ACTIONS(3521),
    [anon_sym_typedef] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym___attribute__] = ACTIONS(3521),
    [anon_sym_COLON_COLON] = ACTIONS(3523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3523),
    [anon_sym___declspec] = ACTIONS(3521),
    [anon_sym___based] = ACTIONS(3521),
    [anon_sym___cdecl] = ACTIONS(3521),
    [anon_sym___clrcall] = ACTIONS(3521),
    [anon_sym___stdcall] = ACTIONS(3521),
    [anon_sym___fastcall] = ACTIONS(3521),
    [anon_sym___thiscall] = ACTIONS(3521),
    [anon_sym___vectorcall] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_signed] = ACTIONS(3521),
    [anon_sym_unsigned] = ACTIONS(3521),
    [anon_sym_long] = ACTIONS(3521),
    [anon_sym_short] = ACTIONS(3521),
    [anon_sym_LBRACK] = ACTIONS(3521),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_register] = ACTIONS(3521),
    [anon_sym_inline] = ACTIONS(3521),
    [anon_sym___inline] = ACTIONS(3521),
    [anon_sym___inline__] = ACTIONS(3521),
    [anon_sym___forceinline] = ACTIONS(3521),
    [anon_sym_thread_local] = ACTIONS(3521),
    [anon_sym___thread] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_constexpr] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym_restrict] = ACTIONS(3521),
    [anon_sym___restrict__] = ACTIONS(3521),
    [anon_sym__Atomic] = ACTIONS(3521),
    [anon_sym__Noreturn] = ACTIONS(3521),
    [anon_sym_noreturn] = ACTIONS(3521),
    [anon_sym_mutable] = ACTIONS(3521),
    [anon_sym_constinit] = ACTIONS(3521),
    [anon_sym_consteval] = ACTIONS(3521),
    [anon_sym_PROGMEM] = ACTIONS(3521),
    [aux_sym_primitive_type_token1] = ACTIONS(3521),
    [anon_sym_byte] = ACTIONS(3521),
    [anon_sym_word] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_class] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_union] = ACTIONS(3521),
    [anon_sym_if] = ACTIONS(3521),
    [anon_sym_switch] = ACTIONS(3521),
    [anon_sym_case] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3521),
    [anon_sym_while] = ACTIONS(3521),
    [anon_sym_do] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3521),
    [anon_sym_return] = ACTIONS(3521),
    [anon_sym_break] = ACTIONS(3521),
    [anon_sym_continue] = ACTIONS(3521),
    [anon_sym_goto] = ACTIONS(3521),
    [anon_sym___try] = ACTIONS(3521),
    [anon_sym___leave] = ACTIONS(3521),
    [anon_sym_not] = ACTIONS(3521),
    [anon_sym_compl] = ACTIONS(3521),
    [anon_sym_DASH_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_PLUS] = ACTIONS(3523),
    [anon_sym_sizeof] = ACTIONS(3521),
    [anon_sym___alignof__] = ACTIONS(3521),
    [anon_sym___alignof] = ACTIONS(3521),
    [anon_sym__alignof] = ACTIONS(3521),
    [anon_sym_alignof] = ACTIONS(3521),
    [anon_sym__Alignof] = ACTIONS(3521),
    [anon_sym_offsetof] = ACTIONS(3521),
    [anon_sym__Generic] = ACTIONS(3521),
    [anon_sym_asm] = ACTIONS(3521),
    [anon_sym___asm__] = ACTIONS(3521),
    [aux_sym_number_literal_token1] = ACTIONS(3523),
    [aux_sym_number_literal_token2] = ACTIONS(3521),
    [anon_sym_L_SQUOTE] = ACTIONS(3523),
    [anon_sym_u_SQUOTE] = ACTIONS(3523),
    [anon_sym_U_SQUOTE] = ACTIONS(3523),
    [anon_sym_u8_SQUOTE] = ACTIONS(3523),
    [anon_sym_SQUOTE] = ACTIONS(3523),
    [anon_sym_L_DQUOTE] = ACTIONS(3523),
    [anon_sym_u_DQUOTE] = ACTIONS(3523),
    [anon_sym_U_DQUOTE] = ACTIONS(3523),
    [anon_sym_u8_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [sym_true] = ACTIONS(3521),
    [sym_false] = ACTIONS(3521),
    [anon_sym_NULL] = ACTIONS(3521),
    [anon_sym_nullptr] = ACTIONS(3521),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3521),
    [anon_sym_decltype] = ACTIONS(3521),
    [anon_sym_virtual] = ACTIONS(3521),
    [anon_sym_alignas] = ACTIONS(3521),
    [anon_sym_explicit] = ACTIONS(3521),
    [anon_sym_typename] = ACTIONS(3521),
    [anon_sym_template] = ACTIONS(3521),
    [anon_sym_operator] = ACTIONS(3521),
    [anon_sym_try] = ACTIONS(3521),
    [anon_sym_delete] = ACTIONS(3521),
    [anon_sym_throw] = ACTIONS(3521),
    [anon_sym_namespace] = ACTIONS(3521),
    [anon_sym_using] = ACTIONS(3521),
    [anon_sym_static_assert] = ACTIONS(3521),
    [anon_sym_concept] = ACTIONS(3521),
    [anon_sym_co_return] = ACTIONS(3521),
    [anon_sym_co_yield] = ACTIONS(3521),
    [anon_sym_R_DQUOTE] = ACTIONS(3523),
    [anon_sym_LR_DQUOTE] = ACTIONS(3523),
    [anon_sym_uR_DQUOTE] = ACTIONS(3523),
    [anon_sym_UR_DQUOTE] = ACTIONS(3523),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3523),
    [anon_sym_co_await] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3521),
    [anon_sym_requires] = ACTIONS(3521),
    [sym_this] = ACTIONS(3521),
  },
  [558] = {
    [sym_identifier] = ACTIONS(3254),
    [aux_sym_preproc_include_token1] = ACTIONS(3254),
    [aux_sym_preproc_def_token1] = ACTIONS(3254),
    [aux_sym_preproc_if_token1] = ACTIONS(3254),
    [aux_sym_preproc_if_token2] = ACTIONS(3254),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3254),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3254),
    [aux_sym_preproc_else_token1] = ACTIONS(3254),
    [aux_sym_preproc_elif_token1] = ACTIONS(3254),
    [sym_preproc_directive] = ACTIONS(3254),
    [anon_sym_LPAREN2] = ACTIONS(3256),
    [anon_sym_BANG] = ACTIONS(3256),
    [anon_sym_TILDE] = ACTIONS(3256),
    [anon_sym_DASH] = ACTIONS(3254),
    [anon_sym_PLUS] = ACTIONS(3254),
    [anon_sym_STAR] = ACTIONS(3256),
    [anon_sym_AMP_AMP] = ACTIONS(3256),
    [anon_sym_AMP] = ACTIONS(3254),
    [anon_sym_SEMI] = ACTIONS(3256),
    [anon_sym___extension__] = ACTIONS(3254),
    [anon_sym_typedef] = ACTIONS(3254),
    [anon_sym_extern] = ACTIONS(3254),
    [anon_sym___attribute__] = ACTIONS(3254),
    [anon_sym_COLON_COLON] = ACTIONS(3256),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3256),
    [anon_sym___declspec] = ACTIONS(3254),
    [anon_sym___based] = ACTIONS(3254),
    [anon_sym___cdecl] = ACTIONS(3254),
    [anon_sym___clrcall] = ACTIONS(3254),
    [anon_sym___stdcall] = ACTIONS(3254),
    [anon_sym___fastcall] = ACTIONS(3254),
    [anon_sym___thiscall] = ACTIONS(3254),
    [anon_sym___vectorcall] = ACTIONS(3254),
    [anon_sym_LBRACE] = ACTIONS(3256),
    [anon_sym_signed] = ACTIONS(3254),
    [anon_sym_unsigned] = ACTIONS(3254),
    [anon_sym_long] = ACTIONS(3254),
    [anon_sym_short] = ACTIONS(3254),
    [anon_sym_LBRACK] = ACTIONS(3254),
    [anon_sym_static] = ACTIONS(3254),
    [anon_sym_register] = ACTIONS(3254),
    [anon_sym_inline] = ACTIONS(3254),
    [anon_sym___inline] = ACTIONS(3254),
    [anon_sym___inline__] = ACTIONS(3254),
    [anon_sym___forceinline] = ACTIONS(3254),
    [anon_sym_thread_local] = ACTIONS(3254),
    [anon_sym___thread] = ACTIONS(3254),
    [anon_sym_const] = ACTIONS(3254),
    [anon_sym_constexpr] = ACTIONS(3254),
    [anon_sym_volatile] = ACTIONS(3254),
    [anon_sym_restrict] = ACTIONS(3254),
    [anon_sym___restrict__] = ACTIONS(3254),
    [anon_sym__Atomic] = ACTIONS(3254),
    [anon_sym__Noreturn] = ACTIONS(3254),
    [anon_sym_noreturn] = ACTIONS(3254),
    [anon_sym_mutable] = ACTIONS(3254),
    [anon_sym_constinit] = ACTIONS(3254),
    [anon_sym_consteval] = ACTIONS(3254),
    [anon_sym_PROGMEM] = ACTIONS(3254),
    [aux_sym_primitive_type_token1] = ACTIONS(3254),
    [anon_sym_byte] = ACTIONS(3254),
    [anon_sym_word] = ACTIONS(3254),
    [anon_sym_enum] = ACTIONS(3254),
    [anon_sym_class] = ACTIONS(3254),
    [anon_sym_struct] = ACTIONS(3254),
    [anon_sym_union] = ACTIONS(3254),
    [anon_sym_if] = ACTIONS(3254),
    [anon_sym_switch] = ACTIONS(3254),
    [anon_sym_case] = ACTIONS(3254),
    [anon_sym_default] = ACTIONS(3254),
    [anon_sym_while] = ACTIONS(3254),
    [anon_sym_do] = ACTIONS(3254),
    [anon_sym_for] = ACTIONS(3254),
    [anon_sym_return] = ACTIONS(3254),
    [anon_sym_break] = ACTIONS(3254),
    [anon_sym_continue] = ACTIONS(3254),
    [anon_sym_goto] = ACTIONS(3254),
    [anon_sym___try] = ACTIONS(3254),
    [anon_sym___leave] = ACTIONS(3254),
    [anon_sym_not] = ACTIONS(3254),
    [anon_sym_compl] = ACTIONS(3254),
    [anon_sym_DASH_DASH] = ACTIONS(3256),
    [anon_sym_PLUS_PLUS] = ACTIONS(3256),
    [anon_sym_sizeof] = ACTIONS(3254),
    [anon_sym___alignof__] = ACTIONS(3254),
    [anon_sym___alignof] = ACTIONS(3254),
    [anon_sym__alignof] = ACTIONS(3254),
    [anon_sym_alignof] = ACTIONS(3254),
    [anon_sym__Alignof] = ACTIONS(3254),
    [anon_sym_offsetof] = ACTIONS(3254),
    [anon_sym__Generic] = ACTIONS(3254),
    [anon_sym_asm] = ACTIONS(3254),
    [anon_sym___asm__] = ACTIONS(3254),
    [aux_sym_number_literal_token1] = ACTIONS(3256),
    [aux_sym_number_literal_token2] = ACTIONS(3254),
    [anon_sym_L_SQUOTE] = ACTIONS(3256),
    [anon_sym_u_SQUOTE] = ACTIONS(3256),
    [anon_sym_U_SQUOTE] = ACTIONS(3256),
    [anon_sym_u8_SQUOTE] = ACTIONS(3256),
    [anon_sym_SQUOTE] = ACTIONS(3256),
    [anon_sym_L_DQUOTE] = ACTIONS(3256),
    [anon_sym_u_DQUOTE] = ACTIONS(3256),
    [anon_sym_U_DQUOTE] = ACTIONS(3256),
    [anon_sym_u8_DQUOTE] = ACTIONS(3256),
    [anon_sym_DQUOTE] = ACTIONS(3256),
    [sym_true] = ACTIONS(3254),
    [sym_false] = ACTIONS(3254),
    [anon_sym_NULL] = ACTIONS(3254),
    [anon_sym_nullptr] = ACTIONS(3254),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3254),
    [anon_sym_decltype] = ACTIONS(3254),
    [anon_sym_virtual] = ACTIONS(3254),
    [anon_sym_alignas] = ACTIONS(3254),
    [anon_sym_explicit] = ACTIONS(3254),
    [anon_sym_typename] = ACTIONS(3254),
    [anon_sym_template] = ACTIONS(3254),
    [anon_sym_operator] = ACTIONS(3254),
    [anon_sym_try] = ACTIONS(3254),
    [anon_sym_delete] = ACTIONS(3254),
    [anon_sym_throw] = ACTIONS(3254),
    [anon_sym_namespace] = ACTIONS(3254),
    [anon_sym_using] = ACTIONS(3254),
    [anon_sym_static_assert] = ACTIONS(3254),
    [anon_sym_concept] = ACTIONS(3254),
    [anon_sym_co_return] = ACTIONS(3254),
    [anon_sym_co_yield] = ACTIONS(3254),
    [anon_sym_R_DQUOTE] = ACTIONS(3256),
    [anon_sym_LR_DQUOTE] = ACTIONS(3256),
    [anon_sym_uR_DQUOTE] = ACTIONS(3256),
    [anon_sym_UR_DQUOTE] = ACTIONS(3256),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3256),
    [anon_sym_co_await] = ACTIONS(3254),
    [anon_sym_new] = ACTIONS(3254),
    [anon_sym_requires] = ACTIONS(3254),
    [sym_this] = ACTIONS(3254),
  },
  [559] = {
    [sym_identifier] = ACTIONS(3443),
    [aux_sym_preproc_include_token1] = ACTIONS(3443),
    [aux_sym_preproc_def_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token2] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3443),
    [aux_sym_preproc_else_token1] = ACTIONS(3443),
    [aux_sym_preproc_elif_token1] = ACTIONS(3443),
    [sym_preproc_directive] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3445),
    [anon_sym_BANG] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_AMP_AMP] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_SEMI] = ACTIONS(3445),
    [anon_sym___extension__] = ACTIONS(3443),
    [anon_sym_typedef] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym___attribute__] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3445),
    [anon_sym___declspec] = ACTIONS(3443),
    [anon_sym___based] = ACTIONS(3443),
    [anon_sym___cdecl] = ACTIONS(3443),
    [anon_sym___clrcall] = ACTIONS(3443),
    [anon_sym___stdcall] = ACTIONS(3443),
    [anon_sym___fastcall] = ACTIONS(3443),
    [anon_sym___thiscall] = ACTIONS(3443),
    [anon_sym___vectorcall] = ACTIONS(3443),
    [anon_sym_LBRACE] = ACTIONS(3445),
    [anon_sym_signed] = ACTIONS(3443),
    [anon_sym_unsigned] = ACTIONS(3443),
    [anon_sym_long] = ACTIONS(3443),
    [anon_sym_short] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_register] = ACTIONS(3443),
    [anon_sym_inline] = ACTIONS(3443),
    [anon_sym___inline] = ACTIONS(3443),
    [anon_sym___inline__] = ACTIONS(3443),
    [anon_sym___forceinline] = ACTIONS(3443),
    [anon_sym_thread_local] = ACTIONS(3443),
    [anon_sym___thread] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_constexpr] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_restrict] = ACTIONS(3443),
    [anon_sym___restrict__] = ACTIONS(3443),
    [anon_sym__Atomic] = ACTIONS(3443),
    [anon_sym__Noreturn] = ACTIONS(3443),
    [anon_sym_noreturn] = ACTIONS(3443),
    [anon_sym_mutable] = ACTIONS(3443),
    [anon_sym_constinit] = ACTIONS(3443),
    [anon_sym_consteval] = ACTIONS(3443),
    [anon_sym_PROGMEM] = ACTIONS(3443),
    [aux_sym_primitive_type_token1] = ACTIONS(3443),
    [anon_sym_byte] = ACTIONS(3443),
    [anon_sym_word] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_union] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_switch] = ACTIONS(3443),
    [anon_sym_case] = ACTIONS(3443),
    [anon_sym_default] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_break] = ACTIONS(3443),
    [anon_sym_continue] = ACTIONS(3443),
    [anon_sym_goto] = ACTIONS(3443),
    [anon_sym___try] = ACTIONS(3443),
    [anon_sym___leave] = ACTIONS(3443),
    [anon_sym_not] = ACTIONS(3443),
    [anon_sym_compl] = ACTIONS(3443),
    [anon_sym_DASH_DASH] = ACTIONS(3445),
    [anon_sym_PLUS_PLUS] = ACTIONS(3445),
    [anon_sym_sizeof] = ACTIONS(3443),
    [anon_sym___alignof__] = ACTIONS(3443),
    [anon_sym___alignof] = ACTIONS(3443),
    [anon_sym__alignof] = ACTIONS(3443),
    [anon_sym_alignof] = ACTIONS(3443),
    [anon_sym__Alignof] = ACTIONS(3443),
    [anon_sym_offsetof] = ACTIONS(3443),
    [anon_sym__Generic] = ACTIONS(3443),
    [anon_sym_asm] = ACTIONS(3443),
    [anon_sym___asm__] = ACTIONS(3443),
    [aux_sym_number_literal_token1] = ACTIONS(3445),
    [aux_sym_number_literal_token2] = ACTIONS(3443),
    [anon_sym_L_SQUOTE] = ACTIONS(3445),
    [anon_sym_u_SQUOTE] = ACTIONS(3445),
    [anon_sym_U_SQUOTE] = ACTIONS(3445),
    [anon_sym_u8_SQUOTE] = ACTIONS(3445),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_L_DQUOTE] = ACTIONS(3445),
    [anon_sym_u_DQUOTE] = ACTIONS(3445),
    [anon_sym_U_DQUOTE] = ACTIONS(3445),
    [anon_sym_u8_DQUOTE] = ACTIONS(3445),
    [anon_sym_DQUOTE] = ACTIONS(3445),
    [sym_true] = ACTIONS(3443),
    [sym_false] = ACTIONS(3443),
    [anon_sym_NULL] = ACTIONS(3443),
    [anon_sym_nullptr] = ACTIONS(3443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3443),
    [anon_sym_decltype] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_alignas] = ACTIONS(3443),
    [anon_sym_explicit] = ACTIONS(3443),
    [anon_sym_typename] = ACTIONS(3443),
    [anon_sym_template] = ACTIONS(3443),
    [anon_sym_operator] = ACTIONS(3443),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_delete] = ACTIONS(3443),
    [anon_sym_throw] = ACTIONS(3443),
    [anon_sym_namespace] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_static_assert] = ACTIONS(3443),
    [anon_sym_concept] = ACTIONS(3443),
    [anon_sym_co_return] = ACTIONS(3443),
    [anon_sym_co_yield] = ACTIONS(3443),
    [anon_sym_R_DQUOTE] = ACTIONS(3445),
    [anon_sym_LR_DQUOTE] = ACTIONS(3445),
    [anon_sym_uR_DQUOTE] = ACTIONS(3445),
    [anon_sym_UR_DQUOTE] = ACTIONS(3445),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3445),
    [anon_sym_co_await] = ACTIONS(3443),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_requires] = ACTIONS(3443),
    [sym_this] = ACTIONS(3443),
  },
  [560] = {
    [sym_identifier] = ACTIONS(3495),
    [aux_sym_preproc_include_token1] = ACTIONS(3495),
    [aux_sym_preproc_def_token1] = ACTIONS(3495),
    [aux_sym_preproc_if_token1] = ACTIONS(3495),
    [aux_sym_preproc_if_token2] = ACTIONS(3495),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3495),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3495),
    [aux_sym_preproc_else_token1] = ACTIONS(3495),
    [aux_sym_preproc_elif_token1] = ACTIONS(3495),
    [sym_preproc_directive] = ACTIONS(3495),
    [anon_sym_LPAREN2] = ACTIONS(3497),
    [anon_sym_BANG] = ACTIONS(3497),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_AMP_AMP] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(3495),
    [anon_sym_SEMI] = ACTIONS(3497),
    [anon_sym___extension__] = ACTIONS(3495),
    [anon_sym_typedef] = ACTIONS(3495),
    [anon_sym_extern] = ACTIONS(3495),
    [anon_sym___attribute__] = ACTIONS(3495),
    [anon_sym_COLON_COLON] = ACTIONS(3497),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3497),
    [anon_sym___declspec] = ACTIONS(3495),
    [anon_sym___based] = ACTIONS(3495),
    [anon_sym___cdecl] = ACTIONS(3495),
    [anon_sym___clrcall] = ACTIONS(3495),
    [anon_sym___stdcall] = ACTIONS(3495),
    [anon_sym___fastcall] = ACTIONS(3495),
    [anon_sym___thiscall] = ACTIONS(3495),
    [anon_sym___vectorcall] = ACTIONS(3495),
    [anon_sym_LBRACE] = ACTIONS(3497),
    [anon_sym_signed] = ACTIONS(3495),
    [anon_sym_unsigned] = ACTIONS(3495),
    [anon_sym_long] = ACTIONS(3495),
    [anon_sym_short] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(3495),
    [anon_sym_static] = ACTIONS(3495),
    [anon_sym_register] = ACTIONS(3495),
    [anon_sym_inline] = ACTIONS(3495),
    [anon_sym___inline] = ACTIONS(3495),
    [anon_sym___inline__] = ACTIONS(3495),
    [anon_sym___forceinline] = ACTIONS(3495),
    [anon_sym_thread_local] = ACTIONS(3495),
    [anon_sym___thread] = ACTIONS(3495),
    [anon_sym_const] = ACTIONS(3495),
    [anon_sym_constexpr] = ACTIONS(3495),
    [anon_sym_volatile] = ACTIONS(3495),
    [anon_sym_restrict] = ACTIONS(3495),
    [anon_sym___restrict__] = ACTIONS(3495),
    [anon_sym__Atomic] = ACTIONS(3495),
    [anon_sym__Noreturn] = ACTIONS(3495),
    [anon_sym_noreturn] = ACTIONS(3495),
    [anon_sym_mutable] = ACTIONS(3495),
    [anon_sym_constinit] = ACTIONS(3495),
    [anon_sym_consteval] = ACTIONS(3495),
    [anon_sym_PROGMEM] = ACTIONS(3495),
    [aux_sym_primitive_type_token1] = ACTIONS(3495),
    [anon_sym_byte] = ACTIONS(3495),
    [anon_sym_word] = ACTIONS(3495),
    [anon_sym_enum] = ACTIONS(3495),
    [anon_sym_class] = ACTIONS(3495),
    [anon_sym_struct] = ACTIONS(3495),
    [anon_sym_union] = ACTIONS(3495),
    [anon_sym_if] = ACTIONS(3495),
    [anon_sym_switch] = ACTIONS(3495),
    [anon_sym_case] = ACTIONS(3495),
    [anon_sym_default] = ACTIONS(3495),
    [anon_sym_while] = ACTIONS(3495),
    [anon_sym_do] = ACTIONS(3495),
    [anon_sym_for] = ACTIONS(3495),
    [anon_sym_return] = ACTIONS(3495),
    [anon_sym_break] = ACTIONS(3495),
    [anon_sym_continue] = ACTIONS(3495),
    [anon_sym_goto] = ACTIONS(3495),
    [anon_sym___try] = ACTIONS(3495),
    [anon_sym___leave] = ACTIONS(3495),
    [anon_sym_not] = ACTIONS(3495),
    [anon_sym_compl] = ACTIONS(3495),
    [anon_sym_DASH_DASH] = ACTIONS(3497),
    [anon_sym_PLUS_PLUS] = ACTIONS(3497),
    [anon_sym_sizeof] = ACTIONS(3495),
    [anon_sym___alignof__] = ACTIONS(3495),
    [anon_sym___alignof] = ACTIONS(3495),
    [anon_sym__alignof] = ACTIONS(3495),
    [anon_sym_alignof] = ACTIONS(3495),
    [anon_sym__Alignof] = ACTIONS(3495),
    [anon_sym_offsetof] = ACTIONS(3495),
    [anon_sym__Generic] = ACTIONS(3495),
    [anon_sym_asm] = ACTIONS(3495),
    [anon_sym___asm__] = ACTIONS(3495),
    [aux_sym_number_literal_token1] = ACTIONS(3497),
    [aux_sym_number_literal_token2] = ACTIONS(3495),
    [anon_sym_L_SQUOTE] = ACTIONS(3497),
    [anon_sym_u_SQUOTE] = ACTIONS(3497),
    [anon_sym_U_SQUOTE] = ACTIONS(3497),
    [anon_sym_u8_SQUOTE] = ACTIONS(3497),
    [anon_sym_SQUOTE] = ACTIONS(3497),
    [anon_sym_L_DQUOTE] = ACTIONS(3497),
    [anon_sym_u_DQUOTE] = ACTIONS(3497),
    [anon_sym_U_DQUOTE] = ACTIONS(3497),
    [anon_sym_u8_DQUOTE] = ACTIONS(3497),
    [anon_sym_DQUOTE] = ACTIONS(3497),
    [sym_true] = ACTIONS(3495),
    [sym_false] = ACTIONS(3495),
    [anon_sym_NULL] = ACTIONS(3495),
    [anon_sym_nullptr] = ACTIONS(3495),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3495),
    [anon_sym_decltype] = ACTIONS(3495),
    [anon_sym_virtual] = ACTIONS(3495),
    [anon_sym_alignas] = ACTIONS(3495),
    [anon_sym_explicit] = ACTIONS(3495),
    [anon_sym_typename] = ACTIONS(3495),
    [anon_sym_template] = ACTIONS(3495),
    [anon_sym_operator] = ACTIONS(3495),
    [anon_sym_try] = ACTIONS(3495),
    [anon_sym_delete] = ACTIONS(3495),
    [anon_sym_throw] = ACTIONS(3495),
    [anon_sym_namespace] = ACTIONS(3495),
    [anon_sym_using] = ACTIONS(3495),
    [anon_sym_static_assert] = ACTIONS(3495),
    [anon_sym_concept] = ACTIONS(3495),
    [anon_sym_co_return] = ACTIONS(3495),
    [anon_sym_co_yield] = ACTIONS(3495),
    [anon_sym_R_DQUOTE] = ACTIONS(3497),
    [anon_sym_LR_DQUOTE] = ACTIONS(3497),
    [anon_sym_uR_DQUOTE] = ACTIONS(3497),
    [anon_sym_UR_DQUOTE] = ACTIONS(3497),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3497),
    [anon_sym_co_await] = ACTIONS(3495),
    [anon_sym_new] = ACTIONS(3495),
    [anon_sym_requires] = ACTIONS(3495),
    [sym_this] = ACTIONS(3495),
  },
  [561] = {
    [sym_identifier] = ACTIONS(3443),
    [aux_sym_preproc_include_token1] = ACTIONS(3443),
    [aux_sym_preproc_def_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token2] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3443),
    [aux_sym_preproc_else_token1] = ACTIONS(3443),
    [aux_sym_preproc_elif_token1] = ACTIONS(3443),
    [sym_preproc_directive] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3445),
    [anon_sym_BANG] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_AMP_AMP] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_SEMI] = ACTIONS(3445),
    [anon_sym___extension__] = ACTIONS(3443),
    [anon_sym_typedef] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym___attribute__] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3445),
    [anon_sym___declspec] = ACTIONS(3443),
    [anon_sym___based] = ACTIONS(3443),
    [anon_sym___cdecl] = ACTIONS(3443),
    [anon_sym___clrcall] = ACTIONS(3443),
    [anon_sym___stdcall] = ACTIONS(3443),
    [anon_sym___fastcall] = ACTIONS(3443),
    [anon_sym___thiscall] = ACTIONS(3443),
    [anon_sym___vectorcall] = ACTIONS(3443),
    [anon_sym_LBRACE] = ACTIONS(3445),
    [anon_sym_signed] = ACTIONS(3443),
    [anon_sym_unsigned] = ACTIONS(3443),
    [anon_sym_long] = ACTIONS(3443),
    [anon_sym_short] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_register] = ACTIONS(3443),
    [anon_sym_inline] = ACTIONS(3443),
    [anon_sym___inline] = ACTIONS(3443),
    [anon_sym___inline__] = ACTIONS(3443),
    [anon_sym___forceinline] = ACTIONS(3443),
    [anon_sym_thread_local] = ACTIONS(3443),
    [anon_sym___thread] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_constexpr] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_restrict] = ACTIONS(3443),
    [anon_sym___restrict__] = ACTIONS(3443),
    [anon_sym__Atomic] = ACTIONS(3443),
    [anon_sym__Noreturn] = ACTIONS(3443),
    [anon_sym_noreturn] = ACTIONS(3443),
    [anon_sym_mutable] = ACTIONS(3443),
    [anon_sym_constinit] = ACTIONS(3443),
    [anon_sym_consteval] = ACTIONS(3443),
    [anon_sym_PROGMEM] = ACTIONS(3443),
    [aux_sym_primitive_type_token1] = ACTIONS(3443),
    [anon_sym_byte] = ACTIONS(3443),
    [anon_sym_word] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_union] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_switch] = ACTIONS(3443),
    [anon_sym_case] = ACTIONS(3443),
    [anon_sym_default] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_break] = ACTIONS(3443),
    [anon_sym_continue] = ACTIONS(3443),
    [anon_sym_goto] = ACTIONS(3443),
    [anon_sym___try] = ACTIONS(3443),
    [anon_sym___leave] = ACTIONS(3443),
    [anon_sym_not] = ACTIONS(3443),
    [anon_sym_compl] = ACTIONS(3443),
    [anon_sym_DASH_DASH] = ACTIONS(3445),
    [anon_sym_PLUS_PLUS] = ACTIONS(3445),
    [anon_sym_sizeof] = ACTIONS(3443),
    [anon_sym___alignof__] = ACTIONS(3443),
    [anon_sym___alignof] = ACTIONS(3443),
    [anon_sym__alignof] = ACTIONS(3443),
    [anon_sym_alignof] = ACTIONS(3443),
    [anon_sym__Alignof] = ACTIONS(3443),
    [anon_sym_offsetof] = ACTIONS(3443),
    [anon_sym__Generic] = ACTIONS(3443),
    [anon_sym_asm] = ACTIONS(3443),
    [anon_sym___asm__] = ACTIONS(3443),
    [aux_sym_number_literal_token1] = ACTIONS(3445),
    [aux_sym_number_literal_token2] = ACTIONS(3443),
    [anon_sym_L_SQUOTE] = ACTIONS(3445),
    [anon_sym_u_SQUOTE] = ACTIONS(3445),
    [anon_sym_U_SQUOTE] = ACTIONS(3445),
    [anon_sym_u8_SQUOTE] = ACTIONS(3445),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_L_DQUOTE] = ACTIONS(3445),
    [anon_sym_u_DQUOTE] = ACTIONS(3445),
    [anon_sym_U_DQUOTE] = ACTIONS(3445),
    [anon_sym_u8_DQUOTE] = ACTIONS(3445),
    [anon_sym_DQUOTE] = ACTIONS(3445),
    [sym_true] = ACTIONS(3443),
    [sym_false] = ACTIONS(3443),
    [anon_sym_NULL] = ACTIONS(3443),
    [anon_sym_nullptr] = ACTIONS(3443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3443),
    [anon_sym_decltype] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_alignas] = ACTIONS(3443),
    [anon_sym_explicit] = ACTIONS(3443),
    [anon_sym_typename] = ACTIONS(3443),
    [anon_sym_template] = ACTIONS(3443),
    [anon_sym_operator] = ACTIONS(3443),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_delete] = ACTIONS(3443),
    [anon_sym_throw] = ACTIONS(3443),
    [anon_sym_namespace] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_static_assert] = ACTIONS(3443),
    [anon_sym_concept] = ACTIONS(3443),
    [anon_sym_co_return] = ACTIONS(3443),
    [anon_sym_co_yield] = ACTIONS(3443),
    [anon_sym_R_DQUOTE] = ACTIONS(3445),
    [anon_sym_LR_DQUOTE] = ACTIONS(3445),
    [anon_sym_uR_DQUOTE] = ACTIONS(3445),
    [anon_sym_UR_DQUOTE] = ACTIONS(3445),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3445),
    [anon_sym_co_await] = ACTIONS(3443),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_requires] = ACTIONS(3443),
    [sym_this] = ACTIONS(3443),
  },
  [562] = {
    [sym_identifier] = ACTIONS(3439),
    [aux_sym_preproc_include_token1] = ACTIONS(3439),
    [aux_sym_preproc_def_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token2] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3439),
    [aux_sym_preproc_else_token1] = ACTIONS(3439),
    [aux_sym_preproc_elif_token1] = ACTIONS(3439),
    [sym_preproc_directive] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3441),
    [anon_sym_BANG] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_DASH] = ACTIONS(3439),
    [anon_sym_PLUS] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3439),
    [anon_sym_SEMI] = ACTIONS(3441),
    [anon_sym___extension__] = ACTIONS(3439),
    [anon_sym_typedef] = ACTIONS(3439),
    [anon_sym_extern] = ACTIONS(3439),
    [anon_sym___attribute__] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3441),
    [anon_sym___declspec] = ACTIONS(3439),
    [anon_sym___based] = ACTIONS(3439),
    [anon_sym___cdecl] = ACTIONS(3439),
    [anon_sym___clrcall] = ACTIONS(3439),
    [anon_sym___stdcall] = ACTIONS(3439),
    [anon_sym___fastcall] = ACTIONS(3439),
    [anon_sym___thiscall] = ACTIONS(3439),
    [anon_sym___vectorcall] = ACTIONS(3439),
    [anon_sym_LBRACE] = ACTIONS(3441),
    [anon_sym_signed] = ACTIONS(3439),
    [anon_sym_unsigned] = ACTIONS(3439),
    [anon_sym_long] = ACTIONS(3439),
    [anon_sym_short] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_register] = ACTIONS(3439),
    [anon_sym_inline] = ACTIONS(3439),
    [anon_sym___inline] = ACTIONS(3439),
    [anon_sym___inline__] = ACTIONS(3439),
    [anon_sym___forceinline] = ACTIONS(3439),
    [anon_sym_thread_local] = ACTIONS(3439),
    [anon_sym___thread] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_constexpr] = ACTIONS(3439),
    [anon_sym_volatile] = ACTIONS(3439),
    [anon_sym_restrict] = ACTIONS(3439),
    [anon_sym___restrict__] = ACTIONS(3439),
    [anon_sym__Atomic] = ACTIONS(3439),
    [anon_sym__Noreturn] = ACTIONS(3439),
    [anon_sym_noreturn] = ACTIONS(3439),
    [anon_sym_mutable] = ACTIONS(3439),
    [anon_sym_constinit] = ACTIONS(3439),
    [anon_sym_consteval] = ACTIONS(3439),
    [anon_sym_PROGMEM] = ACTIONS(3439),
    [aux_sym_primitive_type_token1] = ACTIONS(3439),
    [anon_sym_byte] = ACTIONS(3439),
    [anon_sym_word] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_struct] = ACTIONS(3439),
    [anon_sym_union] = ACTIONS(3439),
    [anon_sym_if] = ACTIONS(3439),
    [anon_sym_switch] = ACTIONS(3439),
    [anon_sym_case] = ACTIONS(3439),
    [anon_sym_default] = ACTIONS(3439),
    [anon_sym_while] = ACTIONS(3439),
    [anon_sym_do] = ACTIONS(3439),
    [anon_sym_for] = ACTIONS(3439),
    [anon_sym_return] = ACTIONS(3439),
    [anon_sym_break] = ACTIONS(3439),
    [anon_sym_continue] = ACTIONS(3439),
    [anon_sym_goto] = ACTIONS(3439),
    [anon_sym___try] = ACTIONS(3439),
    [anon_sym___leave] = ACTIONS(3439),
    [anon_sym_not] = ACTIONS(3439),
    [anon_sym_compl] = ACTIONS(3439),
    [anon_sym_DASH_DASH] = ACTIONS(3441),
    [anon_sym_PLUS_PLUS] = ACTIONS(3441),
    [anon_sym_sizeof] = ACTIONS(3439),
    [anon_sym___alignof__] = ACTIONS(3439),
    [anon_sym___alignof] = ACTIONS(3439),
    [anon_sym__alignof] = ACTIONS(3439),
    [anon_sym_alignof] = ACTIONS(3439),
    [anon_sym__Alignof] = ACTIONS(3439),
    [anon_sym_offsetof] = ACTIONS(3439),
    [anon_sym__Generic] = ACTIONS(3439),
    [anon_sym_asm] = ACTIONS(3439),
    [anon_sym___asm__] = ACTIONS(3439),
    [aux_sym_number_literal_token1] = ACTIONS(3441),
    [aux_sym_number_literal_token2] = ACTIONS(3439),
    [anon_sym_L_SQUOTE] = ACTIONS(3441),
    [anon_sym_u_SQUOTE] = ACTIONS(3441),
    [anon_sym_U_SQUOTE] = ACTIONS(3441),
    [anon_sym_u8_SQUOTE] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [anon_sym_L_DQUOTE] = ACTIONS(3441),
    [anon_sym_u_DQUOTE] = ACTIONS(3441),
    [anon_sym_U_DQUOTE] = ACTIONS(3441),
    [anon_sym_u8_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE] = ACTIONS(3441),
    [sym_true] = ACTIONS(3439),
    [sym_false] = ACTIONS(3439),
    [anon_sym_NULL] = ACTIONS(3439),
    [anon_sym_nullptr] = ACTIONS(3439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3439),
    [anon_sym_decltype] = ACTIONS(3439),
    [anon_sym_virtual] = ACTIONS(3439),
    [anon_sym_alignas] = ACTIONS(3439),
    [anon_sym_explicit] = ACTIONS(3439),
    [anon_sym_typename] = ACTIONS(3439),
    [anon_sym_template] = ACTIONS(3439),
    [anon_sym_operator] = ACTIONS(3439),
    [anon_sym_try] = ACTIONS(3439),
    [anon_sym_delete] = ACTIONS(3439),
    [anon_sym_throw] = ACTIONS(3439),
    [anon_sym_namespace] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_static_assert] = ACTIONS(3439),
    [anon_sym_concept] = ACTIONS(3439),
    [anon_sym_co_return] = ACTIONS(3439),
    [anon_sym_co_yield] = ACTIONS(3439),
    [anon_sym_R_DQUOTE] = ACTIONS(3441),
    [anon_sym_LR_DQUOTE] = ACTIONS(3441),
    [anon_sym_uR_DQUOTE] = ACTIONS(3441),
    [anon_sym_UR_DQUOTE] = ACTIONS(3441),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3441),
    [anon_sym_co_await] = ACTIONS(3439),
    [anon_sym_new] = ACTIONS(3439),
    [anon_sym_requires] = ACTIONS(3439),
    [sym_this] = ACTIONS(3439),
  },
  [563] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_include_token1] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_BANG] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(2265),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym___cdecl] = ACTIONS(2267),
    [anon_sym___clrcall] = ACTIONS(2267),
    [anon_sym___stdcall] = ACTIONS(2267),
    [anon_sym___fastcall] = ACTIONS(2267),
    [anon_sym___thiscall] = ACTIONS(2267),
    [anon_sym___vectorcall] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2265),
    [anon_sym_RBRACE] = ACTIONS(2265),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_else] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_case] = ACTIONS(2267),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_return] = ACTIONS(2267),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_continue] = ACTIONS(2267),
    [anon_sym_goto] = ACTIONS(2267),
    [anon_sym___try] = ACTIONS(2267),
    [anon_sym___leave] = ACTIONS(2267),
    [anon_sym_not] = ACTIONS(2267),
    [anon_sym_compl] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2265),
    [anon_sym_PLUS_PLUS] = ACTIONS(2265),
    [anon_sym_sizeof] = ACTIONS(2267),
    [anon_sym___alignof__] = ACTIONS(2267),
    [anon_sym___alignof] = ACTIONS(2267),
    [anon_sym__alignof] = ACTIONS(2267),
    [anon_sym_alignof] = ACTIONS(2267),
    [anon_sym__Alignof] = ACTIONS(2267),
    [anon_sym_offsetof] = ACTIONS(2267),
    [anon_sym__Generic] = ACTIONS(2267),
    [anon_sym_asm] = ACTIONS(2267),
    [anon_sym___asm__] = ACTIONS(2267),
    [aux_sym_number_literal_token1] = ACTIONS(2265),
    [aux_sym_number_literal_token2] = ACTIONS(2267),
    [anon_sym_L_SQUOTE] = ACTIONS(2265),
    [anon_sym_u_SQUOTE] = ACTIONS(2265),
    [anon_sym_U_SQUOTE] = ACTIONS(2265),
    [anon_sym_u8_SQUOTE] = ACTIONS(2265),
    [anon_sym_SQUOTE] = ACTIONS(2265),
    [anon_sym_L_DQUOTE] = ACTIONS(2265),
    [anon_sym_u_DQUOTE] = ACTIONS(2265),
    [anon_sym_U_DQUOTE] = ACTIONS(2265),
    [anon_sym_u8_DQUOTE] = ACTIONS(2265),
    [anon_sym_DQUOTE] = ACTIONS(2265),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [anon_sym_NULL] = ACTIONS(2267),
    [anon_sym_nullptr] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_try] = ACTIONS(2267),
    [anon_sym_delete] = ACTIONS(2267),
    [anon_sym_throw] = ACTIONS(2267),
    [anon_sym_namespace] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym_concept] = ACTIONS(2267),
    [anon_sym_co_return] = ACTIONS(2267),
    [anon_sym_co_yield] = ACTIONS(2267),
    [anon_sym_catch] = ACTIONS(2267),
    [anon_sym_R_DQUOTE] = ACTIONS(2265),
    [anon_sym_LR_DQUOTE] = ACTIONS(2265),
    [anon_sym_uR_DQUOTE] = ACTIONS(2265),
    [anon_sym_UR_DQUOTE] = ACTIONS(2265),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2265),
    [anon_sym_co_await] = ACTIONS(2267),
    [anon_sym_new] = ACTIONS(2267),
    [anon_sym_requires] = ACTIONS(2267),
    [sym_this] = ACTIONS(2267),
  },
  [564] = {
    [sym_identifier] = ACTIONS(3439),
    [aux_sym_preproc_include_token1] = ACTIONS(3439),
    [aux_sym_preproc_def_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token2] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3439),
    [aux_sym_preproc_else_token1] = ACTIONS(3439),
    [aux_sym_preproc_elif_token1] = ACTIONS(3439),
    [sym_preproc_directive] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3441),
    [anon_sym_BANG] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_DASH] = ACTIONS(3439),
    [anon_sym_PLUS] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3439),
    [anon_sym_SEMI] = ACTIONS(3441),
    [anon_sym___extension__] = ACTIONS(3439),
    [anon_sym_typedef] = ACTIONS(3439),
    [anon_sym_extern] = ACTIONS(3439),
    [anon_sym___attribute__] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3441),
    [anon_sym___declspec] = ACTIONS(3439),
    [anon_sym___based] = ACTIONS(3439),
    [anon_sym___cdecl] = ACTIONS(3439),
    [anon_sym___clrcall] = ACTIONS(3439),
    [anon_sym___stdcall] = ACTIONS(3439),
    [anon_sym___fastcall] = ACTIONS(3439),
    [anon_sym___thiscall] = ACTIONS(3439),
    [anon_sym___vectorcall] = ACTIONS(3439),
    [anon_sym_LBRACE] = ACTIONS(3441),
    [anon_sym_signed] = ACTIONS(3439),
    [anon_sym_unsigned] = ACTIONS(3439),
    [anon_sym_long] = ACTIONS(3439),
    [anon_sym_short] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_register] = ACTIONS(3439),
    [anon_sym_inline] = ACTIONS(3439),
    [anon_sym___inline] = ACTIONS(3439),
    [anon_sym___inline__] = ACTIONS(3439),
    [anon_sym___forceinline] = ACTIONS(3439),
    [anon_sym_thread_local] = ACTIONS(3439),
    [anon_sym___thread] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_constexpr] = ACTIONS(3439),
    [anon_sym_volatile] = ACTIONS(3439),
    [anon_sym_restrict] = ACTIONS(3439),
    [anon_sym___restrict__] = ACTIONS(3439),
    [anon_sym__Atomic] = ACTIONS(3439),
    [anon_sym__Noreturn] = ACTIONS(3439),
    [anon_sym_noreturn] = ACTIONS(3439),
    [anon_sym_mutable] = ACTIONS(3439),
    [anon_sym_constinit] = ACTIONS(3439),
    [anon_sym_consteval] = ACTIONS(3439),
    [anon_sym_PROGMEM] = ACTIONS(3439),
    [aux_sym_primitive_type_token1] = ACTIONS(3439),
    [anon_sym_byte] = ACTIONS(3439),
    [anon_sym_word] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_struct] = ACTIONS(3439),
    [anon_sym_union] = ACTIONS(3439),
    [anon_sym_if] = ACTIONS(3439),
    [anon_sym_switch] = ACTIONS(3439),
    [anon_sym_case] = ACTIONS(3439),
    [anon_sym_default] = ACTIONS(3439),
    [anon_sym_while] = ACTIONS(3439),
    [anon_sym_do] = ACTIONS(3439),
    [anon_sym_for] = ACTIONS(3439),
    [anon_sym_return] = ACTIONS(3439),
    [anon_sym_break] = ACTIONS(3439),
    [anon_sym_continue] = ACTIONS(3439),
    [anon_sym_goto] = ACTIONS(3439),
    [anon_sym___try] = ACTIONS(3439),
    [anon_sym___leave] = ACTIONS(3439),
    [anon_sym_not] = ACTIONS(3439),
    [anon_sym_compl] = ACTIONS(3439),
    [anon_sym_DASH_DASH] = ACTIONS(3441),
    [anon_sym_PLUS_PLUS] = ACTIONS(3441),
    [anon_sym_sizeof] = ACTIONS(3439),
    [anon_sym___alignof__] = ACTIONS(3439),
    [anon_sym___alignof] = ACTIONS(3439),
    [anon_sym__alignof] = ACTIONS(3439),
    [anon_sym_alignof] = ACTIONS(3439),
    [anon_sym__Alignof] = ACTIONS(3439),
    [anon_sym_offsetof] = ACTIONS(3439),
    [anon_sym__Generic] = ACTIONS(3439),
    [anon_sym_asm] = ACTIONS(3439),
    [anon_sym___asm__] = ACTIONS(3439),
    [aux_sym_number_literal_token1] = ACTIONS(3441),
    [aux_sym_number_literal_token2] = ACTIONS(3439),
    [anon_sym_L_SQUOTE] = ACTIONS(3441),
    [anon_sym_u_SQUOTE] = ACTIONS(3441),
    [anon_sym_U_SQUOTE] = ACTIONS(3441),
    [anon_sym_u8_SQUOTE] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [anon_sym_L_DQUOTE] = ACTIONS(3441),
    [anon_sym_u_DQUOTE] = ACTIONS(3441),
    [anon_sym_U_DQUOTE] = ACTIONS(3441),
    [anon_sym_u8_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE] = ACTIONS(3441),
    [sym_true] = ACTIONS(3439),
    [sym_false] = ACTIONS(3439),
    [anon_sym_NULL] = ACTIONS(3439),
    [anon_sym_nullptr] = ACTIONS(3439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3439),
    [anon_sym_decltype] = ACTIONS(3439),
    [anon_sym_virtual] = ACTIONS(3439),
    [anon_sym_alignas] = ACTIONS(3439),
    [anon_sym_explicit] = ACTIONS(3439),
    [anon_sym_typename] = ACTIONS(3439),
    [anon_sym_template] = ACTIONS(3439),
    [anon_sym_operator] = ACTIONS(3439),
    [anon_sym_try] = ACTIONS(3439),
    [anon_sym_delete] = ACTIONS(3439),
    [anon_sym_throw] = ACTIONS(3439),
    [anon_sym_namespace] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_static_assert] = ACTIONS(3439),
    [anon_sym_concept] = ACTIONS(3439),
    [anon_sym_co_return] = ACTIONS(3439),
    [anon_sym_co_yield] = ACTIONS(3439),
    [anon_sym_R_DQUOTE] = ACTIONS(3441),
    [anon_sym_LR_DQUOTE] = ACTIONS(3441),
    [anon_sym_uR_DQUOTE] = ACTIONS(3441),
    [anon_sym_UR_DQUOTE] = ACTIONS(3441),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3441),
    [anon_sym_co_await] = ACTIONS(3439),
    [anon_sym_new] = ACTIONS(3439),
    [anon_sym_requires] = ACTIONS(3439),
    [sym_this] = ACTIONS(3439),
  },
  [565] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_include_token1] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token2] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_BANG] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(2265),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym___cdecl] = ACTIONS(2267),
    [anon_sym___clrcall] = ACTIONS(2267),
    [anon_sym___stdcall] = ACTIONS(2267),
    [anon_sym___fastcall] = ACTIONS(2267),
    [anon_sym___thiscall] = ACTIONS(2267),
    [anon_sym___vectorcall] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2265),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_else] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_case] = ACTIONS(2267),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_return] = ACTIONS(2267),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_continue] = ACTIONS(2267),
    [anon_sym_goto] = ACTIONS(2267),
    [anon_sym___try] = ACTIONS(2267),
    [anon_sym___leave] = ACTIONS(2267),
    [anon_sym_not] = ACTIONS(2267),
    [anon_sym_compl] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2265),
    [anon_sym_PLUS_PLUS] = ACTIONS(2265),
    [anon_sym_sizeof] = ACTIONS(2267),
    [anon_sym___alignof__] = ACTIONS(2267),
    [anon_sym___alignof] = ACTIONS(2267),
    [anon_sym__alignof] = ACTIONS(2267),
    [anon_sym_alignof] = ACTIONS(2267),
    [anon_sym__Alignof] = ACTIONS(2267),
    [anon_sym_offsetof] = ACTIONS(2267),
    [anon_sym__Generic] = ACTIONS(2267),
    [anon_sym_asm] = ACTIONS(2267),
    [anon_sym___asm__] = ACTIONS(2267),
    [aux_sym_number_literal_token1] = ACTIONS(2265),
    [aux_sym_number_literal_token2] = ACTIONS(2267),
    [anon_sym_L_SQUOTE] = ACTIONS(2265),
    [anon_sym_u_SQUOTE] = ACTIONS(2265),
    [anon_sym_U_SQUOTE] = ACTIONS(2265),
    [anon_sym_u8_SQUOTE] = ACTIONS(2265),
    [anon_sym_SQUOTE] = ACTIONS(2265),
    [anon_sym_L_DQUOTE] = ACTIONS(2265),
    [anon_sym_u_DQUOTE] = ACTIONS(2265),
    [anon_sym_U_DQUOTE] = ACTIONS(2265),
    [anon_sym_u8_DQUOTE] = ACTIONS(2265),
    [anon_sym_DQUOTE] = ACTIONS(2265),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [anon_sym_NULL] = ACTIONS(2267),
    [anon_sym_nullptr] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_try] = ACTIONS(2267),
    [anon_sym_delete] = ACTIONS(2267),
    [anon_sym_throw] = ACTIONS(2267),
    [anon_sym_namespace] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym_concept] = ACTIONS(2267),
    [anon_sym_co_return] = ACTIONS(2267),
    [anon_sym_co_yield] = ACTIONS(2267),
    [anon_sym_catch] = ACTIONS(2267),
    [anon_sym_R_DQUOTE] = ACTIONS(2265),
    [anon_sym_LR_DQUOTE] = ACTIONS(2265),
    [anon_sym_uR_DQUOTE] = ACTIONS(2265),
    [anon_sym_UR_DQUOTE] = ACTIONS(2265),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2265),
    [anon_sym_co_await] = ACTIONS(2267),
    [anon_sym_new] = ACTIONS(2267),
    [anon_sym_requires] = ACTIONS(2267),
    [sym_this] = ACTIONS(2267),
  },
  [566] = {
    [sym_else_clause] = STATE(827),
    [ts_builtin_sym_end] = ACTIONS(2893),
    [sym_identifier] = ACTIONS(2891),
    [aux_sym_preproc_include_token1] = ACTIONS(2891),
    [aux_sym_preproc_def_token1] = ACTIONS(2891),
    [aux_sym_preproc_if_token1] = ACTIONS(2891),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2891),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2891),
    [sym_preproc_directive] = ACTIONS(2891),
    [anon_sym_LPAREN2] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_AMP_AMP] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym___extension__] = ACTIONS(2891),
    [anon_sym_typedef] = ACTIONS(2891),
    [anon_sym_extern] = ACTIONS(2891),
    [anon_sym___attribute__] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2893),
    [anon_sym___declspec] = ACTIONS(2891),
    [anon_sym___based] = ACTIONS(2891),
    [anon_sym___cdecl] = ACTIONS(2891),
    [anon_sym___clrcall] = ACTIONS(2891),
    [anon_sym___stdcall] = ACTIONS(2891),
    [anon_sym___fastcall] = ACTIONS(2891),
    [anon_sym___thiscall] = ACTIONS(2891),
    [anon_sym___vectorcall] = ACTIONS(2891),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_signed] = ACTIONS(2891),
    [anon_sym_unsigned] = ACTIONS(2891),
    [anon_sym_long] = ACTIONS(2891),
    [anon_sym_short] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_static] = ACTIONS(2891),
    [anon_sym_register] = ACTIONS(2891),
    [anon_sym_inline] = ACTIONS(2891),
    [anon_sym___inline] = ACTIONS(2891),
    [anon_sym___inline__] = ACTIONS(2891),
    [anon_sym___forceinline] = ACTIONS(2891),
    [anon_sym_thread_local] = ACTIONS(2891),
    [anon_sym___thread] = ACTIONS(2891),
    [anon_sym_const] = ACTIONS(2891),
    [anon_sym_constexpr] = ACTIONS(2891),
    [anon_sym_volatile] = ACTIONS(2891),
    [anon_sym_restrict] = ACTIONS(2891),
    [anon_sym___restrict__] = ACTIONS(2891),
    [anon_sym__Atomic] = ACTIONS(2891),
    [anon_sym__Noreturn] = ACTIONS(2891),
    [anon_sym_noreturn] = ACTIONS(2891),
    [anon_sym_mutable] = ACTIONS(2891),
    [anon_sym_constinit] = ACTIONS(2891),
    [anon_sym_consteval] = ACTIONS(2891),
    [anon_sym_PROGMEM] = ACTIONS(2891),
    [aux_sym_primitive_type_token1] = ACTIONS(2891),
    [anon_sym_byte] = ACTIONS(2891),
    [anon_sym_word] = ACTIONS(2891),
    [anon_sym_enum] = ACTIONS(2891),
    [anon_sym_class] = ACTIONS(2891),
    [anon_sym_struct] = ACTIONS(2891),
    [anon_sym_union] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_else] = ACTIONS(3533),
    [anon_sym_switch] = ACTIONS(2891),
    [anon_sym_case] = ACTIONS(2891),
    [anon_sym_default] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2891),
    [anon_sym_for] = ACTIONS(2891),
    [anon_sym_return] = ACTIONS(2891),
    [anon_sym_break] = ACTIONS(2891),
    [anon_sym_continue] = ACTIONS(2891),
    [anon_sym_goto] = ACTIONS(2891),
    [anon_sym___try] = ACTIONS(2891),
    [anon_sym___leave] = ACTIONS(2891),
    [anon_sym_not] = ACTIONS(2891),
    [anon_sym_compl] = ACTIONS(2891),
    [anon_sym_DASH_DASH] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2893),
    [anon_sym_sizeof] = ACTIONS(2891),
    [anon_sym___alignof__] = ACTIONS(2891),
    [anon_sym___alignof] = ACTIONS(2891),
    [anon_sym__alignof] = ACTIONS(2891),
    [anon_sym_alignof] = ACTIONS(2891),
    [anon_sym__Alignof] = ACTIONS(2891),
    [anon_sym_offsetof] = ACTIONS(2891),
    [anon_sym__Generic] = ACTIONS(2891),
    [anon_sym_asm] = ACTIONS(2891),
    [anon_sym___asm__] = ACTIONS(2891),
    [aux_sym_number_literal_token1] = ACTIONS(2893),
    [aux_sym_number_literal_token2] = ACTIONS(2891),
    [anon_sym_L_SQUOTE] = ACTIONS(2893),
    [anon_sym_u_SQUOTE] = ACTIONS(2893),
    [anon_sym_U_SQUOTE] = ACTIONS(2893),
    [anon_sym_u8_SQUOTE] = ACTIONS(2893),
    [anon_sym_SQUOTE] = ACTIONS(2893),
    [anon_sym_L_DQUOTE] = ACTIONS(2893),
    [anon_sym_u_DQUOTE] = ACTIONS(2893),
    [anon_sym_U_DQUOTE] = ACTIONS(2893),
    [anon_sym_u8_DQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(2893),
    [sym_true] = ACTIONS(2891),
    [sym_false] = ACTIONS(2891),
    [anon_sym_NULL] = ACTIONS(2891),
    [anon_sym_nullptr] = ACTIONS(2891),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2891),
    [anon_sym_decltype] = ACTIONS(2891),
    [anon_sym_virtual] = ACTIONS(2891),
    [anon_sym_alignas] = ACTIONS(2891),
    [anon_sym_explicit] = ACTIONS(2891),
    [anon_sym_typename] = ACTIONS(2891),
    [anon_sym_template] = ACTIONS(2891),
    [anon_sym_operator] = ACTIONS(2891),
    [anon_sym_try] = ACTIONS(2891),
    [anon_sym_delete] = ACTIONS(2891),
    [anon_sym_throw] = ACTIONS(2891),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_using] = ACTIONS(2891),
    [anon_sym_static_assert] = ACTIONS(2891),
    [anon_sym_concept] = ACTIONS(2891),
    [anon_sym_co_return] = ACTIONS(2891),
    [anon_sym_co_yield] = ACTIONS(2891),
    [anon_sym_R_DQUOTE] = ACTIONS(2893),
    [anon_sym_LR_DQUOTE] = ACTIONS(2893),
    [anon_sym_uR_DQUOTE] = ACTIONS(2893),
    [anon_sym_UR_DQUOTE] = ACTIONS(2893),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2893),
    [anon_sym_co_await] = ACTIONS(2891),
    [anon_sym_new] = ACTIONS(2891),
    [anon_sym_requires] = ACTIONS(2891),
    [sym_this] = ACTIONS(2891),
  },
  [567] = {
    [sym_identifier] = ACTIONS(3447),
    [aux_sym_preproc_include_token1] = ACTIONS(3447),
    [aux_sym_preproc_def_token1] = ACTIONS(3447),
    [aux_sym_preproc_if_token1] = ACTIONS(3447),
    [aux_sym_preproc_if_token2] = ACTIONS(3447),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3447),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3447),
    [aux_sym_preproc_else_token1] = ACTIONS(3447),
    [aux_sym_preproc_elif_token1] = ACTIONS(3447),
    [sym_preproc_directive] = ACTIONS(3447),
    [anon_sym_LPAREN2] = ACTIONS(3449),
    [anon_sym_BANG] = ACTIONS(3449),
    [anon_sym_TILDE] = ACTIONS(3449),
    [anon_sym_DASH] = ACTIONS(3447),
    [anon_sym_PLUS] = ACTIONS(3447),
    [anon_sym_STAR] = ACTIONS(3449),
    [anon_sym_AMP_AMP] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3447),
    [anon_sym_SEMI] = ACTIONS(3449),
    [anon_sym___extension__] = ACTIONS(3447),
    [anon_sym_typedef] = ACTIONS(3447),
    [anon_sym_extern] = ACTIONS(3447),
    [anon_sym___attribute__] = ACTIONS(3447),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3449),
    [anon_sym___declspec] = ACTIONS(3447),
    [anon_sym___based] = ACTIONS(3447),
    [anon_sym___cdecl] = ACTIONS(3447),
    [anon_sym___clrcall] = ACTIONS(3447),
    [anon_sym___stdcall] = ACTIONS(3447),
    [anon_sym___fastcall] = ACTIONS(3447),
    [anon_sym___thiscall] = ACTIONS(3447),
    [anon_sym___vectorcall] = ACTIONS(3447),
    [anon_sym_LBRACE] = ACTIONS(3449),
    [anon_sym_signed] = ACTIONS(3447),
    [anon_sym_unsigned] = ACTIONS(3447),
    [anon_sym_long] = ACTIONS(3447),
    [anon_sym_short] = ACTIONS(3447),
    [anon_sym_LBRACK] = ACTIONS(3447),
    [anon_sym_static] = ACTIONS(3447),
    [anon_sym_register] = ACTIONS(3447),
    [anon_sym_inline] = ACTIONS(3447),
    [anon_sym___inline] = ACTIONS(3447),
    [anon_sym___inline__] = ACTIONS(3447),
    [anon_sym___forceinline] = ACTIONS(3447),
    [anon_sym_thread_local] = ACTIONS(3447),
    [anon_sym___thread] = ACTIONS(3447),
    [anon_sym_const] = ACTIONS(3447),
    [anon_sym_constexpr] = ACTIONS(3447),
    [anon_sym_volatile] = ACTIONS(3447),
    [anon_sym_restrict] = ACTIONS(3447),
    [anon_sym___restrict__] = ACTIONS(3447),
    [anon_sym__Atomic] = ACTIONS(3447),
    [anon_sym__Noreturn] = ACTIONS(3447),
    [anon_sym_noreturn] = ACTIONS(3447),
    [anon_sym_mutable] = ACTIONS(3447),
    [anon_sym_constinit] = ACTIONS(3447),
    [anon_sym_consteval] = ACTIONS(3447),
    [anon_sym_PROGMEM] = ACTIONS(3447),
    [aux_sym_primitive_type_token1] = ACTIONS(3447),
    [anon_sym_byte] = ACTIONS(3447),
    [anon_sym_word] = ACTIONS(3447),
    [anon_sym_enum] = ACTIONS(3447),
    [anon_sym_class] = ACTIONS(3447),
    [anon_sym_struct] = ACTIONS(3447),
    [anon_sym_union] = ACTIONS(3447),
    [anon_sym_if] = ACTIONS(3447),
    [anon_sym_switch] = ACTIONS(3447),
    [anon_sym_case] = ACTIONS(3447),
    [anon_sym_default] = ACTIONS(3447),
    [anon_sym_while] = ACTIONS(3447),
    [anon_sym_do] = ACTIONS(3447),
    [anon_sym_for] = ACTIONS(3447),
    [anon_sym_return] = ACTIONS(3447),
    [anon_sym_break] = ACTIONS(3447),
    [anon_sym_continue] = ACTIONS(3447),
    [anon_sym_goto] = ACTIONS(3447),
    [anon_sym___try] = ACTIONS(3447),
    [anon_sym___leave] = ACTIONS(3447),
    [anon_sym_not] = ACTIONS(3447),
    [anon_sym_compl] = ACTIONS(3447),
    [anon_sym_DASH_DASH] = ACTIONS(3449),
    [anon_sym_PLUS_PLUS] = ACTIONS(3449),
    [anon_sym_sizeof] = ACTIONS(3447),
    [anon_sym___alignof__] = ACTIONS(3447),
    [anon_sym___alignof] = ACTIONS(3447),
    [anon_sym__alignof] = ACTIONS(3447),
    [anon_sym_alignof] = ACTIONS(3447),
    [anon_sym__Alignof] = ACTIONS(3447),
    [anon_sym_offsetof] = ACTIONS(3447),
    [anon_sym__Generic] = ACTIONS(3447),
    [anon_sym_asm] = ACTIONS(3447),
    [anon_sym___asm__] = ACTIONS(3447),
    [aux_sym_number_literal_token1] = ACTIONS(3449),
    [aux_sym_number_literal_token2] = ACTIONS(3447),
    [anon_sym_L_SQUOTE] = ACTIONS(3449),
    [anon_sym_u_SQUOTE] = ACTIONS(3449),
    [anon_sym_U_SQUOTE] = ACTIONS(3449),
    [anon_sym_u8_SQUOTE] = ACTIONS(3449),
    [anon_sym_SQUOTE] = ACTIONS(3449),
    [anon_sym_L_DQUOTE] = ACTIONS(3449),
    [anon_sym_u_DQUOTE] = ACTIONS(3449),
    [anon_sym_U_DQUOTE] = ACTIONS(3449),
    [anon_sym_u8_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE] = ACTIONS(3449),
    [sym_true] = ACTIONS(3447),
    [sym_false] = ACTIONS(3447),
    [anon_sym_NULL] = ACTIONS(3447),
    [anon_sym_nullptr] = ACTIONS(3447),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3447),
    [anon_sym_decltype] = ACTIONS(3447),
    [anon_sym_virtual] = ACTIONS(3447),
    [anon_sym_alignas] = ACTIONS(3447),
    [anon_sym_explicit] = ACTIONS(3447),
    [anon_sym_typename] = ACTIONS(3447),
    [anon_sym_template] = ACTIONS(3447),
    [anon_sym_operator] = ACTIONS(3447),
    [anon_sym_try] = ACTIONS(3447),
    [anon_sym_delete] = ACTIONS(3447),
    [anon_sym_throw] = ACTIONS(3447),
    [anon_sym_namespace] = ACTIONS(3447),
    [anon_sym_using] = ACTIONS(3447),
    [anon_sym_static_assert] = ACTIONS(3447),
    [anon_sym_concept] = ACTIONS(3447),
    [anon_sym_co_return] = ACTIONS(3447),
    [anon_sym_co_yield] = ACTIONS(3447),
    [anon_sym_R_DQUOTE] = ACTIONS(3449),
    [anon_sym_LR_DQUOTE] = ACTIONS(3449),
    [anon_sym_uR_DQUOTE] = ACTIONS(3449),
    [anon_sym_UR_DQUOTE] = ACTIONS(3449),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3449),
    [anon_sym_co_await] = ACTIONS(3447),
    [anon_sym_new] = ACTIONS(3447),
    [anon_sym_requires] = ACTIONS(3447),
    [sym_this] = ACTIONS(3447),
  },
  [568] = {
    [sym_identifier] = ACTIONS(3332),
    [aux_sym_preproc_include_token1] = ACTIONS(3332),
    [aux_sym_preproc_def_token1] = ACTIONS(3332),
    [aux_sym_preproc_if_token1] = ACTIONS(3332),
    [aux_sym_preproc_if_token2] = ACTIONS(3332),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3332),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3332),
    [aux_sym_preproc_else_token1] = ACTIONS(3332),
    [aux_sym_preproc_elif_token1] = ACTIONS(3332),
    [sym_preproc_directive] = ACTIONS(3332),
    [anon_sym_LPAREN2] = ACTIONS(3334),
    [anon_sym_BANG] = ACTIONS(3334),
    [anon_sym_TILDE] = ACTIONS(3334),
    [anon_sym_DASH] = ACTIONS(3332),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_STAR] = ACTIONS(3334),
    [anon_sym_AMP_AMP] = ACTIONS(3334),
    [anon_sym_AMP] = ACTIONS(3332),
    [anon_sym_SEMI] = ACTIONS(3334),
    [anon_sym___extension__] = ACTIONS(3332),
    [anon_sym_typedef] = ACTIONS(3332),
    [anon_sym_extern] = ACTIONS(3332),
    [anon_sym___attribute__] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(3334),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3334),
    [anon_sym___declspec] = ACTIONS(3332),
    [anon_sym___based] = ACTIONS(3332),
    [anon_sym___cdecl] = ACTIONS(3332),
    [anon_sym___clrcall] = ACTIONS(3332),
    [anon_sym___stdcall] = ACTIONS(3332),
    [anon_sym___fastcall] = ACTIONS(3332),
    [anon_sym___thiscall] = ACTIONS(3332),
    [anon_sym___vectorcall] = ACTIONS(3332),
    [anon_sym_LBRACE] = ACTIONS(3334),
    [anon_sym_signed] = ACTIONS(3332),
    [anon_sym_unsigned] = ACTIONS(3332),
    [anon_sym_long] = ACTIONS(3332),
    [anon_sym_short] = ACTIONS(3332),
    [anon_sym_LBRACK] = ACTIONS(3332),
    [anon_sym_static] = ACTIONS(3332),
    [anon_sym_register] = ACTIONS(3332),
    [anon_sym_inline] = ACTIONS(3332),
    [anon_sym___inline] = ACTIONS(3332),
    [anon_sym___inline__] = ACTIONS(3332),
    [anon_sym___forceinline] = ACTIONS(3332),
    [anon_sym_thread_local] = ACTIONS(3332),
    [anon_sym___thread] = ACTIONS(3332),
    [anon_sym_const] = ACTIONS(3332),
    [anon_sym_constexpr] = ACTIONS(3332),
    [anon_sym_volatile] = ACTIONS(3332),
    [anon_sym_restrict] = ACTIONS(3332),
    [anon_sym___restrict__] = ACTIONS(3332),
    [anon_sym__Atomic] = ACTIONS(3332),
    [anon_sym__Noreturn] = ACTIONS(3332),
    [anon_sym_noreturn] = ACTIONS(3332),
    [anon_sym_mutable] = ACTIONS(3332),
    [anon_sym_constinit] = ACTIONS(3332),
    [anon_sym_consteval] = ACTIONS(3332),
    [anon_sym_PROGMEM] = ACTIONS(3332),
    [aux_sym_primitive_type_token1] = ACTIONS(3332),
    [anon_sym_byte] = ACTIONS(3332),
    [anon_sym_word] = ACTIONS(3332),
    [anon_sym_enum] = ACTIONS(3332),
    [anon_sym_class] = ACTIONS(3332),
    [anon_sym_struct] = ACTIONS(3332),
    [anon_sym_union] = ACTIONS(3332),
    [anon_sym_if] = ACTIONS(3332),
    [anon_sym_switch] = ACTIONS(3332),
    [anon_sym_case] = ACTIONS(3332),
    [anon_sym_default] = ACTIONS(3332),
    [anon_sym_while] = ACTIONS(3332),
    [anon_sym_do] = ACTIONS(3332),
    [anon_sym_for] = ACTIONS(3332),
    [anon_sym_return] = ACTIONS(3332),
    [anon_sym_break] = ACTIONS(3332),
    [anon_sym_continue] = ACTIONS(3332),
    [anon_sym_goto] = ACTIONS(3332),
    [anon_sym___try] = ACTIONS(3332),
    [anon_sym___leave] = ACTIONS(3332),
    [anon_sym_not] = ACTIONS(3332),
    [anon_sym_compl] = ACTIONS(3332),
    [anon_sym_DASH_DASH] = ACTIONS(3334),
    [anon_sym_PLUS_PLUS] = ACTIONS(3334),
    [anon_sym_sizeof] = ACTIONS(3332),
    [anon_sym___alignof__] = ACTIONS(3332),
    [anon_sym___alignof] = ACTIONS(3332),
    [anon_sym__alignof] = ACTIONS(3332),
    [anon_sym_alignof] = ACTIONS(3332),
    [anon_sym__Alignof] = ACTIONS(3332),
    [anon_sym_offsetof] = ACTIONS(3332),
    [anon_sym__Generic] = ACTIONS(3332),
    [anon_sym_asm] = ACTIONS(3332),
    [anon_sym___asm__] = ACTIONS(3332),
    [aux_sym_number_literal_token1] = ACTIONS(3334),
    [aux_sym_number_literal_token2] = ACTIONS(3332),
    [anon_sym_L_SQUOTE] = ACTIONS(3334),
    [anon_sym_u_SQUOTE] = ACTIONS(3334),
    [anon_sym_U_SQUOTE] = ACTIONS(3334),
    [anon_sym_u8_SQUOTE] = ACTIONS(3334),
    [anon_sym_SQUOTE] = ACTIONS(3334),
    [anon_sym_L_DQUOTE] = ACTIONS(3334),
    [anon_sym_u_DQUOTE] = ACTIONS(3334),
    [anon_sym_U_DQUOTE] = ACTIONS(3334),
    [anon_sym_u8_DQUOTE] = ACTIONS(3334),
    [anon_sym_DQUOTE] = ACTIONS(3334),
    [sym_true] = ACTIONS(3332),
    [sym_false] = ACTIONS(3332),
    [anon_sym_NULL] = ACTIONS(3332),
    [anon_sym_nullptr] = ACTIONS(3332),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3332),
    [anon_sym_decltype] = ACTIONS(3332),
    [anon_sym_virtual] = ACTIONS(3332),
    [anon_sym_alignas] = ACTIONS(3332),
    [anon_sym_explicit] = ACTIONS(3332),
    [anon_sym_typename] = ACTIONS(3332),
    [anon_sym_template] = ACTIONS(3332),
    [anon_sym_operator] = ACTIONS(3332),
    [anon_sym_try] = ACTIONS(3332),
    [anon_sym_delete] = ACTIONS(3332),
    [anon_sym_throw] = ACTIONS(3332),
    [anon_sym_namespace] = ACTIONS(3332),
    [anon_sym_using] = ACTIONS(3332),
    [anon_sym_static_assert] = ACTIONS(3332),
    [anon_sym_concept] = ACTIONS(3332),
    [anon_sym_co_return] = ACTIONS(3332),
    [anon_sym_co_yield] = ACTIONS(3332),
    [anon_sym_R_DQUOTE] = ACTIONS(3334),
    [anon_sym_LR_DQUOTE] = ACTIONS(3334),
    [anon_sym_uR_DQUOTE] = ACTIONS(3334),
    [anon_sym_UR_DQUOTE] = ACTIONS(3334),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3334),
    [anon_sym_co_await] = ACTIONS(3332),
    [anon_sym_new] = ACTIONS(3332),
    [anon_sym_requires] = ACTIONS(3332),
    [sym_this] = ACTIONS(3332),
  },
  [569] = {
    [sym_else_clause] = STATE(761),
    [ts_builtin_sym_end] = ACTIONS(2920),
    [sym_identifier] = ACTIONS(2918),
    [aux_sym_preproc_include_token1] = ACTIONS(2918),
    [aux_sym_preproc_def_token1] = ACTIONS(2918),
    [aux_sym_preproc_if_token1] = ACTIONS(2918),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2918),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2918),
    [sym_preproc_directive] = ACTIONS(2918),
    [anon_sym_LPAREN2] = ACTIONS(2920),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2920),
    [anon_sym_DASH] = ACTIONS(2918),
    [anon_sym_PLUS] = ACTIONS(2918),
    [anon_sym_STAR] = ACTIONS(2920),
    [anon_sym_AMP_AMP] = ACTIONS(2920),
    [anon_sym_AMP] = ACTIONS(2918),
    [anon_sym_SEMI] = ACTIONS(2920),
    [anon_sym___extension__] = ACTIONS(2918),
    [anon_sym_typedef] = ACTIONS(2918),
    [anon_sym_extern] = ACTIONS(2918),
    [anon_sym___attribute__] = ACTIONS(2918),
    [anon_sym_COLON_COLON] = ACTIONS(2920),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2920),
    [anon_sym___declspec] = ACTIONS(2918),
    [anon_sym___based] = ACTIONS(2918),
    [anon_sym___cdecl] = ACTIONS(2918),
    [anon_sym___clrcall] = ACTIONS(2918),
    [anon_sym___stdcall] = ACTIONS(2918),
    [anon_sym___fastcall] = ACTIONS(2918),
    [anon_sym___thiscall] = ACTIONS(2918),
    [anon_sym___vectorcall] = ACTIONS(2918),
    [anon_sym_LBRACE] = ACTIONS(2920),
    [anon_sym_signed] = ACTIONS(2918),
    [anon_sym_unsigned] = ACTIONS(2918),
    [anon_sym_long] = ACTIONS(2918),
    [anon_sym_short] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(2918),
    [anon_sym_static] = ACTIONS(2918),
    [anon_sym_register] = ACTIONS(2918),
    [anon_sym_inline] = ACTIONS(2918),
    [anon_sym___inline] = ACTIONS(2918),
    [anon_sym___inline__] = ACTIONS(2918),
    [anon_sym___forceinline] = ACTIONS(2918),
    [anon_sym_thread_local] = ACTIONS(2918),
    [anon_sym___thread] = ACTIONS(2918),
    [anon_sym_const] = ACTIONS(2918),
    [anon_sym_constexpr] = ACTIONS(2918),
    [anon_sym_volatile] = ACTIONS(2918),
    [anon_sym_restrict] = ACTIONS(2918),
    [anon_sym___restrict__] = ACTIONS(2918),
    [anon_sym__Atomic] = ACTIONS(2918),
    [anon_sym__Noreturn] = ACTIONS(2918),
    [anon_sym_noreturn] = ACTIONS(2918),
    [anon_sym_mutable] = ACTIONS(2918),
    [anon_sym_constinit] = ACTIONS(2918),
    [anon_sym_consteval] = ACTIONS(2918),
    [anon_sym_PROGMEM] = ACTIONS(2918),
    [aux_sym_primitive_type_token1] = ACTIONS(2918),
    [anon_sym_byte] = ACTIONS(2918),
    [anon_sym_word] = ACTIONS(2918),
    [anon_sym_enum] = ACTIONS(2918),
    [anon_sym_class] = ACTIONS(2918),
    [anon_sym_struct] = ACTIONS(2918),
    [anon_sym_union] = ACTIONS(2918),
    [anon_sym_if] = ACTIONS(2918),
    [anon_sym_else] = ACTIONS(3533),
    [anon_sym_switch] = ACTIONS(2918),
    [anon_sym_case] = ACTIONS(2918),
    [anon_sym_default] = ACTIONS(2918),
    [anon_sym_while] = ACTIONS(2918),
    [anon_sym_do] = ACTIONS(2918),
    [anon_sym_for] = ACTIONS(2918),
    [anon_sym_return] = ACTIONS(2918),
    [anon_sym_break] = ACTIONS(2918),
    [anon_sym_continue] = ACTIONS(2918),
    [anon_sym_goto] = ACTIONS(2918),
    [anon_sym___try] = ACTIONS(2918),
    [anon_sym___leave] = ACTIONS(2918),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_compl] = ACTIONS(2918),
    [anon_sym_DASH_DASH] = ACTIONS(2920),
    [anon_sym_PLUS_PLUS] = ACTIONS(2920),
    [anon_sym_sizeof] = ACTIONS(2918),
    [anon_sym___alignof__] = ACTIONS(2918),
    [anon_sym___alignof] = ACTIONS(2918),
    [anon_sym__alignof] = ACTIONS(2918),
    [anon_sym_alignof] = ACTIONS(2918),
    [anon_sym__Alignof] = ACTIONS(2918),
    [anon_sym_offsetof] = ACTIONS(2918),
    [anon_sym__Generic] = ACTIONS(2918),
    [anon_sym_asm] = ACTIONS(2918),
    [anon_sym___asm__] = ACTIONS(2918),
    [aux_sym_number_literal_token1] = ACTIONS(2920),
    [aux_sym_number_literal_token2] = ACTIONS(2918),
    [anon_sym_L_SQUOTE] = ACTIONS(2920),
    [anon_sym_u_SQUOTE] = ACTIONS(2920),
    [anon_sym_U_SQUOTE] = ACTIONS(2920),
    [anon_sym_u8_SQUOTE] = ACTIONS(2920),
    [anon_sym_SQUOTE] = ACTIONS(2920),
    [anon_sym_L_DQUOTE] = ACTIONS(2920),
    [anon_sym_u_DQUOTE] = ACTIONS(2920),
    [anon_sym_U_DQUOTE] = ACTIONS(2920),
    [anon_sym_u8_DQUOTE] = ACTIONS(2920),
    [anon_sym_DQUOTE] = ACTIONS(2920),
    [sym_true] = ACTIONS(2918),
    [sym_false] = ACTIONS(2918),
    [anon_sym_NULL] = ACTIONS(2918),
    [anon_sym_nullptr] = ACTIONS(2918),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2918),
    [anon_sym_decltype] = ACTIONS(2918),
    [anon_sym_virtual] = ACTIONS(2918),
    [anon_sym_alignas] = ACTIONS(2918),
    [anon_sym_explicit] = ACTIONS(2918),
    [anon_sym_typename] = ACTIONS(2918),
    [anon_sym_template] = ACTIONS(2918),
    [anon_sym_operator] = ACTIONS(2918),
    [anon_sym_try] = ACTIONS(2918),
    [anon_sym_delete] = ACTIONS(2918),
    [anon_sym_throw] = ACTIONS(2918),
    [anon_sym_namespace] = ACTIONS(2918),
    [anon_sym_using] = ACTIONS(2918),
    [anon_sym_static_assert] = ACTIONS(2918),
    [anon_sym_concept] = ACTIONS(2918),
    [anon_sym_co_return] = ACTIONS(2918),
    [anon_sym_co_yield] = ACTIONS(2918),
    [anon_sym_R_DQUOTE] = ACTIONS(2920),
    [anon_sym_LR_DQUOTE] = ACTIONS(2920),
    [anon_sym_uR_DQUOTE] = ACTIONS(2920),
    [anon_sym_UR_DQUOTE] = ACTIONS(2920),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2920),
    [anon_sym_co_await] = ACTIONS(2918),
    [anon_sym_new] = ACTIONS(2918),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2918),
  },
  [570] = {
    [sym_identifier] = ACTIONS(2223),
    [aux_sym_preproc_include_token1] = ACTIONS(2223),
    [aux_sym_preproc_def_token1] = ACTIONS(2223),
    [aux_sym_preproc_if_token1] = ACTIONS(2223),
    [aux_sym_preproc_if_token2] = ACTIONS(2223),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2223),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2223),
    [sym_preproc_directive] = ACTIONS(2223),
    [anon_sym_LPAREN2] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2223),
    [anon_sym_PLUS] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(2221),
    [anon_sym_AMP_AMP] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym___extension__] = ACTIONS(2223),
    [anon_sym_typedef] = ACTIONS(2223),
    [anon_sym_extern] = ACTIONS(2223),
    [anon_sym___attribute__] = ACTIONS(2223),
    [anon_sym_COLON_COLON] = ACTIONS(2221),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym___declspec] = ACTIONS(2223),
    [anon_sym___based] = ACTIONS(2223),
    [anon_sym___cdecl] = ACTIONS(2223),
    [anon_sym___clrcall] = ACTIONS(2223),
    [anon_sym___stdcall] = ACTIONS(2223),
    [anon_sym___fastcall] = ACTIONS(2223),
    [anon_sym___thiscall] = ACTIONS(2223),
    [anon_sym___vectorcall] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_signed] = ACTIONS(2223),
    [anon_sym_unsigned] = ACTIONS(2223),
    [anon_sym_long] = ACTIONS(2223),
    [anon_sym_short] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(2223),
    [anon_sym_static] = ACTIONS(2223),
    [anon_sym_register] = ACTIONS(2223),
    [anon_sym_inline] = ACTIONS(2223),
    [anon_sym___inline] = ACTIONS(2223),
    [anon_sym___inline__] = ACTIONS(2223),
    [anon_sym___forceinline] = ACTIONS(2223),
    [anon_sym_thread_local] = ACTIONS(2223),
    [anon_sym___thread] = ACTIONS(2223),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_constexpr] = ACTIONS(2223),
    [anon_sym_volatile] = ACTIONS(2223),
    [anon_sym_restrict] = ACTIONS(2223),
    [anon_sym___restrict__] = ACTIONS(2223),
    [anon_sym__Atomic] = ACTIONS(2223),
    [anon_sym__Noreturn] = ACTIONS(2223),
    [anon_sym_noreturn] = ACTIONS(2223),
    [anon_sym_mutable] = ACTIONS(2223),
    [anon_sym_constinit] = ACTIONS(2223),
    [anon_sym_consteval] = ACTIONS(2223),
    [anon_sym_PROGMEM] = ACTIONS(2223),
    [aux_sym_primitive_type_token1] = ACTIONS(2223),
    [anon_sym_byte] = ACTIONS(2223),
    [anon_sym_word] = ACTIONS(2223),
    [anon_sym_enum] = ACTIONS(2223),
    [anon_sym_class] = ACTIONS(2223),
    [anon_sym_struct] = ACTIONS(2223),
    [anon_sym_union] = ACTIONS(2223),
    [anon_sym_if] = ACTIONS(2223),
    [anon_sym_else] = ACTIONS(2223),
    [anon_sym_switch] = ACTIONS(2223),
    [anon_sym_case] = ACTIONS(2223),
    [anon_sym_default] = ACTIONS(2223),
    [anon_sym_while] = ACTIONS(2223),
    [anon_sym_do] = ACTIONS(2223),
    [anon_sym_for] = ACTIONS(2223),
    [anon_sym_return] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2223),
    [anon_sym_continue] = ACTIONS(2223),
    [anon_sym_goto] = ACTIONS(2223),
    [anon_sym___try] = ACTIONS(2223),
    [anon_sym___leave] = ACTIONS(2223),
    [anon_sym_not] = ACTIONS(2223),
    [anon_sym_compl] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_sizeof] = ACTIONS(2223),
    [anon_sym___alignof__] = ACTIONS(2223),
    [anon_sym___alignof] = ACTIONS(2223),
    [anon_sym__alignof] = ACTIONS(2223),
    [anon_sym_alignof] = ACTIONS(2223),
    [anon_sym__Alignof] = ACTIONS(2223),
    [anon_sym_offsetof] = ACTIONS(2223),
    [anon_sym__Generic] = ACTIONS(2223),
    [anon_sym_asm] = ACTIONS(2223),
    [anon_sym___asm__] = ACTIONS(2223),
    [aux_sym_number_literal_token1] = ACTIONS(2221),
    [aux_sym_number_literal_token2] = ACTIONS(2223),
    [anon_sym_L_SQUOTE] = ACTIONS(2221),
    [anon_sym_u_SQUOTE] = ACTIONS(2221),
    [anon_sym_U_SQUOTE] = ACTIONS(2221),
    [anon_sym_u8_SQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_L_DQUOTE] = ACTIONS(2221),
    [anon_sym_u_DQUOTE] = ACTIONS(2221),
    [anon_sym_U_DQUOTE] = ACTIONS(2221),
    [anon_sym_u8_DQUOTE] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [sym_true] = ACTIONS(2223),
    [sym_false] = ACTIONS(2223),
    [anon_sym_NULL] = ACTIONS(2223),
    [anon_sym_nullptr] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2223),
    [anon_sym_decltype] = ACTIONS(2223),
    [anon_sym_virtual] = ACTIONS(2223),
    [anon_sym_alignas] = ACTIONS(2223),
    [anon_sym_explicit] = ACTIONS(2223),
    [anon_sym_typename] = ACTIONS(2223),
    [anon_sym_template] = ACTIONS(2223),
    [anon_sym_operator] = ACTIONS(2223),
    [anon_sym_try] = ACTIONS(2223),
    [anon_sym_delete] = ACTIONS(2223),
    [anon_sym_throw] = ACTIONS(2223),
    [anon_sym_namespace] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_static_assert] = ACTIONS(2223),
    [anon_sym_concept] = ACTIONS(2223),
    [anon_sym_co_return] = ACTIONS(2223),
    [anon_sym_co_yield] = ACTIONS(2223),
    [anon_sym_catch] = ACTIONS(2223),
    [anon_sym_R_DQUOTE] = ACTIONS(2221),
    [anon_sym_LR_DQUOTE] = ACTIONS(2221),
    [anon_sym_uR_DQUOTE] = ACTIONS(2221),
    [anon_sym_UR_DQUOTE] = ACTIONS(2221),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2221),
    [anon_sym_co_await] = ACTIONS(2223),
    [anon_sym_new] = ACTIONS(2223),
    [anon_sym_requires] = ACTIONS(2223),
    [sym_this] = ACTIONS(2223),
  },
  [571] = {
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_include_token1] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token2] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [aux_sym_preproc_else_token1] = ACTIONS(3513),
    [aux_sym_preproc_elif_token1] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_BANG] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3513),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym_SEMI] = ACTIONS(3515),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym___cdecl] = ACTIONS(3513),
    [anon_sym___clrcall] = ACTIONS(3513),
    [anon_sym___stdcall] = ACTIONS(3513),
    [anon_sym___fastcall] = ACTIONS(3513),
    [anon_sym___thiscall] = ACTIONS(3513),
    [anon_sym___vectorcall] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_PROGMEM] = ACTIONS(3513),
    [aux_sym_primitive_type_token1] = ACTIONS(3513),
    [anon_sym_byte] = ACTIONS(3513),
    [anon_sym_word] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [anon_sym_if] = ACTIONS(3513),
    [anon_sym_switch] = ACTIONS(3513),
    [anon_sym_case] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3513),
    [anon_sym_while] = ACTIONS(3513),
    [anon_sym_do] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3513),
    [anon_sym_return] = ACTIONS(3513),
    [anon_sym_break] = ACTIONS(3513),
    [anon_sym_continue] = ACTIONS(3513),
    [anon_sym_goto] = ACTIONS(3513),
    [anon_sym___try] = ACTIONS(3513),
    [anon_sym___leave] = ACTIONS(3513),
    [anon_sym_not] = ACTIONS(3513),
    [anon_sym_compl] = ACTIONS(3513),
    [anon_sym_DASH_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_PLUS] = ACTIONS(3515),
    [anon_sym_sizeof] = ACTIONS(3513),
    [anon_sym___alignof__] = ACTIONS(3513),
    [anon_sym___alignof] = ACTIONS(3513),
    [anon_sym__alignof] = ACTIONS(3513),
    [anon_sym_alignof] = ACTIONS(3513),
    [anon_sym__Alignof] = ACTIONS(3513),
    [anon_sym_offsetof] = ACTIONS(3513),
    [anon_sym__Generic] = ACTIONS(3513),
    [anon_sym_asm] = ACTIONS(3513),
    [anon_sym___asm__] = ACTIONS(3513),
    [aux_sym_number_literal_token1] = ACTIONS(3515),
    [aux_sym_number_literal_token2] = ACTIONS(3513),
    [anon_sym_L_SQUOTE] = ACTIONS(3515),
    [anon_sym_u_SQUOTE] = ACTIONS(3515),
    [anon_sym_U_SQUOTE] = ACTIONS(3515),
    [anon_sym_u8_SQUOTE] = ACTIONS(3515),
    [anon_sym_SQUOTE] = ACTIONS(3515),
    [anon_sym_L_DQUOTE] = ACTIONS(3515),
    [anon_sym_u_DQUOTE] = ACTIONS(3515),
    [anon_sym_U_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [sym_true] = ACTIONS(3513),
    [sym_false] = ACTIONS(3513),
    [anon_sym_NULL] = ACTIONS(3513),
    [anon_sym_nullptr] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [anon_sym_virtual] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3513),
    [anon_sym_delete] = ACTIONS(3513),
    [anon_sym_throw] = ACTIONS(3513),
    [anon_sym_namespace] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
    [anon_sym_concept] = ACTIONS(3513),
    [anon_sym_co_return] = ACTIONS(3513),
    [anon_sym_co_yield] = ACTIONS(3513),
    [anon_sym_R_DQUOTE] = ACTIONS(3515),
    [anon_sym_LR_DQUOTE] = ACTIONS(3515),
    [anon_sym_uR_DQUOTE] = ACTIONS(3515),
    [anon_sym_UR_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3515),
    [anon_sym_co_await] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3513),
    [anon_sym_requires] = ACTIONS(3513),
    [sym_this] = ACTIONS(3513),
  },
  [572] = {
    [sym_identifier] = ACTIONS(3182),
    [aux_sym_preproc_include_token1] = ACTIONS(3182),
    [aux_sym_preproc_def_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token2] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [aux_sym_preproc_else_token1] = ACTIONS(3182),
    [aux_sym_preproc_elif_token1] = ACTIONS(3182),
    [sym_preproc_directive] = ACTIONS(3182),
    [anon_sym_LPAREN2] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym___extension__] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3182),
    [anon_sym_extern] = ACTIONS(3182),
    [anon_sym___attribute__] = ACTIONS(3182),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3184),
    [anon_sym___declspec] = ACTIONS(3182),
    [anon_sym___based] = ACTIONS(3182),
    [anon_sym___cdecl] = ACTIONS(3182),
    [anon_sym___clrcall] = ACTIONS(3182),
    [anon_sym___stdcall] = ACTIONS(3182),
    [anon_sym___fastcall] = ACTIONS(3182),
    [anon_sym___thiscall] = ACTIONS(3182),
    [anon_sym___vectorcall] = ACTIONS(3182),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_signed] = ACTIONS(3182),
    [anon_sym_unsigned] = ACTIONS(3182),
    [anon_sym_long] = ACTIONS(3182),
    [anon_sym_short] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_register] = ACTIONS(3182),
    [anon_sym_inline] = ACTIONS(3182),
    [anon_sym___inline] = ACTIONS(3182),
    [anon_sym___inline__] = ACTIONS(3182),
    [anon_sym___forceinline] = ACTIONS(3182),
    [anon_sym_thread_local] = ACTIONS(3182),
    [anon_sym___thread] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_constexpr] = ACTIONS(3182),
    [anon_sym_volatile] = ACTIONS(3182),
    [anon_sym_restrict] = ACTIONS(3182),
    [anon_sym___restrict__] = ACTIONS(3182),
    [anon_sym__Atomic] = ACTIONS(3182),
    [anon_sym__Noreturn] = ACTIONS(3182),
    [anon_sym_noreturn] = ACTIONS(3182),
    [anon_sym_mutable] = ACTIONS(3182),
    [anon_sym_constinit] = ACTIONS(3182),
    [anon_sym_consteval] = ACTIONS(3182),
    [anon_sym_PROGMEM] = ACTIONS(3182),
    [aux_sym_primitive_type_token1] = ACTIONS(3182),
    [anon_sym_byte] = ACTIONS(3182),
    [anon_sym_word] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_struct] = ACTIONS(3182),
    [anon_sym_union] = ACTIONS(3182),
    [anon_sym_if] = ACTIONS(3182),
    [anon_sym_switch] = ACTIONS(3182),
    [anon_sym_case] = ACTIONS(3182),
    [anon_sym_default] = ACTIONS(3182),
    [anon_sym_while] = ACTIONS(3182),
    [anon_sym_do] = ACTIONS(3182),
    [anon_sym_for] = ACTIONS(3182),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_break] = ACTIONS(3182),
    [anon_sym_continue] = ACTIONS(3182),
    [anon_sym_goto] = ACTIONS(3182),
    [anon_sym___try] = ACTIONS(3182),
    [anon_sym___leave] = ACTIONS(3182),
    [anon_sym_not] = ACTIONS(3182),
    [anon_sym_compl] = ACTIONS(3182),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_sizeof] = ACTIONS(3182),
    [anon_sym___alignof__] = ACTIONS(3182),
    [anon_sym___alignof] = ACTIONS(3182),
    [anon_sym__alignof] = ACTIONS(3182),
    [anon_sym_alignof] = ACTIONS(3182),
    [anon_sym__Alignof] = ACTIONS(3182),
    [anon_sym_offsetof] = ACTIONS(3182),
    [anon_sym__Generic] = ACTIONS(3182),
    [anon_sym_asm] = ACTIONS(3182),
    [anon_sym___asm__] = ACTIONS(3182),
    [aux_sym_number_literal_token1] = ACTIONS(3184),
    [aux_sym_number_literal_token2] = ACTIONS(3182),
    [anon_sym_L_SQUOTE] = ACTIONS(3184),
    [anon_sym_u_SQUOTE] = ACTIONS(3184),
    [anon_sym_U_SQUOTE] = ACTIONS(3184),
    [anon_sym_u8_SQUOTE] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3184),
    [anon_sym_L_DQUOTE] = ACTIONS(3184),
    [anon_sym_u_DQUOTE] = ACTIONS(3184),
    [anon_sym_U_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8_DQUOTE] = ACTIONS(3184),
    [anon_sym_DQUOTE] = ACTIONS(3184),
    [sym_true] = ACTIONS(3182),
    [sym_false] = ACTIONS(3182),
    [anon_sym_NULL] = ACTIONS(3182),
    [anon_sym_nullptr] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3182),
    [anon_sym_decltype] = ACTIONS(3182),
    [anon_sym_virtual] = ACTIONS(3182),
    [anon_sym_alignas] = ACTIONS(3182),
    [anon_sym_explicit] = ACTIONS(3182),
    [anon_sym_typename] = ACTIONS(3182),
    [anon_sym_template] = ACTIONS(3182),
    [anon_sym_operator] = ACTIONS(3182),
    [anon_sym_try] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3182),
    [anon_sym_throw] = ACTIONS(3182),
    [anon_sym_namespace] = ACTIONS(3182),
    [anon_sym_using] = ACTIONS(3182),
    [anon_sym_static_assert] = ACTIONS(3182),
    [anon_sym_concept] = ACTIONS(3182),
    [anon_sym_co_return] = ACTIONS(3182),
    [anon_sym_co_yield] = ACTIONS(3182),
    [anon_sym_R_DQUOTE] = ACTIONS(3184),
    [anon_sym_LR_DQUOTE] = ACTIONS(3184),
    [anon_sym_uR_DQUOTE] = ACTIONS(3184),
    [anon_sym_UR_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3184),
    [anon_sym_co_await] = ACTIONS(3182),
    [anon_sym_new] = ACTIONS(3182),
    [anon_sym_requires] = ACTIONS(3182),
    [sym_this] = ACTIONS(3182),
  },
  [573] = {
    [sym_identifier] = ACTIONS(3353),
    [aux_sym_preproc_include_token1] = ACTIONS(3353),
    [aux_sym_preproc_def_token1] = ACTIONS(3353),
    [aux_sym_preproc_if_token1] = ACTIONS(3353),
    [aux_sym_preproc_if_token2] = ACTIONS(3353),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3353),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3353),
    [aux_sym_preproc_else_token1] = ACTIONS(3353),
    [aux_sym_preproc_elif_token1] = ACTIONS(3353),
    [sym_preproc_directive] = ACTIONS(3353),
    [anon_sym_LPAREN2] = ACTIONS(3355),
    [anon_sym_BANG] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_AMP_AMP] = ACTIONS(3355),
    [anon_sym_AMP] = ACTIONS(3353),
    [anon_sym_SEMI] = ACTIONS(3355),
    [anon_sym___extension__] = ACTIONS(3353),
    [anon_sym_typedef] = ACTIONS(3353),
    [anon_sym_extern] = ACTIONS(3353),
    [anon_sym___attribute__] = ACTIONS(3353),
    [anon_sym_COLON_COLON] = ACTIONS(3355),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3355),
    [anon_sym___declspec] = ACTIONS(3353),
    [anon_sym___based] = ACTIONS(3353),
    [anon_sym___cdecl] = ACTIONS(3353),
    [anon_sym___clrcall] = ACTIONS(3353),
    [anon_sym___stdcall] = ACTIONS(3353),
    [anon_sym___fastcall] = ACTIONS(3353),
    [anon_sym___thiscall] = ACTIONS(3353),
    [anon_sym___vectorcall] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_signed] = ACTIONS(3353),
    [anon_sym_unsigned] = ACTIONS(3353),
    [anon_sym_long] = ACTIONS(3353),
    [anon_sym_short] = ACTIONS(3353),
    [anon_sym_LBRACK] = ACTIONS(3353),
    [anon_sym_static] = ACTIONS(3353),
    [anon_sym_register] = ACTIONS(3353),
    [anon_sym_inline] = ACTIONS(3353),
    [anon_sym___inline] = ACTIONS(3353),
    [anon_sym___inline__] = ACTIONS(3353),
    [anon_sym___forceinline] = ACTIONS(3353),
    [anon_sym_thread_local] = ACTIONS(3353),
    [anon_sym___thread] = ACTIONS(3353),
    [anon_sym_const] = ACTIONS(3353),
    [anon_sym_constexpr] = ACTIONS(3353),
    [anon_sym_volatile] = ACTIONS(3353),
    [anon_sym_restrict] = ACTIONS(3353),
    [anon_sym___restrict__] = ACTIONS(3353),
    [anon_sym__Atomic] = ACTIONS(3353),
    [anon_sym__Noreturn] = ACTIONS(3353),
    [anon_sym_noreturn] = ACTIONS(3353),
    [anon_sym_mutable] = ACTIONS(3353),
    [anon_sym_constinit] = ACTIONS(3353),
    [anon_sym_consteval] = ACTIONS(3353),
    [anon_sym_PROGMEM] = ACTIONS(3353),
    [aux_sym_primitive_type_token1] = ACTIONS(3353),
    [anon_sym_byte] = ACTIONS(3353),
    [anon_sym_word] = ACTIONS(3353),
    [anon_sym_enum] = ACTIONS(3353),
    [anon_sym_class] = ACTIONS(3353),
    [anon_sym_struct] = ACTIONS(3353),
    [anon_sym_union] = ACTIONS(3353),
    [anon_sym_if] = ACTIONS(3353),
    [anon_sym_switch] = ACTIONS(3353),
    [anon_sym_case] = ACTIONS(3353),
    [anon_sym_default] = ACTIONS(3353),
    [anon_sym_while] = ACTIONS(3353),
    [anon_sym_do] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3353),
    [anon_sym_return] = ACTIONS(3353),
    [anon_sym_break] = ACTIONS(3353),
    [anon_sym_continue] = ACTIONS(3353),
    [anon_sym_goto] = ACTIONS(3353),
    [anon_sym___try] = ACTIONS(3353),
    [anon_sym___leave] = ACTIONS(3353),
    [anon_sym_not] = ACTIONS(3353),
    [anon_sym_compl] = ACTIONS(3353),
    [anon_sym_DASH_DASH] = ACTIONS(3355),
    [anon_sym_PLUS_PLUS] = ACTIONS(3355),
    [anon_sym_sizeof] = ACTIONS(3353),
    [anon_sym___alignof__] = ACTIONS(3353),
    [anon_sym___alignof] = ACTIONS(3353),
    [anon_sym__alignof] = ACTIONS(3353),
    [anon_sym_alignof] = ACTIONS(3353),
    [anon_sym__Alignof] = ACTIONS(3353),
    [anon_sym_offsetof] = ACTIONS(3353),
    [anon_sym__Generic] = ACTIONS(3353),
    [anon_sym_asm] = ACTIONS(3353),
    [anon_sym___asm__] = ACTIONS(3353),
    [aux_sym_number_literal_token1] = ACTIONS(3355),
    [aux_sym_number_literal_token2] = ACTIONS(3353),
    [anon_sym_L_SQUOTE] = ACTIONS(3355),
    [anon_sym_u_SQUOTE] = ACTIONS(3355),
    [anon_sym_U_SQUOTE] = ACTIONS(3355),
    [anon_sym_u8_SQUOTE] = ACTIONS(3355),
    [anon_sym_SQUOTE] = ACTIONS(3355),
    [anon_sym_L_DQUOTE] = ACTIONS(3355),
    [anon_sym_u_DQUOTE] = ACTIONS(3355),
    [anon_sym_U_DQUOTE] = ACTIONS(3355),
    [anon_sym_u8_DQUOTE] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [sym_true] = ACTIONS(3353),
    [sym_false] = ACTIONS(3353),
    [anon_sym_NULL] = ACTIONS(3353),
    [anon_sym_nullptr] = ACTIONS(3353),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3353),
    [anon_sym_decltype] = ACTIONS(3353),
    [anon_sym_virtual] = ACTIONS(3353),
    [anon_sym_alignas] = ACTIONS(3353),
    [anon_sym_explicit] = ACTIONS(3353),
    [anon_sym_typename] = ACTIONS(3353),
    [anon_sym_template] = ACTIONS(3353),
    [anon_sym_operator] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3353),
    [anon_sym_delete] = ACTIONS(3353),
    [anon_sym_throw] = ACTIONS(3353),
    [anon_sym_namespace] = ACTIONS(3353),
    [anon_sym_using] = ACTIONS(3353),
    [anon_sym_static_assert] = ACTIONS(3353),
    [anon_sym_concept] = ACTIONS(3353),
    [anon_sym_co_return] = ACTIONS(3353),
    [anon_sym_co_yield] = ACTIONS(3353),
    [anon_sym_R_DQUOTE] = ACTIONS(3355),
    [anon_sym_LR_DQUOTE] = ACTIONS(3355),
    [anon_sym_uR_DQUOTE] = ACTIONS(3355),
    [anon_sym_UR_DQUOTE] = ACTIONS(3355),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3355),
    [anon_sym_co_await] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3353),
    [anon_sym_requires] = ACTIONS(3353),
    [sym_this] = ACTIONS(3353),
  },
  [574] = {
    [sym_identifier] = ACTIONS(3250),
    [aux_sym_preproc_include_token1] = ACTIONS(3250),
    [aux_sym_preproc_def_token1] = ACTIONS(3250),
    [aux_sym_preproc_if_token1] = ACTIONS(3250),
    [aux_sym_preproc_if_token2] = ACTIONS(3250),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3250),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3250),
    [aux_sym_preproc_else_token1] = ACTIONS(3250),
    [aux_sym_preproc_elif_token1] = ACTIONS(3250),
    [sym_preproc_directive] = ACTIONS(3250),
    [anon_sym_LPAREN2] = ACTIONS(3252),
    [anon_sym_BANG] = ACTIONS(3252),
    [anon_sym_TILDE] = ACTIONS(3252),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_STAR] = ACTIONS(3252),
    [anon_sym_AMP_AMP] = ACTIONS(3252),
    [anon_sym_AMP] = ACTIONS(3250),
    [anon_sym_SEMI] = ACTIONS(3252),
    [anon_sym___extension__] = ACTIONS(3250),
    [anon_sym_typedef] = ACTIONS(3250),
    [anon_sym_extern] = ACTIONS(3250),
    [anon_sym___attribute__] = ACTIONS(3250),
    [anon_sym_COLON_COLON] = ACTIONS(3252),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3252),
    [anon_sym___declspec] = ACTIONS(3250),
    [anon_sym___based] = ACTIONS(3250),
    [anon_sym___cdecl] = ACTIONS(3250),
    [anon_sym___clrcall] = ACTIONS(3250),
    [anon_sym___stdcall] = ACTIONS(3250),
    [anon_sym___fastcall] = ACTIONS(3250),
    [anon_sym___thiscall] = ACTIONS(3250),
    [anon_sym___vectorcall] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3252),
    [anon_sym_signed] = ACTIONS(3250),
    [anon_sym_unsigned] = ACTIONS(3250),
    [anon_sym_long] = ACTIONS(3250),
    [anon_sym_short] = ACTIONS(3250),
    [anon_sym_LBRACK] = ACTIONS(3250),
    [anon_sym_static] = ACTIONS(3250),
    [anon_sym_register] = ACTIONS(3250),
    [anon_sym_inline] = ACTIONS(3250),
    [anon_sym___inline] = ACTIONS(3250),
    [anon_sym___inline__] = ACTIONS(3250),
    [anon_sym___forceinline] = ACTIONS(3250),
    [anon_sym_thread_local] = ACTIONS(3250),
    [anon_sym___thread] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(3250),
    [anon_sym_constexpr] = ACTIONS(3250),
    [anon_sym_volatile] = ACTIONS(3250),
    [anon_sym_restrict] = ACTIONS(3250),
    [anon_sym___restrict__] = ACTIONS(3250),
    [anon_sym__Atomic] = ACTIONS(3250),
    [anon_sym__Noreturn] = ACTIONS(3250),
    [anon_sym_noreturn] = ACTIONS(3250),
    [anon_sym_mutable] = ACTIONS(3250),
    [anon_sym_constinit] = ACTIONS(3250),
    [anon_sym_consteval] = ACTIONS(3250),
    [anon_sym_PROGMEM] = ACTIONS(3250),
    [aux_sym_primitive_type_token1] = ACTIONS(3250),
    [anon_sym_byte] = ACTIONS(3250),
    [anon_sym_word] = ACTIONS(3250),
    [anon_sym_enum] = ACTIONS(3250),
    [anon_sym_class] = ACTIONS(3250),
    [anon_sym_struct] = ACTIONS(3250),
    [anon_sym_union] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_switch] = ACTIONS(3250),
    [anon_sym_case] = ACTIONS(3250),
    [anon_sym_default] = ACTIONS(3250),
    [anon_sym_while] = ACTIONS(3250),
    [anon_sym_do] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_goto] = ACTIONS(3250),
    [anon_sym___try] = ACTIONS(3250),
    [anon_sym___leave] = ACTIONS(3250),
    [anon_sym_not] = ACTIONS(3250),
    [anon_sym_compl] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3252),
    [anon_sym_PLUS_PLUS] = ACTIONS(3252),
    [anon_sym_sizeof] = ACTIONS(3250),
    [anon_sym___alignof__] = ACTIONS(3250),
    [anon_sym___alignof] = ACTIONS(3250),
    [anon_sym__alignof] = ACTIONS(3250),
    [anon_sym_alignof] = ACTIONS(3250),
    [anon_sym__Alignof] = ACTIONS(3250),
    [anon_sym_offsetof] = ACTIONS(3250),
    [anon_sym__Generic] = ACTIONS(3250),
    [anon_sym_asm] = ACTIONS(3250),
    [anon_sym___asm__] = ACTIONS(3250),
    [aux_sym_number_literal_token1] = ACTIONS(3252),
    [aux_sym_number_literal_token2] = ACTIONS(3250),
    [anon_sym_L_SQUOTE] = ACTIONS(3252),
    [anon_sym_u_SQUOTE] = ACTIONS(3252),
    [anon_sym_U_SQUOTE] = ACTIONS(3252),
    [anon_sym_u8_SQUOTE] = ACTIONS(3252),
    [anon_sym_SQUOTE] = ACTIONS(3252),
    [anon_sym_L_DQUOTE] = ACTIONS(3252),
    [anon_sym_u_DQUOTE] = ACTIONS(3252),
    [anon_sym_U_DQUOTE] = ACTIONS(3252),
    [anon_sym_u8_DQUOTE] = ACTIONS(3252),
    [anon_sym_DQUOTE] = ACTIONS(3252),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [anon_sym_NULL] = ACTIONS(3250),
    [anon_sym_nullptr] = ACTIONS(3250),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3250),
    [anon_sym_decltype] = ACTIONS(3250),
    [anon_sym_virtual] = ACTIONS(3250),
    [anon_sym_alignas] = ACTIONS(3250),
    [anon_sym_explicit] = ACTIONS(3250),
    [anon_sym_typename] = ACTIONS(3250),
    [anon_sym_template] = ACTIONS(3250),
    [anon_sym_operator] = ACTIONS(3250),
    [anon_sym_try] = ACTIONS(3250),
    [anon_sym_delete] = ACTIONS(3250),
    [anon_sym_throw] = ACTIONS(3250),
    [anon_sym_namespace] = ACTIONS(3250),
    [anon_sym_using] = ACTIONS(3250),
    [anon_sym_static_assert] = ACTIONS(3250),
    [anon_sym_concept] = ACTIONS(3250),
    [anon_sym_co_return] = ACTIONS(3250),
    [anon_sym_co_yield] = ACTIONS(3250),
    [anon_sym_R_DQUOTE] = ACTIONS(3252),
    [anon_sym_LR_DQUOTE] = ACTIONS(3252),
    [anon_sym_uR_DQUOTE] = ACTIONS(3252),
    [anon_sym_UR_DQUOTE] = ACTIONS(3252),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3252),
    [anon_sym_co_await] = ACTIONS(3250),
    [anon_sym_new] = ACTIONS(3250),
    [anon_sym_requires] = ACTIONS(3250),
    [sym_this] = ACTIONS(3250),
  },
  [575] = {
    [sym_identifier] = ACTIONS(3328),
    [aux_sym_preproc_include_token1] = ACTIONS(3328),
    [aux_sym_preproc_def_token1] = ACTIONS(3328),
    [aux_sym_preproc_if_token1] = ACTIONS(3328),
    [aux_sym_preproc_if_token2] = ACTIONS(3328),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3328),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3328),
    [aux_sym_preproc_else_token1] = ACTIONS(3328),
    [aux_sym_preproc_elif_token1] = ACTIONS(3328),
    [sym_preproc_directive] = ACTIONS(3328),
    [anon_sym_LPAREN2] = ACTIONS(3330),
    [anon_sym_BANG] = ACTIONS(3330),
    [anon_sym_TILDE] = ACTIONS(3330),
    [anon_sym_DASH] = ACTIONS(3328),
    [anon_sym_PLUS] = ACTIONS(3328),
    [anon_sym_STAR] = ACTIONS(3330),
    [anon_sym_AMP_AMP] = ACTIONS(3330),
    [anon_sym_AMP] = ACTIONS(3328),
    [anon_sym_SEMI] = ACTIONS(3330),
    [anon_sym___extension__] = ACTIONS(3328),
    [anon_sym_typedef] = ACTIONS(3328),
    [anon_sym_extern] = ACTIONS(3328),
    [anon_sym___attribute__] = ACTIONS(3328),
    [anon_sym_COLON_COLON] = ACTIONS(3330),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3330),
    [anon_sym___declspec] = ACTIONS(3328),
    [anon_sym___based] = ACTIONS(3328),
    [anon_sym___cdecl] = ACTIONS(3328),
    [anon_sym___clrcall] = ACTIONS(3328),
    [anon_sym___stdcall] = ACTIONS(3328),
    [anon_sym___fastcall] = ACTIONS(3328),
    [anon_sym___thiscall] = ACTIONS(3328),
    [anon_sym___vectorcall] = ACTIONS(3328),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_signed] = ACTIONS(3328),
    [anon_sym_unsigned] = ACTIONS(3328),
    [anon_sym_long] = ACTIONS(3328),
    [anon_sym_short] = ACTIONS(3328),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_static] = ACTIONS(3328),
    [anon_sym_register] = ACTIONS(3328),
    [anon_sym_inline] = ACTIONS(3328),
    [anon_sym___inline] = ACTIONS(3328),
    [anon_sym___inline__] = ACTIONS(3328),
    [anon_sym___forceinline] = ACTIONS(3328),
    [anon_sym_thread_local] = ACTIONS(3328),
    [anon_sym___thread] = ACTIONS(3328),
    [anon_sym_const] = ACTIONS(3328),
    [anon_sym_constexpr] = ACTIONS(3328),
    [anon_sym_volatile] = ACTIONS(3328),
    [anon_sym_restrict] = ACTIONS(3328),
    [anon_sym___restrict__] = ACTIONS(3328),
    [anon_sym__Atomic] = ACTIONS(3328),
    [anon_sym__Noreturn] = ACTIONS(3328),
    [anon_sym_noreturn] = ACTIONS(3328),
    [anon_sym_mutable] = ACTIONS(3328),
    [anon_sym_constinit] = ACTIONS(3328),
    [anon_sym_consteval] = ACTIONS(3328),
    [anon_sym_PROGMEM] = ACTIONS(3328),
    [aux_sym_primitive_type_token1] = ACTIONS(3328),
    [anon_sym_byte] = ACTIONS(3328),
    [anon_sym_word] = ACTIONS(3328),
    [anon_sym_enum] = ACTIONS(3328),
    [anon_sym_class] = ACTIONS(3328),
    [anon_sym_struct] = ACTIONS(3328),
    [anon_sym_union] = ACTIONS(3328),
    [anon_sym_if] = ACTIONS(3328),
    [anon_sym_switch] = ACTIONS(3328),
    [anon_sym_case] = ACTIONS(3328),
    [anon_sym_default] = ACTIONS(3328),
    [anon_sym_while] = ACTIONS(3328),
    [anon_sym_do] = ACTIONS(3328),
    [anon_sym_for] = ACTIONS(3328),
    [anon_sym_return] = ACTIONS(3328),
    [anon_sym_break] = ACTIONS(3328),
    [anon_sym_continue] = ACTIONS(3328),
    [anon_sym_goto] = ACTIONS(3328),
    [anon_sym___try] = ACTIONS(3328),
    [anon_sym___leave] = ACTIONS(3328),
    [anon_sym_not] = ACTIONS(3328),
    [anon_sym_compl] = ACTIONS(3328),
    [anon_sym_DASH_DASH] = ACTIONS(3330),
    [anon_sym_PLUS_PLUS] = ACTIONS(3330),
    [anon_sym_sizeof] = ACTIONS(3328),
    [anon_sym___alignof__] = ACTIONS(3328),
    [anon_sym___alignof] = ACTIONS(3328),
    [anon_sym__alignof] = ACTIONS(3328),
    [anon_sym_alignof] = ACTIONS(3328),
    [anon_sym__Alignof] = ACTIONS(3328),
    [anon_sym_offsetof] = ACTIONS(3328),
    [anon_sym__Generic] = ACTIONS(3328),
    [anon_sym_asm] = ACTIONS(3328),
    [anon_sym___asm__] = ACTIONS(3328),
    [aux_sym_number_literal_token1] = ACTIONS(3330),
    [aux_sym_number_literal_token2] = ACTIONS(3328),
    [anon_sym_L_SQUOTE] = ACTIONS(3330),
    [anon_sym_u_SQUOTE] = ACTIONS(3330),
    [anon_sym_U_SQUOTE] = ACTIONS(3330),
    [anon_sym_u8_SQUOTE] = ACTIONS(3330),
    [anon_sym_SQUOTE] = ACTIONS(3330),
    [anon_sym_L_DQUOTE] = ACTIONS(3330),
    [anon_sym_u_DQUOTE] = ACTIONS(3330),
    [anon_sym_U_DQUOTE] = ACTIONS(3330),
    [anon_sym_u8_DQUOTE] = ACTIONS(3330),
    [anon_sym_DQUOTE] = ACTIONS(3330),
    [sym_true] = ACTIONS(3328),
    [sym_false] = ACTIONS(3328),
    [anon_sym_NULL] = ACTIONS(3328),
    [anon_sym_nullptr] = ACTIONS(3328),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3328),
    [anon_sym_decltype] = ACTIONS(3328),
    [anon_sym_virtual] = ACTIONS(3328),
    [anon_sym_alignas] = ACTIONS(3328),
    [anon_sym_explicit] = ACTIONS(3328),
    [anon_sym_typename] = ACTIONS(3328),
    [anon_sym_template] = ACTIONS(3328),
    [anon_sym_operator] = ACTIONS(3328),
    [anon_sym_try] = ACTIONS(3328),
    [anon_sym_delete] = ACTIONS(3328),
    [anon_sym_throw] = ACTIONS(3328),
    [anon_sym_namespace] = ACTIONS(3328),
    [anon_sym_using] = ACTIONS(3328),
    [anon_sym_static_assert] = ACTIONS(3328),
    [anon_sym_concept] = ACTIONS(3328),
    [anon_sym_co_return] = ACTIONS(3328),
    [anon_sym_co_yield] = ACTIONS(3328),
    [anon_sym_R_DQUOTE] = ACTIONS(3330),
    [anon_sym_LR_DQUOTE] = ACTIONS(3330),
    [anon_sym_uR_DQUOTE] = ACTIONS(3330),
    [anon_sym_UR_DQUOTE] = ACTIONS(3330),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3330),
    [anon_sym_co_await] = ACTIONS(3328),
    [anon_sym_new] = ACTIONS(3328),
    [anon_sym_requires] = ACTIONS(3328),
    [sym_this] = ACTIONS(3328),
  },
  [576] = {
    [sym_identifier] = ACTIONS(3324),
    [aux_sym_preproc_include_token1] = ACTIONS(3324),
    [aux_sym_preproc_def_token1] = ACTIONS(3324),
    [aux_sym_preproc_if_token1] = ACTIONS(3324),
    [aux_sym_preproc_if_token2] = ACTIONS(3324),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3324),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3324),
    [aux_sym_preproc_else_token1] = ACTIONS(3324),
    [aux_sym_preproc_elif_token1] = ACTIONS(3324),
    [sym_preproc_directive] = ACTIONS(3324),
    [anon_sym_LPAREN2] = ACTIONS(3326),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_DASH] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3326),
    [anon_sym_AMP_AMP] = ACTIONS(3326),
    [anon_sym_AMP] = ACTIONS(3324),
    [anon_sym_SEMI] = ACTIONS(3326),
    [anon_sym___extension__] = ACTIONS(3324),
    [anon_sym_typedef] = ACTIONS(3324),
    [anon_sym_extern] = ACTIONS(3324),
    [anon_sym___attribute__] = ACTIONS(3324),
    [anon_sym_COLON_COLON] = ACTIONS(3326),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3326),
    [anon_sym___declspec] = ACTIONS(3324),
    [anon_sym___based] = ACTIONS(3324),
    [anon_sym___cdecl] = ACTIONS(3324),
    [anon_sym___clrcall] = ACTIONS(3324),
    [anon_sym___stdcall] = ACTIONS(3324),
    [anon_sym___fastcall] = ACTIONS(3324),
    [anon_sym___thiscall] = ACTIONS(3324),
    [anon_sym___vectorcall] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3326),
    [anon_sym_signed] = ACTIONS(3324),
    [anon_sym_unsigned] = ACTIONS(3324),
    [anon_sym_long] = ACTIONS(3324),
    [anon_sym_short] = ACTIONS(3324),
    [anon_sym_LBRACK] = ACTIONS(3324),
    [anon_sym_static] = ACTIONS(3324),
    [anon_sym_register] = ACTIONS(3324),
    [anon_sym_inline] = ACTIONS(3324),
    [anon_sym___inline] = ACTIONS(3324),
    [anon_sym___inline__] = ACTIONS(3324),
    [anon_sym___forceinline] = ACTIONS(3324),
    [anon_sym_thread_local] = ACTIONS(3324),
    [anon_sym___thread] = ACTIONS(3324),
    [anon_sym_const] = ACTIONS(3324),
    [anon_sym_constexpr] = ACTIONS(3324),
    [anon_sym_volatile] = ACTIONS(3324),
    [anon_sym_restrict] = ACTIONS(3324),
    [anon_sym___restrict__] = ACTIONS(3324),
    [anon_sym__Atomic] = ACTIONS(3324),
    [anon_sym__Noreturn] = ACTIONS(3324),
    [anon_sym_noreturn] = ACTIONS(3324),
    [anon_sym_mutable] = ACTIONS(3324),
    [anon_sym_constinit] = ACTIONS(3324),
    [anon_sym_consteval] = ACTIONS(3324),
    [anon_sym_PROGMEM] = ACTIONS(3324),
    [aux_sym_primitive_type_token1] = ACTIONS(3324),
    [anon_sym_byte] = ACTIONS(3324),
    [anon_sym_word] = ACTIONS(3324),
    [anon_sym_enum] = ACTIONS(3324),
    [anon_sym_class] = ACTIONS(3324),
    [anon_sym_struct] = ACTIONS(3324),
    [anon_sym_union] = ACTIONS(3324),
    [anon_sym_if] = ACTIONS(3324),
    [anon_sym_switch] = ACTIONS(3324),
    [anon_sym_case] = ACTIONS(3324),
    [anon_sym_default] = ACTIONS(3324),
    [anon_sym_while] = ACTIONS(3324),
    [anon_sym_do] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3324),
    [anon_sym_return] = ACTIONS(3324),
    [anon_sym_break] = ACTIONS(3324),
    [anon_sym_continue] = ACTIONS(3324),
    [anon_sym_goto] = ACTIONS(3324),
    [anon_sym___try] = ACTIONS(3324),
    [anon_sym___leave] = ACTIONS(3324),
    [anon_sym_not] = ACTIONS(3324),
    [anon_sym_compl] = ACTIONS(3324),
    [anon_sym_DASH_DASH] = ACTIONS(3326),
    [anon_sym_PLUS_PLUS] = ACTIONS(3326),
    [anon_sym_sizeof] = ACTIONS(3324),
    [anon_sym___alignof__] = ACTIONS(3324),
    [anon_sym___alignof] = ACTIONS(3324),
    [anon_sym__alignof] = ACTIONS(3324),
    [anon_sym_alignof] = ACTIONS(3324),
    [anon_sym__Alignof] = ACTIONS(3324),
    [anon_sym_offsetof] = ACTIONS(3324),
    [anon_sym__Generic] = ACTIONS(3324),
    [anon_sym_asm] = ACTIONS(3324),
    [anon_sym___asm__] = ACTIONS(3324),
    [aux_sym_number_literal_token1] = ACTIONS(3326),
    [aux_sym_number_literal_token2] = ACTIONS(3324),
    [anon_sym_L_SQUOTE] = ACTIONS(3326),
    [anon_sym_u_SQUOTE] = ACTIONS(3326),
    [anon_sym_U_SQUOTE] = ACTIONS(3326),
    [anon_sym_u8_SQUOTE] = ACTIONS(3326),
    [anon_sym_SQUOTE] = ACTIONS(3326),
    [anon_sym_L_DQUOTE] = ACTIONS(3326),
    [anon_sym_u_DQUOTE] = ACTIONS(3326),
    [anon_sym_U_DQUOTE] = ACTIONS(3326),
    [anon_sym_u8_DQUOTE] = ACTIONS(3326),
    [anon_sym_DQUOTE] = ACTIONS(3326),
    [sym_true] = ACTIONS(3324),
    [sym_false] = ACTIONS(3324),
    [anon_sym_NULL] = ACTIONS(3324),
    [anon_sym_nullptr] = ACTIONS(3324),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3324),
    [anon_sym_decltype] = ACTIONS(3324),
    [anon_sym_virtual] = ACTIONS(3324),
    [anon_sym_alignas] = ACTIONS(3324),
    [anon_sym_explicit] = ACTIONS(3324),
    [anon_sym_typename] = ACTIONS(3324),
    [anon_sym_template] = ACTIONS(3324),
    [anon_sym_operator] = ACTIONS(3324),
    [anon_sym_try] = ACTIONS(3324),
    [anon_sym_delete] = ACTIONS(3324),
    [anon_sym_throw] = ACTIONS(3324),
    [anon_sym_namespace] = ACTIONS(3324),
    [anon_sym_using] = ACTIONS(3324),
    [anon_sym_static_assert] = ACTIONS(3324),
    [anon_sym_concept] = ACTIONS(3324),
    [anon_sym_co_return] = ACTIONS(3324),
    [anon_sym_co_yield] = ACTIONS(3324),
    [anon_sym_R_DQUOTE] = ACTIONS(3326),
    [anon_sym_LR_DQUOTE] = ACTIONS(3326),
    [anon_sym_uR_DQUOTE] = ACTIONS(3326),
    [anon_sym_UR_DQUOTE] = ACTIONS(3326),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3326),
    [anon_sym_co_await] = ACTIONS(3324),
    [anon_sym_new] = ACTIONS(3324),
    [anon_sym_requires] = ACTIONS(3324),
    [sym_this] = ACTIONS(3324),
  },
  [577] = {
    [sym_identifier] = ACTIONS(3301),
    [aux_sym_preproc_include_token1] = ACTIONS(3301),
    [aux_sym_preproc_def_token1] = ACTIONS(3301),
    [aux_sym_preproc_if_token1] = ACTIONS(3301),
    [aux_sym_preproc_if_token2] = ACTIONS(3301),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3301),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3301),
    [aux_sym_preproc_else_token1] = ACTIONS(3301),
    [aux_sym_preproc_elif_token1] = ACTIONS(3301),
    [sym_preproc_directive] = ACTIONS(3301),
    [anon_sym_LPAREN2] = ACTIONS(3303),
    [anon_sym_BANG] = ACTIONS(3303),
    [anon_sym_TILDE] = ACTIONS(3303),
    [anon_sym_DASH] = ACTIONS(3301),
    [anon_sym_PLUS] = ACTIONS(3301),
    [anon_sym_STAR] = ACTIONS(3303),
    [anon_sym_AMP_AMP] = ACTIONS(3303),
    [anon_sym_AMP] = ACTIONS(3301),
    [anon_sym_SEMI] = ACTIONS(3303),
    [anon_sym___extension__] = ACTIONS(3301),
    [anon_sym_typedef] = ACTIONS(3301),
    [anon_sym_extern] = ACTIONS(3301),
    [anon_sym___attribute__] = ACTIONS(3301),
    [anon_sym_COLON_COLON] = ACTIONS(3303),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3303),
    [anon_sym___declspec] = ACTIONS(3301),
    [anon_sym___based] = ACTIONS(3301),
    [anon_sym___cdecl] = ACTIONS(3301),
    [anon_sym___clrcall] = ACTIONS(3301),
    [anon_sym___stdcall] = ACTIONS(3301),
    [anon_sym___fastcall] = ACTIONS(3301),
    [anon_sym___thiscall] = ACTIONS(3301),
    [anon_sym___vectorcall] = ACTIONS(3301),
    [anon_sym_LBRACE] = ACTIONS(3303),
    [anon_sym_signed] = ACTIONS(3301),
    [anon_sym_unsigned] = ACTIONS(3301),
    [anon_sym_long] = ACTIONS(3301),
    [anon_sym_short] = ACTIONS(3301),
    [anon_sym_LBRACK] = ACTIONS(3301),
    [anon_sym_static] = ACTIONS(3301),
    [anon_sym_register] = ACTIONS(3301),
    [anon_sym_inline] = ACTIONS(3301),
    [anon_sym___inline] = ACTIONS(3301),
    [anon_sym___inline__] = ACTIONS(3301),
    [anon_sym___forceinline] = ACTIONS(3301),
    [anon_sym_thread_local] = ACTIONS(3301),
    [anon_sym___thread] = ACTIONS(3301),
    [anon_sym_const] = ACTIONS(3301),
    [anon_sym_constexpr] = ACTIONS(3301),
    [anon_sym_volatile] = ACTIONS(3301),
    [anon_sym_restrict] = ACTIONS(3301),
    [anon_sym___restrict__] = ACTIONS(3301),
    [anon_sym__Atomic] = ACTIONS(3301),
    [anon_sym__Noreturn] = ACTIONS(3301),
    [anon_sym_noreturn] = ACTIONS(3301),
    [anon_sym_mutable] = ACTIONS(3301),
    [anon_sym_constinit] = ACTIONS(3301),
    [anon_sym_consteval] = ACTIONS(3301),
    [anon_sym_PROGMEM] = ACTIONS(3301),
    [aux_sym_primitive_type_token1] = ACTIONS(3301),
    [anon_sym_byte] = ACTIONS(3301),
    [anon_sym_word] = ACTIONS(3301),
    [anon_sym_enum] = ACTIONS(3301),
    [anon_sym_class] = ACTIONS(3301),
    [anon_sym_struct] = ACTIONS(3301),
    [anon_sym_union] = ACTIONS(3301),
    [anon_sym_if] = ACTIONS(3301),
    [anon_sym_switch] = ACTIONS(3301),
    [anon_sym_case] = ACTIONS(3301),
    [anon_sym_default] = ACTIONS(3301),
    [anon_sym_while] = ACTIONS(3301),
    [anon_sym_do] = ACTIONS(3301),
    [anon_sym_for] = ACTIONS(3301),
    [anon_sym_return] = ACTIONS(3301),
    [anon_sym_break] = ACTIONS(3301),
    [anon_sym_continue] = ACTIONS(3301),
    [anon_sym_goto] = ACTIONS(3301),
    [anon_sym___try] = ACTIONS(3301),
    [anon_sym___leave] = ACTIONS(3301),
    [anon_sym_not] = ACTIONS(3301),
    [anon_sym_compl] = ACTIONS(3301),
    [anon_sym_DASH_DASH] = ACTIONS(3303),
    [anon_sym_PLUS_PLUS] = ACTIONS(3303),
    [anon_sym_sizeof] = ACTIONS(3301),
    [anon_sym___alignof__] = ACTIONS(3301),
    [anon_sym___alignof] = ACTIONS(3301),
    [anon_sym__alignof] = ACTIONS(3301),
    [anon_sym_alignof] = ACTIONS(3301),
    [anon_sym__Alignof] = ACTIONS(3301),
    [anon_sym_offsetof] = ACTIONS(3301),
    [anon_sym__Generic] = ACTIONS(3301),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [aux_sym_number_literal_token1] = ACTIONS(3303),
    [aux_sym_number_literal_token2] = ACTIONS(3301),
    [anon_sym_L_SQUOTE] = ACTIONS(3303),
    [anon_sym_u_SQUOTE] = ACTIONS(3303),
    [anon_sym_U_SQUOTE] = ACTIONS(3303),
    [anon_sym_u8_SQUOTE] = ACTIONS(3303),
    [anon_sym_SQUOTE] = ACTIONS(3303),
    [anon_sym_L_DQUOTE] = ACTIONS(3303),
    [anon_sym_u_DQUOTE] = ACTIONS(3303),
    [anon_sym_U_DQUOTE] = ACTIONS(3303),
    [anon_sym_u8_DQUOTE] = ACTIONS(3303),
    [anon_sym_DQUOTE] = ACTIONS(3303),
    [sym_true] = ACTIONS(3301),
    [sym_false] = ACTIONS(3301),
    [anon_sym_NULL] = ACTIONS(3301),
    [anon_sym_nullptr] = ACTIONS(3301),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3301),
    [anon_sym_decltype] = ACTIONS(3301),
    [anon_sym_virtual] = ACTIONS(3301),
    [anon_sym_alignas] = ACTIONS(3301),
    [anon_sym_explicit] = ACTIONS(3301),
    [anon_sym_typename] = ACTIONS(3301),
    [anon_sym_template] = ACTIONS(3301),
    [anon_sym_operator] = ACTIONS(3301),
    [anon_sym_try] = ACTIONS(3301),
    [anon_sym_delete] = ACTIONS(3301),
    [anon_sym_throw] = ACTIONS(3301),
    [anon_sym_namespace] = ACTIONS(3301),
    [anon_sym_using] = ACTIONS(3301),
    [anon_sym_static_assert] = ACTIONS(3301),
    [anon_sym_concept] = ACTIONS(3301),
    [anon_sym_co_return] = ACTIONS(3301),
    [anon_sym_co_yield] = ACTIONS(3301),
    [anon_sym_R_DQUOTE] = ACTIONS(3303),
    [anon_sym_LR_DQUOTE] = ACTIONS(3303),
    [anon_sym_uR_DQUOTE] = ACTIONS(3303),
    [anon_sym_UR_DQUOTE] = ACTIONS(3303),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3303),
    [anon_sym_co_await] = ACTIONS(3301),
    [anon_sym_new] = ACTIONS(3301),
    [anon_sym_requires] = ACTIONS(3301),
    [sym_this] = ACTIONS(3301),
  },
  [578] = {
    [sym_identifier] = ACTIONS(3297),
    [aux_sym_preproc_include_token1] = ACTIONS(3297),
    [aux_sym_preproc_def_token1] = ACTIONS(3297),
    [aux_sym_preproc_if_token1] = ACTIONS(3297),
    [aux_sym_preproc_if_token2] = ACTIONS(3297),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3297),
    [aux_sym_preproc_else_token1] = ACTIONS(3297),
    [aux_sym_preproc_elif_token1] = ACTIONS(3297),
    [sym_preproc_directive] = ACTIONS(3297),
    [anon_sym_LPAREN2] = ACTIONS(3299),
    [anon_sym_BANG] = ACTIONS(3299),
    [anon_sym_TILDE] = ACTIONS(3299),
    [anon_sym_DASH] = ACTIONS(3297),
    [anon_sym_PLUS] = ACTIONS(3297),
    [anon_sym_STAR] = ACTIONS(3299),
    [anon_sym_AMP_AMP] = ACTIONS(3299),
    [anon_sym_AMP] = ACTIONS(3297),
    [anon_sym_SEMI] = ACTIONS(3299),
    [anon_sym___extension__] = ACTIONS(3297),
    [anon_sym_typedef] = ACTIONS(3297),
    [anon_sym_extern] = ACTIONS(3297),
    [anon_sym___attribute__] = ACTIONS(3297),
    [anon_sym_COLON_COLON] = ACTIONS(3299),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3299),
    [anon_sym___declspec] = ACTIONS(3297),
    [anon_sym___based] = ACTIONS(3297),
    [anon_sym___cdecl] = ACTIONS(3297),
    [anon_sym___clrcall] = ACTIONS(3297),
    [anon_sym___stdcall] = ACTIONS(3297),
    [anon_sym___fastcall] = ACTIONS(3297),
    [anon_sym___thiscall] = ACTIONS(3297),
    [anon_sym___vectorcall] = ACTIONS(3297),
    [anon_sym_LBRACE] = ACTIONS(3299),
    [anon_sym_signed] = ACTIONS(3297),
    [anon_sym_unsigned] = ACTIONS(3297),
    [anon_sym_long] = ACTIONS(3297),
    [anon_sym_short] = ACTIONS(3297),
    [anon_sym_LBRACK] = ACTIONS(3297),
    [anon_sym_static] = ACTIONS(3297),
    [anon_sym_register] = ACTIONS(3297),
    [anon_sym_inline] = ACTIONS(3297),
    [anon_sym___inline] = ACTIONS(3297),
    [anon_sym___inline__] = ACTIONS(3297),
    [anon_sym___forceinline] = ACTIONS(3297),
    [anon_sym_thread_local] = ACTIONS(3297),
    [anon_sym___thread] = ACTIONS(3297),
    [anon_sym_const] = ACTIONS(3297),
    [anon_sym_constexpr] = ACTIONS(3297),
    [anon_sym_volatile] = ACTIONS(3297),
    [anon_sym_restrict] = ACTIONS(3297),
    [anon_sym___restrict__] = ACTIONS(3297),
    [anon_sym__Atomic] = ACTIONS(3297),
    [anon_sym__Noreturn] = ACTIONS(3297),
    [anon_sym_noreturn] = ACTIONS(3297),
    [anon_sym_mutable] = ACTIONS(3297),
    [anon_sym_constinit] = ACTIONS(3297),
    [anon_sym_consteval] = ACTIONS(3297),
    [anon_sym_PROGMEM] = ACTIONS(3297),
    [aux_sym_primitive_type_token1] = ACTIONS(3297),
    [anon_sym_byte] = ACTIONS(3297),
    [anon_sym_word] = ACTIONS(3297),
    [anon_sym_enum] = ACTIONS(3297),
    [anon_sym_class] = ACTIONS(3297),
    [anon_sym_struct] = ACTIONS(3297),
    [anon_sym_union] = ACTIONS(3297),
    [anon_sym_if] = ACTIONS(3297),
    [anon_sym_switch] = ACTIONS(3297),
    [anon_sym_case] = ACTIONS(3297),
    [anon_sym_default] = ACTIONS(3297),
    [anon_sym_while] = ACTIONS(3297),
    [anon_sym_do] = ACTIONS(3297),
    [anon_sym_for] = ACTIONS(3297),
    [anon_sym_return] = ACTIONS(3297),
    [anon_sym_break] = ACTIONS(3297),
    [anon_sym_continue] = ACTIONS(3297),
    [anon_sym_goto] = ACTIONS(3297),
    [anon_sym___try] = ACTIONS(3297),
    [anon_sym___leave] = ACTIONS(3297),
    [anon_sym_not] = ACTIONS(3297),
    [anon_sym_compl] = ACTIONS(3297),
    [anon_sym_DASH_DASH] = ACTIONS(3299),
    [anon_sym_PLUS_PLUS] = ACTIONS(3299),
    [anon_sym_sizeof] = ACTIONS(3297),
    [anon_sym___alignof__] = ACTIONS(3297),
    [anon_sym___alignof] = ACTIONS(3297),
    [anon_sym__alignof] = ACTIONS(3297),
    [anon_sym_alignof] = ACTIONS(3297),
    [anon_sym__Alignof] = ACTIONS(3297),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3297),
    [anon_sym_asm] = ACTIONS(3297),
    [anon_sym___asm__] = ACTIONS(3297),
    [aux_sym_number_literal_token1] = ACTIONS(3299),
    [aux_sym_number_literal_token2] = ACTIONS(3297),
    [anon_sym_L_SQUOTE] = ACTIONS(3299),
    [anon_sym_u_SQUOTE] = ACTIONS(3299),
    [anon_sym_U_SQUOTE] = ACTIONS(3299),
    [anon_sym_u8_SQUOTE] = ACTIONS(3299),
    [anon_sym_SQUOTE] = ACTIONS(3299),
    [anon_sym_L_DQUOTE] = ACTIONS(3299),
    [anon_sym_u_DQUOTE] = ACTIONS(3299),
    [anon_sym_U_DQUOTE] = ACTIONS(3299),
    [anon_sym_u8_DQUOTE] = ACTIONS(3299),
    [anon_sym_DQUOTE] = ACTIONS(3299),
    [sym_true] = ACTIONS(3297),
    [sym_false] = ACTIONS(3297),
    [anon_sym_NULL] = ACTIONS(3297),
    [anon_sym_nullptr] = ACTIONS(3297),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3297),
    [anon_sym_decltype] = ACTIONS(3297),
    [anon_sym_virtual] = ACTIONS(3297),
    [anon_sym_alignas] = ACTIONS(3297),
    [anon_sym_explicit] = ACTIONS(3297),
    [anon_sym_typename] = ACTIONS(3297),
    [anon_sym_template] = ACTIONS(3297),
    [anon_sym_operator] = ACTIONS(3297),
    [anon_sym_try] = ACTIONS(3297),
    [anon_sym_delete] = ACTIONS(3297),
    [anon_sym_throw] = ACTIONS(3297),
    [anon_sym_namespace] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3297),
    [anon_sym_static_assert] = ACTIONS(3297),
    [anon_sym_concept] = ACTIONS(3297),
    [anon_sym_co_return] = ACTIONS(3297),
    [anon_sym_co_yield] = ACTIONS(3297),
    [anon_sym_R_DQUOTE] = ACTIONS(3299),
    [anon_sym_LR_DQUOTE] = ACTIONS(3299),
    [anon_sym_uR_DQUOTE] = ACTIONS(3299),
    [anon_sym_UR_DQUOTE] = ACTIONS(3299),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3299),
    [anon_sym_co_await] = ACTIONS(3297),
    [anon_sym_new] = ACTIONS(3297),
    [anon_sym_requires] = ACTIONS(3297),
    [sym_this] = ACTIONS(3297),
  },
  [579] = {
    [sym_identifier] = ACTIONS(3293),
    [aux_sym_preproc_include_token1] = ACTIONS(3293),
    [aux_sym_preproc_def_token1] = ACTIONS(3293),
    [aux_sym_preproc_if_token1] = ACTIONS(3293),
    [aux_sym_preproc_if_token2] = ACTIONS(3293),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3293),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3293),
    [aux_sym_preproc_else_token1] = ACTIONS(3293),
    [aux_sym_preproc_elif_token1] = ACTIONS(3293),
    [sym_preproc_directive] = ACTIONS(3293),
    [anon_sym_LPAREN2] = ACTIONS(3295),
    [anon_sym_BANG] = ACTIONS(3295),
    [anon_sym_TILDE] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3293),
    [anon_sym_STAR] = ACTIONS(3295),
    [anon_sym_AMP_AMP] = ACTIONS(3295),
    [anon_sym_AMP] = ACTIONS(3293),
    [anon_sym_SEMI] = ACTIONS(3295),
    [anon_sym___extension__] = ACTIONS(3293),
    [anon_sym_typedef] = ACTIONS(3293),
    [anon_sym_extern] = ACTIONS(3293),
    [anon_sym___attribute__] = ACTIONS(3293),
    [anon_sym_COLON_COLON] = ACTIONS(3295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3295),
    [anon_sym___declspec] = ACTIONS(3293),
    [anon_sym___based] = ACTIONS(3293),
    [anon_sym___cdecl] = ACTIONS(3293),
    [anon_sym___clrcall] = ACTIONS(3293),
    [anon_sym___stdcall] = ACTIONS(3293),
    [anon_sym___fastcall] = ACTIONS(3293),
    [anon_sym___thiscall] = ACTIONS(3293),
    [anon_sym___vectorcall] = ACTIONS(3293),
    [anon_sym_LBRACE] = ACTIONS(3295),
    [anon_sym_signed] = ACTIONS(3293),
    [anon_sym_unsigned] = ACTIONS(3293),
    [anon_sym_long] = ACTIONS(3293),
    [anon_sym_short] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_static] = ACTIONS(3293),
    [anon_sym_register] = ACTIONS(3293),
    [anon_sym_inline] = ACTIONS(3293),
    [anon_sym___inline] = ACTIONS(3293),
    [anon_sym___inline__] = ACTIONS(3293),
    [anon_sym___forceinline] = ACTIONS(3293),
    [anon_sym_thread_local] = ACTIONS(3293),
    [anon_sym___thread] = ACTIONS(3293),
    [anon_sym_const] = ACTIONS(3293),
    [anon_sym_constexpr] = ACTIONS(3293),
    [anon_sym_volatile] = ACTIONS(3293),
    [anon_sym_restrict] = ACTIONS(3293),
    [anon_sym___restrict__] = ACTIONS(3293),
    [anon_sym__Atomic] = ACTIONS(3293),
    [anon_sym__Noreturn] = ACTIONS(3293),
    [anon_sym_noreturn] = ACTIONS(3293),
    [anon_sym_mutable] = ACTIONS(3293),
    [anon_sym_constinit] = ACTIONS(3293),
    [anon_sym_consteval] = ACTIONS(3293),
    [anon_sym_PROGMEM] = ACTIONS(3293),
    [aux_sym_primitive_type_token1] = ACTIONS(3293),
    [anon_sym_byte] = ACTIONS(3293),
    [anon_sym_word] = ACTIONS(3293),
    [anon_sym_enum] = ACTIONS(3293),
    [anon_sym_class] = ACTIONS(3293),
    [anon_sym_struct] = ACTIONS(3293),
    [anon_sym_union] = ACTIONS(3293),
    [anon_sym_if] = ACTIONS(3293),
    [anon_sym_switch] = ACTIONS(3293),
    [anon_sym_case] = ACTIONS(3293),
    [anon_sym_default] = ACTIONS(3293),
    [anon_sym_while] = ACTIONS(3293),
    [anon_sym_do] = ACTIONS(3293),
    [anon_sym_for] = ACTIONS(3293),
    [anon_sym_return] = ACTIONS(3293),
    [anon_sym_break] = ACTIONS(3293),
    [anon_sym_continue] = ACTIONS(3293),
    [anon_sym_goto] = ACTIONS(3293),
    [anon_sym___try] = ACTIONS(3293),
    [anon_sym___leave] = ACTIONS(3293),
    [anon_sym_not] = ACTIONS(3293),
    [anon_sym_compl] = ACTIONS(3293),
    [anon_sym_DASH_DASH] = ACTIONS(3295),
    [anon_sym_PLUS_PLUS] = ACTIONS(3295),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3293),
    [anon_sym___alignof] = ACTIONS(3293),
    [anon_sym__alignof] = ACTIONS(3293),
    [anon_sym_alignof] = ACTIONS(3293),
    [anon_sym__Alignof] = ACTIONS(3293),
    [anon_sym_offsetof] = ACTIONS(3293),
    [anon_sym__Generic] = ACTIONS(3293),
    [anon_sym_asm] = ACTIONS(3293),
    [anon_sym___asm__] = ACTIONS(3293),
    [aux_sym_number_literal_token1] = ACTIONS(3295),
    [aux_sym_number_literal_token2] = ACTIONS(3293),
    [anon_sym_L_SQUOTE] = ACTIONS(3295),
    [anon_sym_u_SQUOTE] = ACTIONS(3295),
    [anon_sym_U_SQUOTE] = ACTIONS(3295),
    [anon_sym_u8_SQUOTE] = ACTIONS(3295),
    [anon_sym_SQUOTE] = ACTIONS(3295),
    [anon_sym_L_DQUOTE] = ACTIONS(3295),
    [anon_sym_u_DQUOTE] = ACTIONS(3295),
    [anon_sym_U_DQUOTE] = ACTIONS(3295),
    [anon_sym_u8_DQUOTE] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(3295),
    [sym_true] = ACTIONS(3293),
    [sym_false] = ACTIONS(3293),
    [anon_sym_NULL] = ACTIONS(3293),
    [anon_sym_nullptr] = ACTIONS(3293),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3293),
    [anon_sym_decltype] = ACTIONS(3293),
    [anon_sym_virtual] = ACTIONS(3293),
    [anon_sym_alignas] = ACTIONS(3293),
    [anon_sym_explicit] = ACTIONS(3293),
    [anon_sym_typename] = ACTIONS(3293),
    [anon_sym_template] = ACTIONS(3293),
    [anon_sym_operator] = ACTIONS(3293),
    [anon_sym_try] = ACTIONS(3293),
    [anon_sym_delete] = ACTIONS(3293),
    [anon_sym_throw] = ACTIONS(3293),
    [anon_sym_namespace] = ACTIONS(3293),
    [anon_sym_using] = ACTIONS(3293),
    [anon_sym_static_assert] = ACTIONS(3293),
    [anon_sym_concept] = ACTIONS(3293),
    [anon_sym_co_return] = ACTIONS(3293),
    [anon_sym_co_yield] = ACTIONS(3293),
    [anon_sym_R_DQUOTE] = ACTIONS(3295),
    [anon_sym_LR_DQUOTE] = ACTIONS(3295),
    [anon_sym_uR_DQUOTE] = ACTIONS(3295),
    [anon_sym_UR_DQUOTE] = ACTIONS(3295),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3295),
    [anon_sym_co_await] = ACTIONS(3293),
    [anon_sym_new] = ACTIONS(3293),
    [anon_sym_requires] = ACTIONS(3293),
    [sym_this] = ACTIONS(3293),
  },
  [580] = {
    [sym_identifier] = ACTIONS(3280),
    [aux_sym_preproc_include_token1] = ACTIONS(3280),
    [aux_sym_preproc_def_token1] = ACTIONS(3280),
    [aux_sym_preproc_if_token1] = ACTIONS(3280),
    [aux_sym_preproc_if_token2] = ACTIONS(3280),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3280),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3280),
    [aux_sym_preproc_else_token1] = ACTIONS(3280),
    [aux_sym_preproc_elif_token1] = ACTIONS(3280),
    [sym_preproc_directive] = ACTIONS(3280),
    [anon_sym_LPAREN2] = ACTIONS(3282),
    [anon_sym_BANG] = ACTIONS(3282),
    [anon_sym_TILDE] = ACTIONS(3282),
    [anon_sym_DASH] = ACTIONS(3280),
    [anon_sym_PLUS] = ACTIONS(3280),
    [anon_sym_STAR] = ACTIONS(3282),
    [anon_sym_AMP_AMP] = ACTIONS(3282),
    [anon_sym_AMP] = ACTIONS(3280),
    [anon_sym_SEMI] = ACTIONS(3282),
    [anon_sym___extension__] = ACTIONS(3280),
    [anon_sym_typedef] = ACTIONS(3280),
    [anon_sym_extern] = ACTIONS(3280),
    [anon_sym___attribute__] = ACTIONS(3280),
    [anon_sym_COLON_COLON] = ACTIONS(3282),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3282),
    [anon_sym___declspec] = ACTIONS(3280),
    [anon_sym___based] = ACTIONS(3280),
    [anon_sym___cdecl] = ACTIONS(3280),
    [anon_sym___clrcall] = ACTIONS(3280),
    [anon_sym___stdcall] = ACTIONS(3280),
    [anon_sym___fastcall] = ACTIONS(3280),
    [anon_sym___thiscall] = ACTIONS(3280),
    [anon_sym___vectorcall] = ACTIONS(3280),
    [anon_sym_LBRACE] = ACTIONS(3282),
    [anon_sym_signed] = ACTIONS(3280),
    [anon_sym_unsigned] = ACTIONS(3280),
    [anon_sym_long] = ACTIONS(3280),
    [anon_sym_short] = ACTIONS(3280),
    [anon_sym_LBRACK] = ACTIONS(3280),
    [anon_sym_static] = ACTIONS(3280),
    [anon_sym_register] = ACTIONS(3280),
    [anon_sym_inline] = ACTIONS(3280),
    [anon_sym___inline] = ACTIONS(3280),
    [anon_sym___inline__] = ACTIONS(3280),
    [anon_sym___forceinline] = ACTIONS(3280),
    [anon_sym_thread_local] = ACTIONS(3280),
    [anon_sym___thread] = ACTIONS(3280),
    [anon_sym_const] = ACTIONS(3280),
    [anon_sym_constexpr] = ACTIONS(3280),
    [anon_sym_volatile] = ACTIONS(3280),
    [anon_sym_restrict] = ACTIONS(3280),
    [anon_sym___restrict__] = ACTIONS(3280),
    [anon_sym__Atomic] = ACTIONS(3280),
    [anon_sym__Noreturn] = ACTIONS(3280),
    [anon_sym_noreturn] = ACTIONS(3280),
    [anon_sym_mutable] = ACTIONS(3280),
    [anon_sym_constinit] = ACTIONS(3280),
    [anon_sym_consteval] = ACTIONS(3280),
    [anon_sym_PROGMEM] = ACTIONS(3280),
    [aux_sym_primitive_type_token1] = ACTIONS(3280),
    [anon_sym_byte] = ACTIONS(3280),
    [anon_sym_word] = ACTIONS(3280),
    [anon_sym_enum] = ACTIONS(3280),
    [anon_sym_class] = ACTIONS(3280),
    [anon_sym_struct] = ACTIONS(3280),
    [anon_sym_union] = ACTIONS(3280),
    [anon_sym_if] = ACTIONS(3280),
    [anon_sym_switch] = ACTIONS(3280),
    [anon_sym_case] = ACTIONS(3280),
    [anon_sym_default] = ACTIONS(3280),
    [anon_sym_while] = ACTIONS(3280),
    [anon_sym_do] = ACTIONS(3280),
    [anon_sym_for] = ACTIONS(3280),
    [anon_sym_return] = ACTIONS(3280),
    [anon_sym_break] = ACTIONS(3280),
    [anon_sym_continue] = ACTIONS(3280),
    [anon_sym_goto] = ACTIONS(3280),
    [anon_sym___try] = ACTIONS(3280),
    [anon_sym___leave] = ACTIONS(3280),
    [anon_sym_not] = ACTIONS(3280),
    [anon_sym_compl] = ACTIONS(3280),
    [anon_sym_DASH_DASH] = ACTIONS(3282),
    [anon_sym_PLUS_PLUS] = ACTIONS(3282),
    [anon_sym_sizeof] = ACTIONS(3280),
    [anon_sym___alignof__] = ACTIONS(3280),
    [anon_sym___alignof] = ACTIONS(3280),
    [anon_sym__alignof] = ACTIONS(3280),
    [anon_sym_alignof] = ACTIONS(3280),
    [anon_sym__Alignof] = ACTIONS(3280),
    [anon_sym_offsetof] = ACTIONS(3280),
    [anon_sym__Generic] = ACTIONS(3280),
    [anon_sym_asm] = ACTIONS(3280),
    [anon_sym___asm__] = ACTIONS(3280),
    [aux_sym_number_literal_token1] = ACTIONS(3282),
    [aux_sym_number_literal_token2] = ACTIONS(3280),
    [anon_sym_L_SQUOTE] = ACTIONS(3282),
    [anon_sym_u_SQUOTE] = ACTIONS(3282),
    [anon_sym_U_SQUOTE] = ACTIONS(3282),
    [anon_sym_u8_SQUOTE] = ACTIONS(3282),
    [anon_sym_SQUOTE] = ACTIONS(3282),
    [anon_sym_L_DQUOTE] = ACTIONS(3282),
    [anon_sym_u_DQUOTE] = ACTIONS(3282),
    [anon_sym_U_DQUOTE] = ACTIONS(3282),
    [anon_sym_u8_DQUOTE] = ACTIONS(3282),
    [anon_sym_DQUOTE] = ACTIONS(3282),
    [sym_true] = ACTIONS(3280),
    [sym_false] = ACTIONS(3280),
    [anon_sym_NULL] = ACTIONS(3280),
    [anon_sym_nullptr] = ACTIONS(3280),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3280),
    [anon_sym_decltype] = ACTIONS(3280),
    [anon_sym_virtual] = ACTIONS(3280),
    [anon_sym_alignas] = ACTIONS(3280),
    [anon_sym_explicit] = ACTIONS(3280),
    [anon_sym_typename] = ACTIONS(3280),
    [anon_sym_template] = ACTIONS(3280),
    [anon_sym_operator] = ACTIONS(3280),
    [anon_sym_try] = ACTIONS(3280),
    [anon_sym_delete] = ACTIONS(3280),
    [anon_sym_throw] = ACTIONS(3280),
    [anon_sym_namespace] = ACTIONS(3280),
    [anon_sym_using] = ACTIONS(3280),
    [anon_sym_static_assert] = ACTIONS(3280),
    [anon_sym_concept] = ACTIONS(3280),
    [anon_sym_co_return] = ACTIONS(3280),
    [anon_sym_co_yield] = ACTIONS(3280),
    [anon_sym_R_DQUOTE] = ACTIONS(3282),
    [anon_sym_LR_DQUOTE] = ACTIONS(3282),
    [anon_sym_uR_DQUOTE] = ACTIONS(3282),
    [anon_sym_UR_DQUOTE] = ACTIONS(3282),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3282),
    [anon_sym_co_await] = ACTIONS(3280),
    [anon_sym_new] = ACTIONS(3280),
    [anon_sym_requires] = ACTIONS(3280),
    [sym_this] = ACTIONS(3280),
  },
  [581] = {
    [sym_identifier] = ACTIONS(3258),
    [aux_sym_preproc_include_token1] = ACTIONS(3258),
    [aux_sym_preproc_def_token1] = ACTIONS(3258),
    [aux_sym_preproc_if_token1] = ACTIONS(3258),
    [aux_sym_preproc_if_token2] = ACTIONS(3258),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3258),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3258),
    [aux_sym_preproc_else_token1] = ACTIONS(3258),
    [aux_sym_preproc_elif_token1] = ACTIONS(3258),
    [sym_preproc_directive] = ACTIONS(3258),
    [anon_sym_LPAREN2] = ACTIONS(3260),
    [anon_sym_BANG] = ACTIONS(3260),
    [anon_sym_TILDE] = ACTIONS(3260),
    [anon_sym_DASH] = ACTIONS(3258),
    [anon_sym_PLUS] = ACTIONS(3258),
    [anon_sym_STAR] = ACTIONS(3260),
    [anon_sym_AMP_AMP] = ACTIONS(3260),
    [anon_sym_AMP] = ACTIONS(3258),
    [anon_sym_SEMI] = ACTIONS(3260),
    [anon_sym___extension__] = ACTIONS(3258),
    [anon_sym_typedef] = ACTIONS(3258),
    [anon_sym_extern] = ACTIONS(3258),
    [anon_sym___attribute__] = ACTIONS(3258),
    [anon_sym_COLON_COLON] = ACTIONS(3260),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3260),
    [anon_sym___declspec] = ACTIONS(3258),
    [anon_sym___based] = ACTIONS(3258),
    [anon_sym___cdecl] = ACTIONS(3258),
    [anon_sym___clrcall] = ACTIONS(3258),
    [anon_sym___stdcall] = ACTIONS(3258),
    [anon_sym___fastcall] = ACTIONS(3258),
    [anon_sym___thiscall] = ACTIONS(3258),
    [anon_sym___vectorcall] = ACTIONS(3258),
    [anon_sym_LBRACE] = ACTIONS(3260),
    [anon_sym_signed] = ACTIONS(3258),
    [anon_sym_unsigned] = ACTIONS(3258),
    [anon_sym_long] = ACTIONS(3258),
    [anon_sym_short] = ACTIONS(3258),
    [anon_sym_LBRACK] = ACTIONS(3258),
    [anon_sym_static] = ACTIONS(3258),
    [anon_sym_register] = ACTIONS(3258),
    [anon_sym_inline] = ACTIONS(3258),
    [anon_sym___inline] = ACTIONS(3258),
    [anon_sym___inline__] = ACTIONS(3258),
    [anon_sym___forceinline] = ACTIONS(3258),
    [anon_sym_thread_local] = ACTIONS(3258),
    [anon_sym___thread] = ACTIONS(3258),
    [anon_sym_const] = ACTIONS(3258),
    [anon_sym_constexpr] = ACTIONS(3258),
    [anon_sym_volatile] = ACTIONS(3258),
    [anon_sym_restrict] = ACTIONS(3258),
    [anon_sym___restrict__] = ACTIONS(3258),
    [anon_sym__Atomic] = ACTIONS(3258),
    [anon_sym__Noreturn] = ACTIONS(3258),
    [anon_sym_noreturn] = ACTIONS(3258),
    [anon_sym_mutable] = ACTIONS(3258),
    [anon_sym_constinit] = ACTIONS(3258),
    [anon_sym_consteval] = ACTIONS(3258),
    [anon_sym_PROGMEM] = ACTIONS(3258),
    [aux_sym_primitive_type_token1] = ACTIONS(3258),
    [anon_sym_byte] = ACTIONS(3258),
    [anon_sym_word] = ACTIONS(3258),
    [anon_sym_enum] = ACTIONS(3258),
    [anon_sym_class] = ACTIONS(3258),
    [anon_sym_struct] = ACTIONS(3258),
    [anon_sym_union] = ACTIONS(3258),
    [anon_sym_if] = ACTIONS(3258),
    [anon_sym_switch] = ACTIONS(3258),
    [anon_sym_case] = ACTIONS(3258),
    [anon_sym_default] = ACTIONS(3258),
    [anon_sym_while] = ACTIONS(3258),
    [anon_sym_do] = ACTIONS(3258),
    [anon_sym_for] = ACTIONS(3258),
    [anon_sym_return] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3258),
    [anon_sym_continue] = ACTIONS(3258),
    [anon_sym_goto] = ACTIONS(3258),
    [anon_sym___try] = ACTIONS(3258),
    [anon_sym___leave] = ACTIONS(3258),
    [anon_sym_not] = ACTIONS(3258),
    [anon_sym_compl] = ACTIONS(3258),
    [anon_sym_DASH_DASH] = ACTIONS(3260),
    [anon_sym_PLUS_PLUS] = ACTIONS(3260),
    [anon_sym_sizeof] = ACTIONS(3258),
    [anon_sym___alignof__] = ACTIONS(3258),
    [anon_sym___alignof] = ACTIONS(3258),
    [anon_sym__alignof] = ACTIONS(3258),
    [anon_sym_alignof] = ACTIONS(3258),
    [anon_sym__Alignof] = ACTIONS(3258),
    [anon_sym_offsetof] = ACTIONS(3258),
    [anon_sym__Generic] = ACTIONS(3258),
    [anon_sym_asm] = ACTIONS(3258),
    [anon_sym___asm__] = ACTIONS(3258),
    [aux_sym_number_literal_token1] = ACTIONS(3260),
    [aux_sym_number_literal_token2] = ACTIONS(3258),
    [anon_sym_L_SQUOTE] = ACTIONS(3260),
    [anon_sym_u_SQUOTE] = ACTIONS(3260),
    [anon_sym_U_SQUOTE] = ACTIONS(3260),
    [anon_sym_u8_SQUOTE] = ACTIONS(3260),
    [anon_sym_SQUOTE] = ACTIONS(3260),
    [anon_sym_L_DQUOTE] = ACTIONS(3260),
    [anon_sym_u_DQUOTE] = ACTIONS(3260),
    [anon_sym_U_DQUOTE] = ACTIONS(3260),
    [anon_sym_u8_DQUOTE] = ACTIONS(3260),
    [anon_sym_DQUOTE] = ACTIONS(3260),
    [sym_true] = ACTIONS(3258),
    [sym_false] = ACTIONS(3258),
    [anon_sym_NULL] = ACTIONS(3258),
    [anon_sym_nullptr] = ACTIONS(3258),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3258),
    [anon_sym_decltype] = ACTIONS(3258),
    [anon_sym_virtual] = ACTIONS(3258),
    [anon_sym_alignas] = ACTIONS(3258),
    [anon_sym_explicit] = ACTIONS(3258),
    [anon_sym_typename] = ACTIONS(3258),
    [anon_sym_template] = ACTIONS(3258),
    [anon_sym_operator] = ACTIONS(3258),
    [anon_sym_try] = ACTIONS(3258),
    [anon_sym_delete] = ACTIONS(3258),
    [anon_sym_throw] = ACTIONS(3258),
    [anon_sym_namespace] = ACTIONS(3258),
    [anon_sym_using] = ACTIONS(3258),
    [anon_sym_static_assert] = ACTIONS(3258),
    [anon_sym_concept] = ACTIONS(3258),
    [anon_sym_co_return] = ACTIONS(3258),
    [anon_sym_co_yield] = ACTIONS(3258),
    [anon_sym_R_DQUOTE] = ACTIONS(3260),
    [anon_sym_LR_DQUOTE] = ACTIONS(3260),
    [anon_sym_uR_DQUOTE] = ACTIONS(3260),
    [anon_sym_UR_DQUOTE] = ACTIONS(3260),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3260),
    [anon_sym_co_await] = ACTIONS(3258),
    [anon_sym_new] = ACTIONS(3258),
    [anon_sym_requires] = ACTIONS(3258),
    [sym_this] = ACTIONS(3258),
  },
  [582] = {
    [sym_identifier] = ACTIONS(3262),
    [aux_sym_preproc_include_token1] = ACTIONS(3262),
    [aux_sym_preproc_def_token1] = ACTIONS(3262),
    [aux_sym_preproc_if_token1] = ACTIONS(3262),
    [aux_sym_preproc_if_token2] = ACTIONS(3262),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3262),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3262),
    [aux_sym_preproc_else_token1] = ACTIONS(3262),
    [aux_sym_preproc_elif_token1] = ACTIONS(3262),
    [sym_preproc_directive] = ACTIONS(3262),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_BANG] = ACTIONS(3264),
    [anon_sym_TILDE] = ACTIONS(3264),
    [anon_sym_DASH] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3262),
    [anon_sym_STAR] = ACTIONS(3264),
    [anon_sym_AMP_AMP] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3262),
    [anon_sym_SEMI] = ACTIONS(3264),
    [anon_sym___extension__] = ACTIONS(3262),
    [anon_sym_typedef] = ACTIONS(3262),
    [anon_sym_extern] = ACTIONS(3262),
    [anon_sym___attribute__] = ACTIONS(3262),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3264),
    [anon_sym___declspec] = ACTIONS(3262),
    [anon_sym___based] = ACTIONS(3262),
    [anon_sym___cdecl] = ACTIONS(3262),
    [anon_sym___clrcall] = ACTIONS(3262),
    [anon_sym___stdcall] = ACTIONS(3262),
    [anon_sym___fastcall] = ACTIONS(3262),
    [anon_sym___thiscall] = ACTIONS(3262),
    [anon_sym___vectorcall] = ACTIONS(3262),
    [anon_sym_LBRACE] = ACTIONS(3264),
    [anon_sym_signed] = ACTIONS(3262),
    [anon_sym_unsigned] = ACTIONS(3262),
    [anon_sym_long] = ACTIONS(3262),
    [anon_sym_short] = ACTIONS(3262),
    [anon_sym_LBRACK] = ACTIONS(3262),
    [anon_sym_static] = ACTIONS(3262),
    [anon_sym_register] = ACTIONS(3262),
    [anon_sym_inline] = ACTIONS(3262),
    [anon_sym___inline] = ACTIONS(3262),
    [anon_sym___inline__] = ACTIONS(3262),
    [anon_sym___forceinline] = ACTIONS(3262),
    [anon_sym_thread_local] = ACTIONS(3262),
    [anon_sym___thread] = ACTIONS(3262),
    [anon_sym_const] = ACTIONS(3262),
    [anon_sym_constexpr] = ACTIONS(3262),
    [anon_sym_volatile] = ACTIONS(3262),
    [anon_sym_restrict] = ACTIONS(3262),
    [anon_sym___restrict__] = ACTIONS(3262),
    [anon_sym__Atomic] = ACTIONS(3262),
    [anon_sym__Noreturn] = ACTIONS(3262),
    [anon_sym_noreturn] = ACTIONS(3262),
    [anon_sym_mutable] = ACTIONS(3262),
    [anon_sym_constinit] = ACTIONS(3262),
    [anon_sym_consteval] = ACTIONS(3262),
    [anon_sym_PROGMEM] = ACTIONS(3262),
    [aux_sym_primitive_type_token1] = ACTIONS(3262),
    [anon_sym_byte] = ACTIONS(3262),
    [anon_sym_word] = ACTIONS(3262),
    [anon_sym_enum] = ACTIONS(3262),
    [anon_sym_class] = ACTIONS(3262),
    [anon_sym_struct] = ACTIONS(3262),
    [anon_sym_union] = ACTIONS(3262),
    [anon_sym_if] = ACTIONS(3262),
    [anon_sym_switch] = ACTIONS(3262),
    [anon_sym_case] = ACTIONS(3262),
    [anon_sym_default] = ACTIONS(3262),
    [anon_sym_while] = ACTIONS(3262),
    [anon_sym_do] = ACTIONS(3262),
    [anon_sym_for] = ACTIONS(3262),
    [anon_sym_return] = ACTIONS(3262),
    [anon_sym_break] = ACTIONS(3262),
    [anon_sym_continue] = ACTIONS(3262),
    [anon_sym_goto] = ACTIONS(3262),
    [anon_sym___try] = ACTIONS(3262),
    [anon_sym___leave] = ACTIONS(3262),
    [anon_sym_not] = ACTIONS(3262),
    [anon_sym_compl] = ACTIONS(3262),
    [anon_sym_DASH_DASH] = ACTIONS(3264),
    [anon_sym_PLUS_PLUS] = ACTIONS(3264),
    [anon_sym_sizeof] = ACTIONS(3262),
    [anon_sym___alignof__] = ACTIONS(3262),
    [anon_sym___alignof] = ACTIONS(3262),
    [anon_sym__alignof] = ACTIONS(3262),
    [anon_sym_alignof] = ACTIONS(3262),
    [anon_sym__Alignof] = ACTIONS(3262),
    [anon_sym_offsetof] = ACTIONS(3262),
    [anon_sym__Generic] = ACTIONS(3262),
    [anon_sym_asm] = ACTIONS(3262),
    [anon_sym___asm__] = ACTIONS(3262),
    [aux_sym_number_literal_token1] = ACTIONS(3264),
    [aux_sym_number_literal_token2] = ACTIONS(3262),
    [anon_sym_L_SQUOTE] = ACTIONS(3264),
    [anon_sym_u_SQUOTE] = ACTIONS(3264),
    [anon_sym_U_SQUOTE] = ACTIONS(3264),
    [anon_sym_u8_SQUOTE] = ACTIONS(3264),
    [anon_sym_SQUOTE] = ACTIONS(3264),
    [anon_sym_L_DQUOTE] = ACTIONS(3264),
    [anon_sym_u_DQUOTE] = ACTIONS(3264),
    [anon_sym_U_DQUOTE] = ACTIONS(3264),
    [anon_sym_u8_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE] = ACTIONS(3264),
    [sym_true] = ACTIONS(3262),
    [sym_false] = ACTIONS(3262),
    [anon_sym_NULL] = ACTIONS(3262),
    [anon_sym_nullptr] = ACTIONS(3262),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3262),
    [anon_sym_decltype] = ACTIONS(3262),
    [anon_sym_virtual] = ACTIONS(3262),
    [anon_sym_alignas] = ACTIONS(3262),
    [anon_sym_explicit] = ACTIONS(3262),
    [anon_sym_typename] = ACTIONS(3262),
    [anon_sym_template] = ACTIONS(3262),
    [anon_sym_operator] = ACTIONS(3262),
    [anon_sym_try] = ACTIONS(3262),
    [anon_sym_delete] = ACTIONS(3262),
    [anon_sym_throw] = ACTIONS(3262),
    [anon_sym_namespace] = ACTIONS(3262),
    [anon_sym_using] = ACTIONS(3262),
    [anon_sym_static_assert] = ACTIONS(3262),
    [anon_sym_concept] = ACTIONS(3262),
    [anon_sym_co_return] = ACTIONS(3262),
    [anon_sym_co_yield] = ACTIONS(3262),
    [anon_sym_R_DQUOTE] = ACTIONS(3264),
    [anon_sym_LR_DQUOTE] = ACTIONS(3264),
    [anon_sym_uR_DQUOTE] = ACTIONS(3264),
    [anon_sym_UR_DQUOTE] = ACTIONS(3264),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3264),
    [anon_sym_co_await] = ACTIONS(3262),
    [anon_sym_new] = ACTIONS(3262),
    [anon_sym_requires] = ACTIONS(3262),
    [sym_this] = ACTIONS(3262),
  },
  [583] = {
    [sym_identifier] = ACTIONS(3266),
    [aux_sym_preproc_include_token1] = ACTIONS(3266),
    [aux_sym_preproc_def_token1] = ACTIONS(3266),
    [aux_sym_preproc_if_token1] = ACTIONS(3266),
    [aux_sym_preproc_if_token2] = ACTIONS(3266),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3266),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3266),
    [aux_sym_preproc_else_token1] = ACTIONS(3266),
    [aux_sym_preproc_elif_token1] = ACTIONS(3266),
    [sym_preproc_directive] = ACTIONS(3266),
    [anon_sym_LPAREN2] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3268),
    [anon_sym_TILDE] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3266),
    [anon_sym_STAR] = ACTIONS(3268),
    [anon_sym_AMP_AMP] = ACTIONS(3268),
    [anon_sym_AMP] = ACTIONS(3266),
    [anon_sym_SEMI] = ACTIONS(3268),
    [anon_sym___extension__] = ACTIONS(3266),
    [anon_sym_typedef] = ACTIONS(3266),
    [anon_sym_extern] = ACTIONS(3266),
    [anon_sym___attribute__] = ACTIONS(3266),
    [anon_sym_COLON_COLON] = ACTIONS(3268),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3268),
    [anon_sym___declspec] = ACTIONS(3266),
    [anon_sym___based] = ACTIONS(3266),
    [anon_sym___cdecl] = ACTIONS(3266),
    [anon_sym___clrcall] = ACTIONS(3266),
    [anon_sym___stdcall] = ACTIONS(3266),
    [anon_sym___fastcall] = ACTIONS(3266),
    [anon_sym___thiscall] = ACTIONS(3266),
    [anon_sym___vectorcall] = ACTIONS(3266),
    [anon_sym_LBRACE] = ACTIONS(3268),
    [anon_sym_signed] = ACTIONS(3266),
    [anon_sym_unsigned] = ACTIONS(3266),
    [anon_sym_long] = ACTIONS(3266),
    [anon_sym_short] = ACTIONS(3266),
    [anon_sym_LBRACK] = ACTIONS(3266),
    [anon_sym_static] = ACTIONS(3266),
    [anon_sym_register] = ACTIONS(3266),
    [anon_sym_inline] = ACTIONS(3266),
    [anon_sym___inline] = ACTIONS(3266),
    [anon_sym___inline__] = ACTIONS(3266),
    [anon_sym___forceinline] = ACTIONS(3266),
    [anon_sym_thread_local] = ACTIONS(3266),
    [anon_sym___thread] = ACTIONS(3266),
    [anon_sym_const] = ACTIONS(3266),
    [anon_sym_constexpr] = ACTIONS(3266),
    [anon_sym_volatile] = ACTIONS(3266),
    [anon_sym_restrict] = ACTIONS(3266),
    [anon_sym___restrict__] = ACTIONS(3266),
    [anon_sym__Atomic] = ACTIONS(3266),
    [anon_sym__Noreturn] = ACTIONS(3266),
    [anon_sym_noreturn] = ACTIONS(3266),
    [anon_sym_mutable] = ACTIONS(3266),
    [anon_sym_constinit] = ACTIONS(3266),
    [anon_sym_consteval] = ACTIONS(3266),
    [anon_sym_PROGMEM] = ACTIONS(3266),
    [aux_sym_primitive_type_token1] = ACTIONS(3266),
    [anon_sym_byte] = ACTIONS(3266),
    [anon_sym_word] = ACTIONS(3266),
    [anon_sym_enum] = ACTIONS(3266),
    [anon_sym_class] = ACTIONS(3266),
    [anon_sym_struct] = ACTIONS(3266),
    [anon_sym_union] = ACTIONS(3266),
    [anon_sym_if] = ACTIONS(3266),
    [anon_sym_switch] = ACTIONS(3266),
    [anon_sym_case] = ACTIONS(3266),
    [anon_sym_default] = ACTIONS(3266),
    [anon_sym_while] = ACTIONS(3266),
    [anon_sym_do] = ACTIONS(3266),
    [anon_sym_for] = ACTIONS(3266),
    [anon_sym_return] = ACTIONS(3266),
    [anon_sym_break] = ACTIONS(3266),
    [anon_sym_continue] = ACTIONS(3266),
    [anon_sym_goto] = ACTIONS(3266),
    [anon_sym___try] = ACTIONS(3266),
    [anon_sym___leave] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3266),
    [anon_sym_compl] = ACTIONS(3266),
    [anon_sym_DASH_DASH] = ACTIONS(3268),
    [anon_sym_PLUS_PLUS] = ACTIONS(3268),
    [anon_sym_sizeof] = ACTIONS(3266),
    [anon_sym___alignof__] = ACTIONS(3266),
    [anon_sym___alignof] = ACTIONS(3266),
    [anon_sym__alignof] = ACTIONS(3266),
    [anon_sym_alignof] = ACTIONS(3266),
    [anon_sym__Alignof] = ACTIONS(3266),
    [anon_sym_offsetof] = ACTIONS(3266),
    [anon_sym__Generic] = ACTIONS(3266),
    [anon_sym_asm] = ACTIONS(3266),
    [anon_sym___asm__] = ACTIONS(3266),
    [aux_sym_number_literal_token1] = ACTIONS(3268),
    [aux_sym_number_literal_token2] = ACTIONS(3266),
    [anon_sym_L_SQUOTE] = ACTIONS(3268),
    [anon_sym_u_SQUOTE] = ACTIONS(3268),
    [anon_sym_U_SQUOTE] = ACTIONS(3268),
    [anon_sym_u8_SQUOTE] = ACTIONS(3268),
    [anon_sym_SQUOTE] = ACTIONS(3268),
    [anon_sym_L_DQUOTE] = ACTIONS(3268),
    [anon_sym_u_DQUOTE] = ACTIONS(3268),
    [anon_sym_U_DQUOTE] = ACTIONS(3268),
    [anon_sym_u8_DQUOTE] = ACTIONS(3268),
    [anon_sym_DQUOTE] = ACTIONS(3268),
    [sym_true] = ACTIONS(3266),
    [sym_false] = ACTIONS(3266),
    [anon_sym_NULL] = ACTIONS(3266),
    [anon_sym_nullptr] = ACTIONS(3266),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3266),
    [anon_sym_decltype] = ACTIONS(3266),
    [anon_sym_virtual] = ACTIONS(3266),
    [anon_sym_alignas] = ACTIONS(3266),
    [anon_sym_explicit] = ACTIONS(3266),
    [anon_sym_typename] = ACTIONS(3266),
    [anon_sym_template] = ACTIONS(3266),
    [anon_sym_operator] = ACTIONS(3266),
    [anon_sym_try] = ACTIONS(3266),
    [anon_sym_delete] = ACTIONS(3266),
    [anon_sym_throw] = ACTIONS(3266),
    [anon_sym_namespace] = ACTIONS(3266),
    [anon_sym_using] = ACTIONS(3266),
    [anon_sym_static_assert] = ACTIONS(3266),
    [anon_sym_concept] = ACTIONS(3266),
    [anon_sym_co_return] = ACTIONS(3266),
    [anon_sym_co_yield] = ACTIONS(3266),
    [anon_sym_R_DQUOTE] = ACTIONS(3268),
    [anon_sym_LR_DQUOTE] = ACTIONS(3268),
    [anon_sym_uR_DQUOTE] = ACTIONS(3268),
    [anon_sym_UR_DQUOTE] = ACTIONS(3268),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3268),
    [anon_sym_co_await] = ACTIONS(3266),
    [anon_sym_new] = ACTIONS(3266),
    [anon_sym_requires] = ACTIONS(3266),
    [sym_this] = ACTIONS(3266),
  },
  [584] = {
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_include_token1] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token2] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [aux_sym_preproc_else_token1] = ACTIONS(3513),
    [aux_sym_preproc_elif_token1] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_BANG] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3513),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym_SEMI] = ACTIONS(3515),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym___cdecl] = ACTIONS(3513),
    [anon_sym___clrcall] = ACTIONS(3513),
    [anon_sym___stdcall] = ACTIONS(3513),
    [anon_sym___fastcall] = ACTIONS(3513),
    [anon_sym___thiscall] = ACTIONS(3513),
    [anon_sym___vectorcall] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_PROGMEM] = ACTIONS(3513),
    [aux_sym_primitive_type_token1] = ACTIONS(3513),
    [anon_sym_byte] = ACTIONS(3513),
    [anon_sym_word] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [anon_sym_if] = ACTIONS(3513),
    [anon_sym_switch] = ACTIONS(3513),
    [anon_sym_case] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3513),
    [anon_sym_while] = ACTIONS(3513),
    [anon_sym_do] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3513),
    [anon_sym_return] = ACTIONS(3513),
    [anon_sym_break] = ACTIONS(3513),
    [anon_sym_continue] = ACTIONS(3513),
    [anon_sym_goto] = ACTIONS(3513),
    [anon_sym___try] = ACTIONS(3513),
    [anon_sym___leave] = ACTIONS(3513),
    [anon_sym_not] = ACTIONS(3513),
    [anon_sym_compl] = ACTIONS(3513),
    [anon_sym_DASH_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_PLUS] = ACTIONS(3515),
    [anon_sym_sizeof] = ACTIONS(3513),
    [anon_sym___alignof__] = ACTIONS(3513),
    [anon_sym___alignof] = ACTIONS(3513),
    [anon_sym__alignof] = ACTIONS(3513),
    [anon_sym_alignof] = ACTIONS(3513),
    [anon_sym__Alignof] = ACTIONS(3513),
    [anon_sym_offsetof] = ACTIONS(3513),
    [anon_sym__Generic] = ACTIONS(3513),
    [anon_sym_asm] = ACTIONS(3513),
    [anon_sym___asm__] = ACTIONS(3513),
    [aux_sym_number_literal_token1] = ACTIONS(3515),
    [aux_sym_number_literal_token2] = ACTIONS(3513),
    [anon_sym_L_SQUOTE] = ACTIONS(3515),
    [anon_sym_u_SQUOTE] = ACTIONS(3515),
    [anon_sym_U_SQUOTE] = ACTIONS(3515),
    [anon_sym_u8_SQUOTE] = ACTIONS(3515),
    [anon_sym_SQUOTE] = ACTIONS(3515),
    [anon_sym_L_DQUOTE] = ACTIONS(3515),
    [anon_sym_u_DQUOTE] = ACTIONS(3515),
    [anon_sym_U_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [sym_true] = ACTIONS(3513),
    [sym_false] = ACTIONS(3513),
    [anon_sym_NULL] = ACTIONS(3513),
    [anon_sym_nullptr] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [anon_sym_virtual] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3513),
    [anon_sym_delete] = ACTIONS(3513),
    [anon_sym_throw] = ACTIONS(3513),
    [anon_sym_namespace] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
    [anon_sym_concept] = ACTIONS(3513),
    [anon_sym_co_return] = ACTIONS(3513),
    [anon_sym_co_yield] = ACTIONS(3513),
    [anon_sym_R_DQUOTE] = ACTIONS(3515),
    [anon_sym_LR_DQUOTE] = ACTIONS(3515),
    [anon_sym_uR_DQUOTE] = ACTIONS(3515),
    [anon_sym_UR_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3515),
    [anon_sym_co_await] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3513),
    [anon_sym_requires] = ACTIONS(3513),
    [sym_this] = ACTIONS(3513),
  },
  [585] = {
    [sym_identifier] = ACTIONS(3427),
    [aux_sym_preproc_include_token1] = ACTIONS(3427),
    [aux_sym_preproc_def_token1] = ACTIONS(3427),
    [aux_sym_preproc_if_token1] = ACTIONS(3427),
    [aux_sym_preproc_if_token2] = ACTIONS(3427),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3427),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3427),
    [aux_sym_preproc_else_token1] = ACTIONS(3427),
    [aux_sym_preproc_elif_token1] = ACTIONS(3427),
    [sym_preproc_directive] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3429),
    [anon_sym_BANG] = ACTIONS(3429),
    [anon_sym_TILDE] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3429),
    [anon_sym_AMP_AMP] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(3429),
    [anon_sym___extension__] = ACTIONS(3427),
    [anon_sym_typedef] = ACTIONS(3427),
    [anon_sym_extern] = ACTIONS(3427),
    [anon_sym___attribute__] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3429),
    [anon_sym___declspec] = ACTIONS(3427),
    [anon_sym___based] = ACTIONS(3427),
    [anon_sym___cdecl] = ACTIONS(3427),
    [anon_sym___clrcall] = ACTIONS(3427),
    [anon_sym___stdcall] = ACTIONS(3427),
    [anon_sym___fastcall] = ACTIONS(3427),
    [anon_sym___thiscall] = ACTIONS(3427),
    [anon_sym___vectorcall] = ACTIONS(3427),
    [anon_sym_LBRACE] = ACTIONS(3429),
    [anon_sym_signed] = ACTIONS(3427),
    [anon_sym_unsigned] = ACTIONS(3427),
    [anon_sym_long] = ACTIONS(3427),
    [anon_sym_short] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_register] = ACTIONS(3427),
    [anon_sym_inline] = ACTIONS(3427),
    [anon_sym___inline] = ACTIONS(3427),
    [anon_sym___inline__] = ACTIONS(3427),
    [anon_sym___forceinline] = ACTIONS(3427),
    [anon_sym_thread_local] = ACTIONS(3427),
    [anon_sym___thread] = ACTIONS(3427),
    [anon_sym_const] = ACTIONS(3427),
    [anon_sym_constexpr] = ACTIONS(3427),
    [anon_sym_volatile] = ACTIONS(3427),
    [anon_sym_restrict] = ACTIONS(3427),
    [anon_sym___restrict__] = ACTIONS(3427),
    [anon_sym__Atomic] = ACTIONS(3427),
    [anon_sym__Noreturn] = ACTIONS(3427),
    [anon_sym_noreturn] = ACTIONS(3427),
    [anon_sym_mutable] = ACTIONS(3427),
    [anon_sym_constinit] = ACTIONS(3427),
    [anon_sym_consteval] = ACTIONS(3427),
    [anon_sym_PROGMEM] = ACTIONS(3427),
    [aux_sym_primitive_type_token1] = ACTIONS(3427),
    [anon_sym_byte] = ACTIONS(3427),
    [anon_sym_word] = ACTIONS(3427),
    [anon_sym_enum] = ACTIONS(3427),
    [anon_sym_class] = ACTIONS(3427),
    [anon_sym_struct] = ACTIONS(3427),
    [anon_sym_union] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_switch] = ACTIONS(3427),
    [anon_sym_case] = ACTIONS(3427),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_break] = ACTIONS(3427),
    [anon_sym_continue] = ACTIONS(3427),
    [anon_sym_goto] = ACTIONS(3427),
    [anon_sym___try] = ACTIONS(3427),
    [anon_sym___leave] = ACTIONS(3427),
    [anon_sym_not] = ACTIONS(3427),
    [anon_sym_compl] = ACTIONS(3427),
    [anon_sym_DASH_DASH] = ACTIONS(3429),
    [anon_sym_PLUS_PLUS] = ACTIONS(3429),
    [anon_sym_sizeof] = ACTIONS(3427),
    [anon_sym___alignof__] = ACTIONS(3427),
    [anon_sym___alignof] = ACTIONS(3427),
    [anon_sym__alignof] = ACTIONS(3427),
    [anon_sym_alignof] = ACTIONS(3427),
    [anon_sym__Alignof] = ACTIONS(3427),
    [anon_sym_offsetof] = ACTIONS(3427),
    [anon_sym__Generic] = ACTIONS(3427),
    [anon_sym_asm] = ACTIONS(3427),
    [anon_sym___asm__] = ACTIONS(3427),
    [aux_sym_number_literal_token1] = ACTIONS(3429),
    [aux_sym_number_literal_token2] = ACTIONS(3427),
    [anon_sym_L_SQUOTE] = ACTIONS(3429),
    [anon_sym_u_SQUOTE] = ACTIONS(3429),
    [anon_sym_U_SQUOTE] = ACTIONS(3429),
    [anon_sym_u8_SQUOTE] = ACTIONS(3429),
    [anon_sym_SQUOTE] = ACTIONS(3429),
    [anon_sym_L_DQUOTE] = ACTIONS(3429),
    [anon_sym_u_DQUOTE] = ACTIONS(3429),
    [anon_sym_U_DQUOTE] = ACTIONS(3429),
    [anon_sym_u8_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(3429),
    [sym_true] = ACTIONS(3427),
    [sym_false] = ACTIONS(3427),
    [anon_sym_NULL] = ACTIONS(3427),
    [anon_sym_nullptr] = ACTIONS(3427),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3427),
    [anon_sym_decltype] = ACTIONS(3427),
    [anon_sym_virtual] = ACTIONS(3427),
    [anon_sym_alignas] = ACTIONS(3427),
    [anon_sym_explicit] = ACTIONS(3427),
    [anon_sym_typename] = ACTIONS(3427),
    [anon_sym_template] = ACTIONS(3427),
    [anon_sym_operator] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_delete] = ACTIONS(3427),
    [anon_sym_throw] = ACTIONS(3427),
    [anon_sym_namespace] = ACTIONS(3427),
    [anon_sym_using] = ACTIONS(3427),
    [anon_sym_static_assert] = ACTIONS(3427),
    [anon_sym_concept] = ACTIONS(3427),
    [anon_sym_co_return] = ACTIONS(3427),
    [anon_sym_co_yield] = ACTIONS(3427),
    [anon_sym_R_DQUOTE] = ACTIONS(3429),
    [anon_sym_LR_DQUOTE] = ACTIONS(3429),
    [anon_sym_uR_DQUOTE] = ACTIONS(3429),
    [anon_sym_UR_DQUOTE] = ACTIONS(3429),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3429),
    [anon_sym_co_await] = ACTIONS(3427),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_requires] = ACTIONS(3427),
    [sym_this] = ACTIONS(3427),
  },
  [586] = {
    [sym_identifier] = ACTIONS(2887),
    [aux_sym_preproc_include_token1] = ACTIONS(2887),
    [aux_sym_preproc_def_token1] = ACTIONS(2887),
    [aux_sym_preproc_if_token1] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2887),
    [sym_preproc_directive] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2889),
    [anon_sym_BANG] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2887),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_SEMI] = ACTIONS(2889),
    [anon_sym___extension__] = ACTIONS(2887),
    [anon_sym_typedef] = ACTIONS(2887),
    [anon_sym_extern] = ACTIONS(2887),
    [anon_sym___attribute__] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2889),
    [anon_sym___declspec] = ACTIONS(2887),
    [anon_sym___based] = ACTIONS(2887),
    [anon_sym___cdecl] = ACTIONS(2887),
    [anon_sym___clrcall] = ACTIONS(2887),
    [anon_sym___stdcall] = ACTIONS(2887),
    [anon_sym___fastcall] = ACTIONS(2887),
    [anon_sym___thiscall] = ACTIONS(2887),
    [anon_sym___vectorcall] = ACTIONS(2887),
    [anon_sym_LBRACE] = ACTIONS(2889),
    [anon_sym_RBRACE] = ACTIONS(2889),
    [anon_sym_signed] = ACTIONS(2887),
    [anon_sym_unsigned] = ACTIONS(2887),
    [anon_sym_long] = ACTIONS(2887),
    [anon_sym_short] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_static] = ACTIONS(2887),
    [anon_sym_register] = ACTIONS(2887),
    [anon_sym_inline] = ACTIONS(2887),
    [anon_sym___inline] = ACTIONS(2887),
    [anon_sym___inline__] = ACTIONS(2887),
    [anon_sym___forceinline] = ACTIONS(2887),
    [anon_sym_thread_local] = ACTIONS(2887),
    [anon_sym___thread] = ACTIONS(2887),
    [anon_sym_const] = ACTIONS(2887),
    [anon_sym_constexpr] = ACTIONS(2887),
    [anon_sym_volatile] = ACTIONS(2887),
    [anon_sym_restrict] = ACTIONS(2887),
    [anon_sym___restrict__] = ACTIONS(2887),
    [anon_sym__Atomic] = ACTIONS(2887),
    [anon_sym__Noreturn] = ACTIONS(2887),
    [anon_sym_noreturn] = ACTIONS(2887),
    [anon_sym_mutable] = ACTIONS(2887),
    [anon_sym_constinit] = ACTIONS(2887),
    [anon_sym_consteval] = ACTIONS(2887),
    [anon_sym_PROGMEM] = ACTIONS(2887),
    [aux_sym_primitive_type_token1] = ACTIONS(2887),
    [anon_sym_byte] = ACTIONS(2887),
    [anon_sym_word] = ACTIONS(2887),
    [anon_sym_enum] = ACTIONS(2887),
    [anon_sym_class] = ACTIONS(2887),
    [anon_sym_struct] = ACTIONS(2887),
    [anon_sym_union] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_else] = ACTIONS(2887),
    [anon_sym_switch] = ACTIONS(2887),
    [anon_sym_case] = ACTIONS(2887),
    [anon_sym_default] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2887),
    [anon_sym_for] = ACTIONS(2887),
    [anon_sym_return] = ACTIONS(2887),
    [anon_sym_break] = ACTIONS(2887),
    [anon_sym_continue] = ACTIONS(2887),
    [anon_sym_goto] = ACTIONS(2887),
    [anon_sym___try] = ACTIONS(2887),
    [anon_sym___leave] = ACTIONS(2887),
    [anon_sym_not] = ACTIONS(2887),
    [anon_sym_compl] = ACTIONS(2887),
    [anon_sym_DASH_DASH] = ACTIONS(2889),
    [anon_sym_PLUS_PLUS] = ACTIONS(2889),
    [anon_sym_sizeof] = ACTIONS(2887),
    [anon_sym___alignof__] = ACTIONS(2887),
    [anon_sym___alignof] = ACTIONS(2887),
    [anon_sym__alignof] = ACTIONS(2887),
    [anon_sym_alignof] = ACTIONS(2887),
    [anon_sym__Alignof] = ACTIONS(2887),
    [anon_sym_offsetof] = ACTIONS(2887),
    [anon_sym__Generic] = ACTIONS(2887),
    [anon_sym_asm] = ACTIONS(2887),
    [anon_sym___asm__] = ACTIONS(2887),
    [aux_sym_number_literal_token1] = ACTIONS(2889),
    [aux_sym_number_literal_token2] = ACTIONS(2887),
    [anon_sym_L_SQUOTE] = ACTIONS(2889),
    [anon_sym_u_SQUOTE] = ACTIONS(2889),
    [anon_sym_U_SQUOTE] = ACTIONS(2889),
    [anon_sym_u8_SQUOTE] = ACTIONS(2889),
    [anon_sym_SQUOTE] = ACTIONS(2889),
    [anon_sym_L_DQUOTE] = ACTIONS(2889),
    [anon_sym_u_DQUOTE] = ACTIONS(2889),
    [anon_sym_U_DQUOTE] = ACTIONS(2889),
    [anon_sym_u8_DQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE] = ACTIONS(2889),
    [sym_true] = ACTIONS(2887),
    [sym_false] = ACTIONS(2887),
    [anon_sym_NULL] = ACTIONS(2887),
    [anon_sym_nullptr] = ACTIONS(2887),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2887),
    [anon_sym_decltype] = ACTIONS(2887),
    [anon_sym_virtual] = ACTIONS(2887),
    [anon_sym_alignas] = ACTIONS(2887),
    [anon_sym_explicit] = ACTIONS(2887),
    [anon_sym_typename] = ACTIONS(2887),
    [anon_sym_template] = ACTIONS(2887),
    [anon_sym_operator] = ACTIONS(2887),
    [anon_sym_try] = ACTIONS(2887),
    [anon_sym_delete] = ACTIONS(2887),
    [anon_sym_throw] = ACTIONS(2887),
    [anon_sym_namespace] = ACTIONS(2887),
    [anon_sym_using] = ACTIONS(2887),
    [anon_sym_static_assert] = ACTIONS(2887),
    [anon_sym_concept] = ACTIONS(2887),
    [anon_sym_co_return] = ACTIONS(2887),
    [anon_sym_co_yield] = ACTIONS(2887),
    [anon_sym_catch] = ACTIONS(2887),
    [anon_sym_R_DQUOTE] = ACTIONS(2889),
    [anon_sym_LR_DQUOTE] = ACTIONS(2889),
    [anon_sym_uR_DQUOTE] = ACTIONS(2889),
    [anon_sym_UR_DQUOTE] = ACTIONS(2889),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2889),
    [anon_sym_co_await] = ACTIONS(2887),
    [anon_sym_new] = ACTIONS(2887),
    [anon_sym_requires] = ACTIONS(2887),
    [sym_this] = ACTIONS(2887),
  },
  [587] = {
    [sym_identifier] = ACTIONS(3270),
    [aux_sym_preproc_include_token1] = ACTIONS(3270),
    [aux_sym_preproc_def_token1] = ACTIONS(3270),
    [aux_sym_preproc_if_token1] = ACTIONS(3270),
    [aux_sym_preproc_if_token2] = ACTIONS(3270),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3270),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3270),
    [aux_sym_preproc_else_token1] = ACTIONS(3270),
    [aux_sym_preproc_elif_token1] = ACTIONS(3270),
    [sym_preproc_directive] = ACTIONS(3270),
    [anon_sym_LPAREN2] = ACTIONS(3272),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3270),
    [anon_sym_PLUS] = ACTIONS(3270),
    [anon_sym_STAR] = ACTIONS(3272),
    [anon_sym_AMP_AMP] = ACTIONS(3272),
    [anon_sym_AMP] = ACTIONS(3270),
    [anon_sym_SEMI] = ACTIONS(3272),
    [anon_sym___extension__] = ACTIONS(3270),
    [anon_sym_typedef] = ACTIONS(3270),
    [anon_sym_extern] = ACTIONS(3270),
    [anon_sym___attribute__] = ACTIONS(3270),
    [anon_sym_COLON_COLON] = ACTIONS(3272),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3272),
    [anon_sym___declspec] = ACTIONS(3270),
    [anon_sym___based] = ACTIONS(3270),
    [anon_sym___cdecl] = ACTIONS(3270),
    [anon_sym___clrcall] = ACTIONS(3270),
    [anon_sym___stdcall] = ACTIONS(3270),
    [anon_sym___fastcall] = ACTIONS(3270),
    [anon_sym___thiscall] = ACTIONS(3270),
    [anon_sym___vectorcall] = ACTIONS(3270),
    [anon_sym_LBRACE] = ACTIONS(3272),
    [anon_sym_signed] = ACTIONS(3270),
    [anon_sym_unsigned] = ACTIONS(3270),
    [anon_sym_long] = ACTIONS(3270),
    [anon_sym_short] = ACTIONS(3270),
    [anon_sym_LBRACK] = ACTIONS(3270),
    [anon_sym_static] = ACTIONS(3270),
    [anon_sym_register] = ACTIONS(3270),
    [anon_sym_inline] = ACTIONS(3270),
    [anon_sym___inline] = ACTIONS(3270),
    [anon_sym___inline__] = ACTIONS(3270),
    [anon_sym___forceinline] = ACTIONS(3270),
    [anon_sym_thread_local] = ACTIONS(3270),
    [anon_sym___thread] = ACTIONS(3270),
    [anon_sym_const] = ACTIONS(3270),
    [anon_sym_constexpr] = ACTIONS(3270),
    [anon_sym_volatile] = ACTIONS(3270),
    [anon_sym_restrict] = ACTIONS(3270),
    [anon_sym___restrict__] = ACTIONS(3270),
    [anon_sym__Atomic] = ACTIONS(3270),
    [anon_sym__Noreturn] = ACTIONS(3270),
    [anon_sym_noreturn] = ACTIONS(3270),
    [anon_sym_mutable] = ACTIONS(3270),
    [anon_sym_constinit] = ACTIONS(3270),
    [anon_sym_consteval] = ACTIONS(3270),
    [anon_sym_PROGMEM] = ACTIONS(3270),
    [aux_sym_primitive_type_token1] = ACTIONS(3270),
    [anon_sym_byte] = ACTIONS(3270),
    [anon_sym_word] = ACTIONS(3270),
    [anon_sym_enum] = ACTIONS(3270),
    [anon_sym_class] = ACTIONS(3270),
    [anon_sym_struct] = ACTIONS(3270),
    [anon_sym_union] = ACTIONS(3270),
    [anon_sym_if] = ACTIONS(3270),
    [anon_sym_switch] = ACTIONS(3270),
    [anon_sym_case] = ACTIONS(3270),
    [anon_sym_default] = ACTIONS(3270),
    [anon_sym_while] = ACTIONS(3270),
    [anon_sym_do] = ACTIONS(3270),
    [anon_sym_for] = ACTIONS(3270),
    [anon_sym_return] = ACTIONS(3270),
    [anon_sym_break] = ACTIONS(3270),
    [anon_sym_continue] = ACTIONS(3270),
    [anon_sym_goto] = ACTIONS(3270),
    [anon_sym___try] = ACTIONS(3270),
    [anon_sym___leave] = ACTIONS(3270),
    [anon_sym_not] = ACTIONS(3270),
    [anon_sym_compl] = ACTIONS(3270),
    [anon_sym_DASH_DASH] = ACTIONS(3272),
    [anon_sym_PLUS_PLUS] = ACTIONS(3272),
    [anon_sym_sizeof] = ACTIONS(3270),
    [anon_sym___alignof__] = ACTIONS(3270),
    [anon_sym___alignof] = ACTIONS(3270),
    [anon_sym__alignof] = ACTIONS(3270),
    [anon_sym_alignof] = ACTIONS(3270),
    [anon_sym__Alignof] = ACTIONS(3270),
    [anon_sym_offsetof] = ACTIONS(3270),
    [anon_sym__Generic] = ACTIONS(3270),
    [anon_sym_asm] = ACTIONS(3270),
    [anon_sym___asm__] = ACTIONS(3270),
    [aux_sym_number_literal_token1] = ACTIONS(3272),
    [aux_sym_number_literal_token2] = ACTIONS(3270),
    [anon_sym_L_SQUOTE] = ACTIONS(3272),
    [anon_sym_u_SQUOTE] = ACTIONS(3272),
    [anon_sym_U_SQUOTE] = ACTIONS(3272),
    [anon_sym_u8_SQUOTE] = ACTIONS(3272),
    [anon_sym_SQUOTE] = ACTIONS(3272),
    [anon_sym_L_DQUOTE] = ACTIONS(3272),
    [anon_sym_u_DQUOTE] = ACTIONS(3272),
    [anon_sym_U_DQUOTE] = ACTIONS(3272),
    [anon_sym_u8_DQUOTE] = ACTIONS(3272),
    [anon_sym_DQUOTE] = ACTIONS(3272),
    [sym_true] = ACTIONS(3270),
    [sym_false] = ACTIONS(3270),
    [anon_sym_NULL] = ACTIONS(3270),
    [anon_sym_nullptr] = ACTIONS(3270),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3270),
    [anon_sym_decltype] = ACTIONS(3270),
    [anon_sym_virtual] = ACTIONS(3270),
    [anon_sym_alignas] = ACTIONS(3270),
    [anon_sym_explicit] = ACTIONS(3270),
    [anon_sym_typename] = ACTIONS(3270),
    [anon_sym_template] = ACTIONS(3270),
    [anon_sym_operator] = ACTIONS(3270),
    [anon_sym_try] = ACTIONS(3270),
    [anon_sym_delete] = ACTIONS(3270),
    [anon_sym_throw] = ACTIONS(3270),
    [anon_sym_namespace] = ACTIONS(3270),
    [anon_sym_using] = ACTIONS(3270),
    [anon_sym_static_assert] = ACTIONS(3270),
    [anon_sym_concept] = ACTIONS(3270),
    [anon_sym_co_return] = ACTIONS(3270),
    [anon_sym_co_yield] = ACTIONS(3270),
    [anon_sym_R_DQUOTE] = ACTIONS(3272),
    [anon_sym_LR_DQUOTE] = ACTIONS(3272),
    [anon_sym_uR_DQUOTE] = ACTIONS(3272),
    [anon_sym_UR_DQUOTE] = ACTIONS(3272),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3272),
    [anon_sym_co_await] = ACTIONS(3270),
    [anon_sym_new] = ACTIONS(3270),
    [anon_sym_requires] = ACTIONS(3270),
    [sym_this] = ACTIONS(3270),
  },
  [588] = {
    [sym_identifier] = ACTIONS(3403),
    [aux_sym_preproc_include_token1] = ACTIONS(3403),
    [aux_sym_preproc_def_token1] = ACTIONS(3403),
    [aux_sym_preproc_if_token1] = ACTIONS(3403),
    [aux_sym_preproc_if_token2] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3403),
    [aux_sym_preproc_else_token1] = ACTIONS(3403),
    [aux_sym_preproc_elif_token1] = ACTIONS(3403),
    [sym_preproc_directive] = ACTIONS(3403),
    [anon_sym_LPAREN2] = ACTIONS(3405),
    [anon_sym_BANG] = ACTIONS(3405),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_DASH] = ACTIONS(3403),
    [anon_sym_PLUS] = ACTIONS(3403),
    [anon_sym_STAR] = ACTIONS(3405),
    [anon_sym_AMP_AMP] = ACTIONS(3405),
    [anon_sym_AMP] = ACTIONS(3403),
    [anon_sym_SEMI] = ACTIONS(3405),
    [anon_sym___extension__] = ACTIONS(3403),
    [anon_sym_typedef] = ACTIONS(3403),
    [anon_sym_extern] = ACTIONS(3403),
    [anon_sym___attribute__] = ACTIONS(3403),
    [anon_sym_COLON_COLON] = ACTIONS(3405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3405),
    [anon_sym___declspec] = ACTIONS(3403),
    [anon_sym___based] = ACTIONS(3403),
    [anon_sym___cdecl] = ACTIONS(3403),
    [anon_sym___clrcall] = ACTIONS(3403),
    [anon_sym___stdcall] = ACTIONS(3403),
    [anon_sym___fastcall] = ACTIONS(3403),
    [anon_sym___thiscall] = ACTIONS(3403),
    [anon_sym___vectorcall] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3405),
    [anon_sym_signed] = ACTIONS(3403),
    [anon_sym_unsigned] = ACTIONS(3403),
    [anon_sym_long] = ACTIONS(3403),
    [anon_sym_short] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3403),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_register] = ACTIONS(3403),
    [anon_sym_inline] = ACTIONS(3403),
    [anon_sym___inline] = ACTIONS(3403),
    [anon_sym___inline__] = ACTIONS(3403),
    [anon_sym___forceinline] = ACTIONS(3403),
    [anon_sym_thread_local] = ACTIONS(3403),
    [anon_sym___thread] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_constexpr] = ACTIONS(3403),
    [anon_sym_volatile] = ACTIONS(3403),
    [anon_sym_restrict] = ACTIONS(3403),
    [anon_sym___restrict__] = ACTIONS(3403),
    [anon_sym__Atomic] = ACTIONS(3403),
    [anon_sym__Noreturn] = ACTIONS(3403),
    [anon_sym_noreturn] = ACTIONS(3403),
    [anon_sym_mutable] = ACTIONS(3403),
    [anon_sym_constinit] = ACTIONS(3403),
    [anon_sym_consteval] = ACTIONS(3403),
    [anon_sym_PROGMEM] = ACTIONS(3403),
    [aux_sym_primitive_type_token1] = ACTIONS(3403),
    [anon_sym_byte] = ACTIONS(3403),
    [anon_sym_word] = ACTIONS(3403),
    [anon_sym_enum] = ACTIONS(3403),
    [anon_sym_class] = ACTIONS(3403),
    [anon_sym_struct] = ACTIONS(3403),
    [anon_sym_union] = ACTIONS(3403),
    [anon_sym_if] = ACTIONS(3403),
    [anon_sym_switch] = ACTIONS(3403),
    [anon_sym_case] = ACTIONS(3403),
    [anon_sym_default] = ACTIONS(3403),
    [anon_sym_while] = ACTIONS(3403),
    [anon_sym_do] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3403),
    [anon_sym_return] = ACTIONS(3403),
    [anon_sym_break] = ACTIONS(3403),
    [anon_sym_continue] = ACTIONS(3403),
    [anon_sym_goto] = ACTIONS(3403),
    [anon_sym___try] = ACTIONS(3403),
    [anon_sym___leave] = ACTIONS(3403),
    [anon_sym_not] = ACTIONS(3403),
    [anon_sym_compl] = ACTIONS(3403),
    [anon_sym_DASH_DASH] = ACTIONS(3405),
    [anon_sym_PLUS_PLUS] = ACTIONS(3405),
    [anon_sym_sizeof] = ACTIONS(3403),
    [anon_sym___alignof__] = ACTIONS(3403),
    [anon_sym___alignof] = ACTIONS(3403),
    [anon_sym__alignof] = ACTIONS(3403),
    [anon_sym_alignof] = ACTIONS(3403),
    [anon_sym__Alignof] = ACTIONS(3403),
    [anon_sym_offsetof] = ACTIONS(3403),
    [anon_sym__Generic] = ACTIONS(3403),
    [anon_sym_asm] = ACTIONS(3403),
    [anon_sym___asm__] = ACTIONS(3403),
    [aux_sym_number_literal_token1] = ACTIONS(3405),
    [aux_sym_number_literal_token2] = ACTIONS(3403),
    [anon_sym_L_SQUOTE] = ACTIONS(3405),
    [anon_sym_u_SQUOTE] = ACTIONS(3405),
    [anon_sym_U_SQUOTE] = ACTIONS(3405),
    [anon_sym_u8_SQUOTE] = ACTIONS(3405),
    [anon_sym_SQUOTE] = ACTIONS(3405),
    [anon_sym_L_DQUOTE] = ACTIONS(3405),
    [anon_sym_u_DQUOTE] = ACTIONS(3405),
    [anon_sym_U_DQUOTE] = ACTIONS(3405),
    [anon_sym_u8_DQUOTE] = ACTIONS(3405),
    [anon_sym_DQUOTE] = ACTIONS(3405),
    [sym_true] = ACTIONS(3403),
    [sym_false] = ACTIONS(3403),
    [anon_sym_NULL] = ACTIONS(3403),
    [anon_sym_nullptr] = ACTIONS(3403),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3403),
    [anon_sym_decltype] = ACTIONS(3403),
    [anon_sym_virtual] = ACTIONS(3403),
    [anon_sym_alignas] = ACTIONS(3403),
    [anon_sym_explicit] = ACTIONS(3403),
    [anon_sym_typename] = ACTIONS(3403),
    [anon_sym_template] = ACTIONS(3403),
    [anon_sym_operator] = ACTIONS(3403),
    [anon_sym_try] = ACTIONS(3403),
    [anon_sym_delete] = ACTIONS(3403),
    [anon_sym_throw] = ACTIONS(3403),
    [anon_sym_namespace] = ACTIONS(3403),
    [anon_sym_using] = ACTIONS(3403),
    [anon_sym_static_assert] = ACTIONS(3403),
    [anon_sym_concept] = ACTIONS(3403),
    [anon_sym_co_return] = ACTIONS(3403),
    [anon_sym_co_yield] = ACTIONS(3403),
    [anon_sym_R_DQUOTE] = ACTIONS(3405),
    [anon_sym_LR_DQUOTE] = ACTIONS(3405),
    [anon_sym_uR_DQUOTE] = ACTIONS(3405),
    [anon_sym_UR_DQUOTE] = ACTIONS(3405),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3405),
    [anon_sym_co_await] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3403),
    [anon_sym_requires] = ACTIONS(3403),
    [sym_this] = ACTIONS(3403),
  },
  [589] = {
    [sym_identifier] = ACTIONS(3276),
    [aux_sym_preproc_include_token1] = ACTIONS(3276),
    [aux_sym_preproc_def_token1] = ACTIONS(3276),
    [aux_sym_preproc_if_token1] = ACTIONS(3276),
    [aux_sym_preproc_if_token2] = ACTIONS(3276),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3276),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3276),
    [aux_sym_preproc_else_token1] = ACTIONS(3276),
    [aux_sym_preproc_elif_token1] = ACTIONS(3276),
    [sym_preproc_directive] = ACTIONS(3276),
    [anon_sym_LPAREN2] = ACTIONS(3278),
    [anon_sym_BANG] = ACTIONS(3278),
    [anon_sym_TILDE] = ACTIONS(3278),
    [anon_sym_DASH] = ACTIONS(3276),
    [anon_sym_PLUS] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3278),
    [anon_sym_AMP_AMP] = ACTIONS(3278),
    [anon_sym_AMP] = ACTIONS(3276),
    [anon_sym_SEMI] = ACTIONS(3278),
    [anon_sym___extension__] = ACTIONS(3276),
    [anon_sym_typedef] = ACTIONS(3276),
    [anon_sym_extern] = ACTIONS(3276),
    [anon_sym___attribute__] = ACTIONS(3276),
    [anon_sym_COLON_COLON] = ACTIONS(3278),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3278),
    [anon_sym___declspec] = ACTIONS(3276),
    [anon_sym___based] = ACTIONS(3276),
    [anon_sym___cdecl] = ACTIONS(3276),
    [anon_sym___clrcall] = ACTIONS(3276),
    [anon_sym___stdcall] = ACTIONS(3276),
    [anon_sym___fastcall] = ACTIONS(3276),
    [anon_sym___thiscall] = ACTIONS(3276),
    [anon_sym___vectorcall] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3278),
    [anon_sym_signed] = ACTIONS(3276),
    [anon_sym_unsigned] = ACTIONS(3276),
    [anon_sym_long] = ACTIONS(3276),
    [anon_sym_short] = ACTIONS(3276),
    [anon_sym_LBRACK] = ACTIONS(3276),
    [anon_sym_static] = ACTIONS(3276),
    [anon_sym_register] = ACTIONS(3276),
    [anon_sym_inline] = ACTIONS(3276),
    [anon_sym___inline] = ACTIONS(3276),
    [anon_sym___inline__] = ACTIONS(3276),
    [anon_sym___forceinline] = ACTIONS(3276),
    [anon_sym_thread_local] = ACTIONS(3276),
    [anon_sym___thread] = ACTIONS(3276),
    [anon_sym_const] = ACTIONS(3276),
    [anon_sym_constexpr] = ACTIONS(3276),
    [anon_sym_volatile] = ACTIONS(3276),
    [anon_sym_restrict] = ACTIONS(3276),
    [anon_sym___restrict__] = ACTIONS(3276),
    [anon_sym__Atomic] = ACTIONS(3276),
    [anon_sym__Noreturn] = ACTIONS(3276),
    [anon_sym_noreturn] = ACTIONS(3276),
    [anon_sym_mutable] = ACTIONS(3276),
    [anon_sym_constinit] = ACTIONS(3276),
    [anon_sym_consteval] = ACTIONS(3276),
    [anon_sym_PROGMEM] = ACTIONS(3276),
    [aux_sym_primitive_type_token1] = ACTIONS(3276),
    [anon_sym_byte] = ACTIONS(3276),
    [anon_sym_word] = ACTIONS(3276),
    [anon_sym_enum] = ACTIONS(3276),
    [anon_sym_class] = ACTIONS(3276),
    [anon_sym_struct] = ACTIONS(3276),
    [anon_sym_union] = ACTIONS(3276),
    [anon_sym_if] = ACTIONS(3276),
    [anon_sym_switch] = ACTIONS(3276),
    [anon_sym_case] = ACTIONS(3276),
    [anon_sym_default] = ACTIONS(3276),
    [anon_sym_while] = ACTIONS(3276),
    [anon_sym_do] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3276),
    [anon_sym_return] = ACTIONS(3276),
    [anon_sym_break] = ACTIONS(3276),
    [anon_sym_continue] = ACTIONS(3276),
    [anon_sym_goto] = ACTIONS(3276),
    [anon_sym___try] = ACTIONS(3276),
    [anon_sym___leave] = ACTIONS(3276),
    [anon_sym_not] = ACTIONS(3276),
    [anon_sym_compl] = ACTIONS(3276),
    [anon_sym_DASH_DASH] = ACTIONS(3278),
    [anon_sym_PLUS_PLUS] = ACTIONS(3278),
    [anon_sym_sizeof] = ACTIONS(3276),
    [anon_sym___alignof__] = ACTIONS(3276),
    [anon_sym___alignof] = ACTIONS(3276),
    [anon_sym__alignof] = ACTIONS(3276),
    [anon_sym_alignof] = ACTIONS(3276),
    [anon_sym__Alignof] = ACTIONS(3276),
    [anon_sym_offsetof] = ACTIONS(3276),
    [anon_sym__Generic] = ACTIONS(3276),
    [anon_sym_asm] = ACTIONS(3276),
    [anon_sym___asm__] = ACTIONS(3276),
    [aux_sym_number_literal_token1] = ACTIONS(3278),
    [aux_sym_number_literal_token2] = ACTIONS(3276),
    [anon_sym_L_SQUOTE] = ACTIONS(3278),
    [anon_sym_u_SQUOTE] = ACTIONS(3278),
    [anon_sym_U_SQUOTE] = ACTIONS(3278),
    [anon_sym_u8_SQUOTE] = ACTIONS(3278),
    [anon_sym_SQUOTE] = ACTIONS(3278),
    [anon_sym_L_DQUOTE] = ACTIONS(3278),
    [anon_sym_u_DQUOTE] = ACTIONS(3278),
    [anon_sym_U_DQUOTE] = ACTIONS(3278),
    [anon_sym_u8_DQUOTE] = ACTIONS(3278),
    [anon_sym_DQUOTE] = ACTIONS(3278),
    [sym_true] = ACTIONS(3276),
    [sym_false] = ACTIONS(3276),
    [anon_sym_NULL] = ACTIONS(3276),
    [anon_sym_nullptr] = ACTIONS(3276),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3276),
    [anon_sym_decltype] = ACTIONS(3276),
    [anon_sym_virtual] = ACTIONS(3276),
    [anon_sym_alignas] = ACTIONS(3276),
    [anon_sym_explicit] = ACTIONS(3276),
    [anon_sym_typename] = ACTIONS(3276),
    [anon_sym_template] = ACTIONS(3276),
    [anon_sym_operator] = ACTIONS(3276),
    [anon_sym_try] = ACTIONS(3276),
    [anon_sym_delete] = ACTIONS(3276),
    [anon_sym_throw] = ACTIONS(3276),
    [anon_sym_namespace] = ACTIONS(3276),
    [anon_sym_using] = ACTIONS(3276),
    [anon_sym_static_assert] = ACTIONS(3276),
    [anon_sym_concept] = ACTIONS(3276),
    [anon_sym_co_return] = ACTIONS(3276),
    [anon_sym_co_yield] = ACTIONS(3276),
    [anon_sym_R_DQUOTE] = ACTIONS(3278),
    [anon_sym_LR_DQUOTE] = ACTIONS(3278),
    [anon_sym_uR_DQUOTE] = ACTIONS(3278),
    [anon_sym_UR_DQUOTE] = ACTIONS(3278),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3278),
    [anon_sym_co_await] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3276),
    [anon_sym_requires] = ACTIONS(3276),
    [sym_this] = ACTIONS(3276),
  },
  [590] = {
    [sym_identifier] = ACTIONS(3423),
    [aux_sym_preproc_include_token1] = ACTIONS(3423),
    [aux_sym_preproc_def_token1] = ACTIONS(3423),
    [aux_sym_preproc_if_token1] = ACTIONS(3423),
    [aux_sym_preproc_if_token2] = ACTIONS(3423),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3423),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3423),
    [aux_sym_preproc_else_token1] = ACTIONS(3423),
    [aux_sym_preproc_elif_token1] = ACTIONS(3423),
    [sym_preproc_directive] = ACTIONS(3423),
    [anon_sym_LPAREN2] = ACTIONS(3425),
    [anon_sym_BANG] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [anon_sym_DASH] = ACTIONS(3423),
    [anon_sym_PLUS] = ACTIONS(3423),
    [anon_sym_STAR] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3425),
    [anon_sym___extension__] = ACTIONS(3423),
    [anon_sym_typedef] = ACTIONS(3423),
    [anon_sym_extern] = ACTIONS(3423),
    [anon_sym___attribute__] = ACTIONS(3423),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3425),
    [anon_sym___declspec] = ACTIONS(3423),
    [anon_sym___based] = ACTIONS(3423),
    [anon_sym___cdecl] = ACTIONS(3423),
    [anon_sym___clrcall] = ACTIONS(3423),
    [anon_sym___stdcall] = ACTIONS(3423),
    [anon_sym___fastcall] = ACTIONS(3423),
    [anon_sym___thiscall] = ACTIONS(3423),
    [anon_sym___vectorcall] = ACTIONS(3423),
    [anon_sym_LBRACE] = ACTIONS(3425),
    [anon_sym_signed] = ACTIONS(3423),
    [anon_sym_unsigned] = ACTIONS(3423),
    [anon_sym_long] = ACTIONS(3423),
    [anon_sym_short] = ACTIONS(3423),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_static] = ACTIONS(3423),
    [anon_sym_register] = ACTIONS(3423),
    [anon_sym_inline] = ACTIONS(3423),
    [anon_sym___inline] = ACTIONS(3423),
    [anon_sym___inline__] = ACTIONS(3423),
    [anon_sym___forceinline] = ACTIONS(3423),
    [anon_sym_thread_local] = ACTIONS(3423),
    [anon_sym___thread] = ACTIONS(3423),
    [anon_sym_const] = ACTIONS(3423),
    [anon_sym_constexpr] = ACTIONS(3423),
    [anon_sym_volatile] = ACTIONS(3423),
    [anon_sym_restrict] = ACTIONS(3423),
    [anon_sym___restrict__] = ACTIONS(3423),
    [anon_sym__Atomic] = ACTIONS(3423),
    [anon_sym__Noreturn] = ACTIONS(3423),
    [anon_sym_noreturn] = ACTIONS(3423),
    [anon_sym_mutable] = ACTIONS(3423),
    [anon_sym_constinit] = ACTIONS(3423),
    [anon_sym_consteval] = ACTIONS(3423),
    [anon_sym_PROGMEM] = ACTIONS(3423),
    [aux_sym_primitive_type_token1] = ACTIONS(3423),
    [anon_sym_byte] = ACTIONS(3423),
    [anon_sym_word] = ACTIONS(3423),
    [anon_sym_enum] = ACTIONS(3423),
    [anon_sym_class] = ACTIONS(3423),
    [anon_sym_struct] = ACTIONS(3423),
    [anon_sym_union] = ACTIONS(3423),
    [anon_sym_if] = ACTIONS(3423),
    [anon_sym_switch] = ACTIONS(3423),
    [anon_sym_case] = ACTIONS(3423),
    [anon_sym_default] = ACTIONS(3423),
    [anon_sym_while] = ACTIONS(3423),
    [anon_sym_do] = ACTIONS(3423),
    [anon_sym_for] = ACTIONS(3423),
    [anon_sym_return] = ACTIONS(3423),
    [anon_sym_break] = ACTIONS(3423),
    [anon_sym_continue] = ACTIONS(3423),
    [anon_sym_goto] = ACTIONS(3423),
    [anon_sym___try] = ACTIONS(3423),
    [anon_sym___leave] = ACTIONS(3423),
    [anon_sym_not] = ACTIONS(3423),
    [anon_sym_compl] = ACTIONS(3423),
    [anon_sym_DASH_DASH] = ACTIONS(3425),
    [anon_sym_PLUS_PLUS] = ACTIONS(3425),
    [anon_sym_sizeof] = ACTIONS(3423),
    [anon_sym___alignof__] = ACTIONS(3423),
    [anon_sym___alignof] = ACTIONS(3423),
    [anon_sym__alignof] = ACTIONS(3423),
    [anon_sym_alignof] = ACTIONS(3423),
    [anon_sym__Alignof] = ACTIONS(3423),
    [anon_sym_offsetof] = ACTIONS(3423),
    [anon_sym__Generic] = ACTIONS(3423),
    [anon_sym_asm] = ACTIONS(3423),
    [anon_sym___asm__] = ACTIONS(3423),
    [aux_sym_number_literal_token1] = ACTIONS(3425),
    [aux_sym_number_literal_token2] = ACTIONS(3423),
    [anon_sym_L_SQUOTE] = ACTIONS(3425),
    [anon_sym_u_SQUOTE] = ACTIONS(3425),
    [anon_sym_U_SQUOTE] = ACTIONS(3425),
    [anon_sym_u8_SQUOTE] = ACTIONS(3425),
    [anon_sym_SQUOTE] = ACTIONS(3425),
    [anon_sym_L_DQUOTE] = ACTIONS(3425),
    [anon_sym_u_DQUOTE] = ACTIONS(3425),
    [anon_sym_U_DQUOTE] = ACTIONS(3425),
    [anon_sym_u8_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [sym_true] = ACTIONS(3423),
    [sym_false] = ACTIONS(3423),
    [anon_sym_NULL] = ACTIONS(3423),
    [anon_sym_nullptr] = ACTIONS(3423),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3423),
    [anon_sym_decltype] = ACTIONS(3423),
    [anon_sym_virtual] = ACTIONS(3423),
    [anon_sym_alignas] = ACTIONS(3423),
    [anon_sym_explicit] = ACTIONS(3423),
    [anon_sym_typename] = ACTIONS(3423),
    [anon_sym_template] = ACTIONS(3423),
    [anon_sym_operator] = ACTIONS(3423),
    [anon_sym_try] = ACTIONS(3423),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_throw] = ACTIONS(3423),
    [anon_sym_namespace] = ACTIONS(3423),
    [anon_sym_using] = ACTIONS(3423),
    [anon_sym_static_assert] = ACTIONS(3423),
    [anon_sym_concept] = ACTIONS(3423),
    [anon_sym_co_return] = ACTIONS(3423),
    [anon_sym_co_yield] = ACTIONS(3423),
    [anon_sym_R_DQUOTE] = ACTIONS(3425),
    [anon_sym_LR_DQUOTE] = ACTIONS(3425),
    [anon_sym_uR_DQUOTE] = ACTIONS(3425),
    [anon_sym_UR_DQUOTE] = ACTIONS(3425),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3425),
    [anon_sym_co_await] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3423),
    [anon_sym_requires] = ACTIONS(3423),
    [sym_this] = ACTIONS(3423),
  },
  [591] = {
    [sym_else_clause] = STATE(695),
    [sym_identifier] = ACTIONS(2918),
    [aux_sym_preproc_include_token1] = ACTIONS(2918),
    [aux_sym_preproc_def_token1] = ACTIONS(2918),
    [aux_sym_preproc_if_token1] = ACTIONS(2918),
    [aux_sym_preproc_if_token2] = ACTIONS(2918),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2918),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2918),
    [sym_preproc_directive] = ACTIONS(2918),
    [anon_sym_LPAREN2] = ACTIONS(2920),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2920),
    [anon_sym_DASH] = ACTIONS(2918),
    [anon_sym_PLUS] = ACTIONS(2918),
    [anon_sym_STAR] = ACTIONS(2920),
    [anon_sym_AMP_AMP] = ACTIONS(2920),
    [anon_sym_AMP] = ACTIONS(2918),
    [anon_sym_SEMI] = ACTIONS(2920),
    [anon_sym___extension__] = ACTIONS(2918),
    [anon_sym_typedef] = ACTIONS(2918),
    [anon_sym_extern] = ACTIONS(2918),
    [anon_sym___attribute__] = ACTIONS(2918),
    [anon_sym_COLON_COLON] = ACTIONS(2920),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2920),
    [anon_sym___declspec] = ACTIONS(2918),
    [anon_sym___based] = ACTIONS(2918),
    [anon_sym___cdecl] = ACTIONS(2918),
    [anon_sym___clrcall] = ACTIONS(2918),
    [anon_sym___stdcall] = ACTIONS(2918),
    [anon_sym___fastcall] = ACTIONS(2918),
    [anon_sym___thiscall] = ACTIONS(2918),
    [anon_sym___vectorcall] = ACTIONS(2918),
    [anon_sym_LBRACE] = ACTIONS(2920),
    [anon_sym_signed] = ACTIONS(2918),
    [anon_sym_unsigned] = ACTIONS(2918),
    [anon_sym_long] = ACTIONS(2918),
    [anon_sym_short] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(2918),
    [anon_sym_static] = ACTIONS(2918),
    [anon_sym_register] = ACTIONS(2918),
    [anon_sym_inline] = ACTIONS(2918),
    [anon_sym___inline] = ACTIONS(2918),
    [anon_sym___inline__] = ACTIONS(2918),
    [anon_sym___forceinline] = ACTIONS(2918),
    [anon_sym_thread_local] = ACTIONS(2918),
    [anon_sym___thread] = ACTIONS(2918),
    [anon_sym_const] = ACTIONS(2918),
    [anon_sym_constexpr] = ACTIONS(2918),
    [anon_sym_volatile] = ACTIONS(2918),
    [anon_sym_restrict] = ACTIONS(2918),
    [anon_sym___restrict__] = ACTIONS(2918),
    [anon_sym__Atomic] = ACTIONS(2918),
    [anon_sym__Noreturn] = ACTIONS(2918),
    [anon_sym_noreturn] = ACTIONS(2918),
    [anon_sym_mutable] = ACTIONS(2918),
    [anon_sym_constinit] = ACTIONS(2918),
    [anon_sym_consteval] = ACTIONS(2918),
    [anon_sym_PROGMEM] = ACTIONS(2918),
    [aux_sym_primitive_type_token1] = ACTIONS(2918),
    [anon_sym_byte] = ACTIONS(2918),
    [anon_sym_word] = ACTIONS(2918),
    [anon_sym_enum] = ACTIONS(2918),
    [anon_sym_class] = ACTIONS(2918),
    [anon_sym_struct] = ACTIONS(2918),
    [anon_sym_union] = ACTIONS(2918),
    [anon_sym_if] = ACTIONS(2918),
    [anon_sym_else] = ACTIONS(3529),
    [anon_sym_switch] = ACTIONS(2918),
    [anon_sym_case] = ACTIONS(2918),
    [anon_sym_default] = ACTIONS(2918),
    [anon_sym_while] = ACTIONS(2918),
    [anon_sym_do] = ACTIONS(2918),
    [anon_sym_for] = ACTIONS(2918),
    [anon_sym_return] = ACTIONS(2918),
    [anon_sym_break] = ACTIONS(2918),
    [anon_sym_continue] = ACTIONS(2918),
    [anon_sym_goto] = ACTIONS(2918),
    [anon_sym___try] = ACTIONS(2918),
    [anon_sym___leave] = ACTIONS(2918),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_compl] = ACTIONS(2918),
    [anon_sym_DASH_DASH] = ACTIONS(2920),
    [anon_sym_PLUS_PLUS] = ACTIONS(2920),
    [anon_sym_sizeof] = ACTIONS(2918),
    [anon_sym___alignof__] = ACTIONS(2918),
    [anon_sym___alignof] = ACTIONS(2918),
    [anon_sym__alignof] = ACTIONS(2918),
    [anon_sym_alignof] = ACTIONS(2918),
    [anon_sym__Alignof] = ACTIONS(2918),
    [anon_sym_offsetof] = ACTIONS(2918),
    [anon_sym__Generic] = ACTIONS(2918),
    [anon_sym_asm] = ACTIONS(2918),
    [anon_sym___asm__] = ACTIONS(2918),
    [aux_sym_number_literal_token1] = ACTIONS(2920),
    [aux_sym_number_literal_token2] = ACTIONS(2918),
    [anon_sym_L_SQUOTE] = ACTIONS(2920),
    [anon_sym_u_SQUOTE] = ACTIONS(2920),
    [anon_sym_U_SQUOTE] = ACTIONS(2920),
    [anon_sym_u8_SQUOTE] = ACTIONS(2920),
    [anon_sym_SQUOTE] = ACTIONS(2920),
    [anon_sym_L_DQUOTE] = ACTIONS(2920),
    [anon_sym_u_DQUOTE] = ACTIONS(2920),
    [anon_sym_U_DQUOTE] = ACTIONS(2920),
    [anon_sym_u8_DQUOTE] = ACTIONS(2920),
    [anon_sym_DQUOTE] = ACTIONS(2920),
    [sym_true] = ACTIONS(2918),
    [sym_false] = ACTIONS(2918),
    [anon_sym_NULL] = ACTIONS(2918),
    [anon_sym_nullptr] = ACTIONS(2918),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2918),
    [anon_sym_decltype] = ACTIONS(2918),
    [anon_sym_virtual] = ACTIONS(2918),
    [anon_sym_alignas] = ACTIONS(2918),
    [anon_sym_explicit] = ACTIONS(2918),
    [anon_sym_typename] = ACTIONS(2918),
    [anon_sym_template] = ACTIONS(2918),
    [anon_sym_operator] = ACTIONS(2918),
    [anon_sym_try] = ACTIONS(2918),
    [anon_sym_delete] = ACTIONS(2918),
    [anon_sym_throw] = ACTIONS(2918),
    [anon_sym_namespace] = ACTIONS(2918),
    [anon_sym_using] = ACTIONS(2918),
    [anon_sym_static_assert] = ACTIONS(2918),
    [anon_sym_concept] = ACTIONS(2918),
    [anon_sym_co_return] = ACTIONS(2918),
    [anon_sym_co_yield] = ACTIONS(2918),
    [anon_sym_R_DQUOTE] = ACTIONS(2920),
    [anon_sym_LR_DQUOTE] = ACTIONS(2920),
    [anon_sym_uR_DQUOTE] = ACTIONS(2920),
    [anon_sym_UR_DQUOTE] = ACTIONS(2920),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2920),
    [anon_sym_co_await] = ACTIONS(2918),
    [anon_sym_new] = ACTIONS(2918),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2918),
  },
  [592] = {
    [sym_identifier] = ACTIONS(3186),
    [aux_sym_preproc_include_token1] = ACTIONS(3186),
    [aux_sym_preproc_def_token1] = ACTIONS(3186),
    [aux_sym_preproc_if_token1] = ACTIONS(3186),
    [aux_sym_preproc_if_token2] = ACTIONS(3186),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3186),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3186),
    [aux_sym_preproc_else_token1] = ACTIONS(3186),
    [aux_sym_preproc_elif_token1] = ACTIONS(3186),
    [sym_preproc_directive] = ACTIONS(3186),
    [anon_sym_LPAREN2] = ACTIONS(3188),
    [anon_sym_BANG] = ACTIONS(3188),
    [anon_sym_TILDE] = ACTIONS(3188),
    [anon_sym_DASH] = ACTIONS(3186),
    [anon_sym_PLUS] = ACTIONS(3186),
    [anon_sym_STAR] = ACTIONS(3188),
    [anon_sym_AMP_AMP] = ACTIONS(3188),
    [anon_sym_AMP] = ACTIONS(3186),
    [anon_sym_SEMI] = ACTIONS(3188),
    [anon_sym___extension__] = ACTIONS(3186),
    [anon_sym_typedef] = ACTIONS(3186),
    [anon_sym_extern] = ACTIONS(3186),
    [anon_sym___attribute__] = ACTIONS(3186),
    [anon_sym_COLON_COLON] = ACTIONS(3188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3188),
    [anon_sym___declspec] = ACTIONS(3186),
    [anon_sym___based] = ACTIONS(3186),
    [anon_sym___cdecl] = ACTIONS(3186),
    [anon_sym___clrcall] = ACTIONS(3186),
    [anon_sym___stdcall] = ACTIONS(3186),
    [anon_sym___fastcall] = ACTIONS(3186),
    [anon_sym___thiscall] = ACTIONS(3186),
    [anon_sym___vectorcall] = ACTIONS(3186),
    [anon_sym_LBRACE] = ACTIONS(3188),
    [anon_sym_signed] = ACTIONS(3186),
    [anon_sym_unsigned] = ACTIONS(3186),
    [anon_sym_long] = ACTIONS(3186),
    [anon_sym_short] = ACTIONS(3186),
    [anon_sym_LBRACK] = ACTIONS(3186),
    [anon_sym_static] = ACTIONS(3186),
    [anon_sym_register] = ACTIONS(3186),
    [anon_sym_inline] = ACTIONS(3186),
    [anon_sym___inline] = ACTIONS(3186),
    [anon_sym___inline__] = ACTIONS(3186),
    [anon_sym___forceinline] = ACTIONS(3186),
    [anon_sym_thread_local] = ACTIONS(3186),
    [anon_sym___thread] = ACTIONS(3186),
    [anon_sym_const] = ACTIONS(3186),
    [anon_sym_constexpr] = ACTIONS(3186),
    [anon_sym_volatile] = ACTIONS(3186),
    [anon_sym_restrict] = ACTIONS(3186),
    [anon_sym___restrict__] = ACTIONS(3186),
    [anon_sym__Atomic] = ACTIONS(3186),
    [anon_sym__Noreturn] = ACTIONS(3186),
    [anon_sym_noreturn] = ACTIONS(3186),
    [anon_sym_mutable] = ACTIONS(3186),
    [anon_sym_constinit] = ACTIONS(3186),
    [anon_sym_consteval] = ACTIONS(3186),
    [anon_sym_PROGMEM] = ACTIONS(3186),
    [aux_sym_primitive_type_token1] = ACTIONS(3186),
    [anon_sym_byte] = ACTIONS(3186),
    [anon_sym_word] = ACTIONS(3186),
    [anon_sym_enum] = ACTIONS(3186),
    [anon_sym_class] = ACTIONS(3186),
    [anon_sym_struct] = ACTIONS(3186),
    [anon_sym_union] = ACTIONS(3186),
    [anon_sym_if] = ACTIONS(3186),
    [anon_sym_switch] = ACTIONS(3186),
    [anon_sym_case] = ACTIONS(3186),
    [anon_sym_default] = ACTIONS(3186),
    [anon_sym_while] = ACTIONS(3186),
    [anon_sym_do] = ACTIONS(3186),
    [anon_sym_for] = ACTIONS(3186),
    [anon_sym_return] = ACTIONS(3186),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_continue] = ACTIONS(3186),
    [anon_sym_goto] = ACTIONS(3186),
    [anon_sym___try] = ACTIONS(3186),
    [anon_sym___leave] = ACTIONS(3186),
    [anon_sym_not] = ACTIONS(3186),
    [anon_sym_compl] = ACTIONS(3186),
    [anon_sym_DASH_DASH] = ACTIONS(3188),
    [anon_sym_PLUS_PLUS] = ACTIONS(3188),
    [anon_sym_sizeof] = ACTIONS(3186),
    [anon_sym___alignof__] = ACTIONS(3186),
    [anon_sym___alignof] = ACTIONS(3186),
    [anon_sym__alignof] = ACTIONS(3186),
    [anon_sym_alignof] = ACTIONS(3186),
    [anon_sym__Alignof] = ACTIONS(3186),
    [anon_sym_offsetof] = ACTIONS(3186),
    [anon_sym__Generic] = ACTIONS(3186),
    [anon_sym_asm] = ACTIONS(3186),
    [anon_sym___asm__] = ACTIONS(3186),
    [aux_sym_number_literal_token1] = ACTIONS(3188),
    [aux_sym_number_literal_token2] = ACTIONS(3186),
    [anon_sym_L_SQUOTE] = ACTIONS(3188),
    [anon_sym_u_SQUOTE] = ACTIONS(3188),
    [anon_sym_U_SQUOTE] = ACTIONS(3188),
    [anon_sym_u8_SQUOTE] = ACTIONS(3188),
    [anon_sym_SQUOTE] = ACTIONS(3188),
    [anon_sym_L_DQUOTE] = ACTIONS(3188),
    [anon_sym_u_DQUOTE] = ACTIONS(3188),
    [anon_sym_U_DQUOTE] = ACTIONS(3188),
    [anon_sym_u8_DQUOTE] = ACTIONS(3188),
    [anon_sym_DQUOTE] = ACTIONS(3188),
    [sym_true] = ACTIONS(3186),
    [sym_false] = ACTIONS(3186),
    [anon_sym_NULL] = ACTIONS(3186),
    [anon_sym_nullptr] = ACTIONS(3186),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3186),
    [anon_sym_decltype] = ACTIONS(3186),
    [anon_sym_virtual] = ACTIONS(3186),
    [anon_sym_alignas] = ACTIONS(3186),
    [anon_sym_explicit] = ACTIONS(3186),
    [anon_sym_typename] = ACTIONS(3186),
    [anon_sym_template] = ACTIONS(3186),
    [anon_sym_operator] = ACTIONS(3186),
    [anon_sym_try] = ACTIONS(3186),
    [anon_sym_delete] = ACTIONS(3186),
    [anon_sym_throw] = ACTIONS(3186),
    [anon_sym_namespace] = ACTIONS(3186),
    [anon_sym_using] = ACTIONS(3186),
    [anon_sym_static_assert] = ACTIONS(3186),
    [anon_sym_concept] = ACTIONS(3186),
    [anon_sym_co_return] = ACTIONS(3186),
    [anon_sym_co_yield] = ACTIONS(3186),
    [anon_sym_R_DQUOTE] = ACTIONS(3188),
    [anon_sym_LR_DQUOTE] = ACTIONS(3188),
    [anon_sym_uR_DQUOTE] = ACTIONS(3188),
    [anon_sym_UR_DQUOTE] = ACTIONS(3188),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3188),
    [anon_sym_co_await] = ACTIONS(3186),
    [anon_sym_new] = ACTIONS(3186),
    [anon_sym_requires] = ACTIONS(3186),
    [sym_this] = ACTIONS(3186),
  },
  [593] = {
    [sym_identifier] = ACTIONS(3435),
    [aux_sym_preproc_include_token1] = ACTIONS(3435),
    [aux_sym_preproc_def_token1] = ACTIONS(3435),
    [aux_sym_preproc_if_token1] = ACTIONS(3435),
    [aux_sym_preproc_if_token2] = ACTIONS(3435),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3435),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3435),
    [aux_sym_preproc_else_token1] = ACTIONS(3435),
    [aux_sym_preproc_elif_token1] = ACTIONS(3435),
    [sym_preproc_directive] = ACTIONS(3435),
    [anon_sym_LPAREN2] = ACTIONS(3437),
    [anon_sym_BANG] = ACTIONS(3437),
    [anon_sym_TILDE] = ACTIONS(3437),
    [anon_sym_DASH] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3435),
    [anon_sym_STAR] = ACTIONS(3437),
    [anon_sym_AMP_AMP] = ACTIONS(3437),
    [anon_sym_AMP] = ACTIONS(3435),
    [anon_sym_SEMI] = ACTIONS(3437),
    [anon_sym___extension__] = ACTIONS(3435),
    [anon_sym_typedef] = ACTIONS(3435),
    [anon_sym_extern] = ACTIONS(3435),
    [anon_sym___attribute__] = ACTIONS(3435),
    [anon_sym_COLON_COLON] = ACTIONS(3437),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3437),
    [anon_sym___declspec] = ACTIONS(3435),
    [anon_sym___based] = ACTIONS(3435),
    [anon_sym___cdecl] = ACTIONS(3435),
    [anon_sym___clrcall] = ACTIONS(3435),
    [anon_sym___stdcall] = ACTIONS(3435),
    [anon_sym___fastcall] = ACTIONS(3435),
    [anon_sym___thiscall] = ACTIONS(3435),
    [anon_sym___vectorcall] = ACTIONS(3435),
    [anon_sym_LBRACE] = ACTIONS(3437),
    [anon_sym_signed] = ACTIONS(3435),
    [anon_sym_unsigned] = ACTIONS(3435),
    [anon_sym_long] = ACTIONS(3435),
    [anon_sym_short] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3435),
    [anon_sym_static] = ACTIONS(3435),
    [anon_sym_register] = ACTIONS(3435),
    [anon_sym_inline] = ACTIONS(3435),
    [anon_sym___inline] = ACTIONS(3435),
    [anon_sym___inline__] = ACTIONS(3435),
    [anon_sym___forceinline] = ACTIONS(3435),
    [anon_sym_thread_local] = ACTIONS(3435),
    [anon_sym___thread] = ACTIONS(3435),
    [anon_sym_const] = ACTIONS(3435),
    [anon_sym_constexpr] = ACTIONS(3435),
    [anon_sym_volatile] = ACTIONS(3435),
    [anon_sym_restrict] = ACTIONS(3435),
    [anon_sym___restrict__] = ACTIONS(3435),
    [anon_sym__Atomic] = ACTIONS(3435),
    [anon_sym__Noreturn] = ACTIONS(3435),
    [anon_sym_noreturn] = ACTIONS(3435),
    [anon_sym_mutable] = ACTIONS(3435),
    [anon_sym_constinit] = ACTIONS(3435),
    [anon_sym_consteval] = ACTIONS(3435),
    [anon_sym_PROGMEM] = ACTIONS(3435),
    [aux_sym_primitive_type_token1] = ACTIONS(3435),
    [anon_sym_byte] = ACTIONS(3435),
    [anon_sym_word] = ACTIONS(3435),
    [anon_sym_enum] = ACTIONS(3435),
    [anon_sym_class] = ACTIONS(3435),
    [anon_sym_struct] = ACTIONS(3435),
    [anon_sym_union] = ACTIONS(3435),
    [anon_sym_if] = ACTIONS(3435),
    [anon_sym_switch] = ACTIONS(3435),
    [anon_sym_case] = ACTIONS(3435),
    [anon_sym_default] = ACTIONS(3435),
    [anon_sym_while] = ACTIONS(3435),
    [anon_sym_do] = ACTIONS(3435),
    [anon_sym_for] = ACTIONS(3435),
    [anon_sym_return] = ACTIONS(3435),
    [anon_sym_break] = ACTIONS(3435),
    [anon_sym_continue] = ACTIONS(3435),
    [anon_sym_goto] = ACTIONS(3435),
    [anon_sym___try] = ACTIONS(3435),
    [anon_sym___leave] = ACTIONS(3435),
    [anon_sym_not] = ACTIONS(3435),
    [anon_sym_compl] = ACTIONS(3435),
    [anon_sym_DASH_DASH] = ACTIONS(3437),
    [anon_sym_PLUS_PLUS] = ACTIONS(3437),
    [anon_sym_sizeof] = ACTIONS(3435),
    [anon_sym___alignof__] = ACTIONS(3435),
    [anon_sym___alignof] = ACTIONS(3435),
    [anon_sym__alignof] = ACTIONS(3435),
    [anon_sym_alignof] = ACTIONS(3435),
    [anon_sym__Alignof] = ACTIONS(3435),
    [anon_sym_offsetof] = ACTIONS(3435),
    [anon_sym__Generic] = ACTIONS(3435),
    [anon_sym_asm] = ACTIONS(3435),
    [anon_sym___asm__] = ACTIONS(3435),
    [aux_sym_number_literal_token1] = ACTIONS(3437),
    [aux_sym_number_literal_token2] = ACTIONS(3435),
    [anon_sym_L_SQUOTE] = ACTIONS(3437),
    [anon_sym_u_SQUOTE] = ACTIONS(3437),
    [anon_sym_U_SQUOTE] = ACTIONS(3437),
    [anon_sym_u8_SQUOTE] = ACTIONS(3437),
    [anon_sym_SQUOTE] = ACTIONS(3437),
    [anon_sym_L_DQUOTE] = ACTIONS(3437),
    [anon_sym_u_DQUOTE] = ACTIONS(3437),
    [anon_sym_U_DQUOTE] = ACTIONS(3437),
    [anon_sym_u8_DQUOTE] = ACTIONS(3437),
    [anon_sym_DQUOTE] = ACTIONS(3437),
    [sym_true] = ACTIONS(3435),
    [sym_false] = ACTIONS(3435),
    [anon_sym_NULL] = ACTIONS(3435),
    [anon_sym_nullptr] = ACTIONS(3435),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3435),
    [anon_sym_decltype] = ACTIONS(3435),
    [anon_sym_virtual] = ACTIONS(3435),
    [anon_sym_alignas] = ACTIONS(3435),
    [anon_sym_explicit] = ACTIONS(3435),
    [anon_sym_typename] = ACTIONS(3435),
    [anon_sym_template] = ACTIONS(3435),
    [anon_sym_operator] = ACTIONS(3435),
    [anon_sym_try] = ACTIONS(3435),
    [anon_sym_delete] = ACTIONS(3435),
    [anon_sym_throw] = ACTIONS(3435),
    [anon_sym_namespace] = ACTIONS(3435),
    [anon_sym_using] = ACTIONS(3435),
    [anon_sym_static_assert] = ACTIONS(3435),
    [anon_sym_concept] = ACTIONS(3435),
    [anon_sym_co_return] = ACTIONS(3435),
    [anon_sym_co_yield] = ACTIONS(3435),
    [anon_sym_R_DQUOTE] = ACTIONS(3437),
    [anon_sym_LR_DQUOTE] = ACTIONS(3437),
    [anon_sym_uR_DQUOTE] = ACTIONS(3437),
    [anon_sym_UR_DQUOTE] = ACTIONS(3437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3437),
    [anon_sym_co_await] = ACTIONS(3435),
    [anon_sym_new] = ACTIONS(3435),
    [anon_sym_requires] = ACTIONS(3435),
    [sym_this] = ACTIONS(3435),
  },
  [594] = {
    [sym_identifier] = ACTIONS(3451),
    [aux_sym_preproc_include_token1] = ACTIONS(3451),
    [aux_sym_preproc_def_token1] = ACTIONS(3451),
    [aux_sym_preproc_if_token1] = ACTIONS(3451),
    [aux_sym_preproc_if_token2] = ACTIONS(3451),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3451),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3451),
    [aux_sym_preproc_else_token1] = ACTIONS(3451),
    [aux_sym_preproc_elif_token1] = ACTIONS(3451),
    [sym_preproc_directive] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3453),
    [anon_sym_BANG] = ACTIONS(3453),
    [anon_sym_TILDE] = ACTIONS(3453),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(3453),
    [anon_sym_AMP_AMP] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_SEMI] = ACTIONS(3453),
    [anon_sym___extension__] = ACTIONS(3451),
    [anon_sym_typedef] = ACTIONS(3451),
    [anon_sym_extern] = ACTIONS(3451),
    [anon_sym___attribute__] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3453),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3453),
    [anon_sym___declspec] = ACTIONS(3451),
    [anon_sym___based] = ACTIONS(3451),
    [anon_sym___cdecl] = ACTIONS(3451),
    [anon_sym___clrcall] = ACTIONS(3451),
    [anon_sym___stdcall] = ACTIONS(3451),
    [anon_sym___fastcall] = ACTIONS(3451),
    [anon_sym___thiscall] = ACTIONS(3451),
    [anon_sym___vectorcall] = ACTIONS(3451),
    [anon_sym_LBRACE] = ACTIONS(3453),
    [anon_sym_signed] = ACTIONS(3451),
    [anon_sym_unsigned] = ACTIONS(3451),
    [anon_sym_long] = ACTIONS(3451),
    [anon_sym_short] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_register] = ACTIONS(3451),
    [anon_sym_inline] = ACTIONS(3451),
    [anon_sym___inline] = ACTIONS(3451),
    [anon_sym___inline__] = ACTIONS(3451),
    [anon_sym___forceinline] = ACTIONS(3451),
    [anon_sym_thread_local] = ACTIONS(3451),
    [anon_sym___thread] = ACTIONS(3451),
    [anon_sym_const] = ACTIONS(3451),
    [anon_sym_constexpr] = ACTIONS(3451),
    [anon_sym_volatile] = ACTIONS(3451),
    [anon_sym_restrict] = ACTIONS(3451),
    [anon_sym___restrict__] = ACTIONS(3451),
    [anon_sym__Atomic] = ACTIONS(3451),
    [anon_sym__Noreturn] = ACTIONS(3451),
    [anon_sym_noreturn] = ACTIONS(3451),
    [anon_sym_mutable] = ACTIONS(3451),
    [anon_sym_constinit] = ACTIONS(3451),
    [anon_sym_consteval] = ACTIONS(3451),
    [anon_sym_PROGMEM] = ACTIONS(3451),
    [aux_sym_primitive_type_token1] = ACTIONS(3451),
    [anon_sym_byte] = ACTIONS(3451),
    [anon_sym_word] = ACTIONS(3451),
    [anon_sym_enum] = ACTIONS(3451),
    [anon_sym_class] = ACTIONS(3451),
    [anon_sym_struct] = ACTIONS(3451),
    [anon_sym_union] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_switch] = ACTIONS(3451),
    [anon_sym_case] = ACTIONS(3451),
    [anon_sym_default] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_break] = ACTIONS(3451),
    [anon_sym_continue] = ACTIONS(3451),
    [anon_sym_goto] = ACTIONS(3451),
    [anon_sym___try] = ACTIONS(3451),
    [anon_sym___leave] = ACTIONS(3451),
    [anon_sym_not] = ACTIONS(3451),
    [anon_sym_compl] = ACTIONS(3451),
    [anon_sym_DASH_DASH] = ACTIONS(3453),
    [anon_sym_PLUS_PLUS] = ACTIONS(3453),
    [anon_sym_sizeof] = ACTIONS(3451),
    [anon_sym___alignof__] = ACTIONS(3451),
    [anon_sym___alignof] = ACTIONS(3451),
    [anon_sym__alignof] = ACTIONS(3451),
    [anon_sym_alignof] = ACTIONS(3451),
    [anon_sym__Alignof] = ACTIONS(3451),
    [anon_sym_offsetof] = ACTIONS(3451),
    [anon_sym__Generic] = ACTIONS(3451),
    [anon_sym_asm] = ACTIONS(3451),
    [anon_sym___asm__] = ACTIONS(3451),
    [aux_sym_number_literal_token1] = ACTIONS(3453),
    [aux_sym_number_literal_token2] = ACTIONS(3451),
    [anon_sym_L_SQUOTE] = ACTIONS(3453),
    [anon_sym_u_SQUOTE] = ACTIONS(3453),
    [anon_sym_U_SQUOTE] = ACTIONS(3453),
    [anon_sym_u8_SQUOTE] = ACTIONS(3453),
    [anon_sym_SQUOTE] = ACTIONS(3453),
    [anon_sym_L_DQUOTE] = ACTIONS(3453),
    [anon_sym_u_DQUOTE] = ACTIONS(3453),
    [anon_sym_U_DQUOTE] = ACTIONS(3453),
    [anon_sym_u8_DQUOTE] = ACTIONS(3453),
    [anon_sym_DQUOTE] = ACTIONS(3453),
    [sym_true] = ACTIONS(3451),
    [sym_false] = ACTIONS(3451),
    [anon_sym_NULL] = ACTIONS(3451),
    [anon_sym_nullptr] = ACTIONS(3451),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3451),
    [anon_sym_decltype] = ACTIONS(3451),
    [anon_sym_virtual] = ACTIONS(3451),
    [anon_sym_alignas] = ACTIONS(3451),
    [anon_sym_explicit] = ACTIONS(3451),
    [anon_sym_typename] = ACTIONS(3451),
    [anon_sym_template] = ACTIONS(3451),
    [anon_sym_operator] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_delete] = ACTIONS(3451),
    [anon_sym_throw] = ACTIONS(3451),
    [anon_sym_namespace] = ACTIONS(3451),
    [anon_sym_using] = ACTIONS(3451),
    [anon_sym_static_assert] = ACTIONS(3451),
    [anon_sym_concept] = ACTIONS(3451),
    [anon_sym_co_return] = ACTIONS(3451),
    [anon_sym_co_yield] = ACTIONS(3451),
    [anon_sym_R_DQUOTE] = ACTIONS(3453),
    [anon_sym_LR_DQUOTE] = ACTIONS(3453),
    [anon_sym_uR_DQUOTE] = ACTIONS(3453),
    [anon_sym_UR_DQUOTE] = ACTIONS(3453),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3453),
    [anon_sym_co_await] = ACTIONS(3451),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_requires] = ACTIONS(3451),
    [sym_this] = ACTIONS(3451),
  },
  [595] = {
    [sym_identifier] = ACTIONS(3455),
    [aux_sym_preproc_include_token1] = ACTIONS(3455),
    [aux_sym_preproc_def_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token2] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3455),
    [aux_sym_preproc_else_token1] = ACTIONS(3455),
    [aux_sym_preproc_elif_token1] = ACTIONS(3455),
    [sym_preproc_directive] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_BANG] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_STAR] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_SEMI] = ACTIONS(3457),
    [anon_sym___extension__] = ACTIONS(3455),
    [anon_sym_typedef] = ACTIONS(3455),
    [anon_sym_extern] = ACTIONS(3455),
    [anon_sym___attribute__] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3457),
    [anon_sym___declspec] = ACTIONS(3455),
    [anon_sym___based] = ACTIONS(3455),
    [anon_sym___cdecl] = ACTIONS(3455),
    [anon_sym___clrcall] = ACTIONS(3455),
    [anon_sym___stdcall] = ACTIONS(3455),
    [anon_sym___fastcall] = ACTIONS(3455),
    [anon_sym___thiscall] = ACTIONS(3455),
    [anon_sym___vectorcall] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_signed] = ACTIONS(3455),
    [anon_sym_unsigned] = ACTIONS(3455),
    [anon_sym_long] = ACTIONS(3455),
    [anon_sym_short] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_static] = ACTIONS(3455),
    [anon_sym_register] = ACTIONS(3455),
    [anon_sym_inline] = ACTIONS(3455),
    [anon_sym___inline] = ACTIONS(3455),
    [anon_sym___inline__] = ACTIONS(3455),
    [anon_sym___forceinline] = ACTIONS(3455),
    [anon_sym_thread_local] = ACTIONS(3455),
    [anon_sym___thread] = ACTIONS(3455),
    [anon_sym_const] = ACTIONS(3455),
    [anon_sym_constexpr] = ACTIONS(3455),
    [anon_sym_volatile] = ACTIONS(3455),
    [anon_sym_restrict] = ACTIONS(3455),
    [anon_sym___restrict__] = ACTIONS(3455),
    [anon_sym__Atomic] = ACTIONS(3455),
    [anon_sym__Noreturn] = ACTIONS(3455),
    [anon_sym_noreturn] = ACTIONS(3455),
    [anon_sym_mutable] = ACTIONS(3455),
    [anon_sym_constinit] = ACTIONS(3455),
    [anon_sym_consteval] = ACTIONS(3455),
    [anon_sym_PROGMEM] = ACTIONS(3455),
    [aux_sym_primitive_type_token1] = ACTIONS(3455),
    [anon_sym_byte] = ACTIONS(3455),
    [anon_sym_word] = ACTIONS(3455),
    [anon_sym_enum] = ACTIONS(3455),
    [anon_sym_class] = ACTIONS(3455),
    [anon_sym_struct] = ACTIONS(3455),
    [anon_sym_union] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_switch] = ACTIONS(3455),
    [anon_sym_case] = ACTIONS(3455),
    [anon_sym_default] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_break] = ACTIONS(3455),
    [anon_sym_continue] = ACTIONS(3455),
    [anon_sym_goto] = ACTIONS(3455),
    [anon_sym___try] = ACTIONS(3455),
    [anon_sym___leave] = ACTIONS(3455),
    [anon_sym_not] = ACTIONS(3455),
    [anon_sym_compl] = ACTIONS(3455),
    [anon_sym_DASH_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_PLUS] = ACTIONS(3457),
    [anon_sym_sizeof] = ACTIONS(3455),
    [anon_sym___alignof__] = ACTIONS(3455),
    [anon_sym___alignof] = ACTIONS(3455),
    [anon_sym__alignof] = ACTIONS(3455),
    [anon_sym_alignof] = ACTIONS(3455),
    [anon_sym__Alignof] = ACTIONS(3455),
    [anon_sym_offsetof] = ACTIONS(3455),
    [anon_sym__Generic] = ACTIONS(3455),
    [anon_sym_asm] = ACTIONS(3455),
    [anon_sym___asm__] = ACTIONS(3455),
    [aux_sym_number_literal_token1] = ACTIONS(3457),
    [aux_sym_number_literal_token2] = ACTIONS(3455),
    [anon_sym_L_SQUOTE] = ACTIONS(3457),
    [anon_sym_u_SQUOTE] = ACTIONS(3457),
    [anon_sym_U_SQUOTE] = ACTIONS(3457),
    [anon_sym_u8_SQUOTE] = ACTIONS(3457),
    [anon_sym_SQUOTE] = ACTIONS(3457),
    [anon_sym_L_DQUOTE] = ACTIONS(3457),
    [anon_sym_u_DQUOTE] = ACTIONS(3457),
    [anon_sym_U_DQUOTE] = ACTIONS(3457),
    [anon_sym_u8_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [sym_true] = ACTIONS(3455),
    [sym_false] = ACTIONS(3455),
    [anon_sym_NULL] = ACTIONS(3455),
    [anon_sym_nullptr] = ACTIONS(3455),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3455),
    [anon_sym_decltype] = ACTIONS(3455),
    [anon_sym_virtual] = ACTIONS(3455),
    [anon_sym_alignas] = ACTIONS(3455),
    [anon_sym_explicit] = ACTIONS(3455),
    [anon_sym_typename] = ACTIONS(3455),
    [anon_sym_template] = ACTIONS(3455),
    [anon_sym_operator] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_delete] = ACTIONS(3455),
    [anon_sym_throw] = ACTIONS(3455),
    [anon_sym_namespace] = ACTIONS(3455),
    [anon_sym_using] = ACTIONS(3455),
    [anon_sym_static_assert] = ACTIONS(3455),
    [anon_sym_concept] = ACTIONS(3455),
    [anon_sym_co_return] = ACTIONS(3455),
    [anon_sym_co_yield] = ACTIONS(3455),
    [anon_sym_R_DQUOTE] = ACTIONS(3457),
    [anon_sym_LR_DQUOTE] = ACTIONS(3457),
    [anon_sym_uR_DQUOTE] = ACTIONS(3457),
    [anon_sym_UR_DQUOTE] = ACTIONS(3457),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3457),
    [anon_sym_co_await] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_requires] = ACTIONS(3455),
    [sym_this] = ACTIONS(3455),
  },
  [596] = {
    [sym_identifier] = ACTIONS(3467),
    [aux_sym_preproc_include_token1] = ACTIONS(3467),
    [aux_sym_preproc_def_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token2] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3467),
    [aux_sym_preproc_else_token1] = ACTIONS(3467),
    [aux_sym_preproc_elif_token1] = ACTIONS(3467),
    [sym_preproc_directive] = ACTIONS(3467),
    [anon_sym_LPAREN2] = ACTIONS(3469),
    [anon_sym_BANG] = ACTIONS(3469),
    [anon_sym_TILDE] = ACTIONS(3469),
    [anon_sym_DASH] = ACTIONS(3467),
    [anon_sym_PLUS] = ACTIONS(3467),
    [anon_sym_STAR] = ACTIONS(3469),
    [anon_sym_AMP_AMP] = ACTIONS(3469),
    [anon_sym_AMP] = ACTIONS(3467),
    [anon_sym_SEMI] = ACTIONS(3469),
    [anon_sym___extension__] = ACTIONS(3467),
    [anon_sym_typedef] = ACTIONS(3467),
    [anon_sym_extern] = ACTIONS(3467),
    [anon_sym___attribute__] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(3469),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3469),
    [anon_sym___declspec] = ACTIONS(3467),
    [anon_sym___based] = ACTIONS(3467),
    [anon_sym___cdecl] = ACTIONS(3467),
    [anon_sym___clrcall] = ACTIONS(3467),
    [anon_sym___stdcall] = ACTIONS(3467),
    [anon_sym___fastcall] = ACTIONS(3467),
    [anon_sym___thiscall] = ACTIONS(3467),
    [anon_sym___vectorcall] = ACTIONS(3467),
    [anon_sym_LBRACE] = ACTIONS(3469),
    [anon_sym_signed] = ACTIONS(3467),
    [anon_sym_unsigned] = ACTIONS(3467),
    [anon_sym_long] = ACTIONS(3467),
    [anon_sym_short] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [anon_sym_static] = ACTIONS(3467),
    [anon_sym_register] = ACTIONS(3467),
    [anon_sym_inline] = ACTIONS(3467),
    [anon_sym___inline] = ACTIONS(3467),
    [anon_sym___inline__] = ACTIONS(3467),
    [anon_sym___forceinline] = ACTIONS(3467),
    [anon_sym_thread_local] = ACTIONS(3467),
    [anon_sym___thread] = ACTIONS(3467),
    [anon_sym_const] = ACTIONS(3467),
    [anon_sym_constexpr] = ACTIONS(3467),
    [anon_sym_volatile] = ACTIONS(3467),
    [anon_sym_restrict] = ACTIONS(3467),
    [anon_sym___restrict__] = ACTIONS(3467),
    [anon_sym__Atomic] = ACTIONS(3467),
    [anon_sym__Noreturn] = ACTIONS(3467),
    [anon_sym_noreturn] = ACTIONS(3467),
    [anon_sym_mutable] = ACTIONS(3467),
    [anon_sym_constinit] = ACTIONS(3467),
    [anon_sym_consteval] = ACTIONS(3467),
    [anon_sym_PROGMEM] = ACTIONS(3467),
    [aux_sym_primitive_type_token1] = ACTIONS(3467),
    [anon_sym_byte] = ACTIONS(3467),
    [anon_sym_word] = ACTIONS(3467),
    [anon_sym_enum] = ACTIONS(3467),
    [anon_sym_class] = ACTIONS(3467),
    [anon_sym_struct] = ACTIONS(3467),
    [anon_sym_union] = ACTIONS(3467),
    [anon_sym_if] = ACTIONS(3467),
    [anon_sym_switch] = ACTIONS(3467),
    [anon_sym_case] = ACTIONS(3467),
    [anon_sym_default] = ACTIONS(3467),
    [anon_sym_while] = ACTIONS(3467),
    [anon_sym_do] = ACTIONS(3467),
    [anon_sym_for] = ACTIONS(3467),
    [anon_sym_return] = ACTIONS(3467),
    [anon_sym_break] = ACTIONS(3467),
    [anon_sym_continue] = ACTIONS(3467),
    [anon_sym_goto] = ACTIONS(3467),
    [anon_sym___try] = ACTIONS(3467),
    [anon_sym___leave] = ACTIONS(3467),
    [anon_sym_not] = ACTIONS(3467),
    [anon_sym_compl] = ACTIONS(3467),
    [anon_sym_DASH_DASH] = ACTIONS(3469),
    [anon_sym_PLUS_PLUS] = ACTIONS(3469),
    [anon_sym_sizeof] = ACTIONS(3467),
    [anon_sym___alignof__] = ACTIONS(3467),
    [anon_sym___alignof] = ACTIONS(3467),
    [anon_sym__alignof] = ACTIONS(3467),
    [anon_sym_alignof] = ACTIONS(3467),
    [anon_sym__Alignof] = ACTIONS(3467),
    [anon_sym_offsetof] = ACTIONS(3467),
    [anon_sym__Generic] = ACTIONS(3467),
    [anon_sym_asm] = ACTIONS(3467),
    [anon_sym___asm__] = ACTIONS(3467),
    [aux_sym_number_literal_token1] = ACTIONS(3469),
    [aux_sym_number_literal_token2] = ACTIONS(3467),
    [anon_sym_L_SQUOTE] = ACTIONS(3469),
    [anon_sym_u_SQUOTE] = ACTIONS(3469),
    [anon_sym_U_SQUOTE] = ACTIONS(3469),
    [anon_sym_u8_SQUOTE] = ACTIONS(3469),
    [anon_sym_SQUOTE] = ACTIONS(3469),
    [anon_sym_L_DQUOTE] = ACTIONS(3469),
    [anon_sym_u_DQUOTE] = ACTIONS(3469),
    [anon_sym_U_DQUOTE] = ACTIONS(3469),
    [anon_sym_u8_DQUOTE] = ACTIONS(3469),
    [anon_sym_DQUOTE] = ACTIONS(3469),
    [sym_true] = ACTIONS(3467),
    [sym_false] = ACTIONS(3467),
    [anon_sym_NULL] = ACTIONS(3467),
    [anon_sym_nullptr] = ACTIONS(3467),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3467),
    [anon_sym_decltype] = ACTIONS(3467),
    [anon_sym_virtual] = ACTIONS(3467),
    [anon_sym_alignas] = ACTIONS(3467),
    [anon_sym_explicit] = ACTIONS(3467),
    [anon_sym_typename] = ACTIONS(3467),
    [anon_sym_template] = ACTIONS(3467),
    [anon_sym_operator] = ACTIONS(3467),
    [anon_sym_try] = ACTIONS(3467),
    [anon_sym_delete] = ACTIONS(3467),
    [anon_sym_throw] = ACTIONS(3467),
    [anon_sym_namespace] = ACTIONS(3467),
    [anon_sym_using] = ACTIONS(3467),
    [anon_sym_static_assert] = ACTIONS(3467),
    [anon_sym_concept] = ACTIONS(3467),
    [anon_sym_co_return] = ACTIONS(3467),
    [anon_sym_co_yield] = ACTIONS(3467),
    [anon_sym_R_DQUOTE] = ACTIONS(3469),
    [anon_sym_LR_DQUOTE] = ACTIONS(3469),
    [anon_sym_uR_DQUOTE] = ACTIONS(3469),
    [anon_sym_UR_DQUOTE] = ACTIONS(3469),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3469),
    [anon_sym_co_await] = ACTIONS(3467),
    [anon_sym_new] = ACTIONS(3467),
    [anon_sym_requires] = ACTIONS(3467),
    [sym_this] = ACTIONS(3467),
  },
  [597] = {
    [sym_identifier] = ACTIONS(3471),
    [aux_sym_preproc_include_token1] = ACTIONS(3471),
    [aux_sym_preproc_def_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token2] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3471),
    [aux_sym_preproc_else_token1] = ACTIONS(3471),
    [aux_sym_preproc_elif_token1] = ACTIONS(3471),
    [sym_preproc_directive] = ACTIONS(3471),
    [anon_sym_LPAREN2] = ACTIONS(3473),
    [anon_sym_BANG] = ACTIONS(3473),
    [anon_sym_TILDE] = ACTIONS(3473),
    [anon_sym_DASH] = ACTIONS(3471),
    [anon_sym_PLUS] = ACTIONS(3471),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_AMP_AMP] = ACTIONS(3473),
    [anon_sym_AMP] = ACTIONS(3471),
    [anon_sym_SEMI] = ACTIONS(3473),
    [anon_sym___extension__] = ACTIONS(3471),
    [anon_sym_typedef] = ACTIONS(3471),
    [anon_sym_extern] = ACTIONS(3471),
    [anon_sym___attribute__] = ACTIONS(3471),
    [anon_sym_COLON_COLON] = ACTIONS(3473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3473),
    [anon_sym___declspec] = ACTIONS(3471),
    [anon_sym___based] = ACTIONS(3471),
    [anon_sym___cdecl] = ACTIONS(3471),
    [anon_sym___clrcall] = ACTIONS(3471),
    [anon_sym___stdcall] = ACTIONS(3471),
    [anon_sym___fastcall] = ACTIONS(3471),
    [anon_sym___thiscall] = ACTIONS(3471),
    [anon_sym___vectorcall] = ACTIONS(3471),
    [anon_sym_LBRACE] = ACTIONS(3473),
    [anon_sym_signed] = ACTIONS(3471),
    [anon_sym_unsigned] = ACTIONS(3471),
    [anon_sym_long] = ACTIONS(3471),
    [anon_sym_short] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [anon_sym_static] = ACTIONS(3471),
    [anon_sym_register] = ACTIONS(3471),
    [anon_sym_inline] = ACTIONS(3471),
    [anon_sym___inline] = ACTIONS(3471),
    [anon_sym___inline__] = ACTIONS(3471),
    [anon_sym___forceinline] = ACTIONS(3471),
    [anon_sym_thread_local] = ACTIONS(3471),
    [anon_sym___thread] = ACTIONS(3471),
    [anon_sym_const] = ACTIONS(3471),
    [anon_sym_constexpr] = ACTIONS(3471),
    [anon_sym_volatile] = ACTIONS(3471),
    [anon_sym_restrict] = ACTIONS(3471),
    [anon_sym___restrict__] = ACTIONS(3471),
    [anon_sym__Atomic] = ACTIONS(3471),
    [anon_sym__Noreturn] = ACTIONS(3471),
    [anon_sym_noreturn] = ACTIONS(3471),
    [anon_sym_mutable] = ACTIONS(3471),
    [anon_sym_constinit] = ACTIONS(3471),
    [anon_sym_consteval] = ACTIONS(3471),
    [anon_sym_PROGMEM] = ACTIONS(3471),
    [aux_sym_primitive_type_token1] = ACTIONS(3471),
    [anon_sym_byte] = ACTIONS(3471),
    [anon_sym_word] = ACTIONS(3471),
    [anon_sym_enum] = ACTIONS(3471),
    [anon_sym_class] = ACTIONS(3471),
    [anon_sym_struct] = ACTIONS(3471),
    [anon_sym_union] = ACTIONS(3471),
    [anon_sym_if] = ACTIONS(3471),
    [anon_sym_switch] = ACTIONS(3471),
    [anon_sym_case] = ACTIONS(3471),
    [anon_sym_default] = ACTIONS(3471),
    [anon_sym_while] = ACTIONS(3471),
    [anon_sym_do] = ACTIONS(3471),
    [anon_sym_for] = ACTIONS(3471),
    [anon_sym_return] = ACTIONS(3471),
    [anon_sym_break] = ACTIONS(3471),
    [anon_sym_continue] = ACTIONS(3471),
    [anon_sym_goto] = ACTIONS(3471),
    [anon_sym___try] = ACTIONS(3471),
    [anon_sym___leave] = ACTIONS(3471),
    [anon_sym_not] = ACTIONS(3471),
    [anon_sym_compl] = ACTIONS(3471),
    [anon_sym_DASH_DASH] = ACTIONS(3473),
    [anon_sym_PLUS_PLUS] = ACTIONS(3473),
    [anon_sym_sizeof] = ACTIONS(3471),
    [anon_sym___alignof__] = ACTIONS(3471),
    [anon_sym___alignof] = ACTIONS(3471),
    [anon_sym__alignof] = ACTIONS(3471),
    [anon_sym_alignof] = ACTIONS(3471),
    [anon_sym__Alignof] = ACTIONS(3471),
    [anon_sym_offsetof] = ACTIONS(3471),
    [anon_sym__Generic] = ACTIONS(3471),
    [anon_sym_asm] = ACTIONS(3471),
    [anon_sym___asm__] = ACTIONS(3471),
    [aux_sym_number_literal_token1] = ACTIONS(3473),
    [aux_sym_number_literal_token2] = ACTIONS(3471),
    [anon_sym_L_SQUOTE] = ACTIONS(3473),
    [anon_sym_u_SQUOTE] = ACTIONS(3473),
    [anon_sym_U_SQUOTE] = ACTIONS(3473),
    [anon_sym_u8_SQUOTE] = ACTIONS(3473),
    [anon_sym_SQUOTE] = ACTIONS(3473),
    [anon_sym_L_DQUOTE] = ACTIONS(3473),
    [anon_sym_u_DQUOTE] = ACTIONS(3473),
    [anon_sym_U_DQUOTE] = ACTIONS(3473),
    [anon_sym_u8_DQUOTE] = ACTIONS(3473),
    [anon_sym_DQUOTE] = ACTIONS(3473),
    [sym_true] = ACTIONS(3471),
    [sym_false] = ACTIONS(3471),
    [anon_sym_NULL] = ACTIONS(3471),
    [anon_sym_nullptr] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3471),
    [anon_sym_decltype] = ACTIONS(3471),
    [anon_sym_virtual] = ACTIONS(3471),
    [anon_sym_alignas] = ACTIONS(3471),
    [anon_sym_explicit] = ACTIONS(3471),
    [anon_sym_typename] = ACTIONS(3471),
    [anon_sym_template] = ACTIONS(3471),
    [anon_sym_operator] = ACTIONS(3471),
    [anon_sym_try] = ACTIONS(3471),
    [anon_sym_delete] = ACTIONS(3471),
    [anon_sym_throw] = ACTIONS(3471),
    [anon_sym_namespace] = ACTIONS(3471),
    [anon_sym_using] = ACTIONS(3471),
    [anon_sym_static_assert] = ACTIONS(3471),
    [anon_sym_concept] = ACTIONS(3471),
    [anon_sym_co_return] = ACTIONS(3471),
    [anon_sym_co_yield] = ACTIONS(3471),
    [anon_sym_R_DQUOTE] = ACTIONS(3473),
    [anon_sym_LR_DQUOTE] = ACTIONS(3473),
    [anon_sym_uR_DQUOTE] = ACTIONS(3473),
    [anon_sym_UR_DQUOTE] = ACTIONS(3473),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3473),
    [anon_sym_co_await] = ACTIONS(3471),
    [anon_sym_new] = ACTIONS(3471),
    [anon_sym_requires] = ACTIONS(3471),
    [sym_this] = ACTIONS(3471),
  },
  [598] = {
    [sym_identifier] = ACTIONS(3336),
    [aux_sym_preproc_include_token1] = ACTIONS(3336),
    [aux_sym_preproc_def_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token2] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3336),
    [aux_sym_preproc_else_token1] = ACTIONS(3336),
    [aux_sym_preproc_elif_token1] = ACTIONS(3336),
    [sym_preproc_directive] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_BANG] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_SEMI] = ACTIONS(3338),
    [anon_sym___extension__] = ACTIONS(3336),
    [anon_sym_typedef] = ACTIONS(3336),
    [anon_sym_extern] = ACTIONS(3336),
    [anon_sym___attribute__] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3338),
    [anon_sym___declspec] = ACTIONS(3336),
    [anon_sym___based] = ACTIONS(3336),
    [anon_sym___cdecl] = ACTIONS(3336),
    [anon_sym___clrcall] = ACTIONS(3336),
    [anon_sym___stdcall] = ACTIONS(3336),
    [anon_sym___fastcall] = ACTIONS(3336),
    [anon_sym___thiscall] = ACTIONS(3336),
    [anon_sym___vectorcall] = ACTIONS(3336),
    [anon_sym_LBRACE] = ACTIONS(3338),
    [anon_sym_signed] = ACTIONS(3336),
    [anon_sym_unsigned] = ACTIONS(3336),
    [anon_sym_long] = ACTIONS(3336),
    [anon_sym_short] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_static] = ACTIONS(3336),
    [anon_sym_register] = ACTIONS(3336),
    [anon_sym_inline] = ACTIONS(3336),
    [anon_sym___inline] = ACTIONS(3336),
    [anon_sym___inline__] = ACTIONS(3336),
    [anon_sym___forceinline] = ACTIONS(3336),
    [anon_sym_thread_local] = ACTIONS(3336),
    [anon_sym___thread] = ACTIONS(3336),
    [anon_sym_const] = ACTIONS(3336),
    [anon_sym_constexpr] = ACTIONS(3336),
    [anon_sym_volatile] = ACTIONS(3336),
    [anon_sym_restrict] = ACTIONS(3336),
    [anon_sym___restrict__] = ACTIONS(3336),
    [anon_sym__Atomic] = ACTIONS(3336),
    [anon_sym__Noreturn] = ACTIONS(3336),
    [anon_sym_noreturn] = ACTIONS(3336),
    [anon_sym_mutable] = ACTIONS(3336),
    [anon_sym_constinit] = ACTIONS(3336),
    [anon_sym_consteval] = ACTIONS(3336),
    [anon_sym_PROGMEM] = ACTIONS(3336),
    [aux_sym_primitive_type_token1] = ACTIONS(3336),
    [anon_sym_byte] = ACTIONS(3336),
    [anon_sym_word] = ACTIONS(3336),
    [anon_sym_enum] = ACTIONS(3336),
    [anon_sym_class] = ACTIONS(3336),
    [anon_sym_struct] = ACTIONS(3336),
    [anon_sym_union] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_switch] = ACTIONS(3336),
    [anon_sym_case] = ACTIONS(3336),
    [anon_sym_default] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_break] = ACTIONS(3336),
    [anon_sym_continue] = ACTIONS(3336),
    [anon_sym_goto] = ACTIONS(3336),
    [anon_sym___try] = ACTIONS(3336),
    [anon_sym___leave] = ACTIONS(3336),
    [anon_sym_not] = ACTIONS(3336),
    [anon_sym_compl] = ACTIONS(3336),
    [anon_sym_DASH_DASH] = ACTIONS(3338),
    [anon_sym_PLUS_PLUS] = ACTIONS(3338),
    [anon_sym_sizeof] = ACTIONS(3336),
    [anon_sym___alignof__] = ACTIONS(3336),
    [anon_sym___alignof] = ACTIONS(3336),
    [anon_sym__alignof] = ACTIONS(3336),
    [anon_sym_alignof] = ACTIONS(3336),
    [anon_sym__Alignof] = ACTIONS(3336),
    [anon_sym_offsetof] = ACTIONS(3336),
    [anon_sym__Generic] = ACTIONS(3336),
    [anon_sym_asm] = ACTIONS(3336),
    [anon_sym___asm__] = ACTIONS(3336),
    [aux_sym_number_literal_token1] = ACTIONS(3338),
    [aux_sym_number_literal_token2] = ACTIONS(3336),
    [anon_sym_L_SQUOTE] = ACTIONS(3338),
    [anon_sym_u_SQUOTE] = ACTIONS(3338),
    [anon_sym_U_SQUOTE] = ACTIONS(3338),
    [anon_sym_u8_SQUOTE] = ACTIONS(3338),
    [anon_sym_SQUOTE] = ACTIONS(3338),
    [anon_sym_L_DQUOTE] = ACTIONS(3338),
    [anon_sym_u_DQUOTE] = ACTIONS(3338),
    [anon_sym_U_DQUOTE] = ACTIONS(3338),
    [anon_sym_u8_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE] = ACTIONS(3338),
    [sym_true] = ACTIONS(3336),
    [sym_false] = ACTIONS(3336),
    [anon_sym_NULL] = ACTIONS(3336),
    [anon_sym_nullptr] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3336),
    [anon_sym_decltype] = ACTIONS(3336),
    [anon_sym_virtual] = ACTIONS(3336),
    [anon_sym_alignas] = ACTIONS(3336),
    [anon_sym_explicit] = ACTIONS(3336),
    [anon_sym_typename] = ACTIONS(3336),
    [anon_sym_template] = ACTIONS(3336),
    [anon_sym_operator] = ACTIONS(3336),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_delete] = ACTIONS(3336),
    [anon_sym_throw] = ACTIONS(3336),
    [anon_sym_namespace] = ACTIONS(3336),
    [anon_sym_using] = ACTIONS(3336),
    [anon_sym_static_assert] = ACTIONS(3336),
    [anon_sym_concept] = ACTIONS(3336),
    [anon_sym_co_return] = ACTIONS(3336),
    [anon_sym_co_yield] = ACTIONS(3336),
    [anon_sym_R_DQUOTE] = ACTIONS(3338),
    [anon_sym_LR_DQUOTE] = ACTIONS(3338),
    [anon_sym_uR_DQUOTE] = ACTIONS(3338),
    [anon_sym_UR_DQUOTE] = ACTIONS(3338),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3338),
    [anon_sym_co_await] = ACTIONS(3336),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_requires] = ACTIONS(3336),
    [sym_this] = ACTIONS(3336),
  },
  [599] = {
    [sym_identifier] = ACTIONS(3336),
    [aux_sym_preproc_include_token1] = ACTIONS(3336),
    [aux_sym_preproc_def_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token2] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3336),
    [aux_sym_preproc_else_token1] = ACTIONS(3336),
    [aux_sym_preproc_elif_token1] = ACTIONS(3336),
    [sym_preproc_directive] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_BANG] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_SEMI] = ACTIONS(3338),
    [anon_sym___extension__] = ACTIONS(3336),
    [anon_sym_typedef] = ACTIONS(3336),
    [anon_sym_extern] = ACTIONS(3336),
    [anon_sym___attribute__] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3338),
    [anon_sym___declspec] = ACTIONS(3336),
    [anon_sym___based] = ACTIONS(3336),
    [anon_sym___cdecl] = ACTIONS(3336),
    [anon_sym___clrcall] = ACTIONS(3336),
    [anon_sym___stdcall] = ACTIONS(3336),
    [anon_sym___fastcall] = ACTIONS(3336),
    [anon_sym___thiscall] = ACTIONS(3336),
    [anon_sym___vectorcall] = ACTIONS(3336),
    [anon_sym_LBRACE] = ACTIONS(3338),
    [anon_sym_signed] = ACTIONS(3336),
    [anon_sym_unsigned] = ACTIONS(3336),
    [anon_sym_long] = ACTIONS(3336),
    [anon_sym_short] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_static] = ACTIONS(3336),
    [anon_sym_register] = ACTIONS(3336),
    [anon_sym_inline] = ACTIONS(3336),
    [anon_sym___inline] = ACTIONS(3336),
    [anon_sym___inline__] = ACTIONS(3336),
    [anon_sym___forceinline] = ACTIONS(3336),
    [anon_sym_thread_local] = ACTIONS(3336),
    [anon_sym___thread] = ACTIONS(3336),
    [anon_sym_const] = ACTIONS(3336),
    [anon_sym_constexpr] = ACTIONS(3336),
    [anon_sym_volatile] = ACTIONS(3336),
    [anon_sym_restrict] = ACTIONS(3336),
    [anon_sym___restrict__] = ACTIONS(3336),
    [anon_sym__Atomic] = ACTIONS(3336),
    [anon_sym__Noreturn] = ACTIONS(3336),
    [anon_sym_noreturn] = ACTIONS(3336),
    [anon_sym_mutable] = ACTIONS(3336),
    [anon_sym_constinit] = ACTIONS(3336),
    [anon_sym_consteval] = ACTIONS(3336),
    [anon_sym_PROGMEM] = ACTIONS(3336),
    [aux_sym_primitive_type_token1] = ACTIONS(3336),
    [anon_sym_byte] = ACTIONS(3336),
    [anon_sym_word] = ACTIONS(3336),
    [anon_sym_enum] = ACTIONS(3336),
    [anon_sym_class] = ACTIONS(3336),
    [anon_sym_struct] = ACTIONS(3336),
    [anon_sym_union] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_switch] = ACTIONS(3336),
    [anon_sym_case] = ACTIONS(3336),
    [anon_sym_default] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_break] = ACTIONS(3336),
    [anon_sym_continue] = ACTIONS(3336),
    [anon_sym_goto] = ACTIONS(3336),
    [anon_sym___try] = ACTIONS(3336),
    [anon_sym___leave] = ACTIONS(3336),
    [anon_sym_not] = ACTIONS(3336),
    [anon_sym_compl] = ACTIONS(3336),
    [anon_sym_DASH_DASH] = ACTIONS(3338),
    [anon_sym_PLUS_PLUS] = ACTIONS(3338),
    [anon_sym_sizeof] = ACTIONS(3336),
    [anon_sym___alignof__] = ACTIONS(3336),
    [anon_sym___alignof] = ACTIONS(3336),
    [anon_sym__alignof] = ACTIONS(3336),
    [anon_sym_alignof] = ACTIONS(3336),
    [anon_sym__Alignof] = ACTIONS(3336),
    [anon_sym_offsetof] = ACTIONS(3336),
    [anon_sym__Generic] = ACTIONS(3336),
    [anon_sym_asm] = ACTIONS(3336),
    [anon_sym___asm__] = ACTIONS(3336),
    [aux_sym_number_literal_token1] = ACTIONS(3338),
    [aux_sym_number_literal_token2] = ACTIONS(3336),
    [anon_sym_L_SQUOTE] = ACTIONS(3338),
    [anon_sym_u_SQUOTE] = ACTIONS(3338),
    [anon_sym_U_SQUOTE] = ACTIONS(3338),
    [anon_sym_u8_SQUOTE] = ACTIONS(3338),
    [anon_sym_SQUOTE] = ACTIONS(3338),
    [anon_sym_L_DQUOTE] = ACTIONS(3338),
    [anon_sym_u_DQUOTE] = ACTIONS(3338),
    [anon_sym_U_DQUOTE] = ACTIONS(3338),
    [anon_sym_u8_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE] = ACTIONS(3338),
    [sym_true] = ACTIONS(3336),
    [sym_false] = ACTIONS(3336),
    [anon_sym_NULL] = ACTIONS(3336),
    [anon_sym_nullptr] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3336),
    [anon_sym_decltype] = ACTIONS(3336),
    [anon_sym_virtual] = ACTIONS(3336),
    [anon_sym_alignas] = ACTIONS(3336),
    [anon_sym_explicit] = ACTIONS(3336),
    [anon_sym_typename] = ACTIONS(3336),
    [anon_sym_template] = ACTIONS(3336),
    [anon_sym_operator] = ACTIONS(3336),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_delete] = ACTIONS(3336),
    [anon_sym_throw] = ACTIONS(3336),
    [anon_sym_namespace] = ACTIONS(3336),
    [anon_sym_using] = ACTIONS(3336),
    [anon_sym_static_assert] = ACTIONS(3336),
    [anon_sym_concept] = ACTIONS(3336),
    [anon_sym_co_return] = ACTIONS(3336),
    [anon_sym_co_yield] = ACTIONS(3336),
    [anon_sym_R_DQUOTE] = ACTIONS(3338),
    [anon_sym_LR_DQUOTE] = ACTIONS(3338),
    [anon_sym_uR_DQUOTE] = ACTIONS(3338),
    [anon_sym_UR_DQUOTE] = ACTIONS(3338),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3338),
    [anon_sym_co_await] = ACTIONS(3336),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_requires] = ACTIONS(3336),
    [sym_this] = ACTIONS(3336),
  },
  [600] = {
    [sym_else_clause] = STATE(838),
    [sym_identifier] = ACTIONS(2891),
    [aux_sym_preproc_include_token1] = ACTIONS(2891),
    [aux_sym_preproc_def_token1] = ACTIONS(2891),
    [aux_sym_preproc_if_token1] = ACTIONS(2891),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2891),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2891),
    [sym_preproc_directive] = ACTIONS(2891),
    [anon_sym_LPAREN2] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_AMP_AMP] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym___extension__] = ACTIONS(2891),
    [anon_sym_typedef] = ACTIONS(2891),
    [anon_sym_extern] = ACTIONS(2891),
    [anon_sym___attribute__] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2893),
    [anon_sym___declspec] = ACTIONS(2891),
    [anon_sym___based] = ACTIONS(2891),
    [anon_sym___cdecl] = ACTIONS(2891),
    [anon_sym___clrcall] = ACTIONS(2891),
    [anon_sym___stdcall] = ACTIONS(2891),
    [anon_sym___fastcall] = ACTIONS(2891),
    [anon_sym___thiscall] = ACTIONS(2891),
    [anon_sym___vectorcall] = ACTIONS(2891),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_RBRACE] = ACTIONS(2893),
    [anon_sym_signed] = ACTIONS(2891),
    [anon_sym_unsigned] = ACTIONS(2891),
    [anon_sym_long] = ACTIONS(2891),
    [anon_sym_short] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_static] = ACTIONS(2891),
    [anon_sym_register] = ACTIONS(2891),
    [anon_sym_inline] = ACTIONS(2891),
    [anon_sym___inline] = ACTIONS(2891),
    [anon_sym___inline__] = ACTIONS(2891),
    [anon_sym___forceinline] = ACTIONS(2891),
    [anon_sym_thread_local] = ACTIONS(2891),
    [anon_sym___thread] = ACTIONS(2891),
    [anon_sym_const] = ACTIONS(2891),
    [anon_sym_constexpr] = ACTIONS(2891),
    [anon_sym_volatile] = ACTIONS(2891),
    [anon_sym_restrict] = ACTIONS(2891),
    [anon_sym___restrict__] = ACTIONS(2891),
    [anon_sym__Atomic] = ACTIONS(2891),
    [anon_sym__Noreturn] = ACTIONS(2891),
    [anon_sym_noreturn] = ACTIONS(2891),
    [anon_sym_mutable] = ACTIONS(2891),
    [anon_sym_constinit] = ACTIONS(2891),
    [anon_sym_consteval] = ACTIONS(2891),
    [anon_sym_PROGMEM] = ACTIONS(2891),
    [aux_sym_primitive_type_token1] = ACTIONS(2891),
    [anon_sym_byte] = ACTIONS(2891),
    [anon_sym_word] = ACTIONS(2891),
    [anon_sym_enum] = ACTIONS(2891),
    [anon_sym_class] = ACTIONS(2891),
    [anon_sym_struct] = ACTIONS(2891),
    [anon_sym_union] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_else] = ACTIONS(3531),
    [anon_sym_switch] = ACTIONS(2891),
    [anon_sym_case] = ACTIONS(2891),
    [anon_sym_default] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2891),
    [anon_sym_for] = ACTIONS(2891),
    [anon_sym_return] = ACTIONS(2891),
    [anon_sym_break] = ACTIONS(2891),
    [anon_sym_continue] = ACTIONS(2891),
    [anon_sym_goto] = ACTIONS(2891),
    [anon_sym___try] = ACTIONS(2891),
    [anon_sym___leave] = ACTIONS(2891),
    [anon_sym_not] = ACTIONS(2891),
    [anon_sym_compl] = ACTIONS(2891),
    [anon_sym_DASH_DASH] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2893),
    [anon_sym_sizeof] = ACTIONS(2891),
    [anon_sym___alignof__] = ACTIONS(2891),
    [anon_sym___alignof] = ACTIONS(2891),
    [anon_sym__alignof] = ACTIONS(2891),
    [anon_sym_alignof] = ACTIONS(2891),
    [anon_sym__Alignof] = ACTIONS(2891),
    [anon_sym_offsetof] = ACTIONS(2891),
    [anon_sym__Generic] = ACTIONS(2891),
    [anon_sym_asm] = ACTIONS(2891),
    [anon_sym___asm__] = ACTIONS(2891),
    [aux_sym_number_literal_token1] = ACTIONS(2893),
    [aux_sym_number_literal_token2] = ACTIONS(2891),
    [anon_sym_L_SQUOTE] = ACTIONS(2893),
    [anon_sym_u_SQUOTE] = ACTIONS(2893),
    [anon_sym_U_SQUOTE] = ACTIONS(2893),
    [anon_sym_u8_SQUOTE] = ACTIONS(2893),
    [anon_sym_SQUOTE] = ACTIONS(2893),
    [anon_sym_L_DQUOTE] = ACTIONS(2893),
    [anon_sym_u_DQUOTE] = ACTIONS(2893),
    [anon_sym_U_DQUOTE] = ACTIONS(2893),
    [anon_sym_u8_DQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(2893),
    [sym_true] = ACTIONS(2891),
    [sym_false] = ACTIONS(2891),
    [anon_sym_NULL] = ACTIONS(2891),
    [anon_sym_nullptr] = ACTIONS(2891),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2891),
    [anon_sym_decltype] = ACTIONS(2891),
    [anon_sym_virtual] = ACTIONS(2891),
    [anon_sym_alignas] = ACTIONS(2891),
    [anon_sym_explicit] = ACTIONS(2891),
    [anon_sym_typename] = ACTIONS(2891),
    [anon_sym_template] = ACTIONS(2891),
    [anon_sym_operator] = ACTIONS(2891),
    [anon_sym_try] = ACTIONS(2891),
    [anon_sym_delete] = ACTIONS(2891),
    [anon_sym_throw] = ACTIONS(2891),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_using] = ACTIONS(2891),
    [anon_sym_static_assert] = ACTIONS(2891),
    [anon_sym_concept] = ACTIONS(2891),
    [anon_sym_co_return] = ACTIONS(2891),
    [anon_sym_co_yield] = ACTIONS(2891),
    [anon_sym_R_DQUOTE] = ACTIONS(2893),
    [anon_sym_LR_DQUOTE] = ACTIONS(2893),
    [anon_sym_uR_DQUOTE] = ACTIONS(2893),
    [anon_sym_UR_DQUOTE] = ACTIONS(2893),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2893),
    [anon_sym_co_await] = ACTIONS(2891),
    [anon_sym_new] = ACTIONS(2891),
    [anon_sym_requires] = ACTIONS(2891),
    [sym_this] = ACTIONS(2891),
  },
  [601] = {
    [sym_identifier] = ACTIONS(3517),
    [aux_sym_preproc_include_token1] = ACTIONS(3517),
    [aux_sym_preproc_def_token1] = ACTIONS(3517),
    [aux_sym_preproc_if_token1] = ACTIONS(3517),
    [aux_sym_preproc_if_token2] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3517),
    [aux_sym_preproc_else_token1] = ACTIONS(3517),
    [aux_sym_preproc_elif_token1] = ACTIONS(3517),
    [sym_preproc_directive] = ACTIONS(3517),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_BANG] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3517),
    [anon_sym_PLUS] = ACTIONS(3517),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_SEMI] = ACTIONS(3519),
    [anon_sym___extension__] = ACTIONS(3517),
    [anon_sym_typedef] = ACTIONS(3517),
    [anon_sym_extern] = ACTIONS(3517),
    [anon_sym___attribute__] = ACTIONS(3517),
    [anon_sym_COLON_COLON] = ACTIONS(3519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3519),
    [anon_sym___declspec] = ACTIONS(3517),
    [anon_sym___based] = ACTIONS(3517),
    [anon_sym___cdecl] = ACTIONS(3517),
    [anon_sym___clrcall] = ACTIONS(3517),
    [anon_sym___stdcall] = ACTIONS(3517),
    [anon_sym___fastcall] = ACTIONS(3517),
    [anon_sym___thiscall] = ACTIONS(3517),
    [anon_sym___vectorcall] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_signed] = ACTIONS(3517),
    [anon_sym_unsigned] = ACTIONS(3517),
    [anon_sym_long] = ACTIONS(3517),
    [anon_sym_short] = ACTIONS(3517),
    [anon_sym_LBRACK] = ACTIONS(3517),
    [anon_sym_static] = ACTIONS(3517),
    [anon_sym_register] = ACTIONS(3517),
    [anon_sym_inline] = ACTIONS(3517),
    [anon_sym___inline] = ACTIONS(3517),
    [anon_sym___inline__] = ACTIONS(3517),
    [anon_sym___forceinline] = ACTIONS(3517),
    [anon_sym_thread_local] = ACTIONS(3517),
    [anon_sym___thread] = ACTIONS(3517),
    [anon_sym_const] = ACTIONS(3517),
    [anon_sym_constexpr] = ACTIONS(3517),
    [anon_sym_volatile] = ACTIONS(3517),
    [anon_sym_restrict] = ACTIONS(3517),
    [anon_sym___restrict__] = ACTIONS(3517),
    [anon_sym__Atomic] = ACTIONS(3517),
    [anon_sym__Noreturn] = ACTIONS(3517),
    [anon_sym_noreturn] = ACTIONS(3517),
    [anon_sym_mutable] = ACTIONS(3517),
    [anon_sym_constinit] = ACTIONS(3517),
    [anon_sym_consteval] = ACTIONS(3517),
    [anon_sym_PROGMEM] = ACTIONS(3517),
    [aux_sym_primitive_type_token1] = ACTIONS(3517),
    [anon_sym_byte] = ACTIONS(3517),
    [anon_sym_word] = ACTIONS(3517),
    [anon_sym_enum] = ACTIONS(3517),
    [anon_sym_class] = ACTIONS(3517),
    [anon_sym_struct] = ACTIONS(3517),
    [anon_sym_union] = ACTIONS(3517),
    [anon_sym_if] = ACTIONS(3517),
    [anon_sym_switch] = ACTIONS(3517),
    [anon_sym_case] = ACTIONS(3517),
    [anon_sym_default] = ACTIONS(3517),
    [anon_sym_while] = ACTIONS(3517),
    [anon_sym_do] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3517),
    [anon_sym_return] = ACTIONS(3517),
    [anon_sym_break] = ACTIONS(3517),
    [anon_sym_continue] = ACTIONS(3517),
    [anon_sym_goto] = ACTIONS(3517),
    [anon_sym___try] = ACTIONS(3517),
    [anon_sym___leave] = ACTIONS(3517),
    [anon_sym_not] = ACTIONS(3517),
    [anon_sym_compl] = ACTIONS(3517),
    [anon_sym_DASH_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_PLUS] = ACTIONS(3519),
    [anon_sym_sizeof] = ACTIONS(3517),
    [anon_sym___alignof__] = ACTIONS(3517),
    [anon_sym___alignof] = ACTIONS(3517),
    [anon_sym__alignof] = ACTIONS(3517),
    [anon_sym_alignof] = ACTIONS(3517),
    [anon_sym__Alignof] = ACTIONS(3517),
    [anon_sym_offsetof] = ACTIONS(3517),
    [anon_sym__Generic] = ACTIONS(3517),
    [anon_sym_asm] = ACTIONS(3517),
    [anon_sym___asm__] = ACTIONS(3517),
    [aux_sym_number_literal_token1] = ACTIONS(3519),
    [aux_sym_number_literal_token2] = ACTIONS(3517),
    [anon_sym_L_SQUOTE] = ACTIONS(3519),
    [anon_sym_u_SQUOTE] = ACTIONS(3519),
    [anon_sym_U_SQUOTE] = ACTIONS(3519),
    [anon_sym_u8_SQUOTE] = ACTIONS(3519),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_L_DQUOTE] = ACTIONS(3519),
    [anon_sym_u_DQUOTE] = ACTIONS(3519),
    [anon_sym_U_DQUOTE] = ACTIONS(3519),
    [anon_sym_u8_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [sym_true] = ACTIONS(3517),
    [sym_false] = ACTIONS(3517),
    [anon_sym_NULL] = ACTIONS(3517),
    [anon_sym_nullptr] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3517),
    [anon_sym_decltype] = ACTIONS(3517),
    [anon_sym_virtual] = ACTIONS(3517),
    [anon_sym_alignas] = ACTIONS(3517),
    [anon_sym_explicit] = ACTIONS(3517),
    [anon_sym_typename] = ACTIONS(3517),
    [anon_sym_template] = ACTIONS(3517),
    [anon_sym_operator] = ACTIONS(3517),
    [anon_sym_try] = ACTIONS(3517),
    [anon_sym_delete] = ACTIONS(3517),
    [anon_sym_throw] = ACTIONS(3517),
    [anon_sym_namespace] = ACTIONS(3517),
    [anon_sym_using] = ACTIONS(3517),
    [anon_sym_static_assert] = ACTIONS(3517),
    [anon_sym_concept] = ACTIONS(3517),
    [anon_sym_co_return] = ACTIONS(3517),
    [anon_sym_co_yield] = ACTIONS(3517),
    [anon_sym_R_DQUOTE] = ACTIONS(3519),
    [anon_sym_LR_DQUOTE] = ACTIONS(3519),
    [anon_sym_uR_DQUOTE] = ACTIONS(3519),
    [anon_sym_UR_DQUOTE] = ACTIONS(3519),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3519),
    [anon_sym_co_await] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3517),
    [anon_sym_requires] = ACTIONS(3517),
    [sym_this] = ACTIONS(3517),
  },
  [602] = {
    [sym_identifier] = ACTIONS(3475),
    [aux_sym_preproc_include_token1] = ACTIONS(3475),
    [aux_sym_preproc_def_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token2] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3475),
    [aux_sym_preproc_else_token1] = ACTIONS(3475),
    [aux_sym_preproc_elif_token1] = ACTIONS(3475),
    [sym_preproc_directive] = ACTIONS(3475),
    [anon_sym_LPAREN2] = ACTIONS(3477),
    [anon_sym_BANG] = ACTIONS(3477),
    [anon_sym_TILDE] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3475),
    [anon_sym_PLUS] = ACTIONS(3475),
    [anon_sym_STAR] = ACTIONS(3477),
    [anon_sym_AMP_AMP] = ACTIONS(3477),
    [anon_sym_AMP] = ACTIONS(3475),
    [anon_sym_SEMI] = ACTIONS(3477),
    [anon_sym___extension__] = ACTIONS(3475),
    [anon_sym_typedef] = ACTIONS(3475),
    [anon_sym_extern] = ACTIONS(3475),
    [anon_sym___attribute__] = ACTIONS(3475),
    [anon_sym_COLON_COLON] = ACTIONS(3477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3477),
    [anon_sym___declspec] = ACTIONS(3475),
    [anon_sym___based] = ACTIONS(3475),
    [anon_sym___cdecl] = ACTIONS(3475),
    [anon_sym___clrcall] = ACTIONS(3475),
    [anon_sym___stdcall] = ACTIONS(3475),
    [anon_sym___fastcall] = ACTIONS(3475),
    [anon_sym___thiscall] = ACTIONS(3475),
    [anon_sym___vectorcall] = ACTIONS(3475),
    [anon_sym_LBRACE] = ACTIONS(3477),
    [anon_sym_signed] = ACTIONS(3475),
    [anon_sym_unsigned] = ACTIONS(3475),
    [anon_sym_long] = ACTIONS(3475),
    [anon_sym_short] = ACTIONS(3475),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [anon_sym_static] = ACTIONS(3475),
    [anon_sym_register] = ACTIONS(3475),
    [anon_sym_inline] = ACTIONS(3475),
    [anon_sym___inline] = ACTIONS(3475),
    [anon_sym___inline__] = ACTIONS(3475),
    [anon_sym___forceinline] = ACTIONS(3475),
    [anon_sym_thread_local] = ACTIONS(3475),
    [anon_sym___thread] = ACTIONS(3475),
    [anon_sym_const] = ACTIONS(3475),
    [anon_sym_constexpr] = ACTIONS(3475),
    [anon_sym_volatile] = ACTIONS(3475),
    [anon_sym_restrict] = ACTIONS(3475),
    [anon_sym___restrict__] = ACTIONS(3475),
    [anon_sym__Atomic] = ACTIONS(3475),
    [anon_sym__Noreturn] = ACTIONS(3475),
    [anon_sym_noreturn] = ACTIONS(3475),
    [anon_sym_mutable] = ACTIONS(3475),
    [anon_sym_constinit] = ACTIONS(3475),
    [anon_sym_consteval] = ACTIONS(3475),
    [anon_sym_PROGMEM] = ACTIONS(3475),
    [aux_sym_primitive_type_token1] = ACTIONS(3475),
    [anon_sym_byte] = ACTIONS(3475),
    [anon_sym_word] = ACTIONS(3475),
    [anon_sym_enum] = ACTIONS(3475),
    [anon_sym_class] = ACTIONS(3475),
    [anon_sym_struct] = ACTIONS(3475),
    [anon_sym_union] = ACTIONS(3475),
    [anon_sym_if] = ACTIONS(3475),
    [anon_sym_switch] = ACTIONS(3475),
    [anon_sym_case] = ACTIONS(3475),
    [anon_sym_default] = ACTIONS(3475),
    [anon_sym_while] = ACTIONS(3475),
    [anon_sym_do] = ACTIONS(3475),
    [anon_sym_for] = ACTIONS(3475),
    [anon_sym_return] = ACTIONS(3475),
    [anon_sym_break] = ACTIONS(3475),
    [anon_sym_continue] = ACTIONS(3475),
    [anon_sym_goto] = ACTIONS(3475),
    [anon_sym___try] = ACTIONS(3475),
    [anon_sym___leave] = ACTIONS(3475),
    [anon_sym_not] = ACTIONS(3475),
    [anon_sym_compl] = ACTIONS(3475),
    [anon_sym_DASH_DASH] = ACTIONS(3477),
    [anon_sym_PLUS_PLUS] = ACTIONS(3477),
    [anon_sym_sizeof] = ACTIONS(3475),
    [anon_sym___alignof__] = ACTIONS(3475),
    [anon_sym___alignof] = ACTIONS(3475),
    [anon_sym__alignof] = ACTIONS(3475),
    [anon_sym_alignof] = ACTIONS(3475),
    [anon_sym__Alignof] = ACTIONS(3475),
    [anon_sym_offsetof] = ACTIONS(3475),
    [anon_sym__Generic] = ACTIONS(3475),
    [anon_sym_asm] = ACTIONS(3475),
    [anon_sym___asm__] = ACTIONS(3475),
    [aux_sym_number_literal_token1] = ACTIONS(3477),
    [aux_sym_number_literal_token2] = ACTIONS(3475),
    [anon_sym_L_SQUOTE] = ACTIONS(3477),
    [anon_sym_u_SQUOTE] = ACTIONS(3477),
    [anon_sym_U_SQUOTE] = ACTIONS(3477),
    [anon_sym_u8_SQUOTE] = ACTIONS(3477),
    [anon_sym_SQUOTE] = ACTIONS(3477),
    [anon_sym_L_DQUOTE] = ACTIONS(3477),
    [anon_sym_u_DQUOTE] = ACTIONS(3477),
    [anon_sym_U_DQUOTE] = ACTIONS(3477),
    [anon_sym_u8_DQUOTE] = ACTIONS(3477),
    [anon_sym_DQUOTE] = ACTIONS(3477),
    [sym_true] = ACTIONS(3475),
    [sym_false] = ACTIONS(3475),
    [anon_sym_NULL] = ACTIONS(3475),
    [anon_sym_nullptr] = ACTIONS(3475),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3475),
    [anon_sym_decltype] = ACTIONS(3475),
    [anon_sym_virtual] = ACTIONS(3475),
    [anon_sym_alignas] = ACTIONS(3475),
    [anon_sym_explicit] = ACTIONS(3475),
    [anon_sym_typename] = ACTIONS(3475),
    [anon_sym_template] = ACTIONS(3475),
    [anon_sym_operator] = ACTIONS(3475),
    [anon_sym_try] = ACTIONS(3475),
    [anon_sym_delete] = ACTIONS(3475),
    [anon_sym_throw] = ACTIONS(3475),
    [anon_sym_namespace] = ACTIONS(3475),
    [anon_sym_using] = ACTIONS(3475),
    [anon_sym_static_assert] = ACTIONS(3475),
    [anon_sym_concept] = ACTIONS(3475),
    [anon_sym_co_return] = ACTIONS(3475),
    [anon_sym_co_yield] = ACTIONS(3475),
    [anon_sym_R_DQUOTE] = ACTIONS(3477),
    [anon_sym_LR_DQUOTE] = ACTIONS(3477),
    [anon_sym_uR_DQUOTE] = ACTIONS(3477),
    [anon_sym_UR_DQUOTE] = ACTIONS(3477),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3477),
    [anon_sym_co_await] = ACTIONS(3475),
    [anon_sym_new] = ACTIONS(3475),
    [anon_sym_requires] = ACTIONS(3475),
    [sym_this] = ACTIONS(3475),
  },
  [603] = {
    [sym_identifier] = ACTIONS(3371),
    [aux_sym_preproc_include_token1] = ACTIONS(3371),
    [aux_sym_preproc_def_token1] = ACTIONS(3371),
    [aux_sym_preproc_if_token1] = ACTIONS(3371),
    [aux_sym_preproc_if_token2] = ACTIONS(3371),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3371),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3371),
    [aux_sym_preproc_else_token1] = ACTIONS(3371),
    [aux_sym_preproc_elif_token1] = ACTIONS(3371),
    [sym_preproc_directive] = ACTIONS(3371),
    [anon_sym_LPAREN2] = ACTIONS(3373),
    [anon_sym_BANG] = ACTIONS(3373),
    [anon_sym_TILDE] = ACTIONS(3373),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_STAR] = ACTIONS(3373),
    [anon_sym_AMP_AMP] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3371),
    [anon_sym_SEMI] = ACTIONS(3373),
    [anon_sym___extension__] = ACTIONS(3371),
    [anon_sym_typedef] = ACTIONS(3371),
    [anon_sym_extern] = ACTIONS(3371),
    [anon_sym___attribute__] = ACTIONS(3371),
    [anon_sym_COLON_COLON] = ACTIONS(3373),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3373),
    [anon_sym___declspec] = ACTIONS(3371),
    [anon_sym___based] = ACTIONS(3371),
    [anon_sym___cdecl] = ACTIONS(3371),
    [anon_sym___clrcall] = ACTIONS(3371),
    [anon_sym___stdcall] = ACTIONS(3371),
    [anon_sym___fastcall] = ACTIONS(3371),
    [anon_sym___thiscall] = ACTIONS(3371),
    [anon_sym___vectorcall] = ACTIONS(3371),
    [anon_sym_LBRACE] = ACTIONS(3373),
    [anon_sym_signed] = ACTIONS(3371),
    [anon_sym_unsigned] = ACTIONS(3371),
    [anon_sym_long] = ACTIONS(3371),
    [anon_sym_short] = ACTIONS(3371),
    [anon_sym_LBRACK] = ACTIONS(3371),
    [anon_sym_static] = ACTIONS(3371),
    [anon_sym_register] = ACTIONS(3371),
    [anon_sym_inline] = ACTIONS(3371),
    [anon_sym___inline] = ACTIONS(3371),
    [anon_sym___inline__] = ACTIONS(3371),
    [anon_sym___forceinline] = ACTIONS(3371),
    [anon_sym_thread_local] = ACTIONS(3371),
    [anon_sym___thread] = ACTIONS(3371),
    [anon_sym_const] = ACTIONS(3371),
    [anon_sym_constexpr] = ACTIONS(3371),
    [anon_sym_volatile] = ACTIONS(3371),
    [anon_sym_restrict] = ACTIONS(3371),
    [anon_sym___restrict__] = ACTIONS(3371),
    [anon_sym__Atomic] = ACTIONS(3371),
    [anon_sym__Noreturn] = ACTIONS(3371),
    [anon_sym_noreturn] = ACTIONS(3371),
    [anon_sym_mutable] = ACTIONS(3371),
    [anon_sym_constinit] = ACTIONS(3371),
    [anon_sym_consteval] = ACTIONS(3371),
    [anon_sym_PROGMEM] = ACTIONS(3371),
    [aux_sym_primitive_type_token1] = ACTIONS(3371),
    [anon_sym_byte] = ACTIONS(3371),
    [anon_sym_word] = ACTIONS(3371),
    [anon_sym_enum] = ACTIONS(3371),
    [anon_sym_class] = ACTIONS(3371),
    [anon_sym_struct] = ACTIONS(3371),
    [anon_sym_union] = ACTIONS(3371),
    [anon_sym_if] = ACTIONS(3371),
    [anon_sym_switch] = ACTIONS(3371),
    [anon_sym_case] = ACTIONS(3371),
    [anon_sym_default] = ACTIONS(3371),
    [anon_sym_while] = ACTIONS(3371),
    [anon_sym_do] = ACTIONS(3371),
    [anon_sym_for] = ACTIONS(3371),
    [anon_sym_return] = ACTIONS(3371),
    [anon_sym_break] = ACTIONS(3371),
    [anon_sym_continue] = ACTIONS(3371),
    [anon_sym_goto] = ACTIONS(3371),
    [anon_sym___try] = ACTIONS(3371),
    [anon_sym___leave] = ACTIONS(3371),
    [anon_sym_not] = ACTIONS(3371),
    [anon_sym_compl] = ACTIONS(3371),
    [anon_sym_DASH_DASH] = ACTIONS(3373),
    [anon_sym_PLUS_PLUS] = ACTIONS(3373),
    [anon_sym_sizeof] = ACTIONS(3371),
    [anon_sym___alignof__] = ACTIONS(3371),
    [anon_sym___alignof] = ACTIONS(3371),
    [anon_sym__alignof] = ACTIONS(3371),
    [anon_sym_alignof] = ACTIONS(3371),
    [anon_sym__Alignof] = ACTIONS(3371),
    [anon_sym_offsetof] = ACTIONS(3371),
    [anon_sym__Generic] = ACTIONS(3371),
    [anon_sym_asm] = ACTIONS(3371),
    [anon_sym___asm__] = ACTIONS(3371),
    [aux_sym_number_literal_token1] = ACTIONS(3373),
    [aux_sym_number_literal_token2] = ACTIONS(3371),
    [anon_sym_L_SQUOTE] = ACTIONS(3373),
    [anon_sym_u_SQUOTE] = ACTIONS(3373),
    [anon_sym_U_SQUOTE] = ACTIONS(3373),
    [anon_sym_u8_SQUOTE] = ACTIONS(3373),
    [anon_sym_SQUOTE] = ACTIONS(3373),
    [anon_sym_L_DQUOTE] = ACTIONS(3373),
    [anon_sym_u_DQUOTE] = ACTIONS(3373),
    [anon_sym_U_DQUOTE] = ACTIONS(3373),
    [anon_sym_u8_DQUOTE] = ACTIONS(3373),
    [anon_sym_DQUOTE] = ACTIONS(3373),
    [sym_true] = ACTIONS(3371),
    [sym_false] = ACTIONS(3371),
    [anon_sym_NULL] = ACTIONS(3371),
    [anon_sym_nullptr] = ACTIONS(3371),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3371),
    [anon_sym_decltype] = ACTIONS(3371),
    [anon_sym_virtual] = ACTIONS(3371),
    [anon_sym_alignas] = ACTIONS(3371),
    [anon_sym_explicit] = ACTIONS(3371),
    [anon_sym_typename] = ACTIONS(3371),
    [anon_sym_template] = ACTIONS(3371),
    [anon_sym_operator] = ACTIONS(3371),
    [anon_sym_try] = ACTIONS(3371),
    [anon_sym_delete] = ACTIONS(3371),
    [anon_sym_throw] = ACTIONS(3371),
    [anon_sym_namespace] = ACTIONS(3371),
    [anon_sym_using] = ACTIONS(3371),
    [anon_sym_static_assert] = ACTIONS(3371),
    [anon_sym_concept] = ACTIONS(3371),
    [anon_sym_co_return] = ACTIONS(3371),
    [anon_sym_co_yield] = ACTIONS(3371),
    [anon_sym_R_DQUOTE] = ACTIONS(3373),
    [anon_sym_LR_DQUOTE] = ACTIONS(3373),
    [anon_sym_uR_DQUOTE] = ACTIONS(3373),
    [anon_sym_UR_DQUOTE] = ACTIONS(3373),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3373),
    [anon_sym_co_await] = ACTIONS(3371),
    [anon_sym_new] = ACTIONS(3371),
    [anon_sym_requires] = ACTIONS(3371),
    [sym_this] = ACTIONS(3371),
  },
  [604] = {
    [sym_identifier] = ACTIONS(3525),
    [aux_sym_preproc_include_token1] = ACTIONS(3525),
    [aux_sym_preproc_def_token1] = ACTIONS(3525),
    [aux_sym_preproc_if_token1] = ACTIONS(3525),
    [aux_sym_preproc_if_token2] = ACTIONS(3525),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3525),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3525),
    [aux_sym_preproc_else_token1] = ACTIONS(3525),
    [aux_sym_preproc_elif_token1] = ACTIONS(3525),
    [sym_preproc_directive] = ACTIONS(3525),
    [anon_sym_LPAREN2] = ACTIONS(3527),
    [anon_sym_BANG] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3525),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_AMP] = ACTIONS(3525),
    [anon_sym_SEMI] = ACTIONS(3527),
    [anon_sym___extension__] = ACTIONS(3525),
    [anon_sym_typedef] = ACTIONS(3525),
    [anon_sym_extern] = ACTIONS(3525),
    [anon_sym___attribute__] = ACTIONS(3525),
    [anon_sym_COLON_COLON] = ACTIONS(3527),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3527),
    [anon_sym___declspec] = ACTIONS(3525),
    [anon_sym___based] = ACTIONS(3525),
    [anon_sym___cdecl] = ACTIONS(3525),
    [anon_sym___clrcall] = ACTIONS(3525),
    [anon_sym___stdcall] = ACTIONS(3525),
    [anon_sym___fastcall] = ACTIONS(3525),
    [anon_sym___thiscall] = ACTIONS(3525),
    [anon_sym___vectorcall] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_signed] = ACTIONS(3525),
    [anon_sym_unsigned] = ACTIONS(3525),
    [anon_sym_long] = ACTIONS(3525),
    [anon_sym_short] = ACTIONS(3525),
    [anon_sym_LBRACK] = ACTIONS(3525),
    [anon_sym_static] = ACTIONS(3525),
    [anon_sym_register] = ACTIONS(3525),
    [anon_sym_inline] = ACTIONS(3525),
    [anon_sym___inline] = ACTIONS(3525),
    [anon_sym___inline__] = ACTIONS(3525),
    [anon_sym___forceinline] = ACTIONS(3525),
    [anon_sym_thread_local] = ACTIONS(3525),
    [anon_sym___thread] = ACTIONS(3525),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_constexpr] = ACTIONS(3525),
    [anon_sym_volatile] = ACTIONS(3525),
    [anon_sym_restrict] = ACTIONS(3525),
    [anon_sym___restrict__] = ACTIONS(3525),
    [anon_sym__Atomic] = ACTIONS(3525),
    [anon_sym__Noreturn] = ACTIONS(3525),
    [anon_sym_noreturn] = ACTIONS(3525),
    [anon_sym_mutable] = ACTIONS(3525),
    [anon_sym_constinit] = ACTIONS(3525),
    [anon_sym_consteval] = ACTIONS(3525),
    [anon_sym_PROGMEM] = ACTIONS(3525),
    [aux_sym_primitive_type_token1] = ACTIONS(3525),
    [anon_sym_byte] = ACTIONS(3525),
    [anon_sym_word] = ACTIONS(3525),
    [anon_sym_enum] = ACTIONS(3525),
    [anon_sym_class] = ACTIONS(3525),
    [anon_sym_struct] = ACTIONS(3525),
    [anon_sym_union] = ACTIONS(3525),
    [anon_sym_if] = ACTIONS(3525),
    [anon_sym_switch] = ACTIONS(3525),
    [anon_sym_case] = ACTIONS(3525),
    [anon_sym_default] = ACTIONS(3525),
    [anon_sym_while] = ACTIONS(3525),
    [anon_sym_do] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3525),
    [anon_sym_return] = ACTIONS(3525),
    [anon_sym_break] = ACTIONS(3525),
    [anon_sym_continue] = ACTIONS(3525),
    [anon_sym_goto] = ACTIONS(3525),
    [anon_sym___try] = ACTIONS(3525),
    [anon_sym___leave] = ACTIONS(3525),
    [anon_sym_not] = ACTIONS(3525),
    [anon_sym_compl] = ACTIONS(3525),
    [anon_sym_DASH_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_PLUS] = ACTIONS(3527),
    [anon_sym_sizeof] = ACTIONS(3525),
    [anon_sym___alignof__] = ACTIONS(3525),
    [anon_sym___alignof] = ACTIONS(3525),
    [anon_sym__alignof] = ACTIONS(3525),
    [anon_sym_alignof] = ACTIONS(3525),
    [anon_sym__Alignof] = ACTIONS(3525),
    [anon_sym_offsetof] = ACTIONS(3525),
    [anon_sym__Generic] = ACTIONS(3525),
    [anon_sym_asm] = ACTIONS(3525),
    [anon_sym___asm__] = ACTIONS(3525),
    [aux_sym_number_literal_token1] = ACTIONS(3527),
    [aux_sym_number_literal_token2] = ACTIONS(3525),
    [anon_sym_L_SQUOTE] = ACTIONS(3527),
    [anon_sym_u_SQUOTE] = ACTIONS(3527),
    [anon_sym_U_SQUOTE] = ACTIONS(3527),
    [anon_sym_u8_SQUOTE] = ACTIONS(3527),
    [anon_sym_SQUOTE] = ACTIONS(3527),
    [anon_sym_L_DQUOTE] = ACTIONS(3527),
    [anon_sym_u_DQUOTE] = ACTIONS(3527),
    [anon_sym_U_DQUOTE] = ACTIONS(3527),
    [anon_sym_u8_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [sym_true] = ACTIONS(3525),
    [sym_false] = ACTIONS(3525),
    [anon_sym_NULL] = ACTIONS(3525),
    [anon_sym_nullptr] = ACTIONS(3525),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3525),
    [anon_sym_decltype] = ACTIONS(3525),
    [anon_sym_virtual] = ACTIONS(3525),
    [anon_sym_alignas] = ACTIONS(3525),
    [anon_sym_explicit] = ACTIONS(3525),
    [anon_sym_typename] = ACTIONS(3525),
    [anon_sym_template] = ACTIONS(3525),
    [anon_sym_operator] = ACTIONS(3525),
    [anon_sym_try] = ACTIONS(3525),
    [anon_sym_delete] = ACTIONS(3525),
    [anon_sym_throw] = ACTIONS(3525),
    [anon_sym_namespace] = ACTIONS(3525),
    [anon_sym_using] = ACTIONS(3525),
    [anon_sym_static_assert] = ACTIONS(3525),
    [anon_sym_concept] = ACTIONS(3525),
    [anon_sym_co_return] = ACTIONS(3525),
    [anon_sym_co_yield] = ACTIONS(3525),
    [anon_sym_R_DQUOTE] = ACTIONS(3527),
    [anon_sym_LR_DQUOTE] = ACTIONS(3527),
    [anon_sym_uR_DQUOTE] = ACTIONS(3527),
    [anon_sym_UR_DQUOTE] = ACTIONS(3527),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3527),
    [anon_sym_co_await] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3525),
    [anon_sym_requires] = ACTIONS(3525),
    [sym_this] = ACTIONS(3525),
  },
  [605] = {
    [sym_identifier] = ACTIONS(3509),
    [aux_sym_preproc_include_token1] = ACTIONS(3509),
    [aux_sym_preproc_def_token1] = ACTIONS(3509),
    [aux_sym_preproc_if_token1] = ACTIONS(3509),
    [aux_sym_preproc_if_token2] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3509),
    [aux_sym_preproc_else_token1] = ACTIONS(3509),
    [aux_sym_preproc_elif_token1] = ACTIONS(3509),
    [sym_preproc_directive] = ACTIONS(3509),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_BANG] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3509),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_SEMI] = ACTIONS(3511),
    [anon_sym___extension__] = ACTIONS(3509),
    [anon_sym_typedef] = ACTIONS(3509),
    [anon_sym_extern] = ACTIONS(3509),
    [anon_sym___attribute__] = ACTIONS(3509),
    [anon_sym_COLON_COLON] = ACTIONS(3511),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3511),
    [anon_sym___declspec] = ACTIONS(3509),
    [anon_sym___based] = ACTIONS(3509),
    [anon_sym___cdecl] = ACTIONS(3509),
    [anon_sym___clrcall] = ACTIONS(3509),
    [anon_sym___stdcall] = ACTIONS(3509),
    [anon_sym___fastcall] = ACTIONS(3509),
    [anon_sym___thiscall] = ACTIONS(3509),
    [anon_sym___vectorcall] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_signed] = ACTIONS(3509),
    [anon_sym_unsigned] = ACTIONS(3509),
    [anon_sym_long] = ACTIONS(3509),
    [anon_sym_short] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(3509),
    [anon_sym_static] = ACTIONS(3509),
    [anon_sym_register] = ACTIONS(3509),
    [anon_sym_inline] = ACTIONS(3509),
    [anon_sym___inline] = ACTIONS(3509),
    [anon_sym___inline__] = ACTIONS(3509),
    [anon_sym___forceinline] = ACTIONS(3509),
    [anon_sym_thread_local] = ACTIONS(3509),
    [anon_sym___thread] = ACTIONS(3509),
    [anon_sym_const] = ACTIONS(3509),
    [anon_sym_constexpr] = ACTIONS(3509),
    [anon_sym_volatile] = ACTIONS(3509),
    [anon_sym_restrict] = ACTIONS(3509),
    [anon_sym___restrict__] = ACTIONS(3509),
    [anon_sym__Atomic] = ACTIONS(3509),
    [anon_sym__Noreturn] = ACTIONS(3509),
    [anon_sym_noreturn] = ACTIONS(3509),
    [anon_sym_mutable] = ACTIONS(3509),
    [anon_sym_constinit] = ACTIONS(3509),
    [anon_sym_consteval] = ACTIONS(3509),
    [anon_sym_PROGMEM] = ACTIONS(3509),
    [aux_sym_primitive_type_token1] = ACTIONS(3509),
    [anon_sym_byte] = ACTIONS(3509),
    [anon_sym_word] = ACTIONS(3509),
    [anon_sym_enum] = ACTIONS(3509),
    [anon_sym_class] = ACTIONS(3509),
    [anon_sym_struct] = ACTIONS(3509),
    [anon_sym_union] = ACTIONS(3509),
    [anon_sym_if] = ACTIONS(3509),
    [anon_sym_switch] = ACTIONS(3509),
    [anon_sym_case] = ACTIONS(3509),
    [anon_sym_default] = ACTIONS(3509),
    [anon_sym_while] = ACTIONS(3509),
    [anon_sym_do] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3509),
    [anon_sym_return] = ACTIONS(3509),
    [anon_sym_break] = ACTIONS(3509),
    [anon_sym_continue] = ACTIONS(3509),
    [anon_sym_goto] = ACTIONS(3509),
    [anon_sym___try] = ACTIONS(3509),
    [anon_sym___leave] = ACTIONS(3509),
    [anon_sym_not] = ACTIONS(3509),
    [anon_sym_compl] = ACTIONS(3509),
    [anon_sym_DASH_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_PLUS] = ACTIONS(3511),
    [anon_sym_sizeof] = ACTIONS(3509),
    [anon_sym___alignof__] = ACTIONS(3509),
    [anon_sym___alignof] = ACTIONS(3509),
    [anon_sym__alignof] = ACTIONS(3509),
    [anon_sym_alignof] = ACTIONS(3509),
    [anon_sym__Alignof] = ACTIONS(3509),
    [anon_sym_offsetof] = ACTIONS(3509),
    [anon_sym__Generic] = ACTIONS(3509),
    [anon_sym_asm] = ACTIONS(3509),
    [anon_sym___asm__] = ACTIONS(3509),
    [aux_sym_number_literal_token1] = ACTIONS(3511),
    [aux_sym_number_literal_token2] = ACTIONS(3509),
    [anon_sym_L_SQUOTE] = ACTIONS(3511),
    [anon_sym_u_SQUOTE] = ACTIONS(3511),
    [anon_sym_U_SQUOTE] = ACTIONS(3511),
    [anon_sym_u8_SQUOTE] = ACTIONS(3511),
    [anon_sym_SQUOTE] = ACTIONS(3511),
    [anon_sym_L_DQUOTE] = ACTIONS(3511),
    [anon_sym_u_DQUOTE] = ACTIONS(3511),
    [anon_sym_U_DQUOTE] = ACTIONS(3511),
    [anon_sym_u8_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [sym_true] = ACTIONS(3509),
    [sym_false] = ACTIONS(3509),
    [anon_sym_NULL] = ACTIONS(3509),
    [anon_sym_nullptr] = ACTIONS(3509),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3509),
    [anon_sym_decltype] = ACTIONS(3509),
    [anon_sym_virtual] = ACTIONS(3509),
    [anon_sym_alignas] = ACTIONS(3509),
    [anon_sym_explicit] = ACTIONS(3509),
    [anon_sym_typename] = ACTIONS(3509),
    [anon_sym_template] = ACTIONS(3509),
    [anon_sym_operator] = ACTIONS(3509),
    [anon_sym_try] = ACTIONS(3509),
    [anon_sym_delete] = ACTIONS(3509),
    [anon_sym_throw] = ACTIONS(3509),
    [anon_sym_namespace] = ACTIONS(3509),
    [anon_sym_using] = ACTIONS(3509),
    [anon_sym_static_assert] = ACTIONS(3509),
    [anon_sym_concept] = ACTIONS(3509),
    [anon_sym_co_return] = ACTIONS(3509),
    [anon_sym_co_yield] = ACTIONS(3509),
    [anon_sym_R_DQUOTE] = ACTIONS(3511),
    [anon_sym_LR_DQUOTE] = ACTIONS(3511),
    [anon_sym_uR_DQUOTE] = ACTIONS(3511),
    [anon_sym_UR_DQUOTE] = ACTIONS(3511),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3511),
    [anon_sym_co_await] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3509),
    [anon_sym_requires] = ACTIONS(3509),
    [sym_this] = ACTIONS(3509),
  },
  [606] = {
    [sym_identifier] = ACTIONS(3357),
    [aux_sym_preproc_include_token1] = ACTIONS(3357),
    [aux_sym_preproc_def_token1] = ACTIONS(3357),
    [aux_sym_preproc_if_token1] = ACTIONS(3357),
    [aux_sym_preproc_if_token2] = ACTIONS(3357),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3357),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3357),
    [aux_sym_preproc_else_token1] = ACTIONS(3357),
    [aux_sym_preproc_elif_token1] = ACTIONS(3357),
    [sym_preproc_directive] = ACTIONS(3357),
    [anon_sym_LPAREN2] = ACTIONS(3359),
    [anon_sym_BANG] = ACTIONS(3359),
    [anon_sym_TILDE] = ACTIONS(3359),
    [anon_sym_DASH] = ACTIONS(3357),
    [anon_sym_PLUS] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(3359),
    [anon_sym_AMP_AMP] = ACTIONS(3359),
    [anon_sym_AMP] = ACTIONS(3357),
    [anon_sym_SEMI] = ACTIONS(3359),
    [anon_sym___extension__] = ACTIONS(3357),
    [anon_sym_typedef] = ACTIONS(3357),
    [anon_sym_extern] = ACTIONS(3357),
    [anon_sym___attribute__] = ACTIONS(3357),
    [anon_sym_COLON_COLON] = ACTIONS(3359),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3359),
    [anon_sym___declspec] = ACTIONS(3357),
    [anon_sym___based] = ACTIONS(3357),
    [anon_sym___cdecl] = ACTIONS(3357),
    [anon_sym___clrcall] = ACTIONS(3357),
    [anon_sym___stdcall] = ACTIONS(3357),
    [anon_sym___fastcall] = ACTIONS(3357),
    [anon_sym___thiscall] = ACTIONS(3357),
    [anon_sym___vectorcall] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3359),
    [anon_sym_signed] = ACTIONS(3357),
    [anon_sym_unsigned] = ACTIONS(3357),
    [anon_sym_long] = ACTIONS(3357),
    [anon_sym_short] = ACTIONS(3357),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_static] = ACTIONS(3357),
    [anon_sym_register] = ACTIONS(3357),
    [anon_sym_inline] = ACTIONS(3357),
    [anon_sym___inline] = ACTIONS(3357),
    [anon_sym___inline__] = ACTIONS(3357),
    [anon_sym___forceinline] = ACTIONS(3357),
    [anon_sym_thread_local] = ACTIONS(3357),
    [anon_sym___thread] = ACTIONS(3357),
    [anon_sym_const] = ACTIONS(3357),
    [anon_sym_constexpr] = ACTIONS(3357),
    [anon_sym_volatile] = ACTIONS(3357),
    [anon_sym_restrict] = ACTIONS(3357),
    [anon_sym___restrict__] = ACTIONS(3357),
    [anon_sym__Atomic] = ACTIONS(3357),
    [anon_sym__Noreturn] = ACTIONS(3357),
    [anon_sym_noreturn] = ACTIONS(3357),
    [anon_sym_mutable] = ACTIONS(3357),
    [anon_sym_constinit] = ACTIONS(3357),
    [anon_sym_consteval] = ACTIONS(3357),
    [anon_sym_PROGMEM] = ACTIONS(3357),
    [aux_sym_primitive_type_token1] = ACTIONS(3357),
    [anon_sym_byte] = ACTIONS(3357),
    [anon_sym_word] = ACTIONS(3357),
    [anon_sym_enum] = ACTIONS(3357),
    [anon_sym_class] = ACTIONS(3357),
    [anon_sym_struct] = ACTIONS(3357),
    [anon_sym_union] = ACTIONS(3357),
    [anon_sym_if] = ACTIONS(3357),
    [anon_sym_switch] = ACTIONS(3357),
    [anon_sym_case] = ACTIONS(3357),
    [anon_sym_default] = ACTIONS(3357),
    [anon_sym_while] = ACTIONS(3357),
    [anon_sym_do] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3357),
    [anon_sym_return] = ACTIONS(3357),
    [anon_sym_break] = ACTIONS(3357),
    [anon_sym_continue] = ACTIONS(3357),
    [anon_sym_goto] = ACTIONS(3357),
    [anon_sym___try] = ACTIONS(3357),
    [anon_sym___leave] = ACTIONS(3357),
    [anon_sym_not] = ACTIONS(3357),
    [anon_sym_compl] = ACTIONS(3357),
    [anon_sym_DASH_DASH] = ACTIONS(3359),
    [anon_sym_PLUS_PLUS] = ACTIONS(3359),
    [anon_sym_sizeof] = ACTIONS(3357),
    [anon_sym___alignof__] = ACTIONS(3357),
    [anon_sym___alignof] = ACTIONS(3357),
    [anon_sym__alignof] = ACTIONS(3357),
    [anon_sym_alignof] = ACTIONS(3357),
    [anon_sym__Alignof] = ACTIONS(3357),
    [anon_sym_offsetof] = ACTIONS(3357),
    [anon_sym__Generic] = ACTIONS(3357),
    [anon_sym_asm] = ACTIONS(3357),
    [anon_sym___asm__] = ACTIONS(3357),
    [aux_sym_number_literal_token1] = ACTIONS(3359),
    [aux_sym_number_literal_token2] = ACTIONS(3357),
    [anon_sym_L_SQUOTE] = ACTIONS(3359),
    [anon_sym_u_SQUOTE] = ACTIONS(3359),
    [anon_sym_U_SQUOTE] = ACTIONS(3359),
    [anon_sym_u8_SQUOTE] = ACTIONS(3359),
    [anon_sym_SQUOTE] = ACTIONS(3359),
    [anon_sym_L_DQUOTE] = ACTIONS(3359),
    [anon_sym_u_DQUOTE] = ACTIONS(3359),
    [anon_sym_U_DQUOTE] = ACTIONS(3359),
    [anon_sym_u8_DQUOTE] = ACTIONS(3359),
    [anon_sym_DQUOTE] = ACTIONS(3359),
    [sym_true] = ACTIONS(3357),
    [sym_false] = ACTIONS(3357),
    [anon_sym_NULL] = ACTIONS(3357),
    [anon_sym_nullptr] = ACTIONS(3357),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3357),
    [anon_sym_decltype] = ACTIONS(3357),
    [anon_sym_virtual] = ACTIONS(3357),
    [anon_sym_alignas] = ACTIONS(3357),
    [anon_sym_explicit] = ACTIONS(3357),
    [anon_sym_typename] = ACTIONS(3357),
    [anon_sym_template] = ACTIONS(3357),
    [anon_sym_operator] = ACTIONS(3357),
    [anon_sym_try] = ACTIONS(3357),
    [anon_sym_delete] = ACTIONS(3357),
    [anon_sym_throw] = ACTIONS(3357),
    [anon_sym_namespace] = ACTIONS(3357),
    [anon_sym_using] = ACTIONS(3357),
    [anon_sym_static_assert] = ACTIONS(3357),
    [anon_sym_concept] = ACTIONS(3357),
    [anon_sym_co_return] = ACTIONS(3357),
    [anon_sym_co_yield] = ACTIONS(3357),
    [anon_sym_R_DQUOTE] = ACTIONS(3359),
    [anon_sym_LR_DQUOTE] = ACTIONS(3359),
    [anon_sym_uR_DQUOTE] = ACTIONS(3359),
    [anon_sym_UR_DQUOTE] = ACTIONS(3359),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3359),
    [anon_sym_co_await] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3357),
    [anon_sym_requires] = ACTIONS(3357),
    [sym_this] = ACTIONS(3357),
  },
  [607] = {
    [sym_identifier] = ACTIONS(3361),
    [aux_sym_preproc_include_token1] = ACTIONS(3361),
    [aux_sym_preproc_def_token1] = ACTIONS(3361),
    [aux_sym_preproc_if_token1] = ACTIONS(3361),
    [aux_sym_preproc_if_token2] = ACTIONS(3361),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3361),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3361),
    [aux_sym_preproc_else_token1] = ACTIONS(3361),
    [aux_sym_preproc_elif_token1] = ACTIONS(3361),
    [sym_preproc_directive] = ACTIONS(3361),
    [anon_sym_LPAREN2] = ACTIONS(3363),
    [anon_sym_BANG] = ACTIONS(3363),
    [anon_sym_TILDE] = ACTIONS(3363),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_STAR] = ACTIONS(3363),
    [anon_sym_AMP_AMP] = ACTIONS(3363),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_SEMI] = ACTIONS(3363),
    [anon_sym___extension__] = ACTIONS(3361),
    [anon_sym_typedef] = ACTIONS(3361),
    [anon_sym_extern] = ACTIONS(3361),
    [anon_sym___attribute__] = ACTIONS(3361),
    [anon_sym_COLON_COLON] = ACTIONS(3363),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3363),
    [anon_sym___declspec] = ACTIONS(3361),
    [anon_sym___based] = ACTIONS(3361),
    [anon_sym___cdecl] = ACTIONS(3361),
    [anon_sym___clrcall] = ACTIONS(3361),
    [anon_sym___stdcall] = ACTIONS(3361),
    [anon_sym___fastcall] = ACTIONS(3361),
    [anon_sym___thiscall] = ACTIONS(3361),
    [anon_sym___vectorcall] = ACTIONS(3361),
    [anon_sym_LBRACE] = ACTIONS(3363),
    [anon_sym_signed] = ACTIONS(3361),
    [anon_sym_unsigned] = ACTIONS(3361),
    [anon_sym_long] = ACTIONS(3361),
    [anon_sym_short] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_static] = ACTIONS(3361),
    [anon_sym_register] = ACTIONS(3361),
    [anon_sym_inline] = ACTIONS(3361),
    [anon_sym___inline] = ACTIONS(3361),
    [anon_sym___inline__] = ACTIONS(3361),
    [anon_sym___forceinline] = ACTIONS(3361),
    [anon_sym_thread_local] = ACTIONS(3361),
    [anon_sym___thread] = ACTIONS(3361),
    [anon_sym_const] = ACTIONS(3361),
    [anon_sym_constexpr] = ACTIONS(3361),
    [anon_sym_volatile] = ACTIONS(3361),
    [anon_sym_restrict] = ACTIONS(3361),
    [anon_sym___restrict__] = ACTIONS(3361),
    [anon_sym__Atomic] = ACTIONS(3361),
    [anon_sym__Noreturn] = ACTIONS(3361),
    [anon_sym_noreturn] = ACTIONS(3361),
    [anon_sym_mutable] = ACTIONS(3361),
    [anon_sym_constinit] = ACTIONS(3361),
    [anon_sym_consteval] = ACTIONS(3361),
    [anon_sym_PROGMEM] = ACTIONS(3361),
    [aux_sym_primitive_type_token1] = ACTIONS(3361),
    [anon_sym_byte] = ACTIONS(3361),
    [anon_sym_word] = ACTIONS(3361),
    [anon_sym_enum] = ACTIONS(3361),
    [anon_sym_class] = ACTIONS(3361),
    [anon_sym_struct] = ACTIONS(3361),
    [anon_sym_union] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_switch] = ACTIONS(3361),
    [anon_sym_case] = ACTIONS(3361),
    [anon_sym_default] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_break] = ACTIONS(3361),
    [anon_sym_continue] = ACTIONS(3361),
    [anon_sym_goto] = ACTIONS(3361),
    [anon_sym___try] = ACTIONS(3361),
    [anon_sym___leave] = ACTIONS(3361),
    [anon_sym_not] = ACTIONS(3361),
    [anon_sym_compl] = ACTIONS(3361),
    [anon_sym_DASH_DASH] = ACTIONS(3363),
    [anon_sym_PLUS_PLUS] = ACTIONS(3363),
    [anon_sym_sizeof] = ACTIONS(3361),
    [anon_sym___alignof__] = ACTIONS(3361),
    [anon_sym___alignof] = ACTIONS(3361),
    [anon_sym__alignof] = ACTIONS(3361),
    [anon_sym_alignof] = ACTIONS(3361),
    [anon_sym__Alignof] = ACTIONS(3361),
    [anon_sym_offsetof] = ACTIONS(3361),
    [anon_sym__Generic] = ACTIONS(3361),
    [anon_sym_asm] = ACTIONS(3361),
    [anon_sym___asm__] = ACTIONS(3361),
    [aux_sym_number_literal_token1] = ACTIONS(3363),
    [aux_sym_number_literal_token2] = ACTIONS(3361),
    [anon_sym_L_SQUOTE] = ACTIONS(3363),
    [anon_sym_u_SQUOTE] = ACTIONS(3363),
    [anon_sym_U_SQUOTE] = ACTIONS(3363),
    [anon_sym_u8_SQUOTE] = ACTIONS(3363),
    [anon_sym_SQUOTE] = ACTIONS(3363),
    [anon_sym_L_DQUOTE] = ACTIONS(3363),
    [anon_sym_u_DQUOTE] = ACTIONS(3363),
    [anon_sym_U_DQUOTE] = ACTIONS(3363),
    [anon_sym_u8_DQUOTE] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3363),
    [sym_true] = ACTIONS(3361),
    [sym_false] = ACTIONS(3361),
    [anon_sym_NULL] = ACTIONS(3361),
    [anon_sym_nullptr] = ACTIONS(3361),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3361),
    [anon_sym_decltype] = ACTIONS(3361),
    [anon_sym_virtual] = ACTIONS(3361),
    [anon_sym_alignas] = ACTIONS(3361),
    [anon_sym_explicit] = ACTIONS(3361),
    [anon_sym_typename] = ACTIONS(3361),
    [anon_sym_template] = ACTIONS(3361),
    [anon_sym_operator] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_delete] = ACTIONS(3361),
    [anon_sym_throw] = ACTIONS(3361),
    [anon_sym_namespace] = ACTIONS(3361),
    [anon_sym_using] = ACTIONS(3361),
    [anon_sym_static_assert] = ACTIONS(3361),
    [anon_sym_concept] = ACTIONS(3361),
    [anon_sym_co_return] = ACTIONS(3361),
    [anon_sym_co_yield] = ACTIONS(3361),
    [anon_sym_R_DQUOTE] = ACTIONS(3363),
    [anon_sym_LR_DQUOTE] = ACTIONS(3363),
    [anon_sym_uR_DQUOTE] = ACTIONS(3363),
    [anon_sym_UR_DQUOTE] = ACTIONS(3363),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3363),
    [anon_sym_co_await] = ACTIONS(3361),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_requires] = ACTIONS(3361),
    [sym_this] = ACTIONS(3361),
  },
  [608] = {
    [sym_identifier] = ACTIONS(3503),
    [aux_sym_preproc_include_token1] = ACTIONS(3503),
    [aux_sym_preproc_def_token1] = ACTIONS(3503),
    [aux_sym_preproc_if_token1] = ACTIONS(3503),
    [aux_sym_preproc_if_token2] = ACTIONS(3503),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3503),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3503),
    [aux_sym_preproc_else_token1] = ACTIONS(3503),
    [aux_sym_preproc_elif_token1] = ACTIONS(3503),
    [sym_preproc_directive] = ACTIONS(3503),
    [anon_sym_LPAREN2] = ACTIONS(3505),
    [anon_sym_BANG] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3503),
    [anon_sym_PLUS] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP] = ACTIONS(3503),
    [anon_sym_SEMI] = ACTIONS(3505),
    [anon_sym___extension__] = ACTIONS(3503),
    [anon_sym_typedef] = ACTIONS(3503),
    [anon_sym_extern] = ACTIONS(3503),
    [anon_sym___attribute__] = ACTIONS(3503),
    [anon_sym_COLON_COLON] = ACTIONS(3505),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3505),
    [anon_sym___declspec] = ACTIONS(3503),
    [anon_sym___based] = ACTIONS(3503),
    [anon_sym___cdecl] = ACTIONS(3503),
    [anon_sym___clrcall] = ACTIONS(3503),
    [anon_sym___stdcall] = ACTIONS(3503),
    [anon_sym___fastcall] = ACTIONS(3503),
    [anon_sym___thiscall] = ACTIONS(3503),
    [anon_sym___vectorcall] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_signed] = ACTIONS(3503),
    [anon_sym_unsigned] = ACTIONS(3503),
    [anon_sym_long] = ACTIONS(3503),
    [anon_sym_short] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3503),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_register] = ACTIONS(3503),
    [anon_sym_inline] = ACTIONS(3503),
    [anon_sym___inline] = ACTIONS(3503),
    [anon_sym___inline__] = ACTIONS(3503),
    [anon_sym___forceinline] = ACTIONS(3503),
    [anon_sym_thread_local] = ACTIONS(3503),
    [anon_sym___thread] = ACTIONS(3503),
    [anon_sym_const] = ACTIONS(3503),
    [anon_sym_constexpr] = ACTIONS(3503),
    [anon_sym_volatile] = ACTIONS(3503),
    [anon_sym_restrict] = ACTIONS(3503),
    [anon_sym___restrict__] = ACTIONS(3503),
    [anon_sym__Atomic] = ACTIONS(3503),
    [anon_sym__Noreturn] = ACTIONS(3503),
    [anon_sym_noreturn] = ACTIONS(3503),
    [anon_sym_mutable] = ACTIONS(3503),
    [anon_sym_constinit] = ACTIONS(3503),
    [anon_sym_consteval] = ACTIONS(3503),
    [anon_sym_PROGMEM] = ACTIONS(3503),
    [aux_sym_primitive_type_token1] = ACTIONS(3503),
    [anon_sym_byte] = ACTIONS(3503),
    [anon_sym_word] = ACTIONS(3503),
    [anon_sym_enum] = ACTIONS(3503),
    [anon_sym_class] = ACTIONS(3503),
    [anon_sym_struct] = ACTIONS(3503),
    [anon_sym_union] = ACTIONS(3503),
    [anon_sym_if] = ACTIONS(3503),
    [anon_sym_switch] = ACTIONS(3503),
    [anon_sym_case] = ACTIONS(3503),
    [anon_sym_default] = ACTIONS(3503),
    [anon_sym_while] = ACTIONS(3503),
    [anon_sym_do] = ACTIONS(3503),
    [anon_sym_for] = ACTIONS(3503),
    [anon_sym_return] = ACTIONS(3503),
    [anon_sym_break] = ACTIONS(3503),
    [anon_sym_continue] = ACTIONS(3503),
    [anon_sym_goto] = ACTIONS(3503),
    [anon_sym___try] = ACTIONS(3503),
    [anon_sym___leave] = ACTIONS(3503),
    [anon_sym_not] = ACTIONS(3503),
    [anon_sym_compl] = ACTIONS(3503),
    [anon_sym_DASH_DASH] = ACTIONS(3505),
    [anon_sym_PLUS_PLUS] = ACTIONS(3505),
    [anon_sym_sizeof] = ACTIONS(3503),
    [anon_sym___alignof__] = ACTIONS(3503),
    [anon_sym___alignof] = ACTIONS(3503),
    [anon_sym__alignof] = ACTIONS(3503),
    [anon_sym_alignof] = ACTIONS(3503),
    [anon_sym__Alignof] = ACTIONS(3503),
    [anon_sym_offsetof] = ACTIONS(3503),
    [anon_sym__Generic] = ACTIONS(3503),
    [anon_sym_asm] = ACTIONS(3503),
    [anon_sym___asm__] = ACTIONS(3503),
    [aux_sym_number_literal_token1] = ACTIONS(3505),
    [aux_sym_number_literal_token2] = ACTIONS(3503),
    [anon_sym_L_SQUOTE] = ACTIONS(3505),
    [anon_sym_u_SQUOTE] = ACTIONS(3505),
    [anon_sym_U_SQUOTE] = ACTIONS(3505),
    [anon_sym_u8_SQUOTE] = ACTIONS(3505),
    [anon_sym_SQUOTE] = ACTIONS(3505),
    [anon_sym_L_DQUOTE] = ACTIONS(3505),
    [anon_sym_u_DQUOTE] = ACTIONS(3505),
    [anon_sym_U_DQUOTE] = ACTIONS(3505),
    [anon_sym_u8_DQUOTE] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [sym_true] = ACTIONS(3503),
    [sym_false] = ACTIONS(3503),
    [anon_sym_NULL] = ACTIONS(3503),
    [anon_sym_nullptr] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3503),
    [anon_sym_decltype] = ACTIONS(3503),
    [anon_sym_virtual] = ACTIONS(3503),
    [anon_sym_alignas] = ACTIONS(3503),
    [anon_sym_explicit] = ACTIONS(3503),
    [anon_sym_typename] = ACTIONS(3503),
    [anon_sym_template] = ACTIONS(3503),
    [anon_sym_operator] = ACTIONS(3503),
    [anon_sym_try] = ACTIONS(3503),
    [anon_sym_delete] = ACTIONS(3503),
    [anon_sym_throw] = ACTIONS(3503),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_using] = ACTIONS(3503),
    [anon_sym_static_assert] = ACTIONS(3503),
    [anon_sym_concept] = ACTIONS(3503),
    [anon_sym_co_return] = ACTIONS(3503),
    [anon_sym_co_yield] = ACTIONS(3503),
    [anon_sym_R_DQUOTE] = ACTIONS(3505),
    [anon_sym_LR_DQUOTE] = ACTIONS(3505),
    [anon_sym_uR_DQUOTE] = ACTIONS(3505),
    [anon_sym_UR_DQUOTE] = ACTIONS(3505),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3505),
    [anon_sym_co_await] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3503),
    [anon_sym_requires] = ACTIONS(3503),
    [sym_this] = ACTIONS(3503),
  },
  [609] = {
    [sym_identifier] = ACTIONS(3367),
    [aux_sym_preproc_include_token1] = ACTIONS(3367),
    [aux_sym_preproc_def_token1] = ACTIONS(3367),
    [aux_sym_preproc_if_token1] = ACTIONS(3367),
    [aux_sym_preproc_if_token2] = ACTIONS(3367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3367),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3367),
    [aux_sym_preproc_else_token1] = ACTIONS(3367),
    [aux_sym_preproc_elif_token1] = ACTIONS(3367),
    [sym_preproc_directive] = ACTIONS(3367),
    [anon_sym_LPAREN2] = ACTIONS(3369),
    [anon_sym_BANG] = ACTIONS(3369),
    [anon_sym_TILDE] = ACTIONS(3369),
    [anon_sym_DASH] = ACTIONS(3367),
    [anon_sym_PLUS] = ACTIONS(3367),
    [anon_sym_STAR] = ACTIONS(3369),
    [anon_sym_AMP_AMP] = ACTIONS(3369),
    [anon_sym_AMP] = ACTIONS(3367),
    [anon_sym_SEMI] = ACTIONS(3369),
    [anon_sym___extension__] = ACTIONS(3367),
    [anon_sym_typedef] = ACTIONS(3367),
    [anon_sym_extern] = ACTIONS(3367),
    [anon_sym___attribute__] = ACTIONS(3367),
    [anon_sym_COLON_COLON] = ACTIONS(3369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3369),
    [anon_sym___declspec] = ACTIONS(3367),
    [anon_sym___based] = ACTIONS(3367),
    [anon_sym___cdecl] = ACTIONS(3367),
    [anon_sym___clrcall] = ACTIONS(3367),
    [anon_sym___stdcall] = ACTIONS(3367),
    [anon_sym___fastcall] = ACTIONS(3367),
    [anon_sym___thiscall] = ACTIONS(3367),
    [anon_sym___vectorcall] = ACTIONS(3367),
    [anon_sym_LBRACE] = ACTIONS(3369),
    [anon_sym_signed] = ACTIONS(3367),
    [anon_sym_unsigned] = ACTIONS(3367),
    [anon_sym_long] = ACTIONS(3367),
    [anon_sym_short] = ACTIONS(3367),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_static] = ACTIONS(3367),
    [anon_sym_register] = ACTIONS(3367),
    [anon_sym_inline] = ACTIONS(3367),
    [anon_sym___inline] = ACTIONS(3367),
    [anon_sym___inline__] = ACTIONS(3367),
    [anon_sym___forceinline] = ACTIONS(3367),
    [anon_sym_thread_local] = ACTIONS(3367),
    [anon_sym___thread] = ACTIONS(3367),
    [anon_sym_const] = ACTIONS(3367),
    [anon_sym_constexpr] = ACTIONS(3367),
    [anon_sym_volatile] = ACTIONS(3367),
    [anon_sym_restrict] = ACTIONS(3367),
    [anon_sym___restrict__] = ACTIONS(3367),
    [anon_sym__Atomic] = ACTIONS(3367),
    [anon_sym__Noreturn] = ACTIONS(3367),
    [anon_sym_noreturn] = ACTIONS(3367),
    [anon_sym_mutable] = ACTIONS(3367),
    [anon_sym_constinit] = ACTIONS(3367),
    [anon_sym_consteval] = ACTIONS(3367),
    [anon_sym_PROGMEM] = ACTIONS(3367),
    [aux_sym_primitive_type_token1] = ACTIONS(3367),
    [anon_sym_byte] = ACTIONS(3367),
    [anon_sym_word] = ACTIONS(3367),
    [anon_sym_enum] = ACTIONS(3367),
    [anon_sym_class] = ACTIONS(3367),
    [anon_sym_struct] = ACTIONS(3367),
    [anon_sym_union] = ACTIONS(3367),
    [anon_sym_if] = ACTIONS(3367),
    [anon_sym_switch] = ACTIONS(3367),
    [anon_sym_case] = ACTIONS(3367),
    [anon_sym_default] = ACTIONS(3367),
    [anon_sym_while] = ACTIONS(3367),
    [anon_sym_do] = ACTIONS(3367),
    [anon_sym_for] = ACTIONS(3367),
    [anon_sym_return] = ACTIONS(3367),
    [anon_sym_break] = ACTIONS(3367),
    [anon_sym_continue] = ACTIONS(3367),
    [anon_sym_goto] = ACTIONS(3367),
    [anon_sym___try] = ACTIONS(3367),
    [anon_sym___leave] = ACTIONS(3367),
    [anon_sym_not] = ACTIONS(3367),
    [anon_sym_compl] = ACTIONS(3367),
    [anon_sym_DASH_DASH] = ACTIONS(3369),
    [anon_sym_PLUS_PLUS] = ACTIONS(3369),
    [anon_sym_sizeof] = ACTIONS(3367),
    [anon_sym___alignof__] = ACTIONS(3367),
    [anon_sym___alignof] = ACTIONS(3367),
    [anon_sym__alignof] = ACTIONS(3367),
    [anon_sym_alignof] = ACTIONS(3367),
    [anon_sym__Alignof] = ACTIONS(3367),
    [anon_sym_offsetof] = ACTIONS(3367),
    [anon_sym__Generic] = ACTIONS(3367),
    [anon_sym_asm] = ACTIONS(3367),
    [anon_sym___asm__] = ACTIONS(3367),
    [aux_sym_number_literal_token1] = ACTIONS(3369),
    [aux_sym_number_literal_token2] = ACTIONS(3367),
    [anon_sym_L_SQUOTE] = ACTIONS(3369),
    [anon_sym_u_SQUOTE] = ACTIONS(3369),
    [anon_sym_U_SQUOTE] = ACTIONS(3369),
    [anon_sym_u8_SQUOTE] = ACTIONS(3369),
    [anon_sym_SQUOTE] = ACTIONS(3369),
    [anon_sym_L_DQUOTE] = ACTIONS(3369),
    [anon_sym_u_DQUOTE] = ACTIONS(3369),
    [anon_sym_U_DQUOTE] = ACTIONS(3369),
    [anon_sym_u8_DQUOTE] = ACTIONS(3369),
    [anon_sym_DQUOTE] = ACTIONS(3369),
    [sym_true] = ACTIONS(3367),
    [sym_false] = ACTIONS(3367),
    [anon_sym_NULL] = ACTIONS(3367),
    [anon_sym_nullptr] = ACTIONS(3367),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3367),
    [anon_sym_decltype] = ACTIONS(3367),
    [anon_sym_virtual] = ACTIONS(3367),
    [anon_sym_alignas] = ACTIONS(3367),
    [anon_sym_explicit] = ACTIONS(3367),
    [anon_sym_typename] = ACTIONS(3367),
    [anon_sym_template] = ACTIONS(3367),
    [anon_sym_operator] = ACTIONS(3367),
    [anon_sym_try] = ACTIONS(3367),
    [anon_sym_delete] = ACTIONS(3367),
    [anon_sym_throw] = ACTIONS(3367),
    [anon_sym_namespace] = ACTIONS(3367),
    [anon_sym_using] = ACTIONS(3367),
    [anon_sym_static_assert] = ACTIONS(3367),
    [anon_sym_concept] = ACTIONS(3367),
    [anon_sym_co_return] = ACTIONS(3367),
    [anon_sym_co_yield] = ACTIONS(3367),
    [anon_sym_R_DQUOTE] = ACTIONS(3369),
    [anon_sym_LR_DQUOTE] = ACTIONS(3369),
    [anon_sym_uR_DQUOTE] = ACTIONS(3369),
    [anon_sym_UR_DQUOTE] = ACTIONS(3369),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3369),
    [anon_sym_co_await] = ACTIONS(3367),
    [anon_sym_new] = ACTIONS(3367),
    [anon_sym_requires] = ACTIONS(3367),
    [sym_this] = ACTIONS(3367),
  },
  [610] = {
    [sym_identifier] = ACTIONS(3375),
    [aux_sym_preproc_include_token1] = ACTIONS(3375),
    [aux_sym_preproc_def_token1] = ACTIONS(3375),
    [aux_sym_preproc_if_token1] = ACTIONS(3375),
    [aux_sym_preproc_if_token2] = ACTIONS(3375),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3375),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3375),
    [aux_sym_preproc_else_token1] = ACTIONS(3375),
    [aux_sym_preproc_elif_token1] = ACTIONS(3375),
    [sym_preproc_directive] = ACTIONS(3375),
    [anon_sym_LPAREN2] = ACTIONS(3377),
    [anon_sym_BANG] = ACTIONS(3377),
    [anon_sym_TILDE] = ACTIONS(3377),
    [anon_sym_DASH] = ACTIONS(3375),
    [anon_sym_PLUS] = ACTIONS(3375),
    [anon_sym_STAR] = ACTIONS(3377),
    [anon_sym_AMP_AMP] = ACTIONS(3377),
    [anon_sym_AMP] = ACTIONS(3375),
    [anon_sym_SEMI] = ACTIONS(3377),
    [anon_sym___extension__] = ACTIONS(3375),
    [anon_sym_typedef] = ACTIONS(3375),
    [anon_sym_extern] = ACTIONS(3375),
    [anon_sym___attribute__] = ACTIONS(3375),
    [anon_sym_COLON_COLON] = ACTIONS(3377),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3377),
    [anon_sym___declspec] = ACTIONS(3375),
    [anon_sym___based] = ACTIONS(3375),
    [anon_sym___cdecl] = ACTIONS(3375),
    [anon_sym___clrcall] = ACTIONS(3375),
    [anon_sym___stdcall] = ACTIONS(3375),
    [anon_sym___fastcall] = ACTIONS(3375),
    [anon_sym___thiscall] = ACTIONS(3375),
    [anon_sym___vectorcall] = ACTIONS(3375),
    [anon_sym_LBRACE] = ACTIONS(3377),
    [anon_sym_signed] = ACTIONS(3375),
    [anon_sym_unsigned] = ACTIONS(3375),
    [anon_sym_long] = ACTIONS(3375),
    [anon_sym_short] = ACTIONS(3375),
    [anon_sym_LBRACK] = ACTIONS(3375),
    [anon_sym_static] = ACTIONS(3375),
    [anon_sym_register] = ACTIONS(3375),
    [anon_sym_inline] = ACTIONS(3375),
    [anon_sym___inline] = ACTIONS(3375),
    [anon_sym___inline__] = ACTIONS(3375),
    [anon_sym___forceinline] = ACTIONS(3375),
    [anon_sym_thread_local] = ACTIONS(3375),
    [anon_sym___thread] = ACTIONS(3375),
    [anon_sym_const] = ACTIONS(3375),
    [anon_sym_constexpr] = ACTIONS(3375),
    [anon_sym_volatile] = ACTIONS(3375),
    [anon_sym_restrict] = ACTIONS(3375),
    [anon_sym___restrict__] = ACTIONS(3375),
    [anon_sym__Atomic] = ACTIONS(3375),
    [anon_sym__Noreturn] = ACTIONS(3375),
    [anon_sym_noreturn] = ACTIONS(3375),
    [anon_sym_mutable] = ACTIONS(3375),
    [anon_sym_constinit] = ACTIONS(3375),
    [anon_sym_consteval] = ACTIONS(3375),
    [anon_sym_PROGMEM] = ACTIONS(3375),
    [aux_sym_primitive_type_token1] = ACTIONS(3375),
    [anon_sym_byte] = ACTIONS(3375),
    [anon_sym_word] = ACTIONS(3375),
    [anon_sym_enum] = ACTIONS(3375),
    [anon_sym_class] = ACTIONS(3375),
    [anon_sym_struct] = ACTIONS(3375),
    [anon_sym_union] = ACTIONS(3375),
    [anon_sym_if] = ACTIONS(3375),
    [anon_sym_switch] = ACTIONS(3375),
    [anon_sym_case] = ACTIONS(3375),
    [anon_sym_default] = ACTIONS(3375),
    [anon_sym_while] = ACTIONS(3375),
    [anon_sym_do] = ACTIONS(3375),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_return] = ACTIONS(3375),
    [anon_sym_break] = ACTIONS(3375),
    [anon_sym_continue] = ACTIONS(3375),
    [anon_sym_goto] = ACTIONS(3375),
    [anon_sym___try] = ACTIONS(3375),
    [anon_sym___leave] = ACTIONS(3375),
    [anon_sym_not] = ACTIONS(3375),
    [anon_sym_compl] = ACTIONS(3375),
    [anon_sym_DASH_DASH] = ACTIONS(3377),
    [anon_sym_PLUS_PLUS] = ACTIONS(3377),
    [anon_sym_sizeof] = ACTIONS(3375),
    [anon_sym___alignof__] = ACTIONS(3375),
    [anon_sym___alignof] = ACTIONS(3375),
    [anon_sym__alignof] = ACTIONS(3375),
    [anon_sym_alignof] = ACTIONS(3375),
    [anon_sym__Alignof] = ACTIONS(3375),
    [anon_sym_offsetof] = ACTIONS(3375),
    [anon_sym__Generic] = ACTIONS(3375),
    [anon_sym_asm] = ACTIONS(3375),
    [anon_sym___asm__] = ACTIONS(3375),
    [aux_sym_number_literal_token1] = ACTIONS(3377),
    [aux_sym_number_literal_token2] = ACTIONS(3375),
    [anon_sym_L_SQUOTE] = ACTIONS(3377),
    [anon_sym_u_SQUOTE] = ACTIONS(3377),
    [anon_sym_U_SQUOTE] = ACTIONS(3377),
    [anon_sym_u8_SQUOTE] = ACTIONS(3377),
    [anon_sym_SQUOTE] = ACTIONS(3377),
    [anon_sym_L_DQUOTE] = ACTIONS(3377),
    [anon_sym_u_DQUOTE] = ACTIONS(3377),
    [anon_sym_U_DQUOTE] = ACTIONS(3377),
    [anon_sym_u8_DQUOTE] = ACTIONS(3377),
    [anon_sym_DQUOTE] = ACTIONS(3377),
    [sym_true] = ACTIONS(3375),
    [sym_false] = ACTIONS(3375),
    [anon_sym_NULL] = ACTIONS(3375),
    [anon_sym_nullptr] = ACTIONS(3375),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3375),
    [anon_sym_decltype] = ACTIONS(3375),
    [anon_sym_virtual] = ACTIONS(3375),
    [anon_sym_alignas] = ACTIONS(3375),
    [anon_sym_explicit] = ACTIONS(3375),
    [anon_sym_typename] = ACTIONS(3375),
    [anon_sym_template] = ACTIONS(3375),
    [anon_sym_operator] = ACTIONS(3375),
    [anon_sym_try] = ACTIONS(3375),
    [anon_sym_delete] = ACTIONS(3375),
    [anon_sym_throw] = ACTIONS(3375),
    [anon_sym_namespace] = ACTIONS(3375),
    [anon_sym_using] = ACTIONS(3375),
    [anon_sym_static_assert] = ACTIONS(3375),
    [anon_sym_concept] = ACTIONS(3375),
    [anon_sym_co_return] = ACTIONS(3375),
    [anon_sym_co_yield] = ACTIONS(3375),
    [anon_sym_R_DQUOTE] = ACTIONS(3377),
    [anon_sym_LR_DQUOTE] = ACTIONS(3377),
    [anon_sym_uR_DQUOTE] = ACTIONS(3377),
    [anon_sym_UR_DQUOTE] = ACTIONS(3377),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3377),
    [anon_sym_co_await] = ACTIONS(3375),
    [anon_sym_new] = ACTIONS(3375),
    [anon_sym_requires] = ACTIONS(3375),
    [sym_this] = ACTIONS(3375),
  },
  [611] = {
    [sym_identifier] = ACTIONS(3431),
    [aux_sym_preproc_include_token1] = ACTIONS(3431),
    [aux_sym_preproc_def_token1] = ACTIONS(3431),
    [aux_sym_preproc_if_token1] = ACTIONS(3431),
    [aux_sym_preproc_if_token2] = ACTIONS(3431),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3431),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3431),
    [aux_sym_preproc_else_token1] = ACTIONS(3431),
    [aux_sym_preproc_elif_token1] = ACTIONS(3431),
    [sym_preproc_directive] = ACTIONS(3431),
    [anon_sym_LPAREN2] = ACTIONS(3433),
    [anon_sym_BANG] = ACTIONS(3433),
    [anon_sym_TILDE] = ACTIONS(3433),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3433),
    [anon_sym_AMP_AMP] = ACTIONS(3433),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_SEMI] = ACTIONS(3433),
    [anon_sym___extension__] = ACTIONS(3431),
    [anon_sym_typedef] = ACTIONS(3431),
    [anon_sym_extern] = ACTIONS(3431),
    [anon_sym___attribute__] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3433),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3433),
    [anon_sym___declspec] = ACTIONS(3431),
    [anon_sym___based] = ACTIONS(3431),
    [anon_sym___cdecl] = ACTIONS(3431),
    [anon_sym___clrcall] = ACTIONS(3431),
    [anon_sym___stdcall] = ACTIONS(3431),
    [anon_sym___fastcall] = ACTIONS(3431),
    [anon_sym___thiscall] = ACTIONS(3431),
    [anon_sym___vectorcall] = ACTIONS(3431),
    [anon_sym_LBRACE] = ACTIONS(3433),
    [anon_sym_signed] = ACTIONS(3431),
    [anon_sym_unsigned] = ACTIONS(3431),
    [anon_sym_long] = ACTIONS(3431),
    [anon_sym_short] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_static] = ACTIONS(3431),
    [anon_sym_register] = ACTIONS(3431),
    [anon_sym_inline] = ACTIONS(3431),
    [anon_sym___inline] = ACTIONS(3431),
    [anon_sym___inline__] = ACTIONS(3431),
    [anon_sym___forceinline] = ACTIONS(3431),
    [anon_sym_thread_local] = ACTIONS(3431),
    [anon_sym___thread] = ACTIONS(3431),
    [anon_sym_const] = ACTIONS(3431),
    [anon_sym_constexpr] = ACTIONS(3431),
    [anon_sym_volatile] = ACTIONS(3431),
    [anon_sym_restrict] = ACTIONS(3431),
    [anon_sym___restrict__] = ACTIONS(3431),
    [anon_sym__Atomic] = ACTIONS(3431),
    [anon_sym__Noreturn] = ACTIONS(3431),
    [anon_sym_noreturn] = ACTIONS(3431),
    [anon_sym_mutable] = ACTIONS(3431),
    [anon_sym_constinit] = ACTIONS(3431),
    [anon_sym_consteval] = ACTIONS(3431),
    [anon_sym_PROGMEM] = ACTIONS(3431),
    [aux_sym_primitive_type_token1] = ACTIONS(3431),
    [anon_sym_byte] = ACTIONS(3431),
    [anon_sym_word] = ACTIONS(3431),
    [anon_sym_enum] = ACTIONS(3431),
    [anon_sym_class] = ACTIONS(3431),
    [anon_sym_struct] = ACTIONS(3431),
    [anon_sym_union] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_switch] = ACTIONS(3431),
    [anon_sym_case] = ACTIONS(3431),
    [anon_sym_default] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_break] = ACTIONS(3431),
    [anon_sym_continue] = ACTIONS(3431),
    [anon_sym_goto] = ACTIONS(3431),
    [anon_sym___try] = ACTIONS(3431),
    [anon_sym___leave] = ACTIONS(3431),
    [anon_sym_not] = ACTIONS(3431),
    [anon_sym_compl] = ACTIONS(3431),
    [anon_sym_DASH_DASH] = ACTIONS(3433),
    [anon_sym_PLUS_PLUS] = ACTIONS(3433),
    [anon_sym_sizeof] = ACTIONS(3431),
    [anon_sym___alignof__] = ACTIONS(3431),
    [anon_sym___alignof] = ACTIONS(3431),
    [anon_sym__alignof] = ACTIONS(3431),
    [anon_sym_alignof] = ACTIONS(3431),
    [anon_sym__Alignof] = ACTIONS(3431),
    [anon_sym_offsetof] = ACTIONS(3431),
    [anon_sym__Generic] = ACTIONS(3431),
    [anon_sym_asm] = ACTIONS(3431),
    [anon_sym___asm__] = ACTIONS(3431),
    [aux_sym_number_literal_token1] = ACTIONS(3433),
    [aux_sym_number_literal_token2] = ACTIONS(3431),
    [anon_sym_L_SQUOTE] = ACTIONS(3433),
    [anon_sym_u_SQUOTE] = ACTIONS(3433),
    [anon_sym_U_SQUOTE] = ACTIONS(3433),
    [anon_sym_u8_SQUOTE] = ACTIONS(3433),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [anon_sym_L_DQUOTE] = ACTIONS(3433),
    [anon_sym_u_DQUOTE] = ACTIONS(3433),
    [anon_sym_U_DQUOTE] = ACTIONS(3433),
    [anon_sym_u8_DQUOTE] = ACTIONS(3433),
    [anon_sym_DQUOTE] = ACTIONS(3433),
    [sym_true] = ACTIONS(3431),
    [sym_false] = ACTIONS(3431),
    [anon_sym_NULL] = ACTIONS(3431),
    [anon_sym_nullptr] = ACTIONS(3431),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3431),
    [anon_sym_decltype] = ACTIONS(3431),
    [anon_sym_virtual] = ACTIONS(3431),
    [anon_sym_alignas] = ACTIONS(3431),
    [anon_sym_explicit] = ACTIONS(3431),
    [anon_sym_typename] = ACTIONS(3431),
    [anon_sym_template] = ACTIONS(3431),
    [anon_sym_operator] = ACTIONS(3431),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_delete] = ACTIONS(3431),
    [anon_sym_throw] = ACTIONS(3431),
    [anon_sym_namespace] = ACTIONS(3431),
    [anon_sym_using] = ACTIONS(3431),
    [anon_sym_static_assert] = ACTIONS(3431),
    [anon_sym_concept] = ACTIONS(3431),
    [anon_sym_co_return] = ACTIONS(3431),
    [anon_sym_co_yield] = ACTIONS(3431),
    [anon_sym_R_DQUOTE] = ACTIONS(3433),
    [anon_sym_LR_DQUOTE] = ACTIONS(3433),
    [anon_sym_uR_DQUOTE] = ACTIONS(3433),
    [anon_sym_UR_DQUOTE] = ACTIONS(3433),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3433),
    [anon_sym_co_await] = ACTIONS(3431),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_requires] = ACTIONS(3431),
    [sym_this] = ACTIONS(3431),
  },
  [612] = {
    [sym_identifier] = ACTIONS(3379),
    [aux_sym_preproc_include_token1] = ACTIONS(3379),
    [aux_sym_preproc_def_token1] = ACTIONS(3379),
    [aux_sym_preproc_if_token1] = ACTIONS(3379),
    [aux_sym_preproc_if_token2] = ACTIONS(3379),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3379),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3379),
    [aux_sym_preproc_else_token1] = ACTIONS(3379),
    [aux_sym_preproc_elif_token1] = ACTIONS(3379),
    [sym_preproc_directive] = ACTIONS(3379),
    [anon_sym_LPAREN2] = ACTIONS(3381),
    [anon_sym_BANG] = ACTIONS(3381),
    [anon_sym_TILDE] = ACTIONS(3381),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_STAR] = ACTIONS(3381),
    [anon_sym_AMP_AMP] = ACTIONS(3381),
    [anon_sym_AMP] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3381),
    [anon_sym___extension__] = ACTIONS(3379),
    [anon_sym_typedef] = ACTIONS(3379),
    [anon_sym_extern] = ACTIONS(3379),
    [anon_sym___attribute__] = ACTIONS(3379),
    [anon_sym_COLON_COLON] = ACTIONS(3381),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3381),
    [anon_sym___declspec] = ACTIONS(3379),
    [anon_sym___based] = ACTIONS(3379),
    [anon_sym___cdecl] = ACTIONS(3379),
    [anon_sym___clrcall] = ACTIONS(3379),
    [anon_sym___stdcall] = ACTIONS(3379),
    [anon_sym___fastcall] = ACTIONS(3379),
    [anon_sym___thiscall] = ACTIONS(3379),
    [anon_sym___vectorcall] = ACTIONS(3379),
    [anon_sym_LBRACE] = ACTIONS(3381),
    [anon_sym_signed] = ACTIONS(3379),
    [anon_sym_unsigned] = ACTIONS(3379),
    [anon_sym_long] = ACTIONS(3379),
    [anon_sym_short] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_register] = ACTIONS(3379),
    [anon_sym_inline] = ACTIONS(3379),
    [anon_sym___inline] = ACTIONS(3379),
    [anon_sym___inline__] = ACTIONS(3379),
    [anon_sym___forceinline] = ACTIONS(3379),
    [anon_sym_thread_local] = ACTIONS(3379),
    [anon_sym___thread] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_constexpr] = ACTIONS(3379),
    [anon_sym_volatile] = ACTIONS(3379),
    [anon_sym_restrict] = ACTIONS(3379),
    [anon_sym___restrict__] = ACTIONS(3379),
    [anon_sym__Atomic] = ACTIONS(3379),
    [anon_sym__Noreturn] = ACTIONS(3379),
    [anon_sym_noreturn] = ACTIONS(3379),
    [anon_sym_mutable] = ACTIONS(3379),
    [anon_sym_constinit] = ACTIONS(3379),
    [anon_sym_consteval] = ACTIONS(3379),
    [anon_sym_PROGMEM] = ACTIONS(3379),
    [aux_sym_primitive_type_token1] = ACTIONS(3379),
    [anon_sym_byte] = ACTIONS(3379),
    [anon_sym_word] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_struct] = ACTIONS(3379),
    [anon_sym_union] = ACTIONS(3379),
    [anon_sym_if] = ACTIONS(3379),
    [anon_sym_switch] = ACTIONS(3379),
    [anon_sym_case] = ACTIONS(3379),
    [anon_sym_default] = ACTIONS(3379),
    [anon_sym_while] = ACTIONS(3379),
    [anon_sym_do] = ACTIONS(3379),
    [anon_sym_for] = ACTIONS(3379),
    [anon_sym_return] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(3379),
    [anon_sym_continue] = ACTIONS(3379),
    [anon_sym_goto] = ACTIONS(3379),
    [anon_sym___try] = ACTIONS(3379),
    [anon_sym___leave] = ACTIONS(3379),
    [anon_sym_not] = ACTIONS(3379),
    [anon_sym_compl] = ACTIONS(3379),
    [anon_sym_DASH_DASH] = ACTIONS(3381),
    [anon_sym_PLUS_PLUS] = ACTIONS(3381),
    [anon_sym_sizeof] = ACTIONS(3379),
    [anon_sym___alignof__] = ACTIONS(3379),
    [anon_sym___alignof] = ACTIONS(3379),
    [anon_sym__alignof] = ACTIONS(3379),
    [anon_sym_alignof] = ACTIONS(3379),
    [anon_sym__Alignof] = ACTIONS(3379),
    [anon_sym_offsetof] = ACTIONS(3379),
    [anon_sym__Generic] = ACTIONS(3379),
    [anon_sym_asm] = ACTIONS(3379),
    [anon_sym___asm__] = ACTIONS(3379),
    [aux_sym_number_literal_token1] = ACTIONS(3381),
    [aux_sym_number_literal_token2] = ACTIONS(3379),
    [anon_sym_L_SQUOTE] = ACTIONS(3381),
    [anon_sym_u_SQUOTE] = ACTIONS(3381),
    [anon_sym_U_SQUOTE] = ACTIONS(3381),
    [anon_sym_u8_SQUOTE] = ACTIONS(3381),
    [anon_sym_SQUOTE] = ACTIONS(3381),
    [anon_sym_L_DQUOTE] = ACTIONS(3381),
    [anon_sym_u_DQUOTE] = ACTIONS(3381),
    [anon_sym_U_DQUOTE] = ACTIONS(3381),
    [anon_sym_u8_DQUOTE] = ACTIONS(3381),
    [anon_sym_DQUOTE] = ACTIONS(3381),
    [sym_true] = ACTIONS(3379),
    [sym_false] = ACTIONS(3379),
    [anon_sym_NULL] = ACTIONS(3379),
    [anon_sym_nullptr] = ACTIONS(3379),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3379),
    [anon_sym_decltype] = ACTIONS(3379),
    [anon_sym_virtual] = ACTIONS(3379),
    [anon_sym_alignas] = ACTIONS(3379),
    [anon_sym_explicit] = ACTIONS(3379),
    [anon_sym_typename] = ACTIONS(3379),
    [anon_sym_template] = ACTIONS(3379),
    [anon_sym_operator] = ACTIONS(3379),
    [anon_sym_try] = ACTIONS(3379),
    [anon_sym_delete] = ACTIONS(3379),
    [anon_sym_throw] = ACTIONS(3379),
    [anon_sym_namespace] = ACTIONS(3379),
    [anon_sym_using] = ACTIONS(3379),
    [anon_sym_static_assert] = ACTIONS(3379),
    [anon_sym_concept] = ACTIONS(3379),
    [anon_sym_co_return] = ACTIONS(3379),
    [anon_sym_co_yield] = ACTIONS(3379),
    [anon_sym_R_DQUOTE] = ACTIONS(3381),
    [anon_sym_LR_DQUOTE] = ACTIONS(3381),
    [anon_sym_uR_DQUOTE] = ACTIONS(3381),
    [anon_sym_UR_DQUOTE] = ACTIONS(3381),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3381),
    [anon_sym_co_await] = ACTIONS(3379),
    [anon_sym_new] = ACTIONS(3379),
    [anon_sym_requires] = ACTIONS(3379),
    [sym_this] = ACTIONS(3379),
  },
  [613] = {
    [ts_builtin_sym_end] = ACTIONS(2889),
    [sym_identifier] = ACTIONS(2887),
    [aux_sym_preproc_include_token1] = ACTIONS(2887),
    [aux_sym_preproc_def_token1] = ACTIONS(2887),
    [aux_sym_preproc_if_token1] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2887),
    [sym_preproc_directive] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2889),
    [anon_sym_BANG] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2887),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_SEMI] = ACTIONS(2889),
    [anon_sym___extension__] = ACTIONS(2887),
    [anon_sym_typedef] = ACTIONS(2887),
    [anon_sym_extern] = ACTIONS(2887),
    [anon_sym___attribute__] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2889),
    [anon_sym___declspec] = ACTIONS(2887),
    [anon_sym___based] = ACTIONS(2887),
    [anon_sym___cdecl] = ACTIONS(2887),
    [anon_sym___clrcall] = ACTIONS(2887),
    [anon_sym___stdcall] = ACTIONS(2887),
    [anon_sym___fastcall] = ACTIONS(2887),
    [anon_sym___thiscall] = ACTIONS(2887),
    [anon_sym___vectorcall] = ACTIONS(2887),
    [anon_sym_LBRACE] = ACTIONS(2889),
    [anon_sym_signed] = ACTIONS(2887),
    [anon_sym_unsigned] = ACTIONS(2887),
    [anon_sym_long] = ACTIONS(2887),
    [anon_sym_short] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_static] = ACTIONS(2887),
    [anon_sym_register] = ACTIONS(2887),
    [anon_sym_inline] = ACTIONS(2887),
    [anon_sym___inline] = ACTIONS(2887),
    [anon_sym___inline__] = ACTIONS(2887),
    [anon_sym___forceinline] = ACTIONS(2887),
    [anon_sym_thread_local] = ACTIONS(2887),
    [anon_sym___thread] = ACTIONS(2887),
    [anon_sym_const] = ACTIONS(2887),
    [anon_sym_constexpr] = ACTIONS(2887),
    [anon_sym_volatile] = ACTIONS(2887),
    [anon_sym_restrict] = ACTIONS(2887),
    [anon_sym___restrict__] = ACTIONS(2887),
    [anon_sym__Atomic] = ACTIONS(2887),
    [anon_sym__Noreturn] = ACTIONS(2887),
    [anon_sym_noreturn] = ACTIONS(2887),
    [anon_sym_mutable] = ACTIONS(2887),
    [anon_sym_constinit] = ACTIONS(2887),
    [anon_sym_consteval] = ACTIONS(2887),
    [anon_sym_PROGMEM] = ACTIONS(2887),
    [aux_sym_primitive_type_token1] = ACTIONS(2887),
    [anon_sym_byte] = ACTIONS(2887),
    [anon_sym_word] = ACTIONS(2887),
    [anon_sym_enum] = ACTIONS(2887),
    [anon_sym_class] = ACTIONS(2887),
    [anon_sym_struct] = ACTIONS(2887),
    [anon_sym_union] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_else] = ACTIONS(2887),
    [anon_sym_switch] = ACTIONS(2887),
    [anon_sym_case] = ACTIONS(2887),
    [anon_sym_default] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2887),
    [anon_sym_for] = ACTIONS(2887),
    [anon_sym_return] = ACTIONS(2887),
    [anon_sym_break] = ACTIONS(2887),
    [anon_sym_continue] = ACTIONS(2887),
    [anon_sym_goto] = ACTIONS(2887),
    [anon_sym___try] = ACTIONS(2887),
    [anon_sym___leave] = ACTIONS(2887),
    [anon_sym_not] = ACTIONS(2887),
    [anon_sym_compl] = ACTIONS(2887),
    [anon_sym_DASH_DASH] = ACTIONS(2889),
    [anon_sym_PLUS_PLUS] = ACTIONS(2889),
    [anon_sym_sizeof] = ACTIONS(2887),
    [anon_sym___alignof__] = ACTIONS(2887),
    [anon_sym___alignof] = ACTIONS(2887),
    [anon_sym__alignof] = ACTIONS(2887),
    [anon_sym_alignof] = ACTIONS(2887),
    [anon_sym__Alignof] = ACTIONS(2887),
    [anon_sym_offsetof] = ACTIONS(2887),
    [anon_sym__Generic] = ACTIONS(2887),
    [anon_sym_asm] = ACTIONS(2887),
    [anon_sym___asm__] = ACTIONS(2887),
    [aux_sym_number_literal_token1] = ACTIONS(2889),
    [aux_sym_number_literal_token2] = ACTIONS(2887),
    [anon_sym_L_SQUOTE] = ACTIONS(2889),
    [anon_sym_u_SQUOTE] = ACTIONS(2889),
    [anon_sym_U_SQUOTE] = ACTIONS(2889),
    [anon_sym_u8_SQUOTE] = ACTIONS(2889),
    [anon_sym_SQUOTE] = ACTIONS(2889),
    [anon_sym_L_DQUOTE] = ACTIONS(2889),
    [anon_sym_u_DQUOTE] = ACTIONS(2889),
    [anon_sym_U_DQUOTE] = ACTIONS(2889),
    [anon_sym_u8_DQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE] = ACTIONS(2889),
    [sym_true] = ACTIONS(2887),
    [sym_false] = ACTIONS(2887),
    [anon_sym_NULL] = ACTIONS(2887),
    [anon_sym_nullptr] = ACTIONS(2887),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2887),
    [anon_sym_decltype] = ACTIONS(2887),
    [anon_sym_virtual] = ACTIONS(2887),
    [anon_sym_alignas] = ACTIONS(2887),
    [anon_sym_explicit] = ACTIONS(2887),
    [anon_sym_typename] = ACTIONS(2887),
    [anon_sym_template] = ACTIONS(2887),
    [anon_sym_operator] = ACTIONS(2887),
    [anon_sym_try] = ACTIONS(2887),
    [anon_sym_delete] = ACTIONS(2887),
    [anon_sym_throw] = ACTIONS(2887),
    [anon_sym_namespace] = ACTIONS(2887),
    [anon_sym_using] = ACTIONS(2887),
    [anon_sym_static_assert] = ACTIONS(2887),
    [anon_sym_concept] = ACTIONS(2887),
    [anon_sym_co_return] = ACTIONS(2887),
    [anon_sym_co_yield] = ACTIONS(2887),
    [anon_sym_catch] = ACTIONS(2887),
    [anon_sym_R_DQUOTE] = ACTIONS(2889),
    [anon_sym_LR_DQUOTE] = ACTIONS(2889),
    [anon_sym_uR_DQUOTE] = ACTIONS(2889),
    [anon_sym_UR_DQUOTE] = ACTIONS(2889),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2889),
    [anon_sym_co_await] = ACTIONS(2887),
    [anon_sym_new] = ACTIONS(2887),
    [anon_sym_requires] = ACTIONS(2887),
    [sym_this] = ACTIONS(2887),
  },
  [614] = {
    [sym_identifier] = ACTIONS(3411),
    [aux_sym_preproc_include_token1] = ACTIONS(3411),
    [aux_sym_preproc_def_token1] = ACTIONS(3411),
    [aux_sym_preproc_if_token1] = ACTIONS(3411),
    [aux_sym_preproc_if_token2] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3411),
    [aux_sym_preproc_else_token1] = ACTIONS(3411),
    [aux_sym_preproc_elif_token1] = ACTIONS(3411),
    [sym_preproc_directive] = ACTIONS(3411),
    [anon_sym_LPAREN2] = ACTIONS(3413),
    [anon_sym_BANG] = ACTIONS(3413),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_DASH] = ACTIONS(3411),
    [anon_sym_PLUS] = ACTIONS(3411),
    [anon_sym_STAR] = ACTIONS(3413),
    [anon_sym_AMP_AMP] = ACTIONS(3413),
    [anon_sym_AMP] = ACTIONS(3411),
    [anon_sym_SEMI] = ACTIONS(3413),
    [anon_sym___extension__] = ACTIONS(3411),
    [anon_sym_typedef] = ACTIONS(3411),
    [anon_sym_extern] = ACTIONS(3411),
    [anon_sym___attribute__] = ACTIONS(3411),
    [anon_sym_COLON_COLON] = ACTIONS(3413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3413),
    [anon_sym___declspec] = ACTIONS(3411),
    [anon_sym___based] = ACTIONS(3411),
    [anon_sym___cdecl] = ACTIONS(3411),
    [anon_sym___clrcall] = ACTIONS(3411),
    [anon_sym___stdcall] = ACTIONS(3411),
    [anon_sym___fastcall] = ACTIONS(3411),
    [anon_sym___thiscall] = ACTIONS(3411),
    [anon_sym___vectorcall] = ACTIONS(3411),
    [anon_sym_LBRACE] = ACTIONS(3413),
    [anon_sym_signed] = ACTIONS(3411),
    [anon_sym_unsigned] = ACTIONS(3411),
    [anon_sym_long] = ACTIONS(3411),
    [anon_sym_short] = ACTIONS(3411),
    [anon_sym_LBRACK] = ACTIONS(3411),
    [anon_sym_static] = ACTIONS(3411),
    [anon_sym_register] = ACTIONS(3411),
    [anon_sym_inline] = ACTIONS(3411),
    [anon_sym___inline] = ACTIONS(3411),
    [anon_sym___inline__] = ACTIONS(3411),
    [anon_sym___forceinline] = ACTIONS(3411),
    [anon_sym_thread_local] = ACTIONS(3411),
    [anon_sym___thread] = ACTIONS(3411),
    [anon_sym_const] = ACTIONS(3411),
    [anon_sym_constexpr] = ACTIONS(3411),
    [anon_sym_volatile] = ACTIONS(3411),
    [anon_sym_restrict] = ACTIONS(3411),
    [anon_sym___restrict__] = ACTIONS(3411),
    [anon_sym__Atomic] = ACTIONS(3411),
    [anon_sym__Noreturn] = ACTIONS(3411),
    [anon_sym_noreturn] = ACTIONS(3411),
    [anon_sym_mutable] = ACTIONS(3411),
    [anon_sym_constinit] = ACTIONS(3411),
    [anon_sym_consteval] = ACTIONS(3411),
    [anon_sym_PROGMEM] = ACTIONS(3411),
    [aux_sym_primitive_type_token1] = ACTIONS(3411),
    [anon_sym_byte] = ACTIONS(3411),
    [anon_sym_word] = ACTIONS(3411),
    [anon_sym_enum] = ACTIONS(3411),
    [anon_sym_class] = ACTIONS(3411),
    [anon_sym_struct] = ACTIONS(3411),
    [anon_sym_union] = ACTIONS(3411),
    [anon_sym_if] = ACTIONS(3411),
    [anon_sym_switch] = ACTIONS(3411),
    [anon_sym_case] = ACTIONS(3411),
    [anon_sym_default] = ACTIONS(3411),
    [anon_sym_while] = ACTIONS(3411),
    [anon_sym_do] = ACTIONS(3411),
    [anon_sym_for] = ACTIONS(3411),
    [anon_sym_return] = ACTIONS(3411),
    [anon_sym_break] = ACTIONS(3411),
    [anon_sym_continue] = ACTIONS(3411),
    [anon_sym_goto] = ACTIONS(3411),
    [anon_sym___try] = ACTIONS(3411),
    [anon_sym___leave] = ACTIONS(3411),
    [anon_sym_not] = ACTIONS(3411),
    [anon_sym_compl] = ACTIONS(3411),
    [anon_sym_DASH_DASH] = ACTIONS(3413),
    [anon_sym_PLUS_PLUS] = ACTIONS(3413),
    [anon_sym_sizeof] = ACTIONS(3411),
    [anon_sym___alignof__] = ACTIONS(3411),
    [anon_sym___alignof] = ACTIONS(3411),
    [anon_sym__alignof] = ACTIONS(3411),
    [anon_sym_alignof] = ACTIONS(3411),
    [anon_sym__Alignof] = ACTIONS(3411),
    [anon_sym_offsetof] = ACTIONS(3411),
    [anon_sym__Generic] = ACTIONS(3411),
    [anon_sym_asm] = ACTIONS(3411),
    [anon_sym___asm__] = ACTIONS(3411),
    [aux_sym_number_literal_token1] = ACTIONS(3413),
    [aux_sym_number_literal_token2] = ACTIONS(3411),
    [anon_sym_L_SQUOTE] = ACTIONS(3413),
    [anon_sym_u_SQUOTE] = ACTIONS(3413),
    [anon_sym_U_SQUOTE] = ACTIONS(3413),
    [anon_sym_u8_SQUOTE] = ACTIONS(3413),
    [anon_sym_SQUOTE] = ACTIONS(3413),
    [anon_sym_L_DQUOTE] = ACTIONS(3413),
    [anon_sym_u_DQUOTE] = ACTIONS(3413),
    [anon_sym_U_DQUOTE] = ACTIONS(3413),
    [anon_sym_u8_DQUOTE] = ACTIONS(3413),
    [anon_sym_DQUOTE] = ACTIONS(3413),
    [sym_true] = ACTIONS(3411),
    [sym_false] = ACTIONS(3411),
    [anon_sym_NULL] = ACTIONS(3411),
    [anon_sym_nullptr] = ACTIONS(3411),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3411),
    [anon_sym_decltype] = ACTIONS(3411),
    [anon_sym_virtual] = ACTIONS(3411),
    [anon_sym_alignas] = ACTIONS(3411),
    [anon_sym_explicit] = ACTIONS(3411),
    [anon_sym_typename] = ACTIONS(3411),
    [anon_sym_template] = ACTIONS(3411),
    [anon_sym_operator] = ACTIONS(3411),
    [anon_sym_try] = ACTIONS(3411),
    [anon_sym_delete] = ACTIONS(3411),
    [anon_sym_throw] = ACTIONS(3411),
    [anon_sym_namespace] = ACTIONS(3411),
    [anon_sym_using] = ACTIONS(3411),
    [anon_sym_static_assert] = ACTIONS(3411),
    [anon_sym_concept] = ACTIONS(3411),
    [anon_sym_co_return] = ACTIONS(3411),
    [anon_sym_co_yield] = ACTIONS(3411),
    [anon_sym_R_DQUOTE] = ACTIONS(3413),
    [anon_sym_LR_DQUOTE] = ACTIONS(3413),
    [anon_sym_uR_DQUOTE] = ACTIONS(3413),
    [anon_sym_UR_DQUOTE] = ACTIONS(3413),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3413),
    [anon_sym_co_await] = ACTIONS(3411),
    [anon_sym_new] = ACTIONS(3411),
    [anon_sym_requires] = ACTIONS(3411),
    [sym_this] = ACTIONS(3411),
  },
  [615] = {
    [sym_identifier] = ACTIONS(3407),
    [aux_sym_preproc_include_token1] = ACTIONS(3407),
    [aux_sym_preproc_def_token1] = ACTIONS(3407),
    [aux_sym_preproc_if_token1] = ACTIONS(3407),
    [aux_sym_preproc_if_token2] = ACTIONS(3407),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3407),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3407),
    [aux_sym_preproc_else_token1] = ACTIONS(3407),
    [aux_sym_preproc_elif_token1] = ACTIONS(3407),
    [sym_preproc_directive] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3409),
    [anon_sym_TILDE] = ACTIONS(3409),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_AMP_AMP] = ACTIONS(3409),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_SEMI] = ACTIONS(3409),
    [anon_sym___extension__] = ACTIONS(3407),
    [anon_sym_typedef] = ACTIONS(3407),
    [anon_sym_extern] = ACTIONS(3407),
    [anon_sym___attribute__] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3409),
    [anon_sym___declspec] = ACTIONS(3407),
    [anon_sym___based] = ACTIONS(3407),
    [anon_sym___cdecl] = ACTIONS(3407),
    [anon_sym___clrcall] = ACTIONS(3407),
    [anon_sym___stdcall] = ACTIONS(3407),
    [anon_sym___fastcall] = ACTIONS(3407),
    [anon_sym___thiscall] = ACTIONS(3407),
    [anon_sym___vectorcall] = ACTIONS(3407),
    [anon_sym_LBRACE] = ACTIONS(3409),
    [anon_sym_signed] = ACTIONS(3407),
    [anon_sym_unsigned] = ACTIONS(3407),
    [anon_sym_long] = ACTIONS(3407),
    [anon_sym_short] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_register] = ACTIONS(3407),
    [anon_sym_inline] = ACTIONS(3407),
    [anon_sym___inline] = ACTIONS(3407),
    [anon_sym___inline__] = ACTIONS(3407),
    [anon_sym___forceinline] = ACTIONS(3407),
    [anon_sym_thread_local] = ACTIONS(3407),
    [anon_sym___thread] = ACTIONS(3407),
    [anon_sym_const] = ACTIONS(3407),
    [anon_sym_constexpr] = ACTIONS(3407),
    [anon_sym_volatile] = ACTIONS(3407),
    [anon_sym_restrict] = ACTIONS(3407),
    [anon_sym___restrict__] = ACTIONS(3407),
    [anon_sym__Atomic] = ACTIONS(3407),
    [anon_sym__Noreturn] = ACTIONS(3407),
    [anon_sym_noreturn] = ACTIONS(3407),
    [anon_sym_mutable] = ACTIONS(3407),
    [anon_sym_constinit] = ACTIONS(3407),
    [anon_sym_consteval] = ACTIONS(3407),
    [anon_sym_PROGMEM] = ACTIONS(3407),
    [aux_sym_primitive_type_token1] = ACTIONS(3407),
    [anon_sym_byte] = ACTIONS(3407),
    [anon_sym_word] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3407),
    [anon_sym_class] = ACTIONS(3407),
    [anon_sym_struct] = ACTIONS(3407),
    [anon_sym_union] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_switch] = ACTIONS(3407),
    [anon_sym_case] = ACTIONS(3407),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_break] = ACTIONS(3407),
    [anon_sym_continue] = ACTIONS(3407),
    [anon_sym_goto] = ACTIONS(3407),
    [anon_sym___try] = ACTIONS(3407),
    [anon_sym___leave] = ACTIONS(3407),
    [anon_sym_not] = ACTIONS(3407),
    [anon_sym_compl] = ACTIONS(3407),
    [anon_sym_DASH_DASH] = ACTIONS(3409),
    [anon_sym_PLUS_PLUS] = ACTIONS(3409),
    [anon_sym_sizeof] = ACTIONS(3407),
    [anon_sym___alignof__] = ACTIONS(3407),
    [anon_sym___alignof] = ACTIONS(3407),
    [anon_sym__alignof] = ACTIONS(3407),
    [anon_sym_alignof] = ACTIONS(3407),
    [anon_sym__Alignof] = ACTIONS(3407),
    [anon_sym_offsetof] = ACTIONS(3407),
    [anon_sym__Generic] = ACTIONS(3407),
    [anon_sym_asm] = ACTIONS(3407),
    [anon_sym___asm__] = ACTIONS(3407),
    [aux_sym_number_literal_token1] = ACTIONS(3409),
    [aux_sym_number_literal_token2] = ACTIONS(3407),
    [anon_sym_L_SQUOTE] = ACTIONS(3409),
    [anon_sym_u_SQUOTE] = ACTIONS(3409),
    [anon_sym_U_SQUOTE] = ACTIONS(3409),
    [anon_sym_u8_SQUOTE] = ACTIONS(3409),
    [anon_sym_SQUOTE] = ACTIONS(3409),
    [anon_sym_L_DQUOTE] = ACTIONS(3409),
    [anon_sym_u_DQUOTE] = ACTIONS(3409),
    [anon_sym_U_DQUOTE] = ACTIONS(3409),
    [anon_sym_u8_DQUOTE] = ACTIONS(3409),
    [anon_sym_DQUOTE] = ACTIONS(3409),
    [sym_true] = ACTIONS(3407),
    [sym_false] = ACTIONS(3407),
    [anon_sym_NULL] = ACTIONS(3407),
    [anon_sym_nullptr] = ACTIONS(3407),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3407),
    [anon_sym_decltype] = ACTIONS(3407),
    [anon_sym_virtual] = ACTIONS(3407),
    [anon_sym_alignas] = ACTIONS(3407),
    [anon_sym_explicit] = ACTIONS(3407),
    [anon_sym_typename] = ACTIONS(3407),
    [anon_sym_template] = ACTIONS(3407),
    [anon_sym_operator] = ACTIONS(3407),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_delete] = ACTIONS(3407),
    [anon_sym_throw] = ACTIONS(3407),
    [anon_sym_namespace] = ACTIONS(3407),
    [anon_sym_using] = ACTIONS(3407),
    [anon_sym_static_assert] = ACTIONS(3407),
    [anon_sym_concept] = ACTIONS(3407),
    [anon_sym_co_return] = ACTIONS(3407),
    [anon_sym_co_yield] = ACTIONS(3407),
    [anon_sym_R_DQUOTE] = ACTIONS(3409),
    [anon_sym_LR_DQUOTE] = ACTIONS(3409),
    [anon_sym_uR_DQUOTE] = ACTIONS(3409),
    [anon_sym_UR_DQUOTE] = ACTIONS(3409),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3409),
    [anon_sym_co_await] = ACTIONS(3407),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_requires] = ACTIONS(3407),
    [sym_this] = ACTIONS(3407),
  },
  [616] = {
    [sym_identifier] = ACTIONS(3391),
    [aux_sym_preproc_include_token1] = ACTIONS(3391),
    [aux_sym_preproc_def_token1] = ACTIONS(3391),
    [aux_sym_preproc_if_token1] = ACTIONS(3391),
    [aux_sym_preproc_if_token2] = ACTIONS(3391),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3391),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3391),
    [aux_sym_preproc_else_token1] = ACTIONS(3391),
    [aux_sym_preproc_elif_token1] = ACTIONS(3391),
    [sym_preproc_directive] = ACTIONS(3391),
    [anon_sym_LPAREN2] = ACTIONS(3393),
    [anon_sym_BANG] = ACTIONS(3393),
    [anon_sym_TILDE] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_STAR] = ACTIONS(3393),
    [anon_sym_AMP_AMP] = ACTIONS(3393),
    [anon_sym_AMP] = ACTIONS(3391),
    [anon_sym_SEMI] = ACTIONS(3393),
    [anon_sym___extension__] = ACTIONS(3391),
    [anon_sym_typedef] = ACTIONS(3391),
    [anon_sym_extern] = ACTIONS(3391),
    [anon_sym___attribute__] = ACTIONS(3391),
    [anon_sym_COLON_COLON] = ACTIONS(3393),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3393),
    [anon_sym___declspec] = ACTIONS(3391),
    [anon_sym___based] = ACTIONS(3391),
    [anon_sym___cdecl] = ACTIONS(3391),
    [anon_sym___clrcall] = ACTIONS(3391),
    [anon_sym___stdcall] = ACTIONS(3391),
    [anon_sym___fastcall] = ACTIONS(3391),
    [anon_sym___thiscall] = ACTIONS(3391),
    [anon_sym___vectorcall] = ACTIONS(3391),
    [anon_sym_LBRACE] = ACTIONS(3393),
    [anon_sym_signed] = ACTIONS(3391),
    [anon_sym_unsigned] = ACTIONS(3391),
    [anon_sym_long] = ACTIONS(3391),
    [anon_sym_short] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(3391),
    [anon_sym_static] = ACTIONS(3391),
    [anon_sym_register] = ACTIONS(3391),
    [anon_sym_inline] = ACTIONS(3391),
    [anon_sym___inline] = ACTIONS(3391),
    [anon_sym___inline__] = ACTIONS(3391),
    [anon_sym___forceinline] = ACTIONS(3391),
    [anon_sym_thread_local] = ACTIONS(3391),
    [anon_sym___thread] = ACTIONS(3391),
    [anon_sym_const] = ACTIONS(3391),
    [anon_sym_constexpr] = ACTIONS(3391),
    [anon_sym_volatile] = ACTIONS(3391),
    [anon_sym_restrict] = ACTIONS(3391),
    [anon_sym___restrict__] = ACTIONS(3391),
    [anon_sym__Atomic] = ACTIONS(3391),
    [anon_sym__Noreturn] = ACTIONS(3391),
    [anon_sym_noreturn] = ACTIONS(3391),
    [anon_sym_mutable] = ACTIONS(3391),
    [anon_sym_constinit] = ACTIONS(3391),
    [anon_sym_consteval] = ACTIONS(3391),
    [anon_sym_PROGMEM] = ACTIONS(3391),
    [aux_sym_primitive_type_token1] = ACTIONS(3391),
    [anon_sym_byte] = ACTIONS(3391),
    [anon_sym_word] = ACTIONS(3391),
    [anon_sym_enum] = ACTIONS(3391),
    [anon_sym_class] = ACTIONS(3391),
    [anon_sym_struct] = ACTIONS(3391),
    [anon_sym_union] = ACTIONS(3391),
    [anon_sym_if] = ACTIONS(3391),
    [anon_sym_switch] = ACTIONS(3391),
    [anon_sym_case] = ACTIONS(3391),
    [anon_sym_default] = ACTIONS(3391),
    [anon_sym_while] = ACTIONS(3391),
    [anon_sym_do] = ACTIONS(3391),
    [anon_sym_for] = ACTIONS(3391),
    [anon_sym_return] = ACTIONS(3391),
    [anon_sym_break] = ACTIONS(3391),
    [anon_sym_continue] = ACTIONS(3391),
    [anon_sym_goto] = ACTIONS(3391),
    [anon_sym___try] = ACTIONS(3391),
    [anon_sym___leave] = ACTIONS(3391),
    [anon_sym_not] = ACTIONS(3391),
    [anon_sym_compl] = ACTIONS(3391),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_sizeof] = ACTIONS(3391),
    [anon_sym___alignof__] = ACTIONS(3391),
    [anon_sym___alignof] = ACTIONS(3391),
    [anon_sym__alignof] = ACTIONS(3391),
    [anon_sym_alignof] = ACTIONS(3391),
    [anon_sym__Alignof] = ACTIONS(3391),
    [anon_sym_offsetof] = ACTIONS(3391),
    [anon_sym__Generic] = ACTIONS(3391),
    [anon_sym_asm] = ACTIONS(3391),
    [anon_sym___asm__] = ACTIONS(3391),
    [aux_sym_number_literal_token1] = ACTIONS(3393),
    [aux_sym_number_literal_token2] = ACTIONS(3391),
    [anon_sym_L_SQUOTE] = ACTIONS(3393),
    [anon_sym_u_SQUOTE] = ACTIONS(3393),
    [anon_sym_U_SQUOTE] = ACTIONS(3393),
    [anon_sym_u8_SQUOTE] = ACTIONS(3393),
    [anon_sym_SQUOTE] = ACTIONS(3393),
    [anon_sym_L_DQUOTE] = ACTIONS(3393),
    [anon_sym_u_DQUOTE] = ACTIONS(3393),
    [anon_sym_U_DQUOTE] = ACTIONS(3393),
    [anon_sym_u8_DQUOTE] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3393),
    [sym_true] = ACTIONS(3391),
    [sym_false] = ACTIONS(3391),
    [anon_sym_NULL] = ACTIONS(3391),
    [anon_sym_nullptr] = ACTIONS(3391),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3391),
    [anon_sym_decltype] = ACTIONS(3391),
    [anon_sym_virtual] = ACTIONS(3391),
    [anon_sym_alignas] = ACTIONS(3391),
    [anon_sym_explicit] = ACTIONS(3391),
    [anon_sym_typename] = ACTIONS(3391),
    [anon_sym_template] = ACTIONS(3391),
    [anon_sym_operator] = ACTIONS(3391),
    [anon_sym_try] = ACTIONS(3391),
    [anon_sym_delete] = ACTIONS(3391),
    [anon_sym_throw] = ACTIONS(3391),
    [anon_sym_namespace] = ACTIONS(3391),
    [anon_sym_using] = ACTIONS(3391),
    [anon_sym_static_assert] = ACTIONS(3391),
    [anon_sym_concept] = ACTIONS(3391),
    [anon_sym_co_return] = ACTIONS(3391),
    [anon_sym_co_yield] = ACTIONS(3391),
    [anon_sym_R_DQUOTE] = ACTIONS(3393),
    [anon_sym_LR_DQUOTE] = ACTIONS(3393),
    [anon_sym_uR_DQUOTE] = ACTIONS(3393),
    [anon_sym_UR_DQUOTE] = ACTIONS(3393),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3393),
    [anon_sym_co_await] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(3391),
    [anon_sym_requires] = ACTIONS(3391),
    [sym_this] = ACTIONS(3391),
  },
  [617] = {
    [sym_identifier] = ACTIONS(2887),
    [aux_sym_preproc_include_token1] = ACTIONS(2887),
    [aux_sym_preproc_def_token1] = ACTIONS(2887),
    [aux_sym_preproc_if_token1] = ACTIONS(2887),
    [aux_sym_preproc_if_token2] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2887),
    [sym_preproc_directive] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2889),
    [anon_sym_BANG] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2887),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_SEMI] = ACTIONS(2889),
    [anon_sym___extension__] = ACTIONS(2887),
    [anon_sym_typedef] = ACTIONS(2887),
    [anon_sym_extern] = ACTIONS(2887),
    [anon_sym___attribute__] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2889),
    [anon_sym___declspec] = ACTIONS(2887),
    [anon_sym___based] = ACTIONS(2887),
    [anon_sym___cdecl] = ACTIONS(2887),
    [anon_sym___clrcall] = ACTIONS(2887),
    [anon_sym___stdcall] = ACTIONS(2887),
    [anon_sym___fastcall] = ACTIONS(2887),
    [anon_sym___thiscall] = ACTIONS(2887),
    [anon_sym___vectorcall] = ACTIONS(2887),
    [anon_sym_LBRACE] = ACTIONS(2889),
    [anon_sym_signed] = ACTIONS(2887),
    [anon_sym_unsigned] = ACTIONS(2887),
    [anon_sym_long] = ACTIONS(2887),
    [anon_sym_short] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_static] = ACTIONS(2887),
    [anon_sym_register] = ACTIONS(2887),
    [anon_sym_inline] = ACTIONS(2887),
    [anon_sym___inline] = ACTIONS(2887),
    [anon_sym___inline__] = ACTIONS(2887),
    [anon_sym___forceinline] = ACTIONS(2887),
    [anon_sym_thread_local] = ACTIONS(2887),
    [anon_sym___thread] = ACTIONS(2887),
    [anon_sym_const] = ACTIONS(2887),
    [anon_sym_constexpr] = ACTIONS(2887),
    [anon_sym_volatile] = ACTIONS(2887),
    [anon_sym_restrict] = ACTIONS(2887),
    [anon_sym___restrict__] = ACTIONS(2887),
    [anon_sym__Atomic] = ACTIONS(2887),
    [anon_sym__Noreturn] = ACTIONS(2887),
    [anon_sym_noreturn] = ACTIONS(2887),
    [anon_sym_mutable] = ACTIONS(2887),
    [anon_sym_constinit] = ACTIONS(2887),
    [anon_sym_consteval] = ACTIONS(2887),
    [anon_sym_PROGMEM] = ACTIONS(2887),
    [aux_sym_primitive_type_token1] = ACTIONS(2887),
    [anon_sym_byte] = ACTIONS(2887),
    [anon_sym_word] = ACTIONS(2887),
    [anon_sym_enum] = ACTIONS(2887),
    [anon_sym_class] = ACTIONS(2887),
    [anon_sym_struct] = ACTIONS(2887),
    [anon_sym_union] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_else] = ACTIONS(2887),
    [anon_sym_switch] = ACTIONS(2887),
    [anon_sym_case] = ACTIONS(2887),
    [anon_sym_default] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2887),
    [anon_sym_for] = ACTIONS(2887),
    [anon_sym_return] = ACTIONS(2887),
    [anon_sym_break] = ACTIONS(2887),
    [anon_sym_continue] = ACTIONS(2887),
    [anon_sym_goto] = ACTIONS(2887),
    [anon_sym___try] = ACTIONS(2887),
    [anon_sym___leave] = ACTIONS(2887),
    [anon_sym_not] = ACTIONS(2887),
    [anon_sym_compl] = ACTIONS(2887),
    [anon_sym_DASH_DASH] = ACTIONS(2889),
    [anon_sym_PLUS_PLUS] = ACTIONS(2889),
    [anon_sym_sizeof] = ACTIONS(2887),
    [anon_sym___alignof__] = ACTIONS(2887),
    [anon_sym___alignof] = ACTIONS(2887),
    [anon_sym__alignof] = ACTIONS(2887),
    [anon_sym_alignof] = ACTIONS(2887),
    [anon_sym__Alignof] = ACTIONS(2887),
    [anon_sym_offsetof] = ACTIONS(2887),
    [anon_sym__Generic] = ACTIONS(2887),
    [anon_sym_asm] = ACTIONS(2887),
    [anon_sym___asm__] = ACTIONS(2887),
    [aux_sym_number_literal_token1] = ACTIONS(2889),
    [aux_sym_number_literal_token2] = ACTIONS(2887),
    [anon_sym_L_SQUOTE] = ACTIONS(2889),
    [anon_sym_u_SQUOTE] = ACTIONS(2889),
    [anon_sym_U_SQUOTE] = ACTIONS(2889),
    [anon_sym_u8_SQUOTE] = ACTIONS(2889),
    [anon_sym_SQUOTE] = ACTIONS(2889),
    [anon_sym_L_DQUOTE] = ACTIONS(2889),
    [anon_sym_u_DQUOTE] = ACTIONS(2889),
    [anon_sym_U_DQUOTE] = ACTIONS(2889),
    [anon_sym_u8_DQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE] = ACTIONS(2889),
    [sym_true] = ACTIONS(2887),
    [sym_false] = ACTIONS(2887),
    [anon_sym_NULL] = ACTIONS(2887),
    [anon_sym_nullptr] = ACTIONS(2887),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2887),
    [anon_sym_decltype] = ACTIONS(2887),
    [anon_sym_virtual] = ACTIONS(2887),
    [anon_sym_alignas] = ACTIONS(2887),
    [anon_sym_explicit] = ACTIONS(2887),
    [anon_sym_typename] = ACTIONS(2887),
    [anon_sym_template] = ACTIONS(2887),
    [anon_sym_operator] = ACTIONS(2887),
    [anon_sym_try] = ACTIONS(2887),
    [anon_sym_delete] = ACTIONS(2887),
    [anon_sym_throw] = ACTIONS(2887),
    [anon_sym_namespace] = ACTIONS(2887),
    [anon_sym_using] = ACTIONS(2887),
    [anon_sym_static_assert] = ACTIONS(2887),
    [anon_sym_concept] = ACTIONS(2887),
    [anon_sym_co_return] = ACTIONS(2887),
    [anon_sym_co_yield] = ACTIONS(2887),
    [anon_sym_catch] = ACTIONS(2887),
    [anon_sym_R_DQUOTE] = ACTIONS(2889),
    [anon_sym_LR_DQUOTE] = ACTIONS(2889),
    [anon_sym_uR_DQUOTE] = ACTIONS(2889),
    [anon_sym_UR_DQUOTE] = ACTIONS(2889),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2889),
    [anon_sym_co_await] = ACTIONS(2887),
    [anon_sym_new] = ACTIONS(2887),
    [anon_sym_requires] = ACTIONS(2887),
    [sym_this] = ACTIONS(2887),
  },
  [618] = {
    [sym_identifier] = ACTIONS(3415),
    [aux_sym_preproc_include_token1] = ACTIONS(3415),
    [aux_sym_preproc_def_token1] = ACTIONS(3415),
    [aux_sym_preproc_if_token1] = ACTIONS(3415),
    [aux_sym_preproc_if_token2] = ACTIONS(3415),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3415),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3415),
    [aux_sym_preproc_else_token1] = ACTIONS(3415),
    [aux_sym_preproc_elif_token1] = ACTIONS(3415),
    [sym_preproc_directive] = ACTIONS(3415),
    [anon_sym_LPAREN2] = ACTIONS(3417),
    [anon_sym_BANG] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_STAR] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3417),
    [anon_sym___extension__] = ACTIONS(3415),
    [anon_sym_typedef] = ACTIONS(3415),
    [anon_sym_extern] = ACTIONS(3415),
    [anon_sym___attribute__] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3417),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3417),
    [anon_sym___declspec] = ACTIONS(3415),
    [anon_sym___based] = ACTIONS(3415),
    [anon_sym___cdecl] = ACTIONS(3415),
    [anon_sym___clrcall] = ACTIONS(3415),
    [anon_sym___stdcall] = ACTIONS(3415),
    [anon_sym___fastcall] = ACTIONS(3415),
    [anon_sym___thiscall] = ACTIONS(3415),
    [anon_sym___vectorcall] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_signed] = ACTIONS(3415),
    [anon_sym_unsigned] = ACTIONS(3415),
    [anon_sym_long] = ACTIONS(3415),
    [anon_sym_short] = ACTIONS(3415),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_static] = ACTIONS(3415),
    [anon_sym_register] = ACTIONS(3415),
    [anon_sym_inline] = ACTIONS(3415),
    [anon_sym___inline] = ACTIONS(3415),
    [anon_sym___inline__] = ACTIONS(3415),
    [anon_sym___forceinline] = ACTIONS(3415),
    [anon_sym_thread_local] = ACTIONS(3415),
    [anon_sym___thread] = ACTIONS(3415),
    [anon_sym_const] = ACTIONS(3415),
    [anon_sym_constexpr] = ACTIONS(3415),
    [anon_sym_volatile] = ACTIONS(3415),
    [anon_sym_restrict] = ACTIONS(3415),
    [anon_sym___restrict__] = ACTIONS(3415),
    [anon_sym__Atomic] = ACTIONS(3415),
    [anon_sym__Noreturn] = ACTIONS(3415),
    [anon_sym_noreturn] = ACTIONS(3415),
    [anon_sym_mutable] = ACTIONS(3415),
    [anon_sym_constinit] = ACTIONS(3415),
    [anon_sym_consteval] = ACTIONS(3415),
    [anon_sym_PROGMEM] = ACTIONS(3415),
    [aux_sym_primitive_type_token1] = ACTIONS(3415),
    [anon_sym_byte] = ACTIONS(3415),
    [anon_sym_word] = ACTIONS(3415),
    [anon_sym_enum] = ACTIONS(3415),
    [anon_sym_class] = ACTIONS(3415),
    [anon_sym_struct] = ACTIONS(3415),
    [anon_sym_union] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_switch] = ACTIONS(3415),
    [anon_sym_case] = ACTIONS(3415),
    [anon_sym_default] = ACTIONS(3415),
    [anon_sym_while] = ACTIONS(3415),
    [anon_sym_do] = ACTIONS(3415),
    [anon_sym_for] = ACTIONS(3415),
    [anon_sym_return] = ACTIONS(3415),
    [anon_sym_break] = ACTIONS(3415),
    [anon_sym_continue] = ACTIONS(3415),
    [anon_sym_goto] = ACTIONS(3415),
    [anon_sym___try] = ACTIONS(3415),
    [anon_sym___leave] = ACTIONS(3415),
    [anon_sym_not] = ACTIONS(3415),
    [anon_sym_compl] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3415),
    [anon_sym___alignof__] = ACTIONS(3415),
    [anon_sym___alignof] = ACTIONS(3415),
    [anon_sym__alignof] = ACTIONS(3415),
    [anon_sym_alignof] = ACTIONS(3415),
    [anon_sym__Alignof] = ACTIONS(3415),
    [anon_sym_offsetof] = ACTIONS(3415),
    [anon_sym__Generic] = ACTIONS(3415),
    [anon_sym_asm] = ACTIONS(3415),
    [anon_sym___asm__] = ACTIONS(3415),
    [aux_sym_number_literal_token1] = ACTIONS(3417),
    [aux_sym_number_literal_token2] = ACTIONS(3415),
    [anon_sym_L_SQUOTE] = ACTIONS(3417),
    [anon_sym_u_SQUOTE] = ACTIONS(3417),
    [anon_sym_U_SQUOTE] = ACTIONS(3417),
    [anon_sym_u8_SQUOTE] = ACTIONS(3417),
    [anon_sym_SQUOTE] = ACTIONS(3417),
    [anon_sym_L_DQUOTE] = ACTIONS(3417),
    [anon_sym_u_DQUOTE] = ACTIONS(3417),
    [anon_sym_U_DQUOTE] = ACTIONS(3417),
    [anon_sym_u8_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [sym_true] = ACTIONS(3415),
    [sym_false] = ACTIONS(3415),
    [anon_sym_NULL] = ACTIONS(3415),
    [anon_sym_nullptr] = ACTIONS(3415),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3415),
    [anon_sym_decltype] = ACTIONS(3415),
    [anon_sym_virtual] = ACTIONS(3415),
    [anon_sym_alignas] = ACTIONS(3415),
    [anon_sym_explicit] = ACTIONS(3415),
    [anon_sym_typename] = ACTIONS(3415),
    [anon_sym_template] = ACTIONS(3415),
    [anon_sym_operator] = ACTIONS(3415),
    [anon_sym_try] = ACTIONS(3415),
    [anon_sym_delete] = ACTIONS(3415),
    [anon_sym_throw] = ACTIONS(3415),
    [anon_sym_namespace] = ACTIONS(3415),
    [anon_sym_using] = ACTIONS(3415),
    [anon_sym_static_assert] = ACTIONS(3415),
    [anon_sym_concept] = ACTIONS(3415),
    [anon_sym_co_return] = ACTIONS(3415),
    [anon_sym_co_yield] = ACTIONS(3415),
    [anon_sym_R_DQUOTE] = ACTIONS(3417),
    [anon_sym_LR_DQUOTE] = ACTIONS(3417),
    [anon_sym_uR_DQUOTE] = ACTIONS(3417),
    [anon_sym_UR_DQUOTE] = ACTIONS(3417),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3417),
    [anon_sym_co_await] = ACTIONS(3415),
    [anon_sym_new] = ACTIONS(3415),
    [anon_sym_requires] = ACTIONS(3415),
    [sym_this] = ACTIONS(3415),
  },
  [619] = {
    [sym_identifier] = ACTIONS(2223),
    [aux_sym_preproc_include_token1] = ACTIONS(2223),
    [aux_sym_preproc_def_token1] = ACTIONS(2223),
    [aux_sym_preproc_if_token1] = ACTIONS(2223),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2223),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2223),
    [sym_preproc_directive] = ACTIONS(2223),
    [anon_sym_LPAREN2] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2223),
    [anon_sym_PLUS] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(2221),
    [anon_sym_AMP_AMP] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym___extension__] = ACTIONS(2223),
    [anon_sym_typedef] = ACTIONS(2223),
    [anon_sym_extern] = ACTIONS(2223),
    [anon_sym___attribute__] = ACTIONS(2223),
    [anon_sym_COLON_COLON] = ACTIONS(2221),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym___declspec] = ACTIONS(2223),
    [anon_sym___based] = ACTIONS(2223),
    [anon_sym___cdecl] = ACTIONS(2223),
    [anon_sym___clrcall] = ACTIONS(2223),
    [anon_sym___stdcall] = ACTIONS(2223),
    [anon_sym___fastcall] = ACTIONS(2223),
    [anon_sym___thiscall] = ACTIONS(2223),
    [anon_sym___vectorcall] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [anon_sym_signed] = ACTIONS(2223),
    [anon_sym_unsigned] = ACTIONS(2223),
    [anon_sym_long] = ACTIONS(2223),
    [anon_sym_short] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(2223),
    [anon_sym_static] = ACTIONS(2223),
    [anon_sym_register] = ACTIONS(2223),
    [anon_sym_inline] = ACTIONS(2223),
    [anon_sym___inline] = ACTIONS(2223),
    [anon_sym___inline__] = ACTIONS(2223),
    [anon_sym___forceinline] = ACTIONS(2223),
    [anon_sym_thread_local] = ACTIONS(2223),
    [anon_sym___thread] = ACTIONS(2223),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_constexpr] = ACTIONS(2223),
    [anon_sym_volatile] = ACTIONS(2223),
    [anon_sym_restrict] = ACTIONS(2223),
    [anon_sym___restrict__] = ACTIONS(2223),
    [anon_sym__Atomic] = ACTIONS(2223),
    [anon_sym__Noreturn] = ACTIONS(2223),
    [anon_sym_noreturn] = ACTIONS(2223),
    [anon_sym_mutable] = ACTIONS(2223),
    [anon_sym_constinit] = ACTIONS(2223),
    [anon_sym_consteval] = ACTIONS(2223),
    [anon_sym_PROGMEM] = ACTIONS(2223),
    [aux_sym_primitive_type_token1] = ACTIONS(2223),
    [anon_sym_byte] = ACTIONS(2223),
    [anon_sym_word] = ACTIONS(2223),
    [anon_sym_enum] = ACTIONS(2223),
    [anon_sym_class] = ACTIONS(2223),
    [anon_sym_struct] = ACTIONS(2223),
    [anon_sym_union] = ACTIONS(2223),
    [anon_sym_if] = ACTIONS(2223),
    [anon_sym_else] = ACTIONS(2223),
    [anon_sym_switch] = ACTIONS(2223),
    [anon_sym_case] = ACTIONS(2223),
    [anon_sym_default] = ACTIONS(2223),
    [anon_sym_while] = ACTIONS(2223),
    [anon_sym_do] = ACTIONS(2223),
    [anon_sym_for] = ACTIONS(2223),
    [anon_sym_return] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2223),
    [anon_sym_continue] = ACTIONS(2223),
    [anon_sym_goto] = ACTIONS(2223),
    [anon_sym___try] = ACTIONS(2223),
    [anon_sym___leave] = ACTIONS(2223),
    [anon_sym_not] = ACTIONS(2223),
    [anon_sym_compl] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_sizeof] = ACTIONS(2223),
    [anon_sym___alignof__] = ACTIONS(2223),
    [anon_sym___alignof] = ACTIONS(2223),
    [anon_sym__alignof] = ACTIONS(2223),
    [anon_sym_alignof] = ACTIONS(2223),
    [anon_sym__Alignof] = ACTIONS(2223),
    [anon_sym_offsetof] = ACTIONS(2223),
    [anon_sym__Generic] = ACTIONS(2223),
    [anon_sym_asm] = ACTIONS(2223),
    [anon_sym___asm__] = ACTIONS(2223),
    [aux_sym_number_literal_token1] = ACTIONS(2221),
    [aux_sym_number_literal_token2] = ACTIONS(2223),
    [anon_sym_L_SQUOTE] = ACTIONS(2221),
    [anon_sym_u_SQUOTE] = ACTIONS(2221),
    [anon_sym_U_SQUOTE] = ACTIONS(2221),
    [anon_sym_u8_SQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_L_DQUOTE] = ACTIONS(2221),
    [anon_sym_u_DQUOTE] = ACTIONS(2221),
    [anon_sym_U_DQUOTE] = ACTIONS(2221),
    [anon_sym_u8_DQUOTE] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [sym_true] = ACTIONS(2223),
    [sym_false] = ACTIONS(2223),
    [anon_sym_NULL] = ACTIONS(2223),
    [anon_sym_nullptr] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2223),
    [anon_sym_decltype] = ACTIONS(2223),
    [anon_sym_virtual] = ACTIONS(2223),
    [anon_sym_alignas] = ACTIONS(2223),
    [anon_sym_explicit] = ACTIONS(2223),
    [anon_sym_typename] = ACTIONS(2223),
    [anon_sym_template] = ACTIONS(2223),
    [anon_sym_operator] = ACTIONS(2223),
    [anon_sym_try] = ACTIONS(2223),
    [anon_sym_delete] = ACTIONS(2223),
    [anon_sym_throw] = ACTIONS(2223),
    [anon_sym_namespace] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_static_assert] = ACTIONS(2223),
    [anon_sym_concept] = ACTIONS(2223),
    [anon_sym_co_return] = ACTIONS(2223),
    [anon_sym_co_yield] = ACTIONS(2223),
    [anon_sym_catch] = ACTIONS(2223),
    [anon_sym_R_DQUOTE] = ACTIONS(2221),
    [anon_sym_LR_DQUOTE] = ACTIONS(2221),
    [anon_sym_uR_DQUOTE] = ACTIONS(2221),
    [anon_sym_UR_DQUOTE] = ACTIONS(2221),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2221),
    [anon_sym_co_await] = ACTIONS(2223),
    [anon_sym_new] = ACTIONS(2223),
    [anon_sym_requires] = ACTIONS(2223),
    [sym_this] = ACTIONS(2223),
  },
  [620] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [621] = {
    [ts_builtin_sym_end] = ACTIONS(2948),
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [622] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [623] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [624] = {
    [sym_identifier] = ACTIONS(3102),
    [aux_sym_preproc_include_token1] = ACTIONS(3102),
    [aux_sym_preproc_def_token1] = ACTIONS(3102),
    [aux_sym_preproc_if_token1] = ACTIONS(3102),
    [aux_sym_preproc_if_token2] = ACTIONS(3102),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3102),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3102),
    [sym_preproc_directive] = ACTIONS(3102),
    [anon_sym_LPAREN2] = ACTIONS(3104),
    [anon_sym_BANG] = ACTIONS(3104),
    [anon_sym_TILDE] = ACTIONS(3104),
    [anon_sym_DASH] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(3104),
    [anon_sym_AMP_AMP] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3102),
    [anon_sym_SEMI] = ACTIONS(3104),
    [anon_sym___extension__] = ACTIONS(3102),
    [anon_sym_typedef] = ACTIONS(3102),
    [anon_sym_extern] = ACTIONS(3102),
    [anon_sym___attribute__] = ACTIONS(3102),
    [anon_sym_COLON_COLON] = ACTIONS(3104),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3104),
    [anon_sym___declspec] = ACTIONS(3102),
    [anon_sym___based] = ACTIONS(3102),
    [anon_sym___cdecl] = ACTIONS(3102),
    [anon_sym___clrcall] = ACTIONS(3102),
    [anon_sym___stdcall] = ACTIONS(3102),
    [anon_sym___fastcall] = ACTIONS(3102),
    [anon_sym___thiscall] = ACTIONS(3102),
    [anon_sym___vectorcall] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3104),
    [anon_sym_signed] = ACTIONS(3102),
    [anon_sym_unsigned] = ACTIONS(3102),
    [anon_sym_long] = ACTIONS(3102),
    [anon_sym_short] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_static] = ACTIONS(3102),
    [anon_sym_register] = ACTIONS(3102),
    [anon_sym_inline] = ACTIONS(3102),
    [anon_sym___inline] = ACTIONS(3102),
    [anon_sym___inline__] = ACTIONS(3102),
    [anon_sym___forceinline] = ACTIONS(3102),
    [anon_sym_thread_local] = ACTIONS(3102),
    [anon_sym___thread] = ACTIONS(3102),
    [anon_sym_const] = ACTIONS(3102),
    [anon_sym_constexpr] = ACTIONS(3102),
    [anon_sym_volatile] = ACTIONS(3102),
    [anon_sym_restrict] = ACTIONS(3102),
    [anon_sym___restrict__] = ACTIONS(3102),
    [anon_sym__Atomic] = ACTIONS(3102),
    [anon_sym__Noreturn] = ACTIONS(3102),
    [anon_sym_noreturn] = ACTIONS(3102),
    [anon_sym_mutable] = ACTIONS(3102),
    [anon_sym_constinit] = ACTIONS(3102),
    [anon_sym_consteval] = ACTIONS(3102),
    [anon_sym_PROGMEM] = ACTIONS(3102),
    [aux_sym_primitive_type_token1] = ACTIONS(3102),
    [anon_sym_byte] = ACTIONS(3102),
    [anon_sym_word] = ACTIONS(3102),
    [anon_sym_enum] = ACTIONS(3102),
    [anon_sym_class] = ACTIONS(3102),
    [anon_sym_struct] = ACTIONS(3102),
    [anon_sym_union] = ACTIONS(3102),
    [anon_sym_if] = ACTIONS(3102),
    [anon_sym_else] = ACTIONS(3102),
    [anon_sym_switch] = ACTIONS(3102),
    [anon_sym_case] = ACTIONS(3102),
    [anon_sym_default] = ACTIONS(3102),
    [anon_sym_while] = ACTIONS(3102),
    [anon_sym_do] = ACTIONS(3102),
    [anon_sym_for] = ACTIONS(3102),
    [anon_sym_return] = ACTIONS(3102),
    [anon_sym_break] = ACTIONS(3102),
    [anon_sym_continue] = ACTIONS(3102),
    [anon_sym_goto] = ACTIONS(3102),
    [anon_sym___try] = ACTIONS(3102),
    [anon_sym___leave] = ACTIONS(3102),
    [anon_sym_not] = ACTIONS(3102),
    [anon_sym_compl] = ACTIONS(3102),
    [anon_sym_DASH_DASH] = ACTIONS(3104),
    [anon_sym_PLUS_PLUS] = ACTIONS(3104),
    [anon_sym_sizeof] = ACTIONS(3102),
    [anon_sym___alignof__] = ACTIONS(3102),
    [anon_sym___alignof] = ACTIONS(3102),
    [anon_sym__alignof] = ACTIONS(3102),
    [anon_sym_alignof] = ACTIONS(3102),
    [anon_sym__Alignof] = ACTIONS(3102),
    [anon_sym_offsetof] = ACTIONS(3102),
    [anon_sym__Generic] = ACTIONS(3102),
    [anon_sym_asm] = ACTIONS(3102),
    [anon_sym___asm__] = ACTIONS(3102),
    [aux_sym_number_literal_token1] = ACTIONS(3104),
    [aux_sym_number_literal_token2] = ACTIONS(3102),
    [anon_sym_L_SQUOTE] = ACTIONS(3104),
    [anon_sym_u_SQUOTE] = ACTIONS(3104),
    [anon_sym_U_SQUOTE] = ACTIONS(3104),
    [anon_sym_u8_SQUOTE] = ACTIONS(3104),
    [anon_sym_SQUOTE] = ACTIONS(3104),
    [anon_sym_L_DQUOTE] = ACTIONS(3104),
    [anon_sym_u_DQUOTE] = ACTIONS(3104),
    [anon_sym_U_DQUOTE] = ACTIONS(3104),
    [anon_sym_u8_DQUOTE] = ACTIONS(3104),
    [anon_sym_DQUOTE] = ACTIONS(3104),
    [sym_true] = ACTIONS(3102),
    [sym_false] = ACTIONS(3102),
    [anon_sym_NULL] = ACTIONS(3102),
    [anon_sym_nullptr] = ACTIONS(3102),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3102),
    [anon_sym_decltype] = ACTIONS(3102),
    [anon_sym_virtual] = ACTIONS(3102),
    [anon_sym_alignas] = ACTIONS(3102),
    [anon_sym_explicit] = ACTIONS(3102),
    [anon_sym_typename] = ACTIONS(3102),
    [anon_sym_template] = ACTIONS(3102),
    [anon_sym_operator] = ACTIONS(3102),
    [anon_sym_try] = ACTIONS(3102),
    [anon_sym_delete] = ACTIONS(3102),
    [anon_sym_throw] = ACTIONS(3102),
    [anon_sym_namespace] = ACTIONS(3102),
    [anon_sym_using] = ACTIONS(3102),
    [anon_sym_static_assert] = ACTIONS(3102),
    [anon_sym_concept] = ACTIONS(3102),
    [anon_sym_co_return] = ACTIONS(3102),
    [anon_sym_co_yield] = ACTIONS(3102),
    [anon_sym_R_DQUOTE] = ACTIONS(3104),
    [anon_sym_LR_DQUOTE] = ACTIONS(3104),
    [anon_sym_uR_DQUOTE] = ACTIONS(3104),
    [anon_sym_UR_DQUOTE] = ACTIONS(3104),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3104),
    [anon_sym_co_await] = ACTIONS(3102),
    [anon_sym_new] = ACTIONS(3102),
    [anon_sym_requires] = ACTIONS(3102),
    [sym_this] = ACTIONS(3102),
  },
  [625] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [626] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [627] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [628] = {
    [ts_builtin_sym_end] = ACTIONS(3136),
    [sym_identifier] = ACTIONS(3134),
    [aux_sym_preproc_include_token1] = ACTIONS(3134),
    [aux_sym_preproc_def_token1] = ACTIONS(3134),
    [aux_sym_preproc_if_token1] = ACTIONS(3134),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3134),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3134),
    [sym_preproc_directive] = ACTIONS(3134),
    [anon_sym_LPAREN2] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3136),
    [anon_sym_TILDE] = ACTIONS(3136),
    [anon_sym_DASH] = ACTIONS(3134),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_STAR] = ACTIONS(3136),
    [anon_sym_AMP_AMP] = ACTIONS(3136),
    [anon_sym_AMP] = ACTIONS(3134),
    [anon_sym_SEMI] = ACTIONS(3136),
    [anon_sym___extension__] = ACTIONS(3134),
    [anon_sym_typedef] = ACTIONS(3134),
    [anon_sym_extern] = ACTIONS(3134),
    [anon_sym___attribute__] = ACTIONS(3134),
    [anon_sym_COLON_COLON] = ACTIONS(3136),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3136),
    [anon_sym___declspec] = ACTIONS(3134),
    [anon_sym___based] = ACTIONS(3134),
    [anon_sym___cdecl] = ACTIONS(3134),
    [anon_sym___clrcall] = ACTIONS(3134),
    [anon_sym___stdcall] = ACTIONS(3134),
    [anon_sym___fastcall] = ACTIONS(3134),
    [anon_sym___thiscall] = ACTIONS(3134),
    [anon_sym___vectorcall] = ACTIONS(3134),
    [anon_sym_LBRACE] = ACTIONS(3136),
    [anon_sym_signed] = ACTIONS(3134),
    [anon_sym_unsigned] = ACTIONS(3134),
    [anon_sym_long] = ACTIONS(3134),
    [anon_sym_short] = ACTIONS(3134),
    [anon_sym_LBRACK] = ACTIONS(3134),
    [anon_sym_static] = ACTIONS(3134),
    [anon_sym_register] = ACTIONS(3134),
    [anon_sym_inline] = ACTIONS(3134),
    [anon_sym___inline] = ACTIONS(3134),
    [anon_sym___inline__] = ACTIONS(3134),
    [anon_sym___forceinline] = ACTIONS(3134),
    [anon_sym_thread_local] = ACTIONS(3134),
    [anon_sym___thread] = ACTIONS(3134),
    [anon_sym_const] = ACTIONS(3134),
    [anon_sym_constexpr] = ACTIONS(3134),
    [anon_sym_volatile] = ACTIONS(3134),
    [anon_sym_restrict] = ACTIONS(3134),
    [anon_sym___restrict__] = ACTIONS(3134),
    [anon_sym__Atomic] = ACTIONS(3134),
    [anon_sym__Noreturn] = ACTIONS(3134),
    [anon_sym_noreturn] = ACTIONS(3134),
    [anon_sym_mutable] = ACTIONS(3134),
    [anon_sym_constinit] = ACTIONS(3134),
    [anon_sym_consteval] = ACTIONS(3134),
    [anon_sym_PROGMEM] = ACTIONS(3134),
    [aux_sym_primitive_type_token1] = ACTIONS(3134),
    [anon_sym_byte] = ACTIONS(3134),
    [anon_sym_word] = ACTIONS(3134),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3134),
    [anon_sym_struct] = ACTIONS(3134),
    [anon_sym_union] = ACTIONS(3134),
    [anon_sym_if] = ACTIONS(3134),
    [anon_sym_else] = ACTIONS(3134),
    [anon_sym_switch] = ACTIONS(3134),
    [anon_sym_case] = ACTIONS(3134),
    [anon_sym_default] = ACTIONS(3134),
    [anon_sym_while] = ACTIONS(3134),
    [anon_sym_do] = ACTIONS(3134),
    [anon_sym_for] = ACTIONS(3134),
    [anon_sym_return] = ACTIONS(3134),
    [anon_sym_break] = ACTIONS(3134),
    [anon_sym_continue] = ACTIONS(3134),
    [anon_sym_goto] = ACTIONS(3134),
    [anon_sym___try] = ACTIONS(3134),
    [anon_sym___leave] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3134),
    [anon_sym_compl] = ACTIONS(3134),
    [anon_sym_DASH_DASH] = ACTIONS(3136),
    [anon_sym_PLUS_PLUS] = ACTIONS(3136),
    [anon_sym_sizeof] = ACTIONS(3134),
    [anon_sym___alignof__] = ACTIONS(3134),
    [anon_sym___alignof] = ACTIONS(3134),
    [anon_sym__alignof] = ACTIONS(3134),
    [anon_sym_alignof] = ACTIONS(3134),
    [anon_sym__Alignof] = ACTIONS(3134),
    [anon_sym_offsetof] = ACTIONS(3134),
    [anon_sym__Generic] = ACTIONS(3134),
    [anon_sym_asm] = ACTIONS(3134),
    [anon_sym___asm__] = ACTIONS(3134),
    [aux_sym_number_literal_token1] = ACTIONS(3136),
    [aux_sym_number_literal_token2] = ACTIONS(3134),
    [anon_sym_L_SQUOTE] = ACTIONS(3136),
    [anon_sym_u_SQUOTE] = ACTIONS(3136),
    [anon_sym_U_SQUOTE] = ACTIONS(3136),
    [anon_sym_u8_SQUOTE] = ACTIONS(3136),
    [anon_sym_SQUOTE] = ACTIONS(3136),
    [anon_sym_L_DQUOTE] = ACTIONS(3136),
    [anon_sym_u_DQUOTE] = ACTIONS(3136),
    [anon_sym_U_DQUOTE] = ACTIONS(3136),
    [anon_sym_u8_DQUOTE] = ACTIONS(3136),
    [anon_sym_DQUOTE] = ACTIONS(3136),
    [sym_true] = ACTIONS(3134),
    [sym_false] = ACTIONS(3134),
    [anon_sym_NULL] = ACTIONS(3134),
    [anon_sym_nullptr] = ACTIONS(3134),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3134),
    [anon_sym_decltype] = ACTIONS(3134),
    [anon_sym_virtual] = ACTIONS(3134),
    [anon_sym_alignas] = ACTIONS(3134),
    [anon_sym_explicit] = ACTIONS(3134),
    [anon_sym_typename] = ACTIONS(3134),
    [anon_sym_template] = ACTIONS(3134),
    [anon_sym_operator] = ACTIONS(3134),
    [anon_sym_try] = ACTIONS(3134),
    [anon_sym_delete] = ACTIONS(3134),
    [anon_sym_throw] = ACTIONS(3134),
    [anon_sym_namespace] = ACTIONS(3134),
    [anon_sym_using] = ACTIONS(3134),
    [anon_sym_static_assert] = ACTIONS(3134),
    [anon_sym_concept] = ACTIONS(3134),
    [anon_sym_co_return] = ACTIONS(3134),
    [anon_sym_co_yield] = ACTIONS(3134),
    [anon_sym_R_DQUOTE] = ACTIONS(3136),
    [anon_sym_LR_DQUOTE] = ACTIONS(3136),
    [anon_sym_uR_DQUOTE] = ACTIONS(3136),
    [anon_sym_UR_DQUOTE] = ACTIONS(3136),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3136),
    [anon_sym_co_await] = ACTIONS(3134),
    [anon_sym_new] = ACTIONS(3134),
    [anon_sym_requires] = ACTIONS(3134),
    [sym_this] = ACTIONS(3134),
  },
  [629] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [630] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [631] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [632] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [633] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [634] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [635] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [636] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [637] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [638] = {
    [sym_identifier] = ACTIONS(3162),
    [aux_sym_preproc_include_token1] = ACTIONS(3162),
    [aux_sym_preproc_def_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token2] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3162),
    [sym_preproc_directive] = ACTIONS(3162),
    [anon_sym_LPAREN2] = ACTIONS(3164),
    [anon_sym_BANG] = ACTIONS(3164),
    [anon_sym_TILDE] = ACTIONS(3164),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_STAR] = ACTIONS(3164),
    [anon_sym_AMP_AMP] = ACTIONS(3164),
    [anon_sym_AMP] = ACTIONS(3162),
    [anon_sym_SEMI] = ACTIONS(3164),
    [anon_sym___extension__] = ACTIONS(3162),
    [anon_sym_typedef] = ACTIONS(3162),
    [anon_sym_extern] = ACTIONS(3162),
    [anon_sym___attribute__] = ACTIONS(3162),
    [anon_sym_COLON_COLON] = ACTIONS(3164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3164),
    [anon_sym___declspec] = ACTIONS(3162),
    [anon_sym___based] = ACTIONS(3162),
    [anon_sym___cdecl] = ACTIONS(3162),
    [anon_sym___clrcall] = ACTIONS(3162),
    [anon_sym___stdcall] = ACTIONS(3162),
    [anon_sym___fastcall] = ACTIONS(3162),
    [anon_sym___thiscall] = ACTIONS(3162),
    [anon_sym___vectorcall] = ACTIONS(3162),
    [anon_sym_LBRACE] = ACTIONS(3164),
    [anon_sym_signed] = ACTIONS(3162),
    [anon_sym_unsigned] = ACTIONS(3162),
    [anon_sym_long] = ACTIONS(3162),
    [anon_sym_short] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_register] = ACTIONS(3162),
    [anon_sym_inline] = ACTIONS(3162),
    [anon_sym___inline] = ACTIONS(3162),
    [anon_sym___inline__] = ACTIONS(3162),
    [anon_sym___forceinline] = ACTIONS(3162),
    [anon_sym_thread_local] = ACTIONS(3162),
    [anon_sym___thread] = ACTIONS(3162),
    [anon_sym_const] = ACTIONS(3162),
    [anon_sym_constexpr] = ACTIONS(3162),
    [anon_sym_volatile] = ACTIONS(3162),
    [anon_sym_restrict] = ACTIONS(3162),
    [anon_sym___restrict__] = ACTIONS(3162),
    [anon_sym__Atomic] = ACTIONS(3162),
    [anon_sym__Noreturn] = ACTIONS(3162),
    [anon_sym_noreturn] = ACTIONS(3162),
    [anon_sym_mutable] = ACTIONS(3162),
    [anon_sym_constinit] = ACTIONS(3162),
    [anon_sym_consteval] = ACTIONS(3162),
    [anon_sym_PROGMEM] = ACTIONS(3162),
    [aux_sym_primitive_type_token1] = ACTIONS(3162),
    [anon_sym_byte] = ACTIONS(3162),
    [anon_sym_word] = ACTIONS(3162),
    [anon_sym_enum] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_struct] = ACTIONS(3162),
    [anon_sym_union] = ACTIONS(3162),
    [anon_sym_if] = ACTIONS(3162),
    [anon_sym_else] = ACTIONS(3162),
    [anon_sym_switch] = ACTIONS(3162),
    [anon_sym_case] = ACTIONS(3162),
    [anon_sym_default] = ACTIONS(3162),
    [anon_sym_while] = ACTIONS(3162),
    [anon_sym_do] = ACTIONS(3162),
    [anon_sym_for] = ACTIONS(3162),
    [anon_sym_return] = ACTIONS(3162),
    [anon_sym_break] = ACTIONS(3162),
    [anon_sym_continue] = ACTIONS(3162),
    [anon_sym_goto] = ACTIONS(3162),
    [anon_sym___try] = ACTIONS(3162),
    [anon_sym___leave] = ACTIONS(3162),
    [anon_sym_not] = ACTIONS(3162),
    [anon_sym_compl] = ACTIONS(3162),
    [anon_sym_DASH_DASH] = ACTIONS(3164),
    [anon_sym_PLUS_PLUS] = ACTIONS(3164),
    [anon_sym_sizeof] = ACTIONS(3162),
    [anon_sym___alignof__] = ACTIONS(3162),
    [anon_sym___alignof] = ACTIONS(3162),
    [anon_sym__alignof] = ACTIONS(3162),
    [anon_sym_alignof] = ACTIONS(3162),
    [anon_sym__Alignof] = ACTIONS(3162),
    [anon_sym_offsetof] = ACTIONS(3162),
    [anon_sym__Generic] = ACTIONS(3162),
    [anon_sym_asm] = ACTIONS(3162),
    [anon_sym___asm__] = ACTIONS(3162),
    [aux_sym_number_literal_token1] = ACTIONS(3164),
    [aux_sym_number_literal_token2] = ACTIONS(3162),
    [anon_sym_L_SQUOTE] = ACTIONS(3164),
    [anon_sym_u_SQUOTE] = ACTIONS(3164),
    [anon_sym_U_SQUOTE] = ACTIONS(3164),
    [anon_sym_u8_SQUOTE] = ACTIONS(3164),
    [anon_sym_SQUOTE] = ACTIONS(3164),
    [anon_sym_L_DQUOTE] = ACTIONS(3164),
    [anon_sym_u_DQUOTE] = ACTIONS(3164),
    [anon_sym_U_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8_DQUOTE] = ACTIONS(3164),
    [anon_sym_DQUOTE] = ACTIONS(3164),
    [sym_true] = ACTIONS(3162),
    [sym_false] = ACTIONS(3162),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3162),
    [anon_sym_decltype] = ACTIONS(3162),
    [anon_sym_virtual] = ACTIONS(3162),
    [anon_sym_alignas] = ACTIONS(3162),
    [anon_sym_explicit] = ACTIONS(3162),
    [anon_sym_typename] = ACTIONS(3162),
    [anon_sym_template] = ACTIONS(3162),
    [anon_sym_operator] = ACTIONS(3162),
    [anon_sym_try] = ACTIONS(3162),
    [anon_sym_delete] = ACTIONS(3162),
    [anon_sym_throw] = ACTIONS(3162),
    [anon_sym_namespace] = ACTIONS(3162),
    [anon_sym_using] = ACTIONS(3162),
    [anon_sym_static_assert] = ACTIONS(3162),
    [anon_sym_concept] = ACTIONS(3162),
    [anon_sym_co_return] = ACTIONS(3162),
    [anon_sym_co_yield] = ACTIONS(3162),
    [anon_sym_R_DQUOTE] = ACTIONS(3164),
    [anon_sym_LR_DQUOTE] = ACTIONS(3164),
    [anon_sym_uR_DQUOTE] = ACTIONS(3164),
    [anon_sym_UR_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3164),
    [anon_sym_co_await] = ACTIONS(3162),
    [anon_sym_new] = ACTIONS(3162),
    [anon_sym_requires] = ACTIONS(3162),
    [sym_this] = ACTIONS(3162),
  },
  [639] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [640] = {
    [ts_builtin_sym_end] = ACTIONS(3056),
    [sym_identifier] = ACTIONS(3054),
    [aux_sym_preproc_include_token1] = ACTIONS(3054),
    [aux_sym_preproc_def_token1] = ACTIONS(3054),
    [aux_sym_preproc_if_token1] = ACTIONS(3054),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3054),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3054),
    [sym_preproc_directive] = ACTIONS(3054),
    [anon_sym_LPAREN2] = ACTIONS(3056),
    [anon_sym_BANG] = ACTIONS(3056),
    [anon_sym_TILDE] = ACTIONS(3056),
    [anon_sym_DASH] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3056),
    [anon_sym_AMP_AMP] = ACTIONS(3056),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym___extension__] = ACTIONS(3054),
    [anon_sym_typedef] = ACTIONS(3054),
    [anon_sym_extern] = ACTIONS(3054),
    [anon_sym___attribute__] = ACTIONS(3054),
    [anon_sym_COLON_COLON] = ACTIONS(3056),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3056),
    [anon_sym___declspec] = ACTIONS(3054),
    [anon_sym___based] = ACTIONS(3054),
    [anon_sym___cdecl] = ACTIONS(3054),
    [anon_sym___clrcall] = ACTIONS(3054),
    [anon_sym___stdcall] = ACTIONS(3054),
    [anon_sym___fastcall] = ACTIONS(3054),
    [anon_sym___thiscall] = ACTIONS(3054),
    [anon_sym___vectorcall] = ACTIONS(3054),
    [anon_sym_LBRACE] = ACTIONS(3056),
    [anon_sym_signed] = ACTIONS(3054),
    [anon_sym_unsigned] = ACTIONS(3054),
    [anon_sym_long] = ACTIONS(3054),
    [anon_sym_short] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3054),
    [anon_sym_static] = ACTIONS(3054),
    [anon_sym_register] = ACTIONS(3054),
    [anon_sym_inline] = ACTIONS(3054),
    [anon_sym___inline] = ACTIONS(3054),
    [anon_sym___inline__] = ACTIONS(3054),
    [anon_sym___forceinline] = ACTIONS(3054),
    [anon_sym_thread_local] = ACTIONS(3054),
    [anon_sym___thread] = ACTIONS(3054),
    [anon_sym_const] = ACTIONS(3054),
    [anon_sym_constexpr] = ACTIONS(3054),
    [anon_sym_volatile] = ACTIONS(3054),
    [anon_sym_restrict] = ACTIONS(3054),
    [anon_sym___restrict__] = ACTIONS(3054),
    [anon_sym__Atomic] = ACTIONS(3054),
    [anon_sym__Noreturn] = ACTIONS(3054),
    [anon_sym_noreturn] = ACTIONS(3054),
    [anon_sym_mutable] = ACTIONS(3054),
    [anon_sym_constinit] = ACTIONS(3054),
    [anon_sym_consteval] = ACTIONS(3054),
    [anon_sym_PROGMEM] = ACTIONS(3054),
    [aux_sym_primitive_type_token1] = ACTIONS(3054),
    [anon_sym_byte] = ACTIONS(3054),
    [anon_sym_word] = ACTIONS(3054),
    [anon_sym_enum] = ACTIONS(3054),
    [anon_sym_class] = ACTIONS(3054),
    [anon_sym_struct] = ACTIONS(3054),
    [anon_sym_union] = ACTIONS(3054),
    [anon_sym_if] = ACTIONS(3054),
    [anon_sym_else] = ACTIONS(3054),
    [anon_sym_switch] = ACTIONS(3054),
    [anon_sym_case] = ACTIONS(3054),
    [anon_sym_default] = ACTIONS(3054),
    [anon_sym_while] = ACTIONS(3054),
    [anon_sym_do] = ACTIONS(3054),
    [anon_sym_for] = ACTIONS(3054),
    [anon_sym_return] = ACTIONS(3054),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_continue] = ACTIONS(3054),
    [anon_sym_goto] = ACTIONS(3054),
    [anon_sym___try] = ACTIONS(3054),
    [anon_sym___leave] = ACTIONS(3054),
    [anon_sym_not] = ACTIONS(3054),
    [anon_sym_compl] = ACTIONS(3054),
    [anon_sym_DASH_DASH] = ACTIONS(3056),
    [anon_sym_PLUS_PLUS] = ACTIONS(3056),
    [anon_sym_sizeof] = ACTIONS(3054),
    [anon_sym___alignof__] = ACTIONS(3054),
    [anon_sym___alignof] = ACTIONS(3054),
    [anon_sym__alignof] = ACTIONS(3054),
    [anon_sym_alignof] = ACTIONS(3054),
    [anon_sym__Alignof] = ACTIONS(3054),
    [anon_sym_offsetof] = ACTIONS(3054),
    [anon_sym__Generic] = ACTIONS(3054),
    [anon_sym_asm] = ACTIONS(3054),
    [anon_sym___asm__] = ACTIONS(3054),
    [aux_sym_number_literal_token1] = ACTIONS(3056),
    [aux_sym_number_literal_token2] = ACTIONS(3054),
    [anon_sym_L_SQUOTE] = ACTIONS(3056),
    [anon_sym_u_SQUOTE] = ACTIONS(3056),
    [anon_sym_U_SQUOTE] = ACTIONS(3056),
    [anon_sym_u8_SQUOTE] = ACTIONS(3056),
    [anon_sym_SQUOTE] = ACTIONS(3056),
    [anon_sym_L_DQUOTE] = ACTIONS(3056),
    [anon_sym_u_DQUOTE] = ACTIONS(3056),
    [anon_sym_U_DQUOTE] = ACTIONS(3056),
    [anon_sym_u8_DQUOTE] = ACTIONS(3056),
    [anon_sym_DQUOTE] = ACTIONS(3056),
    [sym_true] = ACTIONS(3054),
    [sym_false] = ACTIONS(3054),
    [anon_sym_NULL] = ACTIONS(3054),
    [anon_sym_nullptr] = ACTIONS(3054),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3054),
    [anon_sym_decltype] = ACTIONS(3054),
    [anon_sym_virtual] = ACTIONS(3054),
    [anon_sym_alignas] = ACTIONS(3054),
    [anon_sym_explicit] = ACTIONS(3054),
    [anon_sym_typename] = ACTIONS(3054),
    [anon_sym_template] = ACTIONS(3054),
    [anon_sym_operator] = ACTIONS(3054),
    [anon_sym_try] = ACTIONS(3054),
    [anon_sym_delete] = ACTIONS(3054),
    [anon_sym_throw] = ACTIONS(3054),
    [anon_sym_namespace] = ACTIONS(3054),
    [anon_sym_using] = ACTIONS(3054),
    [anon_sym_static_assert] = ACTIONS(3054),
    [anon_sym_concept] = ACTIONS(3054),
    [anon_sym_co_return] = ACTIONS(3054),
    [anon_sym_co_yield] = ACTIONS(3054),
    [anon_sym_R_DQUOTE] = ACTIONS(3056),
    [anon_sym_LR_DQUOTE] = ACTIONS(3056),
    [anon_sym_uR_DQUOTE] = ACTIONS(3056),
    [anon_sym_UR_DQUOTE] = ACTIONS(3056),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3056),
    [anon_sym_co_await] = ACTIONS(3054),
    [anon_sym_new] = ACTIONS(3054),
    [anon_sym_requires] = ACTIONS(3054),
    [sym_this] = ACTIONS(3054),
  },
  [641] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [642] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [643] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [644] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [645] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [646] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [647] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [648] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [649] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [650] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [651] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [652] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [653] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [654] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [655] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [656] = {
    [ts_builtin_sym_end] = ACTIONS(3052),
    [sym_identifier] = ACTIONS(3050),
    [aux_sym_preproc_include_token1] = ACTIONS(3050),
    [aux_sym_preproc_def_token1] = ACTIONS(3050),
    [aux_sym_preproc_if_token1] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3050),
    [sym_preproc_directive] = ACTIONS(3050),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3050),
    [anon_sym_PLUS] = ACTIONS(3050),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3050),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3050),
    [anon_sym_typedef] = ACTIONS(3050),
    [anon_sym_extern] = ACTIONS(3050),
    [anon_sym___attribute__] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3052),
    [anon_sym___declspec] = ACTIONS(3050),
    [anon_sym___based] = ACTIONS(3050),
    [anon_sym___cdecl] = ACTIONS(3050),
    [anon_sym___clrcall] = ACTIONS(3050),
    [anon_sym___stdcall] = ACTIONS(3050),
    [anon_sym___fastcall] = ACTIONS(3050),
    [anon_sym___thiscall] = ACTIONS(3050),
    [anon_sym___vectorcall] = ACTIONS(3050),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_signed] = ACTIONS(3050),
    [anon_sym_unsigned] = ACTIONS(3050),
    [anon_sym_long] = ACTIONS(3050),
    [anon_sym_short] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_static] = ACTIONS(3050),
    [anon_sym_register] = ACTIONS(3050),
    [anon_sym_inline] = ACTIONS(3050),
    [anon_sym___inline] = ACTIONS(3050),
    [anon_sym___inline__] = ACTIONS(3050),
    [anon_sym___forceinline] = ACTIONS(3050),
    [anon_sym_thread_local] = ACTIONS(3050),
    [anon_sym___thread] = ACTIONS(3050),
    [anon_sym_const] = ACTIONS(3050),
    [anon_sym_constexpr] = ACTIONS(3050),
    [anon_sym_volatile] = ACTIONS(3050),
    [anon_sym_restrict] = ACTIONS(3050),
    [anon_sym___restrict__] = ACTIONS(3050),
    [anon_sym__Atomic] = ACTIONS(3050),
    [anon_sym__Noreturn] = ACTIONS(3050),
    [anon_sym_noreturn] = ACTIONS(3050),
    [anon_sym_mutable] = ACTIONS(3050),
    [anon_sym_constinit] = ACTIONS(3050),
    [anon_sym_consteval] = ACTIONS(3050),
    [anon_sym_PROGMEM] = ACTIONS(3050),
    [aux_sym_primitive_type_token1] = ACTIONS(3050),
    [anon_sym_byte] = ACTIONS(3050),
    [anon_sym_word] = ACTIONS(3050),
    [anon_sym_enum] = ACTIONS(3050),
    [anon_sym_class] = ACTIONS(3050),
    [anon_sym_struct] = ACTIONS(3050),
    [anon_sym_union] = ACTIONS(3050),
    [anon_sym_if] = ACTIONS(3050),
    [anon_sym_else] = ACTIONS(3050),
    [anon_sym_switch] = ACTIONS(3050),
    [anon_sym_case] = ACTIONS(3050),
    [anon_sym_default] = ACTIONS(3050),
    [anon_sym_while] = ACTIONS(3050),
    [anon_sym_do] = ACTIONS(3050),
    [anon_sym_for] = ACTIONS(3050),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_break] = ACTIONS(3050),
    [anon_sym_continue] = ACTIONS(3050),
    [anon_sym_goto] = ACTIONS(3050),
    [anon_sym___try] = ACTIONS(3050),
    [anon_sym___leave] = ACTIONS(3050),
    [anon_sym_not] = ACTIONS(3050),
    [anon_sym_compl] = ACTIONS(3050),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_sizeof] = ACTIONS(3050),
    [anon_sym___alignof__] = ACTIONS(3050),
    [anon_sym___alignof] = ACTIONS(3050),
    [anon_sym__alignof] = ACTIONS(3050),
    [anon_sym_alignof] = ACTIONS(3050),
    [anon_sym__Alignof] = ACTIONS(3050),
    [anon_sym_offsetof] = ACTIONS(3050),
    [anon_sym__Generic] = ACTIONS(3050),
    [anon_sym_asm] = ACTIONS(3050),
    [anon_sym___asm__] = ACTIONS(3050),
    [aux_sym_number_literal_token1] = ACTIONS(3052),
    [aux_sym_number_literal_token2] = ACTIONS(3050),
    [anon_sym_L_SQUOTE] = ACTIONS(3052),
    [anon_sym_u_SQUOTE] = ACTIONS(3052),
    [anon_sym_U_SQUOTE] = ACTIONS(3052),
    [anon_sym_u8_SQUOTE] = ACTIONS(3052),
    [anon_sym_SQUOTE] = ACTIONS(3052),
    [anon_sym_L_DQUOTE] = ACTIONS(3052),
    [anon_sym_u_DQUOTE] = ACTIONS(3052),
    [anon_sym_U_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8_DQUOTE] = ACTIONS(3052),
    [anon_sym_DQUOTE] = ACTIONS(3052),
    [sym_true] = ACTIONS(3050),
    [sym_false] = ACTIONS(3050),
    [anon_sym_NULL] = ACTIONS(3050),
    [anon_sym_nullptr] = ACTIONS(3050),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3050),
    [anon_sym_decltype] = ACTIONS(3050),
    [anon_sym_virtual] = ACTIONS(3050),
    [anon_sym_alignas] = ACTIONS(3050),
    [anon_sym_explicit] = ACTIONS(3050),
    [anon_sym_typename] = ACTIONS(3050),
    [anon_sym_template] = ACTIONS(3050),
    [anon_sym_operator] = ACTIONS(3050),
    [anon_sym_try] = ACTIONS(3050),
    [anon_sym_delete] = ACTIONS(3050),
    [anon_sym_throw] = ACTIONS(3050),
    [anon_sym_namespace] = ACTIONS(3050),
    [anon_sym_using] = ACTIONS(3050),
    [anon_sym_static_assert] = ACTIONS(3050),
    [anon_sym_concept] = ACTIONS(3050),
    [anon_sym_co_return] = ACTIONS(3050),
    [anon_sym_co_yield] = ACTIONS(3050),
    [anon_sym_R_DQUOTE] = ACTIONS(3052),
    [anon_sym_LR_DQUOTE] = ACTIONS(3052),
    [anon_sym_uR_DQUOTE] = ACTIONS(3052),
    [anon_sym_UR_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3052),
    [anon_sym_co_await] = ACTIONS(3050),
    [anon_sym_new] = ACTIONS(3050),
    [anon_sym_requires] = ACTIONS(3050),
    [sym_this] = ACTIONS(3050),
  },
  [657] = {
    [ts_builtin_sym_end] = ACTIONS(3048),
    [sym_identifier] = ACTIONS(3046),
    [aux_sym_preproc_include_token1] = ACTIONS(3046),
    [aux_sym_preproc_def_token1] = ACTIONS(3046),
    [aux_sym_preproc_if_token1] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3046),
    [sym_preproc_directive] = ACTIONS(3046),
    [anon_sym_LPAREN2] = ACTIONS(3048),
    [anon_sym_BANG] = ACTIONS(3048),
    [anon_sym_TILDE] = ACTIONS(3048),
    [anon_sym_DASH] = ACTIONS(3046),
    [anon_sym_PLUS] = ACTIONS(3046),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_AMP_AMP] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3046),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym___extension__] = ACTIONS(3046),
    [anon_sym_typedef] = ACTIONS(3046),
    [anon_sym_extern] = ACTIONS(3046),
    [anon_sym___attribute__] = ACTIONS(3046),
    [anon_sym_COLON_COLON] = ACTIONS(3048),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3048),
    [anon_sym___declspec] = ACTIONS(3046),
    [anon_sym___based] = ACTIONS(3046),
    [anon_sym___cdecl] = ACTIONS(3046),
    [anon_sym___clrcall] = ACTIONS(3046),
    [anon_sym___stdcall] = ACTIONS(3046),
    [anon_sym___fastcall] = ACTIONS(3046),
    [anon_sym___thiscall] = ACTIONS(3046),
    [anon_sym___vectorcall] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3048),
    [anon_sym_signed] = ACTIONS(3046),
    [anon_sym_unsigned] = ACTIONS(3046),
    [anon_sym_long] = ACTIONS(3046),
    [anon_sym_short] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_static] = ACTIONS(3046),
    [anon_sym_register] = ACTIONS(3046),
    [anon_sym_inline] = ACTIONS(3046),
    [anon_sym___inline] = ACTIONS(3046),
    [anon_sym___inline__] = ACTIONS(3046),
    [anon_sym___forceinline] = ACTIONS(3046),
    [anon_sym_thread_local] = ACTIONS(3046),
    [anon_sym___thread] = ACTIONS(3046),
    [anon_sym_const] = ACTIONS(3046),
    [anon_sym_constexpr] = ACTIONS(3046),
    [anon_sym_volatile] = ACTIONS(3046),
    [anon_sym_restrict] = ACTIONS(3046),
    [anon_sym___restrict__] = ACTIONS(3046),
    [anon_sym__Atomic] = ACTIONS(3046),
    [anon_sym__Noreturn] = ACTIONS(3046),
    [anon_sym_noreturn] = ACTIONS(3046),
    [anon_sym_mutable] = ACTIONS(3046),
    [anon_sym_constinit] = ACTIONS(3046),
    [anon_sym_consteval] = ACTIONS(3046),
    [anon_sym_PROGMEM] = ACTIONS(3046),
    [aux_sym_primitive_type_token1] = ACTIONS(3046),
    [anon_sym_byte] = ACTIONS(3046),
    [anon_sym_word] = ACTIONS(3046),
    [anon_sym_enum] = ACTIONS(3046),
    [anon_sym_class] = ACTIONS(3046),
    [anon_sym_struct] = ACTIONS(3046),
    [anon_sym_union] = ACTIONS(3046),
    [anon_sym_if] = ACTIONS(3046),
    [anon_sym_else] = ACTIONS(3046),
    [anon_sym_switch] = ACTIONS(3046),
    [anon_sym_case] = ACTIONS(3046),
    [anon_sym_default] = ACTIONS(3046),
    [anon_sym_while] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_for] = ACTIONS(3046),
    [anon_sym_return] = ACTIONS(3046),
    [anon_sym_break] = ACTIONS(3046),
    [anon_sym_continue] = ACTIONS(3046),
    [anon_sym_goto] = ACTIONS(3046),
    [anon_sym___try] = ACTIONS(3046),
    [anon_sym___leave] = ACTIONS(3046),
    [anon_sym_not] = ACTIONS(3046),
    [anon_sym_compl] = ACTIONS(3046),
    [anon_sym_DASH_DASH] = ACTIONS(3048),
    [anon_sym_PLUS_PLUS] = ACTIONS(3048),
    [anon_sym_sizeof] = ACTIONS(3046),
    [anon_sym___alignof__] = ACTIONS(3046),
    [anon_sym___alignof] = ACTIONS(3046),
    [anon_sym__alignof] = ACTIONS(3046),
    [anon_sym_alignof] = ACTIONS(3046),
    [anon_sym__Alignof] = ACTIONS(3046),
    [anon_sym_offsetof] = ACTIONS(3046),
    [anon_sym__Generic] = ACTIONS(3046),
    [anon_sym_asm] = ACTIONS(3046),
    [anon_sym___asm__] = ACTIONS(3046),
    [aux_sym_number_literal_token1] = ACTIONS(3048),
    [aux_sym_number_literal_token2] = ACTIONS(3046),
    [anon_sym_L_SQUOTE] = ACTIONS(3048),
    [anon_sym_u_SQUOTE] = ACTIONS(3048),
    [anon_sym_U_SQUOTE] = ACTIONS(3048),
    [anon_sym_u8_SQUOTE] = ACTIONS(3048),
    [anon_sym_SQUOTE] = ACTIONS(3048),
    [anon_sym_L_DQUOTE] = ACTIONS(3048),
    [anon_sym_u_DQUOTE] = ACTIONS(3048),
    [anon_sym_U_DQUOTE] = ACTIONS(3048),
    [anon_sym_u8_DQUOTE] = ACTIONS(3048),
    [anon_sym_DQUOTE] = ACTIONS(3048),
    [sym_true] = ACTIONS(3046),
    [sym_false] = ACTIONS(3046),
    [anon_sym_NULL] = ACTIONS(3046),
    [anon_sym_nullptr] = ACTIONS(3046),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3046),
    [anon_sym_decltype] = ACTIONS(3046),
    [anon_sym_virtual] = ACTIONS(3046),
    [anon_sym_alignas] = ACTIONS(3046),
    [anon_sym_explicit] = ACTIONS(3046),
    [anon_sym_typename] = ACTIONS(3046),
    [anon_sym_template] = ACTIONS(3046),
    [anon_sym_operator] = ACTIONS(3046),
    [anon_sym_try] = ACTIONS(3046),
    [anon_sym_delete] = ACTIONS(3046),
    [anon_sym_throw] = ACTIONS(3046),
    [anon_sym_namespace] = ACTIONS(3046),
    [anon_sym_using] = ACTIONS(3046),
    [anon_sym_static_assert] = ACTIONS(3046),
    [anon_sym_concept] = ACTIONS(3046),
    [anon_sym_co_return] = ACTIONS(3046),
    [anon_sym_co_yield] = ACTIONS(3046),
    [anon_sym_R_DQUOTE] = ACTIONS(3048),
    [anon_sym_LR_DQUOTE] = ACTIONS(3048),
    [anon_sym_uR_DQUOTE] = ACTIONS(3048),
    [anon_sym_UR_DQUOTE] = ACTIONS(3048),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3048),
    [anon_sym_co_await] = ACTIONS(3046),
    [anon_sym_new] = ACTIONS(3046),
    [anon_sym_requires] = ACTIONS(3046),
    [sym_this] = ACTIONS(3046),
  },
  [658] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [659] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [660] = {
    [ts_builtin_sym_end] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3124),
    [aux_sym_preproc_include_token1] = ACTIONS(3124),
    [aux_sym_preproc_def_token1] = ACTIONS(3124),
    [aux_sym_preproc_if_token1] = ACTIONS(3124),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3124),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3124),
    [sym_preproc_directive] = ACTIONS(3124),
    [anon_sym_LPAREN2] = ACTIONS(3126),
    [anon_sym_BANG] = ACTIONS(3126),
    [anon_sym_TILDE] = ACTIONS(3126),
    [anon_sym_DASH] = ACTIONS(3124),
    [anon_sym_PLUS] = ACTIONS(3124),
    [anon_sym_STAR] = ACTIONS(3126),
    [anon_sym_AMP_AMP] = ACTIONS(3126),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym_SEMI] = ACTIONS(3126),
    [anon_sym___extension__] = ACTIONS(3124),
    [anon_sym_typedef] = ACTIONS(3124),
    [anon_sym_extern] = ACTIONS(3124),
    [anon_sym___attribute__] = ACTIONS(3124),
    [anon_sym_COLON_COLON] = ACTIONS(3126),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3126),
    [anon_sym___declspec] = ACTIONS(3124),
    [anon_sym___based] = ACTIONS(3124),
    [anon_sym___cdecl] = ACTIONS(3124),
    [anon_sym___clrcall] = ACTIONS(3124),
    [anon_sym___stdcall] = ACTIONS(3124),
    [anon_sym___fastcall] = ACTIONS(3124),
    [anon_sym___thiscall] = ACTIONS(3124),
    [anon_sym___vectorcall] = ACTIONS(3124),
    [anon_sym_LBRACE] = ACTIONS(3126),
    [anon_sym_signed] = ACTIONS(3124),
    [anon_sym_unsigned] = ACTIONS(3124),
    [anon_sym_long] = ACTIONS(3124),
    [anon_sym_short] = ACTIONS(3124),
    [anon_sym_LBRACK] = ACTIONS(3124),
    [anon_sym_static] = ACTIONS(3124),
    [anon_sym_register] = ACTIONS(3124),
    [anon_sym_inline] = ACTIONS(3124),
    [anon_sym___inline] = ACTIONS(3124),
    [anon_sym___inline__] = ACTIONS(3124),
    [anon_sym___forceinline] = ACTIONS(3124),
    [anon_sym_thread_local] = ACTIONS(3124),
    [anon_sym___thread] = ACTIONS(3124),
    [anon_sym_const] = ACTIONS(3124),
    [anon_sym_constexpr] = ACTIONS(3124),
    [anon_sym_volatile] = ACTIONS(3124),
    [anon_sym_restrict] = ACTIONS(3124),
    [anon_sym___restrict__] = ACTIONS(3124),
    [anon_sym__Atomic] = ACTIONS(3124),
    [anon_sym__Noreturn] = ACTIONS(3124),
    [anon_sym_noreturn] = ACTIONS(3124),
    [anon_sym_mutable] = ACTIONS(3124),
    [anon_sym_constinit] = ACTIONS(3124),
    [anon_sym_consteval] = ACTIONS(3124),
    [anon_sym_PROGMEM] = ACTIONS(3124),
    [aux_sym_primitive_type_token1] = ACTIONS(3124),
    [anon_sym_byte] = ACTIONS(3124),
    [anon_sym_word] = ACTIONS(3124),
    [anon_sym_enum] = ACTIONS(3124),
    [anon_sym_class] = ACTIONS(3124),
    [anon_sym_struct] = ACTIONS(3124),
    [anon_sym_union] = ACTIONS(3124),
    [anon_sym_if] = ACTIONS(3124),
    [anon_sym_else] = ACTIONS(3124),
    [anon_sym_switch] = ACTIONS(3124),
    [anon_sym_case] = ACTIONS(3124),
    [anon_sym_default] = ACTIONS(3124),
    [anon_sym_while] = ACTIONS(3124),
    [anon_sym_do] = ACTIONS(3124),
    [anon_sym_for] = ACTIONS(3124),
    [anon_sym_return] = ACTIONS(3124),
    [anon_sym_break] = ACTIONS(3124),
    [anon_sym_continue] = ACTIONS(3124),
    [anon_sym_goto] = ACTIONS(3124),
    [anon_sym___try] = ACTIONS(3124),
    [anon_sym___leave] = ACTIONS(3124),
    [anon_sym_not] = ACTIONS(3124),
    [anon_sym_compl] = ACTIONS(3124),
    [anon_sym_DASH_DASH] = ACTIONS(3126),
    [anon_sym_PLUS_PLUS] = ACTIONS(3126),
    [anon_sym_sizeof] = ACTIONS(3124),
    [anon_sym___alignof__] = ACTIONS(3124),
    [anon_sym___alignof] = ACTIONS(3124),
    [anon_sym__alignof] = ACTIONS(3124),
    [anon_sym_alignof] = ACTIONS(3124),
    [anon_sym__Alignof] = ACTIONS(3124),
    [anon_sym_offsetof] = ACTIONS(3124),
    [anon_sym__Generic] = ACTIONS(3124),
    [anon_sym_asm] = ACTIONS(3124),
    [anon_sym___asm__] = ACTIONS(3124),
    [aux_sym_number_literal_token1] = ACTIONS(3126),
    [aux_sym_number_literal_token2] = ACTIONS(3124),
    [anon_sym_L_SQUOTE] = ACTIONS(3126),
    [anon_sym_u_SQUOTE] = ACTIONS(3126),
    [anon_sym_U_SQUOTE] = ACTIONS(3126),
    [anon_sym_u8_SQUOTE] = ACTIONS(3126),
    [anon_sym_SQUOTE] = ACTIONS(3126),
    [anon_sym_L_DQUOTE] = ACTIONS(3126),
    [anon_sym_u_DQUOTE] = ACTIONS(3126),
    [anon_sym_U_DQUOTE] = ACTIONS(3126),
    [anon_sym_u8_DQUOTE] = ACTIONS(3126),
    [anon_sym_DQUOTE] = ACTIONS(3126),
    [sym_true] = ACTIONS(3124),
    [sym_false] = ACTIONS(3124),
    [anon_sym_NULL] = ACTIONS(3124),
    [anon_sym_nullptr] = ACTIONS(3124),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3124),
    [anon_sym_decltype] = ACTIONS(3124),
    [anon_sym_virtual] = ACTIONS(3124),
    [anon_sym_alignas] = ACTIONS(3124),
    [anon_sym_explicit] = ACTIONS(3124),
    [anon_sym_typename] = ACTIONS(3124),
    [anon_sym_template] = ACTIONS(3124),
    [anon_sym_operator] = ACTIONS(3124),
    [anon_sym_try] = ACTIONS(3124),
    [anon_sym_delete] = ACTIONS(3124),
    [anon_sym_throw] = ACTIONS(3124),
    [anon_sym_namespace] = ACTIONS(3124),
    [anon_sym_using] = ACTIONS(3124),
    [anon_sym_static_assert] = ACTIONS(3124),
    [anon_sym_concept] = ACTIONS(3124),
    [anon_sym_co_return] = ACTIONS(3124),
    [anon_sym_co_yield] = ACTIONS(3124),
    [anon_sym_R_DQUOTE] = ACTIONS(3126),
    [anon_sym_LR_DQUOTE] = ACTIONS(3126),
    [anon_sym_uR_DQUOTE] = ACTIONS(3126),
    [anon_sym_UR_DQUOTE] = ACTIONS(3126),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3126),
    [anon_sym_co_await] = ACTIONS(3124),
    [anon_sym_new] = ACTIONS(3124),
    [anon_sym_requires] = ACTIONS(3124),
    [sym_this] = ACTIONS(3124),
  },
  [661] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [662] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [663] = {
    [ts_builtin_sym_end] = ACTIONS(3104),
    [sym_identifier] = ACTIONS(3102),
    [aux_sym_preproc_include_token1] = ACTIONS(3102),
    [aux_sym_preproc_def_token1] = ACTIONS(3102),
    [aux_sym_preproc_if_token1] = ACTIONS(3102),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3102),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3102),
    [sym_preproc_directive] = ACTIONS(3102),
    [anon_sym_LPAREN2] = ACTIONS(3104),
    [anon_sym_BANG] = ACTIONS(3104),
    [anon_sym_TILDE] = ACTIONS(3104),
    [anon_sym_DASH] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(3104),
    [anon_sym_AMP_AMP] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3102),
    [anon_sym_SEMI] = ACTIONS(3104),
    [anon_sym___extension__] = ACTIONS(3102),
    [anon_sym_typedef] = ACTIONS(3102),
    [anon_sym_extern] = ACTIONS(3102),
    [anon_sym___attribute__] = ACTIONS(3102),
    [anon_sym_COLON_COLON] = ACTIONS(3104),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3104),
    [anon_sym___declspec] = ACTIONS(3102),
    [anon_sym___based] = ACTIONS(3102),
    [anon_sym___cdecl] = ACTIONS(3102),
    [anon_sym___clrcall] = ACTIONS(3102),
    [anon_sym___stdcall] = ACTIONS(3102),
    [anon_sym___fastcall] = ACTIONS(3102),
    [anon_sym___thiscall] = ACTIONS(3102),
    [anon_sym___vectorcall] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3104),
    [anon_sym_signed] = ACTIONS(3102),
    [anon_sym_unsigned] = ACTIONS(3102),
    [anon_sym_long] = ACTIONS(3102),
    [anon_sym_short] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_static] = ACTIONS(3102),
    [anon_sym_register] = ACTIONS(3102),
    [anon_sym_inline] = ACTIONS(3102),
    [anon_sym___inline] = ACTIONS(3102),
    [anon_sym___inline__] = ACTIONS(3102),
    [anon_sym___forceinline] = ACTIONS(3102),
    [anon_sym_thread_local] = ACTIONS(3102),
    [anon_sym___thread] = ACTIONS(3102),
    [anon_sym_const] = ACTIONS(3102),
    [anon_sym_constexpr] = ACTIONS(3102),
    [anon_sym_volatile] = ACTIONS(3102),
    [anon_sym_restrict] = ACTIONS(3102),
    [anon_sym___restrict__] = ACTIONS(3102),
    [anon_sym__Atomic] = ACTIONS(3102),
    [anon_sym__Noreturn] = ACTIONS(3102),
    [anon_sym_noreturn] = ACTIONS(3102),
    [anon_sym_mutable] = ACTIONS(3102),
    [anon_sym_constinit] = ACTIONS(3102),
    [anon_sym_consteval] = ACTIONS(3102),
    [anon_sym_PROGMEM] = ACTIONS(3102),
    [aux_sym_primitive_type_token1] = ACTIONS(3102),
    [anon_sym_byte] = ACTIONS(3102),
    [anon_sym_word] = ACTIONS(3102),
    [anon_sym_enum] = ACTIONS(3102),
    [anon_sym_class] = ACTIONS(3102),
    [anon_sym_struct] = ACTIONS(3102),
    [anon_sym_union] = ACTIONS(3102),
    [anon_sym_if] = ACTIONS(3102),
    [anon_sym_else] = ACTIONS(3102),
    [anon_sym_switch] = ACTIONS(3102),
    [anon_sym_case] = ACTIONS(3102),
    [anon_sym_default] = ACTIONS(3102),
    [anon_sym_while] = ACTIONS(3102),
    [anon_sym_do] = ACTIONS(3102),
    [anon_sym_for] = ACTIONS(3102),
    [anon_sym_return] = ACTIONS(3102),
    [anon_sym_break] = ACTIONS(3102),
    [anon_sym_continue] = ACTIONS(3102),
    [anon_sym_goto] = ACTIONS(3102),
    [anon_sym___try] = ACTIONS(3102),
    [anon_sym___leave] = ACTIONS(3102),
    [anon_sym_not] = ACTIONS(3102),
    [anon_sym_compl] = ACTIONS(3102),
    [anon_sym_DASH_DASH] = ACTIONS(3104),
    [anon_sym_PLUS_PLUS] = ACTIONS(3104),
    [anon_sym_sizeof] = ACTIONS(3102),
    [anon_sym___alignof__] = ACTIONS(3102),
    [anon_sym___alignof] = ACTIONS(3102),
    [anon_sym__alignof] = ACTIONS(3102),
    [anon_sym_alignof] = ACTIONS(3102),
    [anon_sym__Alignof] = ACTIONS(3102),
    [anon_sym_offsetof] = ACTIONS(3102),
    [anon_sym__Generic] = ACTIONS(3102),
    [anon_sym_asm] = ACTIONS(3102),
    [anon_sym___asm__] = ACTIONS(3102),
    [aux_sym_number_literal_token1] = ACTIONS(3104),
    [aux_sym_number_literal_token2] = ACTIONS(3102),
    [anon_sym_L_SQUOTE] = ACTIONS(3104),
    [anon_sym_u_SQUOTE] = ACTIONS(3104),
    [anon_sym_U_SQUOTE] = ACTIONS(3104),
    [anon_sym_u8_SQUOTE] = ACTIONS(3104),
    [anon_sym_SQUOTE] = ACTIONS(3104),
    [anon_sym_L_DQUOTE] = ACTIONS(3104),
    [anon_sym_u_DQUOTE] = ACTIONS(3104),
    [anon_sym_U_DQUOTE] = ACTIONS(3104),
    [anon_sym_u8_DQUOTE] = ACTIONS(3104),
    [anon_sym_DQUOTE] = ACTIONS(3104),
    [sym_true] = ACTIONS(3102),
    [sym_false] = ACTIONS(3102),
    [anon_sym_NULL] = ACTIONS(3102),
    [anon_sym_nullptr] = ACTIONS(3102),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3102),
    [anon_sym_decltype] = ACTIONS(3102),
    [anon_sym_virtual] = ACTIONS(3102),
    [anon_sym_alignas] = ACTIONS(3102),
    [anon_sym_explicit] = ACTIONS(3102),
    [anon_sym_typename] = ACTIONS(3102),
    [anon_sym_template] = ACTIONS(3102),
    [anon_sym_operator] = ACTIONS(3102),
    [anon_sym_try] = ACTIONS(3102),
    [anon_sym_delete] = ACTIONS(3102),
    [anon_sym_throw] = ACTIONS(3102),
    [anon_sym_namespace] = ACTIONS(3102),
    [anon_sym_using] = ACTIONS(3102),
    [anon_sym_static_assert] = ACTIONS(3102),
    [anon_sym_concept] = ACTIONS(3102),
    [anon_sym_co_return] = ACTIONS(3102),
    [anon_sym_co_yield] = ACTIONS(3102),
    [anon_sym_R_DQUOTE] = ACTIONS(3104),
    [anon_sym_LR_DQUOTE] = ACTIONS(3104),
    [anon_sym_uR_DQUOTE] = ACTIONS(3104),
    [anon_sym_UR_DQUOTE] = ACTIONS(3104),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3104),
    [anon_sym_co_await] = ACTIONS(3102),
    [anon_sym_new] = ACTIONS(3102),
    [anon_sym_requires] = ACTIONS(3102),
    [sym_this] = ACTIONS(3102),
  },
  [664] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [665] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [666] = {
    [ts_builtin_sym_end] = ACTIONS(2874),
    [sym_identifier] = ACTIONS(2869),
    [aux_sym_preproc_include_token1] = ACTIONS(2869),
    [aux_sym_preproc_def_token1] = ACTIONS(2869),
    [aux_sym_preproc_if_token1] = ACTIONS(2869),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2869),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2869),
    [sym_preproc_directive] = ACTIONS(2869),
    [anon_sym_LPAREN2] = ACTIONS(2874),
    [anon_sym_BANG] = ACTIONS(2874),
    [anon_sym_TILDE] = ACTIONS(2874),
    [anon_sym_DASH] = ACTIONS(2869),
    [anon_sym_PLUS] = ACTIONS(2869),
    [anon_sym_STAR] = ACTIONS(2874),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2869),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym___extension__] = ACTIONS(2869),
    [anon_sym_typedef] = ACTIONS(2869),
    [anon_sym_extern] = ACTIONS(2869),
    [anon_sym___attribute__] = ACTIONS(2869),
    [anon_sym_COLON_COLON] = ACTIONS(2874),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2874),
    [anon_sym___declspec] = ACTIONS(2869),
    [anon_sym___based] = ACTIONS(2869),
    [anon_sym___cdecl] = ACTIONS(2869),
    [anon_sym___clrcall] = ACTIONS(2869),
    [anon_sym___stdcall] = ACTIONS(2869),
    [anon_sym___fastcall] = ACTIONS(2869),
    [anon_sym___thiscall] = ACTIONS(2869),
    [anon_sym___vectorcall] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2874),
    [anon_sym_signed] = ACTIONS(2869),
    [anon_sym_unsigned] = ACTIONS(2869),
    [anon_sym_long] = ACTIONS(2869),
    [anon_sym_short] = ACTIONS(2869),
    [anon_sym_LBRACK] = ACTIONS(2869),
    [anon_sym_static] = ACTIONS(2869),
    [anon_sym_register] = ACTIONS(2869),
    [anon_sym_inline] = ACTIONS(2869),
    [anon_sym___inline] = ACTIONS(2869),
    [anon_sym___inline__] = ACTIONS(2869),
    [anon_sym___forceinline] = ACTIONS(2869),
    [anon_sym_thread_local] = ACTIONS(2869),
    [anon_sym___thread] = ACTIONS(2869),
    [anon_sym_const] = ACTIONS(2869),
    [anon_sym_constexpr] = ACTIONS(2869),
    [anon_sym_volatile] = ACTIONS(2869),
    [anon_sym_restrict] = ACTIONS(2869),
    [anon_sym___restrict__] = ACTIONS(2869),
    [anon_sym__Atomic] = ACTIONS(2869),
    [anon_sym__Noreturn] = ACTIONS(2869),
    [anon_sym_noreturn] = ACTIONS(2869),
    [anon_sym_mutable] = ACTIONS(2869),
    [anon_sym_constinit] = ACTIONS(2869),
    [anon_sym_consteval] = ACTIONS(2869),
    [anon_sym_PROGMEM] = ACTIONS(2869),
    [aux_sym_primitive_type_token1] = ACTIONS(2869),
    [anon_sym_byte] = ACTIONS(2869),
    [anon_sym_word] = ACTIONS(2869),
    [anon_sym_enum] = ACTIONS(2869),
    [anon_sym_class] = ACTIONS(2869),
    [anon_sym_struct] = ACTIONS(2869),
    [anon_sym_union] = ACTIONS(2869),
    [anon_sym_if] = ACTIONS(2869),
    [anon_sym_else] = ACTIONS(2869),
    [anon_sym_switch] = ACTIONS(2869),
    [anon_sym_case] = ACTIONS(2869),
    [anon_sym_default] = ACTIONS(2869),
    [anon_sym_while] = ACTIONS(2869),
    [anon_sym_do] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2869),
    [anon_sym_return] = ACTIONS(2869),
    [anon_sym_break] = ACTIONS(2869),
    [anon_sym_continue] = ACTIONS(2869),
    [anon_sym_goto] = ACTIONS(2869),
    [anon_sym___try] = ACTIONS(2869),
    [anon_sym___leave] = ACTIONS(2869),
    [anon_sym_not] = ACTIONS(2869),
    [anon_sym_compl] = ACTIONS(2869),
    [anon_sym_DASH_DASH] = ACTIONS(2874),
    [anon_sym_PLUS_PLUS] = ACTIONS(2874),
    [anon_sym_sizeof] = ACTIONS(2869),
    [anon_sym___alignof__] = ACTIONS(2869),
    [anon_sym___alignof] = ACTIONS(2869),
    [anon_sym__alignof] = ACTIONS(2869),
    [anon_sym_alignof] = ACTIONS(2869),
    [anon_sym__Alignof] = ACTIONS(2869),
    [anon_sym_offsetof] = ACTIONS(2869),
    [anon_sym__Generic] = ACTIONS(2869),
    [anon_sym_asm] = ACTIONS(2869),
    [anon_sym___asm__] = ACTIONS(2869),
    [aux_sym_number_literal_token1] = ACTIONS(2874),
    [aux_sym_number_literal_token2] = ACTIONS(2869),
    [anon_sym_L_SQUOTE] = ACTIONS(2874),
    [anon_sym_u_SQUOTE] = ACTIONS(2874),
    [anon_sym_U_SQUOTE] = ACTIONS(2874),
    [anon_sym_u8_SQUOTE] = ACTIONS(2874),
    [anon_sym_SQUOTE] = ACTIONS(2874),
    [anon_sym_L_DQUOTE] = ACTIONS(2874),
    [anon_sym_u_DQUOTE] = ACTIONS(2874),
    [anon_sym_U_DQUOTE] = ACTIONS(2874),
    [anon_sym_u8_DQUOTE] = ACTIONS(2874),
    [anon_sym_DQUOTE] = ACTIONS(2874),
    [sym_true] = ACTIONS(2869),
    [sym_false] = ACTIONS(2869),
    [anon_sym_NULL] = ACTIONS(2869),
    [anon_sym_nullptr] = ACTIONS(2869),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2869),
    [anon_sym_decltype] = ACTIONS(2869),
    [anon_sym_virtual] = ACTIONS(2869),
    [anon_sym_alignas] = ACTIONS(2869),
    [anon_sym_explicit] = ACTIONS(2869),
    [anon_sym_typename] = ACTIONS(2869),
    [anon_sym_template] = ACTIONS(2869),
    [anon_sym_operator] = ACTIONS(2869),
    [anon_sym_try] = ACTIONS(2869),
    [anon_sym_delete] = ACTIONS(2869),
    [anon_sym_throw] = ACTIONS(2869),
    [anon_sym_namespace] = ACTIONS(2869),
    [anon_sym_using] = ACTIONS(2869),
    [anon_sym_static_assert] = ACTIONS(2869),
    [anon_sym_concept] = ACTIONS(2869),
    [anon_sym_co_return] = ACTIONS(2869),
    [anon_sym_co_yield] = ACTIONS(2869),
    [anon_sym_R_DQUOTE] = ACTIONS(2874),
    [anon_sym_LR_DQUOTE] = ACTIONS(2874),
    [anon_sym_uR_DQUOTE] = ACTIONS(2874),
    [anon_sym_UR_DQUOTE] = ACTIONS(2874),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2874),
    [anon_sym_co_await] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2869),
    [sym_this] = ACTIONS(2869),
  },
  [667] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [668] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [669] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [670] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [671] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [672] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [673] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [674] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [675] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [676] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [677] = {
    [ts_builtin_sym_end] = ACTIONS(2972),
    [sym_identifier] = ACTIONS(2970),
    [aux_sym_preproc_include_token1] = ACTIONS(2970),
    [aux_sym_preproc_def_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token1] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2970),
    [sym_preproc_directive] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_BANG] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym___extension__] = ACTIONS(2970),
    [anon_sym_typedef] = ACTIONS(2970),
    [anon_sym_extern] = ACTIONS(2970),
    [anon_sym___attribute__] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2970),
    [anon_sym___based] = ACTIONS(2970),
    [anon_sym___cdecl] = ACTIONS(2970),
    [anon_sym___clrcall] = ACTIONS(2970),
    [anon_sym___stdcall] = ACTIONS(2970),
    [anon_sym___fastcall] = ACTIONS(2970),
    [anon_sym___thiscall] = ACTIONS(2970),
    [anon_sym___vectorcall] = ACTIONS(2970),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_signed] = ACTIONS(2970),
    [anon_sym_unsigned] = ACTIONS(2970),
    [anon_sym_long] = ACTIONS(2970),
    [anon_sym_short] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_register] = ACTIONS(2970),
    [anon_sym_inline] = ACTIONS(2970),
    [anon_sym___inline] = ACTIONS(2970),
    [anon_sym___inline__] = ACTIONS(2970),
    [anon_sym___forceinline] = ACTIONS(2970),
    [anon_sym_thread_local] = ACTIONS(2970),
    [anon_sym___thread] = ACTIONS(2970),
    [anon_sym_const] = ACTIONS(2970),
    [anon_sym_constexpr] = ACTIONS(2970),
    [anon_sym_volatile] = ACTIONS(2970),
    [anon_sym_restrict] = ACTIONS(2970),
    [anon_sym___restrict__] = ACTIONS(2970),
    [anon_sym__Atomic] = ACTIONS(2970),
    [anon_sym__Noreturn] = ACTIONS(2970),
    [anon_sym_noreturn] = ACTIONS(2970),
    [anon_sym_mutable] = ACTIONS(2970),
    [anon_sym_constinit] = ACTIONS(2970),
    [anon_sym_consteval] = ACTIONS(2970),
    [anon_sym_PROGMEM] = ACTIONS(2970),
    [aux_sym_primitive_type_token1] = ACTIONS(2970),
    [anon_sym_byte] = ACTIONS(2970),
    [anon_sym_word] = ACTIONS(2970),
    [anon_sym_enum] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_struct] = ACTIONS(2970),
    [anon_sym_union] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_else] = ACTIONS(2970),
    [anon_sym_switch] = ACTIONS(2970),
    [anon_sym_case] = ACTIONS(2970),
    [anon_sym_default] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_break] = ACTIONS(2970),
    [anon_sym_continue] = ACTIONS(2970),
    [anon_sym_goto] = ACTIONS(2970),
    [anon_sym___try] = ACTIONS(2970),
    [anon_sym___leave] = ACTIONS(2970),
    [anon_sym_not] = ACTIONS(2970),
    [anon_sym_compl] = ACTIONS(2970),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_sizeof] = ACTIONS(2970),
    [anon_sym___alignof__] = ACTIONS(2970),
    [anon_sym___alignof] = ACTIONS(2970),
    [anon_sym__alignof] = ACTIONS(2970),
    [anon_sym_alignof] = ACTIONS(2970),
    [anon_sym__Alignof] = ACTIONS(2970),
    [anon_sym_offsetof] = ACTIONS(2970),
    [anon_sym__Generic] = ACTIONS(2970),
    [anon_sym_asm] = ACTIONS(2970),
    [anon_sym___asm__] = ACTIONS(2970),
    [aux_sym_number_literal_token1] = ACTIONS(2972),
    [aux_sym_number_literal_token2] = ACTIONS(2970),
    [anon_sym_L_SQUOTE] = ACTIONS(2972),
    [anon_sym_u_SQUOTE] = ACTIONS(2972),
    [anon_sym_U_SQUOTE] = ACTIONS(2972),
    [anon_sym_u8_SQUOTE] = ACTIONS(2972),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [anon_sym_L_DQUOTE] = ACTIONS(2972),
    [anon_sym_u_DQUOTE] = ACTIONS(2972),
    [anon_sym_U_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE] = ACTIONS(2972),
    [sym_true] = ACTIONS(2970),
    [sym_false] = ACTIONS(2970),
    [anon_sym_NULL] = ACTIONS(2970),
    [anon_sym_nullptr] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2970),
    [anon_sym_decltype] = ACTIONS(2970),
    [anon_sym_virtual] = ACTIONS(2970),
    [anon_sym_alignas] = ACTIONS(2970),
    [anon_sym_explicit] = ACTIONS(2970),
    [anon_sym_typename] = ACTIONS(2970),
    [anon_sym_template] = ACTIONS(2970),
    [anon_sym_operator] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_delete] = ACTIONS(2970),
    [anon_sym_throw] = ACTIONS(2970),
    [anon_sym_namespace] = ACTIONS(2970),
    [anon_sym_using] = ACTIONS(2970),
    [anon_sym_static_assert] = ACTIONS(2970),
    [anon_sym_concept] = ACTIONS(2970),
    [anon_sym_co_return] = ACTIONS(2970),
    [anon_sym_co_yield] = ACTIONS(2970),
    [anon_sym_R_DQUOTE] = ACTIONS(2972),
    [anon_sym_LR_DQUOTE] = ACTIONS(2972),
    [anon_sym_uR_DQUOTE] = ACTIONS(2972),
    [anon_sym_UR_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2972),
    [anon_sym_co_await] = ACTIONS(2970),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_requires] = ACTIONS(2970),
    [sym_this] = ACTIONS(2970),
  },
  [678] = {
    [sym_identifier] = ACTIONS(3138),
    [aux_sym_preproc_include_token1] = ACTIONS(3138),
    [aux_sym_preproc_def_token1] = ACTIONS(3138),
    [aux_sym_preproc_if_token1] = ACTIONS(3138),
    [aux_sym_preproc_if_token2] = ACTIONS(3138),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3138),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3138),
    [sym_preproc_directive] = ACTIONS(3138),
    [anon_sym_LPAREN2] = ACTIONS(3140),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [anon_sym_DASH] = ACTIONS(3138),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_STAR] = ACTIONS(3140),
    [anon_sym_AMP_AMP] = ACTIONS(3140),
    [anon_sym_AMP] = ACTIONS(3138),
    [anon_sym_SEMI] = ACTIONS(3140),
    [anon_sym___extension__] = ACTIONS(3138),
    [anon_sym_typedef] = ACTIONS(3138),
    [anon_sym_extern] = ACTIONS(3138),
    [anon_sym___attribute__] = ACTIONS(3138),
    [anon_sym_COLON_COLON] = ACTIONS(3140),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3140),
    [anon_sym___declspec] = ACTIONS(3138),
    [anon_sym___based] = ACTIONS(3138),
    [anon_sym___cdecl] = ACTIONS(3138),
    [anon_sym___clrcall] = ACTIONS(3138),
    [anon_sym___stdcall] = ACTIONS(3138),
    [anon_sym___fastcall] = ACTIONS(3138),
    [anon_sym___thiscall] = ACTIONS(3138),
    [anon_sym___vectorcall] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [anon_sym_signed] = ACTIONS(3138),
    [anon_sym_unsigned] = ACTIONS(3138),
    [anon_sym_long] = ACTIONS(3138),
    [anon_sym_short] = ACTIONS(3138),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_static] = ACTIONS(3138),
    [anon_sym_register] = ACTIONS(3138),
    [anon_sym_inline] = ACTIONS(3138),
    [anon_sym___inline] = ACTIONS(3138),
    [anon_sym___inline__] = ACTIONS(3138),
    [anon_sym___forceinline] = ACTIONS(3138),
    [anon_sym_thread_local] = ACTIONS(3138),
    [anon_sym___thread] = ACTIONS(3138),
    [anon_sym_const] = ACTIONS(3138),
    [anon_sym_constexpr] = ACTIONS(3138),
    [anon_sym_volatile] = ACTIONS(3138),
    [anon_sym_restrict] = ACTIONS(3138),
    [anon_sym___restrict__] = ACTIONS(3138),
    [anon_sym__Atomic] = ACTIONS(3138),
    [anon_sym__Noreturn] = ACTIONS(3138),
    [anon_sym_noreturn] = ACTIONS(3138),
    [anon_sym_mutable] = ACTIONS(3138),
    [anon_sym_constinit] = ACTIONS(3138),
    [anon_sym_consteval] = ACTIONS(3138),
    [anon_sym_PROGMEM] = ACTIONS(3138),
    [aux_sym_primitive_type_token1] = ACTIONS(3138),
    [anon_sym_byte] = ACTIONS(3138),
    [anon_sym_word] = ACTIONS(3138),
    [anon_sym_enum] = ACTIONS(3138),
    [anon_sym_class] = ACTIONS(3138),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3138),
    [anon_sym_if] = ACTIONS(3138),
    [anon_sym_else] = ACTIONS(3138),
    [anon_sym_switch] = ACTIONS(3138),
    [anon_sym_case] = ACTIONS(3138),
    [anon_sym_default] = ACTIONS(3138),
    [anon_sym_while] = ACTIONS(3138),
    [anon_sym_do] = ACTIONS(3138),
    [anon_sym_for] = ACTIONS(3138),
    [anon_sym_return] = ACTIONS(3138),
    [anon_sym_break] = ACTIONS(3138),
    [anon_sym_continue] = ACTIONS(3138),
    [anon_sym_goto] = ACTIONS(3138),
    [anon_sym___try] = ACTIONS(3138),
    [anon_sym___leave] = ACTIONS(3138),
    [anon_sym_not] = ACTIONS(3138),
    [anon_sym_compl] = ACTIONS(3138),
    [anon_sym_DASH_DASH] = ACTIONS(3140),
    [anon_sym_PLUS_PLUS] = ACTIONS(3140),
    [anon_sym_sizeof] = ACTIONS(3138),
    [anon_sym___alignof__] = ACTIONS(3138),
    [anon_sym___alignof] = ACTIONS(3138),
    [anon_sym__alignof] = ACTIONS(3138),
    [anon_sym_alignof] = ACTIONS(3138),
    [anon_sym__Alignof] = ACTIONS(3138),
    [anon_sym_offsetof] = ACTIONS(3138),
    [anon_sym__Generic] = ACTIONS(3138),
    [anon_sym_asm] = ACTIONS(3138),
    [anon_sym___asm__] = ACTIONS(3138),
    [aux_sym_number_literal_token1] = ACTIONS(3140),
    [aux_sym_number_literal_token2] = ACTIONS(3138),
    [anon_sym_L_SQUOTE] = ACTIONS(3140),
    [anon_sym_u_SQUOTE] = ACTIONS(3140),
    [anon_sym_U_SQUOTE] = ACTIONS(3140),
    [anon_sym_u8_SQUOTE] = ACTIONS(3140),
    [anon_sym_SQUOTE] = ACTIONS(3140),
    [anon_sym_L_DQUOTE] = ACTIONS(3140),
    [anon_sym_u_DQUOTE] = ACTIONS(3140),
    [anon_sym_U_DQUOTE] = ACTIONS(3140),
    [anon_sym_u8_DQUOTE] = ACTIONS(3140),
    [anon_sym_DQUOTE] = ACTIONS(3140),
    [sym_true] = ACTIONS(3138),
    [sym_false] = ACTIONS(3138),
    [anon_sym_NULL] = ACTIONS(3138),
    [anon_sym_nullptr] = ACTIONS(3138),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3138),
    [anon_sym_decltype] = ACTIONS(3138),
    [anon_sym_virtual] = ACTIONS(3138),
    [anon_sym_alignas] = ACTIONS(3138),
    [anon_sym_explicit] = ACTIONS(3138),
    [anon_sym_typename] = ACTIONS(3138),
    [anon_sym_template] = ACTIONS(3138),
    [anon_sym_operator] = ACTIONS(3138),
    [anon_sym_try] = ACTIONS(3138),
    [anon_sym_delete] = ACTIONS(3138),
    [anon_sym_throw] = ACTIONS(3138),
    [anon_sym_namespace] = ACTIONS(3138),
    [anon_sym_using] = ACTIONS(3138),
    [anon_sym_static_assert] = ACTIONS(3138),
    [anon_sym_concept] = ACTIONS(3138),
    [anon_sym_co_return] = ACTIONS(3138),
    [anon_sym_co_yield] = ACTIONS(3138),
    [anon_sym_R_DQUOTE] = ACTIONS(3140),
    [anon_sym_LR_DQUOTE] = ACTIONS(3140),
    [anon_sym_uR_DQUOTE] = ACTIONS(3140),
    [anon_sym_UR_DQUOTE] = ACTIONS(3140),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3140),
    [anon_sym_co_await] = ACTIONS(3138),
    [anon_sym_new] = ACTIONS(3138),
    [anon_sym_requires] = ACTIONS(3138),
    [sym_this] = ACTIONS(3138),
  },
  [679] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [680] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [681] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [682] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [683] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [684] = {
    [ts_builtin_sym_end] = ACTIONS(2972),
    [sym_identifier] = ACTIONS(2970),
    [aux_sym_preproc_include_token1] = ACTIONS(2970),
    [aux_sym_preproc_def_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token1] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2970),
    [sym_preproc_directive] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_BANG] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym___extension__] = ACTIONS(2970),
    [anon_sym_typedef] = ACTIONS(2970),
    [anon_sym_extern] = ACTIONS(2970),
    [anon_sym___attribute__] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2970),
    [anon_sym___based] = ACTIONS(2970),
    [anon_sym___cdecl] = ACTIONS(2970),
    [anon_sym___clrcall] = ACTIONS(2970),
    [anon_sym___stdcall] = ACTIONS(2970),
    [anon_sym___fastcall] = ACTIONS(2970),
    [anon_sym___thiscall] = ACTIONS(2970),
    [anon_sym___vectorcall] = ACTIONS(2970),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_signed] = ACTIONS(2970),
    [anon_sym_unsigned] = ACTIONS(2970),
    [anon_sym_long] = ACTIONS(2970),
    [anon_sym_short] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_register] = ACTIONS(2970),
    [anon_sym_inline] = ACTIONS(2970),
    [anon_sym___inline] = ACTIONS(2970),
    [anon_sym___inline__] = ACTIONS(2970),
    [anon_sym___forceinline] = ACTIONS(2970),
    [anon_sym_thread_local] = ACTIONS(2970),
    [anon_sym___thread] = ACTIONS(2970),
    [anon_sym_const] = ACTIONS(2970),
    [anon_sym_constexpr] = ACTIONS(2970),
    [anon_sym_volatile] = ACTIONS(2970),
    [anon_sym_restrict] = ACTIONS(2970),
    [anon_sym___restrict__] = ACTIONS(2970),
    [anon_sym__Atomic] = ACTIONS(2970),
    [anon_sym__Noreturn] = ACTIONS(2970),
    [anon_sym_noreturn] = ACTIONS(2970),
    [anon_sym_mutable] = ACTIONS(2970),
    [anon_sym_constinit] = ACTIONS(2970),
    [anon_sym_consteval] = ACTIONS(2970),
    [anon_sym_PROGMEM] = ACTIONS(2970),
    [aux_sym_primitive_type_token1] = ACTIONS(2970),
    [anon_sym_byte] = ACTIONS(2970),
    [anon_sym_word] = ACTIONS(2970),
    [anon_sym_enum] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_struct] = ACTIONS(2970),
    [anon_sym_union] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_else] = ACTIONS(2970),
    [anon_sym_switch] = ACTIONS(2970),
    [anon_sym_case] = ACTIONS(2970),
    [anon_sym_default] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_break] = ACTIONS(2970),
    [anon_sym_continue] = ACTIONS(2970),
    [anon_sym_goto] = ACTIONS(2970),
    [anon_sym___try] = ACTIONS(2970),
    [anon_sym___leave] = ACTIONS(2970),
    [anon_sym_not] = ACTIONS(2970),
    [anon_sym_compl] = ACTIONS(2970),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_sizeof] = ACTIONS(2970),
    [anon_sym___alignof__] = ACTIONS(2970),
    [anon_sym___alignof] = ACTIONS(2970),
    [anon_sym__alignof] = ACTIONS(2970),
    [anon_sym_alignof] = ACTIONS(2970),
    [anon_sym__Alignof] = ACTIONS(2970),
    [anon_sym_offsetof] = ACTIONS(2970),
    [anon_sym__Generic] = ACTIONS(2970),
    [anon_sym_asm] = ACTIONS(2970),
    [anon_sym___asm__] = ACTIONS(2970),
    [aux_sym_number_literal_token1] = ACTIONS(2972),
    [aux_sym_number_literal_token2] = ACTIONS(2970),
    [anon_sym_L_SQUOTE] = ACTIONS(2972),
    [anon_sym_u_SQUOTE] = ACTIONS(2972),
    [anon_sym_U_SQUOTE] = ACTIONS(2972),
    [anon_sym_u8_SQUOTE] = ACTIONS(2972),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [anon_sym_L_DQUOTE] = ACTIONS(2972),
    [anon_sym_u_DQUOTE] = ACTIONS(2972),
    [anon_sym_U_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE] = ACTIONS(2972),
    [sym_true] = ACTIONS(2970),
    [sym_false] = ACTIONS(2970),
    [anon_sym_NULL] = ACTIONS(2970),
    [anon_sym_nullptr] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2970),
    [anon_sym_decltype] = ACTIONS(2970),
    [anon_sym_virtual] = ACTIONS(2970),
    [anon_sym_alignas] = ACTIONS(2970),
    [anon_sym_explicit] = ACTIONS(2970),
    [anon_sym_typename] = ACTIONS(2970),
    [anon_sym_template] = ACTIONS(2970),
    [anon_sym_operator] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_delete] = ACTIONS(2970),
    [anon_sym_throw] = ACTIONS(2970),
    [anon_sym_namespace] = ACTIONS(2970),
    [anon_sym_using] = ACTIONS(2970),
    [anon_sym_static_assert] = ACTIONS(2970),
    [anon_sym_concept] = ACTIONS(2970),
    [anon_sym_co_return] = ACTIONS(2970),
    [anon_sym_co_yield] = ACTIONS(2970),
    [anon_sym_R_DQUOTE] = ACTIONS(2972),
    [anon_sym_LR_DQUOTE] = ACTIONS(2972),
    [anon_sym_uR_DQUOTE] = ACTIONS(2972),
    [anon_sym_UR_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2972),
    [anon_sym_co_await] = ACTIONS(2970),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_requires] = ACTIONS(2970),
    [sym_this] = ACTIONS(2970),
  },
  [685] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [686] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [687] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [688] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [689] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [690] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [691] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [692] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [693] = {
    [sym_identifier] = ACTIONS(2962),
    [aux_sym_preproc_include_token1] = ACTIONS(2962),
    [aux_sym_preproc_def_token1] = ACTIONS(2962),
    [aux_sym_preproc_if_token1] = ACTIONS(2962),
    [aux_sym_preproc_if_token2] = ACTIONS(2962),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2962),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2962),
    [sym_preproc_directive] = ACTIONS(2962),
    [anon_sym_LPAREN2] = ACTIONS(2964),
    [anon_sym_BANG] = ACTIONS(2964),
    [anon_sym_TILDE] = ACTIONS(2964),
    [anon_sym_DASH] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_STAR] = ACTIONS(2964),
    [anon_sym_AMP_AMP] = ACTIONS(2964),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_SEMI] = ACTIONS(2964),
    [anon_sym___extension__] = ACTIONS(2962),
    [anon_sym_typedef] = ACTIONS(2962),
    [anon_sym_extern] = ACTIONS(2962),
    [anon_sym___attribute__] = ACTIONS(2962),
    [anon_sym_COLON_COLON] = ACTIONS(2964),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2964),
    [anon_sym___declspec] = ACTIONS(2962),
    [anon_sym___based] = ACTIONS(2962),
    [anon_sym___cdecl] = ACTIONS(2962),
    [anon_sym___clrcall] = ACTIONS(2962),
    [anon_sym___stdcall] = ACTIONS(2962),
    [anon_sym___fastcall] = ACTIONS(2962),
    [anon_sym___thiscall] = ACTIONS(2962),
    [anon_sym___vectorcall] = ACTIONS(2962),
    [anon_sym_LBRACE] = ACTIONS(2964),
    [anon_sym_signed] = ACTIONS(2962),
    [anon_sym_unsigned] = ACTIONS(2962),
    [anon_sym_long] = ACTIONS(2962),
    [anon_sym_short] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_static] = ACTIONS(2962),
    [anon_sym_register] = ACTIONS(2962),
    [anon_sym_inline] = ACTIONS(2962),
    [anon_sym___inline] = ACTIONS(2962),
    [anon_sym___inline__] = ACTIONS(2962),
    [anon_sym___forceinline] = ACTIONS(2962),
    [anon_sym_thread_local] = ACTIONS(2962),
    [anon_sym___thread] = ACTIONS(2962),
    [anon_sym_const] = ACTIONS(2962),
    [anon_sym_constexpr] = ACTIONS(2962),
    [anon_sym_volatile] = ACTIONS(2962),
    [anon_sym_restrict] = ACTIONS(2962),
    [anon_sym___restrict__] = ACTIONS(2962),
    [anon_sym__Atomic] = ACTIONS(2962),
    [anon_sym__Noreturn] = ACTIONS(2962),
    [anon_sym_noreturn] = ACTIONS(2962),
    [anon_sym_mutable] = ACTIONS(2962),
    [anon_sym_constinit] = ACTIONS(2962),
    [anon_sym_consteval] = ACTIONS(2962),
    [anon_sym_PROGMEM] = ACTIONS(2962),
    [aux_sym_primitive_type_token1] = ACTIONS(2962),
    [anon_sym_byte] = ACTIONS(2962),
    [anon_sym_word] = ACTIONS(2962),
    [anon_sym_enum] = ACTIONS(2962),
    [anon_sym_class] = ACTIONS(2962),
    [anon_sym_struct] = ACTIONS(2962),
    [anon_sym_union] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_else] = ACTIONS(2962),
    [anon_sym_switch] = ACTIONS(2962),
    [anon_sym_case] = ACTIONS(2962),
    [anon_sym_default] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_for] = ACTIONS(2962),
    [anon_sym_return] = ACTIONS(2962),
    [anon_sym_break] = ACTIONS(2962),
    [anon_sym_continue] = ACTIONS(2962),
    [anon_sym_goto] = ACTIONS(2962),
    [anon_sym___try] = ACTIONS(2962),
    [anon_sym___leave] = ACTIONS(2962),
    [anon_sym_not] = ACTIONS(2962),
    [anon_sym_compl] = ACTIONS(2962),
    [anon_sym_DASH_DASH] = ACTIONS(2964),
    [anon_sym_PLUS_PLUS] = ACTIONS(2964),
    [anon_sym_sizeof] = ACTIONS(2962),
    [anon_sym___alignof__] = ACTIONS(2962),
    [anon_sym___alignof] = ACTIONS(2962),
    [anon_sym__alignof] = ACTIONS(2962),
    [anon_sym_alignof] = ACTIONS(2962),
    [anon_sym__Alignof] = ACTIONS(2962),
    [anon_sym_offsetof] = ACTIONS(2962),
    [anon_sym__Generic] = ACTIONS(2962),
    [anon_sym_asm] = ACTIONS(2962),
    [anon_sym___asm__] = ACTIONS(2962),
    [aux_sym_number_literal_token1] = ACTIONS(2964),
    [aux_sym_number_literal_token2] = ACTIONS(2962),
    [anon_sym_L_SQUOTE] = ACTIONS(2964),
    [anon_sym_u_SQUOTE] = ACTIONS(2964),
    [anon_sym_U_SQUOTE] = ACTIONS(2964),
    [anon_sym_u8_SQUOTE] = ACTIONS(2964),
    [anon_sym_SQUOTE] = ACTIONS(2964),
    [anon_sym_L_DQUOTE] = ACTIONS(2964),
    [anon_sym_u_DQUOTE] = ACTIONS(2964),
    [anon_sym_U_DQUOTE] = ACTIONS(2964),
    [anon_sym_u8_DQUOTE] = ACTIONS(2964),
    [anon_sym_DQUOTE] = ACTIONS(2964),
    [sym_true] = ACTIONS(2962),
    [sym_false] = ACTIONS(2962),
    [anon_sym_NULL] = ACTIONS(2962),
    [anon_sym_nullptr] = ACTIONS(2962),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2962),
    [anon_sym_decltype] = ACTIONS(2962),
    [anon_sym_virtual] = ACTIONS(2962),
    [anon_sym_alignas] = ACTIONS(2962),
    [anon_sym_explicit] = ACTIONS(2962),
    [anon_sym_typename] = ACTIONS(2962),
    [anon_sym_template] = ACTIONS(2962),
    [anon_sym_operator] = ACTIONS(2962),
    [anon_sym_try] = ACTIONS(2962),
    [anon_sym_delete] = ACTIONS(2962),
    [anon_sym_throw] = ACTIONS(2962),
    [anon_sym_namespace] = ACTIONS(2962),
    [anon_sym_using] = ACTIONS(2962),
    [anon_sym_static_assert] = ACTIONS(2962),
    [anon_sym_concept] = ACTIONS(2962),
    [anon_sym_co_return] = ACTIONS(2962),
    [anon_sym_co_yield] = ACTIONS(2962),
    [anon_sym_R_DQUOTE] = ACTIONS(2964),
    [anon_sym_LR_DQUOTE] = ACTIONS(2964),
    [anon_sym_uR_DQUOTE] = ACTIONS(2964),
    [anon_sym_UR_DQUOTE] = ACTIONS(2964),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2964),
    [anon_sym_co_await] = ACTIONS(2962),
    [anon_sym_new] = ACTIONS(2962),
    [anon_sym_requires] = ACTIONS(2962),
    [sym_this] = ACTIONS(2962),
  },
  [694] = {
    [sym_identifier] = ACTIONS(2954),
    [aux_sym_preproc_include_token1] = ACTIONS(2954),
    [aux_sym_preproc_def_token1] = ACTIONS(2954),
    [aux_sym_preproc_if_token1] = ACTIONS(2954),
    [aux_sym_preproc_if_token2] = ACTIONS(2954),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2954),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2954),
    [sym_preproc_directive] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2956),
    [anon_sym_BANG] = ACTIONS(2956),
    [anon_sym_TILDE] = ACTIONS(2956),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_STAR] = ACTIONS(2956),
    [anon_sym_AMP_AMP] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2954),
    [anon_sym_SEMI] = ACTIONS(2956),
    [anon_sym___extension__] = ACTIONS(2954),
    [anon_sym_typedef] = ACTIONS(2954),
    [anon_sym_extern] = ACTIONS(2954),
    [anon_sym___attribute__] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2956),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2956),
    [anon_sym___declspec] = ACTIONS(2954),
    [anon_sym___based] = ACTIONS(2954),
    [anon_sym___cdecl] = ACTIONS(2954),
    [anon_sym___clrcall] = ACTIONS(2954),
    [anon_sym___stdcall] = ACTIONS(2954),
    [anon_sym___fastcall] = ACTIONS(2954),
    [anon_sym___thiscall] = ACTIONS(2954),
    [anon_sym___vectorcall] = ACTIONS(2954),
    [anon_sym_LBRACE] = ACTIONS(2956),
    [anon_sym_signed] = ACTIONS(2954),
    [anon_sym_unsigned] = ACTIONS(2954),
    [anon_sym_long] = ACTIONS(2954),
    [anon_sym_short] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_static] = ACTIONS(2954),
    [anon_sym_register] = ACTIONS(2954),
    [anon_sym_inline] = ACTIONS(2954),
    [anon_sym___inline] = ACTIONS(2954),
    [anon_sym___inline__] = ACTIONS(2954),
    [anon_sym___forceinline] = ACTIONS(2954),
    [anon_sym_thread_local] = ACTIONS(2954),
    [anon_sym___thread] = ACTIONS(2954),
    [anon_sym_const] = ACTIONS(2954),
    [anon_sym_constexpr] = ACTIONS(2954),
    [anon_sym_volatile] = ACTIONS(2954),
    [anon_sym_restrict] = ACTIONS(2954),
    [anon_sym___restrict__] = ACTIONS(2954),
    [anon_sym__Atomic] = ACTIONS(2954),
    [anon_sym__Noreturn] = ACTIONS(2954),
    [anon_sym_noreturn] = ACTIONS(2954),
    [anon_sym_mutable] = ACTIONS(2954),
    [anon_sym_constinit] = ACTIONS(2954),
    [anon_sym_consteval] = ACTIONS(2954),
    [anon_sym_PROGMEM] = ACTIONS(2954),
    [aux_sym_primitive_type_token1] = ACTIONS(2954),
    [anon_sym_byte] = ACTIONS(2954),
    [anon_sym_word] = ACTIONS(2954),
    [anon_sym_enum] = ACTIONS(2954),
    [anon_sym_class] = ACTIONS(2954),
    [anon_sym_struct] = ACTIONS(2954),
    [anon_sym_union] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_else] = ACTIONS(2954),
    [anon_sym_switch] = ACTIONS(2954),
    [anon_sym_case] = ACTIONS(2954),
    [anon_sym_default] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_break] = ACTIONS(2954),
    [anon_sym_continue] = ACTIONS(2954),
    [anon_sym_goto] = ACTIONS(2954),
    [anon_sym___try] = ACTIONS(2954),
    [anon_sym___leave] = ACTIONS(2954),
    [anon_sym_not] = ACTIONS(2954),
    [anon_sym_compl] = ACTIONS(2954),
    [anon_sym_DASH_DASH] = ACTIONS(2956),
    [anon_sym_PLUS_PLUS] = ACTIONS(2956),
    [anon_sym_sizeof] = ACTIONS(2954),
    [anon_sym___alignof__] = ACTIONS(2954),
    [anon_sym___alignof] = ACTIONS(2954),
    [anon_sym__alignof] = ACTIONS(2954),
    [anon_sym_alignof] = ACTIONS(2954),
    [anon_sym__Alignof] = ACTIONS(2954),
    [anon_sym_offsetof] = ACTIONS(2954),
    [anon_sym__Generic] = ACTIONS(2954),
    [anon_sym_asm] = ACTIONS(2954),
    [anon_sym___asm__] = ACTIONS(2954),
    [aux_sym_number_literal_token1] = ACTIONS(2956),
    [aux_sym_number_literal_token2] = ACTIONS(2954),
    [anon_sym_L_SQUOTE] = ACTIONS(2956),
    [anon_sym_u_SQUOTE] = ACTIONS(2956),
    [anon_sym_U_SQUOTE] = ACTIONS(2956),
    [anon_sym_u8_SQUOTE] = ACTIONS(2956),
    [anon_sym_SQUOTE] = ACTIONS(2956),
    [anon_sym_L_DQUOTE] = ACTIONS(2956),
    [anon_sym_u_DQUOTE] = ACTIONS(2956),
    [anon_sym_U_DQUOTE] = ACTIONS(2956),
    [anon_sym_u8_DQUOTE] = ACTIONS(2956),
    [anon_sym_DQUOTE] = ACTIONS(2956),
    [sym_true] = ACTIONS(2954),
    [sym_false] = ACTIONS(2954),
    [anon_sym_NULL] = ACTIONS(2954),
    [anon_sym_nullptr] = ACTIONS(2954),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2954),
    [anon_sym_decltype] = ACTIONS(2954),
    [anon_sym_virtual] = ACTIONS(2954),
    [anon_sym_alignas] = ACTIONS(2954),
    [anon_sym_explicit] = ACTIONS(2954),
    [anon_sym_typename] = ACTIONS(2954),
    [anon_sym_template] = ACTIONS(2954),
    [anon_sym_operator] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_delete] = ACTIONS(2954),
    [anon_sym_throw] = ACTIONS(2954),
    [anon_sym_namespace] = ACTIONS(2954),
    [anon_sym_using] = ACTIONS(2954),
    [anon_sym_static_assert] = ACTIONS(2954),
    [anon_sym_concept] = ACTIONS(2954),
    [anon_sym_co_return] = ACTIONS(2954),
    [anon_sym_co_yield] = ACTIONS(2954),
    [anon_sym_R_DQUOTE] = ACTIONS(2956),
    [anon_sym_LR_DQUOTE] = ACTIONS(2956),
    [anon_sym_uR_DQUOTE] = ACTIONS(2956),
    [anon_sym_UR_DQUOTE] = ACTIONS(2956),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2956),
    [anon_sym_co_await] = ACTIONS(2954),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_requires] = ACTIONS(2954),
    [sym_this] = ACTIONS(2954),
  },
  [695] = {
    [sym_identifier] = ACTIONS(2950),
    [aux_sym_preproc_include_token1] = ACTIONS(2950),
    [aux_sym_preproc_def_token1] = ACTIONS(2950),
    [aux_sym_preproc_if_token1] = ACTIONS(2950),
    [aux_sym_preproc_if_token2] = ACTIONS(2950),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2950),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2950),
    [sym_preproc_directive] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2952),
    [anon_sym_BANG] = ACTIONS(2952),
    [anon_sym_TILDE] = ACTIONS(2952),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_STAR] = ACTIONS(2952),
    [anon_sym_AMP_AMP] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_SEMI] = ACTIONS(2952),
    [anon_sym___extension__] = ACTIONS(2950),
    [anon_sym_typedef] = ACTIONS(2950),
    [anon_sym_extern] = ACTIONS(2950),
    [anon_sym___attribute__] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2952),
    [anon_sym___declspec] = ACTIONS(2950),
    [anon_sym___based] = ACTIONS(2950),
    [anon_sym___cdecl] = ACTIONS(2950),
    [anon_sym___clrcall] = ACTIONS(2950),
    [anon_sym___stdcall] = ACTIONS(2950),
    [anon_sym___fastcall] = ACTIONS(2950),
    [anon_sym___thiscall] = ACTIONS(2950),
    [anon_sym___vectorcall] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2952),
    [anon_sym_signed] = ACTIONS(2950),
    [anon_sym_unsigned] = ACTIONS(2950),
    [anon_sym_long] = ACTIONS(2950),
    [anon_sym_short] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_static] = ACTIONS(2950),
    [anon_sym_register] = ACTIONS(2950),
    [anon_sym_inline] = ACTIONS(2950),
    [anon_sym___inline] = ACTIONS(2950),
    [anon_sym___inline__] = ACTIONS(2950),
    [anon_sym___forceinline] = ACTIONS(2950),
    [anon_sym_thread_local] = ACTIONS(2950),
    [anon_sym___thread] = ACTIONS(2950),
    [anon_sym_const] = ACTIONS(2950),
    [anon_sym_constexpr] = ACTIONS(2950),
    [anon_sym_volatile] = ACTIONS(2950),
    [anon_sym_restrict] = ACTIONS(2950),
    [anon_sym___restrict__] = ACTIONS(2950),
    [anon_sym__Atomic] = ACTIONS(2950),
    [anon_sym__Noreturn] = ACTIONS(2950),
    [anon_sym_noreturn] = ACTIONS(2950),
    [anon_sym_mutable] = ACTIONS(2950),
    [anon_sym_constinit] = ACTIONS(2950),
    [anon_sym_consteval] = ACTIONS(2950),
    [anon_sym_PROGMEM] = ACTIONS(2950),
    [aux_sym_primitive_type_token1] = ACTIONS(2950),
    [anon_sym_byte] = ACTIONS(2950),
    [anon_sym_word] = ACTIONS(2950),
    [anon_sym_enum] = ACTIONS(2950),
    [anon_sym_class] = ACTIONS(2950),
    [anon_sym_struct] = ACTIONS(2950),
    [anon_sym_union] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_else] = ACTIONS(2950),
    [anon_sym_switch] = ACTIONS(2950),
    [anon_sym_case] = ACTIONS(2950),
    [anon_sym_default] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_break] = ACTIONS(2950),
    [anon_sym_continue] = ACTIONS(2950),
    [anon_sym_goto] = ACTIONS(2950),
    [anon_sym___try] = ACTIONS(2950),
    [anon_sym___leave] = ACTIONS(2950),
    [anon_sym_not] = ACTIONS(2950),
    [anon_sym_compl] = ACTIONS(2950),
    [anon_sym_DASH_DASH] = ACTIONS(2952),
    [anon_sym_PLUS_PLUS] = ACTIONS(2952),
    [anon_sym_sizeof] = ACTIONS(2950),
    [anon_sym___alignof__] = ACTIONS(2950),
    [anon_sym___alignof] = ACTIONS(2950),
    [anon_sym__alignof] = ACTIONS(2950),
    [anon_sym_alignof] = ACTIONS(2950),
    [anon_sym__Alignof] = ACTIONS(2950),
    [anon_sym_offsetof] = ACTIONS(2950),
    [anon_sym__Generic] = ACTIONS(2950),
    [anon_sym_asm] = ACTIONS(2950),
    [anon_sym___asm__] = ACTIONS(2950),
    [aux_sym_number_literal_token1] = ACTIONS(2952),
    [aux_sym_number_literal_token2] = ACTIONS(2950),
    [anon_sym_L_SQUOTE] = ACTIONS(2952),
    [anon_sym_u_SQUOTE] = ACTIONS(2952),
    [anon_sym_U_SQUOTE] = ACTIONS(2952),
    [anon_sym_u8_SQUOTE] = ACTIONS(2952),
    [anon_sym_SQUOTE] = ACTIONS(2952),
    [anon_sym_L_DQUOTE] = ACTIONS(2952),
    [anon_sym_u_DQUOTE] = ACTIONS(2952),
    [anon_sym_U_DQUOTE] = ACTIONS(2952),
    [anon_sym_u8_DQUOTE] = ACTIONS(2952),
    [anon_sym_DQUOTE] = ACTIONS(2952),
    [sym_true] = ACTIONS(2950),
    [sym_false] = ACTIONS(2950),
    [anon_sym_NULL] = ACTIONS(2950),
    [anon_sym_nullptr] = ACTIONS(2950),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2950),
    [anon_sym_decltype] = ACTIONS(2950),
    [anon_sym_virtual] = ACTIONS(2950),
    [anon_sym_alignas] = ACTIONS(2950),
    [anon_sym_explicit] = ACTIONS(2950),
    [anon_sym_typename] = ACTIONS(2950),
    [anon_sym_template] = ACTIONS(2950),
    [anon_sym_operator] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_delete] = ACTIONS(2950),
    [anon_sym_throw] = ACTIONS(2950),
    [anon_sym_namespace] = ACTIONS(2950),
    [anon_sym_using] = ACTIONS(2950),
    [anon_sym_static_assert] = ACTIONS(2950),
    [anon_sym_concept] = ACTIONS(2950),
    [anon_sym_co_return] = ACTIONS(2950),
    [anon_sym_co_yield] = ACTIONS(2950),
    [anon_sym_R_DQUOTE] = ACTIONS(2952),
    [anon_sym_LR_DQUOTE] = ACTIONS(2952),
    [anon_sym_uR_DQUOTE] = ACTIONS(2952),
    [anon_sym_UR_DQUOTE] = ACTIONS(2952),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2952),
    [anon_sym_co_await] = ACTIONS(2950),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_requires] = ACTIONS(2950),
    [sym_this] = ACTIONS(2950),
  },
  [696] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [697] = {
    [ts_builtin_sym_end] = ACTIONS(3060),
    [sym_identifier] = ACTIONS(3058),
    [aux_sym_preproc_include_token1] = ACTIONS(3058),
    [aux_sym_preproc_def_token1] = ACTIONS(3058),
    [aux_sym_preproc_if_token1] = ACTIONS(3058),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3058),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3058),
    [sym_preproc_directive] = ACTIONS(3058),
    [anon_sym_LPAREN2] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3060),
    [anon_sym_TILDE] = ACTIONS(3060),
    [anon_sym_DASH] = ACTIONS(3058),
    [anon_sym_PLUS] = ACTIONS(3058),
    [anon_sym_STAR] = ACTIONS(3060),
    [anon_sym_AMP_AMP] = ACTIONS(3060),
    [anon_sym_AMP] = ACTIONS(3058),
    [anon_sym_SEMI] = ACTIONS(3060),
    [anon_sym___extension__] = ACTIONS(3058),
    [anon_sym_typedef] = ACTIONS(3058),
    [anon_sym_extern] = ACTIONS(3058),
    [anon_sym___attribute__] = ACTIONS(3058),
    [anon_sym_COLON_COLON] = ACTIONS(3060),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3060),
    [anon_sym___declspec] = ACTIONS(3058),
    [anon_sym___based] = ACTIONS(3058),
    [anon_sym___cdecl] = ACTIONS(3058),
    [anon_sym___clrcall] = ACTIONS(3058),
    [anon_sym___stdcall] = ACTIONS(3058),
    [anon_sym___fastcall] = ACTIONS(3058),
    [anon_sym___thiscall] = ACTIONS(3058),
    [anon_sym___vectorcall] = ACTIONS(3058),
    [anon_sym_LBRACE] = ACTIONS(3060),
    [anon_sym_signed] = ACTIONS(3058),
    [anon_sym_unsigned] = ACTIONS(3058),
    [anon_sym_long] = ACTIONS(3058),
    [anon_sym_short] = ACTIONS(3058),
    [anon_sym_LBRACK] = ACTIONS(3058),
    [anon_sym_static] = ACTIONS(3058),
    [anon_sym_register] = ACTIONS(3058),
    [anon_sym_inline] = ACTIONS(3058),
    [anon_sym___inline] = ACTIONS(3058),
    [anon_sym___inline__] = ACTIONS(3058),
    [anon_sym___forceinline] = ACTIONS(3058),
    [anon_sym_thread_local] = ACTIONS(3058),
    [anon_sym___thread] = ACTIONS(3058),
    [anon_sym_const] = ACTIONS(3058),
    [anon_sym_constexpr] = ACTIONS(3058),
    [anon_sym_volatile] = ACTIONS(3058),
    [anon_sym_restrict] = ACTIONS(3058),
    [anon_sym___restrict__] = ACTIONS(3058),
    [anon_sym__Atomic] = ACTIONS(3058),
    [anon_sym__Noreturn] = ACTIONS(3058),
    [anon_sym_noreturn] = ACTIONS(3058),
    [anon_sym_mutable] = ACTIONS(3058),
    [anon_sym_constinit] = ACTIONS(3058),
    [anon_sym_consteval] = ACTIONS(3058),
    [anon_sym_PROGMEM] = ACTIONS(3058),
    [aux_sym_primitive_type_token1] = ACTIONS(3058),
    [anon_sym_byte] = ACTIONS(3058),
    [anon_sym_word] = ACTIONS(3058),
    [anon_sym_enum] = ACTIONS(3058),
    [anon_sym_class] = ACTIONS(3058),
    [anon_sym_struct] = ACTIONS(3058),
    [anon_sym_union] = ACTIONS(3058),
    [anon_sym_if] = ACTIONS(3058),
    [anon_sym_else] = ACTIONS(3058),
    [anon_sym_switch] = ACTIONS(3058),
    [anon_sym_case] = ACTIONS(3058),
    [anon_sym_default] = ACTIONS(3058),
    [anon_sym_while] = ACTIONS(3058),
    [anon_sym_do] = ACTIONS(3058),
    [anon_sym_for] = ACTIONS(3058),
    [anon_sym_return] = ACTIONS(3058),
    [anon_sym_break] = ACTIONS(3058),
    [anon_sym_continue] = ACTIONS(3058),
    [anon_sym_goto] = ACTIONS(3058),
    [anon_sym___try] = ACTIONS(3058),
    [anon_sym___leave] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3058),
    [anon_sym_compl] = ACTIONS(3058),
    [anon_sym_DASH_DASH] = ACTIONS(3060),
    [anon_sym_PLUS_PLUS] = ACTIONS(3060),
    [anon_sym_sizeof] = ACTIONS(3058),
    [anon_sym___alignof__] = ACTIONS(3058),
    [anon_sym___alignof] = ACTIONS(3058),
    [anon_sym__alignof] = ACTIONS(3058),
    [anon_sym_alignof] = ACTIONS(3058),
    [anon_sym__Alignof] = ACTIONS(3058),
    [anon_sym_offsetof] = ACTIONS(3058),
    [anon_sym__Generic] = ACTIONS(3058),
    [anon_sym_asm] = ACTIONS(3058),
    [anon_sym___asm__] = ACTIONS(3058),
    [aux_sym_number_literal_token1] = ACTIONS(3060),
    [aux_sym_number_literal_token2] = ACTIONS(3058),
    [anon_sym_L_SQUOTE] = ACTIONS(3060),
    [anon_sym_u_SQUOTE] = ACTIONS(3060),
    [anon_sym_U_SQUOTE] = ACTIONS(3060),
    [anon_sym_u8_SQUOTE] = ACTIONS(3060),
    [anon_sym_SQUOTE] = ACTIONS(3060),
    [anon_sym_L_DQUOTE] = ACTIONS(3060),
    [anon_sym_u_DQUOTE] = ACTIONS(3060),
    [anon_sym_U_DQUOTE] = ACTIONS(3060),
    [anon_sym_u8_DQUOTE] = ACTIONS(3060),
    [anon_sym_DQUOTE] = ACTIONS(3060),
    [sym_true] = ACTIONS(3058),
    [sym_false] = ACTIONS(3058),
    [anon_sym_NULL] = ACTIONS(3058),
    [anon_sym_nullptr] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3058),
    [anon_sym_decltype] = ACTIONS(3058),
    [anon_sym_virtual] = ACTIONS(3058),
    [anon_sym_alignas] = ACTIONS(3058),
    [anon_sym_explicit] = ACTIONS(3058),
    [anon_sym_typename] = ACTIONS(3058),
    [anon_sym_template] = ACTIONS(3058),
    [anon_sym_operator] = ACTIONS(3058),
    [anon_sym_try] = ACTIONS(3058),
    [anon_sym_delete] = ACTIONS(3058),
    [anon_sym_throw] = ACTIONS(3058),
    [anon_sym_namespace] = ACTIONS(3058),
    [anon_sym_using] = ACTIONS(3058),
    [anon_sym_static_assert] = ACTIONS(3058),
    [anon_sym_concept] = ACTIONS(3058),
    [anon_sym_co_return] = ACTIONS(3058),
    [anon_sym_co_yield] = ACTIONS(3058),
    [anon_sym_R_DQUOTE] = ACTIONS(3060),
    [anon_sym_LR_DQUOTE] = ACTIONS(3060),
    [anon_sym_uR_DQUOTE] = ACTIONS(3060),
    [anon_sym_UR_DQUOTE] = ACTIONS(3060),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3060),
    [anon_sym_co_await] = ACTIONS(3058),
    [anon_sym_new] = ACTIONS(3058),
    [anon_sym_requires] = ACTIONS(3058),
    [sym_this] = ACTIONS(3058),
  },
  [698] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [699] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [700] = {
    [sym_identifier] = ACTIONS(3138),
    [aux_sym_preproc_include_token1] = ACTIONS(3138),
    [aux_sym_preproc_def_token1] = ACTIONS(3138),
    [aux_sym_preproc_if_token1] = ACTIONS(3138),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3138),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3138),
    [sym_preproc_directive] = ACTIONS(3138),
    [anon_sym_LPAREN2] = ACTIONS(3140),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [anon_sym_DASH] = ACTIONS(3138),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_STAR] = ACTIONS(3140),
    [anon_sym_AMP_AMP] = ACTIONS(3140),
    [anon_sym_AMP] = ACTIONS(3138),
    [anon_sym_SEMI] = ACTIONS(3140),
    [anon_sym___extension__] = ACTIONS(3138),
    [anon_sym_typedef] = ACTIONS(3138),
    [anon_sym_extern] = ACTIONS(3138),
    [anon_sym___attribute__] = ACTIONS(3138),
    [anon_sym_COLON_COLON] = ACTIONS(3140),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3140),
    [anon_sym___declspec] = ACTIONS(3138),
    [anon_sym___based] = ACTIONS(3138),
    [anon_sym___cdecl] = ACTIONS(3138),
    [anon_sym___clrcall] = ACTIONS(3138),
    [anon_sym___stdcall] = ACTIONS(3138),
    [anon_sym___fastcall] = ACTIONS(3138),
    [anon_sym___thiscall] = ACTIONS(3138),
    [anon_sym___vectorcall] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [anon_sym_RBRACE] = ACTIONS(3140),
    [anon_sym_signed] = ACTIONS(3138),
    [anon_sym_unsigned] = ACTIONS(3138),
    [anon_sym_long] = ACTIONS(3138),
    [anon_sym_short] = ACTIONS(3138),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_static] = ACTIONS(3138),
    [anon_sym_register] = ACTIONS(3138),
    [anon_sym_inline] = ACTIONS(3138),
    [anon_sym___inline] = ACTIONS(3138),
    [anon_sym___inline__] = ACTIONS(3138),
    [anon_sym___forceinline] = ACTIONS(3138),
    [anon_sym_thread_local] = ACTIONS(3138),
    [anon_sym___thread] = ACTIONS(3138),
    [anon_sym_const] = ACTIONS(3138),
    [anon_sym_constexpr] = ACTIONS(3138),
    [anon_sym_volatile] = ACTIONS(3138),
    [anon_sym_restrict] = ACTIONS(3138),
    [anon_sym___restrict__] = ACTIONS(3138),
    [anon_sym__Atomic] = ACTIONS(3138),
    [anon_sym__Noreturn] = ACTIONS(3138),
    [anon_sym_noreturn] = ACTIONS(3138),
    [anon_sym_mutable] = ACTIONS(3138),
    [anon_sym_constinit] = ACTIONS(3138),
    [anon_sym_consteval] = ACTIONS(3138),
    [anon_sym_PROGMEM] = ACTIONS(3138),
    [aux_sym_primitive_type_token1] = ACTIONS(3138),
    [anon_sym_byte] = ACTIONS(3138),
    [anon_sym_word] = ACTIONS(3138),
    [anon_sym_enum] = ACTIONS(3138),
    [anon_sym_class] = ACTIONS(3138),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3138),
    [anon_sym_if] = ACTIONS(3138),
    [anon_sym_else] = ACTIONS(3138),
    [anon_sym_switch] = ACTIONS(3138),
    [anon_sym_case] = ACTIONS(3138),
    [anon_sym_default] = ACTIONS(3138),
    [anon_sym_while] = ACTIONS(3138),
    [anon_sym_do] = ACTIONS(3138),
    [anon_sym_for] = ACTIONS(3138),
    [anon_sym_return] = ACTIONS(3138),
    [anon_sym_break] = ACTIONS(3138),
    [anon_sym_continue] = ACTIONS(3138),
    [anon_sym_goto] = ACTIONS(3138),
    [anon_sym___try] = ACTIONS(3138),
    [anon_sym___leave] = ACTIONS(3138),
    [anon_sym_not] = ACTIONS(3138),
    [anon_sym_compl] = ACTIONS(3138),
    [anon_sym_DASH_DASH] = ACTIONS(3140),
    [anon_sym_PLUS_PLUS] = ACTIONS(3140),
    [anon_sym_sizeof] = ACTIONS(3138),
    [anon_sym___alignof__] = ACTIONS(3138),
    [anon_sym___alignof] = ACTIONS(3138),
    [anon_sym__alignof] = ACTIONS(3138),
    [anon_sym_alignof] = ACTIONS(3138),
    [anon_sym__Alignof] = ACTIONS(3138),
    [anon_sym_offsetof] = ACTIONS(3138),
    [anon_sym__Generic] = ACTIONS(3138),
    [anon_sym_asm] = ACTIONS(3138),
    [anon_sym___asm__] = ACTIONS(3138),
    [aux_sym_number_literal_token1] = ACTIONS(3140),
    [aux_sym_number_literal_token2] = ACTIONS(3138),
    [anon_sym_L_SQUOTE] = ACTIONS(3140),
    [anon_sym_u_SQUOTE] = ACTIONS(3140),
    [anon_sym_U_SQUOTE] = ACTIONS(3140),
    [anon_sym_u8_SQUOTE] = ACTIONS(3140),
    [anon_sym_SQUOTE] = ACTIONS(3140),
    [anon_sym_L_DQUOTE] = ACTIONS(3140),
    [anon_sym_u_DQUOTE] = ACTIONS(3140),
    [anon_sym_U_DQUOTE] = ACTIONS(3140),
    [anon_sym_u8_DQUOTE] = ACTIONS(3140),
    [anon_sym_DQUOTE] = ACTIONS(3140),
    [sym_true] = ACTIONS(3138),
    [sym_false] = ACTIONS(3138),
    [anon_sym_NULL] = ACTIONS(3138),
    [anon_sym_nullptr] = ACTIONS(3138),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3138),
    [anon_sym_decltype] = ACTIONS(3138),
    [anon_sym_virtual] = ACTIONS(3138),
    [anon_sym_alignas] = ACTIONS(3138),
    [anon_sym_explicit] = ACTIONS(3138),
    [anon_sym_typename] = ACTIONS(3138),
    [anon_sym_template] = ACTIONS(3138),
    [anon_sym_operator] = ACTIONS(3138),
    [anon_sym_try] = ACTIONS(3138),
    [anon_sym_delete] = ACTIONS(3138),
    [anon_sym_throw] = ACTIONS(3138),
    [anon_sym_namespace] = ACTIONS(3138),
    [anon_sym_using] = ACTIONS(3138),
    [anon_sym_static_assert] = ACTIONS(3138),
    [anon_sym_concept] = ACTIONS(3138),
    [anon_sym_co_return] = ACTIONS(3138),
    [anon_sym_co_yield] = ACTIONS(3138),
    [anon_sym_R_DQUOTE] = ACTIONS(3140),
    [anon_sym_LR_DQUOTE] = ACTIONS(3140),
    [anon_sym_uR_DQUOTE] = ACTIONS(3140),
    [anon_sym_UR_DQUOTE] = ACTIONS(3140),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3140),
    [anon_sym_co_await] = ACTIONS(3138),
    [anon_sym_new] = ACTIONS(3138),
    [anon_sym_requires] = ACTIONS(3138),
    [sym_this] = ACTIONS(3138),
  },
  [701] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [702] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [703] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [704] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [705] = {
    [sym_identifier] = ACTIONS(3096),
    [aux_sym_preproc_include_token1] = ACTIONS(3096),
    [aux_sym_preproc_def_token1] = ACTIONS(3096),
    [aux_sym_preproc_if_token1] = ACTIONS(3096),
    [aux_sym_preproc_if_token2] = ACTIONS(3096),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3096),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3096),
    [sym_preproc_directive] = ACTIONS(3096),
    [anon_sym_LPAREN2] = ACTIONS(3098),
    [anon_sym_BANG] = ACTIONS(3098),
    [anon_sym_TILDE] = ACTIONS(3098),
    [anon_sym_DASH] = ACTIONS(3096),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_STAR] = ACTIONS(3098),
    [anon_sym_AMP_AMP] = ACTIONS(3098),
    [anon_sym_AMP] = ACTIONS(3096),
    [anon_sym_SEMI] = ACTIONS(3098),
    [anon_sym___extension__] = ACTIONS(3096),
    [anon_sym_typedef] = ACTIONS(3096),
    [anon_sym_extern] = ACTIONS(3096),
    [anon_sym___attribute__] = ACTIONS(3096),
    [anon_sym_COLON_COLON] = ACTIONS(3098),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3098),
    [anon_sym___declspec] = ACTIONS(3096),
    [anon_sym___based] = ACTIONS(3096),
    [anon_sym___cdecl] = ACTIONS(3096),
    [anon_sym___clrcall] = ACTIONS(3096),
    [anon_sym___stdcall] = ACTIONS(3096),
    [anon_sym___fastcall] = ACTIONS(3096),
    [anon_sym___thiscall] = ACTIONS(3096),
    [anon_sym___vectorcall] = ACTIONS(3096),
    [anon_sym_LBRACE] = ACTIONS(3098),
    [anon_sym_signed] = ACTIONS(3096),
    [anon_sym_unsigned] = ACTIONS(3096),
    [anon_sym_long] = ACTIONS(3096),
    [anon_sym_short] = ACTIONS(3096),
    [anon_sym_LBRACK] = ACTIONS(3096),
    [anon_sym_static] = ACTIONS(3096),
    [anon_sym_register] = ACTIONS(3096),
    [anon_sym_inline] = ACTIONS(3096),
    [anon_sym___inline] = ACTIONS(3096),
    [anon_sym___inline__] = ACTIONS(3096),
    [anon_sym___forceinline] = ACTIONS(3096),
    [anon_sym_thread_local] = ACTIONS(3096),
    [anon_sym___thread] = ACTIONS(3096),
    [anon_sym_const] = ACTIONS(3096),
    [anon_sym_constexpr] = ACTIONS(3096),
    [anon_sym_volatile] = ACTIONS(3096),
    [anon_sym_restrict] = ACTIONS(3096),
    [anon_sym___restrict__] = ACTIONS(3096),
    [anon_sym__Atomic] = ACTIONS(3096),
    [anon_sym__Noreturn] = ACTIONS(3096),
    [anon_sym_noreturn] = ACTIONS(3096),
    [anon_sym_mutable] = ACTIONS(3096),
    [anon_sym_constinit] = ACTIONS(3096),
    [anon_sym_consteval] = ACTIONS(3096),
    [anon_sym_PROGMEM] = ACTIONS(3096),
    [aux_sym_primitive_type_token1] = ACTIONS(3096),
    [anon_sym_byte] = ACTIONS(3096),
    [anon_sym_word] = ACTIONS(3096),
    [anon_sym_enum] = ACTIONS(3096),
    [anon_sym_class] = ACTIONS(3096),
    [anon_sym_struct] = ACTIONS(3096),
    [anon_sym_union] = ACTIONS(3096),
    [anon_sym_if] = ACTIONS(3096),
    [anon_sym_else] = ACTIONS(3096),
    [anon_sym_switch] = ACTIONS(3096),
    [anon_sym_case] = ACTIONS(3096),
    [anon_sym_default] = ACTIONS(3096),
    [anon_sym_while] = ACTIONS(3096),
    [anon_sym_do] = ACTIONS(3096),
    [anon_sym_for] = ACTIONS(3096),
    [anon_sym_return] = ACTIONS(3096),
    [anon_sym_break] = ACTIONS(3096),
    [anon_sym_continue] = ACTIONS(3096),
    [anon_sym_goto] = ACTIONS(3096),
    [anon_sym___try] = ACTIONS(3096),
    [anon_sym___leave] = ACTIONS(3096),
    [anon_sym_not] = ACTIONS(3096),
    [anon_sym_compl] = ACTIONS(3096),
    [anon_sym_DASH_DASH] = ACTIONS(3098),
    [anon_sym_PLUS_PLUS] = ACTIONS(3098),
    [anon_sym_sizeof] = ACTIONS(3096),
    [anon_sym___alignof__] = ACTIONS(3096),
    [anon_sym___alignof] = ACTIONS(3096),
    [anon_sym__alignof] = ACTIONS(3096),
    [anon_sym_alignof] = ACTIONS(3096),
    [anon_sym__Alignof] = ACTIONS(3096),
    [anon_sym_offsetof] = ACTIONS(3096),
    [anon_sym__Generic] = ACTIONS(3096),
    [anon_sym_asm] = ACTIONS(3096),
    [anon_sym___asm__] = ACTIONS(3096),
    [aux_sym_number_literal_token1] = ACTIONS(3098),
    [aux_sym_number_literal_token2] = ACTIONS(3096),
    [anon_sym_L_SQUOTE] = ACTIONS(3098),
    [anon_sym_u_SQUOTE] = ACTIONS(3098),
    [anon_sym_U_SQUOTE] = ACTIONS(3098),
    [anon_sym_u8_SQUOTE] = ACTIONS(3098),
    [anon_sym_SQUOTE] = ACTIONS(3098),
    [anon_sym_L_DQUOTE] = ACTIONS(3098),
    [anon_sym_u_DQUOTE] = ACTIONS(3098),
    [anon_sym_U_DQUOTE] = ACTIONS(3098),
    [anon_sym_u8_DQUOTE] = ACTIONS(3098),
    [anon_sym_DQUOTE] = ACTIONS(3098),
    [sym_true] = ACTIONS(3096),
    [sym_false] = ACTIONS(3096),
    [anon_sym_NULL] = ACTIONS(3096),
    [anon_sym_nullptr] = ACTIONS(3096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3096),
    [anon_sym_decltype] = ACTIONS(3096),
    [anon_sym_virtual] = ACTIONS(3096),
    [anon_sym_alignas] = ACTIONS(3096),
    [anon_sym_explicit] = ACTIONS(3096),
    [anon_sym_typename] = ACTIONS(3096),
    [anon_sym_template] = ACTIONS(3096),
    [anon_sym_operator] = ACTIONS(3096),
    [anon_sym_try] = ACTIONS(3096),
    [anon_sym_delete] = ACTIONS(3096),
    [anon_sym_throw] = ACTIONS(3096),
    [anon_sym_namespace] = ACTIONS(3096),
    [anon_sym_using] = ACTIONS(3096),
    [anon_sym_static_assert] = ACTIONS(3096),
    [anon_sym_concept] = ACTIONS(3096),
    [anon_sym_co_return] = ACTIONS(3096),
    [anon_sym_co_yield] = ACTIONS(3096),
    [anon_sym_R_DQUOTE] = ACTIONS(3098),
    [anon_sym_LR_DQUOTE] = ACTIONS(3098),
    [anon_sym_uR_DQUOTE] = ACTIONS(3098),
    [anon_sym_UR_DQUOTE] = ACTIONS(3098),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3098),
    [anon_sym_co_await] = ACTIONS(3096),
    [anon_sym_new] = ACTIONS(3096),
    [anon_sym_requires] = ACTIONS(3096),
    [sym_this] = ACTIONS(3096),
  },
  [706] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [707] = {
    [ts_builtin_sym_end] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [708] = {
    [ts_builtin_sym_end] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [709] = {
    [ts_builtin_sym_end] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [710] = {
    [ts_builtin_sym_end] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [711] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [712] = {
    [ts_builtin_sym_end] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [713] = {
    [ts_builtin_sym_end] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [714] = {
    [ts_builtin_sym_end] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [715] = {
    [ts_builtin_sym_end] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [716] = {
    [ts_builtin_sym_end] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [717] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [718] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [719] = {
    [ts_builtin_sym_end] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [720] = {
    [ts_builtin_sym_end] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [721] = {
    [ts_builtin_sym_end] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [722] = {
    [ts_builtin_sym_end] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [723] = {
    [ts_builtin_sym_end] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [724] = {
    [ts_builtin_sym_end] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [725] = {
    [ts_builtin_sym_end] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [726] = {
    [ts_builtin_sym_end] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [727] = {
    [ts_builtin_sym_end] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [728] = {
    [ts_builtin_sym_end] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [729] = {
    [ts_builtin_sym_end] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [730] = {
    [ts_builtin_sym_end] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [731] = {
    [ts_builtin_sym_end] = ACTIONS(2948),
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [732] = {
    [ts_builtin_sym_end] = ACTIONS(2968),
    [sym_identifier] = ACTIONS(2966),
    [aux_sym_preproc_include_token1] = ACTIONS(2966),
    [aux_sym_preproc_def_token1] = ACTIONS(2966),
    [aux_sym_preproc_if_token1] = ACTIONS(2966),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2966),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2966),
    [sym_preproc_directive] = ACTIONS(2966),
    [anon_sym_LPAREN2] = ACTIONS(2968),
    [anon_sym_BANG] = ACTIONS(2968),
    [anon_sym_TILDE] = ACTIONS(2968),
    [anon_sym_DASH] = ACTIONS(2966),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_STAR] = ACTIONS(2968),
    [anon_sym_AMP_AMP] = ACTIONS(2968),
    [anon_sym_AMP] = ACTIONS(2966),
    [anon_sym_SEMI] = ACTIONS(2968),
    [anon_sym___extension__] = ACTIONS(2966),
    [anon_sym_typedef] = ACTIONS(2966),
    [anon_sym_extern] = ACTIONS(2966),
    [anon_sym___attribute__] = ACTIONS(2966),
    [anon_sym_COLON_COLON] = ACTIONS(2968),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2968),
    [anon_sym___declspec] = ACTIONS(2966),
    [anon_sym___based] = ACTIONS(2966),
    [anon_sym___cdecl] = ACTIONS(2966),
    [anon_sym___clrcall] = ACTIONS(2966),
    [anon_sym___stdcall] = ACTIONS(2966),
    [anon_sym___fastcall] = ACTIONS(2966),
    [anon_sym___thiscall] = ACTIONS(2966),
    [anon_sym___vectorcall] = ACTIONS(2966),
    [anon_sym_LBRACE] = ACTIONS(2968),
    [anon_sym_signed] = ACTIONS(2966),
    [anon_sym_unsigned] = ACTIONS(2966),
    [anon_sym_long] = ACTIONS(2966),
    [anon_sym_short] = ACTIONS(2966),
    [anon_sym_LBRACK] = ACTIONS(2966),
    [anon_sym_static] = ACTIONS(2966),
    [anon_sym_register] = ACTIONS(2966),
    [anon_sym_inline] = ACTIONS(2966),
    [anon_sym___inline] = ACTIONS(2966),
    [anon_sym___inline__] = ACTIONS(2966),
    [anon_sym___forceinline] = ACTIONS(2966),
    [anon_sym_thread_local] = ACTIONS(2966),
    [anon_sym___thread] = ACTIONS(2966),
    [anon_sym_const] = ACTIONS(2966),
    [anon_sym_constexpr] = ACTIONS(2966),
    [anon_sym_volatile] = ACTIONS(2966),
    [anon_sym_restrict] = ACTIONS(2966),
    [anon_sym___restrict__] = ACTIONS(2966),
    [anon_sym__Atomic] = ACTIONS(2966),
    [anon_sym__Noreturn] = ACTIONS(2966),
    [anon_sym_noreturn] = ACTIONS(2966),
    [anon_sym_mutable] = ACTIONS(2966),
    [anon_sym_constinit] = ACTIONS(2966),
    [anon_sym_consteval] = ACTIONS(2966),
    [anon_sym_PROGMEM] = ACTIONS(2966),
    [aux_sym_primitive_type_token1] = ACTIONS(2966),
    [anon_sym_byte] = ACTIONS(2966),
    [anon_sym_word] = ACTIONS(2966),
    [anon_sym_enum] = ACTIONS(2966),
    [anon_sym_class] = ACTIONS(2966),
    [anon_sym_struct] = ACTIONS(2966),
    [anon_sym_union] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_else] = ACTIONS(2966),
    [anon_sym_switch] = ACTIONS(2966),
    [anon_sym_case] = ACTIONS(2966),
    [anon_sym_default] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_for] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2966),
    [anon_sym_break] = ACTIONS(2966),
    [anon_sym_continue] = ACTIONS(2966),
    [anon_sym_goto] = ACTIONS(2966),
    [anon_sym___try] = ACTIONS(2966),
    [anon_sym___leave] = ACTIONS(2966),
    [anon_sym_not] = ACTIONS(2966),
    [anon_sym_compl] = ACTIONS(2966),
    [anon_sym_DASH_DASH] = ACTIONS(2968),
    [anon_sym_PLUS_PLUS] = ACTIONS(2968),
    [anon_sym_sizeof] = ACTIONS(2966),
    [anon_sym___alignof__] = ACTIONS(2966),
    [anon_sym___alignof] = ACTIONS(2966),
    [anon_sym__alignof] = ACTIONS(2966),
    [anon_sym_alignof] = ACTIONS(2966),
    [anon_sym__Alignof] = ACTIONS(2966),
    [anon_sym_offsetof] = ACTIONS(2966),
    [anon_sym__Generic] = ACTIONS(2966),
    [anon_sym_asm] = ACTIONS(2966),
    [anon_sym___asm__] = ACTIONS(2966),
    [aux_sym_number_literal_token1] = ACTIONS(2968),
    [aux_sym_number_literal_token2] = ACTIONS(2966),
    [anon_sym_L_SQUOTE] = ACTIONS(2968),
    [anon_sym_u_SQUOTE] = ACTIONS(2968),
    [anon_sym_U_SQUOTE] = ACTIONS(2968),
    [anon_sym_u8_SQUOTE] = ACTIONS(2968),
    [anon_sym_SQUOTE] = ACTIONS(2968),
    [anon_sym_L_DQUOTE] = ACTIONS(2968),
    [anon_sym_u_DQUOTE] = ACTIONS(2968),
    [anon_sym_U_DQUOTE] = ACTIONS(2968),
    [anon_sym_u8_DQUOTE] = ACTIONS(2968),
    [anon_sym_DQUOTE] = ACTIONS(2968),
    [sym_true] = ACTIONS(2966),
    [sym_false] = ACTIONS(2966),
    [anon_sym_NULL] = ACTIONS(2966),
    [anon_sym_nullptr] = ACTIONS(2966),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2966),
    [anon_sym_decltype] = ACTIONS(2966),
    [anon_sym_virtual] = ACTIONS(2966),
    [anon_sym_alignas] = ACTIONS(2966),
    [anon_sym_explicit] = ACTIONS(2966),
    [anon_sym_typename] = ACTIONS(2966),
    [anon_sym_template] = ACTIONS(2966),
    [anon_sym_operator] = ACTIONS(2966),
    [anon_sym_try] = ACTIONS(2966),
    [anon_sym_delete] = ACTIONS(2966),
    [anon_sym_throw] = ACTIONS(2966),
    [anon_sym_namespace] = ACTIONS(2966),
    [anon_sym_using] = ACTIONS(2966),
    [anon_sym_static_assert] = ACTIONS(2966),
    [anon_sym_concept] = ACTIONS(2966),
    [anon_sym_co_return] = ACTIONS(2966),
    [anon_sym_co_yield] = ACTIONS(2966),
    [anon_sym_R_DQUOTE] = ACTIONS(2968),
    [anon_sym_LR_DQUOTE] = ACTIONS(2968),
    [anon_sym_uR_DQUOTE] = ACTIONS(2968),
    [anon_sym_UR_DQUOTE] = ACTIONS(2968),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2968),
    [anon_sym_co_await] = ACTIONS(2966),
    [anon_sym_new] = ACTIONS(2966),
    [anon_sym_requires] = ACTIONS(2966),
    [sym_this] = ACTIONS(2966),
  },
  [733] = {
    [ts_builtin_sym_end] = ACTIONS(2948),
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [734] = {
    [ts_builtin_sym_end] = ACTIONS(2948),
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [735] = {
    [ts_builtin_sym_end] = ACTIONS(2948),
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [736] = {
    [ts_builtin_sym_end] = ACTIONS(2948),
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [737] = {
    [ts_builtin_sym_end] = ACTIONS(2948),
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [738] = {
    [ts_builtin_sym_end] = ACTIONS(2948),
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [739] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [740] = {
    [ts_builtin_sym_end] = ACTIONS(2948),
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [741] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [742] = {
    [ts_builtin_sym_end] = ACTIONS(2948),
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [743] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [744] = {
    [ts_builtin_sym_end] = ACTIONS(2948),
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [745] = {
    [ts_builtin_sym_end] = ACTIONS(2948),
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [746] = {
    [ts_builtin_sym_end] = ACTIONS(2948),
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [747] = {
    [ts_builtin_sym_end] = ACTIONS(2948),
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [748] = {
    [ts_builtin_sym_end] = ACTIONS(3152),
    [sym_identifier] = ACTIONS(3150),
    [aux_sym_preproc_include_token1] = ACTIONS(3150),
    [aux_sym_preproc_def_token1] = ACTIONS(3150),
    [aux_sym_preproc_if_token1] = ACTIONS(3150),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3150),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3150),
    [sym_preproc_directive] = ACTIONS(3150),
    [anon_sym_LPAREN2] = ACTIONS(3152),
    [anon_sym_BANG] = ACTIONS(3152),
    [anon_sym_TILDE] = ACTIONS(3152),
    [anon_sym_DASH] = ACTIONS(3150),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_STAR] = ACTIONS(3152),
    [anon_sym_AMP_AMP] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(3152),
    [anon_sym___extension__] = ACTIONS(3150),
    [anon_sym_typedef] = ACTIONS(3150),
    [anon_sym_extern] = ACTIONS(3150),
    [anon_sym___attribute__] = ACTIONS(3150),
    [anon_sym_COLON_COLON] = ACTIONS(3152),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3152),
    [anon_sym___declspec] = ACTIONS(3150),
    [anon_sym___based] = ACTIONS(3150),
    [anon_sym___cdecl] = ACTIONS(3150),
    [anon_sym___clrcall] = ACTIONS(3150),
    [anon_sym___stdcall] = ACTIONS(3150),
    [anon_sym___fastcall] = ACTIONS(3150),
    [anon_sym___thiscall] = ACTIONS(3150),
    [anon_sym___vectorcall] = ACTIONS(3150),
    [anon_sym_LBRACE] = ACTIONS(3152),
    [anon_sym_signed] = ACTIONS(3150),
    [anon_sym_unsigned] = ACTIONS(3150),
    [anon_sym_long] = ACTIONS(3150),
    [anon_sym_short] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3150),
    [anon_sym_static] = ACTIONS(3150),
    [anon_sym_register] = ACTIONS(3150),
    [anon_sym_inline] = ACTIONS(3150),
    [anon_sym___inline] = ACTIONS(3150),
    [anon_sym___inline__] = ACTIONS(3150),
    [anon_sym___forceinline] = ACTIONS(3150),
    [anon_sym_thread_local] = ACTIONS(3150),
    [anon_sym___thread] = ACTIONS(3150),
    [anon_sym_const] = ACTIONS(3150),
    [anon_sym_constexpr] = ACTIONS(3150),
    [anon_sym_volatile] = ACTIONS(3150),
    [anon_sym_restrict] = ACTIONS(3150),
    [anon_sym___restrict__] = ACTIONS(3150),
    [anon_sym__Atomic] = ACTIONS(3150),
    [anon_sym__Noreturn] = ACTIONS(3150),
    [anon_sym_noreturn] = ACTIONS(3150),
    [anon_sym_mutable] = ACTIONS(3150),
    [anon_sym_constinit] = ACTIONS(3150),
    [anon_sym_consteval] = ACTIONS(3150),
    [anon_sym_PROGMEM] = ACTIONS(3150),
    [aux_sym_primitive_type_token1] = ACTIONS(3150),
    [anon_sym_byte] = ACTIONS(3150),
    [anon_sym_word] = ACTIONS(3150),
    [anon_sym_enum] = ACTIONS(3150),
    [anon_sym_class] = ACTIONS(3150),
    [anon_sym_struct] = ACTIONS(3150),
    [anon_sym_union] = ACTIONS(3150),
    [anon_sym_if] = ACTIONS(3150),
    [anon_sym_else] = ACTIONS(3150),
    [anon_sym_switch] = ACTIONS(3150),
    [anon_sym_case] = ACTIONS(3150),
    [anon_sym_default] = ACTIONS(3150),
    [anon_sym_while] = ACTIONS(3150),
    [anon_sym_do] = ACTIONS(3150),
    [anon_sym_for] = ACTIONS(3150),
    [anon_sym_return] = ACTIONS(3150),
    [anon_sym_break] = ACTIONS(3150),
    [anon_sym_continue] = ACTIONS(3150),
    [anon_sym_goto] = ACTIONS(3150),
    [anon_sym___try] = ACTIONS(3150),
    [anon_sym___leave] = ACTIONS(3150),
    [anon_sym_not] = ACTIONS(3150),
    [anon_sym_compl] = ACTIONS(3150),
    [anon_sym_DASH_DASH] = ACTIONS(3152),
    [anon_sym_PLUS_PLUS] = ACTIONS(3152),
    [anon_sym_sizeof] = ACTIONS(3150),
    [anon_sym___alignof__] = ACTIONS(3150),
    [anon_sym___alignof] = ACTIONS(3150),
    [anon_sym__alignof] = ACTIONS(3150),
    [anon_sym_alignof] = ACTIONS(3150),
    [anon_sym__Alignof] = ACTIONS(3150),
    [anon_sym_offsetof] = ACTIONS(3150),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3150),
    [anon_sym___asm__] = ACTIONS(3150),
    [aux_sym_number_literal_token1] = ACTIONS(3152),
    [aux_sym_number_literal_token2] = ACTIONS(3150),
    [anon_sym_L_SQUOTE] = ACTIONS(3152),
    [anon_sym_u_SQUOTE] = ACTIONS(3152),
    [anon_sym_U_SQUOTE] = ACTIONS(3152),
    [anon_sym_u8_SQUOTE] = ACTIONS(3152),
    [anon_sym_SQUOTE] = ACTIONS(3152),
    [anon_sym_L_DQUOTE] = ACTIONS(3152),
    [anon_sym_u_DQUOTE] = ACTIONS(3152),
    [anon_sym_U_DQUOTE] = ACTIONS(3152),
    [anon_sym_u8_DQUOTE] = ACTIONS(3152),
    [anon_sym_DQUOTE] = ACTIONS(3152),
    [sym_true] = ACTIONS(3150),
    [sym_false] = ACTIONS(3150),
    [anon_sym_NULL] = ACTIONS(3150),
    [anon_sym_nullptr] = ACTIONS(3150),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3150),
    [anon_sym_decltype] = ACTIONS(3150),
    [anon_sym_virtual] = ACTIONS(3150),
    [anon_sym_alignas] = ACTIONS(3150),
    [anon_sym_explicit] = ACTIONS(3150),
    [anon_sym_typename] = ACTIONS(3150),
    [anon_sym_template] = ACTIONS(3150),
    [anon_sym_operator] = ACTIONS(3150),
    [anon_sym_try] = ACTIONS(3150),
    [anon_sym_delete] = ACTIONS(3150),
    [anon_sym_throw] = ACTIONS(3150),
    [anon_sym_namespace] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_static_assert] = ACTIONS(3150),
    [anon_sym_concept] = ACTIONS(3150),
    [anon_sym_co_return] = ACTIONS(3150),
    [anon_sym_co_yield] = ACTIONS(3150),
    [anon_sym_R_DQUOTE] = ACTIONS(3152),
    [anon_sym_LR_DQUOTE] = ACTIONS(3152),
    [anon_sym_uR_DQUOTE] = ACTIONS(3152),
    [anon_sym_UR_DQUOTE] = ACTIONS(3152),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3152),
    [anon_sym_co_await] = ACTIONS(3150),
    [anon_sym_new] = ACTIONS(3150),
    [anon_sym_requires] = ACTIONS(3150),
    [sym_this] = ACTIONS(3150),
  },
  [749] = {
    [ts_builtin_sym_end] = ACTIONS(2948),
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [750] = {
    [ts_builtin_sym_end] = ACTIONS(2948),
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [751] = {
    [ts_builtin_sym_end] = ACTIONS(2948),
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [752] = {
    [ts_builtin_sym_end] = ACTIONS(2948),
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [753] = {
    [ts_builtin_sym_end] = ACTIONS(2948),
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [754] = {
    [ts_builtin_sym_end] = ACTIONS(2948),
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [755] = {
    [ts_builtin_sym_end] = ACTIONS(2948),
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [756] = {
    [ts_builtin_sym_end] = ACTIONS(2932),
    [sym_identifier] = ACTIONS(2927),
    [aux_sym_preproc_include_token1] = ACTIONS(2927),
    [aux_sym_preproc_def_token1] = ACTIONS(2927),
    [aux_sym_preproc_if_token1] = ACTIONS(2927),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2927),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2927),
    [sym_preproc_directive] = ACTIONS(2927),
    [anon_sym_LPAREN2] = ACTIONS(2932),
    [anon_sym_BANG] = ACTIONS(2932),
    [anon_sym_TILDE] = ACTIONS(2932),
    [anon_sym_DASH] = ACTIONS(2927),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2932),
    [anon_sym_AMP_AMP] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2927),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym___extension__] = ACTIONS(2927),
    [anon_sym_typedef] = ACTIONS(2927),
    [anon_sym_extern] = ACTIONS(2927),
    [anon_sym___attribute__] = ACTIONS(2927),
    [anon_sym_COLON_COLON] = ACTIONS(2932),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2932),
    [anon_sym___declspec] = ACTIONS(2927),
    [anon_sym___based] = ACTIONS(2927),
    [anon_sym___cdecl] = ACTIONS(2927),
    [anon_sym___clrcall] = ACTIONS(2927),
    [anon_sym___stdcall] = ACTIONS(2927),
    [anon_sym___fastcall] = ACTIONS(2927),
    [anon_sym___thiscall] = ACTIONS(2927),
    [anon_sym___vectorcall] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2932),
    [anon_sym_signed] = ACTIONS(2927),
    [anon_sym_unsigned] = ACTIONS(2927),
    [anon_sym_long] = ACTIONS(2927),
    [anon_sym_short] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_static] = ACTIONS(2927),
    [anon_sym_register] = ACTIONS(2927),
    [anon_sym_inline] = ACTIONS(2927),
    [anon_sym___inline] = ACTIONS(2927),
    [anon_sym___inline__] = ACTIONS(2927),
    [anon_sym___forceinline] = ACTIONS(2927),
    [anon_sym_thread_local] = ACTIONS(2927),
    [anon_sym___thread] = ACTIONS(2927),
    [anon_sym_const] = ACTIONS(2927),
    [anon_sym_constexpr] = ACTIONS(2927),
    [anon_sym_volatile] = ACTIONS(2927),
    [anon_sym_restrict] = ACTIONS(2927),
    [anon_sym___restrict__] = ACTIONS(2927),
    [anon_sym__Atomic] = ACTIONS(2927),
    [anon_sym__Noreturn] = ACTIONS(2927),
    [anon_sym_noreturn] = ACTIONS(2927),
    [anon_sym_mutable] = ACTIONS(2927),
    [anon_sym_constinit] = ACTIONS(2927),
    [anon_sym_consteval] = ACTIONS(2927),
    [anon_sym_PROGMEM] = ACTIONS(2927),
    [aux_sym_primitive_type_token1] = ACTIONS(2927),
    [anon_sym_byte] = ACTIONS(2927),
    [anon_sym_word] = ACTIONS(2927),
    [anon_sym_enum] = ACTIONS(2927),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_struct] = ACTIONS(2927),
    [anon_sym_union] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_else] = ACTIONS(2927),
    [anon_sym_switch] = ACTIONS(2927),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_default] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_goto] = ACTIONS(2927),
    [anon_sym___try] = ACTIONS(2927),
    [anon_sym___leave] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2927),
    [anon_sym_compl] = ACTIONS(2927),
    [anon_sym_DASH_DASH] = ACTIONS(2932),
    [anon_sym_PLUS_PLUS] = ACTIONS(2932),
    [anon_sym_sizeof] = ACTIONS(2927),
    [anon_sym___alignof__] = ACTIONS(2927),
    [anon_sym___alignof] = ACTIONS(2927),
    [anon_sym__alignof] = ACTIONS(2927),
    [anon_sym_alignof] = ACTIONS(2927),
    [anon_sym__Alignof] = ACTIONS(2927),
    [anon_sym_offsetof] = ACTIONS(2927),
    [anon_sym__Generic] = ACTIONS(2927),
    [anon_sym_asm] = ACTIONS(2927),
    [anon_sym___asm__] = ACTIONS(2927),
    [aux_sym_number_literal_token1] = ACTIONS(2932),
    [aux_sym_number_literal_token2] = ACTIONS(2927),
    [anon_sym_L_SQUOTE] = ACTIONS(2932),
    [anon_sym_u_SQUOTE] = ACTIONS(2932),
    [anon_sym_U_SQUOTE] = ACTIONS(2932),
    [anon_sym_u8_SQUOTE] = ACTIONS(2932),
    [anon_sym_SQUOTE] = ACTIONS(2932),
    [anon_sym_L_DQUOTE] = ACTIONS(2932),
    [anon_sym_u_DQUOTE] = ACTIONS(2932),
    [anon_sym_U_DQUOTE] = ACTIONS(2932),
    [anon_sym_u8_DQUOTE] = ACTIONS(2932),
    [anon_sym_DQUOTE] = ACTIONS(2932),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [anon_sym_NULL] = ACTIONS(2927),
    [anon_sym_nullptr] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2927),
    [anon_sym_decltype] = ACTIONS(2927),
    [anon_sym_virtual] = ACTIONS(2927),
    [anon_sym_alignas] = ACTIONS(2927),
    [anon_sym_explicit] = ACTIONS(2927),
    [anon_sym_typename] = ACTIONS(2927),
    [anon_sym_template] = ACTIONS(2927),
    [anon_sym_operator] = ACTIONS(2927),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_throw] = ACTIONS(2927),
    [anon_sym_namespace] = ACTIONS(2927),
    [anon_sym_using] = ACTIONS(2927),
    [anon_sym_static_assert] = ACTIONS(2927),
    [anon_sym_concept] = ACTIONS(2927),
    [anon_sym_co_return] = ACTIONS(2927),
    [anon_sym_co_yield] = ACTIONS(2927),
    [anon_sym_R_DQUOTE] = ACTIONS(2932),
    [anon_sym_LR_DQUOTE] = ACTIONS(2932),
    [anon_sym_uR_DQUOTE] = ACTIONS(2932),
    [anon_sym_UR_DQUOTE] = ACTIONS(2932),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2932),
    [anon_sym_co_await] = ACTIONS(2927),
    [anon_sym_new] = ACTIONS(2927),
    [anon_sym_requires] = ACTIONS(2927),
    [sym_this] = ACTIONS(2927),
  },
  [757] = {
    [sym_identifier] = ACTIONS(3078),
    [aux_sym_preproc_include_token1] = ACTIONS(3078),
    [aux_sym_preproc_def_token1] = ACTIONS(3078),
    [aux_sym_preproc_if_token1] = ACTIONS(3078),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3078),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3078),
    [sym_preproc_directive] = ACTIONS(3078),
    [anon_sym_LPAREN2] = ACTIONS(3080),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_TILDE] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3078),
    [anon_sym_PLUS] = ACTIONS(3078),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3080),
    [anon_sym_AMP] = ACTIONS(3078),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym___extension__] = ACTIONS(3078),
    [anon_sym_typedef] = ACTIONS(3078),
    [anon_sym_extern] = ACTIONS(3078),
    [anon_sym___attribute__] = ACTIONS(3078),
    [anon_sym_COLON_COLON] = ACTIONS(3080),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3080),
    [anon_sym___declspec] = ACTIONS(3078),
    [anon_sym___based] = ACTIONS(3078),
    [anon_sym___cdecl] = ACTIONS(3078),
    [anon_sym___clrcall] = ACTIONS(3078),
    [anon_sym___stdcall] = ACTIONS(3078),
    [anon_sym___fastcall] = ACTIONS(3078),
    [anon_sym___thiscall] = ACTIONS(3078),
    [anon_sym___vectorcall] = ACTIONS(3078),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_RBRACE] = ACTIONS(3080),
    [anon_sym_signed] = ACTIONS(3078),
    [anon_sym_unsigned] = ACTIONS(3078),
    [anon_sym_long] = ACTIONS(3078),
    [anon_sym_short] = ACTIONS(3078),
    [anon_sym_LBRACK] = ACTIONS(3078),
    [anon_sym_static] = ACTIONS(3078),
    [anon_sym_register] = ACTIONS(3078),
    [anon_sym_inline] = ACTIONS(3078),
    [anon_sym___inline] = ACTIONS(3078),
    [anon_sym___inline__] = ACTIONS(3078),
    [anon_sym___forceinline] = ACTIONS(3078),
    [anon_sym_thread_local] = ACTIONS(3078),
    [anon_sym___thread] = ACTIONS(3078),
    [anon_sym_const] = ACTIONS(3078),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(3078),
    [anon_sym_restrict] = ACTIONS(3078),
    [anon_sym___restrict__] = ACTIONS(3078),
    [anon_sym__Atomic] = ACTIONS(3078),
    [anon_sym__Noreturn] = ACTIONS(3078),
    [anon_sym_noreturn] = ACTIONS(3078),
    [anon_sym_mutable] = ACTIONS(3078),
    [anon_sym_constinit] = ACTIONS(3078),
    [anon_sym_consteval] = ACTIONS(3078),
    [anon_sym_PROGMEM] = ACTIONS(3078),
    [aux_sym_primitive_type_token1] = ACTIONS(3078),
    [anon_sym_byte] = ACTIONS(3078),
    [anon_sym_word] = ACTIONS(3078),
    [anon_sym_enum] = ACTIONS(3078),
    [anon_sym_class] = ACTIONS(3078),
    [anon_sym_struct] = ACTIONS(3078),
    [anon_sym_union] = ACTIONS(3078),
    [anon_sym_if] = ACTIONS(3078),
    [anon_sym_else] = ACTIONS(3078),
    [anon_sym_switch] = ACTIONS(3078),
    [anon_sym_case] = ACTIONS(3078),
    [anon_sym_default] = ACTIONS(3078),
    [anon_sym_while] = ACTIONS(3078),
    [anon_sym_do] = ACTIONS(3078),
    [anon_sym_for] = ACTIONS(3078),
    [anon_sym_return] = ACTIONS(3078),
    [anon_sym_break] = ACTIONS(3078),
    [anon_sym_continue] = ACTIONS(3078),
    [anon_sym_goto] = ACTIONS(3078),
    [anon_sym___try] = ACTIONS(3078),
    [anon_sym___leave] = ACTIONS(3078),
    [anon_sym_not] = ACTIONS(3078),
    [anon_sym_compl] = ACTIONS(3078),
    [anon_sym_DASH_DASH] = ACTIONS(3080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3080),
    [anon_sym_sizeof] = ACTIONS(3078),
    [anon_sym___alignof__] = ACTIONS(3078),
    [anon_sym___alignof] = ACTIONS(3078),
    [anon_sym__alignof] = ACTIONS(3078),
    [anon_sym_alignof] = ACTIONS(3078),
    [anon_sym__Alignof] = ACTIONS(3078),
    [anon_sym_offsetof] = ACTIONS(3078),
    [anon_sym__Generic] = ACTIONS(3078),
    [anon_sym_asm] = ACTIONS(3078),
    [anon_sym___asm__] = ACTIONS(3078),
    [aux_sym_number_literal_token1] = ACTIONS(3080),
    [aux_sym_number_literal_token2] = ACTIONS(3078),
    [anon_sym_L_SQUOTE] = ACTIONS(3080),
    [anon_sym_u_SQUOTE] = ACTIONS(3080),
    [anon_sym_U_SQUOTE] = ACTIONS(3080),
    [anon_sym_u8_SQUOTE] = ACTIONS(3080),
    [anon_sym_SQUOTE] = ACTIONS(3080),
    [anon_sym_L_DQUOTE] = ACTIONS(3080),
    [anon_sym_u_DQUOTE] = ACTIONS(3080),
    [anon_sym_U_DQUOTE] = ACTIONS(3080),
    [anon_sym_u8_DQUOTE] = ACTIONS(3080),
    [anon_sym_DQUOTE] = ACTIONS(3080),
    [sym_true] = ACTIONS(3078),
    [sym_false] = ACTIONS(3078),
    [anon_sym_NULL] = ACTIONS(3078),
    [anon_sym_nullptr] = ACTIONS(3078),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3078),
    [anon_sym_decltype] = ACTIONS(3078),
    [anon_sym_virtual] = ACTIONS(3078),
    [anon_sym_alignas] = ACTIONS(3078),
    [anon_sym_explicit] = ACTIONS(3078),
    [anon_sym_typename] = ACTIONS(3078),
    [anon_sym_template] = ACTIONS(3078),
    [anon_sym_operator] = ACTIONS(3078),
    [anon_sym_try] = ACTIONS(3078),
    [anon_sym_delete] = ACTIONS(3078),
    [anon_sym_throw] = ACTIONS(3078),
    [anon_sym_namespace] = ACTIONS(3078),
    [anon_sym_using] = ACTIONS(3078),
    [anon_sym_static_assert] = ACTIONS(3078),
    [anon_sym_concept] = ACTIONS(3078),
    [anon_sym_co_return] = ACTIONS(3078),
    [anon_sym_co_yield] = ACTIONS(3078),
    [anon_sym_R_DQUOTE] = ACTIONS(3080),
    [anon_sym_LR_DQUOTE] = ACTIONS(3080),
    [anon_sym_uR_DQUOTE] = ACTIONS(3080),
    [anon_sym_UR_DQUOTE] = ACTIONS(3080),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3080),
    [anon_sym_co_await] = ACTIONS(3078),
    [anon_sym_new] = ACTIONS(3078),
    [anon_sym_requires] = ACTIONS(3078),
    [sym_this] = ACTIONS(3078),
  },
  [758] = {
    [ts_builtin_sym_end] = ACTIONS(2964),
    [sym_identifier] = ACTIONS(2962),
    [aux_sym_preproc_include_token1] = ACTIONS(2962),
    [aux_sym_preproc_def_token1] = ACTIONS(2962),
    [aux_sym_preproc_if_token1] = ACTIONS(2962),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2962),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2962),
    [sym_preproc_directive] = ACTIONS(2962),
    [anon_sym_LPAREN2] = ACTIONS(2964),
    [anon_sym_BANG] = ACTIONS(2964),
    [anon_sym_TILDE] = ACTIONS(2964),
    [anon_sym_DASH] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_STAR] = ACTIONS(2964),
    [anon_sym_AMP_AMP] = ACTIONS(2964),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_SEMI] = ACTIONS(2964),
    [anon_sym___extension__] = ACTIONS(2962),
    [anon_sym_typedef] = ACTIONS(2962),
    [anon_sym_extern] = ACTIONS(2962),
    [anon_sym___attribute__] = ACTIONS(2962),
    [anon_sym_COLON_COLON] = ACTIONS(2964),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2964),
    [anon_sym___declspec] = ACTIONS(2962),
    [anon_sym___based] = ACTIONS(2962),
    [anon_sym___cdecl] = ACTIONS(2962),
    [anon_sym___clrcall] = ACTIONS(2962),
    [anon_sym___stdcall] = ACTIONS(2962),
    [anon_sym___fastcall] = ACTIONS(2962),
    [anon_sym___thiscall] = ACTIONS(2962),
    [anon_sym___vectorcall] = ACTIONS(2962),
    [anon_sym_LBRACE] = ACTIONS(2964),
    [anon_sym_signed] = ACTIONS(2962),
    [anon_sym_unsigned] = ACTIONS(2962),
    [anon_sym_long] = ACTIONS(2962),
    [anon_sym_short] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_static] = ACTIONS(2962),
    [anon_sym_register] = ACTIONS(2962),
    [anon_sym_inline] = ACTIONS(2962),
    [anon_sym___inline] = ACTIONS(2962),
    [anon_sym___inline__] = ACTIONS(2962),
    [anon_sym___forceinline] = ACTIONS(2962),
    [anon_sym_thread_local] = ACTIONS(2962),
    [anon_sym___thread] = ACTIONS(2962),
    [anon_sym_const] = ACTIONS(2962),
    [anon_sym_constexpr] = ACTIONS(2962),
    [anon_sym_volatile] = ACTIONS(2962),
    [anon_sym_restrict] = ACTIONS(2962),
    [anon_sym___restrict__] = ACTIONS(2962),
    [anon_sym__Atomic] = ACTIONS(2962),
    [anon_sym__Noreturn] = ACTIONS(2962),
    [anon_sym_noreturn] = ACTIONS(2962),
    [anon_sym_mutable] = ACTIONS(2962),
    [anon_sym_constinit] = ACTIONS(2962),
    [anon_sym_consteval] = ACTIONS(2962),
    [anon_sym_PROGMEM] = ACTIONS(2962),
    [aux_sym_primitive_type_token1] = ACTIONS(2962),
    [anon_sym_byte] = ACTIONS(2962),
    [anon_sym_word] = ACTIONS(2962),
    [anon_sym_enum] = ACTIONS(2962),
    [anon_sym_class] = ACTIONS(2962),
    [anon_sym_struct] = ACTIONS(2962),
    [anon_sym_union] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_else] = ACTIONS(2962),
    [anon_sym_switch] = ACTIONS(2962),
    [anon_sym_case] = ACTIONS(2962),
    [anon_sym_default] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_for] = ACTIONS(2962),
    [anon_sym_return] = ACTIONS(2962),
    [anon_sym_break] = ACTIONS(2962),
    [anon_sym_continue] = ACTIONS(2962),
    [anon_sym_goto] = ACTIONS(2962),
    [anon_sym___try] = ACTIONS(2962),
    [anon_sym___leave] = ACTIONS(2962),
    [anon_sym_not] = ACTIONS(2962),
    [anon_sym_compl] = ACTIONS(2962),
    [anon_sym_DASH_DASH] = ACTIONS(2964),
    [anon_sym_PLUS_PLUS] = ACTIONS(2964),
    [anon_sym_sizeof] = ACTIONS(2962),
    [anon_sym___alignof__] = ACTIONS(2962),
    [anon_sym___alignof] = ACTIONS(2962),
    [anon_sym__alignof] = ACTIONS(2962),
    [anon_sym_alignof] = ACTIONS(2962),
    [anon_sym__Alignof] = ACTIONS(2962),
    [anon_sym_offsetof] = ACTIONS(2962),
    [anon_sym__Generic] = ACTIONS(2962),
    [anon_sym_asm] = ACTIONS(2962),
    [anon_sym___asm__] = ACTIONS(2962),
    [aux_sym_number_literal_token1] = ACTIONS(2964),
    [aux_sym_number_literal_token2] = ACTIONS(2962),
    [anon_sym_L_SQUOTE] = ACTIONS(2964),
    [anon_sym_u_SQUOTE] = ACTIONS(2964),
    [anon_sym_U_SQUOTE] = ACTIONS(2964),
    [anon_sym_u8_SQUOTE] = ACTIONS(2964),
    [anon_sym_SQUOTE] = ACTIONS(2964),
    [anon_sym_L_DQUOTE] = ACTIONS(2964),
    [anon_sym_u_DQUOTE] = ACTIONS(2964),
    [anon_sym_U_DQUOTE] = ACTIONS(2964),
    [anon_sym_u8_DQUOTE] = ACTIONS(2964),
    [anon_sym_DQUOTE] = ACTIONS(2964),
    [sym_true] = ACTIONS(2962),
    [sym_false] = ACTIONS(2962),
    [anon_sym_NULL] = ACTIONS(2962),
    [anon_sym_nullptr] = ACTIONS(2962),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2962),
    [anon_sym_decltype] = ACTIONS(2962),
    [anon_sym_virtual] = ACTIONS(2962),
    [anon_sym_alignas] = ACTIONS(2962),
    [anon_sym_explicit] = ACTIONS(2962),
    [anon_sym_typename] = ACTIONS(2962),
    [anon_sym_template] = ACTIONS(2962),
    [anon_sym_operator] = ACTIONS(2962),
    [anon_sym_try] = ACTIONS(2962),
    [anon_sym_delete] = ACTIONS(2962),
    [anon_sym_throw] = ACTIONS(2962),
    [anon_sym_namespace] = ACTIONS(2962),
    [anon_sym_using] = ACTIONS(2962),
    [anon_sym_static_assert] = ACTIONS(2962),
    [anon_sym_concept] = ACTIONS(2962),
    [anon_sym_co_return] = ACTIONS(2962),
    [anon_sym_co_yield] = ACTIONS(2962),
    [anon_sym_R_DQUOTE] = ACTIONS(2964),
    [anon_sym_LR_DQUOTE] = ACTIONS(2964),
    [anon_sym_uR_DQUOTE] = ACTIONS(2964),
    [anon_sym_UR_DQUOTE] = ACTIONS(2964),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2964),
    [anon_sym_co_await] = ACTIONS(2962),
    [anon_sym_new] = ACTIONS(2962),
    [anon_sym_requires] = ACTIONS(2962),
    [sym_this] = ACTIONS(2962),
  },
  [759] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [760] = {
    [ts_builtin_sym_end] = ACTIONS(2956),
    [sym_identifier] = ACTIONS(2954),
    [aux_sym_preproc_include_token1] = ACTIONS(2954),
    [aux_sym_preproc_def_token1] = ACTIONS(2954),
    [aux_sym_preproc_if_token1] = ACTIONS(2954),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2954),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2954),
    [sym_preproc_directive] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2956),
    [anon_sym_BANG] = ACTIONS(2956),
    [anon_sym_TILDE] = ACTIONS(2956),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_STAR] = ACTIONS(2956),
    [anon_sym_AMP_AMP] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2954),
    [anon_sym_SEMI] = ACTIONS(2956),
    [anon_sym___extension__] = ACTIONS(2954),
    [anon_sym_typedef] = ACTIONS(2954),
    [anon_sym_extern] = ACTIONS(2954),
    [anon_sym___attribute__] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2956),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2956),
    [anon_sym___declspec] = ACTIONS(2954),
    [anon_sym___based] = ACTIONS(2954),
    [anon_sym___cdecl] = ACTIONS(2954),
    [anon_sym___clrcall] = ACTIONS(2954),
    [anon_sym___stdcall] = ACTIONS(2954),
    [anon_sym___fastcall] = ACTIONS(2954),
    [anon_sym___thiscall] = ACTIONS(2954),
    [anon_sym___vectorcall] = ACTIONS(2954),
    [anon_sym_LBRACE] = ACTIONS(2956),
    [anon_sym_signed] = ACTIONS(2954),
    [anon_sym_unsigned] = ACTIONS(2954),
    [anon_sym_long] = ACTIONS(2954),
    [anon_sym_short] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_static] = ACTIONS(2954),
    [anon_sym_register] = ACTIONS(2954),
    [anon_sym_inline] = ACTIONS(2954),
    [anon_sym___inline] = ACTIONS(2954),
    [anon_sym___inline__] = ACTIONS(2954),
    [anon_sym___forceinline] = ACTIONS(2954),
    [anon_sym_thread_local] = ACTIONS(2954),
    [anon_sym___thread] = ACTIONS(2954),
    [anon_sym_const] = ACTIONS(2954),
    [anon_sym_constexpr] = ACTIONS(2954),
    [anon_sym_volatile] = ACTIONS(2954),
    [anon_sym_restrict] = ACTIONS(2954),
    [anon_sym___restrict__] = ACTIONS(2954),
    [anon_sym__Atomic] = ACTIONS(2954),
    [anon_sym__Noreturn] = ACTIONS(2954),
    [anon_sym_noreturn] = ACTIONS(2954),
    [anon_sym_mutable] = ACTIONS(2954),
    [anon_sym_constinit] = ACTIONS(2954),
    [anon_sym_consteval] = ACTIONS(2954),
    [anon_sym_PROGMEM] = ACTIONS(2954),
    [aux_sym_primitive_type_token1] = ACTIONS(2954),
    [anon_sym_byte] = ACTIONS(2954),
    [anon_sym_word] = ACTIONS(2954),
    [anon_sym_enum] = ACTIONS(2954),
    [anon_sym_class] = ACTIONS(2954),
    [anon_sym_struct] = ACTIONS(2954),
    [anon_sym_union] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_else] = ACTIONS(2954),
    [anon_sym_switch] = ACTIONS(2954),
    [anon_sym_case] = ACTIONS(2954),
    [anon_sym_default] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_break] = ACTIONS(2954),
    [anon_sym_continue] = ACTIONS(2954),
    [anon_sym_goto] = ACTIONS(2954),
    [anon_sym___try] = ACTIONS(2954),
    [anon_sym___leave] = ACTIONS(2954),
    [anon_sym_not] = ACTIONS(2954),
    [anon_sym_compl] = ACTIONS(2954),
    [anon_sym_DASH_DASH] = ACTIONS(2956),
    [anon_sym_PLUS_PLUS] = ACTIONS(2956),
    [anon_sym_sizeof] = ACTIONS(2954),
    [anon_sym___alignof__] = ACTIONS(2954),
    [anon_sym___alignof] = ACTIONS(2954),
    [anon_sym__alignof] = ACTIONS(2954),
    [anon_sym_alignof] = ACTIONS(2954),
    [anon_sym__Alignof] = ACTIONS(2954),
    [anon_sym_offsetof] = ACTIONS(2954),
    [anon_sym__Generic] = ACTIONS(2954),
    [anon_sym_asm] = ACTIONS(2954),
    [anon_sym___asm__] = ACTIONS(2954),
    [aux_sym_number_literal_token1] = ACTIONS(2956),
    [aux_sym_number_literal_token2] = ACTIONS(2954),
    [anon_sym_L_SQUOTE] = ACTIONS(2956),
    [anon_sym_u_SQUOTE] = ACTIONS(2956),
    [anon_sym_U_SQUOTE] = ACTIONS(2956),
    [anon_sym_u8_SQUOTE] = ACTIONS(2956),
    [anon_sym_SQUOTE] = ACTIONS(2956),
    [anon_sym_L_DQUOTE] = ACTIONS(2956),
    [anon_sym_u_DQUOTE] = ACTIONS(2956),
    [anon_sym_U_DQUOTE] = ACTIONS(2956),
    [anon_sym_u8_DQUOTE] = ACTIONS(2956),
    [anon_sym_DQUOTE] = ACTIONS(2956),
    [sym_true] = ACTIONS(2954),
    [sym_false] = ACTIONS(2954),
    [anon_sym_NULL] = ACTIONS(2954),
    [anon_sym_nullptr] = ACTIONS(2954),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2954),
    [anon_sym_decltype] = ACTIONS(2954),
    [anon_sym_virtual] = ACTIONS(2954),
    [anon_sym_alignas] = ACTIONS(2954),
    [anon_sym_explicit] = ACTIONS(2954),
    [anon_sym_typename] = ACTIONS(2954),
    [anon_sym_template] = ACTIONS(2954),
    [anon_sym_operator] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_delete] = ACTIONS(2954),
    [anon_sym_throw] = ACTIONS(2954),
    [anon_sym_namespace] = ACTIONS(2954),
    [anon_sym_using] = ACTIONS(2954),
    [anon_sym_static_assert] = ACTIONS(2954),
    [anon_sym_concept] = ACTIONS(2954),
    [anon_sym_co_return] = ACTIONS(2954),
    [anon_sym_co_yield] = ACTIONS(2954),
    [anon_sym_R_DQUOTE] = ACTIONS(2956),
    [anon_sym_LR_DQUOTE] = ACTIONS(2956),
    [anon_sym_uR_DQUOTE] = ACTIONS(2956),
    [anon_sym_UR_DQUOTE] = ACTIONS(2956),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2956),
    [anon_sym_co_await] = ACTIONS(2954),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_requires] = ACTIONS(2954),
    [sym_this] = ACTIONS(2954),
  },
  [761] = {
    [ts_builtin_sym_end] = ACTIONS(2952),
    [sym_identifier] = ACTIONS(2950),
    [aux_sym_preproc_include_token1] = ACTIONS(2950),
    [aux_sym_preproc_def_token1] = ACTIONS(2950),
    [aux_sym_preproc_if_token1] = ACTIONS(2950),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2950),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2950),
    [sym_preproc_directive] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2952),
    [anon_sym_BANG] = ACTIONS(2952),
    [anon_sym_TILDE] = ACTIONS(2952),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_STAR] = ACTIONS(2952),
    [anon_sym_AMP_AMP] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_SEMI] = ACTIONS(2952),
    [anon_sym___extension__] = ACTIONS(2950),
    [anon_sym_typedef] = ACTIONS(2950),
    [anon_sym_extern] = ACTIONS(2950),
    [anon_sym___attribute__] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2952),
    [anon_sym___declspec] = ACTIONS(2950),
    [anon_sym___based] = ACTIONS(2950),
    [anon_sym___cdecl] = ACTIONS(2950),
    [anon_sym___clrcall] = ACTIONS(2950),
    [anon_sym___stdcall] = ACTIONS(2950),
    [anon_sym___fastcall] = ACTIONS(2950),
    [anon_sym___thiscall] = ACTIONS(2950),
    [anon_sym___vectorcall] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2952),
    [anon_sym_signed] = ACTIONS(2950),
    [anon_sym_unsigned] = ACTIONS(2950),
    [anon_sym_long] = ACTIONS(2950),
    [anon_sym_short] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_static] = ACTIONS(2950),
    [anon_sym_register] = ACTIONS(2950),
    [anon_sym_inline] = ACTIONS(2950),
    [anon_sym___inline] = ACTIONS(2950),
    [anon_sym___inline__] = ACTIONS(2950),
    [anon_sym___forceinline] = ACTIONS(2950),
    [anon_sym_thread_local] = ACTIONS(2950),
    [anon_sym___thread] = ACTIONS(2950),
    [anon_sym_const] = ACTIONS(2950),
    [anon_sym_constexpr] = ACTIONS(2950),
    [anon_sym_volatile] = ACTIONS(2950),
    [anon_sym_restrict] = ACTIONS(2950),
    [anon_sym___restrict__] = ACTIONS(2950),
    [anon_sym__Atomic] = ACTIONS(2950),
    [anon_sym__Noreturn] = ACTIONS(2950),
    [anon_sym_noreturn] = ACTIONS(2950),
    [anon_sym_mutable] = ACTIONS(2950),
    [anon_sym_constinit] = ACTIONS(2950),
    [anon_sym_consteval] = ACTIONS(2950),
    [anon_sym_PROGMEM] = ACTIONS(2950),
    [aux_sym_primitive_type_token1] = ACTIONS(2950),
    [anon_sym_byte] = ACTIONS(2950),
    [anon_sym_word] = ACTIONS(2950),
    [anon_sym_enum] = ACTIONS(2950),
    [anon_sym_class] = ACTIONS(2950),
    [anon_sym_struct] = ACTIONS(2950),
    [anon_sym_union] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_else] = ACTIONS(2950),
    [anon_sym_switch] = ACTIONS(2950),
    [anon_sym_case] = ACTIONS(2950),
    [anon_sym_default] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_break] = ACTIONS(2950),
    [anon_sym_continue] = ACTIONS(2950),
    [anon_sym_goto] = ACTIONS(2950),
    [anon_sym___try] = ACTIONS(2950),
    [anon_sym___leave] = ACTIONS(2950),
    [anon_sym_not] = ACTIONS(2950),
    [anon_sym_compl] = ACTIONS(2950),
    [anon_sym_DASH_DASH] = ACTIONS(2952),
    [anon_sym_PLUS_PLUS] = ACTIONS(2952),
    [anon_sym_sizeof] = ACTIONS(2950),
    [anon_sym___alignof__] = ACTIONS(2950),
    [anon_sym___alignof] = ACTIONS(2950),
    [anon_sym__alignof] = ACTIONS(2950),
    [anon_sym_alignof] = ACTIONS(2950),
    [anon_sym__Alignof] = ACTIONS(2950),
    [anon_sym_offsetof] = ACTIONS(2950),
    [anon_sym__Generic] = ACTIONS(2950),
    [anon_sym_asm] = ACTIONS(2950),
    [anon_sym___asm__] = ACTIONS(2950),
    [aux_sym_number_literal_token1] = ACTIONS(2952),
    [aux_sym_number_literal_token2] = ACTIONS(2950),
    [anon_sym_L_SQUOTE] = ACTIONS(2952),
    [anon_sym_u_SQUOTE] = ACTIONS(2952),
    [anon_sym_U_SQUOTE] = ACTIONS(2952),
    [anon_sym_u8_SQUOTE] = ACTIONS(2952),
    [anon_sym_SQUOTE] = ACTIONS(2952),
    [anon_sym_L_DQUOTE] = ACTIONS(2952),
    [anon_sym_u_DQUOTE] = ACTIONS(2952),
    [anon_sym_U_DQUOTE] = ACTIONS(2952),
    [anon_sym_u8_DQUOTE] = ACTIONS(2952),
    [anon_sym_DQUOTE] = ACTIONS(2952),
    [sym_true] = ACTIONS(2950),
    [sym_false] = ACTIONS(2950),
    [anon_sym_NULL] = ACTIONS(2950),
    [anon_sym_nullptr] = ACTIONS(2950),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2950),
    [anon_sym_decltype] = ACTIONS(2950),
    [anon_sym_virtual] = ACTIONS(2950),
    [anon_sym_alignas] = ACTIONS(2950),
    [anon_sym_explicit] = ACTIONS(2950),
    [anon_sym_typename] = ACTIONS(2950),
    [anon_sym_template] = ACTIONS(2950),
    [anon_sym_operator] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_delete] = ACTIONS(2950),
    [anon_sym_throw] = ACTIONS(2950),
    [anon_sym_namespace] = ACTIONS(2950),
    [anon_sym_using] = ACTIONS(2950),
    [anon_sym_static_assert] = ACTIONS(2950),
    [anon_sym_concept] = ACTIONS(2950),
    [anon_sym_co_return] = ACTIONS(2950),
    [anon_sym_co_yield] = ACTIONS(2950),
    [anon_sym_R_DQUOTE] = ACTIONS(2952),
    [anon_sym_LR_DQUOTE] = ACTIONS(2952),
    [anon_sym_uR_DQUOTE] = ACTIONS(2952),
    [anon_sym_UR_DQUOTE] = ACTIONS(2952),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2952),
    [anon_sym_co_await] = ACTIONS(2950),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_requires] = ACTIONS(2950),
    [sym_this] = ACTIONS(2950),
  },
  [762] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [763] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [764] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4519),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_initializer_list] = STATE(4671),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(2149),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2151),
    [anon_sym_COMMA] = ACTIONS(2151),
    [aux_sym_preproc_if_token2] = ACTIONS(2151),
    [aux_sym_preproc_else_token1] = ACTIONS(2151),
    [aux_sym_preproc_elif_token1] = ACTIONS(2149),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2151),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2151),
    [anon_sym_LPAREN2] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(3535),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(2151),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_PERCENT] = ACTIONS(2151),
    [anon_sym_PIPE_PIPE] = ACTIONS(2151),
    [anon_sym_AMP_AMP] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(2149),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2149),
    [anon_sym_EQ_EQ] = ACTIONS(2151),
    [anon_sym_BANG_EQ] = ACTIONS(2151),
    [anon_sym_GT] = ACTIONS(2149),
    [anon_sym_GT_EQ] = ACTIONS(2151),
    [anon_sym_LT_EQ] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_LT_LT] = ACTIONS(2151),
    [anon_sym_GT_GT] = ACTIONS(2151),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_LT_EQ_GT] = ACTIONS(2151),
    [anon_sym_or] = ACTIONS(2149),
    [anon_sym_and] = ACTIONS(2149),
    [anon_sym_bitor] = ACTIONS(2149),
    [anon_sym_xor] = ACTIONS(2149),
    [anon_sym_bitand] = ACTIONS(2149),
    [anon_sym_not_eq] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(2149),
    [anon_sym_DOT_STAR] = ACTIONS(2151),
    [anon_sym_DASH_GT] = ACTIONS(2151),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [765] = {
    [sym_identifier] = ACTIONS(3092),
    [aux_sym_preproc_include_token1] = ACTIONS(3092),
    [aux_sym_preproc_def_token1] = ACTIONS(3092),
    [aux_sym_preproc_if_token1] = ACTIONS(3092),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3092),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3092),
    [sym_preproc_directive] = ACTIONS(3092),
    [anon_sym_LPAREN2] = ACTIONS(3094),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_TILDE] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_SEMI] = ACTIONS(3094),
    [anon_sym___extension__] = ACTIONS(3092),
    [anon_sym_typedef] = ACTIONS(3092),
    [anon_sym_extern] = ACTIONS(3092),
    [anon_sym___attribute__] = ACTIONS(3092),
    [anon_sym_COLON_COLON] = ACTIONS(3094),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3094),
    [anon_sym___declspec] = ACTIONS(3092),
    [anon_sym___based] = ACTIONS(3092),
    [anon_sym___cdecl] = ACTIONS(3092),
    [anon_sym___clrcall] = ACTIONS(3092),
    [anon_sym___stdcall] = ACTIONS(3092),
    [anon_sym___fastcall] = ACTIONS(3092),
    [anon_sym___thiscall] = ACTIONS(3092),
    [anon_sym___vectorcall] = ACTIONS(3092),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_RBRACE] = ACTIONS(3094),
    [anon_sym_signed] = ACTIONS(3092),
    [anon_sym_unsigned] = ACTIONS(3092),
    [anon_sym_long] = ACTIONS(3092),
    [anon_sym_short] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_static] = ACTIONS(3092),
    [anon_sym_register] = ACTIONS(3092),
    [anon_sym_inline] = ACTIONS(3092),
    [anon_sym___inline] = ACTIONS(3092),
    [anon_sym___inline__] = ACTIONS(3092),
    [anon_sym___forceinline] = ACTIONS(3092),
    [anon_sym_thread_local] = ACTIONS(3092),
    [anon_sym___thread] = ACTIONS(3092),
    [anon_sym_const] = ACTIONS(3092),
    [anon_sym_constexpr] = ACTIONS(3092),
    [anon_sym_volatile] = ACTIONS(3092),
    [anon_sym_restrict] = ACTIONS(3092),
    [anon_sym___restrict__] = ACTIONS(3092),
    [anon_sym__Atomic] = ACTIONS(3092),
    [anon_sym__Noreturn] = ACTIONS(3092),
    [anon_sym_noreturn] = ACTIONS(3092),
    [anon_sym_mutable] = ACTIONS(3092),
    [anon_sym_constinit] = ACTIONS(3092),
    [anon_sym_consteval] = ACTIONS(3092),
    [anon_sym_PROGMEM] = ACTIONS(3092),
    [aux_sym_primitive_type_token1] = ACTIONS(3092),
    [anon_sym_byte] = ACTIONS(3092),
    [anon_sym_word] = ACTIONS(3092),
    [anon_sym_enum] = ACTIONS(3092),
    [anon_sym_class] = ACTIONS(3092),
    [anon_sym_struct] = ACTIONS(3092),
    [anon_sym_union] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_switch] = ACTIONS(3092),
    [anon_sym_case] = ACTIONS(3092),
    [anon_sym_default] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_break] = ACTIONS(3092),
    [anon_sym_continue] = ACTIONS(3092),
    [anon_sym_goto] = ACTIONS(3092),
    [anon_sym___try] = ACTIONS(3092),
    [anon_sym___leave] = ACTIONS(3092),
    [anon_sym_not] = ACTIONS(3092),
    [anon_sym_compl] = ACTIONS(3092),
    [anon_sym_DASH_DASH] = ACTIONS(3094),
    [anon_sym_PLUS_PLUS] = ACTIONS(3094),
    [anon_sym_sizeof] = ACTIONS(3092),
    [anon_sym___alignof__] = ACTIONS(3092),
    [anon_sym___alignof] = ACTIONS(3092),
    [anon_sym__alignof] = ACTIONS(3092),
    [anon_sym_alignof] = ACTIONS(3092),
    [anon_sym__Alignof] = ACTIONS(3092),
    [anon_sym_offsetof] = ACTIONS(3092),
    [anon_sym__Generic] = ACTIONS(3092),
    [anon_sym_asm] = ACTIONS(3092),
    [anon_sym___asm__] = ACTIONS(3092),
    [aux_sym_number_literal_token1] = ACTIONS(3094),
    [aux_sym_number_literal_token2] = ACTIONS(3092),
    [anon_sym_L_SQUOTE] = ACTIONS(3094),
    [anon_sym_u_SQUOTE] = ACTIONS(3094),
    [anon_sym_U_SQUOTE] = ACTIONS(3094),
    [anon_sym_u8_SQUOTE] = ACTIONS(3094),
    [anon_sym_SQUOTE] = ACTIONS(3094),
    [anon_sym_L_DQUOTE] = ACTIONS(3094),
    [anon_sym_u_DQUOTE] = ACTIONS(3094),
    [anon_sym_U_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8_DQUOTE] = ACTIONS(3094),
    [anon_sym_DQUOTE] = ACTIONS(3094),
    [sym_true] = ACTIONS(3092),
    [sym_false] = ACTIONS(3092),
    [anon_sym_NULL] = ACTIONS(3092),
    [anon_sym_nullptr] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3092),
    [anon_sym_decltype] = ACTIONS(3092),
    [anon_sym_virtual] = ACTIONS(3092),
    [anon_sym_alignas] = ACTIONS(3092),
    [anon_sym_explicit] = ACTIONS(3092),
    [anon_sym_typename] = ACTIONS(3092),
    [anon_sym_template] = ACTIONS(3092),
    [anon_sym_operator] = ACTIONS(3092),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_delete] = ACTIONS(3092),
    [anon_sym_throw] = ACTIONS(3092),
    [anon_sym_namespace] = ACTIONS(3092),
    [anon_sym_using] = ACTIONS(3092),
    [anon_sym_static_assert] = ACTIONS(3092),
    [anon_sym_concept] = ACTIONS(3092),
    [anon_sym_co_return] = ACTIONS(3092),
    [anon_sym_co_yield] = ACTIONS(3092),
    [anon_sym_R_DQUOTE] = ACTIONS(3094),
    [anon_sym_LR_DQUOTE] = ACTIONS(3094),
    [anon_sym_uR_DQUOTE] = ACTIONS(3094),
    [anon_sym_UR_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3094),
    [anon_sym_co_await] = ACTIONS(3092),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_requires] = ACTIONS(3092),
    [sym_this] = ACTIONS(3092),
  },
  [766] = {
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_include_token1] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_BANG] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_DASH] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym___cdecl] = ACTIONS(3068),
    [anon_sym___clrcall] = ACTIONS(3068),
    [anon_sym___stdcall] = ACTIONS(3068),
    [anon_sym___fastcall] = ACTIONS(3068),
    [anon_sym___thiscall] = ACTIONS(3068),
    [anon_sym___vectorcall] = ACTIONS(3068),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_RBRACE] = ACTIONS(3070),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_PROGMEM] = ACTIONS(3068),
    [aux_sym_primitive_type_token1] = ACTIONS(3068),
    [anon_sym_byte] = ACTIONS(3068),
    [anon_sym_word] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3068),
    [anon_sym_else] = ACTIONS(3068),
    [anon_sym_switch] = ACTIONS(3068),
    [anon_sym_case] = ACTIONS(3068),
    [anon_sym_default] = ACTIONS(3068),
    [anon_sym_while] = ACTIONS(3068),
    [anon_sym_do] = ACTIONS(3068),
    [anon_sym_for] = ACTIONS(3068),
    [anon_sym_return] = ACTIONS(3068),
    [anon_sym_break] = ACTIONS(3068),
    [anon_sym_continue] = ACTIONS(3068),
    [anon_sym_goto] = ACTIONS(3068),
    [anon_sym___try] = ACTIONS(3068),
    [anon_sym___leave] = ACTIONS(3068),
    [anon_sym_not] = ACTIONS(3068),
    [anon_sym_compl] = ACTIONS(3068),
    [anon_sym_DASH_DASH] = ACTIONS(3070),
    [anon_sym_PLUS_PLUS] = ACTIONS(3070),
    [anon_sym_sizeof] = ACTIONS(3068),
    [anon_sym___alignof__] = ACTIONS(3068),
    [anon_sym___alignof] = ACTIONS(3068),
    [anon_sym__alignof] = ACTIONS(3068),
    [anon_sym_alignof] = ACTIONS(3068),
    [anon_sym__Alignof] = ACTIONS(3068),
    [anon_sym_offsetof] = ACTIONS(3068),
    [anon_sym__Generic] = ACTIONS(3068),
    [anon_sym_asm] = ACTIONS(3068),
    [anon_sym___asm__] = ACTIONS(3068),
    [aux_sym_number_literal_token1] = ACTIONS(3070),
    [aux_sym_number_literal_token2] = ACTIONS(3068),
    [anon_sym_L_SQUOTE] = ACTIONS(3070),
    [anon_sym_u_SQUOTE] = ACTIONS(3070),
    [anon_sym_U_SQUOTE] = ACTIONS(3070),
    [anon_sym_u8_SQUOTE] = ACTIONS(3070),
    [anon_sym_SQUOTE] = ACTIONS(3070),
    [anon_sym_L_DQUOTE] = ACTIONS(3070),
    [anon_sym_u_DQUOTE] = ACTIONS(3070),
    [anon_sym_U_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8_DQUOTE] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3070),
    [sym_true] = ACTIONS(3068),
    [sym_false] = ACTIONS(3068),
    [anon_sym_NULL] = ACTIONS(3068),
    [anon_sym_nullptr] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_try] = ACTIONS(3068),
    [anon_sym_delete] = ACTIONS(3068),
    [anon_sym_throw] = ACTIONS(3068),
    [anon_sym_namespace] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
    [anon_sym_concept] = ACTIONS(3068),
    [anon_sym_co_return] = ACTIONS(3068),
    [anon_sym_co_yield] = ACTIONS(3068),
    [anon_sym_R_DQUOTE] = ACTIONS(3070),
    [anon_sym_LR_DQUOTE] = ACTIONS(3070),
    [anon_sym_uR_DQUOTE] = ACTIONS(3070),
    [anon_sym_UR_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3070),
    [anon_sym_co_await] = ACTIONS(3068),
    [anon_sym_new] = ACTIONS(3068),
    [anon_sym_requires] = ACTIONS(3068),
    [sym_this] = ACTIONS(3068),
  },
  [767] = {
    [sym_identifier] = ACTIONS(3064),
    [aux_sym_preproc_include_token1] = ACTIONS(3064),
    [aux_sym_preproc_def_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3064),
    [anon_sym_LPAREN2] = ACTIONS(3066),
    [anon_sym_BANG] = ACTIONS(3066),
    [anon_sym_TILDE] = ACTIONS(3066),
    [anon_sym_DASH] = ACTIONS(3064),
    [anon_sym_PLUS] = ACTIONS(3064),
    [anon_sym_STAR] = ACTIONS(3066),
    [anon_sym_AMP_AMP] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3064),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym___extension__] = ACTIONS(3064),
    [anon_sym_typedef] = ACTIONS(3064),
    [anon_sym_extern] = ACTIONS(3064),
    [anon_sym___attribute__] = ACTIONS(3064),
    [anon_sym_COLON_COLON] = ACTIONS(3066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3066),
    [anon_sym___declspec] = ACTIONS(3064),
    [anon_sym___based] = ACTIONS(3064),
    [anon_sym___cdecl] = ACTIONS(3064),
    [anon_sym___clrcall] = ACTIONS(3064),
    [anon_sym___stdcall] = ACTIONS(3064),
    [anon_sym___fastcall] = ACTIONS(3064),
    [anon_sym___thiscall] = ACTIONS(3064),
    [anon_sym___vectorcall] = ACTIONS(3064),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_RBRACE] = ACTIONS(3066),
    [anon_sym_signed] = ACTIONS(3064),
    [anon_sym_unsigned] = ACTIONS(3064),
    [anon_sym_long] = ACTIONS(3064),
    [anon_sym_short] = ACTIONS(3064),
    [anon_sym_LBRACK] = ACTIONS(3064),
    [anon_sym_static] = ACTIONS(3064),
    [anon_sym_register] = ACTIONS(3064),
    [anon_sym_inline] = ACTIONS(3064),
    [anon_sym___inline] = ACTIONS(3064),
    [anon_sym___inline__] = ACTIONS(3064),
    [anon_sym___forceinline] = ACTIONS(3064),
    [anon_sym_thread_local] = ACTIONS(3064),
    [anon_sym___thread] = ACTIONS(3064),
    [anon_sym_const] = ACTIONS(3064),
    [anon_sym_constexpr] = ACTIONS(3064),
    [anon_sym_volatile] = ACTIONS(3064),
    [anon_sym_restrict] = ACTIONS(3064),
    [anon_sym___restrict__] = ACTIONS(3064),
    [anon_sym__Atomic] = ACTIONS(3064),
    [anon_sym__Noreturn] = ACTIONS(3064),
    [anon_sym_noreturn] = ACTIONS(3064),
    [anon_sym_mutable] = ACTIONS(3064),
    [anon_sym_constinit] = ACTIONS(3064),
    [anon_sym_consteval] = ACTIONS(3064),
    [anon_sym_PROGMEM] = ACTIONS(3064),
    [aux_sym_primitive_type_token1] = ACTIONS(3064),
    [anon_sym_byte] = ACTIONS(3064),
    [anon_sym_word] = ACTIONS(3064),
    [anon_sym_enum] = ACTIONS(3064),
    [anon_sym_class] = ACTIONS(3064),
    [anon_sym_struct] = ACTIONS(3064),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_if] = ACTIONS(3064),
    [anon_sym_else] = ACTIONS(3064),
    [anon_sym_switch] = ACTIONS(3064),
    [anon_sym_case] = ACTIONS(3064),
    [anon_sym_default] = ACTIONS(3064),
    [anon_sym_while] = ACTIONS(3064),
    [anon_sym_do] = ACTIONS(3064),
    [anon_sym_for] = ACTIONS(3064),
    [anon_sym_return] = ACTIONS(3064),
    [anon_sym_break] = ACTIONS(3064),
    [anon_sym_continue] = ACTIONS(3064),
    [anon_sym_goto] = ACTIONS(3064),
    [anon_sym___try] = ACTIONS(3064),
    [anon_sym___leave] = ACTIONS(3064),
    [anon_sym_not] = ACTIONS(3064),
    [anon_sym_compl] = ACTIONS(3064),
    [anon_sym_DASH_DASH] = ACTIONS(3066),
    [anon_sym_PLUS_PLUS] = ACTIONS(3066),
    [anon_sym_sizeof] = ACTIONS(3064),
    [anon_sym___alignof__] = ACTIONS(3064),
    [anon_sym___alignof] = ACTIONS(3064),
    [anon_sym__alignof] = ACTIONS(3064),
    [anon_sym_alignof] = ACTIONS(3064),
    [anon_sym__Alignof] = ACTIONS(3064),
    [anon_sym_offsetof] = ACTIONS(3064),
    [anon_sym__Generic] = ACTIONS(3064),
    [anon_sym_asm] = ACTIONS(3064),
    [anon_sym___asm__] = ACTIONS(3064),
    [aux_sym_number_literal_token1] = ACTIONS(3066),
    [aux_sym_number_literal_token2] = ACTIONS(3064),
    [anon_sym_L_SQUOTE] = ACTIONS(3066),
    [anon_sym_u_SQUOTE] = ACTIONS(3066),
    [anon_sym_U_SQUOTE] = ACTIONS(3066),
    [anon_sym_u8_SQUOTE] = ACTIONS(3066),
    [anon_sym_SQUOTE] = ACTIONS(3066),
    [anon_sym_L_DQUOTE] = ACTIONS(3066),
    [anon_sym_u_DQUOTE] = ACTIONS(3066),
    [anon_sym_U_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8_DQUOTE] = ACTIONS(3066),
    [anon_sym_DQUOTE] = ACTIONS(3066),
    [sym_true] = ACTIONS(3064),
    [sym_false] = ACTIONS(3064),
    [anon_sym_NULL] = ACTIONS(3064),
    [anon_sym_nullptr] = ACTIONS(3064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3064),
    [anon_sym_decltype] = ACTIONS(3064),
    [anon_sym_virtual] = ACTIONS(3064),
    [anon_sym_alignas] = ACTIONS(3064),
    [anon_sym_explicit] = ACTIONS(3064),
    [anon_sym_typename] = ACTIONS(3064),
    [anon_sym_template] = ACTIONS(3064),
    [anon_sym_operator] = ACTIONS(3064),
    [anon_sym_try] = ACTIONS(3064),
    [anon_sym_delete] = ACTIONS(3064),
    [anon_sym_throw] = ACTIONS(3064),
    [anon_sym_namespace] = ACTIONS(3064),
    [anon_sym_using] = ACTIONS(3064),
    [anon_sym_static_assert] = ACTIONS(3064),
    [anon_sym_concept] = ACTIONS(3064),
    [anon_sym_co_return] = ACTIONS(3064),
    [anon_sym_co_yield] = ACTIONS(3064),
    [anon_sym_R_DQUOTE] = ACTIONS(3066),
    [anon_sym_LR_DQUOTE] = ACTIONS(3066),
    [anon_sym_uR_DQUOTE] = ACTIONS(3066),
    [anon_sym_UR_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3066),
    [anon_sym_co_await] = ACTIONS(3064),
    [anon_sym_new] = ACTIONS(3064),
    [anon_sym_requires] = ACTIONS(3064),
    [sym_this] = ACTIONS(3064),
  },
  [768] = {
    [sym_identifier] = ACTIONS(3108),
    [aux_sym_preproc_include_token1] = ACTIONS(3108),
    [aux_sym_preproc_def_token1] = ACTIONS(3108),
    [aux_sym_preproc_if_token1] = ACTIONS(3108),
    [aux_sym_preproc_if_token2] = ACTIONS(3108),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3108),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3108),
    [sym_preproc_directive] = ACTIONS(3108),
    [anon_sym_LPAREN2] = ACTIONS(3110),
    [anon_sym_BANG] = ACTIONS(3110),
    [anon_sym_TILDE] = ACTIONS(3110),
    [anon_sym_DASH] = ACTIONS(3108),
    [anon_sym_PLUS] = ACTIONS(3108),
    [anon_sym_STAR] = ACTIONS(3110),
    [anon_sym_AMP_AMP] = ACTIONS(3110),
    [anon_sym_AMP] = ACTIONS(3108),
    [anon_sym_SEMI] = ACTIONS(3110),
    [anon_sym___extension__] = ACTIONS(3108),
    [anon_sym_typedef] = ACTIONS(3108),
    [anon_sym_extern] = ACTIONS(3108),
    [anon_sym___attribute__] = ACTIONS(3108),
    [anon_sym_COLON_COLON] = ACTIONS(3110),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3110),
    [anon_sym___declspec] = ACTIONS(3108),
    [anon_sym___based] = ACTIONS(3108),
    [anon_sym___cdecl] = ACTIONS(3108),
    [anon_sym___clrcall] = ACTIONS(3108),
    [anon_sym___stdcall] = ACTIONS(3108),
    [anon_sym___fastcall] = ACTIONS(3108),
    [anon_sym___thiscall] = ACTIONS(3108),
    [anon_sym___vectorcall] = ACTIONS(3108),
    [anon_sym_LBRACE] = ACTIONS(3110),
    [anon_sym_signed] = ACTIONS(3108),
    [anon_sym_unsigned] = ACTIONS(3108),
    [anon_sym_long] = ACTIONS(3108),
    [anon_sym_short] = ACTIONS(3108),
    [anon_sym_LBRACK] = ACTIONS(3108),
    [anon_sym_static] = ACTIONS(3108),
    [anon_sym_register] = ACTIONS(3108),
    [anon_sym_inline] = ACTIONS(3108),
    [anon_sym___inline] = ACTIONS(3108),
    [anon_sym___inline__] = ACTIONS(3108),
    [anon_sym___forceinline] = ACTIONS(3108),
    [anon_sym_thread_local] = ACTIONS(3108),
    [anon_sym___thread] = ACTIONS(3108),
    [anon_sym_const] = ACTIONS(3108),
    [anon_sym_constexpr] = ACTIONS(3108),
    [anon_sym_volatile] = ACTIONS(3108),
    [anon_sym_restrict] = ACTIONS(3108),
    [anon_sym___restrict__] = ACTIONS(3108),
    [anon_sym__Atomic] = ACTIONS(3108),
    [anon_sym__Noreturn] = ACTIONS(3108),
    [anon_sym_noreturn] = ACTIONS(3108),
    [anon_sym_mutable] = ACTIONS(3108),
    [anon_sym_constinit] = ACTIONS(3108),
    [anon_sym_consteval] = ACTIONS(3108),
    [anon_sym_PROGMEM] = ACTIONS(3108),
    [aux_sym_primitive_type_token1] = ACTIONS(3108),
    [anon_sym_byte] = ACTIONS(3108),
    [anon_sym_word] = ACTIONS(3108),
    [anon_sym_enum] = ACTIONS(3108),
    [anon_sym_class] = ACTIONS(3108),
    [anon_sym_struct] = ACTIONS(3108),
    [anon_sym_union] = ACTIONS(3108),
    [anon_sym_if] = ACTIONS(3108),
    [anon_sym_else] = ACTIONS(3108),
    [anon_sym_switch] = ACTIONS(3108),
    [anon_sym_case] = ACTIONS(3108),
    [anon_sym_default] = ACTIONS(3108),
    [anon_sym_while] = ACTIONS(3108),
    [anon_sym_do] = ACTIONS(3108),
    [anon_sym_for] = ACTIONS(3108),
    [anon_sym_return] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3108),
    [anon_sym_continue] = ACTIONS(3108),
    [anon_sym_goto] = ACTIONS(3108),
    [anon_sym___try] = ACTIONS(3108),
    [anon_sym___leave] = ACTIONS(3108),
    [anon_sym_not] = ACTIONS(3108),
    [anon_sym_compl] = ACTIONS(3108),
    [anon_sym_DASH_DASH] = ACTIONS(3110),
    [anon_sym_PLUS_PLUS] = ACTIONS(3110),
    [anon_sym_sizeof] = ACTIONS(3108),
    [anon_sym___alignof__] = ACTIONS(3108),
    [anon_sym___alignof] = ACTIONS(3108),
    [anon_sym__alignof] = ACTIONS(3108),
    [anon_sym_alignof] = ACTIONS(3108),
    [anon_sym__Alignof] = ACTIONS(3108),
    [anon_sym_offsetof] = ACTIONS(3108),
    [anon_sym__Generic] = ACTIONS(3108),
    [anon_sym_asm] = ACTIONS(3108),
    [anon_sym___asm__] = ACTIONS(3108),
    [aux_sym_number_literal_token1] = ACTIONS(3110),
    [aux_sym_number_literal_token2] = ACTIONS(3108),
    [anon_sym_L_SQUOTE] = ACTIONS(3110),
    [anon_sym_u_SQUOTE] = ACTIONS(3110),
    [anon_sym_U_SQUOTE] = ACTIONS(3110),
    [anon_sym_u8_SQUOTE] = ACTIONS(3110),
    [anon_sym_SQUOTE] = ACTIONS(3110),
    [anon_sym_L_DQUOTE] = ACTIONS(3110),
    [anon_sym_u_DQUOTE] = ACTIONS(3110),
    [anon_sym_U_DQUOTE] = ACTIONS(3110),
    [anon_sym_u8_DQUOTE] = ACTIONS(3110),
    [anon_sym_DQUOTE] = ACTIONS(3110),
    [sym_true] = ACTIONS(3108),
    [sym_false] = ACTIONS(3108),
    [anon_sym_NULL] = ACTIONS(3108),
    [anon_sym_nullptr] = ACTIONS(3108),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3108),
    [anon_sym_decltype] = ACTIONS(3108),
    [anon_sym_virtual] = ACTIONS(3108),
    [anon_sym_alignas] = ACTIONS(3108),
    [anon_sym_explicit] = ACTIONS(3108),
    [anon_sym_typename] = ACTIONS(3108),
    [anon_sym_template] = ACTIONS(3108),
    [anon_sym_operator] = ACTIONS(3108),
    [anon_sym_try] = ACTIONS(3108),
    [anon_sym_delete] = ACTIONS(3108),
    [anon_sym_throw] = ACTIONS(3108),
    [anon_sym_namespace] = ACTIONS(3108),
    [anon_sym_using] = ACTIONS(3108),
    [anon_sym_static_assert] = ACTIONS(3108),
    [anon_sym_concept] = ACTIONS(3108),
    [anon_sym_co_return] = ACTIONS(3108),
    [anon_sym_co_yield] = ACTIONS(3108),
    [anon_sym_R_DQUOTE] = ACTIONS(3110),
    [anon_sym_LR_DQUOTE] = ACTIONS(3110),
    [anon_sym_uR_DQUOTE] = ACTIONS(3110),
    [anon_sym_UR_DQUOTE] = ACTIONS(3110),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3110),
    [anon_sym_co_await] = ACTIONS(3108),
    [anon_sym_new] = ACTIONS(3108),
    [anon_sym_requires] = ACTIONS(3108),
    [sym_this] = ACTIONS(3108),
  },
  [769] = {
    [sym_identifier] = ACTIONS(2946),
    [aux_sym_preproc_include_token1] = ACTIONS(2946),
    [aux_sym_preproc_def_token1] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2946),
    [sym_preproc_directive] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym___based] = ACTIONS(2946),
    [anon_sym___cdecl] = ACTIONS(2946),
    [anon_sym___clrcall] = ACTIONS(2946),
    [anon_sym___stdcall] = ACTIONS(2946),
    [anon_sym___fastcall] = ACTIONS(2946),
    [anon_sym___thiscall] = ACTIONS(2946),
    [anon_sym___vectorcall] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_explicit] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_using] = ACTIONS(2946),
    [anon_sym_static_assert] = ACTIONS(2946),
    [anon_sym_concept] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [770] = {
    [sym_preproc_def] = STATE(1002),
    [sym_preproc_function_def] = STATE(1002),
    [sym_preproc_call] = STATE(1002),
    [sym_preproc_if_in_field_declaration_list] = STATE(1002),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1002),
    [sym_preproc_else_in_field_declaration_list] = STATE(9441),
    [sym_preproc_elif_in_field_declaration_list] = STATE(9441),
    [sym_type_definition] = STATE(1002),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6507),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7114),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1002),
    [sym_field_declaration] = STATE(1002),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2150),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1002),
    [sym_operator_cast] = STATE(7493),
    [sym_inline_method_definition] = STATE(1002),
    [sym__constructor_specifiers] = STATE(2150),
    [sym_operator_cast_definition] = STATE(1002),
    [sym_operator_cast_declaration] = STATE(1002),
    [sym_constructor_or_destructor_definition] = STATE(1002),
    [sym_constructor_or_destructor_declaration] = STATE(1002),
    [sym_friend_declaration] = STATE(1002),
    [sym_access_specifier] = STATE(9075),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1002),
    [sym_alias_declaration] = STATE(1002),
    [sym_static_assert_declaration] = STATE(1002),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7493),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1002),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2150),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3563),
    [aux_sym_preproc_if_token1] = ACTIONS(3565),
    [aux_sym_preproc_if_token2] = ACTIONS(3567),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3569),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3569),
    [aux_sym_preproc_else_token1] = ACTIONS(3206),
    [aux_sym_preproc_elif_token1] = ACTIONS(3208),
    [sym_preproc_directive] = ACTIONS(3571),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3573),
    [anon_sym_typedef] = ACTIONS(3575),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3577),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3579),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3581),
    [anon_sym_static_assert] = ACTIONS(3583),
  },
  [771] = {
    [sym_preproc_def] = STATE(849),
    [sym_preproc_function_def] = STATE(849),
    [sym_preproc_call] = STATE(849),
    [sym_preproc_if_in_field_declaration_list] = STATE(849),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(849),
    [sym_preproc_else_in_field_declaration_list] = STATE(9442),
    [sym_preproc_elif_in_field_declaration_list] = STATE(9442),
    [sym_type_definition] = STATE(849),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6507),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7114),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(849),
    [sym_field_declaration] = STATE(849),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2150),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(849),
    [sym_operator_cast] = STATE(7493),
    [sym_inline_method_definition] = STATE(849),
    [sym__constructor_specifiers] = STATE(2150),
    [sym_operator_cast_definition] = STATE(849),
    [sym_operator_cast_declaration] = STATE(849),
    [sym_constructor_or_destructor_definition] = STATE(849),
    [sym_constructor_or_destructor_declaration] = STATE(849),
    [sym_friend_declaration] = STATE(849),
    [sym_access_specifier] = STATE(9075),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(849),
    [sym_alias_declaration] = STATE(849),
    [sym_static_assert_declaration] = STATE(849),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7493),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(849),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2150),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3563),
    [aux_sym_preproc_if_token1] = ACTIONS(3565),
    [aux_sym_preproc_if_token2] = ACTIONS(3585),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3569),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3569),
    [aux_sym_preproc_else_token1] = ACTIONS(3206),
    [aux_sym_preproc_elif_token1] = ACTIONS(3208),
    [sym_preproc_directive] = ACTIONS(3571),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3573),
    [anon_sym_typedef] = ACTIONS(3575),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3577),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3579),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3581),
    [anon_sym_static_assert] = ACTIONS(3583),
  },
  [772] = {
    [sym_identifier] = ACTIONS(2962),
    [aux_sym_preproc_include_token1] = ACTIONS(2962),
    [aux_sym_preproc_def_token1] = ACTIONS(2962),
    [aux_sym_preproc_if_token1] = ACTIONS(2962),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2962),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2962),
    [sym_preproc_directive] = ACTIONS(2962),
    [anon_sym_LPAREN2] = ACTIONS(2964),
    [anon_sym_BANG] = ACTIONS(2964),
    [anon_sym_TILDE] = ACTIONS(2964),
    [anon_sym_DASH] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_STAR] = ACTIONS(2964),
    [anon_sym_AMP_AMP] = ACTIONS(2964),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_SEMI] = ACTIONS(2964),
    [anon_sym___extension__] = ACTIONS(2962),
    [anon_sym_typedef] = ACTIONS(2962),
    [anon_sym_extern] = ACTIONS(2962),
    [anon_sym___attribute__] = ACTIONS(2962),
    [anon_sym_COLON_COLON] = ACTIONS(2964),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2964),
    [anon_sym___declspec] = ACTIONS(2962),
    [anon_sym___based] = ACTIONS(2962),
    [anon_sym___cdecl] = ACTIONS(2962),
    [anon_sym___clrcall] = ACTIONS(2962),
    [anon_sym___stdcall] = ACTIONS(2962),
    [anon_sym___fastcall] = ACTIONS(2962),
    [anon_sym___thiscall] = ACTIONS(2962),
    [anon_sym___vectorcall] = ACTIONS(2962),
    [anon_sym_LBRACE] = ACTIONS(2964),
    [anon_sym_RBRACE] = ACTIONS(2964),
    [anon_sym_signed] = ACTIONS(2962),
    [anon_sym_unsigned] = ACTIONS(2962),
    [anon_sym_long] = ACTIONS(2962),
    [anon_sym_short] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_static] = ACTIONS(2962),
    [anon_sym_register] = ACTIONS(2962),
    [anon_sym_inline] = ACTIONS(2962),
    [anon_sym___inline] = ACTIONS(2962),
    [anon_sym___inline__] = ACTIONS(2962),
    [anon_sym___forceinline] = ACTIONS(2962),
    [anon_sym_thread_local] = ACTIONS(2962),
    [anon_sym___thread] = ACTIONS(2962),
    [anon_sym_const] = ACTIONS(2962),
    [anon_sym_constexpr] = ACTIONS(2962),
    [anon_sym_volatile] = ACTIONS(2962),
    [anon_sym_restrict] = ACTIONS(2962),
    [anon_sym___restrict__] = ACTIONS(2962),
    [anon_sym__Atomic] = ACTIONS(2962),
    [anon_sym__Noreturn] = ACTIONS(2962),
    [anon_sym_noreturn] = ACTIONS(2962),
    [anon_sym_mutable] = ACTIONS(2962),
    [anon_sym_constinit] = ACTIONS(2962),
    [anon_sym_consteval] = ACTIONS(2962),
    [anon_sym_PROGMEM] = ACTIONS(2962),
    [aux_sym_primitive_type_token1] = ACTIONS(2962),
    [anon_sym_byte] = ACTIONS(2962),
    [anon_sym_word] = ACTIONS(2962),
    [anon_sym_enum] = ACTIONS(2962),
    [anon_sym_class] = ACTIONS(2962),
    [anon_sym_struct] = ACTIONS(2962),
    [anon_sym_union] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_else] = ACTIONS(2962),
    [anon_sym_switch] = ACTIONS(2962),
    [anon_sym_case] = ACTIONS(2962),
    [anon_sym_default] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_for] = ACTIONS(2962),
    [anon_sym_return] = ACTIONS(2962),
    [anon_sym_break] = ACTIONS(2962),
    [anon_sym_continue] = ACTIONS(2962),
    [anon_sym_goto] = ACTIONS(2962),
    [anon_sym___try] = ACTIONS(2962),
    [anon_sym___leave] = ACTIONS(2962),
    [anon_sym_not] = ACTIONS(2962),
    [anon_sym_compl] = ACTIONS(2962),
    [anon_sym_DASH_DASH] = ACTIONS(2964),
    [anon_sym_PLUS_PLUS] = ACTIONS(2964),
    [anon_sym_sizeof] = ACTIONS(2962),
    [anon_sym___alignof__] = ACTIONS(2962),
    [anon_sym___alignof] = ACTIONS(2962),
    [anon_sym__alignof] = ACTIONS(2962),
    [anon_sym_alignof] = ACTIONS(2962),
    [anon_sym__Alignof] = ACTIONS(2962),
    [anon_sym_offsetof] = ACTIONS(2962),
    [anon_sym__Generic] = ACTIONS(2962),
    [anon_sym_asm] = ACTIONS(2962),
    [anon_sym___asm__] = ACTIONS(2962),
    [aux_sym_number_literal_token1] = ACTIONS(2964),
    [aux_sym_number_literal_token2] = ACTIONS(2962),
    [anon_sym_L_SQUOTE] = ACTIONS(2964),
    [anon_sym_u_SQUOTE] = ACTIONS(2964),
    [anon_sym_U_SQUOTE] = ACTIONS(2964),
    [anon_sym_u8_SQUOTE] = ACTIONS(2964),
    [anon_sym_SQUOTE] = ACTIONS(2964),
    [anon_sym_L_DQUOTE] = ACTIONS(2964),
    [anon_sym_u_DQUOTE] = ACTIONS(2964),
    [anon_sym_U_DQUOTE] = ACTIONS(2964),
    [anon_sym_u8_DQUOTE] = ACTIONS(2964),
    [anon_sym_DQUOTE] = ACTIONS(2964),
    [sym_true] = ACTIONS(2962),
    [sym_false] = ACTIONS(2962),
    [anon_sym_NULL] = ACTIONS(2962),
    [anon_sym_nullptr] = ACTIONS(2962),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2962),
    [anon_sym_decltype] = ACTIONS(2962),
    [anon_sym_virtual] = ACTIONS(2962),
    [anon_sym_alignas] = ACTIONS(2962),
    [anon_sym_explicit] = ACTIONS(2962),
    [anon_sym_typename] = ACTIONS(2962),
    [anon_sym_template] = ACTIONS(2962),
    [anon_sym_operator] = ACTIONS(2962),
    [anon_sym_try] = ACTIONS(2962),
    [anon_sym_delete] = ACTIONS(2962),
    [anon_sym_throw] = ACTIONS(2962),
    [anon_sym_namespace] = ACTIONS(2962),
    [anon_sym_using] = ACTIONS(2962),
    [anon_sym_static_assert] = ACTIONS(2962),
    [anon_sym_concept] = ACTIONS(2962),
    [anon_sym_co_return] = ACTIONS(2962),
    [anon_sym_co_yield] = ACTIONS(2962),
    [anon_sym_R_DQUOTE] = ACTIONS(2964),
    [anon_sym_LR_DQUOTE] = ACTIONS(2964),
    [anon_sym_uR_DQUOTE] = ACTIONS(2964),
    [anon_sym_UR_DQUOTE] = ACTIONS(2964),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2964),
    [anon_sym_co_await] = ACTIONS(2962),
    [anon_sym_new] = ACTIONS(2962),
    [anon_sym_requires] = ACTIONS(2962),
    [sym_this] = ACTIONS(2962),
  },
  [773] = {
    [sym_identifier] = ACTIONS(2954),
    [aux_sym_preproc_include_token1] = ACTIONS(2954),
    [aux_sym_preproc_def_token1] = ACTIONS(2954),
    [aux_sym_preproc_if_token1] = ACTIONS(2954),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2954),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2954),
    [sym_preproc_directive] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2956),
    [anon_sym_BANG] = ACTIONS(2956),
    [anon_sym_TILDE] = ACTIONS(2956),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_STAR] = ACTIONS(2956),
    [anon_sym_AMP_AMP] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2954),
    [anon_sym_SEMI] = ACTIONS(2956),
    [anon_sym___extension__] = ACTIONS(2954),
    [anon_sym_typedef] = ACTIONS(2954),
    [anon_sym_extern] = ACTIONS(2954),
    [anon_sym___attribute__] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2956),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2956),
    [anon_sym___declspec] = ACTIONS(2954),
    [anon_sym___based] = ACTIONS(2954),
    [anon_sym___cdecl] = ACTIONS(2954),
    [anon_sym___clrcall] = ACTIONS(2954),
    [anon_sym___stdcall] = ACTIONS(2954),
    [anon_sym___fastcall] = ACTIONS(2954),
    [anon_sym___thiscall] = ACTIONS(2954),
    [anon_sym___vectorcall] = ACTIONS(2954),
    [anon_sym_LBRACE] = ACTIONS(2956),
    [anon_sym_RBRACE] = ACTIONS(2956),
    [anon_sym_signed] = ACTIONS(2954),
    [anon_sym_unsigned] = ACTIONS(2954),
    [anon_sym_long] = ACTIONS(2954),
    [anon_sym_short] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_static] = ACTIONS(2954),
    [anon_sym_register] = ACTIONS(2954),
    [anon_sym_inline] = ACTIONS(2954),
    [anon_sym___inline] = ACTIONS(2954),
    [anon_sym___inline__] = ACTIONS(2954),
    [anon_sym___forceinline] = ACTIONS(2954),
    [anon_sym_thread_local] = ACTIONS(2954),
    [anon_sym___thread] = ACTIONS(2954),
    [anon_sym_const] = ACTIONS(2954),
    [anon_sym_constexpr] = ACTIONS(2954),
    [anon_sym_volatile] = ACTIONS(2954),
    [anon_sym_restrict] = ACTIONS(2954),
    [anon_sym___restrict__] = ACTIONS(2954),
    [anon_sym__Atomic] = ACTIONS(2954),
    [anon_sym__Noreturn] = ACTIONS(2954),
    [anon_sym_noreturn] = ACTIONS(2954),
    [anon_sym_mutable] = ACTIONS(2954),
    [anon_sym_constinit] = ACTIONS(2954),
    [anon_sym_consteval] = ACTIONS(2954),
    [anon_sym_PROGMEM] = ACTIONS(2954),
    [aux_sym_primitive_type_token1] = ACTIONS(2954),
    [anon_sym_byte] = ACTIONS(2954),
    [anon_sym_word] = ACTIONS(2954),
    [anon_sym_enum] = ACTIONS(2954),
    [anon_sym_class] = ACTIONS(2954),
    [anon_sym_struct] = ACTIONS(2954),
    [anon_sym_union] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_else] = ACTIONS(2954),
    [anon_sym_switch] = ACTIONS(2954),
    [anon_sym_case] = ACTIONS(2954),
    [anon_sym_default] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_break] = ACTIONS(2954),
    [anon_sym_continue] = ACTIONS(2954),
    [anon_sym_goto] = ACTIONS(2954),
    [anon_sym___try] = ACTIONS(2954),
    [anon_sym___leave] = ACTIONS(2954),
    [anon_sym_not] = ACTIONS(2954),
    [anon_sym_compl] = ACTIONS(2954),
    [anon_sym_DASH_DASH] = ACTIONS(2956),
    [anon_sym_PLUS_PLUS] = ACTIONS(2956),
    [anon_sym_sizeof] = ACTIONS(2954),
    [anon_sym___alignof__] = ACTIONS(2954),
    [anon_sym___alignof] = ACTIONS(2954),
    [anon_sym__alignof] = ACTIONS(2954),
    [anon_sym_alignof] = ACTIONS(2954),
    [anon_sym__Alignof] = ACTIONS(2954),
    [anon_sym_offsetof] = ACTIONS(2954),
    [anon_sym__Generic] = ACTIONS(2954),
    [anon_sym_asm] = ACTIONS(2954),
    [anon_sym___asm__] = ACTIONS(2954),
    [aux_sym_number_literal_token1] = ACTIONS(2956),
    [aux_sym_number_literal_token2] = ACTIONS(2954),
    [anon_sym_L_SQUOTE] = ACTIONS(2956),
    [anon_sym_u_SQUOTE] = ACTIONS(2956),
    [anon_sym_U_SQUOTE] = ACTIONS(2956),
    [anon_sym_u8_SQUOTE] = ACTIONS(2956),
    [anon_sym_SQUOTE] = ACTIONS(2956),
    [anon_sym_L_DQUOTE] = ACTIONS(2956),
    [anon_sym_u_DQUOTE] = ACTIONS(2956),
    [anon_sym_U_DQUOTE] = ACTIONS(2956),
    [anon_sym_u8_DQUOTE] = ACTIONS(2956),
    [anon_sym_DQUOTE] = ACTIONS(2956),
    [sym_true] = ACTIONS(2954),
    [sym_false] = ACTIONS(2954),
    [anon_sym_NULL] = ACTIONS(2954),
    [anon_sym_nullptr] = ACTIONS(2954),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2954),
    [anon_sym_decltype] = ACTIONS(2954),
    [anon_sym_virtual] = ACTIONS(2954),
    [anon_sym_alignas] = ACTIONS(2954),
    [anon_sym_explicit] = ACTIONS(2954),
    [anon_sym_typename] = ACTIONS(2954),
    [anon_sym_template] = ACTIONS(2954),
    [anon_sym_operator] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_delete] = ACTIONS(2954),
    [anon_sym_throw] = ACTIONS(2954),
    [anon_sym_namespace] = ACTIONS(2954),
    [anon_sym_using] = ACTIONS(2954),
    [anon_sym_static_assert] = ACTIONS(2954),
    [anon_sym_concept] = ACTIONS(2954),
    [anon_sym_co_return] = ACTIONS(2954),
    [anon_sym_co_yield] = ACTIONS(2954),
    [anon_sym_R_DQUOTE] = ACTIONS(2956),
    [anon_sym_LR_DQUOTE] = ACTIONS(2956),
    [anon_sym_uR_DQUOTE] = ACTIONS(2956),
    [anon_sym_UR_DQUOTE] = ACTIONS(2956),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2956),
    [anon_sym_co_await] = ACTIONS(2954),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_requires] = ACTIONS(2954),
    [sym_this] = ACTIONS(2954),
  },
  [774] = {
    [sym_identifier] = ACTIONS(2950),
    [aux_sym_preproc_include_token1] = ACTIONS(2950),
    [aux_sym_preproc_def_token1] = ACTIONS(2950),
    [aux_sym_preproc_if_token1] = ACTIONS(2950),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2950),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2950),
    [sym_preproc_directive] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2952),
    [anon_sym_BANG] = ACTIONS(2952),
    [anon_sym_TILDE] = ACTIONS(2952),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_STAR] = ACTIONS(2952),
    [anon_sym_AMP_AMP] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_SEMI] = ACTIONS(2952),
    [anon_sym___extension__] = ACTIONS(2950),
    [anon_sym_typedef] = ACTIONS(2950),
    [anon_sym_extern] = ACTIONS(2950),
    [anon_sym___attribute__] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2952),
    [anon_sym___declspec] = ACTIONS(2950),
    [anon_sym___based] = ACTIONS(2950),
    [anon_sym___cdecl] = ACTIONS(2950),
    [anon_sym___clrcall] = ACTIONS(2950),
    [anon_sym___stdcall] = ACTIONS(2950),
    [anon_sym___fastcall] = ACTIONS(2950),
    [anon_sym___thiscall] = ACTIONS(2950),
    [anon_sym___vectorcall] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2952),
    [anon_sym_RBRACE] = ACTIONS(2952),
    [anon_sym_signed] = ACTIONS(2950),
    [anon_sym_unsigned] = ACTIONS(2950),
    [anon_sym_long] = ACTIONS(2950),
    [anon_sym_short] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_static] = ACTIONS(2950),
    [anon_sym_register] = ACTIONS(2950),
    [anon_sym_inline] = ACTIONS(2950),
    [anon_sym___inline] = ACTIONS(2950),
    [anon_sym___inline__] = ACTIONS(2950),
    [anon_sym___forceinline] = ACTIONS(2950),
    [anon_sym_thread_local] = ACTIONS(2950),
    [anon_sym___thread] = ACTIONS(2950),
    [anon_sym_const] = ACTIONS(2950),
    [anon_sym_constexpr] = ACTIONS(2950),
    [anon_sym_volatile] = ACTIONS(2950),
    [anon_sym_restrict] = ACTIONS(2950),
    [anon_sym___restrict__] = ACTIONS(2950),
    [anon_sym__Atomic] = ACTIONS(2950),
    [anon_sym__Noreturn] = ACTIONS(2950),
    [anon_sym_noreturn] = ACTIONS(2950),
    [anon_sym_mutable] = ACTIONS(2950),
    [anon_sym_constinit] = ACTIONS(2950),
    [anon_sym_consteval] = ACTIONS(2950),
    [anon_sym_PROGMEM] = ACTIONS(2950),
    [aux_sym_primitive_type_token1] = ACTIONS(2950),
    [anon_sym_byte] = ACTIONS(2950),
    [anon_sym_word] = ACTIONS(2950),
    [anon_sym_enum] = ACTIONS(2950),
    [anon_sym_class] = ACTIONS(2950),
    [anon_sym_struct] = ACTIONS(2950),
    [anon_sym_union] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_else] = ACTIONS(2950),
    [anon_sym_switch] = ACTIONS(2950),
    [anon_sym_case] = ACTIONS(2950),
    [anon_sym_default] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_break] = ACTIONS(2950),
    [anon_sym_continue] = ACTIONS(2950),
    [anon_sym_goto] = ACTIONS(2950),
    [anon_sym___try] = ACTIONS(2950),
    [anon_sym___leave] = ACTIONS(2950),
    [anon_sym_not] = ACTIONS(2950),
    [anon_sym_compl] = ACTIONS(2950),
    [anon_sym_DASH_DASH] = ACTIONS(2952),
    [anon_sym_PLUS_PLUS] = ACTIONS(2952),
    [anon_sym_sizeof] = ACTIONS(2950),
    [anon_sym___alignof__] = ACTIONS(2950),
    [anon_sym___alignof] = ACTIONS(2950),
    [anon_sym__alignof] = ACTIONS(2950),
    [anon_sym_alignof] = ACTIONS(2950),
    [anon_sym__Alignof] = ACTIONS(2950),
    [anon_sym_offsetof] = ACTIONS(2950),
    [anon_sym__Generic] = ACTIONS(2950),
    [anon_sym_asm] = ACTIONS(2950),
    [anon_sym___asm__] = ACTIONS(2950),
    [aux_sym_number_literal_token1] = ACTIONS(2952),
    [aux_sym_number_literal_token2] = ACTIONS(2950),
    [anon_sym_L_SQUOTE] = ACTIONS(2952),
    [anon_sym_u_SQUOTE] = ACTIONS(2952),
    [anon_sym_U_SQUOTE] = ACTIONS(2952),
    [anon_sym_u8_SQUOTE] = ACTIONS(2952),
    [anon_sym_SQUOTE] = ACTIONS(2952),
    [anon_sym_L_DQUOTE] = ACTIONS(2952),
    [anon_sym_u_DQUOTE] = ACTIONS(2952),
    [anon_sym_U_DQUOTE] = ACTIONS(2952),
    [anon_sym_u8_DQUOTE] = ACTIONS(2952),
    [anon_sym_DQUOTE] = ACTIONS(2952),
    [sym_true] = ACTIONS(2950),
    [sym_false] = ACTIONS(2950),
    [anon_sym_NULL] = ACTIONS(2950),
    [anon_sym_nullptr] = ACTIONS(2950),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2950),
    [anon_sym_decltype] = ACTIONS(2950),
    [anon_sym_virtual] = ACTIONS(2950),
    [anon_sym_alignas] = ACTIONS(2950),
    [anon_sym_explicit] = ACTIONS(2950),
    [anon_sym_typename] = ACTIONS(2950),
    [anon_sym_template] = ACTIONS(2950),
    [anon_sym_operator] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_delete] = ACTIONS(2950),
    [anon_sym_throw] = ACTIONS(2950),
    [anon_sym_namespace] = ACTIONS(2950),
    [anon_sym_using] = ACTIONS(2950),
    [anon_sym_static_assert] = ACTIONS(2950),
    [anon_sym_concept] = ACTIONS(2950),
    [anon_sym_co_return] = ACTIONS(2950),
    [anon_sym_co_yield] = ACTIONS(2950),
    [anon_sym_R_DQUOTE] = ACTIONS(2952),
    [anon_sym_LR_DQUOTE] = ACTIONS(2952),
    [anon_sym_uR_DQUOTE] = ACTIONS(2952),
    [anon_sym_UR_DQUOTE] = ACTIONS(2952),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2952),
    [anon_sym_co_await] = ACTIONS(2950),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_requires] = ACTIONS(2950),
    [sym_this] = ACTIONS(2950),
  },
  [775] = {
    [sym_identifier] = ACTIONS(3058),
    [aux_sym_preproc_include_token1] = ACTIONS(3058),
    [aux_sym_preproc_def_token1] = ACTIONS(3058),
    [aux_sym_preproc_if_token1] = ACTIONS(3058),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3058),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3058),
    [sym_preproc_directive] = ACTIONS(3058),
    [anon_sym_LPAREN2] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3060),
    [anon_sym_TILDE] = ACTIONS(3060),
    [anon_sym_DASH] = ACTIONS(3058),
    [anon_sym_PLUS] = ACTIONS(3058),
    [anon_sym_STAR] = ACTIONS(3060),
    [anon_sym_AMP_AMP] = ACTIONS(3060),
    [anon_sym_AMP] = ACTIONS(3058),
    [anon_sym_SEMI] = ACTIONS(3060),
    [anon_sym___extension__] = ACTIONS(3058),
    [anon_sym_typedef] = ACTIONS(3058),
    [anon_sym_extern] = ACTIONS(3058),
    [anon_sym___attribute__] = ACTIONS(3058),
    [anon_sym_COLON_COLON] = ACTIONS(3060),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3060),
    [anon_sym___declspec] = ACTIONS(3058),
    [anon_sym___based] = ACTIONS(3058),
    [anon_sym___cdecl] = ACTIONS(3058),
    [anon_sym___clrcall] = ACTIONS(3058),
    [anon_sym___stdcall] = ACTIONS(3058),
    [anon_sym___fastcall] = ACTIONS(3058),
    [anon_sym___thiscall] = ACTIONS(3058),
    [anon_sym___vectorcall] = ACTIONS(3058),
    [anon_sym_LBRACE] = ACTIONS(3060),
    [anon_sym_RBRACE] = ACTIONS(3060),
    [anon_sym_signed] = ACTIONS(3058),
    [anon_sym_unsigned] = ACTIONS(3058),
    [anon_sym_long] = ACTIONS(3058),
    [anon_sym_short] = ACTIONS(3058),
    [anon_sym_LBRACK] = ACTIONS(3058),
    [anon_sym_static] = ACTIONS(3058),
    [anon_sym_register] = ACTIONS(3058),
    [anon_sym_inline] = ACTIONS(3058),
    [anon_sym___inline] = ACTIONS(3058),
    [anon_sym___inline__] = ACTIONS(3058),
    [anon_sym___forceinline] = ACTIONS(3058),
    [anon_sym_thread_local] = ACTIONS(3058),
    [anon_sym___thread] = ACTIONS(3058),
    [anon_sym_const] = ACTIONS(3058),
    [anon_sym_constexpr] = ACTIONS(3058),
    [anon_sym_volatile] = ACTIONS(3058),
    [anon_sym_restrict] = ACTIONS(3058),
    [anon_sym___restrict__] = ACTIONS(3058),
    [anon_sym__Atomic] = ACTIONS(3058),
    [anon_sym__Noreturn] = ACTIONS(3058),
    [anon_sym_noreturn] = ACTIONS(3058),
    [anon_sym_mutable] = ACTIONS(3058),
    [anon_sym_constinit] = ACTIONS(3058),
    [anon_sym_consteval] = ACTIONS(3058),
    [anon_sym_PROGMEM] = ACTIONS(3058),
    [aux_sym_primitive_type_token1] = ACTIONS(3058),
    [anon_sym_byte] = ACTIONS(3058),
    [anon_sym_word] = ACTIONS(3058),
    [anon_sym_enum] = ACTIONS(3058),
    [anon_sym_class] = ACTIONS(3058),
    [anon_sym_struct] = ACTIONS(3058),
    [anon_sym_union] = ACTIONS(3058),
    [anon_sym_if] = ACTIONS(3058),
    [anon_sym_else] = ACTIONS(3058),
    [anon_sym_switch] = ACTIONS(3058),
    [anon_sym_case] = ACTIONS(3058),
    [anon_sym_default] = ACTIONS(3058),
    [anon_sym_while] = ACTIONS(3058),
    [anon_sym_do] = ACTIONS(3058),
    [anon_sym_for] = ACTIONS(3058),
    [anon_sym_return] = ACTIONS(3058),
    [anon_sym_break] = ACTIONS(3058),
    [anon_sym_continue] = ACTIONS(3058),
    [anon_sym_goto] = ACTIONS(3058),
    [anon_sym___try] = ACTIONS(3058),
    [anon_sym___leave] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3058),
    [anon_sym_compl] = ACTIONS(3058),
    [anon_sym_DASH_DASH] = ACTIONS(3060),
    [anon_sym_PLUS_PLUS] = ACTIONS(3060),
    [anon_sym_sizeof] = ACTIONS(3058),
    [anon_sym___alignof__] = ACTIONS(3058),
    [anon_sym___alignof] = ACTIONS(3058),
    [anon_sym__alignof] = ACTIONS(3058),
    [anon_sym_alignof] = ACTIONS(3058),
    [anon_sym__Alignof] = ACTIONS(3058),
    [anon_sym_offsetof] = ACTIONS(3058),
    [anon_sym__Generic] = ACTIONS(3058),
    [anon_sym_asm] = ACTIONS(3058),
    [anon_sym___asm__] = ACTIONS(3058),
    [aux_sym_number_literal_token1] = ACTIONS(3060),
    [aux_sym_number_literal_token2] = ACTIONS(3058),
    [anon_sym_L_SQUOTE] = ACTIONS(3060),
    [anon_sym_u_SQUOTE] = ACTIONS(3060),
    [anon_sym_U_SQUOTE] = ACTIONS(3060),
    [anon_sym_u8_SQUOTE] = ACTIONS(3060),
    [anon_sym_SQUOTE] = ACTIONS(3060),
    [anon_sym_L_DQUOTE] = ACTIONS(3060),
    [anon_sym_u_DQUOTE] = ACTIONS(3060),
    [anon_sym_U_DQUOTE] = ACTIONS(3060),
    [anon_sym_u8_DQUOTE] = ACTIONS(3060),
    [anon_sym_DQUOTE] = ACTIONS(3060),
    [sym_true] = ACTIONS(3058),
    [sym_false] = ACTIONS(3058),
    [anon_sym_NULL] = ACTIONS(3058),
    [anon_sym_nullptr] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3058),
    [anon_sym_decltype] = ACTIONS(3058),
    [anon_sym_virtual] = ACTIONS(3058),
    [anon_sym_alignas] = ACTIONS(3058),
    [anon_sym_explicit] = ACTIONS(3058),
    [anon_sym_typename] = ACTIONS(3058),
    [anon_sym_template] = ACTIONS(3058),
    [anon_sym_operator] = ACTIONS(3058),
    [anon_sym_try] = ACTIONS(3058),
    [anon_sym_delete] = ACTIONS(3058),
    [anon_sym_throw] = ACTIONS(3058),
    [anon_sym_namespace] = ACTIONS(3058),
    [anon_sym_using] = ACTIONS(3058),
    [anon_sym_static_assert] = ACTIONS(3058),
    [anon_sym_concept] = ACTIONS(3058),
    [anon_sym_co_return] = ACTIONS(3058),
    [anon_sym_co_yield] = ACTIONS(3058),
    [anon_sym_R_DQUOTE] = ACTIONS(3060),
    [anon_sym_LR_DQUOTE] = ACTIONS(3060),
    [anon_sym_uR_DQUOTE] = ACTIONS(3060),
    [anon_sym_UR_DQUOTE] = ACTIONS(3060),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3060),
    [anon_sym_co_await] = ACTIONS(3058),
    [anon_sym_new] = ACTIONS(3058),
    [anon_sym_requires] = ACTIONS(3058),
    [sym_this] = ACTIONS(3058),
  },
  [776] = {
    [sym_preproc_def] = STATE(770),
    [sym_preproc_function_def] = STATE(770),
    [sym_preproc_call] = STATE(770),
    [sym_preproc_if_in_field_declaration_list] = STATE(770),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(770),
    [sym_preproc_else_in_field_declaration_list] = STATE(9321),
    [sym_preproc_elif_in_field_declaration_list] = STATE(9321),
    [sym_type_definition] = STATE(770),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6507),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7114),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(770),
    [sym_field_declaration] = STATE(770),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2150),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(770),
    [sym_operator_cast] = STATE(7493),
    [sym_inline_method_definition] = STATE(770),
    [sym__constructor_specifiers] = STATE(2150),
    [sym_operator_cast_definition] = STATE(770),
    [sym_operator_cast_declaration] = STATE(770),
    [sym_constructor_or_destructor_definition] = STATE(770),
    [sym_constructor_or_destructor_declaration] = STATE(770),
    [sym_friend_declaration] = STATE(770),
    [sym_access_specifier] = STATE(9075),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(770),
    [sym_alias_declaration] = STATE(770),
    [sym_static_assert_declaration] = STATE(770),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7493),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(770),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2150),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3563),
    [aux_sym_preproc_if_token1] = ACTIONS(3565),
    [aux_sym_preproc_if_token2] = ACTIONS(3587),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3569),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3569),
    [aux_sym_preproc_else_token1] = ACTIONS(3206),
    [aux_sym_preproc_elif_token1] = ACTIONS(3208),
    [sym_preproc_directive] = ACTIONS(3571),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3573),
    [anon_sym_typedef] = ACTIONS(3575),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3577),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3579),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3581),
    [anon_sym_static_assert] = ACTIONS(3583),
  },
  [777] = {
    [ts_builtin_sym_end] = ACTIONS(3098),
    [sym_identifier] = ACTIONS(3096),
    [aux_sym_preproc_include_token1] = ACTIONS(3096),
    [aux_sym_preproc_def_token1] = ACTIONS(3096),
    [aux_sym_preproc_if_token1] = ACTIONS(3096),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3096),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3096),
    [sym_preproc_directive] = ACTIONS(3096),
    [anon_sym_LPAREN2] = ACTIONS(3098),
    [anon_sym_BANG] = ACTIONS(3098),
    [anon_sym_TILDE] = ACTIONS(3098),
    [anon_sym_DASH] = ACTIONS(3096),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_STAR] = ACTIONS(3098),
    [anon_sym_AMP_AMP] = ACTIONS(3098),
    [anon_sym_AMP] = ACTIONS(3096),
    [anon_sym_SEMI] = ACTIONS(3098),
    [anon_sym___extension__] = ACTIONS(3096),
    [anon_sym_typedef] = ACTIONS(3096),
    [anon_sym_extern] = ACTIONS(3096),
    [anon_sym___attribute__] = ACTIONS(3096),
    [anon_sym_COLON_COLON] = ACTIONS(3098),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3098),
    [anon_sym___declspec] = ACTIONS(3096),
    [anon_sym___based] = ACTIONS(3096),
    [anon_sym___cdecl] = ACTIONS(3096),
    [anon_sym___clrcall] = ACTIONS(3096),
    [anon_sym___stdcall] = ACTIONS(3096),
    [anon_sym___fastcall] = ACTIONS(3096),
    [anon_sym___thiscall] = ACTIONS(3096),
    [anon_sym___vectorcall] = ACTIONS(3096),
    [anon_sym_LBRACE] = ACTIONS(3098),
    [anon_sym_signed] = ACTIONS(3096),
    [anon_sym_unsigned] = ACTIONS(3096),
    [anon_sym_long] = ACTIONS(3096),
    [anon_sym_short] = ACTIONS(3096),
    [anon_sym_LBRACK] = ACTIONS(3096),
    [anon_sym_static] = ACTIONS(3096),
    [anon_sym_register] = ACTIONS(3096),
    [anon_sym_inline] = ACTIONS(3096),
    [anon_sym___inline] = ACTIONS(3096),
    [anon_sym___inline__] = ACTIONS(3096),
    [anon_sym___forceinline] = ACTIONS(3096),
    [anon_sym_thread_local] = ACTIONS(3096),
    [anon_sym___thread] = ACTIONS(3096),
    [anon_sym_const] = ACTIONS(3096),
    [anon_sym_constexpr] = ACTIONS(3096),
    [anon_sym_volatile] = ACTIONS(3096),
    [anon_sym_restrict] = ACTIONS(3096),
    [anon_sym___restrict__] = ACTIONS(3096),
    [anon_sym__Atomic] = ACTIONS(3096),
    [anon_sym__Noreturn] = ACTIONS(3096),
    [anon_sym_noreturn] = ACTIONS(3096),
    [anon_sym_mutable] = ACTIONS(3096),
    [anon_sym_constinit] = ACTIONS(3096),
    [anon_sym_consteval] = ACTIONS(3096),
    [anon_sym_PROGMEM] = ACTIONS(3096),
    [aux_sym_primitive_type_token1] = ACTIONS(3096),
    [anon_sym_byte] = ACTIONS(3096),
    [anon_sym_word] = ACTIONS(3096),
    [anon_sym_enum] = ACTIONS(3096),
    [anon_sym_class] = ACTIONS(3096),
    [anon_sym_struct] = ACTIONS(3096),
    [anon_sym_union] = ACTIONS(3096),
    [anon_sym_if] = ACTIONS(3096),
    [anon_sym_else] = ACTIONS(3096),
    [anon_sym_switch] = ACTIONS(3096),
    [anon_sym_case] = ACTIONS(3096),
    [anon_sym_default] = ACTIONS(3096),
    [anon_sym_while] = ACTIONS(3096),
    [anon_sym_do] = ACTIONS(3096),
    [anon_sym_for] = ACTIONS(3096),
    [anon_sym_return] = ACTIONS(3096),
    [anon_sym_break] = ACTIONS(3096),
    [anon_sym_continue] = ACTIONS(3096),
    [anon_sym_goto] = ACTIONS(3096),
    [anon_sym___try] = ACTIONS(3096),
    [anon_sym___leave] = ACTIONS(3096),
    [anon_sym_not] = ACTIONS(3096),
    [anon_sym_compl] = ACTIONS(3096),
    [anon_sym_DASH_DASH] = ACTIONS(3098),
    [anon_sym_PLUS_PLUS] = ACTIONS(3098),
    [anon_sym_sizeof] = ACTIONS(3096),
    [anon_sym___alignof__] = ACTIONS(3096),
    [anon_sym___alignof] = ACTIONS(3096),
    [anon_sym__alignof] = ACTIONS(3096),
    [anon_sym_alignof] = ACTIONS(3096),
    [anon_sym__Alignof] = ACTIONS(3096),
    [anon_sym_offsetof] = ACTIONS(3096),
    [anon_sym__Generic] = ACTIONS(3096),
    [anon_sym_asm] = ACTIONS(3096),
    [anon_sym___asm__] = ACTIONS(3096),
    [aux_sym_number_literal_token1] = ACTIONS(3098),
    [aux_sym_number_literal_token2] = ACTIONS(3096),
    [anon_sym_L_SQUOTE] = ACTIONS(3098),
    [anon_sym_u_SQUOTE] = ACTIONS(3098),
    [anon_sym_U_SQUOTE] = ACTIONS(3098),
    [anon_sym_u8_SQUOTE] = ACTIONS(3098),
    [anon_sym_SQUOTE] = ACTIONS(3098),
    [anon_sym_L_DQUOTE] = ACTIONS(3098),
    [anon_sym_u_DQUOTE] = ACTIONS(3098),
    [anon_sym_U_DQUOTE] = ACTIONS(3098),
    [anon_sym_u8_DQUOTE] = ACTIONS(3098),
    [anon_sym_DQUOTE] = ACTIONS(3098),
    [sym_true] = ACTIONS(3096),
    [sym_false] = ACTIONS(3096),
    [anon_sym_NULL] = ACTIONS(3096),
    [anon_sym_nullptr] = ACTIONS(3096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3096),
    [anon_sym_decltype] = ACTIONS(3096),
    [anon_sym_virtual] = ACTIONS(3096),
    [anon_sym_alignas] = ACTIONS(3096),
    [anon_sym_explicit] = ACTIONS(3096),
    [anon_sym_typename] = ACTIONS(3096),
    [anon_sym_template] = ACTIONS(3096),
    [anon_sym_operator] = ACTIONS(3096),
    [anon_sym_try] = ACTIONS(3096),
    [anon_sym_delete] = ACTIONS(3096),
    [anon_sym_throw] = ACTIONS(3096),
    [anon_sym_namespace] = ACTIONS(3096),
    [anon_sym_using] = ACTIONS(3096),
    [anon_sym_static_assert] = ACTIONS(3096),
    [anon_sym_concept] = ACTIONS(3096),
    [anon_sym_co_return] = ACTIONS(3096),
    [anon_sym_co_yield] = ACTIONS(3096),
    [anon_sym_R_DQUOTE] = ACTIONS(3098),
    [anon_sym_LR_DQUOTE] = ACTIONS(3098),
    [anon_sym_uR_DQUOTE] = ACTIONS(3098),
    [anon_sym_UR_DQUOTE] = ACTIONS(3098),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3098),
    [anon_sym_co_await] = ACTIONS(3096),
    [anon_sym_new] = ACTIONS(3096),
    [anon_sym_requires] = ACTIONS(3096),
    [sym_this] = ACTIONS(3096),
  },
  [778] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [779] = {
    [sym_identifier] = ACTIONS(3128),
    [aux_sym_preproc_include_token1] = ACTIONS(3128),
    [aux_sym_preproc_def_token1] = ACTIONS(3128),
    [aux_sym_preproc_if_token1] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3128),
    [sym_preproc_directive] = ACTIONS(3128),
    [anon_sym_LPAREN2] = ACTIONS(3130),
    [anon_sym_BANG] = ACTIONS(3130),
    [anon_sym_TILDE] = ACTIONS(3130),
    [anon_sym_DASH] = ACTIONS(3128),
    [anon_sym_PLUS] = ACTIONS(3128),
    [anon_sym_STAR] = ACTIONS(3130),
    [anon_sym_AMP_AMP] = ACTIONS(3130),
    [anon_sym_AMP] = ACTIONS(3128),
    [anon_sym_SEMI] = ACTIONS(3130),
    [anon_sym___extension__] = ACTIONS(3128),
    [anon_sym_typedef] = ACTIONS(3128),
    [anon_sym_extern] = ACTIONS(3128),
    [anon_sym___attribute__] = ACTIONS(3128),
    [anon_sym_COLON_COLON] = ACTIONS(3130),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3130),
    [anon_sym___declspec] = ACTIONS(3128),
    [anon_sym___based] = ACTIONS(3128),
    [anon_sym___cdecl] = ACTIONS(3128),
    [anon_sym___clrcall] = ACTIONS(3128),
    [anon_sym___stdcall] = ACTIONS(3128),
    [anon_sym___fastcall] = ACTIONS(3128),
    [anon_sym___thiscall] = ACTIONS(3128),
    [anon_sym___vectorcall] = ACTIONS(3128),
    [anon_sym_LBRACE] = ACTIONS(3130),
    [anon_sym_RBRACE] = ACTIONS(3130),
    [anon_sym_signed] = ACTIONS(3128),
    [anon_sym_unsigned] = ACTIONS(3128),
    [anon_sym_long] = ACTIONS(3128),
    [anon_sym_short] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3128),
    [anon_sym_static] = ACTIONS(3128),
    [anon_sym_register] = ACTIONS(3128),
    [anon_sym_inline] = ACTIONS(3128),
    [anon_sym___inline] = ACTIONS(3128),
    [anon_sym___inline__] = ACTIONS(3128),
    [anon_sym___forceinline] = ACTIONS(3128),
    [anon_sym_thread_local] = ACTIONS(3128),
    [anon_sym___thread] = ACTIONS(3128),
    [anon_sym_const] = ACTIONS(3128),
    [anon_sym_constexpr] = ACTIONS(3128),
    [anon_sym_volatile] = ACTIONS(3128),
    [anon_sym_restrict] = ACTIONS(3128),
    [anon_sym___restrict__] = ACTIONS(3128),
    [anon_sym__Atomic] = ACTIONS(3128),
    [anon_sym__Noreturn] = ACTIONS(3128),
    [anon_sym_noreturn] = ACTIONS(3128),
    [anon_sym_mutable] = ACTIONS(3128),
    [anon_sym_constinit] = ACTIONS(3128),
    [anon_sym_consteval] = ACTIONS(3128),
    [anon_sym_PROGMEM] = ACTIONS(3128),
    [aux_sym_primitive_type_token1] = ACTIONS(3128),
    [anon_sym_byte] = ACTIONS(3128),
    [anon_sym_word] = ACTIONS(3128),
    [anon_sym_enum] = ACTIONS(3128),
    [anon_sym_class] = ACTIONS(3128),
    [anon_sym_struct] = ACTIONS(3128),
    [anon_sym_union] = ACTIONS(3128),
    [anon_sym_if] = ACTIONS(3128),
    [anon_sym_else] = ACTIONS(3128),
    [anon_sym_switch] = ACTIONS(3128),
    [anon_sym_case] = ACTIONS(3128),
    [anon_sym_default] = ACTIONS(3128),
    [anon_sym_while] = ACTIONS(3128),
    [anon_sym_do] = ACTIONS(3128),
    [anon_sym_for] = ACTIONS(3128),
    [anon_sym_return] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3128),
    [anon_sym_continue] = ACTIONS(3128),
    [anon_sym_goto] = ACTIONS(3128),
    [anon_sym___try] = ACTIONS(3128),
    [anon_sym___leave] = ACTIONS(3128),
    [anon_sym_not] = ACTIONS(3128),
    [anon_sym_compl] = ACTIONS(3128),
    [anon_sym_DASH_DASH] = ACTIONS(3130),
    [anon_sym_PLUS_PLUS] = ACTIONS(3130),
    [anon_sym_sizeof] = ACTIONS(3128),
    [anon_sym___alignof__] = ACTIONS(3128),
    [anon_sym___alignof] = ACTIONS(3128),
    [anon_sym__alignof] = ACTIONS(3128),
    [anon_sym_alignof] = ACTIONS(3128),
    [anon_sym__Alignof] = ACTIONS(3128),
    [anon_sym_offsetof] = ACTIONS(3128),
    [anon_sym__Generic] = ACTIONS(3128),
    [anon_sym_asm] = ACTIONS(3128),
    [anon_sym___asm__] = ACTIONS(3128),
    [aux_sym_number_literal_token1] = ACTIONS(3130),
    [aux_sym_number_literal_token2] = ACTIONS(3128),
    [anon_sym_L_SQUOTE] = ACTIONS(3130),
    [anon_sym_u_SQUOTE] = ACTIONS(3130),
    [anon_sym_U_SQUOTE] = ACTIONS(3130),
    [anon_sym_u8_SQUOTE] = ACTIONS(3130),
    [anon_sym_SQUOTE] = ACTIONS(3130),
    [anon_sym_L_DQUOTE] = ACTIONS(3130),
    [anon_sym_u_DQUOTE] = ACTIONS(3130),
    [anon_sym_U_DQUOTE] = ACTIONS(3130),
    [anon_sym_u8_DQUOTE] = ACTIONS(3130),
    [anon_sym_DQUOTE] = ACTIONS(3130),
    [sym_true] = ACTIONS(3128),
    [sym_false] = ACTIONS(3128),
    [anon_sym_NULL] = ACTIONS(3128),
    [anon_sym_nullptr] = ACTIONS(3128),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3128),
    [anon_sym_decltype] = ACTIONS(3128),
    [anon_sym_virtual] = ACTIONS(3128),
    [anon_sym_alignas] = ACTIONS(3128),
    [anon_sym_explicit] = ACTIONS(3128),
    [anon_sym_typename] = ACTIONS(3128),
    [anon_sym_template] = ACTIONS(3128),
    [anon_sym_operator] = ACTIONS(3128),
    [anon_sym_try] = ACTIONS(3128),
    [anon_sym_delete] = ACTIONS(3128),
    [anon_sym_throw] = ACTIONS(3128),
    [anon_sym_namespace] = ACTIONS(3128),
    [anon_sym_using] = ACTIONS(3128),
    [anon_sym_static_assert] = ACTIONS(3128),
    [anon_sym_concept] = ACTIONS(3128),
    [anon_sym_co_return] = ACTIONS(3128),
    [anon_sym_co_yield] = ACTIONS(3128),
    [anon_sym_R_DQUOTE] = ACTIONS(3130),
    [anon_sym_LR_DQUOTE] = ACTIONS(3130),
    [anon_sym_uR_DQUOTE] = ACTIONS(3130),
    [anon_sym_UR_DQUOTE] = ACTIONS(3130),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3130),
    [anon_sym_co_await] = ACTIONS(3128),
    [anon_sym_new] = ACTIONS(3128),
    [anon_sym_requires] = ACTIONS(3128),
    [sym_this] = ACTIONS(3128),
  },
  [780] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [781] = {
    [sym_identifier] = ACTIONS(3096),
    [aux_sym_preproc_include_token1] = ACTIONS(3096),
    [aux_sym_preproc_def_token1] = ACTIONS(3096),
    [aux_sym_preproc_if_token1] = ACTIONS(3096),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3096),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3096),
    [sym_preproc_directive] = ACTIONS(3096),
    [anon_sym_LPAREN2] = ACTIONS(3098),
    [anon_sym_BANG] = ACTIONS(3098),
    [anon_sym_TILDE] = ACTIONS(3098),
    [anon_sym_DASH] = ACTIONS(3096),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_STAR] = ACTIONS(3098),
    [anon_sym_AMP_AMP] = ACTIONS(3098),
    [anon_sym_AMP] = ACTIONS(3096),
    [anon_sym_SEMI] = ACTIONS(3098),
    [anon_sym___extension__] = ACTIONS(3096),
    [anon_sym_typedef] = ACTIONS(3096),
    [anon_sym_extern] = ACTIONS(3096),
    [anon_sym___attribute__] = ACTIONS(3096),
    [anon_sym_COLON_COLON] = ACTIONS(3098),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3098),
    [anon_sym___declspec] = ACTIONS(3096),
    [anon_sym___based] = ACTIONS(3096),
    [anon_sym___cdecl] = ACTIONS(3096),
    [anon_sym___clrcall] = ACTIONS(3096),
    [anon_sym___stdcall] = ACTIONS(3096),
    [anon_sym___fastcall] = ACTIONS(3096),
    [anon_sym___thiscall] = ACTIONS(3096),
    [anon_sym___vectorcall] = ACTIONS(3096),
    [anon_sym_LBRACE] = ACTIONS(3098),
    [anon_sym_RBRACE] = ACTIONS(3098),
    [anon_sym_signed] = ACTIONS(3096),
    [anon_sym_unsigned] = ACTIONS(3096),
    [anon_sym_long] = ACTIONS(3096),
    [anon_sym_short] = ACTIONS(3096),
    [anon_sym_LBRACK] = ACTIONS(3096),
    [anon_sym_static] = ACTIONS(3096),
    [anon_sym_register] = ACTIONS(3096),
    [anon_sym_inline] = ACTIONS(3096),
    [anon_sym___inline] = ACTIONS(3096),
    [anon_sym___inline__] = ACTIONS(3096),
    [anon_sym___forceinline] = ACTIONS(3096),
    [anon_sym_thread_local] = ACTIONS(3096),
    [anon_sym___thread] = ACTIONS(3096),
    [anon_sym_const] = ACTIONS(3096),
    [anon_sym_constexpr] = ACTIONS(3096),
    [anon_sym_volatile] = ACTIONS(3096),
    [anon_sym_restrict] = ACTIONS(3096),
    [anon_sym___restrict__] = ACTIONS(3096),
    [anon_sym__Atomic] = ACTIONS(3096),
    [anon_sym__Noreturn] = ACTIONS(3096),
    [anon_sym_noreturn] = ACTIONS(3096),
    [anon_sym_mutable] = ACTIONS(3096),
    [anon_sym_constinit] = ACTIONS(3096),
    [anon_sym_consteval] = ACTIONS(3096),
    [anon_sym_PROGMEM] = ACTIONS(3096),
    [aux_sym_primitive_type_token1] = ACTIONS(3096),
    [anon_sym_byte] = ACTIONS(3096),
    [anon_sym_word] = ACTIONS(3096),
    [anon_sym_enum] = ACTIONS(3096),
    [anon_sym_class] = ACTIONS(3096),
    [anon_sym_struct] = ACTIONS(3096),
    [anon_sym_union] = ACTIONS(3096),
    [anon_sym_if] = ACTIONS(3096),
    [anon_sym_else] = ACTIONS(3096),
    [anon_sym_switch] = ACTIONS(3096),
    [anon_sym_case] = ACTIONS(3096),
    [anon_sym_default] = ACTIONS(3096),
    [anon_sym_while] = ACTIONS(3096),
    [anon_sym_do] = ACTIONS(3096),
    [anon_sym_for] = ACTIONS(3096),
    [anon_sym_return] = ACTIONS(3096),
    [anon_sym_break] = ACTIONS(3096),
    [anon_sym_continue] = ACTIONS(3096),
    [anon_sym_goto] = ACTIONS(3096),
    [anon_sym___try] = ACTIONS(3096),
    [anon_sym___leave] = ACTIONS(3096),
    [anon_sym_not] = ACTIONS(3096),
    [anon_sym_compl] = ACTIONS(3096),
    [anon_sym_DASH_DASH] = ACTIONS(3098),
    [anon_sym_PLUS_PLUS] = ACTIONS(3098),
    [anon_sym_sizeof] = ACTIONS(3096),
    [anon_sym___alignof__] = ACTIONS(3096),
    [anon_sym___alignof] = ACTIONS(3096),
    [anon_sym__alignof] = ACTIONS(3096),
    [anon_sym_alignof] = ACTIONS(3096),
    [anon_sym__Alignof] = ACTIONS(3096),
    [anon_sym_offsetof] = ACTIONS(3096),
    [anon_sym__Generic] = ACTIONS(3096),
    [anon_sym_asm] = ACTIONS(3096),
    [anon_sym___asm__] = ACTIONS(3096),
    [aux_sym_number_literal_token1] = ACTIONS(3098),
    [aux_sym_number_literal_token2] = ACTIONS(3096),
    [anon_sym_L_SQUOTE] = ACTIONS(3098),
    [anon_sym_u_SQUOTE] = ACTIONS(3098),
    [anon_sym_U_SQUOTE] = ACTIONS(3098),
    [anon_sym_u8_SQUOTE] = ACTIONS(3098),
    [anon_sym_SQUOTE] = ACTIONS(3098),
    [anon_sym_L_DQUOTE] = ACTIONS(3098),
    [anon_sym_u_DQUOTE] = ACTIONS(3098),
    [anon_sym_U_DQUOTE] = ACTIONS(3098),
    [anon_sym_u8_DQUOTE] = ACTIONS(3098),
    [anon_sym_DQUOTE] = ACTIONS(3098),
    [sym_true] = ACTIONS(3096),
    [sym_false] = ACTIONS(3096),
    [anon_sym_NULL] = ACTIONS(3096),
    [anon_sym_nullptr] = ACTIONS(3096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3096),
    [anon_sym_decltype] = ACTIONS(3096),
    [anon_sym_virtual] = ACTIONS(3096),
    [anon_sym_alignas] = ACTIONS(3096),
    [anon_sym_explicit] = ACTIONS(3096),
    [anon_sym_typename] = ACTIONS(3096),
    [anon_sym_template] = ACTIONS(3096),
    [anon_sym_operator] = ACTIONS(3096),
    [anon_sym_try] = ACTIONS(3096),
    [anon_sym_delete] = ACTIONS(3096),
    [anon_sym_throw] = ACTIONS(3096),
    [anon_sym_namespace] = ACTIONS(3096),
    [anon_sym_using] = ACTIONS(3096),
    [anon_sym_static_assert] = ACTIONS(3096),
    [anon_sym_concept] = ACTIONS(3096),
    [anon_sym_co_return] = ACTIONS(3096),
    [anon_sym_co_yield] = ACTIONS(3096),
    [anon_sym_R_DQUOTE] = ACTIONS(3098),
    [anon_sym_LR_DQUOTE] = ACTIONS(3098),
    [anon_sym_uR_DQUOTE] = ACTIONS(3098),
    [anon_sym_UR_DQUOTE] = ACTIONS(3098),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3098),
    [anon_sym_co_await] = ACTIONS(3096),
    [anon_sym_new] = ACTIONS(3096),
    [anon_sym_requires] = ACTIONS(3096),
    [sym_this] = ACTIONS(3096),
  },
  [782] = {
    [ts_builtin_sym_end] = ACTIONS(3130),
    [sym_identifier] = ACTIONS(3128),
    [aux_sym_preproc_include_token1] = ACTIONS(3128),
    [aux_sym_preproc_def_token1] = ACTIONS(3128),
    [aux_sym_preproc_if_token1] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3128),
    [sym_preproc_directive] = ACTIONS(3128),
    [anon_sym_LPAREN2] = ACTIONS(3130),
    [anon_sym_BANG] = ACTIONS(3130),
    [anon_sym_TILDE] = ACTIONS(3130),
    [anon_sym_DASH] = ACTIONS(3128),
    [anon_sym_PLUS] = ACTIONS(3128),
    [anon_sym_STAR] = ACTIONS(3130),
    [anon_sym_AMP_AMP] = ACTIONS(3130),
    [anon_sym_AMP] = ACTIONS(3128),
    [anon_sym_SEMI] = ACTIONS(3130),
    [anon_sym___extension__] = ACTIONS(3128),
    [anon_sym_typedef] = ACTIONS(3128),
    [anon_sym_extern] = ACTIONS(3128),
    [anon_sym___attribute__] = ACTIONS(3128),
    [anon_sym_COLON_COLON] = ACTIONS(3130),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3130),
    [anon_sym___declspec] = ACTIONS(3128),
    [anon_sym___based] = ACTIONS(3128),
    [anon_sym___cdecl] = ACTIONS(3128),
    [anon_sym___clrcall] = ACTIONS(3128),
    [anon_sym___stdcall] = ACTIONS(3128),
    [anon_sym___fastcall] = ACTIONS(3128),
    [anon_sym___thiscall] = ACTIONS(3128),
    [anon_sym___vectorcall] = ACTIONS(3128),
    [anon_sym_LBRACE] = ACTIONS(3130),
    [anon_sym_signed] = ACTIONS(3128),
    [anon_sym_unsigned] = ACTIONS(3128),
    [anon_sym_long] = ACTIONS(3128),
    [anon_sym_short] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3128),
    [anon_sym_static] = ACTIONS(3128),
    [anon_sym_register] = ACTIONS(3128),
    [anon_sym_inline] = ACTIONS(3128),
    [anon_sym___inline] = ACTIONS(3128),
    [anon_sym___inline__] = ACTIONS(3128),
    [anon_sym___forceinline] = ACTIONS(3128),
    [anon_sym_thread_local] = ACTIONS(3128),
    [anon_sym___thread] = ACTIONS(3128),
    [anon_sym_const] = ACTIONS(3128),
    [anon_sym_constexpr] = ACTIONS(3128),
    [anon_sym_volatile] = ACTIONS(3128),
    [anon_sym_restrict] = ACTIONS(3128),
    [anon_sym___restrict__] = ACTIONS(3128),
    [anon_sym__Atomic] = ACTIONS(3128),
    [anon_sym__Noreturn] = ACTIONS(3128),
    [anon_sym_noreturn] = ACTIONS(3128),
    [anon_sym_mutable] = ACTIONS(3128),
    [anon_sym_constinit] = ACTIONS(3128),
    [anon_sym_consteval] = ACTIONS(3128),
    [anon_sym_PROGMEM] = ACTIONS(3128),
    [aux_sym_primitive_type_token1] = ACTIONS(3128),
    [anon_sym_byte] = ACTIONS(3128),
    [anon_sym_word] = ACTIONS(3128),
    [anon_sym_enum] = ACTIONS(3128),
    [anon_sym_class] = ACTIONS(3128),
    [anon_sym_struct] = ACTIONS(3128),
    [anon_sym_union] = ACTIONS(3128),
    [anon_sym_if] = ACTIONS(3128),
    [anon_sym_else] = ACTIONS(3128),
    [anon_sym_switch] = ACTIONS(3128),
    [anon_sym_case] = ACTIONS(3128),
    [anon_sym_default] = ACTIONS(3128),
    [anon_sym_while] = ACTIONS(3128),
    [anon_sym_do] = ACTIONS(3128),
    [anon_sym_for] = ACTIONS(3128),
    [anon_sym_return] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3128),
    [anon_sym_continue] = ACTIONS(3128),
    [anon_sym_goto] = ACTIONS(3128),
    [anon_sym___try] = ACTIONS(3128),
    [anon_sym___leave] = ACTIONS(3128),
    [anon_sym_not] = ACTIONS(3128),
    [anon_sym_compl] = ACTIONS(3128),
    [anon_sym_DASH_DASH] = ACTIONS(3130),
    [anon_sym_PLUS_PLUS] = ACTIONS(3130),
    [anon_sym_sizeof] = ACTIONS(3128),
    [anon_sym___alignof__] = ACTIONS(3128),
    [anon_sym___alignof] = ACTIONS(3128),
    [anon_sym__alignof] = ACTIONS(3128),
    [anon_sym_alignof] = ACTIONS(3128),
    [anon_sym__Alignof] = ACTIONS(3128),
    [anon_sym_offsetof] = ACTIONS(3128),
    [anon_sym__Generic] = ACTIONS(3128),
    [anon_sym_asm] = ACTIONS(3128),
    [anon_sym___asm__] = ACTIONS(3128),
    [aux_sym_number_literal_token1] = ACTIONS(3130),
    [aux_sym_number_literal_token2] = ACTIONS(3128),
    [anon_sym_L_SQUOTE] = ACTIONS(3130),
    [anon_sym_u_SQUOTE] = ACTIONS(3130),
    [anon_sym_U_SQUOTE] = ACTIONS(3130),
    [anon_sym_u8_SQUOTE] = ACTIONS(3130),
    [anon_sym_SQUOTE] = ACTIONS(3130),
    [anon_sym_L_DQUOTE] = ACTIONS(3130),
    [anon_sym_u_DQUOTE] = ACTIONS(3130),
    [anon_sym_U_DQUOTE] = ACTIONS(3130),
    [anon_sym_u8_DQUOTE] = ACTIONS(3130),
    [anon_sym_DQUOTE] = ACTIONS(3130),
    [sym_true] = ACTIONS(3128),
    [sym_false] = ACTIONS(3128),
    [anon_sym_NULL] = ACTIONS(3128),
    [anon_sym_nullptr] = ACTIONS(3128),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3128),
    [anon_sym_decltype] = ACTIONS(3128),
    [anon_sym_virtual] = ACTIONS(3128),
    [anon_sym_alignas] = ACTIONS(3128),
    [anon_sym_explicit] = ACTIONS(3128),
    [anon_sym_typename] = ACTIONS(3128),
    [anon_sym_template] = ACTIONS(3128),
    [anon_sym_operator] = ACTIONS(3128),
    [anon_sym_try] = ACTIONS(3128),
    [anon_sym_delete] = ACTIONS(3128),
    [anon_sym_throw] = ACTIONS(3128),
    [anon_sym_namespace] = ACTIONS(3128),
    [anon_sym_using] = ACTIONS(3128),
    [anon_sym_static_assert] = ACTIONS(3128),
    [anon_sym_concept] = ACTIONS(3128),
    [anon_sym_co_return] = ACTIONS(3128),
    [anon_sym_co_yield] = ACTIONS(3128),
    [anon_sym_R_DQUOTE] = ACTIONS(3130),
    [anon_sym_LR_DQUOTE] = ACTIONS(3130),
    [anon_sym_uR_DQUOTE] = ACTIONS(3130),
    [anon_sym_UR_DQUOTE] = ACTIONS(3130),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3130),
    [anon_sym_co_await] = ACTIONS(3128),
    [anon_sym_new] = ACTIONS(3128),
    [anon_sym_requires] = ACTIONS(3128),
    [sym_this] = ACTIONS(3128),
  },
  [783] = {
    [sym_identifier] = ACTIONS(2958),
    [aux_sym_preproc_include_token1] = ACTIONS(2958),
    [aux_sym_preproc_def_token1] = ACTIONS(2958),
    [aux_sym_preproc_if_token1] = ACTIONS(2958),
    [aux_sym_preproc_if_token2] = ACTIONS(2958),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2958),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2958),
    [sym_preproc_directive] = ACTIONS(2958),
    [anon_sym_LPAREN2] = ACTIONS(2960),
    [anon_sym_BANG] = ACTIONS(2960),
    [anon_sym_TILDE] = ACTIONS(2960),
    [anon_sym_DASH] = ACTIONS(2958),
    [anon_sym_PLUS] = ACTIONS(2958),
    [anon_sym_STAR] = ACTIONS(2960),
    [anon_sym_AMP_AMP] = ACTIONS(2960),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_SEMI] = ACTIONS(2960),
    [anon_sym___extension__] = ACTIONS(2958),
    [anon_sym_typedef] = ACTIONS(2958),
    [anon_sym_extern] = ACTIONS(2958),
    [anon_sym___attribute__] = ACTIONS(2958),
    [anon_sym_COLON_COLON] = ACTIONS(2960),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2960),
    [anon_sym___declspec] = ACTIONS(2958),
    [anon_sym___based] = ACTIONS(2958),
    [anon_sym___cdecl] = ACTIONS(2958),
    [anon_sym___clrcall] = ACTIONS(2958),
    [anon_sym___stdcall] = ACTIONS(2958),
    [anon_sym___fastcall] = ACTIONS(2958),
    [anon_sym___thiscall] = ACTIONS(2958),
    [anon_sym___vectorcall] = ACTIONS(2958),
    [anon_sym_LBRACE] = ACTIONS(2960),
    [anon_sym_signed] = ACTIONS(2958),
    [anon_sym_unsigned] = ACTIONS(2958),
    [anon_sym_long] = ACTIONS(2958),
    [anon_sym_short] = ACTIONS(2958),
    [anon_sym_LBRACK] = ACTIONS(2958),
    [anon_sym_static] = ACTIONS(2958),
    [anon_sym_register] = ACTIONS(2958),
    [anon_sym_inline] = ACTIONS(2958),
    [anon_sym___inline] = ACTIONS(2958),
    [anon_sym___inline__] = ACTIONS(2958),
    [anon_sym___forceinline] = ACTIONS(2958),
    [anon_sym_thread_local] = ACTIONS(2958),
    [anon_sym___thread] = ACTIONS(2958),
    [anon_sym_const] = ACTIONS(2958),
    [anon_sym_constexpr] = ACTIONS(2958),
    [anon_sym_volatile] = ACTIONS(2958),
    [anon_sym_restrict] = ACTIONS(2958),
    [anon_sym___restrict__] = ACTIONS(2958),
    [anon_sym__Atomic] = ACTIONS(2958),
    [anon_sym__Noreturn] = ACTIONS(2958),
    [anon_sym_noreturn] = ACTIONS(2958),
    [anon_sym_mutable] = ACTIONS(2958),
    [anon_sym_constinit] = ACTIONS(2958),
    [anon_sym_consteval] = ACTIONS(2958),
    [anon_sym_PROGMEM] = ACTIONS(2958),
    [aux_sym_primitive_type_token1] = ACTIONS(2958),
    [anon_sym_byte] = ACTIONS(2958),
    [anon_sym_word] = ACTIONS(2958),
    [anon_sym_enum] = ACTIONS(2958),
    [anon_sym_class] = ACTIONS(2958),
    [anon_sym_struct] = ACTIONS(2958),
    [anon_sym_union] = ACTIONS(2958),
    [anon_sym_if] = ACTIONS(2958),
    [anon_sym_else] = ACTIONS(2958),
    [anon_sym_switch] = ACTIONS(2958),
    [anon_sym_case] = ACTIONS(2958),
    [anon_sym_default] = ACTIONS(2958),
    [anon_sym_while] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2958),
    [anon_sym_for] = ACTIONS(2958),
    [anon_sym_return] = ACTIONS(2958),
    [anon_sym_break] = ACTIONS(2958),
    [anon_sym_continue] = ACTIONS(2958),
    [anon_sym_goto] = ACTIONS(2958),
    [anon_sym___try] = ACTIONS(2958),
    [anon_sym___leave] = ACTIONS(2958),
    [anon_sym_not] = ACTIONS(2958),
    [anon_sym_compl] = ACTIONS(2958),
    [anon_sym_DASH_DASH] = ACTIONS(2960),
    [anon_sym_PLUS_PLUS] = ACTIONS(2960),
    [anon_sym_sizeof] = ACTIONS(2958),
    [anon_sym___alignof__] = ACTIONS(2958),
    [anon_sym___alignof] = ACTIONS(2958),
    [anon_sym__alignof] = ACTIONS(2958),
    [anon_sym_alignof] = ACTIONS(2958),
    [anon_sym__Alignof] = ACTIONS(2958),
    [anon_sym_offsetof] = ACTIONS(2958),
    [anon_sym__Generic] = ACTIONS(2958),
    [anon_sym_asm] = ACTIONS(2958),
    [anon_sym___asm__] = ACTIONS(2958),
    [aux_sym_number_literal_token1] = ACTIONS(2960),
    [aux_sym_number_literal_token2] = ACTIONS(2958),
    [anon_sym_L_SQUOTE] = ACTIONS(2960),
    [anon_sym_u_SQUOTE] = ACTIONS(2960),
    [anon_sym_U_SQUOTE] = ACTIONS(2960),
    [anon_sym_u8_SQUOTE] = ACTIONS(2960),
    [anon_sym_SQUOTE] = ACTIONS(2960),
    [anon_sym_L_DQUOTE] = ACTIONS(2960),
    [anon_sym_u_DQUOTE] = ACTIONS(2960),
    [anon_sym_U_DQUOTE] = ACTIONS(2960),
    [anon_sym_u8_DQUOTE] = ACTIONS(2960),
    [anon_sym_DQUOTE] = ACTIONS(2960),
    [sym_true] = ACTIONS(2958),
    [sym_false] = ACTIONS(2958),
    [anon_sym_NULL] = ACTIONS(2958),
    [anon_sym_nullptr] = ACTIONS(2958),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2958),
    [anon_sym_decltype] = ACTIONS(2958),
    [anon_sym_virtual] = ACTIONS(2958),
    [anon_sym_alignas] = ACTIONS(2958),
    [anon_sym_explicit] = ACTIONS(2958),
    [anon_sym_typename] = ACTIONS(2958),
    [anon_sym_template] = ACTIONS(2958),
    [anon_sym_operator] = ACTIONS(2958),
    [anon_sym_try] = ACTIONS(2958),
    [anon_sym_delete] = ACTIONS(2958),
    [anon_sym_throw] = ACTIONS(2958),
    [anon_sym_namespace] = ACTIONS(2958),
    [anon_sym_using] = ACTIONS(2958),
    [anon_sym_static_assert] = ACTIONS(2958),
    [anon_sym_concept] = ACTIONS(2958),
    [anon_sym_co_return] = ACTIONS(2958),
    [anon_sym_co_yield] = ACTIONS(2958),
    [anon_sym_R_DQUOTE] = ACTIONS(2960),
    [anon_sym_LR_DQUOTE] = ACTIONS(2960),
    [anon_sym_uR_DQUOTE] = ACTIONS(2960),
    [anon_sym_UR_DQUOTE] = ACTIONS(2960),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2960),
    [anon_sym_co_await] = ACTIONS(2958),
    [anon_sym_new] = ACTIONS(2958),
    [anon_sym_requires] = ACTIONS(2958),
    [sym_this] = ACTIONS(2958),
  },
  [784] = {
    [ts_builtin_sym_end] = ACTIONS(3146),
    [sym_identifier] = ACTIONS(3144),
    [aux_sym_preproc_include_token1] = ACTIONS(3144),
    [aux_sym_preproc_def_token1] = ACTIONS(3144),
    [aux_sym_preproc_if_token1] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3144),
    [sym_preproc_directive] = ACTIONS(3144),
    [anon_sym_LPAREN2] = ACTIONS(3146),
    [anon_sym_BANG] = ACTIONS(3146),
    [anon_sym_TILDE] = ACTIONS(3146),
    [anon_sym_DASH] = ACTIONS(3144),
    [anon_sym_PLUS] = ACTIONS(3144),
    [anon_sym_STAR] = ACTIONS(3146),
    [anon_sym_AMP_AMP] = ACTIONS(3146),
    [anon_sym_AMP] = ACTIONS(3144),
    [anon_sym_SEMI] = ACTIONS(3146),
    [anon_sym___extension__] = ACTIONS(3144),
    [anon_sym_typedef] = ACTIONS(3144),
    [anon_sym_extern] = ACTIONS(3144),
    [anon_sym___attribute__] = ACTIONS(3144),
    [anon_sym_COLON_COLON] = ACTIONS(3146),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3146),
    [anon_sym___declspec] = ACTIONS(3144),
    [anon_sym___based] = ACTIONS(3144),
    [anon_sym___cdecl] = ACTIONS(3144),
    [anon_sym___clrcall] = ACTIONS(3144),
    [anon_sym___stdcall] = ACTIONS(3144),
    [anon_sym___fastcall] = ACTIONS(3144),
    [anon_sym___thiscall] = ACTIONS(3144),
    [anon_sym___vectorcall] = ACTIONS(3144),
    [anon_sym_LBRACE] = ACTIONS(3146),
    [anon_sym_signed] = ACTIONS(3144),
    [anon_sym_unsigned] = ACTIONS(3144),
    [anon_sym_long] = ACTIONS(3144),
    [anon_sym_short] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3144),
    [anon_sym_static] = ACTIONS(3144),
    [anon_sym_register] = ACTIONS(3144),
    [anon_sym_inline] = ACTIONS(3144),
    [anon_sym___inline] = ACTIONS(3144),
    [anon_sym___inline__] = ACTIONS(3144),
    [anon_sym___forceinline] = ACTIONS(3144),
    [anon_sym_thread_local] = ACTIONS(3144),
    [anon_sym___thread] = ACTIONS(3144),
    [anon_sym_const] = ACTIONS(3144),
    [anon_sym_constexpr] = ACTIONS(3144),
    [anon_sym_volatile] = ACTIONS(3144),
    [anon_sym_restrict] = ACTIONS(3144),
    [anon_sym___restrict__] = ACTIONS(3144),
    [anon_sym__Atomic] = ACTIONS(3144),
    [anon_sym__Noreturn] = ACTIONS(3144),
    [anon_sym_noreturn] = ACTIONS(3144),
    [anon_sym_mutable] = ACTIONS(3144),
    [anon_sym_constinit] = ACTIONS(3144),
    [anon_sym_consteval] = ACTIONS(3144),
    [anon_sym_PROGMEM] = ACTIONS(3144),
    [aux_sym_primitive_type_token1] = ACTIONS(3144),
    [anon_sym_byte] = ACTIONS(3144),
    [anon_sym_word] = ACTIONS(3144),
    [anon_sym_enum] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_struct] = ACTIONS(3144),
    [anon_sym_union] = ACTIONS(3144),
    [anon_sym_if] = ACTIONS(3144),
    [anon_sym_else] = ACTIONS(3144),
    [anon_sym_switch] = ACTIONS(3144),
    [anon_sym_case] = ACTIONS(3144),
    [anon_sym_default] = ACTIONS(3144),
    [anon_sym_while] = ACTIONS(3144),
    [anon_sym_do] = ACTIONS(3144),
    [anon_sym_for] = ACTIONS(3144),
    [anon_sym_return] = ACTIONS(3144),
    [anon_sym_break] = ACTIONS(3144),
    [anon_sym_continue] = ACTIONS(3144),
    [anon_sym_goto] = ACTIONS(3144),
    [anon_sym___try] = ACTIONS(3144),
    [anon_sym___leave] = ACTIONS(3144),
    [anon_sym_not] = ACTIONS(3144),
    [anon_sym_compl] = ACTIONS(3144),
    [anon_sym_DASH_DASH] = ACTIONS(3146),
    [anon_sym_PLUS_PLUS] = ACTIONS(3146),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3144),
    [anon_sym___alignof] = ACTIONS(3144),
    [anon_sym__alignof] = ACTIONS(3144),
    [anon_sym_alignof] = ACTIONS(3144),
    [anon_sym__Alignof] = ACTIONS(3144),
    [anon_sym_offsetof] = ACTIONS(3144),
    [anon_sym__Generic] = ACTIONS(3144),
    [anon_sym_asm] = ACTIONS(3144),
    [anon_sym___asm__] = ACTIONS(3144),
    [aux_sym_number_literal_token1] = ACTIONS(3146),
    [aux_sym_number_literal_token2] = ACTIONS(3144),
    [anon_sym_L_SQUOTE] = ACTIONS(3146),
    [anon_sym_u_SQUOTE] = ACTIONS(3146),
    [anon_sym_U_SQUOTE] = ACTIONS(3146),
    [anon_sym_u8_SQUOTE] = ACTIONS(3146),
    [anon_sym_SQUOTE] = ACTIONS(3146),
    [anon_sym_L_DQUOTE] = ACTIONS(3146),
    [anon_sym_u_DQUOTE] = ACTIONS(3146),
    [anon_sym_U_DQUOTE] = ACTIONS(3146),
    [anon_sym_u8_DQUOTE] = ACTIONS(3146),
    [anon_sym_DQUOTE] = ACTIONS(3146),
    [sym_true] = ACTIONS(3144),
    [sym_false] = ACTIONS(3144),
    [anon_sym_NULL] = ACTIONS(3144),
    [anon_sym_nullptr] = ACTIONS(3144),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3144),
    [anon_sym_decltype] = ACTIONS(3144),
    [anon_sym_virtual] = ACTIONS(3144),
    [anon_sym_alignas] = ACTIONS(3144),
    [anon_sym_explicit] = ACTIONS(3144),
    [anon_sym_typename] = ACTIONS(3144),
    [anon_sym_template] = ACTIONS(3144),
    [anon_sym_operator] = ACTIONS(3144),
    [anon_sym_try] = ACTIONS(3144),
    [anon_sym_delete] = ACTIONS(3144),
    [anon_sym_throw] = ACTIONS(3144),
    [anon_sym_namespace] = ACTIONS(3144),
    [anon_sym_using] = ACTIONS(3144),
    [anon_sym_static_assert] = ACTIONS(3144),
    [anon_sym_concept] = ACTIONS(3144),
    [anon_sym_co_return] = ACTIONS(3144),
    [anon_sym_co_yield] = ACTIONS(3144),
    [anon_sym_R_DQUOTE] = ACTIONS(3146),
    [anon_sym_LR_DQUOTE] = ACTIONS(3146),
    [anon_sym_uR_DQUOTE] = ACTIONS(3146),
    [anon_sym_UR_DQUOTE] = ACTIONS(3146),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3146),
    [anon_sym_co_await] = ACTIONS(3144),
    [anon_sym_new] = ACTIONS(3144),
    [anon_sym_requires] = ACTIONS(3144),
    [sym_this] = ACTIONS(3144),
  },
  [785] = {
    [sym_identifier] = ACTIONS(2927),
    [aux_sym_preproc_include_token1] = ACTIONS(2927),
    [aux_sym_preproc_def_token1] = ACTIONS(2927),
    [aux_sym_preproc_if_token1] = ACTIONS(2927),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2927),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2927),
    [sym_preproc_directive] = ACTIONS(2927),
    [anon_sym_LPAREN2] = ACTIONS(2932),
    [anon_sym_BANG] = ACTIONS(2932),
    [anon_sym_TILDE] = ACTIONS(2932),
    [anon_sym_DASH] = ACTIONS(2927),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2932),
    [anon_sym_AMP_AMP] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2927),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym___extension__] = ACTIONS(2927),
    [anon_sym_typedef] = ACTIONS(2927),
    [anon_sym_extern] = ACTIONS(2927),
    [anon_sym___attribute__] = ACTIONS(2927),
    [anon_sym_COLON_COLON] = ACTIONS(2932),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2932),
    [anon_sym___declspec] = ACTIONS(2927),
    [anon_sym___based] = ACTIONS(2927),
    [anon_sym___cdecl] = ACTIONS(2927),
    [anon_sym___clrcall] = ACTIONS(2927),
    [anon_sym___stdcall] = ACTIONS(2927),
    [anon_sym___fastcall] = ACTIONS(2927),
    [anon_sym___thiscall] = ACTIONS(2927),
    [anon_sym___vectorcall] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2932),
    [anon_sym_RBRACE] = ACTIONS(2932),
    [anon_sym_signed] = ACTIONS(2927),
    [anon_sym_unsigned] = ACTIONS(2927),
    [anon_sym_long] = ACTIONS(2927),
    [anon_sym_short] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_static] = ACTIONS(2927),
    [anon_sym_register] = ACTIONS(2927),
    [anon_sym_inline] = ACTIONS(2927),
    [anon_sym___inline] = ACTIONS(2927),
    [anon_sym___inline__] = ACTIONS(2927),
    [anon_sym___forceinline] = ACTIONS(2927),
    [anon_sym_thread_local] = ACTIONS(2927),
    [anon_sym___thread] = ACTIONS(2927),
    [anon_sym_const] = ACTIONS(2927),
    [anon_sym_constexpr] = ACTIONS(2927),
    [anon_sym_volatile] = ACTIONS(2927),
    [anon_sym_restrict] = ACTIONS(2927),
    [anon_sym___restrict__] = ACTIONS(2927),
    [anon_sym__Atomic] = ACTIONS(2927),
    [anon_sym__Noreturn] = ACTIONS(2927),
    [anon_sym_noreturn] = ACTIONS(2927),
    [anon_sym_mutable] = ACTIONS(2927),
    [anon_sym_constinit] = ACTIONS(2927),
    [anon_sym_consteval] = ACTIONS(2927),
    [anon_sym_PROGMEM] = ACTIONS(2927),
    [aux_sym_primitive_type_token1] = ACTIONS(2927),
    [anon_sym_byte] = ACTIONS(2927),
    [anon_sym_word] = ACTIONS(2927),
    [anon_sym_enum] = ACTIONS(2927),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_struct] = ACTIONS(2927),
    [anon_sym_union] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_else] = ACTIONS(2927),
    [anon_sym_switch] = ACTIONS(2927),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_default] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_goto] = ACTIONS(2927),
    [anon_sym___try] = ACTIONS(2927),
    [anon_sym___leave] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2927),
    [anon_sym_compl] = ACTIONS(2927),
    [anon_sym_DASH_DASH] = ACTIONS(2932),
    [anon_sym_PLUS_PLUS] = ACTIONS(2932),
    [anon_sym_sizeof] = ACTIONS(2927),
    [anon_sym___alignof__] = ACTIONS(2927),
    [anon_sym___alignof] = ACTIONS(2927),
    [anon_sym__alignof] = ACTIONS(2927),
    [anon_sym_alignof] = ACTIONS(2927),
    [anon_sym__Alignof] = ACTIONS(2927),
    [anon_sym_offsetof] = ACTIONS(2927),
    [anon_sym__Generic] = ACTIONS(2927),
    [anon_sym_asm] = ACTIONS(2927),
    [anon_sym___asm__] = ACTIONS(2927),
    [aux_sym_number_literal_token1] = ACTIONS(2932),
    [aux_sym_number_literal_token2] = ACTIONS(2927),
    [anon_sym_L_SQUOTE] = ACTIONS(2932),
    [anon_sym_u_SQUOTE] = ACTIONS(2932),
    [anon_sym_U_SQUOTE] = ACTIONS(2932),
    [anon_sym_u8_SQUOTE] = ACTIONS(2932),
    [anon_sym_SQUOTE] = ACTIONS(2932),
    [anon_sym_L_DQUOTE] = ACTIONS(2932),
    [anon_sym_u_DQUOTE] = ACTIONS(2932),
    [anon_sym_U_DQUOTE] = ACTIONS(2932),
    [anon_sym_u8_DQUOTE] = ACTIONS(2932),
    [anon_sym_DQUOTE] = ACTIONS(2932),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [anon_sym_NULL] = ACTIONS(2927),
    [anon_sym_nullptr] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2927),
    [anon_sym_decltype] = ACTIONS(2927),
    [anon_sym_virtual] = ACTIONS(2927),
    [anon_sym_alignas] = ACTIONS(2927),
    [anon_sym_explicit] = ACTIONS(2927),
    [anon_sym_typename] = ACTIONS(2927),
    [anon_sym_template] = ACTIONS(2927),
    [anon_sym_operator] = ACTIONS(2927),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_throw] = ACTIONS(2927),
    [anon_sym_namespace] = ACTIONS(2927),
    [anon_sym_using] = ACTIONS(2927),
    [anon_sym_static_assert] = ACTIONS(2927),
    [anon_sym_concept] = ACTIONS(2927),
    [anon_sym_co_return] = ACTIONS(2927),
    [anon_sym_co_yield] = ACTIONS(2927),
    [anon_sym_R_DQUOTE] = ACTIONS(2932),
    [anon_sym_LR_DQUOTE] = ACTIONS(2932),
    [anon_sym_uR_DQUOTE] = ACTIONS(2932),
    [anon_sym_UR_DQUOTE] = ACTIONS(2932),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2932),
    [anon_sym_co_await] = ACTIONS(2927),
    [anon_sym_new] = ACTIONS(2927),
    [anon_sym_requires] = ACTIONS(2927),
    [sym_this] = ACTIONS(2927),
  },
  [786] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [787] = {
    [ts_builtin_sym_end] = ACTIONS(3156),
    [sym_identifier] = ACTIONS(3154),
    [aux_sym_preproc_include_token1] = ACTIONS(3154),
    [aux_sym_preproc_def_token1] = ACTIONS(3154),
    [aux_sym_preproc_if_token1] = ACTIONS(3154),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3154),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3154),
    [sym_preproc_directive] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3156),
    [anon_sym_BANG] = ACTIONS(3156),
    [anon_sym_TILDE] = ACTIONS(3156),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_STAR] = ACTIONS(3156),
    [anon_sym_AMP_AMP] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3154),
    [anon_sym_SEMI] = ACTIONS(3156),
    [anon_sym___extension__] = ACTIONS(3154),
    [anon_sym_typedef] = ACTIONS(3154),
    [anon_sym_extern] = ACTIONS(3154),
    [anon_sym___attribute__] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3156),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3156),
    [anon_sym___declspec] = ACTIONS(3154),
    [anon_sym___based] = ACTIONS(3154),
    [anon_sym___cdecl] = ACTIONS(3154),
    [anon_sym___clrcall] = ACTIONS(3154),
    [anon_sym___stdcall] = ACTIONS(3154),
    [anon_sym___fastcall] = ACTIONS(3154),
    [anon_sym___thiscall] = ACTIONS(3154),
    [anon_sym___vectorcall] = ACTIONS(3154),
    [anon_sym_LBRACE] = ACTIONS(3156),
    [anon_sym_signed] = ACTIONS(3154),
    [anon_sym_unsigned] = ACTIONS(3154),
    [anon_sym_long] = ACTIONS(3154),
    [anon_sym_short] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_static] = ACTIONS(3154),
    [anon_sym_register] = ACTIONS(3154),
    [anon_sym_inline] = ACTIONS(3154),
    [anon_sym___inline] = ACTIONS(3154),
    [anon_sym___inline__] = ACTIONS(3154),
    [anon_sym___forceinline] = ACTIONS(3154),
    [anon_sym_thread_local] = ACTIONS(3154),
    [anon_sym___thread] = ACTIONS(3154),
    [anon_sym_const] = ACTIONS(3154),
    [anon_sym_constexpr] = ACTIONS(3154),
    [anon_sym_volatile] = ACTIONS(3154),
    [anon_sym_restrict] = ACTIONS(3154),
    [anon_sym___restrict__] = ACTIONS(3154),
    [anon_sym__Atomic] = ACTIONS(3154),
    [anon_sym__Noreturn] = ACTIONS(3154),
    [anon_sym_noreturn] = ACTIONS(3154),
    [anon_sym_mutable] = ACTIONS(3154),
    [anon_sym_constinit] = ACTIONS(3154),
    [anon_sym_consteval] = ACTIONS(3154),
    [anon_sym_PROGMEM] = ACTIONS(3154),
    [aux_sym_primitive_type_token1] = ACTIONS(3154),
    [anon_sym_byte] = ACTIONS(3154),
    [anon_sym_word] = ACTIONS(3154),
    [anon_sym_enum] = ACTIONS(3154),
    [anon_sym_class] = ACTIONS(3154),
    [anon_sym_struct] = ACTIONS(3154),
    [anon_sym_union] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_else] = ACTIONS(3154),
    [anon_sym_switch] = ACTIONS(3154),
    [anon_sym_case] = ACTIONS(3154),
    [anon_sym_default] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_break] = ACTIONS(3154),
    [anon_sym_continue] = ACTIONS(3154),
    [anon_sym_goto] = ACTIONS(3154),
    [anon_sym___try] = ACTIONS(3154),
    [anon_sym___leave] = ACTIONS(3154),
    [anon_sym_not] = ACTIONS(3154),
    [anon_sym_compl] = ACTIONS(3154),
    [anon_sym_DASH_DASH] = ACTIONS(3156),
    [anon_sym_PLUS_PLUS] = ACTIONS(3156),
    [anon_sym_sizeof] = ACTIONS(3154),
    [anon_sym___alignof__] = ACTIONS(3154),
    [anon_sym___alignof] = ACTIONS(3154),
    [anon_sym__alignof] = ACTIONS(3154),
    [anon_sym_alignof] = ACTIONS(3154),
    [anon_sym__Alignof] = ACTIONS(3154),
    [anon_sym_offsetof] = ACTIONS(3154),
    [anon_sym__Generic] = ACTIONS(3154),
    [anon_sym_asm] = ACTIONS(3154),
    [anon_sym___asm__] = ACTIONS(3154),
    [aux_sym_number_literal_token1] = ACTIONS(3156),
    [aux_sym_number_literal_token2] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3156),
    [anon_sym_u_DQUOTE] = ACTIONS(3156),
    [anon_sym_U_DQUOTE] = ACTIONS(3156),
    [anon_sym_u8_DQUOTE] = ACTIONS(3156),
    [anon_sym_DQUOTE] = ACTIONS(3156),
    [sym_true] = ACTIONS(3154),
    [sym_false] = ACTIONS(3154),
    [anon_sym_NULL] = ACTIONS(3154),
    [anon_sym_nullptr] = ACTIONS(3154),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3154),
    [anon_sym_decltype] = ACTIONS(3154),
    [anon_sym_virtual] = ACTIONS(3154),
    [anon_sym_alignas] = ACTIONS(3154),
    [anon_sym_explicit] = ACTIONS(3154),
    [anon_sym_typename] = ACTIONS(3154),
    [anon_sym_template] = ACTIONS(3154),
    [anon_sym_operator] = ACTIONS(3154),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_delete] = ACTIONS(3154),
    [anon_sym_throw] = ACTIONS(3154),
    [anon_sym_namespace] = ACTIONS(3154),
    [anon_sym_using] = ACTIONS(3154),
    [anon_sym_static_assert] = ACTIONS(3154),
    [anon_sym_concept] = ACTIONS(3154),
    [anon_sym_co_return] = ACTIONS(3154),
    [anon_sym_co_yield] = ACTIONS(3154),
    [anon_sym_R_DQUOTE] = ACTIONS(3156),
    [anon_sym_LR_DQUOTE] = ACTIONS(3156),
    [anon_sym_uR_DQUOTE] = ACTIONS(3156),
    [anon_sym_UR_DQUOTE] = ACTIONS(3156),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3156),
    [anon_sym_co_await] = ACTIONS(3154),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_requires] = ACTIONS(3154),
    [sym_this] = ACTIONS(3154),
  },
  [788] = {
    [ts_builtin_sym_end] = ACTIONS(3066),
    [sym_identifier] = ACTIONS(3064),
    [aux_sym_preproc_include_token1] = ACTIONS(3064),
    [aux_sym_preproc_def_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3064),
    [anon_sym_LPAREN2] = ACTIONS(3066),
    [anon_sym_BANG] = ACTIONS(3066),
    [anon_sym_TILDE] = ACTIONS(3066),
    [anon_sym_DASH] = ACTIONS(3064),
    [anon_sym_PLUS] = ACTIONS(3064),
    [anon_sym_STAR] = ACTIONS(3066),
    [anon_sym_AMP_AMP] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3064),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym___extension__] = ACTIONS(3064),
    [anon_sym_typedef] = ACTIONS(3064),
    [anon_sym_extern] = ACTIONS(3064),
    [anon_sym___attribute__] = ACTIONS(3064),
    [anon_sym_COLON_COLON] = ACTIONS(3066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3066),
    [anon_sym___declspec] = ACTIONS(3064),
    [anon_sym___based] = ACTIONS(3064),
    [anon_sym___cdecl] = ACTIONS(3064),
    [anon_sym___clrcall] = ACTIONS(3064),
    [anon_sym___stdcall] = ACTIONS(3064),
    [anon_sym___fastcall] = ACTIONS(3064),
    [anon_sym___thiscall] = ACTIONS(3064),
    [anon_sym___vectorcall] = ACTIONS(3064),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_signed] = ACTIONS(3064),
    [anon_sym_unsigned] = ACTIONS(3064),
    [anon_sym_long] = ACTIONS(3064),
    [anon_sym_short] = ACTIONS(3064),
    [anon_sym_LBRACK] = ACTIONS(3064),
    [anon_sym_static] = ACTIONS(3064),
    [anon_sym_register] = ACTIONS(3064),
    [anon_sym_inline] = ACTIONS(3064),
    [anon_sym___inline] = ACTIONS(3064),
    [anon_sym___inline__] = ACTIONS(3064),
    [anon_sym___forceinline] = ACTIONS(3064),
    [anon_sym_thread_local] = ACTIONS(3064),
    [anon_sym___thread] = ACTIONS(3064),
    [anon_sym_const] = ACTIONS(3064),
    [anon_sym_constexpr] = ACTIONS(3064),
    [anon_sym_volatile] = ACTIONS(3064),
    [anon_sym_restrict] = ACTIONS(3064),
    [anon_sym___restrict__] = ACTIONS(3064),
    [anon_sym__Atomic] = ACTIONS(3064),
    [anon_sym__Noreturn] = ACTIONS(3064),
    [anon_sym_noreturn] = ACTIONS(3064),
    [anon_sym_mutable] = ACTIONS(3064),
    [anon_sym_constinit] = ACTIONS(3064),
    [anon_sym_consteval] = ACTIONS(3064),
    [anon_sym_PROGMEM] = ACTIONS(3064),
    [aux_sym_primitive_type_token1] = ACTIONS(3064),
    [anon_sym_byte] = ACTIONS(3064),
    [anon_sym_word] = ACTIONS(3064),
    [anon_sym_enum] = ACTIONS(3064),
    [anon_sym_class] = ACTIONS(3064),
    [anon_sym_struct] = ACTIONS(3064),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_if] = ACTIONS(3064),
    [anon_sym_else] = ACTIONS(3064),
    [anon_sym_switch] = ACTIONS(3064),
    [anon_sym_case] = ACTIONS(3064),
    [anon_sym_default] = ACTIONS(3064),
    [anon_sym_while] = ACTIONS(3064),
    [anon_sym_do] = ACTIONS(3064),
    [anon_sym_for] = ACTIONS(3064),
    [anon_sym_return] = ACTIONS(3064),
    [anon_sym_break] = ACTIONS(3064),
    [anon_sym_continue] = ACTIONS(3064),
    [anon_sym_goto] = ACTIONS(3064),
    [anon_sym___try] = ACTIONS(3064),
    [anon_sym___leave] = ACTIONS(3064),
    [anon_sym_not] = ACTIONS(3064),
    [anon_sym_compl] = ACTIONS(3064),
    [anon_sym_DASH_DASH] = ACTIONS(3066),
    [anon_sym_PLUS_PLUS] = ACTIONS(3066),
    [anon_sym_sizeof] = ACTIONS(3064),
    [anon_sym___alignof__] = ACTIONS(3064),
    [anon_sym___alignof] = ACTIONS(3064),
    [anon_sym__alignof] = ACTIONS(3064),
    [anon_sym_alignof] = ACTIONS(3064),
    [anon_sym__Alignof] = ACTIONS(3064),
    [anon_sym_offsetof] = ACTIONS(3064),
    [anon_sym__Generic] = ACTIONS(3064),
    [anon_sym_asm] = ACTIONS(3064),
    [anon_sym___asm__] = ACTIONS(3064),
    [aux_sym_number_literal_token1] = ACTIONS(3066),
    [aux_sym_number_literal_token2] = ACTIONS(3064),
    [anon_sym_L_SQUOTE] = ACTIONS(3066),
    [anon_sym_u_SQUOTE] = ACTIONS(3066),
    [anon_sym_U_SQUOTE] = ACTIONS(3066),
    [anon_sym_u8_SQUOTE] = ACTIONS(3066),
    [anon_sym_SQUOTE] = ACTIONS(3066),
    [anon_sym_L_DQUOTE] = ACTIONS(3066),
    [anon_sym_u_DQUOTE] = ACTIONS(3066),
    [anon_sym_U_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8_DQUOTE] = ACTIONS(3066),
    [anon_sym_DQUOTE] = ACTIONS(3066),
    [sym_true] = ACTIONS(3064),
    [sym_false] = ACTIONS(3064),
    [anon_sym_NULL] = ACTIONS(3064),
    [anon_sym_nullptr] = ACTIONS(3064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3064),
    [anon_sym_decltype] = ACTIONS(3064),
    [anon_sym_virtual] = ACTIONS(3064),
    [anon_sym_alignas] = ACTIONS(3064),
    [anon_sym_explicit] = ACTIONS(3064),
    [anon_sym_typename] = ACTIONS(3064),
    [anon_sym_template] = ACTIONS(3064),
    [anon_sym_operator] = ACTIONS(3064),
    [anon_sym_try] = ACTIONS(3064),
    [anon_sym_delete] = ACTIONS(3064),
    [anon_sym_throw] = ACTIONS(3064),
    [anon_sym_namespace] = ACTIONS(3064),
    [anon_sym_using] = ACTIONS(3064),
    [anon_sym_static_assert] = ACTIONS(3064),
    [anon_sym_concept] = ACTIONS(3064),
    [anon_sym_co_return] = ACTIONS(3064),
    [anon_sym_co_yield] = ACTIONS(3064),
    [anon_sym_R_DQUOTE] = ACTIONS(3066),
    [anon_sym_LR_DQUOTE] = ACTIONS(3066),
    [anon_sym_uR_DQUOTE] = ACTIONS(3066),
    [anon_sym_UR_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3066),
    [anon_sym_co_await] = ACTIONS(3064),
    [anon_sym_new] = ACTIONS(3064),
    [anon_sym_requires] = ACTIONS(3064),
    [sym_this] = ACTIONS(3064),
  },
  [789] = {
    [ts_builtin_sym_end] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_include_token1] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_BANG] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_DASH] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym___cdecl] = ACTIONS(3068),
    [anon_sym___clrcall] = ACTIONS(3068),
    [anon_sym___stdcall] = ACTIONS(3068),
    [anon_sym___fastcall] = ACTIONS(3068),
    [anon_sym___thiscall] = ACTIONS(3068),
    [anon_sym___vectorcall] = ACTIONS(3068),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_PROGMEM] = ACTIONS(3068),
    [aux_sym_primitive_type_token1] = ACTIONS(3068),
    [anon_sym_byte] = ACTIONS(3068),
    [anon_sym_word] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3068),
    [anon_sym_else] = ACTIONS(3068),
    [anon_sym_switch] = ACTIONS(3068),
    [anon_sym_case] = ACTIONS(3068),
    [anon_sym_default] = ACTIONS(3068),
    [anon_sym_while] = ACTIONS(3068),
    [anon_sym_do] = ACTIONS(3068),
    [anon_sym_for] = ACTIONS(3068),
    [anon_sym_return] = ACTIONS(3068),
    [anon_sym_break] = ACTIONS(3068),
    [anon_sym_continue] = ACTIONS(3068),
    [anon_sym_goto] = ACTIONS(3068),
    [anon_sym___try] = ACTIONS(3068),
    [anon_sym___leave] = ACTIONS(3068),
    [anon_sym_not] = ACTIONS(3068),
    [anon_sym_compl] = ACTIONS(3068),
    [anon_sym_DASH_DASH] = ACTIONS(3070),
    [anon_sym_PLUS_PLUS] = ACTIONS(3070),
    [anon_sym_sizeof] = ACTIONS(3068),
    [anon_sym___alignof__] = ACTIONS(3068),
    [anon_sym___alignof] = ACTIONS(3068),
    [anon_sym__alignof] = ACTIONS(3068),
    [anon_sym_alignof] = ACTIONS(3068),
    [anon_sym__Alignof] = ACTIONS(3068),
    [anon_sym_offsetof] = ACTIONS(3068),
    [anon_sym__Generic] = ACTIONS(3068),
    [anon_sym_asm] = ACTIONS(3068),
    [anon_sym___asm__] = ACTIONS(3068),
    [aux_sym_number_literal_token1] = ACTIONS(3070),
    [aux_sym_number_literal_token2] = ACTIONS(3068),
    [anon_sym_L_SQUOTE] = ACTIONS(3070),
    [anon_sym_u_SQUOTE] = ACTIONS(3070),
    [anon_sym_U_SQUOTE] = ACTIONS(3070),
    [anon_sym_u8_SQUOTE] = ACTIONS(3070),
    [anon_sym_SQUOTE] = ACTIONS(3070),
    [anon_sym_L_DQUOTE] = ACTIONS(3070),
    [anon_sym_u_DQUOTE] = ACTIONS(3070),
    [anon_sym_U_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8_DQUOTE] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3070),
    [sym_true] = ACTIONS(3068),
    [sym_false] = ACTIONS(3068),
    [anon_sym_NULL] = ACTIONS(3068),
    [anon_sym_nullptr] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_try] = ACTIONS(3068),
    [anon_sym_delete] = ACTIONS(3068),
    [anon_sym_throw] = ACTIONS(3068),
    [anon_sym_namespace] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
    [anon_sym_concept] = ACTIONS(3068),
    [anon_sym_co_return] = ACTIONS(3068),
    [anon_sym_co_yield] = ACTIONS(3068),
    [anon_sym_R_DQUOTE] = ACTIONS(3070),
    [anon_sym_LR_DQUOTE] = ACTIONS(3070),
    [anon_sym_uR_DQUOTE] = ACTIONS(3070),
    [anon_sym_UR_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3070),
    [anon_sym_co_await] = ACTIONS(3068),
    [anon_sym_new] = ACTIONS(3068),
    [anon_sym_requires] = ACTIONS(3068),
    [sym_this] = ACTIONS(3068),
  },
  [790] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [791] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [792] = {
    [sym_identifier] = ACTIONS(3150),
    [aux_sym_preproc_include_token1] = ACTIONS(3150),
    [aux_sym_preproc_def_token1] = ACTIONS(3150),
    [aux_sym_preproc_if_token1] = ACTIONS(3150),
    [aux_sym_preproc_if_token2] = ACTIONS(3150),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3150),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3150),
    [sym_preproc_directive] = ACTIONS(3150),
    [anon_sym_LPAREN2] = ACTIONS(3152),
    [anon_sym_BANG] = ACTIONS(3152),
    [anon_sym_TILDE] = ACTIONS(3152),
    [anon_sym_DASH] = ACTIONS(3150),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_STAR] = ACTIONS(3152),
    [anon_sym_AMP_AMP] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(3152),
    [anon_sym___extension__] = ACTIONS(3150),
    [anon_sym_typedef] = ACTIONS(3150),
    [anon_sym_extern] = ACTIONS(3150),
    [anon_sym___attribute__] = ACTIONS(3150),
    [anon_sym_COLON_COLON] = ACTIONS(3152),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3152),
    [anon_sym___declspec] = ACTIONS(3150),
    [anon_sym___based] = ACTIONS(3150),
    [anon_sym___cdecl] = ACTIONS(3150),
    [anon_sym___clrcall] = ACTIONS(3150),
    [anon_sym___stdcall] = ACTIONS(3150),
    [anon_sym___fastcall] = ACTIONS(3150),
    [anon_sym___thiscall] = ACTIONS(3150),
    [anon_sym___vectorcall] = ACTIONS(3150),
    [anon_sym_LBRACE] = ACTIONS(3152),
    [anon_sym_signed] = ACTIONS(3150),
    [anon_sym_unsigned] = ACTIONS(3150),
    [anon_sym_long] = ACTIONS(3150),
    [anon_sym_short] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3150),
    [anon_sym_static] = ACTIONS(3150),
    [anon_sym_register] = ACTIONS(3150),
    [anon_sym_inline] = ACTIONS(3150),
    [anon_sym___inline] = ACTIONS(3150),
    [anon_sym___inline__] = ACTIONS(3150),
    [anon_sym___forceinline] = ACTIONS(3150),
    [anon_sym_thread_local] = ACTIONS(3150),
    [anon_sym___thread] = ACTIONS(3150),
    [anon_sym_const] = ACTIONS(3150),
    [anon_sym_constexpr] = ACTIONS(3150),
    [anon_sym_volatile] = ACTIONS(3150),
    [anon_sym_restrict] = ACTIONS(3150),
    [anon_sym___restrict__] = ACTIONS(3150),
    [anon_sym__Atomic] = ACTIONS(3150),
    [anon_sym__Noreturn] = ACTIONS(3150),
    [anon_sym_noreturn] = ACTIONS(3150),
    [anon_sym_mutable] = ACTIONS(3150),
    [anon_sym_constinit] = ACTIONS(3150),
    [anon_sym_consteval] = ACTIONS(3150),
    [anon_sym_PROGMEM] = ACTIONS(3150),
    [aux_sym_primitive_type_token1] = ACTIONS(3150),
    [anon_sym_byte] = ACTIONS(3150),
    [anon_sym_word] = ACTIONS(3150),
    [anon_sym_enum] = ACTIONS(3150),
    [anon_sym_class] = ACTIONS(3150),
    [anon_sym_struct] = ACTIONS(3150),
    [anon_sym_union] = ACTIONS(3150),
    [anon_sym_if] = ACTIONS(3150),
    [anon_sym_else] = ACTIONS(3150),
    [anon_sym_switch] = ACTIONS(3150),
    [anon_sym_case] = ACTIONS(3150),
    [anon_sym_default] = ACTIONS(3150),
    [anon_sym_while] = ACTIONS(3150),
    [anon_sym_do] = ACTIONS(3150),
    [anon_sym_for] = ACTIONS(3150),
    [anon_sym_return] = ACTIONS(3150),
    [anon_sym_break] = ACTIONS(3150),
    [anon_sym_continue] = ACTIONS(3150),
    [anon_sym_goto] = ACTIONS(3150),
    [anon_sym___try] = ACTIONS(3150),
    [anon_sym___leave] = ACTIONS(3150),
    [anon_sym_not] = ACTIONS(3150),
    [anon_sym_compl] = ACTIONS(3150),
    [anon_sym_DASH_DASH] = ACTIONS(3152),
    [anon_sym_PLUS_PLUS] = ACTIONS(3152),
    [anon_sym_sizeof] = ACTIONS(3150),
    [anon_sym___alignof__] = ACTIONS(3150),
    [anon_sym___alignof] = ACTIONS(3150),
    [anon_sym__alignof] = ACTIONS(3150),
    [anon_sym_alignof] = ACTIONS(3150),
    [anon_sym__Alignof] = ACTIONS(3150),
    [anon_sym_offsetof] = ACTIONS(3150),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3150),
    [anon_sym___asm__] = ACTIONS(3150),
    [aux_sym_number_literal_token1] = ACTIONS(3152),
    [aux_sym_number_literal_token2] = ACTIONS(3150),
    [anon_sym_L_SQUOTE] = ACTIONS(3152),
    [anon_sym_u_SQUOTE] = ACTIONS(3152),
    [anon_sym_U_SQUOTE] = ACTIONS(3152),
    [anon_sym_u8_SQUOTE] = ACTIONS(3152),
    [anon_sym_SQUOTE] = ACTIONS(3152),
    [anon_sym_L_DQUOTE] = ACTIONS(3152),
    [anon_sym_u_DQUOTE] = ACTIONS(3152),
    [anon_sym_U_DQUOTE] = ACTIONS(3152),
    [anon_sym_u8_DQUOTE] = ACTIONS(3152),
    [anon_sym_DQUOTE] = ACTIONS(3152),
    [sym_true] = ACTIONS(3150),
    [sym_false] = ACTIONS(3150),
    [anon_sym_NULL] = ACTIONS(3150),
    [anon_sym_nullptr] = ACTIONS(3150),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3150),
    [anon_sym_decltype] = ACTIONS(3150),
    [anon_sym_virtual] = ACTIONS(3150),
    [anon_sym_alignas] = ACTIONS(3150),
    [anon_sym_explicit] = ACTIONS(3150),
    [anon_sym_typename] = ACTIONS(3150),
    [anon_sym_template] = ACTIONS(3150),
    [anon_sym_operator] = ACTIONS(3150),
    [anon_sym_try] = ACTIONS(3150),
    [anon_sym_delete] = ACTIONS(3150),
    [anon_sym_throw] = ACTIONS(3150),
    [anon_sym_namespace] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_static_assert] = ACTIONS(3150),
    [anon_sym_concept] = ACTIONS(3150),
    [anon_sym_co_return] = ACTIONS(3150),
    [anon_sym_co_yield] = ACTIONS(3150),
    [anon_sym_R_DQUOTE] = ACTIONS(3152),
    [anon_sym_LR_DQUOTE] = ACTIONS(3152),
    [anon_sym_uR_DQUOTE] = ACTIONS(3152),
    [anon_sym_UR_DQUOTE] = ACTIONS(3152),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3152),
    [anon_sym_co_await] = ACTIONS(3150),
    [anon_sym_new] = ACTIONS(3150),
    [anon_sym_requires] = ACTIONS(3150),
    [sym_this] = ACTIONS(3150),
  },
  [793] = {
    [sym_identifier] = ACTIONS(3124),
    [aux_sym_preproc_include_token1] = ACTIONS(3124),
    [aux_sym_preproc_def_token1] = ACTIONS(3124),
    [aux_sym_preproc_if_token1] = ACTIONS(3124),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3124),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3124),
    [sym_preproc_directive] = ACTIONS(3124),
    [anon_sym_LPAREN2] = ACTIONS(3126),
    [anon_sym_BANG] = ACTIONS(3126),
    [anon_sym_TILDE] = ACTIONS(3126),
    [anon_sym_DASH] = ACTIONS(3124),
    [anon_sym_PLUS] = ACTIONS(3124),
    [anon_sym_STAR] = ACTIONS(3126),
    [anon_sym_AMP_AMP] = ACTIONS(3126),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym_SEMI] = ACTIONS(3126),
    [anon_sym___extension__] = ACTIONS(3124),
    [anon_sym_typedef] = ACTIONS(3124),
    [anon_sym_extern] = ACTIONS(3124),
    [anon_sym___attribute__] = ACTIONS(3124),
    [anon_sym_COLON_COLON] = ACTIONS(3126),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3126),
    [anon_sym___declspec] = ACTIONS(3124),
    [anon_sym___based] = ACTIONS(3124),
    [anon_sym___cdecl] = ACTIONS(3124),
    [anon_sym___clrcall] = ACTIONS(3124),
    [anon_sym___stdcall] = ACTIONS(3124),
    [anon_sym___fastcall] = ACTIONS(3124),
    [anon_sym___thiscall] = ACTIONS(3124),
    [anon_sym___vectorcall] = ACTIONS(3124),
    [anon_sym_LBRACE] = ACTIONS(3126),
    [anon_sym_RBRACE] = ACTIONS(3126),
    [anon_sym_signed] = ACTIONS(3124),
    [anon_sym_unsigned] = ACTIONS(3124),
    [anon_sym_long] = ACTIONS(3124),
    [anon_sym_short] = ACTIONS(3124),
    [anon_sym_LBRACK] = ACTIONS(3124),
    [anon_sym_static] = ACTIONS(3124),
    [anon_sym_register] = ACTIONS(3124),
    [anon_sym_inline] = ACTIONS(3124),
    [anon_sym___inline] = ACTIONS(3124),
    [anon_sym___inline__] = ACTIONS(3124),
    [anon_sym___forceinline] = ACTIONS(3124),
    [anon_sym_thread_local] = ACTIONS(3124),
    [anon_sym___thread] = ACTIONS(3124),
    [anon_sym_const] = ACTIONS(3124),
    [anon_sym_constexpr] = ACTIONS(3124),
    [anon_sym_volatile] = ACTIONS(3124),
    [anon_sym_restrict] = ACTIONS(3124),
    [anon_sym___restrict__] = ACTIONS(3124),
    [anon_sym__Atomic] = ACTIONS(3124),
    [anon_sym__Noreturn] = ACTIONS(3124),
    [anon_sym_noreturn] = ACTIONS(3124),
    [anon_sym_mutable] = ACTIONS(3124),
    [anon_sym_constinit] = ACTIONS(3124),
    [anon_sym_consteval] = ACTIONS(3124),
    [anon_sym_PROGMEM] = ACTIONS(3124),
    [aux_sym_primitive_type_token1] = ACTIONS(3124),
    [anon_sym_byte] = ACTIONS(3124),
    [anon_sym_word] = ACTIONS(3124),
    [anon_sym_enum] = ACTIONS(3124),
    [anon_sym_class] = ACTIONS(3124),
    [anon_sym_struct] = ACTIONS(3124),
    [anon_sym_union] = ACTIONS(3124),
    [anon_sym_if] = ACTIONS(3124),
    [anon_sym_else] = ACTIONS(3124),
    [anon_sym_switch] = ACTIONS(3124),
    [anon_sym_case] = ACTIONS(3124),
    [anon_sym_default] = ACTIONS(3124),
    [anon_sym_while] = ACTIONS(3124),
    [anon_sym_do] = ACTIONS(3124),
    [anon_sym_for] = ACTIONS(3124),
    [anon_sym_return] = ACTIONS(3124),
    [anon_sym_break] = ACTIONS(3124),
    [anon_sym_continue] = ACTIONS(3124),
    [anon_sym_goto] = ACTIONS(3124),
    [anon_sym___try] = ACTIONS(3124),
    [anon_sym___leave] = ACTIONS(3124),
    [anon_sym_not] = ACTIONS(3124),
    [anon_sym_compl] = ACTIONS(3124),
    [anon_sym_DASH_DASH] = ACTIONS(3126),
    [anon_sym_PLUS_PLUS] = ACTIONS(3126),
    [anon_sym_sizeof] = ACTIONS(3124),
    [anon_sym___alignof__] = ACTIONS(3124),
    [anon_sym___alignof] = ACTIONS(3124),
    [anon_sym__alignof] = ACTIONS(3124),
    [anon_sym_alignof] = ACTIONS(3124),
    [anon_sym__Alignof] = ACTIONS(3124),
    [anon_sym_offsetof] = ACTIONS(3124),
    [anon_sym__Generic] = ACTIONS(3124),
    [anon_sym_asm] = ACTIONS(3124),
    [anon_sym___asm__] = ACTIONS(3124),
    [aux_sym_number_literal_token1] = ACTIONS(3126),
    [aux_sym_number_literal_token2] = ACTIONS(3124),
    [anon_sym_L_SQUOTE] = ACTIONS(3126),
    [anon_sym_u_SQUOTE] = ACTIONS(3126),
    [anon_sym_U_SQUOTE] = ACTIONS(3126),
    [anon_sym_u8_SQUOTE] = ACTIONS(3126),
    [anon_sym_SQUOTE] = ACTIONS(3126),
    [anon_sym_L_DQUOTE] = ACTIONS(3126),
    [anon_sym_u_DQUOTE] = ACTIONS(3126),
    [anon_sym_U_DQUOTE] = ACTIONS(3126),
    [anon_sym_u8_DQUOTE] = ACTIONS(3126),
    [anon_sym_DQUOTE] = ACTIONS(3126),
    [sym_true] = ACTIONS(3124),
    [sym_false] = ACTIONS(3124),
    [anon_sym_NULL] = ACTIONS(3124),
    [anon_sym_nullptr] = ACTIONS(3124),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3124),
    [anon_sym_decltype] = ACTIONS(3124),
    [anon_sym_virtual] = ACTIONS(3124),
    [anon_sym_alignas] = ACTIONS(3124),
    [anon_sym_explicit] = ACTIONS(3124),
    [anon_sym_typename] = ACTIONS(3124),
    [anon_sym_template] = ACTIONS(3124),
    [anon_sym_operator] = ACTIONS(3124),
    [anon_sym_try] = ACTIONS(3124),
    [anon_sym_delete] = ACTIONS(3124),
    [anon_sym_throw] = ACTIONS(3124),
    [anon_sym_namespace] = ACTIONS(3124),
    [anon_sym_using] = ACTIONS(3124),
    [anon_sym_static_assert] = ACTIONS(3124),
    [anon_sym_concept] = ACTIONS(3124),
    [anon_sym_co_return] = ACTIONS(3124),
    [anon_sym_co_yield] = ACTIONS(3124),
    [anon_sym_R_DQUOTE] = ACTIONS(3126),
    [anon_sym_LR_DQUOTE] = ACTIONS(3126),
    [anon_sym_uR_DQUOTE] = ACTIONS(3126),
    [anon_sym_UR_DQUOTE] = ACTIONS(3126),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3126),
    [anon_sym_co_await] = ACTIONS(3124),
    [anon_sym_new] = ACTIONS(3124),
    [anon_sym_requires] = ACTIONS(3124),
    [sym_this] = ACTIONS(3124),
  },
  [794] = {
    [sym_preproc_def] = STATE(797),
    [sym_preproc_function_def] = STATE(797),
    [sym_preproc_call] = STATE(797),
    [sym_preproc_if_in_field_declaration_list] = STATE(797),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(797),
    [sym_preproc_else_in_field_declaration_list] = STATE(8833),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8833),
    [sym_type_definition] = STATE(797),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6507),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7114),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(797),
    [sym_field_declaration] = STATE(797),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2150),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(797),
    [sym_operator_cast] = STATE(7493),
    [sym_inline_method_definition] = STATE(797),
    [sym__constructor_specifiers] = STATE(2150),
    [sym_operator_cast_definition] = STATE(797),
    [sym_operator_cast_declaration] = STATE(797),
    [sym_constructor_or_destructor_definition] = STATE(797),
    [sym_constructor_or_destructor_declaration] = STATE(797),
    [sym_friend_declaration] = STATE(797),
    [sym_access_specifier] = STATE(9075),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(797),
    [sym_alias_declaration] = STATE(797),
    [sym_static_assert_declaration] = STATE(797),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7493),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(797),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2150),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3563),
    [aux_sym_preproc_if_token1] = ACTIONS(3565),
    [aux_sym_preproc_if_token2] = ACTIONS(3589),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3569),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3569),
    [aux_sym_preproc_else_token1] = ACTIONS(3206),
    [aux_sym_preproc_elif_token1] = ACTIONS(3208),
    [sym_preproc_directive] = ACTIONS(3571),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3573),
    [anon_sym_typedef] = ACTIONS(3575),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3577),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3579),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3581),
    [anon_sym_static_assert] = ACTIONS(3583),
  },
  [795] = {
    [sym_identifier] = ACTIONS(3054),
    [aux_sym_preproc_include_token1] = ACTIONS(3054),
    [aux_sym_preproc_def_token1] = ACTIONS(3054),
    [aux_sym_preproc_if_token1] = ACTIONS(3054),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3054),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3054),
    [sym_preproc_directive] = ACTIONS(3054),
    [anon_sym_LPAREN2] = ACTIONS(3056),
    [anon_sym_BANG] = ACTIONS(3056),
    [anon_sym_TILDE] = ACTIONS(3056),
    [anon_sym_DASH] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3056),
    [anon_sym_AMP_AMP] = ACTIONS(3056),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym___extension__] = ACTIONS(3054),
    [anon_sym_typedef] = ACTIONS(3054),
    [anon_sym_extern] = ACTIONS(3054),
    [anon_sym___attribute__] = ACTIONS(3054),
    [anon_sym_COLON_COLON] = ACTIONS(3056),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3056),
    [anon_sym___declspec] = ACTIONS(3054),
    [anon_sym___based] = ACTIONS(3054),
    [anon_sym___cdecl] = ACTIONS(3054),
    [anon_sym___clrcall] = ACTIONS(3054),
    [anon_sym___stdcall] = ACTIONS(3054),
    [anon_sym___fastcall] = ACTIONS(3054),
    [anon_sym___thiscall] = ACTIONS(3054),
    [anon_sym___vectorcall] = ACTIONS(3054),
    [anon_sym_LBRACE] = ACTIONS(3056),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_signed] = ACTIONS(3054),
    [anon_sym_unsigned] = ACTIONS(3054),
    [anon_sym_long] = ACTIONS(3054),
    [anon_sym_short] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3054),
    [anon_sym_static] = ACTIONS(3054),
    [anon_sym_register] = ACTIONS(3054),
    [anon_sym_inline] = ACTIONS(3054),
    [anon_sym___inline] = ACTIONS(3054),
    [anon_sym___inline__] = ACTIONS(3054),
    [anon_sym___forceinline] = ACTIONS(3054),
    [anon_sym_thread_local] = ACTIONS(3054),
    [anon_sym___thread] = ACTIONS(3054),
    [anon_sym_const] = ACTIONS(3054),
    [anon_sym_constexpr] = ACTIONS(3054),
    [anon_sym_volatile] = ACTIONS(3054),
    [anon_sym_restrict] = ACTIONS(3054),
    [anon_sym___restrict__] = ACTIONS(3054),
    [anon_sym__Atomic] = ACTIONS(3054),
    [anon_sym__Noreturn] = ACTIONS(3054),
    [anon_sym_noreturn] = ACTIONS(3054),
    [anon_sym_mutable] = ACTIONS(3054),
    [anon_sym_constinit] = ACTIONS(3054),
    [anon_sym_consteval] = ACTIONS(3054),
    [anon_sym_PROGMEM] = ACTIONS(3054),
    [aux_sym_primitive_type_token1] = ACTIONS(3054),
    [anon_sym_byte] = ACTIONS(3054),
    [anon_sym_word] = ACTIONS(3054),
    [anon_sym_enum] = ACTIONS(3054),
    [anon_sym_class] = ACTIONS(3054),
    [anon_sym_struct] = ACTIONS(3054),
    [anon_sym_union] = ACTIONS(3054),
    [anon_sym_if] = ACTIONS(3054),
    [anon_sym_else] = ACTIONS(3054),
    [anon_sym_switch] = ACTIONS(3054),
    [anon_sym_case] = ACTIONS(3054),
    [anon_sym_default] = ACTIONS(3054),
    [anon_sym_while] = ACTIONS(3054),
    [anon_sym_do] = ACTIONS(3054),
    [anon_sym_for] = ACTIONS(3054),
    [anon_sym_return] = ACTIONS(3054),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_continue] = ACTIONS(3054),
    [anon_sym_goto] = ACTIONS(3054),
    [anon_sym___try] = ACTIONS(3054),
    [anon_sym___leave] = ACTIONS(3054),
    [anon_sym_not] = ACTIONS(3054),
    [anon_sym_compl] = ACTIONS(3054),
    [anon_sym_DASH_DASH] = ACTIONS(3056),
    [anon_sym_PLUS_PLUS] = ACTIONS(3056),
    [anon_sym_sizeof] = ACTIONS(3054),
    [anon_sym___alignof__] = ACTIONS(3054),
    [anon_sym___alignof] = ACTIONS(3054),
    [anon_sym__alignof] = ACTIONS(3054),
    [anon_sym_alignof] = ACTIONS(3054),
    [anon_sym__Alignof] = ACTIONS(3054),
    [anon_sym_offsetof] = ACTIONS(3054),
    [anon_sym__Generic] = ACTIONS(3054),
    [anon_sym_asm] = ACTIONS(3054),
    [anon_sym___asm__] = ACTIONS(3054),
    [aux_sym_number_literal_token1] = ACTIONS(3056),
    [aux_sym_number_literal_token2] = ACTIONS(3054),
    [anon_sym_L_SQUOTE] = ACTIONS(3056),
    [anon_sym_u_SQUOTE] = ACTIONS(3056),
    [anon_sym_U_SQUOTE] = ACTIONS(3056),
    [anon_sym_u8_SQUOTE] = ACTIONS(3056),
    [anon_sym_SQUOTE] = ACTIONS(3056),
    [anon_sym_L_DQUOTE] = ACTIONS(3056),
    [anon_sym_u_DQUOTE] = ACTIONS(3056),
    [anon_sym_U_DQUOTE] = ACTIONS(3056),
    [anon_sym_u8_DQUOTE] = ACTIONS(3056),
    [anon_sym_DQUOTE] = ACTIONS(3056),
    [sym_true] = ACTIONS(3054),
    [sym_false] = ACTIONS(3054),
    [anon_sym_NULL] = ACTIONS(3054),
    [anon_sym_nullptr] = ACTIONS(3054),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3054),
    [anon_sym_decltype] = ACTIONS(3054),
    [anon_sym_virtual] = ACTIONS(3054),
    [anon_sym_alignas] = ACTIONS(3054),
    [anon_sym_explicit] = ACTIONS(3054),
    [anon_sym_typename] = ACTIONS(3054),
    [anon_sym_template] = ACTIONS(3054),
    [anon_sym_operator] = ACTIONS(3054),
    [anon_sym_try] = ACTIONS(3054),
    [anon_sym_delete] = ACTIONS(3054),
    [anon_sym_throw] = ACTIONS(3054),
    [anon_sym_namespace] = ACTIONS(3054),
    [anon_sym_using] = ACTIONS(3054),
    [anon_sym_static_assert] = ACTIONS(3054),
    [anon_sym_concept] = ACTIONS(3054),
    [anon_sym_co_return] = ACTIONS(3054),
    [anon_sym_co_yield] = ACTIONS(3054),
    [anon_sym_R_DQUOTE] = ACTIONS(3056),
    [anon_sym_LR_DQUOTE] = ACTIONS(3056),
    [anon_sym_uR_DQUOTE] = ACTIONS(3056),
    [anon_sym_UR_DQUOTE] = ACTIONS(3056),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3056),
    [anon_sym_co_await] = ACTIONS(3054),
    [anon_sym_new] = ACTIONS(3054),
    [anon_sym_requires] = ACTIONS(3054),
    [sym_this] = ACTIONS(3054),
  },
  [796] = {
    [sym_identifier] = ACTIONS(2966),
    [aux_sym_preproc_include_token1] = ACTIONS(2966),
    [aux_sym_preproc_def_token1] = ACTIONS(2966),
    [aux_sym_preproc_if_token1] = ACTIONS(2966),
    [aux_sym_preproc_if_token2] = ACTIONS(2966),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2966),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2966),
    [sym_preproc_directive] = ACTIONS(2966),
    [anon_sym_LPAREN2] = ACTIONS(2968),
    [anon_sym_BANG] = ACTIONS(2968),
    [anon_sym_TILDE] = ACTIONS(2968),
    [anon_sym_DASH] = ACTIONS(2966),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_STAR] = ACTIONS(2968),
    [anon_sym_AMP_AMP] = ACTIONS(2968),
    [anon_sym_AMP] = ACTIONS(2966),
    [anon_sym_SEMI] = ACTIONS(2968),
    [anon_sym___extension__] = ACTIONS(2966),
    [anon_sym_typedef] = ACTIONS(2966),
    [anon_sym_extern] = ACTIONS(2966),
    [anon_sym___attribute__] = ACTIONS(2966),
    [anon_sym_COLON_COLON] = ACTIONS(2968),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2968),
    [anon_sym___declspec] = ACTIONS(2966),
    [anon_sym___based] = ACTIONS(2966),
    [anon_sym___cdecl] = ACTIONS(2966),
    [anon_sym___clrcall] = ACTIONS(2966),
    [anon_sym___stdcall] = ACTIONS(2966),
    [anon_sym___fastcall] = ACTIONS(2966),
    [anon_sym___thiscall] = ACTIONS(2966),
    [anon_sym___vectorcall] = ACTIONS(2966),
    [anon_sym_LBRACE] = ACTIONS(2968),
    [anon_sym_signed] = ACTIONS(2966),
    [anon_sym_unsigned] = ACTIONS(2966),
    [anon_sym_long] = ACTIONS(2966),
    [anon_sym_short] = ACTIONS(2966),
    [anon_sym_LBRACK] = ACTIONS(2966),
    [anon_sym_static] = ACTIONS(2966),
    [anon_sym_register] = ACTIONS(2966),
    [anon_sym_inline] = ACTIONS(2966),
    [anon_sym___inline] = ACTIONS(2966),
    [anon_sym___inline__] = ACTIONS(2966),
    [anon_sym___forceinline] = ACTIONS(2966),
    [anon_sym_thread_local] = ACTIONS(2966),
    [anon_sym___thread] = ACTIONS(2966),
    [anon_sym_const] = ACTIONS(2966),
    [anon_sym_constexpr] = ACTIONS(2966),
    [anon_sym_volatile] = ACTIONS(2966),
    [anon_sym_restrict] = ACTIONS(2966),
    [anon_sym___restrict__] = ACTIONS(2966),
    [anon_sym__Atomic] = ACTIONS(2966),
    [anon_sym__Noreturn] = ACTIONS(2966),
    [anon_sym_noreturn] = ACTIONS(2966),
    [anon_sym_mutable] = ACTIONS(2966),
    [anon_sym_constinit] = ACTIONS(2966),
    [anon_sym_consteval] = ACTIONS(2966),
    [anon_sym_PROGMEM] = ACTIONS(2966),
    [aux_sym_primitive_type_token1] = ACTIONS(2966),
    [anon_sym_byte] = ACTIONS(2966),
    [anon_sym_word] = ACTIONS(2966),
    [anon_sym_enum] = ACTIONS(2966),
    [anon_sym_class] = ACTIONS(2966),
    [anon_sym_struct] = ACTIONS(2966),
    [anon_sym_union] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_else] = ACTIONS(2966),
    [anon_sym_switch] = ACTIONS(2966),
    [anon_sym_case] = ACTIONS(2966),
    [anon_sym_default] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_for] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2966),
    [anon_sym_break] = ACTIONS(2966),
    [anon_sym_continue] = ACTIONS(2966),
    [anon_sym_goto] = ACTIONS(2966),
    [anon_sym___try] = ACTIONS(2966),
    [anon_sym___leave] = ACTIONS(2966),
    [anon_sym_not] = ACTIONS(2966),
    [anon_sym_compl] = ACTIONS(2966),
    [anon_sym_DASH_DASH] = ACTIONS(2968),
    [anon_sym_PLUS_PLUS] = ACTIONS(2968),
    [anon_sym_sizeof] = ACTIONS(2966),
    [anon_sym___alignof__] = ACTIONS(2966),
    [anon_sym___alignof] = ACTIONS(2966),
    [anon_sym__alignof] = ACTIONS(2966),
    [anon_sym_alignof] = ACTIONS(2966),
    [anon_sym__Alignof] = ACTIONS(2966),
    [anon_sym_offsetof] = ACTIONS(2966),
    [anon_sym__Generic] = ACTIONS(2966),
    [anon_sym_asm] = ACTIONS(2966),
    [anon_sym___asm__] = ACTIONS(2966),
    [aux_sym_number_literal_token1] = ACTIONS(2968),
    [aux_sym_number_literal_token2] = ACTIONS(2966),
    [anon_sym_L_SQUOTE] = ACTIONS(2968),
    [anon_sym_u_SQUOTE] = ACTIONS(2968),
    [anon_sym_U_SQUOTE] = ACTIONS(2968),
    [anon_sym_u8_SQUOTE] = ACTIONS(2968),
    [anon_sym_SQUOTE] = ACTIONS(2968),
    [anon_sym_L_DQUOTE] = ACTIONS(2968),
    [anon_sym_u_DQUOTE] = ACTIONS(2968),
    [anon_sym_U_DQUOTE] = ACTIONS(2968),
    [anon_sym_u8_DQUOTE] = ACTIONS(2968),
    [anon_sym_DQUOTE] = ACTIONS(2968),
    [sym_true] = ACTIONS(2966),
    [sym_false] = ACTIONS(2966),
    [anon_sym_NULL] = ACTIONS(2966),
    [anon_sym_nullptr] = ACTIONS(2966),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2966),
    [anon_sym_decltype] = ACTIONS(2966),
    [anon_sym_virtual] = ACTIONS(2966),
    [anon_sym_alignas] = ACTIONS(2966),
    [anon_sym_explicit] = ACTIONS(2966),
    [anon_sym_typename] = ACTIONS(2966),
    [anon_sym_template] = ACTIONS(2966),
    [anon_sym_operator] = ACTIONS(2966),
    [anon_sym_try] = ACTIONS(2966),
    [anon_sym_delete] = ACTIONS(2966),
    [anon_sym_throw] = ACTIONS(2966),
    [anon_sym_namespace] = ACTIONS(2966),
    [anon_sym_using] = ACTIONS(2966),
    [anon_sym_static_assert] = ACTIONS(2966),
    [anon_sym_concept] = ACTIONS(2966),
    [anon_sym_co_return] = ACTIONS(2966),
    [anon_sym_co_yield] = ACTIONS(2966),
    [anon_sym_R_DQUOTE] = ACTIONS(2968),
    [anon_sym_LR_DQUOTE] = ACTIONS(2968),
    [anon_sym_uR_DQUOTE] = ACTIONS(2968),
    [anon_sym_UR_DQUOTE] = ACTIONS(2968),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2968),
    [anon_sym_co_await] = ACTIONS(2966),
    [anon_sym_new] = ACTIONS(2966),
    [anon_sym_requires] = ACTIONS(2966),
    [sym_this] = ACTIONS(2966),
  },
  [797] = {
    [sym_preproc_def] = STATE(1002),
    [sym_preproc_function_def] = STATE(1002),
    [sym_preproc_call] = STATE(1002),
    [sym_preproc_if_in_field_declaration_list] = STATE(1002),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1002),
    [sym_preproc_else_in_field_declaration_list] = STATE(8815),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8815),
    [sym_type_definition] = STATE(1002),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6507),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7114),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1002),
    [sym_field_declaration] = STATE(1002),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2150),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1002),
    [sym_operator_cast] = STATE(7493),
    [sym_inline_method_definition] = STATE(1002),
    [sym__constructor_specifiers] = STATE(2150),
    [sym_operator_cast_definition] = STATE(1002),
    [sym_operator_cast_declaration] = STATE(1002),
    [sym_constructor_or_destructor_definition] = STATE(1002),
    [sym_constructor_or_destructor_declaration] = STATE(1002),
    [sym_friend_declaration] = STATE(1002),
    [sym_access_specifier] = STATE(9075),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1002),
    [sym_alias_declaration] = STATE(1002),
    [sym_static_assert_declaration] = STATE(1002),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7493),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1002),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2150),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3563),
    [aux_sym_preproc_if_token1] = ACTIONS(3565),
    [aux_sym_preproc_if_token2] = ACTIONS(3591),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3569),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3569),
    [aux_sym_preproc_else_token1] = ACTIONS(3206),
    [aux_sym_preproc_elif_token1] = ACTIONS(3208),
    [sym_preproc_directive] = ACTIONS(3571),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3573),
    [anon_sym_typedef] = ACTIONS(3575),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3577),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3579),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3581),
    [anon_sym_static_assert] = ACTIONS(3583),
  },
  [798] = {
    [sym_identifier] = ACTIONS(3050),
    [aux_sym_preproc_include_token1] = ACTIONS(3050),
    [aux_sym_preproc_def_token1] = ACTIONS(3050),
    [aux_sym_preproc_if_token1] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3050),
    [sym_preproc_directive] = ACTIONS(3050),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3050),
    [anon_sym_PLUS] = ACTIONS(3050),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3050),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3050),
    [anon_sym_typedef] = ACTIONS(3050),
    [anon_sym_extern] = ACTIONS(3050),
    [anon_sym___attribute__] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3052),
    [anon_sym___declspec] = ACTIONS(3050),
    [anon_sym___based] = ACTIONS(3050),
    [anon_sym___cdecl] = ACTIONS(3050),
    [anon_sym___clrcall] = ACTIONS(3050),
    [anon_sym___stdcall] = ACTIONS(3050),
    [anon_sym___fastcall] = ACTIONS(3050),
    [anon_sym___thiscall] = ACTIONS(3050),
    [anon_sym___vectorcall] = ACTIONS(3050),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_RBRACE] = ACTIONS(3052),
    [anon_sym_signed] = ACTIONS(3050),
    [anon_sym_unsigned] = ACTIONS(3050),
    [anon_sym_long] = ACTIONS(3050),
    [anon_sym_short] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_static] = ACTIONS(3050),
    [anon_sym_register] = ACTIONS(3050),
    [anon_sym_inline] = ACTIONS(3050),
    [anon_sym___inline] = ACTIONS(3050),
    [anon_sym___inline__] = ACTIONS(3050),
    [anon_sym___forceinline] = ACTIONS(3050),
    [anon_sym_thread_local] = ACTIONS(3050),
    [anon_sym___thread] = ACTIONS(3050),
    [anon_sym_const] = ACTIONS(3050),
    [anon_sym_constexpr] = ACTIONS(3050),
    [anon_sym_volatile] = ACTIONS(3050),
    [anon_sym_restrict] = ACTIONS(3050),
    [anon_sym___restrict__] = ACTIONS(3050),
    [anon_sym__Atomic] = ACTIONS(3050),
    [anon_sym__Noreturn] = ACTIONS(3050),
    [anon_sym_noreturn] = ACTIONS(3050),
    [anon_sym_mutable] = ACTIONS(3050),
    [anon_sym_constinit] = ACTIONS(3050),
    [anon_sym_consteval] = ACTIONS(3050),
    [anon_sym_PROGMEM] = ACTIONS(3050),
    [aux_sym_primitive_type_token1] = ACTIONS(3050),
    [anon_sym_byte] = ACTIONS(3050),
    [anon_sym_word] = ACTIONS(3050),
    [anon_sym_enum] = ACTIONS(3050),
    [anon_sym_class] = ACTIONS(3050),
    [anon_sym_struct] = ACTIONS(3050),
    [anon_sym_union] = ACTIONS(3050),
    [anon_sym_if] = ACTIONS(3050),
    [anon_sym_else] = ACTIONS(3050),
    [anon_sym_switch] = ACTIONS(3050),
    [anon_sym_case] = ACTIONS(3050),
    [anon_sym_default] = ACTIONS(3050),
    [anon_sym_while] = ACTIONS(3050),
    [anon_sym_do] = ACTIONS(3050),
    [anon_sym_for] = ACTIONS(3050),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_break] = ACTIONS(3050),
    [anon_sym_continue] = ACTIONS(3050),
    [anon_sym_goto] = ACTIONS(3050),
    [anon_sym___try] = ACTIONS(3050),
    [anon_sym___leave] = ACTIONS(3050),
    [anon_sym_not] = ACTIONS(3050),
    [anon_sym_compl] = ACTIONS(3050),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_sizeof] = ACTIONS(3050),
    [anon_sym___alignof__] = ACTIONS(3050),
    [anon_sym___alignof] = ACTIONS(3050),
    [anon_sym__alignof] = ACTIONS(3050),
    [anon_sym_alignof] = ACTIONS(3050),
    [anon_sym__Alignof] = ACTIONS(3050),
    [anon_sym_offsetof] = ACTIONS(3050),
    [anon_sym__Generic] = ACTIONS(3050),
    [anon_sym_asm] = ACTIONS(3050),
    [anon_sym___asm__] = ACTIONS(3050),
    [aux_sym_number_literal_token1] = ACTIONS(3052),
    [aux_sym_number_literal_token2] = ACTIONS(3050),
    [anon_sym_L_SQUOTE] = ACTIONS(3052),
    [anon_sym_u_SQUOTE] = ACTIONS(3052),
    [anon_sym_U_SQUOTE] = ACTIONS(3052),
    [anon_sym_u8_SQUOTE] = ACTIONS(3052),
    [anon_sym_SQUOTE] = ACTIONS(3052),
    [anon_sym_L_DQUOTE] = ACTIONS(3052),
    [anon_sym_u_DQUOTE] = ACTIONS(3052),
    [anon_sym_U_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8_DQUOTE] = ACTIONS(3052),
    [anon_sym_DQUOTE] = ACTIONS(3052),
    [sym_true] = ACTIONS(3050),
    [sym_false] = ACTIONS(3050),
    [anon_sym_NULL] = ACTIONS(3050),
    [anon_sym_nullptr] = ACTIONS(3050),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3050),
    [anon_sym_decltype] = ACTIONS(3050),
    [anon_sym_virtual] = ACTIONS(3050),
    [anon_sym_alignas] = ACTIONS(3050),
    [anon_sym_explicit] = ACTIONS(3050),
    [anon_sym_typename] = ACTIONS(3050),
    [anon_sym_template] = ACTIONS(3050),
    [anon_sym_operator] = ACTIONS(3050),
    [anon_sym_try] = ACTIONS(3050),
    [anon_sym_delete] = ACTIONS(3050),
    [anon_sym_throw] = ACTIONS(3050),
    [anon_sym_namespace] = ACTIONS(3050),
    [anon_sym_using] = ACTIONS(3050),
    [anon_sym_static_assert] = ACTIONS(3050),
    [anon_sym_concept] = ACTIONS(3050),
    [anon_sym_co_return] = ACTIONS(3050),
    [anon_sym_co_yield] = ACTIONS(3050),
    [anon_sym_R_DQUOTE] = ACTIONS(3052),
    [anon_sym_LR_DQUOTE] = ACTIONS(3052),
    [anon_sym_uR_DQUOTE] = ACTIONS(3052),
    [anon_sym_UR_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3052),
    [anon_sym_co_await] = ACTIONS(3050),
    [anon_sym_new] = ACTIONS(3050),
    [anon_sym_requires] = ACTIONS(3050),
    [sym_this] = ACTIONS(3050),
  },
  [799] = {
    [sym_identifier] = ACTIONS(3108),
    [aux_sym_preproc_include_token1] = ACTIONS(3108),
    [aux_sym_preproc_def_token1] = ACTIONS(3108),
    [aux_sym_preproc_if_token1] = ACTIONS(3108),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3108),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3108),
    [sym_preproc_directive] = ACTIONS(3108),
    [anon_sym_LPAREN2] = ACTIONS(3110),
    [anon_sym_BANG] = ACTIONS(3110),
    [anon_sym_TILDE] = ACTIONS(3110),
    [anon_sym_DASH] = ACTIONS(3108),
    [anon_sym_PLUS] = ACTIONS(3108),
    [anon_sym_STAR] = ACTIONS(3110),
    [anon_sym_AMP_AMP] = ACTIONS(3110),
    [anon_sym_AMP] = ACTIONS(3108),
    [anon_sym_SEMI] = ACTIONS(3110),
    [anon_sym___extension__] = ACTIONS(3108),
    [anon_sym_typedef] = ACTIONS(3108),
    [anon_sym_extern] = ACTIONS(3108),
    [anon_sym___attribute__] = ACTIONS(3108),
    [anon_sym_COLON_COLON] = ACTIONS(3110),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3110),
    [anon_sym___declspec] = ACTIONS(3108),
    [anon_sym___based] = ACTIONS(3108),
    [anon_sym___cdecl] = ACTIONS(3108),
    [anon_sym___clrcall] = ACTIONS(3108),
    [anon_sym___stdcall] = ACTIONS(3108),
    [anon_sym___fastcall] = ACTIONS(3108),
    [anon_sym___thiscall] = ACTIONS(3108),
    [anon_sym___vectorcall] = ACTIONS(3108),
    [anon_sym_LBRACE] = ACTIONS(3110),
    [anon_sym_RBRACE] = ACTIONS(3110),
    [anon_sym_signed] = ACTIONS(3108),
    [anon_sym_unsigned] = ACTIONS(3108),
    [anon_sym_long] = ACTIONS(3108),
    [anon_sym_short] = ACTIONS(3108),
    [anon_sym_LBRACK] = ACTIONS(3108),
    [anon_sym_static] = ACTIONS(3108),
    [anon_sym_register] = ACTIONS(3108),
    [anon_sym_inline] = ACTIONS(3108),
    [anon_sym___inline] = ACTIONS(3108),
    [anon_sym___inline__] = ACTIONS(3108),
    [anon_sym___forceinline] = ACTIONS(3108),
    [anon_sym_thread_local] = ACTIONS(3108),
    [anon_sym___thread] = ACTIONS(3108),
    [anon_sym_const] = ACTIONS(3108),
    [anon_sym_constexpr] = ACTIONS(3108),
    [anon_sym_volatile] = ACTIONS(3108),
    [anon_sym_restrict] = ACTIONS(3108),
    [anon_sym___restrict__] = ACTIONS(3108),
    [anon_sym__Atomic] = ACTIONS(3108),
    [anon_sym__Noreturn] = ACTIONS(3108),
    [anon_sym_noreturn] = ACTIONS(3108),
    [anon_sym_mutable] = ACTIONS(3108),
    [anon_sym_constinit] = ACTIONS(3108),
    [anon_sym_consteval] = ACTIONS(3108),
    [anon_sym_PROGMEM] = ACTIONS(3108),
    [aux_sym_primitive_type_token1] = ACTIONS(3108),
    [anon_sym_byte] = ACTIONS(3108),
    [anon_sym_word] = ACTIONS(3108),
    [anon_sym_enum] = ACTIONS(3108),
    [anon_sym_class] = ACTIONS(3108),
    [anon_sym_struct] = ACTIONS(3108),
    [anon_sym_union] = ACTIONS(3108),
    [anon_sym_if] = ACTIONS(3108),
    [anon_sym_else] = ACTIONS(3108),
    [anon_sym_switch] = ACTIONS(3108),
    [anon_sym_case] = ACTIONS(3108),
    [anon_sym_default] = ACTIONS(3108),
    [anon_sym_while] = ACTIONS(3108),
    [anon_sym_do] = ACTIONS(3108),
    [anon_sym_for] = ACTIONS(3108),
    [anon_sym_return] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3108),
    [anon_sym_continue] = ACTIONS(3108),
    [anon_sym_goto] = ACTIONS(3108),
    [anon_sym___try] = ACTIONS(3108),
    [anon_sym___leave] = ACTIONS(3108),
    [anon_sym_not] = ACTIONS(3108),
    [anon_sym_compl] = ACTIONS(3108),
    [anon_sym_DASH_DASH] = ACTIONS(3110),
    [anon_sym_PLUS_PLUS] = ACTIONS(3110),
    [anon_sym_sizeof] = ACTIONS(3108),
    [anon_sym___alignof__] = ACTIONS(3108),
    [anon_sym___alignof] = ACTIONS(3108),
    [anon_sym__alignof] = ACTIONS(3108),
    [anon_sym_alignof] = ACTIONS(3108),
    [anon_sym__Alignof] = ACTIONS(3108),
    [anon_sym_offsetof] = ACTIONS(3108),
    [anon_sym__Generic] = ACTIONS(3108),
    [anon_sym_asm] = ACTIONS(3108),
    [anon_sym___asm__] = ACTIONS(3108),
    [aux_sym_number_literal_token1] = ACTIONS(3110),
    [aux_sym_number_literal_token2] = ACTIONS(3108),
    [anon_sym_L_SQUOTE] = ACTIONS(3110),
    [anon_sym_u_SQUOTE] = ACTIONS(3110),
    [anon_sym_U_SQUOTE] = ACTIONS(3110),
    [anon_sym_u8_SQUOTE] = ACTIONS(3110),
    [anon_sym_SQUOTE] = ACTIONS(3110),
    [anon_sym_L_DQUOTE] = ACTIONS(3110),
    [anon_sym_u_DQUOTE] = ACTIONS(3110),
    [anon_sym_U_DQUOTE] = ACTIONS(3110),
    [anon_sym_u8_DQUOTE] = ACTIONS(3110),
    [anon_sym_DQUOTE] = ACTIONS(3110),
    [sym_true] = ACTIONS(3108),
    [sym_false] = ACTIONS(3108),
    [anon_sym_NULL] = ACTIONS(3108),
    [anon_sym_nullptr] = ACTIONS(3108),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3108),
    [anon_sym_decltype] = ACTIONS(3108),
    [anon_sym_virtual] = ACTIONS(3108),
    [anon_sym_alignas] = ACTIONS(3108),
    [anon_sym_explicit] = ACTIONS(3108),
    [anon_sym_typename] = ACTIONS(3108),
    [anon_sym_template] = ACTIONS(3108),
    [anon_sym_operator] = ACTIONS(3108),
    [anon_sym_try] = ACTIONS(3108),
    [anon_sym_delete] = ACTIONS(3108),
    [anon_sym_throw] = ACTIONS(3108),
    [anon_sym_namespace] = ACTIONS(3108),
    [anon_sym_using] = ACTIONS(3108),
    [anon_sym_static_assert] = ACTIONS(3108),
    [anon_sym_concept] = ACTIONS(3108),
    [anon_sym_co_return] = ACTIONS(3108),
    [anon_sym_co_yield] = ACTIONS(3108),
    [anon_sym_R_DQUOTE] = ACTIONS(3110),
    [anon_sym_LR_DQUOTE] = ACTIONS(3110),
    [anon_sym_uR_DQUOTE] = ACTIONS(3110),
    [anon_sym_UR_DQUOTE] = ACTIONS(3110),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3110),
    [anon_sym_co_await] = ACTIONS(3108),
    [anon_sym_new] = ACTIONS(3108),
    [anon_sym_requires] = ACTIONS(3108),
    [sym_this] = ACTIONS(3108),
  },
  [800] = {
    [ts_builtin_sym_end] = ACTIONS(3084),
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_include_token1] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym___cdecl] = ACTIONS(3082),
    [anon_sym___clrcall] = ACTIONS(3082),
    [anon_sym___stdcall] = ACTIONS(3082),
    [anon_sym___fastcall] = ACTIONS(3082),
    [anon_sym___thiscall] = ACTIONS(3082),
    [anon_sym___vectorcall] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_else] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_goto] = ACTIONS(3082),
    [anon_sym___try] = ACTIONS(3082),
    [anon_sym___leave] = ACTIONS(3082),
    [anon_sym_not] = ACTIONS(3082),
    [anon_sym_compl] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_sizeof] = ACTIONS(3082),
    [anon_sym___alignof__] = ACTIONS(3082),
    [anon_sym___alignof] = ACTIONS(3082),
    [anon_sym__alignof] = ACTIONS(3082),
    [anon_sym_alignof] = ACTIONS(3082),
    [anon_sym__Alignof] = ACTIONS(3082),
    [anon_sym_offsetof] = ACTIONS(3082),
    [anon_sym__Generic] = ACTIONS(3082),
    [anon_sym_asm] = ACTIONS(3082),
    [anon_sym___asm__] = ACTIONS(3082),
    [aux_sym_number_literal_token1] = ACTIONS(3084),
    [aux_sym_number_literal_token2] = ACTIONS(3082),
    [anon_sym_L_SQUOTE] = ACTIONS(3084),
    [anon_sym_u_SQUOTE] = ACTIONS(3084),
    [anon_sym_U_SQUOTE] = ACTIONS(3084),
    [anon_sym_u8_SQUOTE] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_L_DQUOTE] = ACTIONS(3084),
    [anon_sym_u_DQUOTE] = ACTIONS(3084),
    [anon_sym_U_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8_DQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [anon_sym_NULL] = ACTIONS(3082),
    [anon_sym_nullptr] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
    [anon_sym_concept] = ACTIONS(3082),
    [anon_sym_co_return] = ACTIONS(3082),
    [anon_sym_co_yield] = ACTIONS(3082),
    [anon_sym_R_DQUOTE] = ACTIONS(3084),
    [anon_sym_LR_DQUOTE] = ACTIONS(3084),
    [anon_sym_uR_DQUOTE] = ACTIONS(3084),
    [anon_sym_UR_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3084),
    [anon_sym_co_await] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_requires] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
  },
  [801] = {
    [sym_identifier] = ACTIONS(2869),
    [aux_sym_preproc_include_token1] = ACTIONS(2869),
    [aux_sym_preproc_def_token1] = ACTIONS(2869),
    [aux_sym_preproc_if_token1] = ACTIONS(2869),
    [aux_sym_preproc_if_token2] = ACTIONS(2869),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2869),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2869),
    [sym_preproc_directive] = ACTIONS(2869),
    [anon_sym_LPAREN2] = ACTIONS(2874),
    [anon_sym_BANG] = ACTIONS(2874),
    [anon_sym_TILDE] = ACTIONS(2874),
    [anon_sym_DASH] = ACTIONS(2869),
    [anon_sym_PLUS] = ACTIONS(2869),
    [anon_sym_STAR] = ACTIONS(2874),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2869),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym___extension__] = ACTIONS(2869),
    [anon_sym_typedef] = ACTIONS(2869),
    [anon_sym_extern] = ACTIONS(2869),
    [anon_sym___attribute__] = ACTIONS(2869),
    [anon_sym_COLON_COLON] = ACTIONS(2874),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2874),
    [anon_sym___declspec] = ACTIONS(2869),
    [anon_sym___based] = ACTIONS(2869),
    [anon_sym___cdecl] = ACTIONS(2869),
    [anon_sym___clrcall] = ACTIONS(2869),
    [anon_sym___stdcall] = ACTIONS(2869),
    [anon_sym___fastcall] = ACTIONS(2869),
    [anon_sym___thiscall] = ACTIONS(2869),
    [anon_sym___vectorcall] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2874),
    [anon_sym_signed] = ACTIONS(2869),
    [anon_sym_unsigned] = ACTIONS(2869),
    [anon_sym_long] = ACTIONS(2869),
    [anon_sym_short] = ACTIONS(2869),
    [anon_sym_LBRACK] = ACTIONS(2869),
    [anon_sym_static] = ACTIONS(2869),
    [anon_sym_register] = ACTIONS(2869),
    [anon_sym_inline] = ACTIONS(2869),
    [anon_sym___inline] = ACTIONS(2869),
    [anon_sym___inline__] = ACTIONS(2869),
    [anon_sym___forceinline] = ACTIONS(2869),
    [anon_sym_thread_local] = ACTIONS(2869),
    [anon_sym___thread] = ACTIONS(2869),
    [anon_sym_const] = ACTIONS(2869),
    [anon_sym_constexpr] = ACTIONS(2869),
    [anon_sym_volatile] = ACTIONS(2869),
    [anon_sym_restrict] = ACTIONS(2869),
    [anon_sym___restrict__] = ACTIONS(2869),
    [anon_sym__Atomic] = ACTIONS(2869),
    [anon_sym__Noreturn] = ACTIONS(2869),
    [anon_sym_noreturn] = ACTIONS(2869),
    [anon_sym_mutable] = ACTIONS(2869),
    [anon_sym_constinit] = ACTIONS(2869),
    [anon_sym_consteval] = ACTIONS(2869),
    [anon_sym_PROGMEM] = ACTIONS(2869),
    [aux_sym_primitive_type_token1] = ACTIONS(2869),
    [anon_sym_byte] = ACTIONS(2869),
    [anon_sym_word] = ACTIONS(2869),
    [anon_sym_enum] = ACTIONS(2869),
    [anon_sym_class] = ACTIONS(2869),
    [anon_sym_struct] = ACTIONS(2869),
    [anon_sym_union] = ACTIONS(2869),
    [anon_sym_if] = ACTIONS(2869),
    [anon_sym_else] = ACTIONS(2869),
    [anon_sym_switch] = ACTIONS(2869),
    [anon_sym_case] = ACTIONS(2869),
    [anon_sym_default] = ACTIONS(2869),
    [anon_sym_while] = ACTIONS(2869),
    [anon_sym_do] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2869),
    [anon_sym_return] = ACTIONS(2869),
    [anon_sym_break] = ACTIONS(2869),
    [anon_sym_continue] = ACTIONS(2869),
    [anon_sym_goto] = ACTIONS(2869),
    [anon_sym___try] = ACTIONS(2869),
    [anon_sym___leave] = ACTIONS(2869),
    [anon_sym_not] = ACTIONS(2869),
    [anon_sym_compl] = ACTIONS(2869),
    [anon_sym_DASH_DASH] = ACTIONS(2874),
    [anon_sym_PLUS_PLUS] = ACTIONS(2874),
    [anon_sym_sizeof] = ACTIONS(2869),
    [anon_sym___alignof__] = ACTIONS(2869),
    [anon_sym___alignof] = ACTIONS(2869),
    [anon_sym__alignof] = ACTIONS(2869),
    [anon_sym_alignof] = ACTIONS(2869),
    [anon_sym__Alignof] = ACTIONS(2869),
    [anon_sym_offsetof] = ACTIONS(2869),
    [anon_sym__Generic] = ACTIONS(2869),
    [anon_sym_asm] = ACTIONS(2869),
    [anon_sym___asm__] = ACTIONS(2869),
    [aux_sym_number_literal_token1] = ACTIONS(2874),
    [aux_sym_number_literal_token2] = ACTIONS(2869),
    [anon_sym_L_SQUOTE] = ACTIONS(2874),
    [anon_sym_u_SQUOTE] = ACTIONS(2874),
    [anon_sym_U_SQUOTE] = ACTIONS(2874),
    [anon_sym_u8_SQUOTE] = ACTIONS(2874),
    [anon_sym_SQUOTE] = ACTIONS(2874),
    [anon_sym_L_DQUOTE] = ACTIONS(2874),
    [anon_sym_u_DQUOTE] = ACTIONS(2874),
    [anon_sym_U_DQUOTE] = ACTIONS(2874),
    [anon_sym_u8_DQUOTE] = ACTIONS(2874),
    [anon_sym_DQUOTE] = ACTIONS(2874),
    [sym_true] = ACTIONS(2869),
    [sym_false] = ACTIONS(2869),
    [anon_sym_NULL] = ACTIONS(2869),
    [anon_sym_nullptr] = ACTIONS(2869),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2869),
    [anon_sym_decltype] = ACTIONS(2869),
    [anon_sym_virtual] = ACTIONS(2869),
    [anon_sym_alignas] = ACTIONS(2869),
    [anon_sym_explicit] = ACTIONS(2869),
    [anon_sym_typename] = ACTIONS(2869),
    [anon_sym_template] = ACTIONS(2869),
    [anon_sym_operator] = ACTIONS(2869),
    [anon_sym_try] = ACTIONS(2869),
    [anon_sym_delete] = ACTIONS(2869),
    [anon_sym_throw] = ACTIONS(2869),
    [anon_sym_namespace] = ACTIONS(2869),
    [anon_sym_using] = ACTIONS(2869),
    [anon_sym_static_assert] = ACTIONS(2869),
    [anon_sym_concept] = ACTIONS(2869),
    [anon_sym_co_return] = ACTIONS(2869),
    [anon_sym_co_yield] = ACTIONS(2869),
    [anon_sym_R_DQUOTE] = ACTIONS(2874),
    [anon_sym_LR_DQUOTE] = ACTIONS(2874),
    [anon_sym_uR_DQUOTE] = ACTIONS(2874),
    [anon_sym_UR_DQUOTE] = ACTIONS(2874),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2874),
    [anon_sym_co_await] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2869),
    [sym_this] = ACTIONS(2869),
  },
  [802] = {
    [ts_builtin_sym_end] = ACTIONS(3084),
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_include_token1] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym___cdecl] = ACTIONS(3082),
    [anon_sym___clrcall] = ACTIONS(3082),
    [anon_sym___stdcall] = ACTIONS(3082),
    [anon_sym___fastcall] = ACTIONS(3082),
    [anon_sym___thiscall] = ACTIONS(3082),
    [anon_sym___vectorcall] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_else] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_goto] = ACTIONS(3082),
    [anon_sym___try] = ACTIONS(3082),
    [anon_sym___leave] = ACTIONS(3082),
    [anon_sym_not] = ACTIONS(3082),
    [anon_sym_compl] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_sizeof] = ACTIONS(3082),
    [anon_sym___alignof__] = ACTIONS(3082),
    [anon_sym___alignof] = ACTIONS(3082),
    [anon_sym__alignof] = ACTIONS(3082),
    [anon_sym_alignof] = ACTIONS(3082),
    [anon_sym__Alignof] = ACTIONS(3082),
    [anon_sym_offsetof] = ACTIONS(3082),
    [anon_sym__Generic] = ACTIONS(3082),
    [anon_sym_asm] = ACTIONS(3082),
    [anon_sym___asm__] = ACTIONS(3082),
    [aux_sym_number_literal_token1] = ACTIONS(3084),
    [aux_sym_number_literal_token2] = ACTIONS(3082),
    [anon_sym_L_SQUOTE] = ACTIONS(3084),
    [anon_sym_u_SQUOTE] = ACTIONS(3084),
    [anon_sym_U_SQUOTE] = ACTIONS(3084),
    [anon_sym_u8_SQUOTE] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_L_DQUOTE] = ACTIONS(3084),
    [anon_sym_u_DQUOTE] = ACTIONS(3084),
    [anon_sym_U_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8_DQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [anon_sym_NULL] = ACTIONS(3082),
    [anon_sym_nullptr] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
    [anon_sym_concept] = ACTIONS(3082),
    [anon_sym_co_return] = ACTIONS(3082),
    [anon_sym_co_yield] = ACTIONS(3082),
    [anon_sym_R_DQUOTE] = ACTIONS(3084),
    [anon_sym_LR_DQUOTE] = ACTIONS(3084),
    [anon_sym_uR_DQUOTE] = ACTIONS(3084),
    [anon_sym_UR_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3084),
    [anon_sym_co_await] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_requires] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
  },
  [803] = {
    [ts_builtin_sym_end] = ACTIONS(3088),
    [sym_identifier] = ACTIONS(3086),
    [aux_sym_preproc_include_token1] = ACTIONS(3086),
    [aux_sym_preproc_def_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3086),
    [sym_preproc_directive] = ACTIONS(3086),
    [anon_sym_LPAREN2] = ACTIONS(3088),
    [anon_sym_BANG] = ACTIONS(3088),
    [anon_sym_TILDE] = ACTIONS(3088),
    [anon_sym_DASH] = ACTIONS(3086),
    [anon_sym_PLUS] = ACTIONS(3086),
    [anon_sym_STAR] = ACTIONS(3088),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym_SEMI] = ACTIONS(3088),
    [anon_sym___extension__] = ACTIONS(3086),
    [anon_sym_typedef] = ACTIONS(3086),
    [anon_sym_extern] = ACTIONS(3086),
    [anon_sym___attribute__] = ACTIONS(3086),
    [anon_sym_COLON_COLON] = ACTIONS(3088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3088),
    [anon_sym___declspec] = ACTIONS(3086),
    [anon_sym___based] = ACTIONS(3086),
    [anon_sym___cdecl] = ACTIONS(3086),
    [anon_sym___clrcall] = ACTIONS(3086),
    [anon_sym___stdcall] = ACTIONS(3086),
    [anon_sym___fastcall] = ACTIONS(3086),
    [anon_sym___thiscall] = ACTIONS(3086),
    [anon_sym___vectorcall] = ACTIONS(3086),
    [anon_sym_LBRACE] = ACTIONS(3088),
    [anon_sym_signed] = ACTIONS(3086),
    [anon_sym_unsigned] = ACTIONS(3086),
    [anon_sym_long] = ACTIONS(3086),
    [anon_sym_short] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(3086),
    [anon_sym_static] = ACTIONS(3086),
    [anon_sym_register] = ACTIONS(3086),
    [anon_sym_inline] = ACTIONS(3086),
    [anon_sym___inline] = ACTIONS(3086),
    [anon_sym___inline__] = ACTIONS(3086),
    [anon_sym___forceinline] = ACTIONS(3086),
    [anon_sym_thread_local] = ACTIONS(3086),
    [anon_sym___thread] = ACTIONS(3086),
    [anon_sym_const] = ACTIONS(3086),
    [anon_sym_constexpr] = ACTIONS(3086),
    [anon_sym_volatile] = ACTIONS(3086),
    [anon_sym_restrict] = ACTIONS(3086),
    [anon_sym___restrict__] = ACTIONS(3086),
    [anon_sym__Atomic] = ACTIONS(3086),
    [anon_sym__Noreturn] = ACTIONS(3086),
    [anon_sym_noreturn] = ACTIONS(3086),
    [anon_sym_mutable] = ACTIONS(3086),
    [anon_sym_constinit] = ACTIONS(3086),
    [anon_sym_consteval] = ACTIONS(3086),
    [anon_sym_PROGMEM] = ACTIONS(3086),
    [aux_sym_primitive_type_token1] = ACTIONS(3086),
    [anon_sym_byte] = ACTIONS(3086),
    [anon_sym_word] = ACTIONS(3086),
    [anon_sym_enum] = ACTIONS(3086),
    [anon_sym_class] = ACTIONS(3086),
    [anon_sym_struct] = ACTIONS(3086),
    [anon_sym_union] = ACTIONS(3086),
    [anon_sym_if] = ACTIONS(3086),
    [anon_sym_else] = ACTIONS(3086),
    [anon_sym_switch] = ACTIONS(3086),
    [anon_sym_case] = ACTIONS(3086),
    [anon_sym_default] = ACTIONS(3086),
    [anon_sym_while] = ACTIONS(3086),
    [anon_sym_do] = ACTIONS(3086),
    [anon_sym_for] = ACTIONS(3086),
    [anon_sym_return] = ACTIONS(3086),
    [anon_sym_break] = ACTIONS(3086),
    [anon_sym_continue] = ACTIONS(3086),
    [anon_sym_goto] = ACTIONS(3086),
    [anon_sym___try] = ACTIONS(3086),
    [anon_sym___leave] = ACTIONS(3086),
    [anon_sym_not] = ACTIONS(3086),
    [anon_sym_compl] = ACTIONS(3086),
    [anon_sym_DASH_DASH] = ACTIONS(3088),
    [anon_sym_PLUS_PLUS] = ACTIONS(3088),
    [anon_sym_sizeof] = ACTIONS(3086),
    [anon_sym___alignof__] = ACTIONS(3086),
    [anon_sym___alignof] = ACTIONS(3086),
    [anon_sym__alignof] = ACTIONS(3086),
    [anon_sym_alignof] = ACTIONS(3086),
    [anon_sym__Alignof] = ACTIONS(3086),
    [anon_sym_offsetof] = ACTIONS(3086),
    [anon_sym__Generic] = ACTIONS(3086),
    [anon_sym_asm] = ACTIONS(3086),
    [anon_sym___asm__] = ACTIONS(3086),
    [aux_sym_number_literal_token1] = ACTIONS(3088),
    [aux_sym_number_literal_token2] = ACTIONS(3086),
    [anon_sym_L_SQUOTE] = ACTIONS(3088),
    [anon_sym_u_SQUOTE] = ACTIONS(3088),
    [anon_sym_U_SQUOTE] = ACTIONS(3088),
    [anon_sym_u8_SQUOTE] = ACTIONS(3088),
    [anon_sym_SQUOTE] = ACTIONS(3088),
    [anon_sym_L_DQUOTE] = ACTIONS(3088),
    [anon_sym_u_DQUOTE] = ACTIONS(3088),
    [anon_sym_U_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8_DQUOTE] = ACTIONS(3088),
    [anon_sym_DQUOTE] = ACTIONS(3088),
    [sym_true] = ACTIONS(3086),
    [sym_false] = ACTIONS(3086),
    [anon_sym_NULL] = ACTIONS(3086),
    [anon_sym_nullptr] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3086),
    [anon_sym_decltype] = ACTIONS(3086),
    [anon_sym_virtual] = ACTIONS(3086),
    [anon_sym_alignas] = ACTIONS(3086),
    [anon_sym_explicit] = ACTIONS(3086),
    [anon_sym_typename] = ACTIONS(3086),
    [anon_sym_template] = ACTIONS(3086),
    [anon_sym_operator] = ACTIONS(3086),
    [anon_sym_try] = ACTIONS(3086),
    [anon_sym_delete] = ACTIONS(3086),
    [anon_sym_throw] = ACTIONS(3086),
    [anon_sym_namespace] = ACTIONS(3086),
    [anon_sym_using] = ACTIONS(3086),
    [anon_sym_static_assert] = ACTIONS(3086),
    [anon_sym_concept] = ACTIONS(3086),
    [anon_sym_co_return] = ACTIONS(3086),
    [anon_sym_co_yield] = ACTIONS(3086),
    [anon_sym_R_DQUOTE] = ACTIONS(3088),
    [anon_sym_LR_DQUOTE] = ACTIONS(3088),
    [anon_sym_uR_DQUOTE] = ACTIONS(3088),
    [anon_sym_UR_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3088),
    [anon_sym_co_await] = ACTIONS(3086),
    [anon_sym_new] = ACTIONS(3086),
    [anon_sym_requires] = ACTIONS(3086),
    [sym_this] = ACTIONS(3086),
  },
  [804] = {
    [sym_identifier] = ACTIONS(3046),
    [aux_sym_preproc_include_token1] = ACTIONS(3046),
    [aux_sym_preproc_def_token1] = ACTIONS(3046),
    [aux_sym_preproc_if_token1] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3046),
    [sym_preproc_directive] = ACTIONS(3046),
    [anon_sym_LPAREN2] = ACTIONS(3048),
    [anon_sym_BANG] = ACTIONS(3048),
    [anon_sym_TILDE] = ACTIONS(3048),
    [anon_sym_DASH] = ACTIONS(3046),
    [anon_sym_PLUS] = ACTIONS(3046),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_AMP_AMP] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3046),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym___extension__] = ACTIONS(3046),
    [anon_sym_typedef] = ACTIONS(3046),
    [anon_sym_extern] = ACTIONS(3046),
    [anon_sym___attribute__] = ACTIONS(3046),
    [anon_sym_COLON_COLON] = ACTIONS(3048),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3048),
    [anon_sym___declspec] = ACTIONS(3046),
    [anon_sym___based] = ACTIONS(3046),
    [anon_sym___cdecl] = ACTIONS(3046),
    [anon_sym___clrcall] = ACTIONS(3046),
    [anon_sym___stdcall] = ACTIONS(3046),
    [anon_sym___fastcall] = ACTIONS(3046),
    [anon_sym___thiscall] = ACTIONS(3046),
    [anon_sym___vectorcall] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3048),
    [anon_sym_RBRACE] = ACTIONS(3048),
    [anon_sym_signed] = ACTIONS(3046),
    [anon_sym_unsigned] = ACTIONS(3046),
    [anon_sym_long] = ACTIONS(3046),
    [anon_sym_short] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_static] = ACTIONS(3046),
    [anon_sym_register] = ACTIONS(3046),
    [anon_sym_inline] = ACTIONS(3046),
    [anon_sym___inline] = ACTIONS(3046),
    [anon_sym___inline__] = ACTIONS(3046),
    [anon_sym___forceinline] = ACTIONS(3046),
    [anon_sym_thread_local] = ACTIONS(3046),
    [anon_sym___thread] = ACTIONS(3046),
    [anon_sym_const] = ACTIONS(3046),
    [anon_sym_constexpr] = ACTIONS(3046),
    [anon_sym_volatile] = ACTIONS(3046),
    [anon_sym_restrict] = ACTIONS(3046),
    [anon_sym___restrict__] = ACTIONS(3046),
    [anon_sym__Atomic] = ACTIONS(3046),
    [anon_sym__Noreturn] = ACTIONS(3046),
    [anon_sym_noreturn] = ACTIONS(3046),
    [anon_sym_mutable] = ACTIONS(3046),
    [anon_sym_constinit] = ACTIONS(3046),
    [anon_sym_consteval] = ACTIONS(3046),
    [anon_sym_PROGMEM] = ACTIONS(3046),
    [aux_sym_primitive_type_token1] = ACTIONS(3046),
    [anon_sym_byte] = ACTIONS(3046),
    [anon_sym_word] = ACTIONS(3046),
    [anon_sym_enum] = ACTIONS(3046),
    [anon_sym_class] = ACTIONS(3046),
    [anon_sym_struct] = ACTIONS(3046),
    [anon_sym_union] = ACTIONS(3046),
    [anon_sym_if] = ACTIONS(3046),
    [anon_sym_else] = ACTIONS(3046),
    [anon_sym_switch] = ACTIONS(3046),
    [anon_sym_case] = ACTIONS(3046),
    [anon_sym_default] = ACTIONS(3046),
    [anon_sym_while] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_for] = ACTIONS(3046),
    [anon_sym_return] = ACTIONS(3046),
    [anon_sym_break] = ACTIONS(3046),
    [anon_sym_continue] = ACTIONS(3046),
    [anon_sym_goto] = ACTIONS(3046),
    [anon_sym___try] = ACTIONS(3046),
    [anon_sym___leave] = ACTIONS(3046),
    [anon_sym_not] = ACTIONS(3046),
    [anon_sym_compl] = ACTIONS(3046),
    [anon_sym_DASH_DASH] = ACTIONS(3048),
    [anon_sym_PLUS_PLUS] = ACTIONS(3048),
    [anon_sym_sizeof] = ACTIONS(3046),
    [anon_sym___alignof__] = ACTIONS(3046),
    [anon_sym___alignof] = ACTIONS(3046),
    [anon_sym__alignof] = ACTIONS(3046),
    [anon_sym_alignof] = ACTIONS(3046),
    [anon_sym__Alignof] = ACTIONS(3046),
    [anon_sym_offsetof] = ACTIONS(3046),
    [anon_sym__Generic] = ACTIONS(3046),
    [anon_sym_asm] = ACTIONS(3046),
    [anon_sym___asm__] = ACTIONS(3046),
    [aux_sym_number_literal_token1] = ACTIONS(3048),
    [aux_sym_number_literal_token2] = ACTIONS(3046),
    [anon_sym_L_SQUOTE] = ACTIONS(3048),
    [anon_sym_u_SQUOTE] = ACTIONS(3048),
    [anon_sym_U_SQUOTE] = ACTIONS(3048),
    [anon_sym_u8_SQUOTE] = ACTIONS(3048),
    [anon_sym_SQUOTE] = ACTIONS(3048),
    [anon_sym_L_DQUOTE] = ACTIONS(3048),
    [anon_sym_u_DQUOTE] = ACTIONS(3048),
    [anon_sym_U_DQUOTE] = ACTIONS(3048),
    [anon_sym_u8_DQUOTE] = ACTIONS(3048),
    [anon_sym_DQUOTE] = ACTIONS(3048),
    [sym_true] = ACTIONS(3046),
    [sym_false] = ACTIONS(3046),
    [anon_sym_NULL] = ACTIONS(3046),
    [anon_sym_nullptr] = ACTIONS(3046),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3046),
    [anon_sym_decltype] = ACTIONS(3046),
    [anon_sym_virtual] = ACTIONS(3046),
    [anon_sym_alignas] = ACTIONS(3046),
    [anon_sym_explicit] = ACTIONS(3046),
    [anon_sym_typename] = ACTIONS(3046),
    [anon_sym_template] = ACTIONS(3046),
    [anon_sym_operator] = ACTIONS(3046),
    [anon_sym_try] = ACTIONS(3046),
    [anon_sym_delete] = ACTIONS(3046),
    [anon_sym_throw] = ACTIONS(3046),
    [anon_sym_namespace] = ACTIONS(3046),
    [anon_sym_using] = ACTIONS(3046),
    [anon_sym_static_assert] = ACTIONS(3046),
    [anon_sym_concept] = ACTIONS(3046),
    [anon_sym_co_return] = ACTIONS(3046),
    [anon_sym_co_yield] = ACTIONS(3046),
    [anon_sym_R_DQUOTE] = ACTIONS(3048),
    [anon_sym_LR_DQUOTE] = ACTIONS(3048),
    [anon_sym_uR_DQUOTE] = ACTIONS(3048),
    [anon_sym_UR_DQUOTE] = ACTIONS(3048),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3048),
    [anon_sym_co_await] = ACTIONS(3046),
    [anon_sym_new] = ACTIONS(3046),
    [anon_sym_requires] = ACTIONS(3046),
    [sym_this] = ACTIONS(3046),
  },
  [805] = {
    [sym_identifier] = ACTIONS(3154),
    [aux_sym_preproc_include_token1] = ACTIONS(3154),
    [aux_sym_preproc_def_token1] = ACTIONS(3154),
    [aux_sym_preproc_if_token1] = ACTIONS(3154),
    [aux_sym_preproc_if_token2] = ACTIONS(3154),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3154),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3154),
    [sym_preproc_directive] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3156),
    [anon_sym_BANG] = ACTIONS(3156),
    [anon_sym_TILDE] = ACTIONS(3156),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_STAR] = ACTIONS(3156),
    [anon_sym_AMP_AMP] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3154),
    [anon_sym_SEMI] = ACTIONS(3156),
    [anon_sym___extension__] = ACTIONS(3154),
    [anon_sym_typedef] = ACTIONS(3154),
    [anon_sym_extern] = ACTIONS(3154),
    [anon_sym___attribute__] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3156),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3156),
    [anon_sym___declspec] = ACTIONS(3154),
    [anon_sym___based] = ACTIONS(3154),
    [anon_sym___cdecl] = ACTIONS(3154),
    [anon_sym___clrcall] = ACTIONS(3154),
    [anon_sym___stdcall] = ACTIONS(3154),
    [anon_sym___fastcall] = ACTIONS(3154),
    [anon_sym___thiscall] = ACTIONS(3154),
    [anon_sym___vectorcall] = ACTIONS(3154),
    [anon_sym_LBRACE] = ACTIONS(3156),
    [anon_sym_signed] = ACTIONS(3154),
    [anon_sym_unsigned] = ACTIONS(3154),
    [anon_sym_long] = ACTIONS(3154),
    [anon_sym_short] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_static] = ACTIONS(3154),
    [anon_sym_register] = ACTIONS(3154),
    [anon_sym_inline] = ACTIONS(3154),
    [anon_sym___inline] = ACTIONS(3154),
    [anon_sym___inline__] = ACTIONS(3154),
    [anon_sym___forceinline] = ACTIONS(3154),
    [anon_sym_thread_local] = ACTIONS(3154),
    [anon_sym___thread] = ACTIONS(3154),
    [anon_sym_const] = ACTIONS(3154),
    [anon_sym_constexpr] = ACTIONS(3154),
    [anon_sym_volatile] = ACTIONS(3154),
    [anon_sym_restrict] = ACTIONS(3154),
    [anon_sym___restrict__] = ACTIONS(3154),
    [anon_sym__Atomic] = ACTIONS(3154),
    [anon_sym__Noreturn] = ACTIONS(3154),
    [anon_sym_noreturn] = ACTIONS(3154),
    [anon_sym_mutable] = ACTIONS(3154),
    [anon_sym_constinit] = ACTIONS(3154),
    [anon_sym_consteval] = ACTIONS(3154),
    [anon_sym_PROGMEM] = ACTIONS(3154),
    [aux_sym_primitive_type_token1] = ACTIONS(3154),
    [anon_sym_byte] = ACTIONS(3154),
    [anon_sym_word] = ACTIONS(3154),
    [anon_sym_enum] = ACTIONS(3154),
    [anon_sym_class] = ACTIONS(3154),
    [anon_sym_struct] = ACTIONS(3154),
    [anon_sym_union] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_else] = ACTIONS(3154),
    [anon_sym_switch] = ACTIONS(3154),
    [anon_sym_case] = ACTIONS(3154),
    [anon_sym_default] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_break] = ACTIONS(3154),
    [anon_sym_continue] = ACTIONS(3154),
    [anon_sym_goto] = ACTIONS(3154),
    [anon_sym___try] = ACTIONS(3154),
    [anon_sym___leave] = ACTIONS(3154),
    [anon_sym_not] = ACTIONS(3154),
    [anon_sym_compl] = ACTIONS(3154),
    [anon_sym_DASH_DASH] = ACTIONS(3156),
    [anon_sym_PLUS_PLUS] = ACTIONS(3156),
    [anon_sym_sizeof] = ACTIONS(3154),
    [anon_sym___alignof__] = ACTIONS(3154),
    [anon_sym___alignof] = ACTIONS(3154),
    [anon_sym__alignof] = ACTIONS(3154),
    [anon_sym_alignof] = ACTIONS(3154),
    [anon_sym__Alignof] = ACTIONS(3154),
    [anon_sym_offsetof] = ACTIONS(3154),
    [anon_sym__Generic] = ACTIONS(3154),
    [anon_sym_asm] = ACTIONS(3154),
    [anon_sym___asm__] = ACTIONS(3154),
    [aux_sym_number_literal_token1] = ACTIONS(3156),
    [aux_sym_number_literal_token2] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3156),
    [anon_sym_u_DQUOTE] = ACTIONS(3156),
    [anon_sym_U_DQUOTE] = ACTIONS(3156),
    [anon_sym_u8_DQUOTE] = ACTIONS(3156),
    [anon_sym_DQUOTE] = ACTIONS(3156),
    [sym_true] = ACTIONS(3154),
    [sym_false] = ACTIONS(3154),
    [anon_sym_NULL] = ACTIONS(3154),
    [anon_sym_nullptr] = ACTIONS(3154),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3154),
    [anon_sym_decltype] = ACTIONS(3154),
    [anon_sym_virtual] = ACTIONS(3154),
    [anon_sym_alignas] = ACTIONS(3154),
    [anon_sym_explicit] = ACTIONS(3154),
    [anon_sym_typename] = ACTIONS(3154),
    [anon_sym_template] = ACTIONS(3154),
    [anon_sym_operator] = ACTIONS(3154),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_delete] = ACTIONS(3154),
    [anon_sym_throw] = ACTIONS(3154),
    [anon_sym_namespace] = ACTIONS(3154),
    [anon_sym_using] = ACTIONS(3154),
    [anon_sym_static_assert] = ACTIONS(3154),
    [anon_sym_concept] = ACTIONS(3154),
    [anon_sym_co_return] = ACTIONS(3154),
    [anon_sym_co_yield] = ACTIONS(3154),
    [anon_sym_R_DQUOTE] = ACTIONS(3156),
    [anon_sym_LR_DQUOTE] = ACTIONS(3156),
    [anon_sym_uR_DQUOTE] = ACTIONS(3156),
    [anon_sym_UR_DQUOTE] = ACTIONS(3156),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3156),
    [anon_sym_co_await] = ACTIONS(3154),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_requires] = ACTIONS(3154),
    [sym_this] = ACTIONS(3154),
  },
  [806] = {
    [sym_identifier] = ACTIONS(3144),
    [aux_sym_preproc_include_token1] = ACTIONS(3144),
    [aux_sym_preproc_def_token1] = ACTIONS(3144),
    [aux_sym_preproc_if_token1] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3144),
    [sym_preproc_directive] = ACTIONS(3144),
    [anon_sym_LPAREN2] = ACTIONS(3146),
    [anon_sym_BANG] = ACTIONS(3146),
    [anon_sym_TILDE] = ACTIONS(3146),
    [anon_sym_DASH] = ACTIONS(3144),
    [anon_sym_PLUS] = ACTIONS(3144),
    [anon_sym_STAR] = ACTIONS(3146),
    [anon_sym_AMP_AMP] = ACTIONS(3146),
    [anon_sym_AMP] = ACTIONS(3144),
    [anon_sym_SEMI] = ACTIONS(3146),
    [anon_sym___extension__] = ACTIONS(3144),
    [anon_sym_typedef] = ACTIONS(3144),
    [anon_sym_extern] = ACTIONS(3144),
    [anon_sym___attribute__] = ACTIONS(3144),
    [anon_sym_COLON_COLON] = ACTIONS(3146),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3146),
    [anon_sym___declspec] = ACTIONS(3144),
    [anon_sym___based] = ACTIONS(3144),
    [anon_sym___cdecl] = ACTIONS(3144),
    [anon_sym___clrcall] = ACTIONS(3144),
    [anon_sym___stdcall] = ACTIONS(3144),
    [anon_sym___fastcall] = ACTIONS(3144),
    [anon_sym___thiscall] = ACTIONS(3144),
    [anon_sym___vectorcall] = ACTIONS(3144),
    [anon_sym_LBRACE] = ACTIONS(3146),
    [anon_sym_RBRACE] = ACTIONS(3146),
    [anon_sym_signed] = ACTIONS(3144),
    [anon_sym_unsigned] = ACTIONS(3144),
    [anon_sym_long] = ACTIONS(3144),
    [anon_sym_short] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3144),
    [anon_sym_static] = ACTIONS(3144),
    [anon_sym_register] = ACTIONS(3144),
    [anon_sym_inline] = ACTIONS(3144),
    [anon_sym___inline] = ACTIONS(3144),
    [anon_sym___inline__] = ACTIONS(3144),
    [anon_sym___forceinline] = ACTIONS(3144),
    [anon_sym_thread_local] = ACTIONS(3144),
    [anon_sym___thread] = ACTIONS(3144),
    [anon_sym_const] = ACTIONS(3144),
    [anon_sym_constexpr] = ACTIONS(3144),
    [anon_sym_volatile] = ACTIONS(3144),
    [anon_sym_restrict] = ACTIONS(3144),
    [anon_sym___restrict__] = ACTIONS(3144),
    [anon_sym__Atomic] = ACTIONS(3144),
    [anon_sym__Noreturn] = ACTIONS(3144),
    [anon_sym_noreturn] = ACTIONS(3144),
    [anon_sym_mutable] = ACTIONS(3144),
    [anon_sym_constinit] = ACTIONS(3144),
    [anon_sym_consteval] = ACTIONS(3144),
    [anon_sym_PROGMEM] = ACTIONS(3144),
    [aux_sym_primitive_type_token1] = ACTIONS(3144),
    [anon_sym_byte] = ACTIONS(3144),
    [anon_sym_word] = ACTIONS(3144),
    [anon_sym_enum] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_struct] = ACTIONS(3144),
    [anon_sym_union] = ACTIONS(3144),
    [anon_sym_if] = ACTIONS(3144),
    [anon_sym_else] = ACTIONS(3144),
    [anon_sym_switch] = ACTIONS(3144),
    [anon_sym_case] = ACTIONS(3144),
    [anon_sym_default] = ACTIONS(3144),
    [anon_sym_while] = ACTIONS(3144),
    [anon_sym_do] = ACTIONS(3144),
    [anon_sym_for] = ACTIONS(3144),
    [anon_sym_return] = ACTIONS(3144),
    [anon_sym_break] = ACTIONS(3144),
    [anon_sym_continue] = ACTIONS(3144),
    [anon_sym_goto] = ACTIONS(3144),
    [anon_sym___try] = ACTIONS(3144),
    [anon_sym___leave] = ACTIONS(3144),
    [anon_sym_not] = ACTIONS(3144),
    [anon_sym_compl] = ACTIONS(3144),
    [anon_sym_DASH_DASH] = ACTIONS(3146),
    [anon_sym_PLUS_PLUS] = ACTIONS(3146),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3144),
    [anon_sym___alignof] = ACTIONS(3144),
    [anon_sym__alignof] = ACTIONS(3144),
    [anon_sym_alignof] = ACTIONS(3144),
    [anon_sym__Alignof] = ACTIONS(3144),
    [anon_sym_offsetof] = ACTIONS(3144),
    [anon_sym__Generic] = ACTIONS(3144),
    [anon_sym_asm] = ACTIONS(3144),
    [anon_sym___asm__] = ACTIONS(3144),
    [aux_sym_number_literal_token1] = ACTIONS(3146),
    [aux_sym_number_literal_token2] = ACTIONS(3144),
    [anon_sym_L_SQUOTE] = ACTIONS(3146),
    [anon_sym_u_SQUOTE] = ACTIONS(3146),
    [anon_sym_U_SQUOTE] = ACTIONS(3146),
    [anon_sym_u8_SQUOTE] = ACTIONS(3146),
    [anon_sym_SQUOTE] = ACTIONS(3146),
    [anon_sym_L_DQUOTE] = ACTIONS(3146),
    [anon_sym_u_DQUOTE] = ACTIONS(3146),
    [anon_sym_U_DQUOTE] = ACTIONS(3146),
    [anon_sym_u8_DQUOTE] = ACTIONS(3146),
    [anon_sym_DQUOTE] = ACTIONS(3146),
    [sym_true] = ACTIONS(3144),
    [sym_false] = ACTIONS(3144),
    [anon_sym_NULL] = ACTIONS(3144),
    [anon_sym_nullptr] = ACTIONS(3144),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3144),
    [anon_sym_decltype] = ACTIONS(3144),
    [anon_sym_virtual] = ACTIONS(3144),
    [anon_sym_alignas] = ACTIONS(3144),
    [anon_sym_explicit] = ACTIONS(3144),
    [anon_sym_typename] = ACTIONS(3144),
    [anon_sym_template] = ACTIONS(3144),
    [anon_sym_operator] = ACTIONS(3144),
    [anon_sym_try] = ACTIONS(3144),
    [anon_sym_delete] = ACTIONS(3144),
    [anon_sym_throw] = ACTIONS(3144),
    [anon_sym_namespace] = ACTIONS(3144),
    [anon_sym_using] = ACTIONS(3144),
    [anon_sym_static_assert] = ACTIONS(3144),
    [anon_sym_concept] = ACTIONS(3144),
    [anon_sym_co_return] = ACTIONS(3144),
    [anon_sym_co_yield] = ACTIONS(3144),
    [anon_sym_R_DQUOTE] = ACTIONS(3146),
    [anon_sym_LR_DQUOTE] = ACTIONS(3146),
    [anon_sym_uR_DQUOTE] = ACTIONS(3146),
    [anon_sym_UR_DQUOTE] = ACTIONS(3146),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3146),
    [anon_sym_co_await] = ACTIONS(3144),
    [anon_sym_new] = ACTIONS(3144),
    [anon_sym_requires] = ACTIONS(3144),
    [sym_this] = ACTIONS(3144),
  },
  [807] = {
    [sym_identifier] = ACTIONS(2970),
    [aux_sym_preproc_include_token1] = ACTIONS(2970),
    [aux_sym_preproc_def_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token1] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2970),
    [sym_preproc_directive] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_BANG] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym___extension__] = ACTIONS(2970),
    [anon_sym_typedef] = ACTIONS(2970),
    [anon_sym_extern] = ACTIONS(2970),
    [anon_sym___attribute__] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2970),
    [anon_sym___based] = ACTIONS(2970),
    [anon_sym___cdecl] = ACTIONS(2970),
    [anon_sym___clrcall] = ACTIONS(2970),
    [anon_sym___stdcall] = ACTIONS(2970),
    [anon_sym___fastcall] = ACTIONS(2970),
    [anon_sym___thiscall] = ACTIONS(2970),
    [anon_sym___vectorcall] = ACTIONS(2970),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_signed] = ACTIONS(2970),
    [anon_sym_unsigned] = ACTIONS(2970),
    [anon_sym_long] = ACTIONS(2970),
    [anon_sym_short] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_register] = ACTIONS(2970),
    [anon_sym_inline] = ACTIONS(2970),
    [anon_sym___inline] = ACTIONS(2970),
    [anon_sym___inline__] = ACTIONS(2970),
    [anon_sym___forceinline] = ACTIONS(2970),
    [anon_sym_thread_local] = ACTIONS(2970),
    [anon_sym___thread] = ACTIONS(2970),
    [anon_sym_const] = ACTIONS(2970),
    [anon_sym_constexpr] = ACTIONS(2970),
    [anon_sym_volatile] = ACTIONS(2970),
    [anon_sym_restrict] = ACTIONS(2970),
    [anon_sym___restrict__] = ACTIONS(2970),
    [anon_sym__Atomic] = ACTIONS(2970),
    [anon_sym__Noreturn] = ACTIONS(2970),
    [anon_sym_noreturn] = ACTIONS(2970),
    [anon_sym_mutable] = ACTIONS(2970),
    [anon_sym_constinit] = ACTIONS(2970),
    [anon_sym_consteval] = ACTIONS(2970),
    [anon_sym_PROGMEM] = ACTIONS(2970),
    [aux_sym_primitive_type_token1] = ACTIONS(2970),
    [anon_sym_byte] = ACTIONS(2970),
    [anon_sym_word] = ACTIONS(2970),
    [anon_sym_enum] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_struct] = ACTIONS(2970),
    [anon_sym_union] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_else] = ACTIONS(2970),
    [anon_sym_switch] = ACTIONS(2970),
    [anon_sym_case] = ACTIONS(2970),
    [anon_sym_default] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_break] = ACTIONS(2970),
    [anon_sym_continue] = ACTIONS(2970),
    [anon_sym_goto] = ACTIONS(2970),
    [anon_sym___try] = ACTIONS(2970),
    [anon_sym___leave] = ACTIONS(2970),
    [anon_sym_not] = ACTIONS(2970),
    [anon_sym_compl] = ACTIONS(2970),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_sizeof] = ACTIONS(2970),
    [anon_sym___alignof__] = ACTIONS(2970),
    [anon_sym___alignof] = ACTIONS(2970),
    [anon_sym__alignof] = ACTIONS(2970),
    [anon_sym_alignof] = ACTIONS(2970),
    [anon_sym__Alignof] = ACTIONS(2970),
    [anon_sym_offsetof] = ACTIONS(2970),
    [anon_sym__Generic] = ACTIONS(2970),
    [anon_sym_asm] = ACTIONS(2970),
    [anon_sym___asm__] = ACTIONS(2970),
    [aux_sym_number_literal_token1] = ACTIONS(2972),
    [aux_sym_number_literal_token2] = ACTIONS(2970),
    [anon_sym_L_SQUOTE] = ACTIONS(2972),
    [anon_sym_u_SQUOTE] = ACTIONS(2972),
    [anon_sym_U_SQUOTE] = ACTIONS(2972),
    [anon_sym_u8_SQUOTE] = ACTIONS(2972),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [anon_sym_L_DQUOTE] = ACTIONS(2972),
    [anon_sym_u_DQUOTE] = ACTIONS(2972),
    [anon_sym_U_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE] = ACTIONS(2972),
    [sym_true] = ACTIONS(2970),
    [sym_false] = ACTIONS(2970),
    [anon_sym_NULL] = ACTIONS(2970),
    [anon_sym_nullptr] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2970),
    [anon_sym_decltype] = ACTIONS(2970),
    [anon_sym_virtual] = ACTIONS(2970),
    [anon_sym_alignas] = ACTIONS(2970),
    [anon_sym_explicit] = ACTIONS(2970),
    [anon_sym_typename] = ACTIONS(2970),
    [anon_sym_template] = ACTIONS(2970),
    [anon_sym_operator] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_delete] = ACTIONS(2970),
    [anon_sym_throw] = ACTIONS(2970),
    [anon_sym_namespace] = ACTIONS(2970),
    [anon_sym_using] = ACTIONS(2970),
    [anon_sym_static_assert] = ACTIONS(2970),
    [anon_sym_concept] = ACTIONS(2970),
    [anon_sym_co_return] = ACTIONS(2970),
    [anon_sym_co_yield] = ACTIONS(2970),
    [anon_sym_R_DQUOTE] = ACTIONS(2972),
    [anon_sym_LR_DQUOTE] = ACTIONS(2972),
    [anon_sym_uR_DQUOTE] = ACTIONS(2972),
    [anon_sym_UR_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2972),
    [anon_sym_co_await] = ACTIONS(2970),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_requires] = ACTIONS(2970),
    [sym_this] = ACTIONS(2970),
  },
  [808] = {
    [sym_identifier] = ACTIONS(3144),
    [aux_sym_preproc_include_token1] = ACTIONS(3144),
    [aux_sym_preproc_def_token1] = ACTIONS(3144),
    [aux_sym_preproc_if_token1] = ACTIONS(3144),
    [aux_sym_preproc_if_token2] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3144),
    [sym_preproc_directive] = ACTIONS(3144),
    [anon_sym_LPAREN2] = ACTIONS(3146),
    [anon_sym_BANG] = ACTIONS(3146),
    [anon_sym_TILDE] = ACTIONS(3146),
    [anon_sym_DASH] = ACTIONS(3144),
    [anon_sym_PLUS] = ACTIONS(3144),
    [anon_sym_STAR] = ACTIONS(3146),
    [anon_sym_AMP_AMP] = ACTIONS(3146),
    [anon_sym_AMP] = ACTIONS(3144),
    [anon_sym_SEMI] = ACTIONS(3146),
    [anon_sym___extension__] = ACTIONS(3144),
    [anon_sym_typedef] = ACTIONS(3144),
    [anon_sym_extern] = ACTIONS(3144),
    [anon_sym___attribute__] = ACTIONS(3144),
    [anon_sym_COLON_COLON] = ACTIONS(3146),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3146),
    [anon_sym___declspec] = ACTIONS(3144),
    [anon_sym___based] = ACTIONS(3144),
    [anon_sym___cdecl] = ACTIONS(3144),
    [anon_sym___clrcall] = ACTIONS(3144),
    [anon_sym___stdcall] = ACTIONS(3144),
    [anon_sym___fastcall] = ACTIONS(3144),
    [anon_sym___thiscall] = ACTIONS(3144),
    [anon_sym___vectorcall] = ACTIONS(3144),
    [anon_sym_LBRACE] = ACTIONS(3146),
    [anon_sym_signed] = ACTIONS(3144),
    [anon_sym_unsigned] = ACTIONS(3144),
    [anon_sym_long] = ACTIONS(3144),
    [anon_sym_short] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3144),
    [anon_sym_static] = ACTIONS(3144),
    [anon_sym_register] = ACTIONS(3144),
    [anon_sym_inline] = ACTIONS(3144),
    [anon_sym___inline] = ACTIONS(3144),
    [anon_sym___inline__] = ACTIONS(3144),
    [anon_sym___forceinline] = ACTIONS(3144),
    [anon_sym_thread_local] = ACTIONS(3144),
    [anon_sym___thread] = ACTIONS(3144),
    [anon_sym_const] = ACTIONS(3144),
    [anon_sym_constexpr] = ACTIONS(3144),
    [anon_sym_volatile] = ACTIONS(3144),
    [anon_sym_restrict] = ACTIONS(3144),
    [anon_sym___restrict__] = ACTIONS(3144),
    [anon_sym__Atomic] = ACTIONS(3144),
    [anon_sym__Noreturn] = ACTIONS(3144),
    [anon_sym_noreturn] = ACTIONS(3144),
    [anon_sym_mutable] = ACTIONS(3144),
    [anon_sym_constinit] = ACTIONS(3144),
    [anon_sym_consteval] = ACTIONS(3144),
    [anon_sym_PROGMEM] = ACTIONS(3144),
    [aux_sym_primitive_type_token1] = ACTIONS(3144),
    [anon_sym_byte] = ACTIONS(3144),
    [anon_sym_word] = ACTIONS(3144),
    [anon_sym_enum] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_struct] = ACTIONS(3144),
    [anon_sym_union] = ACTIONS(3144),
    [anon_sym_if] = ACTIONS(3144),
    [anon_sym_else] = ACTIONS(3144),
    [anon_sym_switch] = ACTIONS(3144),
    [anon_sym_case] = ACTIONS(3144),
    [anon_sym_default] = ACTIONS(3144),
    [anon_sym_while] = ACTIONS(3144),
    [anon_sym_do] = ACTIONS(3144),
    [anon_sym_for] = ACTIONS(3144),
    [anon_sym_return] = ACTIONS(3144),
    [anon_sym_break] = ACTIONS(3144),
    [anon_sym_continue] = ACTIONS(3144),
    [anon_sym_goto] = ACTIONS(3144),
    [anon_sym___try] = ACTIONS(3144),
    [anon_sym___leave] = ACTIONS(3144),
    [anon_sym_not] = ACTIONS(3144),
    [anon_sym_compl] = ACTIONS(3144),
    [anon_sym_DASH_DASH] = ACTIONS(3146),
    [anon_sym_PLUS_PLUS] = ACTIONS(3146),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3144),
    [anon_sym___alignof] = ACTIONS(3144),
    [anon_sym__alignof] = ACTIONS(3144),
    [anon_sym_alignof] = ACTIONS(3144),
    [anon_sym__Alignof] = ACTIONS(3144),
    [anon_sym_offsetof] = ACTIONS(3144),
    [anon_sym__Generic] = ACTIONS(3144),
    [anon_sym_asm] = ACTIONS(3144),
    [anon_sym___asm__] = ACTIONS(3144),
    [aux_sym_number_literal_token1] = ACTIONS(3146),
    [aux_sym_number_literal_token2] = ACTIONS(3144),
    [anon_sym_L_SQUOTE] = ACTIONS(3146),
    [anon_sym_u_SQUOTE] = ACTIONS(3146),
    [anon_sym_U_SQUOTE] = ACTIONS(3146),
    [anon_sym_u8_SQUOTE] = ACTIONS(3146),
    [anon_sym_SQUOTE] = ACTIONS(3146),
    [anon_sym_L_DQUOTE] = ACTIONS(3146),
    [anon_sym_u_DQUOTE] = ACTIONS(3146),
    [anon_sym_U_DQUOTE] = ACTIONS(3146),
    [anon_sym_u8_DQUOTE] = ACTIONS(3146),
    [anon_sym_DQUOTE] = ACTIONS(3146),
    [sym_true] = ACTIONS(3144),
    [sym_false] = ACTIONS(3144),
    [anon_sym_NULL] = ACTIONS(3144),
    [anon_sym_nullptr] = ACTIONS(3144),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3144),
    [anon_sym_decltype] = ACTIONS(3144),
    [anon_sym_virtual] = ACTIONS(3144),
    [anon_sym_alignas] = ACTIONS(3144),
    [anon_sym_explicit] = ACTIONS(3144),
    [anon_sym_typename] = ACTIONS(3144),
    [anon_sym_template] = ACTIONS(3144),
    [anon_sym_operator] = ACTIONS(3144),
    [anon_sym_try] = ACTIONS(3144),
    [anon_sym_delete] = ACTIONS(3144),
    [anon_sym_throw] = ACTIONS(3144),
    [anon_sym_namespace] = ACTIONS(3144),
    [anon_sym_using] = ACTIONS(3144),
    [anon_sym_static_assert] = ACTIONS(3144),
    [anon_sym_concept] = ACTIONS(3144),
    [anon_sym_co_return] = ACTIONS(3144),
    [anon_sym_co_yield] = ACTIONS(3144),
    [anon_sym_R_DQUOTE] = ACTIONS(3146),
    [anon_sym_LR_DQUOTE] = ACTIONS(3146),
    [anon_sym_uR_DQUOTE] = ACTIONS(3146),
    [anon_sym_UR_DQUOTE] = ACTIONS(3146),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3146),
    [anon_sym_co_await] = ACTIONS(3144),
    [anon_sym_new] = ACTIONS(3144),
    [anon_sym_requires] = ACTIONS(3144),
    [sym_this] = ACTIONS(3144),
  },
  [809] = {
    [ts_builtin_sym_end] = ACTIONS(3110),
    [sym_identifier] = ACTIONS(3108),
    [aux_sym_preproc_include_token1] = ACTIONS(3108),
    [aux_sym_preproc_def_token1] = ACTIONS(3108),
    [aux_sym_preproc_if_token1] = ACTIONS(3108),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3108),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3108),
    [sym_preproc_directive] = ACTIONS(3108),
    [anon_sym_LPAREN2] = ACTIONS(3110),
    [anon_sym_BANG] = ACTIONS(3110),
    [anon_sym_TILDE] = ACTIONS(3110),
    [anon_sym_DASH] = ACTIONS(3108),
    [anon_sym_PLUS] = ACTIONS(3108),
    [anon_sym_STAR] = ACTIONS(3110),
    [anon_sym_AMP_AMP] = ACTIONS(3110),
    [anon_sym_AMP] = ACTIONS(3108),
    [anon_sym_SEMI] = ACTIONS(3110),
    [anon_sym___extension__] = ACTIONS(3108),
    [anon_sym_typedef] = ACTIONS(3108),
    [anon_sym_extern] = ACTIONS(3108),
    [anon_sym___attribute__] = ACTIONS(3108),
    [anon_sym_COLON_COLON] = ACTIONS(3110),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3110),
    [anon_sym___declspec] = ACTIONS(3108),
    [anon_sym___based] = ACTIONS(3108),
    [anon_sym___cdecl] = ACTIONS(3108),
    [anon_sym___clrcall] = ACTIONS(3108),
    [anon_sym___stdcall] = ACTIONS(3108),
    [anon_sym___fastcall] = ACTIONS(3108),
    [anon_sym___thiscall] = ACTIONS(3108),
    [anon_sym___vectorcall] = ACTIONS(3108),
    [anon_sym_LBRACE] = ACTIONS(3110),
    [anon_sym_signed] = ACTIONS(3108),
    [anon_sym_unsigned] = ACTIONS(3108),
    [anon_sym_long] = ACTIONS(3108),
    [anon_sym_short] = ACTIONS(3108),
    [anon_sym_LBRACK] = ACTIONS(3108),
    [anon_sym_static] = ACTIONS(3108),
    [anon_sym_register] = ACTIONS(3108),
    [anon_sym_inline] = ACTIONS(3108),
    [anon_sym___inline] = ACTIONS(3108),
    [anon_sym___inline__] = ACTIONS(3108),
    [anon_sym___forceinline] = ACTIONS(3108),
    [anon_sym_thread_local] = ACTIONS(3108),
    [anon_sym___thread] = ACTIONS(3108),
    [anon_sym_const] = ACTIONS(3108),
    [anon_sym_constexpr] = ACTIONS(3108),
    [anon_sym_volatile] = ACTIONS(3108),
    [anon_sym_restrict] = ACTIONS(3108),
    [anon_sym___restrict__] = ACTIONS(3108),
    [anon_sym__Atomic] = ACTIONS(3108),
    [anon_sym__Noreturn] = ACTIONS(3108),
    [anon_sym_noreturn] = ACTIONS(3108),
    [anon_sym_mutable] = ACTIONS(3108),
    [anon_sym_constinit] = ACTIONS(3108),
    [anon_sym_consteval] = ACTIONS(3108),
    [anon_sym_PROGMEM] = ACTIONS(3108),
    [aux_sym_primitive_type_token1] = ACTIONS(3108),
    [anon_sym_byte] = ACTIONS(3108),
    [anon_sym_word] = ACTIONS(3108),
    [anon_sym_enum] = ACTIONS(3108),
    [anon_sym_class] = ACTIONS(3108),
    [anon_sym_struct] = ACTIONS(3108),
    [anon_sym_union] = ACTIONS(3108),
    [anon_sym_if] = ACTIONS(3108),
    [anon_sym_else] = ACTIONS(3108),
    [anon_sym_switch] = ACTIONS(3108),
    [anon_sym_case] = ACTIONS(3108),
    [anon_sym_default] = ACTIONS(3108),
    [anon_sym_while] = ACTIONS(3108),
    [anon_sym_do] = ACTIONS(3108),
    [anon_sym_for] = ACTIONS(3108),
    [anon_sym_return] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3108),
    [anon_sym_continue] = ACTIONS(3108),
    [anon_sym_goto] = ACTIONS(3108),
    [anon_sym___try] = ACTIONS(3108),
    [anon_sym___leave] = ACTIONS(3108),
    [anon_sym_not] = ACTIONS(3108),
    [anon_sym_compl] = ACTIONS(3108),
    [anon_sym_DASH_DASH] = ACTIONS(3110),
    [anon_sym_PLUS_PLUS] = ACTIONS(3110),
    [anon_sym_sizeof] = ACTIONS(3108),
    [anon_sym___alignof__] = ACTIONS(3108),
    [anon_sym___alignof] = ACTIONS(3108),
    [anon_sym__alignof] = ACTIONS(3108),
    [anon_sym_alignof] = ACTIONS(3108),
    [anon_sym__Alignof] = ACTIONS(3108),
    [anon_sym_offsetof] = ACTIONS(3108),
    [anon_sym__Generic] = ACTIONS(3108),
    [anon_sym_asm] = ACTIONS(3108),
    [anon_sym___asm__] = ACTIONS(3108),
    [aux_sym_number_literal_token1] = ACTIONS(3110),
    [aux_sym_number_literal_token2] = ACTIONS(3108),
    [anon_sym_L_SQUOTE] = ACTIONS(3110),
    [anon_sym_u_SQUOTE] = ACTIONS(3110),
    [anon_sym_U_SQUOTE] = ACTIONS(3110),
    [anon_sym_u8_SQUOTE] = ACTIONS(3110),
    [anon_sym_SQUOTE] = ACTIONS(3110),
    [anon_sym_L_DQUOTE] = ACTIONS(3110),
    [anon_sym_u_DQUOTE] = ACTIONS(3110),
    [anon_sym_U_DQUOTE] = ACTIONS(3110),
    [anon_sym_u8_DQUOTE] = ACTIONS(3110),
    [anon_sym_DQUOTE] = ACTIONS(3110),
    [sym_true] = ACTIONS(3108),
    [sym_false] = ACTIONS(3108),
    [anon_sym_NULL] = ACTIONS(3108),
    [anon_sym_nullptr] = ACTIONS(3108),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3108),
    [anon_sym_decltype] = ACTIONS(3108),
    [anon_sym_virtual] = ACTIONS(3108),
    [anon_sym_alignas] = ACTIONS(3108),
    [anon_sym_explicit] = ACTIONS(3108),
    [anon_sym_typename] = ACTIONS(3108),
    [anon_sym_template] = ACTIONS(3108),
    [anon_sym_operator] = ACTIONS(3108),
    [anon_sym_try] = ACTIONS(3108),
    [anon_sym_delete] = ACTIONS(3108),
    [anon_sym_throw] = ACTIONS(3108),
    [anon_sym_namespace] = ACTIONS(3108),
    [anon_sym_using] = ACTIONS(3108),
    [anon_sym_static_assert] = ACTIONS(3108),
    [anon_sym_concept] = ACTIONS(3108),
    [anon_sym_co_return] = ACTIONS(3108),
    [anon_sym_co_yield] = ACTIONS(3108),
    [anon_sym_R_DQUOTE] = ACTIONS(3110),
    [anon_sym_LR_DQUOTE] = ACTIONS(3110),
    [anon_sym_uR_DQUOTE] = ACTIONS(3110),
    [anon_sym_UR_DQUOTE] = ACTIONS(3110),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3110),
    [anon_sym_co_await] = ACTIONS(3108),
    [anon_sym_new] = ACTIONS(3108),
    [anon_sym_requires] = ACTIONS(3108),
    [sym_this] = ACTIONS(3108),
  },
  [810] = {
    [sym_identifier] = ACTIONS(2970),
    [aux_sym_preproc_include_token1] = ACTIONS(2970),
    [aux_sym_preproc_def_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token1] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2970),
    [sym_preproc_directive] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_BANG] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym___extension__] = ACTIONS(2970),
    [anon_sym_typedef] = ACTIONS(2970),
    [anon_sym_extern] = ACTIONS(2970),
    [anon_sym___attribute__] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2970),
    [anon_sym___based] = ACTIONS(2970),
    [anon_sym___cdecl] = ACTIONS(2970),
    [anon_sym___clrcall] = ACTIONS(2970),
    [anon_sym___stdcall] = ACTIONS(2970),
    [anon_sym___fastcall] = ACTIONS(2970),
    [anon_sym___thiscall] = ACTIONS(2970),
    [anon_sym___vectorcall] = ACTIONS(2970),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_signed] = ACTIONS(2970),
    [anon_sym_unsigned] = ACTIONS(2970),
    [anon_sym_long] = ACTIONS(2970),
    [anon_sym_short] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_register] = ACTIONS(2970),
    [anon_sym_inline] = ACTIONS(2970),
    [anon_sym___inline] = ACTIONS(2970),
    [anon_sym___inline__] = ACTIONS(2970),
    [anon_sym___forceinline] = ACTIONS(2970),
    [anon_sym_thread_local] = ACTIONS(2970),
    [anon_sym___thread] = ACTIONS(2970),
    [anon_sym_const] = ACTIONS(2970),
    [anon_sym_constexpr] = ACTIONS(2970),
    [anon_sym_volatile] = ACTIONS(2970),
    [anon_sym_restrict] = ACTIONS(2970),
    [anon_sym___restrict__] = ACTIONS(2970),
    [anon_sym__Atomic] = ACTIONS(2970),
    [anon_sym__Noreturn] = ACTIONS(2970),
    [anon_sym_noreturn] = ACTIONS(2970),
    [anon_sym_mutable] = ACTIONS(2970),
    [anon_sym_constinit] = ACTIONS(2970),
    [anon_sym_consteval] = ACTIONS(2970),
    [anon_sym_PROGMEM] = ACTIONS(2970),
    [aux_sym_primitive_type_token1] = ACTIONS(2970),
    [anon_sym_byte] = ACTIONS(2970),
    [anon_sym_word] = ACTIONS(2970),
    [anon_sym_enum] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_struct] = ACTIONS(2970),
    [anon_sym_union] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_else] = ACTIONS(2970),
    [anon_sym_switch] = ACTIONS(2970),
    [anon_sym_case] = ACTIONS(2970),
    [anon_sym_default] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_break] = ACTIONS(2970),
    [anon_sym_continue] = ACTIONS(2970),
    [anon_sym_goto] = ACTIONS(2970),
    [anon_sym___try] = ACTIONS(2970),
    [anon_sym___leave] = ACTIONS(2970),
    [anon_sym_not] = ACTIONS(2970),
    [anon_sym_compl] = ACTIONS(2970),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_sizeof] = ACTIONS(2970),
    [anon_sym___alignof__] = ACTIONS(2970),
    [anon_sym___alignof] = ACTIONS(2970),
    [anon_sym__alignof] = ACTIONS(2970),
    [anon_sym_alignof] = ACTIONS(2970),
    [anon_sym__Alignof] = ACTIONS(2970),
    [anon_sym_offsetof] = ACTIONS(2970),
    [anon_sym__Generic] = ACTIONS(2970),
    [anon_sym_asm] = ACTIONS(2970),
    [anon_sym___asm__] = ACTIONS(2970),
    [aux_sym_number_literal_token1] = ACTIONS(2972),
    [aux_sym_number_literal_token2] = ACTIONS(2970),
    [anon_sym_L_SQUOTE] = ACTIONS(2972),
    [anon_sym_u_SQUOTE] = ACTIONS(2972),
    [anon_sym_U_SQUOTE] = ACTIONS(2972),
    [anon_sym_u8_SQUOTE] = ACTIONS(2972),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [anon_sym_L_DQUOTE] = ACTIONS(2972),
    [anon_sym_u_DQUOTE] = ACTIONS(2972),
    [anon_sym_U_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE] = ACTIONS(2972),
    [sym_true] = ACTIONS(2970),
    [sym_false] = ACTIONS(2970),
    [anon_sym_NULL] = ACTIONS(2970),
    [anon_sym_nullptr] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2970),
    [anon_sym_decltype] = ACTIONS(2970),
    [anon_sym_virtual] = ACTIONS(2970),
    [anon_sym_alignas] = ACTIONS(2970),
    [anon_sym_explicit] = ACTIONS(2970),
    [anon_sym_typename] = ACTIONS(2970),
    [anon_sym_template] = ACTIONS(2970),
    [anon_sym_operator] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_delete] = ACTIONS(2970),
    [anon_sym_throw] = ACTIONS(2970),
    [anon_sym_namespace] = ACTIONS(2970),
    [anon_sym_using] = ACTIONS(2970),
    [anon_sym_static_assert] = ACTIONS(2970),
    [anon_sym_concept] = ACTIONS(2970),
    [anon_sym_co_return] = ACTIONS(2970),
    [anon_sym_co_yield] = ACTIONS(2970),
    [anon_sym_R_DQUOTE] = ACTIONS(2972),
    [anon_sym_LR_DQUOTE] = ACTIONS(2972),
    [anon_sym_uR_DQUOTE] = ACTIONS(2972),
    [anon_sym_UR_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2972),
    [anon_sym_co_await] = ACTIONS(2970),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_requires] = ACTIONS(2970),
    [sym_this] = ACTIONS(2970),
  },
  [811] = {
    [sym_identifier] = ACTIONS(3158),
    [aux_sym_preproc_include_token1] = ACTIONS(3158),
    [aux_sym_preproc_def_token1] = ACTIONS(3158),
    [aux_sym_preproc_if_token1] = ACTIONS(3158),
    [aux_sym_preproc_if_token2] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3158),
    [sym_preproc_directive] = ACTIONS(3158),
    [anon_sym_LPAREN2] = ACTIONS(3160),
    [anon_sym_BANG] = ACTIONS(3160),
    [anon_sym_TILDE] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_STAR] = ACTIONS(3160),
    [anon_sym_AMP_AMP] = ACTIONS(3160),
    [anon_sym_AMP] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym___extension__] = ACTIONS(3158),
    [anon_sym_typedef] = ACTIONS(3158),
    [anon_sym_extern] = ACTIONS(3158),
    [anon_sym___attribute__] = ACTIONS(3158),
    [anon_sym_COLON_COLON] = ACTIONS(3160),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3160),
    [anon_sym___declspec] = ACTIONS(3158),
    [anon_sym___based] = ACTIONS(3158),
    [anon_sym___cdecl] = ACTIONS(3158),
    [anon_sym___clrcall] = ACTIONS(3158),
    [anon_sym___stdcall] = ACTIONS(3158),
    [anon_sym___fastcall] = ACTIONS(3158),
    [anon_sym___thiscall] = ACTIONS(3158),
    [anon_sym___vectorcall] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_signed] = ACTIONS(3158),
    [anon_sym_unsigned] = ACTIONS(3158),
    [anon_sym_long] = ACTIONS(3158),
    [anon_sym_short] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_static] = ACTIONS(3158),
    [anon_sym_register] = ACTIONS(3158),
    [anon_sym_inline] = ACTIONS(3158),
    [anon_sym___inline] = ACTIONS(3158),
    [anon_sym___inline__] = ACTIONS(3158),
    [anon_sym___forceinline] = ACTIONS(3158),
    [anon_sym_thread_local] = ACTIONS(3158),
    [anon_sym___thread] = ACTIONS(3158),
    [anon_sym_const] = ACTIONS(3158),
    [anon_sym_constexpr] = ACTIONS(3158),
    [anon_sym_volatile] = ACTIONS(3158),
    [anon_sym_restrict] = ACTIONS(3158),
    [anon_sym___restrict__] = ACTIONS(3158),
    [anon_sym__Atomic] = ACTIONS(3158),
    [anon_sym__Noreturn] = ACTIONS(3158),
    [anon_sym_noreturn] = ACTIONS(3158),
    [anon_sym_mutable] = ACTIONS(3158),
    [anon_sym_constinit] = ACTIONS(3158),
    [anon_sym_consteval] = ACTIONS(3158),
    [anon_sym_PROGMEM] = ACTIONS(3158),
    [aux_sym_primitive_type_token1] = ACTIONS(3158),
    [anon_sym_byte] = ACTIONS(3158),
    [anon_sym_word] = ACTIONS(3158),
    [anon_sym_enum] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(3158),
    [anon_sym_struct] = ACTIONS(3158),
    [anon_sym_union] = ACTIONS(3158),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_else] = ACTIONS(3158),
    [anon_sym_switch] = ACTIONS(3158),
    [anon_sym_case] = ACTIONS(3158),
    [anon_sym_default] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_for] = ACTIONS(3158),
    [anon_sym_return] = ACTIONS(3158),
    [anon_sym_break] = ACTIONS(3158),
    [anon_sym_continue] = ACTIONS(3158),
    [anon_sym_goto] = ACTIONS(3158),
    [anon_sym___try] = ACTIONS(3158),
    [anon_sym___leave] = ACTIONS(3158),
    [anon_sym_not] = ACTIONS(3158),
    [anon_sym_compl] = ACTIONS(3158),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_sizeof] = ACTIONS(3158),
    [anon_sym___alignof__] = ACTIONS(3158),
    [anon_sym___alignof] = ACTIONS(3158),
    [anon_sym__alignof] = ACTIONS(3158),
    [anon_sym_alignof] = ACTIONS(3158),
    [anon_sym__Alignof] = ACTIONS(3158),
    [anon_sym_offsetof] = ACTIONS(3158),
    [anon_sym__Generic] = ACTIONS(3158),
    [anon_sym_asm] = ACTIONS(3158),
    [anon_sym___asm__] = ACTIONS(3158),
    [aux_sym_number_literal_token1] = ACTIONS(3160),
    [aux_sym_number_literal_token2] = ACTIONS(3158),
    [anon_sym_L_SQUOTE] = ACTIONS(3160),
    [anon_sym_u_SQUOTE] = ACTIONS(3160),
    [anon_sym_U_SQUOTE] = ACTIONS(3160),
    [anon_sym_u8_SQUOTE] = ACTIONS(3160),
    [anon_sym_SQUOTE] = ACTIONS(3160),
    [anon_sym_L_DQUOTE] = ACTIONS(3160),
    [anon_sym_u_DQUOTE] = ACTIONS(3160),
    [anon_sym_U_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8_DQUOTE] = ACTIONS(3160),
    [anon_sym_DQUOTE] = ACTIONS(3160),
    [sym_true] = ACTIONS(3158),
    [sym_false] = ACTIONS(3158),
    [anon_sym_NULL] = ACTIONS(3158),
    [anon_sym_nullptr] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3158),
    [anon_sym_decltype] = ACTIONS(3158),
    [anon_sym_virtual] = ACTIONS(3158),
    [anon_sym_alignas] = ACTIONS(3158),
    [anon_sym_explicit] = ACTIONS(3158),
    [anon_sym_typename] = ACTIONS(3158),
    [anon_sym_template] = ACTIONS(3158),
    [anon_sym_operator] = ACTIONS(3158),
    [anon_sym_try] = ACTIONS(3158),
    [anon_sym_delete] = ACTIONS(3158),
    [anon_sym_throw] = ACTIONS(3158),
    [anon_sym_namespace] = ACTIONS(3158),
    [anon_sym_using] = ACTIONS(3158),
    [anon_sym_static_assert] = ACTIONS(3158),
    [anon_sym_concept] = ACTIONS(3158),
    [anon_sym_co_return] = ACTIONS(3158),
    [anon_sym_co_yield] = ACTIONS(3158),
    [anon_sym_R_DQUOTE] = ACTIONS(3160),
    [anon_sym_LR_DQUOTE] = ACTIONS(3160),
    [anon_sym_uR_DQUOTE] = ACTIONS(3160),
    [anon_sym_UR_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3160),
    [anon_sym_co_await] = ACTIONS(3158),
    [anon_sym_new] = ACTIONS(3158),
    [anon_sym_requires] = ACTIONS(3158),
    [sym_this] = ACTIONS(3158),
  },
  [812] = {
    [sym_identifier] = ACTIONS(3172),
    [aux_sym_preproc_include_token1] = ACTIONS(3172),
    [aux_sym_preproc_def_token1] = ACTIONS(3172),
    [aux_sym_preproc_if_token1] = ACTIONS(3172),
    [aux_sym_preproc_if_token2] = ACTIONS(3172),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3172),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3172),
    [sym_preproc_directive] = ACTIONS(3172),
    [anon_sym_LPAREN2] = ACTIONS(3174),
    [anon_sym_BANG] = ACTIONS(3174),
    [anon_sym_TILDE] = ACTIONS(3174),
    [anon_sym_DASH] = ACTIONS(3172),
    [anon_sym_PLUS] = ACTIONS(3172),
    [anon_sym_STAR] = ACTIONS(3174),
    [anon_sym_AMP_AMP] = ACTIONS(3174),
    [anon_sym_AMP] = ACTIONS(3172),
    [anon_sym_SEMI] = ACTIONS(3174),
    [anon_sym___extension__] = ACTIONS(3172),
    [anon_sym_typedef] = ACTIONS(3172),
    [anon_sym_extern] = ACTIONS(3172),
    [anon_sym___attribute__] = ACTIONS(3172),
    [anon_sym_COLON_COLON] = ACTIONS(3174),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3174),
    [anon_sym___declspec] = ACTIONS(3172),
    [anon_sym___based] = ACTIONS(3172),
    [anon_sym___cdecl] = ACTIONS(3172),
    [anon_sym___clrcall] = ACTIONS(3172),
    [anon_sym___stdcall] = ACTIONS(3172),
    [anon_sym___fastcall] = ACTIONS(3172),
    [anon_sym___thiscall] = ACTIONS(3172),
    [anon_sym___vectorcall] = ACTIONS(3172),
    [anon_sym_LBRACE] = ACTIONS(3174),
    [anon_sym_signed] = ACTIONS(3172),
    [anon_sym_unsigned] = ACTIONS(3172),
    [anon_sym_long] = ACTIONS(3172),
    [anon_sym_short] = ACTIONS(3172),
    [anon_sym_LBRACK] = ACTIONS(3172),
    [anon_sym_static] = ACTIONS(3172),
    [anon_sym_register] = ACTIONS(3172),
    [anon_sym_inline] = ACTIONS(3172),
    [anon_sym___inline] = ACTIONS(3172),
    [anon_sym___inline__] = ACTIONS(3172),
    [anon_sym___forceinline] = ACTIONS(3172),
    [anon_sym_thread_local] = ACTIONS(3172),
    [anon_sym___thread] = ACTIONS(3172),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_constexpr] = ACTIONS(3172),
    [anon_sym_volatile] = ACTIONS(3172),
    [anon_sym_restrict] = ACTIONS(3172),
    [anon_sym___restrict__] = ACTIONS(3172),
    [anon_sym__Atomic] = ACTIONS(3172),
    [anon_sym__Noreturn] = ACTIONS(3172),
    [anon_sym_noreturn] = ACTIONS(3172),
    [anon_sym_mutable] = ACTIONS(3172),
    [anon_sym_constinit] = ACTIONS(3172),
    [anon_sym_consteval] = ACTIONS(3172),
    [anon_sym_PROGMEM] = ACTIONS(3172),
    [aux_sym_primitive_type_token1] = ACTIONS(3172),
    [anon_sym_byte] = ACTIONS(3172),
    [anon_sym_word] = ACTIONS(3172),
    [anon_sym_enum] = ACTIONS(3172),
    [anon_sym_class] = ACTIONS(3172),
    [anon_sym_struct] = ACTIONS(3172),
    [anon_sym_union] = ACTIONS(3172),
    [anon_sym_if] = ACTIONS(3172),
    [anon_sym_else] = ACTIONS(3172),
    [anon_sym_switch] = ACTIONS(3172),
    [anon_sym_case] = ACTIONS(3172),
    [anon_sym_default] = ACTIONS(3172),
    [anon_sym_while] = ACTIONS(3172),
    [anon_sym_do] = ACTIONS(3172),
    [anon_sym_for] = ACTIONS(3172),
    [anon_sym_return] = ACTIONS(3172),
    [anon_sym_break] = ACTIONS(3172),
    [anon_sym_continue] = ACTIONS(3172),
    [anon_sym_goto] = ACTIONS(3172),
    [anon_sym___try] = ACTIONS(3172),
    [anon_sym___leave] = ACTIONS(3172),
    [anon_sym_not] = ACTIONS(3172),
    [anon_sym_compl] = ACTIONS(3172),
    [anon_sym_DASH_DASH] = ACTIONS(3174),
    [anon_sym_PLUS_PLUS] = ACTIONS(3174),
    [anon_sym_sizeof] = ACTIONS(3172),
    [anon_sym___alignof__] = ACTIONS(3172),
    [anon_sym___alignof] = ACTIONS(3172),
    [anon_sym__alignof] = ACTIONS(3172),
    [anon_sym_alignof] = ACTIONS(3172),
    [anon_sym__Alignof] = ACTIONS(3172),
    [anon_sym_offsetof] = ACTIONS(3172),
    [anon_sym__Generic] = ACTIONS(3172),
    [anon_sym_asm] = ACTIONS(3172),
    [anon_sym___asm__] = ACTIONS(3172),
    [aux_sym_number_literal_token1] = ACTIONS(3174),
    [aux_sym_number_literal_token2] = ACTIONS(3172),
    [anon_sym_L_SQUOTE] = ACTIONS(3174),
    [anon_sym_u_SQUOTE] = ACTIONS(3174),
    [anon_sym_U_SQUOTE] = ACTIONS(3174),
    [anon_sym_u8_SQUOTE] = ACTIONS(3174),
    [anon_sym_SQUOTE] = ACTIONS(3174),
    [anon_sym_L_DQUOTE] = ACTIONS(3174),
    [anon_sym_u_DQUOTE] = ACTIONS(3174),
    [anon_sym_U_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8_DQUOTE] = ACTIONS(3174),
    [anon_sym_DQUOTE] = ACTIONS(3174),
    [sym_true] = ACTIONS(3172),
    [sym_false] = ACTIONS(3172),
    [anon_sym_NULL] = ACTIONS(3172),
    [anon_sym_nullptr] = ACTIONS(3172),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3172),
    [anon_sym_decltype] = ACTIONS(3172),
    [anon_sym_virtual] = ACTIONS(3172),
    [anon_sym_alignas] = ACTIONS(3172),
    [anon_sym_explicit] = ACTIONS(3172),
    [anon_sym_typename] = ACTIONS(3172),
    [anon_sym_template] = ACTIONS(3172),
    [anon_sym_operator] = ACTIONS(3172),
    [anon_sym_try] = ACTIONS(3172),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_throw] = ACTIONS(3172),
    [anon_sym_namespace] = ACTIONS(3172),
    [anon_sym_using] = ACTIONS(3172),
    [anon_sym_static_assert] = ACTIONS(3172),
    [anon_sym_concept] = ACTIONS(3172),
    [anon_sym_co_return] = ACTIONS(3172),
    [anon_sym_co_yield] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3172),
    [anon_sym_new] = ACTIONS(3172),
    [anon_sym_requires] = ACTIONS(3172),
    [sym_this] = ACTIONS(3172),
  },
  [813] = {
    [sym_identifier] = ACTIONS(3168),
    [aux_sym_preproc_include_token1] = ACTIONS(3168),
    [aux_sym_preproc_def_token1] = ACTIONS(3168),
    [aux_sym_preproc_if_token1] = ACTIONS(3168),
    [aux_sym_preproc_if_token2] = ACTIONS(3168),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3168),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3168),
    [sym_preproc_directive] = ACTIONS(3168),
    [anon_sym_LPAREN2] = ACTIONS(3170),
    [anon_sym_BANG] = ACTIONS(3170),
    [anon_sym_TILDE] = ACTIONS(3170),
    [anon_sym_DASH] = ACTIONS(3168),
    [anon_sym_PLUS] = ACTIONS(3168),
    [anon_sym_STAR] = ACTIONS(3170),
    [anon_sym_AMP_AMP] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3168),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym___extension__] = ACTIONS(3168),
    [anon_sym_typedef] = ACTIONS(3168),
    [anon_sym_extern] = ACTIONS(3168),
    [anon_sym___attribute__] = ACTIONS(3168),
    [anon_sym_COLON_COLON] = ACTIONS(3170),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3170),
    [anon_sym___declspec] = ACTIONS(3168),
    [anon_sym___based] = ACTIONS(3168),
    [anon_sym___cdecl] = ACTIONS(3168),
    [anon_sym___clrcall] = ACTIONS(3168),
    [anon_sym___stdcall] = ACTIONS(3168),
    [anon_sym___fastcall] = ACTIONS(3168),
    [anon_sym___thiscall] = ACTIONS(3168),
    [anon_sym___vectorcall] = ACTIONS(3168),
    [anon_sym_LBRACE] = ACTIONS(3170),
    [anon_sym_signed] = ACTIONS(3168),
    [anon_sym_unsigned] = ACTIONS(3168),
    [anon_sym_long] = ACTIONS(3168),
    [anon_sym_short] = ACTIONS(3168),
    [anon_sym_LBRACK] = ACTIONS(3168),
    [anon_sym_static] = ACTIONS(3168),
    [anon_sym_register] = ACTIONS(3168),
    [anon_sym_inline] = ACTIONS(3168),
    [anon_sym___inline] = ACTIONS(3168),
    [anon_sym___inline__] = ACTIONS(3168),
    [anon_sym___forceinline] = ACTIONS(3168),
    [anon_sym_thread_local] = ACTIONS(3168),
    [anon_sym___thread] = ACTIONS(3168),
    [anon_sym_const] = ACTIONS(3168),
    [anon_sym_constexpr] = ACTIONS(3168),
    [anon_sym_volatile] = ACTIONS(3168),
    [anon_sym_restrict] = ACTIONS(3168),
    [anon_sym___restrict__] = ACTIONS(3168),
    [anon_sym__Atomic] = ACTIONS(3168),
    [anon_sym__Noreturn] = ACTIONS(3168),
    [anon_sym_noreturn] = ACTIONS(3168),
    [anon_sym_mutable] = ACTIONS(3168),
    [anon_sym_constinit] = ACTIONS(3168),
    [anon_sym_consteval] = ACTIONS(3168),
    [anon_sym_PROGMEM] = ACTIONS(3168),
    [aux_sym_primitive_type_token1] = ACTIONS(3168),
    [anon_sym_byte] = ACTIONS(3168),
    [anon_sym_word] = ACTIONS(3168),
    [anon_sym_enum] = ACTIONS(3168),
    [anon_sym_class] = ACTIONS(3168),
    [anon_sym_struct] = ACTIONS(3168),
    [anon_sym_union] = ACTIONS(3168),
    [anon_sym_if] = ACTIONS(3168),
    [anon_sym_else] = ACTIONS(3168),
    [anon_sym_switch] = ACTIONS(3168),
    [anon_sym_case] = ACTIONS(3168),
    [anon_sym_default] = ACTIONS(3168),
    [anon_sym_while] = ACTIONS(3168),
    [anon_sym_do] = ACTIONS(3168),
    [anon_sym_for] = ACTIONS(3168),
    [anon_sym_return] = ACTIONS(3168),
    [anon_sym_break] = ACTIONS(3168),
    [anon_sym_continue] = ACTIONS(3168),
    [anon_sym_goto] = ACTIONS(3168),
    [anon_sym___try] = ACTIONS(3168),
    [anon_sym___leave] = ACTIONS(3168),
    [anon_sym_not] = ACTIONS(3168),
    [anon_sym_compl] = ACTIONS(3168),
    [anon_sym_DASH_DASH] = ACTIONS(3170),
    [anon_sym_PLUS_PLUS] = ACTIONS(3170),
    [anon_sym_sizeof] = ACTIONS(3168),
    [anon_sym___alignof__] = ACTIONS(3168),
    [anon_sym___alignof] = ACTIONS(3168),
    [anon_sym__alignof] = ACTIONS(3168),
    [anon_sym_alignof] = ACTIONS(3168),
    [anon_sym__Alignof] = ACTIONS(3168),
    [anon_sym_offsetof] = ACTIONS(3168),
    [anon_sym__Generic] = ACTIONS(3168),
    [anon_sym_asm] = ACTIONS(3168),
    [anon_sym___asm__] = ACTIONS(3168),
    [aux_sym_number_literal_token1] = ACTIONS(3170),
    [aux_sym_number_literal_token2] = ACTIONS(3168),
    [anon_sym_L_SQUOTE] = ACTIONS(3170),
    [anon_sym_u_SQUOTE] = ACTIONS(3170),
    [anon_sym_U_SQUOTE] = ACTIONS(3170),
    [anon_sym_u8_SQUOTE] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3170),
    [anon_sym_L_DQUOTE] = ACTIONS(3170),
    [anon_sym_u_DQUOTE] = ACTIONS(3170),
    [anon_sym_U_DQUOTE] = ACTIONS(3170),
    [anon_sym_u8_DQUOTE] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3170),
    [sym_true] = ACTIONS(3168),
    [sym_false] = ACTIONS(3168),
    [anon_sym_NULL] = ACTIONS(3168),
    [anon_sym_nullptr] = ACTIONS(3168),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3168),
    [anon_sym_decltype] = ACTIONS(3168),
    [anon_sym_virtual] = ACTIONS(3168),
    [anon_sym_alignas] = ACTIONS(3168),
    [anon_sym_explicit] = ACTIONS(3168),
    [anon_sym_typename] = ACTIONS(3168),
    [anon_sym_template] = ACTIONS(3168),
    [anon_sym_operator] = ACTIONS(3168),
    [anon_sym_try] = ACTIONS(3168),
    [anon_sym_delete] = ACTIONS(3168),
    [anon_sym_throw] = ACTIONS(3168),
    [anon_sym_namespace] = ACTIONS(3168),
    [anon_sym_using] = ACTIONS(3168),
    [anon_sym_static_assert] = ACTIONS(3168),
    [anon_sym_concept] = ACTIONS(3168),
    [anon_sym_co_return] = ACTIONS(3168),
    [anon_sym_co_yield] = ACTIONS(3168),
    [anon_sym_R_DQUOTE] = ACTIONS(3170),
    [anon_sym_LR_DQUOTE] = ACTIONS(3170),
    [anon_sym_uR_DQUOTE] = ACTIONS(3170),
    [anon_sym_UR_DQUOTE] = ACTIONS(3170),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3170),
    [anon_sym_co_await] = ACTIONS(3168),
    [anon_sym_new] = ACTIONS(3168),
    [anon_sym_requires] = ACTIONS(3168),
    [sym_this] = ACTIONS(3168),
  },
  [814] = {
    [sym_identifier] = ACTIONS(3128),
    [aux_sym_preproc_include_token1] = ACTIONS(3128),
    [aux_sym_preproc_def_token1] = ACTIONS(3128),
    [aux_sym_preproc_if_token1] = ACTIONS(3128),
    [aux_sym_preproc_if_token2] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3128),
    [sym_preproc_directive] = ACTIONS(3128),
    [anon_sym_LPAREN2] = ACTIONS(3130),
    [anon_sym_BANG] = ACTIONS(3130),
    [anon_sym_TILDE] = ACTIONS(3130),
    [anon_sym_DASH] = ACTIONS(3128),
    [anon_sym_PLUS] = ACTIONS(3128),
    [anon_sym_STAR] = ACTIONS(3130),
    [anon_sym_AMP_AMP] = ACTIONS(3130),
    [anon_sym_AMP] = ACTIONS(3128),
    [anon_sym_SEMI] = ACTIONS(3130),
    [anon_sym___extension__] = ACTIONS(3128),
    [anon_sym_typedef] = ACTIONS(3128),
    [anon_sym_extern] = ACTIONS(3128),
    [anon_sym___attribute__] = ACTIONS(3128),
    [anon_sym_COLON_COLON] = ACTIONS(3130),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3130),
    [anon_sym___declspec] = ACTIONS(3128),
    [anon_sym___based] = ACTIONS(3128),
    [anon_sym___cdecl] = ACTIONS(3128),
    [anon_sym___clrcall] = ACTIONS(3128),
    [anon_sym___stdcall] = ACTIONS(3128),
    [anon_sym___fastcall] = ACTIONS(3128),
    [anon_sym___thiscall] = ACTIONS(3128),
    [anon_sym___vectorcall] = ACTIONS(3128),
    [anon_sym_LBRACE] = ACTIONS(3130),
    [anon_sym_signed] = ACTIONS(3128),
    [anon_sym_unsigned] = ACTIONS(3128),
    [anon_sym_long] = ACTIONS(3128),
    [anon_sym_short] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3128),
    [anon_sym_static] = ACTIONS(3128),
    [anon_sym_register] = ACTIONS(3128),
    [anon_sym_inline] = ACTIONS(3128),
    [anon_sym___inline] = ACTIONS(3128),
    [anon_sym___inline__] = ACTIONS(3128),
    [anon_sym___forceinline] = ACTIONS(3128),
    [anon_sym_thread_local] = ACTIONS(3128),
    [anon_sym___thread] = ACTIONS(3128),
    [anon_sym_const] = ACTIONS(3128),
    [anon_sym_constexpr] = ACTIONS(3128),
    [anon_sym_volatile] = ACTIONS(3128),
    [anon_sym_restrict] = ACTIONS(3128),
    [anon_sym___restrict__] = ACTIONS(3128),
    [anon_sym__Atomic] = ACTIONS(3128),
    [anon_sym__Noreturn] = ACTIONS(3128),
    [anon_sym_noreturn] = ACTIONS(3128),
    [anon_sym_mutable] = ACTIONS(3128),
    [anon_sym_constinit] = ACTIONS(3128),
    [anon_sym_consteval] = ACTIONS(3128),
    [anon_sym_PROGMEM] = ACTIONS(3128),
    [aux_sym_primitive_type_token1] = ACTIONS(3128),
    [anon_sym_byte] = ACTIONS(3128),
    [anon_sym_word] = ACTIONS(3128),
    [anon_sym_enum] = ACTIONS(3128),
    [anon_sym_class] = ACTIONS(3128),
    [anon_sym_struct] = ACTIONS(3128),
    [anon_sym_union] = ACTIONS(3128),
    [anon_sym_if] = ACTIONS(3128),
    [anon_sym_else] = ACTIONS(3128),
    [anon_sym_switch] = ACTIONS(3128),
    [anon_sym_case] = ACTIONS(3128),
    [anon_sym_default] = ACTIONS(3128),
    [anon_sym_while] = ACTIONS(3128),
    [anon_sym_do] = ACTIONS(3128),
    [anon_sym_for] = ACTIONS(3128),
    [anon_sym_return] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3128),
    [anon_sym_continue] = ACTIONS(3128),
    [anon_sym_goto] = ACTIONS(3128),
    [anon_sym___try] = ACTIONS(3128),
    [anon_sym___leave] = ACTIONS(3128),
    [anon_sym_not] = ACTIONS(3128),
    [anon_sym_compl] = ACTIONS(3128),
    [anon_sym_DASH_DASH] = ACTIONS(3130),
    [anon_sym_PLUS_PLUS] = ACTIONS(3130),
    [anon_sym_sizeof] = ACTIONS(3128),
    [anon_sym___alignof__] = ACTIONS(3128),
    [anon_sym___alignof] = ACTIONS(3128),
    [anon_sym__alignof] = ACTIONS(3128),
    [anon_sym_alignof] = ACTIONS(3128),
    [anon_sym__Alignof] = ACTIONS(3128),
    [anon_sym_offsetof] = ACTIONS(3128),
    [anon_sym__Generic] = ACTIONS(3128),
    [anon_sym_asm] = ACTIONS(3128),
    [anon_sym___asm__] = ACTIONS(3128),
    [aux_sym_number_literal_token1] = ACTIONS(3130),
    [aux_sym_number_literal_token2] = ACTIONS(3128),
    [anon_sym_L_SQUOTE] = ACTIONS(3130),
    [anon_sym_u_SQUOTE] = ACTIONS(3130),
    [anon_sym_U_SQUOTE] = ACTIONS(3130),
    [anon_sym_u8_SQUOTE] = ACTIONS(3130),
    [anon_sym_SQUOTE] = ACTIONS(3130),
    [anon_sym_L_DQUOTE] = ACTIONS(3130),
    [anon_sym_u_DQUOTE] = ACTIONS(3130),
    [anon_sym_U_DQUOTE] = ACTIONS(3130),
    [anon_sym_u8_DQUOTE] = ACTIONS(3130),
    [anon_sym_DQUOTE] = ACTIONS(3130),
    [sym_true] = ACTIONS(3128),
    [sym_false] = ACTIONS(3128),
    [anon_sym_NULL] = ACTIONS(3128),
    [anon_sym_nullptr] = ACTIONS(3128),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3128),
    [anon_sym_decltype] = ACTIONS(3128),
    [anon_sym_virtual] = ACTIONS(3128),
    [anon_sym_alignas] = ACTIONS(3128),
    [anon_sym_explicit] = ACTIONS(3128),
    [anon_sym_typename] = ACTIONS(3128),
    [anon_sym_template] = ACTIONS(3128),
    [anon_sym_operator] = ACTIONS(3128),
    [anon_sym_try] = ACTIONS(3128),
    [anon_sym_delete] = ACTIONS(3128),
    [anon_sym_throw] = ACTIONS(3128),
    [anon_sym_namespace] = ACTIONS(3128),
    [anon_sym_using] = ACTIONS(3128),
    [anon_sym_static_assert] = ACTIONS(3128),
    [anon_sym_concept] = ACTIONS(3128),
    [anon_sym_co_return] = ACTIONS(3128),
    [anon_sym_co_yield] = ACTIONS(3128),
    [anon_sym_R_DQUOTE] = ACTIONS(3130),
    [anon_sym_LR_DQUOTE] = ACTIONS(3130),
    [anon_sym_uR_DQUOTE] = ACTIONS(3130),
    [anon_sym_UR_DQUOTE] = ACTIONS(3130),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3130),
    [anon_sym_co_await] = ACTIONS(3128),
    [anon_sym_new] = ACTIONS(3128),
    [anon_sym_requires] = ACTIONS(3128),
    [sym_this] = ACTIONS(3128),
  },
  [815] = {
    [sym_identifier] = ACTIONS(3134),
    [aux_sym_preproc_include_token1] = ACTIONS(3134),
    [aux_sym_preproc_def_token1] = ACTIONS(3134),
    [aux_sym_preproc_if_token1] = ACTIONS(3134),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3134),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3134),
    [sym_preproc_directive] = ACTIONS(3134),
    [anon_sym_LPAREN2] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3136),
    [anon_sym_TILDE] = ACTIONS(3136),
    [anon_sym_DASH] = ACTIONS(3134),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_STAR] = ACTIONS(3136),
    [anon_sym_AMP_AMP] = ACTIONS(3136),
    [anon_sym_AMP] = ACTIONS(3134),
    [anon_sym_SEMI] = ACTIONS(3136),
    [anon_sym___extension__] = ACTIONS(3134),
    [anon_sym_typedef] = ACTIONS(3134),
    [anon_sym_extern] = ACTIONS(3134),
    [anon_sym___attribute__] = ACTIONS(3134),
    [anon_sym_COLON_COLON] = ACTIONS(3136),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3136),
    [anon_sym___declspec] = ACTIONS(3134),
    [anon_sym___based] = ACTIONS(3134),
    [anon_sym___cdecl] = ACTIONS(3134),
    [anon_sym___clrcall] = ACTIONS(3134),
    [anon_sym___stdcall] = ACTIONS(3134),
    [anon_sym___fastcall] = ACTIONS(3134),
    [anon_sym___thiscall] = ACTIONS(3134),
    [anon_sym___vectorcall] = ACTIONS(3134),
    [anon_sym_LBRACE] = ACTIONS(3136),
    [anon_sym_RBRACE] = ACTIONS(3136),
    [anon_sym_signed] = ACTIONS(3134),
    [anon_sym_unsigned] = ACTIONS(3134),
    [anon_sym_long] = ACTIONS(3134),
    [anon_sym_short] = ACTIONS(3134),
    [anon_sym_LBRACK] = ACTIONS(3134),
    [anon_sym_static] = ACTIONS(3134),
    [anon_sym_register] = ACTIONS(3134),
    [anon_sym_inline] = ACTIONS(3134),
    [anon_sym___inline] = ACTIONS(3134),
    [anon_sym___inline__] = ACTIONS(3134),
    [anon_sym___forceinline] = ACTIONS(3134),
    [anon_sym_thread_local] = ACTIONS(3134),
    [anon_sym___thread] = ACTIONS(3134),
    [anon_sym_const] = ACTIONS(3134),
    [anon_sym_constexpr] = ACTIONS(3134),
    [anon_sym_volatile] = ACTIONS(3134),
    [anon_sym_restrict] = ACTIONS(3134),
    [anon_sym___restrict__] = ACTIONS(3134),
    [anon_sym__Atomic] = ACTIONS(3134),
    [anon_sym__Noreturn] = ACTIONS(3134),
    [anon_sym_noreturn] = ACTIONS(3134),
    [anon_sym_mutable] = ACTIONS(3134),
    [anon_sym_constinit] = ACTIONS(3134),
    [anon_sym_consteval] = ACTIONS(3134),
    [anon_sym_PROGMEM] = ACTIONS(3134),
    [aux_sym_primitive_type_token1] = ACTIONS(3134),
    [anon_sym_byte] = ACTIONS(3134),
    [anon_sym_word] = ACTIONS(3134),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3134),
    [anon_sym_struct] = ACTIONS(3134),
    [anon_sym_union] = ACTIONS(3134),
    [anon_sym_if] = ACTIONS(3134),
    [anon_sym_else] = ACTIONS(3134),
    [anon_sym_switch] = ACTIONS(3134),
    [anon_sym_case] = ACTIONS(3134),
    [anon_sym_default] = ACTIONS(3134),
    [anon_sym_while] = ACTIONS(3134),
    [anon_sym_do] = ACTIONS(3134),
    [anon_sym_for] = ACTIONS(3134),
    [anon_sym_return] = ACTIONS(3134),
    [anon_sym_break] = ACTIONS(3134),
    [anon_sym_continue] = ACTIONS(3134),
    [anon_sym_goto] = ACTIONS(3134),
    [anon_sym___try] = ACTIONS(3134),
    [anon_sym___leave] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3134),
    [anon_sym_compl] = ACTIONS(3134),
    [anon_sym_DASH_DASH] = ACTIONS(3136),
    [anon_sym_PLUS_PLUS] = ACTIONS(3136),
    [anon_sym_sizeof] = ACTIONS(3134),
    [anon_sym___alignof__] = ACTIONS(3134),
    [anon_sym___alignof] = ACTIONS(3134),
    [anon_sym__alignof] = ACTIONS(3134),
    [anon_sym_alignof] = ACTIONS(3134),
    [anon_sym__Alignof] = ACTIONS(3134),
    [anon_sym_offsetof] = ACTIONS(3134),
    [anon_sym__Generic] = ACTIONS(3134),
    [anon_sym_asm] = ACTIONS(3134),
    [anon_sym___asm__] = ACTIONS(3134),
    [aux_sym_number_literal_token1] = ACTIONS(3136),
    [aux_sym_number_literal_token2] = ACTIONS(3134),
    [anon_sym_L_SQUOTE] = ACTIONS(3136),
    [anon_sym_u_SQUOTE] = ACTIONS(3136),
    [anon_sym_U_SQUOTE] = ACTIONS(3136),
    [anon_sym_u8_SQUOTE] = ACTIONS(3136),
    [anon_sym_SQUOTE] = ACTIONS(3136),
    [anon_sym_L_DQUOTE] = ACTIONS(3136),
    [anon_sym_u_DQUOTE] = ACTIONS(3136),
    [anon_sym_U_DQUOTE] = ACTIONS(3136),
    [anon_sym_u8_DQUOTE] = ACTIONS(3136),
    [anon_sym_DQUOTE] = ACTIONS(3136),
    [sym_true] = ACTIONS(3134),
    [sym_false] = ACTIONS(3134),
    [anon_sym_NULL] = ACTIONS(3134),
    [anon_sym_nullptr] = ACTIONS(3134),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3134),
    [anon_sym_decltype] = ACTIONS(3134),
    [anon_sym_virtual] = ACTIONS(3134),
    [anon_sym_alignas] = ACTIONS(3134),
    [anon_sym_explicit] = ACTIONS(3134),
    [anon_sym_typename] = ACTIONS(3134),
    [anon_sym_template] = ACTIONS(3134),
    [anon_sym_operator] = ACTIONS(3134),
    [anon_sym_try] = ACTIONS(3134),
    [anon_sym_delete] = ACTIONS(3134),
    [anon_sym_throw] = ACTIONS(3134),
    [anon_sym_namespace] = ACTIONS(3134),
    [anon_sym_using] = ACTIONS(3134),
    [anon_sym_static_assert] = ACTIONS(3134),
    [anon_sym_concept] = ACTIONS(3134),
    [anon_sym_co_return] = ACTIONS(3134),
    [anon_sym_co_yield] = ACTIONS(3134),
    [anon_sym_R_DQUOTE] = ACTIONS(3136),
    [anon_sym_LR_DQUOTE] = ACTIONS(3136),
    [anon_sym_uR_DQUOTE] = ACTIONS(3136),
    [anon_sym_UR_DQUOTE] = ACTIONS(3136),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3136),
    [anon_sym_co_await] = ACTIONS(3134),
    [anon_sym_new] = ACTIONS(3134),
    [anon_sym_requires] = ACTIONS(3134),
    [sym_this] = ACTIONS(3134),
  },
  [816] = {
    [ts_builtin_sym_end] = ACTIONS(3140),
    [sym_identifier] = ACTIONS(3138),
    [aux_sym_preproc_include_token1] = ACTIONS(3138),
    [aux_sym_preproc_def_token1] = ACTIONS(3138),
    [aux_sym_preproc_if_token1] = ACTIONS(3138),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3138),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3138),
    [sym_preproc_directive] = ACTIONS(3138),
    [anon_sym_LPAREN2] = ACTIONS(3140),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [anon_sym_DASH] = ACTIONS(3138),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_STAR] = ACTIONS(3140),
    [anon_sym_AMP_AMP] = ACTIONS(3140),
    [anon_sym_AMP] = ACTIONS(3138),
    [anon_sym_SEMI] = ACTIONS(3140),
    [anon_sym___extension__] = ACTIONS(3138),
    [anon_sym_typedef] = ACTIONS(3138),
    [anon_sym_extern] = ACTIONS(3138),
    [anon_sym___attribute__] = ACTIONS(3138),
    [anon_sym_COLON_COLON] = ACTIONS(3140),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3140),
    [anon_sym___declspec] = ACTIONS(3138),
    [anon_sym___based] = ACTIONS(3138),
    [anon_sym___cdecl] = ACTIONS(3138),
    [anon_sym___clrcall] = ACTIONS(3138),
    [anon_sym___stdcall] = ACTIONS(3138),
    [anon_sym___fastcall] = ACTIONS(3138),
    [anon_sym___thiscall] = ACTIONS(3138),
    [anon_sym___vectorcall] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [anon_sym_signed] = ACTIONS(3138),
    [anon_sym_unsigned] = ACTIONS(3138),
    [anon_sym_long] = ACTIONS(3138),
    [anon_sym_short] = ACTIONS(3138),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_static] = ACTIONS(3138),
    [anon_sym_register] = ACTIONS(3138),
    [anon_sym_inline] = ACTIONS(3138),
    [anon_sym___inline] = ACTIONS(3138),
    [anon_sym___inline__] = ACTIONS(3138),
    [anon_sym___forceinline] = ACTIONS(3138),
    [anon_sym_thread_local] = ACTIONS(3138),
    [anon_sym___thread] = ACTIONS(3138),
    [anon_sym_const] = ACTIONS(3138),
    [anon_sym_constexpr] = ACTIONS(3138),
    [anon_sym_volatile] = ACTIONS(3138),
    [anon_sym_restrict] = ACTIONS(3138),
    [anon_sym___restrict__] = ACTIONS(3138),
    [anon_sym__Atomic] = ACTIONS(3138),
    [anon_sym__Noreturn] = ACTIONS(3138),
    [anon_sym_noreturn] = ACTIONS(3138),
    [anon_sym_mutable] = ACTIONS(3138),
    [anon_sym_constinit] = ACTIONS(3138),
    [anon_sym_consteval] = ACTIONS(3138),
    [anon_sym_PROGMEM] = ACTIONS(3138),
    [aux_sym_primitive_type_token1] = ACTIONS(3138),
    [anon_sym_byte] = ACTIONS(3138),
    [anon_sym_word] = ACTIONS(3138),
    [anon_sym_enum] = ACTIONS(3138),
    [anon_sym_class] = ACTIONS(3138),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3138),
    [anon_sym_if] = ACTIONS(3138),
    [anon_sym_else] = ACTIONS(3138),
    [anon_sym_switch] = ACTIONS(3138),
    [anon_sym_case] = ACTIONS(3138),
    [anon_sym_default] = ACTIONS(3138),
    [anon_sym_while] = ACTIONS(3138),
    [anon_sym_do] = ACTIONS(3138),
    [anon_sym_for] = ACTIONS(3138),
    [anon_sym_return] = ACTIONS(3138),
    [anon_sym_break] = ACTIONS(3138),
    [anon_sym_continue] = ACTIONS(3138),
    [anon_sym_goto] = ACTIONS(3138),
    [anon_sym___try] = ACTIONS(3138),
    [anon_sym___leave] = ACTIONS(3138),
    [anon_sym_not] = ACTIONS(3138),
    [anon_sym_compl] = ACTIONS(3138),
    [anon_sym_DASH_DASH] = ACTIONS(3140),
    [anon_sym_PLUS_PLUS] = ACTIONS(3140),
    [anon_sym_sizeof] = ACTIONS(3138),
    [anon_sym___alignof__] = ACTIONS(3138),
    [anon_sym___alignof] = ACTIONS(3138),
    [anon_sym__alignof] = ACTIONS(3138),
    [anon_sym_alignof] = ACTIONS(3138),
    [anon_sym__Alignof] = ACTIONS(3138),
    [anon_sym_offsetof] = ACTIONS(3138),
    [anon_sym__Generic] = ACTIONS(3138),
    [anon_sym_asm] = ACTIONS(3138),
    [anon_sym___asm__] = ACTIONS(3138),
    [aux_sym_number_literal_token1] = ACTIONS(3140),
    [aux_sym_number_literal_token2] = ACTIONS(3138),
    [anon_sym_L_SQUOTE] = ACTIONS(3140),
    [anon_sym_u_SQUOTE] = ACTIONS(3140),
    [anon_sym_U_SQUOTE] = ACTIONS(3140),
    [anon_sym_u8_SQUOTE] = ACTIONS(3140),
    [anon_sym_SQUOTE] = ACTIONS(3140),
    [anon_sym_L_DQUOTE] = ACTIONS(3140),
    [anon_sym_u_DQUOTE] = ACTIONS(3140),
    [anon_sym_U_DQUOTE] = ACTIONS(3140),
    [anon_sym_u8_DQUOTE] = ACTIONS(3140),
    [anon_sym_DQUOTE] = ACTIONS(3140),
    [sym_true] = ACTIONS(3138),
    [sym_false] = ACTIONS(3138),
    [anon_sym_NULL] = ACTIONS(3138),
    [anon_sym_nullptr] = ACTIONS(3138),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3138),
    [anon_sym_decltype] = ACTIONS(3138),
    [anon_sym_virtual] = ACTIONS(3138),
    [anon_sym_alignas] = ACTIONS(3138),
    [anon_sym_explicit] = ACTIONS(3138),
    [anon_sym_typename] = ACTIONS(3138),
    [anon_sym_template] = ACTIONS(3138),
    [anon_sym_operator] = ACTIONS(3138),
    [anon_sym_try] = ACTIONS(3138),
    [anon_sym_delete] = ACTIONS(3138),
    [anon_sym_throw] = ACTIONS(3138),
    [anon_sym_namespace] = ACTIONS(3138),
    [anon_sym_using] = ACTIONS(3138),
    [anon_sym_static_assert] = ACTIONS(3138),
    [anon_sym_concept] = ACTIONS(3138),
    [anon_sym_co_return] = ACTIONS(3138),
    [anon_sym_co_yield] = ACTIONS(3138),
    [anon_sym_R_DQUOTE] = ACTIONS(3140),
    [anon_sym_LR_DQUOTE] = ACTIONS(3140),
    [anon_sym_uR_DQUOTE] = ACTIONS(3140),
    [anon_sym_UR_DQUOTE] = ACTIONS(3140),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3140),
    [anon_sym_co_await] = ACTIONS(3138),
    [anon_sym_new] = ACTIONS(3138),
    [anon_sym_requires] = ACTIONS(3138),
    [sym_this] = ACTIONS(3138),
  },
  [817] = {
    [sym_identifier] = ACTIONS(2927),
    [aux_sym_preproc_include_token1] = ACTIONS(2927),
    [aux_sym_preproc_def_token1] = ACTIONS(2927),
    [aux_sym_preproc_if_token1] = ACTIONS(2927),
    [aux_sym_preproc_if_token2] = ACTIONS(2927),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2927),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2927),
    [sym_preproc_directive] = ACTIONS(2927),
    [anon_sym_LPAREN2] = ACTIONS(2932),
    [anon_sym_BANG] = ACTIONS(2932),
    [anon_sym_TILDE] = ACTIONS(2932),
    [anon_sym_DASH] = ACTIONS(2927),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2932),
    [anon_sym_AMP_AMP] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2927),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym___extension__] = ACTIONS(2927),
    [anon_sym_typedef] = ACTIONS(2927),
    [anon_sym_extern] = ACTIONS(2927),
    [anon_sym___attribute__] = ACTIONS(2927),
    [anon_sym_COLON_COLON] = ACTIONS(2932),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2932),
    [anon_sym___declspec] = ACTIONS(2927),
    [anon_sym___based] = ACTIONS(2927),
    [anon_sym___cdecl] = ACTIONS(2927),
    [anon_sym___clrcall] = ACTIONS(2927),
    [anon_sym___stdcall] = ACTIONS(2927),
    [anon_sym___fastcall] = ACTIONS(2927),
    [anon_sym___thiscall] = ACTIONS(2927),
    [anon_sym___vectorcall] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2932),
    [anon_sym_signed] = ACTIONS(2927),
    [anon_sym_unsigned] = ACTIONS(2927),
    [anon_sym_long] = ACTIONS(2927),
    [anon_sym_short] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_static] = ACTIONS(2927),
    [anon_sym_register] = ACTIONS(2927),
    [anon_sym_inline] = ACTIONS(2927),
    [anon_sym___inline] = ACTIONS(2927),
    [anon_sym___inline__] = ACTIONS(2927),
    [anon_sym___forceinline] = ACTIONS(2927),
    [anon_sym_thread_local] = ACTIONS(2927),
    [anon_sym___thread] = ACTIONS(2927),
    [anon_sym_const] = ACTIONS(2927),
    [anon_sym_constexpr] = ACTIONS(2927),
    [anon_sym_volatile] = ACTIONS(2927),
    [anon_sym_restrict] = ACTIONS(2927),
    [anon_sym___restrict__] = ACTIONS(2927),
    [anon_sym__Atomic] = ACTIONS(2927),
    [anon_sym__Noreturn] = ACTIONS(2927),
    [anon_sym_noreturn] = ACTIONS(2927),
    [anon_sym_mutable] = ACTIONS(2927),
    [anon_sym_constinit] = ACTIONS(2927),
    [anon_sym_consteval] = ACTIONS(2927),
    [anon_sym_PROGMEM] = ACTIONS(2927),
    [aux_sym_primitive_type_token1] = ACTIONS(2927),
    [anon_sym_byte] = ACTIONS(2927),
    [anon_sym_word] = ACTIONS(2927),
    [anon_sym_enum] = ACTIONS(2927),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_struct] = ACTIONS(2927),
    [anon_sym_union] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_else] = ACTIONS(2927),
    [anon_sym_switch] = ACTIONS(2927),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_default] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_goto] = ACTIONS(2927),
    [anon_sym___try] = ACTIONS(2927),
    [anon_sym___leave] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2927),
    [anon_sym_compl] = ACTIONS(2927),
    [anon_sym_DASH_DASH] = ACTIONS(2932),
    [anon_sym_PLUS_PLUS] = ACTIONS(2932),
    [anon_sym_sizeof] = ACTIONS(2927),
    [anon_sym___alignof__] = ACTIONS(2927),
    [anon_sym___alignof] = ACTIONS(2927),
    [anon_sym__alignof] = ACTIONS(2927),
    [anon_sym_alignof] = ACTIONS(2927),
    [anon_sym__Alignof] = ACTIONS(2927),
    [anon_sym_offsetof] = ACTIONS(2927),
    [anon_sym__Generic] = ACTIONS(2927),
    [anon_sym_asm] = ACTIONS(2927),
    [anon_sym___asm__] = ACTIONS(2927),
    [aux_sym_number_literal_token1] = ACTIONS(2932),
    [aux_sym_number_literal_token2] = ACTIONS(2927),
    [anon_sym_L_SQUOTE] = ACTIONS(2932),
    [anon_sym_u_SQUOTE] = ACTIONS(2932),
    [anon_sym_U_SQUOTE] = ACTIONS(2932),
    [anon_sym_u8_SQUOTE] = ACTIONS(2932),
    [anon_sym_SQUOTE] = ACTIONS(2932),
    [anon_sym_L_DQUOTE] = ACTIONS(2932),
    [anon_sym_u_DQUOTE] = ACTIONS(2932),
    [anon_sym_U_DQUOTE] = ACTIONS(2932),
    [anon_sym_u8_DQUOTE] = ACTIONS(2932),
    [anon_sym_DQUOTE] = ACTIONS(2932),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [anon_sym_NULL] = ACTIONS(2927),
    [anon_sym_nullptr] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2927),
    [anon_sym_decltype] = ACTIONS(2927),
    [anon_sym_virtual] = ACTIONS(2927),
    [anon_sym_alignas] = ACTIONS(2927),
    [anon_sym_explicit] = ACTIONS(2927),
    [anon_sym_typename] = ACTIONS(2927),
    [anon_sym_template] = ACTIONS(2927),
    [anon_sym_operator] = ACTIONS(2927),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_throw] = ACTIONS(2927),
    [anon_sym_namespace] = ACTIONS(2927),
    [anon_sym_using] = ACTIONS(2927),
    [anon_sym_static_assert] = ACTIONS(2927),
    [anon_sym_concept] = ACTIONS(2927),
    [anon_sym_co_return] = ACTIONS(2927),
    [anon_sym_co_yield] = ACTIONS(2927),
    [anon_sym_R_DQUOTE] = ACTIONS(2932),
    [anon_sym_LR_DQUOTE] = ACTIONS(2932),
    [anon_sym_uR_DQUOTE] = ACTIONS(2932),
    [anon_sym_UR_DQUOTE] = ACTIONS(2932),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2932),
    [anon_sym_co_await] = ACTIONS(2927),
    [anon_sym_new] = ACTIONS(2927),
    [anon_sym_requires] = ACTIONS(2927),
    [sym_this] = ACTIONS(2927),
  },
  [818] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_include_token1] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [anon_sym_COMMA] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token2] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_BANG] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym___cdecl] = ACTIONS(2267),
    [anon_sym___clrcall] = ACTIONS(2267),
    [anon_sym___stdcall] = ACTIONS(2267),
    [anon_sym___fastcall] = ACTIONS(2267),
    [anon_sym___thiscall] = ACTIONS(2267),
    [anon_sym___vectorcall] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2265),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_case] = ACTIONS(2267),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_return] = ACTIONS(2267),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_continue] = ACTIONS(2267),
    [anon_sym_goto] = ACTIONS(2267),
    [anon_sym___try] = ACTIONS(2267),
    [anon_sym___leave] = ACTIONS(2267),
    [anon_sym_not] = ACTIONS(2267),
    [anon_sym_compl] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2265),
    [anon_sym_PLUS_PLUS] = ACTIONS(2265),
    [anon_sym_sizeof] = ACTIONS(2267),
    [anon_sym___alignof__] = ACTIONS(2267),
    [anon_sym___alignof] = ACTIONS(2267),
    [anon_sym__alignof] = ACTIONS(2267),
    [anon_sym_alignof] = ACTIONS(2267),
    [anon_sym__Alignof] = ACTIONS(2267),
    [anon_sym_offsetof] = ACTIONS(2267),
    [anon_sym__Generic] = ACTIONS(2267),
    [anon_sym_asm] = ACTIONS(2267),
    [anon_sym___asm__] = ACTIONS(2267),
    [aux_sym_number_literal_token1] = ACTIONS(2265),
    [aux_sym_number_literal_token2] = ACTIONS(2267),
    [anon_sym_L_SQUOTE] = ACTIONS(2265),
    [anon_sym_u_SQUOTE] = ACTIONS(2265),
    [anon_sym_U_SQUOTE] = ACTIONS(2265),
    [anon_sym_u8_SQUOTE] = ACTIONS(2265),
    [anon_sym_SQUOTE] = ACTIONS(2265),
    [anon_sym_L_DQUOTE] = ACTIONS(2265),
    [anon_sym_u_DQUOTE] = ACTIONS(2265),
    [anon_sym_U_DQUOTE] = ACTIONS(2265),
    [anon_sym_u8_DQUOTE] = ACTIONS(2265),
    [anon_sym_DQUOTE] = ACTIONS(2265),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [anon_sym_NULL] = ACTIONS(2267),
    [anon_sym_nullptr] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_try] = ACTIONS(2267),
    [anon_sym_delete] = ACTIONS(2267),
    [anon_sym_throw] = ACTIONS(2267),
    [anon_sym_namespace] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym_concept] = ACTIONS(2267),
    [anon_sym_co_return] = ACTIONS(2267),
    [anon_sym_co_yield] = ACTIONS(2267),
    [anon_sym_R_DQUOTE] = ACTIONS(2265),
    [anon_sym_LR_DQUOTE] = ACTIONS(2265),
    [anon_sym_uR_DQUOTE] = ACTIONS(2265),
    [anon_sym_UR_DQUOTE] = ACTIONS(2265),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2265),
    [anon_sym_co_await] = ACTIONS(2267),
    [anon_sym_new] = ACTIONS(2267),
    [anon_sym_requires] = ACTIONS(2267),
    [sym_this] = ACTIONS(2267),
  },
  [819] = {
    [sym_identifier] = ACTIONS(3134),
    [aux_sym_preproc_include_token1] = ACTIONS(3134),
    [aux_sym_preproc_def_token1] = ACTIONS(3134),
    [aux_sym_preproc_if_token1] = ACTIONS(3134),
    [aux_sym_preproc_if_token2] = ACTIONS(3134),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3134),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3134),
    [sym_preproc_directive] = ACTIONS(3134),
    [anon_sym_LPAREN2] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3136),
    [anon_sym_TILDE] = ACTIONS(3136),
    [anon_sym_DASH] = ACTIONS(3134),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_STAR] = ACTIONS(3136),
    [anon_sym_AMP_AMP] = ACTIONS(3136),
    [anon_sym_AMP] = ACTIONS(3134),
    [anon_sym_SEMI] = ACTIONS(3136),
    [anon_sym___extension__] = ACTIONS(3134),
    [anon_sym_typedef] = ACTIONS(3134),
    [anon_sym_extern] = ACTIONS(3134),
    [anon_sym___attribute__] = ACTIONS(3134),
    [anon_sym_COLON_COLON] = ACTIONS(3136),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3136),
    [anon_sym___declspec] = ACTIONS(3134),
    [anon_sym___based] = ACTIONS(3134),
    [anon_sym___cdecl] = ACTIONS(3134),
    [anon_sym___clrcall] = ACTIONS(3134),
    [anon_sym___stdcall] = ACTIONS(3134),
    [anon_sym___fastcall] = ACTIONS(3134),
    [anon_sym___thiscall] = ACTIONS(3134),
    [anon_sym___vectorcall] = ACTIONS(3134),
    [anon_sym_LBRACE] = ACTIONS(3136),
    [anon_sym_signed] = ACTIONS(3134),
    [anon_sym_unsigned] = ACTIONS(3134),
    [anon_sym_long] = ACTIONS(3134),
    [anon_sym_short] = ACTIONS(3134),
    [anon_sym_LBRACK] = ACTIONS(3134),
    [anon_sym_static] = ACTIONS(3134),
    [anon_sym_register] = ACTIONS(3134),
    [anon_sym_inline] = ACTIONS(3134),
    [anon_sym___inline] = ACTIONS(3134),
    [anon_sym___inline__] = ACTIONS(3134),
    [anon_sym___forceinline] = ACTIONS(3134),
    [anon_sym_thread_local] = ACTIONS(3134),
    [anon_sym___thread] = ACTIONS(3134),
    [anon_sym_const] = ACTIONS(3134),
    [anon_sym_constexpr] = ACTIONS(3134),
    [anon_sym_volatile] = ACTIONS(3134),
    [anon_sym_restrict] = ACTIONS(3134),
    [anon_sym___restrict__] = ACTIONS(3134),
    [anon_sym__Atomic] = ACTIONS(3134),
    [anon_sym__Noreturn] = ACTIONS(3134),
    [anon_sym_noreturn] = ACTIONS(3134),
    [anon_sym_mutable] = ACTIONS(3134),
    [anon_sym_constinit] = ACTIONS(3134),
    [anon_sym_consteval] = ACTIONS(3134),
    [anon_sym_PROGMEM] = ACTIONS(3134),
    [aux_sym_primitive_type_token1] = ACTIONS(3134),
    [anon_sym_byte] = ACTIONS(3134),
    [anon_sym_word] = ACTIONS(3134),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3134),
    [anon_sym_struct] = ACTIONS(3134),
    [anon_sym_union] = ACTIONS(3134),
    [anon_sym_if] = ACTIONS(3134),
    [anon_sym_else] = ACTIONS(3134),
    [anon_sym_switch] = ACTIONS(3134),
    [anon_sym_case] = ACTIONS(3134),
    [anon_sym_default] = ACTIONS(3134),
    [anon_sym_while] = ACTIONS(3134),
    [anon_sym_do] = ACTIONS(3134),
    [anon_sym_for] = ACTIONS(3134),
    [anon_sym_return] = ACTIONS(3134),
    [anon_sym_break] = ACTIONS(3134),
    [anon_sym_continue] = ACTIONS(3134),
    [anon_sym_goto] = ACTIONS(3134),
    [anon_sym___try] = ACTIONS(3134),
    [anon_sym___leave] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3134),
    [anon_sym_compl] = ACTIONS(3134),
    [anon_sym_DASH_DASH] = ACTIONS(3136),
    [anon_sym_PLUS_PLUS] = ACTIONS(3136),
    [anon_sym_sizeof] = ACTIONS(3134),
    [anon_sym___alignof__] = ACTIONS(3134),
    [anon_sym___alignof] = ACTIONS(3134),
    [anon_sym__alignof] = ACTIONS(3134),
    [anon_sym_alignof] = ACTIONS(3134),
    [anon_sym__Alignof] = ACTIONS(3134),
    [anon_sym_offsetof] = ACTIONS(3134),
    [anon_sym__Generic] = ACTIONS(3134),
    [anon_sym_asm] = ACTIONS(3134),
    [anon_sym___asm__] = ACTIONS(3134),
    [aux_sym_number_literal_token1] = ACTIONS(3136),
    [aux_sym_number_literal_token2] = ACTIONS(3134),
    [anon_sym_L_SQUOTE] = ACTIONS(3136),
    [anon_sym_u_SQUOTE] = ACTIONS(3136),
    [anon_sym_U_SQUOTE] = ACTIONS(3136),
    [anon_sym_u8_SQUOTE] = ACTIONS(3136),
    [anon_sym_SQUOTE] = ACTIONS(3136),
    [anon_sym_L_DQUOTE] = ACTIONS(3136),
    [anon_sym_u_DQUOTE] = ACTIONS(3136),
    [anon_sym_U_DQUOTE] = ACTIONS(3136),
    [anon_sym_u8_DQUOTE] = ACTIONS(3136),
    [anon_sym_DQUOTE] = ACTIONS(3136),
    [sym_true] = ACTIONS(3134),
    [sym_false] = ACTIONS(3134),
    [anon_sym_NULL] = ACTIONS(3134),
    [anon_sym_nullptr] = ACTIONS(3134),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3134),
    [anon_sym_decltype] = ACTIONS(3134),
    [anon_sym_virtual] = ACTIONS(3134),
    [anon_sym_alignas] = ACTIONS(3134),
    [anon_sym_explicit] = ACTIONS(3134),
    [anon_sym_typename] = ACTIONS(3134),
    [anon_sym_template] = ACTIONS(3134),
    [anon_sym_operator] = ACTIONS(3134),
    [anon_sym_try] = ACTIONS(3134),
    [anon_sym_delete] = ACTIONS(3134),
    [anon_sym_throw] = ACTIONS(3134),
    [anon_sym_namespace] = ACTIONS(3134),
    [anon_sym_using] = ACTIONS(3134),
    [anon_sym_static_assert] = ACTIONS(3134),
    [anon_sym_concept] = ACTIONS(3134),
    [anon_sym_co_return] = ACTIONS(3134),
    [anon_sym_co_yield] = ACTIONS(3134),
    [anon_sym_R_DQUOTE] = ACTIONS(3136),
    [anon_sym_LR_DQUOTE] = ACTIONS(3136),
    [anon_sym_uR_DQUOTE] = ACTIONS(3136),
    [anon_sym_UR_DQUOTE] = ACTIONS(3136),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3136),
    [anon_sym_co_await] = ACTIONS(3134),
    [anon_sym_new] = ACTIONS(3134),
    [anon_sym_requires] = ACTIONS(3134),
    [sym_this] = ACTIONS(3134),
  },
  [820] = {
    [sym_identifier] = ACTIONS(3150),
    [aux_sym_preproc_include_token1] = ACTIONS(3150),
    [aux_sym_preproc_def_token1] = ACTIONS(3150),
    [aux_sym_preproc_if_token1] = ACTIONS(3150),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3150),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3150),
    [sym_preproc_directive] = ACTIONS(3150),
    [anon_sym_LPAREN2] = ACTIONS(3152),
    [anon_sym_BANG] = ACTIONS(3152),
    [anon_sym_TILDE] = ACTIONS(3152),
    [anon_sym_DASH] = ACTIONS(3150),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_STAR] = ACTIONS(3152),
    [anon_sym_AMP_AMP] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(3152),
    [anon_sym___extension__] = ACTIONS(3150),
    [anon_sym_typedef] = ACTIONS(3150),
    [anon_sym_extern] = ACTIONS(3150),
    [anon_sym___attribute__] = ACTIONS(3150),
    [anon_sym_COLON_COLON] = ACTIONS(3152),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3152),
    [anon_sym___declspec] = ACTIONS(3150),
    [anon_sym___based] = ACTIONS(3150),
    [anon_sym___cdecl] = ACTIONS(3150),
    [anon_sym___clrcall] = ACTIONS(3150),
    [anon_sym___stdcall] = ACTIONS(3150),
    [anon_sym___fastcall] = ACTIONS(3150),
    [anon_sym___thiscall] = ACTIONS(3150),
    [anon_sym___vectorcall] = ACTIONS(3150),
    [anon_sym_LBRACE] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(3152),
    [anon_sym_signed] = ACTIONS(3150),
    [anon_sym_unsigned] = ACTIONS(3150),
    [anon_sym_long] = ACTIONS(3150),
    [anon_sym_short] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3150),
    [anon_sym_static] = ACTIONS(3150),
    [anon_sym_register] = ACTIONS(3150),
    [anon_sym_inline] = ACTIONS(3150),
    [anon_sym___inline] = ACTIONS(3150),
    [anon_sym___inline__] = ACTIONS(3150),
    [anon_sym___forceinline] = ACTIONS(3150),
    [anon_sym_thread_local] = ACTIONS(3150),
    [anon_sym___thread] = ACTIONS(3150),
    [anon_sym_const] = ACTIONS(3150),
    [anon_sym_constexpr] = ACTIONS(3150),
    [anon_sym_volatile] = ACTIONS(3150),
    [anon_sym_restrict] = ACTIONS(3150),
    [anon_sym___restrict__] = ACTIONS(3150),
    [anon_sym__Atomic] = ACTIONS(3150),
    [anon_sym__Noreturn] = ACTIONS(3150),
    [anon_sym_noreturn] = ACTIONS(3150),
    [anon_sym_mutable] = ACTIONS(3150),
    [anon_sym_constinit] = ACTIONS(3150),
    [anon_sym_consteval] = ACTIONS(3150),
    [anon_sym_PROGMEM] = ACTIONS(3150),
    [aux_sym_primitive_type_token1] = ACTIONS(3150),
    [anon_sym_byte] = ACTIONS(3150),
    [anon_sym_word] = ACTIONS(3150),
    [anon_sym_enum] = ACTIONS(3150),
    [anon_sym_class] = ACTIONS(3150),
    [anon_sym_struct] = ACTIONS(3150),
    [anon_sym_union] = ACTIONS(3150),
    [anon_sym_if] = ACTIONS(3150),
    [anon_sym_else] = ACTIONS(3150),
    [anon_sym_switch] = ACTIONS(3150),
    [anon_sym_case] = ACTIONS(3150),
    [anon_sym_default] = ACTIONS(3150),
    [anon_sym_while] = ACTIONS(3150),
    [anon_sym_do] = ACTIONS(3150),
    [anon_sym_for] = ACTIONS(3150),
    [anon_sym_return] = ACTIONS(3150),
    [anon_sym_break] = ACTIONS(3150),
    [anon_sym_continue] = ACTIONS(3150),
    [anon_sym_goto] = ACTIONS(3150),
    [anon_sym___try] = ACTIONS(3150),
    [anon_sym___leave] = ACTIONS(3150),
    [anon_sym_not] = ACTIONS(3150),
    [anon_sym_compl] = ACTIONS(3150),
    [anon_sym_DASH_DASH] = ACTIONS(3152),
    [anon_sym_PLUS_PLUS] = ACTIONS(3152),
    [anon_sym_sizeof] = ACTIONS(3150),
    [anon_sym___alignof__] = ACTIONS(3150),
    [anon_sym___alignof] = ACTIONS(3150),
    [anon_sym__alignof] = ACTIONS(3150),
    [anon_sym_alignof] = ACTIONS(3150),
    [anon_sym__Alignof] = ACTIONS(3150),
    [anon_sym_offsetof] = ACTIONS(3150),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3150),
    [anon_sym___asm__] = ACTIONS(3150),
    [aux_sym_number_literal_token1] = ACTIONS(3152),
    [aux_sym_number_literal_token2] = ACTIONS(3150),
    [anon_sym_L_SQUOTE] = ACTIONS(3152),
    [anon_sym_u_SQUOTE] = ACTIONS(3152),
    [anon_sym_U_SQUOTE] = ACTIONS(3152),
    [anon_sym_u8_SQUOTE] = ACTIONS(3152),
    [anon_sym_SQUOTE] = ACTIONS(3152),
    [anon_sym_L_DQUOTE] = ACTIONS(3152),
    [anon_sym_u_DQUOTE] = ACTIONS(3152),
    [anon_sym_U_DQUOTE] = ACTIONS(3152),
    [anon_sym_u8_DQUOTE] = ACTIONS(3152),
    [anon_sym_DQUOTE] = ACTIONS(3152),
    [sym_true] = ACTIONS(3150),
    [sym_false] = ACTIONS(3150),
    [anon_sym_NULL] = ACTIONS(3150),
    [anon_sym_nullptr] = ACTIONS(3150),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3150),
    [anon_sym_decltype] = ACTIONS(3150),
    [anon_sym_virtual] = ACTIONS(3150),
    [anon_sym_alignas] = ACTIONS(3150),
    [anon_sym_explicit] = ACTIONS(3150),
    [anon_sym_typename] = ACTIONS(3150),
    [anon_sym_template] = ACTIONS(3150),
    [anon_sym_operator] = ACTIONS(3150),
    [anon_sym_try] = ACTIONS(3150),
    [anon_sym_delete] = ACTIONS(3150),
    [anon_sym_throw] = ACTIONS(3150),
    [anon_sym_namespace] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_static_assert] = ACTIONS(3150),
    [anon_sym_concept] = ACTIONS(3150),
    [anon_sym_co_return] = ACTIONS(3150),
    [anon_sym_co_yield] = ACTIONS(3150),
    [anon_sym_R_DQUOTE] = ACTIONS(3152),
    [anon_sym_LR_DQUOTE] = ACTIONS(3152),
    [anon_sym_uR_DQUOTE] = ACTIONS(3152),
    [anon_sym_UR_DQUOTE] = ACTIONS(3152),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3152),
    [anon_sym_co_await] = ACTIONS(3150),
    [anon_sym_new] = ACTIONS(3150),
    [anon_sym_requires] = ACTIONS(3150),
    [sym_this] = ACTIONS(3150),
  },
  [821] = {
    [ts_builtin_sym_end] = ACTIONS(3170),
    [sym_identifier] = ACTIONS(3168),
    [aux_sym_preproc_include_token1] = ACTIONS(3168),
    [aux_sym_preproc_def_token1] = ACTIONS(3168),
    [aux_sym_preproc_if_token1] = ACTIONS(3168),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3168),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3168),
    [sym_preproc_directive] = ACTIONS(3168),
    [anon_sym_LPAREN2] = ACTIONS(3170),
    [anon_sym_BANG] = ACTIONS(3170),
    [anon_sym_TILDE] = ACTIONS(3170),
    [anon_sym_DASH] = ACTIONS(3168),
    [anon_sym_PLUS] = ACTIONS(3168),
    [anon_sym_STAR] = ACTIONS(3170),
    [anon_sym_AMP_AMP] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3168),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym___extension__] = ACTIONS(3168),
    [anon_sym_typedef] = ACTIONS(3168),
    [anon_sym_extern] = ACTIONS(3168),
    [anon_sym___attribute__] = ACTIONS(3168),
    [anon_sym_COLON_COLON] = ACTIONS(3170),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3170),
    [anon_sym___declspec] = ACTIONS(3168),
    [anon_sym___based] = ACTIONS(3168),
    [anon_sym___cdecl] = ACTIONS(3168),
    [anon_sym___clrcall] = ACTIONS(3168),
    [anon_sym___stdcall] = ACTIONS(3168),
    [anon_sym___fastcall] = ACTIONS(3168),
    [anon_sym___thiscall] = ACTIONS(3168),
    [anon_sym___vectorcall] = ACTIONS(3168),
    [anon_sym_LBRACE] = ACTIONS(3170),
    [anon_sym_signed] = ACTIONS(3168),
    [anon_sym_unsigned] = ACTIONS(3168),
    [anon_sym_long] = ACTIONS(3168),
    [anon_sym_short] = ACTIONS(3168),
    [anon_sym_LBRACK] = ACTIONS(3168),
    [anon_sym_static] = ACTIONS(3168),
    [anon_sym_register] = ACTIONS(3168),
    [anon_sym_inline] = ACTIONS(3168),
    [anon_sym___inline] = ACTIONS(3168),
    [anon_sym___inline__] = ACTIONS(3168),
    [anon_sym___forceinline] = ACTIONS(3168),
    [anon_sym_thread_local] = ACTIONS(3168),
    [anon_sym___thread] = ACTIONS(3168),
    [anon_sym_const] = ACTIONS(3168),
    [anon_sym_constexpr] = ACTIONS(3168),
    [anon_sym_volatile] = ACTIONS(3168),
    [anon_sym_restrict] = ACTIONS(3168),
    [anon_sym___restrict__] = ACTIONS(3168),
    [anon_sym__Atomic] = ACTIONS(3168),
    [anon_sym__Noreturn] = ACTIONS(3168),
    [anon_sym_noreturn] = ACTIONS(3168),
    [anon_sym_mutable] = ACTIONS(3168),
    [anon_sym_constinit] = ACTIONS(3168),
    [anon_sym_consteval] = ACTIONS(3168),
    [anon_sym_PROGMEM] = ACTIONS(3168),
    [aux_sym_primitive_type_token1] = ACTIONS(3168),
    [anon_sym_byte] = ACTIONS(3168),
    [anon_sym_word] = ACTIONS(3168),
    [anon_sym_enum] = ACTIONS(3168),
    [anon_sym_class] = ACTIONS(3168),
    [anon_sym_struct] = ACTIONS(3168),
    [anon_sym_union] = ACTIONS(3168),
    [anon_sym_if] = ACTIONS(3168),
    [anon_sym_else] = ACTIONS(3168),
    [anon_sym_switch] = ACTIONS(3168),
    [anon_sym_case] = ACTIONS(3168),
    [anon_sym_default] = ACTIONS(3168),
    [anon_sym_while] = ACTIONS(3168),
    [anon_sym_do] = ACTIONS(3168),
    [anon_sym_for] = ACTIONS(3168),
    [anon_sym_return] = ACTIONS(3168),
    [anon_sym_break] = ACTIONS(3168),
    [anon_sym_continue] = ACTIONS(3168),
    [anon_sym_goto] = ACTIONS(3168),
    [anon_sym___try] = ACTIONS(3168),
    [anon_sym___leave] = ACTIONS(3168),
    [anon_sym_not] = ACTIONS(3168),
    [anon_sym_compl] = ACTIONS(3168),
    [anon_sym_DASH_DASH] = ACTIONS(3170),
    [anon_sym_PLUS_PLUS] = ACTIONS(3170),
    [anon_sym_sizeof] = ACTIONS(3168),
    [anon_sym___alignof__] = ACTIONS(3168),
    [anon_sym___alignof] = ACTIONS(3168),
    [anon_sym__alignof] = ACTIONS(3168),
    [anon_sym_alignof] = ACTIONS(3168),
    [anon_sym__Alignof] = ACTIONS(3168),
    [anon_sym_offsetof] = ACTIONS(3168),
    [anon_sym__Generic] = ACTIONS(3168),
    [anon_sym_asm] = ACTIONS(3168),
    [anon_sym___asm__] = ACTIONS(3168),
    [aux_sym_number_literal_token1] = ACTIONS(3170),
    [aux_sym_number_literal_token2] = ACTIONS(3168),
    [anon_sym_L_SQUOTE] = ACTIONS(3170),
    [anon_sym_u_SQUOTE] = ACTIONS(3170),
    [anon_sym_U_SQUOTE] = ACTIONS(3170),
    [anon_sym_u8_SQUOTE] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3170),
    [anon_sym_L_DQUOTE] = ACTIONS(3170),
    [anon_sym_u_DQUOTE] = ACTIONS(3170),
    [anon_sym_U_DQUOTE] = ACTIONS(3170),
    [anon_sym_u8_DQUOTE] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3170),
    [sym_true] = ACTIONS(3168),
    [sym_false] = ACTIONS(3168),
    [anon_sym_NULL] = ACTIONS(3168),
    [anon_sym_nullptr] = ACTIONS(3168),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3168),
    [anon_sym_decltype] = ACTIONS(3168),
    [anon_sym_virtual] = ACTIONS(3168),
    [anon_sym_alignas] = ACTIONS(3168),
    [anon_sym_explicit] = ACTIONS(3168),
    [anon_sym_typename] = ACTIONS(3168),
    [anon_sym_template] = ACTIONS(3168),
    [anon_sym_operator] = ACTIONS(3168),
    [anon_sym_try] = ACTIONS(3168),
    [anon_sym_delete] = ACTIONS(3168),
    [anon_sym_throw] = ACTIONS(3168),
    [anon_sym_namespace] = ACTIONS(3168),
    [anon_sym_using] = ACTIONS(3168),
    [anon_sym_static_assert] = ACTIONS(3168),
    [anon_sym_concept] = ACTIONS(3168),
    [anon_sym_co_return] = ACTIONS(3168),
    [anon_sym_co_yield] = ACTIONS(3168),
    [anon_sym_R_DQUOTE] = ACTIONS(3170),
    [anon_sym_LR_DQUOTE] = ACTIONS(3170),
    [anon_sym_uR_DQUOTE] = ACTIONS(3170),
    [anon_sym_UR_DQUOTE] = ACTIONS(3170),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3170),
    [anon_sym_co_await] = ACTIONS(3168),
    [anon_sym_new] = ACTIONS(3168),
    [anon_sym_requires] = ACTIONS(3168),
    [sym_this] = ACTIONS(3168),
  },
  [822] = {
    [sym_identifier] = ACTIONS(3154),
    [aux_sym_preproc_include_token1] = ACTIONS(3154),
    [aux_sym_preproc_def_token1] = ACTIONS(3154),
    [aux_sym_preproc_if_token1] = ACTIONS(3154),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3154),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3154),
    [sym_preproc_directive] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3156),
    [anon_sym_BANG] = ACTIONS(3156),
    [anon_sym_TILDE] = ACTIONS(3156),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_STAR] = ACTIONS(3156),
    [anon_sym_AMP_AMP] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3154),
    [anon_sym_SEMI] = ACTIONS(3156),
    [anon_sym___extension__] = ACTIONS(3154),
    [anon_sym_typedef] = ACTIONS(3154),
    [anon_sym_extern] = ACTIONS(3154),
    [anon_sym___attribute__] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3156),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3156),
    [anon_sym___declspec] = ACTIONS(3154),
    [anon_sym___based] = ACTIONS(3154),
    [anon_sym___cdecl] = ACTIONS(3154),
    [anon_sym___clrcall] = ACTIONS(3154),
    [anon_sym___stdcall] = ACTIONS(3154),
    [anon_sym___fastcall] = ACTIONS(3154),
    [anon_sym___thiscall] = ACTIONS(3154),
    [anon_sym___vectorcall] = ACTIONS(3154),
    [anon_sym_LBRACE] = ACTIONS(3156),
    [anon_sym_RBRACE] = ACTIONS(3156),
    [anon_sym_signed] = ACTIONS(3154),
    [anon_sym_unsigned] = ACTIONS(3154),
    [anon_sym_long] = ACTIONS(3154),
    [anon_sym_short] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_static] = ACTIONS(3154),
    [anon_sym_register] = ACTIONS(3154),
    [anon_sym_inline] = ACTIONS(3154),
    [anon_sym___inline] = ACTIONS(3154),
    [anon_sym___inline__] = ACTIONS(3154),
    [anon_sym___forceinline] = ACTIONS(3154),
    [anon_sym_thread_local] = ACTIONS(3154),
    [anon_sym___thread] = ACTIONS(3154),
    [anon_sym_const] = ACTIONS(3154),
    [anon_sym_constexpr] = ACTIONS(3154),
    [anon_sym_volatile] = ACTIONS(3154),
    [anon_sym_restrict] = ACTIONS(3154),
    [anon_sym___restrict__] = ACTIONS(3154),
    [anon_sym__Atomic] = ACTIONS(3154),
    [anon_sym__Noreturn] = ACTIONS(3154),
    [anon_sym_noreturn] = ACTIONS(3154),
    [anon_sym_mutable] = ACTIONS(3154),
    [anon_sym_constinit] = ACTIONS(3154),
    [anon_sym_consteval] = ACTIONS(3154),
    [anon_sym_PROGMEM] = ACTIONS(3154),
    [aux_sym_primitive_type_token1] = ACTIONS(3154),
    [anon_sym_byte] = ACTIONS(3154),
    [anon_sym_word] = ACTIONS(3154),
    [anon_sym_enum] = ACTIONS(3154),
    [anon_sym_class] = ACTIONS(3154),
    [anon_sym_struct] = ACTIONS(3154),
    [anon_sym_union] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_else] = ACTIONS(3154),
    [anon_sym_switch] = ACTIONS(3154),
    [anon_sym_case] = ACTIONS(3154),
    [anon_sym_default] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_break] = ACTIONS(3154),
    [anon_sym_continue] = ACTIONS(3154),
    [anon_sym_goto] = ACTIONS(3154),
    [anon_sym___try] = ACTIONS(3154),
    [anon_sym___leave] = ACTIONS(3154),
    [anon_sym_not] = ACTIONS(3154),
    [anon_sym_compl] = ACTIONS(3154),
    [anon_sym_DASH_DASH] = ACTIONS(3156),
    [anon_sym_PLUS_PLUS] = ACTIONS(3156),
    [anon_sym_sizeof] = ACTIONS(3154),
    [anon_sym___alignof__] = ACTIONS(3154),
    [anon_sym___alignof] = ACTIONS(3154),
    [anon_sym__alignof] = ACTIONS(3154),
    [anon_sym_alignof] = ACTIONS(3154),
    [anon_sym__Alignof] = ACTIONS(3154),
    [anon_sym_offsetof] = ACTIONS(3154),
    [anon_sym__Generic] = ACTIONS(3154),
    [anon_sym_asm] = ACTIONS(3154),
    [anon_sym___asm__] = ACTIONS(3154),
    [aux_sym_number_literal_token1] = ACTIONS(3156),
    [aux_sym_number_literal_token2] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3156),
    [anon_sym_u_DQUOTE] = ACTIONS(3156),
    [anon_sym_U_DQUOTE] = ACTIONS(3156),
    [anon_sym_u8_DQUOTE] = ACTIONS(3156),
    [anon_sym_DQUOTE] = ACTIONS(3156),
    [sym_true] = ACTIONS(3154),
    [sym_false] = ACTIONS(3154),
    [anon_sym_NULL] = ACTIONS(3154),
    [anon_sym_nullptr] = ACTIONS(3154),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3154),
    [anon_sym_decltype] = ACTIONS(3154),
    [anon_sym_virtual] = ACTIONS(3154),
    [anon_sym_alignas] = ACTIONS(3154),
    [anon_sym_explicit] = ACTIONS(3154),
    [anon_sym_typename] = ACTIONS(3154),
    [anon_sym_template] = ACTIONS(3154),
    [anon_sym_operator] = ACTIONS(3154),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_delete] = ACTIONS(3154),
    [anon_sym_throw] = ACTIONS(3154),
    [anon_sym_namespace] = ACTIONS(3154),
    [anon_sym_using] = ACTIONS(3154),
    [anon_sym_static_assert] = ACTIONS(3154),
    [anon_sym_concept] = ACTIONS(3154),
    [anon_sym_co_return] = ACTIONS(3154),
    [anon_sym_co_yield] = ACTIONS(3154),
    [anon_sym_R_DQUOTE] = ACTIONS(3156),
    [anon_sym_LR_DQUOTE] = ACTIONS(3156),
    [anon_sym_uR_DQUOTE] = ACTIONS(3156),
    [anon_sym_UR_DQUOTE] = ACTIONS(3156),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3156),
    [anon_sym_co_await] = ACTIONS(3154),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_requires] = ACTIONS(3154),
    [sym_this] = ACTIONS(3154),
  },
  [823] = {
    [ts_builtin_sym_end] = ACTIONS(3094),
    [sym_identifier] = ACTIONS(3092),
    [aux_sym_preproc_include_token1] = ACTIONS(3092),
    [aux_sym_preproc_def_token1] = ACTIONS(3092),
    [aux_sym_preproc_if_token1] = ACTIONS(3092),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3092),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3092),
    [sym_preproc_directive] = ACTIONS(3092),
    [anon_sym_LPAREN2] = ACTIONS(3094),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_TILDE] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_SEMI] = ACTIONS(3094),
    [anon_sym___extension__] = ACTIONS(3092),
    [anon_sym_typedef] = ACTIONS(3092),
    [anon_sym_extern] = ACTIONS(3092),
    [anon_sym___attribute__] = ACTIONS(3092),
    [anon_sym_COLON_COLON] = ACTIONS(3094),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3094),
    [anon_sym___declspec] = ACTIONS(3092),
    [anon_sym___based] = ACTIONS(3092),
    [anon_sym___cdecl] = ACTIONS(3092),
    [anon_sym___clrcall] = ACTIONS(3092),
    [anon_sym___stdcall] = ACTIONS(3092),
    [anon_sym___fastcall] = ACTIONS(3092),
    [anon_sym___thiscall] = ACTIONS(3092),
    [anon_sym___vectorcall] = ACTIONS(3092),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_signed] = ACTIONS(3092),
    [anon_sym_unsigned] = ACTIONS(3092),
    [anon_sym_long] = ACTIONS(3092),
    [anon_sym_short] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_static] = ACTIONS(3092),
    [anon_sym_register] = ACTIONS(3092),
    [anon_sym_inline] = ACTIONS(3092),
    [anon_sym___inline] = ACTIONS(3092),
    [anon_sym___inline__] = ACTIONS(3092),
    [anon_sym___forceinline] = ACTIONS(3092),
    [anon_sym_thread_local] = ACTIONS(3092),
    [anon_sym___thread] = ACTIONS(3092),
    [anon_sym_const] = ACTIONS(3092),
    [anon_sym_constexpr] = ACTIONS(3092),
    [anon_sym_volatile] = ACTIONS(3092),
    [anon_sym_restrict] = ACTIONS(3092),
    [anon_sym___restrict__] = ACTIONS(3092),
    [anon_sym__Atomic] = ACTIONS(3092),
    [anon_sym__Noreturn] = ACTIONS(3092),
    [anon_sym_noreturn] = ACTIONS(3092),
    [anon_sym_mutable] = ACTIONS(3092),
    [anon_sym_constinit] = ACTIONS(3092),
    [anon_sym_consteval] = ACTIONS(3092),
    [anon_sym_PROGMEM] = ACTIONS(3092),
    [aux_sym_primitive_type_token1] = ACTIONS(3092),
    [anon_sym_byte] = ACTIONS(3092),
    [anon_sym_word] = ACTIONS(3092),
    [anon_sym_enum] = ACTIONS(3092),
    [anon_sym_class] = ACTIONS(3092),
    [anon_sym_struct] = ACTIONS(3092),
    [anon_sym_union] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_switch] = ACTIONS(3092),
    [anon_sym_case] = ACTIONS(3092),
    [anon_sym_default] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_break] = ACTIONS(3092),
    [anon_sym_continue] = ACTIONS(3092),
    [anon_sym_goto] = ACTIONS(3092),
    [anon_sym___try] = ACTIONS(3092),
    [anon_sym___leave] = ACTIONS(3092),
    [anon_sym_not] = ACTIONS(3092),
    [anon_sym_compl] = ACTIONS(3092),
    [anon_sym_DASH_DASH] = ACTIONS(3094),
    [anon_sym_PLUS_PLUS] = ACTIONS(3094),
    [anon_sym_sizeof] = ACTIONS(3092),
    [anon_sym___alignof__] = ACTIONS(3092),
    [anon_sym___alignof] = ACTIONS(3092),
    [anon_sym__alignof] = ACTIONS(3092),
    [anon_sym_alignof] = ACTIONS(3092),
    [anon_sym__Alignof] = ACTIONS(3092),
    [anon_sym_offsetof] = ACTIONS(3092),
    [anon_sym__Generic] = ACTIONS(3092),
    [anon_sym_asm] = ACTIONS(3092),
    [anon_sym___asm__] = ACTIONS(3092),
    [aux_sym_number_literal_token1] = ACTIONS(3094),
    [aux_sym_number_literal_token2] = ACTIONS(3092),
    [anon_sym_L_SQUOTE] = ACTIONS(3094),
    [anon_sym_u_SQUOTE] = ACTIONS(3094),
    [anon_sym_U_SQUOTE] = ACTIONS(3094),
    [anon_sym_u8_SQUOTE] = ACTIONS(3094),
    [anon_sym_SQUOTE] = ACTIONS(3094),
    [anon_sym_L_DQUOTE] = ACTIONS(3094),
    [anon_sym_u_DQUOTE] = ACTIONS(3094),
    [anon_sym_U_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8_DQUOTE] = ACTIONS(3094),
    [anon_sym_DQUOTE] = ACTIONS(3094),
    [sym_true] = ACTIONS(3092),
    [sym_false] = ACTIONS(3092),
    [anon_sym_NULL] = ACTIONS(3092),
    [anon_sym_nullptr] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3092),
    [anon_sym_decltype] = ACTIONS(3092),
    [anon_sym_virtual] = ACTIONS(3092),
    [anon_sym_alignas] = ACTIONS(3092),
    [anon_sym_explicit] = ACTIONS(3092),
    [anon_sym_typename] = ACTIONS(3092),
    [anon_sym_template] = ACTIONS(3092),
    [anon_sym_operator] = ACTIONS(3092),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_delete] = ACTIONS(3092),
    [anon_sym_throw] = ACTIONS(3092),
    [anon_sym_namespace] = ACTIONS(3092),
    [anon_sym_using] = ACTIONS(3092),
    [anon_sym_static_assert] = ACTIONS(3092),
    [anon_sym_concept] = ACTIONS(3092),
    [anon_sym_co_return] = ACTIONS(3092),
    [anon_sym_co_yield] = ACTIONS(3092),
    [anon_sym_R_DQUOTE] = ACTIONS(3094),
    [anon_sym_LR_DQUOTE] = ACTIONS(3094),
    [anon_sym_uR_DQUOTE] = ACTIONS(3094),
    [anon_sym_UR_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3094),
    [anon_sym_co_await] = ACTIONS(3092),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_requires] = ACTIONS(3092),
    [sym_this] = ACTIONS(3092),
  },
  [824] = {
    [ts_builtin_sym_end] = ACTIONS(3174),
    [sym_identifier] = ACTIONS(3172),
    [aux_sym_preproc_include_token1] = ACTIONS(3172),
    [aux_sym_preproc_def_token1] = ACTIONS(3172),
    [aux_sym_preproc_if_token1] = ACTIONS(3172),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3172),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3172),
    [sym_preproc_directive] = ACTIONS(3172),
    [anon_sym_LPAREN2] = ACTIONS(3174),
    [anon_sym_BANG] = ACTIONS(3174),
    [anon_sym_TILDE] = ACTIONS(3174),
    [anon_sym_DASH] = ACTIONS(3172),
    [anon_sym_PLUS] = ACTIONS(3172),
    [anon_sym_STAR] = ACTIONS(3174),
    [anon_sym_AMP_AMP] = ACTIONS(3174),
    [anon_sym_AMP] = ACTIONS(3172),
    [anon_sym_SEMI] = ACTIONS(3174),
    [anon_sym___extension__] = ACTIONS(3172),
    [anon_sym_typedef] = ACTIONS(3172),
    [anon_sym_extern] = ACTIONS(3172),
    [anon_sym___attribute__] = ACTIONS(3172),
    [anon_sym_COLON_COLON] = ACTIONS(3174),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3174),
    [anon_sym___declspec] = ACTIONS(3172),
    [anon_sym___based] = ACTIONS(3172),
    [anon_sym___cdecl] = ACTIONS(3172),
    [anon_sym___clrcall] = ACTIONS(3172),
    [anon_sym___stdcall] = ACTIONS(3172),
    [anon_sym___fastcall] = ACTIONS(3172),
    [anon_sym___thiscall] = ACTIONS(3172),
    [anon_sym___vectorcall] = ACTIONS(3172),
    [anon_sym_LBRACE] = ACTIONS(3174),
    [anon_sym_signed] = ACTIONS(3172),
    [anon_sym_unsigned] = ACTIONS(3172),
    [anon_sym_long] = ACTIONS(3172),
    [anon_sym_short] = ACTIONS(3172),
    [anon_sym_LBRACK] = ACTIONS(3172),
    [anon_sym_static] = ACTIONS(3172),
    [anon_sym_register] = ACTIONS(3172),
    [anon_sym_inline] = ACTIONS(3172),
    [anon_sym___inline] = ACTIONS(3172),
    [anon_sym___inline__] = ACTIONS(3172),
    [anon_sym___forceinline] = ACTIONS(3172),
    [anon_sym_thread_local] = ACTIONS(3172),
    [anon_sym___thread] = ACTIONS(3172),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_constexpr] = ACTIONS(3172),
    [anon_sym_volatile] = ACTIONS(3172),
    [anon_sym_restrict] = ACTIONS(3172),
    [anon_sym___restrict__] = ACTIONS(3172),
    [anon_sym__Atomic] = ACTIONS(3172),
    [anon_sym__Noreturn] = ACTIONS(3172),
    [anon_sym_noreturn] = ACTIONS(3172),
    [anon_sym_mutable] = ACTIONS(3172),
    [anon_sym_constinit] = ACTIONS(3172),
    [anon_sym_consteval] = ACTIONS(3172),
    [anon_sym_PROGMEM] = ACTIONS(3172),
    [aux_sym_primitive_type_token1] = ACTIONS(3172),
    [anon_sym_byte] = ACTIONS(3172),
    [anon_sym_word] = ACTIONS(3172),
    [anon_sym_enum] = ACTIONS(3172),
    [anon_sym_class] = ACTIONS(3172),
    [anon_sym_struct] = ACTIONS(3172),
    [anon_sym_union] = ACTIONS(3172),
    [anon_sym_if] = ACTIONS(3172),
    [anon_sym_else] = ACTIONS(3172),
    [anon_sym_switch] = ACTIONS(3172),
    [anon_sym_case] = ACTIONS(3172),
    [anon_sym_default] = ACTIONS(3172),
    [anon_sym_while] = ACTIONS(3172),
    [anon_sym_do] = ACTIONS(3172),
    [anon_sym_for] = ACTIONS(3172),
    [anon_sym_return] = ACTIONS(3172),
    [anon_sym_break] = ACTIONS(3172),
    [anon_sym_continue] = ACTIONS(3172),
    [anon_sym_goto] = ACTIONS(3172),
    [anon_sym___try] = ACTIONS(3172),
    [anon_sym___leave] = ACTIONS(3172),
    [anon_sym_not] = ACTIONS(3172),
    [anon_sym_compl] = ACTIONS(3172),
    [anon_sym_DASH_DASH] = ACTIONS(3174),
    [anon_sym_PLUS_PLUS] = ACTIONS(3174),
    [anon_sym_sizeof] = ACTIONS(3172),
    [anon_sym___alignof__] = ACTIONS(3172),
    [anon_sym___alignof] = ACTIONS(3172),
    [anon_sym__alignof] = ACTIONS(3172),
    [anon_sym_alignof] = ACTIONS(3172),
    [anon_sym__Alignof] = ACTIONS(3172),
    [anon_sym_offsetof] = ACTIONS(3172),
    [anon_sym__Generic] = ACTIONS(3172),
    [anon_sym_asm] = ACTIONS(3172),
    [anon_sym___asm__] = ACTIONS(3172),
    [aux_sym_number_literal_token1] = ACTIONS(3174),
    [aux_sym_number_literal_token2] = ACTIONS(3172),
    [anon_sym_L_SQUOTE] = ACTIONS(3174),
    [anon_sym_u_SQUOTE] = ACTIONS(3174),
    [anon_sym_U_SQUOTE] = ACTIONS(3174),
    [anon_sym_u8_SQUOTE] = ACTIONS(3174),
    [anon_sym_SQUOTE] = ACTIONS(3174),
    [anon_sym_L_DQUOTE] = ACTIONS(3174),
    [anon_sym_u_DQUOTE] = ACTIONS(3174),
    [anon_sym_U_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8_DQUOTE] = ACTIONS(3174),
    [anon_sym_DQUOTE] = ACTIONS(3174),
    [sym_true] = ACTIONS(3172),
    [sym_false] = ACTIONS(3172),
    [anon_sym_NULL] = ACTIONS(3172),
    [anon_sym_nullptr] = ACTIONS(3172),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3172),
    [anon_sym_decltype] = ACTIONS(3172),
    [anon_sym_virtual] = ACTIONS(3172),
    [anon_sym_alignas] = ACTIONS(3172),
    [anon_sym_explicit] = ACTIONS(3172),
    [anon_sym_typename] = ACTIONS(3172),
    [anon_sym_template] = ACTIONS(3172),
    [anon_sym_operator] = ACTIONS(3172),
    [anon_sym_try] = ACTIONS(3172),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_throw] = ACTIONS(3172),
    [anon_sym_namespace] = ACTIONS(3172),
    [anon_sym_using] = ACTIONS(3172),
    [anon_sym_static_assert] = ACTIONS(3172),
    [anon_sym_concept] = ACTIONS(3172),
    [anon_sym_co_return] = ACTIONS(3172),
    [anon_sym_co_yield] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3172),
    [anon_sym_new] = ACTIONS(3172),
    [anon_sym_requires] = ACTIONS(3172),
    [sym_this] = ACTIONS(3172),
  },
  [825] = {
    [sym_preproc_def] = STATE(1002),
    [sym_preproc_function_def] = STATE(1002),
    [sym_preproc_call] = STATE(1002),
    [sym_preproc_if_in_field_declaration_list] = STATE(1002),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1002),
    [sym_preproc_else_in_field_declaration_list] = STATE(8830),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8830),
    [sym_type_definition] = STATE(1002),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6507),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7114),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1002),
    [sym_field_declaration] = STATE(1002),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2150),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1002),
    [sym_operator_cast] = STATE(7493),
    [sym_inline_method_definition] = STATE(1002),
    [sym__constructor_specifiers] = STATE(2150),
    [sym_operator_cast_definition] = STATE(1002),
    [sym_operator_cast_declaration] = STATE(1002),
    [sym_constructor_or_destructor_definition] = STATE(1002),
    [sym_constructor_or_destructor_declaration] = STATE(1002),
    [sym_friend_declaration] = STATE(1002),
    [sym_access_specifier] = STATE(9075),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1002),
    [sym_alias_declaration] = STATE(1002),
    [sym_static_assert_declaration] = STATE(1002),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7493),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1002),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2150),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3563),
    [aux_sym_preproc_if_token1] = ACTIONS(3565),
    [aux_sym_preproc_if_token2] = ACTIONS(3593),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3569),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3569),
    [aux_sym_preproc_else_token1] = ACTIONS(3206),
    [aux_sym_preproc_elif_token1] = ACTIONS(3208),
    [sym_preproc_directive] = ACTIONS(3571),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3573),
    [anon_sym_typedef] = ACTIONS(3575),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3577),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3579),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3581),
    [anon_sym_static_assert] = ACTIONS(3583),
  },
  [826] = {
    [ts_builtin_sym_end] = ACTIONS(3160),
    [sym_identifier] = ACTIONS(3158),
    [aux_sym_preproc_include_token1] = ACTIONS(3158),
    [aux_sym_preproc_def_token1] = ACTIONS(3158),
    [aux_sym_preproc_if_token1] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3158),
    [sym_preproc_directive] = ACTIONS(3158),
    [anon_sym_LPAREN2] = ACTIONS(3160),
    [anon_sym_BANG] = ACTIONS(3160),
    [anon_sym_TILDE] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_STAR] = ACTIONS(3160),
    [anon_sym_AMP_AMP] = ACTIONS(3160),
    [anon_sym_AMP] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym___extension__] = ACTIONS(3158),
    [anon_sym_typedef] = ACTIONS(3158),
    [anon_sym_extern] = ACTIONS(3158),
    [anon_sym___attribute__] = ACTIONS(3158),
    [anon_sym_COLON_COLON] = ACTIONS(3160),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3160),
    [anon_sym___declspec] = ACTIONS(3158),
    [anon_sym___based] = ACTIONS(3158),
    [anon_sym___cdecl] = ACTIONS(3158),
    [anon_sym___clrcall] = ACTIONS(3158),
    [anon_sym___stdcall] = ACTIONS(3158),
    [anon_sym___fastcall] = ACTIONS(3158),
    [anon_sym___thiscall] = ACTIONS(3158),
    [anon_sym___vectorcall] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_signed] = ACTIONS(3158),
    [anon_sym_unsigned] = ACTIONS(3158),
    [anon_sym_long] = ACTIONS(3158),
    [anon_sym_short] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_static] = ACTIONS(3158),
    [anon_sym_register] = ACTIONS(3158),
    [anon_sym_inline] = ACTIONS(3158),
    [anon_sym___inline] = ACTIONS(3158),
    [anon_sym___inline__] = ACTIONS(3158),
    [anon_sym___forceinline] = ACTIONS(3158),
    [anon_sym_thread_local] = ACTIONS(3158),
    [anon_sym___thread] = ACTIONS(3158),
    [anon_sym_const] = ACTIONS(3158),
    [anon_sym_constexpr] = ACTIONS(3158),
    [anon_sym_volatile] = ACTIONS(3158),
    [anon_sym_restrict] = ACTIONS(3158),
    [anon_sym___restrict__] = ACTIONS(3158),
    [anon_sym__Atomic] = ACTIONS(3158),
    [anon_sym__Noreturn] = ACTIONS(3158),
    [anon_sym_noreturn] = ACTIONS(3158),
    [anon_sym_mutable] = ACTIONS(3158),
    [anon_sym_constinit] = ACTIONS(3158),
    [anon_sym_consteval] = ACTIONS(3158),
    [anon_sym_PROGMEM] = ACTIONS(3158),
    [aux_sym_primitive_type_token1] = ACTIONS(3158),
    [anon_sym_byte] = ACTIONS(3158),
    [anon_sym_word] = ACTIONS(3158),
    [anon_sym_enum] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(3158),
    [anon_sym_struct] = ACTIONS(3158),
    [anon_sym_union] = ACTIONS(3158),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_else] = ACTIONS(3158),
    [anon_sym_switch] = ACTIONS(3158),
    [anon_sym_case] = ACTIONS(3158),
    [anon_sym_default] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_for] = ACTIONS(3158),
    [anon_sym_return] = ACTIONS(3158),
    [anon_sym_break] = ACTIONS(3158),
    [anon_sym_continue] = ACTIONS(3158),
    [anon_sym_goto] = ACTIONS(3158),
    [anon_sym___try] = ACTIONS(3158),
    [anon_sym___leave] = ACTIONS(3158),
    [anon_sym_not] = ACTIONS(3158),
    [anon_sym_compl] = ACTIONS(3158),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_sizeof] = ACTIONS(3158),
    [anon_sym___alignof__] = ACTIONS(3158),
    [anon_sym___alignof] = ACTIONS(3158),
    [anon_sym__alignof] = ACTIONS(3158),
    [anon_sym_alignof] = ACTIONS(3158),
    [anon_sym__Alignof] = ACTIONS(3158),
    [anon_sym_offsetof] = ACTIONS(3158),
    [anon_sym__Generic] = ACTIONS(3158),
    [anon_sym_asm] = ACTIONS(3158),
    [anon_sym___asm__] = ACTIONS(3158),
    [aux_sym_number_literal_token1] = ACTIONS(3160),
    [aux_sym_number_literal_token2] = ACTIONS(3158),
    [anon_sym_L_SQUOTE] = ACTIONS(3160),
    [anon_sym_u_SQUOTE] = ACTIONS(3160),
    [anon_sym_U_SQUOTE] = ACTIONS(3160),
    [anon_sym_u8_SQUOTE] = ACTIONS(3160),
    [anon_sym_SQUOTE] = ACTIONS(3160),
    [anon_sym_L_DQUOTE] = ACTIONS(3160),
    [anon_sym_u_DQUOTE] = ACTIONS(3160),
    [anon_sym_U_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8_DQUOTE] = ACTIONS(3160),
    [anon_sym_DQUOTE] = ACTIONS(3160),
    [sym_true] = ACTIONS(3158),
    [sym_false] = ACTIONS(3158),
    [anon_sym_NULL] = ACTIONS(3158),
    [anon_sym_nullptr] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3158),
    [anon_sym_decltype] = ACTIONS(3158),
    [anon_sym_virtual] = ACTIONS(3158),
    [anon_sym_alignas] = ACTIONS(3158),
    [anon_sym_explicit] = ACTIONS(3158),
    [anon_sym_typename] = ACTIONS(3158),
    [anon_sym_template] = ACTIONS(3158),
    [anon_sym_operator] = ACTIONS(3158),
    [anon_sym_try] = ACTIONS(3158),
    [anon_sym_delete] = ACTIONS(3158),
    [anon_sym_throw] = ACTIONS(3158),
    [anon_sym_namespace] = ACTIONS(3158),
    [anon_sym_using] = ACTIONS(3158),
    [anon_sym_static_assert] = ACTIONS(3158),
    [anon_sym_concept] = ACTIONS(3158),
    [anon_sym_co_return] = ACTIONS(3158),
    [anon_sym_co_yield] = ACTIONS(3158),
    [anon_sym_R_DQUOTE] = ACTIONS(3160),
    [anon_sym_LR_DQUOTE] = ACTIONS(3160),
    [anon_sym_uR_DQUOTE] = ACTIONS(3160),
    [anon_sym_UR_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3160),
    [anon_sym_co_await] = ACTIONS(3158),
    [anon_sym_new] = ACTIONS(3158),
    [anon_sym_requires] = ACTIONS(3158),
    [sym_this] = ACTIONS(3158),
  },
  [827] = {
    [ts_builtin_sym_end] = ACTIONS(2960),
    [sym_identifier] = ACTIONS(2958),
    [aux_sym_preproc_include_token1] = ACTIONS(2958),
    [aux_sym_preproc_def_token1] = ACTIONS(2958),
    [aux_sym_preproc_if_token1] = ACTIONS(2958),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2958),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2958),
    [sym_preproc_directive] = ACTIONS(2958),
    [anon_sym_LPAREN2] = ACTIONS(2960),
    [anon_sym_BANG] = ACTIONS(2960),
    [anon_sym_TILDE] = ACTIONS(2960),
    [anon_sym_DASH] = ACTIONS(2958),
    [anon_sym_PLUS] = ACTIONS(2958),
    [anon_sym_STAR] = ACTIONS(2960),
    [anon_sym_AMP_AMP] = ACTIONS(2960),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_SEMI] = ACTIONS(2960),
    [anon_sym___extension__] = ACTIONS(2958),
    [anon_sym_typedef] = ACTIONS(2958),
    [anon_sym_extern] = ACTIONS(2958),
    [anon_sym___attribute__] = ACTIONS(2958),
    [anon_sym_COLON_COLON] = ACTIONS(2960),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2960),
    [anon_sym___declspec] = ACTIONS(2958),
    [anon_sym___based] = ACTIONS(2958),
    [anon_sym___cdecl] = ACTIONS(2958),
    [anon_sym___clrcall] = ACTIONS(2958),
    [anon_sym___stdcall] = ACTIONS(2958),
    [anon_sym___fastcall] = ACTIONS(2958),
    [anon_sym___thiscall] = ACTIONS(2958),
    [anon_sym___vectorcall] = ACTIONS(2958),
    [anon_sym_LBRACE] = ACTIONS(2960),
    [anon_sym_signed] = ACTIONS(2958),
    [anon_sym_unsigned] = ACTIONS(2958),
    [anon_sym_long] = ACTIONS(2958),
    [anon_sym_short] = ACTIONS(2958),
    [anon_sym_LBRACK] = ACTIONS(2958),
    [anon_sym_static] = ACTIONS(2958),
    [anon_sym_register] = ACTIONS(2958),
    [anon_sym_inline] = ACTIONS(2958),
    [anon_sym___inline] = ACTIONS(2958),
    [anon_sym___inline__] = ACTIONS(2958),
    [anon_sym___forceinline] = ACTIONS(2958),
    [anon_sym_thread_local] = ACTIONS(2958),
    [anon_sym___thread] = ACTIONS(2958),
    [anon_sym_const] = ACTIONS(2958),
    [anon_sym_constexpr] = ACTIONS(2958),
    [anon_sym_volatile] = ACTIONS(2958),
    [anon_sym_restrict] = ACTIONS(2958),
    [anon_sym___restrict__] = ACTIONS(2958),
    [anon_sym__Atomic] = ACTIONS(2958),
    [anon_sym__Noreturn] = ACTIONS(2958),
    [anon_sym_noreturn] = ACTIONS(2958),
    [anon_sym_mutable] = ACTIONS(2958),
    [anon_sym_constinit] = ACTIONS(2958),
    [anon_sym_consteval] = ACTIONS(2958),
    [anon_sym_PROGMEM] = ACTIONS(2958),
    [aux_sym_primitive_type_token1] = ACTIONS(2958),
    [anon_sym_byte] = ACTIONS(2958),
    [anon_sym_word] = ACTIONS(2958),
    [anon_sym_enum] = ACTIONS(2958),
    [anon_sym_class] = ACTIONS(2958),
    [anon_sym_struct] = ACTIONS(2958),
    [anon_sym_union] = ACTIONS(2958),
    [anon_sym_if] = ACTIONS(2958),
    [anon_sym_else] = ACTIONS(2958),
    [anon_sym_switch] = ACTIONS(2958),
    [anon_sym_case] = ACTIONS(2958),
    [anon_sym_default] = ACTIONS(2958),
    [anon_sym_while] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2958),
    [anon_sym_for] = ACTIONS(2958),
    [anon_sym_return] = ACTIONS(2958),
    [anon_sym_break] = ACTIONS(2958),
    [anon_sym_continue] = ACTIONS(2958),
    [anon_sym_goto] = ACTIONS(2958),
    [anon_sym___try] = ACTIONS(2958),
    [anon_sym___leave] = ACTIONS(2958),
    [anon_sym_not] = ACTIONS(2958),
    [anon_sym_compl] = ACTIONS(2958),
    [anon_sym_DASH_DASH] = ACTIONS(2960),
    [anon_sym_PLUS_PLUS] = ACTIONS(2960),
    [anon_sym_sizeof] = ACTIONS(2958),
    [anon_sym___alignof__] = ACTIONS(2958),
    [anon_sym___alignof] = ACTIONS(2958),
    [anon_sym__alignof] = ACTIONS(2958),
    [anon_sym_alignof] = ACTIONS(2958),
    [anon_sym__Alignof] = ACTIONS(2958),
    [anon_sym_offsetof] = ACTIONS(2958),
    [anon_sym__Generic] = ACTIONS(2958),
    [anon_sym_asm] = ACTIONS(2958),
    [anon_sym___asm__] = ACTIONS(2958),
    [aux_sym_number_literal_token1] = ACTIONS(2960),
    [aux_sym_number_literal_token2] = ACTIONS(2958),
    [anon_sym_L_SQUOTE] = ACTIONS(2960),
    [anon_sym_u_SQUOTE] = ACTIONS(2960),
    [anon_sym_U_SQUOTE] = ACTIONS(2960),
    [anon_sym_u8_SQUOTE] = ACTIONS(2960),
    [anon_sym_SQUOTE] = ACTIONS(2960),
    [anon_sym_L_DQUOTE] = ACTIONS(2960),
    [anon_sym_u_DQUOTE] = ACTIONS(2960),
    [anon_sym_U_DQUOTE] = ACTIONS(2960),
    [anon_sym_u8_DQUOTE] = ACTIONS(2960),
    [anon_sym_DQUOTE] = ACTIONS(2960),
    [sym_true] = ACTIONS(2958),
    [sym_false] = ACTIONS(2958),
    [anon_sym_NULL] = ACTIONS(2958),
    [anon_sym_nullptr] = ACTIONS(2958),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2958),
    [anon_sym_decltype] = ACTIONS(2958),
    [anon_sym_virtual] = ACTIONS(2958),
    [anon_sym_alignas] = ACTIONS(2958),
    [anon_sym_explicit] = ACTIONS(2958),
    [anon_sym_typename] = ACTIONS(2958),
    [anon_sym_template] = ACTIONS(2958),
    [anon_sym_operator] = ACTIONS(2958),
    [anon_sym_try] = ACTIONS(2958),
    [anon_sym_delete] = ACTIONS(2958),
    [anon_sym_throw] = ACTIONS(2958),
    [anon_sym_namespace] = ACTIONS(2958),
    [anon_sym_using] = ACTIONS(2958),
    [anon_sym_static_assert] = ACTIONS(2958),
    [anon_sym_concept] = ACTIONS(2958),
    [anon_sym_co_return] = ACTIONS(2958),
    [anon_sym_co_yield] = ACTIONS(2958),
    [anon_sym_R_DQUOTE] = ACTIONS(2960),
    [anon_sym_LR_DQUOTE] = ACTIONS(2960),
    [anon_sym_uR_DQUOTE] = ACTIONS(2960),
    [anon_sym_UR_DQUOTE] = ACTIONS(2960),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2960),
    [anon_sym_co_await] = ACTIONS(2958),
    [anon_sym_new] = ACTIONS(2958),
    [anon_sym_requires] = ACTIONS(2958),
    [sym_this] = ACTIONS(2958),
  },
  [828] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_include_token1] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym___cdecl] = ACTIONS(3082),
    [anon_sym___clrcall] = ACTIONS(3082),
    [anon_sym___stdcall] = ACTIONS(3082),
    [anon_sym___fastcall] = ACTIONS(3082),
    [anon_sym___thiscall] = ACTIONS(3082),
    [anon_sym___vectorcall] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_RBRACE] = ACTIONS(3084),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_else] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_goto] = ACTIONS(3082),
    [anon_sym___try] = ACTIONS(3082),
    [anon_sym___leave] = ACTIONS(3082),
    [anon_sym_not] = ACTIONS(3082),
    [anon_sym_compl] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_sizeof] = ACTIONS(3082),
    [anon_sym___alignof__] = ACTIONS(3082),
    [anon_sym___alignof] = ACTIONS(3082),
    [anon_sym__alignof] = ACTIONS(3082),
    [anon_sym_alignof] = ACTIONS(3082),
    [anon_sym__Alignof] = ACTIONS(3082),
    [anon_sym_offsetof] = ACTIONS(3082),
    [anon_sym__Generic] = ACTIONS(3082),
    [anon_sym_asm] = ACTIONS(3082),
    [anon_sym___asm__] = ACTIONS(3082),
    [aux_sym_number_literal_token1] = ACTIONS(3084),
    [aux_sym_number_literal_token2] = ACTIONS(3082),
    [anon_sym_L_SQUOTE] = ACTIONS(3084),
    [anon_sym_u_SQUOTE] = ACTIONS(3084),
    [anon_sym_U_SQUOTE] = ACTIONS(3084),
    [anon_sym_u8_SQUOTE] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_L_DQUOTE] = ACTIONS(3084),
    [anon_sym_u_DQUOTE] = ACTIONS(3084),
    [anon_sym_U_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8_DQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [anon_sym_NULL] = ACTIONS(3082),
    [anon_sym_nullptr] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
    [anon_sym_concept] = ACTIONS(3082),
    [anon_sym_co_return] = ACTIONS(3082),
    [anon_sym_co_yield] = ACTIONS(3082),
    [anon_sym_R_DQUOTE] = ACTIONS(3084),
    [anon_sym_LR_DQUOTE] = ACTIONS(3084),
    [anon_sym_uR_DQUOTE] = ACTIONS(3084),
    [anon_sym_UR_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3084),
    [anon_sym_co_await] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_requires] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
  },
  [829] = {
    [sym_preproc_def] = STATE(825),
    [sym_preproc_function_def] = STATE(825),
    [sym_preproc_call] = STATE(825),
    [sym_preproc_if_in_field_declaration_list] = STATE(825),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(825),
    [sym_preproc_else_in_field_declaration_list] = STATE(9008),
    [sym_preproc_elif_in_field_declaration_list] = STATE(9008),
    [sym_type_definition] = STATE(825),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6507),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7114),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(825),
    [sym_field_declaration] = STATE(825),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2150),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(825),
    [sym_operator_cast] = STATE(7493),
    [sym_inline_method_definition] = STATE(825),
    [sym__constructor_specifiers] = STATE(2150),
    [sym_operator_cast_definition] = STATE(825),
    [sym_operator_cast_declaration] = STATE(825),
    [sym_constructor_or_destructor_definition] = STATE(825),
    [sym_constructor_or_destructor_declaration] = STATE(825),
    [sym_friend_declaration] = STATE(825),
    [sym_access_specifier] = STATE(9075),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(825),
    [sym_alias_declaration] = STATE(825),
    [sym_static_assert_declaration] = STATE(825),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7493),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(825),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2150),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3563),
    [aux_sym_preproc_if_token1] = ACTIONS(3565),
    [aux_sym_preproc_if_token2] = ACTIONS(3595),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3569),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3569),
    [aux_sym_preproc_else_token1] = ACTIONS(3206),
    [aux_sym_preproc_elif_token1] = ACTIONS(3208),
    [sym_preproc_directive] = ACTIONS(3571),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3573),
    [anon_sym_typedef] = ACTIONS(3575),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3577),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3579),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3581),
    [anon_sym_static_assert] = ACTIONS(3583),
  },
  [830] = {
    [sym_identifier] = ACTIONS(3124),
    [aux_sym_preproc_include_token1] = ACTIONS(3124),
    [aux_sym_preproc_def_token1] = ACTIONS(3124),
    [aux_sym_preproc_if_token1] = ACTIONS(3124),
    [aux_sym_preproc_if_token2] = ACTIONS(3124),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3124),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3124),
    [sym_preproc_directive] = ACTIONS(3124),
    [anon_sym_LPAREN2] = ACTIONS(3126),
    [anon_sym_BANG] = ACTIONS(3126),
    [anon_sym_TILDE] = ACTIONS(3126),
    [anon_sym_DASH] = ACTIONS(3124),
    [anon_sym_PLUS] = ACTIONS(3124),
    [anon_sym_STAR] = ACTIONS(3126),
    [anon_sym_AMP_AMP] = ACTIONS(3126),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym_SEMI] = ACTIONS(3126),
    [anon_sym___extension__] = ACTIONS(3124),
    [anon_sym_typedef] = ACTIONS(3124),
    [anon_sym_extern] = ACTIONS(3124),
    [anon_sym___attribute__] = ACTIONS(3124),
    [anon_sym_COLON_COLON] = ACTIONS(3126),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3126),
    [anon_sym___declspec] = ACTIONS(3124),
    [anon_sym___based] = ACTIONS(3124),
    [anon_sym___cdecl] = ACTIONS(3124),
    [anon_sym___clrcall] = ACTIONS(3124),
    [anon_sym___stdcall] = ACTIONS(3124),
    [anon_sym___fastcall] = ACTIONS(3124),
    [anon_sym___thiscall] = ACTIONS(3124),
    [anon_sym___vectorcall] = ACTIONS(3124),
    [anon_sym_LBRACE] = ACTIONS(3126),
    [anon_sym_signed] = ACTIONS(3124),
    [anon_sym_unsigned] = ACTIONS(3124),
    [anon_sym_long] = ACTIONS(3124),
    [anon_sym_short] = ACTIONS(3124),
    [anon_sym_LBRACK] = ACTIONS(3124),
    [anon_sym_static] = ACTIONS(3124),
    [anon_sym_register] = ACTIONS(3124),
    [anon_sym_inline] = ACTIONS(3124),
    [anon_sym___inline] = ACTIONS(3124),
    [anon_sym___inline__] = ACTIONS(3124),
    [anon_sym___forceinline] = ACTIONS(3124),
    [anon_sym_thread_local] = ACTIONS(3124),
    [anon_sym___thread] = ACTIONS(3124),
    [anon_sym_const] = ACTIONS(3124),
    [anon_sym_constexpr] = ACTIONS(3124),
    [anon_sym_volatile] = ACTIONS(3124),
    [anon_sym_restrict] = ACTIONS(3124),
    [anon_sym___restrict__] = ACTIONS(3124),
    [anon_sym__Atomic] = ACTIONS(3124),
    [anon_sym__Noreturn] = ACTIONS(3124),
    [anon_sym_noreturn] = ACTIONS(3124),
    [anon_sym_mutable] = ACTIONS(3124),
    [anon_sym_constinit] = ACTIONS(3124),
    [anon_sym_consteval] = ACTIONS(3124),
    [anon_sym_PROGMEM] = ACTIONS(3124),
    [aux_sym_primitive_type_token1] = ACTIONS(3124),
    [anon_sym_byte] = ACTIONS(3124),
    [anon_sym_word] = ACTIONS(3124),
    [anon_sym_enum] = ACTIONS(3124),
    [anon_sym_class] = ACTIONS(3124),
    [anon_sym_struct] = ACTIONS(3124),
    [anon_sym_union] = ACTIONS(3124),
    [anon_sym_if] = ACTIONS(3124),
    [anon_sym_else] = ACTIONS(3124),
    [anon_sym_switch] = ACTIONS(3124),
    [anon_sym_case] = ACTIONS(3124),
    [anon_sym_default] = ACTIONS(3124),
    [anon_sym_while] = ACTIONS(3124),
    [anon_sym_do] = ACTIONS(3124),
    [anon_sym_for] = ACTIONS(3124),
    [anon_sym_return] = ACTIONS(3124),
    [anon_sym_break] = ACTIONS(3124),
    [anon_sym_continue] = ACTIONS(3124),
    [anon_sym_goto] = ACTIONS(3124),
    [anon_sym___try] = ACTIONS(3124),
    [anon_sym___leave] = ACTIONS(3124),
    [anon_sym_not] = ACTIONS(3124),
    [anon_sym_compl] = ACTIONS(3124),
    [anon_sym_DASH_DASH] = ACTIONS(3126),
    [anon_sym_PLUS_PLUS] = ACTIONS(3126),
    [anon_sym_sizeof] = ACTIONS(3124),
    [anon_sym___alignof__] = ACTIONS(3124),
    [anon_sym___alignof] = ACTIONS(3124),
    [anon_sym__alignof] = ACTIONS(3124),
    [anon_sym_alignof] = ACTIONS(3124),
    [anon_sym__Alignof] = ACTIONS(3124),
    [anon_sym_offsetof] = ACTIONS(3124),
    [anon_sym__Generic] = ACTIONS(3124),
    [anon_sym_asm] = ACTIONS(3124),
    [anon_sym___asm__] = ACTIONS(3124),
    [aux_sym_number_literal_token1] = ACTIONS(3126),
    [aux_sym_number_literal_token2] = ACTIONS(3124),
    [anon_sym_L_SQUOTE] = ACTIONS(3126),
    [anon_sym_u_SQUOTE] = ACTIONS(3126),
    [anon_sym_U_SQUOTE] = ACTIONS(3126),
    [anon_sym_u8_SQUOTE] = ACTIONS(3126),
    [anon_sym_SQUOTE] = ACTIONS(3126),
    [anon_sym_L_DQUOTE] = ACTIONS(3126),
    [anon_sym_u_DQUOTE] = ACTIONS(3126),
    [anon_sym_U_DQUOTE] = ACTIONS(3126),
    [anon_sym_u8_DQUOTE] = ACTIONS(3126),
    [anon_sym_DQUOTE] = ACTIONS(3126),
    [sym_true] = ACTIONS(3124),
    [sym_false] = ACTIONS(3124),
    [anon_sym_NULL] = ACTIONS(3124),
    [anon_sym_nullptr] = ACTIONS(3124),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3124),
    [anon_sym_decltype] = ACTIONS(3124),
    [anon_sym_virtual] = ACTIONS(3124),
    [anon_sym_alignas] = ACTIONS(3124),
    [anon_sym_explicit] = ACTIONS(3124),
    [anon_sym_typename] = ACTIONS(3124),
    [anon_sym_template] = ACTIONS(3124),
    [anon_sym_operator] = ACTIONS(3124),
    [anon_sym_try] = ACTIONS(3124),
    [anon_sym_delete] = ACTIONS(3124),
    [anon_sym_throw] = ACTIONS(3124),
    [anon_sym_namespace] = ACTIONS(3124),
    [anon_sym_using] = ACTIONS(3124),
    [anon_sym_static_assert] = ACTIONS(3124),
    [anon_sym_concept] = ACTIONS(3124),
    [anon_sym_co_return] = ACTIONS(3124),
    [anon_sym_co_yield] = ACTIONS(3124),
    [anon_sym_R_DQUOTE] = ACTIONS(3126),
    [anon_sym_LR_DQUOTE] = ACTIONS(3126),
    [anon_sym_uR_DQUOTE] = ACTIONS(3126),
    [anon_sym_UR_DQUOTE] = ACTIONS(3126),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3126),
    [anon_sym_co_await] = ACTIONS(3124),
    [anon_sym_new] = ACTIONS(3124),
    [anon_sym_requires] = ACTIONS(3124),
    [sym_this] = ACTIONS(3124),
  },
  [831] = {
    [sym_preproc_def] = STATE(837),
    [sym_preproc_function_def] = STATE(837),
    [sym_preproc_call] = STATE(837),
    [sym_preproc_if_in_field_declaration_list] = STATE(837),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(837),
    [sym_preproc_else_in_field_declaration_list] = STATE(9299),
    [sym_preproc_elif_in_field_declaration_list] = STATE(9299),
    [sym_type_definition] = STATE(837),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6507),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7114),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(837),
    [sym_field_declaration] = STATE(837),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2150),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(837),
    [sym_operator_cast] = STATE(7493),
    [sym_inline_method_definition] = STATE(837),
    [sym__constructor_specifiers] = STATE(2150),
    [sym_operator_cast_definition] = STATE(837),
    [sym_operator_cast_declaration] = STATE(837),
    [sym_constructor_or_destructor_definition] = STATE(837),
    [sym_constructor_or_destructor_declaration] = STATE(837),
    [sym_friend_declaration] = STATE(837),
    [sym_access_specifier] = STATE(9075),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(837),
    [sym_alias_declaration] = STATE(837),
    [sym_static_assert_declaration] = STATE(837),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7493),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(837),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2150),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3563),
    [aux_sym_preproc_if_token1] = ACTIONS(3565),
    [aux_sym_preproc_if_token2] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3569),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3569),
    [aux_sym_preproc_else_token1] = ACTIONS(3206),
    [aux_sym_preproc_elif_token1] = ACTIONS(3208),
    [sym_preproc_directive] = ACTIONS(3571),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3573),
    [anon_sym_typedef] = ACTIONS(3575),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3577),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3579),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3581),
    [anon_sym_static_assert] = ACTIONS(3583),
  },
  [832] = {
    [sym_identifier] = ACTIONS(3158),
    [aux_sym_preproc_include_token1] = ACTIONS(3158),
    [aux_sym_preproc_def_token1] = ACTIONS(3158),
    [aux_sym_preproc_if_token1] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3158),
    [sym_preproc_directive] = ACTIONS(3158),
    [anon_sym_LPAREN2] = ACTIONS(3160),
    [anon_sym_BANG] = ACTIONS(3160),
    [anon_sym_TILDE] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_STAR] = ACTIONS(3160),
    [anon_sym_AMP_AMP] = ACTIONS(3160),
    [anon_sym_AMP] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym___extension__] = ACTIONS(3158),
    [anon_sym_typedef] = ACTIONS(3158),
    [anon_sym_extern] = ACTIONS(3158),
    [anon_sym___attribute__] = ACTIONS(3158),
    [anon_sym_COLON_COLON] = ACTIONS(3160),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3160),
    [anon_sym___declspec] = ACTIONS(3158),
    [anon_sym___based] = ACTIONS(3158),
    [anon_sym___cdecl] = ACTIONS(3158),
    [anon_sym___clrcall] = ACTIONS(3158),
    [anon_sym___stdcall] = ACTIONS(3158),
    [anon_sym___fastcall] = ACTIONS(3158),
    [anon_sym___thiscall] = ACTIONS(3158),
    [anon_sym___vectorcall] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_RBRACE] = ACTIONS(3160),
    [anon_sym_signed] = ACTIONS(3158),
    [anon_sym_unsigned] = ACTIONS(3158),
    [anon_sym_long] = ACTIONS(3158),
    [anon_sym_short] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_static] = ACTIONS(3158),
    [anon_sym_register] = ACTIONS(3158),
    [anon_sym_inline] = ACTIONS(3158),
    [anon_sym___inline] = ACTIONS(3158),
    [anon_sym___inline__] = ACTIONS(3158),
    [anon_sym___forceinline] = ACTIONS(3158),
    [anon_sym_thread_local] = ACTIONS(3158),
    [anon_sym___thread] = ACTIONS(3158),
    [anon_sym_const] = ACTIONS(3158),
    [anon_sym_constexpr] = ACTIONS(3158),
    [anon_sym_volatile] = ACTIONS(3158),
    [anon_sym_restrict] = ACTIONS(3158),
    [anon_sym___restrict__] = ACTIONS(3158),
    [anon_sym__Atomic] = ACTIONS(3158),
    [anon_sym__Noreturn] = ACTIONS(3158),
    [anon_sym_noreturn] = ACTIONS(3158),
    [anon_sym_mutable] = ACTIONS(3158),
    [anon_sym_constinit] = ACTIONS(3158),
    [anon_sym_consteval] = ACTIONS(3158),
    [anon_sym_PROGMEM] = ACTIONS(3158),
    [aux_sym_primitive_type_token1] = ACTIONS(3158),
    [anon_sym_byte] = ACTIONS(3158),
    [anon_sym_word] = ACTIONS(3158),
    [anon_sym_enum] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(3158),
    [anon_sym_struct] = ACTIONS(3158),
    [anon_sym_union] = ACTIONS(3158),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_else] = ACTIONS(3158),
    [anon_sym_switch] = ACTIONS(3158),
    [anon_sym_case] = ACTIONS(3158),
    [anon_sym_default] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_for] = ACTIONS(3158),
    [anon_sym_return] = ACTIONS(3158),
    [anon_sym_break] = ACTIONS(3158),
    [anon_sym_continue] = ACTIONS(3158),
    [anon_sym_goto] = ACTIONS(3158),
    [anon_sym___try] = ACTIONS(3158),
    [anon_sym___leave] = ACTIONS(3158),
    [anon_sym_not] = ACTIONS(3158),
    [anon_sym_compl] = ACTIONS(3158),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_sizeof] = ACTIONS(3158),
    [anon_sym___alignof__] = ACTIONS(3158),
    [anon_sym___alignof] = ACTIONS(3158),
    [anon_sym__alignof] = ACTIONS(3158),
    [anon_sym_alignof] = ACTIONS(3158),
    [anon_sym__Alignof] = ACTIONS(3158),
    [anon_sym_offsetof] = ACTIONS(3158),
    [anon_sym__Generic] = ACTIONS(3158),
    [anon_sym_asm] = ACTIONS(3158),
    [anon_sym___asm__] = ACTIONS(3158),
    [aux_sym_number_literal_token1] = ACTIONS(3160),
    [aux_sym_number_literal_token2] = ACTIONS(3158),
    [anon_sym_L_SQUOTE] = ACTIONS(3160),
    [anon_sym_u_SQUOTE] = ACTIONS(3160),
    [anon_sym_U_SQUOTE] = ACTIONS(3160),
    [anon_sym_u8_SQUOTE] = ACTIONS(3160),
    [anon_sym_SQUOTE] = ACTIONS(3160),
    [anon_sym_L_DQUOTE] = ACTIONS(3160),
    [anon_sym_u_DQUOTE] = ACTIONS(3160),
    [anon_sym_U_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8_DQUOTE] = ACTIONS(3160),
    [anon_sym_DQUOTE] = ACTIONS(3160),
    [sym_true] = ACTIONS(3158),
    [sym_false] = ACTIONS(3158),
    [anon_sym_NULL] = ACTIONS(3158),
    [anon_sym_nullptr] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3158),
    [anon_sym_decltype] = ACTIONS(3158),
    [anon_sym_virtual] = ACTIONS(3158),
    [anon_sym_alignas] = ACTIONS(3158),
    [anon_sym_explicit] = ACTIONS(3158),
    [anon_sym_typename] = ACTIONS(3158),
    [anon_sym_template] = ACTIONS(3158),
    [anon_sym_operator] = ACTIONS(3158),
    [anon_sym_try] = ACTIONS(3158),
    [anon_sym_delete] = ACTIONS(3158),
    [anon_sym_throw] = ACTIONS(3158),
    [anon_sym_namespace] = ACTIONS(3158),
    [anon_sym_using] = ACTIONS(3158),
    [anon_sym_static_assert] = ACTIONS(3158),
    [anon_sym_concept] = ACTIONS(3158),
    [anon_sym_co_return] = ACTIONS(3158),
    [anon_sym_co_yield] = ACTIONS(3158),
    [anon_sym_R_DQUOTE] = ACTIONS(3160),
    [anon_sym_LR_DQUOTE] = ACTIONS(3160),
    [anon_sym_uR_DQUOTE] = ACTIONS(3160),
    [anon_sym_UR_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3160),
    [anon_sym_co_await] = ACTIONS(3158),
    [anon_sym_new] = ACTIONS(3158),
    [anon_sym_requires] = ACTIONS(3158),
    [sym_this] = ACTIONS(3158),
  },
  [833] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_include_token1] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym___cdecl] = ACTIONS(3082),
    [anon_sym___clrcall] = ACTIONS(3082),
    [anon_sym___stdcall] = ACTIONS(3082),
    [anon_sym___fastcall] = ACTIONS(3082),
    [anon_sym___thiscall] = ACTIONS(3082),
    [anon_sym___vectorcall] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_RBRACE] = ACTIONS(3084),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_else] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_goto] = ACTIONS(3082),
    [anon_sym___try] = ACTIONS(3082),
    [anon_sym___leave] = ACTIONS(3082),
    [anon_sym_not] = ACTIONS(3082),
    [anon_sym_compl] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_sizeof] = ACTIONS(3082),
    [anon_sym___alignof__] = ACTIONS(3082),
    [anon_sym___alignof] = ACTIONS(3082),
    [anon_sym__alignof] = ACTIONS(3082),
    [anon_sym_alignof] = ACTIONS(3082),
    [anon_sym__Alignof] = ACTIONS(3082),
    [anon_sym_offsetof] = ACTIONS(3082),
    [anon_sym__Generic] = ACTIONS(3082),
    [anon_sym_asm] = ACTIONS(3082),
    [anon_sym___asm__] = ACTIONS(3082),
    [aux_sym_number_literal_token1] = ACTIONS(3084),
    [aux_sym_number_literal_token2] = ACTIONS(3082),
    [anon_sym_L_SQUOTE] = ACTIONS(3084),
    [anon_sym_u_SQUOTE] = ACTIONS(3084),
    [anon_sym_U_SQUOTE] = ACTIONS(3084),
    [anon_sym_u8_SQUOTE] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_L_DQUOTE] = ACTIONS(3084),
    [anon_sym_u_DQUOTE] = ACTIONS(3084),
    [anon_sym_U_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8_DQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [anon_sym_NULL] = ACTIONS(3082),
    [anon_sym_nullptr] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
    [anon_sym_concept] = ACTIONS(3082),
    [anon_sym_co_return] = ACTIONS(3082),
    [anon_sym_co_yield] = ACTIONS(3082),
    [anon_sym_R_DQUOTE] = ACTIONS(3084),
    [anon_sym_LR_DQUOTE] = ACTIONS(3084),
    [anon_sym_uR_DQUOTE] = ACTIONS(3084),
    [anon_sym_UR_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3084),
    [anon_sym_co_await] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_requires] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
  },
  [834] = {
    [sym_identifier] = ACTIONS(3086),
    [aux_sym_preproc_include_token1] = ACTIONS(3086),
    [aux_sym_preproc_def_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3086),
    [sym_preproc_directive] = ACTIONS(3086),
    [anon_sym_LPAREN2] = ACTIONS(3088),
    [anon_sym_BANG] = ACTIONS(3088),
    [anon_sym_TILDE] = ACTIONS(3088),
    [anon_sym_DASH] = ACTIONS(3086),
    [anon_sym_PLUS] = ACTIONS(3086),
    [anon_sym_STAR] = ACTIONS(3088),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym_SEMI] = ACTIONS(3088),
    [anon_sym___extension__] = ACTIONS(3086),
    [anon_sym_typedef] = ACTIONS(3086),
    [anon_sym_extern] = ACTIONS(3086),
    [anon_sym___attribute__] = ACTIONS(3086),
    [anon_sym_COLON_COLON] = ACTIONS(3088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3088),
    [anon_sym___declspec] = ACTIONS(3086),
    [anon_sym___based] = ACTIONS(3086),
    [anon_sym___cdecl] = ACTIONS(3086),
    [anon_sym___clrcall] = ACTIONS(3086),
    [anon_sym___stdcall] = ACTIONS(3086),
    [anon_sym___fastcall] = ACTIONS(3086),
    [anon_sym___thiscall] = ACTIONS(3086),
    [anon_sym___vectorcall] = ACTIONS(3086),
    [anon_sym_LBRACE] = ACTIONS(3088),
    [anon_sym_RBRACE] = ACTIONS(3088),
    [anon_sym_signed] = ACTIONS(3086),
    [anon_sym_unsigned] = ACTIONS(3086),
    [anon_sym_long] = ACTIONS(3086),
    [anon_sym_short] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(3086),
    [anon_sym_static] = ACTIONS(3086),
    [anon_sym_register] = ACTIONS(3086),
    [anon_sym_inline] = ACTIONS(3086),
    [anon_sym___inline] = ACTIONS(3086),
    [anon_sym___inline__] = ACTIONS(3086),
    [anon_sym___forceinline] = ACTIONS(3086),
    [anon_sym_thread_local] = ACTIONS(3086),
    [anon_sym___thread] = ACTIONS(3086),
    [anon_sym_const] = ACTIONS(3086),
    [anon_sym_constexpr] = ACTIONS(3086),
    [anon_sym_volatile] = ACTIONS(3086),
    [anon_sym_restrict] = ACTIONS(3086),
    [anon_sym___restrict__] = ACTIONS(3086),
    [anon_sym__Atomic] = ACTIONS(3086),
    [anon_sym__Noreturn] = ACTIONS(3086),
    [anon_sym_noreturn] = ACTIONS(3086),
    [anon_sym_mutable] = ACTIONS(3086),
    [anon_sym_constinit] = ACTIONS(3086),
    [anon_sym_consteval] = ACTIONS(3086),
    [anon_sym_PROGMEM] = ACTIONS(3086),
    [aux_sym_primitive_type_token1] = ACTIONS(3086),
    [anon_sym_byte] = ACTIONS(3086),
    [anon_sym_word] = ACTIONS(3086),
    [anon_sym_enum] = ACTIONS(3086),
    [anon_sym_class] = ACTIONS(3086),
    [anon_sym_struct] = ACTIONS(3086),
    [anon_sym_union] = ACTIONS(3086),
    [anon_sym_if] = ACTIONS(3086),
    [anon_sym_else] = ACTIONS(3086),
    [anon_sym_switch] = ACTIONS(3086),
    [anon_sym_case] = ACTIONS(3086),
    [anon_sym_default] = ACTIONS(3086),
    [anon_sym_while] = ACTIONS(3086),
    [anon_sym_do] = ACTIONS(3086),
    [anon_sym_for] = ACTIONS(3086),
    [anon_sym_return] = ACTIONS(3086),
    [anon_sym_break] = ACTIONS(3086),
    [anon_sym_continue] = ACTIONS(3086),
    [anon_sym_goto] = ACTIONS(3086),
    [anon_sym___try] = ACTIONS(3086),
    [anon_sym___leave] = ACTIONS(3086),
    [anon_sym_not] = ACTIONS(3086),
    [anon_sym_compl] = ACTIONS(3086),
    [anon_sym_DASH_DASH] = ACTIONS(3088),
    [anon_sym_PLUS_PLUS] = ACTIONS(3088),
    [anon_sym_sizeof] = ACTIONS(3086),
    [anon_sym___alignof__] = ACTIONS(3086),
    [anon_sym___alignof] = ACTIONS(3086),
    [anon_sym__alignof] = ACTIONS(3086),
    [anon_sym_alignof] = ACTIONS(3086),
    [anon_sym__Alignof] = ACTIONS(3086),
    [anon_sym_offsetof] = ACTIONS(3086),
    [anon_sym__Generic] = ACTIONS(3086),
    [anon_sym_asm] = ACTIONS(3086),
    [anon_sym___asm__] = ACTIONS(3086),
    [aux_sym_number_literal_token1] = ACTIONS(3088),
    [aux_sym_number_literal_token2] = ACTIONS(3086),
    [anon_sym_L_SQUOTE] = ACTIONS(3088),
    [anon_sym_u_SQUOTE] = ACTIONS(3088),
    [anon_sym_U_SQUOTE] = ACTIONS(3088),
    [anon_sym_u8_SQUOTE] = ACTIONS(3088),
    [anon_sym_SQUOTE] = ACTIONS(3088),
    [anon_sym_L_DQUOTE] = ACTIONS(3088),
    [anon_sym_u_DQUOTE] = ACTIONS(3088),
    [anon_sym_U_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8_DQUOTE] = ACTIONS(3088),
    [anon_sym_DQUOTE] = ACTIONS(3088),
    [sym_true] = ACTIONS(3086),
    [sym_false] = ACTIONS(3086),
    [anon_sym_NULL] = ACTIONS(3086),
    [anon_sym_nullptr] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3086),
    [anon_sym_decltype] = ACTIONS(3086),
    [anon_sym_virtual] = ACTIONS(3086),
    [anon_sym_alignas] = ACTIONS(3086),
    [anon_sym_explicit] = ACTIONS(3086),
    [anon_sym_typename] = ACTIONS(3086),
    [anon_sym_template] = ACTIONS(3086),
    [anon_sym_operator] = ACTIONS(3086),
    [anon_sym_try] = ACTIONS(3086),
    [anon_sym_delete] = ACTIONS(3086),
    [anon_sym_throw] = ACTIONS(3086),
    [anon_sym_namespace] = ACTIONS(3086),
    [anon_sym_using] = ACTIONS(3086),
    [anon_sym_static_assert] = ACTIONS(3086),
    [anon_sym_concept] = ACTIONS(3086),
    [anon_sym_co_return] = ACTIONS(3086),
    [anon_sym_co_yield] = ACTIONS(3086),
    [anon_sym_R_DQUOTE] = ACTIONS(3088),
    [anon_sym_LR_DQUOTE] = ACTIONS(3088),
    [anon_sym_uR_DQUOTE] = ACTIONS(3088),
    [anon_sym_UR_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3088),
    [anon_sym_co_await] = ACTIONS(3086),
    [anon_sym_new] = ACTIONS(3086),
    [anon_sym_requires] = ACTIONS(3086),
    [sym_this] = ACTIONS(3086),
  },
  [835] = {
    [sym_identifier] = ACTIONS(3172),
    [aux_sym_preproc_include_token1] = ACTIONS(3172),
    [aux_sym_preproc_def_token1] = ACTIONS(3172),
    [aux_sym_preproc_if_token1] = ACTIONS(3172),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3172),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3172),
    [sym_preproc_directive] = ACTIONS(3172),
    [anon_sym_LPAREN2] = ACTIONS(3174),
    [anon_sym_BANG] = ACTIONS(3174),
    [anon_sym_TILDE] = ACTIONS(3174),
    [anon_sym_DASH] = ACTIONS(3172),
    [anon_sym_PLUS] = ACTIONS(3172),
    [anon_sym_STAR] = ACTIONS(3174),
    [anon_sym_AMP_AMP] = ACTIONS(3174),
    [anon_sym_AMP] = ACTIONS(3172),
    [anon_sym_SEMI] = ACTIONS(3174),
    [anon_sym___extension__] = ACTIONS(3172),
    [anon_sym_typedef] = ACTIONS(3172),
    [anon_sym_extern] = ACTIONS(3172),
    [anon_sym___attribute__] = ACTIONS(3172),
    [anon_sym_COLON_COLON] = ACTIONS(3174),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3174),
    [anon_sym___declspec] = ACTIONS(3172),
    [anon_sym___based] = ACTIONS(3172),
    [anon_sym___cdecl] = ACTIONS(3172),
    [anon_sym___clrcall] = ACTIONS(3172),
    [anon_sym___stdcall] = ACTIONS(3172),
    [anon_sym___fastcall] = ACTIONS(3172),
    [anon_sym___thiscall] = ACTIONS(3172),
    [anon_sym___vectorcall] = ACTIONS(3172),
    [anon_sym_LBRACE] = ACTIONS(3174),
    [anon_sym_RBRACE] = ACTIONS(3174),
    [anon_sym_signed] = ACTIONS(3172),
    [anon_sym_unsigned] = ACTIONS(3172),
    [anon_sym_long] = ACTIONS(3172),
    [anon_sym_short] = ACTIONS(3172),
    [anon_sym_LBRACK] = ACTIONS(3172),
    [anon_sym_static] = ACTIONS(3172),
    [anon_sym_register] = ACTIONS(3172),
    [anon_sym_inline] = ACTIONS(3172),
    [anon_sym___inline] = ACTIONS(3172),
    [anon_sym___inline__] = ACTIONS(3172),
    [anon_sym___forceinline] = ACTIONS(3172),
    [anon_sym_thread_local] = ACTIONS(3172),
    [anon_sym___thread] = ACTIONS(3172),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_constexpr] = ACTIONS(3172),
    [anon_sym_volatile] = ACTIONS(3172),
    [anon_sym_restrict] = ACTIONS(3172),
    [anon_sym___restrict__] = ACTIONS(3172),
    [anon_sym__Atomic] = ACTIONS(3172),
    [anon_sym__Noreturn] = ACTIONS(3172),
    [anon_sym_noreturn] = ACTIONS(3172),
    [anon_sym_mutable] = ACTIONS(3172),
    [anon_sym_constinit] = ACTIONS(3172),
    [anon_sym_consteval] = ACTIONS(3172),
    [anon_sym_PROGMEM] = ACTIONS(3172),
    [aux_sym_primitive_type_token1] = ACTIONS(3172),
    [anon_sym_byte] = ACTIONS(3172),
    [anon_sym_word] = ACTIONS(3172),
    [anon_sym_enum] = ACTIONS(3172),
    [anon_sym_class] = ACTIONS(3172),
    [anon_sym_struct] = ACTIONS(3172),
    [anon_sym_union] = ACTIONS(3172),
    [anon_sym_if] = ACTIONS(3172),
    [anon_sym_else] = ACTIONS(3172),
    [anon_sym_switch] = ACTIONS(3172),
    [anon_sym_case] = ACTIONS(3172),
    [anon_sym_default] = ACTIONS(3172),
    [anon_sym_while] = ACTIONS(3172),
    [anon_sym_do] = ACTIONS(3172),
    [anon_sym_for] = ACTIONS(3172),
    [anon_sym_return] = ACTIONS(3172),
    [anon_sym_break] = ACTIONS(3172),
    [anon_sym_continue] = ACTIONS(3172),
    [anon_sym_goto] = ACTIONS(3172),
    [anon_sym___try] = ACTIONS(3172),
    [anon_sym___leave] = ACTIONS(3172),
    [anon_sym_not] = ACTIONS(3172),
    [anon_sym_compl] = ACTIONS(3172),
    [anon_sym_DASH_DASH] = ACTIONS(3174),
    [anon_sym_PLUS_PLUS] = ACTIONS(3174),
    [anon_sym_sizeof] = ACTIONS(3172),
    [anon_sym___alignof__] = ACTIONS(3172),
    [anon_sym___alignof] = ACTIONS(3172),
    [anon_sym__alignof] = ACTIONS(3172),
    [anon_sym_alignof] = ACTIONS(3172),
    [anon_sym__Alignof] = ACTIONS(3172),
    [anon_sym_offsetof] = ACTIONS(3172),
    [anon_sym__Generic] = ACTIONS(3172),
    [anon_sym_asm] = ACTIONS(3172),
    [anon_sym___asm__] = ACTIONS(3172),
    [aux_sym_number_literal_token1] = ACTIONS(3174),
    [aux_sym_number_literal_token2] = ACTIONS(3172),
    [anon_sym_L_SQUOTE] = ACTIONS(3174),
    [anon_sym_u_SQUOTE] = ACTIONS(3174),
    [anon_sym_U_SQUOTE] = ACTIONS(3174),
    [anon_sym_u8_SQUOTE] = ACTIONS(3174),
    [anon_sym_SQUOTE] = ACTIONS(3174),
    [anon_sym_L_DQUOTE] = ACTIONS(3174),
    [anon_sym_u_DQUOTE] = ACTIONS(3174),
    [anon_sym_U_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8_DQUOTE] = ACTIONS(3174),
    [anon_sym_DQUOTE] = ACTIONS(3174),
    [sym_true] = ACTIONS(3172),
    [sym_false] = ACTIONS(3172),
    [anon_sym_NULL] = ACTIONS(3172),
    [anon_sym_nullptr] = ACTIONS(3172),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3172),
    [anon_sym_decltype] = ACTIONS(3172),
    [anon_sym_virtual] = ACTIONS(3172),
    [anon_sym_alignas] = ACTIONS(3172),
    [anon_sym_explicit] = ACTIONS(3172),
    [anon_sym_typename] = ACTIONS(3172),
    [anon_sym_template] = ACTIONS(3172),
    [anon_sym_operator] = ACTIONS(3172),
    [anon_sym_try] = ACTIONS(3172),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_throw] = ACTIONS(3172),
    [anon_sym_namespace] = ACTIONS(3172),
    [anon_sym_using] = ACTIONS(3172),
    [anon_sym_static_assert] = ACTIONS(3172),
    [anon_sym_concept] = ACTIONS(3172),
    [anon_sym_co_return] = ACTIONS(3172),
    [anon_sym_co_yield] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3172),
    [anon_sym_new] = ACTIONS(3172),
    [anon_sym_requires] = ACTIONS(3172),
    [sym_this] = ACTIONS(3172),
  },
  [836] = {
    [ts_builtin_sym_end] = ACTIONS(3080),
    [sym_identifier] = ACTIONS(3078),
    [aux_sym_preproc_include_token1] = ACTIONS(3078),
    [aux_sym_preproc_def_token1] = ACTIONS(3078),
    [aux_sym_preproc_if_token1] = ACTIONS(3078),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3078),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3078),
    [sym_preproc_directive] = ACTIONS(3078),
    [anon_sym_LPAREN2] = ACTIONS(3080),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_TILDE] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3078),
    [anon_sym_PLUS] = ACTIONS(3078),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3080),
    [anon_sym_AMP] = ACTIONS(3078),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym___extension__] = ACTIONS(3078),
    [anon_sym_typedef] = ACTIONS(3078),
    [anon_sym_extern] = ACTIONS(3078),
    [anon_sym___attribute__] = ACTIONS(3078),
    [anon_sym_COLON_COLON] = ACTIONS(3080),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3080),
    [anon_sym___declspec] = ACTIONS(3078),
    [anon_sym___based] = ACTIONS(3078),
    [anon_sym___cdecl] = ACTIONS(3078),
    [anon_sym___clrcall] = ACTIONS(3078),
    [anon_sym___stdcall] = ACTIONS(3078),
    [anon_sym___fastcall] = ACTIONS(3078),
    [anon_sym___thiscall] = ACTIONS(3078),
    [anon_sym___vectorcall] = ACTIONS(3078),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_signed] = ACTIONS(3078),
    [anon_sym_unsigned] = ACTIONS(3078),
    [anon_sym_long] = ACTIONS(3078),
    [anon_sym_short] = ACTIONS(3078),
    [anon_sym_LBRACK] = ACTIONS(3078),
    [anon_sym_static] = ACTIONS(3078),
    [anon_sym_register] = ACTIONS(3078),
    [anon_sym_inline] = ACTIONS(3078),
    [anon_sym___inline] = ACTIONS(3078),
    [anon_sym___inline__] = ACTIONS(3078),
    [anon_sym___forceinline] = ACTIONS(3078),
    [anon_sym_thread_local] = ACTIONS(3078),
    [anon_sym___thread] = ACTIONS(3078),
    [anon_sym_const] = ACTIONS(3078),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(3078),
    [anon_sym_restrict] = ACTIONS(3078),
    [anon_sym___restrict__] = ACTIONS(3078),
    [anon_sym__Atomic] = ACTIONS(3078),
    [anon_sym__Noreturn] = ACTIONS(3078),
    [anon_sym_noreturn] = ACTIONS(3078),
    [anon_sym_mutable] = ACTIONS(3078),
    [anon_sym_constinit] = ACTIONS(3078),
    [anon_sym_consteval] = ACTIONS(3078),
    [anon_sym_PROGMEM] = ACTIONS(3078),
    [aux_sym_primitive_type_token1] = ACTIONS(3078),
    [anon_sym_byte] = ACTIONS(3078),
    [anon_sym_word] = ACTIONS(3078),
    [anon_sym_enum] = ACTIONS(3078),
    [anon_sym_class] = ACTIONS(3078),
    [anon_sym_struct] = ACTIONS(3078),
    [anon_sym_union] = ACTIONS(3078),
    [anon_sym_if] = ACTIONS(3078),
    [anon_sym_else] = ACTIONS(3078),
    [anon_sym_switch] = ACTIONS(3078),
    [anon_sym_case] = ACTIONS(3078),
    [anon_sym_default] = ACTIONS(3078),
    [anon_sym_while] = ACTIONS(3078),
    [anon_sym_do] = ACTIONS(3078),
    [anon_sym_for] = ACTIONS(3078),
    [anon_sym_return] = ACTIONS(3078),
    [anon_sym_break] = ACTIONS(3078),
    [anon_sym_continue] = ACTIONS(3078),
    [anon_sym_goto] = ACTIONS(3078),
    [anon_sym___try] = ACTIONS(3078),
    [anon_sym___leave] = ACTIONS(3078),
    [anon_sym_not] = ACTIONS(3078),
    [anon_sym_compl] = ACTIONS(3078),
    [anon_sym_DASH_DASH] = ACTIONS(3080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3080),
    [anon_sym_sizeof] = ACTIONS(3078),
    [anon_sym___alignof__] = ACTIONS(3078),
    [anon_sym___alignof] = ACTIONS(3078),
    [anon_sym__alignof] = ACTIONS(3078),
    [anon_sym_alignof] = ACTIONS(3078),
    [anon_sym__Alignof] = ACTIONS(3078),
    [anon_sym_offsetof] = ACTIONS(3078),
    [anon_sym__Generic] = ACTIONS(3078),
    [anon_sym_asm] = ACTIONS(3078),
    [anon_sym___asm__] = ACTIONS(3078),
    [aux_sym_number_literal_token1] = ACTIONS(3080),
    [aux_sym_number_literal_token2] = ACTIONS(3078),
    [anon_sym_L_SQUOTE] = ACTIONS(3080),
    [anon_sym_u_SQUOTE] = ACTIONS(3080),
    [anon_sym_U_SQUOTE] = ACTIONS(3080),
    [anon_sym_u8_SQUOTE] = ACTIONS(3080),
    [anon_sym_SQUOTE] = ACTIONS(3080),
    [anon_sym_L_DQUOTE] = ACTIONS(3080),
    [anon_sym_u_DQUOTE] = ACTIONS(3080),
    [anon_sym_U_DQUOTE] = ACTIONS(3080),
    [anon_sym_u8_DQUOTE] = ACTIONS(3080),
    [anon_sym_DQUOTE] = ACTIONS(3080),
    [sym_true] = ACTIONS(3078),
    [sym_false] = ACTIONS(3078),
    [anon_sym_NULL] = ACTIONS(3078),
    [anon_sym_nullptr] = ACTIONS(3078),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3078),
    [anon_sym_decltype] = ACTIONS(3078),
    [anon_sym_virtual] = ACTIONS(3078),
    [anon_sym_alignas] = ACTIONS(3078),
    [anon_sym_explicit] = ACTIONS(3078),
    [anon_sym_typename] = ACTIONS(3078),
    [anon_sym_template] = ACTIONS(3078),
    [anon_sym_operator] = ACTIONS(3078),
    [anon_sym_try] = ACTIONS(3078),
    [anon_sym_delete] = ACTIONS(3078),
    [anon_sym_throw] = ACTIONS(3078),
    [anon_sym_namespace] = ACTIONS(3078),
    [anon_sym_using] = ACTIONS(3078),
    [anon_sym_static_assert] = ACTIONS(3078),
    [anon_sym_concept] = ACTIONS(3078),
    [anon_sym_co_return] = ACTIONS(3078),
    [anon_sym_co_yield] = ACTIONS(3078),
    [anon_sym_R_DQUOTE] = ACTIONS(3080),
    [anon_sym_LR_DQUOTE] = ACTIONS(3080),
    [anon_sym_uR_DQUOTE] = ACTIONS(3080),
    [anon_sym_UR_DQUOTE] = ACTIONS(3080),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3080),
    [anon_sym_co_await] = ACTIONS(3078),
    [anon_sym_new] = ACTIONS(3078),
    [anon_sym_requires] = ACTIONS(3078),
    [sym_this] = ACTIONS(3078),
  },
  [837] = {
    [sym_preproc_def] = STATE(1002),
    [sym_preproc_function_def] = STATE(1002),
    [sym_preproc_call] = STATE(1002),
    [sym_preproc_if_in_field_declaration_list] = STATE(1002),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1002),
    [sym_preproc_else_in_field_declaration_list] = STATE(9323),
    [sym_preproc_elif_in_field_declaration_list] = STATE(9323),
    [sym_type_definition] = STATE(1002),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6507),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7114),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1002),
    [sym_field_declaration] = STATE(1002),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2150),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1002),
    [sym_operator_cast] = STATE(7493),
    [sym_inline_method_definition] = STATE(1002),
    [sym__constructor_specifiers] = STATE(2150),
    [sym_operator_cast_definition] = STATE(1002),
    [sym_operator_cast_declaration] = STATE(1002),
    [sym_constructor_or_destructor_definition] = STATE(1002),
    [sym_constructor_or_destructor_declaration] = STATE(1002),
    [sym_friend_declaration] = STATE(1002),
    [sym_access_specifier] = STATE(9075),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1002),
    [sym_alias_declaration] = STATE(1002),
    [sym_static_assert_declaration] = STATE(1002),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7493),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1002),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2150),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3563),
    [aux_sym_preproc_if_token1] = ACTIONS(3565),
    [aux_sym_preproc_if_token2] = ACTIONS(3599),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3569),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3569),
    [aux_sym_preproc_else_token1] = ACTIONS(3206),
    [aux_sym_preproc_elif_token1] = ACTIONS(3208),
    [sym_preproc_directive] = ACTIONS(3571),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3573),
    [anon_sym_typedef] = ACTIONS(3575),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3577),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3579),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3581),
    [anon_sym_static_assert] = ACTIONS(3583),
  },
  [838] = {
    [sym_identifier] = ACTIONS(2958),
    [aux_sym_preproc_include_token1] = ACTIONS(2958),
    [aux_sym_preproc_def_token1] = ACTIONS(2958),
    [aux_sym_preproc_if_token1] = ACTIONS(2958),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2958),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2958),
    [sym_preproc_directive] = ACTIONS(2958),
    [anon_sym_LPAREN2] = ACTIONS(2960),
    [anon_sym_BANG] = ACTIONS(2960),
    [anon_sym_TILDE] = ACTIONS(2960),
    [anon_sym_DASH] = ACTIONS(2958),
    [anon_sym_PLUS] = ACTIONS(2958),
    [anon_sym_STAR] = ACTIONS(2960),
    [anon_sym_AMP_AMP] = ACTIONS(2960),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_SEMI] = ACTIONS(2960),
    [anon_sym___extension__] = ACTIONS(2958),
    [anon_sym_typedef] = ACTIONS(2958),
    [anon_sym_extern] = ACTIONS(2958),
    [anon_sym___attribute__] = ACTIONS(2958),
    [anon_sym_COLON_COLON] = ACTIONS(2960),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2960),
    [anon_sym___declspec] = ACTIONS(2958),
    [anon_sym___based] = ACTIONS(2958),
    [anon_sym___cdecl] = ACTIONS(2958),
    [anon_sym___clrcall] = ACTIONS(2958),
    [anon_sym___stdcall] = ACTIONS(2958),
    [anon_sym___fastcall] = ACTIONS(2958),
    [anon_sym___thiscall] = ACTIONS(2958),
    [anon_sym___vectorcall] = ACTIONS(2958),
    [anon_sym_LBRACE] = ACTIONS(2960),
    [anon_sym_RBRACE] = ACTIONS(2960),
    [anon_sym_signed] = ACTIONS(2958),
    [anon_sym_unsigned] = ACTIONS(2958),
    [anon_sym_long] = ACTIONS(2958),
    [anon_sym_short] = ACTIONS(2958),
    [anon_sym_LBRACK] = ACTIONS(2958),
    [anon_sym_static] = ACTIONS(2958),
    [anon_sym_register] = ACTIONS(2958),
    [anon_sym_inline] = ACTIONS(2958),
    [anon_sym___inline] = ACTIONS(2958),
    [anon_sym___inline__] = ACTIONS(2958),
    [anon_sym___forceinline] = ACTIONS(2958),
    [anon_sym_thread_local] = ACTIONS(2958),
    [anon_sym___thread] = ACTIONS(2958),
    [anon_sym_const] = ACTIONS(2958),
    [anon_sym_constexpr] = ACTIONS(2958),
    [anon_sym_volatile] = ACTIONS(2958),
    [anon_sym_restrict] = ACTIONS(2958),
    [anon_sym___restrict__] = ACTIONS(2958),
    [anon_sym__Atomic] = ACTIONS(2958),
    [anon_sym__Noreturn] = ACTIONS(2958),
    [anon_sym_noreturn] = ACTIONS(2958),
    [anon_sym_mutable] = ACTIONS(2958),
    [anon_sym_constinit] = ACTIONS(2958),
    [anon_sym_consteval] = ACTIONS(2958),
    [anon_sym_PROGMEM] = ACTIONS(2958),
    [aux_sym_primitive_type_token1] = ACTIONS(2958),
    [anon_sym_byte] = ACTIONS(2958),
    [anon_sym_word] = ACTIONS(2958),
    [anon_sym_enum] = ACTIONS(2958),
    [anon_sym_class] = ACTIONS(2958),
    [anon_sym_struct] = ACTIONS(2958),
    [anon_sym_union] = ACTIONS(2958),
    [anon_sym_if] = ACTIONS(2958),
    [anon_sym_else] = ACTIONS(2958),
    [anon_sym_switch] = ACTIONS(2958),
    [anon_sym_case] = ACTIONS(2958),
    [anon_sym_default] = ACTIONS(2958),
    [anon_sym_while] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2958),
    [anon_sym_for] = ACTIONS(2958),
    [anon_sym_return] = ACTIONS(2958),
    [anon_sym_break] = ACTIONS(2958),
    [anon_sym_continue] = ACTIONS(2958),
    [anon_sym_goto] = ACTIONS(2958),
    [anon_sym___try] = ACTIONS(2958),
    [anon_sym___leave] = ACTIONS(2958),
    [anon_sym_not] = ACTIONS(2958),
    [anon_sym_compl] = ACTIONS(2958),
    [anon_sym_DASH_DASH] = ACTIONS(2960),
    [anon_sym_PLUS_PLUS] = ACTIONS(2960),
    [anon_sym_sizeof] = ACTIONS(2958),
    [anon_sym___alignof__] = ACTIONS(2958),
    [anon_sym___alignof] = ACTIONS(2958),
    [anon_sym__alignof] = ACTIONS(2958),
    [anon_sym_alignof] = ACTIONS(2958),
    [anon_sym__Alignof] = ACTIONS(2958),
    [anon_sym_offsetof] = ACTIONS(2958),
    [anon_sym__Generic] = ACTIONS(2958),
    [anon_sym_asm] = ACTIONS(2958),
    [anon_sym___asm__] = ACTIONS(2958),
    [aux_sym_number_literal_token1] = ACTIONS(2960),
    [aux_sym_number_literal_token2] = ACTIONS(2958),
    [anon_sym_L_SQUOTE] = ACTIONS(2960),
    [anon_sym_u_SQUOTE] = ACTIONS(2960),
    [anon_sym_U_SQUOTE] = ACTIONS(2960),
    [anon_sym_u8_SQUOTE] = ACTIONS(2960),
    [anon_sym_SQUOTE] = ACTIONS(2960),
    [anon_sym_L_DQUOTE] = ACTIONS(2960),
    [anon_sym_u_DQUOTE] = ACTIONS(2960),
    [anon_sym_U_DQUOTE] = ACTIONS(2960),
    [anon_sym_u8_DQUOTE] = ACTIONS(2960),
    [anon_sym_DQUOTE] = ACTIONS(2960),
    [sym_true] = ACTIONS(2958),
    [sym_false] = ACTIONS(2958),
    [anon_sym_NULL] = ACTIONS(2958),
    [anon_sym_nullptr] = ACTIONS(2958),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2958),
    [anon_sym_decltype] = ACTIONS(2958),
    [anon_sym_virtual] = ACTIONS(2958),
    [anon_sym_alignas] = ACTIONS(2958),
    [anon_sym_explicit] = ACTIONS(2958),
    [anon_sym_typename] = ACTIONS(2958),
    [anon_sym_template] = ACTIONS(2958),
    [anon_sym_operator] = ACTIONS(2958),
    [anon_sym_try] = ACTIONS(2958),
    [anon_sym_delete] = ACTIONS(2958),
    [anon_sym_throw] = ACTIONS(2958),
    [anon_sym_namespace] = ACTIONS(2958),
    [anon_sym_using] = ACTIONS(2958),
    [anon_sym_static_assert] = ACTIONS(2958),
    [anon_sym_concept] = ACTIONS(2958),
    [anon_sym_co_return] = ACTIONS(2958),
    [anon_sym_co_yield] = ACTIONS(2958),
    [anon_sym_R_DQUOTE] = ACTIONS(2960),
    [anon_sym_LR_DQUOTE] = ACTIONS(2960),
    [anon_sym_uR_DQUOTE] = ACTIONS(2960),
    [anon_sym_UR_DQUOTE] = ACTIONS(2960),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2960),
    [anon_sym_co_await] = ACTIONS(2958),
    [anon_sym_new] = ACTIONS(2958),
    [anon_sym_requires] = ACTIONS(2958),
    [sym_this] = ACTIONS(2958),
  },
  [839] = {
    [sym_identifier] = ACTIONS(3168),
    [aux_sym_preproc_include_token1] = ACTIONS(3168),
    [aux_sym_preproc_def_token1] = ACTIONS(3168),
    [aux_sym_preproc_if_token1] = ACTIONS(3168),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3168),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3168),
    [sym_preproc_directive] = ACTIONS(3168),
    [anon_sym_LPAREN2] = ACTIONS(3170),
    [anon_sym_BANG] = ACTIONS(3170),
    [anon_sym_TILDE] = ACTIONS(3170),
    [anon_sym_DASH] = ACTIONS(3168),
    [anon_sym_PLUS] = ACTIONS(3168),
    [anon_sym_STAR] = ACTIONS(3170),
    [anon_sym_AMP_AMP] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3168),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym___extension__] = ACTIONS(3168),
    [anon_sym_typedef] = ACTIONS(3168),
    [anon_sym_extern] = ACTIONS(3168),
    [anon_sym___attribute__] = ACTIONS(3168),
    [anon_sym_COLON_COLON] = ACTIONS(3170),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3170),
    [anon_sym___declspec] = ACTIONS(3168),
    [anon_sym___based] = ACTIONS(3168),
    [anon_sym___cdecl] = ACTIONS(3168),
    [anon_sym___clrcall] = ACTIONS(3168),
    [anon_sym___stdcall] = ACTIONS(3168),
    [anon_sym___fastcall] = ACTIONS(3168),
    [anon_sym___thiscall] = ACTIONS(3168),
    [anon_sym___vectorcall] = ACTIONS(3168),
    [anon_sym_LBRACE] = ACTIONS(3170),
    [anon_sym_RBRACE] = ACTIONS(3170),
    [anon_sym_signed] = ACTIONS(3168),
    [anon_sym_unsigned] = ACTIONS(3168),
    [anon_sym_long] = ACTIONS(3168),
    [anon_sym_short] = ACTIONS(3168),
    [anon_sym_LBRACK] = ACTIONS(3168),
    [anon_sym_static] = ACTIONS(3168),
    [anon_sym_register] = ACTIONS(3168),
    [anon_sym_inline] = ACTIONS(3168),
    [anon_sym___inline] = ACTIONS(3168),
    [anon_sym___inline__] = ACTIONS(3168),
    [anon_sym___forceinline] = ACTIONS(3168),
    [anon_sym_thread_local] = ACTIONS(3168),
    [anon_sym___thread] = ACTIONS(3168),
    [anon_sym_const] = ACTIONS(3168),
    [anon_sym_constexpr] = ACTIONS(3168),
    [anon_sym_volatile] = ACTIONS(3168),
    [anon_sym_restrict] = ACTIONS(3168),
    [anon_sym___restrict__] = ACTIONS(3168),
    [anon_sym__Atomic] = ACTIONS(3168),
    [anon_sym__Noreturn] = ACTIONS(3168),
    [anon_sym_noreturn] = ACTIONS(3168),
    [anon_sym_mutable] = ACTIONS(3168),
    [anon_sym_constinit] = ACTIONS(3168),
    [anon_sym_consteval] = ACTIONS(3168),
    [anon_sym_PROGMEM] = ACTIONS(3168),
    [aux_sym_primitive_type_token1] = ACTIONS(3168),
    [anon_sym_byte] = ACTIONS(3168),
    [anon_sym_word] = ACTIONS(3168),
    [anon_sym_enum] = ACTIONS(3168),
    [anon_sym_class] = ACTIONS(3168),
    [anon_sym_struct] = ACTIONS(3168),
    [anon_sym_union] = ACTIONS(3168),
    [anon_sym_if] = ACTIONS(3168),
    [anon_sym_else] = ACTIONS(3168),
    [anon_sym_switch] = ACTIONS(3168),
    [anon_sym_case] = ACTIONS(3168),
    [anon_sym_default] = ACTIONS(3168),
    [anon_sym_while] = ACTIONS(3168),
    [anon_sym_do] = ACTIONS(3168),
    [anon_sym_for] = ACTIONS(3168),
    [anon_sym_return] = ACTIONS(3168),
    [anon_sym_break] = ACTIONS(3168),
    [anon_sym_continue] = ACTIONS(3168),
    [anon_sym_goto] = ACTIONS(3168),
    [anon_sym___try] = ACTIONS(3168),
    [anon_sym___leave] = ACTIONS(3168),
    [anon_sym_not] = ACTIONS(3168),
    [anon_sym_compl] = ACTIONS(3168),
    [anon_sym_DASH_DASH] = ACTIONS(3170),
    [anon_sym_PLUS_PLUS] = ACTIONS(3170),
    [anon_sym_sizeof] = ACTIONS(3168),
    [anon_sym___alignof__] = ACTIONS(3168),
    [anon_sym___alignof] = ACTIONS(3168),
    [anon_sym__alignof] = ACTIONS(3168),
    [anon_sym_alignof] = ACTIONS(3168),
    [anon_sym__Alignof] = ACTIONS(3168),
    [anon_sym_offsetof] = ACTIONS(3168),
    [anon_sym__Generic] = ACTIONS(3168),
    [anon_sym_asm] = ACTIONS(3168),
    [anon_sym___asm__] = ACTIONS(3168),
    [aux_sym_number_literal_token1] = ACTIONS(3170),
    [aux_sym_number_literal_token2] = ACTIONS(3168),
    [anon_sym_L_SQUOTE] = ACTIONS(3170),
    [anon_sym_u_SQUOTE] = ACTIONS(3170),
    [anon_sym_U_SQUOTE] = ACTIONS(3170),
    [anon_sym_u8_SQUOTE] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3170),
    [anon_sym_L_DQUOTE] = ACTIONS(3170),
    [anon_sym_u_DQUOTE] = ACTIONS(3170),
    [anon_sym_U_DQUOTE] = ACTIONS(3170),
    [anon_sym_u8_DQUOTE] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3170),
    [sym_true] = ACTIONS(3168),
    [sym_false] = ACTIONS(3168),
    [anon_sym_NULL] = ACTIONS(3168),
    [anon_sym_nullptr] = ACTIONS(3168),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3168),
    [anon_sym_decltype] = ACTIONS(3168),
    [anon_sym_virtual] = ACTIONS(3168),
    [anon_sym_alignas] = ACTIONS(3168),
    [anon_sym_explicit] = ACTIONS(3168),
    [anon_sym_typename] = ACTIONS(3168),
    [anon_sym_template] = ACTIONS(3168),
    [anon_sym_operator] = ACTIONS(3168),
    [anon_sym_try] = ACTIONS(3168),
    [anon_sym_delete] = ACTIONS(3168),
    [anon_sym_throw] = ACTIONS(3168),
    [anon_sym_namespace] = ACTIONS(3168),
    [anon_sym_using] = ACTIONS(3168),
    [anon_sym_static_assert] = ACTIONS(3168),
    [anon_sym_concept] = ACTIONS(3168),
    [anon_sym_co_return] = ACTIONS(3168),
    [anon_sym_co_yield] = ACTIONS(3168),
    [anon_sym_R_DQUOTE] = ACTIONS(3170),
    [anon_sym_LR_DQUOTE] = ACTIONS(3170),
    [anon_sym_uR_DQUOTE] = ACTIONS(3170),
    [anon_sym_UR_DQUOTE] = ACTIONS(3170),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3170),
    [anon_sym_co_await] = ACTIONS(3168),
    [anon_sym_new] = ACTIONS(3168),
    [anon_sym_requires] = ACTIONS(3168),
    [sym_this] = ACTIONS(3168),
  },
  [840] = {
    [sym_identifier] = ACTIONS(3102),
    [aux_sym_preproc_include_token1] = ACTIONS(3102),
    [aux_sym_preproc_def_token1] = ACTIONS(3102),
    [aux_sym_preproc_if_token1] = ACTIONS(3102),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3102),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3102),
    [sym_preproc_directive] = ACTIONS(3102),
    [anon_sym_LPAREN2] = ACTIONS(3104),
    [anon_sym_BANG] = ACTIONS(3104),
    [anon_sym_TILDE] = ACTIONS(3104),
    [anon_sym_DASH] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(3104),
    [anon_sym_AMP_AMP] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3102),
    [anon_sym_SEMI] = ACTIONS(3104),
    [anon_sym___extension__] = ACTIONS(3102),
    [anon_sym_typedef] = ACTIONS(3102),
    [anon_sym_extern] = ACTIONS(3102),
    [anon_sym___attribute__] = ACTIONS(3102),
    [anon_sym_COLON_COLON] = ACTIONS(3104),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3104),
    [anon_sym___declspec] = ACTIONS(3102),
    [anon_sym___based] = ACTIONS(3102),
    [anon_sym___cdecl] = ACTIONS(3102),
    [anon_sym___clrcall] = ACTIONS(3102),
    [anon_sym___stdcall] = ACTIONS(3102),
    [anon_sym___fastcall] = ACTIONS(3102),
    [anon_sym___thiscall] = ACTIONS(3102),
    [anon_sym___vectorcall] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3104),
    [anon_sym_RBRACE] = ACTIONS(3104),
    [anon_sym_signed] = ACTIONS(3102),
    [anon_sym_unsigned] = ACTIONS(3102),
    [anon_sym_long] = ACTIONS(3102),
    [anon_sym_short] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_static] = ACTIONS(3102),
    [anon_sym_register] = ACTIONS(3102),
    [anon_sym_inline] = ACTIONS(3102),
    [anon_sym___inline] = ACTIONS(3102),
    [anon_sym___inline__] = ACTIONS(3102),
    [anon_sym___forceinline] = ACTIONS(3102),
    [anon_sym_thread_local] = ACTIONS(3102),
    [anon_sym___thread] = ACTIONS(3102),
    [anon_sym_const] = ACTIONS(3102),
    [anon_sym_constexpr] = ACTIONS(3102),
    [anon_sym_volatile] = ACTIONS(3102),
    [anon_sym_restrict] = ACTIONS(3102),
    [anon_sym___restrict__] = ACTIONS(3102),
    [anon_sym__Atomic] = ACTIONS(3102),
    [anon_sym__Noreturn] = ACTIONS(3102),
    [anon_sym_noreturn] = ACTIONS(3102),
    [anon_sym_mutable] = ACTIONS(3102),
    [anon_sym_constinit] = ACTIONS(3102),
    [anon_sym_consteval] = ACTIONS(3102),
    [anon_sym_PROGMEM] = ACTIONS(3102),
    [aux_sym_primitive_type_token1] = ACTIONS(3102),
    [anon_sym_byte] = ACTIONS(3102),
    [anon_sym_word] = ACTIONS(3102),
    [anon_sym_enum] = ACTIONS(3102),
    [anon_sym_class] = ACTIONS(3102),
    [anon_sym_struct] = ACTIONS(3102),
    [anon_sym_union] = ACTIONS(3102),
    [anon_sym_if] = ACTIONS(3102),
    [anon_sym_else] = ACTIONS(3102),
    [anon_sym_switch] = ACTIONS(3102),
    [anon_sym_case] = ACTIONS(3102),
    [anon_sym_default] = ACTIONS(3102),
    [anon_sym_while] = ACTIONS(3102),
    [anon_sym_do] = ACTIONS(3102),
    [anon_sym_for] = ACTIONS(3102),
    [anon_sym_return] = ACTIONS(3102),
    [anon_sym_break] = ACTIONS(3102),
    [anon_sym_continue] = ACTIONS(3102),
    [anon_sym_goto] = ACTIONS(3102),
    [anon_sym___try] = ACTIONS(3102),
    [anon_sym___leave] = ACTIONS(3102),
    [anon_sym_not] = ACTIONS(3102),
    [anon_sym_compl] = ACTIONS(3102),
    [anon_sym_DASH_DASH] = ACTIONS(3104),
    [anon_sym_PLUS_PLUS] = ACTIONS(3104),
    [anon_sym_sizeof] = ACTIONS(3102),
    [anon_sym___alignof__] = ACTIONS(3102),
    [anon_sym___alignof] = ACTIONS(3102),
    [anon_sym__alignof] = ACTIONS(3102),
    [anon_sym_alignof] = ACTIONS(3102),
    [anon_sym__Alignof] = ACTIONS(3102),
    [anon_sym_offsetof] = ACTIONS(3102),
    [anon_sym__Generic] = ACTIONS(3102),
    [anon_sym_asm] = ACTIONS(3102),
    [anon_sym___asm__] = ACTIONS(3102),
    [aux_sym_number_literal_token1] = ACTIONS(3104),
    [aux_sym_number_literal_token2] = ACTIONS(3102),
    [anon_sym_L_SQUOTE] = ACTIONS(3104),
    [anon_sym_u_SQUOTE] = ACTIONS(3104),
    [anon_sym_U_SQUOTE] = ACTIONS(3104),
    [anon_sym_u8_SQUOTE] = ACTIONS(3104),
    [anon_sym_SQUOTE] = ACTIONS(3104),
    [anon_sym_L_DQUOTE] = ACTIONS(3104),
    [anon_sym_u_DQUOTE] = ACTIONS(3104),
    [anon_sym_U_DQUOTE] = ACTIONS(3104),
    [anon_sym_u8_DQUOTE] = ACTIONS(3104),
    [anon_sym_DQUOTE] = ACTIONS(3104),
    [sym_true] = ACTIONS(3102),
    [sym_false] = ACTIONS(3102),
    [anon_sym_NULL] = ACTIONS(3102),
    [anon_sym_nullptr] = ACTIONS(3102),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3102),
    [anon_sym_decltype] = ACTIONS(3102),
    [anon_sym_virtual] = ACTIONS(3102),
    [anon_sym_alignas] = ACTIONS(3102),
    [anon_sym_explicit] = ACTIONS(3102),
    [anon_sym_typename] = ACTIONS(3102),
    [anon_sym_template] = ACTIONS(3102),
    [anon_sym_operator] = ACTIONS(3102),
    [anon_sym_try] = ACTIONS(3102),
    [anon_sym_delete] = ACTIONS(3102),
    [anon_sym_throw] = ACTIONS(3102),
    [anon_sym_namespace] = ACTIONS(3102),
    [anon_sym_using] = ACTIONS(3102),
    [anon_sym_static_assert] = ACTIONS(3102),
    [anon_sym_concept] = ACTIONS(3102),
    [anon_sym_co_return] = ACTIONS(3102),
    [anon_sym_co_yield] = ACTIONS(3102),
    [anon_sym_R_DQUOTE] = ACTIONS(3104),
    [anon_sym_LR_DQUOTE] = ACTIONS(3104),
    [anon_sym_uR_DQUOTE] = ACTIONS(3104),
    [anon_sym_UR_DQUOTE] = ACTIONS(3104),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3104),
    [anon_sym_co_await] = ACTIONS(3102),
    [anon_sym_new] = ACTIONS(3102),
    [anon_sym_requires] = ACTIONS(3102),
    [sym_this] = ACTIONS(3102),
  },
  [841] = {
    [sym_identifier] = ACTIONS(2869),
    [aux_sym_preproc_include_token1] = ACTIONS(2869),
    [aux_sym_preproc_def_token1] = ACTIONS(2869),
    [aux_sym_preproc_if_token1] = ACTIONS(2869),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2869),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2869),
    [sym_preproc_directive] = ACTIONS(2869),
    [anon_sym_LPAREN2] = ACTIONS(2874),
    [anon_sym_BANG] = ACTIONS(2874),
    [anon_sym_TILDE] = ACTIONS(2874),
    [anon_sym_DASH] = ACTIONS(2869),
    [anon_sym_PLUS] = ACTIONS(2869),
    [anon_sym_STAR] = ACTIONS(2874),
    [anon_sym_AMP_AMP] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2869),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym___extension__] = ACTIONS(2869),
    [anon_sym_typedef] = ACTIONS(2869),
    [anon_sym_extern] = ACTIONS(2869),
    [anon_sym___attribute__] = ACTIONS(2869),
    [anon_sym_COLON_COLON] = ACTIONS(2874),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2874),
    [anon_sym___declspec] = ACTIONS(2869),
    [anon_sym___based] = ACTIONS(2869),
    [anon_sym___cdecl] = ACTIONS(2869),
    [anon_sym___clrcall] = ACTIONS(2869),
    [anon_sym___stdcall] = ACTIONS(2869),
    [anon_sym___fastcall] = ACTIONS(2869),
    [anon_sym___thiscall] = ACTIONS(2869),
    [anon_sym___vectorcall] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2874),
    [anon_sym_RBRACE] = ACTIONS(2874),
    [anon_sym_signed] = ACTIONS(2869),
    [anon_sym_unsigned] = ACTIONS(2869),
    [anon_sym_long] = ACTIONS(2869),
    [anon_sym_short] = ACTIONS(2869),
    [anon_sym_LBRACK] = ACTIONS(2869),
    [anon_sym_static] = ACTIONS(2869),
    [anon_sym_register] = ACTIONS(2869),
    [anon_sym_inline] = ACTIONS(2869),
    [anon_sym___inline] = ACTIONS(2869),
    [anon_sym___inline__] = ACTIONS(2869),
    [anon_sym___forceinline] = ACTIONS(2869),
    [anon_sym_thread_local] = ACTIONS(2869),
    [anon_sym___thread] = ACTIONS(2869),
    [anon_sym_const] = ACTIONS(2869),
    [anon_sym_constexpr] = ACTIONS(2869),
    [anon_sym_volatile] = ACTIONS(2869),
    [anon_sym_restrict] = ACTIONS(2869),
    [anon_sym___restrict__] = ACTIONS(2869),
    [anon_sym__Atomic] = ACTIONS(2869),
    [anon_sym__Noreturn] = ACTIONS(2869),
    [anon_sym_noreturn] = ACTIONS(2869),
    [anon_sym_mutable] = ACTIONS(2869),
    [anon_sym_constinit] = ACTIONS(2869),
    [anon_sym_consteval] = ACTIONS(2869),
    [anon_sym_PROGMEM] = ACTIONS(2869),
    [aux_sym_primitive_type_token1] = ACTIONS(2869),
    [anon_sym_byte] = ACTIONS(2869),
    [anon_sym_word] = ACTIONS(2869),
    [anon_sym_enum] = ACTIONS(2869),
    [anon_sym_class] = ACTIONS(2869),
    [anon_sym_struct] = ACTIONS(2869),
    [anon_sym_union] = ACTIONS(2869),
    [anon_sym_if] = ACTIONS(2869),
    [anon_sym_else] = ACTIONS(2869),
    [anon_sym_switch] = ACTIONS(2869),
    [anon_sym_case] = ACTIONS(2869),
    [anon_sym_default] = ACTIONS(2869),
    [anon_sym_while] = ACTIONS(2869),
    [anon_sym_do] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2869),
    [anon_sym_return] = ACTIONS(2869),
    [anon_sym_break] = ACTIONS(2869),
    [anon_sym_continue] = ACTIONS(2869),
    [anon_sym_goto] = ACTIONS(2869),
    [anon_sym___try] = ACTIONS(2869),
    [anon_sym___leave] = ACTIONS(2869),
    [anon_sym_not] = ACTIONS(2869),
    [anon_sym_compl] = ACTIONS(2869),
    [anon_sym_DASH_DASH] = ACTIONS(2874),
    [anon_sym_PLUS_PLUS] = ACTIONS(2874),
    [anon_sym_sizeof] = ACTIONS(2869),
    [anon_sym___alignof__] = ACTIONS(2869),
    [anon_sym___alignof] = ACTIONS(2869),
    [anon_sym__alignof] = ACTIONS(2869),
    [anon_sym_alignof] = ACTIONS(2869),
    [anon_sym__Alignof] = ACTIONS(2869),
    [anon_sym_offsetof] = ACTIONS(2869),
    [anon_sym__Generic] = ACTIONS(2869),
    [anon_sym_asm] = ACTIONS(2869),
    [anon_sym___asm__] = ACTIONS(2869),
    [aux_sym_number_literal_token1] = ACTIONS(2874),
    [aux_sym_number_literal_token2] = ACTIONS(2869),
    [anon_sym_L_SQUOTE] = ACTIONS(2874),
    [anon_sym_u_SQUOTE] = ACTIONS(2874),
    [anon_sym_U_SQUOTE] = ACTIONS(2874),
    [anon_sym_u8_SQUOTE] = ACTIONS(2874),
    [anon_sym_SQUOTE] = ACTIONS(2874),
    [anon_sym_L_DQUOTE] = ACTIONS(2874),
    [anon_sym_u_DQUOTE] = ACTIONS(2874),
    [anon_sym_U_DQUOTE] = ACTIONS(2874),
    [anon_sym_u8_DQUOTE] = ACTIONS(2874),
    [anon_sym_DQUOTE] = ACTIONS(2874),
    [sym_true] = ACTIONS(2869),
    [sym_false] = ACTIONS(2869),
    [anon_sym_NULL] = ACTIONS(2869),
    [anon_sym_nullptr] = ACTIONS(2869),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2869),
    [anon_sym_decltype] = ACTIONS(2869),
    [anon_sym_virtual] = ACTIONS(2869),
    [anon_sym_alignas] = ACTIONS(2869),
    [anon_sym_explicit] = ACTIONS(2869),
    [anon_sym_typename] = ACTIONS(2869),
    [anon_sym_template] = ACTIONS(2869),
    [anon_sym_operator] = ACTIONS(2869),
    [anon_sym_try] = ACTIONS(2869),
    [anon_sym_delete] = ACTIONS(2869),
    [anon_sym_throw] = ACTIONS(2869),
    [anon_sym_namespace] = ACTIONS(2869),
    [anon_sym_using] = ACTIONS(2869),
    [anon_sym_static_assert] = ACTIONS(2869),
    [anon_sym_concept] = ACTIONS(2869),
    [anon_sym_co_return] = ACTIONS(2869),
    [anon_sym_co_yield] = ACTIONS(2869),
    [anon_sym_R_DQUOTE] = ACTIONS(2874),
    [anon_sym_LR_DQUOTE] = ACTIONS(2874),
    [anon_sym_uR_DQUOTE] = ACTIONS(2874),
    [anon_sym_UR_DQUOTE] = ACTIONS(2874),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2874),
    [anon_sym_co_await] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2869),
    [sym_this] = ACTIONS(2869),
  },
  [842] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [843] = {
    [sym_preproc_def] = STATE(1002),
    [sym_preproc_function_def] = STATE(1002),
    [sym_preproc_call] = STATE(1002),
    [sym_preproc_if_in_field_declaration_list] = STATE(1002),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1002),
    [sym_preproc_else_in_field_declaration_list] = STATE(9637),
    [sym_preproc_elif_in_field_declaration_list] = STATE(9637),
    [sym_type_definition] = STATE(1002),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6507),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7114),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1002),
    [sym_field_declaration] = STATE(1002),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2150),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1002),
    [sym_operator_cast] = STATE(7493),
    [sym_inline_method_definition] = STATE(1002),
    [sym__constructor_specifiers] = STATE(2150),
    [sym_operator_cast_definition] = STATE(1002),
    [sym_operator_cast_declaration] = STATE(1002),
    [sym_constructor_or_destructor_definition] = STATE(1002),
    [sym_constructor_or_destructor_declaration] = STATE(1002),
    [sym_friend_declaration] = STATE(1002),
    [sym_access_specifier] = STATE(9075),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1002),
    [sym_alias_declaration] = STATE(1002),
    [sym_static_assert_declaration] = STATE(1002),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7493),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1002),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2150),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3563),
    [aux_sym_preproc_if_token1] = ACTIONS(3565),
    [aux_sym_preproc_if_token2] = ACTIONS(3601),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3569),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3569),
    [aux_sym_preproc_else_token1] = ACTIONS(3206),
    [aux_sym_preproc_elif_token1] = ACTIONS(3208),
    [sym_preproc_directive] = ACTIONS(3571),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3573),
    [anon_sym_typedef] = ACTIONS(3575),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3577),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3579),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3581),
    [anon_sym_static_assert] = ACTIONS(3583),
  },
  [844] = {
    [sym_identifier] = ACTIONS(3046),
    [aux_sym_preproc_include_token1] = ACTIONS(3046),
    [aux_sym_preproc_def_token1] = ACTIONS(3046),
    [aux_sym_preproc_if_token1] = ACTIONS(3046),
    [aux_sym_preproc_if_token2] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3046),
    [sym_preproc_directive] = ACTIONS(3046),
    [anon_sym_LPAREN2] = ACTIONS(3048),
    [anon_sym_BANG] = ACTIONS(3048),
    [anon_sym_TILDE] = ACTIONS(3048),
    [anon_sym_DASH] = ACTIONS(3046),
    [anon_sym_PLUS] = ACTIONS(3046),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_AMP_AMP] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3046),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym___extension__] = ACTIONS(3046),
    [anon_sym_typedef] = ACTIONS(3046),
    [anon_sym_extern] = ACTIONS(3046),
    [anon_sym___attribute__] = ACTIONS(3046),
    [anon_sym_COLON_COLON] = ACTIONS(3048),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3048),
    [anon_sym___declspec] = ACTIONS(3046),
    [anon_sym___based] = ACTIONS(3046),
    [anon_sym___cdecl] = ACTIONS(3046),
    [anon_sym___clrcall] = ACTIONS(3046),
    [anon_sym___stdcall] = ACTIONS(3046),
    [anon_sym___fastcall] = ACTIONS(3046),
    [anon_sym___thiscall] = ACTIONS(3046),
    [anon_sym___vectorcall] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3048),
    [anon_sym_signed] = ACTIONS(3046),
    [anon_sym_unsigned] = ACTIONS(3046),
    [anon_sym_long] = ACTIONS(3046),
    [anon_sym_short] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_static] = ACTIONS(3046),
    [anon_sym_register] = ACTIONS(3046),
    [anon_sym_inline] = ACTIONS(3046),
    [anon_sym___inline] = ACTIONS(3046),
    [anon_sym___inline__] = ACTIONS(3046),
    [anon_sym___forceinline] = ACTIONS(3046),
    [anon_sym_thread_local] = ACTIONS(3046),
    [anon_sym___thread] = ACTIONS(3046),
    [anon_sym_const] = ACTIONS(3046),
    [anon_sym_constexpr] = ACTIONS(3046),
    [anon_sym_volatile] = ACTIONS(3046),
    [anon_sym_restrict] = ACTIONS(3046),
    [anon_sym___restrict__] = ACTIONS(3046),
    [anon_sym__Atomic] = ACTIONS(3046),
    [anon_sym__Noreturn] = ACTIONS(3046),
    [anon_sym_noreturn] = ACTIONS(3046),
    [anon_sym_mutable] = ACTIONS(3046),
    [anon_sym_constinit] = ACTIONS(3046),
    [anon_sym_consteval] = ACTIONS(3046),
    [anon_sym_PROGMEM] = ACTIONS(3046),
    [aux_sym_primitive_type_token1] = ACTIONS(3046),
    [anon_sym_byte] = ACTIONS(3046),
    [anon_sym_word] = ACTIONS(3046),
    [anon_sym_enum] = ACTIONS(3046),
    [anon_sym_class] = ACTIONS(3046),
    [anon_sym_struct] = ACTIONS(3046),
    [anon_sym_union] = ACTIONS(3046),
    [anon_sym_if] = ACTIONS(3046),
    [anon_sym_else] = ACTIONS(3046),
    [anon_sym_switch] = ACTIONS(3046),
    [anon_sym_case] = ACTIONS(3046),
    [anon_sym_default] = ACTIONS(3046),
    [anon_sym_while] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_for] = ACTIONS(3046),
    [anon_sym_return] = ACTIONS(3046),
    [anon_sym_break] = ACTIONS(3046),
    [anon_sym_continue] = ACTIONS(3046),
    [anon_sym_goto] = ACTIONS(3046),
    [anon_sym___try] = ACTIONS(3046),
    [anon_sym___leave] = ACTIONS(3046),
    [anon_sym_not] = ACTIONS(3046),
    [anon_sym_compl] = ACTIONS(3046),
    [anon_sym_DASH_DASH] = ACTIONS(3048),
    [anon_sym_PLUS_PLUS] = ACTIONS(3048),
    [anon_sym_sizeof] = ACTIONS(3046),
    [anon_sym___alignof__] = ACTIONS(3046),
    [anon_sym___alignof] = ACTIONS(3046),
    [anon_sym__alignof] = ACTIONS(3046),
    [anon_sym_alignof] = ACTIONS(3046),
    [anon_sym__Alignof] = ACTIONS(3046),
    [anon_sym_offsetof] = ACTIONS(3046),
    [anon_sym__Generic] = ACTIONS(3046),
    [anon_sym_asm] = ACTIONS(3046),
    [anon_sym___asm__] = ACTIONS(3046),
    [aux_sym_number_literal_token1] = ACTIONS(3048),
    [aux_sym_number_literal_token2] = ACTIONS(3046),
    [anon_sym_L_SQUOTE] = ACTIONS(3048),
    [anon_sym_u_SQUOTE] = ACTIONS(3048),
    [anon_sym_U_SQUOTE] = ACTIONS(3048),
    [anon_sym_u8_SQUOTE] = ACTIONS(3048),
    [anon_sym_SQUOTE] = ACTIONS(3048),
    [anon_sym_L_DQUOTE] = ACTIONS(3048),
    [anon_sym_u_DQUOTE] = ACTIONS(3048),
    [anon_sym_U_DQUOTE] = ACTIONS(3048),
    [anon_sym_u8_DQUOTE] = ACTIONS(3048),
    [anon_sym_DQUOTE] = ACTIONS(3048),
    [sym_true] = ACTIONS(3046),
    [sym_false] = ACTIONS(3046),
    [anon_sym_NULL] = ACTIONS(3046),
    [anon_sym_nullptr] = ACTIONS(3046),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3046),
    [anon_sym_decltype] = ACTIONS(3046),
    [anon_sym_virtual] = ACTIONS(3046),
    [anon_sym_alignas] = ACTIONS(3046),
    [anon_sym_explicit] = ACTIONS(3046),
    [anon_sym_typename] = ACTIONS(3046),
    [anon_sym_template] = ACTIONS(3046),
    [anon_sym_operator] = ACTIONS(3046),
    [anon_sym_try] = ACTIONS(3046),
    [anon_sym_delete] = ACTIONS(3046),
    [anon_sym_throw] = ACTIONS(3046),
    [anon_sym_namespace] = ACTIONS(3046),
    [anon_sym_using] = ACTIONS(3046),
    [anon_sym_static_assert] = ACTIONS(3046),
    [anon_sym_concept] = ACTIONS(3046),
    [anon_sym_co_return] = ACTIONS(3046),
    [anon_sym_co_yield] = ACTIONS(3046),
    [anon_sym_R_DQUOTE] = ACTIONS(3048),
    [anon_sym_LR_DQUOTE] = ACTIONS(3048),
    [anon_sym_uR_DQUOTE] = ACTIONS(3048),
    [anon_sym_UR_DQUOTE] = ACTIONS(3048),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3048),
    [anon_sym_co_await] = ACTIONS(3046),
    [anon_sym_new] = ACTIONS(3046),
    [anon_sym_requires] = ACTIONS(3046),
    [sym_this] = ACTIONS(3046),
  },
  [845] = {
    [sym_identifier] = ACTIONS(3050),
    [aux_sym_preproc_include_token1] = ACTIONS(3050),
    [aux_sym_preproc_def_token1] = ACTIONS(3050),
    [aux_sym_preproc_if_token1] = ACTIONS(3050),
    [aux_sym_preproc_if_token2] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3050),
    [sym_preproc_directive] = ACTIONS(3050),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3050),
    [anon_sym_PLUS] = ACTIONS(3050),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3050),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3050),
    [anon_sym_typedef] = ACTIONS(3050),
    [anon_sym_extern] = ACTIONS(3050),
    [anon_sym___attribute__] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3052),
    [anon_sym___declspec] = ACTIONS(3050),
    [anon_sym___based] = ACTIONS(3050),
    [anon_sym___cdecl] = ACTIONS(3050),
    [anon_sym___clrcall] = ACTIONS(3050),
    [anon_sym___stdcall] = ACTIONS(3050),
    [anon_sym___fastcall] = ACTIONS(3050),
    [anon_sym___thiscall] = ACTIONS(3050),
    [anon_sym___vectorcall] = ACTIONS(3050),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_signed] = ACTIONS(3050),
    [anon_sym_unsigned] = ACTIONS(3050),
    [anon_sym_long] = ACTIONS(3050),
    [anon_sym_short] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_static] = ACTIONS(3050),
    [anon_sym_register] = ACTIONS(3050),
    [anon_sym_inline] = ACTIONS(3050),
    [anon_sym___inline] = ACTIONS(3050),
    [anon_sym___inline__] = ACTIONS(3050),
    [anon_sym___forceinline] = ACTIONS(3050),
    [anon_sym_thread_local] = ACTIONS(3050),
    [anon_sym___thread] = ACTIONS(3050),
    [anon_sym_const] = ACTIONS(3050),
    [anon_sym_constexpr] = ACTIONS(3050),
    [anon_sym_volatile] = ACTIONS(3050),
    [anon_sym_restrict] = ACTIONS(3050),
    [anon_sym___restrict__] = ACTIONS(3050),
    [anon_sym__Atomic] = ACTIONS(3050),
    [anon_sym__Noreturn] = ACTIONS(3050),
    [anon_sym_noreturn] = ACTIONS(3050),
    [anon_sym_mutable] = ACTIONS(3050),
    [anon_sym_constinit] = ACTIONS(3050),
    [anon_sym_consteval] = ACTIONS(3050),
    [anon_sym_PROGMEM] = ACTIONS(3050),
    [aux_sym_primitive_type_token1] = ACTIONS(3050),
    [anon_sym_byte] = ACTIONS(3050),
    [anon_sym_word] = ACTIONS(3050),
    [anon_sym_enum] = ACTIONS(3050),
    [anon_sym_class] = ACTIONS(3050),
    [anon_sym_struct] = ACTIONS(3050),
    [anon_sym_union] = ACTIONS(3050),
    [anon_sym_if] = ACTIONS(3050),
    [anon_sym_else] = ACTIONS(3050),
    [anon_sym_switch] = ACTIONS(3050),
    [anon_sym_case] = ACTIONS(3050),
    [anon_sym_default] = ACTIONS(3050),
    [anon_sym_while] = ACTIONS(3050),
    [anon_sym_do] = ACTIONS(3050),
    [anon_sym_for] = ACTIONS(3050),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_break] = ACTIONS(3050),
    [anon_sym_continue] = ACTIONS(3050),
    [anon_sym_goto] = ACTIONS(3050),
    [anon_sym___try] = ACTIONS(3050),
    [anon_sym___leave] = ACTIONS(3050),
    [anon_sym_not] = ACTIONS(3050),
    [anon_sym_compl] = ACTIONS(3050),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_sizeof] = ACTIONS(3050),
    [anon_sym___alignof__] = ACTIONS(3050),
    [anon_sym___alignof] = ACTIONS(3050),
    [anon_sym__alignof] = ACTIONS(3050),
    [anon_sym_alignof] = ACTIONS(3050),
    [anon_sym__Alignof] = ACTIONS(3050),
    [anon_sym_offsetof] = ACTIONS(3050),
    [anon_sym__Generic] = ACTIONS(3050),
    [anon_sym_asm] = ACTIONS(3050),
    [anon_sym___asm__] = ACTIONS(3050),
    [aux_sym_number_literal_token1] = ACTIONS(3052),
    [aux_sym_number_literal_token2] = ACTIONS(3050),
    [anon_sym_L_SQUOTE] = ACTIONS(3052),
    [anon_sym_u_SQUOTE] = ACTIONS(3052),
    [anon_sym_U_SQUOTE] = ACTIONS(3052),
    [anon_sym_u8_SQUOTE] = ACTIONS(3052),
    [anon_sym_SQUOTE] = ACTIONS(3052),
    [anon_sym_L_DQUOTE] = ACTIONS(3052),
    [anon_sym_u_DQUOTE] = ACTIONS(3052),
    [anon_sym_U_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8_DQUOTE] = ACTIONS(3052),
    [anon_sym_DQUOTE] = ACTIONS(3052),
    [sym_true] = ACTIONS(3050),
    [sym_false] = ACTIONS(3050),
    [anon_sym_NULL] = ACTIONS(3050),
    [anon_sym_nullptr] = ACTIONS(3050),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3050),
    [anon_sym_decltype] = ACTIONS(3050),
    [anon_sym_virtual] = ACTIONS(3050),
    [anon_sym_alignas] = ACTIONS(3050),
    [anon_sym_explicit] = ACTIONS(3050),
    [anon_sym_typename] = ACTIONS(3050),
    [anon_sym_template] = ACTIONS(3050),
    [anon_sym_operator] = ACTIONS(3050),
    [anon_sym_try] = ACTIONS(3050),
    [anon_sym_delete] = ACTIONS(3050),
    [anon_sym_throw] = ACTIONS(3050),
    [anon_sym_namespace] = ACTIONS(3050),
    [anon_sym_using] = ACTIONS(3050),
    [anon_sym_static_assert] = ACTIONS(3050),
    [anon_sym_concept] = ACTIONS(3050),
    [anon_sym_co_return] = ACTIONS(3050),
    [anon_sym_co_yield] = ACTIONS(3050),
    [anon_sym_R_DQUOTE] = ACTIONS(3052),
    [anon_sym_LR_DQUOTE] = ACTIONS(3052),
    [anon_sym_uR_DQUOTE] = ACTIONS(3052),
    [anon_sym_UR_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3052),
    [anon_sym_co_await] = ACTIONS(3050),
    [anon_sym_new] = ACTIONS(3050),
    [anon_sym_requires] = ACTIONS(3050),
    [sym_this] = ACTIONS(3050),
  },
  [846] = {
    [sym_preproc_def] = STATE(843),
    [sym_preproc_function_def] = STATE(843),
    [sym_preproc_call] = STATE(843),
    [sym_preproc_if_in_field_declaration_list] = STATE(843),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(843),
    [sym_preproc_else_in_field_declaration_list] = STATE(9592),
    [sym_preproc_elif_in_field_declaration_list] = STATE(9592),
    [sym_type_definition] = STATE(843),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6507),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7114),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(843),
    [sym_field_declaration] = STATE(843),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2150),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(843),
    [sym_operator_cast] = STATE(7493),
    [sym_inline_method_definition] = STATE(843),
    [sym__constructor_specifiers] = STATE(2150),
    [sym_operator_cast_definition] = STATE(843),
    [sym_operator_cast_declaration] = STATE(843),
    [sym_constructor_or_destructor_definition] = STATE(843),
    [sym_constructor_or_destructor_declaration] = STATE(843),
    [sym_friend_declaration] = STATE(843),
    [sym_access_specifier] = STATE(9075),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(843),
    [sym_alias_declaration] = STATE(843),
    [sym_static_assert_declaration] = STATE(843),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7493),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(843),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2150),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3563),
    [aux_sym_preproc_if_token1] = ACTIONS(3565),
    [aux_sym_preproc_if_token2] = ACTIONS(3603),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3569),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3569),
    [aux_sym_preproc_else_token1] = ACTIONS(3206),
    [aux_sym_preproc_elif_token1] = ACTIONS(3208),
    [sym_preproc_directive] = ACTIONS(3571),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3573),
    [anon_sym_typedef] = ACTIONS(3575),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3577),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3579),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3581),
    [anon_sym_static_assert] = ACTIONS(3583),
  },
  [847] = {
    [sym_identifier] = ACTIONS(2970),
    [aux_sym_preproc_include_token1] = ACTIONS(2970),
    [aux_sym_preproc_def_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token2] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2970),
    [sym_preproc_directive] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_BANG] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym___extension__] = ACTIONS(2970),
    [anon_sym_typedef] = ACTIONS(2970),
    [anon_sym_extern] = ACTIONS(2970),
    [anon_sym___attribute__] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2970),
    [anon_sym___based] = ACTIONS(2970),
    [anon_sym___cdecl] = ACTIONS(2970),
    [anon_sym___clrcall] = ACTIONS(2970),
    [anon_sym___stdcall] = ACTIONS(2970),
    [anon_sym___fastcall] = ACTIONS(2970),
    [anon_sym___thiscall] = ACTIONS(2970),
    [anon_sym___vectorcall] = ACTIONS(2970),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_signed] = ACTIONS(2970),
    [anon_sym_unsigned] = ACTIONS(2970),
    [anon_sym_long] = ACTIONS(2970),
    [anon_sym_short] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_register] = ACTIONS(2970),
    [anon_sym_inline] = ACTIONS(2970),
    [anon_sym___inline] = ACTIONS(2970),
    [anon_sym___inline__] = ACTIONS(2970),
    [anon_sym___forceinline] = ACTIONS(2970),
    [anon_sym_thread_local] = ACTIONS(2970),
    [anon_sym___thread] = ACTIONS(2970),
    [anon_sym_const] = ACTIONS(2970),
    [anon_sym_constexpr] = ACTIONS(2970),
    [anon_sym_volatile] = ACTIONS(2970),
    [anon_sym_restrict] = ACTIONS(2970),
    [anon_sym___restrict__] = ACTIONS(2970),
    [anon_sym__Atomic] = ACTIONS(2970),
    [anon_sym__Noreturn] = ACTIONS(2970),
    [anon_sym_noreturn] = ACTIONS(2970),
    [anon_sym_mutable] = ACTIONS(2970),
    [anon_sym_constinit] = ACTIONS(2970),
    [anon_sym_consteval] = ACTIONS(2970),
    [anon_sym_PROGMEM] = ACTIONS(2970),
    [aux_sym_primitive_type_token1] = ACTIONS(2970),
    [anon_sym_byte] = ACTIONS(2970),
    [anon_sym_word] = ACTIONS(2970),
    [anon_sym_enum] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_struct] = ACTIONS(2970),
    [anon_sym_union] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_else] = ACTIONS(2970),
    [anon_sym_switch] = ACTIONS(2970),
    [anon_sym_case] = ACTIONS(2970),
    [anon_sym_default] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_break] = ACTIONS(2970),
    [anon_sym_continue] = ACTIONS(2970),
    [anon_sym_goto] = ACTIONS(2970),
    [anon_sym___try] = ACTIONS(2970),
    [anon_sym___leave] = ACTIONS(2970),
    [anon_sym_not] = ACTIONS(2970),
    [anon_sym_compl] = ACTIONS(2970),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_sizeof] = ACTIONS(2970),
    [anon_sym___alignof__] = ACTIONS(2970),
    [anon_sym___alignof] = ACTIONS(2970),
    [anon_sym__alignof] = ACTIONS(2970),
    [anon_sym_alignof] = ACTIONS(2970),
    [anon_sym__Alignof] = ACTIONS(2970),
    [anon_sym_offsetof] = ACTIONS(2970),
    [anon_sym__Generic] = ACTIONS(2970),
    [anon_sym_asm] = ACTIONS(2970),
    [anon_sym___asm__] = ACTIONS(2970),
    [aux_sym_number_literal_token1] = ACTIONS(2972),
    [aux_sym_number_literal_token2] = ACTIONS(2970),
    [anon_sym_L_SQUOTE] = ACTIONS(2972),
    [anon_sym_u_SQUOTE] = ACTIONS(2972),
    [anon_sym_U_SQUOTE] = ACTIONS(2972),
    [anon_sym_u8_SQUOTE] = ACTIONS(2972),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [anon_sym_L_DQUOTE] = ACTIONS(2972),
    [anon_sym_u_DQUOTE] = ACTIONS(2972),
    [anon_sym_U_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE] = ACTIONS(2972),
    [sym_true] = ACTIONS(2970),
    [sym_false] = ACTIONS(2970),
    [anon_sym_NULL] = ACTIONS(2970),
    [anon_sym_nullptr] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2970),
    [anon_sym_decltype] = ACTIONS(2970),
    [anon_sym_virtual] = ACTIONS(2970),
    [anon_sym_alignas] = ACTIONS(2970),
    [anon_sym_explicit] = ACTIONS(2970),
    [anon_sym_typename] = ACTIONS(2970),
    [anon_sym_template] = ACTIONS(2970),
    [anon_sym_operator] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_delete] = ACTIONS(2970),
    [anon_sym_throw] = ACTIONS(2970),
    [anon_sym_namespace] = ACTIONS(2970),
    [anon_sym_using] = ACTIONS(2970),
    [anon_sym_static_assert] = ACTIONS(2970),
    [anon_sym_concept] = ACTIONS(2970),
    [anon_sym_co_return] = ACTIONS(2970),
    [anon_sym_co_yield] = ACTIONS(2970),
    [anon_sym_R_DQUOTE] = ACTIONS(2972),
    [anon_sym_LR_DQUOTE] = ACTIONS(2972),
    [anon_sym_uR_DQUOTE] = ACTIONS(2972),
    [anon_sym_UR_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2972),
    [anon_sym_co_await] = ACTIONS(2970),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_requires] = ACTIONS(2970),
    [sym_this] = ACTIONS(2970),
  },
  [848] = {
    [sym_preproc_def] = STATE(848),
    [sym_preproc_function_def] = STATE(848),
    [sym_preproc_call] = STATE(848),
    [sym_preproc_if_in_field_declaration_list] = STATE(848),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(848),
    [sym_type_definition] = STATE(848),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6442),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7117),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(848),
    [sym_field_declaration] = STATE(848),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2239),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(848),
    [sym_operator_cast] = STATE(7514),
    [sym_inline_method_definition] = STATE(848),
    [sym__constructor_specifiers] = STATE(2239),
    [sym_operator_cast_definition] = STATE(848),
    [sym_operator_cast_declaration] = STATE(848),
    [sym_constructor_or_destructor_definition] = STATE(848),
    [sym_constructor_or_destructor_declaration] = STATE(848),
    [sym_friend_declaration] = STATE(848),
    [sym_access_specifier] = STATE(9047),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(848),
    [sym_alias_declaration] = STATE(848),
    [sym_static_assert_declaration] = STATE(848),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7514),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(848),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2239),
    [sym_identifier] = ACTIONS(3605),
    [aux_sym_preproc_def_token1] = ACTIONS(3608),
    [aux_sym_preproc_if_token1] = ACTIONS(3611),
    [aux_sym_preproc_if_token2] = ACTIONS(3614),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3616),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3616),
    [aux_sym_preproc_else_token1] = ACTIONS(3614),
    [aux_sym_preproc_elif_token1] = ACTIONS(3614),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3614),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3614),
    [sym_preproc_directive] = ACTIONS(3619),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_TILDE] = ACTIONS(3625),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_AMP_AMP] = ACTIONS(3631),
    [anon_sym_AMP] = ACTIONS(3634),
    [anon_sym___extension__] = ACTIONS(3637),
    [anon_sym_typedef] = ACTIONS(3640),
    [anon_sym_extern] = ACTIONS(3643),
    [anon_sym___attribute__] = ACTIONS(3646),
    [anon_sym_COLON_COLON] = ACTIONS(3649),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3652),
    [anon_sym___declspec] = ACTIONS(3655),
    [anon_sym___based] = ACTIONS(3658),
    [anon_sym_signed] = ACTIONS(3661),
    [anon_sym_unsigned] = ACTIONS(3661),
    [anon_sym_long] = ACTIONS(3661),
    [anon_sym_short] = ACTIONS(3661),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_static] = ACTIONS(3643),
    [anon_sym_register] = ACTIONS(3643),
    [anon_sym_inline] = ACTIONS(3643),
    [anon_sym___inline] = ACTIONS(3643),
    [anon_sym___inline__] = ACTIONS(3643),
    [anon_sym___forceinline] = ACTIONS(3643),
    [anon_sym_thread_local] = ACTIONS(3643),
    [anon_sym___thread] = ACTIONS(3643),
    [anon_sym_const] = ACTIONS(3667),
    [anon_sym_constexpr] = ACTIONS(3667),
    [anon_sym_volatile] = ACTIONS(3667),
    [anon_sym_restrict] = ACTIONS(3667),
    [anon_sym___restrict__] = ACTIONS(3667),
    [anon_sym__Atomic] = ACTIONS(3667),
    [anon_sym__Noreturn] = ACTIONS(3667),
    [anon_sym_noreturn] = ACTIONS(3667),
    [anon_sym_mutable] = ACTIONS(3667),
    [anon_sym_constinit] = ACTIONS(3667),
    [anon_sym_consteval] = ACTIONS(3667),
    [anon_sym_PROGMEM] = ACTIONS(3667),
    [aux_sym_primitive_type_token1] = ACTIONS(3670),
    [anon_sym_byte] = ACTIONS(3670),
    [anon_sym_word] = ACTIONS(3670),
    [anon_sym_enum] = ACTIONS(3673),
    [anon_sym_class] = ACTIONS(3676),
    [anon_sym_struct] = ACTIONS(3679),
    [anon_sym_union] = ACTIONS(3682),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3685),
    [anon_sym_decltype] = ACTIONS(3688),
    [anon_sym_virtual] = ACTIONS(3691),
    [anon_sym_alignas] = ACTIONS(3694),
    [anon_sym_explicit] = ACTIONS(3697),
    [anon_sym_typename] = ACTIONS(3700),
    [anon_sym_template] = ACTIONS(3703),
    [anon_sym_operator] = ACTIONS(3706),
    [anon_sym_friend] = ACTIONS(3709),
    [anon_sym_public] = ACTIONS(3712),
    [anon_sym_private] = ACTIONS(3712),
    [anon_sym_protected] = ACTIONS(3712),
    [anon_sym_using] = ACTIONS(3715),
    [anon_sym_static_assert] = ACTIONS(3718),
  },
  [849] = {
    [sym_preproc_def] = STATE(1002),
    [sym_preproc_function_def] = STATE(1002),
    [sym_preproc_call] = STATE(1002),
    [sym_preproc_if_in_field_declaration_list] = STATE(1002),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1002),
    [sym_preproc_else_in_field_declaration_list] = STATE(9593),
    [sym_preproc_elif_in_field_declaration_list] = STATE(9593),
    [sym_type_definition] = STATE(1002),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6507),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7114),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1002),
    [sym_field_declaration] = STATE(1002),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2150),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1002),
    [sym_operator_cast] = STATE(7493),
    [sym_inline_method_definition] = STATE(1002),
    [sym__constructor_specifiers] = STATE(2150),
    [sym_operator_cast_definition] = STATE(1002),
    [sym_operator_cast_declaration] = STATE(1002),
    [sym_constructor_or_destructor_definition] = STATE(1002),
    [sym_constructor_or_destructor_declaration] = STATE(1002),
    [sym_friend_declaration] = STATE(1002),
    [sym_access_specifier] = STATE(9075),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1002),
    [sym_alias_declaration] = STATE(1002),
    [sym_static_assert_declaration] = STATE(1002),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7493),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1002),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2150),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3563),
    [aux_sym_preproc_if_token1] = ACTIONS(3565),
    [aux_sym_preproc_if_token2] = ACTIONS(3721),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3569),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3569),
    [aux_sym_preproc_else_token1] = ACTIONS(3206),
    [aux_sym_preproc_elif_token1] = ACTIONS(3208),
    [sym_preproc_directive] = ACTIONS(3571),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3573),
    [anon_sym_typedef] = ACTIONS(3575),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3577),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3579),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3581),
    [anon_sym_static_assert] = ACTIONS(3583),
  },
  [850] = {
    [sym_identifier] = ACTIONS(3054),
    [aux_sym_preproc_include_token1] = ACTIONS(3054),
    [aux_sym_preproc_def_token1] = ACTIONS(3054),
    [aux_sym_preproc_if_token1] = ACTIONS(3054),
    [aux_sym_preproc_if_token2] = ACTIONS(3054),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3054),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3054),
    [sym_preproc_directive] = ACTIONS(3054),
    [anon_sym_LPAREN2] = ACTIONS(3056),
    [anon_sym_BANG] = ACTIONS(3056),
    [anon_sym_TILDE] = ACTIONS(3056),
    [anon_sym_DASH] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3056),
    [anon_sym_AMP_AMP] = ACTIONS(3056),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym___extension__] = ACTIONS(3054),
    [anon_sym_typedef] = ACTIONS(3054),
    [anon_sym_extern] = ACTIONS(3054),
    [anon_sym___attribute__] = ACTIONS(3054),
    [anon_sym_COLON_COLON] = ACTIONS(3056),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3056),
    [anon_sym___declspec] = ACTIONS(3054),
    [anon_sym___based] = ACTIONS(3054),
    [anon_sym___cdecl] = ACTIONS(3054),
    [anon_sym___clrcall] = ACTIONS(3054),
    [anon_sym___stdcall] = ACTIONS(3054),
    [anon_sym___fastcall] = ACTIONS(3054),
    [anon_sym___thiscall] = ACTIONS(3054),
    [anon_sym___vectorcall] = ACTIONS(3054),
    [anon_sym_LBRACE] = ACTIONS(3056),
    [anon_sym_signed] = ACTIONS(3054),
    [anon_sym_unsigned] = ACTIONS(3054),
    [anon_sym_long] = ACTIONS(3054),
    [anon_sym_short] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3054),
    [anon_sym_static] = ACTIONS(3054),
    [anon_sym_register] = ACTIONS(3054),
    [anon_sym_inline] = ACTIONS(3054),
    [anon_sym___inline] = ACTIONS(3054),
    [anon_sym___inline__] = ACTIONS(3054),
    [anon_sym___forceinline] = ACTIONS(3054),
    [anon_sym_thread_local] = ACTIONS(3054),
    [anon_sym___thread] = ACTIONS(3054),
    [anon_sym_const] = ACTIONS(3054),
    [anon_sym_constexpr] = ACTIONS(3054),
    [anon_sym_volatile] = ACTIONS(3054),
    [anon_sym_restrict] = ACTIONS(3054),
    [anon_sym___restrict__] = ACTIONS(3054),
    [anon_sym__Atomic] = ACTIONS(3054),
    [anon_sym__Noreturn] = ACTIONS(3054),
    [anon_sym_noreturn] = ACTIONS(3054),
    [anon_sym_mutable] = ACTIONS(3054),
    [anon_sym_constinit] = ACTIONS(3054),
    [anon_sym_consteval] = ACTIONS(3054),
    [anon_sym_PROGMEM] = ACTIONS(3054),
    [aux_sym_primitive_type_token1] = ACTIONS(3054),
    [anon_sym_byte] = ACTIONS(3054),
    [anon_sym_word] = ACTIONS(3054),
    [anon_sym_enum] = ACTIONS(3054),
    [anon_sym_class] = ACTIONS(3054),
    [anon_sym_struct] = ACTIONS(3054),
    [anon_sym_union] = ACTIONS(3054),
    [anon_sym_if] = ACTIONS(3054),
    [anon_sym_else] = ACTIONS(3054),
    [anon_sym_switch] = ACTIONS(3054),
    [anon_sym_case] = ACTIONS(3054),
    [anon_sym_default] = ACTIONS(3054),
    [anon_sym_while] = ACTIONS(3054),
    [anon_sym_do] = ACTIONS(3054),
    [anon_sym_for] = ACTIONS(3054),
    [anon_sym_return] = ACTIONS(3054),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_continue] = ACTIONS(3054),
    [anon_sym_goto] = ACTIONS(3054),
    [anon_sym___try] = ACTIONS(3054),
    [anon_sym___leave] = ACTIONS(3054),
    [anon_sym_not] = ACTIONS(3054),
    [anon_sym_compl] = ACTIONS(3054),
    [anon_sym_DASH_DASH] = ACTIONS(3056),
    [anon_sym_PLUS_PLUS] = ACTIONS(3056),
    [anon_sym_sizeof] = ACTIONS(3054),
    [anon_sym___alignof__] = ACTIONS(3054),
    [anon_sym___alignof] = ACTIONS(3054),
    [anon_sym__alignof] = ACTIONS(3054),
    [anon_sym_alignof] = ACTIONS(3054),
    [anon_sym__Alignof] = ACTIONS(3054),
    [anon_sym_offsetof] = ACTIONS(3054),
    [anon_sym__Generic] = ACTIONS(3054),
    [anon_sym_asm] = ACTIONS(3054),
    [anon_sym___asm__] = ACTIONS(3054),
    [aux_sym_number_literal_token1] = ACTIONS(3056),
    [aux_sym_number_literal_token2] = ACTIONS(3054),
    [anon_sym_L_SQUOTE] = ACTIONS(3056),
    [anon_sym_u_SQUOTE] = ACTIONS(3056),
    [anon_sym_U_SQUOTE] = ACTIONS(3056),
    [anon_sym_u8_SQUOTE] = ACTIONS(3056),
    [anon_sym_SQUOTE] = ACTIONS(3056),
    [anon_sym_L_DQUOTE] = ACTIONS(3056),
    [anon_sym_u_DQUOTE] = ACTIONS(3056),
    [anon_sym_U_DQUOTE] = ACTIONS(3056),
    [anon_sym_u8_DQUOTE] = ACTIONS(3056),
    [anon_sym_DQUOTE] = ACTIONS(3056),
    [sym_true] = ACTIONS(3054),
    [sym_false] = ACTIONS(3054),
    [anon_sym_NULL] = ACTIONS(3054),
    [anon_sym_nullptr] = ACTIONS(3054),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3054),
    [anon_sym_decltype] = ACTIONS(3054),
    [anon_sym_virtual] = ACTIONS(3054),
    [anon_sym_alignas] = ACTIONS(3054),
    [anon_sym_explicit] = ACTIONS(3054),
    [anon_sym_typename] = ACTIONS(3054),
    [anon_sym_template] = ACTIONS(3054),
    [anon_sym_operator] = ACTIONS(3054),
    [anon_sym_try] = ACTIONS(3054),
    [anon_sym_delete] = ACTIONS(3054),
    [anon_sym_throw] = ACTIONS(3054),
    [anon_sym_namespace] = ACTIONS(3054),
    [anon_sym_using] = ACTIONS(3054),
    [anon_sym_static_assert] = ACTIONS(3054),
    [anon_sym_concept] = ACTIONS(3054),
    [anon_sym_co_return] = ACTIONS(3054),
    [anon_sym_co_yield] = ACTIONS(3054),
    [anon_sym_R_DQUOTE] = ACTIONS(3056),
    [anon_sym_LR_DQUOTE] = ACTIONS(3056),
    [anon_sym_uR_DQUOTE] = ACTIONS(3056),
    [anon_sym_UR_DQUOTE] = ACTIONS(3056),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3056),
    [anon_sym_co_await] = ACTIONS(3054),
    [anon_sym_new] = ACTIONS(3054),
    [anon_sym_requires] = ACTIONS(3054),
    [sym_this] = ACTIONS(3054),
  },
  [851] = {
    [sym_identifier] = ACTIONS(3162),
    [aux_sym_preproc_include_token1] = ACTIONS(3162),
    [aux_sym_preproc_def_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token1] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3162),
    [sym_preproc_directive] = ACTIONS(3162),
    [anon_sym_LPAREN2] = ACTIONS(3164),
    [anon_sym_BANG] = ACTIONS(3164),
    [anon_sym_TILDE] = ACTIONS(3164),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_STAR] = ACTIONS(3164),
    [anon_sym_AMP_AMP] = ACTIONS(3164),
    [anon_sym_AMP] = ACTIONS(3162),
    [anon_sym_SEMI] = ACTIONS(3164),
    [anon_sym___extension__] = ACTIONS(3162),
    [anon_sym_typedef] = ACTIONS(3162),
    [anon_sym_extern] = ACTIONS(3162),
    [anon_sym___attribute__] = ACTIONS(3162),
    [anon_sym_COLON_COLON] = ACTIONS(3164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3164),
    [anon_sym___declspec] = ACTIONS(3162),
    [anon_sym___based] = ACTIONS(3162),
    [anon_sym___cdecl] = ACTIONS(3162),
    [anon_sym___clrcall] = ACTIONS(3162),
    [anon_sym___stdcall] = ACTIONS(3162),
    [anon_sym___fastcall] = ACTIONS(3162),
    [anon_sym___thiscall] = ACTIONS(3162),
    [anon_sym___vectorcall] = ACTIONS(3162),
    [anon_sym_LBRACE] = ACTIONS(3164),
    [anon_sym_RBRACE] = ACTIONS(3164),
    [anon_sym_signed] = ACTIONS(3162),
    [anon_sym_unsigned] = ACTIONS(3162),
    [anon_sym_long] = ACTIONS(3162),
    [anon_sym_short] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_register] = ACTIONS(3162),
    [anon_sym_inline] = ACTIONS(3162),
    [anon_sym___inline] = ACTIONS(3162),
    [anon_sym___inline__] = ACTIONS(3162),
    [anon_sym___forceinline] = ACTIONS(3162),
    [anon_sym_thread_local] = ACTIONS(3162),
    [anon_sym___thread] = ACTIONS(3162),
    [anon_sym_const] = ACTIONS(3162),
    [anon_sym_constexpr] = ACTIONS(3162),
    [anon_sym_volatile] = ACTIONS(3162),
    [anon_sym_restrict] = ACTIONS(3162),
    [anon_sym___restrict__] = ACTIONS(3162),
    [anon_sym__Atomic] = ACTIONS(3162),
    [anon_sym__Noreturn] = ACTIONS(3162),
    [anon_sym_noreturn] = ACTIONS(3162),
    [anon_sym_mutable] = ACTIONS(3162),
    [anon_sym_constinit] = ACTIONS(3162),
    [anon_sym_consteval] = ACTIONS(3162),
    [anon_sym_PROGMEM] = ACTIONS(3162),
    [aux_sym_primitive_type_token1] = ACTIONS(3162),
    [anon_sym_byte] = ACTIONS(3162),
    [anon_sym_word] = ACTIONS(3162),
    [anon_sym_enum] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_struct] = ACTIONS(3162),
    [anon_sym_union] = ACTIONS(3162),
    [anon_sym_if] = ACTIONS(3162),
    [anon_sym_else] = ACTIONS(3162),
    [anon_sym_switch] = ACTIONS(3162),
    [anon_sym_case] = ACTIONS(3162),
    [anon_sym_default] = ACTIONS(3162),
    [anon_sym_while] = ACTIONS(3162),
    [anon_sym_do] = ACTIONS(3162),
    [anon_sym_for] = ACTIONS(3162),
    [anon_sym_return] = ACTIONS(3162),
    [anon_sym_break] = ACTIONS(3162),
    [anon_sym_continue] = ACTIONS(3162),
    [anon_sym_goto] = ACTIONS(3162),
    [anon_sym___try] = ACTIONS(3162),
    [anon_sym___leave] = ACTIONS(3162),
    [anon_sym_not] = ACTIONS(3162),
    [anon_sym_compl] = ACTIONS(3162),
    [anon_sym_DASH_DASH] = ACTIONS(3164),
    [anon_sym_PLUS_PLUS] = ACTIONS(3164),
    [anon_sym_sizeof] = ACTIONS(3162),
    [anon_sym___alignof__] = ACTIONS(3162),
    [anon_sym___alignof] = ACTIONS(3162),
    [anon_sym__alignof] = ACTIONS(3162),
    [anon_sym_alignof] = ACTIONS(3162),
    [anon_sym__Alignof] = ACTIONS(3162),
    [anon_sym_offsetof] = ACTIONS(3162),
    [anon_sym__Generic] = ACTIONS(3162),
    [anon_sym_asm] = ACTIONS(3162),
    [anon_sym___asm__] = ACTIONS(3162),
    [aux_sym_number_literal_token1] = ACTIONS(3164),
    [aux_sym_number_literal_token2] = ACTIONS(3162),
    [anon_sym_L_SQUOTE] = ACTIONS(3164),
    [anon_sym_u_SQUOTE] = ACTIONS(3164),
    [anon_sym_U_SQUOTE] = ACTIONS(3164),
    [anon_sym_u8_SQUOTE] = ACTIONS(3164),
    [anon_sym_SQUOTE] = ACTIONS(3164),
    [anon_sym_L_DQUOTE] = ACTIONS(3164),
    [anon_sym_u_DQUOTE] = ACTIONS(3164),
    [anon_sym_U_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8_DQUOTE] = ACTIONS(3164),
    [anon_sym_DQUOTE] = ACTIONS(3164),
    [sym_true] = ACTIONS(3162),
    [sym_false] = ACTIONS(3162),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3162),
    [anon_sym_decltype] = ACTIONS(3162),
    [anon_sym_virtual] = ACTIONS(3162),
    [anon_sym_alignas] = ACTIONS(3162),
    [anon_sym_explicit] = ACTIONS(3162),
    [anon_sym_typename] = ACTIONS(3162),
    [anon_sym_template] = ACTIONS(3162),
    [anon_sym_operator] = ACTIONS(3162),
    [anon_sym_try] = ACTIONS(3162),
    [anon_sym_delete] = ACTIONS(3162),
    [anon_sym_throw] = ACTIONS(3162),
    [anon_sym_namespace] = ACTIONS(3162),
    [anon_sym_using] = ACTIONS(3162),
    [anon_sym_static_assert] = ACTIONS(3162),
    [anon_sym_concept] = ACTIONS(3162),
    [anon_sym_co_return] = ACTIONS(3162),
    [anon_sym_co_yield] = ACTIONS(3162),
    [anon_sym_R_DQUOTE] = ACTIONS(3164),
    [anon_sym_LR_DQUOTE] = ACTIONS(3164),
    [anon_sym_uR_DQUOTE] = ACTIONS(3164),
    [anon_sym_UR_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3164),
    [anon_sym_co_await] = ACTIONS(3162),
    [anon_sym_new] = ACTIONS(3162),
    [anon_sym_requires] = ACTIONS(3162),
    [sym_this] = ACTIONS(3162),
  },
  [852] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_include_token1] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [anon_sym_COMMA] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_BANG] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(2265),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym___cdecl] = ACTIONS(2267),
    [anon_sym___clrcall] = ACTIONS(2267),
    [anon_sym___stdcall] = ACTIONS(2267),
    [anon_sym___fastcall] = ACTIONS(2267),
    [anon_sym___thiscall] = ACTIONS(2267),
    [anon_sym___vectorcall] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2265),
    [anon_sym_RBRACE] = ACTIONS(3176),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_case] = ACTIONS(2267),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_return] = ACTIONS(2267),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_continue] = ACTIONS(2267),
    [anon_sym_goto] = ACTIONS(2267),
    [anon_sym___try] = ACTIONS(2267),
    [anon_sym___leave] = ACTIONS(2267),
    [anon_sym_not] = ACTIONS(2267),
    [anon_sym_compl] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2265),
    [anon_sym_PLUS_PLUS] = ACTIONS(2265),
    [anon_sym_sizeof] = ACTIONS(2267),
    [anon_sym___alignof__] = ACTIONS(2267),
    [anon_sym___alignof] = ACTIONS(2267),
    [anon_sym__alignof] = ACTIONS(2267),
    [anon_sym_alignof] = ACTIONS(2267),
    [anon_sym__Alignof] = ACTIONS(2267),
    [anon_sym_offsetof] = ACTIONS(2267),
    [anon_sym__Generic] = ACTIONS(2267),
    [anon_sym_asm] = ACTIONS(2267),
    [anon_sym___asm__] = ACTIONS(2267),
    [aux_sym_number_literal_token1] = ACTIONS(2265),
    [aux_sym_number_literal_token2] = ACTIONS(2267),
    [anon_sym_L_SQUOTE] = ACTIONS(2265),
    [anon_sym_u_SQUOTE] = ACTIONS(2265),
    [anon_sym_U_SQUOTE] = ACTIONS(2265),
    [anon_sym_u8_SQUOTE] = ACTIONS(2265),
    [anon_sym_SQUOTE] = ACTIONS(2265),
    [anon_sym_L_DQUOTE] = ACTIONS(2265),
    [anon_sym_u_DQUOTE] = ACTIONS(2265),
    [anon_sym_U_DQUOTE] = ACTIONS(2265),
    [anon_sym_u8_DQUOTE] = ACTIONS(2265),
    [anon_sym_DQUOTE] = ACTIONS(2265),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [anon_sym_NULL] = ACTIONS(2267),
    [anon_sym_nullptr] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_try] = ACTIONS(2267),
    [anon_sym_delete] = ACTIONS(2267),
    [anon_sym_throw] = ACTIONS(2267),
    [anon_sym_namespace] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym_concept] = ACTIONS(2267),
    [anon_sym_co_return] = ACTIONS(2267),
    [anon_sym_co_yield] = ACTIONS(2267),
    [anon_sym_R_DQUOTE] = ACTIONS(2265),
    [anon_sym_LR_DQUOTE] = ACTIONS(2265),
    [anon_sym_uR_DQUOTE] = ACTIONS(2265),
    [anon_sym_UR_DQUOTE] = ACTIONS(2265),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2265),
    [anon_sym_co_await] = ACTIONS(2267),
    [anon_sym_new] = ACTIONS(2267),
    [anon_sym_requires] = ACTIONS(2267),
    [sym_this] = ACTIONS(2267),
  },
  [853] = {
    [sym_identifier] = ACTIONS(3086),
    [aux_sym_preproc_include_token1] = ACTIONS(3086),
    [aux_sym_preproc_def_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token2] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3086),
    [sym_preproc_directive] = ACTIONS(3086),
    [anon_sym_LPAREN2] = ACTIONS(3088),
    [anon_sym_BANG] = ACTIONS(3088),
    [anon_sym_TILDE] = ACTIONS(3088),
    [anon_sym_DASH] = ACTIONS(3086),
    [anon_sym_PLUS] = ACTIONS(3086),
    [anon_sym_STAR] = ACTIONS(3088),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym_SEMI] = ACTIONS(3088),
    [anon_sym___extension__] = ACTIONS(3086),
    [anon_sym_typedef] = ACTIONS(3086),
    [anon_sym_extern] = ACTIONS(3086),
    [anon_sym___attribute__] = ACTIONS(3086),
    [anon_sym_COLON_COLON] = ACTIONS(3088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3088),
    [anon_sym___declspec] = ACTIONS(3086),
    [anon_sym___based] = ACTIONS(3086),
    [anon_sym___cdecl] = ACTIONS(3086),
    [anon_sym___clrcall] = ACTIONS(3086),
    [anon_sym___stdcall] = ACTIONS(3086),
    [anon_sym___fastcall] = ACTIONS(3086),
    [anon_sym___thiscall] = ACTIONS(3086),
    [anon_sym___vectorcall] = ACTIONS(3086),
    [anon_sym_LBRACE] = ACTIONS(3088),
    [anon_sym_signed] = ACTIONS(3086),
    [anon_sym_unsigned] = ACTIONS(3086),
    [anon_sym_long] = ACTIONS(3086),
    [anon_sym_short] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(3086),
    [anon_sym_static] = ACTIONS(3086),
    [anon_sym_register] = ACTIONS(3086),
    [anon_sym_inline] = ACTIONS(3086),
    [anon_sym___inline] = ACTIONS(3086),
    [anon_sym___inline__] = ACTIONS(3086),
    [anon_sym___forceinline] = ACTIONS(3086),
    [anon_sym_thread_local] = ACTIONS(3086),
    [anon_sym___thread] = ACTIONS(3086),
    [anon_sym_const] = ACTIONS(3086),
    [anon_sym_constexpr] = ACTIONS(3086),
    [anon_sym_volatile] = ACTIONS(3086),
    [anon_sym_restrict] = ACTIONS(3086),
    [anon_sym___restrict__] = ACTIONS(3086),
    [anon_sym__Atomic] = ACTIONS(3086),
    [anon_sym__Noreturn] = ACTIONS(3086),
    [anon_sym_noreturn] = ACTIONS(3086),
    [anon_sym_mutable] = ACTIONS(3086),
    [anon_sym_constinit] = ACTIONS(3086),
    [anon_sym_consteval] = ACTIONS(3086),
    [anon_sym_PROGMEM] = ACTIONS(3086),
    [aux_sym_primitive_type_token1] = ACTIONS(3086),
    [anon_sym_byte] = ACTIONS(3086),
    [anon_sym_word] = ACTIONS(3086),
    [anon_sym_enum] = ACTIONS(3086),
    [anon_sym_class] = ACTIONS(3086),
    [anon_sym_struct] = ACTIONS(3086),
    [anon_sym_union] = ACTIONS(3086),
    [anon_sym_if] = ACTIONS(3086),
    [anon_sym_else] = ACTIONS(3086),
    [anon_sym_switch] = ACTIONS(3086),
    [anon_sym_case] = ACTIONS(3086),
    [anon_sym_default] = ACTIONS(3086),
    [anon_sym_while] = ACTIONS(3086),
    [anon_sym_do] = ACTIONS(3086),
    [anon_sym_for] = ACTIONS(3086),
    [anon_sym_return] = ACTIONS(3086),
    [anon_sym_break] = ACTIONS(3086),
    [anon_sym_continue] = ACTIONS(3086),
    [anon_sym_goto] = ACTIONS(3086),
    [anon_sym___try] = ACTIONS(3086),
    [anon_sym___leave] = ACTIONS(3086),
    [anon_sym_not] = ACTIONS(3086),
    [anon_sym_compl] = ACTIONS(3086),
    [anon_sym_DASH_DASH] = ACTIONS(3088),
    [anon_sym_PLUS_PLUS] = ACTIONS(3088),
    [anon_sym_sizeof] = ACTIONS(3086),
    [anon_sym___alignof__] = ACTIONS(3086),
    [anon_sym___alignof] = ACTIONS(3086),
    [anon_sym__alignof] = ACTIONS(3086),
    [anon_sym_alignof] = ACTIONS(3086),
    [anon_sym__Alignof] = ACTIONS(3086),
    [anon_sym_offsetof] = ACTIONS(3086),
    [anon_sym__Generic] = ACTIONS(3086),
    [anon_sym_asm] = ACTIONS(3086),
    [anon_sym___asm__] = ACTIONS(3086),
    [aux_sym_number_literal_token1] = ACTIONS(3088),
    [aux_sym_number_literal_token2] = ACTIONS(3086),
    [anon_sym_L_SQUOTE] = ACTIONS(3088),
    [anon_sym_u_SQUOTE] = ACTIONS(3088),
    [anon_sym_U_SQUOTE] = ACTIONS(3088),
    [anon_sym_u8_SQUOTE] = ACTIONS(3088),
    [anon_sym_SQUOTE] = ACTIONS(3088),
    [anon_sym_L_DQUOTE] = ACTIONS(3088),
    [anon_sym_u_DQUOTE] = ACTIONS(3088),
    [anon_sym_U_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8_DQUOTE] = ACTIONS(3088),
    [anon_sym_DQUOTE] = ACTIONS(3088),
    [sym_true] = ACTIONS(3086),
    [sym_false] = ACTIONS(3086),
    [anon_sym_NULL] = ACTIONS(3086),
    [anon_sym_nullptr] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3086),
    [anon_sym_decltype] = ACTIONS(3086),
    [anon_sym_virtual] = ACTIONS(3086),
    [anon_sym_alignas] = ACTIONS(3086),
    [anon_sym_explicit] = ACTIONS(3086),
    [anon_sym_typename] = ACTIONS(3086),
    [anon_sym_template] = ACTIONS(3086),
    [anon_sym_operator] = ACTIONS(3086),
    [anon_sym_try] = ACTIONS(3086),
    [anon_sym_delete] = ACTIONS(3086),
    [anon_sym_throw] = ACTIONS(3086),
    [anon_sym_namespace] = ACTIONS(3086),
    [anon_sym_using] = ACTIONS(3086),
    [anon_sym_static_assert] = ACTIONS(3086),
    [anon_sym_concept] = ACTIONS(3086),
    [anon_sym_co_return] = ACTIONS(3086),
    [anon_sym_co_yield] = ACTIONS(3086),
    [anon_sym_R_DQUOTE] = ACTIONS(3088),
    [anon_sym_LR_DQUOTE] = ACTIONS(3088),
    [anon_sym_uR_DQUOTE] = ACTIONS(3088),
    [anon_sym_UR_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3088),
    [anon_sym_co_await] = ACTIONS(3086),
    [anon_sym_new] = ACTIONS(3086),
    [anon_sym_requires] = ACTIONS(3086),
    [sym_this] = ACTIONS(3086),
  },
  [854] = {
    [sym_identifier] = ACTIONS(3058),
    [aux_sym_preproc_include_token1] = ACTIONS(3058),
    [aux_sym_preproc_def_token1] = ACTIONS(3058),
    [aux_sym_preproc_if_token1] = ACTIONS(3058),
    [aux_sym_preproc_if_token2] = ACTIONS(3058),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3058),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3058),
    [sym_preproc_directive] = ACTIONS(3058),
    [anon_sym_LPAREN2] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3060),
    [anon_sym_TILDE] = ACTIONS(3060),
    [anon_sym_DASH] = ACTIONS(3058),
    [anon_sym_PLUS] = ACTIONS(3058),
    [anon_sym_STAR] = ACTIONS(3060),
    [anon_sym_AMP_AMP] = ACTIONS(3060),
    [anon_sym_AMP] = ACTIONS(3058),
    [anon_sym_SEMI] = ACTIONS(3060),
    [anon_sym___extension__] = ACTIONS(3058),
    [anon_sym_typedef] = ACTIONS(3058),
    [anon_sym_extern] = ACTIONS(3058),
    [anon_sym___attribute__] = ACTIONS(3058),
    [anon_sym_COLON_COLON] = ACTIONS(3060),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3060),
    [anon_sym___declspec] = ACTIONS(3058),
    [anon_sym___based] = ACTIONS(3058),
    [anon_sym___cdecl] = ACTIONS(3058),
    [anon_sym___clrcall] = ACTIONS(3058),
    [anon_sym___stdcall] = ACTIONS(3058),
    [anon_sym___fastcall] = ACTIONS(3058),
    [anon_sym___thiscall] = ACTIONS(3058),
    [anon_sym___vectorcall] = ACTIONS(3058),
    [anon_sym_LBRACE] = ACTIONS(3060),
    [anon_sym_signed] = ACTIONS(3058),
    [anon_sym_unsigned] = ACTIONS(3058),
    [anon_sym_long] = ACTIONS(3058),
    [anon_sym_short] = ACTIONS(3058),
    [anon_sym_LBRACK] = ACTIONS(3058),
    [anon_sym_static] = ACTIONS(3058),
    [anon_sym_register] = ACTIONS(3058),
    [anon_sym_inline] = ACTIONS(3058),
    [anon_sym___inline] = ACTIONS(3058),
    [anon_sym___inline__] = ACTIONS(3058),
    [anon_sym___forceinline] = ACTIONS(3058),
    [anon_sym_thread_local] = ACTIONS(3058),
    [anon_sym___thread] = ACTIONS(3058),
    [anon_sym_const] = ACTIONS(3058),
    [anon_sym_constexpr] = ACTIONS(3058),
    [anon_sym_volatile] = ACTIONS(3058),
    [anon_sym_restrict] = ACTIONS(3058),
    [anon_sym___restrict__] = ACTIONS(3058),
    [anon_sym__Atomic] = ACTIONS(3058),
    [anon_sym__Noreturn] = ACTIONS(3058),
    [anon_sym_noreturn] = ACTIONS(3058),
    [anon_sym_mutable] = ACTIONS(3058),
    [anon_sym_constinit] = ACTIONS(3058),
    [anon_sym_consteval] = ACTIONS(3058),
    [anon_sym_PROGMEM] = ACTIONS(3058),
    [aux_sym_primitive_type_token1] = ACTIONS(3058),
    [anon_sym_byte] = ACTIONS(3058),
    [anon_sym_word] = ACTIONS(3058),
    [anon_sym_enum] = ACTIONS(3058),
    [anon_sym_class] = ACTIONS(3058),
    [anon_sym_struct] = ACTIONS(3058),
    [anon_sym_union] = ACTIONS(3058),
    [anon_sym_if] = ACTIONS(3058),
    [anon_sym_else] = ACTIONS(3058),
    [anon_sym_switch] = ACTIONS(3058),
    [anon_sym_case] = ACTIONS(3058),
    [anon_sym_default] = ACTIONS(3058),
    [anon_sym_while] = ACTIONS(3058),
    [anon_sym_do] = ACTIONS(3058),
    [anon_sym_for] = ACTIONS(3058),
    [anon_sym_return] = ACTIONS(3058),
    [anon_sym_break] = ACTIONS(3058),
    [anon_sym_continue] = ACTIONS(3058),
    [anon_sym_goto] = ACTIONS(3058),
    [anon_sym___try] = ACTIONS(3058),
    [anon_sym___leave] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3058),
    [anon_sym_compl] = ACTIONS(3058),
    [anon_sym_DASH_DASH] = ACTIONS(3060),
    [anon_sym_PLUS_PLUS] = ACTIONS(3060),
    [anon_sym_sizeof] = ACTIONS(3058),
    [anon_sym___alignof__] = ACTIONS(3058),
    [anon_sym___alignof] = ACTIONS(3058),
    [anon_sym__alignof] = ACTIONS(3058),
    [anon_sym_alignof] = ACTIONS(3058),
    [anon_sym__Alignof] = ACTIONS(3058),
    [anon_sym_offsetof] = ACTIONS(3058),
    [anon_sym__Generic] = ACTIONS(3058),
    [anon_sym_asm] = ACTIONS(3058),
    [anon_sym___asm__] = ACTIONS(3058),
    [aux_sym_number_literal_token1] = ACTIONS(3060),
    [aux_sym_number_literal_token2] = ACTIONS(3058),
    [anon_sym_L_SQUOTE] = ACTIONS(3060),
    [anon_sym_u_SQUOTE] = ACTIONS(3060),
    [anon_sym_U_SQUOTE] = ACTIONS(3060),
    [anon_sym_u8_SQUOTE] = ACTIONS(3060),
    [anon_sym_SQUOTE] = ACTIONS(3060),
    [anon_sym_L_DQUOTE] = ACTIONS(3060),
    [anon_sym_u_DQUOTE] = ACTIONS(3060),
    [anon_sym_U_DQUOTE] = ACTIONS(3060),
    [anon_sym_u8_DQUOTE] = ACTIONS(3060),
    [anon_sym_DQUOTE] = ACTIONS(3060),
    [sym_true] = ACTIONS(3058),
    [sym_false] = ACTIONS(3058),
    [anon_sym_NULL] = ACTIONS(3058),
    [anon_sym_nullptr] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3058),
    [anon_sym_decltype] = ACTIONS(3058),
    [anon_sym_virtual] = ACTIONS(3058),
    [anon_sym_alignas] = ACTIONS(3058),
    [anon_sym_explicit] = ACTIONS(3058),
    [anon_sym_typename] = ACTIONS(3058),
    [anon_sym_template] = ACTIONS(3058),
    [anon_sym_operator] = ACTIONS(3058),
    [anon_sym_try] = ACTIONS(3058),
    [anon_sym_delete] = ACTIONS(3058),
    [anon_sym_throw] = ACTIONS(3058),
    [anon_sym_namespace] = ACTIONS(3058),
    [anon_sym_using] = ACTIONS(3058),
    [anon_sym_static_assert] = ACTIONS(3058),
    [anon_sym_concept] = ACTIONS(3058),
    [anon_sym_co_return] = ACTIONS(3058),
    [anon_sym_co_yield] = ACTIONS(3058),
    [anon_sym_R_DQUOTE] = ACTIONS(3060),
    [anon_sym_LR_DQUOTE] = ACTIONS(3060),
    [anon_sym_uR_DQUOTE] = ACTIONS(3060),
    [anon_sym_UR_DQUOTE] = ACTIONS(3060),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3060),
    [anon_sym_co_await] = ACTIONS(3058),
    [anon_sym_new] = ACTIONS(3058),
    [anon_sym_requires] = ACTIONS(3058),
    [sym_this] = ACTIONS(3058),
  },
  [855] = {
    [sym_identifier] = ACTIONS(3064),
    [aux_sym_preproc_include_token1] = ACTIONS(3064),
    [aux_sym_preproc_def_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token2] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3064),
    [anon_sym_LPAREN2] = ACTIONS(3066),
    [anon_sym_BANG] = ACTIONS(3066),
    [anon_sym_TILDE] = ACTIONS(3066),
    [anon_sym_DASH] = ACTIONS(3064),
    [anon_sym_PLUS] = ACTIONS(3064),
    [anon_sym_STAR] = ACTIONS(3066),
    [anon_sym_AMP_AMP] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3064),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym___extension__] = ACTIONS(3064),
    [anon_sym_typedef] = ACTIONS(3064),
    [anon_sym_extern] = ACTIONS(3064),
    [anon_sym___attribute__] = ACTIONS(3064),
    [anon_sym_COLON_COLON] = ACTIONS(3066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3066),
    [anon_sym___declspec] = ACTIONS(3064),
    [anon_sym___based] = ACTIONS(3064),
    [anon_sym___cdecl] = ACTIONS(3064),
    [anon_sym___clrcall] = ACTIONS(3064),
    [anon_sym___stdcall] = ACTIONS(3064),
    [anon_sym___fastcall] = ACTIONS(3064),
    [anon_sym___thiscall] = ACTIONS(3064),
    [anon_sym___vectorcall] = ACTIONS(3064),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_signed] = ACTIONS(3064),
    [anon_sym_unsigned] = ACTIONS(3064),
    [anon_sym_long] = ACTIONS(3064),
    [anon_sym_short] = ACTIONS(3064),
    [anon_sym_LBRACK] = ACTIONS(3064),
    [anon_sym_static] = ACTIONS(3064),
    [anon_sym_register] = ACTIONS(3064),
    [anon_sym_inline] = ACTIONS(3064),
    [anon_sym___inline] = ACTIONS(3064),
    [anon_sym___inline__] = ACTIONS(3064),
    [anon_sym___forceinline] = ACTIONS(3064),
    [anon_sym_thread_local] = ACTIONS(3064),
    [anon_sym___thread] = ACTIONS(3064),
    [anon_sym_const] = ACTIONS(3064),
    [anon_sym_constexpr] = ACTIONS(3064),
    [anon_sym_volatile] = ACTIONS(3064),
    [anon_sym_restrict] = ACTIONS(3064),
    [anon_sym___restrict__] = ACTIONS(3064),
    [anon_sym__Atomic] = ACTIONS(3064),
    [anon_sym__Noreturn] = ACTIONS(3064),
    [anon_sym_noreturn] = ACTIONS(3064),
    [anon_sym_mutable] = ACTIONS(3064),
    [anon_sym_constinit] = ACTIONS(3064),
    [anon_sym_consteval] = ACTIONS(3064),
    [anon_sym_PROGMEM] = ACTIONS(3064),
    [aux_sym_primitive_type_token1] = ACTIONS(3064),
    [anon_sym_byte] = ACTIONS(3064),
    [anon_sym_word] = ACTIONS(3064),
    [anon_sym_enum] = ACTIONS(3064),
    [anon_sym_class] = ACTIONS(3064),
    [anon_sym_struct] = ACTIONS(3064),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_if] = ACTIONS(3064),
    [anon_sym_else] = ACTIONS(3064),
    [anon_sym_switch] = ACTIONS(3064),
    [anon_sym_case] = ACTIONS(3064),
    [anon_sym_default] = ACTIONS(3064),
    [anon_sym_while] = ACTIONS(3064),
    [anon_sym_do] = ACTIONS(3064),
    [anon_sym_for] = ACTIONS(3064),
    [anon_sym_return] = ACTIONS(3064),
    [anon_sym_break] = ACTIONS(3064),
    [anon_sym_continue] = ACTIONS(3064),
    [anon_sym_goto] = ACTIONS(3064),
    [anon_sym___try] = ACTIONS(3064),
    [anon_sym___leave] = ACTIONS(3064),
    [anon_sym_not] = ACTIONS(3064),
    [anon_sym_compl] = ACTIONS(3064),
    [anon_sym_DASH_DASH] = ACTIONS(3066),
    [anon_sym_PLUS_PLUS] = ACTIONS(3066),
    [anon_sym_sizeof] = ACTIONS(3064),
    [anon_sym___alignof__] = ACTIONS(3064),
    [anon_sym___alignof] = ACTIONS(3064),
    [anon_sym__alignof] = ACTIONS(3064),
    [anon_sym_alignof] = ACTIONS(3064),
    [anon_sym__Alignof] = ACTIONS(3064),
    [anon_sym_offsetof] = ACTIONS(3064),
    [anon_sym__Generic] = ACTIONS(3064),
    [anon_sym_asm] = ACTIONS(3064),
    [anon_sym___asm__] = ACTIONS(3064),
    [aux_sym_number_literal_token1] = ACTIONS(3066),
    [aux_sym_number_literal_token2] = ACTIONS(3064),
    [anon_sym_L_SQUOTE] = ACTIONS(3066),
    [anon_sym_u_SQUOTE] = ACTIONS(3066),
    [anon_sym_U_SQUOTE] = ACTIONS(3066),
    [anon_sym_u8_SQUOTE] = ACTIONS(3066),
    [anon_sym_SQUOTE] = ACTIONS(3066),
    [anon_sym_L_DQUOTE] = ACTIONS(3066),
    [anon_sym_u_DQUOTE] = ACTIONS(3066),
    [anon_sym_U_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8_DQUOTE] = ACTIONS(3066),
    [anon_sym_DQUOTE] = ACTIONS(3066),
    [sym_true] = ACTIONS(3064),
    [sym_false] = ACTIONS(3064),
    [anon_sym_NULL] = ACTIONS(3064),
    [anon_sym_nullptr] = ACTIONS(3064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3064),
    [anon_sym_decltype] = ACTIONS(3064),
    [anon_sym_virtual] = ACTIONS(3064),
    [anon_sym_alignas] = ACTIONS(3064),
    [anon_sym_explicit] = ACTIONS(3064),
    [anon_sym_typename] = ACTIONS(3064),
    [anon_sym_template] = ACTIONS(3064),
    [anon_sym_operator] = ACTIONS(3064),
    [anon_sym_try] = ACTIONS(3064),
    [anon_sym_delete] = ACTIONS(3064),
    [anon_sym_throw] = ACTIONS(3064),
    [anon_sym_namespace] = ACTIONS(3064),
    [anon_sym_using] = ACTIONS(3064),
    [anon_sym_static_assert] = ACTIONS(3064),
    [anon_sym_concept] = ACTIONS(3064),
    [anon_sym_co_return] = ACTIONS(3064),
    [anon_sym_co_yield] = ACTIONS(3064),
    [anon_sym_R_DQUOTE] = ACTIONS(3066),
    [anon_sym_LR_DQUOTE] = ACTIONS(3066),
    [anon_sym_uR_DQUOTE] = ACTIONS(3066),
    [anon_sym_UR_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3066),
    [anon_sym_co_await] = ACTIONS(3064),
    [anon_sym_new] = ACTIONS(3064),
    [anon_sym_requires] = ACTIONS(3064),
    [sym_this] = ACTIONS(3064),
  },
  [856] = {
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_include_token1] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token2] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_BANG] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_DASH] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym___cdecl] = ACTIONS(3068),
    [anon_sym___clrcall] = ACTIONS(3068),
    [anon_sym___stdcall] = ACTIONS(3068),
    [anon_sym___fastcall] = ACTIONS(3068),
    [anon_sym___thiscall] = ACTIONS(3068),
    [anon_sym___vectorcall] = ACTIONS(3068),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_PROGMEM] = ACTIONS(3068),
    [aux_sym_primitive_type_token1] = ACTIONS(3068),
    [anon_sym_byte] = ACTIONS(3068),
    [anon_sym_word] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3068),
    [anon_sym_else] = ACTIONS(3068),
    [anon_sym_switch] = ACTIONS(3068),
    [anon_sym_case] = ACTIONS(3068),
    [anon_sym_default] = ACTIONS(3068),
    [anon_sym_while] = ACTIONS(3068),
    [anon_sym_do] = ACTIONS(3068),
    [anon_sym_for] = ACTIONS(3068),
    [anon_sym_return] = ACTIONS(3068),
    [anon_sym_break] = ACTIONS(3068),
    [anon_sym_continue] = ACTIONS(3068),
    [anon_sym_goto] = ACTIONS(3068),
    [anon_sym___try] = ACTIONS(3068),
    [anon_sym___leave] = ACTIONS(3068),
    [anon_sym_not] = ACTIONS(3068),
    [anon_sym_compl] = ACTIONS(3068),
    [anon_sym_DASH_DASH] = ACTIONS(3070),
    [anon_sym_PLUS_PLUS] = ACTIONS(3070),
    [anon_sym_sizeof] = ACTIONS(3068),
    [anon_sym___alignof__] = ACTIONS(3068),
    [anon_sym___alignof] = ACTIONS(3068),
    [anon_sym__alignof] = ACTIONS(3068),
    [anon_sym_alignof] = ACTIONS(3068),
    [anon_sym__Alignof] = ACTIONS(3068),
    [anon_sym_offsetof] = ACTIONS(3068),
    [anon_sym__Generic] = ACTIONS(3068),
    [anon_sym_asm] = ACTIONS(3068),
    [anon_sym___asm__] = ACTIONS(3068),
    [aux_sym_number_literal_token1] = ACTIONS(3070),
    [aux_sym_number_literal_token2] = ACTIONS(3068),
    [anon_sym_L_SQUOTE] = ACTIONS(3070),
    [anon_sym_u_SQUOTE] = ACTIONS(3070),
    [anon_sym_U_SQUOTE] = ACTIONS(3070),
    [anon_sym_u8_SQUOTE] = ACTIONS(3070),
    [anon_sym_SQUOTE] = ACTIONS(3070),
    [anon_sym_L_DQUOTE] = ACTIONS(3070),
    [anon_sym_u_DQUOTE] = ACTIONS(3070),
    [anon_sym_U_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8_DQUOTE] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3070),
    [sym_true] = ACTIONS(3068),
    [sym_false] = ACTIONS(3068),
    [anon_sym_NULL] = ACTIONS(3068),
    [anon_sym_nullptr] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_try] = ACTIONS(3068),
    [anon_sym_delete] = ACTIONS(3068),
    [anon_sym_throw] = ACTIONS(3068),
    [anon_sym_namespace] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
    [anon_sym_concept] = ACTIONS(3068),
    [anon_sym_co_return] = ACTIONS(3068),
    [anon_sym_co_yield] = ACTIONS(3068),
    [anon_sym_R_DQUOTE] = ACTIONS(3070),
    [anon_sym_LR_DQUOTE] = ACTIONS(3070),
    [anon_sym_uR_DQUOTE] = ACTIONS(3070),
    [anon_sym_UR_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3070),
    [anon_sym_co_await] = ACTIONS(3068),
    [anon_sym_new] = ACTIONS(3068),
    [anon_sym_requires] = ACTIONS(3068),
    [sym_this] = ACTIONS(3068),
  },
  [857] = {
    [ts_builtin_sym_end] = ACTIONS(3164),
    [sym_identifier] = ACTIONS(3162),
    [aux_sym_preproc_include_token1] = ACTIONS(3162),
    [aux_sym_preproc_def_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token1] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3162),
    [sym_preproc_directive] = ACTIONS(3162),
    [anon_sym_LPAREN2] = ACTIONS(3164),
    [anon_sym_BANG] = ACTIONS(3164),
    [anon_sym_TILDE] = ACTIONS(3164),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_STAR] = ACTIONS(3164),
    [anon_sym_AMP_AMP] = ACTIONS(3164),
    [anon_sym_AMP] = ACTIONS(3162),
    [anon_sym_SEMI] = ACTIONS(3164),
    [anon_sym___extension__] = ACTIONS(3162),
    [anon_sym_typedef] = ACTIONS(3162),
    [anon_sym_extern] = ACTIONS(3162),
    [anon_sym___attribute__] = ACTIONS(3162),
    [anon_sym_COLON_COLON] = ACTIONS(3164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3164),
    [anon_sym___declspec] = ACTIONS(3162),
    [anon_sym___based] = ACTIONS(3162),
    [anon_sym___cdecl] = ACTIONS(3162),
    [anon_sym___clrcall] = ACTIONS(3162),
    [anon_sym___stdcall] = ACTIONS(3162),
    [anon_sym___fastcall] = ACTIONS(3162),
    [anon_sym___thiscall] = ACTIONS(3162),
    [anon_sym___vectorcall] = ACTIONS(3162),
    [anon_sym_LBRACE] = ACTIONS(3164),
    [anon_sym_signed] = ACTIONS(3162),
    [anon_sym_unsigned] = ACTIONS(3162),
    [anon_sym_long] = ACTIONS(3162),
    [anon_sym_short] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_register] = ACTIONS(3162),
    [anon_sym_inline] = ACTIONS(3162),
    [anon_sym___inline] = ACTIONS(3162),
    [anon_sym___inline__] = ACTIONS(3162),
    [anon_sym___forceinline] = ACTIONS(3162),
    [anon_sym_thread_local] = ACTIONS(3162),
    [anon_sym___thread] = ACTIONS(3162),
    [anon_sym_const] = ACTIONS(3162),
    [anon_sym_constexpr] = ACTIONS(3162),
    [anon_sym_volatile] = ACTIONS(3162),
    [anon_sym_restrict] = ACTIONS(3162),
    [anon_sym___restrict__] = ACTIONS(3162),
    [anon_sym__Atomic] = ACTIONS(3162),
    [anon_sym__Noreturn] = ACTIONS(3162),
    [anon_sym_noreturn] = ACTIONS(3162),
    [anon_sym_mutable] = ACTIONS(3162),
    [anon_sym_constinit] = ACTIONS(3162),
    [anon_sym_consteval] = ACTIONS(3162),
    [anon_sym_PROGMEM] = ACTIONS(3162),
    [aux_sym_primitive_type_token1] = ACTIONS(3162),
    [anon_sym_byte] = ACTIONS(3162),
    [anon_sym_word] = ACTIONS(3162),
    [anon_sym_enum] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_struct] = ACTIONS(3162),
    [anon_sym_union] = ACTIONS(3162),
    [anon_sym_if] = ACTIONS(3162),
    [anon_sym_else] = ACTIONS(3162),
    [anon_sym_switch] = ACTIONS(3162),
    [anon_sym_case] = ACTIONS(3162),
    [anon_sym_default] = ACTIONS(3162),
    [anon_sym_while] = ACTIONS(3162),
    [anon_sym_do] = ACTIONS(3162),
    [anon_sym_for] = ACTIONS(3162),
    [anon_sym_return] = ACTIONS(3162),
    [anon_sym_break] = ACTIONS(3162),
    [anon_sym_continue] = ACTIONS(3162),
    [anon_sym_goto] = ACTIONS(3162),
    [anon_sym___try] = ACTIONS(3162),
    [anon_sym___leave] = ACTIONS(3162),
    [anon_sym_not] = ACTIONS(3162),
    [anon_sym_compl] = ACTIONS(3162),
    [anon_sym_DASH_DASH] = ACTIONS(3164),
    [anon_sym_PLUS_PLUS] = ACTIONS(3164),
    [anon_sym_sizeof] = ACTIONS(3162),
    [anon_sym___alignof__] = ACTIONS(3162),
    [anon_sym___alignof] = ACTIONS(3162),
    [anon_sym__alignof] = ACTIONS(3162),
    [anon_sym_alignof] = ACTIONS(3162),
    [anon_sym__Alignof] = ACTIONS(3162),
    [anon_sym_offsetof] = ACTIONS(3162),
    [anon_sym__Generic] = ACTIONS(3162),
    [anon_sym_asm] = ACTIONS(3162),
    [anon_sym___asm__] = ACTIONS(3162),
    [aux_sym_number_literal_token1] = ACTIONS(3164),
    [aux_sym_number_literal_token2] = ACTIONS(3162),
    [anon_sym_L_SQUOTE] = ACTIONS(3164),
    [anon_sym_u_SQUOTE] = ACTIONS(3164),
    [anon_sym_U_SQUOTE] = ACTIONS(3164),
    [anon_sym_u8_SQUOTE] = ACTIONS(3164),
    [anon_sym_SQUOTE] = ACTIONS(3164),
    [anon_sym_L_DQUOTE] = ACTIONS(3164),
    [anon_sym_u_DQUOTE] = ACTIONS(3164),
    [anon_sym_U_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8_DQUOTE] = ACTIONS(3164),
    [anon_sym_DQUOTE] = ACTIONS(3164),
    [sym_true] = ACTIONS(3162),
    [sym_false] = ACTIONS(3162),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3162),
    [anon_sym_decltype] = ACTIONS(3162),
    [anon_sym_virtual] = ACTIONS(3162),
    [anon_sym_alignas] = ACTIONS(3162),
    [anon_sym_explicit] = ACTIONS(3162),
    [anon_sym_typename] = ACTIONS(3162),
    [anon_sym_template] = ACTIONS(3162),
    [anon_sym_operator] = ACTIONS(3162),
    [anon_sym_try] = ACTIONS(3162),
    [anon_sym_delete] = ACTIONS(3162),
    [anon_sym_throw] = ACTIONS(3162),
    [anon_sym_namespace] = ACTIONS(3162),
    [anon_sym_using] = ACTIONS(3162),
    [anon_sym_static_assert] = ACTIONS(3162),
    [anon_sym_concept] = ACTIONS(3162),
    [anon_sym_co_return] = ACTIONS(3162),
    [anon_sym_co_yield] = ACTIONS(3162),
    [anon_sym_R_DQUOTE] = ACTIONS(3164),
    [anon_sym_LR_DQUOTE] = ACTIONS(3164),
    [anon_sym_uR_DQUOTE] = ACTIONS(3164),
    [anon_sym_UR_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3164),
    [anon_sym_co_await] = ACTIONS(3162),
    [anon_sym_new] = ACTIONS(3162),
    [anon_sym_requires] = ACTIONS(3162),
    [sym_this] = ACTIONS(3162),
  },
  [858] = {
    [sym_identifier] = ACTIONS(3092),
    [aux_sym_preproc_include_token1] = ACTIONS(3092),
    [aux_sym_preproc_def_token1] = ACTIONS(3092),
    [aux_sym_preproc_if_token1] = ACTIONS(3092),
    [aux_sym_preproc_if_token2] = ACTIONS(3092),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3092),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3092),
    [sym_preproc_directive] = ACTIONS(3092),
    [anon_sym_LPAREN2] = ACTIONS(3094),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_TILDE] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_SEMI] = ACTIONS(3094),
    [anon_sym___extension__] = ACTIONS(3092),
    [anon_sym_typedef] = ACTIONS(3092),
    [anon_sym_extern] = ACTIONS(3092),
    [anon_sym___attribute__] = ACTIONS(3092),
    [anon_sym_COLON_COLON] = ACTIONS(3094),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3094),
    [anon_sym___declspec] = ACTIONS(3092),
    [anon_sym___based] = ACTIONS(3092),
    [anon_sym___cdecl] = ACTIONS(3092),
    [anon_sym___clrcall] = ACTIONS(3092),
    [anon_sym___stdcall] = ACTIONS(3092),
    [anon_sym___fastcall] = ACTIONS(3092),
    [anon_sym___thiscall] = ACTIONS(3092),
    [anon_sym___vectorcall] = ACTIONS(3092),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_signed] = ACTIONS(3092),
    [anon_sym_unsigned] = ACTIONS(3092),
    [anon_sym_long] = ACTIONS(3092),
    [anon_sym_short] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_static] = ACTIONS(3092),
    [anon_sym_register] = ACTIONS(3092),
    [anon_sym_inline] = ACTIONS(3092),
    [anon_sym___inline] = ACTIONS(3092),
    [anon_sym___inline__] = ACTIONS(3092),
    [anon_sym___forceinline] = ACTIONS(3092),
    [anon_sym_thread_local] = ACTIONS(3092),
    [anon_sym___thread] = ACTIONS(3092),
    [anon_sym_const] = ACTIONS(3092),
    [anon_sym_constexpr] = ACTIONS(3092),
    [anon_sym_volatile] = ACTIONS(3092),
    [anon_sym_restrict] = ACTIONS(3092),
    [anon_sym___restrict__] = ACTIONS(3092),
    [anon_sym__Atomic] = ACTIONS(3092),
    [anon_sym__Noreturn] = ACTIONS(3092),
    [anon_sym_noreturn] = ACTIONS(3092),
    [anon_sym_mutable] = ACTIONS(3092),
    [anon_sym_constinit] = ACTIONS(3092),
    [anon_sym_consteval] = ACTIONS(3092),
    [anon_sym_PROGMEM] = ACTIONS(3092),
    [aux_sym_primitive_type_token1] = ACTIONS(3092),
    [anon_sym_byte] = ACTIONS(3092),
    [anon_sym_word] = ACTIONS(3092),
    [anon_sym_enum] = ACTIONS(3092),
    [anon_sym_class] = ACTIONS(3092),
    [anon_sym_struct] = ACTIONS(3092),
    [anon_sym_union] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_switch] = ACTIONS(3092),
    [anon_sym_case] = ACTIONS(3092),
    [anon_sym_default] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_break] = ACTIONS(3092),
    [anon_sym_continue] = ACTIONS(3092),
    [anon_sym_goto] = ACTIONS(3092),
    [anon_sym___try] = ACTIONS(3092),
    [anon_sym___leave] = ACTIONS(3092),
    [anon_sym_not] = ACTIONS(3092),
    [anon_sym_compl] = ACTIONS(3092),
    [anon_sym_DASH_DASH] = ACTIONS(3094),
    [anon_sym_PLUS_PLUS] = ACTIONS(3094),
    [anon_sym_sizeof] = ACTIONS(3092),
    [anon_sym___alignof__] = ACTIONS(3092),
    [anon_sym___alignof] = ACTIONS(3092),
    [anon_sym__alignof] = ACTIONS(3092),
    [anon_sym_alignof] = ACTIONS(3092),
    [anon_sym__Alignof] = ACTIONS(3092),
    [anon_sym_offsetof] = ACTIONS(3092),
    [anon_sym__Generic] = ACTIONS(3092),
    [anon_sym_asm] = ACTIONS(3092),
    [anon_sym___asm__] = ACTIONS(3092),
    [aux_sym_number_literal_token1] = ACTIONS(3094),
    [aux_sym_number_literal_token2] = ACTIONS(3092),
    [anon_sym_L_SQUOTE] = ACTIONS(3094),
    [anon_sym_u_SQUOTE] = ACTIONS(3094),
    [anon_sym_U_SQUOTE] = ACTIONS(3094),
    [anon_sym_u8_SQUOTE] = ACTIONS(3094),
    [anon_sym_SQUOTE] = ACTIONS(3094),
    [anon_sym_L_DQUOTE] = ACTIONS(3094),
    [anon_sym_u_DQUOTE] = ACTIONS(3094),
    [anon_sym_U_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8_DQUOTE] = ACTIONS(3094),
    [anon_sym_DQUOTE] = ACTIONS(3094),
    [sym_true] = ACTIONS(3092),
    [sym_false] = ACTIONS(3092),
    [anon_sym_NULL] = ACTIONS(3092),
    [anon_sym_nullptr] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3092),
    [anon_sym_decltype] = ACTIONS(3092),
    [anon_sym_virtual] = ACTIONS(3092),
    [anon_sym_alignas] = ACTIONS(3092),
    [anon_sym_explicit] = ACTIONS(3092),
    [anon_sym_typename] = ACTIONS(3092),
    [anon_sym_template] = ACTIONS(3092),
    [anon_sym_operator] = ACTIONS(3092),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_delete] = ACTIONS(3092),
    [anon_sym_throw] = ACTIONS(3092),
    [anon_sym_namespace] = ACTIONS(3092),
    [anon_sym_using] = ACTIONS(3092),
    [anon_sym_static_assert] = ACTIONS(3092),
    [anon_sym_concept] = ACTIONS(3092),
    [anon_sym_co_return] = ACTIONS(3092),
    [anon_sym_co_yield] = ACTIONS(3092),
    [anon_sym_R_DQUOTE] = ACTIONS(3094),
    [anon_sym_LR_DQUOTE] = ACTIONS(3094),
    [anon_sym_uR_DQUOTE] = ACTIONS(3094),
    [anon_sym_UR_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3094),
    [anon_sym_co_await] = ACTIONS(3092),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_requires] = ACTIONS(3092),
    [sym_this] = ACTIONS(3092),
  },
  [859] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_include_token1] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [anon_sym_COMMA] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_BANG] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym___cdecl] = ACTIONS(2267),
    [anon_sym___clrcall] = ACTIONS(2267),
    [anon_sym___stdcall] = ACTIONS(2267),
    [anon_sym___fastcall] = ACTIONS(2267),
    [anon_sym___thiscall] = ACTIONS(2267),
    [anon_sym___vectorcall] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2265),
    [anon_sym_RBRACE] = ACTIONS(2265),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_case] = ACTIONS(2267),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_return] = ACTIONS(2267),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_continue] = ACTIONS(2267),
    [anon_sym_goto] = ACTIONS(2267),
    [anon_sym___try] = ACTIONS(2267),
    [anon_sym___leave] = ACTIONS(2267),
    [anon_sym_not] = ACTIONS(2267),
    [anon_sym_compl] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2265),
    [anon_sym_PLUS_PLUS] = ACTIONS(2265),
    [anon_sym_sizeof] = ACTIONS(2267),
    [anon_sym___alignof__] = ACTIONS(2267),
    [anon_sym___alignof] = ACTIONS(2267),
    [anon_sym__alignof] = ACTIONS(2267),
    [anon_sym_alignof] = ACTIONS(2267),
    [anon_sym__Alignof] = ACTIONS(2267),
    [anon_sym_offsetof] = ACTIONS(2267),
    [anon_sym__Generic] = ACTIONS(2267),
    [anon_sym_asm] = ACTIONS(2267),
    [anon_sym___asm__] = ACTIONS(2267),
    [aux_sym_number_literal_token1] = ACTIONS(2265),
    [aux_sym_number_literal_token2] = ACTIONS(2267),
    [anon_sym_L_SQUOTE] = ACTIONS(2265),
    [anon_sym_u_SQUOTE] = ACTIONS(2265),
    [anon_sym_U_SQUOTE] = ACTIONS(2265),
    [anon_sym_u8_SQUOTE] = ACTIONS(2265),
    [anon_sym_SQUOTE] = ACTIONS(2265),
    [anon_sym_L_DQUOTE] = ACTIONS(2265),
    [anon_sym_u_DQUOTE] = ACTIONS(2265),
    [anon_sym_U_DQUOTE] = ACTIONS(2265),
    [anon_sym_u8_DQUOTE] = ACTIONS(2265),
    [anon_sym_DQUOTE] = ACTIONS(2265),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [anon_sym_NULL] = ACTIONS(2267),
    [anon_sym_nullptr] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_try] = ACTIONS(2267),
    [anon_sym_delete] = ACTIONS(2267),
    [anon_sym_throw] = ACTIONS(2267),
    [anon_sym_namespace] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym_concept] = ACTIONS(2267),
    [anon_sym_co_return] = ACTIONS(2267),
    [anon_sym_co_yield] = ACTIONS(2267),
    [anon_sym_R_DQUOTE] = ACTIONS(2265),
    [anon_sym_LR_DQUOTE] = ACTIONS(2265),
    [anon_sym_uR_DQUOTE] = ACTIONS(2265),
    [anon_sym_UR_DQUOTE] = ACTIONS(2265),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2265),
    [anon_sym_co_await] = ACTIONS(2267),
    [anon_sym_new] = ACTIONS(2267),
    [anon_sym_requires] = ACTIONS(2267),
    [sym_this] = ACTIONS(2267),
  },
  [860] = {
    [sym_identifier] = ACTIONS(2970),
    [aux_sym_preproc_include_token1] = ACTIONS(2970),
    [aux_sym_preproc_def_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token2] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2970),
    [sym_preproc_directive] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_BANG] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym___extension__] = ACTIONS(2970),
    [anon_sym_typedef] = ACTIONS(2970),
    [anon_sym_extern] = ACTIONS(2970),
    [anon_sym___attribute__] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2970),
    [anon_sym___based] = ACTIONS(2970),
    [anon_sym___cdecl] = ACTIONS(2970),
    [anon_sym___clrcall] = ACTIONS(2970),
    [anon_sym___stdcall] = ACTIONS(2970),
    [anon_sym___fastcall] = ACTIONS(2970),
    [anon_sym___thiscall] = ACTIONS(2970),
    [anon_sym___vectorcall] = ACTIONS(2970),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_signed] = ACTIONS(2970),
    [anon_sym_unsigned] = ACTIONS(2970),
    [anon_sym_long] = ACTIONS(2970),
    [anon_sym_short] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_register] = ACTIONS(2970),
    [anon_sym_inline] = ACTIONS(2970),
    [anon_sym___inline] = ACTIONS(2970),
    [anon_sym___inline__] = ACTIONS(2970),
    [anon_sym___forceinline] = ACTIONS(2970),
    [anon_sym_thread_local] = ACTIONS(2970),
    [anon_sym___thread] = ACTIONS(2970),
    [anon_sym_const] = ACTIONS(2970),
    [anon_sym_constexpr] = ACTIONS(2970),
    [anon_sym_volatile] = ACTIONS(2970),
    [anon_sym_restrict] = ACTIONS(2970),
    [anon_sym___restrict__] = ACTIONS(2970),
    [anon_sym__Atomic] = ACTIONS(2970),
    [anon_sym__Noreturn] = ACTIONS(2970),
    [anon_sym_noreturn] = ACTIONS(2970),
    [anon_sym_mutable] = ACTIONS(2970),
    [anon_sym_constinit] = ACTIONS(2970),
    [anon_sym_consteval] = ACTIONS(2970),
    [anon_sym_PROGMEM] = ACTIONS(2970),
    [aux_sym_primitive_type_token1] = ACTIONS(2970),
    [anon_sym_byte] = ACTIONS(2970),
    [anon_sym_word] = ACTIONS(2970),
    [anon_sym_enum] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_struct] = ACTIONS(2970),
    [anon_sym_union] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_else] = ACTIONS(2970),
    [anon_sym_switch] = ACTIONS(2970),
    [anon_sym_case] = ACTIONS(2970),
    [anon_sym_default] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_break] = ACTIONS(2970),
    [anon_sym_continue] = ACTIONS(2970),
    [anon_sym_goto] = ACTIONS(2970),
    [anon_sym___try] = ACTIONS(2970),
    [anon_sym___leave] = ACTIONS(2970),
    [anon_sym_not] = ACTIONS(2970),
    [anon_sym_compl] = ACTIONS(2970),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_sizeof] = ACTIONS(2970),
    [anon_sym___alignof__] = ACTIONS(2970),
    [anon_sym___alignof] = ACTIONS(2970),
    [anon_sym__alignof] = ACTIONS(2970),
    [anon_sym_alignof] = ACTIONS(2970),
    [anon_sym__Alignof] = ACTIONS(2970),
    [anon_sym_offsetof] = ACTIONS(2970),
    [anon_sym__Generic] = ACTIONS(2970),
    [anon_sym_asm] = ACTIONS(2970),
    [anon_sym___asm__] = ACTIONS(2970),
    [aux_sym_number_literal_token1] = ACTIONS(2972),
    [aux_sym_number_literal_token2] = ACTIONS(2970),
    [anon_sym_L_SQUOTE] = ACTIONS(2972),
    [anon_sym_u_SQUOTE] = ACTIONS(2972),
    [anon_sym_U_SQUOTE] = ACTIONS(2972),
    [anon_sym_u8_SQUOTE] = ACTIONS(2972),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [anon_sym_L_DQUOTE] = ACTIONS(2972),
    [anon_sym_u_DQUOTE] = ACTIONS(2972),
    [anon_sym_U_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE] = ACTIONS(2972),
    [sym_true] = ACTIONS(2970),
    [sym_false] = ACTIONS(2970),
    [anon_sym_NULL] = ACTIONS(2970),
    [anon_sym_nullptr] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2970),
    [anon_sym_decltype] = ACTIONS(2970),
    [anon_sym_virtual] = ACTIONS(2970),
    [anon_sym_alignas] = ACTIONS(2970),
    [anon_sym_explicit] = ACTIONS(2970),
    [anon_sym_typename] = ACTIONS(2970),
    [anon_sym_template] = ACTIONS(2970),
    [anon_sym_operator] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_delete] = ACTIONS(2970),
    [anon_sym_throw] = ACTIONS(2970),
    [anon_sym_namespace] = ACTIONS(2970),
    [anon_sym_using] = ACTIONS(2970),
    [anon_sym_static_assert] = ACTIONS(2970),
    [anon_sym_concept] = ACTIONS(2970),
    [anon_sym_co_return] = ACTIONS(2970),
    [anon_sym_co_yield] = ACTIONS(2970),
    [anon_sym_R_DQUOTE] = ACTIONS(2972),
    [anon_sym_LR_DQUOTE] = ACTIONS(2972),
    [anon_sym_uR_DQUOTE] = ACTIONS(2972),
    [anon_sym_UR_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2972),
    [anon_sym_co_await] = ACTIONS(2970),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_requires] = ACTIONS(2970),
    [sym_this] = ACTIONS(2970),
  },
  [861] = {
    [sym_identifier] = ACTIONS(2966),
    [aux_sym_preproc_include_token1] = ACTIONS(2966),
    [aux_sym_preproc_def_token1] = ACTIONS(2966),
    [aux_sym_preproc_if_token1] = ACTIONS(2966),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2966),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2966),
    [sym_preproc_directive] = ACTIONS(2966),
    [anon_sym_LPAREN2] = ACTIONS(2968),
    [anon_sym_BANG] = ACTIONS(2968),
    [anon_sym_TILDE] = ACTIONS(2968),
    [anon_sym_DASH] = ACTIONS(2966),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_STAR] = ACTIONS(2968),
    [anon_sym_AMP_AMP] = ACTIONS(2968),
    [anon_sym_AMP] = ACTIONS(2966),
    [anon_sym_SEMI] = ACTIONS(2968),
    [anon_sym___extension__] = ACTIONS(2966),
    [anon_sym_typedef] = ACTIONS(2966),
    [anon_sym_extern] = ACTIONS(2966),
    [anon_sym___attribute__] = ACTIONS(2966),
    [anon_sym_COLON_COLON] = ACTIONS(2968),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2968),
    [anon_sym___declspec] = ACTIONS(2966),
    [anon_sym___based] = ACTIONS(2966),
    [anon_sym___cdecl] = ACTIONS(2966),
    [anon_sym___clrcall] = ACTIONS(2966),
    [anon_sym___stdcall] = ACTIONS(2966),
    [anon_sym___fastcall] = ACTIONS(2966),
    [anon_sym___thiscall] = ACTIONS(2966),
    [anon_sym___vectorcall] = ACTIONS(2966),
    [anon_sym_LBRACE] = ACTIONS(2968),
    [anon_sym_RBRACE] = ACTIONS(2968),
    [anon_sym_signed] = ACTIONS(2966),
    [anon_sym_unsigned] = ACTIONS(2966),
    [anon_sym_long] = ACTIONS(2966),
    [anon_sym_short] = ACTIONS(2966),
    [anon_sym_LBRACK] = ACTIONS(2966),
    [anon_sym_static] = ACTIONS(2966),
    [anon_sym_register] = ACTIONS(2966),
    [anon_sym_inline] = ACTIONS(2966),
    [anon_sym___inline] = ACTIONS(2966),
    [anon_sym___inline__] = ACTIONS(2966),
    [anon_sym___forceinline] = ACTIONS(2966),
    [anon_sym_thread_local] = ACTIONS(2966),
    [anon_sym___thread] = ACTIONS(2966),
    [anon_sym_const] = ACTIONS(2966),
    [anon_sym_constexpr] = ACTIONS(2966),
    [anon_sym_volatile] = ACTIONS(2966),
    [anon_sym_restrict] = ACTIONS(2966),
    [anon_sym___restrict__] = ACTIONS(2966),
    [anon_sym__Atomic] = ACTIONS(2966),
    [anon_sym__Noreturn] = ACTIONS(2966),
    [anon_sym_noreturn] = ACTIONS(2966),
    [anon_sym_mutable] = ACTIONS(2966),
    [anon_sym_constinit] = ACTIONS(2966),
    [anon_sym_consteval] = ACTIONS(2966),
    [anon_sym_PROGMEM] = ACTIONS(2966),
    [aux_sym_primitive_type_token1] = ACTIONS(2966),
    [anon_sym_byte] = ACTIONS(2966),
    [anon_sym_word] = ACTIONS(2966),
    [anon_sym_enum] = ACTIONS(2966),
    [anon_sym_class] = ACTIONS(2966),
    [anon_sym_struct] = ACTIONS(2966),
    [anon_sym_union] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_else] = ACTIONS(2966),
    [anon_sym_switch] = ACTIONS(2966),
    [anon_sym_case] = ACTIONS(2966),
    [anon_sym_default] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_for] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2966),
    [anon_sym_break] = ACTIONS(2966),
    [anon_sym_continue] = ACTIONS(2966),
    [anon_sym_goto] = ACTIONS(2966),
    [anon_sym___try] = ACTIONS(2966),
    [anon_sym___leave] = ACTIONS(2966),
    [anon_sym_not] = ACTIONS(2966),
    [anon_sym_compl] = ACTIONS(2966),
    [anon_sym_DASH_DASH] = ACTIONS(2968),
    [anon_sym_PLUS_PLUS] = ACTIONS(2968),
    [anon_sym_sizeof] = ACTIONS(2966),
    [anon_sym___alignof__] = ACTIONS(2966),
    [anon_sym___alignof] = ACTIONS(2966),
    [anon_sym__alignof] = ACTIONS(2966),
    [anon_sym_alignof] = ACTIONS(2966),
    [anon_sym__Alignof] = ACTIONS(2966),
    [anon_sym_offsetof] = ACTIONS(2966),
    [anon_sym__Generic] = ACTIONS(2966),
    [anon_sym_asm] = ACTIONS(2966),
    [anon_sym___asm__] = ACTIONS(2966),
    [aux_sym_number_literal_token1] = ACTIONS(2968),
    [aux_sym_number_literal_token2] = ACTIONS(2966),
    [anon_sym_L_SQUOTE] = ACTIONS(2968),
    [anon_sym_u_SQUOTE] = ACTIONS(2968),
    [anon_sym_U_SQUOTE] = ACTIONS(2968),
    [anon_sym_u8_SQUOTE] = ACTIONS(2968),
    [anon_sym_SQUOTE] = ACTIONS(2968),
    [anon_sym_L_DQUOTE] = ACTIONS(2968),
    [anon_sym_u_DQUOTE] = ACTIONS(2968),
    [anon_sym_U_DQUOTE] = ACTIONS(2968),
    [anon_sym_u8_DQUOTE] = ACTIONS(2968),
    [anon_sym_DQUOTE] = ACTIONS(2968),
    [sym_true] = ACTIONS(2966),
    [sym_false] = ACTIONS(2966),
    [anon_sym_NULL] = ACTIONS(2966),
    [anon_sym_nullptr] = ACTIONS(2966),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2966),
    [anon_sym_decltype] = ACTIONS(2966),
    [anon_sym_virtual] = ACTIONS(2966),
    [anon_sym_alignas] = ACTIONS(2966),
    [anon_sym_explicit] = ACTIONS(2966),
    [anon_sym_typename] = ACTIONS(2966),
    [anon_sym_template] = ACTIONS(2966),
    [anon_sym_operator] = ACTIONS(2966),
    [anon_sym_try] = ACTIONS(2966),
    [anon_sym_delete] = ACTIONS(2966),
    [anon_sym_throw] = ACTIONS(2966),
    [anon_sym_namespace] = ACTIONS(2966),
    [anon_sym_using] = ACTIONS(2966),
    [anon_sym_static_assert] = ACTIONS(2966),
    [anon_sym_concept] = ACTIONS(2966),
    [anon_sym_co_return] = ACTIONS(2966),
    [anon_sym_co_yield] = ACTIONS(2966),
    [anon_sym_R_DQUOTE] = ACTIONS(2968),
    [anon_sym_LR_DQUOTE] = ACTIONS(2968),
    [anon_sym_uR_DQUOTE] = ACTIONS(2968),
    [anon_sym_UR_DQUOTE] = ACTIONS(2968),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2968),
    [anon_sym_co_await] = ACTIONS(2966),
    [anon_sym_new] = ACTIONS(2966),
    [anon_sym_requires] = ACTIONS(2966),
    [sym_this] = ACTIONS(2966),
  },
  [862] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_include_token1] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token2] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym___cdecl] = ACTIONS(3082),
    [anon_sym___clrcall] = ACTIONS(3082),
    [anon_sym___stdcall] = ACTIONS(3082),
    [anon_sym___fastcall] = ACTIONS(3082),
    [anon_sym___thiscall] = ACTIONS(3082),
    [anon_sym___vectorcall] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_else] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_goto] = ACTIONS(3082),
    [anon_sym___try] = ACTIONS(3082),
    [anon_sym___leave] = ACTIONS(3082),
    [anon_sym_not] = ACTIONS(3082),
    [anon_sym_compl] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_sizeof] = ACTIONS(3082),
    [anon_sym___alignof__] = ACTIONS(3082),
    [anon_sym___alignof] = ACTIONS(3082),
    [anon_sym__alignof] = ACTIONS(3082),
    [anon_sym_alignof] = ACTIONS(3082),
    [anon_sym__Alignof] = ACTIONS(3082),
    [anon_sym_offsetof] = ACTIONS(3082),
    [anon_sym__Generic] = ACTIONS(3082),
    [anon_sym_asm] = ACTIONS(3082),
    [anon_sym___asm__] = ACTIONS(3082),
    [aux_sym_number_literal_token1] = ACTIONS(3084),
    [aux_sym_number_literal_token2] = ACTIONS(3082),
    [anon_sym_L_SQUOTE] = ACTIONS(3084),
    [anon_sym_u_SQUOTE] = ACTIONS(3084),
    [anon_sym_U_SQUOTE] = ACTIONS(3084),
    [anon_sym_u8_SQUOTE] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_L_DQUOTE] = ACTIONS(3084),
    [anon_sym_u_DQUOTE] = ACTIONS(3084),
    [anon_sym_U_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8_DQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [anon_sym_NULL] = ACTIONS(3082),
    [anon_sym_nullptr] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
    [anon_sym_concept] = ACTIONS(3082),
    [anon_sym_co_return] = ACTIONS(3082),
    [anon_sym_co_yield] = ACTIONS(3082),
    [anon_sym_R_DQUOTE] = ACTIONS(3084),
    [anon_sym_LR_DQUOTE] = ACTIONS(3084),
    [anon_sym_uR_DQUOTE] = ACTIONS(3084),
    [anon_sym_UR_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3084),
    [anon_sym_co_await] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_requires] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
  },
  [863] = {
    [sym_identifier] = ACTIONS(3078),
    [aux_sym_preproc_include_token1] = ACTIONS(3078),
    [aux_sym_preproc_def_token1] = ACTIONS(3078),
    [aux_sym_preproc_if_token1] = ACTIONS(3078),
    [aux_sym_preproc_if_token2] = ACTIONS(3078),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3078),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3078),
    [sym_preproc_directive] = ACTIONS(3078),
    [anon_sym_LPAREN2] = ACTIONS(3080),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_TILDE] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3078),
    [anon_sym_PLUS] = ACTIONS(3078),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3080),
    [anon_sym_AMP] = ACTIONS(3078),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym___extension__] = ACTIONS(3078),
    [anon_sym_typedef] = ACTIONS(3078),
    [anon_sym_extern] = ACTIONS(3078),
    [anon_sym___attribute__] = ACTIONS(3078),
    [anon_sym_COLON_COLON] = ACTIONS(3080),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3080),
    [anon_sym___declspec] = ACTIONS(3078),
    [anon_sym___based] = ACTIONS(3078),
    [anon_sym___cdecl] = ACTIONS(3078),
    [anon_sym___clrcall] = ACTIONS(3078),
    [anon_sym___stdcall] = ACTIONS(3078),
    [anon_sym___fastcall] = ACTIONS(3078),
    [anon_sym___thiscall] = ACTIONS(3078),
    [anon_sym___vectorcall] = ACTIONS(3078),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_signed] = ACTIONS(3078),
    [anon_sym_unsigned] = ACTIONS(3078),
    [anon_sym_long] = ACTIONS(3078),
    [anon_sym_short] = ACTIONS(3078),
    [anon_sym_LBRACK] = ACTIONS(3078),
    [anon_sym_static] = ACTIONS(3078),
    [anon_sym_register] = ACTIONS(3078),
    [anon_sym_inline] = ACTIONS(3078),
    [anon_sym___inline] = ACTIONS(3078),
    [anon_sym___inline__] = ACTIONS(3078),
    [anon_sym___forceinline] = ACTIONS(3078),
    [anon_sym_thread_local] = ACTIONS(3078),
    [anon_sym___thread] = ACTIONS(3078),
    [anon_sym_const] = ACTIONS(3078),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(3078),
    [anon_sym_restrict] = ACTIONS(3078),
    [anon_sym___restrict__] = ACTIONS(3078),
    [anon_sym__Atomic] = ACTIONS(3078),
    [anon_sym__Noreturn] = ACTIONS(3078),
    [anon_sym_noreturn] = ACTIONS(3078),
    [anon_sym_mutable] = ACTIONS(3078),
    [anon_sym_constinit] = ACTIONS(3078),
    [anon_sym_consteval] = ACTIONS(3078),
    [anon_sym_PROGMEM] = ACTIONS(3078),
    [aux_sym_primitive_type_token1] = ACTIONS(3078),
    [anon_sym_byte] = ACTIONS(3078),
    [anon_sym_word] = ACTIONS(3078),
    [anon_sym_enum] = ACTIONS(3078),
    [anon_sym_class] = ACTIONS(3078),
    [anon_sym_struct] = ACTIONS(3078),
    [anon_sym_union] = ACTIONS(3078),
    [anon_sym_if] = ACTIONS(3078),
    [anon_sym_else] = ACTIONS(3078),
    [anon_sym_switch] = ACTIONS(3078),
    [anon_sym_case] = ACTIONS(3078),
    [anon_sym_default] = ACTIONS(3078),
    [anon_sym_while] = ACTIONS(3078),
    [anon_sym_do] = ACTIONS(3078),
    [anon_sym_for] = ACTIONS(3078),
    [anon_sym_return] = ACTIONS(3078),
    [anon_sym_break] = ACTIONS(3078),
    [anon_sym_continue] = ACTIONS(3078),
    [anon_sym_goto] = ACTIONS(3078),
    [anon_sym___try] = ACTIONS(3078),
    [anon_sym___leave] = ACTIONS(3078),
    [anon_sym_not] = ACTIONS(3078),
    [anon_sym_compl] = ACTIONS(3078),
    [anon_sym_DASH_DASH] = ACTIONS(3080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3080),
    [anon_sym_sizeof] = ACTIONS(3078),
    [anon_sym___alignof__] = ACTIONS(3078),
    [anon_sym___alignof] = ACTIONS(3078),
    [anon_sym__alignof] = ACTIONS(3078),
    [anon_sym_alignof] = ACTIONS(3078),
    [anon_sym__Alignof] = ACTIONS(3078),
    [anon_sym_offsetof] = ACTIONS(3078),
    [anon_sym__Generic] = ACTIONS(3078),
    [anon_sym_asm] = ACTIONS(3078),
    [anon_sym___asm__] = ACTIONS(3078),
    [aux_sym_number_literal_token1] = ACTIONS(3080),
    [aux_sym_number_literal_token2] = ACTIONS(3078),
    [anon_sym_L_SQUOTE] = ACTIONS(3080),
    [anon_sym_u_SQUOTE] = ACTIONS(3080),
    [anon_sym_U_SQUOTE] = ACTIONS(3080),
    [anon_sym_u8_SQUOTE] = ACTIONS(3080),
    [anon_sym_SQUOTE] = ACTIONS(3080),
    [anon_sym_L_DQUOTE] = ACTIONS(3080),
    [anon_sym_u_DQUOTE] = ACTIONS(3080),
    [anon_sym_U_DQUOTE] = ACTIONS(3080),
    [anon_sym_u8_DQUOTE] = ACTIONS(3080),
    [anon_sym_DQUOTE] = ACTIONS(3080),
    [sym_true] = ACTIONS(3078),
    [sym_false] = ACTIONS(3078),
    [anon_sym_NULL] = ACTIONS(3078),
    [anon_sym_nullptr] = ACTIONS(3078),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3078),
    [anon_sym_decltype] = ACTIONS(3078),
    [anon_sym_virtual] = ACTIONS(3078),
    [anon_sym_alignas] = ACTIONS(3078),
    [anon_sym_explicit] = ACTIONS(3078),
    [anon_sym_typename] = ACTIONS(3078),
    [anon_sym_template] = ACTIONS(3078),
    [anon_sym_operator] = ACTIONS(3078),
    [anon_sym_try] = ACTIONS(3078),
    [anon_sym_delete] = ACTIONS(3078),
    [anon_sym_throw] = ACTIONS(3078),
    [anon_sym_namespace] = ACTIONS(3078),
    [anon_sym_using] = ACTIONS(3078),
    [anon_sym_static_assert] = ACTIONS(3078),
    [anon_sym_concept] = ACTIONS(3078),
    [anon_sym_co_return] = ACTIONS(3078),
    [anon_sym_co_yield] = ACTIONS(3078),
    [anon_sym_R_DQUOTE] = ACTIONS(3080),
    [anon_sym_LR_DQUOTE] = ACTIONS(3080),
    [anon_sym_uR_DQUOTE] = ACTIONS(3080),
    [anon_sym_UR_DQUOTE] = ACTIONS(3080),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3080),
    [anon_sym_co_await] = ACTIONS(3078),
    [anon_sym_new] = ACTIONS(3078),
    [anon_sym_requires] = ACTIONS(3078),
    [sym_this] = ACTIONS(3078),
  },
  [864] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_include_token1] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token2] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym___cdecl] = ACTIONS(3082),
    [anon_sym___clrcall] = ACTIONS(3082),
    [anon_sym___stdcall] = ACTIONS(3082),
    [anon_sym___fastcall] = ACTIONS(3082),
    [anon_sym___thiscall] = ACTIONS(3082),
    [anon_sym___vectorcall] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_else] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_goto] = ACTIONS(3082),
    [anon_sym___try] = ACTIONS(3082),
    [anon_sym___leave] = ACTIONS(3082),
    [anon_sym_not] = ACTIONS(3082),
    [anon_sym_compl] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_sizeof] = ACTIONS(3082),
    [anon_sym___alignof__] = ACTIONS(3082),
    [anon_sym___alignof] = ACTIONS(3082),
    [anon_sym__alignof] = ACTIONS(3082),
    [anon_sym_alignof] = ACTIONS(3082),
    [anon_sym__Alignof] = ACTIONS(3082),
    [anon_sym_offsetof] = ACTIONS(3082),
    [anon_sym__Generic] = ACTIONS(3082),
    [anon_sym_asm] = ACTIONS(3082),
    [anon_sym___asm__] = ACTIONS(3082),
    [aux_sym_number_literal_token1] = ACTIONS(3084),
    [aux_sym_number_literal_token2] = ACTIONS(3082),
    [anon_sym_L_SQUOTE] = ACTIONS(3084),
    [anon_sym_u_SQUOTE] = ACTIONS(3084),
    [anon_sym_U_SQUOTE] = ACTIONS(3084),
    [anon_sym_u8_SQUOTE] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_L_DQUOTE] = ACTIONS(3084),
    [anon_sym_u_DQUOTE] = ACTIONS(3084),
    [anon_sym_U_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8_DQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [anon_sym_NULL] = ACTIONS(3082),
    [anon_sym_nullptr] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
    [anon_sym_concept] = ACTIONS(3082),
    [anon_sym_co_return] = ACTIONS(3082),
    [anon_sym_co_yield] = ACTIONS(3082),
    [anon_sym_R_DQUOTE] = ACTIONS(3084),
    [anon_sym_LR_DQUOTE] = ACTIONS(3084),
    [anon_sym_uR_DQUOTE] = ACTIONS(3084),
    [anon_sym_UR_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3084),
    [anon_sym_co_await] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_requires] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
  },
  [865] = {
    [sym_identifier] = ACTIONS(3332),
    [aux_sym_preproc_include_token1] = ACTIONS(3332),
    [aux_sym_preproc_def_token1] = ACTIONS(3332),
    [aux_sym_preproc_if_token1] = ACTIONS(3332),
    [aux_sym_preproc_if_token2] = ACTIONS(3332),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3332),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3332),
    [sym_preproc_directive] = ACTIONS(3332),
    [anon_sym_LPAREN2] = ACTIONS(3334),
    [anon_sym_BANG] = ACTIONS(3334),
    [anon_sym_TILDE] = ACTIONS(3334),
    [anon_sym_DASH] = ACTIONS(3332),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_STAR] = ACTIONS(3334),
    [anon_sym_AMP_AMP] = ACTIONS(3334),
    [anon_sym_AMP] = ACTIONS(3332),
    [anon_sym_SEMI] = ACTIONS(3334),
    [anon_sym___extension__] = ACTIONS(3332),
    [anon_sym_typedef] = ACTIONS(3332),
    [anon_sym_extern] = ACTIONS(3332),
    [anon_sym___attribute__] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(3334),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3334),
    [anon_sym___declspec] = ACTIONS(3332),
    [anon_sym___based] = ACTIONS(3332),
    [anon_sym___cdecl] = ACTIONS(3332),
    [anon_sym___clrcall] = ACTIONS(3332),
    [anon_sym___stdcall] = ACTIONS(3332),
    [anon_sym___fastcall] = ACTIONS(3332),
    [anon_sym___thiscall] = ACTIONS(3332),
    [anon_sym___vectorcall] = ACTIONS(3332),
    [anon_sym_LBRACE] = ACTIONS(3334),
    [anon_sym_signed] = ACTIONS(3332),
    [anon_sym_unsigned] = ACTIONS(3332),
    [anon_sym_long] = ACTIONS(3332),
    [anon_sym_short] = ACTIONS(3332),
    [anon_sym_LBRACK] = ACTIONS(3332),
    [anon_sym_static] = ACTIONS(3332),
    [anon_sym_register] = ACTIONS(3332),
    [anon_sym_inline] = ACTIONS(3332),
    [anon_sym___inline] = ACTIONS(3332),
    [anon_sym___inline__] = ACTIONS(3332),
    [anon_sym___forceinline] = ACTIONS(3332),
    [anon_sym_thread_local] = ACTIONS(3332),
    [anon_sym___thread] = ACTIONS(3332),
    [anon_sym_const] = ACTIONS(3332),
    [anon_sym_constexpr] = ACTIONS(3332),
    [anon_sym_volatile] = ACTIONS(3332),
    [anon_sym_restrict] = ACTIONS(3332),
    [anon_sym___restrict__] = ACTIONS(3332),
    [anon_sym__Atomic] = ACTIONS(3332),
    [anon_sym__Noreturn] = ACTIONS(3332),
    [anon_sym_noreturn] = ACTIONS(3332),
    [anon_sym_mutable] = ACTIONS(3332),
    [anon_sym_constinit] = ACTIONS(3332),
    [anon_sym_consteval] = ACTIONS(3332),
    [anon_sym_PROGMEM] = ACTIONS(3332),
    [aux_sym_primitive_type_token1] = ACTIONS(3332),
    [anon_sym_byte] = ACTIONS(3332),
    [anon_sym_word] = ACTIONS(3332),
    [anon_sym_enum] = ACTIONS(3332),
    [anon_sym_class] = ACTIONS(3332),
    [anon_sym_struct] = ACTIONS(3332),
    [anon_sym_union] = ACTIONS(3332),
    [anon_sym_if] = ACTIONS(3332),
    [anon_sym_switch] = ACTIONS(3332),
    [anon_sym_case] = ACTIONS(3332),
    [anon_sym_default] = ACTIONS(3332),
    [anon_sym_while] = ACTIONS(3332),
    [anon_sym_do] = ACTIONS(3332),
    [anon_sym_for] = ACTIONS(3332),
    [anon_sym_return] = ACTIONS(3332),
    [anon_sym_break] = ACTIONS(3332),
    [anon_sym_continue] = ACTIONS(3332),
    [anon_sym_goto] = ACTIONS(3332),
    [anon_sym___try] = ACTIONS(3332),
    [anon_sym___leave] = ACTIONS(3332),
    [anon_sym_not] = ACTIONS(3332),
    [anon_sym_compl] = ACTIONS(3332),
    [anon_sym_DASH_DASH] = ACTIONS(3334),
    [anon_sym_PLUS_PLUS] = ACTIONS(3334),
    [anon_sym_sizeof] = ACTIONS(3332),
    [anon_sym___alignof__] = ACTIONS(3332),
    [anon_sym___alignof] = ACTIONS(3332),
    [anon_sym__alignof] = ACTIONS(3332),
    [anon_sym_alignof] = ACTIONS(3332),
    [anon_sym__Alignof] = ACTIONS(3332),
    [anon_sym_offsetof] = ACTIONS(3332),
    [anon_sym__Generic] = ACTIONS(3332),
    [anon_sym_asm] = ACTIONS(3332),
    [anon_sym___asm__] = ACTIONS(3332),
    [aux_sym_number_literal_token1] = ACTIONS(3334),
    [aux_sym_number_literal_token2] = ACTIONS(3332),
    [anon_sym_L_SQUOTE] = ACTIONS(3334),
    [anon_sym_u_SQUOTE] = ACTIONS(3334),
    [anon_sym_U_SQUOTE] = ACTIONS(3334),
    [anon_sym_u8_SQUOTE] = ACTIONS(3334),
    [anon_sym_SQUOTE] = ACTIONS(3334),
    [anon_sym_L_DQUOTE] = ACTIONS(3334),
    [anon_sym_u_DQUOTE] = ACTIONS(3334),
    [anon_sym_U_DQUOTE] = ACTIONS(3334),
    [anon_sym_u8_DQUOTE] = ACTIONS(3334),
    [anon_sym_DQUOTE] = ACTIONS(3334),
    [sym_true] = ACTIONS(3332),
    [sym_false] = ACTIONS(3332),
    [anon_sym_NULL] = ACTIONS(3332),
    [anon_sym_nullptr] = ACTIONS(3332),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3332),
    [anon_sym_decltype] = ACTIONS(3332),
    [anon_sym_virtual] = ACTIONS(3332),
    [anon_sym_alignas] = ACTIONS(3332),
    [anon_sym_explicit] = ACTIONS(3332),
    [anon_sym_typename] = ACTIONS(3332),
    [anon_sym_template] = ACTIONS(3332),
    [anon_sym_operator] = ACTIONS(3332),
    [anon_sym_try] = ACTIONS(3332),
    [anon_sym_delete] = ACTIONS(3332),
    [anon_sym_throw] = ACTIONS(3332),
    [anon_sym_namespace] = ACTIONS(3332),
    [anon_sym_using] = ACTIONS(3332),
    [anon_sym_static_assert] = ACTIONS(3332),
    [anon_sym_concept] = ACTIONS(3332),
    [anon_sym_co_return] = ACTIONS(3332),
    [anon_sym_co_yield] = ACTIONS(3332),
    [anon_sym_R_DQUOTE] = ACTIONS(3334),
    [anon_sym_LR_DQUOTE] = ACTIONS(3334),
    [anon_sym_uR_DQUOTE] = ACTIONS(3334),
    [anon_sym_UR_DQUOTE] = ACTIONS(3334),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3334),
    [anon_sym_co_await] = ACTIONS(3332),
    [anon_sym_new] = ACTIONS(3332),
    [anon_sym_requires] = ACTIONS(3332),
    [sym_this] = ACTIONS(3332),
  },
  [866] = {
    [sym_identifier] = ACTIONS(3262),
    [aux_sym_preproc_include_token1] = ACTIONS(3262),
    [aux_sym_preproc_def_token1] = ACTIONS(3262),
    [aux_sym_preproc_if_token1] = ACTIONS(3262),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3262),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3262),
    [sym_preproc_directive] = ACTIONS(3262),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_BANG] = ACTIONS(3264),
    [anon_sym_TILDE] = ACTIONS(3264),
    [anon_sym_DASH] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3262),
    [anon_sym_STAR] = ACTIONS(3264),
    [anon_sym_AMP_AMP] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3262),
    [anon_sym_SEMI] = ACTIONS(3264),
    [anon_sym___extension__] = ACTIONS(3262),
    [anon_sym_typedef] = ACTIONS(3262),
    [anon_sym_extern] = ACTIONS(3262),
    [anon_sym___attribute__] = ACTIONS(3262),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3264),
    [anon_sym___declspec] = ACTIONS(3262),
    [anon_sym___based] = ACTIONS(3262),
    [anon_sym___cdecl] = ACTIONS(3262),
    [anon_sym___clrcall] = ACTIONS(3262),
    [anon_sym___stdcall] = ACTIONS(3262),
    [anon_sym___fastcall] = ACTIONS(3262),
    [anon_sym___thiscall] = ACTIONS(3262),
    [anon_sym___vectorcall] = ACTIONS(3262),
    [anon_sym_LBRACE] = ACTIONS(3264),
    [anon_sym_RBRACE] = ACTIONS(3264),
    [anon_sym_signed] = ACTIONS(3262),
    [anon_sym_unsigned] = ACTIONS(3262),
    [anon_sym_long] = ACTIONS(3262),
    [anon_sym_short] = ACTIONS(3262),
    [anon_sym_LBRACK] = ACTIONS(3262),
    [anon_sym_static] = ACTIONS(3262),
    [anon_sym_register] = ACTIONS(3262),
    [anon_sym_inline] = ACTIONS(3262),
    [anon_sym___inline] = ACTIONS(3262),
    [anon_sym___inline__] = ACTIONS(3262),
    [anon_sym___forceinline] = ACTIONS(3262),
    [anon_sym_thread_local] = ACTIONS(3262),
    [anon_sym___thread] = ACTIONS(3262),
    [anon_sym_const] = ACTIONS(3262),
    [anon_sym_constexpr] = ACTIONS(3262),
    [anon_sym_volatile] = ACTIONS(3262),
    [anon_sym_restrict] = ACTIONS(3262),
    [anon_sym___restrict__] = ACTIONS(3262),
    [anon_sym__Atomic] = ACTIONS(3262),
    [anon_sym__Noreturn] = ACTIONS(3262),
    [anon_sym_noreturn] = ACTIONS(3262),
    [anon_sym_mutable] = ACTIONS(3262),
    [anon_sym_constinit] = ACTIONS(3262),
    [anon_sym_consteval] = ACTIONS(3262),
    [anon_sym_PROGMEM] = ACTIONS(3262),
    [aux_sym_primitive_type_token1] = ACTIONS(3262),
    [anon_sym_byte] = ACTIONS(3262),
    [anon_sym_word] = ACTIONS(3262),
    [anon_sym_enum] = ACTIONS(3262),
    [anon_sym_class] = ACTIONS(3262),
    [anon_sym_struct] = ACTIONS(3262),
    [anon_sym_union] = ACTIONS(3262),
    [anon_sym_if] = ACTIONS(3262),
    [anon_sym_switch] = ACTIONS(3262),
    [anon_sym_case] = ACTIONS(3262),
    [anon_sym_default] = ACTIONS(3262),
    [anon_sym_while] = ACTIONS(3262),
    [anon_sym_do] = ACTIONS(3262),
    [anon_sym_for] = ACTIONS(3262),
    [anon_sym_return] = ACTIONS(3262),
    [anon_sym_break] = ACTIONS(3262),
    [anon_sym_continue] = ACTIONS(3262),
    [anon_sym_goto] = ACTIONS(3262),
    [anon_sym___try] = ACTIONS(3262),
    [anon_sym___leave] = ACTIONS(3262),
    [anon_sym_not] = ACTIONS(3262),
    [anon_sym_compl] = ACTIONS(3262),
    [anon_sym_DASH_DASH] = ACTIONS(3264),
    [anon_sym_PLUS_PLUS] = ACTIONS(3264),
    [anon_sym_sizeof] = ACTIONS(3262),
    [anon_sym___alignof__] = ACTIONS(3262),
    [anon_sym___alignof] = ACTIONS(3262),
    [anon_sym__alignof] = ACTIONS(3262),
    [anon_sym_alignof] = ACTIONS(3262),
    [anon_sym__Alignof] = ACTIONS(3262),
    [anon_sym_offsetof] = ACTIONS(3262),
    [anon_sym__Generic] = ACTIONS(3262),
    [anon_sym_asm] = ACTIONS(3262),
    [anon_sym___asm__] = ACTIONS(3262),
    [aux_sym_number_literal_token1] = ACTIONS(3264),
    [aux_sym_number_literal_token2] = ACTIONS(3262),
    [anon_sym_L_SQUOTE] = ACTIONS(3264),
    [anon_sym_u_SQUOTE] = ACTIONS(3264),
    [anon_sym_U_SQUOTE] = ACTIONS(3264),
    [anon_sym_u8_SQUOTE] = ACTIONS(3264),
    [anon_sym_SQUOTE] = ACTIONS(3264),
    [anon_sym_L_DQUOTE] = ACTIONS(3264),
    [anon_sym_u_DQUOTE] = ACTIONS(3264),
    [anon_sym_U_DQUOTE] = ACTIONS(3264),
    [anon_sym_u8_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE] = ACTIONS(3264),
    [sym_true] = ACTIONS(3262),
    [sym_false] = ACTIONS(3262),
    [anon_sym_NULL] = ACTIONS(3262),
    [anon_sym_nullptr] = ACTIONS(3262),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3262),
    [anon_sym_decltype] = ACTIONS(3262),
    [anon_sym_virtual] = ACTIONS(3262),
    [anon_sym_alignas] = ACTIONS(3262),
    [anon_sym_explicit] = ACTIONS(3262),
    [anon_sym_typename] = ACTIONS(3262),
    [anon_sym_template] = ACTIONS(3262),
    [anon_sym_operator] = ACTIONS(3262),
    [anon_sym_try] = ACTIONS(3262),
    [anon_sym_delete] = ACTIONS(3262),
    [anon_sym_throw] = ACTIONS(3262),
    [anon_sym_namespace] = ACTIONS(3262),
    [anon_sym_using] = ACTIONS(3262),
    [anon_sym_static_assert] = ACTIONS(3262),
    [anon_sym_concept] = ACTIONS(3262),
    [anon_sym_co_return] = ACTIONS(3262),
    [anon_sym_co_yield] = ACTIONS(3262),
    [anon_sym_R_DQUOTE] = ACTIONS(3264),
    [anon_sym_LR_DQUOTE] = ACTIONS(3264),
    [anon_sym_uR_DQUOTE] = ACTIONS(3264),
    [anon_sym_UR_DQUOTE] = ACTIONS(3264),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3264),
    [anon_sym_co_await] = ACTIONS(3262),
    [anon_sym_new] = ACTIONS(3262),
    [anon_sym_requires] = ACTIONS(3262),
    [sym_this] = ACTIONS(3262),
  },
  [867] = {
    [sym_identifier] = ACTIONS(3192),
    [aux_sym_preproc_include_token1] = ACTIONS(3192),
    [aux_sym_preproc_def_token1] = ACTIONS(3192),
    [aux_sym_preproc_if_token1] = ACTIONS(3192),
    [aux_sym_preproc_if_token2] = ACTIONS(3192),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3192),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3192),
    [sym_preproc_directive] = ACTIONS(3192),
    [anon_sym_LPAREN2] = ACTIONS(3194),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_DASH] = ACTIONS(3192),
    [anon_sym_PLUS] = ACTIONS(3192),
    [anon_sym_STAR] = ACTIONS(3194),
    [anon_sym_AMP_AMP] = ACTIONS(3194),
    [anon_sym_AMP] = ACTIONS(3192),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym___extension__] = ACTIONS(3192),
    [anon_sym_typedef] = ACTIONS(3192),
    [anon_sym_extern] = ACTIONS(3192),
    [anon_sym___attribute__] = ACTIONS(3192),
    [anon_sym_COLON_COLON] = ACTIONS(3194),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3194),
    [anon_sym___declspec] = ACTIONS(3192),
    [anon_sym___based] = ACTIONS(3192),
    [anon_sym___cdecl] = ACTIONS(3192),
    [anon_sym___clrcall] = ACTIONS(3192),
    [anon_sym___stdcall] = ACTIONS(3192),
    [anon_sym___fastcall] = ACTIONS(3192),
    [anon_sym___thiscall] = ACTIONS(3192),
    [anon_sym___vectorcall] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_signed] = ACTIONS(3192),
    [anon_sym_unsigned] = ACTIONS(3192),
    [anon_sym_long] = ACTIONS(3192),
    [anon_sym_short] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [anon_sym_static] = ACTIONS(3192),
    [anon_sym_register] = ACTIONS(3192),
    [anon_sym_inline] = ACTIONS(3192),
    [anon_sym___inline] = ACTIONS(3192),
    [anon_sym___inline__] = ACTIONS(3192),
    [anon_sym___forceinline] = ACTIONS(3192),
    [anon_sym_thread_local] = ACTIONS(3192),
    [anon_sym___thread] = ACTIONS(3192),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_constexpr] = ACTIONS(3192),
    [anon_sym_volatile] = ACTIONS(3192),
    [anon_sym_restrict] = ACTIONS(3192),
    [anon_sym___restrict__] = ACTIONS(3192),
    [anon_sym__Atomic] = ACTIONS(3192),
    [anon_sym__Noreturn] = ACTIONS(3192),
    [anon_sym_noreturn] = ACTIONS(3192),
    [anon_sym_mutable] = ACTIONS(3192),
    [anon_sym_constinit] = ACTIONS(3192),
    [anon_sym_consteval] = ACTIONS(3192),
    [anon_sym_PROGMEM] = ACTIONS(3192),
    [aux_sym_primitive_type_token1] = ACTIONS(3192),
    [anon_sym_byte] = ACTIONS(3192),
    [anon_sym_word] = ACTIONS(3192),
    [anon_sym_enum] = ACTIONS(3192),
    [anon_sym_class] = ACTIONS(3192),
    [anon_sym_struct] = ACTIONS(3192),
    [anon_sym_union] = ACTIONS(3192),
    [anon_sym_if] = ACTIONS(3192),
    [anon_sym_switch] = ACTIONS(3192),
    [anon_sym_case] = ACTIONS(3192),
    [anon_sym_default] = ACTIONS(3192),
    [anon_sym_while] = ACTIONS(3192),
    [anon_sym_do] = ACTIONS(3192),
    [anon_sym_for] = ACTIONS(3192),
    [anon_sym_return] = ACTIONS(3192),
    [anon_sym_break] = ACTIONS(3192),
    [anon_sym_continue] = ACTIONS(3192),
    [anon_sym_goto] = ACTIONS(3192),
    [anon_sym___try] = ACTIONS(3192),
    [anon_sym___leave] = ACTIONS(3192),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_compl] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3194),
    [anon_sym_PLUS_PLUS] = ACTIONS(3194),
    [anon_sym_sizeof] = ACTIONS(3192),
    [anon_sym___alignof__] = ACTIONS(3192),
    [anon_sym___alignof] = ACTIONS(3192),
    [anon_sym__alignof] = ACTIONS(3192),
    [anon_sym_alignof] = ACTIONS(3192),
    [anon_sym__Alignof] = ACTIONS(3192),
    [anon_sym_offsetof] = ACTIONS(3192),
    [anon_sym__Generic] = ACTIONS(3192),
    [anon_sym_asm] = ACTIONS(3192),
    [anon_sym___asm__] = ACTIONS(3192),
    [aux_sym_number_literal_token1] = ACTIONS(3194),
    [aux_sym_number_literal_token2] = ACTIONS(3192),
    [anon_sym_L_SQUOTE] = ACTIONS(3194),
    [anon_sym_u_SQUOTE] = ACTIONS(3194),
    [anon_sym_U_SQUOTE] = ACTIONS(3194),
    [anon_sym_u8_SQUOTE] = ACTIONS(3194),
    [anon_sym_SQUOTE] = ACTIONS(3194),
    [anon_sym_L_DQUOTE] = ACTIONS(3194),
    [anon_sym_u_DQUOTE] = ACTIONS(3194),
    [anon_sym_U_DQUOTE] = ACTIONS(3194),
    [anon_sym_u8_DQUOTE] = ACTIONS(3194),
    [anon_sym_DQUOTE] = ACTIONS(3194),
    [sym_true] = ACTIONS(3192),
    [sym_false] = ACTIONS(3192),
    [anon_sym_NULL] = ACTIONS(3192),
    [anon_sym_nullptr] = ACTIONS(3192),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3192),
    [anon_sym_decltype] = ACTIONS(3192),
    [anon_sym_virtual] = ACTIONS(3192),
    [anon_sym_alignas] = ACTIONS(3192),
    [anon_sym_explicit] = ACTIONS(3192),
    [anon_sym_typename] = ACTIONS(3192),
    [anon_sym_template] = ACTIONS(3192),
    [anon_sym_operator] = ACTIONS(3192),
    [anon_sym_try] = ACTIONS(3192),
    [anon_sym_delete] = ACTIONS(3192),
    [anon_sym_throw] = ACTIONS(3192),
    [anon_sym_namespace] = ACTIONS(3192),
    [anon_sym_using] = ACTIONS(3192),
    [anon_sym_static_assert] = ACTIONS(3192),
    [anon_sym_concept] = ACTIONS(3192),
    [anon_sym_co_return] = ACTIONS(3192),
    [anon_sym_co_yield] = ACTIONS(3192),
    [anon_sym_R_DQUOTE] = ACTIONS(3194),
    [anon_sym_LR_DQUOTE] = ACTIONS(3194),
    [anon_sym_uR_DQUOTE] = ACTIONS(3194),
    [anon_sym_UR_DQUOTE] = ACTIONS(3194),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3194),
    [anon_sym_co_await] = ACTIONS(3192),
    [anon_sym_new] = ACTIONS(3192),
    [anon_sym_requires] = ACTIONS(3192),
    [sym_this] = ACTIONS(3192),
  },
  [868] = {
    [sym_identifier] = ACTIONS(3254),
    [aux_sym_preproc_include_token1] = ACTIONS(3254),
    [aux_sym_preproc_def_token1] = ACTIONS(3254),
    [aux_sym_preproc_if_token1] = ACTIONS(3254),
    [aux_sym_preproc_if_token2] = ACTIONS(3254),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3254),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3254),
    [sym_preproc_directive] = ACTIONS(3254),
    [anon_sym_LPAREN2] = ACTIONS(3256),
    [anon_sym_BANG] = ACTIONS(3256),
    [anon_sym_TILDE] = ACTIONS(3256),
    [anon_sym_DASH] = ACTIONS(3254),
    [anon_sym_PLUS] = ACTIONS(3254),
    [anon_sym_STAR] = ACTIONS(3256),
    [anon_sym_AMP_AMP] = ACTIONS(3256),
    [anon_sym_AMP] = ACTIONS(3254),
    [anon_sym_SEMI] = ACTIONS(3256),
    [anon_sym___extension__] = ACTIONS(3254),
    [anon_sym_typedef] = ACTIONS(3254),
    [anon_sym_extern] = ACTIONS(3254),
    [anon_sym___attribute__] = ACTIONS(3254),
    [anon_sym_COLON_COLON] = ACTIONS(3256),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3256),
    [anon_sym___declspec] = ACTIONS(3254),
    [anon_sym___based] = ACTIONS(3254),
    [anon_sym___cdecl] = ACTIONS(3254),
    [anon_sym___clrcall] = ACTIONS(3254),
    [anon_sym___stdcall] = ACTIONS(3254),
    [anon_sym___fastcall] = ACTIONS(3254),
    [anon_sym___thiscall] = ACTIONS(3254),
    [anon_sym___vectorcall] = ACTIONS(3254),
    [anon_sym_LBRACE] = ACTIONS(3256),
    [anon_sym_signed] = ACTIONS(3254),
    [anon_sym_unsigned] = ACTIONS(3254),
    [anon_sym_long] = ACTIONS(3254),
    [anon_sym_short] = ACTIONS(3254),
    [anon_sym_LBRACK] = ACTIONS(3254),
    [anon_sym_static] = ACTIONS(3254),
    [anon_sym_register] = ACTIONS(3254),
    [anon_sym_inline] = ACTIONS(3254),
    [anon_sym___inline] = ACTIONS(3254),
    [anon_sym___inline__] = ACTIONS(3254),
    [anon_sym___forceinline] = ACTIONS(3254),
    [anon_sym_thread_local] = ACTIONS(3254),
    [anon_sym___thread] = ACTIONS(3254),
    [anon_sym_const] = ACTIONS(3254),
    [anon_sym_constexpr] = ACTIONS(3254),
    [anon_sym_volatile] = ACTIONS(3254),
    [anon_sym_restrict] = ACTIONS(3254),
    [anon_sym___restrict__] = ACTIONS(3254),
    [anon_sym__Atomic] = ACTIONS(3254),
    [anon_sym__Noreturn] = ACTIONS(3254),
    [anon_sym_noreturn] = ACTIONS(3254),
    [anon_sym_mutable] = ACTIONS(3254),
    [anon_sym_constinit] = ACTIONS(3254),
    [anon_sym_consteval] = ACTIONS(3254),
    [anon_sym_PROGMEM] = ACTIONS(3254),
    [aux_sym_primitive_type_token1] = ACTIONS(3254),
    [anon_sym_byte] = ACTIONS(3254),
    [anon_sym_word] = ACTIONS(3254),
    [anon_sym_enum] = ACTIONS(3254),
    [anon_sym_class] = ACTIONS(3254),
    [anon_sym_struct] = ACTIONS(3254),
    [anon_sym_union] = ACTIONS(3254),
    [anon_sym_if] = ACTIONS(3254),
    [anon_sym_switch] = ACTIONS(3254),
    [anon_sym_case] = ACTIONS(3254),
    [anon_sym_default] = ACTIONS(3254),
    [anon_sym_while] = ACTIONS(3254),
    [anon_sym_do] = ACTIONS(3254),
    [anon_sym_for] = ACTIONS(3254),
    [anon_sym_return] = ACTIONS(3254),
    [anon_sym_break] = ACTIONS(3254),
    [anon_sym_continue] = ACTIONS(3254),
    [anon_sym_goto] = ACTIONS(3254),
    [anon_sym___try] = ACTIONS(3254),
    [anon_sym___leave] = ACTIONS(3254),
    [anon_sym_not] = ACTIONS(3254),
    [anon_sym_compl] = ACTIONS(3254),
    [anon_sym_DASH_DASH] = ACTIONS(3256),
    [anon_sym_PLUS_PLUS] = ACTIONS(3256),
    [anon_sym_sizeof] = ACTIONS(3254),
    [anon_sym___alignof__] = ACTIONS(3254),
    [anon_sym___alignof] = ACTIONS(3254),
    [anon_sym__alignof] = ACTIONS(3254),
    [anon_sym_alignof] = ACTIONS(3254),
    [anon_sym__Alignof] = ACTIONS(3254),
    [anon_sym_offsetof] = ACTIONS(3254),
    [anon_sym__Generic] = ACTIONS(3254),
    [anon_sym_asm] = ACTIONS(3254),
    [anon_sym___asm__] = ACTIONS(3254),
    [aux_sym_number_literal_token1] = ACTIONS(3256),
    [aux_sym_number_literal_token2] = ACTIONS(3254),
    [anon_sym_L_SQUOTE] = ACTIONS(3256),
    [anon_sym_u_SQUOTE] = ACTIONS(3256),
    [anon_sym_U_SQUOTE] = ACTIONS(3256),
    [anon_sym_u8_SQUOTE] = ACTIONS(3256),
    [anon_sym_SQUOTE] = ACTIONS(3256),
    [anon_sym_L_DQUOTE] = ACTIONS(3256),
    [anon_sym_u_DQUOTE] = ACTIONS(3256),
    [anon_sym_U_DQUOTE] = ACTIONS(3256),
    [anon_sym_u8_DQUOTE] = ACTIONS(3256),
    [anon_sym_DQUOTE] = ACTIONS(3256),
    [sym_true] = ACTIONS(3254),
    [sym_false] = ACTIONS(3254),
    [anon_sym_NULL] = ACTIONS(3254),
    [anon_sym_nullptr] = ACTIONS(3254),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3254),
    [anon_sym_decltype] = ACTIONS(3254),
    [anon_sym_virtual] = ACTIONS(3254),
    [anon_sym_alignas] = ACTIONS(3254),
    [anon_sym_explicit] = ACTIONS(3254),
    [anon_sym_typename] = ACTIONS(3254),
    [anon_sym_template] = ACTIONS(3254),
    [anon_sym_operator] = ACTIONS(3254),
    [anon_sym_try] = ACTIONS(3254),
    [anon_sym_delete] = ACTIONS(3254),
    [anon_sym_throw] = ACTIONS(3254),
    [anon_sym_namespace] = ACTIONS(3254),
    [anon_sym_using] = ACTIONS(3254),
    [anon_sym_static_assert] = ACTIONS(3254),
    [anon_sym_concept] = ACTIONS(3254),
    [anon_sym_co_return] = ACTIONS(3254),
    [anon_sym_co_yield] = ACTIONS(3254),
    [anon_sym_R_DQUOTE] = ACTIONS(3256),
    [anon_sym_LR_DQUOTE] = ACTIONS(3256),
    [anon_sym_uR_DQUOTE] = ACTIONS(3256),
    [anon_sym_UR_DQUOTE] = ACTIONS(3256),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3256),
    [anon_sym_co_await] = ACTIONS(3254),
    [anon_sym_new] = ACTIONS(3254),
    [anon_sym_requires] = ACTIONS(3254),
    [sym_this] = ACTIONS(3254),
  },
  [869] = {
    [sym_identifier] = ACTIONS(3250),
    [aux_sym_preproc_include_token1] = ACTIONS(3250),
    [aux_sym_preproc_def_token1] = ACTIONS(3250),
    [aux_sym_preproc_if_token1] = ACTIONS(3250),
    [aux_sym_preproc_if_token2] = ACTIONS(3250),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3250),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3250),
    [sym_preproc_directive] = ACTIONS(3250),
    [anon_sym_LPAREN2] = ACTIONS(3252),
    [anon_sym_BANG] = ACTIONS(3252),
    [anon_sym_TILDE] = ACTIONS(3252),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_STAR] = ACTIONS(3252),
    [anon_sym_AMP_AMP] = ACTIONS(3252),
    [anon_sym_AMP] = ACTIONS(3250),
    [anon_sym_SEMI] = ACTIONS(3252),
    [anon_sym___extension__] = ACTIONS(3250),
    [anon_sym_typedef] = ACTIONS(3250),
    [anon_sym_extern] = ACTIONS(3250),
    [anon_sym___attribute__] = ACTIONS(3250),
    [anon_sym_COLON_COLON] = ACTIONS(3252),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3252),
    [anon_sym___declspec] = ACTIONS(3250),
    [anon_sym___based] = ACTIONS(3250),
    [anon_sym___cdecl] = ACTIONS(3250),
    [anon_sym___clrcall] = ACTIONS(3250),
    [anon_sym___stdcall] = ACTIONS(3250),
    [anon_sym___fastcall] = ACTIONS(3250),
    [anon_sym___thiscall] = ACTIONS(3250),
    [anon_sym___vectorcall] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3252),
    [anon_sym_signed] = ACTIONS(3250),
    [anon_sym_unsigned] = ACTIONS(3250),
    [anon_sym_long] = ACTIONS(3250),
    [anon_sym_short] = ACTIONS(3250),
    [anon_sym_LBRACK] = ACTIONS(3250),
    [anon_sym_static] = ACTIONS(3250),
    [anon_sym_register] = ACTIONS(3250),
    [anon_sym_inline] = ACTIONS(3250),
    [anon_sym___inline] = ACTIONS(3250),
    [anon_sym___inline__] = ACTIONS(3250),
    [anon_sym___forceinline] = ACTIONS(3250),
    [anon_sym_thread_local] = ACTIONS(3250),
    [anon_sym___thread] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(3250),
    [anon_sym_constexpr] = ACTIONS(3250),
    [anon_sym_volatile] = ACTIONS(3250),
    [anon_sym_restrict] = ACTIONS(3250),
    [anon_sym___restrict__] = ACTIONS(3250),
    [anon_sym__Atomic] = ACTIONS(3250),
    [anon_sym__Noreturn] = ACTIONS(3250),
    [anon_sym_noreturn] = ACTIONS(3250),
    [anon_sym_mutable] = ACTIONS(3250),
    [anon_sym_constinit] = ACTIONS(3250),
    [anon_sym_consteval] = ACTIONS(3250),
    [anon_sym_PROGMEM] = ACTIONS(3250),
    [aux_sym_primitive_type_token1] = ACTIONS(3250),
    [anon_sym_byte] = ACTIONS(3250),
    [anon_sym_word] = ACTIONS(3250),
    [anon_sym_enum] = ACTIONS(3250),
    [anon_sym_class] = ACTIONS(3250),
    [anon_sym_struct] = ACTIONS(3250),
    [anon_sym_union] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_switch] = ACTIONS(3250),
    [anon_sym_case] = ACTIONS(3250),
    [anon_sym_default] = ACTIONS(3250),
    [anon_sym_while] = ACTIONS(3250),
    [anon_sym_do] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_goto] = ACTIONS(3250),
    [anon_sym___try] = ACTIONS(3250),
    [anon_sym___leave] = ACTIONS(3250),
    [anon_sym_not] = ACTIONS(3250),
    [anon_sym_compl] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3252),
    [anon_sym_PLUS_PLUS] = ACTIONS(3252),
    [anon_sym_sizeof] = ACTIONS(3250),
    [anon_sym___alignof__] = ACTIONS(3250),
    [anon_sym___alignof] = ACTIONS(3250),
    [anon_sym__alignof] = ACTIONS(3250),
    [anon_sym_alignof] = ACTIONS(3250),
    [anon_sym__Alignof] = ACTIONS(3250),
    [anon_sym_offsetof] = ACTIONS(3250),
    [anon_sym__Generic] = ACTIONS(3250),
    [anon_sym_asm] = ACTIONS(3250),
    [anon_sym___asm__] = ACTIONS(3250),
    [aux_sym_number_literal_token1] = ACTIONS(3252),
    [aux_sym_number_literal_token2] = ACTIONS(3250),
    [anon_sym_L_SQUOTE] = ACTIONS(3252),
    [anon_sym_u_SQUOTE] = ACTIONS(3252),
    [anon_sym_U_SQUOTE] = ACTIONS(3252),
    [anon_sym_u8_SQUOTE] = ACTIONS(3252),
    [anon_sym_SQUOTE] = ACTIONS(3252),
    [anon_sym_L_DQUOTE] = ACTIONS(3252),
    [anon_sym_u_DQUOTE] = ACTIONS(3252),
    [anon_sym_U_DQUOTE] = ACTIONS(3252),
    [anon_sym_u8_DQUOTE] = ACTIONS(3252),
    [anon_sym_DQUOTE] = ACTIONS(3252),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [anon_sym_NULL] = ACTIONS(3250),
    [anon_sym_nullptr] = ACTIONS(3250),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3250),
    [anon_sym_decltype] = ACTIONS(3250),
    [anon_sym_virtual] = ACTIONS(3250),
    [anon_sym_alignas] = ACTIONS(3250),
    [anon_sym_explicit] = ACTIONS(3250),
    [anon_sym_typename] = ACTIONS(3250),
    [anon_sym_template] = ACTIONS(3250),
    [anon_sym_operator] = ACTIONS(3250),
    [anon_sym_try] = ACTIONS(3250),
    [anon_sym_delete] = ACTIONS(3250),
    [anon_sym_throw] = ACTIONS(3250),
    [anon_sym_namespace] = ACTIONS(3250),
    [anon_sym_using] = ACTIONS(3250),
    [anon_sym_static_assert] = ACTIONS(3250),
    [anon_sym_concept] = ACTIONS(3250),
    [anon_sym_co_return] = ACTIONS(3250),
    [anon_sym_co_yield] = ACTIONS(3250),
    [anon_sym_R_DQUOTE] = ACTIONS(3252),
    [anon_sym_LR_DQUOTE] = ACTIONS(3252),
    [anon_sym_uR_DQUOTE] = ACTIONS(3252),
    [anon_sym_UR_DQUOTE] = ACTIONS(3252),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3252),
    [anon_sym_co_await] = ACTIONS(3250),
    [anon_sym_new] = ACTIONS(3250),
    [anon_sym_requires] = ACTIONS(3250),
    [sym_this] = ACTIONS(3250),
  },
  [870] = {
    [sym_identifier] = ACTIONS(3258),
    [aux_sym_preproc_include_token1] = ACTIONS(3258),
    [aux_sym_preproc_def_token1] = ACTIONS(3258),
    [aux_sym_preproc_if_token1] = ACTIONS(3258),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3258),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3258),
    [sym_preproc_directive] = ACTIONS(3258),
    [anon_sym_LPAREN2] = ACTIONS(3260),
    [anon_sym_BANG] = ACTIONS(3260),
    [anon_sym_TILDE] = ACTIONS(3260),
    [anon_sym_DASH] = ACTIONS(3258),
    [anon_sym_PLUS] = ACTIONS(3258),
    [anon_sym_STAR] = ACTIONS(3260),
    [anon_sym_AMP_AMP] = ACTIONS(3260),
    [anon_sym_AMP] = ACTIONS(3258),
    [anon_sym_SEMI] = ACTIONS(3260),
    [anon_sym___extension__] = ACTIONS(3258),
    [anon_sym_typedef] = ACTIONS(3258),
    [anon_sym_extern] = ACTIONS(3258),
    [anon_sym___attribute__] = ACTIONS(3258),
    [anon_sym_COLON_COLON] = ACTIONS(3260),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3260),
    [anon_sym___declspec] = ACTIONS(3258),
    [anon_sym___based] = ACTIONS(3258),
    [anon_sym___cdecl] = ACTIONS(3258),
    [anon_sym___clrcall] = ACTIONS(3258),
    [anon_sym___stdcall] = ACTIONS(3258),
    [anon_sym___fastcall] = ACTIONS(3258),
    [anon_sym___thiscall] = ACTIONS(3258),
    [anon_sym___vectorcall] = ACTIONS(3258),
    [anon_sym_LBRACE] = ACTIONS(3260),
    [anon_sym_RBRACE] = ACTIONS(3260),
    [anon_sym_signed] = ACTIONS(3258),
    [anon_sym_unsigned] = ACTIONS(3258),
    [anon_sym_long] = ACTIONS(3258),
    [anon_sym_short] = ACTIONS(3258),
    [anon_sym_LBRACK] = ACTIONS(3258),
    [anon_sym_static] = ACTIONS(3258),
    [anon_sym_register] = ACTIONS(3258),
    [anon_sym_inline] = ACTIONS(3258),
    [anon_sym___inline] = ACTIONS(3258),
    [anon_sym___inline__] = ACTIONS(3258),
    [anon_sym___forceinline] = ACTIONS(3258),
    [anon_sym_thread_local] = ACTIONS(3258),
    [anon_sym___thread] = ACTIONS(3258),
    [anon_sym_const] = ACTIONS(3258),
    [anon_sym_constexpr] = ACTIONS(3258),
    [anon_sym_volatile] = ACTIONS(3258),
    [anon_sym_restrict] = ACTIONS(3258),
    [anon_sym___restrict__] = ACTIONS(3258),
    [anon_sym__Atomic] = ACTIONS(3258),
    [anon_sym__Noreturn] = ACTIONS(3258),
    [anon_sym_noreturn] = ACTIONS(3258),
    [anon_sym_mutable] = ACTIONS(3258),
    [anon_sym_constinit] = ACTIONS(3258),
    [anon_sym_consteval] = ACTIONS(3258),
    [anon_sym_PROGMEM] = ACTIONS(3258),
    [aux_sym_primitive_type_token1] = ACTIONS(3258),
    [anon_sym_byte] = ACTIONS(3258),
    [anon_sym_word] = ACTIONS(3258),
    [anon_sym_enum] = ACTIONS(3258),
    [anon_sym_class] = ACTIONS(3258),
    [anon_sym_struct] = ACTIONS(3258),
    [anon_sym_union] = ACTIONS(3258),
    [anon_sym_if] = ACTIONS(3258),
    [anon_sym_switch] = ACTIONS(3258),
    [anon_sym_case] = ACTIONS(3258),
    [anon_sym_default] = ACTIONS(3258),
    [anon_sym_while] = ACTIONS(3258),
    [anon_sym_do] = ACTIONS(3258),
    [anon_sym_for] = ACTIONS(3258),
    [anon_sym_return] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3258),
    [anon_sym_continue] = ACTIONS(3258),
    [anon_sym_goto] = ACTIONS(3258),
    [anon_sym___try] = ACTIONS(3258),
    [anon_sym___leave] = ACTIONS(3258),
    [anon_sym_not] = ACTIONS(3258),
    [anon_sym_compl] = ACTIONS(3258),
    [anon_sym_DASH_DASH] = ACTIONS(3260),
    [anon_sym_PLUS_PLUS] = ACTIONS(3260),
    [anon_sym_sizeof] = ACTIONS(3258),
    [anon_sym___alignof__] = ACTIONS(3258),
    [anon_sym___alignof] = ACTIONS(3258),
    [anon_sym__alignof] = ACTIONS(3258),
    [anon_sym_alignof] = ACTIONS(3258),
    [anon_sym__Alignof] = ACTIONS(3258),
    [anon_sym_offsetof] = ACTIONS(3258),
    [anon_sym__Generic] = ACTIONS(3258),
    [anon_sym_asm] = ACTIONS(3258),
    [anon_sym___asm__] = ACTIONS(3258),
    [aux_sym_number_literal_token1] = ACTIONS(3260),
    [aux_sym_number_literal_token2] = ACTIONS(3258),
    [anon_sym_L_SQUOTE] = ACTIONS(3260),
    [anon_sym_u_SQUOTE] = ACTIONS(3260),
    [anon_sym_U_SQUOTE] = ACTIONS(3260),
    [anon_sym_u8_SQUOTE] = ACTIONS(3260),
    [anon_sym_SQUOTE] = ACTIONS(3260),
    [anon_sym_L_DQUOTE] = ACTIONS(3260),
    [anon_sym_u_DQUOTE] = ACTIONS(3260),
    [anon_sym_U_DQUOTE] = ACTIONS(3260),
    [anon_sym_u8_DQUOTE] = ACTIONS(3260),
    [anon_sym_DQUOTE] = ACTIONS(3260),
    [sym_true] = ACTIONS(3258),
    [sym_false] = ACTIONS(3258),
    [anon_sym_NULL] = ACTIONS(3258),
    [anon_sym_nullptr] = ACTIONS(3258),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3258),
    [anon_sym_decltype] = ACTIONS(3258),
    [anon_sym_virtual] = ACTIONS(3258),
    [anon_sym_alignas] = ACTIONS(3258),
    [anon_sym_explicit] = ACTIONS(3258),
    [anon_sym_typename] = ACTIONS(3258),
    [anon_sym_template] = ACTIONS(3258),
    [anon_sym_operator] = ACTIONS(3258),
    [anon_sym_try] = ACTIONS(3258),
    [anon_sym_delete] = ACTIONS(3258),
    [anon_sym_throw] = ACTIONS(3258),
    [anon_sym_namespace] = ACTIONS(3258),
    [anon_sym_using] = ACTIONS(3258),
    [anon_sym_static_assert] = ACTIONS(3258),
    [anon_sym_concept] = ACTIONS(3258),
    [anon_sym_co_return] = ACTIONS(3258),
    [anon_sym_co_yield] = ACTIONS(3258),
    [anon_sym_R_DQUOTE] = ACTIONS(3260),
    [anon_sym_LR_DQUOTE] = ACTIONS(3260),
    [anon_sym_uR_DQUOTE] = ACTIONS(3260),
    [anon_sym_UR_DQUOTE] = ACTIONS(3260),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3260),
    [anon_sym_co_await] = ACTIONS(3258),
    [anon_sym_new] = ACTIONS(3258),
    [anon_sym_requires] = ACTIONS(3258),
    [sym_this] = ACTIONS(3258),
  },
  [871] = {
    [sym_identifier] = ACTIONS(3379),
    [aux_sym_preproc_include_token1] = ACTIONS(3379),
    [aux_sym_preproc_def_token1] = ACTIONS(3379),
    [aux_sym_preproc_if_token1] = ACTIONS(3379),
    [aux_sym_preproc_if_token2] = ACTIONS(3379),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3379),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3379),
    [sym_preproc_directive] = ACTIONS(3379),
    [anon_sym_LPAREN2] = ACTIONS(3381),
    [anon_sym_BANG] = ACTIONS(3381),
    [anon_sym_TILDE] = ACTIONS(3381),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_STAR] = ACTIONS(3381),
    [anon_sym_AMP_AMP] = ACTIONS(3381),
    [anon_sym_AMP] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3381),
    [anon_sym___extension__] = ACTIONS(3379),
    [anon_sym_typedef] = ACTIONS(3379),
    [anon_sym_extern] = ACTIONS(3379),
    [anon_sym___attribute__] = ACTIONS(3379),
    [anon_sym_COLON_COLON] = ACTIONS(3381),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3381),
    [anon_sym___declspec] = ACTIONS(3379),
    [anon_sym___based] = ACTIONS(3379),
    [anon_sym___cdecl] = ACTIONS(3379),
    [anon_sym___clrcall] = ACTIONS(3379),
    [anon_sym___stdcall] = ACTIONS(3379),
    [anon_sym___fastcall] = ACTIONS(3379),
    [anon_sym___thiscall] = ACTIONS(3379),
    [anon_sym___vectorcall] = ACTIONS(3379),
    [anon_sym_LBRACE] = ACTIONS(3381),
    [anon_sym_signed] = ACTIONS(3379),
    [anon_sym_unsigned] = ACTIONS(3379),
    [anon_sym_long] = ACTIONS(3379),
    [anon_sym_short] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_register] = ACTIONS(3379),
    [anon_sym_inline] = ACTIONS(3379),
    [anon_sym___inline] = ACTIONS(3379),
    [anon_sym___inline__] = ACTIONS(3379),
    [anon_sym___forceinline] = ACTIONS(3379),
    [anon_sym_thread_local] = ACTIONS(3379),
    [anon_sym___thread] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_constexpr] = ACTIONS(3379),
    [anon_sym_volatile] = ACTIONS(3379),
    [anon_sym_restrict] = ACTIONS(3379),
    [anon_sym___restrict__] = ACTIONS(3379),
    [anon_sym__Atomic] = ACTIONS(3379),
    [anon_sym__Noreturn] = ACTIONS(3379),
    [anon_sym_noreturn] = ACTIONS(3379),
    [anon_sym_mutable] = ACTIONS(3379),
    [anon_sym_constinit] = ACTIONS(3379),
    [anon_sym_consteval] = ACTIONS(3379),
    [anon_sym_PROGMEM] = ACTIONS(3379),
    [aux_sym_primitive_type_token1] = ACTIONS(3379),
    [anon_sym_byte] = ACTIONS(3379),
    [anon_sym_word] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_struct] = ACTIONS(3379),
    [anon_sym_union] = ACTIONS(3379),
    [anon_sym_if] = ACTIONS(3379),
    [anon_sym_switch] = ACTIONS(3379),
    [anon_sym_case] = ACTIONS(3379),
    [anon_sym_default] = ACTIONS(3379),
    [anon_sym_while] = ACTIONS(3379),
    [anon_sym_do] = ACTIONS(3379),
    [anon_sym_for] = ACTIONS(3379),
    [anon_sym_return] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(3379),
    [anon_sym_continue] = ACTIONS(3379),
    [anon_sym_goto] = ACTIONS(3379),
    [anon_sym___try] = ACTIONS(3379),
    [anon_sym___leave] = ACTIONS(3379),
    [anon_sym_not] = ACTIONS(3379),
    [anon_sym_compl] = ACTIONS(3379),
    [anon_sym_DASH_DASH] = ACTIONS(3381),
    [anon_sym_PLUS_PLUS] = ACTIONS(3381),
    [anon_sym_sizeof] = ACTIONS(3379),
    [anon_sym___alignof__] = ACTIONS(3379),
    [anon_sym___alignof] = ACTIONS(3379),
    [anon_sym__alignof] = ACTIONS(3379),
    [anon_sym_alignof] = ACTIONS(3379),
    [anon_sym__Alignof] = ACTIONS(3379),
    [anon_sym_offsetof] = ACTIONS(3379),
    [anon_sym__Generic] = ACTIONS(3379),
    [anon_sym_asm] = ACTIONS(3379),
    [anon_sym___asm__] = ACTIONS(3379),
    [aux_sym_number_literal_token1] = ACTIONS(3381),
    [aux_sym_number_literal_token2] = ACTIONS(3379),
    [anon_sym_L_SQUOTE] = ACTIONS(3381),
    [anon_sym_u_SQUOTE] = ACTIONS(3381),
    [anon_sym_U_SQUOTE] = ACTIONS(3381),
    [anon_sym_u8_SQUOTE] = ACTIONS(3381),
    [anon_sym_SQUOTE] = ACTIONS(3381),
    [anon_sym_L_DQUOTE] = ACTIONS(3381),
    [anon_sym_u_DQUOTE] = ACTIONS(3381),
    [anon_sym_U_DQUOTE] = ACTIONS(3381),
    [anon_sym_u8_DQUOTE] = ACTIONS(3381),
    [anon_sym_DQUOTE] = ACTIONS(3381),
    [sym_true] = ACTIONS(3379),
    [sym_false] = ACTIONS(3379),
    [anon_sym_NULL] = ACTIONS(3379),
    [anon_sym_nullptr] = ACTIONS(3379),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3379),
    [anon_sym_decltype] = ACTIONS(3379),
    [anon_sym_virtual] = ACTIONS(3379),
    [anon_sym_alignas] = ACTIONS(3379),
    [anon_sym_explicit] = ACTIONS(3379),
    [anon_sym_typename] = ACTIONS(3379),
    [anon_sym_template] = ACTIONS(3379),
    [anon_sym_operator] = ACTIONS(3379),
    [anon_sym_try] = ACTIONS(3379),
    [anon_sym_delete] = ACTIONS(3379),
    [anon_sym_throw] = ACTIONS(3379),
    [anon_sym_namespace] = ACTIONS(3379),
    [anon_sym_using] = ACTIONS(3379),
    [anon_sym_static_assert] = ACTIONS(3379),
    [anon_sym_concept] = ACTIONS(3379),
    [anon_sym_co_return] = ACTIONS(3379),
    [anon_sym_co_yield] = ACTIONS(3379),
    [anon_sym_R_DQUOTE] = ACTIONS(3381),
    [anon_sym_LR_DQUOTE] = ACTIONS(3381),
    [anon_sym_uR_DQUOTE] = ACTIONS(3381),
    [anon_sym_UR_DQUOTE] = ACTIONS(3381),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3381),
    [anon_sym_co_await] = ACTIONS(3379),
    [anon_sym_new] = ACTIONS(3379),
    [anon_sym_requires] = ACTIONS(3379),
    [sym_this] = ACTIONS(3379),
  },
  [872] = {
    [sym_identifier] = ACTIONS(3182),
    [aux_sym_preproc_include_token1] = ACTIONS(3182),
    [aux_sym_preproc_def_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token2] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [sym_preproc_directive] = ACTIONS(3182),
    [anon_sym_LPAREN2] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym___extension__] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3182),
    [anon_sym_extern] = ACTIONS(3182),
    [anon_sym___attribute__] = ACTIONS(3182),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3184),
    [anon_sym___declspec] = ACTIONS(3182),
    [anon_sym___based] = ACTIONS(3182),
    [anon_sym___cdecl] = ACTIONS(3182),
    [anon_sym___clrcall] = ACTIONS(3182),
    [anon_sym___stdcall] = ACTIONS(3182),
    [anon_sym___fastcall] = ACTIONS(3182),
    [anon_sym___thiscall] = ACTIONS(3182),
    [anon_sym___vectorcall] = ACTIONS(3182),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_signed] = ACTIONS(3182),
    [anon_sym_unsigned] = ACTIONS(3182),
    [anon_sym_long] = ACTIONS(3182),
    [anon_sym_short] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_register] = ACTIONS(3182),
    [anon_sym_inline] = ACTIONS(3182),
    [anon_sym___inline] = ACTIONS(3182),
    [anon_sym___inline__] = ACTIONS(3182),
    [anon_sym___forceinline] = ACTIONS(3182),
    [anon_sym_thread_local] = ACTIONS(3182),
    [anon_sym___thread] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_constexpr] = ACTIONS(3182),
    [anon_sym_volatile] = ACTIONS(3182),
    [anon_sym_restrict] = ACTIONS(3182),
    [anon_sym___restrict__] = ACTIONS(3182),
    [anon_sym__Atomic] = ACTIONS(3182),
    [anon_sym__Noreturn] = ACTIONS(3182),
    [anon_sym_noreturn] = ACTIONS(3182),
    [anon_sym_mutable] = ACTIONS(3182),
    [anon_sym_constinit] = ACTIONS(3182),
    [anon_sym_consteval] = ACTIONS(3182),
    [anon_sym_PROGMEM] = ACTIONS(3182),
    [aux_sym_primitive_type_token1] = ACTIONS(3182),
    [anon_sym_byte] = ACTIONS(3182),
    [anon_sym_word] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_struct] = ACTIONS(3182),
    [anon_sym_union] = ACTIONS(3182),
    [anon_sym_if] = ACTIONS(3182),
    [anon_sym_switch] = ACTIONS(3182),
    [anon_sym_case] = ACTIONS(3182),
    [anon_sym_default] = ACTIONS(3182),
    [anon_sym_while] = ACTIONS(3182),
    [anon_sym_do] = ACTIONS(3182),
    [anon_sym_for] = ACTIONS(3182),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_break] = ACTIONS(3182),
    [anon_sym_continue] = ACTIONS(3182),
    [anon_sym_goto] = ACTIONS(3182),
    [anon_sym___try] = ACTIONS(3182),
    [anon_sym___leave] = ACTIONS(3182),
    [anon_sym_not] = ACTIONS(3182),
    [anon_sym_compl] = ACTIONS(3182),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_sizeof] = ACTIONS(3182),
    [anon_sym___alignof__] = ACTIONS(3182),
    [anon_sym___alignof] = ACTIONS(3182),
    [anon_sym__alignof] = ACTIONS(3182),
    [anon_sym_alignof] = ACTIONS(3182),
    [anon_sym__Alignof] = ACTIONS(3182),
    [anon_sym_offsetof] = ACTIONS(3182),
    [anon_sym__Generic] = ACTIONS(3182),
    [anon_sym_asm] = ACTIONS(3182),
    [anon_sym___asm__] = ACTIONS(3182),
    [aux_sym_number_literal_token1] = ACTIONS(3184),
    [aux_sym_number_literal_token2] = ACTIONS(3182),
    [anon_sym_L_SQUOTE] = ACTIONS(3184),
    [anon_sym_u_SQUOTE] = ACTIONS(3184),
    [anon_sym_U_SQUOTE] = ACTIONS(3184),
    [anon_sym_u8_SQUOTE] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3184),
    [anon_sym_L_DQUOTE] = ACTIONS(3184),
    [anon_sym_u_DQUOTE] = ACTIONS(3184),
    [anon_sym_U_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8_DQUOTE] = ACTIONS(3184),
    [anon_sym_DQUOTE] = ACTIONS(3184),
    [sym_true] = ACTIONS(3182),
    [sym_false] = ACTIONS(3182),
    [anon_sym_NULL] = ACTIONS(3182),
    [anon_sym_nullptr] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3182),
    [anon_sym_decltype] = ACTIONS(3182),
    [anon_sym_virtual] = ACTIONS(3182),
    [anon_sym_alignas] = ACTIONS(3182),
    [anon_sym_explicit] = ACTIONS(3182),
    [anon_sym_typename] = ACTIONS(3182),
    [anon_sym_template] = ACTIONS(3182),
    [anon_sym_operator] = ACTIONS(3182),
    [anon_sym_try] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3182),
    [anon_sym_throw] = ACTIONS(3182),
    [anon_sym_namespace] = ACTIONS(3182),
    [anon_sym_using] = ACTIONS(3182),
    [anon_sym_static_assert] = ACTIONS(3182),
    [anon_sym_concept] = ACTIONS(3182),
    [anon_sym_co_return] = ACTIONS(3182),
    [anon_sym_co_yield] = ACTIONS(3182),
    [anon_sym_R_DQUOTE] = ACTIONS(3184),
    [anon_sym_LR_DQUOTE] = ACTIONS(3184),
    [anon_sym_uR_DQUOTE] = ACTIONS(3184),
    [anon_sym_UR_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3184),
    [anon_sym_co_await] = ACTIONS(3182),
    [anon_sym_new] = ACTIONS(3182),
    [anon_sym_requires] = ACTIONS(3182),
    [sym_this] = ACTIONS(3182),
  },
  [873] = {
    [sym_identifier] = ACTIONS(3266),
    [aux_sym_preproc_include_token1] = ACTIONS(3266),
    [aux_sym_preproc_def_token1] = ACTIONS(3266),
    [aux_sym_preproc_if_token1] = ACTIONS(3266),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3266),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3266),
    [sym_preproc_directive] = ACTIONS(3266),
    [anon_sym_LPAREN2] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3268),
    [anon_sym_TILDE] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3266),
    [anon_sym_STAR] = ACTIONS(3268),
    [anon_sym_AMP_AMP] = ACTIONS(3268),
    [anon_sym_AMP] = ACTIONS(3266),
    [anon_sym_SEMI] = ACTIONS(3268),
    [anon_sym___extension__] = ACTIONS(3266),
    [anon_sym_typedef] = ACTIONS(3266),
    [anon_sym_extern] = ACTIONS(3266),
    [anon_sym___attribute__] = ACTIONS(3266),
    [anon_sym_COLON_COLON] = ACTIONS(3268),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3268),
    [anon_sym___declspec] = ACTIONS(3266),
    [anon_sym___based] = ACTIONS(3266),
    [anon_sym___cdecl] = ACTIONS(3266),
    [anon_sym___clrcall] = ACTIONS(3266),
    [anon_sym___stdcall] = ACTIONS(3266),
    [anon_sym___fastcall] = ACTIONS(3266),
    [anon_sym___thiscall] = ACTIONS(3266),
    [anon_sym___vectorcall] = ACTIONS(3266),
    [anon_sym_LBRACE] = ACTIONS(3268),
    [anon_sym_RBRACE] = ACTIONS(3268),
    [anon_sym_signed] = ACTIONS(3266),
    [anon_sym_unsigned] = ACTIONS(3266),
    [anon_sym_long] = ACTIONS(3266),
    [anon_sym_short] = ACTIONS(3266),
    [anon_sym_LBRACK] = ACTIONS(3266),
    [anon_sym_static] = ACTIONS(3266),
    [anon_sym_register] = ACTIONS(3266),
    [anon_sym_inline] = ACTIONS(3266),
    [anon_sym___inline] = ACTIONS(3266),
    [anon_sym___inline__] = ACTIONS(3266),
    [anon_sym___forceinline] = ACTIONS(3266),
    [anon_sym_thread_local] = ACTIONS(3266),
    [anon_sym___thread] = ACTIONS(3266),
    [anon_sym_const] = ACTIONS(3266),
    [anon_sym_constexpr] = ACTIONS(3266),
    [anon_sym_volatile] = ACTIONS(3266),
    [anon_sym_restrict] = ACTIONS(3266),
    [anon_sym___restrict__] = ACTIONS(3266),
    [anon_sym__Atomic] = ACTIONS(3266),
    [anon_sym__Noreturn] = ACTIONS(3266),
    [anon_sym_noreturn] = ACTIONS(3266),
    [anon_sym_mutable] = ACTIONS(3266),
    [anon_sym_constinit] = ACTIONS(3266),
    [anon_sym_consteval] = ACTIONS(3266),
    [anon_sym_PROGMEM] = ACTIONS(3266),
    [aux_sym_primitive_type_token1] = ACTIONS(3266),
    [anon_sym_byte] = ACTIONS(3266),
    [anon_sym_word] = ACTIONS(3266),
    [anon_sym_enum] = ACTIONS(3266),
    [anon_sym_class] = ACTIONS(3266),
    [anon_sym_struct] = ACTIONS(3266),
    [anon_sym_union] = ACTIONS(3266),
    [anon_sym_if] = ACTIONS(3266),
    [anon_sym_switch] = ACTIONS(3266),
    [anon_sym_case] = ACTIONS(3266),
    [anon_sym_default] = ACTIONS(3266),
    [anon_sym_while] = ACTIONS(3266),
    [anon_sym_do] = ACTIONS(3266),
    [anon_sym_for] = ACTIONS(3266),
    [anon_sym_return] = ACTIONS(3266),
    [anon_sym_break] = ACTIONS(3266),
    [anon_sym_continue] = ACTIONS(3266),
    [anon_sym_goto] = ACTIONS(3266),
    [anon_sym___try] = ACTIONS(3266),
    [anon_sym___leave] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3266),
    [anon_sym_compl] = ACTIONS(3266),
    [anon_sym_DASH_DASH] = ACTIONS(3268),
    [anon_sym_PLUS_PLUS] = ACTIONS(3268),
    [anon_sym_sizeof] = ACTIONS(3266),
    [anon_sym___alignof__] = ACTIONS(3266),
    [anon_sym___alignof] = ACTIONS(3266),
    [anon_sym__alignof] = ACTIONS(3266),
    [anon_sym_alignof] = ACTIONS(3266),
    [anon_sym__Alignof] = ACTIONS(3266),
    [anon_sym_offsetof] = ACTIONS(3266),
    [anon_sym__Generic] = ACTIONS(3266),
    [anon_sym_asm] = ACTIONS(3266),
    [anon_sym___asm__] = ACTIONS(3266),
    [aux_sym_number_literal_token1] = ACTIONS(3268),
    [aux_sym_number_literal_token2] = ACTIONS(3266),
    [anon_sym_L_SQUOTE] = ACTIONS(3268),
    [anon_sym_u_SQUOTE] = ACTIONS(3268),
    [anon_sym_U_SQUOTE] = ACTIONS(3268),
    [anon_sym_u8_SQUOTE] = ACTIONS(3268),
    [anon_sym_SQUOTE] = ACTIONS(3268),
    [anon_sym_L_DQUOTE] = ACTIONS(3268),
    [anon_sym_u_DQUOTE] = ACTIONS(3268),
    [anon_sym_U_DQUOTE] = ACTIONS(3268),
    [anon_sym_u8_DQUOTE] = ACTIONS(3268),
    [anon_sym_DQUOTE] = ACTIONS(3268),
    [sym_true] = ACTIONS(3266),
    [sym_false] = ACTIONS(3266),
    [anon_sym_NULL] = ACTIONS(3266),
    [anon_sym_nullptr] = ACTIONS(3266),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3266),
    [anon_sym_decltype] = ACTIONS(3266),
    [anon_sym_virtual] = ACTIONS(3266),
    [anon_sym_alignas] = ACTIONS(3266),
    [anon_sym_explicit] = ACTIONS(3266),
    [anon_sym_typename] = ACTIONS(3266),
    [anon_sym_template] = ACTIONS(3266),
    [anon_sym_operator] = ACTIONS(3266),
    [anon_sym_try] = ACTIONS(3266),
    [anon_sym_delete] = ACTIONS(3266),
    [anon_sym_throw] = ACTIONS(3266),
    [anon_sym_namespace] = ACTIONS(3266),
    [anon_sym_using] = ACTIONS(3266),
    [anon_sym_static_assert] = ACTIONS(3266),
    [anon_sym_concept] = ACTIONS(3266),
    [anon_sym_co_return] = ACTIONS(3266),
    [anon_sym_co_yield] = ACTIONS(3266),
    [anon_sym_R_DQUOTE] = ACTIONS(3268),
    [anon_sym_LR_DQUOTE] = ACTIONS(3268),
    [anon_sym_uR_DQUOTE] = ACTIONS(3268),
    [anon_sym_UR_DQUOTE] = ACTIONS(3268),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3268),
    [anon_sym_co_await] = ACTIONS(3266),
    [anon_sym_new] = ACTIONS(3266),
    [anon_sym_requires] = ACTIONS(3266),
    [sym_this] = ACTIONS(3266),
  },
  [874] = {
    [sym_identifier] = ACTIONS(3439),
    [aux_sym_preproc_include_token1] = ACTIONS(3439),
    [aux_sym_preproc_def_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token2] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3439),
    [sym_preproc_directive] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3441),
    [anon_sym_BANG] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_DASH] = ACTIONS(3439),
    [anon_sym_PLUS] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3439),
    [anon_sym_SEMI] = ACTIONS(3441),
    [anon_sym___extension__] = ACTIONS(3439),
    [anon_sym_typedef] = ACTIONS(3439),
    [anon_sym_extern] = ACTIONS(3439),
    [anon_sym___attribute__] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3441),
    [anon_sym___declspec] = ACTIONS(3439),
    [anon_sym___based] = ACTIONS(3439),
    [anon_sym___cdecl] = ACTIONS(3439),
    [anon_sym___clrcall] = ACTIONS(3439),
    [anon_sym___stdcall] = ACTIONS(3439),
    [anon_sym___fastcall] = ACTIONS(3439),
    [anon_sym___thiscall] = ACTIONS(3439),
    [anon_sym___vectorcall] = ACTIONS(3439),
    [anon_sym_LBRACE] = ACTIONS(3441),
    [anon_sym_signed] = ACTIONS(3439),
    [anon_sym_unsigned] = ACTIONS(3439),
    [anon_sym_long] = ACTIONS(3439),
    [anon_sym_short] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_register] = ACTIONS(3439),
    [anon_sym_inline] = ACTIONS(3439),
    [anon_sym___inline] = ACTIONS(3439),
    [anon_sym___inline__] = ACTIONS(3439),
    [anon_sym___forceinline] = ACTIONS(3439),
    [anon_sym_thread_local] = ACTIONS(3439),
    [anon_sym___thread] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_constexpr] = ACTIONS(3439),
    [anon_sym_volatile] = ACTIONS(3439),
    [anon_sym_restrict] = ACTIONS(3439),
    [anon_sym___restrict__] = ACTIONS(3439),
    [anon_sym__Atomic] = ACTIONS(3439),
    [anon_sym__Noreturn] = ACTIONS(3439),
    [anon_sym_noreturn] = ACTIONS(3439),
    [anon_sym_mutable] = ACTIONS(3439),
    [anon_sym_constinit] = ACTIONS(3439),
    [anon_sym_consteval] = ACTIONS(3439),
    [anon_sym_PROGMEM] = ACTIONS(3439),
    [aux_sym_primitive_type_token1] = ACTIONS(3439),
    [anon_sym_byte] = ACTIONS(3439),
    [anon_sym_word] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_struct] = ACTIONS(3439),
    [anon_sym_union] = ACTIONS(3439),
    [anon_sym_if] = ACTIONS(3439),
    [anon_sym_switch] = ACTIONS(3439),
    [anon_sym_case] = ACTIONS(3439),
    [anon_sym_default] = ACTIONS(3439),
    [anon_sym_while] = ACTIONS(3439),
    [anon_sym_do] = ACTIONS(3439),
    [anon_sym_for] = ACTIONS(3439),
    [anon_sym_return] = ACTIONS(3439),
    [anon_sym_break] = ACTIONS(3439),
    [anon_sym_continue] = ACTIONS(3439),
    [anon_sym_goto] = ACTIONS(3439),
    [anon_sym___try] = ACTIONS(3439),
    [anon_sym___leave] = ACTIONS(3439),
    [anon_sym_not] = ACTIONS(3439),
    [anon_sym_compl] = ACTIONS(3439),
    [anon_sym_DASH_DASH] = ACTIONS(3441),
    [anon_sym_PLUS_PLUS] = ACTIONS(3441),
    [anon_sym_sizeof] = ACTIONS(3439),
    [anon_sym___alignof__] = ACTIONS(3439),
    [anon_sym___alignof] = ACTIONS(3439),
    [anon_sym__alignof] = ACTIONS(3439),
    [anon_sym_alignof] = ACTIONS(3439),
    [anon_sym__Alignof] = ACTIONS(3439),
    [anon_sym_offsetof] = ACTIONS(3439),
    [anon_sym__Generic] = ACTIONS(3439),
    [anon_sym_asm] = ACTIONS(3439),
    [anon_sym___asm__] = ACTIONS(3439),
    [aux_sym_number_literal_token1] = ACTIONS(3441),
    [aux_sym_number_literal_token2] = ACTIONS(3439),
    [anon_sym_L_SQUOTE] = ACTIONS(3441),
    [anon_sym_u_SQUOTE] = ACTIONS(3441),
    [anon_sym_U_SQUOTE] = ACTIONS(3441),
    [anon_sym_u8_SQUOTE] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [anon_sym_L_DQUOTE] = ACTIONS(3441),
    [anon_sym_u_DQUOTE] = ACTIONS(3441),
    [anon_sym_U_DQUOTE] = ACTIONS(3441),
    [anon_sym_u8_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE] = ACTIONS(3441),
    [sym_true] = ACTIONS(3439),
    [sym_false] = ACTIONS(3439),
    [anon_sym_NULL] = ACTIONS(3439),
    [anon_sym_nullptr] = ACTIONS(3439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3439),
    [anon_sym_decltype] = ACTIONS(3439),
    [anon_sym_virtual] = ACTIONS(3439),
    [anon_sym_alignas] = ACTIONS(3439),
    [anon_sym_explicit] = ACTIONS(3439),
    [anon_sym_typename] = ACTIONS(3439),
    [anon_sym_template] = ACTIONS(3439),
    [anon_sym_operator] = ACTIONS(3439),
    [anon_sym_try] = ACTIONS(3439),
    [anon_sym_delete] = ACTIONS(3439),
    [anon_sym_throw] = ACTIONS(3439),
    [anon_sym_namespace] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_static_assert] = ACTIONS(3439),
    [anon_sym_concept] = ACTIONS(3439),
    [anon_sym_co_return] = ACTIONS(3439),
    [anon_sym_co_yield] = ACTIONS(3439),
    [anon_sym_R_DQUOTE] = ACTIONS(3441),
    [anon_sym_LR_DQUOTE] = ACTIONS(3441),
    [anon_sym_uR_DQUOTE] = ACTIONS(3441),
    [anon_sym_UR_DQUOTE] = ACTIONS(3441),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3441),
    [anon_sym_co_await] = ACTIONS(3439),
    [anon_sym_new] = ACTIONS(3439),
    [anon_sym_requires] = ACTIONS(3439),
    [sym_this] = ACTIONS(3439),
  },
  [875] = {
    [sym_identifier] = ACTIONS(3439),
    [aux_sym_preproc_include_token1] = ACTIONS(3439),
    [aux_sym_preproc_def_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token2] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3439),
    [sym_preproc_directive] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3441),
    [anon_sym_BANG] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_DASH] = ACTIONS(3439),
    [anon_sym_PLUS] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3439),
    [anon_sym_SEMI] = ACTIONS(3441),
    [anon_sym___extension__] = ACTIONS(3439),
    [anon_sym_typedef] = ACTIONS(3439),
    [anon_sym_extern] = ACTIONS(3439),
    [anon_sym___attribute__] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3441),
    [anon_sym___declspec] = ACTIONS(3439),
    [anon_sym___based] = ACTIONS(3439),
    [anon_sym___cdecl] = ACTIONS(3439),
    [anon_sym___clrcall] = ACTIONS(3439),
    [anon_sym___stdcall] = ACTIONS(3439),
    [anon_sym___fastcall] = ACTIONS(3439),
    [anon_sym___thiscall] = ACTIONS(3439),
    [anon_sym___vectorcall] = ACTIONS(3439),
    [anon_sym_LBRACE] = ACTIONS(3441),
    [anon_sym_signed] = ACTIONS(3439),
    [anon_sym_unsigned] = ACTIONS(3439),
    [anon_sym_long] = ACTIONS(3439),
    [anon_sym_short] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_register] = ACTIONS(3439),
    [anon_sym_inline] = ACTIONS(3439),
    [anon_sym___inline] = ACTIONS(3439),
    [anon_sym___inline__] = ACTIONS(3439),
    [anon_sym___forceinline] = ACTIONS(3439),
    [anon_sym_thread_local] = ACTIONS(3439),
    [anon_sym___thread] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_constexpr] = ACTIONS(3439),
    [anon_sym_volatile] = ACTIONS(3439),
    [anon_sym_restrict] = ACTIONS(3439),
    [anon_sym___restrict__] = ACTIONS(3439),
    [anon_sym__Atomic] = ACTIONS(3439),
    [anon_sym__Noreturn] = ACTIONS(3439),
    [anon_sym_noreturn] = ACTIONS(3439),
    [anon_sym_mutable] = ACTIONS(3439),
    [anon_sym_constinit] = ACTIONS(3439),
    [anon_sym_consteval] = ACTIONS(3439),
    [anon_sym_PROGMEM] = ACTIONS(3439),
    [aux_sym_primitive_type_token1] = ACTIONS(3439),
    [anon_sym_byte] = ACTIONS(3439),
    [anon_sym_word] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_struct] = ACTIONS(3439),
    [anon_sym_union] = ACTIONS(3439),
    [anon_sym_if] = ACTIONS(3439),
    [anon_sym_switch] = ACTIONS(3439),
    [anon_sym_case] = ACTIONS(3439),
    [anon_sym_default] = ACTIONS(3439),
    [anon_sym_while] = ACTIONS(3439),
    [anon_sym_do] = ACTIONS(3439),
    [anon_sym_for] = ACTIONS(3439),
    [anon_sym_return] = ACTIONS(3439),
    [anon_sym_break] = ACTIONS(3439),
    [anon_sym_continue] = ACTIONS(3439),
    [anon_sym_goto] = ACTIONS(3439),
    [anon_sym___try] = ACTIONS(3439),
    [anon_sym___leave] = ACTIONS(3439),
    [anon_sym_not] = ACTIONS(3439),
    [anon_sym_compl] = ACTIONS(3439),
    [anon_sym_DASH_DASH] = ACTIONS(3441),
    [anon_sym_PLUS_PLUS] = ACTIONS(3441),
    [anon_sym_sizeof] = ACTIONS(3439),
    [anon_sym___alignof__] = ACTIONS(3439),
    [anon_sym___alignof] = ACTIONS(3439),
    [anon_sym__alignof] = ACTIONS(3439),
    [anon_sym_alignof] = ACTIONS(3439),
    [anon_sym__Alignof] = ACTIONS(3439),
    [anon_sym_offsetof] = ACTIONS(3439),
    [anon_sym__Generic] = ACTIONS(3439),
    [anon_sym_asm] = ACTIONS(3439),
    [anon_sym___asm__] = ACTIONS(3439),
    [aux_sym_number_literal_token1] = ACTIONS(3441),
    [aux_sym_number_literal_token2] = ACTIONS(3439),
    [anon_sym_L_SQUOTE] = ACTIONS(3441),
    [anon_sym_u_SQUOTE] = ACTIONS(3441),
    [anon_sym_U_SQUOTE] = ACTIONS(3441),
    [anon_sym_u8_SQUOTE] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [anon_sym_L_DQUOTE] = ACTIONS(3441),
    [anon_sym_u_DQUOTE] = ACTIONS(3441),
    [anon_sym_U_DQUOTE] = ACTIONS(3441),
    [anon_sym_u8_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE] = ACTIONS(3441),
    [sym_true] = ACTIONS(3439),
    [sym_false] = ACTIONS(3439),
    [anon_sym_NULL] = ACTIONS(3439),
    [anon_sym_nullptr] = ACTIONS(3439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3439),
    [anon_sym_decltype] = ACTIONS(3439),
    [anon_sym_virtual] = ACTIONS(3439),
    [anon_sym_alignas] = ACTIONS(3439),
    [anon_sym_explicit] = ACTIONS(3439),
    [anon_sym_typename] = ACTIONS(3439),
    [anon_sym_template] = ACTIONS(3439),
    [anon_sym_operator] = ACTIONS(3439),
    [anon_sym_try] = ACTIONS(3439),
    [anon_sym_delete] = ACTIONS(3439),
    [anon_sym_throw] = ACTIONS(3439),
    [anon_sym_namespace] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_static_assert] = ACTIONS(3439),
    [anon_sym_concept] = ACTIONS(3439),
    [anon_sym_co_return] = ACTIONS(3439),
    [anon_sym_co_yield] = ACTIONS(3439),
    [anon_sym_R_DQUOTE] = ACTIONS(3441),
    [anon_sym_LR_DQUOTE] = ACTIONS(3441),
    [anon_sym_uR_DQUOTE] = ACTIONS(3441),
    [anon_sym_UR_DQUOTE] = ACTIONS(3441),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3441),
    [anon_sym_co_await] = ACTIONS(3439),
    [anon_sym_new] = ACTIONS(3439),
    [anon_sym_requires] = ACTIONS(3439),
    [sym_this] = ACTIONS(3439),
  },
  [876] = {
    [sym_identifier] = ACTIONS(3270),
    [aux_sym_preproc_include_token1] = ACTIONS(3270),
    [aux_sym_preproc_def_token1] = ACTIONS(3270),
    [aux_sym_preproc_if_token1] = ACTIONS(3270),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3270),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3270),
    [sym_preproc_directive] = ACTIONS(3270),
    [anon_sym_LPAREN2] = ACTIONS(3272),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3270),
    [anon_sym_PLUS] = ACTIONS(3270),
    [anon_sym_STAR] = ACTIONS(3272),
    [anon_sym_AMP_AMP] = ACTIONS(3272),
    [anon_sym_AMP] = ACTIONS(3270),
    [anon_sym_SEMI] = ACTIONS(3272),
    [anon_sym___extension__] = ACTIONS(3270),
    [anon_sym_typedef] = ACTIONS(3270),
    [anon_sym_extern] = ACTIONS(3270),
    [anon_sym___attribute__] = ACTIONS(3270),
    [anon_sym_COLON_COLON] = ACTIONS(3272),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3272),
    [anon_sym___declspec] = ACTIONS(3270),
    [anon_sym___based] = ACTIONS(3270),
    [anon_sym___cdecl] = ACTIONS(3270),
    [anon_sym___clrcall] = ACTIONS(3270),
    [anon_sym___stdcall] = ACTIONS(3270),
    [anon_sym___fastcall] = ACTIONS(3270),
    [anon_sym___thiscall] = ACTIONS(3270),
    [anon_sym___vectorcall] = ACTIONS(3270),
    [anon_sym_LBRACE] = ACTIONS(3272),
    [anon_sym_RBRACE] = ACTIONS(3272),
    [anon_sym_signed] = ACTIONS(3270),
    [anon_sym_unsigned] = ACTIONS(3270),
    [anon_sym_long] = ACTIONS(3270),
    [anon_sym_short] = ACTIONS(3270),
    [anon_sym_LBRACK] = ACTIONS(3270),
    [anon_sym_static] = ACTIONS(3270),
    [anon_sym_register] = ACTIONS(3270),
    [anon_sym_inline] = ACTIONS(3270),
    [anon_sym___inline] = ACTIONS(3270),
    [anon_sym___inline__] = ACTIONS(3270),
    [anon_sym___forceinline] = ACTIONS(3270),
    [anon_sym_thread_local] = ACTIONS(3270),
    [anon_sym___thread] = ACTIONS(3270),
    [anon_sym_const] = ACTIONS(3270),
    [anon_sym_constexpr] = ACTIONS(3270),
    [anon_sym_volatile] = ACTIONS(3270),
    [anon_sym_restrict] = ACTIONS(3270),
    [anon_sym___restrict__] = ACTIONS(3270),
    [anon_sym__Atomic] = ACTIONS(3270),
    [anon_sym__Noreturn] = ACTIONS(3270),
    [anon_sym_noreturn] = ACTIONS(3270),
    [anon_sym_mutable] = ACTIONS(3270),
    [anon_sym_constinit] = ACTIONS(3270),
    [anon_sym_consteval] = ACTIONS(3270),
    [anon_sym_PROGMEM] = ACTIONS(3270),
    [aux_sym_primitive_type_token1] = ACTIONS(3270),
    [anon_sym_byte] = ACTIONS(3270),
    [anon_sym_word] = ACTIONS(3270),
    [anon_sym_enum] = ACTIONS(3270),
    [anon_sym_class] = ACTIONS(3270),
    [anon_sym_struct] = ACTIONS(3270),
    [anon_sym_union] = ACTIONS(3270),
    [anon_sym_if] = ACTIONS(3270),
    [anon_sym_switch] = ACTIONS(3270),
    [anon_sym_case] = ACTIONS(3270),
    [anon_sym_default] = ACTIONS(3270),
    [anon_sym_while] = ACTIONS(3270),
    [anon_sym_do] = ACTIONS(3270),
    [anon_sym_for] = ACTIONS(3270),
    [anon_sym_return] = ACTIONS(3270),
    [anon_sym_break] = ACTIONS(3270),
    [anon_sym_continue] = ACTIONS(3270),
    [anon_sym_goto] = ACTIONS(3270),
    [anon_sym___try] = ACTIONS(3270),
    [anon_sym___leave] = ACTIONS(3270),
    [anon_sym_not] = ACTIONS(3270),
    [anon_sym_compl] = ACTIONS(3270),
    [anon_sym_DASH_DASH] = ACTIONS(3272),
    [anon_sym_PLUS_PLUS] = ACTIONS(3272),
    [anon_sym_sizeof] = ACTIONS(3270),
    [anon_sym___alignof__] = ACTIONS(3270),
    [anon_sym___alignof] = ACTIONS(3270),
    [anon_sym__alignof] = ACTIONS(3270),
    [anon_sym_alignof] = ACTIONS(3270),
    [anon_sym__Alignof] = ACTIONS(3270),
    [anon_sym_offsetof] = ACTIONS(3270),
    [anon_sym__Generic] = ACTIONS(3270),
    [anon_sym_asm] = ACTIONS(3270),
    [anon_sym___asm__] = ACTIONS(3270),
    [aux_sym_number_literal_token1] = ACTIONS(3272),
    [aux_sym_number_literal_token2] = ACTIONS(3270),
    [anon_sym_L_SQUOTE] = ACTIONS(3272),
    [anon_sym_u_SQUOTE] = ACTIONS(3272),
    [anon_sym_U_SQUOTE] = ACTIONS(3272),
    [anon_sym_u8_SQUOTE] = ACTIONS(3272),
    [anon_sym_SQUOTE] = ACTIONS(3272),
    [anon_sym_L_DQUOTE] = ACTIONS(3272),
    [anon_sym_u_DQUOTE] = ACTIONS(3272),
    [anon_sym_U_DQUOTE] = ACTIONS(3272),
    [anon_sym_u8_DQUOTE] = ACTIONS(3272),
    [anon_sym_DQUOTE] = ACTIONS(3272),
    [sym_true] = ACTIONS(3270),
    [sym_false] = ACTIONS(3270),
    [anon_sym_NULL] = ACTIONS(3270),
    [anon_sym_nullptr] = ACTIONS(3270),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3270),
    [anon_sym_decltype] = ACTIONS(3270),
    [anon_sym_virtual] = ACTIONS(3270),
    [anon_sym_alignas] = ACTIONS(3270),
    [anon_sym_explicit] = ACTIONS(3270),
    [anon_sym_typename] = ACTIONS(3270),
    [anon_sym_template] = ACTIONS(3270),
    [anon_sym_operator] = ACTIONS(3270),
    [anon_sym_try] = ACTIONS(3270),
    [anon_sym_delete] = ACTIONS(3270),
    [anon_sym_throw] = ACTIONS(3270),
    [anon_sym_namespace] = ACTIONS(3270),
    [anon_sym_using] = ACTIONS(3270),
    [anon_sym_static_assert] = ACTIONS(3270),
    [anon_sym_concept] = ACTIONS(3270),
    [anon_sym_co_return] = ACTIONS(3270),
    [anon_sym_co_yield] = ACTIONS(3270),
    [anon_sym_R_DQUOTE] = ACTIONS(3272),
    [anon_sym_LR_DQUOTE] = ACTIONS(3272),
    [anon_sym_uR_DQUOTE] = ACTIONS(3272),
    [anon_sym_UR_DQUOTE] = ACTIONS(3272),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3272),
    [anon_sym_co_await] = ACTIONS(3270),
    [anon_sym_new] = ACTIONS(3270),
    [anon_sym_requires] = ACTIONS(3270),
    [sym_this] = ACTIONS(3270),
  },
  [877] = {
    [sym_identifier] = ACTIONS(3258),
    [aux_sym_preproc_include_token1] = ACTIONS(3258),
    [aux_sym_preproc_def_token1] = ACTIONS(3258),
    [aux_sym_preproc_if_token1] = ACTIONS(3258),
    [aux_sym_preproc_if_token2] = ACTIONS(3258),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3258),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3258),
    [sym_preproc_directive] = ACTIONS(3258),
    [anon_sym_LPAREN2] = ACTIONS(3260),
    [anon_sym_BANG] = ACTIONS(3260),
    [anon_sym_TILDE] = ACTIONS(3260),
    [anon_sym_DASH] = ACTIONS(3258),
    [anon_sym_PLUS] = ACTIONS(3258),
    [anon_sym_STAR] = ACTIONS(3260),
    [anon_sym_AMP_AMP] = ACTIONS(3260),
    [anon_sym_AMP] = ACTIONS(3258),
    [anon_sym_SEMI] = ACTIONS(3260),
    [anon_sym___extension__] = ACTIONS(3258),
    [anon_sym_typedef] = ACTIONS(3258),
    [anon_sym_extern] = ACTIONS(3258),
    [anon_sym___attribute__] = ACTIONS(3258),
    [anon_sym_COLON_COLON] = ACTIONS(3260),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3260),
    [anon_sym___declspec] = ACTIONS(3258),
    [anon_sym___based] = ACTIONS(3258),
    [anon_sym___cdecl] = ACTIONS(3258),
    [anon_sym___clrcall] = ACTIONS(3258),
    [anon_sym___stdcall] = ACTIONS(3258),
    [anon_sym___fastcall] = ACTIONS(3258),
    [anon_sym___thiscall] = ACTIONS(3258),
    [anon_sym___vectorcall] = ACTIONS(3258),
    [anon_sym_LBRACE] = ACTIONS(3260),
    [anon_sym_signed] = ACTIONS(3258),
    [anon_sym_unsigned] = ACTIONS(3258),
    [anon_sym_long] = ACTIONS(3258),
    [anon_sym_short] = ACTIONS(3258),
    [anon_sym_LBRACK] = ACTIONS(3258),
    [anon_sym_static] = ACTIONS(3258),
    [anon_sym_register] = ACTIONS(3258),
    [anon_sym_inline] = ACTIONS(3258),
    [anon_sym___inline] = ACTIONS(3258),
    [anon_sym___inline__] = ACTIONS(3258),
    [anon_sym___forceinline] = ACTIONS(3258),
    [anon_sym_thread_local] = ACTIONS(3258),
    [anon_sym___thread] = ACTIONS(3258),
    [anon_sym_const] = ACTIONS(3258),
    [anon_sym_constexpr] = ACTIONS(3258),
    [anon_sym_volatile] = ACTIONS(3258),
    [anon_sym_restrict] = ACTIONS(3258),
    [anon_sym___restrict__] = ACTIONS(3258),
    [anon_sym__Atomic] = ACTIONS(3258),
    [anon_sym__Noreturn] = ACTIONS(3258),
    [anon_sym_noreturn] = ACTIONS(3258),
    [anon_sym_mutable] = ACTIONS(3258),
    [anon_sym_constinit] = ACTIONS(3258),
    [anon_sym_consteval] = ACTIONS(3258),
    [anon_sym_PROGMEM] = ACTIONS(3258),
    [aux_sym_primitive_type_token1] = ACTIONS(3258),
    [anon_sym_byte] = ACTIONS(3258),
    [anon_sym_word] = ACTIONS(3258),
    [anon_sym_enum] = ACTIONS(3258),
    [anon_sym_class] = ACTIONS(3258),
    [anon_sym_struct] = ACTIONS(3258),
    [anon_sym_union] = ACTIONS(3258),
    [anon_sym_if] = ACTIONS(3258),
    [anon_sym_switch] = ACTIONS(3258),
    [anon_sym_case] = ACTIONS(3258),
    [anon_sym_default] = ACTIONS(3258),
    [anon_sym_while] = ACTIONS(3258),
    [anon_sym_do] = ACTIONS(3258),
    [anon_sym_for] = ACTIONS(3258),
    [anon_sym_return] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3258),
    [anon_sym_continue] = ACTIONS(3258),
    [anon_sym_goto] = ACTIONS(3258),
    [anon_sym___try] = ACTIONS(3258),
    [anon_sym___leave] = ACTIONS(3258),
    [anon_sym_not] = ACTIONS(3258),
    [anon_sym_compl] = ACTIONS(3258),
    [anon_sym_DASH_DASH] = ACTIONS(3260),
    [anon_sym_PLUS_PLUS] = ACTIONS(3260),
    [anon_sym_sizeof] = ACTIONS(3258),
    [anon_sym___alignof__] = ACTIONS(3258),
    [anon_sym___alignof] = ACTIONS(3258),
    [anon_sym__alignof] = ACTIONS(3258),
    [anon_sym_alignof] = ACTIONS(3258),
    [anon_sym__Alignof] = ACTIONS(3258),
    [anon_sym_offsetof] = ACTIONS(3258),
    [anon_sym__Generic] = ACTIONS(3258),
    [anon_sym_asm] = ACTIONS(3258),
    [anon_sym___asm__] = ACTIONS(3258),
    [aux_sym_number_literal_token1] = ACTIONS(3260),
    [aux_sym_number_literal_token2] = ACTIONS(3258),
    [anon_sym_L_SQUOTE] = ACTIONS(3260),
    [anon_sym_u_SQUOTE] = ACTIONS(3260),
    [anon_sym_U_SQUOTE] = ACTIONS(3260),
    [anon_sym_u8_SQUOTE] = ACTIONS(3260),
    [anon_sym_SQUOTE] = ACTIONS(3260),
    [anon_sym_L_DQUOTE] = ACTIONS(3260),
    [anon_sym_u_DQUOTE] = ACTIONS(3260),
    [anon_sym_U_DQUOTE] = ACTIONS(3260),
    [anon_sym_u8_DQUOTE] = ACTIONS(3260),
    [anon_sym_DQUOTE] = ACTIONS(3260),
    [sym_true] = ACTIONS(3258),
    [sym_false] = ACTIONS(3258),
    [anon_sym_NULL] = ACTIONS(3258),
    [anon_sym_nullptr] = ACTIONS(3258),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3258),
    [anon_sym_decltype] = ACTIONS(3258),
    [anon_sym_virtual] = ACTIONS(3258),
    [anon_sym_alignas] = ACTIONS(3258),
    [anon_sym_explicit] = ACTIONS(3258),
    [anon_sym_typename] = ACTIONS(3258),
    [anon_sym_template] = ACTIONS(3258),
    [anon_sym_operator] = ACTIONS(3258),
    [anon_sym_try] = ACTIONS(3258),
    [anon_sym_delete] = ACTIONS(3258),
    [anon_sym_throw] = ACTIONS(3258),
    [anon_sym_namespace] = ACTIONS(3258),
    [anon_sym_using] = ACTIONS(3258),
    [anon_sym_static_assert] = ACTIONS(3258),
    [anon_sym_concept] = ACTIONS(3258),
    [anon_sym_co_return] = ACTIONS(3258),
    [anon_sym_co_yield] = ACTIONS(3258),
    [anon_sym_R_DQUOTE] = ACTIONS(3260),
    [anon_sym_LR_DQUOTE] = ACTIONS(3260),
    [anon_sym_uR_DQUOTE] = ACTIONS(3260),
    [anon_sym_UR_DQUOTE] = ACTIONS(3260),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3260),
    [anon_sym_co_await] = ACTIONS(3258),
    [anon_sym_new] = ACTIONS(3258),
    [anon_sym_requires] = ACTIONS(3258),
    [sym_this] = ACTIONS(3258),
  },
  [878] = {
    [sym_identifier] = ACTIONS(3262),
    [aux_sym_preproc_include_token1] = ACTIONS(3262),
    [aux_sym_preproc_def_token1] = ACTIONS(3262),
    [aux_sym_preproc_if_token1] = ACTIONS(3262),
    [aux_sym_preproc_if_token2] = ACTIONS(3262),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3262),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3262),
    [sym_preproc_directive] = ACTIONS(3262),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_BANG] = ACTIONS(3264),
    [anon_sym_TILDE] = ACTIONS(3264),
    [anon_sym_DASH] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3262),
    [anon_sym_STAR] = ACTIONS(3264),
    [anon_sym_AMP_AMP] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3262),
    [anon_sym_SEMI] = ACTIONS(3264),
    [anon_sym___extension__] = ACTIONS(3262),
    [anon_sym_typedef] = ACTIONS(3262),
    [anon_sym_extern] = ACTIONS(3262),
    [anon_sym___attribute__] = ACTIONS(3262),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3264),
    [anon_sym___declspec] = ACTIONS(3262),
    [anon_sym___based] = ACTIONS(3262),
    [anon_sym___cdecl] = ACTIONS(3262),
    [anon_sym___clrcall] = ACTIONS(3262),
    [anon_sym___stdcall] = ACTIONS(3262),
    [anon_sym___fastcall] = ACTIONS(3262),
    [anon_sym___thiscall] = ACTIONS(3262),
    [anon_sym___vectorcall] = ACTIONS(3262),
    [anon_sym_LBRACE] = ACTIONS(3264),
    [anon_sym_signed] = ACTIONS(3262),
    [anon_sym_unsigned] = ACTIONS(3262),
    [anon_sym_long] = ACTIONS(3262),
    [anon_sym_short] = ACTIONS(3262),
    [anon_sym_LBRACK] = ACTIONS(3262),
    [anon_sym_static] = ACTIONS(3262),
    [anon_sym_register] = ACTIONS(3262),
    [anon_sym_inline] = ACTIONS(3262),
    [anon_sym___inline] = ACTIONS(3262),
    [anon_sym___inline__] = ACTIONS(3262),
    [anon_sym___forceinline] = ACTIONS(3262),
    [anon_sym_thread_local] = ACTIONS(3262),
    [anon_sym___thread] = ACTIONS(3262),
    [anon_sym_const] = ACTIONS(3262),
    [anon_sym_constexpr] = ACTIONS(3262),
    [anon_sym_volatile] = ACTIONS(3262),
    [anon_sym_restrict] = ACTIONS(3262),
    [anon_sym___restrict__] = ACTIONS(3262),
    [anon_sym__Atomic] = ACTIONS(3262),
    [anon_sym__Noreturn] = ACTIONS(3262),
    [anon_sym_noreturn] = ACTIONS(3262),
    [anon_sym_mutable] = ACTIONS(3262),
    [anon_sym_constinit] = ACTIONS(3262),
    [anon_sym_consteval] = ACTIONS(3262),
    [anon_sym_PROGMEM] = ACTIONS(3262),
    [aux_sym_primitive_type_token1] = ACTIONS(3262),
    [anon_sym_byte] = ACTIONS(3262),
    [anon_sym_word] = ACTIONS(3262),
    [anon_sym_enum] = ACTIONS(3262),
    [anon_sym_class] = ACTIONS(3262),
    [anon_sym_struct] = ACTIONS(3262),
    [anon_sym_union] = ACTIONS(3262),
    [anon_sym_if] = ACTIONS(3262),
    [anon_sym_switch] = ACTIONS(3262),
    [anon_sym_case] = ACTIONS(3262),
    [anon_sym_default] = ACTIONS(3262),
    [anon_sym_while] = ACTIONS(3262),
    [anon_sym_do] = ACTIONS(3262),
    [anon_sym_for] = ACTIONS(3262),
    [anon_sym_return] = ACTIONS(3262),
    [anon_sym_break] = ACTIONS(3262),
    [anon_sym_continue] = ACTIONS(3262),
    [anon_sym_goto] = ACTIONS(3262),
    [anon_sym___try] = ACTIONS(3262),
    [anon_sym___leave] = ACTIONS(3262),
    [anon_sym_not] = ACTIONS(3262),
    [anon_sym_compl] = ACTIONS(3262),
    [anon_sym_DASH_DASH] = ACTIONS(3264),
    [anon_sym_PLUS_PLUS] = ACTIONS(3264),
    [anon_sym_sizeof] = ACTIONS(3262),
    [anon_sym___alignof__] = ACTIONS(3262),
    [anon_sym___alignof] = ACTIONS(3262),
    [anon_sym__alignof] = ACTIONS(3262),
    [anon_sym_alignof] = ACTIONS(3262),
    [anon_sym__Alignof] = ACTIONS(3262),
    [anon_sym_offsetof] = ACTIONS(3262),
    [anon_sym__Generic] = ACTIONS(3262),
    [anon_sym_asm] = ACTIONS(3262),
    [anon_sym___asm__] = ACTIONS(3262),
    [aux_sym_number_literal_token1] = ACTIONS(3264),
    [aux_sym_number_literal_token2] = ACTIONS(3262),
    [anon_sym_L_SQUOTE] = ACTIONS(3264),
    [anon_sym_u_SQUOTE] = ACTIONS(3264),
    [anon_sym_U_SQUOTE] = ACTIONS(3264),
    [anon_sym_u8_SQUOTE] = ACTIONS(3264),
    [anon_sym_SQUOTE] = ACTIONS(3264),
    [anon_sym_L_DQUOTE] = ACTIONS(3264),
    [anon_sym_u_DQUOTE] = ACTIONS(3264),
    [anon_sym_U_DQUOTE] = ACTIONS(3264),
    [anon_sym_u8_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE] = ACTIONS(3264),
    [sym_true] = ACTIONS(3262),
    [sym_false] = ACTIONS(3262),
    [anon_sym_NULL] = ACTIONS(3262),
    [anon_sym_nullptr] = ACTIONS(3262),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3262),
    [anon_sym_decltype] = ACTIONS(3262),
    [anon_sym_virtual] = ACTIONS(3262),
    [anon_sym_alignas] = ACTIONS(3262),
    [anon_sym_explicit] = ACTIONS(3262),
    [anon_sym_typename] = ACTIONS(3262),
    [anon_sym_template] = ACTIONS(3262),
    [anon_sym_operator] = ACTIONS(3262),
    [anon_sym_try] = ACTIONS(3262),
    [anon_sym_delete] = ACTIONS(3262),
    [anon_sym_throw] = ACTIONS(3262),
    [anon_sym_namespace] = ACTIONS(3262),
    [anon_sym_using] = ACTIONS(3262),
    [anon_sym_static_assert] = ACTIONS(3262),
    [anon_sym_concept] = ACTIONS(3262),
    [anon_sym_co_return] = ACTIONS(3262),
    [anon_sym_co_yield] = ACTIONS(3262),
    [anon_sym_R_DQUOTE] = ACTIONS(3264),
    [anon_sym_LR_DQUOTE] = ACTIONS(3264),
    [anon_sym_uR_DQUOTE] = ACTIONS(3264),
    [anon_sym_UR_DQUOTE] = ACTIONS(3264),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3264),
    [anon_sym_co_await] = ACTIONS(3262),
    [anon_sym_new] = ACTIONS(3262),
    [anon_sym_requires] = ACTIONS(3262),
    [sym_this] = ACTIONS(3262),
  },
  [879] = {
    [ts_builtin_sym_end] = ACTIONS(2265),
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_include_token1] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [anon_sym_COMMA] = ACTIONS(3176),
    [anon_sym_RPAREN] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_BANG] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym___cdecl] = ACTIONS(2267),
    [anon_sym___clrcall] = ACTIONS(2267),
    [anon_sym___stdcall] = ACTIONS(2267),
    [anon_sym___fastcall] = ACTIONS(2267),
    [anon_sym___thiscall] = ACTIONS(2267),
    [anon_sym___vectorcall] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2265),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_case] = ACTIONS(2267),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_return] = ACTIONS(2267),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_continue] = ACTIONS(2267),
    [anon_sym_goto] = ACTIONS(2267),
    [anon_sym_not] = ACTIONS(2267),
    [anon_sym_compl] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2265),
    [anon_sym_PLUS_PLUS] = ACTIONS(2265),
    [anon_sym_sizeof] = ACTIONS(2267),
    [anon_sym___alignof__] = ACTIONS(2267),
    [anon_sym___alignof] = ACTIONS(2267),
    [anon_sym__alignof] = ACTIONS(2267),
    [anon_sym_alignof] = ACTIONS(2267),
    [anon_sym__Alignof] = ACTIONS(2267),
    [anon_sym_offsetof] = ACTIONS(2267),
    [anon_sym__Generic] = ACTIONS(2267),
    [anon_sym_asm] = ACTIONS(2267),
    [anon_sym___asm__] = ACTIONS(2267),
    [aux_sym_number_literal_token1] = ACTIONS(2265),
    [aux_sym_number_literal_token2] = ACTIONS(2267),
    [anon_sym_L_SQUOTE] = ACTIONS(2265),
    [anon_sym_u_SQUOTE] = ACTIONS(2265),
    [anon_sym_U_SQUOTE] = ACTIONS(2265),
    [anon_sym_u8_SQUOTE] = ACTIONS(2265),
    [anon_sym_SQUOTE] = ACTIONS(2265),
    [anon_sym_L_DQUOTE] = ACTIONS(2265),
    [anon_sym_u_DQUOTE] = ACTIONS(2265),
    [anon_sym_U_DQUOTE] = ACTIONS(2265),
    [anon_sym_u8_DQUOTE] = ACTIONS(2265),
    [anon_sym_DQUOTE] = ACTIONS(2265),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [anon_sym_NULL] = ACTIONS(2267),
    [anon_sym_nullptr] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_try] = ACTIONS(2267),
    [anon_sym_delete] = ACTIONS(2267),
    [anon_sym_throw] = ACTIONS(2267),
    [anon_sym_namespace] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym_concept] = ACTIONS(2267),
    [anon_sym_co_return] = ACTIONS(2267),
    [anon_sym_co_yield] = ACTIONS(2267),
    [anon_sym_R_DQUOTE] = ACTIONS(2265),
    [anon_sym_LR_DQUOTE] = ACTIONS(2265),
    [anon_sym_uR_DQUOTE] = ACTIONS(2265),
    [anon_sym_UR_DQUOTE] = ACTIONS(2265),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2265),
    [anon_sym_co_await] = ACTIONS(2267),
    [anon_sym_new] = ACTIONS(2267),
    [anon_sym_requires] = ACTIONS(2267),
    [sym_this] = ACTIONS(2267),
  },
  [880] = {
    [sym_identifier] = ACTIONS(3443),
    [aux_sym_preproc_include_token1] = ACTIONS(3443),
    [aux_sym_preproc_def_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token2] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3443),
    [sym_preproc_directive] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3445),
    [anon_sym_BANG] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_AMP_AMP] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_SEMI] = ACTIONS(3445),
    [anon_sym___extension__] = ACTIONS(3443),
    [anon_sym_typedef] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym___attribute__] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3445),
    [anon_sym___declspec] = ACTIONS(3443),
    [anon_sym___based] = ACTIONS(3443),
    [anon_sym___cdecl] = ACTIONS(3443),
    [anon_sym___clrcall] = ACTIONS(3443),
    [anon_sym___stdcall] = ACTIONS(3443),
    [anon_sym___fastcall] = ACTIONS(3443),
    [anon_sym___thiscall] = ACTIONS(3443),
    [anon_sym___vectorcall] = ACTIONS(3443),
    [anon_sym_LBRACE] = ACTIONS(3445),
    [anon_sym_signed] = ACTIONS(3443),
    [anon_sym_unsigned] = ACTIONS(3443),
    [anon_sym_long] = ACTIONS(3443),
    [anon_sym_short] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_register] = ACTIONS(3443),
    [anon_sym_inline] = ACTIONS(3443),
    [anon_sym___inline] = ACTIONS(3443),
    [anon_sym___inline__] = ACTIONS(3443),
    [anon_sym___forceinline] = ACTIONS(3443),
    [anon_sym_thread_local] = ACTIONS(3443),
    [anon_sym___thread] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_constexpr] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_restrict] = ACTIONS(3443),
    [anon_sym___restrict__] = ACTIONS(3443),
    [anon_sym__Atomic] = ACTIONS(3443),
    [anon_sym__Noreturn] = ACTIONS(3443),
    [anon_sym_noreturn] = ACTIONS(3443),
    [anon_sym_mutable] = ACTIONS(3443),
    [anon_sym_constinit] = ACTIONS(3443),
    [anon_sym_consteval] = ACTIONS(3443),
    [anon_sym_PROGMEM] = ACTIONS(3443),
    [aux_sym_primitive_type_token1] = ACTIONS(3443),
    [anon_sym_byte] = ACTIONS(3443),
    [anon_sym_word] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_union] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_switch] = ACTIONS(3443),
    [anon_sym_case] = ACTIONS(3443),
    [anon_sym_default] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_break] = ACTIONS(3443),
    [anon_sym_continue] = ACTIONS(3443),
    [anon_sym_goto] = ACTIONS(3443),
    [anon_sym___try] = ACTIONS(3443),
    [anon_sym___leave] = ACTIONS(3443),
    [anon_sym_not] = ACTIONS(3443),
    [anon_sym_compl] = ACTIONS(3443),
    [anon_sym_DASH_DASH] = ACTIONS(3445),
    [anon_sym_PLUS_PLUS] = ACTIONS(3445),
    [anon_sym_sizeof] = ACTIONS(3443),
    [anon_sym___alignof__] = ACTIONS(3443),
    [anon_sym___alignof] = ACTIONS(3443),
    [anon_sym__alignof] = ACTIONS(3443),
    [anon_sym_alignof] = ACTIONS(3443),
    [anon_sym__Alignof] = ACTIONS(3443),
    [anon_sym_offsetof] = ACTIONS(3443),
    [anon_sym__Generic] = ACTIONS(3443),
    [anon_sym_asm] = ACTIONS(3443),
    [anon_sym___asm__] = ACTIONS(3443),
    [aux_sym_number_literal_token1] = ACTIONS(3445),
    [aux_sym_number_literal_token2] = ACTIONS(3443),
    [anon_sym_L_SQUOTE] = ACTIONS(3445),
    [anon_sym_u_SQUOTE] = ACTIONS(3445),
    [anon_sym_U_SQUOTE] = ACTIONS(3445),
    [anon_sym_u8_SQUOTE] = ACTIONS(3445),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_L_DQUOTE] = ACTIONS(3445),
    [anon_sym_u_DQUOTE] = ACTIONS(3445),
    [anon_sym_U_DQUOTE] = ACTIONS(3445),
    [anon_sym_u8_DQUOTE] = ACTIONS(3445),
    [anon_sym_DQUOTE] = ACTIONS(3445),
    [sym_true] = ACTIONS(3443),
    [sym_false] = ACTIONS(3443),
    [anon_sym_NULL] = ACTIONS(3443),
    [anon_sym_nullptr] = ACTIONS(3443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3443),
    [anon_sym_decltype] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_alignas] = ACTIONS(3443),
    [anon_sym_explicit] = ACTIONS(3443),
    [anon_sym_typename] = ACTIONS(3443),
    [anon_sym_template] = ACTIONS(3443),
    [anon_sym_operator] = ACTIONS(3443),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_delete] = ACTIONS(3443),
    [anon_sym_throw] = ACTIONS(3443),
    [anon_sym_namespace] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_static_assert] = ACTIONS(3443),
    [anon_sym_concept] = ACTIONS(3443),
    [anon_sym_co_return] = ACTIONS(3443),
    [anon_sym_co_yield] = ACTIONS(3443),
    [anon_sym_R_DQUOTE] = ACTIONS(3445),
    [anon_sym_LR_DQUOTE] = ACTIONS(3445),
    [anon_sym_uR_DQUOTE] = ACTIONS(3445),
    [anon_sym_UR_DQUOTE] = ACTIONS(3445),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3445),
    [anon_sym_co_await] = ACTIONS(3443),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_requires] = ACTIONS(3443),
    [sym_this] = ACTIONS(3443),
  },
  [881] = {
    [sym_identifier] = ACTIONS(3443),
    [aux_sym_preproc_include_token1] = ACTIONS(3443),
    [aux_sym_preproc_def_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token2] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3443),
    [sym_preproc_directive] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3445),
    [anon_sym_BANG] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_AMP_AMP] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_SEMI] = ACTIONS(3445),
    [anon_sym___extension__] = ACTIONS(3443),
    [anon_sym_typedef] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym___attribute__] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3445),
    [anon_sym___declspec] = ACTIONS(3443),
    [anon_sym___based] = ACTIONS(3443),
    [anon_sym___cdecl] = ACTIONS(3443),
    [anon_sym___clrcall] = ACTIONS(3443),
    [anon_sym___stdcall] = ACTIONS(3443),
    [anon_sym___fastcall] = ACTIONS(3443),
    [anon_sym___thiscall] = ACTIONS(3443),
    [anon_sym___vectorcall] = ACTIONS(3443),
    [anon_sym_LBRACE] = ACTIONS(3445),
    [anon_sym_signed] = ACTIONS(3443),
    [anon_sym_unsigned] = ACTIONS(3443),
    [anon_sym_long] = ACTIONS(3443),
    [anon_sym_short] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_register] = ACTIONS(3443),
    [anon_sym_inline] = ACTIONS(3443),
    [anon_sym___inline] = ACTIONS(3443),
    [anon_sym___inline__] = ACTIONS(3443),
    [anon_sym___forceinline] = ACTIONS(3443),
    [anon_sym_thread_local] = ACTIONS(3443),
    [anon_sym___thread] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_constexpr] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_restrict] = ACTIONS(3443),
    [anon_sym___restrict__] = ACTIONS(3443),
    [anon_sym__Atomic] = ACTIONS(3443),
    [anon_sym__Noreturn] = ACTIONS(3443),
    [anon_sym_noreturn] = ACTIONS(3443),
    [anon_sym_mutable] = ACTIONS(3443),
    [anon_sym_constinit] = ACTIONS(3443),
    [anon_sym_consteval] = ACTIONS(3443),
    [anon_sym_PROGMEM] = ACTIONS(3443),
    [aux_sym_primitive_type_token1] = ACTIONS(3443),
    [anon_sym_byte] = ACTIONS(3443),
    [anon_sym_word] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_union] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_switch] = ACTIONS(3443),
    [anon_sym_case] = ACTIONS(3443),
    [anon_sym_default] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_break] = ACTIONS(3443),
    [anon_sym_continue] = ACTIONS(3443),
    [anon_sym_goto] = ACTIONS(3443),
    [anon_sym___try] = ACTIONS(3443),
    [anon_sym___leave] = ACTIONS(3443),
    [anon_sym_not] = ACTIONS(3443),
    [anon_sym_compl] = ACTIONS(3443),
    [anon_sym_DASH_DASH] = ACTIONS(3445),
    [anon_sym_PLUS_PLUS] = ACTIONS(3445),
    [anon_sym_sizeof] = ACTIONS(3443),
    [anon_sym___alignof__] = ACTIONS(3443),
    [anon_sym___alignof] = ACTIONS(3443),
    [anon_sym__alignof] = ACTIONS(3443),
    [anon_sym_alignof] = ACTIONS(3443),
    [anon_sym__Alignof] = ACTIONS(3443),
    [anon_sym_offsetof] = ACTIONS(3443),
    [anon_sym__Generic] = ACTIONS(3443),
    [anon_sym_asm] = ACTIONS(3443),
    [anon_sym___asm__] = ACTIONS(3443),
    [aux_sym_number_literal_token1] = ACTIONS(3445),
    [aux_sym_number_literal_token2] = ACTIONS(3443),
    [anon_sym_L_SQUOTE] = ACTIONS(3445),
    [anon_sym_u_SQUOTE] = ACTIONS(3445),
    [anon_sym_U_SQUOTE] = ACTIONS(3445),
    [anon_sym_u8_SQUOTE] = ACTIONS(3445),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_L_DQUOTE] = ACTIONS(3445),
    [anon_sym_u_DQUOTE] = ACTIONS(3445),
    [anon_sym_U_DQUOTE] = ACTIONS(3445),
    [anon_sym_u8_DQUOTE] = ACTIONS(3445),
    [anon_sym_DQUOTE] = ACTIONS(3445),
    [sym_true] = ACTIONS(3443),
    [sym_false] = ACTIONS(3443),
    [anon_sym_NULL] = ACTIONS(3443),
    [anon_sym_nullptr] = ACTIONS(3443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3443),
    [anon_sym_decltype] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_alignas] = ACTIONS(3443),
    [anon_sym_explicit] = ACTIONS(3443),
    [anon_sym_typename] = ACTIONS(3443),
    [anon_sym_template] = ACTIONS(3443),
    [anon_sym_operator] = ACTIONS(3443),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_delete] = ACTIONS(3443),
    [anon_sym_throw] = ACTIONS(3443),
    [anon_sym_namespace] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_static_assert] = ACTIONS(3443),
    [anon_sym_concept] = ACTIONS(3443),
    [anon_sym_co_return] = ACTIONS(3443),
    [anon_sym_co_yield] = ACTIONS(3443),
    [anon_sym_R_DQUOTE] = ACTIONS(3445),
    [anon_sym_LR_DQUOTE] = ACTIONS(3445),
    [anon_sym_uR_DQUOTE] = ACTIONS(3445),
    [anon_sym_UR_DQUOTE] = ACTIONS(3445),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3445),
    [anon_sym_co_await] = ACTIONS(3443),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_requires] = ACTIONS(3443),
    [sym_this] = ACTIONS(3443),
  },
  [882] = {
    [sym_identifier] = ACTIONS(3353),
    [aux_sym_preproc_include_token1] = ACTIONS(3353),
    [aux_sym_preproc_def_token1] = ACTIONS(3353),
    [aux_sym_preproc_if_token1] = ACTIONS(3353),
    [aux_sym_preproc_if_token2] = ACTIONS(3353),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3353),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3353),
    [sym_preproc_directive] = ACTIONS(3353),
    [anon_sym_LPAREN2] = ACTIONS(3355),
    [anon_sym_BANG] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_AMP_AMP] = ACTIONS(3355),
    [anon_sym_AMP] = ACTIONS(3353),
    [anon_sym_SEMI] = ACTIONS(3355),
    [anon_sym___extension__] = ACTIONS(3353),
    [anon_sym_typedef] = ACTIONS(3353),
    [anon_sym_extern] = ACTIONS(3353),
    [anon_sym___attribute__] = ACTIONS(3353),
    [anon_sym_COLON_COLON] = ACTIONS(3355),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3355),
    [anon_sym___declspec] = ACTIONS(3353),
    [anon_sym___based] = ACTIONS(3353),
    [anon_sym___cdecl] = ACTIONS(3353),
    [anon_sym___clrcall] = ACTIONS(3353),
    [anon_sym___stdcall] = ACTIONS(3353),
    [anon_sym___fastcall] = ACTIONS(3353),
    [anon_sym___thiscall] = ACTIONS(3353),
    [anon_sym___vectorcall] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_signed] = ACTIONS(3353),
    [anon_sym_unsigned] = ACTIONS(3353),
    [anon_sym_long] = ACTIONS(3353),
    [anon_sym_short] = ACTIONS(3353),
    [anon_sym_LBRACK] = ACTIONS(3353),
    [anon_sym_static] = ACTIONS(3353),
    [anon_sym_register] = ACTIONS(3353),
    [anon_sym_inline] = ACTIONS(3353),
    [anon_sym___inline] = ACTIONS(3353),
    [anon_sym___inline__] = ACTIONS(3353),
    [anon_sym___forceinline] = ACTIONS(3353),
    [anon_sym_thread_local] = ACTIONS(3353),
    [anon_sym___thread] = ACTIONS(3353),
    [anon_sym_const] = ACTIONS(3353),
    [anon_sym_constexpr] = ACTIONS(3353),
    [anon_sym_volatile] = ACTIONS(3353),
    [anon_sym_restrict] = ACTIONS(3353),
    [anon_sym___restrict__] = ACTIONS(3353),
    [anon_sym__Atomic] = ACTIONS(3353),
    [anon_sym__Noreturn] = ACTIONS(3353),
    [anon_sym_noreturn] = ACTIONS(3353),
    [anon_sym_mutable] = ACTIONS(3353),
    [anon_sym_constinit] = ACTIONS(3353),
    [anon_sym_consteval] = ACTIONS(3353),
    [anon_sym_PROGMEM] = ACTIONS(3353),
    [aux_sym_primitive_type_token1] = ACTIONS(3353),
    [anon_sym_byte] = ACTIONS(3353),
    [anon_sym_word] = ACTIONS(3353),
    [anon_sym_enum] = ACTIONS(3353),
    [anon_sym_class] = ACTIONS(3353),
    [anon_sym_struct] = ACTIONS(3353),
    [anon_sym_union] = ACTIONS(3353),
    [anon_sym_if] = ACTIONS(3353),
    [anon_sym_switch] = ACTIONS(3353),
    [anon_sym_case] = ACTIONS(3353),
    [anon_sym_default] = ACTIONS(3353),
    [anon_sym_while] = ACTIONS(3353),
    [anon_sym_do] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3353),
    [anon_sym_return] = ACTIONS(3353),
    [anon_sym_break] = ACTIONS(3353),
    [anon_sym_continue] = ACTIONS(3353),
    [anon_sym_goto] = ACTIONS(3353),
    [anon_sym___try] = ACTIONS(3353),
    [anon_sym___leave] = ACTIONS(3353),
    [anon_sym_not] = ACTIONS(3353),
    [anon_sym_compl] = ACTIONS(3353),
    [anon_sym_DASH_DASH] = ACTIONS(3355),
    [anon_sym_PLUS_PLUS] = ACTIONS(3355),
    [anon_sym_sizeof] = ACTIONS(3353),
    [anon_sym___alignof__] = ACTIONS(3353),
    [anon_sym___alignof] = ACTIONS(3353),
    [anon_sym__alignof] = ACTIONS(3353),
    [anon_sym_alignof] = ACTIONS(3353),
    [anon_sym__Alignof] = ACTIONS(3353),
    [anon_sym_offsetof] = ACTIONS(3353),
    [anon_sym__Generic] = ACTIONS(3353),
    [anon_sym_asm] = ACTIONS(3353),
    [anon_sym___asm__] = ACTIONS(3353),
    [aux_sym_number_literal_token1] = ACTIONS(3355),
    [aux_sym_number_literal_token2] = ACTIONS(3353),
    [anon_sym_L_SQUOTE] = ACTIONS(3355),
    [anon_sym_u_SQUOTE] = ACTIONS(3355),
    [anon_sym_U_SQUOTE] = ACTIONS(3355),
    [anon_sym_u8_SQUOTE] = ACTIONS(3355),
    [anon_sym_SQUOTE] = ACTIONS(3355),
    [anon_sym_L_DQUOTE] = ACTIONS(3355),
    [anon_sym_u_DQUOTE] = ACTIONS(3355),
    [anon_sym_U_DQUOTE] = ACTIONS(3355),
    [anon_sym_u8_DQUOTE] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [sym_true] = ACTIONS(3353),
    [sym_false] = ACTIONS(3353),
    [anon_sym_NULL] = ACTIONS(3353),
    [anon_sym_nullptr] = ACTIONS(3353),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3353),
    [anon_sym_decltype] = ACTIONS(3353),
    [anon_sym_virtual] = ACTIONS(3353),
    [anon_sym_alignas] = ACTIONS(3353),
    [anon_sym_explicit] = ACTIONS(3353),
    [anon_sym_typename] = ACTIONS(3353),
    [anon_sym_template] = ACTIONS(3353),
    [anon_sym_operator] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3353),
    [anon_sym_delete] = ACTIONS(3353),
    [anon_sym_throw] = ACTIONS(3353),
    [anon_sym_namespace] = ACTIONS(3353),
    [anon_sym_using] = ACTIONS(3353),
    [anon_sym_static_assert] = ACTIONS(3353),
    [anon_sym_concept] = ACTIONS(3353),
    [anon_sym_co_return] = ACTIONS(3353),
    [anon_sym_co_yield] = ACTIONS(3353),
    [anon_sym_R_DQUOTE] = ACTIONS(3355),
    [anon_sym_LR_DQUOTE] = ACTIONS(3355),
    [anon_sym_uR_DQUOTE] = ACTIONS(3355),
    [anon_sym_UR_DQUOTE] = ACTIONS(3355),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3355),
    [anon_sym_co_await] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3353),
    [anon_sym_requires] = ACTIONS(3353),
    [sym_this] = ACTIONS(3353),
  },
  [883] = {
    [sym_identifier] = ACTIONS(3276),
    [aux_sym_preproc_include_token1] = ACTIONS(3276),
    [aux_sym_preproc_def_token1] = ACTIONS(3276),
    [aux_sym_preproc_if_token1] = ACTIONS(3276),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3276),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3276),
    [sym_preproc_directive] = ACTIONS(3276),
    [anon_sym_LPAREN2] = ACTIONS(3278),
    [anon_sym_BANG] = ACTIONS(3278),
    [anon_sym_TILDE] = ACTIONS(3278),
    [anon_sym_DASH] = ACTIONS(3276),
    [anon_sym_PLUS] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3278),
    [anon_sym_AMP_AMP] = ACTIONS(3278),
    [anon_sym_AMP] = ACTIONS(3276),
    [anon_sym_SEMI] = ACTIONS(3278),
    [anon_sym___extension__] = ACTIONS(3276),
    [anon_sym_typedef] = ACTIONS(3276),
    [anon_sym_extern] = ACTIONS(3276),
    [anon_sym___attribute__] = ACTIONS(3276),
    [anon_sym_COLON_COLON] = ACTIONS(3278),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3278),
    [anon_sym___declspec] = ACTIONS(3276),
    [anon_sym___based] = ACTIONS(3276),
    [anon_sym___cdecl] = ACTIONS(3276),
    [anon_sym___clrcall] = ACTIONS(3276),
    [anon_sym___stdcall] = ACTIONS(3276),
    [anon_sym___fastcall] = ACTIONS(3276),
    [anon_sym___thiscall] = ACTIONS(3276),
    [anon_sym___vectorcall] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3278),
    [anon_sym_RBRACE] = ACTIONS(3278),
    [anon_sym_signed] = ACTIONS(3276),
    [anon_sym_unsigned] = ACTIONS(3276),
    [anon_sym_long] = ACTIONS(3276),
    [anon_sym_short] = ACTIONS(3276),
    [anon_sym_LBRACK] = ACTIONS(3276),
    [anon_sym_static] = ACTIONS(3276),
    [anon_sym_register] = ACTIONS(3276),
    [anon_sym_inline] = ACTIONS(3276),
    [anon_sym___inline] = ACTIONS(3276),
    [anon_sym___inline__] = ACTIONS(3276),
    [anon_sym___forceinline] = ACTIONS(3276),
    [anon_sym_thread_local] = ACTIONS(3276),
    [anon_sym___thread] = ACTIONS(3276),
    [anon_sym_const] = ACTIONS(3276),
    [anon_sym_constexpr] = ACTIONS(3276),
    [anon_sym_volatile] = ACTIONS(3276),
    [anon_sym_restrict] = ACTIONS(3276),
    [anon_sym___restrict__] = ACTIONS(3276),
    [anon_sym__Atomic] = ACTIONS(3276),
    [anon_sym__Noreturn] = ACTIONS(3276),
    [anon_sym_noreturn] = ACTIONS(3276),
    [anon_sym_mutable] = ACTIONS(3276),
    [anon_sym_constinit] = ACTIONS(3276),
    [anon_sym_consteval] = ACTIONS(3276),
    [anon_sym_PROGMEM] = ACTIONS(3276),
    [aux_sym_primitive_type_token1] = ACTIONS(3276),
    [anon_sym_byte] = ACTIONS(3276),
    [anon_sym_word] = ACTIONS(3276),
    [anon_sym_enum] = ACTIONS(3276),
    [anon_sym_class] = ACTIONS(3276),
    [anon_sym_struct] = ACTIONS(3276),
    [anon_sym_union] = ACTIONS(3276),
    [anon_sym_if] = ACTIONS(3276),
    [anon_sym_switch] = ACTIONS(3276),
    [anon_sym_case] = ACTIONS(3276),
    [anon_sym_default] = ACTIONS(3276),
    [anon_sym_while] = ACTIONS(3276),
    [anon_sym_do] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3276),
    [anon_sym_return] = ACTIONS(3276),
    [anon_sym_break] = ACTIONS(3276),
    [anon_sym_continue] = ACTIONS(3276),
    [anon_sym_goto] = ACTIONS(3276),
    [anon_sym___try] = ACTIONS(3276),
    [anon_sym___leave] = ACTIONS(3276),
    [anon_sym_not] = ACTIONS(3276),
    [anon_sym_compl] = ACTIONS(3276),
    [anon_sym_DASH_DASH] = ACTIONS(3278),
    [anon_sym_PLUS_PLUS] = ACTIONS(3278),
    [anon_sym_sizeof] = ACTIONS(3276),
    [anon_sym___alignof__] = ACTIONS(3276),
    [anon_sym___alignof] = ACTIONS(3276),
    [anon_sym__alignof] = ACTIONS(3276),
    [anon_sym_alignof] = ACTIONS(3276),
    [anon_sym__Alignof] = ACTIONS(3276),
    [anon_sym_offsetof] = ACTIONS(3276),
    [anon_sym__Generic] = ACTIONS(3276),
    [anon_sym_asm] = ACTIONS(3276),
    [anon_sym___asm__] = ACTIONS(3276),
    [aux_sym_number_literal_token1] = ACTIONS(3278),
    [aux_sym_number_literal_token2] = ACTIONS(3276),
    [anon_sym_L_SQUOTE] = ACTIONS(3278),
    [anon_sym_u_SQUOTE] = ACTIONS(3278),
    [anon_sym_U_SQUOTE] = ACTIONS(3278),
    [anon_sym_u8_SQUOTE] = ACTIONS(3278),
    [anon_sym_SQUOTE] = ACTIONS(3278),
    [anon_sym_L_DQUOTE] = ACTIONS(3278),
    [anon_sym_u_DQUOTE] = ACTIONS(3278),
    [anon_sym_U_DQUOTE] = ACTIONS(3278),
    [anon_sym_u8_DQUOTE] = ACTIONS(3278),
    [anon_sym_DQUOTE] = ACTIONS(3278),
    [sym_true] = ACTIONS(3276),
    [sym_false] = ACTIONS(3276),
    [anon_sym_NULL] = ACTIONS(3276),
    [anon_sym_nullptr] = ACTIONS(3276),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3276),
    [anon_sym_decltype] = ACTIONS(3276),
    [anon_sym_virtual] = ACTIONS(3276),
    [anon_sym_alignas] = ACTIONS(3276),
    [anon_sym_explicit] = ACTIONS(3276),
    [anon_sym_typename] = ACTIONS(3276),
    [anon_sym_template] = ACTIONS(3276),
    [anon_sym_operator] = ACTIONS(3276),
    [anon_sym_try] = ACTIONS(3276),
    [anon_sym_delete] = ACTIONS(3276),
    [anon_sym_throw] = ACTIONS(3276),
    [anon_sym_namespace] = ACTIONS(3276),
    [anon_sym_using] = ACTIONS(3276),
    [anon_sym_static_assert] = ACTIONS(3276),
    [anon_sym_concept] = ACTIONS(3276),
    [anon_sym_co_return] = ACTIONS(3276),
    [anon_sym_co_yield] = ACTIONS(3276),
    [anon_sym_R_DQUOTE] = ACTIONS(3278),
    [anon_sym_LR_DQUOTE] = ACTIONS(3278),
    [anon_sym_uR_DQUOTE] = ACTIONS(3278),
    [anon_sym_UR_DQUOTE] = ACTIONS(3278),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3278),
    [anon_sym_co_await] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3276),
    [anon_sym_requires] = ACTIONS(3276),
    [sym_this] = ACTIONS(3276),
  },
  [884] = {
    [sym_identifier] = ACTIONS(3280),
    [aux_sym_preproc_include_token1] = ACTIONS(3280),
    [aux_sym_preproc_def_token1] = ACTIONS(3280),
    [aux_sym_preproc_if_token1] = ACTIONS(3280),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3280),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3280),
    [sym_preproc_directive] = ACTIONS(3280),
    [anon_sym_LPAREN2] = ACTIONS(3282),
    [anon_sym_BANG] = ACTIONS(3282),
    [anon_sym_TILDE] = ACTIONS(3282),
    [anon_sym_DASH] = ACTIONS(3280),
    [anon_sym_PLUS] = ACTIONS(3280),
    [anon_sym_STAR] = ACTIONS(3282),
    [anon_sym_AMP_AMP] = ACTIONS(3282),
    [anon_sym_AMP] = ACTIONS(3280),
    [anon_sym_SEMI] = ACTIONS(3282),
    [anon_sym___extension__] = ACTIONS(3280),
    [anon_sym_typedef] = ACTIONS(3280),
    [anon_sym_extern] = ACTIONS(3280),
    [anon_sym___attribute__] = ACTIONS(3280),
    [anon_sym_COLON_COLON] = ACTIONS(3282),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3282),
    [anon_sym___declspec] = ACTIONS(3280),
    [anon_sym___based] = ACTIONS(3280),
    [anon_sym___cdecl] = ACTIONS(3280),
    [anon_sym___clrcall] = ACTIONS(3280),
    [anon_sym___stdcall] = ACTIONS(3280),
    [anon_sym___fastcall] = ACTIONS(3280),
    [anon_sym___thiscall] = ACTIONS(3280),
    [anon_sym___vectorcall] = ACTIONS(3280),
    [anon_sym_LBRACE] = ACTIONS(3282),
    [anon_sym_RBRACE] = ACTIONS(3282),
    [anon_sym_signed] = ACTIONS(3280),
    [anon_sym_unsigned] = ACTIONS(3280),
    [anon_sym_long] = ACTIONS(3280),
    [anon_sym_short] = ACTIONS(3280),
    [anon_sym_LBRACK] = ACTIONS(3280),
    [anon_sym_static] = ACTIONS(3280),
    [anon_sym_register] = ACTIONS(3280),
    [anon_sym_inline] = ACTIONS(3280),
    [anon_sym___inline] = ACTIONS(3280),
    [anon_sym___inline__] = ACTIONS(3280),
    [anon_sym___forceinline] = ACTIONS(3280),
    [anon_sym_thread_local] = ACTIONS(3280),
    [anon_sym___thread] = ACTIONS(3280),
    [anon_sym_const] = ACTIONS(3280),
    [anon_sym_constexpr] = ACTIONS(3280),
    [anon_sym_volatile] = ACTIONS(3280),
    [anon_sym_restrict] = ACTIONS(3280),
    [anon_sym___restrict__] = ACTIONS(3280),
    [anon_sym__Atomic] = ACTIONS(3280),
    [anon_sym__Noreturn] = ACTIONS(3280),
    [anon_sym_noreturn] = ACTIONS(3280),
    [anon_sym_mutable] = ACTIONS(3280),
    [anon_sym_constinit] = ACTIONS(3280),
    [anon_sym_consteval] = ACTIONS(3280),
    [anon_sym_PROGMEM] = ACTIONS(3280),
    [aux_sym_primitive_type_token1] = ACTIONS(3280),
    [anon_sym_byte] = ACTIONS(3280),
    [anon_sym_word] = ACTIONS(3280),
    [anon_sym_enum] = ACTIONS(3280),
    [anon_sym_class] = ACTIONS(3280),
    [anon_sym_struct] = ACTIONS(3280),
    [anon_sym_union] = ACTIONS(3280),
    [anon_sym_if] = ACTIONS(3280),
    [anon_sym_switch] = ACTIONS(3280),
    [anon_sym_case] = ACTIONS(3280),
    [anon_sym_default] = ACTIONS(3280),
    [anon_sym_while] = ACTIONS(3280),
    [anon_sym_do] = ACTIONS(3280),
    [anon_sym_for] = ACTIONS(3280),
    [anon_sym_return] = ACTIONS(3280),
    [anon_sym_break] = ACTIONS(3280),
    [anon_sym_continue] = ACTIONS(3280),
    [anon_sym_goto] = ACTIONS(3280),
    [anon_sym___try] = ACTIONS(3280),
    [anon_sym___leave] = ACTIONS(3280),
    [anon_sym_not] = ACTIONS(3280),
    [anon_sym_compl] = ACTIONS(3280),
    [anon_sym_DASH_DASH] = ACTIONS(3282),
    [anon_sym_PLUS_PLUS] = ACTIONS(3282),
    [anon_sym_sizeof] = ACTIONS(3280),
    [anon_sym___alignof__] = ACTIONS(3280),
    [anon_sym___alignof] = ACTIONS(3280),
    [anon_sym__alignof] = ACTIONS(3280),
    [anon_sym_alignof] = ACTIONS(3280),
    [anon_sym__Alignof] = ACTIONS(3280),
    [anon_sym_offsetof] = ACTIONS(3280),
    [anon_sym__Generic] = ACTIONS(3280),
    [anon_sym_asm] = ACTIONS(3280),
    [anon_sym___asm__] = ACTIONS(3280),
    [aux_sym_number_literal_token1] = ACTIONS(3282),
    [aux_sym_number_literal_token2] = ACTIONS(3280),
    [anon_sym_L_SQUOTE] = ACTIONS(3282),
    [anon_sym_u_SQUOTE] = ACTIONS(3282),
    [anon_sym_U_SQUOTE] = ACTIONS(3282),
    [anon_sym_u8_SQUOTE] = ACTIONS(3282),
    [anon_sym_SQUOTE] = ACTIONS(3282),
    [anon_sym_L_DQUOTE] = ACTIONS(3282),
    [anon_sym_u_DQUOTE] = ACTIONS(3282),
    [anon_sym_U_DQUOTE] = ACTIONS(3282),
    [anon_sym_u8_DQUOTE] = ACTIONS(3282),
    [anon_sym_DQUOTE] = ACTIONS(3282),
    [sym_true] = ACTIONS(3280),
    [sym_false] = ACTIONS(3280),
    [anon_sym_NULL] = ACTIONS(3280),
    [anon_sym_nullptr] = ACTIONS(3280),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3280),
    [anon_sym_decltype] = ACTIONS(3280),
    [anon_sym_virtual] = ACTIONS(3280),
    [anon_sym_alignas] = ACTIONS(3280),
    [anon_sym_explicit] = ACTIONS(3280),
    [anon_sym_typename] = ACTIONS(3280),
    [anon_sym_template] = ACTIONS(3280),
    [anon_sym_operator] = ACTIONS(3280),
    [anon_sym_try] = ACTIONS(3280),
    [anon_sym_delete] = ACTIONS(3280),
    [anon_sym_throw] = ACTIONS(3280),
    [anon_sym_namespace] = ACTIONS(3280),
    [anon_sym_using] = ACTIONS(3280),
    [anon_sym_static_assert] = ACTIONS(3280),
    [anon_sym_concept] = ACTIONS(3280),
    [anon_sym_co_return] = ACTIONS(3280),
    [anon_sym_co_yield] = ACTIONS(3280),
    [anon_sym_R_DQUOTE] = ACTIONS(3282),
    [anon_sym_LR_DQUOTE] = ACTIONS(3282),
    [anon_sym_uR_DQUOTE] = ACTIONS(3282),
    [anon_sym_UR_DQUOTE] = ACTIONS(3282),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3282),
    [anon_sym_co_await] = ACTIONS(3280),
    [anon_sym_new] = ACTIONS(3280),
    [anon_sym_requires] = ACTIONS(3280),
    [sym_this] = ACTIONS(3280),
  },
  [885] = {
    [sym_identifier] = ACTIONS(3293),
    [aux_sym_preproc_include_token1] = ACTIONS(3293),
    [aux_sym_preproc_def_token1] = ACTIONS(3293),
    [aux_sym_preproc_if_token1] = ACTIONS(3293),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3293),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3293),
    [sym_preproc_directive] = ACTIONS(3293),
    [anon_sym_LPAREN2] = ACTIONS(3295),
    [anon_sym_BANG] = ACTIONS(3295),
    [anon_sym_TILDE] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3293),
    [anon_sym_STAR] = ACTIONS(3295),
    [anon_sym_AMP_AMP] = ACTIONS(3295),
    [anon_sym_AMP] = ACTIONS(3293),
    [anon_sym_SEMI] = ACTIONS(3295),
    [anon_sym___extension__] = ACTIONS(3293),
    [anon_sym_typedef] = ACTIONS(3293),
    [anon_sym_extern] = ACTIONS(3293),
    [anon_sym___attribute__] = ACTIONS(3293),
    [anon_sym_COLON_COLON] = ACTIONS(3295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3295),
    [anon_sym___declspec] = ACTIONS(3293),
    [anon_sym___based] = ACTIONS(3293),
    [anon_sym___cdecl] = ACTIONS(3293),
    [anon_sym___clrcall] = ACTIONS(3293),
    [anon_sym___stdcall] = ACTIONS(3293),
    [anon_sym___fastcall] = ACTIONS(3293),
    [anon_sym___thiscall] = ACTIONS(3293),
    [anon_sym___vectorcall] = ACTIONS(3293),
    [anon_sym_LBRACE] = ACTIONS(3295),
    [anon_sym_RBRACE] = ACTIONS(3295),
    [anon_sym_signed] = ACTIONS(3293),
    [anon_sym_unsigned] = ACTIONS(3293),
    [anon_sym_long] = ACTIONS(3293),
    [anon_sym_short] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_static] = ACTIONS(3293),
    [anon_sym_register] = ACTIONS(3293),
    [anon_sym_inline] = ACTIONS(3293),
    [anon_sym___inline] = ACTIONS(3293),
    [anon_sym___inline__] = ACTIONS(3293),
    [anon_sym___forceinline] = ACTIONS(3293),
    [anon_sym_thread_local] = ACTIONS(3293),
    [anon_sym___thread] = ACTIONS(3293),
    [anon_sym_const] = ACTIONS(3293),
    [anon_sym_constexpr] = ACTIONS(3293),
    [anon_sym_volatile] = ACTIONS(3293),
    [anon_sym_restrict] = ACTIONS(3293),
    [anon_sym___restrict__] = ACTIONS(3293),
    [anon_sym__Atomic] = ACTIONS(3293),
    [anon_sym__Noreturn] = ACTIONS(3293),
    [anon_sym_noreturn] = ACTIONS(3293),
    [anon_sym_mutable] = ACTIONS(3293),
    [anon_sym_constinit] = ACTIONS(3293),
    [anon_sym_consteval] = ACTIONS(3293),
    [anon_sym_PROGMEM] = ACTIONS(3293),
    [aux_sym_primitive_type_token1] = ACTIONS(3293),
    [anon_sym_byte] = ACTIONS(3293),
    [anon_sym_word] = ACTIONS(3293),
    [anon_sym_enum] = ACTIONS(3293),
    [anon_sym_class] = ACTIONS(3293),
    [anon_sym_struct] = ACTIONS(3293),
    [anon_sym_union] = ACTIONS(3293),
    [anon_sym_if] = ACTIONS(3293),
    [anon_sym_switch] = ACTIONS(3293),
    [anon_sym_case] = ACTIONS(3293),
    [anon_sym_default] = ACTIONS(3293),
    [anon_sym_while] = ACTIONS(3293),
    [anon_sym_do] = ACTIONS(3293),
    [anon_sym_for] = ACTIONS(3293),
    [anon_sym_return] = ACTIONS(3293),
    [anon_sym_break] = ACTIONS(3293),
    [anon_sym_continue] = ACTIONS(3293),
    [anon_sym_goto] = ACTIONS(3293),
    [anon_sym___try] = ACTIONS(3293),
    [anon_sym___leave] = ACTIONS(3293),
    [anon_sym_not] = ACTIONS(3293),
    [anon_sym_compl] = ACTIONS(3293),
    [anon_sym_DASH_DASH] = ACTIONS(3295),
    [anon_sym_PLUS_PLUS] = ACTIONS(3295),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3293),
    [anon_sym___alignof] = ACTIONS(3293),
    [anon_sym__alignof] = ACTIONS(3293),
    [anon_sym_alignof] = ACTIONS(3293),
    [anon_sym__Alignof] = ACTIONS(3293),
    [anon_sym_offsetof] = ACTIONS(3293),
    [anon_sym__Generic] = ACTIONS(3293),
    [anon_sym_asm] = ACTIONS(3293),
    [anon_sym___asm__] = ACTIONS(3293),
    [aux_sym_number_literal_token1] = ACTIONS(3295),
    [aux_sym_number_literal_token2] = ACTIONS(3293),
    [anon_sym_L_SQUOTE] = ACTIONS(3295),
    [anon_sym_u_SQUOTE] = ACTIONS(3295),
    [anon_sym_U_SQUOTE] = ACTIONS(3295),
    [anon_sym_u8_SQUOTE] = ACTIONS(3295),
    [anon_sym_SQUOTE] = ACTIONS(3295),
    [anon_sym_L_DQUOTE] = ACTIONS(3295),
    [anon_sym_u_DQUOTE] = ACTIONS(3295),
    [anon_sym_U_DQUOTE] = ACTIONS(3295),
    [anon_sym_u8_DQUOTE] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(3295),
    [sym_true] = ACTIONS(3293),
    [sym_false] = ACTIONS(3293),
    [anon_sym_NULL] = ACTIONS(3293),
    [anon_sym_nullptr] = ACTIONS(3293),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3293),
    [anon_sym_decltype] = ACTIONS(3293),
    [anon_sym_virtual] = ACTIONS(3293),
    [anon_sym_alignas] = ACTIONS(3293),
    [anon_sym_explicit] = ACTIONS(3293),
    [anon_sym_typename] = ACTIONS(3293),
    [anon_sym_template] = ACTIONS(3293),
    [anon_sym_operator] = ACTIONS(3293),
    [anon_sym_try] = ACTIONS(3293),
    [anon_sym_delete] = ACTIONS(3293),
    [anon_sym_throw] = ACTIONS(3293),
    [anon_sym_namespace] = ACTIONS(3293),
    [anon_sym_using] = ACTIONS(3293),
    [anon_sym_static_assert] = ACTIONS(3293),
    [anon_sym_concept] = ACTIONS(3293),
    [anon_sym_co_return] = ACTIONS(3293),
    [anon_sym_co_yield] = ACTIONS(3293),
    [anon_sym_R_DQUOTE] = ACTIONS(3295),
    [anon_sym_LR_DQUOTE] = ACTIONS(3295),
    [anon_sym_uR_DQUOTE] = ACTIONS(3295),
    [anon_sym_UR_DQUOTE] = ACTIONS(3295),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3295),
    [anon_sym_co_await] = ACTIONS(3293),
    [anon_sym_new] = ACTIONS(3293),
    [anon_sym_requires] = ACTIONS(3293),
    [sym_this] = ACTIONS(3293),
  },
  [886] = {
    [sym_identifier] = ACTIONS(3297),
    [aux_sym_preproc_include_token1] = ACTIONS(3297),
    [aux_sym_preproc_def_token1] = ACTIONS(3297),
    [aux_sym_preproc_if_token1] = ACTIONS(3297),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3297),
    [sym_preproc_directive] = ACTIONS(3297),
    [anon_sym_LPAREN2] = ACTIONS(3299),
    [anon_sym_BANG] = ACTIONS(3299),
    [anon_sym_TILDE] = ACTIONS(3299),
    [anon_sym_DASH] = ACTIONS(3297),
    [anon_sym_PLUS] = ACTIONS(3297),
    [anon_sym_STAR] = ACTIONS(3299),
    [anon_sym_AMP_AMP] = ACTIONS(3299),
    [anon_sym_AMP] = ACTIONS(3297),
    [anon_sym_SEMI] = ACTIONS(3299),
    [anon_sym___extension__] = ACTIONS(3297),
    [anon_sym_typedef] = ACTIONS(3297),
    [anon_sym_extern] = ACTIONS(3297),
    [anon_sym___attribute__] = ACTIONS(3297),
    [anon_sym_COLON_COLON] = ACTIONS(3299),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3299),
    [anon_sym___declspec] = ACTIONS(3297),
    [anon_sym___based] = ACTIONS(3297),
    [anon_sym___cdecl] = ACTIONS(3297),
    [anon_sym___clrcall] = ACTIONS(3297),
    [anon_sym___stdcall] = ACTIONS(3297),
    [anon_sym___fastcall] = ACTIONS(3297),
    [anon_sym___thiscall] = ACTIONS(3297),
    [anon_sym___vectorcall] = ACTIONS(3297),
    [anon_sym_LBRACE] = ACTIONS(3299),
    [anon_sym_RBRACE] = ACTIONS(3299),
    [anon_sym_signed] = ACTIONS(3297),
    [anon_sym_unsigned] = ACTIONS(3297),
    [anon_sym_long] = ACTIONS(3297),
    [anon_sym_short] = ACTIONS(3297),
    [anon_sym_LBRACK] = ACTIONS(3297),
    [anon_sym_static] = ACTIONS(3297),
    [anon_sym_register] = ACTIONS(3297),
    [anon_sym_inline] = ACTIONS(3297),
    [anon_sym___inline] = ACTIONS(3297),
    [anon_sym___inline__] = ACTIONS(3297),
    [anon_sym___forceinline] = ACTIONS(3297),
    [anon_sym_thread_local] = ACTIONS(3297),
    [anon_sym___thread] = ACTIONS(3297),
    [anon_sym_const] = ACTIONS(3297),
    [anon_sym_constexpr] = ACTIONS(3297),
    [anon_sym_volatile] = ACTIONS(3297),
    [anon_sym_restrict] = ACTIONS(3297),
    [anon_sym___restrict__] = ACTIONS(3297),
    [anon_sym__Atomic] = ACTIONS(3297),
    [anon_sym__Noreturn] = ACTIONS(3297),
    [anon_sym_noreturn] = ACTIONS(3297),
    [anon_sym_mutable] = ACTIONS(3297),
    [anon_sym_constinit] = ACTIONS(3297),
    [anon_sym_consteval] = ACTIONS(3297),
    [anon_sym_PROGMEM] = ACTIONS(3297),
    [aux_sym_primitive_type_token1] = ACTIONS(3297),
    [anon_sym_byte] = ACTIONS(3297),
    [anon_sym_word] = ACTIONS(3297),
    [anon_sym_enum] = ACTIONS(3297),
    [anon_sym_class] = ACTIONS(3297),
    [anon_sym_struct] = ACTIONS(3297),
    [anon_sym_union] = ACTIONS(3297),
    [anon_sym_if] = ACTIONS(3297),
    [anon_sym_switch] = ACTIONS(3297),
    [anon_sym_case] = ACTIONS(3297),
    [anon_sym_default] = ACTIONS(3297),
    [anon_sym_while] = ACTIONS(3297),
    [anon_sym_do] = ACTIONS(3297),
    [anon_sym_for] = ACTIONS(3297),
    [anon_sym_return] = ACTIONS(3297),
    [anon_sym_break] = ACTIONS(3297),
    [anon_sym_continue] = ACTIONS(3297),
    [anon_sym_goto] = ACTIONS(3297),
    [anon_sym___try] = ACTIONS(3297),
    [anon_sym___leave] = ACTIONS(3297),
    [anon_sym_not] = ACTIONS(3297),
    [anon_sym_compl] = ACTIONS(3297),
    [anon_sym_DASH_DASH] = ACTIONS(3299),
    [anon_sym_PLUS_PLUS] = ACTIONS(3299),
    [anon_sym_sizeof] = ACTIONS(3297),
    [anon_sym___alignof__] = ACTIONS(3297),
    [anon_sym___alignof] = ACTIONS(3297),
    [anon_sym__alignof] = ACTIONS(3297),
    [anon_sym_alignof] = ACTIONS(3297),
    [anon_sym__Alignof] = ACTIONS(3297),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3297),
    [anon_sym_asm] = ACTIONS(3297),
    [anon_sym___asm__] = ACTIONS(3297),
    [aux_sym_number_literal_token1] = ACTIONS(3299),
    [aux_sym_number_literal_token2] = ACTIONS(3297),
    [anon_sym_L_SQUOTE] = ACTIONS(3299),
    [anon_sym_u_SQUOTE] = ACTIONS(3299),
    [anon_sym_U_SQUOTE] = ACTIONS(3299),
    [anon_sym_u8_SQUOTE] = ACTIONS(3299),
    [anon_sym_SQUOTE] = ACTIONS(3299),
    [anon_sym_L_DQUOTE] = ACTIONS(3299),
    [anon_sym_u_DQUOTE] = ACTIONS(3299),
    [anon_sym_U_DQUOTE] = ACTIONS(3299),
    [anon_sym_u8_DQUOTE] = ACTIONS(3299),
    [anon_sym_DQUOTE] = ACTIONS(3299),
    [sym_true] = ACTIONS(3297),
    [sym_false] = ACTIONS(3297),
    [anon_sym_NULL] = ACTIONS(3297),
    [anon_sym_nullptr] = ACTIONS(3297),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3297),
    [anon_sym_decltype] = ACTIONS(3297),
    [anon_sym_virtual] = ACTIONS(3297),
    [anon_sym_alignas] = ACTIONS(3297),
    [anon_sym_explicit] = ACTIONS(3297),
    [anon_sym_typename] = ACTIONS(3297),
    [anon_sym_template] = ACTIONS(3297),
    [anon_sym_operator] = ACTIONS(3297),
    [anon_sym_try] = ACTIONS(3297),
    [anon_sym_delete] = ACTIONS(3297),
    [anon_sym_throw] = ACTIONS(3297),
    [anon_sym_namespace] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3297),
    [anon_sym_static_assert] = ACTIONS(3297),
    [anon_sym_concept] = ACTIONS(3297),
    [anon_sym_co_return] = ACTIONS(3297),
    [anon_sym_co_yield] = ACTIONS(3297),
    [anon_sym_R_DQUOTE] = ACTIONS(3299),
    [anon_sym_LR_DQUOTE] = ACTIONS(3299),
    [anon_sym_uR_DQUOTE] = ACTIONS(3299),
    [anon_sym_UR_DQUOTE] = ACTIONS(3299),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3299),
    [anon_sym_co_await] = ACTIONS(3297),
    [anon_sym_new] = ACTIONS(3297),
    [anon_sym_requires] = ACTIONS(3297),
    [sym_this] = ACTIONS(3297),
  },
  [887] = {
    [sym_identifier] = ACTIONS(3301),
    [aux_sym_preproc_include_token1] = ACTIONS(3301),
    [aux_sym_preproc_def_token1] = ACTIONS(3301),
    [aux_sym_preproc_if_token1] = ACTIONS(3301),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3301),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3301),
    [sym_preproc_directive] = ACTIONS(3301),
    [anon_sym_LPAREN2] = ACTIONS(3303),
    [anon_sym_BANG] = ACTIONS(3303),
    [anon_sym_TILDE] = ACTIONS(3303),
    [anon_sym_DASH] = ACTIONS(3301),
    [anon_sym_PLUS] = ACTIONS(3301),
    [anon_sym_STAR] = ACTIONS(3303),
    [anon_sym_AMP_AMP] = ACTIONS(3303),
    [anon_sym_AMP] = ACTIONS(3301),
    [anon_sym_SEMI] = ACTIONS(3303),
    [anon_sym___extension__] = ACTIONS(3301),
    [anon_sym_typedef] = ACTIONS(3301),
    [anon_sym_extern] = ACTIONS(3301),
    [anon_sym___attribute__] = ACTIONS(3301),
    [anon_sym_COLON_COLON] = ACTIONS(3303),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3303),
    [anon_sym___declspec] = ACTIONS(3301),
    [anon_sym___based] = ACTIONS(3301),
    [anon_sym___cdecl] = ACTIONS(3301),
    [anon_sym___clrcall] = ACTIONS(3301),
    [anon_sym___stdcall] = ACTIONS(3301),
    [anon_sym___fastcall] = ACTIONS(3301),
    [anon_sym___thiscall] = ACTIONS(3301),
    [anon_sym___vectorcall] = ACTIONS(3301),
    [anon_sym_LBRACE] = ACTIONS(3303),
    [anon_sym_RBRACE] = ACTIONS(3303),
    [anon_sym_signed] = ACTIONS(3301),
    [anon_sym_unsigned] = ACTIONS(3301),
    [anon_sym_long] = ACTIONS(3301),
    [anon_sym_short] = ACTIONS(3301),
    [anon_sym_LBRACK] = ACTIONS(3301),
    [anon_sym_static] = ACTIONS(3301),
    [anon_sym_register] = ACTIONS(3301),
    [anon_sym_inline] = ACTIONS(3301),
    [anon_sym___inline] = ACTIONS(3301),
    [anon_sym___inline__] = ACTIONS(3301),
    [anon_sym___forceinline] = ACTIONS(3301),
    [anon_sym_thread_local] = ACTIONS(3301),
    [anon_sym___thread] = ACTIONS(3301),
    [anon_sym_const] = ACTIONS(3301),
    [anon_sym_constexpr] = ACTIONS(3301),
    [anon_sym_volatile] = ACTIONS(3301),
    [anon_sym_restrict] = ACTIONS(3301),
    [anon_sym___restrict__] = ACTIONS(3301),
    [anon_sym__Atomic] = ACTIONS(3301),
    [anon_sym__Noreturn] = ACTIONS(3301),
    [anon_sym_noreturn] = ACTIONS(3301),
    [anon_sym_mutable] = ACTIONS(3301),
    [anon_sym_constinit] = ACTIONS(3301),
    [anon_sym_consteval] = ACTIONS(3301),
    [anon_sym_PROGMEM] = ACTIONS(3301),
    [aux_sym_primitive_type_token1] = ACTIONS(3301),
    [anon_sym_byte] = ACTIONS(3301),
    [anon_sym_word] = ACTIONS(3301),
    [anon_sym_enum] = ACTIONS(3301),
    [anon_sym_class] = ACTIONS(3301),
    [anon_sym_struct] = ACTIONS(3301),
    [anon_sym_union] = ACTIONS(3301),
    [anon_sym_if] = ACTIONS(3301),
    [anon_sym_switch] = ACTIONS(3301),
    [anon_sym_case] = ACTIONS(3301),
    [anon_sym_default] = ACTIONS(3301),
    [anon_sym_while] = ACTIONS(3301),
    [anon_sym_do] = ACTIONS(3301),
    [anon_sym_for] = ACTIONS(3301),
    [anon_sym_return] = ACTIONS(3301),
    [anon_sym_break] = ACTIONS(3301),
    [anon_sym_continue] = ACTIONS(3301),
    [anon_sym_goto] = ACTIONS(3301),
    [anon_sym___try] = ACTIONS(3301),
    [anon_sym___leave] = ACTIONS(3301),
    [anon_sym_not] = ACTIONS(3301),
    [anon_sym_compl] = ACTIONS(3301),
    [anon_sym_DASH_DASH] = ACTIONS(3303),
    [anon_sym_PLUS_PLUS] = ACTIONS(3303),
    [anon_sym_sizeof] = ACTIONS(3301),
    [anon_sym___alignof__] = ACTIONS(3301),
    [anon_sym___alignof] = ACTIONS(3301),
    [anon_sym__alignof] = ACTIONS(3301),
    [anon_sym_alignof] = ACTIONS(3301),
    [anon_sym__Alignof] = ACTIONS(3301),
    [anon_sym_offsetof] = ACTIONS(3301),
    [anon_sym__Generic] = ACTIONS(3301),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [aux_sym_number_literal_token1] = ACTIONS(3303),
    [aux_sym_number_literal_token2] = ACTIONS(3301),
    [anon_sym_L_SQUOTE] = ACTIONS(3303),
    [anon_sym_u_SQUOTE] = ACTIONS(3303),
    [anon_sym_U_SQUOTE] = ACTIONS(3303),
    [anon_sym_u8_SQUOTE] = ACTIONS(3303),
    [anon_sym_SQUOTE] = ACTIONS(3303),
    [anon_sym_L_DQUOTE] = ACTIONS(3303),
    [anon_sym_u_DQUOTE] = ACTIONS(3303),
    [anon_sym_U_DQUOTE] = ACTIONS(3303),
    [anon_sym_u8_DQUOTE] = ACTIONS(3303),
    [anon_sym_DQUOTE] = ACTIONS(3303),
    [sym_true] = ACTIONS(3301),
    [sym_false] = ACTIONS(3301),
    [anon_sym_NULL] = ACTIONS(3301),
    [anon_sym_nullptr] = ACTIONS(3301),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3301),
    [anon_sym_decltype] = ACTIONS(3301),
    [anon_sym_virtual] = ACTIONS(3301),
    [anon_sym_alignas] = ACTIONS(3301),
    [anon_sym_explicit] = ACTIONS(3301),
    [anon_sym_typename] = ACTIONS(3301),
    [anon_sym_template] = ACTIONS(3301),
    [anon_sym_operator] = ACTIONS(3301),
    [anon_sym_try] = ACTIONS(3301),
    [anon_sym_delete] = ACTIONS(3301),
    [anon_sym_throw] = ACTIONS(3301),
    [anon_sym_namespace] = ACTIONS(3301),
    [anon_sym_using] = ACTIONS(3301),
    [anon_sym_static_assert] = ACTIONS(3301),
    [anon_sym_concept] = ACTIONS(3301),
    [anon_sym_co_return] = ACTIONS(3301),
    [anon_sym_co_yield] = ACTIONS(3301),
    [anon_sym_R_DQUOTE] = ACTIONS(3303),
    [anon_sym_LR_DQUOTE] = ACTIONS(3303),
    [anon_sym_uR_DQUOTE] = ACTIONS(3303),
    [anon_sym_UR_DQUOTE] = ACTIONS(3303),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3303),
    [anon_sym_co_await] = ACTIONS(3301),
    [anon_sym_new] = ACTIONS(3301),
    [anon_sym_requires] = ACTIONS(3301),
    [sym_this] = ACTIONS(3301),
  },
  [888] = {
    [sym_identifier] = ACTIONS(3324),
    [aux_sym_preproc_include_token1] = ACTIONS(3324),
    [aux_sym_preproc_def_token1] = ACTIONS(3324),
    [aux_sym_preproc_if_token1] = ACTIONS(3324),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3324),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3324),
    [sym_preproc_directive] = ACTIONS(3324),
    [anon_sym_LPAREN2] = ACTIONS(3326),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_DASH] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3326),
    [anon_sym_AMP_AMP] = ACTIONS(3326),
    [anon_sym_AMP] = ACTIONS(3324),
    [anon_sym_SEMI] = ACTIONS(3326),
    [anon_sym___extension__] = ACTIONS(3324),
    [anon_sym_typedef] = ACTIONS(3324),
    [anon_sym_extern] = ACTIONS(3324),
    [anon_sym___attribute__] = ACTIONS(3324),
    [anon_sym_COLON_COLON] = ACTIONS(3326),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3326),
    [anon_sym___declspec] = ACTIONS(3324),
    [anon_sym___based] = ACTIONS(3324),
    [anon_sym___cdecl] = ACTIONS(3324),
    [anon_sym___clrcall] = ACTIONS(3324),
    [anon_sym___stdcall] = ACTIONS(3324),
    [anon_sym___fastcall] = ACTIONS(3324),
    [anon_sym___thiscall] = ACTIONS(3324),
    [anon_sym___vectorcall] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3326),
    [anon_sym_RBRACE] = ACTIONS(3326),
    [anon_sym_signed] = ACTIONS(3324),
    [anon_sym_unsigned] = ACTIONS(3324),
    [anon_sym_long] = ACTIONS(3324),
    [anon_sym_short] = ACTIONS(3324),
    [anon_sym_LBRACK] = ACTIONS(3324),
    [anon_sym_static] = ACTIONS(3324),
    [anon_sym_register] = ACTIONS(3324),
    [anon_sym_inline] = ACTIONS(3324),
    [anon_sym___inline] = ACTIONS(3324),
    [anon_sym___inline__] = ACTIONS(3324),
    [anon_sym___forceinline] = ACTIONS(3324),
    [anon_sym_thread_local] = ACTIONS(3324),
    [anon_sym___thread] = ACTIONS(3324),
    [anon_sym_const] = ACTIONS(3324),
    [anon_sym_constexpr] = ACTIONS(3324),
    [anon_sym_volatile] = ACTIONS(3324),
    [anon_sym_restrict] = ACTIONS(3324),
    [anon_sym___restrict__] = ACTIONS(3324),
    [anon_sym__Atomic] = ACTIONS(3324),
    [anon_sym__Noreturn] = ACTIONS(3324),
    [anon_sym_noreturn] = ACTIONS(3324),
    [anon_sym_mutable] = ACTIONS(3324),
    [anon_sym_constinit] = ACTIONS(3324),
    [anon_sym_consteval] = ACTIONS(3324),
    [anon_sym_PROGMEM] = ACTIONS(3324),
    [aux_sym_primitive_type_token1] = ACTIONS(3324),
    [anon_sym_byte] = ACTIONS(3324),
    [anon_sym_word] = ACTIONS(3324),
    [anon_sym_enum] = ACTIONS(3324),
    [anon_sym_class] = ACTIONS(3324),
    [anon_sym_struct] = ACTIONS(3324),
    [anon_sym_union] = ACTIONS(3324),
    [anon_sym_if] = ACTIONS(3324),
    [anon_sym_switch] = ACTIONS(3324),
    [anon_sym_case] = ACTIONS(3324),
    [anon_sym_default] = ACTIONS(3324),
    [anon_sym_while] = ACTIONS(3324),
    [anon_sym_do] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3324),
    [anon_sym_return] = ACTIONS(3324),
    [anon_sym_break] = ACTIONS(3324),
    [anon_sym_continue] = ACTIONS(3324),
    [anon_sym_goto] = ACTIONS(3324),
    [anon_sym___try] = ACTIONS(3324),
    [anon_sym___leave] = ACTIONS(3324),
    [anon_sym_not] = ACTIONS(3324),
    [anon_sym_compl] = ACTIONS(3324),
    [anon_sym_DASH_DASH] = ACTIONS(3326),
    [anon_sym_PLUS_PLUS] = ACTIONS(3326),
    [anon_sym_sizeof] = ACTIONS(3324),
    [anon_sym___alignof__] = ACTIONS(3324),
    [anon_sym___alignof] = ACTIONS(3324),
    [anon_sym__alignof] = ACTIONS(3324),
    [anon_sym_alignof] = ACTIONS(3324),
    [anon_sym__Alignof] = ACTIONS(3324),
    [anon_sym_offsetof] = ACTIONS(3324),
    [anon_sym__Generic] = ACTIONS(3324),
    [anon_sym_asm] = ACTIONS(3324),
    [anon_sym___asm__] = ACTIONS(3324),
    [aux_sym_number_literal_token1] = ACTIONS(3326),
    [aux_sym_number_literal_token2] = ACTIONS(3324),
    [anon_sym_L_SQUOTE] = ACTIONS(3326),
    [anon_sym_u_SQUOTE] = ACTIONS(3326),
    [anon_sym_U_SQUOTE] = ACTIONS(3326),
    [anon_sym_u8_SQUOTE] = ACTIONS(3326),
    [anon_sym_SQUOTE] = ACTIONS(3326),
    [anon_sym_L_DQUOTE] = ACTIONS(3326),
    [anon_sym_u_DQUOTE] = ACTIONS(3326),
    [anon_sym_U_DQUOTE] = ACTIONS(3326),
    [anon_sym_u8_DQUOTE] = ACTIONS(3326),
    [anon_sym_DQUOTE] = ACTIONS(3326),
    [sym_true] = ACTIONS(3324),
    [sym_false] = ACTIONS(3324),
    [anon_sym_NULL] = ACTIONS(3324),
    [anon_sym_nullptr] = ACTIONS(3324),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3324),
    [anon_sym_decltype] = ACTIONS(3324),
    [anon_sym_virtual] = ACTIONS(3324),
    [anon_sym_alignas] = ACTIONS(3324),
    [anon_sym_explicit] = ACTIONS(3324),
    [anon_sym_typename] = ACTIONS(3324),
    [anon_sym_template] = ACTIONS(3324),
    [anon_sym_operator] = ACTIONS(3324),
    [anon_sym_try] = ACTIONS(3324),
    [anon_sym_delete] = ACTIONS(3324),
    [anon_sym_throw] = ACTIONS(3324),
    [anon_sym_namespace] = ACTIONS(3324),
    [anon_sym_using] = ACTIONS(3324),
    [anon_sym_static_assert] = ACTIONS(3324),
    [anon_sym_concept] = ACTIONS(3324),
    [anon_sym_co_return] = ACTIONS(3324),
    [anon_sym_co_yield] = ACTIONS(3324),
    [anon_sym_R_DQUOTE] = ACTIONS(3326),
    [anon_sym_LR_DQUOTE] = ACTIONS(3326),
    [anon_sym_uR_DQUOTE] = ACTIONS(3326),
    [anon_sym_UR_DQUOTE] = ACTIONS(3326),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3326),
    [anon_sym_co_await] = ACTIONS(3324),
    [anon_sym_new] = ACTIONS(3324),
    [anon_sym_requires] = ACTIONS(3324),
    [sym_this] = ACTIONS(3324),
  },
  [889] = {
    [sym_identifier] = ACTIONS(3328),
    [aux_sym_preproc_include_token1] = ACTIONS(3328),
    [aux_sym_preproc_def_token1] = ACTIONS(3328),
    [aux_sym_preproc_if_token1] = ACTIONS(3328),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3328),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3328),
    [sym_preproc_directive] = ACTIONS(3328),
    [anon_sym_LPAREN2] = ACTIONS(3330),
    [anon_sym_BANG] = ACTIONS(3330),
    [anon_sym_TILDE] = ACTIONS(3330),
    [anon_sym_DASH] = ACTIONS(3328),
    [anon_sym_PLUS] = ACTIONS(3328),
    [anon_sym_STAR] = ACTIONS(3330),
    [anon_sym_AMP_AMP] = ACTIONS(3330),
    [anon_sym_AMP] = ACTIONS(3328),
    [anon_sym_SEMI] = ACTIONS(3330),
    [anon_sym___extension__] = ACTIONS(3328),
    [anon_sym_typedef] = ACTIONS(3328),
    [anon_sym_extern] = ACTIONS(3328),
    [anon_sym___attribute__] = ACTIONS(3328),
    [anon_sym_COLON_COLON] = ACTIONS(3330),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3330),
    [anon_sym___declspec] = ACTIONS(3328),
    [anon_sym___based] = ACTIONS(3328),
    [anon_sym___cdecl] = ACTIONS(3328),
    [anon_sym___clrcall] = ACTIONS(3328),
    [anon_sym___stdcall] = ACTIONS(3328),
    [anon_sym___fastcall] = ACTIONS(3328),
    [anon_sym___thiscall] = ACTIONS(3328),
    [anon_sym___vectorcall] = ACTIONS(3328),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_RBRACE] = ACTIONS(3330),
    [anon_sym_signed] = ACTIONS(3328),
    [anon_sym_unsigned] = ACTIONS(3328),
    [anon_sym_long] = ACTIONS(3328),
    [anon_sym_short] = ACTIONS(3328),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_static] = ACTIONS(3328),
    [anon_sym_register] = ACTIONS(3328),
    [anon_sym_inline] = ACTIONS(3328),
    [anon_sym___inline] = ACTIONS(3328),
    [anon_sym___inline__] = ACTIONS(3328),
    [anon_sym___forceinline] = ACTIONS(3328),
    [anon_sym_thread_local] = ACTIONS(3328),
    [anon_sym___thread] = ACTIONS(3328),
    [anon_sym_const] = ACTIONS(3328),
    [anon_sym_constexpr] = ACTIONS(3328),
    [anon_sym_volatile] = ACTIONS(3328),
    [anon_sym_restrict] = ACTIONS(3328),
    [anon_sym___restrict__] = ACTIONS(3328),
    [anon_sym__Atomic] = ACTIONS(3328),
    [anon_sym__Noreturn] = ACTIONS(3328),
    [anon_sym_noreturn] = ACTIONS(3328),
    [anon_sym_mutable] = ACTIONS(3328),
    [anon_sym_constinit] = ACTIONS(3328),
    [anon_sym_consteval] = ACTIONS(3328),
    [anon_sym_PROGMEM] = ACTIONS(3328),
    [aux_sym_primitive_type_token1] = ACTIONS(3328),
    [anon_sym_byte] = ACTIONS(3328),
    [anon_sym_word] = ACTIONS(3328),
    [anon_sym_enum] = ACTIONS(3328),
    [anon_sym_class] = ACTIONS(3328),
    [anon_sym_struct] = ACTIONS(3328),
    [anon_sym_union] = ACTIONS(3328),
    [anon_sym_if] = ACTIONS(3328),
    [anon_sym_switch] = ACTIONS(3328),
    [anon_sym_case] = ACTIONS(3328),
    [anon_sym_default] = ACTIONS(3328),
    [anon_sym_while] = ACTIONS(3328),
    [anon_sym_do] = ACTIONS(3328),
    [anon_sym_for] = ACTIONS(3328),
    [anon_sym_return] = ACTIONS(3328),
    [anon_sym_break] = ACTIONS(3328),
    [anon_sym_continue] = ACTIONS(3328),
    [anon_sym_goto] = ACTIONS(3328),
    [anon_sym___try] = ACTIONS(3328),
    [anon_sym___leave] = ACTIONS(3328),
    [anon_sym_not] = ACTIONS(3328),
    [anon_sym_compl] = ACTIONS(3328),
    [anon_sym_DASH_DASH] = ACTIONS(3330),
    [anon_sym_PLUS_PLUS] = ACTIONS(3330),
    [anon_sym_sizeof] = ACTIONS(3328),
    [anon_sym___alignof__] = ACTIONS(3328),
    [anon_sym___alignof] = ACTIONS(3328),
    [anon_sym__alignof] = ACTIONS(3328),
    [anon_sym_alignof] = ACTIONS(3328),
    [anon_sym__Alignof] = ACTIONS(3328),
    [anon_sym_offsetof] = ACTIONS(3328),
    [anon_sym__Generic] = ACTIONS(3328),
    [anon_sym_asm] = ACTIONS(3328),
    [anon_sym___asm__] = ACTIONS(3328),
    [aux_sym_number_literal_token1] = ACTIONS(3330),
    [aux_sym_number_literal_token2] = ACTIONS(3328),
    [anon_sym_L_SQUOTE] = ACTIONS(3330),
    [anon_sym_u_SQUOTE] = ACTIONS(3330),
    [anon_sym_U_SQUOTE] = ACTIONS(3330),
    [anon_sym_u8_SQUOTE] = ACTIONS(3330),
    [anon_sym_SQUOTE] = ACTIONS(3330),
    [anon_sym_L_DQUOTE] = ACTIONS(3330),
    [anon_sym_u_DQUOTE] = ACTIONS(3330),
    [anon_sym_U_DQUOTE] = ACTIONS(3330),
    [anon_sym_u8_DQUOTE] = ACTIONS(3330),
    [anon_sym_DQUOTE] = ACTIONS(3330),
    [sym_true] = ACTIONS(3328),
    [sym_false] = ACTIONS(3328),
    [anon_sym_NULL] = ACTIONS(3328),
    [anon_sym_nullptr] = ACTIONS(3328),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3328),
    [anon_sym_decltype] = ACTIONS(3328),
    [anon_sym_virtual] = ACTIONS(3328),
    [anon_sym_alignas] = ACTIONS(3328),
    [anon_sym_explicit] = ACTIONS(3328),
    [anon_sym_typename] = ACTIONS(3328),
    [anon_sym_template] = ACTIONS(3328),
    [anon_sym_operator] = ACTIONS(3328),
    [anon_sym_try] = ACTIONS(3328),
    [anon_sym_delete] = ACTIONS(3328),
    [anon_sym_throw] = ACTIONS(3328),
    [anon_sym_namespace] = ACTIONS(3328),
    [anon_sym_using] = ACTIONS(3328),
    [anon_sym_static_assert] = ACTIONS(3328),
    [anon_sym_concept] = ACTIONS(3328),
    [anon_sym_co_return] = ACTIONS(3328),
    [anon_sym_co_yield] = ACTIONS(3328),
    [anon_sym_R_DQUOTE] = ACTIONS(3330),
    [anon_sym_LR_DQUOTE] = ACTIONS(3330),
    [anon_sym_uR_DQUOTE] = ACTIONS(3330),
    [anon_sym_UR_DQUOTE] = ACTIONS(3330),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3330),
    [anon_sym_co_await] = ACTIONS(3328),
    [anon_sym_new] = ACTIONS(3328),
    [anon_sym_requires] = ACTIONS(3328),
    [sym_this] = ACTIONS(3328),
  },
  [890] = {
    [sym_identifier] = ACTIONS(3250),
    [aux_sym_preproc_include_token1] = ACTIONS(3250),
    [aux_sym_preproc_def_token1] = ACTIONS(3250),
    [aux_sym_preproc_if_token1] = ACTIONS(3250),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3250),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3250),
    [sym_preproc_directive] = ACTIONS(3250),
    [anon_sym_LPAREN2] = ACTIONS(3252),
    [anon_sym_BANG] = ACTIONS(3252),
    [anon_sym_TILDE] = ACTIONS(3252),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_STAR] = ACTIONS(3252),
    [anon_sym_AMP_AMP] = ACTIONS(3252),
    [anon_sym_AMP] = ACTIONS(3250),
    [anon_sym_SEMI] = ACTIONS(3252),
    [anon_sym___extension__] = ACTIONS(3250),
    [anon_sym_typedef] = ACTIONS(3250),
    [anon_sym_extern] = ACTIONS(3250),
    [anon_sym___attribute__] = ACTIONS(3250),
    [anon_sym_COLON_COLON] = ACTIONS(3252),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3252),
    [anon_sym___declspec] = ACTIONS(3250),
    [anon_sym___based] = ACTIONS(3250),
    [anon_sym___cdecl] = ACTIONS(3250),
    [anon_sym___clrcall] = ACTIONS(3250),
    [anon_sym___stdcall] = ACTIONS(3250),
    [anon_sym___fastcall] = ACTIONS(3250),
    [anon_sym___thiscall] = ACTIONS(3250),
    [anon_sym___vectorcall] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3252),
    [anon_sym_RBRACE] = ACTIONS(3252),
    [anon_sym_signed] = ACTIONS(3250),
    [anon_sym_unsigned] = ACTIONS(3250),
    [anon_sym_long] = ACTIONS(3250),
    [anon_sym_short] = ACTIONS(3250),
    [anon_sym_LBRACK] = ACTIONS(3250),
    [anon_sym_static] = ACTIONS(3250),
    [anon_sym_register] = ACTIONS(3250),
    [anon_sym_inline] = ACTIONS(3250),
    [anon_sym___inline] = ACTIONS(3250),
    [anon_sym___inline__] = ACTIONS(3250),
    [anon_sym___forceinline] = ACTIONS(3250),
    [anon_sym_thread_local] = ACTIONS(3250),
    [anon_sym___thread] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(3250),
    [anon_sym_constexpr] = ACTIONS(3250),
    [anon_sym_volatile] = ACTIONS(3250),
    [anon_sym_restrict] = ACTIONS(3250),
    [anon_sym___restrict__] = ACTIONS(3250),
    [anon_sym__Atomic] = ACTIONS(3250),
    [anon_sym__Noreturn] = ACTIONS(3250),
    [anon_sym_noreturn] = ACTIONS(3250),
    [anon_sym_mutable] = ACTIONS(3250),
    [anon_sym_constinit] = ACTIONS(3250),
    [anon_sym_consteval] = ACTIONS(3250),
    [anon_sym_PROGMEM] = ACTIONS(3250),
    [aux_sym_primitive_type_token1] = ACTIONS(3250),
    [anon_sym_byte] = ACTIONS(3250),
    [anon_sym_word] = ACTIONS(3250),
    [anon_sym_enum] = ACTIONS(3250),
    [anon_sym_class] = ACTIONS(3250),
    [anon_sym_struct] = ACTIONS(3250),
    [anon_sym_union] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_switch] = ACTIONS(3250),
    [anon_sym_case] = ACTIONS(3250),
    [anon_sym_default] = ACTIONS(3250),
    [anon_sym_while] = ACTIONS(3250),
    [anon_sym_do] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_goto] = ACTIONS(3250),
    [anon_sym___try] = ACTIONS(3250),
    [anon_sym___leave] = ACTIONS(3250),
    [anon_sym_not] = ACTIONS(3250),
    [anon_sym_compl] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3252),
    [anon_sym_PLUS_PLUS] = ACTIONS(3252),
    [anon_sym_sizeof] = ACTIONS(3250),
    [anon_sym___alignof__] = ACTIONS(3250),
    [anon_sym___alignof] = ACTIONS(3250),
    [anon_sym__alignof] = ACTIONS(3250),
    [anon_sym_alignof] = ACTIONS(3250),
    [anon_sym__Alignof] = ACTIONS(3250),
    [anon_sym_offsetof] = ACTIONS(3250),
    [anon_sym__Generic] = ACTIONS(3250),
    [anon_sym_asm] = ACTIONS(3250),
    [anon_sym___asm__] = ACTIONS(3250),
    [aux_sym_number_literal_token1] = ACTIONS(3252),
    [aux_sym_number_literal_token2] = ACTIONS(3250),
    [anon_sym_L_SQUOTE] = ACTIONS(3252),
    [anon_sym_u_SQUOTE] = ACTIONS(3252),
    [anon_sym_U_SQUOTE] = ACTIONS(3252),
    [anon_sym_u8_SQUOTE] = ACTIONS(3252),
    [anon_sym_SQUOTE] = ACTIONS(3252),
    [anon_sym_L_DQUOTE] = ACTIONS(3252),
    [anon_sym_u_DQUOTE] = ACTIONS(3252),
    [anon_sym_U_DQUOTE] = ACTIONS(3252),
    [anon_sym_u8_DQUOTE] = ACTIONS(3252),
    [anon_sym_DQUOTE] = ACTIONS(3252),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [anon_sym_NULL] = ACTIONS(3250),
    [anon_sym_nullptr] = ACTIONS(3250),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3250),
    [anon_sym_decltype] = ACTIONS(3250),
    [anon_sym_virtual] = ACTIONS(3250),
    [anon_sym_alignas] = ACTIONS(3250),
    [anon_sym_explicit] = ACTIONS(3250),
    [anon_sym_typename] = ACTIONS(3250),
    [anon_sym_template] = ACTIONS(3250),
    [anon_sym_operator] = ACTIONS(3250),
    [anon_sym_try] = ACTIONS(3250),
    [anon_sym_delete] = ACTIONS(3250),
    [anon_sym_throw] = ACTIONS(3250),
    [anon_sym_namespace] = ACTIONS(3250),
    [anon_sym_using] = ACTIONS(3250),
    [anon_sym_static_assert] = ACTIONS(3250),
    [anon_sym_concept] = ACTIONS(3250),
    [anon_sym_co_return] = ACTIONS(3250),
    [anon_sym_co_yield] = ACTIONS(3250),
    [anon_sym_R_DQUOTE] = ACTIONS(3252),
    [anon_sym_LR_DQUOTE] = ACTIONS(3252),
    [anon_sym_uR_DQUOTE] = ACTIONS(3252),
    [anon_sym_UR_DQUOTE] = ACTIONS(3252),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3252),
    [anon_sym_co_await] = ACTIONS(3250),
    [anon_sym_new] = ACTIONS(3250),
    [anon_sym_requires] = ACTIONS(3250),
    [sym_this] = ACTIONS(3250),
  },
  [891] = {
    [sym_identifier] = ACTIONS(3186),
    [aux_sym_preproc_include_token1] = ACTIONS(3186),
    [aux_sym_preproc_def_token1] = ACTIONS(3186),
    [aux_sym_preproc_if_token1] = ACTIONS(3186),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3186),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3186),
    [sym_preproc_directive] = ACTIONS(3186),
    [anon_sym_LPAREN2] = ACTIONS(3188),
    [anon_sym_BANG] = ACTIONS(3188),
    [anon_sym_TILDE] = ACTIONS(3188),
    [anon_sym_DASH] = ACTIONS(3186),
    [anon_sym_PLUS] = ACTIONS(3186),
    [anon_sym_STAR] = ACTIONS(3188),
    [anon_sym_AMP_AMP] = ACTIONS(3188),
    [anon_sym_AMP] = ACTIONS(3186),
    [anon_sym_SEMI] = ACTIONS(3188),
    [anon_sym___extension__] = ACTIONS(3186),
    [anon_sym_typedef] = ACTIONS(3186),
    [anon_sym_extern] = ACTIONS(3186),
    [anon_sym___attribute__] = ACTIONS(3186),
    [anon_sym_COLON_COLON] = ACTIONS(3188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3188),
    [anon_sym___declspec] = ACTIONS(3186),
    [anon_sym___based] = ACTIONS(3186),
    [anon_sym___cdecl] = ACTIONS(3186),
    [anon_sym___clrcall] = ACTIONS(3186),
    [anon_sym___stdcall] = ACTIONS(3186),
    [anon_sym___fastcall] = ACTIONS(3186),
    [anon_sym___thiscall] = ACTIONS(3186),
    [anon_sym___vectorcall] = ACTIONS(3186),
    [anon_sym_LBRACE] = ACTIONS(3188),
    [anon_sym_RBRACE] = ACTIONS(3188),
    [anon_sym_signed] = ACTIONS(3186),
    [anon_sym_unsigned] = ACTIONS(3186),
    [anon_sym_long] = ACTIONS(3186),
    [anon_sym_short] = ACTIONS(3186),
    [anon_sym_LBRACK] = ACTIONS(3186),
    [anon_sym_static] = ACTIONS(3186),
    [anon_sym_register] = ACTIONS(3186),
    [anon_sym_inline] = ACTIONS(3186),
    [anon_sym___inline] = ACTIONS(3186),
    [anon_sym___inline__] = ACTIONS(3186),
    [anon_sym___forceinline] = ACTIONS(3186),
    [anon_sym_thread_local] = ACTIONS(3186),
    [anon_sym___thread] = ACTIONS(3186),
    [anon_sym_const] = ACTIONS(3186),
    [anon_sym_constexpr] = ACTIONS(3186),
    [anon_sym_volatile] = ACTIONS(3186),
    [anon_sym_restrict] = ACTIONS(3186),
    [anon_sym___restrict__] = ACTIONS(3186),
    [anon_sym__Atomic] = ACTIONS(3186),
    [anon_sym__Noreturn] = ACTIONS(3186),
    [anon_sym_noreturn] = ACTIONS(3186),
    [anon_sym_mutable] = ACTIONS(3186),
    [anon_sym_constinit] = ACTIONS(3186),
    [anon_sym_consteval] = ACTIONS(3186),
    [anon_sym_PROGMEM] = ACTIONS(3186),
    [aux_sym_primitive_type_token1] = ACTIONS(3186),
    [anon_sym_byte] = ACTIONS(3186),
    [anon_sym_word] = ACTIONS(3186),
    [anon_sym_enum] = ACTIONS(3186),
    [anon_sym_class] = ACTIONS(3186),
    [anon_sym_struct] = ACTIONS(3186),
    [anon_sym_union] = ACTIONS(3186),
    [anon_sym_if] = ACTIONS(3186),
    [anon_sym_switch] = ACTIONS(3186),
    [anon_sym_case] = ACTIONS(3186),
    [anon_sym_default] = ACTIONS(3186),
    [anon_sym_while] = ACTIONS(3186),
    [anon_sym_do] = ACTIONS(3186),
    [anon_sym_for] = ACTIONS(3186),
    [anon_sym_return] = ACTIONS(3186),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_continue] = ACTIONS(3186),
    [anon_sym_goto] = ACTIONS(3186),
    [anon_sym___try] = ACTIONS(3186),
    [anon_sym___leave] = ACTIONS(3186),
    [anon_sym_not] = ACTIONS(3186),
    [anon_sym_compl] = ACTIONS(3186),
    [anon_sym_DASH_DASH] = ACTIONS(3188),
    [anon_sym_PLUS_PLUS] = ACTIONS(3188),
    [anon_sym_sizeof] = ACTIONS(3186),
    [anon_sym___alignof__] = ACTIONS(3186),
    [anon_sym___alignof] = ACTIONS(3186),
    [anon_sym__alignof] = ACTIONS(3186),
    [anon_sym_alignof] = ACTIONS(3186),
    [anon_sym__Alignof] = ACTIONS(3186),
    [anon_sym_offsetof] = ACTIONS(3186),
    [anon_sym__Generic] = ACTIONS(3186),
    [anon_sym_asm] = ACTIONS(3186),
    [anon_sym___asm__] = ACTIONS(3186),
    [aux_sym_number_literal_token1] = ACTIONS(3188),
    [aux_sym_number_literal_token2] = ACTIONS(3186),
    [anon_sym_L_SQUOTE] = ACTIONS(3188),
    [anon_sym_u_SQUOTE] = ACTIONS(3188),
    [anon_sym_U_SQUOTE] = ACTIONS(3188),
    [anon_sym_u8_SQUOTE] = ACTIONS(3188),
    [anon_sym_SQUOTE] = ACTIONS(3188),
    [anon_sym_L_DQUOTE] = ACTIONS(3188),
    [anon_sym_u_DQUOTE] = ACTIONS(3188),
    [anon_sym_U_DQUOTE] = ACTIONS(3188),
    [anon_sym_u8_DQUOTE] = ACTIONS(3188),
    [anon_sym_DQUOTE] = ACTIONS(3188),
    [sym_true] = ACTIONS(3186),
    [sym_false] = ACTIONS(3186),
    [anon_sym_NULL] = ACTIONS(3186),
    [anon_sym_nullptr] = ACTIONS(3186),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3186),
    [anon_sym_decltype] = ACTIONS(3186),
    [anon_sym_virtual] = ACTIONS(3186),
    [anon_sym_alignas] = ACTIONS(3186),
    [anon_sym_explicit] = ACTIONS(3186),
    [anon_sym_typename] = ACTIONS(3186),
    [anon_sym_template] = ACTIONS(3186),
    [anon_sym_operator] = ACTIONS(3186),
    [anon_sym_try] = ACTIONS(3186),
    [anon_sym_delete] = ACTIONS(3186),
    [anon_sym_throw] = ACTIONS(3186),
    [anon_sym_namespace] = ACTIONS(3186),
    [anon_sym_using] = ACTIONS(3186),
    [anon_sym_static_assert] = ACTIONS(3186),
    [anon_sym_concept] = ACTIONS(3186),
    [anon_sym_co_return] = ACTIONS(3186),
    [anon_sym_co_yield] = ACTIONS(3186),
    [anon_sym_R_DQUOTE] = ACTIONS(3188),
    [anon_sym_LR_DQUOTE] = ACTIONS(3188),
    [anon_sym_uR_DQUOTE] = ACTIONS(3188),
    [anon_sym_UR_DQUOTE] = ACTIONS(3188),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3188),
    [anon_sym_co_await] = ACTIONS(3186),
    [anon_sym_new] = ACTIONS(3186),
    [anon_sym_requires] = ACTIONS(3186),
    [sym_this] = ACTIONS(3186),
  },
  [892] = {
    [sym_identifier] = ACTIONS(3182),
    [aux_sym_preproc_include_token1] = ACTIONS(3182),
    [aux_sym_preproc_def_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [sym_preproc_directive] = ACTIONS(3182),
    [anon_sym_LPAREN2] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym___extension__] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3182),
    [anon_sym_extern] = ACTIONS(3182),
    [anon_sym___attribute__] = ACTIONS(3182),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3184),
    [anon_sym___declspec] = ACTIONS(3182),
    [anon_sym___based] = ACTIONS(3182),
    [anon_sym___cdecl] = ACTIONS(3182),
    [anon_sym___clrcall] = ACTIONS(3182),
    [anon_sym___stdcall] = ACTIONS(3182),
    [anon_sym___fastcall] = ACTIONS(3182),
    [anon_sym___thiscall] = ACTIONS(3182),
    [anon_sym___vectorcall] = ACTIONS(3182),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_RBRACE] = ACTIONS(3184),
    [anon_sym_signed] = ACTIONS(3182),
    [anon_sym_unsigned] = ACTIONS(3182),
    [anon_sym_long] = ACTIONS(3182),
    [anon_sym_short] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_register] = ACTIONS(3182),
    [anon_sym_inline] = ACTIONS(3182),
    [anon_sym___inline] = ACTIONS(3182),
    [anon_sym___inline__] = ACTIONS(3182),
    [anon_sym___forceinline] = ACTIONS(3182),
    [anon_sym_thread_local] = ACTIONS(3182),
    [anon_sym___thread] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_constexpr] = ACTIONS(3182),
    [anon_sym_volatile] = ACTIONS(3182),
    [anon_sym_restrict] = ACTIONS(3182),
    [anon_sym___restrict__] = ACTIONS(3182),
    [anon_sym__Atomic] = ACTIONS(3182),
    [anon_sym__Noreturn] = ACTIONS(3182),
    [anon_sym_noreturn] = ACTIONS(3182),
    [anon_sym_mutable] = ACTIONS(3182),
    [anon_sym_constinit] = ACTIONS(3182),
    [anon_sym_consteval] = ACTIONS(3182),
    [anon_sym_PROGMEM] = ACTIONS(3182),
    [aux_sym_primitive_type_token1] = ACTIONS(3182),
    [anon_sym_byte] = ACTIONS(3182),
    [anon_sym_word] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_struct] = ACTIONS(3182),
    [anon_sym_union] = ACTIONS(3182),
    [anon_sym_if] = ACTIONS(3182),
    [anon_sym_switch] = ACTIONS(3182),
    [anon_sym_case] = ACTIONS(3182),
    [anon_sym_default] = ACTIONS(3182),
    [anon_sym_while] = ACTIONS(3182),
    [anon_sym_do] = ACTIONS(3182),
    [anon_sym_for] = ACTIONS(3182),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_break] = ACTIONS(3182),
    [anon_sym_continue] = ACTIONS(3182),
    [anon_sym_goto] = ACTIONS(3182),
    [anon_sym___try] = ACTIONS(3182),
    [anon_sym___leave] = ACTIONS(3182),
    [anon_sym_not] = ACTIONS(3182),
    [anon_sym_compl] = ACTIONS(3182),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_sizeof] = ACTIONS(3182),
    [anon_sym___alignof__] = ACTIONS(3182),
    [anon_sym___alignof] = ACTIONS(3182),
    [anon_sym__alignof] = ACTIONS(3182),
    [anon_sym_alignof] = ACTIONS(3182),
    [anon_sym__Alignof] = ACTIONS(3182),
    [anon_sym_offsetof] = ACTIONS(3182),
    [anon_sym__Generic] = ACTIONS(3182),
    [anon_sym_asm] = ACTIONS(3182),
    [anon_sym___asm__] = ACTIONS(3182),
    [aux_sym_number_literal_token1] = ACTIONS(3184),
    [aux_sym_number_literal_token2] = ACTIONS(3182),
    [anon_sym_L_SQUOTE] = ACTIONS(3184),
    [anon_sym_u_SQUOTE] = ACTIONS(3184),
    [anon_sym_U_SQUOTE] = ACTIONS(3184),
    [anon_sym_u8_SQUOTE] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3184),
    [anon_sym_L_DQUOTE] = ACTIONS(3184),
    [anon_sym_u_DQUOTE] = ACTIONS(3184),
    [anon_sym_U_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8_DQUOTE] = ACTIONS(3184),
    [anon_sym_DQUOTE] = ACTIONS(3184),
    [sym_true] = ACTIONS(3182),
    [sym_false] = ACTIONS(3182),
    [anon_sym_NULL] = ACTIONS(3182),
    [anon_sym_nullptr] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3182),
    [anon_sym_decltype] = ACTIONS(3182),
    [anon_sym_virtual] = ACTIONS(3182),
    [anon_sym_alignas] = ACTIONS(3182),
    [anon_sym_explicit] = ACTIONS(3182),
    [anon_sym_typename] = ACTIONS(3182),
    [anon_sym_template] = ACTIONS(3182),
    [anon_sym_operator] = ACTIONS(3182),
    [anon_sym_try] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3182),
    [anon_sym_throw] = ACTIONS(3182),
    [anon_sym_namespace] = ACTIONS(3182),
    [anon_sym_using] = ACTIONS(3182),
    [anon_sym_static_assert] = ACTIONS(3182),
    [anon_sym_concept] = ACTIONS(3182),
    [anon_sym_co_return] = ACTIONS(3182),
    [anon_sym_co_yield] = ACTIONS(3182),
    [anon_sym_R_DQUOTE] = ACTIONS(3184),
    [anon_sym_LR_DQUOTE] = ACTIONS(3184),
    [anon_sym_uR_DQUOTE] = ACTIONS(3184),
    [anon_sym_UR_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3184),
    [anon_sym_co_await] = ACTIONS(3182),
    [anon_sym_new] = ACTIONS(3182),
    [anon_sym_requires] = ACTIONS(3182),
    [sym_this] = ACTIONS(3182),
  },
  [893] = {
    [sym_catch_clause] = STATE(396),
    [aux_sym_constructor_try_statement_repeat1] = STATE(396),
    [ts_builtin_sym_end] = ACTIONS(2858),
    [sym_identifier] = ACTIONS(2856),
    [aux_sym_preproc_include_token1] = ACTIONS(2856),
    [aux_sym_preproc_def_token1] = ACTIONS(2856),
    [aux_sym_preproc_if_token1] = ACTIONS(2856),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2856),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2856),
    [sym_preproc_directive] = ACTIONS(2856),
    [anon_sym_LPAREN2] = ACTIONS(2858),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2856),
    [anon_sym_PLUS] = ACTIONS(2856),
    [anon_sym_STAR] = ACTIONS(2858),
    [anon_sym_AMP_AMP] = ACTIONS(2858),
    [anon_sym_AMP] = ACTIONS(2856),
    [anon_sym___extension__] = ACTIONS(2856),
    [anon_sym_typedef] = ACTIONS(2856),
    [anon_sym_extern] = ACTIONS(2856),
    [anon_sym___attribute__] = ACTIONS(2856),
    [anon_sym_COLON_COLON] = ACTIONS(2858),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2858),
    [anon_sym___declspec] = ACTIONS(2856),
    [anon_sym___based] = ACTIONS(2856),
    [anon_sym___cdecl] = ACTIONS(2856),
    [anon_sym___clrcall] = ACTIONS(2856),
    [anon_sym___stdcall] = ACTIONS(2856),
    [anon_sym___fastcall] = ACTIONS(2856),
    [anon_sym___thiscall] = ACTIONS(2856),
    [anon_sym___vectorcall] = ACTIONS(2856),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_signed] = ACTIONS(2856),
    [anon_sym_unsigned] = ACTIONS(2856),
    [anon_sym_long] = ACTIONS(2856),
    [anon_sym_short] = ACTIONS(2856),
    [anon_sym_LBRACK] = ACTIONS(2856),
    [anon_sym_static] = ACTIONS(2856),
    [anon_sym_register] = ACTIONS(2856),
    [anon_sym_inline] = ACTIONS(2856),
    [anon_sym___inline] = ACTIONS(2856),
    [anon_sym___inline__] = ACTIONS(2856),
    [anon_sym___forceinline] = ACTIONS(2856),
    [anon_sym_thread_local] = ACTIONS(2856),
    [anon_sym___thread] = ACTIONS(2856),
    [anon_sym_const] = ACTIONS(2856),
    [anon_sym_constexpr] = ACTIONS(2856),
    [anon_sym_volatile] = ACTIONS(2856),
    [anon_sym_restrict] = ACTIONS(2856),
    [anon_sym___restrict__] = ACTIONS(2856),
    [anon_sym__Atomic] = ACTIONS(2856),
    [anon_sym__Noreturn] = ACTIONS(2856),
    [anon_sym_noreturn] = ACTIONS(2856),
    [anon_sym_mutable] = ACTIONS(2856),
    [anon_sym_constinit] = ACTIONS(2856),
    [anon_sym_consteval] = ACTIONS(2856),
    [anon_sym_PROGMEM] = ACTIONS(2856),
    [aux_sym_primitive_type_token1] = ACTIONS(2856),
    [anon_sym_byte] = ACTIONS(2856),
    [anon_sym_word] = ACTIONS(2856),
    [anon_sym_enum] = ACTIONS(2856),
    [anon_sym_class] = ACTIONS(2856),
    [anon_sym_struct] = ACTIONS(2856),
    [anon_sym_union] = ACTIONS(2856),
    [anon_sym_if] = ACTIONS(2856),
    [anon_sym_switch] = ACTIONS(2856),
    [anon_sym_case] = ACTIONS(2856),
    [anon_sym_default] = ACTIONS(2856),
    [anon_sym_while] = ACTIONS(2856),
    [anon_sym_do] = ACTIONS(2856),
    [anon_sym_for] = ACTIONS(2856),
    [anon_sym_return] = ACTIONS(2856),
    [anon_sym_break] = ACTIONS(2856),
    [anon_sym_continue] = ACTIONS(2856),
    [anon_sym_goto] = ACTIONS(2856),
    [anon_sym_not] = ACTIONS(2856),
    [anon_sym_compl] = ACTIONS(2856),
    [anon_sym_DASH_DASH] = ACTIONS(2858),
    [anon_sym_PLUS_PLUS] = ACTIONS(2858),
    [anon_sym_sizeof] = ACTIONS(2856),
    [anon_sym___alignof__] = ACTIONS(2856),
    [anon_sym___alignof] = ACTIONS(2856),
    [anon_sym__alignof] = ACTIONS(2856),
    [anon_sym_alignof] = ACTIONS(2856),
    [anon_sym__Alignof] = ACTIONS(2856),
    [anon_sym_offsetof] = ACTIONS(2856),
    [anon_sym__Generic] = ACTIONS(2856),
    [anon_sym_asm] = ACTIONS(2856),
    [anon_sym___asm__] = ACTIONS(2856),
    [aux_sym_number_literal_token1] = ACTIONS(2858),
    [aux_sym_number_literal_token2] = ACTIONS(2856),
    [anon_sym_L_SQUOTE] = ACTIONS(2858),
    [anon_sym_u_SQUOTE] = ACTIONS(2858),
    [anon_sym_U_SQUOTE] = ACTIONS(2858),
    [anon_sym_u8_SQUOTE] = ACTIONS(2858),
    [anon_sym_SQUOTE] = ACTIONS(2858),
    [anon_sym_L_DQUOTE] = ACTIONS(2858),
    [anon_sym_u_DQUOTE] = ACTIONS(2858),
    [anon_sym_U_DQUOTE] = ACTIONS(2858),
    [anon_sym_u8_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE] = ACTIONS(2858),
    [sym_true] = ACTIONS(2856),
    [sym_false] = ACTIONS(2856),
    [anon_sym_NULL] = ACTIONS(2856),
    [anon_sym_nullptr] = ACTIONS(2856),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2856),
    [anon_sym_decltype] = ACTIONS(2856),
    [anon_sym_virtual] = ACTIONS(2856),
    [anon_sym_alignas] = ACTIONS(2856),
    [anon_sym_explicit] = ACTIONS(2856),
    [anon_sym_typename] = ACTIONS(2856),
    [anon_sym_template] = ACTIONS(2856),
    [anon_sym_operator] = ACTIONS(2856),
    [anon_sym_try] = ACTIONS(2856),
    [anon_sym_delete] = ACTIONS(2856),
    [anon_sym_throw] = ACTIONS(2856),
    [anon_sym_namespace] = ACTIONS(2856),
    [anon_sym_using] = ACTIONS(2856),
    [anon_sym_static_assert] = ACTIONS(2856),
    [anon_sym_concept] = ACTIONS(2856),
    [anon_sym_co_return] = ACTIONS(2856),
    [anon_sym_co_yield] = ACTIONS(2856),
    [anon_sym_catch] = ACTIONS(3507),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_LR_DQUOTE] = ACTIONS(2858),
    [anon_sym_uR_DQUOTE] = ACTIONS(2858),
    [anon_sym_UR_DQUOTE] = ACTIONS(2858),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2858),
    [anon_sym_co_await] = ACTIONS(2856),
    [anon_sym_new] = ACTIONS(2856),
    [anon_sym_requires] = ACTIONS(2856),
    [sym_this] = ACTIONS(2856),
  },
  [894] = {
    [sym_identifier] = ACTIONS(3266),
    [aux_sym_preproc_include_token1] = ACTIONS(3266),
    [aux_sym_preproc_def_token1] = ACTIONS(3266),
    [aux_sym_preproc_if_token1] = ACTIONS(3266),
    [aux_sym_preproc_if_token2] = ACTIONS(3266),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3266),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3266),
    [sym_preproc_directive] = ACTIONS(3266),
    [anon_sym_LPAREN2] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3268),
    [anon_sym_TILDE] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3266),
    [anon_sym_STAR] = ACTIONS(3268),
    [anon_sym_AMP_AMP] = ACTIONS(3268),
    [anon_sym_AMP] = ACTIONS(3266),
    [anon_sym_SEMI] = ACTIONS(3268),
    [anon_sym___extension__] = ACTIONS(3266),
    [anon_sym_typedef] = ACTIONS(3266),
    [anon_sym_extern] = ACTIONS(3266),
    [anon_sym___attribute__] = ACTIONS(3266),
    [anon_sym_COLON_COLON] = ACTIONS(3268),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3268),
    [anon_sym___declspec] = ACTIONS(3266),
    [anon_sym___based] = ACTIONS(3266),
    [anon_sym___cdecl] = ACTIONS(3266),
    [anon_sym___clrcall] = ACTIONS(3266),
    [anon_sym___stdcall] = ACTIONS(3266),
    [anon_sym___fastcall] = ACTIONS(3266),
    [anon_sym___thiscall] = ACTIONS(3266),
    [anon_sym___vectorcall] = ACTIONS(3266),
    [anon_sym_LBRACE] = ACTIONS(3268),
    [anon_sym_signed] = ACTIONS(3266),
    [anon_sym_unsigned] = ACTIONS(3266),
    [anon_sym_long] = ACTIONS(3266),
    [anon_sym_short] = ACTIONS(3266),
    [anon_sym_LBRACK] = ACTIONS(3266),
    [anon_sym_static] = ACTIONS(3266),
    [anon_sym_register] = ACTIONS(3266),
    [anon_sym_inline] = ACTIONS(3266),
    [anon_sym___inline] = ACTIONS(3266),
    [anon_sym___inline__] = ACTIONS(3266),
    [anon_sym___forceinline] = ACTIONS(3266),
    [anon_sym_thread_local] = ACTIONS(3266),
    [anon_sym___thread] = ACTIONS(3266),
    [anon_sym_const] = ACTIONS(3266),
    [anon_sym_constexpr] = ACTIONS(3266),
    [anon_sym_volatile] = ACTIONS(3266),
    [anon_sym_restrict] = ACTIONS(3266),
    [anon_sym___restrict__] = ACTIONS(3266),
    [anon_sym__Atomic] = ACTIONS(3266),
    [anon_sym__Noreturn] = ACTIONS(3266),
    [anon_sym_noreturn] = ACTIONS(3266),
    [anon_sym_mutable] = ACTIONS(3266),
    [anon_sym_constinit] = ACTIONS(3266),
    [anon_sym_consteval] = ACTIONS(3266),
    [anon_sym_PROGMEM] = ACTIONS(3266),
    [aux_sym_primitive_type_token1] = ACTIONS(3266),
    [anon_sym_byte] = ACTIONS(3266),
    [anon_sym_word] = ACTIONS(3266),
    [anon_sym_enum] = ACTIONS(3266),
    [anon_sym_class] = ACTIONS(3266),
    [anon_sym_struct] = ACTIONS(3266),
    [anon_sym_union] = ACTIONS(3266),
    [anon_sym_if] = ACTIONS(3266),
    [anon_sym_switch] = ACTIONS(3266),
    [anon_sym_case] = ACTIONS(3266),
    [anon_sym_default] = ACTIONS(3266),
    [anon_sym_while] = ACTIONS(3266),
    [anon_sym_do] = ACTIONS(3266),
    [anon_sym_for] = ACTIONS(3266),
    [anon_sym_return] = ACTIONS(3266),
    [anon_sym_break] = ACTIONS(3266),
    [anon_sym_continue] = ACTIONS(3266),
    [anon_sym_goto] = ACTIONS(3266),
    [anon_sym___try] = ACTIONS(3266),
    [anon_sym___leave] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3266),
    [anon_sym_compl] = ACTIONS(3266),
    [anon_sym_DASH_DASH] = ACTIONS(3268),
    [anon_sym_PLUS_PLUS] = ACTIONS(3268),
    [anon_sym_sizeof] = ACTIONS(3266),
    [anon_sym___alignof__] = ACTIONS(3266),
    [anon_sym___alignof] = ACTIONS(3266),
    [anon_sym__alignof] = ACTIONS(3266),
    [anon_sym_alignof] = ACTIONS(3266),
    [anon_sym__Alignof] = ACTIONS(3266),
    [anon_sym_offsetof] = ACTIONS(3266),
    [anon_sym__Generic] = ACTIONS(3266),
    [anon_sym_asm] = ACTIONS(3266),
    [anon_sym___asm__] = ACTIONS(3266),
    [aux_sym_number_literal_token1] = ACTIONS(3268),
    [aux_sym_number_literal_token2] = ACTIONS(3266),
    [anon_sym_L_SQUOTE] = ACTIONS(3268),
    [anon_sym_u_SQUOTE] = ACTIONS(3268),
    [anon_sym_U_SQUOTE] = ACTIONS(3268),
    [anon_sym_u8_SQUOTE] = ACTIONS(3268),
    [anon_sym_SQUOTE] = ACTIONS(3268),
    [anon_sym_L_DQUOTE] = ACTIONS(3268),
    [anon_sym_u_DQUOTE] = ACTIONS(3268),
    [anon_sym_U_DQUOTE] = ACTIONS(3268),
    [anon_sym_u8_DQUOTE] = ACTIONS(3268),
    [anon_sym_DQUOTE] = ACTIONS(3268),
    [sym_true] = ACTIONS(3266),
    [sym_false] = ACTIONS(3266),
    [anon_sym_NULL] = ACTIONS(3266),
    [anon_sym_nullptr] = ACTIONS(3266),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3266),
    [anon_sym_decltype] = ACTIONS(3266),
    [anon_sym_virtual] = ACTIONS(3266),
    [anon_sym_alignas] = ACTIONS(3266),
    [anon_sym_explicit] = ACTIONS(3266),
    [anon_sym_typename] = ACTIONS(3266),
    [anon_sym_template] = ACTIONS(3266),
    [anon_sym_operator] = ACTIONS(3266),
    [anon_sym_try] = ACTIONS(3266),
    [anon_sym_delete] = ACTIONS(3266),
    [anon_sym_throw] = ACTIONS(3266),
    [anon_sym_namespace] = ACTIONS(3266),
    [anon_sym_using] = ACTIONS(3266),
    [anon_sym_static_assert] = ACTIONS(3266),
    [anon_sym_concept] = ACTIONS(3266),
    [anon_sym_co_return] = ACTIONS(3266),
    [anon_sym_co_yield] = ACTIONS(3266),
    [anon_sym_R_DQUOTE] = ACTIONS(3268),
    [anon_sym_LR_DQUOTE] = ACTIONS(3268),
    [anon_sym_uR_DQUOTE] = ACTIONS(3268),
    [anon_sym_UR_DQUOTE] = ACTIONS(3268),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3268),
    [anon_sym_co_await] = ACTIONS(3266),
    [anon_sym_new] = ACTIONS(3266),
    [anon_sym_requires] = ACTIONS(3266),
    [sym_this] = ACTIONS(3266),
  },
  [895] = {
    [sym_identifier] = ACTIONS(3270),
    [aux_sym_preproc_include_token1] = ACTIONS(3270),
    [aux_sym_preproc_def_token1] = ACTIONS(3270),
    [aux_sym_preproc_if_token1] = ACTIONS(3270),
    [aux_sym_preproc_if_token2] = ACTIONS(3270),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3270),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3270),
    [sym_preproc_directive] = ACTIONS(3270),
    [anon_sym_LPAREN2] = ACTIONS(3272),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3270),
    [anon_sym_PLUS] = ACTIONS(3270),
    [anon_sym_STAR] = ACTIONS(3272),
    [anon_sym_AMP_AMP] = ACTIONS(3272),
    [anon_sym_AMP] = ACTIONS(3270),
    [anon_sym_SEMI] = ACTIONS(3272),
    [anon_sym___extension__] = ACTIONS(3270),
    [anon_sym_typedef] = ACTIONS(3270),
    [anon_sym_extern] = ACTIONS(3270),
    [anon_sym___attribute__] = ACTIONS(3270),
    [anon_sym_COLON_COLON] = ACTIONS(3272),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3272),
    [anon_sym___declspec] = ACTIONS(3270),
    [anon_sym___based] = ACTIONS(3270),
    [anon_sym___cdecl] = ACTIONS(3270),
    [anon_sym___clrcall] = ACTIONS(3270),
    [anon_sym___stdcall] = ACTIONS(3270),
    [anon_sym___fastcall] = ACTIONS(3270),
    [anon_sym___thiscall] = ACTIONS(3270),
    [anon_sym___vectorcall] = ACTIONS(3270),
    [anon_sym_LBRACE] = ACTIONS(3272),
    [anon_sym_signed] = ACTIONS(3270),
    [anon_sym_unsigned] = ACTIONS(3270),
    [anon_sym_long] = ACTIONS(3270),
    [anon_sym_short] = ACTIONS(3270),
    [anon_sym_LBRACK] = ACTIONS(3270),
    [anon_sym_static] = ACTIONS(3270),
    [anon_sym_register] = ACTIONS(3270),
    [anon_sym_inline] = ACTIONS(3270),
    [anon_sym___inline] = ACTIONS(3270),
    [anon_sym___inline__] = ACTIONS(3270),
    [anon_sym___forceinline] = ACTIONS(3270),
    [anon_sym_thread_local] = ACTIONS(3270),
    [anon_sym___thread] = ACTIONS(3270),
    [anon_sym_const] = ACTIONS(3270),
    [anon_sym_constexpr] = ACTIONS(3270),
    [anon_sym_volatile] = ACTIONS(3270),
    [anon_sym_restrict] = ACTIONS(3270),
    [anon_sym___restrict__] = ACTIONS(3270),
    [anon_sym__Atomic] = ACTIONS(3270),
    [anon_sym__Noreturn] = ACTIONS(3270),
    [anon_sym_noreturn] = ACTIONS(3270),
    [anon_sym_mutable] = ACTIONS(3270),
    [anon_sym_constinit] = ACTIONS(3270),
    [anon_sym_consteval] = ACTIONS(3270),
    [anon_sym_PROGMEM] = ACTIONS(3270),
    [aux_sym_primitive_type_token1] = ACTIONS(3270),
    [anon_sym_byte] = ACTIONS(3270),
    [anon_sym_word] = ACTIONS(3270),
    [anon_sym_enum] = ACTIONS(3270),
    [anon_sym_class] = ACTIONS(3270),
    [anon_sym_struct] = ACTIONS(3270),
    [anon_sym_union] = ACTIONS(3270),
    [anon_sym_if] = ACTIONS(3270),
    [anon_sym_switch] = ACTIONS(3270),
    [anon_sym_case] = ACTIONS(3270),
    [anon_sym_default] = ACTIONS(3270),
    [anon_sym_while] = ACTIONS(3270),
    [anon_sym_do] = ACTIONS(3270),
    [anon_sym_for] = ACTIONS(3270),
    [anon_sym_return] = ACTIONS(3270),
    [anon_sym_break] = ACTIONS(3270),
    [anon_sym_continue] = ACTIONS(3270),
    [anon_sym_goto] = ACTIONS(3270),
    [anon_sym___try] = ACTIONS(3270),
    [anon_sym___leave] = ACTIONS(3270),
    [anon_sym_not] = ACTIONS(3270),
    [anon_sym_compl] = ACTIONS(3270),
    [anon_sym_DASH_DASH] = ACTIONS(3272),
    [anon_sym_PLUS_PLUS] = ACTIONS(3272),
    [anon_sym_sizeof] = ACTIONS(3270),
    [anon_sym___alignof__] = ACTIONS(3270),
    [anon_sym___alignof] = ACTIONS(3270),
    [anon_sym__alignof] = ACTIONS(3270),
    [anon_sym_alignof] = ACTIONS(3270),
    [anon_sym__Alignof] = ACTIONS(3270),
    [anon_sym_offsetof] = ACTIONS(3270),
    [anon_sym__Generic] = ACTIONS(3270),
    [anon_sym_asm] = ACTIONS(3270),
    [anon_sym___asm__] = ACTIONS(3270),
    [aux_sym_number_literal_token1] = ACTIONS(3272),
    [aux_sym_number_literal_token2] = ACTIONS(3270),
    [anon_sym_L_SQUOTE] = ACTIONS(3272),
    [anon_sym_u_SQUOTE] = ACTIONS(3272),
    [anon_sym_U_SQUOTE] = ACTIONS(3272),
    [anon_sym_u8_SQUOTE] = ACTIONS(3272),
    [anon_sym_SQUOTE] = ACTIONS(3272),
    [anon_sym_L_DQUOTE] = ACTIONS(3272),
    [anon_sym_u_DQUOTE] = ACTIONS(3272),
    [anon_sym_U_DQUOTE] = ACTIONS(3272),
    [anon_sym_u8_DQUOTE] = ACTIONS(3272),
    [anon_sym_DQUOTE] = ACTIONS(3272),
    [sym_true] = ACTIONS(3270),
    [sym_false] = ACTIONS(3270),
    [anon_sym_NULL] = ACTIONS(3270),
    [anon_sym_nullptr] = ACTIONS(3270),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3270),
    [anon_sym_decltype] = ACTIONS(3270),
    [anon_sym_virtual] = ACTIONS(3270),
    [anon_sym_alignas] = ACTIONS(3270),
    [anon_sym_explicit] = ACTIONS(3270),
    [anon_sym_typename] = ACTIONS(3270),
    [anon_sym_template] = ACTIONS(3270),
    [anon_sym_operator] = ACTIONS(3270),
    [anon_sym_try] = ACTIONS(3270),
    [anon_sym_delete] = ACTIONS(3270),
    [anon_sym_throw] = ACTIONS(3270),
    [anon_sym_namespace] = ACTIONS(3270),
    [anon_sym_using] = ACTIONS(3270),
    [anon_sym_static_assert] = ACTIONS(3270),
    [anon_sym_concept] = ACTIONS(3270),
    [anon_sym_co_return] = ACTIONS(3270),
    [anon_sym_co_yield] = ACTIONS(3270),
    [anon_sym_R_DQUOTE] = ACTIONS(3272),
    [anon_sym_LR_DQUOTE] = ACTIONS(3272),
    [anon_sym_uR_DQUOTE] = ACTIONS(3272),
    [anon_sym_UR_DQUOTE] = ACTIONS(3272),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3272),
    [anon_sym_co_await] = ACTIONS(3270),
    [anon_sym_new] = ACTIONS(3270),
    [anon_sym_requires] = ACTIONS(3270),
    [sym_this] = ACTIONS(3270),
  },
  [896] = {
    [sym_identifier] = ACTIONS(3479),
    [aux_sym_preproc_include_token1] = ACTIONS(3479),
    [aux_sym_preproc_def_token1] = ACTIONS(3479),
    [aux_sym_preproc_if_token1] = ACTIONS(3479),
    [aux_sym_preproc_if_token2] = ACTIONS(3479),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3479),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3479),
    [sym_preproc_directive] = ACTIONS(3479),
    [anon_sym_LPAREN2] = ACTIONS(3481),
    [anon_sym_BANG] = ACTIONS(3481),
    [anon_sym_TILDE] = ACTIONS(3481),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_PLUS] = ACTIONS(3479),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_AMP_AMP] = ACTIONS(3481),
    [anon_sym_AMP] = ACTIONS(3479),
    [anon_sym_SEMI] = ACTIONS(3481),
    [anon_sym___extension__] = ACTIONS(3479),
    [anon_sym_typedef] = ACTIONS(3479),
    [anon_sym_extern] = ACTIONS(3479),
    [anon_sym___attribute__] = ACTIONS(3479),
    [anon_sym_COLON_COLON] = ACTIONS(3481),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3481),
    [anon_sym___declspec] = ACTIONS(3479),
    [anon_sym___based] = ACTIONS(3479),
    [anon_sym___cdecl] = ACTIONS(3479),
    [anon_sym___clrcall] = ACTIONS(3479),
    [anon_sym___stdcall] = ACTIONS(3479),
    [anon_sym___fastcall] = ACTIONS(3479),
    [anon_sym___thiscall] = ACTIONS(3479),
    [anon_sym___vectorcall] = ACTIONS(3479),
    [anon_sym_LBRACE] = ACTIONS(3481),
    [anon_sym_signed] = ACTIONS(3479),
    [anon_sym_unsigned] = ACTIONS(3479),
    [anon_sym_long] = ACTIONS(3479),
    [anon_sym_short] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(3479),
    [anon_sym_static] = ACTIONS(3479),
    [anon_sym_register] = ACTIONS(3479),
    [anon_sym_inline] = ACTIONS(3479),
    [anon_sym___inline] = ACTIONS(3479),
    [anon_sym___inline__] = ACTIONS(3479),
    [anon_sym___forceinline] = ACTIONS(3479),
    [anon_sym_thread_local] = ACTIONS(3479),
    [anon_sym___thread] = ACTIONS(3479),
    [anon_sym_const] = ACTIONS(3479),
    [anon_sym_constexpr] = ACTIONS(3479),
    [anon_sym_volatile] = ACTIONS(3479),
    [anon_sym_restrict] = ACTIONS(3479),
    [anon_sym___restrict__] = ACTIONS(3479),
    [anon_sym__Atomic] = ACTIONS(3479),
    [anon_sym__Noreturn] = ACTIONS(3479),
    [anon_sym_noreturn] = ACTIONS(3479),
    [anon_sym_mutable] = ACTIONS(3479),
    [anon_sym_constinit] = ACTIONS(3479),
    [anon_sym_consteval] = ACTIONS(3479),
    [anon_sym_PROGMEM] = ACTIONS(3479),
    [aux_sym_primitive_type_token1] = ACTIONS(3479),
    [anon_sym_byte] = ACTIONS(3479),
    [anon_sym_word] = ACTIONS(3479),
    [anon_sym_enum] = ACTIONS(3479),
    [anon_sym_class] = ACTIONS(3479),
    [anon_sym_struct] = ACTIONS(3479),
    [anon_sym_union] = ACTIONS(3479),
    [anon_sym_if] = ACTIONS(3479),
    [anon_sym_switch] = ACTIONS(3479),
    [anon_sym_case] = ACTIONS(3479),
    [anon_sym_default] = ACTIONS(3479),
    [anon_sym_while] = ACTIONS(3479),
    [anon_sym_do] = ACTIONS(3479),
    [anon_sym_for] = ACTIONS(3479),
    [anon_sym_return] = ACTIONS(3479),
    [anon_sym_break] = ACTIONS(3479),
    [anon_sym_continue] = ACTIONS(3479),
    [anon_sym_goto] = ACTIONS(3479),
    [anon_sym___try] = ACTIONS(3479),
    [anon_sym___leave] = ACTIONS(3479),
    [anon_sym_not] = ACTIONS(3479),
    [anon_sym_compl] = ACTIONS(3479),
    [anon_sym_DASH_DASH] = ACTIONS(3481),
    [anon_sym_PLUS_PLUS] = ACTIONS(3481),
    [anon_sym_sizeof] = ACTIONS(3479),
    [anon_sym___alignof__] = ACTIONS(3479),
    [anon_sym___alignof] = ACTIONS(3479),
    [anon_sym__alignof] = ACTIONS(3479),
    [anon_sym_alignof] = ACTIONS(3479),
    [anon_sym__Alignof] = ACTIONS(3479),
    [anon_sym_offsetof] = ACTIONS(3479),
    [anon_sym__Generic] = ACTIONS(3479),
    [anon_sym_asm] = ACTIONS(3479),
    [anon_sym___asm__] = ACTIONS(3479),
    [aux_sym_number_literal_token1] = ACTIONS(3481),
    [aux_sym_number_literal_token2] = ACTIONS(3479),
    [anon_sym_L_SQUOTE] = ACTIONS(3481),
    [anon_sym_u_SQUOTE] = ACTIONS(3481),
    [anon_sym_U_SQUOTE] = ACTIONS(3481),
    [anon_sym_u8_SQUOTE] = ACTIONS(3481),
    [anon_sym_SQUOTE] = ACTIONS(3481),
    [anon_sym_L_DQUOTE] = ACTIONS(3481),
    [anon_sym_u_DQUOTE] = ACTIONS(3481),
    [anon_sym_U_DQUOTE] = ACTIONS(3481),
    [anon_sym_u8_DQUOTE] = ACTIONS(3481),
    [anon_sym_DQUOTE] = ACTIONS(3481),
    [sym_true] = ACTIONS(3479),
    [sym_false] = ACTIONS(3479),
    [anon_sym_NULL] = ACTIONS(3479),
    [anon_sym_nullptr] = ACTIONS(3479),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3479),
    [anon_sym_decltype] = ACTIONS(3479),
    [anon_sym_virtual] = ACTIONS(3479),
    [anon_sym_alignas] = ACTIONS(3479),
    [anon_sym_explicit] = ACTIONS(3479),
    [anon_sym_typename] = ACTIONS(3479),
    [anon_sym_template] = ACTIONS(3479),
    [anon_sym_operator] = ACTIONS(3479),
    [anon_sym_try] = ACTIONS(3479),
    [anon_sym_delete] = ACTIONS(3479),
    [anon_sym_throw] = ACTIONS(3479),
    [anon_sym_namespace] = ACTIONS(3479),
    [anon_sym_using] = ACTIONS(3479),
    [anon_sym_static_assert] = ACTIONS(3479),
    [anon_sym_concept] = ACTIONS(3479),
    [anon_sym_co_return] = ACTIONS(3479),
    [anon_sym_co_yield] = ACTIONS(3479),
    [anon_sym_R_DQUOTE] = ACTIONS(3481),
    [anon_sym_LR_DQUOTE] = ACTIONS(3481),
    [anon_sym_uR_DQUOTE] = ACTIONS(3481),
    [anon_sym_UR_DQUOTE] = ACTIONS(3481),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3481),
    [anon_sym_co_await] = ACTIONS(3479),
    [anon_sym_new] = ACTIONS(3479),
    [anon_sym_requires] = ACTIONS(3479),
    [sym_this] = ACTIONS(3479),
  },
  [897] = {
    [sym_identifier] = ACTIONS(3435),
    [aux_sym_preproc_include_token1] = ACTIONS(3435),
    [aux_sym_preproc_def_token1] = ACTIONS(3435),
    [aux_sym_preproc_if_token1] = ACTIONS(3435),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3435),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3435),
    [sym_preproc_directive] = ACTIONS(3435),
    [anon_sym_LPAREN2] = ACTIONS(3437),
    [anon_sym_BANG] = ACTIONS(3437),
    [anon_sym_TILDE] = ACTIONS(3437),
    [anon_sym_DASH] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3435),
    [anon_sym_STAR] = ACTIONS(3437),
    [anon_sym_AMP_AMP] = ACTIONS(3437),
    [anon_sym_AMP] = ACTIONS(3435),
    [anon_sym_SEMI] = ACTIONS(3437),
    [anon_sym___extension__] = ACTIONS(3435),
    [anon_sym_typedef] = ACTIONS(3435),
    [anon_sym_extern] = ACTIONS(3435),
    [anon_sym___attribute__] = ACTIONS(3435),
    [anon_sym_COLON_COLON] = ACTIONS(3437),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3437),
    [anon_sym___declspec] = ACTIONS(3435),
    [anon_sym___based] = ACTIONS(3435),
    [anon_sym___cdecl] = ACTIONS(3435),
    [anon_sym___clrcall] = ACTIONS(3435),
    [anon_sym___stdcall] = ACTIONS(3435),
    [anon_sym___fastcall] = ACTIONS(3435),
    [anon_sym___thiscall] = ACTIONS(3435),
    [anon_sym___vectorcall] = ACTIONS(3435),
    [anon_sym_LBRACE] = ACTIONS(3437),
    [anon_sym_RBRACE] = ACTIONS(3437),
    [anon_sym_signed] = ACTIONS(3435),
    [anon_sym_unsigned] = ACTIONS(3435),
    [anon_sym_long] = ACTIONS(3435),
    [anon_sym_short] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3435),
    [anon_sym_static] = ACTIONS(3435),
    [anon_sym_register] = ACTIONS(3435),
    [anon_sym_inline] = ACTIONS(3435),
    [anon_sym___inline] = ACTIONS(3435),
    [anon_sym___inline__] = ACTIONS(3435),
    [anon_sym___forceinline] = ACTIONS(3435),
    [anon_sym_thread_local] = ACTIONS(3435),
    [anon_sym___thread] = ACTIONS(3435),
    [anon_sym_const] = ACTIONS(3435),
    [anon_sym_constexpr] = ACTIONS(3435),
    [anon_sym_volatile] = ACTIONS(3435),
    [anon_sym_restrict] = ACTIONS(3435),
    [anon_sym___restrict__] = ACTIONS(3435),
    [anon_sym__Atomic] = ACTIONS(3435),
    [anon_sym__Noreturn] = ACTIONS(3435),
    [anon_sym_noreturn] = ACTIONS(3435),
    [anon_sym_mutable] = ACTIONS(3435),
    [anon_sym_constinit] = ACTIONS(3435),
    [anon_sym_consteval] = ACTIONS(3435),
    [anon_sym_PROGMEM] = ACTIONS(3435),
    [aux_sym_primitive_type_token1] = ACTIONS(3435),
    [anon_sym_byte] = ACTIONS(3435),
    [anon_sym_word] = ACTIONS(3435),
    [anon_sym_enum] = ACTIONS(3435),
    [anon_sym_class] = ACTIONS(3435),
    [anon_sym_struct] = ACTIONS(3435),
    [anon_sym_union] = ACTIONS(3435),
    [anon_sym_if] = ACTIONS(3435),
    [anon_sym_switch] = ACTIONS(3435),
    [anon_sym_case] = ACTIONS(3435),
    [anon_sym_default] = ACTIONS(3435),
    [anon_sym_while] = ACTIONS(3435),
    [anon_sym_do] = ACTIONS(3435),
    [anon_sym_for] = ACTIONS(3435),
    [anon_sym_return] = ACTIONS(3435),
    [anon_sym_break] = ACTIONS(3435),
    [anon_sym_continue] = ACTIONS(3435),
    [anon_sym_goto] = ACTIONS(3435),
    [anon_sym___try] = ACTIONS(3435),
    [anon_sym___leave] = ACTIONS(3435),
    [anon_sym_not] = ACTIONS(3435),
    [anon_sym_compl] = ACTIONS(3435),
    [anon_sym_DASH_DASH] = ACTIONS(3437),
    [anon_sym_PLUS_PLUS] = ACTIONS(3437),
    [anon_sym_sizeof] = ACTIONS(3435),
    [anon_sym___alignof__] = ACTIONS(3435),
    [anon_sym___alignof] = ACTIONS(3435),
    [anon_sym__alignof] = ACTIONS(3435),
    [anon_sym_alignof] = ACTIONS(3435),
    [anon_sym__Alignof] = ACTIONS(3435),
    [anon_sym_offsetof] = ACTIONS(3435),
    [anon_sym__Generic] = ACTIONS(3435),
    [anon_sym_asm] = ACTIONS(3435),
    [anon_sym___asm__] = ACTIONS(3435),
    [aux_sym_number_literal_token1] = ACTIONS(3437),
    [aux_sym_number_literal_token2] = ACTIONS(3435),
    [anon_sym_L_SQUOTE] = ACTIONS(3437),
    [anon_sym_u_SQUOTE] = ACTIONS(3437),
    [anon_sym_U_SQUOTE] = ACTIONS(3437),
    [anon_sym_u8_SQUOTE] = ACTIONS(3437),
    [anon_sym_SQUOTE] = ACTIONS(3437),
    [anon_sym_L_DQUOTE] = ACTIONS(3437),
    [anon_sym_u_DQUOTE] = ACTIONS(3437),
    [anon_sym_U_DQUOTE] = ACTIONS(3437),
    [anon_sym_u8_DQUOTE] = ACTIONS(3437),
    [anon_sym_DQUOTE] = ACTIONS(3437),
    [sym_true] = ACTIONS(3435),
    [sym_false] = ACTIONS(3435),
    [anon_sym_NULL] = ACTIONS(3435),
    [anon_sym_nullptr] = ACTIONS(3435),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3435),
    [anon_sym_decltype] = ACTIONS(3435),
    [anon_sym_virtual] = ACTIONS(3435),
    [anon_sym_alignas] = ACTIONS(3435),
    [anon_sym_explicit] = ACTIONS(3435),
    [anon_sym_typename] = ACTIONS(3435),
    [anon_sym_template] = ACTIONS(3435),
    [anon_sym_operator] = ACTIONS(3435),
    [anon_sym_try] = ACTIONS(3435),
    [anon_sym_delete] = ACTIONS(3435),
    [anon_sym_throw] = ACTIONS(3435),
    [anon_sym_namespace] = ACTIONS(3435),
    [anon_sym_using] = ACTIONS(3435),
    [anon_sym_static_assert] = ACTIONS(3435),
    [anon_sym_concept] = ACTIONS(3435),
    [anon_sym_co_return] = ACTIONS(3435),
    [anon_sym_co_yield] = ACTIONS(3435),
    [anon_sym_R_DQUOTE] = ACTIONS(3437),
    [anon_sym_LR_DQUOTE] = ACTIONS(3437),
    [anon_sym_uR_DQUOTE] = ACTIONS(3437),
    [anon_sym_UR_DQUOTE] = ACTIONS(3437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3437),
    [anon_sym_co_await] = ACTIONS(3435),
    [anon_sym_new] = ACTIONS(3435),
    [anon_sym_requires] = ACTIONS(3435),
    [sym_this] = ACTIONS(3435),
  },
  [898] = {
    [sym_identifier] = ACTIONS(3439),
    [aux_sym_preproc_include_token1] = ACTIONS(3439),
    [aux_sym_preproc_def_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3439),
    [sym_preproc_directive] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3441),
    [anon_sym_BANG] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_DASH] = ACTIONS(3439),
    [anon_sym_PLUS] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3439),
    [anon_sym_SEMI] = ACTIONS(3441),
    [anon_sym___extension__] = ACTIONS(3439),
    [anon_sym_typedef] = ACTIONS(3439),
    [anon_sym_extern] = ACTIONS(3439),
    [anon_sym___attribute__] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3441),
    [anon_sym___declspec] = ACTIONS(3439),
    [anon_sym___based] = ACTIONS(3439),
    [anon_sym___cdecl] = ACTIONS(3439),
    [anon_sym___clrcall] = ACTIONS(3439),
    [anon_sym___stdcall] = ACTIONS(3439),
    [anon_sym___fastcall] = ACTIONS(3439),
    [anon_sym___thiscall] = ACTIONS(3439),
    [anon_sym___vectorcall] = ACTIONS(3439),
    [anon_sym_LBRACE] = ACTIONS(3441),
    [anon_sym_RBRACE] = ACTIONS(3441),
    [anon_sym_signed] = ACTIONS(3439),
    [anon_sym_unsigned] = ACTIONS(3439),
    [anon_sym_long] = ACTIONS(3439),
    [anon_sym_short] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_register] = ACTIONS(3439),
    [anon_sym_inline] = ACTIONS(3439),
    [anon_sym___inline] = ACTIONS(3439),
    [anon_sym___inline__] = ACTIONS(3439),
    [anon_sym___forceinline] = ACTIONS(3439),
    [anon_sym_thread_local] = ACTIONS(3439),
    [anon_sym___thread] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_constexpr] = ACTIONS(3439),
    [anon_sym_volatile] = ACTIONS(3439),
    [anon_sym_restrict] = ACTIONS(3439),
    [anon_sym___restrict__] = ACTIONS(3439),
    [anon_sym__Atomic] = ACTIONS(3439),
    [anon_sym__Noreturn] = ACTIONS(3439),
    [anon_sym_noreturn] = ACTIONS(3439),
    [anon_sym_mutable] = ACTIONS(3439),
    [anon_sym_constinit] = ACTIONS(3439),
    [anon_sym_consteval] = ACTIONS(3439),
    [anon_sym_PROGMEM] = ACTIONS(3439),
    [aux_sym_primitive_type_token1] = ACTIONS(3439),
    [anon_sym_byte] = ACTIONS(3439),
    [anon_sym_word] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_struct] = ACTIONS(3439),
    [anon_sym_union] = ACTIONS(3439),
    [anon_sym_if] = ACTIONS(3439),
    [anon_sym_switch] = ACTIONS(3439),
    [anon_sym_case] = ACTIONS(3439),
    [anon_sym_default] = ACTIONS(3439),
    [anon_sym_while] = ACTIONS(3439),
    [anon_sym_do] = ACTIONS(3439),
    [anon_sym_for] = ACTIONS(3439),
    [anon_sym_return] = ACTIONS(3439),
    [anon_sym_break] = ACTIONS(3439),
    [anon_sym_continue] = ACTIONS(3439),
    [anon_sym_goto] = ACTIONS(3439),
    [anon_sym___try] = ACTIONS(3439),
    [anon_sym___leave] = ACTIONS(3439),
    [anon_sym_not] = ACTIONS(3439),
    [anon_sym_compl] = ACTIONS(3439),
    [anon_sym_DASH_DASH] = ACTIONS(3441),
    [anon_sym_PLUS_PLUS] = ACTIONS(3441),
    [anon_sym_sizeof] = ACTIONS(3439),
    [anon_sym___alignof__] = ACTIONS(3439),
    [anon_sym___alignof] = ACTIONS(3439),
    [anon_sym__alignof] = ACTIONS(3439),
    [anon_sym_alignof] = ACTIONS(3439),
    [anon_sym__Alignof] = ACTIONS(3439),
    [anon_sym_offsetof] = ACTIONS(3439),
    [anon_sym__Generic] = ACTIONS(3439),
    [anon_sym_asm] = ACTIONS(3439),
    [anon_sym___asm__] = ACTIONS(3439),
    [aux_sym_number_literal_token1] = ACTIONS(3441),
    [aux_sym_number_literal_token2] = ACTIONS(3439),
    [anon_sym_L_SQUOTE] = ACTIONS(3441),
    [anon_sym_u_SQUOTE] = ACTIONS(3441),
    [anon_sym_U_SQUOTE] = ACTIONS(3441),
    [anon_sym_u8_SQUOTE] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [anon_sym_L_DQUOTE] = ACTIONS(3441),
    [anon_sym_u_DQUOTE] = ACTIONS(3441),
    [anon_sym_U_DQUOTE] = ACTIONS(3441),
    [anon_sym_u8_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE] = ACTIONS(3441),
    [sym_true] = ACTIONS(3439),
    [sym_false] = ACTIONS(3439),
    [anon_sym_NULL] = ACTIONS(3439),
    [anon_sym_nullptr] = ACTIONS(3439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3439),
    [anon_sym_decltype] = ACTIONS(3439),
    [anon_sym_virtual] = ACTIONS(3439),
    [anon_sym_alignas] = ACTIONS(3439),
    [anon_sym_explicit] = ACTIONS(3439),
    [anon_sym_typename] = ACTIONS(3439),
    [anon_sym_template] = ACTIONS(3439),
    [anon_sym_operator] = ACTIONS(3439),
    [anon_sym_try] = ACTIONS(3439),
    [anon_sym_delete] = ACTIONS(3439),
    [anon_sym_throw] = ACTIONS(3439),
    [anon_sym_namespace] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_static_assert] = ACTIONS(3439),
    [anon_sym_concept] = ACTIONS(3439),
    [anon_sym_co_return] = ACTIONS(3439),
    [anon_sym_co_yield] = ACTIONS(3439),
    [anon_sym_R_DQUOTE] = ACTIONS(3441),
    [anon_sym_LR_DQUOTE] = ACTIONS(3441),
    [anon_sym_uR_DQUOTE] = ACTIONS(3441),
    [anon_sym_UR_DQUOTE] = ACTIONS(3441),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3441),
    [anon_sym_co_await] = ACTIONS(3439),
    [anon_sym_new] = ACTIONS(3439),
    [anon_sym_requires] = ACTIONS(3439),
    [sym_this] = ACTIONS(3439),
  },
  [899] = {
    [sym_identifier] = ACTIONS(3439),
    [aux_sym_preproc_include_token1] = ACTIONS(3439),
    [aux_sym_preproc_def_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3439),
    [sym_preproc_directive] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3441),
    [anon_sym_BANG] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_DASH] = ACTIONS(3439),
    [anon_sym_PLUS] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3439),
    [anon_sym_SEMI] = ACTIONS(3441),
    [anon_sym___extension__] = ACTIONS(3439),
    [anon_sym_typedef] = ACTIONS(3439),
    [anon_sym_extern] = ACTIONS(3439),
    [anon_sym___attribute__] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3441),
    [anon_sym___declspec] = ACTIONS(3439),
    [anon_sym___based] = ACTIONS(3439),
    [anon_sym___cdecl] = ACTIONS(3439),
    [anon_sym___clrcall] = ACTIONS(3439),
    [anon_sym___stdcall] = ACTIONS(3439),
    [anon_sym___fastcall] = ACTIONS(3439),
    [anon_sym___thiscall] = ACTIONS(3439),
    [anon_sym___vectorcall] = ACTIONS(3439),
    [anon_sym_LBRACE] = ACTIONS(3441),
    [anon_sym_RBRACE] = ACTIONS(3441),
    [anon_sym_signed] = ACTIONS(3439),
    [anon_sym_unsigned] = ACTIONS(3439),
    [anon_sym_long] = ACTIONS(3439),
    [anon_sym_short] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_register] = ACTIONS(3439),
    [anon_sym_inline] = ACTIONS(3439),
    [anon_sym___inline] = ACTIONS(3439),
    [anon_sym___inline__] = ACTIONS(3439),
    [anon_sym___forceinline] = ACTIONS(3439),
    [anon_sym_thread_local] = ACTIONS(3439),
    [anon_sym___thread] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_constexpr] = ACTIONS(3439),
    [anon_sym_volatile] = ACTIONS(3439),
    [anon_sym_restrict] = ACTIONS(3439),
    [anon_sym___restrict__] = ACTIONS(3439),
    [anon_sym__Atomic] = ACTIONS(3439),
    [anon_sym__Noreturn] = ACTIONS(3439),
    [anon_sym_noreturn] = ACTIONS(3439),
    [anon_sym_mutable] = ACTIONS(3439),
    [anon_sym_constinit] = ACTIONS(3439),
    [anon_sym_consteval] = ACTIONS(3439),
    [anon_sym_PROGMEM] = ACTIONS(3439),
    [aux_sym_primitive_type_token1] = ACTIONS(3439),
    [anon_sym_byte] = ACTIONS(3439),
    [anon_sym_word] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_struct] = ACTIONS(3439),
    [anon_sym_union] = ACTIONS(3439),
    [anon_sym_if] = ACTIONS(3439),
    [anon_sym_switch] = ACTIONS(3439),
    [anon_sym_case] = ACTIONS(3439),
    [anon_sym_default] = ACTIONS(3439),
    [anon_sym_while] = ACTIONS(3439),
    [anon_sym_do] = ACTIONS(3439),
    [anon_sym_for] = ACTIONS(3439),
    [anon_sym_return] = ACTIONS(3439),
    [anon_sym_break] = ACTIONS(3439),
    [anon_sym_continue] = ACTIONS(3439),
    [anon_sym_goto] = ACTIONS(3439),
    [anon_sym___try] = ACTIONS(3439),
    [anon_sym___leave] = ACTIONS(3439),
    [anon_sym_not] = ACTIONS(3439),
    [anon_sym_compl] = ACTIONS(3439),
    [anon_sym_DASH_DASH] = ACTIONS(3441),
    [anon_sym_PLUS_PLUS] = ACTIONS(3441),
    [anon_sym_sizeof] = ACTIONS(3439),
    [anon_sym___alignof__] = ACTIONS(3439),
    [anon_sym___alignof] = ACTIONS(3439),
    [anon_sym__alignof] = ACTIONS(3439),
    [anon_sym_alignof] = ACTIONS(3439),
    [anon_sym__Alignof] = ACTIONS(3439),
    [anon_sym_offsetof] = ACTIONS(3439),
    [anon_sym__Generic] = ACTIONS(3439),
    [anon_sym_asm] = ACTIONS(3439),
    [anon_sym___asm__] = ACTIONS(3439),
    [aux_sym_number_literal_token1] = ACTIONS(3441),
    [aux_sym_number_literal_token2] = ACTIONS(3439),
    [anon_sym_L_SQUOTE] = ACTIONS(3441),
    [anon_sym_u_SQUOTE] = ACTIONS(3441),
    [anon_sym_U_SQUOTE] = ACTIONS(3441),
    [anon_sym_u8_SQUOTE] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [anon_sym_L_DQUOTE] = ACTIONS(3441),
    [anon_sym_u_DQUOTE] = ACTIONS(3441),
    [anon_sym_U_DQUOTE] = ACTIONS(3441),
    [anon_sym_u8_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE] = ACTIONS(3441),
    [sym_true] = ACTIONS(3439),
    [sym_false] = ACTIONS(3439),
    [anon_sym_NULL] = ACTIONS(3439),
    [anon_sym_nullptr] = ACTIONS(3439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3439),
    [anon_sym_decltype] = ACTIONS(3439),
    [anon_sym_virtual] = ACTIONS(3439),
    [anon_sym_alignas] = ACTIONS(3439),
    [anon_sym_explicit] = ACTIONS(3439),
    [anon_sym_typename] = ACTIONS(3439),
    [anon_sym_template] = ACTIONS(3439),
    [anon_sym_operator] = ACTIONS(3439),
    [anon_sym_try] = ACTIONS(3439),
    [anon_sym_delete] = ACTIONS(3439),
    [anon_sym_throw] = ACTIONS(3439),
    [anon_sym_namespace] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_static_assert] = ACTIONS(3439),
    [anon_sym_concept] = ACTIONS(3439),
    [anon_sym_co_return] = ACTIONS(3439),
    [anon_sym_co_yield] = ACTIONS(3439),
    [anon_sym_R_DQUOTE] = ACTIONS(3441),
    [anon_sym_LR_DQUOTE] = ACTIONS(3441),
    [anon_sym_uR_DQUOTE] = ACTIONS(3441),
    [anon_sym_UR_DQUOTE] = ACTIONS(3441),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3441),
    [anon_sym_co_await] = ACTIONS(3439),
    [anon_sym_new] = ACTIONS(3439),
    [anon_sym_requires] = ACTIONS(3439),
    [sym_this] = ACTIONS(3439),
  },
  [900] = {
    [sym_identifier] = ACTIONS(3443),
    [aux_sym_preproc_include_token1] = ACTIONS(3443),
    [aux_sym_preproc_def_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3443),
    [sym_preproc_directive] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3445),
    [anon_sym_BANG] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_AMP_AMP] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_SEMI] = ACTIONS(3445),
    [anon_sym___extension__] = ACTIONS(3443),
    [anon_sym_typedef] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym___attribute__] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3445),
    [anon_sym___declspec] = ACTIONS(3443),
    [anon_sym___based] = ACTIONS(3443),
    [anon_sym___cdecl] = ACTIONS(3443),
    [anon_sym___clrcall] = ACTIONS(3443),
    [anon_sym___stdcall] = ACTIONS(3443),
    [anon_sym___fastcall] = ACTIONS(3443),
    [anon_sym___thiscall] = ACTIONS(3443),
    [anon_sym___vectorcall] = ACTIONS(3443),
    [anon_sym_LBRACE] = ACTIONS(3445),
    [anon_sym_RBRACE] = ACTIONS(3445),
    [anon_sym_signed] = ACTIONS(3443),
    [anon_sym_unsigned] = ACTIONS(3443),
    [anon_sym_long] = ACTIONS(3443),
    [anon_sym_short] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_register] = ACTIONS(3443),
    [anon_sym_inline] = ACTIONS(3443),
    [anon_sym___inline] = ACTIONS(3443),
    [anon_sym___inline__] = ACTIONS(3443),
    [anon_sym___forceinline] = ACTIONS(3443),
    [anon_sym_thread_local] = ACTIONS(3443),
    [anon_sym___thread] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_constexpr] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_restrict] = ACTIONS(3443),
    [anon_sym___restrict__] = ACTIONS(3443),
    [anon_sym__Atomic] = ACTIONS(3443),
    [anon_sym__Noreturn] = ACTIONS(3443),
    [anon_sym_noreturn] = ACTIONS(3443),
    [anon_sym_mutable] = ACTIONS(3443),
    [anon_sym_constinit] = ACTIONS(3443),
    [anon_sym_consteval] = ACTIONS(3443),
    [anon_sym_PROGMEM] = ACTIONS(3443),
    [aux_sym_primitive_type_token1] = ACTIONS(3443),
    [anon_sym_byte] = ACTIONS(3443),
    [anon_sym_word] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_union] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_switch] = ACTIONS(3443),
    [anon_sym_case] = ACTIONS(3443),
    [anon_sym_default] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_break] = ACTIONS(3443),
    [anon_sym_continue] = ACTIONS(3443),
    [anon_sym_goto] = ACTIONS(3443),
    [anon_sym___try] = ACTIONS(3443),
    [anon_sym___leave] = ACTIONS(3443),
    [anon_sym_not] = ACTIONS(3443),
    [anon_sym_compl] = ACTIONS(3443),
    [anon_sym_DASH_DASH] = ACTIONS(3445),
    [anon_sym_PLUS_PLUS] = ACTIONS(3445),
    [anon_sym_sizeof] = ACTIONS(3443),
    [anon_sym___alignof__] = ACTIONS(3443),
    [anon_sym___alignof] = ACTIONS(3443),
    [anon_sym__alignof] = ACTIONS(3443),
    [anon_sym_alignof] = ACTIONS(3443),
    [anon_sym__Alignof] = ACTIONS(3443),
    [anon_sym_offsetof] = ACTIONS(3443),
    [anon_sym__Generic] = ACTIONS(3443),
    [anon_sym_asm] = ACTIONS(3443),
    [anon_sym___asm__] = ACTIONS(3443),
    [aux_sym_number_literal_token1] = ACTIONS(3445),
    [aux_sym_number_literal_token2] = ACTIONS(3443),
    [anon_sym_L_SQUOTE] = ACTIONS(3445),
    [anon_sym_u_SQUOTE] = ACTIONS(3445),
    [anon_sym_U_SQUOTE] = ACTIONS(3445),
    [anon_sym_u8_SQUOTE] = ACTIONS(3445),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_L_DQUOTE] = ACTIONS(3445),
    [anon_sym_u_DQUOTE] = ACTIONS(3445),
    [anon_sym_U_DQUOTE] = ACTIONS(3445),
    [anon_sym_u8_DQUOTE] = ACTIONS(3445),
    [anon_sym_DQUOTE] = ACTIONS(3445),
    [sym_true] = ACTIONS(3443),
    [sym_false] = ACTIONS(3443),
    [anon_sym_NULL] = ACTIONS(3443),
    [anon_sym_nullptr] = ACTIONS(3443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3443),
    [anon_sym_decltype] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_alignas] = ACTIONS(3443),
    [anon_sym_explicit] = ACTIONS(3443),
    [anon_sym_typename] = ACTIONS(3443),
    [anon_sym_template] = ACTIONS(3443),
    [anon_sym_operator] = ACTIONS(3443),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_delete] = ACTIONS(3443),
    [anon_sym_throw] = ACTIONS(3443),
    [anon_sym_namespace] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_static_assert] = ACTIONS(3443),
    [anon_sym_concept] = ACTIONS(3443),
    [anon_sym_co_return] = ACTIONS(3443),
    [anon_sym_co_yield] = ACTIONS(3443),
    [anon_sym_R_DQUOTE] = ACTIONS(3445),
    [anon_sym_LR_DQUOTE] = ACTIONS(3445),
    [anon_sym_uR_DQUOTE] = ACTIONS(3445),
    [anon_sym_UR_DQUOTE] = ACTIONS(3445),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3445),
    [anon_sym_co_await] = ACTIONS(3443),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_requires] = ACTIONS(3443),
    [sym_this] = ACTIONS(3443),
  },
  [901] = {
    [sym_identifier] = ACTIONS(3443),
    [aux_sym_preproc_include_token1] = ACTIONS(3443),
    [aux_sym_preproc_def_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3443),
    [sym_preproc_directive] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3445),
    [anon_sym_BANG] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_AMP_AMP] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_SEMI] = ACTIONS(3445),
    [anon_sym___extension__] = ACTIONS(3443),
    [anon_sym_typedef] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym___attribute__] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3445),
    [anon_sym___declspec] = ACTIONS(3443),
    [anon_sym___based] = ACTIONS(3443),
    [anon_sym___cdecl] = ACTIONS(3443),
    [anon_sym___clrcall] = ACTIONS(3443),
    [anon_sym___stdcall] = ACTIONS(3443),
    [anon_sym___fastcall] = ACTIONS(3443),
    [anon_sym___thiscall] = ACTIONS(3443),
    [anon_sym___vectorcall] = ACTIONS(3443),
    [anon_sym_LBRACE] = ACTIONS(3445),
    [anon_sym_RBRACE] = ACTIONS(3445),
    [anon_sym_signed] = ACTIONS(3443),
    [anon_sym_unsigned] = ACTIONS(3443),
    [anon_sym_long] = ACTIONS(3443),
    [anon_sym_short] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_register] = ACTIONS(3443),
    [anon_sym_inline] = ACTIONS(3443),
    [anon_sym___inline] = ACTIONS(3443),
    [anon_sym___inline__] = ACTIONS(3443),
    [anon_sym___forceinline] = ACTIONS(3443),
    [anon_sym_thread_local] = ACTIONS(3443),
    [anon_sym___thread] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_constexpr] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_restrict] = ACTIONS(3443),
    [anon_sym___restrict__] = ACTIONS(3443),
    [anon_sym__Atomic] = ACTIONS(3443),
    [anon_sym__Noreturn] = ACTIONS(3443),
    [anon_sym_noreturn] = ACTIONS(3443),
    [anon_sym_mutable] = ACTIONS(3443),
    [anon_sym_constinit] = ACTIONS(3443),
    [anon_sym_consteval] = ACTIONS(3443),
    [anon_sym_PROGMEM] = ACTIONS(3443),
    [aux_sym_primitive_type_token1] = ACTIONS(3443),
    [anon_sym_byte] = ACTIONS(3443),
    [anon_sym_word] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_union] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_switch] = ACTIONS(3443),
    [anon_sym_case] = ACTIONS(3443),
    [anon_sym_default] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_break] = ACTIONS(3443),
    [anon_sym_continue] = ACTIONS(3443),
    [anon_sym_goto] = ACTIONS(3443),
    [anon_sym___try] = ACTIONS(3443),
    [anon_sym___leave] = ACTIONS(3443),
    [anon_sym_not] = ACTIONS(3443),
    [anon_sym_compl] = ACTIONS(3443),
    [anon_sym_DASH_DASH] = ACTIONS(3445),
    [anon_sym_PLUS_PLUS] = ACTIONS(3445),
    [anon_sym_sizeof] = ACTIONS(3443),
    [anon_sym___alignof__] = ACTIONS(3443),
    [anon_sym___alignof] = ACTIONS(3443),
    [anon_sym__alignof] = ACTIONS(3443),
    [anon_sym_alignof] = ACTIONS(3443),
    [anon_sym__Alignof] = ACTIONS(3443),
    [anon_sym_offsetof] = ACTIONS(3443),
    [anon_sym__Generic] = ACTIONS(3443),
    [anon_sym_asm] = ACTIONS(3443),
    [anon_sym___asm__] = ACTIONS(3443),
    [aux_sym_number_literal_token1] = ACTIONS(3445),
    [aux_sym_number_literal_token2] = ACTIONS(3443),
    [anon_sym_L_SQUOTE] = ACTIONS(3445),
    [anon_sym_u_SQUOTE] = ACTIONS(3445),
    [anon_sym_U_SQUOTE] = ACTIONS(3445),
    [anon_sym_u8_SQUOTE] = ACTIONS(3445),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_L_DQUOTE] = ACTIONS(3445),
    [anon_sym_u_DQUOTE] = ACTIONS(3445),
    [anon_sym_U_DQUOTE] = ACTIONS(3445),
    [anon_sym_u8_DQUOTE] = ACTIONS(3445),
    [anon_sym_DQUOTE] = ACTIONS(3445),
    [sym_true] = ACTIONS(3443),
    [sym_false] = ACTIONS(3443),
    [anon_sym_NULL] = ACTIONS(3443),
    [anon_sym_nullptr] = ACTIONS(3443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3443),
    [anon_sym_decltype] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_alignas] = ACTIONS(3443),
    [anon_sym_explicit] = ACTIONS(3443),
    [anon_sym_typename] = ACTIONS(3443),
    [anon_sym_template] = ACTIONS(3443),
    [anon_sym_operator] = ACTIONS(3443),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_delete] = ACTIONS(3443),
    [anon_sym_throw] = ACTIONS(3443),
    [anon_sym_namespace] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_static_assert] = ACTIONS(3443),
    [anon_sym_concept] = ACTIONS(3443),
    [anon_sym_co_return] = ACTIONS(3443),
    [anon_sym_co_yield] = ACTIONS(3443),
    [anon_sym_R_DQUOTE] = ACTIONS(3445),
    [anon_sym_LR_DQUOTE] = ACTIONS(3445),
    [anon_sym_uR_DQUOTE] = ACTIONS(3445),
    [anon_sym_UR_DQUOTE] = ACTIONS(3445),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3445),
    [anon_sym_co_await] = ACTIONS(3443),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_requires] = ACTIONS(3443),
    [sym_this] = ACTIONS(3443),
  },
  [902] = {
    [sym_identifier] = ACTIONS(3483),
    [aux_sym_preproc_include_token1] = ACTIONS(3483),
    [aux_sym_preproc_def_token1] = ACTIONS(3483),
    [aux_sym_preproc_if_token1] = ACTIONS(3483),
    [aux_sym_preproc_if_token2] = ACTIONS(3483),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3483),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3483),
    [sym_preproc_directive] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_BANG] = ACTIONS(3485),
    [anon_sym_TILDE] = ACTIONS(3485),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_STAR] = ACTIONS(3485),
    [anon_sym_AMP_AMP] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_SEMI] = ACTIONS(3485),
    [anon_sym___extension__] = ACTIONS(3483),
    [anon_sym_typedef] = ACTIONS(3483),
    [anon_sym_extern] = ACTIONS(3483),
    [anon_sym___attribute__] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3485),
    [anon_sym___declspec] = ACTIONS(3483),
    [anon_sym___based] = ACTIONS(3483),
    [anon_sym___cdecl] = ACTIONS(3483),
    [anon_sym___clrcall] = ACTIONS(3483),
    [anon_sym___stdcall] = ACTIONS(3483),
    [anon_sym___fastcall] = ACTIONS(3483),
    [anon_sym___thiscall] = ACTIONS(3483),
    [anon_sym___vectorcall] = ACTIONS(3483),
    [anon_sym_LBRACE] = ACTIONS(3485),
    [anon_sym_signed] = ACTIONS(3483),
    [anon_sym_unsigned] = ACTIONS(3483),
    [anon_sym_long] = ACTIONS(3483),
    [anon_sym_short] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_static] = ACTIONS(3483),
    [anon_sym_register] = ACTIONS(3483),
    [anon_sym_inline] = ACTIONS(3483),
    [anon_sym___inline] = ACTIONS(3483),
    [anon_sym___inline__] = ACTIONS(3483),
    [anon_sym___forceinline] = ACTIONS(3483),
    [anon_sym_thread_local] = ACTIONS(3483),
    [anon_sym___thread] = ACTIONS(3483),
    [anon_sym_const] = ACTIONS(3483),
    [anon_sym_constexpr] = ACTIONS(3483),
    [anon_sym_volatile] = ACTIONS(3483),
    [anon_sym_restrict] = ACTIONS(3483),
    [anon_sym___restrict__] = ACTIONS(3483),
    [anon_sym__Atomic] = ACTIONS(3483),
    [anon_sym__Noreturn] = ACTIONS(3483),
    [anon_sym_noreturn] = ACTIONS(3483),
    [anon_sym_mutable] = ACTIONS(3483),
    [anon_sym_constinit] = ACTIONS(3483),
    [anon_sym_consteval] = ACTIONS(3483),
    [anon_sym_PROGMEM] = ACTIONS(3483),
    [aux_sym_primitive_type_token1] = ACTIONS(3483),
    [anon_sym_byte] = ACTIONS(3483),
    [anon_sym_word] = ACTIONS(3483),
    [anon_sym_enum] = ACTIONS(3483),
    [anon_sym_class] = ACTIONS(3483),
    [anon_sym_struct] = ACTIONS(3483),
    [anon_sym_union] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_switch] = ACTIONS(3483),
    [anon_sym_case] = ACTIONS(3483),
    [anon_sym_default] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_break] = ACTIONS(3483),
    [anon_sym_continue] = ACTIONS(3483),
    [anon_sym_goto] = ACTIONS(3483),
    [anon_sym___try] = ACTIONS(3483),
    [anon_sym___leave] = ACTIONS(3483),
    [anon_sym_not] = ACTIONS(3483),
    [anon_sym_compl] = ACTIONS(3483),
    [anon_sym_DASH_DASH] = ACTIONS(3485),
    [anon_sym_PLUS_PLUS] = ACTIONS(3485),
    [anon_sym_sizeof] = ACTIONS(3483),
    [anon_sym___alignof__] = ACTIONS(3483),
    [anon_sym___alignof] = ACTIONS(3483),
    [anon_sym__alignof] = ACTIONS(3483),
    [anon_sym_alignof] = ACTIONS(3483),
    [anon_sym__Alignof] = ACTIONS(3483),
    [anon_sym_offsetof] = ACTIONS(3483),
    [anon_sym__Generic] = ACTIONS(3483),
    [anon_sym_asm] = ACTIONS(3483),
    [anon_sym___asm__] = ACTIONS(3483),
    [aux_sym_number_literal_token1] = ACTIONS(3485),
    [aux_sym_number_literal_token2] = ACTIONS(3483),
    [anon_sym_L_SQUOTE] = ACTIONS(3485),
    [anon_sym_u_SQUOTE] = ACTIONS(3485),
    [anon_sym_U_SQUOTE] = ACTIONS(3485),
    [anon_sym_u8_SQUOTE] = ACTIONS(3485),
    [anon_sym_SQUOTE] = ACTIONS(3485),
    [anon_sym_L_DQUOTE] = ACTIONS(3485),
    [anon_sym_u_DQUOTE] = ACTIONS(3485),
    [anon_sym_U_DQUOTE] = ACTIONS(3485),
    [anon_sym_u8_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE] = ACTIONS(3485),
    [sym_true] = ACTIONS(3483),
    [sym_false] = ACTIONS(3483),
    [anon_sym_NULL] = ACTIONS(3483),
    [anon_sym_nullptr] = ACTIONS(3483),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3483),
    [anon_sym_decltype] = ACTIONS(3483),
    [anon_sym_virtual] = ACTIONS(3483),
    [anon_sym_alignas] = ACTIONS(3483),
    [anon_sym_explicit] = ACTIONS(3483),
    [anon_sym_typename] = ACTIONS(3483),
    [anon_sym_template] = ACTIONS(3483),
    [anon_sym_operator] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_delete] = ACTIONS(3483),
    [anon_sym_throw] = ACTIONS(3483),
    [anon_sym_namespace] = ACTIONS(3483),
    [anon_sym_using] = ACTIONS(3483),
    [anon_sym_static_assert] = ACTIONS(3483),
    [anon_sym_concept] = ACTIONS(3483),
    [anon_sym_co_return] = ACTIONS(3483),
    [anon_sym_co_yield] = ACTIONS(3483),
    [anon_sym_R_DQUOTE] = ACTIONS(3485),
    [anon_sym_LR_DQUOTE] = ACTIONS(3485),
    [anon_sym_uR_DQUOTE] = ACTIONS(3485),
    [anon_sym_UR_DQUOTE] = ACTIONS(3485),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3485),
    [anon_sym_co_await] = ACTIONS(3483),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_requires] = ACTIONS(3483),
    [sym_this] = ACTIONS(3483),
  },
  [903] = {
    [sym_identifier] = ACTIONS(3451),
    [aux_sym_preproc_include_token1] = ACTIONS(3451),
    [aux_sym_preproc_def_token1] = ACTIONS(3451),
    [aux_sym_preproc_if_token1] = ACTIONS(3451),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3451),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3451),
    [sym_preproc_directive] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3453),
    [anon_sym_BANG] = ACTIONS(3453),
    [anon_sym_TILDE] = ACTIONS(3453),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(3453),
    [anon_sym_AMP_AMP] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_SEMI] = ACTIONS(3453),
    [anon_sym___extension__] = ACTIONS(3451),
    [anon_sym_typedef] = ACTIONS(3451),
    [anon_sym_extern] = ACTIONS(3451),
    [anon_sym___attribute__] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3453),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3453),
    [anon_sym___declspec] = ACTIONS(3451),
    [anon_sym___based] = ACTIONS(3451),
    [anon_sym___cdecl] = ACTIONS(3451),
    [anon_sym___clrcall] = ACTIONS(3451),
    [anon_sym___stdcall] = ACTIONS(3451),
    [anon_sym___fastcall] = ACTIONS(3451),
    [anon_sym___thiscall] = ACTIONS(3451),
    [anon_sym___vectorcall] = ACTIONS(3451),
    [anon_sym_LBRACE] = ACTIONS(3453),
    [anon_sym_RBRACE] = ACTIONS(3453),
    [anon_sym_signed] = ACTIONS(3451),
    [anon_sym_unsigned] = ACTIONS(3451),
    [anon_sym_long] = ACTIONS(3451),
    [anon_sym_short] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_register] = ACTIONS(3451),
    [anon_sym_inline] = ACTIONS(3451),
    [anon_sym___inline] = ACTIONS(3451),
    [anon_sym___inline__] = ACTIONS(3451),
    [anon_sym___forceinline] = ACTIONS(3451),
    [anon_sym_thread_local] = ACTIONS(3451),
    [anon_sym___thread] = ACTIONS(3451),
    [anon_sym_const] = ACTIONS(3451),
    [anon_sym_constexpr] = ACTIONS(3451),
    [anon_sym_volatile] = ACTIONS(3451),
    [anon_sym_restrict] = ACTIONS(3451),
    [anon_sym___restrict__] = ACTIONS(3451),
    [anon_sym__Atomic] = ACTIONS(3451),
    [anon_sym__Noreturn] = ACTIONS(3451),
    [anon_sym_noreturn] = ACTIONS(3451),
    [anon_sym_mutable] = ACTIONS(3451),
    [anon_sym_constinit] = ACTIONS(3451),
    [anon_sym_consteval] = ACTIONS(3451),
    [anon_sym_PROGMEM] = ACTIONS(3451),
    [aux_sym_primitive_type_token1] = ACTIONS(3451),
    [anon_sym_byte] = ACTIONS(3451),
    [anon_sym_word] = ACTIONS(3451),
    [anon_sym_enum] = ACTIONS(3451),
    [anon_sym_class] = ACTIONS(3451),
    [anon_sym_struct] = ACTIONS(3451),
    [anon_sym_union] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_switch] = ACTIONS(3451),
    [anon_sym_case] = ACTIONS(3451),
    [anon_sym_default] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_break] = ACTIONS(3451),
    [anon_sym_continue] = ACTIONS(3451),
    [anon_sym_goto] = ACTIONS(3451),
    [anon_sym___try] = ACTIONS(3451),
    [anon_sym___leave] = ACTIONS(3451),
    [anon_sym_not] = ACTIONS(3451),
    [anon_sym_compl] = ACTIONS(3451),
    [anon_sym_DASH_DASH] = ACTIONS(3453),
    [anon_sym_PLUS_PLUS] = ACTIONS(3453),
    [anon_sym_sizeof] = ACTIONS(3451),
    [anon_sym___alignof__] = ACTIONS(3451),
    [anon_sym___alignof] = ACTIONS(3451),
    [anon_sym__alignof] = ACTIONS(3451),
    [anon_sym_alignof] = ACTIONS(3451),
    [anon_sym__Alignof] = ACTIONS(3451),
    [anon_sym_offsetof] = ACTIONS(3451),
    [anon_sym__Generic] = ACTIONS(3451),
    [anon_sym_asm] = ACTIONS(3451),
    [anon_sym___asm__] = ACTIONS(3451),
    [aux_sym_number_literal_token1] = ACTIONS(3453),
    [aux_sym_number_literal_token2] = ACTIONS(3451),
    [anon_sym_L_SQUOTE] = ACTIONS(3453),
    [anon_sym_u_SQUOTE] = ACTIONS(3453),
    [anon_sym_U_SQUOTE] = ACTIONS(3453),
    [anon_sym_u8_SQUOTE] = ACTIONS(3453),
    [anon_sym_SQUOTE] = ACTIONS(3453),
    [anon_sym_L_DQUOTE] = ACTIONS(3453),
    [anon_sym_u_DQUOTE] = ACTIONS(3453),
    [anon_sym_U_DQUOTE] = ACTIONS(3453),
    [anon_sym_u8_DQUOTE] = ACTIONS(3453),
    [anon_sym_DQUOTE] = ACTIONS(3453),
    [sym_true] = ACTIONS(3451),
    [sym_false] = ACTIONS(3451),
    [anon_sym_NULL] = ACTIONS(3451),
    [anon_sym_nullptr] = ACTIONS(3451),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3451),
    [anon_sym_decltype] = ACTIONS(3451),
    [anon_sym_virtual] = ACTIONS(3451),
    [anon_sym_alignas] = ACTIONS(3451),
    [anon_sym_explicit] = ACTIONS(3451),
    [anon_sym_typename] = ACTIONS(3451),
    [anon_sym_template] = ACTIONS(3451),
    [anon_sym_operator] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_delete] = ACTIONS(3451),
    [anon_sym_throw] = ACTIONS(3451),
    [anon_sym_namespace] = ACTIONS(3451),
    [anon_sym_using] = ACTIONS(3451),
    [anon_sym_static_assert] = ACTIONS(3451),
    [anon_sym_concept] = ACTIONS(3451),
    [anon_sym_co_return] = ACTIONS(3451),
    [anon_sym_co_yield] = ACTIONS(3451),
    [anon_sym_R_DQUOTE] = ACTIONS(3453),
    [anon_sym_LR_DQUOTE] = ACTIONS(3453),
    [anon_sym_uR_DQUOTE] = ACTIONS(3453),
    [anon_sym_UR_DQUOTE] = ACTIONS(3453),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3453),
    [anon_sym_co_await] = ACTIONS(3451),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_requires] = ACTIONS(3451),
    [sym_this] = ACTIONS(3451),
  },
  [904] = {
    [sym_identifier] = ACTIONS(3455),
    [aux_sym_preproc_include_token1] = ACTIONS(3455),
    [aux_sym_preproc_def_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token1] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3455),
    [sym_preproc_directive] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_BANG] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_STAR] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_SEMI] = ACTIONS(3457),
    [anon_sym___extension__] = ACTIONS(3455),
    [anon_sym_typedef] = ACTIONS(3455),
    [anon_sym_extern] = ACTIONS(3455),
    [anon_sym___attribute__] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3457),
    [anon_sym___declspec] = ACTIONS(3455),
    [anon_sym___based] = ACTIONS(3455),
    [anon_sym___cdecl] = ACTIONS(3455),
    [anon_sym___clrcall] = ACTIONS(3455),
    [anon_sym___stdcall] = ACTIONS(3455),
    [anon_sym___fastcall] = ACTIONS(3455),
    [anon_sym___thiscall] = ACTIONS(3455),
    [anon_sym___vectorcall] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_RBRACE] = ACTIONS(3457),
    [anon_sym_signed] = ACTIONS(3455),
    [anon_sym_unsigned] = ACTIONS(3455),
    [anon_sym_long] = ACTIONS(3455),
    [anon_sym_short] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_static] = ACTIONS(3455),
    [anon_sym_register] = ACTIONS(3455),
    [anon_sym_inline] = ACTIONS(3455),
    [anon_sym___inline] = ACTIONS(3455),
    [anon_sym___inline__] = ACTIONS(3455),
    [anon_sym___forceinline] = ACTIONS(3455),
    [anon_sym_thread_local] = ACTIONS(3455),
    [anon_sym___thread] = ACTIONS(3455),
    [anon_sym_const] = ACTIONS(3455),
    [anon_sym_constexpr] = ACTIONS(3455),
    [anon_sym_volatile] = ACTIONS(3455),
    [anon_sym_restrict] = ACTIONS(3455),
    [anon_sym___restrict__] = ACTIONS(3455),
    [anon_sym__Atomic] = ACTIONS(3455),
    [anon_sym__Noreturn] = ACTIONS(3455),
    [anon_sym_noreturn] = ACTIONS(3455),
    [anon_sym_mutable] = ACTIONS(3455),
    [anon_sym_constinit] = ACTIONS(3455),
    [anon_sym_consteval] = ACTIONS(3455),
    [anon_sym_PROGMEM] = ACTIONS(3455),
    [aux_sym_primitive_type_token1] = ACTIONS(3455),
    [anon_sym_byte] = ACTIONS(3455),
    [anon_sym_word] = ACTIONS(3455),
    [anon_sym_enum] = ACTIONS(3455),
    [anon_sym_class] = ACTIONS(3455),
    [anon_sym_struct] = ACTIONS(3455),
    [anon_sym_union] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_switch] = ACTIONS(3455),
    [anon_sym_case] = ACTIONS(3455),
    [anon_sym_default] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_break] = ACTIONS(3455),
    [anon_sym_continue] = ACTIONS(3455),
    [anon_sym_goto] = ACTIONS(3455),
    [anon_sym___try] = ACTIONS(3455),
    [anon_sym___leave] = ACTIONS(3455),
    [anon_sym_not] = ACTIONS(3455),
    [anon_sym_compl] = ACTIONS(3455),
    [anon_sym_DASH_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_PLUS] = ACTIONS(3457),
    [anon_sym_sizeof] = ACTIONS(3455),
    [anon_sym___alignof__] = ACTIONS(3455),
    [anon_sym___alignof] = ACTIONS(3455),
    [anon_sym__alignof] = ACTIONS(3455),
    [anon_sym_alignof] = ACTIONS(3455),
    [anon_sym__Alignof] = ACTIONS(3455),
    [anon_sym_offsetof] = ACTIONS(3455),
    [anon_sym__Generic] = ACTIONS(3455),
    [anon_sym_asm] = ACTIONS(3455),
    [anon_sym___asm__] = ACTIONS(3455),
    [aux_sym_number_literal_token1] = ACTIONS(3457),
    [aux_sym_number_literal_token2] = ACTIONS(3455),
    [anon_sym_L_SQUOTE] = ACTIONS(3457),
    [anon_sym_u_SQUOTE] = ACTIONS(3457),
    [anon_sym_U_SQUOTE] = ACTIONS(3457),
    [anon_sym_u8_SQUOTE] = ACTIONS(3457),
    [anon_sym_SQUOTE] = ACTIONS(3457),
    [anon_sym_L_DQUOTE] = ACTIONS(3457),
    [anon_sym_u_DQUOTE] = ACTIONS(3457),
    [anon_sym_U_DQUOTE] = ACTIONS(3457),
    [anon_sym_u8_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [sym_true] = ACTIONS(3455),
    [sym_false] = ACTIONS(3455),
    [anon_sym_NULL] = ACTIONS(3455),
    [anon_sym_nullptr] = ACTIONS(3455),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3455),
    [anon_sym_decltype] = ACTIONS(3455),
    [anon_sym_virtual] = ACTIONS(3455),
    [anon_sym_alignas] = ACTIONS(3455),
    [anon_sym_explicit] = ACTIONS(3455),
    [anon_sym_typename] = ACTIONS(3455),
    [anon_sym_template] = ACTIONS(3455),
    [anon_sym_operator] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_delete] = ACTIONS(3455),
    [anon_sym_throw] = ACTIONS(3455),
    [anon_sym_namespace] = ACTIONS(3455),
    [anon_sym_using] = ACTIONS(3455),
    [anon_sym_static_assert] = ACTIONS(3455),
    [anon_sym_concept] = ACTIONS(3455),
    [anon_sym_co_return] = ACTIONS(3455),
    [anon_sym_co_yield] = ACTIONS(3455),
    [anon_sym_R_DQUOTE] = ACTIONS(3457),
    [anon_sym_LR_DQUOTE] = ACTIONS(3457),
    [anon_sym_uR_DQUOTE] = ACTIONS(3457),
    [anon_sym_UR_DQUOTE] = ACTIONS(3457),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3457),
    [anon_sym_co_await] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_requires] = ACTIONS(3455),
    [sym_this] = ACTIONS(3455),
  },
  [905] = {
    [sym_identifier] = ACTIONS(3332),
    [aux_sym_preproc_include_token1] = ACTIONS(3332),
    [aux_sym_preproc_def_token1] = ACTIONS(3332),
    [aux_sym_preproc_if_token1] = ACTIONS(3332),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3332),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3332),
    [sym_preproc_directive] = ACTIONS(3332),
    [anon_sym_LPAREN2] = ACTIONS(3334),
    [anon_sym_BANG] = ACTIONS(3334),
    [anon_sym_TILDE] = ACTIONS(3334),
    [anon_sym_DASH] = ACTIONS(3332),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_STAR] = ACTIONS(3334),
    [anon_sym_AMP_AMP] = ACTIONS(3334),
    [anon_sym_AMP] = ACTIONS(3332),
    [anon_sym_SEMI] = ACTIONS(3334),
    [anon_sym___extension__] = ACTIONS(3332),
    [anon_sym_typedef] = ACTIONS(3332),
    [anon_sym_extern] = ACTIONS(3332),
    [anon_sym___attribute__] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(3334),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3334),
    [anon_sym___declspec] = ACTIONS(3332),
    [anon_sym___based] = ACTIONS(3332),
    [anon_sym___cdecl] = ACTIONS(3332),
    [anon_sym___clrcall] = ACTIONS(3332),
    [anon_sym___stdcall] = ACTIONS(3332),
    [anon_sym___fastcall] = ACTIONS(3332),
    [anon_sym___thiscall] = ACTIONS(3332),
    [anon_sym___vectorcall] = ACTIONS(3332),
    [anon_sym_LBRACE] = ACTIONS(3334),
    [anon_sym_RBRACE] = ACTIONS(3334),
    [anon_sym_signed] = ACTIONS(3332),
    [anon_sym_unsigned] = ACTIONS(3332),
    [anon_sym_long] = ACTIONS(3332),
    [anon_sym_short] = ACTIONS(3332),
    [anon_sym_LBRACK] = ACTIONS(3332),
    [anon_sym_static] = ACTIONS(3332),
    [anon_sym_register] = ACTIONS(3332),
    [anon_sym_inline] = ACTIONS(3332),
    [anon_sym___inline] = ACTIONS(3332),
    [anon_sym___inline__] = ACTIONS(3332),
    [anon_sym___forceinline] = ACTIONS(3332),
    [anon_sym_thread_local] = ACTIONS(3332),
    [anon_sym___thread] = ACTIONS(3332),
    [anon_sym_const] = ACTIONS(3332),
    [anon_sym_constexpr] = ACTIONS(3332),
    [anon_sym_volatile] = ACTIONS(3332),
    [anon_sym_restrict] = ACTIONS(3332),
    [anon_sym___restrict__] = ACTIONS(3332),
    [anon_sym__Atomic] = ACTIONS(3332),
    [anon_sym__Noreturn] = ACTIONS(3332),
    [anon_sym_noreturn] = ACTIONS(3332),
    [anon_sym_mutable] = ACTIONS(3332),
    [anon_sym_constinit] = ACTIONS(3332),
    [anon_sym_consteval] = ACTIONS(3332),
    [anon_sym_PROGMEM] = ACTIONS(3332),
    [aux_sym_primitive_type_token1] = ACTIONS(3332),
    [anon_sym_byte] = ACTIONS(3332),
    [anon_sym_word] = ACTIONS(3332),
    [anon_sym_enum] = ACTIONS(3332),
    [anon_sym_class] = ACTIONS(3332),
    [anon_sym_struct] = ACTIONS(3332),
    [anon_sym_union] = ACTIONS(3332),
    [anon_sym_if] = ACTIONS(3332),
    [anon_sym_switch] = ACTIONS(3332),
    [anon_sym_case] = ACTIONS(3332),
    [anon_sym_default] = ACTIONS(3332),
    [anon_sym_while] = ACTIONS(3332),
    [anon_sym_do] = ACTIONS(3332),
    [anon_sym_for] = ACTIONS(3332),
    [anon_sym_return] = ACTIONS(3332),
    [anon_sym_break] = ACTIONS(3332),
    [anon_sym_continue] = ACTIONS(3332),
    [anon_sym_goto] = ACTIONS(3332),
    [anon_sym___try] = ACTIONS(3332),
    [anon_sym___leave] = ACTIONS(3332),
    [anon_sym_not] = ACTIONS(3332),
    [anon_sym_compl] = ACTIONS(3332),
    [anon_sym_DASH_DASH] = ACTIONS(3334),
    [anon_sym_PLUS_PLUS] = ACTIONS(3334),
    [anon_sym_sizeof] = ACTIONS(3332),
    [anon_sym___alignof__] = ACTIONS(3332),
    [anon_sym___alignof] = ACTIONS(3332),
    [anon_sym__alignof] = ACTIONS(3332),
    [anon_sym_alignof] = ACTIONS(3332),
    [anon_sym__Alignof] = ACTIONS(3332),
    [anon_sym_offsetof] = ACTIONS(3332),
    [anon_sym__Generic] = ACTIONS(3332),
    [anon_sym_asm] = ACTIONS(3332),
    [anon_sym___asm__] = ACTIONS(3332),
    [aux_sym_number_literal_token1] = ACTIONS(3334),
    [aux_sym_number_literal_token2] = ACTIONS(3332),
    [anon_sym_L_SQUOTE] = ACTIONS(3334),
    [anon_sym_u_SQUOTE] = ACTIONS(3334),
    [anon_sym_U_SQUOTE] = ACTIONS(3334),
    [anon_sym_u8_SQUOTE] = ACTIONS(3334),
    [anon_sym_SQUOTE] = ACTIONS(3334),
    [anon_sym_L_DQUOTE] = ACTIONS(3334),
    [anon_sym_u_DQUOTE] = ACTIONS(3334),
    [anon_sym_U_DQUOTE] = ACTIONS(3334),
    [anon_sym_u8_DQUOTE] = ACTIONS(3334),
    [anon_sym_DQUOTE] = ACTIONS(3334),
    [sym_true] = ACTIONS(3332),
    [sym_false] = ACTIONS(3332),
    [anon_sym_NULL] = ACTIONS(3332),
    [anon_sym_nullptr] = ACTIONS(3332),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3332),
    [anon_sym_decltype] = ACTIONS(3332),
    [anon_sym_virtual] = ACTIONS(3332),
    [anon_sym_alignas] = ACTIONS(3332),
    [anon_sym_explicit] = ACTIONS(3332),
    [anon_sym_typename] = ACTIONS(3332),
    [anon_sym_template] = ACTIONS(3332),
    [anon_sym_operator] = ACTIONS(3332),
    [anon_sym_try] = ACTIONS(3332),
    [anon_sym_delete] = ACTIONS(3332),
    [anon_sym_throw] = ACTIONS(3332),
    [anon_sym_namespace] = ACTIONS(3332),
    [anon_sym_using] = ACTIONS(3332),
    [anon_sym_static_assert] = ACTIONS(3332),
    [anon_sym_concept] = ACTIONS(3332),
    [anon_sym_co_return] = ACTIONS(3332),
    [anon_sym_co_yield] = ACTIONS(3332),
    [anon_sym_R_DQUOTE] = ACTIONS(3334),
    [anon_sym_LR_DQUOTE] = ACTIONS(3334),
    [anon_sym_uR_DQUOTE] = ACTIONS(3334),
    [anon_sym_UR_DQUOTE] = ACTIONS(3334),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3334),
    [anon_sym_co_await] = ACTIONS(3332),
    [anon_sym_new] = ACTIONS(3332),
    [anon_sym_requires] = ACTIONS(3332),
    [sym_this] = ACTIONS(3332),
  },
  [906] = {
    [sym_identifier] = ACTIONS(3487),
    [aux_sym_preproc_include_token1] = ACTIONS(3487),
    [aux_sym_preproc_def_token1] = ACTIONS(3487),
    [aux_sym_preproc_if_token1] = ACTIONS(3487),
    [aux_sym_preproc_if_token2] = ACTIONS(3487),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3487),
    [sym_preproc_directive] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3489),
    [anon_sym_BANG] = ACTIONS(3489),
    [anon_sym_TILDE] = ACTIONS(3489),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3489),
    [anon_sym_AMP_AMP] = ACTIONS(3489),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_SEMI] = ACTIONS(3489),
    [anon_sym___extension__] = ACTIONS(3487),
    [anon_sym_typedef] = ACTIONS(3487),
    [anon_sym_extern] = ACTIONS(3487),
    [anon_sym___attribute__] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3489),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3489),
    [anon_sym___declspec] = ACTIONS(3487),
    [anon_sym___based] = ACTIONS(3487),
    [anon_sym___cdecl] = ACTIONS(3487),
    [anon_sym___clrcall] = ACTIONS(3487),
    [anon_sym___stdcall] = ACTIONS(3487),
    [anon_sym___fastcall] = ACTIONS(3487),
    [anon_sym___thiscall] = ACTIONS(3487),
    [anon_sym___vectorcall] = ACTIONS(3487),
    [anon_sym_LBRACE] = ACTIONS(3489),
    [anon_sym_signed] = ACTIONS(3487),
    [anon_sym_unsigned] = ACTIONS(3487),
    [anon_sym_long] = ACTIONS(3487),
    [anon_sym_short] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_register] = ACTIONS(3487),
    [anon_sym_inline] = ACTIONS(3487),
    [anon_sym___inline] = ACTIONS(3487),
    [anon_sym___inline__] = ACTIONS(3487),
    [anon_sym___forceinline] = ACTIONS(3487),
    [anon_sym_thread_local] = ACTIONS(3487),
    [anon_sym___thread] = ACTIONS(3487),
    [anon_sym_const] = ACTIONS(3487),
    [anon_sym_constexpr] = ACTIONS(3487),
    [anon_sym_volatile] = ACTIONS(3487),
    [anon_sym_restrict] = ACTIONS(3487),
    [anon_sym___restrict__] = ACTIONS(3487),
    [anon_sym__Atomic] = ACTIONS(3487),
    [anon_sym__Noreturn] = ACTIONS(3487),
    [anon_sym_noreturn] = ACTIONS(3487),
    [anon_sym_mutable] = ACTIONS(3487),
    [anon_sym_constinit] = ACTIONS(3487),
    [anon_sym_consteval] = ACTIONS(3487),
    [anon_sym_PROGMEM] = ACTIONS(3487),
    [aux_sym_primitive_type_token1] = ACTIONS(3487),
    [anon_sym_byte] = ACTIONS(3487),
    [anon_sym_word] = ACTIONS(3487),
    [anon_sym_enum] = ACTIONS(3487),
    [anon_sym_class] = ACTIONS(3487),
    [anon_sym_struct] = ACTIONS(3487),
    [anon_sym_union] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_switch] = ACTIONS(3487),
    [anon_sym_case] = ACTIONS(3487),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_break] = ACTIONS(3487),
    [anon_sym_continue] = ACTIONS(3487),
    [anon_sym_goto] = ACTIONS(3487),
    [anon_sym___try] = ACTIONS(3487),
    [anon_sym___leave] = ACTIONS(3487),
    [anon_sym_not] = ACTIONS(3487),
    [anon_sym_compl] = ACTIONS(3487),
    [anon_sym_DASH_DASH] = ACTIONS(3489),
    [anon_sym_PLUS_PLUS] = ACTIONS(3489),
    [anon_sym_sizeof] = ACTIONS(3487),
    [anon_sym___alignof__] = ACTIONS(3487),
    [anon_sym___alignof] = ACTIONS(3487),
    [anon_sym__alignof] = ACTIONS(3487),
    [anon_sym_alignof] = ACTIONS(3487),
    [anon_sym__Alignof] = ACTIONS(3487),
    [anon_sym_offsetof] = ACTIONS(3487),
    [anon_sym__Generic] = ACTIONS(3487),
    [anon_sym_asm] = ACTIONS(3487),
    [anon_sym___asm__] = ACTIONS(3487),
    [aux_sym_number_literal_token1] = ACTIONS(3489),
    [aux_sym_number_literal_token2] = ACTIONS(3487),
    [anon_sym_L_SQUOTE] = ACTIONS(3489),
    [anon_sym_u_SQUOTE] = ACTIONS(3489),
    [anon_sym_U_SQUOTE] = ACTIONS(3489),
    [anon_sym_u8_SQUOTE] = ACTIONS(3489),
    [anon_sym_SQUOTE] = ACTIONS(3489),
    [anon_sym_L_DQUOTE] = ACTIONS(3489),
    [anon_sym_u_DQUOTE] = ACTIONS(3489),
    [anon_sym_U_DQUOTE] = ACTIONS(3489),
    [anon_sym_u8_DQUOTE] = ACTIONS(3489),
    [anon_sym_DQUOTE] = ACTIONS(3489),
    [sym_true] = ACTIONS(3487),
    [sym_false] = ACTIONS(3487),
    [anon_sym_NULL] = ACTIONS(3487),
    [anon_sym_nullptr] = ACTIONS(3487),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3487),
    [anon_sym_decltype] = ACTIONS(3487),
    [anon_sym_virtual] = ACTIONS(3487),
    [anon_sym_alignas] = ACTIONS(3487),
    [anon_sym_explicit] = ACTIONS(3487),
    [anon_sym_typename] = ACTIONS(3487),
    [anon_sym_template] = ACTIONS(3487),
    [anon_sym_operator] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_delete] = ACTIONS(3487),
    [anon_sym_throw] = ACTIONS(3487),
    [anon_sym_namespace] = ACTIONS(3487),
    [anon_sym_using] = ACTIONS(3487),
    [anon_sym_static_assert] = ACTIONS(3487),
    [anon_sym_concept] = ACTIONS(3487),
    [anon_sym_co_return] = ACTIONS(3487),
    [anon_sym_co_yield] = ACTIONS(3487),
    [anon_sym_R_DQUOTE] = ACTIONS(3489),
    [anon_sym_LR_DQUOTE] = ACTIONS(3489),
    [anon_sym_uR_DQUOTE] = ACTIONS(3489),
    [anon_sym_UR_DQUOTE] = ACTIONS(3489),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3489),
    [anon_sym_co_await] = ACTIONS(3487),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_requires] = ACTIONS(3487),
    [sym_this] = ACTIONS(3487),
  },
  [907] = {
    [sym_identifier] = ACTIONS(3310),
    [aux_sym_preproc_include_token1] = ACTIONS(3310),
    [aux_sym_preproc_def_token1] = ACTIONS(3310),
    [aux_sym_preproc_if_token1] = ACTIONS(3310),
    [aux_sym_preproc_if_token2] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3310),
    [sym_preproc_directive] = ACTIONS(3310),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_AMP_AMP] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3310),
    [anon_sym_SEMI] = ACTIONS(3312),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_typedef] = ACTIONS(3310),
    [anon_sym_extern] = ACTIONS(3310),
    [anon_sym___attribute__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3312),
    [anon_sym___declspec] = ACTIONS(3310),
    [anon_sym___based] = ACTIONS(3310),
    [anon_sym___cdecl] = ACTIONS(3310),
    [anon_sym___clrcall] = ACTIONS(3310),
    [anon_sym___stdcall] = ACTIONS(3310),
    [anon_sym___fastcall] = ACTIONS(3310),
    [anon_sym___thiscall] = ACTIONS(3310),
    [anon_sym___vectorcall] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3312),
    [anon_sym_signed] = ACTIONS(3310),
    [anon_sym_unsigned] = ACTIONS(3310),
    [anon_sym_long] = ACTIONS(3310),
    [anon_sym_short] = ACTIONS(3310),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [anon_sym_static] = ACTIONS(3310),
    [anon_sym_register] = ACTIONS(3310),
    [anon_sym_inline] = ACTIONS(3310),
    [anon_sym___inline] = ACTIONS(3310),
    [anon_sym___inline__] = ACTIONS(3310),
    [anon_sym___forceinline] = ACTIONS(3310),
    [anon_sym_thread_local] = ACTIONS(3310),
    [anon_sym___thread] = ACTIONS(3310),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_constexpr] = ACTIONS(3310),
    [anon_sym_volatile] = ACTIONS(3310),
    [anon_sym_restrict] = ACTIONS(3310),
    [anon_sym___restrict__] = ACTIONS(3310),
    [anon_sym__Atomic] = ACTIONS(3310),
    [anon_sym__Noreturn] = ACTIONS(3310),
    [anon_sym_noreturn] = ACTIONS(3310),
    [anon_sym_mutable] = ACTIONS(3310),
    [anon_sym_constinit] = ACTIONS(3310),
    [anon_sym_consteval] = ACTIONS(3310),
    [anon_sym_PROGMEM] = ACTIONS(3310),
    [aux_sym_primitive_type_token1] = ACTIONS(3310),
    [anon_sym_byte] = ACTIONS(3310),
    [anon_sym_word] = ACTIONS(3310),
    [anon_sym_enum] = ACTIONS(3310),
    [anon_sym_class] = ACTIONS(3310),
    [anon_sym_struct] = ACTIONS(3310),
    [anon_sym_union] = ACTIONS(3310),
    [anon_sym_if] = ACTIONS(3310),
    [anon_sym_switch] = ACTIONS(3310),
    [anon_sym_case] = ACTIONS(3310),
    [anon_sym_default] = ACTIONS(3310),
    [anon_sym_while] = ACTIONS(3310),
    [anon_sym_do] = ACTIONS(3310),
    [anon_sym_for] = ACTIONS(3310),
    [anon_sym_return] = ACTIONS(3310),
    [anon_sym_break] = ACTIONS(3310),
    [anon_sym_continue] = ACTIONS(3310),
    [anon_sym_goto] = ACTIONS(3310),
    [anon_sym___try] = ACTIONS(3310),
    [anon_sym___leave] = ACTIONS(3310),
    [anon_sym_not] = ACTIONS(3310),
    [anon_sym_compl] = ACTIONS(3310),
    [anon_sym_DASH_DASH] = ACTIONS(3312),
    [anon_sym_PLUS_PLUS] = ACTIONS(3312),
    [anon_sym_sizeof] = ACTIONS(3310),
    [anon_sym___alignof__] = ACTIONS(3310),
    [anon_sym___alignof] = ACTIONS(3310),
    [anon_sym__alignof] = ACTIONS(3310),
    [anon_sym_alignof] = ACTIONS(3310),
    [anon_sym__Alignof] = ACTIONS(3310),
    [anon_sym_offsetof] = ACTIONS(3310),
    [anon_sym__Generic] = ACTIONS(3310),
    [anon_sym_asm] = ACTIONS(3310),
    [anon_sym___asm__] = ACTIONS(3310),
    [aux_sym_number_literal_token1] = ACTIONS(3312),
    [aux_sym_number_literal_token2] = ACTIONS(3310),
    [anon_sym_L_SQUOTE] = ACTIONS(3312),
    [anon_sym_u_SQUOTE] = ACTIONS(3312),
    [anon_sym_U_SQUOTE] = ACTIONS(3312),
    [anon_sym_u8_SQUOTE] = ACTIONS(3312),
    [anon_sym_SQUOTE] = ACTIONS(3312),
    [anon_sym_L_DQUOTE] = ACTIONS(3312),
    [anon_sym_u_DQUOTE] = ACTIONS(3312),
    [anon_sym_U_DQUOTE] = ACTIONS(3312),
    [anon_sym_u8_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE] = ACTIONS(3312),
    [sym_true] = ACTIONS(3310),
    [sym_false] = ACTIONS(3310),
    [anon_sym_NULL] = ACTIONS(3310),
    [anon_sym_nullptr] = ACTIONS(3310),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3310),
    [anon_sym_decltype] = ACTIONS(3310),
    [anon_sym_virtual] = ACTIONS(3310),
    [anon_sym_alignas] = ACTIONS(3310),
    [anon_sym_explicit] = ACTIONS(3310),
    [anon_sym_typename] = ACTIONS(3310),
    [anon_sym_template] = ACTIONS(3310),
    [anon_sym_operator] = ACTIONS(3310),
    [anon_sym_try] = ACTIONS(3310),
    [anon_sym_delete] = ACTIONS(3310),
    [anon_sym_throw] = ACTIONS(3310),
    [anon_sym_namespace] = ACTIONS(3310),
    [anon_sym_using] = ACTIONS(3310),
    [anon_sym_static_assert] = ACTIONS(3310),
    [anon_sym_concept] = ACTIONS(3310),
    [anon_sym_co_return] = ACTIONS(3310),
    [anon_sym_co_yield] = ACTIONS(3310),
    [anon_sym_R_DQUOTE] = ACTIONS(3312),
    [anon_sym_LR_DQUOTE] = ACTIONS(3312),
    [anon_sym_uR_DQUOTE] = ACTIONS(3312),
    [anon_sym_UR_DQUOTE] = ACTIONS(3312),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3312),
    [anon_sym_co_await] = ACTIONS(3310),
    [anon_sym_new] = ACTIONS(3310),
    [anon_sym_requires] = ACTIONS(3310),
    [sym_this] = ACTIONS(3310),
  },
  [908] = {
    [sym_identifier] = ACTIONS(3375),
    [aux_sym_preproc_include_token1] = ACTIONS(3375),
    [aux_sym_preproc_def_token1] = ACTIONS(3375),
    [aux_sym_preproc_if_token1] = ACTIONS(3375),
    [aux_sym_preproc_if_token2] = ACTIONS(3375),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3375),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3375),
    [sym_preproc_directive] = ACTIONS(3375),
    [anon_sym_LPAREN2] = ACTIONS(3377),
    [anon_sym_BANG] = ACTIONS(3377),
    [anon_sym_TILDE] = ACTIONS(3377),
    [anon_sym_DASH] = ACTIONS(3375),
    [anon_sym_PLUS] = ACTIONS(3375),
    [anon_sym_STAR] = ACTIONS(3377),
    [anon_sym_AMP_AMP] = ACTIONS(3377),
    [anon_sym_AMP] = ACTIONS(3375),
    [anon_sym_SEMI] = ACTIONS(3377),
    [anon_sym___extension__] = ACTIONS(3375),
    [anon_sym_typedef] = ACTIONS(3375),
    [anon_sym_extern] = ACTIONS(3375),
    [anon_sym___attribute__] = ACTIONS(3375),
    [anon_sym_COLON_COLON] = ACTIONS(3377),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3377),
    [anon_sym___declspec] = ACTIONS(3375),
    [anon_sym___based] = ACTIONS(3375),
    [anon_sym___cdecl] = ACTIONS(3375),
    [anon_sym___clrcall] = ACTIONS(3375),
    [anon_sym___stdcall] = ACTIONS(3375),
    [anon_sym___fastcall] = ACTIONS(3375),
    [anon_sym___thiscall] = ACTIONS(3375),
    [anon_sym___vectorcall] = ACTIONS(3375),
    [anon_sym_LBRACE] = ACTIONS(3377),
    [anon_sym_signed] = ACTIONS(3375),
    [anon_sym_unsigned] = ACTIONS(3375),
    [anon_sym_long] = ACTIONS(3375),
    [anon_sym_short] = ACTIONS(3375),
    [anon_sym_LBRACK] = ACTIONS(3375),
    [anon_sym_static] = ACTIONS(3375),
    [anon_sym_register] = ACTIONS(3375),
    [anon_sym_inline] = ACTIONS(3375),
    [anon_sym___inline] = ACTIONS(3375),
    [anon_sym___inline__] = ACTIONS(3375),
    [anon_sym___forceinline] = ACTIONS(3375),
    [anon_sym_thread_local] = ACTIONS(3375),
    [anon_sym___thread] = ACTIONS(3375),
    [anon_sym_const] = ACTIONS(3375),
    [anon_sym_constexpr] = ACTIONS(3375),
    [anon_sym_volatile] = ACTIONS(3375),
    [anon_sym_restrict] = ACTIONS(3375),
    [anon_sym___restrict__] = ACTIONS(3375),
    [anon_sym__Atomic] = ACTIONS(3375),
    [anon_sym__Noreturn] = ACTIONS(3375),
    [anon_sym_noreturn] = ACTIONS(3375),
    [anon_sym_mutable] = ACTIONS(3375),
    [anon_sym_constinit] = ACTIONS(3375),
    [anon_sym_consteval] = ACTIONS(3375),
    [anon_sym_PROGMEM] = ACTIONS(3375),
    [aux_sym_primitive_type_token1] = ACTIONS(3375),
    [anon_sym_byte] = ACTIONS(3375),
    [anon_sym_word] = ACTIONS(3375),
    [anon_sym_enum] = ACTIONS(3375),
    [anon_sym_class] = ACTIONS(3375),
    [anon_sym_struct] = ACTIONS(3375),
    [anon_sym_union] = ACTIONS(3375),
    [anon_sym_if] = ACTIONS(3375),
    [anon_sym_switch] = ACTIONS(3375),
    [anon_sym_case] = ACTIONS(3375),
    [anon_sym_default] = ACTIONS(3375),
    [anon_sym_while] = ACTIONS(3375),
    [anon_sym_do] = ACTIONS(3375),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_return] = ACTIONS(3375),
    [anon_sym_break] = ACTIONS(3375),
    [anon_sym_continue] = ACTIONS(3375),
    [anon_sym_goto] = ACTIONS(3375),
    [anon_sym___try] = ACTIONS(3375),
    [anon_sym___leave] = ACTIONS(3375),
    [anon_sym_not] = ACTIONS(3375),
    [anon_sym_compl] = ACTIONS(3375),
    [anon_sym_DASH_DASH] = ACTIONS(3377),
    [anon_sym_PLUS_PLUS] = ACTIONS(3377),
    [anon_sym_sizeof] = ACTIONS(3375),
    [anon_sym___alignof__] = ACTIONS(3375),
    [anon_sym___alignof] = ACTIONS(3375),
    [anon_sym__alignof] = ACTIONS(3375),
    [anon_sym_alignof] = ACTIONS(3375),
    [anon_sym__Alignof] = ACTIONS(3375),
    [anon_sym_offsetof] = ACTIONS(3375),
    [anon_sym__Generic] = ACTIONS(3375),
    [anon_sym_asm] = ACTIONS(3375),
    [anon_sym___asm__] = ACTIONS(3375),
    [aux_sym_number_literal_token1] = ACTIONS(3377),
    [aux_sym_number_literal_token2] = ACTIONS(3375),
    [anon_sym_L_SQUOTE] = ACTIONS(3377),
    [anon_sym_u_SQUOTE] = ACTIONS(3377),
    [anon_sym_U_SQUOTE] = ACTIONS(3377),
    [anon_sym_u8_SQUOTE] = ACTIONS(3377),
    [anon_sym_SQUOTE] = ACTIONS(3377),
    [anon_sym_L_DQUOTE] = ACTIONS(3377),
    [anon_sym_u_DQUOTE] = ACTIONS(3377),
    [anon_sym_U_DQUOTE] = ACTIONS(3377),
    [anon_sym_u8_DQUOTE] = ACTIONS(3377),
    [anon_sym_DQUOTE] = ACTIONS(3377),
    [sym_true] = ACTIONS(3375),
    [sym_false] = ACTIONS(3375),
    [anon_sym_NULL] = ACTIONS(3375),
    [anon_sym_nullptr] = ACTIONS(3375),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3375),
    [anon_sym_decltype] = ACTIONS(3375),
    [anon_sym_virtual] = ACTIONS(3375),
    [anon_sym_alignas] = ACTIONS(3375),
    [anon_sym_explicit] = ACTIONS(3375),
    [anon_sym_typename] = ACTIONS(3375),
    [anon_sym_template] = ACTIONS(3375),
    [anon_sym_operator] = ACTIONS(3375),
    [anon_sym_try] = ACTIONS(3375),
    [anon_sym_delete] = ACTIONS(3375),
    [anon_sym_throw] = ACTIONS(3375),
    [anon_sym_namespace] = ACTIONS(3375),
    [anon_sym_using] = ACTIONS(3375),
    [anon_sym_static_assert] = ACTIONS(3375),
    [anon_sym_concept] = ACTIONS(3375),
    [anon_sym_co_return] = ACTIONS(3375),
    [anon_sym_co_yield] = ACTIONS(3375),
    [anon_sym_R_DQUOTE] = ACTIONS(3377),
    [anon_sym_LR_DQUOTE] = ACTIONS(3377),
    [anon_sym_uR_DQUOTE] = ACTIONS(3377),
    [anon_sym_UR_DQUOTE] = ACTIONS(3377),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3377),
    [anon_sym_co_await] = ACTIONS(3375),
    [anon_sym_new] = ACTIONS(3375),
    [anon_sym_requires] = ACTIONS(3375),
    [sym_this] = ACTIONS(3375),
  },
  [909] = {
    [sym_identifier] = ACTIONS(3314),
    [aux_sym_preproc_include_token1] = ACTIONS(3314),
    [aux_sym_preproc_def_token1] = ACTIONS(3314),
    [aux_sym_preproc_if_token1] = ACTIONS(3314),
    [aux_sym_preproc_if_token2] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3314),
    [sym_preproc_directive] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_STAR] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_SEMI] = ACTIONS(3316),
    [anon_sym___extension__] = ACTIONS(3314),
    [anon_sym_typedef] = ACTIONS(3314),
    [anon_sym_extern] = ACTIONS(3314),
    [anon_sym___attribute__] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3316),
    [anon_sym___declspec] = ACTIONS(3314),
    [anon_sym___based] = ACTIONS(3314),
    [anon_sym___cdecl] = ACTIONS(3314),
    [anon_sym___clrcall] = ACTIONS(3314),
    [anon_sym___stdcall] = ACTIONS(3314),
    [anon_sym___fastcall] = ACTIONS(3314),
    [anon_sym___thiscall] = ACTIONS(3314),
    [anon_sym___vectorcall] = ACTIONS(3314),
    [anon_sym_LBRACE] = ACTIONS(3316),
    [anon_sym_signed] = ACTIONS(3314),
    [anon_sym_unsigned] = ACTIONS(3314),
    [anon_sym_long] = ACTIONS(3314),
    [anon_sym_short] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_static] = ACTIONS(3314),
    [anon_sym_register] = ACTIONS(3314),
    [anon_sym_inline] = ACTIONS(3314),
    [anon_sym___inline] = ACTIONS(3314),
    [anon_sym___inline__] = ACTIONS(3314),
    [anon_sym___forceinline] = ACTIONS(3314),
    [anon_sym_thread_local] = ACTIONS(3314),
    [anon_sym___thread] = ACTIONS(3314),
    [anon_sym_const] = ACTIONS(3314),
    [anon_sym_constexpr] = ACTIONS(3314),
    [anon_sym_volatile] = ACTIONS(3314),
    [anon_sym_restrict] = ACTIONS(3314),
    [anon_sym___restrict__] = ACTIONS(3314),
    [anon_sym__Atomic] = ACTIONS(3314),
    [anon_sym__Noreturn] = ACTIONS(3314),
    [anon_sym_noreturn] = ACTIONS(3314),
    [anon_sym_mutable] = ACTIONS(3314),
    [anon_sym_constinit] = ACTIONS(3314),
    [anon_sym_consteval] = ACTIONS(3314),
    [anon_sym_PROGMEM] = ACTIONS(3314),
    [aux_sym_primitive_type_token1] = ACTIONS(3314),
    [anon_sym_byte] = ACTIONS(3314),
    [anon_sym_word] = ACTIONS(3314),
    [anon_sym_enum] = ACTIONS(3314),
    [anon_sym_class] = ACTIONS(3314),
    [anon_sym_struct] = ACTIONS(3314),
    [anon_sym_union] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_switch] = ACTIONS(3314),
    [anon_sym_case] = ACTIONS(3314),
    [anon_sym_default] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_break] = ACTIONS(3314),
    [anon_sym_continue] = ACTIONS(3314),
    [anon_sym_goto] = ACTIONS(3314),
    [anon_sym___try] = ACTIONS(3314),
    [anon_sym___leave] = ACTIONS(3314),
    [anon_sym_not] = ACTIONS(3314),
    [anon_sym_compl] = ACTIONS(3314),
    [anon_sym_DASH_DASH] = ACTIONS(3316),
    [anon_sym_PLUS_PLUS] = ACTIONS(3316),
    [anon_sym_sizeof] = ACTIONS(3314),
    [anon_sym___alignof__] = ACTIONS(3314),
    [anon_sym___alignof] = ACTIONS(3314),
    [anon_sym__alignof] = ACTIONS(3314),
    [anon_sym_alignof] = ACTIONS(3314),
    [anon_sym__Alignof] = ACTIONS(3314),
    [anon_sym_offsetof] = ACTIONS(3314),
    [anon_sym__Generic] = ACTIONS(3314),
    [anon_sym_asm] = ACTIONS(3314),
    [anon_sym___asm__] = ACTIONS(3314),
    [aux_sym_number_literal_token1] = ACTIONS(3316),
    [aux_sym_number_literal_token2] = ACTIONS(3314),
    [anon_sym_L_SQUOTE] = ACTIONS(3316),
    [anon_sym_u_SQUOTE] = ACTIONS(3316),
    [anon_sym_U_SQUOTE] = ACTIONS(3316),
    [anon_sym_u8_SQUOTE] = ACTIONS(3316),
    [anon_sym_SQUOTE] = ACTIONS(3316),
    [anon_sym_L_DQUOTE] = ACTIONS(3316),
    [anon_sym_u_DQUOTE] = ACTIONS(3316),
    [anon_sym_U_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8_DQUOTE] = ACTIONS(3316),
    [anon_sym_DQUOTE] = ACTIONS(3316),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [anon_sym_NULL] = ACTIONS(3314),
    [anon_sym_nullptr] = ACTIONS(3314),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3314),
    [anon_sym_decltype] = ACTIONS(3314),
    [anon_sym_virtual] = ACTIONS(3314),
    [anon_sym_alignas] = ACTIONS(3314),
    [anon_sym_explicit] = ACTIONS(3314),
    [anon_sym_typename] = ACTIONS(3314),
    [anon_sym_template] = ACTIONS(3314),
    [anon_sym_operator] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_delete] = ACTIONS(3314),
    [anon_sym_throw] = ACTIONS(3314),
    [anon_sym_namespace] = ACTIONS(3314),
    [anon_sym_using] = ACTIONS(3314),
    [anon_sym_static_assert] = ACTIONS(3314),
    [anon_sym_concept] = ACTIONS(3314),
    [anon_sym_co_return] = ACTIONS(3314),
    [anon_sym_co_yield] = ACTIONS(3314),
    [anon_sym_R_DQUOTE] = ACTIONS(3316),
    [anon_sym_LR_DQUOTE] = ACTIONS(3316),
    [anon_sym_uR_DQUOTE] = ACTIONS(3316),
    [anon_sym_UR_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3316),
    [anon_sym_co_await] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_requires] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
  },
  [910] = {
    [sym_identifier] = ACTIONS(3467),
    [aux_sym_preproc_include_token1] = ACTIONS(3467),
    [aux_sym_preproc_def_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token1] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3467),
    [sym_preproc_directive] = ACTIONS(3467),
    [anon_sym_LPAREN2] = ACTIONS(3469),
    [anon_sym_BANG] = ACTIONS(3469),
    [anon_sym_TILDE] = ACTIONS(3469),
    [anon_sym_DASH] = ACTIONS(3467),
    [anon_sym_PLUS] = ACTIONS(3467),
    [anon_sym_STAR] = ACTIONS(3469),
    [anon_sym_AMP_AMP] = ACTIONS(3469),
    [anon_sym_AMP] = ACTIONS(3467),
    [anon_sym_SEMI] = ACTIONS(3469),
    [anon_sym___extension__] = ACTIONS(3467),
    [anon_sym_typedef] = ACTIONS(3467),
    [anon_sym_extern] = ACTIONS(3467),
    [anon_sym___attribute__] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(3469),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3469),
    [anon_sym___declspec] = ACTIONS(3467),
    [anon_sym___based] = ACTIONS(3467),
    [anon_sym___cdecl] = ACTIONS(3467),
    [anon_sym___clrcall] = ACTIONS(3467),
    [anon_sym___stdcall] = ACTIONS(3467),
    [anon_sym___fastcall] = ACTIONS(3467),
    [anon_sym___thiscall] = ACTIONS(3467),
    [anon_sym___vectorcall] = ACTIONS(3467),
    [anon_sym_LBRACE] = ACTIONS(3469),
    [anon_sym_RBRACE] = ACTIONS(3469),
    [anon_sym_signed] = ACTIONS(3467),
    [anon_sym_unsigned] = ACTIONS(3467),
    [anon_sym_long] = ACTIONS(3467),
    [anon_sym_short] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [anon_sym_static] = ACTIONS(3467),
    [anon_sym_register] = ACTIONS(3467),
    [anon_sym_inline] = ACTIONS(3467),
    [anon_sym___inline] = ACTIONS(3467),
    [anon_sym___inline__] = ACTIONS(3467),
    [anon_sym___forceinline] = ACTIONS(3467),
    [anon_sym_thread_local] = ACTIONS(3467),
    [anon_sym___thread] = ACTIONS(3467),
    [anon_sym_const] = ACTIONS(3467),
    [anon_sym_constexpr] = ACTIONS(3467),
    [anon_sym_volatile] = ACTIONS(3467),
    [anon_sym_restrict] = ACTIONS(3467),
    [anon_sym___restrict__] = ACTIONS(3467),
    [anon_sym__Atomic] = ACTIONS(3467),
    [anon_sym__Noreturn] = ACTIONS(3467),
    [anon_sym_noreturn] = ACTIONS(3467),
    [anon_sym_mutable] = ACTIONS(3467),
    [anon_sym_constinit] = ACTIONS(3467),
    [anon_sym_consteval] = ACTIONS(3467),
    [anon_sym_PROGMEM] = ACTIONS(3467),
    [aux_sym_primitive_type_token1] = ACTIONS(3467),
    [anon_sym_byte] = ACTIONS(3467),
    [anon_sym_word] = ACTIONS(3467),
    [anon_sym_enum] = ACTIONS(3467),
    [anon_sym_class] = ACTIONS(3467),
    [anon_sym_struct] = ACTIONS(3467),
    [anon_sym_union] = ACTIONS(3467),
    [anon_sym_if] = ACTIONS(3467),
    [anon_sym_switch] = ACTIONS(3467),
    [anon_sym_case] = ACTIONS(3467),
    [anon_sym_default] = ACTIONS(3467),
    [anon_sym_while] = ACTIONS(3467),
    [anon_sym_do] = ACTIONS(3467),
    [anon_sym_for] = ACTIONS(3467),
    [anon_sym_return] = ACTIONS(3467),
    [anon_sym_break] = ACTIONS(3467),
    [anon_sym_continue] = ACTIONS(3467),
    [anon_sym_goto] = ACTIONS(3467),
    [anon_sym___try] = ACTIONS(3467),
    [anon_sym___leave] = ACTIONS(3467),
    [anon_sym_not] = ACTIONS(3467),
    [anon_sym_compl] = ACTIONS(3467),
    [anon_sym_DASH_DASH] = ACTIONS(3469),
    [anon_sym_PLUS_PLUS] = ACTIONS(3469),
    [anon_sym_sizeof] = ACTIONS(3467),
    [anon_sym___alignof__] = ACTIONS(3467),
    [anon_sym___alignof] = ACTIONS(3467),
    [anon_sym__alignof] = ACTIONS(3467),
    [anon_sym_alignof] = ACTIONS(3467),
    [anon_sym__Alignof] = ACTIONS(3467),
    [anon_sym_offsetof] = ACTIONS(3467),
    [anon_sym__Generic] = ACTIONS(3467),
    [anon_sym_asm] = ACTIONS(3467),
    [anon_sym___asm__] = ACTIONS(3467),
    [aux_sym_number_literal_token1] = ACTIONS(3469),
    [aux_sym_number_literal_token2] = ACTIONS(3467),
    [anon_sym_L_SQUOTE] = ACTIONS(3469),
    [anon_sym_u_SQUOTE] = ACTIONS(3469),
    [anon_sym_U_SQUOTE] = ACTIONS(3469),
    [anon_sym_u8_SQUOTE] = ACTIONS(3469),
    [anon_sym_SQUOTE] = ACTIONS(3469),
    [anon_sym_L_DQUOTE] = ACTIONS(3469),
    [anon_sym_u_DQUOTE] = ACTIONS(3469),
    [anon_sym_U_DQUOTE] = ACTIONS(3469),
    [anon_sym_u8_DQUOTE] = ACTIONS(3469),
    [anon_sym_DQUOTE] = ACTIONS(3469),
    [sym_true] = ACTIONS(3467),
    [sym_false] = ACTIONS(3467),
    [anon_sym_NULL] = ACTIONS(3467),
    [anon_sym_nullptr] = ACTIONS(3467),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3467),
    [anon_sym_decltype] = ACTIONS(3467),
    [anon_sym_virtual] = ACTIONS(3467),
    [anon_sym_alignas] = ACTIONS(3467),
    [anon_sym_explicit] = ACTIONS(3467),
    [anon_sym_typename] = ACTIONS(3467),
    [anon_sym_template] = ACTIONS(3467),
    [anon_sym_operator] = ACTIONS(3467),
    [anon_sym_try] = ACTIONS(3467),
    [anon_sym_delete] = ACTIONS(3467),
    [anon_sym_throw] = ACTIONS(3467),
    [anon_sym_namespace] = ACTIONS(3467),
    [anon_sym_using] = ACTIONS(3467),
    [anon_sym_static_assert] = ACTIONS(3467),
    [anon_sym_concept] = ACTIONS(3467),
    [anon_sym_co_return] = ACTIONS(3467),
    [anon_sym_co_yield] = ACTIONS(3467),
    [anon_sym_R_DQUOTE] = ACTIONS(3469),
    [anon_sym_LR_DQUOTE] = ACTIONS(3469),
    [anon_sym_uR_DQUOTE] = ACTIONS(3469),
    [anon_sym_UR_DQUOTE] = ACTIONS(3469),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3469),
    [anon_sym_co_await] = ACTIONS(3467),
    [anon_sym_new] = ACTIONS(3467),
    [anon_sym_requires] = ACTIONS(3467),
    [sym_this] = ACTIONS(3467),
  },
  [911] = {
    [sym_catch_clause] = STATE(396),
    [aux_sym_constructor_try_statement_repeat1] = STATE(396),
    [ts_builtin_sym_end] = ACTIONS(2862),
    [sym_identifier] = ACTIONS(2860),
    [aux_sym_preproc_include_token1] = ACTIONS(2860),
    [aux_sym_preproc_def_token1] = ACTIONS(2860),
    [aux_sym_preproc_if_token1] = ACTIONS(2860),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2860),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2860),
    [sym_preproc_directive] = ACTIONS(2860),
    [anon_sym_LPAREN2] = ACTIONS(2862),
    [anon_sym_BANG] = ACTIONS(2862),
    [anon_sym_TILDE] = ACTIONS(2862),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP_AMP] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2860),
    [anon_sym___extension__] = ACTIONS(2860),
    [anon_sym_typedef] = ACTIONS(2860),
    [anon_sym_extern] = ACTIONS(2860),
    [anon_sym___attribute__] = ACTIONS(2860),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2862),
    [anon_sym___declspec] = ACTIONS(2860),
    [anon_sym___based] = ACTIONS(2860),
    [anon_sym___cdecl] = ACTIONS(2860),
    [anon_sym___clrcall] = ACTIONS(2860),
    [anon_sym___stdcall] = ACTIONS(2860),
    [anon_sym___fastcall] = ACTIONS(2860),
    [anon_sym___thiscall] = ACTIONS(2860),
    [anon_sym___vectorcall] = ACTIONS(2860),
    [anon_sym_LBRACE] = ACTIONS(2862),
    [anon_sym_signed] = ACTIONS(2860),
    [anon_sym_unsigned] = ACTIONS(2860),
    [anon_sym_long] = ACTIONS(2860),
    [anon_sym_short] = ACTIONS(2860),
    [anon_sym_LBRACK] = ACTIONS(2860),
    [anon_sym_static] = ACTIONS(2860),
    [anon_sym_register] = ACTIONS(2860),
    [anon_sym_inline] = ACTIONS(2860),
    [anon_sym___inline] = ACTIONS(2860),
    [anon_sym___inline__] = ACTIONS(2860),
    [anon_sym___forceinline] = ACTIONS(2860),
    [anon_sym_thread_local] = ACTIONS(2860),
    [anon_sym___thread] = ACTIONS(2860),
    [anon_sym_const] = ACTIONS(2860),
    [anon_sym_constexpr] = ACTIONS(2860),
    [anon_sym_volatile] = ACTIONS(2860),
    [anon_sym_restrict] = ACTIONS(2860),
    [anon_sym___restrict__] = ACTIONS(2860),
    [anon_sym__Atomic] = ACTIONS(2860),
    [anon_sym__Noreturn] = ACTIONS(2860),
    [anon_sym_noreturn] = ACTIONS(2860),
    [anon_sym_mutable] = ACTIONS(2860),
    [anon_sym_constinit] = ACTIONS(2860),
    [anon_sym_consteval] = ACTIONS(2860),
    [anon_sym_PROGMEM] = ACTIONS(2860),
    [aux_sym_primitive_type_token1] = ACTIONS(2860),
    [anon_sym_byte] = ACTIONS(2860),
    [anon_sym_word] = ACTIONS(2860),
    [anon_sym_enum] = ACTIONS(2860),
    [anon_sym_class] = ACTIONS(2860),
    [anon_sym_struct] = ACTIONS(2860),
    [anon_sym_union] = ACTIONS(2860),
    [anon_sym_if] = ACTIONS(2860),
    [anon_sym_switch] = ACTIONS(2860),
    [anon_sym_case] = ACTIONS(2860),
    [anon_sym_default] = ACTIONS(2860),
    [anon_sym_while] = ACTIONS(2860),
    [anon_sym_do] = ACTIONS(2860),
    [anon_sym_for] = ACTIONS(2860),
    [anon_sym_return] = ACTIONS(2860),
    [anon_sym_break] = ACTIONS(2860),
    [anon_sym_continue] = ACTIONS(2860),
    [anon_sym_goto] = ACTIONS(2860),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2862),
    [anon_sym_PLUS_PLUS] = ACTIONS(2862),
    [anon_sym_sizeof] = ACTIONS(2860),
    [anon_sym___alignof__] = ACTIONS(2860),
    [anon_sym___alignof] = ACTIONS(2860),
    [anon_sym__alignof] = ACTIONS(2860),
    [anon_sym_alignof] = ACTIONS(2860),
    [anon_sym__Alignof] = ACTIONS(2860),
    [anon_sym_offsetof] = ACTIONS(2860),
    [anon_sym__Generic] = ACTIONS(2860),
    [anon_sym_asm] = ACTIONS(2860),
    [anon_sym___asm__] = ACTIONS(2860),
    [aux_sym_number_literal_token1] = ACTIONS(2862),
    [aux_sym_number_literal_token2] = ACTIONS(2860),
    [anon_sym_L_SQUOTE] = ACTIONS(2862),
    [anon_sym_u_SQUOTE] = ACTIONS(2862),
    [anon_sym_U_SQUOTE] = ACTIONS(2862),
    [anon_sym_u8_SQUOTE] = ACTIONS(2862),
    [anon_sym_SQUOTE] = ACTIONS(2862),
    [anon_sym_L_DQUOTE] = ACTIONS(2862),
    [anon_sym_u_DQUOTE] = ACTIONS(2862),
    [anon_sym_U_DQUOTE] = ACTIONS(2862),
    [anon_sym_u8_DQUOTE] = ACTIONS(2862),
    [anon_sym_DQUOTE] = ACTIONS(2862),
    [sym_true] = ACTIONS(2860),
    [sym_false] = ACTIONS(2860),
    [anon_sym_NULL] = ACTIONS(2860),
    [anon_sym_nullptr] = ACTIONS(2860),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2860),
    [anon_sym_decltype] = ACTIONS(2860),
    [anon_sym_virtual] = ACTIONS(2860),
    [anon_sym_alignas] = ACTIONS(2860),
    [anon_sym_explicit] = ACTIONS(2860),
    [anon_sym_typename] = ACTIONS(2860),
    [anon_sym_template] = ACTIONS(2860),
    [anon_sym_operator] = ACTIONS(2860),
    [anon_sym_try] = ACTIONS(2860),
    [anon_sym_delete] = ACTIONS(2860),
    [anon_sym_throw] = ACTIONS(2860),
    [anon_sym_namespace] = ACTIONS(2860),
    [anon_sym_using] = ACTIONS(2860),
    [anon_sym_static_assert] = ACTIONS(2860),
    [anon_sym_concept] = ACTIONS(2860),
    [anon_sym_co_return] = ACTIONS(2860),
    [anon_sym_co_yield] = ACTIONS(2860),
    [anon_sym_catch] = ACTIONS(3507),
    [anon_sym_R_DQUOTE] = ACTIONS(2862),
    [anon_sym_LR_DQUOTE] = ACTIONS(2862),
    [anon_sym_uR_DQUOTE] = ACTIONS(2862),
    [anon_sym_UR_DQUOTE] = ACTIONS(2862),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2862),
    [anon_sym_co_await] = ACTIONS(2860),
    [anon_sym_new] = ACTIONS(2860),
    [anon_sym_requires] = ACTIONS(2860),
    [sym_this] = ACTIONS(2860),
  },
  [912] = {
    [sym_identifier] = ACTIONS(3471),
    [aux_sym_preproc_include_token1] = ACTIONS(3471),
    [aux_sym_preproc_def_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token1] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3471),
    [sym_preproc_directive] = ACTIONS(3471),
    [anon_sym_LPAREN2] = ACTIONS(3473),
    [anon_sym_BANG] = ACTIONS(3473),
    [anon_sym_TILDE] = ACTIONS(3473),
    [anon_sym_DASH] = ACTIONS(3471),
    [anon_sym_PLUS] = ACTIONS(3471),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_AMP_AMP] = ACTIONS(3473),
    [anon_sym_AMP] = ACTIONS(3471),
    [anon_sym_SEMI] = ACTIONS(3473),
    [anon_sym___extension__] = ACTIONS(3471),
    [anon_sym_typedef] = ACTIONS(3471),
    [anon_sym_extern] = ACTIONS(3471),
    [anon_sym___attribute__] = ACTIONS(3471),
    [anon_sym_COLON_COLON] = ACTIONS(3473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3473),
    [anon_sym___declspec] = ACTIONS(3471),
    [anon_sym___based] = ACTIONS(3471),
    [anon_sym___cdecl] = ACTIONS(3471),
    [anon_sym___clrcall] = ACTIONS(3471),
    [anon_sym___stdcall] = ACTIONS(3471),
    [anon_sym___fastcall] = ACTIONS(3471),
    [anon_sym___thiscall] = ACTIONS(3471),
    [anon_sym___vectorcall] = ACTIONS(3471),
    [anon_sym_LBRACE] = ACTIONS(3473),
    [anon_sym_RBRACE] = ACTIONS(3473),
    [anon_sym_signed] = ACTIONS(3471),
    [anon_sym_unsigned] = ACTIONS(3471),
    [anon_sym_long] = ACTIONS(3471),
    [anon_sym_short] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [anon_sym_static] = ACTIONS(3471),
    [anon_sym_register] = ACTIONS(3471),
    [anon_sym_inline] = ACTIONS(3471),
    [anon_sym___inline] = ACTIONS(3471),
    [anon_sym___inline__] = ACTIONS(3471),
    [anon_sym___forceinline] = ACTIONS(3471),
    [anon_sym_thread_local] = ACTIONS(3471),
    [anon_sym___thread] = ACTIONS(3471),
    [anon_sym_const] = ACTIONS(3471),
    [anon_sym_constexpr] = ACTIONS(3471),
    [anon_sym_volatile] = ACTIONS(3471),
    [anon_sym_restrict] = ACTIONS(3471),
    [anon_sym___restrict__] = ACTIONS(3471),
    [anon_sym__Atomic] = ACTIONS(3471),
    [anon_sym__Noreturn] = ACTIONS(3471),
    [anon_sym_noreturn] = ACTIONS(3471),
    [anon_sym_mutable] = ACTIONS(3471),
    [anon_sym_constinit] = ACTIONS(3471),
    [anon_sym_consteval] = ACTIONS(3471),
    [anon_sym_PROGMEM] = ACTIONS(3471),
    [aux_sym_primitive_type_token1] = ACTIONS(3471),
    [anon_sym_byte] = ACTIONS(3471),
    [anon_sym_word] = ACTIONS(3471),
    [anon_sym_enum] = ACTIONS(3471),
    [anon_sym_class] = ACTIONS(3471),
    [anon_sym_struct] = ACTIONS(3471),
    [anon_sym_union] = ACTIONS(3471),
    [anon_sym_if] = ACTIONS(3471),
    [anon_sym_switch] = ACTIONS(3471),
    [anon_sym_case] = ACTIONS(3471),
    [anon_sym_default] = ACTIONS(3471),
    [anon_sym_while] = ACTIONS(3471),
    [anon_sym_do] = ACTIONS(3471),
    [anon_sym_for] = ACTIONS(3471),
    [anon_sym_return] = ACTIONS(3471),
    [anon_sym_break] = ACTIONS(3471),
    [anon_sym_continue] = ACTIONS(3471),
    [anon_sym_goto] = ACTIONS(3471),
    [anon_sym___try] = ACTIONS(3471),
    [anon_sym___leave] = ACTIONS(3471),
    [anon_sym_not] = ACTIONS(3471),
    [anon_sym_compl] = ACTIONS(3471),
    [anon_sym_DASH_DASH] = ACTIONS(3473),
    [anon_sym_PLUS_PLUS] = ACTIONS(3473),
    [anon_sym_sizeof] = ACTIONS(3471),
    [anon_sym___alignof__] = ACTIONS(3471),
    [anon_sym___alignof] = ACTIONS(3471),
    [anon_sym__alignof] = ACTIONS(3471),
    [anon_sym_alignof] = ACTIONS(3471),
    [anon_sym__Alignof] = ACTIONS(3471),
    [anon_sym_offsetof] = ACTIONS(3471),
    [anon_sym__Generic] = ACTIONS(3471),
    [anon_sym_asm] = ACTIONS(3471),
    [anon_sym___asm__] = ACTIONS(3471),
    [aux_sym_number_literal_token1] = ACTIONS(3473),
    [aux_sym_number_literal_token2] = ACTIONS(3471),
    [anon_sym_L_SQUOTE] = ACTIONS(3473),
    [anon_sym_u_SQUOTE] = ACTIONS(3473),
    [anon_sym_U_SQUOTE] = ACTIONS(3473),
    [anon_sym_u8_SQUOTE] = ACTIONS(3473),
    [anon_sym_SQUOTE] = ACTIONS(3473),
    [anon_sym_L_DQUOTE] = ACTIONS(3473),
    [anon_sym_u_DQUOTE] = ACTIONS(3473),
    [anon_sym_U_DQUOTE] = ACTIONS(3473),
    [anon_sym_u8_DQUOTE] = ACTIONS(3473),
    [anon_sym_DQUOTE] = ACTIONS(3473),
    [sym_true] = ACTIONS(3471),
    [sym_false] = ACTIONS(3471),
    [anon_sym_NULL] = ACTIONS(3471),
    [anon_sym_nullptr] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3471),
    [anon_sym_decltype] = ACTIONS(3471),
    [anon_sym_virtual] = ACTIONS(3471),
    [anon_sym_alignas] = ACTIONS(3471),
    [anon_sym_explicit] = ACTIONS(3471),
    [anon_sym_typename] = ACTIONS(3471),
    [anon_sym_template] = ACTIONS(3471),
    [anon_sym_operator] = ACTIONS(3471),
    [anon_sym_try] = ACTIONS(3471),
    [anon_sym_delete] = ACTIONS(3471),
    [anon_sym_throw] = ACTIONS(3471),
    [anon_sym_namespace] = ACTIONS(3471),
    [anon_sym_using] = ACTIONS(3471),
    [anon_sym_static_assert] = ACTIONS(3471),
    [anon_sym_concept] = ACTIONS(3471),
    [anon_sym_co_return] = ACTIONS(3471),
    [anon_sym_co_yield] = ACTIONS(3471),
    [anon_sym_R_DQUOTE] = ACTIONS(3473),
    [anon_sym_LR_DQUOTE] = ACTIONS(3473),
    [anon_sym_uR_DQUOTE] = ACTIONS(3473),
    [anon_sym_UR_DQUOTE] = ACTIONS(3473),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3473),
    [anon_sym_co_await] = ACTIONS(3471),
    [anon_sym_new] = ACTIONS(3471),
    [anon_sym_requires] = ACTIONS(3471),
    [sym_this] = ACTIONS(3471),
  },
  [913] = {
    [sym_identifier] = ACTIONS(3367),
    [aux_sym_preproc_include_token1] = ACTIONS(3367),
    [aux_sym_preproc_def_token1] = ACTIONS(3367),
    [aux_sym_preproc_if_token1] = ACTIONS(3367),
    [aux_sym_preproc_if_token2] = ACTIONS(3367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3367),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3367),
    [sym_preproc_directive] = ACTIONS(3367),
    [anon_sym_LPAREN2] = ACTIONS(3369),
    [anon_sym_BANG] = ACTIONS(3369),
    [anon_sym_TILDE] = ACTIONS(3369),
    [anon_sym_DASH] = ACTIONS(3367),
    [anon_sym_PLUS] = ACTIONS(3367),
    [anon_sym_STAR] = ACTIONS(3369),
    [anon_sym_AMP_AMP] = ACTIONS(3369),
    [anon_sym_AMP] = ACTIONS(3367),
    [anon_sym_SEMI] = ACTIONS(3369),
    [anon_sym___extension__] = ACTIONS(3367),
    [anon_sym_typedef] = ACTIONS(3367),
    [anon_sym_extern] = ACTIONS(3367),
    [anon_sym___attribute__] = ACTIONS(3367),
    [anon_sym_COLON_COLON] = ACTIONS(3369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3369),
    [anon_sym___declspec] = ACTIONS(3367),
    [anon_sym___based] = ACTIONS(3367),
    [anon_sym___cdecl] = ACTIONS(3367),
    [anon_sym___clrcall] = ACTIONS(3367),
    [anon_sym___stdcall] = ACTIONS(3367),
    [anon_sym___fastcall] = ACTIONS(3367),
    [anon_sym___thiscall] = ACTIONS(3367),
    [anon_sym___vectorcall] = ACTIONS(3367),
    [anon_sym_LBRACE] = ACTIONS(3369),
    [anon_sym_signed] = ACTIONS(3367),
    [anon_sym_unsigned] = ACTIONS(3367),
    [anon_sym_long] = ACTIONS(3367),
    [anon_sym_short] = ACTIONS(3367),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_static] = ACTIONS(3367),
    [anon_sym_register] = ACTIONS(3367),
    [anon_sym_inline] = ACTIONS(3367),
    [anon_sym___inline] = ACTIONS(3367),
    [anon_sym___inline__] = ACTIONS(3367),
    [anon_sym___forceinline] = ACTIONS(3367),
    [anon_sym_thread_local] = ACTIONS(3367),
    [anon_sym___thread] = ACTIONS(3367),
    [anon_sym_const] = ACTIONS(3367),
    [anon_sym_constexpr] = ACTIONS(3367),
    [anon_sym_volatile] = ACTIONS(3367),
    [anon_sym_restrict] = ACTIONS(3367),
    [anon_sym___restrict__] = ACTIONS(3367),
    [anon_sym__Atomic] = ACTIONS(3367),
    [anon_sym__Noreturn] = ACTIONS(3367),
    [anon_sym_noreturn] = ACTIONS(3367),
    [anon_sym_mutable] = ACTIONS(3367),
    [anon_sym_constinit] = ACTIONS(3367),
    [anon_sym_consteval] = ACTIONS(3367),
    [anon_sym_PROGMEM] = ACTIONS(3367),
    [aux_sym_primitive_type_token1] = ACTIONS(3367),
    [anon_sym_byte] = ACTIONS(3367),
    [anon_sym_word] = ACTIONS(3367),
    [anon_sym_enum] = ACTIONS(3367),
    [anon_sym_class] = ACTIONS(3367),
    [anon_sym_struct] = ACTIONS(3367),
    [anon_sym_union] = ACTIONS(3367),
    [anon_sym_if] = ACTIONS(3367),
    [anon_sym_switch] = ACTIONS(3367),
    [anon_sym_case] = ACTIONS(3367),
    [anon_sym_default] = ACTIONS(3367),
    [anon_sym_while] = ACTIONS(3367),
    [anon_sym_do] = ACTIONS(3367),
    [anon_sym_for] = ACTIONS(3367),
    [anon_sym_return] = ACTIONS(3367),
    [anon_sym_break] = ACTIONS(3367),
    [anon_sym_continue] = ACTIONS(3367),
    [anon_sym_goto] = ACTIONS(3367),
    [anon_sym___try] = ACTIONS(3367),
    [anon_sym___leave] = ACTIONS(3367),
    [anon_sym_not] = ACTIONS(3367),
    [anon_sym_compl] = ACTIONS(3367),
    [anon_sym_DASH_DASH] = ACTIONS(3369),
    [anon_sym_PLUS_PLUS] = ACTIONS(3369),
    [anon_sym_sizeof] = ACTIONS(3367),
    [anon_sym___alignof__] = ACTIONS(3367),
    [anon_sym___alignof] = ACTIONS(3367),
    [anon_sym__alignof] = ACTIONS(3367),
    [anon_sym_alignof] = ACTIONS(3367),
    [anon_sym__Alignof] = ACTIONS(3367),
    [anon_sym_offsetof] = ACTIONS(3367),
    [anon_sym__Generic] = ACTIONS(3367),
    [anon_sym_asm] = ACTIONS(3367),
    [anon_sym___asm__] = ACTIONS(3367),
    [aux_sym_number_literal_token1] = ACTIONS(3369),
    [aux_sym_number_literal_token2] = ACTIONS(3367),
    [anon_sym_L_SQUOTE] = ACTIONS(3369),
    [anon_sym_u_SQUOTE] = ACTIONS(3369),
    [anon_sym_U_SQUOTE] = ACTIONS(3369),
    [anon_sym_u8_SQUOTE] = ACTIONS(3369),
    [anon_sym_SQUOTE] = ACTIONS(3369),
    [anon_sym_L_DQUOTE] = ACTIONS(3369),
    [anon_sym_u_DQUOTE] = ACTIONS(3369),
    [anon_sym_U_DQUOTE] = ACTIONS(3369),
    [anon_sym_u8_DQUOTE] = ACTIONS(3369),
    [anon_sym_DQUOTE] = ACTIONS(3369),
    [sym_true] = ACTIONS(3367),
    [sym_false] = ACTIONS(3367),
    [anon_sym_NULL] = ACTIONS(3367),
    [anon_sym_nullptr] = ACTIONS(3367),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3367),
    [anon_sym_decltype] = ACTIONS(3367),
    [anon_sym_virtual] = ACTIONS(3367),
    [anon_sym_alignas] = ACTIONS(3367),
    [anon_sym_explicit] = ACTIONS(3367),
    [anon_sym_typename] = ACTIONS(3367),
    [anon_sym_template] = ACTIONS(3367),
    [anon_sym_operator] = ACTIONS(3367),
    [anon_sym_try] = ACTIONS(3367),
    [anon_sym_delete] = ACTIONS(3367),
    [anon_sym_throw] = ACTIONS(3367),
    [anon_sym_namespace] = ACTIONS(3367),
    [anon_sym_using] = ACTIONS(3367),
    [anon_sym_static_assert] = ACTIONS(3367),
    [anon_sym_concept] = ACTIONS(3367),
    [anon_sym_co_return] = ACTIONS(3367),
    [anon_sym_co_yield] = ACTIONS(3367),
    [anon_sym_R_DQUOTE] = ACTIONS(3369),
    [anon_sym_LR_DQUOTE] = ACTIONS(3369),
    [anon_sym_uR_DQUOTE] = ACTIONS(3369),
    [anon_sym_UR_DQUOTE] = ACTIONS(3369),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3369),
    [anon_sym_co_await] = ACTIONS(3367),
    [anon_sym_new] = ACTIONS(3367),
    [anon_sym_requires] = ACTIONS(3367),
    [sym_this] = ACTIONS(3367),
  },
  [914] = {
    [sym_identifier] = ACTIONS(3336),
    [aux_sym_preproc_include_token1] = ACTIONS(3336),
    [aux_sym_preproc_def_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token1] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3336),
    [sym_preproc_directive] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_BANG] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_SEMI] = ACTIONS(3338),
    [anon_sym___extension__] = ACTIONS(3336),
    [anon_sym_typedef] = ACTIONS(3336),
    [anon_sym_extern] = ACTIONS(3336),
    [anon_sym___attribute__] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3338),
    [anon_sym___declspec] = ACTIONS(3336),
    [anon_sym___based] = ACTIONS(3336),
    [anon_sym___cdecl] = ACTIONS(3336),
    [anon_sym___clrcall] = ACTIONS(3336),
    [anon_sym___stdcall] = ACTIONS(3336),
    [anon_sym___fastcall] = ACTIONS(3336),
    [anon_sym___thiscall] = ACTIONS(3336),
    [anon_sym___vectorcall] = ACTIONS(3336),
    [anon_sym_LBRACE] = ACTIONS(3338),
    [anon_sym_RBRACE] = ACTIONS(3338),
    [anon_sym_signed] = ACTIONS(3336),
    [anon_sym_unsigned] = ACTIONS(3336),
    [anon_sym_long] = ACTIONS(3336),
    [anon_sym_short] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_static] = ACTIONS(3336),
    [anon_sym_register] = ACTIONS(3336),
    [anon_sym_inline] = ACTIONS(3336),
    [anon_sym___inline] = ACTIONS(3336),
    [anon_sym___inline__] = ACTIONS(3336),
    [anon_sym___forceinline] = ACTIONS(3336),
    [anon_sym_thread_local] = ACTIONS(3336),
    [anon_sym___thread] = ACTIONS(3336),
    [anon_sym_const] = ACTIONS(3336),
    [anon_sym_constexpr] = ACTIONS(3336),
    [anon_sym_volatile] = ACTIONS(3336),
    [anon_sym_restrict] = ACTIONS(3336),
    [anon_sym___restrict__] = ACTIONS(3336),
    [anon_sym__Atomic] = ACTIONS(3336),
    [anon_sym__Noreturn] = ACTIONS(3336),
    [anon_sym_noreturn] = ACTIONS(3336),
    [anon_sym_mutable] = ACTIONS(3336),
    [anon_sym_constinit] = ACTIONS(3336),
    [anon_sym_consteval] = ACTIONS(3336),
    [anon_sym_PROGMEM] = ACTIONS(3336),
    [aux_sym_primitive_type_token1] = ACTIONS(3336),
    [anon_sym_byte] = ACTIONS(3336),
    [anon_sym_word] = ACTIONS(3336),
    [anon_sym_enum] = ACTIONS(3336),
    [anon_sym_class] = ACTIONS(3336),
    [anon_sym_struct] = ACTIONS(3336),
    [anon_sym_union] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_switch] = ACTIONS(3336),
    [anon_sym_case] = ACTIONS(3336),
    [anon_sym_default] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_break] = ACTIONS(3336),
    [anon_sym_continue] = ACTIONS(3336),
    [anon_sym_goto] = ACTIONS(3336),
    [anon_sym___try] = ACTIONS(3336),
    [anon_sym___leave] = ACTIONS(3336),
    [anon_sym_not] = ACTIONS(3336),
    [anon_sym_compl] = ACTIONS(3336),
    [anon_sym_DASH_DASH] = ACTIONS(3338),
    [anon_sym_PLUS_PLUS] = ACTIONS(3338),
    [anon_sym_sizeof] = ACTIONS(3336),
    [anon_sym___alignof__] = ACTIONS(3336),
    [anon_sym___alignof] = ACTIONS(3336),
    [anon_sym__alignof] = ACTIONS(3336),
    [anon_sym_alignof] = ACTIONS(3336),
    [anon_sym__Alignof] = ACTIONS(3336),
    [anon_sym_offsetof] = ACTIONS(3336),
    [anon_sym__Generic] = ACTIONS(3336),
    [anon_sym_asm] = ACTIONS(3336),
    [anon_sym___asm__] = ACTIONS(3336),
    [aux_sym_number_literal_token1] = ACTIONS(3338),
    [aux_sym_number_literal_token2] = ACTIONS(3336),
    [anon_sym_L_SQUOTE] = ACTIONS(3338),
    [anon_sym_u_SQUOTE] = ACTIONS(3338),
    [anon_sym_U_SQUOTE] = ACTIONS(3338),
    [anon_sym_u8_SQUOTE] = ACTIONS(3338),
    [anon_sym_SQUOTE] = ACTIONS(3338),
    [anon_sym_L_DQUOTE] = ACTIONS(3338),
    [anon_sym_u_DQUOTE] = ACTIONS(3338),
    [anon_sym_U_DQUOTE] = ACTIONS(3338),
    [anon_sym_u8_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE] = ACTIONS(3338),
    [sym_true] = ACTIONS(3336),
    [sym_false] = ACTIONS(3336),
    [anon_sym_NULL] = ACTIONS(3336),
    [anon_sym_nullptr] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3336),
    [anon_sym_decltype] = ACTIONS(3336),
    [anon_sym_virtual] = ACTIONS(3336),
    [anon_sym_alignas] = ACTIONS(3336),
    [anon_sym_explicit] = ACTIONS(3336),
    [anon_sym_typename] = ACTIONS(3336),
    [anon_sym_template] = ACTIONS(3336),
    [anon_sym_operator] = ACTIONS(3336),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_delete] = ACTIONS(3336),
    [anon_sym_throw] = ACTIONS(3336),
    [anon_sym_namespace] = ACTIONS(3336),
    [anon_sym_using] = ACTIONS(3336),
    [anon_sym_static_assert] = ACTIONS(3336),
    [anon_sym_concept] = ACTIONS(3336),
    [anon_sym_co_return] = ACTIONS(3336),
    [anon_sym_co_yield] = ACTIONS(3336),
    [anon_sym_R_DQUOTE] = ACTIONS(3338),
    [anon_sym_LR_DQUOTE] = ACTIONS(3338),
    [anon_sym_uR_DQUOTE] = ACTIONS(3338),
    [anon_sym_UR_DQUOTE] = ACTIONS(3338),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3338),
    [anon_sym_co_await] = ACTIONS(3336),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_requires] = ACTIONS(3336),
    [sym_this] = ACTIONS(3336),
  },
  [915] = {
    [sym_identifier] = ACTIONS(3361),
    [aux_sym_preproc_include_token1] = ACTIONS(3361),
    [aux_sym_preproc_def_token1] = ACTIONS(3361),
    [aux_sym_preproc_if_token1] = ACTIONS(3361),
    [aux_sym_preproc_if_token2] = ACTIONS(3361),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3361),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3361),
    [sym_preproc_directive] = ACTIONS(3361),
    [anon_sym_LPAREN2] = ACTIONS(3363),
    [anon_sym_BANG] = ACTIONS(3363),
    [anon_sym_TILDE] = ACTIONS(3363),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_STAR] = ACTIONS(3363),
    [anon_sym_AMP_AMP] = ACTIONS(3363),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_SEMI] = ACTIONS(3363),
    [anon_sym___extension__] = ACTIONS(3361),
    [anon_sym_typedef] = ACTIONS(3361),
    [anon_sym_extern] = ACTIONS(3361),
    [anon_sym___attribute__] = ACTIONS(3361),
    [anon_sym_COLON_COLON] = ACTIONS(3363),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3363),
    [anon_sym___declspec] = ACTIONS(3361),
    [anon_sym___based] = ACTIONS(3361),
    [anon_sym___cdecl] = ACTIONS(3361),
    [anon_sym___clrcall] = ACTIONS(3361),
    [anon_sym___stdcall] = ACTIONS(3361),
    [anon_sym___fastcall] = ACTIONS(3361),
    [anon_sym___thiscall] = ACTIONS(3361),
    [anon_sym___vectorcall] = ACTIONS(3361),
    [anon_sym_LBRACE] = ACTIONS(3363),
    [anon_sym_signed] = ACTIONS(3361),
    [anon_sym_unsigned] = ACTIONS(3361),
    [anon_sym_long] = ACTIONS(3361),
    [anon_sym_short] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_static] = ACTIONS(3361),
    [anon_sym_register] = ACTIONS(3361),
    [anon_sym_inline] = ACTIONS(3361),
    [anon_sym___inline] = ACTIONS(3361),
    [anon_sym___inline__] = ACTIONS(3361),
    [anon_sym___forceinline] = ACTIONS(3361),
    [anon_sym_thread_local] = ACTIONS(3361),
    [anon_sym___thread] = ACTIONS(3361),
    [anon_sym_const] = ACTIONS(3361),
    [anon_sym_constexpr] = ACTIONS(3361),
    [anon_sym_volatile] = ACTIONS(3361),
    [anon_sym_restrict] = ACTIONS(3361),
    [anon_sym___restrict__] = ACTIONS(3361),
    [anon_sym__Atomic] = ACTIONS(3361),
    [anon_sym__Noreturn] = ACTIONS(3361),
    [anon_sym_noreturn] = ACTIONS(3361),
    [anon_sym_mutable] = ACTIONS(3361),
    [anon_sym_constinit] = ACTIONS(3361),
    [anon_sym_consteval] = ACTIONS(3361),
    [anon_sym_PROGMEM] = ACTIONS(3361),
    [aux_sym_primitive_type_token1] = ACTIONS(3361),
    [anon_sym_byte] = ACTIONS(3361),
    [anon_sym_word] = ACTIONS(3361),
    [anon_sym_enum] = ACTIONS(3361),
    [anon_sym_class] = ACTIONS(3361),
    [anon_sym_struct] = ACTIONS(3361),
    [anon_sym_union] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_switch] = ACTIONS(3361),
    [anon_sym_case] = ACTIONS(3361),
    [anon_sym_default] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_break] = ACTIONS(3361),
    [anon_sym_continue] = ACTIONS(3361),
    [anon_sym_goto] = ACTIONS(3361),
    [anon_sym___try] = ACTIONS(3361),
    [anon_sym___leave] = ACTIONS(3361),
    [anon_sym_not] = ACTIONS(3361),
    [anon_sym_compl] = ACTIONS(3361),
    [anon_sym_DASH_DASH] = ACTIONS(3363),
    [anon_sym_PLUS_PLUS] = ACTIONS(3363),
    [anon_sym_sizeof] = ACTIONS(3361),
    [anon_sym___alignof__] = ACTIONS(3361),
    [anon_sym___alignof] = ACTIONS(3361),
    [anon_sym__alignof] = ACTIONS(3361),
    [anon_sym_alignof] = ACTIONS(3361),
    [anon_sym__Alignof] = ACTIONS(3361),
    [anon_sym_offsetof] = ACTIONS(3361),
    [anon_sym__Generic] = ACTIONS(3361),
    [anon_sym_asm] = ACTIONS(3361),
    [anon_sym___asm__] = ACTIONS(3361),
    [aux_sym_number_literal_token1] = ACTIONS(3363),
    [aux_sym_number_literal_token2] = ACTIONS(3361),
    [anon_sym_L_SQUOTE] = ACTIONS(3363),
    [anon_sym_u_SQUOTE] = ACTIONS(3363),
    [anon_sym_U_SQUOTE] = ACTIONS(3363),
    [anon_sym_u8_SQUOTE] = ACTIONS(3363),
    [anon_sym_SQUOTE] = ACTIONS(3363),
    [anon_sym_L_DQUOTE] = ACTIONS(3363),
    [anon_sym_u_DQUOTE] = ACTIONS(3363),
    [anon_sym_U_DQUOTE] = ACTIONS(3363),
    [anon_sym_u8_DQUOTE] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3363),
    [sym_true] = ACTIONS(3361),
    [sym_false] = ACTIONS(3361),
    [anon_sym_NULL] = ACTIONS(3361),
    [anon_sym_nullptr] = ACTIONS(3361),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3361),
    [anon_sym_decltype] = ACTIONS(3361),
    [anon_sym_virtual] = ACTIONS(3361),
    [anon_sym_alignas] = ACTIONS(3361),
    [anon_sym_explicit] = ACTIONS(3361),
    [anon_sym_typename] = ACTIONS(3361),
    [anon_sym_template] = ACTIONS(3361),
    [anon_sym_operator] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_delete] = ACTIONS(3361),
    [anon_sym_throw] = ACTIONS(3361),
    [anon_sym_namespace] = ACTIONS(3361),
    [anon_sym_using] = ACTIONS(3361),
    [anon_sym_static_assert] = ACTIONS(3361),
    [anon_sym_concept] = ACTIONS(3361),
    [anon_sym_co_return] = ACTIONS(3361),
    [anon_sym_co_yield] = ACTIONS(3361),
    [anon_sym_R_DQUOTE] = ACTIONS(3363),
    [anon_sym_LR_DQUOTE] = ACTIONS(3363),
    [anon_sym_uR_DQUOTE] = ACTIONS(3363),
    [anon_sym_UR_DQUOTE] = ACTIONS(3363),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3363),
    [anon_sym_co_await] = ACTIONS(3361),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_requires] = ACTIONS(3361),
    [sym_this] = ACTIONS(3361),
  },
  [916] = {
    [sym_identifier] = ACTIONS(3357),
    [aux_sym_preproc_include_token1] = ACTIONS(3357),
    [aux_sym_preproc_def_token1] = ACTIONS(3357),
    [aux_sym_preproc_if_token1] = ACTIONS(3357),
    [aux_sym_preproc_if_token2] = ACTIONS(3357),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3357),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3357),
    [sym_preproc_directive] = ACTIONS(3357),
    [anon_sym_LPAREN2] = ACTIONS(3359),
    [anon_sym_BANG] = ACTIONS(3359),
    [anon_sym_TILDE] = ACTIONS(3359),
    [anon_sym_DASH] = ACTIONS(3357),
    [anon_sym_PLUS] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(3359),
    [anon_sym_AMP_AMP] = ACTIONS(3359),
    [anon_sym_AMP] = ACTIONS(3357),
    [anon_sym_SEMI] = ACTIONS(3359),
    [anon_sym___extension__] = ACTIONS(3357),
    [anon_sym_typedef] = ACTIONS(3357),
    [anon_sym_extern] = ACTIONS(3357),
    [anon_sym___attribute__] = ACTIONS(3357),
    [anon_sym_COLON_COLON] = ACTIONS(3359),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3359),
    [anon_sym___declspec] = ACTIONS(3357),
    [anon_sym___based] = ACTIONS(3357),
    [anon_sym___cdecl] = ACTIONS(3357),
    [anon_sym___clrcall] = ACTIONS(3357),
    [anon_sym___stdcall] = ACTIONS(3357),
    [anon_sym___fastcall] = ACTIONS(3357),
    [anon_sym___thiscall] = ACTIONS(3357),
    [anon_sym___vectorcall] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3359),
    [anon_sym_signed] = ACTIONS(3357),
    [anon_sym_unsigned] = ACTIONS(3357),
    [anon_sym_long] = ACTIONS(3357),
    [anon_sym_short] = ACTIONS(3357),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_static] = ACTIONS(3357),
    [anon_sym_register] = ACTIONS(3357),
    [anon_sym_inline] = ACTIONS(3357),
    [anon_sym___inline] = ACTIONS(3357),
    [anon_sym___inline__] = ACTIONS(3357),
    [anon_sym___forceinline] = ACTIONS(3357),
    [anon_sym_thread_local] = ACTIONS(3357),
    [anon_sym___thread] = ACTIONS(3357),
    [anon_sym_const] = ACTIONS(3357),
    [anon_sym_constexpr] = ACTIONS(3357),
    [anon_sym_volatile] = ACTIONS(3357),
    [anon_sym_restrict] = ACTIONS(3357),
    [anon_sym___restrict__] = ACTIONS(3357),
    [anon_sym__Atomic] = ACTIONS(3357),
    [anon_sym__Noreturn] = ACTIONS(3357),
    [anon_sym_noreturn] = ACTIONS(3357),
    [anon_sym_mutable] = ACTIONS(3357),
    [anon_sym_constinit] = ACTIONS(3357),
    [anon_sym_consteval] = ACTIONS(3357),
    [anon_sym_PROGMEM] = ACTIONS(3357),
    [aux_sym_primitive_type_token1] = ACTIONS(3357),
    [anon_sym_byte] = ACTIONS(3357),
    [anon_sym_word] = ACTIONS(3357),
    [anon_sym_enum] = ACTIONS(3357),
    [anon_sym_class] = ACTIONS(3357),
    [anon_sym_struct] = ACTIONS(3357),
    [anon_sym_union] = ACTIONS(3357),
    [anon_sym_if] = ACTIONS(3357),
    [anon_sym_switch] = ACTIONS(3357),
    [anon_sym_case] = ACTIONS(3357),
    [anon_sym_default] = ACTIONS(3357),
    [anon_sym_while] = ACTIONS(3357),
    [anon_sym_do] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3357),
    [anon_sym_return] = ACTIONS(3357),
    [anon_sym_break] = ACTIONS(3357),
    [anon_sym_continue] = ACTIONS(3357),
    [anon_sym_goto] = ACTIONS(3357),
    [anon_sym___try] = ACTIONS(3357),
    [anon_sym___leave] = ACTIONS(3357),
    [anon_sym_not] = ACTIONS(3357),
    [anon_sym_compl] = ACTIONS(3357),
    [anon_sym_DASH_DASH] = ACTIONS(3359),
    [anon_sym_PLUS_PLUS] = ACTIONS(3359),
    [anon_sym_sizeof] = ACTIONS(3357),
    [anon_sym___alignof__] = ACTIONS(3357),
    [anon_sym___alignof] = ACTIONS(3357),
    [anon_sym__alignof] = ACTIONS(3357),
    [anon_sym_alignof] = ACTIONS(3357),
    [anon_sym__Alignof] = ACTIONS(3357),
    [anon_sym_offsetof] = ACTIONS(3357),
    [anon_sym__Generic] = ACTIONS(3357),
    [anon_sym_asm] = ACTIONS(3357),
    [anon_sym___asm__] = ACTIONS(3357),
    [aux_sym_number_literal_token1] = ACTIONS(3359),
    [aux_sym_number_literal_token2] = ACTIONS(3357),
    [anon_sym_L_SQUOTE] = ACTIONS(3359),
    [anon_sym_u_SQUOTE] = ACTIONS(3359),
    [anon_sym_U_SQUOTE] = ACTIONS(3359),
    [anon_sym_u8_SQUOTE] = ACTIONS(3359),
    [anon_sym_SQUOTE] = ACTIONS(3359),
    [anon_sym_L_DQUOTE] = ACTIONS(3359),
    [anon_sym_u_DQUOTE] = ACTIONS(3359),
    [anon_sym_U_DQUOTE] = ACTIONS(3359),
    [anon_sym_u8_DQUOTE] = ACTIONS(3359),
    [anon_sym_DQUOTE] = ACTIONS(3359),
    [sym_true] = ACTIONS(3357),
    [sym_false] = ACTIONS(3357),
    [anon_sym_NULL] = ACTIONS(3357),
    [anon_sym_nullptr] = ACTIONS(3357),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3357),
    [anon_sym_decltype] = ACTIONS(3357),
    [anon_sym_virtual] = ACTIONS(3357),
    [anon_sym_alignas] = ACTIONS(3357),
    [anon_sym_explicit] = ACTIONS(3357),
    [anon_sym_typename] = ACTIONS(3357),
    [anon_sym_template] = ACTIONS(3357),
    [anon_sym_operator] = ACTIONS(3357),
    [anon_sym_try] = ACTIONS(3357),
    [anon_sym_delete] = ACTIONS(3357),
    [anon_sym_throw] = ACTIONS(3357),
    [anon_sym_namespace] = ACTIONS(3357),
    [anon_sym_using] = ACTIONS(3357),
    [anon_sym_static_assert] = ACTIONS(3357),
    [anon_sym_concept] = ACTIONS(3357),
    [anon_sym_co_return] = ACTIONS(3357),
    [anon_sym_co_yield] = ACTIONS(3357),
    [anon_sym_R_DQUOTE] = ACTIONS(3359),
    [anon_sym_LR_DQUOTE] = ACTIONS(3359),
    [anon_sym_uR_DQUOTE] = ACTIONS(3359),
    [anon_sym_UR_DQUOTE] = ACTIONS(3359),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3359),
    [anon_sym_co_await] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3357),
    [anon_sym_requires] = ACTIONS(3357),
    [sym_this] = ACTIONS(3357),
  },
  [917] = {
    [sym_identifier] = ACTIONS(3336),
    [aux_sym_preproc_include_token1] = ACTIONS(3336),
    [aux_sym_preproc_def_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token1] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3336),
    [sym_preproc_directive] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_BANG] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_SEMI] = ACTIONS(3338),
    [anon_sym___extension__] = ACTIONS(3336),
    [anon_sym_typedef] = ACTIONS(3336),
    [anon_sym_extern] = ACTIONS(3336),
    [anon_sym___attribute__] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3338),
    [anon_sym___declspec] = ACTIONS(3336),
    [anon_sym___based] = ACTIONS(3336),
    [anon_sym___cdecl] = ACTIONS(3336),
    [anon_sym___clrcall] = ACTIONS(3336),
    [anon_sym___stdcall] = ACTIONS(3336),
    [anon_sym___fastcall] = ACTIONS(3336),
    [anon_sym___thiscall] = ACTIONS(3336),
    [anon_sym___vectorcall] = ACTIONS(3336),
    [anon_sym_LBRACE] = ACTIONS(3338),
    [anon_sym_RBRACE] = ACTIONS(3338),
    [anon_sym_signed] = ACTIONS(3336),
    [anon_sym_unsigned] = ACTIONS(3336),
    [anon_sym_long] = ACTIONS(3336),
    [anon_sym_short] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_static] = ACTIONS(3336),
    [anon_sym_register] = ACTIONS(3336),
    [anon_sym_inline] = ACTIONS(3336),
    [anon_sym___inline] = ACTIONS(3336),
    [anon_sym___inline__] = ACTIONS(3336),
    [anon_sym___forceinline] = ACTIONS(3336),
    [anon_sym_thread_local] = ACTIONS(3336),
    [anon_sym___thread] = ACTIONS(3336),
    [anon_sym_const] = ACTIONS(3336),
    [anon_sym_constexpr] = ACTIONS(3336),
    [anon_sym_volatile] = ACTIONS(3336),
    [anon_sym_restrict] = ACTIONS(3336),
    [anon_sym___restrict__] = ACTIONS(3336),
    [anon_sym__Atomic] = ACTIONS(3336),
    [anon_sym__Noreturn] = ACTIONS(3336),
    [anon_sym_noreturn] = ACTIONS(3336),
    [anon_sym_mutable] = ACTIONS(3336),
    [anon_sym_constinit] = ACTIONS(3336),
    [anon_sym_consteval] = ACTIONS(3336),
    [anon_sym_PROGMEM] = ACTIONS(3336),
    [aux_sym_primitive_type_token1] = ACTIONS(3336),
    [anon_sym_byte] = ACTIONS(3336),
    [anon_sym_word] = ACTIONS(3336),
    [anon_sym_enum] = ACTIONS(3336),
    [anon_sym_class] = ACTIONS(3336),
    [anon_sym_struct] = ACTIONS(3336),
    [anon_sym_union] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_switch] = ACTIONS(3336),
    [anon_sym_case] = ACTIONS(3336),
    [anon_sym_default] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_break] = ACTIONS(3336),
    [anon_sym_continue] = ACTIONS(3336),
    [anon_sym_goto] = ACTIONS(3336),
    [anon_sym___try] = ACTIONS(3336),
    [anon_sym___leave] = ACTIONS(3336),
    [anon_sym_not] = ACTIONS(3336),
    [anon_sym_compl] = ACTIONS(3336),
    [anon_sym_DASH_DASH] = ACTIONS(3338),
    [anon_sym_PLUS_PLUS] = ACTIONS(3338),
    [anon_sym_sizeof] = ACTIONS(3336),
    [anon_sym___alignof__] = ACTIONS(3336),
    [anon_sym___alignof] = ACTIONS(3336),
    [anon_sym__alignof] = ACTIONS(3336),
    [anon_sym_alignof] = ACTIONS(3336),
    [anon_sym__Alignof] = ACTIONS(3336),
    [anon_sym_offsetof] = ACTIONS(3336),
    [anon_sym__Generic] = ACTIONS(3336),
    [anon_sym_asm] = ACTIONS(3336),
    [anon_sym___asm__] = ACTIONS(3336),
    [aux_sym_number_literal_token1] = ACTIONS(3338),
    [aux_sym_number_literal_token2] = ACTIONS(3336),
    [anon_sym_L_SQUOTE] = ACTIONS(3338),
    [anon_sym_u_SQUOTE] = ACTIONS(3338),
    [anon_sym_U_SQUOTE] = ACTIONS(3338),
    [anon_sym_u8_SQUOTE] = ACTIONS(3338),
    [anon_sym_SQUOTE] = ACTIONS(3338),
    [anon_sym_L_DQUOTE] = ACTIONS(3338),
    [anon_sym_u_DQUOTE] = ACTIONS(3338),
    [anon_sym_U_DQUOTE] = ACTIONS(3338),
    [anon_sym_u8_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE] = ACTIONS(3338),
    [sym_true] = ACTIONS(3336),
    [sym_false] = ACTIONS(3336),
    [anon_sym_NULL] = ACTIONS(3336),
    [anon_sym_nullptr] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3336),
    [anon_sym_decltype] = ACTIONS(3336),
    [anon_sym_virtual] = ACTIONS(3336),
    [anon_sym_alignas] = ACTIONS(3336),
    [anon_sym_explicit] = ACTIONS(3336),
    [anon_sym_typename] = ACTIONS(3336),
    [anon_sym_template] = ACTIONS(3336),
    [anon_sym_operator] = ACTIONS(3336),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_delete] = ACTIONS(3336),
    [anon_sym_throw] = ACTIONS(3336),
    [anon_sym_namespace] = ACTIONS(3336),
    [anon_sym_using] = ACTIONS(3336),
    [anon_sym_static_assert] = ACTIONS(3336),
    [anon_sym_concept] = ACTIONS(3336),
    [anon_sym_co_return] = ACTIONS(3336),
    [anon_sym_co_yield] = ACTIONS(3336),
    [anon_sym_R_DQUOTE] = ACTIONS(3338),
    [anon_sym_LR_DQUOTE] = ACTIONS(3338),
    [anon_sym_uR_DQUOTE] = ACTIONS(3338),
    [anon_sym_UR_DQUOTE] = ACTIONS(3338),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3338),
    [anon_sym_co_await] = ACTIONS(3336),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_requires] = ACTIONS(3336),
    [sym_this] = ACTIONS(3336),
  },
  [918] = {
    [sym_identifier] = ACTIONS(3475),
    [aux_sym_preproc_include_token1] = ACTIONS(3475),
    [aux_sym_preproc_def_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token1] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3475),
    [sym_preproc_directive] = ACTIONS(3475),
    [anon_sym_LPAREN2] = ACTIONS(3477),
    [anon_sym_BANG] = ACTIONS(3477),
    [anon_sym_TILDE] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3475),
    [anon_sym_PLUS] = ACTIONS(3475),
    [anon_sym_STAR] = ACTIONS(3477),
    [anon_sym_AMP_AMP] = ACTIONS(3477),
    [anon_sym_AMP] = ACTIONS(3475),
    [anon_sym_SEMI] = ACTIONS(3477),
    [anon_sym___extension__] = ACTIONS(3475),
    [anon_sym_typedef] = ACTIONS(3475),
    [anon_sym_extern] = ACTIONS(3475),
    [anon_sym___attribute__] = ACTIONS(3475),
    [anon_sym_COLON_COLON] = ACTIONS(3477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3477),
    [anon_sym___declspec] = ACTIONS(3475),
    [anon_sym___based] = ACTIONS(3475),
    [anon_sym___cdecl] = ACTIONS(3475),
    [anon_sym___clrcall] = ACTIONS(3475),
    [anon_sym___stdcall] = ACTIONS(3475),
    [anon_sym___fastcall] = ACTIONS(3475),
    [anon_sym___thiscall] = ACTIONS(3475),
    [anon_sym___vectorcall] = ACTIONS(3475),
    [anon_sym_LBRACE] = ACTIONS(3477),
    [anon_sym_RBRACE] = ACTIONS(3477),
    [anon_sym_signed] = ACTIONS(3475),
    [anon_sym_unsigned] = ACTIONS(3475),
    [anon_sym_long] = ACTIONS(3475),
    [anon_sym_short] = ACTIONS(3475),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [anon_sym_static] = ACTIONS(3475),
    [anon_sym_register] = ACTIONS(3475),
    [anon_sym_inline] = ACTIONS(3475),
    [anon_sym___inline] = ACTIONS(3475),
    [anon_sym___inline__] = ACTIONS(3475),
    [anon_sym___forceinline] = ACTIONS(3475),
    [anon_sym_thread_local] = ACTIONS(3475),
    [anon_sym___thread] = ACTIONS(3475),
    [anon_sym_const] = ACTIONS(3475),
    [anon_sym_constexpr] = ACTIONS(3475),
    [anon_sym_volatile] = ACTIONS(3475),
    [anon_sym_restrict] = ACTIONS(3475),
    [anon_sym___restrict__] = ACTIONS(3475),
    [anon_sym__Atomic] = ACTIONS(3475),
    [anon_sym__Noreturn] = ACTIONS(3475),
    [anon_sym_noreturn] = ACTIONS(3475),
    [anon_sym_mutable] = ACTIONS(3475),
    [anon_sym_constinit] = ACTIONS(3475),
    [anon_sym_consteval] = ACTIONS(3475),
    [anon_sym_PROGMEM] = ACTIONS(3475),
    [aux_sym_primitive_type_token1] = ACTIONS(3475),
    [anon_sym_byte] = ACTIONS(3475),
    [anon_sym_word] = ACTIONS(3475),
    [anon_sym_enum] = ACTIONS(3475),
    [anon_sym_class] = ACTIONS(3475),
    [anon_sym_struct] = ACTIONS(3475),
    [anon_sym_union] = ACTIONS(3475),
    [anon_sym_if] = ACTIONS(3475),
    [anon_sym_switch] = ACTIONS(3475),
    [anon_sym_case] = ACTIONS(3475),
    [anon_sym_default] = ACTIONS(3475),
    [anon_sym_while] = ACTIONS(3475),
    [anon_sym_do] = ACTIONS(3475),
    [anon_sym_for] = ACTIONS(3475),
    [anon_sym_return] = ACTIONS(3475),
    [anon_sym_break] = ACTIONS(3475),
    [anon_sym_continue] = ACTIONS(3475),
    [anon_sym_goto] = ACTIONS(3475),
    [anon_sym___try] = ACTIONS(3475),
    [anon_sym___leave] = ACTIONS(3475),
    [anon_sym_not] = ACTIONS(3475),
    [anon_sym_compl] = ACTIONS(3475),
    [anon_sym_DASH_DASH] = ACTIONS(3477),
    [anon_sym_PLUS_PLUS] = ACTIONS(3477),
    [anon_sym_sizeof] = ACTIONS(3475),
    [anon_sym___alignof__] = ACTIONS(3475),
    [anon_sym___alignof] = ACTIONS(3475),
    [anon_sym__alignof] = ACTIONS(3475),
    [anon_sym_alignof] = ACTIONS(3475),
    [anon_sym__Alignof] = ACTIONS(3475),
    [anon_sym_offsetof] = ACTIONS(3475),
    [anon_sym__Generic] = ACTIONS(3475),
    [anon_sym_asm] = ACTIONS(3475),
    [anon_sym___asm__] = ACTIONS(3475),
    [aux_sym_number_literal_token1] = ACTIONS(3477),
    [aux_sym_number_literal_token2] = ACTIONS(3475),
    [anon_sym_L_SQUOTE] = ACTIONS(3477),
    [anon_sym_u_SQUOTE] = ACTIONS(3477),
    [anon_sym_U_SQUOTE] = ACTIONS(3477),
    [anon_sym_u8_SQUOTE] = ACTIONS(3477),
    [anon_sym_SQUOTE] = ACTIONS(3477),
    [anon_sym_L_DQUOTE] = ACTIONS(3477),
    [anon_sym_u_DQUOTE] = ACTIONS(3477),
    [anon_sym_U_DQUOTE] = ACTIONS(3477),
    [anon_sym_u8_DQUOTE] = ACTIONS(3477),
    [anon_sym_DQUOTE] = ACTIONS(3477),
    [sym_true] = ACTIONS(3475),
    [sym_false] = ACTIONS(3475),
    [anon_sym_NULL] = ACTIONS(3475),
    [anon_sym_nullptr] = ACTIONS(3475),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3475),
    [anon_sym_decltype] = ACTIONS(3475),
    [anon_sym_virtual] = ACTIONS(3475),
    [anon_sym_alignas] = ACTIONS(3475),
    [anon_sym_explicit] = ACTIONS(3475),
    [anon_sym_typename] = ACTIONS(3475),
    [anon_sym_template] = ACTIONS(3475),
    [anon_sym_operator] = ACTIONS(3475),
    [anon_sym_try] = ACTIONS(3475),
    [anon_sym_delete] = ACTIONS(3475),
    [anon_sym_throw] = ACTIONS(3475),
    [anon_sym_namespace] = ACTIONS(3475),
    [anon_sym_using] = ACTIONS(3475),
    [anon_sym_static_assert] = ACTIONS(3475),
    [anon_sym_concept] = ACTIONS(3475),
    [anon_sym_co_return] = ACTIONS(3475),
    [anon_sym_co_yield] = ACTIONS(3475),
    [anon_sym_R_DQUOTE] = ACTIONS(3477),
    [anon_sym_LR_DQUOTE] = ACTIONS(3477),
    [anon_sym_uR_DQUOTE] = ACTIONS(3477),
    [anon_sym_UR_DQUOTE] = ACTIONS(3477),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3477),
    [anon_sym_co_await] = ACTIONS(3475),
    [anon_sym_new] = ACTIONS(3475),
    [anon_sym_requires] = ACTIONS(3475),
    [sym_this] = ACTIONS(3475),
  },
  [919] = {
    [sym_identifier] = ACTIONS(3479),
    [aux_sym_preproc_include_token1] = ACTIONS(3479),
    [aux_sym_preproc_def_token1] = ACTIONS(3479),
    [aux_sym_preproc_if_token1] = ACTIONS(3479),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3479),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3479),
    [sym_preproc_directive] = ACTIONS(3479),
    [anon_sym_LPAREN2] = ACTIONS(3481),
    [anon_sym_BANG] = ACTIONS(3481),
    [anon_sym_TILDE] = ACTIONS(3481),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_PLUS] = ACTIONS(3479),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_AMP_AMP] = ACTIONS(3481),
    [anon_sym_AMP] = ACTIONS(3479),
    [anon_sym_SEMI] = ACTIONS(3481),
    [anon_sym___extension__] = ACTIONS(3479),
    [anon_sym_typedef] = ACTIONS(3479),
    [anon_sym_extern] = ACTIONS(3479),
    [anon_sym___attribute__] = ACTIONS(3479),
    [anon_sym_COLON_COLON] = ACTIONS(3481),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3481),
    [anon_sym___declspec] = ACTIONS(3479),
    [anon_sym___based] = ACTIONS(3479),
    [anon_sym___cdecl] = ACTIONS(3479),
    [anon_sym___clrcall] = ACTIONS(3479),
    [anon_sym___stdcall] = ACTIONS(3479),
    [anon_sym___fastcall] = ACTIONS(3479),
    [anon_sym___thiscall] = ACTIONS(3479),
    [anon_sym___vectorcall] = ACTIONS(3479),
    [anon_sym_LBRACE] = ACTIONS(3481),
    [anon_sym_RBRACE] = ACTIONS(3481),
    [anon_sym_signed] = ACTIONS(3479),
    [anon_sym_unsigned] = ACTIONS(3479),
    [anon_sym_long] = ACTIONS(3479),
    [anon_sym_short] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(3479),
    [anon_sym_static] = ACTIONS(3479),
    [anon_sym_register] = ACTIONS(3479),
    [anon_sym_inline] = ACTIONS(3479),
    [anon_sym___inline] = ACTIONS(3479),
    [anon_sym___inline__] = ACTIONS(3479),
    [anon_sym___forceinline] = ACTIONS(3479),
    [anon_sym_thread_local] = ACTIONS(3479),
    [anon_sym___thread] = ACTIONS(3479),
    [anon_sym_const] = ACTIONS(3479),
    [anon_sym_constexpr] = ACTIONS(3479),
    [anon_sym_volatile] = ACTIONS(3479),
    [anon_sym_restrict] = ACTIONS(3479),
    [anon_sym___restrict__] = ACTIONS(3479),
    [anon_sym__Atomic] = ACTIONS(3479),
    [anon_sym__Noreturn] = ACTIONS(3479),
    [anon_sym_noreturn] = ACTIONS(3479),
    [anon_sym_mutable] = ACTIONS(3479),
    [anon_sym_constinit] = ACTIONS(3479),
    [anon_sym_consteval] = ACTIONS(3479),
    [anon_sym_PROGMEM] = ACTIONS(3479),
    [aux_sym_primitive_type_token1] = ACTIONS(3479),
    [anon_sym_byte] = ACTIONS(3479),
    [anon_sym_word] = ACTIONS(3479),
    [anon_sym_enum] = ACTIONS(3479),
    [anon_sym_class] = ACTIONS(3479),
    [anon_sym_struct] = ACTIONS(3479),
    [anon_sym_union] = ACTIONS(3479),
    [anon_sym_if] = ACTIONS(3479),
    [anon_sym_switch] = ACTIONS(3479),
    [anon_sym_case] = ACTIONS(3479),
    [anon_sym_default] = ACTIONS(3479),
    [anon_sym_while] = ACTIONS(3479),
    [anon_sym_do] = ACTIONS(3479),
    [anon_sym_for] = ACTIONS(3479),
    [anon_sym_return] = ACTIONS(3479),
    [anon_sym_break] = ACTIONS(3479),
    [anon_sym_continue] = ACTIONS(3479),
    [anon_sym_goto] = ACTIONS(3479),
    [anon_sym___try] = ACTIONS(3479),
    [anon_sym___leave] = ACTIONS(3479),
    [anon_sym_not] = ACTIONS(3479),
    [anon_sym_compl] = ACTIONS(3479),
    [anon_sym_DASH_DASH] = ACTIONS(3481),
    [anon_sym_PLUS_PLUS] = ACTIONS(3481),
    [anon_sym_sizeof] = ACTIONS(3479),
    [anon_sym___alignof__] = ACTIONS(3479),
    [anon_sym___alignof] = ACTIONS(3479),
    [anon_sym__alignof] = ACTIONS(3479),
    [anon_sym_alignof] = ACTIONS(3479),
    [anon_sym__Alignof] = ACTIONS(3479),
    [anon_sym_offsetof] = ACTIONS(3479),
    [anon_sym__Generic] = ACTIONS(3479),
    [anon_sym_asm] = ACTIONS(3479),
    [anon_sym___asm__] = ACTIONS(3479),
    [aux_sym_number_literal_token1] = ACTIONS(3481),
    [aux_sym_number_literal_token2] = ACTIONS(3479),
    [anon_sym_L_SQUOTE] = ACTIONS(3481),
    [anon_sym_u_SQUOTE] = ACTIONS(3481),
    [anon_sym_U_SQUOTE] = ACTIONS(3481),
    [anon_sym_u8_SQUOTE] = ACTIONS(3481),
    [anon_sym_SQUOTE] = ACTIONS(3481),
    [anon_sym_L_DQUOTE] = ACTIONS(3481),
    [anon_sym_u_DQUOTE] = ACTIONS(3481),
    [anon_sym_U_DQUOTE] = ACTIONS(3481),
    [anon_sym_u8_DQUOTE] = ACTIONS(3481),
    [anon_sym_DQUOTE] = ACTIONS(3481),
    [sym_true] = ACTIONS(3479),
    [sym_false] = ACTIONS(3479),
    [anon_sym_NULL] = ACTIONS(3479),
    [anon_sym_nullptr] = ACTIONS(3479),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3479),
    [anon_sym_decltype] = ACTIONS(3479),
    [anon_sym_virtual] = ACTIONS(3479),
    [anon_sym_alignas] = ACTIONS(3479),
    [anon_sym_explicit] = ACTIONS(3479),
    [anon_sym_typename] = ACTIONS(3479),
    [anon_sym_template] = ACTIONS(3479),
    [anon_sym_operator] = ACTIONS(3479),
    [anon_sym_try] = ACTIONS(3479),
    [anon_sym_delete] = ACTIONS(3479),
    [anon_sym_throw] = ACTIONS(3479),
    [anon_sym_namespace] = ACTIONS(3479),
    [anon_sym_using] = ACTIONS(3479),
    [anon_sym_static_assert] = ACTIONS(3479),
    [anon_sym_concept] = ACTIONS(3479),
    [anon_sym_co_return] = ACTIONS(3479),
    [anon_sym_co_yield] = ACTIONS(3479),
    [anon_sym_R_DQUOTE] = ACTIONS(3481),
    [anon_sym_LR_DQUOTE] = ACTIONS(3481),
    [anon_sym_uR_DQUOTE] = ACTIONS(3481),
    [anon_sym_UR_DQUOTE] = ACTIONS(3481),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3481),
    [anon_sym_co_await] = ACTIONS(3479),
    [anon_sym_new] = ACTIONS(3479),
    [anon_sym_requires] = ACTIONS(3479),
    [sym_this] = ACTIONS(3479),
  },
  [920] = {
    [sym_identifier] = ACTIONS(3483),
    [aux_sym_preproc_include_token1] = ACTIONS(3483),
    [aux_sym_preproc_def_token1] = ACTIONS(3483),
    [aux_sym_preproc_if_token1] = ACTIONS(3483),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3483),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3483),
    [sym_preproc_directive] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_BANG] = ACTIONS(3485),
    [anon_sym_TILDE] = ACTIONS(3485),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_STAR] = ACTIONS(3485),
    [anon_sym_AMP_AMP] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_SEMI] = ACTIONS(3485),
    [anon_sym___extension__] = ACTIONS(3483),
    [anon_sym_typedef] = ACTIONS(3483),
    [anon_sym_extern] = ACTIONS(3483),
    [anon_sym___attribute__] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3485),
    [anon_sym___declspec] = ACTIONS(3483),
    [anon_sym___based] = ACTIONS(3483),
    [anon_sym___cdecl] = ACTIONS(3483),
    [anon_sym___clrcall] = ACTIONS(3483),
    [anon_sym___stdcall] = ACTIONS(3483),
    [anon_sym___fastcall] = ACTIONS(3483),
    [anon_sym___thiscall] = ACTIONS(3483),
    [anon_sym___vectorcall] = ACTIONS(3483),
    [anon_sym_LBRACE] = ACTIONS(3485),
    [anon_sym_RBRACE] = ACTIONS(3485),
    [anon_sym_signed] = ACTIONS(3483),
    [anon_sym_unsigned] = ACTIONS(3483),
    [anon_sym_long] = ACTIONS(3483),
    [anon_sym_short] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_static] = ACTIONS(3483),
    [anon_sym_register] = ACTIONS(3483),
    [anon_sym_inline] = ACTIONS(3483),
    [anon_sym___inline] = ACTIONS(3483),
    [anon_sym___inline__] = ACTIONS(3483),
    [anon_sym___forceinline] = ACTIONS(3483),
    [anon_sym_thread_local] = ACTIONS(3483),
    [anon_sym___thread] = ACTIONS(3483),
    [anon_sym_const] = ACTIONS(3483),
    [anon_sym_constexpr] = ACTIONS(3483),
    [anon_sym_volatile] = ACTIONS(3483),
    [anon_sym_restrict] = ACTIONS(3483),
    [anon_sym___restrict__] = ACTIONS(3483),
    [anon_sym__Atomic] = ACTIONS(3483),
    [anon_sym__Noreturn] = ACTIONS(3483),
    [anon_sym_noreturn] = ACTIONS(3483),
    [anon_sym_mutable] = ACTIONS(3483),
    [anon_sym_constinit] = ACTIONS(3483),
    [anon_sym_consteval] = ACTIONS(3483),
    [anon_sym_PROGMEM] = ACTIONS(3483),
    [aux_sym_primitive_type_token1] = ACTIONS(3483),
    [anon_sym_byte] = ACTIONS(3483),
    [anon_sym_word] = ACTIONS(3483),
    [anon_sym_enum] = ACTIONS(3483),
    [anon_sym_class] = ACTIONS(3483),
    [anon_sym_struct] = ACTIONS(3483),
    [anon_sym_union] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_switch] = ACTIONS(3483),
    [anon_sym_case] = ACTIONS(3483),
    [anon_sym_default] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_break] = ACTIONS(3483),
    [anon_sym_continue] = ACTIONS(3483),
    [anon_sym_goto] = ACTIONS(3483),
    [anon_sym___try] = ACTIONS(3483),
    [anon_sym___leave] = ACTIONS(3483),
    [anon_sym_not] = ACTIONS(3483),
    [anon_sym_compl] = ACTIONS(3483),
    [anon_sym_DASH_DASH] = ACTIONS(3485),
    [anon_sym_PLUS_PLUS] = ACTIONS(3485),
    [anon_sym_sizeof] = ACTIONS(3483),
    [anon_sym___alignof__] = ACTIONS(3483),
    [anon_sym___alignof] = ACTIONS(3483),
    [anon_sym__alignof] = ACTIONS(3483),
    [anon_sym_alignof] = ACTIONS(3483),
    [anon_sym__Alignof] = ACTIONS(3483),
    [anon_sym_offsetof] = ACTIONS(3483),
    [anon_sym__Generic] = ACTIONS(3483),
    [anon_sym_asm] = ACTIONS(3483),
    [anon_sym___asm__] = ACTIONS(3483),
    [aux_sym_number_literal_token1] = ACTIONS(3485),
    [aux_sym_number_literal_token2] = ACTIONS(3483),
    [anon_sym_L_SQUOTE] = ACTIONS(3485),
    [anon_sym_u_SQUOTE] = ACTIONS(3485),
    [anon_sym_U_SQUOTE] = ACTIONS(3485),
    [anon_sym_u8_SQUOTE] = ACTIONS(3485),
    [anon_sym_SQUOTE] = ACTIONS(3485),
    [anon_sym_L_DQUOTE] = ACTIONS(3485),
    [anon_sym_u_DQUOTE] = ACTIONS(3485),
    [anon_sym_U_DQUOTE] = ACTIONS(3485),
    [anon_sym_u8_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE] = ACTIONS(3485),
    [sym_true] = ACTIONS(3483),
    [sym_false] = ACTIONS(3483),
    [anon_sym_NULL] = ACTIONS(3483),
    [anon_sym_nullptr] = ACTIONS(3483),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3483),
    [anon_sym_decltype] = ACTIONS(3483),
    [anon_sym_virtual] = ACTIONS(3483),
    [anon_sym_alignas] = ACTIONS(3483),
    [anon_sym_explicit] = ACTIONS(3483),
    [anon_sym_typename] = ACTIONS(3483),
    [anon_sym_template] = ACTIONS(3483),
    [anon_sym_operator] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_delete] = ACTIONS(3483),
    [anon_sym_throw] = ACTIONS(3483),
    [anon_sym_namespace] = ACTIONS(3483),
    [anon_sym_using] = ACTIONS(3483),
    [anon_sym_static_assert] = ACTIONS(3483),
    [anon_sym_concept] = ACTIONS(3483),
    [anon_sym_co_return] = ACTIONS(3483),
    [anon_sym_co_yield] = ACTIONS(3483),
    [anon_sym_R_DQUOTE] = ACTIONS(3485),
    [anon_sym_LR_DQUOTE] = ACTIONS(3485),
    [anon_sym_uR_DQUOTE] = ACTIONS(3485),
    [anon_sym_UR_DQUOTE] = ACTIONS(3485),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3485),
    [anon_sym_co_await] = ACTIONS(3483),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_requires] = ACTIONS(3483),
    [sym_this] = ACTIONS(3483),
  },
  [921] = {
    [sym_identifier] = ACTIONS(3487),
    [aux_sym_preproc_include_token1] = ACTIONS(3487),
    [aux_sym_preproc_def_token1] = ACTIONS(3487),
    [aux_sym_preproc_if_token1] = ACTIONS(3487),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3487),
    [sym_preproc_directive] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3489),
    [anon_sym_BANG] = ACTIONS(3489),
    [anon_sym_TILDE] = ACTIONS(3489),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3489),
    [anon_sym_AMP_AMP] = ACTIONS(3489),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_SEMI] = ACTIONS(3489),
    [anon_sym___extension__] = ACTIONS(3487),
    [anon_sym_typedef] = ACTIONS(3487),
    [anon_sym_extern] = ACTIONS(3487),
    [anon_sym___attribute__] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3489),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3489),
    [anon_sym___declspec] = ACTIONS(3487),
    [anon_sym___based] = ACTIONS(3487),
    [anon_sym___cdecl] = ACTIONS(3487),
    [anon_sym___clrcall] = ACTIONS(3487),
    [anon_sym___stdcall] = ACTIONS(3487),
    [anon_sym___fastcall] = ACTIONS(3487),
    [anon_sym___thiscall] = ACTIONS(3487),
    [anon_sym___vectorcall] = ACTIONS(3487),
    [anon_sym_LBRACE] = ACTIONS(3489),
    [anon_sym_RBRACE] = ACTIONS(3489),
    [anon_sym_signed] = ACTIONS(3487),
    [anon_sym_unsigned] = ACTIONS(3487),
    [anon_sym_long] = ACTIONS(3487),
    [anon_sym_short] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_register] = ACTIONS(3487),
    [anon_sym_inline] = ACTIONS(3487),
    [anon_sym___inline] = ACTIONS(3487),
    [anon_sym___inline__] = ACTIONS(3487),
    [anon_sym___forceinline] = ACTIONS(3487),
    [anon_sym_thread_local] = ACTIONS(3487),
    [anon_sym___thread] = ACTIONS(3487),
    [anon_sym_const] = ACTIONS(3487),
    [anon_sym_constexpr] = ACTIONS(3487),
    [anon_sym_volatile] = ACTIONS(3487),
    [anon_sym_restrict] = ACTIONS(3487),
    [anon_sym___restrict__] = ACTIONS(3487),
    [anon_sym__Atomic] = ACTIONS(3487),
    [anon_sym__Noreturn] = ACTIONS(3487),
    [anon_sym_noreturn] = ACTIONS(3487),
    [anon_sym_mutable] = ACTIONS(3487),
    [anon_sym_constinit] = ACTIONS(3487),
    [anon_sym_consteval] = ACTIONS(3487),
    [anon_sym_PROGMEM] = ACTIONS(3487),
    [aux_sym_primitive_type_token1] = ACTIONS(3487),
    [anon_sym_byte] = ACTIONS(3487),
    [anon_sym_word] = ACTIONS(3487),
    [anon_sym_enum] = ACTIONS(3487),
    [anon_sym_class] = ACTIONS(3487),
    [anon_sym_struct] = ACTIONS(3487),
    [anon_sym_union] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_switch] = ACTIONS(3487),
    [anon_sym_case] = ACTIONS(3487),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_break] = ACTIONS(3487),
    [anon_sym_continue] = ACTIONS(3487),
    [anon_sym_goto] = ACTIONS(3487),
    [anon_sym___try] = ACTIONS(3487),
    [anon_sym___leave] = ACTIONS(3487),
    [anon_sym_not] = ACTIONS(3487),
    [anon_sym_compl] = ACTIONS(3487),
    [anon_sym_DASH_DASH] = ACTIONS(3489),
    [anon_sym_PLUS_PLUS] = ACTIONS(3489),
    [anon_sym_sizeof] = ACTIONS(3487),
    [anon_sym___alignof__] = ACTIONS(3487),
    [anon_sym___alignof] = ACTIONS(3487),
    [anon_sym__alignof] = ACTIONS(3487),
    [anon_sym_alignof] = ACTIONS(3487),
    [anon_sym__Alignof] = ACTIONS(3487),
    [anon_sym_offsetof] = ACTIONS(3487),
    [anon_sym__Generic] = ACTIONS(3487),
    [anon_sym_asm] = ACTIONS(3487),
    [anon_sym___asm__] = ACTIONS(3487),
    [aux_sym_number_literal_token1] = ACTIONS(3489),
    [aux_sym_number_literal_token2] = ACTIONS(3487),
    [anon_sym_L_SQUOTE] = ACTIONS(3489),
    [anon_sym_u_SQUOTE] = ACTIONS(3489),
    [anon_sym_U_SQUOTE] = ACTIONS(3489),
    [anon_sym_u8_SQUOTE] = ACTIONS(3489),
    [anon_sym_SQUOTE] = ACTIONS(3489),
    [anon_sym_L_DQUOTE] = ACTIONS(3489),
    [anon_sym_u_DQUOTE] = ACTIONS(3489),
    [anon_sym_U_DQUOTE] = ACTIONS(3489),
    [anon_sym_u8_DQUOTE] = ACTIONS(3489),
    [anon_sym_DQUOTE] = ACTIONS(3489),
    [sym_true] = ACTIONS(3487),
    [sym_false] = ACTIONS(3487),
    [anon_sym_NULL] = ACTIONS(3487),
    [anon_sym_nullptr] = ACTIONS(3487),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3487),
    [anon_sym_decltype] = ACTIONS(3487),
    [anon_sym_virtual] = ACTIONS(3487),
    [anon_sym_alignas] = ACTIONS(3487),
    [anon_sym_explicit] = ACTIONS(3487),
    [anon_sym_typename] = ACTIONS(3487),
    [anon_sym_template] = ACTIONS(3487),
    [anon_sym_operator] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_delete] = ACTIONS(3487),
    [anon_sym_throw] = ACTIONS(3487),
    [anon_sym_namespace] = ACTIONS(3487),
    [anon_sym_using] = ACTIONS(3487),
    [anon_sym_static_assert] = ACTIONS(3487),
    [anon_sym_concept] = ACTIONS(3487),
    [anon_sym_co_return] = ACTIONS(3487),
    [anon_sym_co_yield] = ACTIONS(3487),
    [anon_sym_R_DQUOTE] = ACTIONS(3489),
    [anon_sym_LR_DQUOTE] = ACTIONS(3489),
    [anon_sym_uR_DQUOTE] = ACTIONS(3489),
    [anon_sym_UR_DQUOTE] = ACTIONS(3489),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3489),
    [anon_sym_co_await] = ACTIONS(3487),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_requires] = ACTIONS(3487),
    [sym_this] = ACTIONS(3487),
  },
  [922] = {
    [sym_identifier] = ACTIONS(3276),
    [aux_sym_preproc_include_token1] = ACTIONS(3276),
    [aux_sym_preproc_def_token1] = ACTIONS(3276),
    [aux_sym_preproc_if_token1] = ACTIONS(3276),
    [aux_sym_preproc_if_token2] = ACTIONS(3276),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3276),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3276),
    [sym_preproc_directive] = ACTIONS(3276),
    [anon_sym_LPAREN2] = ACTIONS(3278),
    [anon_sym_BANG] = ACTIONS(3278),
    [anon_sym_TILDE] = ACTIONS(3278),
    [anon_sym_DASH] = ACTIONS(3276),
    [anon_sym_PLUS] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3278),
    [anon_sym_AMP_AMP] = ACTIONS(3278),
    [anon_sym_AMP] = ACTIONS(3276),
    [anon_sym_SEMI] = ACTIONS(3278),
    [anon_sym___extension__] = ACTIONS(3276),
    [anon_sym_typedef] = ACTIONS(3276),
    [anon_sym_extern] = ACTIONS(3276),
    [anon_sym___attribute__] = ACTIONS(3276),
    [anon_sym_COLON_COLON] = ACTIONS(3278),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3278),
    [anon_sym___declspec] = ACTIONS(3276),
    [anon_sym___based] = ACTIONS(3276),
    [anon_sym___cdecl] = ACTIONS(3276),
    [anon_sym___clrcall] = ACTIONS(3276),
    [anon_sym___stdcall] = ACTIONS(3276),
    [anon_sym___fastcall] = ACTIONS(3276),
    [anon_sym___thiscall] = ACTIONS(3276),
    [anon_sym___vectorcall] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3278),
    [anon_sym_signed] = ACTIONS(3276),
    [anon_sym_unsigned] = ACTIONS(3276),
    [anon_sym_long] = ACTIONS(3276),
    [anon_sym_short] = ACTIONS(3276),
    [anon_sym_LBRACK] = ACTIONS(3276),
    [anon_sym_static] = ACTIONS(3276),
    [anon_sym_register] = ACTIONS(3276),
    [anon_sym_inline] = ACTIONS(3276),
    [anon_sym___inline] = ACTIONS(3276),
    [anon_sym___inline__] = ACTIONS(3276),
    [anon_sym___forceinline] = ACTIONS(3276),
    [anon_sym_thread_local] = ACTIONS(3276),
    [anon_sym___thread] = ACTIONS(3276),
    [anon_sym_const] = ACTIONS(3276),
    [anon_sym_constexpr] = ACTIONS(3276),
    [anon_sym_volatile] = ACTIONS(3276),
    [anon_sym_restrict] = ACTIONS(3276),
    [anon_sym___restrict__] = ACTIONS(3276),
    [anon_sym__Atomic] = ACTIONS(3276),
    [anon_sym__Noreturn] = ACTIONS(3276),
    [anon_sym_noreturn] = ACTIONS(3276),
    [anon_sym_mutable] = ACTIONS(3276),
    [anon_sym_constinit] = ACTIONS(3276),
    [anon_sym_consteval] = ACTIONS(3276),
    [anon_sym_PROGMEM] = ACTIONS(3276),
    [aux_sym_primitive_type_token1] = ACTIONS(3276),
    [anon_sym_byte] = ACTIONS(3276),
    [anon_sym_word] = ACTIONS(3276),
    [anon_sym_enum] = ACTIONS(3276),
    [anon_sym_class] = ACTIONS(3276),
    [anon_sym_struct] = ACTIONS(3276),
    [anon_sym_union] = ACTIONS(3276),
    [anon_sym_if] = ACTIONS(3276),
    [anon_sym_switch] = ACTIONS(3276),
    [anon_sym_case] = ACTIONS(3276),
    [anon_sym_default] = ACTIONS(3276),
    [anon_sym_while] = ACTIONS(3276),
    [anon_sym_do] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3276),
    [anon_sym_return] = ACTIONS(3276),
    [anon_sym_break] = ACTIONS(3276),
    [anon_sym_continue] = ACTIONS(3276),
    [anon_sym_goto] = ACTIONS(3276),
    [anon_sym___try] = ACTIONS(3276),
    [anon_sym___leave] = ACTIONS(3276),
    [anon_sym_not] = ACTIONS(3276),
    [anon_sym_compl] = ACTIONS(3276),
    [anon_sym_DASH_DASH] = ACTIONS(3278),
    [anon_sym_PLUS_PLUS] = ACTIONS(3278),
    [anon_sym_sizeof] = ACTIONS(3276),
    [anon_sym___alignof__] = ACTIONS(3276),
    [anon_sym___alignof] = ACTIONS(3276),
    [anon_sym__alignof] = ACTIONS(3276),
    [anon_sym_alignof] = ACTIONS(3276),
    [anon_sym__Alignof] = ACTIONS(3276),
    [anon_sym_offsetof] = ACTIONS(3276),
    [anon_sym__Generic] = ACTIONS(3276),
    [anon_sym_asm] = ACTIONS(3276),
    [anon_sym___asm__] = ACTIONS(3276),
    [aux_sym_number_literal_token1] = ACTIONS(3278),
    [aux_sym_number_literal_token2] = ACTIONS(3276),
    [anon_sym_L_SQUOTE] = ACTIONS(3278),
    [anon_sym_u_SQUOTE] = ACTIONS(3278),
    [anon_sym_U_SQUOTE] = ACTIONS(3278),
    [anon_sym_u8_SQUOTE] = ACTIONS(3278),
    [anon_sym_SQUOTE] = ACTIONS(3278),
    [anon_sym_L_DQUOTE] = ACTIONS(3278),
    [anon_sym_u_DQUOTE] = ACTIONS(3278),
    [anon_sym_U_DQUOTE] = ACTIONS(3278),
    [anon_sym_u8_DQUOTE] = ACTIONS(3278),
    [anon_sym_DQUOTE] = ACTIONS(3278),
    [sym_true] = ACTIONS(3276),
    [sym_false] = ACTIONS(3276),
    [anon_sym_NULL] = ACTIONS(3276),
    [anon_sym_nullptr] = ACTIONS(3276),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3276),
    [anon_sym_decltype] = ACTIONS(3276),
    [anon_sym_virtual] = ACTIONS(3276),
    [anon_sym_alignas] = ACTIONS(3276),
    [anon_sym_explicit] = ACTIONS(3276),
    [anon_sym_typename] = ACTIONS(3276),
    [anon_sym_template] = ACTIONS(3276),
    [anon_sym_operator] = ACTIONS(3276),
    [anon_sym_try] = ACTIONS(3276),
    [anon_sym_delete] = ACTIONS(3276),
    [anon_sym_throw] = ACTIONS(3276),
    [anon_sym_namespace] = ACTIONS(3276),
    [anon_sym_using] = ACTIONS(3276),
    [anon_sym_static_assert] = ACTIONS(3276),
    [anon_sym_concept] = ACTIONS(3276),
    [anon_sym_co_return] = ACTIONS(3276),
    [anon_sym_co_yield] = ACTIONS(3276),
    [anon_sym_R_DQUOTE] = ACTIONS(3278),
    [anon_sym_LR_DQUOTE] = ACTIONS(3278),
    [anon_sym_uR_DQUOTE] = ACTIONS(3278),
    [anon_sym_UR_DQUOTE] = ACTIONS(3278),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3278),
    [anon_sym_co_await] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3276),
    [anon_sym_requires] = ACTIONS(3276),
    [sym_this] = ACTIONS(3276),
  },
  [923] = {
    [sym_identifier] = ACTIONS(3491),
    [aux_sym_preproc_include_token1] = ACTIONS(3491),
    [aux_sym_preproc_def_token1] = ACTIONS(3491),
    [aux_sym_preproc_if_token1] = ACTIONS(3491),
    [aux_sym_preproc_if_token2] = ACTIONS(3491),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3491),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3491),
    [sym_preproc_directive] = ACTIONS(3491),
    [anon_sym_LPAREN2] = ACTIONS(3493),
    [anon_sym_BANG] = ACTIONS(3493),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(3493),
    [anon_sym_AMP_AMP] = ACTIONS(3493),
    [anon_sym_AMP] = ACTIONS(3491),
    [anon_sym_SEMI] = ACTIONS(3493),
    [anon_sym___extension__] = ACTIONS(3491),
    [anon_sym_typedef] = ACTIONS(3491),
    [anon_sym_extern] = ACTIONS(3491),
    [anon_sym___attribute__] = ACTIONS(3491),
    [anon_sym_COLON_COLON] = ACTIONS(3493),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3493),
    [anon_sym___declspec] = ACTIONS(3491),
    [anon_sym___based] = ACTIONS(3491),
    [anon_sym___cdecl] = ACTIONS(3491),
    [anon_sym___clrcall] = ACTIONS(3491),
    [anon_sym___stdcall] = ACTIONS(3491),
    [anon_sym___fastcall] = ACTIONS(3491),
    [anon_sym___thiscall] = ACTIONS(3491),
    [anon_sym___vectorcall] = ACTIONS(3491),
    [anon_sym_LBRACE] = ACTIONS(3493),
    [anon_sym_signed] = ACTIONS(3491),
    [anon_sym_unsigned] = ACTIONS(3491),
    [anon_sym_long] = ACTIONS(3491),
    [anon_sym_short] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3491),
    [anon_sym_static] = ACTIONS(3491),
    [anon_sym_register] = ACTIONS(3491),
    [anon_sym_inline] = ACTIONS(3491),
    [anon_sym___inline] = ACTIONS(3491),
    [anon_sym___inline__] = ACTIONS(3491),
    [anon_sym___forceinline] = ACTIONS(3491),
    [anon_sym_thread_local] = ACTIONS(3491),
    [anon_sym___thread] = ACTIONS(3491),
    [anon_sym_const] = ACTIONS(3491),
    [anon_sym_constexpr] = ACTIONS(3491),
    [anon_sym_volatile] = ACTIONS(3491),
    [anon_sym_restrict] = ACTIONS(3491),
    [anon_sym___restrict__] = ACTIONS(3491),
    [anon_sym__Atomic] = ACTIONS(3491),
    [anon_sym__Noreturn] = ACTIONS(3491),
    [anon_sym_noreturn] = ACTIONS(3491),
    [anon_sym_mutable] = ACTIONS(3491),
    [anon_sym_constinit] = ACTIONS(3491),
    [anon_sym_consteval] = ACTIONS(3491),
    [anon_sym_PROGMEM] = ACTIONS(3491),
    [aux_sym_primitive_type_token1] = ACTIONS(3491),
    [anon_sym_byte] = ACTIONS(3491),
    [anon_sym_word] = ACTIONS(3491),
    [anon_sym_enum] = ACTIONS(3491),
    [anon_sym_class] = ACTIONS(3491),
    [anon_sym_struct] = ACTIONS(3491),
    [anon_sym_union] = ACTIONS(3491),
    [anon_sym_if] = ACTIONS(3491),
    [anon_sym_switch] = ACTIONS(3491),
    [anon_sym_case] = ACTIONS(3491),
    [anon_sym_default] = ACTIONS(3491),
    [anon_sym_while] = ACTIONS(3491),
    [anon_sym_do] = ACTIONS(3491),
    [anon_sym_for] = ACTIONS(3491),
    [anon_sym_return] = ACTIONS(3491),
    [anon_sym_break] = ACTIONS(3491),
    [anon_sym_continue] = ACTIONS(3491),
    [anon_sym_goto] = ACTIONS(3491),
    [anon_sym___try] = ACTIONS(3491),
    [anon_sym___leave] = ACTIONS(3491),
    [anon_sym_not] = ACTIONS(3491),
    [anon_sym_compl] = ACTIONS(3491),
    [anon_sym_DASH_DASH] = ACTIONS(3493),
    [anon_sym_PLUS_PLUS] = ACTIONS(3493),
    [anon_sym_sizeof] = ACTIONS(3491),
    [anon_sym___alignof__] = ACTIONS(3491),
    [anon_sym___alignof] = ACTIONS(3491),
    [anon_sym__alignof] = ACTIONS(3491),
    [anon_sym_alignof] = ACTIONS(3491),
    [anon_sym__Alignof] = ACTIONS(3491),
    [anon_sym_offsetof] = ACTIONS(3491),
    [anon_sym__Generic] = ACTIONS(3491),
    [anon_sym_asm] = ACTIONS(3491),
    [anon_sym___asm__] = ACTIONS(3491),
    [aux_sym_number_literal_token1] = ACTIONS(3493),
    [aux_sym_number_literal_token2] = ACTIONS(3491),
    [anon_sym_L_SQUOTE] = ACTIONS(3493),
    [anon_sym_u_SQUOTE] = ACTIONS(3493),
    [anon_sym_U_SQUOTE] = ACTIONS(3493),
    [anon_sym_u8_SQUOTE] = ACTIONS(3493),
    [anon_sym_SQUOTE] = ACTIONS(3493),
    [anon_sym_L_DQUOTE] = ACTIONS(3493),
    [anon_sym_u_DQUOTE] = ACTIONS(3493),
    [anon_sym_U_DQUOTE] = ACTIONS(3493),
    [anon_sym_u8_DQUOTE] = ACTIONS(3493),
    [anon_sym_DQUOTE] = ACTIONS(3493),
    [sym_true] = ACTIONS(3491),
    [sym_false] = ACTIONS(3491),
    [anon_sym_NULL] = ACTIONS(3491),
    [anon_sym_nullptr] = ACTIONS(3491),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3491),
    [anon_sym_decltype] = ACTIONS(3491),
    [anon_sym_virtual] = ACTIONS(3491),
    [anon_sym_alignas] = ACTIONS(3491),
    [anon_sym_explicit] = ACTIONS(3491),
    [anon_sym_typename] = ACTIONS(3491),
    [anon_sym_template] = ACTIONS(3491),
    [anon_sym_operator] = ACTIONS(3491),
    [anon_sym_try] = ACTIONS(3491),
    [anon_sym_delete] = ACTIONS(3491),
    [anon_sym_throw] = ACTIONS(3491),
    [anon_sym_namespace] = ACTIONS(3491),
    [anon_sym_using] = ACTIONS(3491),
    [anon_sym_static_assert] = ACTIONS(3491),
    [anon_sym_concept] = ACTIONS(3491),
    [anon_sym_co_return] = ACTIONS(3491),
    [anon_sym_co_yield] = ACTIONS(3491),
    [anon_sym_R_DQUOTE] = ACTIONS(3493),
    [anon_sym_LR_DQUOTE] = ACTIONS(3493),
    [anon_sym_uR_DQUOTE] = ACTIONS(3493),
    [anon_sym_UR_DQUOTE] = ACTIONS(3493),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3493),
    [anon_sym_co_await] = ACTIONS(3491),
    [anon_sym_new] = ACTIONS(3491),
    [anon_sym_requires] = ACTIONS(3491),
    [sym_this] = ACTIONS(3491),
  },
  [924] = {
    [sym_identifier] = ACTIONS(3346),
    [aux_sym_preproc_include_token1] = ACTIONS(3346),
    [aux_sym_preproc_def_token1] = ACTIONS(3346),
    [aux_sym_preproc_if_token1] = ACTIONS(3346),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3346),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3346),
    [sym_preproc_directive] = ACTIONS(3346),
    [anon_sym_LPAREN2] = ACTIONS(3348),
    [anon_sym_BANG] = ACTIONS(3348),
    [anon_sym_TILDE] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3348),
    [anon_sym_AMP_AMP] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym_SEMI] = ACTIONS(3348),
    [anon_sym___extension__] = ACTIONS(3346),
    [anon_sym_typedef] = ACTIONS(3346),
    [anon_sym_extern] = ACTIONS(3346),
    [anon_sym___attribute__] = ACTIONS(3346),
    [anon_sym_COLON_COLON] = ACTIONS(3348),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3348),
    [anon_sym___declspec] = ACTIONS(3346),
    [anon_sym___based] = ACTIONS(3346),
    [anon_sym___cdecl] = ACTIONS(3346),
    [anon_sym___clrcall] = ACTIONS(3346),
    [anon_sym___stdcall] = ACTIONS(3346),
    [anon_sym___fastcall] = ACTIONS(3346),
    [anon_sym___thiscall] = ACTIONS(3346),
    [anon_sym___vectorcall] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3348),
    [anon_sym_RBRACE] = ACTIONS(3348),
    [anon_sym_signed] = ACTIONS(3346),
    [anon_sym_unsigned] = ACTIONS(3346),
    [anon_sym_long] = ACTIONS(3346),
    [anon_sym_short] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3346),
    [anon_sym_register] = ACTIONS(3346),
    [anon_sym_inline] = ACTIONS(3346),
    [anon_sym___inline] = ACTIONS(3346),
    [anon_sym___inline__] = ACTIONS(3346),
    [anon_sym___forceinline] = ACTIONS(3346),
    [anon_sym_thread_local] = ACTIONS(3346),
    [anon_sym___thread] = ACTIONS(3346),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_constexpr] = ACTIONS(3346),
    [anon_sym_volatile] = ACTIONS(3346),
    [anon_sym_restrict] = ACTIONS(3346),
    [anon_sym___restrict__] = ACTIONS(3346),
    [anon_sym__Atomic] = ACTIONS(3346),
    [anon_sym__Noreturn] = ACTIONS(3346),
    [anon_sym_noreturn] = ACTIONS(3346),
    [anon_sym_mutable] = ACTIONS(3346),
    [anon_sym_constinit] = ACTIONS(3346),
    [anon_sym_consteval] = ACTIONS(3346),
    [anon_sym_PROGMEM] = ACTIONS(3346),
    [aux_sym_primitive_type_token1] = ACTIONS(3346),
    [anon_sym_byte] = ACTIONS(3346),
    [anon_sym_word] = ACTIONS(3346),
    [anon_sym_enum] = ACTIONS(3346),
    [anon_sym_class] = ACTIONS(3346),
    [anon_sym_struct] = ACTIONS(3346),
    [anon_sym_union] = ACTIONS(3346),
    [anon_sym_if] = ACTIONS(3346),
    [anon_sym_switch] = ACTIONS(3346),
    [anon_sym_case] = ACTIONS(3346),
    [anon_sym_default] = ACTIONS(3346),
    [anon_sym_while] = ACTIONS(3346),
    [anon_sym_do] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3346),
    [anon_sym_return] = ACTIONS(3346),
    [anon_sym_break] = ACTIONS(3346),
    [anon_sym_continue] = ACTIONS(3346),
    [anon_sym_goto] = ACTIONS(3346),
    [anon_sym___try] = ACTIONS(3346),
    [anon_sym___leave] = ACTIONS(3346),
    [anon_sym_not] = ACTIONS(3346),
    [anon_sym_compl] = ACTIONS(3346),
    [anon_sym_DASH_DASH] = ACTIONS(3348),
    [anon_sym_PLUS_PLUS] = ACTIONS(3348),
    [anon_sym_sizeof] = ACTIONS(3346),
    [anon_sym___alignof__] = ACTIONS(3346),
    [anon_sym___alignof] = ACTIONS(3346),
    [anon_sym__alignof] = ACTIONS(3346),
    [anon_sym_alignof] = ACTIONS(3346),
    [anon_sym__Alignof] = ACTIONS(3346),
    [anon_sym_offsetof] = ACTIONS(3346),
    [anon_sym__Generic] = ACTIONS(3346),
    [anon_sym_asm] = ACTIONS(3346),
    [anon_sym___asm__] = ACTIONS(3346),
    [aux_sym_number_literal_token1] = ACTIONS(3348),
    [aux_sym_number_literal_token2] = ACTIONS(3346),
    [anon_sym_L_SQUOTE] = ACTIONS(3348),
    [anon_sym_u_SQUOTE] = ACTIONS(3348),
    [anon_sym_U_SQUOTE] = ACTIONS(3348),
    [anon_sym_u8_SQUOTE] = ACTIONS(3348),
    [anon_sym_SQUOTE] = ACTIONS(3348),
    [anon_sym_L_DQUOTE] = ACTIONS(3348),
    [anon_sym_u_DQUOTE] = ACTIONS(3348),
    [anon_sym_U_DQUOTE] = ACTIONS(3348),
    [anon_sym_u8_DQUOTE] = ACTIONS(3348),
    [anon_sym_DQUOTE] = ACTIONS(3348),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [anon_sym_NULL] = ACTIONS(3346),
    [anon_sym_nullptr] = ACTIONS(3346),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3346),
    [anon_sym_decltype] = ACTIONS(3346),
    [anon_sym_virtual] = ACTIONS(3346),
    [anon_sym_alignas] = ACTIONS(3346),
    [anon_sym_explicit] = ACTIONS(3346),
    [anon_sym_typename] = ACTIONS(3346),
    [anon_sym_template] = ACTIONS(3346),
    [anon_sym_operator] = ACTIONS(3346),
    [anon_sym_try] = ACTIONS(3346),
    [anon_sym_delete] = ACTIONS(3346),
    [anon_sym_throw] = ACTIONS(3346),
    [anon_sym_namespace] = ACTIONS(3346),
    [anon_sym_using] = ACTIONS(3346),
    [anon_sym_static_assert] = ACTIONS(3346),
    [anon_sym_concept] = ACTIONS(3346),
    [anon_sym_co_return] = ACTIONS(3346),
    [anon_sym_co_yield] = ACTIONS(3346),
    [anon_sym_R_DQUOTE] = ACTIONS(3348),
    [anon_sym_LR_DQUOTE] = ACTIONS(3348),
    [anon_sym_uR_DQUOTE] = ACTIONS(3348),
    [anon_sym_UR_DQUOTE] = ACTIONS(3348),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3348),
    [anon_sym_co_await] = ACTIONS(3346),
    [anon_sym_new] = ACTIONS(3346),
    [anon_sym_requires] = ACTIONS(3346),
    [sym_this] = ACTIONS(3346),
  },
  [925] = {
    [sym_identifier] = ACTIONS(3357),
    [aux_sym_preproc_include_token1] = ACTIONS(3357),
    [aux_sym_preproc_def_token1] = ACTIONS(3357),
    [aux_sym_preproc_if_token1] = ACTIONS(3357),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3357),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3357),
    [sym_preproc_directive] = ACTIONS(3357),
    [anon_sym_LPAREN2] = ACTIONS(3359),
    [anon_sym_BANG] = ACTIONS(3359),
    [anon_sym_TILDE] = ACTIONS(3359),
    [anon_sym_DASH] = ACTIONS(3357),
    [anon_sym_PLUS] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(3359),
    [anon_sym_AMP_AMP] = ACTIONS(3359),
    [anon_sym_AMP] = ACTIONS(3357),
    [anon_sym_SEMI] = ACTIONS(3359),
    [anon_sym___extension__] = ACTIONS(3357),
    [anon_sym_typedef] = ACTIONS(3357),
    [anon_sym_extern] = ACTIONS(3357),
    [anon_sym___attribute__] = ACTIONS(3357),
    [anon_sym_COLON_COLON] = ACTIONS(3359),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3359),
    [anon_sym___declspec] = ACTIONS(3357),
    [anon_sym___based] = ACTIONS(3357),
    [anon_sym___cdecl] = ACTIONS(3357),
    [anon_sym___clrcall] = ACTIONS(3357),
    [anon_sym___stdcall] = ACTIONS(3357),
    [anon_sym___fastcall] = ACTIONS(3357),
    [anon_sym___thiscall] = ACTIONS(3357),
    [anon_sym___vectorcall] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3359),
    [anon_sym_RBRACE] = ACTIONS(3359),
    [anon_sym_signed] = ACTIONS(3357),
    [anon_sym_unsigned] = ACTIONS(3357),
    [anon_sym_long] = ACTIONS(3357),
    [anon_sym_short] = ACTIONS(3357),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_static] = ACTIONS(3357),
    [anon_sym_register] = ACTIONS(3357),
    [anon_sym_inline] = ACTIONS(3357),
    [anon_sym___inline] = ACTIONS(3357),
    [anon_sym___inline__] = ACTIONS(3357),
    [anon_sym___forceinline] = ACTIONS(3357),
    [anon_sym_thread_local] = ACTIONS(3357),
    [anon_sym___thread] = ACTIONS(3357),
    [anon_sym_const] = ACTIONS(3357),
    [anon_sym_constexpr] = ACTIONS(3357),
    [anon_sym_volatile] = ACTIONS(3357),
    [anon_sym_restrict] = ACTIONS(3357),
    [anon_sym___restrict__] = ACTIONS(3357),
    [anon_sym__Atomic] = ACTIONS(3357),
    [anon_sym__Noreturn] = ACTIONS(3357),
    [anon_sym_noreturn] = ACTIONS(3357),
    [anon_sym_mutable] = ACTIONS(3357),
    [anon_sym_constinit] = ACTIONS(3357),
    [anon_sym_consteval] = ACTIONS(3357),
    [anon_sym_PROGMEM] = ACTIONS(3357),
    [aux_sym_primitive_type_token1] = ACTIONS(3357),
    [anon_sym_byte] = ACTIONS(3357),
    [anon_sym_word] = ACTIONS(3357),
    [anon_sym_enum] = ACTIONS(3357),
    [anon_sym_class] = ACTIONS(3357),
    [anon_sym_struct] = ACTIONS(3357),
    [anon_sym_union] = ACTIONS(3357),
    [anon_sym_if] = ACTIONS(3357),
    [anon_sym_switch] = ACTIONS(3357),
    [anon_sym_case] = ACTIONS(3357),
    [anon_sym_default] = ACTIONS(3357),
    [anon_sym_while] = ACTIONS(3357),
    [anon_sym_do] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3357),
    [anon_sym_return] = ACTIONS(3357),
    [anon_sym_break] = ACTIONS(3357),
    [anon_sym_continue] = ACTIONS(3357),
    [anon_sym_goto] = ACTIONS(3357),
    [anon_sym___try] = ACTIONS(3357),
    [anon_sym___leave] = ACTIONS(3357),
    [anon_sym_not] = ACTIONS(3357),
    [anon_sym_compl] = ACTIONS(3357),
    [anon_sym_DASH_DASH] = ACTIONS(3359),
    [anon_sym_PLUS_PLUS] = ACTIONS(3359),
    [anon_sym_sizeof] = ACTIONS(3357),
    [anon_sym___alignof__] = ACTIONS(3357),
    [anon_sym___alignof] = ACTIONS(3357),
    [anon_sym__alignof] = ACTIONS(3357),
    [anon_sym_alignof] = ACTIONS(3357),
    [anon_sym__Alignof] = ACTIONS(3357),
    [anon_sym_offsetof] = ACTIONS(3357),
    [anon_sym__Generic] = ACTIONS(3357),
    [anon_sym_asm] = ACTIONS(3357),
    [anon_sym___asm__] = ACTIONS(3357),
    [aux_sym_number_literal_token1] = ACTIONS(3359),
    [aux_sym_number_literal_token2] = ACTIONS(3357),
    [anon_sym_L_SQUOTE] = ACTIONS(3359),
    [anon_sym_u_SQUOTE] = ACTIONS(3359),
    [anon_sym_U_SQUOTE] = ACTIONS(3359),
    [anon_sym_u8_SQUOTE] = ACTIONS(3359),
    [anon_sym_SQUOTE] = ACTIONS(3359),
    [anon_sym_L_DQUOTE] = ACTIONS(3359),
    [anon_sym_u_DQUOTE] = ACTIONS(3359),
    [anon_sym_U_DQUOTE] = ACTIONS(3359),
    [anon_sym_u8_DQUOTE] = ACTIONS(3359),
    [anon_sym_DQUOTE] = ACTIONS(3359),
    [sym_true] = ACTIONS(3357),
    [sym_false] = ACTIONS(3357),
    [anon_sym_NULL] = ACTIONS(3357),
    [anon_sym_nullptr] = ACTIONS(3357),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3357),
    [anon_sym_decltype] = ACTIONS(3357),
    [anon_sym_virtual] = ACTIONS(3357),
    [anon_sym_alignas] = ACTIONS(3357),
    [anon_sym_explicit] = ACTIONS(3357),
    [anon_sym_typename] = ACTIONS(3357),
    [anon_sym_template] = ACTIONS(3357),
    [anon_sym_operator] = ACTIONS(3357),
    [anon_sym_try] = ACTIONS(3357),
    [anon_sym_delete] = ACTIONS(3357),
    [anon_sym_throw] = ACTIONS(3357),
    [anon_sym_namespace] = ACTIONS(3357),
    [anon_sym_using] = ACTIONS(3357),
    [anon_sym_static_assert] = ACTIONS(3357),
    [anon_sym_concept] = ACTIONS(3357),
    [anon_sym_co_return] = ACTIONS(3357),
    [anon_sym_co_yield] = ACTIONS(3357),
    [anon_sym_R_DQUOTE] = ACTIONS(3359),
    [anon_sym_LR_DQUOTE] = ACTIONS(3359),
    [anon_sym_uR_DQUOTE] = ACTIONS(3359),
    [anon_sym_UR_DQUOTE] = ACTIONS(3359),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3359),
    [anon_sym_co_await] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3357),
    [anon_sym_requires] = ACTIONS(3357),
    [sym_this] = ACTIONS(3357),
  },
  [926] = {
    [sym_identifier] = ACTIONS(3361),
    [aux_sym_preproc_include_token1] = ACTIONS(3361),
    [aux_sym_preproc_def_token1] = ACTIONS(3361),
    [aux_sym_preproc_if_token1] = ACTIONS(3361),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3361),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3361),
    [sym_preproc_directive] = ACTIONS(3361),
    [anon_sym_LPAREN2] = ACTIONS(3363),
    [anon_sym_BANG] = ACTIONS(3363),
    [anon_sym_TILDE] = ACTIONS(3363),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_STAR] = ACTIONS(3363),
    [anon_sym_AMP_AMP] = ACTIONS(3363),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_SEMI] = ACTIONS(3363),
    [anon_sym___extension__] = ACTIONS(3361),
    [anon_sym_typedef] = ACTIONS(3361),
    [anon_sym_extern] = ACTIONS(3361),
    [anon_sym___attribute__] = ACTIONS(3361),
    [anon_sym_COLON_COLON] = ACTIONS(3363),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3363),
    [anon_sym___declspec] = ACTIONS(3361),
    [anon_sym___based] = ACTIONS(3361),
    [anon_sym___cdecl] = ACTIONS(3361),
    [anon_sym___clrcall] = ACTIONS(3361),
    [anon_sym___stdcall] = ACTIONS(3361),
    [anon_sym___fastcall] = ACTIONS(3361),
    [anon_sym___thiscall] = ACTIONS(3361),
    [anon_sym___vectorcall] = ACTIONS(3361),
    [anon_sym_LBRACE] = ACTIONS(3363),
    [anon_sym_RBRACE] = ACTIONS(3363),
    [anon_sym_signed] = ACTIONS(3361),
    [anon_sym_unsigned] = ACTIONS(3361),
    [anon_sym_long] = ACTIONS(3361),
    [anon_sym_short] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_static] = ACTIONS(3361),
    [anon_sym_register] = ACTIONS(3361),
    [anon_sym_inline] = ACTIONS(3361),
    [anon_sym___inline] = ACTIONS(3361),
    [anon_sym___inline__] = ACTIONS(3361),
    [anon_sym___forceinline] = ACTIONS(3361),
    [anon_sym_thread_local] = ACTIONS(3361),
    [anon_sym___thread] = ACTIONS(3361),
    [anon_sym_const] = ACTIONS(3361),
    [anon_sym_constexpr] = ACTIONS(3361),
    [anon_sym_volatile] = ACTIONS(3361),
    [anon_sym_restrict] = ACTIONS(3361),
    [anon_sym___restrict__] = ACTIONS(3361),
    [anon_sym__Atomic] = ACTIONS(3361),
    [anon_sym__Noreturn] = ACTIONS(3361),
    [anon_sym_noreturn] = ACTIONS(3361),
    [anon_sym_mutable] = ACTIONS(3361),
    [anon_sym_constinit] = ACTIONS(3361),
    [anon_sym_consteval] = ACTIONS(3361),
    [anon_sym_PROGMEM] = ACTIONS(3361),
    [aux_sym_primitive_type_token1] = ACTIONS(3361),
    [anon_sym_byte] = ACTIONS(3361),
    [anon_sym_word] = ACTIONS(3361),
    [anon_sym_enum] = ACTIONS(3361),
    [anon_sym_class] = ACTIONS(3361),
    [anon_sym_struct] = ACTIONS(3361),
    [anon_sym_union] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_switch] = ACTIONS(3361),
    [anon_sym_case] = ACTIONS(3361),
    [anon_sym_default] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_break] = ACTIONS(3361),
    [anon_sym_continue] = ACTIONS(3361),
    [anon_sym_goto] = ACTIONS(3361),
    [anon_sym___try] = ACTIONS(3361),
    [anon_sym___leave] = ACTIONS(3361),
    [anon_sym_not] = ACTIONS(3361),
    [anon_sym_compl] = ACTIONS(3361),
    [anon_sym_DASH_DASH] = ACTIONS(3363),
    [anon_sym_PLUS_PLUS] = ACTIONS(3363),
    [anon_sym_sizeof] = ACTIONS(3361),
    [anon_sym___alignof__] = ACTIONS(3361),
    [anon_sym___alignof] = ACTIONS(3361),
    [anon_sym__alignof] = ACTIONS(3361),
    [anon_sym_alignof] = ACTIONS(3361),
    [anon_sym__Alignof] = ACTIONS(3361),
    [anon_sym_offsetof] = ACTIONS(3361),
    [anon_sym__Generic] = ACTIONS(3361),
    [anon_sym_asm] = ACTIONS(3361),
    [anon_sym___asm__] = ACTIONS(3361),
    [aux_sym_number_literal_token1] = ACTIONS(3363),
    [aux_sym_number_literal_token2] = ACTIONS(3361),
    [anon_sym_L_SQUOTE] = ACTIONS(3363),
    [anon_sym_u_SQUOTE] = ACTIONS(3363),
    [anon_sym_U_SQUOTE] = ACTIONS(3363),
    [anon_sym_u8_SQUOTE] = ACTIONS(3363),
    [anon_sym_SQUOTE] = ACTIONS(3363),
    [anon_sym_L_DQUOTE] = ACTIONS(3363),
    [anon_sym_u_DQUOTE] = ACTIONS(3363),
    [anon_sym_U_DQUOTE] = ACTIONS(3363),
    [anon_sym_u8_DQUOTE] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3363),
    [sym_true] = ACTIONS(3361),
    [sym_false] = ACTIONS(3361),
    [anon_sym_NULL] = ACTIONS(3361),
    [anon_sym_nullptr] = ACTIONS(3361),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3361),
    [anon_sym_decltype] = ACTIONS(3361),
    [anon_sym_virtual] = ACTIONS(3361),
    [anon_sym_alignas] = ACTIONS(3361),
    [anon_sym_explicit] = ACTIONS(3361),
    [anon_sym_typename] = ACTIONS(3361),
    [anon_sym_template] = ACTIONS(3361),
    [anon_sym_operator] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_delete] = ACTIONS(3361),
    [anon_sym_throw] = ACTIONS(3361),
    [anon_sym_namespace] = ACTIONS(3361),
    [anon_sym_using] = ACTIONS(3361),
    [anon_sym_static_assert] = ACTIONS(3361),
    [anon_sym_concept] = ACTIONS(3361),
    [anon_sym_co_return] = ACTIONS(3361),
    [anon_sym_co_yield] = ACTIONS(3361),
    [anon_sym_R_DQUOTE] = ACTIONS(3363),
    [anon_sym_LR_DQUOTE] = ACTIONS(3363),
    [anon_sym_uR_DQUOTE] = ACTIONS(3363),
    [anon_sym_UR_DQUOTE] = ACTIONS(3363),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3363),
    [anon_sym_co_await] = ACTIONS(3361),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_requires] = ACTIONS(3361),
    [sym_this] = ACTIONS(3361),
  },
  [927] = {
    [sym_identifier] = ACTIONS(3367),
    [aux_sym_preproc_include_token1] = ACTIONS(3367),
    [aux_sym_preproc_def_token1] = ACTIONS(3367),
    [aux_sym_preproc_if_token1] = ACTIONS(3367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3367),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3367),
    [sym_preproc_directive] = ACTIONS(3367),
    [anon_sym_LPAREN2] = ACTIONS(3369),
    [anon_sym_BANG] = ACTIONS(3369),
    [anon_sym_TILDE] = ACTIONS(3369),
    [anon_sym_DASH] = ACTIONS(3367),
    [anon_sym_PLUS] = ACTIONS(3367),
    [anon_sym_STAR] = ACTIONS(3369),
    [anon_sym_AMP_AMP] = ACTIONS(3369),
    [anon_sym_AMP] = ACTIONS(3367),
    [anon_sym_SEMI] = ACTIONS(3369),
    [anon_sym___extension__] = ACTIONS(3367),
    [anon_sym_typedef] = ACTIONS(3367),
    [anon_sym_extern] = ACTIONS(3367),
    [anon_sym___attribute__] = ACTIONS(3367),
    [anon_sym_COLON_COLON] = ACTIONS(3369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3369),
    [anon_sym___declspec] = ACTIONS(3367),
    [anon_sym___based] = ACTIONS(3367),
    [anon_sym___cdecl] = ACTIONS(3367),
    [anon_sym___clrcall] = ACTIONS(3367),
    [anon_sym___stdcall] = ACTIONS(3367),
    [anon_sym___fastcall] = ACTIONS(3367),
    [anon_sym___thiscall] = ACTIONS(3367),
    [anon_sym___vectorcall] = ACTIONS(3367),
    [anon_sym_LBRACE] = ACTIONS(3369),
    [anon_sym_RBRACE] = ACTIONS(3369),
    [anon_sym_signed] = ACTIONS(3367),
    [anon_sym_unsigned] = ACTIONS(3367),
    [anon_sym_long] = ACTIONS(3367),
    [anon_sym_short] = ACTIONS(3367),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_static] = ACTIONS(3367),
    [anon_sym_register] = ACTIONS(3367),
    [anon_sym_inline] = ACTIONS(3367),
    [anon_sym___inline] = ACTIONS(3367),
    [anon_sym___inline__] = ACTIONS(3367),
    [anon_sym___forceinline] = ACTIONS(3367),
    [anon_sym_thread_local] = ACTIONS(3367),
    [anon_sym___thread] = ACTIONS(3367),
    [anon_sym_const] = ACTIONS(3367),
    [anon_sym_constexpr] = ACTIONS(3367),
    [anon_sym_volatile] = ACTIONS(3367),
    [anon_sym_restrict] = ACTIONS(3367),
    [anon_sym___restrict__] = ACTIONS(3367),
    [anon_sym__Atomic] = ACTIONS(3367),
    [anon_sym__Noreturn] = ACTIONS(3367),
    [anon_sym_noreturn] = ACTIONS(3367),
    [anon_sym_mutable] = ACTIONS(3367),
    [anon_sym_constinit] = ACTIONS(3367),
    [anon_sym_consteval] = ACTIONS(3367),
    [anon_sym_PROGMEM] = ACTIONS(3367),
    [aux_sym_primitive_type_token1] = ACTIONS(3367),
    [anon_sym_byte] = ACTIONS(3367),
    [anon_sym_word] = ACTIONS(3367),
    [anon_sym_enum] = ACTIONS(3367),
    [anon_sym_class] = ACTIONS(3367),
    [anon_sym_struct] = ACTIONS(3367),
    [anon_sym_union] = ACTIONS(3367),
    [anon_sym_if] = ACTIONS(3367),
    [anon_sym_switch] = ACTIONS(3367),
    [anon_sym_case] = ACTIONS(3367),
    [anon_sym_default] = ACTIONS(3367),
    [anon_sym_while] = ACTIONS(3367),
    [anon_sym_do] = ACTIONS(3367),
    [anon_sym_for] = ACTIONS(3367),
    [anon_sym_return] = ACTIONS(3367),
    [anon_sym_break] = ACTIONS(3367),
    [anon_sym_continue] = ACTIONS(3367),
    [anon_sym_goto] = ACTIONS(3367),
    [anon_sym___try] = ACTIONS(3367),
    [anon_sym___leave] = ACTIONS(3367),
    [anon_sym_not] = ACTIONS(3367),
    [anon_sym_compl] = ACTIONS(3367),
    [anon_sym_DASH_DASH] = ACTIONS(3369),
    [anon_sym_PLUS_PLUS] = ACTIONS(3369),
    [anon_sym_sizeof] = ACTIONS(3367),
    [anon_sym___alignof__] = ACTIONS(3367),
    [anon_sym___alignof] = ACTIONS(3367),
    [anon_sym__alignof] = ACTIONS(3367),
    [anon_sym_alignof] = ACTIONS(3367),
    [anon_sym__Alignof] = ACTIONS(3367),
    [anon_sym_offsetof] = ACTIONS(3367),
    [anon_sym__Generic] = ACTIONS(3367),
    [anon_sym_asm] = ACTIONS(3367),
    [anon_sym___asm__] = ACTIONS(3367),
    [aux_sym_number_literal_token1] = ACTIONS(3369),
    [aux_sym_number_literal_token2] = ACTIONS(3367),
    [anon_sym_L_SQUOTE] = ACTIONS(3369),
    [anon_sym_u_SQUOTE] = ACTIONS(3369),
    [anon_sym_U_SQUOTE] = ACTIONS(3369),
    [anon_sym_u8_SQUOTE] = ACTIONS(3369),
    [anon_sym_SQUOTE] = ACTIONS(3369),
    [anon_sym_L_DQUOTE] = ACTIONS(3369),
    [anon_sym_u_DQUOTE] = ACTIONS(3369),
    [anon_sym_U_DQUOTE] = ACTIONS(3369),
    [anon_sym_u8_DQUOTE] = ACTIONS(3369),
    [anon_sym_DQUOTE] = ACTIONS(3369),
    [sym_true] = ACTIONS(3367),
    [sym_false] = ACTIONS(3367),
    [anon_sym_NULL] = ACTIONS(3367),
    [anon_sym_nullptr] = ACTIONS(3367),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3367),
    [anon_sym_decltype] = ACTIONS(3367),
    [anon_sym_virtual] = ACTIONS(3367),
    [anon_sym_alignas] = ACTIONS(3367),
    [anon_sym_explicit] = ACTIONS(3367),
    [anon_sym_typename] = ACTIONS(3367),
    [anon_sym_template] = ACTIONS(3367),
    [anon_sym_operator] = ACTIONS(3367),
    [anon_sym_try] = ACTIONS(3367),
    [anon_sym_delete] = ACTIONS(3367),
    [anon_sym_throw] = ACTIONS(3367),
    [anon_sym_namespace] = ACTIONS(3367),
    [anon_sym_using] = ACTIONS(3367),
    [anon_sym_static_assert] = ACTIONS(3367),
    [anon_sym_concept] = ACTIONS(3367),
    [anon_sym_co_return] = ACTIONS(3367),
    [anon_sym_co_yield] = ACTIONS(3367),
    [anon_sym_R_DQUOTE] = ACTIONS(3369),
    [anon_sym_LR_DQUOTE] = ACTIONS(3369),
    [anon_sym_uR_DQUOTE] = ACTIONS(3369),
    [anon_sym_UR_DQUOTE] = ACTIONS(3369),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3369),
    [anon_sym_co_await] = ACTIONS(3367),
    [anon_sym_new] = ACTIONS(3367),
    [anon_sym_requires] = ACTIONS(3367),
    [sym_this] = ACTIONS(3367),
  },
  [928] = {
    [sym_identifier] = ACTIONS(3431),
    [aux_sym_preproc_include_token1] = ACTIONS(3431),
    [aux_sym_preproc_def_token1] = ACTIONS(3431),
    [aux_sym_preproc_if_token1] = ACTIONS(3431),
    [aux_sym_preproc_if_token2] = ACTIONS(3431),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3431),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3431),
    [sym_preproc_directive] = ACTIONS(3431),
    [anon_sym_LPAREN2] = ACTIONS(3433),
    [anon_sym_BANG] = ACTIONS(3433),
    [anon_sym_TILDE] = ACTIONS(3433),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3433),
    [anon_sym_AMP_AMP] = ACTIONS(3433),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_SEMI] = ACTIONS(3433),
    [anon_sym___extension__] = ACTIONS(3431),
    [anon_sym_typedef] = ACTIONS(3431),
    [anon_sym_extern] = ACTIONS(3431),
    [anon_sym___attribute__] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3433),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3433),
    [anon_sym___declspec] = ACTIONS(3431),
    [anon_sym___based] = ACTIONS(3431),
    [anon_sym___cdecl] = ACTIONS(3431),
    [anon_sym___clrcall] = ACTIONS(3431),
    [anon_sym___stdcall] = ACTIONS(3431),
    [anon_sym___fastcall] = ACTIONS(3431),
    [anon_sym___thiscall] = ACTIONS(3431),
    [anon_sym___vectorcall] = ACTIONS(3431),
    [anon_sym_LBRACE] = ACTIONS(3433),
    [anon_sym_signed] = ACTIONS(3431),
    [anon_sym_unsigned] = ACTIONS(3431),
    [anon_sym_long] = ACTIONS(3431),
    [anon_sym_short] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_static] = ACTIONS(3431),
    [anon_sym_register] = ACTIONS(3431),
    [anon_sym_inline] = ACTIONS(3431),
    [anon_sym___inline] = ACTIONS(3431),
    [anon_sym___inline__] = ACTIONS(3431),
    [anon_sym___forceinline] = ACTIONS(3431),
    [anon_sym_thread_local] = ACTIONS(3431),
    [anon_sym___thread] = ACTIONS(3431),
    [anon_sym_const] = ACTIONS(3431),
    [anon_sym_constexpr] = ACTIONS(3431),
    [anon_sym_volatile] = ACTIONS(3431),
    [anon_sym_restrict] = ACTIONS(3431),
    [anon_sym___restrict__] = ACTIONS(3431),
    [anon_sym__Atomic] = ACTIONS(3431),
    [anon_sym__Noreturn] = ACTIONS(3431),
    [anon_sym_noreturn] = ACTIONS(3431),
    [anon_sym_mutable] = ACTIONS(3431),
    [anon_sym_constinit] = ACTIONS(3431),
    [anon_sym_consteval] = ACTIONS(3431),
    [anon_sym_PROGMEM] = ACTIONS(3431),
    [aux_sym_primitive_type_token1] = ACTIONS(3431),
    [anon_sym_byte] = ACTIONS(3431),
    [anon_sym_word] = ACTIONS(3431),
    [anon_sym_enum] = ACTIONS(3431),
    [anon_sym_class] = ACTIONS(3431),
    [anon_sym_struct] = ACTIONS(3431),
    [anon_sym_union] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_switch] = ACTIONS(3431),
    [anon_sym_case] = ACTIONS(3431),
    [anon_sym_default] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_break] = ACTIONS(3431),
    [anon_sym_continue] = ACTIONS(3431),
    [anon_sym_goto] = ACTIONS(3431),
    [anon_sym___try] = ACTIONS(3431),
    [anon_sym___leave] = ACTIONS(3431),
    [anon_sym_not] = ACTIONS(3431),
    [anon_sym_compl] = ACTIONS(3431),
    [anon_sym_DASH_DASH] = ACTIONS(3433),
    [anon_sym_PLUS_PLUS] = ACTIONS(3433),
    [anon_sym_sizeof] = ACTIONS(3431),
    [anon_sym___alignof__] = ACTIONS(3431),
    [anon_sym___alignof] = ACTIONS(3431),
    [anon_sym__alignof] = ACTIONS(3431),
    [anon_sym_alignof] = ACTIONS(3431),
    [anon_sym__Alignof] = ACTIONS(3431),
    [anon_sym_offsetof] = ACTIONS(3431),
    [anon_sym__Generic] = ACTIONS(3431),
    [anon_sym_asm] = ACTIONS(3431),
    [anon_sym___asm__] = ACTIONS(3431),
    [aux_sym_number_literal_token1] = ACTIONS(3433),
    [aux_sym_number_literal_token2] = ACTIONS(3431),
    [anon_sym_L_SQUOTE] = ACTIONS(3433),
    [anon_sym_u_SQUOTE] = ACTIONS(3433),
    [anon_sym_U_SQUOTE] = ACTIONS(3433),
    [anon_sym_u8_SQUOTE] = ACTIONS(3433),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [anon_sym_L_DQUOTE] = ACTIONS(3433),
    [anon_sym_u_DQUOTE] = ACTIONS(3433),
    [anon_sym_U_DQUOTE] = ACTIONS(3433),
    [anon_sym_u8_DQUOTE] = ACTIONS(3433),
    [anon_sym_DQUOTE] = ACTIONS(3433),
    [sym_true] = ACTIONS(3431),
    [sym_false] = ACTIONS(3431),
    [anon_sym_NULL] = ACTIONS(3431),
    [anon_sym_nullptr] = ACTIONS(3431),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3431),
    [anon_sym_decltype] = ACTIONS(3431),
    [anon_sym_virtual] = ACTIONS(3431),
    [anon_sym_alignas] = ACTIONS(3431),
    [anon_sym_explicit] = ACTIONS(3431),
    [anon_sym_typename] = ACTIONS(3431),
    [anon_sym_template] = ACTIONS(3431),
    [anon_sym_operator] = ACTIONS(3431),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_delete] = ACTIONS(3431),
    [anon_sym_throw] = ACTIONS(3431),
    [anon_sym_namespace] = ACTIONS(3431),
    [anon_sym_using] = ACTIONS(3431),
    [anon_sym_static_assert] = ACTIONS(3431),
    [anon_sym_concept] = ACTIONS(3431),
    [anon_sym_co_return] = ACTIONS(3431),
    [anon_sym_co_yield] = ACTIONS(3431),
    [anon_sym_R_DQUOTE] = ACTIONS(3433),
    [anon_sym_LR_DQUOTE] = ACTIONS(3433),
    [anon_sym_uR_DQUOTE] = ACTIONS(3433),
    [anon_sym_UR_DQUOTE] = ACTIONS(3433),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3433),
    [anon_sym_co_await] = ACTIONS(3431),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_requires] = ACTIONS(3431),
    [sym_this] = ACTIONS(3431),
  },
  [929] = {
    [sym_identifier] = ACTIONS(3419),
    [aux_sym_preproc_include_token1] = ACTIONS(3419),
    [aux_sym_preproc_def_token1] = ACTIONS(3419),
    [aux_sym_preproc_if_token1] = ACTIONS(3419),
    [aux_sym_preproc_if_token2] = ACTIONS(3419),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3419),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3419),
    [sym_preproc_directive] = ACTIONS(3419),
    [anon_sym_LPAREN2] = ACTIONS(3421),
    [anon_sym_BANG] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_SEMI] = ACTIONS(3421),
    [anon_sym___extension__] = ACTIONS(3419),
    [anon_sym_typedef] = ACTIONS(3419),
    [anon_sym_extern] = ACTIONS(3419),
    [anon_sym___attribute__] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3421),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3421),
    [anon_sym___declspec] = ACTIONS(3419),
    [anon_sym___based] = ACTIONS(3419),
    [anon_sym___cdecl] = ACTIONS(3419),
    [anon_sym___clrcall] = ACTIONS(3419),
    [anon_sym___stdcall] = ACTIONS(3419),
    [anon_sym___fastcall] = ACTIONS(3419),
    [anon_sym___thiscall] = ACTIONS(3419),
    [anon_sym___vectorcall] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_signed] = ACTIONS(3419),
    [anon_sym_unsigned] = ACTIONS(3419),
    [anon_sym_long] = ACTIONS(3419),
    [anon_sym_short] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_register] = ACTIONS(3419),
    [anon_sym_inline] = ACTIONS(3419),
    [anon_sym___inline] = ACTIONS(3419),
    [anon_sym___inline__] = ACTIONS(3419),
    [anon_sym___forceinline] = ACTIONS(3419),
    [anon_sym_thread_local] = ACTIONS(3419),
    [anon_sym___thread] = ACTIONS(3419),
    [anon_sym_const] = ACTIONS(3419),
    [anon_sym_constexpr] = ACTIONS(3419),
    [anon_sym_volatile] = ACTIONS(3419),
    [anon_sym_restrict] = ACTIONS(3419),
    [anon_sym___restrict__] = ACTIONS(3419),
    [anon_sym__Atomic] = ACTIONS(3419),
    [anon_sym__Noreturn] = ACTIONS(3419),
    [anon_sym_noreturn] = ACTIONS(3419),
    [anon_sym_mutable] = ACTIONS(3419),
    [anon_sym_constinit] = ACTIONS(3419),
    [anon_sym_consteval] = ACTIONS(3419),
    [anon_sym_PROGMEM] = ACTIONS(3419),
    [aux_sym_primitive_type_token1] = ACTIONS(3419),
    [anon_sym_byte] = ACTIONS(3419),
    [anon_sym_word] = ACTIONS(3419),
    [anon_sym_enum] = ACTIONS(3419),
    [anon_sym_class] = ACTIONS(3419),
    [anon_sym_struct] = ACTIONS(3419),
    [anon_sym_union] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_switch] = ACTIONS(3419),
    [anon_sym_case] = ACTIONS(3419),
    [anon_sym_default] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_break] = ACTIONS(3419),
    [anon_sym_continue] = ACTIONS(3419),
    [anon_sym_goto] = ACTIONS(3419),
    [anon_sym___try] = ACTIONS(3419),
    [anon_sym___leave] = ACTIONS(3419),
    [anon_sym_not] = ACTIONS(3419),
    [anon_sym_compl] = ACTIONS(3419),
    [anon_sym_DASH_DASH] = ACTIONS(3421),
    [anon_sym_PLUS_PLUS] = ACTIONS(3421),
    [anon_sym_sizeof] = ACTIONS(3419),
    [anon_sym___alignof__] = ACTIONS(3419),
    [anon_sym___alignof] = ACTIONS(3419),
    [anon_sym__alignof] = ACTIONS(3419),
    [anon_sym_alignof] = ACTIONS(3419),
    [anon_sym__Alignof] = ACTIONS(3419),
    [anon_sym_offsetof] = ACTIONS(3419),
    [anon_sym__Generic] = ACTIONS(3419),
    [anon_sym_asm] = ACTIONS(3419),
    [anon_sym___asm__] = ACTIONS(3419),
    [aux_sym_number_literal_token1] = ACTIONS(3421),
    [aux_sym_number_literal_token2] = ACTIONS(3419),
    [anon_sym_L_SQUOTE] = ACTIONS(3421),
    [anon_sym_u_SQUOTE] = ACTIONS(3421),
    [anon_sym_U_SQUOTE] = ACTIONS(3421),
    [anon_sym_u8_SQUOTE] = ACTIONS(3421),
    [anon_sym_SQUOTE] = ACTIONS(3421),
    [anon_sym_L_DQUOTE] = ACTIONS(3421),
    [anon_sym_u_DQUOTE] = ACTIONS(3421),
    [anon_sym_U_DQUOTE] = ACTIONS(3421),
    [anon_sym_u8_DQUOTE] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [sym_true] = ACTIONS(3419),
    [sym_false] = ACTIONS(3419),
    [anon_sym_NULL] = ACTIONS(3419),
    [anon_sym_nullptr] = ACTIONS(3419),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3419),
    [anon_sym_decltype] = ACTIONS(3419),
    [anon_sym_virtual] = ACTIONS(3419),
    [anon_sym_alignas] = ACTIONS(3419),
    [anon_sym_explicit] = ACTIONS(3419),
    [anon_sym_typename] = ACTIONS(3419),
    [anon_sym_template] = ACTIONS(3419),
    [anon_sym_operator] = ACTIONS(3419),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_delete] = ACTIONS(3419),
    [anon_sym_throw] = ACTIONS(3419),
    [anon_sym_namespace] = ACTIONS(3419),
    [anon_sym_using] = ACTIONS(3419),
    [anon_sym_static_assert] = ACTIONS(3419),
    [anon_sym_concept] = ACTIONS(3419),
    [anon_sym_co_return] = ACTIONS(3419),
    [anon_sym_co_yield] = ACTIONS(3419),
    [anon_sym_R_DQUOTE] = ACTIONS(3421),
    [anon_sym_LR_DQUOTE] = ACTIONS(3421),
    [anon_sym_uR_DQUOTE] = ACTIONS(3421),
    [anon_sym_UR_DQUOTE] = ACTIONS(3421),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3421),
    [anon_sym_co_await] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_requires] = ACTIONS(3419),
    [sym_this] = ACTIONS(3419),
  },
  [930] = {
    [sym_identifier] = ACTIONS(3178),
    [aux_sym_preproc_include_token1] = ACTIONS(3178),
    [aux_sym_preproc_def_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3178),
    [sym_preproc_directive] = ACTIONS(3178),
    [anon_sym_LPAREN2] = ACTIONS(3180),
    [anon_sym_BANG] = ACTIONS(3180),
    [anon_sym_TILDE] = ACTIONS(3180),
    [anon_sym_DASH] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3178),
    [anon_sym_STAR] = ACTIONS(3180),
    [anon_sym_AMP_AMP] = ACTIONS(3180),
    [anon_sym_AMP] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3180),
    [anon_sym___extension__] = ACTIONS(3178),
    [anon_sym_typedef] = ACTIONS(3178),
    [anon_sym_extern] = ACTIONS(3178),
    [anon_sym___attribute__] = ACTIONS(3178),
    [anon_sym_COLON_COLON] = ACTIONS(3180),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3180),
    [anon_sym___declspec] = ACTIONS(3178),
    [anon_sym___based] = ACTIONS(3178),
    [anon_sym___cdecl] = ACTIONS(3178),
    [anon_sym___clrcall] = ACTIONS(3178),
    [anon_sym___stdcall] = ACTIONS(3178),
    [anon_sym___fastcall] = ACTIONS(3178),
    [anon_sym___thiscall] = ACTIONS(3178),
    [anon_sym___vectorcall] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3180),
    [anon_sym_RBRACE] = ACTIONS(3180),
    [anon_sym_signed] = ACTIONS(3178),
    [anon_sym_unsigned] = ACTIONS(3178),
    [anon_sym_long] = ACTIONS(3178),
    [anon_sym_short] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_static] = ACTIONS(3178),
    [anon_sym_register] = ACTIONS(3178),
    [anon_sym_inline] = ACTIONS(3178),
    [anon_sym___inline] = ACTIONS(3178),
    [anon_sym___inline__] = ACTIONS(3178),
    [anon_sym___forceinline] = ACTIONS(3178),
    [anon_sym_thread_local] = ACTIONS(3178),
    [anon_sym___thread] = ACTIONS(3178),
    [anon_sym_const] = ACTIONS(3178),
    [anon_sym_constexpr] = ACTIONS(3178),
    [anon_sym_volatile] = ACTIONS(3178),
    [anon_sym_restrict] = ACTIONS(3178),
    [anon_sym___restrict__] = ACTIONS(3178),
    [anon_sym__Atomic] = ACTIONS(3178),
    [anon_sym__Noreturn] = ACTIONS(3178),
    [anon_sym_noreturn] = ACTIONS(3178),
    [anon_sym_mutable] = ACTIONS(3178),
    [anon_sym_constinit] = ACTIONS(3178),
    [anon_sym_consteval] = ACTIONS(3178),
    [anon_sym_PROGMEM] = ACTIONS(3178),
    [aux_sym_primitive_type_token1] = ACTIONS(3178),
    [anon_sym_byte] = ACTIONS(3178),
    [anon_sym_word] = ACTIONS(3178),
    [anon_sym_enum] = ACTIONS(3178),
    [anon_sym_class] = ACTIONS(3178),
    [anon_sym_struct] = ACTIONS(3178),
    [anon_sym_union] = ACTIONS(3178),
    [anon_sym_if] = ACTIONS(3178),
    [anon_sym_switch] = ACTIONS(3178),
    [anon_sym_case] = ACTIONS(3178),
    [anon_sym_default] = ACTIONS(3178),
    [anon_sym_while] = ACTIONS(3178),
    [anon_sym_do] = ACTIONS(3178),
    [anon_sym_for] = ACTIONS(3178),
    [anon_sym_return] = ACTIONS(3178),
    [anon_sym_break] = ACTIONS(3178),
    [anon_sym_continue] = ACTIONS(3178),
    [anon_sym_goto] = ACTIONS(3178),
    [anon_sym___try] = ACTIONS(3178),
    [anon_sym___leave] = ACTIONS(3178),
    [anon_sym_not] = ACTIONS(3178),
    [anon_sym_compl] = ACTIONS(3178),
    [anon_sym_DASH_DASH] = ACTIONS(3180),
    [anon_sym_PLUS_PLUS] = ACTIONS(3180),
    [anon_sym_sizeof] = ACTIONS(3178),
    [anon_sym___alignof__] = ACTIONS(3178),
    [anon_sym___alignof] = ACTIONS(3178),
    [anon_sym__alignof] = ACTIONS(3178),
    [anon_sym_alignof] = ACTIONS(3178),
    [anon_sym__Alignof] = ACTIONS(3178),
    [anon_sym_offsetof] = ACTIONS(3178),
    [anon_sym__Generic] = ACTIONS(3178),
    [anon_sym_asm] = ACTIONS(3178),
    [anon_sym___asm__] = ACTIONS(3178),
    [aux_sym_number_literal_token1] = ACTIONS(3180),
    [aux_sym_number_literal_token2] = ACTIONS(3178),
    [anon_sym_L_SQUOTE] = ACTIONS(3180),
    [anon_sym_u_SQUOTE] = ACTIONS(3180),
    [anon_sym_U_SQUOTE] = ACTIONS(3180),
    [anon_sym_u8_SQUOTE] = ACTIONS(3180),
    [anon_sym_SQUOTE] = ACTIONS(3180),
    [anon_sym_L_DQUOTE] = ACTIONS(3180),
    [anon_sym_u_DQUOTE] = ACTIONS(3180),
    [anon_sym_U_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8_DQUOTE] = ACTIONS(3180),
    [anon_sym_DQUOTE] = ACTIONS(3180),
    [sym_true] = ACTIONS(3178),
    [sym_false] = ACTIONS(3178),
    [anon_sym_NULL] = ACTIONS(3178),
    [anon_sym_nullptr] = ACTIONS(3178),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3178),
    [anon_sym_decltype] = ACTIONS(3178),
    [anon_sym_virtual] = ACTIONS(3178),
    [anon_sym_alignas] = ACTIONS(3178),
    [anon_sym_explicit] = ACTIONS(3178),
    [anon_sym_typename] = ACTIONS(3178),
    [anon_sym_template] = ACTIONS(3178),
    [anon_sym_operator] = ACTIONS(3178),
    [anon_sym_try] = ACTIONS(3178),
    [anon_sym_delete] = ACTIONS(3178),
    [anon_sym_throw] = ACTIONS(3178),
    [anon_sym_namespace] = ACTIONS(3178),
    [anon_sym_using] = ACTIONS(3178),
    [anon_sym_static_assert] = ACTIONS(3178),
    [anon_sym_concept] = ACTIONS(3178),
    [anon_sym_co_return] = ACTIONS(3178),
    [anon_sym_co_yield] = ACTIONS(3178),
    [anon_sym_R_DQUOTE] = ACTIONS(3180),
    [anon_sym_LR_DQUOTE] = ACTIONS(3180),
    [anon_sym_uR_DQUOTE] = ACTIONS(3180),
    [anon_sym_UR_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3180),
    [anon_sym_co_await] = ACTIONS(3178),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3178),
    [sym_this] = ACTIONS(3178),
  },
  [931] = {
    [sym_identifier] = ACTIONS(3375),
    [aux_sym_preproc_include_token1] = ACTIONS(3375),
    [aux_sym_preproc_def_token1] = ACTIONS(3375),
    [aux_sym_preproc_if_token1] = ACTIONS(3375),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3375),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3375),
    [sym_preproc_directive] = ACTIONS(3375),
    [anon_sym_LPAREN2] = ACTIONS(3377),
    [anon_sym_BANG] = ACTIONS(3377),
    [anon_sym_TILDE] = ACTIONS(3377),
    [anon_sym_DASH] = ACTIONS(3375),
    [anon_sym_PLUS] = ACTIONS(3375),
    [anon_sym_STAR] = ACTIONS(3377),
    [anon_sym_AMP_AMP] = ACTIONS(3377),
    [anon_sym_AMP] = ACTIONS(3375),
    [anon_sym_SEMI] = ACTIONS(3377),
    [anon_sym___extension__] = ACTIONS(3375),
    [anon_sym_typedef] = ACTIONS(3375),
    [anon_sym_extern] = ACTIONS(3375),
    [anon_sym___attribute__] = ACTIONS(3375),
    [anon_sym_COLON_COLON] = ACTIONS(3377),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3377),
    [anon_sym___declspec] = ACTIONS(3375),
    [anon_sym___based] = ACTIONS(3375),
    [anon_sym___cdecl] = ACTIONS(3375),
    [anon_sym___clrcall] = ACTIONS(3375),
    [anon_sym___stdcall] = ACTIONS(3375),
    [anon_sym___fastcall] = ACTIONS(3375),
    [anon_sym___thiscall] = ACTIONS(3375),
    [anon_sym___vectorcall] = ACTIONS(3375),
    [anon_sym_LBRACE] = ACTIONS(3377),
    [anon_sym_RBRACE] = ACTIONS(3377),
    [anon_sym_signed] = ACTIONS(3375),
    [anon_sym_unsigned] = ACTIONS(3375),
    [anon_sym_long] = ACTIONS(3375),
    [anon_sym_short] = ACTIONS(3375),
    [anon_sym_LBRACK] = ACTIONS(3375),
    [anon_sym_static] = ACTIONS(3375),
    [anon_sym_register] = ACTIONS(3375),
    [anon_sym_inline] = ACTIONS(3375),
    [anon_sym___inline] = ACTIONS(3375),
    [anon_sym___inline__] = ACTIONS(3375),
    [anon_sym___forceinline] = ACTIONS(3375),
    [anon_sym_thread_local] = ACTIONS(3375),
    [anon_sym___thread] = ACTIONS(3375),
    [anon_sym_const] = ACTIONS(3375),
    [anon_sym_constexpr] = ACTIONS(3375),
    [anon_sym_volatile] = ACTIONS(3375),
    [anon_sym_restrict] = ACTIONS(3375),
    [anon_sym___restrict__] = ACTIONS(3375),
    [anon_sym__Atomic] = ACTIONS(3375),
    [anon_sym__Noreturn] = ACTIONS(3375),
    [anon_sym_noreturn] = ACTIONS(3375),
    [anon_sym_mutable] = ACTIONS(3375),
    [anon_sym_constinit] = ACTIONS(3375),
    [anon_sym_consteval] = ACTIONS(3375),
    [anon_sym_PROGMEM] = ACTIONS(3375),
    [aux_sym_primitive_type_token1] = ACTIONS(3375),
    [anon_sym_byte] = ACTIONS(3375),
    [anon_sym_word] = ACTIONS(3375),
    [anon_sym_enum] = ACTIONS(3375),
    [anon_sym_class] = ACTIONS(3375),
    [anon_sym_struct] = ACTIONS(3375),
    [anon_sym_union] = ACTIONS(3375),
    [anon_sym_if] = ACTIONS(3375),
    [anon_sym_switch] = ACTIONS(3375),
    [anon_sym_case] = ACTIONS(3375),
    [anon_sym_default] = ACTIONS(3375),
    [anon_sym_while] = ACTIONS(3375),
    [anon_sym_do] = ACTIONS(3375),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_return] = ACTIONS(3375),
    [anon_sym_break] = ACTIONS(3375),
    [anon_sym_continue] = ACTIONS(3375),
    [anon_sym_goto] = ACTIONS(3375),
    [anon_sym___try] = ACTIONS(3375),
    [anon_sym___leave] = ACTIONS(3375),
    [anon_sym_not] = ACTIONS(3375),
    [anon_sym_compl] = ACTIONS(3375),
    [anon_sym_DASH_DASH] = ACTIONS(3377),
    [anon_sym_PLUS_PLUS] = ACTIONS(3377),
    [anon_sym_sizeof] = ACTIONS(3375),
    [anon_sym___alignof__] = ACTIONS(3375),
    [anon_sym___alignof] = ACTIONS(3375),
    [anon_sym__alignof] = ACTIONS(3375),
    [anon_sym_alignof] = ACTIONS(3375),
    [anon_sym__Alignof] = ACTIONS(3375),
    [anon_sym_offsetof] = ACTIONS(3375),
    [anon_sym__Generic] = ACTIONS(3375),
    [anon_sym_asm] = ACTIONS(3375),
    [anon_sym___asm__] = ACTIONS(3375),
    [aux_sym_number_literal_token1] = ACTIONS(3377),
    [aux_sym_number_literal_token2] = ACTIONS(3375),
    [anon_sym_L_SQUOTE] = ACTIONS(3377),
    [anon_sym_u_SQUOTE] = ACTIONS(3377),
    [anon_sym_U_SQUOTE] = ACTIONS(3377),
    [anon_sym_u8_SQUOTE] = ACTIONS(3377),
    [anon_sym_SQUOTE] = ACTIONS(3377),
    [anon_sym_L_DQUOTE] = ACTIONS(3377),
    [anon_sym_u_DQUOTE] = ACTIONS(3377),
    [anon_sym_U_DQUOTE] = ACTIONS(3377),
    [anon_sym_u8_DQUOTE] = ACTIONS(3377),
    [anon_sym_DQUOTE] = ACTIONS(3377),
    [sym_true] = ACTIONS(3375),
    [sym_false] = ACTIONS(3375),
    [anon_sym_NULL] = ACTIONS(3375),
    [anon_sym_nullptr] = ACTIONS(3375),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3375),
    [anon_sym_decltype] = ACTIONS(3375),
    [anon_sym_virtual] = ACTIONS(3375),
    [anon_sym_alignas] = ACTIONS(3375),
    [anon_sym_explicit] = ACTIONS(3375),
    [anon_sym_typename] = ACTIONS(3375),
    [anon_sym_template] = ACTIONS(3375),
    [anon_sym_operator] = ACTIONS(3375),
    [anon_sym_try] = ACTIONS(3375),
    [anon_sym_delete] = ACTIONS(3375),
    [anon_sym_throw] = ACTIONS(3375),
    [anon_sym_namespace] = ACTIONS(3375),
    [anon_sym_using] = ACTIONS(3375),
    [anon_sym_static_assert] = ACTIONS(3375),
    [anon_sym_concept] = ACTIONS(3375),
    [anon_sym_co_return] = ACTIONS(3375),
    [anon_sym_co_yield] = ACTIONS(3375),
    [anon_sym_R_DQUOTE] = ACTIONS(3377),
    [anon_sym_LR_DQUOTE] = ACTIONS(3377),
    [anon_sym_uR_DQUOTE] = ACTIONS(3377),
    [anon_sym_UR_DQUOTE] = ACTIONS(3377),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3377),
    [anon_sym_co_await] = ACTIONS(3375),
    [anon_sym_new] = ACTIONS(3375),
    [anon_sym_requires] = ACTIONS(3375),
    [sym_this] = ACTIONS(3375),
  },
  [932] = {
    [sym_identifier] = ACTIONS(3495),
    [aux_sym_preproc_include_token1] = ACTIONS(3495),
    [aux_sym_preproc_def_token1] = ACTIONS(3495),
    [aux_sym_preproc_if_token1] = ACTIONS(3495),
    [aux_sym_preproc_if_token2] = ACTIONS(3495),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3495),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3495),
    [sym_preproc_directive] = ACTIONS(3495),
    [anon_sym_LPAREN2] = ACTIONS(3497),
    [anon_sym_BANG] = ACTIONS(3497),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_AMP_AMP] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(3495),
    [anon_sym_SEMI] = ACTIONS(3497),
    [anon_sym___extension__] = ACTIONS(3495),
    [anon_sym_typedef] = ACTIONS(3495),
    [anon_sym_extern] = ACTIONS(3495),
    [anon_sym___attribute__] = ACTIONS(3495),
    [anon_sym_COLON_COLON] = ACTIONS(3497),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3497),
    [anon_sym___declspec] = ACTIONS(3495),
    [anon_sym___based] = ACTIONS(3495),
    [anon_sym___cdecl] = ACTIONS(3495),
    [anon_sym___clrcall] = ACTIONS(3495),
    [anon_sym___stdcall] = ACTIONS(3495),
    [anon_sym___fastcall] = ACTIONS(3495),
    [anon_sym___thiscall] = ACTIONS(3495),
    [anon_sym___vectorcall] = ACTIONS(3495),
    [anon_sym_LBRACE] = ACTIONS(3497),
    [anon_sym_signed] = ACTIONS(3495),
    [anon_sym_unsigned] = ACTIONS(3495),
    [anon_sym_long] = ACTIONS(3495),
    [anon_sym_short] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(3495),
    [anon_sym_static] = ACTIONS(3495),
    [anon_sym_register] = ACTIONS(3495),
    [anon_sym_inline] = ACTIONS(3495),
    [anon_sym___inline] = ACTIONS(3495),
    [anon_sym___inline__] = ACTIONS(3495),
    [anon_sym___forceinline] = ACTIONS(3495),
    [anon_sym_thread_local] = ACTIONS(3495),
    [anon_sym___thread] = ACTIONS(3495),
    [anon_sym_const] = ACTIONS(3495),
    [anon_sym_constexpr] = ACTIONS(3495),
    [anon_sym_volatile] = ACTIONS(3495),
    [anon_sym_restrict] = ACTIONS(3495),
    [anon_sym___restrict__] = ACTIONS(3495),
    [anon_sym__Atomic] = ACTIONS(3495),
    [anon_sym__Noreturn] = ACTIONS(3495),
    [anon_sym_noreturn] = ACTIONS(3495),
    [anon_sym_mutable] = ACTIONS(3495),
    [anon_sym_constinit] = ACTIONS(3495),
    [anon_sym_consteval] = ACTIONS(3495),
    [anon_sym_PROGMEM] = ACTIONS(3495),
    [aux_sym_primitive_type_token1] = ACTIONS(3495),
    [anon_sym_byte] = ACTIONS(3495),
    [anon_sym_word] = ACTIONS(3495),
    [anon_sym_enum] = ACTIONS(3495),
    [anon_sym_class] = ACTIONS(3495),
    [anon_sym_struct] = ACTIONS(3495),
    [anon_sym_union] = ACTIONS(3495),
    [anon_sym_if] = ACTIONS(3495),
    [anon_sym_switch] = ACTIONS(3495),
    [anon_sym_case] = ACTIONS(3495),
    [anon_sym_default] = ACTIONS(3495),
    [anon_sym_while] = ACTIONS(3495),
    [anon_sym_do] = ACTIONS(3495),
    [anon_sym_for] = ACTIONS(3495),
    [anon_sym_return] = ACTIONS(3495),
    [anon_sym_break] = ACTIONS(3495),
    [anon_sym_continue] = ACTIONS(3495),
    [anon_sym_goto] = ACTIONS(3495),
    [anon_sym___try] = ACTIONS(3495),
    [anon_sym___leave] = ACTIONS(3495),
    [anon_sym_not] = ACTIONS(3495),
    [anon_sym_compl] = ACTIONS(3495),
    [anon_sym_DASH_DASH] = ACTIONS(3497),
    [anon_sym_PLUS_PLUS] = ACTIONS(3497),
    [anon_sym_sizeof] = ACTIONS(3495),
    [anon_sym___alignof__] = ACTIONS(3495),
    [anon_sym___alignof] = ACTIONS(3495),
    [anon_sym__alignof] = ACTIONS(3495),
    [anon_sym_alignof] = ACTIONS(3495),
    [anon_sym__Alignof] = ACTIONS(3495),
    [anon_sym_offsetof] = ACTIONS(3495),
    [anon_sym__Generic] = ACTIONS(3495),
    [anon_sym_asm] = ACTIONS(3495),
    [anon_sym___asm__] = ACTIONS(3495),
    [aux_sym_number_literal_token1] = ACTIONS(3497),
    [aux_sym_number_literal_token2] = ACTIONS(3495),
    [anon_sym_L_SQUOTE] = ACTIONS(3497),
    [anon_sym_u_SQUOTE] = ACTIONS(3497),
    [anon_sym_U_SQUOTE] = ACTIONS(3497),
    [anon_sym_u8_SQUOTE] = ACTIONS(3497),
    [anon_sym_SQUOTE] = ACTIONS(3497),
    [anon_sym_L_DQUOTE] = ACTIONS(3497),
    [anon_sym_u_DQUOTE] = ACTIONS(3497),
    [anon_sym_U_DQUOTE] = ACTIONS(3497),
    [anon_sym_u8_DQUOTE] = ACTIONS(3497),
    [anon_sym_DQUOTE] = ACTIONS(3497),
    [sym_true] = ACTIONS(3495),
    [sym_false] = ACTIONS(3495),
    [anon_sym_NULL] = ACTIONS(3495),
    [anon_sym_nullptr] = ACTIONS(3495),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3495),
    [anon_sym_decltype] = ACTIONS(3495),
    [anon_sym_virtual] = ACTIONS(3495),
    [anon_sym_alignas] = ACTIONS(3495),
    [anon_sym_explicit] = ACTIONS(3495),
    [anon_sym_typename] = ACTIONS(3495),
    [anon_sym_template] = ACTIONS(3495),
    [anon_sym_operator] = ACTIONS(3495),
    [anon_sym_try] = ACTIONS(3495),
    [anon_sym_delete] = ACTIONS(3495),
    [anon_sym_throw] = ACTIONS(3495),
    [anon_sym_namespace] = ACTIONS(3495),
    [anon_sym_using] = ACTIONS(3495),
    [anon_sym_static_assert] = ACTIONS(3495),
    [anon_sym_concept] = ACTIONS(3495),
    [anon_sym_co_return] = ACTIONS(3495),
    [anon_sym_co_yield] = ACTIONS(3495),
    [anon_sym_R_DQUOTE] = ACTIONS(3497),
    [anon_sym_LR_DQUOTE] = ACTIONS(3497),
    [anon_sym_uR_DQUOTE] = ACTIONS(3497),
    [anon_sym_UR_DQUOTE] = ACTIONS(3497),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3497),
    [anon_sym_co_await] = ACTIONS(3495),
    [anon_sym_new] = ACTIONS(3495),
    [anon_sym_requires] = ACTIONS(3495),
    [sym_this] = ACTIONS(3495),
  },
  [933] = {
    [sym_identifier] = ACTIONS(3509),
    [aux_sym_preproc_include_token1] = ACTIONS(3509),
    [aux_sym_preproc_def_token1] = ACTIONS(3509),
    [aux_sym_preproc_if_token1] = ACTIONS(3509),
    [aux_sym_preproc_if_token2] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3509),
    [sym_preproc_directive] = ACTIONS(3509),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_BANG] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3509),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_SEMI] = ACTIONS(3511),
    [anon_sym___extension__] = ACTIONS(3509),
    [anon_sym_typedef] = ACTIONS(3509),
    [anon_sym_extern] = ACTIONS(3509),
    [anon_sym___attribute__] = ACTIONS(3509),
    [anon_sym_COLON_COLON] = ACTIONS(3511),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3511),
    [anon_sym___declspec] = ACTIONS(3509),
    [anon_sym___based] = ACTIONS(3509),
    [anon_sym___cdecl] = ACTIONS(3509),
    [anon_sym___clrcall] = ACTIONS(3509),
    [anon_sym___stdcall] = ACTIONS(3509),
    [anon_sym___fastcall] = ACTIONS(3509),
    [anon_sym___thiscall] = ACTIONS(3509),
    [anon_sym___vectorcall] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_signed] = ACTIONS(3509),
    [anon_sym_unsigned] = ACTIONS(3509),
    [anon_sym_long] = ACTIONS(3509),
    [anon_sym_short] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(3509),
    [anon_sym_static] = ACTIONS(3509),
    [anon_sym_register] = ACTIONS(3509),
    [anon_sym_inline] = ACTIONS(3509),
    [anon_sym___inline] = ACTIONS(3509),
    [anon_sym___inline__] = ACTIONS(3509),
    [anon_sym___forceinline] = ACTIONS(3509),
    [anon_sym_thread_local] = ACTIONS(3509),
    [anon_sym___thread] = ACTIONS(3509),
    [anon_sym_const] = ACTIONS(3509),
    [anon_sym_constexpr] = ACTIONS(3509),
    [anon_sym_volatile] = ACTIONS(3509),
    [anon_sym_restrict] = ACTIONS(3509),
    [anon_sym___restrict__] = ACTIONS(3509),
    [anon_sym__Atomic] = ACTIONS(3509),
    [anon_sym__Noreturn] = ACTIONS(3509),
    [anon_sym_noreturn] = ACTIONS(3509),
    [anon_sym_mutable] = ACTIONS(3509),
    [anon_sym_constinit] = ACTIONS(3509),
    [anon_sym_consteval] = ACTIONS(3509),
    [anon_sym_PROGMEM] = ACTIONS(3509),
    [aux_sym_primitive_type_token1] = ACTIONS(3509),
    [anon_sym_byte] = ACTIONS(3509),
    [anon_sym_word] = ACTIONS(3509),
    [anon_sym_enum] = ACTIONS(3509),
    [anon_sym_class] = ACTIONS(3509),
    [anon_sym_struct] = ACTIONS(3509),
    [anon_sym_union] = ACTIONS(3509),
    [anon_sym_if] = ACTIONS(3509),
    [anon_sym_switch] = ACTIONS(3509),
    [anon_sym_case] = ACTIONS(3509),
    [anon_sym_default] = ACTIONS(3509),
    [anon_sym_while] = ACTIONS(3509),
    [anon_sym_do] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3509),
    [anon_sym_return] = ACTIONS(3509),
    [anon_sym_break] = ACTIONS(3509),
    [anon_sym_continue] = ACTIONS(3509),
    [anon_sym_goto] = ACTIONS(3509),
    [anon_sym___try] = ACTIONS(3509),
    [anon_sym___leave] = ACTIONS(3509),
    [anon_sym_not] = ACTIONS(3509),
    [anon_sym_compl] = ACTIONS(3509),
    [anon_sym_DASH_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_PLUS] = ACTIONS(3511),
    [anon_sym_sizeof] = ACTIONS(3509),
    [anon_sym___alignof__] = ACTIONS(3509),
    [anon_sym___alignof] = ACTIONS(3509),
    [anon_sym__alignof] = ACTIONS(3509),
    [anon_sym_alignof] = ACTIONS(3509),
    [anon_sym__Alignof] = ACTIONS(3509),
    [anon_sym_offsetof] = ACTIONS(3509),
    [anon_sym__Generic] = ACTIONS(3509),
    [anon_sym_asm] = ACTIONS(3509),
    [anon_sym___asm__] = ACTIONS(3509),
    [aux_sym_number_literal_token1] = ACTIONS(3511),
    [aux_sym_number_literal_token2] = ACTIONS(3509),
    [anon_sym_L_SQUOTE] = ACTIONS(3511),
    [anon_sym_u_SQUOTE] = ACTIONS(3511),
    [anon_sym_U_SQUOTE] = ACTIONS(3511),
    [anon_sym_u8_SQUOTE] = ACTIONS(3511),
    [anon_sym_SQUOTE] = ACTIONS(3511),
    [anon_sym_L_DQUOTE] = ACTIONS(3511),
    [anon_sym_u_DQUOTE] = ACTIONS(3511),
    [anon_sym_U_DQUOTE] = ACTIONS(3511),
    [anon_sym_u8_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [sym_true] = ACTIONS(3509),
    [sym_false] = ACTIONS(3509),
    [anon_sym_NULL] = ACTIONS(3509),
    [anon_sym_nullptr] = ACTIONS(3509),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3509),
    [anon_sym_decltype] = ACTIONS(3509),
    [anon_sym_virtual] = ACTIONS(3509),
    [anon_sym_alignas] = ACTIONS(3509),
    [anon_sym_explicit] = ACTIONS(3509),
    [anon_sym_typename] = ACTIONS(3509),
    [anon_sym_template] = ACTIONS(3509),
    [anon_sym_operator] = ACTIONS(3509),
    [anon_sym_try] = ACTIONS(3509),
    [anon_sym_delete] = ACTIONS(3509),
    [anon_sym_throw] = ACTIONS(3509),
    [anon_sym_namespace] = ACTIONS(3509),
    [anon_sym_using] = ACTIONS(3509),
    [anon_sym_static_assert] = ACTIONS(3509),
    [anon_sym_concept] = ACTIONS(3509),
    [anon_sym_co_return] = ACTIONS(3509),
    [anon_sym_co_yield] = ACTIONS(3509),
    [anon_sym_R_DQUOTE] = ACTIONS(3511),
    [anon_sym_LR_DQUOTE] = ACTIONS(3511),
    [anon_sym_uR_DQUOTE] = ACTIONS(3511),
    [anon_sym_UR_DQUOTE] = ACTIONS(3511),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3511),
    [anon_sym_co_await] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3509),
    [anon_sym_requires] = ACTIONS(3509),
    [sym_this] = ACTIONS(3509),
  },
  [934] = {
    [sym_identifier] = ACTIONS(3383),
    [aux_sym_preproc_include_token1] = ACTIONS(3383),
    [aux_sym_preproc_def_token1] = ACTIONS(3383),
    [aux_sym_preproc_if_token1] = ACTIONS(3383),
    [aux_sym_preproc_if_token2] = ACTIONS(3383),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3383),
    [sym_preproc_directive] = ACTIONS(3383),
    [anon_sym_LPAREN2] = ACTIONS(3385),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_TILDE] = ACTIONS(3385),
    [anon_sym_DASH] = ACTIONS(3383),
    [anon_sym_PLUS] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(3385),
    [anon_sym_AMP_AMP] = ACTIONS(3385),
    [anon_sym_AMP] = ACTIONS(3383),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym___extension__] = ACTIONS(3383),
    [anon_sym_typedef] = ACTIONS(3383),
    [anon_sym_extern] = ACTIONS(3383),
    [anon_sym___attribute__] = ACTIONS(3383),
    [anon_sym_COLON_COLON] = ACTIONS(3385),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3385),
    [anon_sym___declspec] = ACTIONS(3383),
    [anon_sym___based] = ACTIONS(3383),
    [anon_sym___cdecl] = ACTIONS(3383),
    [anon_sym___clrcall] = ACTIONS(3383),
    [anon_sym___stdcall] = ACTIONS(3383),
    [anon_sym___fastcall] = ACTIONS(3383),
    [anon_sym___thiscall] = ACTIONS(3383),
    [anon_sym___vectorcall] = ACTIONS(3383),
    [anon_sym_LBRACE] = ACTIONS(3385),
    [anon_sym_signed] = ACTIONS(3383),
    [anon_sym_unsigned] = ACTIONS(3383),
    [anon_sym_long] = ACTIONS(3383),
    [anon_sym_short] = ACTIONS(3383),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_static] = ACTIONS(3383),
    [anon_sym_register] = ACTIONS(3383),
    [anon_sym_inline] = ACTIONS(3383),
    [anon_sym___inline] = ACTIONS(3383),
    [anon_sym___inline__] = ACTIONS(3383),
    [anon_sym___forceinline] = ACTIONS(3383),
    [anon_sym_thread_local] = ACTIONS(3383),
    [anon_sym___thread] = ACTIONS(3383),
    [anon_sym_const] = ACTIONS(3383),
    [anon_sym_constexpr] = ACTIONS(3383),
    [anon_sym_volatile] = ACTIONS(3383),
    [anon_sym_restrict] = ACTIONS(3383),
    [anon_sym___restrict__] = ACTIONS(3383),
    [anon_sym__Atomic] = ACTIONS(3383),
    [anon_sym__Noreturn] = ACTIONS(3383),
    [anon_sym_noreturn] = ACTIONS(3383),
    [anon_sym_mutable] = ACTIONS(3383),
    [anon_sym_constinit] = ACTIONS(3383),
    [anon_sym_consteval] = ACTIONS(3383),
    [anon_sym_PROGMEM] = ACTIONS(3383),
    [aux_sym_primitive_type_token1] = ACTIONS(3383),
    [anon_sym_byte] = ACTIONS(3383),
    [anon_sym_word] = ACTIONS(3383),
    [anon_sym_enum] = ACTIONS(3383),
    [anon_sym_class] = ACTIONS(3383),
    [anon_sym_struct] = ACTIONS(3383),
    [anon_sym_union] = ACTIONS(3383),
    [anon_sym_if] = ACTIONS(3383),
    [anon_sym_switch] = ACTIONS(3383),
    [anon_sym_case] = ACTIONS(3383),
    [anon_sym_default] = ACTIONS(3383),
    [anon_sym_while] = ACTIONS(3383),
    [anon_sym_do] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3383),
    [anon_sym_return] = ACTIONS(3383),
    [anon_sym_break] = ACTIONS(3383),
    [anon_sym_continue] = ACTIONS(3383),
    [anon_sym_goto] = ACTIONS(3383),
    [anon_sym___try] = ACTIONS(3383),
    [anon_sym___leave] = ACTIONS(3383),
    [anon_sym_not] = ACTIONS(3383),
    [anon_sym_compl] = ACTIONS(3383),
    [anon_sym_DASH_DASH] = ACTIONS(3385),
    [anon_sym_PLUS_PLUS] = ACTIONS(3385),
    [anon_sym_sizeof] = ACTIONS(3383),
    [anon_sym___alignof__] = ACTIONS(3383),
    [anon_sym___alignof] = ACTIONS(3383),
    [anon_sym__alignof] = ACTIONS(3383),
    [anon_sym_alignof] = ACTIONS(3383),
    [anon_sym__Alignof] = ACTIONS(3383),
    [anon_sym_offsetof] = ACTIONS(3383),
    [anon_sym__Generic] = ACTIONS(3383),
    [anon_sym_asm] = ACTIONS(3383),
    [anon_sym___asm__] = ACTIONS(3383),
    [aux_sym_number_literal_token1] = ACTIONS(3385),
    [aux_sym_number_literal_token2] = ACTIONS(3383),
    [anon_sym_L_SQUOTE] = ACTIONS(3385),
    [anon_sym_u_SQUOTE] = ACTIONS(3385),
    [anon_sym_U_SQUOTE] = ACTIONS(3385),
    [anon_sym_u8_SQUOTE] = ACTIONS(3385),
    [anon_sym_SQUOTE] = ACTIONS(3385),
    [anon_sym_L_DQUOTE] = ACTIONS(3385),
    [anon_sym_u_DQUOTE] = ACTIONS(3385),
    [anon_sym_U_DQUOTE] = ACTIONS(3385),
    [anon_sym_u8_DQUOTE] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(3385),
    [sym_true] = ACTIONS(3383),
    [sym_false] = ACTIONS(3383),
    [anon_sym_NULL] = ACTIONS(3383),
    [anon_sym_nullptr] = ACTIONS(3383),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3383),
    [anon_sym_decltype] = ACTIONS(3383),
    [anon_sym_virtual] = ACTIONS(3383),
    [anon_sym_alignas] = ACTIONS(3383),
    [anon_sym_explicit] = ACTIONS(3383),
    [anon_sym_typename] = ACTIONS(3383),
    [anon_sym_template] = ACTIONS(3383),
    [anon_sym_operator] = ACTIONS(3383),
    [anon_sym_try] = ACTIONS(3383),
    [anon_sym_delete] = ACTIONS(3383),
    [anon_sym_throw] = ACTIONS(3383),
    [anon_sym_namespace] = ACTIONS(3383),
    [anon_sym_using] = ACTIONS(3383),
    [anon_sym_static_assert] = ACTIONS(3383),
    [anon_sym_concept] = ACTIONS(3383),
    [anon_sym_co_return] = ACTIONS(3383),
    [anon_sym_co_yield] = ACTIONS(3383),
    [anon_sym_R_DQUOTE] = ACTIONS(3385),
    [anon_sym_LR_DQUOTE] = ACTIONS(3385),
    [anon_sym_uR_DQUOTE] = ACTIONS(3385),
    [anon_sym_UR_DQUOTE] = ACTIONS(3385),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3385),
    [anon_sym_co_await] = ACTIONS(3383),
    [anon_sym_new] = ACTIONS(3383),
    [anon_sym_requires] = ACTIONS(3383),
    [sym_this] = ACTIONS(3383),
  },
  [935] = {
    [sym_identifier] = ACTIONS(3379),
    [aux_sym_preproc_include_token1] = ACTIONS(3379),
    [aux_sym_preproc_def_token1] = ACTIONS(3379),
    [aux_sym_preproc_if_token1] = ACTIONS(3379),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3379),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3379),
    [sym_preproc_directive] = ACTIONS(3379),
    [anon_sym_LPAREN2] = ACTIONS(3381),
    [anon_sym_BANG] = ACTIONS(3381),
    [anon_sym_TILDE] = ACTIONS(3381),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_STAR] = ACTIONS(3381),
    [anon_sym_AMP_AMP] = ACTIONS(3381),
    [anon_sym_AMP] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3381),
    [anon_sym___extension__] = ACTIONS(3379),
    [anon_sym_typedef] = ACTIONS(3379),
    [anon_sym_extern] = ACTIONS(3379),
    [anon_sym___attribute__] = ACTIONS(3379),
    [anon_sym_COLON_COLON] = ACTIONS(3381),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3381),
    [anon_sym___declspec] = ACTIONS(3379),
    [anon_sym___based] = ACTIONS(3379),
    [anon_sym___cdecl] = ACTIONS(3379),
    [anon_sym___clrcall] = ACTIONS(3379),
    [anon_sym___stdcall] = ACTIONS(3379),
    [anon_sym___fastcall] = ACTIONS(3379),
    [anon_sym___thiscall] = ACTIONS(3379),
    [anon_sym___vectorcall] = ACTIONS(3379),
    [anon_sym_LBRACE] = ACTIONS(3381),
    [anon_sym_RBRACE] = ACTIONS(3381),
    [anon_sym_signed] = ACTIONS(3379),
    [anon_sym_unsigned] = ACTIONS(3379),
    [anon_sym_long] = ACTIONS(3379),
    [anon_sym_short] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_register] = ACTIONS(3379),
    [anon_sym_inline] = ACTIONS(3379),
    [anon_sym___inline] = ACTIONS(3379),
    [anon_sym___inline__] = ACTIONS(3379),
    [anon_sym___forceinline] = ACTIONS(3379),
    [anon_sym_thread_local] = ACTIONS(3379),
    [anon_sym___thread] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_constexpr] = ACTIONS(3379),
    [anon_sym_volatile] = ACTIONS(3379),
    [anon_sym_restrict] = ACTIONS(3379),
    [anon_sym___restrict__] = ACTIONS(3379),
    [anon_sym__Atomic] = ACTIONS(3379),
    [anon_sym__Noreturn] = ACTIONS(3379),
    [anon_sym_noreturn] = ACTIONS(3379),
    [anon_sym_mutable] = ACTIONS(3379),
    [anon_sym_constinit] = ACTIONS(3379),
    [anon_sym_consteval] = ACTIONS(3379),
    [anon_sym_PROGMEM] = ACTIONS(3379),
    [aux_sym_primitive_type_token1] = ACTIONS(3379),
    [anon_sym_byte] = ACTIONS(3379),
    [anon_sym_word] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_struct] = ACTIONS(3379),
    [anon_sym_union] = ACTIONS(3379),
    [anon_sym_if] = ACTIONS(3379),
    [anon_sym_switch] = ACTIONS(3379),
    [anon_sym_case] = ACTIONS(3379),
    [anon_sym_default] = ACTIONS(3379),
    [anon_sym_while] = ACTIONS(3379),
    [anon_sym_do] = ACTIONS(3379),
    [anon_sym_for] = ACTIONS(3379),
    [anon_sym_return] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(3379),
    [anon_sym_continue] = ACTIONS(3379),
    [anon_sym_goto] = ACTIONS(3379),
    [anon_sym___try] = ACTIONS(3379),
    [anon_sym___leave] = ACTIONS(3379),
    [anon_sym_not] = ACTIONS(3379),
    [anon_sym_compl] = ACTIONS(3379),
    [anon_sym_DASH_DASH] = ACTIONS(3381),
    [anon_sym_PLUS_PLUS] = ACTIONS(3381),
    [anon_sym_sizeof] = ACTIONS(3379),
    [anon_sym___alignof__] = ACTIONS(3379),
    [anon_sym___alignof] = ACTIONS(3379),
    [anon_sym__alignof] = ACTIONS(3379),
    [anon_sym_alignof] = ACTIONS(3379),
    [anon_sym__Alignof] = ACTIONS(3379),
    [anon_sym_offsetof] = ACTIONS(3379),
    [anon_sym__Generic] = ACTIONS(3379),
    [anon_sym_asm] = ACTIONS(3379),
    [anon_sym___asm__] = ACTIONS(3379),
    [aux_sym_number_literal_token1] = ACTIONS(3381),
    [aux_sym_number_literal_token2] = ACTIONS(3379),
    [anon_sym_L_SQUOTE] = ACTIONS(3381),
    [anon_sym_u_SQUOTE] = ACTIONS(3381),
    [anon_sym_U_SQUOTE] = ACTIONS(3381),
    [anon_sym_u8_SQUOTE] = ACTIONS(3381),
    [anon_sym_SQUOTE] = ACTIONS(3381),
    [anon_sym_L_DQUOTE] = ACTIONS(3381),
    [anon_sym_u_DQUOTE] = ACTIONS(3381),
    [anon_sym_U_DQUOTE] = ACTIONS(3381),
    [anon_sym_u8_DQUOTE] = ACTIONS(3381),
    [anon_sym_DQUOTE] = ACTIONS(3381),
    [sym_true] = ACTIONS(3379),
    [sym_false] = ACTIONS(3379),
    [anon_sym_NULL] = ACTIONS(3379),
    [anon_sym_nullptr] = ACTIONS(3379),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3379),
    [anon_sym_decltype] = ACTIONS(3379),
    [anon_sym_virtual] = ACTIONS(3379),
    [anon_sym_alignas] = ACTIONS(3379),
    [anon_sym_explicit] = ACTIONS(3379),
    [anon_sym_typename] = ACTIONS(3379),
    [anon_sym_template] = ACTIONS(3379),
    [anon_sym_operator] = ACTIONS(3379),
    [anon_sym_try] = ACTIONS(3379),
    [anon_sym_delete] = ACTIONS(3379),
    [anon_sym_throw] = ACTIONS(3379),
    [anon_sym_namespace] = ACTIONS(3379),
    [anon_sym_using] = ACTIONS(3379),
    [anon_sym_static_assert] = ACTIONS(3379),
    [anon_sym_concept] = ACTIONS(3379),
    [anon_sym_co_return] = ACTIONS(3379),
    [anon_sym_co_yield] = ACTIONS(3379),
    [anon_sym_R_DQUOTE] = ACTIONS(3381),
    [anon_sym_LR_DQUOTE] = ACTIONS(3381),
    [anon_sym_uR_DQUOTE] = ACTIONS(3381),
    [anon_sym_UR_DQUOTE] = ACTIONS(3381),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3381),
    [anon_sym_co_await] = ACTIONS(3379),
    [anon_sym_new] = ACTIONS(3379),
    [anon_sym_requires] = ACTIONS(3379),
    [sym_this] = ACTIONS(3379),
  },
  [936] = {
    [sym_identifier] = ACTIONS(3383),
    [aux_sym_preproc_include_token1] = ACTIONS(3383),
    [aux_sym_preproc_def_token1] = ACTIONS(3383),
    [aux_sym_preproc_if_token1] = ACTIONS(3383),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3383),
    [sym_preproc_directive] = ACTIONS(3383),
    [anon_sym_LPAREN2] = ACTIONS(3385),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_TILDE] = ACTIONS(3385),
    [anon_sym_DASH] = ACTIONS(3383),
    [anon_sym_PLUS] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(3385),
    [anon_sym_AMP_AMP] = ACTIONS(3385),
    [anon_sym_AMP] = ACTIONS(3383),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym___extension__] = ACTIONS(3383),
    [anon_sym_typedef] = ACTIONS(3383),
    [anon_sym_extern] = ACTIONS(3383),
    [anon_sym___attribute__] = ACTIONS(3383),
    [anon_sym_COLON_COLON] = ACTIONS(3385),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3385),
    [anon_sym___declspec] = ACTIONS(3383),
    [anon_sym___based] = ACTIONS(3383),
    [anon_sym___cdecl] = ACTIONS(3383),
    [anon_sym___clrcall] = ACTIONS(3383),
    [anon_sym___stdcall] = ACTIONS(3383),
    [anon_sym___fastcall] = ACTIONS(3383),
    [anon_sym___thiscall] = ACTIONS(3383),
    [anon_sym___vectorcall] = ACTIONS(3383),
    [anon_sym_LBRACE] = ACTIONS(3385),
    [anon_sym_RBRACE] = ACTIONS(3385),
    [anon_sym_signed] = ACTIONS(3383),
    [anon_sym_unsigned] = ACTIONS(3383),
    [anon_sym_long] = ACTIONS(3383),
    [anon_sym_short] = ACTIONS(3383),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_static] = ACTIONS(3383),
    [anon_sym_register] = ACTIONS(3383),
    [anon_sym_inline] = ACTIONS(3383),
    [anon_sym___inline] = ACTIONS(3383),
    [anon_sym___inline__] = ACTIONS(3383),
    [anon_sym___forceinline] = ACTIONS(3383),
    [anon_sym_thread_local] = ACTIONS(3383),
    [anon_sym___thread] = ACTIONS(3383),
    [anon_sym_const] = ACTIONS(3383),
    [anon_sym_constexpr] = ACTIONS(3383),
    [anon_sym_volatile] = ACTIONS(3383),
    [anon_sym_restrict] = ACTIONS(3383),
    [anon_sym___restrict__] = ACTIONS(3383),
    [anon_sym__Atomic] = ACTIONS(3383),
    [anon_sym__Noreturn] = ACTIONS(3383),
    [anon_sym_noreturn] = ACTIONS(3383),
    [anon_sym_mutable] = ACTIONS(3383),
    [anon_sym_constinit] = ACTIONS(3383),
    [anon_sym_consteval] = ACTIONS(3383),
    [anon_sym_PROGMEM] = ACTIONS(3383),
    [aux_sym_primitive_type_token1] = ACTIONS(3383),
    [anon_sym_byte] = ACTIONS(3383),
    [anon_sym_word] = ACTIONS(3383),
    [anon_sym_enum] = ACTIONS(3383),
    [anon_sym_class] = ACTIONS(3383),
    [anon_sym_struct] = ACTIONS(3383),
    [anon_sym_union] = ACTIONS(3383),
    [anon_sym_if] = ACTIONS(3383),
    [anon_sym_switch] = ACTIONS(3383),
    [anon_sym_case] = ACTIONS(3383),
    [anon_sym_default] = ACTIONS(3383),
    [anon_sym_while] = ACTIONS(3383),
    [anon_sym_do] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3383),
    [anon_sym_return] = ACTIONS(3383),
    [anon_sym_break] = ACTIONS(3383),
    [anon_sym_continue] = ACTIONS(3383),
    [anon_sym_goto] = ACTIONS(3383),
    [anon_sym___try] = ACTIONS(3383),
    [anon_sym___leave] = ACTIONS(3383),
    [anon_sym_not] = ACTIONS(3383),
    [anon_sym_compl] = ACTIONS(3383),
    [anon_sym_DASH_DASH] = ACTIONS(3385),
    [anon_sym_PLUS_PLUS] = ACTIONS(3385),
    [anon_sym_sizeof] = ACTIONS(3383),
    [anon_sym___alignof__] = ACTIONS(3383),
    [anon_sym___alignof] = ACTIONS(3383),
    [anon_sym__alignof] = ACTIONS(3383),
    [anon_sym_alignof] = ACTIONS(3383),
    [anon_sym__Alignof] = ACTIONS(3383),
    [anon_sym_offsetof] = ACTIONS(3383),
    [anon_sym__Generic] = ACTIONS(3383),
    [anon_sym_asm] = ACTIONS(3383),
    [anon_sym___asm__] = ACTIONS(3383),
    [aux_sym_number_literal_token1] = ACTIONS(3385),
    [aux_sym_number_literal_token2] = ACTIONS(3383),
    [anon_sym_L_SQUOTE] = ACTIONS(3385),
    [anon_sym_u_SQUOTE] = ACTIONS(3385),
    [anon_sym_U_SQUOTE] = ACTIONS(3385),
    [anon_sym_u8_SQUOTE] = ACTIONS(3385),
    [anon_sym_SQUOTE] = ACTIONS(3385),
    [anon_sym_L_DQUOTE] = ACTIONS(3385),
    [anon_sym_u_DQUOTE] = ACTIONS(3385),
    [anon_sym_U_DQUOTE] = ACTIONS(3385),
    [anon_sym_u8_DQUOTE] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(3385),
    [sym_true] = ACTIONS(3383),
    [sym_false] = ACTIONS(3383),
    [anon_sym_NULL] = ACTIONS(3383),
    [anon_sym_nullptr] = ACTIONS(3383),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3383),
    [anon_sym_decltype] = ACTIONS(3383),
    [anon_sym_virtual] = ACTIONS(3383),
    [anon_sym_alignas] = ACTIONS(3383),
    [anon_sym_explicit] = ACTIONS(3383),
    [anon_sym_typename] = ACTIONS(3383),
    [anon_sym_template] = ACTIONS(3383),
    [anon_sym_operator] = ACTIONS(3383),
    [anon_sym_try] = ACTIONS(3383),
    [anon_sym_delete] = ACTIONS(3383),
    [anon_sym_throw] = ACTIONS(3383),
    [anon_sym_namespace] = ACTIONS(3383),
    [anon_sym_using] = ACTIONS(3383),
    [anon_sym_static_assert] = ACTIONS(3383),
    [anon_sym_concept] = ACTIONS(3383),
    [anon_sym_co_return] = ACTIONS(3383),
    [anon_sym_co_yield] = ACTIONS(3383),
    [anon_sym_R_DQUOTE] = ACTIONS(3385),
    [anon_sym_LR_DQUOTE] = ACTIONS(3385),
    [anon_sym_uR_DQUOTE] = ACTIONS(3385),
    [anon_sym_UR_DQUOTE] = ACTIONS(3385),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3385),
    [anon_sym_co_await] = ACTIONS(3383),
    [anon_sym_new] = ACTIONS(3383),
    [anon_sym_requires] = ACTIONS(3383),
    [sym_this] = ACTIONS(3383),
  },
  [937] = {
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_include_token1] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token2] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_BANG] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3513),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym_SEMI] = ACTIONS(3515),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym___cdecl] = ACTIONS(3513),
    [anon_sym___clrcall] = ACTIONS(3513),
    [anon_sym___stdcall] = ACTIONS(3513),
    [anon_sym___fastcall] = ACTIONS(3513),
    [anon_sym___thiscall] = ACTIONS(3513),
    [anon_sym___vectorcall] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_PROGMEM] = ACTIONS(3513),
    [aux_sym_primitive_type_token1] = ACTIONS(3513),
    [anon_sym_byte] = ACTIONS(3513),
    [anon_sym_word] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [anon_sym_if] = ACTIONS(3513),
    [anon_sym_switch] = ACTIONS(3513),
    [anon_sym_case] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3513),
    [anon_sym_while] = ACTIONS(3513),
    [anon_sym_do] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3513),
    [anon_sym_return] = ACTIONS(3513),
    [anon_sym_break] = ACTIONS(3513),
    [anon_sym_continue] = ACTIONS(3513),
    [anon_sym_goto] = ACTIONS(3513),
    [anon_sym___try] = ACTIONS(3513),
    [anon_sym___leave] = ACTIONS(3513),
    [anon_sym_not] = ACTIONS(3513),
    [anon_sym_compl] = ACTIONS(3513),
    [anon_sym_DASH_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_PLUS] = ACTIONS(3515),
    [anon_sym_sizeof] = ACTIONS(3513),
    [anon_sym___alignof__] = ACTIONS(3513),
    [anon_sym___alignof] = ACTIONS(3513),
    [anon_sym__alignof] = ACTIONS(3513),
    [anon_sym_alignof] = ACTIONS(3513),
    [anon_sym__Alignof] = ACTIONS(3513),
    [anon_sym_offsetof] = ACTIONS(3513),
    [anon_sym__Generic] = ACTIONS(3513),
    [anon_sym_asm] = ACTIONS(3513),
    [anon_sym___asm__] = ACTIONS(3513),
    [aux_sym_number_literal_token1] = ACTIONS(3515),
    [aux_sym_number_literal_token2] = ACTIONS(3513),
    [anon_sym_L_SQUOTE] = ACTIONS(3515),
    [anon_sym_u_SQUOTE] = ACTIONS(3515),
    [anon_sym_U_SQUOTE] = ACTIONS(3515),
    [anon_sym_u8_SQUOTE] = ACTIONS(3515),
    [anon_sym_SQUOTE] = ACTIONS(3515),
    [anon_sym_L_DQUOTE] = ACTIONS(3515),
    [anon_sym_u_DQUOTE] = ACTIONS(3515),
    [anon_sym_U_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [sym_true] = ACTIONS(3513),
    [sym_false] = ACTIONS(3513),
    [anon_sym_NULL] = ACTIONS(3513),
    [anon_sym_nullptr] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [anon_sym_virtual] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3513),
    [anon_sym_delete] = ACTIONS(3513),
    [anon_sym_throw] = ACTIONS(3513),
    [anon_sym_namespace] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
    [anon_sym_concept] = ACTIONS(3513),
    [anon_sym_co_return] = ACTIONS(3513),
    [anon_sym_co_yield] = ACTIONS(3513),
    [anon_sym_R_DQUOTE] = ACTIONS(3515),
    [anon_sym_LR_DQUOTE] = ACTIONS(3515),
    [anon_sym_uR_DQUOTE] = ACTIONS(3515),
    [anon_sym_UR_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3515),
    [anon_sym_co_await] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3513),
    [anon_sym_requires] = ACTIONS(3513),
    [sym_this] = ACTIONS(3513),
  },
  [938] = {
    [sym_identifier] = ACTIONS(3407),
    [aux_sym_preproc_include_token1] = ACTIONS(3407),
    [aux_sym_preproc_def_token1] = ACTIONS(3407),
    [aux_sym_preproc_if_token1] = ACTIONS(3407),
    [aux_sym_preproc_if_token2] = ACTIONS(3407),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3407),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3407),
    [sym_preproc_directive] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3409),
    [anon_sym_TILDE] = ACTIONS(3409),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_AMP_AMP] = ACTIONS(3409),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_SEMI] = ACTIONS(3409),
    [anon_sym___extension__] = ACTIONS(3407),
    [anon_sym_typedef] = ACTIONS(3407),
    [anon_sym_extern] = ACTIONS(3407),
    [anon_sym___attribute__] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3409),
    [anon_sym___declspec] = ACTIONS(3407),
    [anon_sym___based] = ACTIONS(3407),
    [anon_sym___cdecl] = ACTIONS(3407),
    [anon_sym___clrcall] = ACTIONS(3407),
    [anon_sym___stdcall] = ACTIONS(3407),
    [anon_sym___fastcall] = ACTIONS(3407),
    [anon_sym___thiscall] = ACTIONS(3407),
    [anon_sym___vectorcall] = ACTIONS(3407),
    [anon_sym_LBRACE] = ACTIONS(3409),
    [anon_sym_signed] = ACTIONS(3407),
    [anon_sym_unsigned] = ACTIONS(3407),
    [anon_sym_long] = ACTIONS(3407),
    [anon_sym_short] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_register] = ACTIONS(3407),
    [anon_sym_inline] = ACTIONS(3407),
    [anon_sym___inline] = ACTIONS(3407),
    [anon_sym___inline__] = ACTIONS(3407),
    [anon_sym___forceinline] = ACTIONS(3407),
    [anon_sym_thread_local] = ACTIONS(3407),
    [anon_sym___thread] = ACTIONS(3407),
    [anon_sym_const] = ACTIONS(3407),
    [anon_sym_constexpr] = ACTIONS(3407),
    [anon_sym_volatile] = ACTIONS(3407),
    [anon_sym_restrict] = ACTIONS(3407),
    [anon_sym___restrict__] = ACTIONS(3407),
    [anon_sym__Atomic] = ACTIONS(3407),
    [anon_sym__Noreturn] = ACTIONS(3407),
    [anon_sym_noreturn] = ACTIONS(3407),
    [anon_sym_mutable] = ACTIONS(3407),
    [anon_sym_constinit] = ACTIONS(3407),
    [anon_sym_consteval] = ACTIONS(3407),
    [anon_sym_PROGMEM] = ACTIONS(3407),
    [aux_sym_primitive_type_token1] = ACTIONS(3407),
    [anon_sym_byte] = ACTIONS(3407),
    [anon_sym_word] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3407),
    [anon_sym_class] = ACTIONS(3407),
    [anon_sym_struct] = ACTIONS(3407),
    [anon_sym_union] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_switch] = ACTIONS(3407),
    [anon_sym_case] = ACTIONS(3407),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_break] = ACTIONS(3407),
    [anon_sym_continue] = ACTIONS(3407),
    [anon_sym_goto] = ACTIONS(3407),
    [anon_sym___try] = ACTIONS(3407),
    [anon_sym___leave] = ACTIONS(3407),
    [anon_sym_not] = ACTIONS(3407),
    [anon_sym_compl] = ACTIONS(3407),
    [anon_sym_DASH_DASH] = ACTIONS(3409),
    [anon_sym_PLUS_PLUS] = ACTIONS(3409),
    [anon_sym_sizeof] = ACTIONS(3407),
    [anon_sym___alignof__] = ACTIONS(3407),
    [anon_sym___alignof] = ACTIONS(3407),
    [anon_sym__alignof] = ACTIONS(3407),
    [anon_sym_alignof] = ACTIONS(3407),
    [anon_sym__Alignof] = ACTIONS(3407),
    [anon_sym_offsetof] = ACTIONS(3407),
    [anon_sym__Generic] = ACTIONS(3407),
    [anon_sym_asm] = ACTIONS(3407),
    [anon_sym___asm__] = ACTIONS(3407),
    [aux_sym_number_literal_token1] = ACTIONS(3409),
    [aux_sym_number_literal_token2] = ACTIONS(3407),
    [anon_sym_L_SQUOTE] = ACTIONS(3409),
    [anon_sym_u_SQUOTE] = ACTIONS(3409),
    [anon_sym_U_SQUOTE] = ACTIONS(3409),
    [anon_sym_u8_SQUOTE] = ACTIONS(3409),
    [anon_sym_SQUOTE] = ACTIONS(3409),
    [anon_sym_L_DQUOTE] = ACTIONS(3409),
    [anon_sym_u_DQUOTE] = ACTIONS(3409),
    [anon_sym_U_DQUOTE] = ACTIONS(3409),
    [anon_sym_u8_DQUOTE] = ACTIONS(3409),
    [anon_sym_DQUOTE] = ACTIONS(3409),
    [sym_true] = ACTIONS(3407),
    [sym_false] = ACTIONS(3407),
    [anon_sym_NULL] = ACTIONS(3407),
    [anon_sym_nullptr] = ACTIONS(3407),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3407),
    [anon_sym_decltype] = ACTIONS(3407),
    [anon_sym_virtual] = ACTIONS(3407),
    [anon_sym_alignas] = ACTIONS(3407),
    [anon_sym_explicit] = ACTIONS(3407),
    [anon_sym_typename] = ACTIONS(3407),
    [anon_sym_template] = ACTIONS(3407),
    [anon_sym_operator] = ACTIONS(3407),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_delete] = ACTIONS(3407),
    [anon_sym_throw] = ACTIONS(3407),
    [anon_sym_namespace] = ACTIONS(3407),
    [anon_sym_using] = ACTIONS(3407),
    [anon_sym_static_assert] = ACTIONS(3407),
    [anon_sym_concept] = ACTIONS(3407),
    [anon_sym_co_return] = ACTIONS(3407),
    [anon_sym_co_yield] = ACTIONS(3407),
    [anon_sym_R_DQUOTE] = ACTIONS(3409),
    [anon_sym_LR_DQUOTE] = ACTIONS(3409),
    [anon_sym_uR_DQUOTE] = ACTIONS(3409),
    [anon_sym_UR_DQUOTE] = ACTIONS(3409),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3409),
    [anon_sym_co_await] = ACTIONS(3407),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_requires] = ACTIONS(3407),
    [sym_this] = ACTIONS(3407),
  },
  [939] = {
    [sym_identifier] = ACTIONS(3387),
    [aux_sym_preproc_include_token1] = ACTIONS(3387),
    [aux_sym_preproc_def_token1] = ACTIONS(3387),
    [aux_sym_preproc_if_token1] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3387),
    [sym_preproc_directive] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_BANG] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_STAR] = ACTIONS(3389),
    [anon_sym_AMP_AMP] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_SEMI] = ACTIONS(3389),
    [anon_sym___extension__] = ACTIONS(3387),
    [anon_sym_typedef] = ACTIONS(3387),
    [anon_sym_extern] = ACTIONS(3387),
    [anon_sym___attribute__] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3389),
    [anon_sym___declspec] = ACTIONS(3387),
    [anon_sym___based] = ACTIONS(3387),
    [anon_sym___cdecl] = ACTIONS(3387),
    [anon_sym___clrcall] = ACTIONS(3387),
    [anon_sym___stdcall] = ACTIONS(3387),
    [anon_sym___fastcall] = ACTIONS(3387),
    [anon_sym___thiscall] = ACTIONS(3387),
    [anon_sym___vectorcall] = ACTIONS(3387),
    [anon_sym_LBRACE] = ACTIONS(3389),
    [anon_sym_RBRACE] = ACTIONS(3389),
    [anon_sym_signed] = ACTIONS(3387),
    [anon_sym_unsigned] = ACTIONS(3387),
    [anon_sym_long] = ACTIONS(3387),
    [anon_sym_short] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_register] = ACTIONS(3387),
    [anon_sym_inline] = ACTIONS(3387),
    [anon_sym___inline] = ACTIONS(3387),
    [anon_sym___inline__] = ACTIONS(3387),
    [anon_sym___forceinline] = ACTIONS(3387),
    [anon_sym_thread_local] = ACTIONS(3387),
    [anon_sym___thread] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_constexpr] = ACTIONS(3387),
    [anon_sym_volatile] = ACTIONS(3387),
    [anon_sym_restrict] = ACTIONS(3387),
    [anon_sym___restrict__] = ACTIONS(3387),
    [anon_sym__Atomic] = ACTIONS(3387),
    [anon_sym__Noreturn] = ACTIONS(3387),
    [anon_sym_noreturn] = ACTIONS(3387),
    [anon_sym_mutable] = ACTIONS(3387),
    [anon_sym_constinit] = ACTIONS(3387),
    [anon_sym_consteval] = ACTIONS(3387),
    [anon_sym_PROGMEM] = ACTIONS(3387),
    [aux_sym_primitive_type_token1] = ACTIONS(3387),
    [anon_sym_byte] = ACTIONS(3387),
    [anon_sym_word] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [anon_sym_class] = ACTIONS(3387),
    [anon_sym_struct] = ACTIONS(3387),
    [anon_sym_union] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_switch] = ACTIONS(3387),
    [anon_sym_case] = ACTIONS(3387),
    [anon_sym_default] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_break] = ACTIONS(3387),
    [anon_sym_continue] = ACTIONS(3387),
    [anon_sym_goto] = ACTIONS(3387),
    [anon_sym___try] = ACTIONS(3387),
    [anon_sym___leave] = ACTIONS(3387),
    [anon_sym_not] = ACTIONS(3387),
    [anon_sym_compl] = ACTIONS(3387),
    [anon_sym_DASH_DASH] = ACTIONS(3389),
    [anon_sym_PLUS_PLUS] = ACTIONS(3389),
    [anon_sym_sizeof] = ACTIONS(3387),
    [anon_sym___alignof__] = ACTIONS(3387),
    [anon_sym___alignof] = ACTIONS(3387),
    [anon_sym__alignof] = ACTIONS(3387),
    [anon_sym_alignof] = ACTIONS(3387),
    [anon_sym__Alignof] = ACTIONS(3387),
    [anon_sym_offsetof] = ACTIONS(3387),
    [anon_sym__Generic] = ACTIONS(3387),
    [anon_sym_asm] = ACTIONS(3387),
    [anon_sym___asm__] = ACTIONS(3387),
    [aux_sym_number_literal_token1] = ACTIONS(3389),
    [aux_sym_number_literal_token2] = ACTIONS(3387),
    [anon_sym_L_SQUOTE] = ACTIONS(3389),
    [anon_sym_u_SQUOTE] = ACTIONS(3389),
    [anon_sym_U_SQUOTE] = ACTIONS(3389),
    [anon_sym_u8_SQUOTE] = ACTIONS(3389),
    [anon_sym_SQUOTE] = ACTIONS(3389),
    [anon_sym_L_DQUOTE] = ACTIONS(3389),
    [anon_sym_u_DQUOTE] = ACTIONS(3389),
    [anon_sym_U_DQUOTE] = ACTIONS(3389),
    [anon_sym_u8_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE] = ACTIONS(3389),
    [sym_true] = ACTIONS(3387),
    [sym_false] = ACTIONS(3387),
    [anon_sym_NULL] = ACTIONS(3387),
    [anon_sym_nullptr] = ACTIONS(3387),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3387),
    [anon_sym_decltype] = ACTIONS(3387),
    [anon_sym_virtual] = ACTIONS(3387),
    [anon_sym_alignas] = ACTIONS(3387),
    [anon_sym_explicit] = ACTIONS(3387),
    [anon_sym_typename] = ACTIONS(3387),
    [anon_sym_template] = ACTIONS(3387),
    [anon_sym_operator] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_delete] = ACTIONS(3387),
    [anon_sym_throw] = ACTIONS(3387),
    [anon_sym_namespace] = ACTIONS(3387),
    [anon_sym_using] = ACTIONS(3387),
    [anon_sym_static_assert] = ACTIONS(3387),
    [anon_sym_concept] = ACTIONS(3387),
    [anon_sym_co_return] = ACTIONS(3387),
    [anon_sym_co_yield] = ACTIONS(3387),
    [anon_sym_R_DQUOTE] = ACTIONS(3389),
    [anon_sym_LR_DQUOTE] = ACTIONS(3389),
    [anon_sym_uR_DQUOTE] = ACTIONS(3389),
    [anon_sym_UR_DQUOTE] = ACTIONS(3389),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3389),
    [anon_sym_co_await] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_requires] = ACTIONS(3387),
    [sym_this] = ACTIONS(3387),
  },
  [940] = {
    [sym_identifier] = ACTIONS(3391),
    [aux_sym_preproc_include_token1] = ACTIONS(3391),
    [aux_sym_preproc_def_token1] = ACTIONS(3391),
    [aux_sym_preproc_if_token1] = ACTIONS(3391),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3391),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3391),
    [sym_preproc_directive] = ACTIONS(3391),
    [anon_sym_LPAREN2] = ACTIONS(3393),
    [anon_sym_BANG] = ACTIONS(3393),
    [anon_sym_TILDE] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_STAR] = ACTIONS(3393),
    [anon_sym_AMP_AMP] = ACTIONS(3393),
    [anon_sym_AMP] = ACTIONS(3391),
    [anon_sym_SEMI] = ACTIONS(3393),
    [anon_sym___extension__] = ACTIONS(3391),
    [anon_sym_typedef] = ACTIONS(3391),
    [anon_sym_extern] = ACTIONS(3391),
    [anon_sym___attribute__] = ACTIONS(3391),
    [anon_sym_COLON_COLON] = ACTIONS(3393),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3393),
    [anon_sym___declspec] = ACTIONS(3391),
    [anon_sym___based] = ACTIONS(3391),
    [anon_sym___cdecl] = ACTIONS(3391),
    [anon_sym___clrcall] = ACTIONS(3391),
    [anon_sym___stdcall] = ACTIONS(3391),
    [anon_sym___fastcall] = ACTIONS(3391),
    [anon_sym___thiscall] = ACTIONS(3391),
    [anon_sym___vectorcall] = ACTIONS(3391),
    [anon_sym_LBRACE] = ACTIONS(3393),
    [anon_sym_RBRACE] = ACTIONS(3393),
    [anon_sym_signed] = ACTIONS(3391),
    [anon_sym_unsigned] = ACTIONS(3391),
    [anon_sym_long] = ACTIONS(3391),
    [anon_sym_short] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(3391),
    [anon_sym_static] = ACTIONS(3391),
    [anon_sym_register] = ACTIONS(3391),
    [anon_sym_inline] = ACTIONS(3391),
    [anon_sym___inline] = ACTIONS(3391),
    [anon_sym___inline__] = ACTIONS(3391),
    [anon_sym___forceinline] = ACTIONS(3391),
    [anon_sym_thread_local] = ACTIONS(3391),
    [anon_sym___thread] = ACTIONS(3391),
    [anon_sym_const] = ACTIONS(3391),
    [anon_sym_constexpr] = ACTIONS(3391),
    [anon_sym_volatile] = ACTIONS(3391),
    [anon_sym_restrict] = ACTIONS(3391),
    [anon_sym___restrict__] = ACTIONS(3391),
    [anon_sym__Atomic] = ACTIONS(3391),
    [anon_sym__Noreturn] = ACTIONS(3391),
    [anon_sym_noreturn] = ACTIONS(3391),
    [anon_sym_mutable] = ACTIONS(3391),
    [anon_sym_constinit] = ACTIONS(3391),
    [anon_sym_consteval] = ACTIONS(3391),
    [anon_sym_PROGMEM] = ACTIONS(3391),
    [aux_sym_primitive_type_token1] = ACTIONS(3391),
    [anon_sym_byte] = ACTIONS(3391),
    [anon_sym_word] = ACTIONS(3391),
    [anon_sym_enum] = ACTIONS(3391),
    [anon_sym_class] = ACTIONS(3391),
    [anon_sym_struct] = ACTIONS(3391),
    [anon_sym_union] = ACTIONS(3391),
    [anon_sym_if] = ACTIONS(3391),
    [anon_sym_switch] = ACTIONS(3391),
    [anon_sym_case] = ACTIONS(3391),
    [anon_sym_default] = ACTIONS(3391),
    [anon_sym_while] = ACTIONS(3391),
    [anon_sym_do] = ACTIONS(3391),
    [anon_sym_for] = ACTIONS(3391),
    [anon_sym_return] = ACTIONS(3391),
    [anon_sym_break] = ACTIONS(3391),
    [anon_sym_continue] = ACTIONS(3391),
    [anon_sym_goto] = ACTIONS(3391),
    [anon_sym___try] = ACTIONS(3391),
    [anon_sym___leave] = ACTIONS(3391),
    [anon_sym_not] = ACTIONS(3391),
    [anon_sym_compl] = ACTIONS(3391),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_sizeof] = ACTIONS(3391),
    [anon_sym___alignof__] = ACTIONS(3391),
    [anon_sym___alignof] = ACTIONS(3391),
    [anon_sym__alignof] = ACTIONS(3391),
    [anon_sym_alignof] = ACTIONS(3391),
    [anon_sym__Alignof] = ACTIONS(3391),
    [anon_sym_offsetof] = ACTIONS(3391),
    [anon_sym__Generic] = ACTIONS(3391),
    [anon_sym_asm] = ACTIONS(3391),
    [anon_sym___asm__] = ACTIONS(3391),
    [aux_sym_number_literal_token1] = ACTIONS(3393),
    [aux_sym_number_literal_token2] = ACTIONS(3391),
    [anon_sym_L_SQUOTE] = ACTIONS(3393),
    [anon_sym_u_SQUOTE] = ACTIONS(3393),
    [anon_sym_U_SQUOTE] = ACTIONS(3393),
    [anon_sym_u8_SQUOTE] = ACTIONS(3393),
    [anon_sym_SQUOTE] = ACTIONS(3393),
    [anon_sym_L_DQUOTE] = ACTIONS(3393),
    [anon_sym_u_DQUOTE] = ACTIONS(3393),
    [anon_sym_U_DQUOTE] = ACTIONS(3393),
    [anon_sym_u8_DQUOTE] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3393),
    [sym_true] = ACTIONS(3391),
    [sym_false] = ACTIONS(3391),
    [anon_sym_NULL] = ACTIONS(3391),
    [anon_sym_nullptr] = ACTIONS(3391),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3391),
    [anon_sym_decltype] = ACTIONS(3391),
    [anon_sym_virtual] = ACTIONS(3391),
    [anon_sym_alignas] = ACTIONS(3391),
    [anon_sym_explicit] = ACTIONS(3391),
    [anon_sym_typename] = ACTIONS(3391),
    [anon_sym_template] = ACTIONS(3391),
    [anon_sym_operator] = ACTIONS(3391),
    [anon_sym_try] = ACTIONS(3391),
    [anon_sym_delete] = ACTIONS(3391),
    [anon_sym_throw] = ACTIONS(3391),
    [anon_sym_namespace] = ACTIONS(3391),
    [anon_sym_using] = ACTIONS(3391),
    [anon_sym_static_assert] = ACTIONS(3391),
    [anon_sym_concept] = ACTIONS(3391),
    [anon_sym_co_return] = ACTIONS(3391),
    [anon_sym_co_yield] = ACTIONS(3391),
    [anon_sym_R_DQUOTE] = ACTIONS(3393),
    [anon_sym_LR_DQUOTE] = ACTIONS(3393),
    [anon_sym_uR_DQUOTE] = ACTIONS(3393),
    [anon_sym_UR_DQUOTE] = ACTIONS(3393),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3393),
    [anon_sym_co_await] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(3391),
    [anon_sym_requires] = ACTIONS(3391),
    [sym_this] = ACTIONS(3391),
  },
  [941] = {
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_include_token1] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token2] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_BANG] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3513),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym_SEMI] = ACTIONS(3515),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym___cdecl] = ACTIONS(3513),
    [anon_sym___clrcall] = ACTIONS(3513),
    [anon_sym___stdcall] = ACTIONS(3513),
    [anon_sym___fastcall] = ACTIONS(3513),
    [anon_sym___thiscall] = ACTIONS(3513),
    [anon_sym___vectorcall] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_PROGMEM] = ACTIONS(3513),
    [aux_sym_primitive_type_token1] = ACTIONS(3513),
    [anon_sym_byte] = ACTIONS(3513),
    [anon_sym_word] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [anon_sym_if] = ACTIONS(3513),
    [anon_sym_switch] = ACTIONS(3513),
    [anon_sym_case] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3513),
    [anon_sym_while] = ACTIONS(3513),
    [anon_sym_do] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3513),
    [anon_sym_return] = ACTIONS(3513),
    [anon_sym_break] = ACTIONS(3513),
    [anon_sym_continue] = ACTIONS(3513),
    [anon_sym_goto] = ACTIONS(3513),
    [anon_sym___try] = ACTIONS(3513),
    [anon_sym___leave] = ACTIONS(3513),
    [anon_sym_not] = ACTIONS(3513),
    [anon_sym_compl] = ACTIONS(3513),
    [anon_sym_DASH_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_PLUS] = ACTIONS(3515),
    [anon_sym_sizeof] = ACTIONS(3513),
    [anon_sym___alignof__] = ACTIONS(3513),
    [anon_sym___alignof] = ACTIONS(3513),
    [anon_sym__alignof] = ACTIONS(3513),
    [anon_sym_alignof] = ACTIONS(3513),
    [anon_sym__Alignof] = ACTIONS(3513),
    [anon_sym_offsetof] = ACTIONS(3513),
    [anon_sym__Generic] = ACTIONS(3513),
    [anon_sym_asm] = ACTIONS(3513),
    [anon_sym___asm__] = ACTIONS(3513),
    [aux_sym_number_literal_token1] = ACTIONS(3515),
    [aux_sym_number_literal_token2] = ACTIONS(3513),
    [anon_sym_L_SQUOTE] = ACTIONS(3515),
    [anon_sym_u_SQUOTE] = ACTIONS(3515),
    [anon_sym_U_SQUOTE] = ACTIONS(3515),
    [anon_sym_u8_SQUOTE] = ACTIONS(3515),
    [anon_sym_SQUOTE] = ACTIONS(3515),
    [anon_sym_L_DQUOTE] = ACTIONS(3515),
    [anon_sym_u_DQUOTE] = ACTIONS(3515),
    [anon_sym_U_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [sym_true] = ACTIONS(3513),
    [sym_false] = ACTIONS(3513),
    [anon_sym_NULL] = ACTIONS(3513),
    [anon_sym_nullptr] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [anon_sym_virtual] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3513),
    [anon_sym_delete] = ACTIONS(3513),
    [anon_sym_throw] = ACTIONS(3513),
    [anon_sym_namespace] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
    [anon_sym_concept] = ACTIONS(3513),
    [anon_sym_co_return] = ACTIONS(3513),
    [anon_sym_co_yield] = ACTIONS(3513),
    [anon_sym_R_DQUOTE] = ACTIONS(3515),
    [anon_sym_LR_DQUOTE] = ACTIONS(3515),
    [anon_sym_uR_DQUOTE] = ACTIONS(3515),
    [anon_sym_UR_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3515),
    [anon_sym_co_await] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3513),
    [anon_sym_requires] = ACTIONS(3513),
    [sym_this] = ACTIONS(3513),
  },
  [942] = {
    [sym_identifier] = ACTIONS(3391),
    [aux_sym_preproc_include_token1] = ACTIONS(3391),
    [aux_sym_preproc_def_token1] = ACTIONS(3391),
    [aux_sym_preproc_if_token1] = ACTIONS(3391),
    [aux_sym_preproc_if_token2] = ACTIONS(3391),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3391),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3391),
    [sym_preproc_directive] = ACTIONS(3391),
    [anon_sym_LPAREN2] = ACTIONS(3393),
    [anon_sym_BANG] = ACTIONS(3393),
    [anon_sym_TILDE] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_STAR] = ACTIONS(3393),
    [anon_sym_AMP_AMP] = ACTIONS(3393),
    [anon_sym_AMP] = ACTIONS(3391),
    [anon_sym_SEMI] = ACTIONS(3393),
    [anon_sym___extension__] = ACTIONS(3391),
    [anon_sym_typedef] = ACTIONS(3391),
    [anon_sym_extern] = ACTIONS(3391),
    [anon_sym___attribute__] = ACTIONS(3391),
    [anon_sym_COLON_COLON] = ACTIONS(3393),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3393),
    [anon_sym___declspec] = ACTIONS(3391),
    [anon_sym___based] = ACTIONS(3391),
    [anon_sym___cdecl] = ACTIONS(3391),
    [anon_sym___clrcall] = ACTIONS(3391),
    [anon_sym___stdcall] = ACTIONS(3391),
    [anon_sym___fastcall] = ACTIONS(3391),
    [anon_sym___thiscall] = ACTIONS(3391),
    [anon_sym___vectorcall] = ACTIONS(3391),
    [anon_sym_LBRACE] = ACTIONS(3393),
    [anon_sym_signed] = ACTIONS(3391),
    [anon_sym_unsigned] = ACTIONS(3391),
    [anon_sym_long] = ACTIONS(3391),
    [anon_sym_short] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(3391),
    [anon_sym_static] = ACTIONS(3391),
    [anon_sym_register] = ACTIONS(3391),
    [anon_sym_inline] = ACTIONS(3391),
    [anon_sym___inline] = ACTIONS(3391),
    [anon_sym___inline__] = ACTIONS(3391),
    [anon_sym___forceinline] = ACTIONS(3391),
    [anon_sym_thread_local] = ACTIONS(3391),
    [anon_sym___thread] = ACTIONS(3391),
    [anon_sym_const] = ACTIONS(3391),
    [anon_sym_constexpr] = ACTIONS(3391),
    [anon_sym_volatile] = ACTIONS(3391),
    [anon_sym_restrict] = ACTIONS(3391),
    [anon_sym___restrict__] = ACTIONS(3391),
    [anon_sym__Atomic] = ACTIONS(3391),
    [anon_sym__Noreturn] = ACTIONS(3391),
    [anon_sym_noreturn] = ACTIONS(3391),
    [anon_sym_mutable] = ACTIONS(3391),
    [anon_sym_constinit] = ACTIONS(3391),
    [anon_sym_consteval] = ACTIONS(3391),
    [anon_sym_PROGMEM] = ACTIONS(3391),
    [aux_sym_primitive_type_token1] = ACTIONS(3391),
    [anon_sym_byte] = ACTIONS(3391),
    [anon_sym_word] = ACTIONS(3391),
    [anon_sym_enum] = ACTIONS(3391),
    [anon_sym_class] = ACTIONS(3391),
    [anon_sym_struct] = ACTIONS(3391),
    [anon_sym_union] = ACTIONS(3391),
    [anon_sym_if] = ACTIONS(3391),
    [anon_sym_switch] = ACTIONS(3391),
    [anon_sym_case] = ACTIONS(3391),
    [anon_sym_default] = ACTIONS(3391),
    [anon_sym_while] = ACTIONS(3391),
    [anon_sym_do] = ACTIONS(3391),
    [anon_sym_for] = ACTIONS(3391),
    [anon_sym_return] = ACTIONS(3391),
    [anon_sym_break] = ACTIONS(3391),
    [anon_sym_continue] = ACTIONS(3391),
    [anon_sym_goto] = ACTIONS(3391),
    [anon_sym___try] = ACTIONS(3391),
    [anon_sym___leave] = ACTIONS(3391),
    [anon_sym_not] = ACTIONS(3391),
    [anon_sym_compl] = ACTIONS(3391),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_sizeof] = ACTIONS(3391),
    [anon_sym___alignof__] = ACTIONS(3391),
    [anon_sym___alignof] = ACTIONS(3391),
    [anon_sym__alignof] = ACTIONS(3391),
    [anon_sym_alignof] = ACTIONS(3391),
    [anon_sym__Alignof] = ACTIONS(3391),
    [anon_sym_offsetof] = ACTIONS(3391),
    [anon_sym__Generic] = ACTIONS(3391),
    [anon_sym_asm] = ACTIONS(3391),
    [anon_sym___asm__] = ACTIONS(3391),
    [aux_sym_number_literal_token1] = ACTIONS(3393),
    [aux_sym_number_literal_token2] = ACTIONS(3391),
    [anon_sym_L_SQUOTE] = ACTIONS(3393),
    [anon_sym_u_SQUOTE] = ACTIONS(3393),
    [anon_sym_U_SQUOTE] = ACTIONS(3393),
    [anon_sym_u8_SQUOTE] = ACTIONS(3393),
    [anon_sym_SQUOTE] = ACTIONS(3393),
    [anon_sym_L_DQUOTE] = ACTIONS(3393),
    [anon_sym_u_DQUOTE] = ACTIONS(3393),
    [anon_sym_U_DQUOTE] = ACTIONS(3393),
    [anon_sym_u8_DQUOTE] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3393),
    [sym_true] = ACTIONS(3391),
    [sym_false] = ACTIONS(3391),
    [anon_sym_NULL] = ACTIONS(3391),
    [anon_sym_nullptr] = ACTIONS(3391),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3391),
    [anon_sym_decltype] = ACTIONS(3391),
    [anon_sym_virtual] = ACTIONS(3391),
    [anon_sym_alignas] = ACTIONS(3391),
    [anon_sym_explicit] = ACTIONS(3391),
    [anon_sym_typename] = ACTIONS(3391),
    [anon_sym_template] = ACTIONS(3391),
    [anon_sym_operator] = ACTIONS(3391),
    [anon_sym_try] = ACTIONS(3391),
    [anon_sym_delete] = ACTIONS(3391),
    [anon_sym_throw] = ACTIONS(3391),
    [anon_sym_namespace] = ACTIONS(3391),
    [anon_sym_using] = ACTIONS(3391),
    [anon_sym_static_assert] = ACTIONS(3391),
    [anon_sym_concept] = ACTIONS(3391),
    [anon_sym_co_return] = ACTIONS(3391),
    [anon_sym_co_yield] = ACTIONS(3391),
    [anon_sym_R_DQUOTE] = ACTIONS(3393),
    [anon_sym_LR_DQUOTE] = ACTIONS(3393),
    [anon_sym_uR_DQUOTE] = ACTIONS(3393),
    [anon_sym_UR_DQUOTE] = ACTIONS(3393),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3393),
    [anon_sym_co_await] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(3391),
    [anon_sym_requires] = ACTIONS(3391),
    [sym_this] = ACTIONS(3391),
  },
  [943] = {
    [sym_identifier] = ACTIONS(3525),
    [aux_sym_preproc_include_token1] = ACTIONS(3525),
    [aux_sym_preproc_def_token1] = ACTIONS(3525),
    [aux_sym_preproc_if_token1] = ACTIONS(3525),
    [aux_sym_preproc_if_token2] = ACTIONS(3525),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3525),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3525),
    [sym_preproc_directive] = ACTIONS(3525),
    [anon_sym_LPAREN2] = ACTIONS(3527),
    [anon_sym_BANG] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3525),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_AMP] = ACTIONS(3525),
    [anon_sym_SEMI] = ACTIONS(3527),
    [anon_sym___extension__] = ACTIONS(3525),
    [anon_sym_typedef] = ACTIONS(3525),
    [anon_sym_extern] = ACTIONS(3525),
    [anon_sym___attribute__] = ACTIONS(3525),
    [anon_sym_COLON_COLON] = ACTIONS(3527),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3527),
    [anon_sym___declspec] = ACTIONS(3525),
    [anon_sym___based] = ACTIONS(3525),
    [anon_sym___cdecl] = ACTIONS(3525),
    [anon_sym___clrcall] = ACTIONS(3525),
    [anon_sym___stdcall] = ACTIONS(3525),
    [anon_sym___fastcall] = ACTIONS(3525),
    [anon_sym___thiscall] = ACTIONS(3525),
    [anon_sym___vectorcall] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_signed] = ACTIONS(3525),
    [anon_sym_unsigned] = ACTIONS(3525),
    [anon_sym_long] = ACTIONS(3525),
    [anon_sym_short] = ACTIONS(3525),
    [anon_sym_LBRACK] = ACTIONS(3525),
    [anon_sym_static] = ACTIONS(3525),
    [anon_sym_register] = ACTIONS(3525),
    [anon_sym_inline] = ACTIONS(3525),
    [anon_sym___inline] = ACTIONS(3525),
    [anon_sym___inline__] = ACTIONS(3525),
    [anon_sym___forceinline] = ACTIONS(3525),
    [anon_sym_thread_local] = ACTIONS(3525),
    [anon_sym___thread] = ACTIONS(3525),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_constexpr] = ACTIONS(3525),
    [anon_sym_volatile] = ACTIONS(3525),
    [anon_sym_restrict] = ACTIONS(3525),
    [anon_sym___restrict__] = ACTIONS(3525),
    [anon_sym__Atomic] = ACTIONS(3525),
    [anon_sym__Noreturn] = ACTIONS(3525),
    [anon_sym_noreturn] = ACTIONS(3525),
    [anon_sym_mutable] = ACTIONS(3525),
    [anon_sym_constinit] = ACTIONS(3525),
    [anon_sym_consteval] = ACTIONS(3525),
    [anon_sym_PROGMEM] = ACTIONS(3525),
    [aux_sym_primitive_type_token1] = ACTIONS(3525),
    [anon_sym_byte] = ACTIONS(3525),
    [anon_sym_word] = ACTIONS(3525),
    [anon_sym_enum] = ACTIONS(3525),
    [anon_sym_class] = ACTIONS(3525),
    [anon_sym_struct] = ACTIONS(3525),
    [anon_sym_union] = ACTIONS(3525),
    [anon_sym_if] = ACTIONS(3525),
    [anon_sym_switch] = ACTIONS(3525),
    [anon_sym_case] = ACTIONS(3525),
    [anon_sym_default] = ACTIONS(3525),
    [anon_sym_while] = ACTIONS(3525),
    [anon_sym_do] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3525),
    [anon_sym_return] = ACTIONS(3525),
    [anon_sym_break] = ACTIONS(3525),
    [anon_sym_continue] = ACTIONS(3525),
    [anon_sym_goto] = ACTIONS(3525),
    [anon_sym___try] = ACTIONS(3525),
    [anon_sym___leave] = ACTIONS(3525),
    [anon_sym_not] = ACTIONS(3525),
    [anon_sym_compl] = ACTIONS(3525),
    [anon_sym_DASH_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_PLUS] = ACTIONS(3527),
    [anon_sym_sizeof] = ACTIONS(3525),
    [anon_sym___alignof__] = ACTIONS(3525),
    [anon_sym___alignof] = ACTIONS(3525),
    [anon_sym__alignof] = ACTIONS(3525),
    [anon_sym_alignof] = ACTIONS(3525),
    [anon_sym__Alignof] = ACTIONS(3525),
    [anon_sym_offsetof] = ACTIONS(3525),
    [anon_sym__Generic] = ACTIONS(3525),
    [anon_sym_asm] = ACTIONS(3525),
    [anon_sym___asm__] = ACTIONS(3525),
    [aux_sym_number_literal_token1] = ACTIONS(3527),
    [aux_sym_number_literal_token2] = ACTIONS(3525),
    [anon_sym_L_SQUOTE] = ACTIONS(3527),
    [anon_sym_u_SQUOTE] = ACTIONS(3527),
    [anon_sym_U_SQUOTE] = ACTIONS(3527),
    [anon_sym_u8_SQUOTE] = ACTIONS(3527),
    [anon_sym_SQUOTE] = ACTIONS(3527),
    [anon_sym_L_DQUOTE] = ACTIONS(3527),
    [anon_sym_u_DQUOTE] = ACTIONS(3527),
    [anon_sym_U_DQUOTE] = ACTIONS(3527),
    [anon_sym_u8_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [sym_true] = ACTIONS(3525),
    [sym_false] = ACTIONS(3525),
    [anon_sym_NULL] = ACTIONS(3525),
    [anon_sym_nullptr] = ACTIONS(3525),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3525),
    [anon_sym_decltype] = ACTIONS(3525),
    [anon_sym_virtual] = ACTIONS(3525),
    [anon_sym_alignas] = ACTIONS(3525),
    [anon_sym_explicit] = ACTIONS(3525),
    [anon_sym_typename] = ACTIONS(3525),
    [anon_sym_template] = ACTIONS(3525),
    [anon_sym_operator] = ACTIONS(3525),
    [anon_sym_try] = ACTIONS(3525),
    [anon_sym_delete] = ACTIONS(3525),
    [anon_sym_throw] = ACTIONS(3525),
    [anon_sym_namespace] = ACTIONS(3525),
    [anon_sym_using] = ACTIONS(3525),
    [anon_sym_static_assert] = ACTIONS(3525),
    [anon_sym_concept] = ACTIONS(3525),
    [anon_sym_co_return] = ACTIONS(3525),
    [anon_sym_co_yield] = ACTIONS(3525),
    [anon_sym_R_DQUOTE] = ACTIONS(3527),
    [anon_sym_LR_DQUOTE] = ACTIONS(3527),
    [anon_sym_uR_DQUOTE] = ACTIONS(3527),
    [anon_sym_UR_DQUOTE] = ACTIONS(3527),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3527),
    [anon_sym_co_await] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3525),
    [anon_sym_requires] = ACTIONS(3525),
    [sym_this] = ACTIONS(3525),
  },
  [944] = {
    [sym_identifier] = ACTIONS(3491),
    [aux_sym_preproc_include_token1] = ACTIONS(3491),
    [aux_sym_preproc_def_token1] = ACTIONS(3491),
    [aux_sym_preproc_if_token1] = ACTIONS(3491),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3491),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3491),
    [sym_preproc_directive] = ACTIONS(3491),
    [anon_sym_LPAREN2] = ACTIONS(3493),
    [anon_sym_BANG] = ACTIONS(3493),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(3493),
    [anon_sym_AMP_AMP] = ACTIONS(3493),
    [anon_sym_AMP] = ACTIONS(3491),
    [anon_sym_SEMI] = ACTIONS(3493),
    [anon_sym___extension__] = ACTIONS(3491),
    [anon_sym_typedef] = ACTIONS(3491),
    [anon_sym_extern] = ACTIONS(3491),
    [anon_sym___attribute__] = ACTIONS(3491),
    [anon_sym_COLON_COLON] = ACTIONS(3493),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3493),
    [anon_sym___declspec] = ACTIONS(3491),
    [anon_sym___based] = ACTIONS(3491),
    [anon_sym___cdecl] = ACTIONS(3491),
    [anon_sym___clrcall] = ACTIONS(3491),
    [anon_sym___stdcall] = ACTIONS(3491),
    [anon_sym___fastcall] = ACTIONS(3491),
    [anon_sym___thiscall] = ACTIONS(3491),
    [anon_sym___vectorcall] = ACTIONS(3491),
    [anon_sym_LBRACE] = ACTIONS(3493),
    [anon_sym_RBRACE] = ACTIONS(3493),
    [anon_sym_signed] = ACTIONS(3491),
    [anon_sym_unsigned] = ACTIONS(3491),
    [anon_sym_long] = ACTIONS(3491),
    [anon_sym_short] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3491),
    [anon_sym_static] = ACTIONS(3491),
    [anon_sym_register] = ACTIONS(3491),
    [anon_sym_inline] = ACTIONS(3491),
    [anon_sym___inline] = ACTIONS(3491),
    [anon_sym___inline__] = ACTIONS(3491),
    [anon_sym___forceinline] = ACTIONS(3491),
    [anon_sym_thread_local] = ACTIONS(3491),
    [anon_sym___thread] = ACTIONS(3491),
    [anon_sym_const] = ACTIONS(3491),
    [anon_sym_constexpr] = ACTIONS(3491),
    [anon_sym_volatile] = ACTIONS(3491),
    [anon_sym_restrict] = ACTIONS(3491),
    [anon_sym___restrict__] = ACTIONS(3491),
    [anon_sym__Atomic] = ACTIONS(3491),
    [anon_sym__Noreturn] = ACTIONS(3491),
    [anon_sym_noreturn] = ACTIONS(3491),
    [anon_sym_mutable] = ACTIONS(3491),
    [anon_sym_constinit] = ACTIONS(3491),
    [anon_sym_consteval] = ACTIONS(3491),
    [anon_sym_PROGMEM] = ACTIONS(3491),
    [aux_sym_primitive_type_token1] = ACTIONS(3491),
    [anon_sym_byte] = ACTIONS(3491),
    [anon_sym_word] = ACTIONS(3491),
    [anon_sym_enum] = ACTIONS(3491),
    [anon_sym_class] = ACTIONS(3491),
    [anon_sym_struct] = ACTIONS(3491),
    [anon_sym_union] = ACTIONS(3491),
    [anon_sym_if] = ACTIONS(3491),
    [anon_sym_switch] = ACTIONS(3491),
    [anon_sym_case] = ACTIONS(3491),
    [anon_sym_default] = ACTIONS(3491),
    [anon_sym_while] = ACTIONS(3491),
    [anon_sym_do] = ACTIONS(3491),
    [anon_sym_for] = ACTIONS(3491),
    [anon_sym_return] = ACTIONS(3491),
    [anon_sym_break] = ACTIONS(3491),
    [anon_sym_continue] = ACTIONS(3491),
    [anon_sym_goto] = ACTIONS(3491),
    [anon_sym___try] = ACTIONS(3491),
    [anon_sym___leave] = ACTIONS(3491),
    [anon_sym_not] = ACTIONS(3491),
    [anon_sym_compl] = ACTIONS(3491),
    [anon_sym_DASH_DASH] = ACTIONS(3493),
    [anon_sym_PLUS_PLUS] = ACTIONS(3493),
    [anon_sym_sizeof] = ACTIONS(3491),
    [anon_sym___alignof__] = ACTIONS(3491),
    [anon_sym___alignof] = ACTIONS(3491),
    [anon_sym__alignof] = ACTIONS(3491),
    [anon_sym_alignof] = ACTIONS(3491),
    [anon_sym__Alignof] = ACTIONS(3491),
    [anon_sym_offsetof] = ACTIONS(3491),
    [anon_sym__Generic] = ACTIONS(3491),
    [anon_sym_asm] = ACTIONS(3491),
    [anon_sym___asm__] = ACTIONS(3491),
    [aux_sym_number_literal_token1] = ACTIONS(3493),
    [aux_sym_number_literal_token2] = ACTIONS(3491),
    [anon_sym_L_SQUOTE] = ACTIONS(3493),
    [anon_sym_u_SQUOTE] = ACTIONS(3493),
    [anon_sym_U_SQUOTE] = ACTIONS(3493),
    [anon_sym_u8_SQUOTE] = ACTIONS(3493),
    [anon_sym_SQUOTE] = ACTIONS(3493),
    [anon_sym_L_DQUOTE] = ACTIONS(3493),
    [anon_sym_u_DQUOTE] = ACTIONS(3493),
    [anon_sym_U_DQUOTE] = ACTIONS(3493),
    [anon_sym_u8_DQUOTE] = ACTIONS(3493),
    [anon_sym_DQUOTE] = ACTIONS(3493),
    [sym_true] = ACTIONS(3491),
    [sym_false] = ACTIONS(3491),
    [anon_sym_NULL] = ACTIONS(3491),
    [anon_sym_nullptr] = ACTIONS(3491),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3491),
    [anon_sym_decltype] = ACTIONS(3491),
    [anon_sym_virtual] = ACTIONS(3491),
    [anon_sym_alignas] = ACTIONS(3491),
    [anon_sym_explicit] = ACTIONS(3491),
    [anon_sym_typename] = ACTIONS(3491),
    [anon_sym_template] = ACTIONS(3491),
    [anon_sym_operator] = ACTIONS(3491),
    [anon_sym_try] = ACTIONS(3491),
    [anon_sym_delete] = ACTIONS(3491),
    [anon_sym_throw] = ACTIONS(3491),
    [anon_sym_namespace] = ACTIONS(3491),
    [anon_sym_using] = ACTIONS(3491),
    [anon_sym_static_assert] = ACTIONS(3491),
    [anon_sym_concept] = ACTIONS(3491),
    [anon_sym_co_return] = ACTIONS(3491),
    [anon_sym_co_yield] = ACTIONS(3491),
    [anon_sym_R_DQUOTE] = ACTIONS(3493),
    [anon_sym_LR_DQUOTE] = ACTIONS(3493),
    [anon_sym_uR_DQUOTE] = ACTIONS(3493),
    [anon_sym_UR_DQUOTE] = ACTIONS(3493),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3493),
    [anon_sym_co_await] = ACTIONS(3491),
    [anon_sym_new] = ACTIONS(3491),
    [anon_sym_requires] = ACTIONS(3491),
    [sym_this] = ACTIONS(3491),
  },
  [945] = {
    [sym_identifier] = ACTIONS(3403),
    [aux_sym_preproc_include_token1] = ACTIONS(3403),
    [aux_sym_preproc_def_token1] = ACTIONS(3403),
    [aux_sym_preproc_if_token1] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3403),
    [sym_preproc_directive] = ACTIONS(3403),
    [anon_sym_LPAREN2] = ACTIONS(3405),
    [anon_sym_BANG] = ACTIONS(3405),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_DASH] = ACTIONS(3403),
    [anon_sym_PLUS] = ACTIONS(3403),
    [anon_sym_STAR] = ACTIONS(3405),
    [anon_sym_AMP_AMP] = ACTIONS(3405),
    [anon_sym_AMP] = ACTIONS(3403),
    [anon_sym_SEMI] = ACTIONS(3405),
    [anon_sym___extension__] = ACTIONS(3403),
    [anon_sym_typedef] = ACTIONS(3403),
    [anon_sym_extern] = ACTIONS(3403),
    [anon_sym___attribute__] = ACTIONS(3403),
    [anon_sym_COLON_COLON] = ACTIONS(3405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3405),
    [anon_sym___declspec] = ACTIONS(3403),
    [anon_sym___based] = ACTIONS(3403),
    [anon_sym___cdecl] = ACTIONS(3403),
    [anon_sym___clrcall] = ACTIONS(3403),
    [anon_sym___stdcall] = ACTIONS(3403),
    [anon_sym___fastcall] = ACTIONS(3403),
    [anon_sym___thiscall] = ACTIONS(3403),
    [anon_sym___vectorcall] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3405),
    [anon_sym_RBRACE] = ACTIONS(3405),
    [anon_sym_signed] = ACTIONS(3403),
    [anon_sym_unsigned] = ACTIONS(3403),
    [anon_sym_long] = ACTIONS(3403),
    [anon_sym_short] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3403),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_register] = ACTIONS(3403),
    [anon_sym_inline] = ACTIONS(3403),
    [anon_sym___inline] = ACTIONS(3403),
    [anon_sym___inline__] = ACTIONS(3403),
    [anon_sym___forceinline] = ACTIONS(3403),
    [anon_sym_thread_local] = ACTIONS(3403),
    [anon_sym___thread] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_constexpr] = ACTIONS(3403),
    [anon_sym_volatile] = ACTIONS(3403),
    [anon_sym_restrict] = ACTIONS(3403),
    [anon_sym___restrict__] = ACTIONS(3403),
    [anon_sym__Atomic] = ACTIONS(3403),
    [anon_sym__Noreturn] = ACTIONS(3403),
    [anon_sym_noreturn] = ACTIONS(3403),
    [anon_sym_mutable] = ACTIONS(3403),
    [anon_sym_constinit] = ACTIONS(3403),
    [anon_sym_consteval] = ACTIONS(3403),
    [anon_sym_PROGMEM] = ACTIONS(3403),
    [aux_sym_primitive_type_token1] = ACTIONS(3403),
    [anon_sym_byte] = ACTIONS(3403),
    [anon_sym_word] = ACTIONS(3403),
    [anon_sym_enum] = ACTIONS(3403),
    [anon_sym_class] = ACTIONS(3403),
    [anon_sym_struct] = ACTIONS(3403),
    [anon_sym_union] = ACTIONS(3403),
    [anon_sym_if] = ACTIONS(3403),
    [anon_sym_switch] = ACTIONS(3403),
    [anon_sym_case] = ACTIONS(3403),
    [anon_sym_default] = ACTIONS(3403),
    [anon_sym_while] = ACTIONS(3403),
    [anon_sym_do] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3403),
    [anon_sym_return] = ACTIONS(3403),
    [anon_sym_break] = ACTIONS(3403),
    [anon_sym_continue] = ACTIONS(3403),
    [anon_sym_goto] = ACTIONS(3403),
    [anon_sym___try] = ACTIONS(3403),
    [anon_sym___leave] = ACTIONS(3403),
    [anon_sym_not] = ACTIONS(3403),
    [anon_sym_compl] = ACTIONS(3403),
    [anon_sym_DASH_DASH] = ACTIONS(3405),
    [anon_sym_PLUS_PLUS] = ACTIONS(3405),
    [anon_sym_sizeof] = ACTIONS(3403),
    [anon_sym___alignof__] = ACTIONS(3403),
    [anon_sym___alignof] = ACTIONS(3403),
    [anon_sym__alignof] = ACTIONS(3403),
    [anon_sym_alignof] = ACTIONS(3403),
    [anon_sym__Alignof] = ACTIONS(3403),
    [anon_sym_offsetof] = ACTIONS(3403),
    [anon_sym__Generic] = ACTIONS(3403),
    [anon_sym_asm] = ACTIONS(3403),
    [anon_sym___asm__] = ACTIONS(3403),
    [aux_sym_number_literal_token1] = ACTIONS(3405),
    [aux_sym_number_literal_token2] = ACTIONS(3403),
    [anon_sym_L_SQUOTE] = ACTIONS(3405),
    [anon_sym_u_SQUOTE] = ACTIONS(3405),
    [anon_sym_U_SQUOTE] = ACTIONS(3405),
    [anon_sym_u8_SQUOTE] = ACTIONS(3405),
    [anon_sym_SQUOTE] = ACTIONS(3405),
    [anon_sym_L_DQUOTE] = ACTIONS(3405),
    [anon_sym_u_DQUOTE] = ACTIONS(3405),
    [anon_sym_U_DQUOTE] = ACTIONS(3405),
    [anon_sym_u8_DQUOTE] = ACTIONS(3405),
    [anon_sym_DQUOTE] = ACTIONS(3405),
    [sym_true] = ACTIONS(3403),
    [sym_false] = ACTIONS(3403),
    [anon_sym_NULL] = ACTIONS(3403),
    [anon_sym_nullptr] = ACTIONS(3403),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3403),
    [anon_sym_decltype] = ACTIONS(3403),
    [anon_sym_virtual] = ACTIONS(3403),
    [anon_sym_alignas] = ACTIONS(3403),
    [anon_sym_explicit] = ACTIONS(3403),
    [anon_sym_typename] = ACTIONS(3403),
    [anon_sym_template] = ACTIONS(3403),
    [anon_sym_operator] = ACTIONS(3403),
    [anon_sym_try] = ACTIONS(3403),
    [anon_sym_delete] = ACTIONS(3403),
    [anon_sym_throw] = ACTIONS(3403),
    [anon_sym_namespace] = ACTIONS(3403),
    [anon_sym_using] = ACTIONS(3403),
    [anon_sym_static_assert] = ACTIONS(3403),
    [anon_sym_concept] = ACTIONS(3403),
    [anon_sym_co_return] = ACTIONS(3403),
    [anon_sym_co_yield] = ACTIONS(3403),
    [anon_sym_R_DQUOTE] = ACTIONS(3405),
    [anon_sym_LR_DQUOTE] = ACTIONS(3405),
    [anon_sym_uR_DQUOTE] = ACTIONS(3405),
    [anon_sym_UR_DQUOTE] = ACTIONS(3405),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3405),
    [anon_sym_co_await] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3403),
    [anon_sym_requires] = ACTIONS(3403),
    [sym_this] = ACTIONS(3403),
  },
  [946] = {
    [sym_identifier] = ACTIONS(3495),
    [aux_sym_preproc_include_token1] = ACTIONS(3495),
    [aux_sym_preproc_def_token1] = ACTIONS(3495),
    [aux_sym_preproc_if_token1] = ACTIONS(3495),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3495),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3495),
    [sym_preproc_directive] = ACTIONS(3495),
    [anon_sym_LPAREN2] = ACTIONS(3497),
    [anon_sym_BANG] = ACTIONS(3497),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_AMP_AMP] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(3495),
    [anon_sym_SEMI] = ACTIONS(3497),
    [anon_sym___extension__] = ACTIONS(3495),
    [anon_sym_typedef] = ACTIONS(3495),
    [anon_sym_extern] = ACTIONS(3495),
    [anon_sym___attribute__] = ACTIONS(3495),
    [anon_sym_COLON_COLON] = ACTIONS(3497),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3497),
    [anon_sym___declspec] = ACTIONS(3495),
    [anon_sym___based] = ACTIONS(3495),
    [anon_sym___cdecl] = ACTIONS(3495),
    [anon_sym___clrcall] = ACTIONS(3495),
    [anon_sym___stdcall] = ACTIONS(3495),
    [anon_sym___fastcall] = ACTIONS(3495),
    [anon_sym___thiscall] = ACTIONS(3495),
    [anon_sym___vectorcall] = ACTIONS(3495),
    [anon_sym_LBRACE] = ACTIONS(3497),
    [anon_sym_RBRACE] = ACTIONS(3497),
    [anon_sym_signed] = ACTIONS(3495),
    [anon_sym_unsigned] = ACTIONS(3495),
    [anon_sym_long] = ACTIONS(3495),
    [anon_sym_short] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(3495),
    [anon_sym_static] = ACTIONS(3495),
    [anon_sym_register] = ACTIONS(3495),
    [anon_sym_inline] = ACTIONS(3495),
    [anon_sym___inline] = ACTIONS(3495),
    [anon_sym___inline__] = ACTIONS(3495),
    [anon_sym___forceinline] = ACTIONS(3495),
    [anon_sym_thread_local] = ACTIONS(3495),
    [anon_sym___thread] = ACTIONS(3495),
    [anon_sym_const] = ACTIONS(3495),
    [anon_sym_constexpr] = ACTIONS(3495),
    [anon_sym_volatile] = ACTIONS(3495),
    [anon_sym_restrict] = ACTIONS(3495),
    [anon_sym___restrict__] = ACTIONS(3495),
    [anon_sym__Atomic] = ACTIONS(3495),
    [anon_sym__Noreturn] = ACTIONS(3495),
    [anon_sym_noreturn] = ACTIONS(3495),
    [anon_sym_mutable] = ACTIONS(3495),
    [anon_sym_constinit] = ACTIONS(3495),
    [anon_sym_consteval] = ACTIONS(3495),
    [anon_sym_PROGMEM] = ACTIONS(3495),
    [aux_sym_primitive_type_token1] = ACTIONS(3495),
    [anon_sym_byte] = ACTIONS(3495),
    [anon_sym_word] = ACTIONS(3495),
    [anon_sym_enum] = ACTIONS(3495),
    [anon_sym_class] = ACTIONS(3495),
    [anon_sym_struct] = ACTIONS(3495),
    [anon_sym_union] = ACTIONS(3495),
    [anon_sym_if] = ACTIONS(3495),
    [anon_sym_switch] = ACTIONS(3495),
    [anon_sym_case] = ACTIONS(3495),
    [anon_sym_default] = ACTIONS(3495),
    [anon_sym_while] = ACTIONS(3495),
    [anon_sym_do] = ACTIONS(3495),
    [anon_sym_for] = ACTIONS(3495),
    [anon_sym_return] = ACTIONS(3495),
    [anon_sym_break] = ACTIONS(3495),
    [anon_sym_continue] = ACTIONS(3495),
    [anon_sym_goto] = ACTIONS(3495),
    [anon_sym___try] = ACTIONS(3495),
    [anon_sym___leave] = ACTIONS(3495),
    [anon_sym_not] = ACTIONS(3495),
    [anon_sym_compl] = ACTIONS(3495),
    [anon_sym_DASH_DASH] = ACTIONS(3497),
    [anon_sym_PLUS_PLUS] = ACTIONS(3497),
    [anon_sym_sizeof] = ACTIONS(3495),
    [anon_sym___alignof__] = ACTIONS(3495),
    [anon_sym___alignof] = ACTIONS(3495),
    [anon_sym__alignof] = ACTIONS(3495),
    [anon_sym_alignof] = ACTIONS(3495),
    [anon_sym__Alignof] = ACTIONS(3495),
    [anon_sym_offsetof] = ACTIONS(3495),
    [anon_sym__Generic] = ACTIONS(3495),
    [anon_sym_asm] = ACTIONS(3495),
    [anon_sym___asm__] = ACTIONS(3495),
    [aux_sym_number_literal_token1] = ACTIONS(3497),
    [aux_sym_number_literal_token2] = ACTIONS(3495),
    [anon_sym_L_SQUOTE] = ACTIONS(3497),
    [anon_sym_u_SQUOTE] = ACTIONS(3497),
    [anon_sym_U_SQUOTE] = ACTIONS(3497),
    [anon_sym_u8_SQUOTE] = ACTIONS(3497),
    [anon_sym_SQUOTE] = ACTIONS(3497),
    [anon_sym_L_DQUOTE] = ACTIONS(3497),
    [anon_sym_u_DQUOTE] = ACTIONS(3497),
    [anon_sym_U_DQUOTE] = ACTIONS(3497),
    [anon_sym_u8_DQUOTE] = ACTIONS(3497),
    [anon_sym_DQUOTE] = ACTIONS(3497),
    [sym_true] = ACTIONS(3495),
    [sym_false] = ACTIONS(3495),
    [anon_sym_NULL] = ACTIONS(3495),
    [anon_sym_nullptr] = ACTIONS(3495),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3495),
    [anon_sym_decltype] = ACTIONS(3495),
    [anon_sym_virtual] = ACTIONS(3495),
    [anon_sym_alignas] = ACTIONS(3495),
    [anon_sym_explicit] = ACTIONS(3495),
    [anon_sym_typename] = ACTIONS(3495),
    [anon_sym_template] = ACTIONS(3495),
    [anon_sym_operator] = ACTIONS(3495),
    [anon_sym_try] = ACTIONS(3495),
    [anon_sym_delete] = ACTIONS(3495),
    [anon_sym_throw] = ACTIONS(3495),
    [anon_sym_namespace] = ACTIONS(3495),
    [anon_sym_using] = ACTIONS(3495),
    [anon_sym_static_assert] = ACTIONS(3495),
    [anon_sym_concept] = ACTIONS(3495),
    [anon_sym_co_return] = ACTIONS(3495),
    [anon_sym_co_yield] = ACTIONS(3495),
    [anon_sym_R_DQUOTE] = ACTIONS(3497),
    [anon_sym_LR_DQUOTE] = ACTIONS(3497),
    [anon_sym_uR_DQUOTE] = ACTIONS(3497),
    [anon_sym_UR_DQUOTE] = ACTIONS(3497),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3497),
    [anon_sym_co_await] = ACTIONS(3495),
    [anon_sym_new] = ACTIONS(3495),
    [anon_sym_requires] = ACTIONS(3495),
    [sym_this] = ACTIONS(3495),
  },
  [947] = {
    [sym_identifier] = ACTIONS(3336),
    [aux_sym_preproc_include_token1] = ACTIONS(3336),
    [aux_sym_preproc_def_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token2] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3336),
    [sym_preproc_directive] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_BANG] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_SEMI] = ACTIONS(3338),
    [anon_sym___extension__] = ACTIONS(3336),
    [anon_sym_typedef] = ACTIONS(3336),
    [anon_sym_extern] = ACTIONS(3336),
    [anon_sym___attribute__] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3338),
    [anon_sym___declspec] = ACTIONS(3336),
    [anon_sym___based] = ACTIONS(3336),
    [anon_sym___cdecl] = ACTIONS(3336),
    [anon_sym___clrcall] = ACTIONS(3336),
    [anon_sym___stdcall] = ACTIONS(3336),
    [anon_sym___fastcall] = ACTIONS(3336),
    [anon_sym___thiscall] = ACTIONS(3336),
    [anon_sym___vectorcall] = ACTIONS(3336),
    [anon_sym_LBRACE] = ACTIONS(3338),
    [anon_sym_signed] = ACTIONS(3336),
    [anon_sym_unsigned] = ACTIONS(3336),
    [anon_sym_long] = ACTIONS(3336),
    [anon_sym_short] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_static] = ACTIONS(3336),
    [anon_sym_register] = ACTIONS(3336),
    [anon_sym_inline] = ACTIONS(3336),
    [anon_sym___inline] = ACTIONS(3336),
    [anon_sym___inline__] = ACTIONS(3336),
    [anon_sym___forceinline] = ACTIONS(3336),
    [anon_sym_thread_local] = ACTIONS(3336),
    [anon_sym___thread] = ACTIONS(3336),
    [anon_sym_const] = ACTIONS(3336),
    [anon_sym_constexpr] = ACTIONS(3336),
    [anon_sym_volatile] = ACTIONS(3336),
    [anon_sym_restrict] = ACTIONS(3336),
    [anon_sym___restrict__] = ACTIONS(3336),
    [anon_sym__Atomic] = ACTIONS(3336),
    [anon_sym__Noreturn] = ACTIONS(3336),
    [anon_sym_noreturn] = ACTIONS(3336),
    [anon_sym_mutable] = ACTIONS(3336),
    [anon_sym_constinit] = ACTIONS(3336),
    [anon_sym_consteval] = ACTIONS(3336),
    [anon_sym_PROGMEM] = ACTIONS(3336),
    [aux_sym_primitive_type_token1] = ACTIONS(3336),
    [anon_sym_byte] = ACTIONS(3336),
    [anon_sym_word] = ACTIONS(3336),
    [anon_sym_enum] = ACTIONS(3336),
    [anon_sym_class] = ACTIONS(3336),
    [anon_sym_struct] = ACTIONS(3336),
    [anon_sym_union] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_switch] = ACTIONS(3336),
    [anon_sym_case] = ACTIONS(3336),
    [anon_sym_default] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_break] = ACTIONS(3336),
    [anon_sym_continue] = ACTIONS(3336),
    [anon_sym_goto] = ACTIONS(3336),
    [anon_sym___try] = ACTIONS(3336),
    [anon_sym___leave] = ACTIONS(3336),
    [anon_sym_not] = ACTIONS(3336),
    [anon_sym_compl] = ACTIONS(3336),
    [anon_sym_DASH_DASH] = ACTIONS(3338),
    [anon_sym_PLUS_PLUS] = ACTIONS(3338),
    [anon_sym_sizeof] = ACTIONS(3336),
    [anon_sym___alignof__] = ACTIONS(3336),
    [anon_sym___alignof] = ACTIONS(3336),
    [anon_sym__alignof] = ACTIONS(3336),
    [anon_sym_alignof] = ACTIONS(3336),
    [anon_sym__Alignof] = ACTIONS(3336),
    [anon_sym_offsetof] = ACTIONS(3336),
    [anon_sym__Generic] = ACTIONS(3336),
    [anon_sym_asm] = ACTIONS(3336),
    [anon_sym___asm__] = ACTIONS(3336),
    [aux_sym_number_literal_token1] = ACTIONS(3338),
    [aux_sym_number_literal_token2] = ACTIONS(3336),
    [anon_sym_L_SQUOTE] = ACTIONS(3338),
    [anon_sym_u_SQUOTE] = ACTIONS(3338),
    [anon_sym_U_SQUOTE] = ACTIONS(3338),
    [anon_sym_u8_SQUOTE] = ACTIONS(3338),
    [anon_sym_SQUOTE] = ACTIONS(3338),
    [anon_sym_L_DQUOTE] = ACTIONS(3338),
    [anon_sym_u_DQUOTE] = ACTIONS(3338),
    [anon_sym_U_DQUOTE] = ACTIONS(3338),
    [anon_sym_u8_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE] = ACTIONS(3338),
    [sym_true] = ACTIONS(3336),
    [sym_false] = ACTIONS(3336),
    [anon_sym_NULL] = ACTIONS(3336),
    [anon_sym_nullptr] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3336),
    [anon_sym_decltype] = ACTIONS(3336),
    [anon_sym_virtual] = ACTIONS(3336),
    [anon_sym_alignas] = ACTIONS(3336),
    [anon_sym_explicit] = ACTIONS(3336),
    [anon_sym_typename] = ACTIONS(3336),
    [anon_sym_template] = ACTIONS(3336),
    [anon_sym_operator] = ACTIONS(3336),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_delete] = ACTIONS(3336),
    [anon_sym_throw] = ACTIONS(3336),
    [anon_sym_namespace] = ACTIONS(3336),
    [anon_sym_using] = ACTIONS(3336),
    [anon_sym_static_assert] = ACTIONS(3336),
    [anon_sym_concept] = ACTIONS(3336),
    [anon_sym_co_return] = ACTIONS(3336),
    [anon_sym_co_yield] = ACTIONS(3336),
    [anon_sym_R_DQUOTE] = ACTIONS(3338),
    [anon_sym_LR_DQUOTE] = ACTIONS(3338),
    [anon_sym_uR_DQUOTE] = ACTIONS(3338),
    [anon_sym_UR_DQUOTE] = ACTIONS(3338),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3338),
    [anon_sym_co_await] = ACTIONS(3336),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_requires] = ACTIONS(3336),
    [sym_this] = ACTIONS(3336),
  },
  [948] = {
    [sym_identifier] = ACTIONS(3407),
    [aux_sym_preproc_include_token1] = ACTIONS(3407),
    [aux_sym_preproc_def_token1] = ACTIONS(3407),
    [aux_sym_preproc_if_token1] = ACTIONS(3407),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3407),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3407),
    [sym_preproc_directive] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3409),
    [anon_sym_TILDE] = ACTIONS(3409),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_AMP_AMP] = ACTIONS(3409),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_SEMI] = ACTIONS(3409),
    [anon_sym___extension__] = ACTIONS(3407),
    [anon_sym_typedef] = ACTIONS(3407),
    [anon_sym_extern] = ACTIONS(3407),
    [anon_sym___attribute__] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3409),
    [anon_sym___declspec] = ACTIONS(3407),
    [anon_sym___based] = ACTIONS(3407),
    [anon_sym___cdecl] = ACTIONS(3407),
    [anon_sym___clrcall] = ACTIONS(3407),
    [anon_sym___stdcall] = ACTIONS(3407),
    [anon_sym___fastcall] = ACTIONS(3407),
    [anon_sym___thiscall] = ACTIONS(3407),
    [anon_sym___vectorcall] = ACTIONS(3407),
    [anon_sym_LBRACE] = ACTIONS(3409),
    [anon_sym_RBRACE] = ACTIONS(3409),
    [anon_sym_signed] = ACTIONS(3407),
    [anon_sym_unsigned] = ACTIONS(3407),
    [anon_sym_long] = ACTIONS(3407),
    [anon_sym_short] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_register] = ACTIONS(3407),
    [anon_sym_inline] = ACTIONS(3407),
    [anon_sym___inline] = ACTIONS(3407),
    [anon_sym___inline__] = ACTIONS(3407),
    [anon_sym___forceinline] = ACTIONS(3407),
    [anon_sym_thread_local] = ACTIONS(3407),
    [anon_sym___thread] = ACTIONS(3407),
    [anon_sym_const] = ACTIONS(3407),
    [anon_sym_constexpr] = ACTIONS(3407),
    [anon_sym_volatile] = ACTIONS(3407),
    [anon_sym_restrict] = ACTIONS(3407),
    [anon_sym___restrict__] = ACTIONS(3407),
    [anon_sym__Atomic] = ACTIONS(3407),
    [anon_sym__Noreturn] = ACTIONS(3407),
    [anon_sym_noreturn] = ACTIONS(3407),
    [anon_sym_mutable] = ACTIONS(3407),
    [anon_sym_constinit] = ACTIONS(3407),
    [anon_sym_consteval] = ACTIONS(3407),
    [anon_sym_PROGMEM] = ACTIONS(3407),
    [aux_sym_primitive_type_token1] = ACTIONS(3407),
    [anon_sym_byte] = ACTIONS(3407),
    [anon_sym_word] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3407),
    [anon_sym_class] = ACTIONS(3407),
    [anon_sym_struct] = ACTIONS(3407),
    [anon_sym_union] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_switch] = ACTIONS(3407),
    [anon_sym_case] = ACTIONS(3407),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_break] = ACTIONS(3407),
    [anon_sym_continue] = ACTIONS(3407),
    [anon_sym_goto] = ACTIONS(3407),
    [anon_sym___try] = ACTIONS(3407),
    [anon_sym___leave] = ACTIONS(3407),
    [anon_sym_not] = ACTIONS(3407),
    [anon_sym_compl] = ACTIONS(3407),
    [anon_sym_DASH_DASH] = ACTIONS(3409),
    [anon_sym_PLUS_PLUS] = ACTIONS(3409),
    [anon_sym_sizeof] = ACTIONS(3407),
    [anon_sym___alignof__] = ACTIONS(3407),
    [anon_sym___alignof] = ACTIONS(3407),
    [anon_sym__alignof] = ACTIONS(3407),
    [anon_sym_alignof] = ACTIONS(3407),
    [anon_sym__Alignof] = ACTIONS(3407),
    [anon_sym_offsetof] = ACTIONS(3407),
    [anon_sym__Generic] = ACTIONS(3407),
    [anon_sym_asm] = ACTIONS(3407),
    [anon_sym___asm__] = ACTIONS(3407),
    [aux_sym_number_literal_token1] = ACTIONS(3409),
    [aux_sym_number_literal_token2] = ACTIONS(3407),
    [anon_sym_L_SQUOTE] = ACTIONS(3409),
    [anon_sym_u_SQUOTE] = ACTIONS(3409),
    [anon_sym_U_SQUOTE] = ACTIONS(3409),
    [anon_sym_u8_SQUOTE] = ACTIONS(3409),
    [anon_sym_SQUOTE] = ACTIONS(3409),
    [anon_sym_L_DQUOTE] = ACTIONS(3409),
    [anon_sym_u_DQUOTE] = ACTIONS(3409),
    [anon_sym_U_DQUOTE] = ACTIONS(3409),
    [anon_sym_u8_DQUOTE] = ACTIONS(3409),
    [anon_sym_DQUOTE] = ACTIONS(3409),
    [sym_true] = ACTIONS(3407),
    [sym_false] = ACTIONS(3407),
    [anon_sym_NULL] = ACTIONS(3407),
    [anon_sym_nullptr] = ACTIONS(3407),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3407),
    [anon_sym_decltype] = ACTIONS(3407),
    [anon_sym_virtual] = ACTIONS(3407),
    [anon_sym_alignas] = ACTIONS(3407),
    [anon_sym_explicit] = ACTIONS(3407),
    [anon_sym_typename] = ACTIONS(3407),
    [anon_sym_template] = ACTIONS(3407),
    [anon_sym_operator] = ACTIONS(3407),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_delete] = ACTIONS(3407),
    [anon_sym_throw] = ACTIONS(3407),
    [anon_sym_namespace] = ACTIONS(3407),
    [anon_sym_using] = ACTIONS(3407),
    [anon_sym_static_assert] = ACTIONS(3407),
    [anon_sym_concept] = ACTIONS(3407),
    [anon_sym_co_return] = ACTIONS(3407),
    [anon_sym_co_yield] = ACTIONS(3407),
    [anon_sym_R_DQUOTE] = ACTIONS(3409),
    [anon_sym_LR_DQUOTE] = ACTIONS(3409),
    [anon_sym_uR_DQUOTE] = ACTIONS(3409),
    [anon_sym_UR_DQUOTE] = ACTIONS(3409),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3409),
    [anon_sym_co_await] = ACTIONS(3407),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_requires] = ACTIONS(3407),
    [sym_this] = ACTIONS(3407),
  },
  [949] = {
    [sym_identifier] = ACTIONS(3336),
    [aux_sym_preproc_include_token1] = ACTIONS(3336),
    [aux_sym_preproc_def_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token2] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3336),
    [sym_preproc_directive] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_BANG] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_SEMI] = ACTIONS(3338),
    [anon_sym___extension__] = ACTIONS(3336),
    [anon_sym_typedef] = ACTIONS(3336),
    [anon_sym_extern] = ACTIONS(3336),
    [anon_sym___attribute__] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3338),
    [anon_sym___declspec] = ACTIONS(3336),
    [anon_sym___based] = ACTIONS(3336),
    [anon_sym___cdecl] = ACTIONS(3336),
    [anon_sym___clrcall] = ACTIONS(3336),
    [anon_sym___stdcall] = ACTIONS(3336),
    [anon_sym___fastcall] = ACTIONS(3336),
    [anon_sym___thiscall] = ACTIONS(3336),
    [anon_sym___vectorcall] = ACTIONS(3336),
    [anon_sym_LBRACE] = ACTIONS(3338),
    [anon_sym_signed] = ACTIONS(3336),
    [anon_sym_unsigned] = ACTIONS(3336),
    [anon_sym_long] = ACTIONS(3336),
    [anon_sym_short] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_static] = ACTIONS(3336),
    [anon_sym_register] = ACTIONS(3336),
    [anon_sym_inline] = ACTIONS(3336),
    [anon_sym___inline] = ACTIONS(3336),
    [anon_sym___inline__] = ACTIONS(3336),
    [anon_sym___forceinline] = ACTIONS(3336),
    [anon_sym_thread_local] = ACTIONS(3336),
    [anon_sym___thread] = ACTIONS(3336),
    [anon_sym_const] = ACTIONS(3336),
    [anon_sym_constexpr] = ACTIONS(3336),
    [anon_sym_volatile] = ACTIONS(3336),
    [anon_sym_restrict] = ACTIONS(3336),
    [anon_sym___restrict__] = ACTIONS(3336),
    [anon_sym__Atomic] = ACTIONS(3336),
    [anon_sym__Noreturn] = ACTIONS(3336),
    [anon_sym_noreturn] = ACTIONS(3336),
    [anon_sym_mutable] = ACTIONS(3336),
    [anon_sym_constinit] = ACTIONS(3336),
    [anon_sym_consteval] = ACTIONS(3336),
    [anon_sym_PROGMEM] = ACTIONS(3336),
    [aux_sym_primitive_type_token1] = ACTIONS(3336),
    [anon_sym_byte] = ACTIONS(3336),
    [anon_sym_word] = ACTIONS(3336),
    [anon_sym_enum] = ACTIONS(3336),
    [anon_sym_class] = ACTIONS(3336),
    [anon_sym_struct] = ACTIONS(3336),
    [anon_sym_union] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_switch] = ACTIONS(3336),
    [anon_sym_case] = ACTIONS(3336),
    [anon_sym_default] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_break] = ACTIONS(3336),
    [anon_sym_continue] = ACTIONS(3336),
    [anon_sym_goto] = ACTIONS(3336),
    [anon_sym___try] = ACTIONS(3336),
    [anon_sym___leave] = ACTIONS(3336),
    [anon_sym_not] = ACTIONS(3336),
    [anon_sym_compl] = ACTIONS(3336),
    [anon_sym_DASH_DASH] = ACTIONS(3338),
    [anon_sym_PLUS_PLUS] = ACTIONS(3338),
    [anon_sym_sizeof] = ACTIONS(3336),
    [anon_sym___alignof__] = ACTIONS(3336),
    [anon_sym___alignof] = ACTIONS(3336),
    [anon_sym__alignof] = ACTIONS(3336),
    [anon_sym_alignof] = ACTIONS(3336),
    [anon_sym__Alignof] = ACTIONS(3336),
    [anon_sym_offsetof] = ACTIONS(3336),
    [anon_sym__Generic] = ACTIONS(3336),
    [anon_sym_asm] = ACTIONS(3336),
    [anon_sym___asm__] = ACTIONS(3336),
    [aux_sym_number_literal_token1] = ACTIONS(3338),
    [aux_sym_number_literal_token2] = ACTIONS(3336),
    [anon_sym_L_SQUOTE] = ACTIONS(3338),
    [anon_sym_u_SQUOTE] = ACTIONS(3338),
    [anon_sym_U_SQUOTE] = ACTIONS(3338),
    [anon_sym_u8_SQUOTE] = ACTIONS(3338),
    [anon_sym_SQUOTE] = ACTIONS(3338),
    [anon_sym_L_DQUOTE] = ACTIONS(3338),
    [anon_sym_u_DQUOTE] = ACTIONS(3338),
    [anon_sym_U_DQUOTE] = ACTIONS(3338),
    [anon_sym_u8_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE] = ACTIONS(3338),
    [sym_true] = ACTIONS(3336),
    [sym_false] = ACTIONS(3336),
    [anon_sym_NULL] = ACTIONS(3336),
    [anon_sym_nullptr] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3336),
    [anon_sym_decltype] = ACTIONS(3336),
    [anon_sym_virtual] = ACTIONS(3336),
    [anon_sym_alignas] = ACTIONS(3336),
    [anon_sym_explicit] = ACTIONS(3336),
    [anon_sym_typename] = ACTIONS(3336),
    [anon_sym_template] = ACTIONS(3336),
    [anon_sym_operator] = ACTIONS(3336),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_delete] = ACTIONS(3336),
    [anon_sym_throw] = ACTIONS(3336),
    [anon_sym_namespace] = ACTIONS(3336),
    [anon_sym_using] = ACTIONS(3336),
    [anon_sym_static_assert] = ACTIONS(3336),
    [anon_sym_concept] = ACTIONS(3336),
    [anon_sym_co_return] = ACTIONS(3336),
    [anon_sym_co_yield] = ACTIONS(3336),
    [anon_sym_R_DQUOTE] = ACTIONS(3338),
    [anon_sym_LR_DQUOTE] = ACTIONS(3338),
    [anon_sym_uR_DQUOTE] = ACTIONS(3338),
    [anon_sym_UR_DQUOTE] = ACTIONS(3338),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3338),
    [anon_sym_co_await] = ACTIONS(3336),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_requires] = ACTIONS(3336),
    [sym_this] = ACTIONS(3336),
  },
  [950] = {
    [sym_identifier] = ACTIONS(3353),
    [aux_sym_preproc_include_token1] = ACTIONS(3353),
    [aux_sym_preproc_def_token1] = ACTIONS(3353),
    [aux_sym_preproc_if_token1] = ACTIONS(3353),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3353),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3353),
    [sym_preproc_directive] = ACTIONS(3353),
    [anon_sym_LPAREN2] = ACTIONS(3355),
    [anon_sym_BANG] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_AMP_AMP] = ACTIONS(3355),
    [anon_sym_AMP] = ACTIONS(3353),
    [anon_sym_SEMI] = ACTIONS(3355),
    [anon_sym___extension__] = ACTIONS(3353),
    [anon_sym_typedef] = ACTIONS(3353),
    [anon_sym_extern] = ACTIONS(3353),
    [anon_sym___attribute__] = ACTIONS(3353),
    [anon_sym_COLON_COLON] = ACTIONS(3355),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3355),
    [anon_sym___declspec] = ACTIONS(3353),
    [anon_sym___based] = ACTIONS(3353),
    [anon_sym___cdecl] = ACTIONS(3353),
    [anon_sym___clrcall] = ACTIONS(3353),
    [anon_sym___stdcall] = ACTIONS(3353),
    [anon_sym___fastcall] = ACTIONS(3353),
    [anon_sym___thiscall] = ACTIONS(3353),
    [anon_sym___vectorcall] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_RBRACE] = ACTIONS(3355),
    [anon_sym_signed] = ACTIONS(3353),
    [anon_sym_unsigned] = ACTIONS(3353),
    [anon_sym_long] = ACTIONS(3353),
    [anon_sym_short] = ACTIONS(3353),
    [anon_sym_LBRACK] = ACTIONS(3353),
    [anon_sym_static] = ACTIONS(3353),
    [anon_sym_register] = ACTIONS(3353),
    [anon_sym_inline] = ACTIONS(3353),
    [anon_sym___inline] = ACTIONS(3353),
    [anon_sym___inline__] = ACTIONS(3353),
    [anon_sym___forceinline] = ACTIONS(3353),
    [anon_sym_thread_local] = ACTIONS(3353),
    [anon_sym___thread] = ACTIONS(3353),
    [anon_sym_const] = ACTIONS(3353),
    [anon_sym_constexpr] = ACTIONS(3353),
    [anon_sym_volatile] = ACTIONS(3353),
    [anon_sym_restrict] = ACTIONS(3353),
    [anon_sym___restrict__] = ACTIONS(3353),
    [anon_sym__Atomic] = ACTIONS(3353),
    [anon_sym__Noreturn] = ACTIONS(3353),
    [anon_sym_noreturn] = ACTIONS(3353),
    [anon_sym_mutable] = ACTIONS(3353),
    [anon_sym_constinit] = ACTIONS(3353),
    [anon_sym_consteval] = ACTIONS(3353),
    [anon_sym_PROGMEM] = ACTIONS(3353),
    [aux_sym_primitive_type_token1] = ACTIONS(3353),
    [anon_sym_byte] = ACTIONS(3353),
    [anon_sym_word] = ACTIONS(3353),
    [anon_sym_enum] = ACTIONS(3353),
    [anon_sym_class] = ACTIONS(3353),
    [anon_sym_struct] = ACTIONS(3353),
    [anon_sym_union] = ACTIONS(3353),
    [anon_sym_if] = ACTIONS(3353),
    [anon_sym_switch] = ACTIONS(3353),
    [anon_sym_case] = ACTIONS(3353),
    [anon_sym_default] = ACTIONS(3353),
    [anon_sym_while] = ACTIONS(3353),
    [anon_sym_do] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3353),
    [anon_sym_return] = ACTIONS(3353),
    [anon_sym_break] = ACTIONS(3353),
    [anon_sym_continue] = ACTIONS(3353),
    [anon_sym_goto] = ACTIONS(3353),
    [anon_sym___try] = ACTIONS(3353),
    [anon_sym___leave] = ACTIONS(3353),
    [anon_sym_not] = ACTIONS(3353),
    [anon_sym_compl] = ACTIONS(3353),
    [anon_sym_DASH_DASH] = ACTIONS(3355),
    [anon_sym_PLUS_PLUS] = ACTIONS(3355),
    [anon_sym_sizeof] = ACTIONS(3353),
    [anon_sym___alignof__] = ACTIONS(3353),
    [anon_sym___alignof] = ACTIONS(3353),
    [anon_sym__alignof] = ACTIONS(3353),
    [anon_sym_alignof] = ACTIONS(3353),
    [anon_sym__Alignof] = ACTIONS(3353),
    [anon_sym_offsetof] = ACTIONS(3353),
    [anon_sym__Generic] = ACTIONS(3353),
    [anon_sym_asm] = ACTIONS(3353),
    [anon_sym___asm__] = ACTIONS(3353),
    [aux_sym_number_literal_token1] = ACTIONS(3355),
    [aux_sym_number_literal_token2] = ACTIONS(3353),
    [anon_sym_L_SQUOTE] = ACTIONS(3355),
    [anon_sym_u_SQUOTE] = ACTIONS(3355),
    [anon_sym_U_SQUOTE] = ACTIONS(3355),
    [anon_sym_u8_SQUOTE] = ACTIONS(3355),
    [anon_sym_SQUOTE] = ACTIONS(3355),
    [anon_sym_L_DQUOTE] = ACTIONS(3355),
    [anon_sym_u_DQUOTE] = ACTIONS(3355),
    [anon_sym_U_DQUOTE] = ACTIONS(3355),
    [anon_sym_u8_DQUOTE] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [sym_true] = ACTIONS(3353),
    [sym_false] = ACTIONS(3353),
    [anon_sym_NULL] = ACTIONS(3353),
    [anon_sym_nullptr] = ACTIONS(3353),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3353),
    [anon_sym_decltype] = ACTIONS(3353),
    [anon_sym_virtual] = ACTIONS(3353),
    [anon_sym_alignas] = ACTIONS(3353),
    [anon_sym_explicit] = ACTIONS(3353),
    [anon_sym_typename] = ACTIONS(3353),
    [anon_sym_template] = ACTIONS(3353),
    [anon_sym_operator] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3353),
    [anon_sym_delete] = ACTIONS(3353),
    [anon_sym_throw] = ACTIONS(3353),
    [anon_sym_namespace] = ACTIONS(3353),
    [anon_sym_using] = ACTIONS(3353),
    [anon_sym_static_assert] = ACTIONS(3353),
    [anon_sym_concept] = ACTIONS(3353),
    [anon_sym_co_return] = ACTIONS(3353),
    [anon_sym_co_yield] = ACTIONS(3353),
    [anon_sym_R_DQUOTE] = ACTIONS(3355),
    [anon_sym_LR_DQUOTE] = ACTIONS(3355),
    [anon_sym_uR_DQUOTE] = ACTIONS(3355),
    [anon_sym_UR_DQUOTE] = ACTIONS(3355),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3355),
    [anon_sym_co_await] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3353),
    [anon_sym_requires] = ACTIONS(3353),
    [sym_this] = ACTIONS(3353),
  },
  [951] = {
    [sym_identifier] = ACTIONS(3499),
    [aux_sym_preproc_include_token1] = ACTIONS(3499),
    [aux_sym_preproc_def_token1] = ACTIONS(3499),
    [aux_sym_preproc_if_token1] = ACTIONS(3499),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3499),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3499),
    [sym_preproc_directive] = ACTIONS(3499),
    [anon_sym_LPAREN2] = ACTIONS(3501),
    [anon_sym_BANG] = ACTIONS(3501),
    [anon_sym_TILDE] = ACTIONS(3501),
    [anon_sym_DASH] = ACTIONS(3499),
    [anon_sym_PLUS] = ACTIONS(3499),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_AMP_AMP] = ACTIONS(3501),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_SEMI] = ACTIONS(3501),
    [anon_sym___extension__] = ACTIONS(3499),
    [anon_sym_typedef] = ACTIONS(3499),
    [anon_sym_extern] = ACTIONS(3499),
    [anon_sym___attribute__] = ACTIONS(3499),
    [anon_sym_COLON_COLON] = ACTIONS(3501),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3501),
    [anon_sym___declspec] = ACTIONS(3499),
    [anon_sym___based] = ACTIONS(3499),
    [anon_sym___cdecl] = ACTIONS(3499),
    [anon_sym___clrcall] = ACTIONS(3499),
    [anon_sym___stdcall] = ACTIONS(3499),
    [anon_sym___fastcall] = ACTIONS(3499),
    [anon_sym___thiscall] = ACTIONS(3499),
    [anon_sym___vectorcall] = ACTIONS(3499),
    [anon_sym_LBRACE] = ACTIONS(3501),
    [anon_sym_RBRACE] = ACTIONS(3501),
    [anon_sym_signed] = ACTIONS(3499),
    [anon_sym_unsigned] = ACTIONS(3499),
    [anon_sym_long] = ACTIONS(3499),
    [anon_sym_short] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(3499),
    [anon_sym_static] = ACTIONS(3499),
    [anon_sym_register] = ACTIONS(3499),
    [anon_sym_inline] = ACTIONS(3499),
    [anon_sym___inline] = ACTIONS(3499),
    [anon_sym___inline__] = ACTIONS(3499),
    [anon_sym___forceinline] = ACTIONS(3499),
    [anon_sym_thread_local] = ACTIONS(3499),
    [anon_sym___thread] = ACTIONS(3499),
    [anon_sym_const] = ACTIONS(3499),
    [anon_sym_constexpr] = ACTIONS(3499),
    [anon_sym_volatile] = ACTIONS(3499),
    [anon_sym_restrict] = ACTIONS(3499),
    [anon_sym___restrict__] = ACTIONS(3499),
    [anon_sym__Atomic] = ACTIONS(3499),
    [anon_sym__Noreturn] = ACTIONS(3499),
    [anon_sym_noreturn] = ACTIONS(3499),
    [anon_sym_mutable] = ACTIONS(3499),
    [anon_sym_constinit] = ACTIONS(3499),
    [anon_sym_consteval] = ACTIONS(3499),
    [anon_sym_PROGMEM] = ACTIONS(3499),
    [aux_sym_primitive_type_token1] = ACTIONS(3499),
    [anon_sym_byte] = ACTIONS(3499),
    [anon_sym_word] = ACTIONS(3499),
    [anon_sym_enum] = ACTIONS(3499),
    [anon_sym_class] = ACTIONS(3499),
    [anon_sym_struct] = ACTIONS(3499),
    [anon_sym_union] = ACTIONS(3499),
    [anon_sym_if] = ACTIONS(3499),
    [anon_sym_switch] = ACTIONS(3499),
    [anon_sym_case] = ACTIONS(3499),
    [anon_sym_default] = ACTIONS(3499),
    [anon_sym_while] = ACTIONS(3499),
    [anon_sym_do] = ACTIONS(3499),
    [anon_sym_for] = ACTIONS(3499),
    [anon_sym_return] = ACTIONS(3499),
    [anon_sym_break] = ACTIONS(3499),
    [anon_sym_continue] = ACTIONS(3499),
    [anon_sym_goto] = ACTIONS(3499),
    [anon_sym___try] = ACTIONS(3499),
    [anon_sym___leave] = ACTIONS(3499),
    [anon_sym_not] = ACTIONS(3499),
    [anon_sym_compl] = ACTIONS(3499),
    [anon_sym_DASH_DASH] = ACTIONS(3501),
    [anon_sym_PLUS_PLUS] = ACTIONS(3501),
    [anon_sym_sizeof] = ACTIONS(3499),
    [anon_sym___alignof__] = ACTIONS(3499),
    [anon_sym___alignof] = ACTIONS(3499),
    [anon_sym__alignof] = ACTIONS(3499),
    [anon_sym_alignof] = ACTIONS(3499),
    [anon_sym__Alignof] = ACTIONS(3499),
    [anon_sym_offsetof] = ACTIONS(3499),
    [anon_sym__Generic] = ACTIONS(3499),
    [anon_sym_asm] = ACTIONS(3499),
    [anon_sym___asm__] = ACTIONS(3499),
    [aux_sym_number_literal_token1] = ACTIONS(3501),
    [aux_sym_number_literal_token2] = ACTIONS(3499),
    [anon_sym_L_SQUOTE] = ACTIONS(3501),
    [anon_sym_u_SQUOTE] = ACTIONS(3501),
    [anon_sym_U_SQUOTE] = ACTIONS(3501),
    [anon_sym_u8_SQUOTE] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3501),
    [anon_sym_L_DQUOTE] = ACTIONS(3501),
    [anon_sym_u_DQUOTE] = ACTIONS(3501),
    [anon_sym_U_DQUOTE] = ACTIONS(3501),
    [anon_sym_u8_DQUOTE] = ACTIONS(3501),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [sym_true] = ACTIONS(3499),
    [sym_false] = ACTIONS(3499),
    [anon_sym_NULL] = ACTIONS(3499),
    [anon_sym_nullptr] = ACTIONS(3499),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3499),
    [anon_sym_decltype] = ACTIONS(3499),
    [anon_sym_virtual] = ACTIONS(3499),
    [anon_sym_alignas] = ACTIONS(3499),
    [anon_sym_explicit] = ACTIONS(3499),
    [anon_sym_typename] = ACTIONS(3499),
    [anon_sym_template] = ACTIONS(3499),
    [anon_sym_operator] = ACTIONS(3499),
    [anon_sym_try] = ACTIONS(3499),
    [anon_sym_delete] = ACTIONS(3499),
    [anon_sym_throw] = ACTIONS(3499),
    [anon_sym_namespace] = ACTIONS(3499),
    [anon_sym_using] = ACTIONS(3499),
    [anon_sym_static_assert] = ACTIONS(3499),
    [anon_sym_concept] = ACTIONS(3499),
    [anon_sym_co_return] = ACTIONS(3499),
    [anon_sym_co_yield] = ACTIONS(3499),
    [anon_sym_R_DQUOTE] = ACTIONS(3501),
    [anon_sym_LR_DQUOTE] = ACTIONS(3501),
    [anon_sym_uR_DQUOTE] = ACTIONS(3501),
    [anon_sym_UR_DQUOTE] = ACTIONS(3501),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3501),
    [anon_sym_co_await] = ACTIONS(3499),
    [anon_sym_new] = ACTIONS(3499),
    [anon_sym_requires] = ACTIONS(3499),
    [sym_this] = ACTIONS(3499),
  },
  [952] = {
    [sym_identifier] = ACTIONS(3503),
    [aux_sym_preproc_include_token1] = ACTIONS(3503),
    [aux_sym_preproc_def_token1] = ACTIONS(3503),
    [aux_sym_preproc_if_token1] = ACTIONS(3503),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3503),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3503),
    [sym_preproc_directive] = ACTIONS(3503),
    [anon_sym_LPAREN2] = ACTIONS(3505),
    [anon_sym_BANG] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3503),
    [anon_sym_PLUS] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP] = ACTIONS(3503),
    [anon_sym_SEMI] = ACTIONS(3505),
    [anon_sym___extension__] = ACTIONS(3503),
    [anon_sym_typedef] = ACTIONS(3503),
    [anon_sym_extern] = ACTIONS(3503),
    [anon_sym___attribute__] = ACTIONS(3503),
    [anon_sym_COLON_COLON] = ACTIONS(3505),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3505),
    [anon_sym___declspec] = ACTIONS(3503),
    [anon_sym___based] = ACTIONS(3503),
    [anon_sym___cdecl] = ACTIONS(3503),
    [anon_sym___clrcall] = ACTIONS(3503),
    [anon_sym___stdcall] = ACTIONS(3503),
    [anon_sym___fastcall] = ACTIONS(3503),
    [anon_sym___thiscall] = ACTIONS(3503),
    [anon_sym___vectorcall] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_RBRACE] = ACTIONS(3505),
    [anon_sym_signed] = ACTIONS(3503),
    [anon_sym_unsigned] = ACTIONS(3503),
    [anon_sym_long] = ACTIONS(3503),
    [anon_sym_short] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3503),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_register] = ACTIONS(3503),
    [anon_sym_inline] = ACTIONS(3503),
    [anon_sym___inline] = ACTIONS(3503),
    [anon_sym___inline__] = ACTIONS(3503),
    [anon_sym___forceinline] = ACTIONS(3503),
    [anon_sym_thread_local] = ACTIONS(3503),
    [anon_sym___thread] = ACTIONS(3503),
    [anon_sym_const] = ACTIONS(3503),
    [anon_sym_constexpr] = ACTIONS(3503),
    [anon_sym_volatile] = ACTIONS(3503),
    [anon_sym_restrict] = ACTIONS(3503),
    [anon_sym___restrict__] = ACTIONS(3503),
    [anon_sym__Atomic] = ACTIONS(3503),
    [anon_sym__Noreturn] = ACTIONS(3503),
    [anon_sym_noreturn] = ACTIONS(3503),
    [anon_sym_mutable] = ACTIONS(3503),
    [anon_sym_constinit] = ACTIONS(3503),
    [anon_sym_consteval] = ACTIONS(3503),
    [anon_sym_PROGMEM] = ACTIONS(3503),
    [aux_sym_primitive_type_token1] = ACTIONS(3503),
    [anon_sym_byte] = ACTIONS(3503),
    [anon_sym_word] = ACTIONS(3503),
    [anon_sym_enum] = ACTIONS(3503),
    [anon_sym_class] = ACTIONS(3503),
    [anon_sym_struct] = ACTIONS(3503),
    [anon_sym_union] = ACTIONS(3503),
    [anon_sym_if] = ACTIONS(3503),
    [anon_sym_switch] = ACTIONS(3503),
    [anon_sym_case] = ACTIONS(3503),
    [anon_sym_default] = ACTIONS(3503),
    [anon_sym_while] = ACTIONS(3503),
    [anon_sym_do] = ACTIONS(3503),
    [anon_sym_for] = ACTIONS(3503),
    [anon_sym_return] = ACTIONS(3503),
    [anon_sym_break] = ACTIONS(3503),
    [anon_sym_continue] = ACTIONS(3503),
    [anon_sym_goto] = ACTIONS(3503),
    [anon_sym___try] = ACTIONS(3503),
    [anon_sym___leave] = ACTIONS(3503),
    [anon_sym_not] = ACTIONS(3503),
    [anon_sym_compl] = ACTIONS(3503),
    [anon_sym_DASH_DASH] = ACTIONS(3505),
    [anon_sym_PLUS_PLUS] = ACTIONS(3505),
    [anon_sym_sizeof] = ACTIONS(3503),
    [anon_sym___alignof__] = ACTIONS(3503),
    [anon_sym___alignof] = ACTIONS(3503),
    [anon_sym__alignof] = ACTIONS(3503),
    [anon_sym_alignof] = ACTIONS(3503),
    [anon_sym__Alignof] = ACTIONS(3503),
    [anon_sym_offsetof] = ACTIONS(3503),
    [anon_sym__Generic] = ACTIONS(3503),
    [anon_sym_asm] = ACTIONS(3503),
    [anon_sym___asm__] = ACTIONS(3503),
    [aux_sym_number_literal_token1] = ACTIONS(3505),
    [aux_sym_number_literal_token2] = ACTIONS(3503),
    [anon_sym_L_SQUOTE] = ACTIONS(3505),
    [anon_sym_u_SQUOTE] = ACTIONS(3505),
    [anon_sym_U_SQUOTE] = ACTIONS(3505),
    [anon_sym_u8_SQUOTE] = ACTIONS(3505),
    [anon_sym_SQUOTE] = ACTIONS(3505),
    [anon_sym_L_DQUOTE] = ACTIONS(3505),
    [anon_sym_u_DQUOTE] = ACTIONS(3505),
    [anon_sym_U_DQUOTE] = ACTIONS(3505),
    [anon_sym_u8_DQUOTE] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [sym_true] = ACTIONS(3503),
    [sym_false] = ACTIONS(3503),
    [anon_sym_NULL] = ACTIONS(3503),
    [anon_sym_nullptr] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3503),
    [anon_sym_decltype] = ACTIONS(3503),
    [anon_sym_virtual] = ACTIONS(3503),
    [anon_sym_alignas] = ACTIONS(3503),
    [anon_sym_explicit] = ACTIONS(3503),
    [anon_sym_typename] = ACTIONS(3503),
    [anon_sym_template] = ACTIONS(3503),
    [anon_sym_operator] = ACTIONS(3503),
    [anon_sym_try] = ACTIONS(3503),
    [anon_sym_delete] = ACTIONS(3503),
    [anon_sym_throw] = ACTIONS(3503),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_using] = ACTIONS(3503),
    [anon_sym_static_assert] = ACTIONS(3503),
    [anon_sym_concept] = ACTIONS(3503),
    [anon_sym_co_return] = ACTIONS(3503),
    [anon_sym_co_yield] = ACTIONS(3503),
    [anon_sym_R_DQUOTE] = ACTIONS(3505),
    [anon_sym_LR_DQUOTE] = ACTIONS(3505),
    [anon_sym_uR_DQUOTE] = ACTIONS(3505),
    [anon_sym_UR_DQUOTE] = ACTIONS(3505),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3505),
    [anon_sym_co_await] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3503),
    [anon_sym_requires] = ACTIONS(3503),
    [sym_this] = ACTIONS(3503),
  },
  [953] = {
    [sym_identifier] = ACTIONS(3509),
    [aux_sym_preproc_include_token1] = ACTIONS(3509),
    [aux_sym_preproc_def_token1] = ACTIONS(3509),
    [aux_sym_preproc_if_token1] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3509),
    [sym_preproc_directive] = ACTIONS(3509),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_BANG] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3509),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_SEMI] = ACTIONS(3511),
    [anon_sym___extension__] = ACTIONS(3509),
    [anon_sym_typedef] = ACTIONS(3509),
    [anon_sym_extern] = ACTIONS(3509),
    [anon_sym___attribute__] = ACTIONS(3509),
    [anon_sym_COLON_COLON] = ACTIONS(3511),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3511),
    [anon_sym___declspec] = ACTIONS(3509),
    [anon_sym___based] = ACTIONS(3509),
    [anon_sym___cdecl] = ACTIONS(3509),
    [anon_sym___clrcall] = ACTIONS(3509),
    [anon_sym___stdcall] = ACTIONS(3509),
    [anon_sym___fastcall] = ACTIONS(3509),
    [anon_sym___thiscall] = ACTIONS(3509),
    [anon_sym___vectorcall] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_RBRACE] = ACTIONS(3511),
    [anon_sym_signed] = ACTIONS(3509),
    [anon_sym_unsigned] = ACTIONS(3509),
    [anon_sym_long] = ACTIONS(3509),
    [anon_sym_short] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(3509),
    [anon_sym_static] = ACTIONS(3509),
    [anon_sym_register] = ACTIONS(3509),
    [anon_sym_inline] = ACTIONS(3509),
    [anon_sym___inline] = ACTIONS(3509),
    [anon_sym___inline__] = ACTIONS(3509),
    [anon_sym___forceinline] = ACTIONS(3509),
    [anon_sym_thread_local] = ACTIONS(3509),
    [anon_sym___thread] = ACTIONS(3509),
    [anon_sym_const] = ACTIONS(3509),
    [anon_sym_constexpr] = ACTIONS(3509),
    [anon_sym_volatile] = ACTIONS(3509),
    [anon_sym_restrict] = ACTIONS(3509),
    [anon_sym___restrict__] = ACTIONS(3509),
    [anon_sym__Atomic] = ACTIONS(3509),
    [anon_sym__Noreturn] = ACTIONS(3509),
    [anon_sym_noreturn] = ACTIONS(3509),
    [anon_sym_mutable] = ACTIONS(3509),
    [anon_sym_constinit] = ACTIONS(3509),
    [anon_sym_consteval] = ACTIONS(3509),
    [anon_sym_PROGMEM] = ACTIONS(3509),
    [aux_sym_primitive_type_token1] = ACTIONS(3509),
    [anon_sym_byte] = ACTIONS(3509),
    [anon_sym_word] = ACTIONS(3509),
    [anon_sym_enum] = ACTIONS(3509),
    [anon_sym_class] = ACTIONS(3509),
    [anon_sym_struct] = ACTIONS(3509),
    [anon_sym_union] = ACTIONS(3509),
    [anon_sym_if] = ACTIONS(3509),
    [anon_sym_switch] = ACTIONS(3509),
    [anon_sym_case] = ACTIONS(3509),
    [anon_sym_default] = ACTIONS(3509),
    [anon_sym_while] = ACTIONS(3509),
    [anon_sym_do] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3509),
    [anon_sym_return] = ACTIONS(3509),
    [anon_sym_break] = ACTIONS(3509),
    [anon_sym_continue] = ACTIONS(3509),
    [anon_sym_goto] = ACTIONS(3509),
    [anon_sym___try] = ACTIONS(3509),
    [anon_sym___leave] = ACTIONS(3509),
    [anon_sym_not] = ACTIONS(3509),
    [anon_sym_compl] = ACTIONS(3509),
    [anon_sym_DASH_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_PLUS] = ACTIONS(3511),
    [anon_sym_sizeof] = ACTIONS(3509),
    [anon_sym___alignof__] = ACTIONS(3509),
    [anon_sym___alignof] = ACTIONS(3509),
    [anon_sym__alignof] = ACTIONS(3509),
    [anon_sym_alignof] = ACTIONS(3509),
    [anon_sym__Alignof] = ACTIONS(3509),
    [anon_sym_offsetof] = ACTIONS(3509),
    [anon_sym__Generic] = ACTIONS(3509),
    [anon_sym_asm] = ACTIONS(3509),
    [anon_sym___asm__] = ACTIONS(3509),
    [aux_sym_number_literal_token1] = ACTIONS(3511),
    [aux_sym_number_literal_token2] = ACTIONS(3509),
    [anon_sym_L_SQUOTE] = ACTIONS(3511),
    [anon_sym_u_SQUOTE] = ACTIONS(3511),
    [anon_sym_U_SQUOTE] = ACTIONS(3511),
    [anon_sym_u8_SQUOTE] = ACTIONS(3511),
    [anon_sym_SQUOTE] = ACTIONS(3511),
    [anon_sym_L_DQUOTE] = ACTIONS(3511),
    [anon_sym_u_DQUOTE] = ACTIONS(3511),
    [anon_sym_U_DQUOTE] = ACTIONS(3511),
    [anon_sym_u8_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [sym_true] = ACTIONS(3509),
    [sym_false] = ACTIONS(3509),
    [anon_sym_NULL] = ACTIONS(3509),
    [anon_sym_nullptr] = ACTIONS(3509),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3509),
    [anon_sym_decltype] = ACTIONS(3509),
    [anon_sym_virtual] = ACTIONS(3509),
    [anon_sym_alignas] = ACTIONS(3509),
    [anon_sym_explicit] = ACTIONS(3509),
    [anon_sym_typename] = ACTIONS(3509),
    [anon_sym_template] = ACTIONS(3509),
    [anon_sym_operator] = ACTIONS(3509),
    [anon_sym_try] = ACTIONS(3509),
    [anon_sym_delete] = ACTIONS(3509),
    [anon_sym_throw] = ACTIONS(3509),
    [anon_sym_namespace] = ACTIONS(3509),
    [anon_sym_using] = ACTIONS(3509),
    [anon_sym_static_assert] = ACTIONS(3509),
    [anon_sym_concept] = ACTIONS(3509),
    [anon_sym_co_return] = ACTIONS(3509),
    [anon_sym_co_yield] = ACTIONS(3509),
    [anon_sym_R_DQUOTE] = ACTIONS(3511),
    [anon_sym_LR_DQUOTE] = ACTIONS(3511),
    [anon_sym_uR_DQUOTE] = ACTIONS(3511),
    [anon_sym_UR_DQUOTE] = ACTIONS(3511),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3511),
    [anon_sym_co_await] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3509),
    [anon_sym_requires] = ACTIONS(3509),
    [sym_this] = ACTIONS(3509),
  },
  [954] = {
    [sym_identifier] = ACTIONS(3447),
    [aux_sym_preproc_include_token1] = ACTIONS(3447),
    [aux_sym_preproc_def_token1] = ACTIONS(3447),
    [aux_sym_preproc_if_token1] = ACTIONS(3447),
    [aux_sym_preproc_if_token2] = ACTIONS(3447),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3447),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3447),
    [sym_preproc_directive] = ACTIONS(3447),
    [anon_sym_LPAREN2] = ACTIONS(3449),
    [anon_sym_BANG] = ACTIONS(3449),
    [anon_sym_TILDE] = ACTIONS(3449),
    [anon_sym_DASH] = ACTIONS(3447),
    [anon_sym_PLUS] = ACTIONS(3447),
    [anon_sym_STAR] = ACTIONS(3449),
    [anon_sym_AMP_AMP] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3447),
    [anon_sym_SEMI] = ACTIONS(3449),
    [anon_sym___extension__] = ACTIONS(3447),
    [anon_sym_typedef] = ACTIONS(3447),
    [anon_sym_extern] = ACTIONS(3447),
    [anon_sym___attribute__] = ACTIONS(3447),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3449),
    [anon_sym___declspec] = ACTIONS(3447),
    [anon_sym___based] = ACTIONS(3447),
    [anon_sym___cdecl] = ACTIONS(3447),
    [anon_sym___clrcall] = ACTIONS(3447),
    [anon_sym___stdcall] = ACTIONS(3447),
    [anon_sym___fastcall] = ACTIONS(3447),
    [anon_sym___thiscall] = ACTIONS(3447),
    [anon_sym___vectorcall] = ACTIONS(3447),
    [anon_sym_LBRACE] = ACTIONS(3449),
    [anon_sym_signed] = ACTIONS(3447),
    [anon_sym_unsigned] = ACTIONS(3447),
    [anon_sym_long] = ACTIONS(3447),
    [anon_sym_short] = ACTIONS(3447),
    [anon_sym_LBRACK] = ACTIONS(3447),
    [anon_sym_static] = ACTIONS(3447),
    [anon_sym_register] = ACTIONS(3447),
    [anon_sym_inline] = ACTIONS(3447),
    [anon_sym___inline] = ACTIONS(3447),
    [anon_sym___inline__] = ACTIONS(3447),
    [anon_sym___forceinline] = ACTIONS(3447),
    [anon_sym_thread_local] = ACTIONS(3447),
    [anon_sym___thread] = ACTIONS(3447),
    [anon_sym_const] = ACTIONS(3447),
    [anon_sym_constexpr] = ACTIONS(3447),
    [anon_sym_volatile] = ACTIONS(3447),
    [anon_sym_restrict] = ACTIONS(3447),
    [anon_sym___restrict__] = ACTIONS(3447),
    [anon_sym__Atomic] = ACTIONS(3447),
    [anon_sym__Noreturn] = ACTIONS(3447),
    [anon_sym_noreturn] = ACTIONS(3447),
    [anon_sym_mutable] = ACTIONS(3447),
    [anon_sym_constinit] = ACTIONS(3447),
    [anon_sym_consteval] = ACTIONS(3447),
    [anon_sym_PROGMEM] = ACTIONS(3447),
    [aux_sym_primitive_type_token1] = ACTIONS(3447),
    [anon_sym_byte] = ACTIONS(3447),
    [anon_sym_word] = ACTIONS(3447),
    [anon_sym_enum] = ACTIONS(3447),
    [anon_sym_class] = ACTIONS(3447),
    [anon_sym_struct] = ACTIONS(3447),
    [anon_sym_union] = ACTIONS(3447),
    [anon_sym_if] = ACTIONS(3447),
    [anon_sym_switch] = ACTIONS(3447),
    [anon_sym_case] = ACTIONS(3447),
    [anon_sym_default] = ACTIONS(3447),
    [anon_sym_while] = ACTIONS(3447),
    [anon_sym_do] = ACTIONS(3447),
    [anon_sym_for] = ACTIONS(3447),
    [anon_sym_return] = ACTIONS(3447),
    [anon_sym_break] = ACTIONS(3447),
    [anon_sym_continue] = ACTIONS(3447),
    [anon_sym_goto] = ACTIONS(3447),
    [anon_sym___try] = ACTIONS(3447),
    [anon_sym___leave] = ACTIONS(3447),
    [anon_sym_not] = ACTIONS(3447),
    [anon_sym_compl] = ACTIONS(3447),
    [anon_sym_DASH_DASH] = ACTIONS(3449),
    [anon_sym_PLUS_PLUS] = ACTIONS(3449),
    [anon_sym_sizeof] = ACTIONS(3447),
    [anon_sym___alignof__] = ACTIONS(3447),
    [anon_sym___alignof] = ACTIONS(3447),
    [anon_sym__alignof] = ACTIONS(3447),
    [anon_sym_alignof] = ACTIONS(3447),
    [anon_sym__Alignof] = ACTIONS(3447),
    [anon_sym_offsetof] = ACTIONS(3447),
    [anon_sym__Generic] = ACTIONS(3447),
    [anon_sym_asm] = ACTIONS(3447),
    [anon_sym___asm__] = ACTIONS(3447),
    [aux_sym_number_literal_token1] = ACTIONS(3449),
    [aux_sym_number_literal_token2] = ACTIONS(3447),
    [anon_sym_L_SQUOTE] = ACTIONS(3449),
    [anon_sym_u_SQUOTE] = ACTIONS(3449),
    [anon_sym_U_SQUOTE] = ACTIONS(3449),
    [anon_sym_u8_SQUOTE] = ACTIONS(3449),
    [anon_sym_SQUOTE] = ACTIONS(3449),
    [anon_sym_L_DQUOTE] = ACTIONS(3449),
    [anon_sym_u_DQUOTE] = ACTIONS(3449),
    [anon_sym_U_DQUOTE] = ACTIONS(3449),
    [anon_sym_u8_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE] = ACTIONS(3449),
    [sym_true] = ACTIONS(3447),
    [sym_false] = ACTIONS(3447),
    [anon_sym_NULL] = ACTIONS(3447),
    [anon_sym_nullptr] = ACTIONS(3447),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3447),
    [anon_sym_decltype] = ACTIONS(3447),
    [anon_sym_virtual] = ACTIONS(3447),
    [anon_sym_alignas] = ACTIONS(3447),
    [anon_sym_explicit] = ACTIONS(3447),
    [anon_sym_typename] = ACTIONS(3447),
    [anon_sym_template] = ACTIONS(3447),
    [anon_sym_operator] = ACTIONS(3447),
    [anon_sym_try] = ACTIONS(3447),
    [anon_sym_delete] = ACTIONS(3447),
    [anon_sym_throw] = ACTIONS(3447),
    [anon_sym_namespace] = ACTIONS(3447),
    [anon_sym_using] = ACTIONS(3447),
    [anon_sym_static_assert] = ACTIONS(3447),
    [anon_sym_concept] = ACTIONS(3447),
    [anon_sym_co_return] = ACTIONS(3447),
    [anon_sym_co_yield] = ACTIONS(3447),
    [anon_sym_R_DQUOTE] = ACTIONS(3449),
    [anon_sym_LR_DQUOTE] = ACTIONS(3449),
    [anon_sym_uR_DQUOTE] = ACTIONS(3449),
    [anon_sym_UR_DQUOTE] = ACTIONS(3449),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3449),
    [anon_sym_co_await] = ACTIONS(3447),
    [anon_sym_new] = ACTIONS(3447),
    [anon_sym_requires] = ACTIONS(3447),
    [sym_this] = ACTIONS(3447),
  },
  [955] = {
    [sym_identifier] = ACTIONS(3254),
    [aux_sym_preproc_include_token1] = ACTIONS(3254),
    [aux_sym_preproc_def_token1] = ACTIONS(3254),
    [aux_sym_preproc_if_token1] = ACTIONS(3254),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3254),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3254),
    [sym_preproc_directive] = ACTIONS(3254),
    [anon_sym_LPAREN2] = ACTIONS(3256),
    [anon_sym_BANG] = ACTIONS(3256),
    [anon_sym_TILDE] = ACTIONS(3256),
    [anon_sym_DASH] = ACTIONS(3254),
    [anon_sym_PLUS] = ACTIONS(3254),
    [anon_sym_STAR] = ACTIONS(3256),
    [anon_sym_AMP_AMP] = ACTIONS(3256),
    [anon_sym_AMP] = ACTIONS(3254),
    [anon_sym_SEMI] = ACTIONS(3256),
    [anon_sym___extension__] = ACTIONS(3254),
    [anon_sym_typedef] = ACTIONS(3254),
    [anon_sym_extern] = ACTIONS(3254),
    [anon_sym___attribute__] = ACTIONS(3254),
    [anon_sym_COLON_COLON] = ACTIONS(3256),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3256),
    [anon_sym___declspec] = ACTIONS(3254),
    [anon_sym___based] = ACTIONS(3254),
    [anon_sym___cdecl] = ACTIONS(3254),
    [anon_sym___clrcall] = ACTIONS(3254),
    [anon_sym___stdcall] = ACTIONS(3254),
    [anon_sym___fastcall] = ACTIONS(3254),
    [anon_sym___thiscall] = ACTIONS(3254),
    [anon_sym___vectorcall] = ACTIONS(3254),
    [anon_sym_LBRACE] = ACTIONS(3256),
    [anon_sym_RBRACE] = ACTIONS(3256),
    [anon_sym_signed] = ACTIONS(3254),
    [anon_sym_unsigned] = ACTIONS(3254),
    [anon_sym_long] = ACTIONS(3254),
    [anon_sym_short] = ACTIONS(3254),
    [anon_sym_LBRACK] = ACTIONS(3254),
    [anon_sym_static] = ACTIONS(3254),
    [anon_sym_register] = ACTIONS(3254),
    [anon_sym_inline] = ACTIONS(3254),
    [anon_sym___inline] = ACTIONS(3254),
    [anon_sym___inline__] = ACTIONS(3254),
    [anon_sym___forceinline] = ACTIONS(3254),
    [anon_sym_thread_local] = ACTIONS(3254),
    [anon_sym___thread] = ACTIONS(3254),
    [anon_sym_const] = ACTIONS(3254),
    [anon_sym_constexpr] = ACTIONS(3254),
    [anon_sym_volatile] = ACTIONS(3254),
    [anon_sym_restrict] = ACTIONS(3254),
    [anon_sym___restrict__] = ACTIONS(3254),
    [anon_sym__Atomic] = ACTIONS(3254),
    [anon_sym__Noreturn] = ACTIONS(3254),
    [anon_sym_noreturn] = ACTIONS(3254),
    [anon_sym_mutable] = ACTIONS(3254),
    [anon_sym_constinit] = ACTIONS(3254),
    [anon_sym_consteval] = ACTIONS(3254),
    [anon_sym_PROGMEM] = ACTIONS(3254),
    [aux_sym_primitive_type_token1] = ACTIONS(3254),
    [anon_sym_byte] = ACTIONS(3254),
    [anon_sym_word] = ACTIONS(3254),
    [anon_sym_enum] = ACTIONS(3254),
    [anon_sym_class] = ACTIONS(3254),
    [anon_sym_struct] = ACTIONS(3254),
    [anon_sym_union] = ACTIONS(3254),
    [anon_sym_if] = ACTIONS(3254),
    [anon_sym_switch] = ACTIONS(3254),
    [anon_sym_case] = ACTIONS(3254),
    [anon_sym_default] = ACTIONS(3254),
    [anon_sym_while] = ACTIONS(3254),
    [anon_sym_do] = ACTIONS(3254),
    [anon_sym_for] = ACTIONS(3254),
    [anon_sym_return] = ACTIONS(3254),
    [anon_sym_break] = ACTIONS(3254),
    [anon_sym_continue] = ACTIONS(3254),
    [anon_sym_goto] = ACTIONS(3254),
    [anon_sym___try] = ACTIONS(3254),
    [anon_sym___leave] = ACTIONS(3254),
    [anon_sym_not] = ACTIONS(3254),
    [anon_sym_compl] = ACTIONS(3254),
    [anon_sym_DASH_DASH] = ACTIONS(3256),
    [anon_sym_PLUS_PLUS] = ACTIONS(3256),
    [anon_sym_sizeof] = ACTIONS(3254),
    [anon_sym___alignof__] = ACTIONS(3254),
    [anon_sym___alignof] = ACTIONS(3254),
    [anon_sym__alignof] = ACTIONS(3254),
    [anon_sym_alignof] = ACTIONS(3254),
    [anon_sym__Alignof] = ACTIONS(3254),
    [anon_sym_offsetof] = ACTIONS(3254),
    [anon_sym__Generic] = ACTIONS(3254),
    [anon_sym_asm] = ACTIONS(3254),
    [anon_sym___asm__] = ACTIONS(3254),
    [aux_sym_number_literal_token1] = ACTIONS(3256),
    [aux_sym_number_literal_token2] = ACTIONS(3254),
    [anon_sym_L_SQUOTE] = ACTIONS(3256),
    [anon_sym_u_SQUOTE] = ACTIONS(3256),
    [anon_sym_U_SQUOTE] = ACTIONS(3256),
    [anon_sym_u8_SQUOTE] = ACTIONS(3256),
    [anon_sym_SQUOTE] = ACTIONS(3256),
    [anon_sym_L_DQUOTE] = ACTIONS(3256),
    [anon_sym_u_DQUOTE] = ACTIONS(3256),
    [anon_sym_U_DQUOTE] = ACTIONS(3256),
    [anon_sym_u8_DQUOTE] = ACTIONS(3256),
    [anon_sym_DQUOTE] = ACTIONS(3256),
    [sym_true] = ACTIONS(3254),
    [sym_false] = ACTIONS(3254),
    [anon_sym_NULL] = ACTIONS(3254),
    [anon_sym_nullptr] = ACTIONS(3254),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3254),
    [anon_sym_decltype] = ACTIONS(3254),
    [anon_sym_virtual] = ACTIONS(3254),
    [anon_sym_alignas] = ACTIONS(3254),
    [anon_sym_explicit] = ACTIONS(3254),
    [anon_sym_typename] = ACTIONS(3254),
    [anon_sym_template] = ACTIONS(3254),
    [anon_sym_operator] = ACTIONS(3254),
    [anon_sym_try] = ACTIONS(3254),
    [anon_sym_delete] = ACTIONS(3254),
    [anon_sym_throw] = ACTIONS(3254),
    [anon_sym_namespace] = ACTIONS(3254),
    [anon_sym_using] = ACTIONS(3254),
    [anon_sym_static_assert] = ACTIONS(3254),
    [anon_sym_concept] = ACTIONS(3254),
    [anon_sym_co_return] = ACTIONS(3254),
    [anon_sym_co_yield] = ACTIONS(3254),
    [anon_sym_R_DQUOTE] = ACTIONS(3256),
    [anon_sym_LR_DQUOTE] = ACTIONS(3256),
    [anon_sym_uR_DQUOTE] = ACTIONS(3256),
    [anon_sym_UR_DQUOTE] = ACTIONS(3256),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3256),
    [anon_sym_co_await] = ACTIONS(3254),
    [anon_sym_new] = ACTIONS(3254),
    [anon_sym_requires] = ACTIONS(3254),
    [sym_this] = ACTIONS(3254),
  },
  [956] = {
    [sym_identifier] = ACTIONS(3192),
    [aux_sym_preproc_include_token1] = ACTIONS(3192),
    [aux_sym_preproc_def_token1] = ACTIONS(3192),
    [aux_sym_preproc_if_token1] = ACTIONS(3192),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3192),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3192),
    [sym_preproc_directive] = ACTIONS(3192),
    [anon_sym_LPAREN2] = ACTIONS(3194),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_DASH] = ACTIONS(3192),
    [anon_sym_PLUS] = ACTIONS(3192),
    [anon_sym_STAR] = ACTIONS(3194),
    [anon_sym_AMP_AMP] = ACTIONS(3194),
    [anon_sym_AMP] = ACTIONS(3192),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym___extension__] = ACTIONS(3192),
    [anon_sym_typedef] = ACTIONS(3192),
    [anon_sym_extern] = ACTIONS(3192),
    [anon_sym___attribute__] = ACTIONS(3192),
    [anon_sym_COLON_COLON] = ACTIONS(3194),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3194),
    [anon_sym___declspec] = ACTIONS(3192),
    [anon_sym___based] = ACTIONS(3192),
    [anon_sym___cdecl] = ACTIONS(3192),
    [anon_sym___clrcall] = ACTIONS(3192),
    [anon_sym___stdcall] = ACTIONS(3192),
    [anon_sym___fastcall] = ACTIONS(3192),
    [anon_sym___thiscall] = ACTIONS(3192),
    [anon_sym___vectorcall] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3194),
    [anon_sym_signed] = ACTIONS(3192),
    [anon_sym_unsigned] = ACTIONS(3192),
    [anon_sym_long] = ACTIONS(3192),
    [anon_sym_short] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [anon_sym_static] = ACTIONS(3192),
    [anon_sym_register] = ACTIONS(3192),
    [anon_sym_inline] = ACTIONS(3192),
    [anon_sym___inline] = ACTIONS(3192),
    [anon_sym___inline__] = ACTIONS(3192),
    [anon_sym___forceinline] = ACTIONS(3192),
    [anon_sym_thread_local] = ACTIONS(3192),
    [anon_sym___thread] = ACTIONS(3192),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_constexpr] = ACTIONS(3192),
    [anon_sym_volatile] = ACTIONS(3192),
    [anon_sym_restrict] = ACTIONS(3192),
    [anon_sym___restrict__] = ACTIONS(3192),
    [anon_sym__Atomic] = ACTIONS(3192),
    [anon_sym__Noreturn] = ACTIONS(3192),
    [anon_sym_noreturn] = ACTIONS(3192),
    [anon_sym_mutable] = ACTIONS(3192),
    [anon_sym_constinit] = ACTIONS(3192),
    [anon_sym_consteval] = ACTIONS(3192),
    [anon_sym_PROGMEM] = ACTIONS(3192),
    [aux_sym_primitive_type_token1] = ACTIONS(3192),
    [anon_sym_byte] = ACTIONS(3192),
    [anon_sym_word] = ACTIONS(3192),
    [anon_sym_enum] = ACTIONS(3192),
    [anon_sym_class] = ACTIONS(3192),
    [anon_sym_struct] = ACTIONS(3192),
    [anon_sym_union] = ACTIONS(3192),
    [anon_sym_if] = ACTIONS(3192),
    [anon_sym_switch] = ACTIONS(3192),
    [anon_sym_case] = ACTIONS(3192),
    [anon_sym_default] = ACTIONS(3192),
    [anon_sym_while] = ACTIONS(3192),
    [anon_sym_do] = ACTIONS(3192),
    [anon_sym_for] = ACTIONS(3192),
    [anon_sym_return] = ACTIONS(3192),
    [anon_sym_break] = ACTIONS(3192),
    [anon_sym_continue] = ACTIONS(3192),
    [anon_sym_goto] = ACTIONS(3192),
    [anon_sym___try] = ACTIONS(3192),
    [anon_sym___leave] = ACTIONS(3192),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_compl] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3194),
    [anon_sym_PLUS_PLUS] = ACTIONS(3194),
    [anon_sym_sizeof] = ACTIONS(3192),
    [anon_sym___alignof__] = ACTIONS(3192),
    [anon_sym___alignof] = ACTIONS(3192),
    [anon_sym__alignof] = ACTIONS(3192),
    [anon_sym_alignof] = ACTIONS(3192),
    [anon_sym__Alignof] = ACTIONS(3192),
    [anon_sym_offsetof] = ACTIONS(3192),
    [anon_sym__Generic] = ACTIONS(3192),
    [anon_sym_asm] = ACTIONS(3192),
    [anon_sym___asm__] = ACTIONS(3192),
    [aux_sym_number_literal_token1] = ACTIONS(3194),
    [aux_sym_number_literal_token2] = ACTIONS(3192),
    [anon_sym_L_SQUOTE] = ACTIONS(3194),
    [anon_sym_u_SQUOTE] = ACTIONS(3194),
    [anon_sym_U_SQUOTE] = ACTIONS(3194),
    [anon_sym_u8_SQUOTE] = ACTIONS(3194),
    [anon_sym_SQUOTE] = ACTIONS(3194),
    [anon_sym_L_DQUOTE] = ACTIONS(3194),
    [anon_sym_u_DQUOTE] = ACTIONS(3194),
    [anon_sym_U_DQUOTE] = ACTIONS(3194),
    [anon_sym_u8_DQUOTE] = ACTIONS(3194),
    [anon_sym_DQUOTE] = ACTIONS(3194),
    [sym_true] = ACTIONS(3192),
    [sym_false] = ACTIONS(3192),
    [anon_sym_NULL] = ACTIONS(3192),
    [anon_sym_nullptr] = ACTIONS(3192),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3192),
    [anon_sym_decltype] = ACTIONS(3192),
    [anon_sym_virtual] = ACTIONS(3192),
    [anon_sym_alignas] = ACTIONS(3192),
    [anon_sym_explicit] = ACTIONS(3192),
    [anon_sym_typename] = ACTIONS(3192),
    [anon_sym_template] = ACTIONS(3192),
    [anon_sym_operator] = ACTIONS(3192),
    [anon_sym_try] = ACTIONS(3192),
    [anon_sym_delete] = ACTIONS(3192),
    [anon_sym_throw] = ACTIONS(3192),
    [anon_sym_namespace] = ACTIONS(3192),
    [anon_sym_using] = ACTIONS(3192),
    [anon_sym_static_assert] = ACTIONS(3192),
    [anon_sym_concept] = ACTIONS(3192),
    [anon_sym_co_return] = ACTIONS(3192),
    [anon_sym_co_yield] = ACTIONS(3192),
    [anon_sym_R_DQUOTE] = ACTIONS(3194),
    [anon_sym_LR_DQUOTE] = ACTIONS(3194),
    [anon_sym_uR_DQUOTE] = ACTIONS(3194),
    [anon_sym_UR_DQUOTE] = ACTIONS(3194),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3194),
    [anon_sym_co_await] = ACTIONS(3192),
    [anon_sym_new] = ACTIONS(3192),
    [anon_sym_requires] = ACTIONS(3192),
    [sym_this] = ACTIONS(3192),
  },
  [957] = {
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_include_token1] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_BANG] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3513),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym_SEMI] = ACTIONS(3515),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym___cdecl] = ACTIONS(3513),
    [anon_sym___clrcall] = ACTIONS(3513),
    [anon_sym___stdcall] = ACTIONS(3513),
    [anon_sym___fastcall] = ACTIONS(3513),
    [anon_sym___thiscall] = ACTIONS(3513),
    [anon_sym___vectorcall] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_RBRACE] = ACTIONS(3515),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_PROGMEM] = ACTIONS(3513),
    [aux_sym_primitive_type_token1] = ACTIONS(3513),
    [anon_sym_byte] = ACTIONS(3513),
    [anon_sym_word] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [anon_sym_if] = ACTIONS(3513),
    [anon_sym_switch] = ACTIONS(3513),
    [anon_sym_case] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3513),
    [anon_sym_while] = ACTIONS(3513),
    [anon_sym_do] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3513),
    [anon_sym_return] = ACTIONS(3513),
    [anon_sym_break] = ACTIONS(3513),
    [anon_sym_continue] = ACTIONS(3513),
    [anon_sym_goto] = ACTIONS(3513),
    [anon_sym___try] = ACTIONS(3513),
    [anon_sym___leave] = ACTIONS(3513),
    [anon_sym_not] = ACTIONS(3513),
    [anon_sym_compl] = ACTIONS(3513),
    [anon_sym_DASH_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_PLUS] = ACTIONS(3515),
    [anon_sym_sizeof] = ACTIONS(3513),
    [anon_sym___alignof__] = ACTIONS(3513),
    [anon_sym___alignof] = ACTIONS(3513),
    [anon_sym__alignof] = ACTIONS(3513),
    [anon_sym_alignof] = ACTIONS(3513),
    [anon_sym__Alignof] = ACTIONS(3513),
    [anon_sym_offsetof] = ACTIONS(3513),
    [anon_sym__Generic] = ACTIONS(3513),
    [anon_sym_asm] = ACTIONS(3513),
    [anon_sym___asm__] = ACTIONS(3513),
    [aux_sym_number_literal_token1] = ACTIONS(3515),
    [aux_sym_number_literal_token2] = ACTIONS(3513),
    [anon_sym_L_SQUOTE] = ACTIONS(3515),
    [anon_sym_u_SQUOTE] = ACTIONS(3515),
    [anon_sym_U_SQUOTE] = ACTIONS(3515),
    [anon_sym_u8_SQUOTE] = ACTIONS(3515),
    [anon_sym_SQUOTE] = ACTIONS(3515),
    [anon_sym_L_DQUOTE] = ACTIONS(3515),
    [anon_sym_u_DQUOTE] = ACTIONS(3515),
    [anon_sym_U_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [sym_true] = ACTIONS(3513),
    [sym_false] = ACTIONS(3513),
    [anon_sym_NULL] = ACTIONS(3513),
    [anon_sym_nullptr] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [anon_sym_virtual] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3513),
    [anon_sym_delete] = ACTIONS(3513),
    [anon_sym_throw] = ACTIONS(3513),
    [anon_sym_namespace] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
    [anon_sym_concept] = ACTIONS(3513),
    [anon_sym_co_return] = ACTIONS(3513),
    [anon_sym_co_yield] = ACTIONS(3513),
    [anon_sym_R_DQUOTE] = ACTIONS(3515),
    [anon_sym_LR_DQUOTE] = ACTIONS(3515),
    [anon_sym_uR_DQUOTE] = ACTIONS(3515),
    [anon_sym_UR_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3515),
    [anon_sym_co_await] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3513),
    [anon_sym_requires] = ACTIONS(3513),
    [sym_this] = ACTIONS(3513),
  },
  [958] = {
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_include_token1] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_BANG] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3513),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym_SEMI] = ACTIONS(3515),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym___cdecl] = ACTIONS(3513),
    [anon_sym___clrcall] = ACTIONS(3513),
    [anon_sym___stdcall] = ACTIONS(3513),
    [anon_sym___fastcall] = ACTIONS(3513),
    [anon_sym___thiscall] = ACTIONS(3513),
    [anon_sym___vectorcall] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_RBRACE] = ACTIONS(3515),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_PROGMEM] = ACTIONS(3513),
    [aux_sym_primitive_type_token1] = ACTIONS(3513),
    [anon_sym_byte] = ACTIONS(3513),
    [anon_sym_word] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [anon_sym_if] = ACTIONS(3513),
    [anon_sym_switch] = ACTIONS(3513),
    [anon_sym_case] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3513),
    [anon_sym_while] = ACTIONS(3513),
    [anon_sym_do] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3513),
    [anon_sym_return] = ACTIONS(3513),
    [anon_sym_break] = ACTIONS(3513),
    [anon_sym_continue] = ACTIONS(3513),
    [anon_sym_goto] = ACTIONS(3513),
    [anon_sym___try] = ACTIONS(3513),
    [anon_sym___leave] = ACTIONS(3513),
    [anon_sym_not] = ACTIONS(3513),
    [anon_sym_compl] = ACTIONS(3513),
    [anon_sym_DASH_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_PLUS] = ACTIONS(3515),
    [anon_sym_sizeof] = ACTIONS(3513),
    [anon_sym___alignof__] = ACTIONS(3513),
    [anon_sym___alignof] = ACTIONS(3513),
    [anon_sym__alignof] = ACTIONS(3513),
    [anon_sym_alignof] = ACTIONS(3513),
    [anon_sym__Alignof] = ACTIONS(3513),
    [anon_sym_offsetof] = ACTIONS(3513),
    [anon_sym__Generic] = ACTIONS(3513),
    [anon_sym_asm] = ACTIONS(3513),
    [anon_sym___asm__] = ACTIONS(3513),
    [aux_sym_number_literal_token1] = ACTIONS(3515),
    [aux_sym_number_literal_token2] = ACTIONS(3513),
    [anon_sym_L_SQUOTE] = ACTIONS(3515),
    [anon_sym_u_SQUOTE] = ACTIONS(3515),
    [anon_sym_U_SQUOTE] = ACTIONS(3515),
    [anon_sym_u8_SQUOTE] = ACTIONS(3515),
    [anon_sym_SQUOTE] = ACTIONS(3515),
    [anon_sym_L_DQUOTE] = ACTIONS(3515),
    [anon_sym_u_DQUOTE] = ACTIONS(3515),
    [anon_sym_U_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [sym_true] = ACTIONS(3513),
    [sym_false] = ACTIONS(3513),
    [anon_sym_NULL] = ACTIONS(3513),
    [anon_sym_nullptr] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [anon_sym_virtual] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3513),
    [anon_sym_delete] = ACTIONS(3513),
    [anon_sym_throw] = ACTIONS(3513),
    [anon_sym_namespace] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
    [anon_sym_concept] = ACTIONS(3513),
    [anon_sym_co_return] = ACTIONS(3513),
    [anon_sym_co_yield] = ACTIONS(3513),
    [anon_sym_R_DQUOTE] = ACTIONS(3515),
    [anon_sym_LR_DQUOTE] = ACTIONS(3515),
    [anon_sym_uR_DQUOTE] = ACTIONS(3515),
    [anon_sym_UR_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3515),
    [anon_sym_co_await] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3513),
    [anon_sym_requires] = ACTIONS(3513),
    [sym_this] = ACTIONS(3513),
  },
  [959] = {
    [sym_identifier] = ACTIONS(3427),
    [aux_sym_preproc_include_token1] = ACTIONS(3427),
    [aux_sym_preproc_def_token1] = ACTIONS(3427),
    [aux_sym_preproc_if_token1] = ACTIONS(3427),
    [aux_sym_preproc_if_token2] = ACTIONS(3427),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3427),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3427),
    [sym_preproc_directive] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3429),
    [anon_sym_BANG] = ACTIONS(3429),
    [anon_sym_TILDE] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3429),
    [anon_sym_AMP_AMP] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(3429),
    [anon_sym___extension__] = ACTIONS(3427),
    [anon_sym_typedef] = ACTIONS(3427),
    [anon_sym_extern] = ACTIONS(3427),
    [anon_sym___attribute__] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3429),
    [anon_sym___declspec] = ACTIONS(3427),
    [anon_sym___based] = ACTIONS(3427),
    [anon_sym___cdecl] = ACTIONS(3427),
    [anon_sym___clrcall] = ACTIONS(3427),
    [anon_sym___stdcall] = ACTIONS(3427),
    [anon_sym___fastcall] = ACTIONS(3427),
    [anon_sym___thiscall] = ACTIONS(3427),
    [anon_sym___vectorcall] = ACTIONS(3427),
    [anon_sym_LBRACE] = ACTIONS(3429),
    [anon_sym_signed] = ACTIONS(3427),
    [anon_sym_unsigned] = ACTIONS(3427),
    [anon_sym_long] = ACTIONS(3427),
    [anon_sym_short] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_register] = ACTIONS(3427),
    [anon_sym_inline] = ACTIONS(3427),
    [anon_sym___inline] = ACTIONS(3427),
    [anon_sym___inline__] = ACTIONS(3427),
    [anon_sym___forceinline] = ACTIONS(3427),
    [anon_sym_thread_local] = ACTIONS(3427),
    [anon_sym___thread] = ACTIONS(3427),
    [anon_sym_const] = ACTIONS(3427),
    [anon_sym_constexpr] = ACTIONS(3427),
    [anon_sym_volatile] = ACTIONS(3427),
    [anon_sym_restrict] = ACTIONS(3427),
    [anon_sym___restrict__] = ACTIONS(3427),
    [anon_sym__Atomic] = ACTIONS(3427),
    [anon_sym__Noreturn] = ACTIONS(3427),
    [anon_sym_noreturn] = ACTIONS(3427),
    [anon_sym_mutable] = ACTIONS(3427),
    [anon_sym_constinit] = ACTIONS(3427),
    [anon_sym_consteval] = ACTIONS(3427),
    [anon_sym_PROGMEM] = ACTIONS(3427),
    [aux_sym_primitive_type_token1] = ACTIONS(3427),
    [anon_sym_byte] = ACTIONS(3427),
    [anon_sym_word] = ACTIONS(3427),
    [anon_sym_enum] = ACTIONS(3427),
    [anon_sym_class] = ACTIONS(3427),
    [anon_sym_struct] = ACTIONS(3427),
    [anon_sym_union] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_switch] = ACTIONS(3427),
    [anon_sym_case] = ACTIONS(3427),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_break] = ACTIONS(3427),
    [anon_sym_continue] = ACTIONS(3427),
    [anon_sym_goto] = ACTIONS(3427),
    [anon_sym___try] = ACTIONS(3427),
    [anon_sym___leave] = ACTIONS(3427),
    [anon_sym_not] = ACTIONS(3427),
    [anon_sym_compl] = ACTIONS(3427),
    [anon_sym_DASH_DASH] = ACTIONS(3429),
    [anon_sym_PLUS_PLUS] = ACTIONS(3429),
    [anon_sym_sizeof] = ACTIONS(3427),
    [anon_sym___alignof__] = ACTIONS(3427),
    [anon_sym___alignof] = ACTIONS(3427),
    [anon_sym__alignof] = ACTIONS(3427),
    [anon_sym_alignof] = ACTIONS(3427),
    [anon_sym__Alignof] = ACTIONS(3427),
    [anon_sym_offsetof] = ACTIONS(3427),
    [anon_sym__Generic] = ACTIONS(3427),
    [anon_sym_asm] = ACTIONS(3427),
    [anon_sym___asm__] = ACTIONS(3427),
    [aux_sym_number_literal_token1] = ACTIONS(3429),
    [aux_sym_number_literal_token2] = ACTIONS(3427),
    [anon_sym_L_SQUOTE] = ACTIONS(3429),
    [anon_sym_u_SQUOTE] = ACTIONS(3429),
    [anon_sym_U_SQUOTE] = ACTIONS(3429),
    [anon_sym_u8_SQUOTE] = ACTIONS(3429),
    [anon_sym_SQUOTE] = ACTIONS(3429),
    [anon_sym_L_DQUOTE] = ACTIONS(3429),
    [anon_sym_u_DQUOTE] = ACTIONS(3429),
    [anon_sym_U_DQUOTE] = ACTIONS(3429),
    [anon_sym_u8_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(3429),
    [sym_true] = ACTIONS(3427),
    [sym_false] = ACTIONS(3427),
    [anon_sym_NULL] = ACTIONS(3427),
    [anon_sym_nullptr] = ACTIONS(3427),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3427),
    [anon_sym_decltype] = ACTIONS(3427),
    [anon_sym_virtual] = ACTIONS(3427),
    [anon_sym_alignas] = ACTIONS(3427),
    [anon_sym_explicit] = ACTIONS(3427),
    [anon_sym_typename] = ACTIONS(3427),
    [anon_sym_template] = ACTIONS(3427),
    [anon_sym_operator] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_delete] = ACTIONS(3427),
    [anon_sym_throw] = ACTIONS(3427),
    [anon_sym_namespace] = ACTIONS(3427),
    [anon_sym_using] = ACTIONS(3427),
    [anon_sym_static_assert] = ACTIONS(3427),
    [anon_sym_concept] = ACTIONS(3427),
    [anon_sym_co_return] = ACTIONS(3427),
    [anon_sym_co_yield] = ACTIONS(3427),
    [anon_sym_R_DQUOTE] = ACTIONS(3429),
    [anon_sym_LR_DQUOTE] = ACTIONS(3429),
    [anon_sym_uR_DQUOTE] = ACTIONS(3429),
    [anon_sym_UR_DQUOTE] = ACTIONS(3429),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3429),
    [anon_sym_co_await] = ACTIONS(3427),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_requires] = ACTIONS(3427),
    [sym_this] = ACTIONS(3427),
  },
  [960] = {
    [sym_identifier] = ACTIONS(3423),
    [aux_sym_preproc_include_token1] = ACTIONS(3423),
    [aux_sym_preproc_def_token1] = ACTIONS(3423),
    [aux_sym_preproc_if_token1] = ACTIONS(3423),
    [aux_sym_preproc_if_token2] = ACTIONS(3423),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3423),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3423),
    [sym_preproc_directive] = ACTIONS(3423),
    [anon_sym_LPAREN2] = ACTIONS(3425),
    [anon_sym_BANG] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [anon_sym_DASH] = ACTIONS(3423),
    [anon_sym_PLUS] = ACTIONS(3423),
    [anon_sym_STAR] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3425),
    [anon_sym___extension__] = ACTIONS(3423),
    [anon_sym_typedef] = ACTIONS(3423),
    [anon_sym_extern] = ACTIONS(3423),
    [anon_sym___attribute__] = ACTIONS(3423),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3425),
    [anon_sym___declspec] = ACTIONS(3423),
    [anon_sym___based] = ACTIONS(3423),
    [anon_sym___cdecl] = ACTIONS(3423),
    [anon_sym___clrcall] = ACTIONS(3423),
    [anon_sym___stdcall] = ACTIONS(3423),
    [anon_sym___fastcall] = ACTIONS(3423),
    [anon_sym___thiscall] = ACTIONS(3423),
    [anon_sym___vectorcall] = ACTIONS(3423),
    [anon_sym_LBRACE] = ACTIONS(3425),
    [anon_sym_signed] = ACTIONS(3423),
    [anon_sym_unsigned] = ACTIONS(3423),
    [anon_sym_long] = ACTIONS(3423),
    [anon_sym_short] = ACTIONS(3423),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_static] = ACTIONS(3423),
    [anon_sym_register] = ACTIONS(3423),
    [anon_sym_inline] = ACTIONS(3423),
    [anon_sym___inline] = ACTIONS(3423),
    [anon_sym___inline__] = ACTIONS(3423),
    [anon_sym___forceinline] = ACTIONS(3423),
    [anon_sym_thread_local] = ACTIONS(3423),
    [anon_sym___thread] = ACTIONS(3423),
    [anon_sym_const] = ACTIONS(3423),
    [anon_sym_constexpr] = ACTIONS(3423),
    [anon_sym_volatile] = ACTIONS(3423),
    [anon_sym_restrict] = ACTIONS(3423),
    [anon_sym___restrict__] = ACTIONS(3423),
    [anon_sym__Atomic] = ACTIONS(3423),
    [anon_sym__Noreturn] = ACTIONS(3423),
    [anon_sym_noreturn] = ACTIONS(3423),
    [anon_sym_mutable] = ACTIONS(3423),
    [anon_sym_constinit] = ACTIONS(3423),
    [anon_sym_consteval] = ACTIONS(3423),
    [anon_sym_PROGMEM] = ACTIONS(3423),
    [aux_sym_primitive_type_token1] = ACTIONS(3423),
    [anon_sym_byte] = ACTIONS(3423),
    [anon_sym_word] = ACTIONS(3423),
    [anon_sym_enum] = ACTIONS(3423),
    [anon_sym_class] = ACTIONS(3423),
    [anon_sym_struct] = ACTIONS(3423),
    [anon_sym_union] = ACTIONS(3423),
    [anon_sym_if] = ACTIONS(3423),
    [anon_sym_switch] = ACTIONS(3423),
    [anon_sym_case] = ACTIONS(3423),
    [anon_sym_default] = ACTIONS(3423),
    [anon_sym_while] = ACTIONS(3423),
    [anon_sym_do] = ACTIONS(3423),
    [anon_sym_for] = ACTIONS(3423),
    [anon_sym_return] = ACTIONS(3423),
    [anon_sym_break] = ACTIONS(3423),
    [anon_sym_continue] = ACTIONS(3423),
    [anon_sym_goto] = ACTIONS(3423),
    [anon_sym___try] = ACTIONS(3423),
    [anon_sym___leave] = ACTIONS(3423),
    [anon_sym_not] = ACTIONS(3423),
    [anon_sym_compl] = ACTIONS(3423),
    [anon_sym_DASH_DASH] = ACTIONS(3425),
    [anon_sym_PLUS_PLUS] = ACTIONS(3425),
    [anon_sym_sizeof] = ACTIONS(3423),
    [anon_sym___alignof__] = ACTIONS(3423),
    [anon_sym___alignof] = ACTIONS(3423),
    [anon_sym__alignof] = ACTIONS(3423),
    [anon_sym_alignof] = ACTIONS(3423),
    [anon_sym__Alignof] = ACTIONS(3423),
    [anon_sym_offsetof] = ACTIONS(3423),
    [anon_sym__Generic] = ACTIONS(3423),
    [anon_sym_asm] = ACTIONS(3423),
    [anon_sym___asm__] = ACTIONS(3423),
    [aux_sym_number_literal_token1] = ACTIONS(3425),
    [aux_sym_number_literal_token2] = ACTIONS(3423),
    [anon_sym_L_SQUOTE] = ACTIONS(3425),
    [anon_sym_u_SQUOTE] = ACTIONS(3425),
    [anon_sym_U_SQUOTE] = ACTIONS(3425),
    [anon_sym_u8_SQUOTE] = ACTIONS(3425),
    [anon_sym_SQUOTE] = ACTIONS(3425),
    [anon_sym_L_DQUOTE] = ACTIONS(3425),
    [anon_sym_u_DQUOTE] = ACTIONS(3425),
    [anon_sym_U_DQUOTE] = ACTIONS(3425),
    [anon_sym_u8_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [sym_true] = ACTIONS(3423),
    [sym_false] = ACTIONS(3423),
    [anon_sym_NULL] = ACTIONS(3423),
    [anon_sym_nullptr] = ACTIONS(3423),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3423),
    [anon_sym_decltype] = ACTIONS(3423),
    [anon_sym_virtual] = ACTIONS(3423),
    [anon_sym_alignas] = ACTIONS(3423),
    [anon_sym_explicit] = ACTIONS(3423),
    [anon_sym_typename] = ACTIONS(3423),
    [anon_sym_template] = ACTIONS(3423),
    [anon_sym_operator] = ACTIONS(3423),
    [anon_sym_try] = ACTIONS(3423),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_throw] = ACTIONS(3423),
    [anon_sym_namespace] = ACTIONS(3423),
    [anon_sym_using] = ACTIONS(3423),
    [anon_sym_static_assert] = ACTIONS(3423),
    [anon_sym_concept] = ACTIONS(3423),
    [anon_sym_co_return] = ACTIONS(3423),
    [anon_sym_co_yield] = ACTIONS(3423),
    [anon_sym_R_DQUOTE] = ACTIONS(3425),
    [anon_sym_LR_DQUOTE] = ACTIONS(3425),
    [anon_sym_uR_DQUOTE] = ACTIONS(3425),
    [anon_sym_UR_DQUOTE] = ACTIONS(3425),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3425),
    [anon_sym_co_await] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3423),
    [anon_sym_requires] = ACTIONS(3423),
    [sym_this] = ACTIONS(3423),
  },
  [961] = {
    [sym_identifier] = ACTIONS(3371),
    [aux_sym_preproc_include_token1] = ACTIONS(3371),
    [aux_sym_preproc_def_token1] = ACTIONS(3371),
    [aux_sym_preproc_if_token1] = ACTIONS(3371),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3371),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3371),
    [sym_preproc_directive] = ACTIONS(3371),
    [anon_sym_LPAREN2] = ACTIONS(3373),
    [anon_sym_BANG] = ACTIONS(3373),
    [anon_sym_TILDE] = ACTIONS(3373),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_STAR] = ACTIONS(3373),
    [anon_sym_AMP_AMP] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3371),
    [anon_sym_SEMI] = ACTIONS(3373),
    [anon_sym___extension__] = ACTIONS(3371),
    [anon_sym_typedef] = ACTIONS(3371),
    [anon_sym_extern] = ACTIONS(3371),
    [anon_sym___attribute__] = ACTIONS(3371),
    [anon_sym_COLON_COLON] = ACTIONS(3373),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3373),
    [anon_sym___declspec] = ACTIONS(3371),
    [anon_sym___based] = ACTIONS(3371),
    [anon_sym___cdecl] = ACTIONS(3371),
    [anon_sym___clrcall] = ACTIONS(3371),
    [anon_sym___stdcall] = ACTIONS(3371),
    [anon_sym___fastcall] = ACTIONS(3371),
    [anon_sym___thiscall] = ACTIONS(3371),
    [anon_sym___vectorcall] = ACTIONS(3371),
    [anon_sym_LBRACE] = ACTIONS(3373),
    [anon_sym_RBRACE] = ACTIONS(3373),
    [anon_sym_signed] = ACTIONS(3371),
    [anon_sym_unsigned] = ACTIONS(3371),
    [anon_sym_long] = ACTIONS(3371),
    [anon_sym_short] = ACTIONS(3371),
    [anon_sym_LBRACK] = ACTIONS(3371),
    [anon_sym_static] = ACTIONS(3371),
    [anon_sym_register] = ACTIONS(3371),
    [anon_sym_inline] = ACTIONS(3371),
    [anon_sym___inline] = ACTIONS(3371),
    [anon_sym___inline__] = ACTIONS(3371),
    [anon_sym___forceinline] = ACTIONS(3371),
    [anon_sym_thread_local] = ACTIONS(3371),
    [anon_sym___thread] = ACTIONS(3371),
    [anon_sym_const] = ACTIONS(3371),
    [anon_sym_constexpr] = ACTIONS(3371),
    [anon_sym_volatile] = ACTIONS(3371),
    [anon_sym_restrict] = ACTIONS(3371),
    [anon_sym___restrict__] = ACTIONS(3371),
    [anon_sym__Atomic] = ACTIONS(3371),
    [anon_sym__Noreturn] = ACTIONS(3371),
    [anon_sym_noreturn] = ACTIONS(3371),
    [anon_sym_mutable] = ACTIONS(3371),
    [anon_sym_constinit] = ACTIONS(3371),
    [anon_sym_consteval] = ACTIONS(3371),
    [anon_sym_PROGMEM] = ACTIONS(3371),
    [aux_sym_primitive_type_token1] = ACTIONS(3371),
    [anon_sym_byte] = ACTIONS(3371),
    [anon_sym_word] = ACTIONS(3371),
    [anon_sym_enum] = ACTIONS(3371),
    [anon_sym_class] = ACTIONS(3371),
    [anon_sym_struct] = ACTIONS(3371),
    [anon_sym_union] = ACTIONS(3371),
    [anon_sym_if] = ACTIONS(3371),
    [anon_sym_switch] = ACTIONS(3371),
    [anon_sym_case] = ACTIONS(3371),
    [anon_sym_default] = ACTIONS(3371),
    [anon_sym_while] = ACTIONS(3371),
    [anon_sym_do] = ACTIONS(3371),
    [anon_sym_for] = ACTIONS(3371),
    [anon_sym_return] = ACTIONS(3371),
    [anon_sym_break] = ACTIONS(3371),
    [anon_sym_continue] = ACTIONS(3371),
    [anon_sym_goto] = ACTIONS(3371),
    [anon_sym___try] = ACTIONS(3371),
    [anon_sym___leave] = ACTIONS(3371),
    [anon_sym_not] = ACTIONS(3371),
    [anon_sym_compl] = ACTIONS(3371),
    [anon_sym_DASH_DASH] = ACTIONS(3373),
    [anon_sym_PLUS_PLUS] = ACTIONS(3373),
    [anon_sym_sizeof] = ACTIONS(3371),
    [anon_sym___alignof__] = ACTIONS(3371),
    [anon_sym___alignof] = ACTIONS(3371),
    [anon_sym__alignof] = ACTIONS(3371),
    [anon_sym_alignof] = ACTIONS(3371),
    [anon_sym__Alignof] = ACTIONS(3371),
    [anon_sym_offsetof] = ACTIONS(3371),
    [anon_sym__Generic] = ACTIONS(3371),
    [anon_sym_asm] = ACTIONS(3371),
    [anon_sym___asm__] = ACTIONS(3371),
    [aux_sym_number_literal_token1] = ACTIONS(3373),
    [aux_sym_number_literal_token2] = ACTIONS(3371),
    [anon_sym_L_SQUOTE] = ACTIONS(3373),
    [anon_sym_u_SQUOTE] = ACTIONS(3373),
    [anon_sym_U_SQUOTE] = ACTIONS(3373),
    [anon_sym_u8_SQUOTE] = ACTIONS(3373),
    [anon_sym_SQUOTE] = ACTIONS(3373),
    [anon_sym_L_DQUOTE] = ACTIONS(3373),
    [anon_sym_u_DQUOTE] = ACTIONS(3373),
    [anon_sym_U_DQUOTE] = ACTIONS(3373),
    [anon_sym_u8_DQUOTE] = ACTIONS(3373),
    [anon_sym_DQUOTE] = ACTIONS(3373),
    [sym_true] = ACTIONS(3371),
    [sym_false] = ACTIONS(3371),
    [anon_sym_NULL] = ACTIONS(3371),
    [anon_sym_nullptr] = ACTIONS(3371),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3371),
    [anon_sym_decltype] = ACTIONS(3371),
    [anon_sym_virtual] = ACTIONS(3371),
    [anon_sym_alignas] = ACTIONS(3371),
    [anon_sym_explicit] = ACTIONS(3371),
    [anon_sym_typename] = ACTIONS(3371),
    [anon_sym_template] = ACTIONS(3371),
    [anon_sym_operator] = ACTIONS(3371),
    [anon_sym_try] = ACTIONS(3371),
    [anon_sym_delete] = ACTIONS(3371),
    [anon_sym_throw] = ACTIONS(3371),
    [anon_sym_namespace] = ACTIONS(3371),
    [anon_sym_using] = ACTIONS(3371),
    [anon_sym_static_assert] = ACTIONS(3371),
    [anon_sym_concept] = ACTIONS(3371),
    [anon_sym_co_return] = ACTIONS(3371),
    [anon_sym_co_yield] = ACTIONS(3371),
    [anon_sym_R_DQUOTE] = ACTIONS(3373),
    [anon_sym_LR_DQUOTE] = ACTIONS(3373),
    [anon_sym_uR_DQUOTE] = ACTIONS(3373),
    [anon_sym_UR_DQUOTE] = ACTIONS(3373),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3373),
    [anon_sym_co_await] = ACTIONS(3371),
    [anon_sym_new] = ACTIONS(3371),
    [anon_sym_requires] = ACTIONS(3371),
    [sym_this] = ACTIONS(3371),
  },
  [962] = {
    [sym_identifier] = ACTIONS(3525),
    [aux_sym_preproc_include_token1] = ACTIONS(3525),
    [aux_sym_preproc_def_token1] = ACTIONS(3525),
    [aux_sym_preproc_if_token1] = ACTIONS(3525),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3525),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3525),
    [sym_preproc_directive] = ACTIONS(3525),
    [anon_sym_LPAREN2] = ACTIONS(3527),
    [anon_sym_BANG] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3525),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_AMP] = ACTIONS(3525),
    [anon_sym_SEMI] = ACTIONS(3527),
    [anon_sym___extension__] = ACTIONS(3525),
    [anon_sym_typedef] = ACTIONS(3525),
    [anon_sym_extern] = ACTIONS(3525),
    [anon_sym___attribute__] = ACTIONS(3525),
    [anon_sym_COLON_COLON] = ACTIONS(3527),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3527),
    [anon_sym___declspec] = ACTIONS(3525),
    [anon_sym___based] = ACTIONS(3525),
    [anon_sym___cdecl] = ACTIONS(3525),
    [anon_sym___clrcall] = ACTIONS(3525),
    [anon_sym___stdcall] = ACTIONS(3525),
    [anon_sym___fastcall] = ACTIONS(3525),
    [anon_sym___thiscall] = ACTIONS(3525),
    [anon_sym___vectorcall] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_RBRACE] = ACTIONS(3527),
    [anon_sym_signed] = ACTIONS(3525),
    [anon_sym_unsigned] = ACTIONS(3525),
    [anon_sym_long] = ACTIONS(3525),
    [anon_sym_short] = ACTIONS(3525),
    [anon_sym_LBRACK] = ACTIONS(3525),
    [anon_sym_static] = ACTIONS(3525),
    [anon_sym_register] = ACTIONS(3525),
    [anon_sym_inline] = ACTIONS(3525),
    [anon_sym___inline] = ACTIONS(3525),
    [anon_sym___inline__] = ACTIONS(3525),
    [anon_sym___forceinline] = ACTIONS(3525),
    [anon_sym_thread_local] = ACTIONS(3525),
    [anon_sym___thread] = ACTIONS(3525),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_constexpr] = ACTIONS(3525),
    [anon_sym_volatile] = ACTIONS(3525),
    [anon_sym_restrict] = ACTIONS(3525),
    [anon_sym___restrict__] = ACTIONS(3525),
    [anon_sym__Atomic] = ACTIONS(3525),
    [anon_sym__Noreturn] = ACTIONS(3525),
    [anon_sym_noreturn] = ACTIONS(3525),
    [anon_sym_mutable] = ACTIONS(3525),
    [anon_sym_constinit] = ACTIONS(3525),
    [anon_sym_consteval] = ACTIONS(3525),
    [anon_sym_PROGMEM] = ACTIONS(3525),
    [aux_sym_primitive_type_token1] = ACTIONS(3525),
    [anon_sym_byte] = ACTIONS(3525),
    [anon_sym_word] = ACTIONS(3525),
    [anon_sym_enum] = ACTIONS(3525),
    [anon_sym_class] = ACTIONS(3525),
    [anon_sym_struct] = ACTIONS(3525),
    [anon_sym_union] = ACTIONS(3525),
    [anon_sym_if] = ACTIONS(3525),
    [anon_sym_switch] = ACTIONS(3525),
    [anon_sym_case] = ACTIONS(3525),
    [anon_sym_default] = ACTIONS(3525),
    [anon_sym_while] = ACTIONS(3525),
    [anon_sym_do] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3525),
    [anon_sym_return] = ACTIONS(3525),
    [anon_sym_break] = ACTIONS(3525),
    [anon_sym_continue] = ACTIONS(3525),
    [anon_sym_goto] = ACTIONS(3525),
    [anon_sym___try] = ACTIONS(3525),
    [anon_sym___leave] = ACTIONS(3525),
    [anon_sym_not] = ACTIONS(3525),
    [anon_sym_compl] = ACTIONS(3525),
    [anon_sym_DASH_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_PLUS] = ACTIONS(3527),
    [anon_sym_sizeof] = ACTIONS(3525),
    [anon_sym___alignof__] = ACTIONS(3525),
    [anon_sym___alignof] = ACTIONS(3525),
    [anon_sym__alignof] = ACTIONS(3525),
    [anon_sym_alignof] = ACTIONS(3525),
    [anon_sym__Alignof] = ACTIONS(3525),
    [anon_sym_offsetof] = ACTIONS(3525),
    [anon_sym__Generic] = ACTIONS(3525),
    [anon_sym_asm] = ACTIONS(3525),
    [anon_sym___asm__] = ACTIONS(3525),
    [aux_sym_number_literal_token1] = ACTIONS(3527),
    [aux_sym_number_literal_token2] = ACTIONS(3525),
    [anon_sym_L_SQUOTE] = ACTIONS(3527),
    [anon_sym_u_SQUOTE] = ACTIONS(3527),
    [anon_sym_U_SQUOTE] = ACTIONS(3527),
    [anon_sym_u8_SQUOTE] = ACTIONS(3527),
    [anon_sym_SQUOTE] = ACTIONS(3527),
    [anon_sym_L_DQUOTE] = ACTIONS(3527),
    [anon_sym_u_DQUOTE] = ACTIONS(3527),
    [anon_sym_U_DQUOTE] = ACTIONS(3527),
    [anon_sym_u8_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [sym_true] = ACTIONS(3525),
    [sym_false] = ACTIONS(3525),
    [anon_sym_NULL] = ACTIONS(3525),
    [anon_sym_nullptr] = ACTIONS(3525),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3525),
    [anon_sym_decltype] = ACTIONS(3525),
    [anon_sym_virtual] = ACTIONS(3525),
    [anon_sym_alignas] = ACTIONS(3525),
    [anon_sym_explicit] = ACTIONS(3525),
    [anon_sym_typename] = ACTIONS(3525),
    [anon_sym_template] = ACTIONS(3525),
    [anon_sym_operator] = ACTIONS(3525),
    [anon_sym_try] = ACTIONS(3525),
    [anon_sym_delete] = ACTIONS(3525),
    [anon_sym_throw] = ACTIONS(3525),
    [anon_sym_namespace] = ACTIONS(3525),
    [anon_sym_using] = ACTIONS(3525),
    [anon_sym_static_assert] = ACTIONS(3525),
    [anon_sym_concept] = ACTIONS(3525),
    [anon_sym_co_return] = ACTIONS(3525),
    [anon_sym_co_yield] = ACTIONS(3525),
    [anon_sym_R_DQUOTE] = ACTIONS(3527),
    [anon_sym_LR_DQUOTE] = ACTIONS(3527),
    [anon_sym_uR_DQUOTE] = ACTIONS(3527),
    [anon_sym_UR_DQUOTE] = ACTIONS(3527),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3527),
    [anon_sym_co_await] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3525),
    [anon_sym_requires] = ACTIONS(3525),
    [sym_this] = ACTIONS(3525),
  },
  [963] = {
    [sym_identifier] = ACTIONS(3415),
    [aux_sym_preproc_include_token1] = ACTIONS(3415),
    [aux_sym_preproc_def_token1] = ACTIONS(3415),
    [aux_sym_preproc_if_token1] = ACTIONS(3415),
    [aux_sym_preproc_if_token2] = ACTIONS(3415),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3415),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3415),
    [sym_preproc_directive] = ACTIONS(3415),
    [anon_sym_LPAREN2] = ACTIONS(3417),
    [anon_sym_BANG] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_STAR] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3417),
    [anon_sym___extension__] = ACTIONS(3415),
    [anon_sym_typedef] = ACTIONS(3415),
    [anon_sym_extern] = ACTIONS(3415),
    [anon_sym___attribute__] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3417),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3417),
    [anon_sym___declspec] = ACTIONS(3415),
    [anon_sym___based] = ACTIONS(3415),
    [anon_sym___cdecl] = ACTIONS(3415),
    [anon_sym___clrcall] = ACTIONS(3415),
    [anon_sym___stdcall] = ACTIONS(3415),
    [anon_sym___fastcall] = ACTIONS(3415),
    [anon_sym___thiscall] = ACTIONS(3415),
    [anon_sym___vectorcall] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_signed] = ACTIONS(3415),
    [anon_sym_unsigned] = ACTIONS(3415),
    [anon_sym_long] = ACTIONS(3415),
    [anon_sym_short] = ACTIONS(3415),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_static] = ACTIONS(3415),
    [anon_sym_register] = ACTIONS(3415),
    [anon_sym_inline] = ACTIONS(3415),
    [anon_sym___inline] = ACTIONS(3415),
    [anon_sym___inline__] = ACTIONS(3415),
    [anon_sym___forceinline] = ACTIONS(3415),
    [anon_sym_thread_local] = ACTIONS(3415),
    [anon_sym___thread] = ACTIONS(3415),
    [anon_sym_const] = ACTIONS(3415),
    [anon_sym_constexpr] = ACTIONS(3415),
    [anon_sym_volatile] = ACTIONS(3415),
    [anon_sym_restrict] = ACTIONS(3415),
    [anon_sym___restrict__] = ACTIONS(3415),
    [anon_sym__Atomic] = ACTIONS(3415),
    [anon_sym__Noreturn] = ACTIONS(3415),
    [anon_sym_noreturn] = ACTIONS(3415),
    [anon_sym_mutable] = ACTIONS(3415),
    [anon_sym_constinit] = ACTIONS(3415),
    [anon_sym_consteval] = ACTIONS(3415),
    [anon_sym_PROGMEM] = ACTIONS(3415),
    [aux_sym_primitive_type_token1] = ACTIONS(3415),
    [anon_sym_byte] = ACTIONS(3415),
    [anon_sym_word] = ACTIONS(3415),
    [anon_sym_enum] = ACTIONS(3415),
    [anon_sym_class] = ACTIONS(3415),
    [anon_sym_struct] = ACTIONS(3415),
    [anon_sym_union] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_switch] = ACTIONS(3415),
    [anon_sym_case] = ACTIONS(3415),
    [anon_sym_default] = ACTIONS(3415),
    [anon_sym_while] = ACTIONS(3415),
    [anon_sym_do] = ACTIONS(3415),
    [anon_sym_for] = ACTIONS(3415),
    [anon_sym_return] = ACTIONS(3415),
    [anon_sym_break] = ACTIONS(3415),
    [anon_sym_continue] = ACTIONS(3415),
    [anon_sym_goto] = ACTIONS(3415),
    [anon_sym___try] = ACTIONS(3415),
    [anon_sym___leave] = ACTIONS(3415),
    [anon_sym_not] = ACTIONS(3415),
    [anon_sym_compl] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3415),
    [anon_sym___alignof__] = ACTIONS(3415),
    [anon_sym___alignof] = ACTIONS(3415),
    [anon_sym__alignof] = ACTIONS(3415),
    [anon_sym_alignof] = ACTIONS(3415),
    [anon_sym__Alignof] = ACTIONS(3415),
    [anon_sym_offsetof] = ACTIONS(3415),
    [anon_sym__Generic] = ACTIONS(3415),
    [anon_sym_asm] = ACTIONS(3415),
    [anon_sym___asm__] = ACTIONS(3415),
    [aux_sym_number_literal_token1] = ACTIONS(3417),
    [aux_sym_number_literal_token2] = ACTIONS(3415),
    [anon_sym_L_SQUOTE] = ACTIONS(3417),
    [anon_sym_u_SQUOTE] = ACTIONS(3417),
    [anon_sym_U_SQUOTE] = ACTIONS(3417),
    [anon_sym_u8_SQUOTE] = ACTIONS(3417),
    [anon_sym_SQUOTE] = ACTIONS(3417),
    [anon_sym_L_DQUOTE] = ACTIONS(3417),
    [anon_sym_u_DQUOTE] = ACTIONS(3417),
    [anon_sym_U_DQUOTE] = ACTIONS(3417),
    [anon_sym_u8_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [sym_true] = ACTIONS(3415),
    [sym_false] = ACTIONS(3415),
    [anon_sym_NULL] = ACTIONS(3415),
    [anon_sym_nullptr] = ACTIONS(3415),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3415),
    [anon_sym_decltype] = ACTIONS(3415),
    [anon_sym_virtual] = ACTIONS(3415),
    [anon_sym_alignas] = ACTIONS(3415),
    [anon_sym_explicit] = ACTIONS(3415),
    [anon_sym_typename] = ACTIONS(3415),
    [anon_sym_template] = ACTIONS(3415),
    [anon_sym_operator] = ACTIONS(3415),
    [anon_sym_try] = ACTIONS(3415),
    [anon_sym_delete] = ACTIONS(3415),
    [anon_sym_throw] = ACTIONS(3415),
    [anon_sym_namespace] = ACTIONS(3415),
    [anon_sym_using] = ACTIONS(3415),
    [anon_sym_static_assert] = ACTIONS(3415),
    [anon_sym_concept] = ACTIONS(3415),
    [anon_sym_co_return] = ACTIONS(3415),
    [anon_sym_co_yield] = ACTIONS(3415),
    [anon_sym_R_DQUOTE] = ACTIONS(3417),
    [anon_sym_LR_DQUOTE] = ACTIONS(3417),
    [anon_sym_uR_DQUOTE] = ACTIONS(3417),
    [anon_sym_UR_DQUOTE] = ACTIONS(3417),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3417),
    [anon_sym_co_await] = ACTIONS(3415),
    [anon_sym_new] = ACTIONS(3415),
    [anon_sym_requires] = ACTIONS(3415),
    [sym_this] = ACTIONS(3415),
  },
  [964] = {
    [sym_identifier] = ACTIONS(3411),
    [aux_sym_preproc_include_token1] = ACTIONS(3411),
    [aux_sym_preproc_def_token1] = ACTIONS(3411),
    [aux_sym_preproc_if_token1] = ACTIONS(3411),
    [aux_sym_preproc_if_token2] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3411),
    [sym_preproc_directive] = ACTIONS(3411),
    [anon_sym_LPAREN2] = ACTIONS(3413),
    [anon_sym_BANG] = ACTIONS(3413),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_DASH] = ACTIONS(3411),
    [anon_sym_PLUS] = ACTIONS(3411),
    [anon_sym_STAR] = ACTIONS(3413),
    [anon_sym_AMP_AMP] = ACTIONS(3413),
    [anon_sym_AMP] = ACTIONS(3411),
    [anon_sym_SEMI] = ACTIONS(3413),
    [anon_sym___extension__] = ACTIONS(3411),
    [anon_sym_typedef] = ACTIONS(3411),
    [anon_sym_extern] = ACTIONS(3411),
    [anon_sym___attribute__] = ACTIONS(3411),
    [anon_sym_COLON_COLON] = ACTIONS(3413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3413),
    [anon_sym___declspec] = ACTIONS(3411),
    [anon_sym___based] = ACTIONS(3411),
    [anon_sym___cdecl] = ACTIONS(3411),
    [anon_sym___clrcall] = ACTIONS(3411),
    [anon_sym___stdcall] = ACTIONS(3411),
    [anon_sym___fastcall] = ACTIONS(3411),
    [anon_sym___thiscall] = ACTIONS(3411),
    [anon_sym___vectorcall] = ACTIONS(3411),
    [anon_sym_LBRACE] = ACTIONS(3413),
    [anon_sym_signed] = ACTIONS(3411),
    [anon_sym_unsigned] = ACTIONS(3411),
    [anon_sym_long] = ACTIONS(3411),
    [anon_sym_short] = ACTIONS(3411),
    [anon_sym_LBRACK] = ACTIONS(3411),
    [anon_sym_static] = ACTIONS(3411),
    [anon_sym_register] = ACTIONS(3411),
    [anon_sym_inline] = ACTIONS(3411),
    [anon_sym___inline] = ACTIONS(3411),
    [anon_sym___inline__] = ACTIONS(3411),
    [anon_sym___forceinline] = ACTIONS(3411),
    [anon_sym_thread_local] = ACTIONS(3411),
    [anon_sym___thread] = ACTIONS(3411),
    [anon_sym_const] = ACTIONS(3411),
    [anon_sym_constexpr] = ACTIONS(3411),
    [anon_sym_volatile] = ACTIONS(3411),
    [anon_sym_restrict] = ACTIONS(3411),
    [anon_sym___restrict__] = ACTIONS(3411),
    [anon_sym__Atomic] = ACTIONS(3411),
    [anon_sym__Noreturn] = ACTIONS(3411),
    [anon_sym_noreturn] = ACTIONS(3411),
    [anon_sym_mutable] = ACTIONS(3411),
    [anon_sym_constinit] = ACTIONS(3411),
    [anon_sym_consteval] = ACTIONS(3411),
    [anon_sym_PROGMEM] = ACTIONS(3411),
    [aux_sym_primitive_type_token1] = ACTIONS(3411),
    [anon_sym_byte] = ACTIONS(3411),
    [anon_sym_word] = ACTIONS(3411),
    [anon_sym_enum] = ACTIONS(3411),
    [anon_sym_class] = ACTIONS(3411),
    [anon_sym_struct] = ACTIONS(3411),
    [anon_sym_union] = ACTIONS(3411),
    [anon_sym_if] = ACTIONS(3411),
    [anon_sym_switch] = ACTIONS(3411),
    [anon_sym_case] = ACTIONS(3411),
    [anon_sym_default] = ACTIONS(3411),
    [anon_sym_while] = ACTIONS(3411),
    [anon_sym_do] = ACTIONS(3411),
    [anon_sym_for] = ACTIONS(3411),
    [anon_sym_return] = ACTIONS(3411),
    [anon_sym_break] = ACTIONS(3411),
    [anon_sym_continue] = ACTIONS(3411),
    [anon_sym_goto] = ACTIONS(3411),
    [anon_sym___try] = ACTIONS(3411),
    [anon_sym___leave] = ACTIONS(3411),
    [anon_sym_not] = ACTIONS(3411),
    [anon_sym_compl] = ACTIONS(3411),
    [anon_sym_DASH_DASH] = ACTIONS(3413),
    [anon_sym_PLUS_PLUS] = ACTIONS(3413),
    [anon_sym_sizeof] = ACTIONS(3411),
    [anon_sym___alignof__] = ACTIONS(3411),
    [anon_sym___alignof] = ACTIONS(3411),
    [anon_sym__alignof] = ACTIONS(3411),
    [anon_sym_alignof] = ACTIONS(3411),
    [anon_sym__Alignof] = ACTIONS(3411),
    [anon_sym_offsetof] = ACTIONS(3411),
    [anon_sym__Generic] = ACTIONS(3411),
    [anon_sym_asm] = ACTIONS(3411),
    [anon_sym___asm__] = ACTIONS(3411),
    [aux_sym_number_literal_token1] = ACTIONS(3413),
    [aux_sym_number_literal_token2] = ACTIONS(3411),
    [anon_sym_L_SQUOTE] = ACTIONS(3413),
    [anon_sym_u_SQUOTE] = ACTIONS(3413),
    [anon_sym_U_SQUOTE] = ACTIONS(3413),
    [anon_sym_u8_SQUOTE] = ACTIONS(3413),
    [anon_sym_SQUOTE] = ACTIONS(3413),
    [anon_sym_L_DQUOTE] = ACTIONS(3413),
    [anon_sym_u_DQUOTE] = ACTIONS(3413),
    [anon_sym_U_DQUOTE] = ACTIONS(3413),
    [anon_sym_u8_DQUOTE] = ACTIONS(3413),
    [anon_sym_DQUOTE] = ACTIONS(3413),
    [sym_true] = ACTIONS(3411),
    [sym_false] = ACTIONS(3411),
    [anon_sym_NULL] = ACTIONS(3411),
    [anon_sym_nullptr] = ACTIONS(3411),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3411),
    [anon_sym_decltype] = ACTIONS(3411),
    [anon_sym_virtual] = ACTIONS(3411),
    [anon_sym_alignas] = ACTIONS(3411),
    [anon_sym_explicit] = ACTIONS(3411),
    [anon_sym_typename] = ACTIONS(3411),
    [anon_sym_template] = ACTIONS(3411),
    [anon_sym_operator] = ACTIONS(3411),
    [anon_sym_try] = ACTIONS(3411),
    [anon_sym_delete] = ACTIONS(3411),
    [anon_sym_throw] = ACTIONS(3411),
    [anon_sym_namespace] = ACTIONS(3411),
    [anon_sym_using] = ACTIONS(3411),
    [anon_sym_static_assert] = ACTIONS(3411),
    [anon_sym_concept] = ACTIONS(3411),
    [anon_sym_co_return] = ACTIONS(3411),
    [anon_sym_co_yield] = ACTIONS(3411),
    [anon_sym_R_DQUOTE] = ACTIONS(3413),
    [anon_sym_LR_DQUOTE] = ACTIONS(3413),
    [anon_sym_uR_DQUOTE] = ACTIONS(3413),
    [anon_sym_UR_DQUOTE] = ACTIONS(3413),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3413),
    [anon_sym_co_await] = ACTIONS(3411),
    [anon_sym_new] = ACTIONS(3411),
    [anon_sym_requires] = ACTIONS(3411),
    [sym_this] = ACTIONS(3411),
  },
  [965] = {
    [sym_identifier] = ACTIONS(3499),
    [aux_sym_preproc_include_token1] = ACTIONS(3499),
    [aux_sym_preproc_def_token1] = ACTIONS(3499),
    [aux_sym_preproc_if_token1] = ACTIONS(3499),
    [aux_sym_preproc_if_token2] = ACTIONS(3499),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3499),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3499),
    [sym_preproc_directive] = ACTIONS(3499),
    [anon_sym_LPAREN2] = ACTIONS(3501),
    [anon_sym_BANG] = ACTIONS(3501),
    [anon_sym_TILDE] = ACTIONS(3501),
    [anon_sym_DASH] = ACTIONS(3499),
    [anon_sym_PLUS] = ACTIONS(3499),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_AMP_AMP] = ACTIONS(3501),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_SEMI] = ACTIONS(3501),
    [anon_sym___extension__] = ACTIONS(3499),
    [anon_sym_typedef] = ACTIONS(3499),
    [anon_sym_extern] = ACTIONS(3499),
    [anon_sym___attribute__] = ACTIONS(3499),
    [anon_sym_COLON_COLON] = ACTIONS(3501),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3501),
    [anon_sym___declspec] = ACTIONS(3499),
    [anon_sym___based] = ACTIONS(3499),
    [anon_sym___cdecl] = ACTIONS(3499),
    [anon_sym___clrcall] = ACTIONS(3499),
    [anon_sym___stdcall] = ACTIONS(3499),
    [anon_sym___fastcall] = ACTIONS(3499),
    [anon_sym___thiscall] = ACTIONS(3499),
    [anon_sym___vectorcall] = ACTIONS(3499),
    [anon_sym_LBRACE] = ACTIONS(3501),
    [anon_sym_signed] = ACTIONS(3499),
    [anon_sym_unsigned] = ACTIONS(3499),
    [anon_sym_long] = ACTIONS(3499),
    [anon_sym_short] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(3499),
    [anon_sym_static] = ACTIONS(3499),
    [anon_sym_register] = ACTIONS(3499),
    [anon_sym_inline] = ACTIONS(3499),
    [anon_sym___inline] = ACTIONS(3499),
    [anon_sym___inline__] = ACTIONS(3499),
    [anon_sym___forceinline] = ACTIONS(3499),
    [anon_sym_thread_local] = ACTIONS(3499),
    [anon_sym___thread] = ACTIONS(3499),
    [anon_sym_const] = ACTIONS(3499),
    [anon_sym_constexpr] = ACTIONS(3499),
    [anon_sym_volatile] = ACTIONS(3499),
    [anon_sym_restrict] = ACTIONS(3499),
    [anon_sym___restrict__] = ACTIONS(3499),
    [anon_sym__Atomic] = ACTIONS(3499),
    [anon_sym__Noreturn] = ACTIONS(3499),
    [anon_sym_noreturn] = ACTIONS(3499),
    [anon_sym_mutable] = ACTIONS(3499),
    [anon_sym_constinit] = ACTIONS(3499),
    [anon_sym_consteval] = ACTIONS(3499),
    [anon_sym_PROGMEM] = ACTIONS(3499),
    [aux_sym_primitive_type_token1] = ACTIONS(3499),
    [anon_sym_byte] = ACTIONS(3499),
    [anon_sym_word] = ACTIONS(3499),
    [anon_sym_enum] = ACTIONS(3499),
    [anon_sym_class] = ACTIONS(3499),
    [anon_sym_struct] = ACTIONS(3499),
    [anon_sym_union] = ACTIONS(3499),
    [anon_sym_if] = ACTIONS(3499),
    [anon_sym_switch] = ACTIONS(3499),
    [anon_sym_case] = ACTIONS(3499),
    [anon_sym_default] = ACTIONS(3499),
    [anon_sym_while] = ACTIONS(3499),
    [anon_sym_do] = ACTIONS(3499),
    [anon_sym_for] = ACTIONS(3499),
    [anon_sym_return] = ACTIONS(3499),
    [anon_sym_break] = ACTIONS(3499),
    [anon_sym_continue] = ACTIONS(3499),
    [anon_sym_goto] = ACTIONS(3499),
    [anon_sym___try] = ACTIONS(3499),
    [anon_sym___leave] = ACTIONS(3499),
    [anon_sym_not] = ACTIONS(3499),
    [anon_sym_compl] = ACTIONS(3499),
    [anon_sym_DASH_DASH] = ACTIONS(3501),
    [anon_sym_PLUS_PLUS] = ACTIONS(3501),
    [anon_sym_sizeof] = ACTIONS(3499),
    [anon_sym___alignof__] = ACTIONS(3499),
    [anon_sym___alignof] = ACTIONS(3499),
    [anon_sym__alignof] = ACTIONS(3499),
    [anon_sym_alignof] = ACTIONS(3499),
    [anon_sym__Alignof] = ACTIONS(3499),
    [anon_sym_offsetof] = ACTIONS(3499),
    [anon_sym__Generic] = ACTIONS(3499),
    [anon_sym_asm] = ACTIONS(3499),
    [anon_sym___asm__] = ACTIONS(3499),
    [aux_sym_number_literal_token1] = ACTIONS(3501),
    [aux_sym_number_literal_token2] = ACTIONS(3499),
    [anon_sym_L_SQUOTE] = ACTIONS(3501),
    [anon_sym_u_SQUOTE] = ACTIONS(3501),
    [anon_sym_U_SQUOTE] = ACTIONS(3501),
    [anon_sym_u8_SQUOTE] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3501),
    [anon_sym_L_DQUOTE] = ACTIONS(3501),
    [anon_sym_u_DQUOTE] = ACTIONS(3501),
    [anon_sym_U_DQUOTE] = ACTIONS(3501),
    [anon_sym_u8_DQUOTE] = ACTIONS(3501),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [sym_true] = ACTIONS(3499),
    [sym_false] = ACTIONS(3499),
    [anon_sym_NULL] = ACTIONS(3499),
    [anon_sym_nullptr] = ACTIONS(3499),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3499),
    [anon_sym_decltype] = ACTIONS(3499),
    [anon_sym_virtual] = ACTIONS(3499),
    [anon_sym_alignas] = ACTIONS(3499),
    [anon_sym_explicit] = ACTIONS(3499),
    [anon_sym_typename] = ACTIONS(3499),
    [anon_sym_template] = ACTIONS(3499),
    [anon_sym_operator] = ACTIONS(3499),
    [anon_sym_try] = ACTIONS(3499),
    [anon_sym_delete] = ACTIONS(3499),
    [anon_sym_throw] = ACTIONS(3499),
    [anon_sym_namespace] = ACTIONS(3499),
    [anon_sym_using] = ACTIONS(3499),
    [anon_sym_static_assert] = ACTIONS(3499),
    [anon_sym_concept] = ACTIONS(3499),
    [anon_sym_co_return] = ACTIONS(3499),
    [anon_sym_co_yield] = ACTIONS(3499),
    [anon_sym_R_DQUOTE] = ACTIONS(3501),
    [anon_sym_LR_DQUOTE] = ACTIONS(3501),
    [anon_sym_uR_DQUOTE] = ACTIONS(3501),
    [anon_sym_UR_DQUOTE] = ACTIONS(3501),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3501),
    [anon_sym_co_await] = ACTIONS(3499),
    [anon_sym_new] = ACTIONS(3499),
    [anon_sym_requires] = ACTIONS(3499),
    [sym_this] = ACTIONS(3499),
  },
  [966] = {
    [sym_identifier] = ACTIONS(3411),
    [aux_sym_preproc_include_token1] = ACTIONS(3411),
    [aux_sym_preproc_def_token1] = ACTIONS(3411),
    [aux_sym_preproc_if_token1] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3411),
    [sym_preproc_directive] = ACTIONS(3411),
    [anon_sym_LPAREN2] = ACTIONS(3413),
    [anon_sym_BANG] = ACTIONS(3413),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_DASH] = ACTIONS(3411),
    [anon_sym_PLUS] = ACTIONS(3411),
    [anon_sym_STAR] = ACTIONS(3413),
    [anon_sym_AMP_AMP] = ACTIONS(3413),
    [anon_sym_AMP] = ACTIONS(3411),
    [anon_sym_SEMI] = ACTIONS(3413),
    [anon_sym___extension__] = ACTIONS(3411),
    [anon_sym_typedef] = ACTIONS(3411),
    [anon_sym_extern] = ACTIONS(3411),
    [anon_sym___attribute__] = ACTIONS(3411),
    [anon_sym_COLON_COLON] = ACTIONS(3413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3413),
    [anon_sym___declspec] = ACTIONS(3411),
    [anon_sym___based] = ACTIONS(3411),
    [anon_sym___cdecl] = ACTIONS(3411),
    [anon_sym___clrcall] = ACTIONS(3411),
    [anon_sym___stdcall] = ACTIONS(3411),
    [anon_sym___fastcall] = ACTIONS(3411),
    [anon_sym___thiscall] = ACTIONS(3411),
    [anon_sym___vectorcall] = ACTIONS(3411),
    [anon_sym_LBRACE] = ACTIONS(3413),
    [anon_sym_RBRACE] = ACTIONS(3413),
    [anon_sym_signed] = ACTIONS(3411),
    [anon_sym_unsigned] = ACTIONS(3411),
    [anon_sym_long] = ACTIONS(3411),
    [anon_sym_short] = ACTIONS(3411),
    [anon_sym_LBRACK] = ACTIONS(3411),
    [anon_sym_static] = ACTIONS(3411),
    [anon_sym_register] = ACTIONS(3411),
    [anon_sym_inline] = ACTIONS(3411),
    [anon_sym___inline] = ACTIONS(3411),
    [anon_sym___inline__] = ACTIONS(3411),
    [anon_sym___forceinline] = ACTIONS(3411),
    [anon_sym_thread_local] = ACTIONS(3411),
    [anon_sym___thread] = ACTIONS(3411),
    [anon_sym_const] = ACTIONS(3411),
    [anon_sym_constexpr] = ACTIONS(3411),
    [anon_sym_volatile] = ACTIONS(3411),
    [anon_sym_restrict] = ACTIONS(3411),
    [anon_sym___restrict__] = ACTIONS(3411),
    [anon_sym__Atomic] = ACTIONS(3411),
    [anon_sym__Noreturn] = ACTIONS(3411),
    [anon_sym_noreturn] = ACTIONS(3411),
    [anon_sym_mutable] = ACTIONS(3411),
    [anon_sym_constinit] = ACTIONS(3411),
    [anon_sym_consteval] = ACTIONS(3411),
    [anon_sym_PROGMEM] = ACTIONS(3411),
    [aux_sym_primitive_type_token1] = ACTIONS(3411),
    [anon_sym_byte] = ACTIONS(3411),
    [anon_sym_word] = ACTIONS(3411),
    [anon_sym_enum] = ACTIONS(3411),
    [anon_sym_class] = ACTIONS(3411),
    [anon_sym_struct] = ACTIONS(3411),
    [anon_sym_union] = ACTIONS(3411),
    [anon_sym_if] = ACTIONS(3411),
    [anon_sym_switch] = ACTIONS(3411),
    [anon_sym_case] = ACTIONS(3411),
    [anon_sym_default] = ACTIONS(3411),
    [anon_sym_while] = ACTIONS(3411),
    [anon_sym_do] = ACTIONS(3411),
    [anon_sym_for] = ACTIONS(3411),
    [anon_sym_return] = ACTIONS(3411),
    [anon_sym_break] = ACTIONS(3411),
    [anon_sym_continue] = ACTIONS(3411),
    [anon_sym_goto] = ACTIONS(3411),
    [anon_sym___try] = ACTIONS(3411),
    [anon_sym___leave] = ACTIONS(3411),
    [anon_sym_not] = ACTIONS(3411),
    [anon_sym_compl] = ACTIONS(3411),
    [anon_sym_DASH_DASH] = ACTIONS(3413),
    [anon_sym_PLUS_PLUS] = ACTIONS(3413),
    [anon_sym_sizeof] = ACTIONS(3411),
    [anon_sym___alignof__] = ACTIONS(3411),
    [anon_sym___alignof] = ACTIONS(3411),
    [anon_sym__alignof] = ACTIONS(3411),
    [anon_sym_alignof] = ACTIONS(3411),
    [anon_sym__Alignof] = ACTIONS(3411),
    [anon_sym_offsetof] = ACTIONS(3411),
    [anon_sym__Generic] = ACTIONS(3411),
    [anon_sym_asm] = ACTIONS(3411),
    [anon_sym___asm__] = ACTIONS(3411),
    [aux_sym_number_literal_token1] = ACTIONS(3413),
    [aux_sym_number_literal_token2] = ACTIONS(3411),
    [anon_sym_L_SQUOTE] = ACTIONS(3413),
    [anon_sym_u_SQUOTE] = ACTIONS(3413),
    [anon_sym_U_SQUOTE] = ACTIONS(3413),
    [anon_sym_u8_SQUOTE] = ACTIONS(3413),
    [anon_sym_SQUOTE] = ACTIONS(3413),
    [anon_sym_L_DQUOTE] = ACTIONS(3413),
    [anon_sym_u_DQUOTE] = ACTIONS(3413),
    [anon_sym_U_DQUOTE] = ACTIONS(3413),
    [anon_sym_u8_DQUOTE] = ACTIONS(3413),
    [anon_sym_DQUOTE] = ACTIONS(3413),
    [sym_true] = ACTIONS(3411),
    [sym_false] = ACTIONS(3411),
    [anon_sym_NULL] = ACTIONS(3411),
    [anon_sym_nullptr] = ACTIONS(3411),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3411),
    [anon_sym_decltype] = ACTIONS(3411),
    [anon_sym_virtual] = ACTIONS(3411),
    [anon_sym_alignas] = ACTIONS(3411),
    [anon_sym_explicit] = ACTIONS(3411),
    [anon_sym_typename] = ACTIONS(3411),
    [anon_sym_template] = ACTIONS(3411),
    [anon_sym_operator] = ACTIONS(3411),
    [anon_sym_try] = ACTIONS(3411),
    [anon_sym_delete] = ACTIONS(3411),
    [anon_sym_throw] = ACTIONS(3411),
    [anon_sym_namespace] = ACTIONS(3411),
    [anon_sym_using] = ACTIONS(3411),
    [anon_sym_static_assert] = ACTIONS(3411),
    [anon_sym_concept] = ACTIONS(3411),
    [anon_sym_co_return] = ACTIONS(3411),
    [anon_sym_co_yield] = ACTIONS(3411),
    [anon_sym_R_DQUOTE] = ACTIONS(3413),
    [anon_sym_LR_DQUOTE] = ACTIONS(3413),
    [anon_sym_uR_DQUOTE] = ACTIONS(3413),
    [anon_sym_UR_DQUOTE] = ACTIONS(3413),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3413),
    [anon_sym_co_await] = ACTIONS(3411),
    [anon_sym_new] = ACTIONS(3411),
    [anon_sym_requires] = ACTIONS(3411),
    [sym_this] = ACTIONS(3411),
  },
  [967] = {
    [sym_identifier] = ACTIONS(3415),
    [aux_sym_preproc_include_token1] = ACTIONS(3415),
    [aux_sym_preproc_def_token1] = ACTIONS(3415),
    [aux_sym_preproc_if_token1] = ACTIONS(3415),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3415),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3415),
    [sym_preproc_directive] = ACTIONS(3415),
    [anon_sym_LPAREN2] = ACTIONS(3417),
    [anon_sym_BANG] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_STAR] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3417),
    [anon_sym___extension__] = ACTIONS(3415),
    [anon_sym_typedef] = ACTIONS(3415),
    [anon_sym_extern] = ACTIONS(3415),
    [anon_sym___attribute__] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3417),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3417),
    [anon_sym___declspec] = ACTIONS(3415),
    [anon_sym___based] = ACTIONS(3415),
    [anon_sym___cdecl] = ACTIONS(3415),
    [anon_sym___clrcall] = ACTIONS(3415),
    [anon_sym___stdcall] = ACTIONS(3415),
    [anon_sym___fastcall] = ACTIONS(3415),
    [anon_sym___thiscall] = ACTIONS(3415),
    [anon_sym___vectorcall] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(3417),
    [anon_sym_signed] = ACTIONS(3415),
    [anon_sym_unsigned] = ACTIONS(3415),
    [anon_sym_long] = ACTIONS(3415),
    [anon_sym_short] = ACTIONS(3415),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_static] = ACTIONS(3415),
    [anon_sym_register] = ACTIONS(3415),
    [anon_sym_inline] = ACTIONS(3415),
    [anon_sym___inline] = ACTIONS(3415),
    [anon_sym___inline__] = ACTIONS(3415),
    [anon_sym___forceinline] = ACTIONS(3415),
    [anon_sym_thread_local] = ACTIONS(3415),
    [anon_sym___thread] = ACTIONS(3415),
    [anon_sym_const] = ACTIONS(3415),
    [anon_sym_constexpr] = ACTIONS(3415),
    [anon_sym_volatile] = ACTIONS(3415),
    [anon_sym_restrict] = ACTIONS(3415),
    [anon_sym___restrict__] = ACTIONS(3415),
    [anon_sym__Atomic] = ACTIONS(3415),
    [anon_sym__Noreturn] = ACTIONS(3415),
    [anon_sym_noreturn] = ACTIONS(3415),
    [anon_sym_mutable] = ACTIONS(3415),
    [anon_sym_constinit] = ACTIONS(3415),
    [anon_sym_consteval] = ACTIONS(3415),
    [anon_sym_PROGMEM] = ACTIONS(3415),
    [aux_sym_primitive_type_token1] = ACTIONS(3415),
    [anon_sym_byte] = ACTIONS(3415),
    [anon_sym_word] = ACTIONS(3415),
    [anon_sym_enum] = ACTIONS(3415),
    [anon_sym_class] = ACTIONS(3415),
    [anon_sym_struct] = ACTIONS(3415),
    [anon_sym_union] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_switch] = ACTIONS(3415),
    [anon_sym_case] = ACTIONS(3415),
    [anon_sym_default] = ACTIONS(3415),
    [anon_sym_while] = ACTIONS(3415),
    [anon_sym_do] = ACTIONS(3415),
    [anon_sym_for] = ACTIONS(3415),
    [anon_sym_return] = ACTIONS(3415),
    [anon_sym_break] = ACTIONS(3415),
    [anon_sym_continue] = ACTIONS(3415),
    [anon_sym_goto] = ACTIONS(3415),
    [anon_sym___try] = ACTIONS(3415),
    [anon_sym___leave] = ACTIONS(3415),
    [anon_sym_not] = ACTIONS(3415),
    [anon_sym_compl] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3415),
    [anon_sym___alignof__] = ACTIONS(3415),
    [anon_sym___alignof] = ACTIONS(3415),
    [anon_sym__alignof] = ACTIONS(3415),
    [anon_sym_alignof] = ACTIONS(3415),
    [anon_sym__Alignof] = ACTIONS(3415),
    [anon_sym_offsetof] = ACTIONS(3415),
    [anon_sym__Generic] = ACTIONS(3415),
    [anon_sym_asm] = ACTIONS(3415),
    [anon_sym___asm__] = ACTIONS(3415),
    [aux_sym_number_literal_token1] = ACTIONS(3417),
    [aux_sym_number_literal_token2] = ACTIONS(3415),
    [anon_sym_L_SQUOTE] = ACTIONS(3417),
    [anon_sym_u_SQUOTE] = ACTIONS(3417),
    [anon_sym_U_SQUOTE] = ACTIONS(3417),
    [anon_sym_u8_SQUOTE] = ACTIONS(3417),
    [anon_sym_SQUOTE] = ACTIONS(3417),
    [anon_sym_L_DQUOTE] = ACTIONS(3417),
    [anon_sym_u_DQUOTE] = ACTIONS(3417),
    [anon_sym_U_DQUOTE] = ACTIONS(3417),
    [anon_sym_u8_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [sym_true] = ACTIONS(3415),
    [sym_false] = ACTIONS(3415),
    [anon_sym_NULL] = ACTIONS(3415),
    [anon_sym_nullptr] = ACTIONS(3415),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3415),
    [anon_sym_decltype] = ACTIONS(3415),
    [anon_sym_virtual] = ACTIONS(3415),
    [anon_sym_alignas] = ACTIONS(3415),
    [anon_sym_explicit] = ACTIONS(3415),
    [anon_sym_typename] = ACTIONS(3415),
    [anon_sym_template] = ACTIONS(3415),
    [anon_sym_operator] = ACTIONS(3415),
    [anon_sym_try] = ACTIONS(3415),
    [anon_sym_delete] = ACTIONS(3415),
    [anon_sym_throw] = ACTIONS(3415),
    [anon_sym_namespace] = ACTIONS(3415),
    [anon_sym_using] = ACTIONS(3415),
    [anon_sym_static_assert] = ACTIONS(3415),
    [anon_sym_concept] = ACTIONS(3415),
    [anon_sym_co_return] = ACTIONS(3415),
    [anon_sym_co_yield] = ACTIONS(3415),
    [anon_sym_R_DQUOTE] = ACTIONS(3417),
    [anon_sym_LR_DQUOTE] = ACTIONS(3417),
    [anon_sym_uR_DQUOTE] = ACTIONS(3417),
    [anon_sym_UR_DQUOTE] = ACTIONS(3417),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3417),
    [anon_sym_co_await] = ACTIONS(3415),
    [anon_sym_new] = ACTIONS(3415),
    [anon_sym_requires] = ACTIONS(3415),
    [sym_this] = ACTIONS(3415),
  },
  [968] = {
    [sym_identifier] = ACTIONS(3521),
    [aux_sym_preproc_include_token1] = ACTIONS(3521),
    [aux_sym_preproc_def_token1] = ACTIONS(3521),
    [aux_sym_preproc_if_token1] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3521),
    [sym_preproc_directive] = ACTIONS(3521),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_BANG] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3521),
    [anon_sym_PLUS] = ACTIONS(3521),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3521),
    [anon_sym_SEMI] = ACTIONS(3523),
    [anon_sym___extension__] = ACTIONS(3521),
    [anon_sym_typedef] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym___attribute__] = ACTIONS(3521),
    [anon_sym_COLON_COLON] = ACTIONS(3523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3523),
    [anon_sym___declspec] = ACTIONS(3521),
    [anon_sym___based] = ACTIONS(3521),
    [anon_sym___cdecl] = ACTIONS(3521),
    [anon_sym___clrcall] = ACTIONS(3521),
    [anon_sym___stdcall] = ACTIONS(3521),
    [anon_sym___fastcall] = ACTIONS(3521),
    [anon_sym___thiscall] = ACTIONS(3521),
    [anon_sym___vectorcall] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_RBRACE] = ACTIONS(3523),
    [anon_sym_signed] = ACTIONS(3521),
    [anon_sym_unsigned] = ACTIONS(3521),
    [anon_sym_long] = ACTIONS(3521),
    [anon_sym_short] = ACTIONS(3521),
    [anon_sym_LBRACK] = ACTIONS(3521),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_register] = ACTIONS(3521),
    [anon_sym_inline] = ACTIONS(3521),
    [anon_sym___inline] = ACTIONS(3521),
    [anon_sym___inline__] = ACTIONS(3521),
    [anon_sym___forceinline] = ACTIONS(3521),
    [anon_sym_thread_local] = ACTIONS(3521),
    [anon_sym___thread] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_constexpr] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym_restrict] = ACTIONS(3521),
    [anon_sym___restrict__] = ACTIONS(3521),
    [anon_sym__Atomic] = ACTIONS(3521),
    [anon_sym__Noreturn] = ACTIONS(3521),
    [anon_sym_noreturn] = ACTIONS(3521),
    [anon_sym_mutable] = ACTIONS(3521),
    [anon_sym_constinit] = ACTIONS(3521),
    [anon_sym_consteval] = ACTIONS(3521),
    [anon_sym_PROGMEM] = ACTIONS(3521),
    [aux_sym_primitive_type_token1] = ACTIONS(3521),
    [anon_sym_byte] = ACTIONS(3521),
    [anon_sym_word] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_class] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_union] = ACTIONS(3521),
    [anon_sym_if] = ACTIONS(3521),
    [anon_sym_switch] = ACTIONS(3521),
    [anon_sym_case] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3521),
    [anon_sym_while] = ACTIONS(3521),
    [anon_sym_do] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3521),
    [anon_sym_return] = ACTIONS(3521),
    [anon_sym_break] = ACTIONS(3521),
    [anon_sym_continue] = ACTIONS(3521),
    [anon_sym_goto] = ACTIONS(3521),
    [anon_sym___try] = ACTIONS(3521),
    [anon_sym___leave] = ACTIONS(3521),
    [anon_sym_not] = ACTIONS(3521),
    [anon_sym_compl] = ACTIONS(3521),
    [anon_sym_DASH_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_PLUS] = ACTIONS(3523),
    [anon_sym_sizeof] = ACTIONS(3521),
    [anon_sym___alignof__] = ACTIONS(3521),
    [anon_sym___alignof] = ACTIONS(3521),
    [anon_sym__alignof] = ACTIONS(3521),
    [anon_sym_alignof] = ACTIONS(3521),
    [anon_sym__Alignof] = ACTIONS(3521),
    [anon_sym_offsetof] = ACTIONS(3521),
    [anon_sym__Generic] = ACTIONS(3521),
    [anon_sym_asm] = ACTIONS(3521),
    [anon_sym___asm__] = ACTIONS(3521),
    [aux_sym_number_literal_token1] = ACTIONS(3523),
    [aux_sym_number_literal_token2] = ACTIONS(3521),
    [anon_sym_L_SQUOTE] = ACTIONS(3523),
    [anon_sym_u_SQUOTE] = ACTIONS(3523),
    [anon_sym_U_SQUOTE] = ACTIONS(3523),
    [anon_sym_u8_SQUOTE] = ACTIONS(3523),
    [anon_sym_SQUOTE] = ACTIONS(3523),
    [anon_sym_L_DQUOTE] = ACTIONS(3523),
    [anon_sym_u_DQUOTE] = ACTIONS(3523),
    [anon_sym_U_DQUOTE] = ACTIONS(3523),
    [anon_sym_u8_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [sym_true] = ACTIONS(3521),
    [sym_false] = ACTIONS(3521),
    [anon_sym_NULL] = ACTIONS(3521),
    [anon_sym_nullptr] = ACTIONS(3521),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3521),
    [anon_sym_decltype] = ACTIONS(3521),
    [anon_sym_virtual] = ACTIONS(3521),
    [anon_sym_alignas] = ACTIONS(3521),
    [anon_sym_explicit] = ACTIONS(3521),
    [anon_sym_typename] = ACTIONS(3521),
    [anon_sym_template] = ACTIONS(3521),
    [anon_sym_operator] = ACTIONS(3521),
    [anon_sym_try] = ACTIONS(3521),
    [anon_sym_delete] = ACTIONS(3521),
    [anon_sym_throw] = ACTIONS(3521),
    [anon_sym_namespace] = ACTIONS(3521),
    [anon_sym_using] = ACTIONS(3521),
    [anon_sym_static_assert] = ACTIONS(3521),
    [anon_sym_concept] = ACTIONS(3521),
    [anon_sym_co_return] = ACTIONS(3521),
    [anon_sym_co_yield] = ACTIONS(3521),
    [anon_sym_R_DQUOTE] = ACTIONS(3523),
    [anon_sym_LR_DQUOTE] = ACTIONS(3523),
    [anon_sym_uR_DQUOTE] = ACTIONS(3523),
    [anon_sym_UR_DQUOTE] = ACTIONS(3523),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3523),
    [anon_sym_co_await] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3521),
    [anon_sym_requires] = ACTIONS(3521),
    [sym_this] = ACTIONS(3521),
  },
  [969] = {
    [sym_identifier] = ACTIONS(3403),
    [aux_sym_preproc_include_token1] = ACTIONS(3403),
    [aux_sym_preproc_def_token1] = ACTIONS(3403),
    [aux_sym_preproc_if_token1] = ACTIONS(3403),
    [aux_sym_preproc_if_token2] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3403),
    [sym_preproc_directive] = ACTIONS(3403),
    [anon_sym_LPAREN2] = ACTIONS(3405),
    [anon_sym_BANG] = ACTIONS(3405),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_DASH] = ACTIONS(3403),
    [anon_sym_PLUS] = ACTIONS(3403),
    [anon_sym_STAR] = ACTIONS(3405),
    [anon_sym_AMP_AMP] = ACTIONS(3405),
    [anon_sym_AMP] = ACTIONS(3403),
    [anon_sym_SEMI] = ACTIONS(3405),
    [anon_sym___extension__] = ACTIONS(3403),
    [anon_sym_typedef] = ACTIONS(3403),
    [anon_sym_extern] = ACTIONS(3403),
    [anon_sym___attribute__] = ACTIONS(3403),
    [anon_sym_COLON_COLON] = ACTIONS(3405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3405),
    [anon_sym___declspec] = ACTIONS(3403),
    [anon_sym___based] = ACTIONS(3403),
    [anon_sym___cdecl] = ACTIONS(3403),
    [anon_sym___clrcall] = ACTIONS(3403),
    [anon_sym___stdcall] = ACTIONS(3403),
    [anon_sym___fastcall] = ACTIONS(3403),
    [anon_sym___thiscall] = ACTIONS(3403),
    [anon_sym___vectorcall] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3405),
    [anon_sym_signed] = ACTIONS(3403),
    [anon_sym_unsigned] = ACTIONS(3403),
    [anon_sym_long] = ACTIONS(3403),
    [anon_sym_short] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3403),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_register] = ACTIONS(3403),
    [anon_sym_inline] = ACTIONS(3403),
    [anon_sym___inline] = ACTIONS(3403),
    [anon_sym___inline__] = ACTIONS(3403),
    [anon_sym___forceinline] = ACTIONS(3403),
    [anon_sym_thread_local] = ACTIONS(3403),
    [anon_sym___thread] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_constexpr] = ACTIONS(3403),
    [anon_sym_volatile] = ACTIONS(3403),
    [anon_sym_restrict] = ACTIONS(3403),
    [anon_sym___restrict__] = ACTIONS(3403),
    [anon_sym__Atomic] = ACTIONS(3403),
    [anon_sym__Noreturn] = ACTIONS(3403),
    [anon_sym_noreturn] = ACTIONS(3403),
    [anon_sym_mutable] = ACTIONS(3403),
    [anon_sym_constinit] = ACTIONS(3403),
    [anon_sym_consteval] = ACTIONS(3403),
    [anon_sym_PROGMEM] = ACTIONS(3403),
    [aux_sym_primitive_type_token1] = ACTIONS(3403),
    [anon_sym_byte] = ACTIONS(3403),
    [anon_sym_word] = ACTIONS(3403),
    [anon_sym_enum] = ACTIONS(3403),
    [anon_sym_class] = ACTIONS(3403),
    [anon_sym_struct] = ACTIONS(3403),
    [anon_sym_union] = ACTIONS(3403),
    [anon_sym_if] = ACTIONS(3403),
    [anon_sym_switch] = ACTIONS(3403),
    [anon_sym_case] = ACTIONS(3403),
    [anon_sym_default] = ACTIONS(3403),
    [anon_sym_while] = ACTIONS(3403),
    [anon_sym_do] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3403),
    [anon_sym_return] = ACTIONS(3403),
    [anon_sym_break] = ACTIONS(3403),
    [anon_sym_continue] = ACTIONS(3403),
    [anon_sym_goto] = ACTIONS(3403),
    [anon_sym___try] = ACTIONS(3403),
    [anon_sym___leave] = ACTIONS(3403),
    [anon_sym_not] = ACTIONS(3403),
    [anon_sym_compl] = ACTIONS(3403),
    [anon_sym_DASH_DASH] = ACTIONS(3405),
    [anon_sym_PLUS_PLUS] = ACTIONS(3405),
    [anon_sym_sizeof] = ACTIONS(3403),
    [anon_sym___alignof__] = ACTIONS(3403),
    [anon_sym___alignof] = ACTIONS(3403),
    [anon_sym__alignof] = ACTIONS(3403),
    [anon_sym_alignof] = ACTIONS(3403),
    [anon_sym__Alignof] = ACTIONS(3403),
    [anon_sym_offsetof] = ACTIONS(3403),
    [anon_sym__Generic] = ACTIONS(3403),
    [anon_sym_asm] = ACTIONS(3403),
    [anon_sym___asm__] = ACTIONS(3403),
    [aux_sym_number_literal_token1] = ACTIONS(3405),
    [aux_sym_number_literal_token2] = ACTIONS(3403),
    [anon_sym_L_SQUOTE] = ACTIONS(3405),
    [anon_sym_u_SQUOTE] = ACTIONS(3405),
    [anon_sym_U_SQUOTE] = ACTIONS(3405),
    [anon_sym_u8_SQUOTE] = ACTIONS(3405),
    [anon_sym_SQUOTE] = ACTIONS(3405),
    [anon_sym_L_DQUOTE] = ACTIONS(3405),
    [anon_sym_u_DQUOTE] = ACTIONS(3405),
    [anon_sym_U_DQUOTE] = ACTIONS(3405),
    [anon_sym_u8_DQUOTE] = ACTIONS(3405),
    [anon_sym_DQUOTE] = ACTIONS(3405),
    [sym_true] = ACTIONS(3403),
    [sym_false] = ACTIONS(3403),
    [anon_sym_NULL] = ACTIONS(3403),
    [anon_sym_nullptr] = ACTIONS(3403),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3403),
    [anon_sym_decltype] = ACTIONS(3403),
    [anon_sym_virtual] = ACTIONS(3403),
    [anon_sym_alignas] = ACTIONS(3403),
    [anon_sym_explicit] = ACTIONS(3403),
    [anon_sym_typename] = ACTIONS(3403),
    [anon_sym_template] = ACTIONS(3403),
    [anon_sym_operator] = ACTIONS(3403),
    [anon_sym_try] = ACTIONS(3403),
    [anon_sym_delete] = ACTIONS(3403),
    [anon_sym_throw] = ACTIONS(3403),
    [anon_sym_namespace] = ACTIONS(3403),
    [anon_sym_using] = ACTIONS(3403),
    [anon_sym_static_assert] = ACTIONS(3403),
    [anon_sym_concept] = ACTIONS(3403),
    [anon_sym_co_return] = ACTIONS(3403),
    [anon_sym_co_yield] = ACTIONS(3403),
    [anon_sym_R_DQUOTE] = ACTIONS(3405),
    [anon_sym_LR_DQUOTE] = ACTIONS(3405),
    [anon_sym_uR_DQUOTE] = ACTIONS(3405),
    [anon_sym_UR_DQUOTE] = ACTIONS(3405),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3405),
    [anon_sym_co_await] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3403),
    [anon_sym_requires] = ACTIONS(3403),
    [sym_this] = ACTIONS(3403),
  },
  [970] = {
    [sym_identifier] = ACTIONS(3517),
    [aux_sym_preproc_include_token1] = ACTIONS(3517),
    [aux_sym_preproc_def_token1] = ACTIONS(3517),
    [aux_sym_preproc_if_token1] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3517),
    [sym_preproc_directive] = ACTIONS(3517),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_BANG] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3517),
    [anon_sym_PLUS] = ACTIONS(3517),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_SEMI] = ACTIONS(3519),
    [anon_sym___extension__] = ACTIONS(3517),
    [anon_sym_typedef] = ACTIONS(3517),
    [anon_sym_extern] = ACTIONS(3517),
    [anon_sym___attribute__] = ACTIONS(3517),
    [anon_sym_COLON_COLON] = ACTIONS(3519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3519),
    [anon_sym___declspec] = ACTIONS(3517),
    [anon_sym___based] = ACTIONS(3517),
    [anon_sym___cdecl] = ACTIONS(3517),
    [anon_sym___clrcall] = ACTIONS(3517),
    [anon_sym___stdcall] = ACTIONS(3517),
    [anon_sym___fastcall] = ACTIONS(3517),
    [anon_sym___thiscall] = ACTIONS(3517),
    [anon_sym___vectorcall] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_RBRACE] = ACTIONS(3519),
    [anon_sym_signed] = ACTIONS(3517),
    [anon_sym_unsigned] = ACTIONS(3517),
    [anon_sym_long] = ACTIONS(3517),
    [anon_sym_short] = ACTIONS(3517),
    [anon_sym_LBRACK] = ACTIONS(3517),
    [anon_sym_static] = ACTIONS(3517),
    [anon_sym_register] = ACTIONS(3517),
    [anon_sym_inline] = ACTIONS(3517),
    [anon_sym___inline] = ACTIONS(3517),
    [anon_sym___inline__] = ACTIONS(3517),
    [anon_sym___forceinline] = ACTIONS(3517),
    [anon_sym_thread_local] = ACTIONS(3517),
    [anon_sym___thread] = ACTIONS(3517),
    [anon_sym_const] = ACTIONS(3517),
    [anon_sym_constexpr] = ACTIONS(3517),
    [anon_sym_volatile] = ACTIONS(3517),
    [anon_sym_restrict] = ACTIONS(3517),
    [anon_sym___restrict__] = ACTIONS(3517),
    [anon_sym__Atomic] = ACTIONS(3517),
    [anon_sym__Noreturn] = ACTIONS(3517),
    [anon_sym_noreturn] = ACTIONS(3517),
    [anon_sym_mutable] = ACTIONS(3517),
    [anon_sym_constinit] = ACTIONS(3517),
    [anon_sym_consteval] = ACTIONS(3517),
    [anon_sym_PROGMEM] = ACTIONS(3517),
    [aux_sym_primitive_type_token1] = ACTIONS(3517),
    [anon_sym_byte] = ACTIONS(3517),
    [anon_sym_word] = ACTIONS(3517),
    [anon_sym_enum] = ACTIONS(3517),
    [anon_sym_class] = ACTIONS(3517),
    [anon_sym_struct] = ACTIONS(3517),
    [anon_sym_union] = ACTIONS(3517),
    [anon_sym_if] = ACTIONS(3517),
    [anon_sym_switch] = ACTIONS(3517),
    [anon_sym_case] = ACTIONS(3517),
    [anon_sym_default] = ACTIONS(3517),
    [anon_sym_while] = ACTIONS(3517),
    [anon_sym_do] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3517),
    [anon_sym_return] = ACTIONS(3517),
    [anon_sym_break] = ACTIONS(3517),
    [anon_sym_continue] = ACTIONS(3517),
    [anon_sym_goto] = ACTIONS(3517),
    [anon_sym___try] = ACTIONS(3517),
    [anon_sym___leave] = ACTIONS(3517),
    [anon_sym_not] = ACTIONS(3517),
    [anon_sym_compl] = ACTIONS(3517),
    [anon_sym_DASH_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_PLUS] = ACTIONS(3519),
    [anon_sym_sizeof] = ACTIONS(3517),
    [anon_sym___alignof__] = ACTIONS(3517),
    [anon_sym___alignof] = ACTIONS(3517),
    [anon_sym__alignof] = ACTIONS(3517),
    [anon_sym_alignof] = ACTIONS(3517),
    [anon_sym__Alignof] = ACTIONS(3517),
    [anon_sym_offsetof] = ACTIONS(3517),
    [anon_sym__Generic] = ACTIONS(3517),
    [anon_sym_asm] = ACTIONS(3517),
    [anon_sym___asm__] = ACTIONS(3517),
    [aux_sym_number_literal_token1] = ACTIONS(3519),
    [aux_sym_number_literal_token2] = ACTIONS(3517),
    [anon_sym_L_SQUOTE] = ACTIONS(3519),
    [anon_sym_u_SQUOTE] = ACTIONS(3519),
    [anon_sym_U_SQUOTE] = ACTIONS(3519),
    [anon_sym_u8_SQUOTE] = ACTIONS(3519),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_L_DQUOTE] = ACTIONS(3519),
    [anon_sym_u_DQUOTE] = ACTIONS(3519),
    [anon_sym_U_DQUOTE] = ACTIONS(3519),
    [anon_sym_u8_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [sym_true] = ACTIONS(3517),
    [sym_false] = ACTIONS(3517),
    [anon_sym_NULL] = ACTIONS(3517),
    [anon_sym_nullptr] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3517),
    [anon_sym_decltype] = ACTIONS(3517),
    [anon_sym_virtual] = ACTIONS(3517),
    [anon_sym_alignas] = ACTIONS(3517),
    [anon_sym_explicit] = ACTIONS(3517),
    [anon_sym_typename] = ACTIONS(3517),
    [anon_sym_template] = ACTIONS(3517),
    [anon_sym_operator] = ACTIONS(3517),
    [anon_sym_try] = ACTIONS(3517),
    [anon_sym_delete] = ACTIONS(3517),
    [anon_sym_throw] = ACTIONS(3517),
    [anon_sym_namespace] = ACTIONS(3517),
    [anon_sym_using] = ACTIONS(3517),
    [anon_sym_static_assert] = ACTIONS(3517),
    [anon_sym_concept] = ACTIONS(3517),
    [anon_sym_co_return] = ACTIONS(3517),
    [anon_sym_co_yield] = ACTIONS(3517),
    [anon_sym_R_DQUOTE] = ACTIONS(3519),
    [anon_sym_LR_DQUOTE] = ACTIONS(3519),
    [anon_sym_uR_DQUOTE] = ACTIONS(3519),
    [anon_sym_UR_DQUOTE] = ACTIONS(3519),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3519),
    [anon_sym_co_await] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3517),
    [anon_sym_requires] = ACTIONS(3517),
    [sym_this] = ACTIONS(3517),
  },
  [971] = {
    [sym_identifier] = ACTIONS(3387),
    [aux_sym_preproc_include_token1] = ACTIONS(3387),
    [aux_sym_preproc_def_token1] = ACTIONS(3387),
    [aux_sym_preproc_if_token1] = ACTIONS(3387),
    [aux_sym_preproc_if_token2] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3387),
    [sym_preproc_directive] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_BANG] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_STAR] = ACTIONS(3389),
    [anon_sym_AMP_AMP] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_SEMI] = ACTIONS(3389),
    [anon_sym___extension__] = ACTIONS(3387),
    [anon_sym_typedef] = ACTIONS(3387),
    [anon_sym_extern] = ACTIONS(3387),
    [anon_sym___attribute__] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3389),
    [anon_sym___declspec] = ACTIONS(3387),
    [anon_sym___based] = ACTIONS(3387),
    [anon_sym___cdecl] = ACTIONS(3387),
    [anon_sym___clrcall] = ACTIONS(3387),
    [anon_sym___stdcall] = ACTIONS(3387),
    [anon_sym___fastcall] = ACTIONS(3387),
    [anon_sym___thiscall] = ACTIONS(3387),
    [anon_sym___vectorcall] = ACTIONS(3387),
    [anon_sym_LBRACE] = ACTIONS(3389),
    [anon_sym_signed] = ACTIONS(3387),
    [anon_sym_unsigned] = ACTIONS(3387),
    [anon_sym_long] = ACTIONS(3387),
    [anon_sym_short] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_register] = ACTIONS(3387),
    [anon_sym_inline] = ACTIONS(3387),
    [anon_sym___inline] = ACTIONS(3387),
    [anon_sym___inline__] = ACTIONS(3387),
    [anon_sym___forceinline] = ACTIONS(3387),
    [anon_sym_thread_local] = ACTIONS(3387),
    [anon_sym___thread] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_constexpr] = ACTIONS(3387),
    [anon_sym_volatile] = ACTIONS(3387),
    [anon_sym_restrict] = ACTIONS(3387),
    [anon_sym___restrict__] = ACTIONS(3387),
    [anon_sym__Atomic] = ACTIONS(3387),
    [anon_sym__Noreturn] = ACTIONS(3387),
    [anon_sym_noreturn] = ACTIONS(3387),
    [anon_sym_mutable] = ACTIONS(3387),
    [anon_sym_constinit] = ACTIONS(3387),
    [anon_sym_consteval] = ACTIONS(3387),
    [anon_sym_PROGMEM] = ACTIONS(3387),
    [aux_sym_primitive_type_token1] = ACTIONS(3387),
    [anon_sym_byte] = ACTIONS(3387),
    [anon_sym_word] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [anon_sym_class] = ACTIONS(3387),
    [anon_sym_struct] = ACTIONS(3387),
    [anon_sym_union] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_switch] = ACTIONS(3387),
    [anon_sym_case] = ACTIONS(3387),
    [anon_sym_default] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_break] = ACTIONS(3387),
    [anon_sym_continue] = ACTIONS(3387),
    [anon_sym_goto] = ACTIONS(3387),
    [anon_sym___try] = ACTIONS(3387),
    [anon_sym___leave] = ACTIONS(3387),
    [anon_sym_not] = ACTIONS(3387),
    [anon_sym_compl] = ACTIONS(3387),
    [anon_sym_DASH_DASH] = ACTIONS(3389),
    [anon_sym_PLUS_PLUS] = ACTIONS(3389),
    [anon_sym_sizeof] = ACTIONS(3387),
    [anon_sym___alignof__] = ACTIONS(3387),
    [anon_sym___alignof] = ACTIONS(3387),
    [anon_sym__alignof] = ACTIONS(3387),
    [anon_sym_alignof] = ACTIONS(3387),
    [anon_sym__Alignof] = ACTIONS(3387),
    [anon_sym_offsetof] = ACTIONS(3387),
    [anon_sym__Generic] = ACTIONS(3387),
    [anon_sym_asm] = ACTIONS(3387),
    [anon_sym___asm__] = ACTIONS(3387),
    [aux_sym_number_literal_token1] = ACTIONS(3389),
    [aux_sym_number_literal_token2] = ACTIONS(3387),
    [anon_sym_L_SQUOTE] = ACTIONS(3389),
    [anon_sym_u_SQUOTE] = ACTIONS(3389),
    [anon_sym_U_SQUOTE] = ACTIONS(3389),
    [anon_sym_u8_SQUOTE] = ACTIONS(3389),
    [anon_sym_SQUOTE] = ACTIONS(3389),
    [anon_sym_L_DQUOTE] = ACTIONS(3389),
    [anon_sym_u_DQUOTE] = ACTIONS(3389),
    [anon_sym_U_DQUOTE] = ACTIONS(3389),
    [anon_sym_u8_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE] = ACTIONS(3389),
    [sym_true] = ACTIONS(3387),
    [sym_false] = ACTIONS(3387),
    [anon_sym_NULL] = ACTIONS(3387),
    [anon_sym_nullptr] = ACTIONS(3387),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3387),
    [anon_sym_decltype] = ACTIONS(3387),
    [anon_sym_virtual] = ACTIONS(3387),
    [anon_sym_alignas] = ACTIONS(3387),
    [anon_sym_explicit] = ACTIONS(3387),
    [anon_sym_typename] = ACTIONS(3387),
    [anon_sym_template] = ACTIONS(3387),
    [anon_sym_operator] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_delete] = ACTIONS(3387),
    [anon_sym_throw] = ACTIONS(3387),
    [anon_sym_namespace] = ACTIONS(3387),
    [anon_sym_using] = ACTIONS(3387),
    [anon_sym_static_assert] = ACTIONS(3387),
    [anon_sym_concept] = ACTIONS(3387),
    [anon_sym_co_return] = ACTIONS(3387),
    [anon_sym_co_yield] = ACTIONS(3387),
    [anon_sym_R_DQUOTE] = ACTIONS(3389),
    [anon_sym_LR_DQUOTE] = ACTIONS(3389),
    [anon_sym_uR_DQUOTE] = ACTIONS(3389),
    [anon_sym_UR_DQUOTE] = ACTIONS(3389),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3389),
    [anon_sym_co_await] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_requires] = ACTIONS(3387),
    [sym_this] = ACTIONS(3387),
  },
  [972] = {
    [sym_identifier] = ACTIONS(3419),
    [aux_sym_preproc_include_token1] = ACTIONS(3419),
    [aux_sym_preproc_def_token1] = ACTIONS(3419),
    [aux_sym_preproc_if_token1] = ACTIONS(3419),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3419),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3419),
    [sym_preproc_directive] = ACTIONS(3419),
    [anon_sym_LPAREN2] = ACTIONS(3421),
    [anon_sym_BANG] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_SEMI] = ACTIONS(3421),
    [anon_sym___extension__] = ACTIONS(3419),
    [anon_sym_typedef] = ACTIONS(3419),
    [anon_sym_extern] = ACTIONS(3419),
    [anon_sym___attribute__] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3421),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3421),
    [anon_sym___declspec] = ACTIONS(3419),
    [anon_sym___based] = ACTIONS(3419),
    [anon_sym___cdecl] = ACTIONS(3419),
    [anon_sym___clrcall] = ACTIONS(3419),
    [anon_sym___stdcall] = ACTIONS(3419),
    [anon_sym___fastcall] = ACTIONS(3419),
    [anon_sym___thiscall] = ACTIONS(3419),
    [anon_sym___vectorcall] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_RBRACE] = ACTIONS(3421),
    [anon_sym_signed] = ACTIONS(3419),
    [anon_sym_unsigned] = ACTIONS(3419),
    [anon_sym_long] = ACTIONS(3419),
    [anon_sym_short] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_register] = ACTIONS(3419),
    [anon_sym_inline] = ACTIONS(3419),
    [anon_sym___inline] = ACTIONS(3419),
    [anon_sym___inline__] = ACTIONS(3419),
    [anon_sym___forceinline] = ACTIONS(3419),
    [anon_sym_thread_local] = ACTIONS(3419),
    [anon_sym___thread] = ACTIONS(3419),
    [anon_sym_const] = ACTIONS(3419),
    [anon_sym_constexpr] = ACTIONS(3419),
    [anon_sym_volatile] = ACTIONS(3419),
    [anon_sym_restrict] = ACTIONS(3419),
    [anon_sym___restrict__] = ACTIONS(3419),
    [anon_sym__Atomic] = ACTIONS(3419),
    [anon_sym__Noreturn] = ACTIONS(3419),
    [anon_sym_noreturn] = ACTIONS(3419),
    [anon_sym_mutable] = ACTIONS(3419),
    [anon_sym_constinit] = ACTIONS(3419),
    [anon_sym_consteval] = ACTIONS(3419),
    [anon_sym_PROGMEM] = ACTIONS(3419),
    [aux_sym_primitive_type_token1] = ACTIONS(3419),
    [anon_sym_byte] = ACTIONS(3419),
    [anon_sym_word] = ACTIONS(3419),
    [anon_sym_enum] = ACTIONS(3419),
    [anon_sym_class] = ACTIONS(3419),
    [anon_sym_struct] = ACTIONS(3419),
    [anon_sym_union] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_switch] = ACTIONS(3419),
    [anon_sym_case] = ACTIONS(3419),
    [anon_sym_default] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_break] = ACTIONS(3419),
    [anon_sym_continue] = ACTIONS(3419),
    [anon_sym_goto] = ACTIONS(3419),
    [anon_sym___try] = ACTIONS(3419),
    [anon_sym___leave] = ACTIONS(3419),
    [anon_sym_not] = ACTIONS(3419),
    [anon_sym_compl] = ACTIONS(3419),
    [anon_sym_DASH_DASH] = ACTIONS(3421),
    [anon_sym_PLUS_PLUS] = ACTIONS(3421),
    [anon_sym_sizeof] = ACTIONS(3419),
    [anon_sym___alignof__] = ACTIONS(3419),
    [anon_sym___alignof] = ACTIONS(3419),
    [anon_sym__alignof] = ACTIONS(3419),
    [anon_sym_alignof] = ACTIONS(3419),
    [anon_sym__Alignof] = ACTIONS(3419),
    [anon_sym_offsetof] = ACTIONS(3419),
    [anon_sym__Generic] = ACTIONS(3419),
    [anon_sym_asm] = ACTIONS(3419),
    [anon_sym___asm__] = ACTIONS(3419),
    [aux_sym_number_literal_token1] = ACTIONS(3421),
    [aux_sym_number_literal_token2] = ACTIONS(3419),
    [anon_sym_L_SQUOTE] = ACTIONS(3421),
    [anon_sym_u_SQUOTE] = ACTIONS(3421),
    [anon_sym_U_SQUOTE] = ACTIONS(3421),
    [anon_sym_u8_SQUOTE] = ACTIONS(3421),
    [anon_sym_SQUOTE] = ACTIONS(3421),
    [anon_sym_L_DQUOTE] = ACTIONS(3421),
    [anon_sym_u_DQUOTE] = ACTIONS(3421),
    [anon_sym_U_DQUOTE] = ACTIONS(3421),
    [anon_sym_u8_DQUOTE] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [sym_true] = ACTIONS(3419),
    [sym_false] = ACTIONS(3419),
    [anon_sym_NULL] = ACTIONS(3419),
    [anon_sym_nullptr] = ACTIONS(3419),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3419),
    [anon_sym_decltype] = ACTIONS(3419),
    [anon_sym_virtual] = ACTIONS(3419),
    [anon_sym_alignas] = ACTIONS(3419),
    [anon_sym_explicit] = ACTIONS(3419),
    [anon_sym_typename] = ACTIONS(3419),
    [anon_sym_template] = ACTIONS(3419),
    [anon_sym_operator] = ACTIONS(3419),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_delete] = ACTIONS(3419),
    [anon_sym_throw] = ACTIONS(3419),
    [anon_sym_namespace] = ACTIONS(3419),
    [anon_sym_using] = ACTIONS(3419),
    [anon_sym_static_assert] = ACTIONS(3419),
    [anon_sym_concept] = ACTIONS(3419),
    [anon_sym_co_return] = ACTIONS(3419),
    [anon_sym_co_yield] = ACTIONS(3419),
    [anon_sym_R_DQUOTE] = ACTIONS(3421),
    [anon_sym_LR_DQUOTE] = ACTIONS(3421),
    [anon_sym_uR_DQUOTE] = ACTIONS(3421),
    [anon_sym_UR_DQUOTE] = ACTIONS(3421),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3421),
    [anon_sym_co_await] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_requires] = ACTIONS(3419),
    [sym_this] = ACTIONS(3419),
  },
  [973] = {
    [sym_identifier] = ACTIONS(3423),
    [aux_sym_preproc_include_token1] = ACTIONS(3423),
    [aux_sym_preproc_def_token1] = ACTIONS(3423),
    [aux_sym_preproc_if_token1] = ACTIONS(3423),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3423),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3423),
    [sym_preproc_directive] = ACTIONS(3423),
    [anon_sym_LPAREN2] = ACTIONS(3425),
    [anon_sym_BANG] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [anon_sym_DASH] = ACTIONS(3423),
    [anon_sym_PLUS] = ACTIONS(3423),
    [anon_sym_STAR] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3425),
    [anon_sym___extension__] = ACTIONS(3423),
    [anon_sym_typedef] = ACTIONS(3423),
    [anon_sym_extern] = ACTIONS(3423),
    [anon_sym___attribute__] = ACTIONS(3423),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3425),
    [anon_sym___declspec] = ACTIONS(3423),
    [anon_sym___based] = ACTIONS(3423),
    [anon_sym___cdecl] = ACTIONS(3423),
    [anon_sym___clrcall] = ACTIONS(3423),
    [anon_sym___stdcall] = ACTIONS(3423),
    [anon_sym___fastcall] = ACTIONS(3423),
    [anon_sym___thiscall] = ACTIONS(3423),
    [anon_sym___vectorcall] = ACTIONS(3423),
    [anon_sym_LBRACE] = ACTIONS(3425),
    [anon_sym_RBRACE] = ACTIONS(3425),
    [anon_sym_signed] = ACTIONS(3423),
    [anon_sym_unsigned] = ACTIONS(3423),
    [anon_sym_long] = ACTIONS(3423),
    [anon_sym_short] = ACTIONS(3423),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_static] = ACTIONS(3423),
    [anon_sym_register] = ACTIONS(3423),
    [anon_sym_inline] = ACTIONS(3423),
    [anon_sym___inline] = ACTIONS(3423),
    [anon_sym___inline__] = ACTIONS(3423),
    [anon_sym___forceinline] = ACTIONS(3423),
    [anon_sym_thread_local] = ACTIONS(3423),
    [anon_sym___thread] = ACTIONS(3423),
    [anon_sym_const] = ACTIONS(3423),
    [anon_sym_constexpr] = ACTIONS(3423),
    [anon_sym_volatile] = ACTIONS(3423),
    [anon_sym_restrict] = ACTIONS(3423),
    [anon_sym___restrict__] = ACTIONS(3423),
    [anon_sym__Atomic] = ACTIONS(3423),
    [anon_sym__Noreturn] = ACTIONS(3423),
    [anon_sym_noreturn] = ACTIONS(3423),
    [anon_sym_mutable] = ACTIONS(3423),
    [anon_sym_constinit] = ACTIONS(3423),
    [anon_sym_consteval] = ACTIONS(3423),
    [anon_sym_PROGMEM] = ACTIONS(3423),
    [aux_sym_primitive_type_token1] = ACTIONS(3423),
    [anon_sym_byte] = ACTIONS(3423),
    [anon_sym_word] = ACTIONS(3423),
    [anon_sym_enum] = ACTIONS(3423),
    [anon_sym_class] = ACTIONS(3423),
    [anon_sym_struct] = ACTIONS(3423),
    [anon_sym_union] = ACTIONS(3423),
    [anon_sym_if] = ACTIONS(3423),
    [anon_sym_switch] = ACTIONS(3423),
    [anon_sym_case] = ACTIONS(3423),
    [anon_sym_default] = ACTIONS(3423),
    [anon_sym_while] = ACTIONS(3423),
    [anon_sym_do] = ACTIONS(3423),
    [anon_sym_for] = ACTIONS(3423),
    [anon_sym_return] = ACTIONS(3423),
    [anon_sym_break] = ACTIONS(3423),
    [anon_sym_continue] = ACTIONS(3423),
    [anon_sym_goto] = ACTIONS(3423),
    [anon_sym___try] = ACTIONS(3423),
    [anon_sym___leave] = ACTIONS(3423),
    [anon_sym_not] = ACTIONS(3423),
    [anon_sym_compl] = ACTIONS(3423),
    [anon_sym_DASH_DASH] = ACTIONS(3425),
    [anon_sym_PLUS_PLUS] = ACTIONS(3425),
    [anon_sym_sizeof] = ACTIONS(3423),
    [anon_sym___alignof__] = ACTIONS(3423),
    [anon_sym___alignof] = ACTIONS(3423),
    [anon_sym__alignof] = ACTIONS(3423),
    [anon_sym_alignof] = ACTIONS(3423),
    [anon_sym__Alignof] = ACTIONS(3423),
    [anon_sym_offsetof] = ACTIONS(3423),
    [anon_sym__Generic] = ACTIONS(3423),
    [anon_sym_asm] = ACTIONS(3423),
    [anon_sym___asm__] = ACTIONS(3423),
    [aux_sym_number_literal_token1] = ACTIONS(3425),
    [aux_sym_number_literal_token2] = ACTIONS(3423),
    [anon_sym_L_SQUOTE] = ACTIONS(3425),
    [anon_sym_u_SQUOTE] = ACTIONS(3425),
    [anon_sym_U_SQUOTE] = ACTIONS(3425),
    [anon_sym_u8_SQUOTE] = ACTIONS(3425),
    [anon_sym_SQUOTE] = ACTIONS(3425),
    [anon_sym_L_DQUOTE] = ACTIONS(3425),
    [anon_sym_u_DQUOTE] = ACTIONS(3425),
    [anon_sym_U_DQUOTE] = ACTIONS(3425),
    [anon_sym_u8_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [sym_true] = ACTIONS(3423),
    [sym_false] = ACTIONS(3423),
    [anon_sym_NULL] = ACTIONS(3423),
    [anon_sym_nullptr] = ACTIONS(3423),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3423),
    [anon_sym_decltype] = ACTIONS(3423),
    [anon_sym_virtual] = ACTIONS(3423),
    [anon_sym_alignas] = ACTIONS(3423),
    [anon_sym_explicit] = ACTIONS(3423),
    [anon_sym_typename] = ACTIONS(3423),
    [anon_sym_template] = ACTIONS(3423),
    [anon_sym_operator] = ACTIONS(3423),
    [anon_sym_try] = ACTIONS(3423),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_throw] = ACTIONS(3423),
    [anon_sym_namespace] = ACTIONS(3423),
    [anon_sym_using] = ACTIONS(3423),
    [anon_sym_static_assert] = ACTIONS(3423),
    [anon_sym_concept] = ACTIONS(3423),
    [anon_sym_co_return] = ACTIONS(3423),
    [anon_sym_co_yield] = ACTIONS(3423),
    [anon_sym_R_DQUOTE] = ACTIONS(3425),
    [anon_sym_LR_DQUOTE] = ACTIONS(3425),
    [anon_sym_uR_DQUOTE] = ACTIONS(3425),
    [anon_sym_UR_DQUOTE] = ACTIONS(3425),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3425),
    [anon_sym_co_await] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3423),
    [anon_sym_requires] = ACTIONS(3423),
    [sym_this] = ACTIONS(3423),
  },
  [974] = {
    [sym_identifier] = ACTIONS(3427),
    [aux_sym_preproc_include_token1] = ACTIONS(3427),
    [aux_sym_preproc_def_token1] = ACTIONS(3427),
    [aux_sym_preproc_if_token1] = ACTIONS(3427),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3427),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3427),
    [sym_preproc_directive] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3429),
    [anon_sym_BANG] = ACTIONS(3429),
    [anon_sym_TILDE] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3429),
    [anon_sym_AMP_AMP] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(3429),
    [anon_sym___extension__] = ACTIONS(3427),
    [anon_sym_typedef] = ACTIONS(3427),
    [anon_sym_extern] = ACTIONS(3427),
    [anon_sym___attribute__] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3429),
    [anon_sym___declspec] = ACTIONS(3427),
    [anon_sym___based] = ACTIONS(3427),
    [anon_sym___cdecl] = ACTIONS(3427),
    [anon_sym___clrcall] = ACTIONS(3427),
    [anon_sym___stdcall] = ACTIONS(3427),
    [anon_sym___fastcall] = ACTIONS(3427),
    [anon_sym___thiscall] = ACTIONS(3427),
    [anon_sym___vectorcall] = ACTIONS(3427),
    [anon_sym_LBRACE] = ACTIONS(3429),
    [anon_sym_RBRACE] = ACTIONS(3429),
    [anon_sym_signed] = ACTIONS(3427),
    [anon_sym_unsigned] = ACTIONS(3427),
    [anon_sym_long] = ACTIONS(3427),
    [anon_sym_short] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_register] = ACTIONS(3427),
    [anon_sym_inline] = ACTIONS(3427),
    [anon_sym___inline] = ACTIONS(3427),
    [anon_sym___inline__] = ACTIONS(3427),
    [anon_sym___forceinline] = ACTIONS(3427),
    [anon_sym_thread_local] = ACTIONS(3427),
    [anon_sym___thread] = ACTIONS(3427),
    [anon_sym_const] = ACTIONS(3427),
    [anon_sym_constexpr] = ACTIONS(3427),
    [anon_sym_volatile] = ACTIONS(3427),
    [anon_sym_restrict] = ACTIONS(3427),
    [anon_sym___restrict__] = ACTIONS(3427),
    [anon_sym__Atomic] = ACTIONS(3427),
    [anon_sym__Noreturn] = ACTIONS(3427),
    [anon_sym_noreturn] = ACTIONS(3427),
    [anon_sym_mutable] = ACTIONS(3427),
    [anon_sym_constinit] = ACTIONS(3427),
    [anon_sym_consteval] = ACTIONS(3427),
    [anon_sym_PROGMEM] = ACTIONS(3427),
    [aux_sym_primitive_type_token1] = ACTIONS(3427),
    [anon_sym_byte] = ACTIONS(3427),
    [anon_sym_word] = ACTIONS(3427),
    [anon_sym_enum] = ACTIONS(3427),
    [anon_sym_class] = ACTIONS(3427),
    [anon_sym_struct] = ACTIONS(3427),
    [anon_sym_union] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_switch] = ACTIONS(3427),
    [anon_sym_case] = ACTIONS(3427),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_break] = ACTIONS(3427),
    [anon_sym_continue] = ACTIONS(3427),
    [anon_sym_goto] = ACTIONS(3427),
    [anon_sym___try] = ACTIONS(3427),
    [anon_sym___leave] = ACTIONS(3427),
    [anon_sym_not] = ACTIONS(3427),
    [anon_sym_compl] = ACTIONS(3427),
    [anon_sym_DASH_DASH] = ACTIONS(3429),
    [anon_sym_PLUS_PLUS] = ACTIONS(3429),
    [anon_sym_sizeof] = ACTIONS(3427),
    [anon_sym___alignof__] = ACTIONS(3427),
    [anon_sym___alignof] = ACTIONS(3427),
    [anon_sym__alignof] = ACTIONS(3427),
    [anon_sym_alignof] = ACTIONS(3427),
    [anon_sym__Alignof] = ACTIONS(3427),
    [anon_sym_offsetof] = ACTIONS(3427),
    [anon_sym__Generic] = ACTIONS(3427),
    [anon_sym_asm] = ACTIONS(3427),
    [anon_sym___asm__] = ACTIONS(3427),
    [aux_sym_number_literal_token1] = ACTIONS(3429),
    [aux_sym_number_literal_token2] = ACTIONS(3427),
    [anon_sym_L_SQUOTE] = ACTIONS(3429),
    [anon_sym_u_SQUOTE] = ACTIONS(3429),
    [anon_sym_U_SQUOTE] = ACTIONS(3429),
    [anon_sym_u8_SQUOTE] = ACTIONS(3429),
    [anon_sym_SQUOTE] = ACTIONS(3429),
    [anon_sym_L_DQUOTE] = ACTIONS(3429),
    [anon_sym_u_DQUOTE] = ACTIONS(3429),
    [anon_sym_U_DQUOTE] = ACTIONS(3429),
    [anon_sym_u8_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(3429),
    [sym_true] = ACTIONS(3427),
    [sym_false] = ACTIONS(3427),
    [anon_sym_NULL] = ACTIONS(3427),
    [anon_sym_nullptr] = ACTIONS(3427),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3427),
    [anon_sym_decltype] = ACTIONS(3427),
    [anon_sym_virtual] = ACTIONS(3427),
    [anon_sym_alignas] = ACTIONS(3427),
    [anon_sym_explicit] = ACTIONS(3427),
    [anon_sym_typename] = ACTIONS(3427),
    [anon_sym_template] = ACTIONS(3427),
    [anon_sym_operator] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_delete] = ACTIONS(3427),
    [anon_sym_throw] = ACTIONS(3427),
    [anon_sym_namespace] = ACTIONS(3427),
    [anon_sym_using] = ACTIONS(3427),
    [anon_sym_static_assert] = ACTIONS(3427),
    [anon_sym_concept] = ACTIONS(3427),
    [anon_sym_co_return] = ACTIONS(3427),
    [anon_sym_co_yield] = ACTIONS(3427),
    [anon_sym_R_DQUOTE] = ACTIONS(3429),
    [anon_sym_LR_DQUOTE] = ACTIONS(3429),
    [anon_sym_uR_DQUOTE] = ACTIONS(3429),
    [anon_sym_UR_DQUOTE] = ACTIONS(3429),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3429),
    [anon_sym_co_await] = ACTIONS(3427),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_requires] = ACTIONS(3427),
    [sym_this] = ACTIONS(3427),
  },
  [975] = {
    [sym_identifier] = ACTIONS(3517),
    [aux_sym_preproc_include_token1] = ACTIONS(3517),
    [aux_sym_preproc_def_token1] = ACTIONS(3517),
    [aux_sym_preproc_if_token1] = ACTIONS(3517),
    [aux_sym_preproc_if_token2] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3517),
    [sym_preproc_directive] = ACTIONS(3517),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_BANG] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3517),
    [anon_sym_PLUS] = ACTIONS(3517),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_SEMI] = ACTIONS(3519),
    [anon_sym___extension__] = ACTIONS(3517),
    [anon_sym_typedef] = ACTIONS(3517),
    [anon_sym_extern] = ACTIONS(3517),
    [anon_sym___attribute__] = ACTIONS(3517),
    [anon_sym_COLON_COLON] = ACTIONS(3519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3519),
    [anon_sym___declspec] = ACTIONS(3517),
    [anon_sym___based] = ACTIONS(3517),
    [anon_sym___cdecl] = ACTIONS(3517),
    [anon_sym___clrcall] = ACTIONS(3517),
    [anon_sym___stdcall] = ACTIONS(3517),
    [anon_sym___fastcall] = ACTIONS(3517),
    [anon_sym___thiscall] = ACTIONS(3517),
    [anon_sym___vectorcall] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_signed] = ACTIONS(3517),
    [anon_sym_unsigned] = ACTIONS(3517),
    [anon_sym_long] = ACTIONS(3517),
    [anon_sym_short] = ACTIONS(3517),
    [anon_sym_LBRACK] = ACTIONS(3517),
    [anon_sym_static] = ACTIONS(3517),
    [anon_sym_register] = ACTIONS(3517),
    [anon_sym_inline] = ACTIONS(3517),
    [anon_sym___inline] = ACTIONS(3517),
    [anon_sym___inline__] = ACTIONS(3517),
    [anon_sym___forceinline] = ACTIONS(3517),
    [anon_sym_thread_local] = ACTIONS(3517),
    [anon_sym___thread] = ACTIONS(3517),
    [anon_sym_const] = ACTIONS(3517),
    [anon_sym_constexpr] = ACTIONS(3517),
    [anon_sym_volatile] = ACTIONS(3517),
    [anon_sym_restrict] = ACTIONS(3517),
    [anon_sym___restrict__] = ACTIONS(3517),
    [anon_sym__Atomic] = ACTIONS(3517),
    [anon_sym__Noreturn] = ACTIONS(3517),
    [anon_sym_noreturn] = ACTIONS(3517),
    [anon_sym_mutable] = ACTIONS(3517),
    [anon_sym_constinit] = ACTIONS(3517),
    [anon_sym_consteval] = ACTIONS(3517),
    [anon_sym_PROGMEM] = ACTIONS(3517),
    [aux_sym_primitive_type_token1] = ACTIONS(3517),
    [anon_sym_byte] = ACTIONS(3517),
    [anon_sym_word] = ACTIONS(3517),
    [anon_sym_enum] = ACTIONS(3517),
    [anon_sym_class] = ACTIONS(3517),
    [anon_sym_struct] = ACTIONS(3517),
    [anon_sym_union] = ACTIONS(3517),
    [anon_sym_if] = ACTIONS(3517),
    [anon_sym_switch] = ACTIONS(3517),
    [anon_sym_case] = ACTIONS(3517),
    [anon_sym_default] = ACTIONS(3517),
    [anon_sym_while] = ACTIONS(3517),
    [anon_sym_do] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3517),
    [anon_sym_return] = ACTIONS(3517),
    [anon_sym_break] = ACTIONS(3517),
    [anon_sym_continue] = ACTIONS(3517),
    [anon_sym_goto] = ACTIONS(3517),
    [anon_sym___try] = ACTIONS(3517),
    [anon_sym___leave] = ACTIONS(3517),
    [anon_sym_not] = ACTIONS(3517),
    [anon_sym_compl] = ACTIONS(3517),
    [anon_sym_DASH_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_PLUS] = ACTIONS(3519),
    [anon_sym_sizeof] = ACTIONS(3517),
    [anon_sym___alignof__] = ACTIONS(3517),
    [anon_sym___alignof] = ACTIONS(3517),
    [anon_sym__alignof] = ACTIONS(3517),
    [anon_sym_alignof] = ACTIONS(3517),
    [anon_sym__Alignof] = ACTIONS(3517),
    [anon_sym_offsetof] = ACTIONS(3517),
    [anon_sym__Generic] = ACTIONS(3517),
    [anon_sym_asm] = ACTIONS(3517),
    [anon_sym___asm__] = ACTIONS(3517),
    [aux_sym_number_literal_token1] = ACTIONS(3519),
    [aux_sym_number_literal_token2] = ACTIONS(3517),
    [anon_sym_L_SQUOTE] = ACTIONS(3519),
    [anon_sym_u_SQUOTE] = ACTIONS(3519),
    [anon_sym_U_SQUOTE] = ACTIONS(3519),
    [anon_sym_u8_SQUOTE] = ACTIONS(3519),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_L_DQUOTE] = ACTIONS(3519),
    [anon_sym_u_DQUOTE] = ACTIONS(3519),
    [anon_sym_U_DQUOTE] = ACTIONS(3519),
    [anon_sym_u8_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [sym_true] = ACTIONS(3517),
    [sym_false] = ACTIONS(3517),
    [anon_sym_NULL] = ACTIONS(3517),
    [anon_sym_nullptr] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3517),
    [anon_sym_decltype] = ACTIONS(3517),
    [anon_sym_virtual] = ACTIONS(3517),
    [anon_sym_alignas] = ACTIONS(3517),
    [anon_sym_explicit] = ACTIONS(3517),
    [anon_sym_typename] = ACTIONS(3517),
    [anon_sym_template] = ACTIONS(3517),
    [anon_sym_operator] = ACTIONS(3517),
    [anon_sym_try] = ACTIONS(3517),
    [anon_sym_delete] = ACTIONS(3517),
    [anon_sym_throw] = ACTIONS(3517),
    [anon_sym_namespace] = ACTIONS(3517),
    [anon_sym_using] = ACTIONS(3517),
    [anon_sym_static_assert] = ACTIONS(3517),
    [anon_sym_concept] = ACTIONS(3517),
    [anon_sym_co_return] = ACTIONS(3517),
    [anon_sym_co_yield] = ACTIONS(3517),
    [anon_sym_R_DQUOTE] = ACTIONS(3519),
    [anon_sym_LR_DQUOTE] = ACTIONS(3519),
    [anon_sym_uR_DQUOTE] = ACTIONS(3519),
    [anon_sym_UR_DQUOTE] = ACTIONS(3519),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3519),
    [anon_sym_co_await] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3517),
    [anon_sym_requires] = ACTIONS(3517),
    [sym_this] = ACTIONS(3517),
  },
  [976] = {
    [sym_identifier] = ACTIONS(3521),
    [aux_sym_preproc_include_token1] = ACTIONS(3521),
    [aux_sym_preproc_def_token1] = ACTIONS(3521),
    [aux_sym_preproc_if_token1] = ACTIONS(3521),
    [aux_sym_preproc_if_token2] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3521),
    [sym_preproc_directive] = ACTIONS(3521),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_BANG] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3521),
    [anon_sym_PLUS] = ACTIONS(3521),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3521),
    [anon_sym_SEMI] = ACTIONS(3523),
    [anon_sym___extension__] = ACTIONS(3521),
    [anon_sym_typedef] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym___attribute__] = ACTIONS(3521),
    [anon_sym_COLON_COLON] = ACTIONS(3523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3523),
    [anon_sym___declspec] = ACTIONS(3521),
    [anon_sym___based] = ACTIONS(3521),
    [anon_sym___cdecl] = ACTIONS(3521),
    [anon_sym___clrcall] = ACTIONS(3521),
    [anon_sym___stdcall] = ACTIONS(3521),
    [anon_sym___fastcall] = ACTIONS(3521),
    [anon_sym___thiscall] = ACTIONS(3521),
    [anon_sym___vectorcall] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_signed] = ACTIONS(3521),
    [anon_sym_unsigned] = ACTIONS(3521),
    [anon_sym_long] = ACTIONS(3521),
    [anon_sym_short] = ACTIONS(3521),
    [anon_sym_LBRACK] = ACTIONS(3521),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_register] = ACTIONS(3521),
    [anon_sym_inline] = ACTIONS(3521),
    [anon_sym___inline] = ACTIONS(3521),
    [anon_sym___inline__] = ACTIONS(3521),
    [anon_sym___forceinline] = ACTIONS(3521),
    [anon_sym_thread_local] = ACTIONS(3521),
    [anon_sym___thread] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_constexpr] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym_restrict] = ACTIONS(3521),
    [anon_sym___restrict__] = ACTIONS(3521),
    [anon_sym__Atomic] = ACTIONS(3521),
    [anon_sym__Noreturn] = ACTIONS(3521),
    [anon_sym_noreturn] = ACTIONS(3521),
    [anon_sym_mutable] = ACTIONS(3521),
    [anon_sym_constinit] = ACTIONS(3521),
    [anon_sym_consteval] = ACTIONS(3521),
    [anon_sym_PROGMEM] = ACTIONS(3521),
    [aux_sym_primitive_type_token1] = ACTIONS(3521),
    [anon_sym_byte] = ACTIONS(3521),
    [anon_sym_word] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_class] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_union] = ACTIONS(3521),
    [anon_sym_if] = ACTIONS(3521),
    [anon_sym_switch] = ACTIONS(3521),
    [anon_sym_case] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3521),
    [anon_sym_while] = ACTIONS(3521),
    [anon_sym_do] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3521),
    [anon_sym_return] = ACTIONS(3521),
    [anon_sym_break] = ACTIONS(3521),
    [anon_sym_continue] = ACTIONS(3521),
    [anon_sym_goto] = ACTIONS(3521),
    [anon_sym___try] = ACTIONS(3521),
    [anon_sym___leave] = ACTIONS(3521),
    [anon_sym_not] = ACTIONS(3521),
    [anon_sym_compl] = ACTIONS(3521),
    [anon_sym_DASH_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_PLUS] = ACTIONS(3523),
    [anon_sym_sizeof] = ACTIONS(3521),
    [anon_sym___alignof__] = ACTIONS(3521),
    [anon_sym___alignof] = ACTIONS(3521),
    [anon_sym__alignof] = ACTIONS(3521),
    [anon_sym_alignof] = ACTIONS(3521),
    [anon_sym__Alignof] = ACTIONS(3521),
    [anon_sym_offsetof] = ACTIONS(3521),
    [anon_sym__Generic] = ACTIONS(3521),
    [anon_sym_asm] = ACTIONS(3521),
    [anon_sym___asm__] = ACTIONS(3521),
    [aux_sym_number_literal_token1] = ACTIONS(3523),
    [aux_sym_number_literal_token2] = ACTIONS(3521),
    [anon_sym_L_SQUOTE] = ACTIONS(3523),
    [anon_sym_u_SQUOTE] = ACTIONS(3523),
    [anon_sym_U_SQUOTE] = ACTIONS(3523),
    [anon_sym_u8_SQUOTE] = ACTIONS(3523),
    [anon_sym_SQUOTE] = ACTIONS(3523),
    [anon_sym_L_DQUOTE] = ACTIONS(3523),
    [anon_sym_u_DQUOTE] = ACTIONS(3523),
    [anon_sym_U_DQUOTE] = ACTIONS(3523),
    [anon_sym_u8_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [sym_true] = ACTIONS(3521),
    [sym_false] = ACTIONS(3521),
    [anon_sym_NULL] = ACTIONS(3521),
    [anon_sym_nullptr] = ACTIONS(3521),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3521),
    [anon_sym_decltype] = ACTIONS(3521),
    [anon_sym_virtual] = ACTIONS(3521),
    [anon_sym_alignas] = ACTIONS(3521),
    [anon_sym_explicit] = ACTIONS(3521),
    [anon_sym_typename] = ACTIONS(3521),
    [anon_sym_template] = ACTIONS(3521),
    [anon_sym_operator] = ACTIONS(3521),
    [anon_sym_try] = ACTIONS(3521),
    [anon_sym_delete] = ACTIONS(3521),
    [anon_sym_throw] = ACTIONS(3521),
    [anon_sym_namespace] = ACTIONS(3521),
    [anon_sym_using] = ACTIONS(3521),
    [anon_sym_static_assert] = ACTIONS(3521),
    [anon_sym_concept] = ACTIONS(3521),
    [anon_sym_co_return] = ACTIONS(3521),
    [anon_sym_co_yield] = ACTIONS(3521),
    [anon_sym_R_DQUOTE] = ACTIONS(3523),
    [anon_sym_LR_DQUOTE] = ACTIONS(3523),
    [anon_sym_uR_DQUOTE] = ACTIONS(3523),
    [anon_sym_UR_DQUOTE] = ACTIONS(3523),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3523),
    [anon_sym_co_await] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3521),
    [anon_sym_requires] = ACTIONS(3521),
    [sym_this] = ACTIONS(3521),
  },
  [977] = {
    [sym_identifier] = ACTIONS(3310),
    [aux_sym_preproc_include_token1] = ACTIONS(3310),
    [aux_sym_preproc_def_token1] = ACTIONS(3310),
    [aux_sym_preproc_if_token1] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3310),
    [sym_preproc_directive] = ACTIONS(3310),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_AMP_AMP] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3310),
    [anon_sym_SEMI] = ACTIONS(3312),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_typedef] = ACTIONS(3310),
    [anon_sym_extern] = ACTIONS(3310),
    [anon_sym___attribute__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3312),
    [anon_sym___declspec] = ACTIONS(3310),
    [anon_sym___based] = ACTIONS(3310),
    [anon_sym___cdecl] = ACTIONS(3310),
    [anon_sym___clrcall] = ACTIONS(3310),
    [anon_sym___stdcall] = ACTIONS(3310),
    [anon_sym___fastcall] = ACTIONS(3310),
    [anon_sym___thiscall] = ACTIONS(3310),
    [anon_sym___vectorcall] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3312),
    [anon_sym_RBRACE] = ACTIONS(3312),
    [anon_sym_signed] = ACTIONS(3310),
    [anon_sym_unsigned] = ACTIONS(3310),
    [anon_sym_long] = ACTIONS(3310),
    [anon_sym_short] = ACTIONS(3310),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [anon_sym_static] = ACTIONS(3310),
    [anon_sym_register] = ACTIONS(3310),
    [anon_sym_inline] = ACTIONS(3310),
    [anon_sym___inline] = ACTIONS(3310),
    [anon_sym___inline__] = ACTIONS(3310),
    [anon_sym___forceinline] = ACTIONS(3310),
    [anon_sym_thread_local] = ACTIONS(3310),
    [anon_sym___thread] = ACTIONS(3310),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_constexpr] = ACTIONS(3310),
    [anon_sym_volatile] = ACTIONS(3310),
    [anon_sym_restrict] = ACTIONS(3310),
    [anon_sym___restrict__] = ACTIONS(3310),
    [anon_sym__Atomic] = ACTIONS(3310),
    [anon_sym__Noreturn] = ACTIONS(3310),
    [anon_sym_noreturn] = ACTIONS(3310),
    [anon_sym_mutable] = ACTIONS(3310),
    [anon_sym_constinit] = ACTIONS(3310),
    [anon_sym_consteval] = ACTIONS(3310),
    [anon_sym_PROGMEM] = ACTIONS(3310),
    [aux_sym_primitive_type_token1] = ACTIONS(3310),
    [anon_sym_byte] = ACTIONS(3310),
    [anon_sym_word] = ACTIONS(3310),
    [anon_sym_enum] = ACTIONS(3310),
    [anon_sym_class] = ACTIONS(3310),
    [anon_sym_struct] = ACTIONS(3310),
    [anon_sym_union] = ACTIONS(3310),
    [anon_sym_if] = ACTIONS(3310),
    [anon_sym_switch] = ACTIONS(3310),
    [anon_sym_case] = ACTIONS(3310),
    [anon_sym_default] = ACTIONS(3310),
    [anon_sym_while] = ACTIONS(3310),
    [anon_sym_do] = ACTIONS(3310),
    [anon_sym_for] = ACTIONS(3310),
    [anon_sym_return] = ACTIONS(3310),
    [anon_sym_break] = ACTIONS(3310),
    [anon_sym_continue] = ACTIONS(3310),
    [anon_sym_goto] = ACTIONS(3310),
    [anon_sym___try] = ACTIONS(3310),
    [anon_sym___leave] = ACTIONS(3310),
    [anon_sym_not] = ACTIONS(3310),
    [anon_sym_compl] = ACTIONS(3310),
    [anon_sym_DASH_DASH] = ACTIONS(3312),
    [anon_sym_PLUS_PLUS] = ACTIONS(3312),
    [anon_sym_sizeof] = ACTIONS(3310),
    [anon_sym___alignof__] = ACTIONS(3310),
    [anon_sym___alignof] = ACTIONS(3310),
    [anon_sym__alignof] = ACTIONS(3310),
    [anon_sym_alignof] = ACTIONS(3310),
    [anon_sym__Alignof] = ACTIONS(3310),
    [anon_sym_offsetof] = ACTIONS(3310),
    [anon_sym__Generic] = ACTIONS(3310),
    [anon_sym_asm] = ACTIONS(3310),
    [anon_sym___asm__] = ACTIONS(3310),
    [aux_sym_number_literal_token1] = ACTIONS(3312),
    [aux_sym_number_literal_token2] = ACTIONS(3310),
    [anon_sym_L_SQUOTE] = ACTIONS(3312),
    [anon_sym_u_SQUOTE] = ACTIONS(3312),
    [anon_sym_U_SQUOTE] = ACTIONS(3312),
    [anon_sym_u8_SQUOTE] = ACTIONS(3312),
    [anon_sym_SQUOTE] = ACTIONS(3312),
    [anon_sym_L_DQUOTE] = ACTIONS(3312),
    [anon_sym_u_DQUOTE] = ACTIONS(3312),
    [anon_sym_U_DQUOTE] = ACTIONS(3312),
    [anon_sym_u8_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE] = ACTIONS(3312),
    [sym_true] = ACTIONS(3310),
    [sym_false] = ACTIONS(3310),
    [anon_sym_NULL] = ACTIONS(3310),
    [anon_sym_nullptr] = ACTIONS(3310),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3310),
    [anon_sym_decltype] = ACTIONS(3310),
    [anon_sym_virtual] = ACTIONS(3310),
    [anon_sym_alignas] = ACTIONS(3310),
    [anon_sym_explicit] = ACTIONS(3310),
    [anon_sym_typename] = ACTIONS(3310),
    [anon_sym_template] = ACTIONS(3310),
    [anon_sym_operator] = ACTIONS(3310),
    [anon_sym_try] = ACTIONS(3310),
    [anon_sym_delete] = ACTIONS(3310),
    [anon_sym_throw] = ACTIONS(3310),
    [anon_sym_namespace] = ACTIONS(3310),
    [anon_sym_using] = ACTIONS(3310),
    [anon_sym_static_assert] = ACTIONS(3310),
    [anon_sym_concept] = ACTIONS(3310),
    [anon_sym_co_return] = ACTIONS(3310),
    [anon_sym_co_yield] = ACTIONS(3310),
    [anon_sym_R_DQUOTE] = ACTIONS(3312),
    [anon_sym_LR_DQUOTE] = ACTIONS(3312),
    [anon_sym_uR_DQUOTE] = ACTIONS(3312),
    [anon_sym_UR_DQUOTE] = ACTIONS(3312),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3312),
    [anon_sym_co_await] = ACTIONS(3310),
    [anon_sym_new] = ACTIONS(3310),
    [anon_sym_requires] = ACTIONS(3310),
    [sym_this] = ACTIONS(3310),
  },
  [978] = {
    [sym_identifier] = ACTIONS(3314),
    [aux_sym_preproc_include_token1] = ACTIONS(3314),
    [aux_sym_preproc_def_token1] = ACTIONS(3314),
    [aux_sym_preproc_if_token1] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3314),
    [sym_preproc_directive] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_STAR] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_SEMI] = ACTIONS(3316),
    [anon_sym___extension__] = ACTIONS(3314),
    [anon_sym_typedef] = ACTIONS(3314),
    [anon_sym_extern] = ACTIONS(3314),
    [anon_sym___attribute__] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3316),
    [anon_sym___declspec] = ACTIONS(3314),
    [anon_sym___based] = ACTIONS(3314),
    [anon_sym___cdecl] = ACTIONS(3314),
    [anon_sym___clrcall] = ACTIONS(3314),
    [anon_sym___stdcall] = ACTIONS(3314),
    [anon_sym___fastcall] = ACTIONS(3314),
    [anon_sym___thiscall] = ACTIONS(3314),
    [anon_sym___vectorcall] = ACTIONS(3314),
    [anon_sym_LBRACE] = ACTIONS(3316),
    [anon_sym_RBRACE] = ACTIONS(3316),
    [anon_sym_signed] = ACTIONS(3314),
    [anon_sym_unsigned] = ACTIONS(3314),
    [anon_sym_long] = ACTIONS(3314),
    [anon_sym_short] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_static] = ACTIONS(3314),
    [anon_sym_register] = ACTIONS(3314),
    [anon_sym_inline] = ACTIONS(3314),
    [anon_sym___inline] = ACTIONS(3314),
    [anon_sym___inline__] = ACTIONS(3314),
    [anon_sym___forceinline] = ACTIONS(3314),
    [anon_sym_thread_local] = ACTIONS(3314),
    [anon_sym___thread] = ACTIONS(3314),
    [anon_sym_const] = ACTIONS(3314),
    [anon_sym_constexpr] = ACTIONS(3314),
    [anon_sym_volatile] = ACTIONS(3314),
    [anon_sym_restrict] = ACTIONS(3314),
    [anon_sym___restrict__] = ACTIONS(3314),
    [anon_sym__Atomic] = ACTIONS(3314),
    [anon_sym__Noreturn] = ACTIONS(3314),
    [anon_sym_noreturn] = ACTIONS(3314),
    [anon_sym_mutable] = ACTIONS(3314),
    [anon_sym_constinit] = ACTIONS(3314),
    [anon_sym_consteval] = ACTIONS(3314),
    [anon_sym_PROGMEM] = ACTIONS(3314),
    [aux_sym_primitive_type_token1] = ACTIONS(3314),
    [anon_sym_byte] = ACTIONS(3314),
    [anon_sym_word] = ACTIONS(3314),
    [anon_sym_enum] = ACTIONS(3314),
    [anon_sym_class] = ACTIONS(3314),
    [anon_sym_struct] = ACTIONS(3314),
    [anon_sym_union] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_switch] = ACTIONS(3314),
    [anon_sym_case] = ACTIONS(3314),
    [anon_sym_default] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_break] = ACTIONS(3314),
    [anon_sym_continue] = ACTIONS(3314),
    [anon_sym_goto] = ACTIONS(3314),
    [anon_sym___try] = ACTIONS(3314),
    [anon_sym___leave] = ACTIONS(3314),
    [anon_sym_not] = ACTIONS(3314),
    [anon_sym_compl] = ACTIONS(3314),
    [anon_sym_DASH_DASH] = ACTIONS(3316),
    [anon_sym_PLUS_PLUS] = ACTIONS(3316),
    [anon_sym_sizeof] = ACTIONS(3314),
    [anon_sym___alignof__] = ACTIONS(3314),
    [anon_sym___alignof] = ACTIONS(3314),
    [anon_sym__alignof] = ACTIONS(3314),
    [anon_sym_alignof] = ACTIONS(3314),
    [anon_sym__Alignof] = ACTIONS(3314),
    [anon_sym_offsetof] = ACTIONS(3314),
    [anon_sym__Generic] = ACTIONS(3314),
    [anon_sym_asm] = ACTIONS(3314),
    [anon_sym___asm__] = ACTIONS(3314),
    [aux_sym_number_literal_token1] = ACTIONS(3316),
    [aux_sym_number_literal_token2] = ACTIONS(3314),
    [anon_sym_L_SQUOTE] = ACTIONS(3316),
    [anon_sym_u_SQUOTE] = ACTIONS(3316),
    [anon_sym_U_SQUOTE] = ACTIONS(3316),
    [anon_sym_u8_SQUOTE] = ACTIONS(3316),
    [anon_sym_SQUOTE] = ACTIONS(3316),
    [anon_sym_L_DQUOTE] = ACTIONS(3316),
    [anon_sym_u_DQUOTE] = ACTIONS(3316),
    [anon_sym_U_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8_DQUOTE] = ACTIONS(3316),
    [anon_sym_DQUOTE] = ACTIONS(3316),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [anon_sym_NULL] = ACTIONS(3314),
    [anon_sym_nullptr] = ACTIONS(3314),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3314),
    [anon_sym_decltype] = ACTIONS(3314),
    [anon_sym_virtual] = ACTIONS(3314),
    [anon_sym_alignas] = ACTIONS(3314),
    [anon_sym_explicit] = ACTIONS(3314),
    [anon_sym_typename] = ACTIONS(3314),
    [anon_sym_template] = ACTIONS(3314),
    [anon_sym_operator] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_delete] = ACTIONS(3314),
    [anon_sym_throw] = ACTIONS(3314),
    [anon_sym_namespace] = ACTIONS(3314),
    [anon_sym_using] = ACTIONS(3314),
    [anon_sym_static_assert] = ACTIONS(3314),
    [anon_sym_concept] = ACTIONS(3314),
    [anon_sym_co_return] = ACTIONS(3314),
    [anon_sym_co_yield] = ACTIONS(3314),
    [anon_sym_R_DQUOTE] = ACTIONS(3316),
    [anon_sym_LR_DQUOTE] = ACTIONS(3316),
    [anon_sym_uR_DQUOTE] = ACTIONS(3316),
    [anon_sym_UR_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3316),
    [anon_sym_co_await] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_requires] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
  },
  [979] = {
    [sym_identifier] = ACTIONS(3431),
    [aux_sym_preproc_include_token1] = ACTIONS(3431),
    [aux_sym_preproc_def_token1] = ACTIONS(3431),
    [aux_sym_preproc_if_token1] = ACTIONS(3431),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3431),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3431),
    [sym_preproc_directive] = ACTIONS(3431),
    [anon_sym_LPAREN2] = ACTIONS(3433),
    [anon_sym_BANG] = ACTIONS(3433),
    [anon_sym_TILDE] = ACTIONS(3433),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3433),
    [anon_sym_AMP_AMP] = ACTIONS(3433),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_SEMI] = ACTIONS(3433),
    [anon_sym___extension__] = ACTIONS(3431),
    [anon_sym_typedef] = ACTIONS(3431),
    [anon_sym_extern] = ACTIONS(3431),
    [anon_sym___attribute__] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3433),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3433),
    [anon_sym___declspec] = ACTIONS(3431),
    [anon_sym___based] = ACTIONS(3431),
    [anon_sym___cdecl] = ACTIONS(3431),
    [anon_sym___clrcall] = ACTIONS(3431),
    [anon_sym___stdcall] = ACTIONS(3431),
    [anon_sym___fastcall] = ACTIONS(3431),
    [anon_sym___thiscall] = ACTIONS(3431),
    [anon_sym___vectorcall] = ACTIONS(3431),
    [anon_sym_LBRACE] = ACTIONS(3433),
    [anon_sym_RBRACE] = ACTIONS(3433),
    [anon_sym_signed] = ACTIONS(3431),
    [anon_sym_unsigned] = ACTIONS(3431),
    [anon_sym_long] = ACTIONS(3431),
    [anon_sym_short] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_static] = ACTIONS(3431),
    [anon_sym_register] = ACTIONS(3431),
    [anon_sym_inline] = ACTIONS(3431),
    [anon_sym___inline] = ACTIONS(3431),
    [anon_sym___inline__] = ACTIONS(3431),
    [anon_sym___forceinline] = ACTIONS(3431),
    [anon_sym_thread_local] = ACTIONS(3431),
    [anon_sym___thread] = ACTIONS(3431),
    [anon_sym_const] = ACTIONS(3431),
    [anon_sym_constexpr] = ACTIONS(3431),
    [anon_sym_volatile] = ACTIONS(3431),
    [anon_sym_restrict] = ACTIONS(3431),
    [anon_sym___restrict__] = ACTIONS(3431),
    [anon_sym__Atomic] = ACTIONS(3431),
    [anon_sym__Noreturn] = ACTIONS(3431),
    [anon_sym_noreturn] = ACTIONS(3431),
    [anon_sym_mutable] = ACTIONS(3431),
    [anon_sym_constinit] = ACTIONS(3431),
    [anon_sym_consteval] = ACTIONS(3431),
    [anon_sym_PROGMEM] = ACTIONS(3431),
    [aux_sym_primitive_type_token1] = ACTIONS(3431),
    [anon_sym_byte] = ACTIONS(3431),
    [anon_sym_word] = ACTIONS(3431),
    [anon_sym_enum] = ACTIONS(3431),
    [anon_sym_class] = ACTIONS(3431),
    [anon_sym_struct] = ACTIONS(3431),
    [anon_sym_union] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_switch] = ACTIONS(3431),
    [anon_sym_case] = ACTIONS(3431),
    [anon_sym_default] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_break] = ACTIONS(3431),
    [anon_sym_continue] = ACTIONS(3431),
    [anon_sym_goto] = ACTIONS(3431),
    [anon_sym___try] = ACTIONS(3431),
    [anon_sym___leave] = ACTIONS(3431),
    [anon_sym_not] = ACTIONS(3431),
    [anon_sym_compl] = ACTIONS(3431),
    [anon_sym_DASH_DASH] = ACTIONS(3433),
    [anon_sym_PLUS_PLUS] = ACTIONS(3433),
    [anon_sym_sizeof] = ACTIONS(3431),
    [anon_sym___alignof__] = ACTIONS(3431),
    [anon_sym___alignof] = ACTIONS(3431),
    [anon_sym__alignof] = ACTIONS(3431),
    [anon_sym_alignof] = ACTIONS(3431),
    [anon_sym__Alignof] = ACTIONS(3431),
    [anon_sym_offsetof] = ACTIONS(3431),
    [anon_sym__Generic] = ACTIONS(3431),
    [anon_sym_asm] = ACTIONS(3431),
    [anon_sym___asm__] = ACTIONS(3431),
    [aux_sym_number_literal_token1] = ACTIONS(3433),
    [aux_sym_number_literal_token2] = ACTIONS(3431),
    [anon_sym_L_SQUOTE] = ACTIONS(3433),
    [anon_sym_u_SQUOTE] = ACTIONS(3433),
    [anon_sym_U_SQUOTE] = ACTIONS(3433),
    [anon_sym_u8_SQUOTE] = ACTIONS(3433),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [anon_sym_L_DQUOTE] = ACTIONS(3433),
    [anon_sym_u_DQUOTE] = ACTIONS(3433),
    [anon_sym_U_DQUOTE] = ACTIONS(3433),
    [anon_sym_u8_DQUOTE] = ACTIONS(3433),
    [anon_sym_DQUOTE] = ACTIONS(3433),
    [sym_true] = ACTIONS(3431),
    [sym_false] = ACTIONS(3431),
    [anon_sym_NULL] = ACTIONS(3431),
    [anon_sym_nullptr] = ACTIONS(3431),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3431),
    [anon_sym_decltype] = ACTIONS(3431),
    [anon_sym_virtual] = ACTIONS(3431),
    [anon_sym_alignas] = ACTIONS(3431),
    [anon_sym_explicit] = ACTIONS(3431),
    [anon_sym_typename] = ACTIONS(3431),
    [anon_sym_template] = ACTIONS(3431),
    [anon_sym_operator] = ACTIONS(3431),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_delete] = ACTIONS(3431),
    [anon_sym_throw] = ACTIONS(3431),
    [anon_sym_namespace] = ACTIONS(3431),
    [anon_sym_using] = ACTIONS(3431),
    [anon_sym_static_assert] = ACTIONS(3431),
    [anon_sym_concept] = ACTIONS(3431),
    [anon_sym_co_return] = ACTIONS(3431),
    [anon_sym_co_yield] = ACTIONS(3431),
    [anon_sym_R_DQUOTE] = ACTIONS(3433),
    [anon_sym_LR_DQUOTE] = ACTIONS(3433),
    [anon_sym_uR_DQUOTE] = ACTIONS(3433),
    [anon_sym_UR_DQUOTE] = ACTIONS(3433),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3433),
    [anon_sym_co_await] = ACTIONS(3431),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_requires] = ACTIONS(3431),
    [sym_this] = ACTIONS(3431),
  },
  [980] = {
    [sym_identifier] = ACTIONS(3371),
    [aux_sym_preproc_include_token1] = ACTIONS(3371),
    [aux_sym_preproc_def_token1] = ACTIONS(3371),
    [aux_sym_preproc_if_token1] = ACTIONS(3371),
    [aux_sym_preproc_if_token2] = ACTIONS(3371),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3371),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3371),
    [sym_preproc_directive] = ACTIONS(3371),
    [anon_sym_LPAREN2] = ACTIONS(3373),
    [anon_sym_BANG] = ACTIONS(3373),
    [anon_sym_TILDE] = ACTIONS(3373),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_STAR] = ACTIONS(3373),
    [anon_sym_AMP_AMP] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3371),
    [anon_sym_SEMI] = ACTIONS(3373),
    [anon_sym___extension__] = ACTIONS(3371),
    [anon_sym_typedef] = ACTIONS(3371),
    [anon_sym_extern] = ACTIONS(3371),
    [anon_sym___attribute__] = ACTIONS(3371),
    [anon_sym_COLON_COLON] = ACTIONS(3373),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3373),
    [anon_sym___declspec] = ACTIONS(3371),
    [anon_sym___based] = ACTIONS(3371),
    [anon_sym___cdecl] = ACTIONS(3371),
    [anon_sym___clrcall] = ACTIONS(3371),
    [anon_sym___stdcall] = ACTIONS(3371),
    [anon_sym___fastcall] = ACTIONS(3371),
    [anon_sym___thiscall] = ACTIONS(3371),
    [anon_sym___vectorcall] = ACTIONS(3371),
    [anon_sym_LBRACE] = ACTIONS(3373),
    [anon_sym_signed] = ACTIONS(3371),
    [anon_sym_unsigned] = ACTIONS(3371),
    [anon_sym_long] = ACTIONS(3371),
    [anon_sym_short] = ACTIONS(3371),
    [anon_sym_LBRACK] = ACTIONS(3371),
    [anon_sym_static] = ACTIONS(3371),
    [anon_sym_register] = ACTIONS(3371),
    [anon_sym_inline] = ACTIONS(3371),
    [anon_sym___inline] = ACTIONS(3371),
    [anon_sym___inline__] = ACTIONS(3371),
    [anon_sym___forceinline] = ACTIONS(3371),
    [anon_sym_thread_local] = ACTIONS(3371),
    [anon_sym___thread] = ACTIONS(3371),
    [anon_sym_const] = ACTIONS(3371),
    [anon_sym_constexpr] = ACTIONS(3371),
    [anon_sym_volatile] = ACTIONS(3371),
    [anon_sym_restrict] = ACTIONS(3371),
    [anon_sym___restrict__] = ACTIONS(3371),
    [anon_sym__Atomic] = ACTIONS(3371),
    [anon_sym__Noreturn] = ACTIONS(3371),
    [anon_sym_noreturn] = ACTIONS(3371),
    [anon_sym_mutable] = ACTIONS(3371),
    [anon_sym_constinit] = ACTIONS(3371),
    [anon_sym_consteval] = ACTIONS(3371),
    [anon_sym_PROGMEM] = ACTIONS(3371),
    [aux_sym_primitive_type_token1] = ACTIONS(3371),
    [anon_sym_byte] = ACTIONS(3371),
    [anon_sym_word] = ACTIONS(3371),
    [anon_sym_enum] = ACTIONS(3371),
    [anon_sym_class] = ACTIONS(3371),
    [anon_sym_struct] = ACTIONS(3371),
    [anon_sym_union] = ACTIONS(3371),
    [anon_sym_if] = ACTIONS(3371),
    [anon_sym_switch] = ACTIONS(3371),
    [anon_sym_case] = ACTIONS(3371),
    [anon_sym_default] = ACTIONS(3371),
    [anon_sym_while] = ACTIONS(3371),
    [anon_sym_do] = ACTIONS(3371),
    [anon_sym_for] = ACTIONS(3371),
    [anon_sym_return] = ACTIONS(3371),
    [anon_sym_break] = ACTIONS(3371),
    [anon_sym_continue] = ACTIONS(3371),
    [anon_sym_goto] = ACTIONS(3371),
    [anon_sym___try] = ACTIONS(3371),
    [anon_sym___leave] = ACTIONS(3371),
    [anon_sym_not] = ACTIONS(3371),
    [anon_sym_compl] = ACTIONS(3371),
    [anon_sym_DASH_DASH] = ACTIONS(3373),
    [anon_sym_PLUS_PLUS] = ACTIONS(3373),
    [anon_sym_sizeof] = ACTIONS(3371),
    [anon_sym___alignof__] = ACTIONS(3371),
    [anon_sym___alignof] = ACTIONS(3371),
    [anon_sym__alignof] = ACTIONS(3371),
    [anon_sym_alignof] = ACTIONS(3371),
    [anon_sym__Alignof] = ACTIONS(3371),
    [anon_sym_offsetof] = ACTIONS(3371),
    [anon_sym__Generic] = ACTIONS(3371),
    [anon_sym_asm] = ACTIONS(3371),
    [anon_sym___asm__] = ACTIONS(3371),
    [aux_sym_number_literal_token1] = ACTIONS(3373),
    [aux_sym_number_literal_token2] = ACTIONS(3371),
    [anon_sym_L_SQUOTE] = ACTIONS(3373),
    [anon_sym_u_SQUOTE] = ACTIONS(3373),
    [anon_sym_U_SQUOTE] = ACTIONS(3373),
    [anon_sym_u8_SQUOTE] = ACTIONS(3373),
    [anon_sym_SQUOTE] = ACTIONS(3373),
    [anon_sym_L_DQUOTE] = ACTIONS(3373),
    [anon_sym_u_DQUOTE] = ACTIONS(3373),
    [anon_sym_U_DQUOTE] = ACTIONS(3373),
    [anon_sym_u8_DQUOTE] = ACTIONS(3373),
    [anon_sym_DQUOTE] = ACTIONS(3373),
    [sym_true] = ACTIONS(3371),
    [sym_false] = ACTIONS(3371),
    [anon_sym_NULL] = ACTIONS(3371),
    [anon_sym_nullptr] = ACTIONS(3371),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3371),
    [anon_sym_decltype] = ACTIONS(3371),
    [anon_sym_virtual] = ACTIONS(3371),
    [anon_sym_alignas] = ACTIONS(3371),
    [anon_sym_explicit] = ACTIONS(3371),
    [anon_sym_typename] = ACTIONS(3371),
    [anon_sym_template] = ACTIONS(3371),
    [anon_sym_operator] = ACTIONS(3371),
    [anon_sym_try] = ACTIONS(3371),
    [anon_sym_delete] = ACTIONS(3371),
    [anon_sym_throw] = ACTIONS(3371),
    [anon_sym_namespace] = ACTIONS(3371),
    [anon_sym_using] = ACTIONS(3371),
    [anon_sym_static_assert] = ACTIONS(3371),
    [anon_sym_concept] = ACTIONS(3371),
    [anon_sym_co_return] = ACTIONS(3371),
    [anon_sym_co_yield] = ACTIONS(3371),
    [anon_sym_R_DQUOTE] = ACTIONS(3373),
    [anon_sym_LR_DQUOTE] = ACTIONS(3373),
    [anon_sym_uR_DQUOTE] = ACTIONS(3373),
    [anon_sym_UR_DQUOTE] = ACTIONS(3373),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3373),
    [anon_sym_co_await] = ACTIONS(3371),
    [anon_sym_new] = ACTIONS(3371),
    [anon_sym_requires] = ACTIONS(3371),
    [sym_this] = ACTIONS(3371),
  },
  [981] = {
    [sym_identifier] = ACTIONS(3178),
    [aux_sym_preproc_include_token1] = ACTIONS(3178),
    [aux_sym_preproc_def_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3178),
    [sym_preproc_directive] = ACTIONS(3178),
    [anon_sym_LPAREN2] = ACTIONS(3180),
    [anon_sym_BANG] = ACTIONS(3180),
    [anon_sym_TILDE] = ACTIONS(3180),
    [anon_sym_DASH] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3178),
    [anon_sym_STAR] = ACTIONS(3180),
    [anon_sym_AMP_AMP] = ACTIONS(3180),
    [anon_sym_AMP] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3180),
    [anon_sym___extension__] = ACTIONS(3178),
    [anon_sym_typedef] = ACTIONS(3178),
    [anon_sym_extern] = ACTIONS(3178),
    [anon_sym___attribute__] = ACTIONS(3178),
    [anon_sym_COLON_COLON] = ACTIONS(3180),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3180),
    [anon_sym___declspec] = ACTIONS(3178),
    [anon_sym___based] = ACTIONS(3178),
    [anon_sym___cdecl] = ACTIONS(3178),
    [anon_sym___clrcall] = ACTIONS(3178),
    [anon_sym___stdcall] = ACTIONS(3178),
    [anon_sym___fastcall] = ACTIONS(3178),
    [anon_sym___thiscall] = ACTIONS(3178),
    [anon_sym___vectorcall] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3180),
    [anon_sym_signed] = ACTIONS(3178),
    [anon_sym_unsigned] = ACTIONS(3178),
    [anon_sym_long] = ACTIONS(3178),
    [anon_sym_short] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_static] = ACTIONS(3178),
    [anon_sym_register] = ACTIONS(3178),
    [anon_sym_inline] = ACTIONS(3178),
    [anon_sym___inline] = ACTIONS(3178),
    [anon_sym___inline__] = ACTIONS(3178),
    [anon_sym___forceinline] = ACTIONS(3178),
    [anon_sym_thread_local] = ACTIONS(3178),
    [anon_sym___thread] = ACTIONS(3178),
    [anon_sym_const] = ACTIONS(3178),
    [anon_sym_constexpr] = ACTIONS(3178),
    [anon_sym_volatile] = ACTIONS(3178),
    [anon_sym_restrict] = ACTIONS(3178),
    [anon_sym___restrict__] = ACTIONS(3178),
    [anon_sym__Atomic] = ACTIONS(3178),
    [anon_sym__Noreturn] = ACTIONS(3178),
    [anon_sym_noreturn] = ACTIONS(3178),
    [anon_sym_mutable] = ACTIONS(3178),
    [anon_sym_constinit] = ACTIONS(3178),
    [anon_sym_consteval] = ACTIONS(3178),
    [anon_sym_PROGMEM] = ACTIONS(3178),
    [aux_sym_primitive_type_token1] = ACTIONS(3178),
    [anon_sym_byte] = ACTIONS(3178),
    [anon_sym_word] = ACTIONS(3178),
    [anon_sym_enum] = ACTIONS(3178),
    [anon_sym_class] = ACTIONS(3178),
    [anon_sym_struct] = ACTIONS(3178),
    [anon_sym_union] = ACTIONS(3178),
    [anon_sym_if] = ACTIONS(3178),
    [anon_sym_switch] = ACTIONS(3178),
    [anon_sym_case] = ACTIONS(3178),
    [anon_sym_default] = ACTIONS(3178),
    [anon_sym_while] = ACTIONS(3178),
    [anon_sym_do] = ACTIONS(3178),
    [anon_sym_for] = ACTIONS(3178),
    [anon_sym_return] = ACTIONS(3178),
    [anon_sym_break] = ACTIONS(3178),
    [anon_sym_continue] = ACTIONS(3178),
    [anon_sym_goto] = ACTIONS(3178),
    [anon_sym___try] = ACTIONS(3178),
    [anon_sym___leave] = ACTIONS(3178),
    [anon_sym_not] = ACTIONS(3178),
    [anon_sym_compl] = ACTIONS(3178),
    [anon_sym_DASH_DASH] = ACTIONS(3180),
    [anon_sym_PLUS_PLUS] = ACTIONS(3180),
    [anon_sym_sizeof] = ACTIONS(3178),
    [anon_sym___alignof__] = ACTIONS(3178),
    [anon_sym___alignof] = ACTIONS(3178),
    [anon_sym__alignof] = ACTIONS(3178),
    [anon_sym_alignof] = ACTIONS(3178),
    [anon_sym__Alignof] = ACTIONS(3178),
    [anon_sym_offsetof] = ACTIONS(3178),
    [anon_sym__Generic] = ACTIONS(3178),
    [anon_sym_asm] = ACTIONS(3178),
    [anon_sym___asm__] = ACTIONS(3178),
    [aux_sym_number_literal_token1] = ACTIONS(3180),
    [aux_sym_number_literal_token2] = ACTIONS(3178),
    [anon_sym_L_SQUOTE] = ACTIONS(3180),
    [anon_sym_u_SQUOTE] = ACTIONS(3180),
    [anon_sym_U_SQUOTE] = ACTIONS(3180),
    [anon_sym_u8_SQUOTE] = ACTIONS(3180),
    [anon_sym_SQUOTE] = ACTIONS(3180),
    [anon_sym_L_DQUOTE] = ACTIONS(3180),
    [anon_sym_u_DQUOTE] = ACTIONS(3180),
    [anon_sym_U_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8_DQUOTE] = ACTIONS(3180),
    [anon_sym_DQUOTE] = ACTIONS(3180),
    [sym_true] = ACTIONS(3178),
    [sym_false] = ACTIONS(3178),
    [anon_sym_NULL] = ACTIONS(3178),
    [anon_sym_nullptr] = ACTIONS(3178),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3178),
    [anon_sym_decltype] = ACTIONS(3178),
    [anon_sym_virtual] = ACTIONS(3178),
    [anon_sym_alignas] = ACTIONS(3178),
    [anon_sym_explicit] = ACTIONS(3178),
    [anon_sym_typename] = ACTIONS(3178),
    [anon_sym_template] = ACTIONS(3178),
    [anon_sym_operator] = ACTIONS(3178),
    [anon_sym_try] = ACTIONS(3178),
    [anon_sym_delete] = ACTIONS(3178),
    [anon_sym_throw] = ACTIONS(3178),
    [anon_sym_namespace] = ACTIONS(3178),
    [anon_sym_using] = ACTIONS(3178),
    [anon_sym_static_assert] = ACTIONS(3178),
    [anon_sym_concept] = ACTIONS(3178),
    [anon_sym_co_return] = ACTIONS(3178),
    [anon_sym_co_yield] = ACTIONS(3178),
    [anon_sym_R_DQUOTE] = ACTIONS(3180),
    [anon_sym_LR_DQUOTE] = ACTIONS(3180),
    [anon_sym_uR_DQUOTE] = ACTIONS(3180),
    [anon_sym_UR_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3180),
    [anon_sym_co_await] = ACTIONS(3178),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3178),
    [sym_this] = ACTIONS(3178),
  },
  [982] = {
    [sym_identifier] = ACTIONS(3503),
    [aux_sym_preproc_include_token1] = ACTIONS(3503),
    [aux_sym_preproc_def_token1] = ACTIONS(3503),
    [aux_sym_preproc_if_token1] = ACTIONS(3503),
    [aux_sym_preproc_if_token2] = ACTIONS(3503),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3503),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3503),
    [sym_preproc_directive] = ACTIONS(3503),
    [anon_sym_LPAREN2] = ACTIONS(3505),
    [anon_sym_BANG] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3503),
    [anon_sym_PLUS] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP] = ACTIONS(3503),
    [anon_sym_SEMI] = ACTIONS(3505),
    [anon_sym___extension__] = ACTIONS(3503),
    [anon_sym_typedef] = ACTIONS(3503),
    [anon_sym_extern] = ACTIONS(3503),
    [anon_sym___attribute__] = ACTIONS(3503),
    [anon_sym_COLON_COLON] = ACTIONS(3505),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3505),
    [anon_sym___declspec] = ACTIONS(3503),
    [anon_sym___based] = ACTIONS(3503),
    [anon_sym___cdecl] = ACTIONS(3503),
    [anon_sym___clrcall] = ACTIONS(3503),
    [anon_sym___stdcall] = ACTIONS(3503),
    [anon_sym___fastcall] = ACTIONS(3503),
    [anon_sym___thiscall] = ACTIONS(3503),
    [anon_sym___vectorcall] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_signed] = ACTIONS(3503),
    [anon_sym_unsigned] = ACTIONS(3503),
    [anon_sym_long] = ACTIONS(3503),
    [anon_sym_short] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3503),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_register] = ACTIONS(3503),
    [anon_sym_inline] = ACTIONS(3503),
    [anon_sym___inline] = ACTIONS(3503),
    [anon_sym___inline__] = ACTIONS(3503),
    [anon_sym___forceinline] = ACTIONS(3503),
    [anon_sym_thread_local] = ACTIONS(3503),
    [anon_sym___thread] = ACTIONS(3503),
    [anon_sym_const] = ACTIONS(3503),
    [anon_sym_constexpr] = ACTIONS(3503),
    [anon_sym_volatile] = ACTIONS(3503),
    [anon_sym_restrict] = ACTIONS(3503),
    [anon_sym___restrict__] = ACTIONS(3503),
    [anon_sym__Atomic] = ACTIONS(3503),
    [anon_sym__Noreturn] = ACTIONS(3503),
    [anon_sym_noreturn] = ACTIONS(3503),
    [anon_sym_mutable] = ACTIONS(3503),
    [anon_sym_constinit] = ACTIONS(3503),
    [anon_sym_consteval] = ACTIONS(3503),
    [anon_sym_PROGMEM] = ACTIONS(3503),
    [aux_sym_primitive_type_token1] = ACTIONS(3503),
    [anon_sym_byte] = ACTIONS(3503),
    [anon_sym_word] = ACTIONS(3503),
    [anon_sym_enum] = ACTIONS(3503),
    [anon_sym_class] = ACTIONS(3503),
    [anon_sym_struct] = ACTIONS(3503),
    [anon_sym_union] = ACTIONS(3503),
    [anon_sym_if] = ACTIONS(3503),
    [anon_sym_switch] = ACTIONS(3503),
    [anon_sym_case] = ACTIONS(3503),
    [anon_sym_default] = ACTIONS(3503),
    [anon_sym_while] = ACTIONS(3503),
    [anon_sym_do] = ACTIONS(3503),
    [anon_sym_for] = ACTIONS(3503),
    [anon_sym_return] = ACTIONS(3503),
    [anon_sym_break] = ACTIONS(3503),
    [anon_sym_continue] = ACTIONS(3503),
    [anon_sym_goto] = ACTIONS(3503),
    [anon_sym___try] = ACTIONS(3503),
    [anon_sym___leave] = ACTIONS(3503),
    [anon_sym_not] = ACTIONS(3503),
    [anon_sym_compl] = ACTIONS(3503),
    [anon_sym_DASH_DASH] = ACTIONS(3505),
    [anon_sym_PLUS_PLUS] = ACTIONS(3505),
    [anon_sym_sizeof] = ACTIONS(3503),
    [anon_sym___alignof__] = ACTIONS(3503),
    [anon_sym___alignof] = ACTIONS(3503),
    [anon_sym__alignof] = ACTIONS(3503),
    [anon_sym_alignof] = ACTIONS(3503),
    [anon_sym__Alignof] = ACTIONS(3503),
    [anon_sym_offsetof] = ACTIONS(3503),
    [anon_sym__Generic] = ACTIONS(3503),
    [anon_sym_asm] = ACTIONS(3503),
    [anon_sym___asm__] = ACTIONS(3503),
    [aux_sym_number_literal_token1] = ACTIONS(3505),
    [aux_sym_number_literal_token2] = ACTIONS(3503),
    [anon_sym_L_SQUOTE] = ACTIONS(3505),
    [anon_sym_u_SQUOTE] = ACTIONS(3505),
    [anon_sym_U_SQUOTE] = ACTIONS(3505),
    [anon_sym_u8_SQUOTE] = ACTIONS(3505),
    [anon_sym_SQUOTE] = ACTIONS(3505),
    [anon_sym_L_DQUOTE] = ACTIONS(3505),
    [anon_sym_u_DQUOTE] = ACTIONS(3505),
    [anon_sym_U_DQUOTE] = ACTIONS(3505),
    [anon_sym_u8_DQUOTE] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [sym_true] = ACTIONS(3503),
    [sym_false] = ACTIONS(3503),
    [anon_sym_NULL] = ACTIONS(3503),
    [anon_sym_nullptr] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3503),
    [anon_sym_decltype] = ACTIONS(3503),
    [anon_sym_virtual] = ACTIONS(3503),
    [anon_sym_alignas] = ACTIONS(3503),
    [anon_sym_explicit] = ACTIONS(3503),
    [anon_sym_typename] = ACTIONS(3503),
    [anon_sym_template] = ACTIONS(3503),
    [anon_sym_operator] = ACTIONS(3503),
    [anon_sym_try] = ACTIONS(3503),
    [anon_sym_delete] = ACTIONS(3503),
    [anon_sym_throw] = ACTIONS(3503),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_using] = ACTIONS(3503),
    [anon_sym_static_assert] = ACTIONS(3503),
    [anon_sym_concept] = ACTIONS(3503),
    [anon_sym_co_return] = ACTIONS(3503),
    [anon_sym_co_yield] = ACTIONS(3503),
    [anon_sym_R_DQUOTE] = ACTIONS(3505),
    [anon_sym_LR_DQUOTE] = ACTIONS(3505),
    [anon_sym_uR_DQUOTE] = ACTIONS(3505),
    [anon_sym_UR_DQUOTE] = ACTIONS(3505),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3505),
    [anon_sym_co_await] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3503),
    [anon_sym_requires] = ACTIONS(3503),
    [sym_this] = ACTIONS(3503),
  },
  [983] = {
    [sym_identifier] = ACTIONS(3346),
    [aux_sym_preproc_include_token1] = ACTIONS(3346),
    [aux_sym_preproc_def_token1] = ACTIONS(3346),
    [aux_sym_preproc_if_token1] = ACTIONS(3346),
    [aux_sym_preproc_if_token2] = ACTIONS(3346),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3346),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3346),
    [sym_preproc_directive] = ACTIONS(3346),
    [anon_sym_LPAREN2] = ACTIONS(3348),
    [anon_sym_BANG] = ACTIONS(3348),
    [anon_sym_TILDE] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3348),
    [anon_sym_AMP_AMP] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym_SEMI] = ACTIONS(3348),
    [anon_sym___extension__] = ACTIONS(3346),
    [anon_sym_typedef] = ACTIONS(3346),
    [anon_sym_extern] = ACTIONS(3346),
    [anon_sym___attribute__] = ACTIONS(3346),
    [anon_sym_COLON_COLON] = ACTIONS(3348),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3348),
    [anon_sym___declspec] = ACTIONS(3346),
    [anon_sym___based] = ACTIONS(3346),
    [anon_sym___cdecl] = ACTIONS(3346),
    [anon_sym___clrcall] = ACTIONS(3346),
    [anon_sym___stdcall] = ACTIONS(3346),
    [anon_sym___fastcall] = ACTIONS(3346),
    [anon_sym___thiscall] = ACTIONS(3346),
    [anon_sym___vectorcall] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3348),
    [anon_sym_signed] = ACTIONS(3346),
    [anon_sym_unsigned] = ACTIONS(3346),
    [anon_sym_long] = ACTIONS(3346),
    [anon_sym_short] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3346),
    [anon_sym_register] = ACTIONS(3346),
    [anon_sym_inline] = ACTIONS(3346),
    [anon_sym___inline] = ACTIONS(3346),
    [anon_sym___inline__] = ACTIONS(3346),
    [anon_sym___forceinline] = ACTIONS(3346),
    [anon_sym_thread_local] = ACTIONS(3346),
    [anon_sym___thread] = ACTIONS(3346),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_constexpr] = ACTIONS(3346),
    [anon_sym_volatile] = ACTIONS(3346),
    [anon_sym_restrict] = ACTIONS(3346),
    [anon_sym___restrict__] = ACTIONS(3346),
    [anon_sym__Atomic] = ACTIONS(3346),
    [anon_sym__Noreturn] = ACTIONS(3346),
    [anon_sym_noreturn] = ACTIONS(3346),
    [anon_sym_mutable] = ACTIONS(3346),
    [anon_sym_constinit] = ACTIONS(3346),
    [anon_sym_consteval] = ACTIONS(3346),
    [anon_sym_PROGMEM] = ACTIONS(3346),
    [aux_sym_primitive_type_token1] = ACTIONS(3346),
    [anon_sym_byte] = ACTIONS(3346),
    [anon_sym_word] = ACTIONS(3346),
    [anon_sym_enum] = ACTIONS(3346),
    [anon_sym_class] = ACTIONS(3346),
    [anon_sym_struct] = ACTIONS(3346),
    [anon_sym_union] = ACTIONS(3346),
    [anon_sym_if] = ACTIONS(3346),
    [anon_sym_switch] = ACTIONS(3346),
    [anon_sym_case] = ACTIONS(3346),
    [anon_sym_default] = ACTIONS(3346),
    [anon_sym_while] = ACTIONS(3346),
    [anon_sym_do] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3346),
    [anon_sym_return] = ACTIONS(3346),
    [anon_sym_break] = ACTIONS(3346),
    [anon_sym_continue] = ACTIONS(3346),
    [anon_sym_goto] = ACTIONS(3346),
    [anon_sym___try] = ACTIONS(3346),
    [anon_sym___leave] = ACTIONS(3346),
    [anon_sym_not] = ACTIONS(3346),
    [anon_sym_compl] = ACTIONS(3346),
    [anon_sym_DASH_DASH] = ACTIONS(3348),
    [anon_sym_PLUS_PLUS] = ACTIONS(3348),
    [anon_sym_sizeof] = ACTIONS(3346),
    [anon_sym___alignof__] = ACTIONS(3346),
    [anon_sym___alignof] = ACTIONS(3346),
    [anon_sym__alignof] = ACTIONS(3346),
    [anon_sym_alignof] = ACTIONS(3346),
    [anon_sym__Alignof] = ACTIONS(3346),
    [anon_sym_offsetof] = ACTIONS(3346),
    [anon_sym__Generic] = ACTIONS(3346),
    [anon_sym_asm] = ACTIONS(3346),
    [anon_sym___asm__] = ACTIONS(3346),
    [aux_sym_number_literal_token1] = ACTIONS(3348),
    [aux_sym_number_literal_token2] = ACTIONS(3346),
    [anon_sym_L_SQUOTE] = ACTIONS(3348),
    [anon_sym_u_SQUOTE] = ACTIONS(3348),
    [anon_sym_U_SQUOTE] = ACTIONS(3348),
    [anon_sym_u8_SQUOTE] = ACTIONS(3348),
    [anon_sym_SQUOTE] = ACTIONS(3348),
    [anon_sym_L_DQUOTE] = ACTIONS(3348),
    [anon_sym_u_DQUOTE] = ACTIONS(3348),
    [anon_sym_U_DQUOTE] = ACTIONS(3348),
    [anon_sym_u8_DQUOTE] = ACTIONS(3348),
    [anon_sym_DQUOTE] = ACTIONS(3348),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [anon_sym_NULL] = ACTIONS(3346),
    [anon_sym_nullptr] = ACTIONS(3346),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3346),
    [anon_sym_decltype] = ACTIONS(3346),
    [anon_sym_virtual] = ACTIONS(3346),
    [anon_sym_alignas] = ACTIONS(3346),
    [anon_sym_explicit] = ACTIONS(3346),
    [anon_sym_typename] = ACTIONS(3346),
    [anon_sym_template] = ACTIONS(3346),
    [anon_sym_operator] = ACTIONS(3346),
    [anon_sym_try] = ACTIONS(3346),
    [anon_sym_delete] = ACTIONS(3346),
    [anon_sym_throw] = ACTIONS(3346),
    [anon_sym_namespace] = ACTIONS(3346),
    [anon_sym_using] = ACTIONS(3346),
    [anon_sym_static_assert] = ACTIONS(3346),
    [anon_sym_concept] = ACTIONS(3346),
    [anon_sym_co_return] = ACTIONS(3346),
    [anon_sym_co_yield] = ACTIONS(3346),
    [anon_sym_R_DQUOTE] = ACTIONS(3348),
    [anon_sym_LR_DQUOTE] = ACTIONS(3348),
    [anon_sym_uR_DQUOTE] = ACTIONS(3348),
    [anon_sym_UR_DQUOTE] = ACTIONS(3348),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3348),
    [anon_sym_co_await] = ACTIONS(3346),
    [anon_sym_new] = ACTIONS(3346),
    [anon_sym_requires] = ACTIONS(3346),
    [sym_this] = ACTIONS(3346),
  },
  [984] = {
    [sym_identifier] = ACTIONS(3447),
    [aux_sym_preproc_include_token1] = ACTIONS(3447),
    [aux_sym_preproc_def_token1] = ACTIONS(3447),
    [aux_sym_preproc_if_token1] = ACTIONS(3447),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3447),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3447),
    [sym_preproc_directive] = ACTIONS(3447),
    [anon_sym_LPAREN2] = ACTIONS(3449),
    [anon_sym_BANG] = ACTIONS(3449),
    [anon_sym_TILDE] = ACTIONS(3449),
    [anon_sym_DASH] = ACTIONS(3447),
    [anon_sym_PLUS] = ACTIONS(3447),
    [anon_sym_STAR] = ACTIONS(3449),
    [anon_sym_AMP_AMP] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3447),
    [anon_sym_SEMI] = ACTIONS(3449),
    [anon_sym___extension__] = ACTIONS(3447),
    [anon_sym_typedef] = ACTIONS(3447),
    [anon_sym_extern] = ACTIONS(3447),
    [anon_sym___attribute__] = ACTIONS(3447),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3449),
    [anon_sym___declspec] = ACTIONS(3447),
    [anon_sym___based] = ACTIONS(3447),
    [anon_sym___cdecl] = ACTIONS(3447),
    [anon_sym___clrcall] = ACTIONS(3447),
    [anon_sym___stdcall] = ACTIONS(3447),
    [anon_sym___fastcall] = ACTIONS(3447),
    [anon_sym___thiscall] = ACTIONS(3447),
    [anon_sym___vectorcall] = ACTIONS(3447),
    [anon_sym_LBRACE] = ACTIONS(3449),
    [anon_sym_RBRACE] = ACTIONS(3449),
    [anon_sym_signed] = ACTIONS(3447),
    [anon_sym_unsigned] = ACTIONS(3447),
    [anon_sym_long] = ACTIONS(3447),
    [anon_sym_short] = ACTIONS(3447),
    [anon_sym_LBRACK] = ACTIONS(3447),
    [anon_sym_static] = ACTIONS(3447),
    [anon_sym_register] = ACTIONS(3447),
    [anon_sym_inline] = ACTIONS(3447),
    [anon_sym___inline] = ACTIONS(3447),
    [anon_sym___inline__] = ACTIONS(3447),
    [anon_sym___forceinline] = ACTIONS(3447),
    [anon_sym_thread_local] = ACTIONS(3447),
    [anon_sym___thread] = ACTIONS(3447),
    [anon_sym_const] = ACTIONS(3447),
    [anon_sym_constexpr] = ACTIONS(3447),
    [anon_sym_volatile] = ACTIONS(3447),
    [anon_sym_restrict] = ACTIONS(3447),
    [anon_sym___restrict__] = ACTIONS(3447),
    [anon_sym__Atomic] = ACTIONS(3447),
    [anon_sym__Noreturn] = ACTIONS(3447),
    [anon_sym_noreturn] = ACTIONS(3447),
    [anon_sym_mutable] = ACTIONS(3447),
    [anon_sym_constinit] = ACTIONS(3447),
    [anon_sym_consteval] = ACTIONS(3447),
    [anon_sym_PROGMEM] = ACTIONS(3447),
    [aux_sym_primitive_type_token1] = ACTIONS(3447),
    [anon_sym_byte] = ACTIONS(3447),
    [anon_sym_word] = ACTIONS(3447),
    [anon_sym_enum] = ACTIONS(3447),
    [anon_sym_class] = ACTIONS(3447),
    [anon_sym_struct] = ACTIONS(3447),
    [anon_sym_union] = ACTIONS(3447),
    [anon_sym_if] = ACTIONS(3447),
    [anon_sym_switch] = ACTIONS(3447),
    [anon_sym_case] = ACTIONS(3447),
    [anon_sym_default] = ACTIONS(3447),
    [anon_sym_while] = ACTIONS(3447),
    [anon_sym_do] = ACTIONS(3447),
    [anon_sym_for] = ACTIONS(3447),
    [anon_sym_return] = ACTIONS(3447),
    [anon_sym_break] = ACTIONS(3447),
    [anon_sym_continue] = ACTIONS(3447),
    [anon_sym_goto] = ACTIONS(3447),
    [anon_sym___try] = ACTIONS(3447),
    [anon_sym___leave] = ACTIONS(3447),
    [anon_sym_not] = ACTIONS(3447),
    [anon_sym_compl] = ACTIONS(3447),
    [anon_sym_DASH_DASH] = ACTIONS(3449),
    [anon_sym_PLUS_PLUS] = ACTIONS(3449),
    [anon_sym_sizeof] = ACTIONS(3447),
    [anon_sym___alignof__] = ACTIONS(3447),
    [anon_sym___alignof] = ACTIONS(3447),
    [anon_sym__alignof] = ACTIONS(3447),
    [anon_sym_alignof] = ACTIONS(3447),
    [anon_sym__Alignof] = ACTIONS(3447),
    [anon_sym_offsetof] = ACTIONS(3447),
    [anon_sym__Generic] = ACTIONS(3447),
    [anon_sym_asm] = ACTIONS(3447),
    [anon_sym___asm__] = ACTIONS(3447),
    [aux_sym_number_literal_token1] = ACTIONS(3449),
    [aux_sym_number_literal_token2] = ACTIONS(3447),
    [anon_sym_L_SQUOTE] = ACTIONS(3449),
    [anon_sym_u_SQUOTE] = ACTIONS(3449),
    [anon_sym_U_SQUOTE] = ACTIONS(3449),
    [anon_sym_u8_SQUOTE] = ACTIONS(3449),
    [anon_sym_SQUOTE] = ACTIONS(3449),
    [anon_sym_L_DQUOTE] = ACTIONS(3449),
    [anon_sym_u_DQUOTE] = ACTIONS(3449),
    [anon_sym_U_DQUOTE] = ACTIONS(3449),
    [anon_sym_u8_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE] = ACTIONS(3449),
    [sym_true] = ACTIONS(3447),
    [sym_false] = ACTIONS(3447),
    [anon_sym_NULL] = ACTIONS(3447),
    [anon_sym_nullptr] = ACTIONS(3447),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3447),
    [anon_sym_decltype] = ACTIONS(3447),
    [anon_sym_virtual] = ACTIONS(3447),
    [anon_sym_alignas] = ACTIONS(3447),
    [anon_sym_explicit] = ACTIONS(3447),
    [anon_sym_typename] = ACTIONS(3447),
    [anon_sym_template] = ACTIONS(3447),
    [anon_sym_operator] = ACTIONS(3447),
    [anon_sym_try] = ACTIONS(3447),
    [anon_sym_delete] = ACTIONS(3447),
    [anon_sym_throw] = ACTIONS(3447),
    [anon_sym_namespace] = ACTIONS(3447),
    [anon_sym_using] = ACTIONS(3447),
    [anon_sym_static_assert] = ACTIONS(3447),
    [anon_sym_concept] = ACTIONS(3447),
    [anon_sym_co_return] = ACTIONS(3447),
    [anon_sym_co_yield] = ACTIONS(3447),
    [anon_sym_R_DQUOTE] = ACTIONS(3449),
    [anon_sym_LR_DQUOTE] = ACTIONS(3449),
    [anon_sym_uR_DQUOTE] = ACTIONS(3449),
    [anon_sym_UR_DQUOTE] = ACTIONS(3449),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3449),
    [anon_sym_co_await] = ACTIONS(3447),
    [anon_sym_new] = ACTIONS(3447),
    [anon_sym_requires] = ACTIONS(3447),
    [sym_this] = ACTIONS(3447),
  },
  [985] = {
    [sym_identifier] = ACTIONS(3328),
    [aux_sym_preproc_include_token1] = ACTIONS(3328),
    [aux_sym_preproc_def_token1] = ACTIONS(3328),
    [aux_sym_preproc_if_token1] = ACTIONS(3328),
    [aux_sym_preproc_if_token2] = ACTIONS(3328),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3328),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3328),
    [sym_preproc_directive] = ACTIONS(3328),
    [anon_sym_LPAREN2] = ACTIONS(3330),
    [anon_sym_BANG] = ACTIONS(3330),
    [anon_sym_TILDE] = ACTIONS(3330),
    [anon_sym_DASH] = ACTIONS(3328),
    [anon_sym_PLUS] = ACTIONS(3328),
    [anon_sym_STAR] = ACTIONS(3330),
    [anon_sym_AMP_AMP] = ACTIONS(3330),
    [anon_sym_AMP] = ACTIONS(3328),
    [anon_sym_SEMI] = ACTIONS(3330),
    [anon_sym___extension__] = ACTIONS(3328),
    [anon_sym_typedef] = ACTIONS(3328),
    [anon_sym_extern] = ACTIONS(3328),
    [anon_sym___attribute__] = ACTIONS(3328),
    [anon_sym_COLON_COLON] = ACTIONS(3330),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3330),
    [anon_sym___declspec] = ACTIONS(3328),
    [anon_sym___based] = ACTIONS(3328),
    [anon_sym___cdecl] = ACTIONS(3328),
    [anon_sym___clrcall] = ACTIONS(3328),
    [anon_sym___stdcall] = ACTIONS(3328),
    [anon_sym___fastcall] = ACTIONS(3328),
    [anon_sym___thiscall] = ACTIONS(3328),
    [anon_sym___vectorcall] = ACTIONS(3328),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_signed] = ACTIONS(3328),
    [anon_sym_unsigned] = ACTIONS(3328),
    [anon_sym_long] = ACTIONS(3328),
    [anon_sym_short] = ACTIONS(3328),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_static] = ACTIONS(3328),
    [anon_sym_register] = ACTIONS(3328),
    [anon_sym_inline] = ACTIONS(3328),
    [anon_sym___inline] = ACTIONS(3328),
    [anon_sym___inline__] = ACTIONS(3328),
    [anon_sym___forceinline] = ACTIONS(3328),
    [anon_sym_thread_local] = ACTIONS(3328),
    [anon_sym___thread] = ACTIONS(3328),
    [anon_sym_const] = ACTIONS(3328),
    [anon_sym_constexpr] = ACTIONS(3328),
    [anon_sym_volatile] = ACTIONS(3328),
    [anon_sym_restrict] = ACTIONS(3328),
    [anon_sym___restrict__] = ACTIONS(3328),
    [anon_sym__Atomic] = ACTIONS(3328),
    [anon_sym__Noreturn] = ACTIONS(3328),
    [anon_sym_noreturn] = ACTIONS(3328),
    [anon_sym_mutable] = ACTIONS(3328),
    [anon_sym_constinit] = ACTIONS(3328),
    [anon_sym_consteval] = ACTIONS(3328),
    [anon_sym_PROGMEM] = ACTIONS(3328),
    [aux_sym_primitive_type_token1] = ACTIONS(3328),
    [anon_sym_byte] = ACTIONS(3328),
    [anon_sym_word] = ACTIONS(3328),
    [anon_sym_enum] = ACTIONS(3328),
    [anon_sym_class] = ACTIONS(3328),
    [anon_sym_struct] = ACTIONS(3328),
    [anon_sym_union] = ACTIONS(3328),
    [anon_sym_if] = ACTIONS(3328),
    [anon_sym_switch] = ACTIONS(3328),
    [anon_sym_case] = ACTIONS(3328),
    [anon_sym_default] = ACTIONS(3328),
    [anon_sym_while] = ACTIONS(3328),
    [anon_sym_do] = ACTIONS(3328),
    [anon_sym_for] = ACTIONS(3328),
    [anon_sym_return] = ACTIONS(3328),
    [anon_sym_break] = ACTIONS(3328),
    [anon_sym_continue] = ACTIONS(3328),
    [anon_sym_goto] = ACTIONS(3328),
    [anon_sym___try] = ACTIONS(3328),
    [anon_sym___leave] = ACTIONS(3328),
    [anon_sym_not] = ACTIONS(3328),
    [anon_sym_compl] = ACTIONS(3328),
    [anon_sym_DASH_DASH] = ACTIONS(3330),
    [anon_sym_PLUS_PLUS] = ACTIONS(3330),
    [anon_sym_sizeof] = ACTIONS(3328),
    [anon_sym___alignof__] = ACTIONS(3328),
    [anon_sym___alignof] = ACTIONS(3328),
    [anon_sym__alignof] = ACTIONS(3328),
    [anon_sym_alignof] = ACTIONS(3328),
    [anon_sym__Alignof] = ACTIONS(3328),
    [anon_sym_offsetof] = ACTIONS(3328),
    [anon_sym__Generic] = ACTIONS(3328),
    [anon_sym_asm] = ACTIONS(3328),
    [anon_sym___asm__] = ACTIONS(3328),
    [aux_sym_number_literal_token1] = ACTIONS(3330),
    [aux_sym_number_literal_token2] = ACTIONS(3328),
    [anon_sym_L_SQUOTE] = ACTIONS(3330),
    [anon_sym_u_SQUOTE] = ACTIONS(3330),
    [anon_sym_U_SQUOTE] = ACTIONS(3330),
    [anon_sym_u8_SQUOTE] = ACTIONS(3330),
    [anon_sym_SQUOTE] = ACTIONS(3330),
    [anon_sym_L_DQUOTE] = ACTIONS(3330),
    [anon_sym_u_DQUOTE] = ACTIONS(3330),
    [anon_sym_U_DQUOTE] = ACTIONS(3330),
    [anon_sym_u8_DQUOTE] = ACTIONS(3330),
    [anon_sym_DQUOTE] = ACTIONS(3330),
    [sym_true] = ACTIONS(3328),
    [sym_false] = ACTIONS(3328),
    [anon_sym_NULL] = ACTIONS(3328),
    [anon_sym_nullptr] = ACTIONS(3328),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3328),
    [anon_sym_decltype] = ACTIONS(3328),
    [anon_sym_virtual] = ACTIONS(3328),
    [anon_sym_alignas] = ACTIONS(3328),
    [anon_sym_explicit] = ACTIONS(3328),
    [anon_sym_typename] = ACTIONS(3328),
    [anon_sym_template] = ACTIONS(3328),
    [anon_sym_operator] = ACTIONS(3328),
    [anon_sym_try] = ACTIONS(3328),
    [anon_sym_delete] = ACTIONS(3328),
    [anon_sym_throw] = ACTIONS(3328),
    [anon_sym_namespace] = ACTIONS(3328),
    [anon_sym_using] = ACTIONS(3328),
    [anon_sym_static_assert] = ACTIONS(3328),
    [anon_sym_concept] = ACTIONS(3328),
    [anon_sym_co_return] = ACTIONS(3328),
    [anon_sym_co_yield] = ACTIONS(3328),
    [anon_sym_R_DQUOTE] = ACTIONS(3330),
    [anon_sym_LR_DQUOTE] = ACTIONS(3330),
    [anon_sym_uR_DQUOTE] = ACTIONS(3330),
    [anon_sym_UR_DQUOTE] = ACTIONS(3330),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3330),
    [anon_sym_co_await] = ACTIONS(3328),
    [anon_sym_new] = ACTIONS(3328),
    [anon_sym_requires] = ACTIONS(3328),
    [sym_this] = ACTIONS(3328),
  },
  [986] = {
    [sym_identifier] = ACTIONS(3324),
    [aux_sym_preproc_include_token1] = ACTIONS(3324),
    [aux_sym_preproc_def_token1] = ACTIONS(3324),
    [aux_sym_preproc_if_token1] = ACTIONS(3324),
    [aux_sym_preproc_if_token2] = ACTIONS(3324),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3324),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3324),
    [sym_preproc_directive] = ACTIONS(3324),
    [anon_sym_LPAREN2] = ACTIONS(3326),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_DASH] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3326),
    [anon_sym_AMP_AMP] = ACTIONS(3326),
    [anon_sym_AMP] = ACTIONS(3324),
    [anon_sym_SEMI] = ACTIONS(3326),
    [anon_sym___extension__] = ACTIONS(3324),
    [anon_sym_typedef] = ACTIONS(3324),
    [anon_sym_extern] = ACTIONS(3324),
    [anon_sym___attribute__] = ACTIONS(3324),
    [anon_sym_COLON_COLON] = ACTIONS(3326),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3326),
    [anon_sym___declspec] = ACTIONS(3324),
    [anon_sym___based] = ACTIONS(3324),
    [anon_sym___cdecl] = ACTIONS(3324),
    [anon_sym___clrcall] = ACTIONS(3324),
    [anon_sym___stdcall] = ACTIONS(3324),
    [anon_sym___fastcall] = ACTIONS(3324),
    [anon_sym___thiscall] = ACTIONS(3324),
    [anon_sym___vectorcall] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3326),
    [anon_sym_signed] = ACTIONS(3324),
    [anon_sym_unsigned] = ACTIONS(3324),
    [anon_sym_long] = ACTIONS(3324),
    [anon_sym_short] = ACTIONS(3324),
    [anon_sym_LBRACK] = ACTIONS(3324),
    [anon_sym_static] = ACTIONS(3324),
    [anon_sym_register] = ACTIONS(3324),
    [anon_sym_inline] = ACTIONS(3324),
    [anon_sym___inline] = ACTIONS(3324),
    [anon_sym___inline__] = ACTIONS(3324),
    [anon_sym___forceinline] = ACTIONS(3324),
    [anon_sym_thread_local] = ACTIONS(3324),
    [anon_sym___thread] = ACTIONS(3324),
    [anon_sym_const] = ACTIONS(3324),
    [anon_sym_constexpr] = ACTIONS(3324),
    [anon_sym_volatile] = ACTIONS(3324),
    [anon_sym_restrict] = ACTIONS(3324),
    [anon_sym___restrict__] = ACTIONS(3324),
    [anon_sym__Atomic] = ACTIONS(3324),
    [anon_sym__Noreturn] = ACTIONS(3324),
    [anon_sym_noreturn] = ACTIONS(3324),
    [anon_sym_mutable] = ACTIONS(3324),
    [anon_sym_constinit] = ACTIONS(3324),
    [anon_sym_consteval] = ACTIONS(3324),
    [anon_sym_PROGMEM] = ACTIONS(3324),
    [aux_sym_primitive_type_token1] = ACTIONS(3324),
    [anon_sym_byte] = ACTIONS(3324),
    [anon_sym_word] = ACTIONS(3324),
    [anon_sym_enum] = ACTIONS(3324),
    [anon_sym_class] = ACTIONS(3324),
    [anon_sym_struct] = ACTIONS(3324),
    [anon_sym_union] = ACTIONS(3324),
    [anon_sym_if] = ACTIONS(3324),
    [anon_sym_switch] = ACTIONS(3324),
    [anon_sym_case] = ACTIONS(3324),
    [anon_sym_default] = ACTIONS(3324),
    [anon_sym_while] = ACTIONS(3324),
    [anon_sym_do] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3324),
    [anon_sym_return] = ACTIONS(3324),
    [anon_sym_break] = ACTIONS(3324),
    [anon_sym_continue] = ACTIONS(3324),
    [anon_sym_goto] = ACTIONS(3324),
    [anon_sym___try] = ACTIONS(3324),
    [anon_sym___leave] = ACTIONS(3324),
    [anon_sym_not] = ACTIONS(3324),
    [anon_sym_compl] = ACTIONS(3324),
    [anon_sym_DASH_DASH] = ACTIONS(3326),
    [anon_sym_PLUS_PLUS] = ACTIONS(3326),
    [anon_sym_sizeof] = ACTIONS(3324),
    [anon_sym___alignof__] = ACTIONS(3324),
    [anon_sym___alignof] = ACTIONS(3324),
    [anon_sym__alignof] = ACTIONS(3324),
    [anon_sym_alignof] = ACTIONS(3324),
    [anon_sym__Alignof] = ACTIONS(3324),
    [anon_sym_offsetof] = ACTIONS(3324),
    [anon_sym__Generic] = ACTIONS(3324),
    [anon_sym_asm] = ACTIONS(3324),
    [anon_sym___asm__] = ACTIONS(3324),
    [aux_sym_number_literal_token1] = ACTIONS(3326),
    [aux_sym_number_literal_token2] = ACTIONS(3324),
    [anon_sym_L_SQUOTE] = ACTIONS(3326),
    [anon_sym_u_SQUOTE] = ACTIONS(3326),
    [anon_sym_U_SQUOTE] = ACTIONS(3326),
    [anon_sym_u8_SQUOTE] = ACTIONS(3326),
    [anon_sym_SQUOTE] = ACTIONS(3326),
    [anon_sym_L_DQUOTE] = ACTIONS(3326),
    [anon_sym_u_DQUOTE] = ACTIONS(3326),
    [anon_sym_U_DQUOTE] = ACTIONS(3326),
    [anon_sym_u8_DQUOTE] = ACTIONS(3326),
    [anon_sym_DQUOTE] = ACTIONS(3326),
    [sym_true] = ACTIONS(3324),
    [sym_false] = ACTIONS(3324),
    [anon_sym_NULL] = ACTIONS(3324),
    [anon_sym_nullptr] = ACTIONS(3324),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3324),
    [anon_sym_decltype] = ACTIONS(3324),
    [anon_sym_virtual] = ACTIONS(3324),
    [anon_sym_alignas] = ACTIONS(3324),
    [anon_sym_explicit] = ACTIONS(3324),
    [anon_sym_typename] = ACTIONS(3324),
    [anon_sym_template] = ACTIONS(3324),
    [anon_sym_operator] = ACTIONS(3324),
    [anon_sym_try] = ACTIONS(3324),
    [anon_sym_delete] = ACTIONS(3324),
    [anon_sym_throw] = ACTIONS(3324),
    [anon_sym_namespace] = ACTIONS(3324),
    [anon_sym_using] = ACTIONS(3324),
    [anon_sym_static_assert] = ACTIONS(3324),
    [anon_sym_concept] = ACTIONS(3324),
    [anon_sym_co_return] = ACTIONS(3324),
    [anon_sym_co_yield] = ACTIONS(3324),
    [anon_sym_R_DQUOTE] = ACTIONS(3326),
    [anon_sym_LR_DQUOTE] = ACTIONS(3326),
    [anon_sym_uR_DQUOTE] = ACTIONS(3326),
    [anon_sym_UR_DQUOTE] = ACTIONS(3326),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3326),
    [anon_sym_co_await] = ACTIONS(3324),
    [anon_sym_new] = ACTIONS(3324),
    [anon_sym_requires] = ACTIONS(3324),
    [sym_this] = ACTIONS(3324),
  },
  [987] = {
    [sym_identifier] = ACTIONS(3301),
    [aux_sym_preproc_include_token1] = ACTIONS(3301),
    [aux_sym_preproc_def_token1] = ACTIONS(3301),
    [aux_sym_preproc_if_token1] = ACTIONS(3301),
    [aux_sym_preproc_if_token2] = ACTIONS(3301),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3301),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3301),
    [sym_preproc_directive] = ACTIONS(3301),
    [anon_sym_LPAREN2] = ACTIONS(3303),
    [anon_sym_BANG] = ACTIONS(3303),
    [anon_sym_TILDE] = ACTIONS(3303),
    [anon_sym_DASH] = ACTIONS(3301),
    [anon_sym_PLUS] = ACTIONS(3301),
    [anon_sym_STAR] = ACTIONS(3303),
    [anon_sym_AMP_AMP] = ACTIONS(3303),
    [anon_sym_AMP] = ACTIONS(3301),
    [anon_sym_SEMI] = ACTIONS(3303),
    [anon_sym___extension__] = ACTIONS(3301),
    [anon_sym_typedef] = ACTIONS(3301),
    [anon_sym_extern] = ACTIONS(3301),
    [anon_sym___attribute__] = ACTIONS(3301),
    [anon_sym_COLON_COLON] = ACTIONS(3303),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3303),
    [anon_sym___declspec] = ACTIONS(3301),
    [anon_sym___based] = ACTIONS(3301),
    [anon_sym___cdecl] = ACTIONS(3301),
    [anon_sym___clrcall] = ACTIONS(3301),
    [anon_sym___stdcall] = ACTIONS(3301),
    [anon_sym___fastcall] = ACTIONS(3301),
    [anon_sym___thiscall] = ACTIONS(3301),
    [anon_sym___vectorcall] = ACTIONS(3301),
    [anon_sym_LBRACE] = ACTIONS(3303),
    [anon_sym_signed] = ACTIONS(3301),
    [anon_sym_unsigned] = ACTIONS(3301),
    [anon_sym_long] = ACTIONS(3301),
    [anon_sym_short] = ACTIONS(3301),
    [anon_sym_LBRACK] = ACTIONS(3301),
    [anon_sym_static] = ACTIONS(3301),
    [anon_sym_register] = ACTIONS(3301),
    [anon_sym_inline] = ACTIONS(3301),
    [anon_sym___inline] = ACTIONS(3301),
    [anon_sym___inline__] = ACTIONS(3301),
    [anon_sym___forceinline] = ACTIONS(3301),
    [anon_sym_thread_local] = ACTIONS(3301),
    [anon_sym___thread] = ACTIONS(3301),
    [anon_sym_const] = ACTIONS(3301),
    [anon_sym_constexpr] = ACTIONS(3301),
    [anon_sym_volatile] = ACTIONS(3301),
    [anon_sym_restrict] = ACTIONS(3301),
    [anon_sym___restrict__] = ACTIONS(3301),
    [anon_sym__Atomic] = ACTIONS(3301),
    [anon_sym__Noreturn] = ACTIONS(3301),
    [anon_sym_noreturn] = ACTIONS(3301),
    [anon_sym_mutable] = ACTIONS(3301),
    [anon_sym_constinit] = ACTIONS(3301),
    [anon_sym_consteval] = ACTIONS(3301),
    [anon_sym_PROGMEM] = ACTIONS(3301),
    [aux_sym_primitive_type_token1] = ACTIONS(3301),
    [anon_sym_byte] = ACTIONS(3301),
    [anon_sym_word] = ACTIONS(3301),
    [anon_sym_enum] = ACTIONS(3301),
    [anon_sym_class] = ACTIONS(3301),
    [anon_sym_struct] = ACTIONS(3301),
    [anon_sym_union] = ACTIONS(3301),
    [anon_sym_if] = ACTIONS(3301),
    [anon_sym_switch] = ACTIONS(3301),
    [anon_sym_case] = ACTIONS(3301),
    [anon_sym_default] = ACTIONS(3301),
    [anon_sym_while] = ACTIONS(3301),
    [anon_sym_do] = ACTIONS(3301),
    [anon_sym_for] = ACTIONS(3301),
    [anon_sym_return] = ACTIONS(3301),
    [anon_sym_break] = ACTIONS(3301),
    [anon_sym_continue] = ACTIONS(3301),
    [anon_sym_goto] = ACTIONS(3301),
    [anon_sym___try] = ACTIONS(3301),
    [anon_sym___leave] = ACTIONS(3301),
    [anon_sym_not] = ACTIONS(3301),
    [anon_sym_compl] = ACTIONS(3301),
    [anon_sym_DASH_DASH] = ACTIONS(3303),
    [anon_sym_PLUS_PLUS] = ACTIONS(3303),
    [anon_sym_sizeof] = ACTIONS(3301),
    [anon_sym___alignof__] = ACTIONS(3301),
    [anon_sym___alignof] = ACTIONS(3301),
    [anon_sym__alignof] = ACTIONS(3301),
    [anon_sym_alignof] = ACTIONS(3301),
    [anon_sym__Alignof] = ACTIONS(3301),
    [anon_sym_offsetof] = ACTIONS(3301),
    [anon_sym__Generic] = ACTIONS(3301),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [aux_sym_number_literal_token1] = ACTIONS(3303),
    [aux_sym_number_literal_token2] = ACTIONS(3301),
    [anon_sym_L_SQUOTE] = ACTIONS(3303),
    [anon_sym_u_SQUOTE] = ACTIONS(3303),
    [anon_sym_U_SQUOTE] = ACTIONS(3303),
    [anon_sym_u8_SQUOTE] = ACTIONS(3303),
    [anon_sym_SQUOTE] = ACTIONS(3303),
    [anon_sym_L_DQUOTE] = ACTIONS(3303),
    [anon_sym_u_DQUOTE] = ACTIONS(3303),
    [anon_sym_U_DQUOTE] = ACTIONS(3303),
    [anon_sym_u8_DQUOTE] = ACTIONS(3303),
    [anon_sym_DQUOTE] = ACTIONS(3303),
    [sym_true] = ACTIONS(3301),
    [sym_false] = ACTIONS(3301),
    [anon_sym_NULL] = ACTIONS(3301),
    [anon_sym_nullptr] = ACTIONS(3301),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3301),
    [anon_sym_decltype] = ACTIONS(3301),
    [anon_sym_virtual] = ACTIONS(3301),
    [anon_sym_alignas] = ACTIONS(3301),
    [anon_sym_explicit] = ACTIONS(3301),
    [anon_sym_typename] = ACTIONS(3301),
    [anon_sym_template] = ACTIONS(3301),
    [anon_sym_operator] = ACTIONS(3301),
    [anon_sym_try] = ACTIONS(3301),
    [anon_sym_delete] = ACTIONS(3301),
    [anon_sym_throw] = ACTIONS(3301),
    [anon_sym_namespace] = ACTIONS(3301),
    [anon_sym_using] = ACTIONS(3301),
    [anon_sym_static_assert] = ACTIONS(3301),
    [anon_sym_concept] = ACTIONS(3301),
    [anon_sym_co_return] = ACTIONS(3301),
    [anon_sym_co_yield] = ACTIONS(3301),
    [anon_sym_R_DQUOTE] = ACTIONS(3303),
    [anon_sym_LR_DQUOTE] = ACTIONS(3303),
    [anon_sym_uR_DQUOTE] = ACTIONS(3303),
    [anon_sym_UR_DQUOTE] = ACTIONS(3303),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3303),
    [anon_sym_co_await] = ACTIONS(3301),
    [anon_sym_new] = ACTIONS(3301),
    [anon_sym_requires] = ACTIONS(3301),
    [sym_this] = ACTIONS(3301),
  },
  [988] = {
    [sym_identifier] = ACTIONS(3297),
    [aux_sym_preproc_include_token1] = ACTIONS(3297),
    [aux_sym_preproc_def_token1] = ACTIONS(3297),
    [aux_sym_preproc_if_token1] = ACTIONS(3297),
    [aux_sym_preproc_if_token2] = ACTIONS(3297),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3297),
    [sym_preproc_directive] = ACTIONS(3297),
    [anon_sym_LPAREN2] = ACTIONS(3299),
    [anon_sym_BANG] = ACTIONS(3299),
    [anon_sym_TILDE] = ACTIONS(3299),
    [anon_sym_DASH] = ACTIONS(3297),
    [anon_sym_PLUS] = ACTIONS(3297),
    [anon_sym_STAR] = ACTIONS(3299),
    [anon_sym_AMP_AMP] = ACTIONS(3299),
    [anon_sym_AMP] = ACTIONS(3297),
    [anon_sym_SEMI] = ACTIONS(3299),
    [anon_sym___extension__] = ACTIONS(3297),
    [anon_sym_typedef] = ACTIONS(3297),
    [anon_sym_extern] = ACTIONS(3297),
    [anon_sym___attribute__] = ACTIONS(3297),
    [anon_sym_COLON_COLON] = ACTIONS(3299),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3299),
    [anon_sym___declspec] = ACTIONS(3297),
    [anon_sym___based] = ACTIONS(3297),
    [anon_sym___cdecl] = ACTIONS(3297),
    [anon_sym___clrcall] = ACTIONS(3297),
    [anon_sym___stdcall] = ACTIONS(3297),
    [anon_sym___fastcall] = ACTIONS(3297),
    [anon_sym___thiscall] = ACTIONS(3297),
    [anon_sym___vectorcall] = ACTIONS(3297),
    [anon_sym_LBRACE] = ACTIONS(3299),
    [anon_sym_signed] = ACTIONS(3297),
    [anon_sym_unsigned] = ACTIONS(3297),
    [anon_sym_long] = ACTIONS(3297),
    [anon_sym_short] = ACTIONS(3297),
    [anon_sym_LBRACK] = ACTIONS(3297),
    [anon_sym_static] = ACTIONS(3297),
    [anon_sym_register] = ACTIONS(3297),
    [anon_sym_inline] = ACTIONS(3297),
    [anon_sym___inline] = ACTIONS(3297),
    [anon_sym___inline__] = ACTIONS(3297),
    [anon_sym___forceinline] = ACTIONS(3297),
    [anon_sym_thread_local] = ACTIONS(3297),
    [anon_sym___thread] = ACTIONS(3297),
    [anon_sym_const] = ACTIONS(3297),
    [anon_sym_constexpr] = ACTIONS(3297),
    [anon_sym_volatile] = ACTIONS(3297),
    [anon_sym_restrict] = ACTIONS(3297),
    [anon_sym___restrict__] = ACTIONS(3297),
    [anon_sym__Atomic] = ACTIONS(3297),
    [anon_sym__Noreturn] = ACTIONS(3297),
    [anon_sym_noreturn] = ACTIONS(3297),
    [anon_sym_mutable] = ACTIONS(3297),
    [anon_sym_constinit] = ACTIONS(3297),
    [anon_sym_consteval] = ACTIONS(3297),
    [anon_sym_PROGMEM] = ACTIONS(3297),
    [aux_sym_primitive_type_token1] = ACTIONS(3297),
    [anon_sym_byte] = ACTIONS(3297),
    [anon_sym_word] = ACTIONS(3297),
    [anon_sym_enum] = ACTIONS(3297),
    [anon_sym_class] = ACTIONS(3297),
    [anon_sym_struct] = ACTIONS(3297),
    [anon_sym_union] = ACTIONS(3297),
    [anon_sym_if] = ACTIONS(3297),
    [anon_sym_switch] = ACTIONS(3297),
    [anon_sym_case] = ACTIONS(3297),
    [anon_sym_default] = ACTIONS(3297),
    [anon_sym_while] = ACTIONS(3297),
    [anon_sym_do] = ACTIONS(3297),
    [anon_sym_for] = ACTIONS(3297),
    [anon_sym_return] = ACTIONS(3297),
    [anon_sym_break] = ACTIONS(3297),
    [anon_sym_continue] = ACTIONS(3297),
    [anon_sym_goto] = ACTIONS(3297),
    [anon_sym___try] = ACTIONS(3297),
    [anon_sym___leave] = ACTIONS(3297),
    [anon_sym_not] = ACTIONS(3297),
    [anon_sym_compl] = ACTIONS(3297),
    [anon_sym_DASH_DASH] = ACTIONS(3299),
    [anon_sym_PLUS_PLUS] = ACTIONS(3299),
    [anon_sym_sizeof] = ACTIONS(3297),
    [anon_sym___alignof__] = ACTIONS(3297),
    [anon_sym___alignof] = ACTIONS(3297),
    [anon_sym__alignof] = ACTIONS(3297),
    [anon_sym_alignof] = ACTIONS(3297),
    [anon_sym__Alignof] = ACTIONS(3297),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3297),
    [anon_sym_asm] = ACTIONS(3297),
    [anon_sym___asm__] = ACTIONS(3297),
    [aux_sym_number_literal_token1] = ACTIONS(3299),
    [aux_sym_number_literal_token2] = ACTIONS(3297),
    [anon_sym_L_SQUOTE] = ACTIONS(3299),
    [anon_sym_u_SQUOTE] = ACTIONS(3299),
    [anon_sym_U_SQUOTE] = ACTIONS(3299),
    [anon_sym_u8_SQUOTE] = ACTIONS(3299),
    [anon_sym_SQUOTE] = ACTIONS(3299),
    [anon_sym_L_DQUOTE] = ACTIONS(3299),
    [anon_sym_u_DQUOTE] = ACTIONS(3299),
    [anon_sym_U_DQUOTE] = ACTIONS(3299),
    [anon_sym_u8_DQUOTE] = ACTIONS(3299),
    [anon_sym_DQUOTE] = ACTIONS(3299),
    [sym_true] = ACTIONS(3297),
    [sym_false] = ACTIONS(3297),
    [anon_sym_NULL] = ACTIONS(3297),
    [anon_sym_nullptr] = ACTIONS(3297),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3297),
    [anon_sym_decltype] = ACTIONS(3297),
    [anon_sym_virtual] = ACTIONS(3297),
    [anon_sym_alignas] = ACTIONS(3297),
    [anon_sym_explicit] = ACTIONS(3297),
    [anon_sym_typename] = ACTIONS(3297),
    [anon_sym_template] = ACTIONS(3297),
    [anon_sym_operator] = ACTIONS(3297),
    [anon_sym_try] = ACTIONS(3297),
    [anon_sym_delete] = ACTIONS(3297),
    [anon_sym_throw] = ACTIONS(3297),
    [anon_sym_namespace] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3297),
    [anon_sym_static_assert] = ACTIONS(3297),
    [anon_sym_concept] = ACTIONS(3297),
    [anon_sym_co_return] = ACTIONS(3297),
    [anon_sym_co_yield] = ACTIONS(3297),
    [anon_sym_R_DQUOTE] = ACTIONS(3299),
    [anon_sym_LR_DQUOTE] = ACTIONS(3299),
    [anon_sym_uR_DQUOTE] = ACTIONS(3299),
    [anon_sym_UR_DQUOTE] = ACTIONS(3299),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3299),
    [anon_sym_co_await] = ACTIONS(3297),
    [anon_sym_new] = ACTIONS(3297),
    [anon_sym_requires] = ACTIONS(3297),
    [sym_this] = ACTIONS(3297),
  },
  [989] = {
    [sym_identifier] = ACTIONS(3293),
    [aux_sym_preproc_include_token1] = ACTIONS(3293),
    [aux_sym_preproc_def_token1] = ACTIONS(3293),
    [aux_sym_preproc_if_token1] = ACTIONS(3293),
    [aux_sym_preproc_if_token2] = ACTIONS(3293),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3293),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3293),
    [sym_preproc_directive] = ACTIONS(3293),
    [anon_sym_LPAREN2] = ACTIONS(3295),
    [anon_sym_BANG] = ACTIONS(3295),
    [anon_sym_TILDE] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3293),
    [anon_sym_STAR] = ACTIONS(3295),
    [anon_sym_AMP_AMP] = ACTIONS(3295),
    [anon_sym_AMP] = ACTIONS(3293),
    [anon_sym_SEMI] = ACTIONS(3295),
    [anon_sym___extension__] = ACTIONS(3293),
    [anon_sym_typedef] = ACTIONS(3293),
    [anon_sym_extern] = ACTIONS(3293),
    [anon_sym___attribute__] = ACTIONS(3293),
    [anon_sym_COLON_COLON] = ACTIONS(3295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3295),
    [anon_sym___declspec] = ACTIONS(3293),
    [anon_sym___based] = ACTIONS(3293),
    [anon_sym___cdecl] = ACTIONS(3293),
    [anon_sym___clrcall] = ACTIONS(3293),
    [anon_sym___stdcall] = ACTIONS(3293),
    [anon_sym___fastcall] = ACTIONS(3293),
    [anon_sym___thiscall] = ACTIONS(3293),
    [anon_sym___vectorcall] = ACTIONS(3293),
    [anon_sym_LBRACE] = ACTIONS(3295),
    [anon_sym_signed] = ACTIONS(3293),
    [anon_sym_unsigned] = ACTIONS(3293),
    [anon_sym_long] = ACTIONS(3293),
    [anon_sym_short] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_static] = ACTIONS(3293),
    [anon_sym_register] = ACTIONS(3293),
    [anon_sym_inline] = ACTIONS(3293),
    [anon_sym___inline] = ACTIONS(3293),
    [anon_sym___inline__] = ACTIONS(3293),
    [anon_sym___forceinline] = ACTIONS(3293),
    [anon_sym_thread_local] = ACTIONS(3293),
    [anon_sym___thread] = ACTIONS(3293),
    [anon_sym_const] = ACTIONS(3293),
    [anon_sym_constexpr] = ACTIONS(3293),
    [anon_sym_volatile] = ACTIONS(3293),
    [anon_sym_restrict] = ACTIONS(3293),
    [anon_sym___restrict__] = ACTIONS(3293),
    [anon_sym__Atomic] = ACTIONS(3293),
    [anon_sym__Noreturn] = ACTIONS(3293),
    [anon_sym_noreturn] = ACTIONS(3293),
    [anon_sym_mutable] = ACTIONS(3293),
    [anon_sym_constinit] = ACTIONS(3293),
    [anon_sym_consteval] = ACTIONS(3293),
    [anon_sym_PROGMEM] = ACTIONS(3293),
    [aux_sym_primitive_type_token1] = ACTIONS(3293),
    [anon_sym_byte] = ACTIONS(3293),
    [anon_sym_word] = ACTIONS(3293),
    [anon_sym_enum] = ACTIONS(3293),
    [anon_sym_class] = ACTIONS(3293),
    [anon_sym_struct] = ACTIONS(3293),
    [anon_sym_union] = ACTIONS(3293),
    [anon_sym_if] = ACTIONS(3293),
    [anon_sym_switch] = ACTIONS(3293),
    [anon_sym_case] = ACTIONS(3293),
    [anon_sym_default] = ACTIONS(3293),
    [anon_sym_while] = ACTIONS(3293),
    [anon_sym_do] = ACTIONS(3293),
    [anon_sym_for] = ACTIONS(3293),
    [anon_sym_return] = ACTIONS(3293),
    [anon_sym_break] = ACTIONS(3293),
    [anon_sym_continue] = ACTIONS(3293),
    [anon_sym_goto] = ACTIONS(3293),
    [anon_sym___try] = ACTIONS(3293),
    [anon_sym___leave] = ACTIONS(3293),
    [anon_sym_not] = ACTIONS(3293),
    [anon_sym_compl] = ACTIONS(3293),
    [anon_sym_DASH_DASH] = ACTIONS(3295),
    [anon_sym_PLUS_PLUS] = ACTIONS(3295),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3293),
    [anon_sym___alignof] = ACTIONS(3293),
    [anon_sym__alignof] = ACTIONS(3293),
    [anon_sym_alignof] = ACTIONS(3293),
    [anon_sym__Alignof] = ACTIONS(3293),
    [anon_sym_offsetof] = ACTIONS(3293),
    [anon_sym__Generic] = ACTIONS(3293),
    [anon_sym_asm] = ACTIONS(3293),
    [anon_sym___asm__] = ACTIONS(3293),
    [aux_sym_number_literal_token1] = ACTIONS(3295),
    [aux_sym_number_literal_token2] = ACTIONS(3293),
    [anon_sym_L_SQUOTE] = ACTIONS(3295),
    [anon_sym_u_SQUOTE] = ACTIONS(3295),
    [anon_sym_U_SQUOTE] = ACTIONS(3295),
    [anon_sym_u8_SQUOTE] = ACTIONS(3295),
    [anon_sym_SQUOTE] = ACTIONS(3295),
    [anon_sym_L_DQUOTE] = ACTIONS(3295),
    [anon_sym_u_DQUOTE] = ACTIONS(3295),
    [anon_sym_U_DQUOTE] = ACTIONS(3295),
    [anon_sym_u8_DQUOTE] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(3295),
    [sym_true] = ACTIONS(3293),
    [sym_false] = ACTIONS(3293),
    [anon_sym_NULL] = ACTIONS(3293),
    [anon_sym_nullptr] = ACTIONS(3293),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3293),
    [anon_sym_decltype] = ACTIONS(3293),
    [anon_sym_virtual] = ACTIONS(3293),
    [anon_sym_alignas] = ACTIONS(3293),
    [anon_sym_explicit] = ACTIONS(3293),
    [anon_sym_typename] = ACTIONS(3293),
    [anon_sym_template] = ACTIONS(3293),
    [anon_sym_operator] = ACTIONS(3293),
    [anon_sym_try] = ACTIONS(3293),
    [anon_sym_delete] = ACTIONS(3293),
    [anon_sym_throw] = ACTIONS(3293),
    [anon_sym_namespace] = ACTIONS(3293),
    [anon_sym_using] = ACTIONS(3293),
    [anon_sym_static_assert] = ACTIONS(3293),
    [anon_sym_concept] = ACTIONS(3293),
    [anon_sym_co_return] = ACTIONS(3293),
    [anon_sym_co_yield] = ACTIONS(3293),
    [anon_sym_R_DQUOTE] = ACTIONS(3295),
    [anon_sym_LR_DQUOTE] = ACTIONS(3295),
    [anon_sym_uR_DQUOTE] = ACTIONS(3295),
    [anon_sym_UR_DQUOTE] = ACTIONS(3295),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3295),
    [anon_sym_co_await] = ACTIONS(3293),
    [anon_sym_new] = ACTIONS(3293),
    [anon_sym_requires] = ACTIONS(3293),
    [sym_this] = ACTIONS(3293),
  },
  [990] = {
    [sym_identifier] = ACTIONS(3475),
    [aux_sym_preproc_include_token1] = ACTIONS(3475),
    [aux_sym_preproc_def_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token2] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3475),
    [sym_preproc_directive] = ACTIONS(3475),
    [anon_sym_LPAREN2] = ACTIONS(3477),
    [anon_sym_BANG] = ACTIONS(3477),
    [anon_sym_TILDE] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3475),
    [anon_sym_PLUS] = ACTIONS(3475),
    [anon_sym_STAR] = ACTIONS(3477),
    [anon_sym_AMP_AMP] = ACTIONS(3477),
    [anon_sym_AMP] = ACTIONS(3475),
    [anon_sym_SEMI] = ACTIONS(3477),
    [anon_sym___extension__] = ACTIONS(3475),
    [anon_sym_typedef] = ACTIONS(3475),
    [anon_sym_extern] = ACTIONS(3475),
    [anon_sym___attribute__] = ACTIONS(3475),
    [anon_sym_COLON_COLON] = ACTIONS(3477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3477),
    [anon_sym___declspec] = ACTIONS(3475),
    [anon_sym___based] = ACTIONS(3475),
    [anon_sym___cdecl] = ACTIONS(3475),
    [anon_sym___clrcall] = ACTIONS(3475),
    [anon_sym___stdcall] = ACTIONS(3475),
    [anon_sym___fastcall] = ACTIONS(3475),
    [anon_sym___thiscall] = ACTIONS(3475),
    [anon_sym___vectorcall] = ACTIONS(3475),
    [anon_sym_LBRACE] = ACTIONS(3477),
    [anon_sym_signed] = ACTIONS(3475),
    [anon_sym_unsigned] = ACTIONS(3475),
    [anon_sym_long] = ACTIONS(3475),
    [anon_sym_short] = ACTIONS(3475),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [anon_sym_static] = ACTIONS(3475),
    [anon_sym_register] = ACTIONS(3475),
    [anon_sym_inline] = ACTIONS(3475),
    [anon_sym___inline] = ACTIONS(3475),
    [anon_sym___inline__] = ACTIONS(3475),
    [anon_sym___forceinline] = ACTIONS(3475),
    [anon_sym_thread_local] = ACTIONS(3475),
    [anon_sym___thread] = ACTIONS(3475),
    [anon_sym_const] = ACTIONS(3475),
    [anon_sym_constexpr] = ACTIONS(3475),
    [anon_sym_volatile] = ACTIONS(3475),
    [anon_sym_restrict] = ACTIONS(3475),
    [anon_sym___restrict__] = ACTIONS(3475),
    [anon_sym__Atomic] = ACTIONS(3475),
    [anon_sym__Noreturn] = ACTIONS(3475),
    [anon_sym_noreturn] = ACTIONS(3475),
    [anon_sym_mutable] = ACTIONS(3475),
    [anon_sym_constinit] = ACTIONS(3475),
    [anon_sym_consteval] = ACTIONS(3475),
    [anon_sym_PROGMEM] = ACTIONS(3475),
    [aux_sym_primitive_type_token1] = ACTIONS(3475),
    [anon_sym_byte] = ACTIONS(3475),
    [anon_sym_word] = ACTIONS(3475),
    [anon_sym_enum] = ACTIONS(3475),
    [anon_sym_class] = ACTIONS(3475),
    [anon_sym_struct] = ACTIONS(3475),
    [anon_sym_union] = ACTIONS(3475),
    [anon_sym_if] = ACTIONS(3475),
    [anon_sym_switch] = ACTIONS(3475),
    [anon_sym_case] = ACTIONS(3475),
    [anon_sym_default] = ACTIONS(3475),
    [anon_sym_while] = ACTIONS(3475),
    [anon_sym_do] = ACTIONS(3475),
    [anon_sym_for] = ACTIONS(3475),
    [anon_sym_return] = ACTIONS(3475),
    [anon_sym_break] = ACTIONS(3475),
    [anon_sym_continue] = ACTIONS(3475),
    [anon_sym_goto] = ACTIONS(3475),
    [anon_sym___try] = ACTIONS(3475),
    [anon_sym___leave] = ACTIONS(3475),
    [anon_sym_not] = ACTIONS(3475),
    [anon_sym_compl] = ACTIONS(3475),
    [anon_sym_DASH_DASH] = ACTIONS(3477),
    [anon_sym_PLUS_PLUS] = ACTIONS(3477),
    [anon_sym_sizeof] = ACTIONS(3475),
    [anon_sym___alignof__] = ACTIONS(3475),
    [anon_sym___alignof] = ACTIONS(3475),
    [anon_sym__alignof] = ACTIONS(3475),
    [anon_sym_alignof] = ACTIONS(3475),
    [anon_sym__Alignof] = ACTIONS(3475),
    [anon_sym_offsetof] = ACTIONS(3475),
    [anon_sym__Generic] = ACTIONS(3475),
    [anon_sym_asm] = ACTIONS(3475),
    [anon_sym___asm__] = ACTIONS(3475),
    [aux_sym_number_literal_token1] = ACTIONS(3477),
    [aux_sym_number_literal_token2] = ACTIONS(3475),
    [anon_sym_L_SQUOTE] = ACTIONS(3477),
    [anon_sym_u_SQUOTE] = ACTIONS(3477),
    [anon_sym_U_SQUOTE] = ACTIONS(3477),
    [anon_sym_u8_SQUOTE] = ACTIONS(3477),
    [anon_sym_SQUOTE] = ACTIONS(3477),
    [anon_sym_L_DQUOTE] = ACTIONS(3477),
    [anon_sym_u_DQUOTE] = ACTIONS(3477),
    [anon_sym_U_DQUOTE] = ACTIONS(3477),
    [anon_sym_u8_DQUOTE] = ACTIONS(3477),
    [anon_sym_DQUOTE] = ACTIONS(3477),
    [sym_true] = ACTIONS(3475),
    [sym_false] = ACTIONS(3475),
    [anon_sym_NULL] = ACTIONS(3475),
    [anon_sym_nullptr] = ACTIONS(3475),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3475),
    [anon_sym_decltype] = ACTIONS(3475),
    [anon_sym_virtual] = ACTIONS(3475),
    [anon_sym_alignas] = ACTIONS(3475),
    [anon_sym_explicit] = ACTIONS(3475),
    [anon_sym_typename] = ACTIONS(3475),
    [anon_sym_template] = ACTIONS(3475),
    [anon_sym_operator] = ACTIONS(3475),
    [anon_sym_try] = ACTIONS(3475),
    [anon_sym_delete] = ACTIONS(3475),
    [anon_sym_throw] = ACTIONS(3475),
    [anon_sym_namespace] = ACTIONS(3475),
    [anon_sym_using] = ACTIONS(3475),
    [anon_sym_static_assert] = ACTIONS(3475),
    [anon_sym_concept] = ACTIONS(3475),
    [anon_sym_co_return] = ACTIONS(3475),
    [anon_sym_co_yield] = ACTIONS(3475),
    [anon_sym_R_DQUOTE] = ACTIONS(3477),
    [anon_sym_LR_DQUOTE] = ACTIONS(3477),
    [anon_sym_uR_DQUOTE] = ACTIONS(3477),
    [anon_sym_UR_DQUOTE] = ACTIONS(3477),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3477),
    [anon_sym_co_await] = ACTIONS(3475),
    [anon_sym_new] = ACTIONS(3475),
    [anon_sym_requires] = ACTIONS(3475),
    [sym_this] = ACTIONS(3475),
  },
  [991] = {
    [sym_identifier] = ACTIONS(3471),
    [aux_sym_preproc_include_token1] = ACTIONS(3471),
    [aux_sym_preproc_def_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token2] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3471),
    [sym_preproc_directive] = ACTIONS(3471),
    [anon_sym_LPAREN2] = ACTIONS(3473),
    [anon_sym_BANG] = ACTIONS(3473),
    [anon_sym_TILDE] = ACTIONS(3473),
    [anon_sym_DASH] = ACTIONS(3471),
    [anon_sym_PLUS] = ACTIONS(3471),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_AMP_AMP] = ACTIONS(3473),
    [anon_sym_AMP] = ACTIONS(3471),
    [anon_sym_SEMI] = ACTIONS(3473),
    [anon_sym___extension__] = ACTIONS(3471),
    [anon_sym_typedef] = ACTIONS(3471),
    [anon_sym_extern] = ACTIONS(3471),
    [anon_sym___attribute__] = ACTIONS(3471),
    [anon_sym_COLON_COLON] = ACTIONS(3473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3473),
    [anon_sym___declspec] = ACTIONS(3471),
    [anon_sym___based] = ACTIONS(3471),
    [anon_sym___cdecl] = ACTIONS(3471),
    [anon_sym___clrcall] = ACTIONS(3471),
    [anon_sym___stdcall] = ACTIONS(3471),
    [anon_sym___fastcall] = ACTIONS(3471),
    [anon_sym___thiscall] = ACTIONS(3471),
    [anon_sym___vectorcall] = ACTIONS(3471),
    [anon_sym_LBRACE] = ACTIONS(3473),
    [anon_sym_signed] = ACTIONS(3471),
    [anon_sym_unsigned] = ACTIONS(3471),
    [anon_sym_long] = ACTIONS(3471),
    [anon_sym_short] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [anon_sym_static] = ACTIONS(3471),
    [anon_sym_register] = ACTIONS(3471),
    [anon_sym_inline] = ACTIONS(3471),
    [anon_sym___inline] = ACTIONS(3471),
    [anon_sym___inline__] = ACTIONS(3471),
    [anon_sym___forceinline] = ACTIONS(3471),
    [anon_sym_thread_local] = ACTIONS(3471),
    [anon_sym___thread] = ACTIONS(3471),
    [anon_sym_const] = ACTIONS(3471),
    [anon_sym_constexpr] = ACTIONS(3471),
    [anon_sym_volatile] = ACTIONS(3471),
    [anon_sym_restrict] = ACTIONS(3471),
    [anon_sym___restrict__] = ACTIONS(3471),
    [anon_sym__Atomic] = ACTIONS(3471),
    [anon_sym__Noreturn] = ACTIONS(3471),
    [anon_sym_noreturn] = ACTIONS(3471),
    [anon_sym_mutable] = ACTIONS(3471),
    [anon_sym_constinit] = ACTIONS(3471),
    [anon_sym_consteval] = ACTIONS(3471),
    [anon_sym_PROGMEM] = ACTIONS(3471),
    [aux_sym_primitive_type_token1] = ACTIONS(3471),
    [anon_sym_byte] = ACTIONS(3471),
    [anon_sym_word] = ACTIONS(3471),
    [anon_sym_enum] = ACTIONS(3471),
    [anon_sym_class] = ACTIONS(3471),
    [anon_sym_struct] = ACTIONS(3471),
    [anon_sym_union] = ACTIONS(3471),
    [anon_sym_if] = ACTIONS(3471),
    [anon_sym_switch] = ACTIONS(3471),
    [anon_sym_case] = ACTIONS(3471),
    [anon_sym_default] = ACTIONS(3471),
    [anon_sym_while] = ACTIONS(3471),
    [anon_sym_do] = ACTIONS(3471),
    [anon_sym_for] = ACTIONS(3471),
    [anon_sym_return] = ACTIONS(3471),
    [anon_sym_break] = ACTIONS(3471),
    [anon_sym_continue] = ACTIONS(3471),
    [anon_sym_goto] = ACTIONS(3471),
    [anon_sym___try] = ACTIONS(3471),
    [anon_sym___leave] = ACTIONS(3471),
    [anon_sym_not] = ACTIONS(3471),
    [anon_sym_compl] = ACTIONS(3471),
    [anon_sym_DASH_DASH] = ACTIONS(3473),
    [anon_sym_PLUS_PLUS] = ACTIONS(3473),
    [anon_sym_sizeof] = ACTIONS(3471),
    [anon_sym___alignof__] = ACTIONS(3471),
    [anon_sym___alignof] = ACTIONS(3471),
    [anon_sym__alignof] = ACTIONS(3471),
    [anon_sym_alignof] = ACTIONS(3471),
    [anon_sym__Alignof] = ACTIONS(3471),
    [anon_sym_offsetof] = ACTIONS(3471),
    [anon_sym__Generic] = ACTIONS(3471),
    [anon_sym_asm] = ACTIONS(3471),
    [anon_sym___asm__] = ACTIONS(3471),
    [aux_sym_number_literal_token1] = ACTIONS(3473),
    [aux_sym_number_literal_token2] = ACTIONS(3471),
    [anon_sym_L_SQUOTE] = ACTIONS(3473),
    [anon_sym_u_SQUOTE] = ACTIONS(3473),
    [anon_sym_U_SQUOTE] = ACTIONS(3473),
    [anon_sym_u8_SQUOTE] = ACTIONS(3473),
    [anon_sym_SQUOTE] = ACTIONS(3473),
    [anon_sym_L_DQUOTE] = ACTIONS(3473),
    [anon_sym_u_DQUOTE] = ACTIONS(3473),
    [anon_sym_U_DQUOTE] = ACTIONS(3473),
    [anon_sym_u8_DQUOTE] = ACTIONS(3473),
    [anon_sym_DQUOTE] = ACTIONS(3473),
    [sym_true] = ACTIONS(3471),
    [sym_false] = ACTIONS(3471),
    [anon_sym_NULL] = ACTIONS(3471),
    [anon_sym_nullptr] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3471),
    [anon_sym_decltype] = ACTIONS(3471),
    [anon_sym_virtual] = ACTIONS(3471),
    [anon_sym_alignas] = ACTIONS(3471),
    [anon_sym_explicit] = ACTIONS(3471),
    [anon_sym_typename] = ACTIONS(3471),
    [anon_sym_template] = ACTIONS(3471),
    [anon_sym_operator] = ACTIONS(3471),
    [anon_sym_try] = ACTIONS(3471),
    [anon_sym_delete] = ACTIONS(3471),
    [anon_sym_throw] = ACTIONS(3471),
    [anon_sym_namespace] = ACTIONS(3471),
    [anon_sym_using] = ACTIONS(3471),
    [anon_sym_static_assert] = ACTIONS(3471),
    [anon_sym_concept] = ACTIONS(3471),
    [anon_sym_co_return] = ACTIONS(3471),
    [anon_sym_co_yield] = ACTIONS(3471),
    [anon_sym_R_DQUOTE] = ACTIONS(3473),
    [anon_sym_LR_DQUOTE] = ACTIONS(3473),
    [anon_sym_uR_DQUOTE] = ACTIONS(3473),
    [anon_sym_UR_DQUOTE] = ACTIONS(3473),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3473),
    [anon_sym_co_await] = ACTIONS(3471),
    [anon_sym_new] = ACTIONS(3471),
    [anon_sym_requires] = ACTIONS(3471),
    [sym_this] = ACTIONS(3471),
  },
  [992] = {
    [sym_identifier] = ACTIONS(3467),
    [aux_sym_preproc_include_token1] = ACTIONS(3467),
    [aux_sym_preproc_def_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token2] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3467),
    [sym_preproc_directive] = ACTIONS(3467),
    [anon_sym_LPAREN2] = ACTIONS(3469),
    [anon_sym_BANG] = ACTIONS(3469),
    [anon_sym_TILDE] = ACTIONS(3469),
    [anon_sym_DASH] = ACTIONS(3467),
    [anon_sym_PLUS] = ACTIONS(3467),
    [anon_sym_STAR] = ACTIONS(3469),
    [anon_sym_AMP_AMP] = ACTIONS(3469),
    [anon_sym_AMP] = ACTIONS(3467),
    [anon_sym_SEMI] = ACTIONS(3469),
    [anon_sym___extension__] = ACTIONS(3467),
    [anon_sym_typedef] = ACTIONS(3467),
    [anon_sym_extern] = ACTIONS(3467),
    [anon_sym___attribute__] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(3469),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3469),
    [anon_sym___declspec] = ACTIONS(3467),
    [anon_sym___based] = ACTIONS(3467),
    [anon_sym___cdecl] = ACTIONS(3467),
    [anon_sym___clrcall] = ACTIONS(3467),
    [anon_sym___stdcall] = ACTIONS(3467),
    [anon_sym___fastcall] = ACTIONS(3467),
    [anon_sym___thiscall] = ACTIONS(3467),
    [anon_sym___vectorcall] = ACTIONS(3467),
    [anon_sym_LBRACE] = ACTIONS(3469),
    [anon_sym_signed] = ACTIONS(3467),
    [anon_sym_unsigned] = ACTIONS(3467),
    [anon_sym_long] = ACTIONS(3467),
    [anon_sym_short] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [anon_sym_static] = ACTIONS(3467),
    [anon_sym_register] = ACTIONS(3467),
    [anon_sym_inline] = ACTIONS(3467),
    [anon_sym___inline] = ACTIONS(3467),
    [anon_sym___inline__] = ACTIONS(3467),
    [anon_sym___forceinline] = ACTIONS(3467),
    [anon_sym_thread_local] = ACTIONS(3467),
    [anon_sym___thread] = ACTIONS(3467),
    [anon_sym_const] = ACTIONS(3467),
    [anon_sym_constexpr] = ACTIONS(3467),
    [anon_sym_volatile] = ACTIONS(3467),
    [anon_sym_restrict] = ACTIONS(3467),
    [anon_sym___restrict__] = ACTIONS(3467),
    [anon_sym__Atomic] = ACTIONS(3467),
    [anon_sym__Noreturn] = ACTIONS(3467),
    [anon_sym_noreturn] = ACTIONS(3467),
    [anon_sym_mutable] = ACTIONS(3467),
    [anon_sym_constinit] = ACTIONS(3467),
    [anon_sym_consteval] = ACTIONS(3467),
    [anon_sym_PROGMEM] = ACTIONS(3467),
    [aux_sym_primitive_type_token1] = ACTIONS(3467),
    [anon_sym_byte] = ACTIONS(3467),
    [anon_sym_word] = ACTIONS(3467),
    [anon_sym_enum] = ACTIONS(3467),
    [anon_sym_class] = ACTIONS(3467),
    [anon_sym_struct] = ACTIONS(3467),
    [anon_sym_union] = ACTIONS(3467),
    [anon_sym_if] = ACTIONS(3467),
    [anon_sym_switch] = ACTIONS(3467),
    [anon_sym_case] = ACTIONS(3467),
    [anon_sym_default] = ACTIONS(3467),
    [anon_sym_while] = ACTIONS(3467),
    [anon_sym_do] = ACTIONS(3467),
    [anon_sym_for] = ACTIONS(3467),
    [anon_sym_return] = ACTIONS(3467),
    [anon_sym_break] = ACTIONS(3467),
    [anon_sym_continue] = ACTIONS(3467),
    [anon_sym_goto] = ACTIONS(3467),
    [anon_sym___try] = ACTIONS(3467),
    [anon_sym___leave] = ACTIONS(3467),
    [anon_sym_not] = ACTIONS(3467),
    [anon_sym_compl] = ACTIONS(3467),
    [anon_sym_DASH_DASH] = ACTIONS(3469),
    [anon_sym_PLUS_PLUS] = ACTIONS(3469),
    [anon_sym_sizeof] = ACTIONS(3467),
    [anon_sym___alignof__] = ACTIONS(3467),
    [anon_sym___alignof] = ACTIONS(3467),
    [anon_sym__alignof] = ACTIONS(3467),
    [anon_sym_alignof] = ACTIONS(3467),
    [anon_sym__Alignof] = ACTIONS(3467),
    [anon_sym_offsetof] = ACTIONS(3467),
    [anon_sym__Generic] = ACTIONS(3467),
    [anon_sym_asm] = ACTIONS(3467),
    [anon_sym___asm__] = ACTIONS(3467),
    [aux_sym_number_literal_token1] = ACTIONS(3469),
    [aux_sym_number_literal_token2] = ACTIONS(3467),
    [anon_sym_L_SQUOTE] = ACTIONS(3469),
    [anon_sym_u_SQUOTE] = ACTIONS(3469),
    [anon_sym_U_SQUOTE] = ACTIONS(3469),
    [anon_sym_u8_SQUOTE] = ACTIONS(3469),
    [anon_sym_SQUOTE] = ACTIONS(3469),
    [anon_sym_L_DQUOTE] = ACTIONS(3469),
    [anon_sym_u_DQUOTE] = ACTIONS(3469),
    [anon_sym_U_DQUOTE] = ACTIONS(3469),
    [anon_sym_u8_DQUOTE] = ACTIONS(3469),
    [anon_sym_DQUOTE] = ACTIONS(3469),
    [sym_true] = ACTIONS(3467),
    [sym_false] = ACTIONS(3467),
    [anon_sym_NULL] = ACTIONS(3467),
    [anon_sym_nullptr] = ACTIONS(3467),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3467),
    [anon_sym_decltype] = ACTIONS(3467),
    [anon_sym_virtual] = ACTIONS(3467),
    [anon_sym_alignas] = ACTIONS(3467),
    [anon_sym_explicit] = ACTIONS(3467),
    [anon_sym_typename] = ACTIONS(3467),
    [anon_sym_template] = ACTIONS(3467),
    [anon_sym_operator] = ACTIONS(3467),
    [anon_sym_try] = ACTIONS(3467),
    [anon_sym_delete] = ACTIONS(3467),
    [anon_sym_throw] = ACTIONS(3467),
    [anon_sym_namespace] = ACTIONS(3467),
    [anon_sym_using] = ACTIONS(3467),
    [anon_sym_static_assert] = ACTIONS(3467),
    [anon_sym_concept] = ACTIONS(3467),
    [anon_sym_co_return] = ACTIONS(3467),
    [anon_sym_co_yield] = ACTIONS(3467),
    [anon_sym_R_DQUOTE] = ACTIONS(3469),
    [anon_sym_LR_DQUOTE] = ACTIONS(3469),
    [anon_sym_uR_DQUOTE] = ACTIONS(3469),
    [anon_sym_UR_DQUOTE] = ACTIONS(3469),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3469),
    [anon_sym_co_await] = ACTIONS(3467),
    [anon_sym_new] = ACTIONS(3467),
    [anon_sym_requires] = ACTIONS(3467),
    [sym_this] = ACTIONS(3467),
  },
  [993] = {
    [sym_identifier] = ACTIONS(3455),
    [aux_sym_preproc_include_token1] = ACTIONS(3455),
    [aux_sym_preproc_def_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token2] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3455),
    [sym_preproc_directive] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_BANG] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_STAR] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_SEMI] = ACTIONS(3457),
    [anon_sym___extension__] = ACTIONS(3455),
    [anon_sym_typedef] = ACTIONS(3455),
    [anon_sym_extern] = ACTIONS(3455),
    [anon_sym___attribute__] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3457),
    [anon_sym___declspec] = ACTIONS(3455),
    [anon_sym___based] = ACTIONS(3455),
    [anon_sym___cdecl] = ACTIONS(3455),
    [anon_sym___clrcall] = ACTIONS(3455),
    [anon_sym___stdcall] = ACTIONS(3455),
    [anon_sym___fastcall] = ACTIONS(3455),
    [anon_sym___thiscall] = ACTIONS(3455),
    [anon_sym___vectorcall] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_signed] = ACTIONS(3455),
    [anon_sym_unsigned] = ACTIONS(3455),
    [anon_sym_long] = ACTIONS(3455),
    [anon_sym_short] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_static] = ACTIONS(3455),
    [anon_sym_register] = ACTIONS(3455),
    [anon_sym_inline] = ACTIONS(3455),
    [anon_sym___inline] = ACTIONS(3455),
    [anon_sym___inline__] = ACTIONS(3455),
    [anon_sym___forceinline] = ACTIONS(3455),
    [anon_sym_thread_local] = ACTIONS(3455),
    [anon_sym___thread] = ACTIONS(3455),
    [anon_sym_const] = ACTIONS(3455),
    [anon_sym_constexpr] = ACTIONS(3455),
    [anon_sym_volatile] = ACTIONS(3455),
    [anon_sym_restrict] = ACTIONS(3455),
    [anon_sym___restrict__] = ACTIONS(3455),
    [anon_sym__Atomic] = ACTIONS(3455),
    [anon_sym__Noreturn] = ACTIONS(3455),
    [anon_sym_noreturn] = ACTIONS(3455),
    [anon_sym_mutable] = ACTIONS(3455),
    [anon_sym_constinit] = ACTIONS(3455),
    [anon_sym_consteval] = ACTIONS(3455),
    [anon_sym_PROGMEM] = ACTIONS(3455),
    [aux_sym_primitive_type_token1] = ACTIONS(3455),
    [anon_sym_byte] = ACTIONS(3455),
    [anon_sym_word] = ACTIONS(3455),
    [anon_sym_enum] = ACTIONS(3455),
    [anon_sym_class] = ACTIONS(3455),
    [anon_sym_struct] = ACTIONS(3455),
    [anon_sym_union] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_switch] = ACTIONS(3455),
    [anon_sym_case] = ACTIONS(3455),
    [anon_sym_default] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_break] = ACTIONS(3455),
    [anon_sym_continue] = ACTIONS(3455),
    [anon_sym_goto] = ACTIONS(3455),
    [anon_sym___try] = ACTIONS(3455),
    [anon_sym___leave] = ACTIONS(3455),
    [anon_sym_not] = ACTIONS(3455),
    [anon_sym_compl] = ACTIONS(3455),
    [anon_sym_DASH_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_PLUS] = ACTIONS(3457),
    [anon_sym_sizeof] = ACTIONS(3455),
    [anon_sym___alignof__] = ACTIONS(3455),
    [anon_sym___alignof] = ACTIONS(3455),
    [anon_sym__alignof] = ACTIONS(3455),
    [anon_sym_alignof] = ACTIONS(3455),
    [anon_sym__Alignof] = ACTIONS(3455),
    [anon_sym_offsetof] = ACTIONS(3455),
    [anon_sym__Generic] = ACTIONS(3455),
    [anon_sym_asm] = ACTIONS(3455),
    [anon_sym___asm__] = ACTIONS(3455),
    [aux_sym_number_literal_token1] = ACTIONS(3457),
    [aux_sym_number_literal_token2] = ACTIONS(3455),
    [anon_sym_L_SQUOTE] = ACTIONS(3457),
    [anon_sym_u_SQUOTE] = ACTIONS(3457),
    [anon_sym_U_SQUOTE] = ACTIONS(3457),
    [anon_sym_u8_SQUOTE] = ACTIONS(3457),
    [anon_sym_SQUOTE] = ACTIONS(3457),
    [anon_sym_L_DQUOTE] = ACTIONS(3457),
    [anon_sym_u_DQUOTE] = ACTIONS(3457),
    [anon_sym_U_DQUOTE] = ACTIONS(3457),
    [anon_sym_u8_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [sym_true] = ACTIONS(3455),
    [sym_false] = ACTIONS(3455),
    [anon_sym_NULL] = ACTIONS(3455),
    [anon_sym_nullptr] = ACTIONS(3455),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3455),
    [anon_sym_decltype] = ACTIONS(3455),
    [anon_sym_virtual] = ACTIONS(3455),
    [anon_sym_alignas] = ACTIONS(3455),
    [anon_sym_explicit] = ACTIONS(3455),
    [anon_sym_typename] = ACTIONS(3455),
    [anon_sym_template] = ACTIONS(3455),
    [anon_sym_operator] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_delete] = ACTIONS(3455),
    [anon_sym_throw] = ACTIONS(3455),
    [anon_sym_namespace] = ACTIONS(3455),
    [anon_sym_using] = ACTIONS(3455),
    [anon_sym_static_assert] = ACTIONS(3455),
    [anon_sym_concept] = ACTIONS(3455),
    [anon_sym_co_return] = ACTIONS(3455),
    [anon_sym_co_yield] = ACTIONS(3455),
    [anon_sym_R_DQUOTE] = ACTIONS(3457),
    [anon_sym_LR_DQUOTE] = ACTIONS(3457),
    [anon_sym_uR_DQUOTE] = ACTIONS(3457),
    [anon_sym_UR_DQUOTE] = ACTIONS(3457),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3457),
    [anon_sym_co_await] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_requires] = ACTIONS(3455),
    [sym_this] = ACTIONS(3455),
  },
  [994] = {
    [sym_identifier] = ACTIONS(3451),
    [aux_sym_preproc_include_token1] = ACTIONS(3451),
    [aux_sym_preproc_def_token1] = ACTIONS(3451),
    [aux_sym_preproc_if_token1] = ACTIONS(3451),
    [aux_sym_preproc_if_token2] = ACTIONS(3451),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3451),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3451),
    [sym_preproc_directive] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3453),
    [anon_sym_BANG] = ACTIONS(3453),
    [anon_sym_TILDE] = ACTIONS(3453),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(3453),
    [anon_sym_AMP_AMP] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_SEMI] = ACTIONS(3453),
    [anon_sym___extension__] = ACTIONS(3451),
    [anon_sym_typedef] = ACTIONS(3451),
    [anon_sym_extern] = ACTIONS(3451),
    [anon_sym___attribute__] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3453),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3453),
    [anon_sym___declspec] = ACTIONS(3451),
    [anon_sym___based] = ACTIONS(3451),
    [anon_sym___cdecl] = ACTIONS(3451),
    [anon_sym___clrcall] = ACTIONS(3451),
    [anon_sym___stdcall] = ACTIONS(3451),
    [anon_sym___fastcall] = ACTIONS(3451),
    [anon_sym___thiscall] = ACTIONS(3451),
    [anon_sym___vectorcall] = ACTIONS(3451),
    [anon_sym_LBRACE] = ACTIONS(3453),
    [anon_sym_signed] = ACTIONS(3451),
    [anon_sym_unsigned] = ACTIONS(3451),
    [anon_sym_long] = ACTIONS(3451),
    [anon_sym_short] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_register] = ACTIONS(3451),
    [anon_sym_inline] = ACTIONS(3451),
    [anon_sym___inline] = ACTIONS(3451),
    [anon_sym___inline__] = ACTIONS(3451),
    [anon_sym___forceinline] = ACTIONS(3451),
    [anon_sym_thread_local] = ACTIONS(3451),
    [anon_sym___thread] = ACTIONS(3451),
    [anon_sym_const] = ACTIONS(3451),
    [anon_sym_constexpr] = ACTIONS(3451),
    [anon_sym_volatile] = ACTIONS(3451),
    [anon_sym_restrict] = ACTIONS(3451),
    [anon_sym___restrict__] = ACTIONS(3451),
    [anon_sym__Atomic] = ACTIONS(3451),
    [anon_sym__Noreturn] = ACTIONS(3451),
    [anon_sym_noreturn] = ACTIONS(3451),
    [anon_sym_mutable] = ACTIONS(3451),
    [anon_sym_constinit] = ACTIONS(3451),
    [anon_sym_consteval] = ACTIONS(3451),
    [anon_sym_PROGMEM] = ACTIONS(3451),
    [aux_sym_primitive_type_token1] = ACTIONS(3451),
    [anon_sym_byte] = ACTIONS(3451),
    [anon_sym_word] = ACTIONS(3451),
    [anon_sym_enum] = ACTIONS(3451),
    [anon_sym_class] = ACTIONS(3451),
    [anon_sym_struct] = ACTIONS(3451),
    [anon_sym_union] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_switch] = ACTIONS(3451),
    [anon_sym_case] = ACTIONS(3451),
    [anon_sym_default] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_break] = ACTIONS(3451),
    [anon_sym_continue] = ACTIONS(3451),
    [anon_sym_goto] = ACTIONS(3451),
    [anon_sym___try] = ACTIONS(3451),
    [anon_sym___leave] = ACTIONS(3451),
    [anon_sym_not] = ACTIONS(3451),
    [anon_sym_compl] = ACTIONS(3451),
    [anon_sym_DASH_DASH] = ACTIONS(3453),
    [anon_sym_PLUS_PLUS] = ACTIONS(3453),
    [anon_sym_sizeof] = ACTIONS(3451),
    [anon_sym___alignof__] = ACTIONS(3451),
    [anon_sym___alignof] = ACTIONS(3451),
    [anon_sym__alignof] = ACTIONS(3451),
    [anon_sym_alignof] = ACTIONS(3451),
    [anon_sym__Alignof] = ACTIONS(3451),
    [anon_sym_offsetof] = ACTIONS(3451),
    [anon_sym__Generic] = ACTIONS(3451),
    [anon_sym_asm] = ACTIONS(3451),
    [anon_sym___asm__] = ACTIONS(3451),
    [aux_sym_number_literal_token1] = ACTIONS(3453),
    [aux_sym_number_literal_token2] = ACTIONS(3451),
    [anon_sym_L_SQUOTE] = ACTIONS(3453),
    [anon_sym_u_SQUOTE] = ACTIONS(3453),
    [anon_sym_U_SQUOTE] = ACTIONS(3453),
    [anon_sym_u8_SQUOTE] = ACTIONS(3453),
    [anon_sym_SQUOTE] = ACTIONS(3453),
    [anon_sym_L_DQUOTE] = ACTIONS(3453),
    [anon_sym_u_DQUOTE] = ACTIONS(3453),
    [anon_sym_U_DQUOTE] = ACTIONS(3453),
    [anon_sym_u8_DQUOTE] = ACTIONS(3453),
    [anon_sym_DQUOTE] = ACTIONS(3453),
    [sym_true] = ACTIONS(3451),
    [sym_false] = ACTIONS(3451),
    [anon_sym_NULL] = ACTIONS(3451),
    [anon_sym_nullptr] = ACTIONS(3451),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3451),
    [anon_sym_decltype] = ACTIONS(3451),
    [anon_sym_virtual] = ACTIONS(3451),
    [anon_sym_alignas] = ACTIONS(3451),
    [anon_sym_explicit] = ACTIONS(3451),
    [anon_sym_typename] = ACTIONS(3451),
    [anon_sym_template] = ACTIONS(3451),
    [anon_sym_operator] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_delete] = ACTIONS(3451),
    [anon_sym_throw] = ACTIONS(3451),
    [anon_sym_namespace] = ACTIONS(3451),
    [anon_sym_using] = ACTIONS(3451),
    [anon_sym_static_assert] = ACTIONS(3451),
    [anon_sym_concept] = ACTIONS(3451),
    [anon_sym_co_return] = ACTIONS(3451),
    [anon_sym_co_yield] = ACTIONS(3451),
    [anon_sym_R_DQUOTE] = ACTIONS(3453),
    [anon_sym_LR_DQUOTE] = ACTIONS(3453),
    [anon_sym_uR_DQUOTE] = ACTIONS(3453),
    [anon_sym_UR_DQUOTE] = ACTIONS(3453),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3453),
    [anon_sym_co_await] = ACTIONS(3451),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_requires] = ACTIONS(3451),
    [sym_this] = ACTIONS(3451),
  },
  [995] = {
    [sym_identifier] = ACTIONS(3280),
    [aux_sym_preproc_include_token1] = ACTIONS(3280),
    [aux_sym_preproc_def_token1] = ACTIONS(3280),
    [aux_sym_preproc_if_token1] = ACTIONS(3280),
    [aux_sym_preproc_if_token2] = ACTIONS(3280),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3280),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3280),
    [sym_preproc_directive] = ACTIONS(3280),
    [anon_sym_LPAREN2] = ACTIONS(3282),
    [anon_sym_BANG] = ACTIONS(3282),
    [anon_sym_TILDE] = ACTIONS(3282),
    [anon_sym_DASH] = ACTIONS(3280),
    [anon_sym_PLUS] = ACTIONS(3280),
    [anon_sym_STAR] = ACTIONS(3282),
    [anon_sym_AMP_AMP] = ACTIONS(3282),
    [anon_sym_AMP] = ACTIONS(3280),
    [anon_sym_SEMI] = ACTIONS(3282),
    [anon_sym___extension__] = ACTIONS(3280),
    [anon_sym_typedef] = ACTIONS(3280),
    [anon_sym_extern] = ACTIONS(3280),
    [anon_sym___attribute__] = ACTIONS(3280),
    [anon_sym_COLON_COLON] = ACTIONS(3282),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3282),
    [anon_sym___declspec] = ACTIONS(3280),
    [anon_sym___based] = ACTIONS(3280),
    [anon_sym___cdecl] = ACTIONS(3280),
    [anon_sym___clrcall] = ACTIONS(3280),
    [anon_sym___stdcall] = ACTIONS(3280),
    [anon_sym___fastcall] = ACTIONS(3280),
    [anon_sym___thiscall] = ACTIONS(3280),
    [anon_sym___vectorcall] = ACTIONS(3280),
    [anon_sym_LBRACE] = ACTIONS(3282),
    [anon_sym_signed] = ACTIONS(3280),
    [anon_sym_unsigned] = ACTIONS(3280),
    [anon_sym_long] = ACTIONS(3280),
    [anon_sym_short] = ACTIONS(3280),
    [anon_sym_LBRACK] = ACTIONS(3280),
    [anon_sym_static] = ACTIONS(3280),
    [anon_sym_register] = ACTIONS(3280),
    [anon_sym_inline] = ACTIONS(3280),
    [anon_sym___inline] = ACTIONS(3280),
    [anon_sym___inline__] = ACTIONS(3280),
    [anon_sym___forceinline] = ACTIONS(3280),
    [anon_sym_thread_local] = ACTIONS(3280),
    [anon_sym___thread] = ACTIONS(3280),
    [anon_sym_const] = ACTIONS(3280),
    [anon_sym_constexpr] = ACTIONS(3280),
    [anon_sym_volatile] = ACTIONS(3280),
    [anon_sym_restrict] = ACTIONS(3280),
    [anon_sym___restrict__] = ACTIONS(3280),
    [anon_sym__Atomic] = ACTIONS(3280),
    [anon_sym__Noreturn] = ACTIONS(3280),
    [anon_sym_noreturn] = ACTIONS(3280),
    [anon_sym_mutable] = ACTIONS(3280),
    [anon_sym_constinit] = ACTIONS(3280),
    [anon_sym_consteval] = ACTIONS(3280),
    [anon_sym_PROGMEM] = ACTIONS(3280),
    [aux_sym_primitive_type_token1] = ACTIONS(3280),
    [anon_sym_byte] = ACTIONS(3280),
    [anon_sym_word] = ACTIONS(3280),
    [anon_sym_enum] = ACTIONS(3280),
    [anon_sym_class] = ACTIONS(3280),
    [anon_sym_struct] = ACTIONS(3280),
    [anon_sym_union] = ACTIONS(3280),
    [anon_sym_if] = ACTIONS(3280),
    [anon_sym_switch] = ACTIONS(3280),
    [anon_sym_case] = ACTIONS(3280),
    [anon_sym_default] = ACTIONS(3280),
    [anon_sym_while] = ACTIONS(3280),
    [anon_sym_do] = ACTIONS(3280),
    [anon_sym_for] = ACTIONS(3280),
    [anon_sym_return] = ACTIONS(3280),
    [anon_sym_break] = ACTIONS(3280),
    [anon_sym_continue] = ACTIONS(3280),
    [anon_sym_goto] = ACTIONS(3280),
    [anon_sym___try] = ACTIONS(3280),
    [anon_sym___leave] = ACTIONS(3280),
    [anon_sym_not] = ACTIONS(3280),
    [anon_sym_compl] = ACTIONS(3280),
    [anon_sym_DASH_DASH] = ACTIONS(3282),
    [anon_sym_PLUS_PLUS] = ACTIONS(3282),
    [anon_sym_sizeof] = ACTIONS(3280),
    [anon_sym___alignof__] = ACTIONS(3280),
    [anon_sym___alignof] = ACTIONS(3280),
    [anon_sym__alignof] = ACTIONS(3280),
    [anon_sym_alignof] = ACTIONS(3280),
    [anon_sym__Alignof] = ACTIONS(3280),
    [anon_sym_offsetof] = ACTIONS(3280),
    [anon_sym__Generic] = ACTIONS(3280),
    [anon_sym_asm] = ACTIONS(3280),
    [anon_sym___asm__] = ACTIONS(3280),
    [aux_sym_number_literal_token1] = ACTIONS(3282),
    [aux_sym_number_literal_token2] = ACTIONS(3280),
    [anon_sym_L_SQUOTE] = ACTIONS(3282),
    [anon_sym_u_SQUOTE] = ACTIONS(3282),
    [anon_sym_U_SQUOTE] = ACTIONS(3282),
    [anon_sym_u8_SQUOTE] = ACTIONS(3282),
    [anon_sym_SQUOTE] = ACTIONS(3282),
    [anon_sym_L_DQUOTE] = ACTIONS(3282),
    [anon_sym_u_DQUOTE] = ACTIONS(3282),
    [anon_sym_U_DQUOTE] = ACTIONS(3282),
    [anon_sym_u8_DQUOTE] = ACTIONS(3282),
    [anon_sym_DQUOTE] = ACTIONS(3282),
    [sym_true] = ACTIONS(3280),
    [sym_false] = ACTIONS(3280),
    [anon_sym_NULL] = ACTIONS(3280),
    [anon_sym_nullptr] = ACTIONS(3280),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3280),
    [anon_sym_decltype] = ACTIONS(3280),
    [anon_sym_virtual] = ACTIONS(3280),
    [anon_sym_alignas] = ACTIONS(3280),
    [anon_sym_explicit] = ACTIONS(3280),
    [anon_sym_typename] = ACTIONS(3280),
    [anon_sym_template] = ACTIONS(3280),
    [anon_sym_operator] = ACTIONS(3280),
    [anon_sym_try] = ACTIONS(3280),
    [anon_sym_delete] = ACTIONS(3280),
    [anon_sym_throw] = ACTIONS(3280),
    [anon_sym_namespace] = ACTIONS(3280),
    [anon_sym_using] = ACTIONS(3280),
    [anon_sym_static_assert] = ACTIONS(3280),
    [anon_sym_concept] = ACTIONS(3280),
    [anon_sym_co_return] = ACTIONS(3280),
    [anon_sym_co_yield] = ACTIONS(3280),
    [anon_sym_R_DQUOTE] = ACTIONS(3282),
    [anon_sym_LR_DQUOTE] = ACTIONS(3282),
    [anon_sym_uR_DQUOTE] = ACTIONS(3282),
    [anon_sym_UR_DQUOTE] = ACTIONS(3282),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3282),
    [anon_sym_co_await] = ACTIONS(3280),
    [anon_sym_new] = ACTIONS(3280),
    [anon_sym_requires] = ACTIONS(3280),
    [sym_this] = ACTIONS(3280),
  },
  [996] = {
    [sym_identifier] = ACTIONS(3186),
    [aux_sym_preproc_include_token1] = ACTIONS(3186),
    [aux_sym_preproc_def_token1] = ACTIONS(3186),
    [aux_sym_preproc_if_token1] = ACTIONS(3186),
    [aux_sym_preproc_if_token2] = ACTIONS(3186),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3186),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3186),
    [sym_preproc_directive] = ACTIONS(3186),
    [anon_sym_LPAREN2] = ACTIONS(3188),
    [anon_sym_BANG] = ACTIONS(3188),
    [anon_sym_TILDE] = ACTIONS(3188),
    [anon_sym_DASH] = ACTIONS(3186),
    [anon_sym_PLUS] = ACTIONS(3186),
    [anon_sym_STAR] = ACTIONS(3188),
    [anon_sym_AMP_AMP] = ACTIONS(3188),
    [anon_sym_AMP] = ACTIONS(3186),
    [anon_sym_SEMI] = ACTIONS(3188),
    [anon_sym___extension__] = ACTIONS(3186),
    [anon_sym_typedef] = ACTIONS(3186),
    [anon_sym_extern] = ACTIONS(3186),
    [anon_sym___attribute__] = ACTIONS(3186),
    [anon_sym_COLON_COLON] = ACTIONS(3188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3188),
    [anon_sym___declspec] = ACTIONS(3186),
    [anon_sym___based] = ACTIONS(3186),
    [anon_sym___cdecl] = ACTIONS(3186),
    [anon_sym___clrcall] = ACTIONS(3186),
    [anon_sym___stdcall] = ACTIONS(3186),
    [anon_sym___fastcall] = ACTIONS(3186),
    [anon_sym___thiscall] = ACTIONS(3186),
    [anon_sym___vectorcall] = ACTIONS(3186),
    [anon_sym_LBRACE] = ACTIONS(3188),
    [anon_sym_signed] = ACTIONS(3186),
    [anon_sym_unsigned] = ACTIONS(3186),
    [anon_sym_long] = ACTIONS(3186),
    [anon_sym_short] = ACTIONS(3186),
    [anon_sym_LBRACK] = ACTIONS(3186),
    [anon_sym_static] = ACTIONS(3186),
    [anon_sym_register] = ACTIONS(3186),
    [anon_sym_inline] = ACTIONS(3186),
    [anon_sym___inline] = ACTIONS(3186),
    [anon_sym___inline__] = ACTIONS(3186),
    [anon_sym___forceinline] = ACTIONS(3186),
    [anon_sym_thread_local] = ACTIONS(3186),
    [anon_sym___thread] = ACTIONS(3186),
    [anon_sym_const] = ACTIONS(3186),
    [anon_sym_constexpr] = ACTIONS(3186),
    [anon_sym_volatile] = ACTIONS(3186),
    [anon_sym_restrict] = ACTIONS(3186),
    [anon_sym___restrict__] = ACTIONS(3186),
    [anon_sym__Atomic] = ACTIONS(3186),
    [anon_sym__Noreturn] = ACTIONS(3186),
    [anon_sym_noreturn] = ACTIONS(3186),
    [anon_sym_mutable] = ACTIONS(3186),
    [anon_sym_constinit] = ACTIONS(3186),
    [anon_sym_consteval] = ACTIONS(3186),
    [anon_sym_PROGMEM] = ACTIONS(3186),
    [aux_sym_primitive_type_token1] = ACTIONS(3186),
    [anon_sym_byte] = ACTIONS(3186),
    [anon_sym_word] = ACTIONS(3186),
    [anon_sym_enum] = ACTIONS(3186),
    [anon_sym_class] = ACTIONS(3186),
    [anon_sym_struct] = ACTIONS(3186),
    [anon_sym_union] = ACTIONS(3186),
    [anon_sym_if] = ACTIONS(3186),
    [anon_sym_switch] = ACTIONS(3186),
    [anon_sym_case] = ACTIONS(3186),
    [anon_sym_default] = ACTIONS(3186),
    [anon_sym_while] = ACTIONS(3186),
    [anon_sym_do] = ACTIONS(3186),
    [anon_sym_for] = ACTIONS(3186),
    [anon_sym_return] = ACTIONS(3186),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_continue] = ACTIONS(3186),
    [anon_sym_goto] = ACTIONS(3186),
    [anon_sym___try] = ACTIONS(3186),
    [anon_sym___leave] = ACTIONS(3186),
    [anon_sym_not] = ACTIONS(3186),
    [anon_sym_compl] = ACTIONS(3186),
    [anon_sym_DASH_DASH] = ACTIONS(3188),
    [anon_sym_PLUS_PLUS] = ACTIONS(3188),
    [anon_sym_sizeof] = ACTIONS(3186),
    [anon_sym___alignof__] = ACTIONS(3186),
    [anon_sym___alignof] = ACTIONS(3186),
    [anon_sym__alignof] = ACTIONS(3186),
    [anon_sym_alignof] = ACTIONS(3186),
    [anon_sym__Alignof] = ACTIONS(3186),
    [anon_sym_offsetof] = ACTIONS(3186),
    [anon_sym__Generic] = ACTIONS(3186),
    [anon_sym_asm] = ACTIONS(3186),
    [anon_sym___asm__] = ACTIONS(3186),
    [aux_sym_number_literal_token1] = ACTIONS(3188),
    [aux_sym_number_literal_token2] = ACTIONS(3186),
    [anon_sym_L_SQUOTE] = ACTIONS(3188),
    [anon_sym_u_SQUOTE] = ACTIONS(3188),
    [anon_sym_U_SQUOTE] = ACTIONS(3188),
    [anon_sym_u8_SQUOTE] = ACTIONS(3188),
    [anon_sym_SQUOTE] = ACTIONS(3188),
    [anon_sym_L_DQUOTE] = ACTIONS(3188),
    [anon_sym_u_DQUOTE] = ACTIONS(3188),
    [anon_sym_U_DQUOTE] = ACTIONS(3188),
    [anon_sym_u8_DQUOTE] = ACTIONS(3188),
    [anon_sym_DQUOTE] = ACTIONS(3188),
    [sym_true] = ACTIONS(3186),
    [sym_false] = ACTIONS(3186),
    [anon_sym_NULL] = ACTIONS(3186),
    [anon_sym_nullptr] = ACTIONS(3186),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3186),
    [anon_sym_decltype] = ACTIONS(3186),
    [anon_sym_virtual] = ACTIONS(3186),
    [anon_sym_alignas] = ACTIONS(3186),
    [anon_sym_explicit] = ACTIONS(3186),
    [anon_sym_typename] = ACTIONS(3186),
    [anon_sym_template] = ACTIONS(3186),
    [anon_sym_operator] = ACTIONS(3186),
    [anon_sym_try] = ACTIONS(3186),
    [anon_sym_delete] = ACTIONS(3186),
    [anon_sym_throw] = ACTIONS(3186),
    [anon_sym_namespace] = ACTIONS(3186),
    [anon_sym_using] = ACTIONS(3186),
    [anon_sym_static_assert] = ACTIONS(3186),
    [anon_sym_concept] = ACTIONS(3186),
    [anon_sym_co_return] = ACTIONS(3186),
    [anon_sym_co_yield] = ACTIONS(3186),
    [anon_sym_R_DQUOTE] = ACTIONS(3188),
    [anon_sym_LR_DQUOTE] = ACTIONS(3188),
    [anon_sym_uR_DQUOTE] = ACTIONS(3188),
    [anon_sym_UR_DQUOTE] = ACTIONS(3188),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3188),
    [anon_sym_co_await] = ACTIONS(3186),
    [anon_sym_new] = ACTIONS(3186),
    [anon_sym_requires] = ACTIONS(3186),
    [sym_this] = ACTIONS(3186),
  },
  [997] = {
    [sym_identifier] = ACTIONS(3435),
    [aux_sym_preproc_include_token1] = ACTIONS(3435),
    [aux_sym_preproc_def_token1] = ACTIONS(3435),
    [aux_sym_preproc_if_token1] = ACTIONS(3435),
    [aux_sym_preproc_if_token2] = ACTIONS(3435),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3435),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3435),
    [sym_preproc_directive] = ACTIONS(3435),
    [anon_sym_LPAREN2] = ACTIONS(3437),
    [anon_sym_BANG] = ACTIONS(3437),
    [anon_sym_TILDE] = ACTIONS(3437),
    [anon_sym_DASH] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3435),
    [anon_sym_STAR] = ACTIONS(3437),
    [anon_sym_AMP_AMP] = ACTIONS(3437),
    [anon_sym_AMP] = ACTIONS(3435),
    [anon_sym_SEMI] = ACTIONS(3437),
    [anon_sym___extension__] = ACTIONS(3435),
    [anon_sym_typedef] = ACTIONS(3435),
    [anon_sym_extern] = ACTIONS(3435),
    [anon_sym___attribute__] = ACTIONS(3435),
    [anon_sym_COLON_COLON] = ACTIONS(3437),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3437),
    [anon_sym___declspec] = ACTIONS(3435),
    [anon_sym___based] = ACTIONS(3435),
    [anon_sym___cdecl] = ACTIONS(3435),
    [anon_sym___clrcall] = ACTIONS(3435),
    [anon_sym___stdcall] = ACTIONS(3435),
    [anon_sym___fastcall] = ACTIONS(3435),
    [anon_sym___thiscall] = ACTIONS(3435),
    [anon_sym___vectorcall] = ACTIONS(3435),
    [anon_sym_LBRACE] = ACTIONS(3437),
    [anon_sym_signed] = ACTIONS(3435),
    [anon_sym_unsigned] = ACTIONS(3435),
    [anon_sym_long] = ACTIONS(3435),
    [anon_sym_short] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3435),
    [anon_sym_static] = ACTIONS(3435),
    [anon_sym_register] = ACTIONS(3435),
    [anon_sym_inline] = ACTIONS(3435),
    [anon_sym___inline] = ACTIONS(3435),
    [anon_sym___inline__] = ACTIONS(3435),
    [anon_sym___forceinline] = ACTIONS(3435),
    [anon_sym_thread_local] = ACTIONS(3435),
    [anon_sym___thread] = ACTIONS(3435),
    [anon_sym_const] = ACTIONS(3435),
    [anon_sym_constexpr] = ACTIONS(3435),
    [anon_sym_volatile] = ACTIONS(3435),
    [anon_sym_restrict] = ACTIONS(3435),
    [anon_sym___restrict__] = ACTIONS(3435),
    [anon_sym__Atomic] = ACTIONS(3435),
    [anon_sym__Noreturn] = ACTIONS(3435),
    [anon_sym_noreturn] = ACTIONS(3435),
    [anon_sym_mutable] = ACTIONS(3435),
    [anon_sym_constinit] = ACTIONS(3435),
    [anon_sym_consteval] = ACTIONS(3435),
    [anon_sym_PROGMEM] = ACTIONS(3435),
    [aux_sym_primitive_type_token1] = ACTIONS(3435),
    [anon_sym_byte] = ACTIONS(3435),
    [anon_sym_word] = ACTIONS(3435),
    [anon_sym_enum] = ACTIONS(3435),
    [anon_sym_class] = ACTIONS(3435),
    [anon_sym_struct] = ACTIONS(3435),
    [anon_sym_union] = ACTIONS(3435),
    [anon_sym_if] = ACTIONS(3435),
    [anon_sym_switch] = ACTIONS(3435),
    [anon_sym_case] = ACTIONS(3435),
    [anon_sym_default] = ACTIONS(3435),
    [anon_sym_while] = ACTIONS(3435),
    [anon_sym_do] = ACTIONS(3435),
    [anon_sym_for] = ACTIONS(3435),
    [anon_sym_return] = ACTIONS(3435),
    [anon_sym_break] = ACTIONS(3435),
    [anon_sym_continue] = ACTIONS(3435),
    [anon_sym_goto] = ACTIONS(3435),
    [anon_sym___try] = ACTIONS(3435),
    [anon_sym___leave] = ACTIONS(3435),
    [anon_sym_not] = ACTIONS(3435),
    [anon_sym_compl] = ACTIONS(3435),
    [anon_sym_DASH_DASH] = ACTIONS(3437),
    [anon_sym_PLUS_PLUS] = ACTIONS(3437),
    [anon_sym_sizeof] = ACTIONS(3435),
    [anon_sym___alignof__] = ACTIONS(3435),
    [anon_sym___alignof] = ACTIONS(3435),
    [anon_sym__alignof] = ACTIONS(3435),
    [anon_sym_alignof] = ACTIONS(3435),
    [anon_sym__Alignof] = ACTIONS(3435),
    [anon_sym_offsetof] = ACTIONS(3435),
    [anon_sym__Generic] = ACTIONS(3435),
    [anon_sym_asm] = ACTIONS(3435),
    [anon_sym___asm__] = ACTIONS(3435),
    [aux_sym_number_literal_token1] = ACTIONS(3437),
    [aux_sym_number_literal_token2] = ACTIONS(3435),
    [anon_sym_L_SQUOTE] = ACTIONS(3437),
    [anon_sym_u_SQUOTE] = ACTIONS(3437),
    [anon_sym_U_SQUOTE] = ACTIONS(3437),
    [anon_sym_u8_SQUOTE] = ACTIONS(3437),
    [anon_sym_SQUOTE] = ACTIONS(3437),
    [anon_sym_L_DQUOTE] = ACTIONS(3437),
    [anon_sym_u_DQUOTE] = ACTIONS(3437),
    [anon_sym_U_DQUOTE] = ACTIONS(3437),
    [anon_sym_u8_DQUOTE] = ACTIONS(3437),
    [anon_sym_DQUOTE] = ACTIONS(3437),
    [sym_true] = ACTIONS(3435),
    [sym_false] = ACTIONS(3435),
    [anon_sym_NULL] = ACTIONS(3435),
    [anon_sym_nullptr] = ACTIONS(3435),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3435),
    [anon_sym_decltype] = ACTIONS(3435),
    [anon_sym_virtual] = ACTIONS(3435),
    [anon_sym_alignas] = ACTIONS(3435),
    [anon_sym_explicit] = ACTIONS(3435),
    [anon_sym_typename] = ACTIONS(3435),
    [anon_sym_template] = ACTIONS(3435),
    [anon_sym_operator] = ACTIONS(3435),
    [anon_sym_try] = ACTIONS(3435),
    [anon_sym_delete] = ACTIONS(3435),
    [anon_sym_throw] = ACTIONS(3435),
    [anon_sym_namespace] = ACTIONS(3435),
    [anon_sym_using] = ACTIONS(3435),
    [anon_sym_static_assert] = ACTIONS(3435),
    [anon_sym_concept] = ACTIONS(3435),
    [anon_sym_co_return] = ACTIONS(3435),
    [anon_sym_co_yield] = ACTIONS(3435),
    [anon_sym_R_DQUOTE] = ACTIONS(3437),
    [anon_sym_LR_DQUOTE] = ACTIONS(3437),
    [anon_sym_uR_DQUOTE] = ACTIONS(3437),
    [anon_sym_UR_DQUOTE] = ACTIONS(3437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3437),
    [anon_sym_co_await] = ACTIONS(3435),
    [anon_sym_new] = ACTIONS(3435),
    [anon_sym_requires] = ACTIONS(3435),
    [sym_this] = ACTIONS(3435),
  },
  [998] = {
    [ts_builtin_sym_end] = ACTIONS(3389),
    [sym_identifier] = ACTIONS(3387),
    [aux_sym_preproc_include_token1] = ACTIONS(3387),
    [aux_sym_preproc_def_token1] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [aux_sym_preproc_if_token1] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3387),
    [sym_preproc_directive] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_BANG] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_STAR] = ACTIONS(3389),
    [anon_sym_AMP_AMP] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym___extension__] = ACTIONS(3387),
    [anon_sym_typedef] = ACTIONS(3387),
    [anon_sym_extern] = ACTIONS(3387),
    [anon_sym___attribute__] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3389),
    [anon_sym___declspec] = ACTIONS(3387),
    [anon_sym___based] = ACTIONS(3387),
    [anon_sym___cdecl] = ACTIONS(3387),
    [anon_sym___clrcall] = ACTIONS(3387),
    [anon_sym___stdcall] = ACTIONS(3387),
    [anon_sym___fastcall] = ACTIONS(3387),
    [anon_sym___thiscall] = ACTIONS(3387),
    [anon_sym___vectorcall] = ACTIONS(3387),
    [anon_sym_LBRACE] = ACTIONS(3389),
    [anon_sym_RBRACE] = ACTIONS(3389),
    [anon_sym_signed] = ACTIONS(3387),
    [anon_sym_unsigned] = ACTIONS(3387),
    [anon_sym_long] = ACTIONS(3387),
    [anon_sym_short] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_register] = ACTIONS(3387),
    [anon_sym_inline] = ACTIONS(3387),
    [anon_sym___inline] = ACTIONS(3387),
    [anon_sym___inline__] = ACTIONS(3387),
    [anon_sym___forceinline] = ACTIONS(3387),
    [anon_sym_thread_local] = ACTIONS(3387),
    [anon_sym___thread] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_constexpr] = ACTIONS(3387),
    [anon_sym_volatile] = ACTIONS(3387),
    [anon_sym_restrict] = ACTIONS(3387),
    [anon_sym___restrict__] = ACTIONS(3387),
    [anon_sym__Atomic] = ACTIONS(3387),
    [anon_sym__Noreturn] = ACTIONS(3387),
    [anon_sym_noreturn] = ACTIONS(3387),
    [anon_sym_mutable] = ACTIONS(3387),
    [anon_sym_constinit] = ACTIONS(3387),
    [anon_sym_consteval] = ACTIONS(3387),
    [anon_sym_PROGMEM] = ACTIONS(3387),
    [aux_sym_primitive_type_token1] = ACTIONS(3387),
    [anon_sym_byte] = ACTIONS(3387),
    [anon_sym_word] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [anon_sym_class] = ACTIONS(3387),
    [anon_sym_struct] = ACTIONS(3387),
    [anon_sym_union] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_switch] = ACTIONS(3387),
    [anon_sym_case] = ACTIONS(3387),
    [anon_sym_default] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_break] = ACTIONS(3387),
    [anon_sym_continue] = ACTIONS(3387),
    [anon_sym_goto] = ACTIONS(3387),
    [anon_sym_not] = ACTIONS(3387),
    [anon_sym_compl] = ACTIONS(3387),
    [anon_sym_DASH_DASH] = ACTIONS(3389),
    [anon_sym_PLUS_PLUS] = ACTIONS(3389),
    [anon_sym_sizeof] = ACTIONS(3387),
    [anon_sym___alignof__] = ACTIONS(3387),
    [anon_sym___alignof] = ACTIONS(3387),
    [anon_sym__alignof] = ACTIONS(3387),
    [anon_sym_alignof] = ACTIONS(3387),
    [anon_sym__Alignof] = ACTIONS(3387),
    [anon_sym_offsetof] = ACTIONS(3387),
    [anon_sym__Generic] = ACTIONS(3387),
    [anon_sym_asm] = ACTIONS(3387),
    [anon_sym___asm__] = ACTIONS(3387),
    [aux_sym_number_literal_token1] = ACTIONS(3389),
    [aux_sym_number_literal_token2] = ACTIONS(3387),
    [anon_sym_L_SQUOTE] = ACTIONS(3389),
    [anon_sym_u_SQUOTE] = ACTIONS(3389),
    [anon_sym_U_SQUOTE] = ACTIONS(3389),
    [anon_sym_u8_SQUOTE] = ACTIONS(3389),
    [anon_sym_SQUOTE] = ACTIONS(3389),
    [anon_sym_L_DQUOTE] = ACTIONS(3389),
    [anon_sym_u_DQUOTE] = ACTIONS(3389),
    [anon_sym_U_DQUOTE] = ACTIONS(3389),
    [anon_sym_u8_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE] = ACTIONS(3389),
    [sym_true] = ACTIONS(3387),
    [sym_false] = ACTIONS(3387),
    [anon_sym_NULL] = ACTIONS(3387),
    [anon_sym_nullptr] = ACTIONS(3387),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3387),
    [anon_sym_decltype] = ACTIONS(3387),
    [anon_sym_virtual] = ACTIONS(3387),
    [anon_sym_alignas] = ACTIONS(3387),
    [anon_sym_explicit] = ACTIONS(3387),
    [anon_sym_typename] = ACTIONS(3387),
    [anon_sym_template] = ACTIONS(3387),
    [anon_sym_operator] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_delete] = ACTIONS(3387),
    [anon_sym_throw] = ACTIONS(3387),
    [anon_sym_namespace] = ACTIONS(3387),
    [anon_sym_using] = ACTIONS(3387),
    [anon_sym_static_assert] = ACTIONS(3387),
    [anon_sym_concept] = ACTIONS(3387),
    [anon_sym_co_return] = ACTIONS(3387),
    [anon_sym_co_yield] = ACTIONS(3387),
    [anon_sym_R_DQUOTE] = ACTIONS(3389),
    [anon_sym_LR_DQUOTE] = ACTIONS(3389),
    [anon_sym_uR_DQUOTE] = ACTIONS(3389),
    [anon_sym_UR_DQUOTE] = ACTIONS(3389),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3389),
    [anon_sym_co_await] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_requires] = ACTIONS(3387),
    [sym_this] = ACTIONS(3387),
  },
  [999] = {
    [ts_builtin_sym_end] = ACTIONS(3449),
    [sym_identifier] = ACTIONS(3447),
    [aux_sym_preproc_include_token1] = ACTIONS(3447),
    [aux_sym_preproc_def_token1] = ACTIONS(3447),
    [anon_sym_COMMA] = ACTIONS(3449),
    [aux_sym_preproc_if_token1] = ACTIONS(3447),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3447),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3447),
    [sym_preproc_directive] = ACTIONS(3447),
    [anon_sym_LPAREN2] = ACTIONS(3449),
    [anon_sym_BANG] = ACTIONS(3449),
    [anon_sym_TILDE] = ACTIONS(3449),
    [anon_sym_DASH] = ACTIONS(3447),
    [anon_sym_PLUS] = ACTIONS(3447),
    [anon_sym_STAR] = ACTIONS(3449),
    [anon_sym_AMP_AMP] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3447),
    [anon_sym___extension__] = ACTIONS(3447),
    [anon_sym_typedef] = ACTIONS(3447),
    [anon_sym_extern] = ACTIONS(3447),
    [anon_sym___attribute__] = ACTIONS(3447),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3449),
    [anon_sym___declspec] = ACTIONS(3447),
    [anon_sym___based] = ACTIONS(3447),
    [anon_sym___cdecl] = ACTIONS(3447),
    [anon_sym___clrcall] = ACTIONS(3447),
    [anon_sym___stdcall] = ACTIONS(3447),
    [anon_sym___fastcall] = ACTIONS(3447),
    [anon_sym___thiscall] = ACTIONS(3447),
    [anon_sym___vectorcall] = ACTIONS(3447),
    [anon_sym_LBRACE] = ACTIONS(3449),
    [anon_sym_RBRACE] = ACTIONS(3449),
    [anon_sym_signed] = ACTIONS(3447),
    [anon_sym_unsigned] = ACTIONS(3447),
    [anon_sym_long] = ACTIONS(3447),
    [anon_sym_short] = ACTIONS(3447),
    [anon_sym_LBRACK] = ACTIONS(3447),
    [anon_sym_static] = ACTIONS(3447),
    [anon_sym_register] = ACTIONS(3447),
    [anon_sym_inline] = ACTIONS(3447),
    [anon_sym___inline] = ACTIONS(3447),
    [anon_sym___inline__] = ACTIONS(3447),
    [anon_sym___forceinline] = ACTIONS(3447),
    [anon_sym_thread_local] = ACTIONS(3447),
    [anon_sym___thread] = ACTIONS(3447),
    [anon_sym_const] = ACTIONS(3447),
    [anon_sym_constexpr] = ACTIONS(3447),
    [anon_sym_volatile] = ACTIONS(3447),
    [anon_sym_restrict] = ACTIONS(3447),
    [anon_sym___restrict__] = ACTIONS(3447),
    [anon_sym__Atomic] = ACTIONS(3447),
    [anon_sym__Noreturn] = ACTIONS(3447),
    [anon_sym_noreturn] = ACTIONS(3447),
    [anon_sym_mutable] = ACTIONS(3447),
    [anon_sym_constinit] = ACTIONS(3447),
    [anon_sym_consteval] = ACTIONS(3447),
    [anon_sym_PROGMEM] = ACTIONS(3447),
    [aux_sym_primitive_type_token1] = ACTIONS(3447),
    [anon_sym_byte] = ACTIONS(3447),
    [anon_sym_word] = ACTIONS(3447),
    [anon_sym_enum] = ACTIONS(3447),
    [anon_sym_class] = ACTIONS(3447),
    [anon_sym_struct] = ACTIONS(3447),
    [anon_sym_union] = ACTIONS(3447),
    [anon_sym_if] = ACTIONS(3447),
    [anon_sym_switch] = ACTIONS(3447),
    [anon_sym_case] = ACTIONS(3447),
    [anon_sym_default] = ACTIONS(3447),
    [anon_sym_while] = ACTIONS(3447),
    [anon_sym_do] = ACTIONS(3447),
    [anon_sym_for] = ACTIONS(3447),
    [anon_sym_return] = ACTIONS(3447),
    [anon_sym_break] = ACTIONS(3447),
    [anon_sym_continue] = ACTIONS(3447),
    [anon_sym_goto] = ACTIONS(3447),
    [anon_sym_not] = ACTIONS(3447),
    [anon_sym_compl] = ACTIONS(3447),
    [anon_sym_DASH_DASH] = ACTIONS(3449),
    [anon_sym_PLUS_PLUS] = ACTIONS(3449),
    [anon_sym_sizeof] = ACTIONS(3447),
    [anon_sym___alignof__] = ACTIONS(3447),
    [anon_sym___alignof] = ACTIONS(3447),
    [anon_sym__alignof] = ACTIONS(3447),
    [anon_sym_alignof] = ACTIONS(3447),
    [anon_sym__Alignof] = ACTIONS(3447),
    [anon_sym_offsetof] = ACTIONS(3447),
    [anon_sym__Generic] = ACTIONS(3447),
    [anon_sym_asm] = ACTIONS(3447),
    [anon_sym___asm__] = ACTIONS(3447),
    [aux_sym_number_literal_token1] = ACTIONS(3449),
    [aux_sym_number_literal_token2] = ACTIONS(3447),
    [anon_sym_L_SQUOTE] = ACTIONS(3449),
    [anon_sym_u_SQUOTE] = ACTIONS(3449),
    [anon_sym_U_SQUOTE] = ACTIONS(3449),
    [anon_sym_u8_SQUOTE] = ACTIONS(3449),
    [anon_sym_SQUOTE] = ACTIONS(3449),
    [anon_sym_L_DQUOTE] = ACTIONS(3449),
    [anon_sym_u_DQUOTE] = ACTIONS(3449),
    [anon_sym_U_DQUOTE] = ACTIONS(3449),
    [anon_sym_u8_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE] = ACTIONS(3449),
    [sym_true] = ACTIONS(3447),
    [sym_false] = ACTIONS(3447),
    [anon_sym_NULL] = ACTIONS(3447),
    [anon_sym_nullptr] = ACTIONS(3447),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3447),
    [anon_sym_decltype] = ACTIONS(3447),
    [anon_sym_virtual] = ACTIONS(3447),
    [anon_sym_alignas] = ACTIONS(3447),
    [anon_sym_explicit] = ACTIONS(3447),
    [anon_sym_typename] = ACTIONS(3447),
    [anon_sym_template] = ACTIONS(3447),
    [anon_sym_operator] = ACTIONS(3447),
    [anon_sym_try] = ACTIONS(3447),
    [anon_sym_delete] = ACTIONS(3447),
    [anon_sym_throw] = ACTIONS(3447),
    [anon_sym_namespace] = ACTIONS(3447),
    [anon_sym_using] = ACTIONS(3447),
    [anon_sym_static_assert] = ACTIONS(3447),
    [anon_sym_concept] = ACTIONS(3447),
    [anon_sym_co_return] = ACTIONS(3447),
    [anon_sym_co_yield] = ACTIONS(3447),
    [anon_sym_R_DQUOTE] = ACTIONS(3449),
    [anon_sym_LR_DQUOTE] = ACTIONS(3449),
    [anon_sym_uR_DQUOTE] = ACTIONS(3449),
    [anon_sym_UR_DQUOTE] = ACTIONS(3449),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3449),
    [anon_sym_co_await] = ACTIONS(3447),
    [anon_sym_new] = ACTIONS(3447),
    [anon_sym_requires] = ACTIONS(3447),
    [sym_this] = ACTIONS(3447),
  },
  [1000] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4519),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(4671),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2151),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_RPAREN] = ACTIONS(2151),
    [anon_sym_LPAREN2] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(2151),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_PERCENT] = ACTIONS(2151),
    [anon_sym_PIPE_PIPE] = ACTIONS(2151),
    [anon_sym_AMP_AMP] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(2149),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2149),
    [anon_sym_EQ_EQ] = ACTIONS(2151),
    [anon_sym_BANG_EQ] = ACTIONS(2151),
    [anon_sym_GT] = ACTIONS(2149),
    [anon_sym_GT_EQ] = ACTIONS(2151),
    [anon_sym_LT_EQ] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_LT_LT] = ACTIONS(2151),
    [anon_sym_GT_GT] = ACTIONS(2151),
    [anon_sym_SEMI] = ACTIONS(2151),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(2151),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_LT_EQ_GT] = ACTIONS(2151),
    [anon_sym_or] = ACTIONS(2149),
    [anon_sym_and] = ACTIONS(2149),
    [anon_sym_bitor] = ACTIONS(2149),
    [anon_sym_xor] = ACTIONS(2149),
    [anon_sym_bitand] = ACTIONS(2149),
    [anon_sym_not_eq] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(2149),
    [anon_sym_DOT_STAR] = ACTIONS(2151),
    [anon_sym_DASH_GT] = ACTIONS(2151),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1001] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4982),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_initializer_list] = STATE(5208),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(2149),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2151),
    [anon_sym_COMMA] = ACTIONS(2151),
    [aux_sym_preproc_if_token2] = ACTIONS(2151),
    [aux_sym_preproc_else_token1] = ACTIONS(2151),
    [aux_sym_preproc_elif_token1] = ACTIONS(2151),
    [anon_sym_LPAREN2] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(3723),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(2151),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_PERCENT] = ACTIONS(2151),
    [anon_sym_PIPE_PIPE] = ACTIONS(2151),
    [anon_sym_AMP_AMP] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(2149),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2149),
    [anon_sym_EQ_EQ] = ACTIONS(2151),
    [anon_sym_BANG_EQ] = ACTIONS(2151),
    [anon_sym_GT] = ACTIONS(2149),
    [anon_sym_GT_EQ] = ACTIONS(2151),
    [anon_sym_LT_EQ] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_LT_LT] = ACTIONS(2151),
    [anon_sym_GT_GT] = ACTIONS(2151),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACE] = ACTIONS(3729),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_LT_EQ_GT] = ACTIONS(2151),
    [anon_sym_or] = ACTIONS(2149),
    [anon_sym_and] = ACTIONS(2149),
    [anon_sym_bitor] = ACTIONS(2149),
    [anon_sym_xor] = ACTIONS(2149),
    [anon_sym_bitand] = ACTIONS(2149),
    [anon_sym_not_eq] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [anon_sym_DOT] = ACTIONS(2149),
    [anon_sym_DOT_STAR] = ACTIONS(2151),
    [anon_sym_DASH_GT] = ACTIONS(2151),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1002] = {
    [sym_preproc_def] = STATE(1002),
    [sym_preproc_function_def] = STATE(1002),
    [sym_preproc_call] = STATE(1002),
    [sym_preproc_if_in_field_declaration_list] = STATE(1002),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1002),
    [sym_type_definition] = STATE(1002),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6507),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7114),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1002),
    [sym_field_declaration] = STATE(1002),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2150),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1002),
    [sym_operator_cast] = STATE(7493),
    [sym_inline_method_definition] = STATE(1002),
    [sym__constructor_specifiers] = STATE(2150),
    [sym_operator_cast_definition] = STATE(1002),
    [sym_operator_cast_declaration] = STATE(1002),
    [sym_constructor_or_destructor_definition] = STATE(1002),
    [sym_constructor_or_destructor_declaration] = STATE(1002),
    [sym_friend_declaration] = STATE(1002),
    [sym_access_specifier] = STATE(9075),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1002),
    [sym_alias_declaration] = STATE(1002),
    [sym_static_assert_declaration] = STATE(1002),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7493),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1002),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2150),
    [sym_identifier] = ACTIONS(3605),
    [aux_sym_preproc_def_token1] = ACTIONS(3763),
    [aux_sym_preproc_if_token1] = ACTIONS(3766),
    [aux_sym_preproc_if_token2] = ACTIONS(3614),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3769),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3769),
    [aux_sym_preproc_else_token1] = ACTIONS(3614),
    [aux_sym_preproc_elif_token1] = ACTIONS(3614),
    [sym_preproc_directive] = ACTIONS(3772),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_TILDE] = ACTIONS(3625),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_AMP_AMP] = ACTIONS(3631),
    [anon_sym_AMP] = ACTIONS(3634),
    [anon_sym___extension__] = ACTIONS(3775),
    [anon_sym_typedef] = ACTIONS(3778),
    [anon_sym_extern] = ACTIONS(3643),
    [anon_sym___attribute__] = ACTIONS(3646),
    [anon_sym_COLON_COLON] = ACTIONS(3649),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3652),
    [anon_sym___declspec] = ACTIONS(3655),
    [anon_sym___based] = ACTIONS(3658),
    [anon_sym_signed] = ACTIONS(3661),
    [anon_sym_unsigned] = ACTIONS(3661),
    [anon_sym_long] = ACTIONS(3661),
    [anon_sym_short] = ACTIONS(3661),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_static] = ACTIONS(3643),
    [anon_sym_register] = ACTIONS(3643),
    [anon_sym_inline] = ACTIONS(3643),
    [anon_sym___inline] = ACTIONS(3643),
    [anon_sym___inline__] = ACTIONS(3643),
    [anon_sym___forceinline] = ACTIONS(3643),
    [anon_sym_thread_local] = ACTIONS(3643),
    [anon_sym___thread] = ACTIONS(3643),
    [anon_sym_const] = ACTIONS(3667),
    [anon_sym_constexpr] = ACTIONS(3667),
    [anon_sym_volatile] = ACTIONS(3667),
    [anon_sym_restrict] = ACTIONS(3667),
    [anon_sym___restrict__] = ACTIONS(3667),
    [anon_sym__Atomic] = ACTIONS(3667),
    [anon_sym__Noreturn] = ACTIONS(3667),
    [anon_sym_noreturn] = ACTIONS(3667),
    [anon_sym_mutable] = ACTIONS(3667),
    [anon_sym_constinit] = ACTIONS(3667),
    [anon_sym_consteval] = ACTIONS(3667),
    [anon_sym_PROGMEM] = ACTIONS(3667),
    [aux_sym_primitive_type_token1] = ACTIONS(3670),
    [anon_sym_byte] = ACTIONS(3670),
    [anon_sym_word] = ACTIONS(3670),
    [anon_sym_enum] = ACTIONS(3673),
    [anon_sym_class] = ACTIONS(3676),
    [anon_sym_struct] = ACTIONS(3679),
    [anon_sym_union] = ACTIONS(3682),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3685),
    [anon_sym_decltype] = ACTIONS(3688),
    [anon_sym_virtual] = ACTIONS(3691),
    [anon_sym_alignas] = ACTIONS(3694),
    [anon_sym_explicit] = ACTIONS(3697),
    [anon_sym_typename] = ACTIONS(3700),
    [anon_sym_template] = ACTIONS(3781),
    [anon_sym_operator] = ACTIONS(3706),
    [anon_sym_friend] = ACTIONS(3784),
    [anon_sym_public] = ACTIONS(3712),
    [anon_sym_private] = ACTIONS(3712),
    [anon_sym_protected] = ACTIONS(3712),
    [anon_sym_using] = ACTIONS(3787),
    [anon_sym_static_assert] = ACTIONS(3790),
  },
  [1003] = {
    [ts_builtin_sym_end] = ACTIONS(3473),
    [sym_identifier] = ACTIONS(3471),
    [aux_sym_preproc_include_token1] = ACTIONS(3471),
    [aux_sym_preproc_def_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token1] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3471),
    [sym_preproc_directive] = ACTIONS(3471),
    [anon_sym_LPAREN2] = ACTIONS(3473),
    [anon_sym_BANG] = ACTIONS(3473),
    [anon_sym_TILDE] = ACTIONS(3473),
    [anon_sym_DASH] = ACTIONS(3471),
    [anon_sym_PLUS] = ACTIONS(3471),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_AMP_AMP] = ACTIONS(3473),
    [anon_sym_AMP] = ACTIONS(3471),
    [anon_sym_SEMI] = ACTIONS(3793),
    [anon_sym___extension__] = ACTIONS(3471),
    [anon_sym_typedef] = ACTIONS(3471),
    [anon_sym_extern] = ACTIONS(3471),
    [anon_sym___attribute__] = ACTIONS(3471),
    [anon_sym_COLON_COLON] = ACTIONS(3473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3473),
    [anon_sym___declspec] = ACTIONS(3471),
    [anon_sym___based] = ACTIONS(3471),
    [anon_sym___cdecl] = ACTIONS(3471),
    [anon_sym___clrcall] = ACTIONS(3471),
    [anon_sym___stdcall] = ACTIONS(3471),
    [anon_sym___fastcall] = ACTIONS(3471),
    [anon_sym___thiscall] = ACTIONS(3471),
    [anon_sym___vectorcall] = ACTIONS(3471),
    [anon_sym_LBRACE] = ACTIONS(3473),
    [anon_sym_signed] = ACTIONS(3471),
    [anon_sym_unsigned] = ACTIONS(3471),
    [anon_sym_long] = ACTIONS(3471),
    [anon_sym_short] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [anon_sym_static] = ACTIONS(3471),
    [anon_sym_register] = ACTIONS(3471),
    [anon_sym_inline] = ACTIONS(3471),
    [anon_sym___inline] = ACTIONS(3471),
    [anon_sym___inline__] = ACTIONS(3471),
    [anon_sym___forceinline] = ACTIONS(3471),
    [anon_sym_thread_local] = ACTIONS(3471),
    [anon_sym___thread] = ACTIONS(3471),
    [anon_sym_const] = ACTIONS(3471),
    [anon_sym_constexpr] = ACTIONS(3471),
    [anon_sym_volatile] = ACTIONS(3471),
    [anon_sym_restrict] = ACTIONS(3471),
    [anon_sym___restrict__] = ACTIONS(3471),
    [anon_sym__Atomic] = ACTIONS(3471),
    [anon_sym__Noreturn] = ACTIONS(3471),
    [anon_sym_noreturn] = ACTIONS(3471),
    [anon_sym_mutable] = ACTIONS(3471),
    [anon_sym_constinit] = ACTIONS(3471),
    [anon_sym_consteval] = ACTIONS(3471),
    [anon_sym_PROGMEM] = ACTIONS(3471),
    [aux_sym_primitive_type_token1] = ACTIONS(3471),
    [anon_sym_byte] = ACTIONS(3471),
    [anon_sym_word] = ACTIONS(3471),
    [anon_sym_enum] = ACTIONS(3471),
    [anon_sym_class] = ACTIONS(3471),
    [anon_sym_struct] = ACTIONS(3471),
    [anon_sym_union] = ACTIONS(3471),
    [anon_sym_if] = ACTIONS(3471),
    [anon_sym_switch] = ACTIONS(3471),
    [anon_sym_case] = ACTIONS(3471),
    [anon_sym_default] = ACTIONS(3471),
    [anon_sym_while] = ACTIONS(3471),
    [anon_sym_do] = ACTIONS(3471),
    [anon_sym_for] = ACTIONS(3471),
    [anon_sym_return] = ACTIONS(3471),
    [anon_sym_break] = ACTIONS(3471),
    [anon_sym_continue] = ACTIONS(3471),
    [anon_sym_goto] = ACTIONS(3471),
    [anon_sym_not] = ACTIONS(3471),
    [anon_sym_compl] = ACTIONS(3471),
    [anon_sym_DASH_DASH] = ACTIONS(3473),
    [anon_sym_PLUS_PLUS] = ACTIONS(3473),
    [anon_sym_sizeof] = ACTIONS(3471),
    [anon_sym___alignof__] = ACTIONS(3471),
    [anon_sym___alignof] = ACTIONS(3471),
    [anon_sym__alignof] = ACTIONS(3471),
    [anon_sym_alignof] = ACTIONS(3471),
    [anon_sym__Alignof] = ACTIONS(3471),
    [anon_sym_offsetof] = ACTIONS(3471),
    [anon_sym__Generic] = ACTIONS(3471),
    [anon_sym_asm] = ACTIONS(3471),
    [anon_sym___asm__] = ACTIONS(3471),
    [aux_sym_number_literal_token1] = ACTIONS(3473),
    [aux_sym_number_literal_token2] = ACTIONS(3471),
    [anon_sym_L_SQUOTE] = ACTIONS(3473),
    [anon_sym_u_SQUOTE] = ACTIONS(3473),
    [anon_sym_U_SQUOTE] = ACTIONS(3473),
    [anon_sym_u8_SQUOTE] = ACTIONS(3473),
    [anon_sym_SQUOTE] = ACTIONS(3473),
    [anon_sym_L_DQUOTE] = ACTIONS(3473),
    [anon_sym_u_DQUOTE] = ACTIONS(3473),
    [anon_sym_U_DQUOTE] = ACTIONS(3473),
    [anon_sym_u8_DQUOTE] = ACTIONS(3473),
    [anon_sym_DQUOTE] = ACTIONS(3473),
    [sym_true] = ACTIONS(3471),
    [sym_false] = ACTIONS(3471),
    [anon_sym_NULL] = ACTIONS(3471),
    [anon_sym_nullptr] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3471),
    [anon_sym_decltype] = ACTIONS(3471),
    [anon_sym_virtual] = ACTIONS(3471),
    [anon_sym_alignas] = ACTIONS(3471),
    [anon_sym_explicit] = ACTIONS(3471),
    [anon_sym_typename] = ACTIONS(3471),
    [anon_sym_template] = ACTIONS(3471),
    [anon_sym_operator] = ACTIONS(3471),
    [anon_sym_try] = ACTIONS(3471),
    [anon_sym_delete] = ACTIONS(3471),
    [anon_sym_throw] = ACTIONS(3471),
    [anon_sym_namespace] = ACTIONS(3471),
    [anon_sym_using] = ACTIONS(3471),
    [anon_sym_static_assert] = ACTIONS(3471),
    [anon_sym_concept] = ACTIONS(3471),
    [anon_sym_co_return] = ACTIONS(3471),
    [anon_sym_co_yield] = ACTIONS(3471),
    [anon_sym_R_DQUOTE] = ACTIONS(3473),
    [anon_sym_LR_DQUOTE] = ACTIONS(3473),
    [anon_sym_uR_DQUOTE] = ACTIONS(3473),
    [anon_sym_UR_DQUOTE] = ACTIONS(3473),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3473),
    [anon_sym_co_await] = ACTIONS(3471),
    [anon_sym_new] = ACTIONS(3471),
    [anon_sym_requires] = ACTIONS(3471),
    [sym_this] = ACTIONS(3471),
  },
  [1004] = {
    [ts_builtin_sym_end] = ACTIONS(3330),
    [sym_identifier] = ACTIONS(3328),
    [aux_sym_preproc_include_token1] = ACTIONS(3328),
    [aux_sym_preproc_def_token1] = ACTIONS(3328),
    [aux_sym_preproc_if_token1] = ACTIONS(3328),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3328),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3328),
    [sym_preproc_directive] = ACTIONS(3328),
    [anon_sym_LPAREN2] = ACTIONS(3330),
    [anon_sym_BANG] = ACTIONS(3330),
    [anon_sym_TILDE] = ACTIONS(3330),
    [anon_sym_DASH] = ACTIONS(3328),
    [anon_sym_PLUS] = ACTIONS(3328),
    [anon_sym_STAR] = ACTIONS(3330),
    [anon_sym_AMP_AMP] = ACTIONS(3330),
    [anon_sym_AMP] = ACTIONS(3328),
    [anon_sym_SEMI] = ACTIONS(3795),
    [anon_sym___extension__] = ACTIONS(3328),
    [anon_sym_typedef] = ACTIONS(3328),
    [anon_sym_extern] = ACTIONS(3328),
    [anon_sym___attribute__] = ACTIONS(3328),
    [anon_sym_COLON_COLON] = ACTIONS(3330),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3330),
    [anon_sym___declspec] = ACTIONS(3328),
    [anon_sym___based] = ACTIONS(3328),
    [anon_sym___cdecl] = ACTIONS(3328),
    [anon_sym___clrcall] = ACTIONS(3328),
    [anon_sym___stdcall] = ACTIONS(3328),
    [anon_sym___fastcall] = ACTIONS(3328),
    [anon_sym___thiscall] = ACTIONS(3328),
    [anon_sym___vectorcall] = ACTIONS(3328),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_signed] = ACTIONS(3328),
    [anon_sym_unsigned] = ACTIONS(3328),
    [anon_sym_long] = ACTIONS(3328),
    [anon_sym_short] = ACTIONS(3328),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_static] = ACTIONS(3328),
    [anon_sym_register] = ACTIONS(3328),
    [anon_sym_inline] = ACTIONS(3328),
    [anon_sym___inline] = ACTIONS(3328),
    [anon_sym___inline__] = ACTIONS(3328),
    [anon_sym___forceinline] = ACTIONS(3328),
    [anon_sym_thread_local] = ACTIONS(3328),
    [anon_sym___thread] = ACTIONS(3328),
    [anon_sym_const] = ACTIONS(3328),
    [anon_sym_constexpr] = ACTIONS(3328),
    [anon_sym_volatile] = ACTIONS(3328),
    [anon_sym_restrict] = ACTIONS(3328),
    [anon_sym___restrict__] = ACTIONS(3328),
    [anon_sym__Atomic] = ACTIONS(3328),
    [anon_sym__Noreturn] = ACTIONS(3328),
    [anon_sym_noreturn] = ACTIONS(3328),
    [anon_sym_mutable] = ACTIONS(3328),
    [anon_sym_constinit] = ACTIONS(3328),
    [anon_sym_consteval] = ACTIONS(3328),
    [anon_sym_PROGMEM] = ACTIONS(3328),
    [aux_sym_primitive_type_token1] = ACTIONS(3328),
    [anon_sym_byte] = ACTIONS(3328),
    [anon_sym_word] = ACTIONS(3328),
    [anon_sym_enum] = ACTIONS(3328),
    [anon_sym_class] = ACTIONS(3328),
    [anon_sym_struct] = ACTIONS(3328),
    [anon_sym_union] = ACTIONS(3328),
    [anon_sym_if] = ACTIONS(3328),
    [anon_sym_switch] = ACTIONS(3328),
    [anon_sym_case] = ACTIONS(3328),
    [anon_sym_default] = ACTIONS(3328),
    [anon_sym_while] = ACTIONS(3328),
    [anon_sym_do] = ACTIONS(3328),
    [anon_sym_for] = ACTIONS(3328),
    [anon_sym_return] = ACTIONS(3328),
    [anon_sym_break] = ACTIONS(3328),
    [anon_sym_continue] = ACTIONS(3328),
    [anon_sym_goto] = ACTIONS(3328),
    [anon_sym_not] = ACTIONS(3328),
    [anon_sym_compl] = ACTIONS(3328),
    [anon_sym_DASH_DASH] = ACTIONS(3330),
    [anon_sym_PLUS_PLUS] = ACTIONS(3330),
    [anon_sym_sizeof] = ACTIONS(3328),
    [anon_sym___alignof__] = ACTIONS(3328),
    [anon_sym___alignof] = ACTIONS(3328),
    [anon_sym__alignof] = ACTIONS(3328),
    [anon_sym_alignof] = ACTIONS(3328),
    [anon_sym__Alignof] = ACTIONS(3328),
    [anon_sym_offsetof] = ACTIONS(3328),
    [anon_sym__Generic] = ACTIONS(3328),
    [anon_sym_asm] = ACTIONS(3328),
    [anon_sym___asm__] = ACTIONS(3328),
    [aux_sym_number_literal_token1] = ACTIONS(3330),
    [aux_sym_number_literal_token2] = ACTIONS(3328),
    [anon_sym_L_SQUOTE] = ACTIONS(3330),
    [anon_sym_u_SQUOTE] = ACTIONS(3330),
    [anon_sym_U_SQUOTE] = ACTIONS(3330),
    [anon_sym_u8_SQUOTE] = ACTIONS(3330),
    [anon_sym_SQUOTE] = ACTIONS(3330),
    [anon_sym_L_DQUOTE] = ACTIONS(3330),
    [anon_sym_u_DQUOTE] = ACTIONS(3330),
    [anon_sym_U_DQUOTE] = ACTIONS(3330),
    [anon_sym_u8_DQUOTE] = ACTIONS(3330),
    [anon_sym_DQUOTE] = ACTIONS(3330),
    [sym_true] = ACTIONS(3328),
    [sym_false] = ACTIONS(3328),
    [anon_sym_NULL] = ACTIONS(3328),
    [anon_sym_nullptr] = ACTIONS(3328),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3328),
    [anon_sym_decltype] = ACTIONS(3328),
    [anon_sym_virtual] = ACTIONS(3328),
    [anon_sym_alignas] = ACTIONS(3328),
    [anon_sym_explicit] = ACTIONS(3328),
    [anon_sym_typename] = ACTIONS(3328),
    [anon_sym_template] = ACTIONS(3328),
    [anon_sym_operator] = ACTIONS(3328),
    [anon_sym_try] = ACTIONS(3328),
    [anon_sym_delete] = ACTIONS(3328),
    [anon_sym_throw] = ACTIONS(3328),
    [anon_sym_namespace] = ACTIONS(3328),
    [anon_sym_using] = ACTIONS(3328),
    [anon_sym_static_assert] = ACTIONS(3328),
    [anon_sym_concept] = ACTIONS(3328),
    [anon_sym_co_return] = ACTIONS(3328),
    [anon_sym_co_yield] = ACTIONS(3328),
    [anon_sym_R_DQUOTE] = ACTIONS(3330),
    [anon_sym_LR_DQUOTE] = ACTIONS(3330),
    [anon_sym_uR_DQUOTE] = ACTIONS(3330),
    [anon_sym_UR_DQUOTE] = ACTIONS(3330),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3330),
    [anon_sym_co_await] = ACTIONS(3328),
    [anon_sym_new] = ACTIONS(3328),
    [anon_sym_requires] = ACTIONS(3328),
    [sym_this] = ACTIONS(3328),
  },
  [1005] = {
    [ts_builtin_sym_end] = ACTIONS(3334),
    [sym_identifier] = ACTIONS(3332),
    [aux_sym_preproc_include_token1] = ACTIONS(3332),
    [aux_sym_preproc_def_token1] = ACTIONS(3332),
    [aux_sym_preproc_if_token1] = ACTIONS(3332),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3332),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3332),
    [sym_preproc_directive] = ACTIONS(3332),
    [anon_sym_LPAREN2] = ACTIONS(3334),
    [anon_sym_BANG] = ACTIONS(3334),
    [anon_sym_TILDE] = ACTIONS(3334),
    [anon_sym_DASH] = ACTIONS(3332),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_STAR] = ACTIONS(3334),
    [anon_sym_AMP_AMP] = ACTIONS(3334),
    [anon_sym_AMP] = ACTIONS(3332),
    [anon_sym_SEMI] = ACTIONS(3797),
    [anon_sym___extension__] = ACTIONS(3332),
    [anon_sym_typedef] = ACTIONS(3332),
    [anon_sym_extern] = ACTIONS(3332),
    [anon_sym___attribute__] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(3334),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3334),
    [anon_sym___declspec] = ACTIONS(3332),
    [anon_sym___based] = ACTIONS(3332),
    [anon_sym___cdecl] = ACTIONS(3332),
    [anon_sym___clrcall] = ACTIONS(3332),
    [anon_sym___stdcall] = ACTIONS(3332),
    [anon_sym___fastcall] = ACTIONS(3332),
    [anon_sym___thiscall] = ACTIONS(3332),
    [anon_sym___vectorcall] = ACTIONS(3332),
    [anon_sym_LBRACE] = ACTIONS(3334),
    [anon_sym_signed] = ACTIONS(3332),
    [anon_sym_unsigned] = ACTIONS(3332),
    [anon_sym_long] = ACTIONS(3332),
    [anon_sym_short] = ACTIONS(3332),
    [anon_sym_LBRACK] = ACTIONS(3332),
    [anon_sym_static] = ACTIONS(3332),
    [anon_sym_register] = ACTIONS(3332),
    [anon_sym_inline] = ACTIONS(3332),
    [anon_sym___inline] = ACTIONS(3332),
    [anon_sym___inline__] = ACTIONS(3332),
    [anon_sym___forceinline] = ACTIONS(3332),
    [anon_sym_thread_local] = ACTIONS(3332),
    [anon_sym___thread] = ACTIONS(3332),
    [anon_sym_const] = ACTIONS(3332),
    [anon_sym_constexpr] = ACTIONS(3332),
    [anon_sym_volatile] = ACTIONS(3332),
    [anon_sym_restrict] = ACTIONS(3332),
    [anon_sym___restrict__] = ACTIONS(3332),
    [anon_sym__Atomic] = ACTIONS(3332),
    [anon_sym__Noreturn] = ACTIONS(3332),
    [anon_sym_noreturn] = ACTIONS(3332),
    [anon_sym_mutable] = ACTIONS(3332),
    [anon_sym_constinit] = ACTIONS(3332),
    [anon_sym_consteval] = ACTIONS(3332),
    [anon_sym_PROGMEM] = ACTIONS(3332),
    [aux_sym_primitive_type_token1] = ACTIONS(3332),
    [anon_sym_byte] = ACTIONS(3332),
    [anon_sym_word] = ACTIONS(3332),
    [anon_sym_enum] = ACTIONS(3332),
    [anon_sym_class] = ACTIONS(3332),
    [anon_sym_struct] = ACTIONS(3332),
    [anon_sym_union] = ACTIONS(3332),
    [anon_sym_if] = ACTIONS(3332),
    [anon_sym_switch] = ACTIONS(3332),
    [anon_sym_case] = ACTIONS(3332),
    [anon_sym_default] = ACTIONS(3332),
    [anon_sym_while] = ACTIONS(3332),
    [anon_sym_do] = ACTIONS(3332),
    [anon_sym_for] = ACTIONS(3332),
    [anon_sym_return] = ACTIONS(3332),
    [anon_sym_break] = ACTIONS(3332),
    [anon_sym_continue] = ACTIONS(3332),
    [anon_sym_goto] = ACTIONS(3332),
    [anon_sym_not] = ACTIONS(3332),
    [anon_sym_compl] = ACTIONS(3332),
    [anon_sym_DASH_DASH] = ACTIONS(3334),
    [anon_sym_PLUS_PLUS] = ACTIONS(3334),
    [anon_sym_sizeof] = ACTIONS(3332),
    [anon_sym___alignof__] = ACTIONS(3332),
    [anon_sym___alignof] = ACTIONS(3332),
    [anon_sym__alignof] = ACTIONS(3332),
    [anon_sym_alignof] = ACTIONS(3332),
    [anon_sym__Alignof] = ACTIONS(3332),
    [anon_sym_offsetof] = ACTIONS(3332),
    [anon_sym__Generic] = ACTIONS(3332),
    [anon_sym_asm] = ACTIONS(3332),
    [anon_sym___asm__] = ACTIONS(3332),
    [aux_sym_number_literal_token1] = ACTIONS(3334),
    [aux_sym_number_literal_token2] = ACTIONS(3332),
    [anon_sym_L_SQUOTE] = ACTIONS(3334),
    [anon_sym_u_SQUOTE] = ACTIONS(3334),
    [anon_sym_U_SQUOTE] = ACTIONS(3334),
    [anon_sym_u8_SQUOTE] = ACTIONS(3334),
    [anon_sym_SQUOTE] = ACTIONS(3334),
    [anon_sym_L_DQUOTE] = ACTIONS(3334),
    [anon_sym_u_DQUOTE] = ACTIONS(3334),
    [anon_sym_U_DQUOTE] = ACTIONS(3334),
    [anon_sym_u8_DQUOTE] = ACTIONS(3334),
    [anon_sym_DQUOTE] = ACTIONS(3334),
    [sym_true] = ACTIONS(3332),
    [sym_false] = ACTIONS(3332),
    [anon_sym_NULL] = ACTIONS(3332),
    [anon_sym_nullptr] = ACTIONS(3332),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3332),
    [anon_sym_decltype] = ACTIONS(3332),
    [anon_sym_virtual] = ACTIONS(3332),
    [anon_sym_alignas] = ACTIONS(3332),
    [anon_sym_explicit] = ACTIONS(3332),
    [anon_sym_typename] = ACTIONS(3332),
    [anon_sym_template] = ACTIONS(3332),
    [anon_sym_operator] = ACTIONS(3332),
    [anon_sym_try] = ACTIONS(3332),
    [anon_sym_delete] = ACTIONS(3332),
    [anon_sym_throw] = ACTIONS(3332),
    [anon_sym_namespace] = ACTIONS(3332),
    [anon_sym_using] = ACTIONS(3332),
    [anon_sym_static_assert] = ACTIONS(3332),
    [anon_sym_concept] = ACTIONS(3332),
    [anon_sym_co_return] = ACTIONS(3332),
    [anon_sym_co_yield] = ACTIONS(3332),
    [anon_sym_R_DQUOTE] = ACTIONS(3334),
    [anon_sym_LR_DQUOTE] = ACTIONS(3334),
    [anon_sym_uR_DQUOTE] = ACTIONS(3334),
    [anon_sym_UR_DQUOTE] = ACTIONS(3334),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3334),
    [anon_sym_co_await] = ACTIONS(3332),
    [anon_sym_new] = ACTIONS(3332),
    [anon_sym_requires] = ACTIONS(3332),
    [sym_this] = ACTIONS(3332),
  },
  [1006] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4519),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_initializer_list] = STATE(4671),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2151),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_LPAREN2] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(3801),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(2151),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_PERCENT] = ACTIONS(2151),
    [anon_sym_PIPE_PIPE] = ACTIONS(2151),
    [anon_sym_AMP_AMP] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(2149),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2149),
    [anon_sym_EQ_EQ] = ACTIONS(2151),
    [anon_sym_BANG_EQ] = ACTIONS(2151),
    [anon_sym_GT] = ACTIONS(2149),
    [anon_sym_GT_EQ] = ACTIONS(2151),
    [anon_sym_LT_EQ] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_LT_LT] = ACTIONS(2151),
    [anon_sym_GT_GT] = ACTIONS(2151),
    [anon_sym_SEMI] = ACTIONS(2151),
    [anon_sym___attribute__] = ACTIONS(2149),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_LT_EQ_GT] = ACTIONS(2151),
    [anon_sym_or] = ACTIONS(2149),
    [anon_sym_and] = ACTIONS(2149),
    [anon_sym_bitor] = ACTIONS(2149),
    [anon_sym_xor] = ACTIONS(2149),
    [anon_sym_bitand] = ACTIONS(2149),
    [anon_sym_not_eq] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(2149),
    [anon_sym_DOT_STAR] = ACTIONS(2151),
    [anon_sym_DASH_GT] = ACTIONS(2151),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1007] = {
    [ts_builtin_sym_end] = ACTIONS(3429),
    [sym_identifier] = ACTIONS(3427),
    [aux_sym_preproc_include_token1] = ACTIONS(3427),
    [aux_sym_preproc_def_token1] = ACTIONS(3427),
    [aux_sym_preproc_if_token1] = ACTIONS(3427),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3427),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3427),
    [sym_preproc_directive] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3429),
    [anon_sym_BANG] = ACTIONS(3429),
    [anon_sym_TILDE] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3429),
    [anon_sym_AMP_AMP] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(3823),
    [anon_sym___extension__] = ACTIONS(3427),
    [anon_sym_typedef] = ACTIONS(3427),
    [anon_sym_extern] = ACTIONS(3427),
    [anon_sym___attribute__] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3429),
    [anon_sym___declspec] = ACTIONS(3427),
    [anon_sym___based] = ACTIONS(3427),
    [anon_sym___cdecl] = ACTIONS(3427),
    [anon_sym___clrcall] = ACTIONS(3427),
    [anon_sym___stdcall] = ACTIONS(3427),
    [anon_sym___fastcall] = ACTIONS(3427),
    [anon_sym___thiscall] = ACTIONS(3427),
    [anon_sym___vectorcall] = ACTIONS(3427),
    [anon_sym_LBRACE] = ACTIONS(3429),
    [anon_sym_signed] = ACTIONS(3427),
    [anon_sym_unsigned] = ACTIONS(3427),
    [anon_sym_long] = ACTIONS(3427),
    [anon_sym_short] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_register] = ACTIONS(3427),
    [anon_sym_inline] = ACTIONS(3427),
    [anon_sym___inline] = ACTIONS(3427),
    [anon_sym___inline__] = ACTIONS(3427),
    [anon_sym___forceinline] = ACTIONS(3427),
    [anon_sym_thread_local] = ACTIONS(3427),
    [anon_sym___thread] = ACTIONS(3427),
    [anon_sym_const] = ACTIONS(3427),
    [anon_sym_constexpr] = ACTIONS(3427),
    [anon_sym_volatile] = ACTIONS(3427),
    [anon_sym_restrict] = ACTIONS(3427),
    [anon_sym___restrict__] = ACTIONS(3427),
    [anon_sym__Atomic] = ACTIONS(3427),
    [anon_sym__Noreturn] = ACTIONS(3427),
    [anon_sym_noreturn] = ACTIONS(3427),
    [anon_sym_mutable] = ACTIONS(3427),
    [anon_sym_constinit] = ACTIONS(3427),
    [anon_sym_consteval] = ACTIONS(3427),
    [anon_sym_PROGMEM] = ACTIONS(3427),
    [aux_sym_primitive_type_token1] = ACTIONS(3427),
    [anon_sym_byte] = ACTIONS(3427),
    [anon_sym_word] = ACTIONS(3427),
    [anon_sym_enum] = ACTIONS(3427),
    [anon_sym_class] = ACTIONS(3427),
    [anon_sym_struct] = ACTIONS(3427),
    [anon_sym_union] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_switch] = ACTIONS(3427),
    [anon_sym_case] = ACTIONS(3427),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_break] = ACTIONS(3427),
    [anon_sym_continue] = ACTIONS(3427),
    [anon_sym_goto] = ACTIONS(3427),
    [anon_sym_not] = ACTIONS(3427),
    [anon_sym_compl] = ACTIONS(3427),
    [anon_sym_DASH_DASH] = ACTIONS(3429),
    [anon_sym_PLUS_PLUS] = ACTIONS(3429),
    [anon_sym_sizeof] = ACTIONS(3427),
    [anon_sym___alignof__] = ACTIONS(3427),
    [anon_sym___alignof] = ACTIONS(3427),
    [anon_sym__alignof] = ACTIONS(3427),
    [anon_sym_alignof] = ACTIONS(3427),
    [anon_sym__Alignof] = ACTIONS(3427),
    [anon_sym_offsetof] = ACTIONS(3427),
    [anon_sym__Generic] = ACTIONS(3427),
    [anon_sym_asm] = ACTIONS(3427),
    [anon_sym___asm__] = ACTIONS(3427),
    [aux_sym_number_literal_token1] = ACTIONS(3429),
    [aux_sym_number_literal_token2] = ACTIONS(3427),
    [anon_sym_L_SQUOTE] = ACTIONS(3429),
    [anon_sym_u_SQUOTE] = ACTIONS(3429),
    [anon_sym_U_SQUOTE] = ACTIONS(3429),
    [anon_sym_u8_SQUOTE] = ACTIONS(3429),
    [anon_sym_SQUOTE] = ACTIONS(3429),
    [anon_sym_L_DQUOTE] = ACTIONS(3429),
    [anon_sym_u_DQUOTE] = ACTIONS(3429),
    [anon_sym_U_DQUOTE] = ACTIONS(3429),
    [anon_sym_u8_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(3429),
    [sym_true] = ACTIONS(3427),
    [sym_false] = ACTIONS(3427),
    [anon_sym_NULL] = ACTIONS(3427),
    [anon_sym_nullptr] = ACTIONS(3427),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3427),
    [anon_sym_decltype] = ACTIONS(3427),
    [anon_sym_virtual] = ACTIONS(3427),
    [anon_sym_alignas] = ACTIONS(3427),
    [anon_sym_explicit] = ACTIONS(3427),
    [anon_sym_typename] = ACTIONS(3427),
    [anon_sym_template] = ACTIONS(3427),
    [anon_sym_operator] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_delete] = ACTIONS(3427),
    [anon_sym_throw] = ACTIONS(3427),
    [anon_sym_namespace] = ACTIONS(3427),
    [anon_sym_using] = ACTIONS(3427),
    [anon_sym_static_assert] = ACTIONS(3427),
    [anon_sym_concept] = ACTIONS(3427),
    [anon_sym_co_return] = ACTIONS(3427),
    [anon_sym_co_yield] = ACTIONS(3427),
    [anon_sym_R_DQUOTE] = ACTIONS(3429),
    [anon_sym_LR_DQUOTE] = ACTIONS(3429),
    [anon_sym_uR_DQUOTE] = ACTIONS(3429),
    [anon_sym_UR_DQUOTE] = ACTIONS(3429),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3429),
    [anon_sym_co_await] = ACTIONS(3427),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_requires] = ACTIONS(3427),
    [sym_this] = ACTIONS(3427),
  },
  [1008] = {
    [ts_builtin_sym_end] = ACTIONS(3348),
    [sym_identifier] = ACTIONS(3346),
    [aux_sym_preproc_include_token1] = ACTIONS(3346),
    [aux_sym_preproc_def_token1] = ACTIONS(3346),
    [aux_sym_preproc_if_token1] = ACTIONS(3346),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3346),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3346),
    [sym_preproc_directive] = ACTIONS(3346),
    [anon_sym_LPAREN2] = ACTIONS(3348),
    [anon_sym_BANG] = ACTIONS(3348),
    [anon_sym_TILDE] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3348),
    [anon_sym_AMP_AMP] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym___extension__] = ACTIONS(3346),
    [anon_sym_typedef] = ACTIONS(3346),
    [anon_sym_extern] = ACTIONS(3346),
    [anon_sym___attribute__] = ACTIONS(3346),
    [anon_sym_COLON_COLON] = ACTIONS(3348),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3348),
    [anon_sym___declspec] = ACTIONS(3346),
    [anon_sym___based] = ACTIONS(3346),
    [anon_sym___cdecl] = ACTIONS(3346),
    [anon_sym___clrcall] = ACTIONS(3346),
    [anon_sym___stdcall] = ACTIONS(3346),
    [anon_sym___fastcall] = ACTIONS(3346),
    [anon_sym___thiscall] = ACTIONS(3346),
    [anon_sym___vectorcall] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3348),
    [anon_sym_signed] = ACTIONS(3346),
    [anon_sym_unsigned] = ACTIONS(3346),
    [anon_sym_long] = ACTIONS(3346),
    [anon_sym_short] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3346),
    [anon_sym_register] = ACTIONS(3346),
    [anon_sym_inline] = ACTIONS(3346),
    [anon_sym___inline] = ACTIONS(3346),
    [anon_sym___inline__] = ACTIONS(3346),
    [anon_sym___forceinline] = ACTIONS(3346),
    [anon_sym_thread_local] = ACTIONS(3346),
    [anon_sym___thread] = ACTIONS(3346),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_constexpr] = ACTIONS(3346),
    [anon_sym_volatile] = ACTIONS(3346),
    [anon_sym_restrict] = ACTIONS(3346),
    [anon_sym___restrict__] = ACTIONS(3346),
    [anon_sym__Atomic] = ACTIONS(3346),
    [anon_sym__Noreturn] = ACTIONS(3346),
    [anon_sym_noreturn] = ACTIONS(3346),
    [anon_sym_mutable] = ACTIONS(3346),
    [anon_sym_constinit] = ACTIONS(3346),
    [anon_sym_consteval] = ACTIONS(3346),
    [anon_sym_PROGMEM] = ACTIONS(3346),
    [aux_sym_primitive_type_token1] = ACTIONS(3346),
    [anon_sym_byte] = ACTIONS(3346),
    [anon_sym_word] = ACTIONS(3346),
    [anon_sym_enum] = ACTIONS(3346),
    [anon_sym_class] = ACTIONS(3346),
    [anon_sym_struct] = ACTIONS(3346),
    [anon_sym_union] = ACTIONS(3346),
    [anon_sym_if] = ACTIONS(3346),
    [anon_sym_switch] = ACTIONS(3346),
    [anon_sym_case] = ACTIONS(3346),
    [anon_sym_default] = ACTIONS(3346),
    [anon_sym_while] = ACTIONS(3346),
    [anon_sym_do] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3346),
    [anon_sym_return] = ACTIONS(3346),
    [anon_sym_break] = ACTIONS(3346),
    [anon_sym_continue] = ACTIONS(3346),
    [anon_sym_goto] = ACTIONS(3346),
    [anon_sym_not] = ACTIONS(3346),
    [anon_sym_compl] = ACTIONS(3346),
    [anon_sym_DASH_DASH] = ACTIONS(3348),
    [anon_sym_PLUS_PLUS] = ACTIONS(3348),
    [anon_sym_sizeof] = ACTIONS(3346),
    [anon_sym___alignof__] = ACTIONS(3346),
    [anon_sym___alignof] = ACTIONS(3346),
    [anon_sym__alignof] = ACTIONS(3346),
    [anon_sym_alignof] = ACTIONS(3346),
    [anon_sym__Alignof] = ACTIONS(3346),
    [anon_sym_offsetof] = ACTIONS(3346),
    [anon_sym__Generic] = ACTIONS(3346),
    [anon_sym_asm] = ACTIONS(3346),
    [anon_sym___asm__] = ACTIONS(3346),
    [aux_sym_number_literal_token1] = ACTIONS(3348),
    [aux_sym_number_literal_token2] = ACTIONS(3346),
    [anon_sym_L_SQUOTE] = ACTIONS(3348),
    [anon_sym_u_SQUOTE] = ACTIONS(3348),
    [anon_sym_U_SQUOTE] = ACTIONS(3348),
    [anon_sym_u8_SQUOTE] = ACTIONS(3348),
    [anon_sym_SQUOTE] = ACTIONS(3348),
    [anon_sym_L_DQUOTE] = ACTIONS(3348),
    [anon_sym_u_DQUOTE] = ACTIONS(3348),
    [anon_sym_U_DQUOTE] = ACTIONS(3348),
    [anon_sym_u8_DQUOTE] = ACTIONS(3348),
    [anon_sym_DQUOTE] = ACTIONS(3348),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [anon_sym_NULL] = ACTIONS(3346),
    [anon_sym_nullptr] = ACTIONS(3346),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3346),
    [anon_sym_decltype] = ACTIONS(3346),
    [anon_sym_virtual] = ACTIONS(3346),
    [anon_sym_alignas] = ACTIONS(3346),
    [anon_sym_explicit] = ACTIONS(3346),
    [anon_sym_typename] = ACTIONS(3346),
    [anon_sym_template] = ACTIONS(3346),
    [anon_sym_operator] = ACTIONS(3346),
    [anon_sym_try] = ACTIONS(3346),
    [anon_sym_delete] = ACTIONS(3346),
    [anon_sym_throw] = ACTIONS(3346),
    [anon_sym_namespace] = ACTIONS(3346),
    [anon_sym_using] = ACTIONS(3346),
    [anon_sym_static_assert] = ACTIONS(3346),
    [anon_sym_concept] = ACTIONS(3346),
    [anon_sym_co_return] = ACTIONS(3346),
    [anon_sym_co_yield] = ACTIONS(3346),
    [anon_sym_R_DQUOTE] = ACTIONS(3348),
    [anon_sym_LR_DQUOTE] = ACTIONS(3348),
    [anon_sym_uR_DQUOTE] = ACTIONS(3348),
    [anon_sym_UR_DQUOTE] = ACTIONS(3348),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3348),
    [anon_sym_co_await] = ACTIONS(3346),
    [anon_sym_new] = ACTIONS(3346),
    [anon_sym_requires] = ACTIONS(3346),
    [sym_this] = ACTIONS(3346),
  },
  [1009] = {
    [ts_builtin_sym_end] = ACTIONS(3299),
    [sym_identifier] = ACTIONS(3297),
    [aux_sym_preproc_include_token1] = ACTIONS(3297),
    [aux_sym_preproc_def_token1] = ACTIONS(3297),
    [aux_sym_preproc_if_token1] = ACTIONS(3297),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3297),
    [sym_preproc_directive] = ACTIONS(3297),
    [anon_sym_LPAREN2] = ACTIONS(3299),
    [anon_sym_BANG] = ACTIONS(3299),
    [anon_sym_TILDE] = ACTIONS(3299),
    [anon_sym_DASH] = ACTIONS(3297),
    [anon_sym_PLUS] = ACTIONS(3297),
    [anon_sym_STAR] = ACTIONS(3299),
    [anon_sym_AMP_AMP] = ACTIONS(3299),
    [anon_sym_AMP] = ACTIONS(3297),
    [anon_sym___extension__] = ACTIONS(3297),
    [anon_sym_typedef] = ACTIONS(3297),
    [anon_sym_extern] = ACTIONS(3297),
    [anon_sym___attribute__] = ACTIONS(3297),
    [anon_sym_COLON_COLON] = ACTIONS(3299),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3299),
    [anon_sym___declspec] = ACTIONS(3297),
    [anon_sym___based] = ACTIONS(3297),
    [anon_sym___cdecl] = ACTIONS(3297),
    [anon_sym___clrcall] = ACTIONS(3297),
    [anon_sym___stdcall] = ACTIONS(3297),
    [anon_sym___fastcall] = ACTIONS(3297),
    [anon_sym___thiscall] = ACTIONS(3297),
    [anon_sym___vectorcall] = ACTIONS(3297),
    [anon_sym_LBRACE] = ACTIONS(3299),
    [anon_sym_signed] = ACTIONS(3297),
    [anon_sym_unsigned] = ACTIONS(3297),
    [anon_sym_long] = ACTIONS(3297),
    [anon_sym_short] = ACTIONS(3297),
    [anon_sym_LBRACK] = ACTIONS(3297),
    [anon_sym_static] = ACTIONS(3297),
    [anon_sym_register] = ACTIONS(3297),
    [anon_sym_inline] = ACTIONS(3297),
    [anon_sym___inline] = ACTIONS(3297),
    [anon_sym___inline__] = ACTIONS(3297),
    [anon_sym___forceinline] = ACTIONS(3297),
    [anon_sym_thread_local] = ACTIONS(3297),
    [anon_sym___thread] = ACTIONS(3297),
    [anon_sym_const] = ACTIONS(3297),
    [anon_sym_constexpr] = ACTIONS(3297),
    [anon_sym_volatile] = ACTIONS(3297),
    [anon_sym_restrict] = ACTIONS(3297),
    [anon_sym___restrict__] = ACTIONS(3297),
    [anon_sym__Atomic] = ACTIONS(3297),
    [anon_sym__Noreturn] = ACTIONS(3297),
    [anon_sym_noreturn] = ACTIONS(3297),
    [anon_sym_mutable] = ACTIONS(3297),
    [anon_sym_constinit] = ACTIONS(3297),
    [anon_sym_consteval] = ACTIONS(3297),
    [anon_sym_PROGMEM] = ACTIONS(3297),
    [aux_sym_primitive_type_token1] = ACTIONS(3297),
    [anon_sym_byte] = ACTIONS(3297),
    [anon_sym_word] = ACTIONS(3297),
    [anon_sym_enum] = ACTIONS(3297),
    [anon_sym_class] = ACTIONS(3297),
    [anon_sym_struct] = ACTIONS(3297),
    [anon_sym_union] = ACTIONS(3297),
    [anon_sym_if] = ACTIONS(3297),
    [anon_sym_switch] = ACTIONS(3297),
    [anon_sym_case] = ACTIONS(3297),
    [anon_sym_default] = ACTIONS(3297),
    [anon_sym_while] = ACTIONS(3297),
    [anon_sym_do] = ACTIONS(3297),
    [anon_sym_for] = ACTIONS(3297),
    [anon_sym_return] = ACTIONS(3297),
    [anon_sym_break] = ACTIONS(3297),
    [anon_sym_continue] = ACTIONS(3297),
    [anon_sym_goto] = ACTIONS(3297),
    [anon_sym_not] = ACTIONS(3297),
    [anon_sym_compl] = ACTIONS(3297),
    [anon_sym_DASH_DASH] = ACTIONS(3299),
    [anon_sym_PLUS_PLUS] = ACTIONS(3299),
    [anon_sym_sizeof] = ACTIONS(3297),
    [anon_sym___alignof__] = ACTIONS(3297),
    [anon_sym___alignof] = ACTIONS(3297),
    [anon_sym__alignof] = ACTIONS(3297),
    [anon_sym_alignof] = ACTIONS(3297),
    [anon_sym__Alignof] = ACTIONS(3297),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3297),
    [anon_sym_asm] = ACTIONS(3297),
    [anon_sym___asm__] = ACTIONS(3297),
    [aux_sym_number_literal_token1] = ACTIONS(3299),
    [aux_sym_number_literal_token2] = ACTIONS(3297),
    [anon_sym_L_SQUOTE] = ACTIONS(3299),
    [anon_sym_u_SQUOTE] = ACTIONS(3299),
    [anon_sym_U_SQUOTE] = ACTIONS(3299),
    [anon_sym_u8_SQUOTE] = ACTIONS(3299),
    [anon_sym_SQUOTE] = ACTIONS(3299),
    [anon_sym_L_DQUOTE] = ACTIONS(3299),
    [anon_sym_u_DQUOTE] = ACTIONS(3299),
    [anon_sym_U_DQUOTE] = ACTIONS(3299),
    [anon_sym_u8_DQUOTE] = ACTIONS(3299),
    [anon_sym_DQUOTE] = ACTIONS(3299),
    [sym_true] = ACTIONS(3297),
    [sym_false] = ACTIONS(3297),
    [anon_sym_NULL] = ACTIONS(3297),
    [anon_sym_nullptr] = ACTIONS(3297),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3297),
    [anon_sym_decltype] = ACTIONS(3297),
    [anon_sym_virtual] = ACTIONS(3297),
    [anon_sym_alignas] = ACTIONS(3297),
    [anon_sym_explicit] = ACTIONS(3297),
    [anon_sym_typename] = ACTIONS(3297),
    [anon_sym_template] = ACTIONS(3297),
    [anon_sym_operator] = ACTIONS(3297),
    [anon_sym_try] = ACTIONS(3297),
    [anon_sym_delete] = ACTIONS(3297),
    [anon_sym_throw] = ACTIONS(3297),
    [anon_sym_namespace] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3297),
    [anon_sym_static_assert] = ACTIONS(3297),
    [anon_sym_concept] = ACTIONS(3297),
    [anon_sym_co_return] = ACTIONS(3297),
    [anon_sym_co_yield] = ACTIONS(3297),
    [anon_sym_R_DQUOTE] = ACTIONS(3299),
    [anon_sym_LR_DQUOTE] = ACTIONS(3299),
    [anon_sym_uR_DQUOTE] = ACTIONS(3299),
    [anon_sym_UR_DQUOTE] = ACTIONS(3299),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3299),
    [anon_sym_co_await] = ACTIONS(3297),
    [anon_sym_new] = ACTIONS(3297),
    [anon_sym_requires] = ACTIONS(3297),
    [sym_this] = ACTIONS(3297),
  },
  [1010] = {
    [sym_preproc_def] = STATE(1056),
    [sym_preproc_function_def] = STATE(1056),
    [sym_preproc_call] = STATE(1056),
    [sym_preproc_if_in_field_declaration_list] = STATE(1056),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1056),
    [sym_type_definition] = STATE(1056),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1056),
    [sym_field_declaration] = STATE(1056),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1056),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1056),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1056),
    [sym_operator_cast_declaration] = STATE(1056),
    [sym_constructor_or_destructor_definition] = STATE(1056),
    [sym_constructor_or_destructor_declaration] = STATE(1056),
    [sym_friend_declaration] = STATE(1056),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1056),
    [sym_alias_declaration] = STATE(1056),
    [sym_static_assert_declaration] = STATE(1056),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1056),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3829),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3829),
    [sym_preproc_directive] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3833),
    [anon_sym_typedef] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3837),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_static_assert] = ACTIONS(3845),
  },
  [1011] = {
    [ts_builtin_sym_end] = ACTIONS(3481),
    [sym_identifier] = ACTIONS(3479),
    [aux_sym_preproc_include_token1] = ACTIONS(3479),
    [aux_sym_preproc_def_token1] = ACTIONS(3479),
    [aux_sym_preproc_if_token1] = ACTIONS(3479),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3479),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3479),
    [sym_preproc_directive] = ACTIONS(3479),
    [anon_sym_LPAREN2] = ACTIONS(3481),
    [anon_sym_BANG] = ACTIONS(3481),
    [anon_sym_TILDE] = ACTIONS(3481),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_PLUS] = ACTIONS(3479),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_AMP_AMP] = ACTIONS(3481),
    [anon_sym_AMP] = ACTIONS(3479),
    [anon_sym___extension__] = ACTIONS(3479),
    [anon_sym_typedef] = ACTIONS(3479),
    [anon_sym_extern] = ACTIONS(3479),
    [anon_sym___attribute__] = ACTIONS(3479),
    [anon_sym_COLON_COLON] = ACTIONS(3481),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3481),
    [anon_sym___declspec] = ACTIONS(3479),
    [anon_sym___based] = ACTIONS(3479),
    [anon_sym___cdecl] = ACTIONS(3479),
    [anon_sym___clrcall] = ACTIONS(3479),
    [anon_sym___stdcall] = ACTIONS(3479),
    [anon_sym___fastcall] = ACTIONS(3479),
    [anon_sym___thiscall] = ACTIONS(3479),
    [anon_sym___vectorcall] = ACTIONS(3479),
    [anon_sym_LBRACE] = ACTIONS(3481),
    [anon_sym_signed] = ACTIONS(3479),
    [anon_sym_unsigned] = ACTIONS(3479),
    [anon_sym_long] = ACTIONS(3479),
    [anon_sym_short] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(3479),
    [anon_sym_static] = ACTIONS(3479),
    [anon_sym_register] = ACTIONS(3479),
    [anon_sym_inline] = ACTIONS(3479),
    [anon_sym___inline] = ACTIONS(3479),
    [anon_sym___inline__] = ACTIONS(3479),
    [anon_sym___forceinline] = ACTIONS(3479),
    [anon_sym_thread_local] = ACTIONS(3479),
    [anon_sym___thread] = ACTIONS(3479),
    [anon_sym_const] = ACTIONS(3479),
    [anon_sym_constexpr] = ACTIONS(3479),
    [anon_sym_volatile] = ACTIONS(3479),
    [anon_sym_restrict] = ACTIONS(3479),
    [anon_sym___restrict__] = ACTIONS(3479),
    [anon_sym__Atomic] = ACTIONS(3479),
    [anon_sym__Noreturn] = ACTIONS(3479),
    [anon_sym_noreturn] = ACTIONS(3479),
    [anon_sym_mutable] = ACTIONS(3479),
    [anon_sym_constinit] = ACTIONS(3479),
    [anon_sym_consteval] = ACTIONS(3479),
    [anon_sym_PROGMEM] = ACTIONS(3479),
    [aux_sym_primitive_type_token1] = ACTIONS(3479),
    [anon_sym_byte] = ACTIONS(3479),
    [anon_sym_word] = ACTIONS(3479),
    [anon_sym_enum] = ACTIONS(3479),
    [anon_sym_class] = ACTIONS(3479),
    [anon_sym_struct] = ACTIONS(3479),
    [anon_sym_union] = ACTIONS(3479),
    [anon_sym_if] = ACTIONS(3479),
    [anon_sym_switch] = ACTIONS(3479),
    [anon_sym_case] = ACTIONS(3479),
    [anon_sym_default] = ACTIONS(3479),
    [anon_sym_while] = ACTIONS(3479),
    [anon_sym_do] = ACTIONS(3479),
    [anon_sym_for] = ACTIONS(3479),
    [anon_sym_return] = ACTIONS(3479),
    [anon_sym_break] = ACTIONS(3479),
    [anon_sym_continue] = ACTIONS(3479),
    [anon_sym_goto] = ACTIONS(3479),
    [anon_sym_not] = ACTIONS(3479),
    [anon_sym_compl] = ACTIONS(3479),
    [anon_sym_DASH_DASH] = ACTIONS(3481),
    [anon_sym_PLUS_PLUS] = ACTIONS(3481),
    [anon_sym_sizeof] = ACTIONS(3479),
    [anon_sym___alignof__] = ACTIONS(3479),
    [anon_sym___alignof] = ACTIONS(3479),
    [anon_sym__alignof] = ACTIONS(3479),
    [anon_sym_alignof] = ACTIONS(3479),
    [anon_sym__Alignof] = ACTIONS(3479),
    [anon_sym_offsetof] = ACTIONS(3479),
    [anon_sym__Generic] = ACTIONS(3479),
    [anon_sym_asm] = ACTIONS(3479),
    [anon_sym___asm__] = ACTIONS(3479),
    [aux_sym_number_literal_token1] = ACTIONS(3481),
    [aux_sym_number_literal_token2] = ACTIONS(3479),
    [anon_sym_L_SQUOTE] = ACTIONS(3481),
    [anon_sym_u_SQUOTE] = ACTIONS(3481),
    [anon_sym_U_SQUOTE] = ACTIONS(3481),
    [anon_sym_u8_SQUOTE] = ACTIONS(3481),
    [anon_sym_SQUOTE] = ACTIONS(3481),
    [anon_sym_L_DQUOTE] = ACTIONS(3481),
    [anon_sym_u_DQUOTE] = ACTIONS(3481),
    [anon_sym_U_DQUOTE] = ACTIONS(3481),
    [anon_sym_u8_DQUOTE] = ACTIONS(3481),
    [anon_sym_DQUOTE] = ACTIONS(3481),
    [sym_true] = ACTIONS(3479),
    [sym_false] = ACTIONS(3479),
    [anon_sym_NULL] = ACTIONS(3479),
    [anon_sym_nullptr] = ACTIONS(3479),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3479),
    [anon_sym_decltype] = ACTIONS(3479),
    [anon_sym_virtual] = ACTIONS(3479),
    [anon_sym_alignas] = ACTIONS(3479),
    [anon_sym_explicit] = ACTIONS(3479),
    [anon_sym_typename] = ACTIONS(3479),
    [anon_sym_template] = ACTIONS(3479),
    [anon_sym_operator] = ACTIONS(3479),
    [anon_sym_try] = ACTIONS(3479),
    [anon_sym_delete] = ACTIONS(3479),
    [anon_sym_throw] = ACTIONS(3479),
    [anon_sym_namespace] = ACTIONS(3479),
    [anon_sym_using] = ACTIONS(3479),
    [anon_sym_static_assert] = ACTIONS(3479),
    [anon_sym_concept] = ACTIONS(3479),
    [anon_sym_co_return] = ACTIONS(3479),
    [anon_sym_co_yield] = ACTIONS(3479),
    [anon_sym_R_DQUOTE] = ACTIONS(3481),
    [anon_sym_LR_DQUOTE] = ACTIONS(3481),
    [anon_sym_uR_DQUOTE] = ACTIONS(3481),
    [anon_sym_UR_DQUOTE] = ACTIONS(3481),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3481),
    [anon_sym_co_await] = ACTIONS(3479),
    [anon_sym_new] = ACTIONS(3479),
    [anon_sym_requires] = ACTIONS(3479),
    [sym_this] = ACTIONS(3479),
  },
  [1012] = {
    [sym_preproc_def] = STATE(1021),
    [sym_preproc_function_def] = STATE(1021),
    [sym_preproc_call] = STATE(1021),
    [sym_preproc_if_in_field_declaration_list] = STATE(1021),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1021),
    [sym_type_definition] = STATE(1021),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1021),
    [sym_field_declaration] = STATE(1021),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1021),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1021),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1021),
    [sym_operator_cast_declaration] = STATE(1021),
    [sym_constructor_or_destructor_definition] = STATE(1021),
    [sym_constructor_or_destructor_declaration] = STATE(1021),
    [sym_friend_declaration] = STATE(1021),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1021),
    [sym_alias_declaration] = STATE(1021),
    [sym_static_assert_declaration] = STATE(1021),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1021),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3829),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3829),
    [sym_preproc_directive] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3833),
    [anon_sym_typedef] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3847),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_static_assert] = ACTIONS(3845),
  },
  [1013] = {
    [ts_builtin_sym_end] = ACTIONS(3381),
    [sym_identifier] = ACTIONS(3379),
    [aux_sym_preproc_include_token1] = ACTIONS(3379),
    [aux_sym_preproc_def_token1] = ACTIONS(3379),
    [aux_sym_preproc_if_token1] = ACTIONS(3379),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3379),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3379),
    [sym_preproc_directive] = ACTIONS(3379),
    [anon_sym_LPAREN2] = ACTIONS(3381),
    [anon_sym_BANG] = ACTIONS(3381),
    [anon_sym_TILDE] = ACTIONS(3381),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_STAR] = ACTIONS(3381),
    [anon_sym_AMP_AMP] = ACTIONS(3381),
    [anon_sym_AMP] = ACTIONS(3379),
    [anon_sym___extension__] = ACTIONS(3379),
    [anon_sym_typedef] = ACTIONS(3379),
    [anon_sym_extern] = ACTIONS(3379),
    [anon_sym___attribute__] = ACTIONS(3379),
    [anon_sym_COLON_COLON] = ACTIONS(3381),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3381),
    [anon_sym___declspec] = ACTIONS(3379),
    [anon_sym___based] = ACTIONS(3379),
    [anon_sym___cdecl] = ACTIONS(3379),
    [anon_sym___clrcall] = ACTIONS(3379),
    [anon_sym___stdcall] = ACTIONS(3379),
    [anon_sym___fastcall] = ACTIONS(3379),
    [anon_sym___thiscall] = ACTIONS(3379),
    [anon_sym___vectorcall] = ACTIONS(3379),
    [anon_sym_LBRACE] = ACTIONS(3381),
    [anon_sym_signed] = ACTIONS(3379),
    [anon_sym_unsigned] = ACTIONS(3379),
    [anon_sym_long] = ACTIONS(3379),
    [anon_sym_short] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_register] = ACTIONS(3379),
    [anon_sym_inline] = ACTIONS(3379),
    [anon_sym___inline] = ACTIONS(3379),
    [anon_sym___inline__] = ACTIONS(3379),
    [anon_sym___forceinline] = ACTIONS(3379),
    [anon_sym_thread_local] = ACTIONS(3379),
    [anon_sym___thread] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_constexpr] = ACTIONS(3379),
    [anon_sym_volatile] = ACTIONS(3379),
    [anon_sym_restrict] = ACTIONS(3379),
    [anon_sym___restrict__] = ACTIONS(3379),
    [anon_sym__Atomic] = ACTIONS(3379),
    [anon_sym__Noreturn] = ACTIONS(3379),
    [anon_sym_noreturn] = ACTIONS(3379),
    [anon_sym_mutable] = ACTIONS(3379),
    [anon_sym_constinit] = ACTIONS(3379),
    [anon_sym_consteval] = ACTIONS(3379),
    [anon_sym_PROGMEM] = ACTIONS(3379),
    [aux_sym_primitive_type_token1] = ACTIONS(3379),
    [anon_sym_byte] = ACTIONS(3379),
    [anon_sym_word] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_struct] = ACTIONS(3379),
    [anon_sym_union] = ACTIONS(3379),
    [anon_sym_if] = ACTIONS(3379),
    [anon_sym_switch] = ACTIONS(3379),
    [anon_sym_case] = ACTIONS(3379),
    [anon_sym_default] = ACTIONS(3379),
    [anon_sym_while] = ACTIONS(3379),
    [anon_sym_do] = ACTIONS(3379),
    [anon_sym_for] = ACTIONS(3379),
    [anon_sym_return] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(3379),
    [anon_sym_continue] = ACTIONS(3379),
    [anon_sym_goto] = ACTIONS(3379),
    [anon_sym_not] = ACTIONS(3379),
    [anon_sym_compl] = ACTIONS(3379),
    [anon_sym_DASH_DASH] = ACTIONS(3381),
    [anon_sym_PLUS_PLUS] = ACTIONS(3381),
    [anon_sym_sizeof] = ACTIONS(3379),
    [anon_sym___alignof__] = ACTIONS(3379),
    [anon_sym___alignof] = ACTIONS(3379),
    [anon_sym__alignof] = ACTIONS(3379),
    [anon_sym_alignof] = ACTIONS(3379),
    [anon_sym__Alignof] = ACTIONS(3379),
    [anon_sym_offsetof] = ACTIONS(3379),
    [anon_sym__Generic] = ACTIONS(3379),
    [anon_sym_asm] = ACTIONS(3379),
    [anon_sym___asm__] = ACTIONS(3379),
    [aux_sym_number_literal_token1] = ACTIONS(3381),
    [aux_sym_number_literal_token2] = ACTIONS(3379),
    [anon_sym_L_SQUOTE] = ACTIONS(3381),
    [anon_sym_u_SQUOTE] = ACTIONS(3381),
    [anon_sym_U_SQUOTE] = ACTIONS(3381),
    [anon_sym_u8_SQUOTE] = ACTIONS(3381),
    [anon_sym_SQUOTE] = ACTIONS(3381),
    [anon_sym_L_DQUOTE] = ACTIONS(3381),
    [anon_sym_u_DQUOTE] = ACTIONS(3381),
    [anon_sym_U_DQUOTE] = ACTIONS(3381),
    [anon_sym_u8_DQUOTE] = ACTIONS(3381),
    [anon_sym_DQUOTE] = ACTIONS(3381),
    [sym_true] = ACTIONS(3379),
    [sym_false] = ACTIONS(3379),
    [anon_sym_NULL] = ACTIONS(3379),
    [anon_sym_nullptr] = ACTIONS(3379),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3379),
    [anon_sym_decltype] = ACTIONS(3379),
    [anon_sym_virtual] = ACTIONS(3379),
    [anon_sym_alignas] = ACTIONS(3379),
    [anon_sym_explicit] = ACTIONS(3379),
    [anon_sym_typename] = ACTIONS(3379),
    [anon_sym_template] = ACTIONS(3379),
    [anon_sym_operator] = ACTIONS(3379),
    [anon_sym_try] = ACTIONS(3379),
    [anon_sym_delete] = ACTIONS(3379),
    [anon_sym_throw] = ACTIONS(3379),
    [anon_sym_namespace] = ACTIONS(3379),
    [anon_sym_using] = ACTIONS(3379),
    [anon_sym_static_assert] = ACTIONS(3379),
    [anon_sym_concept] = ACTIONS(3379),
    [anon_sym_co_return] = ACTIONS(3379),
    [anon_sym_co_yield] = ACTIONS(3379),
    [anon_sym_R_DQUOTE] = ACTIONS(3381),
    [anon_sym_LR_DQUOTE] = ACTIONS(3381),
    [anon_sym_uR_DQUOTE] = ACTIONS(3381),
    [anon_sym_UR_DQUOTE] = ACTIONS(3381),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3381),
    [anon_sym_co_await] = ACTIONS(3379),
    [anon_sym_new] = ACTIONS(3379),
    [anon_sym_requires] = ACTIONS(3379),
    [sym_this] = ACTIONS(3379),
  },
  [1014] = {
    [sym_preproc_def] = STATE(1056),
    [sym_preproc_function_def] = STATE(1056),
    [sym_preproc_call] = STATE(1056),
    [sym_preproc_if_in_field_declaration_list] = STATE(1056),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1056),
    [sym_type_definition] = STATE(1056),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1056),
    [sym_field_declaration] = STATE(1056),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1056),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1056),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1056),
    [sym_operator_cast_declaration] = STATE(1056),
    [sym_constructor_or_destructor_definition] = STATE(1056),
    [sym_constructor_or_destructor_declaration] = STATE(1056),
    [sym_friend_declaration] = STATE(1056),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1056),
    [sym_alias_declaration] = STATE(1056),
    [sym_static_assert_declaration] = STATE(1056),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1056),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3829),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3829),
    [sym_preproc_directive] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3833),
    [anon_sym_typedef] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3849),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_static_assert] = ACTIONS(3845),
  },
  [1015] = {
    [ts_builtin_sym_end] = ACTIONS(3511),
    [sym_identifier] = ACTIONS(3509),
    [aux_sym_preproc_include_token1] = ACTIONS(3509),
    [aux_sym_preproc_def_token1] = ACTIONS(3509),
    [aux_sym_preproc_if_token1] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3509),
    [sym_preproc_directive] = ACTIONS(3509),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_BANG] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3509),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym___extension__] = ACTIONS(3509),
    [anon_sym_typedef] = ACTIONS(3509),
    [anon_sym_extern] = ACTIONS(3509),
    [anon_sym___attribute__] = ACTIONS(3509),
    [anon_sym_COLON_COLON] = ACTIONS(3511),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3511),
    [anon_sym___declspec] = ACTIONS(3509),
    [anon_sym___based] = ACTIONS(3509),
    [anon_sym___cdecl] = ACTIONS(3509),
    [anon_sym___clrcall] = ACTIONS(3509),
    [anon_sym___stdcall] = ACTIONS(3509),
    [anon_sym___fastcall] = ACTIONS(3509),
    [anon_sym___thiscall] = ACTIONS(3509),
    [anon_sym___vectorcall] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_signed] = ACTIONS(3509),
    [anon_sym_unsigned] = ACTIONS(3509),
    [anon_sym_long] = ACTIONS(3509),
    [anon_sym_short] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(3509),
    [anon_sym_static] = ACTIONS(3509),
    [anon_sym_register] = ACTIONS(3509),
    [anon_sym_inline] = ACTIONS(3509),
    [anon_sym___inline] = ACTIONS(3509),
    [anon_sym___inline__] = ACTIONS(3509),
    [anon_sym___forceinline] = ACTIONS(3509),
    [anon_sym_thread_local] = ACTIONS(3509),
    [anon_sym___thread] = ACTIONS(3509),
    [anon_sym_const] = ACTIONS(3509),
    [anon_sym_constexpr] = ACTIONS(3509),
    [anon_sym_volatile] = ACTIONS(3509),
    [anon_sym_restrict] = ACTIONS(3509),
    [anon_sym___restrict__] = ACTIONS(3509),
    [anon_sym__Atomic] = ACTIONS(3509),
    [anon_sym__Noreturn] = ACTIONS(3509),
    [anon_sym_noreturn] = ACTIONS(3509),
    [anon_sym_mutable] = ACTIONS(3509),
    [anon_sym_constinit] = ACTIONS(3509),
    [anon_sym_consteval] = ACTIONS(3509),
    [anon_sym_PROGMEM] = ACTIONS(3509),
    [aux_sym_primitive_type_token1] = ACTIONS(3509),
    [anon_sym_byte] = ACTIONS(3509),
    [anon_sym_word] = ACTIONS(3509),
    [anon_sym_enum] = ACTIONS(3509),
    [anon_sym_class] = ACTIONS(3509),
    [anon_sym_struct] = ACTIONS(3509),
    [anon_sym_union] = ACTIONS(3509),
    [anon_sym_if] = ACTIONS(3509),
    [anon_sym_switch] = ACTIONS(3509),
    [anon_sym_case] = ACTIONS(3509),
    [anon_sym_default] = ACTIONS(3509),
    [anon_sym_while] = ACTIONS(3509),
    [anon_sym_do] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3509),
    [anon_sym_return] = ACTIONS(3509),
    [anon_sym_break] = ACTIONS(3509),
    [anon_sym_continue] = ACTIONS(3509),
    [anon_sym_goto] = ACTIONS(3509),
    [anon_sym_not] = ACTIONS(3509),
    [anon_sym_compl] = ACTIONS(3509),
    [anon_sym_DASH_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_PLUS] = ACTIONS(3511),
    [anon_sym_sizeof] = ACTIONS(3509),
    [anon_sym___alignof__] = ACTIONS(3509),
    [anon_sym___alignof] = ACTIONS(3509),
    [anon_sym__alignof] = ACTIONS(3509),
    [anon_sym_alignof] = ACTIONS(3509),
    [anon_sym__Alignof] = ACTIONS(3509),
    [anon_sym_offsetof] = ACTIONS(3509),
    [anon_sym__Generic] = ACTIONS(3509),
    [anon_sym_asm] = ACTIONS(3509),
    [anon_sym___asm__] = ACTIONS(3509),
    [aux_sym_number_literal_token1] = ACTIONS(3511),
    [aux_sym_number_literal_token2] = ACTIONS(3509),
    [anon_sym_L_SQUOTE] = ACTIONS(3511),
    [anon_sym_u_SQUOTE] = ACTIONS(3511),
    [anon_sym_U_SQUOTE] = ACTIONS(3511),
    [anon_sym_u8_SQUOTE] = ACTIONS(3511),
    [anon_sym_SQUOTE] = ACTIONS(3511),
    [anon_sym_L_DQUOTE] = ACTIONS(3511),
    [anon_sym_u_DQUOTE] = ACTIONS(3511),
    [anon_sym_U_DQUOTE] = ACTIONS(3511),
    [anon_sym_u8_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [sym_true] = ACTIONS(3509),
    [sym_false] = ACTIONS(3509),
    [anon_sym_NULL] = ACTIONS(3509),
    [anon_sym_nullptr] = ACTIONS(3509),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3509),
    [anon_sym_decltype] = ACTIONS(3509),
    [anon_sym_virtual] = ACTIONS(3509),
    [anon_sym_alignas] = ACTIONS(3509),
    [anon_sym_explicit] = ACTIONS(3509),
    [anon_sym_typename] = ACTIONS(3509),
    [anon_sym_template] = ACTIONS(3509),
    [anon_sym_operator] = ACTIONS(3509),
    [anon_sym_try] = ACTIONS(3509),
    [anon_sym_delete] = ACTIONS(3509),
    [anon_sym_throw] = ACTIONS(3509),
    [anon_sym_namespace] = ACTIONS(3509),
    [anon_sym_using] = ACTIONS(3509),
    [anon_sym_static_assert] = ACTIONS(3509),
    [anon_sym_concept] = ACTIONS(3509),
    [anon_sym_co_return] = ACTIONS(3509),
    [anon_sym_co_yield] = ACTIONS(3509),
    [anon_sym_R_DQUOTE] = ACTIONS(3511),
    [anon_sym_LR_DQUOTE] = ACTIONS(3511),
    [anon_sym_uR_DQUOTE] = ACTIONS(3511),
    [anon_sym_UR_DQUOTE] = ACTIONS(3511),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3511),
    [anon_sym_co_await] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3509),
    [anon_sym_requires] = ACTIONS(3509),
    [sym_this] = ACTIONS(3509),
  },
  [1016] = {
    [ts_builtin_sym_end] = ACTIONS(3485),
    [sym_identifier] = ACTIONS(3483),
    [aux_sym_preproc_include_token1] = ACTIONS(3483),
    [aux_sym_preproc_def_token1] = ACTIONS(3483),
    [aux_sym_preproc_if_token1] = ACTIONS(3483),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3483),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3483),
    [sym_preproc_directive] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_BANG] = ACTIONS(3485),
    [anon_sym_TILDE] = ACTIONS(3485),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_STAR] = ACTIONS(3485),
    [anon_sym_AMP_AMP] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym___extension__] = ACTIONS(3483),
    [anon_sym_typedef] = ACTIONS(3483),
    [anon_sym_extern] = ACTIONS(3483),
    [anon_sym___attribute__] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3485),
    [anon_sym___declspec] = ACTIONS(3483),
    [anon_sym___based] = ACTIONS(3483),
    [anon_sym___cdecl] = ACTIONS(3483),
    [anon_sym___clrcall] = ACTIONS(3483),
    [anon_sym___stdcall] = ACTIONS(3483),
    [anon_sym___fastcall] = ACTIONS(3483),
    [anon_sym___thiscall] = ACTIONS(3483),
    [anon_sym___vectorcall] = ACTIONS(3483),
    [anon_sym_LBRACE] = ACTIONS(3485),
    [anon_sym_signed] = ACTIONS(3483),
    [anon_sym_unsigned] = ACTIONS(3483),
    [anon_sym_long] = ACTIONS(3483),
    [anon_sym_short] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_static] = ACTIONS(3483),
    [anon_sym_register] = ACTIONS(3483),
    [anon_sym_inline] = ACTIONS(3483),
    [anon_sym___inline] = ACTIONS(3483),
    [anon_sym___inline__] = ACTIONS(3483),
    [anon_sym___forceinline] = ACTIONS(3483),
    [anon_sym_thread_local] = ACTIONS(3483),
    [anon_sym___thread] = ACTIONS(3483),
    [anon_sym_const] = ACTIONS(3483),
    [anon_sym_constexpr] = ACTIONS(3483),
    [anon_sym_volatile] = ACTIONS(3483),
    [anon_sym_restrict] = ACTIONS(3483),
    [anon_sym___restrict__] = ACTIONS(3483),
    [anon_sym__Atomic] = ACTIONS(3483),
    [anon_sym__Noreturn] = ACTIONS(3483),
    [anon_sym_noreturn] = ACTIONS(3483),
    [anon_sym_mutable] = ACTIONS(3483),
    [anon_sym_constinit] = ACTIONS(3483),
    [anon_sym_consteval] = ACTIONS(3483),
    [anon_sym_PROGMEM] = ACTIONS(3483),
    [aux_sym_primitive_type_token1] = ACTIONS(3483),
    [anon_sym_byte] = ACTIONS(3483),
    [anon_sym_word] = ACTIONS(3483),
    [anon_sym_enum] = ACTIONS(3483),
    [anon_sym_class] = ACTIONS(3483),
    [anon_sym_struct] = ACTIONS(3483),
    [anon_sym_union] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_switch] = ACTIONS(3483),
    [anon_sym_case] = ACTIONS(3483),
    [anon_sym_default] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_break] = ACTIONS(3483),
    [anon_sym_continue] = ACTIONS(3483),
    [anon_sym_goto] = ACTIONS(3483),
    [anon_sym_not] = ACTIONS(3483),
    [anon_sym_compl] = ACTIONS(3483),
    [anon_sym_DASH_DASH] = ACTIONS(3485),
    [anon_sym_PLUS_PLUS] = ACTIONS(3485),
    [anon_sym_sizeof] = ACTIONS(3483),
    [anon_sym___alignof__] = ACTIONS(3483),
    [anon_sym___alignof] = ACTIONS(3483),
    [anon_sym__alignof] = ACTIONS(3483),
    [anon_sym_alignof] = ACTIONS(3483),
    [anon_sym__Alignof] = ACTIONS(3483),
    [anon_sym_offsetof] = ACTIONS(3483),
    [anon_sym__Generic] = ACTIONS(3483),
    [anon_sym_asm] = ACTIONS(3483),
    [anon_sym___asm__] = ACTIONS(3483),
    [aux_sym_number_literal_token1] = ACTIONS(3485),
    [aux_sym_number_literal_token2] = ACTIONS(3483),
    [anon_sym_L_SQUOTE] = ACTIONS(3485),
    [anon_sym_u_SQUOTE] = ACTIONS(3485),
    [anon_sym_U_SQUOTE] = ACTIONS(3485),
    [anon_sym_u8_SQUOTE] = ACTIONS(3485),
    [anon_sym_SQUOTE] = ACTIONS(3485),
    [anon_sym_L_DQUOTE] = ACTIONS(3485),
    [anon_sym_u_DQUOTE] = ACTIONS(3485),
    [anon_sym_U_DQUOTE] = ACTIONS(3485),
    [anon_sym_u8_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE] = ACTIONS(3485),
    [sym_true] = ACTIONS(3483),
    [sym_false] = ACTIONS(3483),
    [anon_sym_NULL] = ACTIONS(3483),
    [anon_sym_nullptr] = ACTIONS(3483),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3483),
    [anon_sym_decltype] = ACTIONS(3483),
    [anon_sym_virtual] = ACTIONS(3483),
    [anon_sym_alignas] = ACTIONS(3483),
    [anon_sym_explicit] = ACTIONS(3483),
    [anon_sym_typename] = ACTIONS(3483),
    [anon_sym_template] = ACTIONS(3483),
    [anon_sym_operator] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_delete] = ACTIONS(3483),
    [anon_sym_throw] = ACTIONS(3483),
    [anon_sym_namespace] = ACTIONS(3483),
    [anon_sym_using] = ACTIONS(3483),
    [anon_sym_static_assert] = ACTIONS(3483),
    [anon_sym_concept] = ACTIONS(3483),
    [anon_sym_co_return] = ACTIONS(3483),
    [anon_sym_co_yield] = ACTIONS(3483),
    [anon_sym_R_DQUOTE] = ACTIONS(3485),
    [anon_sym_LR_DQUOTE] = ACTIONS(3485),
    [anon_sym_uR_DQUOTE] = ACTIONS(3485),
    [anon_sym_UR_DQUOTE] = ACTIONS(3485),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3485),
    [anon_sym_co_await] = ACTIONS(3483),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_requires] = ACTIONS(3483),
    [sym_this] = ACTIONS(3483),
  },
  [1017] = {
    [ts_builtin_sym_end] = ACTIONS(3477),
    [sym_identifier] = ACTIONS(3475),
    [aux_sym_preproc_include_token1] = ACTIONS(3475),
    [aux_sym_preproc_def_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token1] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3475),
    [sym_preproc_directive] = ACTIONS(3475),
    [anon_sym_LPAREN2] = ACTIONS(3477),
    [anon_sym_BANG] = ACTIONS(3477),
    [anon_sym_TILDE] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3475),
    [anon_sym_PLUS] = ACTIONS(3475),
    [anon_sym_STAR] = ACTIONS(3477),
    [anon_sym_AMP_AMP] = ACTIONS(3477),
    [anon_sym_AMP] = ACTIONS(3475),
    [anon_sym___extension__] = ACTIONS(3475),
    [anon_sym_typedef] = ACTIONS(3475),
    [anon_sym_extern] = ACTIONS(3475),
    [anon_sym___attribute__] = ACTIONS(3475),
    [anon_sym_COLON_COLON] = ACTIONS(3477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3477),
    [anon_sym___declspec] = ACTIONS(3475),
    [anon_sym___based] = ACTIONS(3475),
    [anon_sym___cdecl] = ACTIONS(3475),
    [anon_sym___clrcall] = ACTIONS(3475),
    [anon_sym___stdcall] = ACTIONS(3475),
    [anon_sym___fastcall] = ACTIONS(3475),
    [anon_sym___thiscall] = ACTIONS(3475),
    [anon_sym___vectorcall] = ACTIONS(3475),
    [anon_sym_LBRACE] = ACTIONS(3477),
    [anon_sym_signed] = ACTIONS(3475),
    [anon_sym_unsigned] = ACTIONS(3475),
    [anon_sym_long] = ACTIONS(3475),
    [anon_sym_short] = ACTIONS(3475),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [anon_sym_static] = ACTIONS(3475),
    [anon_sym_register] = ACTIONS(3475),
    [anon_sym_inline] = ACTIONS(3475),
    [anon_sym___inline] = ACTIONS(3475),
    [anon_sym___inline__] = ACTIONS(3475),
    [anon_sym___forceinline] = ACTIONS(3475),
    [anon_sym_thread_local] = ACTIONS(3475),
    [anon_sym___thread] = ACTIONS(3475),
    [anon_sym_const] = ACTIONS(3475),
    [anon_sym_constexpr] = ACTIONS(3475),
    [anon_sym_volatile] = ACTIONS(3475),
    [anon_sym_restrict] = ACTIONS(3475),
    [anon_sym___restrict__] = ACTIONS(3475),
    [anon_sym__Atomic] = ACTIONS(3475),
    [anon_sym__Noreturn] = ACTIONS(3475),
    [anon_sym_noreturn] = ACTIONS(3475),
    [anon_sym_mutable] = ACTIONS(3475),
    [anon_sym_constinit] = ACTIONS(3475),
    [anon_sym_consteval] = ACTIONS(3475),
    [anon_sym_PROGMEM] = ACTIONS(3475),
    [aux_sym_primitive_type_token1] = ACTIONS(3475),
    [anon_sym_byte] = ACTIONS(3475),
    [anon_sym_word] = ACTIONS(3475),
    [anon_sym_enum] = ACTIONS(3475),
    [anon_sym_class] = ACTIONS(3475),
    [anon_sym_struct] = ACTIONS(3475),
    [anon_sym_union] = ACTIONS(3475),
    [anon_sym_if] = ACTIONS(3475),
    [anon_sym_switch] = ACTIONS(3475),
    [anon_sym_case] = ACTIONS(3475),
    [anon_sym_default] = ACTIONS(3475),
    [anon_sym_while] = ACTIONS(3475),
    [anon_sym_do] = ACTIONS(3475),
    [anon_sym_for] = ACTIONS(3475),
    [anon_sym_return] = ACTIONS(3475),
    [anon_sym_break] = ACTIONS(3475),
    [anon_sym_continue] = ACTIONS(3475),
    [anon_sym_goto] = ACTIONS(3475),
    [anon_sym_not] = ACTIONS(3475),
    [anon_sym_compl] = ACTIONS(3475),
    [anon_sym_DASH_DASH] = ACTIONS(3477),
    [anon_sym_PLUS_PLUS] = ACTIONS(3477),
    [anon_sym_sizeof] = ACTIONS(3475),
    [anon_sym___alignof__] = ACTIONS(3475),
    [anon_sym___alignof] = ACTIONS(3475),
    [anon_sym__alignof] = ACTIONS(3475),
    [anon_sym_alignof] = ACTIONS(3475),
    [anon_sym__Alignof] = ACTIONS(3475),
    [anon_sym_offsetof] = ACTIONS(3475),
    [anon_sym__Generic] = ACTIONS(3475),
    [anon_sym_asm] = ACTIONS(3475),
    [anon_sym___asm__] = ACTIONS(3475),
    [aux_sym_number_literal_token1] = ACTIONS(3477),
    [aux_sym_number_literal_token2] = ACTIONS(3475),
    [anon_sym_L_SQUOTE] = ACTIONS(3477),
    [anon_sym_u_SQUOTE] = ACTIONS(3477),
    [anon_sym_U_SQUOTE] = ACTIONS(3477),
    [anon_sym_u8_SQUOTE] = ACTIONS(3477),
    [anon_sym_SQUOTE] = ACTIONS(3477),
    [anon_sym_L_DQUOTE] = ACTIONS(3477),
    [anon_sym_u_DQUOTE] = ACTIONS(3477),
    [anon_sym_U_DQUOTE] = ACTIONS(3477),
    [anon_sym_u8_DQUOTE] = ACTIONS(3477),
    [anon_sym_DQUOTE] = ACTIONS(3477),
    [sym_true] = ACTIONS(3475),
    [sym_false] = ACTIONS(3475),
    [anon_sym_NULL] = ACTIONS(3475),
    [anon_sym_nullptr] = ACTIONS(3475),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3475),
    [anon_sym_decltype] = ACTIONS(3475),
    [anon_sym_virtual] = ACTIONS(3475),
    [anon_sym_alignas] = ACTIONS(3475),
    [anon_sym_explicit] = ACTIONS(3475),
    [anon_sym_typename] = ACTIONS(3475),
    [anon_sym_template] = ACTIONS(3475),
    [anon_sym_operator] = ACTIONS(3475),
    [anon_sym_try] = ACTIONS(3475),
    [anon_sym_delete] = ACTIONS(3475),
    [anon_sym_throw] = ACTIONS(3475),
    [anon_sym_namespace] = ACTIONS(3475),
    [anon_sym_using] = ACTIONS(3475),
    [anon_sym_static_assert] = ACTIONS(3475),
    [anon_sym_concept] = ACTIONS(3475),
    [anon_sym_co_return] = ACTIONS(3475),
    [anon_sym_co_yield] = ACTIONS(3475),
    [anon_sym_R_DQUOTE] = ACTIONS(3477),
    [anon_sym_LR_DQUOTE] = ACTIONS(3477),
    [anon_sym_uR_DQUOTE] = ACTIONS(3477),
    [anon_sym_UR_DQUOTE] = ACTIONS(3477),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3477),
    [anon_sym_co_await] = ACTIONS(3475),
    [anon_sym_new] = ACTIONS(3475),
    [anon_sym_requires] = ACTIONS(3475),
    [sym_this] = ACTIONS(3475),
  },
  [1018] = {
    [sym_preproc_def] = STATE(1056),
    [sym_preproc_function_def] = STATE(1056),
    [sym_preproc_call] = STATE(1056),
    [sym_preproc_if_in_field_declaration_list] = STATE(1056),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1056),
    [sym_type_definition] = STATE(1056),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1056),
    [sym_field_declaration] = STATE(1056),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1056),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1056),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1056),
    [sym_operator_cast_declaration] = STATE(1056),
    [sym_constructor_or_destructor_definition] = STATE(1056),
    [sym_constructor_or_destructor_declaration] = STATE(1056),
    [sym_friend_declaration] = STATE(1056),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1056),
    [sym_alias_declaration] = STATE(1056),
    [sym_static_assert_declaration] = STATE(1056),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1056),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3829),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3829),
    [sym_preproc_directive] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3833),
    [anon_sym_typedef] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3851),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_static_assert] = ACTIONS(3845),
  },
  [1019] = {
    [sym_preproc_def] = STATE(1056),
    [sym_preproc_function_def] = STATE(1056),
    [sym_preproc_call] = STATE(1056),
    [sym_preproc_if_in_field_declaration_list] = STATE(1056),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1056),
    [sym_type_definition] = STATE(1056),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1056),
    [sym_field_declaration] = STATE(1056),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1056),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1056),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1056),
    [sym_operator_cast_declaration] = STATE(1056),
    [sym_constructor_or_destructor_definition] = STATE(1056),
    [sym_constructor_or_destructor_declaration] = STATE(1056),
    [sym_friend_declaration] = STATE(1056),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1056),
    [sym_alias_declaration] = STATE(1056),
    [sym_static_assert_declaration] = STATE(1056),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1056),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3829),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3829),
    [sym_preproc_directive] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3833),
    [anon_sym_typedef] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3853),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_static_assert] = ACTIONS(3845),
  },
  [1020] = {
    [sym_preproc_def] = STATE(1056),
    [sym_preproc_function_def] = STATE(1056),
    [sym_preproc_call] = STATE(1056),
    [sym_preproc_if_in_field_declaration_list] = STATE(1056),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1056),
    [sym_type_definition] = STATE(1056),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1056),
    [sym_field_declaration] = STATE(1056),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1056),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1056),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1056),
    [sym_operator_cast_declaration] = STATE(1056),
    [sym_constructor_or_destructor_definition] = STATE(1056),
    [sym_constructor_or_destructor_declaration] = STATE(1056),
    [sym_friend_declaration] = STATE(1056),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1056),
    [sym_alias_declaration] = STATE(1056),
    [sym_static_assert_declaration] = STATE(1056),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1056),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3829),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3829),
    [sym_preproc_directive] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3833),
    [anon_sym_typedef] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3855),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_static_assert] = ACTIONS(3845),
  },
  [1021] = {
    [sym_preproc_def] = STATE(1056),
    [sym_preproc_function_def] = STATE(1056),
    [sym_preproc_call] = STATE(1056),
    [sym_preproc_if_in_field_declaration_list] = STATE(1056),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1056),
    [sym_type_definition] = STATE(1056),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1056),
    [sym_field_declaration] = STATE(1056),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1056),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1056),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1056),
    [sym_operator_cast_declaration] = STATE(1056),
    [sym_constructor_or_destructor_definition] = STATE(1056),
    [sym_constructor_or_destructor_declaration] = STATE(1056),
    [sym_friend_declaration] = STATE(1056),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1056),
    [sym_alias_declaration] = STATE(1056),
    [sym_static_assert_declaration] = STATE(1056),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1056),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3829),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3829),
    [sym_preproc_directive] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3833),
    [anon_sym_typedef] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3857),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_static_assert] = ACTIONS(3845),
  },
  [1022] = {
    [sym_preproc_def] = STATE(1014),
    [sym_preproc_function_def] = STATE(1014),
    [sym_preproc_call] = STATE(1014),
    [sym_preproc_if_in_field_declaration_list] = STATE(1014),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1014),
    [sym_type_definition] = STATE(1014),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1014),
    [sym_field_declaration] = STATE(1014),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1014),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1014),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1014),
    [sym_operator_cast_declaration] = STATE(1014),
    [sym_constructor_or_destructor_definition] = STATE(1014),
    [sym_constructor_or_destructor_declaration] = STATE(1014),
    [sym_friend_declaration] = STATE(1014),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1014),
    [sym_alias_declaration] = STATE(1014),
    [sym_static_assert_declaration] = STATE(1014),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1014),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3829),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3829),
    [sym_preproc_directive] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3833),
    [anon_sym_typedef] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3859),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_static_assert] = ACTIONS(3845),
  },
  [1023] = {
    [ts_builtin_sym_end] = ACTIONS(3861),
    [sym_identifier] = ACTIONS(3863),
    [aux_sym_preproc_include_token1] = ACTIONS(3863),
    [aux_sym_preproc_def_token1] = ACTIONS(3863),
    [aux_sym_preproc_if_token1] = ACTIONS(3863),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3863),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3863),
    [sym_preproc_directive] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3861),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_STAR] = ACTIONS(3861),
    [anon_sym_AMP_AMP] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym___extension__] = ACTIONS(3863),
    [anon_sym_typedef] = ACTIONS(3863),
    [anon_sym_extern] = ACTIONS(3863),
    [anon_sym___attribute__] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3861),
    [anon_sym___declspec] = ACTIONS(3863),
    [anon_sym___based] = ACTIONS(3863),
    [anon_sym___cdecl] = ACTIONS(3863),
    [anon_sym___clrcall] = ACTIONS(3863),
    [anon_sym___stdcall] = ACTIONS(3863),
    [anon_sym___fastcall] = ACTIONS(3863),
    [anon_sym___thiscall] = ACTIONS(3863),
    [anon_sym___vectorcall] = ACTIONS(3863),
    [anon_sym_LBRACE] = ACTIONS(3861),
    [anon_sym_signed] = ACTIONS(3863),
    [anon_sym_unsigned] = ACTIONS(3863),
    [anon_sym_long] = ACTIONS(3863),
    [anon_sym_short] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_static] = ACTIONS(3863),
    [anon_sym_register] = ACTIONS(3863),
    [anon_sym_inline] = ACTIONS(3863),
    [anon_sym___inline] = ACTIONS(3863),
    [anon_sym___inline__] = ACTIONS(3863),
    [anon_sym___forceinline] = ACTIONS(3863),
    [anon_sym_thread_local] = ACTIONS(3863),
    [anon_sym___thread] = ACTIONS(3863),
    [anon_sym_const] = ACTIONS(3863),
    [anon_sym_constexpr] = ACTIONS(3863),
    [anon_sym_volatile] = ACTIONS(3863),
    [anon_sym_restrict] = ACTIONS(3863),
    [anon_sym___restrict__] = ACTIONS(3863),
    [anon_sym__Atomic] = ACTIONS(3863),
    [anon_sym__Noreturn] = ACTIONS(3863),
    [anon_sym_noreturn] = ACTIONS(3863),
    [anon_sym_mutable] = ACTIONS(3863),
    [anon_sym_constinit] = ACTIONS(3863),
    [anon_sym_consteval] = ACTIONS(3863),
    [anon_sym_PROGMEM] = ACTIONS(3863),
    [aux_sym_primitive_type_token1] = ACTIONS(3863),
    [anon_sym_byte] = ACTIONS(3863),
    [anon_sym_word] = ACTIONS(3863),
    [anon_sym_enum] = ACTIONS(3863),
    [anon_sym_class] = ACTIONS(3863),
    [anon_sym_struct] = ACTIONS(3863),
    [anon_sym_union] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_switch] = ACTIONS(3863),
    [anon_sym_case] = ACTIONS(3863),
    [anon_sym_default] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_break] = ACTIONS(3863),
    [anon_sym_continue] = ACTIONS(3863),
    [anon_sym_goto] = ACTIONS(3863),
    [anon_sym_not] = ACTIONS(3863),
    [anon_sym_compl] = ACTIONS(3863),
    [anon_sym_DASH_DASH] = ACTIONS(3861),
    [anon_sym_PLUS_PLUS] = ACTIONS(3861),
    [anon_sym_sizeof] = ACTIONS(3863),
    [anon_sym___alignof__] = ACTIONS(3863),
    [anon_sym___alignof] = ACTIONS(3863),
    [anon_sym__alignof] = ACTIONS(3863),
    [anon_sym_alignof] = ACTIONS(3863),
    [anon_sym__Alignof] = ACTIONS(3863),
    [anon_sym_offsetof] = ACTIONS(3863),
    [anon_sym__Generic] = ACTIONS(3863),
    [anon_sym_asm] = ACTIONS(3863),
    [anon_sym___asm__] = ACTIONS(3863),
    [aux_sym_number_literal_token1] = ACTIONS(3861),
    [aux_sym_number_literal_token2] = ACTIONS(3863),
    [anon_sym_L_SQUOTE] = ACTIONS(3861),
    [anon_sym_u_SQUOTE] = ACTIONS(3861),
    [anon_sym_U_SQUOTE] = ACTIONS(3861),
    [anon_sym_u8_SQUOTE] = ACTIONS(3861),
    [anon_sym_SQUOTE] = ACTIONS(3861),
    [anon_sym_L_DQUOTE] = ACTIONS(3861),
    [anon_sym_u_DQUOTE] = ACTIONS(3861),
    [anon_sym_U_DQUOTE] = ACTIONS(3861),
    [anon_sym_u8_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE] = ACTIONS(3861),
    [sym_true] = ACTIONS(3863),
    [sym_false] = ACTIONS(3863),
    [anon_sym_NULL] = ACTIONS(3863),
    [anon_sym_nullptr] = ACTIONS(3863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3863),
    [anon_sym_decltype] = ACTIONS(3863),
    [anon_sym_virtual] = ACTIONS(3863),
    [anon_sym_alignas] = ACTIONS(3863),
    [anon_sym_explicit] = ACTIONS(3863),
    [anon_sym_typename] = ACTIONS(3863),
    [anon_sym_template] = ACTIONS(3863),
    [anon_sym_operator] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_delete] = ACTIONS(3863),
    [anon_sym_throw] = ACTIONS(3863),
    [anon_sym_namespace] = ACTIONS(3863),
    [anon_sym_using] = ACTIONS(3863),
    [anon_sym_static_assert] = ACTIONS(3863),
    [anon_sym_concept] = ACTIONS(3863),
    [anon_sym_co_return] = ACTIONS(3863),
    [anon_sym_co_yield] = ACTIONS(3863),
    [anon_sym_R_DQUOTE] = ACTIONS(3861),
    [anon_sym_LR_DQUOTE] = ACTIONS(3861),
    [anon_sym_uR_DQUOTE] = ACTIONS(3861),
    [anon_sym_UR_DQUOTE] = ACTIONS(3861),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3861),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_requires] = ACTIONS(3863),
    [sym_this] = ACTIONS(3863),
  },
  [1024] = {
    [sym_preproc_def] = STATE(1010),
    [sym_preproc_function_def] = STATE(1010),
    [sym_preproc_call] = STATE(1010),
    [sym_preproc_if_in_field_declaration_list] = STATE(1010),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1010),
    [sym_type_definition] = STATE(1010),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1010),
    [sym_field_declaration] = STATE(1010),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1010),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1010),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1010),
    [sym_operator_cast_declaration] = STATE(1010),
    [sym_constructor_or_destructor_definition] = STATE(1010),
    [sym_constructor_or_destructor_declaration] = STATE(1010),
    [sym_friend_declaration] = STATE(1010),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1010),
    [sym_alias_declaration] = STATE(1010),
    [sym_static_assert_declaration] = STATE(1010),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1010),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3829),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3829),
    [sym_preproc_directive] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3833),
    [anon_sym_typedef] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3865),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_static_assert] = ACTIONS(3845),
  },
  [1025] = {
    [ts_builtin_sym_end] = ACTIONS(3867),
    [sym_identifier] = ACTIONS(3869),
    [aux_sym_preproc_include_token1] = ACTIONS(3869),
    [aux_sym_preproc_def_token1] = ACTIONS(3869),
    [aux_sym_preproc_if_token1] = ACTIONS(3869),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3869),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3869),
    [sym_preproc_directive] = ACTIONS(3869),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_BANG] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_AMP] = ACTIONS(3869),
    [anon_sym___extension__] = ACTIONS(3869),
    [anon_sym_typedef] = ACTIONS(3869),
    [anon_sym_extern] = ACTIONS(3869),
    [anon_sym___attribute__] = ACTIONS(3869),
    [anon_sym_COLON_COLON] = ACTIONS(3867),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3867),
    [anon_sym___declspec] = ACTIONS(3869),
    [anon_sym___based] = ACTIONS(3869),
    [anon_sym___cdecl] = ACTIONS(3869),
    [anon_sym___clrcall] = ACTIONS(3869),
    [anon_sym___stdcall] = ACTIONS(3869),
    [anon_sym___fastcall] = ACTIONS(3869),
    [anon_sym___thiscall] = ACTIONS(3869),
    [anon_sym___vectorcall] = ACTIONS(3869),
    [anon_sym_LBRACE] = ACTIONS(3867),
    [anon_sym_signed] = ACTIONS(3869),
    [anon_sym_unsigned] = ACTIONS(3869),
    [anon_sym_long] = ACTIONS(3869),
    [anon_sym_short] = ACTIONS(3869),
    [anon_sym_LBRACK] = ACTIONS(3869),
    [anon_sym_static] = ACTIONS(3869),
    [anon_sym_register] = ACTIONS(3869),
    [anon_sym_inline] = ACTIONS(3869),
    [anon_sym___inline] = ACTIONS(3869),
    [anon_sym___inline__] = ACTIONS(3869),
    [anon_sym___forceinline] = ACTIONS(3869),
    [anon_sym_thread_local] = ACTIONS(3869),
    [anon_sym___thread] = ACTIONS(3869),
    [anon_sym_const] = ACTIONS(3869),
    [anon_sym_constexpr] = ACTIONS(3869),
    [anon_sym_volatile] = ACTIONS(3869),
    [anon_sym_restrict] = ACTIONS(3869),
    [anon_sym___restrict__] = ACTIONS(3869),
    [anon_sym__Atomic] = ACTIONS(3869),
    [anon_sym__Noreturn] = ACTIONS(3869),
    [anon_sym_noreturn] = ACTIONS(3869),
    [anon_sym_mutable] = ACTIONS(3869),
    [anon_sym_constinit] = ACTIONS(3869),
    [anon_sym_consteval] = ACTIONS(3869),
    [anon_sym_PROGMEM] = ACTIONS(3869),
    [aux_sym_primitive_type_token1] = ACTIONS(3869),
    [anon_sym_byte] = ACTIONS(3869),
    [anon_sym_word] = ACTIONS(3869),
    [anon_sym_enum] = ACTIONS(3869),
    [anon_sym_class] = ACTIONS(3869),
    [anon_sym_struct] = ACTIONS(3869),
    [anon_sym_union] = ACTIONS(3869),
    [anon_sym_if] = ACTIONS(3869),
    [anon_sym_switch] = ACTIONS(3869),
    [anon_sym_case] = ACTIONS(3869),
    [anon_sym_default] = ACTIONS(3869),
    [anon_sym_while] = ACTIONS(3869),
    [anon_sym_do] = ACTIONS(3869),
    [anon_sym_for] = ACTIONS(3869),
    [anon_sym_return] = ACTIONS(3869),
    [anon_sym_break] = ACTIONS(3869),
    [anon_sym_continue] = ACTIONS(3869),
    [anon_sym_goto] = ACTIONS(3869),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(3867),
    [anon_sym_PLUS_PLUS] = ACTIONS(3867),
    [anon_sym_sizeof] = ACTIONS(3869),
    [anon_sym___alignof__] = ACTIONS(3869),
    [anon_sym___alignof] = ACTIONS(3869),
    [anon_sym__alignof] = ACTIONS(3869),
    [anon_sym_alignof] = ACTIONS(3869),
    [anon_sym__Alignof] = ACTIONS(3869),
    [anon_sym_offsetof] = ACTIONS(3869),
    [anon_sym__Generic] = ACTIONS(3869),
    [anon_sym_asm] = ACTIONS(3869),
    [anon_sym___asm__] = ACTIONS(3869),
    [aux_sym_number_literal_token1] = ACTIONS(3867),
    [aux_sym_number_literal_token2] = ACTIONS(3869),
    [anon_sym_L_SQUOTE] = ACTIONS(3867),
    [anon_sym_u_SQUOTE] = ACTIONS(3867),
    [anon_sym_U_SQUOTE] = ACTIONS(3867),
    [anon_sym_u8_SQUOTE] = ACTIONS(3867),
    [anon_sym_SQUOTE] = ACTIONS(3867),
    [anon_sym_L_DQUOTE] = ACTIONS(3867),
    [anon_sym_u_DQUOTE] = ACTIONS(3867),
    [anon_sym_U_DQUOTE] = ACTIONS(3867),
    [anon_sym_u8_DQUOTE] = ACTIONS(3867),
    [anon_sym_DQUOTE] = ACTIONS(3867),
    [sym_true] = ACTIONS(3869),
    [sym_false] = ACTIONS(3869),
    [anon_sym_NULL] = ACTIONS(3869),
    [anon_sym_nullptr] = ACTIONS(3869),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3869),
    [anon_sym_decltype] = ACTIONS(3869),
    [anon_sym_virtual] = ACTIONS(3869),
    [anon_sym_alignas] = ACTIONS(3869),
    [anon_sym_explicit] = ACTIONS(3869),
    [anon_sym_typename] = ACTIONS(3869),
    [anon_sym_template] = ACTIONS(3869),
    [anon_sym_operator] = ACTIONS(3869),
    [anon_sym_try] = ACTIONS(3869),
    [anon_sym_delete] = ACTIONS(3869),
    [anon_sym_throw] = ACTIONS(3869),
    [anon_sym_namespace] = ACTIONS(3869),
    [anon_sym_using] = ACTIONS(3869),
    [anon_sym_static_assert] = ACTIONS(3869),
    [anon_sym_concept] = ACTIONS(3869),
    [anon_sym_co_return] = ACTIONS(3869),
    [anon_sym_co_yield] = ACTIONS(3869),
    [anon_sym_R_DQUOTE] = ACTIONS(3867),
    [anon_sym_LR_DQUOTE] = ACTIONS(3867),
    [anon_sym_uR_DQUOTE] = ACTIONS(3867),
    [anon_sym_UR_DQUOTE] = ACTIONS(3867),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3867),
    [anon_sym_co_await] = ACTIONS(3869),
    [anon_sym_new] = ACTIONS(3869),
    [anon_sym_requires] = ACTIONS(3869),
    [sym_this] = ACTIONS(3869),
  },
  [1026] = {
    [ts_builtin_sym_end] = ACTIONS(3489),
    [sym_identifier] = ACTIONS(3487),
    [aux_sym_preproc_include_token1] = ACTIONS(3487),
    [aux_sym_preproc_def_token1] = ACTIONS(3487),
    [aux_sym_preproc_if_token1] = ACTIONS(3487),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3487),
    [sym_preproc_directive] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3489),
    [anon_sym_BANG] = ACTIONS(3489),
    [anon_sym_TILDE] = ACTIONS(3489),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3489),
    [anon_sym_AMP_AMP] = ACTIONS(3489),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym___extension__] = ACTIONS(3487),
    [anon_sym_typedef] = ACTIONS(3487),
    [anon_sym_extern] = ACTIONS(3487),
    [anon_sym___attribute__] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3489),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3489),
    [anon_sym___declspec] = ACTIONS(3487),
    [anon_sym___based] = ACTIONS(3487),
    [anon_sym___cdecl] = ACTIONS(3487),
    [anon_sym___clrcall] = ACTIONS(3487),
    [anon_sym___stdcall] = ACTIONS(3487),
    [anon_sym___fastcall] = ACTIONS(3487),
    [anon_sym___thiscall] = ACTIONS(3487),
    [anon_sym___vectorcall] = ACTIONS(3487),
    [anon_sym_LBRACE] = ACTIONS(3489),
    [anon_sym_signed] = ACTIONS(3487),
    [anon_sym_unsigned] = ACTIONS(3487),
    [anon_sym_long] = ACTIONS(3487),
    [anon_sym_short] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_register] = ACTIONS(3487),
    [anon_sym_inline] = ACTIONS(3487),
    [anon_sym___inline] = ACTIONS(3487),
    [anon_sym___inline__] = ACTIONS(3487),
    [anon_sym___forceinline] = ACTIONS(3487),
    [anon_sym_thread_local] = ACTIONS(3487),
    [anon_sym___thread] = ACTIONS(3487),
    [anon_sym_const] = ACTIONS(3487),
    [anon_sym_constexpr] = ACTIONS(3487),
    [anon_sym_volatile] = ACTIONS(3487),
    [anon_sym_restrict] = ACTIONS(3487),
    [anon_sym___restrict__] = ACTIONS(3487),
    [anon_sym__Atomic] = ACTIONS(3487),
    [anon_sym__Noreturn] = ACTIONS(3487),
    [anon_sym_noreturn] = ACTIONS(3487),
    [anon_sym_mutable] = ACTIONS(3487),
    [anon_sym_constinit] = ACTIONS(3487),
    [anon_sym_consteval] = ACTIONS(3487),
    [anon_sym_PROGMEM] = ACTIONS(3487),
    [aux_sym_primitive_type_token1] = ACTIONS(3487),
    [anon_sym_byte] = ACTIONS(3487),
    [anon_sym_word] = ACTIONS(3487),
    [anon_sym_enum] = ACTIONS(3487),
    [anon_sym_class] = ACTIONS(3487),
    [anon_sym_struct] = ACTIONS(3487),
    [anon_sym_union] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_switch] = ACTIONS(3487),
    [anon_sym_case] = ACTIONS(3487),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_break] = ACTIONS(3487),
    [anon_sym_continue] = ACTIONS(3487),
    [anon_sym_goto] = ACTIONS(3487),
    [anon_sym_not] = ACTIONS(3487),
    [anon_sym_compl] = ACTIONS(3487),
    [anon_sym_DASH_DASH] = ACTIONS(3489),
    [anon_sym_PLUS_PLUS] = ACTIONS(3489),
    [anon_sym_sizeof] = ACTIONS(3487),
    [anon_sym___alignof__] = ACTIONS(3487),
    [anon_sym___alignof] = ACTIONS(3487),
    [anon_sym__alignof] = ACTIONS(3487),
    [anon_sym_alignof] = ACTIONS(3487),
    [anon_sym__Alignof] = ACTIONS(3487),
    [anon_sym_offsetof] = ACTIONS(3487),
    [anon_sym__Generic] = ACTIONS(3487),
    [anon_sym_asm] = ACTIONS(3487),
    [anon_sym___asm__] = ACTIONS(3487),
    [aux_sym_number_literal_token1] = ACTIONS(3489),
    [aux_sym_number_literal_token2] = ACTIONS(3487),
    [anon_sym_L_SQUOTE] = ACTIONS(3489),
    [anon_sym_u_SQUOTE] = ACTIONS(3489),
    [anon_sym_U_SQUOTE] = ACTIONS(3489),
    [anon_sym_u8_SQUOTE] = ACTIONS(3489),
    [anon_sym_SQUOTE] = ACTIONS(3489),
    [anon_sym_L_DQUOTE] = ACTIONS(3489),
    [anon_sym_u_DQUOTE] = ACTIONS(3489),
    [anon_sym_U_DQUOTE] = ACTIONS(3489),
    [anon_sym_u8_DQUOTE] = ACTIONS(3489),
    [anon_sym_DQUOTE] = ACTIONS(3489),
    [sym_true] = ACTIONS(3487),
    [sym_false] = ACTIONS(3487),
    [anon_sym_NULL] = ACTIONS(3487),
    [anon_sym_nullptr] = ACTIONS(3487),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3487),
    [anon_sym_decltype] = ACTIONS(3487),
    [anon_sym_virtual] = ACTIONS(3487),
    [anon_sym_alignas] = ACTIONS(3487),
    [anon_sym_explicit] = ACTIONS(3487),
    [anon_sym_typename] = ACTIONS(3487),
    [anon_sym_template] = ACTIONS(3487),
    [anon_sym_operator] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_delete] = ACTIONS(3487),
    [anon_sym_throw] = ACTIONS(3487),
    [anon_sym_namespace] = ACTIONS(3487),
    [anon_sym_using] = ACTIONS(3487),
    [anon_sym_static_assert] = ACTIONS(3487),
    [anon_sym_concept] = ACTIONS(3487),
    [anon_sym_co_return] = ACTIONS(3487),
    [anon_sym_co_yield] = ACTIONS(3487),
    [anon_sym_R_DQUOTE] = ACTIONS(3489),
    [anon_sym_LR_DQUOTE] = ACTIONS(3489),
    [anon_sym_uR_DQUOTE] = ACTIONS(3489),
    [anon_sym_UR_DQUOTE] = ACTIONS(3489),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3489),
    [anon_sym_co_await] = ACTIONS(3487),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_requires] = ACTIONS(3487),
    [sym_this] = ACTIONS(3487),
  },
  [1027] = {
    [ts_builtin_sym_end] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3276),
    [aux_sym_preproc_include_token1] = ACTIONS(3276),
    [aux_sym_preproc_def_token1] = ACTIONS(3276),
    [aux_sym_preproc_if_token1] = ACTIONS(3276),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3276),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3276),
    [sym_preproc_directive] = ACTIONS(3276),
    [anon_sym_LPAREN2] = ACTIONS(3278),
    [anon_sym_BANG] = ACTIONS(3278),
    [anon_sym_TILDE] = ACTIONS(3278),
    [anon_sym_DASH] = ACTIONS(3276),
    [anon_sym_PLUS] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3278),
    [anon_sym_AMP_AMP] = ACTIONS(3278),
    [anon_sym_AMP] = ACTIONS(3276),
    [anon_sym___extension__] = ACTIONS(3276),
    [anon_sym_typedef] = ACTIONS(3276),
    [anon_sym_extern] = ACTIONS(3276),
    [anon_sym___attribute__] = ACTIONS(3276),
    [anon_sym_COLON_COLON] = ACTIONS(3278),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3278),
    [anon_sym___declspec] = ACTIONS(3276),
    [anon_sym___based] = ACTIONS(3276),
    [anon_sym___cdecl] = ACTIONS(3276),
    [anon_sym___clrcall] = ACTIONS(3276),
    [anon_sym___stdcall] = ACTIONS(3276),
    [anon_sym___fastcall] = ACTIONS(3276),
    [anon_sym___thiscall] = ACTIONS(3276),
    [anon_sym___vectorcall] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3278),
    [anon_sym_signed] = ACTIONS(3276),
    [anon_sym_unsigned] = ACTIONS(3276),
    [anon_sym_long] = ACTIONS(3276),
    [anon_sym_short] = ACTIONS(3276),
    [anon_sym_LBRACK] = ACTIONS(3276),
    [anon_sym_static] = ACTIONS(3276),
    [anon_sym_register] = ACTIONS(3276),
    [anon_sym_inline] = ACTIONS(3276),
    [anon_sym___inline] = ACTIONS(3276),
    [anon_sym___inline__] = ACTIONS(3276),
    [anon_sym___forceinline] = ACTIONS(3276),
    [anon_sym_thread_local] = ACTIONS(3276),
    [anon_sym___thread] = ACTIONS(3276),
    [anon_sym_const] = ACTIONS(3276),
    [anon_sym_constexpr] = ACTIONS(3276),
    [anon_sym_volatile] = ACTIONS(3276),
    [anon_sym_restrict] = ACTIONS(3276),
    [anon_sym___restrict__] = ACTIONS(3276),
    [anon_sym__Atomic] = ACTIONS(3276),
    [anon_sym__Noreturn] = ACTIONS(3276),
    [anon_sym_noreturn] = ACTIONS(3276),
    [anon_sym_mutable] = ACTIONS(3276),
    [anon_sym_constinit] = ACTIONS(3276),
    [anon_sym_consteval] = ACTIONS(3276),
    [anon_sym_PROGMEM] = ACTIONS(3276),
    [aux_sym_primitive_type_token1] = ACTIONS(3276),
    [anon_sym_byte] = ACTIONS(3276),
    [anon_sym_word] = ACTIONS(3276),
    [anon_sym_enum] = ACTIONS(3276),
    [anon_sym_class] = ACTIONS(3276),
    [anon_sym_struct] = ACTIONS(3276),
    [anon_sym_union] = ACTIONS(3276),
    [anon_sym_if] = ACTIONS(3276),
    [anon_sym_switch] = ACTIONS(3276),
    [anon_sym_case] = ACTIONS(3276),
    [anon_sym_default] = ACTIONS(3276),
    [anon_sym_while] = ACTIONS(3276),
    [anon_sym_do] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3276),
    [anon_sym_return] = ACTIONS(3276),
    [anon_sym_break] = ACTIONS(3276),
    [anon_sym_continue] = ACTIONS(3276),
    [anon_sym_goto] = ACTIONS(3276),
    [anon_sym_not] = ACTIONS(3276),
    [anon_sym_compl] = ACTIONS(3276),
    [anon_sym_DASH_DASH] = ACTIONS(3278),
    [anon_sym_PLUS_PLUS] = ACTIONS(3278),
    [anon_sym_sizeof] = ACTIONS(3276),
    [anon_sym___alignof__] = ACTIONS(3276),
    [anon_sym___alignof] = ACTIONS(3276),
    [anon_sym__alignof] = ACTIONS(3276),
    [anon_sym_alignof] = ACTIONS(3276),
    [anon_sym__Alignof] = ACTIONS(3276),
    [anon_sym_offsetof] = ACTIONS(3276),
    [anon_sym__Generic] = ACTIONS(3276),
    [anon_sym_asm] = ACTIONS(3276),
    [anon_sym___asm__] = ACTIONS(3276),
    [aux_sym_number_literal_token1] = ACTIONS(3278),
    [aux_sym_number_literal_token2] = ACTIONS(3276),
    [anon_sym_L_SQUOTE] = ACTIONS(3278),
    [anon_sym_u_SQUOTE] = ACTIONS(3278),
    [anon_sym_U_SQUOTE] = ACTIONS(3278),
    [anon_sym_u8_SQUOTE] = ACTIONS(3278),
    [anon_sym_SQUOTE] = ACTIONS(3278),
    [anon_sym_L_DQUOTE] = ACTIONS(3278),
    [anon_sym_u_DQUOTE] = ACTIONS(3278),
    [anon_sym_U_DQUOTE] = ACTIONS(3278),
    [anon_sym_u8_DQUOTE] = ACTIONS(3278),
    [anon_sym_DQUOTE] = ACTIONS(3278),
    [sym_true] = ACTIONS(3276),
    [sym_false] = ACTIONS(3276),
    [anon_sym_NULL] = ACTIONS(3276),
    [anon_sym_nullptr] = ACTIONS(3276),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3276),
    [anon_sym_decltype] = ACTIONS(3276),
    [anon_sym_virtual] = ACTIONS(3276),
    [anon_sym_alignas] = ACTIONS(3276),
    [anon_sym_explicit] = ACTIONS(3276),
    [anon_sym_typename] = ACTIONS(3276),
    [anon_sym_template] = ACTIONS(3276),
    [anon_sym_operator] = ACTIONS(3276),
    [anon_sym_try] = ACTIONS(3276),
    [anon_sym_delete] = ACTIONS(3276),
    [anon_sym_throw] = ACTIONS(3276),
    [anon_sym_namespace] = ACTIONS(3276),
    [anon_sym_using] = ACTIONS(3276),
    [anon_sym_static_assert] = ACTIONS(3276),
    [anon_sym_concept] = ACTIONS(3276),
    [anon_sym_co_return] = ACTIONS(3276),
    [anon_sym_co_yield] = ACTIONS(3276),
    [anon_sym_R_DQUOTE] = ACTIONS(3278),
    [anon_sym_LR_DQUOTE] = ACTIONS(3278),
    [anon_sym_uR_DQUOTE] = ACTIONS(3278),
    [anon_sym_UR_DQUOTE] = ACTIONS(3278),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3278),
    [anon_sym_co_await] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3276),
    [anon_sym_requires] = ACTIONS(3276),
    [sym_this] = ACTIONS(3276),
  },
  [1028] = {
    [ts_builtin_sym_end] = ACTIONS(3252),
    [sym_identifier] = ACTIONS(3250),
    [aux_sym_preproc_include_token1] = ACTIONS(3250),
    [aux_sym_preproc_def_token1] = ACTIONS(3250),
    [aux_sym_preproc_if_token1] = ACTIONS(3250),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3250),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3250),
    [sym_preproc_directive] = ACTIONS(3250),
    [anon_sym_LPAREN2] = ACTIONS(3252),
    [anon_sym_BANG] = ACTIONS(3252),
    [anon_sym_TILDE] = ACTIONS(3252),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_STAR] = ACTIONS(3252),
    [anon_sym_AMP_AMP] = ACTIONS(3252),
    [anon_sym_AMP] = ACTIONS(3250),
    [anon_sym___extension__] = ACTIONS(3250),
    [anon_sym_typedef] = ACTIONS(3250),
    [anon_sym_extern] = ACTIONS(3250),
    [anon_sym___attribute__] = ACTIONS(3250),
    [anon_sym_COLON_COLON] = ACTIONS(3252),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3252),
    [anon_sym___declspec] = ACTIONS(3250),
    [anon_sym___based] = ACTIONS(3250),
    [anon_sym___cdecl] = ACTIONS(3250),
    [anon_sym___clrcall] = ACTIONS(3250),
    [anon_sym___stdcall] = ACTIONS(3250),
    [anon_sym___fastcall] = ACTIONS(3250),
    [anon_sym___thiscall] = ACTIONS(3250),
    [anon_sym___vectorcall] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3252),
    [anon_sym_signed] = ACTIONS(3250),
    [anon_sym_unsigned] = ACTIONS(3250),
    [anon_sym_long] = ACTIONS(3250),
    [anon_sym_short] = ACTIONS(3250),
    [anon_sym_LBRACK] = ACTIONS(3250),
    [anon_sym_static] = ACTIONS(3250),
    [anon_sym_register] = ACTIONS(3250),
    [anon_sym_inline] = ACTIONS(3250),
    [anon_sym___inline] = ACTIONS(3250),
    [anon_sym___inline__] = ACTIONS(3250),
    [anon_sym___forceinline] = ACTIONS(3250),
    [anon_sym_thread_local] = ACTIONS(3250),
    [anon_sym___thread] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(3250),
    [anon_sym_constexpr] = ACTIONS(3250),
    [anon_sym_volatile] = ACTIONS(3250),
    [anon_sym_restrict] = ACTIONS(3250),
    [anon_sym___restrict__] = ACTIONS(3250),
    [anon_sym__Atomic] = ACTIONS(3250),
    [anon_sym__Noreturn] = ACTIONS(3250),
    [anon_sym_noreturn] = ACTIONS(3250),
    [anon_sym_mutable] = ACTIONS(3250),
    [anon_sym_constinit] = ACTIONS(3250),
    [anon_sym_consteval] = ACTIONS(3250),
    [anon_sym_PROGMEM] = ACTIONS(3250),
    [aux_sym_primitive_type_token1] = ACTIONS(3250),
    [anon_sym_byte] = ACTIONS(3250),
    [anon_sym_word] = ACTIONS(3250),
    [anon_sym_enum] = ACTIONS(3250),
    [anon_sym_class] = ACTIONS(3250),
    [anon_sym_struct] = ACTIONS(3250),
    [anon_sym_union] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_switch] = ACTIONS(3250),
    [anon_sym_case] = ACTIONS(3250),
    [anon_sym_default] = ACTIONS(3250),
    [anon_sym_while] = ACTIONS(3250),
    [anon_sym_do] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_goto] = ACTIONS(3250),
    [anon_sym_not] = ACTIONS(3250),
    [anon_sym_compl] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3252),
    [anon_sym_PLUS_PLUS] = ACTIONS(3252),
    [anon_sym_sizeof] = ACTIONS(3250),
    [anon_sym___alignof__] = ACTIONS(3250),
    [anon_sym___alignof] = ACTIONS(3250),
    [anon_sym__alignof] = ACTIONS(3250),
    [anon_sym_alignof] = ACTIONS(3250),
    [anon_sym__Alignof] = ACTIONS(3250),
    [anon_sym_offsetof] = ACTIONS(3250),
    [anon_sym__Generic] = ACTIONS(3250),
    [anon_sym_asm] = ACTIONS(3250),
    [anon_sym___asm__] = ACTIONS(3250),
    [aux_sym_number_literal_token1] = ACTIONS(3252),
    [aux_sym_number_literal_token2] = ACTIONS(3250),
    [anon_sym_L_SQUOTE] = ACTIONS(3252),
    [anon_sym_u_SQUOTE] = ACTIONS(3252),
    [anon_sym_U_SQUOTE] = ACTIONS(3252),
    [anon_sym_u8_SQUOTE] = ACTIONS(3252),
    [anon_sym_SQUOTE] = ACTIONS(3252),
    [anon_sym_L_DQUOTE] = ACTIONS(3252),
    [anon_sym_u_DQUOTE] = ACTIONS(3252),
    [anon_sym_U_DQUOTE] = ACTIONS(3252),
    [anon_sym_u8_DQUOTE] = ACTIONS(3252),
    [anon_sym_DQUOTE] = ACTIONS(3252),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [anon_sym_NULL] = ACTIONS(3250),
    [anon_sym_nullptr] = ACTIONS(3250),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3250),
    [anon_sym_decltype] = ACTIONS(3250),
    [anon_sym_virtual] = ACTIONS(3250),
    [anon_sym_alignas] = ACTIONS(3250),
    [anon_sym_explicit] = ACTIONS(3250),
    [anon_sym_typename] = ACTIONS(3250),
    [anon_sym_template] = ACTIONS(3250),
    [anon_sym_operator] = ACTIONS(3250),
    [anon_sym_try] = ACTIONS(3250),
    [anon_sym_delete] = ACTIONS(3250),
    [anon_sym_throw] = ACTIONS(3250),
    [anon_sym_namespace] = ACTIONS(3250),
    [anon_sym_using] = ACTIONS(3250),
    [anon_sym_static_assert] = ACTIONS(3250),
    [anon_sym_concept] = ACTIONS(3250),
    [anon_sym_co_return] = ACTIONS(3250),
    [anon_sym_co_yield] = ACTIONS(3250),
    [anon_sym_R_DQUOTE] = ACTIONS(3252),
    [anon_sym_LR_DQUOTE] = ACTIONS(3252),
    [anon_sym_uR_DQUOTE] = ACTIONS(3252),
    [anon_sym_UR_DQUOTE] = ACTIONS(3252),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3252),
    [anon_sym_co_await] = ACTIONS(3250),
    [anon_sym_new] = ACTIONS(3250),
    [anon_sym_requires] = ACTIONS(3250),
    [sym_this] = ACTIONS(3250),
  },
  [1029] = {
    [sym_preproc_def] = STATE(1020),
    [sym_preproc_function_def] = STATE(1020),
    [sym_preproc_call] = STATE(1020),
    [sym_preproc_if_in_field_declaration_list] = STATE(1020),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1020),
    [sym_type_definition] = STATE(1020),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1020),
    [sym_field_declaration] = STATE(1020),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1020),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1020),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1020),
    [sym_operator_cast_declaration] = STATE(1020),
    [sym_constructor_or_destructor_definition] = STATE(1020),
    [sym_constructor_or_destructor_declaration] = STATE(1020),
    [sym_friend_declaration] = STATE(1020),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1020),
    [sym_alias_declaration] = STATE(1020),
    [sym_static_assert_declaration] = STATE(1020),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1020),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3829),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3829),
    [sym_preproc_directive] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3833),
    [anon_sym_typedef] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3871),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_static_assert] = ACTIONS(3845),
  },
  [1030] = {
    [ts_builtin_sym_end] = ACTIONS(3188),
    [sym_identifier] = ACTIONS(3186),
    [aux_sym_preproc_include_token1] = ACTIONS(3186),
    [aux_sym_preproc_def_token1] = ACTIONS(3186),
    [aux_sym_preproc_if_token1] = ACTIONS(3186),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3186),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3186),
    [sym_preproc_directive] = ACTIONS(3186),
    [anon_sym_LPAREN2] = ACTIONS(3188),
    [anon_sym_BANG] = ACTIONS(3188),
    [anon_sym_TILDE] = ACTIONS(3188),
    [anon_sym_DASH] = ACTIONS(3186),
    [anon_sym_PLUS] = ACTIONS(3186),
    [anon_sym_STAR] = ACTIONS(3188),
    [anon_sym_AMP_AMP] = ACTIONS(3188),
    [anon_sym_AMP] = ACTIONS(3186),
    [anon_sym___extension__] = ACTIONS(3186),
    [anon_sym_typedef] = ACTIONS(3186),
    [anon_sym_extern] = ACTIONS(3186),
    [anon_sym___attribute__] = ACTIONS(3186),
    [anon_sym_COLON_COLON] = ACTIONS(3188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3188),
    [anon_sym___declspec] = ACTIONS(3186),
    [anon_sym___based] = ACTIONS(3186),
    [anon_sym___cdecl] = ACTIONS(3186),
    [anon_sym___clrcall] = ACTIONS(3186),
    [anon_sym___stdcall] = ACTIONS(3186),
    [anon_sym___fastcall] = ACTIONS(3186),
    [anon_sym___thiscall] = ACTIONS(3186),
    [anon_sym___vectorcall] = ACTIONS(3186),
    [anon_sym_LBRACE] = ACTIONS(3188),
    [anon_sym_signed] = ACTIONS(3186),
    [anon_sym_unsigned] = ACTIONS(3186),
    [anon_sym_long] = ACTIONS(3186),
    [anon_sym_short] = ACTIONS(3186),
    [anon_sym_LBRACK] = ACTIONS(3186),
    [anon_sym_static] = ACTIONS(3186),
    [anon_sym_register] = ACTIONS(3186),
    [anon_sym_inline] = ACTIONS(3186),
    [anon_sym___inline] = ACTIONS(3186),
    [anon_sym___inline__] = ACTIONS(3186),
    [anon_sym___forceinline] = ACTIONS(3186),
    [anon_sym_thread_local] = ACTIONS(3186),
    [anon_sym___thread] = ACTIONS(3186),
    [anon_sym_const] = ACTIONS(3186),
    [anon_sym_constexpr] = ACTIONS(3186),
    [anon_sym_volatile] = ACTIONS(3186),
    [anon_sym_restrict] = ACTIONS(3186),
    [anon_sym___restrict__] = ACTIONS(3186),
    [anon_sym__Atomic] = ACTIONS(3186),
    [anon_sym__Noreturn] = ACTIONS(3186),
    [anon_sym_noreturn] = ACTIONS(3186),
    [anon_sym_mutable] = ACTIONS(3186),
    [anon_sym_constinit] = ACTIONS(3186),
    [anon_sym_consteval] = ACTIONS(3186),
    [anon_sym_PROGMEM] = ACTIONS(3186),
    [aux_sym_primitive_type_token1] = ACTIONS(3186),
    [anon_sym_byte] = ACTIONS(3186),
    [anon_sym_word] = ACTIONS(3186),
    [anon_sym_enum] = ACTIONS(3186),
    [anon_sym_class] = ACTIONS(3186),
    [anon_sym_struct] = ACTIONS(3186),
    [anon_sym_union] = ACTIONS(3186),
    [anon_sym_if] = ACTIONS(3186),
    [anon_sym_switch] = ACTIONS(3186),
    [anon_sym_case] = ACTIONS(3186),
    [anon_sym_default] = ACTIONS(3186),
    [anon_sym_while] = ACTIONS(3186),
    [anon_sym_do] = ACTIONS(3186),
    [anon_sym_for] = ACTIONS(3186),
    [anon_sym_return] = ACTIONS(3186),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_continue] = ACTIONS(3186),
    [anon_sym_goto] = ACTIONS(3186),
    [anon_sym_not] = ACTIONS(3186),
    [anon_sym_compl] = ACTIONS(3186),
    [anon_sym_DASH_DASH] = ACTIONS(3188),
    [anon_sym_PLUS_PLUS] = ACTIONS(3188),
    [anon_sym_sizeof] = ACTIONS(3186),
    [anon_sym___alignof__] = ACTIONS(3186),
    [anon_sym___alignof] = ACTIONS(3186),
    [anon_sym__alignof] = ACTIONS(3186),
    [anon_sym_alignof] = ACTIONS(3186),
    [anon_sym__Alignof] = ACTIONS(3186),
    [anon_sym_offsetof] = ACTIONS(3186),
    [anon_sym__Generic] = ACTIONS(3186),
    [anon_sym_asm] = ACTIONS(3186),
    [anon_sym___asm__] = ACTIONS(3186),
    [aux_sym_number_literal_token1] = ACTIONS(3188),
    [aux_sym_number_literal_token2] = ACTIONS(3186),
    [anon_sym_L_SQUOTE] = ACTIONS(3188),
    [anon_sym_u_SQUOTE] = ACTIONS(3188),
    [anon_sym_U_SQUOTE] = ACTIONS(3188),
    [anon_sym_u8_SQUOTE] = ACTIONS(3188),
    [anon_sym_SQUOTE] = ACTIONS(3188),
    [anon_sym_L_DQUOTE] = ACTIONS(3188),
    [anon_sym_u_DQUOTE] = ACTIONS(3188),
    [anon_sym_U_DQUOTE] = ACTIONS(3188),
    [anon_sym_u8_DQUOTE] = ACTIONS(3188),
    [anon_sym_DQUOTE] = ACTIONS(3188),
    [sym_true] = ACTIONS(3186),
    [sym_false] = ACTIONS(3186),
    [anon_sym_NULL] = ACTIONS(3186),
    [anon_sym_nullptr] = ACTIONS(3186),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3186),
    [anon_sym_decltype] = ACTIONS(3186),
    [anon_sym_virtual] = ACTIONS(3186),
    [anon_sym_alignas] = ACTIONS(3186),
    [anon_sym_explicit] = ACTIONS(3186),
    [anon_sym_typename] = ACTIONS(3186),
    [anon_sym_template] = ACTIONS(3186),
    [anon_sym_operator] = ACTIONS(3186),
    [anon_sym_try] = ACTIONS(3186),
    [anon_sym_delete] = ACTIONS(3186),
    [anon_sym_throw] = ACTIONS(3186),
    [anon_sym_namespace] = ACTIONS(3186),
    [anon_sym_using] = ACTIONS(3186),
    [anon_sym_static_assert] = ACTIONS(3186),
    [anon_sym_concept] = ACTIONS(3186),
    [anon_sym_co_return] = ACTIONS(3186),
    [anon_sym_co_yield] = ACTIONS(3186),
    [anon_sym_R_DQUOTE] = ACTIONS(3188),
    [anon_sym_LR_DQUOTE] = ACTIONS(3188),
    [anon_sym_uR_DQUOTE] = ACTIONS(3188),
    [anon_sym_UR_DQUOTE] = ACTIONS(3188),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3188),
    [anon_sym_co_await] = ACTIONS(3186),
    [anon_sym_new] = ACTIONS(3186),
    [anon_sym_requires] = ACTIONS(3186),
    [sym_this] = ACTIONS(3186),
  },
  [1031] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4519),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_initializer_list] = STATE(4671),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2151),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_LPAREN2] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(3875),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(2151),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_PERCENT] = ACTIONS(2151),
    [anon_sym_PIPE_PIPE] = ACTIONS(2151),
    [anon_sym_AMP_AMP] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(2149),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2149),
    [anon_sym_EQ_EQ] = ACTIONS(2151),
    [anon_sym_BANG_EQ] = ACTIONS(2151),
    [anon_sym_GT] = ACTIONS(2149),
    [anon_sym_GT_EQ] = ACTIONS(2151),
    [anon_sym_LT_EQ] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_LT_LT] = ACTIONS(2151),
    [anon_sym_GT_GT] = ACTIONS(2151),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [anon_sym_RBRACK] = ACTIONS(2151),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_LT_EQ_GT] = ACTIONS(2151),
    [anon_sym_or] = ACTIONS(2149),
    [anon_sym_and] = ACTIONS(2149),
    [anon_sym_bitor] = ACTIONS(2149),
    [anon_sym_xor] = ACTIONS(2149),
    [anon_sym_bitand] = ACTIONS(2149),
    [anon_sym_not_eq] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(2149),
    [anon_sym_DOT_STAR] = ACTIONS(2151),
    [anon_sym_DASH_GT] = ACTIONS(2151),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1032] = {
    [ts_builtin_sym_end] = ACTIONS(3409),
    [sym_identifier] = ACTIONS(3407),
    [aux_sym_preproc_include_token1] = ACTIONS(3407),
    [aux_sym_preproc_def_token1] = ACTIONS(3407),
    [aux_sym_preproc_if_token1] = ACTIONS(3407),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3407),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3407),
    [sym_preproc_directive] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3409),
    [anon_sym_TILDE] = ACTIONS(3409),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_AMP_AMP] = ACTIONS(3409),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym___extension__] = ACTIONS(3407),
    [anon_sym_typedef] = ACTIONS(3407),
    [anon_sym_extern] = ACTIONS(3407),
    [anon_sym___attribute__] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3409),
    [anon_sym___declspec] = ACTIONS(3407),
    [anon_sym___based] = ACTIONS(3407),
    [anon_sym___cdecl] = ACTIONS(3407),
    [anon_sym___clrcall] = ACTIONS(3407),
    [anon_sym___stdcall] = ACTIONS(3407),
    [anon_sym___fastcall] = ACTIONS(3407),
    [anon_sym___thiscall] = ACTIONS(3407),
    [anon_sym___vectorcall] = ACTIONS(3407),
    [anon_sym_LBRACE] = ACTIONS(3409),
    [anon_sym_signed] = ACTIONS(3407),
    [anon_sym_unsigned] = ACTIONS(3407),
    [anon_sym_long] = ACTIONS(3407),
    [anon_sym_short] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_register] = ACTIONS(3407),
    [anon_sym_inline] = ACTIONS(3407),
    [anon_sym___inline] = ACTIONS(3407),
    [anon_sym___inline__] = ACTIONS(3407),
    [anon_sym___forceinline] = ACTIONS(3407),
    [anon_sym_thread_local] = ACTIONS(3407),
    [anon_sym___thread] = ACTIONS(3407),
    [anon_sym_const] = ACTIONS(3407),
    [anon_sym_constexpr] = ACTIONS(3407),
    [anon_sym_volatile] = ACTIONS(3407),
    [anon_sym_restrict] = ACTIONS(3407),
    [anon_sym___restrict__] = ACTIONS(3407),
    [anon_sym__Atomic] = ACTIONS(3407),
    [anon_sym__Noreturn] = ACTIONS(3407),
    [anon_sym_noreturn] = ACTIONS(3407),
    [anon_sym_mutable] = ACTIONS(3407),
    [anon_sym_constinit] = ACTIONS(3407),
    [anon_sym_consteval] = ACTIONS(3407),
    [anon_sym_PROGMEM] = ACTIONS(3407),
    [aux_sym_primitive_type_token1] = ACTIONS(3407),
    [anon_sym_byte] = ACTIONS(3407),
    [anon_sym_word] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3407),
    [anon_sym_class] = ACTIONS(3407),
    [anon_sym_struct] = ACTIONS(3407),
    [anon_sym_union] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_switch] = ACTIONS(3407),
    [anon_sym_case] = ACTIONS(3407),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_break] = ACTIONS(3407),
    [anon_sym_continue] = ACTIONS(3407),
    [anon_sym_goto] = ACTIONS(3407),
    [anon_sym_not] = ACTIONS(3407),
    [anon_sym_compl] = ACTIONS(3407),
    [anon_sym_DASH_DASH] = ACTIONS(3409),
    [anon_sym_PLUS_PLUS] = ACTIONS(3409),
    [anon_sym_sizeof] = ACTIONS(3407),
    [anon_sym___alignof__] = ACTIONS(3407),
    [anon_sym___alignof] = ACTIONS(3407),
    [anon_sym__alignof] = ACTIONS(3407),
    [anon_sym_alignof] = ACTIONS(3407),
    [anon_sym__Alignof] = ACTIONS(3407),
    [anon_sym_offsetof] = ACTIONS(3407),
    [anon_sym__Generic] = ACTIONS(3407),
    [anon_sym_asm] = ACTIONS(3407),
    [anon_sym___asm__] = ACTIONS(3407),
    [aux_sym_number_literal_token1] = ACTIONS(3409),
    [aux_sym_number_literal_token2] = ACTIONS(3407),
    [anon_sym_L_SQUOTE] = ACTIONS(3409),
    [anon_sym_u_SQUOTE] = ACTIONS(3409),
    [anon_sym_U_SQUOTE] = ACTIONS(3409),
    [anon_sym_u8_SQUOTE] = ACTIONS(3409),
    [anon_sym_SQUOTE] = ACTIONS(3409),
    [anon_sym_L_DQUOTE] = ACTIONS(3409),
    [anon_sym_u_DQUOTE] = ACTIONS(3409),
    [anon_sym_U_DQUOTE] = ACTIONS(3409),
    [anon_sym_u8_DQUOTE] = ACTIONS(3409),
    [anon_sym_DQUOTE] = ACTIONS(3409),
    [sym_true] = ACTIONS(3407),
    [sym_false] = ACTIONS(3407),
    [anon_sym_NULL] = ACTIONS(3407),
    [anon_sym_nullptr] = ACTIONS(3407),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3407),
    [anon_sym_decltype] = ACTIONS(3407),
    [anon_sym_virtual] = ACTIONS(3407),
    [anon_sym_alignas] = ACTIONS(3407),
    [anon_sym_explicit] = ACTIONS(3407),
    [anon_sym_typename] = ACTIONS(3407),
    [anon_sym_template] = ACTIONS(3407),
    [anon_sym_operator] = ACTIONS(3407),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_delete] = ACTIONS(3407),
    [anon_sym_throw] = ACTIONS(3407),
    [anon_sym_namespace] = ACTIONS(3407),
    [anon_sym_using] = ACTIONS(3407),
    [anon_sym_static_assert] = ACTIONS(3407),
    [anon_sym_concept] = ACTIONS(3407),
    [anon_sym_co_return] = ACTIONS(3407),
    [anon_sym_co_yield] = ACTIONS(3407),
    [anon_sym_R_DQUOTE] = ACTIONS(3409),
    [anon_sym_LR_DQUOTE] = ACTIONS(3409),
    [anon_sym_uR_DQUOTE] = ACTIONS(3409),
    [anon_sym_UR_DQUOTE] = ACTIONS(3409),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3409),
    [anon_sym_co_await] = ACTIONS(3407),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_requires] = ACTIONS(3407),
    [sym_this] = ACTIONS(3407),
  },
  [1033] = {
    [ts_builtin_sym_end] = ACTIONS(3417),
    [sym_identifier] = ACTIONS(3415),
    [aux_sym_preproc_include_token1] = ACTIONS(3415),
    [aux_sym_preproc_def_token1] = ACTIONS(3415),
    [aux_sym_preproc_if_token1] = ACTIONS(3415),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3415),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3415),
    [sym_preproc_directive] = ACTIONS(3415),
    [anon_sym_LPAREN2] = ACTIONS(3417),
    [anon_sym_BANG] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_STAR] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3415),
    [anon_sym___extension__] = ACTIONS(3415),
    [anon_sym_typedef] = ACTIONS(3415),
    [anon_sym_extern] = ACTIONS(3415),
    [anon_sym___attribute__] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3417),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3417),
    [anon_sym___declspec] = ACTIONS(3415),
    [anon_sym___based] = ACTIONS(3415),
    [anon_sym___cdecl] = ACTIONS(3415),
    [anon_sym___clrcall] = ACTIONS(3415),
    [anon_sym___stdcall] = ACTIONS(3415),
    [anon_sym___fastcall] = ACTIONS(3415),
    [anon_sym___thiscall] = ACTIONS(3415),
    [anon_sym___vectorcall] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_signed] = ACTIONS(3415),
    [anon_sym_unsigned] = ACTIONS(3415),
    [anon_sym_long] = ACTIONS(3415),
    [anon_sym_short] = ACTIONS(3415),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_static] = ACTIONS(3415),
    [anon_sym_register] = ACTIONS(3415),
    [anon_sym_inline] = ACTIONS(3415),
    [anon_sym___inline] = ACTIONS(3415),
    [anon_sym___inline__] = ACTIONS(3415),
    [anon_sym___forceinline] = ACTIONS(3415),
    [anon_sym_thread_local] = ACTIONS(3415),
    [anon_sym___thread] = ACTIONS(3415),
    [anon_sym_const] = ACTIONS(3415),
    [anon_sym_constexpr] = ACTIONS(3415),
    [anon_sym_volatile] = ACTIONS(3415),
    [anon_sym_restrict] = ACTIONS(3415),
    [anon_sym___restrict__] = ACTIONS(3415),
    [anon_sym__Atomic] = ACTIONS(3415),
    [anon_sym__Noreturn] = ACTIONS(3415),
    [anon_sym_noreturn] = ACTIONS(3415),
    [anon_sym_mutable] = ACTIONS(3415),
    [anon_sym_constinit] = ACTIONS(3415),
    [anon_sym_consteval] = ACTIONS(3415),
    [anon_sym_PROGMEM] = ACTIONS(3415),
    [aux_sym_primitive_type_token1] = ACTIONS(3415),
    [anon_sym_byte] = ACTIONS(3415),
    [anon_sym_word] = ACTIONS(3415),
    [anon_sym_enum] = ACTIONS(3415),
    [anon_sym_class] = ACTIONS(3415),
    [anon_sym_struct] = ACTIONS(3415),
    [anon_sym_union] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_switch] = ACTIONS(3415),
    [anon_sym_case] = ACTIONS(3415),
    [anon_sym_default] = ACTIONS(3415),
    [anon_sym_while] = ACTIONS(3415),
    [anon_sym_do] = ACTIONS(3415),
    [anon_sym_for] = ACTIONS(3415),
    [anon_sym_return] = ACTIONS(3415),
    [anon_sym_break] = ACTIONS(3415),
    [anon_sym_continue] = ACTIONS(3415),
    [anon_sym_goto] = ACTIONS(3415),
    [anon_sym_not] = ACTIONS(3415),
    [anon_sym_compl] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3415),
    [anon_sym___alignof__] = ACTIONS(3415),
    [anon_sym___alignof] = ACTIONS(3415),
    [anon_sym__alignof] = ACTIONS(3415),
    [anon_sym_alignof] = ACTIONS(3415),
    [anon_sym__Alignof] = ACTIONS(3415),
    [anon_sym_offsetof] = ACTIONS(3415),
    [anon_sym__Generic] = ACTIONS(3415),
    [anon_sym_asm] = ACTIONS(3415),
    [anon_sym___asm__] = ACTIONS(3415),
    [aux_sym_number_literal_token1] = ACTIONS(3417),
    [aux_sym_number_literal_token2] = ACTIONS(3415),
    [anon_sym_L_SQUOTE] = ACTIONS(3417),
    [anon_sym_u_SQUOTE] = ACTIONS(3417),
    [anon_sym_U_SQUOTE] = ACTIONS(3417),
    [anon_sym_u8_SQUOTE] = ACTIONS(3417),
    [anon_sym_SQUOTE] = ACTIONS(3417),
    [anon_sym_L_DQUOTE] = ACTIONS(3417),
    [anon_sym_u_DQUOTE] = ACTIONS(3417),
    [anon_sym_U_DQUOTE] = ACTIONS(3417),
    [anon_sym_u8_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [sym_true] = ACTIONS(3415),
    [sym_false] = ACTIONS(3415),
    [anon_sym_NULL] = ACTIONS(3415),
    [anon_sym_nullptr] = ACTIONS(3415),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3415),
    [anon_sym_decltype] = ACTIONS(3415),
    [anon_sym_virtual] = ACTIONS(3415),
    [anon_sym_alignas] = ACTIONS(3415),
    [anon_sym_explicit] = ACTIONS(3415),
    [anon_sym_typename] = ACTIONS(3415),
    [anon_sym_template] = ACTIONS(3415),
    [anon_sym_operator] = ACTIONS(3415),
    [anon_sym_try] = ACTIONS(3415),
    [anon_sym_delete] = ACTIONS(3415),
    [anon_sym_throw] = ACTIONS(3415),
    [anon_sym_namespace] = ACTIONS(3415),
    [anon_sym_using] = ACTIONS(3415),
    [anon_sym_static_assert] = ACTIONS(3415),
    [anon_sym_concept] = ACTIONS(3415),
    [anon_sym_co_return] = ACTIONS(3415),
    [anon_sym_co_yield] = ACTIONS(3415),
    [anon_sym_R_DQUOTE] = ACTIONS(3417),
    [anon_sym_LR_DQUOTE] = ACTIONS(3417),
    [anon_sym_uR_DQUOTE] = ACTIONS(3417),
    [anon_sym_UR_DQUOTE] = ACTIONS(3417),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3417),
    [anon_sym_co_await] = ACTIONS(3415),
    [anon_sym_new] = ACTIONS(3415),
    [anon_sym_requires] = ACTIONS(3415),
    [sym_this] = ACTIONS(3415),
  },
  [1034] = {
    [ts_builtin_sym_end] = ACTIONS(3184),
    [sym_identifier] = ACTIONS(3182),
    [aux_sym_preproc_include_token1] = ACTIONS(3182),
    [aux_sym_preproc_def_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [sym_preproc_directive] = ACTIONS(3182),
    [anon_sym_LPAREN2] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym___extension__] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3182),
    [anon_sym_extern] = ACTIONS(3182),
    [anon_sym___attribute__] = ACTIONS(3182),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3184),
    [anon_sym___declspec] = ACTIONS(3182),
    [anon_sym___based] = ACTIONS(3182),
    [anon_sym___cdecl] = ACTIONS(3182),
    [anon_sym___clrcall] = ACTIONS(3182),
    [anon_sym___stdcall] = ACTIONS(3182),
    [anon_sym___fastcall] = ACTIONS(3182),
    [anon_sym___thiscall] = ACTIONS(3182),
    [anon_sym___vectorcall] = ACTIONS(3182),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_signed] = ACTIONS(3182),
    [anon_sym_unsigned] = ACTIONS(3182),
    [anon_sym_long] = ACTIONS(3182),
    [anon_sym_short] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_register] = ACTIONS(3182),
    [anon_sym_inline] = ACTIONS(3182),
    [anon_sym___inline] = ACTIONS(3182),
    [anon_sym___inline__] = ACTIONS(3182),
    [anon_sym___forceinline] = ACTIONS(3182),
    [anon_sym_thread_local] = ACTIONS(3182),
    [anon_sym___thread] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_constexpr] = ACTIONS(3182),
    [anon_sym_volatile] = ACTIONS(3182),
    [anon_sym_restrict] = ACTIONS(3182),
    [anon_sym___restrict__] = ACTIONS(3182),
    [anon_sym__Atomic] = ACTIONS(3182),
    [anon_sym__Noreturn] = ACTIONS(3182),
    [anon_sym_noreturn] = ACTIONS(3182),
    [anon_sym_mutable] = ACTIONS(3182),
    [anon_sym_constinit] = ACTIONS(3182),
    [anon_sym_consteval] = ACTIONS(3182),
    [anon_sym_PROGMEM] = ACTIONS(3182),
    [aux_sym_primitive_type_token1] = ACTIONS(3182),
    [anon_sym_byte] = ACTIONS(3182),
    [anon_sym_word] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_struct] = ACTIONS(3182),
    [anon_sym_union] = ACTIONS(3182),
    [anon_sym_if] = ACTIONS(3182),
    [anon_sym_switch] = ACTIONS(3182),
    [anon_sym_case] = ACTIONS(3182),
    [anon_sym_default] = ACTIONS(3182),
    [anon_sym_while] = ACTIONS(3182),
    [anon_sym_do] = ACTIONS(3182),
    [anon_sym_for] = ACTIONS(3182),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_break] = ACTIONS(3182),
    [anon_sym_continue] = ACTIONS(3182),
    [anon_sym_goto] = ACTIONS(3182),
    [anon_sym_not] = ACTIONS(3182),
    [anon_sym_compl] = ACTIONS(3182),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_sizeof] = ACTIONS(3182),
    [anon_sym___alignof__] = ACTIONS(3182),
    [anon_sym___alignof] = ACTIONS(3182),
    [anon_sym__alignof] = ACTIONS(3182),
    [anon_sym_alignof] = ACTIONS(3182),
    [anon_sym__Alignof] = ACTIONS(3182),
    [anon_sym_offsetof] = ACTIONS(3182),
    [anon_sym__Generic] = ACTIONS(3182),
    [anon_sym_asm] = ACTIONS(3182),
    [anon_sym___asm__] = ACTIONS(3182),
    [aux_sym_number_literal_token1] = ACTIONS(3184),
    [aux_sym_number_literal_token2] = ACTIONS(3182),
    [anon_sym_L_SQUOTE] = ACTIONS(3184),
    [anon_sym_u_SQUOTE] = ACTIONS(3184),
    [anon_sym_U_SQUOTE] = ACTIONS(3184),
    [anon_sym_u8_SQUOTE] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3184),
    [anon_sym_L_DQUOTE] = ACTIONS(3184),
    [anon_sym_u_DQUOTE] = ACTIONS(3184),
    [anon_sym_U_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8_DQUOTE] = ACTIONS(3184),
    [anon_sym_DQUOTE] = ACTIONS(3184),
    [sym_true] = ACTIONS(3182),
    [sym_false] = ACTIONS(3182),
    [anon_sym_NULL] = ACTIONS(3182),
    [anon_sym_nullptr] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3182),
    [anon_sym_decltype] = ACTIONS(3182),
    [anon_sym_virtual] = ACTIONS(3182),
    [anon_sym_alignas] = ACTIONS(3182),
    [anon_sym_explicit] = ACTIONS(3182),
    [anon_sym_typename] = ACTIONS(3182),
    [anon_sym_template] = ACTIONS(3182),
    [anon_sym_operator] = ACTIONS(3182),
    [anon_sym_try] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3182),
    [anon_sym_throw] = ACTIONS(3182),
    [anon_sym_namespace] = ACTIONS(3182),
    [anon_sym_using] = ACTIONS(3182),
    [anon_sym_static_assert] = ACTIONS(3182),
    [anon_sym_concept] = ACTIONS(3182),
    [anon_sym_co_return] = ACTIONS(3182),
    [anon_sym_co_yield] = ACTIONS(3182),
    [anon_sym_R_DQUOTE] = ACTIONS(3184),
    [anon_sym_LR_DQUOTE] = ACTIONS(3184),
    [anon_sym_uR_DQUOTE] = ACTIONS(3184),
    [anon_sym_UR_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3184),
    [anon_sym_co_await] = ACTIONS(3182),
    [anon_sym_new] = ACTIONS(3182),
    [anon_sym_requires] = ACTIONS(3182),
    [sym_this] = ACTIONS(3182),
  },
  [1035] = {
    [ts_builtin_sym_end] = ACTIONS(3355),
    [sym_identifier] = ACTIONS(3353),
    [aux_sym_preproc_include_token1] = ACTIONS(3353),
    [aux_sym_preproc_def_token1] = ACTIONS(3353),
    [aux_sym_preproc_if_token1] = ACTIONS(3353),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3353),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3353),
    [sym_preproc_directive] = ACTIONS(3353),
    [anon_sym_LPAREN2] = ACTIONS(3355),
    [anon_sym_BANG] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_AMP_AMP] = ACTIONS(3355),
    [anon_sym_AMP] = ACTIONS(3353),
    [anon_sym___extension__] = ACTIONS(3353),
    [anon_sym_typedef] = ACTIONS(3353),
    [anon_sym_extern] = ACTIONS(3353),
    [anon_sym___attribute__] = ACTIONS(3353),
    [anon_sym_COLON_COLON] = ACTIONS(3355),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3355),
    [anon_sym___declspec] = ACTIONS(3353),
    [anon_sym___based] = ACTIONS(3353),
    [anon_sym___cdecl] = ACTIONS(3353),
    [anon_sym___clrcall] = ACTIONS(3353),
    [anon_sym___stdcall] = ACTIONS(3353),
    [anon_sym___fastcall] = ACTIONS(3353),
    [anon_sym___thiscall] = ACTIONS(3353),
    [anon_sym___vectorcall] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_signed] = ACTIONS(3353),
    [anon_sym_unsigned] = ACTIONS(3353),
    [anon_sym_long] = ACTIONS(3353),
    [anon_sym_short] = ACTIONS(3353),
    [anon_sym_LBRACK] = ACTIONS(3353),
    [anon_sym_static] = ACTIONS(3353),
    [anon_sym_register] = ACTIONS(3353),
    [anon_sym_inline] = ACTIONS(3353),
    [anon_sym___inline] = ACTIONS(3353),
    [anon_sym___inline__] = ACTIONS(3353),
    [anon_sym___forceinline] = ACTIONS(3353),
    [anon_sym_thread_local] = ACTIONS(3353),
    [anon_sym___thread] = ACTIONS(3353),
    [anon_sym_const] = ACTIONS(3353),
    [anon_sym_constexpr] = ACTIONS(3353),
    [anon_sym_volatile] = ACTIONS(3353),
    [anon_sym_restrict] = ACTIONS(3353),
    [anon_sym___restrict__] = ACTIONS(3353),
    [anon_sym__Atomic] = ACTIONS(3353),
    [anon_sym__Noreturn] = ACTIONS(3353),
    [anon_sym_noreturn] = ACTIONS(3353),
    [anon_sym_mutable] = ACTIONS(3353),
    [anon_sym_constinit] = ACTIONS(3353),
    [anon_sym_consteval] = ACTIONS(3353),
    [anon_sym_PROGMEM] = ACTIONS(3353),
    [aux_sym_primitive_type_token1] = ACTIONS(3353),
    [anon_sym_byte] = ACTIONS(3353),
    [anon_sym_word] = ACTIONS(3353),
    [anon_sym_enum] = ACTIONS(3353),
    [anon_sym_class] = ACTIONS(3353),
    [anon_sym_struct] = ACTIONS(3353),
    [anon_sym_union] = ACTIONS(3353),
    [anon_sym_if] = ACTIONS(3353),
    [anon_sym_switch] = ACTIONS(3353),
    [anon_sym_case] = ACTIONS(3353),
    [anon_sym_default] = ACTIONS(3353),
    [anon_sym_while] = ACTIONS(3353),
    [anon_sym_do] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3353),
    [anon_sym_return] = ACTIONS(3353),
    [anon_sym_break] = ACTIONS(3353),
    [anon_sym_continue] = ACTIONS(3353),
    [anon_sym_goto] = ACTIONS(3353),
    [anon_sym_not] = ACTIONS(3353),
    [anon_sym_compl] = ACTIONS(3353),
    [anon_sym_DASH_DASH] = ACTIONS(3355),
    [anon_sym_PLUS_PLUS] = ACTIONS(3355),
    [anon_sym_sizeof] = ACTIONS(3353),
    [anon_sym___alignof__] = ACTIONS(3353),
    [anon_sym___alignof] = ACTIONS(3353),
    [anon_sym__alignof] = ACTIONS(3353),
    [anon_sym_alignof] = ACTIONS(3353),
    [anon_sym__Alignof] = ACTIONS(3353),
    [anon_sym_offsetof] = ACTIONS(3353),
    [anon_sym__Generic] = ACTIONS(3353),
    [anon_sym_asm] = ACTIONS(3353),
    [anon_sym___asm__] = ACTIONS(3353),
    [aux_sym_number_literal_token1] = ACTIONS(3355),
    [aux_sym_number_literal_token2] = ACTIONS(3353),
    [anon_sym_L_SQUOTE] = ACTIONS(3355),
    [anon_sym_u_SQUOTE] = ACTIONS(3355),
    [anon_sym_U_SQUOTE] = ACTIONS(3355),
    [anon_sym_u8_SQUOTE] = ACTIONS(3355),
    [anon_sym_SQUOTE] = ACTIONS(3355),
    [anon_sym_L_DQUOTE] = ACTIONS(3355),
    [anon_sym_u_DQUOTE] = ACTIONS(3355),
    [anon_sym_U_DQUOTE] = ACTIONS(3355),
    [anon_sym_u8_DQUOTE] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [sym_true] = ACTIONS(3353),
    [sym_false] = ACTIONS(3353),
    [anon_sym_NULL] = ACTIONS(3353),
    [anon_sym_nullptr] = ACTIONS(3353),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3353),
    [anon_sym_decltype] = ACTIONS(3353),
    [anon_sym_virtual] = ACTIONS(3353),
    [anon_sym_alignas] = ACTIONS(3353),
    [anon_sym_explicit] = ACTIONS(3353),
    [anon_sym_typename] = ACTIONS(3353),
    [anon_sym_template] = ACTIONS(3353),
    [anon_sym_operator] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3353),
    [anon_sym_delete] = ACTIONS(3353),
    [anon_sym_throw] = ACTIONS(3353),
    [anon_sym_namespace] = ACTIONS(3353),
    [anon_sym_using] = ACTIONS(3353),
    [anon_sym_static_assert] = ACTIONS(3353),
    [anon_sym_concept] = ACTIONS(3353),
    [anon_sym_co_return] = ACTIONS(3353),
    [anon_sym_co_yield] = ACTIONS(3353),
    [anon_sym_R_DQUOTE] = ACTIONS(3355),
    [anon_sym_LR_DQUOTE] = ACTIONS(3355),
    [anon_sym_uR_DQUOTE] = ACTIONS(3355),
    [anon_sym_UR_DQUOTE] = ACTIONS(3355),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3355),
    [anon_sym_co_await] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3353),
    [anon_sym_requires] = ACTIONS(3353),
    [sym_this] = ACTIONS(3353),
  },
  [1036] = {
    [sym_preproc_def] = STATE(1051),
    [sym_preproc_function_def] = STATE(1051),
    [sym_preproc_call] = STATE(1051),
    [sym_preproc_if_in_field_declaration_list] = STATE(1051),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1051),
    [sym_type_definition] = STATE(1051),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1051),
    [sym_field_declaration] = STATE(1051),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1051),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1051),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1051),
    [sym_operator_cast_declaration] = STATE(1051),
    [sym_constructor_or_destructor_definition] = STATE(1051),
    [sym_constructor_or_destructor_declaration] = STATE(1051),
    [sym_friend_declaration] = STATE(1051),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1051),
    [sym_alias_declaration] = STATE(1051),
    [sym_static_assert_declaration] = STATE(1051),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1051),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3829),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3829),
    [sym_preproc_directive] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3833),
    [anon_sym_typedef] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3889),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_static_assert] = ACTIONS(3845),
  },
  [1037] = {
    [sym_preproc_def] = STATE(1037),
    [sym_preproc_function_def] = STATE(1037),
    [sym_preproc_call] = STATE(1037),
    [sym_preproc_if_in_field_declaration_list] = STATE(1037),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1037),
    [sym_type_definition] = STATE(1037),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6440),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7010),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1037),
    [sym_field_declaration] = STATE(1037),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2144),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1037),
    [sym_operator_cast] = STATE(7526),
    [sym_inline_method_definition] = STATE(1037),
    [sym__constructor_specifiers] = STATE(2144),
    [sym_operator_cast_definition] = STATE(1037),
    [sym_operator_cast_declaration] = STATE(1037),
    [sym_constructor_or_destructor_definition] = STATE(1037),
    [sym_constructor_or_destructor_declaration] = STATE(1037),
    [sym_friend_declaration] = STATE(1037),
    [sym_access_specifier] = STATE(9703),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1037),
    [sym_alias_declaration] = STATE(1037),
    [sym_static_assert_declaration] = STATE(1037),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7526),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1037),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2144),
    [sym_identifier] = ACTIONS(3605),
    [aux_sym_preproc_def_token1] = ACTIONS(3891),
    [aux_sym_preproc_if_token1] = ACTIONS(3894),
    [aux_sym_preproc_if_token2] = ACTIONS(3614),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3897),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3897),
    [sym_preproc_directive] = ACTIONS(3900),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_TILDE] = ACTIONS(3625),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_AMP_AMP] = ACTIONS(3631),
    [anon_sym_AMP] = ACTIONS(3634),
    [anon_sym___extension__] = ACTIONS(3903),
    [anon_sym_typedef] = ACTIONS(3906),
    [anon_sym_extern] = ACTIONS(3643),
    [anon_sym___attribute__] = ACTIONS(3646),
    [anon_sym_COLON_COLON] = ACTIONS(3649),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3652),
    [anon_sym___declspec] = ACTIONS(3655),
    [anon_sym___based] = ACTIONS(3658),
    [anon_sym_signed] = ACTIONS(3661),
    [anon_sym_unsigned] = ACTIONS(3661),
    [anon_sym_long] = ACTIONS(3661),
    [anon_sym_short] = ACTIONS(3661),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_static] = ACTIONS(3643),
    [anon_sym_register] = ACTIONS(3643),
    [anon_sym_inline] = ACTIONS(3643),
    [anon_sym___inline] = ACTIONS(3643),
    [anon_sym___inline__] = ACTIONS(3643),
    [anon_sym___forceinline] = ACTIONS(3643),
    [anon_sym_thread_local] = ACTIONS(3643),
    [anon_sym___thread] = ACTIONS(3643),
    [anon_sym_const] = ACTIONS(3667),
    [anon_sym_constexpr] = ACTIONS(3667),
    [anon_sym_volatile] = ACTIONS(3667),
    [anon_sym_restrict] = ACTIONS(3667),
    [anon_sym___restrict__] = ACTIONS(3667),
    [anon_sym__Atomic] = ACTIONS(3667),
    [anon_sym__Noreturn] = ACTIONS(3667),
    [anon_sym_noreturn] = ACTIONS(3667),
    [anon_sym_mutable] = ACTIONS(3667),
    [anon_sym_constinit] = ACTIONS(3667),
    [anon_sym_consteval] = ACTIONS(3667),
    [anon_sym_PROGMEM] = ACTIONS(3667),
    [aux_sym_primitive_type_token1] = ACTIONS(3670),
    [anon_sym_byte] = ACTIONS(3670),
    [anon_sym_word] = ACTIONS(3670),
    [anon_sym_enum] = ACTIONS(3673),
    [anon_sym_class] = ACTIONS(3676),
    [anon_sym_struct] = ACTIONS(3679),
    [anon_sym_union] = ACTIONS(3682),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3685),
    [anon_sym_decltype] = ACTIONS(3688),
    [anon_sym_virtual] = ACTIONS(3691),
    [anon_sym_alignas] = ACTIONS(3694),
    [anon_sym_explicit] = ACTIONS(3697),
    [anon_sym_typename] = ACTIONS(3700),
    [anon_sym_template] = ACTIONS(3909),
    [anon_sym_operator] = ACTIONS(3706),
    [anon_sym_friend] = ACTIONS(3912),
    [anon_sym_public] = ACTIONS(3712),
    [anon_sym_private] = ACTIONS(3712),
    [anon_sym_protected] = ACTIONS(3712),
    [anon_sym_using] = ACTIONS(3915),
    [anon_sym_static_assert] = ACTIONS(3918),
  },
  [1038] = {
    [ts_builtin_sym_end] = ACTIONS(3523),
    [sym_identifier] = ACTIONS(3521),
    [aux_sym_preproc_include_token1] = ACTIONS(3521),
    [aux_sym_preproc_def_token1] = ACTIONS(3521),
    [aux_sym_preproc_if_token1] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3521),
    [sym_preproc_directive] = ACTIONS(3521),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_BANG] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3521),
    [anon_sym_PLUS] = ACTIONS(3521),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3521),
    [anon_sym___extension__] = ACTIONS(3521),
    [anon_sym_typedef] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym___attribute__] = ACTIONS(3521),
    [anon_sym_COLON_COLON] = ACTIONS(3523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3523),
    [anon_sym___declspec] = ACTIONS(3521),
    [anon_sym___based] = ACTIONS(3521),
    [anon_sym___cdecl] = ACTIONS(3521),
    [anon_sym___clrcall] = ACTIONS(3521),
    [anon_sym___stdcall] = ACTIONS(3521),
    [anon_sym___fastcall] = ACTIONS(3521),
    [anon_sym___thiscall] = ACTIONS(3521),
    [anon_sym___vectorcall] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_signed] = ACTIONS(3521),
    [anon_sym_unsigned] = ACTIONS(3521),
    [anon_sym_long] = ACTIONS(3521),
    [anon_sym_short] = ACTIONS(3521),
    [anon_sym_LBRACK] = ACTIONS(3521),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_register] = ACTIONS(3521),
    [anon_sym_inline] = ACTIONS(3521),
    [anon_sym___inline] = ACTIONS(3521),
    [anon_sym___inline__] = ACTIONS(3521),
    [anon_sym___forceinline] = ACTIONS(3521),
    [anon_sym_thread_local] = ACTIONS(3521),
    [anon_sym___thread] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_constexpr] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym_restrict] = ACTIONS(3521),
    [anon_sym___restrict__] = ACTIONS(3521),
    [anon_sym__Atomic] = ACTIONS(3521),
    [anon_sym__Noreturn] = ACTIONS(3521),
    [anon_sym_noreturn] = ACTIONS(3521),
    [anon_sym_mutable] = ACTIONS(3521),
    [anon_sym_constinit] = ACTIONS(3521),
    [anon_sym_consteval] = ACTIONS(3521),
    [anon_sym_PROGMEM] = ACTIONS(3521),
    [aux_sym_primitive_type_token1] = ACTIONS(3521),
    [anon_sym_byte] = ACTIONS(3521),
    [anon_sym_word] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_class] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_union] = ACTIONS(3521),
    [anon_sym_if] = ACTIONS(3521),
    [anon_sym_switch] = ACTIONS(3521),
    [anon_sym_case] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3521),
    [anon_sym_while] = ACTIONS(3521),
    [anon_sym_do] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3521),
    [anon_sym_return] = ACTIONS(3521),
    [anon_sym_break] = ACTIONS(3521),
    [anon_sym_continue] = ACTIONS(3521),
    [anon_sym_goto] = ACTIONS(3521),
    [anon_sym_not] = ACTIONS(3521),
    [anon_sym_compl] = ACTIONS(3521),
    [anon_sym_DASH_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_PLUS] = ACTIONS(3523),
    [anon_sym_sizeof] = ACTIONS(3521),
    [anon_sym___alignof__] = ACTIONS(3521),
    [anon_sym___alignof] = ACTIONS(3521),
    [anon_sym__alignof] = ACTIONS(3521),
    [anon_sym_alignof] = ACTIONS(3521),
    [anon_sym__Alignof] = ACTIONS(3521),
    [anon_sym_offsetof] = ACTIONS(3521),
    [anon_sym__Generic] = ACTIONS(3521),
    [anon_sym_asm] = ACTIONS(3521),
    [anon_sym___asm__] = ACTIONS(3521),
    [aux_sym_number_literal_token1] = ACTIONS(3523),
    [aux_sym_number_literal_token2] = ACTIONS(3521),
    [anon_sym_L_SQUOTE] = ACTIONS(3523),
    [anon_sym_u_SQUOTE] = ACTIONS(3523),
    [anon_sym_U_SQUOTE] = ACTIONS(3523),
    [anon_sym_u8_SQUOTE] = ACTIONS(3523),
    [anon_sym_SQUOTE] = ACTIONS(3523),
    [anon_sym_L_DQUOTE] = ACTIONS(3523),
    [anon_sym_u_DQUOTE] = ACTIONS(3523),
    [anon_sym_U_DQUOTE] = ACTIONS(3523),
    [anon_sym_u8_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [sym_true] = ACTIONS(3521),
    [sym_false] = ACTIONS(3521),
    [anon_sym_NULL] = ACTIONS(3521),
    [anon_sym_nullptr] = ACTIONS(3521),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3521),
    [anon_sym_decltype] = ACTIONS(3521),
    [anon_sym_virtual] = ACTIONS(3521),
    [anon_sym_alignas] = ACTIONS(3521),
    [anon_sym_explicit] = ACTIONS(3521),
    [anon_sym_typename] = ACTIONS(3521),
    [anon_sym_template] = ACTIONS(3521),
    [anon_sym_operator] = ACTIONS(3521),
    [anon_sym_try] = ACTIONS(3521),
    [anon_sym_delete] = ACTIONS(3521),
    [anon_sym_throw] = ACTIONS(3521),
    [anon_sym_namespace] = ACTIONS(3521),
    [anon_sym_using] = ACTIONS(3521),
    [anon_sym_static_assert] = ACTIONS(3521),
    [anon_sym_concept] = ACTIONS(3521),
    [anon_sym_co_return] = ACTIONS(3521),
    [anon_sym_co_yield] = ACTIONS(3521),
    [anon_sym_R_DQUOTE] = ACTIONS(3523),
    [anon_sym_LR_DQUOTE] = ACTIONS(3523),
    [anon_sym_uR_DQUOTE] = ACTIONS(3523),
    [anon_sym_UR_DQUOTE] = ACTIONS(3523),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3523),
    [anon_sym_co_await] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3521),
    [anon_sym_requires] = ACTIONS(3521),
    [sym_this] = ACTIONS(3521),
  },
  [1039] = {
    [ts_builtin_sym_end] = ACTIONS(3437),
    [sym_identifier] = ACTIONS(3435),
    [aux_sym_preproc_include_token1] = ACTIONS(3435),
    [aux_sym_preproc_def_token1] = ACTIONS(3435),
    [aux_sym_preproc_if_token1] = ACTIONS(3435),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3435),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3435),
    [sym_preproc_directive] = ACTIONS(3435),
    [anon_sym_LPAREN2] = ACTIONS(3437),
    [anon_sym_BANG] = ACTIONS(3437),
    [anon_sym_TILDE] = ACTIONS(3437),
    [anon_sym_DASH] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3435),
    [anon_sym_STAR] = ACTIONS(3437),
    [anon_sym_AMP_AMP] = ACTIONS(3437),
    [anon_sym_AMP] = ACTIONS(3435),
    [anon_sym___extension__] = ACTIONS(3435),
    [anon_sym_typedef] = ACTIONS(3435),
    [anon_sym_extern] = ACTIONS(3435),
    [anon_sym___attribute__] = ACTIONS(3435),
    [anon_sym_COLON_COLON] = ACTIONS(3437),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3437),
    [anon_sym___declspec] = ACTIONS(3435),
    [anon_sym___based] = ACTIONS(3435),
    [anon_sym___cdecl] = ACTIONS(3435),
    [anon_sym___clrcall] = ACTIONS(3435),
    [anon_sym___stdcall] = ACTIONS(3435),
    [anon_sym___fastcall] = ACTIONS(3435),
    [anon_sym___thiscall] = ACTIONS(3435),
    [anon_sym___vectorcall] = ACTIONS(3435),
    [anon_sym_LBRACE] = ACTIONS(3437),
    [anon_sym_signed] = ACTIONS(3435),
    [anon_sym_unsigned] = ACTIONS(3435),
    [anon_sym_long] = ACTIONS(3435),
    [anon_sym_short] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3435),
    [anon_sym_static] = ACTIONS(3435),
    [anon_sym_register] = ACTIONS(3435),
    [anon_sym_inline] = ACTIONS(3435),
    [anon_sym___inline] = ACTIONS(3435),
    [anon_sym___inline__] = ACTIONS(3435),
    [anon_sym___forceinline] = ACTIONS(3435),
    [anon_sym_thread_local] = ACTIONS(3435),
    [anon_sym___thread] = ACTIONS(3435),
    [anon_sym_const] = ACTIONS(3435),
    [anon_sym_constexpr] = ACTIONS(3435),
    [anon_sym_volatile] = ACTIONS(3435),
    [anon_sym_restrict] = ACTIONS(3435),
    [anon_sym___restrict__] = ACTIONS(3435),
    [anon_sym__Atomic] = ACTIONS(3435),
    [anon_sym__Noreturn] = ACTIONS(3435),
    [anon_sym_noreturn] = ACTIONS(3435),
    [anon_sym_mutable] = ACTIONS(3435),
    [anon_sym_constinit] = ACTIONS(3435),
    [anon_sym_consteval] = ACTIONS(3435),
    [anon_sym_PROGMEM] = ACTIONS(3435),
    [aux_sym_primitive_type_token1] = ACTIONS(3435),
    [anon_sym_byte] = ACTIONS(3435),
    [anon_sym_word] = ACTIONS(3435),
    [anon_sym_enum] = ACTIONS(3435),
    [anon_sym_class] = ACTIONS(3435),
    [anon_sym_struct] = ACTIONS(3435),
    [anon_sym_union] = ACTIONS(3435),
    [anon_sym_if] = ACTIONS(3435),
    [anon_sym_switch] = ACTIONS(3435),
    [anon_sym_case] = ACTIONS(3435),
    [anon_sym_default] = ACTIONS(3435),
    [anon_sym_while] = ACTIONS(3435),
    [anon_sym_do] = ACTIONS(3435),
    [anon_sym_for] = ACTIONS(3435),
    [anon_sym_return] = ACTIONS(3435),
    [anon_sym_break] = ACTIONS(3435),
    [anon_sym_continue] = ACTIONS(3435),
    [anon_sym_goto] = ACTIONS(3435),
    [anon_sym_not] = ACTIONS(3435),
    [anon_sym_compl] = ACTIONS(3435),
    [anon_sym_DASH_DASH] = ACTIONS(3437),
    [anon_sym_PLUS_PLUS] = ACTIONS(3437),
    [anon_sym_sizeof] = ACTIONS(3435),
    [anon_sym___alignof__] = ACTIONS(3435),
    [anon_sym___alignof] = ACTIONS(3435),
    [anon_sym__alignof] = ACTIONS(3435),
    [anon_sym_alignof] = ACTIONS(3435),
    [anon_sym__Alignof] = ACTIONS(3435),
    [anon_sym_offsetof] = ACTIONS(3435),
    [anon_sym__Generic] = ACTIONS(3435),
    [anon_sym_asm] = ACTIONS(3435),
    [anon_sym___asm__] = ACTIONS(3435),
    [aux_sym_number_literal_token1] = ACTIONS(3437),
    [aux_sym_number_literal_token2] = ACTIONS(3435),
    [anon_sym_L_SQUOTE] = ACTIONS(3437),
    [anon_sym_u_SQUOTE] = ACTIONS(3437),
    [anon_sym_U_SQUOTE] = ACTIONS(3437),
    [anon_sym_u8_SQUOTE] = ACTIONS(3437),
    [anon_sym_SQUOTE] = ACTIONS(3437),
    [anon_sym_L_DQUOTE] = ACTIONS(3437),
    [anon_sym_u_DQUOTE] = ACTIONS(3437),
    [anon_sym_U_DQUOTE] = ACTIONS(3437),
    [anon_sym_u8_DQUOTE] = ACTIONS(3437),
    [anon_sym_DQUOTE] = ACTIONS(3437),
    [sym_true] = ACTIONS(3435),
    [sym_false] = ACTIONS(3435),
    [anon_sym_NULL] = ACTIONS(3435),
    [anon_sym_nullptr] = ACTIONS(3435),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3435),
    [anon_sym_decltype] = ACTIONS(3435),
    [anon_sym_virtual] = ACTIONS(3435),
    [anon_sym_alignas] = ACTIONS(3435),
    [anon_sym_explicit] = ACTIONS(3435),
    [anon_sym_typename] = ACTIONS(3435),
    [anon_sym_template] = ACTIONS(3435),
    [anon_sym_operator] = ACTIONS(3435),
    [anon_sym_try] = ACTIONS(3435),
    [anon_sym_delete] = ACTIONS(3435),
    [anon_sym_throw] = ACTIONS(3435),
    [anon_sym_namespace] = ACTIONS(3435),
    [anon_sym_using] = ACTIONS(3435),
    [anon_sym_static_assert] = ACTIONS(3435),
    [anon_sym_concept] = ACTIONS(3435),
    [anon_sym_co_return] = ACTIONS(3435),
    [anon_sym_co_yield] = ACTIONS(3435),
    [anon_sym_R_DQUOTE] = ACTIONS(3437),
    [anon_sym_LR_DQUOTE] = ACTIONS(3437),
    [anon_sym_uR_DQUOTE] = ACTIONS(3437),
    [anon_sym_UR_DQUOTE] = ACTIONS(3437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3437),
    [anon_sym_co_await] = ACTIONS(3435),
    [anon_sym_new] = ACTIONS(3435),
    [anon_sym_requires] = ACTIONS(3435),
    [sym_this] = ACTIONS(3435),
  },
  [1040] = {
    [ts_builtin_sym_end] = ACTIONS(3385),
    [sym_identifier] = ACTIONS(3383),
    [aux_sym_preproc_include_token1] = ACTIONS(3383),
    [aux_sym_preproc_def_token1] = ACTIONS(3383),
    [aux_sym_preproc_if_token1] = ACTIONS(3383),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3383),
    [sym_preproc_directive] = ACTIONS(3383),
    [anon_sym_LPAREN2] = ACTIONS(3385),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_TILDE] = ACTIONS(3385),
    [anon_sym_DASH] = ACTIONS(3383),
    [anon_sym_PLUS] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(3385),
    [anon_sym_AMP_AMP] = ACTIONS(3385),
    [anon_sym_AMP] = ACTIONS(3383),
    [anon_sym___extension__] = ACTIONS(3383),
    [anon_sym_typedef] = ACTIONS(3383),
    [anon_sym_extern] = ACTIONS(3383),
    [anon_sym___attribute__] = ACTIONS(3383),
    [anon_sym_COLON_COLON] = ACTIONS(3385),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3385),
    [anon_sym___declspec] = ACTIONS(3383),
    [anon_sym___based] = ACTIONS(3383),
    [anon_sym___cdecl] = ACTIONS(3383),
    [anon_sym___clrcall] = ACTIONS(3383),
    [anon_sym___stdcall] = ACTIONS(3383),
    [anon_sym___fastcall] = ACTIONS(3383),
    [anon_sym___thiscall] = ACTIONS(3383),
    [anon_sym___vectorcall] = ACTIONS(3383),
    [anon_sym_LBRACE] = ACTIONS(3385),
    [anon_sym_signed] = ACTIONS(3383),
    [anon_sym_unsigned] = ACTIONS(3383),
    [anon_sym_long] = ACTIONS(3383),
    [anon_sym_short] = ACTIONS(3383),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_static] = ACTIONS(3383),
    [anon_sym_register] = ACTIONS(3383),
    [anon_sym_inline] = ACTIONS(3383),
    [anon_sym___inline] = ACTIONS(3383),
    [anon_sym___inline__] = ACTIONS(3383),
    [anon_sym___forceinline] = ACTIONS(3383),
    [anon_sym_thread_local] = ACTIONS(3383),
    [anon_sym___thread] = ACTIONS(3383),
    [anon_sym_const] = ACTIONS(3383),
    [anon_sym_constexpr] = ACTIONS(3383),
    [anon_sym_volatile] = ACTIONS(3383),
    [anon_sym_restrict] = ACTIONS(3383),
    [anon_sym___restrict__] = ACTIONS(3383),
    [anon_sym__Atomic] = ACTIONS(3383),
    [anon_sym__Noreturn] = ACTIONS(3383),
    [anon_sym_noreturn] = ACTIONS(3383),
    [anon_sym_mutable] = ACTIONS(3383),
    [anon_sym_constinit] = ACTIONS(3383),
    [anon_sym_consteval] = ACTIONS(3383),
    [anon_sym_PROGMEM] = ACTIONS(3383),
    [aux_sym_primitive_type_token1] = ACTIONS(3383),
    [anon_sym_byte] = ACTIONS(3383),
    [anon_sym_word] = ACTIONS(3383),
    [anon_sym_enum] = ACTIONS(3383),
    [anon_sym_class] = ACTIONS(3383),
    [anon_sym_struct] = ACTIONS(3383),
    [anon_sym_union] = ACTIONS(3383),
    [anon_sym_if] = ACTIONS(3383),
    [anon_sym_switch] = ACTIONS(3383),
    [anon_sym_case] = ACTIONS(3383),
    [anon_sym_default] = ACTIONS(3383),
    [anon_sym_while] = ACTIONS(3383),
    [anon_sym_do] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3383),
    [anon_sym_return] = ACTIONS(3383),
    [anon_sym_break] = ACTIONS(3383),
    [anon_sym_continue] = ACTIONS(3383),
    [anon_sym_goto] = ACTIONS(3383),
    [anon_sym_not] = ACTIONS(3383),
    [anon_sym_compl] = ACTIONS(3383),
    [anon_sym_DASH_DASH] = ACTIONS(3385),
    [anon_sym_PLUS_PLUS] = ACTIONS(3385),
    [anon_sym_sizeof] = ACTIONS(3383),
    [anon_sym___alignof__] = ACTIONS(3383),
    [anon_sym___alignof] = ACTIONS(3383),
    [anon_sym__alignof] = ACTIONS(3383),
    [anon_sym_alignof] = ACTIONS(3383),
    [anon_sym__Alignof] = ACTIONS(3383),
    [anon_sym_offsetof] = ACTIONS(3383),
    [anon_sym__Generic] = ACTIONS(3383),
    [anon_sym_asm] = ACTIONS(3383),
    [anon_sym___asm__] = ACTIONS(3383),
    [aux_sym_number_literal_token1] = ACTIONS(3385),
    [aux_sym_number_literal_token2] = ACTIONS(3383),
    [anon_sym_L_SQUOTE] = ACTIONS(3385),
    [anon_sym_u_SQUOTE] = ACTIONS(3385),
    [anon_sym_U_SQUOTE] = ACTIONS(3385),
    [anon_sym_u8_SQUOTE] = ACTIONS(3385),
    [anon_sym_SQUOTE] = ACTIONS(3385),
    [anon_sym_L_DQUOTE] = ACTIONS(3385),
    [anon_sym_u_DQUOTE] = ACTIONS(3385),
    [anon_sym_U_DQUOTE] = ACTIONS(3385),
    [anon_sym_u8_DQUOTE] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(3385),
    [sym_true] = ACTIONS(3383),
    [sym_false] = ACTIONS(3383),
    [anon_sym_NULL] = ACTIONS(3383),
    [anon_sym_nullptr] = ACTIONS(3383),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3383),
    [anon_sym_decltype] = ACTIONS(3383),
    [anon_sym_virtual] = ACTIONS(3383),
    [anon_sym_alignas] = ACTIONS(3383),
    [anon_sym_explicit] = ACTIONS(3383),
    [anon_sym_typename] = ACTIONS(3383),
    [anon_sym_template] = ACTIONS(3383),
    [anon_sym_operator] = ACTIONS(3383),
    [anon_sym_try] = ACTIONS(3383),
    [anon_sym_delete] = ACTIONS(3383),
    [anon_sym_throw] = ACTIONS(3383),
    [anon_sym_namespace] = ACTIONS(3383),
    [anon_sym_using] = ACTIONS(3383),
    [anon_sym_static_assert] = ACTIONS(3383),
    [anon_sym_concept] = ACTIONS(3383),
    [anon_sym_co_return] = ACTIONS(3383),
    [anon_sym_co_yield] = ACTIONS(3383),
    [anon_sym_R_DQUOTE] = ACTIONS(3385),
    [anon_sym_LR_DQUOTE] = ACTIONS(3385),
    [anon_sym_uR_DQUOTE] = ACTIONS(3385),
    [anon_sym_UR_DQUOTE] = ACTIONS(3385),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3385),
    [anon_sym_co_await] = ACTIONS(3383),
    [anon_sym_new] = ACTIONS(3383),
    [anon_sym_requires] = ACTIONS(3383),
    [sym_this] = ACTIONS(3383),
  },
  [1041] = {
    [ts_builtin_sym_end] = ACTIONS(3282),
    [sym_identifier] = ACTIONS(3280),
    [aux_sym_preproc_include_token1] = ACTIONS(3280),
    [aux_sym_preproc_def_token1] = ACTIONS(3280),
    [aux_sym_preproc_if_token1] = ACTIONS(3280),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3280),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3280),
    [sym_preproc_directive] = ACTIONS(3280),
    [anon_sym_LPAREN2] = ACTIONS(3282),
    [anon_sym_BANG] = ACTIONS(3282),
    [anon_sym_TILDE] = ACTIONS(3282),
    [anon_sym_DASH] = ACTIONS(3280),
    [anon_sym_PLUS] = ACTIONS(3280),
    [anon_sym_STAR] = ACTIONS(3282),
    [anon_sym_AMP_AMP] = ACTIONS(3282),
    [anon_sym_AMP] = ACTIONS(3280),
    [anon_sym___extension__] = ACTIONS(3280),
    [anon_sym_typedef] = ACTIONS(3280),
    [anon_sym_extern] = ACTIONS(3280),
    [anon_sym___attribute__] = ACTIONS(3280),
    [anon_sym_COLON_COLON] = ACTIONS(3282),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3282),
    [anon_sym___declspec] = ACTIONS(3280),
    [anon_sym___based] = ACTIONS(3280),
    [anon_sym___cdecl] = ACTIONS(3280),
    [anon_sym___clrcall] = ACTIONS(3280),
    [anon_sym___stdcall] = ACTIONS(3280),
    [anon_sym___fastcall] = ACTIONS(3280),
    [anon_sym___thiscall] = ACTIONS(3280),
    [anon_sym___vectorcall] = ACTIONS(3280),
    [anon_sym_LBRACE] = ACTIONS(3282),
    [anon_sym_signed] = ACTIONS(3280),
    [anon_sym_unsigned] = ACTIONS(3280),
    [anon_sym_long] = ACTIONS(3280),
    [anon_sym_short] = ACTIONS(3280),
    [anon_sym_LBRACK] = ACTIONS(3280),
    [anon_sym_static] = ACTIONS(3280),
    [anon_sym_register] = ACTIONS(3280),
    [anon_sym_inline] = ACTIONS(3280),
    [anon_sym___inline] = ACTIONS(3280),
    [anon_sym___inline__] = ACTIONS(3280),
    [anon_sym___forceinline] = ACTIONS(3280),
    [anon_sym_thread_local] = ACTIONS(3280),
    [anon_sym___thread] = ACTIONS(3280),
    [anon_sym_const] = ACTIONS(3280),
    [anon_sym_constexpr] = ACTIONS(3280),
    [anon_sym_volatile] = ACTIONS(3280),
    [anon_sym_restrict] = ACTIONS(3280),
    [anon_sym___restrict__] = ACTIONS(3280),
    [anon_sym__Atomic] = ACTIONS(3280),
    [anon_sym__Noreturn] = ACTIONS(3280),
    [anon_sym_noreturn] = ACTIONS(3280),
    [anon_sym_mutable] = ACTIONS(3280),
    [anon_sym_constinit] = ACTIONS(3280),
    [anon_sym_consteval] = ACTIONS(3280),
    [anon_sym_PROGMEM] = ACTIONS(3280),
    [aux_sym_primitive_type_token1] = ACTIONS(3280),
    [anon_sym_byte] = ACTIONS(3280),
    [anon_sym_word] = ACTIONS(3280),
    [anon_sym_enum] = ACTIONS(3280),
    [anon_sym_class] = ACTIONS(3280),
    [anon_sym_struct] = ACTIONS(3280),
    [anon_sym_union] = ACTIONS(3280),
    [anon_sym_if] = ACTIONS(3280),
    [anon_sym_switch] = ACTIONS(3280),
    [anon_sym_case] = ACTIONS(3280),
    [anon_sym_default] = ACTIONS(3280),
    [anon_sym_while] = ACTIONS(3280),
    [anon_sym_do] = ACTIONS(3280),
    [anon_sym_for] = ACTIONS(3280),
    [anon_sym_return] = ACTIONS(3280),
    [anon_sym_break] = ACTIONS(3280),
    [anon_sym_continue] = ACTIONS(3280),
    [anon_sym_goto] = ACTIONS(3280),
    [anon_sym_not] = ACTIONS(3280),
    [anon_sym_compl] = ACTIONS(3280),
    [anon_sym_DASH_DASH] = ACTIONS(3282),
    [anon_sym_PLUS_PLUS] = ACTIONS(3282),
    [anon_sym_sizeof] = ACTIONS(3280),
    [anon_sym___alignof__] = ACTIONS(3280),
    [anon_sym___alignof] = ACTIONS(3280),
    [anon_sym__alignof] = ACTIONS(3280),
    [anon_sym_alignof] = ACTIONS(3280),
    [anon_sym__Alignof] = ACTIONS(3280),
    [anon_sym_offsetof] = ACTIONS(3280),
    [anon_sym__Generic] = ACTIONS(3280),
    [anon_sym_asm] = ACTIONS(3280),
    [anon_sym___asm__] = ACTIONS(3280),
    [aux_sym_number_literal_token1] = ACTIONS(3282),
    [aux_sym_number_literal_token2] = ACTIONS(3280),
    [anon_sym_L_SQUOTE] = ACTIONS(3282),
    [anon_sym_u_SQUOTE] = ACTIONS(3282),
    [anon_sym_U_SQUOTE] = ACTIONS(3282),
    [anon_sym_u8_SQUOTE] = ACTIONS(3282),
    [anon_sym_SQUOTE] = ACTIONS(3282),
    [anon_sym_L_DQUOTE] = ACTIONS(3282),
    [anon_sym_u_DQUOTE] = ACTIONS(3282),
    [anon_sym_U_DQUOTE] = ACTIONS(3282),
    [anon_sym_u8_DQUOTE] = ACTIONS(3282),
    [anon_sym_DQUOTE] = ACTIONS(3282),
    [sym_true] = ACTIONS(3280),
    [sym_false] = ACTIONS(3280),
    [anon_sym_NULL] = ACTIONS(3280),
    [anon_sym_nullptr] = ACTIONS(3280),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3280),
    [anon_sym_decltype] = ACTIONS(3280),
    [anon_sym_virtual] = ACTIONS(3280),
    [anon_sym_alignas] = ACTIONS(3280),
    [anon_sym_explicit] = ACTIONS(3280),
    [anon_sym_typename] = ACTIONS(3280),
    [anon_sym_template] = ACTIONS(3280),
    [anon_sym_operator] = ACTIONS(3280),
    [anon_sym_try] = ACTIONS(3280),
    [anon_sym_delete] = ACTIONS(3280),
    [anon_sym_throw] = ACTIONS(3280),
    [anon_sym_namespace] = ACTIONS(3280),
    [anon_sym_using] = ACTIONS(3280),
    [anon_sym_static_assert] = ACTIONS(3280),
    [anon_sym_concept] = ACTIONS(3280),
    [anon_sym_co_return] = ACTIONS(3280),
    [anon_sym_co_yield] = ACTIONS(3280),
    [anon_sym_R_DQUOTE] = ACTIONS(3282),
    [anon_sym_LR_DQUOTE] = ACTIONS(3282),
    [anon_sym_uR_DQUOTE] = ACTIONS(3282),
    [anon_sym_UR_DQUOTE] = ACTIONS(3282),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3282),
    [anon_sym_co_await] = ACTIONS(3280),
    [anon_sym_new] = ACTIONS(3280),
    [anon_sym_requires] = ACTIONS(3280),
    [sym_this] = ACTIONS(3280),
  },
  [1042] = {
    [ts_builtin_sym_end] = ACTIONS(3413),
    [sym_identifier] = ACTIONS(3411),
    [aux_sym_preproc_include_token1] = ACTIONS(3411),
    [aux_sym_preproc_def_token1] = ACTIONS(3411),
    [aux_sym_preproc_if_token1] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3411),
    [sym_preproc_directive] = ACTIONS(3411),
    [anon_sym_LPAREN2] = ACTIONS(3413),
    [anon_sym_BANG] = ACTIONS(3413),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_DASH] = ACTIONS(3411),
    [anon_sym_PLUS] = ACTIONS(3411),
    [anon_sym_STAR] = ACTIONS(3413),
    [anon_sym_AMP_AMP] = ACTIONS(3413),
    [anon_sym_AMP] = ACTIONS(3411),
    [anon_sym___extension__] = ACTIONS(3411),
    [anon_sym_typedef] = ACTIONS(3411),
    [anon_sym_extern] = ACTIONS(3411),
    [anon_sym___attribute__] = ACTIONS(3411),
    [anon_sym_COLON_COLON] = ACTIONS(3413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3413),
    [anon_sym___declspec] = ACTIONS(3411),
    [anon_sym___based] = ACTIONS(3411),
    [anon_sym___cdecl] = ACTIONS(3411),
    [anon_sym___clrcall] = ACTIONS(3411),
    [anon_sym___stdcall] = ACTIONS(3411),
    [anon_sym___fastcall] = ACTIONS(3411),
    [anon_sym___thiscall] = ACTIONS(3411),
    [anon_sym___vectorcall] = ACTIONS(3411),
    [anon_sym_LBRACE] = ACTIONS(3413),
    [anon_sym_signed] = ACTIONS(3411),
    [anon_sym_unsigned] = ACTIONS(3411),
    [anon_sym_long] = ACTIONS(3411),
    [anon_sym_short] = ACTIONS(3411),
    [anon_sym_LBRACK] = ACTIONS(3411),
    [anon_sym_static] = ACTIONS(3411),
    [anon_sym_register] = ACTIONS(3411),
    [anon_sym_inline] = ACTIONS(3411),
    [anon_sym___inline] = ACTIONS(3411),
    [anon_sym___inline__] = ACTIONS(3411),
    [anon_sym___forceinline] = ACTIONS(3411),
    [anon_sym_thread_local] = ACTIONS(3411),
    [anon_sym___thread] = ACTIONS(3411),
    [anon_sym_const] = ACTIONS(3411),
    [anon_sym_constexpr] = ACTIONS(3411),
    [anon_sym_volatile] = ACTIONS(3411),
    [anon_sym_restrict] = ACTIONS(3411),
    [anon_sym___restrict__] = ACTIONS(3411),
    [anon_sym__Atomic] = ACTIONS(3411),
    [anon_sym__Noreturn] = ACTIONS(3411),
    [anon_sym_noreturn] = ACTIONS(3411),
    [anon_sym_mutable] = ACTIONS(3411),
    [anon_sym_constinit] = ACTIONS(3411),
    [anon_sym_consteval] = ACTIONS(3411),
    [anon_sym_PROGMEM] = ACTIONS(3411),
    [aux_sym_primitive_type_token1] = ACTIONS(3411),
    [anon_sym_byte] = ACTIONS(3411),
    [anon_sym_word] = ACTIONS(3411),
    [anon_sym_enum] = ACTIONS(3411),
    [anon_sym_class] = ACTIONS(3411),
    [anon_sym_struct] = ACTIONS(3411),
    [anon_sym_union] = ACTIONS(3411),
    [anon_sym_if] = ACTIONS(3411),
    [anon_sym_switch] = ACTIONS(3411),
    [anon_sym_case] = ACTIONS(3411),
    [anon_sym_default] = ACTIONS(3411),
    [anon_sym_while] = ACTIONS(3411),
    [anon_sym_do] = ACTIONS(3411),
    [anon_sym_for] = ACTIONS(3411),
    [anon_sym_return] = ACTIONS(3411),
    [anon_sym_break] = ACTIONS(3411),
    [anon_sym_continue] = ACTIONS(3411),
    [anon_sym_goto] = ACTIONS(3411),
    [anon_sym_not] = ACTIONS(3411),
    [anon_sym_compl] = ACTIONS(3411),
    [anon_sym_DASH_DASH] = ACTIONS(3413),
    [anon_sym_PLUS_PLUS] = ACTIONS(3413),
    [anon_sym_sizeof] = ACTIONS(3411),
    [anon_sym___alignof__] = ACTIONS(3411),
    [anon_sym___alignof] = ACTIONS(3411),
    [anon_sym__alignof] = ACTIONS(3411),
    [anon_sym_alignof] = ACTIONS(3411),
    [anon_sym__Alignof] = ACTIONS(3411),
    [anon_sym_offsetof] = ACTIONS(3411),
    [anon_sym__Generic] = ACTIONS(3411),
    [anon_sym_asm] = ACTIONS(3411),
    [anon_sym___asm__] = ACTIONS(3411),
    [aux_sym_number_literal_token1] = ACTIONS(3413),
    [aux_sym_number_literal_token2] = ACTIONS(3411),
    [anon_sym_L_SQUOTE] = ACTIONS(3413),
    [anon_sym_u_SQUOTE] = ACTIONS(3413),
    [anon_sym_U_SQUOTE] = ACTIONS(3413),
    [anon_sym_u8_SQUOTE] = ACTIONS(3413),
    [anon_sym_SQUOTE] = ACTIONS(3413),
    [anon_sym_L_DQUOTE] = ACTIONS(3413),
    [anon_sym_u_DQUOTE] = ACTIONS(3413),
    [anon_sym_U_DQUOTE] = ACTIONS(3413),
    [anon_sym_u8_DQUOTE] = ACTIONS(3413),
    [anon_sym_DQUOTE] = ACTIONS(3413),
    [sym_true] = ACTIONS(3411),
    [sym_false] = ACTIONS(3411),
    [anon_sym_NULL] = ACTIONS(3411),
    [anon_sym_nullptr] = ACTIONS(3411),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3411),
    [anon_sym_decltype] = ACTIONS(3411),
    [anon_sym_virtual] = ACTIONS(3411),
    [anon_sym_alignas] = ACTIONS(3411),
    [anon_sym_explicit] = ACTIONS(3411),
    [anon_sym_typename] = ACTIONS(3411),
    [anon_sym_template] = ACTIONS(3411),
    [anon_sym_operator] = ACTIONS(3411),
    [anon_sym_try] = ACTIONS(3411),
    [anon_sym_delete] = ACTIONS(3411),
    [anon_sym_throw] = ACTIONS(3411),
    [anon_sym_namespace] = ACTIONS(3411),
    [anon_sym_using] = ACTIONS(3411),
    [anon_sym_static_assert] = ACTIONS(3411),
    [anon_sym_concept] = ACTIONS(3411),
    [anon_sym_co_return] = ACTIONS(3411),
    [anon_sym_co_yield] = ACTIONS(3411),
    [anon_sym_R_DQUOTE] = ACTIONS(3413),
    [anon_sym_LR_DQUOTE] = ACTIONS(3413),
    [anon_sym_uR_DQUOTE] = ACTIONS(3413),
    [anon_sym_UR_DQUOTE] = ACTIONS(3413),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3413),
    [anon_sym_co_await] = ACTIONS(3411),
    [anon_sym_new] = ACTIONS(3411),
    [anon_sym_requires] = ACTIONS(3411),
    [sym_this] = ACTIONS(3411),
  },
  [1043] = {
    [ts_builtin_sym_end] = ACTIONS(3295),
    [sym_identifier] = ACTIONS(3293),
    [aux_sym_preproc_include_token1] = ACTIONS(3293),
    [aux_sym_preproc_def_token1] = ACTIONS(3293),
    [aux_sym_preproc_if_token1] = ACTIONS(3293),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3293),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3293),
    [sym_preproc_directive] = ACTIONS(3293),
    [anon_sym_LPAREN2] = ACTIONS(3295),
    [anon_sym_BANG] = ACTIONS(3295),
    [anon_sym_TILDE] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3293),
    [anon_sym_STAR] = ACTIONS(3295),
    [anon_sym_AMP_AMP] = ACTIONS(3295),
    [anon_sym_AMP] = ACTIONS(3293),
    [anon_sym___extension__] = ACTIONS(3293),
    [anon_sym_typedef] = ACTIONS(3293),
    [anon_sym_extern] = ACTIONS(3293),
    [anon_sym___attribute__] = ACTIONS(3293),
    [anon_sym_COLON_COLON] = ACTIONS(3295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3295),
    [anon_sym___declspec] = ACTIONS(3293),
    [anon_sym___based] = ACTIONS(3293),
    [anon_sym___cdecl] = ACTIONS(3293),
    [anon_sym___clrcall] = ACTIONS(3293),
    [anon_sym___stdcall] = ACTIONS(3293),
    [anon_sym___fastcall] = ACTIONS(3293),
    [anon_sym___thiscall] = ACTIONS(3293),
    [anon_sym___vectorcall] = ACTIONS(3293),
    [anon_sym_LBRACE] = ACTIONS(3295),
    [anon_sym_signed] = ACTIONS(3293),
    [anon_sym_unsigned] = ACTIONS(3293),
    [anon_sym_long] = ACTIONS(3293),
    [anon_sym_short] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_static] = ACTIONS(3293),
    [anon_sym_register] = ACTIONS(3293),
    [anon_sym_inline] = ACTIONS(3293),
    [anon_sym___inline] = ACTIONS(3293),
    [anon_sym___inline__] = ACTIONS(3293),
    [anon_sym___forceinline] = ACTIONS(3293),
    [anon_sym_thread_local] = ACTIONS(3293),
    [anon_sym___thread] = ACTIONS(3293),
    [anon_sym_const] = ACTIONS(3293),
    [anon_sym_constexpr] = ACTIONS(3293),
    [anon_sym_volatile] = ACTIONS(3293),
    [anon_sym_restrict] = ACTIONS(3293),
    [anon_sym___restrict__] = ACTIONS(3293),
    [anon_sym__Atomic] = ACTIONS(3293),
    [anon_sym__Noreturn] = ACTIONS(3293),
    [anon_sym_noreturn] = ACTIONS(3293),
    [anon_sym_mutable] = ACTIONS(3293),
    [anon_sym_constinit] = ACTIONS(3293),
    [anon_sym_consteval] = ACTIONS(3293),
    [anon_sym_PROGMEM] = ACTIONS(3293),
    [aux_sym_primitive_type_token1] = ACTIONS(3293),
    [anon_sym_byte] = ACTIONS(3293),
    [anon_sym_word] = ACTIONS(3293),
    [anon_sym_enum] = ACTIONS(3293),
    [anon_sym_class] = ACTIONS(3293),
    [anon_sym_struct] = ACTIONS(3293),
    [anon_sym_union] = ACTIONS(3293),
    [anon_sym_if] = ACTIONS(3293),
    [anon_sym_switch] = ACTIONS(3293),
    [anon_sym_case] = ACTIONS(3293),
    [anon_sym_default] = ACTIONS(3293),
    [anon_sym_while] = ACTIONS(3293),
    [anon_sym_do] = ACTIONS(3293),
    [anon_sym_for] = ACTIONS(3293),
    [anon_sym_return] = ACTIONS(3293),
    [anon_sym_break] = ACTIONS(3293),
    [anon_sym_continue] = ACTIONS(3293),
    [anon_sym_goto] = ACTIONS(3293),
    [anon_sym_not] = ACTIONS(3293),
    [anon_sym_compl] = ACTIONS(3293),
    [anon_sym_DASH_DASH] = ACTIONS(3295),
    [anon_sym_PLUS_PLUS] = ACTIONS(3295),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3293),
    [anon_sym___alignof] = ACTIONS(3293),
    [anon_sym__alignof] = ACTIONS(3293),
    [anon_sym_alignof] = ACTIONS(3293),
    [anon_sym__Alignof] = ACTIONS(3293),
    [anon_sym_offsetof] = ACTIONS(3293),
    [anon_sym__Generic] = ACTIONS(3293),
    [anon_sym_asm] = ACTIONS(3293),
    [anon_sym___asm__] = ACTIONS(3293),
    [aux_sym_number_literal_token1] = ACTIONS(3295),
    [aux_sym_number_literal_token2] = ACTIONS(3293),
    [anon_sym_L_SQUOTE] = ACTIONS(3295),
    [anon_sym_u_SQUOTE] = ACTIONS(3295),
    [anon_sym_U_SQUOTE] = ACTIONS(3295),
    [anon_sym_u8_SQUOTE] = ACTIONS(3295),
    [anon_sym_SQUOTE] = ACTIONS(3295),
    [anon_sym_L_DQUOTE] = ACTIONS(3295),
    [anon_sym_u_DQUOTE] = ACTIONS(3295),
    [anon_sym_U_DQUOTE] = ACTIONS(3295),
    [anon_sym_u8_DQUOTE] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(3295),
    [sym_true] = ACTIONS(3293),
    [sym_false] = ACTIONS(3293),
    [anon_sym_NULL] = ACTIONS(3293),
    [anon_sym_nullptr] = ACTIONS(3293),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3293),
    [anon_sym_decltype] = ACTIONS(3293),
    [anon_sym_virtual] = ACTIONS(3293),
    [anon_sym_alignas] = ACTIONS(3293),
    [anon_sym_explicit] = ACTIONS(3293),
    [anon_sym_typename] = ACTIONS(3293),
    [anon_sym_template] = ACTIONS(3293),
    [anon_sym_operator] = ACTIONS(3293),
    [anon_sym_try] = ACTIONS(3293),
    [anon_sym_delete] = ACTIONS(3293),
    [anon_sym_throw] = ACTIONS(3293),
    [anon_sym_namespace] = ACTIONS(3293),
    [anon_sym_using] = ACTIONS(3293),
    [anon_sym_static_assert] = ACTIONS(3293),
    [anon_sym_concept] = ACTIONS(3293),
    [anon_sym_co_return] = ACTIONS(3293),
    [anon_sym_co_yield] = ACTIONS(3293),
    [anon_sym_R_DQUOTE] = ACTIONS(3295),
    [anon_sym_LR_DQUOTE] = ACTIONS(3295),
    [anon_sym_uR_DQUOTE] = ACTIONS(3295),
    [anon_sym_UR_DQUOTE] = ACTIONS(3295),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3295),
    [anon_sym_co_await] = ACTIONS(3293),
    [anon_sym_new] = ACTIONS(3293),
    [anon_sym_requires] = ACTIONS(3293),
    [sym_this] = ACTIONS(3293),
  },
  [1044] = {
    [sym_preproc_def] = STATE(1018),
    [sym_preproc_function_def] = STATE(1018),
    [sym_preproc_call] = STATE(1018),
    [sym_preproc_if_in_field_declaration_list] = STATE(1018),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1018),
    [sym_type_definition] = STATE(1018),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1018),
    [sym_field_declaration] = STATE(1018),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1018),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1018),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1018),
    [sym_operator_cast_declaration] = STATE(1018),
    [sym_constructor_or_destructor_definition] = STATE(1018),
    [sym_constructor_or_destructor_declaration] = STATE(1018),
    [sym_friend_declaration] = STATE(1018),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1018),
    [sym_alias_declaration] = STATE(1018),
    [sym_static_assert_declaration] = STATE(1018),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1018),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3829),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3829),
    [sym_preproc_directive] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3833),
    [anon_sym_typedef] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3921),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_static_assert] = ACTIONS(3845),
  },
  [1045] = {
    [sym_preproc_def] = STATE(1083),
    [sym_preproc_function_def] = STATE(1083),
    [sym_preproc_call] = STATE(1083),
    [sym_preproc_if_in_field_declaration_list] = STATE(1083),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1083),
    [sym_type_definition] = STATE(1083),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1083),
    [sym_field_declaration] = STATE(1083),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1083),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1083),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1083),
    [sym_operator_cast_declaration] = STATE(1083),
    [sym_constructor_or_destructor_definition] = STATE(1083),
    [sym_constructor_or_destructor_declaration] = STATE(1083),
    [sym_friend_declaration] = STATE(1083),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1083),
    [sym_alias_declaration] = STATE(1083),
    [sym_static_assert_declaration] = STATE(1083),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1083),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3829),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3829),
    [sym_preproc_directive] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3833),
    [anon_sym_typedef] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3923),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_static_assert] = ACTIONS(3845),
  },
  [1046] = {
    [sym_preproc_def] = STATE(1048),
    [sym_preproc_function_def] = STATE(1048),
    [sym_preproc_call] = STATE(1048),
    [sym_preproc_if_in_field_declaration_list] = STATE(1048),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1048),
    [sym_type_definition] = STATE(1048),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6440),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7010),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1048),
    [sym_field_declaration] = STATE(1048),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2144),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1048),
    [sym_operator_cast] = STATE(7526),
    [sym_inline_method_definition] = STATE(1048),
    [sym__constructor_specifiers] = STATE(2144),
    [sym_operator_cast_definition] = STATE(1048),
    [sym_operator_cast_declaration] = STATE(1048),
    [sym_constructor_or_destructor_definition] = STATE(1048),
    [sym_constructor_or_destructor_declaration] = STATE(1048),
    [sym_friend_declaration] = STATE(1048),
    [sym_access_specifier] = STATE(9703),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1048),
    [sym_alias_declaration] = STATE(1048),
    [sym_static_assert_declaration] = STATE(1048),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7526),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1048),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2144),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3925),
    [aux_sym_preproc_if_token1] = ACTIONS(3927),
    [aux_sym_preproc_if_token2] = ACTIONS(3929),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3931),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3931),
    [sym_preproc_directive] = ACTIONS(3933),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3935),
    [anon_sym_typedef] = ACTIONS(3937),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3939),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3941),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3943),
    [anon_sym_static_assert] = ACTIONS(3945),
  },
  [1047] = {
    [sym_preproc_def] = STATE(1066),
    [sym_preproc_function_def] = STATE(1066),
    [sym_preproc_call] = STATE(1066),
    [sym_preproc_if_in_field_declaration_list] = STATE(1066),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1066),
    [sym_type_definition] = STATE(1066),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1066),
    [sym_field_declaration] = STATE(1066),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1066),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1066),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1066),
    [sym_operator_cast_declaration] = STATE(1066),
    [sym_constructor_or_destructor_definition] = STATE(1066),
    [sym_constructor_or_destructor_declaration] = STATE(1066),
    [sym_friend_declaration] = STATE(1066),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1066),
    [sym_alias_declaration] = STATE(1066),
    [sym_static_assert_declaration] = STATE(1066),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1066),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3829),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3829),
    [sym_preproc_directive] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3833),
    [anon_sym_typedef] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3947),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_static_assert] = ACTIONS(3845),
  },
  [1048] = {
    [sym_preproc_def] = STATE(1037),
    [sym_preproc_function_def] = STATE(1037),
    [sym_preproc_call] = STATE(1037),
    [sym_preproc_if_in_field_declaration_list] = STATE(1037),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1037),
    [sym_type_definition] = STATE(1037),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6440),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7010),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1037),
    [sym_field_declaration] = STATE(1037),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2144),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1037),
    [sym_operator_cast] = STATE(7526),
    [sym_inline_method_definition] = STATE(1037),
    [sym__constructor_specifiers] = STATE(2144),
    [sym_operator_cast_definition] = STATE(1037),
    [sym_operator_cast_declaration] = STATE(1037),
    [sym_constructor_or_destructor_definition] = STATE(1037),
    [sym_constructor_or_destructor_declaration] = STATE(1037),
    [sym_friend_declaration] = STATE(1037),
    [sym_access_specifier] = STATE(9703),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1037),
    [sym_alias_declaration] = STATE(1037),
    [sym_static_assert_declaration] = STATE(1037),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7526),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1037),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2144),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3925),
    [aux_sym_preproc_if_token1] = ACTIONS(3927),
    [aux_sym_preproc_if_token2] = ACTIONS(3949),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3931),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3931),
    [sym_preproc_directive] = ACTIONS(3933),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3935),
    [anon_sym_typedef] = ACTIONS(3937),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3939),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3941),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3943),
    [anon_sym_static_assert] = ACTIONS(3945),
  },
  [1049] = {
    [ts_builtin_sym_end] = ACTIONS(3433),
    [sym_identifier] = ACTIONS(3431),
    [aux_sym_preproc_include_token1] = ACTIONS(3431),
    [aux_sym_preproc_def_token1] = ACTIONS(3431),
    [aux_sym_preproc_if_token1] = ACTIONS(3431),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3431),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3431),
    [sym_preproc_directive] = ACTIONS(3431),
    [anon_sym_LPAREN2] = ACTIONS(3433),
    [anon_sym_BANG] = ACTIONS(3433),
    [anon_sym_TILDE] = ACTIONS(3433),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3433),
    [anon_sym_AMP_AMP] = ACTIONS(3433),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym___extension__] = ACTIONS(3431),
    [anon_sym_typedef] = ACTIONS(3431),
    [anon_sym_extern] = ACTIONS(3431),
    [anon_sym___attribute__] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3433),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3433),
    [anon_sym___declspec] = ACTIONS(3431),
    [anon_sym___based] = ACTIONS(3431),
    [anon_sym___cdecl] = ACTIONS(3431),
    [anon_sym___clrcall] = ACTIONS(3431),
    [anon_sym___stdcall] = ACTIONS(3431),
    [anon_sym___fastcall] = ACTIONS(3431),
    [anon_sym___thiscall] = ACTIONS(3431),
    [anon_sym___vectorcall] = ACTIONS(3431),
    [anon_sym_LBRACE] = ACTIONS(3433),
    [anon_sym_signed] = ACTIONS(3431),
    [anon_sym_unsigned] = ACTIONS(3431),
    [anon_sym_long] = ACTIONS(3431),
    [anon_sym_short] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_static] = ACTIONS(3431),
    [anon_sym_register] = ACTIONS(3431),
    [anon_sym_inline] = ACTIONS(3431),
    [anon_sym___inline] = ACTIONS(3431),
    [anon_sym___inline__] = ACTIONS(3431),
    [anon_sym___forceinline] = ACTIONS(3431),
    [anon_sym_thread_local] = ACTIONS(3431),
    [anon_sym___thread] = ACTIONS(3431),
    [anon_sym_const] = ACTIONS(3431),
    [anon_sym_constexpr] = ACTIONS(3431),
    [anon_sym_volatile] = ACTIONS(3431),
    [anon_sym_restrict] = ACTIONS(3431),
    [anon_sym___restrict__] = ACTIONS(3431),
    [anon_sym__Atomic] = ACTIONS(3431),
    [anon_sym__Noreturn] = ACTIONS(3431),
    [anon_sym_noreturn] = ACTIONS(3431),
    [anon_sym_mutable] = ACTIONS(3431),
    [anon_sym_constinit] = ACTIONS(3431),
    [anon_sym_consteval] = ACTIONS(3431),
    [anon_sym_PROGMEM] = ACTIONS(3431),
    [aux_sym_primitive_type_token1] = ACTIONS(3431),
    [anon_sym_byte] = ACTIONS(3431),
    [anon_sym_word] = ACTIONS(3431),
    [anon_sym_enum] = ACTIONS(3431),
    [anon_sym_class] = ACTIONS(3431),
    [anon_sym_struct] = ACTIONS(3431),
    [anon_sym_union] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_switch] = ACTIONS(3431),
    [anon_sym_case] = ACTIONS(3431),
    [anon_sym_default] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_break] = ACTIONS(3431),
    [anon_sym_continue] = ACTIONS(3431),
    [anon_sym_goto] = ACTIONS(3431),
    [anon_sym_not] = ACTIONS(3431),
    [anon_sym_compl] = ACTIONS(3431),
    [anon_sym_DASH_DASH] = ACTIONS(3433),
    [anon_sym_PLUS_PLUS] = ACTIONS(3433),
    [anon_sym_sizeof] = ACTIONS(3431),
    [anon_sym___alignof__] = ACTIONS(3431),
    [anon_sym___alignof] = ACTIONS(3431),
    [anon_sym__alignof] = ACTIONS(3431),
    [anon_sym_alignof] = ACTIONS(3431),
    [anon_sym__Alignof] = ACTIONS(3431),
    [anon_sym_offsetof] = ACTIONS(3431),
    [anon_sym__Generic] = ACTIONS(3431),
    [anon_sym_asm] = ACTIONS(3431),
    [anon_sym___asm__] = ACTIONS(3431),
    [aux_sym_number_literal_token1] = ACTIONS(3433),
    [aux_sym_number_literal_token2] = ACTIONS(3431),
    [anon_sym_L_SQUOTE] = ACTIONS(3433),
    [anon_sym_u_SQUOTE] = ACTIONS(3433),
    [anon_sym_U_SQUOTE] = ACTIONS(3433),
    [anon_sym_u8_SQUOTE] = ACTIONS(3433),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [anon_sym_L_DQUOTE] = ACTIONS(3433),
    [anon_sym_u_DQUOTE] = ACTIONS(3433),
    [anon_sym_U_DQUOTE] = ACTIONS(3433),
    [anon_sym_u8_DQUOTE] = ACTIONS(3433),
    [anon_sym_DQUOTE] = ACTIONS(3433),
    [sym_true] = ACTIONS(3431),
    [sym_false] = ACTIONS(3431),
    [anon_sym_NULL] = ACTIONS(3431),
    [anon_sym_nullptr] = ACTIONS(3431),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3431),
    [anon_sym_decltype] = ACTIONS(3431),
    [anon_sym_virtual] = ACTIONS(3431),
    [anon_sym_alignas] = ACTIONS(3431),
    [anon_sym_explicit] = ACTIONS(3431),
    [anon_sym_typename] = ACTIONS(3431),
    [anon_sym_template] = ACTIONS(3431),
    [anon_sym_operator] = ACTIONS(3431),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_delete] = ACTIONS(3431),
    [anon_sym_throw] = ACTIONS(3431),
    [anon_sym_namespace] = ACTIONS(3431),
    [anon_sym_using] = ACTIONS(3431),
    [anon_sym_static_assert] = ACTIONS(3431),
    [anon_sym_concept] = ACTIONS(3431),
    [anon_sym_co_return] = ACTIONS(3431),
    [anon_sym_co_yield] = ACTIONS(3431),
    [anon_sym_R_DQUOTE] = ACTIONS(3433),
    [anon_sym_LR_DQUOTE] = ACTIONS(3433),
    [anon_sym_uR_DQUOTE] = ACTIONS(3433),
    [anon_sym_UR_DQUOTE] = ACTIONS(3433),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3433),
    [anon_sym_co_await] = ACTIONS(3431),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_requires] = ACTIONS(3431),
    [sym_this] = ACTIONS(3431),
  },
  [1050] = {
    [sym_preproc_def] = STATE(1056),
    [sym_preproc_function_def] = STATE(1056),
    [sym_preproc_call] = STATE(1056),
    [sym_preproc_if_in_field_declaration_list] = STATE(1056),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1056),
    [sym_type_definition] = STATE(1056),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1056),
    [sym_field_declaration] = STATE(1056),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1056),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1056),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1056),
    [sym_operator_cast_declaration] = STATE(1056),
    [sym_constructor_or_destructor_definition] = STATE(1056),
    [sym_constructor_or_destructor_declaration] = STATE(1056),
    [sym_friend_declaration] = STATE(1056),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1056),
    [sym_alias_declaration] = STATE(1056),
    [sym_static_assert_declaration] = STATE(1056),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1056),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3829),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3829),
    [sym_preproc_directive] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3833),
    [anon_sym_typedef] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3951),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_static_assert] = ACTIONS(3845),
  },
  [1051] = {
    [sym_preproc_def] = STATE(1056),
    [sym_preproc_function_def] = STATE(1056),
    [sym_preproc_call] = STATE(1056),
    [sym_preproc_if_in_field_declaration_list] = STATE(1056),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1056),
    [sym_type_definition] = STATE(1056),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1056),
    [sym_field_declaration] = STATE(1056),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1056),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1056),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1056),
    [sym_operator_cast_declaration] = STATE(1056),
    [sym_constructor_or_destructor_definition] = STATE(1056),
    [sym_constructor_or_destructor_declaration] = STATE(1056),
    [sym_friend_declaration] = STATE(1056),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1056),
    [sym_alias_declaration] = STATE(1056),
    [sym_static_assert_declaration] = STATE(1056),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1056),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3829),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3829),
    [sym_preproc_directive] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3833),
    [anon_sym_typedef] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3953),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_static_assert] = ACTIONS(3845),
  },
  [1052] = {
    [ts_builtin_sym_end] = ACTIONS(3469),
    [sym_identifier] = ACTIONS(3467),
    [aux_sym_preproc_include_token1] = ACTIONS(3467),
    [aux_sym_preproc_def_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token1] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3467),
    [sym_preproc_directive] = ACTIONS(3467),
    [anon_sym_LPAREN2] = ACTIONS(3469),
    [anon_sym_BANG] = ACTIONS(3469),
    [anon_sym_TILDE] = ACTIONS(3469),
    [anon_sym_DASH] = ACTIONS(3467),
    [anon_sym_PLUS] = ACTIONS(3467),
    [anon_sym_STAR] = ACTIONS(3469),
    [anon_sym_AMP_AMP] = ACTIONS(3469),
    [anon_sym_AMP] = ACTIONS(3467),
    [anon_sym___extension__] = ACTIONS(3467),
    [anon_sym_typedef] = ACTIONS(3467),
    [anon_sym_extern] = ACTIONS(3467),
    [anon_sym___attribute__] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(3469),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3469),
    [anon_sym___declspec] = ACTIONS(3467),
    [anon_sym___based] = ACTIONS(3467),
    [anon_sym___cdecl] = ACTIONS(3467),
    [anon_sym___clrcall] = ACTIONS(3467),
    [anon_sym___stdcall] = ACTIONS(3467),
    [anon_sym___fastcall] = ACTIONS(3467),
    [anon_sym___thiscall] = ACTIONS(3467),
    [anon_sym___vectorcall] = ACTIONS(3467),
    [anon_sym_LBRACE] = ACTIONS(3469),
    [anon_sym_signed] = ACTIONS(3467),
    [anon_sym_unsigned] = ACTIONS(3467),
    [anon_sym_long] = ACTIONS(3467),
    [anon_sym_short] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [anon_sym_static] = ACTIONS(3467),
    [anon_sym_register] = ACTIONS(3467),
    [anon_sym_inline] = ACTIONS(3467),
    [anon_sym___inline] = ACTIONS(3467),
    [anon_sym___inline__] = ACTIONS(3467),
    [anon_sym___forceinline] = ACTIONS(3467),
    [anon_sym_thread_local] = ACTIONS(3467),
    [anon_sym___thread] = ACTIONS(3467),
    [anon_sym_const] = ACTIONS(3467),
    [anon_sym_constexpr] = ACTIONS(3467),
    [anon_sym_volatile] = ACTIONS(3467),
    [anon_sym_restrict] = ACTIONS(3467),
    [anon_sym___restrict__] = ACTIONS(3467),
    [anon_sym__Atomic] = ACTIONS(3467),
    [anon_sym__Noreturn] = ACTIONS(3467),
    [anon_sym_noreturn] = ACTIONS(3467),
    [anon_sym_mutable] = ACTIONS(3467),
    [anon_sym_constinit] = ACTIONS(3467),
    [anon_sym_consteval] = ACTIONS(3467),
    [anon_sym_PROGMEM] = ACTIONS(3467),
    [aux_sym_primitive_type_token1] = ACTIONS(3467),
    [anon_sym_byte] = ACTIONS(3467),
    [anon_sym_word] = ACTIONS(3467),
    [anon_sym_enum] = ACTIONS(3467),
    [anon_sym_class] = ACTIONS(3467),
    [anon_sym_struct] = ACTIONS(3467),
    [anon_sym_union] = ACTIONS(3467),
    [anon_sym_if] = ACTIONS(3467),
    [anon_sym_switch] = ACTIONS(3467),
    [anon_sym_case] = ACTIONS(3467),
    [anon_sym_default] = ACTIONS(3467),
    [anon_sym_while] = ACTIONS(3467),
    [anon_sym_do] = ACTIONS(3467),
    [anon_sym_for] = ACTIONS(3467),
    [anon_sym_return] = ACTIONS(3467),
    [anon_sym_break] = ACTIONS(3467),
    [anon_sym_continue] = ACTIONS(3467),
    [anon_sym_goto] = ACTIONS(3467),
    [anon_sym_not] = ACTIONS(3467),
    [anon_sym_compl] = ACTIONS(3467),
    [anon_sym_DASH_DASH] = ACTIONS(3469),
    [anon_sym_PLUS_PLUS] = ACTIONS(3469),
    [anon_sym_sizeof] = ACTIONS(3467),
    [anon_sym___alignof__] = ACTIONS(3467),
    [anon_sym___alignof] = ACTIONS(3467),
    [anon_sym__alignof] = ACTIONS(3467),
    [anon_sym_alignof] = ACTIONS(3467),
    [anon_sym__Alignof] = ACTIONS(3467),
    [anon_sym_offsetof] = ACTIONS(3467),
    [anon_sym__Generic] = ACTIONS(3467),
    [anon_sym_asm] = ACTIONS(3467),
    [anon_sym___asm__] = ACTIONS(3467),
    [aux_sym_number_literal_token1] = ACTIONS(3469),
    [aux_sym_number_literal_token2] = ACTIONS(3467),
    [anon_sym_L_SQUOTE] = ACTIONS(3469),
    [anon_sym_u_SQUOTE] = ACTIONS(3469),
    [anon_sym_U_SQUOTE] = ACTIONS(3469),
    [anon_sym_u8_SQUOTE] = ACTIONS(3469),
    [anon_sym_SQUOTE] = ACTIONS(3469),
    [anon_sym_L_DQUOTE] = ACTIONS(3469),
    [anon_sym_u_DQUOTE] = ACTIONS(3469),
    [anon_sym_U_DQUOTE] = ACTIONS(3469),
    [anon_sym_u8_DQUOTE] = ACTIONS(3469),
    [anon_sym_DQUOTE] = ACTIONS(3469),
    [sym_true] = ACTIONS(3467),
    [sym_false] = ACTIONS(3467),
    [anon_sym_NULL] = ACTIONS(3467),
    [anon_sym_nullptr] = ACTIONS(3467),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3467),
    [anon_sym_decltype] = ACTIONS(3467),
    [anon_sym_virtual] = ACTIONS(3467),
    [anon_sym_alignas] = ACTIONS(3467),
    [anon_sym_explicit] = ACTIONS(3467),
    [anon_sym_typename] = ACTIONS(3467),
    [anon_sym_template] = ACTIONS(3467),
    [anon_sym_operator] = ACTIONS(3467),
    [anon_sym_try] = ACTIONS(3467),
    [anon_sym_delete] = ACTIONS(3467),
    [anon_sym_throw] = ACTIONS(3467),
    [anon_sym_namespace] = ACTIONS(3467),
    [anon_sym_using] = ACTIONS(3467),
    [anon_sym_static_assert] = ACTIONS(3467),
    [anon_sym_concept] = ACTIONS(3467),
    [anon_sym_co_return] = ACTIONS(3467),
    [anon_sym_co_yield] = ACTIONS(3467),
    [anon_sym_R_DQUOTE] = ACTIONS(3469),
    [anon_sym_LR_DQUOTE] = ACTIONS(3469),
    [anon_sym_uR_DQUOTE] = ACTIONS(3469),
    [anon_sym_UR_DQUOTE] = ACTIONS(3469),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3469),
    [anon_sym_co_await] = ACTIONS(3467),
    [anon_sym_new] = ACTIONS(3467),
    [anon_sym_requires] = ACTIONS(3467),
    [sym_this] = ACTIONS(3467),
  },
  [1053] = {
    [ts_builtin_sym_end] = ACTIONS(3316),
    [sym_identifier] = ACTIONS(3314),
    [aux_sym_preproc_include_token1] = ACTIONS(3314),
    [aux_sym_preproc_def_token1] = ACTIONS(3314),
    [aux_sym_preproc_if_token1] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3314),
    [sym_preproc_directive] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_STAR] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym___extension__] = ACTIONS(3314),
    [anon_sym_typedef] = ACTIONS(3314),
    [anon_sym_extern] = ACTIONS(3314),
    [anon_sym___attribute__] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3316),
    [anon_sym___declspec] = ACTIONS(3314),
    [anon_sym___based] = ACTIONS(3314),
    [anon_sym___cdecl] = ACTIONS(3314),
    [anon_sym___clrcall] = ACTIONS(3314),
    [anon_sym___stdcall] = ACTIONS(3314),
    [anon_sym___fastcall] = ACTIONS(3314),
    [anon_sym___thiscall] = ACTIONS(3314),
    [anon_sym___vectorcall] = ACTIONS(3314),
    [anon_sym_LBRACE] = ACTIONS(3316),
    [anon_sym_signed] = ACTIONS(3314),
    [anon_sym_unsigned] = ACTIONS(3314),
    [anon_sym_long] = ACTIONS(3314),
    [anon_sym_short] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_static] = ACTIONS(3314),
    [anon_sym_register] = ACTIONS(3314),
    [anon_sym_inline] = ACTIONS(3314),
    [anon_sym___inline] = ACTIONS(3314),
    [anon_sym___inline__] = ACTIONS(3314),
    [anon_sym___forceinline] = ACTIONS(3314),
    [anon_sym_thread_local] = ACTIONS(3314),
    [anon_sym___thread] = ACTIONS(3314),
    [anon_sym_const] = ACTIONS(3314),
    [anon_sym_constexpr] = ACTIONS(3314),
    [anon_sym_volatile] = ACTIONS(3314),
    [anon_sym_restrict] = ACTIONS(3314),
    [anon_sym___restrict__] = ACTIONS(3314),
    [anon_sym__Atomic] = ACTIONS(3314),
    [anon_sym__Noreturn] = ACTIONS(3314),
    [anon_sym_noreturn] = ACTIONS(3314),
    [anon_sym_mutable] = ACTIONS(3314),
    [anon_sym_constinit] = ACTIONS(3314),
    [anon_sym_consteval] = ACTIONS(3314),
    [anon_sym_PROGMEM] = ACTIONS(3314),
    [aux_sym_primitive_type_token1] = ACTIONS(3314),
    [anon_sym_byte] = ACTIONS(3314),
    [anon_sym_word] = ACTIONS(3314),
    [anon_sym_enum] = ACTIONS(3314),
    [anon_sym_class] = ACTIONS(3314),
    [anon_sym_struct] = ACTIONS(3314),
    [anon_sym_union] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_switch] = ACTIONS(3314),
    [anon_sym_case] = ACTIONS(3314),
    [anon_sym_default] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_break] = ACTIONS(3314),
    [anon_sym_continue] = ACTIONS(3314),
    [anon_sym_goto] = ACTIONS(3314),
    [anon_sym_not] = ACTIONS(3314),
    [anon_sym_compl] = ACTIONS(3314),
    [anon_sym_DASH_DASH] = ACTIONS(3316),
    [anon_sym_PLUS_PLUS] = ACTIONS(3316),
    [anon_sym_sizeof] = ACTIONS(3314),
    [anon_sym___alignof__] = ACTIONS(3314),
    [anon_sym___alignof] = ACTIONS(3314),
    [anon_sym__alignof] = ACTIONS(3314),
    [anon_sym_alignof] = ACTIONS(3314),
    [anon_sym__Alignof] = ACTIONS(3314),
    [anon_sym_offsetof] = ACTIONS(3314),
    [anon_sym__Generic] = ACTIONS(3314),
    [anon_sym_asm] = ACTIONS(3314),
    [anon_sym___asm__] = ACTIONS(3314),
    [aux_sym_number_literal_token1] = ACTIONS(3316),
    [aux_sym_number_literal_token2] = ACTIONS(3314),
    [anon_sym_L_SQUOTE] = ACTIONS(3316),
    [anon_sym_u_SQUOTE] = ACTIONS(3316),
    [anon_sym_U_SQUOTE] = ACTIONS(3316),
    [anon_sym_u8_SQUOTE] = ACTIONS(3316),
    [anon_sym_SQUOTE] = ACTIONS(3316),
    [anon_sym_L_DQUOTE] = ACTIONS(3316),
    [anon_sym_u_DQUOTE] = ACTIONS(3316),
    [anon_sym_U_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8_DQUOTE] = ACTIONS(3316),
    [anon_sym_DQUOTE] = ACTIONS(3316),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [anon_sym_NULL] = ACTIONS(3314),
    [anon_sym_nullptr] = ACTIONS(3314),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3314),
    [anon_sym_decltype] = ACTIONS(3314),
    [anon_sym_virtual] = ACTIONS(3314),
    [anon_sym_alignas] = ACTIONS(3314),
    [anon_sym_explicit] = ACTIONS(3314),
    [anon_sym_typename] = ACTIONS(3314),
    [anon_sym_template] = ACTIONS(3314),
    [anon_sym_operator] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_delete] = ACTIONS(3314),
    [anon_sym_throw] = ACTIONS(3314),
    [anon_sym_namespace] = ACTIONS(3314),
    [anon_sym_using] = ACTIONS(3314),
    [anon_sym_static_assert] = ACTIONS(3314),
    [anon_sym_concept] = ACTIONS(3314),
    [anon_sym_co_return] = ACTIONS(3314),
    [anon_sym_co_yield] = ACTIONS(3314),
    [anon_sym_R_DQUOTE] = ACTIONS(3316),
    [anon_sym_LR_DQUOTE] = ACTIONS(3316),
    [anon_sym_uR_DQUOTE] = ACTIONS(3316),
    [anon_sym_UR_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3316),
    [anon_sym_co_await] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_requires] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
  },
  [1054] = {
    [sym_preproc_def] = STATE(1019),
    [sym_preproc_function_def] = STATE(1019),
    [sym_preproc_call] = STATE(1019),
    [sym_preproc_if_in_field_declaration_list] = STATE(1019),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1019),
    [sym_type_definition] = STATE(1019),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1019),
    [sym_field_declaration] = STATE(1019),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1019),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1019),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1019),
    [sym_operator_cast_declaration] = STATE(1019),
    [sym_constructor_or_destructor_definition] = STATE(1019),
    [sym_constructor_or_destructor_declaration] = STATE(1019),
    [sym_friend_declaration] = STATE(1019),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1019),
    [sym_alias_declaration] = STATE(1019),
    [sym_static_assert_declaration] = STATE(1019),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1019),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3829),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3829),
    [sym_preproc_directive] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3833),
    [anon_sym_typedef] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3955),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_static_assert] = ACTIONS(3845),
  },
  [1055] = {
    [ts_builtin_sym_end] = ACTIONS(3326),
    [sym_identifier] = ACTIONS(3324),
    [aux_sym_preproc_include_token1] = ACTIONS(3324),
    [aux_sym_preproc_def_token1] = ACTIONS(3324),
    [aux_sym_preproc_if_token1] = ACTIONS(3324),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3324),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3324),
    [sym_preproc_directive] = ACTIONS(3324),
    [anon_sym_LPAREN2] = ACTIONS(3326),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_DASH] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3326),
    [anon_sym_AMP_AMP] = ACTIONS(3326),
    [anon_sym_AMP] = ACTIONS(3324),
    [anon_sym___extension__] = ACTIONS(3324),
    [anon_sym_typedef] = ACTIONS(3324),
    [anon_sym_extern] = ACTIONS(3324),
    [anon_sym___attribute__] = ACTIONS(3324),
    [anon_sym_COLON_COLON] = ACTIONS(3326),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3326),
    [anon_sym___declspec] = ACTIONS(3324),
    [anon_sym___based] = ACTIONS(3324),
    [anon_sym___cdecl] = ACTIONS(3324),
    [anon_sym___clrcall] = ACTIONS(3324),
    [anon_sym___stdcall] = ACTIONS(3324),
    [anon_sym___fastcall] = ACTIONS(3324),
    [anon_sym___thiscall] = ACTIONS(3324),
    [anon_sym___vectorcall] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3326),
    [anon_sym_signed] = ACTIONS(3324),
    [anon_sym_unsigned] = ACTIONS(3324),
    [anon_sym_long] = ACTIONS(3324),
    [anon_sym_short] = ACTIONS(3324),
    [anon_sym_LBRACK] = ACTIONS(3324),
    [anon_sym_static] = ACTIONS(3324),
    [anon_sym_register] = ACTIONS(3324),
    [anon_sym_inline] = ACTIONS(3324),
    [anon_sym___inline] = ACTIONS(3324),
    [anon_sym___inline__] = ACTIONS(3324),
    [anon_sym___forceinline] = ACTIONS(3324),
    [anon_sym_thread_local] = ACTIONS(3324),
    [anon_sym___thread] = ACTIONS(3324),
    [anon_sym_const] = ACTIONS(3324),
    [anon_sym_constexpr] = ACTIONS(3324),
    [anon_sym_volatile] = ACTIONS(3324),
    [anon_sym_restrict] = ACTIONS(3324),
    [anon_sym___restrict__] = ACTIONS(3324),
    [anon_sym__Atomic] = ACTIONS(3324),
    [anon_sym__Noreturn] = ACTIONS(3324),
    [anon_sym_noreturn] = ACTIONS(3324),
    [anon_sym_mutable] = ACTIONS(3324),
    [anon_sym_constinit] = ACTIONS(3324),
    [anon_sym_consteval] = ACTIONS(3324),
    [anon_sym_PROGMEM] = ACTIONS(3324),
    [aux_sym_primitive_type_token1] = ACTIONS(3324),
    [anon_sym_byte] = ACTIONS(3324),
    [anon_sym_word] = ACTIONS(3324),
    [anon_sym_enum] = ACTIONS(3324),
    [anon_sym_class] = ACTIONS(3324),
    [anon_sym_struct] = ACTIONS(3324),
    [anon_sym_union] = ACTIONS(3324),
    [anon_sym_if] = ACTIONS(3324),
    [anon_sym_switch] = ACTIONS(3324),
    [anon_sym_case] = ACTIONS(3324),
    [anon_sym_default] = ACTIONS(3324),
    [anon_sym_while] = ACTIONS(3324),
    [anon_sym_do] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3324),
    [anon_sym_return] = ACTIONS(3324),
    [anon_sym_break] = ACTIONS(3324),
    [anon_sym_continue] = ACTIONS(3324),
    [anon_sym_goto] = ACTIONS(3324),
    [anon_sym_not] = ACTIONS(3324),
    [anon_sym_compl] = ACTIONS(3324),
    [anon_sym_DASH_DASH] = ACTIONS(3326),
    [anon_sym_PLUS_PLUS] = ACTIONS(3326),
    [anon_sym_sizeof] = ACTIONS(3324),
    [anon_sym___alignof__] = ACTIONS(3324),
    [anon_sym___alignof] = ACTIONS(3324),
    [anon_sym__alignof] = ACTIONS(3324),
    [anon_sym_alignof] = ACTIONS(3324),
    [anon_sym__Alignof] = ACTIONS(3324),
    [anon_sym_offsetof] = ACTIONS(3324),
    [anon_sym__Generic] = ACTIONS(3324),
    [anon_sym_asm] = ACTIONS(3324),
    [anon_sym___asm__] = ACTIONS(3324),
    [aux_sym_number_literal_token1] = ACTIONS(3326),
    [aux_sym_number_literal_token2] = ACTIONS(3324),
    [anon_sym_L_SQUOTE] = ACTIONS(3326),
    [anon_sym_u_SQUOTE] = ACTIONS(3326),
    [anon_sym_U_SQUOTE] = ACTIONS(3326),
    [anon_sym_u8_SQUOTE] = ACTIONS(3326),
    [anon_sym_SQUOTE] = ACTIONS(3326),
    [anon_sym_L_DQUOTE] = ACTIONS(3326),
    [anon_sym_u_DQUOTE] = ACTIONS(3326),
    [anon_sym_U_DQUOTE] = ACTIONS(3326),
    [anon_sym_u8_DQUOTE] = ACTIONS(3326),
    [anon_sym_DQUOTE] = ACTIONS(3326),
    [sym_true] = ACTIONS(3324),
    [sym_false] = ACTIONS(3324),
    [anon_sym_NULL] = ACTIONS(3324),
    [anon_sym_nullptr] = ACTIONS(3324),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3324),
    [anon_sym_decltype] = ACTIONS(3324),
    [anon_sym_virtual] = ACTIONS(3324),
    [anon_sym_alignas] = ACTIONS(3324),
    [anon_sym_explicit] = ACTIONS(3324),
    [anon_sym_typename] = ACTIONS(3324),
    [anon_sym_template] = ACTIONS(3324),
    [anon_sym_operator] = ACTIONS(3324),
    [anon_sym_try] = ACTIONS(3324),
    [anon_sym_delete] = ACTIONS(3324),
    [anon_sym_throw] = ACTIONS(3324),
    [anon_sym_namespace] = ACTIONS(3324),
    [anon_sym_using] = ACTIONS(3324),
    [anon_sym_static_assert] = ACTIONS(3324),
    [anon_sym_concept] = ACTIONS(3324),
    [anon_sym_co_return] = ACTIONS(3324),
    [anon_sym_co_yield] = ACTIONS(3324),
    [anon_sym_R_DQUOTE] = ACTIONS(3326),
    [anon_sym_LR_DQUOTE] = ACTIONS(3326),
    [anon_sym_uR_DQUOTE] = ACTIONS(3326),
    [anon_sym_UR_DQUOTE] = ACTIONS(3326),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3326),
    [anon_sym_co_await] = ACTIONS(3324),
    [anon_sym_new] = ACTIONS(3324),
    [anon_sym_requires] = ACTIONS(3324),
    [sym_this] = ACTIONS(3324),
  },
  [1056] = {
    [sym_preproc_def] = STATE(1056),
    [sym_preproc_function_def] = STATE(1056),
    [sym_preproc_call] = STATE(1056),
    [sym_preproc_if_in_field_declaration_list] = STATE(1056),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1056),
    [sym_type_definition] = STATE(1056),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1056),
    [sym_field_declaration] = STATE(1056),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1056),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1056),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1056),
    [sym_operator_cast_declaration] = STATE(1056),
    [sym_constructor_or_destructor_definition] = STATE(1056),
    [sym_constructor_or_destructor_declaration] = STATE(1056),
    [sym_friend_declaration] = STATE(1056),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1056),
    [sym_alias_declaration] = STATE(1056),
    [sym_static_assert_declaration] = STATE(1056),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1056),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3605),
    [aux_sym_preproc_def_token1] = ACTIONS(3957),
    [aux_sym_preproc_if_token1] = ACTIONS(3960),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3963),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3963),
    [sym_preproc_directive] = ACTIONS(3966),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_TILDE] = ACTIONS(3625),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_AMP_AMP] = ACTIONS(3631),
    [anon_sym_AMP] = ACTIONS(3634),
    [anon_sym___extension__] = ACTIONS(3969),
    [anon_sym_typedef] = ACTIONS(3972),
    [anon_sym_extern] = ACTIONS(3643),
    [anon_sym___attribute__] = ACTIONS(3646),
    [anon_sym_COLON_COLON] = ACTIONS(3649),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3652),
    [anon_sym___declspec] = ACTIONS(3655),
    [anon_sym___based] = ACTIONS(3658),
    [anon_sym_RBRACE] = ACTIONS(3975),
    [anon_sym_signed] = ACTIONS(3661),
    [anon_sym_unsigned] = ACTIONS(3661),
    [anon_sym_long] = ACTIONS(3661),
    [anon_sym_short] = ACTIONS(3661),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_static] = ACTIONS(3643),
    [anon_sym_register] = ACTIONS(3643),
    [anon_sym_inline] = ACTIONS(3643),
    [anon_sym___inline] = ACTIONS(3643),
    [anon_sym___inline__] = ACTIONS(3643),
    [anon_sym___forceinline] = ACTIONS(3643),
    [anon_sym_thread_local] = ACTIONS(3643),
    [anon_sym___thread] = ACTIONS(3643),
    [anon_sym_const] = ACTIONS(3667),
    [anon_sym_constexpr] = ACTIONS(3667),
    [anon_sym_volatile] = ACTIONS(3667),
    [anon_sym_restrict] = ACTIONS(3667),
    [anon_sym___restrict__] = ACTIONS(3667),
    [anon_sym__Atomic] = ACTIONS(3667),
    [anon_sym__Noreturn] = ACTIONS(3667),
    [anon_sym_noreturn] = ACTIONS(3667),
    [anon_sym_mutable] = ACTIONS(3667),
    [anon_sym_constinit] = ACTIONS(3667),
    [anon_sym_consteval] = ACTIONS(3667),
    [anon_sym_PROGMEM] = ACTIONS(3667),
    [aux_sym_primitive_type_token1] = ACTIONS(3670),
    [anon_sym_byte] = ACTIONS(3670),
    [anon_sym_word] = ACTIONS(3670),
    [anon_sym_enum] = ACTIONS(3673),
    [anon_sym_class] = ACTIONS(3676),
    [anon_sym_struct] = ACTIONS(3679),
    [anon_sym_union] = ACTIONS(3682),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3685),
    [anon_sym_decltype] = ACTIONS(3688),
    [anon_sym_virtual] = ACTIONS(3691),
    [anon_sym_alignas] = ACTIONS(3694),
    [anon_sym_explicit] = ACTIONS(3697),
    [anon_sym_typename] = ACTIONS(3700),
    [anon_sym_template] = ACTIONS(3977),
    [anon_sym_operator] = ACTIONS(3706),
    [anon_sym_friend] = ACTIONS(3980),
    [anon_sym_public] = ACTIONS(3712),
    [anon_sym_private] = ACTIONS(3712),
    [anon_sym_protected] = ACTIONS(3712),
    [anon_sym_using] = ACTIONS(3983),
    [anon_sym_static_assert] = ACTIONS(3986),
  },
  [1057] = {
    [ts_builtin_sym_end] = ACTIONS(3312),
    [sym_identifier] = ACTIONS(3310),
    [aux_sym_preproc_include_token1] = ACTIONS(3310),
    [aux_sym_preproc_def_token1] = ACTIONS(3310),
    [aux_sym_preproc_if_token1] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3310),
    [sym_preproc_directive] = ACTIONS(3310),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_AMP_AMP] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3310),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_typedef] = ACTIONS(3310),
    [anon_sym_extern] = ACTIONS(3310),
    [anon_sym___attribute__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3312),
    [anon_sym___declspec] = ACTIONS(3310),
    [anon_sym___based] = ACTIONS(3310),
    [anon_sym___cdecl] = ACTIONS(3310),
    [anon_sym___clrcall] = ACTIONS(3310),
    [anon_sym___stdcall] = ACTIONS(3310),
    [anon_sym___fastcall] = ACTIONS(3310),
    [anon_sym___thiscall] = ACTIONS(3310),
    [anon_sym___vectorcall] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3312),
    [anon_sym_signed] = ACTIONS(3310),
    [anon_sym_unsigned] = ACTIONS(3310),
    [anon_sym_long] = ACTIONS(3310),
    [anon_sym_short] = ACTIONS(3310),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [anon_sym_static] = ACTIONS(3310),
    [anon_sym_register] = ACTIONS(3310),
    [anon_sym_inline] = ACTIONS(3310),
    [anon_sym___inline] = ACTIONS(3310),
    [anon_sym___inline__] = ACTIONS(3310),
    [anon_sym___forceinline] = ACTIONS(3310),
    [anon_sym_thread_local] = ACTIONS(3310),
    [anon_sym___thread] = ACTIONS(3310),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_constexpr] = ACTIONS(3310),
    [anon_sym_volatile] = ACTIONS(3310),
    [anon_sym_restrict] = ACTIONS(3310),
    [anon_sym___restrict__] = ACTIONS(3310),
    [anon_sym__Atomic] = ACTIONS(3310),
    [anon_sym__Noreturn] = ACTIONS(3310),
    [anon_sym_noreturn] = ACTIONS(3310),
    [anon_sym_mutable] = ACTIONS(3310),
    [anon_sym_constinit] = ACTIONS(3310),
    [anon_sym_consteval] = ACTIONS(3310),
    [anon_sym_PROGMEM] = ACTIONS(3310),
    [aux_sym_primitive_type_token1] = ACTIONS(3310),
    [anon_sym_byte] = ACTIONS(3310),
    [anon_sym_word] = ACTIONS(3310),
    [anon_sym_enum] = ACTIONS(3310),
    [anon_sym_class] = ACTIONS(3310),
    [anon_sym_struct] = ACTIONS(3310),
    [anon_sym_union] = ACTIONS(3310),
    [anon_sym_if] = ACTIONS(3310),
    [anon_sym_switch] = ACTIONS(3310),
    [anon_sym_case] = ACTIONS(3310),
    [anon_sym_default] = ACTIONS(3310),
    [anon_sym_while] = ACTIONS(3310),
    [anon_sym_do] = ACTIONS(3310),
    [anon_sym_for] = ACTIONS(3310),
    [anon_sym_return] = ACTIONS(3310),
    [anon_sym_break] = ACTIONS(3310),
    [anon_sym_continue] = ACTIONS(3310),
    [anon_sym_goto] = ACTIONS(3310),
    [anon_sym_not] = ACTIONS(3310),
    [anon_sym_compl] = ACTIONS(3310),
    [anon_sym_DASH_DASH] = ACTIONS(3312),
    [anon_sym_PLUS_PLUS] = ACTIONS(3312),
    [anon_sym_sizeof] = ACTIONS(3310),
    [anon_sym___alignof__] = ACTIONS(3310),
    [anon_sym___alignof] = ACTIONS(3310),
    [anon_sym__alignof] = ACTIONS(3310),
    [anon_sym_alignof] = ACTIONS(3310),
    [anon_sym__Alignof] = ACTIONS(3310),
    [anon_sym_offsetof] = ACTIONS(3310),
    [anon_sym__Generic] = ACTIONS(3310),
    [anon_sym_asm] = ACTIONS(3310),
    [anon_sym___asm__] = ACTIONS(3310),
    [aux_sym_number_literal_token1] = ACTIONS(3312),
    [aux_sym_number_literal_token2] = ACTIONS(3310),
    [anon_sym_L_SQUOTE] = ACTIONS(3312),
    [anon_sym_u_SQUOTE] = ACTIONS(3312),
    [anon_sym_U_SQUOTE] = ACTIONS(3312),
    [anon_sym_u8_SQUOTE] = ACTIONS(3312),
    [anon_sym_SQUOTE] = ACTIONS(3312),
    [anon_sym_L_DQUOTE] = ACTIONS(3312),
    [anon_sym_u_DQUOTE] = ACTIONS(3312),
    [anon_sym_U_DQUOTE] = ACTIONS(3312),
    [anon_sym_u8_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE] = ACTIONS(3312),
    [sym_true] = ACTIONS(3310),
    [sym_false] = ACTIONS(3310),
    [anon_sym_NULL] = ACTIONS(3310),
    [anon_sym_nullptr] = ACTIONS(3310),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3310),
    [anon_sym_decltype] = ACTIONS(3310),
    [anon_sym_virtual] = ACTIONS(3310),
    [anon_sym_alignas] = ACTIONS(3310),
    [anon_sym_explicit] = ACTIONS(3310),
    [anon_sym_typename] = ACTIONS(3310),
    [anon_sym_template] = ACTIONS(3310),
    [anon_sym_operator] = ACTIONS(3310),
    [anon_sym_try] = ACTIONS(3310),
    [anon_sym_delete] = ACTIONS(3310),
    [anon_sym_throw] = ACTIONS(3310),
    [anon_sym_namespace] = ACTIONS(3310),
    [anon_sym_using] = ACTIONS(3310),
    [anon_sym_static_assert] = ACTIONS(3310),
    [anon_sym_concept] = ACTIONS(3310),
    [anon_sym_co_return] = ACTIONS(3310),
    [anon_sym_co_yield] = ACTIONS(3310),
    [anon_sym_R_DQUOTE] = ACTIONS(3312),
    [anon_sym_LR_DQUOTE] = ACTIONS(3312),
    [anon_sym_uR_DQUOTE] = ACTIONS(3312),
    [anon_sym_UR_DQUOTE] = ACTIONS(3312),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3312),
    [anon_sym_co_await] = ACTIONS(3310),
    [anon_sym_new] = ACTIONS(3310),
    [anon_sym_requires] = ACTIONS(3310),
    [sym_this] = ACTIONS(3310),
  },
  [1058] = {
    [ts_builtin_sym_end] = ACTIONS(3421),
    [sym_identifier] = ACTIONS(3419),
    [aux_sym_preproc_include_token1] = ACTIONS(3419),
    [aux_sym_preproc_def_token1] = ACTIONS(3419),
    [aux_sym_preproc_if_token1] = ACTIONS(3419),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3419),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3419),
    [sym_preproc_directive] = ACTIONS(3419),
    [anon_sym_LPAREN2] = ACTIONS(3421),
    [anon_sym_BANG] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym___extension__] = ACTIONS(3419),
    [anon_sym_typedef] = ACTIONS(3419),
    [anon_sym_extern] = ACTIONS(3419),
    [anon_sym___attribute__] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3421),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3421),
    [anon_sym___declspec] = ACTIONS(3419),
    [anon_sym___based] = ACTIONS(3419),
    [anon_sym___cdecl] = ACTIONS(3419),
    [anon_sym___clrcall] = ACTIONS(3419),
    [anon_sym___stdcall] = ACTIONS(3419),
    [anon_sym___fastcall] = ACTIONS(3419),
    [anon_sym___thiscall] = ACTIONS(3419),
    [anon_sym___vectorcall] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_signed] = ACTIONS(3419),
    [anon_sym_unsigned] = ACTIONS(3419),
    [anon_sym_long] = ACTIONS(3419),
    [anon_sym_short] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_register] = ACTIONS(3419),
    [anon_sym_inline] = ACTIONS(3419),
    [anon_sym___inline] = ACTIONS(3419),
    [anon_sym___inline__] = ACTIONS(3419),
    [anon_sym___forceinline] = ACTIONS(3419),
    [anon_sym_thread_local] = ACTIONS(3419),
    [anon_sym___thread] = ACTIONS(3419),
    [anon_sym_const] = ACTIONS(3419),
    [anon_sym_constexpr] = ACTIONS(3419),
    [anon_sym_volatile] = ACTIONS(3419),
    [anon_sym_restrict] = ACTIONS(3419),
    [anon_sym___restrict__] = ACTIONS(3419),
    [anon_sym__Atomic] = ACTIONS(3419),
    [anon_sym__Noreturn] = ACTIONS(3419),
    [anon_sym_noreturn] = ACTIONS(3419),
    [anon_sym_mutable] = ACTIONS(3419),
    [anon_sym_constinit] = ACTIONS(3419),
    [anon_sym_consteval] = ACTIONS(3419),
    [anon_sym_PROGMEM] = ACTIONS(3419),
    [aux_sym_primitive_type_token1] = ACTIONS(3419),
    [anon_sym_byte] = ACTIONS(3419),
    [anon_sym_word] = ACTIONS(3419),
    [anon_sym_enum] = ACTIONS(3419),
    [anon_sym_class] = ACTIONS(3419),
    [anon_sym_struct] = ACTIONS(3419),
    [anon_sym_union] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_switch] = ACTIONS(3419),
    [anon_sym_case] = ACTIONS(3419),
    [anon_sym_default] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_break] = ACTIONS(3419),
    [anon_sym_continue] = ACTIONS(3419),
    [anon_sym_goto] = ACTIONS(3419),
    [anon_sym_not] = ACTIONS(3419),
    [anon_sym_compl] = ACTIONS(3419),
    [anon_sym_DASH_DASH] = ACTIONS(3421),
    [anon_sym_PLUS_PLUS] = ACTIONS(3421),
    [anon_sym_sizeof] = ACTIONS(3419),
    [anon_sym___alignof__] = ACTIONS(3419),
    [anon_sym___alignof] = ACTIONS(3419),
    [anon_sym__alignof] = ACTIONS(3419),
    [anon_sym_alignof] = ACTIONS(3419),
    [anon_sym__Alignof] = ACTIONS(3419),
    [anon_sym_offsetof] = ACTIONS(3419),
    [anon_sym__Generic] = ACTIONS(3419),
    [anon_sym_asm] = ACTIONS(3419),
    [anon_sym___asm__] = ACTIONS(3419),
    [aux_sym_number_literal_token1] = ACTIONS(3421),
    [aux_sym_number_literal_token2] = ACTIONS(3419),
    [anon_sym_L_SQUOTE] = ACTIONS(3421),
    [anon_sym_u_SQUOTE] = ACTIONS(3421),
    [anon_sym_U_SQUOTE] = ACTIONS(3421),
    [anon_sym_u8_SQUOTE] = ACTIONS(3421),
    [anon_sym_SQUOTE] = ACTIONS(3421),
    [anon_sym_L_DQUOTE] = ACTIONS(3421),
    [anon_sym_u_DQUOTE] = ACTIONS(3421),
    [anon_sym_U_DQUOTE] = ACTIONS(3421),
    [anon_sym_u8_DQUOTE] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [sym_true] = ACTIONS(3419),
    [sym_false] = ACTIONS(3419),
    [anon_sym_NULL] = ACTIONS(3419),
    [anon_sym_nullptr] = ACTIONS(3419),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3419),
    [anon_sym_decltype] = ACTIONS(3419),
    [anon_sym_virtual] = ACTIONS(3419),
    [anon_sym_alignas] = ACTIONS(3419),
    [anon_sym_explicit] = ACTIONS(3419),
    [anon_sym_typename] = ACTIONS(3419),
    [anon_sym_template] = ACTIONS(3419),
    [anon_sym_operator] = ACTIONS(3419),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_delete] = ACTIONS(3419),
    [anon_sym_throw] = ACTIONS(3419),
    [anon_sym_namespace] = ACTIONS(3419),
    [anon_sym_using] = ACTIONS(3419),
    [anon_sym_static_assert] = ACTIONS(3419),
    [anon_sym_concept] = ACTIONS(3419),
    [anon_sym_co_return] = ACTIONS(3419),
    [anon_sym_co_yield] = ACTIONS(3419),
    [anon_sym_R_DQUOTE] = ACTIONS(3421),
    [anon_sym_LR_DQUOTE] = ACTIONS(3421),
    [anon_sym_uR_DQUOTE] = ACTIONS(3421),
    [anon_sym_UR_DQUOTE] = ACTIONS(3421),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3421),
    [anon_sym_co_await] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_requires] = ACTIONS(3419),
    [sym_this] = ACTIONS(3419),
  },
  [1059] = {
    [ts_builtin_sym_end] = ACTIONS(3256),
    [sym_identifier] = ACTIONS(3254),
    [aux_sym_preproc_include_token1] = ACTIONS(3254),
    [aux_sym_preproc_def_token1] = ACTIONS(3254),
    [aux_sym_preproc_if_token1] = ACTIONS(3254),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3254),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3254),
    [sym_preproc_directive] = ACTIONS(3254),
    [anon_sym_LPAREN2] = ACTIONS(3256),
    [anon_sym_BANG] = ACTIONS(3256),
    [anon_sym_TILDE] = ACTIONS(3256),
    [anon_sym_DASH] = ACTIONS(3254),
    [anon_sym_PLUS] = ACTIONS(3254),
    [anon_sym_STAR] = ACTIONS(3256),
    [anon_sym_AMP_AMP] = ACTIONS(3256),
    [anon_sym_AMP] = ACTIONS(3254),
    [anon_sym___extension__] = ACTIONS(3254),
    [anon_sym_typedef] = ACTIONS(3254),
    [anon_sym_extern] = ACTIONS(3254),
    [anon_sym___attribute__] = ACTIONS(3254),
    [anon_sym_COLON_COLON] = ACTIONS(3256),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3256),
    [anon_sym___declspec] = ACTIONS(3254),
    [anon_sym___based] = ACTIONS(3254),
    [anon_sym___cdecl] = ACTIONS(3254),
    [anon_sym___clrcall] = ACTIONS(3254),
    [anon_sym___stdcall] = ACTIONS(3254),
    [anon_sym___fastcall] = ACTIONS(3254),
    [anon_sym___thiscall] = ACTIONS(3254),
    [anon_sym___vectorcall] = ACTIONS(3254),
    [anon_sym_LBRACE] = ACTIONS(3256),
    [anon_sym_signed] = ACTIONS(3254),
    [anon_sym_unsigned] = ACTIONS(3254),
    [anon_sym_long] = ACTIONS(3254),
    [anon_sym_short] = ACTIONS(3254),
    [anon_sym_LBRACK] = ACTIONS(3254),
    [anon_sym_static] = ACTIONS(3254),
    [anon_sym_register] = ACTIONS(3254),
    [anon_sym_inline] = ACTIONS(3254),
    [anon_sym___inline] = ACTIONS(3254),
    [anon_sym___inline__] = ACTIONS(3254),
    [anon_sym___forceinline] = ACTIONS(3254),
    [anon_sym_thread_local] = ACTIONS(3254),
    [anon_sym___thread] = ACTIONS(3254),
    [anon_sym_const] = ACTIONS(3254),
    [anon_sym_constexpr] = ACTIONS(3254),
    [anon_sym_volatile] = ACTIONS(3254),
    [anon_sym_restrict] = ACTIONS(3254),
    [anon_sym___restrict__] = ACTIONS(3254),
    [anon_sym__Atomic] = ACTIONS(3254),
    [anon_sym__Noreturn] = ACTIONS(3254),
    [anon_sym_noreturn] = ACTIONS(3254),
    [anon_sym_mutable] = ACTIONS(3254),
    [anon_sym_constinit] = ACTIONS(3254),
    [anon_sym_consteval] = ACTIONS(3254),
    [anon_sym_PROGMEM] = ACTIONS(3254),
    [aux_sym_primitive_type_token1] = ACTIONS(3254),
    [anon_sym_byte] = ACTIONS(3254),
    [anon_sym_word] = ACTIONS(3254),
    [anon_sym_enum] = ACTIONS(3254),
    [anon_sym_class] = ACTIONS(3254),
    [anon_sym_struct] = ACTIONS(3254),
    [anon_sym_union] = ACTIONS(3254),
    [anon_sym_if] = ACTIONS(3254),
    [anon_sym_switch] = ACTIONS(3254),
    [anon_sym_case] = ACTIONS(3254),
    [anon_sym_default] = ACTIONS(3254),
    [anon_sym_while] = ACTIONS(3254),
    [anon_sym_do] = ACTIONS(3254),
    [anon_sym_for] = ACTIONS(3254),
    [anon_sym_return] = ACTIONS(3254),
    [anon_sym_break] = ACTIONS(3254),
    [anon_sym_continue] = ACTIONS(3254),
    [anon_sym_goto] = ACTIONS(3254),
    [anon_sym_not] = ACTIONS(3254),
    [anon_sym_compl] = ACTIONS(3254),
    [anon_sym_DASH_DASH] = ACTIONS(3256),
    [anon_sym_PLUS_PLUS] = ACTIONS(3256),
    [anon_sym_sizeof] = ACTIONS(3254),
    [anon_sym___alignof__] = ACTIONS(3254),
    [anon_sym___alignof] = ACTIONS(3254),
    [anon_sym__alignof] = ACTIONS(3254),
    [anon_sym_alignof] = ACTIONS(3254),
    [anon_sym__Alignof] = ACTIONS(3254),
    [anon_sym_offsetof] = ACTIONS(3254),
    [anon_sym__Generic] = ACTIONS(3254),
    [anon_sym_asm] = ACTIONS(3254),
    [anon_sym___asm__] = ACTIONS(3254),
    [aux_sym_number_literal_token1] = ACTIONS(3256),
    [aux_sym_number_literal_token2] = ACTIONS(3254),
    [anon_sym_L_SQUOTE] = ACTIONS(3256),
    [anon_sym_u_SQUOTE] = ACTIONS(3256),
    [anon_sym_U_SQUOTE] = ACTIONS(3256),
    [anon_sym_u8_SQUOTE] = ACTIONS(3256),
    [anon_sym_SQUOTE] = ACTIONS(3256),
    [anon_sym_L_DQUOTE] = ACTIONS(3256),
    [anon_sym_u_DQUOTE] = ACTIONS(3256),
    [anon_sym_U_DQUOTE] = ACTIONS(3256),
    [anon_sym_u8_DQUOTE] = ACTIONS(3256),
    [anon_sym_DQUOTE] = ACTIONS(3256),
    [sym_true] = ACTIONS(3254),
    [sym_false] = ACTIONS(3254),
    [anon_sym_NULL] = ACTIONS(3254),
    [anon_sym_nullptr] = ACTIONS(3254),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3254),
    [anon_sym_decltype] = ACTIONS(3254),
    [anon_sym_virtual] = ACTIONS(3254),
    [anon_sym_alignas] = ACTIONS(3254),
    [anon_sym_explicit] = ACTIONS(3254),
    [anon_sym_typename] = ACTIONS(3254),
    [anon_sym_template] = ACTIONS(3254),
    [anon_sym_operator] = ACTIONS(3254),
    [anon_sym_try] = ACTIONS(3254),
    [anon_sym_delete] = ACTIONS(3254),
    [anon_sym_throw] = ACTIONS(3254),
    [anon_sym_namespace] = ACTIONS(3254),
    [anon_sym_using] = ACTIONS(3254),
    [anon_sym_static_assert] = ACTIONS(3254),
    [anon_sym_concept] = ACTIONS(3254),
    [anon_sym_co_return] = ACTIONS(3254),
    [anon_sym_co_yield] = ACTIONS(3254),
    [anon_sym_R_DQUOTE] = ACTIONS(3256),
    [anon_sym_LR_DQUOTE] = ACTIONS(3256),
    [anon_sym_uR_DQUOTE] = ACTIONS(3256),
    [anon_sym_UR_DQUOTE] = ACTIONS(3256),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3256),
    [anon_sym_co_await] = ACTIONS(3254),
    [anon_sym_new] = ACTIONS(3254),
    [anon_sym_requires] = ACTIONS(3254),
    [sym_this] = ACTIONS(3254),
  },
  [1060] = {
    [sym_preproc_def] = STATE(1050),
    [sym_preproc_function_def] = STATE(1050),
    [sym_preproc_call] = STATE(1050),
    [sym_preproc_if_in_field_declaration_list] = STATE(1050),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1050),
    [sym_type_definition] = STATE(1050),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1050),
    [sym_field_declaration] = STATE(1050),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1050),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1050),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1050),
    [sym_operator_cast_declaration] = STATE(1050),
    [sym_constructor_or_destructor_definition] = STATE(1050),
    [sym_constructor_or_destructor_declaration] = STATE(1050),
    [sym_friend_declaration] = STATE(1050),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1050),
    [sym_alias_declaration] = STATE(1050),
    [sym_static_assert_declaration] = STATE(1050),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1050),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3829),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3829),
    [sym_preproc_directive] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3833),
    [anon_sym_typedef] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3989),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_static_assert] = ACTIONS(3845),
  },
  [1061] = {
    [ts_builtin_sym_end] = ACTIONS(3194),
    [sym_identifier] = ACTIONS(3192),
    [aux_sym_preproc_include_token1] = ACTIONS(3192),
    [aux_sym_preproc_def_token1] = ACTIONS(3192),
    [aux_sym_preproc_if_token1] = ACTIONS(3192),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3192),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3192),
    [sym_preproc_directive] = ACTIONS(3192),
    [anon_sym_LPAREN2] = ACTIONS(3194),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_DASH] = ACTIONS(3192),
    [anon_sym_PLUS] = ACTIONS(3192),
    [anon_sym_STAR] = ACTIONS(3194),
    [anon_sym_AMP_AMP] = ACTIONS(3194),
    [anon_sym_AMP] = ACTIONS(3192),
    [anon_sym___extension__] = ACTIONS(3192),
    [anon_sym_typedef] = ACTIONS(3192),
    [anon_sym_extern] = ACTIONS(3192),
    [anon_sym___attribute__] = ACTIONS(3192),
    [anon_sym_COLON_COLON] = ACTIONS(3194),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3194),
    [anon_sym___declspec] = ACTIONS(3192),
    [anon_sym___based] = ACTIONS(3192),
    [anon_sym___cdecl] = ACTIONS(3192),
    [anon_sym___clrcall] = ACTIONS(3192),
    [anon_sym___stdcall] = ACTIONS(3192),
    [anon_sym___fastcall] = ACTIONS(3192),
    [anon_sym___thiscall] = ACTIONS(3192),
    [anon_sym___vectorcall] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_signed] = ACTIONS(3192),
    [anon_sym_unsigned] = ACTIONS(3192),
    [anon_sym_long] = ACTIONS(3192),
    [anon_sym_short] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [anon_sym_static] = ACTIONS(3192),
    [anon_sym_register] = ACTIONS(3192),
    [anon_sym_inline] = ACTIONS(3192),
    [anon_sym___inline] = ACTIONS(3192),
    [anon_sym___inline__] = ACTIONS(3192),
    [anon_sym___forceinline] = ACTIONS(3192),
    [anon_sym_thread_local] = ACTIONS(3192),
    [anon_sym___thread] = ACTIONS(3192),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_constexpr] = ACTIONS(3192),
    [anon_sym_volatile] = ACTIONS(3192),
    [anon_sym_restrict] = ACTIONS(3192),
    [anon_sym___restrict__] = ACTIONS(3192),
    [anon_sym__Atomic] = ACTIONS(3192),
    [anon_sym__Noreturn] = ACTIONS(3192),
    [anon_sym_noreturn] = ACTIONS(3192),
    [anon_sym_mutable] = ACTIONS(3192),
    [anon_sym_constinit] = ACTIONS(3192),
    [anon_sym_consteval] = ACTIONS(3192),
    [anon_sym_PROGMEM] = ACTIONS(3192),
    [aux_sym_primitive_type_token1] = ACTIONS(3192),
    [anon_sym_byte] = ACTIONS(3192),
    [anon_sym_word] = ACTIONS(3192),
    [anon_sym_enum] = ACTIONS(3192),
    [anon_sym_class] = ACTIONS(3192),
    [anon_sym_struct] = ACTIONS(3192),
    [anon_sym_union] = ACTIONS(3192),
    [anon_sym_if] = ACTIONS(3192),
    [anon_sym_switch] = ACTIONS(3192),
    [anon_sym_case] = ACTIONS(3192),
    [anon_sym_default] = ACTIONS(3192),
    [anon_sym_while] = ACTIONS(3192),
    [anon_sym_do] = ACTIONS(3192),
    [anon_sym_for] = ACTIONS(3192),
    [anon_sym_return] = ACTIONS(3192),
    [anon_sym_break] = ACTIONS(3192),
    [anon_sym_continue] = ACTIONS(3192),
    [anon_sym_goto] = ACTIONS(3192),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_compl] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3194),
    [anon_sym_PLUS_PLUS] = ACTIONS(3194),
    [anon_sym_sizeof] = ACTIONS(3192),
    [anon_sym___alignof__] = ACTIONS(3192),
    [anon_sym___alignof] = ACTIONS(3192),
    [anon_sym__alignof] = ACTIONS(3192),
    [anon_sym_alignof] = ACTIONS(3192),
    [anon_sym__Alignof] = ACTIONS(3192),
    [anon_sym_offsetof] = ACTIONS(3192),
    [anon_sym__Generic] = ACTIONS(3192),
    [anon_sym_asm] = ACTIONS(3192),
    [anon_sym___asm__] = ACTIONS(3192),
    [aux_sym_number_literal_token1] = ACTIONS(3194),
    [aux_sym_number_literal_token2] = ACTIONS(3192),
    [anon_sym_L_SQUOTE] = ACTIONS(3194),
    [anon_sym_u_SQUOTE] = ACTIONS(3194),
    [anon_sym_U_SQUOTE] = ACTIONS(3194),
    [anon_sym_u8_SQUOTE] = ACTIONS(3194),
    [anon_sym_SQUOTE] = ACTIONS(3194),
    [anon_sym_L_DQUOTE] = ACTIONS(3194),
    [anon_sym_u_DQUOTE] = ACTIONS(3194),
    [anon_sym_U_DQUOTE] = ACTIONS(3194),
    [anon_sym_u8_DQUOTE] = ACTIONS(3194),
    [anon_sym_DQUOTE] = ACTIONS(3194),
    [sym_true] = ACTIONS(3192),
    [sym_false] = ACTIONS(3192),
    [anon_sym_NULL] = ACTIONS(3192),
    [anon_sym_nullptr] = ACTIONS(3192),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3192),
    [anon_sym_decltype] = ACTIONS(3192),
    [anon_sym_virtual] = ACTIONS(3192),
    [anon_sym_alignas] = ACTIONS(3192),
    [anon_sym_explicit] = ACTIONS(3192),
    [anon_sym_typename] = ACTIONS(3192),
    [anon_sym_template] = ACTIONS(3192),
    [anon_sym_operator] = ACTIONS(3192),
    [anon_sym_try] = ACTIONS(3192),
    [anon_sym_delete] = ACTIONS(3192),
    [anon_sym_throw] = ACTIONS(3192),
    [anon_sym_namespace] = ACTIONS(3192),
    [anon_sym_using] = ACTIONS(3192),
    [anon_sym_static_assert] = ACTIONS(3192),
    [anon_sym_concept] = ACTIONS(3192),
    [anon_sym_co_return] = ACTIONS(3192),
    [anon_sym_co_yield] = ACTIONS(3192),
    [anon_sym_R_DQUOTE] = ACTIONS(3194),
    [anon_sym_LR_DQUOTE] = ACTIONS(3194),
    [anon_sym_uR_DQUOTE] = ACTIONS(3194),
    [anon_sym_UR_DQUOTE] = ACTIONS(3194),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3194),
    [anon_sym_co_await] = ACTIONS(3192),
    [anon_sym_new] = ACTIONS(3192),
    [anon_sym_requires] = ACTIONS(3192),
    [sym_this] = ACTIONS(3192),
  },
  [1062] = {
    [ts_builtin_sym_end] = ACTIONS(3425),
    [sym_identifier] = ACTIONS(3423),
    [aux_sym_preproc_include_token1] = ACTIONS(3423),
    [aux_sym_preproc_def_token1] = ACTIONS(3423),
    [aux_sym_preproc_if_token1] = ACTIONS(3423),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3423),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3423),
    [sym_preproc_directive] = ACTIONS(3423),
    [anon_sym_LPAREN2] = ACTIONS(3425),
    [anon_sym_BANG] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [anon_sym_DASH] = ACTIONS(3423),
    [anon_sym_PLUS] = ACTIONS(3423),
    [anon_sym_STAR] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3423),
    [anon_sym___extension__] = ACTIONS(3423),
    [anon_sym_typedef] = ACTIONS(3423),
    [anon_sym_extern] = ACTIONS(3423),
    [anon_sym___attribute__] = ACTIONS(3423),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3425),
    [anon_sym___declspec] = ACTIONS(3423),
    [anon_sym___based] = ACTIONS(3423),
    [anon_sym___cdecl] = ACTIONS(3423),
    [anon_sym___clrcall] = ACTIONS(3423),
    [anon_sym___stdcall] = ACTIONS(3423),
    [anon_sym___fastcall] = ACTIONS(3423),
    [anon_sym___thiscall] = ACTIONS(3423),
    [anon_sym___vectorcall] = ACTIONS(3423),
    [anon_sym_LBRACE] = ACTIONS(3425),
    [anon_sym_signed] = ACTIONS(3423),
    [anon_sym_unsigned] = ACTIONS(3423),
    [anon_sym_long] = ACTIONS(3423),
    [anon_sym_short] = ACTIONS(3423),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_static] = ACTIONS(3423),
    [anon_sym_register] = ACTIONS(3423),
    [anon_sym_inline] = ACTIONS(3423),
    [anon_sym___inline] = ACTIONS(3423),
    [anon_sym___inline__] = ACTIONS(3423),
    [anon_sym___forceinline] = ACTIONS(3423),
    [anon_sym_thread_local] = ACTIONS(3423),
    [anon_sym___thread] = ACTIONS(3423),
    [anon_sym_const] = ACTIONS(3423),
    [anon_sym_constexpr] = ACTIONS(3423),
    [anon_sym_volatile] = ACTIONS(3423),
    [anon_sym_restrict] = ACTIONS(3423),
    [anon_sym___restrict__] = ACTIONS(3423),
    [anon_sym__Atomic] = ACTIONS(3423),
    [anon_sym__Noreturn] = ACTIONS(3423),
    [anon_sym_noreturn] = ACTIONS(3423),
    [anon_sym_mutable] = ACTIONS(3423),
    [anon_sym_constinit] = ACTIONS(3423),
    [anon_sym_consteval] = ACTIONS(3423),
    [anon_sym_PROGMEM] = ACTIONS(3423),
    [aux_sym_primitive_type_token1] = ACTIONS(3423),
    [anon_sym_byte] = ACTIONS(3423),
    [anon_sym_word] = ACTIONS(3423),
    [anon_sym_enum] = ACTIONS(3423),
    [anon_sym_class] = ACTIONS(3423),
    [anon_sym_struct] = ACTIONS(3423),
    [anon_sym_union] = ACTIONS(3423),
    [anon_sym_if] = ACTIONS(3423),
    [anon_sym_switch] = ACTIONS(3423),
    [anon_sym_case] = ACTIONS(3423),
    [anon_sym_default] = ACTIONS(3423),
    [anon_sym_while] = ACTIONS(3423),
    [anon_sym_do] = ACTIONS(3423),
    [anon_sym_for] = ACTIONS(3423),
    [anon_sym_return] = ACTIONS(3423),
    [anon_sym_break] = ACTIONS(3423),
    [anon_sym_continue] = ACTIONS(3423),
    [anon_sym_goto] = ACTIONS(3423),
    [anon_sym_not] = ACTIONS(3423),
    [anon_sym_compl] = ACTIONS(3423),
    [anon_sym_DASH_DASH] = ACTIONS(3425),
    [anon_sym_PLUS_PLUS] = ACTIONS(3425),
    [anon_sym_sizeof] = ACTIONS(3423),
    [anon_sym___alignof__] = ACTIONS(3423),
    [anon_sym___alignof] = ACTIONS(3423),
    [anon_sym__alignof] = ACTIONS(3423),
    [anon_sym_alignof] = ACTIONS(3423),
    [anon_sym__Alignof] = ACTIONS(3423),
    [anon_sym_offsetof] = ACTIONS(3423),
    [anon_sym__Generic] = ACTIONS(3423),
    [anon_sym_asm] = ACTIONS(3423),
    [anon_sym___asm__] = ACTIONS(3423),
    [aux_sym_number_literal_token1] = ACTIONS(3425),
    [aux_sym_number_literal_token2] = ACTIONS(3423),
    [anon_sym_L_SQUOTE] = ACTIONS(3425),
    [anon_sym_u_SQUOTE] = ACTIONS(3425),
    [anon_sym_U_SQUOTE] = ACTIONS(3425),
    [anon_sym_u8_SQUOTE] = ACTIONS(3425),
    [anon_sym_SQUOTE] = ACTIONS(3425),
    [anon_sym_L_DQUOTE] = ACTIONS(3425),
    [anon_sym_u_DQUOTE] = ACTIONS(3425),
    [anon_sym_U_DQUOTE] = ACTIONS(3425),
    [anon_sym_u8_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [sym_true] = ACTIONS(3423),
    [sym_false] = ACTIONS(3423),
    [anon_sym_NULL] = ACTIONS(3423),
    [anon_sym_nullptr] = ACTIONS(3423),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3423),
    [anon_sym_decltype] = ACTIONS(3423),
    [anon_sym_virtual] = ACTIONS(3423),
    [anon_sym_alignas] = ACTIONS(3423),
    [anon_sym_explicit] = ACTIONS(3423),
    [anon_sym_typename] = ACTIONS(3423),
    [anon_sym_template] = ACTIONS(3423),
    [anon_sym_operator] = ACTIONS(3423),
    [anon_sym_try] = ACTIONS(3423),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_throw] = ACTIONS(3423),
    [anon_sym_namespace] = ACTIONS(3423),
    [anon_sym_using] = ACTIONS(3423),
    [anon_sym_static_assert] = ACTIONS(3423),
    [anon_sym_concept] = ACTIONS(3423),
    [anon_sym_co_return] = ACTIONS(3423),
    [anon_sym_co_yield] = ACTIONS(3423),
    [anon_sym_R_DQUOTE] = ACTIONS(3425),
    [anon_sym_LR_DQUOTE] = ACTIONS(3425),
    [anon_sym_uR_DQUOTE] = ACTIONS(3425),
    [anon_sym_UR_DQUOTE] = ACTIONS(3425),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3425),
    [anon_sym_co_await] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3423),
    [anon_sym_requires] = ACTIONS(3423),
    [sym_this] = ACTIONS(3423),
  },
  [1063] = {
    [ts_builtin_sym_end] = ACTIONS(3527),
    [sym_identifier] = ACTIONS(3525),
    [aux_sym_preproc_include_token1] = ACTIONS(3525),
    [aux_sym_preproc_def_token1] = ACTIONS(3525),
    [aux_sym_preproc_if_token1] = ACTIONS(3525),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3525),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3525),
    [sym_preproc_directive] = ACTIONS(3525),
    [anon_sym_LPAREN2] = ACTIONS(3527),
    [anon_sym_BANG] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3525),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_AMP] = ACTIONS(3525),
    [anon_sym___extension__] = ACTIONS(3525),
    [anon_sym_typedef] = ACTIONS(3525),
    [anon_sym_extern] = ACTIONS(3525),
    [anon_sym___attribute__] = ACTIONS(3525),
    [anon_sym_COLON_COLON] = ACTIONS(3527),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3527),
    [anon_sym___declspec] = ACTIONS(3525),
    [anon_sym___based] = ACTIONS(3525),
    [anon_sym___cdecl] = ACTIONS(3525),
    [anon_sym___clrcall] = ACTIONS(3525),
    [anon_sym___stdcall] = ACTIONS(3525),
    [anon_sym___fastcall] = ACTIONS(3525),
    [anon_sym___thiscall] = ACTIONS(3525),
    [anon_sym___vectorcall] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_signed] = ACTIONS(3525),
    [anon_sym_unsigned] = ACTIONS(3525),
    [anon_sym_long] = ACTIONS(3525),
    [anon_sym_short] = ACTIONS(3525),
    [anon_sym_LBRACK] = ACTIONS(3525),
    [anon_sym_static] = ACTIONS(3525),
    [anon_sym_register] = ACTIONS(3525),
    [anon_sym_inline] = ACTIONS(3525),
    [anon_sym___inline] = ACTIONS(3525),
    [anon_sym___inline__] = ACTIONS(3525),
    [anon_sym___forceinline] = ACTIONS(3525),
    [anon_sym_thread_local] = ACTIONS(3525),
    [anon_sym___thread] = ACTIONS(3525),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_constexpr] = ACTIONS(3525),
    [anon_sym_volatile] = ACTIONS(3525),
    [anon_sym_restrict] = ACTIONS(3525),
    [anon_sym___restrict__] = ACTIONS(3525),
    [anon_sym__Atomic] = ACTIONS(3525),
    [anon_sym__Noreturn] = ACTIONS(3525),
    [anon_sym_noreturn] = ACTIONS(3525),
    [anon_sym_mutable] = ACTIONS(3525),
    [anon_sym_constinit] = ACTIONS(3525),
    [anon_sym_consteval] = ACTIONS(3525),
    [anon_sym_PROGMEM] = ACTIONS(3525),
    [aux_sym_primitive_type_token1] = ACTIONS(3525),
    [anon_sym_byte] = ACTIONS(3525),
    [anon_sym_word] = ACTIONS(3525),
    [anon_sym_enum] = ACTIONS(3525),
    [anon_sym_class] = ACTIONS(3525),
    [anon_sym_struct] = ACTIONS(3525),
    [anon_sym_union] = ACTIONS(3525),
    [anon_sym_if] = ACTIONS(3525),
    [anon_sym_switch] = ACTIONS(3525),
    [anon_sym_case] = ACTIONS(3525),
    [anon_sym_default] = ACTIONS(3525),
    [anon_sym_while] = ACTIONS(3525),
    [anon_sym_do] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3525),
    [anon_sym_return] = ACTIONS(3525),
    [anon_sym_break] = ACTIONS(3525),
    [anon_sym_continue] = ACTIONS(3525),
    [anon_sym_goto] = ACTIONS(3525),
    [anon_sym_not] = ACTIONS(3525),
    [anon_sym_compl] = ACTIONS(3525),
    [anon_sym_DASH_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_PLUS] = ACTIONS(3527),
    [anon_sym_sizeof] = ACTIONS(3525),
    [anon_sym___alignof__] = ACTIONS(3525),
    [anon_sym___alignof] = ACTIONS(3525),
    [anon_sym__alignof] = ACTIONS(3525),
    [anon_sym_alignof] = ACTIONS(3525),
    [anon_sym__Alignof] = ACTIONS(3525),
    [anon_sym_offsetof] = ACTIONS(3525),
    [anon_sym__Generic] = ACTIONS(3525),
    [anon_sym_asm] = ACTIONS(3525),
    [anon_sym___asm__] = ACTIONS(3525),
    [aux_sym_number_literal_token1] = ACTIONS(3527),
    [aux_sym_number_literal_token2] = ACTIONS(3525),
    [anon_sym_L_SQUOTE] = ACTIONS(3527),
    [anon_sym_u_SQUOTE] = ACTIONS(3527),
    [anon_sym_U_SQUOTE] = ACTIONS(3527),
    [anon_sym_u8_SQUOTE] = ACTIONS(3527),
    [anon_sym_SQUOTE] = ACTIONS(3527),
    [anon_sym_L_DQUOTE] = ACTIONS(3527),
    [anon_sym_u_DQUOTE] = ACTIONS(3527),
    [anon_sym_U_DQUOTE] = ACTIONS(3527),
    [anon_sym_u8_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [sym_true] = ACTIONS(3525),
    [sym_false] = ACTIONS(3525),
    [anon_sym_NULL] = ACTIONS(3525),
    [anon_sym_nullptr] = ACTIONS(3525),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3525),
    [anon_sym_decltype] = ACTIONS(3525),
    [anon_sym_virtual] = ACTIONS(3525),
    [anon_sym_alignas] = ACTIONS(3525),
    [anon_sym_explicit] = ACTIONS(3525),
    [anon_sym_typename] = ACTIONS(3525),
    [anon_sym_template] = ACTIONS(3525),
    [anon_sym_operator] = ACTIONS(3525),
    [anon_sym_try] = ACTIONS(3525),
    [anon_sym_delete] = ACTIONS(3525),
    [anon_sym_throw] = ACTIONS(3525),
    [anon_sym_namespace] = ACTIONS(3525),
    [anon_sym_using] = ACTIONS(3525),
    [anon_sym_static_assert] = ACTIONS(3525),
    [anon_sym_concept] = ACTIONS(3525),
    [anon_sym_co_return] = ACTIONS(3525),
    [anon_sym_co_yield] = ACTIONS(3525),
    [anon_sym_R_DQUOTE] = ACTIONS(3527),
    [anon_sym_LR_DQUOTE] = ACTIONS(3527),
    [anon_sym_uR_DQUOTE] = ACTIONS(3527),
    [anon_sym_UR_DQUOTE] = ACTIONS(3527),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3527),
    [anon_sym_co_await] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3525),
    [anon_sym_requires] = ACTIONS(3525),
    [sym_this] = ACTIONS(3525),
  },
  [1064] = {
    [ts_builtin_sym_end] = ACTIONS(3373),
    [sym_identifier] = ACTIONS(3371),
    [aux_sym_preproc_include_token1] = ACTIONS(3371),
    [aux_sym_preproc_def_token1] = ACTIONS(3371),
    [aux_sym_preproc_if_token1] = ACTIONS(3371),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3371),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3371),
    [sym_preproc_directive] = ACTIONS(3371),
    [anon_sym_LPAREN2] = ACTIONS(3373),
    [anon_sym_BANG] = ACTIONS(3373),
    [anon_sym_TILDE] = ACTIONS(3373),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_STAR] = ACTIONS(3373),
    [anon_sym_AMP_AMP] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3371),
    [anon_sym___extension__] = ACTIONS(3371),
    [anon_sym_typedef] = ACTIONS(3371),
    [anon_sym_extern] = ACTIONS(3371),
    [anon_sym___attribute__] = ACTIONS(3371),
    [anon_sym_COLON_COLON] = ACTIONS(3373),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3373),
    [anon_sym___declspec] = ACTIONS(3371),
    [anon_sym___based] = ACTIONS(3371),
    [anon_sym___cdecl] = ACTIONS(3371),
    [anon_sym___clrcall] = ACTIONS(3371),
    [anon_sym___stdcall] = ACTIONS(3371),
    [anon_sym___fastcall] = ACTIONS(3371),
    [anon_sym___thiscall] = ACTIONS(3371),
    [anon_sym___vectorcall] = ACTIONS(3371),
    [anon_sym_LBRACE] = ACTIONS(3373),
    [anon_sym_signed] = ACTIONS(3371),
    [anon_sym_unsigned] = ACTIONS(3371),
    [anon_sym_long] = ACTIONS(3371),
    [anon_sym_short] = ACTIONS(3371),
    [anon_sym_LBRACK] = ACTIONS(3371),
    [anon_sym_static] = ACTIONS(3371),
    [anon_sym_register] = ACTIONS(3371),
    [anon_sym_inline] = ACTIONS(3371),
    [anon_sym___inline] = ACTIONS(3371),
    [anon_sym___inline__] = ACTIONS(3371),
    [anon_sym___forceinline] = ACTIONS(3371),
    [anon_sym_thread_local] = ACTIONS(3371),
    [anon_sym___thread] = ACTIONS(3371),
    [anon_sym_const] = ACTIONS(3371),
    [anon_sym_constexpr] = ACTIONS(3371),
    [anon_sym_volatile] = ACTIONS(3371),
    [anon_sym_restrict] = ACTIONS(3371),
    [anon_sym___restrict__] = ACTIONS(3371),
    [anon_sym__Atomic] = ACTIONS(3371),
    [anon_sym__Noreturn] = ACTIONS(3371),
    [anon_sym_noreturn] = ACTIONS(3371),
    [anon_sym_mutable] = ACTIONS(3371),
    [anon_sym_constinit] = ACTIONS(3371),
    [anon_sym_consteval] = ACTIONS(3371),
    [anon_sym_PROGMEM] = ACTIONS(3371),
    [aux_sym_primitive_type_token1] = ACTIONS(3371),
    [anon_sym_byte] = ACTIONS(3371),
    [anon_sym_word] = ACTIONS(3371),
    [anon_sym_enum] = ACTIONS(3371),
    [anon_sym_class] = ACTIONS(3371),
    [anon_sym_struct] = ACTIONS(3371),
    [anon_sym_union] = ACTIONS(3371),
    [anon_sym_if] = ACTIONS(3371),
    [anon_sym_switch] = ACTIONS(3371),
    [anon_sym_case] = ACTIONS(3371),
    [anon_sym_default] = ACTIONS(3371),
    [anon_sym_while] = ACTIONS(3371),
    [anon_sym_do] = ACTIONS(3371),
    [anon_sym_for] = ACTIONS(3371),
    [anon_sym_return] = ACTIONS(3371),
    [anon_sym_break] = ACTIONS(3371),
    [anon_sym_continue] = ACTIONS(3371),
    [anon_sym_goto] = ACTIONS(3371),
    [anon_sym_not] = ACTIONS(3371),
    [anon_sym_compl] = ACTIONS(3371),
    [anon_sym_DASH_DASH] = ACTIONS(3373),
    [anon_sym_PLUS_PLUS] = ACTIONS(3373),
    [anon_sym_sizeof] = ACTIONS(3371),
    [anon_sym___alignof__] = ACTIONS(3371),
    [anon_sym___alignof] = ACTIONS(3371),
    [anon_sym__alignof] = ACTIONS(3371),
    [anon_sym_alignof] = ACTIONS(3371),
    [anon_sym__Alignof] = ACTIONS(3371),
    [anon_sym_offsetof] = ACTIONS(3371),
    [anon_sym__Generic] = ACTIONS(3371),
    [anon_sym_asm] = ACTIONS(3371),
    [anon_sym___asm__] = ACTIONS(3371),
    [aux_sym_number_literal_token1] = ACTIONS(3373),
    [aux_sym_number_literal_token2] = ACTIONS(3371),
    [anon_sym_L_SQUOTE] = ACTIONS(3373),
    [anon_sym_u_SQUOTE] = ACTIONS(3373),
    [anon_sym_U_SQUOTE] = ACTIONS(3373),
    [anon_sym_u8_SQUOTE] = ACTIONS(3373),
    [anon_sym_SQUOTE] = ACTIONS(3373),
    [anon_sym_L_DQUOTE] = ACTIONS(3373),
    [anon_sym_u_DQUOTE] = ACTIONS(3373),
    [anon_sym_U_DQUOTE] = ACTIONS(3373),
    [anon_sym_u8_DQUOTE] = ACTIONS(3373),
    [anon_sym_DQUOTE] = ACTIONS(3373),
    [sym_true] = ACTIONS(3371),
    [sym_false] = ACTIONS(3371),
    [anon_sym_NULL] = ACTIONS(3371),
    [anon_sym_nullptr] = ACTIONS(3371),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3371),
    [anon_sym_decltype] = ACTIONS(3371),
    [anon_sym_virtual] = ACTIONS(3371),
    [anon_sym_alignas] = ACTIONS(3371),
    [anon_sym_explicit] = ACTIONS(3371),
    [anon_sym_typename] = ACTIONS(3371),
    [anon_sym_template] = ACTIONS(3371),
    [anon_sym_operator] = ACTIONS(3371),
    [anon_sym_try] = ACTIONS(3371),
    [anon_sym_delete] = ACTIONS(3371),
    [anon_sym_throw] = ACTIONS(3371),
    [anon_sym_namespace] = ACTIONS(3371),
    [anon_sym_using] = ACTIONS(3371),
    [anon_sym_static_assert] = ACTIONS(3371),
    [anon_sym_concept] = ACTIONS(3371),
    [anon_sym_co_return] = ACTIONS(3371),
    [anon_sym_co_yield] = ACTIONS(3371),
    [anon_sym_R_DQUOTE] = ACTIONS(3373),
    [anon_sym_LR_DQUOTE] = ACTIONS(3373),
    [anon_sym_uR_DQUOTE] = ACTIONS(3373),
    [anon_sym_UR_DQUOTE] = ACTIONS(3373),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3373),
    [anon_sym_co_await] = ACTIONS(3371),
    [anon_sym_new] = ACTIONS(3371),
    [anon_sym_requires] = ACTIONS(3371),
    [sym_this] = ACTIONS(3371),
  },
  [1065] = {
    [ts_builtin_sym_end] = ACTIONS(3991),
    [sym_identifier] = ACTIONS(3993),
    [aux_sym_preproc_include_token1] = ACTIONS(3993),
    [aux_sym_preproc_def_token1] = ACTIONS(3993),
    [aux_sym_preproc_if_token1] = ACTIONS(3993),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3993),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3993),
    [sym_preproc_directive] = ACTIONS(3993),
    [anon_sym_LPAREN2] = ACTIONS(3991),
    [anon_sym_BANG] = ACTIONS(3991),
    [anon_sym_TILDE] = ACTIONS(3991),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym___extension__] = ACTIONS(3993),
    [anon_sym_typedef] = ACTIONS(3993),
    [anon_sym_extern] = ACTIONS(3993),
    [anon_sym___attribute__] = ACTIONS(3993),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3991),
    [anon_sym___declspec] = ACTIONS(3993),
    [anon_sym___based] = ACTIONS(3993),
    [anon_sym___cdecl] = ACTIONS(3993),
    [anon_sym___clrcall] = ACTIONS(3993),
    [anon_sym___stdcall] = ACTIONS(3993),
    [anon_sym___fastcall] = ACTIONS(3993),
    [anon_sym___thiscall] = ACTIONS(3993),
    [anon_sym___vectorcall] = ACTIONS(3993),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_signed] = ACTIONS(3993),
    [anon_sym_unsigned] = ACTIONS(3993),
    [anon_sym_long] = ACTIONS(3993),
    [anon_sym_short] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3993),
    [anon_sym_static] = ACTIONS(3993),
    [anon_sym_register] = ACTIONS(3993),
    [anon_sym_inline] = ACTIONS(3993),
    [anon_sym___inline] = ACTIONS(3993),
    [anon_sym___inline__] = ACTIONS(3993),
    [anon_sym___forceinline] = ACTIONS(3993),
    [anon_sym_thread_local] = ACTIONS(3993),
    [anon_sym___thread] = ACTIONS(3993),
    [anon_sym_const] = ACTIONS(3993),
    [anon_sym_constexpr] = ACTIONS(3993),
    [anon_sym_volatile] = ACTIONS(3993),
    [anon_sym_restrict] = ACTIONS(3993),
    [anon_sym___restrict__] = ACTIONS(3993),
    [anon_sym__Atomic] = ACTIONS(3993),
    [anon_sym__Noreturn] = ACTIONS(3993),
    [anon_sym_noreturn] = ACTIONS(3993),
    [anon_sym_mutable] = ACTIONS(3993),
    [anon_sym_constinit] = ACTIONS(3993),
    [anon_sym_consteval] = ACTIONS(3993),
    [anon_sym_PROGMEM] = ACTIONS(3993),
    [aux_sym_primitive_type_token1] = ACTIONS(3993),
    [anon_sym_byte] = ACTIONS(3993),
    [anon_sym_word] = ACTIONS(3993),
    [anon_sym_enum] = ACTIONS(3993),
    [anon_sym_class] = ACTIONS(3993),
    [anon_sym_struct] = ACTIONS(3993),
    [anon_sym_union] = ACTIONS(3993),
    [anon_sym_if] = ACTIONS(3993),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_case] = ACTIONS(3993),
    [anon_sym_default] = ACTIONS(3993),
    [anon_sym_while] = ACTIONS(3993),
    [anon_sym_do] = ACTIONS(3993),
    [anon_sym_for] = ACTIONS(3993),
    [anon_sym_return] = ACTIONS(3993),
    [anon_sym_break] = ACTIONS(3993),
    [anon_sym_continue] = ACTIONS(3993),
    [anon_sym_goto] = ACTIONS(3993),
    [anon_sym_not] = ACTIONS(3993),
    [anon_sym_compl] = ACTIONS(3993),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_sizeof] = ACTIONS(3993),
    [anon_sym___alignof__] = ACTIONS(3993),
    [anon_sym___alignof] = ACTIONS(3993),
    [anon_sym__alignof] = ACTIONS(3993),
    [anon_sym_alignof] = ACTIONS(3993),
    [anon_sym__Alignof] = ACTIONS(3993),
    [anon_sym_offsetof] = ACTIONS(3993),
    [anon_sym__Generic] = ACTIONS(3993),
    [anon_sym_asm] = ACTIONS(3993),
    [anon_sym___asm__] = ACTIONS(3993),
    [aux_sym_number_literal_token1] = ACTIONS(3991),
    [aux_sym_number_literal_token2] = ACTIONS(3993),
    [anon_sym_L_SQUOTE] = ACTIONS(3991),
    [anon_sym_u_SQUOTE] = ACTIONS(3991),
    [anon_sym_U_SQUOTE] = ACTIONS(3991),
    [anon_sym_u8_SQUOTE] = ACTIONS(3991),
    [anon_sym_SQUOTE] = ACTIONS(3991),
    [anon_sym_L_DQUOTE] = ACTIONS(3991),
    [anon_sym_u_DQUOTE] = ACTIONS(3991),
    [anon_sym_U_DQUOTE] = ACTIONS(3991),
    [anon_sym_u8_DQUOTE] = ACTIONS(3991),
    [anon_sym_DQUOTE] = ACTIONS(3991),
    [sym_true] = ACTIONS(3993),
    [sym_false] = ACTIONS(3993),
    [anon_sym_NULL] = ACTIONS(3993),
    [anon_sym_nullptr] = ACTIONS(3993),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3993),
    [anon_sym_decltype] = ACTIONS(3993),
    [anon_sym_virtual] = ACTIONS(3993),
    [anon_sym_alignas] = ACTIONS(3993),
    [anon_sym_explicit] = ACTIONS(3993),
    [anon_sym_typename] = ACTIONS(3993),
    [anon_sym_template] = ACTIONS(3993),
    [anon_sym_operator] = ACTIONS(3993),
    [anon_sym_try] = ACTIONS(3993),
    [anon_sym_delete] = ACTIONS(3993),
    [anon_sym_throw] = ACTIONS(3993),
    [anon_sym_namespace] = ACTIONS(3993),
    [anon_sym_using] = ACTIONS(3993),
    [anon_sym_static_assert] = ACTIONS(3993),
    [anon_sym_concept] = ACTIONS(3993),
    [anon_sym_co_return] = ACTIONS(3993),
    [anon_sym_co_yield] = ACTIONS(3993),
    [anon_sym_R_DQUOTE] = ACTIONS(3991),
    [anon_sym_LR_DQUOTE] = ACTIONS(3991),
    [anon_sym_uR_DQUOTE] = ACTIONS(3991),
    [anon_sym_UR_DQUOTE] = ACTIONS(3991),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3991),
    [anon_sym_co_await] = ACTIONS(3993),
    [anon_sym_new] = ACTIONS(3993),
    [anon_sym_requires] = ACTIONS(3993),
    [sym_this] = ACTIONS(3993),
  },
  [1066] = {
    [sym_preproc_def] = STATE(1056),
    [sym_preproc_function_def] = STATE(1056),
    [sym_preproc_call] = STATE(1056),
    [sym_preproc_if_in_field_declaration_list] = STATE(1056),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1056),
    [sym_type_definition] = STATE(1056),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1056),
    [sym_field_declaration] = STATE(1056),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1056),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1056),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1056),
    [sym_operator_cast_declaration] = STATE(1056),
    [sym_constructor_or_destructor_definition] = STATE(1056),
    [sym_constructor_or_destructor_declaration] = STATE(1056),
    [sym_friend_declaration] = STATE(1056),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1056),
    [sym_alias_declaration] = STATE(1056),
    [sym_static_assert_declaration] = STATE(1056),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1056),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3829),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3829),
    [sym_preproc_directive] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3833),
    [anon_sym_typedef] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3995),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_static_assert] = ACTIONS(3845),
  },
  [1067] = {
    [ts_builtin_sym_end] = ACTIONS(3377),
    [sym_identifier] = ACTIONS(3375),
    [aux_sym_preproc_include_token1] = ACTIONS(3375),
    [aux_sym_preproc_def_token1] = ACTIONS(3375),
    [aux_sym_preproc_if_token1] = ACTIONS(3375),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3375),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3375),
    [sym_preproc_directive] = ACTIONS(3375),
    [anon_sym_LPAREN2] = ACTIONS(3377),
    [anon_sym_BANG] = ACTIONS(3377),
    [anon_sym_TILDE] = ACTIONS(3377),
    [anon_sym_DASH] = ACTIONS(3375),
    [anon_sym_PLUS] = ACTIONS(3375),
    [anon_sym_STAR] = ACTIONS(3377),
    [anon_sym_AMP_AMP] = ACTIONS(3377),
    [anon_sym_AMP] = ACTIONS(3375),
    [anon_sym___extension__] = ACTIONS(3375),
    [anon_sym_typedef] = ACTIONS(3375),
    [anon_sym_extern] = ACTIONS(3375),
    [anon_sym___attribute__] = ACTIONS(3375),
    [anon_sym_COLON_COLON] = ACTIONS(3377),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3377),
    [anon_sym___declspec] = ACTIONS(3375),
    [anon_sym___based] = ACTIONS(3375),
    [anon_sym___cdecl] = ACTIONS(3375),
    [anon_sym___clrcall] = ACTIONS(3375),
    [anon_sym___stdcall] = ACTIONS(3375),
    [anon_sym___fastcall] = ACTIONS(3375),
    [anon_sym___thiscall] = ACTIONS(3375),
    [anon_sym___vectorcall] = ACTIONS(3375),
    [anon_sym_LBRACE] = ACTIONS(3377),
    [anon_sym_signed] = ACTIONS(3375),
    [anon_sym_unsigned] = ACTIONS(3375),
    [anon_sym_long] = ACTIONS(3375),
    [anon_sym_short] = ACTIONS(3375),
    [anon_sym_LBRACK] = ACTIONS(3375),
    [anon_sym_static] = ACTIONS(3375),
    [anon_sym_register] = ACTIONS(3375),
    [anon_sym_inline] = ACTIONS(3375),
    [anon_sym___inline] = ACTIONS(3375),
    [anon_sym___inline__] = ACTIONS(3375),
    [anon_sym___forceinline] = ACTIONS(3375),
    [anon_sym_thread_local] = ACTIONS(3375),
    [anon_sym___thread] = ACTIONS(3375),
    [anon_sym_const] = ACTIONS(3375),
    [anon_sym_constexpr] = ACTIONS(3375),
    [anon_sym_volatile] = ACTIONS(3375),
    [anon_sym_restrict] = ACTIONS(3375),
    [anon_sym___restrict__] = ACTIONS(3375),
    [anon_sym__Atomic] = ACTIONS(3375),
    [anon_sym__Noreturn] = ACTIONS(3375),
    [anon_sym_noreturn] = ACTIONS(3375),
    [anon_sym_mutable] = ACTIONS(3375),
    [anon_sym_constinit] = ACTIONS(3375),
    [anon_sym_consteval] = ACTIONS(3375),
    [anon_sym_PROGMEM] = ACTIONS(3375),
    [aux_sym_primitive_type_token1] = ACTIONS(3375),
    [anon_sym_byte] = ACTIONS(3375),
    [anon_sym_word] = ACTIONS(3375),
    [anon_sym_enum] = ACTIONS(3375),
    [anon_sym_class] = ACTIONS(3375),
    [anon_sym_struct] = ACTIONS(3375),
    [anon_sym_union] = ACTIONS(3375),
    [anon_sym_if] = ACTIONS(3375),
    [anon_sym_switch] = ACTIONS(3375),
    [anon_sym_case] = ACTIONS(3375),
    [anon_sym_default] = ACTIONS(3375),
    [anon_sym_while] = ACTIONS(3375),
    [anon_sym_do] = ACTIONS(3375),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_return] = ACTIONS(3375),
    [anon_sym_break] = ACTIONS(3375),
    [anon_sym_continue] = ACTIONS(3375),
    [anon_sym_goto] = ACTIONS(3375),
    [anon_sym_not] = ACTIONS(3375),
    [anon_sym_compl] = ACTIONS(3375),
    [anon_sym_DASH_DASH] = ACTIONS(3377),
    [anon_sym_PLUS_PLUS] = ACTIONS(3377),
    [anon_sym_sizeof] = ACTIONS(3375),
    [anon_sym___alignof__] = ACTIONS(3375),
    [anon_sym___alignof] = ACTIONS(3375),
    [anon_sym__alignof] = ACTIONS(3375),
    [anon_sym_alignof] = ACTIONS(3375),
    [anon_sym__Alignof] = ACTIONS(3375),
    [anon_sym_offsetof] = ACTIONS(3375),
    [anon_sym__Generic] = ACTIONS(3375),
    [anon_sym_asm] = ACTIONS(3375),
    [anon_sym___asm__] = ACTIONS(3375),
    [aux_sym_number_literal_token1] = ACTIONS(3377),
    [aux_sym_number_literal_token2] = ACTIONS(3375),
    [anon_sym_L_SQUOTE] = ACTIONS(3377),
    [anon_sym_u_SQUOTE] = ACTIONS(3377),
    [anon_sym_U_SQUOTE] = ACTIONS(3377),
    [anon_sym_u8_SQUOTE] = ACTIONS(3377),
    [anon_sym_SQUOTE] = ACTIONS(3377),
    [anon_sym_L_DQUOTE] = ACTIONS(3377),
    [anon_sym_u_DQUOTE] = ACTIONS(3377),
    [anon_sym_U_DQUOTE] = ACTIONS(3377),
    [anon_sym_u8_DQUOTE] = ACTIONS(3377),
    [anon_sym_DQUOTE] = ACTIONS(3377),
    [sym_true] = ACTIONS(3375),
    [sym_false] = ACTIONS(3375),
    [anon_sym_NULL] = ACTIONS(3375),
    [anon_sym_nullptr] = ACTIONS(3375),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3375),
    [anon_sym_decltype] = ACTIONS(3375),
    [anon_sym_virtual] = ACTIONS(3375),
    [anon_sym_alignas] = ACTIONS(3375),
    [anon_sym_explicit] = ACTIONS(3375),
    [anon_sym_typename] = ACTIONS(3375),
    [anon_sym_template] = ACTIONS(3375),
    [anon_sym_operator] = ACTIONS(3375),
    [anon_sym_try] = ACTIONS(3375),
    [anon_sym_delete] = ACTIONS(3375),
    [anon_sym_throw] = ACTIONS(3375),
    [anon_sym_namespace] = ACTIONS(3375),
    [anon_sym_using] = ACTIONS(3375),
    [anon_sym_static_assert] = ACTIONS(3375),
    [anon_sym_concept] = ACTIONS(3375),
    [anon_sym_co_return] = ACTIONS(3375),
    [anon_sym_co_yield] = ACTIONS(3375),
    [anon_sym_R_DQUOTE] = ACTIONS(3377),
    [anon_sym_LR_DQUOTE] = ACTIONS(3377),
    [anon_sym_uR_DQUOTE] = ACTIONS(3377),
    [anon_sym_UR_DQUOTE] = ACTIONS(3377),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3377),
    [anon_sym_co_await] = ACTIONS(3375),
    [anon_sym_new] = ACTIONS(3375),
    [anon_sym_requires] = ACTIONS(3375),
    [sym_this] = ACTIONS(3375),
  },
  [1068] = {
    [ts_builtin_sym_end] = ACTIONS(3180),
    [sym_identifier] = ACTIONS(3178),
    [aux_sym_preproc_include_token1] = ACTIONS(3178),
    [aux_sym_preproc_def_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3178),
    [sym_preproc_directive] = ACTIONS(3178),
    [anon_sym_LPAREN2] = ACTIONS(3180),
    [anon_sym_BANG] = ACTIONS(3180),
    [anon_sym_TILDE] = ACTIONS(3180),
    [anon_sym_DASH] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3178),
    [anon_sym_STAR] = ACTIONS(3180),
    [anon_sym_AMP_AMP] = ACTIONS(3180),
    [anon_sym_AMP] = ACTIONS(3178),
    [anon_sym___extension__] = ACTIONS(3178),
    [anon_sym_typedef] = ACTIONS(3178),
    [anon_sym_extern] = ACTIONS(3178),
    [anon_sym___attribute__] = ACTIONS(3178),
    [anon_sym_COLON_COLON] = ACTIONS(3180),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3180),
    [anon_sym___declspec] = ACTIONS(3178),
    [anon_sym___based] = ACTIONS(3178),
    [anon_sym___cdecl] = ACTIONS(3178),
    [anon_sym___clrcall] = ACTIONS(3178),
    [anon_sym___stdcall] = ACTIONS(3178),
    [anon_sym___fastcall] = ACTIONS(3178),
    [anon_sym___thiscall] = ACTIONS(3178),
    [anon_sym___vectorcall] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3180),
    [anon_sym_signed] = ACTIONS(3178),
    [anon_sym_unsigned] = ACTIONS(3178),
    [anon_sym_long] = ACTIONS(3178),
    [anon_sym_short] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_static] = ACTIONS(3178),
    [anon_sym_register] = ACTIONS(3178),
    [anon_sym_inline] = ACTIONS(3178),
    [anon_sym___inline] = ACTIONS(3178),
    [anon_sym___inline__] = ACTIONS(3178),
    [anon_sym___forceinline] = ACTIONS(3178),
    [anon_sym_thread_local] = ACTIONS(3178),
    [anon_sym___thread] = ACTIONS(3178),
    [anon_sym_const] = ACTIONS(3178),
    [anon_sym_constexpr] = ACTIONS(3178),
    [anon_sym_volatile] = ACTIONS(3178),
    [anon_sym_restrict] = ACTIONS(3178),
    [anon_sym___restrict__] = ACTIONS(3178),
    [anon_sym__Atomic] = ACTIONS(3178),
    [anon_sym__Noreturn] = ACTIONS(3178),
    [anon_sym_noreturn] = ACTIONS(3178),
    [anon_sym_mutable] = ACTIONS(3178),
    [anon_sym_constinit] = ACTIONS(3178),
    [anon_sym_consteval] = ACTIONS(3178),
    [anon_sym_PROGMEM] = ACTIONS(3178),
    [aux_sym_primitive_type_token1] = ACTIONS(3178),
    [anon_sym_byte] = ACTIONS(3178),
    [anon_sym_word] = ACTIONS(3178),
    [anon_sym_enum] = ACTIONS(3178),
    [anon_sym_class] = ACTIONS(3178),
    [anon_sym_struct] = ACTIONS(3178),
    [anon_sym_union] = ACTIONS(3178),
    [anon_sym_if] = ACTIONS(3178),
    [anon_sym_switch] = ACTIONS(3178),
    [anon_sym_case] = ACTIONS(3178),
    [anon_sym_default] = ACTIONS(3178),
    [anon_sym_while] = ACTIONS(3178),
    [anon_sym_do] = ACTIONS(3178),
    [anon_sym_for] = ACTIONS(3178),
    [anon_sym_return] = ACTIONS(3178),
    [anon_sym_break] = ACTIONS(3178),
    [anon_sym_continue] = ACTIONS(3178),
    [anon_sym_goto] = ACTIONS(3178),
    [anon_sym_not] = ACTIONS(3178),
    [anon_sym_compl] = ACTIONS(3178),
    [anon_sym_DASH_DASH] = ACTIONS(3180),
    [anon_sym_PLUS_PLUS] = ACTIONS(3180),
    [anon_sym_sizeof] = ACTIONS(3178),
    [anon_sym___alignof__] = ACTIONS(3178),
    [anon_sym___alignof] = ACTIONS(3178),
    [anon_sym__alignof] = ACTIONS(3178),
    [anon_sym_alignof] = ACTIONS(3178),
    [anon_sym__Alignof] = ACTIONS(3178),
    [anon_sym_offsetof] = ACTIONS(3178),
    [anon_sym__Generic] = ACTIONS(3178),
    [anon_sym_asm] = ACTIONS(3178),
    [anon_sym___asm__] = ACTIONS(3178),
    [aux_sym_number_literal_token1] = ACTIONS(3180),
    [aux_sym_number_literal_token2] = ACTIONS(3178),
    [anon_sym_L_SQUOTE] = ACTIONS(3180),
    [anon_sym_u_SQUOTE] = ACTIONS(3180),
    [anon_sym_U_SQUOTE] = ACTIONS(3180),
    [anon_sym_u8_SQUOTE] = ACTIONS(3180),
    [anon_sym_SQUOTE] = ACTIONS(3180),
    [anon_sym_L_DQUOTE] = ACTIONS(3180),
    [anon_sym_u_DQUOTE] = ACTIONS(3180),
    [anon_sym_U_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8_DQUOTE] = ACTIONS(3180),
    [anon_sym_DQUOTE] = ACTIONS(3180),
    [sym_true] = ACTIONS(3178),
    [sym_false] = ACTIONS(3178),
    [anon_sym_NULL] = ACTIONS(3178),
    [anon_sym_nullptr] = ACTIONS(3178),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3178),
    [anon_sym_decltype] = ACTIONS(3178),
    [anon_sym_virtual] = ACTIONS(3178),
    [anon_sym_alignas] = ACTIONS(3178),
    [anon_sym_explicit] = ACTIONS(3178),
    [anon_sym_typename] = ACTIONS(3178),
    [anon_sym_template] = ACTIONS(3178),
    [anon_sym_operator] = ACTIONS(3178),
    [anon_sym_try] = ACTIONS(3178),
    [anon_sym_delete] = ACTIONS(3178),
    [anon_sym_throw] = ACTIONS(3178),
    [anon_sym_namespace] = ACTIONS(3178),
    [anon_sym_using] = ACTIONS(3178),
    [anon_sym_static_assert] = ACTIONS(3178),
    [anon_sym_concept] = ACTIONS(3178),
    [anon_sym_co_return] = ACTIONS(3178),
    [anon_sym_co_yield] = ACTIONS(3178),
    [anon_sym_R_DQUOTE] = ACTIONS(3180),
    [anon_sym_LR_DQUOTE] = ACTIONS(3180),
    [anon_sym_uR_DQUOTE] = ACTIONS(3180),
    [anon_sym_UR_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3180),
    [anon_sym_co_await] = ACTIONS(3178),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3178),
    [sym_this] = ACTIONS(3178),
  },
  [1069] = {
    [ts_builtin_sym_end] = ACTIONS(3405),
    [sym_identifier] = ACTIONS(3403),
    [aux_sym_preproc_include_token1] = ACTIONS(3403),
    [aux_sym_preproc_def_token1] = ACTIONS(3403),
    [aux_sym_preproc_if_token1] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3403),
    [sym_preproc_directive] = ACTIONS(3403),
    [anon_sym_LPAREN2] = ACTIONS(3405),
    [anon_sym_BANG] = ACTIONS(3405),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_DASH] = ACTIONS(3403),
    [anon_sym_PLUS] = ACTIONS(3403),
    [anon_sym_STAR] = ACTIONS(3405),
    [anon_sym_AMP_AMP] = ACTIONS(3405),
    [anon_sym_AMP] = ACTIONS(3403),
    [anon_sym___extension__] = ACTIONS(3403),
    [anon_sym_typedef] = ACTIONS(3403),
    [anon_sym_extern] = ACTIONS(3403),
    [anon_sym___attribute__] = ACTIONS(3403),
    [anon_sym_COLON_COLON] = ACTIONS(3405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3405),
    [anon_sym___declspec] = ACTIONS(3403),
    [anon_sym___based] = ACTIONS(3403),
    [anon_sym___cdecl] = ACTIONS(3403),
    [anon_sym___clrcall] = ACTIONS(3403),
    [anon_sym___stdcall] = ACTIONS(3403),
    [anon_sym___fastcall] = ACTIONS(3403),
    [anon_sym___thiscall] = ACTIONS(3403),
    [anon_sym___vectorcall] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3405),
    [anon_sym_signed] = ACTIONS(3403),
    [anon_sym_unsigned] = ACTIONS(3403),
    [anon_sym_long] = ACTIONS(3403),
    [anon_sym_short] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3403),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_register] = ACTIONS(3403),
    [anon_sym_inline] = ACTIONS(3403),
    [anon_sym___inline] = ACTIONS(3403),
    [anon_sym___inline__] = ACTIONS(3403),
    [anon_sym___forceinline] = ACTIONS(3403),
    [anon_sym_thread_local] = ACTIONS(3403),
    [anon_sym___thread] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_constexpr] = ACTIONS(3403),
    [anon_sym_volatile] = ACTIONS(3403),
    [anon_sym_restrict] = ACTIONS(3403),
    [anon_sym___restrict__] = ACTIONS(3403),
    [anon_sym__Atomic] = ACTIONS(3403),
    [anon_sym__Noreturn] = ACTIONS(3403),
    [anon_sym_noreturn] = ACTIONS(3403),
    [anon_sym_mutable] = ACTIONS(3403),
    [anon_sym_constinit] = ACTIONS(3403),
    [anon_sym_consteval] = ACTIONS(3403),
    [anon_sym_PROGMEM] = ACTIONS(3403),
    [aux_sym_primitive_type_token1] = ACTIONS(3403),
    [anon_sym_byte] = ACTIONS(3403),
    [anon_sym_word] = ACTIONS(3403),
    [anon_sym_enum] = ACTIONS(3403),
    [anon_sym_class] = ACTIONS(3403),
    [anon_sym_struct] = ACTIONS(3403),
    [anon_sym_union] = ACTIONS(3403),
    [anon_sym_if] = ACTIONS(3403),
    [anon_sym_switch] = ACTIONS(3403),
    [anon_sym_case] = ACTIONS(3403),
    [anon_sym_default] = ACTIONS(3403),
    [anon_sym_while] = ACTIONS(3403),
    [anon_sym_do] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3403),
    [anon_sym_return] = ACTIONS(3403),
    [anon_sym_break] = ACTIONS(3403),
    [anon_sym_continue] = ACTIONS(3403),
    [anon_sym_goto] = ACTIONS(3403),
    [anon_sym_not] = ACTIONS(3403),
    [anon_sym_compl] = ACTIONS(3403),
    [anon_sym_DASH_DASH] = ACTIONS(3405),
    [anon_sym_PLUS_PLUS] = ACTIONS(3405),
    [anon_sym_sizeof] = ACTIONS(3403),
    [anon_sym___alignof__] = ACTIONS(3403),
    [anon_sym___alignof] = ACTIONS(3403),
    [anon_sym__alignof] = ACTIONS(3403),
    [anon_sym_alignof] = ACTIONS(3403),
    [anon_sym__Alignof] = ACTIONS(3403),
    [anon_sym_offsetof] = ACTIONS(3403),
    [anon_sym__Generic] = ACTIONS(3403),
    [anon_sym_asm] = ACTIONS(3403),
    [anon_sym___asm__] = ACTIONS(3403),
    [aux_sym_number_literal_token1] = ACTIONS(3405),
    [aux_sym_number_literal_token2] = ACTIONS(3403),
    [anon_sym_L_SQUOTE] = ACTIONS(3405),
    [anon_sym_u_SQUOTE] = ACTIONS(3405),
    [anon_sym_U_SQUOTE] = ACTIONS(3405),
    [anon_sym_u8_SQUOTE] = ACTIONS(3405),
    [anon_sym_SQUOTE] = ACTIONS(3405),
    [anon_sym_L_DQUOTE] = ACTIONS(3405),
    [anon_sym_u_DQUOTE] = ACTIONS(3405),
    [anon_sym_U_DQUOTE] = ACTIONS(3405),
    [anon_sym_u8_DQUOTE] = ACTIONS(3405),
    [anon_sym_DQUOTE] = ACTIONS(3405),
    [sym_true] = ACTIONS(3403),
    [sym_false] = ACTIONS(3403),
    [anon_sym_NULL] = ACTIONS(3403),
    [anon_sym_nullptr] = ACTIONS(3403),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3403),
    [anon_sym_decltype] = ACTIONS(3403),
    [anon_sym_virtual] = ACTIONS(3403),
    [anon_sym_alignas] = ACTIONS(3403),
    [anon_sym_explicit] = ACTIONS(3403),
    [anon_sym_typename] = ACTIONS(3403),
    [anon_sym_template] = ACTIONS(3403),
    [anon_sym_operator] = ACTIONS(3403),
    [anon_sym_try] = ACTIONS(3403),
    [anon_sym_delete] = ACTIONS(3403),
    [anon_sym_throw] = ACTIONS(3403),
    [anon_sym_namespace] = ACTIONS(3403),
    [anon_sym_using] = ACTIONS(3403),
    [anon_sym_static_assert] = ACTIONS(3403),
    [anon_sym_concept] = ACTIONS(3403),
    [anon_sym_co_return] = ACTIONS(3403),
    [anon_sym_co_yield] = ACTIONS(3403),
    [anon_sym_R_DQUOTE] = ACTIONS(3405),
    [anon_sym_LR_DQUOTE] = ACTIONS(3405),
    [anon_sym_uR_DQUOTE] = ACTIONS(3405),
    [anon_sym_UR_DQUOTE] = ACTIONS(3405),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3405),
    [anon_sym_co_await] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3403),
    [anon_sym_requires] = ACTIONS(3403),
    [sym_this] = ACTIONS(3403),
  },
  [1070] = {
    [ts_builtin_sym_end] = ACTIONS(3393),
    [sym_identifier] = ACTIONS(3391),
    [aux_sym_preproc_include_token1] = ACTIONS(3391),
    [aux_sym_preproc_def_token1] = ACTIONS(3391),
    [aux_sym_preproc_if_token1] = ACTIONS(3391),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3391),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3391),
    [sym_preproc_directive] = ACTIONS(3391),
    [anon_sym_LPAREN2] = ACTIONS(3393),
    [anon_sym_BANG] = ACTIONS(3393),
    [anon_sym_TILDE] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_STAR] = ACTIONS(3393),
    [anon_sym_AMP_AMP] = ACTIONS(3393),
    [anon_sym_AMP] = ACTIONS(3391),
    [anon_sym___extension__] = ACTIONS(3391),
    [anon_sym_typedef] = ACTIONS(3391),
    [anon_sym_extern] = ACTIONS(3391),
    [anon_sym___attribute__] = ACTIONS(3391),
    [anon_sym_COLON_COLON] = ACTIONS(3393),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3393),
    [anon_sym___declspec] = ACTIONS(3391),
    [anon_sym___based] = ACTIONS(3391),
    [anon_sym___cdecl] = ACTIONS(3391),
    [anon_sym___clrcall] = ACTIONS(3391),
    [anon_sym___stdcall] = ACTIONS(3391),
    [anon_sym___fastcall] = ACTIONS(3391),
    [anon_sym___thiscall] = ACTIONS(3391),
    [anon_sym___vectorcall] = ACTIONS(3391),
    [anon_sym_LBRACE] = ACTIONS(3393),
    [anon_sym_signed] = ACTIONS(3391),
    [anon_sym_unsigned] = ACTIONS(3391),
    [anon_sym_long] = ACTIONS(3391),
    [anon_sym_short] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(3391),
    [anon_sym_static] = ACTIONS(3391),
    [anon_sym_register] = ACTIONS(3391),
    [anon_sym_inline] = ACTIONS(3391),
    [anon_sym___inline] = ACTIONS(3391),
    [anon_sym___inline__] = ACTIONS(3391),
    [anon_sym___forceinline] = ACTIONS(3391),
    [anon_sym_thread_local] = ACTIONS(3391),
    [anon_sym___thread] = ACTIONS(3391),
    [anon_sym_const] = ACTIONS(3391),
    [anon_sym_constexpr] = ACTIONS(3391),
    [anon_sym_volatile] = ACTIONS(3391),
    [anon_sym_restrict] = ACTIONS(3391),
    [anon_sym___restrict__] = ACTIONS(3391),
    [anon_sym__Atomic] = ACTIONS(3391),
    [anon_sym__Noreturn] = ACTIONS(3391),
    [anon_sym_noreturn] = ACTIONS(3391),
    [anon_sym_mutable] = ACTIONS(3391),
    [anon_sym_constinit] = ACTIONS(3391),
    [anon_sym_consteval] = ACTIONS(3391),
    [anon_sym_PROGMEM] = ACTIONS(3391),
    [aux_sym_primitive_type_token1] = ACTIONS(3391),
    [anon_sym_byte] = ACTIONS(3391),
    [anon_sym_word] = ACTIONS(3391),
    [anon_sym_enum] = ACTIONS(3391),
    [anon_sym_class] = ACTIONS(3391),
    [anon_sym_struct] = ACTIONS(3391),
    [anon_sym_union] = ACTIONS(3391),
    [anon_sym_if] = ACTIONS(3391),
    [anon_sym_switch] = ACTIONS(3391),
    [anon_sym_case] = ACTIONS(3391),
    [anon_sym_default] = ACTIONS(3391),
    [anon_sym_while] = ACTIONS(3391),
    [anon_sym_do] = ACTIONS(3391),
    [anon_sym_for] = ACTIONS(3391),
    [anon_sym_return] = ACTIONS(3391),
    [anon_sym_break] = ACTIONS(3391),
    [anon_sym_continue] = ACTIONS(3391),
    [anon_sym_goto] = ACTIONS(3391),
    [anon_sym_not] = ACTIONS(3391),
    [anon_sym_compl] = ACTIONS(3391),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_sizeof] = ACTIONS(3391),
    [anon_sym___alignof__] = ACTIONS(3391),
    [anon_sym___alignof] = ACTIONS(3391),
    [anon_sym__alignof] = ACTIONS(3391),
    [anon_sym_alignof] = ACTIONS(3391),
    [anon_sym__Alignof] = ACTIONS(3391),
    [anon_sym_offsetof] = ACTIONS(3391),
    [anon_sym__Generic] = ACTIONS(3391),
    [anon_sym_asm] = ACTIONS(3391),
    [anon_sym___asm__] = ACTIONS(3391),
    [aux_sym_number_literal_token1] = ACTIONS(3393),
    [aux_sym_number_literal_token2] = ACTIONS(3391),
    [anon_sym_L_SQUOTE] = ACTIONS(3393),
    [anon_sym_u_SQUOTE] = ACTIONS(3393),
    [anon_sym_U_SQUOTE] = ACTIONS(3393),
    [anon_sym_u8_SQUOTE] = ACTIONS(3393),
    [anon_sym_SQUOTE] = ACTIONS(3393),
    [anon_sym_L_DQUOTE] = ACTIONS(3393),
    [anon_sym_u_DQUOTE] = ACTIONS(3393),
    [anon_sym_U_DQUOTE] = ACTIONS(3393),
    [anon_sym_u8_DQUOTE] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3393),
    [sym_true] = ACTIONS(3391),
    [sym_false] = ACTIONS(3391),
    [anon_sym_NULL] = ACTIONS(3391),
    [anon_sym_nullptr] = ACTIONS(3391),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3391),
    [anon_sym_decltype] = ACTIONS(3391),
    [anon_sym_virtual] = ACTIONS(3391),
    [anon_sym_alignas] = ACTIONS(3391),
    [anon_sym_explicit] = ACTIONS(3391),
    [anon_sym_typename] = ACTIONS(3391),
    [anon_sym_template] = ACTIONS(3391),
    [anon_sym_operator] = ACTIONS(3391),
    [anon_sym_try] = ACTIONS(3391),
    [anon_sym_delete] = ACTIONS(3391),
    [anon_sym_throw] = ACTIONS(3391),
    [anon_sym_namespace] = ACTIONS(3391),
    [anon_sym_using] = ACTIONS(3391),
    [anon_sym_static_assert] = ACTIONS(3391),
    [anon_sym_concept] = ACTIONS(3391),
    [anon_sym_co_return] = ACTIONS(3391),
    [anon_sym_co_yield] = ACTIONS(3391),
    [anon_sym_R_DQUOTE] = ACTIONS(3393),
    [anon_sym_LR_DQUOTE] = ACTIONS(3393),
    [anon_sym_uR_DQUOTE] = ACTIONS(3393),
    [anon_sym_UR_DQUOTE] = ACTIONS(3393),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3393),
    [anon_sym_co_await] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(3391),
    [anon_sym_requires] = ACTIONS(3391),
    [sym_this] = ACTIONS(3391),
  },
  [1071] = {
    [ts_builtin_sym_end] = ACTIONS(3441),
    [sym_identifier] = ACTIONS(3439),
    [aux_sym_preproc_include_token1] = ACTIONS(3439),
    [aux_sym_preproc_def_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3439),
    [sym_preproc_directive] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3441),
    [anon_sym_BANG] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_DASH] = ACTIONS(3439),
    [anon_sym_PLUS] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3439),
    [anon_sym___extension__] = ACTIONS(3439),
    [anon_sym_typedef] = ACTIONS(3439),
    [anon_sym_extern] = ACTIONS(3439),
    [anon_sym___attribute__] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3441),
    [anon_sym___declspec] = ACTIONS(3439),
    [anon_sym___based] = ACTIONS(3439),
    [anon_sym___cdecl] = ACTIONS(3439),
    [anon_sym___clrcall] = ACTIONS(3439),
    [anon_sym___stdcall] = ACTIONS(3439),
    [anon_sym___fastcall] = ACTIONS(3439),
    [anon_sym___thiscall] = ACTIONS(3439),
    [anon_sym___vectorcall] = ACTIONS(3439),
    [anon_sym_LBRACE] = ACTIONS(3441),
    [anon_sym_signed] = ACTIONS(3439),
    [anon_sym_unsigned] = ACTIONS(3439),
    [anon_sym_long] = ACTIONS(3439),
    [anon_sym_short] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_register] = ACTIONS(3439),
    [anon_sym_inline] = ACTIONS(3439),
    [anon_sym___inline] = ACTIONS(3439),
    [anon_sym___inline__] = ACTIONS(3439),
    [anon_sym___forceinline] = ACTIONS(3439),
    [anon_sym_thread_local] = ACTIONS(3439),
    [anon_sym___thread] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_constexpr] = ACTIONS(3439),
    [anon_sym_volatile] = ACTIONS(3439),
    [anon_sym_restrict] = ACTIONS(3439),
    [anon_sym___restrict__] = ACTIONS(3439),
    [anon_sym__Atomic] = ACTIONS(3439),
    [anon_sym__Noreturn] = ACTIONS(3439),
    [anon_sym_noreturn] = ACTIONS(3439),
    [anon_sym_mutable] = ACTIONS(3439),
    [anon_sym_constinit] = ACTIONS(3439),
    [anon_sym_consteval] = ACTIONS(3439),
    [anon_sym_PROGMEM] = ACTIONS(3439),
    [aux_sym_primitive_type_token1] = ACTIONS(3439),
    [anon_sym_byte] = ACTIONS(3439),
    [anon_sym_word] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_struct] = ACTIONS(3439),
    [anon_sym_union] = ACTIONS(3439),
    [anon_sym_if] = ACTIONS(3439),
    [anon_sym_switch] = ACTIONS(3439),
    [anon_sym_case] = ACTIONS(3439),
    [anon_sym_default] = ACTIONS(3439),
    [anon_sym_while] = ACTIONS(3439),
    [anon_sym_do] = ACTIONS(3439),
    [anon_sym_for] = ACTIONS(3439),
    [anon_sym_return] = ACTIONS(3439),
    [anon_sym_break] = ACTIONS(3439),
    [anon_sym_continue] = ACTIONS(3439),
    [anon_sym_goto] = ACTIONS(3439),
    [anon_sym_not] = ACTIONS(3439),
    [anon_sym_compl] = ACTIONS(3439),
    [anon_sym_DASH_DASH] = ACTIONS(3441),
    [anon_sym_PLUS_PLUS] = ACTIONS(3441),
    [anon_sym_sizeof] = ACTIONS(3439),
    [anon_sym___alignof__] = ACTIONS(3439),
    [anon_sym___alignof] = ACTIONS(3439),
    [anon_sym__alignof] = ACTIONS(3439),
    [anon_sym_alignof] = ACTIONS(3439),
    [anon_sym__Alignof] = ACTIONS(3439),
    [anon_sym_offsetof] = ACTIONS(3439),
    [anon_sym__Generic] = ACTIONS(3439),
    [anon_sym_asm] = ACTIONS(3439),
    [anon_sym___asm__] = ACTIONS(3439),
    [aux_sym_number_literal_token1] = ACTIONS(3441),
    [aux_sym_number_literal_token2] = ACTIONS(3439),
    [anon_sym_L_SQUOTE] = ACTIONS(3441),
    [anon_sym_u_SQUOTE] = ACTIONS(3441),
    [anon_sym_U_SQUOTE] = ACTIONS(3441),
    [anon_sym_u8_SQUOTE] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [anon_sym_L_DQUOTE] = ACTIONS(3441),
    [anon_sym_u_DQUOTE] = ACTIONS(3441),
    [anon_sym_U_DQUOTE] = ACTIONS(3441),
    [anon_sym_u8_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE] = ACTIONS(3441),
    [sym_true] = ACTIONS(3439),
    [sym_false] = ACTIONS(3439),
    [anon_sym_NULL] = ACTIONS(3439),
    [anon_sym_nullptr] = ACTIONS(3439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3439),
    [anon_sym_decltype] = ACTIONS(3439),
    [anon_sym_virtual] = ACTIONS(3439),
    [anon_sym_alignas] = ACTIONS(3439),
    [anon_sym_explicit] = ACTIONS(3439),
    [anon_sym_typename] = ACTIONS(3439),
    [anon_sym_template] = ACTIONS(3439),
    [anon_sym_operator] = ACTIONS(3439),
    [anon_sym_try] = ACTIONS(3439),
    [anon_sym_delete] = ACTIONS(3439),
    [anon_sym_throw] = ACTIONS(3439),
    [anon_sym_namespace] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_static_assert] = ACTIONS(3439),
    [anon_sym_concept] = ACTIONS(3439),
    [anon_sym_co_return] = ACTIONS(3439),
    [anon_sym_co_yield] = ACTIONS(3439),
    [anon_sym_R_DQUOTE] = ACTIONS(3441),
    [anon_sym_LR_DQUOTE] = ACTIONS(3441),
    [anon_sym_uR_DQUOTE] = ACTIONS(3441),
    [anon_sym_UR_DQUOTE] = ACTIONS(3441),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3441),
    [anon_sym_co_await] = ACTIONS(3439),
    [anon_sym_new] = ACTIONS(3439),
    [anon_sym_requires] = ACTIONS(3439),
    [sym_this] = ACTIONS(3439),
  },
  [1072] = {
    [ts_builtin_sym_end] = ACTIONS(3441),
    [sym_identifier] = ACTIONS(3439),
    [aux_sym_preproc_include_token1] = ACTIONS(3439),
    [aux_sym_preproc_def_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3439),
    [sym_preproc_directive] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3441),
    [anon_sym_BANG] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_DASH] = ACTIONS(3439),
    [anon_sym_PLUS] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3439),
    [anon_sym___extension__] = ACTIONS(3439),
    [anon_sym_typedef] = ACTIONS(3439),
    [anon_sym_extern] = ACTIONS(3439),
    [anon_sym___attribute__] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3441),
    [anon_sym___declspec] = ACTIONS(3439),
    [anon_sym___based] = ACTIONS(3439),
    [anon_sym___cdecl] = ACTIONS(3439),
    [anon_sym___clrcall] = ACTIONS(3439),
    [anon_sym___stdcall] = ACTIONS(3439),
    [anon_sym___fastcall] = ACTIONS(3439),
    [anon_sym___thiscall] = ACTIONS(3439),
    [anon_sym___vectorcall] = ACTIONS(3439),
    [anon_sym_LBRACE] = ACTIONS(3441),
    [anon_sym_signed] = ACTIONS(3439),
    [anon_sym_unsigned] = ACTIONS(3439),
    [anon_sym_long] = ACTIONS(3439),
    [anon_sym_short] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_register] = ACTIONS(3439),
    [anon_sym_inline] = ACTIONS(3439),
    [anon_sym___inline] = ACTIONS(3439),
    [anon_sym___inline__] = ACTIONS(3439),
    [anon_sym___forceinline] = ACTIONS(3439),
    [anon_sym_thread_local] = ACTIONS(3439),
    [anon_sym___thread] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_constexpr] = ACTIONS(3439),
    [anon_sym_volatile] = ACTIONS(3439),
    [anon_sym_restrict] = ACTIONS(3439),
    [anon_sym___restrict__] = ACTIONS(3439),
    [anon_sym__Atomic] = ACTIONS(3439),
    [anon_sym__Noreturn] = ACTIONS(3439),
    [anon_sym_noreturn] = ACTIONS(3439),
    [anon_sym_mutable] = ACTIONS(3439),
    [anon_sym_constinit] = ACTIONS(3439),
    [anon_sym_consteval] = ACTIONS(3439),
    [anon_sym_PROGMEM] = ACTIONS(3439),
    [aux_sym_primitive_type_token1] = ACTIONS(3439),
    [anon_sym_byte] = ACTIONS(3439),
    [anon_sym_word] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_struct] = ACTIONS(3439),
    [anon_sym_union] = ACTIONS(3439),
    [anon_sym_if] = ACTIONS(3439),
    [anon_sym_switch] = ACTIONS(3439),
    [anon_sym_case] = ACTIONS(3439),
    [anon_sym_default] = ACTIONS(3439),
    [anon_sym_while] = ACTIONS(3439),
    [anon_sym_do] = ACTIONS(3439),
    [anon_sym_for] = ACTIONS(3439),
    [anon_sym_return] = ACTIONS(3439),
    [anon_sym_break] = ACTIONS(3439),
    [anon_sym_continue] = ACTIONS(3439),
    [anon_sym_goto] = ACTIONS(3439),
    [anon_sym_not] = ACTIONS(3439),
    [anon_sym_compl] = ACTIONS(3439),
    [anon_sym_DASH_DASH] = ACTIONS(3441),
    [anon_sym_PLUS_PLUS] = ACTIONS(3441),
    [anon_sym_sizeof] = ACTIONS(3439),
    [anon_sym___alignof__] = ACTIONS(3439),
    [anon_sym___alignof] = ACTIONS(3439),
    [anon_sym__alignof] = ACTIONS(3439),
    [anon_sym_alignof] = ACTIONS(3439),
    [anon_sym__Alignof] = ACTIONS(3439),
    [anon_sym_offsetof] = ACTIONS(3439),
    [anon_sym__Generic] = ACTIONS(3439),
    [anon_sym_asm] = ACTIONS(3439),
    [anon_sym___asm__] = ACTIONS(3439),
    [aux_sym_number_literal_token1] = ACTIONS(3441),
    [aux_sym_number_literal_token2] = ACTIONS(3439),
    [anon_sym_L_SQUOTE] = ACTIONS(3441),
    [anon_sym_u_SQUOTE] = ACTIONS(3441),
    [anon_sym_U_SQUOTE] = ACTIONS(3441),
    [anon_sym_u8_SQUOTE] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [anon_sym_L_DQUOTE] = ACTIONS(3441),
    [anon_sym_u_DQUOTE] = ACTIONS(3441),
    [anon_sym_U_DQUOTE] = ACTIONS(3441),
    [anon_sym_u8_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE] = ACTIONS(3441),
    [sym_true] = ACTIONS(3439),
    [sym_false] = ACTIONS(3439),
    [anon_sym_NULL] = ACTIONS(3439),
    [anon_sym_nullptr] = ACTIONS(3439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3439),
    [anon_sym_decltype] = ACTIONS(3439),
    [anon_sym_virtual] = ACTIONS(3439),
    [anon_sym_alignas] = ACTIONS(3439),
    [anon_sym_explicit] = ACTIONS(3439),
    [anon_sym_typename] = ACTIONS(3439),
    [anon_sym_template] = ACTIONS(3439),
    [anon_sym_operator] = ACTIONS(3439),
    [anon_sym_try] = ACTIONS(3439),
    [anon_sym_delete] = ACTIONS(3439),
    [anon_sym_throw] = ACTIONS(3439),
    [anon_sym_namespace] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_static_assert] = ACTIONS(3439),
    [anon_sym_concept] = ACTIONS(3439),
    [anon_sym_co_return] = ACTIONS(3439),
    [anon_sym_co_yield] = ACTIONS(3439),
    [anon_sym_R_DQUOTE] = ACTIONS(3441),
    [anon_sym_LR_DQUOTE] = ACTIONS(3441),
    [anon_sym_uR_DQUOTE] = ACTIONS(3441),
    [anon_sym_UR_DQUOTE] = ACTIONS(3441),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3441),
    [anon_sym_co_await] = ACTIONS(3439),
    [anon_sym_new] = ACTIONS(3439),
    [anon_sym_requires] = ACTIONS(3439),
    [sym_this] = ACTIONS(3439),
  },
  [1073] = {
    [ts_builtin_sym_end] = ACTIONS(3369),
    [sym_identifier] = ACTIONS(3367),
    [aux_sym_preproc_include_token1] = ACTIONS(3367),
    [aux_sym_preproc_def_token1] = ACTIONS(3367),
    [aux_sym_preproc_if_token1] = ACTIONS(3367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3367),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3367),
    [sym_preproc_directive] = ACTIONS(3367),
    [anon_sym_LPAREN2] = ACTIONS(3369),
    [anon_sym_BANG] = ACTIONS(3369),
    [anon_sym_TILDE] = ACTIONS(3369),
    [anon_sym_DASH] = ACTIONS(3367),
    [anon_sym_PLUS] = ACTIONS(3367),
    [anon_sym_STAR] = ACTIONS(3369),
    [anon_sym_AMP_AMP] = ACTIONS(3369),
    [anon_sym_AMP] = ACTIONS(3367),
    [anon_sym___extension__] = ACTIONS(3367),
    [anon_sym_typedef] = ACTIONS(3367),
    [anon_sym_extern] = ACTIONS(3367),
    [anon_sym___attribute__] = ACTIONS(3367),
    [anon_sym_COLON_COLON] = ACTIONS(3369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3369),
    [anon_sym___declspec] = ACTIONS(3367),
    [anon_sym___based] = ACTIONS(3367),
    [anon_sym___cdecl] = ACTIONS(3367),
    [anon_sym___clrcall] = ACTIONS(3367),
    [anon_sym___stdcall] = ACTIONS(3367),
    [anon_sym___fastcall] = ACTIONS(3367),
    [anon_sym___thiscall] = ACTIONS(3367),
    [anon_sym___vectorcall] = ACTIONS(3367),
    [anon_sym_LBRACE] = ACTIONS(3369),
    [anon_sym_signed] = ACTIONS(3367),
    [anon_sym_unsigned] = ACTIONS(3367),
    [anon_sym_long] = ACTIONS(3367),
    [anon_sym_short] = ACTIONS(3367),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_static] = ACTIONS(3367),
    [anon_sym_register] = ACTIONS(3367),
    [anon_sym_inline] = ACTIONS(3367),
    [anon_sym___inline] = ACTIONS(3367),
    [anon_sym___inline__] = ACTIONS(3367),
    [anon_sym___forceinline] = ACTIONS(3367),
    [anon_sym_thread_local] = ACTIONS(3367),
    [anon_sym___thread] = ACTIONS(3367),
    [anon_sym_const] = ACTIONS(3367),
    [anon_sym_constexpr] = ACTIONS(3367),
    [anon_sym_volatile] = ACTIONS(3367),
    [anon_sym_restrict] = ACTIONS(3367),
    [anon_sym___restrict__] = ACTIONS(3367),
    [anon_sym__Atomic] = ACTIONS(3367),
    [anon_sym__Noreturn] = ACTIONS(3367),
    [anon_sym_noreturn] = ACTIONS(3367),
    [anon_sym_mutable] = ACTIONS(3367),
    [anon_sym_constinit] = ACTIONS(3367),
    [anon_sym_consteval] = ACTIONS(3367),
    [anon_sym_PROGMEM] = ACTIONS(3367),
    [aux_sym_primitive_type_token1] = ACTIONS(3367),
    [anon_sym_byte] = ACTIONS(3367),
    [anon_sym_word] = ACTIONS(3367),
    [anon_sym_enum] = ACTIONS(3367),
    [anon_sym_class] = ACTIONS(3367),
    [anon_sym_struct] = ACTIONS(3367),
    [anon_sym_union] = ACTIONS(3367),
    [anon_sym_if] = ACTIONS(3367),
    [anon_sym_switch] = ACTIONS(3367),
    [anon_sym_case] = ACTIONS(3367),
    [anon_sym_default] = ACTIONS(3367),
    [anon_sym_while] = ACTIONS(3367),
    [anon_sym_do] = ACTIONS(3367),
    [anon_sym_for] = ACTIONS(3367),
    [anon_sym_return] = ACTIONS(3367),
    [anon_sym_break] = ACTIONS(3367),
    [anon_sym_continue] = ACTIONS(3367),
    [anon_sym_goto] = ACTIONS(3367),
    [anon_sym_not] = ACTIONS(3367),
    [anon_sym_compl] = ACTIONS(3367),
    [anon_sym_DASH_DASH] = ACTIONS(3369),
    [anon_sym_PLUS_PLUS] = ACTIONS(3369),
    [anon_sym_sizeof] = ACTIONS(3367),
    [anon_sym___alignof__] = ACTIONS(3367),
    [anon_sym___alignof] = ACTIONS(3367),
    [anon_sym__alignof] = ACTIONS(3367),
    [anon_sym_alignof] = ACTIONS(3367),
    [anon_sym__Alignof] = ACTIONS(3367),
    [anon_sym_offsetof] = ACTIONS(3367),
    [anon_sym__Generic] = ACTIONS(3367),
    [anon_sym_asm] = ACTIONS(3367),
    [anon_sym___asm__] = ACTIONS(3367),
    [aux_sym_number_literal_token1] = ACTIONS(3369),
    [aux_sym_number_literal_token2] = ACTIONS(3367),
    [anon_sym_L_SQUOTE] = ACTIONS(3369),
    [anon_sym_u_SQUOTE] = ACTIONS(3369),
    [anon_sym_U_SQUOTE] = ACTIONS(3369),
    [anon_sym_u8_SQUOTE] = ACTIONS(3369),
    [anon_sym_SQUOTE] = ACTIONS(3369),
    [anon_sym_L_DQUOTE] = ACTIONS(3369),
    [anon_sym_u_DQUOTE] = ACTIONS(3369),
    [anon_sym_U_DQUOTE] = ACTIONS(3369),
    [anon_sym_u8_DQUOTE] = ACTIONS(3369),
    [anon_sym_DQUOTE] = ACTIONS(3369),
    [sym_true] = ACTIONS(3367),
    [sym_false] = ACTIONS(3367),
    [anon_sym_NULL] = ACTIONS(3367),
    [anon_sym_nullptr] = ACTIONS(3367),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3367),
    [anon_sym_decltype] = ACTIONS(3367),
    [anon_sym_virtual] = ACTIONS(3367),
    [anon_sym_alignas] = ACTIONS(3367),
    [anon_sym_explicit] = ACTIONS(3367),
    [anon_sym_typename] = ACTIONS(3367),
    [anon_sym_template] = ACTIONS(3367),
    [anon_sym_operator] = ACTIONS(3367),
    [anon_sym_try] = ACTIONS(3367),
    [anon_sym_delete] = ACTIONS(3367),
    [anon_sym_throw] = ACTIONS(3367),
    [anon_sym_namespace] = ACTIONS(3367),
    [anon_sym_using] = ACTIONS(3367),
    [anon_sym_static_assert] = ACTIONS(3367),
    [anon_sym_concept] = ACTIONS(3367),
    [anon_sym_co_return] = ACTIONS(3367),
    [anon_sym_co_yield] = ACTIONS(3367),
    [anon_sym_R_DQUOTE] = ACTIONS(3369),
    [anon_sym_LR_DQUOTE] = ACTIONS(3369),
    [anon_sym_uR_DQUOTE] = ACTIONS(3369),
    [anon_sym_UR_DQUOTE] = ACTIONS(3369),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3369),
    [anon_sym_co_await] = ACTIONS(3367),
    [anon_sym_new] = ACTIONS(3367),
    [anon_sym_requires] = ACTIONS(3367),
    [sym_this] = ACTIONS(3367),
  },
  [1074] = {
    [ts_builtin_sym_end] = ACTIONS(3997),
    [sym_identifier] = ACTIONS(3999),
    [aux_sym_preproc_include_token1] = ACTIONS(3999),
    [aux_sym_preproc_def_token1] = ACTIONS(3999),
    [aux_sym_preproc_if_token1] = ACTIONS(3999),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3999),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3999),
    [sym_preproc_directive] = ACTIONS(3999),
    [anon_sym_LPAREN2] = ACTIONS(3997),
    [anon_sym_BANG] = ACTIONS(3997),
    [anon_sym_TILDE] = ACTIONS(3997),
    [anon_sym_DASH] = ACTIONS(3999),
    [anon_sym_PLUS] = ACTIONS(3999),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_AMP] = ACTIONS(3999),
    [anon_sym___extension__] = ACTIONS(3999),
    [anon_sym_typedef] = ACTIONS(3999),
    [anon_sym_extern] = ACTIONS(3999),
    [anon_sym___attribute__] = ACTIONS(3999),
    [anon_sym_COLON_COLON] = ACTIONS(3997),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3997),
    [anon_sym___declspec] = ACTIONS(3999),
    [anon_sym___based] = ACTIONS(3999),
    [anon_sym___cdecl] = ACTIONS(3999),
    [anon_sym___clrcall] = ACTIONS(3999),
    [anon_sym___stdcall] = ACTIONS(3999),
    [anon_sym___fastcall] = ACTIONS(3999),
    [anon_sym___thiscall] = ACTIONS(3999),
    [anon_sym___vectorcall] = ACTIONS(3999),
    [anon_sym_LBRACE] = ACTIONS(3997),
    [anon_sym_signed] = ACTIONS(3999),
    [anon_sym_unsigned] = ACTIONS(3999),
    [anon_sym_long] = ACTIONS(3999),
    [anon_sym_short] = ACTIONS(3999),
    [anon_sym_LBRACK] = ACTIONS(3999),
    [anon_sym_static] = ACTIONS(3999),
    [anon_sym_register] = ACTIONS(3999),
    [anon_sym_inline] = ACTIONS(3999),
    [anon_sym___inline] = ACTIONS(3999),
    [anon_sym___inline__] = ACTIONS(3999),
    [anon_sym___forceinline] = ACTIONS(3999),
    [anon_sym_thread_local] = ACTIONS(3999),
    [anon_sym___thread] = ACTIONS(3999),
    [anon_sym_const] = ACTIONS(3999),
    [anon_sym_constexpr] = ACTIONS(3999),
    [anon_sym_volatile] = ACTIONS(3999),
    [anon_sym_restrict] = ACTIONS(3999),
    [anon_sym___restrict__] = ACTIONS(3999),
    [anon_sym__Atomic] = ACTIONS(3999),
    [anon_sym__Noreturn] = ACTIONS(3999),
    [anon_sym_noreturn] = ACTIONS(3999),
    [anon_sym_mutable] = ACTIONS(3999),
    [anon_sym_constinit] = ACTIONS(3999),
    [anon_sym_consteval] = ACTIONS(3999),
    [anon_sym_PROGMEM] = ACTIONS(3999),
    [aux_sym_primitive_type_token1] = ACTIONS(3999),
    [anon_sym_byte] = ACTIONS(3999),
    [anon_sym_word] = ACTIONS(3999),
    [anon_sym_enum] = ACTIONS(3999),
    [anon_sym_class] = ACTIONS(3999),
    [anon_sym_struct] = ACTIONS(3999),
    [anon_sym_union] = ACTIONS(3999),
    [anon_sym_if] = ACTIONS(3999),
    [anon_sym_switch] = ACTIONS(3999),
    [anon_sym_case] = ACTIONS(3999),
    [anon_sym_default] = ACTIONS(3999),
    [anon_sym_while] = ACTIONS(3999),
    [anon_sym_do] = ACTIONS(3999),
    [anon_sym_for] = ACTIONS(3999),
    [anon_sym_return] = ACTIONS(3999),
    [anon_sym_break] = ACTIONS(3999),
    [anon_sym_continue] = ACTIONS(3999),
    [anon_sym_goto] = ACTIONS(3999),
    [anon_sym_not] = ACTIONS(3999),
    [anon_sym_compl] = ACTIONS(3999),
    [anon_sym_DASH_DASH] = ACTIONS(3997),
    [anon_sym_PLUS_PLUS] = ACTIONS(3997),
    [anon_sym_sizeof] = ACTIONS(3999),
    [anon_sym___alignof__] = ACTIONS(3999),
    [anon_sym___alignof] = ACTIONS(3999),
    [anon_sym__alignof] = ACTIONS(3999),
    [anon_sym_alignof] = ACTIONS(3999),
    [anon_sym__Alignof] = ACTIONS(3999),
    [anon_sym_offsetof] = ACTIONS(3999),
    [anon_sym__Generic] = ACTIONS(3999),
    [anon_sym_asm] = ACTIONS(3999),
    [anon_sym___asm__] = ACTIONS(3999),
    [aux_sym_number_literal_token1] = ACTIONS(3997),
    [aux_sym_number_literal_token2] = ACTIONS(3999),
    [anon_sym_L_SQUOTE] = ACTIONS(3997),
    [anon_sym_u_SQUOTE] = ACTIONS(3997),
    [anon_sym_U_SQUOTE] = ACTIONS(3997),
    [anon_sym_u8_SQUOTE] = ACTIONS(3997),
    [anon_sym_SQUOTE] = ACTIONS(3997),
    [anon_sym_L_DQUOTE] = ACTIONS(3997),
    [anon_sym_u_DQUOTE] = ACTIONS(3997),
    [anon_sym_U_DQUOTE] = ACTIONS(3997),
    [anon_sym_u8_DQUOTE] = ACTIONS(3997),
    [anon_sym_DQUOTE] = ACTIONS(3997),
    [sym_true] = ACTIONS(3999),
    [sym_false] = ACTIONS(3999),
    [anon_sym_NULL] = ACTIONS(3999),
    [anon_sym_nullptr] = ACTIONS(3999),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3999),
    [anon_sym_decltype] = ACTIONS(3999),
    [anon_sym_virtual] = ACTIONS(3999),
    [anon_sym_alignas] = ACTIONS(3999),
    [anon_sym_explicit] = ACTIONS(3999),
    [anon_sym_typename] = ACTIONS(3999),
    [anon_sym_template] = ACTIONS(3999),
    [anon_sym_operator] = ACTIONS(3999),
    [anon_sym_try] = ACTIONS(3999),
    [anon_sym_delete] = ACTIONS(3999),
    [anon_sym_throw] = ACTIONS(3999),
    [anon_sym_namespace] = ACTIONS(3999),
    [anon_sym_using] = ACTIONS(3999),
    [anon_sym_static_assert] = ACTIONS(3999),
    [anon_sym_concept] = ACTIONS(3999),
    [anon_sym_co_return] = ACTIONS(3999),
    [anon_sym_co_yield] = ACTIONS(3999),
    [anon_sym_R_DQUOTE] = ACTIONS(3997),
    [anon_sym_LR_DQUOTE] = ACTIONS(3997),
    [anon_sym_uR_DQUOTE] = ACTIONS(3997),
    [anon_sym_UR_DQUOTE] = ACTIONS(3997),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3997),
    [anon_sym_co_await] = ACTIONS(3999),
    [anon_sym_new] = ACTIONS(3999),
    [anon_sym_requires] = ACTIONS(3999),
    [sym_this] = ACTIONS(3999),
  },
  [1075] = {
    [ts_builtin_sym_end] = ACTIONS(3363),
    [sym_identifier] = ACTIONS(3361),
    [aux_sym_preproc_include_token1] = ACTIONS(3361),
    [aux_sym_preproc_def_token1] = ACTIONS(3361),
    [aux_sym_preproc_if_token1] = ACTIONS(3361),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3361),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3361),
    [sym_preproc_directive] = ACTIONS(3361),
    [anon_sym_LPAREN2] = ACTIONS(3363),
    [anon_sym_BANG] = ACTIONS(3363),
    [anon_sym_TILDE] = ACTIONS(3363),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_STAR] = ACTIONS(3363),
    [anon_sym_AMP_AMP] = ACTIONS(3363),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym___extension__] = ACTIONS(3361),
    [anon_sym_typedef] = ACTIONS(3361),
    [anon_sym_extern] = ACTIONS(3361),
    [anon_sym___attribute__] = ACTIONS(3361),
    [anon_sym_COLON_COLON] = ACTIONS(3363),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3363),
    [anon_sym___declspec] = ACTIONS(3361),
    [anon_sym___based] = ACTIONS(3361),
    [anon_sym___cdecl] = ACTIONS(3361),
    [anon_sym___clrcall] = ACTIONS(3361),
    [anon_sym___stdcall] = ACTIONS(3361),
    [anon_sym___fastcall] = ACTIONS(3361),
    [anon_sym___thiscall] = ACTIONS(3361),
    [anon_sym___vectorcall] = ACTIONS(3361),
    [anon_sym_LBRACE] = ACTIONS(3363),
    [anon_sym_signed] = ACTIONS(3361),
    [anon_sym_unsigned] = ACTIONS(3361),
    [anon_sym_long] = ACTIONS(3361),
    [anon_sym_short] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_static] = ACTIONS(3361),
    [anon_sym_register] = ACTIONS(3361),
    [anon_sym_inline] = ACTIONS(3361),
    [anon_sym___inline] = ACTIONS(3361),
    [anon_sym___inline__] = ACTIONS(3361),
    [anon_sym___forceinline] = ACTIONS(3361),
    [anon_sym_thread_local] = ACTIONS(3361),
    [anon_sym___thread] = ACTIONS(3361),
    [anon_sym_const] = ACTIONS(3361),
    [anon_sym_constexpr] = ACTIONS(3361),
    [anon_sym_volatile] = ACTIONS(3361),
    [anon_sym_restrict] = ACTIONS(3361),
    [anon_sym___restrict__] = ACTIONS(3361),
    [anon_sym__Atomic] = ACTIONS(3361),
    [anon_sym__Noreturn] = ACTIONS(3361),
    [anon_sym_noreturn] = ACTIONS(3361),
    [anon_sym_mutable] = ACTIONS(3361),
    [anon_sym_constinit] = ACTIONS(3361),
    [anon_sym_consteval] = ACTIONS(3361),
    [anon_sym_PROGMEM] = ACTIONS(3361),
    [aux_sym_primitive_type_token1] = ACTIONS(3361),
    [anon_sym_byte] = ACTIONS(3361),
    [anon_sym_word] = ACTIONS(3361),
    [anon_sym_enum] = ACTIONS(3361),
    [anon_sym_class] = ACTIONS(3361),
    [anon_sym_struct] = ACTIONS(3361),
    [anon_sym_union] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_switch] = ACTIONS(3361),
    [anon_sym_case] = ACTIONS(3361),
    [anon_sym_default] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_break] = ACTIONS(3361),
    [anon_sym_continue] = ACTIONS(3361),
    [anon_sym_goto] = ACTIONS(3361),
    [anon_sym_not] = ACTIONS(3361),
    [anon_sym_compl] = ACTIONS(3361),
    [anon_sym_DASH_DASH] = ACTIONS(3363),
    [anon_sym_PLUS_PLUS] = ACTIONS(3363),
    [anon_sym_sizeof] = ACTIONS(3361),
    [anon_sym___alignof__] = ACTIONS(3361),
    [anon_sym___alignof] = ACTIONS(3361),
    [anon_sym__alignof] = ACTIONS(3361),
    [anon_sym_alignof] = ACTIONS(3361),
    [anon_sym__Alignof] = ACTIONS(3361),
    [anon_sym_offsetof] = ACTIONS(3361),
    [anon_sym__Generic] = ACTIONS(3361),
    [anon_sym_asm] = ACTIONS(3361),
    [anon_sym___asm__] = ACTIONS(3361),
    [aux_sym_number_literal_token1] = ACTIONS(3363),
    [aux_sym_number_literal_token2] = ACTIONS(3361),
    [anon_sym_L_SQUOTE] = ACTIONS(3363),
    [anon_sym_u_SQUOTE] = ACTIONS(3363),
    [anon_sym_U_SQUOTE] = ACTIONS(3363),
    [anon_sym_u8_SQUOTE] = ACTIONS(3363),
    [anon_sym_SQUOTE] = ACTIONS(3363),
    [anon_sym_L_DQUOTE] = ACTIONS(3363),
    [anon_sym_u_DQUOTE] = ACTIONS(3363),
    [anon_sym_U_DQUOTE] = ACTIONS(3363),
    [anon_sym_u8_DQUOTE] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3363),
    [sym_true] = ACTIONS(3361),
    [sym_false] = ACTIONS(3361),
    [anon_sym_NULL] = ACTIONS(3361),
    [anon_sym_nullptr] = ACTIONS(3361),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3361),
    [anon_sym_decltype] = ACTIONS(3361),
    [anon_sym_virtual] = ACTIONS(3361),
    [anon_sym_alignas] = ACTIONS(3361),
    [anon_sym_explicit] = ACTIONS(3361),
    [anon_sym_typename] = ACTIONS(3361),
    [anon_sym_template] = ACTIONS(3361),
    [anon_sym_operator] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_delete] = ACTIONS(3361),
    [anon_sym_throw] = ACTIONS(3361),
    [anon_sym_namespace] = ACTIONS(3361),
    [anon_sym_using] = ACTIONS(3361),
    [anon_sym_static_assert] = ACTIONS(3361),
    [anon_sym_concept] = ACTIONS(3361),
    [anon_sym_co_return] = ACTIONS(3361),
    [anon_sym_co_yield] = ACTIONS(3361),
    [anon_sym_R_DQUOTE] = ACTIONS(3363),
    [anon_sym_LR_DQUOTE] = ACTIONS(3363),
    [anon_sym_uR_DQUOTE] = ACTIONS(3363),
    [anon_sym_UR_DQUOTE] = ACTIONS(3363),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3363),
    [anon_sym_co_await] = ACTIONS(3361),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_requires] = ACTIONS(3361),
    [sym_this] = ACTIONS(3361),
  },
  [1076] = {
    [sym_preproc_def] = STATE(1056),
    [sym_preproc_function_def] = STATE(1056),
    [sym_preproc_call] = STATE(1056),
    [sym_preproc_if_in_field_declaration_list] = STATE(1056),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1056),
    [sym_type_definition] = STATE(1056),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1056),
    [sym_field_declaration] = STATE(1056),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1056),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1056),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1056),
    [sym_operator_cast_declaration] = STATE(1056),
    [sym_constructor_or_destructor_definition] = STATE(1056),
    [sym_constructor_or_destructor_declaration] = STATE(1056),
    [sym_friend_declaration] = STATE(1056),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1056),
    [sym_alias_declaration] = STATE(1056),
    [sym_static_assert_declaration] = STATE(1056),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1056),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3829),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3829),
    [sym_preproc_directive] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3833),
    [anon_sym_typedef] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(4001),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_static_assert] = ACTIONS(3845),
  },
  [1077] = {
    [ts_builtin_sym_end] = ACTIONS(3359),
    [sym_identifier] = ACTIONS(3357),
    [aux_sym_preproc_include_token1] = ACTIONS(3357),
    [aux_sym_preproc_def_token1] = ACTIONS(3357),
    [aux_sym_preproc_if_token1] = ACTIONS(3357),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3357),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3357),
    [sym_preproc_directive] = ACTIONS(3357),
    [anon_sym_LPAREN2] = ACTIONS(3359),
    [anon_sym_BANG] = ACTIONS(3359),
    [anon_sym_TILDE] = ACTIONS(3359),
    [anon_sym_DASH] = ACTIONS(3357),
    [anon_sym_PLUS] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(3359),
    [anon_sym_AMP_AMP] = ACTIONS(3359),
    [anon_sym_AMP] = ACTIONS(3357),
    [anon_sym___extension__] = ACTIONS(3357),
    [anon_sym_typedef] = ACTIONS(3357),
    [anon_sym_extern] = ACTIONS(3357),
    [anon_sym___attribute__] = ACTIONS(3357),
    [anon_sym_COLON_COLON] = ACTIONS(3359),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3359),
    [anon_sym___declspec] = ACTIONS(3357),
    [anon_sym___based] = ACTIONS(3357),
    [anon_sym___cdecl] = ACTIONS(3357),
    [anon_sym___clrcall] = ACTIONS(3357),
    [anon_sym___stdcall] = ACTIONS(3357),
    [anon_sym___fastcall] = ACTIONS(3357),
    [anon_sym___thiscall] = ACTIONS(3357),
    [anon_sym___vectorcall] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3359),
    [anon_sym_signed] = ACTIONS(3357),
    [anon_sym_unsigned] = ACTIONS(3357),
    [anon_sym_long] = ACTIONS(3357),
    [anon_sym_short] = ACTIONS(3357),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_static] = ACTIONS(3357),
    [anon_sym_register] = ACTIONS(3357),
    [anon_sym_inline] = ACTIONS(3357),
    [anon_sym___inline] = ACTIONS(3357),
    [anon_sym___inline__] = ACTIONS(3357),
    [anon_sym___forceinline] = ACTIONS(3357),
    [anon_sym_thread_local] = ACTIONS(3357),
    [anon_sym___thread] = ACTIONS(3357),
    [anon_sym_const] = ACTIONS(3357),
    [anon_sym_constexpr] = ACTIONS(3357),
    [anon_sym_volatile] = ACTIONS(3357),
    [anon_sym_restrict] = ACTIONS(3357),
    [anon_sym___restrict__] = ACTIONS(3357),
    [anon_sym__Atomic] = ACTIONS(3357),
    [anon_sym__Noreturn] = ACTIONS(3357),
    [anon_sym_noreturn] = ACTIONS(3357),
    [anon_sym_mutable] = ACTIONS(3357),
    [anon_sym_constinit] = ACTIONS(3357),
    [anon_sym_consteval] = ACTIONS(3357),
    [anon_sym_PROGMEM] = ACTIONS(3357),
    [aux_sym_primitive_type_token1] = ACTIONS(3357),
    [anon_sym_byte] = ACTIONS(3357),
    [anon_sym_word] = ACTIONS(3357),
    [anon_sym_enum] = ACTIONS(3357),
    [anon_sym_class] = ACTIONS(3357),
    [anon_sym_struct] = ACTIONS(3357),
    [anon_sym_union] = ACTIONS(3357),
    [anon_sym_if] = ACTIONS(3357),
    [anon_sym_switch] = ACTIONS(3357),
    [anon_sym_case] = ACTIONS(3357),
    [anon_sym_default] = ACTIONS(3357),
    [anon_sym_while] = ACTIONS(3357),
    [anon_sym_do] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3357),
    [anon_sym_return] = ACTIONS(3357),
    [anon_sym_break] = ACTIONS(3357),
    [anon_sym_continue] = ACTIONS(3357),
    [anon_sym_goto] = ACTIONS(3357),
    [anon_sym_not] = ACTIONS(3357),
    [anon_sym_compl] = ACTIONS(3357),
    [anon_sym_DASH_DASH] = ACTIONS(3359),
    [anon_sym_PLUS_PLUS] = ACTIONS(3359),
    [anon_sym_sizeof] = ACTIONS(3357),
    [anon_sym___alignof__] = ACTIONS(3357),
    [anon_sym___alignof] = ACTIONS(3357),
    [anon_sym__alignof] = ACTIONS(3357),
    [anon_sym_alignof] = ACTIONS(3357),
    [anon_sym__Alignof] = ACTIONS(3357),
    [anon_sym_offsetof] = ACTIONS(3357),
    [anon_sym__Generic] = ACTIONS(3357),
    [anon_sym_asm] = ACTIONS(3357),
    [anon_sym___asm__] = ACTIONS(3357),
    [aux_sym_number_literal_token1] = ACTIONS(3359),
    [aux_sym_number_literal_token2] = ACTIONS(3357),
    [anon_sym_L_SQUOTE] = ACTIONS(3359),
    [anon_sym_u_SQUOTE] = ACTIONS(3359),
    [anon_sym_U_SQUOTE] = ACTIONS(3359),
    [anon_sym_u8_SQUOTE] = ACTIONS(3359),
    [anon_sym_SQUOTE] = ACTIONS(3359),
    [anon_sym_L_DQUOTE] = ACTIONS(3359),
    [anon_sym_u_DQUOTE] = ACTIONS(3359),
    [anon_sym_U_DQUOTE] = ACTIONS(3359),
    [anon_sym_u8_DQUOTE] = ACTIONS(3359),
    [anon_sym_DQUOTE] = ACTIONS(3359),
    [sym_true] = ACTIONS(3357),
    [sym_false] = ACTIONS(3357),
    [anon_sym_NULL] = ACTIONS(3357),
    [anon_sym_nullptr] = ACTIONS(3357),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3357),
    [anon_sym_decltype] = ACTIONS(3357),
    [anon_sym_virtual] = ACTIONS(3357),
    [anon_sym_alignas] = ACTIONS(3357),
    [anon_sym_explicit] = ACTIONS(3357),
    [anon_sym_typename] = ACTIONS(3357),
    [anon_sym_template] = ACTIONS(3357),
    [anon_sym_operator] = ACTIONS(3357),
    [anon_sym_try] = ACTIONS(3357),
    [anon_sym_delete] = ACTIONS(3357),
    [anon_sym_throw] = ACTIONS(3357),
    [anon_sym_namespace] = ACTIONS(3357),
    [anon_sym_using] = ACTIONS(3357),
    [anon_sym_static_assert] = ACTIONS(3357),
    [anon_sym_concept] = ACTIONS(3357),
    [anon_sym_co_return] = ACTIONS(3357),
    [anon_sym_co_yield] = ACTIONS(3357),
    [anon_sym_R_DQUOTE] = ACTIONS(3359),
    [anon_sym_LR_DQUOTE] = ACTIONS(3359),
    [anon_sym_uR_DQUOTE] = ACTIONS(3359),
    [anon_sym_UR_DQUOTE] = ACTIONS(3359),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3359),
    [anon_sym_co_await] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3357),
    [anon_sym_requires] = ACTIONS(3357),
    [sym_this] = ACTIONS(3357),
  },
  [1078] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5301),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_initializer_list] = STATE(4671),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2151),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_LPAREN2] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(4005),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(2151),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_PERCENT] = ACTIONS(2151),
    [anon_sym_PIPE_PIPE] = ACTIONS(2151),
    [anon_sym_AMP_AMP] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(2149),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2149),
    [anon_sym_EQ_EQ] = ACTIONS(2151),
    [anon_sym_BANG_EQ] = ACTIONS(2151),
    [anon_sym_GT] = ACTIONS(2149),
    [anon_sym_GT_EQ] = ACTIONS(2151),
    [anon_sym_LT_EQ] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_LT_LT] = ACTIONS(2151),
    [anon_sym_GT_GT] = ACTIONS(2151),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(2149),
    [anon_sym_QMARK] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_LT_EQ_GT] = ACTIONS(2151),
    [anon_sym_or] = ACTIONS(2149),
    [anon_sym_and] = ACTIONS(2149),
    [anon_sym_bitor] = ACTIONS(2149),
    [anon_sym_xor] = ACTIONS(2149),
    [anon_sym_bitand] = ACTIONS(2149),
    [anon_sym_not_eq] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(2149),
    [anon_sym_DOT_STAR] = ACTIONS(2151),
    [anon_sym_DASH_GT] = ACTIONS(2151),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1079] = {
    [ts_builtin_sym_end] = ACTIONS(3515),
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_include_token1] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_BANG] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3513),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym___cdecl] = ACTIONS(3513),
    [anon_sym___clrcall] = ACTIONS(3513),
    [anon_sym___stdcall] = ACTIONS(3513),
    [anon_sym___fastcall] = ACTIONS(3513),
    [anon_sym___thiscall] = ACTIONS(3513),
    [anon_sym___vectorcall] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_PROGMEM] = ACTIONS(3513),
    [aux_sym_primitive_type_token1] = ACTIONS(3513),
    [anon_sym_byte] = ACTIONS(3513),
    [anon_sym_word] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [anon_sym_if] = ACTIONS(3513),
    [anon_sym_switch] = ACTIONS(3513),
    [anon_sym_case] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3513),
    [anon_sym_while] = ACTIONS(3513),
    [anon_sym_do] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3513),
    [anon_sym_return] = ACTIONS(3513),
    [anon_sym_break] = ACTIONS(3513),
    [anon_sym_continue] = ACTIONS(3513),
    [anon_sym_goto] = ACTIONS(3513),
    [anon_sym_not] = ACTIONS(3513),
    [anon_sym_compl] = ACTIONS(3513),
    [anon_sym_DASH_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_PLUS] = ACTIONS(3515),
    [anon_sym_sizeof] = ACTIONS(3513),
    [anon_sym___alignof__] = ACTIONS(3513),
    [anon_sym___alignof] = ACTIONS(3513),
    [anon_sym__alignof] = ACTIONS(3513),
    [anon_sym_alignof] = ACTIONS(3513),
    [anon_sym__Alignof] = ACTIONS(3513),
    [anon_sym_offsetof] = ACTIONS(3513),
    [anon_sym__Generic] = ACTIONS(3513),
    [anon_sym_asm] = ACTIONS(3513),
    [anon_sym___asm__] = ACTIONS(3513),
    [aux_sym_number_literal_token1] = ACTIONS(3515),
    [aux_sym_number_literal_token2] = ACTIONS(3513),
    [anon_sym_L_SQUOTE] = ACTIONS(3515),
    [anon_sym_u_SQUOTE] = ACTIONS(3515),
    [anon_sym_U_SQUOTE] = ACTIONS(3515),
    [anon_sym_u8_SQUOTE] = ACTIONS(3515),
    [anon_sym_SQUOTE] = ACTIONS(3515),
    [anon_sym_L_DQUOTE] = ACTIONS(3515),
    [anon_sym_u_DQUOTE] = ACTIONS(3515),
    [anon_sym_U_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [sym_true] = ACTIONS(3513),
    [sym_false] = ACTIONS(3513),
    [anon_sym_NULL] = ACTIONS(3513),
    [anon_sym_nullptr] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [anon_sym_virtual] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3513),
    [anon_sym_delete] = ACTIONS(3513),
    [anon_sym_throw] = ACTIONS(3513),
    [anon_sym_namespace] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
    [anon_sym_concept] = ACTIONS(3513),
    [anon_sym_co_return] = ACTIONS(3513),
    [anon_sym_co_yield] = ACTIONS(3513),
    [anon_sym_R_DQUOTE] = ACTIONS(3515),
    [anon_sym_LR_DQUOTE] = ACTIONS(3515),
    [anon_sym_uR_DQUOTE] = ACTIONS(3515),
    [anon_sym_UR_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3515),
    [anon_sym_co_await] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3513),
    [anon_sym_requires] = ACTIONS(3513),
    [sym_this] = ACTIONS(3513),
  },
  [1080] = {
    [ts_builtin_sym_end] = ACTIONS(3515),
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_include_token1] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_BANG] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3513),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym___cdecl] = ACTIONS(3513),
    [anon_sym___clrcall] = ACTIONS(3513),
    [anon_sym___stdcall] = ACTIONS(3513),
    [anon_sym___fastcall] = ACTIONS(3513),
    [anon_sym___thiscall] = ACTIONS(3513),
    [anon_sym___vectorcall] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_PROGMEM] = ACTIONS(3513),
    [aux_sym_primitive_type_token1] = ACTIONS(3513),
    [anon_sym_byte] = ACTIONS(3513),
    [anon_sym_word] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [anon_sym_if] = ACTIONS(3513),
    [anon_sym_switch] = ACTIONS(3513),
    [anon_sym_case] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3513),
    [anon_sym_while] = ACTIONS(3513),
    [anon_sym_do] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3513),
    [anon_sym_return] = ACTIONS(3513),
    [anon_sym_break] = ACTIONS(3513),
    [anon_sym_continue] = ACTIONS(3513),
    [anon_sym_goto] = ACTIONS(3513),
    [anon_sym_not] = ACTIONS(3513),
    [anon_sym_compl] = ACTIONS(3513),
    [anon_sym_DASH_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_PLUS] = ACTIONS(3515),
    [anon_sym_sizeof] = ACTIONS(3513),
    [anon_sym___alignof__] = ACTIONS(3513),
    [anon_sym___alignof] = ACTIONS(3513),
    [anon_sym__alignof] = ACTIONS(3513),
    [anon_sym_alignof] = ACTIONS(3513),
    [anon_sym__Alignof] = ACTIONS(3513),
    [anon_sym_offsetof] = ACTIONS(3513),
    [anon_sym__Generic] = ACTIONS(3513),
    [anon_sym_asm] = ACTIONS(3513),
    [anon_sym___asm__] = ACTIONS(3513),
    [aux_sym_number_literal_token1] = ACTIONS(3515),
    [aux_sym_number_literal_token2] = ACTIONS(3513),
    [anon_sym_L_SQUOTE] = ACTIONS(3515),
    [anon_sym_u_SQUOTE] = ACTIONS(3515),
    [anon_sym_U_SQUOTE] = ACTIONS(3515),
    [anon_sym_u8_SQUOTE] = ACTIONS(3515),
    [anon_sym_SQUOTE] = ACTIONS(3515),
    [anon_sym_L_DQUOTE] = ACTIONS(3515),
    [anon_sym_u_DQUOTE] = ACTIONS(3515),
    [anon_sym_U_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [sym_true] = ACTIONS(3513),
    [sym_false] = ACTIONS(3513),
    [anon_sym_NULL] = ACTIONS(3513),
    [anon_sym_nullptr] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [anon_sym_virtual] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3513),
    [anon_sym_delete] = ACTIONS(3513),
    [anon_sym_throw] = ACTIONS(3513),
    [anon_sym_namespace] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
    [anon_sym_concept] = ACTIONS(3513),
    [anon_sym_co_return] = ACTIONS(3513),
    [anon_sym_co_yield] = ACTIONS(3513),
    [anon_sym_R_DQUOTE] = ACTIONS(3515),
    [anon_sym_LR_DQUOTE] = ACTIONS(3515),
    [anon_sym_uR_DQUOTE] = ACTIONS(3515),
    [anon_sym_UR_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3515),
    [anon_sym_co_await] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3513),
    [anon_sym_requires] = ACTIONS(3513),
    [sym_this] = ACTIONS(3513),
  },
  [1081] = {
    [ts_builtin_sym_end] = ACTIONS(3264),
    [sym_identifier] = ACTIONS(3262),
    [aux_sym_preproc_include_token1] = ACTIONS(3262),
    [aux_sym_preproc_def_token1] = ACTIONS(3262),
    [aux_sym_preproc_if_token1] = ACTIONS(3262),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3262),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3262),
    [sym_preproc_directive] = ACTIONS(3262),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_BANG] = ACTIONS(3264),
    [anon_sym_TILDE] = ACTIONS(3264),
    [anon_sym_DASH] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3262),
    [anon_sym_STAR] = ACTIONS(3264),
    [anon_sym_AMP_AMP] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3262),
    [anon_sym___extension__] = ACTIONS(3262),
    [anon_sym_typedef] = ACTIONS(3262),
    [anon_sym_extern] = ACTIONS(3262),
    [anon_sym___attribute__] = ACTIONS(3262),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3264),
    [anon_sym___declspec] = ACTIONS(3262),
    [anon_sym___based] = ACTIONS(3262),
    [anon_sym___cdecl] = ACTIONS(3262),
    [anon_sym___clrcall] = ACTIONS(3262),
    [anon_sym___stdcall] = ACTIONS(3262),
    [anon_sym___fastcall] = ACTIONS(3262),
    [anon_sym___thiscall] = ACTIONS(3262),
    [anon_sym___vectorcall] = ACTIONS(3262),
    [anon_sym_LBRACE] = ACTIONS(3264),
    [anon_sym_signed] = ACTIONS(3262),
    [anon_sym_unsigned] = ACTIONS(3262),
    [anon_sym_long] = ACTIONS(3262),
    [anon_sym_short] = ACTIONS(3262),
    [anon_sym_LBRACK] = ACTIONS(3262),
    [anon_sym_static] = ACTIONS(3262),
    [anon_sym_register] = ACTIONS(3262),
    [anon_sym_inline] = ACTIONS(3262),
    [anon_sym___inline] = ACTIONS(3262),
    [anon_sym___inline__] = ACTIONS(3262),
    [anon_sym___forceinline] = ACTIONS(3262),
    [anon_sym_thread_local] = ACTIONS(3262),
    [anon_sym___thread] = ACTIONS(3262),
    [anon_sym_const] = ACTIONS(3262),
    [anon_sym_constexpr] = ACTIONS(3262),
    [anon_sym_volatile] = ACTIONS(3262),
    [anon_sym_restrict] = ACTIONS(3262),
    [anon_sym___restrict__] = ACTIONS(3262),
    [anon_sym__Atomic] = ACTIONS(3262),
    [anon_sym__Noreturn] = ACTIONS(3262),
    [anon_sym_noreturn] = ACTIONS(3262),
    [anon_sym_mutable] = ACTIONS(3262),
    [anon_sym_constinit] = ACTIONS(3262),
    [anon_sym_consteval] = ACTIONS(3262),
    [anon_sym_PROGMEM] = ACTIONS(3262),
    [aux_sym_primitive_type_token1] = ACTIONS(3262),
    [anon_sym_byte] = ACTIONS(3262),
    [anon_sym_word] = ACTIONS(3262),
    [anon_sym_enum] = ACTIONS(3262),
    [anon_sym_class] = ACTIONS(3262),
    [anon_sym_struct] = ACTIONS(3262),
    [anon_sym_union] = ACTIONS(3262),
    [anon_sym_if] = ACTIONS(3262),
    [anon_sym_switch] = ACTIONS(3262),
    [anon_sym_case] = ACTIONS(3262),
    [anon_sym_default] = ACTIONS(3262),
    [anon_sym_while] = ACTIONS(3262),
    [anon_sym_do] = ACTIONS(3262),
    [anon_sym_for] = ACTIONS(3262),
    [anon_sym_return] = ACTIONS(3262),
    [anon_sym_break] = ACTIONS(3262),
    [anon_sym_continue] = ACTIONS(3262),
    [anon_sym_goto] = ACTIONS(3262),
    [anon_sym_not] = ACTIONS(3262),
    [anon_sym_compl] = ACTIONS(3262),
    [anon_sym_DASH_DASH] = ACTIONS(3264),
    [anon_sym_PLUS_PLUS] = ACTIONS(3264),
    [anon_sym_sizeof] = ACTIONS(3262),
    [anon_sym___alignof__] = ACTIONS(3262),
    [anon_sym___alignof] = ACTIONS(3262),
    [anon_sym__alignof] = ACTIONS(3262),
    [anon_sym_alignof] = ACTIONS(3262),
    [anon_sym__Alignof] = ACTIONS(3262),
    [anon_sym_offsetof] = ACTIONS(3262),
    [anon_sym__Generic] = ACTIONS(3262),
    [anon_sym_asm] = ACTIONS(3262),
    [anon_sym___asm__] = ACTIONS(3262),
    [aux_sym_number_literal_token1] = ACTIONS(3264),
    [aux_sym_number_literal_token2] = ACTIONS(3262),
    [anon_sym_L_SQUOTE] = ACTIONS(3264),
    [anon_sym_u_SQUOTE] = ACTIONS(3264),
    [anon_sym_U_SQUOTE] = ACTIONS(3264),
    [anon_sym_u8_SQUOTE] = ACTIONS(3264),
    [anon_sym_SQUOTE] = ACTIONS(3264),
    [anon_sym_L_DQUOTE] = ACTIONS(3264),
    [anon_sym_u_DQUOTE] = ACTIONS(3264),
    [anon_sym_U_DQUOTE] = ACTIONS(3264),
    [anon_sym_u8_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE] = ACTIONS(3264),
    [sym_true] = ACTIONS(3262),
    [sym_false] = ACTIONS(3262),
    [anon_sym_NULL] = ACTIONS(3262),
    [anon_sym_nullptr] = ACTIONS(3262),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3262),
    [anon_sym_decltype] = ACTIONS(3262),
    [anon_sym_virtual] = ACTIONS(3262),
    [anon_sym_alignas] = ACTIONS(3262),
    [anon_sym_explicit] = ACTIONS(3262),
    [anon_sym_typename] = ACTIONS(3262),
    [anon_sym_template] = ACTIONS(3262),
    [anon_sym_operator] = ACTIONS(3262),
    [anon_sym_try] = ACTIONS(3262),
    [anon_sym_delete] = ACTIONS(3262),
    [anon_sym_throw] = ACTIONS(3262),
    [anon_sym_namespace] = ACTIONS(3262),
    [anon_sym_using] = ACTIONS(3262),
    [anon_sym_static_assert] = ACTIONS(3262),
    [anon_sym_concept] = ACTIONS(3262),
    [anon_sym_co_return] = ACTIONS(3262),
    [anon_sym_co_yield] = ACTIONS(3262),
    [anon_sym_R_DQUOTE] = ACTIONS(3264),
    [anon_sym_LR_DQUOTE] = ACTIONS(3264),
    [anon_sym_uR_DQUOTE] = ACTIONS(3264),
    [anon_sym_UR_DQUOTE] = ACTIONS(3264),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3264),
    [anon_sym_co_await] = ACTIONS(3262),
    [anon_sym_new] = ACTIONS(3262),
    [anon_sym_requires] = ACTIONS(3262),
    [sym_this] = ACTIONS(3262),
  },
  [1082] = {
    [ts_builtin_sym_end] = ACTIONS(3303),
    [sym_identifier] = ACTIONS(3301),
    [aux_sym_preproc_include_token1] = ACTIONS(3301),
    [aux_sym_preproc_def_token1] = ACTIONS(3301),
    [aux_sym_preproc_if_token1] = ACTIONS(3301),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3301),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3301),
    [sym_preproc_directive] = ACTIONS(3301),
    [anon_sym_LPAREN2] = ACTIONS(3303),
    [anon_sym_BANG] = ACTIONS(3303),
    [anon_sym_TILDE] = ACTIONS(3303),
    [anon_sym_DASH] = ACTIONS(3301),
    [anon_sym_PLUS] = ACTIONS(3301),
    [anon_sym_STAR] = ACTIONS(3303),
    [anon_sym_AMP_AMP] = ACTIONS(3303),
    [anon_sym_AMP] = ACTIONS(3301),
    [anon_sym___extension__] = ACTIONS(3301),
    [anon_sym_typedef] = ACTIONS(3301),
    [anon_sym_extern] = ACTIONS(3301),
    [anon_sym___attribute__] = ACTIONS(3301),
    [anon_sym_COLON_COLON] = ACTIONS(3303),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3303),
    [anon_sym___declspec] = ACTIONS(3301),
    [anon_sym___based] = ACTIONS(3301),
    [anon_sym___cdecl] = ACTIONS(3301),
    [anon_sym___clrcall] = ACTIONS(3301),
    [anon_sym___stdcall] = ACTIONS(3301),
    [anon_sym___fastcall] = ACTIONS(3301),
    [anon_sym___thiscall] = ACTIONS(3301),
    [anon_sym___vectorcall] = ACTIONS(3301),
    [anon_sym_LBRACE] = ACTIONS(3303),
    [anon_sym_signed] = ACTIONS(3301),
    [anon_sym_unsigned] = ACTIONS(3301),
    [anon_sym_long] = ACTIONS(3301),
    [anon_sym_short] = ACTIONS(3301),
    [anon_sym_LBRACK] = ACTIONS(3301),
    [anon_sym_static] = ACTIONS(3301),
    [anon_sym_register] = ACTIONS(3301),
    [anon_sym_inline] = ACTIONS(3301),
    [anon_sym___inline] = ACTIONS(3301),
    [anon_sym___inline__] = ACTIONS(3301),
    [anon_sym___forceinline] = ACTIONS(3301),
    [anon_sym_thread_local] = ACTIONS(3301),
    [anon_sym___thread] = ACTIONS(3301),
    [anon_sym_const] = ACTIONS(3301),
    [anon_sym_constexpr] = ACTIONS(3301),
    [anon_sym_volatile] = ACTIONS(3301),
    [anon_sym_restrict] = ACTIONS(3301),
    [anon_sym___restrict__] = ACTIONS(3301),
    [anon_sym__Atomic] = ACTIONS(3301),
    [anon_sym__Noreturn] = ACTIONS(3301),
    [anon_sym_noreturn] = ACTIONS(3301),
    [anon_sym_mutable] = ACTIONS(3301),
    [anon_sym_constinit] = ACTIONS(3301),
    [anon_sym_consteval] = ACTIONS(3301),
    [anon_sym_PROGMEM] = ACTIONS(3301),
    [aux_sym_primitive_type_token1] = ACTIONS(3301),
    [anon_sym_byte] = ACTIONS(3301),
    [anon_sym_word] = ACTIONS(3301),
    [anon_sym_enum] = ACTIONS(3301),
    [anon_sym_class] = ACTIONS(3301),
    [anon_sym_struct] = ACTIONS(3301),
    [anon_sym_union] = ACTIONS(3301),
    [anon_sym_if] = ACTIONS(3301),
    [anon_sym_switch] = ACTIONS(3301),
    [anon_sym_case] = ACTIONS(3301),
    [anon_sym_default] = ACTIONS(3301),
    [anon_sym_while] = ACTIONS(3301),
    [anon_sym_do] = ACTIONS(3301),
    [anon_sym_for] = ACTIONS(3301),
    [anon_sym_return] = ACTIONS(3301),
    [anon_sym_break] = ACTIONS(3301),
    [anon_sym_continue] = ACTIONS(3301),
    [anon_sym_goto] = ACTIONS(3301),
    [anon_sym_not] = ACTIONS(3301),
    [anon_sym_compl] = ACTIONS(3301),
    [anon_sym_DASH_DASH] = ACTIONS(3303),
    [anon_sym_PLUS_PLUS] = ACTIONS(3303),
    [anon_sym_sizeof] = ACTIONS(3301),
    [anon_sym___alignof__] = ACTIONS(3301),
    [anon_sym___alignof] = ACTIONS(3301),
    [anon_sym__alignof] = ACTIONS(3301),
    [anon_sym_alignof] = ACTIONS(3301),
    [anon_sym__Alignof] = ACTIONS(3301),
    [anon_sym_offsetof] = ACTIONS(3301),
    [anon_sym__Generic] = ACTIONS(3301),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [aux_sym_number_literal_token1] = ACTIONS(3303),
    [aux_sym_number_literal_token2] = ACTIONS(3301),
    [anon_sym_L_SQUOTE] = ACTIONS(3303),
    [anon_sym_u_SQUOTE] = ACTIONS(3303),
    [anon_sym_U_SQUOTE] = ACTIONS(3303),
    [anon_sym_u8_SQUOTE] = ACTIONS(3303),
    [anon_sym_SQUOTE] = ACTIONS(3303),
    [anon_sym_L_DQUOTE] = ACTIONS(3303),
    [anon_sym_u_DQUOTE] = ACTIONS(3303),
    [anon_sym_U_DQUOTE] = ACTIONS(3303),
    [anon_sym_u8_DQUOTE] = ACTIONS(3303),
    [anon_sym_DQUOTE] = ACTIONS(3303),
    [sym_true] = ACTIONS(3301),
    [sym_false] = ACTIONS(3301),
    [anon_sym_NULL] = ACTIONS(3301),
    [anon_sym_nullptr] = ACTIONS(3301),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3301),
    [anon_sym_decltype] = ACTIONS(3301),
    [anon_sym_virtual] = ACTIONS(3301),
    [anon_sym_alignas] = ACTIONS(3301),
    [anon_sym_explicit] = ACTIONS(3301),
    [anon_sym_typename] = ACTIONS(3301),
    [anon_sym_template] = ACTIONS(3301),
    [anon_sym_operator] = ACTIONS(3301),
    [anon_sym_try] = ACTIONS(3301),
    [anon_sym_delete] = ACTIONS(3301),
    [anon_sym_throw] = ACTIONS(3301),
    [anon_sym_namespace] = ACTIONS(3301),
    [anon_sym_using] = ACTIONS(3301),
    [anon_sym_static_assert] = ACTIONS(3301),
    [anon_sym_concept] = ACTIONS(3301),
    [anon_sym_co_return] = ACTIONS(3301),
    [anon_sym_co_yield] = ACTIONS(3301),
    [anon_sym_R_DQUOTE] = ACTIONS(3303),
    [anon_sym_LR_DQUOTE] = ACTIONS(3303),
    [anon_sym_uR_DQUOTE] = ACTIONS(3303),
    [anon_sym_UR_DQUOTE] = ACTIONS(3303),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3303),
    [anon_sym_co_await] = ACTIONS(3301),
    [anon_sym_new] = ACTIONS(3301),
    [anon_sym_requires] = ACTIONS(3301),
    [sym_this] = ACTIONS(3301),
  },
  [1083] = {
    [sym_preproc_def] = STATE(1056),
    [sym_preproc_function_def] = STATE(1056),
    [sym_preproc_call] = STATE(1056),
    [sym_preproc_if_in_field_declaration_list] = STATE(1056),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1056),
    [sym_type_definition] = STATE(1056),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1056),
    [sym_field_declaration] = STATE(1056),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1056),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1056),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1056),
    [sym_operator_cast_declaration] = STATE(1056),
    [sym_constructor_or_destructor_definition] = STATE(1056),
    [sym_constructor_or_destructor_declaration] = STATE(1056),
    [sym_friend_declaration] = STATE(1056),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1056),
    [sym_alias_declaration] = STATE(1056),
    [sym_static_assert_declaration] = STATE(1056),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1056),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3829),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3829),
    [sym_preproc_directive] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3833),
    [anon_sym_typedef] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(4017),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_static_assert] = ACTIONS(3845),
  },
  [1084] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5281),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_initializer_list] = STATE(5536),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2151),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_LPAREN2] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2980),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(2151),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_PERCENT] = ACTIONS(2151),
    [anon_sym_PIPE_PIPE] = ACTIONS(2151),
    [anon_sym_AMP_AMP] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(2149),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2149),
    [anon_sym_EQ_EQ] = ACTIONS(2151),
    [anon_sym_BANG_EQ] = ACTIONS(2151),
    [anon_sym_GT] = ACTIONS(2149),
    [anon_sym_GT_EQ] = ACTIONS(2149),
    [anon_sym_LT_EQ] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_LT_LT] = ACTIONS(2151),
    [anon_sym_GT_GT] = ACTIONS(2149),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_LT_EQ_GT] = ACTIONS(2151),
    [anon_sym_or] = ACTIONS(2149),
    [anon_sym_and] = ACTIONS(2149),
    [anon_sym_bitor] = ACTIONS(2149),
    [anon_sym_xor] = ACTIONS(2149),
    [anon_sym_bitand] = ACTIONS(2149),
    [anon_sym_not_eq] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [anon_sym_DOT] = ACTIONS(2149),
    [anon_sym_DOT_STAR] = ACTIONS(2151),
    [anon_sym_DASH_GT] = ACTIONS(2151),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_GT2] = ACTIONS(2151),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1085] = {
    [ts_builtin_sym_end] = ACTIONS(3505),
    [sym_identifier] = ACTIONS(3503),
    [aux_sym_preproc_include_token1] = ACTIONS(3503),
    [aux_sym_preproc_def_token1] = ACTIONS(3503),
    [aux_sym_preproc_if_token1] = ACTIONS(3503),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3503),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3503),
    [sym_preproc_directive] = ACTIONS(3503),
    [anon_sym_LPAREN2] = ACTIONS(3505),
    [anon_sym_BANG] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3503),
    [anon_sym_PLUS] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP] = ACTIONS(3503),
    [anon_sym___extension__] = ACTIONS(3503),
    [anon_sym_typedef] = ACTIONS(3503),
    [anon_sym_extern] = ACTIONS(3503),
    [anon_sym___attribute__] = ACTIONS(3503),
    [anon_sym_COLON_COLON] = ACTIONS(3505),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3505),
    [anon_sym___declspec] = ACTIONS(3503),
    [anon_sym___based] = ACTIONS(3503),
    [anon_sym___cdecl] = ACTIONS(3503),
    [anon_sym___clrcall] = ACTIONS(3503),
    [anon_sym___stdcall] = ACTIONS(3503),
    [anon_sym___fastcall] = ACTIONS(3503),
    [anon_sym___thiscall] = ACTIONS(3503),
    [anon_sym___vectorcall] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_signed] = ACTIONS(3503),
    [anon_sym_unsigned] = ACTIONS(3503),
    [anon_sym_long] = ACTIONS(3503),
    [anon_sym_short] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3503),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_register] = ACTIONS(3503),
    [anon_sym_inline] = ACTIONS(3503),
    [anon_sym___inline] = ACTIONS(3503),
    [anon_sym___inline__] = ACTIONS(3503),
    [anon_sym___forceinline] = ACTIONS(3503),
    [anon_sym_thread_local] = ACTIONS(3503),
    [anon_sym___thread] = ACTIONS(3503),
    [anon_sym_const] = ACTIONS(3503),
    [anon_sym_constexpr] = ACTIONS(3503),
    [anon_sym_volatile] = ACTIONS(3503),
    [anon_sym_restrict] = ACTIONS(3503),
    [anon_sym___restrict__] = ACTIONS(3503),
    [anon_sym__Atomic] = ACTIONS(3503),
    [anon_sym__Noreturn] = ACTIONS(3503),
    [anon_sym_noreturn] = ACTIONS(3503),
    [anon_sym_mutable] = ACTIONS(3503),
    [anon_sym_constinit] = ACTIONS(3503),
    [anon_sym_consteval] = ACTIONS(3503),
    [anon_sym_PROGMEM] = ACTIONS(3503),
    [aux_sym_primitive_type_token1] = ACTIONS(3503),
    [anon_sym_byte] = ACTIONS(3503),
    [anon_sym_word] = ACTIONS(3503),
    [anon_sym_enum] = ACTIONS(3503),
    [anon_sym_class] = ACTIONS(3503),
    [anon_sym_struct] = ACTIONS(3503),
    [anon_sym_union] = ACTIONS(3503),
    [anon_sym_if] = ACTIONS(3503),
    [anon_sym_switch] = ACTIONS(3503),
    [anon_sym_case] = ACTIONS(3503),
    [anon_sym_default] = ACTIONS(3503),
    [anon_sym_while] = ACTIONS(3503),
    [anon_sym_do] = ACTIONS(3503),
    [anon_sym_for] = ACTIONS(3503),
    [anon_sym_return] = ACTIONS(3503),
    [anon_sym_break] = ACTIONS(3503),
    [anon_sym_continue] = ACTIONS(3503),
    [anon_sym_goto] = ACTIONS(3503),
    [anon_sym_not] = ACTIONS(3503),
    [anon_sym_compl] = ACTIONS(3503),
    [anon_sym_DASH_DASH] = ACTIONS(3505),
    [anon_sym_PLUS_PLUS] = ACTIONS(3505),
    [anon_sym_sizeof] = ACTIONS(3503),
    [anon_sym___alignof__] = ACTIONS(3503),
    [anon_sym___alignof] = ACTIONS(3503),
    [anon_sym__alignof] = ACTIONS(3503),
    [anon_sym_alignof] = ACTIONS(3503),
    [anon_sym__Alignof] = ACTIONS(3503),
    [anon_sym_offsetof] = ACTIONS(3503),
    [anon_sym__Generic] = ACTIONS(3503),
    [anon_sym_asm] = ACTIONS(3503),
    [anon_sym___asm__] = ACTIONS(3503),
    [aux_sym_number_literal_token1] = ACTIONS(3505),
    [aux_sym_number_literal_token2] = ACTIONS(3503),
    [anon_sym_L_SQUOTE] = ACTIONS(3505),
    [anon_sym_u_SQUOTE] = ACTIONS(3505),
    [anon_sym_U_SQUOTE] = ACTIONS(3505),
    [anon_sym_u8_SQUOTE] = ACTIONS(3505),
    [anon_sym_SQUOTE] = ACTIONS(3505),
    [anon_sym_L_DQUOTE] = ACTIONS(3505),
    [anon_sym_u_DQUOTE] = ACTIONS(3505),
    [anon_sym_U_DQUOTE] = ACTIONS(3505),
    [anon_sym_u8_DQUOTE] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [sym_true] = ACTIONS(3503),
    [sym_false] = ACTIONS(3503),
    [anon_sym_NULL] = ACTIONS(3503),
    [anon_sym_nullptr] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3503),
    [anon_sym_decltype] = ACTIONS(3503),
    [anon_sym_virtual] = ACTIONS(3503),
    [anon_sym_alignas] = ACTIONS(3503),
    [anon_sym_explicit] = ACTIONS(3503),
    [anon_sym_typename] = ACTIONS(3503),
    [anon_sym_template] = ACTIONS(3503),
    [anon_sym_operator] = ACTIONS(3503),
    [anon_sym_try] = ACTIONS(3503),
    [anon_sym_delete] = ACTIONS(3503),
    [anon_sym_throw] = ACTIONS(3503),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_using] = ACTIONS(3503),
    [anon_sym_static_assert] = ACTIONS(3503),
    [anon_sym_concept] = ACTIONS(3503),
    [anon_sym_co_return] = ACTIONS(3503),
    [anon_sym_co_yield] = ACTIONS(3503),
    [anon_sym_R_DQUOTE] = ACTIONS(3505),
    [anon_sym_LR_DQUOTE] = ACTIONS(3505),
    [anon_sym_uR_DQUOTE] = ACTIONS(3505),
    [anon_sym_UR_DQUOTE] = ACTIONS(3505),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3505),
    [anon_sym_co_await] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3503),
    [anon_sym_requires] = ACTIONS(3503),
    [sym_this] = ACTIONS(3503),
  },
  [1086] = {
    [ts_builtin_sym_end] = ACTIONS(3445),
    [sym_identifier] = ACTIONS(3443),
    [aux_sym_preproc_include_token1] = ACTIONS(3443),
    [aux_sym_preproc_def_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3443),
    [sym_preproc_directive] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3445),
    [anon_sym_BANG] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_AMP_AMP] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym___extension__] = ACTIONS(3443),
    [anon_sym_typedef] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym___attribute__] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3445),
    [anon_sym___declspec] = ACTIONS(3443),
    [anon_sym___based] = ACTIONS(3443),
    [anon_sym___cdecl] = ACTIONS(3443),
    [anon_sym___clrcall] = ACTIONS(3443),
    [anon_sym___stdcall] = ACTIONS(3443),
    [anon_sym___fastcall] = ACTIONS(3443),
    [anon_sym___thiscall] = ACTIONS(3443),
    [anon_sym___vectorcall] = ACTIONS(3443),
    [anon_sym_LBRACE] = ACTIONS(3445),
    [anon_sym_signed] = ACTIONS(3443),
    [anon_sym_unsigned] = ACTIONS(3443),
    [anon_sym_long] = ACTIONS(3443),
    [anon_sym_short] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_register] = ACTIONS(3443),
    [anon_sym_inline] = ACTIONS(3443),
    [anon_sym___inline] = ACTIONS(3443),
    [anon_sym___inline__] = ACTIONS(3443),
    [anon_sym___forceinline] = ACTIONS(3443),
    [anon_sym_thread_local] = ACTIONS(3443),
    [anon_sym___thread] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_constexpr] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_restrict] = ACTIONS(3443),
    [anon_sym___restrict__] = ACTIONS(3443),
    [anon_sym__Atomic] = ACTIONS(3443),
    [anon_sym__Noreturn] = ACTIONS(3443),
    [anon_sym_noreturn] = ACTIONS(3443),
    [anon_sym_mutable] = ACTIONS(3443),
    [anon_sym_constinit] = ACTIONS(3443),
    [anon_sym_consteval] = ACTIONS(3443),
    [anon_sym_PROGMEM] = ACTIONS(3443),
    [aux_sym_primitive_type_token1] = ACTIONS(3443),
    [anon_sym_byte] = ACTIONS(3443),
    [anon_sym_word] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_union] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_switch] = ACTIONS(3443),
    [anon_sym_case] = ACTIONS(3443),
    [anon_sym_default] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_break] = ACTIONS(3443),
    [anon_sym_continue] = ACTIONS(3443),
    [anon_sym_goto] = ACTIONS(3443),
    [anon_sym_not] = ACTIONS(3443),
    [anon_sym_compl] = ACTIONS(3443),
    [anon_sym_DASH_DASH] = ACTIONS(3445),
    [anon_sym_PLUS_PLUS] = ACTIONS(3445),
    [anon_sym_sizeof] = ACTIONS(3443),
    [anon_sym___alignof__] = ACTIONS(3443),
    [anon_sym___alignof] = ACTIONS(3443),
    [anon_sym__alignof] = ACTIONS(3443),
    [anon_sym_alignof] = ACTIONS(3443),
    [anon_sym__Alignof] = ACTIONS(3443),
    [anon_sym_offsetof] = ACTIONS(3443),
    [anon_sym__Generic] = ACTIONS(3443),
    [anon_sym_asm] = ACTIONS(3443),
    [anon_sym___asm__] = ACTIONS(3443),
    [aux_sym_number_literal_token1] = ACTIONS(3445),
    [aux_sym_number_literal_token2] = ACTIONS(3443),
    [anon_sym_L_SQUOTE] = ACTIONS(3445),
    [anon_sym_u_SQUOTE] = ACTIONS(3445),
    [anon_sym_U_SQUOTE] = ACTIONS(3445),
    [anon_sym_u8_SQUOTE] = ACTIONS(3445),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_L_DQUOTE] = ACTIONS(3445),
    [anon_sym_u_DQUOTE] = ACTIONS(3445),
    [anon_sym_U_DQUOTE] = ACTIONS(3445),
    [anon_sym_u8_DQUOTE] = ACTIONS(3445),
    [anon_sym_DQUOTE] = ACTIONS(3445),
    [sym_true] = ACTIONS(3443),
    [sym_false] = ACTIONS(3443),
    [anon_sym_NULL] = ACTIONS(3443),
    [anon_sym_nullptr] = ACTIONS(3443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3443),
    [anon_sym_decltype] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_alignas] = ACTIONS(3443),
    [anon_sym_explicit] = ACTIONS(3443),
    [anon_sym_typename] = ACTIONS(3443),
    [anon_sym_template] = ACTIONS(3443),
    [anon_sym_operator] = ACTIONS(3443),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_delete] = ACTIONS(3443),
    [anon_sym_throw] = ACTIONS(3443),
    [anon_sym_namespace] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_static_assert] = ACTIONS(3443),
    [anon_sym_concept] = ACTIONS(3443),
    [anon_sym_co_return] = ACTIONS(3443),
    [anon_sym_co_yield] = ACTIONS(3443),
    [anon_sym_R_DQUOTE] = ACTIONS(3445),
    [anon_sym_LR_DQUOTE] = ACTIONS(3445),
    [anon_sym_uR_DQUOTE] = ACTIONS(3445),
    [anon_sym_UR_DQUOTE] = ACTIONS(3445),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3445),
    [anon_sym_co_await] = ACTIONS(3443),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_requires] = ACTIONS(3443),
    [sym_this] = ACTIONS(3443),
  },
  [1087] = {
    [ts_builtin_sym_end] = ACTIONS(3445),
    [sym_identifier] = ACTIONS(3443),
    [aux_sym_preproc_include_token1] = ACTIONS(3443),
    [aux_sym_preproc_def_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3443),
    [sym_preproc_directive] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3445),
    [anon_sym_BANG] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_AMP_AMP] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym___extension__] = ACTIONS(3443),
    [anon_sym_typedef] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym___attribute__] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3445),
    [anon_sym___declspec] = ACTIONS(3443),
    [anon_sym___based] = ACTIONS(3443),
    [anon_sym___cdecl] = ACTIONS(3443),
    [anon_sym___clrcall] = ACTIONS(3443),
    [anon_sym___stdcall] = ACTIONS(3443),
    [anon_sym___fastcall] = ACTIONS(3443),
    [anon_sym___thiscall] = ACTIONS(3443),
    [anon_sym___vectorcall] = ACTIONS(3443),
    [anon_sym_LBRACE] = ACTIONS(3445),
    [anon_sym_signed] = ACTIONS(3443),
    [anon_sym_unsigned] = ACTIONS(3443),
    [anon_sym_long] = ACTIONS(3443),
    [anon_sym_short] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_register] = ACTIONS(3443),
    [anon_sym_inline] = ACTIONS(3443),
    [anon_sym___inline] = ACTIONS(3443),
    [anon_sym___inline__] = ACTIONS(3443),
    [anon_sym___forceinline] = ACTIONS(3443),
    [anon_sym_thread_local] = ACTIONS(3443),
    [anon_sym___thread] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_constexpr] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_restrict] = ACTIONS(3443),
    [anon_sym___restrict__] = ACTIONS(3443),
    [anon_sym__Atomic] = ACTIONS(3443),
    [anon_sym__Noreturn] = ACTIONS(3443),
    [anon_sym_noreturn] = ACTIONS(3443),
    [anon_sym_mutable] = ACTIONS(3443),
    [anon_sym_constinit] = ACTIONS(3443),
    [anon_sym_consteval] = ACTIONS(3443),
    [anon_sym_PROGMEM] = ACTIONS(3443),
    [aux_sym_primitive_type_token1] = ACTIONS(3443),
    [anon_sym_byte] = ACTIONS(3443),
    [anon_sym_word] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_union] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_switch] = ACTIONS(3443),
    [anon_sym_case] = ACTIONS(3443),
    [anon_sym_default] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_break] = ACTIONS(3443),
    [anon_sym_continue] = ACTIONS(3443),
    [anon_sym_goto] = ACTIONS(3443),
    [anon_sym_not] = ACTIONS(3443),
    [anon_sym_compl] = ACTIONS(3443),
    [anon_sym_DASH_DASH] = ACTIONS(3445),
    [anon_sym_PLUS_PLUS] = ACTIONS(3445),
    [anon_sym_sizeof] = ACTIONS(3443),
    [anon_sym___alignof__] = ACTIONS(3443),
    [anon_sym___alignof] = ACTIONS(3443),
    [anon_sym__alignof] = ACTIONS(3443),
    [anon_sym_alignof] = ACTIONS(3443),
    [anon_sym__Alignof] = ACTIONS(3443),
    [anon_sym_offsetof] = ACTIONS(3443),
    [anon_sym__Generic] = ACTIONS(3443),
    [anon_sym_asm] = ACTIONS(3443),
    [anon_sym___asm__] = ACTIONS(3443),
    [aux_sym_number_literal_token1] = ACTIONS(3445),
    [aux_sym_number_literal_token2] = ACTIONS(3443),
    [anon_sym_L_SQUOTE] = ACTIONS(3445),
    [anon_sym_u_SQUOTE] = ACTIONS(3445),
    [anon_sym_U_SQUOTE] = ACTIONS(3445),
    [anon_sym_u8_SQUOTE] = ACTIONS(3445),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_L_DQUOTE] = ACTIONS(3445),
    [anon_sym_u_DQUOTE] = ACTIONS(3445),
    [anon_sym_U_DQUOTE] = ACTIONS(3445),
    [anon_sym_u8_DQUOTE] = ACTIONS(3445),
    [anon_sym_DQUOTE] = ACTIONS(3445),
    [sym_true] = ACTIONS(3443),
    [sym_false] = ACTIONS(3443),
    [anon_sym_NULL] = ACTIONS(3443),
    [anon_sym_nullptr] = ACTIONS(3443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3443),
    [anon_sym_decltype] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_alignas] = ACTIONS(3443),
    [anon_sym_explicit] = ACTIONS(3443),
    [anon_sym_typename] = ACTIONS(3443),
    [anon_sym_template] = ACTIONS(3443),
    [anon_sym_operator] = ACTIONS(3443),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_delete] = ACTIONS(3443),
    [anon_sym_throw] = ACTIONS(3443),
    [anon_sym_namespace] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_static_assert] = ACTIONS(3443),
    [anon_sym_concept] = ACTIONS(3443),
    [anon_sym_co_return] = ACTIONS(3443),
    [anon_sym_co_yield] = ACTIONS(3443),
    [anon_sym_R_DQUOTE] = ACTIONS(3445),
    [anon_sym_LR_DQUOTE] = ACTIONS(3445),
    [anon_sym_uR_DQUOTE] = ACTIONS(3445),
    [anon_sym_UR_DQUOTE] = ACTIONS(3445),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3445),
    [anon_sym_co_await] = ACTIONS(3443),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_requires] = ACTIONS(3443),
    [sym_this] = ACTIONS(3443),
  },
  [1088] = {
    [ts_builtin_sym_end] = ACTIONS(3268),
    [sym_identifier] = ACTIONS(3266),
    [aux_sym_preproc_include_token1] = ACTIONS(3266),
    [aux_sym_preproc_def_token1] = ACTIONS(3266),
    [aux_sym_preproc_if_token1] = ACTIONS(3266),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3266),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3266),
    [sym_preproc_directive] = ACTIONS(3266),
    [anon_sym_LPAREN2] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3268),
    [anon_sym_TILDE] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3266),
    [anon_sym_STAR] = ACTIONS(3268),
    [anon_sym_AMP_AMP] = ACTIONS(3268),
    [anon_sym_AMP] = ACTIONS(3266),
    [anon_sym___extension__] = ACTIONS(3266),
    [anon_sym_typedef] = ACTIONS(3266),
    [anon_sym_extern] = ACTIONS(3266),
    [anon_sym___attribute__] = ACTIONS(3266),
    [anon_sym_COLON_COLON] = ACTIONS(3268),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3268),
    [anon_sym___declspec] = ACTIONS(3266),
    [anon_sym___based] = ACTIONS(3266),
    [anon_sym___cdecl] = ACTIONS(3266),
    [anon_sym___clrcall] = ACTIONS(3266),
    [anon_sym___stdcall] = ACTIONS(3266),
    [anon_sym___fastcall] = ACTIONS(3266),
    [anon_sym___thiscall] = ACTIONS(3266),
    [anon_sym___vectorcall] = ACTIONS(3266),
    [anon_sym_LBRACE] = ACTIONS(3268),
    [anon_sym_signed] = ACTIONS(3266),
    [anon_sym_unsigned] = ACTIONS(3266),
    [anon_sym_long] = ACTIONS(3266),
    [anon_sym_short] = ACTIONS(3266),
    [anon_sym_LBRACK] = ACTIONS(3266),
    [anon_sym_static] = ACTIONS(3266),
    [anon_sym_register] = ACTIONS(3266),
    [anon_sym_inline] = ACTIONS(3266),
    [anon_sym___inline] = ACTIONS(3266),
    [anon_sym___inline__] = ACTIONS(3266),
    [anon_sym___forceinline] = ACTIONS(3266),
    [anon_sym_thread_local] = ACTIONS(3266),
    [anon_sym___thread] = ACTIONS(3266),
    [anon_sym_const] = ACTIONS(3266),
    [anon_sym_constexpr] = ACTIONS(3266),
    [anon_sym_volatile] = ACTIONS(3266),
    [anon_sym_restrict] = ACTIONS(3266),
    [anon_sym___restrict__] = ACTIONS(3266),
    [anon_sym__Atomic] = ACTIONS(3266),
    [anon_sym__Noreturn] = ACTIONS(3266),
    [anon_sym_noreturn] = ACTIONS(3266),
    [anon_sym_mutable] = ACTIONS(3266),
    [anon_sym_constinit] = ACTIONS(3266),
    [anon_sym_consteval] = ACTIONS(3266),
    [anon_sym_PROGMEM] = ACTIONS(3266),
    [aux_sym_primitive_type_token1] = ACTIONS(3266),
    [anon_sym_byte] = ACTIONS(3266),
    [anon_sym_word] = ACTIONS(3266),
    [anon_sym_enum] = ACTIONS(3266),
    [anon_sym_class] = ACTIONS(3266),
    [anon_sym_struct] = ACTIONS(3266),
    [anon_sym_union] = ACTIONS(3266),
    [anon_sym_if] = ACTIONS(3266),
    [anon_sym_switch] = ACTIONS(3266),
    [anon_sym_case] = ACTIONS(3266),
    [anon_sym_default] = ACTIONS(3266),
    [anon_sym_while] = ACTIONS(3266),
    [anon_sym_do] = ACTIONS(3266),
    [anon_sym_for] = ACTIONS(3266),
    [anon_sym_return] = ACTIONS(3266),
    [anon_sym_break] = ACTIONS(3266),
    [anon_sym_continue] = ACTIONS(3266),
    [anon_sym_goto] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3266),
    [anon_sym_compl] = ACTIONS(3266),
    [anon_sym_DASH_DASH] = ACTIONS(3268),
    [anon_sym_PLUS_PLUS] = ACTIONS(3268),
    [anon_sym_sizeof] = ACTIONS(3266),
    [anon_sym___alignof__] = ACTIONS(3266),
    [anon_sym___alignof] = ACTIONS(3266),
    [anon_sym__alignof] = ACTIONS(3266),
    [anon_sym_alignof] = ACTIONS(3266),
    [anon_sym__Alignof] = ACTIONS(3266),
    [anon_sym_offsetof] = ACTIONS(3266),
    [anon_sym__Generic] = ACTIONS(3266),
    [anon_sym_asm] = ACTIONS(3266),
    [anon_sym___asm__] = ACTIONS(3266),
    [aux_sym_number_literal_token1] = ACTIONS(3268),
    [aux_sym_number_literal_token2] = ACTIONS(3266),
    [anon_sym_L_SQUOTE] = ACTIONS(3268),
    [anon_sym_u_SQUOTE] = ACTIONS(3268),
    [anon_sym_U_SQUOTE] = ACTIONS(3268),
    [anon_sym_u8_SQUOTE] = ACTIONS(3268),
    [anon_sym_SQUOTE] = ACTIONS(3268),
    [anon_sym_L_DQUOTE] = ACTIONS(3268),
    [anon_sym_u_DQUOTE] = ACTIONS(3268),
    [anon_sym_U_DQUOTE] = ACTIONS(3268),
    [anon_sym_u8_DQUOTE] = ACTIONS(3268),
    [anon_sym_DQUOTE] = ACTIONS(3268),
    [sym_true] = ACTIONS(3266),
    [sym_false] = ACTIONS(3266),
    [anon_sym_NULL] = ACTIONS(3266),
    [anon_sym_nullptr] = ACTIONS(3266),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3266),
    [anon_sym_decltype] = ACTIONS(3266),
    [anon_sym_virtual] = ACTIONS(3266),
    [anon_sym_alignas] = ACTIONS(3266),
    [anon_sym_explicit] = ACTIONS(3266),
    [anon_sym_typename] = ACTIONS(3266),
    [anon_sym_template] = ACTIONS(3266),
    [anon_sym_operator] = ACTIONS(3266),
    [anon_sym_try] = ACTIONS(3266),
    [anon_sym_delete] = ACTIONS(3266),
    [anon_sym_throw] = ACTIONS(3266),
    [anon_sym_namespace] = ACTIONS(3266),
    [anon_sym_using] = ACTIONS(3266),
    [anon_sym_static_assert] = ACTIONS(3266),
    [anon_sym_concept] = ACTIONS(3266),
    [anon_sym_co_return] = ACTIONS(3266),
    [anon_sym_co_yield] = ACTIONS(3266),
    [anon_sym_R_DQUOTE] = ACTIONS(3268),
    [anon_sym_LR_DQUOTE] = ACTIONS(3268),
    [anon_sym_uR_DQUOTE] = ACTIONS(3268),
    [anon_sym_UR_DQUOTE] = ACTIONS(3268),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3268),
    [anon_sym_co_await] = ACTIONS(3266),
    [anon_sym_new] = ACTIONS(3266),
    [anon_sym_requires] = ACTIONS(3266),
    [sym_this] = ACTIONS(3266),
  },
  [1089] = {
    [ts_builtin_sym_end] = ACTIONS(3501),
    [sym_identifier] = ACTIONS(3499),
    [aux_sym_preproc_include_token1] = ACTIONS(3499),
    [aux_sym_preproc_def_token1] = ACTIONS(3499),
    [aux_sym_preproc_if_token1] = ACTIONS(3499),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3499),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3499),
    [sym_preproc_directive] = ACTIONS(3499),
    [anon_sym_LPAREN2] = ACTIONS(3501),
    [anon_sym_BANG] = ACTIONS(3501),
    [anon_sym_TILDE] = ACTIONS(3501),
    [anon_sym_DASH] = ACTIONS(3499),
    [anon_sym_PLUS] = ACTIONS(3499),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_AMP_AMP] = ACTIONS(3501),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym___extension__] = ACTIONS(3499),
    [anon_sym_typedef] = ACTIONS(3499),
    [anon_sym_extern] = ACTIONS(3499),
    [anon_sym___attribute__] = ACTIONS(3499),
    [anon_sym_COLON_COLON] = ACTIONS(3501),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3501),
    [anon_sym___declspec] = ACTIONS(3499),
    [anon_sym___based] = ACTIONS(3499),
    [anon_sym___cdecl] = ACTIONS(3499),
    [anon_sym___clrcall] = ACTIONS(3499),
    [anon_sym___stdcall] = ACTIONS(3499),
    [anon_sym___fastcall] = ACTIONS(3499),
    [anon_sym___thiscall] = ACTIONS(3499),
    [anon_sym___vectorcall] = ACTIONS(3499),
    [anon_sym_LBRACE] = ACTIONS(3501),
    [anon_sym_signed] = ACTIONS(3499),
    [anon_sym_unsigned] = ACTIONS(3499),
    [anon_sym_long] = ACTIONS(3499),
    [anon_sym_short] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(3499),
    [anon_sym_static] = ACTIONS(3499),
    [anon_sym_register] = ACTIONS(3499),
    [anon_sym_inline] = ACTIONS(3499),
    [anon_sym___inline] = ACTIONS(3499),
    [anon_sym___inline__] = ACTIONS(3499),
    [anon_sym___forceinline] = ACTIONS(3499),
    [anon_sym_thread_local] = ACTIONS(3499),
    [anon_sym___thread] = ACTIONS(3499),
    [anon_sym_const] = ACTIONS(3499),
    [anon_sym_constexpr] = ACTIONS(3499),
    [anon_sym_volatile] = ACTIONS(3499),
    [anon_sym_restrict] = ACTIONS(3499),
    [anon_sym___restrict__] = ACTIONS(3499),
    [anon_sym__Atomic] = ACTIONS(3499),
    [anon_sym__Noreturn] = ACTIONS(3499),
    [anon_sym_noreturn] = ACTIONS(3499),
    [anon_sym_mutable] = ACTIONS(3499),
    [anon_sym_constinit] = ACTIONS(3499),
    [anon_sym_consteval] = ACTIONS(3499),
    [anon_sym_PROGMEM] = ACTIONS(3499),
    [aux_sym_primitive_type_token1] = ACTIONS(3499),
    [anon_sym_byte] = ACTIONS(3499),
    [anon_sym_word] = ACTIONS(3499),
    [anon_sym_enum] = ACTIONS(3499),
    [anon_sym_class] = ACTIONS(3499),
    [anon_sym_struct] = ACTIONS(3499),
    [anon_sym_union] = ACTIONS(3499),
    [anon_sym_if] = ACTIONS(3499),
    [anon_sym_switch] = ACTIONS(3499),
    [anon_sym_case] = ACTIONS(3499),
    [anon_sym_default] = ACTIONS(3499),
    [anon_sym_while] = ACTIONS(3499),
    [anon_sym_do] = ACTIONS(3499),
    [anon_sym_for] = ACTIONS(3499),
    [anon_sym_return] = ACTIONS(3499),
    [anon_sym_break] = ACTIONS(3499),
    [anon_sym_continue] = ACTIONS(3499),
    [anon_sym_goto] = ACTIONS(3499),
    [anon_sym_not] = ACTIONS(3499),
    [anon_sym_compl] = ACTIONS(3499),
    [anon_sym_DASH_DASH] = ACTIONS(3501),
    [anon_sym_PLUS_PLUS] = ACTIONS(3501),
    [anon_sym_sizeof] = ACTIONS(3499),
    [anon_sym___alignof__] = ACTIONS(3499),
    [anon_sym___alignof] = ACTIONS(3499),
    [anon_sym__alignof] = ACTIONS(3499),
    [anon_sym_alignof] = ACTIONS(3499),
    [anon_sym__Alignof] = ACTIONS(3499),
    [anon_sym_offsetof] = ACTIONS(3499),
    [anon_sym__Generic] = ACTIONS(3499),
    [anon_sym_asm] = ACTIONS(3499),
    [anon_sym___asm__] = ACTIONS(3499),
    [aux_sym_number_literal_token1] = ACTIONS(3501),
    [aux_sym_number_literal_token2] = ACTIONS(3499),
    [anon_sym_L_SQUOTE] = ACTIONS(3501),
    [anon_sym_u_SQUOTE] = ACTIONS(3501),
    [anon_sym_U_SQUOTE] = ACTIONS(3501),
    [anon_sym_u8_SQUOTE] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3501),
    [anon_sym_L_DQUOTE] = ACTIONS(3501),
    [anon_sym_u_DQUOTE] = ACTIONS(3501),
    [anon_sym_U_DQUOTE] = ACTIONS(3501),
    [anon_sym_u8_DQUOTE] = ACTIONS(3501),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [sym_true] = ACTIONS(3499),
    [sym_false] = ACTIONS(3499),
    [anon_sym_NULL] = ACTIONS(3499),
    [anon_sym_nullptr] = ACTIONS(3499),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3499),
    [anon_sym_decltype] = ACTIONS(3499),
    [anon_sym_virtual] = ACTIONS(3499),
    [anon_sym_alignas] = ACTIONS(3499),
    [anon_sym_explicit] = ACTIONS(3499),
    [anon_sym_typename] = ACTIONS(3499),
    [anon_sym_template] = ACTIONS(3499),
    [anon_sym_operator] = ACTIONS(3499),
    [anon_sym_try] = ACTIONS(3499),
    [anon_sym_delete] = ACTIONS(3499),
    [anon_sym_throw] = ACTIONS(3499),
    [anon_sym_namespace] = ACTIONS(3499),
    [anon_sym_using] = ACTIONS(3499),
    [anon_sym_static_assert] = ACTIONS(3499),
    [anon_sym_concept] = ACTIONS(3499),
    [anon_sym_co_return] = ACTIONS(3499),
    [anon_sym_co_yield] = ACTIONS(3499),
    [anon_sym_R_DQUOTE] = ACTIONS(3501),
    [anon_sym_LR_DQUOTE] = ACTIONS(3501),
    [anon_sym_uR_DQUOTE] = ACTIONS(3501),
    [anon_sym_UR_DQUOTE] = ACTIONS(3501),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3501),
    [anon_sym_co_await] = ACTIONS(3499),
    [anon_sym_new] = ACTIONS(3499),
    [anon_sym_requires] = ACTIONS(3499),
    [sym_this] = ACTIONS(3499),
  },
  [1090] = {
    [ts_builtin_sym_end] = ACTIONS(3497),
    [sym_identifier] = ACTIONS(3495),
    [aux_sym_preproc_include_token1] = ACTIONS(3495),
    [aux_sym_preproc_def_token1] = ACTIONS(3495),
    [aux_sym_preproc_if_token1] = ACTIONS(3495),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3495),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3495),
    [sym_preproc_directive] = ACTIONS(3495),
    [anon_sym_LPAREN2] = ACTIONS(3497),
    [anon_sym_BANG] = ACTIONS(3497),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_AMP_AMP] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(3495),
    [anon_sym___extension__] = ACTIONS(3495),
    [anon_sym_typedef] = ACTIONS(3495),
    [anon_sym_extern] = ACTIONS(3495),
    [anon_sym___attribute__] = ACTIONS(3495),
    [anon_sym_COLON_COLON] = ACTIONS(3497),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3497),
    [anon_sym___declspec] = ACTIONS(3495),
    [anon_sym___based] = ACTIONS(3495),
    [anon_sym___cdecl] = ACTIONS(3495),
    [anon_sym___clrcall] = ACTIONS(3495),
    [anon_sym___stdcall] = ACTIONS(3495),
    [anon_sym___fastcall] = ACTIONS(3495),
    [anon_sym___thiscall] = ACTIONS(3495),
    [anon_sym___vectorcall] = ACTIONS(3495),
    [anon_sym_LBRACE] = ACTIONS(3497),
    [anon_sym_signed] = ACTIONS(3495),
    [anon_sym_unsigned] = ACTIONS(3495),
    [anon_sym_long] = ACTIONS(3495),
    [anon_sym_short] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(3495),
    [anon_sym_static] = ACTIONS(3495),
    [anon_sym_register] = ACTIONS(3495),
    [anon_sym_inline] = ACTIONS(3495),
    [anon_sym___inline] = ACTIONS(3495),
    [anon_sym___inline__] = ACTIONS(3495),
    [anon_sym___forceinline] = ACTIONS(3495),
    [anon_sym_thread_local] = ACTIONS(3495),
    [anon_sym___thread] = ACTIONS(3495),
    [anon_sym_const] = ACTIONS(3495),
    [anon_sym_constexpr] = ACTIONS(3495),
    [anon_sym_volatile] = ACTIONS(3495),
    [anon_sym_restrict] = ACTIONS(3495),
    [anon_sym___restrict__] = ACTIONS(3495),
    [anon_sym__Atomic] = ACTIONS(3495),
    [anon_sym__Noreturn] = ACTIONS(3495),
    [anon_sym_noreturn] = ACTIONS(3495),
    [anon_sym_mutable] = ACTIONS(3495),
    [anon_sym_constinit] = ACTIONS(3495),
    [anon_sym_consteval] = ACTIONS(3495),
    [anon_sym_PROGMEM] = ACTIONS(3495),
    [aux_sym_primitive_type_token1] = ACTIONS(3495),
    [anon_sym_byte] = ACTIONS(3495),
    [anon_sym_word] = ACTIONS(3495),
    [anon_sym_enum] = ACTIONS(3495),
    [anon_sym_class] = ACTIONS(3495),
    [anon_sym_struct] = ACTIONS(3495),
    [anon_sym_union] = ACTIONS(3495),
    [anon_sym_if] = ACTIONS(3495),
    [anon_sym_switch] = ACTIONS(3495),
    [anon_sym_case] = ACTIONS(3495),
    [anon_sym_default] = ACTIONS(3495),
    [anon_sym_while] = ACTIONS(3495),
    [anon_sym_do] = ACTIONS(3495),
    [anon_sym_for] = ACTIONS(3495),
    [anon_sym_return] = ACTIONS(3495),
    [anon_sym_break] = ACTIONS(3495),
    [anon_sym_continue] = ACTIONS(3495),
    [anon_sym_goto] = ACTIONS(3495),
    [anon_sym_not] = ACTIONS(3495),
    [anon_sym_compl] = ACTIONS(3495),
    [anon_sym_DASH_DASH] = ACTIONS(3497),
    [anon_sym_PLUS_PLUS] = ACTIONS(3497),
    [anon_sym_sizeof] = ACTIONS(3495),
    [anon_sym___alignof__] = ACTIONS(3495),
    [anon_sym___alignof] = ACTIONS(3495),
    [anon_sym__alignof] = ACTIONS(3495),
    [anon_sym_alignof] = ACTIONS(3495),
    [anon_sym__Alignof] = ACTIONS(3495),
    [anon_sym_offsetof] = ACTIONS(3495),
    [anon_sym__Generic] = ACTIONS(3495),
    [anon_sym_asm] = ACTIONS(3495),
    [anon_sym___asm__] = ACTIONS(3495),
    [aux_sym_number_literal_token1] = ACTIONS(3497),
    [aux_sym_number_literal_token2] = ACTIONS(3495),
    [anon_sym_L_SQUOTE] = ACTIONS(3497),
    [anon_sym_u_SQUOTE] = ACTIONS(3497),
    [anon_sym_U_SQUOTE] = ACTIONS(3497),
    [anon_sym_u8_SQUOTE] = ACTIONS(3497),
    [anon_sym_SQUOTE] = ACTIONS(3497),
    [anon_sym_L_DQUOTE] = ACTIONS(3497),
    [anon_sym_u_DQUOTE] = ACTIONS(3497),
    [anon_sym_U_DQUOTE] = ACTIONS(3497),
    [anon_sym_u8_DQUOTE] = ACTIONS(3497),
    [anon_sym_DQUOTE] = ACTIONS(3497),
    [sym_true] = ACTIONS(3495),
    [sym_false] = ACTIONS(3495),
    [anon_sym_NULL] = ACTIONS(3495),
    [anon_sym_nullptr] = ACTIONS(3495),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3495),
    [anon_sym_decltype] = ACTIONS(3495),
    [anon_sym_virtual] = ACTIONS(3495),
    [anon_sym_alignas] = ACTIONS(3495),
    [anon_sym_explicit] = ACTIONS(3495),
    [anon_sym_typename] = ACTIONS(3495),
    [anon_sym_template] = ACTIONS(3495),
    [anon_sym_operator] = ACTIONS(3495),
    [anon_sym_try] = ACTIONS(3495),
    [anon_sym_delete] = ACTIONS(3495),
    [anon_sym_throw] = ACTIONS(3495),
    [anon_sym_namespace] = ACTIONS(3495),
    [anon_sym_using] = ACTIONS(3495),
    [anon_sym_static_assert] = ACTIONS(3495),
    [anon_sym_concept] = ACTIONS(3495),
    [anon_sym_co_return] = ACTIONS(3495),
    [anon_sym_co_yield] = ACTIONS(3495),
    [anon_sym_R_DQUOTE] = ACTIONS(3497),
    [anon_sym_LR_DQUOTE] = ACTIONS(3497),
    [anon_sym_uR_DQUOTE] = ACTIONS(3497),
    [anon_sym_UR_DQUOTE] = ACTIONS(3497),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3497),
    [anon_sym_co_await] = ACTIONS(3495),
    [anon_sym_new] = ACTIONS(3495),
    [anon_sym_requires] = ACTIONS(3495),
    [sym_this] = ACTIONS(3495),
  },
  [1091] = {
    [ts_builtin_sym_end] = ACTIONS(3493),
    [sym_identifier] = ACTIONS(3491),
    [aux_sym_preproc_include_token1] = ACTIONS(3491),
    [aux_sym_preproc_def_token1] = ACTIONS(3491),
    [aux_sym_preproc_if_token1] = ACTIONS(3491),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3491),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3491),
    [sym_preproc_directive] = ACTIONS(3491),
    [anon_sym_LPAREN2] = ACTIONS(3493),
    [anon_sym_BANG] = ACTIONS(3493),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(3493),
    [anon_sym_AMP_AMP] = ACTIONS(3493),
    [anon_sym_AMP] = ACTIONS(3491),
    [anon_sym___extension__] = ACTIONS(3491),
    [anon_sym_typedef] = ACTIONS(3491),
    [anon_sym_extern] = ACTIONS(3491),
    [anon_sym___attribute__] = ACTIONS(3491),
    [anon_sym_COLON_COLON] = ACTIONS(3493),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3493),
    [anon_sym___declspec] = ACTIONS(3491),
    [anon_sym___based] = ACTIONS(3491),
    [anon_sym___cdecl] = ACTIONS(3491),
    [anon_sym___clrcall] = ACTIONS(3491),
    [anon_sym___stdcall] = ACTIONS(3491),
    [anon_sym___fastcall] = ACTIONS(3491),
    [anon_sym___thiscall] = ACTIONS(3491),
    [anon_sym___vectorcall] = ACTIONS(3491),
    [anon_sym_LBRACE] = ACTIONS(3493),
    [anon_sym_signed] = ACTIONS(3491),
    [anon_sym_unsigned] = ACTIONS(3491),
    [anon_sym_long] = ACTIONS(3491),
    [anon_sym_short] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3491),
    [anon_sym_static] = ACTIONS(3491),
    [anon_sym_register] = ACTIONS(3491),
    [anon_sym_inline] = ACTIONS(3491),
    [anon_sym___inline] = ACTIONS(3491),
    [anon_sym___inline__] = ACTIONS(3491),
    [anon_sym___forceinline] = ACTIONS(3491),
    [anon_sym_thread_local] = ACTIONS(3491),
    [anon_sym___thread] = ACTIONS(3491),
    [anon_sym_const] = ACTIONS(3491),
    [anon_sym_constexpr] = ACTIONS(3491),
    [anon_sym_volatile] = ACTIONS(3491),
    [anon_sym_restrict] = ACTIONS(3491),
    [anon_sym___restrict__] = ACTIONS(3491),
    [anon_sym__Atomic] = ACTIONS(3491),
    [anon_sym__Noreturn] = ACTIONS(3491),
    [anon_sym_noreturn] = ACTIONS(3491),
    [anon_sym_mutable] = ACTIONS(3491),
    [anon_sym_constinit] = ACTIONS(3491),
    [anon_sym_consteval] = ACTIONS(3491),
    [anon_sym_PROGMEM] = ACTIONS(3491),
    [aux_sym_primitive_type_token1] = ACTIONS(3491),
    [anon_sym_byte] = ACTIONS(3491),
    [anon_sym_word] = ACTIONS(3491),
    [anon_sym_enum] = ACTIONS(3491),
    [anon_sym_class] = ACTIONS(3491),
    [anon_sym_struct] = ACTIONS(3491),
    [anon_sym_union] = ACTIONS(3491),
    [anon_sym_if] = ACTIONS(3491),
    [anon_sym_switch] = ACTIONS(3491),
    [anon_sym_case] = ACTIONS(3491),
    [anon_sym_default] = ACTIONS(3491),
    [anon_sym_while] = ACTIONS(3491),
    [anon_sym_do] = ACTIONS(3491),
    [anon_sym_for] = ACTIONS(3491),
    [anon_sym_return] = ACTIONS(3491),
    [anon_sym_break] = ACTIONS(3491),
    [anon_sym_continue] = ACTIONS(3491),
    [anon_sym_goto] = ACTIONS(3491),
    [anon_sym_not] = ACTIONS(3491),
    [anon_sym_compl] = ACTIONS(3491),
    [anon_sym_DASH_DASH] = ACTIONS(3493),
    [anon_sym_PLUS_PLUS] = ACTIONS(3493),
    [anon_sym_sizeof] = ACTIONS(3491),
    [anon_sym___alignof__] = ACTIONS(3491),
    [anon_sym___alignof] = ACTIONS(3491),
    [anon_sym__alignof] = ACTIONS(3491),
    [anon_sym_alignof] = ACTIONS(3491),
    [anon_sym__Alignof] = ACTIONS(3491),
    [anon_sym_offsetof] = ACTIONS(3491),
    [anon_sym__Generic] = ACTIONS(3491),
    [anon_sym_asm] = ACTIONS(3491),
    [anon_sym___asm__] = ACTIONS(3491),
    [aux_sym_number_literal_token1] = ACTIONS(3493),
    [aux_sym_number_literal_token2] = ACTIONS(3491),
    [anon_sym_L_SQUOTE] = ACTIONS(3493),
    [anon_sym_u_SQUOTE] = ACTIONS(3493),
    [anon_sym_U_SQUOTE] = ACTIONS(3493),
    [anon_sym_u8_SQUOTE] = ACTIONS(3493),
    [anon_sym_SQUOTE] = ACTIONS(3493),
    [anon_sym_L_DQUOTE] = ACTIONS(3493),
    [anon_sym_u_DQUOTE] = ACTIONS(3493),
    [anon_sym_U_DQUOTE] = ACTIONS(3493),
    [anon_sym_u8_DQUOTE] = ACTIONS(3493),
    [anon_sym_DQUOTE] = ACTIONS(3493),
    [sym_true] = ACTIONS(3491),
    [sym_false] = ACTIONS(3491),
    [anon_sym_NULL] = ACTIONS(3491),
    [anon_sym_nullptr] = ACTIONS(3491),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3491),
    [anon_sym_decltype] = ACTIONS(3491),
    [anon_sym_virtual] = ACTIONS(3491),
    [anon_sym_alignas] = ACTIONS(3491),
    [anon_sym_explicit] = ACTIONS(3491),
    [anon_sym_typename] = ACTIONS(3491),
    [anon_sym_template] = ACTIONS(3491),
    [anon_sym_operator] = ACTIONS(3491),
    [anon_sym_try] = ACTIONS(3491),
    [anon_sym_delete] = ACTIONS(3491),
    [anon_sym_throw] = ACTIONS(3491),
    [anon_sym_namespace] = ACTIONS(3491),
    [anon_sym_using] = ACTIONS(3491),
    [anon_sym_static_assert] = ACTIONS(3491),
    [anon_sym_concept] = ACTIONS(3491),
    [anon_sym_co_return] = ACTIONS(3491),
    [anon_sym_co_yield] = ACTIONS(3491),
    [anon_sym_R_DQUOTE] = ACTIONS(3493),
    [anon_sym_LR_DQUOTE] = ACTIONS(3493),
    [anon_sym_uR_DQUOTE] = ACTIONS(3493),
    [anon_sym_UR_DQUOTE] = ACTIONS(3493),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3493),
    [anon_sym_co_await] = ACTIONS(3491),
    [anon_sym_new] = ACTIONS(3491),
    [anon_sym_requires] = ACTIONS(3491),
    [sym_this] = ACTIONS(3491),
  },
  [1092] = {
    [ts_builtin_sym_end] = ACTIONS(3338),
    [sym_identifier] = ACTIONS(3336),
    [aux_sym_preproc_include_token1] = ACTIONS(3336),
    [aux_sym_preproc_def_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token1] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3336),
    [sym_preproc_directive] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_BANG] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym___extension__] = ACTIONS(3336),
    [anon_sym_typedef] = ACTIONS(3336),
    [anon_sym_extern] = ACTIONS(3336),
    [anon_sym___attribute__] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3338),
    [anon_sym___declspec] = ACTIONS(3336),
    [anon_sym___based] = ACTIONS(3336),
    [anon_sym___cdecl] = ACTIONS(3336),
    [anon_sym___clrcall] = ACTIONS(3336),
    [anon_sym___stdcall] = ACTIONS(3336),
    [anon_sym___fastcall] = ACTIONS(3336),
    [anon_sym___thiscall] = ACTIONS(3336),
    [anon_sym___vectorcall] = ACTIONS(3336),
    [anon_sym_LBRACE] = ACTIONS(3338),
    [anon_sym_signed] = ACTIONS(3336),
    [anon_sym_unsigned] = ACTIONS(3336),
    [anon_sym_long] = ACTIONS(3336),
    [anon_sym_short] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_static] = ACTIONS(3336),
    [anon_sym_register] = ACTIONS(3336),
    [anon_sym_inline] = ACTIONS(3336),
    [anon_sym___inline] = ACTIONS(3336),
    [anon_sym___inline__] = ACTIONS(3336),
    [anon_sym___forceinline] = ACTIONS(3336),
    [anon_sym_thread_local] = ACTIONS(3336),
    [anon_sym___thread] = ACTIONS(3336),
    [anon_sym_const] = ACTIONS(3336),
    [anon_sym_constexpr] = ACTIONS(3336),
    [anon_sym_volatile] = ACTIONS(3336),
    [anon_sym_restrict] = ACTIONS(3336),
    [anon_sym___restrict__] = ACTIONS(3336),
    [anon_sym__Atomic] = ACTIONS(3336),
    [anon_sym__Noreturn] = ACTIONS(3336),
    [anon_sym_noreturn] = ACTIONS(3336),
    [anon_sym_mutable] = ACTIONS(3336),
    [anon_sym_constinit] = ACTIONS(3336),
    [anon_sym_consteval] = ACTIONS(3336),
    [anon_sym_PROGMEM] = ACTIONS(3336),
    [aux_sym_primitive_type_token1] = ACTIONS(3336),
    [anon_sym_byte] = ACTIONS(3336),
    [anon_sym_word] = ACTIONS(3336),
    [anon_sym_enum] = ACTIONS(3336),
    [anon_sym_class] = ACTIONS(3336),
    [anon_sym_struct] = ACTIONS(3336),
    [anon_sym_union] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_switch] = ACTIONS(3336),
    [anon_sym_case] = ACTIONS(3336),
    [anon_sym_default] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_break] = ACTIONS(3336),
    [anon_sym_continue] = ACTIONS(3336),
    [anon_sym_goto] = ACTIONS(3336),
    [anon_sym_not] = ACTIONS(3336),
    [anon_sym_compl] = ACTIONS(3336),
    [anon_sym_DASH_DASH] = ACTIONS(3338),
    [anon_sym_PLUS_PLUS] = ACTIONS(3338),
    [anon_sym_sizeof] = ACTIONS(3336),
    [anon_sym___alignof__] = ACTIONS(3336),
    [anon_sym___alignof] = ACTIONS(3336),
    [anon_sym__alignof] = ACTIONS(3336),
    [anon_sym_alignof] = ACTIONS(3336),
    [anon_sym__Alignof] = ACTIONS(3336),
    [anon_sym_offsetof] = ACTIONS(3336),
    [anon_sym__Generic] = ACTIONS(3336),
    [anon_sym_asm] = ACTIONS(3336),
    [anon_sym___asm__] = ACTIONS(3336),
    [aux_sym_number_literal_token1] = ACTIONS(3338),
    [aux_sym_number_literal_token2] = ACTIONS(3336),
    [anon_sym_L_SQUOTE] = ACTIONS(3338),
    [anon_sym_u_SQUOTE] = ACTIONS(3338),
    [anon_sym_U_SQUOTE] = ACTIONS(3338),
    [anon_sym_u8_SQUOTE] = ACTIONS(3338),
    [anon_sym_SQUOTE] = ACTIONS(3338),
    [anon_sym_L_DQUOTE] = ACTIONS(3338),
    [anon_sym_u_DQUOTE] = ACTIONS(3338),
    [anon_sym_U_DQUOTE] = ACTIONS(3338),
    [anon_sym_u8_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE] = ACTIONS(3338),
    [sym_true] = ACTIONS(3336),
    [sym_false] = ACTIONS(3336),
    [anon_sym_NULL] = ACTIONS(3336),
    [anon_sym_nullptr] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3336),
    [anon_sym_decltype] = ACTIONS(3336),
    [anon_sym_virtual] = ACTIONS(3336),
    [anon_sym_alignas] = ACTIONS(3336),
    [anon_sym_explicit] = ACTIONS(3336),
    [anon_sym_typename] = ACTIONS(3336),
    [anon_sym_template] = ACTIONS(3336),
    [anon_sym_operator] = ACTIONS(3336),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_delete] = ACTIONS(3336),
    [anon_sym_throw] = ACTIONS(3336),
    [anon_sym_namespace] = ACTIONS(3336),
    [anon_sym_using] = ACTIONS(3336),
    [anon_sym_static_assert] = ACTIONS(3336),
    [anon_sym_concept] = ACTIONS(3336),
    [anon_sym_co_return] = ACTIONS(3336),
    [anon_sym_co_yield] = ACTIONS(3336),
    [anon_sym_R_DQUOTE] = ACTIONS(3338),
    [anon_sym_LR_DQUOTE] = ACTIONS(3338),
    [anon_sym_uR_DQUOTE] = ACTIONS(3338),
    [anon_sym_UR_DQUOTE] = ACTIONS(3338),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3338),
    [anon_sym_co_await] = ACTIONS(3336),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_requires] = ACTIONS(3336),
    [sym_this] = ACTIONS(3336),
  },
  [1093] = {
    [ts_builtin_sym_end] = ACTIONS(3338),
    [sym_identifier] = ACTIONS(3336),
    [aux_sym_preproc_include_token1] = ACTIONS(3336),
    [aux_sym_preproc_def_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token1] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3336),
    [sym_preproc_directive] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_BANG] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym___extension__] = ACTIONS(3336),
    [anon_sym_typedef] = ACTIONS(3336),
    [anon_sym_extern] = ACTIONS(3336),
    [anon_sym___attribute__] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3338),
    [anon_sym___declspec] = ACTIONS(3336),
    [anon_sym___based] = ACTIONS(3336),
    [anon_sym___cdecl] = ACTIONS(3336),
    [anon_sym___clrcall] = ACTIONS(3336),
    [anon_sym___stdcall] = ACTIONS(3336),
    [anon_sym___fastcall] = ACTIONS(3336),
    [anon_sym___thiscall] = ACTIONS(3336),
    [anon_sym___vectorcall] = ACTIONS(3336),
    [anon_sym_LBRACE] = ACTIONS(3338),
    [anon_sym_signed] = ACTIONS(3336),
    [anon_sym_unsigned] = ACTIONS(3336),
    [anon_sym_long] = ACTIONS(3336),
    [anon_sym_short] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_static] = ACTIONS(3336),
    [anon_sym_register] = ACTIONS(3336),
    [anon_sym_inline] = ACTIONS(3336),
    [anon_sym___inline] = ACTIONS(3336),
    [anon_sym___inline__] = ACTIONS(3336),
    [anon_sym___forceinline] = ACTIONS(3336),
    [anon_sym_thread_local] = ACTIONS(3336),
    [anon_sym___thread] = ACTIONS(3336),
    [anon_sym_const] = ACTIONS(3336),
    [anon_sym_constexpr] = ACTIONS(3336),
    [anon_sym_volatile] = ACTIONS(3336),
    [anon_sym_restrict] = ACTIONS(3336),
    [anon_sym___restrict__] = ACTIONS(3336),
    [anon_sym__Atomic] = ACTIONS(3336),
    [anon_sym__Noreturn] = ACTIONS(3336),
    [anon_sym_noreturn] = ACTIONS(3336),
    [anon_sym_mutable] = ACTIONS(3336),
    [anon_sym_constinit] = ACTIONS(3336),
    [anon_sym_consteval] = ACTIONS(3336),
    [anon_sym_PROGMEM] = ACTIONS(3336),
    [aux_sym_primitive_type_token1] = ACTIONS(3336),
    [anon_sym_byte] = ACTIONS(3336),
    [anon_sym_word] = ACTIONS(3336),
    [anon_sym_enum] = ACTIONS(3336),
    [anon_sym_class] = ACTIONS(3336),
    [anon_sym_struct] = ACTIONS(3336),
    [anon_sym_union] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_switch] = ACTIONS(3336),
    [anon_sym_case] = ACTIONS(3336),
    [anon_sym_default] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_break] = ACTIONS(3336),
    [anon_sym_continue] = ACTIONS(3336),
    [anon_sym_goto] = ACTIONS(3336),
    [anon_sym_not] = ACTIONS(3336),
    [anon_sym_compl] = ACTIONS(3336),
    [anon_sym_DASH_DASH] = ACTIONS(3338),
    [anon_sym_PLUS_PLUS] = ACTIONS(3338),
    [anon_sym_sizeof] = ACTIONS(3336),
    [anon_sym___alignof__] = ACTIONS(3336),
    [anon_sym___alignof] = ACTIONS(3336),
    [anon_sym__alignof] = ACTIONS(3336),
    [anon_sym_alignof] = ACTIONS(3336),
    [anon_sym__Alignof] = ACTIONS(3336),
    [anon_sym_offsetof] = ACTIONS(3336),
    [anon_sym__Generic] = ACTIONS(3336),
    [anon_sym_asm] = ACTIONS(3336),
    [anon_sym___asm__] = ACTIONS(3336),
    [aux_sym_number_literal_token1] = ACTIONS(3338),
    [aux_sym_number_literal_token2] = ACTIONS(3336),
    [anon_sym_L_SQUOTE] = ACTIONS(3338),
    [anon_sym_u_SQUOTE] = ACTIONS(3338),
    [anon_sym_U_SQUOTE] = ACTIONS(3338),
    [anon_sym_u8_SQUOTE] = ACTIONS(3338),
    [anon_sym_SQUOTE] = ACTIONS(3338),
    [anon_sym_L_DQUOTE] = ACTIONS(3338),
    [anon_sym_u_DQUOTE] = ACTIONS(3338),
    [anon_sym_U_DQUOTE] = ACTIONS(3338),
    [anon_sym_u8_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE] = ACTIONS(3338),
    [sym_true] = ACTIONS(3336),
    [sym_false] = ACTIONS(3336),
    [anon_sym_NULL] = ACTIONS(3336),
    [anon_sym_nullptr] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3336),
    [anon_sym_decltype] = ACTIONS(3336),
    [anon_sym_virtual] = ACTIONS(3336),
    [anon_sym_alignas] = ACTIONS(3336),
    [anon_sym_explicit] = ACTIONS(3336),
    [anon_sym_typename] = ACTIONS(3336),
    [anon_sym_template] = ACTIONS(3336),
    [anon_sym_operator] = ACTIONS(3336),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_delete] = ACTIONS(3336),
    [anon_sym_throw] = ACTIONS(3336),
    [anon_sym_namespace] = ACTIONS(3336),
    [anon_sym_using] = ACTIONS(3336),
    [anon_sym_static_assert] = ACTIONS(3336),
    [anon_sym_concept] = ACTIONS(3336),
    [anon_sym_co_return] = ACTIONS(3336),
    [anon_sym_co_yield] = ACTIONS(3336),
    [anon_sym_R_DQUOTE] = ACTIONS(3338),
    [anon_sym_LR_DQUOTE] = ACTIONS(3338),
    [anon_sym_uR_DQUOTE] = ACTIONS(3338),
    [anon_sym_UR_DQUOTE] = ACTIONS(3338),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3338),
    [anon_sym_co_await] = ACTIONS(3336),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_requires] = ACTIONS(3336),
    [sym_this] = ACTIONS(3336),
  },
  [1094] = {
    [sym_preproc_def] = STATE(1076),
    [sym_preproc_function_def] = STATE(1076),
    [sym_preproc_call] = STATE(1076),
    [sym_preproc_if_in_field_declaration_list] = STATE(1076),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1076),
    [sym_type_definition] = STATE(1076),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1076),
    [sym_field_declaration] = STATE(1076),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1076),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1076),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1076),
    [sym_operator_cast_declaration] = STATE(1076),
    [sym_constructor_or_destructor_definition] = STATE(1076),
    [sym_constructor_or_destructor_declaration] = STATE(1076),
    [sym_friend_declaration] = STATE(1076),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1076),
    [sym_alias_declaration] = STATE(1076),
    [sym_static_assert_declaration] = STATE(1076),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1076),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3829),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3829),
    [sym_preproc_directive] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3833),
    [anon_sym_typedef] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_static_assert] = ACTIONS(3845),
  },
  [1095] = {
    [sym_preproc_def] = STATE(1056),
    [sym_preproc_function_def] = STATE(1056),
    [sym_preproc_call] = STATE(1056),
    [sym_preproc_if_in_field_declaration_list] = STATE(1056),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1056),
    [sym_type_definition] = STATE(1056),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1056),
    [sym_field_declaration] = STATE(1056),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1056),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1056),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1056),
    [sym_operator_cast_declaration] = STATE(1056),
    [sym_constructor_or_destructor_definition] = STATE(1056),
    [sym_constructor_or_destructor_declaration] = STATE(1056),
    [sym_friend_declaration] = STATE(1056),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1056),
    [sym_alias_declaration] = STATE(1056),
    [sym_static_assert_declaration] = STATE(1056),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1056),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3829),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3829),
    [sym_preproc_directive] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3833),
    [anon_sym_typedef] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(4025),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_static_assert] = ACTIONS(3845),
  },
  [1096] = {
    [sym_preproc_def] = STATE(1095),
    [sym_preproc_function_def] = STATE(1095),
    [sym_preproc_call] = STATE(1095),
    [sym_preproc_if_in_field_declaration_list] = STATE(1095),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1095),
    [sym_type_definition] = STATE(1095),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(6455),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__field_declaration_list_item] = STATE(1095),
    [sym_field_declaration] = STATE(1095),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1095),
    [sym_operator_cast] = STATE(7501),
    [sym_inline_method_definition] = STATE(1095),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(1095),
    [sym_operator_cast_declaration] = STATE(1095),
    [sym_constructor_or_destructor_definition] = STATE(1095),
    [sym_constructor_or_destructor_declaration] = STATE(1095),
    [sym_friend_declaration] = STATE(1095),
    [sym_access_specifier] = STATE(8793),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_using_declaration] = STATE(1095),
    [sym_alias_declaration] = STATE(1095),
    [sym_static_assert_declaration] = STATE(1095),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6250),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1095),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3829),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3829),
    [sym_preproc_directive] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3833),
    [anon_sym_typedef] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(4027),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3244),
    [anon_sym_private] = ACTIONS(3244),
    [anon_sym_protected] = ACTIONS(3244),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_static_assert] = ACTIONS(3845),
  },
  [1097] = {
    [ts_builtin_sym_end] = ACTIONS(4029),
    [sym_identifier] = ACTIONS(4031),
    [aux_sym_preproc_include_token1] = ACTIONS(4031),
    [aux_sym_preproc_def_token1] = ACTIONS(4031),
    [aux_sym_preproc_if_token1] = ACTIONS(4031),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4031),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4031),
    [sym_preproc_directive] = ACTIONS(4031),
    [anon_sym_LPAREN2] = ACTIONS(4029),
    [anon_sym_BANG] = ACTIONS(4029),
    [anon_sym_TILDE] = ACTIONS(4029),
    [anon_sym_DASH] = ACTIONS(4031),
    [anon_sym_PLUS] = ACTIONS(4031),
    [anon_sym_STAR] = ACTIONS(4029),
    [anon_sym_AMP_AMP] = ACTIONS(4029),
    [anon_sym_AMP] = ACTIONS(4031),
    [anon_sym___extension__] = ACTIONS(4031),
    [anon_sym_typedef] = ACTIONS(4031),
    [anon_sym_extern] = ACTIONS(4031),
    [anon_sym___attribute__] = ACTIONS(4031),
    [anon_sym_COLON_COLON] = ACTIONS(4029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4029),
    [anon_sym___declspec] = ACTIONS(4031),
    [anon_sym___based] = ACTIONS(4031),
    [anon_sym___cdecl] = ACTIONS(4031),
    [anon_sym___clrcall] = ACTIONS(4031),
    [anon_sym___stdcall] = ACTIONS(4031),
    [anon_sym___fastcall] = ACTIONS(4031),
    [anon_sym___thiscall] = ACTIONS(4031),
    [anon_sym___vectorcall] = ACTIONS(4031),
    [anon_sym_LBRACE] = ACTIONS(4029),
    [anon_sym_signed] = ACTIONS(4031),
    [anon_sym_unsigned] = ACTIONS(4031),
    [anon_sym_long] = ACTIONS(4031),
    [anon_sym_short] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4031),
    [anon_sym_static] = ACTIONS(4031),
    [anon_sym_register] = ACTIONS(4031),
    [anon_sym_inline] = ACTIONS(4031),
    [anon_sym___inline] = ACTIONS(4031),
    [anon_sym___inline__] = ACTIONS(4031),
    [anon_sym___forceinline] = ACTIONS(4031),
    [anon_sym_thread_local] = ACTIONS(4031),
    [anon_sym___thread] = ACTIONS(4031),
    [anon_sym_const] = ACTIONS(4031),
    [anon_sym_constexpr] = ACTIONS(4031),
    [anon_sym_volatile] = ACTIONS(4031),
    [anon_sym_restrict] = ACTIONS(4031),
    [anon_sym___restrict__] = ACTIONS(4031),
    [anon_sym__Atomic] = ACTIONS(4031),
    [anon_sym__Noreturn] = ACTIONS(4031),
    [anon_sym_noreturn] = ACTIONS(4031),
    [anon_sym_mutable] = ACTIONS(4031),
    [anon_sym_constinit] = ACTIONS(4031),
    [anon_sym_consteval] = ACTIONS(4031),
    [anon_sym_PROGMEM] = ACTIONS(4031),
    [aux_sym_primitive_type_token1] = ACTIONS(4031),
    [anon_sym_byte] = ACTIONS(4031),
    [anon_sym_word] = ACTIONS(4031),
    [anon_sym_enum] = ACTIONS(4031),
    [anon_sym_class] = ACTIONS(4031),
    [anon_sym_struct] = ACTIONS(4031),
    [anon_sym_union] = ACTIONS(4031),
    [anon_sym_if] = ACTIONS(4031),
    [anon_sym_switch] = ACTIONS(4031),
    [anon_sym_case] = ACTIONS(4031),
    [anon_sym_default] = ACTIONS(4031),
    [anon_sym_while] = ACTIONS(4031),
    [anon_sym_do] = ACTIONS(4031),
    [anon_sym_for] = ACTIONS(4031),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_break] = ACTIONS(4031),
    [anon_sym_continue] = ACTIONS(4031),
    [anon_sym_goto] = ACTIONS(4031),
    [anon_sym_not] = ACTIONS(4031),
    [anon_sym_compl] = ACTIONS(4031),
    [anon_sym_DASH_DASH] = ACTIONS(4029),
    [anon_sym_PLUS_PLUS] = ACTIONS(4029),
    [anon_sym_sizeof] = ACTIONS(4031),
    [anon_sym___alignof__] = ACTIONS(4031),
    [anon_sym___alignof] = ACTIONS(4031),
    [anon_sym__alignof] = ACTIONS(4031),
    [anon_sym_alignof] = ACTIONS(4031),
    [anon_sym__Alignof] = ACTIONS(4031),
    [anon_sym_offsetof] = ACTIONS(4031),
    [anon_sym__Generic] = ACTIONS(4031),
    [anon_sym_asm] = ACTIONS(4031),
    [anon_sym___asm__] = ACTIONS(4031),
    [aux_sym_number_literal_token1] = ACTIONS(4029),
    [aux_sym_number_literal_token2] = ACTIONS(4031),
    [anon_sym_L_SQUOTE] = ACTIONS(4029),
    [anon_sym_u_SQUOTE] = ACTIONS(4029),
    [anon_sym_U_SQUOTE] = ACTIONS(4029),
    [anon_sym_u8_SQUOTE] = ACTIONS(4029),
    [anon_sym_SQUOTE] = ACTIONS(4029),
    [anon_sym_L_DQUOTE] = ACTIONS(4029),
    [anon_sym_u_DQUOTE] = ACTIONS(4029),
    [anon_sym_U_DQUOTE] = ACTIONS(4029),
    [anon_sym_u8_DQUOTE] = ACTIONS(4029),
    [anon_sym_DQUOTE] = ACTIONS(4029),
    [sym_true] = ACTIONS(4031),
    [sym_false] = ACTIONS(4031),
    [anon_sym_NULL] = ACTIONS(4031),
    [anon_sym_nullptr] = ACTIONS(4031),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4031),
    [anon_sym_decltype] = ACTIONS(4031),
    [anon_sym_virtual] = ACTIONS(4031),
    [anon_sym_alignas] = ACTIONS(4031),
    [anon_sym_explicit] = ACTIONS(4031),
    [anon_sym_typename] = ACTIONS(4031),
    [anon_sym_template] = ACTIONS(4031),
    [anon_sym_operator] = ACTIONS(4031),
    [anon_sym_try] = ACTIONS(4031),
    [anon_sym_delete] = ACTIONS(4031),
    [anon_sym_throw] = ACTIONS(4031),
    [anon_sym_namespace] = ACTIONS(4031),
    [anon_sym_using] = ACTIONS(4031),
    [anon_sym_static_assert] = ACTIONS(4031),
    [anon_sym_concept] = ACTIONS(4031),
    [anon_sym_co_return] = ACTIONS(4031),
    [anon_sym_co_yield] = ACTIONS(4031),
    [anon_sym_R_DQUOTE] = ACTIONS(4029),
    [anon_sym_LR_DQUOTE] = ACTIONS(4029),
    [anon_sym_uR_DQUOTE] = ACTIONS(4029),
    [anon_sym_UR_DQUOTE] = ACTIONS(4029),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4029),
    [anon_sym_co_await] = ACTIONS(4031),
    [anon_sym_new] = ACTIONS(4031),
    [anon_sym_requires] = ACTIONS(4031),
    [sym_this] = ACTIONS(4031),
  },
  [1098] = {
    [ts_builtin_sym_end] = ACTIONS(3519),
    [sym_identifier] = ACTIONS(3517),
    [aux_sym_preproc_include_token1] = ACTIONS(3517),
    [aux_sym_preproc_def_token1] = ACTIONS(3517),
    [aux_sym_preproc_if_token1] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3517),
    [sym_preproc_directive] = ACTIONS(3517),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_BANG] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3517),
    [anon_sym_PLUS] = ACTIONS(3517),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym___extension__] = ACTIONS(3517),
    [anon_sym_typedef] = ACTIONS(3517),
    [anon_sym_extern] = ACTIONS(3517),
    [anon_sym___attribute__] = ACTIONS(3517),
    [anon_sym_COLON_COLON] = ACTIONS(3519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3519),
    [anon_sym___declspec] = ACTIONS(3517),
    [anon_sym___based] = ACTIONS(3517),
    [anon_sym___cdecl] = ACTIONS(3517),
    [anon_sym___clrcall] = ACTIONS(3517),
    [anon_sym___stdcall] = ACTIONS(3517),
    [anon_sym___fastcall] = ACTIONS(3517),
    [anon_sym___thiscall] = ACTIONS(3517),
    [anon_sym___vectorcall] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_signed] = ACTIONS(3517),
    [anon_sym_unsigned] = ACTIONS(3517),
    [anon_sym_long] = ACTIONS(3517),
    [anon_sym_short] = ACTIONS(3517),
    [anon_sym_LBRACK] = ACTIONS(3517),
    [anon_sym_static] = ACTIONS(3517),
    [anon_sym_register] = ACTIONS(3517),
    [anon_sym_inline] = ACTIONS(3517),
    [anon_sym___inline] = ACTIONS(3517),
    [anon_sym___inline__] = ACTIONS(3517),
    [anon_sym___forceinline] = ACTIONS(3517),
    [anon_sym_thread_local] = ACTIONS(3517),
    [anon_sym___thread] = ACTIONS(3517),
    [anon_sym_const] = ACTIONS(3517),
    [anon_sym_constexpr] = ACTIONS(3517),
    [anon_sym_volatile] = ACTIONS(3517),
    [anon_sym_restrict] = ACTIONS(3517),
    [anon_sym___restrict__] = ACTIONS(3517),
    [anon_sym__Atomic] = ACTIONS(3517),
    [anon_sym__Noreturn] = ACTIONS(3517),
    [anon_sym_noreturn] = ACTIONS(3517),
    [anon_sym_mutable] = ACTIONS(3517),
    [anon_sym_constinit] = ACTIONS(3517),
    [anon_sym_consteval] = ACTIONS(3517),
    [anon_sym_PROGMEM] = ACTIONS(3517),
    [aux_sym_primitive_type_token1] = ACTIONS(3517),
    [anon_sym_byte] = ACTIONS(3517),
    [anon_sym_word] = ACTIONS(3517),
    [anon_sym_enum] = ACTIONS(3517),
    [anon_sym_class] = ACTIONS(3517),
    [anon_sym_struct] = ACTIONS(3517),
    [anon_sym_union] = ACTIONS(3517),
    [anon_sym_if] = ACTIONS(3517),
    [anon_sym_switch] = ACTIONS(3517),
    [anon_sym_case] = ACTIONS(3517),
    [anon_sym_default] = ACTIONS(3517),
    [anon_sym_while] = ACTIONS(3517),
    [anon_sym_do] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3517),
    [anon_sym_return] = ACTIONS(3517),
    [anon_sym_break] = ACTIONS(3517),
    [anon_sym_continue] = ACTIONS(3517),
    [anon_sym_goto] = ACTIONS(3517),
    [anon_sym_not] = ACTIONS(3517),
    [anon_sym_compl] = ACTIONS(3517),
    [anon_sym_DASH_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_PLUS] = ACTIONS(3519),
    [anon_sym_sizeof] = ACTIONS(3517),
    [anon_sym___alignof__] = ACTIONS(3517),
    [anon_sym___alignof] = ACTIONS(3517),
    [anon_sym__alignof] = ACTIONS(3517),
    [anon_sym_alignof] = ACTIONS(3517),
    [anon_sym__Alignof] = ACTIONS(3517),
    [anon_sym_offsetof] = ACTIONS(3517),
    [anon_sym__Generic] = ACTIONS(3517),
    [anon_sym_asm] = ACTIONS(3517),
    [anon_sym___asm__] = ACTIONS(3517),
    [aux_sym_number_literal_token1] = ACTIONS(3519),
    [aux_sym_number_literal_token2] = ACTIONS(3517),
    [anon_sym_L_SQUOTE] = ACTIONS(3519),
    [anon_sym_u_SQUOTE] = ACTIONS(3519),
    [anon_sym_U_SQUOTE] = ACTIONS(3519),
    [anon_sym_u8_SQUOTE] = ACTIONS(3519),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_L_DQUOTE] = ACTIONS(3519),
    [anon_sym_u_DQUOTE] = ACTIONS(3519),
    [anon_sym_U_DQUOTE] = ACTIONS(3519),
    [anon_sym_u8_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [sym_true] = ACTIONS(3517),
    [sym_false] = ACTIONS(3517),
    [anon_sym_NULL] = ACTIONS(3517),
    [anon_sym_nullptr] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3517),
    [anon_sym_decltype] = ACTIONS(3517),
    [anon_sym_virtual] = ACTIONS(3517),
    [anon_sym_alignas] = ACTIONS(3517),
    [anon_sym_explicit] = ACTIONS(3517),
    [anon_sym_typename] = ACTIONS(3517),
    [anon_sym_template] = ACTIONS(3517),
    [anon_sym_operator] = ACTIONS(3517),
    [anon_sym_try] = ACTIONS(3517),
    [anon_sym_delete] = ACTIONS(3517),
    [anon_sym_throw] = ACTIONS(3517),
    [anon_sym_namespace] = ACTIONS(3517),
    [anon_sym_using] = ACTIONS(3517),
    [anon_sym_static_assert] = ACTIONS(3517),
    [anon_sym_concept] = ACTIONS(3517),
    [anon_sym_co_return] = ACTIONS(3517),
    [anon_sym_co_yield] = ACTIONS(3517),
    [anon_sym_R_DQUOTE] = ACTIONS(3519),
    [anon_sym_LR_DQUOTE] = ACTIONS(3519),
    [anon_sym_uR_DQUOTE] = ACTIONS(3519),
    [anon_sym_UR_DQUOTE] = ACTIONS(3519),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3519),
    [anon_sym_co_await] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3517),
    [anon_sym_requires] = ACTIONS(3517),
    [sym_this] = ACTIONS(3517),
  },
  [1099] = {
    [ts_builtin_sym_end] = ACTIONS(3272),
    [sym_identifier] = ACTIONS(3270),
    [aux_sym_preproc_include_token1] = ACTIONS(3270),
    [aux_sym_preproc_def_token1] = ACTIONS(3270),
    [aux_sym_preproc_if_token1] = ACTIONS(3270),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3270),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3270),
    [sym_preproc_directive] = ACTIONS(3270),
    [anon_sym_LPAREN2] = ACTIONS(3272),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3270),
    [anon_sym_PLUS] = ACTIONS(3270),
    [anon_sym_STAR] = ACTIONS(3272),
    [anon_sym_AMP_AMP] = ACTIONS(3272),
    [anon_sym_AMP] = ACTIONS(3270),
    [anon_sym___extension__] = ACTIONS(3270),
    [anon_sym_typedef] = ACTIONS(3270),
    [anon_sym_extern] = ACTIONS(3270),
    [anon_sym___attribute__] = ACTIONS(3270),
    [anon_sym_COLON_COLON] = ACTIONS(3272),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3272),
    [anon_sym___declspec] = ACTIONS(3270),
    [anon_sym___based] = ACTIONS(3270),
    [anon_sym___cdecl] = ACTIONS(3270),
    [anon_sym___clrcall] = ACTIONS(3270),
    [anon_sym___stdcall] = ACTIONS(3270),
    [anon_sym___fastcall] = ACTIONS(3270),
    [anon_sym___thiscall] = ACTIONS(3270),
    [anon_sym___vectorcall] = ACTIONS(3270),
    [anon_sym_LBRACE] = ACTIONS(3272),
    [anon_sym_signed] = ACTIONS(3270),
    [anon_sym_unsigned] = ACTIONS(3270),
    [anon_sym_long] = ACTIONS(3270),
    [anon_sym_short] = ACTIONS(3270),
    [anon_sym_LBRACK] = ACTIONS(3270),
    [anon_sym_static] = ACTIONS(3270),
    [anon_sym_register] = ACTIONS(3270),
    [anon_sym_inline] = ACTIONS(3270),
    [anon_sym___inline] = ACTIONS(3270),
    [anon_sym___inline__] = ACTIONS(3270),
    [anon_sym___forceinline] = ACTIONS(3270),
    [anon_sym_thread_local] = ACTIONS(3270),
    [anon_sym___thread] = ACTIONS(3270),
    [anon_sym_const] = ACTIONS(3270),
    [anon_sym_constexpr] = ACTIONS(3270),
    [anon_sym_volatile] = ACTIONS(3270),
    [anon_sym_restrict] = ACTIONS(3270),
    [anon_sym___restrict__] = ACTIONS(3270),
    [anon_sym__Atomic] = ACTIONS(3270),
    [anon_sym__Noreturn] = ACTIONS(3270),
    [anon_sym_noreturn] = ACTIONS(3270),
    [anon_sym_mutable] = ACTIONS(3270),
    [anon_sym_constinit] = ACTIONS(3270),
    [anon_sym_consteval] = ACTIONS(3270),
    [anon_sym_PROGMEM] = ACTIONS(3270),
    [aux_sym_primitive_type_token1] = ACTIONS(3270),
    [anon_sym_byte] = ACTIONS(3270),
    [anon_sym_word] = ACTIONS(3270),
    [anon_sym_enum] = ACTIONS(3270),
    [anon_sym_class] = ACTIONS(3270),
    [anon_sym_struct] = ACTIONS(3270),
    [anon_sym_union] = ACTIONS(3270),
    [anon_sym_if] = ACTIONS(3270),
    [anon_sym_switch] = ACTIONS(3270),
    [anon_sym_case] = ACTIONS(3270),
    [anon_sym_default] = ACTIONS(3270),
    [anon_sym_while] = ACTIONS(3270),
    [anon_sym_do] = ACTIONS(3270),
    [anon_sym_for] = ACTIONS(3270),
    [anon_sym_return] = ACTIONS(3270),
    [anon_sym_break] = ACTIONS(3270),
    [anon_sym_continue] = ACTIONS(3270),
    [anon_sym_goto] = ACTIONS(3270),
    [anon_sym_not] = ACTIONS(3270),
    [anon_sym_compl] = ACTIONS(3270),
    [anon_sym_DASH_DASH] = ACTIONS(3272),
    [anon_sym_PLUS_PLUS] = ACTIONS(3272),
    [anon_sym_sizeof] = ACTIONS(3270),
    [anon_sym___alignof__] = ACTIONS(3270),
    [anon_sym___alignof] = ACTIONS(3270),
    [anon_sym__alignof] = ACTIONS(3270),
    [anon_sym_alignof] = ACTIONS(3270),
    [anon_sym__Alignof] = ACTIONS(3270),
    [anon_sym_offsetof] = ACTIONS(3270),
    [anon_sym__Generic] = ACTIONS(3270),
    [anon_sym_asm] = ACTIONS(3270),
    [anon_sym___asm__] = ACTIONS(3270),
    [aux_sym_number_literal_token1] = ACTIONS(3272),
    [aux_sym_number_literal_token2] = ACTIONS(3270),
    [anon_sym_L_SQUOTE] = ACTIONS(3272),
    [anon_sym_u_SQUOTE] = ACTIONS(3272),
    [anon_sym_U_SQUOTE] = ACTIONS(3272),
    [anon_sym_u8_SQUOTE] = ACTIONS(3272),
    [anon_sym_SQUOTE] = ACTIONS(3272),
    [anon_sym_L_DQUOTE] = ACTIONS(3272),
    [anon_sym_u_DQUOTE] = ACTIONS(3272),
    [anon_sym_U_DQUOTE] = ACTIONS(3272),
    [anon_sym_u8_DQUOTE] = ACTIONS(3272),
    [anon_sym_DQUOTE] = ACTIONS(3272),
    [sym_true] = ACTIONS(3270),
    [sym_false] = ACTIONS(3270),
    [anon_sym_NULL] = ACTIONS(3270),
    [anon_sym_nullptr] = ACTIONS(3270),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3270),
    [anon_sym_decltype] = ACTIONS(3270),
    [anon_sym_virtual] = ACTIONS(3270),
    [anon_sym_alignas] = ACTIONS(3270),
    [anon_sym_explicit] = ACTIONS(3270),
    [anon_sym_typename] = ACTIONS(3270),
    [anon_sym_template] = ACTIONS(3270),
    [anon_sym_operator] = ACTIONS(3270),
    [anon_sym_try] = ACTIONS(3270),
    [anon_sym_delete] = ACTIONS(3270),
    [anon_sym_throw] = ACTIONS(3270),
    [anon_sym_namespace] = ACTIONS(3270),
    [anon_sym_using] = ACTIONS(3270),
    [anon_sym_static_assert] = ACTIONS(3270),
    [anon_sym_concept] = ACTIONS(3270),
    [anon_sym_co_return] = ACTIONS(3270),
    [anon_sym_co_yield] = ACTIONS(3270),
    [anon_sym_R_DQUOTE] = ACTIONS(3272),
    [anon_sym_LR_DQUOTE] = ACTIONS(3272),
    [anon_sym_uR_DQUOTE] = ACTIONS(3272),
    [anon_sym_UR_DQUOTE] = ACTIONS(3272),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3272),
    [anon_sym_co_await] = ACTIONS(3270),
    [anon_sym_new] = ACTIONS(3270),
    [anon_sym_requires] = ACTIONS(3270),
    [sym_this] = ACTIONS(3270),
  },
  [1100] = {
    [ts_builtin_sym_end] = ACTIONS(3453),
    [sym_identifier] = ACTIONS(3451),
    [aux_sym_preproc_include_token1] = ACTIONS(3451),
    [aux_sym_preproc_def_token1] = ACTIONS(3451),
    [aux_sym_preproc_if_token1] = ACTIONS(3451),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3451),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3451),
    [sym_preproc_directive] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3453),
    [anon_sym_BANG] = ACTIONS(3453),
    [anon_sym_TILDE] = ACTIONS(3453),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(3453),
    [anon_sym_AMP_AMP] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym___extension__] = ACTIONS(3451),
    [anon_sym_typedef] = ACTIONS(3451),
    [anon_sym_extern] = ACTIONS(3451),
    [anon_sym___attribute__] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3453),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3453),
    [anon_sym___declspec] = ACTIONS(3451),
    [anon_sym___based] = ACTIONS(3451),
    [anon_sym___cdecl] = ACTIONS(3451),
    [anon_sym___clrcall] = ACTIONS(3451),
    [anon_sym___stdcall] = ACTIONS(3451),
    [anon_sym___fastcall] = ACTIONS(3451),
    [anon_sym___thiscall] = ACTIONS(3451),
    [anon_sym___vectorcall] = ACTIONS(3451),
    [anon_sym_LBRACE] = ACTIONS(3453),
    [anon_sym_signed] = ACTIONS(3451),
    [anon_sym_unsigned] = ACTIONS(3451),
    [anon_sym_long] = ACTIONS(3451),
    [anon_sym_short] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_register] = ACTIONS(3451),
    [anon_sym_inline] = ACTIONS(3451),
    [anon_sym___inline] = ACTIONS(3451),
    [anon_sym___inline__] = ACTIONS(3451),
    [anon_sym___forceinline] = ACTIONS(3451),
    [anon_sym_thread_local] = ACTIONS(3451),
    [anon_sym___thread] = ACTIONS(3451),
    [anon_sym_const] = ACTIONS(3451),
    [anon_sym_constexpr] = ACTIONS(3451),
    [anon_sym_volatile] = ACTIONS(3451),
    [anon_sym_restrict] = ACTIONS(3451),
    [anon_sym___restrict__] = ACTIONS(3451),
    [anon_sym__Atomic] = ACTIONS(3451),
    [anon_sym__Noreturn] = ACTIONS(3451),
    [anon_sym_noreturn] = ACTIONS(3451),
    [anon_sym_mutable] = ACTIONS(3451),
    [anon_sym_constinit] = ACTIONS(3451),
    [anon_sym_consteval] = ACTIONS(3451),
    [anon_sym_PROGMEM] = ACTIONS(3451),
    [aux_sym_primitive_type_token1] = ACTIONS(3451),
    [anon_sym_byte] = ACTIONS(3451),
    [anon_sym_word] = ACTIONS(3451),
    [anon_sym_enum] = ACTIONS(3451),
    [anon_sym_class] = ACTIONS(3451),
    [anon_sym_struct] = ACTIONS(3451),
    [anon_sym_union] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_switch] = ACTIONS(3451),
    [anon_sym_case] = ACTIONS(3451),
    [anon_sym_default] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_break] = ACTIONS(3451),
    [anon_sym_continue] = ACTIONS(3451),
    [anon_sym_goto] = ACTIONS(3451),
    [anon_sym_not] = ACTIONS(3451),
    [anon_sym_compl] = ACTIONS(3451),
    [anon_sym_DASH_DASH] = ACTIONS(3453),
    [anon_sym_PLUS_PLUS] = ACTIONS(3453),
    [anon_sym_sizeof] = ACTIONS(3451),
    [anon_sym___alignof__] = ACTIONS(3451),
    [anon_sym___alignof] = ACTIONS(3451),
    [anon_sym__alignof] = ACTIONS(3451),
    [anon_sym_alignof] = ACTIONS(3451),
    [anon_sym__Alignof] = ACTIONS(3451),
    [anon_sym_offsetof] = ACTIONS(3451),
    [anon_sym__Generic] = ACTIONS(3451),
    [anon_sym_asm] = ACTIONS(3451),
    [anon_sym___asm__] = ACTIONS(3451),
    [aux_sym_number_literal_token1] = ACTIONS(3453),
    [aux_sym_number_literal_token2] = ACTIONS(3451),
    [anon_sym_L_SQUOTE] = ACTIONS(3453),
    [anon_sym_u_SQUOTE] = ACTIONS(3453),
    [anon_sym_U_SQUOTE] = ACTIONS(3453),
    [anon_sym_u8_SQUOTE] = ACTIONS(3453),
    [anon_sym_SQUOTE] = ACTIONS(3453),
    [anon_sym_L_DQUOTE] = ACTIONS(3453),
    [anon_sym_u_DQUOTE] = ACTIONS(3453),
    [anon_sym_U_DQUOTE] = ACTIONS(3453),
    [anon_sym_u8_DQUOTE] = ACTIONS(3453),
    [anon_sym_DQUOTE] = ACTIONS(3453),
    [sym_true] = ACTIONS(3451),
    [sym_false] = ACTIONS(3451),
    [anon_sym_NULL] = ACTIONS(3451),
    [anon_sym_nullptr] = ACTIONS(3451),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3451),
    [anon_sym_decltype] = ACTIONS(3451),
    [anon_sym_virtual] = ACTIONS(3451),
    [anon_sym_alignas] = ACTIONS(3451),
    [anon_sym_explicit] = ACTIONS(3451),
    [anon_sym_typename] = ACTIONS(3451),
    [anon_sym_template] = ACTIONS(3451),
    [anon_sym_operator] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_delete] = ACTIONS(3451),
    [anon_sym_throw] = ACTIONS(3451),
    [anon_sym_namespace] = ACTIONS(3451),
    [anon_sym_using] = ACTIONS(3451),
    [anon_sym_static_assert] = ACTIONS(3451),
    [anon_sym_concept] = ACTIONS(3451),
    [anon_sym_co_return] = ACTIONS(3451),
    [anon_sym_co_yield] = ACTIONS(3451),
    [anon_sym_R_DQUOTE] = ACTIONS(3453),
    [anon_sym_LR_DQUOTE] = ACTIONS(3453),
    [anon_sym_uR_DQUOTE] = ACTIONS(3453),
    [anon_sym_UR_DQUOTE] = ACTIONS(3453),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3453),
    [anon_sym_co_await] = ACTIONS(3451),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_requires] = ACTIONS(3451),
    [sym_this] = ACTIONS(3451),
  },
  [1101] = {
    [ts_builtin_sym_end] = ACTIONS(3457),
    [sym_identifier] = ACTIONS(3455),
    [aux_sym_preproc_include_token1] = ACTIONS(3455),
    [aux_sym_preproc_def_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token1] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3455),
    [sym_preproc_directive] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_BANG] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_STAR] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym___extension__] = ACTIONS(3455),
    [anon_sym_typedef] = ACTIONS(3455),
    [anon_sym_extern] = ACTIONS(3455),
    [anon_sym___attribute__] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3457),
    [anon_sym___declspec] = ACTIONS(3455),
    [anon_sym___based] = ACTIONS(3455),
    [anon_sym___cdecl] = ACTIONS(3455),
    [anon_sym___clrcall] = ACTIONS(3455),
    [anon_sym___stdcall] = ACTIONS(3455),
    [anon_sym___fastcall] = ACTIONS(3455),
    [anon_sym___thiscall] = ACTIONS(3455),
    [anon_sym___vectorcall] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_signed] = ACTIONS(3455),
    [anon_sym_unsigned] = ACTIONS(3455),
    [anon_sym_long] = ACTIONS(3455),
    [anon_sym_short] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_static] = ACTIONS(3455),
    [anon_sym_register] = ACTIONS(3455),
    [anon_sym_inline] = ACTIONS(3455),
    [anon_sym___inline] = ACTIONS(3455),
    [anon_sym___inline__] = ACTIONS(3455),
    [anon_sym___forceinline] = ACTIONS(3455),
    [anon_sym_thread_local] = ACTIONS(3455),
    [anon_sym___thread] = ACTIONS(3455),
    [anon_sym_const] = ACTIONS(3455),
    [anon_sym_constexpr] = ACTIONS(3455),
    [anon_sym_volatile] = ACTIONS(3455),
    [anon_sym_restrict] = ACTIONS(3455),
    [anon_sym___restrict__] = ACTIONS(3455),
    [anon_sym__Atomic] = ACTIONS(3455),
    [anon_sym__Noreturn] = ACTIONS(3455),
    [anon_sym_noreturn] = ACTIONS(3455),
    [anon_sym_mutable] = ACTIONS(3455),
    [anon_sym_constinit] = ACTIONS(3455),
    [anon_sym_consteval] = ACTIONS(3455),
    [anon_sym_PROGMEM] = ACTIONS(3455),
    [aux_sym_primitive_type_token1] = ACTIONS(3455),
    [anon_sym_byte] = ACTIONS(3455),
    [anon_sym_word] = ACTIONS(3455),
    [anon_sym_enum] = ACTIONS(3455),
    [anon_sym_class] = ACTIONS(3455),
    [anon_sym_struct] = ACTIONS(3455),
    [anon_sym_union] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_switch] = ACTIONS(3455),
    [anon_sym_case] = ACTIONS(3455),
    [anon_sym_default] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_break] = ACTIONS(3455),
    [anon_sym_continue] = ACTIONS(3455),
    [anon_sym_goto] = ACTIONS(3455),
    [anon_sym_not] = ACTIONS(3455),
    [anon_sym_compl] = ACTIONS(3455),
    [anon_sym_DASH_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_PLUS] = ACTIONS(3457),
    [anon_sym_sizeof] = ACTIONS(3455),
    [anon_sym___alignof__] = ACTIONS(3455),
    [anon_sym___alignof] = ACTIONS(3455),
    [anon_sym__alignof] = ACTIONS(3455),
    [anon_sym_alignof] = ACTIONS(3455),
    [anon_sym__Alignof] = ACTIONS(3455),
    [anon_sym_offsetof] = ACTIONS(3455),
    [anon_sym__Generic] = ACTIONS(3455),
    [anon_sym_asm] = ACTIONS(3455),
    [anon_sym___asm__] = ACTIONS(3455),
    [aux_sym_number_literal_token1] = ACTIONS(3457),
    [aux_sym_number_literal_token2] = ACTIONS(3455),
    [anon_sym_L_SQUOTE] = ACTIONS(3457),
    [anon_sym_u_SQUOTE] = ACTIONS(3457),
    [anon_sym_U_SQUOTE] = ACTIONS(3457),
    [anon_sym_u8_SQUOTE] = ACTIONS(3457),
    [anon_sym_SQUOTE] = ACTIONS(3457),
    [anon_sym_L_DQUOTE] = ACTIONS(3457),
    [anon_sym_u_DQUOTE] = ACTIONS(3457),
    [anon_sym_U_DQUOTE] = ACTIONS(3457),
    [anon_sym_u8_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [sym_true] = ACTIONS(3455),
    [sym_false] = ACTIONS(3455),
    [anon_sym_NULL] = ACTIONS(3455),
    [anon_sym_nullptr] = ACTIONS(3455),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3455),
    [anon_sym_decltype] = ACTIONS(3455),
    [anon_sym_virtual] = ACTIONS(3455),
    [anon_sym_alignas] = ACTIONS(3455),
    [anon_sym_explicit] = ACTIONS(3455),
    [anon_sym_typename] = ACTIONS(3455),
    [anon_sym_template] = ACTIONS(3455),
    [anon_sym_operator] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_delete] = ACTIONS(3455),
    [anon_sym_throw] = ACTIONS(3455),
    [anon_sym_namespace] = ACTIONS(3455),
    [anon_sym_using] = ACTIONS(3455),
    [anon_sym_static_assert] = ACTIONS(3455),
    [anon_sym_concept] = ACTIONS(3455),
    [anon_sym_co_return] = ACTIONS(3455),
    [anon_sym_co_yield] = ACTIONS(3455),
    [anon_sym_R_DQUOTE] = ACTIONS(3457),
    [anon_sym_LR_DQUOTE] = ACTIONS(3457),
    [anon_sym_uR_DQUOTE] = ACTIONS(3457),
    [anon_sym_UR_DQUOTE] = ACTIONS(3457),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3457),
    [anon_sym_co_await] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_requires] = ACTIONS(3455),
    [sym_this] = ACTIONS(3455),
  },
  [1102] = {
    [ts_builtin_sym_end] = ACTIONS(3260),
    [sym_identifier] = ACTIONS(3258),
    [aux_sym_preproc_include_token1] = ACTIONS(3258),
    [aux_sym_preproc_def_token1] = ACTIONS(3258),
    [aux_sym_preproc_if_token1] = ACTIONS(3258),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3258),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3258),
    [sym_preproc_directive] = ACTIONS(3258),
    [anon_sym_LPAREN2] = ACTIONS(3260),
    [anon_sym_BANG] = ACTIONS(3260),
    [anon_sym_TILDE] = ACTIONS(3260),
    [anon_sym_DASH] = ACTIONS(3258),
    [anon_sym_PLUS] = ACTIONS(3258),
    [anon_sym_STAR] = ACTIONS(3260),
    [anon_sym_AMP_AMP] = ACTIONS(3260),
    [anon_sym_AMP] = ACTIONS(3258),
    [anon_sym___extension__] = ACTIONS(3258),
    [anon_sym_typedef] = ACTIONS(3258),
    [anon_sym_extern] = ACTIONS(3258),
    [anon_sym___attribute__] = ACTIONS(3258),
    [anon_sym_COLON_COLON] = ACTIONS(3260),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3260),
    [anon_sym___declspec] = ACTIONS(3258),
    [anon_sym___based] = ACTIONS(3258),
    [anon_sym___cdecl] = ACTIONS(3258),
    [anon_sym___clrcall] = ACTIONS(3258),
    [anon_sym___stdcall] = ACTIONS(3258),
    [anon_sym___fastcall] = ACTIONS(3258),
    [anon_sym___thiscall] = ACTIONS(3258),
    [anon_sym___vectorcall] = ACTIONS(3258),
    [anon_sym_LBRACE] = ACTIONS(3260),
    [anon_sym_signed] = ACTIONS(3258),
    [anon_sym_unsigned] = ACTIONS(3258),
    [anon_sym_long] = ACTIONS(3258),
    [anon_sym_short] = ACTIONS(3258),
    [anon_sym_LBRACK] = ACTIONS(3258),
    [anon_sym_static] = ACTIONS(3258),
    [anon_sym_register] = ACTIONS(3258),
    [anon_sym_inline] = ACTIONS(3258),
    [anon_sym___inline] = ACTIONS(3258),
    [anon_sym___inline__] = ACTIONS(3258),
    [anon_sym___forceinline] = ACTIONS(3258),
    [anon_sym_thread_local] = ACTIONS(3258),
    [anon_sym___thread] = ACTIONS(3258),
    [anon_sym_const] = ACTIONS(3258),
    [anon_sym_constexpr] = ACTIONS(3258),
    [anon_sym_volatile] = ACTIONS(3258),
    [anon_sym_restrict] = ACTIONS(3258),
    [anon_sym___restrict__] = ACTIONS(3258),
    [anon_sym__Atomic] = ACTIONS(3258),
    [anon_sym__Noreturn] = ACTIONS(3258),
    [anon_sym_noreturn] = ACTIONS(3258),
    [anon_sym_mutable] = ACTIONS(3258),
    [anon_sym_constinit] = ACTIONS(3258),
    [anon_sym_consteval] = ACTIONS(3258),
    [anon_sym_PROGMEM] = ACTIONS(3258),
    [aux_sym_primitive_type_token1] = ACTIONS(3258),
    [anon_sym_byte] = ACTIONS(3258),
    [anon_sym_word] = ACTIONS(3258),
    [anon_sym_enum] = ACTIONS(3258),
    [anon_sym_class] = ACTIONS(3258),
    [anon_sym_struct] = ACTIONS(3258),
    [anon_sym_union] = ACTIONS(3258),
    [anon_sym_if] = ACTIONS(3258),
    [anon_sym_switch] = ACTIONS(3258),
    [anon_sym_case] = ACTIONS(3258),
    [anon_sym_default] = ACTIONS(3258),
    [anon_sym_while] = ACTIONS(3258),
    [anon_sym_do] = ACTIONS(3258),
    [anon_sym_for] = ACTIONS(3258),
    [anon_sym_return] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3258),
    [anon_sym_continue] = ACTIONS(3258),
    [anon_sym_goto] = ACTIONS(3258),
    [anon_sym_not] = ACTIONS(3258),
    [anon_sym_compl] = ACTIONS(3258),
    [anon_sym_DASH_DASH] = ACTIONS(3260),
    [anon_sym_PLUS_PLUS] = ACTIONS(3260),
    [anon_sym_sizeof] = ACTIONS(3258),
    [anon_sym___alignof__] = ACTIONS(3258),
    [anon_sym___alignof] = ACTIONS(3258),
    [anon_sym__alignof] = ACTIONS(3258),
    [anon_sym_alignof] = ACTIONS(3258),
    [anon_sym__Alignof] = ACTIONS(3258),
    [anon_sym_offsetof] = ACTIONS(3258),
    [anon_sym__Generic] = ACTIONS(3258),
    [anon_sym_asm] = ACTIONS(3258),
    [anon_sym___asm__] = ACTIONS(3258),
    [aux_sym_number_literal_token1] = ACTIONS(3260),
    [aux_sym_number_literal_token2] = ACTIONS(3258),
    [anon_sym_L_SQUOTE] = ACTIONS(3260),
    [anon_sym_u_SQUOTE] = ACTIONS(3260),
    [anon_sym_U_SQUOTE] = ACTIONS(3260),
    [anon_sym_u8_SQUOTE] = ACTIONS(3260),
    [anon_sym_SQUOTE] = ACTIONS(3260),
    [anon_sym_L_DQUOTE] = ACTIONS(3260),
    [anon_sym_u_DQUOTE] = ACTIONS(3260),
    [anon_sym_U_DQUOTE] = ACTIONS(3260),
    [anon_sym_u8_DQUOTE] = ACTIONS(3260),
    [anon_sym_DQUOTE] = ACTIONS(3260),
    [sym_true] = ACTIONS(3258),
    [sym_false] = ACTIONS(3258),
    [anon_sym_NULL] = ACTIONS(3258),
    [anon_sym_nullptr] = ACTIONS(3258),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3258),
    [anon_sym_decltype] = ACTIONS(3258),
    [anon_sym_virtual] = ACTIONS(3258),
    [anon_sym_alignas] = ACTIONS(3258),
    [anon_sym_explicit] = ACTIONS(3258),
    [anon_sym_typename] = ACTIONS(3258),
    [anon_sym_template] = ACTIONS(3258),
    [anon_sym_operator] = ACTIONS(3258),
    [anon_sym_try] = ACTIONS(3258),
    [anon_sym_delete] = ACTIONS(3258),
    [anon_sym_throw] = ACTIONS(3258),
    [anon_sym_namespace] = ACTIONS(3258),
    [anon_sym_using] = ACTIONS(3258),
    [anon_sym_static_assert] = ACTIONS(3258),
    [anon_sym_concept] = ACTIONS(3258),
    [anon_sym_co_return] = ACTIONS(3258),
    [anon_sym_co_yield] = ACTIONS(3258),
    [anon_sym_R_DQUOTE] = ACTIONS(3260),
    [anon_sym_LR_DQUOTE] = ACTIONS(3260),
    [anon_sym_uR_DQUOTE] = ACTIONS(3260),
    [anon_sym_UR_DQUOTE] = ACTIONS(3260),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3260),
    [anon_sym_co_await] = ACTIONS(3258),
    [anon_sym_new] = ACTIONS(3258),
    [anon_sym_requires] = ACTIONS(3258),
    [sym_this] = ACTIONS(3258),
  },
  [1103] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5489),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4033),
    [anon_sym_COMMA] = ACTIONS(4033),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3875),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_SLASH] = ACTIONS(4037),
    [anon_sym_PERCENT] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE] = ACTIONS(4037),
    [anon_sym_CARET] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_EQ_EQ] = ACTIONS(4033),
    [anon_sym_BANG_EQ] = ACTIONS(4033),
    [anon_sym_GT] = ACTIONS(4037),
    [anon_sym_GT_EQ] = ACTIONS(4033),
    [anon_sym_LT_EQ] = ACTIONS(4037),
    [anon_sym_LT] = ACTIONS(4037),
    [anon_sym_LT_LT] = ACTIONS(4033),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4033),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(4033),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_LT_EQ_GT] = ACTIONS(4033),
    [anon_sym_or] = ACTIONS(4037),
    [anon_sym_and] = ACTIONS(4037),
    [anon_sym_bitor] = ACTIONS(4037),
    [anon_sym_xor] = ACTIONS(4037),
    [anon_sym_bitand] = ACTIONS(4037),
    [anon_sym_not_eq] = ACTIONS(4037),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(4037),
    [anon_sym_DOT_STAR] = ACTIONS(4033),
    [anon_sym_DASH_GT] = ACTIONS(4033),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1104] = {
    [sym__declaration_modifiers] = STATE(2255),
    [sym__declaration_specifiers] = STATE(7018),
    [sym_attribute_specifier] = STATE(2255),
    [sym_attribute_declaration] = STATE(2255),
    [sym_ms_declspec_modifier] = STATE(2255),
    [sym_storage_class_specifier] = STATE(2255),
    [sym_type_qualifier] = STATE(2255),
    [sym__type_specifier] = STATE(4780),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(4130),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2255),
    [sym_alignas_specifier] = STATE(2255),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7352),
    [sym_qualified_type_identifier] = STATE(3374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2255),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3331),
    [sym_identifier] = ACTIONS(4041),
    [anon_sym_COMMA] = ACTIONS(4043),
    [anon_sym_BANG] = ACTIONS(4045),
    [anon_sym_TILDE] = ACTIONS(4043),
    [anon_sym_DASH] = ACTIONS(4045),
    [anon_sym_PLUS] = ACTIONS(4045),
    [anon_sym_STAR] = ACTIONS(4045),
    [anon_sym_SLASH] = ACTIONS(4045),
    [anon_sym_PERCENT] = ACTIONS(4045),
    [anon_sym_PIPE_PIPE] = ACTIONS(4043),
    [anon_sym_AMP_AMP] = ACTIONS(4043),
    [anon_sym_PIPE] = ACTIONS(4045),
    [anon_sym_CARET] = ACTIONS(4045),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4043),
    [anon_sym_BANG_EQ] = ACTIONS(4043),
    [anon_sym_GT] = ACTIONS(4045),
    [anon_sym_GT_EQ] = ACTIONS(4043),
    [anon_sym_LT_EQ] = ACTIONS(4045),
    [anon_sym_LT] = ACTIONS(4045),
    [anon_sym_LT_LT] = ACTIONS(4045),
    [anon_sym_GT_GT] = ACTIONS(4045),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4047),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(4049),
    [anon_sym_unsigned] = ACTIONS(4049),
    [anon_sym_long] = ACTIONS(4049),
    [anon_sym_short] = ACTIONS(4049),
    [anon_sym_EQ] = ACTIONS(4045),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(4051),
    [anon_sym_class] = ACTIONS(4053),
    [anon_sym_struct] = ACTIONS(4055),
    [anon_sym_union] = ACTIONS(4057),
    [anon_sym_STAR_EQ] = ACTIONS(4043),
    [anon_sym_SLASH_EQ] = ACTIONS(4043),
    [anon_sym_PERCENT_EQ] = ACTIONS(4043),
    [anon_sym_PLUS_EQ] = ACTIONS(4043),
    [anon_sym_DASH_EQ] = ACTIONS(4043),
    [anon_sym_LT_LT_EQ] = ACTIONS(4043),
    [anon_sym_GT_GT_EQ] = ACTIONS(4043),
    [anon_sym_AMP_EQ] = ACTIONS(4043),
    [anon_sym_CARET_EQ] = ACTIONS(4043),
    [anon_sym_PIPE_EQ] = ACTIONS(4043),
    [anon_sym_and_eq] = ACTIONS(4045),
    [anon_sym_or_eq] = ACTIONS(4045),
    [anon_sym_xor_eq] = ACTIONS(4045),
    [anon_sym_not] = ACTIONS(4045),
    [anon_sym_compl] = ACTIONS(4045),
    [anon_sym_LT_EQ_GT] = ACTIONS(4043),
    [anon_sym_or] = ACTIONS(4045),
    [anon_sym_and] = ACTIONS(4045),
    [anon_sym_bitor] = ACTIONS(4045),
    [anon_sym_xor] = ACTIONS(4045),
    [anon_sym_bitand] = ACTIONS(4045),
    [anon_sym_not_eq] = ACTIONS(4045),
    [anon_sym_DASH_DASH] = ACTIONS(4043),
    [anon_sym_PLUS_PLUS] = ACTIONS(4043),
    [anon_sym_DASH_GT] = ACTIONS(4045),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(4059),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4061),
    [anon_sym_co_await] = ACTIONS(4045),
    [anon_sym_new] = ACTIONS(4061),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4043),
    [anon_sym_LPAREN_RPAREN] = ACTIONS(4043),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4043),
    [anon_sym_DQUOTE_DQUOTE] = ACTIONS(4063),
  },
  [1105] = {
    [sym__declaration_modifiers] = STATE(2255),
    [sym__declaration_specifiers] = STATE(7018),
    [sym_attribute_specifier] = STATE(2255),
    [sym_attribute_declaration] = STATE(2255),
    [sym_ms_declspec_modifier] = STATE(2255),
    [sym_storage_class_specifier] = STATE(2255),
    [sym_type_qualifier] = STATE(2255),
    [sym__type_specifier] = STATE(4780),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(4130),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2255),
    [sym_alignas_specifier] = STATE(2255),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7352),
    [sym_qualified_type_identifier] = STATE(3374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2255),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3331),
    [sym_identifier] = ACTIONS(4041),
    [anon_sym_COMMA] = ACTIONS(4065),
    [anon_sym_BANG] = ACTIONS(4067),
    [anon_sym_TILDE] = ACTIONS(4065),
    [anon_sym_DASH] = ACTIONS(4067),
    [anon_sym_PLUS] = ACTIONS(4067),
    [anon_sym_STAR] = ACTIONS(4067),
    [anon_sym_SLASH] = ACTIONS(4067),
    [anon_sym_PERCENT] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4065),
    [anon_sym_AMP_AMP] = ACTIONS(4065),
    [anon_sym_PIPE] = ACTIONS(4067),
    [anon_sym_CARET] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4067),
    [anon_sym_EQ_EQ] = ACTIONS(4065),
    [anon_sym_BANG_EQ] = ACTIONS(4065),
    [anon_sym_GT] = ACTIONS(4067),
    [anon_sym_GT_EQ] = ACTIONS(4065),
    [anon_sym_LT_EQ] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4067),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4047),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(4049),
    [anon_sym_unsigned] = ACTIONS(4049),
    [anon_sym_long] = ACTIONS(4049),
    [anon_sym_short] = ACTIONS(4049),
    [anon_sym_EQ] = ACTIONS(4067),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(4051),
    [anon_sym_class] = ACTIONS(4053),
    [anon_sym_struct] = ACTIONS(4055),
    [anon_sym_union] = ACTIONS(4057),
    [anon_sym_STAR_EQ] = ACTIONS(4065),
    [anon_sym_SLASH_EQ] = ACTIONS(4065),
    [anon_sym_PERCENT_EQ] = ACTIONS(4065),
    [anon_sym_PLUS_EQ] = ACTIONS(4065),
    [anon_sym_DASH_EQ] = ACTIONS(4065),
    [anon_sym_LT_LT_EQ] = ACTIONS(4065),
    [anon_sym_GT_GT_EQ] = ACTIONS(4065),
    [anon_sym_AMP_EQ] = ACTIONS(4065),
    [anon_sym_CARET_EQ] = ACTIONS(4065),
    [anon_sym_PIPE_EQ] = ACTIONS(4065),
    [anon_sym_and_eq] = ACTIONS(4067),
    [anon_sym_or_eq] = ACTIONS(4067),
    [anon_sym_xor_eq] = ACTIONS(4067),
    [anon_sym_not] = ACTIONS(4067),
    [anon_sym_compl] = ACTIONS(4067),
    [anon_sym_LT_EQ_GT] = ACTIONS(4065),
    [anon_sym_or] = ACTIONS(4067),
    [anon_sym_and] = ACTIONS(4067),
    [anon_sym_bitor] = ACTIONS(4067),
    [anon_sym_xor] = ACTIONS(4067),
    [anon_sym_bitand] = ACTIONS(4067),
    [anon_sym_not_eq] = ACTIONS(4067),
    [anon_sym_DASH_DASH] = ACTIONS(4065),
    [anon_sym_PLUS_PLUS] = ACTIONS(4065),
    [anon_sym_DASH_GT] = ACTIONS(4067),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(4059),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4069),
    [anon_sym_co_await] = ACTIONS(4067),
    [anon_sym_new] = ACTIONS(4069),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4065),
    [anon_sym_LPAREN_RPAREN] = ACTIONS(4065),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4065),
    [anon_sym_DQUOTE_DQUOTE] = ACTIONS(4071),
  },
  [1106] = {
    [sym_function_definition] = STATE(930),
    [sym_declaration] = STATE(930),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7036),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__empty_declaration] = STATE(930),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2171),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(930),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2171),
    [sym_operator_cast_definition] = STATE(930),
    [sym_operator_cast_declaration] = STATE(930),
    [sym_constructor_or_destructor_definition] = STATE(930),
    [sym_constructor_or_destructor_declaration] = STATE(930),
    [sym_friend_declaration] = STATE(930),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_alias_declaration] = STATE(930),
    [sym_concept_definition] = STATE(930),
    [sym_requires_clause] = STATE(1123),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6254),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2171),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4075),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(4077),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(4079),
    [anon_sym_using] = ACTIONS(4081),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_requires] = ACTIONS(4083),
  },
  [1107] = {
    [sym_function_definition] = STATE(2240),
    [sym_declaration] = STATE(2240),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5415),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2155),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7117),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3269),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__empty_declaration] = STATE(2240),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2239),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(2240),
    [sym_operator_cast] = STATE(7514),
    [sym__constructor_specifiers] = STATE(2239),
    [sym_operator_cast_definition] = STATE(2240),
    [sym_operator_cast_declaration] = STATE(2240),
    [sym_constructor_or_destructor_definition] = STATE(2240),
    [sym_constructor_or_destructor_declaration] = STATE(2240),
    [sym_friend_declaration] = STATE(2240),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_alias_declaration] = STATE(2240),
    [sym_concept_definition] = STATE(2240),
    [sym_requires_clause] = STATE(1124),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6254),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7514),
    [sym_operator_name] = STATE(7008),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2239),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4075),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3240),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3242),
    [anon_sym_using] = ACTIONS(4085),
    [anon_sym_concept] = ACTIONS(4087),
    [anon_sym_requires] = ACTIONS(4083),
  },
  [1108] = {
    [sym_function_definition] = STATE(373),
    [sym_declaration] = STATE(373),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5497),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2132),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7007),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3222),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__empty_declaration] = STATE(373),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2234),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(373),
    [sym_operator_cast] = STATE(7547),
    [sym__constructor_specifiers] = STATE(2234),
    [sym_operator_cast_definition] = STATE(373),
    [sym_operator_cast_declaration] = STATE(373),
    [sym_constructor_or_destructor_definition] = STATE(373),
    [sym_constructor_or_destructor_declaration] = STATE(373),
    [sym_friend_declaration] = STATE(373),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_alias_declaration] = STATE(373),
    [sym_concept_definition] = STATE(373),
    [sym_requires_clause] = STATE(1120),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6254),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7547),
    [sym_operator_name] = STATE(7008),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2234),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4075),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(4089),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(4091),
    [anon_sym_using] = ACTIONS(4093),
    [anon_sym_concept] = ACTIONS(335),
    [anon_sym_requires] = ACTIONS(4083),
  },
  [1109] = {
    [sym_function_definition] = STATE(2361),
    [sym_declaration] = STATE(2361),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5443),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2228),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7114),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3276),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__empty_declaration] = STATE(2361),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2150),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(2361),
    [sym_operator_cast] = STATE(7493),
    [sym__constructor_specifiers] = STATE(2150),
    [sym_operator_cast_definition] = STATE(2361),
    [sym_operator_cast_declaration] = STATE(2361),
    [sym_constructor_or_destructor_definition] = STATE(2361),
    [sym_constructor_or_destructor_declaration] = STATE(2361),
    [sym_friend_declaration] = STATE(2361),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_alias_declaration] = STATE(2361),
    [sym_concept_definition] = STATE(2361),
    [sym_requires_clause] = STATE(1118),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6254),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7493),
    [sym_operator_name] = STATE(7008),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2150),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4075),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3577),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3579),
    [anon_sym_using] = ACTIONS(4095),
    [anon_sym_concept] = ACTIONS(4097),
    [anon_sym_requires] = ACTIONS(4083),
  },
  [1110] = {
    [sym_function_definition] = STATE(2492),
    [sym_declaration] = STATE(2492),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5392),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2113),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3263),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__empty_declaration] = STATE(2492),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(2492),
    [sym_operator_cast] = STATE(7501),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(2492),
    [sym_operator_cast_declaration] = STATE(2492),
    [sym_constructor_or_destructor_definition] = STATE(2492),
    [sym_constructor_or_destructor_declaration] = STATE(2492),
    [sym_friend_declaration] = STATE(2492),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_alias_declaration] = STATE(2492),
    [sym_concept_definition] = STATE(2492),
    [sym_requires_clause] = STATE(1122),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6254),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4075),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_using] = ACTIONS(4099),
    [anon_sym_concept] = ACTIONS(4101),
    [anon_sym_requires] = ACTIONS(4083),
  },
  [1111] = {
    [sym_function_definition] = STATE(981),
    [sym_declaration] = STATE(981),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5414),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2119),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7074),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3248),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__empty_declaration] = STATE(981),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2151),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(981),
    [sym_operator_cast] = STATE(7504),
    [sym__constructor_specifiers] = STATE(2151),
    [sym_operator_cast_definition] = STATE(981),
    [sym_operator_cast_declaration] = STATE(981),
    [sym_constructor_or_destructor_definition] = STATE(981),
    [sym_constructor_or_destructor_declaration] = STATE(981),
    [sym_friend_declaration] = STATE(981),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_alias_declaration] = STATE(981),
    [sym_concept_definition] = STATE(981),
    [sym_requires_clause] = STATE(1121),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6254),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7504),
    [sym_operator_name] = STATE(7008),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2151),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4075),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(4103),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(4105),
    [anon_sym_using] = ACTIONS(4107),
    [anon_sym_concept] = ACTIONS(1159),
    [anon_sym_requires] = ACTIONS(4083),
  },
  [1112] = {
    [sym_function_definition] = STATE(551),
    [sym_declaration] = STATE(551),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5457),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2123),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7006),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3219),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__empty_declaration] = STATE(551),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2174),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(551),
    [sym_operator_cast] = STATE(7525),
    [sym__constructor_specifiers] = STATE(2174),
    [sym_operator_cast_definition] = STATE(551),
    [sym_operator_cast_declaration] = STATE(551),
    [sym_constructor_or_destructor_definition] = STATE(551),
    [sym_constructor_or_destructor_declaration] = STATE(551),
    [sym_friend_declaration] = STATE(551),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_alias_declaration] = STATE(551),
    [sym_concept_definition] = STATE(551),
    [sym_requires_clause] = STATE(1117),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6254),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7525),
    [sym_operator_name] = STATE(7008),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2174),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4075),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(4109),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(4111),
    [anon_sym_using] = ACTIONS(4113),
    [anon_sym_concept] = ACTIONS(423),
    [anon_sym_requires] = ACTIONS(4083),
  },
  [1113] = {
    [sym_function_definition] = STATE(2462),
    [sym_declaration] = STATE(2462),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5460),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2152),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7010),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3281),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__empty_declaration] = STATE(2462),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2144),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(2462),
    [sym_operator_cast] = STATE(7526),
    [sym__constructor_specifiers] = STATE(2144),
    [sym_operator_cast_definition] = STATE(2462),
    [sym_operator_cast_declaration] = STATE(2462),
    [sym_constructor_or_destructor_definition] = STATE(2462),
    [sym_constructor_or_destructor_declaration] = STATE(2462),
    [sym_friend_declaration] = STATE(2462),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_alias_declaration] = STATE(2462),
    [sym_concept_definition] = STATE(2462),
    [sym_requires_clause] = STATE(1119),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6254),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7526),
    [sym_operator_name] = STATE(7008),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2144),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4075),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3939),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3941),
    [anon_sym_using] = ACTIONS(4115),
    [anon_sym_concept] = ACTIONS(4117),
    [anon_sym_requires] = ACTIONS(4083),
  },
  [1114] = {
    [sym_function_definition] = STATE(1068),
    [sym_declaration] = STATE(1068),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5408),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2149),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7035),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3271),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__empty_declaration] = STATE(1068),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2138),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1068),
    [sym_operator_cast] = STATE(7529),
    [sym__constructor_specifiers] = STATE(2138),
    [sym_operator_cast_definition] = STATE(1068),
    [sym_operator_cast_declaration] = STATE(1068),
    [sym_constructor_or_destructor_definition] = STATE(1068),
    [sym_constructor_or_destructor_declaration] = STATE(1068),
    [sym_friend_declaration] = STATE(1068),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_alias_declaration] = STATE(1068),
    [sym_concept_definition] = STATE(1068),
    [sym_requires_clause] = STATE(1125),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6254),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7529),
    [sym_operator_name] = STATE(7008),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2138),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4075),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(4119),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(4121),
    [anon_sym_using] = ACTIONS(4123),
    [anon_sym_concept] = ACTIONS(147),
    [anon_sym_requires] = ACTIONS(4083),
  },
  [1115] = {
    [sym_identifier] = ACTIONS(4125),
    [anon_sym_COMMA] = ACTIONS(4127),
    [anon_sym_RPAREN] = ACTIONS(4127),
    [anon_sym_LPAREN2] = ACTIONS(4127),
    [anon_sym_BANG] = ACTIONS(4127),
    [anon_sym_TILDE] = ACTIONS(4127),
    [anon_sym_DASH] = ACTIONS(4125),
    [anon_sym_PLUS] = ACTIONS(4125),
    [anon_sym_STAR] = ACTIONS(4127),
    [anon_sym_AMP_AMP] = ACTIONS(4127),
    [anon_sym_AMP] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym___extension__] = ACTIONS(4125),
    [anon_sym_extern] = ACTIONS(4125),
    [anon_sym___attribute__] = ACTIONS(4125),
    [anon_sym_COLON_COLON] = ACTIONS(4127),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4127),
    [anon_sym___declspec] = ACTIONS(4125),
    [anon_sym___based] = ACTIONS(4125),
    [anon_sym_LBRACE] = ACTIONS(4127),
    [anon_sym_signed] = ACTIONS(4125),
    [anon_sym_unsigned] = ACTIONS(4125),
    [anon_sym_long] = ACTIONS(4125),
    [anon_sym_short] = ACTIONS(4125),
    [anon_sym_LBRACK] = ACTIONS(4125),
    [anon_sym_EQ] = ACTIONS(4127),
    [anon_sym_static] = ACTIONS(4125),
    [anon_sym_register] = ACTIONS(4125),
    [anon_sym_inline] = ACTIONS(4125),
    [anon_sym___inline] = ACTIONS(4125),
    [anon_sym___inline__] = ACTIONS(4125),
    [anon_sym___forceinline] = ACTIONS(4125),
    [anon_sym_thread_local] = ACTIONS(4125),
    [anon_sym___thread] = ACTIONS(4125),
    [anon_sym_const] = ACTIONS(4125),
    [anon_sym_constexpr] = ACTIONS(4125),
    [anon_sym_volatile] = ACTIONS(4125),
    [anon_sym_restrict] = ACTIONS(4125),
    [anon_sym___restrict__] = ACTIONS(4125),
    [anon_sym__Atomic] = ACTIONS(4125),
    [anon_sym__Noreturn] = ACTIONS(4125),
    [anon_sym_noreturn] = ACTIONS(4125),
    [anon_sym_mutable] = ACTIONS(4125),
    [anon_sym_constinit] = ACTIONS(4125),
    [anon_sym_consteval] = ACTIONS(4125),
    [anon_sym_PROGMEM] = ACTIONS(4125),
    [aux_sym_primitive_type_token1] = ACTIONS(4125),
    [anon_sym_byte] = ACTIONS(4125),
    [anon_sym_word] = ACTIONS(4125),
    [anon_sym_enum] = ACTIONS(4125),
    [anon_sym_class] = ACTIONS(4125),
    [anon_sym_struct] = ACTIONS(4125),
    [anon_sym_union] = ACTIONS(4125),
    [anon_sym_if] = ACTIONS(4125),
    [anon_sym_switch] = ACTIONS(4125),
    [anon_sym_case] = ACTIONS(4125),
    [anon_sym_default] = ACTIONS(4125),
    [anon_sym_while] = ACTIONS(4125),
    [anon_sym_do] = ACTIONS(4125),
    [anon_sym_for] = ACTIONS(4125),
    [anon_sym_return] = ACTIONS(4125),
    [anon_sym_break] = ACTIONS(4125),
    [anon_sym_continue] = ACTIONS(4125),
    [anon_sym_goto] = ACTIONS(4125),
    [anon_sym___try] = ACTIONS(4125),
    [anon_sym___leave] = ACTIONS(4125),
    [anon_sym_not] = ACTIONS(4125),
    [anon_sym_compl] = ACTIONS(4125),
    [anon_sym_DASH_DASH] = ACTIONS(4127),
    [anon_sym_PLUS_PLUS] = ACTIONS(4127),
    [anon_sym_sizeof] = ACTIONS(4125),
    [anon_sym___alignof__] = ACTIONS(4125),
    [anon_sym___alignof] = ACTIONS(4125),
    [anon_sym__alignof] = ACTIONS(4125),
    [anon_sym_alignof] = ACTIONS(4125),
    [anon_sym__Alignof] = ACTIONS(4125),
    [anon_sym_offsetof] = ACTIONS(4125),
    [anon_sym__Generic] = ACTIONS(4125),
    [anon_sym_asm] = ACTIONS(4125),
    [anon_sym___asm__] = ACTIONS(4125),
    [aux_sym_number_literal_token1] = ACTIONS(4127),
    [aux_sym_number_literal_token2] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4127),
    [anon_sym_u_DQUOTE] = ACTIONS(4127),
    [anon_sym_U_DQUOTE] = ACTIONS(4127),
    [anon_sym_u8_DQUOTE] = ACTIONS(4127),
    [anon_sym_DQUOTE] = ACTIONS(4127),
    [sym_true] = ACTIONS(4125),
    [sym_false] = ACTIONS(4125),
    [anon_sym_NULL] = ACTIONS(4125),
    [anon_sym_nullptr] = ACTIONS(4125),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4125),
    [anon_sym_decltype] = ACTIONS(4125),
    [anon_sym_virtual] = ACTIONS(4125),
    [anon_sym_alignas] = ACTIONS(4125),
    [anon_sym_explicit] = ACTIONS(4125),
    [anon_sym_typename] = ACTIONS(4125),
    [anon_sym_template] = ACTIONS(4125),
    [anon_sym_GT2] = ACTIONS(4127),
    [anon_sym_operator] = ACTIONS(4125),
    [anon_sym_try] = ACTIONS(4125),
    [anon_sym_delete] = ACTIONS(4125),
    [anon_sym_throw] = ACTIONS(4125),
    [anon_sym_co_return] = ACTIONS(4125),
    [anon_sym_co_yield] = ACTIONS(4125),
    [anon_sym_R_DQUOTE] = ACTIONS(4127),
    [anon_sym_LR_DQUOTE] = ACTIONS(4127),
    [anon_sym_uR_DQUOTE] = ACTIONS(4127),
    [anon_sym_UR_DQUOTE] = ACTIONS(4127),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4127),
    [anon_sym_co_await] = ACTIONS(4125),
    [anon_sym_new] = ACTIONS(4125),
    [anon_sym_requires] = ACTIONS(4125),
    [sym_this] = ACTIONS(4125),
  },
  [1116] = {
    [sym_identifier] = ACTIONS(4129),
    [anon_sym_COMMA] = ACTIONS(4131),
    [anon_sym_RPAREN] = ACTIONS(4131),
    [anon_sym_LPAREN2] = ACTIONS(4131),
    [anon_sym_BANG] = ACTIONS(4131),
    [anon_sym_TILDE] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4129),
    [anon_sym_STAR] = ACTIONS(4131),
    [anon_sym_AMP_AMP] = ACTIONS(4131),
    [anon_sym_AMP] = ACTIONS(4129),
    [anon_sym_SEMI] = ACTIONS(4131),
    [anon_sym___extension__] = ACTIONS(4129),
    [anon_sym_extern] = ACTIONS(4129),
    [anon_sym___attribute__] = ACTIONS(4129),
    [anon_sym_COLON_COLON] = ACTIONS(4131),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4131),
    [anon_sym___declspec] = ACTIONS(4129),
    [anon_sym___based] = ACTIONS(4129),
    [anon_sym_LBRACE] = ACTIONS(4131),
    [anon_sym_signed] = ACTIONS(4129),
    [anon_sym_unsigned] = ACTIONS(4129),
    [anon_sym_long] = ACTIONS(4129),
    [anon_sym_short] = ACTIONS(4129),
    [anon_sym_LBRACK] = ACTIONS(4129),
    [anon_sym_EQ] = ACTIONS(4131),
    [anon_sym_static] = ACTIONS(4129),
    [anon_sym_register] = ACTIONS(4129),
    [anon_sym_inline] = ACTIONS(4129),
    [anon_sym___inline] = ACTIONS(4129),
    [anon_sym___inline__] = ACTIONS(4129),
    [anon_sym___forceinline] = ACTIONS(4129),
    [anon_sym_thread_local] = ACTIONS(4129),
    [anon_sym___thread] = ACTIONS(4129),
    [anon_sym_const] = ACTIONS(4129),
    [anon_sym_constexpr] = ACTIONS(4129),
    [anon_sym_volatile] = ACTIONS(4129),
    [anon_sym_restrict] = ACTIONS(4129),
    [anon_sym___restrict__] = ACTIONS(4129),
    [anon_sym__Atomic] = ACTIONS(4129),
    [anon_sym__Noreturn] = ACTIONS(4129),
    [anon_sym_noreturn] = ACTIONS(4129),
    [anon_sym_mutable] = ACTIONS(4129),
    [anon_sym_constinit] = ACTIONS(4129),
    [anon_sym_consteval] = ACTIONS(4129),
    [anon_sym_PROGMEM] = ACTIONS(4129),
    [aux_sym_primitive_type_token1] = ACTIONS(4129),
    [anon_sym_byte] = ACTIONS(4129),
    [anon_sym_word] = ACTIONS(4129),
    [anon_sym_enum] = ACTIONS(4129),
    [anon_sym_class] = ACTIONS(4129),
    [anon_sym_struct] = ACTIONS(4129),
    [anon_sym_union] = ACTIONS(4129),
    [anon_sym_if] = ACTIONS(4129),
    [anon_sym_switch] = ACTIONS(4129),
    [anon_sym_case] = ACTIONS(4129),
    [anon_sym_default] = ACTIONS(4129),
    [anon_sym_while] = ACTIONS(4129),
    [anon_sym_do] = ACTIONS(4129),
    [anon_sym_for] = ACTIONS(4129),
    [anon_sym_return] = ACTIONS(4129),
    [anon_sym_break] = ACTIONS(4129),
    [anon_sym_continue] = ACTIONS(4129),
    [anon_sym_goto] = ACTIONS(4129),
    [anon_sym___try] = ACTIONS(4129),
    [anon_sym___leave] = ACTIONS(4129),
    [anon_sym_not] = ACTIONS(4129),
    [anon_sym_compl] = ACTIONS(4129),
    [anon_sym_DASH_DASH] = ACTIONS(4131),
    [anon_sym_PLUS_PLUS] = ACTIONS(4131),
    [anon_sym_sizeof] = ACTIONS(4129),
    [anon_sym___alignof__] = ACTIONS(4129),
    [anon_sym___alignof] = ACTIONS(4129),
    [anon_sym__alignof] = ACTIONS(4129),
    [anon_sym_alignof] = ACTIONS(4129),
    [anon_sym__Alignof] = ACTIONS(4129),
    [anon_sym_offsetof] = ACTIONS(4129),
    [anon_sym__Generic] = ACTIONS(4129),
    [anon_sym_asm] = ACTIONS(4129),
    [anon_sym___asm__] = ACTIONS(4129),
    [aux_sym_number_literal_token1] = ACTIONS(4131),
    [aux_sym_number_literal_token2] = ACTIONS(4129),
    [anon_sym_L_SQUOTE] = ACTIONS(4131),
    [anon_sym_u_SQUOTE] = ACTIONS(4131),
    [anon_sym_U_SQUOTE] = ACTIONS(4131),
    [anon_sym_u8_SQUOTE] = ACTIONS(4131),
    [anon_sym_SQUOTE] = ACTIONS(4131),
    [anon_sym_L_DQUOTE] = ACTIONS(4131),
    [anon_sym_u_DQUOTE] = ACTIONS(4131),
    [anon_sym_U_DQUOTE] = ACTIONS(4131),
    [anon_sym_u8_DQUOTE] = ACTIONS(4131),
    [anon_sym_DQUOTE] = ACTIONS(4131),
    [sym_true] = ACTIONS(4129),
    [sym_false] = ACTIONS(4129),
    [anon_sym_NULL] = ACTIONS(4129),
    [anon_sym_nullptr] = ACTIONS(4129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4129),
    [anon_sym_decltype] = ACTIONS(4129),
    [anon_sym_virtual] = ACTIONS(4129),
    [anon_sym_alignas] = ACTIONS(4129),
    [anon_sym_explicit] = ACTIONS(4129),
    [anon_sym_typename] = ACTIONS(4129),
    [anon_sym_template] = ACTIONS(4129),
    [anon_sym_GT2] = ACTIONS(4131),
    [anon_sym_operator] = ACTIONS(4129),
    [anon_sym_try] = ACTIONS(4129),
    [anon_sym_delete] = ACTIONS(4129),
    [anon_sym_throw] = ACTIONS(4129),
    [anon_sym_co_return] = ACTIONS(4129),
    [anon_sym_co_yield] = ACTIONS(4129),
    [anon_sym_R_DQUOTE] = ACTIONS(4131),
    [anon_sym_LR_DQUOTE] = ACTIONS(4131),
    [anon_sym_uR_DQUOTE] = ACTIONS(4131),
    [anon_sym_UR_DQUOTE] = ACTIONS(4131),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4131),
    [anon_sym_co_await] = ACTIONS(4129),
    [anon_sym_new] = ACTIONS(4129),
    [anon_sym_requires] = ACTIONS(4129),
    [sym_this] = ACTIONS(4129),
  },
  [1117] = {
    [sym_function_definition] = STATE(592),
    [sym_declaration] = STATE(592),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5457),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2123),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7006),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3219),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__empty_declaration] = STATE(592),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2174),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(592),
    [sym_operator_cast] = STATE(7525),
    [sym__constructor_specifiers] = STATE(2174),
    [sym_operator_cast_definition] = STATE(592),
    [sym_operator_cast_declaration] = STATE(592),
    [sym_constructor_or_destructor_definition] = STATE(592),
    [sym_constructor_or_destructor_declaration] = STATE(592),
    [sym_friend_declaration] = STATE(592),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_alias_declaration] = STATE(592),
    [sym_concept_definition] = STATE(592),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6254),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7525),
    [sym_operator_name] = STATE(7008),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2174),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4075),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(4109),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(4111),
    [anon_sym_using] = ACTIONS(4113),
    [anon_sym_concept] = ACTIONS(423),
  },
  [1118] = {
    [sym_function_definition] = STATE(2397),
    [sym_declaration] = STATE(2397),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5443),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2228),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7114),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3276),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__empty_declaration] = STATE(2397),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2150),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(2397),
    [sym_operator_cast] = STATE(7493),
    [sym__constructor_specifiers] = STATE(2150),
    [sym_operator_cast_definition] = STATE(2397),
    [sym_operator_cast_declaration] = STATE(2397),
    [sym_constructor_or_destructor_definition] = STATE(2397),
    [sym_constructor_or_destructor_declaration] = STATE(2397),
    [sym_friend_declaration] = STATE(2397),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_alias_declaration] = STATE(2397),
    [sym_concept_definition] = STATE(2397),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6254),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7493),
    [sym_operator_name] = STATE(7008),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2150),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4075),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3577),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3579),
    [anon_sym_using] = ACTIONS(4095),
    [anon_sym_concept] = ACTIONS(4097),
  },
  [1119] = {
    [sym_function_definition] = STATE(2493),
    [sym_declaration] = STATE(2493),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5460),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2152),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7010),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3281),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__empty_declaration] = STATE(2493),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2144),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(2493),
    [sym_operator_cast] = STATE(7526),
    [sym__constructor_specifiers] = STATE(2144),
    [sym_operator_cast_definition] = STATE(2493),
    [sym_operator_cast_declaration] = STATE(2493),
    [sym_constructor_or_destructor_definition] = STATE(2493),
    [sym_constructor_or_destructor_declaration] = STATE(2493),
    [sym_friend_declaration] = STATE(2493),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_alias_declaration] = STATE(2493),
    [sym_concept_definition] = STATE(2493),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6254),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7526),
    [sym_operator_name] = STATE(7008),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2144),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4075),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3939),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3941),
    [anon_sym_using] = ACTIONS(4115),
    [anon_sym_concept] = ACTIONS(4117),
  },
  [1120] = {
    [sym_function_definition] = STATE(375),
    [sym_declaration] = STATE(375),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5497),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2132),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7007),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3222),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__empty_declaration] = STATE(375),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2234),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(375),
    [sym_operator_cast] = STATE(7547),
    [sym__constructor_specifiers] = STATE(2234),
    [sym_operator_cast_definition] = STATE(375),
    [sym_operator_cast_declaration] = STATE(375),
    [sym_constructor_or_destructor_definition] = STATE(375),
    [sym_constructor_or_destructor_declaration] = STATE(375),
    [sym_friend_declaration] = STATE(375),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_alias_declaration] = STATE(375),
    [sym_concept_definition] = STATE(375),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6254),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7547),
    [sym_operator_name] = STATE(7008),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2234),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4075),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(4089),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(4091),
    [anon_sym_using] = ACTIONS(4093),
    [anon_sym_concept] = ACTIONS(335),
  },
  [1121] = {
    [sym_function_definition] = STATE(996),
    [sym_declaration] = STATE(996),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5414),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2119),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7074),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3248),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__empty_declaration] = STATE(996),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2151),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(996),
    [sym_operator_cast] = STATE(7504),
    [sym__constructor_specifiers] = STATE(2151),
    [sym_operator_cast_definition] = STATE(996),
    [sym_operator_cast_declaration] = STATE(996),
    [sym_constructor_or_destructor_definition] = STATE(996),
    [sym_constructor_or_destructor_declaration] = STATE(996),
    [sym_friend_declaration] = STATE(996),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_alias_declaration] = STATE(996),
    [sym_concept_definition] = STATE(996),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6254),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7504),
    [sym_operator_name] = STATE(7008),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2151),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4075),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(4103),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(4105),
    [anon_sym_using] = ACTIONS(4107),
    [anon_sym_concept] = ACTIONS(1159),
  },
  [1122] = {
    [sym_function_definition] = STATE(2648),
    [sym_declaration] = STATE(2648),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5392),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2113),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7077),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3263),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__empty_declaration] = STATE(2648),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2210),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(2648),
    [sym_operator_cast] = STATE(7501),
    [sym__constructor_specifiers] = STATE(2210),
    [sym_operator_cast_definition] = STATE(2648),
    [sym_operator_cast_declaration] = STATE(2648),
    [sym_constructor_or_destructor_definition] = STATE(2648),
    [sym_constructor_or_destructor_declaration] = STATE(2648),
    [sym_friend_declaration] = STATE(2648),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_alias_declaration] = STATE(2648),
    [sym_concept_definition] = STATE(2648),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6254),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7501),
    [sym_operator_name] = STATE(7008),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4075),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3839),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3841),
    [anon_sym_using] = ACTIONS(4099),
    [anon_sym_concept] = ACTIONS(4101),
  },
  [1123] = {
    [sym_function_definition] = STATE(891),
    [sym_declaration] = STATE(891),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2206),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7036),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3254),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__empty_declaration] = STATE(891),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2171),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(891),
    [sym_operator_cast] = STATE(7507),
    [sym__constructor_specifiers] = STATE(2171),
    [sym_operator_cast_definition] = STATE(891),
    [sym_operator_cast_declaration] = STATE(891),
    [sym_constructor_or_destructor_definition] = STATE(891),
    [sym_constructor_or_destructor_declaration] = STATE(891),
    [sym_friend_declaration] = STATE(891),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_alias_declaration] = STATE(891),
    [sym_concept_definition] = STATE(891),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6254),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7507),
    [sym_operator_name] = STATE(7008),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2171),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4075),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(4077),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(4079),
    [anon_sym_using] = ACTIONS(4081),
    [anon_sym_concept] = ACTIONS(233),
  },
  [1124] = {
    [sym_function_definition] = STATE(2143),
    [sym_declaration] = STATE(2143),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5415),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2155),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7117),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3269),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__empty_declaration] = STATE(2143),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2239),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(2143),
    [sym_operator_cast] = STATE(7514),
    [sym__constructor_specifiers] = STATE(2239),
    [sym_operator_cast_definition] = STATE(2143),
    [sym_operator_cast_declaration] = STATE(2143),
    [sym_constructor_or_destructor_definition] = STATE(2143),
    [sym_constructor_or_destructor_declaration] = STATE(2143),
    [sym_friend_declaration] = STATE(2143),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_alias_declaration] = STATE(2143),
    [sym_concept_definition] = STATE(2143),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6254),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7514),
    [sym_operator_name] = STATE(7008),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2239),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4075),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3240),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3242),
    [anon_sym_using] = ACTIONS(4085),
    [anon_sym_concept] = ACTIONS(4087),
  },
  [1125] = {
    [sym_function_definition] = STATE(1030),
    [sym_declaration] = STATE(1030),
    [sym__declaration_modifiers] = STATE(3840),
    [sym__declaration_specifiers] = STATE(5408),
    [sym_attribute_specifier] = STATE(3840),
    [sym_attribute_declaration] = STATE(3840),
    [sym_ms_declspec_modifier] = STATE(3840),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(2149),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7035),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(3840),
    [sym_type_qualifier] = STATE(3840),
    [sym__type_specifier] = STATE(3271),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym__empty_declaration] = STATE(1030),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3840),
    [sym_alignas_specifier] = STATE(3840),
    [sym_explicit_function_specifier] = STATE(2138),
    [sym_dependent_type] = STATE(3087),
    [sym_template_declaration] = STATE(1030),
    [sym_operator_cast] = STATE(7529),
    [sym__constructor_specifiers] = STATE(2138),
    [sym_operator_cast_definition] = STATE(1030),
    [sym_operator_cast_declaration] = STATE(1030),
    [sym_constructor_or_destructor_definition] = STATE(1030),
    [sym_constructor_or_destructor_declaration] = STATE(1030),
    [sym_friend_declaration] = STATE(1030),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_alias_declaration] = STATE(1030),
    [sym_concept_definition] = STATE(1030),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6254),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_qualified_operator_cast_identifier] = STATE(7529),
    [sym_operator_name] = STATE(7008),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2138),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4075),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(4119),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(4121),
    [anon_sym_using] = ACTIONS(4123),
    [anon_sym_concept] = ACTIONS(147),
  },
  [1126] = {
    [sym_type_qualifier] = STATE(1140),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5471),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [aux_sym__type_definition_type_repeat1] = STATE(1140),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4135),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4137),
    [anon_sym_const] = ACTIONS(4135),
    [anon_sym_constexpr] = ACTIONS(4135),
    [anon_sym_volatile] = ACTIONS(4135),
    [anon_sym_restrict] = ACTIONS(4135),
    [anon_sym___restrict__] = ACTIONS(4135),
    [anon_sym__Atomic] = ACTIONS(4135),
    [anon_sym__Noreturn] = ACTIONS(4135),
    [anon_sym_noreturn] = ACTIONS(4135),
    [anon_sym_mutable] = ACTIONS(4135),
    [anon_sym_constinit] = ACTIONS(4135),
    [anon_sym_consteval] = ACTIONS(4135),
    [anon_sym_PROGMEM] = ACTIONS(4135),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1127] = {
    [sym_type_qualifier] = STATE(1143),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5416),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [aux_sym__type_definition_type_repeat1] = STATE(1143),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4139),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4135),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4141),
    [anon_sym_const] = ACTIONS(4135),
    [anon_sym_constexpr] = ACTIONS(4135),
    [anon_sym_volatile] = ACTIONS(4135),
    [anon_sym_restrict] = ACTIONS(4135),
    [anon_sym___restrict__] = ACTIONS(4135),
    [anon_sym__Atomic] = ACTIONS(4135),
    [anon_sym__Noreturn] = ACTIONS(4135),
    [anon_sym_noreturn] = ACTIONS(4135),
    [anon_sym_mutable] = ACTIONS(4135),
    [anon_sym_constinit] = ACTIONS(4135),
    [anon_sym_consteval] = ACTIONS(4135),
    [anon_sym_PROGMEM] = ACTIONS(4135),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1128] = {
    [sym_type_qualifier] = STATE(1141),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5433),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [aux_sym__type_definition_type_repeat1] = STATE(1141),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4143),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4135),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4145),
    [anon_sym_const] = ACTIONS(4135),
    [anon_sym_constexpr] = ACTIONS(4135),
    [anon_sym_volatile] = ACTIONS(4135),
    [anon_sym_restrict] = ACTIONS(4135),
    [anon_sym___restrict__] = ACTIONS(4135),
    [anon_sym__Atomic] = ACTIONS(4135),
    [anon_sym__Noreturn] = ACTIONS(4135),
    [anon_sym_noreturn] = ACTIONS(4135),
    [anon_sym_mutable] = ACTIONS(4135),
    [anon_sym_constinit] = ACTIONS(4135),
    [anon_sym_consteval] = ACTIONS(4135),
    [anon_sym_PROGMEM] = ACTIONS(4135),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1129] = {
    [sym_type_qualifier] = STATE(1137),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5514),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [aux_sym__type_definition_type_repeat1] = STATE(1137),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4147),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4135),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4149),
    [anon_sym_const] = ACTIONS(4135),
    [anon_sym_constexpr] = ACTIONS(4135),
    [anon_sym_volatile] = ACTIONS(4135),
    [anon_sym_restrict] = ACTIONS(4135),
    [anon_sym___restrict__] = ACTIONS(4135),
    [anon_sym__Atomic] = ACTIONS(4135),
    [anon_sym__Noreturn] = ACTIONS(4135),
    [anon_sym_noreturn] = ACTIONS(4135),
    [anon_sym_mutable] = ACTIONS(4135),
    [anon_sym_constinit] = ACTIONS(4135),
    [anon_sym_consteval] = ACTIONS(4135),
    [anon_sym_PROGMEM] = ACTIONS(4135),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1130] = {
    [sym_type_qualifier] = STATE(2101),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5470),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [aux_sym__type_definition_type_repeat1] = STATE(2101),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4151),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4135),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4153),
    [anon_sym_const] = ACTIONS(4135),
    [anon_sym_constexpr] = ACTIONS(4135),
    [anon_sym_volatile] = ACTIONS(4135),
    [anon_sym_restrict] = ACTIONS(4135),
    [anon_sym___restrict__] = ACTIONS(4135),
    [anon_sym__Atomic] = ACTIONS(4135),
    [anon_sym__Noreturn] = ACTIONS(4135),
    [anon_sym_noreturn] = ACTIONS(4135),
    [anon_sym_mutable] = ACTIONS(4135),
    [anon_sym_constinit] = ACTIONS(4135),
    [anon_sym_consteval] = ACTIONS(4135),
    [anon_sym_PROGMEM] = ACTIONS(4135),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1131] = {
    [sym_type_qualifier] = STATE(1134),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5527),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [aux_sym__type_definition_type_repeat1] = STATE(1134),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4155),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4135),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4157),
    [anon_sym_const] = ACTIONS(4135),
    [anon_sym_constexpr] = ACTIONS(4135),
    [anon_sym_volatile] = ACTIONS(4135),
    [anon_sym_restrict] = ACTIONS(4135),
    [anon_sym___restrict__] = ACTIONS(4135),
    [anon_sym__Atomic] = ACTIONS(4135),
    [anon_sym__Noreturn] = ACTIONS(4135),
    [anon_sym_noreturn] = ACTIONS(4135),
    [anon_sym_mutable] = ACTIONS(4135),
    [anon_sym_constinit] = ACTIONS(4135),
    [anon_sym_consteval] = ACTIONS(4135),
    [anon_sym_PROGMEM] = ACTIONS(4135),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1132] = {
    [sym_type_qualifier] = STATE(1144),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5412),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [aux_sym__type_definition_type_repeat1] = STATE(1144),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4135),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4161),
    [anon_sym_const] = ACTIONS(4135),
    [anon_sym_constexpr] = ACTIONS(4135),
    [anon_sym_volatile] = ACTIONS(4135),
    [anon_sym_restrict] = ACTIONS(4135),
    [anon_sym___restrict__] = ACTIONS(4135),
    [anon_sym__Atomic] = ACTIONS(4135),
    [anon_sym__Noreturn] = ACTIONS(4135),
    [anon_sym_noreturn] = ACTIONS(4135),
    [anon_sym_mutable] = ACTIONS(4135),
    [anon_sym_constinit] = ACTIONS(4135),
    [anon_sym_consteval] = ACTIONS(4135),
    [anon_sym_PROGMEM] = ACTIONS(4135),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1133] = {
    [sym_type_qualifier] = STATE(2101),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5467),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [aux_sym__type_definition_type_repeat1] = STATE(2101),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4163),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4135),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4165),
    [anon_sym_const] = ACTIONS(4135),
    [anon_sym_constexpr] = ACTIONS(4135),
    [anon_sym_volatile] = ACTIONS(4135),
    [anon_sym_restrict] = ACTIONS(4135),
    [anon_sym___restrict__] = ACTIONS(4135),
    [anon_sym__Atomic] = ACTIONS(4135),
    [anon_sym__Noreturn] = ACTIONS(4135),
    [anon_sym_noreturn] = ACTIONS(4135),
    [anon_sym_mutable] = ACTIONS(4135),
    [anon_sym_constinit] = ACTIONS(4135),
    [anon_sym_consteval] = ACTIONS(4135),
    [anon_sym_PROGMEM] = ACTIONS(4135),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1134] = {
    [sym_type_qualifier] = STATE(2101),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5517),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [aux_sym__type_definition_type_repeat1] = STATE(2101),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4167),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4135),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4169),
    [anon_sym_const] = ACTIONS(4135),
    [anon_sym_constexpr] = ACTIONS(4135),
    [anon_sym_volatile] = ACTIONS(4135),
    [anon_sym_restrict] = ACTIONS(4135),
    [anon_sym___restrict__] = ACTIONS(4135),
    [anon_sym__Atomic] = ACTIONS(4135),
    [anon_sym__Noreturn] = ACTIONS(4135),
    [anon_sym_noreturn] = ACTIONS(4135),
    [anon_sym_mutable] = ACTIONS(4135),
    [anon_sym_constinit] = ACTIONS(4135),
    [anon_sym_consteval] = ACTIONS(4135),
    [anon_sym_PROGMEM] = ACTIONS(4135),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1135] = {
    [sym_type_qualifier] = STATE(1146),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5434),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [aux_sym__type_definition_type_repeat1] = STATE(1146),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4171),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4135),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4173),
    [anon_sym_const] = ACTIONS(4135),
    [anon_sym_constexpr] = ACTIONS(4135),
    [anon_sym_volatile] = ACTIONS(4135),
    [anon_sym_restrict] = ACTIONS(4135),
    [anon_sym___restrict__] = ACTIONS(4135),
    [anon_sym__Atomic] = ACTIONS(4135),
    [anon_sym__Noreturn] = ACTIONS(4135),
    [anon_sym_noreturn] = ACTIONS(4135),
    [anon_sym_mutable] = ACTIONS(4135),
    [anon_sym_constinit] = ACTIONS(4135),
    [anon_sym_consteval] = ACTIONS(4135),
    [anon_sym_PROGMEM] = ACTIONS(4135),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1136] = {
    [sym_type_qualifier] = STATE(1141),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5433),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [aux_sym__type_definition_type_repeat1] = STATE(1141),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4143),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4135),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4145),
    [anon_sym_const] = ACTIONS(4135),
    [anon_sym_constexpr] = ACTIONS(4135),
    [anon_sym_volatile] = ACTIONS(4135),
    [anon_sym_restrict] = ACTIONS(4135),
    [anon_sym___restrict__] = ACTIONS(4135),
    [anon_sym__Atomic] = ACTIONS(4135),
    [anon_sym__Noreturn] = ACTIONS(4135),
    [anon_sym_noreturn] = ACTIONS(4135),
    [anon_sym_mutable] = ACTIONS(4135),
    [anon_sym_constinit] = ACTIONS(4135),
    [anon_sym_consteval] = ACTIONS(4135),
    [anon_sym_PROGMEM] = ACTIONS(4135),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1137] = {
    [sym_type_qualifier] = STATE(2101),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5422),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [aux_sym__type_definition_type_repeat1] = STATE(2101),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4177),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4135),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4179),
    [anon_sym_const] = ACTIONS(4135),
    [anon_sym_constexpr] = ACTIONS(4135),
    [anon_sym_volatile] = ACTIONS(4135),
    [anon_sym_restrict] = ACTIONS(4135),
    [anon_sym___restrict__] = ACTIONS(4135),
    [anon_sym__Atomic] = ACTIONS(4135),
    [anon_sym__Noreturn] = ACTIONS(4135),
    [anon_sym_noreturn] = ACTIONS(4135),
    [anon_sym_mutable] = ACTIONS(4135),
    [anon_sym_constinit] = ACTIONS(4135),
    [anon_sym_consteval] = ACTIONS(4135),
    [anon_sym_PROGMEM] = ACTIONS(4135),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1138] = {
    [sym_type_qualifier] = STATE(2101),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5510),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [aux_sym__type_definition_type_repeat1] = STATE(2101),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4181),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4135),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4183),
    [anon_sym_const] = ACTIONS(4135),
    [anon_sym_constexpr] = ACTIONS(4135),
    [anon_sym_volatile] = ACTIONS(4135),
    [anon_sym_restrict] = ACTIONS(4135),
    [anon_sym___restrict__] = ACTIONS(4135),
    [anon_sym__Atomic] = ACTIONS(4135),
    [anon_sym__Noreturn] = ACTIONS(4135),
    [anon_sym_noreturn] = ACTIONS(4135),
    [anon_sym_mutable] = ACTIONS(4135),
    [anon_sym_constinit] = ACTIONS(4135),
    [anon_sym_consteval] = ACTIONS(4135),
    [anon_sym_PROGMEM] = ACTIONS(4135),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1139] = {
    [sym_type_qualifier] = STATE(1138),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5477),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [aux_sym__type_definition_type_repeat1] = STATE(1138),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4185),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4135),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4187),
    [anon_sym_const] = ACTIONS(4135),
    [anon_sym_constexpr] = ACTIONS(4135),
    [anon_sym_volatile] = ACTIONS(4135),
    [anon_sym_restrict] = ACTIONS(4135),
    [anon_sym___restrict__] = ACTIONS(4135),
    [anon_sym__Atomic] = ACTIONS(4135),
    [anon_sym__Noreturn] = ACTIONS(4135),
    [anon_sym_noreturn] = ACTIONS(4135),
    [anon_sym_mutable] = ACTIONS(4135),
    [anon_sym_constinit] = ACTIONS(4135),
    [anon_sym_consteval] = ACTIONS(4135),
    [anon_sym_PROGMEM] = ACTIONS(4135),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1140] = {
    [sym_type_qualifier] = STATE(2101),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5483),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [aux_sym__type_definition_type_repeat1] = STATE(2101),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4189),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4135),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4191),
    [anon_sym_const] = ACTIONS(4135),
    [anon_sym_constexpr] = ACTIONS(4135),
    [anon_sym_volatile] = ACTIONS(4135),
    [anon_sym_restrict] = ACTIONS(4135),
    [anon_sym___restrict__] = ACTIONS(4135),
    [anon_sym__Atomic] = ACTIONS(4135),
    [anon_sym__Noreturn] = ACTIONS(4135),
    [anon_sym_noreturn] = ACTIONS(4135),
    [anon_sym_mutable] = ACTIONS(4135),
    [anon_sym_constinit] = ACTIONS(4135),
    [anon_sym_consteval] = ACTIONS(4135),
    [anon_sym_PROGMEM] = ACTIONS(4135),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1141] = {
    [sym_type_qualifier] = STATE(2101),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5385),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [aux_sym__type_definition_type_repeat1] = STATE(2101),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4193),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4135),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4195),
    [anon_sym_const] = ACTIONS(4135),
    [anon_sym_constexpr] = ACTIONS(4135),
    [anon_sym_volatile] = ACTIONS(4135),
    [anon_sym_restrict] = ACTIONS(4135),
    [anon_sym___restrict__] = ACTIONS(4135),
    [anon_sym__Atomic] = ACTIONS(4135),
    [anon_sym__Noreturn] = ACTIONS(4135),
    [anon_sym_noreturn] = ACTIONS(4135),
    [anon_sym_mutable] = ACTIONS(4135),
    [anon_sym_constinit] = ACTIONS(4135),
    [anon_sym_consteval] = ACTIONS(4135),
    [anon_sym_PROGMEM] = ACTIONS(4135),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1142] = {
    [sym_type_qualifier] = STATE(1145),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5386),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [aux_sym__type_definition_type_repeat1] = STATE(1145),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4197),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4135),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4199),
    [anon_sym_const] = ACTIONS(4135),
    [anon_sym_constexpr] = ACTIONS(4135),
    [anon_sym_volatile] = ACTIONS(4135),
    [anon_sym_restrict] = ACTIONS(4135),
    [anon_sym___restrict__] = ACTIONS(4135),
    [anon_sym__Atomic] = ACTIONS(4135),
    [anon_sym__Noreturn] = ACTIONS(4135),
    [anon_sym_noreturn] = ACTIONS(4135),
    [anon_sym_mutable] = ACTIONS(4135),
    [anon_sym_constinit] = ACTIONS(4135),
    [anon_sym_consteval] = ACTIONS(4135),
    [anon_sym_PROGMEM] = ACTIONS(4135),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1143] = {
    [sym_type_qualifier] = STATE(2101),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5441),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [aux_sym__type_definition_type_repeat1] = STATE(2101),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4135),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4203),
    [anon_sym_const] = ACTIONS(4135),
    [anon_sym_constexpr] = ACTIONS(4135),
    [anon_sym_volatile] = ACTIONS(4135),
    [anon_sym_restrict] = ACTIONS(4135),
    [anon_sym___restrict__] = ACTIONS(4135),
    [anon_sym__Atomic] = ACTIONS(4135),
    [anon_sym__Noreturn] = ACTIONS(4135),
    [anon_sym_noreturn] = ACTIONS(4135),
    [anon_sym_mutable] = ACTIONS(4135),
    [anon_sym_constinit] = ACTIONS(4135),
    [anon_sym_consteval] = ACTIONS(4135),
    [anon_sym_PROGMEM] = ACTIONS(4135),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1144] = {
    [sym_type_qualifier] = STATE(2101),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5427),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [aux_sym__type_definition_type_repeat1] = STATE(2101),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4205),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4135),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4207),
    [anon_sym_const] = ACTIONS(4135),
    [anon_sym_constexpr] = ACTIONS(4135),
    [anon_sym_volatile] = ACTIONS(4135),
    [anon_sym_restrict] = ACTIONS(4135),
    [anon_sym___restrict__] = ACTIONS(4135),
    [anon_sym__Atomic] = ACTIONS(4135),
    [anon_sym__Noreturn] = ACTIONS(4135),
    [anon_sym_noreturn] = ACTIONS(4135),
    [anon_sym_mutable] = ACTIONS(4135),
    [anon_sym_constinit] = ACTIONS(4135),
    [anon_sym_consteval] = ACTIONS(4135),
    [anon_sym_PROGMEM] = ACTIONS(4135),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1145] = {
    [sym_type_qualifier] = STATE(2101),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5450),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [aux_sym__type_definition_type_repeat1] = STATE(2101),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4209),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4135),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4211),
    [anon_sym_const] = ACTIONS(4135),
    [anon_sym_constexpr] = ACTIONS(4135),
    [anon_sym_volatile] = ACTIONS(4135),
    [anon_sym_restrict] = ACTIONS(4135),
    [anon_sym___restrict__] = ACTIONS(4135),
    [anon_sym__Atomic] = ACTIONS(4135),
    [anon_sym__Noreturn] = ACTIONS(4135),
    [anon_sym_noreturn] = ACTIONS(4135),
    [anon_sym_mutable] = ACTIONS(4135),
    [anon_sym_constinit] = ACTIONS(4135),
    [anon_sym_consteval] = ACTIONS(4135),
    [anon_sym_PROGMEM] = ACTIONS(4135),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1146] = {
    [sym_type_qualifier] = STATE(2101),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5420),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [aux_sym__type_definition_type_repeat1] = STATE(2101),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4213),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4135),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4135),
    [anon_sym_constexpr] = ACTIONS(4135),
    [anon_sym_volatile] = ACTIONS(4135),
    [anon_sym_restrict] = ACTIONS(4135),
    [anon_sym___restrict__] = ACTIONS(4135),
    [anon_sym__Atomic] = ACTIONS(4135),
    [anon_sym__Noreturn] = ACTIONS(4135),
    [anon_sym_noreturn] = ACTIONS(4135),
    [anon_sym_mutable] = ACTIONS(4135),
    [anon_sym_constinit] = ACTIONS(4135),
    [anon_sym_consteval] = ACTIONS(4135),
    [anon_sym_PROGMEM] = ACTIONS(4135),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1147] = {
    [sym_type_qualifier] = STATE(1133),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5451),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [aux_sym__type_definition_type_repeat1] = STATE(1133),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4217),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4135),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4219),
    [anon_sym_const] = ACTIONS(4135),
    [anon_sym_constexpr] = ACTIONS(4135),
    [anon_sym_volatile] = ACTIONS(4135),
    [anon_sym_restrict] = ACTIONS(4135),
    [anon_sym___restrict__] = ACTIONS(4135),
    [anon_sym__Atomic] = ACTIONS(4135),
    [anon_sym__Noreturn] = ACTIONS(4135),
    [anon_sym_noreturn] = ACTIONS(4135),
    [anon_sym_mutable] = ACTIONS(4135),
    [anon_sym_constinit] = ACTIONS(4135),
    [anon_sym_consteval] = ACTIONS(4135),
    [anon_sym_PROGMEM] = ACTIONS(4135),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1148] = {
    [sym_type_qualifier] = STATE(1130),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5454),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [aux_sym__type_definition_type_repeat1] = STATE(1130),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4221),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4135),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4223),
    [anon_sym_const] = ACTIONS(4135),
    [anon_sym_constexpr] = ACTIONS(4135),
    [anon_sym_volatile] = ACTIONS(4135),
    [anon_sym_restrict] = ACTIONS(4135),
    [anon_sym___restrict__] = ACTIONS(4135),
    [anon_sym__Atomic] = ACTIONS(4135),
    [anon_sym__Noreturn] = ACTIONS(4135),
    [anon_sym_noreturn] = ACTIONS(4135),
    [anon_sym_mutable] = ACTIONS(4135),
    [anon_sym_constinit] = ACTIONS(4135),
    [anon_sym_consteval] = ACTIONS(4135),
    [anon_sym_PROGMEM] = ACTIONS(4135),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1149] = {
    [sym_identifier] = ACTIONS(4225),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_BANG] = ACTIONS(4231),
    [anon_sym_TILDE] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4233),
    [anon_sym_PLUS] = ACTIONS(4233),
    [anon_sym_STAR] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4235),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_SEMI] = ACTIONS(4231),
    [anon_sym___extension__] = ACTIONS(4237),
    [anon_sym_extern] = ACTIONS(4237),
    [anon_sym___attribute__] = ACTIONS(4237),
    [anon_sym_COLON_COLON] = ACTIONS(4228),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4228),
    [anon_sym___declspec] = ACTIONS(4237),
    [anon_sym___based] = ACTIONS(4237),
    [anon_sym_LBRACE] = ACTIONS(4231),
    [anon_sym_signed] = ACTIONS(4237),
    [anon_sym_unsigned] = ACTIONS(4237),
    [anon_sym_long] = ACTIONS(4237),
    [anon_sym_short] = ACTIONS(4237),
    [anon_sym_LBRACK] = ACTIONS(4225),
    [anon_sym_static] = ACTIONS(4237),
    [anon_sym_register] = ACTIONS(4237),
    [anon_sym_inline] = ACTIONS(4237),
    [anon_sym___inline] = ACTIONS(4237),
    [anon_sym___inline__] = ACTIONS(4237),
    [anon_sym___forceinline] = ACTIONS(4237),
    [anon_sym_thread_local] = ACTIONS(4237),
    [anon_sym___thread] = ACTIONS(4237),
    [anon_sym_const] = ACTIONS(4237),
    [anon_sym_constexpr] = ACTIONS(4237),
    [anon_sym_volatile] = ACTIONS(4237),
    [anon_sym_restrict] = ACTIONS(4237),
    [anon_sym___restrict__] = ACTIONS(4237),
    [anon_sym__Atomic] = ACTIONS(4237),
    [anon_sym__Noreturn] = ACTIONS(4237),
    [anon_sym_noreturn] = ACTIONS(4237),
    [anon_sym_mutable] = ACTIONS(4237),
    [anon_sym_constinit] = ACTIONS(4237),
    [anon_sym_consteval] = ACTIONS(4237),
    [anon_sym_PROGMEM] = ACTIONS(4237),
    [aux_sym_primitive_type_token1] = ACTIONS(4225),
    [anon_sym_byte] = ACTIONS(4225),
    [anon_sym_word] = ACTIONS(4225),
    [anon_sym_enum] = ACTIONS(4237),
    [anon_sym_class] = ACTIONS(4237),
    [anon_sym_struct] = ACTIONS(4237),
    [anon_sym_union] = ACTIONS(4237),
    [anon_sym_if] = ACTIONS(4233),
    [anon_sym_switch] = ACTIONS(4233),
    [anon_sym_case] = ACTIONS(4233),
    [anon_sym_default] = ACTIONS(4233),
    [anon_sym_while] = ACTIONS(4233),
    [anon_sym_do] = ACTIONS(4233),
    [anon_sym_for] = ACTIONS(4233),
    [anon_sym_return] = ACTIONS(4233),
    [anon_sym_break] = ACTIONS(4233),
    [anon_sym_continue] = ACTIONS(4233),
    [anon_sym_goto] = ACTIONS(4233),
    [anon_sym___try] = ACTIONS(4233),
    [anon_sym___leave] = ACTIONS(4233),
    [anon_sym_not] = ACTIONS(4233),
    [anon_sym_compl] = ACTIONS(4233),
    [anon_sym_DASH_DASH] = ACTIONS(4231),
    [anon_sym_PLUS_PLUS] = ACTIONS(4231),
    [anon_sym_sizeof] = ACTIONS(4233),
    [anon_sym___alignof__] = ACTIONS(4233),
    [anon_sym___alignof] = ACTIONS(4233),
    [anon_sym__alignof] = ACTIONS(4233),
    [anon_sym_alignof] = ACTIONS(4233),
    [anon_sym__Alignof] = ACTIONS(4233),
    [anon_sym_offsetof] = ACTIONS(4233),
    [anon_sym__Generic] = ACTIONS(4233),
    [anon_sym_asm] = ACTIONS(4233),
    [anon_sym___asm__] = ACTIONS(4233),
    [aux_sym_number_literal_token1] = ACTIONS(4231),
    [aux_sym_number_literal_token2] = ACTIONS(4233),
    [anon_sym_L_SQUOTE] = ACTIONS(4231),
    [anon_sym_u_SQUOTE] = ACTIONS(4231),
    [anon_sym_U_SQUOTE] = ACTIONS(4231),
    [anon_sym_u8_SQUOTE] = ACTIONS(4231),
    [anon_sym_SQUOTE] = ACTIONS(4231),
    [anon_sym_L_DQUOTE] = ACTIONS(4231),
    [anon_sym_u_DQUOTE] = ACTIONS(4231),
    [anon_sym_U_DQUOTE] = ACTIONS(4231),
    [anon_sym_u8_DQUOTE] = ACTIONS(4231),
    [anon_sym_DQUOTE] = ACTIONS(4231),
    [sym_true] = ACTIONS(4233),
    [sym_false] = ACTIONS(4233),
    [anon_sym_NULL] = ACTIONS(4233),
    [anon_sym_nullptr] = ACTIONS(4233),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4237),
    [anon_sym_decltype] = ACTIONS(4225),
    [anon_sym_virtual] = ACTIONS(4237),
    [anon_sym_alignas] = ACTIONS(4237),
    [anon_sym_explicit] = ACTIONS(4237),
    [anon_sym_typename] = ACTIONS(4237),
    [anon_sym_template] = ACTIONS(4225),
    [anon_sym_operator] = ACTIONS(4237),
    [anon_sym_try] = ACTIONS(4233),
    [anon_sym_delete] = ACTIONS(4233),
    [anon_sym_throw] = ACTIONS(4233),
    [anon_sym_co_return] = ACTIONS(4233),
    [anon_sym_co_yield] = ACTIONS(4233),
    [anon_sym_R_DQUOTE] = ACTIONS(4231),
    [anon_sym_LR_DQUOTE] = ACTIONS(4231),
    [anon_sym_uR_DQUOTE] = ACTIONS(4231),
    [anon_sym_UR_DQUOTE] = ACTIONS(4231),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4231),
    [anon_sym_co_await] = ACTIONS(4233),
    [anon_sym_new] = ACTIONS(4233),
    [anon_sym_requires] = ACTIONS(4233),
    [sym_this] = ACTIONS(4233),
  },
  [1150] = {
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7224),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7008),
    [sym_array_declarator] = STATE(7008),
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3820),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6474),
    [sym_qualified_identifier] = STATE(3890),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(3395),
    [anon_sym_LPAREN2] = ACTIONS(2077),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2085),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2087),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2095),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(2137),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1151] = {
    [sym_catch_clause] = STATE(1151),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1151),
    [sym_identifier] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2845),
    [anon_sym_BANG] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2845),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym___extension__] = ACTIONS(2843),
    [anon_sym_typedef] = ACTIONS(2843),
    [anon_sym_extern] = ACTIONS(2843),
    [anon_sym___attribute__] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2845),
    [anon_sym___declspec] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(2845),
    [anon_sym_signed] = ACTIONS(2843),
    [anon_sym_unsigned] = ACTIONS(2843),
    [anon_sym_long] = ACTIONS(2843),
    [anon_sym_short] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_register] = ACTIONS(2843),
    [anon_sym_inline] = ACTIONS(2843),
    [anon_sym___inline] = ACTIONS(2843),
    [anon_sym___inline__] = ACTIONS(2843),
    [anon_sym___forceinline] = ACTIONS(2843),
    [anon_sym_thread_local] = ACTIONS(2843),
    [anon_sym___thread] = ACTIONS(2843),
    [anon_sym_const] = ACTIONS(2843),
    [anon_sym_constexpr] = ACTIONS(2843),
    [anon_sym_volatile] = ACTIONS(2843),
    [anon_sym_restrict] = ACTIONS(2843),
    [anon_sym___restrict__] = ACTIONS(2843),
    [anon_sym__Atomic] = ACTIONS(2843),
    [anon_sym__Noreturn] = ACTIONS(2843),
    [anon_sym_noreturn] = ACTIONS(2843),
    [anon_sym_mutable] = ACTIONS(2843),
    [anon_sym_constinit] = ACTIONS(2843),
    [anon_sym_consteval] = ACTIONS(2843),
    [anon_sym_PROGMEM] = ACTIONS(2843),
    [aux_sym_primitive_type_token1] = ACTIONS(2843),
    [anon_sym_byte] = ACTIONS(2843),
    [anon_sym_word] = ACTIONS(2843),
    [anon_sym_enum] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2843),
    [anon_sym_union] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_else] = ACTIONS(2843),
    [anon_sym_switch] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_break] = ACTIONS(2843),
    [anon_sym_continue] = ACTIONS(2843),
    [anon_sym_goto] = ACTIONS(2843),
    [anon_sym___try] = ACTIONS(2843),
    [anon_sym___leave] = ACTIONS(2843),
    [anon_sym_not] = ACTIONS(2843),
    [anon_sym_compl] = ACTIONS(2843),
    [anon_sym_DASH_DASH] = ACTIONS(2845),
    [anon_sym_PLUS_PLUS] = ACTIONS(2845),
    [anon_sym_sizeof] = ACTIONS(2843),
    [anon_sym___alignof__] = ACTIONS(2843),
    [anon_sym___alignof] = ACTIONS(2843),
    [anon_sym__alignof] = ACTIONS(2843),
    [anon_sym_alignof] = ACTIONS(2843),
    [anon_sym__Alignof] = ACTIONS(2843),
    [anon_sym_offsetof] = ACTIONS(2843),
    [anon_sym__Generic] = ACTIONS(2843),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [aux_sym_number_literal_token1] = ACTIONS(2845),
    [aux_sym_number_literal_token2] = ACTIONS(2843),
    [anon_sym_L_SQUOTE] = ACTIONS(2845),
    [anon_sym_u_SQUOTE] = ACTIONS(2845),
    [anon_sym_U_SQUOTE] = ACTIONS(2845),
    [anon_sym_u8_SQUOTE] = ACTIONS(2845),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_L_DQUOTE] = ACTIONS(2845),
    [anon_sym_u_DQUOTE] = ACTIONS(2845),
    [anon_sym_U_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(2845),
    [sym_true] = ACTIONS(2843),
    [sym_false] = ACTIONS(2843),
    [anon_sym_NULL] = ACTIONS(2843),
    [anon_sym_nullptr] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2843),
    [anon_sym_decltype] = ACTIONS(2843),
    [anon_sym_virtual] = ACTIONS(2843),
    [anon_sym_alignas] = ACTIONS(2843),
    [anon_sym_typename] = ACTIONS(2843),
    [anon_sym_template] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_delete] = ACTIONS(2843),
    [anon_sym_throw] = ACTIONS(2843),
    [anon_sym_co_return] = ACTIONS(2843),
    [anon_sym_co_yield] = ACTIONS(2843),
    [anon_sym_catch] = ACTIONS(4239),
    [anon_sym_R_DQUOTE] = ACTIONS(2845),
    [anon_sym_LR_DQUOTE] = ACTIONS(2845),
    [anon_sym_uR_DQUOTE] = ACTIONS(2845),
    [anon_sym_UR_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2845),
    [anon_sym_co_await] = ACTIONS(2843),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_requires] = ACTIONS(2843),
    [sym_this] = ACTIONS(2843),
  },
  [1152] = {
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7224),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7008),
    [sym_array_declarator] = STATE(7008),
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4013),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6503),
    [sym_qualified_identifier] = STATE(4014),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_operator_name] = STATE(7008),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(3459),
    [anon_sym_LPAREN2] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(3463),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2095),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(2137),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1153] = {
    [sym_catch_clause] = STATE(1151),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1151),
    [sym_identifier] = ACTIONS(2850),
    [anon_sym_LPAREN2] = ACTIONS(2852),
    [anon_sym_BANG] = ACTIONS(2852),
    [anon_sym_TILDE] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(2850),
    [anon_sym_PLUS] = ACTIONS(2850),
    [anon_sym_STAR] = ACTIONS(2852),
    [anon_sym_AMP] = ACTIONS(2852),
    [anon_sym_SEMI] = ACTIONS(2852),
    [anon_sym___extension__] = ACTIONS(2850),
    [anon_sym_typedef] = ACTIONS(2850),
    [anon_sym_extern] = ACTIONS(2850),
    [anon_sym___attribute__] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2852),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2852),
    [anon_sym___declspec] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2852),
    [anon_sym_signed] = ACTIONS(2850),
    [anon_sym_unsigned] = ACTIONS(2850),
    [anon_sym_long] = ACTIONS(2850),
    [anon_sym_short] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2850),
    [anon_sym_register] = ACTIONS(2850),
    [anon_sym_inline] = ACTIONS(2850),
    [anon_sym___inline] = ACTIONS(2850),
    [anon_sym___inline__] = ACTIONS(2850),
    [anon_sym___forceinline] = ACTIONS(2850),
    [anon_sym_thread_local] = ACTIONS(2850),
    [anon_sym___thread] = ACTIONS(2850),
    [anon_sym_const] = ACTIONS(2850),
    [anon_sym_constexpr] = ACTIONS(2850),
    [anon_sym_volatile] = ACTIONS(2850),
    [anon_sym_restrict] = ACTIONS(2850),
    [anon_sym___restrict__] = ACTIONS(2850),
    [anon_sym__Atomic] = ACTIONS(2850),
    [anon_sym__Noreturn] = ACTIONS(2850),
    [anon_sym_noreturn] = ACTIONS(2850),
    [anon_sym_mutable] = ACTIONS(2850),
    [anon_sym_constinit] = ACTIONS(2850),
    [anon_sym_consteval] = ACTIONS(2850),
    [anon_sym_PROGMEM] = ACTIONS(2850),
    [aux_sym_primitive_type_token1] = ACTIONS(2850),
    [anon_sym_byte] = ACTIONS(2850),
    [anon_sym_word] = ACTIONS(2850),
    [anon_sym_enum] = ACTIONS(2850),
    [anon_sym_class] = ACTIONS(2850),
    [anon_sym_struct] = ACTIONS(2850),
    [anon_sym_union] = ACTIONS(2850),
    [anon_sym_if] = ACTIONS(2850),
    [anon_sym_else] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2850),
    [anon_sym_while] = ACTIONS(2850),
    [anon_sym_do] = ACTIONS(2850),
    [anon_sym_for] = ACTIONS(2850),
    [anon_sym_return] = ACTIONS(2850),
    [anon_sym_break] = ACTIONS(2850),
    [anon_sym_continue] = ACTIONS(2850),
    [anon_sym_goto] = ACTIONS(2850),
    [anon_sym___try] = ACTIONS(2850),
    [anon_sym___leave] = ACTIONS(2850),
    [anon_sym_not] = ACTIONS(2850),
    [anon_sym_compl] = ACTIONS(2850),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_sizeof] = ACTIONS(2850),
    [anon_sym___alignof__] = ACTIONS(2850),
    [anon_sym___alignof] = ACTIONS(2850),
    [anon_sym__alignof] = ACTIONS(2850),
    [anon_sym_alignof] = ACTIONS(2850),
    [anon_sym__Alignof] = ACTIONS(2850),
    [anon_sym_offsetof] = ACTIONS(2850),
    [anon_sym__Generic] = ACTIONS(2850),
    [anon_sym_asm] = ACTIONS(2850),
    [anon_sym___asm__] = ACTIONS(2850),
    [aux_sym_number_literal_token1] = ACTIONS(2852),
    [aux_sym_number_literal_token2] = ACTIONS(2850),
    [anon_sym_L_SQUOTE] = ACTIONS(2852),
    [anon_sym_u_SQUOTE] = ACTIONS(2852),
    [anon_sym_U_SQUOTE] = ACTIONS(2852),
    [anon_sym_u8_SQUOTE] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2852),
    [anon_sym_L_DQUOTE] = ACTIONS(2852),
    [anon_sym_u_DQUOTE] = ACTIONS(2852),
    [anon_sym_U_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8_DQUOTE] = ACTIONS(2852),
    [anon_sym_DQUOTE] = ACTIONS(2852),
    [sym_true] = ACTIONS(2850),
    [sym_false] = ACTIONS(2850),
    [anon_sym_NULL] = ACTIONS(2850),
    [anon_sym_nullptr] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2850),
    [anon_sym_decltype] = ACTIONS(2850),
    [anon_sym_virtual] = ACTIONS(2850),
    [anon_sym_alignas] = ACTIONS(2850),
    [anon_sym_typename] = ACTIONS(2850),
    [anon_sym_template] = ACTIONS(2850),
    [anon_sym_try] = ACTIONS(2850),
    [anon_sym_delete] = ACTIONS(2850),
    [anon_sym_throw] = ACTIONS(2850),
    [anon_sym_co_return] = ACTIONS(2850),
    [anon_sym_co_yield] = ACTIONS(2850),
    [anon_sym_catch] = ACTIONS(4242),
    [anon_sym_R_DQUOTE] = ACTIONS(2852),
    [anon_sym_LR_DQUOTE] = ACTIONS(2852),
    [anon_sym_uR_DQUOTE] = ACTIONS(2852),
    [anon_sym_UR_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2852),
    [anon_sym_co_await] = ACTIONS(2850),
    [anon_sym_new] = ACTIONS(2850),
    [anon_sym_requires] = ACTIONS(2850),
    [sym_this] = ACTIONS(2850),
  },
  [1154] = {
    [sym_else_clause] = STATE(1197),
    [sym_identifier] = ACTIONS(2891),
    [anon_sym_LPAREN2] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym___extension__] = ACTIONS(2891),
    [anon_sym_typedef] = ACTIONS(2891),
    [anon_sym_extern] = ACTIONS(2891),
    [anon_sym___attribute__] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2893),
    [anon_sym___declspec] = ACTIONS(2891),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_signed] = ACTIONS(2891),
    [anon_sym_unsigned] = ACTIONS(2891),
    [anon_sym_long] = ACTIONS(2891),
    [anon_sym_short] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_static] = ACTIONS(2891),
    [anon_sym_register] = ACTIONS(2891),
    [anon_sym_inline] = ACTIONS(2891),
    [anon_sym___inline] = ACTIONS(2891),
    [anon_sym___inline__] = ACTIONS(2891),
    [anon_sym___forceinline] = ACTIONS(2891),
    [anon_sym_thread_local] = ACTIONS(2891),
    [anon_sym___thread] = ACTIONS(2891),
    [anon_sym_const] = ACTIONS(2891),
    [anon_sym_constexpr] = ACTIONS(2891),
    [anon_sym_volatile] = ACTIONS(2891),
    [anon_sym_restrict] = ACTIONS(2891),
    [anon_sym___restrict__] = ACTIONS(2891),
    [anon_sym__Atomic] = ACTIONS(2891),
    [anon_sym__Noreturn] = ACTIONS(2891),
    [anon_sym_noreturn] = ACTIONS(2891),
    [anon_sym_mutable] = ACTIONS(2891),
    [anon_sym_constinit] = ACTIONS(2891),
    [anon_sym_consteval] = ACTIONS(2891),
    [anon_sym_PROGMEM] = ACTIONS(2891),
    [aux_sym_primitive_type_token1] = ACTIONS(2891),
    [anon_sym_byte] = ACTIONS(2891),
    [anon_sym_word] = ACTIONS(2891),
    [anon_sym_enum] = ACTIONS(2891),
    [anon_sym_class] = ACTIONS(2891),
    [anon_sym_struct] = ACTIONS(2891),
    [anon_sym_union] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_else] = ACTIONS(4244),
    [anon_sym_switch] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2891),
    [anon_sym_for] = ACTIONS(2891),
    [anon_sym_return] = ACTIONS(2891),
    [anon_sym_break] = ACTIONS(2891),
    [anon_sym_continue] = ACTIONS(2891),
    [anon_sym_goto] = ACTIONS(2891),
    [anon_sym___try] = ACTIONS(2891),
    [anon_sym___leave] = ACTIONS(2891),
    [anon_sym_not] = ACTIONS(2891),
    [anon_sym_compl] = ACTIONS(2891),
    [anon_sym_DASH_DASH] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2893),
    [anon_sym_sizeof] = ACTIONS(2891),
    [anon_sym___alignof__] = ACTIONS(2891),
    [anon_sym___alignof] = ACTIONS(2891),
    [anon_sym__alignof] = ACTIONS(2891),
    [anon_sym_alignof] = ACTIONS(2891),
    [anon_sym__Alignof] = ACTIONS(2891),
    [anon_sym_offsetof] = ACTIONS(2891),
    [anon_sym__Generic] = ACTIONS(2891),
    [anon_sym_asm] = ACTIONS(2891),
    [anon_sym___asm__] = ACTIONS(2891),
    [aux_sym_number_literal_token1] = ACTIONS(2893),
    [aux_sym_number_literal_token2] = ACTIONS(2891),
    [anon_sym_L_SQUOTE] = ACTIONS(2893),
    [anon_sym_u_SQUOTE] = ACTIONS(2893),
    [anon_sym_U_SQUOTE] = ACTIONS(2893),
    [anon_sym_u8_SQUOTE] = ACTIONS(2893),
    [anon_sym_SQUOTE] = ACTIONS(2893),
    [anon_sym_L_DQUOTE] = ACTIONS(2893),
    [anon_sym_u_DQUOTE] = ACTIONS(2893),
    [anon_sym_U_DQUOTE] = ACTIONS(2893),
    [anon_sym_u8_DQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(2893),
    [sym_true] = ACTIONS(2891),
    [sym_false] = ACTIONS(2891),
    [anon_sym_NULL] = ACTIONS(2891),
    [anon_sym_nullptr] = ACTIONS(2891),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2891),
    [anon_sym_decltype] = ACTIONS(2891),
    [anon_sym_virtual] = ACTIONS(2891),
    [anon_sym_alignas] = ACTIONS(2891),
    [anon_sym_typename] = ACTIONS(2891),
    [anon_sym_template] = ACTIONS(2891),
    [anon_sym_try] = ACTIONS(2891),
    [anon_sym_delete] = ACTIONS(2891),
    [anon_sym_throw] = ACTIONS(2891),
    [anon_sym_co_return] = ACTIONS(2891),
    [anon_sym_co_yield] = ACTIONS(2891),
    [anon_sym_R_DQUOTE] = ACTIONS(2893),
    [anon_sym_LR_DQUOTE] = ACTIONS(2893),
    [anon_sym_uR_DQUOTE] = ACTIONS(2893),
    [anon_sym_UR_DQUOTE] = ACTIONS(2893),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2893),
    [anon_sym_co_await] = ACTIONS(2891),
    [anon_sym_new] = ACTIONS(2891),
    [anon_sym_requires] = ACTIONS(2891),
    [sym_this] = ACTIONS(2891),
  },
  [1155] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(2035),
    [sym_raw_string_literal] = STATE(3057),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3184),
    [sym_identifier] = ACTIONS(4246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4250),
    [anon_sym_TILDE] = ACTIONS(4254),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4258),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4261),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4258),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(4264),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4261),
    [anon_sym___extension__] = ACTIONS(4246),
    [anon_sym_extern] = ACTIONS(4246),
    [anon_sym___attribute__] = ACTIONS(4246),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4269),
    [anon_sym___declspec] = ACTIONS(4246),
    [anon_sym___based] = ACTIONS(4246),
    [anon_sym___cdecl] = ACTIONS(4246),
    [anon_sym___clrcall] = ACTIONS(4246),
    [anon_sym___stdcall] = ACTIONS(4246),
    [anon_sym___fastcall] = ACTIONS(4246),
    [anon_sym___thiscall] = ACTIONS(4246),
    [anon_sym___vectorcall] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_RBRACE] = ACTIONS(4248),
    [anon_sym_signed] = ACTIONS(4274),
    [anon_sym_unsigned] = ACTIONS(4274),
    [anon_sym_long] = ACTIONS(4274),
    [anon_sym_short] = ACTIONS(4274),
    [anon_sym_LBRACK] = ACTIONS(4276),
    [anon_sym_EQ] = ACTIONS(4280),
    [anon_sym_static] = ACTIONS(4246),
    [anon_sym_register] = ACTIONS(4246),
    [anon_sym_inline] = ACTIONS(4246),
    [anon_sym___inline] = ACTIONS(4246),
    [anon_sym___inline__] = ACTIONS(4246),
    [anon_sym___forceinline] = ACTIONS(4246),
    [anon_sym_thread_local] = ACTIONS(4246),
    [anon_sym___thread] = ACTIONS(4246),
    [anon_sym_const] = ACTIONS(4246),
    [anon_sym_constexpr] = ACTIONS(4246),
    [anon_sym_volatile] = ACTIONS(4246),
    [anon_sym_restrict] = ACTIONS(4246),
    [anon_sym___restrict__] = ACTIONS(4246),
    [anon_sym__Atomic] = ACTIONS(4246),
    [anon_sym__Noreturn] = ACTIONS(4246),
    [anon_sym_noreturn] = ACTIONS(4246),
    [anon_sym_mutable] = ACTIONS(4246),
    [anon_sym_constinit] = ACTIONS(4246),
    [anon_sym_consteval] = ACTIONS(4246),
    [anon_sym_PROGMEM] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4282),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_and_eq] = ACTIONS(4280),
    [anon_sym_or_eq] = ACTIONS(4280),
    [anon_sym_xor_eq] = ACTIONS(4280),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4256),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4256),
    [anon_sym_not_eq] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4246),
    [anon_sym_decltype] = ACTIONS(4246),
    [anon_sym_virtual] = ACTIONS(4246),
    [anon_sym_alignas] = ACTIONS(4246),
    [anon_sym_template] = ACTIONS(4246),
    [anon_sym_operator] = ACTIONS(4246),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [1156] = {
    [sym_identifier] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2889),
    [anon_sym_BANG] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2887),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2889),
    [anon_sym_SEMI] = ACTIONS(2889),
    [anon_sym___extension__] = ACTIONS(2887),
    [anon_sym_typedef] = ACTIONS(2887),
    [anon_sym_extern] = ACTIONS(2887),
    [anon_sym___attribute__] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2889),
    [anon_sym___declspec] = ACTIONS(2887),
    [anon_sym_LBRACE] = ACTIONS(2889),
    [anon_sym_signed] = ACTIONS(2887),
    [anon_sym_unsigned] = ACTIONS(2887),
    [anon_sym_long] = ACTIONS(2887),
    [anon_sym_short] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_static] = ACTIONS(2887),
    [anon_sym_register] = ACTIONS(2887),
    [anon_sym_inline] = ACTIONS(2887),
    [anon_sym___inline] = ACTIONS(2887),
    [anon_sym___inline__] = ACTIONS(2887),
    [anon_sym___forceinline] = ACTIONS(2887),
    [anon_sym_thread_local] = ACTIONS(2887),
    [anon_sym___thread] = ACTIONS(2887),
    [anon_sym_const] = ACTIONS(2887),
    [anon_sym_constexpr] = ACTIONS(2887),
    [anon_sym_volatile] = ACTIONS(2887),
    [anon_sym_restrict] = ACTIONS(2887),
    [anon_sym___restrict__] = ACTIONS(2887),
    [anon_sym__Atomic] = ACTIONS(2887),
    [anon_sym__Noreturn] = ACTIONS(2887),
    [anon_sym_noreturn] = ACTIONS(2887),
    [anon_sym_mutable] = ACTIONS(2887),
    [anon_sym_constinit] = ACTIONS(2887),
    [anon_sym_consteval] = ACTIONS(2887),
    [anon_sym_PROGMEM] = ACTIONS(2887),
    [aux_sym_primitive_type_token1] = ACTIONS(2887),
    [anon_sym_byte] = ACTIONS(2887),
    [anon_sym_word] = ACTIONS(2887),
    [anon_sym_enum] = ACTIONS(2887),
    [anon_sym_class] = ACTIONS(2887),
    [anon_sym_struct] = ACTIONS(2887),
    [anon_sym_union] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_else] = ACTIONS(2887),
    [anon_sym_switch] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2887),
    [anon_sym_for] = ACTIONS(2887),
    [anon_sym_return] = ACTIONS(2887),
    [anon_sym_break] = ACTIONS(2887),
    [anon_sym_continue] = ACTIONS(2887),
    [anon_sym_goto] = ACTIONS(2887),
    [anon_sym___try] = ACTIONS(2887),
    [anon_sym___leave] = ACTIONS(2887),
    [anon_sym_not] = ACTIONS(2887),
    [anon_sym_compl] = ACTIONS(2887),
    [anon_sym_DASH_DASH] = ACTIONS(2889),
    [anon_sym_PLUS_PLUS] = ACTIONS(2889),
    [anon_sym_sizeof] = ACTIONS(2887),
    [anon_sym___alignof__] = ACTIONS(2887),
    [anon_sym___alignof] = ACTIONS(2887),
    [anon_sym__alignof] = ACTIONS(2887),
    [anon_sym_alignof] = ACTIONS(2887),
    [anon_sym__Alignof] = ACTIONS(2887),
    [anon_sym_offsetof] = ACTIONS(2887),
    [anon_sym__Generic] = ACTIONS(2887),
    [anon_sym_asm] = ACTIONS(2887),
    [anon_sym___asm__] = ACTIONS(2887),
    [aux_sym_number_literal_token1] = ACTIONS(2889),
    [aux_sym_number_literal_token2] = ACTIONS(2887),
    [anon_sym_L_SQUOTE] = ACTIONS(2889),
    [anon_sym_u_SQUOTE] = ACTIONS(2889),
    [anon_sym_U_SQUOTE] = ACTIONS(2889),
    [anon_sym_u8_SQUOTE] = ACTIONS(2889),
    [anon_sym_SQUOTE] = ACTIONS(2889),
    [anon_sym_L_DQUOTE] = ACTIONS(2889),
    [anon_sym_u_DQUOTE] = ACTIONS(2889),
    [anon_sym_U_DQUOTE] = ACTIONS(2889),
    [anon_sym_u8_DQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE] = ACTIONS(2889),
    [sym_true] = ACTIONS(2887),
    [sym_false] = ACTIONS(2887),
    [anon_sym_NULL] = ACTIONS(2887),
    [anon_sym_nullptr] = ACTIONS(2887),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2887),
    [anon_sym_decltype] = ACTIONS(2887),
    [anon_sym_virtual] = ACTIONS(2887),
    [anon_sym_alignas] = ACTIONS(2887),
    [anon_sym_typename] = ACTIONS(2887),
    [anon_sym_template] = ACTIONS(2887),
    [anon_sym_try] = ACTIONS(2887),
    [anon_sym_delete] = ACTIONS(2887),
    [anon_sym_throw] = ACTIONS(2887),
    [anon_sym_co_return] = ACTIONS(2887),
    [anon_sym_co_yield] = ACTIONS(2887),
    [anon_sym_catch] = ACTIONS(2887),
    [anon_sym_R_DQUOTE] = ACTIONS(2889),
    [anon_sym_LR_DQUOTE] = ACTIONS(2889),
    [anon_sym_uR_DQUOTE] = ACTIONS(2889),
    [anon_sym_UR_DQUOTE] = ACTIONS(2889),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2889),
    [anon_sym_co_await] = ACTIONS(2887),
    [anon_sym_new] = ACTIONS(2887),
    [anon_sym_requires] = ACTIONS(2887),
    [sym_this] = ACTIONS(2887),
  },
  [1157] = {
    [sym_else_clause] = STATE(1207),
    [sym_identifier] = ACTIONS(2918),
    [anon_sym_LPAREN2] = ACTIONS(2920),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2920),
    [anon_sym_DASH] = ACTIONS(2918),
    [anon_sym_PLUS] = ACTIONS(2918),
    [anon_sym_STAR] = ACTIONS(2920),
    [anon_sym_AMP] = ACTIONS(2920),
    [anon_sym_SEMI] = ACTIONS(2920),
    [anon_sym___extension__] = ACTIONS(2918),
    [anon_sym_typedef] = ACTIONS(2918),
    [anon_sym_extern] = ACTIONS(2918),
    [anon_sym___attribute__] = ACTIONS(2918),
    [anon_sym_COLON_COLON] = ACTIONS(2920),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2920),
    [anon_sym___declspec] = ACTIONS(2918),
    [anon_sym_LBRACE] = ACTIONS(2920),
    [anon_sym_signed] = ACTIONS(2918),
    [anon_sym_unsigned] = ACTIONS(2918),
    [anon_sym_long] = ACTIONS(2918),
    [anon_sym_short] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(2918),
    [anon_sym_static] = ACTIONS(2918),
    [anon_sym_register] = ACTIONS(2918),
    [anon_sym_inline] = ACTIONS(2918),
    [anon_sym___inline] = ACTIONS(2918),
    [anon_sym___inline__] = ACTIONS(2918),
    [anon_sym___forceinline] = ACTIONS(2918),
    [anon_sym_thread_local] = ACTIONS(2918),
    [anon_sym___thread] = ACTIONS(2918),
    [anon_sym_const] = ACTIONS(2918),
    [anon_sym_constexpr] = ACTIONS(2918),
    [anon_sym_volatile] = ACTIONS(2918),
    [anon_sym_restrict] = ACTIONS(2918),
    [anon_sym___restrict__] = ACTIONS(2918),
    [anon_sym__Atomic] = ACTIONS(2918),
    [anon_sym__Noreturn] = ACTIONS(2918),
    [anon_sym_noreturn] = ACTIONS(2918),
    [anon_sym_mutable] = ACTIONS(2918),
    [anon_sym_constinit] = ACTIONS(2918),
    [anon_sym_consteval] = ACTIONS(2918),
    [anon_sym_PROGMEM] = ACTIONS(2918),
    [aux_sym_primitive_type_token1] = ACTIONS(2918),
    [anon_sym_byte] = ACTIONS(2918),
    [anon_sym_word] = ACTIONS(2918),
    [anon_sym_enum] = ACTIONS(2918),
    [anon_sym_class] = ACTIONS(2918),
    [anon_sym_struct] = ACTIONS(2918),
    [anon_sym_union] = ACTIONS(2918),
    [anon_sym_if] = ACTIONS(2918),
    [anon_sym_else] = ACTIONS(4244),
    [anon_sym_switch] = ACTIONS(2918),
    [anon_sym_while] = ACTIONS(2918),
    [anon_sym_do] = ACTIONS(2918),
    [anon_sym_for] = ACTIONS(2918),
    [anon_sym_return] = ACTIONS(2918),
    [anon_sym_break] = ACTIONS(2918),
    [anon_sym_continue] = ACTIONS(2918),
    [anon_sym_goto] = ACTIONS(2918),
    [anon_sym___try] = ACTIONS(2918),
    [anon_sym___leave] = ACTIONS(2918),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_compl] = ACTIONS(2918),
    [anon_sym_DASH_DASH] = ACTIONS(2920),
    [anon_sym_PLUS_PLUS] = ACTIONS(2920),
    [anon_sym_sizeof] = ACTIONS(2918),
    [anon_sym___alignof__] = ACTIONS(2918),
    [anon_sym___alignof] = ACTIONS(2918),
    [anon_sym__alignof] = ACTIONS(2918),
    [anon_sym_alignof] = ACTIONS(2918),
    [anon_sym__Alignof] = ACTIONS(2918),
    [anon_sym_offsetof] = ACTIONS(2918),
    [anon_sym__Generic] = ACTIONS(2918),
    [anon_sym_asm] = ACTIONS(2918),
    [anon_sym___asm__] = ACTIONS(2918),
    [aux_sym_number_literal_token1] = ACTIONS(2920),
    [aux_sym_number_literal_token2] = ACTIONS(2918),
    [anon_sym_L_SQUOTE] = ACTIONS(2920),
    [anon_sym_u_SQUOTE] = ACTIONS(2920),
    [anon_sym_U_SQUOTE] = ACTIONS(2920),
    [anon_sym_u8_SQUOTE] = ACTIONS(2920),
    [anon_sym_SQUOTE] = ACTIONS(2920),
    [anon_sym_L_DQUOTE] = ACTIONS(2920),
    [anon_sym_u_DQUOTE] = ACTIONS(2920),
    [anon_sym_U_DQUOTE] = ACTIONS(2920),
    [anon_sym_u8_DQUOTE] = ACTIONS(2920),
    [anon_sym_DQUOTE] = ACTIONS(2920),
    [sym_true] = ACTIONS(2918),
    [sym_false] = ACTIONS(2918),
    [anon_sym_NULL] = ACTIONS(2918),
    [anon_sym_nullptr] = ACTIONS(2918),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2918),
    [anon_sym_decltype] = ACTIONS(2918),
    [anon_sym_virtual] = ACTIONS(2918),
    [anon_sym_alignas] = ACTIONS(2918),
    [anon_sym_typename] = ACTIONS(2918),
    [anon_sym_template] = ACTIONS(2918),
    [anon_sym_try] = ACTIONS(2918),
    [anon_sym_delete] = ACTIONS(2918),
    [anon_sym_throw] = ACTIONS(2918),
    [anon_sym_co_return] = ACTIONS(2918),
    [anon_sym_co_yield] = ACTIONS(2918),
    [anon_sym_R_DQUOTE] = ACTIONS(2920),
    [anon_sym_LR_DQUOTE] = ACTIONS(2920),
    [anon_sym_uR_DQUOTE] = ACTIONS(2920),
    [anon_sym_UR_DQUOTE] = ACTIONS(2920),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2920),
    [anon_sym_co_await] = ACTIONS(2918),
    [anon_sym_new] = ACTIONS(2918),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2918),
  },
  [1158] = {
    [sym_identifier] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_BANG] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2265),
    [anon_sym_SEMI] = ACTIONS(2265),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2265),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_else] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_return] = ACTIONS(2267),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_continue] = ACTIONS(2267),
    [anon_sym_goto] = ACTIONS(2267),
    [anon_sym___try] = ACTIONS(2267),
    [anon_sym___leave] = ACTIONS(2267),
    [anon_sym_not] = ACTIONS(2267),
    [anon_sym_compl] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2265),
    [anon_sym_PLUS_PLUS] = ACTIONS(2265),
    [anon_sym_sizeof] = ACTIONS(2267),
    [anon_sym___alignof__] = ACTIONS(2267),
    [anon_sym___alignof] = ACTIONS(2267),
    [anon_sym__alignof] = ACTIONS(2267),
    [anon_sym_alignof] = ACTIONS(2267),
    [anon_sym__Alignof] = ACTIONS(2267),
    [anon_sym_offsetof] = ACTIONS(2267),
    [anon_sym__Generic] = ACTIONS(2267),
    [anon_sym_asm] = ACTIONS(2267),
    [anon_sym___asm__] = ACTIONS(2267),
    [aux_sym_number_literal_token1] = ACTIONS(2265),
    [aux_sym_number_literal_token2] = ACTIONS(2267),
    [anon_sym_L_SQUOTE] = ACTIONS(2265),
    [anon_sym_u_SQUOTE] = ACTIONS(2265),
    [anon_sym_U_SQUOTE] = ACTIONS(2265),
    [anon_sym_u8_SQUOTE] = ACTIONS(2265),
    [anon_sym_SQUOTE] = ACTIONS(2265),
    [anon_sym_L_DQUOTE] = ACTIONS(2265),
    [anon_sym_u_DQUOTE] = ACTIONS(2265),
    [anon_sym_U_DQUOTE] = ACTIONS(2265),
    [anon_sym_u8_DQUOTE] = ACTIONS(2265),
    [anon_sym_DQUOTE] = ACTIONS(2265),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [anon_sym_NULL] = ACTIONS(2267),
    [anon_sym_nullptr] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_try] = ACTIONS(2267),
    [anon_sym_delete] = ACTIONS(2267),
    [anon_sym_throw] = ACTIONS(2267),
    [anon_sym_co_return] = ACTIONS(2267),
    [anon_sym_co_yield] = ACTIONS(2267),
    [anon_sym_catch] = ACTIONS(2267),
    [anon_sym_R_DQUOTE] = ACTIONS(2265),
    [anon_sym_LR_DQUOTE] = ACTIONS(2265),
    [anon_sym_uR_DQUOTE] = ACTIONS(2265),
    [anon_sym_UR_DQUOTE] = ACTIONS(2265),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2265),
    [anon_sym_co_await] = ACTIONS(2267),
    [anon_sym_new] = ACTIONS(2267),
    [anon_sym_requires] = ACTIONS(2267),
    [sym_this] = ACTIONS(2267),
  },
  [1159] = {
    [sym_identifier] = ACTIONS(2223),
    [anon_sym_LPAREN2] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2223),
    [anon_sym_PLUS] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym___extension__] = ACTIONS(2223),
    [anon_sym_typedef] = ACTIONS(2223),
    [anon_sym_extern] = ACTIONS(2223),
    [anon_sym___attribute__] = ACTIONS(2223),
    [anon_sym_COLON_COLON] = ACTIONS(2221),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym___declspec] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_signed] = ACTIONS(2223),
    [anon_sym_unsigned] = ACTIONS(2223),
    [anon_sym_long] = ACTIONS(2223),
    [anon_sym_short] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(2223),
    [anon_sym_static] = ACTIONS(2223),
    [anon_sym_register] = ACTIONS(2223),
    [anon_sym_inline] = ACTIONS(2223),
    [anon_sym___inline] = ACTIONS(2223),
    [anon_sym___inline__] = ACTIONS(2223),
    [anon_sym___forceinline] = ACTIONS(2223),
    [anon_sym_thread_local] = ACTIONS(2223),
    [anon_sym___thread] = ACTIONS(2223),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_constexpr] = ACTIONS(2223),
    [anon_sym_volatile] = ACTIONS(2223),
    [anon_sym_restrict] = ACTIONS(2223),
    [anon_sym___restrict__] = ACTIONS(2223),
    [anon_sym__Atomic] = ACTIONS(2223),
    [anon_sym__Noreturn] = ACTIONS(2223),
    [anon_sym_noreturn] = ACTIONS(2223),
    [anon_sym_mutable] = ACTIONS(2223),
    [anon_sym_constinit] = ACTIONS(2223),
    [anon_sym_consteval] = ACTIONS(2223),
    [anon_sym_PROGMEM] = ACTIONS(2223),
    [aux_sym_primitive_type_token1] = ACTIONS(2223),
    [anon_sym_byte] = ACTIONS(2223),
    [anon_sym_word] = ACTIONS(2223),
    [anon_sym_enum] = ACTIONS(2223),
    [anon_sym_class] = ACTIONS(2223),
    [anon_sym_struct] = ACTIONS(2223),
    [anon_sym_union] = ACTIONS(2223),
    [anon_sym_if] = ACTIONS(2223),
    [anon_sym_else] = ACTIONS(2223),
    [anon_sym_switch] = ACTIONS(2223),
    [anon_sym_while] = ACTIONS(2223),
    [anon_sym_do] = ACTIONS(2223),
    [anon_sym_for] = ACTIONS(2223),
    [anon_sym_return] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2223),
    [anon_sym_continue] = ACTIONS(2223),
    [anon_sym_goto] = ACTIONS(2223),
    [anon_sym___try] = ACTIONS(2223),
    [anon_sym___leave] = ACTIONS(2223),
    [anon_sym_not] = ACTIONS(2223),
    [anon_sym_compl] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_sizeof] = ACTIONS(2223),
    [anon_sym___alignof__] = ACTIONS(2223),
    [anon_sym___alignof] = ACTIONS(2223),
    [anon_sym__alignof] = ACTIONS(2223),
    [anon_sym_alignof] = ACTIONS(2223),
    [anon_sym__Alignof] = ACTIONS(2223),
    [anon_sym_offsetof] = ACTIONS(2223),
    [anon_sym__Generic] = ACTIONS(2223),
    [anon_sym_asm] = ACTIONS(2223),
    [anon_sym___asm__] = ACTIONS(2223),
    [aux_sym_number_literal_token1] = ACTIONS(2221),
    [aux_sym_number_literal_token2] = ACTIONS(2223),
    [anon_sym_L_SQUOTE] = ACTIONS(2221),
    [anon_sym_u_SQUOTE] = ACTIONS(2221),
    [anon_sym_U_SQUOTE] = ACTIONS(2221),
    [anon_sym_u8_SQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_L_DQUOTE] = ACTIONS(2221),
    [anon_sym_u_DQUOTE] = ACTIONS(2221),
    [anon_sym_U_DQUOTE] = ACTIONS(2221),
    [anon_sym_u8_DQUOTE] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [sym_true] = ACTIONS(2223),
    [sym_false] = ACTIONS(2223),
    [anon_sym_NULL] = ACTIONS(2223),
    [anon_sym_nullptr] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2223),
    [anon_sym_decltype] = ACTIONS(2223),
    [anon_sym_virtual] = ACTIONS(2223),
    [anon_sym_alignas] = ACTIONS(2223),
    [anon_sym_typename] = ACTIONS(2223),
    [anon_sym_template] = ACTIONS(2223),
    [anon_sym_try] = ACTIONS(2223),
    [anon_sym_delete] = ACTIONS(2223),
    [anon_sym_throw] = ACTIONS(2223),
    [anon_sym_co_return] = ACTIONS(2223),
    [anon_sym_co_yield] = ACTIONS(2223),
    [anon_sym_catch] = ACTIONS(2223),
    [anon_sym_R_DQUOTE] = ACTIONS(2221),
    [anon_sym_LR_DQUOTE] = ACTIONS(2221),
    [anon_sym_uR_DQUOTE] = ACTIONS(2221),
    [anon_sym_UR_DQUOTE] = ACTIONS(2221),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2221),
    [anon_sym_co_await] = ACTIONS(2223),
    [anon_sym_new] = ACTIONS(2223),
    [anon_sym_requires] = ACTIONS(2223),
    [sym_this] = ACTIONS(2223),
  },
  [1160] = {
    [sym_identifier] = ACTIONS(2927),
    [anon_sym_LPAREN2] = ACTIONS(2932),
    [anon_sym_BANG] = ACTIONS(2932),
    [anon_sym_TILDE] = ACTIONS(2932),
    [anon_sym_DASH] = ACTIONS(2927),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2932),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym___extension__] = ACTIONS(2927),
    [anon_sym_typedef] = ACTIONS(2927),
    [anon_sym_extern] = ACTIONS(2927),
    [anon_sym___attribute__] = ACTIONS(2927),
    [anon_sym_COLON_COLON] = ACTIONS(2932),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2932),
    [anon_sym___declspec] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2932),
    [anon_sym_signed] = ACTIONS(2927),
    [anon_sym_unsigned] = ACTIONS(2927),
    [anon_sym_long] = ACTIONS(2927),
    [anon_sym_short] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_static] = ACTIONS(2927),
    [anon_sym_register] = ACTIONS(2927),
    [anon_sym_inline] = ACTIONS(2927),
    [anon_sym___inline] = ACTIONS(2927),
    [anon_sym___inline__] = ACTIONS(2927),
    [anon_sym___forceinline] = ACTIONS(2927),
    [anon_sym_thread_local] = ACTIONS(2927),
    [anon_sym___thread] = ACTIONS(2927),
    [anon_sym_const] = ACTIONS(2927),
    [anon_sym_constexpr] = ACTIONS(2927),
    [anon_sym_volatile] = ACTIONS(2927),
    [anon_sym_restrict] = ACTIONS(2927),
    [anon_sym___restrict__] = ACTIONS(2927),
    [anon_sym__Atomic] = ACTIONS(2927),
    [anon_sym__Noreturn] = ACTIONS(2927),
    [anon_sym_noreturn] = ACTIONS(2927),
    [anon_sym_mutable] = ACTIONS(2927),
    [anon_sym_constinit] = ACTIONS(2927),
    [anon_sym_consteval] = ACTIONS(2927),
    [anon_sym_PROGMEM] = ACTIONS(2927),
    [aux_sym_primitive_type_token1] = ACTIONS(2927),
    [anon_sym_byte] = ACTIONS(2927),
    [anon_sym_word] = ACTIONS(2927),
    [anon_sym_enum] = ACTIONS(2927),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_struct] = ACTIONS(2927),
    [anon_sym_union] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_else] = ACTIONS(2927),
    [anon_sym_switch] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_goto] = ACTIONS(2927),
    [anon_sym___try] = ACTIONS(2927),
    [anon_sym___leave] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2927),
    [anon_sym_compl] = ACTIONS(2927),
    [anon_sym_DASH_DASH] = ACTIONS(2932),
    [anon_sym_PLUS_PLUS] = ACTIONS(2932),
    [anon_sym_sizeof] = ACTIONS(2927),
    [anon_sym___alignof__] = ACTIONS(2927),
    [anon_sym___alignof] = ACTIONS(2927),
    [anon_sym__alignof] = ACTIONS(2927),
    [anon_sym_alignof] = ACTIONS(2927),
    [anon_sym__Alignof] = ACTIONS(2927),
    [anon_sym_offsetof] = ACTIONS(2927),
    [anon_sym__Generic] = ACTIONS(2927),
    [anon_sym_asm] = ACTIONS(2927),
    [anon_sym___asm__] = ACTIONS(2927),
    [aux_sym_number_literal_token1] = ACTIONS(2932),
    [aux_sym_number_literal_token2] = ACTIONS(2927),
    [anon_sym_L_SQUOTE] = ACTIONS(2932),
    [anon_sym_u_SQUOTE] = ACTIONS(2932),
    [anon_sym_U_SQUOTE] = ACTIONS(2932),
    [anon_sym_u8_SQUOTE] = ACTIONS(2932),
    [anon_sym_SQUOTE] = ACTIONS(2932),
    [anon_sym_L_DQUOTE] = ACTIONS(2932),
    [anon_sym_u_DQUOTE] = ACTIONS(2932),
    [anon_sym_U_DQUOTE] = ACTIONS(2932),
    [anon_sym_u8_DQUOTE] = ACTIONS(2932),
    [anon_sym_DQUOTE] = ACTIONS(2932),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [anon_sym_NULL] = ACTIONS(2927),
    [anon_sym_nullptr] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2927),
    [anon_sym_decltype] = ACTIONS(2927),
    [anon_sym_virtual] = ACTIONS(2927),
    [anon_sym_alignas] = ACTIONS(2927),
    [anon_sym_typename] = ACTIONS(2927),
    [anon_sym_template] = ACTIONS(2927),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_throw] = ACTIONS(2927),
    [anon_sym_co_return] = ACTIONS(2927),
    [anon_sym_co_yield] = ACTIONS(2927),
    [anon_sym_R_DQUOTE] = ACTIONS(2932),
    [anon_sym_LR_DQUOTE] = ACTIONS(2932),
    [anon_sym_uR_DQUOTE] = ACTIONS(2932),
    [anon_sym_UR_DQUOTE] = ACTIONS(2932),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2932),
    [anon_sym_co_await] = ACTIONS(2927),
    [anon_sym_new] = ACTIONS(2927),
    [anon_sym_requires] = ACTIONS(2927),
    [sym_this] = ACTIONS(2927),
  },
  [1161] = {
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [1162] = {
    [sym_identifier] = ACTIONS(3046),
    [anon_sym_LPAREN2] = ACTIONS(3048),
    [anon_sym_BANG] = ACTIONS(3048),
    [anon_sym_TILDE] = ACTIONS(3048),
    [anon_sym_DASH] = ACTIONS(3046),
    [anon_sym_PLUS] = ACTIONS(3046),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym___extension__] = ACTIONS(3046),
    [anon_sym_typedef] = ACTIONS(3046),
    [anon_sym_extern] = ACTIONS(3046),
    [anon_sym___attribute__] = ACTIONS(3046),
    [anon_sym_COLON_COLON] = ACTIONS(3048),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3048),
    [anon_sym___declspec] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3048),
    [anon_sym_signed] = ACTIONS(3046),
    [anon_sym_unsigned] = ACTIONS(3046),
    [anon_sym_long] = ACTIONS(3046),
    [anon_sym_short] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_static] = ACTIONS(3046),
    [anon_sym_register] = ACTIONS(3046),
    [anon_sym_inline] = ACTIONS(3046),
    [anon_sym___inline] = ACTIONS(3046),
    [anon_sym___inline__] = ACTIONS(3046),
    [anon_sym___forceinline] = ACTIONS(3046),
    [anon_sym_thread_local] = ACTIONS(3046),
    [anon_sym___thread] = ACTIONS(3046),
    [anon_sym_const] = ACTIONS(3046),
    [anon_sym_constexpr] = ACTIONS(3046),
    [anon_sym_volatile] = ACTIONS(3046),
    [anon_sym_restrict] = ACTIONS(3046),
    [anon_sym___restrict__] = ACTIONS(3046),
    [anon_sym__Atomic] = ACTIONS(3046),
    [anon_sym__Noreturn] = ACTIONS(3046),
    [anon_sym_noreturn] = ACTIONS(3046),
    [anon_sym_mutable] = ACTIONS(3046),
    [anon_sym_constinit] = ACTIONS(3046),
    [anon_sym_consteval] = ACTIONS(3046),
    [anon_sym_PROGMEM] = ACTIONS(3046),
    [aux_sym_primitive_type_token1] = ACTIONS(3046),
    [anon_sym_byte] = ACTIONS(3046),
    [anon_sym_word] = ACTIONS(3046),
    [anon_sym_enum] = ACTIONS(3046),
    [anon_sym_class] = ACTIONS(3046),
    [anon_sym_struct] = ACTIONS(3046),
    [anon_sym_union] = ACTIONS(3046),
    [anon_sym_if] = ACTIONS(3046),
    [anon_sym_else] = ACTIONS(3046),
    [anon_sym_switch] = ACTIONS(3046),
    [anon_sym_while] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_for] = ACTIONS(3046),
    [anon_sym_return] = ACTIONS(3046),
    [anon_sym_break] = ACTIONS(3046),
    [anon_sym_continue] = ACTIONS(3046),
    [anon_sym_goto] = ACTIONS(3046),
    [anon_sym___try] = ACTIONS(3046),
    [anon_sym___leave] = ACTIONS(3046),
    [anon_sym_not] = ACTIONS(3046),
    [anon_sym_compl] = ACTIONS(3046),
    [anon_sym_DASH_DASH] = ACTIONS(3048),
    [anon_sym_PLUS_PLUS] = ACTIONS(3048),
    [anon_sym_sizeof] = ACTIONS(3046),
    [anon_sym___alignof__] = ACTIONS(3046),
    [anon_sym___alignof] = ACTIONS(3046),
    [anon_sym__alignof] = ACTIONS(3046),
    [anon_sym_alignof] = ACTIONS(3046),
    [anon_sym__Alignof] = ACTIONS(3046),
    [anon_sym_offsetof] = ACTIONS(3046),
    [anon_sym__Generic] = ACTIONS(3046),
    [anon_sym_asm] = ACTIONS(3046),
    [anon_sym___asm__] = ACTIONS(3046),
    [aux_sym_number_literal_token1] = ACTIONS(3048),
    [aux_sym_number_literal_token2] = ACTIONS(3046),
    [anon_sym_L_SQUOTE] = ACTIONS(3048),
    [anon_sym_u_SQUOTE] = ACTIONS(3048),
    [anon_sym_U_SQUOTE] = ACTIONS(3048),
    [anon_sym_u8_SQUOTE] = ACTIONS(3048),
    [anon_sym_SQUOTE] = ACTIONS(3048),
    [anon_sym_L_DQUOTE] = ACTIONS(3048),
    [anon_sym_u_DQUOTE] = ACTIONS(3048),
    [anon_sym_U_DQUOTE] = ACTIONS(3048),
    [anon_sym_u8_DQUOTE] = ACTIONS(3048),
    [anon_sym_DQUOTE] = ACTIONS(3048),
    [sym_true] = ACTIONS(3046),
    [sym_false] = ACTIONS(3046),
    [anon_sym_NULL] = ACTIONS(3046),
    [anon_sym_nullptr] = ACTIONS(3046),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3046),
    [anon_sym_decltype] = ACTIONS(3046),
    [anon_sym_virtual] = ACTIONS(3046),
    [anon_sym_alignas] = ACTIONS(3046),
    [anon_sym_typename] = ACTIONS(3046),
    [anon_sym_template] = ACTIONS(3046),
    [anon_sym_try] = ACTIONS(3046),
    [anon_sym_delete] = ACTIONS(3046),
    [anon_sym_throw] = ACTIONS(3046),
    [anon_sym_co_return] = ACTIONS(3046),
    [anon_sym_co_yield] = ACTIONS(3046),
    [anon_sym_R_DQUOTE] = ACTIONS(3048),
    [anon_sym_LR_DQUOTE] = ACTIONS(3048),
    [anon_sym_uR_DQUOTE] = ACTIONS(3048),
    [anon_sym_UR_DQUOTE] = ACTIONS(3048),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3048),
    [anon_sym_co_await] = ACTIONS(3046),
    [anon_sym_new] = ACTIONS(3046),
    [anon_sym_requires] = ACTIONS(3046),
    [sym_this] = ACTIONS(3046),
  },
  [1163] = {
    [sym_identifier] = ACTIONS(4125),
    [anon_sym_LPAREN2] = ACTIONS(4127),
    [anon_sym_BANG] = ACTIONS(4127),
    [anon_sym_TILDE] = ACTIONS(4127),
    [anon_sym_DASH] = ACTIONS(4125),
    [anon_sym_PLUS] = ACTIONS(4125),
    [anon_sym_STAR] = ACTIONS(4127),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym___extension__] = ACTIONS(4125),
    [anon_sym_extern] = ACTIONS(4125),
    [anon_sym___attribute__] = ACTIONS(4125),
    [anon_sym_COLON_COLON] = ACTIONS(4127),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4127),
    [anon_sym___declspec] = ACTIONS(4125),
    [anon_sym_LBRACE] = ACTIONS(4127),
    [anon_sym_signed] = ACTIONS(4125),
    [anon_sym_unsigned] = ACTIONS(4125),
    [anon_sym_long] = ACTIONS(4125),
    [anon_sym_short] = ACTIONS(4125),
    [anon_sym_LBRACK] = ACTIONS(4125),
    [anon_sym_static] = ACTIONS(4125),
    [anon_sym_register] = ACTIONS(4125),
    [anon_sym_inline] = ACTIONS(4125),
    [anon_sym___inline] = ACTIONS(4125),
    [anon_sym___inline__] = ACTIONS(4125),
    [anon_sym___forceinline] = ACTIONS(4125),
    [anon_sym_thread_local] = ACTIONS(4125),
    [anon_sym___thread] = ACTIONS(4125),
    [anon_sym_const] = ACTIONS(4125),
    [anon_sym_constexpr] = ACTIONS(4125),
    [anon_sym_volatile] = ACTIONS(4125),
    [anon_sym_restrict] = ACTIONS(4125),
    [anon_sym___restrict__] = ACTIONS(4125),
    [anon_sym__Atomic] = ACTIONS(4125),
    [anon_sym__Noreturn] = ACTIONS(4125),
    [anon_sym_noreturn] = ACTIONS(4125),
    [anon_sym_mutable] = ACTIONS(4125),
    [anon_sym_constinit] = ACTIONS(4125),
    [anon_sym_consteval] = ACTIONS(4125),
    [anon_sym_PROGMEM] = ACTIONS(4125),
    [aux_sym_primitive_type_token1] = ACTIONS(4125),
    [anon_sym_byte] = ACTIONS(4125),
    [anon_sym_word] = ACTIONS(4125),
    [anon_sym_enum] = ACTIONS(4125),
    [anon_sym_class] = ACTIONS(4125),
    [anon_sym_struct] = ACTIONS(4125),
    [anon_sym_union] = ACTIONS(4125),
    [anon_sym_if] = ACTIONS(4125),
    [anon_sym_switch] = ACTIONS(4125),
    [anon_sym_case] = ACTIONS(4125),
    [anon_sym_default] = ACTIONS(4125),
    [anon_sym_while] = ACTIONS(4125),
    [anon_sym_do] = ACTIONS(4125),
    [anon_sym_for] = ACTIONS(4125),
    [anon_sym_return] = ACTIONS(4125),
    [anon_sym_break] = ACTIONS(4125),
    [anon_sym_continue] = ACTIONS(4125),
    [anon_sym_goto] = ACTIONS(4125),
    [anon_sym___try] = ACTIONS(4125),
    [anon_sym___leave] = ACTIONS(4125),
    [anon_sym_not] = ACTIONS(4125),
    [anon_sym_compl] = ACTIONS(4125),
    [anon_sym_DASH_DASH] = ACTIONS(4127),
    [anon_sym_PLUS_PLUS] = ACTIONS(4127),
    [anon_sym_sizeof] = ACTIONS(4125),
    [anon_sym___alignof__] = ACTIONS(4125),
    [anon_sym___alignof] = ACTIONS(4125),
    [anon_sym__alignof] = ACTIONS(4125),
    [anon_sym_alignof] = ACTIONS(4125),
    [anon_sym__Alignof] = ACTIONS(4125),
    [anon_sym_offsetof] = ACTIONS(4125),
    [anon_sym__Generic] = ACTIONS(4125),
    [anon_sym_asm] = ACTIONS(4125),
    [anon_sym___asm__] = ACTIONS(4125),
    [aux_sym_number_literal_token1] = ACTIONS(4127),
    [aux_sym_number_literal_token2] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4127),
    [anon_sym_u_DQUOTE] = ACTIONS(4127),
    [anon_sym_U_DQUOTE] = ACTIONS(4127),
    [anon_sym_u8_DQUOTE] = ACTIONS(4127),
    [anon_sym_DQUOTE] = ACTIONS(4127),
    [sym_true] = ACTIONS(4125),
    [sym_false] = ACTIONS(4125),
    [anon_sym_NULL] = ACTIONS(4125),
    [anon_sym_nullptr] = ACTIONS(4125),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4125),
    [anon_sym_decltype] = ACTIONS(4125),
    [anon_sym_virtual] = ACTIONS(4125),
    [anon_sym_alignas] = ACTIONS(4125),
    [anon_sym_typename] = ACTIONS(4125),
    [anon_sym_template] = ACTIONS(4125),
    [anon_sym_try] = ACTIONS(4125),
    [anon_sym_delete] = ACTIONS(4125),
    [anon_sym_throw] = ACTIONS(4125),
    [anon_sym_co_return] = ACTIONS(4125),
    [anon_sym_co_yield] = ACTIONS(4125),
    [anon_sym_R_DQUOTE] = ACTIONS(4127),
    [anon_sym_LR_DQUOTE] = ACTIONS(4127),
    [anon_sym_uR_DQUOTE] = ACTIONS(4127),
    [anon_sym_UR_DQUOTE] = ACTIONS(4127),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4127),
    [anon_sym_co_await] = ACTIONS(4125),
    [anon_sym_new] = ACTIONS(4125),
    [anon_sym_requires] = ACTIONS(4125),
    [sym_this] = ACTIONS(4125),
  },
  [1164] = {
    [sym_identifier] = ACTIONS(3144),
    [anon_sym_LPAREN2] = ACTIONS(3146),
    [anon_sym_BANG] = ACTIONS(3146),
    [anon_sym_TILDE] = ACTIONS(3146),
    [anon_sym_DASH] = ACTIONS(3144),
    [anon_sym_PLUS] = ACTIONS(3144),
    [anon_sym_STAR] = ACTIONS(3146),
    [anon_sym_AMP] = ACTIONS(3146),
    [anon_sym_SEMI] = ACTIONS(3146),
    [anon_sym___extension__] = ACTIONS(3144),
    [anon_sym_typedef] = ACTIONS(3144),
    [anon_sym_extern] = ACTIONS(3144),
    [anon_sym___attribute__] = ACTIONS(3144),
    [anon_sym_COLON_COLON] = ACTIONS(3146),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3146),
    [anon_sym___declspec] = ACTIONS(3144),
    [anon_sym_LBRACE] = ACTIONS(3146),
    [anon_sym_signed] = ACTIONS(3144),
    [anon_sym_unsigned] = ACTIONS(3144),
    [anon_sym_long] = ACTIONS(3144),
    [anon_sym_short] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3144),
    [anon_sym_static] = ACTIONS(3144),
    [anon_sym_register] = ACTIONS(3144),
    [anon_sym_inline] = ACTIONS(3144),
    [anon_sym___inline] = ACTIONS(3144),
    [anon_sym___inline__] = ACTIONS(3144),
    [anon_sym___forceinline] = ACTIONS(3144),
    [anon_sym_thread_local] = ACTIONS(3144),
    [anon_sym___thread] = ACTIONS(3144),
    [anon_sym_const] = ACTIONS(3144),
    [anon_sym_constexpr] = ACTIONS(3144),
    [anon_sym_volatile] = ACTIONS(3144),
    [anon_sym_restrict] = ACTIONS(3144),
    [anon_sym___restrict__] = ACTIONS(3144),
    [anon_sym__Atomic] = ACTIONS(3144),
    [anon_sym__Noreturn] = ACTIONS(3144),
    [anon_sym_noreturn] = ACTIONS(3144),
    [anon_sym_mutable] = ACTIONS(3144),
    [anon_sym_constinit] = ACTIONS(3144),
    [anon_sym_consteval] = ACTIONS(3144),
    [anon_sym_PROGMEM] = ACTIONS(3144),
    [aux_sym_primitive_type_token1] = ACTIONS(3144),
    [anon_sym_byte] = ACTIONS(3144),
    [anon_sym_word] = ACTIONS(3144),
    [anon_sym_enum] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_struct] = ACTIONS(3144),
    [anon_sym_union] = ACTIONS(3144),
    [anon_sym_if] = ACTIONS(3144),
    [anon_sym_else] = ACTIONS(3144),
    [anon_sym_switch] = ACTIONS(3144),
    [anon_sym_while] = ACTIONS(3144),
    [anon_sym_do] = ACTIONS(3144),
    [anon_sym_for] = ACTIONS(3144),
    [anon_sym_return] = ACTIONS(3144),
    [anon_sym_break] = ACTIONS(3144),
    [anon_sym_continue] = ACTIONS(3144),
    [anon_sym_goto] = ACTIONS(3144),
    [anon_sym___try] = ACTIONS(3144),
    [anon_sym___leave] = ACTIONS(3144),
    [anon_sym_not] = ACTIONS(3144),
    [anon_sym_compl] = ACTIONS(3144),
    [anon_sym_DASH_DASH] = ACTIONS(3146),
    [anon_sym_PLUS_PLUS] = ACTIONS(3146),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3144),
    [anon_sym___alignof] = ACTIONS(3144),
    [anon_sym__alignof] = ACTIONS(3144),
    [anon_sym_alignof] = ACTIONS(3144),
    [anon_sym__Alignof] = ACTIONS(3144),
    [anon_sym_offsetof] = ACTIONS(3144),
    [anon_sym__Generic] = ACTIONS(3144),
    [anon_sym_asm] = ACTIONS(3144),
    [anon_sym___asm__] = ACTIONS(3144),
    [aux_sym_number_literal_token1] = ACTIONS(3146),
    [aux_sym_number_literal_token2] = ACTIONS(3144),
    [anon_sym_L_SQUOTE] = ACTIONS(3146),
    [anon_sym_u_SQUOTE] = ACTIONS(3146),
    [anon_sym_U_SQUOTE] = ACTIONS(3146),
    [anon_sym_u8_SQUOTE] = ACTIONS(3146),
    [anon_sym_SQUOTE] = ACTIONS(3146),
    [anon_sym_L_DQUOTE] = ACTIONS(3146),
    [anon_sym_u_DQUOTE] = ACTIONS(3146),
    [anon_sym_U_DQUOTE] = ACTIONS(3146),
    [anon_sym_u8_DQUOTE] = ACTIONS(3146),
    [anon_sym_DQUOTE] = ACTIONS(3146),
    [sym_true] = ACTIONS(3144),
    [sym_false] = ACTIONS(3144),
    [anon_sym_NULL] = ACTIONS(3144),
    [anon_sym_nullptr] = ACTIONS(3144),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3144),
    [anon_sym_decltype] = ACTIONS(3144),
    [anon_sym_virtual] = ACTIONS(3144),
    [anon_sym_alignas] = ACTIONS(3144),
    [anon_sym_typename] = ACTIONS(3144),
    [anon_sym_template] = ACTIONS(3144),
    [anon_sym_try] = ACTIONS(3144),
    [anon_sym_delete] = ACTIONS(3144),
    [anon_sym_throw] = ACTIONS(3144),
    [anon_sym_co_return] = ACTIONS(3144),
    [anon_sym_co_yield] = ACTIONS(3144),
    [anon_sym_R_DQUOTE] = ACTIONS(3146),
    [anon_sym_LR_DQUOTE] = ACTIONS(3146),
    [anon_sym_uR_DQUOTE] = ACTIONS(3146),
    [anon_sym_UR_DQUOTE] = ACTIONS(3146),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3146),
    [anon_sym_co_await] = ACTIONS(3144),
    [anon_sym_new] = ACTIONS(3144),
    [anon_sym_requires] = ACTIONS(3144),
    [sym_this] = ACTIONS(3144),
  },
  [1165] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(2035),
    [sym_raw_string_literal] = STATE(3057),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3184),
    [sym_identifier] = ACTIONS(4246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4250),
    [anon_sym_TILDE] = ACTIONS(4254),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4258),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4261),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4258),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(4264),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4261),
    [anon_sym___extension__] = ACTIONS(4246),
    [anon_sym_extern] = ACTIONS(4246),
    [anon_sym___attribute__] = ACTIONS(4246),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4269),
    [anon_sym___declspec] = ACTIONS(4246),
    [anon_sym___based] = ACTIONS(4246),
    [anon_sym___cdecl] = ACTIONS(4246),
    [anon_sym___clrcall] = ACTIONS(4246),
    [anon_sym___stdcall] = ACTIONS(4246),
    [anon_sym___fastcall] = ACTIONS(4246),
    [anon_sym___thiscall] = ACTIONS(4246),
    [anon_sym___vectorcall] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_signed] = ACTIONS(4274),
    [anon_sym_unsigned] = ACTIONS(4274),
    [anon_sym_long] = ACTIONS(4274),
    [anon_sym_short] = ACTIONS(4274),
    [anon_sym_LBRACK] = ACTIONS(4276),
    [anon_sym_EQ] = ACTIONS(4280),
    [anon_sym_static] = ACTIONS(4246),
    [anon_sym_register] = ACTIONS(4246),
    [anon_sym_inline] = ACTIONS(4246),
    [anon_sym___inline] = ACTIONS(4246),
    [anon_sym___inline__] = ACTIONS(4246),
    [anon_sym___forceinline] = ACTIONS(4246),
    [anon_sym_thread_local] = ACTIONS(4246),
    [anon_sym___thread] = ACTIONS(4246),
    [anon_sym_const] = ACTIONS(4246),
    [anon_sym_constexpr] = ACTIONS(4246),
    [anon_sym_volatile] = ACTIONS(4246),
    [anon_sym_restrict] = ACTIONS(4246),
    [anon_sym___restrict__] = ACTIONS(4246),
    [anon_sym__Atomic] = ACTIONS(4246),
    [anon_sym__Noreturn] = ACTIONS(4246),
    [anon_sym_noreturn] = ACTIONS(4246),
    [anon_sym_mutable] = ACTIONS(4246),
    [anon_sym_constinit] = ACTIONS(4246),
    [anon_sym_consteval] = ACTIONS(4246),
    [anon_sym_PROGMEM] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_and_eq] = ACTIONS(4280),
    [anon_sym_or_eq] = ACTIONS(4280),
    [anon_sym_xor_eq] = ACTIONS(4280),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4256),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4256),
    [anon_sym_not_eq] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4246),
    [anon_sym_decltype] = ACTIONS(4246),
    [anon_sym_virtual] = ACTIONS(4246),
    [anon_sym_alignas] = ACTIONS(4246),
    [anon_sym_template] = ACTIONS(4246),
    [anon_sym_operator] = ACTIONS(4246),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [1166] = {
    [sym_identifier] = ACTIONS(2869),
    [anon_sym_LPAREN2] = ACTIONS(2874),
    [anon_sym_BANG] = ACTIONS(2874),
    [anon_sym_TILDE] = ACTIONS(2874),
    [anon_sym_DASH] = ACTIONS(2869),
    [anon_sym_PLUS] = ACTIONS(2869),
    [anon_sym_STAR] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym___extension__] = ACTIONS(2869),
    [anon_sym_typedef] = ACTIONS(2869),
    [anon_sym_extern] = ACTIONS(2869),
    [anon_sym___attribute__] = ACTIONS(2869),
    [anon_sym_COLON_COLON] = ACTIONS(2874),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2874),
    [anon_sym___declspec] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2874),
    [anon_sym_signed] = ACTIONS(2869),
    [anon_sym_unsigned] = ACTIONS(2869),
    [anon_sym_long] = ACTIONS(2869),
    [anon_sym_short] = ACTIONS(2869),
    [anon_sym_LBRACK] = ACTIONS(2869),
    [anon_sym_static] = ACTIONS(2869),
    [anon_sym_register] = ACTIONS(2869),
    [anon_sym_inline] = ACTIONS(2869),
    [anon_sym___inline] = ACTIONS(2869),
    [anon_sym___inline__] = ACTIONS(2869),
    [anon_sym___forceinline] = ACTIONS(2869),
    [anon_sym_thread_local] = ACTIONS(2869),
    [anon_sym___thread] = ACTIONS(2869),
    [anon_sym_const] = ACTIONS(2869),
    [anon_sym_constexpr] = ACTIONS(2869),
    [anon_sym_volatile] = ACTIONS(2869),
    [anon_sym_restrict] = ACTIONS(2869),
    [anon_sym___restrict__] = ACTIONS(2869),
    [anon_sym__Atomic] = ACTIONS(2869),
    [anon_sym__Noreturn] = ACTIONS(2869),
    [anon_sym_noreturn] = ACTIONS(2869),
    [anon_sym_mutable] = ACTIONS(2869),
    [anon_sym_constinit] = ACTIONS(2869),
    [anon_sym_consteval] = ACTIONS(2869),
    [anon_sym_PROGMEM] = ACTIONS(2869),
    [aux_sym_primitive_type_token1] = ACTIONS(2869),
    [anon_sym_byte] = ACTIONS(2869),
    [anon_sym_word] = ACTIONS(2869),
    [anon_sym_enum] = ACTIONS(2869),
    [anon_sym_class] = ACTIONS(2869),
    [anon_sym_struct] = ACTIONS(2869),
    [anon_sym_union] = ACTIONS(2869),
    [anon_sym_if] = ACTIONS(2869),
    [anon_sym_else] = ACTIONS(2869),
    [anon_sym_switch] = ACTIONS(2869),
    [anon_sym_while] = ACTIONS(2869),
    [anon_sym_do] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2869),
    [anon_sym_return] = ACTIONS(2869),
    [anon_sym_break] = ACTIONS(2869),
    [anon_sym_continue] = ACTIONS(2869),
    [anon_sym_goto] = ACTIONS(2869),
    [anon_sym___try] = ACTIONS(2869),
    [anon_sym___leave] = ACTIONS(2869),
    [anon_sym_not] = ACTIONS(2869),
    [anon_sym_compl] = ACTIONS(2869),
    [anon_sym_DASH_DASH] = ACTIONS(2874),
    [anon_sym_PLUS_PLUS] = ACTIONS(2874),
    [anon_sym_sizeof] = ACTIONS(2869),
    [anon_sym___alignof__] = ACTIONS(2869),
    [anon_sym___alignof] = ACTIONS(2869),
    [anon_sym__alignof] = ACTIONS(2869),
    [anon_sym_alignof] = ACTIONS(2869),
    [anon_sym__Alignof] = ACTIONS(2869),
    [anon_sym_offsetof] = ACTIONS(2869),
    [anon_sym__Generic] = ACTIONS(2869),
    [anon_sym_asm] = ACTIONS(2869),
    [anon_sym___asm__] = ACTIONS(2869),
    [aux_sym_number_literal_token1] = ACTIONS(2874),
    [aux_sym_number_literal_token2] = ACTIONS(2869),
    [anon_sym_L_SQUOTE] = ACTIONS(2874),
    [anon_sym_u_SQUOTE] = ACTIONS(2874),
    [anon_sym_U_SQUOTE] = ACTIONS(2874),
    [anon_sym_u8_SQUOTE] = ACTIONS(2874),
    [anon_sym_SQUOTE] = ACTIONS(2874),
    [anon_sym_L_DQUOTE] = ACTIONS(2874),
    [anon_sym_u_DQUOTE] = ACTIONS(2874),
    [anon_sym_U_DQUOTE] = ACTIONS(2874),
    [anon_sym_u8_DQUOTE] = ACTIONS(2874),
    [anon_sym_DQUOTE] = ACTIONS(2874),
    [sym_true] = ACTIONS(2869),
    [sym_false] = ACTIONS(2869),
    [anon_sym_NULL] = ACTIONS(2869),
    [anon_sym_nullptr] = ACTIONS(2869),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2869),
    [anon_sym_decltype] = ACTIONS(2869),
    [anon_sym_virtual] = ACTIONS(2869),
    [anon_sym_alignas] = ACTIONS(2869),
    [anon_sym_typename] = ACTIONS(2869),
    [anon_sym_template] = ACTIONS(2869),
    [anon_sym_try] = ACTIONS(2869),
    [anon_sym_delete] = ACTIONS(2869),
    [anon_sym_throw] = ACTIONS(2869),
    [anon_sym_co_return] = ACTIONS(2869),
    [anon_sym_co_yield] = ACTIONS(2869),
    [anon_sym_R_DQUOTE] = ACTIONS(2874),
    [anon_sym_LR_DQUOTE] = ACTIONS(2874),
    [anon_sym_uR_DQUOTE] = ACTIONS(2874),
    [anon_sym_UR_DQUOTE] = ACTIONS(2874),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2874),
    [anon_sym_co_await] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2869),
    [sym_this] = ACTIONS(2869),
  },
  [1167] = {
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_BANG] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2972),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym___extension__] = ACTIONS(2970),
    [anon_sym_typedef] = ACTIONS(2970),
    [anon_sym_extern] = ACTIONS(2970),
    [anon_sym___attribute__] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2970),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_signed] = ACTIONS(2970),
    [anon_sym_unsigned] = ACTIONS(2970),
    [anon_sym_long] = ACTIONS(2970),
    [anon_sym_short] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_register] = ACTIONS(2970),
    [anon_sym_inline] = ACTIONS(2970),
    [anon_sym___inline] = ACTIONS(2970),
    [anon_sym___inline__] = ACTIONS(2970),
    [anon_sym___forceinline] = ACTIONS(2970),
    [anon_sym_thread_local] = ACTIONS(2970),
    [anon_sym___thread] = ACTIONS(2970),
    [anon_sym_const] = ACTIONS(2970),
    [anon_sym_constexpr] = ACTIONS(2970),
    [anon_sym_volatile] = ACTIONS(2970),
    [anon_sym_restrict] = ACTIONS(2970),
    [anon_sym___restrict__] = ACTIONS(2970),
    [anon_sym__Atomic] = ACTIONS(2970),
    [anon_sym__Noreturn] = ACTIONS(2970),
    [anon_sym_noreturn] = ACTIONS(2970),
    [anon_sym_mutable] = ACTIONS(2970),
    [anon_sym_constinit] = ACTIONS(2970),
    [anon_sym_consteval] = ACTIONS(2970),
    [anon_sym_PROGMEM] = ACTIONS(2970),
    [aux_sym_primitive_type_token1] = ACTIONS(2970),
    [anon_sym_byte] = ACTIONS(2970),
    [anon_sym_word] = ACTIONS(2970),
    [anon_sym_enum] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_struct] = ACTIONS(2970),
    [anon_sym_union] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_else] = ACTIONS(2970),
    [anon_sym_switch] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_break] = ACTIONS(2970),
    [anon_sym_continue] = ACTIONS(2970),
    [anon_sym_goto] = ACTIONS(2970),
    [anon_sym___try] = ACTIONS(2970),
    [anon_sym___leave] = ACTIONS(2970),
    [anon_sym_not] = ACTIONS(2970),
    [anon_sym_compl] = ACTIONS(2970),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_sizeof] = ACTIONS(2970),
    [anon_sym___alignof__] = ACTIONS(2970),
    [anon_sym___alignof] = ACTIONS(2970),
    [anon_sym__alignof] = ACTIONS(2970),
    [anon_sym_alignof] = ACTIONS(2970),
    [anon_sym__Alignof] = ACTIONS(2970),
    [anon_sym_offsetof] = ACTIONS(2970),
    [anon_sym__Generic] = ACTIONS(2970),
    [anon_sym_asm] = ACTIONS(2970),
    [anon_sym___asm__] = ACTIONS(2970),
    [aux_sym_number_literal_token1] = ACTIONS(2972),
    [aux_sym_number_literal_token2] = ACTIONS(2970),
    [anon_sym_L_SQUOTE] = ACTIONS(2972),
    [anon_sym_u_SQUOTE] = ACTIONS(2972),
    [anon_sym_U_SQUOTE] = ACTIONS(2972),
    [anon_sym_u8_SQUOTE] = ACTIONS(2972),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [anon_sym_L_DQUOTE] = ACTIONS(2972),
    [anon_sym_u_DQUOTE] = ACTIONS(2972),
    [anon_sym_U_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE] = ACTIONS(2972),
    [sym_true] = ACTIONS(2970),
    [sym_false] = ACTIONS(2970),
    [anon_sym_NULL] = ACTIONS(2970),
    [anon_sym_nullptr] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2970),
    [anon_sym_decltype] = ACTIONS(2970),
    [anon_sym_virtual] = ACTIONS(2970),
    [anon_sym_alignas] = ACTIONS(2970),
    [anon_sym_typename] = ACTIONS(2970),
    [anon_sym_template] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_delete] = ACTIONS(2970),
    [anon_sym_throw] = ACTIONS(2970),
    [anon_sym_co_return] = ACTIONS(2970),
    [anon_sym_co_yield] = ACTIONS(2970),
    [anon_sym_R_DQUOTE] = ACTIONS(2972),
    [anon_sym_LR_DQUOTE] = ACTIONS(2972),
    [anon_sym_uR_DQUOTE] = ACTIONS(2972),
    [anon_sym_UR_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2972),
    [anon_sym_co_await] = ACTIONS(2970),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_requires] = ACTIONS(2970),
    [sym_this] = ACTIONS(2970),
  },
  [1168] = {
    [sym_identifier] = ACTIONS(3124),
    [anon_sym_LPAREN2] = ACTIONS(3126),
    [anon_sym_BANG] = ACTIONS(3126),
    [anon_sym_TILDE] = ACTIONS(3126),
    [anon_sym_DASH] = ACTIONS(3124),
    [anon_sym_PLUS] = ACTIONS(3124),
    [anon_sym_STAR] = ACTIONS(3126),
    [anon_sym_AMP] = ACTIONS(3126),
    [anon_sym_SEMI] = ACTIONS(3126),
    [anon_sym___extension__] = ACTIONS(3124),
    [anon_sym_typedef] = ACTIONS(3124),
    [anon_sym_extern] = ACTIONS(3124),
    [anon_sym___attribute__] = ACTIONS(3124),
    [anon_sym_COLON_COLON] = ACTIONS(3126),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3126),
    [anon_sym___declspec] = ACTIONS(3124),
    [anon_sym_LBRACE] = ACTIONS(3126),
    [anon_sym_signed] = ACTIONS(3124),
    [anon_sym_unsigned] = ACTIONS(3124),
    [anon_sym_long] = ACTIONS(3124),
    [anon_sym_short] = ACTIONS(3124),
    [anon_sym_LBRACK] = ACTIONS(3124),
    [anon_sym_static] = ACTIONS(3124),
    [anon_sym_register] = ACTIONS(3124),
    [anon_sym_inline] = ACTIONS(3124),
    [anon_sym___inline] = ACTIONS(3124),
    [anon_sym___inline__] = ACTIONS(3124),
    [anon_sym___forceinline] = ACTIONS(3124),
    [anon_sym_thread_local] = ACTIONS(3124),
    [anon_sym___thread] = ACTIONS(3124),
    [anon_sym_const] = ACTIONS(3124),
    [anon_sym_constexpr] = ACTIONS(3124),
    [anon_sym_volatile] = ACTIONS(3124),
    [anon_sym_restrict] = ACTIONS(3124),
    [anon_sym___restrict__] = ACTIONS(3124),
    [anon_sym__Atomic] = ACTIONS(3124),
    [anon_sym__Noreturn] = ACTIONS(3124),
    [anon_sym_noreturn] = ACTIONS(3124),
    [anon_sym_mutable] = ACTIONS(3124),
    [anon_sym_constinit] = ACTIONS(3124),
    [anon_sym_consteval] = ACTIONS(3124),
    [anon_sym_PROGMEM] = ACTIONS(3124),
    [aux_sym_primitive_type_token1] = ACTIONS(3124),
    [anon_sym_byte] = ACTIONS(3124),
    [anon_sym_word] = ACTIONS(3124),
    [anon_sym_enum] = ACTIONS(3124),
    [anon_sym_class] = ACTIONS(3124),
    [anon_sym_struct] = ACTIONS(3124),
    [anon_sym_union] = ACTIONS(3124),
    [anon_sym_if] = ACTIONS(3124),
    [anon_sym_else] = ACTIONS(3124),
    [anon_sym_switch] = ACTIONS(3124),
    [anon_sym_while] = ACTIONS(3124),
    [anon_sym_do] = ACTIONS(3124),
    [anon_sym_for] = ACTIONS(3124),
    [anon_sym_return] = ACTIONS(3124),
    [anon_sym_break] = ACTIONS(3124),
    [anon_sym_continue] = ACTIONS(3124),
    [anon_sym_goto] = ACTIONS(3124),
    [anon_sym___try] = ACTIONS(3124),
    [anon_sym___leave] = ACTIONS(3124),
    [anon_sym_not] = ACTIONS(3124),
    [anon_sym_compl] = ACTIONS(3124),
    [anon_sym_DASH_DASH] = ACTIONS(3126),
    [anon_sym_PLUS_PLUS] = ACTIONS(3126),
    [anon_sym_sizeof] = ACTIONS(3124),
    [anon_sym___alignof__] = ACTIONS(3124),
    [anon_sym___alignof] = ACTIONS(3124),
    [anon_sym__alignof] = ACTIONS(3124),
    [anon_sym_alignof] = ACTIONS(3124),
    [anon_sym__Alignof] = ACTIONS(3124),
    [anon_sym_offsetof] = ACTIONS(3124),
    [anon_sym__Generic] = ACTIONS(3124),
    [anon_sym_asm] = ACTIONS(3124),
    [anon_sym___asm__] = ACTIONS(3124),
    [aux_sym_number_literal_token1] = ACTIONS(3126),
    [aux_sym_number_literal_token2] = ACTIONS(3124),
    [anon_sym_L_SQUOTE] = ACTIONS(3126),
    [anon_sym_u_SQUOTE] = ACTIONS(3126),
    [anon_sym_U_SQUOTE] = ACTIONS(3126),
    [anon_sym_u8_SQUOTE] = ACTIONS(3126),
    [anon_sym_SQUOTE] = ACTIONS(3126),
    [anon_sym_L_DQUOTE] = ACTIONS(3126),
    [anon_sym_u_DQUOTE] = ACTIONS(3126),
    [anon_sym_U_DQUOTE] = ACTIONS(3126),
    [anon_sym_u8_DQUOTE] = ACTIONS(3126),
    [anon_sym_DQUOTE] = ACTIONS(3126),
    [sym_true] = ACTIONS(3124),
    [sym_false] = ACTIONS(3124),
    [anon_sym_NULL] = ACTIONS(3124),
    [anon_sym_nullptr] = ACTIONS(3124),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3124),
    [anon_sym_decltype] = ACTIONS(3124),
    [anon_sym_virtual] = ACTIONS(3124),
    [anon_sym_alignas] = ACTIONS(3124),
    [anon_sym_typename] = ACTIONS(3124),
    [anon_sym_template] = ACTIONS(3124),
    [anon_sym_try] = ACTIONS(3124),
    [anon_sym_delete] = ACTIONS(3124),
    [anon_sym_throw] = ACTIONS(3124),
    [anon_sym_co_return] = ACTIONS(3124),
    [anon_sym_co_yield] = ACTIONS(3124),
    [anon_sym_R_DQUOTE] = ACTIONS(3126),
    [anon_sym_LR_DQUOTE] = ACTIONS(3126),
    [anon_sym_uR_DQUOTE] = ACTIONS(3126),
    [anon_sym_UR_DQUOTE] = ACTIONS(3126),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3126),
    [anon_sym_co_await] = ACTIONS(3124),
    [anon_sym_new] = ACTIONS(3124),
    [anon_sym_requires] = ACTIONS(3124),
    [sym_this] = ACTIONS(3124),
  },
  [1169] = {
    [sym_identifier] = ACTIONS(3138),
    [anon_sym_LPAREN2] = ACTIONS(3140),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [anon_sym_DASH] = ACTIONS(3138),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_STAR] = ACTIONS(3140),
    [anon_sym_AMP] = ACTIONS(3140),
    [anon_sym_SEMI] = ACTIONS(3140),
    [anon_sym___extension__] = ACTIONS(3138),
    [anon_sym_typedef] = ACTIONS(3138),
    [anon_sym_extern] = ACTIONS(3138),
    [anon_sym___attribute__] = ACTIONS(3138),
    [anon_sym_COLON_COLON] = ACTIONS(3140),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3140),
    [anon_sym___declspec] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [anon_sym_signed] = ACTIONS(3138),
    [anon_sym_unsigned] = ACTIONS(3138),
    [anon_sym_long] = ACTIONS(3138),
    [anon_sym_short] = ACTIONS(3138),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_static] = ACTIONS(3138),
    [anon_sym_register] = ACTIONS(3138),
    [anon_sym_inline] = ACTIONS(3138),
    [anon_sym___inline] = ACTIONS(3138),
    [anon_sym___inline__] = ACTIONS(3138),
    [anon_sym___forceinline] = ACTIONS(3138),
    [anon_sym_thread_local] = ACTIONS(3138),
    [anon_sym___thread] = ACTIONS(3138),
    [anon_sym_const] = ACTIONS(3138),
    [anon_sym_constexpr] = ACTIONS(3138),
    [anon_sym_volatile] = ACTIONS(3138),
    [anon_sym_restrict] = ACTIONS(3138),
    [anon_sym___restrict__] = ACTIONS(3138),
    [anon_sym__Atomic] = ACTIONS(3138),
    [anon_sym__Noreturn] = ACTIONS(3138),
    [anon_sym_noreturn] = ACTIONS(3138),
    [anon_sym_mutable] = ACTIONS(3138),
    [anon_sym_constinit] = ACTIONS(3138),
    [anon_sym_consteval] = ACTIONS(3138),
    [anon_sym_PROGMEM] = ACTIONS(3138),
    [aux_sym_primitive_type_token1] = ACTIONS(3138),
    [anon_sym_byte] = ACTIONS(3138),
    [anon_sym_word] = ACTIONS(3138),
    [anon_sym_enum] = ACTIONS(3138),
    [anon_sym_class] = ACTIONS(3138),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3138),
    [anon_sym_if] = ACTIONS(3138),
    [anon_sym_else] = ACTIONS(3138),
    [anon_sym_switch] = ACTIONS(3138),
    [anon_sym_while] = ACTIONS(3138),
    [anon_sym_do] = ACTIONS(3138),
    [anon_sym_for] = ACTIONS(3138),
    [anon_sym_return] = ACTIONS(3138),
    [anon_sym_break] = ACTIONS(3138),
    [anon_sym_continue] = ACTIONS(3138),
    [anon_sym_goto] = ACTIONS(3138),
    [anon_sym___try] = ACTIONS(3138),
    [anon_sym___leave] = ACTIONS(3138),
    [anon_sym_not] = ACTIONS(3138),
    [anon_sym_compl] = ACTIONS(3138),
    [anon_sym_DASH_DASH] = ACTIONS(3140),
    [anon_sym_PLUS_PLUS] = ACTIONS(3140),
    [anon_sym_sizeof] = ACTIONS(3138),
    [anon_sym___alignof__] = ACTIONS(3138),
    [anon_sym___alignof] = ACTIONS(3138),
    [anon_sym__alignof] = ACTIONS(3138),
    [anon_sym_alignof] = ACTIONS(3138),
    [anon_sym__Alignof] = ACTIONS(3138),
    [anon_sym_offsetof] = ACTIONS(3138),
    [anon_sym__Generic] = ACTIONS(3138),
    [anon_sym_asm] = ACTIONS(3138),
    [anon_sym___asm__] = ACTIONS(3138),
    [aux_sym_number_literal_token1] = ACTIONS(3140),
    [aux_sym_number_literal_token2] = ACTIONS(3138),
    [anon_sym_L_SQUOTE] = ACTIONS(3140),
    [anon_sym_u_SQUOTE] = ACTIONS(3140),
    [anon_sym_U_SQUOTE] = ACTIONS(3140),
    [anon_sym_u8_SQUOTE] = ACTIONS(3140),
    [anon_sym_SQUOTE] = ACTIONS(3140),
    [anon_sym_L_DQUOTE] = ACTIONS(3140),
    [anon_sym_u_DQUOTE] = ACTIONS(3140),
    [anon_sym_U_DQUOTE] = ACTIONS(3140),
    [anon_sym_u8_DQUOTE] = ACTIONS(3140),
    [anon_sym_DQUOTE] = ACTIONS(3140),
    [sym_true] = ACTIONS(3138),
    [sym_false] = ACTIONS(3138),
    [anon_sym_NULL] = ACTIONS(3138),
    [anon_sym_nullptr] = ACTIONS(3138),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3138),
    [anon_sym_decltype] = ACTIONS(3138),
    [anon_sym_virtual] = ACTIONS(3138),
    [anon_sym_alignas] = ACTIONS(3138),
    [anon_sym_typename] = ACTIONS(3138),
    [anon_sym_template] = ACTIONS(3138),
    [anon_sym_try] = ACTIONS(3138),
    [anon_sym_delete] = ACTIONS(3138),
    [anon_sym_throw] = ACTIONS(3138),
    [anon_sym_co_return] = ACTIONS(3138),
    [anon_sym_co_yield] = ACTIONS(3138),
    [anon_sym_R_DQUOTE] = ACTIONS(3140),
    [anon_sym_LR_DQUOTE] = ACTIONS(3140),
    [anon_sym_uR_DQUOTE] = ACTIONS(3140),
    [anon_sym_UR_DQUOTE] = ACTIONS(3140),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3140),
    [anon_sym_co_await] = ACTIONS(3138),
    [anon_sym_new] = ACTIONS(3138),
    [anon_sym_requires] = ACTIONS(3138),
    [sym_this] = ACTIONS(3138),
  },
  [1170] = {
    [sym_identifier] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [1171] = {
    [sym_identifier] = ACTIONS(3050),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3050),
    [anon_sym_PLUS] = ACTIONS(3050),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3050),
    [anon_sym_typedef] = ACTIONS(3050),
    [anon_sym_extern] = ACTIONS(3050),
    [anon_sym___attribute__] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3052),
    [anon_sym___declspec] = ACTIONS(3050),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_signed] = ACTIONS(3050),
    [anon_sym_unsigned] = ACTIONS(3050),
    [anon_sym_long] = ACTIONS(3050),
    [anon_sym_short] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_static] = ACTIONS(3050),
    [anon_sym_register] = ACTIONS(3050),
    [anon_sym_inline] = ACTIONS(3050),
    [anon_sym___inline] = ACTIONS(3050),
    [anon_sym___inline__] = ACTIONS(3050),
    [anon_sym___forceinline] = ACTIONS(3050),
    [anon_sym_thread_local] = ACTIONS(3050),
    [anon_sym___thread] = ACTIONS(3050),
    [anon_sym_const] = ACTIONS(3050),
    [anon_sym_constexpr] = ACTIONS(3050),
    [anon_sym_volatile] = ACTIONS(3050),
    [anon_sym_restrict] = ACTIONS(3050),
    [anon_sym___restrict__] = ACTIONS(3050),
    [anon_sym__Atomic] = ACTIONS(3050),
    [anon_sym__Noreturn] = ACTIONS(3050),
    [anon_sym_noreturn] = ACTIONS(3050),
    [anon_sym_mutable] = ACTIONS(3050),
    [anon_sym_constinit] = ACTIONS(3050),
    [anon_sym_consteval] = ACTIONS(3050),
    [anon_sym_PROGMEM] = ACTIONS(3050),
    [aux_sym_primitive_type_token1] = ACTIONS(3050),
    [anon_sym_byte] = ACTIONS(3050),
    [anon_sym_word] = ACTIONS(3050),
    [anon_sym_enum] = ACTIONS(3050),
    [anon_sym_class] = ACTIONS(3050),
    [anon_sym_struct] = ACTIONS(3050),
    [anon_sym_union] = ACTIONS(3050),
    [anon_sym_if] = ACTIONS(3050),
    [anon_sym_else] = ACTIONS(3050),
    [anon_sym_switch] = ACTIONS(3050),
    [anon_sym_while] = ACTIONS(3050),
    [anon_sym_do] = ACTIONS(3050),
    [anon_sym_for] = ACTIONS(3050),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_break] = ACTIONS(3050),
    [anon_sym_continue] = ACTIONS(3050),
    [anon_sym_goto] = ACTIONS(3050),
    [anon_sym___try] = ACTIONS(3050),
    [anon_sym___leave] = ACTIONS(3050),
    [anon_sym_not] = ACTIONS(3050),
    [anon_sym_compl] = ACTIONS(3050),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_sizeof] = ACTIONS(3050),
    [anon_sym___alignof__] = ACTIONS(3050),
    [anon_sym___alignof] = ACTIONS(3050),
    [anon_sym__alignof] = ACTIONS(3050),
    [anon_sym_alignof] = ACTIONS(3050),
    [anon_sym__Alignof] = ACTIONS(3050),
    [anon_sym_offsetof] = ACTIONS(3050),
    [anon_sym__Generic] = ACTIONS(3050),
    [anon_sym_asm] = ACTIONS(3050),
    [anon_sym___asm__] = ACTIONS(3050),
    [aux_sym_number_literal_token1] = ACTIONS(3052),
    [aux_sym_number_literal_token2] = ACTIONS(3050),
    [anon_sym_L_SQUOTE] = ACTIONS(3052),
    [anon_sym_u_SQUOTE] = ACTIONS(3052),
    [anon_sym_U_SQUOTE] = ACTIONS(3052),
    [anon_sym_u8_SQUOTE] = ACTIONS(3052),
    [anon_sym_SQUOTE] = ACTIONS(3052),
    [anon_sym_L_DQUOTE] = ACTIONS(3052),
    [anon_sym_u_DQUOTE] = ACTIONS(3052),
    [anon_sym_U_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8_DQUOTE] = ACTIONS(3052),
    [anon_sym_DQUOTE] = ACTIONS(3052),
    [sym_true] = ACTIONS(3050),
    [sym_false] = ACTIONS(3050),
    [anon_sym_NULL] = ACTIONS(3050),
    [anon_sym_nullptr] = ACTIONS(3050),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3050),
    [anon_sym_decltype] = ACTIONS(3050),
    [anon_sym_virtual] = ACTIONS(3050),
    [anon_sym_alignas] = ACTIONS(3050),
    [anon_sym_typename] = ACTIONS(3050),
    [anon_sym_template] = ACTIONS(3050),
    [anon_sym_try] = ACTIONS(3050),
    [anon_sym_delete] = ACTIONS(3050),
    [anon_sym_throw] = ACTIONS(3050),
    [anon_sym_co_return] = ACTIONS(3050),
    [anon_sym_co_yield] = ACTIONS(3050),
    [anon_sym_R_DQUOTE] = ACTIONS(3052),
    [anon_sym_LR_DQUOTE] = ACTIONS(3052),
    [anon_sym_uR_DQUOTE] = ACTIONS(3052),
    [anon_sym_UR_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3052),
    [anon_sym_co_await] = ACTIONS(3050),
    [anon_sym_new] = ACTIONS(3050),
    [anon_sym_requires] = ACTIONS(3050),
    [sym_this] = ACTIONS(3050),
  },
  [1172] = {
    [sym_identifier] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [1173] = {
    [sym_identifier] = ACTIONS(3054),
    [anon_sym_LPAREN2] = ACTIONS(3056),
    [anon_sym_BANG] = ACTIONS(3056),
    [anon_sym_TILDE] = ACTIONS(3056),
    [anon_sym_DASH] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3056),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym___extension__] = ACTIONS(3054),
    [anon_sym_typedef] = ACTIONS(3054),
    [anon_sym_extern] = ACTIONS(3054),
    [anon_sym___attribute__] = ACTIONS(3054),
    [anon_sym_COLON_COLON] = ACTIONS(3056),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3056),
    [anon_sym___declspec] = ACTIONS(3054),
    [anon_sym_LBRACE] = ACTIONS(3056),
    [anon_sym_signed] = ACTIONS(3054),
    [anon_sym_unsigned] = ACTIONS(3054),
    [anon_sym_long] = ACTIONS(3054),
    [anon_sym_short] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3054),
    [anon_sym_static] = ACTIONS(3054),
    [anon_sym_register] = ACTIONS(3054),
    [anon_sym_inline] = ACTIONS(3054),
    [anon_sym___inline] = ACTIONS(3054),
    [anon_sym___inline__] = ACTIONS(3054),
    [anon_sym___forceinline] = ACTIONS(3054),
    [anon_sym_thread_local] = ACTIONS(3054),
    [anon_sym___thread] = ACTIONS(3054),
    [anon_sym_const] = ACTIONS(3054),
    [anon_sym_constexpr] = ACTIONS(3054),
    [anon_sym_volatile] = ACTIONS(3054),
    [anon_sym_restrict] = ACTIONS(3054),
    [anon_sym___restrict__] = ACTIONS(3054),
    [anon_sym__Atomic] = ACTIONS(3054),
    [anon_sym__Noreturn] = ACTIONS(3054),
    [anon_sym_noreturn] = ACTIONS(3054),
    [anon_sym_mutable] = ACTIONS(3054),
    [anon_sym_constinit] = ACTIONS(3054),
    [anon_sym_consteval] = ACTIONS(3054),
    [anon_sym_PROGMEM] = ACTIONS(3054),
    [aux_sym_primitive_type_token1] = ACTIONS(3054),
    [anon_sym_byte] = ACTIONS(3054),
    [anon_sym_word] = ACTIONS(3054),
    [anon_sym_enum] = ACTIONS(3054),
    [anon_sym_class] = ACTIONS(3054),
    [anon_sym_struct] = ACTIONS(3054),
    [anon_sym_union] = ACTIONS(3054),
    [anon_sym_if] = ACTIONS(3054),
    [anon_sym_else] = ACTIONS(3054),
    [anon_sym_switch] = ACTIONS(3054),
    [anon_sym_while] = ACTIONS(3054),
    [anon_sym_do] = ACTIONS(3054),
    [anon_sym_for] = ACTIONS(3054),
    [anon_sym_return] = ACTIONS(3054),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_continue] = ACTIONS(3054),
    [anon_sym_goto] = ACTIONS(3054),
    [anon_sym___try] = ACTIONS(3054),
    [anon_sym___leave] = ACTIONS(3054),
    [anon_sym_not] = ACTIONS(3054),
    [anon_sym_compl] = ACTIONS(3054),
    [anon_sym_DASH_DASH] = ACTIONS(3056),
    [anon_sym_PLUS_PLUS] = ACTIONS(3056),
    [anon_sym_sizeof] = ACTIONS(3054),
    [anon_sym___alignof__] = ACTIONS(3054),
    [anon_sym___alignof] = ACTIONS(3054),
    [anon_sym__alignof] = ACTIONS(3054),
    [anon_sym_alignof] = ACTIONS(3054),
    [anon_sym__Alignof] = ACTIONS(3054),
    [anon_sym_offsetof] = ACTIONS(3054),
    [anon_sym__Generic] = ACTIONS(3054),
    [anon_sym_asm] = ACTIONS(3054),
    [anon_sym___asm__] = ACTIONS(3054),
    [aux_sym_number_literal_token1] = ACTIONS(3056),
    [aux_sym_number_literal_token2] = ACTIONS(3054),
    [anon_sym_L_SQUOTE] = ACTIONS(3056),
    [anon_sym_u_SQUOTE] = ACTIONS(3056),
    [anon_sym_U_SQUOTE] = ACTIONS(3056),
    [anon_sym_u8_SQUOTE] = ACTIONS(3056),
    [anon_sym_SQUOTE] = ACTIONS(3056),
    [anon_sym_L_DQUOTE] = ACTIONS(3056),
    [anon_sym_u_DQUOTE] = ACTIONS(3056),
    [anon_sym_U_DQUOTE] = ACTIONS(3056),
    [anon_sym_u8_DQUOTE] = ACTIONS(3056),
    [anon_sym_DQUOTE] = ACTIONS(3056),
    [sym_true] = ACTIONS(3054),
    [sym_false] = ACTIONS(3054),
    [anon_sym_NULL] = ACTIONS(3054),
    [anon_sym_nullptr] = ACTIONS(3054),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3054),
    [anon_sym_decltype] = ACTIONS(3054),
    [anon_sym_virtual] = ACTIONS(3054),
    [anon_sym_alignas] = ACTIONS(3054),
    [anon_sym_typename] = ACTIONS(3054),
    [anon_sym_template] = ACTIONS(3054),
    [anon_sym_try] = ACTIONS(3054),
    [anon_sym_delete] = ACTIONS(3054),
    [anon_sym_throw] = ACTIONS(3054),
    [anon_sym_co_return] = ACTIONS(3054),
    [anon_sym_co_yield] = ACTIONS(3054),
    [anon_sym_R_DQUOTE] = ACTIONS(3056),
    [anon_sym_LR_DQUOTE] = ACTIONS(3056),
    [anon_sym_uR_DQUOTE] = ACTIONS(3056),
    [anon_sym_UR_DQUOTE] = ACTIONS(3056),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3056),
    [anon_sym_co_await] = ACTIONS(3054),
    [anon_sym_new] = ACTIONS(3054),
    [anon_sym_requires] = ACTIONS(3054),
    [sym_this] = ACTIONS(3054),
  },
  [1174] = {
    [sym_identifier] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [1175] = {
    [sym_identifier] = ACTIONS(3058),
    [anon_sym_LPAREN2] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3060),
    [anon_sym_TILDE] = ACTIONS(3060),
    [anon_sym_DASH] = ACTIONS(3058),
    [anon_sym_PLUS] = ACTIONS(3058),
    [anon_sym_STAR] = ACTIONS(3060),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym_SEMI] = ACTIONS(3060),
    [anon_sym___extension__] = ACTIONS(3058),
    [anon_sym_typedef] = ACTIONS(3058),
    [anon_sym_extern] = ACTIONS(3058),
    [anon_sym___attribute__] = ACTIONS(3058),
    [anon_sym_COLON_COLON] = ACTIONS(3060),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3060),
    [anon_sym___declspec] = ACTIONS(3058),
    [anon_sym_LBRACE] = ACTIONS(3060),
    [anon_sym_signed] = ACTIONS(3058),
    [anon_sym_unsigned] = ACTIONS(3058),
    [anon_sym_long] = ACTIONS(3058),
    [anon_sym_short] = ACTIONS(3058),
    [anon_sym_LBRACK] = ACTIONS(3058),
    [anon_sym_static] = ACTIONS(3058),
    [anon_sym_register] = ACTIONS(3058),
    [anon_sym_inline] = ACTIONS(3058),
    [anon_sym___inline] = ACTIONS(3058),
    [anon_sym___inline__] = ACTIONS(3058),
    [anon_sym___forceinline] = ACTIONS(3058),
    [anon_sym_thread_local] = ACTIONS(3058),
    [anon_sym___thread] = ACTIONS(3058),
    [anon_sym_const] = ACTIONS(3058),
    [anon_sym_constexpr] = ACTIONS(3058),
    [anon_sym_volatile] = ACTIONS(3058),
    [anon_sym_restrict] = ACTIONS(3058),
    [anon_sym___restrict__] = ACTIONS(3058),
    [anon_sym__Atomic] = ACTIONS(3058),
    [anon_sym__Noreturn] = ACTIONS(3058),
    [anon_sym_noreturn] = ACTIONS(3058),
    [anon_sym_mutable] = ACTIONS(3058),
    [anon_sym_constinit] = ACTIONS(3058),
    [anon_sym_consteval] = ACTIONS(3058),
    [anon_sym_PROGMEM] = ACTIONS(3058),
    [aux_sym_primitive_type_token1] = ACTIONS(3058),
    [anon_sym_byte] = ACTIONS(3058),
    [anon_sym_word] = ACTIONS(3058),
    [anon_sym_enum] = ACTIONS(3058),
    [anon_sym_class] = ACTIONS(3058),
    [anon_sym_struct] = ACTIONS(3058),
    [anon_sym_union] = ACTIONS(3058),
    [anon_sym_if] = ACTIONS(3058),
    [anon_sym_else] = ACTIONS(3058),
    [anon_sym_switch] = ACTIONS(3058),
    [anon_sym_while] = ACTIONS(3058),
    [anon_sym_do] = ACTIONS(3058),
    [anon_sym_for] = ACTIONS(3058),
    [anon_sym_return] = ACTIONS(3058),
    [anon_sym_break] = ACTIONS(3058),
    [anon_sym_continue] = ACTIONS(3058),
    [anon_sym_goto] = ACTIONS(3058),
    [anon_sym___try] = ACTIONS(3058),
    [anon_sym___leave] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3058),
    [anon_sym_compl] = ACTIONS(3058),
    [anon_sym_DASH_DASH] = ACTIONS(3060),
    [anon_sym_PLUS_PLUS] = ACTIONS(3060),
    [anon_sym_sizeof] = ACTIONS(3058),
    [anon_sym___alignof__] = ACTIONS(3058),
    [anon_sym___alignof] = ACTIONS(3058),
    [anon_sym__alignof] = ACTIONS(3058),
    [anon_sym_alignof] = ACTIONS(3058),
    [anon_sym__Alignof] = ACTIONS(3058),
    [anon_sym_offsetof] = ACTIONS(3058),
    [anon_sym__Generic] = ACTIONS(3058),
    [anon_sym_asm] = ACTIONS(3058),
    [anon_sym___asm__] = ACTIONS(3058),
    [aux_sym_number_literal_token1] = ACTIONS(3060),
    [aux_sym_number_literal_token2] = ACTIONS(3058),
    [anon_sym_L_SQUOTE] = ACTIONS(3060),
    [anon_sym_u_SQUOTE] = ACTIONS(3060),
    [anon_sym_U_SQUOTE] = ACTIONS(3060),
    [anon_sym_u8_SQUOTE] = ACTIONS(3060),
    [anon_sym_SQUOTE] = ACTIONS(3060),
    [anon_sym_L_DQUOTE] = ACTIONS(3060),
    [anon_sym_u_DQUOTE] = ACTIONS(3060),
    [anon_sym_U_DQUOTE] = ACTIONS(3060),
    [anon_sym_u8_DQUOTE] = ACTIONS(3060),
    [anon_sym_DQUOTE] = ACTIONS(3060),
    [sym_true] = ACTIONS(3058),
    [sym_false] = ACTIONS(3058),
    [anon_sym_NULL] = ACTIONS(3058),
    [anon_sym_nullptr] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3058),
    [anon_sym_decltype] = ACTIONS(3058),
    [anon_sym_virtual] = ACTIONS(3058),
    [anon_sym_alignas] = ACTIONS(3058),
    [anon_sym_typename] = ACTIONS(3058),
    [anon_sym_template] = ACTIONS(3058),
    [anon_sym_try] = ACTIONS(3058),
    [anon_sym_delete] = ACTIONS(3058),
    [anon_sym_throw] = ACTIONS(3058),
    [anon_sym_co_return] = ACTIONS(3058),
    [anon_sym_co_yield] = ACTIONS(3058),
    [anon_sym_R_DQUOTE] = ACTIONS(3060),
    [anon_sym_LR_DQUOTE] = ACTIONS(3060),
    [anon_sym_uR_DQUOTE] = ACTIONS(3060),
    [anon_sym_UR_DQUOTE] = ACTIONS(3060),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3060),
    [anon_sym_co_await] = ACTIONS(3058),
    [anon_sym_new] = ACTIONS(3058),
    [anon_sym_requires] = ACTIONS(3058),
    [sym_this] = ACTIONS(3058),
  },
  [1176] = {
    [sym_identifier] = ACTIONS(3064),
    [anon_sym_LPAREN2] = ACTIONS(3066),
    [anon_sym_BANG] = ACTIONS(3066),
    [anon_sym_TILDE] = ACTIONS(3066),
    [anon_sym_DASH] = ACTIONS(3064),
    [anon_sym_PLUS] = ACTIONS(3064),
    [anon_sym_STAR] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3066),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym___extension__] = ACTIONS(3064),
    [anon_sym_typedef] = ACTIONS(3064),
    [anon_sym_extern] = ACTIONS(3064),
    [anon_sym___attribute__] = ACTIONS(3064),
    [anon_sym_COLON_COLON] = ACTIONS(3066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3066),
    [anon_sym___declspec] = ACTIONS(3064),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_signed] = ACTIONS(3064),
    [anon_sym_unsigned] = ACTIONS(3064),
    [anon_sym_long] = ACTIONS(3064),
    [anon_sym_short] = ACTIONS(3064),
    [anon_sym_LBRACK] = ACTIONS(3064),
    [anon_sym_static] = ACTIONS(3064),
    [anon_sym_register] = ACTIONS(3064),
    [anon_sym_inline] = ACTIONS(3064),
    [anon_sym___inline] = ACTIONS(3064),
    [anon_sym___inline__] = ACTIONS(3064),
    [anon_sym___forceinline] = ACTIONS(3064),
    [anon_sym_thread_local] = ACTIONS(3064),
    [anon_sym___thread] = ACTIONS(3064),
    [anon_sym_const] = ACTIONS(3064),
    [anon_sym_constexpr] = ACTIONS(3064),
    [anon_sym_volatile] = ACTIONS(3064),
    [anon_sym_restrict] = ACTIONS(3064),
    [anon_sym___restrict__] = ACTIONS(3064),
    [anon_sym__Atomic] = ACTIONS(3064),
    [anon_sym__Noreturn] = ACTIONS(3064),
    [anon_sym_noreturn] = ACTIONS(3064),
    [anon_sym_mutable] = ACTIONS(3064),
    [anon_sym_constinit] = ACTIONS(3064),
    [anon_sym_consteval] = ACTIONS(3064),
    [anon_sym_PROGMEM] = ACTIONS(3064),
    [aux_sym_primitive_type_token1] = ACTIONS(3064),
    [anon_sym_byte] = ACTIONS(3064),
    [anon_sym_word] = ACTIONS(3064),
    [anon_sym_enum] = ACTIONS(3064),
    [anon_sym_class] = ACTIONS(3064),
    [anon_sym_struct] = ACTIONS(3064),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_if] = ACTIONS(3064),
    [anon_sym_else] = ACTIONS(3064),
    [anon_sym_switch] = ACTIONS(3064),
    [anon_sym_while] = ACTIONS(3064),
    [anon_sym_do] = ACTIONS(3064),
    [anon_sym_for] = ACTIONS(3064),
    [anon_sym_return] = ACTIONS(3064),
    [anon_sym_break] = ACTIONS(3064),
    [anon_sym_continue] = ACTIONS(3064),
    [anon_sym_goto] = ACTIONS(3064),
    [anon_sym___try] = ACTIONS(3064),
    [anon_sym___leave] = ACTIONS(3064),
    [anon_sym_not] = ACTIONS(3064),
    [anon_sym_compl] = ACTIONS(3064),
    [anon_sym_DASH_DASH] = ACTIONS(3066),
    [anon_sym_PLUS_PLUS] = ACTIONS(3066),
    [anon_sym_sizeof] = ACTIONS(3064),
    [anon_sym___alignof__] = ACTIONS(3064),
    [anon_sym___alignof] = ACTIONS(3064),
    [anon_sym__alignof] = ACTIONS(3064),
    [anon_sym_alignof] = ACTIONS(3064),
    [anon_sym__Alignof] = ACTIONS(3064),
    [anon_sym_offsetof] = ACTIONS(3064),
    [anon_sym__Generic] = ACTIONS(3064),
    [anon_sym_asm] = ACTIONS(3064),
    [anon_sym___asm__] = ACTIONS(3064),
    [aux_sym_number_literal_token1] = ACTIONS(3066),
    [aux_sym_number_literal_token2] = ACTIONS(3064),
    [anon_sym_L_SQUOTE] = ACTIONS(3066),
    [anon_sym_u_SQUOTE] = ACTIONS(3066),
    [anon_sym_U_SQUOTE] = ACTIONS(3066),
    [anon_sym_u8_SQUOTE] = ACTIONS(3066),
    [anon_sym_SQUOTE] = ACTIONS(3066),
    [anon_sym_L_DQUOTE] = ACTIONS(3066),
    [anon_sym_u_DQUOTE] = ACTIONS(3066),
    [anon_sym_U_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8_DQUOTE] = ACTIONS(3066),
    [anon_sym_DQUOTE] = ACTIONS(3066),
    [sym_true] = ACTIONS(3064),
    [sym_false] = ACTIONS(3064),
    [anon_sym_NULL] = ACTIONS(3064),
    [anon_sym_nullptr] = ACTIONS(3064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3064),
    [anon_sym_decltype] = ACTIONS(3064),
    [anon_sym_virtual] = ACTIONS(3064),
    [anon_sym_alignas] = ACTIONS(3064),
    [anon_sym_typename] = ACTIONS(3064),
    [anon_sym_template] = ACTIONS(3064),
    [anon_sym_try] = ACTIONS(3064),
    [anon_sym_delete] = ACTIONS(3064),
    [anon_sym_throw] = ACTIONS(3064),
    [anon_sym_co_return] = ACTIONS(3064),
    [anon_sym_co_yield] = ACTIONS(3064),
    [anon_sym_R_DQUOTE] = ACTIONS(3066),
    [anon_sym_LR_DQUOTE] = ACTIONS(3066),
    [anon_sym_uR_DQUOTE] = ACTIONS(3066),
    [anon_sym_UR_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3066),
    [anon_sym_co_await] = ACTIONS(3064),
    [anon_sym_new] = ACTIONS(3064),
    [anon_sym_requires] = ACTIONS(3064),
    [sym_this] = ACTIONS(3064),
  },
  [1177] = {
    [sym_identifier] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_BANG] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_DASH] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3070),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_PROGMEM] = ACTIONS(3068),
    [aux_sym_primitive_type_token1] = ACTIONS(3068),
    [anon_sym_byte] = ACTIONS(3068),
    [anon_sym_word] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3068),
    [anon_sym_else] = ACTIONS(3068),
    [anon_sym_switch] = ACTIONS(3068),
    [anon_sym_while] = ACTIONS(3068),
    [anon_sym_do] = ACTIONS(3068),
    [anon_sym_for] = ACTIONS(3068),
    [anon_sym_return] = ACTIONS(3068),
    [anon_sym_break] = ACTIONS(3068),
    [anon_sym_continue] = ACTIONS(3068),
    [anon_sym_goto] = ACTIONS(3068),
    [anon_sym___try] = ACTIONS(3068),
    [anon_sym___leave] = ACTIONS(3068),
    [anon_sym_not] = ACTIONS(3068),
    [anon_sym_compl] = ACTIONS(3068),
    [anon_sym_DASH_DASH] = ACTIONS(3070),
    [anon_sym_PLUS_PLUS] = ACTIONS(3070),
    [anon_sym_sizeof] = ACTIONS(3068),
    [anon_sym___alignof__] = ACTIONS(3068),
    [anon_sym___alignof] = ACTIONS(3068),
    [anon_sym__alignof] = ACTIONS(3068),
    [anon_sym_alignof] = ACTIONS(3068),
    [anon_sym__Alignof] = ACTIONS(3068),
    [anon_sym_offsetof] = ACTIONS(3068),
    [anon_sym__Generic] = ACTIONS(3068),
    [anon_sym_asm] = ACTIONS(3068),
    [anon_sym___asm__] = ACTIONS(3068),
    [aux_sym_number_literal_token1] = ACTIONS(3070),
    [aux_sym_number_literal_token2] = ACTIONS(3068),
    [anon_sym_L_SQUOTE] = ACTIONS(3070),
    [anon_sym_u_SQUOTE] = ACTIONS(3070),
    [anon_sym_U_SQUOTE] = ACTIONS(3070),
    [anon_sym_u8_SQUOTE] = ACTIONS(3070),
    [anon_sym_SQUOTE] = ACTIONS(3070),
    [anon_sym_L_DQUOTE] = ACTIONS(3070),
    [anon_sym_u_DQUOTE] = ACTIONS(3070),
    [anon_sym_U_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8_DQUOTE] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3070),
    [sym_true] = ACTIONS(3068),
    [sym_false] = ACTIONS(3068),
    [anon_sym_NULL] = ACTIONS(3068),
    [anon_sym_nullptr] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_try] = ACTIONS(3068),
    [anon_sym_delete] = ACTIONS(3068),
    [anon_sym_throw] = ACTIONS(3068),
    [anon_sym_co_return] = ACTIONS(3068),
    [anon_sym_co_yield] = ACTIONS(3068),
    [anon_sym_R_DQUOTE] = ACTIONS(3070),
    [anon_sym_LR_DQUOTE] = ACTIONS(3070),
    [anon_sym_uR_DQUOTE] = ACTIONS(3070),
    [anon_sym_UR_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3070),
    [anon_sym_co_await] = ACTIONS(3068),
    [anon_sym_new] = ACTIONS(3068),
    [anon_sym_requires] = ACTIONS(3068),
    [sym_this] = ACTIONS(3068),
  },
  [1178] = {
    [sym_identifier] = ACTIONS(3092),
    [anon_sym_LPAREN2] = ACTIONS(3094),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_TILDE] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(3094),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3094),
    [anon_sym___extension__] = ACTIONS(3092),
    [anon_sym_typedef] = ACTIONS(3092),
    [anon_sym_extern] = ACTIONS(3092),
    [anon_sym___attribute__] = ACTIONS(3092),
    [anon_sym_COLON_COLON] = ACTIONS(3094),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3094),
    [anon_sym___declspec] = ACTIONS(3092),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_signed] = ACTIONS(3092),
    [anon_sym_unsigned] = ACTIONS(3092),
    [anon_sym_long] = ACTIONS(3092),
    [anon_sym_short] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_static] = ACTIONS(3092),
    [anon_sym_register] = ACTIONS(3092),
    [anon_sym_inline] = ACTIONS(3092),
    [anon_sym___inline] = ACTIONS(3092),
    [anon_sym___inline__] = ACTIONS(3092),
    [anon_sym___forceinline] = ACTIONS(3092),
    [anon_sym_thread_local] = ACTIONS(3092),
    [anon_sym___thread] = ACTIONS(3092),
    [anon_sym_const] = ACTIONS(3092),
    [anon_sym_constexpr] = ACTIONS(3092),
    [anon_sym_volatile] = ACTIONS(3092),
    [anon_sym_restrict] = ACTIONS(3092),
    [anon_sym___restrict__] = ACTIONS(3092),
    [anon_sym__Atomic] = ACTIONS(3092),
    [anon_sym__Noreturn] = ACTIONS(3092),
    [anon_sym_noreturn] = ACTIONS(3092),
    [anon_sym_mutable] = ACTIONS(3092),
    [anon_sym_constinit] = ACTIONS(3092),
    [anon_sym_consteval] = ACTIONS(3092),
    [anon_sym_PROGMEM] = ACTIONS(3092),
    [aux_sym_primitive_type_token1] = ACTIONS(3092),
    [anon_sym_byte] = ACTIONS(3092),
    [anon_sym_word] = ACTIONS(3092),
    [anon_sym_enum] = ACTIONS(3092),
    [anon_sym_class] = ACTIONS(3092),
    [anon_sym_struct] = ACTIONS(3092),
    [anon_sym_union] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_switch] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_break] = ACTIONS(3092),
    [anon_sym_continue] = ACTIONS(3092),
    [anon_sym_goto] = ACTIONS(3092),
    [anon_sym___try] = ACTIONS(3092),
    [anon_sym___leave] = ACTIONS(3092),
    [anon_sym_not] = ACTIONS(3092),
    [anon_sym_compl] = ACTIONS(3092),
    [anon_sym_DASH_DASH] = ACTIONS(3094),
    [anon_sym_PLUS_PLUS] = ACTIONS(3094),
    [anon_sym_sizeof] = ACTIONS(3092),
    [anon_sym___alignof__] = ACTIONS(3092),
    [anon_sym___alignof] = ACTIONS(3092),
    [anon_sym__alignof] = ACTIONS(3092),
    [anon_sym_alignof] = ACTIONS(3092),
    [anon_sym__Alignof] = ACTIONS(3092),
    [anon_sym_offsetof] = ACTIONS(3092),
    [anon_sym__Generic] = ACTIONS(3092),
    [anon_sym_asm] = ACTIONS(3092),
    [anon_sym___asm__] = ACTIONS(3092),
    [aux_sym_number_literal_token1] = ACTIONS(3094),
    [aux_sym_number_literal_token2] = ACTIONS(3092),
    [anon_sym_L_SQUOTE] = ACTIONS(3094),
    [anon_sym_u_SQUOTE] = ACTIONS(3094),
    [anon_sym_U_SQUOTE] = ACTIONS(3094),
    [anon_sym_u8_SQUOTE] = ACTIONS(3094),
    [anon_sym_SQUOTE] = ACTIONS(3094),
    [anon_sym_L_DQUOTE] = ACTIONS(3094),
    [anon_sym_u_DQUOTE] = ACTIONS(3094),
    [anon_sym_U_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8_DQUOTE] = ACTIONS(3094),
    [anon_sym_DQUOTE] = ACTIONS(3094),
    [sym_true] = ACTIONS(3092),
    [sym_false] = ACTIONS(3092),
    [anon_sym_NULL] = ACTIONS(3092),
    [anon_sym_nullptr] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3092),
    [anon_sym_decltype] = ACTIONS(3092),
    [anon_sym_virtual] = ACTIONS(3092),
    [anon_sym_alignas] = ACTIONS(3092),
    [anon_sym_typename] = ACTIONS(3092),
    [anon_sym_template] = ACTIONS(3092),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_delete] = ACTIONS(3092),
    [anon_sym_throw] = ACTIONS(3092),
    [anon_sym_co_return] = ACTIONS(3092),
    [anon_sym_co_yield] = ACTIONS(3092),
    [anon_sym_R_DQUOTE] = ACTIONS(3094),
    [anon_sym_LR_DQUOTE] = ACTIONS(3094),
    [anon_sym_uR_DQUOTE] = ACTIONS(3094),
    [anon_sym_UR_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3094),
    [anon_sym_co_await] = ACTIONS(3092),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_requires] = ACTIONS(3092),
    [sym_this] = ACTIONS(3092),
  },
  [1179] = {
    [sym_identifier] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [1180] = {
    [sym_identifier] = ACTIONS(3078),
    [anon_sym_LPAREN2] = ACTIONS(3080),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_TILDE] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3078),
    [anon_sym_PLUS] = ACTIONS(3078),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_AMP] = ACTIONS(3080),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym___extension__] = ACTIONS(3078),
    [anon_sym_typedef] = ACTIONS(3078),
    [anon_sym_extern] = ACTIONS(3078),
    [anon_sym___attribute__] = ACTIONS(3078),
    [anon_sym_COLON_COLON] = ACTIONS(3080),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3080),
    [anon_sym___declspec] = ACTIONS(3078),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_signed] = ACTIONS(3078),
    [anon_sym_unsigned] = ACTIONS(3078),
    [anon_sym_long] = ACTIONS(3078),
    [anon_sym_short] = ACTIONS(3078),
    [anon_sym_LBRACK] = ACTIONS(3078),
    [anon_sym_static] = ACTIONS(3078),
    [anon_sym_register] = ACTIONS(3078),
    [anon_sym_inline] = ACTIONS(3078),
    [anon_sym___inline] = ACTIONS(3078),
    [anon_sym___inline__] = ACTIONS(3078),
    [anon_sym___forceinline] = ACTIONS(3078),
    [anon_sym_thread_local] = ACTIONS(3078),
    [anon_sym___thread] = ACTIONS(3078),
    [anon_sym_const] = ACTIONS(3078),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(3078),
    [anon_sym_restrict] = ACTIONS(3078),
    [anon_sym___restrict__] = ACTIONS(3078),
    [anon_sym__Atomic] = ACTIONS(3078),
    [anon_sym__Noreturn] = ACTIONS(3078),
    [anon_sym_noreturn] = ACTIONS(3078),
    [anon_sym_mutable] = ACTIONS(3078),
    [anon_sym_constinit] = ACTIONS(3078),
    [anon_sym_consteval] = ACTIONS(3078),
    [anon_sym_PROGMEM] = ACTIONS(3078),
    [aux_sym_primitive_type_token1] = ACTIONS(3078),
    [anon_sym_byte] = ACTIONS(3078),
    [anon_sym_word] = ACTIONS(3078),
    [anon_sym_enum] = ACTIONS(3078),
    [anon_sym_class] = ACTIONS(3078),
    [anon_sym_struct] = ACTIONS(3078),
    [anon_sym_union] = ACTIONS(3078),
    [anon_sym_if] = ACTIONS(3078),
    [anon_sym_else] = ACTIONS(3078),
    [anon_sym_switch] = ACTIONS(3078),
    [anon_sym_while] = ACTIONS(3078),
    [anon_sym_do] = ACTIONS(3078),
    [anon_sym_for] = ACTIONS(3078),
    [anon_sym_return] = ACTIONS(3078),
    [anon_sym_break] = ACTIONS(3078),
    [anon_sym_continue] = ACTIONS(3078),
    [anon_sym_goto] = ACTIONS(3078),
    [anon_sym___try] = ACTIONS(3078),
    [anon_sym___leave] = ACTIONS(3078),
    [anon_sym_not] = ACTIONS(3078),
    [anon_sym_compl] = ACTIONS(3078),
    [anon_sym_DASH_DASH] = ACTIONS(3080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3080),
    [anon_sym_sizeof] = ACTIONS(3078),
    [anon_sym___alignof__] = ACTIONS(3078),
    [anon_sym___alignof] = ACTIONS(3078),
    [anon_sym__alignof] = ACTIONS(3078),
    [anon_sym_alignof] = ACTIONS(3078),
    [anon_sym__Alignof] = ACTIONS(3078),
    [anon_sym_offsetof] = ACTIONS(3078),
    [anon_sym__Generic] = ACTIONS(3078),
    [anon_sym_asm] = ACTIONS(3078),
    [anon_sym___asm__] = ACTIONS(3078),
    [aux_sym_number_literal_token1] = ACTIONS(3080),
    [aux_sym_number_literal_token2] = ACTIONS(3078),
    [anon_sym_L_SQUOTE] = ACTIONS(3080),
    [anon_sym_u_SQUOTE] = ACTIONS(3080),
    [anon_sym_U_SQUOTE] = ACTIONS(3080),
    [anon_sym_u8_SQUOTE] = ACTIONS(3080),
    [anon_sym_SQUOTE] = ACTIONS(3080),
    [anon_sym_L_DQUOTE] = ACTIONS(3080),
    [anon_sym_u_DQUOTE] = ACTIONS(3080),
    [anon_sym_U_DQUOTE] = ACTIONS(3080),
    [anon_sym_u8_DQUOTE] = ACTIONS(3080),
    [anon_sym_DQUOTE] = ACTIONS(3080),
    [sym_true] = ACTIONS(3078),
    [sym_false] = ACTIONS(3078),
    [anon_sym_NULL] = ACTIONS(3078),
    [anon_sym_nullptr] = ACTIONS(3078),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3078),
    [anon_sym_decltype] = ACTIONS(3078),
    [anon_sym_virtual] = ACTIONS(3078),
    [anon_sym_alignas] = ACTIONS(3078),
    [anon_sym_typename] = ACTIONS(3078),
    [anon_sym_template] = ACTIONS(3078),
    [anon_sym_try] = ACTIONS(3078),
    [anon_sym_delete] = ACTIONS(3078),
    [anon_sym_throw] = ACTIONS(3078),
    [anon_sym_co_return] = ACTIONS(3078),
    [anon_sym_co_yield] = ACTIONS(3078),
    [anon_sym_R_DQUOTE] = ACTIONS(3080),
    [anon_sym_LR_DQUOTE] = ACTIONS(3080),
    [anon_sym_uR_DQUOTE] = ACTIONS(3080),
    [anon_sym_UR_DQUOTE] = ACTIONS(3080),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3080),
    [anon_sym_co_await] = ACTIONS(3078),
    [anon_sym_new] = ACTIONS(3078),
    [anon_sym_requires] = ACTIONS(3078),
    [sym_this] = ACTIONS(3078),
  },
  [1181] = {
    [sym_identifier] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [1182] = {
    [sym_identifier] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [1183] = {
    [sym_identifier] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [1184] = {
    [sym_identifier] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [1185] = {
    [sym_identifier] = ACTIONS(3102),
    [anon_sym_LPAREN2] = ACTIONS(3104),
    [anon_sym_BANG] = ACTIONS(3104),
    [anon_sym_TILDE] = ACTIONS(3104),
    [anon_sym_DASH] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(3104),
    [anon_sym___extension__] = ACTIONS(3102),
    [anon_sym_typedef] = ACTIONS(3102),
    [anon_sym_extern] = ACTIONS(3102),
    [anon_sym___attribute__] = ACTIONS(3102),
    [anon_sym_COLON_COLON] = ACTIONS(3104),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3104),
    [anon_sym___declspec] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3104),
    [anon_sym_signed] = ACTIONS(3102),
    [anon_sym_unsigned] = ACTIONS(3102),
    [anon_sym_long] = ACTIONS(3102),
    [anon_sym_short] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_static] = ACTIONS(3102),
    [anon_sym_register] = ACTIONS(3102),
    [anon_sym_inline] = ACTIONS(3102),
    [anon_sym___inline] = ACTIONS(3102),
    [anon_sym___inline__] = ACTIONS(3102),
    [anon_sym___forceinline] = ACTIONS(3102),
    [anon_sym_thread_local] = ACTIONS(3102),
    [anon_sym___thread] = ACTIONS(3102),
    [anon_sym_const] = ACTIONS(3102),
    [anon_sym_constexpr] = ACTIONS(3102),
    [anon_sym_volatile] = ACTIONS(3102),
    [anon_sym_restrict] = ACTIONS(3102),
    [anon_sym___restrict__] = ACTIONS(3102),
    [anon_sym__Atomic] = ACTIONS(3102),
    [anon_sym__Noreturn] = ACTIONS(3102),
    [anon_sym_noreturn] = ACTIONS(3102),
    [anon_sym_mutable] = ACTIONS(3102),
    [anon_sym_constinit] = ACTIONS(3102),
    [anon_sym_consteval] = ACTIONS(3102),
    [anon_sym_PROGMEM] = ACTIONS(3102),
    [aux_sym_primitive_type_token1] = ACTIONS(3102),
    [anon_sym_byte] = ACTIONS(3102),
    [anon_sym_word] = ACTIONS(3102),
    [anon_sym_enum] = ACTIONS(3102),
    [anon_sym_class] = ACTIONS(3102),
    [anon_sym_struct] = ACTIONS(3102),
    [anon_sym_union] = ACTIONS(3102),
    [anon_sym_if] = ACTIONS(3102),
    [anon_sym_else] = ACTIONS(3102),
    [anon_sym_switch] = ACTIONS(3102),
    [anon_sym_while] = ACTIONS(3102),
    [anon_sym_do] = ACTIONS(3102),
    [anon_sym_for] = ACTIONS(3102),
    [anon_sym_return] = ACTIONS(3102),
    [anon_sym_break] = ACTIONS(3102),
    [anon_sym_continue] = ACTIONS(3102),
    [anon_sym_goto] = ACTIONS(3102),
    [anon_sym___try] = ACTIONS(3102),
    [anon_sym___leave] = ACTIONS(3102),
    [anon_sym_not] = ACTIONS(3102),
    [anon_sym_compl] = ACTIONS(3102),
    [anon_sym_DASH_DASH] = ACTIONS(3104),
    [anon_sym_PLUS_PLUS] = ACTIONS(3104),
    [anon_sym_sizeof] = ACTIONS(3102),
    [anon_sym___alignof__] = ACTIONS(3102),
    [anon_sym___alignof] = ACTIONS(3102),
    [anon_sym__alignof] = ACTIONS(3102),
    [anon_sym_alignof] = ACTIONS(3102),
    [anon_sym__Alignof] = ACTIONS(3102),
    [anon_sym_offsetof] = ACTIONS(3102),
    [anon_sym__Generic] = ACTIONS(3102),
    [anon_sym_asm] = ACTIONS(3102),
    [anon_sym___asm__] = ACTIONS(3102),
    [aux_sym_number_literal_token1] = ACTIONS(3104),
    [aux_sym_number_literal_token2] = ACTIONS(3102),
    [anon_sym_L_SQUOTE] = ACTIONS(3104),
    [anon_sym_u_SQUOTE] = ACTIONS(3104),
    [anon_sym_U_SQUOTE] = ACTIONS(3104),
    [anon_sym_u8_SQUOTE] = ACTIONS(3104),
    [anon_sym_SQUOTE] = ACTIONS(3104),
    [anon_sym_L_DQUOTE] = ACTIONS(3104),
    [anon_sym_u_DQUOTE] = ACTIONS(3104),
    [anon_sym_U_DQUOTE] = ACTIONS(3104),
    [anon_sym_u8_DQUOTE] = ACTIONS(3104),
    [anon_sym_DQUOTE] = ACTIONS(3104),
    [sym_true] = ACTIONS(3102),
    [sym_false] = ACTIONS(3102),
    [anon_sym_NULL] = ACTIONS(3102),
    [anon_sym_nullptr] = ACTIONS(3102),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3102),
    [anon_sym_decltype] = ACTIONS(3102),
    [anon_sym_virtual] = ACTIONS(3102),
    [anon_sym_alignas] = ACTIONS(3102),
    [anon_sym_typename] = ACTIONS(3102),
    [anon_sym_template] = ACTIONS(3102),
    [anon_sym_try] = ACTIONS(3102),
    [anon_sym_delete] = ACTIONS(3102),
    [anon_sym_throw] = ACTIONS(3102),
    [anon_sym_co_return] = ACTIONS(3102),
    [anon_sym_co_yield] = ACTIONS(3102),
    [anon_sym_R_DQUOTE] = ACTIONS(3104),
    [anon_sym_LR_DQUOTE] = ACTIONS(3104),
    [anon_sym_uR_DQUOTE] = ACTIONS(3104),
    [anon_sym_UR_DQUOTE] = ACTIONS(3104),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3104),
    [anon_sym_co_await] = ACTIONS(3102),
    [anon_sym_new] = ACTIONS(3102),
    [anon_sym_requires] = ACTIONS(3102),
    [sym_this] = ACTIONS(3102),
  },
  [1186] = {
    [sym_identifier] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [1187] = {
    [sym_identifier] = ACTIONS(3108),
    [anon_sym_LPAREN2] = ACTIONS(3110),
    [anon_sym_BANG] = ACTIONS(3110),
    [anon_sym_TILDE] = ACTIONS(3110),
    [anon_sym_DASH] = ACTIONS(3108),
    [anon_sym_PLUS] = ACTIONS(3108),
    [anon_sym_STAR] = ACTIONS(3110),
    [anon_sym_AMP] = ACTIONS(3110),
    [anon_sym_SEMI] = ACTIONS(3110),
    [anon_sym___extension__] = ACTIONS(3108),
    [anon_sym_typedef] = ACTIONS(3108),
    [anon_sym_extern] = ACTIONS(3108),
    [anon_sym___attribute__] = ACTIONS(3108),
    [anon_sym_COLON_COLON] = ACTIONS(3110),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3110),
    [anon_sym___declspec] = ACTIONS(3108),
    [anon_sym_LBRACE] = ACTIONS(3110),
    [anon_sym_signed] = ACTIONS(3108),
    [anon_sym_unsigned] = ACTIONS(3108),
    [anon_sym_long] = ACTIONS(3108),
    [anon_sym_short] = ACTIONS(3108),
    [anon_sym_LBRACK] = ACTIONS(3108),
    [anon_sym_static] = ACTIONS(3108),
    [anon_sym_register] = ACTIONS(3108),
    [anon_sym_inline] = ACTIONS(3108),
    [anon_sym___inline] = ACTIONS(3108),
    [anon_sym___inline__] = ACTIONS(3108),
    [anon_sym___forceinline] = ACTIONS(3108),
    [anon_sym_thread_local] = ACTIONS(3108),
    [anon_sym___thread] = ACTIONS(3108),
    [anon_sym_const] = ACTIONS(3108),
    [anon_sym_constexpr] = ACTIONS(3108),
    [anon_sym_volatile] = ACTIONS(3108),
    [anon_sym_restrict] = ACTIONS(3108),
    [anon_sym___restrict__] = ACTIONS(3108),
    [anon_sym__Atomic] = ACTIONS(3108),
    [anon_sym__Noreturn] = ACTIONS(3108),
    [anon_sym_noreturn] = ACTIONS(3108),
    [anon_sym_mutable] = ACTIONS(3108),
    [anon_sym_constinit] = ACTIONS(3108),
    [anon_sym_consteval] = ACTIONS(3108),
    [anon_sym_PROGMEM] = ACTIONS(3108),
    [aux_sym_primitive_type_token1] = ACTIONS(3108),
    [anon_sym_byte] = ACTIONS(3108),
    [anon_sym_word] = ACTIONS(3108),
    [anon_sym_enum] = ACTIONS(3108),
    [anon_sym_class] = ACTIONS(3108),
    [anon_sym_struct] = ACTIONS(3108),
    [anon_sym_union] = ACTIONS(3108),
    [anon_sym_if] = ACTIONS(3108),
    [anon_sym_else] = ACTIONS(3108),
    [anon_sym_switch] = ACTIONS(3108),
    [anon_sym_while] = ACTIONS(3108),
    [anon_sym_do] = ACTIONS(3108),
    [anon_sym_for] = ACTIONS(3108),
    [anon_sym_return] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3108),
    [anon_sym_continue] = ACTIONS(3108),
    [anon_sym_goto] = ACTIONS(3108),
    [anon_sym___try] = ACTIONS(3108),
    [anon_sym___leave] = ACTIONS(3108),
    [anon_sym_not] = ACTIONS(3108),
    [anon_sym_compl] = ACTIONS(3108),
    [anon_sym_DASH_DASH] = ACTIONS(3110),
    [anon_sym_PLUS_PLUS] = ACTIONS(3110),
    [anon_sym_sizeof] = ACTIONS(3108),
    [anon_sym___alignof__] = ACTIONS(3108),
    [anon_sym___alignof] = ACTIONS(3108),
    [anon_sym__alignof] = ACTIONS(3108),
    [anon_sym_alignof] = ACTIONS(3108),
    [anon_sym__Alignof] = ACTIONS(3108),
    [anon_sym_offsetof] = ACTIONS(3108),
    [anon_sym__Generic] = ACTIONS(3108),
    [anon_sym_asm] = ACTIONS(3108),
    [anon_sym___asm__] = ACTIONS(3108),
    [aux_sym_number_literal_token1] = ACTIONS(3110),
    [aux_sym_number_literal_token2] = ACTIONS(3108),
    [anon_sym_L_SQUOTE] = ACTIONS(3110),
    [anon_sym_u_SQUOTE] = ACTIONS(3110),
    [anon_sym_U_SQUOTE] = ACTIONS(3110),
    [anon_sym_u8_SQUOTE] = ACTIONS(3110),
    [anon_sym_SQUOTE] = ACTIONS(3110),
    [anon_sym_L_DQUOTE] = ACTIONS(3110),
    [anon_sym_u_DQUOTE] = ACTIONS(3110),
    [anon_sym_U_DQUOTE] = ACTIONS(3110),
    [anon_sym_u8_DQUOTE] = ACTIONS(3110),
    [anon_sym_DQUOTE] = ACTIONS(3110),
    [sym_true] = ACTIONS(3108),
    [sym_false] = ACTIONS(3108),
    [anon_sym_NULL] = ACTIONS(3108),
    [anon_sym_nullptr] = ACTIONS(3108),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3108),
    [anon_sym_decltype] = ACTIONS(3108),
    [anon_sym_virtual] = ACTIONS(3108),
    [anon_sym_alignas] = ACTIONS(3108),
    [anon_sym_typename] = ACTIONS(3108),
    [anon_sym_template] = ACTIONS(3108),
    [anon_sym_try] = ACTIONS(3108),
    [anon_sym_delete] = ACTIONS(3108),
    [anon_sym_throw] = ACTIONS(3108),
    [anon_sym_co_return] = ACTIONS(3108),
    [anon_sym_co_yield] = ACTIONS(3108),
    [anon_sym_R_DQUOTE] = ACTIONS(3110),
    [anon_sym_LR_DQUOTE] = ACTIONS(3110),
    [anon_sym_uR_DQUOTE] = ACTIONS(3110),
    [anon_sym_UR_DQUOTE] = ACTIONS(3110),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3110),
    [anon_sym_co_await] = ACTIONS(3108),
    [anon_sym_new] = ACTIONS(3108),
    [anon_sym_requires] = ACTIONS(3108),
    [sym_this] = ACTIONS(3108),
  },
  [1188] = {
    [sym_identifier] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [1189] = {
    [sym_identifier] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [1190] = {
    [sym_identifier] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [1191] = {
    [sym_identifier] = ACTIONS(3150),
    [anon_sym_LPAREN2] = ACTIONS(3152),
    [anon_sym_BANG] = ACTIONS(3152),
    [anon_sym_TILDE] = ACTIONS(3152),
    [anon_sym_DASH] = ACTIONS(3150),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_STAR] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3152),
    [anon_sym_SEMI] = ACTIONS(3152),
    [anon_sym___extension__] = ACTIONS(3150),
    [anon_sym_typedef] = ACTIONS(3150),
    [anon_sym_extern] = ACTIONS(3150),
    [anon_sym___attribute__] = ACTIONS(3150),
    [anon_sym_COLON_COLON] = ACTIONS(3152),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3152),
    [anon_sym___declspec] = ACTIONS(3150),
    [anon_sym_LBRACE] = ACTIONS(3152),
    [anon_sym_signed] = ACTIONS(3150),
    [anon_sym_unsigned] = ACTIONS(3150),
    [anon_sym_long] = ACTIONS(3150),
    [anon_sym_short] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3150),
    [anon_sym_static] = ACTIONS(3150),
    [anon_sym_register] = ACTIONS(3150),
    [anon_sym_inline] = ACTIONS(3150),
    [anon_sym___inline] = ACTIONS(3150),
    [anon_sym___inline__] = ACTIONS(3150),
    [anon_sym___forceinline] = ACTIONS(3150),
    [anon_sym_thread_local] = ACTIONS(3150),
    [anon_sym___thread] = ACTIONS(3150),
    [anon_sym_const] = ACTIONS(3150),
    [anon_sym_constexpr] = ACTIONS(3150),
    [anon_sym_volatile] = ACTIONS(3150),
    [anon_sym_restrict] = ACTIONS(3150),
    [anon_sym___restrict__] = ACTIONS(3150),
    [anon_sym__Atomic] = ACTIONS(3150),
    [anon_sym__Noreturn] = ACTIONS(3150),
    [anon_sym_noreturn] = ACTIONS(3150),
    [anon_sym_mutable] = ACTIONS(3150),
    [anon_sym_constinit] = ACTIONS(3150),
    [anon_sym_consteval] = ACTIONS(3150),
    [anon_sym_PROGMEM] = ACTIONS(3150),
    [aux_sym_primitive_type_token1] = ACTIONS(3150),
    [anon_sym_byte] = ACTIONS(3150),
    [anon_sym_word] = ACTIONS(3150),
    [anon_sym_enum] = ACTIONS(3150),
    [anon_sym_class] = ACTIONS(3150),
    [anon_sym_struct] = ACTIONS(3150),
    [anon_sym_union] = ACTIONS(3150),
    [anon_sym_if] = ACTIONS(3150),
    [anon_sym_else] = ACTIONS(3150),
    [anon_sym_switch] = ACTIONS(3150),
    [anon_sym_while] = ACTIONS(3150),
    [anon_sym_do] = ACTIONS(3150),
    [anon_sym_for] = ACTIONS(3150),
    [anon_sym_return] = ACTIONS(3150),
    [anon_sym_break] = ACTIONS(3150),
    [anon_sym_continue] = ACTIONS(3150),
    [anon_sym_goto] = ACTIONS(3150),
    [anon_sym___try] = ACTIONS(3150),
    [anon_sym___leave] = ACTIONS(3150),
    [anon_sym_not] = ACTIONS(3150),
    [anon_sym_compl] = ACTIONS(3150),
    [anon_sym_DASH_DASH] = ACTIONS(3152),
    [anon_sym_PLUS_PLUS] = ACTIONS(3152),
    [anon_sym_sizeof] = ACTIONS(3150),
    [anon_sym___alignof__] = ACTIONS(3150),
    [anon_sym___alignof] = ACTIONS(3150),
    [anon_sym__alignof] = ACTIONS(3150),
    [anon_sym_alignof] = ACTIONS(3150),
    [anon_sym__Alignof] = ACTIONS(3150),
    [anon_sym_offsetof] = ACTIONS(3150),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3150),
    [anon_sym___asm__] = ACTIONS(3150),
    [aux_sym_number_literal_token1] = ACTIONS(3152),
    [aux_sym_number_literal_token2] = ACTIONS(3150),
    [anon_sym_L_SQUOTE] = ACTIONS(3152),
    [anon_sym_u_SQUOTE] = ACTIONS(3152),
    [anon_sym_U_SQUOTE] = ACTIONS(3152),
    [anon_sym_u8_SQUOTE] = ACTIONS(3152),
    [anon_sym_SQUOTE] = ACTIONS(3152),
    [anon_sym_L_DQUOTE] = ACTIONS(3152),
    [anon_sym_u_DQUOTE] = ACTIONS(3152),
    [anon_sym_U_DQUOTE] = ACTIONS(3152),
    [anon_sym_u8_DQUOTE] = ACTIONS(3152),
    [anon_sym_DQUOTE] = ACTIONS(3152),
    [sym_true] = ACTIONS(3150),
    [sym_false] = ACTIONS(3150),
    [anon_sym_NULL] = ACTIONS(3150),
    [anon_sym_nullptr] = ACTIONS(3150),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3150),
    [anon_sym_decltype] = ACTIONS(3150),
    [anon_sym_virtual] = ACTIONS(3150),
    [anon_sym_alignas] = ACTIONS(3150),
    [anon_sym_typename] = ACTIONS(3150),
    [anon_sym_template] = ACTIONS(3150),
    [anon_sym_try] = ACTIONS(3150),
    [anon_sym_delete] = ACTIONS(3150),
    [anon_sym_throw] = ACTIONS(3150),
    [anon_sym_co_return] = ACTIONS(3150),
    [anon_sym_co_yield] = ACTIONS(3150),
    [anon_sym_R_DQUOTE] = ACTIONS(3152),
    [anon_sym_LR_DQUOTE] = ACTIONS(3152),
    [anon_sym_uR_DQUOTE] = ACTIONS(3152),
    [anon_sym_UR_DQUOTE] = ACTIONS(3152),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3152),
    [anon_sym_co_await] = ACTIONS(3150),
    [anon_sym_new] = ACTIONS(3150),
    [anon_sym_requires] = ACTIONS(3150),
    [sym_this] = ACTIONS(3150),
  },
  [1192] = {
    [sym_identifier] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3156),
    [anon_sym_BANG] = ACTIONS(3156),
    [anon_sym_TILDE] = ACTIONS(3156),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_STAR] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_SEMI] = ACTIONS(3156),
    [anon_sym___extension__] = ACTIONS(3154),
    [anon_sym_typedef] = ACTIONS(3154),
    [anon_sym_extern] = ACTIONS(3154),
    [anon_sym___attribute__] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3156),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3156),
    [anon_sym___declspec] = ACTIONS(3154),
    [anon_sym_LBRACE] = ACTIONS(3156),
    [anon_sym_signed] = ACTIONS(3154),
    [anon_sym_unsigned] = ACTIONS(3154),
    [anon_sym_long] = ACTIONS(3154),
    [anon_sym_short] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_static] = ACTIONS(3154),
    [anon_sym_register] = ACTIONS(3154),
    [anon_sym_inline] = ACTIONS(3154),
    [anon_sym___inline] = ACTIONS(3154),
    [anon_sym___inline__] = ACTIONS(3154),
    [anon_sym___forceinline] = ACTIONS(3154),
    [anon_sym_thread_local] = ACTIONS(3154),
    [anon_sym___thread] = ACTIONS(3154),
    [anon_sym_const] = ACTIONS(3154),
    [anon_sym_constexpr] = ACTIONS(3154),
    [anon_sym_volatile] = ACTIONS(3154),
    [anon_sym_restrict] = ACTIONS(3154),
    [anon_sym___restrict__] = ACTIONS(3154),
    [anon_sym__Atomic] = ACTIONS(3154),
    [anon_sym__Noreturn] = ACTIONS(3154),
    [anon_sym_noreturn] = ACTIONS(3154),
    [anon_sym_mutable] = ACTIONS(3154),
    [anon_sym_constinit] = ACTIONS(3154),
    [anon_sym_consteval] = ACTIONS(3154),
    [anon_sym_PROGMEM] = ACTIONS(3154),
    [aux_sym_primitive_type_token1] = ACTIONS(3154),
    [anon_sym_byte] = ACTIONS(3154),
    [anon_sym_word] = ACTIONS(3154),
    [anon_sym_enum] = ACTIONS(3154),
    [anon_sym_class] = ACTIONS(3154),
    [anon_sym_struct] = ACTIONS(3154),
    [anon_sym_union] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_else] = ACTIONS(3154),
    [anon_sym_switch] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_break] = ACTIONS(3154),
    [anon_sym_continue] = ACTIONS(3154),
    [anon_sym_goto] = ACTIONS(3154),
    [anon_sym___try] = ACTIONS(3154),
    [anon_sym___leave] = ACTIONS(3154),
    [anon_sym_not] = ACTIONS(3154),
    [anon_sym_compl] = ACTIONS(3154),
    [anon_sym_DASH_DASH] = ACTIONS(3156),
    [anon_sym_PLUS_PLUS] = ACTIONS(3156),
    [anon_sym_sizeof] = ACTIONS(3154),
    [anon_sym___alignof__] = ACTIONS(3154),
    [anon_sym___alignof] = ACTIONS(3154),
    [anon_sym__alignof] = ACTIONS(3154),
    [anon_sym_alignof] = ACTIONS(3154),
    [anon_sym__Alignof] = ACTIONS(3154),
    [anon_sym_offsetof] = ACTIONS(3154),
    [anon_sym__Generic] = ACTIONS(3154),
    [anon_sym_asm] = ACTIONS(3154),
    [anon_sym___asm__] = ACTIONS(3154),
    [aux_sym_number_literal_token1] = ACTIONS(3156),
    [aux_sym_number_literal_token2] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3156),
    [anon_sym_u_DQUOTE] = ACTIONS(3156),
    [anon_sym_U_DQUOTE] = ACTIONS(3156),
    [anon_sym_u8_DQUOTE] = ACTIONS(3156),
    [anon_sym_DQUOTE] = ACTIONS(3156),
    [sym_true] = ACTIONS(3154),
    [sym_false] = ACTIONS(3154),
    [anon_sym_NULL] = ACTIONS(3154),
    [anon_sym_nullptr] = ACTIONS(3154),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3154),
    [anon_sym_decltype] = ACTIONS(3154),
    [anon_sym_virtual] = ACTIONS(3154),
    [anon_sym_alignas] = ACTIONS(3154),
    [anon_sym_typename] = ACTIONS(3154),
    [anon_sym_template] = ACTIONS(3154),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_delete] = ACTIONS(3154),
    [anon_sym_throw] = ACTIONS(3154),
    [anon_sym_co_return] = ACTIONS(3154),
    [anon_sym_co_yield] = ACTIONS(3154),
    [anon_sym_R_DQUOTE] = ACTIONS(3156),
    [anon_sym_LR_DQUOTE] = ACTIONS(3156),
    [anon_sym_uR_DQUOTE] = ACTIONS(3156),
    [anon_sym_UR_DQUOTE] = ACTIONS(3156),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3156),
    [anon_sym_co_await] = ACTIONS(3154),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_requires] = ACTIONS(3154),
    [sym_this] = ACTIONS(3154),
  },
  [1193] = {
    [sym_identifier] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [1194] = {
    [sym_identifier] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [1195] = {
    [sym_identifier] = ACTIONS(3162),
    [anon_sym_LPAREN2] = ACTIONS(3164),
    [anon_sym_BANG] = ACTIONS(3164),
    [anon_sym_TILDE] = ACTIONS(3164),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_STAR] = ACTIONS(3164),
    [anon_sym_AMP] = ACTIONS(3164),
    [anon_sym_SEMI] = ACTIONS(3164),
    [anon_sym___extension__] = ACTIONS(3162),
    [anon_sym_typedef] = ACTIONS(3162),
    [anon_sym_extern] = ACTIONS(3162),
    [anon_sym___attribute__] = ACTIONS(3162),
    [anon_sym_COLON_COLON] = ACTIONS(3164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3164),
    [anon_sym___declspec] = ACTIONS(3162),
    [anon_sym_LBRACE] = ACTIONS(3164),
    [anon_sym_signed] = ACTIONS(3162),
    [anon_sym_unsigned] = ACTIONS(3162),
    [anon_sym_long] = ACTIONS(3162),
    [anon_sym_short] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_register] = ACTIONS(3162),
    [anon_sym_inline] = ACTIONS(3162),
    [anon_sym___inline] = ACTIONS(3162),
    [anon_sym___inline__] = ACTIONS(3162),
    [anon_sym___forceinline] = ACTIONS(3162),
    [anon_sym_thread_local] = ACTIONS(3162),
    [anon_sym___thread] = ACTIONS(3162),
    [anon_sym_const] = ACTIONS(3162),
    [anon_sym_constexpr] = ACTIONS(3162),
    [anon_sym_volatile] = ACTIONS(3162),
    [anon_sym_restrict] = ACTIONS(3162),
    [anon_sym___restrict__] = ACTIONS(3162),
    [anon_sym__Atomic] = ACTIONS(3162),
    [anon_sym__Noreturn] = ACTIONS(3162),
    [anon_sym_noreturn] = ACTIONS(3162),
    [anon_sym_mutable] = ACTIONS(3162),
    [anon_sym_constinit] = ACTIONS(3162),
    [anon_sym_consteval] = ACTIONS(3162),
    [anon_sym_PROGMEM] = ACTIONS(3162),
    [aux_sym_primitive_type_token1] = ACTIONS(3162),
    [anon_sym_byte] = ACTIONS(3162),
    [anon_sym_word] = ACTIONS(3162),
    [anon_sym_enum] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_struct] = ACTIONS(3162),
    [anon_sym_union] = ACTIONS(3162),
    [anon_sym_if] = ACTIONS(3162),
    [anon_sym_else] = ACTIONS(3162),
    [anon_sym_switch] = ACTIONS(3162),
    [anon_sym_while] = ACTIONS(3162),
    [anon_sym_do] = ACTIONS(3162),
    [anon_sym_for] = ACTIONS(3162),
    [anon_sym_return] = ACTIONS(3162),
    [anon_sym_break] = ACTIONS(3162),
    [anon_sym_continue] = ACTIONS(3162),
    [anon_sym_goto] = ACTIONS(3162),
    [anon_sym___try] = ACTIONS(3162),
    [anon_sym___leave] = ACTIONS(3162),
    [anon_sym_not] = ACTIONS(3162),
    [anon_sym_compl] = ACTIONS(3162),
    [anon_sym_DASH_DASH] = ACTIONS(3164),
    [anon_sym_PLUS_PLUS] = ACTIONS(3164),
    [anon_sym_sizeof] = ACTIONS(3162),
    [anon_sym___alignof__] = ACTIONS(3162),
    [anon_sym___alignof] = ACTIONS(3162),
    [anon_sym__alignof] = ACTIONS(3162),
    [anon_sym_alignof] = ACTIONS(3162),
    [anon_sym__Alignof] = ACTIONS(3162),
    [anon_sym_offsetof] = ACTIONS(3162),
    [anon_sym__Generic] = ACTIONS(3162),
    [anon_sym_asm] = ACTIONS(3162),
    [anon_sym___asm__] = ACTIONS(3162),
    [aux_sym_number_literal_token1] = ACTIONS(3164),
    [aux_sym_number_literal_token2] = ACTIONS(3162),
    [anon_sym_L_SQUOTE] = ACTIONS(3164),
    [anon_sym_u_SQUOTE] = ACTIONS(3164),
    [anon_sym_U_SQUOTE] = ACTIONS(3164),
    [anon_sym_u8_SQUOTE] = ACTIONS(3164),
    [anon_sym_SQUOTE] = ACTIONS(3164),
    [anon_sym_L_DQUOTE] = ACTIONS(3164),
    [anon_sym_u_DQUOTE] = ACTIONS(3164),
    [anon_sym_U_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8_DQUOTE] = ACTIONS(3164),
    [anon_sym_DQUOTE] = ACTIONS(3164),
    [sym_true] = ACTIONS(3162),
    [sym_false] = ACTIONS(3162),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3162),
    [anon_sym_decltype] = ACTIONS(3162),
    [anon_sym_virtual] = ACTIONS(3162),
    [anon_sym_alignas] = ACTIONS(3162),
    [anon_sym_typename] = ACTIONS(3162),
    [anon_sym_template] = ACTIONS(3162),
    [anon_sym_try] = ACTIONS(3162),
    [anon_sym_delete] = ACTIONS(3162),
    [anon_sym_throw] = ACTIONS(3162),
    [anon_sym_co_return] = ACTIONS(3162),
    [anon_sym_co_yield] = ACTIONS(3162),
    [anon_sym_R_DQUOTE] = ACTIONS(3164),
    [anon_sym_LR_DQUOTE] = ACTIONS(3164),
    [anon_sym_uR_DQUOTE] = ACTIONS(3164),
    [anon_sym_UR_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3164),
    [anon_sym_co_await] = ACTIONS(3162),
    [anon_sym_new] = ACTIONS(3162),
    [anon_sym_requires] = ACTIONS(3162),
    [sym_this] = ACTIONS(3162),
  },
  [1196] = {
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_LPAREN2] = ACTIONS(2968),
    [anon_sym_BANG] = ACTIONS(2968),
    [anon_sym_TILDE] = ACTIONS(2968),
    [anon_sym_DASH] = ACTIONS(2966),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_STAR] = ACTIONS(2968),
    [anon_sym_AMP] = ACTIONS(2968),
    [anon_sym_SEMI] = ACTIONS(2968),
    [anon_sym___extension__] = ACTIONS(2966),
    [anon_sym_typedef] = ACTIONS(2966),
    [anon_sym_extern] = ACTIONS(2966),
    [anon_sym___attribute__] = ACTIONS(2966),
    [anon_sym_COLON_COLON] = ACTIONS(2968),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2968),
    [anon_sym___declspec] = ACTIONS(2966),
    [anon_sym_LBRACE] = ACTIONS(2968),
    [anon_sym_signed] = ACTIONS(2966),
    [anon_sym_unsigned] = ACTIONS(2966),
    [anon_sym_long] = ACTIONS(2966),
    [anon_sym_short] = ACTIONS(2966),
    [anon_sym_LBRACK] = ACTIONS(2966),
    [anon_sym_static] = ACTIONS(2966),
    [anon_sym_register] = ACTIONS(2966),
    [anon_sym_inline] = ACTIONS(2966),
    [anon_sym___inline] = ACTIONS(2966),
    [anon_sym___inline__] = ACTIONS(2966),
    [anon_sym___forceinline] = ACTIONS(2966),
    [anon_sym_thread_local] = ACTIONS(2966),
    [anon_sym___thread] = ACTIONS(2966),
    [anon_sym_const] = ACTIONS(2966),
    [anon_sym_constexpr] = ACTIONS(2966),
    [anon_sym_volatile] = ACTIONS(2966),
    [anon_sym_restrict] = ACTIONS(2966),
    [anon_sym___restrict__] = ACTIONS(2966),
    [anon_sym__Atomic] = ACTIONS(2966),
    [anon_sym__Noreturn] = ACTIONS(2966),
    [anon_sym_noreturn] = ACTIONS(2966),
    [anon_sym_mutable] = ACTIONS(2966),
    [anon_sym_constinit] = ACTIONS(2966),
    [anon_sym_consteval] = ACTIONS(2966),
    [anon_sym_PROGMEM] = ACTIONS(2966),
    [aux_sym_primitive_type_token1] = ACTIONS(2966),
    [anon_sym_byte] = ACTIONS(2966),
    [anon_sym_word] = ACTIONS(2966),
    [anon_sym_enum] = ACTIONS(2966),
    [anon_sym_class] = ACTIONS(2966),
    [anon_sym_struct] = ACTIONS(2966),
    [anon_sym_union] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_else] = ACTIONS(2966),
    [anon_sym_switch] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_for] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2966),
    [anon_sym_break] = ACTIONS(2966),
    [anon_sym_continue] = ACTIONS(2966),
    [anon_sym_goto] = ACTIONS(2966),
    [anon_sym___try] = ACTIONS(2966),
    [anon_sym___leave] = ACTIONS(2966),
    [anon_sym_not] = ACTIONS(2966),
    [anon_sym_compl] = ACTIONS(2966),
    [anon_sym_DASH_DASH] = ACTIONS(2968),
    [anon_sym_PLUS_PLUS] = ACTIONS(2968),
    [anon_sym_sizeof] = ACTIONS(2966),
    [anon_sym___alignof__] = ACTIONS(2966),
    [anon_sym___alignof] = ACTIONS(2966),
    [anon_sym__alignof] = ACTIONS(2966),
    [anon_sym_alignof] = ACTIONS(2966),
    [anon_sym__Alignof] = ACTIONS(2966),
    [anon_sym_offsetof] = ACTIONS(2966),
    [anon_sym__Generic] = ACTIONS(2966),
    [anon_sym_asm] = ACTIONS(2966),
    [anon_sym___asm__] = ACTIONS(2966),
    [aux_sym_number_literal_token1] = ACTIONS(2968),
    [aux_sym_number_literal_token2] = ACTIONS(2966),
    [anon_sym_L_SQUOTE] = ACTIONS(2968),
    [anon_sym_u_SQUOTE] = ACTIONS(2968),
    [anon_sym_U_SQUOTE] = ACTIONS(2968),
    [anon_sym_u8_SQUOTE] = ACTIONS(2968),
    [anon_sym_SQUOTE] = ACTIONS(2968),
    [anon_sym_L_DQUOTE] = ACTIONS(2968),
    [anon_sym_u_DQUOTE] = ACTIONS(2968),
    [anon_sym_U_DQUOTE] = ACTIONS(2968),
    [anon_sym_u8_DQUOTE] = ACTIONS(2968),
    [anon_sym_DQUOTE] = ACTIONS(2968),
    [sym_true] = ACTIONS(2966),
    [sym_false] = ACTIONS(2966),
    [anon_sym_NULL] = ACTIONS(2966),
    [anon_sym_nullptr] = ACTIONS(2966),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2966),
    [anon_sym_decltype] = ACTIONS(2966),
    [anon_sym_virtual] = ACTIONS(2966),
    [anon_sym_alignas] = ACTIONS(2966),
    [anon_sym_typename] = ACTIONS(2966),
    [anon_sym_template] = ACTIONS(2966),
    [anon_sym_try] = ACTIONS(2966),
    [anon_sym_delete] = ACTIONS(2966),
    [anon_sym_throw] = ACTIONS(2966),
    [anon_sym_co_return] = ACTIONS(2966),
    [anon_sym_co_yield] = ACTIONS(2966),
    [anon_sym_R_DQUOTE] = ACTIONS(2968),
    [anon_sym_LR_DQUOTE] = ACTIONS(2968),
    [anon_sym_uR_DQUOTE] = ACTIONS(2968),
    [anon_sym_UR_DQUOTE] = ACTIONS(2968),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2968),
    [anon_sym_co_await] = ACTIONS(2966),
    [anon_sym_new] = ACTIONS(2966),
    [anon_sym_requires] = ACTIONS(2966),
    [sym_this] = ACTIONS(2966),
  },
  [1197] = {
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_LPAREN2] = ACTIONS(2960),
    [anon_sym_BANG] = ACTIONS(2960),
    [anon_sym_TILDE] = ACTIONS(2960),
    [anon_sym_DASH] = ACTIONS(2958),
    [anon_sym_PLUS] = ACTIONS(2958),
    [anon_sym_STAR] = ACTIONS(2960),
    [anon_sym_AMP] = ACTIONS(2960),
    [anon_sym_SEMI] = ACTIONS(2960),
    [anon_sym___extension__] = ACTIONS(2958),
    [anon_sym_typedef] = ACTIONS(2958),
    [anon_sym_extern] = ACTIONS(2958),
    [anon_sym___attribute__] = ACTIONS(2958),
    [anon_sym_COLON_COLON] = ACTIONS(2960),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2960),
    [anon_sym___declspec] = ACTIONS(2958),
    [anon_sym_LBRACE] = ACTIONS(2960),
    [anon_sym_signed] = ACTIONS(2958),
    [anon_sym_unsigned] = ACTIONS(2958),
    [anon_sym_long] = ACTIONS(2958),
    [anon_sym_short] = ACTIONS(2958),
    [anon_sym_LBRACK] = ACTIONS(2958),
    [anon_sym_static] = ACTIONS(2958),
    [anon_sym_register] = ACTIONS(2958),
    [anon_sym_inline] = ACTIONS(2958),
    [anon_sym___inline] = ACTIONS(2958),
    [anon_sym___inline__] = ACTIONS(2958),
    [anon_sym___forceinline] = ACTIONS(2958),
    [anon_sym_thread_local] = ACTIONS(2958),
    [anon_sym___thread] = ACTIONS(2958),
    [anon_sym_const] = ACTIONS(2958),
    [anon_sym_constexpr] = ACTIONS(2958),
    [anon_sym_volatile] = ACTIONS(2958),
    [anon_sym_restrict] = ACTIONS(2958),
    [anon_sym___restrict__] = ACTIONS(2958),
    [anon_sym__Atomic] = ACTIONS(2958),
    [anon_sym__Noreturn] = ACTIONS(2958),
    [anon_sym_noreturn] = ACTIONS(2958),
    [anon_sym_mutable] = ACTIONS(2958),
    [anon_sym_constinit] = ACTIONS(2958),
    [anon_sym_consteval] = ACTIONS(2958),
    [anon_sym_PROGMEM] = ACTIONS(2958),
    [aux_sym_primitive_type_token1] = ACTIONS(2958),
    [anon_sym_byte] = ACTIONS(2958),
    [anon_sym_word] = ACTIONS(2958),
    [anon_sym_enum] = ACTIONS(2958),
    [anon_sym_class] = ACTIONS(2958),
    [anon_sym_struct] = ACTIONS(2958),
    [anon_sym_union] = ACTIONS(2958),
    [anon_sym_if] = ACTIONS(2958),
    [anon_sym_else] = ACTIONS(2958),
    [anon_sym_switch] = ACTIONS(2958),
    [anon_sym_while] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2958),
    [anon_sym_for] = ACTIONS(2958),
    [anon_sym_return] = ACTIONS(2958),
    [anon_sym_break] = ACTIONS(2958),
    [anon_sym_continue] = ACTIONS(2958),
    [anon_sym_goto] = ACTIONS(2958),
    [anon_sym___try] = ACTIONS(2958),
    [anon_sym___leave] = ACTIONS(2958),
    [anon_sym_not] = ACTIONS(2958),
    [anon_sym_compl] = ACTIONS(2958),
    [anon_sym_DASH_DASH] = ACTIONS(2960),
    [anon_sym_PLUS_PLUS] = ACTIONS(2960),
    [anon_sym_sizeof] = ACTIONS(2958),
    [anon_sym___alignof__] = ACTIONS(2958),
    [anon_sym___alignof] = ACTIONS(2958),
    [anon_sym__alignof] = ACTIONS(2958),
    [anon_sym_alignof] = ACTIONS(2958),
    [anon_sym__Alignof] = ACTIONS(2958),
    [anon_sym_offsetof] = ACTIONS(2958),
    [anon_sym__Generic] = ACTIONS(2958),
    [anon_sym_asm] = ACTIONS(2958),
    [anon_sym___asm__] = ACTIONS(2958),
    [aux_sym_number_literal_token1] = ACTIONS(2960),
    [aux_sym_number_literal_token2] = ACTIONS(2958),
    [anon_sym_L_SQUOTE] = ACTIONS(2960),
    [anon_sym_u_SQUOTE] = ACTIONS(2960),
    [anon_sym_U_SQUOTE] = ACTIONS(2960),
    [anon_sym_u8_SQUOTE] = ACTIONS(2960),
    [anon_sym_SQUOTE] = ACTIONS(2960),
    [anon_sym_L_DQUOTE] = ACTIONS(2960),
    [anon_sym_u_DQUOTE] = ACTIONS(2960),
    [anon_sym_U_DQUOTE] = ACTIONS(2960),
    [anon_sym_u8_DQUOTE] = ACTIONS(2960),
    [anon_sym_DQUOTE] = ACTIONS(2960),
    [sym_true] = ACTIONS(2958),
    [sym_false] = ACTIONS(2958),
    [anon_sym_NULL] = ACTIONS(2958),
    [anon_sym_nullptr] = ACTIONS(2958),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2958),
    [anon_sym_decltype] = ACTIONS(2958),
    [anon_sym_virtual] = ACTIONS(2958),
    [anon_sym_alignas] = ACTIONS(2958),
    [anon_sym_typename] = ACTIONS(2958),
    [anon_sym_template] = ACTIONS(2958),
    [anon_sym_try] = ACTIONS(2958),
    [anon_sym_delete] = ACTIONS(2958),
    [anon_sym_throw] = ACTIONS(2958),
    [anon_sym_co_return] = ACTIONS(2958),
    [anon_sym_co_yield] = ACTIONS(2958),
    [anon_sym_R_DQUOTE] = ACTIONS(2960),
    [anon_sym_LR_DQUOTE] = ACTIONS(2960),
    [anon_sym_uR_DQUOTE] = ACTIONS(2960),
    [anon_sym_UR_DQUOTE] = ACTIONS(2960),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2960),
    [anon_sym_co_await] = ACTIONS(2958),
    [anon_sym_new] = ACTIONS(2958),
    [anon_sym_requires] = ACTIONS(2958),
    [sym_this] = ACTIONS(2958),
  },
  [1198] = {
    [sym_identifier] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [1199] = {
    [sym_identifier] = ACTIONS(3086),
    [anon_sym_LPAREN2] = ACTIONS(3088),
    [anon_sym_BANG] = ACTIONS(3088),
    [anon_sym_TILDE] = ACTIONS(3088),
    [anon_sym_DASH] = ACTIONS(3086),
    [anon_sym_PLUS] = ACTIONS(3086),
    [anon_sym_STAR] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3088),
    [anon_sym_SEMI] = ACTIONS(3088),
    [anon_sym___extension__] = ACTIONS(3086),
    [anon_sym_typedef] = ACTIONS(3086),
    [anon_sym_extern] = ACTIONS(3086),
    [anon_sym___attribute__] = ACTIONS(3086),
    [anon_sym_COLON_COLON] = ACTIONS(3088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3088),
    [anon_sym___declspec] = ACTIONS(3086),
    [anon_sym_LBRACE] = ACTIONS(3088),
    [anon_sym_signed] = ACTIONS(3086),
    [anon_sym_unsigned] = ACTIONS(3086),
    [anon_sym_long] = ACTIONS(3086),
    [anon_sym_short] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(3086),
    [anon_sym_static] = ACTIONS(3086),
    [anon_sym_register] = ACTIONS(3086),
    [anon_sym_inline] = ACTIONS(3086),
    [anon_sym___inline] = ACTIONS(3086),
    [anon_sym___inline__] = ACTIONS(3086),
    [anon_sym___forceinline] = ACTIONS(3086),
    [anon_sym_thread_local] = ACTIONS(3086),
    [anon_sym___thread] = ACTIONS(3086),
    [anon_sym_const] = ACTIONS(3086),
    [anon_sym_constexpr] = ACTIONS(3086),
    [anon_sym_volatile] = ACTIONS(3086),
    [anon_sym_restrict] = ACTIONS(3086),
    [anon_sym___restrict__] = ACTIONS(3086),
    [anon_sym__Atomic] = ACTIONS(3086),
    [anon_sym__Noreturn] = ACTIONS(3086),
    [anon_sym_noreturn] = ACTIONS(3086),
    [anon_sym_mutable] = ACTIONS(3086),
    [anon_sym_constinit] = ACTIONS(3086),
    [anon_sym_consteval] = ACTIONS(3086),
    [anon_sym_PROGMEM] = ACTIONS(3086),
    [aux_sym_primitive_type_token1] = ACTIONS(3086),
    [anon_sym_byte] = ACTIONS(3086),
    [anon_sym_word] = ACTIONS(3086),
    [anon_sym_enum] = ACTIONS(3086),
    [anon_sym_class] = ACTIONS(3086),
    [anon_sym_struct] = ACTIONS(3086),
    [anon_sym_union] = ACTIONS(3086),
    [anon_sym_if] = ACTIONS(3086),
    [anon_sym_else] = ACTIONS(3086),
    [anon_sym_switch] = ACTIONS(3086),
    [anon_sym_while] = ACTIONS(3086),
    [anon_sym_do] = ACTIONS(3086),
    [anon_sym_for] = ACTIONS(3086),
    [anon_sym_return] = ACTIONS(3086),
    [anon_sym_break] = ACTIONS(3086),
    [anon_sym_continue] = ACTIONS(3086),
    [anon_sym_goto] = ACTIONS(3086),
    [anon_sym___try] = ACTIONS(3086),
    [anon_sym___leave] = ACTIONS(3086),
    [anon_sym_not] = ACTIONS(3086),
    [anon_sym_compl] = ACTIONS(3086),
    [anon_sym_DASH_DASH] = ACTIONS(3088),
    [anon_sym_PLUS_PLUS] = ACTIONS(3088),
    [anon_sym_sizeof] = ACTIONS(3086),
    [anon_sym___alignof__] = ACTIONS(3086),
    [anon_sym___alignof] = ACTIONS(3086),
    [anon_sym__alignof] = ACTIONS(3086),
    [anon_sym_alignof] = ACTIONS(3086),
    [anon_sym__Alignof] = ACTIONS(3086),
    [anon_sym_offsetof] = ACTIONS(3086),
    [anon_sym__Generic] = ACTIONS(3086),
    [anon_sym_asm] = ACTIONS(3086),
    [anon_sym___asm__] = ACTIONS(3086),
    [aux_sym_number_literal_token1] = ACTIONS(3088),
    [aux_sym_number_literal_token2] = ACTIONS(3086),
    [anon_sym_L_SQUOTE] = ACTIONS(3088),
    [anon_sym_u_SQUOTE] = ACTIONS(3088),
    [anon_sym_U_SQUOTE] = ACTIONS(3088),
    [anon_sym_u8_SQUOTE] = ACTIONS(3088),
    [anon_sym_SQUOTE] = ACTIONS(3088),
    [anon_sym_L_DQUOTE] = ACTIONS(3088),
    [anon_sym_u_DQUOTE] = ACTIONS(3088),
    [anon_sym_U_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8_DQUOTE] = ACTIONS(3088),
    [anon_sym_DQUOTE] = ACTIONS(3088),
    [sym_true] = ACTIONS(3086),
    [sym_false] = ACTIONS(3086),
    [anon_sym_NULL] = ACTIONS(3086),
    [anon_sym_nullptr] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3086),
    [anon_sym_decltype] = ACTIONS(3086),
    [anon_sym_virtual] = ACTIONS(3086),
    [anon_sym_alignas] = ACTIONS(3086),
    [anon_sym_typename] = ACTIONS(3086),
    [anon_sym_template] = ACTIONS(3086),
    [anon_sym_try] = ACTIONS(3086),
    [anon_sym_delete] = ACTIONS(3086),
    [anon_sym_throw] = ACTIONS(3086),
    [anon_sym_co_return] = ACTIONS(3086),
    [anon_sym_co_yield] = ACTIONS(3086),
    [anon_sym_R_DQUOTE] = ACTIONS(3088),
    [anon_sym_LR_DQUOTE] = ACTIONS(3088),
    [anon_sym_uR_DQUOTE] = ACTIONS(3088),
    [anon_sym_UR_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3088),
    [anon_sym_co_await] = ACTIONS(3086),
    [anon_sym_new] = ACTIONS(3086),
    [anon_sym_requires] = ACTIONS(3086),
    [sym_this] = ACTIONS(3086),
  },
  [1200] = {
    [sym_identifier] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [1201] = {
    [sym_identifier] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3084),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_else] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_goto] = ACTIONS(3082),
    [anon_sym___try] = ACTIONS(3082),
    [anon_sym___leave] = ACTIONS(3082),
    [anon_sym_not] = ACTIONS(3082),
    [anon_sym_compl] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_sizeof] = ACTIONS(3082),
    [anon_sym___alignof__] = ACTIONS(3082),
    [anon_sym___alignof] = ACTIONS(3082),
    [anon_sym__alignof] = ACTIONS(3082),
    [anon_sym_alignof] = ACTIONS(3082),
    [anon_sym__Alignof] = ACTIONS(3082),
    [anon_sym_offsetof] = ACTIONS(3082),
    [anon_sym__Generic] = ACTIONS(3082),
    [anon_sym_asm] = ACTIONS(3082),
    [anon_sym___asm__] = ACTIONS(3082),
    [aux_sym_number_literal_token1] = ACTIONS(3084),
    [aux_sym_number_literal_token2] = ACTIONS(3082),
    [anon_sym_L_SQUOTE] = ACTIONS(3084),
    [anon_sym_u_SQUOTE] = ACTIONS(3084),
    [anon_sym_U_SQUOTE] = ACTIONS(3084),
    [anon_sym_u8_SQUOTE] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_L_DQUOTE] = ACTIONS(3084),
    [anon_sym_u_DQUOTE] = ACTIONS(3084),
    [anon_sym_U_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8_DQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [anon_sym_NULL] = ACTIONS(3082),
    [anon_sym_nullptr] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_co_return] = ACTIONS(3082),
    [anon_sym_co_yield] = ACTIONS(3082),
    [anon_sym_R_DQUOTE] = ACTIONS(3084),
    [anon_sym_LR_DQUOTE] = ACTIONS(3084),
    [anon_sym_uR_DQUOTE] = ACTIONS(3084),
    [anon_sym_UR_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3084),
    [anon_sym_co_await] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_requires] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
  },
  [1202] = {
    [sym_identifier] = ACTIONS(3096),
    [anon_sym_LPAREN2] = ACTIONS(3098),
    [anon_sym_BANG] = ACTIONS(3098),
    [anon_sym_TILDE] = ACTIONS(3098),
    [anon_sym_DASH] = ACTIONS(3096),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_STAR] = ACTIONS(3098),
    [anon_sym_AMP] = ACTIONS(3098),
    [anon_sym_SEMI] = ACTIONS(3098),
    [anon_sym___extension__] = ACTIONS(3096),
    [anon_sym_typedef] = ACTIONS(3096),
    [anon_sym_extern] = ACTIONS(3096),
    [anon_sym___attribute__] = ACTIONS(3096),
    [anon_sym_COLON_COLON] = ACTIONS(3098),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3098),
    [anon_sym___declspec] = ACTIONS(3096),
    [anon_sym_LBRACE] = ACTIONS(3098),
    [anon_sym_signed] = ACTIONS(3096),
    [anon_sym_unsigned] = ACTIONS(3096),
    [anon_sym_long] = ACTIONS(3096),
    [anon_sym_short] = ACTIONS(3096),
    [anon_sym_LBRACK] = ACTIONS(3096),
    [anon_sym_static] = ACTIONS(3096),
    [anon_sym_register] = ACTIONS(3096),
    [anon_sym_inline] = ACTIONS(3096),
    [anon_sym___inline] = ACTIONS(3096),
    [anon_sym___inline__] = ACTIONS(3096),
    [anon_sym___forceinline] = ACTIONS(3096),
    [anon_sym_thread_local] = ACTIONS(3096),
    [anon_sym___thread] = ACTIONS(3096),
    [anon_sym_const] = ACTIONS(3096),
    [anon_sym_constexpr] = ACTIONS(3096),
    [anon_sym_volatile] = ACTIONS(3096),
    [anon_sym_restrict] = ACTIONS(3096),
    [anon_sym___restrict__] = ACTIONS(3096),
    [anon_sym__Atomic] = ACTIONS(3096),
    [anon_sym__Noreturn] = ACTIONS(3096),
    [anon_sym_noreturn] = ACTIONS(3096),
    [anon_sym_mutable] = ACTIONS(3096),
    [anon_sym_constinit] = ACTIONS(3096),
    [anon_sym_consteval] = ACTIONS(3096),
    [anon_sym_PROGMEM] = ACTIONS(3096),
    [aux_sym_primitive_type_token1] = ACTIONS(3096),
    [anon_sym_byte] = ACTIONS(3096),
    [anon_sym_word] = ACTIONS(3096),
    [anon_sym_enum] = ACTIONS(3096),
    [anon_sym_class] = ACTIONS(3096),
    [anon_sym_struct] = ACTIONS(3096),
    [anon_sym_union] = ACTIONS(3096),
    [anon_sym_if] = ACTIONS(3096),
    [anon_sym_else] = ACTIONS(3096),
    [anon_sym_switch] = ACTIONS(3096),
    [anon_sym_while] = ACTIONS(3096),
    [anon_sym_do] = ACTIONS(3096),
    [anon_sym_for] = ACTIONS(3096),
    [anon_sym_return] = ACTIONS(3096),
    [anon_sym_break] = ACTIONS(3096),
    [anon_sym_continue] = ACTIONS(3096),
    [anon_sym_goto] = ACTIONS(3096),
    [anon_sym___try] = ACTIONS(3096),
    [anon_sym___leave] = ACTIONS(3096),
    [anon_sym_not] = ACTIONS(3096),
    [anon_sym_compl] = ACTIONS(3096),
    [anon_sym_DASH_DASH] = ACTIONS(3098),
    [anon_sym_PLUS_PLUS] = ACTIONS(3098),
    [anon_sym_sizeof] = ACTIONS(3096),
    [anon_sym___alignof__] = ACTIONS(3096),
    [anon_sym___alignof] = ACTIONS(3096),
    [anon_sym__alignof] = ACTIONS(3096),
    [anon_sym_alignof] = ACTIONS(3096),
    [anon_sym__Alignof] = ACTIONS(3096),
    [anon_sym_offsetof] = ACTIONS(3096),
    [anon_sym__Generic] = ACTIONS(3096),
    [anon_sym_asm] = ACTIONS(3096),
    [anon_sym___asm__] = ACTIONS(3096),
    [aux_sym_number_literal_token1] = ACTIONS(3098),
    [aux_sym_number_literal_token2] = ACTIONS(3096),
    [anon_sym_L_SQUOTE] = ACTIONS(3098),
    [anon_sym_u_SQUOTE] = ACTIONS(3098),
    [anon_sym_U_SQUOTE] = ACTIONS(3098),
    [anon_sym_u8_SQUOTE] = ACTIONS(3098),
    [anon_sym_SQUOTE] = ACTIONS(3098),
    [anon_sym_L_DQUOTE] = ACTIONS(3098),
    [anon_sym_u_DQUOTE] = ACTIONS(3098),
    [anon_sym_U_DQUOTE] = ACTIONS(3098),
    [anon_sym_u8_DQUOTE] = ACTIONS(3098),
    [anon_sym_DQUOTE] = ACTIONS(3098),
    [sym_true] = ACTIONS(3096),
    [sym_false] = ACTIONS(3096),
    [anon_sym_NULL] = ACTIONS(3096),
    [anon_sym_nullptr] = ACTIONS(3096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3096),
    [anon_sym_decltype] = ACTIONS(3096),
    [anon_sym_virtual] = ACTIONS(3096),
    [anon_sym_alignas] = ACTIONS(3096),
    [anon_sym_typename] = ACTIONS(3096),
    [anon_sym_template] = ACTIONS(3096),
    [anon_sym_try] = ACTIONS(3096),
    [anon_sym_delete] = ACTIONS(3096),
    [anon_sym_throw] = ACTIONS(3096),
    [anon_sym_co_return] = ACTIONS(3096),
    [anon_sym_co_yield] = ACTIONS(3096),
    [anon_sym_R_DQUOTE] = ACTIONS(3098),
    [anon_sym_LR_DQUOTE] = ACTIONS(3098),
    [anon_sym_uR_DQUOTE] = ACTIONS(3098),
    [anon_sym_UR_DQUOTE] = ACTIONS(3098),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3098),
    [anon_sym_co_await] = ACTIONS(3096),
    [anon_sym_new] = ACTIONS(3096),
    [anon_sym_requires] = ACTIONS(3096),
    [sym_this] = ACTIONS(3096),
  },
  [1203] = {
    [sym_identifier] = ACTIONS(4129),
    [anon_sym_LPAREN2] = ACTIONS(4131),
    [anon_sym_BANG] = ACTIONS(4131),
    [anon_sym_TILDE] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4129),
    [anon_sym_STAR] = ACTIONS(4131),
    [anon_sym_AMP] = ACTIONS(4131),
    [anon_sym_SEMI] = ACTIONS(4131),
    [anon_sym___extension__] = ACTIONS(4129),
    [anon_sym_extern] = ACTIONS(4129),
    [anon_sym___attribute__] = ACTIONS(4129),
    [anon_sym_COLON_COLON] = ACTIONS(4131),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4131),
    [anon_sym___declspec] = ACTIONS(4129),
    [anon_sym_LBRACE] = ACTIONS(4131),
    [anon_sym_signed] = ACTIONS(4129),
    [anon_sym_unsigned] = ACTIONS(4129),
    [anon_sym_long] = ACTIONS(4129),
    [anon_sym_short] = ACTIONS(4129),
    [anon_sym_LBRACK] = ACTIONS(4129),
    [anon_sym_static] = ACTIONS(4129),
    [anon_sym_register] = ACTIONS(4129),
    [anon_sym_inline] = ACTIONS(4129),
    [anon_sym___inline] = ACTIONS(4129),
    [anon_sym___inline__] = ACTIONS(4129),
    [anon_sym___forceinline] = ACTIONS(4129),
    [anon_sym_thread_local] = ACTIONS(4129),
    [anon_sym___thread] = ACTIONS(4129),
    [anon_sym_const] = ACTIONS(4129),
    [anon_sym_constexpr] = ACTIONS(4129),
    [anon_sym_volatile] = ACTIONS(4129),
    [anon_sym_restrict] = ACTIONS(4129),
    [anon_sym___restrict__] = ACTIONS(4129),
    [anon_sym__Atomic] = ACTIONS(4129),
    [anon_sym__Noreturn] = ACTIONS(4129),
    [anon_sym_noreturn] = ACTIONS(4129),
    [anon_sym_mutable] = ACTIONS(4129),
    [anon_sym_constinit] = ACTIONS(4129),
    [anon_sym_consteval] = ACTIONS(4129),
    [anon_sym_PROGMEM] = ACTIONS(4129),
    [aux_sym_primitive_type_token1] = ACTIONS(4129),
    [anon_sym_byte] = ACTIONS(4129),
    [anon_sym_word] = ACTIONS(4129),
    [anon_sym_enum] = ACTIONS(4129),
    [anon_sym_class] = ACTIONS(4129),
    [anon_sym_struct] = ACTIONS(4129),
    [anon_sym_union] = ACTIONS(4129),
    [anon_sym_if] = ACTIONS(4129),
    [anon_sym_switch] = ACTIONS(4129),
    [anon_sym_case] = ACTIONS(4129),
    [anon_sym_default] = ACTIONS(4129),
    [anon_sym_while] = ACTIONS(4129),
    [anon_sym_do] = ACTIONS(4129),
    [anon_sym_for] = ACTIONS(4129),
    [anon_sym_return] = ACTIONS(4129),
    [anon_sym_break] = ACTIONS(4129),
    [anon_sym_continue] = ACTIONS(4129),
    [anon_sym_goto] = ACTIONS(4129),
    [anon_sym___try] = ACTIONS(4129),
    [anon_sym___leave] = ACTIONS(4129),
    [anon_sym_not] = ACTIONS(4129),
    [anon_sym_compl] = ACTIONS(4129),
    [anon_sym_DASH_DASH] = ACTIONS(4131),
    [anon_sym_PLUS_PLUS] = ACTIONS(4131),
    [anon_sym_sizeof] = ACTIONS(4129),
    [anon_sym___alignof__] = ACTIONS(4129),
    [anon_sym___alignof] = ACTIONS(4129),
    [anon_sym__alignof] = ACTIONS(4129),
    [anon_sym_alignof] = ACTIONS(4129),
    [anon_sym__Alignof] = ACTIONS(4129),
    [anon_sym_offsetof] = ACTIONS(4129),
    [anon_sym__Generic] = ACTIONS(4129),
    [anon_sym_asm] = ACTIONS(4129),
    [anon_sym___asm__] = ACTIONS(4129),
    [aux_sym_number_literal_token1] = ACTIONS(4131),
    [aux_sym_number_literal_token2] = ACTIONS(4129),
    [anon_sym_L_SQUOTE] = ACTIONS(4131),
    [anon_sym_u_SQUOTE] = ACTIONS(4131),
    [anon_sym_U_SQUOTE] = ACTIONS(4131),
    [anon_sym_u8_SQUOTE] = ACTIONS(4131),
    [anon_sym_SQUOTE] = ACTIONS(4131),
    [anon_sym_L_DQUOTE] = ACTIONS(4131),
    [anon_sym_u_DQUOTE] = ACTIONS(4131),
    [anon_sym_U_DQUOTE] = ACTIONS(4131),
    [anon_sym_u8_DQUOTE] = ACTIONS(4131),
    [anon_sym_DQUOTE] = ACTIONS(4131),
    [sym_true] = ACTIONS(4129),
    [sym_false] = ACTIONS(4129),
    [anon_sym_NULL] = ACTIONS(4129),
    [anon_sym_nullptr] = ACTIONS(4129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4129),
    [anon_sym_decltype] = ACTIONS(4129),
    [anon_sym_virtual] = ACTIONS(4129),
    [anon_sym_alignas] = ACTIONS(4129),
    [anon_sym_typename] = ACTIONS(4129),
    [anon_sym_template] = ACTIONS(4129),
    [anon_sym_try] = ACTIONS(4129),
    [anon_sym_delete] = ACTIONS(4129),
    [anon_sym_throw] = ACTIONS(4129),
    [anon_sym_co_return] = ACTIONS(4129),
    [anon_sym_co_yield] = ACTIONS(4129),
    [anon_sym_R_DQUOTE] = ACTIONS(4131),
    [anon_sym_LR_DQUOTE] = ACTIONS(4131),
    [anon_sym_uR_DQUOTE] = ACTIONS(4131),
    [anon_sym_UR_DQUOTE] = ACTIONS(4131),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4131),
    [anon_sym_co_await] = ACTIONS(4129),
    [anon_sym_new] = ACTIONS(4129),
    [anon_sym_requires] = ACTIONS(4129),
    [sym_this] = ACTIONS(4129),
  },
  [1204] = {
    [sym_identifier] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [1205] = {
    [sym_identifier] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3084),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_else] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_goto] = ACTIONS(3082),
    [anon_sym___try] = ACTIONS(3082),
    [anon_sym___leave] = ACTIONS(3082),
    [anon_sym_not] = ACTIONS(3082),
    [anon_sym_compl] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_sizeof] = ACTIONS(3082),
    [anon_sym___alignof__] = ACTIONS(3082),
    [anon_sym___alignof] = ACTIONS(3082),
    [anon_sym__alignof] = ACTIONS(3082),
    [anon_sym_alignof] = ACTIONS(3082),
    [anon_sym__Alignof] = ACTIONS(3082),
    [anon_sym_offsetof] = ACTIONS(3082),
    [anon_sym__Generic] = ACTIONS(3082),
    [anon_sym_asm] = ACTIONS(3082),
    [anon_sym___asm__] = ACTIONS(3082),
    [aux_sym_number_literal_token1] = ACTIONS(3084),
    [aux_sym_number_literal_token2] = ACTIONS(3082),
    [anon_sym_L_SQUOTE] = ACTIONS(3084),
    [anon_sym_u_SQUOTE] = ACTIONS(3084),
    [anon_sym_U_SQUOTE] = ACTIONS(3084),
    [anon_sym_u8_SQUOTE] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_L_DQUOTE] = ACTIONS(3084),
    [anon_sym_u_DQUOTE] = ACTIONS(3084),
    [anon_sym_U_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8_DQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [anon_sym_NULL] = ACTIONS(3082),
    [anon_sym_nullptr] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_co_return] = ACTIONS(3082),
    [anon_sym_co_yield] = ACTIONS(3082),
    [anon_sym_R_DQUOTE] = ACTIONS(3084),
    [anon_sym_LR_DQUOTE] = ACTIONS(3084),
    [anon_sym_uR_DQUOTE] = ACTIONS(3084),
    [anon_sym_UR_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3084),
    [anon_sym_co_await] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_requires] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
  },
  [1206] = {
    [sym_identifier] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [1207] = {
    [sym_identifier] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2952),
    [anon_sym_BANG] = ACTIONS(2952),
    [anon_sym_TILDE] = ACTIONS(2952),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_STAR] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2952),
    [anon_sym_SEMI] = ACTIONS(2952),
    [anon_sym___extension__] = ACTIONS(2950),
    [anon_sym_typedef] = ACTIONS(2950),
    [anon_sym_extern] = ACTIONS(2950),
    [anon_sym___attribute__] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2952),
    [anon_sym___declspec] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2952),
    [anon_sym_signed] = ACTIONS(2950),
    [anon_sym_unsigned] = ACTIONS(2950),
    [anon_sym_long] = ACTIONS(2950),
    [anon_sym_short] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_static] = ACTIONS(2950),
    [anon_sym_register] = ACTIONS(2950),
    [anon_sym_inline] = ACTIONS(2950),
    [anon_sym___inline] = ACTIONS(2950),
    [anon_sym___inline__] = ACTIONS(2950),
    [anon_sym___forceinline] = ACTIONS(2950),
    [anon_sym_thread_local] = ACTIONS(2950),
    [anon_sym___thread] = ACTIONS(2950),
    [anon_sym_const] = ACTIONS(2950),
    [anon_sym_constexpr] = ACTIONS(2950),
    [anon_sym_volatile] = ACTIONS(2950),
    [anon_sym_restrict] = ACTIONS(2950),
    [anon_sym___restrict__] = ACTIONS(2950),
    [anon_sym__Atomic] = ACTIONS(2950),
    [anon_sym__Noreturn] = ACTIONS(2950),
    [anon_sym_noreturn] = ACTIONS(2950),
    [anon_sym_mutable] = ACTIONS(2950),
    [anon_sym_constinit] = ACTIONS(2950),
    [anon_sym_consteval] = ACTIONS(2950),
    [anon_sym_PROGMEM] = ACTIONS(2950),
    [aux_sym_primitive_type_token1] = ACTIONS(2950),
    [anon_sym_byte] = ACTIONS(2950),
    [anon_sym_word] = ACTIONS(2950),
    [anon_sym_enum] = ACTIONS(2950),
    [anon_sym_class] = ACTIONS(2950),
    [anon_sym_struct] = ACTIONS(2950),
    [anon_sym_union] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_else] = ACTIONS(2950),
    [anon_sym_switch] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_break] = ACTIONS(2950),
    [anon_sym_continue] = ACTIONS(2950),
    [anon_sym_goto] = ACTIONS(2950),
    [anon_sym___try] = ACTIONS(2950),
    [anon_sym___leave] = ACTIONS(2950),
    [anon_sym_not] = ACTIONS(2950),
    [anon_sym_compl] = ACTIONS(2950),
    [anon_sym_DASH_DASH] = ACTIONS(2952),
    [anon_sym_PLUS_PLUS] = ACTIONS(2952),
    [anon_sym_sizeof] = ACTIONS(2950),
    [anon_sym___alignof__] = ACTIONS(2950),
    [anon_sym___alignof] = ACTIONS(2950),
    [anon_sym__alignof] = ACTIONS(2950),
    [anon_sym_alignof] = ACTIONS(2950),
    [anon_sym__Alignof] = ACTIONS(2950),
    [anon_sym_offsetof] = ACTIONS(2950),
    [anon_sym__Generic] = ACTIONS(2950),
    [anon_sym_asm] = ACTIONS(2950),
    [anon_sym___asm__] = ACTIONS(2950),
    [aux_sym_number_literal_token1] = ACTIONS(2952),
    [aux_sym_number_literal_token2] = ACTIONS(2950),
    [anon_sym_L_SQUOTE] = ACTIONS(2952),
    [anon_sym_u_SQUOTE] = ACTIONS(2952),
    [anon_sym_U_SQUOTE] = ACTIONS(2952),
    [anon_sym_u8_SQUOTE] = ACTIONS(2952),
    [anon_sym_SQUOTE] = ACTIONS(2952),
    [anon_sym_L_DQUOTE] = ACTIONS(2952),
    [anon_sym_u_DQUOTE] = ACTIONS(2952),
    [anon_sym_U_DQUOTE] = ACTIONS(2952),
    [anon_sym_u8_DQUOTE] = ACTIONS(2952),
    [anon_sym_DQUOTE] = ACTIONS(2952),
    [sym_true] = ACTIONS(2950),
    [sym_false] = ACTIONS(2950),
    [anon_sym_NULL] = ACTIONS(2950),
    [anon_sym_nullptr] = ACTIONS(2950),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2950),
    [anon_sym_decltype] = ACTIONS(2950),
    [anon_sym_virtual] = ACTIONS(2950),
    [anon_sym_alignas] = ACTIONS(2950),
    [anon_sym_typename] = ACTIONS(2950),
    [anon_sym_template] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_delete] = ACTIONS(2950),
    [anon_sym_throw] = ACTIONS(2950),
    [anon_sym_co_return] = ACTIONS(2950),
    [anon_sym_co_yield] = ACTIONS(2950),
    [anon_sym_R_DQUOTE] = ACTIONS(2952),
    [anon_sym_LR_DQUOTE] = ACTIONS(2952),
    [anon_sym_uR_DQUOTE] = ACTIONS(2952),
    [anon_sym_UR_DQUOTE] = ACTIONS(2952),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2952),
    [anon_sym_co_await] = ACTIONS(2950),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_requires] = ACTIONS(2950),
    [sym_this] = ACTIONS(2950),
  },
  [1208] = {
    [sym_identifier] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2956),
    [anon_sym_BANG] = ACTIONS(2956),
    [anon_sym_TILDE] = ACTIONS(2956),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_STAR] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2956),
    [anon_sym_SEMI] = ACTIONS(2956),
    [anon_sym___extension__] = ACTIONS(2954),
    [anon_sym_typedef] = ACTIONS(2954),
    [anon_sym_extern] = ACTIONS(2954),
    [anon_sym___attribute__] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2956),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2956),
    [anon_sym___declspec] = ACTIONS(2954),
    [anon_sym_LBRACE] = ACTIONS(2956),
    [anon_sym_signed] = ACTIONS(2954),
    [anon_sym_unsigned] = ACTIONS(2954),
    [anon_sym_long] = ACTIONS(2954),
    [anon_sym_short] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_static] = ACTIONS(2954),
    [anon_sym_register] = ACTIONS(2954),
    [anon_sym_inline] = ACTIONS(2954),
    [anon_sym___inline] = ACTIONS(2954),
    [anon_sym___inline__] = ACTIONS(2954),
    [anon_sym___forceinline] = ACTIONS(2954),
    [anon_sym_thread_local] = ACTIONS(2954),
    [anon_sym___thread] = ACTIONS(2954),
    [anon_sym_const] = ACTIONS(2954),
    [anon_sym_constexpr] = ACTIONS(2954),
    [anon_sym_volatile] = ACTIONS(2954),
    [anon_sym_restrict] = ACTIONS(2954),
    [anon_sym___restrict__] = ACTIONS(2954),
    [anon_sym__Atomic] = ACTIONS(2954),
    [anon_sym__Noreturn] = ACTIONS(2954),
    [anon_sym_noreturn] = ACTIONS(2954),
    [anon_sym_mutable] = ACTIONS(2954),
    [anon_sym_constinit] = ACTIONS(2954),
    [anon_sym_consteval] = ACTIONS(2954),
    [anon_sym_PROGMEM] = ACTIONS(2954),
    [aux_sym_primitive_type_token1] = ACTIONS(2954),
    [anon_sym_byte] = ACTIONS(2954),
    [anon_sym_word] = ACTIONS(2954),
    [anon_sym_enum] = ACTIONS(2954),
    [anon_sym_class] = ACTIONS(2954),
    [anon_sym_struct] = ACTIONS(2954),
    [anon_sym_union] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_else] = ACTIONS(2954),
    [anon_sym_switch] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_break] = ACTIONS(2954),
    [anon_sym_continue] = ACTIONS(2954),
    [anon_sym_goto] = ACTIONS(2954),
    [anon_sym___try] = ACTIONS(2954),
    [anon_sym___leave] = ACTIONS(2954),
    [anon_sym_not] = ACTIONS(2954),
    [anon_sym_compl] = ACTIONS(2954),
    [anon_sym_DASH_DASH] = ACTIONS(2956),
    [anon_sym_PLUS_PLUS] = ACTIONS(2956),
    [anon_sym_sizeof] = ACTIONS(2954),
    [anon_sym___alignof__] = ACTIONS(2954),
    [anon_sym___alignof] = ACTIONS(2954),
    [anon_sym__alignof] = ACTIONS(2954),
    [anon_sym_alignof] = ACTIONS(2954),
    [anon_sym__Alignof] = ACTIONS(2954),
    [anon_sym_offsetof] = ACTIONS(2954),
    [anon_sym__Generic] = ACTIONS(2954),
    [anon_sym_asm] = ACTIONS(2954),
    [anon_sym___asm__] = ACTIONS(2954),
    [aux_sym_number_literal_token1] = ACTIONS(2956),
    [aux_sym_number_literal_token2] = ACTIONS(2954),
    [anon_sym_L_SQUOTE] = ACTIONS(2956),
    [anon_sym_u_SQUOTE] = ACTIONS(2956),
    [anon_sym_U_SQUOTE] = ACTIONS(2956),
    [anon_sym_u8_SQUOTE] = ACTIONS(2956),
    [anon_sym_SQUOTE] = ACTIONS(2956),
    [anon_sym_L_DQUOTE] = ACTIONS(2956),
    [anon_sym_u_DQUOTE] = ACTIONS(2956),
    [anon_sym_U_DQUOTE] = ACTIONS(2956),
    [anon_sym_u8_DQUOTE] = ACTIONS(2956),
    [anon_sym_DQUOTE] = ACTIONS(2956),
    [sym_true] = ACTIONS(2954),
    [sym_false] = ACTIONS(2954),
    [anon_sym_NULL] = ACTIONS(2954),
    [anon_sym_nullptr] = ACTIONS(2954),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2954),
    [anon_sym_decltype] = ACTIONS(2954),
    [anon_sym_virtual] = ACTIONS(2954),
    [anon_sym_alignas] = ACTIONS(2954),
    [anon_sym_typename] = ACTIONS(2954),
    [anon_sym_template] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_delete] = ACTIONS(2954),
    [anon_sym_throw] = ACTIONS(2954),
    [anon_sym_co_return] = ACTIONS(2954),
    [anon_sym_co_yield] = ACTIONS(2954),
    [anon_sym_R_DQUOTE] = ACTIONS(2956),
    [anon_sym_LR_DQUOTE] = ACTIONS(2956),
    [anon_sym_uR_DQUOTE] = ACTIONS(2956),
    [anon_sym_UR_DQUOTE] = ACTIONS(2956),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2956),
    [anon_sym_co_await] = ACTIONS(2954),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_requires] = ACTIONS(2954),
    [sym_this] = ACTIONS(2954),
  },
  [1209] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(2035),
    [sym_raw_string_literal] = STATE(3057),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3184),
    [sym_identifier] = ACTIONS(4246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4250),
    [anon_sym_TILDE] = ACTIONS(4254),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4258),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4261),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4258),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(4264),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4261),
    [anon_sym___extension__] = ACTIONS(4246),
    [anon_sym_extern] = ACTIONS(4246),
    [anon_sym___attribute__] = ACTIONS(4246),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4269),
    [anon_sym___declspec] = ACTIONS(4246),
    [anon_sym___based] = ACTIONS(4246),
    [anon_sym___cdecl] = ACTIONS(4246),
    [anon_sym___clrcall] = ACTIONS(4246),
    [anon_sym___stdcall] = ACTIONS(4246),
    [anon_sym___fastcall] = ACTIONS(4246),
    [anon_sym___thiscall] = ACTIONS(4246),
    [anon_sym___vectorcall] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_signed] = ACTIONS(4274),
    [anon_sym_unsigned] = ACTIONS(4274),
    [anon_sym_long] = ACTIONS(4274),
    [anon_sym_short] = ACTIONS(4274),
    [anon_sym_LBRACK] = ACTIONS(4276),
    [anon_sym_EQ] = ACTIONS(4280),
    [anon_sym_static] = ACTIONS(4246),
    [anon_sym_register] = ACTIONS(4246),
    [anon_sym_inline] = ACTIONS(4246),
    [anon_sym___inline] = ACTIONS(4246),
    [anon_sym___inline__] = ACTIONS(4246),
    [anon_sym___forceinline] = ACTIONS(4246),
    [anon_sym_thread_local] = ACTIONS(4246),
    [anon_sym___thread] = ACTIONS(4246),
    [anon_sym_const] = ACTIONS(4246),
    [anon_sym_constexpr] = ACTIONS(4246),
    [anon_sym_volatile] = ACTIONS(4246),
    [anon_sym_restrict] = ACTIONS(4246),
    [anon_sym___restrict__] = ACTIONS(4246),
    [anon_sym__Atomic] = ACTIONS(4246),
    [anon_sym__Noreturn] = ACTIONS(4246),
    [anon_sym_noreturn] = ACTIONS(4246),
    [anon_sym_mutable] = ACTIONS(4246),
    [anon_sym_constinit] = ACTIONS(4246),
    [anon_sym_consteval] = ACTIONS(4246),
    [anon_sym_PROGMEM] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_and_eq] = ACTIONS(4280),
    [anon_sym_or_eq] = ACTIONS(4280),
    [anon_sym_xor_eq] = ACTIONS(4280),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4256),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4256),
    [anon_sym_not_eq] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4246),
    [anon_sym_decltype] = ACTIONS(4246),
    [anon_sym_virtual] = ACTIONS(4246),
    [anon_sym_alignas] = ACTIONS(4246),
    [anon_sym_template] = ACTIONS(4246),
    [anon_sym_operator] = ACTIONS(4246),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [1210] = {
    [sym_identifier] = ACTIONS(2962),
    [anon_sym_LPAREN2] = ACTIONS(2964),
    [anon_sym_BANG] = ACTIONS(2964),
    [anon_sym_TILDE] = ACTIONS(2964),
    [anon_sym_DASH] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_STAR] = ACTIONS(2964),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2964),
    [anon_sym___extension__] = ACTIONS(2962),
    [anon_sym_typedef] = ACTIONS(2962),
    [anon_sym_extern] = ACTIONS(2962),
    [anon_sym___attribute__] = ACTIONS(2962),
    [anon_sym_COLON_COLON] = ACTIONS(2964),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2964),
    [anon_sym___declspec] = ACTIONS(2962),
    [anon_sym_LBRACE] = ACTIONS(2964),
    [anon_sym_signed] = ACTIONS(2962),
    [anon_sym_unsigned] = ACTIONS(2962),
    [anon_sym_long] = ACTIONS(2962),
    [anon_sym_short] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_static] = ACTIONS(2962),
    [anon_sym_register] = ACTIONS(2962),
    [anon_sym_inline] = ACTIONS(2962),
    [anon_sym___inline] = ACTIONS(2962),
    [anon_sym___inline__] = ACTIONS(2962),
    [anon_sym___forceinline] = ACTIONS(2962),
    [anon_sym_thread_local] = ACTIONS(2962),
    [anon_sym___thread] = ACTIONS(2962),
    [anon_sym_const] = ACTIONS(2962),
    [anon_sym_constexpr] = ACTIONS(2962),
    [anon_sym_volatile] = ACTIONS(2962),
    [anon_sym_restrict] = ACTIONS(2962),
    [anon_sym___restrict__] = ACTIONS(2962),
    [anon_sym__Atomic] = ACTIONS(2962),
    [anon_sym__Noreturn] = ACTIONS(2962),
    [anon_sym_noreturn] = ACTIONS(2962),
    [anon_sym_mutable] = ACTIONS(2962),
    [anon_sym_constinit] = ACTIONS(2962),
    [anon_sym_consteval] = ACTIONS(2962),
    [anon_sym_PROGMEM] = ACTIONS(2962),
    [aux_sym_primitive_type_token1] = ACTIONS(2962),
    [anon_sym_byte] = ACTIONS(2962),
    [anon_sym_word] = ACTIONS(2962),
    [anon_sym_enum] = ACTIONS(2962),
    [anon_sym_class] = ACTIONS(2962),
    [anon_sym_struct] = ACTIONS(2962),
    [anon_sym_union] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_else] = ACTIONS(2962),
    [anon_sym_switch] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_for] = ACTIONS(2962),
    [anon_sym_return] = ACTIONS(2962),
    [anon_sym_break] = ACTIONS(2962),
    [anon_sym_continue] = ACTIONS(2962),
    [anon_sym_goto] = ACTIONS(2962),
    [anon_sym___try] = ACTIONS(2962),
    [anon_sym___leave] = ACTIONS(2962),
    [anon_sym_not] = ACTIONS(2962),
    [anon_sym_compl] = ACTIONS(2962),
    [anon_sym_DASH_DASH] = ACTIONS(2964),
    [anon_sym_PLUS_PLUS] = ACTIONS(2964),
    [anon_sym_sizeof] = ACTIONS(2962),
    [anon_sym___alignof__] = ACTIONS(2962),
    [anon_sym___alignof] = ACTIONS(2962),
    [anon_sym__alignof] = ACTIONS(2962),
    [anon_sym_alignof] = ACTIONS(2962),
    [anon_sym__Alignof] = ACTIONS(2962),
    [anon_sym_offsetof] = ACTIONS(2962),
    [anon_sym__Generic] = ACTIONS(2962),
    [anon_sym_asm] = ACTIONS(2962),
    [anon_sym___asm__] = ACTIONS(2962),
    [aux_sym_number_literal_token1] = ACTIONS(2964),
    [aux_sym_number_literal_token2] = ACTIONS(2962),
    [anon_sym_L_SQUOTE] = ACTIONS(2964),
    [anon_sym_u_SQUOTE] = ACTIONS(2964),
    [anon_sym_U_SQUOTE] = ACTIONS(2964),
    [anon_sym_u8_SQUOTE] = ACTIONS(2964),
    [anon_sym_SQUOTE] = ACTIONS(2964),
    [anon_sym_L_DQUOTE] = ACTIONS(2964),
    [anon_sym_u_DQUOTE] = ACTIONS(2964),
    [anon_sym_U_DQUOTE] = ACTIONS(2964),
    [anon_sym_u8_DQUOTE] = ACTIONS(2964),
    [anon_sym_DQUOTE] = ACTIONS(2964),
    [sym_true] = ACTIONS(2962),
    [sym_false] = ACTIONS(2962),
    [anon_sym_NULL] = ACTIONS(2962),
    [anon_sym_nullptr] = ACTIONS(2962),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2962),
    [anon_sym_decltype] = ACTIONS(2962),
    [anon_sym_virtual] = ACTIONS(2962),
    [anon_sym_alignas] = ACTIONS(2962),
    [anon_sym_typename] = ACTIONS(2962),
    [anon_sym_template] = ACTIONS(2962),
    [anon_sym_try] = ACTIONS(2962),
    [anon_sym_delete] = ACTIONS(2962),
    [anon_sym_throw] = ACTIONS(2962),
    [anon_sym_co_return] = ACTIONS(2962),
    [anon_sym_co_yield] = ACTIONS(2962),
    [anon_sym_R_DQUOTE] = ACTIONS(2964),
    [anon_sym_LR_DQUOTE] = ACTIONS(2964),
    [anon_sym_uR_DQUOTE] = ACTIONS(2964),
    [anon_sym_UR_DQUOTE] = ACTIONS(2964),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2964),
    [anon_sym_co_await] = ACTIONS(2962),
    [anon_sym_new] = ACTIONS(2962),
    [anon_sym_requires] = ACTIONS(2962),
    [sym_this] = ACTIONS(2962),
  },
  [1211] = {
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [1212] = {
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [1213] = {
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [1214] = {
    [sym_identifier] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [1215] = {
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [1216] = {
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [1217] = {
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [1218] = {
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_BANG] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2972),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym___extension__] = ACTIONS(2970),
    [anon_sym_typedef] = ACTIONS(2970),
    [anon_sym_extern] = ACTIONS(2970),
    [anon_sym___attribute__] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2970),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_signed] = ACTIONS(2970),
    [anon_sym_unsigned] = ACTIONS(2970),
    [anon_sym_long] = ACTIONS(2970),
    [anon_sym_short] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_register] = ACTIONS(2970),
    [anon_sym_inline] = ACTIONS(2970),
    [anon_sym___inline] = ACTIONS(2970),
    [anon_sym___inline__] = ACTIONS(2970),
    [anon_sym___forceinline] = ACTIONS(2970),
    [anon_sym_thread_local] = ACTIONS(2970),
    [anon_sym___thread] = ACTIONS(2970),
    [anon_sym_const] = ACTIONS(2970),
    [anon_sym_constexpr] = ACTIONS(2970),
    [anon_sym_volatile] = ACTIONS(2970),
    [anon_sym_restrict] = ACTIONS(2970),
    [anon_sym___restrict__] = ACTIONS(2970),
    [anon_sym__Atomic] = ACTIONS(2970),
    [anon_sym__Noreturn] = ACTIONS(2970),
    [anon_sym_noreturn] = ACTIONS(2970),
    [anon_sym_mutable] = ACTIONS(2970),
    [anon_sym_constinit] = ACTIONS(2970),
    [anon_sym_consteval] = ACTIONS(2970),
    [anon_sym_PROGMEM] = ACTIONS(2970),
    [aux_sym_primitive_type_token1] = ACTIONS(2970),
    [anon_sym_byte] = ACTIONS(2970),
    [anon_sym_word] = ACTIONS(2970),
    [anon_sym_enum] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_struct] = ACTIONS(2970),
    [anon_sym_union] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_else] = ACTIONS(2970),
    [anon_sym_switch] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_break] = ACTIONS(2970),
    [anon_sym_continue] = ACTIONS(2970),
    [anon_sym_goto] = ACTIONS(2970),
    [anon_sym___try] = ACTIONS(2970),
    [anon_sym___leave] = ACTIONS(2970),
    [anon_sym_not] = ACTIONS(2970),
    [anon_sym_compl] = ACTIONS(2970),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_sizeof] = ACTIONS(2970),
    [anon_sym___alignof__] = ACTIONS(2970),
    [anon_sym___alignof] = ACTIONS(2970),
    [anon_sym__alignof] = ACTIONS(2970),
    [anon_sym_alignof] = ACTIONS(2970),
    [anon_sym__Alignof] = ACTIONS(2970),
    [anon_sym_offsetof] = ACTIONS(2970),
    [anon_sym__Generic] = ACTIONS(2970),
    [anon_sym_asm] = ACTIONS(2970),
    [anon_sym___asm__] = ACTIONS(2970),
    [aux_sym_number_literal_token1] = ACTIONS(2972),
    [aux_sym_number_literal_token2] = ACTIONS(2970),
    [anon_sym_L_SQUOTE] = ACTIONS(2972),
    [anon_sym_u_SQUOTE] = ACTIONS(2972),
    [anon_sym_U_SQUOTE] = ACTIONS(2972),
    [anon_sym_u8_SQUOTE] = ACTIONS(2972),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [anon_sym_L_DQUOTE] = ACTIONS(2972),
    [anon_sym_u_DQUOTE] = ACTIONS(2972),
    [anon_sym_U_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE] = ACTIONS(2972),
    [sym_true] = ACTIONS(2970),
    [sym_false] = ACTIONS(2970),
    [anon_sym_NULL] = ACTIONS(2970),
    [anon_sym_nullptr] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2970),
    [anon_sym_decltype] = ACTIONS(2970),
    [anon_sym_virtual] = ACTIONS(2970),
    [anon_sym_alignas] = ACTIONS(2970),
    [anon_sym_typename] = ACTIONS(2970),
    [anon_sym_template] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_delete] = ACTIONS(2970),
    [anon_sym_throw] = ACTIONS(2970),
    [anon_sym_co_return] = ACTIONS(2970),
    [anon_sym_co_yield] = ACTIONS(2970),
    [anon_sym_R_DQUOTE] = ACTIONS(2972),
    [anon_sym_LR_DQUOTE] = ACTIONS(2972),
    [anon_sym_uR_DQUOTE] = ACTIONS(2972),
    [anon_sym_UR_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2972),
    [anon_sym_co_await] = ACTIONS(2970),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_requires] = ACTIONS(2970),
    [sym_this] = ACTIONS(2970),
  },
  [1219] = {
    [sym_identifier] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [1220] = {
    [sym_identifier] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [1221] = {
    [sym_identifier] = ACTIONS(3158),
    [anon_sym_LPAREN2] = ACTIONS(3160),
    [anon_sym_BANG] = ACTIONS(3160),
    [anon_sym_TILDE] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_STAR] = ACTIONS(3160),
    [anon_sym_AMP] = ACTIONS(3160),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym___extension__] = ACTIONS(3158),
    [anon_sym_typedef] = ACTIONS(3158),
    [anon_sym_extern] = ACTIONS(3158),
    [anon_sym___attribute__] = ACTIONS(3158),
    [anon_sym_COLON_COLON] = ACTIONS(3160),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3160),
    [anon_sym___declspec] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_signed] = ACTIONS(3158),
    [anon_sym_unsigned] = ACTIONS(3158),
    [anon_sym_long] = ACTIONS(3158),
    [anon_sym_short] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_static] = ACTIONS(3158),
    [anon_sym_register] = ACTIONS(3158),
    [anon_sym_inline] = ACTIONS(3158),
    [anon_sym___inline] = ACTIONS(3158),
    [anon_sym___inline__] = ACTIONS(3158),
    [anon_sym___forceinline] = ACTIONS(3158),
    [anon_sym_thread_local] = ACTIONS(3158),
    [anon_sym___thread] = ACTIONS(3158),
    [anon_sym_const] = ACTIONS(3158),
    [anon_sym_constexpr] = ACTIONS(3158),
    [anon_sym_volatile] = ACTIONS(3158),
    [anon_sym_restrict] = ACTIONS(3158),
    [anon_sym___restrict__] = ACTIONS(3158),
    [anon_sym__Atomic] = ACTIONS(3158),
    [anon_sym__Noreturn] = ACTIONS(3158),
    [anon_sym_noreturn] = ACTIONS(3158),
    [anon_sym_mutable] = ACTIONS(3158),
    [anon_sym_constinit] = ACTIONS(3158),
    [anon_sym_consteval] = ACTIONS(3158),
    [anon_sym_PROGMEM] = ACTIONS(3158),
    [aux_sym_primitive_type_token1] = ACTIONS(3158),
    [anon_sym_byte] = ACTIONS(3158),
    [anon_sym_word] = ACTIONS(3158),
    [anon_sym_enum] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(3158),
    [anon_sym_struct] = ACTIONS(3158),
    [anon_sym_union] = ACTIONS(3158),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_else] = ACTIONS(3158),
    [anon_sym_switch] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_for] = ACTIONS(3158),
    [anon_sym_return] = ACTIONS(3158),
    [anon_sym_break] = ACTIONS(3158),
    [anon_sym_continue] = ACTIONS(3158),
    [anon_sym_goto] = ACTIONS(3158),
    [anon_sym___try] = ACTIONS(3158),
    [anon_sym___leave] = ACTIONS(3158),
    [anon_sym_not] = ACTIONS(3158),
    [anon_sym_compl] = ACTIONS(3158),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_sizeof] = ACTIONS(3158),
    [anon_sym___alignof__] = ACTIONS(3158),
    [anon_sym___alignof] = ACTIONS(3158),
    [anon_sym__alignof] = ACTIONS(3158),
    [anon_sym_alignof] = ACTIONS(3158),
    [anon_sym__Alignof] = ACTIONS(3158),
    [anon_sym_offsetof] = ACTIONS(3158),
    [anon_sym__Generic] = ACTIONS(3158),
    [anon_sym_asm] = ACTIONS(3158),
    [anon_sym___asm__] = ACTIONS(3158),
    [aux_sym_number_literal_token1] = ACTIONS(3160),
    [aux_sym_number_literal_token2] = ACTIONS(3158),
    [anon_sym_L_SQUOTE] = ACTIONS(3160),
    [anon_sym_u_SQUOTE] = ACTIONS(3160),
    [anon_sym_U_SQUOTE] = ACTIONS(3160),
    [anon_sym_u8_SQUOTE] = ACTIONS(3160),
    [anon_sym_SQUOTE] = ACTIONS(3160),
    [anon_sym_L_DQUOTE] = ACTIONS(3160),
    [anon_sym_u_DQUOTE] = ACTIONS(3160),
    [anon_sym_U_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8_DQUOTE] = ACTIONS(3160),
    [anon_sym_DQUOTE] = ACTIONS(3160),
    [sym_true] = ACTIONS(3158),
    [sym_false] = ACTIONS(3158),
    [anon_sym_NULL] = ACTIONS(3158),
    [anon_sym_nullptr] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3158),
    [anon_sym_decltype] = ACTIONS(3158),
    [anon_sym_virtual] = ACTIONS(3158),
    [anon_sym_alignas] = ACTIONS(3158),
    [anon_sym_typename] = ACTIONS(3158),
    [anon_sym_template] = ACTIONS(3158),
    [anon_sym_try] = ACTIONS(3158),
    [anon_sym_delete] = ACTIONS(3158),
    [anon_sym_throw] = ACTIONS(3158),
    [anon_sym_co_return] = ACTIONS(3158),
    [anon_sym_co_yield] = ACTIONS(3158),
    [anon_sym_R_DQUOTE] = ACTIONS(3160),
    [anon_sym_LR_DQUOTE] = ACTIONS(3160),
    [anon_sym_uR_DQUOTE] = ACTIONS(3160),
    [anon_sym_UR_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3160),
    [anon_sym_co_await] = ACTIONS(3158),
    [anon_sym_new] = ACTIONS(3158),
    [anon_sym_requires] = ACTIONS(3158),
    [sym_this] = ACTIONS(3158),
  },
  [1222] = {
    [sym_identifier] = ACTIONS(3172),
    [anon_sym_LPAREN2] = ACTIONS(3174),
    [anon_sym_BANG] = ACTIONS(3174),
    [anon_sym_TILDE] = ACTIONS(3174),
    [anon_sym_DASH] = ACTIONS(3172),
    [anon_sym_PLUS] = ACTIONS(3172),
    [anon_sym_STAR] = ACTIONS(3174),
    [anon_sym_AMP] = ACTIONS(3174),
    [anon_sym_SEMI] = ACTIONS(3174),
    [anon_sym___extension__] = ACTIONS(3172),
    [anon_sym_typedef] = ACTIONS(3172),
    [anon_sym_extern] = ACTIONS(3172),
    [anon_sym___attribute__] = ACTIONS(3172),
    [anon_sym_COLON_COLON] = ACTIONS(3174),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3174),
    [anon_sym___declspec] = ACTIONS(3172),
    [anon_sym_LBRACE] = ACTIONS(3174),
    [anon_sym_signed] = ACTIONS(3172),
    [anon_sym_unsigned] = ACTIONS(3172),
    [anon_sym_long] = ACTIONS(3172),
    [anon_sym_short] = ACTIONS(3172),
    [anon_sym_LBRACK] = ACTIONS(3172),
    [anon_sym_static] = ACTIONS(3172),
    [anon_sym_register] = ACTIONS(3172),
    [anon_sym_inline] = ACTIONS(3172),
    [anon_sym___inline] = ACTIONS(3172),
    [anon_sym___inline__] = ACTIONS(3172),
    [anon_sym___forceinline] = ACTIONS(3172),
    [anon_sym_thread_local] = ACTIONS(3172),
    [anon_sym___thread] = ACTIONS(3172),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_constexpr] = ACTIONS(3172),
    [anon_sym_volatile] = ACTIONS(3172),
    [anon_sym_restrict] = ACTIONS(3172),
    [anon_sym___restrict__] = ACTIONS(3172),
    [anon_sym__Atomic] = ACTIONS(3172),
    [anon_sym__Noreturn] = ACTIONS(3172),
    [anon_sym_noreturn] = ACTIONS(3172),
    [anon_sym_mutable] = ACTIONS(3172),
    [anon_sym_constinit] = ACTIONS(3172),
    [anon_sym_consteval] = ACTIONS(3172),
    [anon_sym_PROGMEM] = ACTIONS(3172),
    [aux_sym_primitive_type_token1] = ACTIONS(3172),
    [anon_sym_byte] = ACTIONS(3172),
    [anon_sym_word] = ACTIONS(3172),
    [anon_sym_enum] = ACTIONS(3172),
    [anon_sym_class] = ACTIONS(3172),
    [anon_sym_struct] = ACTIONS(3172),
    [anon_sym_union] = ACTIONS(3172),
    [anon_sym_if] = ACTIONS(3172),
    [anon_sym_else] = ACTIONS(3172),
    [anon_sym_switch] = ACTIONS(3172),
    [anon_sym_while] = ACTIONS(3172),
    [anon_sym_do] = ACTIONS(3172),
    [anon_sym_for] = ACTIONS(3172),
    [anon_sym_return] = ACTIONS(3172),
    [anon_sym_break] = ACTIONS(3172),
    [anon_sym_continue] = ACTIONS(3172),
    [anon_sym_goto] = ACTIONS(3172),
    [anon_sym___try] = ACTIONS(3172),
    [anon_sym___leave] = ACTIONS(3172),
    [anon_sym_not] = ACTIONS(3172),
    [anon_sym_compl] = ACTIONS(3172),
    [anon_sym_DASH_DASH] = ACTIONS(3174),
    [anon_sym_PLUS_PLUS] = ACTIONS(3174),
    [anon_sym_sizeof] = ACTIONS(3172),
    [anon_sym___alignof__] = ACTIONS(3172),
    [anon_sym___alignof] = ACTIONS(3172),
    [anon_sym__alignof] = ACTIONS(3172),
    [anon_sym_alignof] = ACTIONS(3172),
    [anon_sym__Alignof] = ACTIONS(3172),
    [anon_sym_offsetof] = ACTIONS(3172),
    [anon_sym__Generic] = ACTIONS(3172),
    [anon_sym_asm] = ACTIONS(3172),
    [anon_sym___asm__] = ACTIONS(3172),
    [aux_sym_number_literal_token1] = ACTIONS(3174),
    [aux_sym_number_literal_token2] = ACTIONS(3172),
    [anon_sym_L_SQUOTE] = ACTIONS(3174),
    [anon_sym_u_SQUOTE] = ACTIONS(3174),
    [anon_sym_U_SQUOTE] = ACTIONS(3174),
    [anon_sym_u8_SQUOTE] = ACTIONS(3174),
    [anon_sym_SQUOTE] = ACTIONS(3174),
    [anon_sym_L_DQUOTE] = ACTIONS(3174),
    [anon_sym_u_DQUOTE] = ACTIONS(3174),
    [anon_sym_U_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8_DQUOTE] = ACTIONS(3174),
    [anon_sym_DQUOTE] = ACTIONS(3174),
    [sym_true] = ACTIONS(3172),
    [sym_false] = ACTIONS(3172),
    [anon_sym_NULL] = ACTIONS(3172),
    [anon_sym_nullptr] = ACTIONS(3172),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3172),
    [anon_sym_decltype] = ACTIONS(3172),
    [anon_sym_virtual] = ACTIONS(3172),
    [anon_sym_alignas] = ACTIONS(3172),
    [anon_sym_typename] = ACTIONS(3172),
    [anon_sym_template] = ACTIONS(3172),
    [anon_sym_try] = ACTIONS(3172),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_throw] = ACTIONS(3172),
    [anon_sym_co_return] = ACTIONS(3172),
    [anon_sym_co_yield] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3172),
    [anon_sym_new] = ACTIONS(3172),
    [anon_sym_requires] = ACTIONS(3172),
    [sym_this] = ACTIONS(3172),
  },
  [1223] = {
    [sym_identifier] = ACTIONS(3168),
    [anon_sym_LPAREN2] = ACTIONS(3170),
    [anon_sym_BANG] = ACTIONS(3170),
    [anon_sym_TILDE] = ACTIONS(3170),
    [anon_sym_DASH] = ACTIONS(3168),
    [anon_sym_PLUS] = ACTIONS(3168),
    [anon_sym_STAR] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3170),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym___extension__] = ACTIONS(3168),
    [anon_sym_typedef] = ACTIONS(3168),
    [anon_sym_extern] = ACTIONS(3168),
    [anon_sym___attribute__] = ACTIONS(3168),
    [anon_sym_COLON_COLON] = ACTIONS(3170),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3170),
    [anon_sym___declspec] = ACTIONS(3168),
    [anon_sym_LBRACE] = ACTIONS(3170),
    [anon_sym_signed] = ACTIONS(3168),
    [anon_sym_unsigned] = ACTIONS(3168),
    [anon_sym_long] = ACTIONS(3168),
    [anon_sym_short] = ACTIONS(3168),
    [anon_sym_LBRACK] = ACTIONS(3168),
    [anon_sym_static] = ACTIONS(3168),
    [anon_sym_register] = ACTIONS(3168),
    [anon_sym_inline] = ACTIONS(3168),
    [anon_sym___inline] = ACTIONS(3168),
    [anon_sym___inline__] = ACTIONS(3168),
    [anon_sym___forceinline] = ACTIONS(3168),
    [anon_sym_thread_local] = ACTIONS(3168),
    [anon_sym___thread] = ACTIONS(3168),
    [anon_sym_const] = ACTIONS(3168),
    [anon_sym_constexpr] = ACTIONS(3168),
    [anon_sym_volatile] = ACTIONS(3168),
    [anon_sym_restrict] = ACTIONS(3168),
    [anon_sym___restrict__] = ACTIONS(3168),
    [anon_sym__Atomic] = ACTIONS(3168),
    [anon_sym__Noreturn] = ACTIONS(3168),
    [anon_sym_noreturn] = ACTIONS(3168),
    [anon_sym_mutable] = ACTIONS(3168),
    [anon_sym_constinit] = ACTIONS(3168),
    [anon_sym_consteval] = ACTIONS(3168),
    [anon_sym_PROGMEM] = ACTIONS(3168),
    [aux_sym_primitive_type_token1] = ACTIONS(3168),
    [anon_sym_byte] = ACTIONS(3168),
    [anon_sym_word] = ACTIONS(3168),
    [anon_sym_enum] = ACTIONS(3168),
    [anon_sym_class] = ACTIONS(3168),
    [anon_sym_struct] = ACTIONS(3168),
    [anon_sym_union] = ACTIONS(3168),
    [anon_sym_if] = ACTIONS(3168),
    [anon_sym_else] = ACTIONS(3168),
    [anon_sym_switch] = ACTIONS(3168),
    [anon_sym_while] = ACTIONS(3168),
    [anon_sym_do] = ACTIONS(3168),
    [anon_sym_for] = ACTIONS(3168),
    [anon_sym_return] = ACTIONS(3168),
    [anon_sym_break] = ACTIONS(3168),
    [anon_sym_continue] = ACTIONS(3168),
    [anon_sym_goto] = ACTIONS(3168),
    [anon_sym___try] = ACTIONS(3168),
    [anon_sym___leave] = ACTIONS(3168),
    [anon_sym_not] = ACTIONS(3168),
    [anon_sym_compl] = ACTIONS(3168),
    [anon_sym_DASH_DASH] = ACTIONS(3170),
    [anon_sym_PLUS_PLUS] = ACTIONS(3170),
    [anon_sym_sizeof] = ACTIONS(3168),
    [anon_sym___alignof__] = ACTIONS(3168),
    [anon_sym___alignof] = ACTIONS(3168),
    [anon_sym__alignof] = ACTIONS(3168),
    [anon_sym_alignof] = ACTIONS(3168),
    [anon_sym__Alignof] = ACTIONS(3168),
    [anon_sym_offsetof] = ACTIONS(3168),
    [anon_sym__Generic] = ACTIONS(3168),
    [anon_sym_asm] = ACTIONS(3168),
    [anon_sym___asm__] = ACTIONS(3168),
    [aux_sym_number_literal_token1] = ACTIONS(3170),
    [aux_sym_number_literal_token2] = ACTIONS(3168),
    [anon_sym_L_SQUOTE] = ACTIONS(3170),
    [anon_sym_u_SQUOTE] = ACTIONS(3170),
    [anon_sym_U_SQUOTE] = ACTIONS(3170),
    [anon_sym_u8_SQUOTE] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3170),
    [anon_sym_L_DQUOTE] = ACTIONS(3170),
    [anon_sym_u_DQUOTE] = ACTIONS(3170),
    [anon_sym_U_DQUOTE] = ACTIONS(3170),
    [anon_sym_u8_DQUOTE] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3170),
    [sym_true] = ACTIONS(3168),
    [sym_false] = ACTIONS(3168),
    [anon_sym_NULL] = ACTIONS(3168),
    [anon_sym_nullptr] = ACTIONS(3168),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3168),
    [anon_sym_decltype] = ACTIONS(3168),
    [anon_sym_virtual] = ACTIONS(3168),
    [anon_sym_alignas] = ACTIONS(3168),
    [anon_sym_typename] = ACTIONS(3168),
    [anon_sym_template] = ACTIONS(3168),
    [anon_sym_try] = ACTIONS(3168),
    [anon_sym_delete] = ACTIONS(3168),
    [anon_sym_throw] = ACTIONS(3168),
    [anon_sym_co_return] = ACTIONS(3168),
    [anon_sym_co_yield] = ACTIONS(3168),
    [anon_sym_R_DQUOTE] = ACTIONS(3170),
    [anon_sym_LR_DQUOTE] = ACTIONS(3170),
    [anon_sym_uR_DQUOTE] = ACTIONS(3170),
    [anon_sym_UR_DQUOTE] = ACTIONS(3170),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3170),
    [anon_sym_co_await] = ACTIONS(3168),
    [anon_sym_new] = ACTIONS(3168),
    [anon_sym_requires] = ACTIONS(3168),
    [sym_this] = ACTIONS(3168),
  },
  [1224] = {
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [1225] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(2035),
    [sym_raw_string_literal] = STATE(3057),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3184),
    [sym_identifier] = ACTIONS(4246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4250),
    [anon_sym_TILDE] = ACTIONS(4254),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4258),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4261),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4258),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(4264),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4261),
    [anon_sym___extension__] = ACTIONS(4246),
    [anon_sym_extern] = ACTIONS(4246),
    [anon_sym___attribute__] = ACTIONS(4246),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4269),
    [anon_sym___declspec] = ACTIONS(4246),
    [anon_sym___based] = ACTIONS(4246),
    [anon_sym___cdecl] = ACTIONS(4246),
    [anon_sym___clrcall] = ACTIONS(4246),
    [anon_sym___stdcall] = ACTIONS(4246),
    [anon_sym___fastcall] = ACTIONS(4246),
    [anon_sym___thiscall] = ACTIONS(4246),
    [anon_sym___vectorcall] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_signed] = ACTIONS(4274),
    [anon_sym_unsigned] = ACTIONS(4274),
    [anon_sym_long] = ACTIONS(4274),
    [anon_sym_short] = ACTIONS(4274),
    [anon_sym_LBRACK] = ACTIONS(4276),
    [anon_sym_EQ] = ACTIONS(4280),
    [anon_sym_static] = ACTIONS(4246),
    [anon_sym_register] = ACTIONS(4246),
    [anon_sym_inline] = ACTIONS(4246),
    [anon_sym___inline] = ACTIONS(4246),
    [anon_sym___inline__] = ACTIONS(4246),
    [anon_sym___forceinline] = ACTIONS(4246),
    [anon_sym_thread_local] = ACTIONS(4246),
    [anon_sym___thread] = ACTIONS(4246),
    [anon_sym_const] = ACTIONS(4246),
    [anon_sym_constexpr] = ACTIONS(4246),
    [anon_sym_volatile] = ACTIONS(4246),
    [anon_sym_restrict] = ACTIONS(4246),
    [anon_sym___restrict__] = ACTIONS(4246),
    [anon_sym__Atomic] = ACTIONS(4246),
    [anon_sym__Noreturn] = ACTIONS(4246),
    [anon_sym_noreturn] = ACTIONS(4246),
    [anon_sym_mutable] = ACTIONS(4246),
    [anon_sym_constinit] = ACTIONS(4246),
    [anon_sym_consteval] = ACTIONS(4246),
    [anon_sym_PROGMEM] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4290),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_and_eq] = ACTIONS(4280),
    [anon_sym_or_eq] = ACTIONS(4280),
    [anon_sym_xor_eq] = ACTIONS(4280),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4256),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4256),
    [anon_sym_not_eq] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4246),
    [anon_sym_decltype] = ACTIONS(4246),
    [anon_sym_virtual] = ACTIONS(4246),
    [anon_sym_alignas] = ACTIONS(4246),
    [anon_sym_template] = ACTIONS(4246),
    [anon_sym_operator] = ACTIONS(4246),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [1226] = {
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [1227] = {
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [1228] = {
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [1229] = {
    [sym__declaration_modifiers] = STATE(2282),
    [sym__declaration_specifiers] = STATE(4808),
    [sym_attribute_specifier] = STATE(2282),
    [sym_attribute_declaration] = STATE(2282),
    [sym_ms_declspec_modifier] = STATE(2282),
    [sym_ms_based_modifier] = STATE(9597),
    [sym_ms_call_modifier] = STATE(5530),
    [sym__declarator] = STATE(7386),
    [sym__abstract_declarator] = STATE(7561),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_abstract_parenthesized_declarator] = STATE(6944),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_abstract_pointer_declarator] = STATE(6944),
    [sym_function_declarator] = STATE(7008),
    [sym_abstract_function_declarator] = STATE(6944),
    [sym_array_declarator] = STATE(7008),
    [sym_abstract_array_declarator] = STATE(6944),
    [sym_storage_class_specifier] = STATE(2282),
    [sym_type_qualifier] = STATE(2282),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_parameter_list] = STATE(4434),
    [sym_parameter_declaration] = STATE(8304),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2282),
    [sym_alignas_specifier] = STATE(2282),
    [sym_dependent_type] = STATE(3087),
    [sym_optional_parameter_declaration] = STATE(8304),
    [sym_variadic_parameter_declaration] = STATE(8304),
    [sym_reference_declarator] = STATE(7008),
    [sym_abstract_reference_declarator] = STATE(6944),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym__function_declarator_seq] = STATE(6967),
    [sym_template_type] = STATE(3039),
    [sym_template_function] = STATE(7008),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6449),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_operator_name] = STATE(7008),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2282),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(4292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2067),
    [anon_sym_RPAREN] = ACTIONS(4294),
    [anon_sym_LPAREN2] = ACTIONS(4296),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(4298),
    [anon_sym_AMP_AMP] = ACTIONS(4300),
    [anon_sym_AMP] = ACTIONS(4302),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4304),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(2091),
    [anon_sym___clrcall] = ACTIONS(2091),
    [anon_sym___stdcall] = ACTIONS(2091),
    [anon_sym___fastcall] = ACTIONS(2091),
    [anon_sym___thiscall] = ACTIONS(2091),
    [anon_sym___vectorcall] = ACTIONS(2091),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2023),
    [anon_sym_struct] = ACTIONS(2025),
    [anon_sym_union] = ACTIONS(2027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2053),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(2137),
  },
  [1230] = {
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [1231] = {
    [sym_identifier] = ACTIONS(4225),
    [anon_sym_LPAREN2] = ACTIONS(4231),
    [anon_sym_BANG] = ACTIONS(4231),
    [anon_sym_TILDE] = ACTIONS(4231),
    [anon_sym_DASH] = ACTIONS(4233),
    [anon_sym_PLUS] = ACTIONS(4233),
    [anon_sym_STAR] = ACTIONS(4231),
    [anon_sym_AMP] = ACTIONS(4231),
    [anon_sym_SEMI] = ACTIONS(4231),
    [anon_sym___extension__] = ACTIONS(4237),
    [anon_sym_extern] = ACTIONS(4237),
    [anon_sym___attribute__] = ACTIONS(4237),
    [anon_sym_COLON_COLON] = ACTIONS(4228),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4228),
    [anon_sym___declspec] = ACTIONS(4237),
    [anon_sym_LBRACE] = ACTIONS(4231),
    [anon_sym_signed] = ACTIONS(4237),
    [anon_sym_unsigned] = ACTIONS(4237),
    [anon_sym_long] = ACTIONS(4237),
    [anon_sym_short] = ACTIONS(4237),
    [anon_sym_LBRACK] = ACTIONS(4233),
    [anon_sym_static] = ACTIONS(4237),
    [anon_sym_register] = ACTIONS(4237),
    [anon_sym_inline] = ACTIONS(4237),
    [anon_sym___inline] = ACTIONS(4237),
    [anon_sym___inline__] = ACTIONS(4237),
    [anon_sym___forceinline] = ACTIONS(4237),
    [anon_sym_thread_local] = ACTIONS(4237),
    [anon_sym___thread] = ACTIONS(4237),
    [anon_sym_const] = ACTIONS(4237),
    [anon_sym_constexpr] = ACTIONS(4237),
    [anon_sym_volatile] = ACTIONS(4237),
    [anon_sym_restrict] = ACTIONS(4237),
    [anon_sym___restrict__] = ACTIONS(4237),
    [anon_sym__Atomic] = ACTIONS(4237),
    [anon_sym__Noreturn] = ACTIONS(4237),
    [anon_sym_noreturn] = ACTIONS(4237),
    [anon_sym_mutable] = ACTIONS(4237),
    [anon_sym_constinit] = ACTIONS(4237),
    [anon_sym_consteval] = ACTIONS(4237),
    [anon_sym_PROGMEM] = ACTIONS(4237),
    [aux_sym_primitive_type_token1] = ACTIONS(4225),
    [anon_sym_byte] = ACTIONS(4225),
    [anon_sym_word] = ACTIONS(4225),
    [anon_sym_enum] = ACTIONS(4237),
    [anon_sym_class] = ACTIONS(4237),
    [anon_sym_struct] = ACTIONS(4237),
    [anon_sym_union] = ACTIONS(4237),
    [anon_sym_if] = ACTIONS(4233),
    [anon_sym_switch] = ACTIONS(4233),
    [anon_sym_case] = ACTIONS(4233),
    [anon_sym_default] = ACTIONS(4233),
    [anon_sym_while] = ACTIONS(4233),
    [anon_sym_do] = ACTIONS(4233),
    [anon_sym_for] = ACTIONS(4233),
    [anon_sym_return] = ACTIONS(4233),
    [anon_sym_break] = ACTIONS(4233),
    [anon_sym_continue] = ACTIONS(4233),
    [anon_sym_goto] = ACTIONS(4233),
    [anon_sym___try] = ACTIONS(4233),
    [anon_sym___leave] = ACTIONS(4233),
    [anon_sym_not] = ACTIONS(4233),
    [anon_sym_compl] = ACTIONS(4233),
    [anon_sym_DASH_DASH] = ACTIONS(4231),
    [anon_sym_PLUS_PLUS] = ACTIONS(4231),
    [anon_sym_sizeof] = ACTIONS(4233),
    [anon_sym___alignof__] = ACTIONS(4233),
    [anon_sym___alignof] = ACTIONS(4233),
    [anon_sym__alignof] = ACTIONS(4233),
    [anon_sym_alignof] = ACTIONS(4233),
    [anon_sym__Alignof] = ACTIONS(4233),
    [anon_sym_offsetof] = ACTIONS(4233),
    [anon_sym__Generic] = ACTIONS(4233),
    [anon_sym_asm] = ACTIONS(4233),
    [anon_sym___asm__] = ACTIONS(4233),
    [aux_sym_number_literal_token1] = ACTIONS(4231),
    [aux_sym_number_literal_token2] = ACTIONS(4233),
    [anon_sym_L_SQUOTE] = ACTIONS(4231),
    [anon_sym_u_SQUOTE] = ACTIONS(4231),
    [anon_sym_U_SQUOTE] = ACTIONS(4231),
    [anon_sym_u8_SQUOTE] = ACTIONS(4231),
    [anon_sym_SQUOTE] = ACTIONS(4231),
    [anon_sym_L_DQUOTE] = ACTIONS(4231),
    [anon_sym_u_DQUOTE] = ACTIONS(4231),
    [anon_sym_U_DQUOTE] = ACTIONS(4231),
    [anon_sym_u8_DQUOTE] = ACTIONS(4231),
    [anon_sym_DQUOTE] = ACTIONS(4231),
    [sym_true] = ACTIONS(4233),
    [sym_false] = ACTIONS(4233),
    [anon_sym_NULL] = ACTIONS(4233),
    [anon_sym_nullptr] = ACTIONS(4233),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4237),
    [anon_sym_decltype] = ACTIONS(4225),
    [anon_sym_virtual] = ACTIONS(4237),
    [anon_sym_alignas] = ACTIONS(4237),
    [anon_sym_typename] = ACTIONS(4237),
    [anon_sym_template] = ACTIONS(4225),
    [anon_sym_try] = ACTIONS(4233),
    [anon_sym_delete] = ACTIONS(4233),
    [anon_sym_throw] = ACTIONS(4233),
    [anon_sym_co_return] = ACTIONS(4233),
    [anon_sym_co_yield] = ACTIONS(4233),
    [anon_sym_R_DQUOTE] = ACTIONS(4231),
    [anon_sym_LR_DQUOTE] = ACTIONS(4231),
    [anon_sym_uR_DQUOTE] = ACTIONS(4231),
    [anon_sym_UR_DQUOTE] = ACTIONS(4231),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4231),
    [anon_sym_co_await] = ACTIONS(4233),
    [anon_sym_new] = ACTIONS(4233),
    [anon_sym_requires] = ACTIONS(4233),
    [sym_this] = ACTIONS(4233),
  },
  [1232] = {
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [1233] = {
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [1234] = {
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [1235] = {
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [1236] = {
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [1237] = {
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [1238] = {
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [1239] = {
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [1240] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(2035),
    [sym_raw_string_literal] = STATE(3057),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3184),
    [sym_identifier] = ACTIONS(4246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4250),
    [anon_sym_TILDE] = ACTIONS(4254),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4258),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4261),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4258),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(4264),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4261),
    [anon_sym___extension__] = ACTIONS(4246),
    [anon_sym_extern] = ACTIONS(4246),
    [anon_sym___attribute__] = ACTIONS(4246),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4269),
    [anon_sym___declspec] = ACTIONS(4246),
    [anon_sym___based] = ACTIONS(4246),
    [anon_sym___cdecl] = ACTIONS(4246),
    [anon_sym___clrcall] = ACTIONS(4246),
    [anon_sym___stdcall] = ACTIONS(4246),
    [anon_sym___fastcall] = ACTIONS(4246),
    [anon_sym___thiscall] = ACTIONS(4246),
    [anon_sym___vectorcall] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_signed] = ACTIONS(4274),
    [anon_sym_unsigned] = ACTIONS(4274),
    [anon_sym_long] = ACTIONS(4274),
    [anon_sym_short] = ACTIONS(4274),
    [anon_sym_LBRACK] = ACTIONS(4276),
    [anon_sym_EQ] = ACTIONS(4280),
    [anon_sym_static] = ACTIONS(4246),
    [anon_sym_register] = ACTIONS(4246),
    [anon_sym_inline] = ACTIONS(4246),
    [anon_sym___inline] = ACTIONS(4246),
    [anon_sym___inline__] = ACTIONS(4246),
    [anon_sym___forceinline] = ACTIONS(4246),
    [anon_sym_thread_local] = ACTIONS(4246),
    [anon_sym___thread] = ACTIONS(4246),
    [anon_sym_const] = ACTIONS(4246),
    [anon_sym_constexpr] = ACTIONS(4246),
    [anon_sym_volatile] = ACTIONS(4246),
    [anon_sym_restrict] = ACTIONS(4246),
    [anon_sym___restrict__] = ACTIONS(4246),
    [anon_sym__Atomic] = ACTIONS(4246),
    [anon_sym__Noreturn] = ACTIONS(4246),
    [anon_sym_noreturn] = ACTIONS(4246),
    [anon_sym_mutable] = ACTIONS(4246),
    [anon_sym_constinit] = ACTIONS(4246),
    [anon_sym_consteval] = ACTIONS(4246),
    [anon_sym_PROGMEM] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4308),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_and_eq] = ACTIONS(4280),
    [anon_sym_or_eq] = ACTIONS(4280),
    [anon_sym_xor_eq] = ACTIONS(4280),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4256),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4256),
    [anon_sym_not_eq] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4246),
    [anon_sym_decltype] = ACTIONS(4246),
    [anon_sym_virtual] = ACTIONS(4246),
    [anon_sym_alignas] = ACTIONS(4246),
    [anon_sym_template] = ACTIONS(4246),
    [anon_sym_operator] = ACTIONS(4246),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [1241] = {
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym___extension__] = ACTIONS(2946),
    [anon_sym_typedef] = ACTIONS(2946),
    [anon_sym_extern] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2948),
    [anon_sym___declspec] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_signed] = ACTIONS(2946),
    [anon_sym_unsigned] = ACTIONS(2946),
    [anon_sym_long] = ACTIONS(2946),
    [anon_sym_short] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2946),
    [anon_sym_inline] = ACTIONS(2946),
    [anon_sym___inline] = ACTIONS(2946),
    [anon_sym___inline__] = ACTIONS(2946),
    [anon_sym___forceinline] = ACTIONS(2946),
    [anon_sym_thread_local] = ACTIONS(2946),
    [anon_sym___thread] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_constexpr] = ACTIONS(2946),
    [anon_sym_volatile] = ACTIONS(2946),
    [anon_sym_restrict] = ACTIONS(2946),
    [anon_sym___restrict__] = ACTIONS(2946),
    [anon_sym__Atomic] = ACTIONS(2946),
    [anon_sym__Noreturn] = ACTIONS(2946),
    [anon_sym_noreturn] = ACTIONS(2946),
    [anon_sym_mutable] = ACTIONS(2946),
    [anon_sym_constinit] = ACTIONS(2946),
    [anon_sym_consteval] = ACTIONS(2946),
    [anon_sym_PROGMEM] = ACTIONS(2946),
    [aux_sym_primitive_type_token1] = ACTIONS(2946),
    [anon_sym_byte] = ACTIONS(2946),
    [anon_sym_word] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_struct] = ACTIONS(2946),
    [anon_sym_union] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_goto] = ACTIONS(2946),
    [anon_sym___try] = ACTIONS(2946),
    [anon_sym___leave] = ACTIONS(2946),
    [anon_sym_not] = ACTIONS(2946),
    [anon_sym_compl] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_sizeof] = ACTIONS(2946),
    [anon_sym___alignof__] = ACTIONS(2946),
    [anon_sym___alignof] = ACTIONS(2946),
    [anon_sym__alignof] = ACTIONS(2946),
    [anon_sym_alignof] = ACTIONS(2946),
    [anon_sym__Alignof] = ACTIONS(2946),
    [anon_sym_offsetof] = ACTIONS(2946),
    [anon_sym__Generic] = ACTIONS(2946),
    [anon_sym_asm] = ACTIONS(2946),
    [anon_sym___asm__] = ACTIONS(2946),
    [aux_sym_number_literal_token1] = ACTIONS(2948),
    [aux_sym_number_literal_token2] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2948),
    [anon_sym_u_SQUOTE] = ACTIONS(2948),
    [anon_sym_U_SQUOTE] = ACTIONS(2948),
    [anon_sym_u8_SQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [anon_sym_L_DQUOTE] = ACTIONS(2948),
    [anon_sym_u_DQUOTE] = ACTIONS(2948),
    [anon_sym_U_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [anon_sym_NULL] = ACTIONS(2946),
    [anon_sym_nullptr] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2946),
    [anon_sym_decltype] = ACTIONS(2946),
    [anon_sym_virtual] = ACTIONS(2946),
    [anon_sym_alignas] = ACTIONS(2946),
    [anon_sym_typename] = ACTIONS(2946),
    [anon_sym_template] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_co_return] = ACTIONS(2946),
    [anon_sym_co_yield] = ACTIONS(2946),
    [anon_sym_R_DQUOTE] = ACTIONS(2948),
    [anon_sym_LR_DQUOTE] = ACTIONS(2948),
    [anon_sym_uR_DQUOTE] = ACTIONS(2948),
    [anon_sym_UR_DQUOTE] = ACTIONS(2948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2948),
    [anon_sym_co_await] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_requires] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
  },
  [1242] = {
    [sym_identifier] = ACTIONS(3128),
    [anon_sym_LPAREN2] = ACTIONS(3130),
    [anon_sym_BANG] = ACTIONS(3130),
    [anon_sym_TILDE] = ACTIONS(3130),
    [anon_sym_DASH] = ACTIONS(3128),
    [anon_sym_PLUS] = ACTIONS(3128),
    [anon_sym_STAR] = ACTIONS(3130),
    [anon_sym_AMP] = ACTIONS(3130),
    [anon_sym_SEMI] = ACTIONS(3130),
    [anon_sym___extension__] = ACTIONS(3128),
    [anon_sym_typedef] = ACTIONS(3128),
    [anon_sym_extern] = ACTIONS(3128),
    [anon_sym___attribute__] = ACTIONS(3128),
    [anon_sym_COLON_COLON] = ACTIONS(3130),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3130),
    [anon_sym___declspec] = ACTIONS(3128),
    [anon_sym_LBRACE] = ACTIONS(3130),
    [anon_sym_signed] = ACTIONS(3128),
    [anon_sym_unsigned] = ACTIONS(3128),
    [anon_sym_long] = ACTIONS(3128),
    [anon_sym_short] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3128),
    [anon_sym_static] = ACTIONS(3128),
    [anon_sym_register] = ACTIONS(3128),
    [anon_sym_inline] = ACTIONS(3128),
    [anon_sym___inline] = ACTIONS(3128),
    [anon_sym___inline__] = ACTIONS(3128),
    [anon_sym___forceinline] = ACTIONS(3128),
    [anon_sym_thread_local] = ACTIONS(3128),
    [anon_sym___thread] = ACTIONS(3128),
    [anon_sym_const] = ACTIONS(3128),
    [anon_sym_constexpr] = ACTIONS(3128),
    [anon_sym_volatile] = ACTIONS(3128),
    [anon_sym_restrict] = ACTIONS(3128),
    [anon_sym___restrict__] = ACTIONS(3128),
    [anon_sym__Atomic] = ACTIONS(3128),
    [anon_sym__Noreturn] = ACTIONS(3128),
    [anon_sym_noreturn] = ACTIONS(3128),
    [anon_sym_mutable] = ACTIONS(3128),
    [anon_sym_constinit] = ACTIONS(3128),
    [anon_sym_consteval] = ACTIONS(3128),
    [anon_sym_PROGMEM] = ACTIONS(3128),
    [aux_sym_primitive_type_token1] = ACTIONS(3128),
    [anon_sym_byte] = ACTIONS(3128),
    [anon_sym_word] = ACTIONS(3128),
    [anon_sym_enum] = ACTIONS(3128),
    [anon_sym_class] = ACTIONS(3128),
    [anon_sym_struct] = ACTIONS(3128),
    [anon_sym_union] = ACTIONS(3128),
    [anon_sym_if] = ACTIONS(3128),
    [anon_sym_else] = ACTIONS(3128),
    [anon_sym_switch] = ACTIONS(3128),
    [anon_sym_while] = ACTIONS(3128),
    [anon_sym_do] = ACTIONS(3128),
    [anon_sym_for] = ACTIONS(3128),
    [anon_sym_return] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3128),
    [anon_sym_continue] = ACTIONS(3128),
    [anon_sym_goto] = ACTIONS(3128),
    [anon_sym___try] = ACTIONS(3128),
    [anon_sym___leave] = ACTIONS(3128),
    [anon_sym_not] = ACTIONS(3128),
    [anon_sym_compl] = ACTIONS(3128),
    [anon_sym_DASH_DASH] = ACTIONS(3130),
    [anon_sym_PLUS_PLUS] = ACTIONS(3130),
    [anon_sym_sizeof] = ACTIONS(3128),
    [anon_sym___alignof__] = ACTIONS(3128),
    [anon_sym___alignof] = ACTIONS(3128),
    [anon_sym__alignof] = ACTIONS(3128),
    [anon_sym_alignof] = ACTIONS(3128),
    [anon_sym__Alignof] = ACTIONS(3128),
    [anon_sym_offsetof] = ACTIONS(3128),
    [anon_sym__Generic] = ACTIONS(3128),
    [anon_sym_asm] = ACTIONS(3128),
    [anon_sym___asm__] = ACTIONS(3128),
    [aux_sym_number_literal_token1] = ACTIONS(3130),
    [aux_sym_number_literal_token2] = ACTIONS(3128),
    [anon_sym_L_SQUOTE] = ACTIONS(3130),
    [anon_sym_u_SQUOTE] = ACTIONS(3130),
    [anon_sym_U_SQUOTE] = ACTIONS(3130),
    [anon_sym_u8_SQUOTE] = ACTIONS(3130),
    [anon_sym_SQUOTE] = ACTIONS(3130),
    [anon_sym_L_DQUOTE] = ACTIONS(3130),
    [anon_sym_u_DQUOTE] = ACTIONS(3130),
    [anon_sym_U_DQUOTE] = ACTIONS(3130),
    [anon_sym_u8_DQUOTE] = ACTIONS(3130),
    [anon_sym_DQUOTE] = ACTIONS(3130),
    [sym_true] = ACTIONS(3128),
    [sym_false] = ACTIONS(3128),
    [anon_sym_NULL] = ACTIONS(3128),
    [anon_sym_nullptr] = ACTIONS(3128),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3128),
    [anon_sym_decltype] = ACTIONS(3128),
    [anon_sym_virtual] = ACTIONS(3128),
    [anon_sym_alignas] = ACTIONS(3128),
    [anon_sym_typename] = ACTIONS(3128),
    [anon_sym_template] = ACTIONS(3128),
    [anon_sym_try] = ACTIONS(3128),
    [anon_sym_delete] = ACTIONS(3128),
    [anon_sym_throw] = ACTIONS(3128),
    [anon_sym_co_return] = ACTIONS(3128),
    [anon_sym_co_yield] = ACTIONS(3128),
    [anon_sym_R_DQUOTE] = ACTIONS(3130),
    [anon_sym_LR_DQUOTE] = ACTIONS(3130),
    [anon_sym_uR_DQUOTE] = ACTIONS(3130),
    [anon_sym_UR_DQUOTE] = ACTIONS(3130),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3130),
    [anon_sym_co_await] = ACTIONS(3128),
    [anon_sym_new] = ACTIONS(3128),
    [anon_sym_requires] = ACTIONS(3128),
    [sym_this] = ACTIONS(3128),
  },
  [1243] = {
    [sym_identifier] = ACTIONS(3134),
    [anon_sym_LPAREN2] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3136),
    [anon_sym_TILDE] = ACTIONS(3136),
    [anon_sym_DASH] = ACTIONS(3134),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_STAR] = ACTIONS(3136),
    [anon_sym_AMP] = ACTIONS(3136),
    [anon_sym_SEMI] = ACTIONS(3136),
    [anon_sym___extension__] = ACTIONS(3134),
    [anon_sym_typedef] = ACTIONS(3134),
    [anon_sym_extern] = ACTIONS(3134),
    [anon_sym___attribute__] = ACTIONS(3134),
    [anon_sym_COLON_COLON] = ACTIONS(3136),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3136),
    [anon_sym___declspec] = ACTIONS(3134),
    [anon_sym_LBRACE] = ACTIONS(3136),
    [anon_sym_signed] = ACTIONS(3134),
    [anon_sym_unsigned] = ACTIONS(3134),
    [anon_sym_long] = ACTIONS(3134),
    [anon_sym_short] = ACTIONS(3134),
    [anon_sym_LBRACK] = ACTIONS(3134),
    [anon_sym_static] = ACTIONS(3134),
    [anon_sym_register] = ACTIONS(3134),
    [anon_sym_inline] = ACTIONS(3134),
    [anon_sym___inline] = ACTIONS(3134),
    [anon_sym___inline__] = ACTIONS(3134),
    [anon_sym___forceinline] = ACTIONS(3134),
    [anon_sym_thread_local] = ACTIONS(3134),
    [anon_sym___thread] = ACTIONS(3134),
    [anon_sym_const] = ACTIONS(3134),
    [anon_sym_constexpr] = ACTIONS(3134),
    [anon_sym_volatile] = ACTIONS(3134),
    [anon_sym_restrict] = ACTIONS(3134),
    [anon_sym___restrict__] = ACTIONS(3134),
    [anon_sym__Atomic] = ACTIONS(3134),
    [anon_sym__Noreturn] = ACTIONS(3134),
    [anon_sym_noreturn] = ACTIONS(3134),
    [anon_sym_mutable] = ACTIONS(3134),
    [anon_sym_constinit] = ACTIONS(3134),
    [anon_sym_consteval] = ACTIONS(3134),
    [anon_sym_PROGMEM] = ACTIONS(3134),
    [aux_sym_primitive_type_token1] = ACTIONS(3134),
    [anon_sym_byte] = ACTIONS(3134),
    [anon_sym_word] = ACTIONS(3134),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3134),
    [anon_sym_struct] = ACTIONS(3134),
    [anon_sym_union] = ACTIONS(3134),
    [anon_sym_if] = ACTIONS(3134),
    [anon_sym_else] = ACTIONS(3134),
    [anon_sym_switch] = ACTIONS(3134),
    [anon_sym_while] = ACTIONS(3134),
    [anon_sym_do] = ACTIONS(3134),
    [anon_sym_for] = ACTIONS(3134),
    [anon_sym_return] = ACTIONS(3134),
    [anon_sym_break] = ACTIONS(3134),
    [anon_sym_continue] = ACTIONS(3134),
    [anon_sym_goto] = ACTIONS(3134),
    [anon_sym___try] = ACTIONS(3134),
    [anon_sym___leave] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3134),
    [anon_sym_compl] = ACTIONS(3134),
    [anon_sym_DASH_DASH] = ACTIONS(3136),
    [anon_sym_PLUS_PLUS] = ACTIONS(3136),
    [anon_sym_sizeof] = ACTIONS(3134),
    [anon_sym___alignof__] = ACTIONS(3134),
    [anon_sym___alignof] = ACTIONS(3134),
    [anon_sym__alignof] = ACTIONS(3134),
    [anon_sym_alignof] = ACTIONS(3134),
    [anon_sym__Alignof] = ACTIONS(3134),
    [anon_sym_offsetof] = ACTIONS(3134),
    [anon_sym__Generic] = ACTIONS(3134),
    [anon_sym_asm] = ACTIONS(3134),
    [anon_sym___asm__] = ACTIONS(3134),
    [aux_sym_number_literal_token1] = ACTIONS(3136),
    [aux_sym_number_literal_token2] = ACTIONS(3134),
    [anon_sym_L_SQUOTE] = ACTIONS(3136),
    [anon_sym_u_SQUOTE] = ACTIONS(3136),
    [anon_sym_U_SQUOTE] = ACTIONS(3136),
    [anon_sym_u8_SQUOTE] = ACTIONS(3136),
    [anon_sym_SQUOTE] = ACTIONS(3136),
    [anon_sym_L_DQUOTE] = ACTIONS(3136),
    [anon_sym_u_DQUOTE] = ACTIONS(3136),
    [anon_sym_U_DQUOTE] = ACTIONS(3136),
    [anon_sym_u8_DQUOTE] = ACTIONS(3136),
    [anon_sym_DQUOTE] = ACTIONS(3136),
    [sym_true] = ACTIONS(3134),
    [sym_false] = ACTIONS(3134),
    [anon_sym_NULL] = ACTIONS(3134),
    [anon_sym_nullptr] = ACTIONS(3134),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3134),
    [anon_sym_decltype] = ACTIONS(3134),
    [anon_sym_virtual] = ACTIONS(3134),
    [anon_sym_alignas] = ACTIONS(3134),
    [anon_sym_typename] = ACTIONS(3134),
    [anon_sym_template] = ACTIONS(3134),
    [anon_sym_try] = ACTIONS(3134),
    [anon_sym_delete] = ACTIONS(3134),
    [anon_sym_throw] = ACTIONS(3134),
    [anon_sym_co_return] = ACTIONS(3134),
    [anon_sym_co_yield] = ACTIONS(3134),
    [anon_sym_R_DQUOTE] = ACTIONS(3136),
    [anon_sym_LR_DQUOTE] = ACTIONS(3136),
    [anon_sym_uR_DQUOTE] = ACTIONS(3136),
    [anon_sym_UR_DQUOTE] = ACTIONS(3136),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3136),
    [anon_sym_co_await] = ACTIONS(3134),
    [anon_sym_new] = ACTIONS(3134),
    [anon_sym_requires] = ACTIONS(3134),
    [sym_this] = ACTIONS(3134),
  },
  [1244] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(2035),
    [sym_raw_string_literal] = STATE(3057),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3184),
    [sym_identifier] = ACTIONS(4246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4250),
    [anon_sym_TILDE] = ACTIONS(4254),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4258),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4261),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4258),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(4264),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4261),
    [anon_sym___extension__] = ACTIONS(4246),
    [anon_sym_extern] = ACTIONS(4246),
    [anon_sym___attribute__] = ACTIONS(4246),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4269),
    [anon_sym___declspec] = ACTIONS(4246),
    [anon_sym___based] = ACTIONS(4246),
    [anon_sym___cdecl] = ACTIONS(4246),
    [anon_sym___clrcall] = ACTIONS(4246),
    [anon_sym___stdcall] = ACTIONS(4246),
    [anon_sym___fastcall] = ACTIONS(4246),
    [anon_sym___thiscall] = ACTIONS(4246),
    [anon_sym___vectorcall] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_signed] = ACTIONS(4274),
    [anon_sym_unsigned] = ACTIONS(4274),
    [anon_sym_long] = ACTIONS(4274),
    [anon_sym_short] = ACTIONS(4274),
    [anon_sym_LBRACK] = ACTIONS(4276),
    [anon_sym_EQ] = ACTIONS(4280),
    [anon_sym_static] = ACTIONS(4246),
    [anon_sym_register] = ACTIONS(4246),
    [anon_sym_inline] = ACTIONS(4246),
    [anon_sym___inline] = ACTIONS(4246),
    [anon_sym___inline__] = ACTIONS(4246),
    [anon_sym___forceinline] = ACTIONS(4246),
    [anon_sym_thread_local] = ACTIONS(4246),
    [anon_sym___thread] = ACTIONS(4246),
    [anon_sym_const] = ACTIONS(4246),
    [anon_sym_constexpr] = ACTIONS(4246),
    [anon_sym_volatile] = ACTIONS(4246),
    [anon_sym_restrict] = ACTIONS(4246),
    [anon_sym___restrict__] = ACTIONS(4246),
    [anon_sym__Atomic] = ACTIONS(4246),
    [anon_sym__Noreturn] = ACTIONS(4246),
    [anon_sym_noreturn] = ACTIONS(4246),
    [anon_sym_mutable] = ACTIONS(4246),
    [anon_sym_constinit] = ACTIONS(4246),
    [anon_sym_consteval] = ACTIONS(4246),
    [anon_sym_PROGMEM] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4310),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_and_eq] = ACTIONS(4280),
    [anon_sym_or_eq] = ACTIONS(4280),
    [anon_sym_xor_eq] = ACTIONS(4280),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4256),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4256),
    [anon_sym_not_eq] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4246),
    [anon_sym_decltype] = ACTIONS(4246),
    [anon_sym_virtual] = ACTIONS(4246),
    [anon_sym_alignas] = ACTIONS(4246),
    [anon_sym_template] = ACTIONS(4246),
    [anon_sym_operator] = ACTIONS(4246),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [1245] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5117),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8103),
    [sym_initializer_pair] = STATE(8103),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_COMMA] = ACTIONS(4314),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4316),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1246] = {
    [sym_primitive_type] = STATE(7715),
    [sym_expression_statement] = STATE(3112),
    [sym__expression] = STATE(5310),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9679),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_type_requirement] = STATE(1259),
    [sym_compound_requirement] = STATE(1259),
    [sym__requirement] = STATE(1259),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_requirement_seq_repeat1] = STATE(1259),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [anon_sym_RBRACE] = ACTIONS(4324),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_typename] = ACTIONS(4326),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1247] = {
    [sym_primitive_type] = STATE(7715),
    [sym_expression_statement] = STATE(3112),
    [sym__expression] = STATE(5310),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9679),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_type_requirement] = STATE(1266),
    [sym_compound_requirement] = STATE(1266),
    [sym__requirement] = STATE(1266),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_requirement_seq_repeat1] = STATE(1266),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [anon_sym_RBRACE] = ACTIONS(4328),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_typename] = ACTIONS(4326),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1248] = {
    [sym_primitive_type] = STATE(7715),
    [sym_expression_statement] = STATE(3112),
    [sym__expression] = STATE(5310),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9679),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_type_requirement] = STATE(1259),
    [sym_compound_requirement] = STATE(1259),
    [sym__requirement] = STATE(1259),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_requirement_seq_repeat1] = STATE(1259),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [anon_sym_RBRACE] = ACTIONS(4330),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_typename] = ACTIONS(4326),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1249] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5076),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8010),
    [sym_initializer_pair] = STATE(8010),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_COMMA] = ACTIONS(4332),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4334),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1250] = {
    [sym_primitive_type] = STATE(7715),
    [sym_expression_statement] = STATE(3112),
    [sym__expression] = STATE(5310),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9679),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_type_requirement] = STATE(1246),
    [sym_compound_requirement] = STATE(1246),
    [sym__requirement] = STATE(1246),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_requirement_seq_repeat1] = STATE(1246),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [anon_sym_RBRACE] = ACTIONS(4336),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_typename] = ACTIONS(4326),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1251] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5144),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8004),
    [sym_initializer_pair] = STATE(8004),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_COMMA] = ACTIONS(4338),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4340),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1252] = {
    [sym_primitive_type] = STATE(7715),
    [sym_expression_statement] = STATE(3112),
    [sym__expression] = STATE(5310),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9679),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_type_requirement] = STATE(1255),
    [sym_compound_requirement] = STATE(1255),
    [sym__requirement] = STATE(1255),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_requirement_seq_repeat1] = STATE(1255),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [anon_sym_RBRACE] = ACTIONS(4342),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_typename] = ACTIONS(4326),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1253] = {
    [sym_primitive_type] = STATE(7715),
    [sym_expression_statement] = STATE(3112),
    [sym__expression] = STATE(5310),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9679),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_type_requirement] = STATE(1259),
    [sym_compound_requirement] = STATE(1259),
    [sym__requirement] = STATE(1259),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_requirement_seq_repeat1] = STATE(1259),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [anon_sym_RBRACE] = ACTIONS(4344),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_typename] = ACTIONS(4326),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1254] = {
    [sym_primitive_type] = STATE(7715),
    [sym_expression_statement] = STATE(3112),
    [sym__expression] = STATE(5310),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9679),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_type_requirement] = STATE(1259),
    [sym_compound_requirement] = STATE(1259),
    [sym__requirement] = STATE(1259),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_requirement_seq_repeat1] = STATE(1259),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_typename] = ACTIONS(4326),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1255] = {
    [sym_primitive_type] = STATE(7715),
    [sym_expression_statement] = STATE(3112),
    [sym__expression] = STATE(5310),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9679),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_type_requirement] = STATE(1259),
    [sym_compound_requirement] = STATE(1259),
    [sym__requirement] = STATE(1259),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_requirement_seq_repeat1] = STATE(1259),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [anon_sym_RBRACE] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_typename] = ACTIONS(4326),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1256] = {
    [sym_primitive_type] = STATE(7715),
    [sym_expression_statement] = STATE(3112),
    [sym__expression] = STATE(5310),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9679),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_type_requirement] = STATE(1254),
    [sym_compound_requirement] = STATE(1254),
    [sym__requirement] = STATE(1254),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_requirement_seq_repeat1] = STATE(1254),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [anon_sym_RBRACE] = ACTIONS(4350),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_typename] = ACTIONS(4326),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1257] = {
    [sym_primitive_type] = STATE(7715),
    [sym_expression_statement] = STATE(3112),
    [sym__expression] = STATE(5310),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9679),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_type_requirement] = STATE(1259),
    [sym_compound_requirement] = STATE(1259),
    [sym__requirement] = STATE(1259),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_requirement_seq_repeat1] = STATE(1259),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [anon_sym_RBRACE] = ACTIONS(4352),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_typename] = ACTIONS(4326),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1258] = {
    [sym_primitive_type] = STATE(7715),
    [sym_expression_statement] = STATE(3112),
    [sym__expression] = STATE(5310),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9679),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_type_requirement] = STATE(1248),
    [sym_compound_requirement] = STATE(1248),
    [sym__requirement] = STATE(1248),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_requirement_seq_repeat1] = STATE(1248),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [anon_sym_RBRACE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_typename] = ACTIONS(4326),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1259] = {
    [sym_primitive_type] = STATE(7715),
    [sym_expression_statement] = STATE(3112),
    [sym__expression] = STATE(5310),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9679),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_type_requirement] = STATE(1259),
    [sym_compound_requirement] = STATE(1259),
    [sym__requirement] = STATE(1259),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_requirement_seq_repeat1] = STATE(1259),
    [sym_identifier] = ACTIONS(4356),
    [anon_sym_LPAREN2] = ACTIONS(4359),
    [anon_sym_BANG] = ACTIONS(4362),
    [anon_sym_TILDE] = ACTIONS(4362),
    [anon_sym_DASH] = ACTIONS(4365),
    [anon_sym_PLUS] = ACTIONS(4365),
    [anon_sym_STAR] = ACTIONS(4368),
    [anon_sym_AMP] = ACTIONS(4368),
    [anon_sym_SEMI] = ACTIONS(4371),
    [anon_sym_COLON_COLON] = ACTIONS(4374),
    [anon_sym_LBRACE] = ACTIONS(4377),
    [anon_sym_RBRACE] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(4382),
    [aux_sym_primitive_type_token1] = ACTIONS(4385),
    [anon_sym_byte] = ACTIONS(4385),
    [anon_sym_word] = ACTIONS(4385),
    [anon_sym_not] = ACTIONS(4365),
    [anon_sym_compl] = ACTIONS(4365),
    [anon_sym_DASH_DASH] = ACTIONS(4388),
    [anon_sym_PLUS_PLUS] = ACTIONS(4388),
    [anon_sym_sizeof] = ACTIONS(4391),
    [anon_sym___alignof__] = ACTIONS(4394),
    [anon_sym___alignof] = ACTIONS(4394),
    [anon_sym__alignof] = ACTIONS(4394),
    [anon_sym_alignof] = ACTIONS(4394),
    [anon_sym__Alignof] = ACTIONS(4394),
    [anon_sym_offsetof] = ACTIONS(4397),
    [anon_sym__Generic] = ACTIONS(4400),
    [anon_sym_asm] = ACTIONS(4403),
    [anon_sym___asm__] = ACTIONS(4403),
    [aux_sym_number_literal_token1] = ACTIONS(4406),
    [aux_sym_number_literal_token2] = ACTIONS(4409),
    [anon_sym_L_SQUOTE] = ACTIONS(4412),
    [anon_sym_u_SQUOTE] = ACTIONS(4412),
    [anon_sym_U_SQUOTE] = ACTIONS(4412),
    [anon_sym_u8_SQUOTE] = ACTIONS(4412),
    [anon_sym_SQUOTE] = ACTIONS(4412),
    [anon_sym_L_DQUOTE] = ACTIONS(4415),
    [anon_sym_u_DQUOTE] = ACTIONS(4415),
    [anon_sym_U_DQUOTE] = ACTIONS(4415),
    [anon_sym_u8_DQUOTE] = ACTIONS(4415),
    [anon_sym_DQUOTE] = ACTIONS(4415),
    [sym_true] = ACTIONS(4418),
    [sym_false] = ACTIONS(4418),
    [anon_sym_NULL] = ACTIONS(4421),
    [anon_sym_nullptr] = ACTIONS(4421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4424),
    [anon_sym_typename] = ACTIONS(4427),
    [anon_sym_template] = ACTIONS(4430),
    [anon_sym_delete] = ACTIONS(4433),
    [anon_sym_R_DQUOTE] = ACTIONS(4436),
    [anon_sym_LR_DQUOTE] = ACTIONS(4436),
    [anon_sym_uR_DQUOTE] = ACTIONS(4436),
    [anon_sym_UR_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4436),
    [anon_sym_co_await] = ACTIONS(4439),
    [anon_sym_new] = ACTIONS(4442),
    [anon_sym_requires] = ACTIONS(4445),
    [sym_this] = ACTIONS(4418),
  },
  [1260] = {
    [sym_primitive_type] = STATE(7715),
    [sym_expression_statement] = STATE(3112),
    [sym__expression] = STATE(5310),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9679),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_type_requirement] = STATE(1262),
    [sym_compound_requirement] = STATE(1262),
    [sym__requirement] = STATE(1262),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_requirement_seq_repeat1] = STATE(1262),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [anon_sym_RBRACE] = ACTIONS(4448),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_typename] = ACTIONS(4326),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1261] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5107),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8013),
    [sym_initializer_pair] = STATE(8013),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_COMMA] = ACTIONS(167),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4450),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1262] = {
    [sym_primitive_type] = STATE(7715),
    [sym_expression_statement] = STATE(3112),
    [sym__expression] = STATE(5310),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9679),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_type_requirement] = STATE(1259),
    [sym_compound_requirement] = STATE(1259),
    [sym__requirement] = STATE(1259),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_requirement_seq_repeat1] = STATE(1259),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [anon_sym_RBRACE] = ACTIONS(4452),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_typename] = ACTIONS(4326),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1263] = {
    [sym_primitive_type] = STATE(7715),
    [sym_expression_statement] = STATE(3112),
    [sym__expression] = STATE(5310),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9679),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_type_requirement] = STATE(1276),
    [sym_compound_requirement] = STATE(1276),
    [sym__requirement] = STATE(1276),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_requirement_seq_repeat1] = STATE(1276),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [anon_sym_RBRACE] = ACTIONS(4454),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_typename] = ACTIONS(4326),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1264] = {
    [sym_primitive_type] = STATE(7715),
    [sym_expression_statement] = STATE(3112),
    [sym__expression] = STATE(5310),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9679),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_type_requirement] = STATE(1275),
    [sym_compound_requirement] = STATE(1275),
    [sym__requirement] = STATE(1275),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_requirement_seq_repeat1] = STATE(1275),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [anon_sym_RBRACE] = ACTIONS(4456),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_typename] = ACTIONS(4326),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1265] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5069),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8385),
    [sym_initializer_pair] = STATE(8385),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_COMMA] = ACTIONS(4458),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4460),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1266] = {
    [sym_primitive_type] = STATE(7715),
    [sym_expression_statement] = STATE(3112),
    [sym__expression] = STATE(5310),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9679),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_type_requirement] = STATE(1259),
    [sym_compound_requirement] = STATE(1259),
    [sym__requirement] = STATE(1259),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_requirement_seq_repeat1] = STATE(1259),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [anon_sym_RBRACE] = ACTIONS(4462),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_typename] = ACTIONS(4326),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1267] = {
    [sym_primitive_type] = STATE(7715),
    [sym_expression_statement] = STATE(3112),
    [sym__expression] = STATE(5310),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9679),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_type_requirement] = STATE(1259),
    [sym_compound_requirement] = STATE(1259),
    [sym__requirement] = STATE(1259),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_requirement_seq_repeat1] = STATE(1259),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [anon_sym_RBRACE] = ACTIONS(4464),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_typename] = ACTIONS(4326),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1268] = {
    [sym_primitive_type] = STATE(7715),
    [sym_expression_statement] = STATE(3112),
    [sym__expression] = STATE(5310),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9679),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_type_requirement] = STATE(1253),
    [sym_compound_requirement] = STATE(1253),
    [sym__requirement] = STATE(1253),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_requirement_seq_repeat1] = STATE(1253),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [anon_sym_RBRACE] = ACTIONS(4466),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_typename] = ACTIONS(4326),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1269] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5062),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8239),
    [sym_initializer_pair] = STATE(8239),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_COMMA] = ACTIONS(4468),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4470),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1270] = {
    [sym_primitive_type] = STATE(7715),
    [sym_expression_statement] = STATE(3112),
    [sym__expression] = STATE(5310),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9679),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_type_requirement] = STATE(1267),
    [sym_compound_requirement] = STATE(1267),
    [sym__requirement] = STATE(1267),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_requirement_seq_repeat1] = STATE(1267),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [anon_sym_RBRACE] = ACTIONS(4472),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_typename] = ACTIONS(4326),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1271] = {
    [sym_primitive_type] = STATE(7715),
    [sym_expression_statement] = STATE(3112),
    [sym__expression] = STATE(5310),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9679),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_type_requirement] = STATE(1257),
    [sym_compound_requirement] = STATE(1257),
    [sym__requirement] = STATE(1257),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_requirement_seq_repeat1] = STATE(1257),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [anon_sym_RBRACE] = ACTIONS(4474),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_typename] = ACTIONS(4326),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1272] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5124),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8138),
    [sym_initializer_pair] = STATE(8138),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_COMMA] = ACTIONS(4476),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4478),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1273] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5139),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8319),
    [sym_initializer_pair] = STATE(8319),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_COMMA] = ACTIONS(4480),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4482),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1274] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5043),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(7938),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8553),
    [sym_initializer_pair] = STATE(8553),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1275] = {
    [sym_primitive_type] = STATE(7715),
    [sym_expression_statement] = STATE(3112),
    [sym__expression] = STATE(5310),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9679),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_type_requirement] = STATE(1259),
    [sym_compound_requirement] = STATE(1259),
    [sym__requirement] = STATE(1259),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_requirement_seq_repeat1] = STATE(1259),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [anon_sym_RBRACE] = ACTIONS(4486),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_typename] = ACTIONS(4326),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1276] = {
    [sym_primitive_type] = STATE(7715),
    [sym_expression_statement] = STATE(3112),
    [sym__expression] = STATE(5310),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9679),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_type_requirement] = STATE(1259),
    [sym_compound_requirement] = STATE(1259),
    [sym__requirement] = STATE(1259),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_requirement_seq_repeat1] = STATE(1259),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [anon_sym_RBRACE] = ACTIONS(4488),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_typename] = ACTIONS(4326),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1277] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5300),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8553),
    [sym_initializer_pair] = STATE(8553),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4490),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1278] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5300),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8553),
    [sym_initializer_pair] = STATE(8553),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1279] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5300),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8553),
    [sym_initializer_pair] = STATE(8553),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4494),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1280] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5300),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8553),
    [sym_initializer_pair] = STATE(8553),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4496),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1281] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5300),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8553),
    [sym_initializer_pair] = STATE(8553),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4498),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1282] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5300),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8553),
    [sym_initializer_pair] = STATE(8553),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1283] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5300),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8553),
    [sym_initializer_pair] = STATE(8553),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4500),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1284] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5300),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8553),
    [sym_initializer_pair] = STATE(8553),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4502),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1285] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5300),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8553),
    [sym_initializer_pair] = STATE(8553),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4504),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1286] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5300),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8553),
    [sym_initializer_pair] = STATE(8553),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4506),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1287] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5300),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8553),
    [sym_initializer_pair] = STATE(8553),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4508),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1288] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5300),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8553),
    [sym_initializer_pair] = STATE(8553),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4510),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1289] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5300),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8553),
    [sym_initializer_pair] = STATE(8553),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4512),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1290] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5300),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8553),
    [sym_initializer_pair] = STATE(8553),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4514),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1291] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5300),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8553),
    [sym_initializer_pair] = STATE(8553),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4516),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1292] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5300),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8553),
    [sym_initializer_pair] = STATE(8553),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(4518),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1293] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5300),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8553),
    [sym_initializer_pair] = STATE(8553),
    [sym_subscript_designator] = STATE(7440),
    [sym_subscript_range_designator] = STATE(7440),
    [sym_field_designator] = STATE(7440),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [aux_sym_initializer_pair_repeat1] = STATE(7440),
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1294] = {
    [sym_string_literal] = STATE(2837),
    [sym_template_argument_list] = STATE(2018),
    [sym_raw_string_literal] = STATE(2837),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3184),
    [sym_identifier] = ACTIONS(4246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4261),
    [anon_sym_COMMA] = ACTIONS(4261),
    [anon_sym_RPAREN] = ACTIONS(4261),
    [anon_sym_LPAREN2] = ACTIONS(4261),
    [anon_sym_TILDE] = ACTIONS(4254),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4258),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4261),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4258),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(4520),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym___extension__] = ACTIONS(4246),
    [anon_sym_extern] = ACTIONS(4246),
    [anon_sym___attribute__] = ACTIONS(4246),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4254),
    [anon_sym___declspec] = ACTIONS(4246),
    [anon_sym___based] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_signed] = ACTIONS(4274),
    [anon_sym_unsigned] = ACTIONS(4274),
    [anon_sym_long] = ACTIONS(4274),
    [anon_sym_short] = ACTIONS(4274),
    [anon_sym_LBRACK] = ACTIONS(4258),
    [anon_sym_EQ] = ACTIONS(4258),
    [anon_sym_static] = ACTIONS(4246),
    [anon_sym_register] = ACTIONS(4246),
    [anon_sym_inline] = ACTIONS(4246),
    [anon_sym___inline] = ACTIONS(4246),
    [anon_sym___inline__] = ACTIONS(4246),
    [anon_sym___forceinline] = ACTIONS(4246),
    [anon_sym_thread_local] = ACTIONS(4246),
    [anon_sym___thread] = ACTIONS(4246),
    [anon_sym_const] = ACTIONS(4246),
    [anon_sym_constexpr] = ACTIONS(4246),
    [anon_sym_volatile] = ACTIONS(4246),
    [anon_sym_restrict] = ACTIONS(4246),
    [anon_sym___restrict__] = ACTIONS(4246),
    [anon_sym__Atomic] = ACTIONS(4246),
    [anon_sym__Noreturn] = ACTIONS(4246),
    [anon_sym_noreturn] = ACTIONS(4246),
    [anon_sym_mutable] = ACTIONS(4246),
    [anon_sym_constinit] = ACTIONS(4246),
    [anon_sym_consteval] = ACTIONS(4246),
    [anon_sym_PROGMEM] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4248),
    [anon_sym_SLASH_EQ] = ACTIONS(4248),
    [anon_sym_PERCENT_EQ] = ACTIONS(4248),
    [anon_sym_PLUS_EQ] = ACTIONS(4248),
    [anon_sym_DASH_EQ] = ACTIONS(4248),
    [anon_sym_LT_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT_GT_EQ] = ACTIONS(4248),
    [anon_sym_AMP_EQ] = ACTIONS(4248),
    [anon_sym_CARET_EQ] = ACTIONS(4248),
    [anon_sym_PIPE_EQ] = ACTIONS(4248),
    [anon_sym_and_eq] = ACTIONS(4523),
    [anon_sym_or_eq] = ACTIONS(4523),
    [anon_sym_xor_eq] = ACTIONS(4523),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4256),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4256),
    [anon_sym_not_eq] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4256),
    [anon_sym_L_DQUOTE] = ACTIONS(4525),
    [anon_sym_u_DQUOTE] = ACTIONS(4525),
    [anon_sym_U_DQUOTE] = ACTIONS(4525),
    [anon_sym_u8_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4525),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4246),
    [anon_sym_decltype] = ACTIONS(4246),
    [anon_sym_virtual] = ACTIONS(4246),
    [anon_sym_alignas] = ACTIONS(4246),
    [anon_sym_template] = ACTIONS(4246),
    [anon_sym_operator] = ACTIONS(4246),
    [anon_sym_R_DQUOTE] = ACTIONS(4527),
    [anon_sym_LR_DQUOTE] = ACTIONS(4527),
    [anon_sym_uR_DQUOTE] = ACTIONS(4527),
    [anon_sym_UR_DQUOTE] = ACTIONS(4527),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4527),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4248),
  },
  [1295] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(2075),
    [sym_raw_string_literal] = STATE(3057),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3184),
    [sym_identifier] = ACTIONS(4246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4261),
    [anon_sym_TILDE] = ACTIONS(4254),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4258),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4261),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4258),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(4264),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym___extension__] = ACTIONS(4246),
    [anon_sym_extern] = ACTIONS(4246),
    [anon_sym___attribute__] = ACTIONS(4246),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4254),
    [anon_sym___declspec] = ACTIONS(4246),
    [anon_sym___based] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_signed] = ACTIONS(4274),
    [anon_sym_unsigned] = ACTIONS(4274),
    [anon_sym_long] = ACTIONS(4274),
    [anon_sym_short] = ACTIONS(4274),
    [anon_sym_LBRACK] = ACTIONS(4258),
    [anon_sym_EQ] = ACTIONS(4280),
    [anon_sym_static] = ACTIONS(4246),
    [anon_sym_register] = ACTIONS(4246),
    [anon_sym_inline] = ACTIONS(4246),
    [anon_sym___inline] = ACTIONS(4246),
    [anon_sym___inline__] = ACTIONS(4246),
    [anon_sym___forceinline] = ACTIONS(4246),
    [anon_sym_thread_local] = ACTIONS(4246),
    [anon_sym___thread] = ACTIONS(4246),
    [anon_sym_const] = ACTIONS(4246),
    [anon_sym_constexpr] = ACTIONS(4246),
    [anon_sym_volatile] = ACTIONS(4246),
    [anon_sym_restrict] = ACTIONS(4246),
    [anon_sym___restrict__] = ACTIONS(4246),
    [anon_sym__Atomic] = ACTIONS(4246),
    [anon_sym__Noreturn] = ACTIONS(4246),
    [anon_sym_noreturn] = ACTIONS(4246),
    [anon_sym_mutable] = ACTIONS(4246),
    [anon_sym_constinit] = ACTIONS(4246),
    [anon_sym_consteval] = ACTIONS(4246),
    [anon_sym_PROGMEM] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4310),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_and_eq] = ACTIONS(4280),
    [anon_sym_or_eq] = ACTIONS(4280),
    [anon_sym_xor_eq] = ACTIONS(4280),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4256),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4256),
    [anon_sym_not_eq] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4246),
    [anon_sym_decltype] = ACTIONS(4246),
    [anon_sym_virtual] = ACTIONS(4246),
    [anon_sym_alignas] = ACTIONS(4246),
    [anon_sym_template] = ACTIONS(4246),
    [anon_sym_operator] = ACTIONS(4246),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [1296] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(2075),
    [sym_raw_string_literal] = STATE(3057),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3184),
    [sym_identifier] = ACTIONS(4246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4261),
    [anon_sym_TILDE] = ACTIONS(4254),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4258),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4261),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4258),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(4264),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym___extension__] = ACTIONS(4246),
    [anon_sym_extern] = ACTIONS(4246),
    [anon_sym___attribute__] = ACTIONS(4246),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4254),
    [anon_sym___declspec] = ACTIONS(4246),
    [anon_sym___based] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_signed] = ACTIONS(4274),
    [anon_sym_unsigned] = ACTIONS(4274),
    [anon_sym_long] = ACTIONS(4274),
    [anon_sym_short] = ACTIONS(4274),
    [anon_sym_LBRACK] = ACTIONS(4258),
    [anon_sym_EQ] = ACTIONS(4280),
    [anon_sym_static] = ACTIONS(4246),
    [anon_sym_register] = ACTIONS(4246),
    [anon_sym_inline] = ACTIONS(4246),
    [anon_sym___inline] = ACTIONS(4246),
    [anon_sym___inline__] = ACTIONS(4246),
    [anon_sym___forceinline] = ACTIONS(4246),
    [anon_sym_thread_local] = ACTIONS(4246),
    [anon_sym___thread] = ACTIONS(4246),
    [anon_sym_const] = ACTIONS(4246),
    [anon_sym_constexpr] = ACTIONS(4246),
    [anon_sym_volatile] = ACTIONS(4246),
    [anon_sym_restrict] = ACTIONS(4246),
    [anon_sym___restrict__] = ACTIONS(4246),
    [anon_sym__Atomic] = ACTIONS(4246),
    [anon_sym__Noreturn] = ACTIONS(4246),
    [anon_sym_noreturn] = ACTIONS(4246),
    [anon_sym_mutable] = ACTIONS(4246),
    [anon_sym_constinit] = ACTIONS(4246),
    [anon_sym_consteval] = ACTIONS(4246),
    [anon_sym_PROGMEM] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4308),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_and_eq] = ACTIONS(4280),
    [anon_sym_or_eq] = ACTIONS(4280),
    [anon_sym_xor_eq] = ACTIONS(4280),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4256),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4256),
    [anon_sym_not_eq] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4246),
    [anon_sym_decltype] = ACTIONS(4246),
    [anon_sym_virtual] = ACTIONS(4246),
    [anon_sym_alignas] = ACTIONS(4246),
    [anon_sym_template] = ACTIONS(4246),
    [anon_sym_operator] = ACTIONS(4246),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [1297] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(2075),
    [sym_raw_string_literal] = STATE(3057),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3184),
    [sym_identifier] = ACTIONS(4246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4261),
    [anon_sym_TILDE] = ACTIONS(4254),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4258),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4261),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4258),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(4264),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym___extension__] = ACTIONS(4246),
    [anon_sym_extern] = ACTIONS(4246),
    [anon_sym___attribute__] = ACTIONS(4246),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4254),
    [anon_sym___declspec] = ACTIONS(4246),
    [anon_sym___based] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_signed] = ACTIONS(4274),
    [anon_sym_unsigned] = ACTIONS(4274),
    [anon_sym_long] = ACTIONS(4274),
    [anon_sym_short] = ACTIONS(4274),
    [anon_sym_LBRACK] = ACTIONS(4258),
    [anon_sym_EQ] = ACTIONS(4280),
    [anon_sym_static] = ACTIONS(4246),
    [anon_sym_register] = ACTIONS(4246),
    [anon_sym_inline] = ACTIONS(4246),
    [anon_sym___inline] = ACTIONS(4246),
    [anon_sym___inline__] = ACTIONS(4246),
    [anon_sym___forceinline] = ACTIONS(4246),
    [anon_sym_thread_local] = ACTIONS(4246),
    [anon_sym___thread] = ACTIONS(4246),
    [anon_sym_const] = ACTIONS(4246),
    [anon_sym_constexpr] = ACTIONS(4246),
    [anon_sym_volatile] = ACTIONS(4246),
    [anon_sym_restrict] = ACTIONS(4246),
    [anon_sym___restrict__] = ACTIONS(4246),
    [anon_sym__Atomic] = ACTIONS(4246),
    [anon_sym__Noreturn] = ACTIONS(4246),
    [anon_sym_noreturn] = ACTIONS(4246),
    [anon_sym_mutable] = ACTIONS(4246),
    [anon_sym_constinit] = ACTIONS(4246),
    [anon_sym_consteval] = ACTIONS(4246),
    [anon_sym_PROGMEM] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4290),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_and_eq] = ACTIONS(4280),
    [anon_sym_or_eq] = ACTIONS(4280),
    [anon_sym_xor_eq] = ACTIONS(4280),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4256),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4256),
    [anon_sym_not_eq] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4246),
    [anon_sym_decltype] = ACTIONS(4246),
    [anon_sym_virtual] = ACTIONS(4246),
    [anon_sym_alignas] = ACTIONS(4246),
    [anon_sym_template] = ACTIONS(4246),
    [anon_sym_operator] = ACTIONS(4246),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [1298] = {
    [sym_compound_statement] = STATE(8083),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5130),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8083),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_RPAREN] = ACTIONS(4529),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4531),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(2073),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1299] = {
    [sym_compound_statement] = STATE(8090),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5129),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8090),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_RPAREN] = ACTIONS(4533),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4535),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(2073),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1300] = {
    [sym_compound_statement] = STATE(8178),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5057),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8178),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_RPAREN] = ACTIONS(4537),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4539),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(2073),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1301] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(2075),
    [sym_raw_string_literal] = STATE(3057),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3184),
    [sym_identifier] = ACTIONS(4246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_RPAREN] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4261),
    [anon_sym_TILDE] = ACTIONS(4254),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4258),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4261),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4258),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(4264),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym___extension__] = ACTIONS(4246),
    [anon_sym_extern] = ACTIONS(4246),
    [anon_sym___attribute__] = ACTIONS(4246),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4254),
    [anon_sym___declspec] = ACTIONS(4246),
    [anon_sym___based] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_signed] = ACTIONS(4274),
    [anon_sym_unsigned] = ACTIONS(4274),
    [anon_sym_long] = ACTIONS(4274),
    [anon_sym_short] = ACTIONS(4274),
    [anon_sym_LBRACK] = ACTIONS(4258),
    [anon_sym_EQ] = ACTIONS(4280),
    [anon_sym_static] = ACTIONS(4246),
    [anon_sym_register] = ACTIONS(4246),
    [anon_sym_inline] = ACTIONS(4246),
    [anon_sym___inline] = ACTIONS(4246),
    [anon_sym___inline__] = ACTIONS(4246),
    [anon_sym___forceinline] = ACTIONS(4246),
    [anon_sym_thread_local] = ACTIONS(4246),
    [anon_sym___thread] = ACTIONS(4246),
    [anon_sym_const] = ACTIONS(4246),
    [anon_sym_constexpr] = ACTIONS(4246),
    [anon_sym_volatile] = ACTIONS(4246),
    [anon_sym_restrict] = ACTIONS(4246),
    [anon_sym___restrict__] = ACTIONS(4246),
    [anon_sym__Atomic] = ACTIONS(4246),
    [anon_sym__Noreturn] = ACTIONS(4246),
    [anon_sym_noreturn] = ACTIONS(4246),
    [anon_sym_mutable] = ACTIONS(4246),
    [anon_sym_constinit] = ACTIONS(4246),
    [anon_sym_consteval] = ACTIONS(4246),
    [anon_sym_PROGMEM] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_and_eq] = ACTIONS(4280),
    [anon_sym_or_eq] = ACTIONS(4280),
    [anon_sym_xor_eq] = ACTIONS(4280),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4256),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4256),
    [anon_sym_not_eq] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4246),
    [anon_sym_decltype] = ACTIONS(4246),
    [anon_sym_virtual] = ACTIONS(4246),
    [anon_sym_alignas] = ACTIONS(4246),
    [anon_sym_template] = ACTIONS(4246),
    [anon_sym_operator] = ACTIONS(4246),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [1302] = {
    [sym_compound_statement] = STATE(8194),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5079),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8194),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_RPAREN] = ACTIONS(4541),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4543),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(2073),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1303] = {
    [sym_compound_statement] = STATE(8126),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5039),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8126),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_RPAREN] = ACTIONS(4545),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4547),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(2073),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1304] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(2075),
    [sym_raw_string_literal] = STATE(3057),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3184),
    [sym_identifier] = ACTIONS(4246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4261),
    [anon_sym_TILDE] = ACTIONS(4254),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4258),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4261),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4258),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(4264),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym___extension__] = ACTIONS(4246),
    [anon_sym_extern] = ACTIONS(4246),
    [anon_sym___attribute__] = ACTIONS(4246),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4254),
    [anon_sym___declspec] = ACTIONS(4246),
    [anon_sym___based] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_signed] = ACTIONS(4274),
    [anon_sym_unsigned] = ACTIONS(4274),
    [anon_sym_long] = ACTIONS(4274),
    [anon_sym_short] = ACTIONS(4274),
    [anon_sym_LBRACK] = ACTIONS(4258),
    [anon_sym_EQ] = ACTIONS(4280),
    [anon_sym_static] = ACTIONS(4246),
    [anon_sym_register] = ACTIONS(4246),
    [anon_sym_inline] = ACTIONS(4246),
    [anon_sym___inline] = ACTIONS(4246),
    [anon_sym___inline__] = ACTIONS(4246),
    [anon_sym___forceinline] = ACTIONS(4246),
    [anon_sym_thread_local] = ACTIONS(4246),
    [anon_sym___thread] = ACTIONS(4246),
    [anon_sym_const] = ACTIONS(4246),
    [anon_sym_constexpr] = ACTIONS(4246),
    [anon_sym_volatile] = ACTIONS(4246),
    [anon_sym_restrict] = ACTIONS(4246),
    [anon_sym___restrict__] = ACTIONS(4246),
    [anon_sym__Atomic] = ACTIONS(4246),
    [anon_sym__Noreturn] = ACTIONS(4246),
    [anon_sym_noreturn] = ACTIONS(4246),
    [anon_sym_mutable] = ACTIONS(4246),
    [anon_sym_constinit] = ACTIONS(4246),
    [anon_sym_consteval] = ACTIONS(4246),
    [anon_sym_PROGMEM] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_and_eq] = ACTIONS(4280),
    [anon_sym_or_eq] = ACTIONS(4280),
    [anon_sym_xor_eq] = ACTIONS(4280),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4256),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4256),
    [anon_sym_not_eq] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4246),
    [anon_sym_decltype] = ACTIONS(4246),
    [anon_sym_virtual] = ACTIONS(4246),
    [anon_sym_alignas] = ACTIONS(4246),
    [anon_sym_template] = ACTIONS(4246),
    [anon_sym_operator] = ACTIONS(4246),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [1305] = {
    [sym_compound_statement] = STATE(8353),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5156),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8353),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_RPAREN] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4551),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(2073),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1306] = {
    [sym_compound_statement] = STATE(8016),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5099),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8016),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_RPAREN] = ACTIONS(4553),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4555),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(2073),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1307] = {
    [sym_compound_statement] = STATE(7944),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5201),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(7944),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_RPAREN] = ACTIONS(4557),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4559),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(2073),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1308] = {
    [sym_compound_statement] = STATE(8249),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5067),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8249),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_RPAREN] = ACTIONS(4561),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4563),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(2073),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1309] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(2075),
    [sym_raw_string_literal] = STATE(3057),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3184),
    [sym_identifier] = ACTIONS(4246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4261),
    [anon_sym_TILDE] = ACTIONS(4254),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4258),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4261),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4258),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(4264),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym___extension__] = ACTIONS(4246),
    [anon_sym_extern] = ACTIONS(4246),
    [anon_sym___attribute__] = ACTIONS(4246),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4254),
    [anon_sym___declspec] = ACTIONS(4246),
    [anon_sym___based] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_signed] = ACTIONS(4274),
    [anon_sym_unsigned] = ACTIONS(4274),
    [anon_sym_long] = ACTIONS(4274),
    [anon_sym_short] = ACTIONS(4274),
    [anon_sym_LBRACK] = ACTIONS(4258),
    [anon_sym_EQ] = ACTIONS(4280),
    [anon_sym_static] = ACTIONS(4246),
    [anon_sym_register] = ACTIONS(4246),
    [anon_sym_inline] = ACTIONS(4246),
    [anon_sym___inline] = ACTIONS(4246),
    [anon_sym___inline__] = ACTIONS(4246),
    [anon_sym___forceinline] = ACTIONS(4246),
    [anon_sym_thread_local] = ACTIONS(4246),
    [anon_sym___thread] = ACTIONS(4246),
    [anon_sym_const] = ACTIONS(4246),
    [anon_sym_constexpr] = ACTIONS(4246),
    [anon_sym_volatile] = ACTIONS(4246),
    [anon_sym_restrict] = ACTIONS(4246),
    [anon_sym___restrict__] = ACTIONS(4246),
    [anon_sym__Atomic] = ACTIONS(4246),
    [anon_sym__Noreturn] = ACTIONS(4246),
    [anon_sym_noreturn] = ACTIONS(4246),
    [anon_sym_mutable] = ACTIONS(4246),
    [anon_sym_constinit] = ACTIONS(4246),
    [anon_sym_consteval] = ACTIONS(4246),
    [anon_sym_PROGMEM] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_and_eq] = ACTIONS(4280),
    [anon_sym_or_eq] = ACTIONS(4280),
    [anon_sym_xor_eq] = ACTIONS(4280),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4256),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4256),
    [anon_sym_not_eq] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4246),
    [anon_sym_decltype] = ACTIONS(4246),
    [anon_sym_virtual] = ACTIONS(4246),
    [anon_sym_alignas] = ACTIONS(4246),
    [anon_sym_template] = ACTIONS(4246),
    [anon_sym_operator] = ACTIONS(4246),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [1310] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(2075),
    [sym_raw_string_literal] = STATE(3057),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3184),
    [sym_identifier] = ACTIONS(4246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4261),
    [anon_sym_TILDE] = ACTIONS(4254),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4258),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4261),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4258),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(4264),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym___extension__] = ACTIONS(4246),
    [anon_sym_extern] = ACTIONS(4246),
    [anon_sym___attribute__] = ACTIONS(4246),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4254),
    [anon_sym___declspec] = ACTIONS(4246),
    [anon_sym___based] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_signed] = ACTIONS(4274),
    [anon_sym_unsigned] = ACTIONS(4274),
    [anon_sym_long] = ACTIONS(4274),
    [anon_sym_short] = ACTIONS(4274),
    [anon_sym_LBRACK] = ACTIONS(4258),
    [anon_sym_EQ] = ACTIONS(4280),
    [anon_sym_static] = ACTIONS(4246),
    [anon_sym_register] = ACTIONS(4246),
    [anon_sym_inline] = ACTIONS(4246),
    [anon_sym___inline] = ACTIONS(4246),
    [anon_sym___inline__] = ACTIONS(4246),
    [anon_sym___forceinline] = ACTIONS(4246),
    [anon_sym_thread_local] = ACTIONS(4246),
    [anon_sym___thread] = ACTIONS(4246),
    [anon_sym_const] = ACTIONS(4246),
    [anon_sym_constexpr] = ACTIONS(4246),
    [anon_sym_volatile] = ACTIONS(4246),
    [anon_sym_restrict] = ACTIONS(4246),
    [anon_sym___restrict__] = ACTIONS(4246),
    [anon_sym__Atomic] = ACTIONS(4246),
    [anon_sym__Noreturn] = ACTIONS(4246),
    [anon_sym_noreturn] = ACTIONS(4246),
    [anon_sym_mutable] = ACTIONS(4246),
    [anon_sym_constinit] = ACTIONS(4246),
    [anon_sym_consteval] = ACTIONS(4246),
    [anon_sym_PROGMEM] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4565),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_and_eq] = ACTIONS(4280),
    [anon_sym_or_eq] = ACTIONS(4280),
    [anon_sym_xor_eq] = ACTIONS(4280),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4256),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4256),
    [anon_sym_not_eq] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4246),
    [anon_sym_decltype] = ACTIONS(4246),
    [anon_sym_virtual] = ACTIONS(4246),
    [anon_sym_alignas] = ACTIONS(4246),
    [anon_sym_template] = ACTIONS(4246),
    [anon_sym_operator] = ACTIONS(4246),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [1311] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5341),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9586),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(9586),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4567),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1312] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(3888),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym__unary_left_fold] = STATE(9250),
    [sym__unary_right_fold] = STATE(9248),
    [sym__binary_fold] = STATE(9247),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1313] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(3959),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym__unary_left_fold] = STATE(9629),
    [sym__unary_right_fold] = STATE(9631),
    [sym__binary_fold] = STATE(9638),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1314] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(3908),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym__unary_left_fold] = STATE(9465),
    [sym__unary_right_fold] = STATE(9462),
    [sym__binary_fold] = STATE(9458),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1315] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(3949),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym__unary_left_fold] = STATE(8809),
    [sym__unary_right_fold] = STATE(8802),
    [sym__binary_fold] = STATE(8799),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1316] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5235),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9014),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(9014),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4569),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1317] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5268),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9123),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(9123),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4571),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1318] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4019),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym__unary_left_fold] = STATE(8948),
    [sym__unary_right_fold] = STATE(8950),
    [sym__binary_fold] = STATE(8952),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1319] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5373),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8960),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8960),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4573),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1320] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4005),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym__unary_left_fold] = STATE(9223),
    [sym__unary_right_fold] = STATE(9218),
    [sym__binary_fold] = STATE(9214),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1321] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5272),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9158),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(9158),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4575),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1322] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(3951),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym__unary_left_fold] = STATE(9031),
    [sym__unary_right_fold] = STATE(9037),
    [sym__binary_fold] = STATE(9039),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1323] = {
    [sym_compound_statement] = STATE(8635),
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5340),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8635),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym___extension__] = ACTIONS(4577),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(2073),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1324] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5251),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9695),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(9695),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4579),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1325] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(3943),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym__unary_left_fold] = STATE(8998),
    [sym__unary_right_fold] = STATE(8997),
    [sym__binary_fold] = STATE(8994),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1326] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(2072),
    [sym_raw_string_literal] = STATE(3057),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3184),
    [sym_identifier] = ACTIONS(4246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4261),
    [anon_sym_COMMA] = ACTIONS(4261),
    [anon_sym_RPAREN] = ACTIONS(4261),
    [anon_sym_LPAREN2] = ACTIONS(4261),
    [anon_sym_TILDE] = ACTIONS(4254),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4258),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4261),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4258),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(4264),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym___extension__] = ACTIONS(4246),
    [anon_sym_extern] = ACTIONS(4246),
    [anon_sym___attribute__] = ACTIONS(4246),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4254),
    [anon_sym___declspec] = ACTIONS(4246),
    [anon_sym___based] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_signed] = ACTIONS(4274),
    [anon_sym_unsigned] = ACTIONS(4274),
    [anon_sym_long] = ACTIONS(4274),
    [anon_sym_short] = ACTIONS(4274),
    [anon_sym_LBRACK] = ACTIONS(4258),
    [anon_sym_EQ] = ACTIONS(4246),
    [anon_sym_static] = ACTIONS(4246),
    [anon_sym_register] = ACTIONS(4246),
    [anon_sym_inline] = ACTIONS(4246),
    [anon_sym___inline] = ACTIONS(4246),
    [anon_sym___inline__] = ACTIONS(4246),
    [anon_sym___forceinline] = ACTIONS(4246),
    [anon_sym_thread_local] = ACTIONS(4246),
    [anon_sym___thread] = ACTIONS(4246),
    [anon_sym_const] = ACTIONS(4246),
    [anon_sym_constexpr] = ACTIONS(4246),
    [anon_sym_volatile] = ACTIONS(4246),
    [anon_sym_restrict] = ACTIONS(4246),
    [anon_sym___restrict__] = ACTIONS(4246),
    [anon_sym__Atomic] = ACTIONS(4246),
    [anon_sym__Noreturn] = ACTIONS(4246),
    [anon_sym_noreturn] = ACTIONS(4246),
    [anon_sym_mutable] = ACTIONS(4246),
    [anon_sym_constinit] = ACTIONS(4246),
    [anon_sym_consteval] = ACTIONS(4246),
    [anon_sym_PROGMEM] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_and_eq] = ACTIONS(4280),
    [anon_sym_or_eq] = ACTIONS(4280),
    [anon_sym_xor_eq] = ACTIONS(4280),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4256),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4256),
    [anon_sym_not_eq] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4246),
    [anon_sym_decltype] = ACTIONS(4246),
    [anon_sym_virtual] = ACTIONS(4246),
    [anon_sym_alignas] = ACTIONS(4246),
    [anon_sym_template] = ACTIONS(4246),
    [anon_sym_operator] = ACTIONS(4246),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [1327] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(3868),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym__unary_left_fold] = STATE(8951),
    [sym__unary_right_fold] = STATE(8953),
    [sym__binary_fold] = STATE(8956),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1328] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(3922),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym__unary_left_fold] = STATE(9517),
    [sym__unary_right_fold] = STATE(9519),
    [sym__binary_fold] = STATE(9521),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1329] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(3882),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym__unary_left_fold] = STATE(9288),
    [sym__unary_right_fold] = STATE(9285),
    [sym__binary_fold] = STATE(9284),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1330] = {
    [sym_primitive_type] = STATE(7711),
    [sym__expression] = STATE(3422),
    [sym__expression_not_binary] = STATE(3678),
    [sym__string] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_alignof_expression] = STATE(3678),
    [sym_offsetof_expression] = STATE(3678),
    [sym_generic_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_number_literal] = STATE(3544),
    [sym_char_literal] = STATE(3544),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(2634),
    [sym_null] = STATE(3678),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8556),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3678),
    [sym_raw_string_literal] = STATE(2647),
    [sym_co_await_expression] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_requires_clause] = STATE(3678),
    [sym_requires_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(6739),
    [sym_fold_expression] = STATE(3678),
    [sym_parameter_pack_expansion] = STATE(3678),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(8556),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2225),
    [anon_sym_compl] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(4587),
    [anon_sym_PLUS_PLUS] = ACTIONS(4587),
    [anon_sym_sizeof] = ACTIONS(2233),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2237),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2241),
    [anon_sym___asm__] = ACTIONS(2241),
    [aux_sym_number_literal_token1] = ACTIONS(2243),
    [aux_sym_number_literal_token2] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2247),
    [anon_sym_u_SQUOTE] = ACTIONS(2247),
    [anon_sym_U_SQUOTE] = ACTIONS(2247),
    [anon_sym_u8_SQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2253),
    [anon_sym_nullptr] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_requires] = ACTIONS(2263),
    [sym_this] = ACTIONS(2251),
  },
  [1331] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4998),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1332] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4591),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1333] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4595),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1334] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3668),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1335] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3399),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1336] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4597),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1337] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4599),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1338] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4601),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1339] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4957),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4605),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1340] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5335),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1341] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4607),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1342] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4609),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1343] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5020),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1344] = {
    [sym_primitive_type] = STATE(7889),
    [sym__expression] = STATE(4016),
    [sym__expression_not_binary] = STATE(4247),
    [sym__string] = STATE(4247),
    [sym_conditional_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4247),
    [sym_pointer_expression] = STATE(4247),
    [sym_unary_expression] = STATE(4247),
    [sym_binary_expression] = STATE(4247),
    [sym_update_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_alignof_expression] = STATE(4247),
    [sym_offsetof_expression] = STATE(4247),
    [sym_generic_expression] = STATE(4247),
    [sym_subscript_expression] = STATE(4247),
    [sym_call_expression] = STATE(4247),
    [sym_gnu_asm_expression] = STATE(4247),
    [sym_field_expression] = STATE(4247),
    [sym_compound_literal_expression] = STATE(4247),
    [sym_parenthesized_expression] = STATE(4247),
    [sym_number_literal] = STATE(4205),
    [sym_char_literal] = STATE(4205),
    [sym_concatenated_string] = STATE(4204),
    [sym_string_literal] = STATE(2832),
    [sym_null] = STATE(4247),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8484),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4247),
    [sym_raw_string_literal] = STATE(2831),
    [sym_co_await_expression] = STATE(4247),
    [sym_new_expression] = STATE(4247),
    [sym_delete_expression] = STATE(4247),
    [sym_requires_clause] = STATE(4247),
    [sym_requires_expression] = STATE(4247),
    [sym_lambda_expression] = STATE(4247),
    [sym_lambda_capture_specifier] = STATE(6732),
    [sym_fold_expression] = STATE(4247),
    [sym_parameter_pack_expansion] = STATE(4247),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4247),
    [sym_qualified_type_identifier] = STATE(8484),
    [sym_user_defined_literal] = STATE(4247),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2733),
    [anon_sym_compl] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(4611),
    [anon_sym_PLUS_PLUS] = ACTIONS(4611),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2745),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2749),
    [anon_sym___asm__] = ACTIONS(2749),
    [aux_sym_number_literal_token1] = ACTIONS(2751),
    [aux_sym_number_literal_token2] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2755),
    [anon_sym_u_SQUOTE] = ACTIONS(2755),
    [anon_sym_U_SQUOTE] = ACTIONS(2755),
    [anon_sym_u8_SQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2759),
  },
  [1345] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4953),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_initializer_list] = STATE(7588),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(4617),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4621),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1346] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4623),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1347] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5088),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(4625),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4627),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1348] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3903),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_sizeof] = ACTIONS(2663),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1349] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5274),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1350] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4631),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1351] = {
    [sym_primitive_type] = STATE(7889),
    [sym__expression] = STATE(3858),
    [sym__expression_not_binary] = STATE(4247),
    [sym__string] = STATE(4247),
    [sym_conditional_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4247),
    [sym_pointer_expression] = STATE(4247),
    [sym_unary_expression] = STATE(4247),
    [sym_binary_expression] = STATE(4247),
    [sym_update_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_alignof_expression] = STATE(4247),
    [sym_offsetof_expression] = STATE(4247),
    [sym_generic_expression] = STATE(4247),
    [sym_subscript_expression] = STATE(4247),
    [sym_call_expression] = STATE(4247),
    [sym_gnu_asm_expression] = STATE(4247),
    [sym_field_expression] = STATE(4247),
    [sym_compound_literal_expression] = STATE(4247),
    [sym_parenthesized_expression] = STATE(4247),
    [sym_number_literal] = STATE(4205),
    [sym_char_literal] = STATE(4205),
    [sym_concatenated_string] = STATE(4204),
    [sym_string_literal] = STATE(2832),
    [sym_null] = STATE(4247),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8484),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4247),
    [sym_raw_string_literal] = STATE(2831),
    [sym_co_await_expression] = STATE(4247),
    [sym_new_expression] = STATE(4247),
    [sym_delete_expression] = STATE(4247),
    [sym_requires_clause] = STATE(4247),
    [sym_requires_expression] = STATE(4247),
    [sym_lambda_expression] = STATE(4247),
    [sym_lambda_capture_specifier] = STATE(6732),
    [sym_fold_expression] = STATE(4247),
    [sym_parameter_pack_expansion] = STATE(4247),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4247),
    [sym_qualified_type_identifier] = STATE(8484),
    [sym_user_defined_literal] = STATE(4247),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2733),
    [anon_sym_compl] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(4611),
    [anon_sym_PLUS_PLUS] = ACTIONS(4611),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2745),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2749),
    [anon_sym___asm__] = ACTIONS(2749),
    [aux_sym_number_literal_token1] = ACTIONS(2751),
    [aux_sym_number_literal_token2] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2755),
    [anon_sym_u_SQUOTE] = ACTIONS(2755),
    [anon_sym_U_SQUOTE] = ACTIONS(2755),
    [anon_sym_u8_SQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2759),
  },
  [1352] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5175),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1353] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3900),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_sizeof] = ACTIONS(2663),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1354] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5426),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(9011),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4633),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1355] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4636),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1356] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(4625),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4627),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1357] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3423),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1358] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5426),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(9011),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4638),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1359] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5426),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(9011),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4641),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1360] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4644),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1361] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4646),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1362] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4648),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1363] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4650),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1364] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4652),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1365] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5068),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_initializer_list] = STATE(8165),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4654),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1366] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5426),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(9011),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4656),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1367] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4659),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1368] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4661),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1369] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5183),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_initializer_list] = STATE(8283),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4663),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1370] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5278),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1371] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5426),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(9011),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4667),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1372] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5309),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1373] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5088),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4627),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1374] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5051),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_initializer_list] = STATE(7978),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4670),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1375] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5426),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(9011),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4672),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1376] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4954),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_initializer_list] = STATE(7611),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(4675),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1377] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4679),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1378] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4627),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1379] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4681),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1380] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3217),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_concatenated_string] = STATE(3312),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2365),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2153),
    [anon_sym_compl] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4683),
    [anon_sym_sizeof] = ACTIONS(2161),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2171),
    [aux_sym_number_literal_token2] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2175),
    [anon_sym_u_SQUOTE] = ACTIONS(2175),
    [anon_sym_U_SQUOTE] = ACTIONS(2175),
    [anon_sym_u8_SQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1381] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4685),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1382] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4842),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(4689),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [1383] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4691),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1384] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5426),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(9011),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4693),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1385] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4849),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(4689),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [1386] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4696),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1387] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5426),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(9011),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4698),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1388] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5426),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(9011),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4701),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1389] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5426),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(9011),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4704),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1390] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4992),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_initializer_list] = STATE(7618),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(4707),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4709),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1391] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4362),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1392] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5153),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1393] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5096),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_initializer_list] = STATE(8270),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4711),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1394] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4713),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1395] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4715),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1396] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5323),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1397] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4717),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1398] = {
    [sym_primitive_type] = STATE(7711),
    [sym__expression] = STATE(3438),
    [sym__expression_not_binary] = STATE(3678),
    [sym__string] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_alignof_expression] = STATE(3678),
    [sym_offsetof_expression] = STATE(3678),
    [sym_generic_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_number_literal] = STATE(3544),
    [sym_char_literal] = STATE(3544),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(2634),
    [sym_null] = STATE(3678),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8556),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3678),
    [sym_raw_string_literal] = STATE(2647),
    [sym_co_await_expression] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_requires_clause] = STATE(3678),
    [sym_requires_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(6739),
    [sym_fold_expression] = STATE(3678),
    [sym_parameter_pack_expansion] = STATE(3678),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(8556),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2225),
    [anon_sym_compl] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(4587),
    [anon_sym_PLUS_PLUS] = ACTIONS(4587),
    [anon_sym_sizeof] = ACTIONS(2233),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2237),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2241),
    [anon_sym___asm__] = ACTIONS(2241),
    [aux_sym_number_literal_token1] = ACTIONS(2243),
    [aux_sym_number_literal_token2] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2247),
    [anon_sym_u_SQUOTE] = ACTIONS(2247),
    [anon_sym_U_SQUOTE] = ACTIONS(2247),
    [anon_sym_u8_SQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2253),
    [anon_sym_nullptr] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_requires] = ACTIONS(2263),
    [sym_this] = ACTIONS(2251),
  },
  [1399] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4719),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1400] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3213),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_concatenated_string] = STATE(3312),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2365),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2153),
    [anon_sym_compl] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4683),
    [anon_sym_sizeof] = ACTIONS(2161),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2171),
    [aux_sym_number_literal_token2] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2175),
    [anon_sym_u_SQUOTE] = ACTIONS(2175),
    [anon_sym_U_SQUOTE] = ACTIONS(2175),
    [anon_sym_u8_SQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1401] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5226),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1402] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4952),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4605),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1403] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4721),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1404] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4723),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1405] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3810),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3897),
    [sym_char_literal] = STATE(3897),
    [sym_concatenated_string] = STATE(3895),
    [sym_string_literal] = STATE(2803),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2782),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_compl] = ACTIONS(2273),
    [anon_sym_DASH_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4725),
    [anon_sym_sizeof] = ACTIONS(2279),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2281),
    [aux_sym_number_literal_token2] = ACTIONS(2283),
    [anon_sym_L_SQUOTE] = ACTIONS(2285),
    [anon_sym_u_SQUOTE] = ACTIONS(2285),
    [anon_sym_U_SQUOTE] = ACTIONS(2285),
    [anon_sym_u8_SQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_L_DQUOTE] = ACTIONS(2287),
    [anon_sym_u_DQUOTE] = ACTIONS(2287),
    [anon_sym_U_DQUOTE] = ACTIONS(2287),
    [anon_sym_u8_DQUOTE] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_R_DQUOTE] = ACTIONS(2291),
    [anon_sym_LR_DQUOTE] = ACTIONS(2291),
    [anon_sym_uR_DQUOTE] = ACTIONS(2291),
    [anon_sym_UR_DQUOTE] = ACTIONS(2291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2291),
    [anon_sym_co_await] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1406] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3652),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1407] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4727),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1408] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5426),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(9011),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4729),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1409] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5103),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_lambda_default_capture] = STATE(8647),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(4589),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4732),
    [anon_sym_EQ] = ACTIONS(4593),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1410] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4288),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1411] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3821),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3897),
    [sym_char_literal] = STATE(3897),
    [sym_concatenated_string] = STATE(3895),
    [sym_string_literal] = STATE(2803),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2782),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP_AMP] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4585),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_compl] = ACTIONS(2273),
    [anon_sym_DASH_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4725),
    [anon_sym_sizeof] = ACTIONS(2279),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2281),
    [aux_sym_number_literal_token2] = ACTIONS(2283),
    [anon_sym_L_SQUOTE] = ACTIONS(2285),
    [anon_sym_u_SQUOTE] = ACTIONS(2285),
    [anon_sym_U_SQUOTE] = ACTIONS(2285),
    [anon_sym_u8_SQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_L_DQUOTE] = ACTIONS(2287),
    [anon_sym_u_DQUOTE] = ACTIONS(2287),
    [anon_sym_U_DQUOTE] = ACTIONS(2287),
    [anon_sym_u8_DQUOTE] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_R_DQUOTE] = ACTIONS(2291),
    [anon_sym_LR_DQUOTE] = ACTIONS(2291),
    [anon_sym_uR_DQUOTE] = ACTIONS(2291),
    [anon_sym_UR_DQUOTE] = ACTIONS(2291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2291),
    [anon_sym_co_await] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1412] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4943),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_initializer_list] = STATE(7573),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(4734),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4736),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1413] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5280),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8555),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1414] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2894),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_initializer_list] = STATE(2907),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACE] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1415] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4319),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_initializer_list] = STATE(4546),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1416] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2894),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_initializer_list] = STATE(2907),
    [sym_number_literal] = STATE(3897),
    [sym_char_literal] = STATE(3897),
    [sym_concatenated_string] = STATE(3895),
    [sym_string_literal] = STATE(2803),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2782),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(4740),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_compl] = ACTIONS(2273),
    [anon_sym_DASH_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4725),
    [anon_sym_sizeof] = ACTIONS(2279),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2281),
    [aux_sym_number_literal_token2] = ACTIONS(2283),
    [anon_sym_L_SQUOTE] = ACTIONS(2285),
    [anon_sym_u_SQUOTE] = ACTIONS(2285),
    [anon_sym_U_SQUOTE] = ACTIONS(2285),
    [anon_sym_u8_SQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_L_DQUOTE] = ACTIONS(2287),
    [anon_sym_u_DQUOTE] = ACTIONS(2287),
    [anon_sym_U_DQUOTE] = ACTIONS(2287),
    [anon_sym_u8_DQUOTE] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_R_DQUOTE] = ACTIONS(2291),
    [anon_sym_LR_DQUOTE] = ACTIONS(2291),
    [anon_sym_uR_DQUOTE] = ACTIONS(2291),
    [anon_sym_UR_DQUOTE] = ACTIONS(2291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2291),
    [anon_sym_co_await] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1417] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5375),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9632),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4746),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1418] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4519),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(4671),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1419] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5288),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8889),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4748),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1420] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5073),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_initializer_list] = STATE(8330),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1421] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4519),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_initializer_list] = STATE(4671),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1422] = {
    [sym_primitive_type] = STATE(7889),
    [sym__expression] = STATE(3987),
    [sym__expression_not_binary] = STATE(4247),
    [sym__string] = STATE(4247),
    [sym_conditional_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4247),
    [sym_pointer_expression] = STATE(4247),
    [sym_unary_expression] = STATE(4247),
    [sym_binary_expression] = STATE(4247),
    [sym_update_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_alignof_expression] = STATE(4247),
    [sym_offsetof_expression] = STATE(4247),
    [sym_generic_expression] = STATE(4247),
    [sym_subscript_expression] = STATE(4247),
    [sym_call_expression] = STATE(4247),
    [sym_gnu_asm_expression] = STATE(4247),
    [sym_field_expression] = STATE(4247),
    [sym_compound_literal_expression] = STATE(4247),
    [sym_parenthesized_expression] = STATE(4247),
    [sym_initializer_list] = STATE(4332),
    [sym_number_literal] = STATE(4205),
    [sym_char_literal] = STATE(4205),
    [sym_concatenated_string] = STATE(4204),
    [sym_string_literal] = STATE(2832),
    [sym_null] = STATE(4247),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8484),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4247),
    [sym_raw_string_literal] = STATE(2831),
    [sym_co_await_expression] = STATE(4247),
    [sym_new_expression] = STATE(4247),
    [sym_delete_expression] = STATE(4247),
    [sym_requires_clause] = STATE(4247),
    [sym_requires_expression] = STATE(4247),
    [sym_lambda_expression] = STATE(4247),
    [sym_lambda_capture_specifier] = STATE(6732),
    [sym_fold_expression] = STATE(4247),
    [sym_parameter_pack_expansion] = STATE(4247),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4247),
    [sym_qualified_type_identifier] = STATE(8484),
    [sym_user_defined_literal] = STATE(4247),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACE] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2733),
    [anon_sym_compl] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(4611),
    [anon_sym_PLUS_PLUS] = ACTIONS(4611),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2745),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2749),
    [anon_sym___asm__] = ACTIONS(2749),
    [aux_sym_number_literal_token1] = ACTIONS(2751),
    [aux_sym_number_literal_token2] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2755),
    [anon_sym_u_SQUOTE] = ACTIONS(2755),
    [anon_sym_U_SQUOTE] = ACTIONS(2755),
    [anon_sym_u8_SQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2759),
  },
  [1423] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5426),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(9011),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1424] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5352),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8977),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4752),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1425] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3904),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_initializer_list] = STATE(2907),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4754),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACE] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_sizeof] = ACTIONS(2663),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1426] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3665),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_initializer_list] = STATE(4143),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACE] = ACTIONS(2297),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1427] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5316),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9643),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4756),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1428] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5390),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(9505),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1429] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5367),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9499),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_RPAREN] = ACTIONS(4758),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1430] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5343),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9614),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4760),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1431] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5232),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_initializer_list] = STATE(4626),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1432] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5301),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_initializer_list] = STATE(4671),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1433] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5363),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9308),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4762),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1434] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4519),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_initializer_list] = STATE(4671),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1435] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5307),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8552),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1436] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5498),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(9367),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1437] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5242),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9361),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_RPAREN] = ACTIONS(4764),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1438] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5364),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9255),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4766),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1439] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3980),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_comma_expression] = STATE(9369),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym__assignment_expression_lhs] = STATE(9251),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1440] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5244),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9360),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_RPAREN] = ACTIONS(4768),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1441] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5282),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9266),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4770),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1442] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5304),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_initializer_list] = STATE(4626),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1443] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_COMMA] = ACTIONS(4772),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4772),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1444] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5257),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9257),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_RPAREN] = ACTIONS(4774),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1445] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5371),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8979),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4776),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1446] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5207),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8777),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1447] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5336),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(8777),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1448] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4969),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_initializer_list] = STATE(5181),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_LPAREN2] = ACTIONS(4778),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACE] = ACTIONS(3729),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4605),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1449] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5360),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9112),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4782),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1450] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5197),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(7938),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4784),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1451] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5171),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_initializer_list] = STATE(4626),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1452] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5308),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9001),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1453] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5359),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(8787),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4789),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1454] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2894),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_initializer_list] = STATE(2907),
    [sym_number_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_concatenated_string] = STATE(3312),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2365),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4791),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACE] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2153),
    [anon_sym_compl] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4683),
    [anon_sym_sizeof] = ACTIONS(2161),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2171),
    [aux_sym_number_literal_token2] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2175),
    [anon_sym_u_SQUOTE] = ACTIONS(2175),
    [anon_sym_U_SQUOTE] = ACTIONS(2175),
    [anon_sym_u8_SQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1455] = {
    [sym_primitive_type] = STATE(7711),
    [sym__expression] = STATE(3507),
    [sym__expression_not_binary] = STATE(3678),
    [sym__string] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_alignof_expression] = STATE(3678),
    [sym_offsetof_expression] = STATE(3678),
    [sym_generic_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_initializer_list] = STATE(3754),
    [sym_number_literal] = STATE(3544),
    [sym_char_literal] = STATE(3544),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(2634),
    [sym_null] = STATE(3678),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8556),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3678),
    [sym_raw_string_literal] = STATE(2647),
    [sym_co_await_expression] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_requires_clause] = STATE(3678),
    [sym_requires_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(6739),
    [sym_fold_expression] = STATE(3678),
    [sym_parameter_pack_expansion] = STATE(3678),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(8556),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACE] = ACTIONS(2231),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2225),
    [anon_sym_compl] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(4587),
    [anon_sym_PLUS_PLUS] = ACTIONS(4587),
    [anon_sym_sizeof] = ACTIONS(2233),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2237),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2241),
    [anon_sym___asm__] = ACTIONS(2241),
    [aux_sym_number_literal_token1] = ACTIONS(2243),
    [aux_sym_number_literal_token2] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2247),
    [anon_sym_u_SQUOTE] = ACTIONS(2247),
    [anon_sym_U_SQUOTE] = ACTIONS(2247),
    [anon_sym_u8_SQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2253),
    [anon_sym_nullptr] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_requires] = ACTIONS(2263),
    [sym_this] = ACTIONS(2251),
  },
  [1456] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5356),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_initializer_list] = STATE(5583),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1457] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5361),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_initializer_list] = STATE(8529),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1458] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5267),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9472),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4797),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1459] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5036),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_initializer_list] = STATE(4626),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1460] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5264),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9258),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_RPAREN] = ACTIONS(4799),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1461] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4293),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_initializer_list] = STATE(4498),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1462] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5380),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9350),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4801),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1463] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5281),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_initializer_list] = STATE(5536),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1464] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4846),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_initializer_list] = STATE(4626),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(4689),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [1465] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4519),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_initializer_list] = STATE(4671),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(4689),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [1466] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5354),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9476),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4805),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1467] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5238),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(9370),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_RPAREN] = ACTIONS(4807),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1468] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4982),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_initializer_list] = STATE(5208),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_LPAREN2] = ACTIONS(4778),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACE] = ACTIONS(3729),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4605),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1469] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5496),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4809),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1470] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5509),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4811),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1471] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4535),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4813),
    [anon_sym_LPAREN2] = ACTIONS(4815),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(4689),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [1472] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5468),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4817),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1473] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5465),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4819),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1474] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4821),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1475] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5505),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4823),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1476] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5499),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4825),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1477] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3712),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4827),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1478] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3708),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4830),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1479] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3717),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4833),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1480] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5524),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4836),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1481] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5449),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4838),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1482] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3708),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4840),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1483] = {
    [sym_primitive_type] = STATE(7711),
    [sym__expression] = STATE(3444),
    [sym__expression_not_binary] = STATE(3678),
    [sym__string] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_alignof_expression] = STATE(3678),
    [sym_offsetof_expression] = STATE(3678),
    [sym_generic_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_number_literal] = STATE(3544),
    [sym_char_literal] = STATE(3544),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(2634),
    [sym_null] = STATE(3678),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8556),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3678),
    [sym_raw_string_literal] = STATE(2647),
    [sym_co_await_expression] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_requires_clause] = STATE(3678),
    [sym_requires_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(6739),
    [sym_fold_expression] = STATE(3678),
    [sym_parameter_pack_expansion] = STATE(3678),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(8556),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4843),
    [anon_sym_LPAREN2] = ACTIONS(4845),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2225),
    [anon_sym_compl] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(4587),
    [anon_sym_PLUS_PLUS] = ACTIONS(4587),
    [anon_sym_sizeof] = ACTIONS(2233),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2237),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2241),
    [anon_sym___asm__] = ACTIONS(2241),
    [aux_sym_number_literal_token1] = ACTIONS(2243),
    [aux_sym_number_literal_token2] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2247),
    [anon_sym_u_SQUOTE] = ACTIONS(2247),
    [anon_sym_U_SQUOTE] = ACTIONS(2247),
    [anon_sym_u8_SQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2253),
    [anon_sym_nullptr] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_requires] = ACTIONS(2263),
    [sym_this] = ACTIONS(2251),
  },
  [1484] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4847),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1485] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4849),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1486] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4851),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1487] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5429),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4853),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1488] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5368),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4813),
    [anon_sym_LPAREN2] = ACTIONS(4855),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1489] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4230),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4857),
    [anon_sym_LPAREN2] = ACTIONS(4859),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1490] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5159),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_SEMI] = ACTIONS(4861),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(4863),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1491] = {
    [sym_primitive_type] = STATE(7889),
    [sym__expression] = STATE(3860),
    [sym__expression_not_binary] = STATE(4247),
    [sym__string] = STATE(4247),
    [sym_conditional_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4247),
    [sym_pointer_expression] = STATE(4247),
    [sym_unary_expression] = STATE(4247),
    [sym_binary_expression] = STATE(4247),
    [sym_update_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_alignof_expression] = STATE(4247),
    [sym_offsetof_expression] = STATE(4247),
    [sym_generic_expression] = STATE(4247),
    [sym_subscript_expression] = STATE(4247),
    [sym_call_expression] = STATE(4247),
    [sym_gnu_asm_expression] = STATE(4247),
    [sym_field_expression] = STATE(4247),
    [sym_compound_literal_expression] = STATE(4247),
    [sym_parenthesized_expression] = STATE(4247),
    [sym_number_literal] = STATE(4205),
    [sym_char_literal] = STATE(4205),
    [sym_concatenated_string] = STATE(4204),
    [sym_string_literal] = STATE(2832),
    [sym_null] = STATE(4247),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8484),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4247),
    [sym_raw_string_literal] = STATE(2831),
    [sym_co_await_expression] = STATE(4247),
    [sym_new_expression] = STATE(4247),
    [sym_delete_expression] = STATE(4247),
    [sym_requires_clause] = STATE(4247),
    [sym_requires_expression] = STATE(4247),
    [sym_lambda_expression] = STATE(4247),
    [sym_lambda_capture_specifier] = STATE(6732),
    [sym_fold_expression] = STATE(4247),
    [sym_parameter_pack_expansion] = STATE(4247),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4247),
    [sym_qualified_type_identifier] = STATE(8484),
    [sym_user_defined_literal] = STATE(4247),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4865),
    [anon_sym_LPAREN2] = ACTIONS(4867),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2733),
    [anon_sym_compl] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(4611),
    [anon_sym_PLUS_PLUS] = ACTIONS(4611),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2745),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2749),
    [anon_sym___asm__] = ACTIONS(2749),
    [aux_sym_number_literal_token1] = ACTIONS(2751),
    [aux_sym_number_literal_token2] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2755),
    [anon_sym_u_SQUOTE] = ACTIONS(2755),
    [anon_sym_U_SQUOTE] = ACTIONS(2755),
    [anon_sym_u8_SQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2759),
  },
  [1492] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5425),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4869),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1493] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4535),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4813),
    [anon_sym_LPAREN2] = ACTIONS(4871),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1494] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4873),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1495] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4875),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1496] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4877),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1497] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4879),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1498] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5317),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4881),
    [anon_sym_LPAREN2] = ACTIONS(4883),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1499] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5424),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4885),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1500] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5159),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_SEMI] = ACTIONS(4887),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(4863),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1501] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3712),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4889),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1502] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4892),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1503] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3646),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4894),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1504] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3646),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4897),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1505] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4900),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1506] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5488),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4902),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1507] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5478),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4904),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1508] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5499),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4906),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1509] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4323),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4894),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1510] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2865),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_concatenated_string] = STATE(3312),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2365),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4908),
    [anon_sym_LPAREN2] = ACTIONS(4910),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2153),
    [anon_sym_compl] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4683),
    [anon_sym_sizeof] = ACTIONS(2161),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2171),
    [aux_sym_number_literal_token2] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2175),
    [anon_sym_u_SQUOTE] = ACTIONS(2175),
    [anon_sym_U_SQUOTE] = ACTIONS(2175),
    [anon_sym_u8_SQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1511] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3728),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4912),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1512] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4323),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4897),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1513] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4295),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4912),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1514] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4535),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4813),
    [anon_sym_LPAREN2] = ACTIONS(4915),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1515] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3945),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4908),
    [anon_sym_LPAREN2] = ACTIONS(4917),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_sizeof] = ACTIONS(2663),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1516] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3728),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4919),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1517] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4295),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4919),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1518] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3728),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4922),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1519] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4925),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1520] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3726),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4927),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1521] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4930),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1522] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3723),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4932),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1523] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4295),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4922),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1524] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4297),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4927),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1525] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4298),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4932),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1526] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3812),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4935),
    [anon_sym_LPAREN2] = ACTIONS(4937),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1527] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5159),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_SEMI] = ACTIONS(4939),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(4863),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1528] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4941),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1529] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4943),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1530] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4945),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1531] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4299),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4947),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1532] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5461),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4950),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1533] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4964),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4952),
    [anon_sym_LPAREN2] = ACTIONS(4954),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4605),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1534] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3722),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4947),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1535] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4956),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1536] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4958),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1537] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4300),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4960),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1538] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4301),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4963),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1539] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5445),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4966),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1540] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5159),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_SEMI] = ACTIONS(4968),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(4863),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1541] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3719),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4960),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1542] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4970),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1543] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5395),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4972),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1544] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5404),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4974),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1545] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5402),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4976),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1546] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4302),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4978),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1547] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4302),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4981),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1548] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4303),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4984),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1549] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2865),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4908),
    [anon_sym_LPAREN2] = ACTIONS(4987),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1550] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5493),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4989),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1551] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5485),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(4991),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1552] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4303),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4993),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1553] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5197),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(7938),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1554] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5239),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_comma_expression] = STATE(7938),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1555] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(4996),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1556] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4535),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4813),
    [anon_sym_LPAREN2] = ACTIONS(4998),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1557] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2865),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3897),
    [sym_char_literal] = STATE(3897),
    [sym_concatenated_string] = STATE(3895),
    [sym_string_literal] = STATE(2803),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2782),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2271),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4908),
    [anon_sym_LPAREN2] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_compl] = ACTIONS(2273),
    [anon_sym_DASH_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4725),
    [anon_sym_sizeof] = ACTIONS(2279),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2281),
    [aux_sym_number_literal_token2] = ACTIONS(2283),
    [anon_sym_L_SQUOTE] = ACTIONS(2285),
    [anon_sym_u_SQUOTE] = ACTIONS(2285),
    [anon_sym_U_SQUOTE] = ACTIONS(2285),
    [anon_sym_u8_SQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_L_DQUOTE] = ACTIONS(2287),
    [anon_sym_u_DQUOTE] = ACTIONS(2287),
    [anon_sym_U_DQUOTE] = ACTIONS(2287),
    [anon_sym_u8_DQUOTE] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_R_DQUOTE] = ACTIONS(2291),
    [anon_sym_LR_DQUOTE] = ACTIONS(2291),
    [anon_sym_uR_DQUOTE] = ACTIONS(2291),
    [anon_sym_UR_DQUOTE] = ACTIONS(2291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2291),
    [anon_sym_co_await] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1558] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4303),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4889),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1559] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4303),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4827),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1560] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4304),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4830),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1561] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4304),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4840),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1562] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4297),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5002),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1563] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4298),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5005),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1564] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5439),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5008),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1565] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4299),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5010),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1566] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4300),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5013),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1567] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3717),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4963),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1568] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3715),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4978),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1569] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(5016),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1570] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4301),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4833),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1571] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(5018),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1572] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3726),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5002),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1573] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3723),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5005),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1574] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3722),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5010),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1575] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5472),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_RPAREN] = ACTIONS(5020),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1576] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4302),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5022),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1577] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3715),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4981),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1578] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3712),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4984),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1579] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3712),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4993),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1580] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3719),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5013),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1581] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3715),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5022),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1582] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(5025),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1583] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5502),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(5027),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1584] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5413),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5029),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1585] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2890),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3897),
    [sym_char_literal] = STATE(3897),
    [sym_concatenated_string] = STATE(3895),
    [sym_string_literal] = STATE(2803),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2782),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(4740),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_compl] = ACTIONS(2273),
    [anon_sym_DASH_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4725),
    [anon_sym_sizeof] = ACTIONS(2279),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2281),
    [aux_sym_number_literal_token2] = ACTIONS(2283),
    [anon_sym_L_SQUOTE] = ACTIONS(2285),
    [anon_sym_u_SQUOTE] = ACTIONS(2285),
    [anon_sym_U_SQUOTE] = ACTIONS(2285),
    [anon_sym_u8_SQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_L_DQUOTE] = ACTIONS(2287),
    [anon_sym_u_DQUOTE] = ACTIONS(2287),
    [anon_sym_U_DQUOTE] = ACTIONS(2287),
    [anon_sym_u8_DQUOTE] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_R_DQUOTE] = ACTIONS(2291),
    [anon_sym_LR_DQUOTE] = ACTIONS(2291),
    [anon_sym_uR_DQUOTE] = ACTIONS(2291),
    [anon_sym_UR_DQUOTE] = ACTIONS(2291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2291),
    [anon_sym_co_await] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1586] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_concatenated_string] = STATE(3312),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2365),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4791),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2153),
    [anon_sym_compl] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4683),
    [anon_sym_sizeof] = ACTIONS(2161),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2171),
    [aux_sym_number_literal_token2] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2175),
    [anon_sym_u_SQUOTE] = ACTIONS(2175),
    [anon_sym_U_SQUOTE] = ACTIONS(2175),
    [anon_sym_u8_SQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1587] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5029),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1588] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3928),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4754),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_sizeof] = ACTIONS(2663),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1589] = {
    [sym_primitive_type] = STATE(7889),
    [sym__expression] = STATE(4024),
    [sym__expression_not_binary] = STATE(4247),
    [sym__string] = STATE(4247),
    [sym_conditional_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4247),
    [sym_pointer_expression] = STATE(4247),
    [sym_unary_expression] = STATE(4247),
    [sym_binary_expression] = STATE(4247),
    [sym_update_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_alignof_expression] = STATE(4247),
    [sym_offsetof_expression] = STATE(4247),
    [sym_generic_expression] = STATE(4247),
    [sym_subscript_expression] = STATE(4247),
    [sym_call_expression] = STATE(4247),
    [sym_gnu_asm_expression] = STATE(4247),
    [sym_field_expression] = STATE(4247),
    [sym_compound_literal_expression] = STATE(4247),
    [sym_parenthesized_expression] = STATE(4247),
    [sym_number_literal] = STATE(4205),
    [sym_char_literal] = STATE(4205),
    [sym_concatenated_string] = STATE(4204),
    [sym_string_literal] = STATE(2832),
    [sym_null] = STATE(4247),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8484),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4247),
    [sym_raw_string_literal] = STATE(2831),
    [sym_co_await_expression] = STATE(4247),
    [sym_new_expression] = STATE(4247),
    [sym_delete_expression] = STATE(4247),
    [sym_requires_clause] = STATE(4247),
    [sym_requires_expression] = STATE(4247),
    [sym_lambda_expression] = STATE(4247),
    [sym_lambda_capture_specifier] = STATE(6732),
    [sym_fold_expression] = STATE(4247),
    [sym_parameter_pack_expansion] = STATE(4247),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4247),
    [sym_qualified_type_identifier] = STATE(8484),
    [sym_user_defined_literal] = STATE(4247),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2733),
    [anon_sym_compl] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(4611),
    [anon_sym_PLUS_PLUS] = ACTIONS(4611),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2745),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2749),
    [anon_sym___asm__] = ACTIONS(2749),
    [aux_sym_number_literal_token1] = ACTIONS(2751),
    [aux_sym_number_literal_token2] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2755),
    [anon_sym_u_SQUOTE] = ACTIONS(2755),
    [anon_sym_U_SQUOTE] = ACTIONS(2755),
    [anon_sym_u8_SQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2759),
  },
  [1590] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5289),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1591] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5370),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1592] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3939),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4754),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(5031),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_sizeof] = ACTIONS(2663),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1593] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3932),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4754),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_sizeof] = ACTIONS(2663),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1594] = {
    [sym_primitive_type] = STATE(7711),
    [sym__expression] = STATE(3456),
    [sym__expression_not_binary] = STATE(3678),
    [sym__string] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_alignof_expression] = STATE(3678),
    [sym_offsetof_expression] = STATE(3678),
    [sym_generic_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_number_literal] = STATE(3544),
    [sym_char_literal] = STATE(3544),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(2634),
    [sym_null] = STATE(3678),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8556),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3678),
    [sym_raw_string_literal] = STATE(2647),
    [sym_co_await_expression] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_requires_clause] = STATE(3678),
    [sym_requires_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(6739),
    [sym_fold_expression] = STATE(3678),
    [sym_parameter_pack_expansion] = STATE(3678),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(8556),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2225),
    [anon_sym_compl] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(4587),
    [anon_sym_PLUS_PLUS] = ACTIONS(4587),
    [anon_sym_sizeof] = ACTIONS(2233),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2237),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2241),
    [anon_sym___asm__] = ACTIONS(2241),
    [aux_sym_number_literal_token1] = ACTIONS(2243),
    [aux_sym_number_literal_token2] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2247),
    [anon_sym_u_SQUOTE] = ACTIONS(2247),
    [anon_sym_U_SQUOTE] = ACTIONS(2247),
    [anon_sym_u8_SQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2253),
    [anon_sym_nullptr] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_requires] = ACTIONS(2263),
    [sym_this] = ACTIONS(2251),
  },
  [1595] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3935),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4754),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_sizeof] = ACTIONS(2663),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1596] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3874),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4754),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_sizeof] = ACTIONS(2663),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1597] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5297),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1598] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5332),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1599] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5031),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1600] = {
    [sym_primitive_type] = STATE(7711),
    [sym__expression] = STATE(3455),
    [sym__expression_not_binary] = STATE(3678),
    [sym__string] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_alignof_expression] = STATE(3678),
    [sym_offsetof_expression] = STATE(3678),
    [sym_generic_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_number_literal] = STATE(3544),
    [sym_char_literal] = STATE(3544),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(2634),
    [sym_null] = STATE(3678),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8556),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3678),
    [sym_raw_string_literal] = STATE(2647),
    [sym_co_await_expression] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_requires_clause] = STATE(3678),
    [sym_requires_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(6739),
    [sym_fold_expression] = STATE(3678),
    [sym_parameter_pack_expansion] = STATE(3678),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(8556),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2225),
    [anon_sym_compl] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(4587),
    [anon_sym_PLUS_PLUS] = ACTIONS(4587),
    [anon_sym_sizeof] = ACTIONS(2233),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2237),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2241),
    [anon_sym___asm__] = ACTIONS(2241),
    [aux_sym_number_literal_token1] = ACTIONS(2243),
    [aux_sym_number_literal_token2] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2247),
    [anon_sym_u_SQUOTE] = ACTIONS(2247),
    [anon_sym_U_SQUOTE] = ACTIONS(2247),
    [anon_sym_u8_SQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2253),
    [anon_sym_nullptr] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_requires] = ACTIONS(2263),
    [sym_this] = ACTIONS(2251),
  },
  [1601] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4304),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1602] = {
    [sym_primitive_type] = STATE(7711),
    [sym__expression] = STATE(3388),
    [sym__expression_not_binary] = STATE(3678),
    [sym__string] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_alignof_expression] = STATE(3678),
    [sym_offsetof_expression] = STATE(3678),
    [sym_generic_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_number_literal] = STATE(3544),
    [sym_char_literal] = STATE(3544),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(2634),
    [sym_null] = STATE(3678),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8556),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3678),
    [sym_raw_string_literal] = STATE(2647),
    [sym_co_await_expression] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_requires_clause] = STATE(3678),
    [sym_requires_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(6739),
    [sym_fold_expression] = STATE(3678),
    [sym_parameter_pack_expansion] = STATE(3678),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(8556),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2225),
    [anon_sym_compl] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(4587),
    [anon_sym_PLUS_PLUS] = ACTIONS(4587),
    [anon_sym_sizeof] = ACTIONS(2233),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2237),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2241),
    [anon_sym___asm__] = ACTIONS(2241),
    [aux_sym_number_literal_token1] = ACTIONS(2243),
    [aux_sym_number_literal_token2] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2247),
    [anon_sym_u_SQUOTE] = ACTIONS(2247),
    [anon_sym_U_SQUOTE] = ACTIONS(2247),
    [anon_sym_u8_SQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2253),
    [anon_sym_nullptr] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_requires] = ACTIONS(2263),
    [sym_this] = ACTIONS(2251),
  },
  [1603] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5436),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1604] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4511),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(5033),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1605] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5290),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1606] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2891),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3897),
    [sym_char_literal] = STATE(3897),
    [sym_concatenated_string] = STATE(3895),
    [sym_string_literal] = STATE(2803),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2782),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(4740),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_compl] = ACTIONS(2273),
    [anon_sym_DASH_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4725),
    [anon_sym_sizeof] = ACTIONS(2279),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2281),
    [aux_sym_number_literal_token2] = ACTIONS(2283),
    [anon_sym_L_SQUOTE] = ACTIONS(2285),
    [anon_sym_u_SQUOTE] = ACTIONS(2285),
    [anon_sym_U_SQUOTE] = ACTIONS(2285),
    [anon_sym_u8_SQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_L_DQUOTE] = ACTIONS(2287),
    [anon_sym_u_DQUOTE] = ACTIONS(2287),
    [anon_sym_U_DQUOTE] = ACTIONS(2287),
    [anon_sym_u8_DQUOTE] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_R_DQUOTE] = ACTIONS(2291),
    [anon_sym_LR_DQUOTE] = ACTIONS(2291),
    [anon_sym_uR_DQUOTE] = ACTIONS(2291),
    [anon_sym_UR_DQUOTE] = ACTIONS(2291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2291),
    [anon_sym_co_await] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1607] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5521),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1608] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2862),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1609] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5324),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1610] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3457),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1611] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3940),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4754),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_sizeof] = ACTIONS(2663),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1612] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5041),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1613] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5456),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1614] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4959),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_LPAREN2] = ACTIONS(4778),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4605),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1615] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3944),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4754),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(5035),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_sizeof] = ACTIONS(2663),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1616] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2862),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3897),
    [sym_char_literal] = STATE(3897),
    [sym_concatenated_string] = STATE(3895),
    [sym_string_literal] = STATE(2803),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2782),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(4740),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_compl] = ACTIONS(2273),
    [anon_sym_DASH_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4725),
    [anon_sym_sizeof] = ACTIONS(2279),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2281),
    [aux_sym_number_literal_token2] = ACTIONS(2283),
    [anon_sym_L_SQUOTE] = ACTIONS(2285),
    [anon_sym_u_SQUOTE] = ACTIONS(2285),
    [anon_sym_U_SQUOTE] = ACTIONS(2285),
    [anon_sym_u8_SQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_L_DQUOTE] = ACTIONS(2287),
    [anon_sym_u_DQUOTE] = ACTIONS(2287),
    [anon_sym_U_DQUOTE] = ACTIONS(2287),
    [anon_sym_u8_DQUOTE] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_R_DQUOTE] = ACTIONS(2291),
    [anon_sym_LR_DQUOTE] = ACTIONS(2291),
    [anon_sym_uR_DQUOTE] = ACTIONS(2291),
    [anon_sym_UR_DQUOTE] = ACTIONS(2291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2291),
    [anon_sym_co_await] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1617] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5431),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1618] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3909),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4754),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_sizeof] = ACTIONS(2663),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1619] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3910),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4754),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_sizeof] = ACTIONS(2663),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1620] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3921),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4754),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_sizeof] = ACTIONS(2663),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1621] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4223),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1622] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3923),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4754),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_sizeof] = ACTIONS(2663),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1623] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3920),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4754),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_sizeof] = ACTIONS(2663),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1624] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5393),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1625] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4303),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1626] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3925),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4754),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_sizeof] = ACTIONS(2663),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1627] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3926),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4754),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_sizeof] = ACTIONS(2663),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1628] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5346),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1629] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5508),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1630] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4997),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1631] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4985),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_LPAREN2] = ACTIONS(4778),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4605),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1632] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5025),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1633] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4939),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_LPAREN2] = ACTIONS(4778),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4605),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1634] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4511),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1635] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4302),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1636] = {
    [sym_primitive_type] = STATE(7889),
    [sym__expression] = STATE(4021),
    [sym__expression_not_binary] = STATE(4247),
    [sym__string] = STATE(4247),
    [sym_conditional_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4247),
    [sym_pointer_expression] = STATE(4247),
    [sym_unary_expression] = STATE(4247),
    [sym_binary_expression] = STATE(4247),
    [sym_update_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_alignof_expression] = STATE(4247),
    [sym_offsetof_expression] = STATE(4247),
    [sym_generic_expression] = STATE(4247),
    [sym_subscript_expression] = STATE(4247),
    [sym_call_expression] = STATE(4247),
    [sym_gnu_asm_expression] = STATE(4247),
    [sym_field_expression] = STATE(4247),
    [sym_compound_literal_expression] = STATE(4247),
    [sym_parenthesized_expression] = STATE(4247),
    [sym_number_literal] = STATE(4205),
    [sym_char_literal] = STATE(4205),
    [sym_concatenated_string] = STATE(4204),
    [sym_string_literal] = STATE(2832),
    [sym_null] = STATE(4247),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8484),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4247),
    [sym_raw_string_literal] = STATE(2831),
    [sym_co_await_expression] = STATE(4247),
    [sym_new_expression] = STATE(4247),
    [sym_delete_expression] = STATE(4247),
    [sym_requires_clause] = STATE(4247),
    [sym_requires_expression] = STATE(4247),
    [sym_lambda_expression] = STATE(4247),
    [sym_lambda_capture_specifier] = STATE(6732),
    [sym_fold_expression] = STATE(4247),
    [sym_parameter_pack_expansion] = STATE(4247),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4247),
    [sym_qualified_type_identifier] = STATE(8484),
    [sym_user_defined_literal] = STATE(4247),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2733),
    [anon_sym_compl] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(4611),
    [anon_sym_PLUS_PLUS] = ACTIONS(4611),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2745),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2749),
    [anon_sym___asm__] = ACTIONS(2749),
    [aux_sym_number_literal_token1] = ACTIONS(2751),
    [aux_sym_number_literal_token2] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2755),
    [anon_sym_u_SQUOTE] = ACTIONS(2755),
    [anon_sym_U_SQUOTE] = ACTIONS(2755),
    [anon_sym_u8_SQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2759),
  },
  [1637] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4539),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1638] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5396),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1639] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5128),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1640] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4301),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1641] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3906),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4754),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_sizeof] = ACTIONS(2663),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1642] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5423),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1643] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4542),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1644] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3420),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1645] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5432),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1646] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5052),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1647] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5291),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1648] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5438),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1649] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5440),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1650] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4300),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1651] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3901),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4754),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_sizeof] = ACTIONS(2663),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1652] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4841),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(4689),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [1653] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5028),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1654] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4539),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1655] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3898),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4754),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_sizeof] = ACTIONS(2663),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1656] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5362),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1657] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5012),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1658] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5170),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1659] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5378),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1660] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5376),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1661] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5008),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1662] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3897),
    [sym_char_literal] = STATE(3897),
    [sym_concatenated_string] = STATE(3895),
    [sym_string_literal] = STATE(2803),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2782),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(4740),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_compl] = ACTIONS(2273),
    [anon_sym_DASH_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4725),
    [anon_sym_sizeof] = ACTIONS(2279),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2281),
    [aux_sym_number_literal_token2] = ACTIONS(2283),
    [anon_sym_L_SQUOTE] = ACTIONS(2285),
    [anon_sym_u_SQUOTE] = ACTIONS(2285),
    [anon_sym_U_SQUOTE] = ACTIONS(2285),
    [anon_sym_u8_SQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_L_DQUOTE] = ACTIONS(2287),
    [anon_sym_u_DQUOTE] = ACTIONS(2287),
    [anon_sym_U_DQUOTE] = ACTIONS(2287),
    [anon_sym_u8_DQUOTE] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_R_DQUOTE] = ACTIONS(2291),
    [anon_sym_LR_DQUOTE] = ACTIONS(2291),
    [anon_sym_uR_DQUOTE] = ACTIONS(2291),
    [anon_sym_UR_DQUOTE] = ACTIONS(2291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2291),
    [anon_sym_co_await] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1663] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5037),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(5037),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1664] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4229),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1665] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5329),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1666] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5166),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1667] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5519),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1668] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5231),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(5039),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1669] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5311),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1670] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5296),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1671] = {
    [sym_primitive_type] = STATE(7572),
    [sym__expression] = STATE(5400),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1672] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2859),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1673] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5162),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1674] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5452),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1675] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5394),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1676] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5518),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1677] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3822),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3897),
    [sym_char_literal] = STATE(3897),
    [sym_concatenated_string] = STATE(3895),
    [sym_string_literal] = STATE(2803),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2782),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(4740),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_compl] = ACTIONS(2273),
    [anon_sym_DASH_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4725),
    [anon_sym_sizeof] = ACTIONS(2279),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2281),
    [aux_sym_number_literal_token2] = ACTIONS(2283),
    [anon_sym_L_SQUOTE] = ACTIONS(2285),
    [anon_sym_u_SQUOTE] = ACTIONS(2285),
    [anon_sym_U_SQUOTE] = ACTIONS(2285),
    [anon_sym_u8_SQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_L_DQUOTE] = ACTIONS(2287),
    [anon_sym_u_DQUOTE] = ACTIONS(2287),
    [anon_sym_U_DQUOTE] = ACTIONS(2287),
    [anon_sym_u8_DQUOTE] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_R_DQUOTE] = ACTIONS(2291),
    [anon_sym_LR_DQUOTE] = ACTIONS(2291),
    [anon_sym_uR_DQUOTE] = ACTIONS(2291),
    [anon_sym_UR_DQUOTE] = ACTIONS(2291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2291),
    [anon_sym_co_await] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1678] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5277),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1679] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5233),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1680] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5007),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1681] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5236),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1682] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5237),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1683] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4299),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1684] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5246),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1685] = {
    [sym_primitive_type] = STATE(7889),
    [sym__expression] = STATE(4009),
    [sym__expression_not_binary] = STATE(4247),
    [sym__string] = STATE(4247),
    [sym_conditional_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4247),
    [sym_pointer_expression] = STATE(4247),
    [sym_unary_expression] = STATE(4247),
    [sym_binary_expression] = STATE(4247),
    [sym_update_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_alignof_expression] = STATE(4247),
    [sym_offsetof_expression] = STATE(4247),
    [sym_generic_expression] = STATE(4247),
    [sym_subscript_expression] = STATE(4247),
    [sym_call_expression] = STATE(4247),
    [sym_gnu_asm_expression] = STATE(4247),
    [sym_field_expression] = STATE(4247),
    [sym_compound_literal_expression] = STATE(4247),
    [sym_parenthesized_expression] = STATE(4247),
    [sym_number_literal] = STATE(4205),
    [sym_char_literal] = STATE(4205),
    [sym_concatenated_string] = STATE(4204),
    [sym_string_literal] = STATE(2832),
    [sym_null] = STATE(4247),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8484),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4247),
    [sym_raw_string_literal] = STATE(2831),
    [sym_co_await_expression] = STATE(4247),
    [sym_new_expression] = STATE(4247),
    [sym_delete_expression] = STATE(4247),
    [sym_requires_clause] = STATE(4247),
    [sym_requires_expression] = STATE(4247),
    [sym_lambda_expression] = STATE(4247),
    [sym_lambda_capture_specifier] = STATE(6732),
    [sym_fold_expression] = STATE(4247),
    [sym_parameter_pack_expansion] = STATE(4247),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4247),
    [sym_qualified_type_identifier] = STATE(8484),
    [sym_user_defined_literal] = STATE(4247),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2733),
    [anon_sym_compl] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(4611),
    [anon_sym_PLUS_PLUS] = ACTIONS(4611),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2745),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2749),
    [anon_sym___asm__] = ACTIONS(2749),
    [aux_sym_number_literal_token1] = ACTIONS(2751),
    [aux_sym_number_literal_token2] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2755),
    [anon_sym_u_SQUOTE] = ACTIONS(2755),
    [anon_sym_U_SQUOTE] = ACTIONS(2755),
    [anon_sym_u8_SQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2759),
  },
  [1686] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5250),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1687] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4298),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1688] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2891),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_concatenated_string] = STATE(3312),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2365),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4791),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2153),
    [anon_sym_compl] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4683),
    [anon_sym_sizeof] = ACTIONS(2161),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2171),
    [aux_sym_number_literal_token2] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2175),
    [anon_sym_u_SQUOTE] = ACTIONS(2175),
    [anon_sym_U_SQUOTE] = ACTIONS(2175),
    [anon_sym_u8_SQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1689] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5254),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1690] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4297),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1691] = {
    [sym_primitive_type] = STATE(7711),
    [sym__expression] = STATE(3411),
    [sym__expression_not_binary] = STATE(3678),
    [sym__string] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_alignof_expression] = STATE(3678),
    [sym_offsetof_expression] = STATE(3678),
    [sym_generic_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_number_literal] = STATE(3544),
    [sym_char_literal] = STATE(3544),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(2634),
    [sym_null] = STATE(3678),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8556),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3678),
    [sym_raw_string_literal] = STATE(2647),
    [sym_co_await_expression] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_requires_clause] = STATE(3678),
    [sym_requires_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(6739),
    [sym_fold_expression] = STATE(3678),
    [sym_parameter_pack_expansion] = STATE(3678),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(8556),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2225),
    [anon_sym_compl] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(4587),
    [anon_sym_PLUS_PLUS] = ACTIONS(4587),
    [anon_sym_sizeof] = ACTIONS(2233),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2237),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2241),
    [anon_sym___asm__] = ACTIONS(2241),
    [aux_sym_number_literal_token1] = ACTIONS(2243),
    [aux_sym_number_literal_token2] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2247),
    [anon_sym_u_SQUOTE] = ACTIONS(2247),
    [anon_sym_U_SQUOTE] = ACTIONS(2247),
    [anon_sym_u8_SQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2253),
    [anon_sym_nullptr] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_requires] = ACTIONS(2263),
    [sym_this] = ACTIONS(2251),
  },
  [1692] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3946),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4754),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_sizeof] = ACTIONS(2663),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1693] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5349),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1694] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5255),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1695] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4533),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1696] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5265),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1697] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2862),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_concatenated_string] = STATE(3312),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2365),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4791),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2153),
    [anon_sym_compl] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4683),
    [anon_sym_sizeof] = ACTIONS(2161),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2171),
    [aux_sym_number_literal_token2] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2175),
    [anon_sym_u_SQUOTE] = ACTIONS(2175),
    [anon_sym_U_SQUOTE] = ACTIONS(2175),
    [anon_sym_u8_SQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1698] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5266),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1699] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5271),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1700] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5306),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1701] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5388),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1702] = {
    [sym_primitive_type] = STATE(7711),
    [sym__expression] = STATE(3460),
    [sym__expression_not_binary] = STATE(3678),
    [sym__string] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_alignof_expression] = STATE(3678),
    [sym_offsetof_expression] = STATE(3678),
    [sym_generic_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_number_literal] = STATE(3544),
    [sym_char_literal] = STATE(3544),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(2634),
    [sym_null] = STATE(3678),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8556),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3678),
    [sym_raw_string_literal] = STATE(2647),
    [sym_co_await_expression] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_requires_clause] = STATE(3678),
    [sym_requires_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(6739),
    [sym_fold_expression] = STATE(3678),
    [sym_parameter_pack_expansion] = STATE(3678),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(8556),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2225),
    [anon_sym_compl] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(4587),
    [anon_sym_PLUS_PLUS] = ACTIONS(4587),
    [anon_sym_sizeof] = ACTIONS(2233),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2237),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2241),
    [anon_sym___asm__] = ACTIONS(2241),
    [aux_sym_number_literal_token1] = ACTIONS(2243),
    [aux_sym_number_literal_token2] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2247),
    [anon_sym_u_SQUOTE] = ACTIONS(2247),
    [anon_sym_U_SQUOTE] = ACTIONS(2247),
    [anon_sym_u8_SQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2253),
    [anon_sym_nullptr] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_requires] = ACTIONS(2263),
    [sym_this] = ACTIONS(2251),
  },
  [1703] = {
    [sym_primitive_type] = STATE(7711),
    [sym__expression] = STATE(3461),
    [sym__expression_not_binary] = STATE(3678),
    [sym__string] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_alignof_expression] = STATE(3678),
    [sym_offsetof_expression] = STATE(3678),
    [sym_generic_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_number_literal] = STATE(3544),
    [sym_char_literal] = STATE(3544),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(2634),
    [sym_null] = STATE(3678),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8556),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3678),
    [sym_raw_string_literal] = STATE(2647),
    [sym_co_await_expression] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_requires_clause] = STATE(3678),
    [sym_requires_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(6739),
    [sym_fold_expression] = STATE(3678),
    [sym_parameter_pack_expansion] = STATE(3678),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(8556),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2225),
    [anon_sym_compl] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(4587),
    [anon_sym_PLUS_PLUS] = ACTIONS(4587),
    [anon_sym_sizeof] = ACTIONS(2233),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2237),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2241),
    [anon_sym___asm__] = ACTIONS(2241),
    [aux_sym_number_literal_token1] = ACTIONS(2243),
    [aux_sym_number_literal_token2] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2247),
    [anon_sym_u_SQUOTE] = ACTIONS(2247),
    [anon_sym_U_SQUOTE] = ACTIONS(2247),
    [anon_sym_u8_SQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2253),
    [anon_sym_nullptr] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_requires] = ACTIONS(2263),
    [sym_this] = ACTIONS(2251),
  },
  [1704] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4840),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(4689),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [1705] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5495),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1706] = {
    [sym_primitive_type] = STATE(7711),
    [sym__expression] = STATE(3464),
    [sym__expression_not_binary] = STATE(3678),
    [sym__string] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_alignof_expression] = STATE(3678),
    [sym_offsetof_expression] = STATE(3678),
    [sym_generic_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_number_literal] = STATE(3544),
    [sym_char_literal] = STATE(3544),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(2634),
    [sym_null] = STATE(3678),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8556),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3678),
    [sym_raw_string_literal] = STATE(2647),
    [sym_co_await_expression] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_requires_clause] = STATE(3678),
    [sym_requires_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(6739),
    [sym_fold_expression] = STATE(3678),
    [sym_parameter_pack_expansion] = STATE(3678),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(8556),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2225),
    [anon_sym_compl] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(4587),
    [anon_sym_PLUS_PLUS] = ACTIONS(4587),
    [anon_sym_sizeof] = ACTIONS(2233),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2237),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2241),
    [anon_sym___asm__] = ACTIONS(2241),
    [aux_sym_number_literal_token1] = ACTIONS(2243),
    [aux_sym_number_literal_token2] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2247),
    [anon_sym_u_SQUOTE] = ACTIONS(2247),
    [anon_sym_U_SQUOTE] = ACTIONS(2247),
    [anon_sym_u8_SQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2253),
    [anon_sym_nullptr] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_requires] = ACTIONS(2263),
    [sym_this] = ACTIONS(2251),
  },
  [1707] = {
    [sym_primitive_type] = STATE(7711),
    [sym__expression] = STATE(3465),
    [sym__expression_not_binary] = STATE(3678),
    [sym__string] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_alignof_expression] = STATE(3678),
    [sym_offsetof_expression] = STATE(3678),
    [sym_generic_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_number_literal] = STATE(3544),
    [sym_char_literal] = STATE(3544),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(2634),
    [sym_null] = STATE(3678),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8556),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3678),
    [sym_raw_string_literal] = STATE(2647),
    [sym_co_await_expression] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_requires_clause] = STATE(3678),
    [sym_requires_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(6739),
    [sym_fold_expression] = STATE(3678),
    [sym_parameter_pack_expansion] = STATE(3678),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(8556),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2225),
    [anon_sym_compl] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(4587),
    [anon_sym_PLUS_PLUS] = ACTIONS(4587),
    [anon_sym_sizeof] = ACTIONS(2233),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2237),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2241),
    [anon_sym___asm__] = ACTIONS(2241),
    [aux_sym_number_literal_token1] = ACTIONS(2243),
    [aux_sym_number_literal_token2] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2247),
    [anon_sym_u_SQUOTE] = ACTIONS(2247),
    [anon_sym_U_SQUOTE] = ACTIONS(2247),
    [anon_sym_u8_SQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2253),
    [anon_sym_nullptr] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_requires] = ACTIONS(2263),
    [sym_this] = ACTIONS(2251),
  },
  [1708] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5312),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1709] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4258),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(5041),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1710] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5421),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1711] = {
    [sym_primitive_type] = STATE(7711),
    [sym__expression] = STATE(3497),
    [sym__expression_not_binary] = STATE(3678),
    [sym__string] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_alignof_expression] = STATE(3678),
    [sym_offsetof_expression] = STATE(3678),
    [sym_generic_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_number_literal] = STATE(3544),
    [sym_char_literal] = STATE(3544),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(2634),
    [sym_null] = STATE(3678),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8556),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3678),
    [sym_raw_string_literal] = STATE(2647),
    [sym_co_await_expression] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_requires_clause] = STATE(3678),
    [sym_requires_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(6739),
    [sym_fold_expression] = STATE(3678),
    [sym_parameter_pack_expansion] = STATE(3678),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(8556),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2225),
    [anon_sym_compl] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(4587),
    [anon_sym_PLUS_PLUS] = ACTIONS(4587),
    [anon_sym_sizeof] = ACTIONS(2233),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2237),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2241),
    [anon_sym___asm__] = ACTIONS(2241),
    [aux_sym_number_literal_token1] = ACTIONS(2243),
    [aux_sym_number_literal_token2] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2247),
    [anon_sym_u_SQUOTE] = ACTIONS(2247),
    [anon_sym_U_SQUOTE] = ACTIONS(2247),
    [anon_sym_u8_SQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2253),
    [anon_sym_nullptr] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_requires] = ACTIONS(2263),
    [sym_this] = ACTIONS(2251),
  },
  [1712] = {
    [sym_primitive_type] = STATE(7711),
    [sym__expression] = STATE(3466),
    [sym__expression_not_binary] = STATE(3678),
    [sym__string] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_alignof_expression] = STATE(3678),
    [sym_offsetof_expression] = STATE(3678),
    [sym_generic_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_number_literal] = STATE(3544),
    [sym_char_literal] = STATE(3544),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(2634),
    [sym_null] = STATE(3678),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8556),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3678),
    [sym_raw_string_literal] = STATE(2647),
    [sym_co_await_expression] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_requires_clause] = STATE(3678),
    [sym_requires_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(6739),
    [sym_fold_expression] = STATE(3678),
    [sym_parameter_pack_expansion] = STATE(3678),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(8556),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2225),
    [anon_sym_compl] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(4587),
    [anon_sym_PLUS_PLUS] = ACTIONS(4587),
    [anon_sym_sizeof] = ACTIONS(2233),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2237),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2241),
    [anon_sym___asm__] = ACTIONS(2241),
    [aux_sym_number_literal_token1] = ACTIONS(2243),
    [aux_sym_number_literal_token2] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2247),
    [anon_sym_u_SQUOTE] = ACTIONS(2247),
    [anon_sym_U_SQUOTE] = ACTIONS(2247),
    [anon_sym_u8_SQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2253),
    [anon_sym_nullptr] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_requires] = ACTIONS(2263),
    [sym_this] = ACTIONS(2251),
  },
  [1713] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4965),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_LPAREN2] = ACTIONS(4778),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(5043),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4605),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1714] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5377),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1715] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5369),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1716] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5004),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1717] = {
    [sym_primitive_type] = STATE(7889),
    [sym__expression] = STATE(3899),
    [sym__expression_not_binary] = STATE(4247),
    [sym__string] = STATE(4247),
    [sym_conditional_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4247),
    [sym_pointer_expression] = STATE(4247),
    [sym_unary_expression] = STATE(4247),
    [sym_binary_expression] = STATE(4247),
    [sym_update_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_alignof_expression] = STATE(4247),
    [sym_offsetof_expression] = STATE(4247),
    [sym_generic_expression] = STATE(4247),
    [sym_subscript_expression] = STATE(4247),
    [sym_call_expression] = STATE(4247),
    [sym_gnu_asm_expression] = STATE(4247),
    [sym_field_expression] = STATE(4247),
    [sym_compound_literal_expression] = STATE(4247),
    [sym_parenthesized_expression] = STATE(4247),
    [sym_number_literal] = STATE(4205),
    [sym_char_literal] = STATE(4205),
    [sym_concatenated_string] = STATE(4204),
    [sym_string_literal] = STATE(2832),
    [sym_null] = STATE(4247),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8484),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4247),
    [sym_raw_string_literal] = STATE(2831),
    [sym_co_await_expression] = STATE(4247),
    [sym_new_expression] = STATE(4247),
    [sym_delete_expression] = STATE(4247),
    [sym_requires_clause] = STATE(4247),
    [sym_requires_expression] = STATE(4247),
    [sym_lambda_expression] = STATE(4247),
    [sym_lambda_capture_specifier] = STATE(6732),
    [sym_fold_expression] = STATE(4247),
    [sym_parameter_pack_expansion] = STATE(4247),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4247),
    [sym_qualified_type_identifier] = STATE(8484),
    [sym_user_defined_literal] = STATE(4247),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(5045),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2733),
    [anon_sym_compl] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(4611),
    [anon_sym_PLUS_PLUS] = ACTIONS(4611),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2745),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2749),
    [anon_sym___asm__] = ACTIONS(2749),
    [aux_sym_number_literal_token1] = ACTIONS(2751),
    [aux_sym_number_literal_token2] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2755),
    [anon_sym_u_SQUOTE] = ACTIONS(2755),
    [anon_sym_U_SQUOTE] = ACTIONS(2755),
    [anon_sym_u8_SQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2759),
  },
  [1718] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4848),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(4689),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [1719] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5320),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(5047),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1720] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5526),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1721] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5419),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1722] = {
    [sym_primitive_type] = STATE(7889),
    [sym__expression] = STATE(3866),
    [sym__expression_not_binary] = STATE(4247),
    [sym__string] = STATE(4247),
    [sym_conditional_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4247),
    [sym_pointer_expression] = STATE(4247),
    [sym_unary_expression] = STATE(4247),
    [sym_binary_expression] = STATE(4247),
    [sym_update_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_alignof_expression] = STATE(4247),
    [sym_offsetof_expression] = STATE(4247),
    [sym_generic_expression] = STATE(4247),
    [sym_subscript_expression] = STATE(4247),
    [sym_call_expression] = STATE(4247),
    [sym_gnu_asm_expression] = STATE(4247),
    [sym_field_expression] = STATE(4247),
    [sym_compound_literal_expression] = STATE(4247),
    [sym_parenthesized_expression] = STATE(4247),
    [sym_number_literal] = STATE(4205),
    [sym_char_literal] = STATE(4205),
    [sym_concatenated_string] = STATE(4204),
    [sym_string_literal] = STATE(2832),
    [sym_null] = STATE(4247),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8484),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4247),
    [sym_raw_string_literal] = STATE(2831),
    [sym_co_await_expression] = STATE(4247),
    [sym_new_expression] = STATE(4247),
    [sym_delete_expression] = STATE(4247),
    [sym_requires_clause] = STATE(4247),
    [sym_requires_expression] = STATE(4247),
    [sym_lambda_expression] = STATE(4247),
    [sym_lambda_capture_specifier] = STATE(6732),
    [sym_fold_expression] = STATE(4247),
    [sym_parameter_pack_expansion] = STATE(4247),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4247),
    [sym_qualified_type_identifier] = STATE(8484),
    [sym_user_defined_literal] = STATE(4247),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2733),
    [anon_sym_compl] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(4611),
    [anon_sym_PLUS_PLUS] = ACTIONS(4611),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2745),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2749),
    [anon_sym___asm__] = ACTIONS(2749),
    [aux_sym_number_literal_token1] = ACTIONS(2751),
    [aux_sym_number_literal_token2] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2755),
    [anon_sym_u_SQUOTE] = ACTIONS(2755),
    [anon_sym_U_SQUOTE] = ACTIONS(2755),
    [anon_sym_u8_SQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2759),
  },
  [1723] = {
    [sym_primitive_type] = STATE(7889),
    [sym__expression] = STATE(3865),
    [sym__expression_not_binary] = STATE(4247),
    [sym__string] = STATE(4247),
    [sym_conditional_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4247),
    [sym_pointer_expression] = STATE(4247),
    [sym_unary_expression] = STATE(4247),
    [sym_binary_expression] = STATE(4247),
    [sym_update_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_alignof_expression] = STATE(4247),
    [sym_offsetof_expression] = STATE(4247),
    [sym_generic_expression] = STATE(4247),
    [sym_subscript_expression] = STATE(4247),
    [sym_call_expression] = STATE(4247),
    [sym_gnu_asm_expression] = STATE(4247),
    [sym_field_expression] = STATE(4247),
    [sym_compound_literal_expression] = STATE(4247),
    [sym_parenthesized_expression] = STATE(4247),
    [sym_number_literal] = STATE(4205),
    [sym_char_literal] = STATE(4205),
    [sym_concatenated_string] = STATE(4204),
    [sym_string_literal] = STATE(2832),
    [sym_null] = STATE(4247),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8484),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4247),
    [sym_raw_string_literal] = STATE(2831),
    [sym_co_await_expression] = STATE(4247),
    [sym_new_expression] = STATE(4247),
    [sym_delete_expression] = STATE(4247),
    [sym_requires_clause] = STATE(4247),
    [sym_requires_expression] = STATE(4247),
    [sym_lambda_expression] = STATE(4247),
    [sym_lambda_capture_specifier] = STATE(6732),
    [sym_fold_expression] = STATE(4247),
    [sym_parameter_pack_expansion] = STATE(4247),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4247),
    [sym_qualified_type_identifier] = STATE(8484),
    [sym_user_defined_literal] = STATE(4247),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(5049),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2733),
    [anon_sym_compl] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(4611),
    [anon_sym_PLUS_PLUS] = ACTIONS(4611),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2745),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2749),
    [anon_sym___asm__] = ACTIONS(2749),
    [aux_sym_number_literal_token1] = ACTIONS(2751),
    [aux_sym_number_literal_token2] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2755),
    [anon_sym_u_SQUOTE] = ACTIONS(2755),
    [anon_sym_U_SQUOTE] = ACTIONS(2755),
    [anon_sym_u8_SQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2759),
  },
  [1724] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3948),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4754),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_sizeof] = ACTIONS(2663),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1725] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5294),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1726] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5348),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1727] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5473),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1728] = {
    [sym_primitive_type] = STATE(7711),
    [sym__expression] = STATE(3426),
    [sym__expression_not_binary] = STATE(3678),
    [sym__string] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_alignof_expression] = STATE(3678),
    [sym_offsetof_expression] = STATE(3678),
    [sym_generic_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_number_literal] = STATE(3544),
    [sym_char_literal] = STATE(3544),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(2634),
    [sym_null] = STATE(3678),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8556),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3678),
    [sym_raw_string_literal] = STATE(2647),
    [sym_co_await_expression] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_requires_clause] = STATE(3678),
    [sym_requires_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(6739),
    [sym_fold_expression] = STATE(3678),
    [sym_parameter_pack_expansion] = STATE(3678),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(8556),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2225),
    [anon_sym_compl] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(4587),
    [anon_sym_PLUS_PLUS] = ACTIONS(4587),
    [anon_sym_sizeof] = ACTIONS(2233),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2237),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2241),
    [anon_sym___asm__] = ACTIONS(2241),
    [aux_sym_number_literal_token1] = ACTIONS(2243),
    [aux_sym_number_literal_token2] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2247),
    [anon_sym_u_SQUOTE] = ACTIONS(2247),
    [anon_sym_U_SQUOTE] = ACTIONS(2247),
    [anon_sym_u8_SQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2253),
    [anon_sym_nullptr] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_requires] = ACTIONS(2263),
    [sym_this] = ACTIONS(2251),
  },
  [1729] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5241),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(5051),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1730] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5245),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(5053),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1731] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5275),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1732] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4843),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(4689),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [1733] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5065),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1734] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4847),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(5055),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(4689),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [1735] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5351),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(5057),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1736] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4542),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(4689),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [1737] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3491),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1738] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4827),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(5059),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(4689),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [1739] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3708),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1740] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3712),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1741] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3715),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1742] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3717),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1743] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3790),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(5061),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1744] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3789),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1745] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5327),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1746] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3719),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1747] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3722),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1748] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5516),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1749] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3723),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1750] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3726),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1751] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3728),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1752] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3646),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1753] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4822),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(4689),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [1754] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4825),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(4689),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [1755] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4835),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(4689),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [1756] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5019),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(5063),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1757] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4831),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(4689),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [1758] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4818),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(4689),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [1759] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5381),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1760] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4968),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_LPAREN2] = ACTIONS(4778),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4605),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1761] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4830),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(4689),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [1762] = {
    [sym_primitive_type] = STATE(7711),
    [sym__expression] = STATE(3454),
    [sym__expression_not_binary] = STATE(3678),
    [sym__string] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_alignof_expression] = STATE(3678),
    [sym_offsetof_expression] = STATE(3678),
    [sym_generic_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_number_literal] = STATE(3544),
    [sym_char_literal] = STATE(3544),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(2634),
    [sym_null] = STATE(3678),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8556),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3678),
    [sym_raw_string_literal] = STATE(2647),
    [sym_co_await_expression] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_requires_clause] = STATE(3678),
    [sym_requires_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(6739),
    [sym_fold_expression] = STATE(3678),
    [sym_parameter_pack_expansion] = STATE(3678),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(8556),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2225),
    [anon_sym_compl] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(4587),
    [anon_sym_PLUS_PLUS] = ACTIONS(4587),
    [anon_sym_sizeof] = ACTIONS(2233),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2237),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2241),
    [anon_sym___asm__] = ACTIONS(2241),
    [aux_sym_number_literal_token1] = ACTIONS(2243),
    [aux_sym_number_literal_token2] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2247),
    [anon_sym_u_SQUOTE] = ACTIONS(2247),
    [anon_sym_U_SQUOTE] = ACTIONS(2247),
    [anon_sym_u8_SQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2253),
    [anon_sym_nullptr] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_requires] = ACTIONS(2263),
    [sym_this] = ACTIONS(2251),
  },
  [1763] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4533),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(4689),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [1764] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4845),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(4689),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [1765] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4511),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(4689),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [1766] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3268),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_concatenated_string] = STATE(3312),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2365),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4791),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2153),
    [anon_sym_compl] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4683),
    [anon_sym_sizeof] = ACTIONS(2161),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2171),
    [aux_sym_number_literal_token2] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2175),
    [anon_sym_u_SQUOTE] = ACTIONS(2175),
    [anon_sym_U_SQUOTE] = ACTIONS(2175),
    [anon_sym_u8_SQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1767] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3212),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_concatenated_string] = STATE(3312),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2365),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4791),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2153),
    [anon_sym_compl] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4683),
    [anon_sym_sizeof] = ACTIONS(2161),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2171),
    [aux_sym_number_literal_token2] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2175),
    [anon_sym_u_SQUOTE] = ACTIONS(2175),
    [anon_sym_U_SQUOTE] = ACTIONS(2175),
    [anon_sym_u8_SQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1768] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3231),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_concatenated_string] = STATE(3312),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2365),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4791),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2153),
    [anon_sym_compl] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4683),
    [anon_sym_sizeof] = ACTIONS(2161),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2171),
    [aux_sym_number_literal_token2] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2175),
    [anon_sym_u_SQUOTE] = ACTIONS(2175),
    [anon_sym_U_SQUOTE] = ACTIONS(2175),
    [anon_sym_u8_SQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1769] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3232),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_concatenated_string] = STATE(3312),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2365),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4791),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2153),
    [anon_sym_compl] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4683),
    [anon_sym_sizeof] = ACTIONS(2161),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2171),
    [aux_sym_number_literal_token2] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2175),
    [anon_sym_u_SQUOTE] = ACTIONS(2175),
    [anon_sym_U_SQUOTE] = ACTIONS(2175),
    [anon_sym_u8_SQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1770] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3235),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_concatenated_string] = STATE(3312),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2365),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4791),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2153),
    [anon_sym_compl] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4683),
    [anon_sym_sizeof] = ACTIONS(2161),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2171),
    [aux_sym_number_literal_token2] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2175),
    [anon_sym_u_SQUOTE] = ACTIONS(2175),
    [anon_sym_U_SQUOTE] = ACTIONS(2175),
    [anon_sym_u8_SQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1771] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5252),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1772] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4813),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(4689),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [1773] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5303),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1774] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3756),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(5065),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1775] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5223),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1776] = {
    [sym_primitive_type] = STATE(7711),
    [sym__expression] = STATE(3424),
    [sym__expression_not_binary] = STATE(3678),
    [sym__string] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_alignof_expression] = STATE(3678),
    [sym_offsetof_expression] = STATE(3678),
    [sym_generic_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_number_literal] = STATE(3544),
    [sym_char_literal] = STATE(3544),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(2634),
    [sym_null] = STATE(3678),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8556),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3678),
    [sym_raw_string_literal] = STATE(2647),
    [sym_co_await_expression] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_requires_clause] = STATE(3678),
    [sym_requires_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(6739),
    [sym_fold_expression] = STATE(3678),
    [sym_parameter_pack_expansion] = STATE(3678),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(8556),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2225),
    [anon_sym_compl] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(4587),
    [anon_sym_PLUS_PLUS] = ACTIONS(4587),
    [anon_sym_sizeof] = ACTIONS(2233),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2237),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2241),
    [anon_sym___asm__] = ACTIONS(2241),
    [aux_sym_number_literal_token1] = ACTIONS(2243),
    [aux_sym_number_literal_token2] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2247),
    [anon_sym_u_SQUOTE] = ACTIONS(2247),
    [anon_sym_U_SQUOTE] = ACTIONS(2247),
    [anon_sym_u8_SQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2253),
    [anon_sym_nullptr] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_requires] = ACTIONS(2263),
    [sym_this] = ACTIONS(2251),
  },
  [1777] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4539),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1778] = {
    [sym_primitive_type] = STATE(7711),
    [sym__expression] = STATE(3480),
    [sym__expression_not_binary] = STATE(3678),
    [sym__string] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_alignof_expression] = STATE(3678),
    [sym_offsetof_expression] = STATE(3678),
    [sym_generic_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_number_literal] = STATE(3544),
    [sym_char_literal] = STATE(3544),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(2634),
    [sym_null] = STATE(3678),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8556),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3678),
    [sym_raw_string_literal] = STATE(2647),
    [sym_co_await_expression] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_requires_clause] = STATE(3678),
    [sym_requires_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(6739),
    [sym_fold_expression] = STATE(3678),
    [sym_parameter_pack_expansion] = STATE(3678),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(8556),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(5067),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2225),
    [anon_sym_compl] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(4587),
    [anon_sym_PLUS_PLUS] = ACTIONS(4587),
    [anon_sym_sizeof] = ACTIONS(2233),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2237),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2241),
    [anon_sym___asm__] = ACTIONS(2241),
    [aux_sym_number_literal_token1] = ACTIONS(2243),
    [aux_sym_number_literal_token2] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2247),
    [anon_sym_u_SQUOTE] = ACTIONS(2247),
    [anon_sym_U_SQUOTE] = ACTIONS(2247),
    [anon_sym_u8_SQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2253),
    [anon_sym_nullptr] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_requires] = ACTIONS(2263),
    [sym_this] = ACTIONS(2251),
  },
  [1779] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5224),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1780] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5222),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1781] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5221),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1782] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5220),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1783] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4539),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(4689),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [1784] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4839),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3404),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3404),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_number_literal] = STATE(4917),
    [sym_char_literal] = STATE(4917),
    [sym_concatenated_string] = STATE(4915),
    [sym_string_literal] = STATE(3609),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3608),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3404),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3404),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(4689),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3545),
    [aux_sym_number_literal_token2] = ACTIONS(3547),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3553),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
    [anon_sym_co_await] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3561),
    [sym_this] = ACTIONS(219),
  },
  [1785] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5217),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1786] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5215),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1787] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5214),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1788] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5213),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1789] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3453),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(5069),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1790] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5321),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1791] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3238),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_concatenated_string] = STATE(3312),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2365),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4791),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2153),
    [anon_sym_compl] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4683),
    [anon_sym_sizeof] = ACTIONS(2161),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2171),
    [aux_sym_number_literal_token2] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2175),
    [anon_sym_u_SQUOTE] = ACTIONS(2175),
    [anon_sym_U_SQUOTE] = ACTIONS(2175),
    [anon_sym_u8_SQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1792] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4511),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1793] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4533),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1794] = {
    [sym_primitive_type] = STATE(7711),
    [sym__expression] = STATE(3458),
    [sym__expression_not_binary] = STATE(3678),
    [sym__string] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_alignof_expression] = STATE(3678),
    [sym_offsetof_expression] = STATE(3678),
    [sym_generic_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_number_literal] = STATE(3544),
    [sym_char_literal] = STATE(3544),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(2634),
    [sym_null] = STATE(3678),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8556),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3678),
    [sym_raw_string_literal] = STATE(2647),
    [sym_co_await_expression] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_requires_clause] = STATE(3678),
    [sym_requires_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(6739),
    [sym_fold_expression] = STATE(3678),
    [sym_parameter_pack_expansion] = STATE(3678),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(8556),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2225),
    [anon_sym_compl] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(4587),
    [anon_sym_PLUS_PLUS] = ACTIONS(4587),
    [anon_sym_sizeof] = ACTIONS(2233),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2237),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2241),
    [anon_sym___asm__] = ACTIONS(2241),
    [aux_sym_number_literal_token1] = ACTIONS(2243),
    [aux_sym_number_literal_token2] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2247),
    [anon_sym_u_SQUOTE] = ACTIONS(2247),
    [anon_sym_U_SQUOTE] = ACTIONS(2247),
    [anon_sym_u8_SQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2253),
    [anon_sym_nullptr] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_requires] = ACTIONS(2263),
    [sym_this] = ACTIONS(2251),
  },
  [1795] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5398),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1796] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2891),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(5071),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1797] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5353),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1798] = {
    [sym_primitive_type] = STATE(7711),
    [sym__expression] = STATE(3459),
    [sym__expression_not_binary] = STATE(3678),
    [sym__string] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_alignof_expression] = STATE(3678),
    [sym_offsetof_expression] = STATE(3678),
    [sym_generic_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_number_literal] = STATE(3544),
    [sym_char_literal] = STATE(3544),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(2634),
    [sym_null] = STATE(3678),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8556),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3678),
    [sym_raw_string_literal] = STATE(2647),
    [sym_co_await_expression] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_requires_clause] = STATE(3678),
    [sym_requires_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(6739),
    [sym_fold_expression] = STATE(3678),
    [sym_parameter_pack_expansion] = STATE(3678),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(8556),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2225),
    [anon_sym_compl] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(4587),
    [anon_sym_PLUS_PLUS] = ACTIONS(4587),
    [anon_sym_sizeof] = ACTIONS(2233),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2237),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2241),
    [anon_sym___asm__] = ACTIONS(2241),
    [aux_sym_number_literal_token1] = ACTIONS(2243),
    [aux_sym_number_literal_token2] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2247),
    [anon_sym_u_SQUOTE] = ACTIONS(2247),
    [anon_sym_U_SQUOTE] = ACTIONS(2247),
    [anon_sym_u8_SQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2253),
    [anon_sym_nullptr] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_requires] = ACTIONS(2263),
    [sym_this] = ACTIONS(2251),
  },
  [1799] = {
    [sym_primitive_type] = STATE(7711),
    [sym__expression] = STATE(3451),
    [sym__expression_not_binary] = STATE(3678),
    [sym__string] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_alignof_expression] = STATE(3678),
    [sym_offsetof_expression] = STATE(3678),
    [sym_generic_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_number_literal] = STATE(3544),
    [sym_char_literal] = STATE(3544),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(2634),
    [sym_null] = STATE(3678),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8556),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3678),
    [sym_raw_string_literal] = STATE(2647),
    [sym_co_await_expression] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_requires_clause] = STATE(3678),
    [sym_requires_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(6739),
    [sym_fold_expression] = STATE(3678),
    [sym_parameter_pack_expansion] = STATE(3678),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(8556),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(5073),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2225),
    [anon_sym_compl] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(4587),
    [anon_sym_PLUS_PLUS] = ACTIONS(4587),
    [anon_sym_sizeof] = ACTIONS(2233),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2237),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2241),
    [anon_sym___asm__] = ACTIONS(2241),
    [aux_sym_number_literal_token1] = ACTIONS(2243),
    [aux_sym_number_literal_token2] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2247),
    [anon_sym_u_SQUOTE] = ACTIONS(2247),
    [anon_sym_U_SQUOTE] = ACTIONS(2247),
    [anon_sym_u8_SQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2253),
    [anon_sym_nullptr] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_requires] = ACTIONS(2263),
    [sym_this] = ACTIONS(2251),
  },
  [1800] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3209),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_concatenated_string] = STATE(3312),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2365),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4791),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2153),
    [anon_sym_compl] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4683),
    [anon_sym_sizeof] = ACTIONS(2161),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2171),
    [aux_sym_number_literal_token2] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2175),
    [anon_sym_u_SQUOTE] = ACTIONS(2175),
    [anon_sym_U_SQUOTE] = ACTIONS(2175),
    [anon_sym_u8_SQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1801] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2876),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_concatenated_string] = STATE(3312),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2365),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4791),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2153),
    [anon_sym_compl] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4683),
    [anon_sym_sizeof] = ACTIONS(2161),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2171),
    [aux_sym_number_literal_token2] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2175),
    [anon_sym_u_SQUOTE] = ACTIONS(2175),
    [anon_sym_U_SQUOTE] = ACTIONS(2175),
    [anon_sym_u8_SQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1802] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3273),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_concatenated_string] = STATE(3312),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2365),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4791),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2153),
    [anon_sym_compl] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4683),
    [anon_sym_sizeof] = ACTIONS(2161),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2171),
    [aux_sym_number_literal_token2] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2175),
    [anon_sym_u_SQUOTE] = ACTIONS(2175),
    [anon_sym_U_SQUOTE] = ACTIONS(2175),
    [anon_sym_u8_SQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1803] = {
    [sym_primitive_type] = STATE(7889),
    [sym__expression] = STATE(3967),
    [sym__expression_not_binary] = STATE(4247),
    [sym__string] = STATE(4247),
    [sym_conditional_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4247),
    [sym_pointer_expression] = STATE(4247),
    [sym_unary_expression] = STATE(4247),
    [sym_binary_expression] = STATE(4247),
    [sym_update_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_alignof_expression] = STATE(4247),
    [sym_offsetof_expression] = STATE(4247),
    [sym_generic_expression] = STATE(4247),
    [sym_subscript_expression] = STATE(4247),
    [sym_call_expression] = STATE(4247),
    [sym_gnu_asm_expression] = STATE(4247),
    [sym_field_expression] = STATE(4247),
    [sym_compound_literal_expression] = STATE(4247),
    [sym_parenthesized_expression] = STATE(4247),
    [sym_number_literal] = STATE(4205),
    [sym_char_literal] = STATE(4205),
    [sym_concatenated_string] = STATE(4204),
    [sym_string_literal] = STATE(2832),
    [sym_null] = STATE(4247),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8484),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4247),
    [sym_raw_string_literal] = STATE(2831),
    [sym_co_await_expression] = STATE(4247),
    [sym_new_expression] = STATE(4247),
    [sym_delete_expression] = STATE(4247),
    [sym_requires_clause] = STATE(4247),
    [sym_requires_expression] = STATE(4247),
    [sym_lambda_expression] = STATE(4247),
    [sym_lambda_capture_specifier] = STATE(6732),
    [sym_fold_expression] = STATE(4247),
    [sym_parameter_pack_expansion] = STATE(4247),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4247),
    [sym_qualified_type_identifier] = STATE(8484),
    [sym_user_defined_literal] = STATE(4247),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2733),
    [anon_sym_compl] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(4611),
    [anon_sym_PLUS_PLUS] = ACTIONS(4611),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2745),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2749),
    [anon_sym___asm__] = ACTIONS(2749),
    [aux_sym_number_literal_token1] = ACTIONS(2751),
    [aux_sym_number_literal_token2] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2755),
    [anon_sym_u_SQUOTE] = ACTIONS(2755),
    [anon_sym_U_SQUOTE] = ACTIONS(2755),
    [anon_sym_u8_SQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2759),
  },
  [1804] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5520),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1805] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5119),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1806] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3811),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3897),
    [sym_char_literal] = STATE(3897),
    [sym_concatenated_string] = STATE(3895),
    [sym_string_literal] = STATE(2803),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2782),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(4740),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_compl] = ACTIONS(2273),
    [anon_sym_DASH_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4725),
    [anon_sym_sizeof] = ACTIONS(2279),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2281),
    [aux_sym_number_literal_token2] = ACTIONS(2283),
    [anon_sym_L_SQUOTE] = ACTIONS(2285),
    [anon_sym_u_SQUOTE] = ACTIONS(2285),
    [anon_sym_U_SQUOTE] = ACTIONS(2285),
    [anon_sym_u8_SQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_L_DQUOTE] = ACTIONS(2287),
    [anon_sym_u_DQUOTE] = ACTIONS(2287),
    [anon_sym_U_DQUOTE] = ACTIONS(2287),
    [anon_sym_u8_DQUOTE] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_R_DQUOTE] = ACTIONS(2291),
    [anon_sym_LR_DQUOTE] = ACTIONS(2291),
    [anon_sym_uR_DQUOTE] = ACTIONS(2291),
    [anon_sym_UR_DQUOTE] = ACTIONS(2291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2291),
    [anon_sym_co_await] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1807] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5219),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1808] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3808),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3897),
    [sym_char_literal] = STATE(3897),
    [sym_concatenated_string] = STATE(3895),
    [sym_string_literal] = STATE(2803),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2782),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(4740),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_compl] = ACTIONS(2273),
    [anon_sym_DASH_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4725),
    [anon_sym_sizeof] = ACTIONS(2279),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2281),
    [aux_sym_number_literal_token2] = ACTIONS(2283),
    [anon_sym_L_SQUOTE] = ACTIONS(2285),
    [anon_sym_u_SQUOTE] = ACTIONS(2285),
    [anon_sym_U_SQUOTE] = ACTIONS(2285),
    [anon_sym_u8_SQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_L_DQUOTE] = ACTIONS(2287),
    [anon_sym_u_DQUOTE] = ACTIONS(2287),
    [anon_sym_U_DQUOTE] = ACTIONS(2287),
    [anon_sym_u8_DQUOTE] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_R_DQUOTE] = ACTIONS(2291),
    [anon_sym_LR_DQUOTE] = ACTIONS(2291),
    [anon_sym_uR_DQUOTE] = ACTIONS(2291),
    [anon_sym_UR_DQUOTE] = ACTIONS(2291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2291),
    [anon_sym_co_await] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1809] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2890),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1810] = {
    [sym_primitive_type] = STATE(7711),
    [sym__expression] = STATE(3443),
    [sym__expression_not_binary] = STATE(3678),
    [sym__string] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_alignof_expression] = STATE(3678),
    [sym_offsetof_expression] = STATE(3678),
    [sym_generic_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_number_literal] = STATE(3544),
    [sym_char_literal] = STATE(3544),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(2634),
    [sym_null] = STATE(3678),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8556),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3678),
    [sym_raw_string_literal] = STATE(2647),
    [sym_co_await_expression] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_requires_clause] = STATE(3678),
    [sym_requires_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(6739),
    [sym_fold_expression] = STATE(3678),
    [sym_parameter_pack_expansion] = STATE(3678),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(8556),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2225),
    [anon_sym_compl] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(4587),
    [anon_sym_PLUS_PLUS] = ACTIONS(4587),
    [anon_sym_sizeof] = ACTIONS(2233),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2237),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2241),
    [anon_sym___asm__] = ACTIONS(2241),
    [aux_sym_number_literal_token1] = ACTIONS(2243),
    [aux_sym_number_literal_token2] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2247),
    [anon_sym_u_SQUOTE] = ACTIONS(2247),
    [anon_sym_U_SQUOTE] = ACTIONS(2247),
    [anon_sym_u8_SQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2253),
    [anon_sym_nullptr] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_requires] = ACTIONS(2263),
    [sym_this] = ACTIONS(2251),
  },
  [1811] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4944),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_LPAREN2] = ACTIONS(4778),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(5075),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4605),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1812] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5501),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1813] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5391),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1814] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3513),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(5077),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1815] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3793),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3897),
    [sym_char_literal] = STATE(3897),
    [sym_concatenated_string] = STATE(3895),
    [sym_string_literal] = STATE(2803),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2782),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(4740),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK] = ACTIONS(5079),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_compl] = ACTIONS(2273),
    [anon_sym_DASH_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4725),
    [anon_sym_sizeof] = ACTIONS(2279),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2281),
    [aux_sym_number_literal_token2] = ACTIONS(2283),
    [anon_sym_L_SQUOTE] = ACTIONS(2285),
    [anon_sym_u_SQUOTE] = ACTIONS(2285),
    [anon_sym_U_SQUOTE] = ACTIONS(2285),
    [anon_sym_u8_SQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_L_DQUOTE] = ACTIONS(2287),
    [anon_sym_u_DQUOTE] = ACTIONS(2287),
    [anon_sym_U_DQUOTE] = ACTIONS(2287),
    [anon_sym_u8_DQUOTE] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_R_DQUOTE] = ACTIONS(2291),
    [anon_sym_LR_DQUOTE] = ACTIONS(2291),
    [anon_sym_uR_DQUOTE] = ACTIONS(2291),
    [anon_sym_UR_DQUOTE] = ACTIONS(2291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2291),
    [anon_sym_co_await] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1816] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5455),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1817] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5159),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(4863),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1818] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5409),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1819] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4295),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1820] = {
    [sym_primitive_type] = STATE(7889),
    [sym__expression] = STATE(3971),
    [sym__expression_not_binary] = STATE(4247),
    [sym__string] = STATE(4247),
    [sym_conditional_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4247),
    [sym_pointer_expression] = STATE(4247),
    [sym_unary_expression] = STATE(4247),
    [sym_binary_expression] = STATE(4247),
    [sym_update_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_alignof_expression] = STATE(4247),
    [sym_offsetof_expression] = STATE(4247),
    [sym_generic_expression] = STATE(4247),
    [sym_subscript_expression] = STATE(4247),
    [sym_call_expression] = STATE(4247),
    [sym_gnu_asm_expression] = STATE(4247),
    [sym_field_expression] = STATE(4247),
    [sym_compound_literal_expression] = STATE(4247),
    [sym_parenthesized_expression] = STATE(4247),
    [sym_number_literal] = STATE(4205),
    [sym_char_literal] = STATE(4205),
    [sym_concatenated_string] = STATE(4204),
    [sym_string_literal] = STATE(2832),
    [sym_null] = STATE(4247),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8484),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4247),
    [sym_raw_string_literal] = STATE(2831),
    [sym_co_await_expression] = STATE(4247),
    [sym_new_expression] = STATE(4247),
    [sym_delete_expression] = STATE(4247),
    [sym_requires_clause] = STATE(4247),
    [sym_requires_expression] = STATE(4247),
    [sym_lambda_expression] = STATE(4247),
    [sym_lambda_capture_specifier] = STATE(6732),
    [sym_fold_expression] = STATE(4247),
    [sym_parameter_pack_expansion] = STATE(4247),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4247),
    [sym_qualified_type_identifier] = STATE(8484),
    [sym_user_defined_literal] = STATE(4247),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2733),
    [anon_sym_compl] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(4611),
    [anon_sym_PLUS_PLUS] = ACTIONS(4611),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2745),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2749),
    [anon_sym___asm__] = ACTIONS(2749),
    [aux_sym_number_literal_token1] = ACTIONS(2751),
    [aux_sym_number_literal_token2] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2755),
    [anon_sym_u_SQUOTE] = ACTIONS(2755),
    [anon_sym_U_SQUOTE] = ACTIONS(2755),
    [anon_sym_u8_SQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2759),
  },
  [1821] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4542),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1822] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5141),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(5081),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1823] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4323),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1824] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5299),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1825] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4237),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1826] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5446),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1827] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3505),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1828] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2876),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1829] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3503),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1830] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3506),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1831] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3502),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1832] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3501),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1833] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3500),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1834] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3499),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1835] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3498),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1836] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3496),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1837] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3701),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1838] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5506),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1839] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5074),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1840] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5333),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1841] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5212),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1842] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3791),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3897),
    [sym_char_literal] = STATE(3897),
    [sym_concatenated_string] = STATE(3895),
    [sym_string_literal] = STATE(2803),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2782),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(4740),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK] = ACTIONS(5083),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_compl] = ACTIONS(2273),
    [anon_sym_DASH_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4725),
    [anon_sym_sizeof] = ACTIONS(2279),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2281),
    [aux_sym_number_literal_token2] = ACTIONS(2283),
    [anon_sym_L_SQUOTE] = ACTIONS(2285),
    [anon_sym_u_SQUOTE] = ACTIONS(2285),
    [anon_sym_U_SQUOTE] = ACTIONS(2285),
    [anon_sym_u8_SQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_L_DQUOTE] = ACTIONS(2287),
    [anon_sym_u_DQUOTE] = ACTIONS(2287),
    [anon_sym_U_DQUOTE] = ACTIONS(2287),
    [anon_sym_u8_DQUOTE] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_R_DQUOTE] = ACTIONS(2291),
    [anon_sym_LR_DQUOTE] = ACTIONS(2291),
    [anon_sym_uR_DQUOTE] = ACTIONS(2291),
    [anon_sym_UR_DQUOTE] = ACTIONS(2291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2291),
    [anon_sym_co_await] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1843] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5442),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1844] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4533),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1845] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5295),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(5085),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1846] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5331),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1847] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5127),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1848] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5512),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1849] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4511),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1850] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5466),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1851] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4990),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_LPAREN2] = ACTIONS(4778),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4605),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1852] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3218),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_concatenated_string] = STATE(3312),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2365),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4791),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2153),
    [anon_sym_compl] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4683),
    [anon_sym_sizeof] = ACTIONS(2161),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2171),
    [aux_sym_number_literal_token2] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2175),
    [anon_sym_u_SQUOTE] = ACTIONS(2175),
    [anon_sym_U_SQUOTE] = ACTIONS(2175),
    [anon_sym_u8_SQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1853] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5112),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1854] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5417),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1855] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5261),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1856] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5384),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1857] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5259),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1858] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4357),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1859] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4988),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_LPAREN2] = ACTIONS(4778),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4605),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1860] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4987),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_LPAREN2] = ACTIONS(4778),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4605),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1861] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5437),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1862] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5387),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1863] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4980),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_LPAREN2] = ACTIONS(4778),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4605),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1864] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4979),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_LPAREN2] = ACTIONS(4778),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4605),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1865] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5078),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1866] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3643),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1867] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4978),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_LPAREN2] = ACTIONS(4778),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4605),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1868] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4991),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_LPAREN2] = ACTIONS(4778),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4605),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1869] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4977),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_LPAREN2] = ACTIONS(4778),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4605),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1870] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4946),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_LPAREN2] = ACTIONS(4778),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4605),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1871] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4236),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(5087),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1872] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5474),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1873] = {
    [sym_primitive_type] = STATE(7889),
    [sym__expression] = STATE(3960),
    [sym__expression_not_binary] = STATE(4247),
    [sym__string] = STATE(4247),
    [sym_conditional_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4247),
    [sym_pointer_expression] = STATE(4247),
    [sym_unary_expression] = STATE(4247),
    [sym_binary_expression] = STATE(4247),
    [sym_update_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_alignof_expression] = STATE(4247),
    [sym_offsetof_expression] = STATE(4247),
    [sym_generic_expression] = STATE(4247),
    [sym_subscript_expression] = STATE(4247),
    [sym_call_expression] = STATE(4247),
    [sym_gnu_asm_expression] = STATE(4247),
    [sym_field_expression] = STATE(4247),
    [sym_compound_literal_expression] = STATE(4247),
    [sym_parenthesized_expression] = STATE(4247),
    [sym_number_literal] = STATE(4205),
    [sym_char_literal] = STATE(4205),
    [sym_concatenated_string] = STATE(4204),
    [sym_string_literal] = STATE(2832),
    [sym_null] = STATE(4247),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8484),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4247),
    [sym_raw_string_literal] = STATE(2831),
    [sym_co_await_expression] = STATE(4247),
    [sym_new_expression] = STATE(4247),
    [sym_delete_expression] = STATE(4247),
    [sym_requires_clause] = STATE(4247),
    [sym_requires_expression] = STATE(4247),
    [sym_lambda_expression] = STATE(4247),
    [sym_lambda_capture_specifier] = STATE(6732),
    [sym_fold_expression] = STATE(4247),
    [sym_parameter_pack_expansion] = STATE(4247),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4247),
    [sym_qualified_type_identifier] = STATE(8484),
    [sym_user_defined_literal] = STATE(4247),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2733),
    [anon_sym_compl] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(4611),
    [anon_sym_PLUS_PLUS] = ACTIONS(4611),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2745),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2749),
    [anon_sym___asm__] = ACTIONS(2749),
    [aux_sym_number_literal_token1] = ACTIONS(2751),
    [aux_sym_number_literal_token2] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2755),
    [anon_sym_u_SQUOTE] = ACTIONS(2755),
    [anon_sym_U_SQUOTE] = ACTIONS(2755),
    [anon_sym_u8_SQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2759),
  },
  [1874] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5350),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1875] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5347),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1876] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5406),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1877] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5463),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1878] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5401),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1879] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5515),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1880] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2891),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_concatenated_string] = STATE(3508),
    [sym_string_literal] = STATE(2442),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2441),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4738),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2205),
    [aux_sym_number_literal_token2] = ACTIONS(2207),
    [anon_sym_L_SQUOTE] = ACTIONS(2209),
    [anon_sym_u_SQUOTE] = ACTIONS(2209),
    [anon_sym_U_SQUOTE] = ACTIONS(2209),
    [anon_sym_u8_SQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_L_DQUOTE] = ACTIONS(2211),
    [anon_sym_u_DQUOTE] = ACTIONS(2211),
    [anon_sym_U_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8_DQUOTE] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_R_DQUOTE] = ACTIONS(2215),
    [anon_sym_LR_DQUOTE] = ACTIONS(2215),
    [anon_sym_uR_DQUOTE] = ACTIONS(2215),
    [anon_sym_UR_DQUOTE] = ACTIONS(2215),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2215),
    [anon_sym_co_await] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1881] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5286),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1882] = {
    [sym_primitive_type] = STATE(7889),
    [sym__expression] = STATE(3961),
    [sym__expression_not_binary] = STATE(4247),
    [sym__string] = STATE(4247),
    [sym_conditional_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4247),
    [sym_pointer_expression] = STATE(4247),
    [sym_unary_expression] = STATE(4247),
    [sym_binary_expression] = STATE(4247),
    [sym_update_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_alignof_expression] = STATE(4247),
    [sym_offsetof_expression] = STATE(4247),
    [sym_generic_expression] = STATE(4247),
    [sym_subscript_expression] = STATE(4247),
    [sym_call_expression] = STATE(4247),
    [sym_gnu_asm_expression] = STATE(4247),
    [sym_field_expression] = STATE(4247),
    [sym_compound_literal_expression] = STATE(4247),
    [sym_parenthesized_expression] = STATE(4247),
    [sym_number_literal] = STATE(4205),
    [sym_char_literal] = STATE(4205),
    [sym_concatenated_string] = STATE(4204),
    [sym_string_literal] = STATE(2832),
    [sym_null] = STATE(4247),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8484),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4247),
    [sym_raw_string_literal] = STATE(2831),
    [sym_co_await_expression] = STATE(4247),
    [sym_new_expression] = STATE(4247),
    [sym_delete_expression] = STATE(4247),
    [sym_requires_clause] = STATE(4247),
    [sym_requires_expression] = STATE(4247),
    [sym_lambda_expression] = STATE(4247),
    [sym_lambda_capture_specifier] = STATE(6732),
    [sym_fold_expression] = STATE(4247),
    [sym_parameter_pack_expansion] = STATE(4247),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4247),
    [sym_qualified_type_identifier] = STATE(8484),
    [sym_user_defined_literal] = STATE(4247),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2733),
    [anon_sym_compl] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(4611),
    [anon_sym_PLUS_PLUS] = ACTIONS(4611),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2745),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2749),
    [anon_sym___asm__] = ACTIONS(2749),
    [aux_sym_number_literal_token1] = ACTIONS(2751),
    [aux_sym_number_literal_token2] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2755),
    [anon_sym_u_SQUOTE] = ACTIONS(2755),
    [anon_sym_U_SQUOTE] = ACTIONS(2755),
    [anon_sym_u8_SQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2759),
  },
  [1883] = {
    [sym_primitive_type] = STATE(7889),
    [sym__expression] = STATE(3962),
    [sym__expression_not_binary] = STATE(4247),
    [sym__string] = STATE(4247),
    [sym_conditional_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4247),
    [sym_pointer_expression] = STATE(4247),
    [sym_unary_expression] = STATE(4247),
    [sym_binary_expression] = STATE(4247),
    [sym_update_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_alignof_expression] = STATE(4247),
    [sym_offsetof_expression] = STATE(4247),
    [sym_generic_expression] = STATE(4247),
    [sym_subscript_expression] = STATE(4247),
    [sym_call_expression] = STATE(4247),
    [sym_gnu_asm_expression] = STATE(4247),
    [sym_field_expression] = STATE(4247),
    [sym_compound_literal_expression] = STATE(4247),
    [sym_parenthesized_expression] = STATE(4247),
    [sym_number_literal] = STATE(4205),
    [sym_char_literal] = STATE(4205),
    [sym_concatenated_string] = STATE(4204),
    [sym_string_literal] = STATE(2832),
    [sym_null] = STATE(4247),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8484),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4247),
    [sym_raw_string_literal] = STATE(2831),
    [sym_co_await_expression] = STATE(4247),
    [sym_new_expression] = STATE(4247),
    [sym_delete_expression] = STATE(4247),
    [sym_requires_clause] = STATE(4247),
    [sym_requires_expression] = STATE(4247),
    [sym_lambda_expression] = STATE(4247),
    [sym_lambda_capture_specifier] = STATE(6732),
    [sym_fold_expression] = STATE(4247),
    [sym_parameter_pack_expansion] = STATE(4247),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4247),
    [sym_qualified_type_identifier] = STATE(8484),
    [sym_user_defined_literal] = STATE(4247),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2733),
    [anon_sym_compl] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(4611),
    [anon_sym_PLUS_PLUS] = ACTIONS(4611),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2745),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2749),
    [anon_sym___asm__] = ACTIONS(2749),
    [aux_sym_number_literal_token1] = ACTIONS(2751),
    [aux_sym_number_literal_token2] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2755),
    [anon_sym_u_SQUOTE] = ACTIONS(2755),
    [anon_sym_U_SQUOTE] = ACTIONS(2755),
    [anon_sym_u8_SQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2759),
  },
  [1884] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5418),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1885] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3214),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_concatenated_string] = STATE(3312),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2365),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4791),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2153),
    [anon_sym_compl] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4683),
    [anon_sym_sizeof] = ACTIONS(2161),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2171),
    [aux_sym_number_literal_token2] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2175),
    [anon_sym_u_SQUOTE] = ACTIONS(2175),
    [anon_sym_U_SQUOTE] = ACTIONS(2175),
    [anon_sym_u8_SQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1886] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5397),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1887] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5435),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1888] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4976),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_LPAREN2] = ACTIONS(4778),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4605),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1889] = {
    [sym_primitive_type] = STATE(7889),
    [sym__expression] = STATE(3963),
    [sym__expression_not_binary] = STATE(4247),
    [sym__string] = STATE(4247),
    [sym_conditional_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4247),
    [sym_pointer_expression] = STATE(4247),
    [sym_unary_expression] = STATE(4247),
    [sym_binary_expression] = STATE(4247),
    [sym_update_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_alignof_expression] = STATE(4247),
    [sym_offsetof_expression] = STATE(4247),
    [sym_generic_expression] = STATE(4247),
    [sym_subscript_expression] = STATE(4247),
    [sym_call_expression] = STATE(4247),
    [sym_gnu_asm_expression] = STATE(4247),
    [sym_field_expression] = STATE(4247),
    [sym_compound_literal_expression] = STATE(4247),
    [sym_parenthesized_expression] = STATE(4247),
    [sym_number_literal] = STATE(4205),
    [sym_char_literal] = STATE(4205),
    [sym_concatenated_string] = STATE(4204),
    [sym_string_literal] = STATE(2832),
    [sym_null] = STATE(4247),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8484),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4247),
    [sym_raw_string_literal] = STATE(2831),
    [sym_co_await_expression] = STATE(4247),
    [sym_new_expression] = STATE(4247),
    [sym_delete_expression] = STATE(4247),
    [sym_requires_clause] = STATE(4247),
    [sym_requires_expression] = STATE(4247),
    [sym_lambda_expression] = STATE(4247),
    [sym_lambda_capture_specifier] = STATE(6732),
    [sym_fold_expression] = STATE(4247),
    [sym_parameter_pack_expansion] = STATE(4247),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4247),
    [sym_qualified_type_identifier] = STATE(8484),
    [sym_user_defined_literal] = STATE(4247),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2733),
    [anon_sym_compl] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(4611),
    [anon_sym_PLUS_PLUS] = ACTIONS(4611),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2745),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2749),
    [anon_sym___asm__] = ACTIONS(2749),
    [aux_sym_number_literal_token1] = ACTIONS(2751),
    [aux_sym_number_literal_token2] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2755),
    [anon_sym_u_SQUOTE] = ACTIONS(2755),
    [anon_sym_U_SQUOTE] = ACTIONS(2755),
    [anon_sym_u8_SQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2759),
  },
  [1890] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5430),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1891] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5263),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1892] = {
    [sym_primitive_type] = STATE(7889),
    [sym__expression] = STATE(3964),
    [sym__expression_not_binary] = STATE(4247),
    [sym__string] = STATE(4247),
    [sym_conditional_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4247),
    [sym_pointer_expression] = STATE(4247),
    [sym_unary_expression] = STATE(4247),
    [sym_binary_expression] = STATE(4247),
    [sym_update_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_alignof_expression] = STATE(4247),
    [sym_offsetof_expression] = STATE(4247),
    [sym_generic_expression] = STATE(4247),
    [sym_subscript_expression] = STATE(4247),
    [sym_call_expression] = STATE(4247),
    [sym_gnu_asm_expression] = STATE(4247),
    [sym_field_expression] = STATE(4247),
    [sym_compound_literal_expression] = STATE(4247),
    [sym_parenthesized_expression] = STATE(4247),
    [sym_number_literal] = STATE(4205),
    [sym_char_literal] = STATE(4205),
    [sym_concatenated_string] = STATE(4204),
    [sym_string_literal] = STATE(2832),
    [sym_null] = STATE(4247),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8484),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4247),
    [sym_raw_string_literal] = STATE(2831),
    [sym_co_await_expression] = STATE(4247),
    [sym_new_expression] = STATE(4247),
    [sym_delete_expression] = STATE(4247),
    [sym_requires_clause] = STATE(4247),
    [sym_requires_expression] = STATE(4247),
    [sym_lambda_expression] = STATE(4247),
    [sym_lambda_capture_specifier] = STATE(6732),
    [sym_fold_expression] = STATE(4247),
    [sym_parameter_pack_expansion] = STATE(4247),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4247),
    [sym_qualified_type_identifier] = STATE(8484),
    [sym_user_defined_literal] = STATE(4247),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2733),
    [anon_sym_compl] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(4611),
    [anon_sym_PLUS_PLUS] = ACTIONS(4611),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2745),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2749),
    [anon_sym___asm__] = ACTIONS(2749),
    [aux_sym_number_literal_token1] = ACTIONS(2751),
    [aux_sym_number_literal_token2] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2755),
    [anon_sym_u_SQUOTE] = ACTIONS(2755),
    [anon_sym_U_SQUOTE] = ACTIONS(2755),
    [anon_sym_u8_SQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2759),
  },
  [1893] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5184),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1894] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4945),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_LPAREN2] = ACTIONS(4778),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4605),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1895] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4975),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_LPAREN2] = ACTIONS(4778),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4605),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1896] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5082),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1897] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5302),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1898] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5499),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1899] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3696),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1900] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5177),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1901] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4995),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1902] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5389),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1903] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5479),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1904] = {
    [sym_primitive_type] = STATE(7889),
    [sym__expression] = STATE(3965),
    [sym__expression_not_binary] = STATE(4247),
    [sym__string] = STATE(4247),
    [sym_conditional_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4247),
    [sym_pointer_expression] = STATE(4247),
    [sym_unary_expression] = STATE(4247),
    [sym_binary_expression] = STATE(4247),
    [sym_update_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_alignof_expression] = STATE(4247),
    [sym_offsetof_expression] = STATE(4247),
    [sym_generic_expression] = STATE(4247),
    [sym_subscript_expression] = STATE(4247),
    [sym_call_expression] = STATE(4247),
    [sym_gnu_asm_expression] = STATE(4247),
    [sym_field_expression] = STATE(4247),
    [sym_compound_literal_expression] = STATE(4247),
    [sym_parenthesized_expression] = STATE(4247),
    [sym_number_literal] = STATE(4205),
    [sym_char_literal] = STATE(4205),
    [sym_concatenated_string] = STATE(4204),
    [sym_string_literal] = STATE(2832),
    [sym_null] = STATE(4247),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8484),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4247),
    [sym_raw_string_literal] = STATE(2831),
    [sym_co_await_expression] = STATE(4247),
    [sym_new_expression] = STATE(4247),
    [sym_delete_expression] = STATE(4247),
    [sym_requires_clause] = STATE(4247),
    [sym_requires_expression] = STATE(4247),
    [sym_lambda_expression] = STATE(4247),
    [sym_lambda_capture_specifier] = STATE(6732),
    [sym_fold_expression] = STATE(4247),
    [sym_parameter_pack_expansion] = STATE(4247),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4247),
    [sym_qualified_type_identifier] = STATE(8484),
    [sym_user_defined_literal] = STATE(4247),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2733),
    [anon_sym_compl] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(4611),
    [anon_sym_PLUS_PLUS] = ACTIONS(4611),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2745),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2749),
    [anon_sym___asm__] = ACTIONS(2749),
    [aux_sym_number_literal_token1] = ACTIONS(2751),
    [aux_sym_number_literal_token2] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2755),
    [anon_sym_u_SQUOTE] = ACTIONS(2755),
    [anon_sym_U_SQUOTE] = ACTIONS(2755),
    [anon_sym_u8_SQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2759),
  },
  [1905] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5273),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1906] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5225),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1907] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5480),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1908] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5279),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1909] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4305),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1910] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5034),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1911] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5487),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1912] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5513),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4243),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4243),
    [sym_call_expression] = STATE(4243),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4243),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4243),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4243),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4243),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4742),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(4005),
    [anon_sym_compl] = ACTIONS(4005),
    [anon_sym_DASH_DASH] = ACTIONS(4665),
    [anon_sym_PLUS_PLUS] = ACTIONS(4665),
    [anon_sym_sizeof] = ACTIONS(4011),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(4013),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1913] = {
    [sym_primitive_type] = STATE(7889),
    [sym__expression] = STATE(3966),
    [sym__expression_not_binary] = STATE(4247),
    [sym__string] = STATE(4247),
    [sym_conditional_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4247),
    [sym_pointer_expression] = STATE(4247),
    [sym_unary_expression] = STATE(4247),
    [sym_binary_expression] = STATE(4247),
    [sym_update_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_alignof_expression] = STATE(4247),
    [sym_offsetof_expression] = STATE(4247),
    [sym_generic_expression] = STATE(4247),
    [sym_subscript_expression] = STATE(4247),
    [sym_call_expression] = STATE(4247),
    [sym_gnu_asm_expression] = STATE(4247),
    [sym_field_expression] = STATE(4247),
    [sym_compound_literal_expression] = STATE(4247),
    [sym_parenthesized_expression] = STATE(4247),
    [sym_number_literal] = STATE(4205),
    [sym_char_literal] = STATE(4205),
    [sym_concatenated_string] = STATE(4204),
    [sym_string_literal] = STATE(2832),
    [sym_null] = STATE(4247),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8484),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4247),
    [sym_raw_string_literal] = STATE(2831),
    [sym_co_await_expression] = STATE(4247),
    [sym_new_expression] = STATE(4247),
    [sym_delete_expression] = STATE(4247),
    [sym_requires_clause] = STATE(4247),
    [sym_requires_expression] = STATE(4247),
    [sym_lambda_expression] = STATE(4247),
    [sym_lambda_capture_specifier] = STATE(6732),
    [sym_fold_expression] = STATE(4247),
    [sym_parameter_pack_expansion] = STATE(4247),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4247),
    [sym_qualified_type_identifier] = STATE(8484),
    [sym_user_defined_literal] = STATE(4247),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2733),
    [anon_sym_compl] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(4611),
    [anon_sym_PLUS_PLUS] = ACTIONS(4611),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2745),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2749),
    [anon_sym___asm__] = ACTIONS(2749),
    [aux_sym_number_literal_token1] = ACTIONS(2751),
    [aux_sym_number_literal_token2] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2755),
    [anon_sym_u_SQUOTE] = ACTIONS(2755),
    [anon_sym_U_SQUOTE] = ACTIONS(2755),
    [anon_sym_u8_SQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2759),
  },
  [1914] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5269),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1915] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5262),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1916] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5260),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1917] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5256),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1918] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5229),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1919] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5045),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1920] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5337),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1921] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5285),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1922] = {
    [sym_primitive_type] = STATE(7711),
    [sym__expression] = STATE(3515),
    [sym__expression_not_binary] = STATE(3678),
    [sym__string] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_alignof_expression] = STATE(3678),
    [sym_offsetof_expression] = STATE(3678),
    [sym_generic_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_number_literal] = STATE(3544),
    [sym_char_literal] = STATE(3544),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(2634),
    [sym_null] = STATE(3678),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8556),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3678),
    [sym_raw_string_literal] = STATE(2647),
    [sym_co_await_expression] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_requires_clause] = STATE(3678),
    [sym_requires_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(6739),
    [sym_fold_expression] = STATE(3678),
    [sym_parameter_pack_expansion] = STATE(3678),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(8556),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2225),
    [anon_sym_compl] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(4587),
    [anon_sym_PLUS_PLUS] = ACTIONS(4587),
    [anon_sym_sizeof] = ACTIONS(2233),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2237),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2241),
    [anon_sym___asm__] = ACTIONS(2241),
    [aux_sym_number_literal_token1] = ACTIONS(2243),
    [aux_sym_number_literal_token2] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2247),
    [anon_sym_u_SQUOTE] = ACTIONS(2247),
    [anon_sym_U_SQUOTE] = ACTIONS(2247),
    [anon_sym_u8_SQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2253),
    [anon_sym_nullptr] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_requires] = ACTIONS(2263),
    [sym_this] = ACTIONS(2251),
  },
  [1923] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5484),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1924] = {
    [sym_primitive_type] = STATE(7757),
    [sym__expression] = STATE(5270),
    [sym__expression_not_binary] = STATE(5552),
    [sym__string] = STATE(5552),
    [sym_conditional_expression] = STATE(5552),
    [sym_assignment_expression] = STATE(5552),
    [sym_pointer_expression] = STATE(4248),
    [sym_unary_expression] = STATE(5552),
    [sym_binary_expression] = STATE(5552),
    [sym_update_expression] = STATE(5552),
    [sym_cast_expression] = STATE(5552),
    [sym_sizeof_expression] = STATE(5552),
    [sym_alignof_expression] = STATE(5552),
    [sym_offsetof_expression] = STATE(5552),
    [sym_generic_expression] = STATE(5552),
    [sym_subscript_expression] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_gnu_asm_expression] = STATE(5552),
    [sym_field_expression] = STATE(4248),
    [sym_compound_literal_expression] = STATE(5552),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_number_literal] = STATE(5482),
    [sym_char_literal] = STATE(5482),
    [sym_concatenated_string] = STATE(5407),
    [sym_string_literal] = STATE(4435),
    [sym_null] = STATE(5552),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8471),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5552),
    [sym_raw_string_literal] = STATE(4436),
    [sym_co_await_expression] = STATE(5552),
    [sym_new_expression] = STATE(5552),
    [sym_delete_expression] = STATE(5552),
    [sym_requires_clause] = STATE(5552),
    [sym_requires_expression] = STATE(5552),
    [sym_lambda_expression] = STATE(5552),
    [sym_lambda_capture_specifier] = STATE(6745),
    [sym_fold_expression] = STATE(5552),
    [sym_parameter_pack_expansion] = STATE(5552),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4248),
    [sym_qualified_type_identifier] = STATE(8471),
    [sym_user_defined_literal] = STATE(4248),
    [sym_identifier] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3004),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3018),
  },
  [1925] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3797),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3897),
    [sym_char_literal] = STATE(3897),
    [sym_concatenated_string] = STATE(3895),
    [sym_string_literal] = STATE(2803),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2782),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(4740),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_compl] = ACTIONS(2273),
    [anon_sym_DASH_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4725),
    [anon_sym_sizeof] = ACTIONS(2279),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2281),
    [aux_sym_number_literal_token2] = ACTIONS(2283),
    [anon_sym_L_SQUOTE] = ACTIONS(2285),
    [anon_sym_u_SQUOTE] = ACTIONS(2285),
    [anon_sym_U_SQUOTE] = ACTIONS(2285),
    [anon_sym_u8_SQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_L_DQUOTE] = ACTIONS(2287),
    [anon_sym_u_DQUOTE] = ACTIONS(2287),
    [anon_sym_U_DQUOTE] = ACTIONS(2287),
    [anon_sym_u8_DQUOTE] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_R_DQUOTE] = ACTIONS(2291),
    [anon_sym_LR_DQUOTE] = ACTIONS(2291),
    [anon_sym_uR_DQUOTE] = ACTIONS(2291),
    [anon_sym_UR_DQUOTE] = ACTIONS(2291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2291),
    [anon_sym_co_await] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1926] = {
    [sym_primitive_type] = STATE(7889),
    [sym__expression] = STATE(3859),
    [sym__expression_not_binary] = STATE(4247),
    [sym__string] = STATE(4247),
    [sym_conditional_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4247),
    [sym_pointer_expression] = STATE(4247),
    [sym_unary_expression] = STATE(4247),
    [sym_binary_expression] = STATE(4247),
    [sym_update_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_alignof_expression] = STATE(4247),
    [sym_offsetof_expression] = STATE(4247),
    [sym_generic_expression] = STATE(4247),
    [sym_subscript_expression] = STATE(4247),
    [sym_call_expression] = STATE(4247),
    [sym_gnu_asm_expression] = STATE(4247),
    [sym_field_expression] = STATE(4247),
    [sym_compound_literal_expression] = STATE(4247),
    [sym_parenthesized_expression] = STATE(4247),
    [sym_number_literal] = STATE(4205),
    [sym_char_literal] = STATE(4205),
    [sym_concatenated_string] = STATE(4204),
    [sym_string_literal] = STATE(2832),
    [sym_null] = STATE(4247),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8484),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4247),
    [sym_raw_string_literal] = STATE(2831),
    [sym_co_await_expression] = STATE(4247),
    [sym_new_expression] = STATE(4247),
    [sym_delete_expression] = STATE(4247),
    [sym_requires_clause] = STATE(4247),
    [sym_requires_expression] = STATE(4247),
    [sym_lambda_expression] = STATE(4247),
    [sym_lambda_capture_specifier] = STATE(6732),
    [sym_fold_expression] = STATE(4247),
    [sym_parameter_pack_expansion] = STATE(4247),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4247),
    [sym_qualified_type_identifier] = STATE(8484),
    [sym_user_defined_literal] = STATE(4247),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2733),
    [anon_sym_compl] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(4611),
    [anon_sym_PLUS_PLUS] = ACTIONS(4611),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2745),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2749),
    [anon_sym___asm__] = ACTIONS(2749),
    [aux_sym_number_literal_token1] = ACTIONS(2751),
    [aux_sym_number_literal_token2] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2755),
    [anon_sym_u_SQUOTE] = ACTIONS(2755),
    [anon_sym_U_SQUOTE] = ACTIONS(2755),
    [anon_sym_u8_SQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2759),
  },
  [1927] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5287),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1928] = {
    [sym_primitive_type] = STATE(7889),
    [sym__expression] = STATE(3990),
    [sym__expression_not_binary] = STATE(4247),
    [sym__string] = STATE(4247),
    [sym_conditional_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4247),
    [sym_pointer_expression] = STATE(4247),
    [sym_unary_expression] = STATE(4247),
    [sym_binary_expression] = STATE(4247),
    [sym_update_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_alignof_expression] = STATE(4247),
    [sym_offsetof_expression] = STATE(4247),
    [sym_generic_expression] = STATE(4247),
    [sym_subscript_expression] = STATE(4247),
    [sym_call_expression] = STATE(4247),
    [sym_gnu_asm_expression] = STATE(4247),
    [sym_field_expression] = STATE(4247),
    [sym_compound_literal_expression] = STATE(4247),
    [sym_parenthesized_expression] = STATE(4247),
    [sym_number_literal] = STATE(4205),
    [sym_char_literal] = STATE(4205),
    [sym_concatenated_string] = STATE(4204),
    [sym_string_literal] = STATE(2832),
    [sym_null] = STATE(4247),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8484),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4247),
    [sym_raw_string_literal] = STATE(2831),
    [sym_co_await_expression] = STATE(4247),
    [sym_new_expression] = STATE(4247),
    [sym_delete_expression] = STATE(4247),
    [sym_requires_clause] = STATE(4247),
    [sym_requires_expression] = STATE(4247),
    [sym_lambda_expression] = STATE(4247),
    [sym_lambda_capture_specifier] = STATE(6732),
    [sym_fold_expression] = STATE(4247),
    [sym_parameter_pack_expansion] = STATE(4247),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4247),
    [sym_qualified_type_identifier] = STATE(8484),
    [sym_user_defined_literal] = STATE(4247),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2733),
    [anon_sym_compl] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(4611),
    [anon_sym_PLUS_PLUS] = ACTIONS(4611),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2745),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2749),
    [anon_sym___asm__] = ACTIONS(2749),
    [aux_sym_number_literal_token1] = ACTIONS(2751),
    [aux_sym_number_literal_token2] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2755),
    [anon_sym_u_SQUOTE] = ACTIONS(2755),
    [anon_sym_U_SQUOTE] = ACTIONS(2755),
    [anon_sym_u8_SQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2759),
  },
  [1929] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3806),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3897),
    [sym_char_literal] = STATE(3897),
    [sym_concatenated_string] = STATE(3895),
    [sym_string_literal] = STATE(2803),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2782),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(4740),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_compl] = ACTIONS(2273),
    [anon_sym_DASH_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4725),
    [anon_sym_sizeof] = ACTIONS(2279),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2281),
    [aux_sym_number_literal_token2] = ACTIONS(2283),
    [anon_sym_L_SQUOTE] = ACTIONS(2285),
    [anon_sym_u_SQUOTE] = ACTIONS(2285),
    [anon_sym_U_SQUOTE] = ACTIONS(2285),
    [anon_sym_u8_SQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_L_DQUOTE] = ACTIONS(2287),
    [anon_sym_u_DQUOTE] = ACTIONS(2287),
    [anon_sym_U_DQUOTE] = ACTIONS(2287),
    [anon_sym_u8_DQUOTE] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_R_DQUOTE] = ACTIONS(2291),
    [anon_sym_LR_DQUOTE] = ACTIONS(2291),
    [anon_sym_uR_DQUOTE] = ACTIONS(2291),
    [anon_sym_UR_DQUOTE] = ACTIONS(2291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2291),
    [anon_sym_co_await] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1930] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3805),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3897),
    [sym_char_literal] = STATE(3897),
    [sym_concatenated_string] = STATE(3895),
    [sym_string_literal] = STATE(2803),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2782),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(4740),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_compl] = ACTIONS(2273),
    [anon_sym_DASH_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4725),
    [anon_sym_sizeof] = ACTIONS(2279),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2281),
    [aux_sym_number_literal_token2] = ACTIONS(2283),
    [anon_sym_L_SQUOTE] = ACTIONS(2285),
    [anon_sym_u_SQUOTE] = ACTIONS(2285),
    [anon_sym_U_SQUOTE] = ACTIONS(2285),
    [anon_sym_u8_SQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_L_DQUOTE] = ACTIONS(2287),
    [anon_sym_u_DQUOTE] = ACTIONS(2287),
    [anon_sym_U_DQUOTE] = ACTIONS(2287),
    [anon_sym_u8_DQUOTE] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_R_DQUOTE] = ACTIONS(2291),
    [anon_sym_LR_DQUOTE] = ACTIONS(2291),
    [anon_sym_uR_DQUOTE] = ACTIONS(2291),
    [anon_sym_UR_DQUOTE] = ACTIONS(2291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2291),
    [anon_sym_co_await] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1931] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3804),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3897),
    [sym_char_literal] = STATE(3897),
    [sym_concatenated_string] = STATE(3895),
    [sym_string_literal] = STATE(2803),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2782),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(4740),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_compl] = ACTIONS(2273),
    [anon_sym_DASH_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4725),
    [anon_sym_sizeof] = ACTIONS(2279),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2281),
    [aux_sym_number_literal_token2] = ACTIONS(2283),
    [anon_sym_L_SQUOTE] = ACTIONS(2285),
    [anon_sym_u_SQUOTE] = ACTIONS(2285),
    [anon_sym_U_SQUOTE] = ACTIONS(2285),
    [anon_sym_u8_SQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_L_DQUOTE] = ACTIONS(2287),
    [anon_sym_u_DQUOTE] = ACTIONS(2287),
    [anon_sym_U_DQUOTE] = ACTIONS(2287),
    [anon_sym_u8_DQUOTE] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_R_DQUOTE] = ACTIONS(2291),
    [anon_sym_LR_DQUOTE] = ACTIONS(2291),
    [anon_sym_uR_DQUOTE] = ACTIONS(2291),
    [anon_sym_UR_DQUOTE] = ACTIONS(2291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2291),
    [anon_sym_co_await] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1932] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3802),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3897),
    [sym_char_literal] = STATE(3897),
    [sym_concatenated_string] = STATE(3895),
    [sym_string_literal] = STATE(2803),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2782),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(4740),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_compl] = ACTIONS(2273),
    [anon_sym_DASH_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4725),
    [anon_sym_sizeof] = ACTIONS(2279),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2281),
    [aux_sym_number_literal_token2] = ACTIONS(2283),
    [anon_sym_L_SQUOTE] = ACTIONS(2285),
    [anon_sym_u_SQUOTE] = ACTIONS(2285),
    [anon_sym_U_SQUOTE] = ACTIONS(2285),
    [anon_sym_u8_SQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_L_DQUOTE] = ACTIONS(2287),
    [anon_sym_u_DQUOTE] = ACTIONS(2287),
    [anon_sym_U_DQUOTE] = ACTIONS(2287),
    [anon_sym_u8_DQUOTE] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_R_DQUOTE] = ACTIONS(2291),
    [anon_sym_LR_DQUOTE] = ACTIONS(2291),
    [anon_sym_uR_DQUOTE] = ACTIONS(2291),
    [anon_sym_UR_DQUOTE] = ACTIONS(2291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2291),
    [anon_sym_co_await] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1933] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5491),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1934] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3801),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3897),
    [sym_char_literal] = STATE(3897),
    [sym_concatenated_string] = STATE(3895),
    [sym_string_literal] = STATE(2803),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2782),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(4740),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_compl] = ACTIONS(2273),
    [anon_sym_DASH_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4725),
    [anon_sym_sizeof] = ACTIONS(2279),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2281),
    [aux_sym_number_literal_token2] = ACTIONS(2283),
    [anon_sym_L_SQUOTE] = ACTIONS(2285),
    [anon_sym_u_SQUOTE] = ACTIONS(2285),
    [anon_sym_U_SQUOTE] = ACTIONS(2285),
    [anon_sym_u8_SQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_L_DQUOTE] = ACTIONS(2287),
    [anon_sym_u_DQUOTE] = ACTIONS(2287),
    [anon_sym_U_DQUOTE] = ACTIONS(2287),
    [anon_sym_u8_DQUOTE] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_R_DQUOTE] = ACTIONS(2291),
    [anon_sym_LR_DQUOTE] = ACTIONS(2291),
    [anon_sym_uR_DQUOTE] = ACTIONS(2291),
    [anon_sym_UR_DQUOTE] = ACTIONS(2291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2291),
    [anon_sym_co_await] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1935] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3800),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3897),
    [sym_char_literal] = STATE(3897),
    [sym_concatenated_string] = STATE(3895),
    [sym_string_literal] = STATE(2803),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2782),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(4740),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_compl] = ACTIONS(2273),
    [anon_sym_DASH_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4725),
    [anon_sym_sizeof] = ACTIONS(2279),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2281),
    [aux_sym_number_literal_token2] = ACTIONS(2283),
    [anon_sym_L_SQUOTE] = ACTIONS(2285),
    [anon_sym_u_SQUOTE] = ACTIONS(2285),
    [anon_sym_U_SQUOTE] = ACTIONS(2285),
    [anon_sym_u8_SQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_L_DQUOTE] = ACTIONS(2287),
    [anon_sym_u_DQUOTE] = ACTIONS(2287),
    [anon_sym_U_DQUOTE] = ACTIONS(2287),
    [anon_sym_u8_DQUOTE] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_R_DQUOTE] = ACTIONS(2291),
    [anon_sym_LR_DQUOTE] = ACTIONS(2291),
    [anon_sym_uR_DQUOTE] = ACTIONS(2291),
    [anon_sym_UR_DQUOTE] = ACTIONS(2291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2291),
    [anon_sym_co_await] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1936] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(4542),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1937] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5017),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1938] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3799),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3897),
    [sym_char_literal] = STATE(3897),
    [sym_concatenated_string] = STATE(3895),
    [sym_string_literal] = STATE(2803),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2782),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(4740),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_compl] = ACTIONS(2273),
    [anon_sym_DASH_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4725),
    [anon_sym_sizeof] = ACTIONS(2279),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2281),
    [aux_sym_number_literal_token2] = ACTIONS(2283),
    [anon_sym_L_SQUOTE] = ACTIONS(2285),
    [anon_sym_u_SQUOTE] = ACTIONS(2285),
    [anon_sym_U_SQUOTE] = ACTIONS(2285),
    [anon_sym_u8_SQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_L_DQUOTE] = ACTIONS(2287),
    [anon_sym_u_DQUOTE] = ACTIONS(2287),
    [anon_sym_U_DQUOTE] = ACTIONS(2287),
    [anon_sym_u8_DQUOTE] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_R_DQUOTE] = ACTIONS(2291),
    [anon_sym_LR_DQUOTE] = ACTIONS(2291),
    [anon_sym_uR_DQUOTE] = ACTIONS(2291),
    [anon_sym_UR_DQUOTE] = ACTIONS(2291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2291),
    [anon_sym_co_await] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1939] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3798),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3897),
    [sym_char_literal] = STATE(3897),
    [sym_concatenated_string] = STATE(3895),
    [sym_string_literal] = STATE(2803),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2782),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(4740),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_compl] = ACTIONS(2273),
    [anon_sym_DASH_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4725),
    [anon_sym_sizeof] = ACTIONS(2279),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2281),
    [aux_sym_number_literal_token2] = ACTIONS(2283),
    [anon_sym_L_SQUOTE] = ACTIONS(2285),
    [anon_sym_u_SQUOTE] = ACTIONS(2285),
    [anon_sym_U_SQUOTE] = ACTIONS(2285),
    [anon_sym_u8_SQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_L_DQUOTE] = ACTIONS(2287),
    [anon_sym_u_DQUOTE] = ACTIONS(2287),
    [anon_sym_U_DQUOTE] = ACTIONS(2287),
    [anon_sym_u8_DQUOTE] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_R_DQUOTE] = ACTIONS(2291),
    [anon_sym_LR_DQUOTE] = ACTIONS(2291),
    [anon_sym_uR_DQUOTE] = ACTIONS(2291),
    [anon_sym_UR_DQUOTE] = ACTIONS(2291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2291),
    [anon_sym_co_await] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1940] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2876),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3897),
    [sym_char_literal] = STATE(3897),
    [sym_concatenated_string] = STATE(3895),
    [sym_string_literal] = STATE(2803),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2782),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(4740),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_compl] = ACTIONS(2273),
    [anon_sym_DASH_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4725),
    [anon_sym_sizeof] = ACTIONS(2279),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2281),
    [aux_sym_number_literal_token2] = ACTIONS(2283),
    [anon_sym_L_SQUOTE] = ACTIONS(2285),
    [anon_sym_u_SQUOTE] = ACTIONS(2285),
    [anon_sym_U_SQUOTE] = ACTIONS(2285),
    [anon_sym_u8_SQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_L_DQUOTE] = ACTIONS(2287),
    [anon_sym_u_DQUOTE] = ACTIONS(2287),
    [anon_sym_U_DQUOTE] = ACTIONS(2287),
    [anon_sym_u8_DQUOTE] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_R_DQUOTE] = ACTIONS(2291),
    [anon_sym_LR_DQUOTE] = ACTIONS(2291),
    [anon_sym_uR_DQUOTE] = ACTIONS(2291),
    [anon_sym_UR_DQUOTE] = ACTIONS(2291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2291),
    [anon_sym_co_await] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1941] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5066),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1942] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3243),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_concatenated_string] = STATE(3312),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2365),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4791),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2153),
    [anon_sym_compl] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4683),
    [anon_sym_sizeof] = ACTIONS(2161),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2171),
    [aux_sym_number_literal_token2] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2175),
    [anon_sym_u_SQUOTE] = ACTIONS(2175),
    [anon_sym_U_SQUOTE] = ACTIONS(2175),
    [anon_sym_u8_SQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1943] = {
    [sym_primitive_type] = STATE(7782),
    [sym__expression] = STATE(4966),
    [sym__expression_not_binary] = STATE(5060),
    [sym__string] = STATE(5060),
    [sym_conditional_expression] = STATE(5060),
    [sym_assignment_expression] = STATE(5060),
    [sym_pointer_expression] = STATE(3745),
    [sym_unary_expression] = STATE(5060),
    [sym_binary_expression] = STATE(5060),
    [sym_update_expression] = STATE(5060),
    [sym_cast_expression] = STATE(5060),
    [sym_sizeof_expression] = STATE(5060),
    [sym_alignof_expression] = STATE(5060),
    [sym_offsetof_expression] = STATE(5060),
    [sym_generic_expression] = STATE(5060),
    [sym_subscript_expression] = STATE(3745),
    [sym_call_expression] = STATE(3745),
    [sym_gnu_asm_expression] = STATE(5060),
    [sym_field_expression] = STATE(3745),
    [sym_compound_literal_expression] = STATE(5060),
    [sym_parenthesized_expression] = STATE(3745),
    [sym_number_literal] = STATE(5014),
    [sym_char_literal] = STATE(5014),
    [sym_concatenated_string] = STATE(5015),
    [sym_string_literal] = STATE(3873),
    [sym_null] = STATE(5060),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8487),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(5060),
    [sym_raw_string_literal] = STATE(3872),
    [sym_co_await_expression] = STATE(5060),
    [sym_new_expression] = STATE(5060),
    [sym_delete_expression] = STATE(5060),
    [sym_requires_clause] = STATE(5060),
    [sym_requires_expression] = STATE(5060),
    [sym_lambda_expression] = STATE(5060),
    [sym_lambda_capture_specifier] = STATE(6754),
    [sym_fold_expression] = STATE(5060),
    [sym_parameter_pack_expansion] = STATE(5060),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6453),
    [sym_qualified_identifier] = STATE(3745),
    [sym_qualified_type_identifier] = STATE(8487),
    [sym_user_defined_literal] = STATE(3745),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_LPAREN2] = ACTIONS(4778),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_AMP] = ACTIONS(4780),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4605),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3733),
    [anon_sym___alignof] = ACTIONS(3733),
    [anon_sym__alignof] = ACTIONS(3733),
    [anon_sym_alignof] = ACTIONS(3733),
    [anon_sym__Alignof] = ACTIONS(3733),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3737),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [aux_sym_number_literal_token1] = ACTIONS(3741),
    [aux_sym_number_literal_token2] = ACTIONS(3743),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3753),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3761),
    [sym_this] = ACTIONS(3749),
  },
  [1944] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5086),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1945] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5405),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1946] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5330),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1947] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3826),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1948] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3820),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1949] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3826),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(5089),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1950] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5410),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1951] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5444),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1952] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5403),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1953] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5459),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1954] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5157),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4177),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4177),
    [sym_call_expression] = STATE(4177),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4177),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4177),
    [sym_number_literal] = STATE(5366),
    [sym_char_literal] = STATE(5366),
    [sym_concatenated_string] = STATE(5365),
    [sym_string_literal] = STATE(4273),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(4265),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4177),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4177),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(4613),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_compl] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(4619),
    [anon_sym_PLUS_PLUS] = ACTIONS(4619),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3809),
    [aux_sym_number_literal_token2] = ACTIONS(3811),
    [anon_sym_L_SQUOTE] = ACTIONS(3813),
    [anon_sym_u_SQUOTE] = ACTIONS(3813),
    [anon_sym_U_SQUOTE] = ACTIONS(3813),
    [anon_sym_u8_SQUOTE] = ACTIONS(3813),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [anon_sym_L_DQUOTE] = ACTIONS(3815),
    [anon_sym_u_DQUOTE] = ACTIONS(3815),
    [anon_sym_U_DQUOTE] = ACTIONS(3815),
    [anon_sym_u8_DQUOTE] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3815),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3817),
    [anon_sym_R_DQUOTE] = ACTIONS(3819),
    [anon_sym_LR_DQUOTE] = ACTIONS(3819),
    [anon_sym_uR_DQUOTE] = ACTIONS(3819),
    [anon_sym_UR_DQUOTE] = ACTIONS(3819),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3819),
    [anon_sym_co_await] = ACTIONS(3821),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1955] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5476),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1956] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5163),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1957] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5448),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1958] = {
    [sym_primitive_type] = STATE(7889),
    [sym__expression] = STATE(3968),
    [sym__expression_not_binary] = STATE(4247),
    [sym__string] = STATE(4247),
    [sym_conditional_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4247),
    [sym_pointer_expression] = STATE(4247),
    [sym_unary_expression] = STATE(4247),
    [sym_binary_expression] = STATE(4247),
    [sym_update_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_alignof_expression] = STATE(4247),
    [sym_offsetof_expression] = STATE(4247),
    [sym_generic_expression] = STATE(4247),
    [sym_subscript_expression] = STATE(4247),
    [sym_call_expression] = STATE(4247),
    [sym_gnu_asm_expression] = STATE(4247),
    [sym_field_expression] = STATE(4247),
    [sym_compound_literal_expression] = STATE(4247),
    [sym_parenthesized_expression] = STATE(4247),
    [sym_number_literal] = STATE(4205),
    [sym_char_literal] = STATE(4205),
    [sym_concatenated_string] = STATE(4204),
    [sym_string_literal] = STATE(2832),
    [sym_null] = STATE(4247),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8484),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4247),
    [sym_raw_string_literal] = STATE(2831),
    [sym_co_await_expression] = STATE(4247),
    [sym_new_expression] = STATE(4247),
    [sym_delete_expression] = STATE(4247),
    [sym_requires_clause] = STATE(4247),
    [sym_requires_expression] = STATE(4247),
    [sym_lambda_expression] = STATE(4247),
    [sym_lambda_capture_specifier] = STATE(6732),
    [sym_fold_expression] = STATE(4247),
    [sym_parameter_pack_expansion] = STATE(4247),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4247),
    [sym_qualified_type_identifier] = STATE(8484),
    [sym_user_defined_literal] = STATE(4247),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2733),
    [anon_sym_compl] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(4611),
    [anon_sym_PLUS_PLUS] = ACTIONS(4611),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2745),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2749),
    [anon_sym___asm__] = ACTIONS(2749),
    [aux_sym_number_literal_token1] = ACTIONS(2751),
    [aux_sym_number_literal_token2] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2755),
    [anon_sym_u_SQUOTE] = ACTIONS(2755),
    [anon_sym_U_SQUOTE] = ACTIONS(2755),
    [anon_sym_u8_SQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2759),
  },
  [1959] = {
    [sym_primitive_type] = STATE(7787),
    [sym__expression] = STATE(3803),
    [sym__expression_not_binary] = STATE(4059),
    [sym__string] = STATE(4059),
    [sym_conditional_expression] = STATE(4059),
    [sym_assignment_expression] = STATE(4059),
    [sym_pointer_expression] = STATE(4059),
    [sym_unary_expression] = STATE(4059),
    [sym_binary_expression] = STATE(4059),
    [sym_update_expression] = STATE(4059),
    [sym_cast_expression] = STATE(4059),
    [sym_sizeof_expression] = STATE(4059),
    [sym_alignof_expression] = STATE(4059),
    [sym_offsetof_expression] = STATE(4059),
    [sym_generic_expression] = STATE(4059),
    [sym_subscript_expression] = STATE(4059),
    [sym_call_expression] = STATE(4059),
    [sym_gnu_asm_expression] = STATE(4059),
    [sym_field_expression] = STATE(4059),
    [sym_compound_literal_expression] = STATE(4059),
    [sym_parenthesized_expression] = STATE(4059),
    [sym_number_literal] = STATE(3886),
    [sym_char_literal] = STATE(3886),
    [sym_concatenated_string] = STATE(3887),
    [sym_string_literal] = STATE(2797),
    [sym_null] = STATE(4059),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8564),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4059),
    [sym_raw_string_literal] = STATE(2774),
    [sym_co_await_expression] = STATE(4059),
    [sym_new_expression] = STATE(4059),
    [sym_delete_expression] = STATE(4059),
    [sym_requires_clause] = STATE(4059),
    [sym_requires_expression] = STATE(4059),
    [sym_lambda_expression] = STATE(4059),
    [sym_lambda_capture_specifier] = STATE(6743),
    [sym_fold_expression] = STATE(4059),
    [sym_parameter_pack_expansion] = STATE(4059),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4059),
    [sym_qualified_type_identifier] = STATE(8564),
    [sym_user_defined_literal] = STATE(4059),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2083),
    [anon_sym_compl] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2109),
    [anon_sym___alignof__] = ACTIONS(2111),
    [anon_sym___alignof] = ACTIONS(2111),
    [anon_sym__alignof] = ACTIONS(2111),
    [anon_sym_alignof] = ACTIONS(2111),
    [anon_sym__Alignof] = ACTIONS(2111),
    [anon_sym_offsetof] = ACTIONS(2113),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2117),
    [anon_sym___asm__] = ACTIONS(2117),
    [aux_sym_number_literal_token1] = ACTIONS(2119),
    [aux_sym_number_literal_token2] = ACTIONS(2121),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2125),
    [anon_sym_u_DQUOTE] = ACTIONS(2125),
    [anon_sym_U_DQUOTE] = ACTIONS(2125),
    [anon_sym_u8_DQUOTE] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [anon_sym_NULL] = ACTIONS(2129),
    [anon_sym_nullptr] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2147),
    [sym_this] = ACTIONS(2127),
  },
  [1960] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5458),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1961] = {
    [sym_primitive_type] = STATE(7889),
    [sym__expression] = STATE(3969),
    [sym__expression_not_binary] = STATE(4247),
    [sym__string] = STATE(4247),
    [sym_conditional_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4247),
    [sym_pointer_expression] = STATE(4247),
    [sym_unary_expression] = STATE(4247),
    [sym_binary_expression] = STATE(4247),
    [sym_update_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_alignof_expression] = STATE(4247),
    [sym_offsetof_expression] = STATE(4247),
    [sym_generic_expression] = STATE(4247),
    [sym_subscript_expression] = STATE(4247),
    [sym_call_expression] = STATE(4247),
    [sym_gnu_asm_expression] = STATE(4247),
    [sym_field_expression] = STATE(4247),
    [sym_compound_literal_expression] = STATE(4247),
    [sym_parenthesized_expression] = STATE(4247),
    [sym_number_literal] = STATE(4205),
    [sym_char_literal] = STATE(4205),
    [sym_concatenated_string] = STATE(4204),
    [sym_string_literal] = STATE(2832),
    [sym_null] = STATE(4247),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8484),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4247),
    [sym_raw_string_literal] = STATE(2831),
    [sym_co_await_expression] = STATE(4247),
    [sym_new_expression] = STATE(4247),
    [sym_delete_expression] = STATE(4247),
    [sym_requires_clause] = STATE(4247),
    [sym_requires_expression] = STATE(4247),
    [sym_lambda_expression] = STATE(4247),
    [sym_lambda_capture_specifier] = STATE(6732),
    [sym_fold_expression] = STATE(4247),
    [sym_parameter_pack_expansion] = STATE(4247),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6443),
    [sym_qualified_identifier] = STATE(4247),
    [sym_qualified_type_identifier] = STATE(8484),
    [sym_user_defined_literal] = STATE(4247),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2733),
    [anon_sym_compl] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(4611),
    [anon_sym_PLUS_PLUS] = ACTIONS(4611),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2745),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2749),
    [anon_sym___asm__] = ACTIONS(2749),
    [aux_sym_number_literal_token1] = ACTIONS(2751),
    [aux_sym_number_literal_token2] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2755),
    [anon_sym_u_SQUOTE] = ACTIONS(2755),
    [anon_sym_U_SQUOTE] = ACTIONS(2755),
    [anon_sym_u8_SQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2759),
  },
  [1962] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3274),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_concatenated_string] = STATE(3312),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2365),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4791),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(5091),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2153),
    [anon_sym_compl] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4683),
    [anon_sym_sizeof] = ACTIONS(2161),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2171),
    [aux_sym_number_literal_token2] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2175),
    [anon_sym_u_SQUOTE] = ACTIONS(2175),
    [anon_sym_U_SQUOTE] = ACTIONS(2175),
    [anon_sym_u8_SQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1963] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(2890),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_concatenated_string] = STATE(3312),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2365),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4791),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2153),
    [anon_sym_compl] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4683),
    [anon_sym_sizeof] = ACTIONS(2161),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2171),
    [aux_sym_number_literal_token2] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2175),
    [anon_sym_u_SQUOTE] = ACTIONS(2175),
    [anon_sym_U_SQUOTE] = ACTIONS(2175),
    [anon_sym_u8_SQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1964] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3245),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_concatenated_string] = STATE(3312),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2365),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4791),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2153),
    [anon_sym_compl] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4683),
    [anon_sym_sizeof] = ACTIONS(2161),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2171),
    [aux_sym_number_literal_token2] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2175),
    [anon_sym_u_SQUOTE] = ACTIONS(2175),
    [anon_sym_U_SQUOTE] = ACTIONS(2175),
    [anon_sym_u8_SQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1965] = {
    [sym_primitive_type] = STATE(7749),
    [sym__expression] = STATE(3285),
    [sym__expression_not_binary] = STATE(3026),
    [sym__string] = STATE(3026),
    [sym_conditional_expression] = STATE(3026),
    [sym_assignment_expression] = STATE(3026),
    [sym_pointer_expression] = STATE(3026),
    [sym_unary_expression] = STATE(3026),
    [sym_binary_expression] = STATE(3026),
    [sym_update_expression] = STATE(3026),
    [sym_cast_expression] = STATE(3026),
    [sym_sizeof_expression] = STATE(3026),
    [sym_alignof_expression] = STATE(3026),
    [sym_offsetof_expression] = STATE(3026),
    [sym_generic_expression] = STATE(3026),
    [sym_subscript_expression] = STATE(3026),
    [sym_call_expression] = STATE(3026),
    [sym_gnu_asm_expression] = STATE(3026),
    [sym_field_expression] = STATE(3026),
    [sym_compound_literal_expression] = STATE(3026),
    [sym_parenthesized_expression] = STATE(3026),
    [sym_number_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_concatenated_string] = STATE(3312),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3026),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8727),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(3026),
    [sym_raw_string_literal] = STATE(2365),
    [sym_co_await_expression] = STATE(3026),
    [sym_new_expression] = STATE(3026),
    [sym_delete_expression] = STATE(3026),
    [sym_requires_clause] = STATE(3026),
    [sym_requires_expression] = STATE(3026),
    [sym_lambda_expression] = STATE(3026),
    [sym_lambda_capture_specifier] = STATE(6699),
    [sym_fold_expression] = STATE(3026),
    [sym_parameter_pack_expansion] = STATE(3026),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3026),
    [sym_qualified_type_identifier] = STATE(8727),
    [sym_user_defined_literal] = STATE(3026),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(4791),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_AMP] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2153),
    [anon_sym_compl] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4683),
    [anon_sym_sizeof] = ACTIONS(2161),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2165),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [aux_sym_number_literal_token1] = ACTIONS(2171),
    [aux_sym_number_literal_token2] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2175),
    [anon_sym_u_SQUOTE] = ACTIONS(2175),
    [anon_sym_U_SQUOTE] = ACTIONS(2175),
    [anon_sym_u8_SQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [anon_sym_NULL] = ACTIONS(2181),
    [anon_sym_nullptr] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2193),
    [sym_this] = ACTIONS(2179),
  },
  [1966] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5486),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1967] = {
    [sym_primitive_type] = STATE(7608),
    [sym__expression] = STATE(5475),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1968] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5462),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(3876),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(3876),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(3876),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(3876),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1969] = {
    [sym_primitive_type] = STATE(7715),
    [sym__expression] = STATE(5283),
    [sym__expression_not_binary] = STATE(4662),
    [sym__string] = STATE(4662),
    [sym_conditional_expression] = STATE(4662),
    [sym_assignment_expression] = STATE(4662),
    [sym_pointer_expression] = STATE(4324),
    [sym_unary_expression] = STATE(4662),
    [sym_binary_expression] = STATE(4662),
    [sym_update_expression] = STATE(4662),
    [sym_cast_expression] = STATE(4662),
    [sym_sizeof_expression] = STATE(4662),
    [sym_alignof_expression] = STATE(4662),
    [sym_offsetof_expression] = STATE(4662),
    [sym_generic_expression] = STATE(4662),
    [sym_subscript_expression] = STATE(4324),
    [sym_call_expression] = STATE(4324),
    [sym_gnu_asm_expression] = STATE(4662),
    [sym_field_expression] = STATE(4324),
    [sym_compound_literal_expression] = STATE(4662),
    [sym_parenthesized_expression] = STATE(4324),
    [sym_number_literal] = STATE(4983),
    [sym_char_literal] = STATE(4983),
    [sym_concatenated_string] = STATE(4986),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4662),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8468),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4662),
    [sym_raw_string_literal] = STATE(3834),
    [sym_co_await_expression] = STATE(4662),
    [sym_new_expression] = STATE(4662),
    [sym_delete_expression] = STATE(4662),
    [sym_requires_clause] = STATE(4662),
    [sym_requires_expression] = STATE(4662),
    [sym_lambda_expression] = STATE(4662),
    [sym_lambda_capture_specifier] = STATE(6752),
    [sym_fold_expression] = STATE(4662),
    [sym_parameter_pack_expansion] = STATE(4662),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6475),
    [sym_qualified_identifier] = STATE(4324),
    [sym_qualified_type_identifier] = STATE(8468),
    [sym_user_defined_literal] = STATE(4324),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3875),
    [anon_sym_compl] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4039),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1970] = {
    [sym_primitive_type] = STATE(7717),
    [sym__expression] = STATE(4316),
    [sym__expression_not_binary] = STATE(4526),
    [sym__string] = STATE(4526),
    [sym_conditional_expression] = STATE(4526),
    [sym_assignment_expression] = STATE(4526),
    [sym_pointer_expression] = STATE(4035),
    [sym_unary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_cast_expression] = STATE(4526),
    [sym_sizeof_expression] = STATE(4526),
    [sym_alignof_expression] = STATE(4526),
    [sym_offsetof_expression] = STATE(4526),
    [sym_generic_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(4035),
    [sym_call_expression] = STATE(4035),
    [sym_gnu_asm_expression] = STATE(4526),
    [sym_field_expression] = STATE(4035),
    [sym_compound_literal_expression] = STATE(4526),
    [sym_parenthesized_expression] = STATE(4035),
    [sym_number_literal] = STATE(4383),
    [sym_char_literal] = STATE(4383),
    [sym_concatenated_string] = STATE(4398),
    [sym_string_literal] = STATE(3024),
    [sym_null] = STATE(4526),
    [sym_decltype] = STATE(9504),
    [sym__class_name] = STATE(8742),
    [sym_template_type] = STATE(2836),
    [sym_template_function] = STATE(4526),
    [sym_raw_string_literal] = STATE(3025),
    [sym_co_await_expression] = STATE(4526),
    [sym_new_expression] = STATE(4526),
    [sym_delete_expression] = STATE(4526),
    [sym_requires_clause] = STATE(4526),
    [sym_requires_expression] = STATE(4526),
    [sym_lambda_expression] = STATE(4526),
    [sym_lambda_capture_specifier] = STATE(6679),
    [sym_fold_expression] = STATE(4526),
    [sym_parameter_pack_expansion] = STATE(4526),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6471),
    [sym_qualified_identifier] = STATE(4035),
    [sym_qualified_type_identifier] = STATE(8742),
    [sym_user_defined_literal] = STATE(4035),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2015),
    [anon_sym_compl] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2033),
    [anon_sym___alignof] = ACTIONS(2033),
    [anon_sym__alignof] = ACTIONS(2033),
    [anon_sym_alignof] = ACTIONS(2033),
    [anon_sym__Alignof] = ACTIONS(2033),
    [anon_sym_offsetof] = ACTIONS(2035),
    [anon_sym__Generic] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2039),
    [anon_sym___asm__] = ACTIONS(2039),
    [aux_sym_number_literal_token1] = ACTIONS(2041),
    [aux_sym_number_literal_token2] = ACTIONS(2043),
    [anon_sym_L_SQUOTE] = ACTIONS(2045),
    [anon_sym_u_SQUOTE] = ACTIONS(2045),
    [anon_sym_U_SQUOTE] = ACTIONS(2045),
    [anon_sym_u8_SQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_L_DQUOTE] = ACTIONS(2047),
    [anon_sym_u_DQUOTE] = ACTIONS(2047),
    [anon_sym_U_DQUOTE] = ACTIONS(2047),
    [anon_sym_u8_DQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [anon_sym_NULL] = ACTIONS(2051),
    [anon_sym_nullptr] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_R_DQUOTE] = ACTIONS(2057),
    [anon_sym_LR_DQUOTE] = ACTIONS(2057),
    [anon_sym_uR_DQUOTE] = ACTIONS(2057),
    [anon_sym_UR_DQUOTE] = ACTIONS(2057),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2057),
    [anon_sym_co_await] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_requires] = ACTIONS(2063),
    [sym_this] = ACTIONS(2049),
  },
  [1971] = {
    [sym__declaration_modifiers] = STATE(2282),
    [sym__declaration_specifiers] = STATE(4808),
    [sym_attribute_specifier] = STATE(2282),
    [sym_attribute_declaration] = STATE(2282),
    [sym_ms_declspec_modifier] = STATE(2282),
    [sym_ms_call_modifier] = STATE(7057),
    [sym__abstract_declarator] = STATE(7561),
    [sym_abstract_parenthesized_declarator] = STATE(6944),
    [sym_abstract_pointer_declarator] = STATE(6944),
    [sym_abstract_function_declarator] = STATE(6944),
    [sym_abstract_array_declarator] = STATE(6944),
    [sym_storage_class_specifier] = STATE(2282),
    [sym_type_qualifier] = STATE(2282),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_parameter_list] = STATE(4434),
    [sym_parameter_declaration] = STATE(8304),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2282),
    [sym_alignas_specifier] = STATE(2282),
    [sym_dependent_type] = STATE(3087),
    [sym_optional_parameter_declaration] = STATE(8304),
    [sym_variadic_parameter_declaration] = STATE(8304),
    [sym_abstract_reference_declarator] = STATE(6944),
    [sym__function_declarator_seq] = STATE(6967),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7326),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2282),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2067),
    [anon_sym_RPAREN] = ACTIONS(4294),
    [anon_sym_LPAREN2] = ACTIONS(5097),
    [anon_sym_STAR] = ACTIONS(5099),
    [anon_sym_AMP_AMP] = ACTIONS(5101),
    [anon_sym_AMP] = ACTIONS(5103),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5105),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(2091),
    [anon_sym___clrcall] = ACTIONS(2091),
    [anon_sym___stdcall] = ACTIONS(2091),
    [anon_sym___fastcall] = ACTIONS(2091),
    [anon_sym___thiscall] = ACTIONS(2091),
    [anon_sym___vectorcall] = ACTIONS(2091),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(5107),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2023),
    [anon_sym_struct] = ACTIONS(2025),
    [anon_sym_union] = ACTIONS(2027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2053),
    [anon_sym_template] = ACTIONS(1436),
  },
  [1972] = {
    [sym__declaration_modifiers] = STATE(2282),
    [sym__declaration_specifiers] = STATE(4808),
    [sym_attribute_specifier] = STATE(2282),
    [sym_attribute_declaration] = STATE(2282),
    [sym_ms_declspec_modifier] = STATE(2282),
    [sym_ms_call_modifier] = STATE(7050),
    [sym__abstract_declarator] = STATE(7566),
    [sym_abstract_parenthesized_declarator] = STATE(6944),
    [sym_abstract_pointer_declarator] = STATE(6944),
    [sym_abstract_function_declarator] = STATE(6944),
    [sym_abstract_array_declarator] = STATE(6944),
    [sym_storage_class_specifier] = STATE(2282),
    [sym_type_qualifier] = STATE(2282),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_parameter_list] = STATE(4434),
    [sym_parameter_declaration] = STATE(8304),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2282),
    [sym_alignas_specifier] = STATE(2282),
    [sym_dependent_type] = STATE(3087),
    [sym_optional_parameter_declaration] = STATE(8304),
    [sym_variadic_parameter_declaration] = STATE(8304),
    [sym_abstract_reference_declarator] = STATE(6944),
    [sym__function_declarator_seq] = STATE(6967),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7326),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2282),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2067),
    [anon_sym_RPAREN] = ACTIONS(4294),
    [anon_sym_LPAREN2] = ACTIONS(5097),
    [anon_sym_STAR] = ACTIONS(5099),
    [anon_sym_AMP_AMP] = ACTIONS(5101),
    [anon_sym_AMP] = ACTIONS(5103),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5105),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(2091),
    [anon_sym___clrcall] = ACTIONS(2091),
    [anon_sym___stdcall] = ACTIONS(2091),
    [anon_sym___fastcall] = ACTIONS(2091),
    [anon_sym___thiscall] = ACTIONS(2091),
    [anon_sym___vectorcall] = ACTIONS(2091),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(5107),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2023),
    [anon_sym_struct] = ACTIONS(2025),
    [anon_sym_union] = ACTIONS(2027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2053),
    [anon_sym_template] = ACTIONS(1436),
  },
  [1973] = {
    [sym_identifier] = ACTIONS(5109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5111),
    [anon_sym_COMMA] = ACTIONS(5111),
    [anon_sym_RPAREN] = ACTIONS(5111),
    [anon_sym_LPAREN2] = ACTIONS(5111),
    [anon_sym_TILDE] = ACTIONS(5111),
    [anon_sym_DASH] = ACTIONS(5109),
    [anon_sym_PLUS] = ACTIONS(5109),
    [anon_sym_STAR] = ACTIONS(5109),
    [anon_sym_SLASH] = ACTIONS(5109),
    [anon_sym_PERCENT] = ACTIONS(5109),
    [anon_sym_PIPE_PIPE] = ACTIONS(5111),
    [anon_sym_AMP_AMP] = ACTIONS(5111),
    [anon_sym_PIPE] = ACTIONS(5109),
    [anon_sym_CARET] = ACTIONS(5109),
    [anon_sym_AMP] = ACTIONS(5109),
    [anon_sym_EQ_EQ] = ACTIONS(5111),
    [anon_sym_BANG_EQ] = ACTIONS(5111),
    [anon_sym_GT] = ACTIONS(5109),
    [anon_sym_GT_EQ] = ACTIONS(5111),
    [anon_sym_LT_EQ] = ACTIONS(5109),
    [anon_sym_LT] = ACTIONS(5109),
    [anon_sym_LT_LT] = ACTIONS(5109),
    [anon_sym_GT_GT] = ACTIONS(5109),
    [anon_sym_SEMI] = ACTIONS(5111),
    [anon_sym___extension__] = ACTIONS(5109),
    [anon_sym_extern] = ACTIONS(5109),
    [anon_sym___attribute__] = ACTIONS(5109),
    [anon_sym_COLON_COLON] = ACTIONS(5111),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5111),
    [anon_sym___declspec] = ACTIONS(5109),
    [anon_sym___based] = ACTIONS(5109),
    [anon_sym___cdecl] = ACTIONS(5109),
    [anon_sym___clrcall] = ACTIONS(5109),
    [anon_sym___stdcall] = ACTIONS(5109),
    [anon_sym___fastcall] = ACTIONS(5109),
    [anon_sym___thiscall] = ACTIONS(5109),
    [anon_sym___vectorcall] = ACTIONS(5109),
    [anon_sym_LBRACE] = ACTIONS(5111),
    [anon_sym_RBRACE] = ACTIONS(5111),
    [anon_sym_LBRACK] = ACTIONS(5109),
    [anon_sym_EQ] = ACTIONS(5109),
    [anon_sym_static] = ACTIONS(5109),
    [anon_sym_register] = ACTIONS(5109),
    [anon_sym_inline] = ACTIONS(5109),
    [anon_sym___inline] = ACTIONS(5109),
    [anon_sym___inline__] = ACTIONS(5109),
    [anon_sym___forceinline] = ACTIONS(5109),
    [anon_sym_thread_local] = ACTIONS(5109),
    [anon_sym___thread] = ACTIONS(5109),
    [anon_sym_const] = ACTIONS(5109),
    [anon_sym_constexpr] = ACTIONS(5109),
    [anon_sym_volatile] = ACTIONS(5109),
    [anon_sym_restrict] = ACTIONS(5109),
    [anon_sym___restrict__] = ACTIONS(5109),
    [anon_sym__Atomic] = ACTIONS(5109),
    [anon_sym__Noreturn] = ACTIONS(5109),
    [anon_sym_noreturn] = ACTIONS(5109),
    [anon_sym_mutable] = ACTIONS(5109),
    [anon_sym_constinit] = ACTIONS(5109),
    [anon_sym_consteval] = ACTIONS(5109),
    [anon_sym_PROGMEM] = ACTIONS(5109),
    [anon_sym_QMARK] = ACTIONS(5111),
    [anon_sym_STAR_EQ] = ACTIONS(5111),
    [anon_sym_SLASH_EQ] = ACTIONS(5111),
    [anon_sym_PERCENT_EQ] = ACTIONS(5111),
    [anon_sym_PLUS_EQ] = ACTIONS(5111),
    [anon_sym_DASH_EQ] = ACTIONS(5111),
    [anon_sym_LT_LT_EQ] = ACTIONS(5111),
    [anon_sym_GT_GT_EQ] = ACTIONS(5111),
    [anon_sym_AMP_EQ] = ACTIONS(5111),
    [anon_sym_CARET_EQ] = ACTIONS(5111),
    [anon_sym_PIPE_EQ] = ACTIONS(5111),
    [anon_sym_and_eq] = ACTIONS(5109),
    [anon_sym_or_eq] = ACTIONS(5109),
    [anon_sym_xor_eq] = ACTIONS(5109),
    [anon_sym_LT_EQ_GT] = ACTIONS(5111),
    [anon_sym_or] = ACTIONS(5109),
    [anon_sym_and] = ACTIONS(5109),
    [anon_sym_bitor] = ACTIONS(5109),
    [anon_sym_xor] = ACTIONS(5109),
    [anon_sym_bitand] = ACTIONS(5109),
    [anon_sym_not_eq] = ACTIONS(5109),
    [anon_sym_DASH_DASH] = ACTIONS(5111),
    [anon_sym_PLUS_PLUS] = ACTIONS(5111),
    [anon_sym_DOT] = ACTIONS(5109),
    [anon_sym_DOT_STAR] = ACTIONS(5111),
    [anon_sym_DASH_GT] = ACTIONS(5111),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5109),
    [anon_sym_decltype] = ACTIONS(5109),
    [anon_sym_virtual] = ACTIONS(5109),
    [anon_sym_alignas] = ACTIONS(5109),
    [anon_sym_template] = ACTIONS(5109),
    [anon_sym_operator] = ACTIONS(5109),
  },
  [1974] = {
    [sym_identifier] = ACTIONS(5113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5115),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_RPAREN] = ACTIONS(5115),
    [anon_sym_LPAREN2] = ACTIONS(5115),
    [anon_sym_TILDE] = ACTIONS(5115),
    [anon_sym_DASH] = ACTIONS(5113),
    [anon_sym_PLUS] = ACTIONS(5113),
    [anon_sym_STAR] = ACTIONS(5113),
    [anon_sym_SLASH] = ACTIONS(5113),
    [anon_sym_PERCENT] = ACTIONS(5113),
    [anon_sym_PIPE_PIPE] = ACTIONS(5115),
    [anon_sym_AMP_AMP] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(5113),
    [anon_sym_CARET] = ACTIONS(5113),
    [anon_sym_AMP] = ACTIONS(5113),
    [anon_sym_EQ_EQ] = ACTIONS(5115),
    [anon_sym_BANG_EQ] = ACTIONS(5115),
    [anon_sym_GT] = ACTIONS(5113),
    [anon_sym_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_EQ] = ACTIONS(5113),
    [anon_sym_LT] = ACTIONS(5113),
    [anon_sym_LT_LT] = ACTIONS(5113),
    [anon_sym_GT_GT] = ACTIONS(5113),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym___extension__] = ACTIONS(5113),
    [anon_sym_extern] = ACTIONS(5113),
    [anon_sym___attribute__] = ACTIONS(5113),
    [anon_sym_COLON_COLON] = ACTIONS(5115),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5115),
    [anon_sym___declspec] = ACTIONS(5113),
    [anon_sym___based] = ACTIONS(5113),
    [anon_sym___cdecl] = ACTIONS(5113),
    [anon_sym___clrcall] = ACTIONS(5113),
    [anon_sym___stdcall] = ACTIONS(5113),
    [anon_sym___fastcall] = ACTIONS(5113),
    [anon_sym___thiscall] = ACTIONS(5113),
    [anon_sym___vectorcall] = ACTIONS(5113),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_RBRACE] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5113),
    [anon_sym_EQ] = ACTIONS(5113),
    [anon_sym_static] = ACTIONS(5113),
    [anon_sym_register] = ACTIONS(5113),
    [anon_sym_inline] = ACTIONS(5113),
    [anon_sym___inline] = ACTIONS(5113),
    [anon_sym___inline__] = ACTIONS(5113),
    [anon_sym___forceinline] = ACTIONS(5113),
    [anon_sym_thread_local] = ACTIONS(5113),
    [anon_sym___thread] = ACTIONS(5113),
    [anon_sym_const] = ACTIONS(5113),
    [anon_sym_constexpr] = ACTIONS(5113),
    [anon_sym_volatile] = ACTIONS(5113),
    [anon_sym_restrict] = ACTIONS(5113),
    [anon_sym___restrict__] = ACTIONS(5113),
    [anon_sym__Atomic] = ACTIONS(5113),
    [anon_sym__Noreturn] = ACTIONS(5113),
    [anon_sym_noreturn] = ACTIONS(5113),
    [anon_sym_mutable] = ACTIONS(5113),
    [anon_sym_constinit] = ACTIONS(5113),
    [anon_sym_consteval] = ACTIONS(5113),
    [anon_sym_PROGMEM] = ACTIONS(5113),
    [anon_sym_QMARK] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_and_eq] = ACTIONS(5113),
    [anon_sym_or_eq] = ACTIONS(5113),
    [anon_sym_xor_eq] = ACTIONS(5113),
    [anon_sym_LT_EQ_GT] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5113),
    [anon_sym_and] = ACTIONS(5113),
    [anon_sym_bitor] = ACTIONS(5113),
    [anon_sym_xor] = ACTIONS(5113),
    [anon_sym_bitand] = ACTIONS(5113),
    [anon_sym_not_eq] = ACTIONS(5113),
    [anon_sym_DASH_DASH] = ACTIONS(5115),
    [anon_sym_PLUS_PLUS] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(5113),
    [anon_sym_DOT_STAR] = ACTIONS(5115),
    [anon_sym_DASH_GT] = ACTIONS(5115),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5113),
    [anon_sym_decltype] = ACTIONS(5113),
    [anon_sym_virtual] = ACTIONS(5113),
    [anon_sym_alignas] = ACTIONS(5113),
    [anon_sym_template] = ACTIONS(5113),
    [anon_sym_operator] = ACTIONS(5113),
  },
  [1975] = {
    [sym_identifier] = ACTIONS(5117),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(5119),
    [anon_sym_RPAREN] = ACTIONS(5119),
    [anon_sym_LPAREN2] = ACTIONS(5119),
    [anon_sym_TILDE] = ACTIONS(5119),
    [anon_sym_DASH] = ACTIONS(5117),
    [anon_sym_PLUS] = ACTIONS(5117),
    [anon_sym_STAR] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5117),
    [anon_sym_PERCENT] = ACTIONS(5117),
    [anon_sym_PIPE_PIPE] = ACTIONS(5119),
    [anon_sym_AMP_AMP] = ACTIONS(5119),
    [anon_sym_PIPE] = ACTIONS(5117),
    [anon_sym_CARET] = ACTIONS(5117),
    [anon_sym_AMP] = ACTIONS(5117),
    [anon_sym_EQ_EQ] = ACTIONS(5119),
    [anon_sym_BANG_EQ] = ACTIONS(5119),
    [anon_sym_GT] = ACTIONS(5117),
    [anon_sym_GT_EQ] = ACTIONS(5119),
    [anon_sym_LT_EQ] = ACTIONS(5117),
    [anon_sym_LT] = ACTIONS(5117),
    [anon_sym_LT_LT] = ACTIONS(5117),
    [anon_sym_GT_GT] = ACTIONS(5117),
    [anon_sym_SEMI] = ACTIONS(5119),
    [anon_sym___extension__] = ACTIONS(5117),
    [anon_sym_extern] = ACTIONS(5117),
    [anon_sym___attribute__] = ACTIONS(5117),
    [anon_sym_COLON_COLON] = ACTIONS(5119),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5119),
    [anon_sym___declspec] = ACTIONS(5117),
    [anon_sym___based] = ACTIONS(5117),
    [anon_sym___cdecl] = ACTIONS(5117),
    [anon_sym___clrcall] = ACTIONS(5117),
    [anon_sym___stdcall] = ACTIONS(5117),
    [anon_sym___fastcall] = ACTIONS(5117),
    [anon_sym___thiscall] = ACTIONS(5117),
    [anon_sym___vectorcall] = ACTIONS(5117),
    [anon_sym_LBRACE] = ACTIONS(5119),
    [anon_sym_RBRACE] = ACTIONS(5119),
    [anon_sym_LBRACK] = ACTIONS(5117),
    [anon_sym_EQ] = ACTIONS(5117),
    [anon_sym_static] = ACTIONS(5117),
    [anon_sym_register] = ACTIONS(5117),
    [anon_sym_inline] = ACTIONS(5117),
    [anon_sym___inline] = ACTIONS(5117),
    [anon_sym___inline__] = ACTIONS(5117),
    [anon_sym___forceinline] = ACTIONS(5117),
    [anon_sym_thread_local] = ACTIONS(5117),
    [anon_sym___thread] = ACTIONS(5117),
    [anon_sym_const] = ACTIONS(5117),
    [anon_sym_constexpr] = ACTIONS(5117),
    [anon_sym_volatile] = ACTIONS(5117),
    [anon_sym_restrict] = ACTIONS(5117),
    [anon_sym___restrict__] = ACTIONS(5117),
    [anon_sym__Atomic] = ACTIONS(5117),
    [anon_sym__Noreturn] = ACTIONS(5117),
    [anon_sym_noreturn] = ACTIONS(5117),
    [anon_sym_mutable] = ACTIONS(5117),
    [anon_sym_constinit] = ACTIONS(5117),
    [anon_sym_consteval] = ACTIONS(5117),
    [anon_sym_PROGMEM] = ACTIONS(5117),
    [anon_sym_QMARK] = ACTIONS(5119),
    [anon_sym_STAR_EQ] = ACTIONS(5119),
    [anon_sym_SLASH_EQ] = ACTIONS(5119),
    [anon_sym_PERCENT_EQ] = ACTIONS(5119),
    [anon_sym_PLUS_EQ] = ACTIONS(5119),
    [anon_sym_DASH_EQ] = ACTIONS(5119),
    [anon_sym_LT_LT_EQ] = ACTIONS(5119),
    [anon_sym_GT_GT_EQ] = ACTIONS(5119),
    [anon_sym_AMP_EQ] = ACTIONS(5119),
    [anon_sym_CARET_EQ] = ACTIONS(5119),
    [anon_sym_PIPE_EQ] = ACTIONS(5119),
    [anon_sym_and_eq] = ACTIONS(5117),
    [anon_sym_or_eq] = ACTIONS(5117),
    [anon_sym_xor_eq] = ACTIONS(5117),
    [anon_sym_LT_EQ_GT] = ACTIONS(5119),
    [anon_sym_or] = ACTIONS(5117),
    [anon_sym_and] = ACTIONS(5117),
    [anon_sym_bitor] = ACTIONS(5117),
    [anon_sym_xor] = ACTIONS(5117),
    [anon_sym_bitand] = ACTIONS(5117),
    [anon_sym_not_eq] = ACTIONS(5117),
    [anon_sym_DASH_DASH] = ACTIONS(5119),
    [anon_sym_PLUS_PLUS] = ACTIONS(5119),
    [anon_sym_DOT] = ACTIONS(5117),
    [anon_sym_DOT_STAR] = ACTIONS(5119),
    [anon_sym_DASH_GT] = ACTIONS(5119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5117),
    [anon_sym_decltype] = ACTIONS(5117),
    [anon_sym_virtual] = ACTIONS(5117),
    [anon_sym_alignas] = ACTIONS(5117),
    [anon_sym_template] = ACTIONS(5117),
    [anon_sym_operator] = ACTIONS(5117),
  },
  [1976] = {
    [sym_identifier] = ACTIONS(5121),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5123),
    [anon_sym_COMMA] = ACTIONS(5123),
    [anon_sym_RPAREN] = ACTIONS(5123),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_TILDE] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5121),
    [anon_sym_PLUS] = ACTIONS(5121),
    [anon_sym_STAR] = ACTIONS(5121),
    [anon_sym_SLASH] = ACTIONS(5121),
    [anon_sym_PERCENT] = ACTIONS(5121),
    [anon_sym_PIPE_PIPE] = ACTIONS(5123),
    [anon_sym_AMP_AMP] = ACTIONS(5123),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_CARET] = ACTIONS(5121),
    [anon_sym_AMP] = ACTIONS(5121),
    [anon_sym_EQ_EQ] = ACTIONS(5123),
    [anon_sym_BANG_EQ] = ACTIONS(5123),
    [anon_sym_GT] = ACTIONS(5121),
    [anon_sym_GT_EQ] = ACTIONS(5123),
    [anon_sym_LT_EQ] = ACTIONS(5121),
    [anon_sym_LT] = ACTIONS(5121),
    [anon_sym_LT_LT] = ACTIONS(5121),
    [anon_sym_GT_GT] = ACTIONS(5121),
    [anon_sym_SEMI] = ACTIONS(5123),
    [anon_sym___extension__] = ACTIONS(5121),
    [anon_sym_extern] = ACTIONS(5121),
    [anon_sym___attribute__] = ACTIONS(5121),
    [anon_sym_COLON_COLON] = ACTIONS(5123),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5123),
    [anon_sym___declspec] = ACTIONS(5121),
    [anon_sym___based] = ACTIONS(5121),
    [anon_sym___cdecl] = ACTIONS(5121),
    [anon_sym___clrcall] = ACTIONS(5121),
    [anon_sym___stdcall] = ACTIONS(5121),
    [anon_sym___fastcall] = ACTIONS(5121),
    [anon_sym___thiscall] = ACTIONS(5121),
    [anon_sym___vectorcall] = ACTIONS(5121),
    [anon_sym_LBRACE] = ACTIONS(5123),
    [anon_sym_RBRACE] = ACTIONS(5123),
    [anon_sym_LBRACK] = ACTIONS(5121),
    [anon_sym_EQ] = ACTIONS(5121),
    [anon_sym_static] = ACTIONS(5121),
    [anon_sym_register] = ACTIONS(5121),
    [anon_sym_inline] = ACTIONS(5121),
    [anon_sym___inline] = ACTIONS(5121),
    [anon_sym___inline__] = ACTIONS(5121),
    [anon_sym___forceinline] = ACTIONS(5121),
    [anon_sym_thread_local] = ACTIONS(5121),
    [anon_sym___thread] = ACTIONS(5121),
    [anon_sym_const] = ACTIONS(5121),
    [anon_sym_constexpr] = ACTIONS(5121),
    [anon_sym_volatile] = ACTIONS(5121),
    [anon_sym_restrict] = ACTIONS(5121),
    [anon_sym___restrict__] = ACTIONS(5121),
    [anon_sym__Atomic] = ACTIONS(5121),
    [anon_sym__Noreturn] = ACTIONS(5121),
    [anon_sym_noreturn] = ACTIONS(5121),
    [anon_sym_mutable] = ACTIONS(5121),
    [anon_sym_constinit] = ACTIONS(5121),
    [anon_sym_consteval] = ACTIONS(5121),
    [anon_sym_PROGMEM] = ACTIONS(5121),
    [anon_sym_QMARK] = ACTIONS(5123),
    [anon_sym_STAR_EQ] = ACTIONS(5123),
    [anon_sym_SLASH_EQ] = ACTIONS(5123),
    [anon_sym_PERCENT_EQ] = ACTIONS(5123),
    [anon_sym_PLUS_EQ] = ACTIONS(5123),
    [anon_sym_DASH_EQ] = ACTIONS(5123),
    [anon_sym_LT_LT_EQ] = ACTIONS(5123),
    [anon_sym_GT_GT_EQ] = ACTIONS(5123),
    [anon_sym_AMP_EQ] = ACTIONS(5123),
    [anon_sym_CARET_EQ] = ACTIONS(5123),
    [anon_sym_PIPE_EQ] = ACTIONS(5123),
    [anon_sym_and_eq] = ACTIONS(5121),
    [anon_sym_or_eq] = ACTIONS(5121),
    [anon_sym_xor_eq] = ACTIONS(5121),
    [anon_sym_LT_EQ_GT] = ACTIONS(5123),
    [anon_sym_or] = ACTIONS(5121),
    [anon_sym_and] = ACTIONS(5121),
    [anon_sym_bitor] = ACTIONS(5121),
    [anon_sym_xor] = ACTIONS(5121),
    [anon_sym_bitand] = ACTIONS(5121),
    [anon_sym_not_eq] = ACTIONS(5121),
    [anon_sym_DASH_DASH] = ACTIONS(5123),
    [anon_sym_PLUS_PLUS] = ACTIONS(5123),
    [anon_sym_DOT] = ACTIONS(5121),
    [anon_sym_DOT_STAR] = ACTIONS(5123),
    [anon_sym_DASH_GT] = ACTIONS(5123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5121),
    [anon_sym_decltype] = ACTIONS(5121),
    [anon_sym_virtual] = ACTIONS(5121),
    [anon_sym_alignas] = ACTIONS(5121),
    [anon_sym_template] = ACTIONS(5121),
    [anon_sym_operator] = ACTIONS(5121),
  },
  [1977] = {
    [sym_identifier] = ACTIONS(5125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5127),
    [anon_sym_COMMA] = ACTIONS(5127),
    [anon_sym_RPAREN] = ACTIONS(5127),
    [anon_sym_LPAREN2] = ACTIONS(5127),
    [anon_sym_TILDE] = ACTIONS(5127),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_PLUS] = ACTIONS(5125),
    [anon_sym_STAR] = ACTIONS(5125),
    [anon_sym_SLASH] = ACTIONS(5125),
    [anon_sym_PERCENT] = ACTIONS(5125),
    [anon_sym_PIPE_PIPE] = ACTIONS(5127),
    [anon_sym_AMP_AMP] = ACTIONS(5127),
    [anon_sym_PIPE] = ACTIONS(5125),
    [anon_sym_CARET] = ACTIONS(5125),
    [anon_sym_AMP] = ACTIONS(5125),
    [anon_sym_EQ_EQ] = ACTIONS(5127),
    [anon_sym_BANG_EQ] = ACTIONS(5127),
    [anon_sym_GT] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5127),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_LT] = ACTIONS(5125),
    [anon_sym_LT_LT] = ACTIONS(5125),
    [anon_sym_GT_GT] = ACTIONS(5125),
    [anon_sym_SEMI] = ACTIONS(5127),
    [anon_sym___extension__] = ACTIONS(5125),
    [anon_sym_extern] = ACTIONS(5125),
    [anon_sym___attribute__] = ACTIONS(5125),
    [anon_sym_COLON_COLON] = ACTIONS(5127),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5127),
    [anon_sym___declspec] = ACTIONS(5125),
    [anon_sym___based] = ACTIONS(5125),
    [anon_sym___cdecl] = ACTIONS(5125),
    [anon_sym___clrcall] = ACTIONS(5125),
    [anon_sym___stdcall] = ACTIONS(5125),
    [anon_sym___fastcall] = ACTIONS(5125),
    [anon_sym___thiscall] = ACTIONS(5125),
    [anon_sym___vectorcall] = ACTIONS(5125),
    [anon_sym_LBRACE] = ACTIONS(5127),
    [anon_sym_RBRACE] = ACTIONS(5127),
    [anon_sym_LBRACK] = ACTIONS(5125),
    [anon_sym_EQ] = ACTIONS(5125),
    [anon_sym_static] = ACTIONS(5125),
    [anon_sym_register] = ACTIONS(5125),
    [anon_sym_inline] = ACTIONS(5125),
    [anon_sym___inline] = ACTIONS(5125),
    [anon_sym___inline__] = ACTIONS(5125),
    [anon_sym___forceinline] = ACTIONS(5125),
    [anon_sym_thread_local] = ACTIONS(5125),
    [anon_sym___thread] = ACTIONS(5125),
    [anon_sym_const] = ACTIONS(5125),
    [anon_sym_constexpr] = ACTIONS(5125),
    [anon_sym_volatile] = ACTIONS(5125),
    [anon_sym_restrict] = ACTIONS(5125),
    [anon_sym___restrict__] = ACTIONS(5125),
    [anon_sym__Atomic] = ACTIONS(5125),
    [anon_sym__Noreturn] = ACTIONS(5125),
    [anon_sym_noreturn] = ACTIONS(5125),
    [anon_sym_mutable] = ACTIONS(5125),
    [anon_sym_constinit] = ACTIONS(5125),
    [anon_sym_consteval] = ACTIONS(5125),
    [anon_sym_PROGMEM] = ACTIONS(5125),
    [anon_sym_QMARK] = ACTIONS(5127),
    [anon_sym_STAR_EQ] = ACTIONS(5127),
    [anon_sym_SLASH_EQ] = ACTIONS(5127),
    [anon_sym_PERCENT_EQ] = ACTIONS(5127),
    [anon_sym_PLUS_EQ] = ACTIONS(5127),
    [anon_sym_DASH_EQ] = ACTIONS(5127),
    [anon_sym_LT_LT_EQ] = ACTIONS(5127),
    [anon_sym_GT_GT_EQ] = ACTIONS(5127),
    [anon_sym_AMP_EQ] = ACTIONS(5127),
    [anon_sym_CARET_EQ] = ACTIONS(5127),
    [anon_sym_PIPE_EQ] = ACTIONS(5127),
    [anon_sym_and_eq] = ACTIONS(5125),
    [anon_sym_or_eq] = ACTIONS(5125),
    [anon_sym_xor_eq] = ACTIONS(5125),
    [anon_sym_LT_EQ_GT] = ACTIONS(5127),
    [anon_sym_or] = ACTIONS(5125),
    [anon_sym_and] = ACTIONS(5125),
    [anon_sym_bitor] = ACTIONS(5125),
    [anon_sym_xor] = ACTIONS(5125),
    [anon_sym_bitand] = ACTIONS(5125),
    [anon_sym_not_eq] = ACTIONS(5125),
    [anon_sym_DASH_DASH] = ACTIONS(5127),
    [anon_sym_PLUS_PLUS] = ACTIONS(5127),
    [anon_sym_DOT] = ACTIONS(5125),
    [anon_sym_DOT_STAR] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5127),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5125),
    [anon_sym_decltype] = ACTIONS(5125),
    [anon_sym_virtual] = ACTIONS(5125),
    [anon_sym_alignas] = ACTIONS(5125),
    [anon_sym_template] = ACTIONS(5125),
    [anon_sym_operator] = ACTIONS(5125),
  },
  [1978] = {
    [sym_template_argument_list] = STATE(1983),
    [sym_identifier] = ACTIONS(5129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5131),
    [anon_sym_COMMA] = ACTIONS(5131),
    [anon_sym_LPAREN2] = ACTIONS(5133),
    [anon_sym_TILDE] = ACTIONS(5136),
    [anon_sym_DASH] = ACTIONS(5138),
    [anon_sym_PLUS] = ACTIONS(5138),
    [anon_sym_STAR] = ACTIONS(5140),
    [anon_sym_SLASH] = ACTIONS(5138),
    [anon_sym_PERCENT] = ACTIONS(5138),
    [anon_sym_PIPE_PIPE] = ACTIONS(5131),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5138),
    [anon_sym_CARET] = ACTIONS(5138),
    [anon_sym_AMP] = ACTIONS(5140),
    [anon_sym_EQ_EQ] = ACTIONS(5131),
    [anon_sym_BANG_EQ] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5138),
    [anon_sym_GT_EQ] = ACTIONS(5131),
    [anon_sym_LT_EQ] = ACTIONS(5138),
    [anon_sym_LT] = ACTIONS(5143),
    [anon_sym_LT_LT] = ACTIONS(5138),
    [anon_sym_GT_GT] = ACTIONS(5138),
    [anon_sym_SEMI] = ACTIONS(5133),
    [anon_sym___extension__] = ACTIONS(5129),
    [anon_sym_extern] = ACTIONS(5129),
    [anon_sym___attribute__] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5133),
    [anon_sym___declspec] = ACTIONS(5129),
    [anon_sym___based] = ACTIONS(5129),
    [anon_sym___cdecl] = ACTIONS(5129),
    [anon_sym___clrcall] = ACTIONS(5129),
    [anon_sym___stdcall] = ACTIONS(5129),
    [anon_sym___fastcall] = ACTIONS(5129),
    [anon_sym___thiscall] = ACTIONS(5129),
    [anon_sym___vectorcall] = ACTIONS(5129),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_RBRACE] = ACTIONS(5131),
    [anon_sym_LBRACK] = ACTIONS(5140),
    [anon_sym_EQ] = ACTIONS(5138),
    [anon_sym_static] = ACTIONS(5129),
    [anon_sym_register] = ACTIONS(5129),
    [anon_sym_inline] = ACTIONS(5129),
    [anon_sym___inline] = ACTIONS(5129),
    [anon_sym___inline__] = ACTIONS(5129),
    [anon_sym___forceinline] = ACTIONS(5129),
    [anon_sym_thread_local] = ACTIONS(5129),
    [anon_sym___thread] = ACTIONS(5129),
    [anon_sym_const] = ACTIONS(5129),
    [anon_sym_constexpr] = ACTIONS(5129),
    [anon_sym_volatile] = ACTIONS(5129),
    [anon_sym_restrict] = ACTIONS(5129),
    [anon_sym___restrict__] = ACTIONS(5129),
    [anon_sym__Atomic] = ACTIONS(5129),
    [anon_sym__Noreturn] = ACTIONS(5129),
    [anon_sym_noreturn] = ACTIONS(5129),
    [anon_sym_mutable] = ACTIONS(5129),
    [anon_sym_constinit] = ACTIONS(5129),
    [anon_sym_consteval] = ACTIONS(5129),
    [anon_sym_PROGMEM] = ACTIONS(5129),
    [anon_sym_QMARK] = ACTIONS(5131),
    [anon_sym_STAR_EQ] = ACTIONS(5131),
    [anon_sym_SLASH_EQ] = ACTIONS(5131),
    [anon_sym_PERCENT_EQ] = ACTIONS(5131),
    [anon_sym_PLUS_EQ] = ACTIONS(5131),
    [anon_sym_DASH_EQ] = ACTIONS(5131),
    [anon_sym_LT_LT_EQ] = ACTIONS(5131),
    [anon_sym_GT_GT_EQ] = ACTIONS(5131),
    [anon_sym_AMP_EQ] = ACTIONS(5131),
    [anon_sym_CARET_EQ] = ACTIONS(5131),
    [anon_sym_PIPE_EQ] = ACTIONS(5131),
    [anon_sym_and_eq] = ACTIONS(5138),
    [anon_sym_or_eq] = ACTIONS(5138),
    [anon_sym_xor_eq] = ACTIONS(5138),
    [anon_sym_LT_EQ_GT] = ACTIONS(5131),
    [anon_sym_or] = ACTIONS(5138),
    [anon_sym_and] = ACTIONS(5138),
    [anon_sym_bitor] = ACTIONS(5138),
    [anon_sym_xor] = ACTIONS(5138),
    [anon_sym_bitand] = ACTIONS(5138),
    [anon_sym_not_eq] = ACTIONS(5138),
    [anon_sym_DASH_DASH] = ACTIONS(5131),
    [anon_sym_PLUS_PLUS] = ACTIONS(5131),
    [anon_sym_DOT] = ACTIONS(5138),
    [anon_sym_DOT_STAR] = ACTIONS(5131),
    [anon_sym_DASH_GT] = ACTIONS(5131),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5129),
    [anon_sym_decltype] = ACTIONS(5129),
    [anon_sym_virtual] = ACTIONS(5129),
    [anon_sym_alignas] = ACTIONS(5129),
    [anon_sym_template] = ACTIONS(5129),
    [anon_sym_operator] = ACTIONS(5129),
  },
  [1979] = {
    [sym_identifier] = ACTIONS(5146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5148),
    [anon_sym_COMMA] = ACTIONS(5148),
    [anon_sym_RPAREN] = ACTIONS(5148),
    [anon_sym_LPAREN2] = ACTIONS(5148),
    [anon_sym_TILDE] = ACTIONS(5148),
    [anon_sym_DASH] = ACTIONS(5146),
    [anon_sym_PLUS] = ACTIONS(5146),
    [anon_sym_STAR] = ACTIONS(5146),
    [anon_sym_SLASH] = ACTIONS(5146),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [anon_sym_PIPE_PIPE] = ACTIONS(5148),
    [anon_sym_AMP_AMP] = ACTIONS(5148),
    [anon_sym_PIPE] = ACTIONS(5146),
    [anon_sym_CARET] = ACTIONS(5146),
    [anon_sym_AMP] = ACTIONS(5146),
    [anon_sym_EQ_EQ] = ACTIONS(5148),
    [anon_sym_BANG_EQ] = ACTIONS(5148),
    [anon_sym_GT] = ACTIONS(5146),
    [anon_sym_GT_EQ] = ACTIONS(5148),
    [anon_sym_LT_EQ] = ACTIONS(5146),
    [anon_sym_LT] = ACTIONS(5146),
    [anon_sym_LT_LT] = ACTIONS(5146),
    [anon_sym_GT_GT] = ACTIONS(5146),
    [anon_sym_SEMI] = ACTIONS(5148),
    [anon_sym___extension__] = ACTIONS(5146),
    [anon_sym_extern] = ACTIONS(5146),
    [anon_sym___attribute__] = ACTIONS(5146),
    [anon_sym_COLON_COLON] = ACTIONS(5148),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5148),
    [anon_sym___declspec] = ACTIONS(5146),
    [anon_sym___based] = ACTIONS(5146),
    [anon_sym___cdecl] = ACTIONS(5146),
    [anon_sym___clrcall] = ACTIONS(5146),
    [anon_sym___stdcall] = ACTIONS(5146),
    [anon_sym___fastcall] = ACTIONS(5146),
    [anon_sym___thiscall] = ACTIONS(5146),
    [anon_sym___vectorcall] = ACTIONS(5146),
    [anon_sym_LBRACE] = ACTIONS(5148),
    [anon_sym_RBRACE] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5146),
    [anon_sym_EQ] = ACTIONS(5146),
    [anon_sym_static] = ACTIONS(5146),
    [anon_sym_register] = ACTIONS(5146),
    [anon_sym_inline] = ACTIONS(5146),
    [anon_sym___inline] = ACTIONS(5146),
    [anon_sym___inline__] = ACTIONS(5146),
    [anon_sym___forceinline] = ACTIONS(5146),
    [anon_sym_thread_local] = ACTIONS(5146),
    [anon_sym___thread] = ACTIONS(5146),
    [anon_sym_const] = ACTIONS(5146),
    [anon_sym_constexpr] = ACTIONS(5146),
    [anon_sym_volatile] = ACTIONS(5146),
    [anon_sym_restrict] = ACTIONS(5146),
    [anon_sym___restrict__] = ACTIONS(5146),
    [anon_sym__Atomic] = ACTIONS(5146),
    [anon_sym__Noreturn] = ACTIONS(5146),
    [anon_sym_noreturn] = ACTIONS(5146),
    [anon_sym_mutable] = ACTIONS(5146),
    [anon_sym_constinit] = ACTIONS(5146),
    [anon_sym_consteval] = ACTIONS(5146),
    [anon_sym_PROGMEM] = ACTIONS(5146),
    [anon_sym_QMARK] = ACTIONS(5148),
    [anon_sym_STAR_EQ] = ACTIONS(5148),
    [anon_sym_SLASH_EQ] = ACTIONS(5148),
    [anon_sym_PERCENT_EQ] = ACTIONS(5148),
    [anon_sym_PLUS_EQ] = ACTIONS(5148),
    [anon_sym_DASH_EQ] = ACTIONS(5148),
    [anon_sym_LT_LT_EQ] = ACTIONS(5148),
    [anon_sym_GT_GT_EQ] = ACTIONS(5148),
    [anon_sym_AMP_EQ] = ACTIONS(5148),
    [anon_sym_CARET_EQ] = ACTIONS(5148),
    [anon_sym_PIPE_EQ] = ACTIONS(5148),
    [anon_sym_and_eq] = ACTIONS(5146),
    [anon_sym_or_eq] = ACTIONS(5146),
    [anon_sym_xor_eq] = ACTIONS(5146),
    [anon_sym_LT_EQ_GT] = ACTIONS(5148),
    [anon_sym_or] = ACTIONS(5146),
    [anon_sym_and] = ACTIONS(5146),
    [anon_sym_bitor] = ACTIONS(5146),
    [anon_sym_xor] = ACTIONS(5146),
    [anon_sym_bitand] = ACTIONS(5146),
    [anon_sym_not_eq] = ACTIONS(5146),
    [anon_sym_DASH_DASH] = ACTIONS(5148),
    [anon_sym_PLUS_PLUS] = ACTIONS(5148),
    [anon_sym_DOT] = ACTIONS(5146),
    [anon_sym_DOT_STAR] = ACTIONS(5148),
    [anon_sym_DASH_GT] = ACTIONS(5148),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5146),
    [anon_sym_decltype] = ACTIONS(5146),
    [anon_sym_virtual] = ACTIONS(5146),
    [anon_sym_alignas] = ACTIONS(5146),
    [anon_sym_template] = ACTIONS(5146),
    [anon_sym_operator] = ACTIONS(5146),
  },
  [1980] = {
    [sym_identifier] = ACTIONS(5150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5152),
    [anon_sym_COMMA] = ACTIONS(5152),
    [anon_sym_RPAREN] = ACTIONS(5152),
    [anon_sym_LPAREN2] = ACTIONS(5152),
    [anon_sym_TILDE] = ACTIONS(5152),
    [anon_sym_DASH] = ACTIONS(5150),
    [anon_sym_PLUS] = ACTIONS(5150),
    [anon_sym_STAR] = ACTIONS(5150),
    [anon_sym_SLASH] = ACTIONS(5150),
    [anon_sym_PERCENT] = ACTIONS(5150),
    [anon_sym_PIPE_PIPE] = ACTIONS(5152),
    [anon_sym_AMP_AMP] = ACTIONS(5152),
    [anon_sym_PIPE] = ACTIONS(5150),
    [anon_sym_CARET] = ACTIONS(5150),
    [anon_sym_AMP] = ACTIONS(5150),
    [anon_sym_EQ_EQ] = ACTIONS(5152),
    [anon_sym_BANG_EQ] = ACTIONS(5152),
    [anon_sym_GT] = ACTIONS(5150),
    [anon_sym_GT_EQ] = ACTIONS(5152),
    [anon_sym_LT_EQ] = ACTIONS(5150),
    [anon_sym_LT] = ACTIONS(5150),
    [anon_sym_LT_LT] = ACTIONS(5150),
    [anon_sym_GT_GT] = ACTIONS(5150),
    [anon_sym_SEMI] = ACTIONS(5152),
    [anon_sym___extension__] = ACTIONS(5150),
    [anon_sym_extern] = ACTIONS(5150),
    [anon_sym___attribute__] = ACTIONS(5150),
    [anon_sym_COLON_COLON] = ACTIONS(5152),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5152),
    [anon_sym___declspec] = ACTIONS(5150),
    [anon_sym___based] = ACTIONS(5150),
    [anon_sym___cdecl] = ACTIONS(5150),
    [anon_sym___clrcall] = ACTIONS(5150),
    [anon_sym___stdcall] = ACTIONS(5150),
    [anon_sym___fastcall] = ACTIONS(5150),
    [anon_sym___thiscall] = ACTIONS(5150),
    [anon_sym___vectorcall] = ACTIONS(5150),
    [anon_sym_LBRACE] = ACTIONS(5152),
    [anon_sym_RBRACE] = ACTIONS(5152),
    [anon_sym_LBRACK] = ACTIONS(5150),
    [anon_sym_EQ] = ACTIONS(5150),
    [anon_sym_static] = ACTIONS(5150),
    [anon_sym_register] = ACTIONS(5150),
    [anon_sym_inline] = ACTIONS(5150),
    [anon_sym___inline] = ACTIONS(5150),
    [anon_sym___inline__] = ACTIONS(5150),
    [anon_sym___forceinline] = ACTIONS(5150),
    [anon_sym_thread_local] = ACTIONS(5150),
    [anon_sym___thread] = ACTIONS(5150),
    [anon_sym_const] = ACTIONS(5150),
    [anon_sym_constexpr] = ACTIONS(5150),
    [anon_sym_volatile] = ACTIONS(5150),
    [anon_sym_restrict] = ACTIONS(5150),
    [anon_sym___restrict__] = ACTIONS(5150),
    [anon_sym__Atomic] = ACTIONS(5150),
    [anon_sym__Noreturn] = ACTIONS(5150),
    [anon_sym_noreturn] = ACTIONS(5150),
    [anon_sym_mutable] = ACTIONS(5150),
    [anon_sym_constinit] = ACTIONS(5150),
    [anon_sym_consteval] = ACTIONS(5150),
    [anon_sym_PROGMEM] = ACTIONS(5150),
    [anon_sym_QMARK] = ACTIONS(5152),
    [anon_sym_STAR_EQ] = ACTIONS(5152),
    [anon_sym_SLASH_EQ] = ACTIONS(5152),
    [anon_sym_PERCENT_EQ] = ACTIONS(5152),
    [anon_sym_PLUS_EQ] = ACTIONS(5152),
    [anon_sym_DASH_EQ] = ACTIONS(5152),
    [anon_sym_LT_LT_EQ] = ACTIONS(5152),
    [anon_sym_GT_GT_EQ] = ACTIONS(5152),
    [anon_sym_AMP_EQ] = ACTIONS(5152),
    [anon_sym_CARET_EQ] = ACTIONS(5152),
    [anon_sym_PIPE_EQ] = ACTIONS(5152),
    [anon_sym_and_eq] = ACTIONS(5150),
    [anon_sym_or_eq] = ACTIONS(5150),
    [anon_sym_xor_eq] = ACTIONS(5150),
    [anon_sym_LT_EQ_GT] = ACTIONS(5152),
    [anon_sym_or] = ACTIONS(5150),
    [anon_sym_and] = ACTIONS(5150),
    [anon_sym_bitor] = ACTIONS(5150),
    [anon_sym_xor] = ACTIONS(5150),
    [anon_sym_bitand] = ACTIONS(5150),
    [anon_sym_not_eq] = ACTIONS(5150),
    [anon_sym_DASH_DASH] = ACTIONS(5152),
    [anon_sym_PLUS_PLUS] = ACTIONS(5152),
    [anon_sym_DOT] = ACTIONS(5150),
    [anon_sym_DOT_STAR] = ACTIONS(5152),
    [anon_sym_DASH_GT] = ACTIONS(5152),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5150),
    [anon_sym_decltype] = ACTIONS(5150),
    [anon_sym_virtual] = ACTIONS(5150),
    [anon_sym_alignas] = ACTIONS(5150),
    [anon_sym_template] = ACTIONS(5150),
    [anon_sym_operator] = ACTIONS(5150),
  },
  [1981] = {
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(6032),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7416),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7008),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_parameter_list] = STATE(1111),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(5006),
    [sym_template_function] = STATE(7008),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6482),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_operator_name] = STATE(7008),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5154),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym_LT] = ACTIONS(5156),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5158),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(2137),
  },
  [1982] = {
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5988),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7423),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7008),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_parameter_list] = STATE(1112),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(5006),
    [sym_template_function] = STATE(7008),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6482),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_operator_name] = STATE(7008),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5154),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym_LT] = ACTIONS(5156),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5158),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(2137),
  },
  [1983] = {
    [sym_identifier] = ACTIONS(5160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5162),
    [anon_sym_COMMA] = ACTIONS(5162),
    [anon_sym_LPAREN2] = ACTIONS(5164),
    [anon_sym_TILDE] = ACTIONS(5167),
    [anon_sym_DASH] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5169),
    [anon_sym_STAR] = ACTIONS(5171),
    [anon_sym_SLASH] = ACTIONS(5169),
    [anon_sym_PERCENT] = ACTIONS(5169),
    [anon_sym_PIPE_PIPE] = ACTIONS(5162),
    [anon_sym_AMP_AMP] = ACTIONS(5164),
    [anon_sym_PIPE] = ACTIONS(5169),
    [anon_sym_CARET] = ACTIONS(5169),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_EQ] = ACTIONS(5162),
    [anon_sym_GT] = ACTIONS(5169),
    [anon_sym_GT_EQ] = ACTIONS(5162),
    [anon_sym_LT_EQ] = ACTIONS(5169),
    [anon_sym_LT] = ACTIONS(5169),
    [anon_sym_LT_LT] = ACTIONS(5169),
    [anon_sym_GT_GT] = ACTIONS(5169),
    [anon_sym_SEMI] = ACTIONS(5164),
    [anon_sym___extension__] = ACTIONS(5160),
    [anon_sym_extern] = ACTIONS(5160),
    [anon_sym___attribute__] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5164),
    [anon_sym___declspec] = ACTIONS(5160),
    [anon_sym___based] = ACTIONS(5160),
    [anon_sym___cdecl] = ACTIONS(5160),
    [anon_sym___clrcall] = ACTIONS(5160),
    [anon_sym___stdcall] = ACTIONS(5160),
    [anon_sym___fastcall] = ACTIONS(5160),
    [anon_sym___thiscall] = ACTIONS(5160),
    [anon_sym___vectorcall] = ACTIONS(5160),
    [anon_sym_LBRACE] = ACTIONS(5167),
    [anon_sym_RBRACE] = ACTIONS(5162),
    [anon_sym_LBRACK] = ACTIONS(5171),
    [anon_sym_EQ] = ACTIONS(5169),
    [anon_sym_static] = ACTIONS(5160),
    [anon_sym_register] = ACTIONS(5160),
    [anon_sym_inline] = ACTIONS(5160),
    [anon_sym___inline] = ACTIONS(5160),
    [anon_sym___inline__] = ACTIONS(5160),
    [anon_sym___forceinline] = ACTIONS(5160),
    [anon_sym_thread_local] = ACTIONS(5160),
    [anon_sym___thread] = ACTIONS(5160),
    [anon_sym_const] = ACTIONS(5160),
    [anon_sym_constexpr] = ACTIONS(5160),
    [anon_sym_volatile] = ACTIONS(5160),
    [anon_sym_restrict] = ACTIONS(5160),
    [anon_sym___restrict__] = ACTIONS(5160),
    [anon_sym__Atomic] = ACTIONS(5160),
    [anon_sym__Noreturn] = ACTIONS(5160),
    [anon_sym_noreturn] = ACTIONS(5160),
    [anon_sym_mutable] = ACTIONS(5160),
    [anon_sym_constinit] = ACTIONS(5160),
    [anon_sym_consteval] = ACTIONS(5160),
    [anon_sym_PROGMEM] = ACTIONS(5160),
    [anon_sym_QMARK] = ACTIONS(5162),
    [anon_sym_STAR_EQ] = ACTIONS(5162),
    [anon_sym_SLASH_EQ] = ACTIONS(5162),
    [anon_sym_PERCENT_EQ] = ACTIONS(5162),
    [anon_sym_PLUS_EQ] = ACTIONS(5162),
    [anon_sym_DASH_EQ] = ACTIONS(5162),
    [anon_sym_LT_LT_EQ] = ACTIONS(5162),
    [anon_sym_GT_GT_EQ] = ACTIONS(5162),
    [anon_sym_AMP_EQ] = ACTIONS(5162),
    [anon_sym_CARET_EQ] = ACTIONS(5162),
    [anon_sym_PIPE_EQ] = ACTIONS(5162),
    [anon_sym_and_eq] = ACTIONS(5169),
    [anon_sym_or_eq] = ACTIONS(5169),
    [anon_sym_xor_eq] = ACTIONS(5169),
    [anon_sym_LT_EQ_GT] = ACTIONS(5162),
    [anon_sym_or] = ACTIONS(5169),
    [anon_sym_and] = ACTIONS(5169),
    [anon_sym_bitor] = ACTIONS(5169),
    [anon_sym_xor] = ACTIONS(5169),
    [anon_sym_bitand] = ACTIONS(5169),
    [anon_sym_not_eq] = ACTIONS(5169),
    [anon_sym_DASH_DASH] = ACTIONS(5162),
    [anon_sym_PLUS_PLUS] = ACTIONS(5162),
    [anon_sym_DOT] = ACTIONS(5169),
    [anon_sym_DOT_STAR] = ACTIONS(5162),
    [anon_sym_DASH_GT] = ACTIONS(5162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5160),
    [anon_sym_decltype] = ACTIONS(5160),
    [anon_sym_virtual] = ACTIONS(5160),
    [anon_sym_alignas] = ACTIONS(5160),
    [anon_sym_template] = ACTIONS(5160),
    [anon_sym_operator] = ACTIONS(5160),
  },
  [1984] = {
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(6063),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7408),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7008),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_parameter_list] = STATE(1108),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(5006),
    [sym_template_function] = STATE(7008),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6482),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_operator_name] = STATE(7008),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5154),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym_LT] = ACTIONS(5156),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5158),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(2137),
  },
  [1985] = {
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5978),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7376),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7008),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_parameter_list] = STATE(1114),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(5006),
    [sym_template_function] = STATE(7008),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6482),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_operator_name] = STATE(7008),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5154),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym_LT] = ACTIONS(5156),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5158),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(2137),
  },
  [1986] = {
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5996),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7432),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7008),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_parameter_list] = STATE(1106),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(5006),
    [sym_template_function] = STATE(7008),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6482),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_type_identifier] = STATE(3893),
    [sym_operator_name] = STATE(7008),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5154),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym_LT] = ACTIONS(5156),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5158),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(2137),
  },
  [1987] = {
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_LPAREN2] = ACTIONS(2907),
    [anon_sym_BANG] = ACTIONS(2907),
    [anon_sym_TILDE] = ACTIONS(2907),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_STAR] = ACTIONS(2907),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym___extension__] = ACTIONS(2902),
    [anon_sym_extern] = ACTIONS(2902),
    [anon_sym___attribute__] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(2907),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2907),
    [anon_sym___declspec] = ACTIONS(2902),
    [anon_sym_signed] = ACTIONS(2902),
    [anon_sym_unsigned] = ACTIONS(2902),
    [anon_sym_long] = ACTIONS(2902),
    [anon_sym_short] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2902),
    [anon_sym_static] = ACTIONS(2902),
    [anon_sym_register] = ACTIONS(2902),
    [anon_sym_inline] = ACTIONS(2902),
    [anon_sym___inline] = ACTIONS(2902),
    [anon_sym___inline__] = ACTIONS(2902),
    [anon_sym___forceinline] = ACTIONS(2902),
    [anon_sym_thread_local] = ACTIONS(2902),
    [anon_sym___thread] = ACTIONS(2902),
    [anon_sym_const] = ACTIONS(2902),
    [anon_sym_constexpr] = ACTIONS(2902),
    [anon_sym_volatile] = ACTIONS(2902),
    [anon_sym_restrict] = ACTIONS(2902),
    [anon_sym___restrict__] = ACTIONS(2902),
    [anon_sym__Atomic] = ACTIONS(2902),
    [anon_sym__Noreturn] = ACTIONS(2902),
    [anon_sym_noreturn] = ACTIONS(2902),
    [anon_sym_mutable] = ACTIONS(2902),
    [anon_sym_constinit] = ACTIONS(2902),
    [anon_sym_consteval] = ACTIONS(2902),
    [anon_sym_PROGMEM] = ACTIONS(2902),
    [aux_sym_primitive_type_token1] = ACTIONS(2902),
    [anon_sym_byte] = ACTIONS(2902),
    [anon_sym_word] = ACTIONS(2902),
    [anon_sym_enum] = ACTIONS(2902),
    [anon_sym_class] = ACTIONS(2902),
    [anon_sym_struct] = ACTIONS(2902),
    [anon_sym_union] = ACTIONS(2902),
    [anon_sym_not] = ACTIONS(2902),
    [anon_sym_compl] = ACTIONS(2902),
    [anon_sym_DASH_DASH] = ACTIONS(2907),
    [anon_sym_PLUS_PLUS] = ACTIONS(2907),
    [anon_sym_sizeof] = ACTIONS(2902),
    [anon_sym___alignof__] = ACTIONS(2902),
    [anon_sym___alignof] = ACTIONS(2902),
    [anon_sym__alignof] = ACTIONS(2902),
    [anon_sym_alignof] = ACTIONS(2902),
    [anon_sym__Alignof] = ACTIONS(2902),
    [anon_sym_offsetof] = ACTIONS(2902),
    [anon_sym__Generic] = ACTIONS(2902),
    [anon_sym_asm] = ACTIONS(2902),
    [anon_sym___asm__] = ACTIONS(2902),
    [aux_sym_number_literal_token1] = ACTIONS(2907),
    [aux_sym_number_literal_token2] = ACTIONS(2902),
    [anon_sym_L_SQUOTE] = ACTIONS(2907),
    [anon_sym_u_SQUOTE] = ACTIONS(2907),
    [anon_sym_U_SQUOTE] = ACTIONS(2907),
    [anon_sym_u8_SQUOTE] = ACTIONS(2907),
    [anon_sym_SQUOTE] = ACTIONS(2907),
    [anon_sym_L_DQUOTE] = ACTIONS(2907),
    [anon_sym_u_DQUOTE] = ACTIONS(2907),
    [anon_sym_U_DQUOTE] = ACTIONS(2907),
    [anon_sym_u8_DQUOTE] = ACTIONS(2907),
    [anon_sym_DQUOTE] = ACTIONS(2907),
    [sym_true] = ACTIONS(2902),
    [sym_false] = ACTIONS(2902),
    [anon_sym_NULL] = ACTIONS(2902),
    [anon_sym_nullptr] = ACTIONS(2902),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2902),
    [anon_sym_virtual] = ACTIONS(2902),
    [anon_sym_alignas] = ACTIONS(2902),
    [anon_sym_typename] = ACTIONS(2902),
    [anon_sym_template] = ACTIONS(2902),
    [anon_sym_delete] = ACTIONS(2902),
    [anon_sym_R_DQUOTE] = ACTIONS(2907),
    [anon_sym_LR_DQUOTE] = ACTIONS(2907),
    [anon_sym_uR_DQUOTE] = ACTIONS(2907),
    [anon_sym_UR_DQUOTE] = ACTIONS(2907),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2907),
    [anon_sym_co_await] = ACTIONS(2902),
    [anon_sym_new] = ACTIONS(2902),
    [anon_sym_requires] = ACTIONS(2902),
    [sym_this] = ACTIONS(2902),
  },
  [1988] = {
    [sym_identifier] = ACTIONS(3499),
    [anon_sym_LPAREN2] = ACTIONS(3501),
    [anon_sym_BANG] = ACTIONS(3501),
    [anon_sym_TILDE] = ACTIONS(3501),
    [anon_sym_DASH] = ACTIONS(3499),
    [anon_sym_PLUS] = ACTIONS(3499),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_AMP] = ACTIONS(3501),
    [anon_sym___extension__] = ACTIONS(3499),
    [anon_sym_extern] = ACTIONS(3499),
    [anon_sym___attribute__] = ACTIONS(3499),
    [anon_sym_COLON_COLON] = ACTIONS(3501),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3501),
    [anon_sym___declspec] = ACTIONS(3499),
    [anon_sym_signed] = ACTIONS(3499),
    [anon_sym_unsigned] = ACTIONS(3499),
    [anon_sym_long] = ACTIONS(3499),
    [anon_sym_short] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(3499),
    [anon_sym_static] = ACTIONS(3499),
    [anon_sym_register] = ACTIONS(3499),
    [anon_sym_inline] = ACTIONS(3499),
    [anon_sym___inline] = ACTIONS(3499),
    [anon_sym___inline__] = ACTIONS(3499),
    [anon_sym___forceinline] = ACTIONS(3499),
    [anon_sym_thread_local] = ACTIONS(3499),
    [anon_sym___thread] = ACTIONS(3499),
    [anon_sym_const] = ACTIONS(3499),
    [anon_sym_constexpr] = ACTIONS(3499),
    [anon_sym_volatile] = ACTIONS(3499),
    [anon_sym_restrict] = ACTIONS(3499),
    [anon_sym___restrict__] = ACTIONS(3499),
    [anon_sym__Atomic] = ACTIONS(3499),
    [anon_sym__Noreturn] = ACTIONS(3499),
    [anon_sym_noreturn] = ACTIONS(3499),
    [anon_sym_mutable] = ACTIONS(3499),
    [anon_sym_constinit] = ACTIONS(3499),
    [anon_sym_consteval] = ACTIONS(3499),
    [anon_sym_PROGMEM] = ACTIONS(3499),
    [aux_sym_primitive_type_token1] = ACTIONS(3499),
    [anon_sym_byte] = ACTIONS(3499),
    [anon_sym_word] = ACTIONS(3499),
    [anon_sym_enum] = ACTIONS(3499),
    [anon_sym_class] = ACTIONS(3499),
    [anon_sym_struct] = ACTIONS(3499),
    [anon_sym_union] = ACTIONS(3499),
    [anon_sym_not] = ACTIONS(3499),
    [anon_sym_compl] = ACTIONS(3499),
    [anon_sym_DASH_DASH] = ACTIONS(3501),
    [anon_sym_PLUS_PLUS] = ACTIONS(3501),
    [anon_sym_sizeof] = ACTIONS(3499),
    [anon_sym___alignof__] = ACTIONS(3499),
    [anon_sym___alignof] = ACTIONS(3499),
    [anon_sym__alignof] = ACTIONS(3499),
    [anon_sym_alignof] = ACTIONS(3499),
    [anon_sym__Alignof] = ACTIONS(3499),
    [anon_sym_offsetof] = ACTIONS(3499),
    [anon_sym__Generic] = ACTIONS(3499),
    [anon_sym_asm] = ACTIONS(3499),
    [anon_sym___asm__] = ACTIONS(3499),
    [aux_sym_number_literal_token1] = ACTIONS(3501),
    [aux_sym_number_literal_token2] = ACTIONS(3499),
    [anon_sym_L_SQUOTE] = ACTIONS(3501),
    [anon_sym_u_SQUOTE] = ACTIONS(3501),
    [anon_sym_U_SQUOTE] = ACTIONS(3501),
    [anon_sym_u8_SQUOTE] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3501),
    [anon_sym_L_DQUOTE] = ACTIONS(3501),
    [anon_sym_u_DQUOTE] = ACTIONS(3501),
    [anon_sym_U_DQUOTE] = ACTIONS(3501),
    [anon_sym_u8_DQUOTE] = ACTIONS(3501),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [sym_true] = ACTIONS(3499),
    [sym_false] = ACTIONS(3499),
    [anon_sym_NULL] = ACTIONS(3499),
    [anon_sym_nullptr] = ACTIONS(3499),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3499),
    [anon_sym_decltype] = ACTIONS(3499),
    [anon_sym_virtual] = ACTIONS(3499),
    [anon_sym_alignas] = ACTIONS(3499),
    [anon_sym_typename] = ACTIONS(3499),
    [anon_sym_template] = ACTIONS(3499),
    [anon_sym_delete] = ACTIONS(3499),
    [anon_sym_R_DQUOTE] = ACTIONS(3501),
    [anon_sym_LR_DQUOTE] = ACTIONS(3501),
    [anon_sym_uR_DQUOTE] = ACTIONS(3501),
    [anon_sym_UR_DQUOTE] = ACTIONS(3501),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3501),
    [anon_sym_co_await] = ACTIONS(3499),
    [anon_sym_new] = ACTIONS(3499),
    [anon_sym_requires] = ACTIONS(3499),
    [sym_this] = ACTIONS(3499),
  },
  [1989] = {
    [sym_identifier] = ACTIONS(3521),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_BANG] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3521),
    [anon_sym_PLUS] = ACTIONS(3521),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym___extension__] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym___attribute__] = ACTIONS(3521),
    [anon_sym_COLON_COLON] = ACTIONS(3523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3523),
    [anon_sym___declspec] = ACTIONS(3521),
    [anon_sym_signed] = ACTIONS(3521),
    [anon_sym_unsigned] = ACTIONS(3521),
    [anon_sym_long] = ACTIONS(3521),
    [anon_sym_short] = ACTIONS(3521),
    [anon_sym_LBRACK] = ACTIONS(3521),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_register] = ACTIONS(3521),
    [anon_sym_inline] = ACTIONS(3521),
    [anon_sym___inline] = ACTIONS(3521),
    [anon_sym___inline__] = ACTIONS(3521),
    [anon_sym___forceinline] = ACTIONS(3521),
    [anon_sym_thread_local] = ACTIONS(3521),
    [anon_sym___thread] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_constexpr] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym_restrict] = ACTIONS(3521),
    [anon_sym___restrict__] = ACTIONS(3521),
    [anon_sym__Atomic] = ACTIONS(3521),
    [anon_sym__Noreturn] = ACTIONS(3521),
    [anon_sym_noreturn] = ACTIONS(3521),
    [anon_sym_mutable] = ACTIONS(3521),
    [anon_sym_constinit] = ACTIONS(3521),
    [anon_sym_consteval] = ACTIONS(3521),
    [anon_sym_PROGMEM] = ACTIONS(3521),
    [aux_sym_primitive_type_token1] = ACTIONS(3521),
    [anon_sym_byte] = ACTIONS(3521),
    [anon_sym_word] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_class] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_union] = ACTIONS(3521),
    [anon_sym_not] = ACTIONS(3521),
    [anon_sym_compl] = ACTIONS(3521),
    [anon_sym_DASH_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_PLUS] = ACTIONS(3523),
    [anon_sym_sizeof] = ACTIONS(3521),
    [anon_sym___alignof__] = ACTIONS(3521),
    [anon_sym___alignof] = ACTIONS(3521),
    [anon_sym__alignof] = ACTIONS(3521),
    [anon_sym_alignof] = ACTIONS(3521),
    [anon_sym__Alignof] = ACTIONS(3521),
    [anon_sym_offsetof] = ACTIONS(3521),
    [anon_sym__Generic] = ACTIONS(3521),
    [anon_sym_asm] = ACTIONS(3521),
    [anon_sym___asm__] = ACTIONS(3521),
    [aux_sym_number_literal_token1] = ACTIONS(3523),
    [aux_sym_number_literal_token2] = ACTIONS(3521),
    [anon_sym_L_SQUOTE] = ACTIONS(3523),
    [anon_sym_u_SQUOTE] = ACTIONS(3523),
    [anon_sym_U_SQUOTE] = ACTIONS(3523),
    [anon_sym_u8_SQUOTE] = ACTIONS(3523),
    [anon_sym_SQUOTE] = ACTIONS(3523),
    [anon_sym_L_DQUOTE] = ACTIONS(3523),
    [anon_sym_u_DQUOTE] = ACTIONS(3523),
    [anon_sym_U_DQUOTE] = ACTIONS(3523),
    [anon_sym_u8_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [sym_true] = ACTIONS(3521),
    [sym_false] = ACTIONS(3521),
    [anon_sym_NULL] = ACTIONS(3521),
    [anon_sym_nullptr] = ACTIONS(3521),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3521),
    [anon_sym_decltype] = ACTIONS(3521),
    [anon_sym_virtual] = ACTIONS(3521),
    [anon_sym_alignas] = ACTIONS(3521),
    [anon_sym_typename] = ACTIONS(3521),
    [anon_sym_template] = ACTIONS(3521),
    [anon_sym_delete] = ACTIONS(3521),
    [anon_sym_R_DQUOTE] = ACTIONS(3523),
    [anon_sym_LR_DQUOTE] = ACTIONS(3523),
    [anon_sym_uR_DQUOTE] = ACTIONS(3523),
    [anon_sym_UR_DQUOTE] = ACTIONS(3523),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3523),
    [anon_sym_co_await] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3521),
    [anon_sym_requires] = ACTIONS(3521),
    [sym_this] = ACTIONS(3521),
  },
  [1990] = {
    [sym_template_argument_list] = STATE(2001),
    [sym_identifier] = ACTIONS(5129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5131),
    [anon_sym_COMMA] = ACTIONS(5131),
    [anon_sym_RPAREN] = ACTIONS(5131),
    [anon_sym_LPAREN2] = ACTIONS(5133),
    [anon_sym_TILDE] = ACTIONS(5136),
    [anon_sym_DASH] = ACTIONS(5138),
    [anon_sym_PLUS] = ACTIONS(5138),
    [anon_sym_STAR] = ACTIONS(5140),
    [anon_sym_SLASH] = ACTIONS(5138),
    [anon_sym_PERCENT] = ACTIONS(5138),
    [anon_sym_PIPE_PIPE] = ACTIONS(5131),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5138),
    [anon_sym_CARET] = ACTIONS(5138),
    [anon_sym_AMP] = ACTIONS(5140),
    [anon_sym_EQ_EQ] = ACTIONS(5131),
    [anon_sym_BANG_EQ] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5138),
    [anon_sym_GT_EQ] = ACTIONS(5131),
    [anon_sym_LT_EQ] = ACTIONS(5138),
    [anon_sym_LT] = ACTIONS(5143),
    [anon_sym_LT_LT] = ACTIONS(5138),
    [anon_sym_GT_GT] = ACTIONS(5138),
    [anon_sym_SEMI] = ACTIONS(5131),
    [anon_sym___extension__] = ACTIONS(5129),
    [anon_sym_extern] = ACTIONS(5129),
    [anon_sym___attribute__] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5136),
    [anon_sym___declspec] = ACTIONS(5129),
    [anon_sym___based] = ACTIONS(5129),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_LBRACK] = ACTIONS(5140),
    [anon_sym_EQ] = ACTIONS(5138),
    [anon_sym_static] = ACTIONS(5129),
    [anon_sym_register] = ACTIONS(5129),
    [anon_sym_inline] = ACTIONS(5129),
    [anon_sym___inline] = ACTIONS(5129),
    [anon_sym___inline__] = ACTIONS(5129),
    [anon_sym___forceinline] = ACTIONS(5129),
    [anon_sym_thread_local] = ACTIONS(5129),
    [anon_sym___thread] = ACTIONS(5129),
    [anon_sym_const] = ACTIONS(5129),
    [anon_sym_constexpr] = ACTIONS(5129),
    [anon_sym_volatile] = ACTIONS(5129),
    [anon_sym_restrict] = ACTIONS(5129),
    [anon_sym___restrict__] = ACTIONS(5129),
    [anon_sym__Atomic] = ACTIONS(5129),
    [anon_sym__Noreturn] = ACTIONS(5129),
    [anon_sym_noreturn] = ACTIONS(5129),
    [anon_sym_mutable] = ACTIONS(5129),
    [anon_sym_constinit] = ACTIONS(5129),
    [anon_sym_consteval] = ACTIONS(5129),
    [anon_sym_PROGMEM] = ACTIONS(5129),
    [anon_sym_QMARK] = ACTIONS(5131),
    [anon_sym_STAR_EQ] = ACTIONS(5131),
    [anon_sym_SLASH_EQ] = ACTIONS(5131),
    [anon_sym_PERCENT_EQ] = ACTIONS(5131),
    [anon_sym_PLUS_EQ] = ACTIONS(5131),
    [anon_sym_DASH_EQ] = ACTIONS(5131),
    [anon_sym_LT_LT_EQ] = ACTIONS(5131),
    [anon_sym_GT_GT_EQ] = ACTIONS(5131),
    [anon_sym_AMP_EQ] = ACTIONS(5131),
    [anon_sym_CARET_EQ] = ACTIONS(5131),
    [anon_sym_PIPE_EQ] = ACTIONS(5131),
    [anon_sym_and_eq] = ACTIONS(5138),
    [anon_sym_or_eq] = ACTIONS(5138),
    [anon_sym_xor_eq] = ACTIONS(5138),
    [anon_sym_LT_EQ_GT] = ACTIONS(5131),
    [anon_sym_or] = ACTIONS(5138),
    [anon_sym_and] = ACTIONS(5138),
    [anon_sym_bitor] = ACTIONS(5138),
    [anon_sym_xor] = ACTIONS(5138),
    [anon_sym_bitand] = ACTIONS(5138),
    [anon_sym_not_eq] = ACTIONS(5138),
    [anon_sym_DASH_DASH] = ACTIONS(5131),
    [anon_sym_PLUS_PLUS] = ACTIONS(5131),
    [anon_sym_DOT] = ACTIONS(5138),
    [anon_sym_DOT_STAR] = ACTIONS(5131),
    [anon_sym_DASH_GT] = ACTIONS(5131),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5129),
    [anon_sym_decltype] = ACTIONS(5129),
    [anon_sym_virtual] = ACTIONS(5129),
    [anon_sym_alignas] = ACTIONS(5129),
    [anon_sym_template] = ACTIONS(5129),
    [anon_sym_operator] = ACTIONS(5129),
  },
  [1991] = {
    [sym_template_argument_list] = STATE(2002),
    [sym_identifier] = ACTIONS(5129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5133),
    [anon_sym_COMMA] = ACTIONS(5133),
    [anon_sym_RPAREN] = ACTIONS(5133),
    [anon_sym_LPAREN2] = ACTIONS(5133),
    [anon_sym_TILDE] = ACTIONS(5136),
    [anon_sym_DASH] = ACTIONS(5138),
    [anon_sym_PLUS] = ACTIONS(5138),
    [anon_sym_STAR] = ACTIONS(5140),
    [anon_sym_SLASH] = ACTIONS(5138),
    [anon_sym_PERCENT] = ACTIONS(5138),
    [anon_sym_PIPE_PIPE] = ACTIONS(5131),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5138),
    [anon_sym_CARET] = ACTIONS(5138),
    [anon_sym_AMP] = ACTIONS(5140),
    [anon_sym_EQ_EQ] = ACTIONS(5131),
    [anon_sym_BANG_EQ] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5138),
    [anon_sym_GT_EQ] = ACTIONS(5131),
    [anon_sym_LT_EQ] = ACTIONS(5138),
    [anon_sym_LT] = ACTIONS(5174),
    [anon_sym_LT_LT] = ACTIONS(5138),
    [anon_sym_GT_GT] = ACTIONS(5138),
    [anon_sym___extension__] = ACTIONS(5129),
    [anon_sym_extern] = ACTIONS(5129),
    [anon_sym___attribute__] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5136),
    [anon_sym___declspec] = ACTIONS(5129),
    [anon_sym___based] = ACTIONS(5129),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_LBRACK] = ACTIONS(5140),
    [anon_sym_EQ] = ACTIONS(5140),
    [anon_sym_static] = ACTIONS(5129),
    [anon_sym_register] = ACTIONS(5129),
    [anon_sym_inline] = ACTIONS(5129),
    [anon_sym___inline] = ACTIONS(5129),
    [anon_sym___inline__] = ACTIONS(5129),
    [anon_sym___forceinline] = ACTIONS(5129),
    [anon_sym_thread_local] = ACTIONS(5129),
    [anon_sym___thread] = ACTIONS(5129),
    [anon_sym_const] = ACTIONS(5129),
    [anon_sym_constexpr] = ACTIONS(5129),
    [anon_sym_volatile] = ACTIONS(5129),
    [anon_sym_restrict] = ACTIONS(5129),
    [anon_sym___restrict__] = ACTIONS(5129),
    [anon_sym__Atomic] = ACTIONS(5129),
    [anon_sym__Noreturn] = ACTIONS(5129),
    [anon_sym_noreturn] = ACTIONS(5129),
    [anon_sym_mutable] = ACTIONS(5129),
    [anon_sym_constinit] = ACTIONS(5129),
    [anon_sym_consteval] = ACTIONS(5129),
    [anon_sym_PROGMEM] = ACTIONS(5129),
    [anon_sym_QMARK] = ACTIONS(5131),
    [anon_sym_STAR_EQ] = ACTIONS(5131),
    [anon_sym_SLASH_EQ] = ACTIONS(5131),
    [anon_sym_PERCENT_EQ] = ACTIONS(5131),
    [anon_sym_PLUS_EQ] = ACTIONS(5131),
    [anon_sym_DASH_EQ] = ACTIONS(5131),
    [anon_sym_LT_LT_EQ] = ACTIONS(5131),
    [anon_sym_GT_GT_EQ] = ACTIONS(5131),
    [anon_sym_AMP_EQ] = ACTIONS(5131),
    [anon_sym_CARET_EQ] = ACTIONS(5131),
    [anon_sym_PIPE_EQ] = ACTIONS(5131),
    [anon_sym_and_eq] = ACTIONS(5138),
    [anon_sym_or_eq] = ACTIONS(5138),
    [anon_sym_xor_eq] = ACTIONS(5138),
    [anon_sym_LT_EQ_GT] = ACTIONS(5131),
    [anon_sym_or] = ACTIONS(5138),
    [anon_sym_and] = ACTIONS(5138),
    [anon_sym_bitor] = ACTIONS(5138),
    [anon_sym_xor] = ACTIONS(5138),
    [anon_sym_bitand] = ACTIONS(5138),
    [anon_sym_not_eq] = ACTIONS(5138),
    [anon_sym_DASH_DASH] = ACTIONS(5131),
    [anon_sym_PLUS_PLUS] = ACTIONS(5131),
    [anon_sym_DOT] = ACTIONS(5138),
    [anon_sym_DOT_STAR] = ACTIONS(5131),
    [anon_sym_DASH_GT] = ACTIONS(5138),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5129),
    [anon_sym_decltype] = ACTIONS(5129),
    [anon_sym_virtual] = ACTIONS(5129),
    [anon_sym_alignas] = ACTIONS(5129),
    [anon_sym_template] = ACTIONS(5129),
    [anon_sym_operator] = ACTIONS(5129),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5131),
  },
  [1992] = {
    [sym_identifier] = ACTIONS(5117),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(5119),
    [anon_sym_RPAREN] = ACTIONS(5119),
    [anon_sym_LPAREN2] = ACTIONS(5119),
    [anon_sym_TILDE] = ACTIONS(5119),
    [anon_sym_DASH] = ACTIONS(5117),
    [anon_sym_PLUS] = ACTIONS(5117),
    [anon_sym_STAR] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5117),
    [anon_sym_PERCENT] = ACTIONS(5117),
    [anon_sym_PIPE_PIPE] = ACTIONS(5119),
    [anon_sym_AMP_AMP] = ACTIONS(5119),
    [anon_sym_PIPE] = ACTIONS(5117),
    [anon_sym_CARET] = ACTIONS(5117),
    [anon_sym_AMP] = ACTIONS(5117),
    [anon_sym_EQ_EQ] = ACTIONS(5119),
    [anon_sym_BANG_EQ] = ACTIONS(5119),
    [anon_sym_GT] = ACTIONS(5117),
    [anon_sym_GT_EQ] = ACTIONS(5119),
    [anon_sym_LT_EQ] = ACTIONS(5117),
    [anon_sym_LT] = ACTIONS(5117),
    [anon_sym_LT_LT] = ACTIONS(5117),
    [anon_sym_GT_GT] = ACTIONS(5117),
    [anon_sym___extension__] = ACTIONS(5117),
    [anon_sym_extern] = ACTIONS(5117),
    [anon_sym___attribute__] = ACTIONS(5117),
    [anon_sym_COLON_COLON] = ACTIONS(5119),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5119),
    [anon_sym___declspec] = ACTIONS(5117),
    [anon_sym___based] = ACTIONS(5117),
    [anon_sym_LBRACE] = ACTIONS(5119),
    [anon_sym_LBRACK] = ACTIONS(5117),
    [anon_sym_EQ] = ACTIONS(5117),
    [anon_sym_static] = ACTIONS(5117),
    [anon_sym_register] = ACTIONS(5117),
    [anon_sym_inline] = ACTIONS(5117),
    [anon_sym___inline] = ACTIONS(5117),
    [anon_sym___inline__] = ACTIONS(5117),
    [anon_sym___forceinline] = ACTIONS(5117),
    [anon_sym_thread_local] = ACTIONS(5117),
    [anon_sym___thread] = ACTIONS(5117),
    [anon_sym_const] = ACTIONS(5117),
    [anon_sym_constexpr] = ACTIONS(5117),
    [anon_sym_volatile] = ACTIONS(5117),
    [anon_sym_restrict] = ACTIONS(5117),
    [anon_sym___restrict__] = ACTIONS(5117),
    [anon_sym__Atomic] = ACTIONS(5117),
    [anon_sym__Noreturn] = ACTIONS(5117),
    [anon_sym_noreturn] = ACTIONS(5117),
    [anon_sym_mutable] = ACTIONS(5117),
    [anon_sym_constinit] = ACTIONS(5117),
    [anon_sym_consteval] = ACTIONS(5117),
    [anon_sym_PROGMEM] = ACTIONS(5117),
    [anon_sym_QMARK] = ACTIONS(5119),
    [anon_sym_STAR_EQ] = ACTIONS(5119),
    [anon_sym_SLASH_EQ] = ACTIONS(5119),
    [anon_sym_PERCENT_EQ] = ACTIONS(5119),
    [anon_sym_PLUS_EQ] = ACTIONS(5119),
    [anon_sym_DASH_EQ] = ACTIONS(5119),
    [anon_sym_LT_LT_EQ] = ACTIONS(5119),
    [anon_sym_GT_GT_EQ] = ACTIONS(5119),
    [anon_sym_AMP_EQ] = ACTIONS(5119),
    [anon_sym_CARET_EQ] = ACTIONS(5119),
    [anon_sym_PIPE_EQ] = ACTIONS(5119),
    [anon_sym_and_eq] = ACTIONS(5117),
    [anon_sym_or_eq] = ACTIONS(5117),
    [anon_sym_xor_eq] = ACTIONS(5117),
    [anon_sym_LT_EQ_GT] = ACTIONS(5119),
    [anon_sym_or] = ACTIONS(5117),
    [anon_sym_and] = ACTIONS(5117),
    [anon_sym_bitor] = ACTIONS(5117),
    [anon_sym_xor] = ACTIONS(5117),
    [anon_sym_bitand] = ACTIONS(5117),
    [anon_sym_not_eq] = ACTIONS(5117),
    [anon_sym_DASH_DASH] = ACTIONS(5119),
    [anon_sym_PLUS_PLUS] = ACTIONS(5119),
    [anon_sym_DOT] = ACTIONS(5117),
    [anon_sym_DOT_STAR] = ACTIONS(5119),
    [anon_sym_DASH_GT] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5117),
    [anon_sym_decltype] = ACTIONS(5117),
    [anon_sym_virtual] = ACTIONS(5117),
    [anon_sym_alignas] = ACTIONS(5117),
    [anon_sym_template] = ACTIONS(5117),
    [anon_sym_operator] = ACTIONS(5117),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5119),
  },
  [1993] = {
    [sym_template_argument_list] = STATE(2010),
    [sym_identifier] = ACTIONS(5129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5133),
    [anon_sym_COMMA] = ACTIONS(5133),
    [anon_sym_RPAREN] = ACTIONS(5133),
    [anon_sym_LPAREN2] = ACTIONS(5133),
    [anon_sym_TILDE] = ACTIONS(5136),
    [anon_sym_DASH] = ACTIONS(5138),
    [anon_sym_PLUS] = ACTIONS(5138),
    [anon_sym_STAR] = ACTIONS(5140),
    [anon_sym_SLASH] = ACTIONS(5138),
    [anon_sym_PERCENT] = ACTIONS(5138),
    [anon_sym_PIPE_PIPE] = ACTIONS(5131),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5138),
    [anon_sym_CARET] = ACTIONS(5138),
    [anon_sym_AMP] = ACTIONS(5140),
    [anon_sym_EQ_EQ] = ACTIONS(5131),
    [anon_sym_BANG_EQ] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5138),
    [anon_sym_GT_EQ] = ACTIONS(5131),
    [anon_sym_LT_EQ] = ACTIONS(5138),
    [anon_sym_LT] = ACTIONS(5143),
    [anon_sym_LT_LT] = ACTIONS(5138),
    [anon_sym_GT_GT] = ACTIONS(5138),
    [anon_sym___extension__] = ACTIONS(5129),
    [anon_sym_extern] = ACTIONS(5129),
    [anon_sym___attribute__] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5136),
    [anon_sym___declspec] = ACTIONS(5129),
    [anon_sym___based] = ACTIONS(5129),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_LBRACK] = ACTIONS(5140),
    [anon_sym_EQ] = ACTIONS(5140),
    [anon_sym_static] = ACTIONS(5129),
    [anon_sym_register] = ACTIONS(5129),
    [anon_sym_inline] = ACTIONS(5129),
    [anon_sym___inline] = ACTIONS(5129),
    [anon_sym___inline__] = ACTIONS(5129),
    [anon_sym___forceinline] = ACTIONS(5129),
    [anon_sym_thread_local] = ACTIONS(5129),
    [anon_sym___thread] = ACTIONS(5129),
    [anon_sym_const] = ACTIONS(5129),
    [anon_sym_constexpr] = ACTIONS(5129),
    [anon_sym_volatile] = ACTIONS(5129),
    [anon_sym_restrict] = ACTIONS(5129),
    [anon_sym___restrict__] = ACTIONS(5129),
    [anon_sym__Atomic] = ACTIONS(5129),
    [anon_sym__Noreturn] = ACTIONS(5129),
    [anon_sym_noreturn] = ACTIONS(5129),
    [anon_sym_mutable] = ACTIONS(5129),
    [anon_sym_constinit] = ACTIONS(5129),
    [anon_sym_consteval] = ACTIONS(5129),
    [anon_sym_PROGMEM] = ACTIONS(5129),
    [anon_sym_QMARK] = ACTIONS(5131),
    [anon_sym_STAR_EQ] = ACTIONS(5131),
    [anon_sym_SLASH_EQ] = ACTIONS(5131),
    [anon_sym_PERCENT_EQ] = ACTIONS(5131),
    [anon_sym_PLUS_EQ] = ACTIONS(5131),
    [anon_sym_DASH_EQ] = ACTIONS(5131),
    [anon_sym_LT_LT_EQ] = ACTIONS(5131),
    [anon_sym_GT_GT_EQ] = ACTIONS(5131),
    [anon_sym_AMP_EQ] = ACTIONS(5131),
    [anon_sym_CARET_EQ] = ACTIONS(5131),
    [anon_sym_PIPE_EQ] = ACTIONS(5131),
    [anon_sym_and_eq] = ACTIONS(5138),
    [anon_sym_or_eq] = ACTIONS(5138),
    [anon_sym_xor_eq] = ACTIONS(5138),
    [anon_sym_LT_EQ_GT] = ACTIONS(5131),
    [anon_sym_or] = ACTIONS(5138),
    [anon_sym_and] = ACTIONS(5138),
    [anon_sym_bitor] = ACTIONS(5138),
    [anon_sym_xor] = ACTIONS(5138),
    [anon_sym_bitand] = ACTIONS(5138),
    [anon_sym_not_eq] = ACTIONS(5138),
    [anon_sym_DASH_DASH] = ACTIONS(5131),
    [anon_sym_PLUS_PLUS] = ACTIONS(5131),
    [anon_sym_DOT] = ACTIONS(5138),
    [anon_sym_DOT_STAR] = ACTIONS(5131),
    [anon_sym_DASH_GT] = ACTIONS(5131),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5129),
    [anon_sym_decltype] = ACTIONS(5129),
    [anon_sym_virtual] = ACTIONS(5129),
    [anon_sym_alignas] = ACTIONS(5129),
    [anon_sym_template] = ACTIONS(5129),
    [anon_sym_operator] = ACTIONS(5129),
  },
  [1994] = {
    [sym_identifier] = ACTIONS(5146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5148),
    [anon_sym_COMMA] = ACTIONS(5148),
    [anon_sym_RPAREN] = ACTIONS(5148),
    [anon_sym_LPAREN2] = ACTIONS(5148),
    [anon_sym_TILDE] = ACTIONS(5148),
    [anon_sym_DASH] = ACTIONS(5146),
    [anon_sym_PLUS] = ACTIONS(5146),
    [anon_sym_STAR] = ACTIONS(5146),
    [anon_sym_SLASH] = ACTIONS(5146),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [anon_sym_PIPE_PIPE] = ACTIONS(5148),
    [anon_sym_AMP_AMP] = ACTIONS(5148),
    [anon_sym_PIPE] = ACTIONS(5146),
    [anon_sym_CARET] = ACTIONS(5146),
    [anon_sym_AMP] = ACTIONS(5146),
    [anon_sym_EQ_EQ] = ACTIONS(5148),
    [anon_sym_BANG_EQ] = ACTIONS(5148),
    [anon_sym_GT] = ACTIONS(5146),
    [anon_sym_GT_EQ] = ACTIONS(5148),
    [anon_sym_LT_EQ] = ACTIONS(5146),
    [anon_sym_LT] = ACTIONS(5146),
    [anon_sym_LT_LT] = ACTIONS(5146),
    [anon_sym_GT_GT] = ACTIONS(5146),
    [anon_sym___extension__] = ACTIONS(5146),
    [anon_sym_extern] = ACTIONS(5146),
    [anon_sym___attribute__] = ACTIONS(5146),
    [anon_sym_COLON_COLON] = ACTIONS(5148),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5148),
    [anon_sym___declspec] = ACTIONS(5146),
    [anon_sym___based] = ACTIONS(5146),
    [anon_sym_LBRACE] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5146),
    [anon_sym_EQ] = ACTIONS(5146),
    [anon_sym_static] = ACTIONS(5146),
    [anon_sym_register] = ACTIONS(5146),
    [anon_sym_inline] = ACTIONS(5146),
    [anon_sym___inline] = ACTIONS(5146),
    [anon_sym___inline__] = ACTIONS(5146),
    [anon_sym___forceinline] = ACTIONS(5146),
    [anon_sym_thread_local] = ACTIONS(5146),
    [anon_sym___thread] = ACTIONS(5146),
    [anon_sym_const] = ACTIONS(5146),
    [anon_sym_constexpr] = ACTIONS(5146),
    [anon_sym_volatile] = ACTIONS(5146),
    [anon_sym_restrict] = ACTIONS(5146),
    [anon_sym___restrict__] = ACTIONS(5146),
    [anon_sym__Atomic] = ACTIONS(5146),
    [anon_sym__Noreturn] = ACTIONS(5146),
    [anon_sym_noreturn] = ACTIONS(5146),
    [anon_sym_mutable] = ACTIONS(5146),
    [anon_sym_constinit] = ACTIONS(5146),
    [anon_sym_consteval] = ACTIONS(5146),
    [anon_sym_PROGMEM] = ACTIONS(5146),
    [anon_sym_QMARK] = ACTIONS(5148),
    [anon_sym_STAR_EQ] = ACTIONS(5148),
    [anon_sym_SLASH_EQ] = ACTIONS(5148),
    [anon_sym_PERCENT_EQ] = ACTIONS(5148),
    [anon_sym_PLUS_EQ] = ACTIONS(5148),
    [anon_sym_DASH_EQ] = ACTIONS(5148),
    [anon_sym_LT_LT_EQ] = ACTIONS(5148),
    [anon_sym_GT_GT_EQ] = ACTIONS(5148),
    [anon_sym_AMP_EQ] = ACTIONS(5148),
    [anon_sym_CARET_EQ] = ACTIONS(5148),
    [anon_sym_PIPE_EQ] = ACTIONS(5148),
    [anon_sym_and_eq] = ACTIONS(5146),
    [anon_sym_or_eq] = ACTIONS(5146),
    [anon_sym_xor_eq] = ACTIONS(5146),
    [anon_sym_LT_EQ_GT] = ACTIONS(5148),
    [anon_sym_or] = ACTIONS(5146),
    [anon_sym_and] = ACTIONS(5146),
    [anon_sym_bitor] = ACTIONS(5146),
    [anon_sym_xor] = ACTIONS(5146),
    [anon_sym_bitand] = ACTIONS(5146),
    [anon_sym_not_eq] = ACTIONS(5146),
    [anon_sym_DASH_DASH] = ACTIONS(5148),
    [anon_sym_PLUS_PLUS] = ACTIONS(5148),
    [anon_sym_DOT] = ACTIONS(5146),
    [anon_sym_DOT_STAR] = ACTIONS(5148),
    [anon_sym_DASH_GT] = ACTIONS(5146),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5146),
    [anon_sym_decltype] = ACTIONS(5146),
    [anon_sym_virtual] = ACTIONS(5146),
    [anon_sym_alignas] = ACTIONS(5146),
    [anon_sym_template] = ACTIONS(5146),
    [anon_sym_operator] = ACTIONS(5146),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5148),
  },
  [1995] = {
    [sym_string_literal] = STATE(2616),
    [sym_template_argument_list] = STATE(2153),
    [sym_raw_string_literal] = STATE(2616),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2671),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_RPAREN] = ACTIONS(4250),
    [anon_sym_LPAREN2] = ACTIONS(4250),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4258),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4261),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4258),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5177),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym___extension__] = ACTIONS(4254),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5180),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_signed] = ACTIONS(5182),
    [anon_sym_unsigned] = ACTIONS(5182),
    [anon_sym_long] = ACTIONS(5182),
    [anon_sym_short] = ACTIONS(5182),
    [anon_sym_LBRACK] = ACTIONS(4276),
    [anon_sym_EQ] = ACTIONS(4256),
    [anon_sym_const] = ACTIONS(4246),
    [anon_sym_constexpr] = ACTIONS(4254),
    [anon_sym_volatile] = ACTIONS(4254),
    [anon_sym_restrict] = ACTIONS(4254),
    [anon_sym___restrict__] = ACTIONS(4254),
    [anon_sym__Atomic] = ACTIONS(4254),
    [anon_sym__Noreturn] = ACTIONS(4254),
    [anon_sym_noreturn] = ACTIONS(4254),
    [anon_sym_mutable] = ACTIONS(4254),
    [anon_sym_constinit] = ACTIONS(4254),
    [anon_sym_consteval] = ACTIONS(4254),
    [anon_sym_PROGMEM] = ACTIONS(4254),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4248),
    [anon_sym_SLASH_EQ] = ACTIONS(4248),
    [anon_sym_PERCENT_EQ] = ACTIONS(4248),
    [anon_sym_PLUS_EQ] = ACTIONS(4248),
    [anon_sym_DASH_EQ] = ACTIONS(4248),
    [anon_sym_LT_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT_GT_EQ] = ACTIONS(4248),
    [anon_sym_AMP_EQ] = ACTIONS(4248),
    [anon_sym_CARET_EQ] = ACTIONS(4248),
    [anon_sym_PIPE_EQ] = ACTIONS(4248),
    [anon_sym_and_eq] = ACTIONS(4248),
    [anon_sym_or_eq] = ACTIONS(4248),
    [anon_sym_xor_eq] = ACTIONS(4248),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4256),
    [anon_sym_L_DQUOTE] = ACTIONS(5184),
    [anon_sym_u_DQUOTE] = ACTIONS(5184),
    [anon_sym_U_DQUOTE] = ACTIONS(5184),
    [anon_sym_u8_DQUOTE] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4254),
    [anon_sym_decltype] = ACTIONS(4254),
    [anon_sym_R_DQUOTE] = ACTIONS(5186),
    [anon_sym_LR_DQUOTE] = ACTIONS(5186),
    [anon_sym_uR_DQUOTE] = ACTIONS(5186),
    [anon_sym_UR_DQUOTE] = ACTIONS(5186),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5186),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4248),
  },
  [1996] = {
    [sym_identifier] = ACTIONS(5109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5111),
    [anon_sym_COMMA] = ACTIONS(5111),
    [anon_sym_RPAREN] = ACTIONS(5111),
    [anon_sym_LPAREN2] = ACTIONS(5111),
    [anon_sym_TILDE] = ACTIONS(5111),
    [anon_sym_DASH] = ACTIONS(5109),
    [anon_sym_PLUS] = ACTIONS(5109),
    [anon_sym_STAR] = ACTIONS(5109),
    [anon_sym_SLASH] = ACTIONS(5109),
    [anon_sym_PERCENT] = ACTIONS(5109),
    [anon_sym_PIPE_PIPE] = ACTIONS(5111),
    [anon_sym_AMP_AMP] = ACTIONS(5111),
    [anon_sym_PIPE] = ACTIONS(5109),
    [anon_sym_CARET] = ACTIONS(5109),
    [anon_sym_AMP] = ACTIONS(5109),
    [anon_sym_EQ_EQ] = ACTIONS(5111),
    [anon_sym_BANG_EQ] = ACTIONS(5111),
    [anon_sym_GT] = ACTIONS(5109),
    [anon_sym_GT_EQ] = ACTIONS(5111),
    [anon_sym_LT_EQ] = ACTIONS(5109),
    [anon_sym_LT] = ACTIONS(5109),
    [anon_sym_LT_LT] = ACTIONS(5109),
    [anon_sym_GT_GT] = ACTIONS(5109),
    [anon_sym___extension__] = ACTIONS(5109),
    [anon_sym_extern] = ACTIONS(5109),
    [anon_sym___attribute__] = ACTIONS(5109),
    [anon_sym_COLON_COLON] = ACTIONS(5111),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5111),
    [anon_sym___declspec] = ACTIONS(5109),
    [anon_sym___based] = ACTIONS(5109),
    [anon_sym_LBRACE] = ACTIONS(5111),
    [anon_sym_LBRACK] = ACTIONS(5109),
    [anon_sym_EQ] = ACTIONS(5109),
    [anon_sym_static] = ACTIONS(5109),
    [anon_sym_register] = ACTIONS(5109),
    [anon_sym_inline] = ACTIONS(5109),
    [anon_sym___inline] = ACTIONS(5109),
    [anon_sym___inline__] = ACTIONS(5109),
    [anon_sym___forceinline] = ACTIONS(5109),
    [anon_sym_thread_local] = ACTIONS(5109),
    [anon_sym___thread] = ACTIONS(5109),
    [anon_sym_const] = ACTIONS(5109),
    [anon_sym_constexpr] = ACTIONS(5109),
    [anon_sym_volatile] = ACTIONS(5109),
    [anon_sym_restrict] = ACTIONS(5109),
    [anon_sym___restrict__] = ACTIONS(5109),
    [anon_sym__Atomic] = ACTIONS(5109),
    [anon_sym__Noreturn] = ACTIONS(5109),
    [anon_sym_noreturn] = ACTIONS(5109),
    [anon_sym_mutable] = ACTIONS(5109),
    [anon_sym_constinit] = ACTIONS(5109),
    [anon_sym_consteval] = ACTIONS(5109),
    [anon_sym_PROGMEM] = ACTIONS(5109),
    [anon_sym_QMARK] = ACTIONS(5111),
    [anon_sym_STAR_EQ] = ACTIONS(5111),
    [anon_sym_SLASH_EQ] = ACTIONS(5111),
    [anon_sym_PERCENT_EQ] = ACTIONS(5111),
    [anon_sym_PLUS_EQ] = ACTIONS(5111),
    [anon_sym_DASH_EQ] = ACTIONS(5111),
    [anon_sym_LT_LT_EQ] = ACTIONS(5111),
    [anon_sym_GT_GT_EQ] = ACTIONS(5111),
    [anon_sym_AMP_EQ] = ACTIONS(5111),
    [anon_sym_CARET_EQ] = ACTIONS(5111),
    [anon_sym_PIPE_EQ] = ACTIONS(5111),
    [anon_sym_and_eq] = ACTIONS(5109),
    [anon_sym_or_eq] = ACTIONS(5109),
    [anon_sym_xor_eq] = ACTIONS(5109),
    [anon_sym_LT_EQ_GT] = ACTIONS(5111),
    [anon_sym_or] = ACTIONS(5109),
    [anon_sym_and] = ACTIONS(5109),
    [anon_sym_bitor] = ACTIONS(5109),
    [anon_sym_xor] = ACTIONS(5109),
    [anon_sym_bitand] = ACTIONS(5109),
    [anon_sym_not_eq] = ACTIONS(5109),
    [anon_sym_DASH_DASH] = ACTIONS(5111),
    [anon_sym_PLUS_PLUS] = ACTIONS(5111),
    [anon_sym_DOT] = ACTIONS(5109),
    [anon_sym_DOT_STAR] = ACTIONS(5111),
    [anon_sym_DASH_GT] = ACTIONS(5109),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5109),
    [anon_sym_decltype] = ACTIONS(5109),
    [anon_sym_virtual] = ACTIONS(5109),
    [anon_sym_alignas] = ACTIONS(5109),
    [anon_sym_template] = ACTIONS(5109),
    [anon_sym_operator] = ACTIONS(5109),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5111),
  },
  [1997] = {
    [sym_identifier] = ACTIONS(5150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5152),
    [anon_sym_COMMA] = ACTIONS(5152),
    [anon_sym_RPAREN] = ACTIONS(5152),
    [anon_sym_LPAREN2] = ACTIONS(5152),
    [anon_sym_TILDE] = ACTIONS(5152),
    [anon_sym_DASH] = ACTIONS(5150),
    [anon_sym_PLUS] = ACTIONS(5150),
    [anon_sym_STAR] = ACTIONS(5150),
    [anon_sym_SLASH] = ACTIONS(5150),
    [anon_sym_PERCENT] = ACTIONS(5150),
    [anon_sym_PIPE_PIPE] = ACTIONS(5152),
    [anon_sym_AMP_AMP] = ACTIONS(5152),
    [anon_sym_PIPE] = ACTIONS(5150),
    [anon_sym_CARET] = ACTIONS(5150),
    [anon_sym_AMP] = ACTIONS(5150),
    [anon_sym_EQ_EQ] = ACTIONS(5152),
    [anon_sym_BANG_EQ] = ACTIONS(5152),
    [anon_sym_GT] = ACTIONS(5150),
    [anon_sym_GT_EQ] = ACTIONS(5152),
    [anon_sym_LT_EQ] = ACTIONS(5150),
    [anon_sym_LT] = ACTIONS(5150),
    [anon_sym_LT_LT] = ACTIONS(5150),
    [anon_sym_GT_GT] = ACTIONS(5150),
    [anon_sym___extension__] = ACTIONS(5150),
    [anon_sym_extern] = ACTIONS(5150),
    [anon_sym___attribute__] = ACTIONS(5150),
    [anon_sym_COLON_COLON] = ACTIONS(5152),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5152),
    [anon_sym___declspec] = ACTIONS(5150),
    [anon_sym___based] = ACTIONS(5150),
    [anon_sym_LBRACE] = ACTIONS(5152),
    [anon_sym_LBRACK] = ACTIONS(5150),
    [anon_sym_EQ] = ACTIONS(5150),
    [anon_sym_static] = ACTIONS(5150),
    [anon_sym_register] = ACTIONS(5150),
    [anon_sym_inline] = ACTIONS(5150),
    [anon_sym___inline] = ACTIONS(5150),
    [anon_sym___inline__] = ACTIONS(5150),
    [anon_sym___forceinline] = ACTIONS(5150),
    [anon_sym_thread_local] = ACTIONS(5150),
    [anon_sym___thread] = ACTIONS(5150),
    [anon_sym_const] = ACTIONS(5150),
    [anon_sym_constexpr] = ACTIONS(5150),
    [anon_sym_volatile] = ACTIONS(5150),
    [anon_sym_restrict] = ACTIONS(5150),
    [anon_sym___restrict__] = ACTIONS(5150),
    [anon_sym__Atomic] = ACTIONS(5150),
    [anon_sym__Noreturn] = ACTIONS(5150),
    [anon_sym_noreturn] = ACTIONS(5150),
    [anon_sym_mutable] = ACTIONS(5150),
    [anon_sym_constinit] = ACTIONS(5150),
    [anon_sym_consteval] = ACTIONS(5150),
    [anon_sym_PROGMEM] = ACTIONS(5150),
    [anon_sym_QMARK] = ACTIONS(5152),
    [anon_sym_STAR_EQ] = ACTIONS(5152),
    [anon_sym_SLASH_EQ] = ACTIONS(5152),
    [anon_sym_PERCENT_EQ] = ACTIONS(5152),
    [anon_sym_PLUS_EQ] = ACTIONS(5152),
    [anon_sym_DASH_EQ] = ACTIONS(5152),
    [anon_sym_LT_LT_EQ] = ACTIONS(5152),
    [anon_sym_GT_GT_EQ] = ACTIONS(5152),
    [anon_sym_AMP_EQ] = ACTIONS(5152),
    [anon_sym_CARET_EQ] = ACTIONS(5152),
    [anon_sym_PIPE_EQ] = ACTIONS(5152),
    [anon_sym_and_eq] = ACTIONS(5150),
    [anon_sym_or_eq] = ACTIONS(5150),
    [anon_sym_xor_eq] = ACTIONS(5150),
    [anon_sym_LT_EQ_GT] = ACTIONS(5152),
    [anon_sym_or] = ACTIONS(5150),
    [anon_sym_and] = ACTIONS(5150),
    [anon_sym_bitor] = ACTIONS(5150),
    [anon_sym_xor] = ACTIONS(5150),
    [anon_sym_bitand] = ACTIONS(5150),
    [anon_sym_not_eq] = ACTIONS(5150),
    [anon_sym_DASH_DASH] = ACTIONS(5152),
    [anon_sym_PLUS_PLUS] = ACTIONS(5152),
    [anon_sym_DOT] = ACTIONS(5150),
    [anon_sym_DOT_STAR] = ACTIONS(5152),
    [anon_sym_DASH_GT] = ACTIONS(5150),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5150),
    [anon_sym_decltype] = ACTIONS(5150),
    [anon_sym_virtual] = ACTIONS(5150),
    [anon_sym_alignas] = ACTIONS(5150),
    [anon_sym_template] = ACTIONS(5150),
    [anon_sym_operator] = ACTIONS(5150),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5152),
  },
  [1998] = {
    [sym_identifier] = ACTIONS(5113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5115),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_RPAREN] = ACTIONS(5115),
    [anon_sym_LPAREN2] = ACTIONS(5115),
    [anon_sym_TILDE] = ACTIONS(5115),
    [anon_sym_DASH] = ACTIONS(5113),
    [anon_sym_PLUS] = ACTIONS(5113),
    [anon_sym_STAR] = ACTIONS(5113),
    [anon_sym_SLASH] = ACTIONS(5113),
    [anon_sym_PERCENT] = ACTIONS(5113),
    [anon_sym_PIPE_PIPE] = ACTIONS(5115),
    [anon_sym_AMP_AMP] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(5113),
    [anon_sym_CARET] = ACTIONS(5113),
    [anon_sym_AMP] = ACTIONS(5113),
    [anon_sym_EQ_EQ] = ACTIONS(5115),
    [anon_sym_BANG_EQ] = ACTIONS(5115),
    [anon_sym_GT] = ACTIONS(5113),
    [anon_sym_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_EQ] = ACTIONS(5113),
    [anon_sym_LT] = ACTIONS(5113),
    [anon_sym_LT_LT] = ACTIONS(5113),
    [anon_sym_GT_GT] = ACTIONS(5113),
    [anon_sym___extension__] = ACTIONS(5113),
    [anon_sym_extern] = ACTIONS(5113),
    [anon_sym___attribute__] = ACTIONS(5113),
    [anon_sym_COLON_COLON] = ACTIONS(5115),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5115),
    [anon_sym___declspec] = ACTIONS(5113),
    [anon_sym___based] = ACTIONS(5113),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5113),
    [anon_sym_EQ] = ACTIONS(5113),
    [anon_sym_static] = ACTIONS(5113),
    [anon_sym_register] = ACTIONS(5113),
    [anon_sym_inline] = ACTIONS(5113),
    [anon_sym___inline] = ACTIONS(5113),
    [anon_sym___inline__] = ACTIONS(5113),
    [anon_sym___forceinline] = ACTIONS(5113),
    [anon_sym_thread_local] = ACTIONS(5113),
    [anon_sym___thread] = ACTIONS(5113),
    [anon_sym_const] = ACTIONS(5113),
    [anon_sym_constexpr] = ACTIONS(5113),
    [anon_sym_volatile] = ACTIONS(5113),
    [anon_sym_restrict] = ACTIONS(5113),
    [anon_sym___restrict__] = ACTIONS(5113),
    [anon_sym__Atomic] = ACTIONS(5113),
    [anon_sym__Noreturn] = ACTIONS(5113),
    [anon_sym_noreturn] = ACTIONS(5113),
    [anon_sym_mutable] = ACTIONS(5113),
    [anon_sym_constinit] = ACTIONS(5113),
    [anon_sym_consteval] = ACTIONS(5113),
    [anon_sym_PROGMEM] = ACTIONS(5113),
    [anon_sym_QMARK] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_and_eq] = ACTIONS(5113),
    [anon_sym_or_eq] = ACTIONS(5113),
    [anon_sym_xor_eq] = ACTIONS(5113),
    [anon_sym_LT_EQ_GT] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5113),
    [anon_sym_and] = ACTIONS(5113),
    [anon_sym_bitor] = ACTIONS(5113),
    [anon_sym_xor] = ACTIONS(5113),
    [anon_sym_bitand] = ACTIONS(5113),
    [anon_sym_not_eq] = ACTIONS(5113),
    [anon_sym_DASH_DASH] = ACTIONS(5115),
    [anon_sym_PLUS_PLUS] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(5113),
    [anon_sym_DOT_STAR] = ACTIONS(5115),
    [anon_sym_DASH_GT] = ACTIONS(5113),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5113),
    [anon_sym_decltype] = ACTIONS(5113),
    [anon_sym_virtual] = ACTIONS(5113),
    [anon_sym_alignas] = ACTIONS(5113),
    [anon_sym_template] = ACTIONS(5113),
    [anon_sym_operator] = ACTIONS(5113),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5115),
  },
  [1999] = {
    [sym_identifier] = ACTIONS(5121),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5123),
    [anon_sym_COMMA] = ACTIONS(5123),
    [anon_sym_RPAREN] = ACTIONS(5123),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_TILDE] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5121),
    [anon_sym_PLUS] = ACTIONS(5121),
    [anon_sym_STAR] = ACTIONS(5121),
    [anon_sym_SLASH] = ACTIONS(5121),
    [anon_sym_PERCENT] = ACTIONS(5121),
    [anon_sym_PIPE_PIPE] = ACTIONS(5123),
    [anon_sym_AMP_AMP] = ACTIONS(5123),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_CARET] = ACTIONS(5121),
    [anon_sym_AMP] = ACTIONS(5121),
    [anon_sym_EQ_EQ] = ACTIONS(5123),
    [anon_sym_BANG_EQ] = ACTIONS(5123),
    [anon_sym_GT] = ACTIONS(5121),
    [anon_sym_GT_EQ] = ACTIONS(5123),
    [anon_sym_LT_EQ] = ACTIONS(5121),
    [anon_sym_LT] = ACTIONS(5121),
    [anon_sym_LT_LT] = ACTIONS(5121),
    [anon_sym_GT_GT] = ACTIONS(5121),
    [anon_sym___extension__] = ACTIONS(5121),
    [anon_sym_extern] = ACTIONS(5121),
    [anon_sym___attribute__] = ACTIONS(5121),
    [anon_sym_COLON_COLON] = ACTIONS(5123),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5123),
    [anon_sym___declspec] = ACTIONS(5121),
    [anon_sym___based] = ACTIONS(5121),
    [anon_sym_LBRACE] = ACTIONS(5123),
    [anon_sym_LBRACK] = ACTIONS(5121),
    [anon_sym_EQ] = ACTIONS(5121),
    [anon_sym_static] = ACTIONS(5121),
    [anon_sym_register] = ACTIONS(5121),
    [anon_sym_inline] = ACTIONS(5121),
    [anon_sym___inline] = ACTIONS(5121),
    [anon_sym___inline__] = ACTIONS(5121),
    [anon_sym___forceinline] = ACTIONS(5121),
    [anon_sym_thread_local] = ACTIONS(5121),
    [anon_sym___thread] = ACTIONS(5121),
    [anon_sym_const] = ACTIONS(5121),
    [anon_sym_constexpr] = ACTIONS(5121),
    [anon_sym_volatile] = ACTIONS(5121),
    [anon_sym_restrict] = ACTIONS(5121),
    [anon_sym___restrict__] = ACTIONS(5121),
    [anon_sym__Atomic] = ACTIONS(5121),
    [anon_sym__Noreturn] = ACTIONS(5121),
    [anon_sym_noreturn] = ACTIONS(5121),
    [anon_sym_mutable] = ACTIONS(5121),
    [anon_sym_constinit] = ACTIONS(5121),
    [anon_sym_consteval] = ACTIONS(5121),
    [anon_sym_PROGMEM] = ACTIONS(5121),
    [anon_sym_QMARK] = ACTIONS(5123),
    [anon_sym_STAR_EQ] = ACTIONS(5123),
    [anon_sym_SLASH_EQ] = ACTIONS(5123),
    [anon_sym_PERCENT_EQ] = ACTIONS(5123),
    [anon_sym_PLUS_EQ] = ACTIONS(5123),
    [anon_sym_DASH_EQ] = ACTIONS(5123),
    [anon_sym_LT_LT_EQ] = ACTIONS(5123),
    [anon_sym_GT_GT_EQ] = ACTIONS(5123),
    [anon_sym_AMP_EQ] = ACTIONS(5123),
    [anon_sym_CARET_EQ] = ACTIONS(5123),
    [anon_sym_PIPE_EQ] = ACTIONS(5123),
    [anon_sym_and_eq] = ACTIONS(5121),
    [anon_sym_or_eq] = ACTIONS(5121),
    [anon_sym_xor_eq] = ACTIONS(5121),
    [anon_sym_LT_EQ_GT] = ACTIONS(5123),
    [anon_sym_or] = ACTIONS(5121),
    [anon_sym_and] = ACTIONS(5121),
    [anon_sym_bitor] = ACTIONS(5121),
    [anon_sym_xor] = ACTIONS(5121),
    [anon_sym_bitand] = ACTIONS(5121),
    [anon_sym_not_eq] = ACTIONS(5121),
    [anon_sym_DASH_DASH] = ACTIONS(5123),
    [anon_sym_PLUS_PLUS] = ACTIONS(5123),
    [anon_sym_DOT] = ACTIONS(5121),
    [anon_sym_DOT_STAR] = ACTIONS(5123),
    [anon_sym_DASH_GT] = ACTIONS(5121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5121),
    [anon_sym_decltype] = ACTIONS(5121),
    [anon_sym_virtual] = ACTIONS(5121),
    [anon_sym_alignas] = ACTIONS(5121),
    [anon_sym_template] = ACTIONS(5121),
    [anon_sym_operator] = ACTIONS(5121),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5123),
  },
  [2000] = {
    [sym_identifier] = ACTIONS(5125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5127),
    [anon_sym_COMMA] = ACTIONS(5127),
    [anon_sym_RPAREN] = ACTIONS(5127),
    [anon_sym_LPAREN2] = ACTIONS(5127),
    [anon_sym_TILDE] = ACTIONS(5127),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_PLUS] = ACTIONS(5125),
    [anon_sym_STAR] = ACTIONS(5125),
    [anon_sym_SLASH] = ACTIONS(5125),
    [anon_sym_PERCENT] = ACTIONS(5125),
    [anon_sym_PIPE_PIPE] = ACTIONS(5127),
    [anon_sym_AMP_AMP] = ACTIONS(5127),
    [anon_sym_PIPE] = ACTIONS(5125),
    [anon_sym_CARET] = ACTIONS(5125),
    [anon_sym_AMP] = ACTIONS(5125),
    [anon_sym_EQ_EQ] = ACTIONS(5127),
    [anon_sym_BANG_EQ] = ACTIONS(5127),
    [anon_sym_GT] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5127),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_LT] = ACTIONS(5125),
    [anon_sym_LT_LT] = ACTIONS(5125),
    [anon_sym_GT_GT] = ACTIONS(5125),
    [anon_sym___extension__] = ACTIONS(5125),
    [anon_sym_extern] = ACTIONS(5125),
    [anon_sym___attribute__] = ACTIONS(5125),
    [anon_sym_COLON_COLON] = ACTIONS(5127),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5127),
    [anon_sym___declspec] = ACTIONS(5125),
    [anon_sym___based] = ACTIONS(5125),
    [anon_sym_LBRACE] = ACTIONS(5127),
    [anon_sym_LBRACK] = ACTIONS(5125),
    [anon_sym_EQ] = ACTIONS(5125),
    [anon_sym_static] = ACTIONS(5125),
    [anon_sym_register] = ACTIONS(5125),
    [anon_sym_inline] = ACTIONS(5125),
    [anon_sym___inline] = ACTIONS(5125),
    [anon_sym___inline__] = ACTIONS(5125),
    [anon_sym___forceinline] = ACTIONS(5125),
    [anon_sym_thread_local] = ACTIONS(5125),
    [anon_sym___thread] = ACTIONS(5125),
    [anon_sym_const] = ACTIONS(5125),
    [anon_sym_constexpr] = ACTIONS(5125),
    [anon_sym_volatile] = ACTIONS(5125),
    [anon_sym_restrict] = ACTIONS(5125),
    [anon_sym___restrict__] = ACTIONS(5125),
    [anon_sym__Atomic] = ACTIONS(5125),
    [anon_sym__Noreturn] = ACTIONS(5125),
    [anon_sym_noreturn] = ACTIONS(5125),
    [anon_sym_mutable] = ACTIONS(5125),
    [anon_sym_constinit] = ACTIONS(5125),
    [anon_sym_consteval] = ACTIONS(5125),
    [anon_sym_PROGMEM] = ACTIONS(5125),
    [anon_sym_QMARK] = ACTIONS(5127),
    [anon_sym_STAR_EQ] = ACTIONS(5127),
    [anon_sym_SLASH_EQ] = ACTIONS(5127),
    [anon_sym_PERCENT_EQ] = ACTIONS(5127),
    [anon_sym_PLUS_EQ] = ACTIONS(5127),
    [anon_sym_DASH_EQ] = ACTIONS(5127),
    [anon_sym_LT_LT_EQ] = ACTIONS(5127),
    [anon_sym_GT_GT_EQ] = ACTIONS(5127),
    [anon_sym_AMP_EQ] = ACTIONS(5127),
    [anon_sym_CARET_EQ] = ACTIONS(5127),
    [anon_sym_PIPE_EQ] = ACTIONS(5127),
    [anon_sym_and_eq] = ACTIONS(5125),
    [anon_sym_or_eq] = ACTIONS(5125),
    [anon_sym_xor_eq] = ACTIONS(5125),
    [anon_sym_LT_EQ_GT] = ACTIONS(5127),
    [anon_sym_or] = ACTIONS(5125),
    [anon_sym_and] = ACTIONS(5125),
    [anon_sym_bitor] = ACTIONS(5125),
    [anon_sym_xor] = ACTIONS(5125),
    [anon_sym_bitand] = ACTIONS(5125),
    [anon_sym_not_eq] = ACTIONS(5125),
    [anon_sym_DASH_DASH] = ACTIONS(5127),
    [anon_sym_PLUS_PLUS] = ACTIONS(5127),
    [anon_sym_DOT] = ACTIONS(5125),
    [anon_sym_DOT_STAR] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5125),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5125),
    [anon_sym_decltype] = ACTIONS(5125),
    [anon_sym_virtual] = ACTIONS(5125),
    [anon_sym_alignas] = ACTIONS(5125),
    [anon_sym_template] = ACTIONS(5125),
    [anon_sym_operator] = ACTIONS(5125),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5127),
  },
  [2001] = {
    [sym_identifier] = ACTIONS(5160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5162),
    [anon_sym_COMMA] = ACTIONS(5162),
    [anon_sym_RPAREN] = ACTIONS(5162),
    [anon_sym_LPAREN2] = ACTIONS(5164),
    [anon_sym_TILDE] = ACTIONS(5167),
    [anon_sym_DASH] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5169),
    [anon_sym_STAR] = ACTIONS(5171),
    [anon_sym_SLASH] = ACTIONS(5169),
    [anon_sym_PERCENT] = ACTIONS(5169),
    [anon_sym_PIPE_PIPE] = ACTIONS(5162),
    [anon_sym_AMP_AMP] = ACTIONS(5164),
    [anon_sym_PIPE] = ACTIONS(5169),
    [anon_sym_CARET] = ACTIONS(5169),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_EQ] = ACTIONS(5162),
    [anon_sym_GT] = ACTIONS(5169),
    [anon_sym_GT_EQ] = ACTIONS(5162),
    [anon_sym_LT_EQ] = ACTIONS(5169),
    [anon_sym_LT] = ACTIONS(5169),
    [anon_sym_LT_LT] = ACTIONS(5169),
    [anon_sym_GT_GT] = ACTIONS(5169),
    [anon_sym_SEMI] = ACTIONS(5162),
    [anon_sym___extension__] = ACTIONS(5160),
    [anon_sym_extern] = ACTIONS(5160),
    [anon_sym___attribute__] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5167),
    [anon_sym___declspec] = ACTIONS(5160),
    [anon_sym___based] = ACTIONS(5160),
    [anon_sym_LBRACE] = ACTIONS(5167),
    [anon_sym_LBRACK] = ACTIONS(5171),
    [anon_sym_EQ] = ACTIONS(5169),
    [anon_sym_static] = ACTIONS(5160),
    [anon_sym_register] = ACTIONS(5160),
    [anon_sym_inline] = ACTIONS(5160),
    [anon_sym___inline] = ACTIONS(5160),
    [anon_sym___inline__] = ACTIONS(5160),
    [anon_sym___forceinline] = ACTIONS(5160),
    [anon_sym_thread_local] = ACTIONS(5160),
    [anon_sym___thread] = ACTIONS(5160),
    [anon_sym_const] = ACTIONS(5160),
    [anon_sym_constexpr] = ACTIONS(5160),
    [anon_sym_volatile] = ACTIONS(5160),
    [anon_sym_restrict] = ACTIONS(5160),
    [anon_sym___restrict__] = ACTIONS(5160),
    [anon_sym__Atomic] = ACTIONS(5160),
    [anon_sym__Noreturn] = ACTIONS(5160),
    [anon_sym_noreturn] = ACTIONS(5160),
    [anon_sym_mutable] = ACTIONS(5160),
    [anon_sym_constinit] = ACTIONS(5160),
    [anon_sym_consteval] = ACTIONS(5160),
    [anon_sym_PROGMEM] = ACTIONS(5160),
    [anon_sym_QMARK] = ACTIONS(5162),
    [anon_sym_STAR_EQ] = ACTIONS(5162),
    [anon_sym_SLASH_EQ] = ACTIONS(5162),
    [anon_sym_PERCENT_EQ] = ACTIONS(5162),
    [anon_sym_PLUS_EQ] = ACTIONS(5162),
    [anon_sym_DASH_EQ] = ACTIONS(5162),
    [anon_sym_LT_LT_EQ] = ACTIONS(5162),
    [anon_sym_GT_GT_EQ] = ACTIONS(5162),
    [anon_sym_AMP_EQ] = ACTIONS(5162),
    [anon_sym_CARET_EQ] = ACTIONS(5162),
    [anon_sym_PIPE_EQ] = ACTIONS(5162),
    [anon_sym_and_eq] = ACTIONS(5169),
    [anon_sym_or_eq] = ACTIONS(5169),
    [anon_sym_xor_eq] = ACTIONS(5169),
    [anon_sym_LT_EQ_GT] = ACTIONS(5162),
    [anon_sym_or] = ACTIONS(5169),
    [anon_sym_and] = ACTIONS(5169),
    [anon_sym_bitor] = ACTIONS(5169),
    [anon_sym_xor] = ACTIONS(5169),
    [anon_sym_bitand] = ACTIONS(5169),
    [anon_sym_not_eq] = ACTIONS(5169),
    [anon_sym_DASH_DASH] = ACTIONS(5162),
    [anon_sym_PLUS_PLUS] = ACTIONS(5162),
    [anon_sym_DOT] = ACTIONS(5169),
    [anon_sym_DOT_STAR] = ACTIONS(5162),
    [anon_sym_DASH_GT] = ACTIONS(5162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5160),
    [anon_sym_decltype] = ACTIONS(5160),
    [anon_sym_virtual] = ACTIONS(5160),
    [anon_sym_alignas] = ACTIONS(5160),
    [anon_sym_template] = ACTIONS(5160),
    [anon_sym_operator] = ACTIONS(5160),
  },
  [2002] = {
    [sym_identifier] = ACTIONS(5160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5164),
    [anon_sym_COMMA] = ACTIONS(5164),
    [anon_sym_RPAREN] = ACTIONS(5164),
    [anon_sym_LPAREN2] = ACTIONS(5164),
    [anon_sym_TILDE] = ACTIONS(5167),
    [anon_sym_DASH] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5169),
    [anon_sym_STAR] = ACTIONS(5171),
    [anon_sym_SLASH] = ACTIONS(5169),
    [anon_sym_PERCENT] = ACTIONS(5169),
    [anon_sym_PIPE_PIPE] = ACTIONS(5162),
    [anon_sym_AMP_AMP] = ACTIONS(5164),
    [anon_sym_PIPE] = ACTIONS(5169),
    [anon_sym_CARET] = ACTIONS(5169),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_EQ] = ACTIONS(5162),
    [anon_sym_GT] = ACTIONS(5169),
    [anon_sym_GT_EQ] = ACTIONS(5162),
    [anon_sym_LT_EQ] = ACTIONS(5169),
    [anon_sym_LT] = ACTIONS(5169),
    [anon_sym_LT_LT] = ACTIONS(5169),
    [anon_sym_GT_GT] = ACTIONS(5169),
    [anon_sym___extension__] = ACTIONS(5160),
    [anon_sym_extern] = ACTIONS(5160),
    [anon_sym___attribute__] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5167),
    [anon_sym___declspec] = ACTIONS(5160),
    [anon_sym___based] = ACTIONS(5160),
    [anon_sym_LBRACE] = ACTIONS(5167),
    [anon_sym_LBRACK] = ACTIONS(5171),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_static] = ACTIONS(5160),
    [anon_sym_register] = ACTIONS(5160),
    [anon_sym_inline] = ACTIONS(5160),
    [anon_sym___inline] = ACTIONS(5160),
    [anon_sym___inline__] = ACTIONS(5160),
    [anon_sym___forceinline] = ACTIONS(5160),
    [anon_sym_thread_local] = ACTIONS(5160),
    [anon_sym___thread] = ACTIONS(5160),
    [anon_sym_const] = ACTIONS(5160),
    [anon_sym_constexpr] = ACTIONS(5160),
    [anon_sym_volatile] = ACTIONS(5160),
    [anon_sym_restrict] = ACTIONS(5160),
    [anon_sym___restrict__] = ACTIONS(5160),
    [anon_sym__Atomic] = ACTIONS(5160),
    [anon_sym__Noreturn] = ACTIONS(5160),
    [anon_sym_noreturn] = ACTIONS(5160),
    [anon_sym_mutable] = ACTIONS(5160),
    [anon_sym_constinit] = ACTIONS(5160),
    [anon_sym_consteval] = ACTIONS(5160),
    [anon_sym_PROGMEM] = ACTIONS(5160),
    [anon_sym_QMARK] = ACTIONS(5162),
    [anon_sym_STAR_EQ] = ACTIONS(5162),
    [anon_sym_SLASH_EQ] = ACTIONS(5162),
    [anon_sym_PERCENT_EQ] = ACTIONS(5162),
    [anon_sym_PLUS_EQ] = ACTIONS(5162),
    [anon_sym_DASH_EQ] = ACTIONS(5162),
    [anon_sym_LT_LT_EQ] = ACTIONS(5162),
    [anon_sym_GT_GT_EQ] = ACTIONS(5162),
    [anon_sym_AMP_EQ] = ACTIONS(5162),
    [anon_sym_CARET_EQ] = ACTIONS(5162),
    [anon_sym_PIPE_EQ] = ACTIONS(5162),
    [anon_sym_and_eq] = ACTIONS(5169),
    [anon_sym_or_eq] = ACTIONS(5169),
    [anon_sym_xor_eq] = ACTIONS(5169),
    [anon_sym_LT_EQ_GT] = ACTIONS(5162),
    [anon_sym_or] = ACTIONS(5169),
    [anon_sym_and] = ACTIONS(5169),
    [anon_sym_bitor] = ACTIONS(5169),
    [anon_sym_xor] = ACTIONS(5169),
    [anon_sym_bitand] = ACTIONS(5169),
    [anon_sym_not_eq] = ACTIONS(5169),
    [anon_sym_DASH_DASH] = ACTIONS(5162),
    [anon_sym_PLUS_PLUS] = ACTIONS(5162),
    [anon_sym_DOT] = ACTIONS(5169),
    [anon_sym_DOT_STAR] = ACTIONS(5162),
    [anon_sym_DASH_GT] = ACTIONS(5169),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5160),
    [anon_sym_decltype] = ACTIONS(5160),
    [anon_sym_virtual] = ACTIONS(5160),
    [anon_sym_alignas] = ACTIONS(5160),
    [anon_sym_template] = ACTIONS(5160),
    [anon_sym_operator] = ACTIONS(5160),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5162),
  },
  [2003] = {
    [sym_identifier] = ACTIONS(5113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5115),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_RPAREN] = ACTIONS(5115),
    [anon_sym_LPAREN2] = ACTIONS(5115),
    [anon_sym_TILDE] = ACTIONS(5115),
    [anon_sym_DASH] = ACTIONS(5113),
    [anon_sym_PLUS] = ACTIONS(5113),
    [anon_sym_STAR] = ACTIONS(5115),
    [anon_sym_SLASH] = ACTIONS(5113),
    [anon_sym_PERCENT] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(5115),
    [anon_sym_AMP_AMP] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(5113),
    [anon_sym_CARET] = ACTIONS(5115),
    [anon_sym_AMP] = ACTIONS(5113),
    [anon_sym_EQ_EQ] = ACTIONS(5115),
    [anon_sym_BANG_EQ] = ACTIONS(5115),
    [anon_sym_GT] = ACTIONS(5113),
    [anon_sym_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_EQ] = ACTIONS(5113),
    [anon_sym_LT] = ACTIONS(5113),
    [anon_sym_LT_LT] = ACTIONS(5115),
    [anon_sym_GT_GT] = ACTIONS(5115),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym___extension__] = ACTIONS(5113),
    [anon_sym_extern] = ACTIONS(5113),
    [anon_sym___attribute__] = ACTIONS(5113),
    [anon_sym_COLON_COLON] = ACTIONS(5115),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5115),
    [anon_sym___declspec] = ACTIONS(5113),
    [anon_sym___based] = ACTIONS(5113),
    [anon_sym___cdecl] = ACTIONS(5113),
    [anon_sym___clrcall] = ACTIONS(5113),
    [anon_sym___stdcall] = ACTIONS(5113),
    [anon_sym___fastcall] = ACTIONS(5113),
    [anon_sym___thiscall] = ACTIONS(5113),
    [anon_sym___vectorcall] = ACTIONS(5113),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_RBRACE] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5113),
    [anon_sym_EQ] = ACTIONS(5113),
    [anon_sym_static] = ACTIONS(5113),
    [anon_sym_register] = ACTIONS(5113),
    [anon_sym_inline] = ACTIONS(5113),
    [anon_sym___inline] = ACTIONS(5113),
    [anon_sym___inline__] = ACTIONS(5113),
    [anon_sym___forceinline] = ACTIONS(5113),
    [anon_sym_thread_local] = ACTIONS(5113),
    [anon_sym___thread] = ACTIONS(5113),
    [anon_sym_const] = ACTIONS(5113),
    [anon_sym_constexpr] = ACTIONS(5113),
    [anon_sym_volatile] = ACTIONS(5113),
    [anon_sym_restrict] = ACTIONS(5113),
    [anon_sym___restrict__] = ACTIONS(5113),
    [anon_sym__Atomic] = ACTIONS(5113),
    [anon_sym__Noreturn] = ACTIONS(5113),
    [anon_sym_noreturn] = ACTIONS(5113),
    [anon_sym_mutable] = ACTIONS(5113),
    [anon_sym_constinit] = ACTIONS(5113),
    [anon_sym_consteval] = ACTIONS(5113),
    [anon_sym_PROGMEM] = ACTIONS(5113),
    [anon_sym_COLON] = ACTIONS(5113),
    [anon_sym_QMARK] = ACTIONS(5115),
    [anon_sym_LT_EQ_GT] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5113),
    [anon_sym_and] = ACTIONS(5113),
    [anon_sym_bitor] = ACTIONS(5113),
    [anon_sym_xor] = ACTIONS(5113),
    [anon_sym_bitand] = ACTIONS(5113),
    [anon_sym_not_eq] = ACTIONS(5113),
    [anon_sym_DASH_DASH] = ACTIONS(5115),
    [anon_sym_PLUS_PLUS] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(5113),
    [anon_sym_DOT_STAR] = ACTIONS(5115),
    [anon_sym_DASH_GT] = ACTIONS(5115),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5113),
    [anon_sym_decltype] = ACTIONS(5113),
    [anon_sym_final] = ACTIONS(5113),
    [anon_sym_override] = ACTIONS(5113),
    [anon_sym_virtual] = ACTIONS(5113),
    [anon_sym_alignas] = ACTIONS(5113),
    [anon_sym_template] = ACTIONS(5113),
    [anon_sym_operator] = ACTIONS(5113),
    [anon_sym_try] = ACTIONS(5113),
    [anon_sym_requires] = ACTIONS(5113),
  },
  [2004] = {
    [sym_identifier] = ACTIONS(5109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5111),
    [anon_sym_COMMA] = ACTIONS(5111),
    [anon_sym_RPAREN] = ACTIONS(5111),
    [anon_sym_LPAREN2] = ACTIONS(5111),
    [anon_sym_TILDE] = ACTIONS(5111),
    [anon_sym_DASH] = ACTIONS(5109),
    [anon_sym_PLUS] = ACTIONS(5109),
    [anon_sym_STAR] = ACTIONS(5111),
    [anon_sym_SLASH] = ACTIONS(5109),
    [anon_sym_PERCENT] = ACTIONS(5111),
    [anon_sym_PIPE_PIPE] = ACTIONS(5111),
    [anon_sym_AMP_AMP] = ACTIONS(5111),
    [anon_sym_PIPE] = ACTIONS(5109),
    [anon_sym_CARET] = ACTIONS(5111),
    [anon_sym_AMP] = ACTIONS(5109),
    [anon_sym_EQ_EQ] = ACTIONS(5111),
    [anon_sym_BANG_EQ] = ACTIONS(5111),
    [anon_sym_GT] = ACTIONS(5109),
    [anon_sym_GT_EQ] = ACTIONS(5111),
    [anon_sym_LT_EQ] = ACTIONS(5109),
    [anon_sym_LT] = ACTIONS(5109),
    [anon_sym_LT_LT] = ACTIONS(5111),
    [anon_sym_GT_GT] = ACTIONS(5111),
    [anon_sym_SEMI] = ACTIONS(5111),
    [anon_sym___extension__] = ACTIONS(5109),
    [anon_sym_extern] = ACTIONS(5109),
    [anon_sym___attribute__] = ACTIONS(5109),
    [anon_sym_COLON_COLON] = ACTIONS(5111),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5111),
    [anon_sym___declspec] = ACTIONS(5109),
    [anon_sym___based] = ACTIONS(5109),
    [anon_sym___cdecl] = ACTIONS(5109),
    [anon_sym___clrcall] = ACTIONS(5109),
    [anon_sym___stdcall] = ACTIONS(5109),
    [anon_sym___fastcall] = ACTIONS(5109),
    [anon_sym___thiscall] = ACTIONS(5109),
    [anon_sym___vectorcall] = ACTIONS(5109),
    [anon_sym_LBRACE] = ACTIONS(5111),
    [anon_sym_RBRACE] = ACTIONS(5111),
    [anon_sym_LBRACK] = ACTIONS(5109),
    [anon_sym_EQ] = ACTIONS(5109),
    [anon_sym_static] = ACTIONS(5109),
    [anon_sym_register] = ACTIONS(5109),
    [anon_sym_inline] = ACTIONS(5109),
    [anon_sym___inline] = ACTIONS(5109),
    [anon_sym___inline__] = ACTIONS(5109),
    [anon_sym___forceinline] = ACTIONS(5109),
    [anon_sym_thread_local] = ACTIONS(5109),
    [anon_sym___thread] = ACTIONS(5109),
    [anon_sym_const] = ACTIONS(5109),
    [anon_sym_constexpr] = ACTIONS(5109),
    [anon_sym_volatile] = ACTIONS(5109),
    [anon_sym_restrict] = ACTIONS(5109),
    [anon_sym___restrict__] = ACTIONS(5109),
    [anon_sym__Atomic] = ACTIONS(5109),
    [anon_sym__Noreturn] = ACTIONS(5109),
    [anon_sym_noreturn] = ACTIONS(5109),
    [anon_sym_mutable] = ACTIONS(5109),
    [anon_sym_constinit] = ACTIONS(5109),
    [anon_sym_consteval] = ACTIONS(5109),
    [anon_sym_PROGMEM] = ACTIONS(5109),
    [anon_sym_COLON] = ACTIONS(5109),
    [anon_sym_QMARK] = ACTIONS(5111),
    [anon_sym_LT_EQ_GT] = ACTIONS(5111),
    [anon_sym_or] = ACTIONS(5109),
    [anon_sym_and] = ACTIONS(5109),
    [anon_sym_bitor] = ACTIONS(5109),
    [anon_sym_xor] = ACTIONS(5109),
    [anon_sym_bitand] = ACTIONS(5109),
    [anon_sym_not_eq] = ACTIONS(5109),
    [anon_sym_DASH_DASH] = ACTIONS(5111),
    [anon_sym_PLUS_PLUS] = ACTIONS(5111),
    [anon_sym_DOT] = ACTIONS(5109),
    [anon_sym_DOT_STAR] = ACTIONS(5111),
    [anon_sym_DASH_GT] = ACTIONS(5111),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5109),
    [anon_sym_decltype] = ACTIONS(5109),
    [anon_sym_final] = ACTIONS(5109),
    [anon_sym_override] = ACTIONS(5109),
    [anon_sym_virtual] = ACTIONS(5109),
    [anon_sym_alignas] = ACTIONS(5109),
    [anon_sym_template] = ACTIONS(5109),
    [anon_sym_operator] = ACTIONS(5109),
    [anon_sym_try] = ACTIONS(5109),
    [anon_sym_requires] = ACTIONS(5109),
  },
  [2005] = {
    [sym_identifier] = ACTIONS(5117),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(5119),
    [anon_sym_RPAREN] = ACTIONS(5119),
    [anon_sym_LPAREN2] = ACTIONS(5119),
    [anon_sym_TILDE] = ACTIONS(5119),
    [anon_sym_DASH] = ACTIONS(5117),
    [anon_sym_PLUS] = ACTIONS(5117),
    [anon_sym_STAR] = ACTIONS(5119),
    [anon_sym_SLASH] = ACTIONS(5117),
    [anon_sym_PERCENT] = ACTIONS(5119),
    [anon_sym_PIPE_PIPE] = ACTIONS(5119),
    [anon_sym_AMP_AMP] = ACTIONS(5119),
    [anon_sym_PIPE] = ACTIONS(5117),
    [anon_sym_CARET] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5117),
    [anon_sym_EQ_EQ] = ACTIONS(5119),
    [anon_sym_BANG_EQ] = ACTIONS(5119),
    [anon_sym_GT] = ACTIONS(5117),
    [anon_sym_GT_EQ] = ACTIONS(5119),
    [anon_sym_LT_EQ] = ACTIONS(5117),
    [anon_sym_LT] = ACTIONS(5117),
    [anon_sym_LT_LT] = ACTIONS(5119),
    [anon_sym_GT_GT] = ACTIONS(5119),
    [anon_sym_SEMI] = ACTIONS(5119),
    [anon_sym___extension__] = ACTIONS(5117),
    [anon_sym_extern] = ACTIONS(5117),
    [anon_sym___attribute__] = ACTIONS(5117),
    [anon_sym_COLON_COLON] = ACTIONS(5119),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5119),
    [anon_sym___declspec] = ACTIONS(5117),
    [anon_sym___based] = ACTIONS(5117),
    [anon_sym___cdecl] = ACTIONS(5117),
    [anon_sym___clrcall] = ACTIONS(5117),
    [anon_sym___stdcall] = ACTIONS(5117),
    [anon_sym___fastcall] = ACTIONS(5117),
    [anon_sym___thiscall] = ACTIONS(5117),
    [anon_sym___vectorcall] = ACTIONS(5117),
    [anon_sym_LBRACE] = ACTIONS(5119),
    [anon_sym_RBRACE] = ACTIONS(5119),
    [anon_sym_LBRACK] = ACTIONS(5117),
    [anon_sym_EQ] = ACTIONS(5117),
    [anon_sym_static] = ACTIONS(5117),
    [anon_sym_register] = ACTIONS(5117),
    [anon_sym_inline] = ACTIONS(5117),
    [anon_sym___inline] = ACTIONS(5117),
    [anon_sym___inline__] = ACTIONS(5117),
    [anon_sym___forceinline] = ACTIONS(5117),
    [anon_sym_thread_local] = ACTIONS(5117),
    [anon_sym___thread] = ACTIONS(5117),
    [anon_sym_const] = ACTIONS(5117),
    [anon_sym_constexpr] = ACTIONS(5117),
    [anon_sym_volatile] = ACTIONS(5117),
    [anon_sym_restrict] = ACTIONS(5117),
    [anon_sym___restrict__] = ACTIONS(5117),
    [anon_sym__Atomic] = ACTIONS(5117),
    [anon_sym__Noreturn] = ACTIONS(5117),
    [anon_sym_noreturn] = ACTIONS(5117),
    [anon_sym_mutable] = ACTIONS(5117),
    [anon_sym_constinit] = ACTIONS(5117),
    [anon_sym_consteval] = ACTIONS(5117),
    [anon_sym_PROGMEM] = ACTIONS(5117),
    [anon_sym_COLON] = ACTIONS(5117),
    [anon_sym_QMARK] = ACTIONS(5119),
    [anon_sym_LT_EQ_GT] = ACTIONS(5119),
    [anon_sym_or] = ACTIONS(5117),
    [anon_sym_and] = ACTIONS(5117),
    [anon_sym_bitor] = ACTIONS(5117),
    [anon_sym_xor] = ACTIONS(5117),
    [anon_sym_bitand] = ACTIONS(5117),
    [anon_sym_not_eq] = ACTIONS(5117),
    [anon_sym_DASH_DASH] = ACTIONS(5119),
    [anon_sym_PLUS_PLUS] = ACTIONS(5119),
    [anon_sym_DOT] = ACTIONS(5117),
    [anon_sym_DOT_STAR] = ACTIONS(5119),
    [anon_sym_DASH_GT] = ACTIONS(5119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5117),
    [anon_sym_decltype] = ACTIONS(5117),
    [anon_sym_final] = ACTIONS(5117),
    [anon_sym_override] = ACTIONS(5117),
    [anon_sym_virtual] = ACTIONS(5117),
    [anon_sym_alignas] = ACTIONS(5117),
    [anon_sym_template] = ACTIONS(5117),
    [anon_sym_operator] = ACTIONS(5117),
    [anon_sym_try] = ACTIONS(5117),
    [anon_sym_requires] = ACTIONS(5117),
  },
  [2006] = {
    [sym_string_literal] = STATE(2616),
    [sym_template_argument_list] = STATE(2408),
    [sym_raw_string_literal] = STATE(2616),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2671),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_RPAREN] = ACTIONS(4261),
    [anon_sym_LPAREN2] = ACTIONS(4261),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4258),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4261),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4258),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5188),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym___extension__] = ACTIONS(4254),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_signed] = ACTIONS(5182),
    [anon_sym_unsigned] = ACTIONS(5182),
    [anon_sym_long] = ACTIONS(5182),
    [anon_sym_short] = ACTIONS(5182),
    [anon_sym_LBRACK] = ACTIONS(4261),
    [anon_sym_EQ] = ACTIONS(4256),
    [anon_sym_const] = ACTIONS(4246),
    [anon_sym_constexpr] = ACTIONS(4254),
    [anon_sym_volatile] = ACTIONS(4254),
    [anon_sym_restrict] = ACTIONS(4254),
    [anon_sym___restrict__] = ACTIONS(4254),
    [anon_sym__Atomic] = ACTIONS(4254),
    [anon_sym__Noreturn] = ACTIONS(4254),
    [anon_sym_noreturn] = ACTIONS(4254),
    [anon_sym_mutable] = ACTIONS(4254),
    [anon_sym_constinit] = ACTIONS(4254),
    [anon_sym_consteval] = ACTIONS(4254),
    [anon_sym_PROGMEM] = ACTIONS(4254),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4248),
    [anon_sym_SLASH_EQ] = ACTIONS(4248),
    [anon_sym_PERCENT_EQ] = ACTIONS(4248),
    [anon_sym_PLUS_EQ] = ACTIONS(4248),
    [anon_sym_DASH_EQ] = ACTIONS(4248),
    [anon_sym_LT_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT_GT_EQ] = ACTIONS(4248),
    [anon_sym_AMP_EQ] = ACTIONS(4248),
    [anon_sym_CARET_EQ] = ACTIONS(4248),
    [anon_sym_PIPE_EQ] = ACTIONS(4248),
    [anon_sym_and_eq] = ACTIONS(4248),
    [anon_sym_or_eq] = ACTIONS(4248),
    [anon_sym_xor_eq] = ACTIONS(4248),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4256),
    [anon_sym_L_DQUOTE] = ACTIONS(5184),
    [anon_sym_u_DQUOTE] = ACTIONS(5184),
    [anon_sym_U_DQUOTE] = ACTIONS(5184),
    [anon_sym_u8_DQUOTE] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4254),
    [anon_sym_decltype] = ACTIONS(4254),
    [anon_sym_R_DQUOTE] = ACTIONS(5186),
    [anon_sym_LR_DQUOTE] = ACTIONS(5186),
    [anon_sym_uR_DQUOTE] = ACTIONS(5186),
    [anon_sym_UR_DQUOTE] = ACTIONS(5186),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5186),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4248),
  },
  [2007] = {
    [sym_identifier] = ACTIONS(5121),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5123),
    [anon_sym_COMMA] = ACTIONS(5123),
    [anon_sym_RPAREN] = ACTIONS(5123),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_TILDE] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5121),
    [anon_sym_PLUS] = ACTIONS(5121),
    [anon_sym_STAR] = ACTIONS(5123),
    [anon_sym_SLASH] = ACTIONS(5121),
    [anon_sym_PERCENT] = ACTIONS(5123),
    [anon_sym_PIPE_PIPE] = ACTIONS(5123),
    [anon_sym_AMP_AMP] = ACTIONS(5123),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_CARET] = ACTIONS(5123),
    [anon_sym_AMP] = ACTIONS(5121),
    [anon_sym_EQ_EQ] = ACTIONS(5123),
    [anon_sym_BANG_EQ] = ACTIONS(5123),
    [anon_sym_GT] = ACTIONS(5121),
    [anon_sym_GT_EQ] = ACTIONS(5123),
    [anon_sym_LT_EQ] = ACTIONS(5121),
    [anon_sym_LT] = ACTIONS(5121),
    [anon_sym_LT_LT] = ACTIONS(5123),
    [anon_sym_GT_GT] = ACTIONS(5123),
    [anon_sym_SEMI] = ACTIONS(5123),
    [anon_sym___extension__] = ACTIONS(5121),
    [anon_sym_extern] = ACTIONS(5121),
    [anon_sym___attribute__] = ACTIONS(5121),
    [anon_sym_COLON_COLON] = ACTIONS(5123),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5123),
    [anon_sym___declspec] = ACTIONS(5121),
    [anon_sym___based] = ACTIONS(5121),
    [anon_sym___cdecl] = ACTIONS(5121),
    [anon_sym___clrcall] = ACTIONS(5121),
    [anon_sym___stdcall] = ACTIONS(5121),
    [anon_sym___fastcall] = ACTIONS(5121),
    [anon_sym___thiscall] = ACTIONS(5121),
    [anon_sym___vectorcall] = ACTIONS(5121),
    [anon_sym_LBRACE] = ACTIONS(5123),
    [anon_sym_RBRACE] = ACTIONS(5123),
    [anon_sym_LBRACK] = ACTIONS(5121),
    [anon_sym_EQ] = ACTIONS(5121),
    [anon_sym_static] = ACTIONS(5121),
    [anon_sym_register] = ACTIONS(5121),
    [anon_sym_inline] = ACTIONS(5121),
    [anon_sym___inline] = ACTIONS(5121),
    [anon_sym___inline__] = ACTIONS(5121),
    [anon_sym___forceinline] = ACTIONS(5121),
    [anon_sym_thread_local] = ACTIONS(5121),
    [anon_sym___thread] = ACTIONS(5121),
    [anon_sym_const] = ACTIONS(5121),
    [anon_sym_constexpr] = ACTIONS(5121),
    [anon_sym_volatile] = ACTIONS(5121),
    [anon_sym_restrict] = ACTIONS(5121),
    [anon_sym___restrict__] = ACTIONS(5121),
    [anon_sym__Atomic] = ACTIONS(5121),
    [anon_sym__Noreturn] = ACTIONS(5121),
    [anon_sym_noreturn] = ACTIONS(5121),
    [anon_sym_mutable] = ACTIONS(5121),
    [anon_sym_constinit] = ACTIONS(5121),
    [anon_sym_consteval] = ACTIONS(5121),
    [anon_sym_PROGMEM] = ACTIONS(5121),
    [anon_sym_COLON] = ACTIONS(5121),
    [anon_sym_QMARK] = ACTIONS(5123),
    [anon_sym_LT_EQ_GT] = ACTIONS(5123),
    [anon_sym_or] = ACTIONS(5121),
    [anon_sym_and] = ACTIONS(5121),
    [anon_sym_bitor] = ACTIONS(5121),
    [anon_sym_xor] = ACTIONS(5121),
    [anon_sym_bitand] = ACTIONS(5121),
    [anon_sym_not_eq] = ACTIONS(5121),
    [anon_sym_DASH_DASH] = ACTIONS(5123),
    [anon_sym_PLUS_PLUS] = ACTIONS(5123),
    [anon_sym_DOT] = ACTIONS(5121),
    [anon_sym_DOT_STAR] = ACTIONS(5123),
    [anon_sym_DASH_GT] = ACTIONS(5123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5121),
    [anon_sym_decltype] = ACTIONS(5121),
    [anon_sym_final] = ACTIONS(5121),
    [anon_sym_override] = ACTIONS(5121),
    [anon_sym_virtual] = ACTIONS(5121),
    [anon_sym_alignas] = ACTIONS(5121),
    [anon_sym_template] = ACTIONS(5121),
    [anon_sym_operator] = ACTIONS(5121),
    [anon_sym_try] = ACTIONS(5121),
    [anon_sym_requires] = ACTIONS(5121),
  },
  [2008] = {
    [sym_identifier] = ACTIONS(5125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5127),
    [anon_sym_COMMA] = ACTIONS(5127),
    [anon_sym_RPAREN] = ACTIONS(5127),
    [anon_sym_LPAREN2] = ACTIONS(5127),
    [anon_sym_TILDE] = ACTIONS(5127),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_PLUS] = ACTIONS(5125),
    [anon_sym_STAR] = ACTIONS(5127),
    [anon_sym_SLASH] = ACTIONS(5125),
    [anon_sym_PERCENT] = ACTIONS(5127),
    [anon_sym_PIPE_PIPE] = ACTIONS(5127),
    [anon_sym_AMP_AMP] = ACTIONS(5127),
    [anon_sym_PIPE] = ACTIONS(5125),
    [anon_sym_CARET] = ACTIONS(5127),
    [anon_sym_AMP] = ACTIONS(5125),
    [anon_sym_EQ_EQ] = ACTIONS(5127),
    [anon_sym_BANG_EQ] = ACTIONS(5127),
    [anon_sym_GT] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5127),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_LT] = ACTIONS(5125),
    [anon_sym_LT_LT] = ACTIONS(5127),
    [anon_sym_GT_GT] = ACTIONS(5127),
    [anon_sym_SEMI] = ACTIONS(5127),
    [anon_sym___extension__] = ACTIONS(5125),
    [anon_sym_extern] = ACTIONS(5125),
    [anon_sym___attribute__] = ACTIONS(5125),
    [anon_sym_COLON_COLON] = ACTIONS(5127),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5127),
    [anon_sym___declspec] = ACTIONS(5125),
    [anon_sym___based] = ACTIONS(5125),
    [anon_sym___cdecl] = ACTIONS(5125),
    [anon_sym___clrcall] = ACTIONS(5125),
    [anon_sym___stdcall] = ACTIONS(5125),
    [anon_sym___fastcall] = ACTIONS(5125),
    [anon_sym___thiscall] = ACTIONS(5125),
    [anon_sym___vectorcall] = ACTIONS(5125),
    [anon_sym_LBRACE] = ACTIONS(5127),
    [anon_sym_RBRACE] = ACTIONS(5127),
    [anon_sym_LBRACK] = ACTIONS(5125),
    [anon_sym_EQ] = ACTIONS(5125),
    [anon_sym_static] = ACTIONS(5125),
    [anon_sym_register] = ACTIONS(5125),
    [anon_sym_inline] = ACTIONS(5125),
    [anon_sym___inline] = ACTIONS(5125),
    [anon_sym___inline__] = ACTIONS(5125),
    [anon_sym___forceinline] = ACTIONS(5125),
    [anon_sym_thread_local] = ACTIONS(5125),
    [anon_sym___thread] = ACTIONS(5125),
    [anon_sym_const] = ACTIONS(5125),
    [anon_sym_constexpr] = ACTIONS(5125),
    [anon_sym_volatile] = ACTIONS(5125),
    [anon_sym_restrict] = ACTIONS(5125),
    [anon_sym___restrict__] = ACTIONS(5125),
    [anon_sym__Atomic] = ACTIONS(5125),
    [anon_sym__Noreturn] = ACTIONS(5125),
    [anon_sym_noreturn] = ACTIONS(5125),
    [anon_sym_mutable] = ACTIONS(5125),
    [anon_sym_constinit] = ACTIONS(5125),
    [anon_sym_consteval] = ACTIONS(5125),
    [anon_sym_PROGMEM] = ACTIONS(5125),
    [anon_sym_COLON] = ACTIONS(5125),
    [anon_sym_QMARK] = ACTIONS(5127),
    [anon_sym_LT_EQ_GT] = ACTIONS(5127),
    [anon_sym_or] = ACTIONS(5125),
    [anon_sym_and] = ACTIONS(5125),
    [anon_sym_bitor] = ACTIONS(5125),
    [anon_sym_xor] = ACTIONS(5125),
    [anon_sym_bitand] = ACTIONS(5125),
    [anon_sym_not_eq] = ACTIONS(5125),
    [anon_sym_DASH_DASH] = ACTIONS(5127),
    [anon_sym_PLUS_PLUS] = ACTIONS(5127),
    [anon_sym_DOT] = ACTIONS(5125),
    [anon_sym_DOT_STAR] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5127),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5125),
    [anon_sym_decltype] = ACTIONS(5125),
    [anon_sym_final] = ACTIONS(5125),
    [anon_sym_override] = ACTIONS(5125),
    [anon_sym_virtual] = ACTIONS(5125),
    [anon_sym_alignas] = ACTIONS(5125),
    [anon_sym_template] = ACTIONS(5125),
    [anon_sym_operator] = ACTIONS(5125),
    [anon_sym_try] = ACTIONS(5125),
    [anon_sym_requires] = ACTIONS(5125),
  },
  [2009] = {
    [sym_identifier] = ACTIONS(5150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5152),
    [anon_sym_COMMA] = ACTIONS(5152),
    [anon_sym_RPAREN] = ACTIONS(5152),
    [anon_sym_LPAREN2] = ACTIONS(5152),
    [anon_sym_TILDE] = ACTIONS(5152),
    [anon_sym_DASH] = ACTIONS(5150),
    [anon_sym_PLUS] = ACTIONS(5150),
    [anon_sym_STAR] = ACTIONS(5152),
    [anon_sym_SLASH] = ACTIONS(5150),
    [anon_sym_PERCENT] = ACTIONS(5152),
    [anon_sym_PIPE_PIPE] = ACTIONS(5152),
    [anon_sym_AMP_AMP] = ACTIONS(5152),
    [anon_sym_PIPE] = ACTIONS(5150),
    [anon_sym_CARET] = ACTIONS(5152),
    [anon_sym_AMP] = ACTIONS(5150),
    [anon_sym_EQ_EQ] = ACTIONS(5152),
    [anon_sym_BANG_EQ] = ACTIONS(5152),
    [anon_sym_GT] = ACTIONS(5150),
    [anon_sym_GT_EQ] = ACTIONS(5152),
    [anon_sym_LT_EQ] = ACTIONS(5150),
    [anon_sym_LT] = ACTIONS(5150),
    [anon_sym_LT_LT] = ACTIONS(5152),
    [anon_sym_GT_GT] = ACTIONS(5152),
    [anon_sym_SEMI] = ACTIONS(5152),
    [anon_sym___extension__] = ACTIONS(5150),
    [anon_sym_extern] = ACTIONS(5150),
    [anon_sym___attribute__] = ACTIONS(5150),
    [anon_sym_COLON_COLON] = ACTIONS(5152),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5152),
    [anon_sym___declspec] = ACTIONS(5150),
    [anon_sym___based] = ACTIONS(5150),
    [anon_sym___cdecl] = ACTIONS(5150),
    [anon_sym___clrcall] = ACTIONS(5150),
    [anon_sym___stdcall] = ACTIONS(5150),
    [anon_sym___fastcall] = ACTIONS(5150),
    [anon_sym___thiscall] = ACTIONS(5150),
    [anon_sym___vectorcall] = ACTIONS(5150),
    [anon_sym_LBRACE] = ACTIONS(5152),
    [anon_sym_RBRACE] = ACTIONS(5152),
    [anon_sym_LBRACK] = ACTIONS(5150),
    [anon_sym_EQ] = ACTIONS(5150),
    [anon_sym_static] = ACTIONS(5150),
    [anon_sym_register] = ACTIONS(5150),
    [anon_sym_inline] = ACTIONS(5150),
    [anon_sym___inline] = ACTIONS(5150),
    [anon_sym___inline__] = ACTIONS(5150),
    [anon_sym___forceinline] = ACTIONS(5150),
    [anon_sym_thread_local] = ACTIONS(5150),
    [anon_sym___thread] = ACTIONS(5150),
    [anon_sym_const] = ACTIONS(5150),
    [anon_sym_constexpr] = ACTIONS(5150),
    [anon_sym_volatile] = ACTIONS(5150),
    [anon_sym_restrict] = ACTIONS(5150),
    [anon_sym___restrict__] = ACTIONS(5150),
    [anon_sym__Atomic] = ACTIONS(5150),
    [anon_sym__Noreturn] = ACTIONS(5150),
    [anon_sym_noreturn] = ACTIONS(5150),
    [anon_sym_mutable] = ACTIONS(5150),
    [anon_sym_constinit] = ACTIONS(5150),
    [anon_sym_consteval] = ACTIONS(5150),
    [anon_sym_PROGMEM] = ACTIONS(5150),
    [anon_sym_COLON] = ACTIONS(5150),
    [anon_sym_QMARK] = ACTIONS(5152),
    [anon_sym_LT_EQ_GT] = ACTIONS(5152),
    [anon_sym_or] = ACTIONS(5150),
    [anon_sym_and] = ACTIONS(5150),
    [anon_sym_bitor] = ACTIONS(5150),
    [anon_sym_xor] = ACTIONS(5150),
    [anon_sym_bitand] = ACTIONS(5150),
    [anon_sym_not_eq] = ACTIONS(5150),
    [anon_sym_DASH_DASH] = ACTIONS(5152),
    [anon_sym_PLUS_PLUS] = ACTIONS(5152),
    [anon_sym_DOT] = ACTIONS(5150),
    [anon_sym_DOT_STAR] = ACTIONS(5152),
    [anon_sym_DASH_GT] = ACTIONS(5152),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5150),
    [anon_sym_decltype] = ACTIONS(5150),
    [anon_sym_final] = ACTIONS(5150),
    [anon_sym_override] = ACTIONS(5150),
    [anon_sym_virtual] = ACTIONS(5150),
    [anon_sym_alignas] = ACTIONS(5150),
    [anon_sym_template] = ACTIONS(5150),
    [anon_sym_operator] = ACTIONS(5150),
    [anon_sym_try] = ACTIONS(5150),
    [anon_sym_requires] = ACTIONS(5150),
  },
  [2010] = {
    [sym_identifier] = ACTIONS(5160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5164),
    [anon_sym_COMMA] = ACTIONS(5164),
    [anon_sym_RPAREN] = ACTIONS(5164),
    [anon_sym_LPAREN2] = ACTIONS(5164),
    [anon_sym_TILDE] = ACTIONS(5167),
    [anon_sym_DASH] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5169),
    [anon_sym_STAR] = ACTIONS(5171),
    [anon_sym_SLASH] = ACTIONS(5169),
    [anon_sym_PERCENT] = ACTIONS(5169),
    [anon_sym_PIPE_PIPE] = ACTIONS(5162),
    [anon_sym_AMP_AMP] = ACTIONS(5164),
    [anon_sym_PIPE] = ACTIONS(5169),
    [anon_sym_CARET] = ACTIONS(5169),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_EQ] = ACTIONS(5162),
    [anon_sym_GT] = ACTIONS(5169),
    [anon_sym_GT_EQ] = ACTIONS(5162),
    [anon_sym_LT_EQ] = ACTIONS(5169),
    [anon_sym_LT] = ACTIONS(5169),
    [anon_sym_LT_LT] = ACTIONS(5169),
    [anon_sym_GT_GT] = ACTIONS(5169),
    [anon_sym___extension__] = ACTIONS(5160),
    [anon_sym_extern] = ACTIONS(5160),
    [anon_sym___attribute__] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5167),
    [anon_sym___declspec] = ACTIONS(5160),
    [anon_sym___based] = ACTIONS(5160),
    [anon_sym_LBRACE] = ACTIONS(5167),
    [anon_sym_LBRACK] = ACTIONS(5171),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_static] = ACTIONS(5160),
    [anon_sym_register] = ACTIONS(5160),
    [anon_sym_inline] = ACTIONS(5160),
    [anon_sym___inline] = ACTIONS(5160),
    [anon_sym___inline__] = ACTIONS(5160),
    [anon_sym___forceinline] = ACTIONS(5160),
    [anon_sym_thread_local] = ACTIONS(5160),
    [anon_sym___thread] = ACTIONS(5160),
    [anon_sym_const] = ACTIONS(5160),
    [anon_sym_constexpr] = ACTIONS(5160),
    [anon_sym_volatile] = ACTIONS(5160),
    [anon_sym_restrict] = ACTIONS(5160),
    [anon_sym___restrict__] = ACTIONS(5160),
    [anon_sym__Atomic] = ACTIONS(5160),
    [anon_sym__Noreturn] = ACTIONS(5160),
    [anon_sym_noreturn] = ACTIONS(5160),
    [anon_sym_mutable] = ACTIONS(5160),
    [anon_sym_constinit] = ACTIONS(5160),
    [anon_sym_consteval] = ACTIONS(5160),
    [anon_sym_PROGMEM] = ACTIONS(5160),
    [anon_sym_QMARK] = ACTIONS(5162),
    [anon_sym_STAR_EQ] = ACTIONS(5162),
    [anon_sym_SLASH_EQ] = ACTIONS(5162),
    [anon_sym_PERCENT_EQ] = ACTIONS(5162),
    [anon_sym_PLUS_EQ] = ACTIONS(5162),
    [anon_sym_DASH_EQ] = ACTIONS(5162),
    [anon_sym_LT_LT_EQ] = ACTIONS(5162),
    [anon_sym_GT_GT_EQ] = ACTIONS(5162),
    [anon_sym_AMP_EQ] = ACTIONS(5162),
    [anon_sym_CARET_EQ] = ACTIONS(5162),
    [anon_sym_PIPE_EQ] = ACTIONS(5162),
    [anon_sym_and_eq] = ACTIONS(5169),
    [anon_sym_or_eq] = ACTIONS(5169),
    [anon_sym_xor_eq] = ACTIONS(5169),
    [anon_sym_LT_EQ_GT] = ACTIONS(5162),
    [anon_sym_or] = ACTIONS(5169),
    [anon_sym_and] = ACTIONS(5169),
    [anon_sym_bitor] = ACTIONS(5169),
    [anon_sym_xor] = ACTIONS(5169),
    [anon_sym_bitand] = ACTIONS(5169),
    [anon_sym_not_eq] = ACTIONS(5169),
    [anon_sym_DASH_DASH] = ACTIONS(5162),
    [anon_sym_PLUS_PLUS] = ACTIONS(5162),
    [anon_sym_DOT] = ACTIONS(5169),
    [anon_sym_DOT_STAR] = ACTIONS(5162),
    [anon_sym_DASH_GT] = ACTIONS(5162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5160),
    [anon_sym_decltype] = ACTIONS(5160),
    [anon_sym_virtual] = ACTIONS(5160),
    [anon_sym_alignas] = ACTIONS(5160),
    [anon_sym_template] = ACTIONS(5160),
    [anon_sym_operator] = ACTIONS(5160),
  },
  [2011] = {
    [sym_identifier] = ACTIONS(5146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5148),
    [anon_sym_COMMA] = ACTIONS(5148),
    [anon_sym_RPAREN] = ACTIONS(5148),
    [anon_sym_LPAREN2] = ACTIONS(5148),
    [anon_sym_TILDE] = ACTIONS(5148),
    [anon_sym_DASH] = ACTIONS(5146),
    [anon_sym_PLUS] = ACTIONS(5146),
    [anon_sym_STAR] = ACTIONS(5148),
    [anon_sym_SLASH] = ACTIONS(5146),
    [anon_sym_PERCENT] = ACTIONS(5148),
    [anon_sym_PIPE_PIPE] = ACTIONS(5148),
    [anon_sym_AMP_AMP] = ACTIONS(5148),
    [anon_sym_PIPE] = ACTIONS(5146),
    [anon_sym_CARET] = ACTIONS(5148),
    [anon_sym_AMP] = ACTIONS(5146),
    [anon_sym_EQ_EQ] = ACTIONS(5148),
    [anon_sym_BANG_EQ] = ACTIONS(5148),
    [anon_sym_GT] = ACTIONS(5146),
    [anon_sym_GT_EQ] = ACTIONS(5148),
    [anon_sym_LT_EQ] = ACTIONS(5146),
    [anon_sym_LT] = ACTIONS(5146),
    [anon_sym_LT_LT] = ACTIONS(5148),
    [anon_sym_GT_GT] = ACTIONS(5148),
    [anon_sym_SEMI] = ACTIONS(5148),
    [anon_sym___extension__] = ACTIONS(5146),
    [anon_sym_extern] = ACTIONS(5146),
    [anon_sym___attribute__] = ACTIONS(5146),
    [anon_sym_COLON_COLON] = ACTIONS(5148),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5148),
    [anon_sym___declspec] = ACTIONS(5146),
    [anon_sym___based] = ACTIONS(5146),
    [anon_sym___cdecl] = ACTIONS(5146),
    [anon_sym___clrcall] = ACTIONS(5146),
    [anon_sym___stdcall] = ACTIONS(5146),
    [anon_sym___fastcall] = ACTIONS(5146),
    [anon_sym___thiscall] = ACTIONS(5146),
    [anon_sym___vectorcall] = ACTIONS(5146),
    [anon_sym_LBRACE] = ACTIONS(5148),
    [anon_sym_RBRACE] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5146),
    [anon_sym_EQ] = ACTIONS(5146),
    [anon_sym_static] = ACTIONS(5146),
    [anon_sym_register] = ACTIONS(5146),
    [anon_sym_inline] = ACTIONS(5146),
    [anon_sym___inline] = ACTIONS(5146),
    [anon_sym___inline__] = ACTIONS(5146),
    [anon_sym___forceinline] = ACTIONS(5146),
    [anon_sym_thread_local] = ACTIONS(5146),
    [anon_sym___thread] = ACTIONS(5146),
    [anon_sym_const] = ACTIONS(5146),
    [anon_sym_constexpr] = ACTIONS(5146),
    [anon_sym_volatile] = ACTIONS(5146),
    [anon_sym_restrict] = ACTIONS(5146),
    [anon_sym___restrict__] = ACTIONS(5146),
    [anon_sym__Atomic] = ACTIONS(5146),
    [anon_sym__Noreturn] = ACTIONS(5146),
    [anon_sym_noreturn] = ACTIONS(5146),
    [anon_sym_mutable] = ACTIONS(5146),
    [anon_sym_constinit] = ACTIONS(5146),
    [anon_sym_consteval] = ACTIONS(5146),
    [anon_sym_PROGMEM] = ACTIONS(5146),
    [anon_sym_COLON] = ACTIONS(5146),
    [anon_sym_QMARK] = ACTIONS(5148),
    [anon_sym_LT_EQ_GT] = ACTIONS(5148),
    [anon_sym_or] = ACTIONS(5146),
    [anon_sym_and] = ACTIONS(5146),
    [anon_sym_bitor] = ACTIONS(5146),
    [anon_sym_xor] = ACTIONS(5146),
    [anon_sym_bitand] = ACTIONS(5146),
    [anon_sym_not_eq] = ACTIONS(5146),
    [anon_sym_DASH_DASH] = ACTIONS(5148),
    [anon_sym_PLUS_PLUS] = ACTIONS(5148),
    [anon_sym_DOT] = ACTIONS(5146),
    [anon_sym_DOT_STAR] = ACTIONS(5148),
    [anon_sym_DASH_GT] = ACTIONS(5148),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5146),
    [anon_sym_decltype] = ACTIONS(5146),
    [anon_sym_final] = ACTIONS(5146),
    [anon_sym_override] = ACTIONS(5146),
    [anon_sym_virtual] = ACTIONS(5146),
    [anon_sym_alignas] = ACTIONS(5146),
    [anon_sym_template] = ACTIONS(5146),
    [anon_sym_operator] = ACTIONS(5146),
    [anon_sym_try] = ACTIONS(5146),
    [anon_sym_requires] = ACTIONS(5146),
  },
  [2012] = {
    [sym_string_literal] = STATE(4043),
    [sym_template_argument_list] = STATE(3674),
    [sym_raw_string_literal] = STATE(4043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4261),
    [anon_sym_COMMA] = ACTIONS(4261),
    [anon_sym_LPAREN2] = ACTIONS(4261),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4258),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4261),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4258),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4256),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5191),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym___extension__] = ACTIONS(4254),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_signed] = ACTIONS(5194),
    [anon_sym_unsigned] = ACTIONS(5194),
    [anon_sym_long] = ACTIONS(5194),
    [anon_sym_short] = ACTIONS(5194),
    [anon_sym_LBRACK] = ACTIONS(4261),
    [anon_sym_EQ] = ACTIONS(5196),
    [anon_sym_const] = ACTIONS(4246),
    [anon_sym_constexpr] = ACTIONS(4254),
    [anon_sym_volatile] = ACTIONS(4254),
    [anon_sym_restrict] = ACTIONS(4254),
    [anon_sym___restrict__] = ACTIONS(4254),
    [anon_sym__Atomic] = ACTIONS(4254),
    [anon_sym__Noreturn] = ACTIONS(4254),
    [anon_sym_noreturn] = ACTIONS(4254),
    [anon_sym_mutable] = ACTIONS(4254),
    [anon_sym_constinit] = ACTIONS(4254),
    [anon_sym_consteval] = ACTIONS(4254),
    [anon_sym_PROGMEM] = ACTIONS(4254),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(5198),
    [anon_sym_SLASH_EQ] = ACTIONS(5198),
    [anon_sym_PERCENT_EQ] = ACTIONS(5198),
    [anon_sym_PLUS_EQ] = ACTIONS(5198),
    [anon_sym_DASH_EQ] = ACTIONS(5198),
    [anon_sym_LT_LT_EQ] = ACTIONS(5198),
    [anon_sym_GT_GT_EQ] = ACTIONS(5196),
    [anon_sym_AMP_EQ] = ACTIONS(5198),
    [anon_sym_CARET_EQ] = ACTIONS(5198),
    [anon_sym_PIPE_EQ] = ACTIONS(5198),
    [anon_sym_and_eq] = ACTIONS(5198),
    [anon_sym_or_eq] = ACTIONS(5198),
    [anon_sym_xor_eq] = ACTIONS(5198),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(5200),
    [anon_sym_u_DQUOTE] = ACTIONS(5200),
    [anon_sym_U_DQUOTE] = ACTIONS(5200),
    [anon_sym_u8_DQUOTE] = ACTIONS(5200),
    [anon_sym_DQUOTE] = ACTIONS(5200),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4254),
    [anon_sym_decltype] = ACTIONS(4254),
    [anon_sym_GT2] = ACTIONS(4261),
    [anon_sym_R_DQUOTE] = ACTIONS(5202),
    [anon_sym_LR_DQUOTE] = ACTIONS(5202),
    [anon_sym_uR_DQUOTE] = ACTIONS(5202),
    [anon_sym_UR_DQUOTE] = ACTIONS(5202),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5202),
  },
  [2013] = {
    [sym_identifier] = ACTIONS(5113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5115),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_RPAREN] = ACTIONS(5115),
    [anon_sym_LPAREN2] = ACTIONS(5115),
    [anon_sym_TILDE] = ACTIONS(5115),
    [anon_sym_DASH] = ACTIONS(5113),
    [anon_sym_PLUS] = ACTIONS(5113),
    [anon_sym_STAR] = ACTIONS(5113),
    [anon_sym_SLASH] = ACTIONS(5113),
    [anon_sym_PERCENT] = ACTIONS(5113),
    [anon_sym_PIPE_PIPE] = ACTIONS(5115),
    [anon_sym_AMP_AMP] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(5113),
    [anon_sym_CARET] = ACTIONS(5113),
    [anon_sym_AMP] = ACTIONS(5113),
    [anon_sym_EQ_EQ] = ACTIONS(5115),
    [anon_sym_BANG_EQ] = ACTIONS(5115),
    [anon_sym_GT] = ACTIONS(5113),
    [anon_sym_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_EQ] = ACTIONS(5113),
    [anon_sym_LT] = ACTIONS(5113),
    [anon_sym_LT_LT] = ACTIONS(5113),
    [anon_sym_GT_GT] = ACTIONS(5113),
    [anon_sym___extension__] = ACTIONS(5113),
    [anon_sym_extern] = ACTIONS(5113),
    [anon_sym___attribute__] = ACTIONS(5113),
    [anon_sym_COLON_COLON] = ACTIONS(5115),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5115),
    [anon_sym___declspec] = ACTIONS(5113),
    [anon_sym___based] = ACTIONS(5113),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5113),
    [anon_sym_EQ] = ACTIONS(5113),
    [anon_sym_static] = ACTIONS(5113),
    [anon_sym_register] = ACTIONS(5113),
    [anon_sym_inline] = ACTIONS(5113),
    [anon_sym___inline] = ACTIONS(5113),
    [anon_sym___inline__] = ACTIONS(5113),
    [anon_sym___forceinline] = ACTIONS(5113),
    [anon_sym_thread_local] = ACTIONS(5113),
    [anon_sym___thread] = ACTIONS(5113),
    [anon_sym_const] = ACTIONS(5113),
    [anon_sym_constexpr] = ACTIONS(5113),
    [anon_sym_volatile] = ACTIONS(5113),
    [anon_sym_restrict] = ACTIONS(5113),
    [anon_sym___restrict__] = ACTIONS(5113),
    [anon_sym__Atomic] = ACTIONS(5113),
    [anon_sym__Noreturn] = ACTIONS(5113),
    [anon_sym_noreturn] = ACTIONS(5113),
    [anon_sym_mutable] = ACTIONS(5113),
    [anon_sym_constinit] = ACTIONS(5113),
    [anon_sym_consteval] = ACTIONS(5113),
    [anon_sym_PROGMEM] = ACTIONS(5113),
    [anon_sym_QMARK] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_LT_EQ_GT] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5113),
    [anon_sym_and] = ACTIONS(5113),
    [anon_sym_bitor] = ACTIONS(5113),
    [anon_sym_xor] = ACTIONS(5113),
    [anon_sym_bitand] = ACTIONS(5113),
    [anon_sym_not_eq] = ACTIONS(5113),
    [anon_sym_DASH_DASH] = ACTIONS(5115),
    [anon_sym_PLUS_PLUS] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(5113),
    [anon_sym_DOT_STAR] = ACTIONS(5115),
    [anon_sym_DASH_GT] = ACTIONS(5113),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5113),
    [anon_sym_decltype] = ACTIONS(5113),
    [anon_sym_virtual] = ACTIONS(5113),
    [anon_sym_alignas] = ACTIONS(5113),
    [anon_sym_template] = ACTIONS(5113),
    [anon_sym_operator] = ACTIONS(5113),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5115),
  },
  [2014] = {
    [sym_identifier] = ACTIONS(5150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5152),
    [anon_sym_COMMA] = ACTIONS(5152),
    [anon_sym_RPAREN] = ACTIONS(5152),
    [anon_sym_LPAREN2] = ACTIONS(5152),
    [anon_sym_TILDE] = ACTIONS(5152),
    [anon_sym_DASH] = ACTIONS(5150),
    [anon_sym_PLUS] = ACTIONS(5150),
    [anon_sym_STAR] = ACTIONS(5150),
    [anon_sym_SLASH] = ACTIONS(5150),
    [anon_sym_PERCENT] = ACTIONS(5150),
    [anon_sym_PIPE_PIPE] = ACTIONS(5152),
    [anon_sym_AMP_AMP] = ACTIONS(5152),
    [anon_sym_PIPE] = ACTIONS(5150),
    [anon_sym_CARET] = ACTIONS(5150),
    [anon_sym_AMP] = ACTIONS(5150),
    [anon_sym_EQ_EQ] = ACTIONS(5152),
    [anon_sym_BANG_EQ] = ACTIONS(5152),
    [anon_sym_GT] = ACTIONS(5150),
    [anon_sym_GT_EQ] = ACTIONS(5152),
    [anon_sym_LT_EQ] = ACTIONS(5150),
    [anon_sym_LT] = ACTIONS(5150),
    [anon_sym_LT_LT] = ACTIONS(5150),
    [anon_sym_GT_GT] = ACTIONS(5150),
    [anon_sym___extension__] = ACTIONS(5150),
    [anon_sym_extern] = ACTIONS(5150),
    [anon_sym___attribute__] = ACTIONS(5150),
    [anon_sym_COLON_COLON] = ACTIONS(5152),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5152),
    [anon_sym___declspec] = ACTIONS(5150),
    [anon_sym___based] = ACTIONS(5150),
    [anon_sym_LBRACE] = ACTIONS(5152),
    [anon_sym_LBRACK] = ACTIONS(5150),
    [anon_sym_EQ] = ACTIONS(5150),
    [anon_sym_static] = ACTIONS(5150),
    [anon_sym_register] = ACTIONS(5150),
    [anon_sym_inline] = ACTIONS(5150),
    [anon_sym___inline] = ACTIONS(5150),
    [anon_sym___inline__] = ACTIONS(5150),
    [anon_sym___forceinline] = ACTIONS(5150),
    [anon_sym_thread_local] = ACTIONS(5150),
    [anon_sym___thread] = ACTIONS(5150),
    [anon_sym_const] = ACTIONS(5150),
    [anon_sym_constexpr] = ACTIONS(5150),
    [anon_sym_volatile] = ACTIONS(5150),
    [anon_sym_restrict] = ACTIONS(5150),
    [anon_sym___restrict__] = ACTIONS(5150),
    [anon_sym__Atomic] = ACTIONS(5150),
    [anon_sym__Noreturn] = ACTIONS(5150),
    [anon_sym_noreturn] = ACTIONS(5150),
    [anon_sym_mutable] = ACTIONS(5150),
    [anon_sym_constinit] = ACTIONS(5150),
    [anon_sym_consteval] = ACTIONS(5150),
    [anon_sym_PROGMEM] = ACTIONS(5150),
    [anon_sym_QMARK] = ACTIONS(5152),
    [anon_sym_STAR_EQ] = ACTIONS(5152),
    [anon_sym_SLASH_EQ] = ACTIONS(5152),
    [anon_sym_PERCENT_EQ] = ACTIONS(5152),
    [anon_sym_PLUS_EQ] = ACTIONS(5152),
    [anon_sym_DASH_EQ] = ACTIONS(5152),
    [anon_sym_LT_LT_EQ] = ACTIONS(5152),
    [anon_sym_GT_GT_EQ] = ACTIONS(5152),
    [anon_sym_AMP_EQ] = ACTIONS(5152),
    [anon_sym_CARET_EQ] = ACTIONS(5152),
    [anon_sym_PIPE_EQ] = ACTIONS(5152),
    [anon_sym_LT_EQ_GT] = ACTIONS(5152),
    [anon_sym_or] = ACTIONS(5150),
    [anon_sym_and] = ACTIONS(5150),
    [anon_sym_bitor] = ACTIONS(5150),
    [anon_sym_xor] = ACTIONS(5150),
    [anon_sym_bitand] = ACTIONS(5150),
    [anon_sym_not_eq] = ACTIONS(5150),
    [anon_sym_DASH_DASH] = ACTIONS(5152),
    [anon_sym_PLUS_PLUS] = ACTIONS(5152),
    [anon_sym_DOT] = ACTIONS(5150),
    [anon_sym_DOT_STAR] = ACTIONS(5152),
    [anon_sym_DASH_GT] = ACTIONS(5150),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5150),
    [anon_sym_decltype] = ACTIONS(5150),
    [anon_sym_virtual] = ACTIONS(5150),
    [anon_sym_alignas] = ACTIONS(5150),
    [anon_sym_template] = ACTIONS(5150),
    [anon_sym_operator] = ACTIONS(5150),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5152),
  },
  [2015] = {
    [sym_identifier] = ACTIONS(5117),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(5119),
    [anon_sym_RPAREN] = ACTIONS(5119),
    [anon_sym_LPAREN2] = ACTIONS(5119),
    [anon_sym_TILDE] = ACTIONS(5119),
    [anon_sym_DASH] = ACTIONS(5117),
    [anon_sym_PLUS] = ACTIONS(5117),
    [anon_sym_STAR] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5117),
    [anon_sym_PERCENT] = ACTIONS(5117),
    [anon_sym_PIPE_PIPE] = ACTIONS(5119),
    [anon_sym_AMP_AMP] = ACTIONS(5119),
    [anon_sym_PIPE] = ACTIONS(5117),
    [anon_sym_CARET] = ACTIONS(5117),
    [anon_sym_AMP] = ACTIONS(5117),
    [anon_sym_EQ_EQ] = ACTIONS(5119),
    [anon_sym_BANG_EQ] = ACTIONS(5119),
    [anon_sym_GT] = ACTIONS(5117),
    [anon_sym_GT_EQ] = ACTIONS(5119),
    [anon_sym_LT_EQ] = ACTIONS(5117),
    [anon_sym_LT] = ACTIONS(5117),
    [anon_sym_LT_LT] = ACTIONS(5117),
    [anon_sym_GT_GT] = ACTIONS(5117),
    [anon_sym___extension__] = ACTIONS(5117),
    [anon_sym_extern] = ACTIONS(5117),
    [anon_sym___attribute__] = ACTIONS(5117),
    [anon_sym_COLON_COLON] = ACTIONS(5119),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5119),
    [anon_sym___declspec] = ACTIONS(5117),
    [anon_sym___based] = ACTIONS(5117),
    [anon_sym_LBRACE] = ACTIONS(5119),
    [anon_sym_LBRACK] = ACTIONS(5117),
    [anon_sym_EQ] = ACTIONS(5117),
    [anon_sym_static] = ACTIONS(5117),
    [anon_sym_register] = ACTIONS(5117),
    [anon_sym_inline] = ACTIONS(5117),
    [anon_sym___inline] = ACTIONS(5117),
    [anon_sym___inline__] = ACTIONS(5117),
    [anon_sym___forceinline] = ACTIONS(5117),
    [anon_sym_thread_local] = ACTIONS(5117),
    [anon_sym___thread] = ACTIONS(5117),
    [anon_sym_const] = ACTIONS(5117),
    [anon_sym_constexpr] = ACTIONS(5117),
    [anon_sym_volatile] = ACTIONS(5117),
    [anon_sym_restrict] = ACTIONS(5117),
    [anon_sym___restrict__] = ACTIONS(5117),
    [anon_sym__Atomic] = ACTIONS(5117),
    [anon_sym__Noreturn] = ACTIONS(5117),
    [anon_sym_noreturn] = ACTIONS(5117),
    [anon_sym_mutable] = ACTIONS(5117),
    [anon_sym_constinit] = ACTIONS(5117),
    [anon_sym_consteval] = ACTIONS(5117),
    [anon_sym_PROGMEM] = ACTIONS(5117),
    [anon_sym_QMARK] = ACTIONS(5119),
    [anon_sym_STAR_EQ] = ACTIONS(5119),
    [anon_sym_SLASH_EQ] = ACTIONS(5119),
    [anon_sym_PERCENT_EQ] = ACTIONS(5119),
    [anon_sym_PLUS_EQ] = ACTIONS(5119),
    [anon_sym_DASH_EQ] = ACTIONS(5119),
    [anon_sym_LT_LT_EQ] = ACTIONS(5119),
    [anon_sym_GT_GT_EQ] = ACTIONS(5119),
    [anon_sym_AMP_EQ] = ACTIONS(5119),
    [anon_sym_CARET_EQ] = ACTIONS(5119),
    [anon_sym_PIPE_EQ] = ACTIONS(5119),
    [anon_sym_LT_EQ_GT] = ACTIONS(5119),
    [anon_sym_or] = ACTIONS(5117),
    [anon_sym_and] = ACTIONS(5117),
    [anon_sym_bitor] = ACTIONS(5117),
    [anon_sym_xor] = ACTIONS(5117),
    [anon_sym_bitand] = ACTIONS(5117),
    [anon_sym_not_eq] = ACTIONS(5117),
    [anon_sym_DASH_DASH] = ACTIONS(5119),
    [anon_sym_PLUS_PLUS] = ACTIONS(5119),
    [anon_sym_DOT] = ACTIONS(5117),
    [anon_sym_DOT_STAR] = ACTIONS(5119),
    [anon_sym_DASH_GT] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5117),
    [anon_sym_decltype] = ACTIONS(5117),
    [anon_sym_virtual] = ACTIONS(5117),
    [anon_sym_alignas] = ACTIONS(5117),
    [anon_sym_template] = ACTIONS(5117),
    [anon_sym_operator] = ACTIONS(5117),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5119),
  },
  [2016] = {
    [sym_identifier] = ACTIONS(5125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5127),
    [anon_sym_COMMA] = ACTIONS(5127),
    [anon_sym_RPAREN] = ACTIONS(5127),
    [anon_sym_LPAREN2] = ACTIONS(5127),
    [anon_sym_TILDE] = ACTIONS(5127),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_PLUS] = ACTIONS(5125),
    [anon_sym_STAR] = ACTIONS(5125),
    [anon_sym_SLASH] = ACTIONS(5125),
    [anon_sym_PERCENT] = ACTIONS(5125),
    [anon_sym_PIPE_PIPE] = ACTIONS(5127),
    [anon_sym_AMP_AMP] = ACTIONS(5127),
    [anon_sym_PIPE] = ACTIONS(5125),
    [anon_sym_CARET] = ACTIONS(5125),
    [anon_sym_AMP] = ACTIONS(5125),
    [anon_sym_EQ_EQ] = ACTIONS(5127),
    [anon_sym_BANG_EQ] = ACTIONS(5127),
    [anon_sym_GT] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5127),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_LT] = ACTIONS(5125),
    [anon_sym_LT_LT] = ACTIONS(5125),
    [anon_sym_GT_GT] = ACTIONS(5125),
    [anon_sym___extension__] = ACTIONS(5125),
    [anon_sym_extern] = ACTIONS(5125),
    [anon_sym___attribute__] = ACTIONS(5125),
    [anon_sym_COLON_COLON] = ACTIONS(5127),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5127),
    [anon_sym___declspec] = ACTIONS(5125),
    [anon_sym___based] = ACTIONS(5125),
    [anon_sym_LBRACE] = ACTIONS(5127),
    [anon_sym_LBRACK] = ACTIONS(5125),
    [anon_sym_EQ] = ACTIONS(5125),
    [anon_sym_static] = ACTIONS(5125),
    [anon_sym_register] = ACTIONS(5125),
    [anon_sym_inline] = ACTIONS(5125),
    [anon_sym___inline] = ACTIONS(5125),
    [anon_sym___inline__] = ACTIONS(5125),
    [anon_sym___forceinline] = ACTIONS(5125),
    [anon_sym_thread_local] = ACTIONS(5125),
    [anon_sym___thread] = ACTIONS(5125),
    [anon_sym_const] = ACTIONS(5125),
    [anon_sym_constexpr] = ACTIONS(5125),
    [anon_sym_volatile] = ACTIONS(5125),
    [anon_sym_restrict] = ACTIONS(5125),
    [anon_sym___restrict__] = ACTIONS(5125),
    [anon_sym__Atomic] = ACTIONS(5125),
    [anon_sym__Noreturn] = ACTIONS(5125),
    [anon_sym_noreturn] = ACTIONS(5125),
    [anon_sym_mutable] = ACTIONS(5125),
    [anon_sym_constinit] = ACTIONS(5125),
    [anon_sym_consteval] = ACTIONS(5125),
    [anon_sym_PROGMEM] = ACTIONS(5125),
    [anon_sym_QMARK] = ACTIONS(5127),
    [anon_sym_STAR_EQ] = ACTIONS(5127),
    [anon_sym_SLASH_EQ] = ACTIONS(5127),
    [anon_sym_PERCENT_EQ] = ACTIONS(5127),
    [anon_sym_PLUS_EQ] = ACTIONS(5127),
    [anon_sym_DASH_EQ] = ACTIONS(5127),
    [anon_sym_LT_LT_EQ] = ACTIONS(5127),
    [anon_sym_GT_GT_EQ] = ACTIONS(5127),
    [anon_sym_AMP_EQ] = ACTIONS(5127),
    [anon_sym_CARET_EQ] = ACTIONS(5127),
    [anon_sym_PIPE_EQ] = ACTIONS(5127),
    [anon_sym_LT_EQ_GT] = ACTIONS(5127),
    [anon_sym_or] = ACTIONS(5125),
    [anon_sym_and] = ACTIONS(5125),
    [anon_sym_bitor] = ACTIONS(5125),
    [anon_sym_xor] = ACTIONS(5125),
    [anon_sym_bitand] = ACTIONS(5125),
    [anon_sym_not_eq] = ACTIONS(5125),
    [anon_sym_DASH_DASH] = ACTIONS(5127),
    [anon_sym_PLUS_PLUS] = ACTIONS(5127),
    [anon_sym_DOT] = ACTIONS(5125),
    [anon_sym_DOT_STAR] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5125),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5125),
    [anon_sym_decltype] = ACTIONS(5125),
    [anon_sym_virtual] = ACTIONS(5125),
    [anon_sym_alignas] = ACTIONS(5125),
    [anon_sym_template] = ACTIONS(5125),
    [anon_sym_operator] = ACTIONS(5125),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5127),
  },
  [2017] = {
    [sym_identifier] = ACTIONS(5121),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5123),
    [anon_sym_COMMA] = ACTIONS(5123),
    [anon_sym_RPAREN] = ACTIONS(5123),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_TILDE] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5121),
    [anon_sym_PLUS] = ACTIONS(5121),
    [anon_sym_STAR] = ACTIONS(5121),
    [anon_sym_SLASH] = ACTIONS(5121),
    [anon_sym_PERCENT] = ACTIONS(5121),
    [anon_sym_PIPE_PIPE] = ACTIONS(5123),
    [anon_sym_AMP_AMP] = ACTIONS(5123),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_CARET] = ACTIONS(5121),
    [anon_sym_AMP] = ACTIONS(5121),
    [anon_sym_EQ_EQ] = ACTIONS(5123),
    [anon_sym_BANG_EQ] = ACTIONS(5123),
    [anon_sym_GT] = ACTIONS(5121),
    [anon_sym_GT_EQ] = ACTIONS(5123),
    [anon_sym_LT_EQ] = ACTIONS(5121),
    [anon_sym_LT] = ACTIONS(5121),
    [anon_sym_LT_LT] = ACTIONS(5121),
    [anon_sym_GT_GT] = ACTIONS(5121),
    [anon_sym___extension__] = ACTIONS(5121),
    [anon_sym_extern] = ACTIONS(5121),
    [anon_sym___attribute__] = ACTIONS(5121),
    [anon_sym_COLON_COLON] = ACTIONS(5123),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5123),
    [anon_sym___declspec] = ACTIONS(5121),
    [anon_sym___based] = ACTIONS(5121),
    [anon_sym_LBRACE] = ACTIONS(5123),
    [anon_sym_LBRACK] = ACTIONS(5121),
    [anon_sym_EQ] = ACTIONS(5121),
    [anon_sym_static] = ACTIONS(5121),
    [anon_sym_register] = ACTIONS(5121),
    [anon_sym_inline] = ACTIONS(5121),
    [anon_sym___inline] = ACTIONS(5121),
    [anon_sym___inline__] = ACTIONS(5121),
    [anon_sym___forceinline] = ACTIONS(5121),
    [anon_sym_thread_local] = ACTIONS(5121),
    [anon_sym___thread] = ACTIONS(5121),
    [anon_sym_const] = ACTIONS(5121),
    [anon_sym_constexpr] = ACTIONS(5121),
    [anon_sym_volatile] = ACTIONS(5121),
    [anon_sym_restrict] = ACTIONS(5121),
    [anon_sym___restrict__] = ACTIONS(5121),
    [anon_sym__Atomic] = ACTIONS(5121),
    [anon_sym__Noreturn] = ACTIONS(5121),
    [anon_sym_noreturn] = ACTIONS(5121),
    [anon_sym_mutable] = ACTIONS(5121),
    [anon_sym_constinit] = ACTIONS(5121),
    [anon_sym_consteval] = ACTIONS(5121),
    [anon_sym_PROGMEM] = ACTIONS(5121),
    [anon_sym_QMARK] = ACTIONS(5123),
    [anon_sym_STAR_EQ] = ACTIONS(5123),
    [anon_sym_SLASH_EQ] = ACTIONS(5123),
    [anon_sym_PERCENT_EQ] = ACTIONS(5123),
    [anon_sym_PLUS_EQ] = ACTIONS(5123),
    [anon_sym_DASH_EQ] = ACTIONS(5123),
    [anon_sym_LT_LT_EQ] = ACTIONS(5123),
    [anon_sym_GT_GT_EQ] = ACTIONS(5123),
    [anon_sym_AMP_EQ] = ACTIONS(5123),
    [anon_sym_CARET_EQ] = ACTIONS(5123),
    [anon_sym_PIPE_EQ] = ACTIONS(5123),
    [anon_sym_LT_EQ_GT] = ACTIONS(5123),
    [anon_sym_or] = ACTIONS(5121),
    [anon_sym_and] = ACTIONS(5121),
    [anon_sym_bitor] = ACTIONS(5121),
    [anon_sym_xor] = ACTIONS(5121),
    [anon_sym_bitand] = ACTIONS(5121),
    [anon_sym_not_eq] = ACTIONS(5121),
    [anon_sym_DASH_DASH] = ACTIONS(5123),
    [anon_sym_PLUS_PLUS] = ACTIONS(5123),
    [anon_sym_DOT] = ACTIONS(5121),
    [anon_sym_DOT_STAR] = ACTIONS(5123),
    [anon_sym_DASH_GT] = ACTIONS(5121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5121),
    [anon_sym_decltype] = ACTIONS(5121),
    [anon_sym_virtual] = ACTIONS(5121),
    [anon_sym_alignas] = ACTIONS(5121),
    [anon_sym_template] = ACTIONS(5121),
    [anon_sym_operator] = ACTIONS(5121),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5123),
  },
  [2018] = {
    [sym_identifier] = ACTIONS(5160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5164),
    [anon_sym_COMMA] = ACTIONS(5164),
    [anon_sym_RPAREN] = ACTIONS(5164),
    [anon_sym_LPAREN2] = ACTIONS(5164),
    [anon_sym_TILDE] = ACTIONS(5167),
    [anon_sym_DASH] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5169),
    [anon_sym_STAR] = ACTIONS(5171),
    [anon_sym_SLASH] = ACTIONS(5169),
    [anon_sym_PERCENT] = ACTIONS(5169),
    [anon_sym_PIPE_PIPE] = ACTIONS(5162),
    [anon_sym_AMP_AMP] = ACTIONS(5164),
    [anon_sym_PIPE] = ACTIONS(5169),
    [anon_sym_CARET] = ACTIONS(5169),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_EQ] = ACTIONS(5162),
    [anon_sym_GT] = ACTIONS(5169),
    [anon_sym_GT_EQ] = ACTIONS(5162),
    [anon_sym_LT_EQ] = ACTIONS(5169),
    [anon_sym_LT] = ACTIONS(5169),
    [anon_sym_LT_LT] = ACTIONS(5169),
    [anon_sym_GT_GT] = ACTIONS(5169),
    [anon_sym___extension__] = ACTIONS(5160),
    [anon_sym_extern] = ACTIONS(5160),
    [anon_sym___attribute__] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5167),
    [anon_sym___declspec] = ACTIONS(5160),
    [anon_sym___based] = ACTIONS(5160),
    [anon_sym_LBRACE] = ACTIONS(5167),
    [anon_sym_LBRACK] = ACTIONS(5171),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_static] = ACTIONS(5160),
    [anon_sym_register] = ACTIONS(5160),
    [anon_sym_inline] = ACTIONS(5160),
    [anon_sym___inline] = ACTIONS(5160),
    [anon_sym___inline__] = ACTIONS(5160),
    [anon_sym___forceinline] = ACTIONS(5160),
    [anon_sym_thread_local] = ACTIONS(5160),
    [anon_sym___thread] = ACTIONS(5160),
    [anon_sym_const] = ACTIONS(5160),
    [anon_sym_constexpr] = ACTIONS(5160),
    [anon_sym_volatile] = ACTIONS(5160),
    [anon_sym_restrict] = ACTIONS(5160),
    [anon_sym___restrict__] = ACTIONS(5160),
    [anon_sym__Atomic] = ACTIONS(5160),
    [anon_sym__Noreturn] = ACTIONS(5160),
    [anon_sym_noreturn] = ACTIONS(5160),
    [anon_sym_mutable] = ACTIONS(5160),
    [anon_sym_constinit] = ACTIONS(5160),
    [anon_sym_consteval] = ACTIONS(5160),
    [anon_sym_PROGMEM] = ACTIONS(5160),
    [anon_sym_QMARK] = ACTIONS(5162),
    [anon_sym_STAR_EQ] = ACTIONS(5162),
    [anon_sym_SLASH_EQ] = ACTIONS(5162),
    [anon_sym_PERCENT_EQ] = ACTIONS(5162),
    [anon_sym_PLUS_EQ] = ACTIONS(5162),
    [anon_sym_DASH_EQ] = ACTIONS(5162),
    [anon_sym_LT_LT_EQ] = ACTIONS(5162),
    [anon_sym_GT_GT_EQ] = ACTIONS(5162),
    [anon_sym_AMP_EQ] = ACTIONS(5162),
    [anon_sym_CARET_EQ] = ACTIONS(5162),
    [anon_sym_PIPE_EQ] = ACTIONS(5162),
    [anon_sym_LT_EQ_GT] = ACTIONS(5162),
    [anon_sym_or] = ACTIONS(5169),
    [anon_sym_and] = ACTIONS(5169),
    [anon_sym_bitor] = ACTIONS(5169),
    [anon_sym_xor] = ACTIONS(5169),
    [anon_sym_bitand] = ACTIONS(5169),
    [anon_sym_not_eq] = ACTIONS(5169),
    [anon_sym_DASH_DASH] = ACTIONS(5162),
    [anon_sym_PLUS_PLUS] = ACTIONS(5162),
    [anon_sym_DOT] = ACTIONS(5169),
    [anon_sym_DOT_STAR] = ACTIONS(5162),
    [anon_sym_DASH_GT] = ACTIONS(5169),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5160),
    [anon_sym_decltype] = ACTIONS(5160),
    [anon_sym_virtual] = ACTIONS(5160),
    [anon_sym_alignas] = ACTIONS(5160),
    [anon_sym_template] = ACTIONS(5160),
    [anon_sym_operator] = ACTIONS(5160),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5162),
  },
  [2019] = {
    [sym_identifier] = ACTIONS(5146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5148),
    [anon_sym_COMMA] = ACTIONS(5148),
    [anon_sym_RPAREN] = ACTIONS(5148),
    [anon_sym_LPAREN2] = ACTIONS(5148),
    [anon_sym_TILDE] = ACTIONS(5148),
    [anon_sym_DASH] = ACTIONS(5146),
    [anon_sym_PLUS] = ACTIONS(5146),
    [anon_sym_STAR] = ACTIONS(5146),
    [anon_sym_SLASH] = ACTIONS(5146),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [anon_sym_PIPE_PIPE] = ACTIONS(5148),
    [anon_sym_AMP_AMP] = ACTIONS(5148),
    [anon_sym_PIPE] = ACTIONS(5146),
    [anon_sym_CARET] = ACTIONS(5146),
    [anon_sym_AMP] = ACTIONS(5146),
    [anon_sym_EQ_EQ] = ACTIONS(5148),
    [anon_sym_BANG_EQ] = ACTIONS(5148),
    [anon_sym_GT] = ACTIONS(5146),
    [anon_sym_GT_EQ] = ACTIONS(5148),
    [anon_sym_LT_EQ] = ACTIONS(5146),
    [anon_sym_LT] = ACTIONS(5146),
    [anon_sym_LT_LT] = ACTIONS(5146),
    [anon_sym_GT_GT] = ACTIONS(5146),
    [anon_sym___extension__] = ACTIONS(5146),
    [anon_sym_extern] = ACTIONS(5146),
    [anon_sym___attribute__] = ACTIONS(5146),
    [anon_sym_COLON_COLON] = ACTIONS(5148),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5148),
    [anon_sym___declspec] = ACTIONS(5146),
    [anon_sym___based] = ACTIONS(5146),
    [anon_sym_LBRACE] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5146),
    [anon_sym_EQ] = ACTIONS(5146),
    [anon_sym_static] = ACTIONS(5146),
    [anon_sym_register] = ACTIONS(5146),
    [anon_sym_inline] = ACTIONS(5146),
    [anon_sym___inline] = ACTIONS(5146),
    [anon_sym___inline__] = ACTIONS(5146),
    [anon_sym___forceinline] = ACTIONS(5146),
    [anon_sym_thread_local] = ACTIONS(5146),
    [anon_sym___thread] = ACTIONS(5146),
    [anon_sym_const] = ACTIONS(5146),
    [anon_sym_constexpr] = ACTIONS(5146),
    [anon_sym_volatile] = ACTIONS(5146),
    [anon_sym_restrict] = ACTIONS(5146),
    [anon_sym___restrict__] = ACTIONS(5146),
    [anon_sym__Atomic] = ACTIONS(5146),
    [anon_sym__Noreturn] = ACTIONS(5146),
    [anon_sym_noreturn] = ACTIONS(5146),
    [anon_sym_mutable] = ACTIONS(5146),
    [anon_sym_constinit] = ACTIONS(5146),
    [anon_sym_consteval] = ACTIONS(5146),
    [anon_sym_PROGMEM] = ACTIONS(5146),
    [anon_sym_QMARK] = ACTIONS(5148),
    [anon_sym_STAR_EQ] = ACTIONS(5148),
    [anon_sym_SLASH_EQ] = ACTIONS(5148),
    [anon_sym_PERCENT_EQ] = ACTIONS(5148),
    [anon_sym_PLUS_EQ] = ACTIONS(5148),
    [anon_sym_DASH_EQ] = ACTIONS(5148),
    [anon_sym_LT_LT_EQ] = ACTIONS(5148),
    [anon_sym_GT_GT_EQ] = ACTIONS(5148),
    [anon_sym_AMP_EQ] = ACTIONS(5148),
    [anon_sym_CARET_EQ] = ACTIONS(5148),
    [anon_sym_PIPE_EQ] = ACTIONS(5148),
    [anon_sym_LT_EQ_GT] = ACTIONS(5148),
    [anon_sym_or] = ACTIONS(5146),
    [anon_sym_and] = ACTIONS(5146),
    [anon_sym_bitor] = ACTIONS(5146),
    [anon_sym_xor] = ACTIONS(5146),
    [anon_sym_bitand] = ACTIONS(5146),
    [anon_sym_not_eq] = ACTIONS(5146),
    [anon_sym_DASH_DASH] = ACTIONS(5148),
    [anon_sym_PLUS_PLUS] = ACTIONS(5148),
    [anon_sym_DOT] = ACTIONS(5146),
    [anon_sym_DOT_STAR] = ACTIONS(5148),
    [anon_sym_DASH_GT] = ACTIONS(5146),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5146),
    [anon_sym_decltype] = ACTIONS(5146),
    [anon_sym_virtual] = ACTIONS(5146),
    [anon_sym_alignas] = ACTIONS(5146),
    [anon_sym_template] = ACTIONS(5146),
    [anon_sym_operator] = ACTIONS(5146),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5148),
  },
  [2020] = {
    [sym_identifier] = ACTIONS(5109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5111),
    [anon_sym_COMMA] = ACTIONS(5111),
    [anon_sym_RPAREN] = ACTIONS(5111),
    [anon_sym_LPAREN2] = ACTIONS(5111),
    [anon_sym_TILDE] = ACTIONS(5111),
    [anon_sym_DASH] = ACTIONS(5109),
    [anon_sym_PLUS] = ACTIONS(5109),
    [anon_sym_STAR] = ACTIONS(5109),
    [anon_sym_SLASH] = ACTIONS(5109),
    [anon_sym_PERCENT] = ACTIONS(5109),
    [anon_sym_PIPE_PIPE] = ACTIONS(5111),
    [anon_sym_AMP_AMP] = ACTIONS(5111),
    [anon_sym_PIPE] = ACTIONS(5109),
    [anon_sym_CARET] = ACTIONS(5109),
    [anon_sym_AMP] = ACTIONS(5109),
    [anon_sym_EQ_EQ] = ACTIONS(5111),
    [anon_sym_BANG_EQ] = ACTIONS(5111),
    [anon_sym_GT] = ACTIONS(5109),
    [anon_sym_GT_EQ] = ACTIONS(5111),
    [anon_sym_LT_EQ] = ACTIONS(5109),
    [anon_sym_LT] = ACTIONS(5109),
    [anon_sym_LT_LT] = ACTIONS(5109),
    [anon_sym_GT_GT] = ACTIONS(5109),
    [anon_sym___extension__] = ACTIONS(5109),
    [anon_sym_extern] = ACTIONS(5109),
    [anon_sym___attribute__] = ACTIONS(5109),
    [anon_sym_COLON_COLON] = ACTIONS(5111),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5111),
    [anon_sym___declspec] = ACTIONS(5109),
    [anon_sym___based] = ACTIONS(5109),
    [anon_sym_LBRACE] = ACTIONS(5111),
    [anon_sym_LBRACK] = ACTIONS(5109),
    [anon_sym_EQ] = ACTIONS(5109),
    [anon_sym_static] = ACTIONS(5109),
    [anon_sym_register] = ACTIONS(5109),
    [anon_sym_inline] = ACTIONS(5109),
    [anon_sym___inline] = ACTIONS(5109),
    [anon_sym___inline__] = ACTIONS(5109),
    [anon_sym___forceinline] = ACTIONS(5109),
    [anon_sym_thread_local] = ACTIONS(5109),
    [anon_sym___thread] = ACTIONS(5109),
    [anon_sym_const] = ACTIONS(5109),
    [anon_sym_constexpr] = ACTIONS(5109),
    [anon_sym_volatile] = ACTIONS(5109),
    [anon_sym_restrict] = ACTIONS(5109),
    [anon_sym___restrict__] = ACTIONS(5109),
    [anon_sym__Atomic] = ACTIONS(5109),
    [anon_sym__Noreturn] = ACTIONS(5109),
    [anon_sym_noreturn] = ACTIONS(5109),
    [anon_sym_mutable] = ACTIONS(5109),
    [anon_sym_constinit] = ACTIONS(5109),
    [anon_sym_consteval] = ACTIONS(5109),
    [anon_sym_PROGMEM] = ACTIONS(5109),
    [anon_sym_QMARK] = ACTIONS(5111),
    [anon_sym_STAR_EQ] = ACTIONS(5111),
    [anon_sym_SLASH_EQ] = ACTIONS(5111),
    [anon_sym_PERCENT_EQ] = ACTIONS(5111),
    [anon_sym_PLUS_EQ] = ACTIONS(5111),
    [anon_sym_DASH_EQ] = ACTIONS(5111),
    [anon_sym_LT_LT_EQ] = ACTIONS(5111),
    [anon_sym_GT_GT_EQ] = ACTIONS(5111),
    [anon_sym_AMP_EQ] = ACTIONS(5111),
    [anon_sym_CARET_EQ] = ACTIONS(5111),
    [anon_sym_PIPE_EQ] = ACTIONS(5111),
    [anon_sym_LT_EQ_GT] = ACTIONS(5111),
    [anon_sym_or] = ACTIONS(5109),
    [anon_sym_and] = ACTIONS(5109),
    [anon_sym_bitor] = ACTIONS(5109),
    [anon_sym_xor] = ACTIONS(5109),
    [anon_sym_bitand] = ACTIONS(5109),
    [anon_sym_not_eq] = ACTIONS(5109),
    [anon_sym_DASH_DASH] = ACTIONS(5111),
    [anon_sym_PLUS_PLUS] = ACTIONS(5111),
    [anon_sym_DOT] = ACTIONS(5109),
    [anon_sym_DOT_STAR] = ACTIONS(5111),
    [anon_sym_DASH_GT] = ACTIONS(5109),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5109),
    [anon_sym_decltype] = ACTIONS(5109),
    [anon_sym_virtual] = ACTIONS(5109),
    [anon_sym_alignas] = ACTIONS(5109),
    [anon_sym_template] = ACTIONS(5109),
    [anon_sym_operator] = ACTIONS(5109),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5111),
  },
  [2021] = {
    [sym_function_definition] = STATE(1040),
    [sym_declaration] = STATE(1040),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5408),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_ms_call_modifier] = STATE(2149),
    [sym_declaration_list] = STATE(1040),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5204),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(5208),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2022] = {
    [sym_function_definition] = STATE(543),
    [sym_declaration] = STATE(543),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5457),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_ms_call_modifier] = STATE(2123),
    [sym_declaration_list] = STATE(543),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5204),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(5210),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2023] = {
    [sym_function_definition] = STATE(420),
    [sym_declaration] = STATE(420),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5497),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_ms_call_modifier] = STATE(2132),
    [sym_declaration_list] = STATE(420),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5204),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(5212),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2024] = {
    [sym_function_definition] = STATE(934),
    [sym_declaration] = STATE(934),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5414),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_ms_call_modifier] = STATE(2119),
    [sym_declaration_list] = STATE(934),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5204),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(5214),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2025] = {
    [sym_function_definition] = STATE(936),
    [sym_declaration] = STATE(936),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_ms_call_modifier] = STATE(2206),
    [sym_declaration_list] = STATE(936),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5204),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(5216),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2026] = {
    [sym_function_definition] = STATE(909),
    [sym_declaration] = STATE(909),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5414),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_ms_call_modifier] = STATE(2119),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(9340),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(4664),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(4647),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5218),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(5220),
    [anon_sym_struct] = ACTIONS(5222),
    [anon_sym_union] = ACTIONS(5224),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2027] = {
    [sym_function_definition] = STATE(1053),
    [sym_declaration] = STATE(1053),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5408),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_ms_call_modifier] = STATE(2149),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8940),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(4664),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(4647),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5218),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(5226),
    [anon_sym_struct] = ACTIONS(5228),
    [anon_sym_union] = ACTIONS(5230),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2028] = {
    [sym_function_definition] = STATE(978),
    [sym_declaration] = STATE(978),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5503),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_ms_call_modifier] = STATE(2206),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(9161),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(4664),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(4647),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5218),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(5232),
    [anon_sym_struct] = ACTIONS(5234),
    [anon_sym_union] = ACTIONS(5236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2029] = {
    [sym_function_definition] = STATE(2406),
    [sym_declaration] = STATE(2406),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5443),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_ms_call_modifier] = STATE(2228),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(9109),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(4664),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(4647),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5218),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(5238),
    [anon_sym_struct] = ACTIONS(5240),
    [anon_sym_union] = ACTIONS(5242),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2030] = {
    [sym_function_definition] = STATE(2147),
    [sym_declaration] = STATE(2147),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5415),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_ms_call_modifier] = STATE(2155),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(9306),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(4664),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(4647),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5218),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(5244),
    [anon_sym_struct] = ACTIONS(5246),
    [anon_sym_union] = ACTIONS(5248),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2031] = {
    [sym_function_definition] = STATE(2485),
    [sym_declaration] = STATE(2485),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5460),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_ms_call_modifier] = STATE(2152),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(8874),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(4664),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(4647),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5218),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(5250),
    [anon_sym_struct] = ACTIONS(5252),
    [anon_sym_union] = ACTIONS(5254),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2032] = {
    [sym_function_definition] = STATE(553),
    [sym_declaration] = STATE(553),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5457),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_ms_call_modifier] = STATE(2123),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(9611),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(4664),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(4647),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5218),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(5256),
    [anon_sym_struct] = ACTIONS(5258),
    [anon_sym_union] = ACTIONS(5260),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2033] = {
    [sym_function_definition] = STATE(2621),
    [sym_declaration] = STATE(2621),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5392),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_ms_call_modifier] = STATE(2113),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(9420),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(4664),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(4647),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5218),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(5262),
    [anon_sym_struct] = ACTIONS(5264),
    [anon_sym_union] = ACTIONS(5266),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2034] = {
    [sym_function_definition] = STATE(399),
    [sym_declaration] = STATE(399),
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5497),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_ms_call_modifier] = STATE(2132),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym__class_name] = STATE(9277),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(4664),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(4647),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5218),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(5268),
    [anon_sym_struct] = ACTIONS(5270),
    [anon_sym_union] = ACTIONS(5272),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2035] = {
    [sym_identifier] = ACTIONS(5160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5162),
    [anon_sym_COMMA] = ACTIONS(5162),
    [anon_sym_LPAREN2] = ACTIONS(5164),
    [anon_sym_TILDE] = ACTIONS(5167),
    [anon_sym_DASH] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5169),
    [anon_sym_STAR] = ACTIONS(5164),
    [anon_sym_SLASH] = ACTIONS(5169),
    [anon_sym_PERCENT] = ACTIONS(5162),
    [anon_sym_PIPE_PIPE] = ACTIONS(5162),
    [anon_sym_AMP_AMP] = ACTIONS(5164),
    [anon_sym_PIPE] = ACTIONS(5169),
    [anon_sym_CARET] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_EQ] = ACTIONS(5162),
    [anon_sym_GT] = ACTIONS(5169),
    [anon_sym_GT_EQ] = ACTIONS(5162),
    [anon_sym_LT_EQ] = ACTIONS(5169),
    [anon_sym_LT] = ACTIONS(5169),
    [anon_sym_LT_LT] = ACTIONS(5162),
    [anon_sym_GT_GT] = ACTIONS(5162),
    [anon_sym_SEMI] = ACTIONS(5164),
    [anon_sym___extension__] = ACTIONS(5160),
    [anon_sym_extern] = ACTIONS(5160),
    [anon_sym___attribute__] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5164),
    [anon_sym___declspec] = ACTIONS(5160),
    [anon_sym___based] = ACTIONS(5160),
    [anon_sym___cdecl] = ACTIONS(5160),
    [anon_sym___clrcall] = ACTIONS(5160),
    [anon_sym___stdcall] = ACTIONS(5160),
    [anon_sym___fastcall] = ACTIONS(5160),
    [anon_sym___thiscall] = ACTIONS(5160),
    [anon_sym___vectorcall] = ACTIONS(5160),
    [anon_sym_LBRACE] = ACTIONS(5167),
    [anon_sym_RBRACE] = ACTIONS(5162),
    [anon_sym_LBRACK] = ACTIONS(5171),
    [anon_sym_static] = ACTIONS(5160),
    [anon_sym_register] = ACTIONS(5160),
    [anon_sym_inline] = ACTIONS(5160),
    [anon_sym___inline] = ACTIONS(5160),
    [anon_sym___inline__] = ACTIONS(5160),
    [anon_sym___forceinline] = ACTIONS(5160),
    [anon_sym_thread_local] = ACTIONS(5160),
    [anon_sym___thread] = ACTIONS(5160),
    [anon_sym_const] = ACTIONS(5160),
    [anon_sym_constexpr] = ACTIONS(5160),
    [anon_sym_volatile] = ACTIONS(5160),
    [anon_sym_restrict] = ACTIONS(5160),
    [anon_sym___restrict__] = ACTIONS(5160),
    [anon_sym__Atomic] = ACTIONS(5160),
    [anon_sym__Noreturn] = ACTIONS(5160),
    [anon_sym_noreturn] = ACTIONS(5160),
    [anon_sym_mutable] = ACTIONS(5160),
    [anon_sym_constinit] = ACTIONS(5160),
    [anon_sym_consteval] = ACTIONS(5160),
    [anon_sym_PROGMEM] = ACTIONS(5160),
    [anon_sym_QMARK] = ACTIONS(5162),
    [anon_sym_LT_EQ_GT] = ACTIONS(5162),
    [anon_sym_or] = ACTIONS(5169),
    [anon_sym_and] = ACTIONS(5169),
    [anon_sym_bitor] = ACTIONS(5169),
    [anon_sym_xor] = ACTIONS(5169),
    [anon_sym_bitand] = ACTIONS(5169),
    [anon_sym_not_eq] = ACTIONS(5169),
    [anon_sym_DASH_DASH] = ACTIONS(5162),
    [anon_sym_PLUS_PLUS] = ACTIONS(5162),
    [anon_sym_DOT] = ACTIONS(5169),
    [anon_sym_DOT_STAR] = ACTIONS(5162),
    [anon_sym_DASH_GT] = ACTIONS(5162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5160),
    [anon_sym_decltype] = ACTIONS(5160),
    [anon_sym_virtual] = ACTIONS(5160),
    [anon_sym_alignas] = ACTIONS(5160),
    [anon_sym_template] = ACTIONS(5160),
    [anon_sym_operator] = ACTIONS(5160),
  },
  [2036] = {
    [sym_identifier] = ACTIONS(5160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5167),
    [anon_sym_COMMA] = ACTIONS(5167),
    [anon_sym_RPAREN] = ACTIONS(5167),
    [anon_sym_LPAREN2] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [anon_sym_STAR] = ACTIONS(5167),
    [anon_sym_PIPE_PIPE] = ACTIONS(5167),
    [anon_sym_AMP_AMP] = ACTIONS(5167),
    [anon_sym_AMP] = ACTIONS(5160),
    [anon_sym_SEMI] = ACTIONS(5167),
    [anon_sym___extension__] = ACTIONS(5160),
    [anon_sym_extern] = ACTIONS(5160),
    [anon_sym___attribute__] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5167),
    [anon_sym___declspec] = ACTIONS(5160),
    [anon_sym___based] = ACTIONS(5160),
    [anon_sym___cdecl] = ACTIONS(5160),
    [anon_sym___clrcall] = ACTIONS(5160),
    [anon_sym___stdcall] = ACTIONS(5160),
    [anon_sym___fastcall] = ACTIONS(5160),
    [anon_sym___thiscall] = ACTIONS(5160),
    [anon_sym___vectorcall] = ACTIONS(5160),
    [anon_sym_LBRACE] = ACTIONS(5167),
    [anon_sym_signed] = ACTIONS(5160),
    [anon_sym_unsigned] = ACTIONS(5160),
    [anon_sym_long] = ACTIONS(5160),
    [anon_sym_short] = ACTIONS(5160),
    [anon_sym_LBRACK] = ACTIONS(5160),
    [anon_sym_EQ] = ACTIONS(5167),
    [anon_sym_static] = ACTIONS(5160),
    [anon_sym_register] = ACTIONS(5160),
    [anon_sym_inline] = ACTIONS(5160),
    [anon_sym___inline] = ACTIONS(5160),
    [anon_sym___inline__] = ACTIONS(5160),
    [anon_sym___forceinline] = ACTIONS(5160),
    [anon_sym_thread_local] = ACTIONS(5160),
    [anon_sym___thread] = ACTIONS(5160),
    [anon_sym_const] = ACTIONS(5160),
    [anon_sym_constexpr] = ACTIONS(5160),
    [anon_sym_volatile] = ACTIONS(5160),
    [anon_sym_restrict] = ACTIONS(5160),
    [anon_sym___restrict__] = ACTIONS(5160),
    [anon_sym__Atomic] = ACTIONS(5160),
    [anon_sym__Noreturn] = ACTIONS(5160),
    [anon_sym_noreturn] = ACTIONS(5160),
    [anon_sym_mutable] = ACTIONS(5160),
    [anon_sym_constinit] = ACTIONS(5160),
    [anon_sym_consteval] = ACTIONS(5160),
    [anon_sym_PROGMEM] = ACTIONS(5160),
    [aux_sym_primitive_type_token1] = ACTIONS(5160),
    [anon_sym_byte] = ACTIONS(5160),
    [anon_sym_word] = ACTIONS(5160),
    [anon_sym_enum] = ACTIONS(5160),
    [anon_sym_class] = ACTIONS(5160),
    [anon_sym_struct] = ACTIONS(5160),
    [anon_sym_union] = ACTIONS(5160),
    [anon_sym_COLON] = ACTIONS(5160),
    [anon_sym_or] = ACTIONS(5160),
    [anon_sym_and] = ACTIONS(5160),
    [anon_sym_asm] = ACTIONS(5160),
    [anon_sym___asm__] = ACTIONS(5160),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5160),
    [anon_sym_decltype] = ACTIONS(5160),
    [anon_sym_final] = ACTIONS(5160),
    [anon_sym_override] = ACTIONS(5160),
    [anon_sym_virtual] = ACTIONS(5160),
    [anon_sym_alignas] = ACTIONS(5160),
    [anon_sym_explicit] = ACTIONS(5160),
    [anon_sym_typename] = ACTIONS(5160),
    [anon_sym_template] = ACTIONS(5160),
    [anon_sym_GT2] = ACTIONS(5167),
    [anon_sym_operator] = ACTIONS(5160),
    [anon_sym_try] = ACTIONS(5160),
    [anon_sym_friend] = ACTIONS(5160),
    [anon_sym_using] = ACTIONS(5160),
    [anon_sym_concept] = ACTIONS(5160),
    [anon_sym_requires] = ACTIONS(5160),
  },
  [2037] = {
    [sym__declaration_modifiers] = STATE(2282),
    [sym__declaration_specifiers] = STATE(4815),
    [sym_attribute_specifier] = STATE(2282),
    [sym_attribute_declaration] = STATE(2282),
    [sym_ms_declspec_modifier] = STATE(2282),
    [sym_storage_class_specifier] = STATE(2282),
    [sym_type_qualifier] = STATE(2282),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_parameter_declaration] = STATE(8002),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2282),
    [sym_alignas_specifier] = STATE(2282),
    [sym_dependent_type] = STATE(3087),
    [sym_type_parameter_declaration] = STATE(8002),
    [sym_variadic_type_parameter_declaration] = STATE(8002),
    [sym_optional_type_parameter_declaration] = STATE(8002),
    [sym_template_template_parameter_declaration] = STATE(8002),
    [sym_optional_parameter_declaration] = STATE(8002),
    [sym_variadic_parameter_declaration] = STATE(8002),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7326),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2282),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5095),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5105),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(5274),
    [anon_sym_struct] = ACTIONS(2025),
    [anon_sym_union] = ACTIONS(2027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(5276),
    [anon_sym_template] = ACTIONS(5278),
    [anon_sym_GT2] = ACTIONS(5280),
  },
  [2038] = {
    [sym__declaration_modifiers] = STATE(2282),
    [sym__declaration_specifiers] = STATE(4815),
    [sym_attribute_specifier] = STATE(2282),
    [sym_attribute_declaration] = STATE(2282),
    [sym_ms_declspec_modifier] = STATE(2282),
    [sym_storage_class_specifier] = STATE(2282),
    [sym_type_qualifier] = STATE(2282),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_parameter_declaration] = STATE(8140),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2282),
    [sym_alignas_specifier] = STATE(2282),
    [sym_dependent_type] = STATE(3087),
    [sym_type_parameter_declaration] = STATE(8140),
    [sym_variadic_type_parameter_declaration] = STATE(8140),
    [sym_optional_type_parameter_declaration] = STATE(8140),
    [sym_template_template_parameter_declaration] = STATE(8140),
    [sym_optional_parameter_declaration] = STATE(8140),
    [sym_variadic_parameter_declaration] = STATE(8140),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7326),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2282),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5095),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5105),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(5274),
    [anon_sym_struct] = ACTIONS(2025),
    [anon_sym_union] = ACTIONS(2027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(5276),
    [anon_sym_template] = ACTIONS(5278),
    [anon_sym_GT2] = ACTIONS(5282),
  },
  [2039] = {
    [sym_identifier] = ACTIONS(5284),
    [anon_sym_COMMA] = ACTIONS(5286),
    [anon_sym_RPAREN] = ACTIONS(5286),
    [anon_sym_LPAREN2] = ACTIONS(5286),
    [anon_sym_TILDE] = ACTIONS(5286),
    [anon_sym_STAR] = ACTIONS(5286),
    [anon_sym_PIPE_PIPE] = ACTIONS(5286),
    [anon_sym_AMP_AMP] = ACTIONS(5286),
    [anon_sym_AMP] = ACTIONS(5284),
    [anon_sym_SEMI] = ACTIONS(5286),
    [anon_sym___extension__] = ACTIONS(5284),
    [anon_sym_extern] = ACTIONS(5284),
    [anon_sym___attribute__] = ACTIONS(5284),
    [anon_sym_COLON_COLON] = ACTIONS(5286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5286),
    [anon_sym___declspec] = ACTIONS(5284),
    [anon_sym___based] = ACTIONS(5284),
    [anon_sym___cdecl] = ACTIONS(5284),
    [anon_sym___clrcall] = ACTIONS(5284),
    [anon_sym___stdcall] = ACTIONS(5284),
    [anon_sym___fastcall] = ACTIONS(5284),
    [anon_sym___thiscall] = ACTIONS(5284),
    [anon_sym___vectorcall] = ACTIONS(5284),
    [anon_sym_LBRACE] = ACTIONS(5286),
    [anon_sym_signed] = ACTIONS(5284),
    [anon_sym_unsigned] = ACTIONS(5284),
    [anon_sym_long] = ACTIONS(5284),
    [anon_sym_short] = ACTIONS(5284),
    [anon_sym_LBRACK] = ACTIONS(5284),
    [anon_sym_EQ] = ACTIONS(5286),
    [anon_sym_static] = ACTIONS(5284),
    [anon_sym_register] = ACTIONS(5284),
    [anon_sym_inline] = ACTIONS(5284),
    [anon_sym___inline] = ACTIONS(5284),
    [anon_sym___inline__] = ACTIONS(5284),
    [anon_sym___forceinline] = ACTIONS(5284),
    [anon_sym_thread_local] = ACTIONS(5284),
    [anon_sym___thread] = ACTIONS(5284),
    [anon_sym_const] = ACTIONS(5284),
    [anon_sym_constexpr] = ACTIONS(5284),
    [anon_sym_volatile] = ACTIONS(5284),
    [anon_sym_restrict] = ACTIONS(5284),
    [anon_sym___restrict__] = ACTIONS(5284),
    [anon_sym__Atomic] = ACTIONS(5284),
    [anon_sym__Noreturn] = ACTIONS(5284),
    [anon_sym_noreturn] = ACTIONS(5284),
    [anon_sym_mutable] = ACTIONS(5284),
    [anon_sym_constinit] = ACTIONS(5284),
    [anon_sym_consteval] = ACTIONS(5284),
    [anon_sym_PROGMEM] = ACTIONS(5284),
    [aux_sym_primitive_type_token1] = ACTIONS(5284),
    [anon_sym_byte] = ACTIONS(5284),
    [anon_sym_word] = ACTIONS(5284),
    [anon_sym_enum] = ACTIONS(5284),
    [anon_sym_class] = ACTIONS(5284),
    [anon_sym_struct] = ACTIONS(5284),
    [anon_sym_union] = ACTIONS(5284),
    [anon_sym_or] = ACTIONS(5284),
    [anon_sym_and] = ACTIONS(5284),
    [anon_sym_asm] = ACTIONS(5284),
    [anon_sym___asm__] = ACTIONS(5284),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5284),
    [anon_sym_decltype] = ACTIONS(5284),
    [anon_sym_final] = ACTIONS(5284),
    [anon_sym_override] = ACTIONS(5284),
    [anon_sym_virtual] = ACTIONS(5284),
    [anon_sym_alignas] = ACTIONS(5284),
    [anon_sym_explicit] = ACTIONS(5284),
    [anon_sym_typename] = ACTIONS(5284),
    [anon_sym_template] = ACTIONS(5284),
    [anon_sym_GT2] = ACTIONS(5286),
    [anon_sym_operator] = ACTIONS(5284),
    [anon_sym_try] = ACTIONS(5284),
    [anon_sym_friend] = ACTIONS(5284),
    [anon_sym_using] = ACTIONS(5284),
    [anon_sym_concept] = ACTIONS(5284),
    [anon_sym_requires] = ACTIONS(5284),
  },
  [2040] = {
    [sym_identifier] = ACTIONS(5288),
    [anon_sym_COMMA] = ACTIONS(5290),
    [anon_sym_RPAREN] = ACTIONS(5290),
    [anon_sym_LPAREN2] = ACTIONS(5290),
    [anon_sym_TILDE] = ACTIONS(5290),
    [anon_sym_STAR] = ACTIONS(5290),
    [anon_sym_PIPE_PIPE] = ACTIONS(5290),
    [anon_sym_AMP_AMP] = ACTIONS(5290),
    [anon_sym_AMP] = ACTIONS(5288),
    [anon_sym_SEMI] = ACTIONS(5290),
    [anon_sym___extension__] = ACTIONS(5288),
    [anon_sym_extern] = ACTIONS(5288),
    [anon_sym___attribute__] = ACTIONS(5288),
    [anon_sym_COLON_COLON] = ACTIONS(5290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5290),
    [anon_sym___declspec] = ACTIONS(5288),
    [anon_sym___based] = ACTIONS(5288),
    [anon_sym___cdecl] = ACTIONS(5288),
    [anon_sym___clrcall] = ACTIONS(5288),
    [anon_sym___stdcall] = ACTIONS(5288),
    [anon_sym___fastcall] = ACTIONS(5288),
    [anon_sym___thiscall] = ACTIONS(5288),
    [anon_sym___vectorcall] = ACTIONS(5288),
    [anon_sym_LBRACE] = ACTIONS(5290),
    [anon_sym_signed] = ACTIONS(5288),
    [anon_sym_unsigned] = ACTIONS(5288),
    [anon_sym_long] = ACTIONS(5288),
    [anon_sym_short] = ACTIONS(5288),
    [anon_sym_LBRACK] = ACTIONS(5288),
    [anon_sym_EQ] = ACTIONS(5290),
    [anon_sym_static] = ACTIONS(5288),
    [anon_sym_register] = ACTIONS(5288),
    [anon_sym_inline] = ACTIONS(5288),
    [anon_sym___inline] = ACTIONS(5288),
    [anon_sym___inline__] = ACTIONS(5288),
    [anon_sym___forceinline] = ACTIONS(5288),
    [anon_sym_thread_local] = ACTIONS(5288),
    [anon_sym___thread] = ACTIONS(5288),
    [anon_sym_const] = ACTIONS(5288),
    [anon_sym_constexpr] = ACTIONS(5288),
    [anon_sym_volatile] = ACTIONS(5288),
    [anon_sym_restrict] = ACTIONS(5288),
    [anon_sym___restrict__] = ACTIONS(5288),
    [anon_sym__Atomic] = ACTIONS(5288),
    [anon_sym__Noreturn] = ACTIONS(5288),
    [anon_sym_noreturn] = ACTIONS(5288),
    [anon_sym_mutable] = ACTIONS(5288),
    [anon_sym_constinit] = ACTIONS(5288),
    [anon_sym_consteval] = ACTIONS(5288),
    [anon_sym_PROGMEM] = ACTIONS(5288),
    [aux_sym_primitive_type_token1] = ACTIONS(5288),
    [anon_sym_byte] = ACTIONS(5288),
    [anon_sym_word] = ACTIONS(5288),
    [anon_sym_enum] = ACTIONS(5288),
    [anon_sym_class] = ACTIONS(5288),
    [anon_sym_struct] = ACTIONS(5288),
    [anon_sym_union] = ACTIONS(5288),
    [anon_sym_or] = ACTIONS(5288),
    [anon_sym_and] = ACTIONS(5288),
    [anon_sym_asm] = ACTIONS(5288),
    [anon_sym___asm__] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5288),
    [anon_sym_decltype] = ACTIONS(5288),
    [anon_sym_final] = ACTIONS(5288),
    [anon_sym_override] = ACTIONS(5288),
    [anon_sym_virtual] = ACTIONS(5288),
    [anon_sym_alignas] = ACTIONS(5288),
    [anon_sym_explicit] = ACTIONS(5288),
    [anon_sym_typename] = ACTIONS(5288),
    [anon_sym_template] = ACTIONS(5288),
    [anon_sym_GT2] = ACTIONS(5290),
    [anon_sym_operator] = ACTIONS(5288),
    [anon_sym_try] = ACTIONS(5288),
    [anon_sym_friend] = ACTIONS(5288),
    [anon_sym_using] = ACTIONS(5288),
    [anon_sym_concept] = ACTIONS(5288),
    [anon_sym_requires] = ACTIONS(5288),
  },
  [2041] = {
    [sym_identifier] = ACTIONS(5292),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_RPAREN] = ACTIONS(5294),
    [anon_sym_LPAREN2] = ACTIONS(5294),
    [anon_sym_TILDE] = ACTIONS(5294),
    [anon_sym_STAR] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_AMP] = ACTIONS(5292),
    [anon_sym_SEMI] = ACTIONS(5294),
    [anon_sym___extension__] = ACTIONS(5292),
    [anon_sym_extern] = ACTIONS(5292),
    [anon_sym___attribute__] = ACTIONS(5292),
    [anon_sym_COLON_COLON] = ACTIONS(5294),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5294),
    [anon_sym___declspec] = ACTIONS(5292),
    [anon_sym___based] = ACTIONS(5292),
    [anon_sym___cdecl] = ACTIONS(5292),
    [anon_sym___clrcall] = ACTIONS(5292),
    [anon_sym___stdcall] = ACTIONS(5292),
    [anon_sym___fastcall] = ACTIONS(5292),
    [anon_sym___thiscall] = ACTIONS(5292),
    [anon_sym___vectorcall] = ACTIONS(5292),
    [anon_sym_LBRACE] = ACTIONS(5294),
    [anon_sym_signed] = ACTIONS(5292),
    [anon_sym_unsigned] = ACTIONS(5292),
    [anon_sym_long] = ACTIONS(5292),
    [anon_sym_short] = ACTIONS(5292),
    [anon_sym_LBRACK] = ACTIONS(5292),
    [anon_sym_EQ] = ACTIONS(5294),
    [anon_sym_static] = ACTIONS(5292),
    [anon_sym_register] = ACTIONS(5292),
    [anon_sym_inline] = ACTIONS(5292),
    [anon_sym___inline] = ACTIONS(5292),
    [anon_sym___inline__] = ACTIONS(5292),
    [anon_sym___forceinline] = ACTIONS(5292),
    [anon_sym_thread_local] = ACTIONS(5292),
    [anon_sym___thread] = ACTIONS(5292),
    [anon_sym_const] = ACTIONS(5292),
    [anon_sym_constexpr] = ACTIONS(5292),
    [anon_sym_volatile] = ACTIONS(5292),
    [anon_sym_restrict] = ACTIONS(5292),
    [anon_sym___restrict__] = ACTIONS(5292),
    [anon_sym__Atomic] = ACTIONS(5292),
    [anon_sym__Noreturn] = ACTIONS(5292),
    [anon_sym_noreturn] = ACTIONS(5292),
    [anon_sym_mutable] = ACTIONS(5292),
    [anon_sym_constinit] = ACTIONS(5292),
    [anon_sym_consteval] = ACTIONS(5292),
    [anon_sym_PROGMEM] = ACTIONS(5292),
    [aux_sym_primitive_type_token1] = ACTIONS(5292),
    [anon_sym_byte] = ACTIONS(5292),
    [anon_sym_word] = ACTIONS(5292),
    [anon_sym_enum] = ACTIONS(5292),
    [anon_sym_class] = ACTIONS(5292),
    [anon_sym_struct] = ACTIONS(5292),
    [anon_sym_union] = ACTIONS(5292),
    [anon_sym_or] = ACTIONS(5292),
    [anon_sym_and] = ACTIONS(5292),
    [anon_sym_asm] = ACTIONS(5292),
    [anon_sym___asm__] = ACTIONS(5292),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5292),
    [anon_sym_decltype] = ACTIONS(5292),
    [anon_sym_final] = ACTIONS(5292),
    [anon_sym_override] = ACTIONS(5292),
    [anon_sym_virtual] = ACTIONS(5292),
    [anon_sym_alignas] = ACTIONS(5292),
    [anon_sym_explicit] = ACTIONS(5292),
    [anon_sym_typename] = ACTIONS(5292),
    [anon_sym_template] = ACTIONS(5292),
    [anon_sym_GT2] = ACTIONS(5294),
    [anon_sym_operator] = ACTIONS(5292),
    [anon_sym_try] = ACTIONS(5292),
    [anon_sym_friend] = ACTIONS(5292),
    [anon_sym_using] = ACTIONS(5292),
    [anon_sym_concept] = ACTIONS(5292),
    [anon_sym_requires] = ACTIONS(5292),
  },
  [2042] = {
    [sym_identifier] = ACTIONS(5296),
    [anon_sym_COMMA] = ACTIONS(5298),
    [anon_sym_RPAREN] = ACTIONS(5298),
    [anon_sym_LPAREN2] = ACTIONS(5298),
    [anon_sym_TILDE] = ACTIONS(5298),
    [anon_sym_STAR] = ACTIONS(5298),
    [anon_sym_PIPE_PIPE] = ACTIONS(5298),
    [anon_sym_AMP_AMP] = ACTIONS(5298),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_SEMI] = ACTIONS(5298),
    [anon_sym___extension__] = ACTIONS(5296),
    [anon_sym_extern] = ACTIONS(5296),
    [anon_sym___attribute__] = ACTIONS(5296),
    [anon_sym_COLON_COLON] = ACTIONS(5298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5298),
    [anon_sym___declspec] = ACTIONS(5296),
    [anon_sym___based] = ACTIONS(5296),
    [anon_sym___cdecl] = ACTIONS(5296),
    [anon_sym___clrcall] = ACTIONS(5296),
    [anon_sym___stdcall] = ACTIONS(5296),
    [anon_sym___fastcall] = ACTIONS(5296),
    [anon_sym___thiscall] = ACTIONS(5296),
    [anon_sym___vectorcall] = ACTIONS(5296),
    [anon_sym_LBRACE] = ACTIONS(5298),
    [anon_sym_signed] = ACTIONS(5296),
    [anon_sym_unsigned] = ACTIONS(5296),
    [anon_sym_long] = ACTIONS(5296),
    [anon_sym_short] = ACTIONS(5296),
    [anon_sym_LBRACK] = ACTIONS(5296),
    [anon_sym_EQ] = ACTIONS(5298),
    [anon_sym_static] = ACTIONS(5296),
    [anon_sym_register] = ACTIONS(5296),
    [anon_sym_inline] = ACTIONS(5296),
    [anon_sym___inline] = ACTIONS(5296),
    [anon_sym___inline__] = ACTIONS(5296),
    [anon_sym___forceinline] = ACTIONS(5296),
    [anon_sym_thread_local] = ACTIONS(5296),
    [anon_sym___thread] = ACTIONS(5296),
    [anon_sym_const] = ACTIONS(5296),
    [anon_sym_constexpr] = ACTIONS(5296),
    [anon_sym_volatile] = ACTIONS(5296),
    [anon_sym_restrict] = ACTIONS(5296),
    [anon_sym___restrict__] = ACTIONS(5296),
    [anon_sym__Atomic] = ACTIONS(5296),
    [anon_sym__Noreturn] = ACTIONS(5296),
    [anon_sym_noreturn] = ACTIONS(5296),
    [anon_sym_mutable] = ACTIONS(5296),
    [anon_sym_constinit] = ACTIONS(5296),
    [anon_sym_consteval] = ACTIONS(5296),
    [anon_sym_PROGMEM] = ACTIONS(5296),
    [aux_sym_primitive_type_token1] = ACTIONS(5296),
    [anon_sym_byte] = ACTIONS(5296),
    [anon_sym_word] = ACTIONS(5296),
    [anon_sym_enum] = ACTIONS(5296),
    [anon_sym_class] = ACTIONS(5296),
    [anon_sym_struct] = ACTIONS(5296),
    [anon_sym_union] = ACTIONS(5296),
    [anon_sym_or] = ACTIONS(5296),
    [anon_sym_and] = ACTIONS(5296),
    [anon_sym_asm] = ACTIONS(5296),
    [anon_sym___asm__] = ACTIONS(5296),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5296),
    [anon_sym_decltype] = ACTIONS(5296),
    [anon_sym_final] = ACTIONS(5296),
    [anon_sym_override] = ACTIONS(5296),
    [anon_sym_virtual] = ACTIONS(5296),
    [anon_sym_alignas] = ACTIONS(5296),
    [anon_sym_explicit] = ACTIONS(5296),
    [anon_sym_typename] = ACTIONS(5296),
    [anon_sym_template] = ACTIONS(5296),
    [anon_sym_GT2] = ACTIONS(5298),
    [anon_sym_operator] = ACTIONS(5296),
    [anon_sym_try] = ACTIONS(5296),
    [anon_sym_friend] = ACTIONS(5296),
    [anon_sym_using] = ACTIONS(5296),
    [anon_sym_concept] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5296),
  },
  [2043] = {
    [sym_identifier] = ACTIONS(5300),
    [anon_sym_COMMA] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5302),
    [anon_sym_LPAREN2] = ACTIONS(5302),
    [anon_sym_TILDE] = ACTIONS(5302),
    [anon_sym_STAR] = ACTIONS(5302),
    [anon_sym_PIPE_PIPE] = ACTIONS(5302),
    [anon_sym_AMP_AMP] = ACTIONS(5302),
    [anon_sym_AMP] = ACTIONS(5300),
    [anon_sym_SEMI] = ACTIONS(5302),
    [anon_sym___extension__] = ACTIONS(5300),
    [anon_sym_extern] = ACTIONS(5300),
    [anon_sym___attribute__] = ACTIONS(5300),
    [anon_sym_COLON_COLON] = ACTIONS(5302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5302),
    [anon_sym___declspec] = ACTIONS(5300),
    [anon_sym___based] = ACTIONS(5300),
    [anon_sym___cdecl] = ACTIONS(5300),
    [anon_sym___clrcall] = ACTIONS(5300),
    [anon_sym___stdcall] = ACTIONS(5300),
    [anon_sym___fastcall] = ACTIONS(5300),
    [anon_sym___thiscall] = ACTIONS(5300),
    [anon_sym___vectorcall] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(5302),
    [anon_sym_signed] = ACTIONS(5300),
    [anon_sym_unsigned] = ACTIONS(5300),
    [anon_sym_long] = ACTIONS(5300),
    [anon_sym_short] = ACTIONS(5300),
    [anon_sym_LBRACK] = ACTIONS(5300),
    [anon_sym_EQ] = ACTIONS(5302),
    [anon_sym_static] = ACTIONS(5300),
    [anon_sym_register] = ACTIONS(5300),
    [anon_sym_inline] = ACTIONS(5300),
    [anon_sym___inline] = ACTIONS(5300),
    [anon_sym___inline__] = ACTIONS(5300),
    [anon_sym___forceinline] = ACTIONS(5300),
    [anon_sym_thread_local] = ACTIONS(5300),
    [anon_sym___thread] = ACTIONS(5300),
    [anon_sym_const] = ACTIONS(5300),
    [anon_sym_constexpr] = ACTIONS(5300),
    [anon_sym_volatile] = ACTIONS(5300),
    [anon_sym_restrict] = ACTIONS(5300),
    [anon_sym___restrict__] = ACTIONS(5300),
    [anon_sym__Atomic] = ACTIONS(5300),
    [anon_sym__Noreturn] = ACTIONS(5300),
    [anon_sym_noreturn] = ACTIONS(5300),
    [anon_sym_mutable] = ACTIONS(5300),
    [anon_sym_constinit] = ACTIONS(5300),
    [anon_sym_consteval] = ACTIONS(5300),
    [anon_sym_PROGMEM] = ACTIONS(5300),
    [aux_sym_primitive_type_token1] = ACTIONS(5300),
    [anon_sym_byte] = ACTIONS(5300),
    [anon_sym_word] = ACTIONS(5300),
    [anon_sym_enum] = ACTIONS(5300),
    [anon_sym_class] = ACTIONS(5300),
    [anon_sym_struct] = ACTIONS(5300),
    [anon_sym_union] = ACTIONS(5300),
    [anon_sym_or] = ACTIONS(5300),
    [anon_sym_and] = ACTIONS(5300),
    [anon_sym_asm] = ACTIONS(5300),
    [anon_sym___asm__] = ACTIONS(5300),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5300),
    [anon_sym_decltype] = ACTIONS(5300),
    [anon_sym_final] = ACTIONS(5300),
    [anon_sym_override] = ACTIONS(5300),
    [anon_sym_virtual] = ACTIONS(5300),
    [anon_sym_alignas] = ACTIONS(5300),
    [anon_sym_explicit] = ACTIONS(5300),
    [anon_sym_typename] = ACTIONS(5300),
    [anon_sym_template] = ACTIONS(5300),
    [anon_sym_GT2] = ACTIONS(5302),
    [anon_sym_operator] = ACTIONS(5300),
    [anon_sym_try] = ACTIONS(5300),
    [anon_sym_friend] = ACTIONS(5300),
    [anon_sym_using] = ACTIONS(5300),
    [anon_sym_concept] = ACTIONS(5300),
    [anon_sym_requires] = ACTIONS(5300),
  },
  [2044] = {
    [sym_identifier] = ACTIONS(5304),
    [anon_sym_COMMA] = ACTIONS(5306),
    [anon_sym_RPAREN] = ACTIONS(5306),
    [anon_sym_LPAREN2] = ACTIONS(5306),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_STAR] = ACTIONS(5306),
    [anon_sym_PIPE_PIPE] = ACTIONS(5306),
    [anon_sym_AMP_AMP] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(5304),
    [anon_sym_SEMI] = ACTIONS(5306),
    [anon_sym___extension__] = ACTIONS(5304),
    [anon_sym_extern] = ACTIONS(5304),
    [anon_sym___attribute__] = ACTIONS(5304),
    [anon_sym_COLON_COLON] = ACTIONS(5306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5306),
    [anon_sym___declspec] = ACTIONS(5304),
    [anon_sym___based] = ACTIONS(5304),
    [anon_sym___cdecl] = ACTIONS(5304),
    [anon_sym___clrcall] = ACTIONS(5304),
    [anon_sym___stdcall] = ACTIONS(5304),
    [anon_sym___fastcall] = ACTIONS(5304),
    [anon_sym___thiscall] = ACTIONS(5304),
    [anon_sym___vectorcall] = ACTIONS(5304),
    [anon_sym_LBRACE] = ACTIONS(5306),
    [anon_sym_signed] = ACTIONS(5304),
    [anon_sym_unsigned] = ACTIONS(5304),
    [anon_sym_long] = ACTIONS(5304),
    [anon_sym_short] = ACTIONS(5304),
    [anon_sym_LBRACK] = ACTIONS(5304),
    [anon_sym_EQ] = ACTIONS(5306),
    [anon_sym_static] = ACTIONS(5304),
    [anon_sym_register] = ACTIONS(5304),
    [anon_sym_inline] = ACTIONS(5304),
    [anon_sym___inline] = ACTIONS(5304),
    [anon_sym___inline__] = ACTIONS(5304),
    [anon_sym___forceinline] = ACTIONS(5304),
    [anon_sym_thread_local] = ACTIONS(5304),
    [anon_sym___thread] = ACTIONS(5304),
    [anon_sym_const] = ACTIONS(5304),
    [anon_sym_constexpr] = ACTIONS(5304),
    [anon_sym_volatile] = ACTIONS(5304),
    [anon_sym_restrict] = ACTIONS(5304),
    [anon_sym___restrict__] = ACTIONS(5304),
    [anon_sym__Atomic] = ACTIONS(5304),
    [anon_sym__Noreturn] = ACTIONS(5304),
    [anon_sym_noreturn] = ACTIONS(5304),
    [anon_sym_mutable] = ACTIONS(5304),
    [anon_sym_constinit] = ACTIONS(5304),
    [anon_sym_consteval] = ACTIONS(5304),
    [anon_sym_PROGMEM] = ACTIONS(5304),
    [aux_sym_primitive_type_token1] = ACTIONS(5304),
    [anon_sym_byte] = ACTIONS(5304),
    [anon_sym_word] = ACTIONS(5304),
    [anon_sym_enum] = ACTIONS(5304),
    [anon_sym_class] = ACTIONS(5304),
    [anon_sym_struct] = ACTIONS(5304),
    [anon_sym_union] = ACTIONS(5304),
    [anon_sym_or] = ACTIONS(5304),
    [anon_sym_and] = ACTIONS(5304),
    [anon_sym_asm] = ACTIONS(5304),
    [anon_sym___asm__] = ACTIONS(5304),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5304),
    [anon_sym_decltype] = ACTIONS(5304),
    [anon_sym_final] = ACTIONS(5304),
    [anon_sym_override] = ACTIONS(5304),
    [anon_sym_virtual] = ACTIONS(5304),
    [anon_sym_alignas] = ACTIONS(5304),
    [anon_sym_explicit] = ACTIONS(5304),
    [anon_sym_typename] = ACTIONS(5304),
    [anon_sym_template] = ACTIONS(5304),
    [anon_sym_GT2] = ACTIONS(5306),
    [anon_sym_operator] = ACTIONS(5304),
    [anon_sym_try] = ACTIONS(5304),
    [anon_sym_friend] = ACTIONS(5304),
    [anon_sym_using] = ACTIONS(5304),
    [anon_sym_concept] = ACTIONS(5304),
    [anon_sym_requires] = ACTIONS(5304),
  },
  [2045] = {
    [sym_identifier] = ACTIONS(5308),
    [anon_sym_COMMA] = ACTIONS(5310),
    [anon_sym_RPAREN] = ACTIONS(5310),
    [anon_sym_LPAREN2] = ACTIONS(5310),
    [anon_sym_TILDE] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(5310),
    [anon_sym_PIPE_PIPE] = ACTIONS(5310),
    [anon_sym_AMP_AMP] = ACTIONS(5310),
    [anon_sym_AMP] = ACTIONS(5308),
    [anon_sym_SEMI] = ACTIONS(5310),
    [anon_sym___extension__] = ACTIONS(5308),
    [anon_sym_extern] = ACTIONS(5308),
    [anon_sym___attribute__] = ACTIONS(5308),
    [anon_sym_COLON_COLON] = ACTIONS(5310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5310),
    [anon_sym___declspec] = ACTIONS(5308),
    [anon_sym___based] = ACTIONS(5308),
    [anon_sym___cdecl] = ACTIONS(5308),
    [anon_sym___clrcall] = ACTIONS(5308),
    [anon_sym___stdcall] = ACTIONS(5308),
    [anon_sym___fastcall] = ACTIONS(5308),
    [anon_sym___thiscall] = ACTIONS(5308),
    [anon_sym___vectorcall] = ACTIONS(5308),
    [anon_sym_LBRACE] = ACTIONS(5310),
    [anon_sym_signed] = ACTIONS(5308),
    [anon_sym_unsigned] = ACTIONS(5308),
    [anon_sym_long] = ACTIONS(5308),
    [anon_sym_short] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(5310),
    [anon_sym_static] = ACTIONS(5308),
    [anon_sym_register] = ACTIONS(5308),
    [anon_sym_inline] = ACTIONS(5308),
    [anon_sym___inline] = ACTIONS(5308),
    [anon_sym___inline__] = ACTIONS(5308),
    [anon_sym___forceinline] = ACTIONS(5308),
    [anon_sym_thread_local] = ACTIONS(5308),
    [anon_sym___thread] = ACTIONS(5308),
    [anon_sym_const] = ACTIONS(5308),
    [anon_sym_constexpr] = ACTIONS(5308),
    [anon_sym_volatile] = ACTIONS(5308),
    [anon_sym_restrict] = ACTIONS(5308),
    [anon_sym___restrict__] = ACTIONS(5308),
    [anon_sym__Atomic] = ACTIONS(5308),
    [anon_sym__Noreturn] = ACTIONS(5308),
    [anon_sym_noreturn] = ACTIONS(5308),
    [anon_sym_mutable] = ACTIONS(5308),
    [anon_sym_constinit] = ACTIONS(5308),
    [anon_sym_consteval] = ACTIONS(5308),
    [anon_sym_PROGMEM] = ACTIONS(5308),
    [aux_sym_primitive_type_token1] = ACTIONS(5308),
    [anon_sym_byte] = ACTIONS(5308),
    [anon_sym_word] = ACTIONS(5308),
    [anon_sym_enum] = ACTIONS(5308),
    [anon_sym_class] = ACTIONS(5308),
    [anon_sym_struct] = ACTIONS(5308),
    [anon_sym_union] = ACTIONS(5308),
    [anon_sym_or] = ACTIONS(5308),
    [anon_sym_and] = ACTIONS(5308),
    [anon_sym_asm] = ACTIONS(5308),
    [anon_sym___asm__] = ACTIONS(5308),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5308),
    [anon_sym_decltype] = ACTIONS(5308),
    [anon_sym_final] = ACTIONS(5308),
    [anon_sym_override] = ACTIONS(5308),
    [anon_sym_virtual] = ACTIONS(5308),
    [anon_sym_alignas] = ACTIONS(5308),
    [anon_sym_explicit] = ACTIONS(5308),
    [anon_sym_typename] = ACTIONS(5308),
    [anon_sym_template] = ACTIONS(5308),
    [anon_sym_GT2] = ACTIONS(5310),
    [anon_sym_operator] = ACTIONS(5308),
    [anon_sym_try] = ACTIONS(5308),
    [anon_sym_friend] = ACTIONS(5308),
    [anon_sym_using] = ACTIONS(5308),
    [anon_sym_concept] = ACTIONS(5308),
    [anon_sym_requires] = ACTIONS(5308),
  },
  [2046] = {
    [sym_identifier] = ACTIONS(5312),
    [anon_sym_COMMA] = ACTIONS(5314),
    [anon_sym_RPAREN] = ACTIONS(5314),
    [anon_sym_LPAREN2] = ACTIONS(5314),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_STAR] = ACTIONS(5314),
    [anon_sym_PIPE_PIPE] = ACTIONS(5314),
    [anon_sym_AMP_AMP] = ACTIONS(5314),
    [anon_sym_AMP] = ACTIONS(5312),
    [anon_sym_SEMI] = ACTIONS(5314),
    [anon_sym___extension__] = ACTIONS(5312),
    [anon_sym_extern] = ACTIONS(5312),
    [anon_sym___attribute__] = ACTIONS(5312),
    [anon_sym_COLON_COLON] = ACTIONS(5314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5314),
    [anon_sym___declspec] = ACTIONS(5312),
    [anon_sym___based] = ACTIONS(5312),
    [anon_sym___cdecl] = ACTIONS(5312),
    [anon_sym___clrcall] = ACTIONS(5312),
    [anon_sym___stdcall] = ACTIONS(5312),
    [anon_sym___fastcall] = ACTIONS(5312),
    [anon_sym___thiscall] = ACTIONS(5312),
    [anon_sym___vectorcall] = ACTIONS(5312),
    [anon_sym_LBRACE] = ACTIONS(5314),
    [anon_sym_signed] = ACTIONS(5312),
    [anon_sym_unsigned] = ACTIONS(5312),
    [anon_sym_long] = ACTIONS(5312),
    [anon_sym_short] = ACTIONS(5312),
    [anon_sym_LBRACK] = ACTIONS(5312),
    [anon_sym_EQ] = ACTIONS(5314),
    [anon_sym_static] = ACTIONS(5312),
    [anon_sym_register] = ACTIONS(5312),
    [anon_sym_inline] = ACTIONS(5312),
    [anon_sym___inline] = ACTIONS(5312),
    [anon_sym___inline__] = ACTIONS(5312),
    [anon_sym___forceinline] = ACTIONS(5312),
    [anon_sym_thread_local] = ACTIONS(5312),
    [anon_sym___thread] = ACTIONS(5312),
    [anon_sym_const] = ACTIONS(5312),
    [anon_sym_constexpr] = ACTIONS(5312),
    [anon_sym_volatile] = ACTIONS(5312),
    [anon_sym_restrict] = ACTIONS(5312),
    [anon_sym___restrict__] = ACTIONS(5312),
    [anon_sym__Atomic] = ACTIONS(5312),
    [anon_sym__Noreturn] = ACTIONS(5312),
    [anon_sym_noreturn] = ACTIONS(5312),
    [anon_sym_mutable] = ACTIONS(5312),
    [anon_sym_constinit] = ACTIONS(5312),
    [anon_sym_consteval] = ACTIONS(5312),
    [anon_sym_PROGMEM] = ACTIONS(5312),
    [aux_sym_primitive_type_token1] = ACTIONS(5312),
    [anon_sym_byte] = ACTIONS(5312),
    [anon_sym_word] = ACTIONS(5312),
    [anon_sym_enum] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(5312),
    [anon_sym_struct] = ACTIONS(5312),
    [anon_sym_union] = ACTIONS(5312),
    [anon_sym_or] = ACTIONS(5312),
    [anon_sym_and] = ACTIONS(5312),
    [anon_sym_asm] = ACTIONS(5312),
    [anon_sym___asm__] = ACTIONS(5312),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5312),
    [anon_sym_decltype] = ACTIONS(5312),
    [anon_sym_final] = ACTIONS(5312),
    [anon_sym_override] = ACTIONS(5312),
    [anon_sym_virtual] = ACTIONS(5312),
    [anon_sym_alignas] = ACTIONS(5312),
    [anon_sym_explicit] = ACTIONS(5312),
    [anon_sym_typename] = ACTIONS(5312),
    [anon_sym_template] = ACTIONS(5312),
    [anon_sym_GT2] = ACTIONS(5314),
    [anon_sym_operator] = ACTIONS(5312),
    [anon_sym_try] = ACTIONS(5312),
    [anon_sym_friend] = ACTIONS(5312),
    [anon_sym_using] = ACTIONS(5312),
    [anon_sym_concept] = ACTIONS(5312),
    [anon_sym_requires] = ACTIONS(5312),
  },
  [2047] = {
    [sym_identifier] = ACTIONS(5312),
    [anon_sym_COMMA] = ACTIONS(5314),
    [anon_sym_RPAREN] = ACTIONS(5314),
    [anon_sym_LPAREN2] = ACTIONS(5314),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_STAR] = ACTIONS(5314),
    [anon_sym_PIPE_PIPE] = ACTIONS(5314),
    [anon_sym_AMP_AMP] = ACTIONS(5314),
    [anon_sym_AMP] = ACTIONS(5312),
    [anon_sym_SEMI] = ACTIONS(5314),
    [anon_sym___extension__] = ACTIONS(5312),
    [anon_sym_extern] = ACTIONS(5312),
    [anon_sym___attribute__] = ACTIONS(5312),
    [anon_sym_COLON_COLON] = ACTIONS(5314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5314),
    [anon_sym___declspec] = ACTIONS(5312),
    [anon_sym___based] = ACTIONS(5312),
    [anon_sym___cdecl] = ACTIONS(5312),
    [anon_sym___clrcall] = ACTIONS(5312),
    [anon_sym___stdcall] = ACTIONS(5312),
    [anon_sym___fastcall] = ACTIONS(5312),
    [anon_sym___thiscall] = ACTIONS(5312),
    [anon_sym___vectorcall] = ACTIONS(5312),
    [anon_sym_LBRACE] = ACTIONS(5314),
    [anon_sym_signed] = ACTIONS(5312),
    [anon_sym_unsigned] = ACTIONS(5312),
    [anon_sym_long] = ACTIONS(5312),
    [anon_sym_short] = ACTIONS(5312),
    [anon_sym_LBRACK] = ACTIONS(5312),
    [anon_sym_EQ] = ACTIONS(5314),
    [anon_sym_static] = ACTIONS(5312),
    [anon_sym_register] = ACTIONS(5312),
    [anon_sym_inline] = ACTIONS(5312),
    [anon_sym___inline] = ACTIONS(5312),
    [anon_sym___inline__] = ACTIONS(5312),
    [anon_sym___forceinline] = ACTIONS(5312),
    [anon_sym_thread_local] = ACTIONS(5312),
    [anon_sym___thread] = ACTIONS(5312),
    [anon_sym_const] = ACTIONS(5312),
    [anon_sym_constexpr] = ACTIONS(5312),
    [anon_sym_volatile] = ACTIONS(5312),
    [anon_sym_restrict] = ACTIONS(5312),
    [anon_sym___restrict__] = ACTIONS(5312),
    [anon_sym__Atomic] = ACTIONS(5312),
    [anon_sym__Noreturn] = ACTIONS(5312),
    [anon_sym_noreturn] = ACTIONS(5312),
    [anon_sym_mutable] = ACTIONS(5312),
    [anon_sym_constinit] = ACTIONS(5312),
    [anon_sym_consteval] = ACTIONS(5312),
    [anon_sym_PROGMEM] = ACTIONS(5312),
    [aux_sym_primitive_type_token1] = ACTIONS(5312),
    [anon_sym_byte] = ACTIONS(5312),
    [anon_sym_word] = ACTIONS(5312),
    [anon_sym_enum] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(5312),
    [anon_sym_struct] = ACTIONS(5312),
    [anon_sym_union] = ACTIONS(5312),
    [anon_sym_or] = ACTIONS(5312),
    [anon_sym_and] = ACTIONS(5312),
    [anon_sym_asm] = ACTIONS(5312),
    [anon_sym___asm__] = ACTIONS(5312),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5312),
    [anon_sym_decltype] = ACTIONS(5312),
    [anon_sym_final] = ACTIONS(5312),
    [anon_sym_override] = ACTIONS(5312),
    [anon_sym_virtual] = ACTIONS(5312),
    [anon_sym_alignas] = ACTIONS(5312),
    [anon_sym_explicit] = ACTIONS(5312),
    [anon_sym_typename] = ACTIONS(5312),
    [anon_sym_template] = ACTIONS(5312),
    [anon_sym_GT2] = ACTIONS(5314),
    [anon_sym_operator] = ACTIONS(5312),
    [anon_sym_try] = ACTIONS(5312),
    [anon_sym_friend] = ACTIONS(5312),
    [anon_sym_using] = ACTIONS(5312),
    [anon_sym_concept] = ACTIONS(5312),
    [anon_sym_requires] = ACTIONS(5312),
  },
  [2048] = {
    [sym_identifier] = ACTIONS(5312),
    [anon_sym_COMMA] = ACTIONS(5314),
    [anon_sym_RPAREN] = ACTIONS(5314),
    [anon_sym_LPAREN2] = ACTIONS(5314),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_STAR] = ACTIONS(5314),
    [anon_sym_PIPE_PIPE] = ACTIONS(5314),
    [anon_sym_AMP_AMP] = ACTIONS(5314),
    [anon_sym_AMP] = ACTIONS(5312),
    [anon_sym_SEMI] = ACTIONS(5314),
    [anon_sym___extension__] = ACTIONS(5312),
    [anon_sym_extern] = ACTIONS(5312),
    [anon_sym___attribute__] = ACTIONS(5312),
    [anon_sym_COLON_COLON] = ACTIONS(5314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5314),
    [anon_sym___declspec] = ACTIONS(5312),
    [anon_sym___based] = ACTIONS(5312),
    [anon_sym___cdecl] = ACTIONS(5312),
    [anon_sym___clrcall] = ACTIONS(5312),
    [anon_sym___stdcall] = ACTIONS(5312),
    [anon_sym___fastcall] = ACTIONS(5312),
    [anon_sym___thiscall] = ACTIONS(5312),
    [anon_sym___vectorcall] = ACTIONS(5312),
    [anon_sym_LBRACE] = ACTIONS(5314),
    [anon_sym_signed] = ACTIONS(5312),
    [anon_sym_unsigned] = ACTIONS(5312),
    [anon_sym_long] = ACTIONS(5312),
    [anon_sym_short] = ACTIONS(5312),
    [anon_sym_LBRACK] = ACTIONS(5312),
    [anon_sym_EQ] = ACTIONS(5314),
    [anon_sym_static] = ACTIONS(5312),
    [anon_sym_register] = ACTIONS(5312),
    [anon_sym_inline] = ACTIONS(5312),
    [anon_sym___inline] = ACTIONS(5312),
    [anon_sym___inline__] = ACTIONS(5312),
    [anon_sym___forceinline] = ACTIONS(5312),
    [anon_sym_thread_local] = ACTIONS(5312),
    [anon_sym___thread] = ACTIONS(5312),
    [anon_sym_const] = ACTIONS(5312),
    [anon_sym_constexpr] = ACTIONS(5312),
    [anon_sym_volatile] = ACTIONS(5312),
    [anon_sym_restrict] = ACTIONS(5312),
    [anon_sym___restrict__] = ACTIONS(5312),
    [anon_sym__Atomic] = ACTIONS(5312),
    [anon_sym__Noreturn] = ACTIONS(5312),
    [anon_sym_noreturn] = ACTIONS(5312),
    [anon_sym_mutable] = ACTIONS(5312),
    [anon_sym_constinit] = ACTIONS(5312),
    [anon_sym_consteval] = ACTIONS(5312),
    [anon_sym_PROGMEM] = ACTIONS(5312),
    [aux_sym_primitive_type_token1] = ACTIONS(5312),
    [anon_sym_byte] = ACTIONS(5312),
    [anon_sym_word] = ACTIONS(5312),
    [anon_sym_enum] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(5312),
    [anon_sym_struct] = ACTIONS(5312),
    [anon_sym_union] = ACTIONS(5312),
    [anon_sym_or] = ACTIONS(5312),
    [anon_sym_and] = ACTIONS(5312),
    [anon_sym_asm] = ACTIONS(5312),
    [anon_sym___asm__] = ACTIONS(5312),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5312),
    [anon_sym_decltype] = ACTIONS(5312),
    [anon_sym_final] = ACTIONS(5312),
    [anon_sym_override] = ACTIONS(5312),
    [anon_sym_virtual] = ACTIONS(5312),
    [anon_sym_alignas] = ACTIONS(5312),
    [anon_sym_explicit] = ACTIONS(5312),
    [anon_sym_typename] = ACTIONS(5312),
    [anon_sym_template] = ACTIONS(5312),
    [anon_sym_GT2] = ACTIONS(5314),
    [anon_sym_operator] = ACTIONS(5312),
    [anon_sym_try] = ACTIONS(5312),
    [anon_sym_friend] = ACTIONS(5312),
    [anon_sym_using] = ACTIONS(5312),
    [anon_sym_concept] = ACTIONS(5312),
    [anon_sym_requires] = ACTIONS(5312),
  },
  [2049] = {
    [sym_identifier] = ACTIONS(5316),
    [anon_sym_COMMA] = ACTIONS(5318),
    [anon_sym_RPAREN] = ACTIONS(5318),
    [anon_sym_LPAREN2] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [anon_sym_STAR] = ACTIONS(5318),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_AMP] = ACTIONS(5316),
    [anon_sym_SEMI] = ACTIONS(5318),
    [anon_sym___extension__] = ACTIONS(5316),
    [anon_sym_extern] = ACTIONS(5316),
    [anon_sym___attribute__] = ACTIONS(5316),
    [anon_sym_COLON_COLON] = ACTIONS(5318),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5318),
    [anon_sym___declspec] = ACTIONS(5316),
    [anon_sym___based] = ACTIONS(5316),
    [anon_sym___cdecl] = ACTIONS(5316),
    [anon_sym___clrcall] = ACTIONS(5316),
    [anon_sym___stdcall] = ACTIONS(5316),
    [anon_sym___fastcall] = ACTIONS(5316),
    [anon_sym___thiscall] = ACTIONS(5316),
    [anon_sym___vectorcall] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(5318),
    [anon_sym_signed] = ACTIONS(5316),
    [anon_sym_unsigned] = ACTIONS(5316),
    [anon_sym_long] = ACTIONS(5316),
    [anon_sym_short] = ACTIONS(5316),
    [anon_sym_LBRACK] = ACTIONS(5316),
    [anon_sym_EQ] = ACTIONS(5318),
    [anon_sym_static] = ACTIONS(5316),
    [anon_sym_register] = ACTIONS(5316),
    [anon_sym_inline] = ACTIONS(5316),
    [anon_sym___inline] = ACTIONS(5316),
    [anon_sym___inline__] = ACTIONS(5316),
    [anon_sym___forceinline] = ACTIONS(5316),
    [anon_sym_thread_local] = ACTIONS(5316),
    [anon_sym___thread] = ACTIONS(5316),
    [anon_sym_const] = ACTIONS(5316),
    [anon_sym_constexpr] = ACTIONS(5316),
    [anon_sym_volatile] = ACTIONS(5316),
    [anon_sym_restrict] = ACTIONS(5316),
    [anon_sym___restrict__] = ACTIONS(5316),
    [anon_sym__Atomic] = ACTIONS(5316),
    [anon_sym__Noreturn] = ACTIONS(5316),
    [anon_sym_noreturn] = ACTIONS(5316),
    [anon_sym_mutable] = ACTIONS(5316),
    [anon_sym_constinit] = ACTIONS(5316),
    [anon_sym_consteval] = ACTIONS(5316),
    [anon_sym_PROGMEM] = ACTIONS(5316),
    [aux_sym_primitive_type_token1] = ACTIONS(5316),
    [anon_sym_byte] = ACTIONS(5316),
    [anon_sym_word] = ACTIONS(5316),
    [anon_sym_enum] = ACTIONS(5316),
    [anon_sym_class] = ACTIONS(5316),
    [anon_sym_struct] = ACTIONS(5316),
    [anon_sym_union] = ACTIONS(5316),
    [anon_sym_or] = ACTIONS(5316),
    [anon_sym_and] = ACTIONS(5316),
    [anon_sym_asm] = ACTIONS(5316),
    [anon_sym___asm__] = ACTIONS(5316),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5316),
    [anon_sym_decltype] = ACTIONS(5316),
    [anon_sym_final] = ACTIONS(5316),
    [anon_sym_override] = ACTIONS(5316),
    [anon_sym_virtual] = ACTIONS(5316),
    [anon_sym_alignas] = ACTIONS(5316),
    [anon_sym_explicit] = ACTIONS(5316),
    [anon_sym_typename] = ACTIONS(5316),
    [anon_sym_template] = ACTIONS(5316),
    [anon_sym_GT2] = ACTIONS(5318),
    [anon_sym_operator] = ACTIONS(5316),
    [anon_sym_try] = ACTIONS(5316),
    [anon_sym_friend] = ACTIONS(5316),
    [anon_sym_using] = ACTIONS(5316),
    [anon_sym_concept] = ACTIONS(5316),
    [anon_sym_requires] = ACTIONS(5316),
  },
  [2050] = {
    [sym_identifier] = ACTIONS(5320),
    [anon_sym_COMMA] = ACTIONS(5322),
    [anon_sym_RPAREN] = ACTIONS(5322),
    [anon_sym_LPAREN2] = ACTIONS(5322),
    [anon_sym_TILDE] = ACTIONS(5322),
    [anon_sym_STAR] = ACTIONS(5322),
    [anon_sym_PIPE_PIPE] = ACTIONS(5322),
    [anon_sym_AMP_AMP] = ACTIONS(5322),
    [anon_sym_AMP] = ACTIONS(5320),
    [anon_sym_SEMI] = ACTIONS(5322),
    [anon_sym___extension__] = ACTIONS(5320),
    [anon_sym_extern] = ACTIONS(5320),
    [anon_sym___attribute__] = ACTIONS(5320),
    [anon_sym_COLON_COLON] = ACTIONS(5322),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5322),
    [anon_sym___declspec] = ACTIONS(5320),
    [anon_sym___based] = ACTIONS(5320),
    [anon_sym___cdecl] = ACTIONS(5320),
    [anon_sym___clrcall] = ACTIONS(5320),
    [anon_sym___stdcall] = ACTIONS(5320),
    [anon_sym___fastcall] = ACTIONS(5320),
    [anon_sym___thiscall] = ACTIONS(5320),
    [anon_sym___vectorcall] = ACTIONS(5320),
    [anon_sym_LBRACE] = ACTIONS(5322),
    [anon_sym_signed] = ACTIONS(5320),
    [anon_sym_unsigned] = ACTIONS(5320),
    [anon_sym_long] = ACTIONS(5320),
    [anon_sym_short] = ACTIONS(5320),
    [anon_sym_LBRACK] = ACTIONS(5320),
    [anon_sym_EQ] = ACTIONS(5322),
    [anon_sym_static] = ACTIONS(5320),
    [anon_sym_register] = ACTIONS(5320),
    [anon_sym_inline] = ACTIONS(5320),
    [anon_sym___inline] = ACTIONS(5320),
    [anon_sym___inline__] = ACTIONS(5320),
    [anon_sym___forceinline] = ACTIONS(5320),
    [anon_sym_thread_local] = ACTIONS(5320),
    [anon_sym___thread] = ACTIONS(5320),
    [anon_sym_const] = ACTIONS(5320),
    [anon_sym_constexpr] = ACTIONS(5320),
    [anon_sym_volatile] = ACTIONS(5320),
    [anon_sym_restrict] = ACTIONS(5320),
    [anon_sym___restrict__] = ACTIONS(5320),
    [anon_sym__Atomic] = ACTIONS(5320),
    [anon_sym__Noreturn] = ACTIONS(5320),
    [anon_sym_noreturn] = ACTIONS(5320),
    [anon_sym_mutable] = ACTIONS(5320),
    [anon_sym_constinit] = ACTIONS(5320),
    [anon_sym_consteval] = ACTIONS(5320),
    [anon_sym_PROGMEM] = ACTIONS(5320),
    [aux_sym_primitive_type_token1] = ACTIONS(5320),
    [anon_sym_byte] = ACTIONS(5320),
    [anon_sym_word] = ACTIONS(5320),
    [anon_sym_enum] = ACTIONS(5320),
    [anon_sym_class] = ACTIONS(5320),
    [anon_sym_struct] = ACTIONS(5320),
    [anon_sym_union] = ACTIONS(5320),
    [anon_sym_or] = ACTIONS(5320),
    [anon_sym_and] = ACTIONS(5320),
    [anon_sym_asm] = ACTIONS(5320),
    [anon_sym___asm__] = ACTIONS(5320),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5320),
    [anon_sym_decltype] = ACTIONS(5320),
    [anon_sym_final] = ACTIONS(5320),
    [anon_sym_override] = ACTIONS(5320),
    [anon_sym_virtual] = ACTIONS(5320),
    [anon_sym_alignas] = ACTIONS(5320),
    [anon_sym_explicit] = ACTIONS(5320),
    [anon_sym_typename] = ACTIONS(5320),
    [anon_sym_template] = ACTIONS(5320),
    [anon_sym_GT2] = ACTIONS(5322),
    [anon_sym_operator] = ACTIONS(5320),
    [anon_sym_try] = ACTIONS(5320),
    [anon_sym_friend] = ACTIONS(5320),
    [anon_sym_using] = ACTIONS(5320),
    [anon_sym_concept] = ACTIONS(5320),
    [anon_sym_requires] = ACTIONS(5320),
  },
  [2051] = {
    [sym_identifier] = ACTIONS(5324),
    [anon_sym_COMMA] = ACTIONS(5326),
    [anon_sym_RPAREN] = ACTIONS(5326),
    [anon_sym_LPAREN2] = ACTIONS(5326),
    [anon_sym_TILDE] = ACTIONS(5326),
    [anon_sym_STAR] = ACTIONS(5326),
    [anon_sym_PIPE_PIPE] = ACTIONS(5326),
    [anon_sym_AMP_AMP] = ACTIONS(5326),
    [anon_sym_AMP] = ACTIONS(5324),
    [anon_sym_SEMI] = ACTIONS(5326),
    [anon_sym___extension__] = ACTIONS(5324),
    [anon_sym_extern] = ACTIONS(5324),
    [anon_sym___attribute__] = ACTIONS(5324),
    [anon_sym_COLON_COLON] = ACTIONS(5326),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5326),
    [anon_sym___declspec] = ACTIONS(5324),
    [anon_sym___based] = ACTIONS(5324),
    [anon_sym___cdecl] = ACTIONS(5324),
    [anon_sym___clrcall] = ACTIONS(5324),
    [anon_sym___stdcall] = ACTIONS(5324),
    [anon_sym___fastcall] = ACTIONS(5324),
    [anon_sym___thiscall] = ACTIONS(5324),
    [anon_sym___vectorcall] = ACTIONS(5324),
    [anon_sym_LBRACE] = ACTIONS(5326),
    [anon_sym_signed] = ACTIONS(5324),
    [anon_sym_unsigned] = ACTIONS(5324),
    [anon_sym_long] = ACTIONS(5324),
    [anon_sym_short] = ACTIONS(5324),
    [anon_sym_LBRACK] = ACTIONS(5324),
    [anon_sym_EQ] = ACTIONS(5326),
    [anon_sym_static] = ACTIONS(5324),
    [anon_sym_register] = ACTIONS(5324),
    [anon_sym_inline] = ACTIONS(5324),
    [anon_sym___inline] = ACTIONS(5324),
    [anon_sym___inline__] = ACTIONS(5324),
    [anon_sym___forceinline] = ACTIONS(5324),
    [anon_sym_thread_local] = ACTIONS(5324),
    [anon_sym___thread] = ACTIONS(5324),
    [anon_sym_const] = ACTIONS(5324),
    [anon_sym_constexpr] = ACTIONS(5324),
    [anon_sym_volatile] = ACTIONS(5324),
    [anon_sym_restrict] = ACTIONS(5324),
    [anon_sym___restrict__] = ACTIONS(5324),
    [anon_sym__Atomic] = ACTIONS(5324),
    [anon_sym__Noreturn] = ACTIONS(5324),
    [anon_sym_noreturn] = ACTIONS(5324),
    [anon_sym_mutable] = ACTIONS(5324),
    [anon_sym_constinit] = ACTIONS(5324),
    [anon_sym_consteval] = ACTIONS(5324),
    [anon_sym_PROGMEM] = ACTIONS(5324),
    [aux_sym_primitive_type_token1] = ACTIONS(5324),
    [anon_sym_byte] = ACTIONS(5324),
    [anon_sym_word] = ACTIONS(5324),
    [anon_sym_enum] = ACTIONS(5324),
    [anon_sym_class] = ACTIONS(5324),
    [anon_sym_struct] = ACTIONS(5324),
    [anon_sym_union] = ACTIONS(5324),
    [anon_sym_or] = ACTIONS(5324),
    [anon_sym_and] = ACTIONS(5324),
    [anon_sym_asm] = ACTIONS(5324),
    [anon_sym___asm__] = ACTIONS(5324),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5324),
    [anon_sym_decltype] = ACTIONS(5324),
    [anon_sym_final] = ACTIONS(5324),
    [anon_sym_override] = ACTIONS(5324),
    [anon_sym_virtual] = ACTIONS(5324),
    [anon_sym_alignas] = ACTIONS(5324),
    [anon_sym_explicit] = ACTIONS(5324),
    [anon_sym_typename] = ACTIONS(5324),
    [anon_sym_template] = ACTIONS(5324),
    [anon_sym_GT2] = ACTIONS(5326),
    [anon_sym_operator] = ACTIONS(5324),
    [anon_sym_try] = ACTIONS(5324),
    [anon_sym_friend] = ACTIONS(5324),
    [anon_sym_using] = ACTIONS(5324),
    [anon_sym_concept] = ACTIONS(5324),
    [anon_sym_requires] = ACTIONS(5324),
  },
  [2052] = {
    [sym_identifier] = ACTIONS(5328),
    [anon_sym_COMMA] = ACTIONS(5330),
    [anon_sym_RPAREN] = ACTIONS(5330),
    [anon_sym_LPAREN2] = ACTIONS(5330),
    [anon_sym_TILDE] = ACTIONS(5330),
    [anon_sym_STAR] = ACTIONS(5330),
    [anon_sym_PIPE_PIPE] = ACTIONS(5330),
    [anon_sym_AMP_AMP] = ACTIONS(5330),
    [anon_sym_AMP] = ACTIONS(5328),
    [anon_sym_SEMI] = ACTIONS(5330),
    [anon_sym___extension__] = ACTIONS(5328),
    [anon_sym_extern] = ACTIONS(5328),
    [anon_sym___attribute__] = ACTIONS(5328),
    [anon_sym_COLON_COLON] = ACTIONS(5330),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5330),
    [anon_sym___declspec] = ACTIONS(5328),
    [anon_sym___based] = ACTIONS(5328),
    [anon_sym___cdecl] = ACTIONS(5328),
    [anon_sym___clrcall] = ACTIONS(5328),
    [anon_sym___stdcall] = ACTIONS(5328),
    [anon_sym___fastcall] = ACTIONS(5328),
    [anon_sym___thiscall] = ACTIONS(5328),
    [anon_sym___vectorcall] = ACTIONS(5328),
    [anon_sym_LBRACE] = ACTIONS(5330),
    [anon_sym_signed] = ACTIONS(5328),
    [anon_sym_unsigned] = ACTIONS(5328),
    [anon_sym_long] = ACTIONS(5328),
    [anon_sym_short] = ACTIONS(5328),
    [anon_sym_LBRACK] = ACTIONS(5328),
    [anon_sym_EQ] = ACTIONS(5330),
    [anon_sym_static] = ACTIONS(5328),
    [anon_sym_register] = ACTIONS(5328),
    [anon_sym_inline] = ACTIONS(5328),
    [anon_sym___inline] = ACTIONS(5328),
    [anon_sym___inline__] = ACTIONS(5328),
    [anon_sym___forceinline] = ACTIONS(5328),
    [anon_sym_thread_local] = ACTIONS(5328),
    [anon_sym___thread] = ACTIONS(5328),
    [anon_sym_const] = ACTIONS(5328),
    [anon_sym_constexpr] = ACTIONS(5328),
    [anon_sym_volatile] = ACTIONS(5328),
    [anon_sym_restrict] = ACTIONS(5328),
    [anon_sym___restrict__] = ACTIONS(5328),
    [anon_sym__Atomic] = ACTIONS(5328),
    [anon_sym__Noreturn] = ACTIONS(5328),
    [anon_sym_noreturn] = ACTIONS(5328),
    [anon_sym_mutable] = ACTIONS(5328),
    [anon_sym_constinit] = ACTIONS(5328),
    [anon_sym_consteval] = ACTIONS(5328),
    [anon_sym_PROGMEM] = ACTIONS(5328),
    [aux_sym_primitive_type_token1] = ACTIONS(5328),
    [anon_sym_byte] = ACTIONS(5328),
    [anon_sym_word] = ACTIONS(5328),
    [anon_sym_enum] = ACTIONS(5328),
    [anon_sym_class] = ACTIONS(5328),
    [anon_sym_struct] = ACTIONS(5328),
    [anon_sym_union] = ACTIONS(5328),
    [anon_sym_or] = ACTIONS(5328),
    [anon_sym_and] = ACTIONS(5328),
    [anon_sym_asm] = ACTIONS(5328),
    [anon_sym___asm__] = ACTIONS(5328),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5328),
    [anon_sym_decltype] = ACTIONS(5328),
    [anon_sym_final] = ACTIONS(5328),
    [anon_sym_override] = ACTIONS(5328),
    [anon_sym_virtual] = ACTIONS(5328),
    [anon_sym_alignas] = ACTIONS(5328),
    [anon_sym_explicit] = ACTIONS(5328),
    [anon_sym_typename] = ACTIONS(5328),
    [anon_sym_template] = ACTIONS(5328),
    [anon_sym_GT2] = ACTIONS(5330),
    [anon_sym_operator] = ACTIONS(5328),
    [anon_sym_try] = ACTIONS(5328),
    [anon_sym_friend] = ACTIONS(5328),
    [anon_sym_using] = ACTIONS(5328),
    [anon_sym_concept] = ACTIONS(5328),
    [anon_sym_requires] = ACTIONS(5328),
  },
  [2053] = {
    [sym__declaration_modifiers] = STATE(2282),
    [sym__declaration_specifiers] = STATE(4815),
    [sym_attribute_specifier] = STATE(2282),
    [sym_attribute_declaration] = STATE(2282),
    [sym_ms_declspec_modifier] = STATE(2282),
    [sym_storage_class_specifier] = STATE(2282),
    [sym_type_qualifier] = STATE(2282),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_parameter_declaration] = STATE(8543),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2282),
    [sym_alignas_specifier] = STATE(2282),
    [sym_dependent_type] = STATE(3087),
    [sym_type_parameter_declaration] = STATE(8543),
    [sym_variadic_type_parameter_declaration] = STATE(8543),
    [sym_optional_type_parameter_declaration] = STATE(8543),
    [sym_template_template_parameter_declaration] = STATE(8543),
    [sym_optional_parameter_declaration] = STATE(8543),
    [sym_variadic_parameter_declaration] = STATE(8543),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7326),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2282),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5095),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5105),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(5274),
    [anon_sym_struct] = ACTIONS(2025),
    [anon_sym_union] = ACTIONS(2027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(5276),
    [anon_sym_template] = ACTIONS(5278),
  },
  [2054] = {
    [sym_identifier] = ACTIONS(5332),
    [anon_sym_COMMA] = ACTIONS(5334),
    [anon_sym_RPAREN] = ACTIONS(5334),
    [anon_sym_LPAREN2] = ACTIONS(5334),
    [anon_sym_TILDE] = ACTIONS(5334),
    [anon_sym_STAR] = ACTIONS(5334),
    [anon_sym_PIPE_PIPE] = ACTIONS(5334),
    [anon_sym_AMP_AMP] = ACTIONS(5334),
    [anon_sym_AMP] = ACTIONS(5332),
    [anon_sym_SEMI] = ACTIONS(5334),
    [anon_sym___extension__] = ACTIONS(5332),
    [anon_sym_extern] = ACTIONS(5332),
    [anon_sym___attribute__] = ACTIONS(5332),
    [anon_sym_COLON_COLON] = ACTIONS(5334),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5334),
    [anon_sym___declspec] = ACTIONS(5332),
    [anon_sym___based] = ACTIONS(5332),
    [anon_sym___cdecl] = ACTIONS(5332),
    [anon_sym___clrcall] = ACTIONS(5332),
    [anon_sym___stdcall] = ACTIONS(5332),
    [anon_sym___fastcall] = ACTIONS(5332),
    [anon_sym___thiscall] = ACTIONS(5332),
    [anon_sym___vectorcall] = ACTIONS(5332),
    [anon_sym_LBRACE] = ACTIONS(5334),
    [anon_sym_signed] = ACTIONS(5332),
    [anon_sym_unsigned] = ACTIONS(5332),
    [anon_sym_long] = ACTIONS(5332),
    [anon_sym_short] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(5332),
    [anon_sym_EQ] = ACTIONS(5334),
    [anon_sym_static] = ACTIONS(5332),
    [anon_sym_register] = ACTIONS(5332),
    [anon_sym_inline] = ACTIONS(5332),
    [anon_sym___inline] = ACTIONS(5332),
    [anon_sym___inline__] = ACTIONS(5332),
    [anon_sym___forceinline] = ACTIONS(5332),
    [anon_sym_thread_local] = ACTIONS(5332),
    [anon_sym___thread] = ACTIONS(5332),
    [anon_sym_const] = ACTIONS(5332),
    [anon_sym_constexpr] = ACTIONS(5332),
    [anon_sym_volatile] = ACTIONS(5332),
    [anon_sym_restrict] = ACTIONS(5332),
    [anon_sym___restrict__] = ACTIONS(5332),
    [anon_sym__Atomic] = ACTIONS(5332),
    [anon_sym__Noreturn] = ACTIONS(5332),
    [anon_sym_noreturn] = ACTIONS(5332),
    [anon_sym_mutable] = ACTIONS(5332),
    [anon_sym_constinit] = ACTIONS(5332),
    [anon_sym_consteval] = ACTIONS(5332),
    [anon_sym_PROGMEM] = ACTIONS(5332),
    [aux_sym_primitive_type_token1] = ACTIONS(5332),
    [anon_sym_byte] = ACTIONS(5332),
    [anon_sym_word] = ACTIONS(5332),
    [anon_sym_enum] = ACTIONS(5332),
    [anon_sym_class] = ACTIONS(5332),
    [anon_sym_struct] = ACTIONS(5332),
    [anon_sym_union] = ACTIONS(5332),
    [anon_sym_or] = ACTIONS(5332),
    [anon_sym_and] = ACTIONS(5332),
    [anon_sym_asm] = ACTIONS(5332),
    [anon_sym___asm__] = ACTIONS(5332),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5332),
    [anon_sym_decltype] = ACTIONS(5332),
    [anon_sym_final] = ACTIONS(5332),
    [anon_sym_override] = ACTIONS(5332),
    [anon_sym_virtual] = ACTIONS(5332),
    [anon_sym_alignas] = ACTIONS(5332),
    [anon_sym_explicit] = ACTIONS(5332),
    [anon_sym_typename] = ACTIONS(5332),
    [anon_sym_template] = ACTIONS(5332),
    [anon_sym_GT2] = ACTIONS(5334),
    [anon_sym_operator] = ACTIONS(5332),
    [anon_sym_try] = ACTIONS(5332),
    [anon_sym_friend] = ACTIONS(5332),
    [anon_sym_using] = ACTIONS(5332),
    [anon_sym_concept] = ACTIONS(5332),
    [anon_sym_requires] = ACTIONS(5332),
  },
  [2055] = {
    [sym__declaration_modifiers] = STATE(2282),
    [sym__declaration_specifiers] = STATE(4808),
    [sym_attribute_specifier] = STATE(2282),
    [sym_attribute_declaration] = STATE(2282),
    [sym_ms_declspec_modifier] = STATE(2282),
    [sym_storage_class_specifier] = STATE(2282),
    [sym_type_qualifier] = STATE(2282),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_parameter_declaration] = STATE(8128),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2282),
    [sym_alignas_specifier] = STATE(2282),
    [sym_dependent_type] = STATE(3087),
    [sym_optional_parameter_declaration] = STATE(8128),
    [sym_variadic_parameter_declaration] = STATE(8128),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7326),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2282),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5336),
    [anon_sym_RPAREN] = ACTIONS(5338),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5105),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2023),
    [anon_sym_struct] = ACTIONS(2025),
    [anon_sym_union] = ACTIONS(2027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2053),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2056] = {
    [sym__declaration_modifiers] = STATE(2282),
    [sym__declaration_specifiers] = STATE(4808),
    [sym_attribute_specifier] = STATE(2282),
    [sym_attribute_declaration] = STATE(2282),
    [sym_ms_declspec_modifier] = STATE(2282),
    [sym_storage_class_specifier] = STATE(2282),
    [sym_type_qualifier] = STATE(2282),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_parameter_declaration] = STATE(8304),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2282),
    [sym_alignas_specifier] = STATE(2282),
    [sym_dependent_type] = STATE(3087),
    [sym_optional_parameter_declaration] = STATE(8304),
    [sym_variadic_parameter_declaration] = STATE(8304),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7326),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2282),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2067),
    [anon_sym_RPAREN] = ACTIONS(4294),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5105),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2023),
    [anon_sym_struct] = ACTIONS(2025),
    [anon_sym_union] = ACTIONS(2027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2053),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2057] = {
    [sym_identifier] = ACTIONS(5340),
    [anon_sym_LPAREN2] = ACTIONS(5342),
    [anon_sym_BANG] = ACTIONS(5342),
    [anon_sym_TILDE] = ACTIONS(5342),
    [anon_sym_DASH] = ACTIONS(5340),
    [anon_sym_PLUS] = ACTIONS(5340),
    [anon_sym_STAR] = ACTIONS(5342),
    [anon_sym_AMP] = ACTIONS(5342),
    [anon_sym_SEMI] = ACTIONS(5342),
    [anon_sym_COLON_COLON] = ACTIONS(5342),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5342),
    [anon_sym_LBRACE] = ACTIONS(5342),
    [anon_sym_LBRACK] = ACTIONS(5340),
    [aux_sym_primitive_type_token1] = ACTIONS(5340),
    [anon_sym_byte] = ACTIONS(5340),
    [anon_sym_word] = ACTIONS(5340),
    [anon_sym_if] = ACTIONS(5340),
    [anon_sym_switch] = ACTIONS(5340),
    [anon_sym_case] = ACTIONS(5340),
    [anon_sym_default] = ACTIONS(5340),
    [anon_sym_while] = ACTIONS(5340),
    [anon_sym_do] = ACTIONS(5340),
    [anon_sym_for] = ACTIONS(5340),
    [anon_sym_return] = ACTIONS(5340),
    [anon_sym_break] = ACTIONS(5340),
    [anon_sym_continue] = ACTIONS(5340),
    [anon_sym_goto] = ACTIONS(5340),
    [anon_sym___try] = ACTIONS(5340),
    [anon_sym___leave] = ACTIONS(5340),
    [anon_sym_not] = ACTIONS(5340),
    [anon_sym_compl] = ACTIONS(5340),
    [anon_sym_DASH_DASH] = ACTIONS(5342),
    [anon_sym_PLUS_PLUS] = ACTIONS(5342),
    [anon_sym_sizeof] = ACTIONS(5340),
    [anon_sym___alignof__] = ACTIONS(5340),
    [anon_sym___alignof] = ACTIONS(5340),
    [anon_sym__alignof] = ACTIONS(5340),
    [anon_sym_alignof] = ACTIONS(5340),
    [anon_sym__Alignof] = ACTIONS(5340),
    [anon_sym_offsetof] = ACTIONS(5340),
    [anon_sym__Generic] = ACTIONS(5340),
    [anon_sym_asm] = ACTIONS(5340),
    [anon_sym___asm__] = ACTIONS(5340),
    [aux_sym_number_literal_token1] = ACTIONS(5342),
    [aux_sym_number_literal_token2] = ACTIONS(5340),
    [anon_sym_L_SQUOTE] = ACTIONS(5342),
    [anon_sym_u_SQUOTE] = ACTIONS(5342),
    [anon_sym_U_SQUOTE] = ACTIONS(5342),
    [anon_sym_u8_SQUOTE] = ACTIONS(5342),
    [anon_sym_SQUOTE] = ACTIONS(5342),
    [anon_sym_L_DQUOTE] = ACTIONS(5342),
    [anon_sym_u_DQUOTE] = ACTIONS(5342),
    [anon_sym_U_DQUOTE] = ACTIONS(5342),
    [anon_sym_u8_DQUOTE] = ACTIONS(5342),
    [anon_sym_DQUOTE] = ACTIONS(5342),
    [sym_true] = ACTIONS(5340),
    [sym_false] = ACTIONS(5340),
    [anon_sym_NULL] = ACTIONS(5340),
    [anon_sym_nullptr] = ACTIONS(5340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5340),
    [anon_sym_template] = ACTIONS(5340),
    [anon_sym_try] = ACTIONS(5340),
    [anon_sym_delete] = ACTIONS(5340),
    [anon_sym_throw] = ACTIONS(5340),
    [anon_sym_co_return] = ACTIONS(5340),
    [anon_sym_co_yield] = ACTIONS(5340),
    [anon_sym_R_DQUOTE] = ACTIONS(5342),
    [anon_sym_LR_DQUOTE] = ACTIONS(5342),
    [anon_sym_uR_DQUOTE] = ACTIONS(5342),
    [anon_sym_UR_DQUOTE] = ACTIONS(5342),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5342),
    [anon_sym_co_await] = ACTIONS(5340),
    [anon_sym_new] = ACTIONS(5340),
    [anon_sym_requires] = ACTIONS(5340),
    [sym_this] = ACTIONS(5340),
  },
  [2058] = {
    [sym__declaration_modifiers] = STATE(2282),
    [sym__declaration_specifiers] = STATE(4808),
    [sym_attribute_specifier] = STATE(2282),
    [sym_attribute_declaration] = STATE(2282),
    [sym_ms_declspec_modifier] = STATE(2282),
    [sym_storage_class_specifier] = STATE(2282),
    [sym_type_qualifier] = STATE(2282),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_parameter_declaration] = STATE(8160),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2282),
    [sym_alignas_specifier] = STATE(2282),
    [sym_dependent_type] = STATE(3087),
    [sym_optional_parameter_declaration] = STATE(8160),
    [sym_variadic_parameter_declaration] = STATE(8160),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7326),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2282),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5344),
    [anon_sym_RPAREN] = ACTIONS(5346),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5105),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2023),
    [anon_sym_struct] = ACTIONS(2025),
    [anon_sym_union] = ACTIONS(2027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2053),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2059] = {
    [sym_string_literal] = STATE(2067),
    [sym_template_argument_list] = STATE(2840),
    [sym_raw_string_literal] = STATE(2067),
    [sym_identifier] = ACTIONS(4256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_RPAREN] = ACTIONS(4248),
    [aux_sym_preproc_if_token2] = ACTIONS(4248),
    [aux_sym_preproc_else_token1] = ACTIONS(4248),
    [aux_sym_preproc_elif_token1] = ACTIONS(4256),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4248),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5348),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_RBRACE] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_RBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4256),
    [anon_sym_COLON] = ACTIONS(4256),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4248),
    [anon_sym_SLASH_EQ] = ACTIONS(4248),
    [anon_sym_PERCENT_EQ] = ACTIONS(4248),
    [anon_sym_PLUS_EQ] = ACTIONS(4248),
    [anon_sym_DASH_EQ] = ACTIONS(4248),
    [anon_sym_LT_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT_GT_EQ] = ACTIONS(4248),
    [anon_sym_AMP_EQ] = ACTIONS(4248),
    [anon_sym_CARET_EQ] = ACTIONS(4248),
    [anon_sym_PIPE_EQ] = ACTIONS(4248),
    [anon_sym_and_eq] = ACTIONS(4256),
    [anon_sym_or_eq] = ACTIONS(4256),
    [anon_sym_xor_eq] = ACTIONS(4256),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4256),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4256),
    [anon_sym_not_eq] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
  },
  [2060] = {
    [sym__declaration_modifiers] = STATE(2282),
    [sym__declaration_specifiers] = STATE(4808),
    [sym_attribute_specifier] = STATE(2282),
    [sym_attribute_declaration] = STATE(2282),
    [sym_ms_declspec_modifier] = STATE(2282),
    [sym_storage_class_specifier] = STATE(2282),
    [sym_type_qualifier] = STATE(2282),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_parameter_declaration] = STATE(7984),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2282),
    [sym_alignas_specifier] = STATE(2282),
    [sym_dependent_type] = STATE(3087),
    [sym_optional_parameter_declaration] = STATE(7984),
    [sym_variadic_parameter_declaration] = STATE(7984),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7326),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2282),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5351),
    [anon_sym_RPAREN] = ACTIONS(5353),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5105),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2023),
    [anon_sym_struct] = ACTIONS(2025),
    [anon_sym_union] = ACTIONS(2027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2053),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2061] = {
    [sym__declaration_modifiers] = STATE(2282),
    [sym__declaration_specifiers] = STATE(4808),
    [sym_attribute_specifier] = STATE(2282),
    [sym_attribute_declaration] = STATE(2282),
    [sym_ms_declspec_modifier] = STATE(2282),
    [sym_storage_class_specifier] = STATE(2282),
    [sym_type_qualifier] = STATE(2282),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_parameter_declaration] = STATE(8288),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2282),
    [sym_alignas_specifier] = STATE(2282),
    [sym_dependent_type] = STATE(3087),
    [sym_optional_parameter_declaration] = STATE(8288),
    [sym_variadic_parameter_declaration] = STATE(8288),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7326),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2282),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5355),
    [anon_sym_RPAREN] = ACTIONS(5357),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5105),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2023),
    [anon_sym_struct] = ACTIONS(2025),
    [anon_sym_union] = ACTIONS(2027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2053),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2062] = {
    [sym_identifier] = ACTIONS(5359),
    [anon_sym_LPAREN2] = ACTIONS(5361),
    [anon_sym_BANG] = ACTIONS(5361),
    [anon_sym_TILDE] = ACTIONS(5361),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_PLUS] = ACTIONS(5359),
    [anon_sym_STAR] = ACTIONS(5361),
    [anon_sym_AMP] = ACTIONS(5361),
    [anon_sym_SEMI] = ACTIONS(5361),
    [anon_sym_COLON_COLON] = ACTIONS(5361),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5361),
    [anon_sym_LBRACE] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5359),
    [aux_sym_primitive_type_token1] = ACTIONS(5359),
    [anon_sym_byte] = ACTIONS(5359),
    [anon_sym_word] = ACTIONS(5359),
    [anon_sym_if] = ACTIONS(5359),
    [anon_sym_switch] = ACTIONS(5359),
    [anon_sym_case] = ACTIONS(5359),
    [anon_sym_default] = ACTIONS(5359),
    [anon_sym_while] = ACTIONS(5359),
    [anon_sym_do] = ACTIONS(5359),
    [anon_sym_for] = ACTIONS(5359),
    [anon_sym_return] = ACTIONS(5359),
    [anon_sym_break] = ACTIONS(5359),
    [anon_sym_continue] = ACTIONS(5359),
    [anon_sym_goto] = ACTIONS(5359),
    [anon_sym___try] = ACTIONS(5359),
    [anon_sym___leave] = ACTIONS(5359),
    [anon_sym_not] = ACTIONS(5359),
    [anon_sym_compl] = ACTIONS(5359),
    [anon_sym_DASH_DASH] = ACTIONS(5361),
    [anon_sym_PLUS_PLUS] = ACTIONS(5361),
    [anon_sym_sizeof] = ACTIONS(5359),
    [anon_sym___alignof__] = ACTIONS(5359),
    [anon_sym___alignof] = ACTIONS(5359),
    [anon_sym__alignof] = ACTIONS(5359),
    [anon_sym_alignof] = ACTIONS(5359),
    [anon_sym__Alignof] = ACTIONS(5359),
    [anon_sym_offsetof] = ACTIONS(5359),
    [anon_sym__Generic] = ACTIONS(5359),
    [anon_sym_asm] = ACTIONS(5359),
    [anon_sym___asm__] = ACTIONS(5359),
    [aux_sym_number_literal_token1] = ACTIONS(5361),
    [aux_sym_number_literal_token2] = ACTIONS(5359),
    [anon_sym_L_SQUOTE] = ACTIONS(5361),
    [anon_sym_u_SQUOTE] = ACTIONS(5361),
    [anon_sym_U_SQUOTE] = ACTIONS(5361),
    [anon_sym_u8_SQUOTE] = ACTIONS(5361),
    [anon_sym_SQUOTE] = ACTIONS(5361),
    [anon_sym_L_DQUOTE] = ACTIONS(5361),
    [anon_sym_u_DQUOTE] = ACTIONS(5361),
    [anon_sym_U_DQUOTE] = ACTIONS(5361),
    [anon_sym_u8_DQUOTE] = ACTIONS(5361),
    [anon_sym_DQUOTE] = ACTIONS(5361),
    [sym_true] = ACTIONS(5359),
    [sym_false] = ACTIONS(5359),
    [anon_sym_NULL] = ACTIONS(5359),
    [anon_sym_nullptr] = ACTIONS(5359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5359),
    [anon_sym_template] = ACTIONS(5359),
    [anon_sym_try] = ACTIONS(5359),
    [anon_sym_delete] = ACTIONS(5359),
    [anon_sym_throw] = ACTIONS(5359),
    [anon_sym_co_return] = ACTIONS(5359),
    [anon_sym_co_yield] = ACTIONS(5359),
    [anon_sym_R_DQUOTE] = ACTIONS(5361),
    [anon_sym_LR_DQUOTE] = ACTIONS(5361),
    [anon_sym_uR_DQUOTE] = ACTIONS(5361),
    [anon_sym_UR_DQUOTE] = ACTIONS(5361),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5361),
    [anon_sym_co_await] = ACTIONS(5359),
    [anon_sym_new] = ACTIONS(5359),
    [anon_sym_requires] = ACTIONS(5359),
    [sym_this] = ACTIONS(5359),
  },
  [2063] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2063),
    [sym_identifier] = ACTIONS(5363),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5365),
    [anon_sym_COMMA] = ACTIONS(5365),
    [anon_sym_RPAREN] = ACTIONS(5365),
    [aux_sym_preproc_if_token2] = ACTIONS(5365),
    [aux_sym_preproc_else_token1] = ACTIONS(5365),
    [aux_sym_preproc_elif_token1] = ACTIONS(5363),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5365),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5365),
    [anon_sym_LPAREN2] = ACTIONS(5365),
    [anon_sym_DASH] = ACTIONS(5363),
    [anon_sym_PLUS] = ACTIONS(5363),
    [anon_sym_STAR] = ACTIONS(5365),
    [anon_sym_SLASH] = ACTIONS(5363),
    [anon_sym_PERCENT] = ACTIONS(5365),
    [anon_sym_PIPE_PIPE] = ACTIONS(5365),
    [anon_sym_AMP_AMP] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5363),
    [anon_sym_CARET] = ACTIONS(5365),
    [anon_sym_AMP] = ACTIONS(5363),
    [anon_sym_EQ_EQ] = ACTIONS(5365),
    [anon_sym_BANG_EQ] = ACTIONS(5365),
    [anon_sym_GT] = ACTIONS(5363),
    [anon_sym_GT_EQ] = ACTIONS(5365),
    [anon_sym_LT_EQ] = ACTIONS(5363),
    [anon_sym_LT] = ACTIONS(5363),
    [anon_sym_LT_LT] = ACTIONS(5365),
    [anon_sym_GT_GT] = ACTIONS(5365),
    [anon_sym_SEMI] = ACTIONS(5365),
    [anon_sym___extension__] = ACTIONS(5363),
    [anon_sym___attribute__] = ACTIONS(5363),
    [anon_sym_LBRACE] = ACTIONS(5365),
    [anon_sym_RBRACE] = ACTIONS(5365),
    [anon_sym_signed] = ACTIONS(5367),
    [anon_sym_unsigned] = ACTIONS(5367),
    [anon_sym_long] = ACTIONS(5367),
    [anon_sym_short] = ACTIONS(5367),
    [anon_sym_LBRACK] = ACTIONS(5365),
    [anon_sym_RBRACK] = ACTIONS(5365),
    [anon_sym_const] = ACTIONS(5363),
    [anon_sym_constexpr] = ACTIONS(5363),
    [anon_sym_volatile] = ACTIONS(5363),
    [anon_sym_restrict] = ACTIONS(5363),
    [anon_sym___restrict__] = ACTIONS(5363),
    [anon_sym__Atomic] = ACTIONS(5363),
    [anon_sym__Noreturn] = ACTIONS(5363),
    [anon_sym_noreturn] = ACTIONS(5363),
    [anon_sym_mutable] = ACTIONS(5363),
    [anon_sym_constinit] = ACTIONS(5363),
    [anon_sym_consteval] = ACTIONS(5363),
    [anon_sym_PROGMEM] = ACTIONS(5363),
    [aux_sym_primitive_type_token1] = ACTIONS(5363),
    [anon_sym_byte] = ACTIONS(5363),
    [anon_sym_word] = ACTIONS(5363),
    [anon_sym_COLON] = ACTIONS(5365),
    [anon_sym_QMARK] = ACTIONS(5365),
    [anon_sym_LT_EQ_GT] = ACTIONS(5365),
    [anon_sym_or] = ACTIONS(5363),
    [anon_sym_and] = ACTIONS(5363),
    [anon_sym_bitor] = ACTIONS(5363),
    [anon_sym_xor] = ACTIONS(5363),
    [anon_sym_bitand] = ACTIONS(5363),
    [anon_sym_not_eq] = ACTIONS(5363),
    [anon_sym_DASH_DASH] = ACTIONS(5365),
    [anon_sym_PLUS_PLUS] = ACTIONS(5365),
    [anon_sym_DOT] = ACTIONS(5363),
    [anon_sym_DOT_STAR] = ACTIONS(5365),
    [anon_sym_DASH_GT] = ACTIONS(5365),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5363),
    [anon_sym_decltype] = ACTIONS(5363),
    [anon_sym_final] = ACTIONS(5363),
    [anon_sym_override] = ACTIONS(5363),
    [anon_sym_requires] = ACTIONS(5363),
  },
  [2064] = {
    [sym__declaration_modifiers] = STATE(2282),
    [sym__declaration_specifiers] = STATE(4808),
    [sym_attribute_specifier] = STATE(2282),
    [sym_attribute_declaration] = STATE(2282),
    [sym_ms_declspec_modifier] = STATE(2282),
    [sym_storage_class_specifier] = STATE(2282),
    [sym_type_qualifier] = STATE(2282),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_parameter_declaration] = STATE(8262),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2282),
    [sym_alignas_specifier] = STATE(2282),
    [sym_dependent_type] = STATE(3087),
    [sym_optional_parameter_declaration] = STATE(8262),
    [sym_variadic_parameter_declaration] = STATE(8262),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7326),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2282),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5095),
    [anon_sym_RPAREN] = ACTIONS(2009),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5105),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2023),
    [anon_sym_struct] = ACTIONS(2025),
    [anon_sym_union] = ACTIONS(2027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2053),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2065] = {
    [sym_string_literal] = STATE(2065),
    [sym_raw_string_literal] = STATE(2065),
    [aux_sym_concatenated_string_repeat1] = STATE(2065),
    [sym_identifier] = ACTIONS(5370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5373),
    [anon_sym_COMMA] = ACTIONS(5373),
    [anon_sym_RPAREN] = ACTIONS(5373),
    [aux_sym_preproc_if_token2] = ACTIONS(5373),
    [aux_sym_preproc_else_token1] = ACTIONS(5373),
    [aux_sym_preproc_elif_token1] = ACTIONS(5375),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5373),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5373),
    [anon_sym_LPAREN2] = ACTIONS(5373),
    [anon_sym_DASH] = ACTIONS(5375),
    [anon_sym_PLUS] = ACTIONS(5375),
    [anon_sym_STAR] = ACTIONS(5375),
    [anon_sym_SLASH] = ACTIONS(5375),
    [anon_sym_PERCENT] = ACTIONS(5375),
    [anon_sym_PIPE_PIPE] = ACTIONS(5373),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_PIPE] = ACTIONS(5375),
    [anon_sym_CARET] = ACTIONS(5375),
    [anon_sym_AMP] = ACTIONS(5375),
    [anon_sym_EQ_EQ] = ACTIONS(5373),
    [anon_sym_BANG_EQ] = ACTIONS(5373),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5373),
    [anon_sym_LT_EQ] = ACTIONS(5375),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_LT] = ACTIONS(5375),
    [anon_sym_GT_GT] = ACTIONS(5375),
    [anon_sym_SEMI] = ACTIONS(5373),
    [anon_sym_RBRACE] = ACTIONS(5373),
    [anon_sym_LBRACK] = ACTIONS(5373),
    [anon_sym_RBRACK] = ACTIONS(5373),
    [anon_sym_EQ] = ACTIONS(5375),
    [anon_sym_COLON] = ACTIONS(5373),
    [anon_sym_QMARK] = ACTIONS(5373),
    [anon_sym_STAR_EQ] = ACTIONS(5373),
    [anon_sym_SLASH_EQ] = ACTIONS(5373),
    [anon_sym_PERCENT_EQ] = ACTIONS(5373),
    [anon_sym_PLUS_EQ] = ACTIONS(5373),
    [anon_sym_DASH_EQ] = ACTIONS(5373),
    [anon_sym_LT_LT_EQ] = ACTIONS(5373),
    [anon_sym_GT_GT_EQ] = ACTIONS(5373),
    [anon_sym_AMP_EQ] = ACTIONS(5373),
    [anon_sym_CARET_EQ] = ACTIONS(5373),
    [anon_sym_PIPE_EQ] = ACTIONS(5373),
    [anon_sym_and_eq] = ACTIONS(5375),
    [anon_sym_or_eq] = ACTIONS(5375),
    [anon_sym_xor_eq] = ACTIONS(5375),
    [anon_sym_LT_EQ_GT] = ACTIONS(5373),
    [anon_sym_or] = ACTIONS(5375),
    [anon_sym_and] = ACTIONS(5375),
    [anon_sym_bitor] = ACTIONS(5375),
    [anon_sym_xor] = ACTIONS(5375),
    [anon_sym_bitand] = ACTIONS(5375),
    [anon_sym_not_eq] = ACTIONS(5375),
    [anon_sym_DASH_DASH] = ACTIONS(5373),
    [anon_sym_PLUS_PLUS] = ACTIONS(5373),
    [anon_sym_DOT] = ACTIONS(5375),
    [anon_sym_DOT_STAR] = ACTIONS(5373),
    [anon_sym_DASH_GT] = ACTIONS(5373),
    [anon_sym_L_DQUOTE] = ACTIONS(5377),
    [anon_sym_u_DQUOTE] = ACTIONS(5377),
    [anon_sym_U_DQUOTE] = ACTIONS(5377),
    [anon_sym_u8_DQUOTE] = ACTIONS(5377),
    [anon_sym_DQUOTE] = ACTIONS(5377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5380),
    [anon_sym_LR_DQUOTE] = ACTIONS(5380),
    [anon_sym_uR_DQUOTE] = ACTIONS(5380),
    [anon_sym_UR_DQUOTE] = ACTIONS(5380),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5380),
    [sym_literal_suffix] = ACTIONS(5375),
  },
  [2066] = {
    [sym__declaration_modifiers] = STATE(2282),
    [sym__declaration_specifiers] = STATE(4808),
    [sym_attribute_specifier] = STATE(2282),
    [sym_attribute_declaration] = STATE(2282),
    [sym_ms_declspec_modifier] = STATE(2282),
    [sym_storage_class_specifier] = STATE(2282),
    [sym_type_qualifier] = STATE(2282),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_parameter_declaration] = STATE(8534),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2282),
    [sym_alignas_specifier] = STATE(2282),
    [sym_dependent_type] = STATE(3087),
    [sym_optional_parameter_declaration] = STATE(8534),
    [sym_variadic_parameter_declaration] = STATE(8534),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7326),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2282),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5383),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5105),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2023),
    [anon_sym_struct] = ACTIONS(2025),
    [anon_sym_union] = ACTIONS(2027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2053),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2067] = {
    [sym_string_literal] = STATE(2068),
    [sym_raw_string_literal] = STATE(2068),
    [aux_sym_concatenated_string_repeat1] = STATE(2068),
    [sym_identifier] = ACTIONS(5385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5387),
    [anon_sym_COMMA] = ACTIONS(5387),
    [anon_sym_RPAREN] = ACTIONS(5387),
    [aux_sym_preproc_if_token2] = ACTIONS(5387),
    [aux_sym_preproc_else_token1] = ACTIONS(5387),
    [aux_sym_preproc_elif_token1] = ACTIONS(5389),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5387),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5387),
    [anon_sym_LPAREN2] = ACTIONS(5387),
    [anon_sym_DASH] = ACTIONS(5389),
    [anon_sym_PLUS] = ACTIONS(5389),
    [anon_sym_STAR] = ACTIONS(5389),
    [anon_sym_SLASH] = ACTIONS(5389),
    [anon_sym_PERCENT] = ACTIONS(5389),
    [anon_sym_PIPE_PIPE] = ACTIONS(5387),
    [anon_sym_AMP_AMP] = ACTIONS(5387),
    [anon_sym_PIPE] = ACTIONS(5389),
    [anon_sym_CARET] = ACTIONS(5389),
    [anon_sym_AMP] = ACTIONS(5389),
    [anon_sym_EQ_EQ] = ACTIONS(5387),
    [anon_sym_BANG_EQ] = ACTIONS(5387),
    [anon_sym_GT] = ACTIONS(5389),
    [anon_sym_GT_EQ] = ACTIONS(5387),
    [anon_sym_LT_EQ] = ACTIONS(5389),
    [anon_sym_LT] = ACTIONS(5389),
    [anon_sym_LT_LT] = ACTIONS(5389),
    [anon_sym_GT_GT] = ACTIONS(5389),
    [anon_sym_SEMI] = ACTIONS(5387),
    [anon_sym_RBRACE] = ACTIONS(5387),
    [anon_sym_LBRACK] = ACTIONS(5387),
    [anon_sym_RBRACK] = ACTIONS(5387),
    [anon_sym_EQ] = ACTIONS(5389),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_QMARK] = ACTIONS(5387),
    [anon_sym_STAR_EQ] = ACTIONS(5387),
    [anon_sym_SLASH_EQ] = ACTIONS(5387),
    [anon_sym_PERCENT_EQ] = ACTIONS(5387),
    [anon_sym_PLUS_EQ] = ACTIONS(5387),
    [anon_sym_DASH_EQ] = ACTIONS(5387),
    [anon_sym_LT_LT_EQ] = ACTIONS(5387),
    [anon_sym_GT_GT_EQ] = ACTIONS(5387),
    [anon_sym_AMP_EQ] = ACTIONS(5387),
    [anon_sym_CARET_EQ] = ACTIONS(5387),
    [anon_sym_PIPE_EQ] = ACTIONS(5387),
    [anon_sym_and_eq] = ACTIONS(5389),
    [anon_sym_or_eq] = ACTIONS(5389),
    [anon_sym_xor_eq] = ACTIONS(5389),
    [anon_sym_LT_EQ_GT] = ACTIONS(5387),
    [anon_sym_or] = ACTIONS(5389),
    [anon_sym_and] = ACTIONS(5389),
    [anon_sym_bitor] = ACTIONS(5389),
    [anon_sym_xor] = ACTIONS(5389),
    [anon_sym_bitand] = ACTIONS(5389),
    [anon_sym_not_eq] = ACTIONS(5389),
    [anon_sym_DASH_DASH] = ACTIONS(5387),
    [anon_sym_PLUS_PLUS] = ACTIONS(5387),
    [anon_sym_DOT] = ACTIONS(5389),
    [anon_sym_DOT_STAR] = ACTIONS(5387),
    [anon_sym_DASH_GT] = ACTIONS(5387),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [sym_literal_suffix] = ACTIONS(5389),
  },
  [2068] = {
    [sym_string_literal] = STATE(2065),
    [sym_raw_string_literal] = STATE(2065),
    [aux_sym_concatenated_string_repeat1] = STATE(2065),
    [sym_identifier] = ACTIONS(5391),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5393),
    [anon_sym_COMMA] = ACTIONS(5393),
    [anon_sym_RPAREN] = ACTIONS(5393),
    [aux_sym_preproc_if_token2] = ACTIONS(5393),
    [aux_sym_preproc_else_token1] = ACTIONS(5393),
    [aux_sym_preproc_elif_token1] = ACTIONS(5395),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5393),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5393),
    [anon_sym_LPAREN2] = ACTIONS(5393),
    [anon_sym_DASH] = ACTIONS(5395),
    [anon_sym_PLUS] = ACTIONS(5395),
    [anon_sym_STAR] = ACTIONS(5395),
    [anon_sym_SLASH] = ACTIONS(5395),
    [anon_sym_PERCENT] = ACTIONS(5395),
    [anon_sym_PIPE_PIPE] = ACTIONS(5393),
    [anon_sym_AMP_AMP] = ACTIONS(5393),
    [anon_sym_PIPE] = ACTIONS(5395),
    [anon_sym_CARET] = ACTIONS(5395),
    [anon_sym_AMP] = ACTIONS(5395),
    [anon_sym_EQ_EQ] = ACTIONS(5393),
    [anon_sym_BANG_EQ] = ACTIONS(5393),
    [anon_sym_GT] = ACTIONS(5395),
    [anon_sym_GT_EQ] = ACTIONS(5393),
    [anon_sym_LT_EQ] = ACTIONS(5395),
    [anon_sym_LT] = ACTIONS(5395),
    [anon_sym_LT_LT] = ACTIONS(5395),
    [anon_sym_GT_GT] = ACTIONS(5395),
    [anon_sym_SEMI] = ACTIONS(5393),
    [anon_sym_RBRACE] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(5393),
    [anon_sym_RBRACK] = ACTIONS(5393),
    [anon_sym_EQ] = ACTIONS(5395),
    [anon_sym_COLON] = ACTIONS(5393),
    [anon_sym_QMARK] = ACTIONS(5393),
    [anon_sym_STAR_EQ] = ACTIONS(5393),
    [anon_sym_SLASH_EQ] = ACTIONS(5393),
    [anon_sym_PERCENT_EQ] = ACTIONS(5393),
    [anon_sym_PLUS_EQ] = ACTIONS(5393),
    [anon_sym_DASH_EQ] = ACTIONS(5393),
    [anon_sym_LT_LT_EQ] = ACTIONS(5393),
    [anon_sym_GT_GT_EQ] = ACTIONS(5393),
    [anon_sym_AMP_EQ] = ACTIONS(5393),
    [anon_sym_CARET_EQ] = ACTIONS(5393),
    [anon_sym_PIPE_EQ] = ACTIONS(5393),
    [anon_sym_and_eq] = ACTIONS(5395),
    [anon_sym_or_eq] = ACTIONS(5395),
    [anon_sym_xor_eq] = ACTIONS(5395),
    [anon_sym_LT_EQ_GT] = ACTIONS(5393),
    [anon_sym_or] = ACTIONS(5395),
    [anon_sym_and] = ACTIONS(5395),
    [anon_sym_bitor] = ACTIONS(5395),
    [anon_sym_xor] = ACTIONS(5395),
    [anon_sym_bitand] = ACTIONS(5395),
    [anon_sym_not_eq] = ACTIONS(5395),
    [anon_sym_DASH_DASH] = ACTIONS(5393),
    [anon_sym_PLUS_PLUS] = ACTIONS(5393),
    [anon_sym_DOT] = ACTIONS(5395),
    [anon_sym_DOT_STAR] = ACTIONS(5393),
    [anon_sym_DASH_GT] = ACTIONS(5393),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [sym_literal_suffix] = ACTIONS(5395),
  },
  [2069] = {
    [sym_catch_clause] = STATE(2069),
    [aux_sym_constructor_try_statement_repeat1] = STATE(2069),
    [sym_identifier] = ACTIONS(2843),
    [aux_sym_preproc_def_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token2] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2843),
    [aux_sym_preproc_else_token1] = ACTIONS(2843),
    [aux_sym_preproc_elif_token1] = ACTIONS(2843),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2843),
    [sym_preproc_directive] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym___extension__] = ACTIONS(2843),
    [anon_sym_typedef] = ACTIONS(2843),
    [anon_sym_extern] = ACTIONS(2843),
    [anon_sym___attribute__] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2845),
    [anon_sym___declspec] = ACTIONS(2843),
    [anon_sym___based] = ACTIONS(2843),
    [anon_sym_signed] = ACTIONS(2843),
    [anon_sym_unsigned] = ACTIONS(2843),
    [anon_sym_long] = ACTIONS(2843),
    [anon_sym_short] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_register] = ACTIONS(2843),
    [anon_sym_inline] = ACTIONS(2843),
    [anon_sym___inline] = ACTIONS(2843),
    [anon_sym___inline__] = ACTIONS(2843),
    [anon_sym___forceinline] = ACTIONS(2843),
    [anon_sym_thread_local] = ACTIONS(2843),
    [anon_sym___thread] = ACTIONS(2843),
    [anon_sym_const] = ACTIONS(2843),
    [anon_sym_constexpr] = ACTIONS(2843),
    [anon_sym_volatile] = ACTIONS(2843),
    [anon_sym_restrict] = ACTIONS(2843),
    [anon_sym___restrict__] = ACTIONS(2843),
    [anon_sym__Atomic] = ACTIONS(2843),
    [anon_sym__Noreturn] = ACTIONS(2843),
    [anon_sym_noreturn] = ACTIONS(2843),
    [anon_sym_mutable] = ACTIONS(2843),
    [anon_sym_constinit] = ACTIONS(2843),
    [anon_sym_consteval] = ACTIONS(2843),
    [anon_sym_PROGMEM] = ACTIONS(2843),
    [aux_sym_primitive_type_token1] = ACTIONS(2843),
    [anon_sym_byte] = ACTIONS(2843),
    [anon_sym_word] = ACTIONS(2843),
    [anon_sym_enum] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2843),
    [anon_sym_union] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2843),
    [anon_sym_decltype] = ACTIONS(2843),
    [anon_sym_virtual] = ACTIONS(2843),
    [anon_sym_alignas] = ACTIONS(2843),
    [anon_sym_explicit] = ACTIONS(2843),
    [anon_sym_typename] = ACTIONS(2843),
    [anon_sym_template] = ACTIONS(2843),
    [anon_sym_operator] = ACTIONS(2843),
    [anon_sym_friend] = ACTIONS(2843),
    [anon_sym_public] = ACTIONS(2843),
    [anon_sym_private] = ACTIONS(2843),
    [anon_sym_protected] = ACTIONS(2843),
    [anon_sym_using] = ACTIONS(2843),
    [anon_sym_static_assert] = ACTIONS(2843),
    [anon_sym_catch] = ACTIONS(5397),
  },
  [2070] = {
    [sym_catch_clause] = STATE(2069),
    [aux_sym_constructor_try_statement_repeat1] = STATE(2069),
    [sym_identifier] = ACTIONS(2850),
    [aux_sym_preproc_def_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token2] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2850),
    [aux_sym_preproc_else_token1] = ACTIONS(2850),
    [aux_sym_preproc_elif_token1] = ACTIONS(2850),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2850),
    [sym_preproc_directive] = ACTIONS(2850),
    [anon_sym_LPAREN2] = ACTIONS(2852),
    [anon_sym_TILDE] = ACTIONS(2852),
    [anon_sym_STAR] = ACTIONS(2852),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_AMP] = ACTIONS(2850),
    [anon_sym___extension__] = ACTIONS(2850),
    [anon_sym_typedef] = ACTIONS(2850),
    [anon_sym_extern] = ACTIONS(2850),
    [anon_sym___attribute__] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2852),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2852),
    [anon_sym___declspec] = ACTIONS(2850),
    [anon_sym___based] = ACTIONS(2850),
    [anon_sym_signed] = ACTIONS(2850),
    [anon_sym_unsigned] = ACTIONS(2850),
    [anon_sym_long] = ACTIONS(2850),
    [anon_sym_short] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2850),
    [anon_sym_register] = ACTIONS(2850),
    [anon_sym_inline] = ACTIONS(2850),
    [anon_sym___inline] = ACTIONS(2850),
    [anon_sym___inline__] = ACTIONS(2850),
    [anon_sym___forceinline] = ACTIONS(2850),
    [anon_sym_thread_local] = ACTIONS(2850),
    [anon_sym___thread] = ACTIONS(2850),
    [anon_sym_const] = ACTIONS(2850),
    [anon_sym_constexpr] = ACTIONS(2850),
    [anon_sym_volatile] = ACTIONS(2850),
    [anon_sym_restrict] = ACTIONS(2850),
    [anon_sym___restrict__] = ACTIONS(2850),
    [anon_sym__Atomic] = ACTIONS(2850),
    [anon_sym__Noreturn] = ACTIONS(2850),
    [anon_sym_noreturn] = ACTIONS(2850),
    [anon_sym_mutable] = ACTIONS(2850),
    [anon_sym_constinit] = ACTIONS(2850),
    [anon_sym_consteval] = ACTIONS(2850),
    [anon_sym_PROGMEM] = ACTIONS(2850),
    [aux_sym_primitive_type_token1] = ACTIONS(2850),
    [anon_sym_byte] = ACTIONS(2850),
    [anon_sym_word] = ACTIONS(2850),
    [anon_sym_enum] = ACTIONS(2850),
    [anon_sym_class] = ACTIONS(2850),
    [anon_sym_struct] = ACTIONS(2850),
    [anon_sym_union] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2850),
    [anon_sym_decltype] = ACTIONS(2850),
    [anon_sym_virtual] = ACTIONS(2850),
    [anon_sym_alignas] = ACTIONS(2850),
    [anon_sym_explicit] = ACTIONS(2850),
    [anon_sym_typename] = ACTIONS(2850),
    [anon_sym_template] = ACTIONS(2850),
    [anon_sym_operator] = ACTIONS(2850),
    [anon_sym_friend] = ACTIONS(2850),
    [anon_sym_public] = ACTIONS(2850),
    [anon_sym_private] = ACTIONS(2850),
    [anon_sym_protected] = ACTIONS(2850),
    [anon_sym_using] = ACTIONS(2850),
    [anon_sym_static_assert] = ACTIONS(2850),
    [anon_sym_catch] = ACTIONS(5400),
  },
  [2071] = {
    [sym__declaration_modifiers] = STATE(2282),
    [sym__declaration_specifiers] = STATE(4808),
    [sym_attribute_specifier] = STATE(2282),
    [sym_attribute_declaration] = STATE(2282),
    [sym_ms_declspec_modifier] = STATE(2282),
    [sym_storage_class_specifier] = STATE(2282),
    [sym_type_qualifier] = STATE(2282),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_parameter_declaration] = STATE(8541),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2282),
    [sym_alignas_specifier] = STATE(2282),
    [sym_dependent_type] = STATE(3087),
    [sym_optional_parameter_declaration] = STATE(8541),
    [sym_variadic_parameter_declaration] = STATE(8541),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7326),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2282),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5095),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5105),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2023),
    [anon_sym_struct] = ACTIONS(2025),
    [anon_sym_union] = ACTIONS(2027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2053),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2072] = {
    [sym_identifier] = ACTIONS(5160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5164),
    [anon_sym_COMMA] = ACTIONS(5164),
    [anon_sym_RPAREN] = ACTIONS(5164),
    [anon_sym_LPAREN2] = ACTIONS(5164),
    [anon_sym_TILDE] = ACTIONS(5167),
    [anon_sym_DASH] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5169),
    [anon_sym_STAR] = ACTIONS(5164),
    [anon_sym_SLASH] = ACTIONS(5169),
    [anon_sym_PERCENT] = ACTIONS(5162),
    [anon_sym_PIPE_PIPE] = ACTIONS(5162),
    [anon_sym_AMP_AMP] = ACTIONS(5164),
    [anon_sym_PIPE] = ACTIONS(5169),
    [anon_sym_CARET] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_EQ] = ACTIONS(5162),
    [anon_sym_GT] = ACTIONS(5169),
    [anon_sym_GT_EQ] = ACTIONS(5162),
    [anon_sym_LT_EQ] = ACTIONS(5169),
    [anon_sym_LT] = ACTIONS(5169),
    [anon_sym_LT_LT] = ACTIONS(5162),
    [anon_sym_GT_GT] = ACTIONS(5162),
    [anon_sym___extension__] = ACTIONS(5160),
    [anon_sym_extern] = ACTIONS(5160),
    [anon_sym___attribute__] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5167),
    [anon_sym___declspec] = ACTIONS(5160),
    [anon_sym___based] = ACTIONS(5160),
    [anon_sym_LBRACE] = ACTIONS(5167),
    [anon_sym_LBRACK] = ACTIONS(5171),
    [anon_sym_EQ] = ACTIONS(5160),
    [anon_sym_static] = ACTIONS(5160),
    [anon_sym_register] = ACTIONS(5160),
    [anon_sym_inline] = ACTIONS(5160),
    [anon_sym___inline] = ACTIONS(5160),
    [anon_sym___inline__] = ACTIONS(5160),
    [anon_sym___forceinline] = ACTIONS(5160),
    [anon_sym_thread_local] = ACTIONS(5160),
    [anon_sym___thread] = ACTIONS(5160),
    [anon_sym_const] = ACTIONS(5160),
    [anon_sym_constexpr] = ACTIONS(5160),
    [anon_sym_volatile] = ACTIONS(5160),
    [anon_sym_restrict] = ACTIONS(5160),
    [anon_sym___restrict__] = ACTIONS(5160),
    [anon_sym__Atomic] = ACTIONS(5160),
    [anon_sym__Noreturn] = ACTIONS(5160),
    [anon_sym_noreturn] = ACTIONS(5160),
    [anon_sym_mutable] = ACTIONS(5160),
    [anon_sym_constinit] = ACTIONS(5160),
    [anon_sym_consteval] = ACTIONS(5160),
    [anon_sym_PROGMEM] = ACTIONS(5160),
    [anon_sym_QMARK] = ACTIONS(5162),
    [anon_sym_LT_EQ_GT] = ACTIONS(5162),
    [anon_sym_or] = ACTIONS(5169),
    [anon_sym_and] = ACTIONS(5169),
    [anon_sym_bitor] = ACTIONS(5169),
    [anon_sym_xor] = ACTIONS(5169),
    [anon_sym_bitand] = ACTIONS(5169),
    [anon_sym_not_eq] = ACTIONS(5169),
    [anon_sym_DASH_DASH] = ACTIONS(5162),
    [anon_sym_PLUS_PLUS] = ACTIONS(5162),
    [anon_sym_DOT] = ACTIONS(5169),
    [anon_sym_DOT_STAR] = ACTIONS(5162),
    [anon_sym_DASH_GT] = ACTIONS(5162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5160),
    [anon_sym_decltype] = ACTIONS(5160),
    [anon_sym_virtual] = ACTIONS(5160),
    [anon_sym_alignas] = ACTIONS(5160),
    [anon_sym_template] = ACTIONS(5160),
    [anon_sym_operator] = ACTIONS(5160),
  },
  [2073] = {
    [sym_catch_clause] = STATE(2069),
    [aux_sym_constructor_try_statement_repeat1] = STATE(2069),
    [sym_identifier] = ACTIONS(2856),
    [aux_sym_preproc_def_token1] = ACTIONS(2856),
    [aux_sym_preproc_if_token1] = ACTIONS(2856),
    [aux_sym_preproc_if_token2] = ACTIONS(2856),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2856),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2856),
    [aux_sym_preproc_else_token1] = ACTIONS(2856),
    [aux_sym_preproc_elif_token1] = ACTIONS(2856),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2856),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2856),
    [sym_preproc_directive] = ACTIONS(2856),
    [anon_sym_LPAREN2] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_STAR] = ACTIONS(2858),
    [anon_sym_AMP_AMP] = ACTIONS(2858),
    [anon_sym_AMP] = ACTIONS(2856),
    [anon_sym___extension__] = ACTIONS(2856),
    [anon_sym_typedef] = ACTIONS(2856),
    [anon_sym_extern] = ACTIONS(2856),
    [anon_sym___attribute__] = ACTIONS(2856),
    [anon_sym_COLON_COLON] = ACTIONS(2858),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2858),
    [anon_sym___declspec] = ACTIONS(2856),
    [anon_sym___based] = ACTIONS(2856),
    [anon_sym_signed] = ACTIONS(2856),
    [anon_sym_unsigned] = ACTIONS(2856),
    [anon_sym_long] = ACTIONS(2856),
    [anon_sym_short] = ACTIONS(2856),
    [anon_sym_LBRACK] = ACTIONS(2856),
    [anon_sym_static] = ACTIONS(2856),
    [anon_sym_register] = ACTIONS(2856),
    [anon_sym_inline] = ACTIONS(2856),
    [anon_sym___inline] = ACTIONS(2856),
    [anon_sym___inline__] = ACTIONS(2856),
    [anon_sym___forceinline] = ACTIONS(2856),
    [anon_sym_thread_local] = ACTIONS(2856),
    [anon_sym___thread] = ACTIONS(2856),
    [anon_sym_const] = ACTIONS(2856),
    [anon_sym_constexpr] = ACTIONS(2856),
    [anon_sym_volatile] = ACTIONS(2856),
    [anon_sym_restrict] = ACTIONS(2856),
    [anon_sym___restrict__] = ACTIONS(2856),
    [anon_sym__Atomic] = ACTIONS(2856),
    [anon_sym__Noreturn] = ACTIONS(2856),
    [anon_sym_noreturn] = ACTIONS(2856),
    [anon_sym_mutable] = ACTIONS(2856),
    [anon_sym_constinit] = ACTIONS(2856),
    [anon_sym_consteval] = ACTIONS(2856),
    [anon_sym_PROGMEM] = ACTIONS(2856),
    [aux_sym_primitive_type_token1] = ACTIONS(2856),
    [anon_sym_byte] = ACTIONS(2856),
    [anon_sym_word] = ACTIONS(2856),
    [anon_sym_enum] = ACTIONS(2856),
    [anon_sym_class] = ACTIONS(2856),
    [anon_sym_struct] = ACTIONS(2856),
    [anon_sym_union] = ACTIONS(2856),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2856),
    [anon_sym_decltype] = ACTIONS(2856),
    [anon_sym_virtual] = ACTIONS(2856),
    [anon_sym_alignas] = ACTIONS(2856),
    [anon_sym_explicit] = ACTIONS(2856),
    [anon_sym_typename] = ACTIONS(2856),
    [anon_sym_template] = ACTIONS(2856),
    [anon_sym_operator] = ACTIONS(2856),
    [anon_sym_friend] = ACTIONS(2856),
    [anon_sym_public] = ACTIONS(2856),
    [anon_sym_private] = ACTIONS(2856),
    [anon_sym_protected] = ACTIONS(2856),
    [anon_sym_using] = ACTIONS(2856),
    [anon_sym_static_assert] = ACTIONS(2856),
    [anon_sym_catch] = ACTIONS(5400),
  },
  [2074] = {
    [sym_catch_clause] = STATE(2069),
    [aux_sym_constructor_try_statement_repeat1] = STATE(2069),
    [sym_identifier] = ACTIONS(2860),
    [aux_sym_preproc_def_token1] = ACTIONS(2860),
    [aux_sym_preproc_if_token1] = ACTIONS(2860),
    [aux_sym_preproc_if_token2] = ACTIONS(2860),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2860),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2860),
    [aux_sym_preproc_else_token1] = ACTIONS(2860),
    [aux_sym_preproc_elif_token1] = ACTIONS(2860),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2860),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2860),
    [sym_preproc_directive] = ACTIONS(2860),
    [anon_sym_LPAREN2] = ACTIONS(2862),
    [anon_sym_TILDE] = ACTIONS(2862),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP_AMP] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2860),
    [anon_sym___extension__] = ACTIONS(2860),
    [anon_sym_typedef] = ACTIONS(2860),
    [anon_sym_extern] = ACTIONS(2860),
    [anon_sym___attribute__] = ACTIONS(2860),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2862),
    [anon_sym___declspec] = ACTIONS(2860),
    [anon_sym___based] = ACTIONS(2860),
    [anon_sym_signed] = ACTIONS(2860),
    [anon_sym_unsigned] = ACTIONS(2860),
    [anon_sym_long] = ACTIONS(2860),
    [anon_sym_short] = ACTIONS(2860),
    [anon_sym_LBRACK] = ACTIONS(2860),
    [anon_sym_static] = ACTIONS(2860),
    [anon_sym_register] = ACTIONS(2860),
    [anon_sym_inline] = ACTIONS(2860),
    [anon_sym___inline] = ACTIONS(2860),
    [anon_sym___inline__] = ACTIONS(2860),
    [anon_sym___forceinline] = ACTIONS(2860),
    [anon_sym_thread_local] = ACTIONS(2860),
    [anon_sym___thread] = ACTIONS(2860),
    [anon_sym_const] = ACTIONS(2860),
    [anon_sym_constexpr] = ACTIONS(2860),
    [anon_sym_volatile] = ACTIONS(2860),
    [anon_sym_restrict] = ACTIONS(2860),
    [anon_sym___restrict__] = ACTIONS(2860),
    [anon_sym__Atomic] = ACTIONS(2860),
    [anon_sym__Noreturn] = ACTIONS(2860),
    [anon_sym_noreturn] = ACTIONS(2860),
    [anon_sym_mutable] = ACTIONS(2860),
    [anon_sym_constinit] = ACTIONS(2860),
    [anon_sym_consteval] = ACTIONS(2860),
    [anon_sym_PROGMEM] = ACTIONS(2860),
    [aux_sym_primitive_type_token1] = ACTIONS(2860),
    [anon_sym_byte] = ACTIONS(2860),
    [anon_sym_word] = ACTIONS(2860),
    [anon_sym_enum] = ACTIONS(2860),
    [anon_sym_class] = ACTIONS(2860),
    [anon_sym_struct] = ACTIONS(2860),
    [anon_sym_union] = ACTIONS(2860),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2860),
    [anon_sym_decltype] = ACTIONS(2860),
    [anon_sym_virtual] = ACTIONS(2860),
    [anon_sym_alignas] = ACTIONS(2860),
    [anon_sym_explicit] = ACTIONS(2860),
    [anon_sym_typename] = ACTIONS(2860),
    [anon_sym_template] = ACTIONS(2860),
    [anon_sym_operator] = ACTIONS(2860),
    [anon_sym_friend] = ACTIONS(2860),
    [anon_sym_public] = ACTIONS(2860),
    [anon_sym_private] = ACTIONS(2860),
    [anon_sym_protected] = ACTIONS(2860),
    [anon_sym_using] = ACTIONS(2860),
    [anon_sym_static_assert] = ACTIONS(2860),
    [anon_sym_catch] = ACTIONS(5400),
  },
  [2075] = {
    [sym_identifier] = ACTIONS(5160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5162),
    [anon_sym_COMMA] = ACTIONS(5162),
    [anon_sym_RPAREN] = ACTIONS(5162),
    [anon_sym_LPAREN2] = ACTIONS(5164),
    [anon_sym_TILDE] = ACTIONS(5167),
    [anon_sym_DASH] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5169),
    [anon_sym_STAR] = ACTIONS(5164),
    [anon_sym_SLASH] = ACTIONS(5169),
    [anon_sym_PERCENT] = ACTIONS(5162),
    [anon_sym_PIPE_PIPE] = ACTIONS(5162),
    [anon_sym_AMP_AMP] = ACTIONS(5164),
    [anon_sym_PIPE] = ACTIONS(5169),
    [anon_sym_CARET] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_EQ] = ACTIONS(5162),
    [anon_sym_GT] = ACTIONS(5169),
    [anon_sym_GT_EQ] = ACTIONS(5162),
    [anon_sym_LT_EQ] = ACTIONS(5169),
    [anon_sym_LT] = ACTIONS(5169),
    [anon_sym_LT_LT] = ACTIONS(5162),
    [anon_sym_GT_GT] = ACTIONS(5162),
    [anon_sym_SEMI] = ACTIONS(5162),
    [anon_sym___extension__] = ACTIONS(5160),
    [anon_sym_extern] = ACTIONS(5160),
    [anon_sym___attribute__] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5167),
    [anon_sym___declspec] = ACTIONS(5160),
    [anon_sym___based] = ACTIONS(5160),
    [anon_sym_LBRACE] = ACTIONS(5167),
    [anon_sym_LBRACK] = ACTIONS(5171),
    [anon_sym_static] = ACTIONS(5160),
    [anon_sym_register] = ACTIONS(5160),
    [anon_sym_inline] = ACTIONS(5160),
    [anon_sym___inline] = ACTIONS(5160),
    [anon_sym___inline__] = ACTIONS(5160),
    [anon_sym___forceinline] = ACTIONS(5160),
    [anon_sym_thread_local] = ACTIONS(5160),
    [anon_sym___thread] = ACTIONS(5160),
    [anon_sym_const] = ACTIONS(5160),
    [anon_sym_constexpr] = ACTIONS(5160),
    [anon_sym_volatile] = ACTIONS(5160),
    [anon_sym_restrict] = ACTIONS(5160),
    [anon_sym___restrict__] = ACTIONS(5160),
    [anon_sym__Atomic] = ACTIONS(5160),
    [anon_sym__Noreturn] = ACTIONS(5160),
    [anon_sym_noreturn] = ACTIONS(5160),
    [anon_sym_mutable] = ACTIONS(5160),
    [anon_sym_constinit] = ACTIONS(5160),
    [anon_sym_consteval] = ACTIONS(5160),
    [anon_sym_PROGMEM] = ACTIONS(5160),
    [anon_sym_QMARK] = ACTIONS(5162),
    [anon_sym_LT_EQ_GT] = ACTIONS(5162),
    [anon_sym_or] = ACTIONS(5169),
    [anon_sym_and] = ACTIONS(5169),
    [anon_sym_bitor] = ACTIONS(5169),
    [anon_sym_xor] = ACTIONS(5169),
    [anon_sym_bitand] = ACTIONS(5169),
    [anon_sym_not_eq] = ACTIONS(5169),
    [anon_sym_DASH_DASH] = ACTIONS(5162),
    [anon_sym_PLUS_PLUS] = ACTIONS(5162),
    [anon_sym_DOT] = ACTIONS(5169),
    [anon_sym_DOT_STAR] = ACTIONS(5162),
    [anon_sym_DASH_GT] = ACTIONS(5162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5160),
    [anon_sym_decltype] = ACTIONS(5160),
    [anon_sym_virtual] = ACTIONS(5160),
    [anon_sym_alignas] = ACTIONS(5160),
    [anon_sym_template] = ACTIONS(5160),
    [anon_sym_operator] = ACTIONS(5160),
  },
  [2076] = {
    [sym_identifier] = ACTIONS(2223),
    [aux_sym_preproc_def_token1] = ACTIONS(2223),
    [aux_sym_preproc_if_token1] = ACTIONS(2223),
    [aux_sym_preproc_if_token2] = ACTIONS(2223),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2223),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2223),
    [aux_sym_preproc_else_token1] = ACTIONS(2223),
    [aux_sym_preproc_elif_token1] = ACTIONS(2223),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2223),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2223),
    [sym_preproc_directive] = ACTIONS(2223),
    [anon_sym_LPAREN2] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2221),
    [anon_sym_AMP_AMP] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym___extension__] = ACTIONS(2223),
    [anon_sym_typedef] = ACTIONS(2223),
    [anon_sym_extern] = ACTIONS(2223),
    [anon_sym___attribute__] = ACTIONS(2223),
    [anon_sym_COLON_COLON] = ACTIONS(2221),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym___declspec] = ACTIONS(2223),
    [anon_sym___based] = ACTIONS(2223),
    [anon_sym_signed] = ACTIONS(2223),
    [anon_sym_unsigned] = ACTIONS(2223),
    [anon_sym_long] = ACTIONS(2223),
    [anon_sym_short] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(2223),
    [anon_sym_static] = ACTIONS(2223),
    [anon_sym_register] = ACTIONS(2223),
    [anon_sym_inline] = ACTIONS(2223),
    [anon_sym___inline] = ACTIONS(2223),
    [anon_sym___inline__] = ACTIONS(2223),
    [anon_sym___forceinline] = ACTIONS(2223),
    [anon_sym_thread_local] = ACTIONS(2223),
    [anon_sym___thread] = ACTIONS(2223),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_constexpr] = ACTIONS(2223),
    [anon_sym_volatile] = ACTIONS(2223),
    [anon_sym_restrict] = ACTIONS(2223),
    [anon_sym___restrict__] = ACTIONS(2223),
    [anon_sym__Atomic] = ACTIONS(2223),
    [anon_sym__Noreturn] = ACTIONS(2223),
    [anon_sym_noreturn] = ACTIONS(2223),
    [anon_sym_mutable] = ACTIONS(2223),
    [anon_sym_constinit] = ACTIONS(2223),
    [anon_sym_consteval] = ACTIONS(2223),
    [anon_sym_PROGMEM] = ACTIONS(2223),
    [aux_sym_primitive_type_token1] = ACTIONS(2223),
    [anon_sym_byte] = ACTIONS(2223),
    [anon_sym_word] = ACTIONS(2223),
    [anon_sym_enum] = ACTIONS(2223),
    [anon_sym_class] = ACTIONS(2223),
    [anon_sym_struct] = ACTIONS(2223),
    [anon_sym_union] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2223),
    [anon_sym_decltype] = ACTIONS(2223),
    [anon_sym_virtual] = ACTIONS(2223),
    [anon_sym_alignas] = ACTIONS(2223),
    [anon_sym_explicit] = ACTIONS(2223),
    [anon_sym_typename] = ACTIONS(2223),
    [anon_sym_template] = ACTIONS(2223),
    [anon_sym_operator] = ACTIONS(2223),
    [anon_sym_friend] = ACTIONS(2223),
    [anon_sym_public] = ACTIONS(2223),
    [anon_sym_private] = ACTIONS(2223),
    [anon_sym_protected] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_static_assert] = ACTIONS(2223),
    [anon_sym_catch] = ACTIONS(2223),
  },
  [2077] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(5119),
    [anon_sym_RPAREN] = ACTIONS(5119),
    [anon_sym_LPAREN2] = ACTIONS(5119),
    [anon_sym_DASH] = ACTIONS(5117),
    [anon_sym_PLUS] = ACTIONS(5117),
    [anon_sym_STAR] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5117),
    [anon_sym_PERCENT] = ACTIONS(5117),
    [anon_sym_PIPE_PIPE] = ACTIONS(5119),
    [anon_sym_AMP_AMP] = ACTIONS(5119),
    [anon_sym_PIPE] = ACTIONS(5117),
    [anon_sym_CARET] = ACTIONS(5117),
    [anon_sym_AMP] = ACTIONS(5117),
    [anon_sym_EQ_EQ] = ACTIONS(5119),
    [anon_sym_BANG_EQ] = ACTIONS(5119),
    [anon_sym_GT] = ACTIONS(5117),
    [anon_sym_GT_EQ] = ACTIONS(5119),
    [anon_sym_LT_EQ] = ACTIONS(5117),
    [anon_sym_LT] = ACTIONS(5117),
    [anon_sym_LT_LT] = ACTIONS(5117),
    [anon_sym_GT_GT] = ACTIONS(5117),
    [anon_sym___extension__] = ACTIONS(5119),
    [anon_sym___attribute__] = ACTIONS(5119),
    [anon_sym_COLON_COLON] = ACTIONS(5119),
    [anon_sym_LBRACE] = ACTIONS(5119),
    [anon_sym_LBRACK] = ACTIONS(5119),
    [anon_sym_EQ] = ACTIONS(5117),
    [anon_sym_const] = ACTIONS(5117),
    [anon_sym_constexpr] = ACTIONS(5119),
    [anon_sym_volatile] = ACTIONS(5119),
    [anon_sym_restrict] = ACTIONS(5119),
    [anon_sym___restrict__] = ACTIONS(5119),
    [anon_sym__Atomic] = ACTIONS(5119),
    [anon_sym__Noreturn] = ACTIONS(5119),
    [anon_sym_noreturn] = ACTIONS(5119),
    [anon_sym_mutable] = ACTIONS(5119),
    [anon_sym_constinit] = ACTIONS(5119),
    [anon_sym_consteval] = ACTIONS(5119),
    [anon_sym_PROGMEM] = ACTIONS(5119),
    [anon_sym_COLON] = ACTIONS(5117),
    [anon_sym_QMARK] = ACTIONS(5119),
    [anon_sym_STAR_EQ] = ACTIONS(5119),
    [anon_sym_SLASH_EQ] = ACTIONS(5119),
    [anon_sym_PERCENT_EQ] = ACTIONS(5119),
    [anon_sym_PLUS_EQ] = ACTIONS(5119),
    [anon_sym_DASH_EQ] = ACTIONS(5119),
    [anon_sym_LT_LT_EQ] = ACTIONS(5119),
    [anon_sym_GT_GT_EQ] = ACTIONS(5119),
    [anon_sym_AMP_EQ] = ACTIONS(5119),
    [anon_sym_CARET_EQ] = ACTIONS(5119),
    [anon_sym_PIPE_EQ] = ACTIONS(5119),
    [anon_sym_and_eq] = ACTIONS(5119),
    [anon_sym_or_eq] = ACTIONS(5119),
    [anon_sym_xor_eq] = ACTIONS(5119),
    [anon_sym_LT_EQ_GT] = ACTIONS(5119),
    [anon_sym_or] = ACTIONS(5117),
    [anon_sym_and] = ACTIONS(5117),
    [anon_sym_bitor] = ACTIONS(5119),
    [anon_sym_xor] = ACTIONS(5117),
    [anon_sym_bitand] = ACTIONS(5119),
    [anon_sym_not_eq] = ACTIONS(5119),
    [anon_sym_DASH_DASH] = ACTIONS(5119),
    [anon_sym_PLUS_PLUS] = ACTIONS(5119),
    [anon_sym_DOT] = ACTIONS(5117),
    [anon_sym_DOT_STAR] = ACTIONS(5119),
    [anon_sym_DASH_GT] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5119),
    [anon_sym_decltype] = ACTIONS(5119),
    [anon_sym_final] = ACTIONS(5119),
    [anon_sym_override] = ACTIONS(5119),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5119),
  },
  [2078] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5127),
    [anon_sym_COMMA] = ACTIONS(5127),
    [anon_sym_RPAREN] = ACTIONS(5127),
    [anon_sym_LPAREN2] = ACTIONS(5127),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_PLUS] = ACTIONS(5125),
    [anon_sym_STAR] = ACTIONS(5125),
    [anon_sym_SLASH] = ACTIONS(5125),
    [anon_sym_PERCENT] = ACTIONS(5125),
    [anon_sym_PIPE_PIPE] = ACTIONS(5127),
    [anon_sym_AMP_AMP] = ACTIONS(5127),
    [anon_sym_PIPE] = ACTIONS(5125),
    [anon_sym_CARET] = ACTIONS(5125),
    [anon_sym_AMP] = ACTIONS(5125),
    [anon_sym_EQ_EQ] = ACTIONS(5127),
    [anon_sym_BANG_EQ] = ACTIONS(5127),
    [anon_sym_GT] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5127),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_LT] = ACTIONS(5125),
    [anon_sym_LT_LT] = ACTIONS(5125),
    [anon_sym_GT_GT] = ACTIONS(5125),
    [anon_sym___extension__] = ACTIONS(5127),
    [anon_sym___attribute__] = ACTIONS(5127),
    [anon_sym_COLON_COLON] = ACTIONS(5127),
    [anon_sym_LBRACE] = ACTIONS(5127),
    [anon_sym_LBRACK] = ACTIONS(5127),
    [anon_sym_EQ] = ACTIONS(5125),
    [anon_sym_const] = ACTIONS(5125),
    [anon_sym_constexpr] = ACTIONS(5127),
    [anon_sym_volatile] = ACTIONS(5127),
    [anon_sym_restrict] = ACTIONS(5127),
    [anon_sym___restrict__] = ACTIONS(5127),
    [anon_sym__Atomic] = ACTIONS(5127),
    [anon_sym__Noreturn] = ACTIONS(5127),
    [anon_sym_noreturn] = ACTIONS(5127),
    [anon_sym_mutable] = ACTIONS(5127),
    [anon_sym_constinit] = ACTIONS(5127),
    [anon_sym_consteval] = ACTIONS(5127),
    [anon_sym_PROGMEM] = ACTIONS(5127),
    [anon_sym_COLON] = ACTIONS(5125),
    [anon_sym_QMARK] = ACTIONS(5127),
    [anon_sym_STAR_EQ] = ACTIONS(5127),
    [anon_sym_SLASH_EQ] = ACTIONS(5127),
    [anon_sym_PERCENT_EQ] = ACTIONS(5127),
    [anon_sym_PLUS_EQ] = ACTIONS(5127),
    [anon_sym_DASH_EQ] = ACTIONS(5127),
    [anon_sym_LT_LT_EQ] = ACTIONS(5127),
    [anon_sym_GT_GT_EQ] = ACTIONS(5127),
    [anon_sym_AMP_EQ] = ACTIONS(5127),
    [anon_sym_CARET_EQ] = ACTIONS(5127),
    [anon_sym_PIPE_EQ] = ACTIONS(5127),
    [anon_sym_and_eq] = ACTIONS(5127),
    [anon_sym_or_eq] = ACTIONS(5127),
    [anon_sym_xor_eq] = ACTIONS(5127),
    [anon_sym_LT_EQ_GT] = ACTIONS(5127),
    [anon_sym_or] = ACTIONS(5125),
    [anon_sym_and] = ACTIONS(5125),
    [anon_sym_bitor] = ACTIONS(5127),
    [anon_sym_xor] = ACTIONS(5125),
    [anon_sym_bitand] = ACTIONS(5127),
    [anon_sym_not_eq] = ACTIONS(5127),
    [anon_sym_DASH_DASH] = ACTIONS(5127),
    [anon_sym_PLUS_PLUS] = ACTIONS(5127),
    [anon_sym_DOT] = ACTIONS(5125),
    [anon_sym_DOT_STAR] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5125),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5127),
    [anon_sym_decltype] = ACTIONS(5127),
    [anon_sym_final] = ACTIONS(5127),
    [anon_sym_override] = ACTIONS(5127),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5127),
  },
  [2079] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2079),
    [sym_identifier] = ACTIONS(5363),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5365),
    [anon_sym_COMMA] = ACTIONS(5365),
    [anon_sym_RPAREN] = ACTIONS(5365),
    [aux_sym_preproc_if_token2] = ACTIONS(5365),
    [aux_sym_preproc_else_token1] = ACTIONS(5365),
    [aux_sym_preproc_elif_token1] = ACTIONS(5363),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5365),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5365),
    [anon_sym_LPAREN2] = ACTIONS(5365),
    [anon_sym_DASH] = ACTIONS(5363),
    [anon_sym_PLUS] = ACTIONS(5363),
    [anon_sym_STAR] = ACTIONS(5363),
    [anon_sym_SLASH] = ACTIONS(5363),
    [anon_sym_PERCENT] = ACTIONS(5363),
    [anon_sym_PIPE_PIPE] = ACTIONS(5365),
    [anon_sym_AMP_AMP] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5363),
    [anon_sym_CARET] = ACTIONS(5363),
    [anon_sym_AMP] = ACTIONS(5363),
    [anon_sym_EQ_EQ] = ACTIONS(5365),
    [anon_sym_BANG_EQ] = ACTIONS(5365),
    [anon_sym_GT] = ACTIONS(5363),
    [anon_sym_GT_EQ] = ACTIONS(5365),
    [anon_sym_LT_EQ] = ACTIONS(5363),
    [anon_sym_LT] = ACTIONS(5363),
    [anon_sym_LT_LT] = ACTIONS(5363),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_SEMI] = ACTIONS(5365),
    [anon_sym___attribute__] = ACTIONS(5363),
    [anon_sym_LBRACE] = ACTIONS(5365),
    [anon_sym_RBRACE] = ACTIONS(5365),
    [anon_sym_signed] = ACTIONS(5402),
    [anon_sym_unsigned] = ACTIONS(5402),
    [anon_sym_long] = ACTIONS(5402),
    [anon_sym_short] = ACTIONS(5402),
    [anon_sym_LBRACK] = ACTIONS(5365),
    [anon_sym_RBRACK] = ACTIONS(5365),
    [anon_sym_EQ] = ACTIONS(5363),
    [aux_sym_primitive_type_token1] = ACTIONS(5363),
    [anon_sym_byte] = ACTIONS(5363),
    [anon_sym_word] = ACTIONS(5363),
    [anon_sym_COLON] = ACTIONS(5365),
    [anon_sym_QMARK] = ACTIONS(5365),
    [anon_sym_STAR_EQ] = ACTIONS(5365),
    [anon_sym_SLASH_EQ] = ACTIONS(5365),
    [anon_sym_PERCENT_EQ] = ACTIONS(5365),
    [anon_sym_PLUS_EQ] = ACTIONS(5365),
    [anon_sym_DASH_EQ] = ACTIONS(5365),
    [anon_sym_LT_LT_EQ] = ACTIONS(5365),
    [anon_sym_GT_GT_EQ] = ACTIONS(5365),
    [anon_sym_AMP_EQ] = ACTIONS(5365),
    [anon_sym_CARET_EQ] = ACTIONS(5365),
    [anon_sym_PIPE_EQ] = ACTIONS(5365),
    [anon_sym_and_eq] = ACTIONS(5363),
    [anon_sym_or_eq] = ACTIONS(5363),
    [anon_sym_xor_eq] = ACTIONS(5363),
    [anon_sym_LT_EQ_GT] = ACTIONS(5365),
    [anon_sym_or] = ACTIONS(5363),
    [anon_sym_and] = ACTIONS(5363),
    [anon_sym_bitor] = ACTIONS(5363),
    [anon_sym_xor] = ACTIONS(5363),
    [anon_sym_bitand] = ACTIONS(5363),
    [anon_sym_not_eq] = ACTIONS(5363),
    [anon_sym_DASH_DASH] = ACTIONS(5365),
    [anon_sym_PLUS_PLUS] = ACTIONS(5365),
    [anon_sym_DOT] = ACTIONS(5363),
    [anon_sym_DOT_STAR] = ACTIONS(5365),
    [anon_sym_DASH_GT] = ACTIONS(5365),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5363),
    [anon_sym_decltype] = ACTIONS(5363),
  },
  [2080] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5123),
    [anon_sym_COMMA] = ACTIONS(5123),
    [anon_sym_RPAREN] = ACTIONS(5123),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5121),
    [anon_sym_PLUS] = ACTIONS(5121),
    [anon_sym_STAR] = ACTIONS(5121),
    [anon_sym_SLASH] = ACTIONS(5121),
    [anon_sym_PERCENT] = ACTIONS(5121),
    [anon_sym_PIPE_PIPE] = ACTIONS(5123),
    [anon_sym_AMP_AMP] = ACTIONS(5123),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_CARET] = ACTIONS(5121),
    [anon_sym_AMP] = ACTIONS(5121),
    [anon_sym_EQ_EQ] = ACTIONS(5123),
    [anon_sym_BANG_EQ] = ACTIONS(5123),
    [anon_sym_GT] = ACTIONS(5121),
    [anon_sym_GT_EQ] = ACTIONS(5123),
    [anon_sym_LT_EQ] = ACTIONS(5121),
    [anon_sym_LT] = ACTIONS(5121),
    [anon_sym_LT_LT] = ACTIONS(5121),
    [anon_sym_GT_GT] = ACTIONS(5121),
    [anon_sym___extension__] = ACTIONS(5123),
    [anon_sym___attribute__] = ACTIONS(5123),
    [anon_sym_COLON_COLON] = ACTIONS(5123),
    [anon_sym_LBRACE] = ACTIONS(5123),
    [anon_sym_LBRACK] = ACTIONS(5123),
    [anon_sym_EQ] = ACTIONS(5121),
    [anon_sym_const] = ACTIONS(5121),
    [anon_sym_constexpr] = ACTIONS(5123),
    [anon_sym_volatile] = ACTIONS(5123),
    [anon_sym_restrict] = ACTIONS(5123),
    [anon_sym___restrict__] = ACTIONS(5123),
    [anon_sym__Atomic] = ACTIONS(5123),
    [anon_sym__Noreturn] = ACTIONS(5123),
    [anon_sym_noreturn] = ACTIONS(5123),
    [anon_sym_mutable] = ACTIONS(5123),
    [anon_sym_constinit] = ACTIONS(5123),
    [anon_sym_consteval] = ACTIONS(5123),
    [anon_sym_PROGMEM] = ACTIONS(5123),
    [anon_sym_COLON] = ACTIONS(5121),
    [anon_sym_QMARK] = ACTIONS(5123),
    [anon_sym_STAR_EQ] = ACTIONS(5123),
    [anon_sym_SLASH_EQ] = ACTIONS(5123),
    [anon_sym_PERCENT_EQ] = ACTIONS(5123),
    [anon_sym_PLUS_EQ] = ACTIONS(5123),
    [anon_sym_DASH_EQ] = ACTIONS(5123),
    [anon_sym_LT_LT_EQ] = ACTIONS(5123),
    [anon_sym_GT_GT_EQ] = ACTIONS(5123),
    [anon_sym_AMP_EQ] = ACTIONS(5123),
    [anon_sym_CARET_EQ] = ACTIONS(5123),
    [anon_sym_PIPE_EQ] = ACTIONS(5123),
    [anon_sym_and_eq] = ACTIONS(5123),
    [anon_sym_or_eq] = ACTIONS(5123),
    [anon_sym_xor_eq] = ACTIONS(5123),
    [anon_sym_LT_EQ_GT] = ACTIONS(5123),
    [anon_sym_or] = ACTIONS(5121),
    [anon_sym_and] = ACTIONS(5121),
    [anon_sym_bitor] = ACTIONS(5123),
    [anon_sym_xor] = ACTIONS(5121),
    [anon_sym_bitand] = ACTIONS(5123),
    [anon_sym_not_eq] = ACTIONS(5123),
    [anon_sym_DASH_DASH] = ACTIONS(5123),
    [anon_sym_PLUS_PLUS] = ACTIONS(5123),
    [anon_sym_DOT] = ACTIONS(5121),
    [anon_sym_DOT_STAR] = ACTIONS(5123),
    [anon_sym_DASH_GT] = ACTIONS(5121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5123),
    [anon_sym_decltype] = ACTIONS(5123),
    [anon_sym_final] = ACTIONS(5123),
    [anon_sym_override] = ACTIONS(5123),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5123),
  },
  [2081] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [anon_sym_COMMA] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token2] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [aux_sym_preproc_else_token1] = ACTIONS(2267),
    [aux_sym_preproc_elif_token1] = ACTIONS(2267),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(5405),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_friend] = ACTIONS(2267),
    [anon_sym_public] = ACTIONS(2267),
    [anon_sym_private] = ACTIONS(2267),
    [anon_sym_protected] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
  },
  [2082] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [anon_sym_COMMA] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token2] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [aux_sym_preproc_else_token1] = ACTIONS(2267),
    [aux_sym_preproc_elif_token1] = ACTIONS(2267),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_friend] = ACTIONS(2267),
    [anon_sym_public] = ACTIONS(2267),
    [anon_sym_private] = ACTIONS(2267),
    [anon_sym_protected] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
  },
  [2083] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5111),
    [anon_sym_COMMA] = ACTIONS(5111),
    [anon_sym_RPAREN] = ACTIONS(5111),
    [anon_sym_LPAREN2] = ACTIONS(5111),
    [anon_sym_DASH] = ACTIONS(5109),
    [anon_sym_PLUS] = ACTIONS(5109),
    [anon_sym_STAR] = ACTIONS(5109),
    [anon_sym_SLASH] = ACTIONS(5109),
    [anon_sym_PERCENT] = ACTIONS(5109),
    [anon_sym_PIPE_PIPE] = ACTIONS(5111),
    [anon_sym_AMP_AMP] = ACTIONS(5111),
    [anon_sym_PIPE] = ACTIONS(5109),
    [anon_sym_CARET] = ACTIONS(5109),
    [anon_sym_AMP] = ACTIONS(5109),
    [anon_sym_EQ_EQ] = ACTIONS(5111),
    [anon_sym_BANG_EQ] = ACTIONS(5111),
    [anon_sym_GT] = ACTIONS(5109),
    [anon_sym_GT_EQ] = ACTIONS(5111),
    [anon_sym_LT_EQ] = ACTIONS(5109),
    [anon_sym_LT] = ACTIONS(5109),
    [anon_sym_LT_LT] = ACTIONS(5109),
    [anon_sym_GT_GT] = ACTIONS(5109),
    [anon_sym___extension__] = ACTIONS(5111),
    [anon_sym___attribute__] = ACTIONS(5111),
    [anon_sym_COLON_COLON] = ACTIONS(5111),
    [anon_sym_LBRACE] = ACTIONS(5111),
    [anon_sym_LBRACK] = ACTIONS(5111),
    [anon_sym_EQ] = ACTIONS(5109),
    [anon_sym_const] = ACTIONS(5109),
    [anon_sym_constexpr] = ACTIONS(5111),
    [anon_sym_volatile] = ACTIONS(5111),
    [anon_sym_restrict] = ACTIONS(5111),
    [anon_sym___restrict__] = ACTIONS(5111),
    [anon_sym__Atomic] = ACTIONS(5111),
    [anon_sym__Noreturn] = ACTIONS(5111),
    [anon_sym_noreturn] = ACTIONS(5111),
    [anon_sym_mutable] = ACTIONS(5111),
    [anon_sym_constinit] = ACTIONS(5111),
    [anon_sym_consteval] = ACTIONS(5111),
    [anon_sym_PROGMEM] = ACTIONS(5111),
    [anon_sym_COLON] = ACTIONS(5109),
    [anon_sym_QMARK] = ACTIONS(5111),
    [anon_sym_STAR_EQ] = ACTIONS(5111),
    [anon_sym_SLASH_EQ] = ACTIONS(5111),
    [anon_sym_PERCENT_EQ] = ACTIONS(5111),
    [anon_sym_PLUS_EQ] = ACTIONS(5111),
    [anon_sym_DASH_EQ] = ACTIONS(5111),
    [anon_sym_LT_LT_EQ] = ACTIONS(5111),
    [anon_sym_GT_GT_EQ] = ACTIONS(5111),
    [anon_sym_AMP_EQ] = ACTIONS(5111),
    [anon_sym_CARET_EQ] = ACTIONS(5111),
    [anon_sym_PIPE_EQ] = ACTIONS(5111),
    [anon_sym_and_eq] = ACTIONS(5111),
    [anon_sym_or_eq] = ACTIONS(5111),
    [anon_sym_xor_eq] = ACTIONS(5111),
    [anon_sym_LT_EQ_GT] = ACTIONS(5111),
    [anon_sym_or] = ACTIONS(5109),
    [anon_sym_and] = ACTIONS(5109),
    [anon_sym_bitor] = ACTIONS(5111),
    [anon_sym_xor] = ACTIONS(5109),
    [anon_sym_bitand] = ACTIONS(5111),
    [anon_sym_not_eq] = ACTIONS(5111),
    [anon_sym_DASH_DASH] = ACTIONS(5111),
    [anon_sym_PLUS_PLUS] = ACTIONS(5111),
    [anon_sym_DOT] = ACTIONS(5109),
    [anon_sym_DOT_STAR] = ACTIONS(5111),
    [anon_sym_DASH_GT] = ACTIONS(5109),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5111),
    [anon_sym_decltype] = ACTIONS(5111),
    [anon_sym_final] = ACTIONS(5111),
    [anon_sym_override] = ACTIONS(5111),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5111),
  },
  [2084] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5148),
    [anon_sym_COMMA] = ACTIONS(5148),
    [anon_sym_RPAREN] = ACTIONS(5148),
    [anon_sym_LPAREN2] = ACTIONS(5148),
    [anon_sym_DASH] = ACTIONS(5146),
    [anon_sym_PLUS] = ACTIONS(5146),
    [anon_sym_STAR] = ACTIONS(5146),
    [anon_sym_SLASH] = ACTIONS(5146),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [anon_sym_PIPE_PIPE] = ACTIONS(5148),
    [anon_sym_AMP_AMP] = ACTIONS(5148),
    [anon_sym_PIPE] = ACTIONS(5146),
    [anon_sym_CARET] = ACTIONS(5146),
    [anon_sym_AMP] = ACTIONS(5146),
    [anon_sym_EQ_EQ] = ACTIONS(5148),
    [anon_sym_BANG_EQ] = ACTIONS(5148),
    [anon_sym_GT] = ACTIONS(5146),
    [anon_sym_GT_EQ] = ACTIONS(5148),
    [anon_sym_LT_EQ] = ACTIONS(5146),
    [anon_sym_LT] = ACTIONS(5146),
    [anon_sym_LT_LT] = ACTIONS(5146),
    [anon_sym_GT_GT] = ACTIONS(5146),
    [anon_sym___extension__] = ACTIONS(5148),
    [anon_sym___attribute__] = ACTIONS(5148),
    [anon_sym_COLON_COLON] = ACTIONS(5148),
    [anon_sym_LBRACE] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5148),
    [anon_sym_EQ] = ACTIONS(5146),
    [anon_sym_const] = ACTIONS(5146),
    [anon_sym_constexpr] = ACTIONS(5148),
    [anon_sym_volatile] = ACTIONS(5148),
    [anon_sym_restrict] = ACTIONS(5148),
    [anon_sym___restrict__] = ACTIONS(5148),
    [anon_sym__Atomic] = ACTIONS(5148),
    [anon_sym__Noreturn] = ACTIONS(5148),
    [anon_sym_noreturn] = ACTIONS(5148),
    [anon_sym_mutable] = ACTIONS(5148),
    [anon_sym_constinit] = ACTIONS(5148),
    [anon_sym_consteval] = ACTIONS(5148),
    [anon_sym_PROGMEM] = ACTIONS(5148),
    [anon_sym_COLON] = ACTIONS(5146),
    [anon_sym_QMARK] = ACTIONS(5148),
    [anon_sym_STAR_EQ] = ACTIONS(5148),
    [anon_sym_SLASH_EQ] = ACTIONS(5148),
    [anon_sym_PERCENT_EQ] = ACTIONS(5148),
    [anon_sym_PLUS_EQ] = ACTIONS(5148),
    [anon_sym_DASH_EQ] = ACTIONS(5148),
    [anon_sym_LT_LT_EQ] = ACTIONS(5148),
    [anon_sym_GT_GT_EQ] = ACTIONS(5148),
    [anon_sym_AMP_EQ] = ACTIONS(5148),
    [anon_sym_CARET_EQ] = ACTIONS(5148),
    [anon_sym_PIPE_EQ] = ACTIONS(5148),
    [anon_sym_and_eq] = ACTIONS(5148),
    [anon_sym_or_eq] = ACTIONS(5148),
    [anon_sym_xor_eq] = ACTIONS(5148),
    [anon_sym_LT_EQ_GT] = ACTIONS(5148),
    [anon_sym_or] = ACTIONS(5146),
    [anon_sym_and] = ACTIONS(5146),
    [anon_sym_bitor] = ACTIONS(5148),
    [anon_sym_xor] = ACTIONS(5146),
    [anon_sym_bitand] = ACTIONS(5148),
    [anon_sym_not_eq] = ACTIONS(5148),
    [anon_sym_DASH_DASH] = ACTIONS(5148),
    [anon_sym_PLUS_PLUS] = ACTIONS(5148),
    [anon_sym_DOT] = ACTIONS(5146),
    [anon_sym_DOT_STAR] = ACTIONS(5148),
    [anon_sym_DASH_GT] = ACTIONS(5146),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5148),
    [anon_sym_decltype] = ACTIONS(5148),
    [anon_sym_final] = ACTIONS(5148),
    [anon_sym_override] = ACTIONS(5148),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5148),
  },
  [2085] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5152),
    [anon_sym_COMMA] = ACTIONS(5152),
    [anon_sym_RPAREN] = ACTIONS(5152),
    [anon_sym_LPAREN2] = ACTIONS(5152),
    [anon_sym_DASH] = ACTIONS(5150),
    [anon_sym_PLUS] = ACTIONS(5150),
    [anon_sym_STAR] = ACTIONS(5150),
    [anon_sym_SLASH] = ACTIONS(5150),
    [anon_sym_PERCENT] = ACTIONS(5150),
    [anon_sym_PIPE_PIPE] = ACTIONS(5152),
    [anon_sym_AMP_AMP] = ACTIONS(5152),
    [anon_sym_PIPE] = ACTIONS(5150),
    [anon_sym_CARET] = ACTIONS(5150),
    [anon_sym_AMP] = ACTIONS(5150),
    [anon_sym_EQ_EQ] = ACTIONS(5152),
    [anon_sym_BANG_EQ] = ACTIONS(5152),
    [anon_sym_GT] = ACTIONS(5150),
    [anon_sym_GT_EQ] = ACTIONS(5152),
    [anon_sym_LT_EQ] = ACTIONS(5150),
    [anon_sym_LT] = ACTIONS(5150),
    [anon_sym_LT_LT] = ACTIONS(5150),
    [anon_sym_GT_GT] = ACTIONS(5150),
    [anon_sym___extension__] = ACTIONS(5152),
    [anon_sym___attribute__] = ACTIONS(5152),
    [anon_sym_COLON_COLON] = ACTIONS(5152),
    [anon_sym_LBRACE] = ACTIONS(5152),
    [anon_sym_LBRACK] = ACTIONS(5152),
    [anon_sym_EQ] = ACTIONS(5150),
    [anon_sym_const] = ACTIONS(5150),
    [anon_sym_constexpr] = ACTIONS(5152),
    [anon_sym_volatile] = ACTIONS(5152),
    [anon_sym_restrict] = ACTIONS(5152),
    [anon_sym___restrict__] = ACTIONS(5152),
    [anon_sym__Atomic] = ACTIONS(5152),
    [anon_sym__Noreturn] = ACTIONS(5152),
    [anon_sym_noreturn] = ACTIONS(5152),
    [anon_sym_mutable] = ACTIONS(5152),
    [anon_sym_constinit] = ACTIONS(5152),
    [anon_sym_consteval] = ACTIONS(5152),
    [anon_sym_PROGMEM] = ACTIONS(5152),
    [anon_sym_COLON] = ACTIONS(5150),
    [anon_sym_QMARK] = ACTIONS(5152),
    [anon_sym_STAR_EQ] = ACTIONS(5152),
    [anon_sym_SLASH_EQ] = ACTIONS(5152),
    [anon_sym_PERCENT_EQ] = ACTIONS(5152),
    [anon_sym_PLUS_EQ] = ACTIONS(5152),
    [anon_sym_DASH_EQ] = ACTIONS(5152),
    [anon_sym_LT_LT_EQ] = ACTIONS(5152),
    [anon_sym_GT_GT_EQ] = ACTIONS(5152),
    [anon_sym_AMP_EQ] = ACTIONS(5152),
    [anon_sym_CARET_EQ] = ACTIONS(5152),
    [anon_sym_PIPE_EQ] = ACTIONS(5152),
    [anon_sym_and_eq] = ACTIONS(5152),
    [anon_sym_or_eq] = ACTIONS(5152),
    [anon_sym_xor_eq] = ACTIONS(5152),
    [anon_sym_LT_EQ_GT] = ACTIONS(5152),
    [anon_sym_or] = ACTIONS(5150),
    [anon_sym_and] = ACTIONS(5150),
    [anon_sym_bitor] = ACTIONS(5152),
    [anon_sym_xor] = ACTIONS(5150),
    [anon_sym_bitand] = ACTIONS(5152),
    [anon_sym_not_eq] = ACTIONS(5152),
    [anon_sym_DASH_DASH] = ACTIONS(5152),
    [anon_sym_PLUS_PLUS] = ACTIONS(5152),
    [anon_sym_DOT] = ACTIONS(5150),
    [anon_sym_DOT_STAR] = ACTIONS(5152),
    [anon_sym_DASH_GT] = ACTIONS(5150),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5152),
    [anon_sym_decltype] = ACTIONS(5152),
    [anon_sym_final] = ACTIONS(5152),
    [anon_sym_override] = ACTIONS(5152),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5152),
  },
  [2086] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5115),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_RPAREN] = ACTIONS(5115),
    [anon_sym_LPAREN2] = ACTIONS(5115),
    [anon_sym_DASH] = ACTIONS(5113),
    [anon_sym_PLUS] = ACTIONS(5113),
    [anon_sym_STAR] = ACTIONS(5113),
    [anon_sym_SLASH] = ACTIONS(5113),
    [anon_sym_PERCENT] = ACTIONS(5113),
    [anon_sym_PIPE_PIPE] = ACTIONS(5115),
    [anon_sym_AMP_AMP] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(5113),
    [anon_sym_CARET] = ACTIONS(5113),
    [anon_sym_AMP] = ACTIONS(5113),
    [anon_sym_EQ_EQ] = ACTIONS(5115),
    [anon_sym_BANG_EQ] = ACTIONS(5115),
    [anon_sym_GT] = ACTIONS(5113),
    [anon_sym_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_EQ] = ACTIONS(5113),
    [anon_sym_LT] = ACTIONS(5113),
    [anon_sym_LT_LT] = ACTIONS(5113),
    [anon_sym_GT_GT] = ACTIONS(5113),
    [anon_sym___extension__] = ACTIONS(5115),
    [anon_sym___attribute__] = ACTIONS(5115),
    [anon_sym_COLON_COLON] = ACTIONS(5115),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5113),
    [anon_sym_const] = ACTIONS(5113),
    [anon_sym_constexpr] = ACTIONS(5115),
    [anon_sym_volatile] = ACTIONS(5115),
    [anon_sym_restrict] = ACTIONS(5115),
    [anon_sym___restrict__] = ACTIONS(5115),
    [anon_sym__Atomic] = ACTIONS(5115),
    [anon_sym__Noreturn] = ACTIONS(5115),
    [anon_sym_noreturn] = ACTIONS(5115),
    [anon_sym_mutable] = ACTIONS(5115),
    [anon_sym_constinit] = ACTIONS(5115),
    [anon_sym_consteval] = ACTIONS(5115),
    [anon_sym_PROGMEM] = ACTIONS(5115),
    [anon_sym_COLON] = ACTIONS(5113),
    [anon_sym_QMARK] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_and_eq] = ACTIONS(5115),
    [anon_sym_or_eq] = ACTIONS(5115),
    [anon_sym_xor_eq] = ACTIONS(5115),
    [anon_sym_LT_EQ_GT] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5113),
    [anon_sym_and] = ACTIONS(5113),
    [anon_sym_bitor] = ACTIONS(5115),
    [anon_sym_xor] = ACTIONS(5113),
    [anon_sym_bitand] = ACTIONS(5115),
    [anon_sym_not_eq] = ACTIONS(5115),
    [anon_sym_DASH_DASH] = ACTIONS(5115),
    [anon_sym_PLUS_PLUS] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(5113),
    [anon_sym_DOT_STAR] = ACTIONS(5115),
    [anon_sym_DASH_GT] = ACTIONS(5113),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5115),
    [anon_sym_decltype] = ACTIONS(5115),
    [anon_sym_final] = ACTIONS(5115),
    [anon_sym_override] = ACTIONS(5115),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5115),
  },
  [2087] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token2] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [aux_sym_preproc_else_token1] = ACTIONS(2267),
    [aux_sym_preproc_elif_token1] = ACTIONS(2267),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(2265),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_friend] = ACTIONS(2267),
    [anon_sym_public] = ACTIONS(2267),
    [anon_sym_private] = ACTIONS(2267),
    [anon_sym_protected] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym_catch] = ACTIONS(2267),
  },
  [2088] = {
    [sym_identifier] = ACTIONS(3328),
    [aux_sym_preproc_def_token1] = ACTIONS(3328),
    [aux_sym_preproc_if_token1] = ACTIONS(3328),
    [aux_sym_preproc_if_token2] = ACTIONS(3328),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3328),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3328),
    [aux_sym_preproc_else_token1] = ACTIONS(3328),
    [aux_sym_preproc_elif_token1] = ACTIONS(3328),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3328),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3328),
    [sym_preproc_directive] = ACTIONS(3328),
    [anon_sym_LPAREN2] = ACTIONS(3330),
    [anon_sym_TILDE] = ACTIONS(3330),
    [anon_sym_STAR] = ACTIONS(3330),
    [anon_sym_AMP_AMP] = ACTIONS(3330),
    [anon_sym_AMP] = ACTIONS(3328),
    [anon_sym_SEMI] = ACTIONS(5407),
    [anon_sym___extension__] = ACTIONS(3328),
    [anon_sym_typedef] = ACTIONS(3328),
    [anon_sym_extern] = ACTIONS(3328),
    [anon_sym___attribute__] = ACTIONS(3328),
    [anon_sym_COLON_COLON] = ACTIONS(3330),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3330),
    [anon_sym___declspec] = ACTIONS(3328),
    [anon_sym___based] = ACTIONS(3328),
    [anon_sym_signed] = ACTIONS(3328),
    [anon_sym_unsigned] = ACTIONS(3328),
    [anon_sym_long] = ACTIONS(3328),
    [anon_sym_short] = ACTIONS(3328),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_static] = ACTIONS(3328),
    [anon_sym_register] = ACTIONS(3328),
    [anon_sym_inline] = ACTIONS(3328),
    [anon_sym___inline] = ACTIONS(3328),
    [anon_sym___inline__] = ACTIONS(3328),
    [anon_sym___forceinline] = ACTIONS(3328),
    [anon_sym_thread_local] = ACTIONS(3328),
    [anon_sym___thread] = ACTIONS(3328),
    [anon_sym_const] = ACTIONS(3328),
    [anon_sym_constexpr] = ACTIONS(3328),
    [anon_sym_volatile] = ACTIONS(3328),
    [anon_sym_restrict] = ACTIONS(3328),
    [anon_sym___restrict__] = ACTIONS(3328),
    [anon_sym__Atomic] = ACTIONS(3328),
    [anon_sym__Noreturn] = ACTIONS(3328),
    [anon_sym_noreturn] = ACTIONS(3328),
    [anon_sym_mutable] = ACTIONS(3328),
    [anon_sym_constinit] = ACTIONS(3328),
    [anon_sym_consteval] = ACTIONS(3328),
    [anon_sym_PROGMEM] = ACTIONS(3328),
    [aux_sym_primitive_type_token1] = ACTIONS(3328),
    [anon_sym_byte] = ACTIONS(3328),
    [anon_sym_word] = ACTIONS(3328),
    [anon_sym_enum] = ACTIONS(3328),
    [anon_sym_class] = ACTIONS(3328),
    [anon_sym_struct] = ACTIONS(3328),
    [anon_sym_union] = ACTIONS(3328),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3328),
    [anon_sym_decltype] = ACTIONS(3328),
    [anon_sym_virtual] = ACTIONS(3328),
    [anon_sym_alignas] = ACTIONS(3328),
    [anon_sym_explicit] = ACTIONS(3328),
    [anon_sym_typename] = ACTIONS(3328),
    [anon_sym_template] = ACTIONS(3328),
    [anon_sym_operator] = ACTIONS(3328),
    [anon_sym_friend] = ACTIONS(3328),
    [anon_sym_public] = ACTIONS(3328),
    [anon_sym_private] = ACTIONS(3328),
    [anon_sym_protected] = ACTIONS(3328),
    [anon_sym_using] = ACTIONS(3328),
    [anon_sym_static_assert] = ACTIONS(3328),
  },
  [2089] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(5119),
    [anon_sym_LPAREN2] = ACTIONS(5119),
    [anon_sym_DASH] = ACTIONS(5117),
    [anon_sym_PLUS] = ACTIONS(5117),
    [anon_sym_STAR] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5117),
    [anon_sym_PERCENT] = ACTIONS(5117),
    [anon_sym_PIPE_PIPE] = ACTIONS(5119),
    [anon_sym_AMP_AMP] = ACTIONS(5119),
    [anon_sym_PIPE] = ACTIONS(5117),
    [anon_sym_CARET] = ACTIONS(5117),
    [anon_sym_AMP] = ACTIONS(5117),
    [anon_sym_EQ_EQ] = ACTIONS(5119),
    [anon_sym_BANG_EQ] = ACTIONS(5119),
    [anon_sym_GT] = ACTIONS(5117),
    [anon_sym_GT_EQ] = ACTIONS(5117),
    [anon_sym_LT_EQ] = ACTIONS(5117),
    [anon_sym_LT] = ACTIONS(5117),
    [anon_sym_LT_LT] = ACTIONS(5117),
    [anon_sym_GT_GT] = ACTIONS(5117),
    [anon_sym___extension__] = ACTIONS(5119),
    [anon_sym___attribute__] = ACTIONS(5119),
    [anon_sym_COLON_COLON] = ACTIONS(5119),
    [anon_sym_LBRACE] = ACTIONS(5119),
    [anon_sym_LBRACK] = ACTIONS(5119),
    [anon_sym_EQ] = ACTIONS(5117),
    [anon_sym_const] = ACTIONS(5117),
    [anon_sym_constexpr] = ACTIONS(5119),
    [anon_sym_volatile] = ACTIONS(5119),
    [anon_sym_restrict] = ACTIONS(5119),
    [anon_sym___restrict__] = ACTIONS(5119),
    [anon_sym__Atomic] = ACTIONS(5119),
    [anon_sym__Noreturn] = ACTIONS(5119),
    [anon_sym_noreturn] = ACTIONS(5119),
    [anon_sym_mutable] = ACTIONS(5119),
    [anon_sym_constinit] = ACTIONS(5119),
    [anon_sym_consteval] = ACTIONS(5119),
    [anon_sym_PROGMEM] = ACTIONS(5119),
    [anon_sym_COLON] = ACTIONS(5117),
    [anon_sym_QMARK] = ACTIONS(5119),
    [anon_sym_STAR_EQ] = ACTIONS(5119),
    [anon_sym_SLASH_EQ] = ACTIONS(5119),
    [anon_sym_PERCENT_EQ] = ACTIONS(5119),
    [anon_sym_PLUS_EQ] = ACTIONS(5119),
    [anon_sym_DASH_EQ] = ACTIONS(5119),
    [anon_sym_LT_LT_EQ] = ACTIONS(5119),
    [anon_sym_GT_GT_EQ] = ACTIONS(5117),
    [anon_sym_AMP_EQ] = ACTIONS(5119),
    [anon_sym_CARET_EQ] = ACTIONS(5119),
    [anon_sym_PIPE_EQ] = ACTIONS(5119),
    [anon_sym_and_eq] = ACTIONS(5119),
    [anon_sym_or_eq] = ACTIONS(5119),
    [anon_sym_xor_eq] = ACTIONS(5119),
    [anon_sym_LT_EQ_GT] = ACTIONS(5119),
    [anon_sym_or] = ACTIONS(5117),
    [anon_sym_and] = ACTIONS(5117),
    [anon_sym_bitor] = ACTIONS(5119),
    [anon_sym_xor] = ACTIONS(5117),
    [anon_sym_bitand] = ACTIONS(5119),
    [anon_sym_not_eq] = ACTIONS(5119),
    [anon_sym_DASH_DASH] = ACTIONS(5119),
    [anon_sym_PLUS_PLUS] = ACTIONS(5119),
    [anon_sym_DOT] = ACTIONS(5117),
    [anon_sym_DOT_STAR] = ACTIONS(5119),
    [anon_sym_DASH_GT] = ACTIONS(5119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5119),
    [anon_sym_decltype] = ACTIONS(5119),
    [anon_sym_final] = ACTIONS(5119),
    [anon_sym_override] = ACTIONS(5119),
    [anon_sym_GT2] = ACTIONS(5119),
  },
  [2090] = {
    [sym_identifier] = ACTIONS(3332),
    [aux_sym_preproc_def_token1] = ACTIONS(3332),
    [aux_sym_preproc_if_token1] = ACTIONS(3332),
    [aux_sym_preproc_if_token2] = ACTIONS(3332),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3332),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3332),
    [aux_sym_preproc_else_token1] = ACTIONS(3332),
    [aux_sym_preproc_elif_token1] = ACTIONS(3332),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3332),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3332),
    [sym_preproc_directive] = ACTIONS(3332),
    [anon_sym_LPAREN2] = ACTIONS(3334),
    [anon_sym_TILDE] = ACTIONS(3334),
    [anon_sym_STAR] = ACTIONS(3334),
    [anon_sym_AMP_AMP] = ACTIONS(3334),
    [anon_sym_AMP] = ACTIONS(3332),
    [anon_sym_SEMI] = ACTIONS(5409),
    [anon_sym___extension__] = ACTIONS(3332),
    [anon_sym_typedef] = ACTIONS(3332),
    [anon_sym_extern] = ACTIONS(3332),
    [anon_sym___attribute__] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(3334),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3334),
    [anon_sym___declspec] = ACTIONS(3332),
    [anon_sym___based] = ACTIONS(3332),
    [anon_sym_signed] = ACTIONS(3332),
    [anon_sym_unsigned] = ACTIONS(3332),
    [anon_sym_long] = ACTIONS(3332),
    [anon_sym_short] = ACTIONS(3332),
    [anon_sym_LBRACK] = ACTIONS(3332),
    [anon_sym_static] = ACTIONS(3332),
    [anon_sym_register] = ACTIONS(3332),
    [anon_sym_inline] = ACTIONS(3332),
    [anon_sym___inline] = ACTIONS(3332),
    [anon_sym___inline__] = ACTIONS(3332),
    [anon_sym___forceinline] = ACTIONS(3332),
    [anon_sym_thread_local] = ACTIONS(3332),
    [anon_sym___thread] = ACTIONS(3332),
    [anon_sym_const] = ACTIONS(3332),
    [anon_sym_constexpr] = ACTIONS(3332),
    [anon_sym_volatile] = ACTIONS(3332),
    [anon_sym_restrict] = ACTIONS(3332),
    [anon_sym___restrict__] = ACTIONS(3332),
    [anon_sym__Atomic] = ACTIONS(3332),
    [anon_sym__Noreturn] = ACTIONS(3332),
    [anon_sym_noreturn] = ACTIONS(3332),
    [anon_sym_mutable] = ACTIONS(3332),
    [anon_sym_constinit] = ACTIONS(3332),
    [anon_sym_consteval] = ACTIONS(3332),
    [anon_sym_PROGMEM] = ACTIONS(3332),
    [aux_sym_primitive_type_token1] = ACTIONS(3332),
    [anon_sym_byte] = ACTIONS(3332),
    [anon_sym_word] = ACTIONS(3332),
    [anon_sym_enum] = ACTIONS(3332),
    [anon_sym_class] = ACTIONS(3332),
    [anon_sym_struct] = ACTIONS(3332),
    [anon_sym_union] = ACTIONS(3332),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3332),
    [anon_sym_decltype] = ACTIONS(3332),
    [anon_sym_virtual] = ACTIONS(3332),
    [anon_sym_alignas] = ACTIONS(3332),
    [anon_sym_explicit] = ACTIONS(3332),
    [anon_sym_typename] = ACTIONS(3332),
    [anon_sym_template] = ACTIONS(3332),
    [anon_sym_operator] = ACTIONS(3332),
    [anon_sym_friend] = ACTIONS(3332),
    [anon_sym_public] = ACTIONS(3332),
    [anon_sym_private] = ACTIONS(3332),
    [anon_sym_protected] = ACTIONS(3332),
    [anon_sym_using] = ACTIONS(3332),
    [anon_sym_static_assert] = ACTIONS(3332),
  },
  [2091] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5152),
    [anon_sym_COMMA] = ACTIONS(5152),
    [anon_sym_LPAREN2] = ACTIONS(5152),
    [anon_sym_DASH] = ACTIONS(5150),
    [anon_sym_PLUS] = ACTIONS(5150),
    [anon_sym_STAR] = ACTIONS(5150),
    [anon_sym_SLASH] = ACTIONS(5150),
    [anon_sym_PERCENT] = ACTIONS(5150),
    [anon_sym_PIPE_PIPE] = ACTIONS(5152),
    [anon_sym_AMP_AMP] = ACTIONS(5152),
    [anon_sym_PIPE] = ACTIONS(5150),
    [anon_sym_CARET] = ACTIONS(5150),
    [anon_sym_AMP] = ACTIONS(5150),
    [anon_sym_EQ_EQ] = ACTIONS(5152),
    [anon_sym_BANG_EQ] = ACTIONS(5152),
    [anon_sym_GT] = ACTIONS(5150),
    [anon_sym_GT_EQ] = ACTIONS(5150),
    [anon_sym_LT_EQ] = ACTIONS(5150),
    [anon_sym_LT] = ACTIONS(5150),
    [anon_sym_LT_LT] = ACTIONS(5150),
    [anon_sym_GT_GT] = ACTIONS(5150),
    [anon_sym___extension__] = ACTIONS(5152),
    [anon_sym___attribute__] = ACTIONS(5152),
    [anon_sym_COLON_COLON] = ACTIONS(5152),
    [anon_sym_LBRACE] = ACTIONS(5152),
    [anon_sym_LBRACK] = ACTIONS(5152),
    [anon_sym_EQ] = ACTIONS(5150),
    [anon_sym_const] = ACTIONS(5150),
    [anon_sym_constexpr] = ACTIONS(5152),
    [anon_sym_volatile] = ACTIONS(5152),
    [anon_sym_restrict] = ACTIONS(5152),
    [anon_sym___restrict__] = ACTIONS(5152),
    [anon_sym__Atomic] = ACTIONS(5152),
    [anon_sym__Noreturn] = ACTIONS(5152),
    [anon_sym_noreturn] = ACTIONS(5152),
    [anon_sym_mutable] = ACTIONS(5152),
    [anon_sym_constinit] = ACTIONS(5152),
    [anon_sym_consteval] = ACTIONS(5152),
    [anon_sym_PROGMEM] = ACTIONS(5152),
    [anon_sym_COLON] = ACTIONS(5150),
    [anon_sym_QMARK] = ACTIONS(5152),
    [anon_sym_STAR_EQ] = ACTIONS(5152),
    [anon_sym_SLASH_EQ] = ACTIONS(5152),
    [anon_sym_PERCENT_EQ] = ACTIONS(5152),
    [anon_sym_PLUS_EQ] = ACTIONS(5152),
    [anon_sym_DASH_EQ] = ACTIONS(5152),
    [anon_sym_LT_LT_EQ] = ACTIONS(5152),
    [anon_sym_GT_GT_EQ] = ACTIONS(5150),
    [anon_sym_AMP_EQ] = ACTIONS(5152),
    [anon_sym_CARET_EQ] = ACTIONS(5152),
    [anon_sym_PIPE_EQ] = ACTIONS(5152),
    [anon_sym_and_eq] = ACTIONS(5152),
    [anon_sym_or_eq] = ACTIONS(5152),
    [anon_sym_xor_eq] = ACTIONS(5152),
    [anon_sym_LT_EQ_GT] = ACTIONS(5152),
    [anon_sym_or] = ACTIONS(5150),
    [anon_sym_and] = ACTIONS(5150),
    [anon_sym_bitor] = ACTIONS(5152),
    [anon_sym_xor] = ACTIONS(5150),
    [anon_sym_bitand] = ACTIONS(5152),
    [anon_sym_not_eq] = ACTIONS(5152),
    [anon_sym_DASH_DASH] = ACTIONS(5152),
    [anon_sym_PLUS_PLUS] = ACTIONS(5152),
    [anon_sym_DOT] = ACTIONS(5150),
    [anon_sym_DOT_STAR] = ACTIONS(5152),
    [anon_sym_DASH_GT] = ACTIONS(5152),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5152),
    [anon_sym_decltype] = ACTIONS(5152),
    [anon_sym_final] = ACTIONS(5152),
    [anon_sym_override] = ACTIONS(5152),
    [anon_sym_GT2] = ACTIONS(5152),
  },
  [2092] = {
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5413),
    [anon_sym_COMMA] = ACTIONS(5413),
    [anon_sym_RPAREN] = ACTIONS(5413),
    [aux_sym_preproc_if_token2] = ACTIONS(5413),
    [aux_sym_preproc_else_token1] = ACTIONS(5413),
    [aux_sym_preproc_elif_token1] = ACTIONS(5411),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5413),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5413),
    [anon_sym_LPAREN2] = ACTIONS(5413),
    [anon_sym_DASH] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5411),
    [anon_sym_STAR] = ACTIONS(5411),
    [anon_sym_SLASH] = ACTIONS(5411),
    [anon_sym_PERCENT] = ACTIONS(5411),
    [anon_sym_PIPE_PIPE] = ACTIONS(5413),
    [anon_sym_AMP_AMP] = ACTIONS(5413),
    [anon_sym_PIPE] = ACTIONS(5411),
    [anon_sym_CARET] = ACTIONS(5411),
    [anon_sym_AMP] = ACTIONS(5411),
    [anon_sym_EQ_EQ] = ACTIONS(5413),
    [anon_sym_BANG_EQ] = ACTIONS(5413),
    [anon_sym_GT] = ACTIONS(5411),
    [anon_sym_GT_EQ] = ACTIONS(5413),
    [anon_sym_LT_EQ] = ACTIONS(5411),
    [anon_sym_LT] = ACTIONS(5411),
    [anon_sym_LT_LT] = ACTIONS(5411),
    [anon_sym_GT_GT] = ACTIONS(5411),
    [anon_sym_SEMI] = ACTIONS(5413),
    [anon_sym_RBRACE] = ACTIONS(5413),
    [anon_sym_LBRACK] = ACTIONS(5413),
    [anon_sym_RBRACK] = ACTIONS(5413),
    [anon_sym_EQ] = ACTIONS(5411),
    [anon_sym_COLON] = ACTIONS(5413),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_STAR_EQ] = ACTIONS(5413),
    [anon_sym_SLASH_EQ] = ACTIONS(5413),
    [anon_sym_PERCENT_EQ] = ACTIONS(5413),
    [anon_sym_PLUS_EQ] = ACTIONS(5413),
    [anon_sym_DASH_EQ] = ACTIONS(5413),
    [anon_sym_LT_LT_EQ] = ACTIONS(5413),
    [anon_sym_GT_GT_EQ] = ACTIONS(5413),
    [anon_sym_AMP_EQ] = ACTIONS(5413),
    [anon_sym_CARET_EQ] = ACTIONS(5413),
    [anon_sym_PIPE_EQ] = ACTIONS(5413),
    [anon_sym_and_eq] = ACTIONS(5411),
    [anon_sym_or_eq] = ACTIONS(5411),
    [anon_sym_xor_eq] = ACTIONS(5411),
    [anon_sym_LT_EQ_GT] = ACTIONS(5413),
    [anon_sym_or] = ACTIONS(5411),
    [anon_sym_and] = ACTIONS(5411),
    [anon_sym_bitor] = ACTIONS(5411),
    [anon_sym_xor] = ACTIONS(5411),
    [anon_sym_bitand] = ACTIONS(5411),
    [anon_sym_not_eq] = ACTIONS(5411),
    [anon_sym_DASH_DASH] = ACTIONS(5413),
    [anon_sym_PLUS_PLUS] = ACTIONS(5413),
    [anon_sym_DOT] = ACTIONS(5411),
    [anon_sym_DOT_STAR] = ACTIONS(5413),
    [anon_sym_DASH_GT] = ACTIONS(5413),
    [anon_sym_L_DQUOTE] = ACTIONS(5413),
    [anon_sym_u_DQUOTE] = ACTIONS(5413),
    [anon_sym_U_DQUOTE] = ACTIONS(5413),
    [anon_sym_u8_DQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5413),
    [anon_sym_LR_DQUOTE] = ACTIONS(5413),
    [anon_sym_uR_DQUOTE] = ACTIONS(5413),
    [anon_sym_UR_DQUOTE] = ACTIONS(5413),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5413),
    [sym_literal_suffix] = ACTIONS(5411),
  },
  [2093] = {
    [sym_catch_clause] = STATE(2100),
    [aux_sym_constructor_try_statement_repeat1] = STATE(2100),
    [sym_identifier] = ACTIONS(2856),
    [aux_sym_preproc_def_token1] = ACTIONS(2856),
    [aux_sym_preproc_if_token1] = ACTIONS(2856),
    [aux_sym_preproc_if_token2] = ACTIONS(2856),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2856),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2856),
    [aux_sym_preproc_else_token1] = ACTIONS(2856),
    [aux_sym_preproc_elif_token1] = ACTIONS(2856),
    [sym_preproc_directive] = ACTIONS(2856),
    [anon_sym_LPAREN2] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_STAR] = ACTIONS(2858),
    [anon_sym_AMP_AMP] = ACTIONS(2858),
    [anon_sym_AMP] = ACTIONS(2856),
    [anon_sym___extension__] = ACTIONS(2856),
    [anon_sym_typedef] = ACTIONS(2856),
    [anon_sym_extern] = ACTIONS(2856),
    [anon_sym___attribute__] = ACTIONS(2856),
    [anon_sym_COLON_COLON] = ACTIONS(2858),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2858),
    [anon_sym___declspec] = ACTIONS(2856),
    [anon_sym___based] = ACTIONS(2856),
    [anon_sym_signed] = ACTIONS(2856),
    [anon_sym_unsigned] = ACTIONS(2856),
    [anon_sym_long] = ACTIONS(2856),
    [anon_sym_short] = ACTIONS(2856),
    [anon_sym_LBRACK] = ACTIONS(2856),
    [anon_sym_static] = ACTIONS(2856),
    [anon_sym_register] = ACTIONS(2856),
    [anon_sym_inline] = ACTIONS(2856),
    [anon_sym___inline] = ACTIONS(2856),
    [anon_sym___inline__] = ACTIONS(2856),
    [anon_sym___forceinline] = ACTIONS(2856),
    [anon_sym_thread_local] = ACTIONS(2856),
    [anon_sym___thread] = ACTIONS(2856),
    [anon_sym_const] = ACTIONS(2856),
    [anon_sym_constexpr] = ACTIONS(2856),
    [anon_sym_volatile] = ACTIONS(2856),
    [anon_sym_restrict] = ACTIONS(2856),
    [anon_sym___restrict__] = ACTIONS(2856),
    [anon_sym__Atomic] = ACTIONS(2856),
    [anon_sym__Noreturn] = ACTIONS(2856),
    [anon_sym_noreturn] = ACTIONS(2856),
    [anon_sym_mutable] = ACTIONS(2856),
    [anon_sym_constinit] = ACTIONS(2856),
    [anon_sym_consteval] = ACTIONS(2856),
    [anon_sym_PROGMEM] = ACTIONS(2856),
    [aux_sym_primitive_type_token1] = ACTIONS(2856),
    [anon_sym_byte] = ACTIONS(2856),
    [anon_sym_word] = ACTIONS(2856),
    [anon_sym_enum] = ACTIONS(2856),
    [anon_sym_class] = ACTIONS(2856),
    [anon_sym_struct] = ACTIONS(2856),
    [anon_sym_union] = ACTIONS(2856),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2856),
    [anon_sym_decltype] = ACTIONS(2856),
    [anon_sym_virtual] = ACTIONS(2856),
    [anon_sym_alignas] = ACTIONS(2856),
    [anon_sym_explicit] = ACTIONS(2856),
    [anon_sym_typename] = ACTIONS(2856),
    [anon_sym_template] = ACTIONS(2856),
    [anon_sym_operator] = ACTIONS(2856),
    [anon_sym_friend] = ACTIONS(2856),
    [anon_sym_public] = ACTIONS(2856),
    [anon_sym_private] = ACTIONS(2856),
    [anon_sym_protected] = ACTIONS(2856),
    [anon_sym_using] = ACTIONS(2856),
    [anon_sym_static_assert] = ACTIONS(2856),
    [anon_sym_catch] = ACTIONS(5415),
  },
  [2094] = {
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5419),
    [anon_sym_COMMA] = ACTIONS(5419),
    [anon_sym_RPAREN] = ACTIONS(5419),
    [aux_sym_preproc_if_token2] = ACTIONS(5419),
    [aux_sym_preproc_else_token1] = ACTIONS(5419),
    [aux_sym_preproc_elif_token1] = ACTIONS(5417),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5419),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5419),
    [anon_sym_LPAREN2] = ACTIONS(5419),
    [anon_sym_DASH] = ACTIONS(5417),
    [anon_sym_PLUS] = ACTIONS(5417),
    [anon_sym_STAR] = ACTIONS(5417),
    [anon_sym_SLASH] = ACTIONS(5417),
    [anon_sym_PERCENT] = ACTIONS(5417),
    [anon_sym_PIPE_PIPE] = ACTIONS(5419),
    [anon_sym_AMP_AMP] = ACTIONS(5419),
    [anon_sym_PIPE] = ACTIONS(5417),
    [anon_sym_CARET] = ACTIONS(5417),
    [anon_sym_AMP] = ACTIONS(5417),
    [anon_sym_EQ_EQ] = ACTIONS(5419),
    [anon_sym_BANG_EQ] = ACTIONS(5419),
    [anon_sym_GT] = ACTIONS(5417),
    [anon_sym_GT_EQ] = ACTIONS(5419),
    [anon_sym_LT_EQ] = ACTIONS(5417),
    [anon_sym_LT] = ACTIONS(5417),
    [anon_sym_LT_LT] = ACTIONS(5417),
    [anon_sym_GT_GT] = ACTIONS(5417),
    [anon_sym_SEMI] = ACTIONS(5419),
    [anon_sym_RBRACE] = ACTIONS(5419),
    [anon_sym_LBRACK] = ACTIONS(5419),
    [anon_sym_RBRACK] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(5417),
    [anon_sym_COLON] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5419),
    [anon_sym_STAR_EQ] = ACTIONS(5419),
    [anon_sym_SLASH_EQ] = ACTIONS(5419),
    [anon_sym_PERCENT_EQ] = ACTIONS(5419),
    [anon_sym_PLUS_EQ] = ACTIONS(5419),
    [anon_sym_DASH_EQ] = ACTIONS(5419),
    [anon_sym_LT_LT_EQ] = ACTIONS(5419),
    [anon_sym_GT_GT_EQ] = ACTIONS(5419),
    [anon_sym_AMP_EQ] = ACTIONS(5419),
    [anon_sym_CARET_EQ] = ACTIONS(5419),
    [anon_sym_PIPE_EQ] = ACTIONS(5419),
    [anon_sym_and_eq] = ACTIONS(5417),
    [anon_sym_or_eq] = ACTIONS(5417),
    [anon_sym_xor_eq] = ACTIONS(5417),
    [anon_sym_LT_EQ_GT] = ACTIONS(5419),
    [anon_sym_or] = ACTIONS(5417),
    [anon_sym_and] = ACTIONS(5417),
    [anon_sym_bitor] = ACTIONS(5417),
    [anon_sym_xor] = ACTIONS(5417),
    [anon_sym_bitand] = ACTIONS(5417),
    [anon_sym_not_eq] = ACTIONS(5417),
    [anon_sym_DASH_DASH] = ACTIONS(5419),
    [anon_sym_PLUS_PLUS] = ACTIONS(5419),
    [anon_sym_DOT] = ACTIONS(5417),
    [anon_sym_DOT_STAR] = ACTIONS(5419),
    [anon_sym_DASH_GT] = ACTIONS(5419),
    [anon_sym_L_DQUOTE] = ACTIONS(5419),
    [anon_sym_u_DQUOTE] = ACTIONS(5419),
    [anon_sym_U_DQUOTE] = ACTIONS(5419),
    [anon_sym_u8_DQUOTE] = ACTIONS(5419),
    [anon_sym_DQUOTE] = ACTIONS(5419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5419),
    [anon_sym_LR_DQUOTE] = ACTIONS(5419),
    [anon_sym_uR_DQUOTE] = ACTIONS(5419),
    [anon_sym_UR_DQUOTE] = ACTIONS(5419),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5419),
    [sym_literal_suffix] = ACTIONS(5417),
  },
  [2095] = {
    [sym_identifier] = ACTIONS(5421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5423),
    [anon_sym_COMMA] = ACTIONS(5423),
    [anon_sym_RPAREN] = ACTIONS(5423),
    [aux_sym_preproc_if_token2] = ACTIONS(5423),
    [aux_sym_preproc_else_token1] = ACTIONS(5423),
    [aux_sym_preproc_elif_token1] = ACTIONS(5421),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5423),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5423),
    [anon_sym_LPAREN2] = ACTIONS(5423),
    [anon_sym_DASH] = ACTIONS(5421),
    [anon_sym_PLUS] = ACTIONS(5421),
    [anon_sym_STAR] = ACTIONS(5421),
    [anon_sym_SLASH] = ACTIONS(5421),
    [anon_sym_PERCENT] = ACTIONS(5421),
    [anon_sym_PIPE_PIPE] = ACTIONS(5423),
    [anon_sym_AMP_AMP] = ACTIONS(5423),
    [anon_sym_PIPE] = ACTIONS(5421),
    [anon_sym_CARET] = ACTIONS(5421),
    [anon_sym_AMP] = ACTIONS(5421),
    [anon_sym_EQ_EQ] = ACTIONS(5423),
    [anon_sym_BANG_EQ] = ACTIONS(5423),
    [anon_sym_GT] = ACTIONS(5421),
    [anon_sym_GT_EQ] = ACTIONS(5423),
    [anon_sym_LT_EQ] = ACTIONS(5421),
    [anon_sym_LT] = ACTIONS(5421),
    [anon_sym_LT_LT] = ACTIONS(5421),
    [anon_sym_GT_GT] = ACTIONS(5421),
    [anon_sym_SEMI] = ACTIONS(5423),
    [anon_sym_RBRACE] = ACTIONS(5423),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_RBRACK] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(5421),
    [anon_sym_COLON] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5423),
    [anon_sym_STAR_EQ] = ACTIONS(5423),
    [anon_sym_SLASH_EQ] = ACTIONS(5423),
    [anon_sym_PERCENT_EQ] = ACTIONS(5423),
    [anon_sym_PLUS_EQ] = ACTIONS(5423),
    [anon_sym_DASH_EQ] = ACTIONS(5423),
    [anon_sym_LT_LT_EQ] = ACTIONS(5423),
    [anon_sym_GT_GT_EQ] = ACTIONS(5423),
    [anon_sym_AMP_EQ] = ACTIONS(5423),
    [anon_sym_CARET_EQ] = ACTIONS(5423),
    [anon_sym_PIPE_EQ] = ACTIONS(5423),
    [anon_sym_and_eq] = ACTIONS(5421),
    [anon_sym_or_eq] = ACTIONS(5421),
    [anon_sym_xor_eq] = ACTIONS(5421),
    [anon_sym_LT_EQ_GT] = ACTIONS(5423),
    [anon_sym_or] = ACTIONS(5421),
    [anon_sym_and] = ACTIONS(5421),
    [anon_sym_bitor] = ACTIONS(5421),
    [anon_sym_xor] = ACTIONS(5421),
    [anon_sym_bitand] = ACTIONS(5421),
    [anon_sym_not_eq] = ACTIONS(5421),
    [anon_sym_DASH_DASH] = ACTIONS(5423),
    [anon_sym_PLUS_PLUS] = ACTIONS(5423),
    [anon_sym_DOT] = ACTIONS(5421),
    [anon_sym_DOT_STAR] = ACTIONS(5423),
    [anon_sym_DASH_GT] = ACTIONS(5423),
    [anon_sym_L_DQUOTE] = ACTIONS(5423),
    [anon_sym_u_DQUOTE] = ACTIONS(5423),
    [anon_sym_U_DQUOTE] = ACTIONS(5423),
    [anon_sym_u8_DQUOTE] = ACTIONS(5423),
    [anon_sym_DQUOTE] = ACTIONS(5423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5423),
    [anon_sym_LR_DQUOTE] = ACTIONS(5423),
    [anon_sym_uR_DQUOTE] = ACTIONS(5423),
    [anon_sym_UR_DQUOTE] = ACTIONS(5423),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5423),
    [sym_literal_suffix] = ACTIONS(5421),
  },
  [2096] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5115),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_LPAREN2] = ACTIONS(5115),
    [anon_sym_DASH] = ACTIONS(5113),
    [anon_sym_PLUS] = ACTIONS(5113),
    [anon_sym_STAR] = ACTIONS(5113),
    [anon_sym_SLASH] = ACTIONS(5113),
    [anon_sym_PERCENT] = ACTIONS(5113),
    [anon_sym_PIPE_PIPE] = ACTIONS(5115),
    [anon_sym_AMP_AMP] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(5113),
    [anon_sym_CARET] = ACTIONS(5113),
    [anon_sym_AMP] = ACTIONS(5113),
    [anon_sym_EQ_EQ] = ACTIONS(5115),
    [anon_sym_BANG_EQ] = ACTIONS(5115),
    [anon_sym_GT] = ACTIONS(5113),
    [anon_sym_GT_EQ] = ACTIONS(5113),
    [anon_sym_LT_EQ] = ACTIONS(5113),
    [anon_sym_LT] = ACTIONS(5113),
    [anon_sym_LT_LT] = ACTIONS(5113),
    [anon_sym_GT_GT] = ACTIONS(5113),
    [anon_sym___extension__] = ACTIONS(5115),
    [anon_sym___attribute__] = ACTIONS(5115),
    [anon_sym_COLON_COLON] = ACTIONS(5115),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5113),
    [anon_sym_const] = ACTIONS(5113),
    [anon_sym_constexpr] = ACTIONS(5115),
    [anon_sym_volatile] = ACTIONS(5115),
    [anon_sym_restrict] = ACTIONS(5115),
    [anon_sym___restrict__] = ACTIONS(5115),
    [anon_sym__Atomic] = ACTIONS(5115),
    [anon_sym__Noreturn] = ACTIONS(5115),
    [anon_sym_noreturn] = ACTIONS(5115),
    [anon_sym_mutable] = ACTIONS(5115),
    [anon_sym_constinit] = ACTIONS(5115),
    [anon_sym_consteval] = ACTIONS(5115),
    [anon_sym_PROGMEM] = ACTIONS(5115),
    [anon_sym_COLON] = ACTIONS(5113),
    [anon_sym_QMARK] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5113),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_and_eq] = ACTIONS(5115),
    [anon_sym_or_eq] = ACTIONS(5115),
    [anon_sym_xor_eq] = ACTIONS(5115),
    [anon_sym_LT_EQ_GT] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5113),
    [anon_sym_and] = ACTIONS(5113),
    [anon_sym_bitor] = ACTIONS(5115),
    [anon_sym_xor] = ACTIONS(5113),
    [anon_sym_bitand] = ACTIONS(5115),
    [anon_sym_not_eq] = ACTIONS(5115),
    [anon_sym_DASH_DASH] = ACTIONS(5115),
    [anon_sym_PLUS_PLUS] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(5113),
    [anon_sym_DOT_STAR] = ACTIONS(5115),
    [anon_sym_DASH_GT] = ACTIONS(5115),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5115),
    [anon_sym_decltype] = ACTIONS(5115),
    [anon_sym_final] = ACTIONS(5115),
    [anon_sym_override] = ACTIONS(5115),
    [anon_sym_GT2] = ACTIONS(5115),
  },
  [2097] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5127),
    [anon_sym_COMMA] = ACTIONS(5127),
    [anon_sym_LPAREN2] = ACTIONS(5127),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_PLUS] = ACTIONS(5125),
    [anon_sym_STAR] = ACTIONS(5125),
    [anon_sym_SLASH] = ACTIONS(5125),
    [anon_sym_PERCENT] = ACTIONS(5125),
    [anon_sym_PIPE_PIPE] = ACTIONS(5127),
    [anon_sym_AMP_AMP] = ACTIONS(5127),
    [anon_sym_PIPE] = ACTIONS(5125),
    [anon_sym_CARET] = ACTIONS(5125),
    [anon_sym_AMP] = ACTIONS(5125),
    [anon_sym_EQ_EQ] = ACTIONS(5127),
    [anon_sym_BANG_EQ] = ACTIONS(5127),
    [anon_sym_GT] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5125),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_LT] = ACTIONS(5125),
    [anon_sym_LT_LT] = ACTIONS(5125),
    [anon_sym_GT_GT] = ACTIONS(5125),
    [anon_sym___extension__] = ACTIONS(5127),
    [anon_sym___attribute__] = ACTIONS(5127),
    [anon_sym_COLON_COLON] = ACTIONS(5127),
    [anon_sym_LBRACE] = ACTIONS(5127),
    [anon_sym_LBRACK] = ACTIONS(5127),
    [anon_sym_EQ] = ACTIONS(5125),
    [anon_sym_const] = ACTIONS(5125),
    [anon_sym_constexpr] = ACTIONS(5127),
    [anon_sym_volatile] = ACTIONS(5127),
    [anon_sym_restrict] = ACTIONS(5127),
    [anon_sym___restrict__] = ACTIONS(5127),
    [anon_sym__Atomic] = ACTIONS(5127),
    [anon_sym__Noreturn] = ACTIONS(5127),
    [anon_sym_noreturn] = ACTIONS(5127),
    [anon_sym_mutable] = ACTIONS(5127),
    [anon_sym_constinit] = ACTIONS(5127),
    [anon_sym_consteval] = ACTIONS(5127),
    [anon_sym_PROGMEM] = ACTIONS(5127),
    [anon_sym_COLON] = ACTIONS(5125),
    [anon_sym_QMARK] = ACTIONS(5127),
    [anon_sym_STAR_EQ] = ACTIONS(5127),
    [anon_sym_SLASH_EQ] = ACTIONS(5127),
    [anon_sym_PERCENT_EQ] = ACTIONS(5127),
    [anon_sym_PLUS_EQ] = ACTIONS(5127),
    [anon_sym_DASH_EQ] = ACTIONS(5127),
    [anon_sym_LT_LT_EQ] = ACTIONS(5127),
    [anon_sym_GT_GT_EQ] = ACTIONS(5125),
    [anon_sym_AMP_EQ] = ACTIONS(5127),
    [anon_sym_CARET_EQ] = ACTIONS(5127),
    [anon_sym_PIPE_EQ] = ACTIONS(5127),
    [anon_sym_and_eq] = ACTIONS(5127),
    [anon_sym_or_eq] = ACTIONS(5127),
    [anon_sym_xor_eq] = ACTIONS(5127),
    [anon_sym_LT_EQ_GT] = ACTIONS(5127),
    [anon_sym_or] = ACTIONS(5125),
    [anon_sym_and] = ACTIONS(5125),
    [anon_sym_bitor] = ACTIONS(5127),
    [anon_sym_xor] = ACTIONS(5125),
    [anon_sym_bitand] = ACTIONS(5127),
    [anon_sym_not_eq] = ACTIONS(5127),
    [anon_sym_DASH_DASH] = ACTIONS(5127),
    [anon_sym_PLUS_PLUS] = ACTIONS(5127),
    [anon_sym_DOT] = ACTIONS(5125),
    [anon_sym_DOT_STAR] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5127),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5127),
    [anon_sym_decltype] = ACTIONS(5127),
    [anon_sym_final] = ACTIONS(5127),
    [anon_sym_override] = ACTIONS(5127),
    [anon_sym_GT2] = ACTIONS(5127),
  },
  [2098] = {
    [sym_catch_clause] = STATE(2100),
    [aux_sym_constructor_try_statement_repeat1] = STATE(2100),
    [sym_identifier] = ACTIONS(2860),
    [aux_sym_preproc_def_token1] = ACTIONS(2860),
    [aux_sym_preproc_if_token1] = ACTIONS(2860),
    [aux_sym_preproc_if_token2] = ACTIONS(2860),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2860),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2860),
    [aux_sym_preproc_else_token1] = ACTIONS(2860),
    [aux_sym_preproc_elif_token1] = ACTIONS(2860),
    [sym_preproc_directive] = ACTIONS(2860),
    [anon_sym_LPAREN2] = ACTIONS(2862),
    [anon_sym_TILDE] = ACTIONS(2862),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP_AMP] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2860),
    [anon_sym___extension__] = ACTIONS(2860),
    [anon_sym_typedef] = ACTIONS(2860),
    [anon_sym_extern] = ACTIONS(2860),
    [anon_sym___attribute__] = ACTIONS(2860),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2862),
    [anon_sym___declspec] = ACTIONS(2860),
    [anon_sym___based] = ACTIONS(2860),
    [anon_sym_signed] = ACTIONS(2860),
    [anon_sym_unsigned] = ACTIONS(2860),
    [anon_sym_long] = ACTIONS(2860),
    [anon_sym_short] = ACTIONS(2860),
    [anon_sym_LBRACK] = ACTIONS(2860),
    [anon_sym_static] = ACTIONS(2860),
    [anon_sym_register] = ACTIONS(2860),
    [anon_sym_inline] = ACTIONS(2860),
    [anon_sym___inline] = ACTIONS(2860),
    [anon_sym___inline__] = ACTIONS(2860),
    [anon_sym___forceinline] = ACTIONS(2860),
    [anon_sym_thread_local] = ACTIONS(2860),
    [anon_sym___thread] = ACTIONS(2860),
    [anon_sym_const] = ACTIONS(2860),
    [anon_sym_constexpr] = ACTIONS(2860),
    [anon_sym_volatile] = ACTIONS(2860),
    [anon_sym_restrict] = ACTIONS(2860),
    [anon_sym___restrict__] = ACTIONS(2860),
    [anon_sym__Atomic] = ACTIONS(2860),
    [anon_sym__Noreturn] = ACTIONS(2860),
    [anon_sym_noreturn] = ACTIONS(2860),
    [anon_sym_mutable] = ACTIONS(2860),
    [anon_sym_constinit] = ACTIONS(2860),
    [anon_sym_consteval] = ACTIONS(2860),
    [anon_sym_PROGMEM] = ACTIONS(2860),
    [aux_sym_primitive_type_token1] = ACTIONS(2860),
    [anon_sym_byte] = ACTIONS(2860),
    [anon_sym_word] = ACTIONS(2860),
    [anon_sym_enum] = ACTIONS(2860),
    [anon_sym_class] = ACTIONS(2860),
    [anon_sym_struct] = ACTIONS(2860),
    [anon_sym_union] = ACTIONS(2860),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2860),
    [anon_sym_decltype] = ACTIONS(2860),
    [anon_sym_virtual] = ACTIONS(2860),
    [anon_sym_alignas] = ACTIONS(2860),
    [anon_sym_explicit] = ACTIONS(2860),
    [anon_sym_typename] = ACTIONS(2860),
    [anon_sym_template] = ACTIONS(2860),
    [anon_sym_operator] = ACTIONS(2860),
    [anon_sym_friend] = ACTIONS(2860),
    [anon_sym_public] = ACTIONS(2860),
    [anon_sym_private] = ACTIONS(2860),
    [anon_sym_protected] = ACTIONS(2860),
    [anon_sym_using] = ACTIONS(2860),
    [anon_sym_static_assert] = ACTIONS(2860),
    [anon_sym_catch] = ACTIONS(5415),
  },
  [2099] = {
    [sym_identifier] = ACTIONS(3427),
    [aux_sym_preproc_def_token1] = ACTIONS(3427),
    [aux_sym_preproc_if_token1] = ACTIONS(3427),
    [aux_sym_preproc_if_token2] = ACTIONS(3427),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3427),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3427),
    [aux_sym_preproc_else_token1] = ACTIONS(3427),
    [aux_sym_preproc_elif_token1] = ACTIONS(3427),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3427),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3427),
    [sym_preproc_directive] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3429),
    [anon_sym_TILDE] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(3429),
    [anon_sym_AMP_AMP] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym___extension__] = ACTIONS(3427),
    [anon_sym_typedef] = ACTIONS(3427),
    [anon_sym_extern] = ACTIONS(3427),
    [anon_sym___attribute__] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3429),
    [anon_sym___declspec] = ACTIONS(3427),
    [anon_sym___based] = ACTIONS(3427),
    [anon_sym_signed] = ACTIONS(3427),
    [anon_sym_unsigned] = ACTIONS(3427),
    [anon_sym_long] = ACTIONS(3427),
    [anon_sym_short] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_register] = ACTIONS(3427),
    [anon_sym_inline] = ACTIONS(3427),
    [anon_sym___inline] = ACTIONS(3427),
    [anon_sym___inline__] = ACTIONS(3427),
    [anon_sym___forceinline] = ACTIONS(3427),
    [anon_sym_thread_local] = ACTIONS(3427),
    [anon_sym___thread] = ACTIONS(3427),
    [anon_sym_const] = ACTIONS(3427),
    [anon_sym_constexpr] = ACTIONS(3427),
    [anon_sym_volatile] = ACTIONS(3427),
    [anon_sym_restrict] = ACTIONS(3427),
    [anon_sym___restrict__] = ACTIONS(3427),
    [anon_sym__Atomic] = ACTIONS(3427),
    [anon_sym__Noreturn] = ACTIONS(3427),
    [anon_sym_noreturn] = ACTIONS(3427),
    [anon_sym_mutable] = ACTIONS(3427),
    [anon_sym_constinit] = ACTIONS(3427),
    [anon_sym_consteval] = ACTIONS(3427),
    [anon_sym_PROGMEM] = ACTIONS(3427),
    [aux_sym_primitive_type_token1] = ACTIONS(3427),
    [anon_sym_byte] = ACTIONS(3427),
    [anon_sym_word] = ACTIONS(3427),
    [anon_sym_enum] = ACTIONS(3427),
    [anon_sym_class] = ACTIONS(3427),
    [anon_sym_struct] = ACTIONS(3427),
    [anon_sym_union] = ACTIONS(3427),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3427),
    [anon_sym_decltype] = ACTIONS(3427),
    [anon_sym_virtual] = ACTIONS(3427),
    [anon_sym_alignas] = ACTIONS(3427),
    [anon_sym_explicit] = ACTIONS(3427),
    [anon_sym_typename] = ACTIONS(3427),
    [anon_sym_template] = ACTIONS(3427),
    [anon_sym_operator] = ACTIONS(3427),
    [anon_sym_friend] = ACTIONS(3427),
    [anon_sym_public] = ACTIONS(3427),
    [anon_sym_private] = ACTIONS(3427),
    [anon_sym_protected] = ACTIONS(3427),
    [anon_sym_using] = ACTIONS(3427),
    [anon_sym_static_assert] = ACTIONS(3427),
  },
  [2100] = {
    [sym_catch_clause] = STATE(2100),
    [aux_sym_constructor_try_statement_repeat1] = STATE(2100),
    [sym_identifier] = ACTIONS(2843),
    [aux_sym_preproc_def_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token2] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2843),
    [aux_sym_preproc_else_token1] = ACTIONS(2843),
    [aux_sym_preproc_elif_token1] = ACTIONS(2843),
    [sym_preproc_directive] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym___extension__] = ACTIONS(2843),
    [anon_sym_typedef] = ACTIONS(2843),
    [anon_sym_extern] = ACTIONS(2843),
    [anon_sym___attribute__] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2845),
    [anon_sym___declspec] = ACTIONS(2843),
    [anon_sym___based] = ACTIONS(2843),
    [anon_sym_signed] = ACTIONS(2843),
    [anon_sym_unsigned] = ACTIONS(2843),
    [anon_sym_long] = ACTIONS(2843),
    [anon_sym_short] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_register] = ACTIONS(2843),
    [anon_sym_inline] = ACTIONS(2843),
    [anon_sym___inline] = ACTIONS(2843),
    [anon_sym___inline__] = ACTIONS(2843),
    [anon_sym___forceinline] = ACTIONS(2843),
    [anon_sym_thread_local] = ACTIONS(2843),
    [anon_sym___thread] = ACTIONS(2843),
    [anon_sym_const] = ACTIONS(2843),
    [anon_sym_constexpr] = ACTIONS(2843),
    [anon_sym_volatile] = ACTIONS(2843),
    [anon_sym_restrict] = ACTIONS(2843),
    [anon_sym___restrict__] = ACTIONS(2843),
    [anon_sym__Atomic] = ACTIONS(2843),
    [anon_sym__Noreturn] = ACTIONS(2843),
    [anon_sym_noreturn] = ACTIONS(2843),
    [anon_sym_mutable] = ACTIONS(2843),
    [anon_sym_constinit] = ACTIONS(2843),
    [anon_sym_consteval] = ACTIONS(2843),
    [anon_sym_PROGMEM] = ACTIONS(2843),
    [aux_sym_primitive_type_token1] = ACTIONS(2843),
    [anon_sym_byte] = ACTIONS(2843),
    [anon_sym_word] = ACTIONS(2843),
    [anon_sym_enum] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2843),
    [anon_sym_union] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2843),
    [anon_sym_decltype] = ACTIONS(2843),
    [anon_sym_virtual] = ACTIONS(2843),
    [anon_sym_alignas] = ACTIONS(2843),
    [anon_sym_explicit] = ACTIONS(2843),
    [anon_sym_typename] = ACTIONS(2843),
    [anon_sym_template] = ACTIONS(2843),
    [anon_sym_operator] = ACTIONS(2843),
    [anon_sym_friend] = ACTIONS(2843),
    [anon_sym_public] = ACTIONS(2843),
    [anon_sym_private] = ACTIONS(2843),
    [anon_sym_protected] = ACTIONS(2843),
    [anon_sym_using] = ACTIONS(2843),
    [anon_sym_static_assert] = ACTIONS(2843),
    [anon_sym_catch] = ACTIONS(5427),
  },
  [2101] = {
    [sym_type_qualifier] = STATE(2101),
    [aux_sym__type_definition_type_repeat1] = STATE(2101),
    [sym_identifier] = ACTIONS(5430),
    [anon_sym_LPAREN2] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5432),
    [anon_sym_TILDE] = ACTIONS(5432),
    [anon_sym_DASH] = ACTIONS(5430),
    [anon_sym_PLUS] = ACTIONS(5430),
    [anon_sym_STAR] = ACTIONS(5432),
    [anon_sym_AMP] = ACTIONS(5432),
    [anon_sym___extension__] = ACTIONS(5434),
    [anon_sym_COLON_COLON] = ACTIONS(5432),
    [anon_sym_LBRACK] = ACTIONS(5432),
    [anon_sym_RBRACK] = ACTIONS(5432),
    [anon_sym_const] = ACTIONS(5434),
    [anon_sym_constexpr] = ACTIONS(5434),
    [anon_sym_volatile] = ACTIONS(5434),
    [anon_sym_restrict] = ACTIONS(5434),
    [anon_sym___restrict__] = ACTIONS(5434),
    [anon_sym__Atomic] = ACTIONS(5434),
    [anon_sym__Noreturn] = ACTIONS(5434),
    [anon_sym_noreturn] = ACTIONS(5434),
    [anon_sym_mutable] = ACTIONS(5434),
    [anon_sym_constinit] = ACTIONS(5434),
    [anon_sym_consteval] = ACTIONS(5434),
    [anon_sym_PROGMEM] = ACTIONS(5434),
    [aux_sym_primitive_type_token1] = ACTIONS(5430),
    [anon_sym_byte] = ACTIONS(5430),
    [anon_sym_word] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5430),
    [anon_sym_compl] = ACTIONS(5430),
    [anon_sym_DASH_DASH] = ACTIONS(5432),
    [anon_sym_PLUS_PLUS] = ACTIONS(5432),
    [anon_sym_sizeof] = ACTIONS(5430),
    [anon_sym___alignof__] = ACTIONS(5430),
    [anon_sym___alignof] = ACTIONS(5430),
    [anon_sym__alignof] = ACTIONS(5430),
    [anon_sym_alignof] = ACTIONS(5430),
    [anon_sym__Alignof] = ACTIONS(5430),
    [anon_sym_offsetof] = ACTIONS(5430),
    [anon_sym__Generic] = ACTIONS(5430),
    [anon_sym_asm] = ACTIONS(5430),
    [anon_sym___asm__] = ACTIONS(5430),
    [aux_sym_number_literal_token1] = ACTIONS(5432),
    [aux_sym_number_literal_token2] = ACTIONS(5430),
    [anon_sym_L_SQUOTE] = ACTIONS(5432),
    [anon_sym_u_SQUOTE] = ACTIONS(5432),
    [anon_sym_U_SQUOTE] = ACTIONS(5432),
    [anon_sym_u8_SQUOTE] = ACTIONS(5432),
    [anon_sym_SQUOTE] = ACTIONS(5432),
    [anon_sym_L_DQUOTE] = ACTIONS(5432),
    [anon_sym_u_DQUOTE] = ACTIONS(5432),
    [anon_sym_U_DQUOTE] = ACTIONS(5432),
    [anon_sym_u8_DQUOTE] = ACTIONS(5432),
    [anon_sym_DQUOTE] = ACTIONS(5432),
    [sym_true] = ACTIONS(5430),
    [sym_false] = ACTIONS(5430),
    [anon_sym_NULL] = ACTIONS(5430),
    [anon_sym_nullptr] = ACTIONS(5430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5430),
    [anon_sym_template] = ACTIONS(5430),
    [anon_sym_delete] = ACTIONS(5430),
    [anon_sym_R_DQUOTE] = ACTIONS(5432),
    [anon_sym_LR_DQUOTE] = ACTIONS(5432),
    [anon_sym_uR_DQUOTE] = ACTIONS(5432),
    [anon_sym_UR_DQUOTE] = ACTIONS(5432),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5432),
    [anon_sym_co_await] = ACTIONS(5430),
    [anon_sym_new] = ACTIONS(5430),
    [anon_sym_requires] = ACTIONS(5430),
    [sym_this] = ACTIONS(5430),
  },
  [2102] = {
    [sym_catch_clause] = STATE(2100),
    [aux_sym_constructor_try_statement_repeat1] = STATE(2100),
    [sym_identifier] = ACTIONS(2850),
    [aux_sym_preproc_def_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token2] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2850),
    [aux_sym_preproc_else_token1] = ACTIONS(2850),
    [aux_sym_preproc_elif_token1] = ACTIONS(2850),
    [sym_preproc_directive] = ACTIONS(2850),
    [anon_sym_LPAREN2] = ACTIONS(2852),
    [anon_sym_TILDE] = ACTIONS(2852),
    [anon_sym_STAR] = ACTIONS(2852),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_AMP] = ACTIONS(2850),
    [anon_sym___extension__] = ACTIONS(2850),
    [anon_sym_typedef] = ACTIONS(2850),
    [anon_sym_extern] = ACTIONS(2850),
    [anon_sym___attribute__] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2852),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2852),
    [anon_sym___declspec] = ACTIONS(2850),
    [anon_sym___based] = ACTIONS(2850),
    [anon_sym_signed] = ACTIONS(2850),
    [anon_sym_unsigned] = ACTIONS(2850),
    [anon_sym_long] = ACTIONS(2850),
    [anon_sym_short] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2850),
    [anon_sym_register] = ACTIONS(2850),
    [anon_sym_inline] = ACTIONS(2850),
    [anon_sym___inline] = ACTIONS(2850),
    [anon_sym___inline__] = ACTIONS(2850),
    [anon_sym___forceinline] = ACTIONS(2850),
    [anon_sym_thread_local] = ACTIONS(2850),
    [anon_sym___thread] = ACTIONS(2850),
    [anon_sym_const] = ACTIONS(2850),
    [anon_sym_constexpr] = ACTIONS(2850),
    [anon_sym_volatile] = ACTIONS(2850),
    [anon_sym_restrict] = ACTIONS(2850),
    [anon_sym___restrict__] = ACTIONS(2850),
    [anon_sym__Atomic] = ACTIONS(2850),
    [anon_sym__Noreturn] = ACTIONS(2850),
    [anon_sym_noreturn] = ACTIONS(2850),
    [anon_sym_mutable] = ACTIONS(2850),
    [anon_sym_constinit] = ACTIONS(2850),
    [anon_sym_consteval] = ACTIONS(2850),
    [anon_sym_PROGMEM] = ACTIONS(2850),
    [aux_sym_primitive_type_token1] = ACTIONS(2850),
    [anon_sym_byte] = ACTIONS(2850),
    [anon_sym_word] = ACTIONS(2850),
    [anon_sym_enum] = ACTIONS(2850),
    [anon_sym_class] = ACTIONS(2850),
    [anon_sym_struct] = ACTIONS(2850),
    [anon_sym_union] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2850),
    [anon_sym_decltype] = ACTIONS(2850),
    [anon_sym_virtual] = ACTIONS(2850),
    [anon_sym_alignas] = ACTIONS(2850),
    [anon_sym_explicit] = ACTIONS(2850),
    [anon_sym_typename] = ACTIONS(2850),
    [anon_sym_template] = ACTIONS(2850),
    [anon_sym_operator] = ACTIONS(2850),
    [anon_sym_friend] = ACTIONS(2850),
    [anon_sym_public] = ACTIONS(2850),
    [anon_sym_private] = ACTIONS(2850),
    [anon_sym_protected] = ACTIONS(2850),
    [anon_sym_using] = ACTIONS(2850),
    [anon_sym_static_assert] = ACTIONS(2850),
    [anon_sym_catch] = ACTIONS(5415),
  },
  [2103] = {
    [sym_identifier] = ACTIONS(3471),
    [aux_sym_preproc_def_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token2] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3471),
    [aux_sym_preproc_else_token1] = ACTIONS(3471),
    [aux_sym_preproc_elif_token1] = ACTIONS(3471),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3471),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3471),
    [sym_preproc_directive] = ACTIONS(3471),
    [anon_sym_LPAREN2] = ACTIONS(3473),
    [anon_sym_TILDE] = ACTIONS(3473),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_AMP_AMP] = ACTIONS(3473),
    [anon_sym_AMP] = ACTIONS(3471),
    [anon_sym_SEMI] = ACTIONS(5437),
    [anon_sym___extension__] = ACTIONS(3471),
    [anon_sym_typedef] = ACTIONS(3471),
    [anon_sym_extern] = ACTIONS(3471),
    [anon_sym___attribute__] = ACTIONS(3471),
    [anon_sym_COLON_COLON] = ACTIONS(3473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3473),
    [anon_sym___declspec] = ACTIONS(3471),
    [anon_sym___based] = ACTIONS(3471),
    [anon_sym_signed] = ACTIONS(3471),
    [anon_sym_unsigned] = ACTIONS(3471),
    [anon_sym_long] = ACTIONS(3471),
    [anon_sym_short] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [anon_sym_static] = ACTIONS(3471),
    [anon_sym_register] = ACTIONS(3471),
    [anon_sym_inline] = ACTIONS(3471),
    [anon_sym___inline] = ACTIONS(3471),
    [anon_sym___inline__] = ACTIONS(3471),
    [anon_sym___forceinline] = ACTIONS(3471),
    [anon_sym_thread_local] = ACTIONS(3471),
    [anon_sym___thread] = ACTIONS(3471),
    [anon_sym_const] = ACTIONS(3471),
    [anon_sym_constexpr] = ACTIONS(3471),
    [anon_sym_volatile] = ACTIONS(3471),
    [anon_sym_restrict] = ACTIONS(3471),
    [anon_sym___restrict__] = ACTIONS(3471),
    [anon_sym__Atomic] = ACTIONS(3471),
    [anon_sym__Noreturn] = ACTIONS(3471),
    [anon_sym_noreturn] = ACTIONS(3471),
    [anon_sym_mutable] = ACTIONS(3471),
    [anon_sym_constinit] = ACTIONS(3471),
    [anon_sym_consteval] = ACTIONS(3471),
    [anon_sym_PROGMEM] = ACTIONS(3471),
    [aux_sym_primitive_type_token1] = ACTIONS(3471),
    [anon_sym_byte] = ACTIONS(3471),
    [anon_sym_word] = ACTIONS(3471),
    [anon_sym_enum] = ACTIONS(3471),
    [anon_sym_class] = ACTIONS(3471),
    [anon_sym_struct] = ACTIONS(3471),
    [anon_sym_union] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3471),
    [anon_sym_decltype] = ACTIONS(3471),
    [anon_sym_virtual] = ACTIONS(3471),
    [anon_sym_alignas] = ACTIONS(3471),
    [anon_sym_explicit] = ACTIONS(3471),
    [anon_sym_typename] = ACTIONS(3471),
    [anon_sym_template] = ACTIONS(3471),
    [anon_sym_operator] = ACTIONS(3471),
    [anon_sym_friend] = ACTIONS(3471),
    [anon_sym_public] = ACTIONS(3471),
    [anon_sym_private] = ACTIONS(3471),
    [anon_sym_protected] = ACTIONS(3471),
    [anon_sym_using] = ACTIONS(3471),
    [anon_sym_static_assert] = ACTIONS(3471),
  },
  [2104] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5123),
    [anon_sym_COMMA] = ACTIONS(5123),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5121),
    [anon_sym_PLUS] = ACTIONS(5121),
    [anon_sym_STAR] = ACTIONS(5121),
    [anon_sym_SLASH] = ACTIONS(5121),
    [anon_sym_PERCENT] = ACTIONS(5121),
    [anon_sym_PIPE_PIPE] = ACTIONS(5123),
    [anon_sym_AMP_AMP] = ACTIONS(5123),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_CARET] = ACTIONS(5121),
    [anon_sym_AMP] = ACTIONS(5121),
    [anon_sym_EQ_EQ] = ACTIONS(5123),
    [anon_sym_BANG_EQ] = ACTIONS(5123),
    [anon_sym_GT] = ACTIONS(5121),
    [anon_sym_GT_EQ] = ACTIONS(5121),
    [anon_sym_LT_EQ] = ACTIONS(5121),
    [anon_sym_LT] = ACTIONS(5121),
    [anon_sym_LT_LT] = ACTIONS(5121),
    [anon_sym_GT_GT] = ACTIONS(5121),
    [anon_sym___extension__] = ACTIONS(5123),
    [anon_sym___attribute__] = ACTIONS(5123),
    [anon_sym_COLON_COLON] = ACTIONS(5123),
    [anon_sym_LBRACE] = ACTIONS(5123),
    [anon_sym_LBRACK] = ACTIONS(5123),
    [anon_sym_EQ] = ACTIONS(5121),
    [anon_sym_const] = ACTIONS(5121),
    [anon_sym_constexpr] = ACTIONS(5123),
    [anon_sym_volatile] = ACTIONS(5123),
    [anon_sym_restrict] = ACTIONS(5123),
    [anon_sym___restrict__] = ACTIONS(5123),
    [anon_sym__Atomic] = ACTIONS(5123),
    [anon_sym__Noreturn] = ACTIONS(5123),
    [anon_sym_noreturn] = ACTIONS(5123),
    [anon_sym_mutable] = ACTIONS(5123),
    [anon_sym_constinit] = ACTIONS(5123),
    [anon_sym_consteval] = ACTIONS(5123),
    [anon_sym_PROGMEM] = ACTIONS(5123),
    [anon_sym_COLON] = ACTIONS(5121),
    [anon_sym_QMARK] = ACTIONS(5123),
    [anon_sym_STAR_EQ] = ACTIONS(5123),
    [anon_sym_SLASH_EQ] = ACTIONS(5123),
    [anon_sym_PERCENT_EQ] = ACTIONS(5123),
    [anon_sym_PLUS_EQ] = ACTIONS(5123),
    [anon_sym_DASH_EQ] = ACTIONS(5123),
    [anon_sym_LT_LT_EQ] = ACTIONS(5123),
    [anon_sym_GT_GT_EQ] = ACTIONS(5121),
    [anon_sym_AMP_EQ] = ACTIONS(5123),
    [anon_sym_CARET_EQ] = ACTIONS(5123),
    [anon_sym_PIPE_EQ] = ACTIONS(5123),
    [anon_sym_and_eq] = ACTIONS(5123),
    [anon_sym_or_eq] = ACTIONS(5123),
    [anon_sym_xor_eq] = ACTIONS(5123),
    [anon_sym_LT_EQ_GT] = ACTIONS(5123),
    [anon_sym_or] = ACTIONS(5121),
    [anon_sym_and] = ACTIONS(5121),
    [anon_sym_bitor] = ACTIONS(5123),
    [anon_sym_xor] = ACTIONS(5121),
    [anon_sym_bitand] = ACTIONS(5123),
    [anon_sym_not_eq] = ACTIONS(5123),
    [anon_sym_DASH_DASH] = ACTIONS(5123),
    [anon_sym_PLUS_PLUS] = ACTIONS(5123),
    [anon_sym_DOT] = ACTIONS(5121),
    [anon_sym_DOT_STAR] = ACTIONS(5123),
    [anon_sym_DASH_GT] = ACTIONS(5123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5123),
    [anon_sym_decltype] = ACTIONS(5123),
    [anon_sym_final] = ACTIONS(5123),
    [anon_sym_override] = ACTIONS(5123),
    [anon_sym_GT2] = ACTIONS(5123),
  },
  [2105] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5111),
    [anon_sym_COMMA] = ACTIONS(5111),
    [anon_sym_LPAREN2] = ACTIONS(5111),
    [anon_sym_DASH] = ACTIONS(5109),
    [anon_sym_PLUS] = ACTIONS(5109),
    [anon_sym_STAR] = ACTIONS(5109),
    [anon_sym_SLASH] = ACTIONS(5109),
    [anon_sym_PERCENT] = ACTIONS(5109),
    [anon_sym_PIPE_PIPE] = ACTIONS(5111),
    [anon_sym_AMP_AMP] = ACTIONS(5111),
    [anon_sym_PIPE] = ACTIONS(5109),
    [anon_sym_CARET] = ACTIONS(5109),
    [anon_sym_AMP] = ACTIONS(5109),
    [anon_sym_EQ_EQ] = ACTIONS(5111),
    [anon_sym_BANG_EQ] = ACTIONS(5111),
    [anon_sym_GT] = ACTIONS(5109),
    [anon_sym_GT_EQ] = ACTIONS(5109),
    [anon_sym_LT_EQ] = ACTIONS(5109),
    [anon_sym_LT] = ACTIONS(5109),
    [anon_sym_LT_LT] = ACTIONS(5109),
    [anon_sym_GT_GT] = ACTIONS(5109),
    [anon_sym___extension__] = ACTIONS(5111),
    [anon_sym___attribute__] = ACTIONS(5111),
    [anon_sym_COLON_COLON] = ACTIONS(5111),
    [anon_sym_LBRACE] = ACTIONS(5111),
    [anon_sym_LBRACK] = ACTIONS(5111),
    [anon_sym_EQ] = ACTIONS(5109),
    [anon_sym_const] = ACTIONS(5109),
    [anon_sym_constexpr] = ACTIONS(5111),
    [anon_sym_volatile] = ACTIONS(5111),
    [anon_sym_restrict] = ACTIONS(5111),
    [anon_sym___restrict__] = ACTIONS(5111),
    [anon_sym__Atomic] = ACTIONS(5111),
    [anon_sym__Noreturn] = ACTIONS(5111),
    [anon_sym_noreturn] = ACTIONS(5111),
    [anon_sym_mutable] = ACTIONS(5111),
    [anon_sym_constinit] = ACTIONS(5111),
    [anon_sym_consteval] = ACTIONS(5111),
    [anon_sym_PROGMEM] = ACTIONS(5111),
    [anon_sym_COLON] = ACTIONS(5109),
    [anon_sym_QMARK] = ACTIONS(5111),
    [anon_sym_STAR_EQ] = ACTIONS(5111),
    [anon_sym_SLASH_EQ] = ACTIONS(5111),
    [anon_sym_PERCENT_EQ] = ACTIONS(5111),
    [anon_sym_PLUS_EQ] = ACTIONS(5111),
    [anon_sym_DASH_EQ] = ACTIONS(5111),
    [anon_sym_LT_LT_EQ] = ACTIONS(5111),
    [anon_sym_GT_GT_EQ] = ACTIONS(5109),
    [anon_sym_AMP_EQ] = ACTIONS(5111),
    [anon_sym_CARET_EQ] = ACTIONS(5111),
    [anon_sym_PIPE_EQ] = ACTIONS(5111),
    [anon_sym_and_eq] = ACTIONS(5111),
    [anon_sym_or_eq] = ACTIONS(5111),
    [anon_sym_xor_eq] = ACTIONS(5111),
    [anon_sym_LT_EQ_GT] = ACTIONS(5111),
    [anon_sym_or] = ACTIONS(5109),
    [anon_sym_and] = ACTIONS(5109),
    [anon_sym_bitor] = ACTIONS(5111),
    [anon_sym_xor] = ACTIONS(5109),
    [anon_sym_bitand] = ACTIONS(5111),
    [anon_sym_not_eq] = ACTIONS(5111),
    [anon_sym_DASH_DASH] = ACTIONS(5111),
    [anon_sym_PLUS_PLUS] = ACTIONS(5111),
    [anon_sym_DOT] = ACTIONS(5109),
    [anon_sym_DOT_STAR] = ACTIONS(5111),
    [anon_sym_DASH_GT] = ACTIONS(5111),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5111),
    [anon_sym_decltype] = ACTIONS(5111),
    [anon_sym_final] = ACTIONS(5111),
    [anon_sym_override] = ACTIONS(5111),
    [anon_sym_GT2] = ACTIONS(5111),
  },
  [2106] = {
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5441),
    [anon_sym_COMMA] = ACTIONS(5441),
    [anon_sym_RPAREN] = ACTIONS(5441),
    [aux_sym_preproc_if_token2] = ACTIONS(5441),
    [aux_sym_preproc_else_token1] = ACTIONS(5441),
    [aux_sym_preproc_elif_token1] = ACTIONS(5439),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5441),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(5441),
    [anon_sym_DASH] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(5439),
    [anon_sym_STAR] = ACTIONS(5439),
    [anon_sym_SLASH] = ACTIONS(5439),
    [anon_sym_PERCENT] = ACTIONS(5439),
    [anon_sym_PIPE_PIPE] = ACTIONS(5441),
    [anon_sym_AMP_AMP] = ACTIONS(5441),
    [anon_sym_PIPE] = ACTIONS(5439),
    [anon_sym_CARET] = ACTIONS(5439),
    [anon_sym_AMP] = ACTIONS(5439),
    [anon_sym_EQ_EQ] = ACTIONS(5441),
    [anon_sym_BANG_EQ] = ACTIONS(5441),
    [anon_sym_GT] = ACTIONS(5439),
    [anon_sym_GT_EQ] = ACTIONS(5441),
    [anon_sym_LT_EQ] = ACTIONS(5439),
    [anon_sym_LT] = ACTIONS(5439),
    [anon_sym_LT_LT] = ACTIONS(5439),
    [anon_sym_GT_GT] = ACTIONS(5439),
    [anon_sym_SEMI] = ACTIONS(5441),
    [anon_sym_RBRACE] = ACTIONS(5441),
    [anon_sym_LBRACK] = ACTIONS(5441),
    [anon_sym_RBRACK] = ACTIONS(5441),
    [anon_sym_EQ] = ACTIONS(5439),
    [anon_sym_COLON] = ACTIONS(5441),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_STAR_EQ] = ACTIONS(5441),
    [anon_sym_SLASH_EQ] = ACTIONS(5441),
    [anon_sym_PERCENT_EQ] = ACTIONS(5441),
    [anon_sym_PLUS_EQ] = ACTIONS(5441),
    [anon_sym_DASH_EQ] = ACTIONS(5441),
    [anon_sym_LT_LT_EQ] = ACTIONS(5441),
    [anon_sym_GT_GT_EQ] = ACTIONS(5441),
    [anon_sym_AMP_EQ] = ACTIONS(5441),
    [anon_sym_CARET_EQ] = ACTIONS(5441),
    [anon_sym_PIPE_EQ] = ACTIONS(5441),
    [anon_sym_and_eq] = ACTIONS(5439),
    [anon_sym_or_eq] = ACTIONS(5439),
    [anon_sym_xor_eq] = ACTIONS(5439),
    [anon_sym_LT_EQ_GT] = ACTIONS(5441),
    [anon_sym_or] = ACTIONS(5439),
    [anon_sym_and] = ACTIONS(5439),
    [anon_sym_bitor] = ACTIONS(5439),
    [anon_sym_xor] = ACTIONS(5439),
    [anon_sym_bitand] = ACTIONS(5439),
    [anon_sym_not_eq] = ACTIONS(5439),
    [anon_sym_DASH_DASH] = ACTIONS(5441),
    [anon_sym_PLUS_PLUS] = ACTIONS(5441),
    [anon_sym_DOT] = ACTIONS(5439),
    [anon_sym_DOT_STAR] = ACTIONS(5441),
    [anon_sym_DASH_GT] = ACTIONS(5441),
    [anon_sym_L_DQUOTE] = ACTIONS(5441),
    [anon_sym_u_DQUOTE] = ACTIONS(5441),
    [anon_sym_U_DQUOTE] = ACTIONS(5441),
    [anon_sym_u8_DQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5441),
    [anon_sym_LR_DQUOTE] = ACTIONS(5441),
    [anon_sym_uR_DQUOTE] = ACTIONS(5441),
    [anon_sym_UR_DQUOTE] = ACTIONS(5441),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5441),
    [sym_literal_suffix] = ACTIONS(5439),
  },
  [2107] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5148),
    [anon_sym_COMMA] = ACTIONS(5148),
    [anon_sym_LPAREN2] = ACTIONS(5148),
    [anon_sym_DASH] = ACTIONS(5146),
    [anon_sym_PLUS] = ACTIONS(5146),
    [anon_sym_STAR] = ACTIONS(5146),
    [anon_sym_SLASH] = ACTIONS(5146),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [anon_sym_PIPE_PIPE] = ACTIONS(5148),
    [anon_sym_AMP_AMP] = ACTIONS(5148),
    [anon_sym_PIPE] = ACTIONS(5146),
    [anon_sym_CARET] = ACTIONS(5146),
    [anon_sym_AMP] = ACTIONS(5146),
    [anon_sym_EQ_EQ] = ACTIONS(5148),
    [anon_sym_BANG_EQ] = ACTIONS(5148),
    [anon_sym_GT] = ACTIONS(5146),
    [anon_sym_GT_EQ] = ACTIONS(5146),
    [anon_sym_LT_EQ] = ACTIONS(5146),
    [anon_sym_LT] = ACTIONS(5146),
    [anon_sym_LT_LT] = ACTIONS(5146),
    [anon_sym_GT_GT] = ACTIONS(5146),
    [anon_sym___extension__] = ACTIONS(5148),
    [anon_sym___attribute__] = ACTIONS(5148),
    [anon_sym_COLON_COLON] = ACTIONS(5148),
    [anon_sym_LBRACE] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5148),
    [anon_sym_EQ] = ACTIONS(5146),
    [anon_sym_const] = ACTIONS(5146),
    [anon_sym_constexpr] = ACTIONS(5148),
    [anon_sym_volatile] = ACTIONS(5148),
    [anon_sym_restrict] = ACTIONS(5148),
    [anon_sym___restrict__] = ACTIONS(5148),
    [anon_sym__Atomic] = ACTIONS(5148),
    [anon_sym__Noreturn] = ACTIONS(5148),
    [anon_sym_noreturn] = ACTIONS(5148),
    [anon_sym_mutable] = ACTIONS(5148),
    [anon_sym_constinit] = ACTIONS(5148),
    [anon_sym_consteval] = ACTIONS(5148),
    [anon_sym_PROGMEM] = ACTIONS(5148),
    [anon_sym_COLON] = ACTIONS(5146),
    [anon_sym_QMARK] = ACTIONS(5148),
    [anon_sym_STAR_EQ] = ACTIONS(5148),
    [anon_sym_SLASH_EQ] = ACTIONS(5148),
    [anon_sym_PERCENT_EQ] = ACTIONS(5148),
    [anon_sym_PLUS_EQ] = ACTIONS(5148),
    [anon_sym_DASH_EQ] = ACTIONS(5148),
    [anon_sym_LT_LT_EQ] = ACTIONS(5148),
    [anon_sym_GT_GT_EQ] = ACTIONS(5146),
    [anon_sym_AMP_EQ] = ACTIONS(5148),
    [anon_sym_CARET_EQ] = ACTIONS(5148),
    [anon_sym_PIPE_EQ] = ACTIONS(5148),
    [anon_sym_and_eq] = ACTIONS(5148),
    [anon_sym_or_eq] = ACTIONS(5148),
    [anon_sym_xor_eq] = ACTIONS(5148),
    [anon_sym_LT_EQ_GT] = ACTIONS(5148),
    [anon_sym_or] = ACTIONS(5146),
    [anon_sym_and] = ACTIONS(5146),
    [anon_sym_bitor] = ACTIONS(5148),
    [anon_sym_xor] = ACTIONS(5146),
    [anon_sym_bitand] = ACTIONS(5148),
    [anon_sym_not_eq] = ACTIONS(5148),
    [anon_sym_DASH_DASH] = ACTIONS(5148),
    [anon_sym_PLUS_PLUS] = ACTIONS(5148),
    [anon_sym_DOT] = ACTIONS(5146),
    [anon_sym_DOT_STAR] = ACTIONS(5148),
    [anon_sym_DASH_GT] = ACTIONS(5148),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5148),
    [anon_sym_decltype] = ACTIONS(5148),
    [anon_sym_final] = ACTIONS(5148),
    [anon_sym_override] = ACTIONS(5148),
    [anon_sym_GT2] = ACTIONS(5148),
  },
  [2108] = {
    [sym_identifier] = ACTIONS(2887),
    [aux_sym_preproc_def_token1] = ACTIONS(2887),
    [aux_sym_preproc_if_token1] = ACTIONS(2887),
    [aux_sym_preproc_if_token2] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2887),
    [aux_sym_preproc_else_token1] = ACTIONS(2887),
    [aux_sym_preproc_elif_token1] = ACTIONS(2887),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2887),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2887),
    [sym_preproc_directive] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2889),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym___extension__] = ACTIONS(2887),
    [anon_sym_typedef] = ACTIONS(2887),
    [anon_sym_extern] = ACTIONS(2887),
    [anon_sym___attribute__] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2889),
    [anon_sym___declspec] = ACTIONS(2887),
    [anon_sym___based] = ACTIONS(2887),
    [anon_sym_signed] = ACTIONS(2887),
    [anon_sym_unsigned] = ACTIONS(2887),
    [anon_sym_long] = ACTIONS(2887),
    [anon_sym_short] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_static] = ACTIONS(2887),
    [anon_sym_register] = ACTIONS(2887),
    [anon_sym_inline] = ACTIONS(2887),
    [anon_sym___inline] = ACTIONS(2887),
    [anon_sym___inline__] = ACTIONS(2887),
    [anon_sym___forceinline] = ACTIONS(2887),
    [anon_sym_thread_local] = ACTIONS(2887),
    [anon_sym___thread] = ACTIONS(2887),
    [anon_sym_const] = ACTIONS(2887),
    [anon_sym_constexpr] = ACTIONS(2887),
    [anon_sym_volatile] = ACTIONS(2887),
    [anon_sym_restrict] = ACTIONS(2887),
    [anon_sym___restrict__] = ACTIONS(2887),
    [anon_sym__Atomic] = ACTIONS(2887),
    [anon_sym__Noreturn] = ACTIONS(2887),
    [anon_sym_noreturn] = ACTIONS(2887),
    [anon_sym_mutable] = ACTIONS(2887),
    [anon_sym_constinit] = ACTIONS(2887),
    [anon_sym_consteval] = ACTIONS(2887),
    [anon_sym_PROGMEM] = ACTIONS(2887),
    [aux_sym_primitive_type_token1] = ACTIONS(2887),
    [anon_sym_byte] = ACTIONS(2887),
    [anon_sym_word] = ACTIONS(2887),
    [anon_sym_enum] = ACTIONS(2887),
    [anon_sym_class] = ACTIONS(2887),
    [anon_sym_struct] = ACTIONS(2887),
    [anon_sym_union] = ACTIONS(2887),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2887),
    [anon_sym_decltype] = ACTIONS(2887),
    [anon_sym_virtual] = ACTIONS(2887),
    [anon_sym_alignas] = ACTIONS(2887),
    [anon_sym_explicit] = ACTIONS(2887),
    [anon_sym_typename] = ACTIONS(2887),
    [anon_sym_template] = ACTIONS(2887),
    [anon_sym_operator] = ACTIONS(2887),
    [anon_sym_friend] = ACTIONS(2887),
    [anon_sym_public] = ACTIONS(2887),
    [anon_sym_private] = ACTIONS(2887),
    [anon_sym_protected] = ACTIONS(2887),
    [anon_sym_using] = ACTIONS(2887),
    [anon_sym_static_assert] = ACTIONS(2887),
    [anon_sym_catch] = ACTIONS(2887),
  },
  [2109] = {
    [sym_identifier] = ACTIONS(5443),
    [aux_sym_preproc_def_token1] = ACTIONS(5443),
    [aux_sym_preproc_if_token1] = ACTIONS(5443),
    [aux_sym_preproc_if_token2] = ACTIONS(5443),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5443),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5443),
    [aux_sym_preproc_else_token1] = ACTIONS(5443),
    [aux_sym_preproc_elif_token1] = ACTIONS(5443),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5443),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5443),
    [sym_preproc_directive] = ACTIONS(5443),
    [anon_sym_LPAREN2] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_STAR] = ACTIONS(5445),
    [anon_sym_AMP_AMP] = ACTIONS(5445),
    [anon_sym_AMP] = ACTIONS(5443),
    [anon_sym___extension__] = ACTIONS(5443),
    [anon_sym_typedef] = ACTIONS(5443),
    [anon_sym_extern] = ACTIONS(5443),
    [anon_sym___attribute__] = ACTIONS(5443),
    [anon_sym_COLON_COLON] = ACTIONS(5445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5445),
    [anon_sym___declspec] = ACTIONS(5443),
    [anon_sym___based] = ACTIONS(5443),
    [anon_sym_signed] = ACTIONS(5443),
    [anon_sym_unsigned] = ACTIONS(5443),
    [anon_sym_long] = ACTIONS(5443),
    [anon_sym_short] = ACTIONS(5443),
    [anon_sym_LBRACK] = ACTIONS(5443),
    [anon_sym_static] = ACTIONS(5443),
    [anon_sym_register] = ACTIONS(5443),
    [anon_sym_inline] = ACTIONS(5443),
    [anon_sym___inline] = ACTIONS(5443),
    [anon_sym___inline__] = ACTIONS(5443),
    [anon_sym___forceinline] = ACTIONS(5443),
    [anon_sym_thread_local] = ACTIONS(5443),
    [anon_sym___thread] = ACTIONS(5443),
    [anon_sym_const] = ACTIONS(5443),
    [anon_sym_constexpr] = ACTIONS(5443),
    [anon_sym_volatile] = ACTIONS(5443),
    [anon_sym_restrict] = ACTIONS(5443),
    [anon_sym___restrict__] = ACTIONS(5443),
    [anon_sym__Atomic] = ACTIONS(5443),
    [anon_sym__Noreturn] = ACTIONS(5443),
    [anon_sym_noreturn] = ACTIONS(5443),
    [anon_sym_mutable] = ACTIONS(5443),
    [anon_sym_constinit] = ACTIONS(5443),
    [anon_sym_consteval] = ACTIONS(5443),
    [anon_sym_PROGMEM] = ACTIONS(5443),
    [aux_sym_primitive_type_token1] = ACTIONS(5443),
    [anon_sym_byte] = ACTIONS(5443),
    [anon_sym_word] = ACTIONS(5443),
    [anon_sym_enum] = ACTIONS(5443),
    [anon_sym_class] = ACTIONS(5443),
    [anon_sym_struct] = ACTIONS(5443),
    [anon_sym_union] = ACTIONS(5443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5443),
    [anon_sym_decltype] = ACTIONS(5443),
    [anon_sym_virtual] = ACTIONS(5443),
    [anon_sym_alignas] = ACTIONS(5443),
    [anon_sym_explicit] = ACTIONS(5443),
    [anon_sym_typename] = ACTIONS(5443),
    [anon_sym_template] = ACTIONS(5443),
    [anon_sym_operator] = ACTIONS(5443),
    [anon_sym_friend] = ACTIONS(5443),
    [anon_sym_public] = ACTIONS(5443),
    [anon_sym_private] = ACTIONS(5443),
    [anon_sym_protected] = ACTIONS(5443),
    [anon_sym_using] = ACTIONS(5443),
    [anon_sym_static_assert] = ACTIONS(5443),
  },
  [2110] = {
    [sym_identifier] = ACTIONS(2970),
    [aux_sym_preproc_def_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token2] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2970),
    [aux_sym_preproc_else_token1] = ACTIONS(2970),
    [aux_sym_preproc_elif_token1] = ACTIONS(2970),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2970),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2970),
    [sym_preproc_directive] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym___extension__] = ACTIONS(2970),
    [anon_sym_typedef] = ACTIONS(2970),
    [anon_sym_extern] = ACTIONS(2970),
    [anon_sym___attribute__] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2970),
    [anon_sym___based] = ACTIONS(2970),
    [anon_sym_signed] = ACTIONS(2970),
    [anon_sym_unsigned] = ACTIONS(2970),
    [anon_sym_long] = ACTIONS(2970),
    [anon_sym_short] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_register] = ACTIONS(2970),
    [anon_sym_inline] = ACTIONS(2970),
    [anon_sym___inline] = ACTIONS(2970),
    [anon_sym___inline__] = ACTIONS(2970),
    [anon_sym___forceinline] = ACTIONS(2970),
    [anon_sym_thread_local] = ACTIONS(2970),
    [anon_sym___thread] = ACTIONS(2970),
    [anon_sym_const] = ACTIONS(2970),
    [anon_sym_constexpr] = ACTIONS(2970),
    [anon_sym_volatile] = ACTIONS(2970),
    [anon_sym_restrict] = ACTIONS(2970),
    [anon_sym___restrict__] = ACTIONS(2970),
    [anon_sym__Atomic] = ACTIONS(2970),
    [anon_sym__Noreturn] = ACTIONS(2970),
    [anon_sym_noreturn] = ACTIONS(2970),
    [anon_sym_mutable] = ACTIONS(2970),
    [anon_sym_constinit] = ACTIONS(2970),
    [anon_sym_consteval] = ACTIONS(2970),
    [anon_sym_PROGMEM] = ACTIONS(2970),
    [aux_sym_primitive_type_token1] = ACTIONS(2970),
    [anon_sym_byte] = ACTIONS(2970),
    [anon_sym_word] = ACTIONS(2970),
    [anon_sym_enum] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_struct] = ACTIONS(2970),
    [anon_sym_union] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2970),
    [anon_sym_decltype] = ACTIONS(2970),
    [anon_sym_virtual] = ACTIONS(2970),
    [anon_sym_alignas] = ACTIONS(2970),
    [anon_sym_explicit] = ACTIONS(2970),
    [anon_sym_typename] = ACTIONS(2970),
    [anon_sym_template] = ACTIONS(2970),
    [anon_sym_operator] = ACTIONS(2970),
    [anon_sym_friend] = ACTIONS(2970),
    [anon_sym_public] = ACTIONS(2970),
    [anon_sym_private] = ACTIONS(2970),
    [anon_sym_protected] = ACTIONS(2970),
    [anon_sym_using] = ACTIONS(2970),
    [anon_sym_static_assert] = ACTIONS(2970),
  },
  [2111] = {
    [sym_identifier] = ACTIONS(3086),
    [aux_sym_preproc_def_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token2] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3086),
    [aux_sym_preproc_else_token1] = ACTIONS(3086),
    [aux_sym_preproc_elif_token1] = ACTIONS(3086),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3086),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3086),
    [sym_preproc_directive] = ACTIONS(3086),
    [anon_sym_LPAREN2] = ACTIONS(3088),
    [anon_sym_TILDE] = ACTIONS(3088),
    [anon_sym_STAR] = ACTIONS(3088),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym___extension__] = ACTIONS(3086),
    [anon_sym_typedef] = ACTIONS(3086),
    [anon_sym_extern] = ACTIONS(3086),
    [anon_sym___attribute__] = ACTIONS(3086),
    [anon_sym_COLON_COLON] = ACTIONS(3088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3088),
    [anon_sym___declspec] = ACTIONS(3086),
    [anon_sym___based] = ACTIONS(3086),
    [anon_sym_signed] = ACTIONS(3086),
    [anon_sym_unsigned] = ACTIONS(3086),
    [anon_sym_long] = ACTIONS(3086),
    [anon_sym_short] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(3086),
    [anon_sym_static] = ACTIONS(3086),
    [anon_sym_register] = ACTIONS(3086),
    [anon_sym_inline] = ACTIONS(3086),
    [anon_sym___inline] = ACTIONS(3086),
    [anon_sym___inline__] = ACTIONS(3086),
    [anon_sym___forceinline] = ACTIONS(3086),
    [anon_sym_thread_local] = ACTIONS(3086),
    [anon_sym___thread] = ACTIONS(3086),
    [anon_sym_const] = ACTIONS(3086),
    [anon_sym_constexpr] = ACTIONS(3086),
    [anon_sym_volatile] = ACTIONS(3086),
    [anon_sym_restrict] = ACTIONS(3086),
    [anon_sym___restrict__] = ACTIONS(3086),
    [anon_sym__Atomic] = ACTIONS(3086),
    [anon_sym__Noreturn] = ACTIONS(3086),
    [anon_sym_noreturn] = ACTIONS(3086),
    [anon_sym_mutable] = ACTIONS(3086),
    [anon_sym_constinit] = ACTIONS(3086),
    [anon_sym_consteval] = ACTIONS(3086),
    [anon_sym_PROGMEM] = ACTIONS(3086),
    [aux_sym_primitive_type_token1] = ACTIONS(3086),
    [anon_sym_byte] = ACTIONS(3086),
    [anon_sym_word] = ACTIONS(3086),
    [anon_sym_enum] = ACTIONS(3086),
    [anon_sym_class] = ACTIONS(3086),
    [anon_sym_struct] = ACTIONS(3086),
    [anon_sym_union] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3086),
    [anon_sym_decltype] = ACTIONS(3086),
    [anon_sym_virtual] = ACTIONS(3086),
    [anon_sym_alignas] = ACTIONS(3086),
    [anon_sym_explicit] = ACTIONS(3086),
    [anon_sym_typename] = ACTIONS(3086),
    [anon_sym_template] = ACTIONS(3086),
    [anon_sym_operator] = ACTIONS(3086),
    [anon_sym_friend] = ACTIONS(3086),
    [anon_sym_public] = ACTIONS(3086),
    [anon_sym_private] = ACTIONS(3086),
    [anon_sym_protected] = ACTIONS(3086),
    [anon_sym_using] = ACTIONS(3086),
    [anon_sym_static_assert] = ACTIONS(3086),
  },
  [2112] = {
    [sym_identifier] = ACTIONS(3517),
    [aux_sym_preproc_def_token1] = ACTIONS(3517),
    [aux_sym_preproc_if_token1] = ACTIONS(3517),
    [aux_sym_preproc_if_token2] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3517),
    [aux_sym_preproc_else_token1] = ACTIONS(3517),
    [aux_sym_preproc_elif_token1] = ACTIONS(3517),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3517),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3517),
    [sym_preproc_directive] = ACTIONS(3517),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym___extension__] = ACTIONS(3517),
    [anon_sym_typedef] = ACTIONS(3517),
    [anon_sym_extern] = ACTIONS(3517),
    [anon_sym___attribute__] = ACTIONS(3517),
    [anon_sym_COLON_COLON] = ACTIONS(3519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3519),
    [anon_sym___declspec] = ACTIONS(3517),
    [anon_sym___based] = ACTIONS(3517),
    [anon_sym_signed] = ACTIONS(3517),
    [anon_sym_unsigned] = ACTIONS(3517),
    [anon_sym_long] = ACTIONS(3517),
    [anon_sym_short] = ACTIONS(3517),
    [anon_sym_LBRACK] = ACTIONS(3517),
    [anon_sym_static] = ACTIONS(3517),
    [anon_sym_register] = ACTIONS(3517),
    [anon_sym_inline] = ACTIONS(3517),
    [anon_sym___inline] = ACTIONS(3517),
    [anon_sym___inline__] = ACTIONS(3517),
    [anon_sym___forceinline] = ACTIONS(3517),
    [anon_sym_thread_local] = ACTIONS(3517),
    [anon_sym___thread] = ACTIONS(3517),
    [anon_sym_const] = ACTIONS(3517),
    [anon_sym_constexpr] = ACTIONS(3517),
    [anon_sym_volatile] = ACTIONS(3517),
    [anon_sym_restrict] = ACTIONS(3517),
    [anon_sym___restrict__] = ACTIONS(3517),
    [anon_sym__Atomic] = ACTIONS(3517),
    [anon_sym__Noreturn] = ACTIONS(3517),
    [anon_sym_noreturn] = ACTIONS(3517),
    [anon_sym_mutable] = ACTIONS(3517),
    [anon_sym_constinit] = ACTIONS(3517),
    [anon_sym_consteval] = ACTIONS(3517),
    [anon_sym_PROGMEM] = ACTIONS(3517),
    [aux_sym_primitive_type_token1] = ACTIONS(3517),
    [anon_sym_byte] = ACTIONS(3517),
    [anon_sym_word] = ACTIONS(3517),
    [anon_sym_enum] = ACTIONS(3517),
    [anon_sym_class] = ACTIONS(3517),
    [anon_sym_struct] = ACTIONS(3517),
    [anon_sym_union] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3517),
    [anon_sym_decltype] = ACTIONS(3517),
    [anon_sym_virtual] = ACTIONS(3517),
    [anon_sym_alignas] = ACTIONS(3517),
    [anon_sym_explicit] = ACTIONS(3517),
    [anon_sym_typename] = ACTIONS(3517),
    [anon_sym_template] = ACTIONS(3517),
    [anon_sym_operator] = ACTIONS(3517),
    [anon_sym_friend] = ACTIONS(3517),
    [anon_sym_public] = ACTIONS(3517),
    [anon_sym_private] = ACTIONS(3517),
    [anon_sym_protected] = ACTIONS(3517),
    [anon_sym_using] = ACTIONS(3517),
    [anon_sym_static_assert] = ACTIONS(3517),
  },
  [2113] = {
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5542),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5204),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2114] = {
    [sym_identifier] = ACTIONS(3869),
    [aux_sym_preproc_def_token1] = ACTIONS(3869),
    [aux_sym_preproc_if_token1] = ACTIONS(3869),
    [aux_sym_preproc_if_token2] = ACTIONS(3869),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3869),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3869),
    [aux_sym_preproc_else_token1] = ACTIONS(3869),
    [aux_sym_preproc_elif_token1] = ACTIONS(3869),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3869),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3869),
    [sym_preproc_directive] = ACTIONS(3869),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3867),
    [anon_sym_STAR] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_AMP] = ACTIONS(3869),
    [anon_sym___extension__] = ACTIONS(3869),
    [anon_sym_typedef] = ACTIONS(3869),
    [anon_sym_extern] = ACTIONS(3869),
    [anon_sym___attribute__] = ACTIONS(3869),
    [anon_sym_COLON_COLON] = ACTIONS(3867),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3867),
    [anon_sym___declspec] = ACTIONS(3869),
    [anon_sym___based] = ACTIONS(3869),
    [anon_sym_signed] = ACTIONS(3869),
    [anon_sym_unsigned] = ACTIONS(3869),
    [anon_sym_long] = ACTIONS(3869),
    [anon_sym_short] = ACTIONS(3869),
    [anon_sym_LBRACK] = ACTIONS(3869),
    [anon_sym_static] = ACTIONS(3869),
    [anon_sym_register] = ACTIONS(3869),
    [anon_sym_inline] = ACTIONS(3869),
    [anon_sym___inline] = ACTIONS(3869),
    [anon_sym___inline__] = ACTIONS(3869),
    [anon_sym___forceinline] = ACTIONS(3869),
    [anon_sym_thread_local] = ACTIONS(3869),
    [anon_sym___thread] = ACTIONS(3869),
    [anon_sym_const] = ACTIONS(3869),
    [anon_sym_constexpr] = ACTIONS(3869),
    [anon_sym_volatile] = ACTIONS(3869),
    [anon_sym_restrict] = ACTIONS(3869),
    [anon_sym___restrict__] = ACTIONS(3869),
    [anon_sym__Atomic] = ACTIONS(3869),
    [anon_sym__Noreturn] = ACTIONS(3869),
    [anon_sym_noreturn] = ACTIONS(3869),
    [anon_sym_mutable] = ACTIONS(3869),
    [anon_sym_constinit] = ACTIONS(3869),
    [anon_sym_consteval] = ACTIONS(3869),
    [anon_sym_PROGMEM] = ACTIONS(3869),
    [aux_sym_primitive_type_token1] = ACTIONS(3869),
    [anon_sym_byte] = ACTIONS(3869),
    [anon_sym_word] = ACTIONS(3869),
    [anon_sym_enum] = ACTIONS(3869),
    [anon_sym_class] = ACTIONS(3869),
    [anon_sym_struct] = ACTIONS(3869),
    [anon_sym_union] = ACTIONS(3869),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3869),
    [anon_sym_decltype] = ACTIONS(3869),
    [anon_sym_virtual] = ACTIONS(3869),
    [anon_sym_alignas] = ACTIONS(3869),
    [anon_sym_explicit] = ACTIONS(3869),
    [anon_sym_typename] = ACTIONS(3869),
    [anon_sym_template] = ACTIONS(3869),
    [anon_sym_operator] = ACTIONS(3869),
    [anon_sym_friend] = ACTIONS(3869),
    [anon_sym_public] = ACTIONS(3869),
    [anon_sym_private] = ACTIONS(3869),
    [anon_sym_protected] = ACTIONS(3869),
    [anon_sym_using] = ACTIONS(3869),
    [anon_sym_static_assert] = ACTIONS(3869),
  },
  [2115] = {
    [sym_identifier] = ACTIONS(3521),
    [aux_sym_preproc_def_token1] = ACTIONS(3521),
    [aux_sym_preproc_if_token1] = ACTIONS(3521),
    [aux_sym_preproc_if_token2] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3521),
    [aux_sym_preproc_else_token1] = ACTIONS(3521),
    [aux_sym_preproc_elif_token1] = ACTIONS(3521),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3521),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3521),
    [sym_preproc_directive] = ACTIONS(3521),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3521),
    [anon_sym___extension__] = ACTIONS(3521),
    [anon_sym_typedef] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym___attribute__] = ACTIONS(3521),
    [anon_sym_COLON_COLON] = ACTIONS(3523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3523),
    [anon_sym___declspec] = ACTIONS(3521),
    [anon_sym___based] = ACTIONS(3521),
    [anon_sym_signed] = ACTIONS(3521),
    [anon_sym_unsigned] = ACTIONS(3521),
    [anon_sym_long] = ACTIONS(3521),
    [anon_sym_short] = ACTIONS(3521),
    [anon_sym_LBRACK] = ACTIONS(3521),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_register] = ACTIONS(3521),
    [anon_sym_inline] = ACTIONS(3521),
    [anon_sym___inline] = ACTIONS(3521),
    [anon_sym___inline__] = ACTIONS(3521),
    [anon_sym___forceinline] = ACTIONS(3521),
    [anon_sym_thread_local] = ACTIONS(3521),
    [anon_sym___thread] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_constexpr] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym_restrict] = ACTIONS(3521),
    [anon_sym___restrict__] = ACTIONS(3521),
    [anon_sym__Atomic] = ACTIONS(3521),
    [anon_sym__Noreturn] = ACTIONS(3521),
    [anon_sym_noreturn] = ACTIONS(3521),
    [anon_sym_mutable] = ACTIONS(3521),
    [anon_sym_constinit] = ACTIONS(3521),
    [anon_sym_consteval] = ACTIONS(3521),
    [anon_sym_PROGMEM] = ACTIONS(3521),
    [aux_sym_primitive_type_token1] = ACTIONS(3521),
    [anon_sym_byte] = ACTIONS(3521),
    [anon_sym_word] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_class] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_union] = ACTIONS(3521),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3521),
    [anon_sym_decltype] = ACTIONS(3521),
    [anon_sym_virtual] = ACTIONS(3521),
    [anon_sym_alignas] = ACTIONS(3521),
    [anon_sym_explicit] = ACTIONS(3521),
    [anon_sym_typename] = ACTIONS(3521),
    [anon_sym_template] = ACTIONS(3521),
    [anon_sym_operator] = ACTIONS(3521),
    [anon_sym_friend] = ACTIONS(3521),
    [anon_sym_public] = ACTIONS(3521),
    [anon_sym_private] = ACTIONS(3521),
    [anon_sym_protected] = ACTIONS(3521),
    [anon_sym_using] = ACTIONS(3521),
    [anon_sym_static_assert] = ACTIONS(3521),
  },
  [2116] = {
    [sym__declaration_modifiers] = STATE(4180),
    [sym_attribute_specifier] = STATE(4180),
    [sym_attribute_declaration] = STATE(4180),
    [sym_ms_declspec_modifier] = STATE(4180),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7134),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(4180),
    [sym_type_qualifier] = STATE(4180),
    [sym_decltype] = STATE(9504),
    [sym_virtual] = STATE(4180),
    [sym_alignas_specifier] = STATE(4180),
    [sym_explicit_function_specifier] = STATE(4180),
    [sym_operator_cast] = STATE(7531),
    [sym__constructor_specifiers] = STATE(4180),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(9504),
    [sym_template_function] = STATE(7008),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6421),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_operator_cast_identifier] = STATE(7531),
    [sym_operator_name] = STATE(7008),
    [aux_sym_operator_cast_definition_repeat1] = STATE(4180),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(5449),
    [anon_sym_extern] = ACTIONS(5451),
    [anon_sym___attribute__] = ACTIONS(5453),
    [anon_sym_COLON_COLON] = ACTIONS(5455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5457),
    [anon_sym___declspec] = ACTIONS(5459),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(5451),
    [anon_sym_register] = ACTIONS(5451),
    [anon_sym_inline] = ACTIONS(5451),
    [anon_sym___inline] = ACTIONS(5451),
    [anon_sym___inline__] = ACTIONS(5451),
    [anon_sym___forceinline] = ACTIONS(5451),
    [anon_sym_thread_local] = ACTIONS(5451),
    [anon_sym___thread] = ACTIONS(5451),
    [anon_sym_const] = ACTIONS(5449),
    [anon_sym_constexpr] = ACTIONS(5449),
    [anon_sym_volatile] = ACTIONS(5449),
    [anon_sym_restrict] = ACTIONS(5449),
    [anon_sym___restrict__] = ACTIONS(5449),
    [anon_sym__Atomic] = ACTIONS(5449),
    [anon_sym__Noreturn] = ACTIONS(5449),
    [anon_sym_noreturn] = ACTIONS(5449),
    [anon_sym_mutable] = ACTIONS(5449),
    [anon_sym_constinit] = ACTIONS(5449),
    [anon_sym_consteval] = ACTIONS(5449),
    [anon_sym_PROGMEM] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_virtual] = ACTIONS(5461),
    [anon_sym_alignas] = ACTIONS(5463),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(133),
  },
  [2117] = {
    [sym_identifier] = ACTIONS(3134),
    [aux_sym_preproc_def_token1] = ACTIONS(3134),
    [aux_sym_preproc_if_token1] = ACTIONS(3134),
    [aux_sym_preproc_if_token2] = ACTIONS(3134),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3134),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3134),
    [aux_sym_preproc_else_token1] = ACTIONS(3134),
    [aux_sym_preproc_elif_token1] = ACTIONS(3134),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3134),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3134),
    [sym_preproc_directive] = ACTIONS(3134),
    [anon_sym_LPAREN2] = ACTIONS(3136),
    [anon_sym_TILDE] = ACTIONS(3136),
    [anon_sym_STAR] = ACTIONS(3136),
    [anon_sym_AMP_AMP] = ACTIONS(3136),
    [anon_sym_AMP] = ACTIONS(3134),
    [anon_sym___extension__] = ACTIONS(3134),
    [anon_sym_typedef] = ACTIONS(3134),
    [anon_sym_extern] = ACTIONS(3134),
    [anon_sym___attribute__] = ACTIONS(3134),
    [anon_sym_COLON_COLON] = ACTIONS(3136),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3136),
    [anon_sym___declspec] = ACTIONS(3134),
    [anon_sym___based] = ACTIONS(3134),
    [anon_sym_signed] = ACTIONS(3134),
    [anon_sym_unsigned] = ACTIONS(3134),
    [anon_sym_long] = ACTIONS(3134),
    [anon_sym_short] = ACTIONS(3134),
    [anon_sym_LBRACK] = ACTIONS(3134),
    [anon_sym_static] = ACTIONS(3134),
    [anon_sym_register] = ACTIONS(3134),
    [anon_sym_inline] = ACTIONS(3134),
    [anon_sym___inline] = ACTIONS(3134),
    [anon_sym___inline__] = ACTIONS(3134),
    [anon_sym___forceinline] = ACTIONS(3134),
    [anon_sym_thread_local] = ACTIONS(3134),
    [anon_sym___thread] = ACTIONS(3134),
    [anon_sym_const] = ACTIONS(3134),
    [anon_sym_constexpr] = ACTIONS(3134),
    [anon_sym_volatile] = ACTIONS(3134),
    [anon_sym_restrict] = ACTIONS(3134),
    [anon_sym___restrict__] = ACTIONS(3134),
    [anon_sym__Atomic] = ACTIONS(3134),
    [anon_sym__Noreturn] = ACTIONS(3134),
    [anon_sym_noreturn] = ACTIONS(3134),
    [anon_sym_mutable] = ACTIONS(3134),
    [anon_sym_constinit] = ACTIONS(3134),
    [anon_sym_consteval] = ACTIONS(3134),
    [anon_sym_PROGMEM] = ACTIONS(3134),
    [aux_sym_primitive_type_token1] = ACTIONS(3134),
    [anon_sym_byte] = ACTIONS(3134),
    [anon_sym_word] = ACTIONS(3134),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3134),
    [anon_sym_struct] = ACTIONS(3134),
    [anon_sym_union] = ACTIONS(3134),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3134),
    [anon_sym_decltype] = ACTIONS(3134),
    [anon_sym_virtual] = ACTIONS(3134),
    [anon_sym_alignas] = ACTIONS(3134),
    [anon_sym_explicit] = ACTIONS(3134),
    [anon_sym_typename] = ACTIONS(3134),
    [anon_sym_template] = ACTIONS(3134),
    [anon_sym_operator] = ACTIONS(3134),
    [anon_sym_friend] = ACTIONS(3134),
    [anon_sym_public] = ACTIONS(3134),
    [anon_sym_private] = ACTIONS(3134),
    [anon_sym_protected] = ACTIONS(3134),
    [anon_sym_using] = ACTIONS(3134),
    [anon_sym_static_assert] = ACTIONS(3134),
  },
  [2118] = {
    [sym_identifier] = ACTIONS(5465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5467),
    [anon_sym_COMMA] = ACTIONS(5467),
    [anon_sym_RPAREN] = ACTIONS(5467),
    [anon_sym_LPAREN2] = ACTIONS(5467),
    [anon_sym_DASH] = ACTIONS(5465),
    [anon_sym_PLUS] = ACTIONS(5465),
    [anon_sym_STAR] = ACTIONS(5467),
    [anon_sym_SLASH] = ACTIONS(5465),
    [anon_sym_PERCENT] = ACTIONS(5467),
    [anon_sym_PIPE_PIPE] = ACTIONS(5467),
    [anon_sym_AMP_AMP] = ACTIONS(5467),
    [anon_sym_PIPE] = ACTIONS(5465),
    [anon_sym_CARET] = ACTIONS(5467),
    [anon_sym_AMP] = ACTIONS(5465),
    [anon_sym_EQ_EQ] = ACTIONS(5467),
    [anon_sym_BANG_EQ] = ACTIONS(5467),
    [anon_sym_GT] = ACTIONS(5465),
    [anon_sym_GT_EQ] = ACTIONS(5467),
    [anon_sym_LT_EQ] = ACTIONS(5465),
    [anon_sym_LT] = ACTIONS(5465),
    [anon_sym_LT_LT] = ACTIONS(5467),
    [anon_sym_GT_GT] = ACTIONS(5467),
    [anon_sym_SEMI] = ACTIONS(5467),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym___attribute__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym___based] = ACTIONS(5465),
    [anon_sym_LBRACE] = ACTIONS(5467),
    [anon_sym_RBRACE] = ACTIONS(5467),
    [anon_sym_signed] = ACTIONS(5465),
    [anon_sym_unsigned] = ACTIONS(5465),
    [anon_sym_long] = ACTIONS(5465),
    [anon_sym_short] = ACTIONS(5465),
    [anon_sym_LBRACK] = ACTIONS(5467),
    [anon_sym_RBRACK] = ACTIONS(5467),
    [anon_sym_const] = ACTIONS(5465),
    [anon_sym_constexpr] = ACTIONS(5465),
    [anon_sym_volatile] = ACTIONS(5465),
    [anon_sym_restrict] = ACTIONS(5465),
    [anon_sym___restrict__] = ACTIONS(5465),
    [anon_sym__Atomic] = ACTIONS(5465),
    [anon_sym__Noreturn] = ACTIONS(5465),
    [anon_sym_noreturn] = ACTIONS(5465),
    [anon_sym_mutable] = ACTIONS(5465),
    [anon_sym_constinit] = ACTIONS(5465),
    [anon_sym_consteval] = ACTIONS(5465),
    [anon_sym_PROGMEM] = ACTIONS(5465),
    [aux_sym_primitive_type_token1] = ACTIONS(5465),
    [anon_sym_byte] = ACTIONS(5465),
    [anon_sym_word] = ACTIONS(5465),
    [anon_sym_COLON] = ACTIONS(5465),
    [anon_sym_QMARK] = ACTIONS(5467),
    [anon_sym_LT_EQ_GT] = ACTIONS(5467),
    [anon_sym_or] = ACTIONS(5465),
    [anon_sym_and] = ACTIONS(5465),
    [anon_sym_bitor] = ACTIONS(5465),
    [anon_sym_xor] = ACTIONS(5465),
    [anon_sym_bitand] = ACTIONS(5465),
    [anon_sym_not_eq] = ACTIONS(5465),
    [anon_sym_DASH_DASH] = ACTIONS(5467),
    [anon_sym_PLUS_PLUS] = ACTIONS(5467),
    [anon_sym_DOT] = ACTIONS(5465),
    [anon_sym_DOT_STAR] = ACTIONS(5467),
    [anon_sym_DASH_GT] = ACTIONS(5467),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5465),
    [anon_sym_decltype] = ACTIONS(5465),
    [anon_sym_final] = ACTIONS(5465),
    [anon_sym_override] = ACTIONS(5465),
    [anon_sym_requires] = ACTIONS(5465),
  },
  [2119] = {
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5547),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5204),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2120] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token2] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [aux_sym_preproc_else_token1] = ACTIONS(2267),
    [aux_sym_preproc_elif_token1] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(2265),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_friend] = ACTIONS(2267),
    [anon_sym_public] = ACTIONS(2267),
    [anon_sym_private] = ACTIONS(2267),
    [anon_sym_protected] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym_catch] = ACTIONS(2267),
  },
  [2121] = {
    [sym_attribute_specifier] = STATE(2739),
    [sym_field_declaration_list] = STATE(2710),
    [sym_virtual_specifier] = STATE(7800),
    [sym_base_class_clause] = STATE(8429),
    [sym_identifier] = ACTIONS(5469),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5471),
    [anon_sym_COMMA] = ACTIONS(5471),
    [anon_sym_RPAREN] = ACTIONS(5471),
    [aux_sym_preproc_if_token2] = ACTIONS(5471),
    [aux_sym_preproc_else_token1] = ACTIONS(5471),
    [aux_sym_preproc_elif_token1] = ACTIONS(5469),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5471),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5471),
    [anon_sym_LPAREN2] = ACTIONS(5471),
    [anon_sym_DASH] = ACTIONS(5469),
    [anon_sym_PLUS] = ACTIONS(5469),
    [anon_sym_STAR] = ACTIONS(5469),
    [anon_sym_SLASH] = ACTIONS(5469),
    [anon_sym_PERCENT] = ACTIONS(5469),
    [anon_sym_PIPE_PIPE] = ACTIONS(5471),
    [anon_sym_AMP_AMP] = ACTIONS(5471),
    [anon_sym_PIPE] = ACTIONS(5469),
    [anon_sym_CARET] = ACTIONS(5469),
    [anon_sym_AMP] = ACTIONS(5469),
    [anon_sym_EQ_EQ] = ACTIONS(5471),
    [anon_sym_BANG_EQ] = ACTIONS(5471),
    [anon_sym_GT] = ACTIONS(5469),
    [anon_sym_GT_EQ] = ACTIONS(5471),
    [anon_sym_LT_EQ] = ACTIONS(5469),
    [anon_sym_LT] = ACTIONS(5469),
    [anon_sym_LT_LT] = ACTIONS(5469),
    [anon_sym_GT_GT] = ACTIONS(5469),
    [anon_sym_SEMI] = ACTIONS(5471),
    [anon_sym___attribute__] = ACTIONS(5473),
    [anon_sym_LBRACE] = ACTIONS(5475),
    [anon_sym_RBRACE] = ACTIONS(5471),
    [anon_sym_LBRACK] = ACTIONS(5471),
    [anon_sym_RBRACK] = ACTIONS(5471),
    [anon_sym_EQ] = ACTIONS(5469),
    [anon_sym_COLON] = ACTIONS(5477),
    [anon_sym_QMARK] = ACTIONS(5471),
    [anon_sym_STAR_EQ] = ACTIONS(5471),
    [anon_sym_SLASH_EQ] = ACTIONS(5471),
    [anon_sym_PERCENT_EQ] = ACTIONS(5471),
    [anon_sym_PLUS_EQ] = ACTIONS(5471),
    [anon_sym_DASH_EQ] = ACTIONS(5471),
    [anon_sym_LT_LT_EQ] = ACTIONS(5471),
    [anon_sym_GT_GT_EQ] = ACTIONS(5471),
    [anon_sym_AMP_EQ] = ACTIONS(5471),
    [anon_sym_CARET_EQ] = ACTIONS(5471),
    [anon_sym_PIPE_EQ] = ACTIONS(5471),
    [anon_sym_and_eq] = ACTIONS(5469),
    [anon_sym_or_eq] = ACTIONS(5469),
    [anon_sym_xor_eq] = ACTIONS(5469),
    [anon_sym_LT_EQ_GT] = ACTIONS(5471),
    [anon_sym_or] = ACTIONS(5469),
    [anon_sym_and] = ACTIONS(5469),
    [anon_sym_bitor] = ACTIONS(5469),
    [anon_sym_xor] = ACTIONS(5469),
    [anon_sym_bitand] = ACTIONS(5469),
    [anon_sym_not_eq] = ACTIONS(5469),
    [anon_sym_DASH_DASH] = ACTIONS(5471),
    [anon_sym_PLUS_PLUS] = ACTIONS(5471),
    [anon_sym_DOT] = ACTIONS(5469),
    [anon_sym_DOT_STAR] = ACTIONS(5471),
    [anon_sym_DASH_GT] = ACTIONS(5471),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5469),
    [anon_sym_decltype] = ACTIONS(5469),
    [anon_sym_final] = ACTIONS(5479),
    [anon_sym_override] = ACTIONS(5479),
  },
  [2122] = {
    [sym_identifier] = ACTIONS(3467),
    [aux_sym_preproc_def_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token2] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3467),
    [aux_sym_preproc_else_token1] = ACTIONS(3467),
    [aux_sym_preproc_elif_token1] = ACTIONS(3467),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3467),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3467),
    [sym_preproc_directive] = ACTIONS(3467),
    [anon_sym_LPAREN2] = ACTIONS(3469),
    [anon_sym_TILDE] = ACTIONS(3469),
    [anon_sym_STAR] = ACTIONS(3469),
    [anon_sym_AMP_AMP] = ACTIONS(3469),
    [anon_sym_AMP] = ACTIONS(3467),
    [anon_sym___extension__] = ACTIONS(3467),
    [anon_sym_typedef] = ACTIONS(3467),
    [anon_sym_extern] = ACTIONS(3467),
    [anon_sym___attribute__] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(3469),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3469),
    [anon_sym___declspec] = ACTIONS(3467),
    [anon_sym___based] = ACTIONS(3467),
    [anon_sym_signed] = ACTIONS(3467),
    [anon_sym_unsigned] = ACTIONS(3467),
    [anon_sym_long] = ACTIONS(3467),
    [anon_sym_short] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [anon_sym_static] = ACTIONS(3467),
    [anon_sym_register] = ACTIONS(3467),
    [anon_sym_inline] = ACTIONS(3467),
    [anon_sym___inline] = ACTIONS(3467),
    [anon_sym___inline__] = ACTIONS(3467),
    [anon_sym___forceinline] = ACTIONS(3467),
    [anon_sym_thread_local] = ACTIONS(3467),
    [anon_sym___thread] = ACTIONS(3467),
    [anon_sym_const] = ACTIONS(3467),
    [anon_sym_constexpr] = ACTIONS(3467),
    [anon_sym_volatile] = ACTIONS(3467),
    [anon_sym_restrict] = ACTIONS(3467),
    [anon_sym___restrict__] = ACTIONS(3467),
    [anon_sym__Atomic] = ACTIONS(3467),
    [anon_sym__Noreturn] = ACTIONS(3467),
    [anon_sym_noreturn] = ACTIONS(3467),
    [anon_sym_mutable] = ACTIONS(3467),
    [anon_sym_constinit] = ACTIONS(3467),
    [anon_sym_consteval] = ACTIONS(3467),
    [anon_sym_PROGMEM] = ACTIONS(3467),
    [aux_sym_primitive_type_token1] = ACTIONS(3467),
    [anon_sym_byte] = ACTIONS(3467),
    [anon_sym_word] = ACTIONS(3467),
    [anon_sym_enum] = ACTIONS(3467),
    [anon_sym_class] = ACTIONS(3467),
    [anon_sym_struct] = ACTIONS(3467),
    [anon_sym_union] = ACTIONS(3467),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3467),
    [anon_sym_decltype] = ACTIONS(3467),
    [anon_sym_virtual] = ACTIONS(3467),
    [anon_sym_alignas] = ACTIONS(3467),
    [anon_sym_explicit] = ACTIONS(3467),
    [anon_sym_typename] = ACTIONS(3467),
    [anon_sym_template] = ACTIONS(3467),
    [anon_sym_operator] = ACTIONS(3467),
    [anon_sym_friend] = ACTIONS(3467),
    [anon_sym_public] = ACTIONS(3467),
    [anon_sym_private] = ACTIONS(3467),
    [anon_sym_protected] = ACTIONS(3467),
    [anon_sym_using] = ACTIONS(3467),
    [anon_sym_static_assert] = ACTIONS(3467),
  },
  [2123] = {
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5531),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5204),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2124] = {
    [sym_identifier] = ACTIONS(2223),
    [aux_sym_preproc_def_token1] = ACTIONS(2223),
    [aux_sym_preproc_if_token1] = ACTIONS(2223),
    [aux_sym_preproc_if_token2] = ACTIONS(2223),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2223),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2223),
    [aux_sym_preproc_else_token1] = ACTIONS(2223),
    [aux_sym_preproc_elif_token1] = ACTIONS(2223),
    [sym_preproc_directive] = ACTIONS(2223),
    [anon_sym_LPAREN2] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2221),
    [anon_sym_AMP_AMP] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym___extension__] = ACTIONS(2223),
    [anon_sym_typedef] = ACTIONS(2223),
    [anon_sym_extern] = ACTIONS(2223),
    [anon_sym___attribute__] = ACTIONS(2223),
    [anon_sym_COLON_COLON] = ACTIONS(2221),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym___declspec] = ACTIONS(2223),
    [anon_sym___based] = ACTIONS(2223),
    [anon_sym_signed] = ACTIONS(2223),
    [anon_sym_unsigned] = ACTIONS(2223),
    [anon_sym_long] = ACTIONS(2223),
    [anon_sym_short] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(2223),
    [anon_sym_static] = ACTIONS(2223),
    [anon_sym_register] = ACTIONS(2223),
    [anon_sym_inline] = ACTIONS(2223),
    [anon_sym___inline] = ACTIONS(2223),
    [anon_sym___inline__] = ACTIONS(2223),
    [anon_sym___forceinline] = ACTIONS(2223),
    [anon_sym_thread_local] = ACTIONS(2223),
    [anon_sym___thread] = ACTIONS(2223),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_constexpr] = ACTIONS(2223),
    [anon_sym_volatile] = ACTIONS(2223),
    [anon_sym_restrict] = ACTIONS(2223),
    [anon_sym___restrict__] = ACTIONS(2223),
    [anon_sym__Atomic] = ACTIONS(2223),
    [anon_sym__Noreturn] = ACTIONS(2223),
    [anon_sym_noreturn] = ACTIONS(2223),
    [anon_sym_mutable] = ACTIONS(2223),
    [anon_sym_constinit] = ACTIONS(2223),
    [anon_sym_consteval] = ACTIONS(2223),
    [anon_sym_PROGMEM] = ACTIONS(2223),
    [aux_sym_primitive_type_token1] = ACTIONS(2223),
    [anon_sym_byte] = ACTIONS(2223),
    [anon_sym_word] = ACTIONS(2223),
    [anon_sym_enum] = ACTIONS(2223),
    [anon_sym_class] = ACTIONS(2223),
    [anon_sym_struct] = ACTIONS(2223),
    [anon_sym_union] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2223),
    [anon_sym_decltype] = ACTIONS(2223),
    [anon_sym_virtual] = ACTIONS(2223),
    [anon_sym_alignas] = ACTIONS(2223),
    [anon_sym_explicit] = ACTIONS(2223),
    [anon_sym_typename] = ACTIONS(2223),
    [anon_sym_template] = ACTIONS(2223),
    [anon_sym_operator] = ACTIONS(2223),
    [anon_sym_friend] = ACTIONS(2223),
    [anon_sym_public] = ACTIONS(2223),
    [anon_sym_private] = ACTIONS(2223),
    [anon_sym_protected] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_static_assert] = ACTIONS(2223),
    [anon_sym_catch] = ACTIONS(2223),
  },
  [2125] = {
    [sym_identifier] = ACTIONS(5146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5148),
    [anon_sym_COMMA] = ACTIONS(5148),
    [anon_sym_RPAREN] = ACTIONS(5148),
    [anon_sym_LPAREN2] = ACTIONS(5148),
    [anon_sym_DASH] = ACTIONS(5146),
    [anon_sym_PLUS] = ACTIONS(5146),
    [anon_sym_STAR] = ACTIONS(5148),
    [anon_sym_SLASH] = ACTIONS(5146),
    [anon_sym_PERCENT] = ACTIONS(5148),
    [anon_sym_PIPE_PIPE] = ACTIONS(5148),
    [anon_sym_AMP_AMP] = ACTIONS(5148),
    [anon_sym_PIPE] = ACTIONS(5146),
    [anon_sym_CARET] = ACTIONS(5148),
    [anon_sym_AMP] = ACTIONS(5146),
    [anon_sym_EQ_EQ] = ACTIONS(5148),
    [anon_sym_BANG_EQ] = ACTIONS(5148),
    [anon_sym_GT] = ACTIONS(5146),
    [anon_sym_GT_EQ] = ACTIONS(5148),
    [anon_sym_LT_EQ] = ACTIONS(5146),
    [anon_sym_LT] = ACTIONS(5146),
    [anon_sym_LT_LT] = ACTIONS(5148),
    [anon_sym_GT_GT] = ACTIONS(5148),
    [anon_sym_SEMI] = ACTIONS(5148),
    [anon_sym___extension__] = ACTIONS(5146),
    [anon_sym___attribute__] = ACTIONS(5146),
    [anon_sym_COLON_COLON] = ACTIONS(5148),
    [anon_sym___based] = ACTIONS(5146),
    [anon_sym_LBRACE] = ACTIONS(5148),
    [anon_sym_RBRACE] = ACTIONS(5148),
    [anon_sym_signed] = ACTIONS(5146),
    [anon_sym_unsigned] = ACTIONS(5146),
    [anon_sym_long] = ACTIONS(5146),
    [anon_sym_short] = ACTIONS(5146),
    [anon_sym_LBRACK] = ACTIONS(5148),
    [anon_sym_RBRACK] = ACTIONS(5148),
    [anon_sym_const] = ACTIONS(5146),
    [anon_sym_constexpr] = ACTIONS(5146),
    [anon_sym_volatile] = ACTIONS(5146),
    [anon_sym_restrict] = ACTIONS(5146),
    [anon_sym___restrict__] = ACTIONS(5146),
    [anon_sym__Atomic] = ACTIONS(5146),
    [anon_sym__Noreturn] = ACTIONS(5146),
    [anon_sym_noreturn] = ACTIONS(5146),
    [anon_sym_mutable] = ACTIONS(5146),
    [anon_sym_constinit] = ACTIONS(5146),
    [anon_sym_consteval] = ACTIONS(5146),
    [anon_sym_PROGMEM] = ACTIONS(5146),
    [aux_sym_primitive_type_token1] = ACTIONS(5146),
    [anon_sym_byte] = ACTIONS(5146),
    [anon_sym_word] = ACTIONS(5146),
    [anon_sym_COLON] = ACTIONS(5146),
    [anon_sym_QMARK] = ACTIONS(5148),
    [anon_sym_LT_EQ_GT] = ACTIONS(5148),
    [anon_sym_or] = ACTIONS(5146),
    [anon_sym_and] = ACTIONS(5146),
    [anon_sym_bitor] = ACTIONS(5146),
    [anon_sym_xor] = ACTIONS(5146),
    [anon_sym_bitand] = ACTIONS(5146),
    [anon_sym_not_eq] = ACTIONS(5146),
    [anon_sym_DASH_DASH] = ACTIONS(5148),
    [anon_sym_PLUS_PLUS] = ACTIONS(5148),
    [anon_sym_DOT] = ACTIONS(5146),
    [anon_sym_DOT_STAR] = ACTIONS(5148),
    [anon_sym_DASH_GT] = ACTIONS(5148),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5146),
    [anon_sym_decltype] = ACTIONS(5146),
    [anon_sym_final] = ACTIONS(5146),
    [anon_sym_override] = ACTIONS(5146),
    [anon_sym_requires] = ACTIONS(5146),
  },
  [2126] = {
    [sym_identifier] = ACTIONS(3999),
    [aux_sym_preproc_def_token1] = ACTIONS(3999),
    [aux_sym_preproc_if_token1] = ACTIONS(3999),
    [aux_sym_preproc_if_token2] = ACTIONS(3999),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3999),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3999),
    [aux_sym_preproc_else_token1] = ACTIONS(3999),
    [aux_sym_preproc_elif_token1] = ACTIONS(3999),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3999),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3999),
    [sym_preproc_directive] = ACTIONS(3999),
    [anon_sym_LPAREN2] = ACTIONS(3997),
    [anon_sym_TILDE] = ACTIONS(3997),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_AMP] = ACTIONS(3999),
    [anon_sym___extension__] = ACTIONS(3999),
    [anon_sym_typedef] = ACTIONS(3999),
    [anon_sym_extern] = ACTIONS(3999),
    [anon_sym___attribute__] = ACTIONS(3999),
    [anon_sym_COLON_COLON] = ACTIONS(3997),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3997),
    [anon_sym___declspec] = ACTIONS(3999),
    [anon_sym___based] = ACTIONS(3999),
    [anon_sym_signed] = ACTIONS(3999),
    [anon_sym_unsigned] = ACTIONS(3999),
    [anon_sym_long] = ACTIONS(3999),
    [anon_sym_short] = ACTIONS(3999),
    [anon_sym_LBRACK] = ACTIONS(3999),
    [anon_sym_static] = ACTIONS(3999),
    [anon_sym_register] = ACTIONS(3999),
    [anon_sym_inline] = ACTIONS(3999),
    [anon_sym___inline] = ACTIONS(3999),
    [anon_sym___inline__] = ACTIONS(3999),
    [anon_sym___forceinline] = ACTIONS(3999),
    [anon_sym_thread_local] = ACTIONS(3999),
    [anon_sym___thread] = ACTIONS(3999),
    [anon_sym_const] = ACTIONS(3999),
    [anon_sym_constexpr] = ACTIONS(3999),
    [anon_sym_volatile] = ACTIONS(3999),
    [anon_sym_restrict] = ACTIONS(3999),
    [anon_sym___restrict__] = ACTIONS(3999),
    [anon_sym__Atomic] = ACTIONS(3999),
    [anon_sym__Noreturn] = ACTIONS(3999),
    [anon_sym_noreturn] = ACTIONS(3999),
    [anon_sym_mutable] = ACTIONS(3999),
    [anon_sym_constinit] = ACTIONS(3999),
    [anon_sym_consteval] = ACTIONS(3999),
    [anon_sym_PROGMEM] = ACTIONS(3999),
    [aux_sym_primitive_type_token1] = ACTIONS(3999),
    [anon_sym_byte] = ACTIONS(3999),
    [anon_sym_word] = ACTIONS(3999),
    [anon_sym_enum] = ACTIONS(3999),
    [anon_sym_class] = ACTIONS(3999),
    [anon_sym_struct] = ACTIONS(3999),
    [anon_sym_union] = ACTIONS(3999),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3999),
    [anon_sym_decltype] = ACTIONS(3999),
    [anon_sym_virtual] = ACTIONS(3999),
    [anon_sym_alignas] = ACTIONS(3999),
    [anon_sym_explicit] = ACTIONS(3999),
    [anon_sym_typename] = ACTIONS(3999),
    [anon_sym_template] = ACTIONS(3999),
    [anon_sym_operator] = ACTIONS(3999),
    [anon_sym_friend] = ACTIONS(3999),
    [anon_sym_public] = ACTIONS(3999),
    [anon_sym_private] = ACTIONS(3999),
    [anon_sym_protected] = ACTIONS(3999),
    [anon_sym_using] = ACTIONS(3999),
    [anon_sym_static_assert] = ACTIONS(3999),
  },
  [2127] = {
    [sym_identifier] = ACTIONS(3455),
    [aux_sym_preproc_def_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token2] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3455),
    [aux_sym_preproc_else_token1] = ACTIONS(3455),
    [aux_sym_preproc_elif_token1] = ACTIONS(3455),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3455),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3455),
    [sym_preproc_directive] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3457),
    [anon_sym_STAR] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym___extension__] = ACTIONS(3455),
    [anon_sym_typedef] = ACTIONS(3455),
    [anon_sym_extern] = ACTIONS(3455),
    [anon_sym___attribute__] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3457),
    [anon_sym___declspec] = ACTIONS(3455),
    [anon_sym___based] = ACTIONS(3455),
    [anon_sym_signed] = ACTIONS(3455),
    [anon_sym_unsigned] = ACTIONS(3455),
    [anon_sym_long] = ACTIONS(3455),
    [anon_sym_short] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_static] = ACTIONS(3455),
    [anon_sym_register] = ACTIONS(3455),
    [anon_sym_inline] = ACTIONS(3455),
    [anon_sym___inline] = ACTIONS(3455),
    [anon_sym___inline__] = ACTIONS(3455),
    [anon_sym___forceinline] = ACTIONS(3455),
    [anon_sym_thread_local] = ACTIONS(3455),
    [anon_sym___thread] = ACTIONS(3455),
    [anon_sym_const] = ACTIONS(3455),
    [anon_sym_constexpr] = ACTIONS(3455),
    [anon_sym_volatile] = ACTIONS(3455),
    [anon_sym_restrict] = ACTIONS(3455),
    [anon_sym___restrict__] = ACTIONS(3455),
    [anon_sym__Atomic] = ACTIONS(3455),
    [anon_sym__Noreturn] = ACTIONS(3455),
    [anon_sym_noreturn] = ACTIONS(3455),
    [anon_sym_mutable] = ACTIONS(3455),
    [anon_sym_constinit] = ACTIONS(3455),
    [anon_sym_consteval] = ACTIONS(3455),
    [anon_sym_PROGMEM] = ACTIONS(3455),
    [aux_sym_primitive_type_token1] = ACTIONS(3455),
    [anon_sym_byte] = ACTIONS(3455),
    [anon_sym_word] = ACTIONS(3455),
    [anon_sym_enum] = ACTIONS(3455),
    [anon_sym_class] = ACTIONS(3455),
    [anon_sym_struct] = ACTIONS(3455),
    [anon_sym_union] = ACTIONS(3455),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3455),
    [anon_sym_decltype] = ACTIONS(3455),
    [anon_sym_virtual] = ACTIONS(3455),
    [anon_sym_alignas] = ACTIONS(3455),
    [anon_sym_explicit] = ACTIONS(3455),
    [anon_sym_typename] = ACTIONS(3455),
    [anon_sym_template] = ACTIONS(3455),
    [anon_sym_operator] = ACTIONS(3455),
    [anon_sym_friend] = ACTIONS(3455),
    [anon_sym_public] = ACTIONS(3455),
    [anon_sym_private] = ACTIONS(3455),
    [anon_sym_protected] = ACTIONS(3455),
    [anon_sym_using] = ACTIONS(3455),
    [anon_sym_static_assert] = ACTIONS(3455),
  },
  [2128] = {
    [sym_identifier] = ACTIONS(3451),
    [aux_sym_preproc_def_token1] = ACTIONS(3451),
    [aux_sym_preproc_if_token1] = ACTIONS(3451),
    [aux_sym_preproc_if_token2] = ACTIONS(3451),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3451),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3451),
    [aux_sym_preproc_else_token1] = ACTIONS(3451),
    [aux_sym_preproc_elif_token1] = ACTIONS(3451),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3451),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3451),
    [sym_preproc_directive] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3453),
    [anon_sym_TILDE] = ACTIONS(3453),
    [anon_sym_STAR] = ACTIONS(3453),
    [anon_sym_AMP_AMP] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym___extension__] = ACTIONS(3451),
    [anon_sym_typedef] = ACTIONS(3451),
    [anon_sym_extern] = ACTIONS(3451),
    [anon_sym___attribute__] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3453),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3453),
    [anon_sym___declspec] = ACTIONS(3451),
    [anon_sym___based] = ACTIONS(3451),
    [anon_sym_signed] = ACTIONS(3451),
    [anon_sym_unsigned] = ACTIONS(3451),
    [anon_sym_long] = ACTIONS(3451),
    [anon_sym_short] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_register] = ACTIONS(3451),
    [anon_sym_inline] = ACTIONS(3451),
    [anon_sym___inline] = ACTIONS(3451),
    [anon_sym___inline__] = ACTIONS(3451),
    [anon_sym___forceinline] = ACTIONS(3451),
    [anon_sym_thread_local] = ACTIONS(3451),
    [anon_sym___thread] = ACTIONS(3451),
    [anon_sym_const] = ACTIONS(3451),
    [anon_sym_constexpr] = ACTIONS(3451),
    [anon_sym_volatile] = ACTIONS(3451),
    [anon_sym_restrict] = ACTIONS(3451),
    [anon_sym___restrict__] = ACTIONS(3451),
    [anon_sym__Atomic] = ACTIONS(3451),
    [anon_sym__Noreturn] = ACTIONS(3451),
    [anon_sym_noreturn] = ACTIONS(3451),
    [anon_sym_mutable] = ACTIONS(3451),
    [anon_sym_constinit] = ACTIONS(3451),
    [anon_sym_consteval] = ACTIONS(3451),
    [anon_sym_PROGMEM] = ACTIONS(3451),
    [aux_sym_primitive_type_token1] = ACTIONS(3451),
    [anon_sym_byte] = ACTIONS(3451),
    [anon_sym_word] = ACTIONS(3451),
    [anon_sym_enum] = ACTIONS(3451),
    [anon_sym_class] = ACTIONS(3451),
    [anon_sym_struct] = ACTIONS(3451),
    [anon_sym_union] = ACTIONS(3451),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3451),
    [anon_sym_decltype] = ACTIONS(3451),
    [anon_sym_virtual] = ACTIONS(3451),
    [anon_sym_alignas] = ACTIONS(3451),
    [anon_sym_explicit] = ACTIONS(3451),
    [anon_sym_typename] = ACTIONS(3451),
    [anon_sym_template] = ACTIONS(3451),
    [anon_sym_operator] = ACTIONS(3451),
    [anon_sym_friend] = ACTIONS(3451),
    [anon_sym_public] = ACTIONS(3451),
    [anon_sym_private] = ACTIONS(3451),
    [anon_sym_protected] = ACTIONS(3451),
    [anon_sym_using] = ACTIONS(3451),
    [anon_sym_static_assert] = ACTIONS(3451),
  },
  [2129] = {
    [sym_identifier] = ACTIONS(3443),
    [aux_sym_preproc_def_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token2] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3443),
    [aux_sym_preproc_else_token1] = ACTIONS(3443),
    [aux_sym_preproc_elif_token1] = ACTIONS(3443),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3443),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3443),
    [sym_preproc_directive] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_AMP_AMP] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym___extension__] = ACTIONS(3443),
    [anon_sym_typedef] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym___attribute__] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3445),
    [anon_sym___declspec] = ACTIONS(3443),
    [anon_sym___based] = ACTIONS(3443),
    [anon_sym_signed] = ACTIONS(3443),
    [anon_sym_unsigned] = ACTIONS(3443),
    [anon_sym_long] = ACTIONS(3443),
    [anon_sym_short] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_register] = ACTIONS(3443),
    [anon_sym_inline] = ACTIONS(3443),
    [anon_sym___inline] = ACTIONS(3443),
    [anon_sym___inline__] = ACTIONS(3443),
    [anon_sym___forceinline] = ACTIONS(3443),
    [anon_sym_thread_local] = ACTIONS(3443),
    [anon_sym___thread] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_constexpr] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_restrict] = ACTIONS(3443),
    [anon_sym___restrict__] = ACTIONS(3443),
    [anon_sym__Atomic] = ACTIONS(3443),
    [anon_sym__Noreturn] = ACTIONS(3443),
    [anon_sym_noreturn] = ACTIONS(3443),
    [anon_sym_mutable] = ACTIONS(3443),
    [anon_sym_constinit] = ACTIONS(3443),
    [anon_sym_consteval] = ACTIONS(3443),
    [anon_sym_PROGMEM] = ACTIONS(3443),
    [aux_sym_primitive_type_token1] = ACTIONS(3443),
    [anon_sym_byte] = ACTIONS(3443),
    [anon_sym_word] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_union] = ACTIONS(3443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3443),
    [anon_sym_decltype] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_alignas] = ACTIONS(3443),
    [anon_sym_explicit] = ACTIONS(3443),
    [anon_sym_typename] = ACTIONS(3443),
    [anon_sym_template] = ACTIONS(3443),
    [anon_sym_operator] = ACTIONS(3443),
    [anon_sym_friend] = ACTIONS(3443),
    [anon_sym_public] = ACTIONS(3443),
    [anon_sym_private] = ACTIONS(3443),
    [anon_sym_protected] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_static_assert] = ACTIONS(3443),
  },
  [2130] = {
    [sym_identifier] = ACTIONS(3443),
    [aux_sym_preproc_def_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token2] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3443),
    [aux_sym_preproc_else_token1] = ACTIONS(3443),
    [aux_sym_preproc_elif_token1] = ACTIONS(3443),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3443),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3443),
    [sym_preproc_directive] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_AMP_AMP] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym___extension__] = ACTIONS(3443),
    [anon_sym_typedef] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym___attribute__] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3445),
    [anon_sym___declspec] = ACTIONS(3443),
    [anon_sym___based] = ACTIONS(3443),
    [anon_sym_signed] = ACTIONS(3443),
    [anon_sym_unsigned] = ACTIONS(3443),
    [anon_sym_long] = ACTIONS(3443),
    [anon_sym_short] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_register] = ACTIONS(3443),
    [anon_sym_inline] = ACTIONS(3443),
    [anon_sym___inline] = ACTIONS(3443),
    [anon_sym___inline__] = ACTIONS(3443),
    [anon_sym___forceinline] = ACTIONS(3443),
    [anon_sym_thread_local] = ACTIONS(3443),
    [anon_sym___thread] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_constexpr] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_restrict] = ACTIONS(3443),
    [anon_sym___restrict__] = ACTIONS(3443),
    [anon_sym__Atomic] = ACTIONS(3443),
    [anon_sym__Noreturn] = ACTIONS(3443),
    [anon_sym_noreturn] = ACTIONS(3443),
    [anon_sym_mutable] = ACTIONS(3443),
    [anon_sym_constinit] = ACTIONS(3443),
    [anon_sym_consteval] = ACTIONS(3443),
    [anon_sym_PROGMEM] = ACTIONS(3443),
    [aux_sym_primitive_type_token1] = ACTIONS(3443),
    [anon_sym_byte] = ACTIONS(3443),
    [anon_sym_word] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_union] = ACTIONS(3443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3443),
    [anon_sym_decltype] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_alignas] = ACTIONS(3443),
    [anon_sym_explicit] = ACTIONS(3443),
    [anon_sym_typename] = ACTIONS(3443),
    [anon_sym_template] = ACTIONS(3443),
    [anon_sym_operator] = ACTIONS(3443),
    [anon_sym_friend] = ACTIONS(3443),
    [anon_sym_public] = ACTIONS(3443),
    [anon_sym_private] = ACTIONS(3443),
    [anon_sym_protected] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_static_assert] = ACTIONS(3443),
  },
  [2131] = {
    [sym_identifier] = ACTIONS(3499),
    [aux_sym_preproc_def_token1] = ACTIONS(3499),
    [aux_sym_preproc_if_token1] = ACTIONS(3499),
    [aux_sym_preproc_if_token2] = ACTIONS(3499),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3499),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3499),
    [aux_sym_preproc_else_token1] = ACTIONS(3499),
    [aux_sym_preproc_elif_token1] = ACTIONS(3499),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3499),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3499),
    [sym_preproc_directive] = ACTIONS(3499),
    [anon_sym_LPAREN2] = ACTIONS(3501),
    [anon_sym_TILDE] = ACTIONS(3501),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_AMP_AMP] = ACTIONS(3501),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym___extension__] = ACTIONS(3499),
    [anon_sym_typedef] = ACTIONS(3499),
    [anon_sym_extern] = ACTIONS(3499),
    [anon_sym___attribute__] = ACTIONS(3499),
    [anon_sym_COLON_COLON] = ACTIONS(3501),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3501),
    [anon_sym___declspec] = ACTIONS(3499),
    [anon_sym___based] = ACTIONS(3499),
    [anon_sym_signed] = ACTIONS(3499),
    [anon_sym_unsigned] = ACTIONS(3499),
    [anon_sym_long] = ACTIONS(3499),
    [anon_sym_short] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(3499),
    [anon_sym_static] = ACTIONS(3499),
    [anon_sym_register] = ACTIONS(3499),
    [anon_sym_inline] = ACTIONS(3499),
    [anon_sym___inline] = ACTIONS(3499),
    [anon_sym___inline__] = ACTIONS(3499),
    [anon_sym___forceinline] = ACTIONS(3499),
    [anon_sym_thread_local] = ACTIONS(3499),
    [anon_sym___thread] = ACTIONS(3499),
    [anon_sym_const] = ACTIONS(3499),
    [anon_sym_constexpr] = ACTIONS(3499),
    [anon_sym_volatile] = ACTIONS(3499),
    [anon_sym_restrict] = ACTIONS(3499),
    [anon_sym___restrict__] = ACTIONS(3499),
    [anon_sym__Atomic] = ACTIONS(3499),
    [anon_sym__Noreturn] = ACTIONS(3499),
    [anon_sym_noreturn] = ACTIONS(3499),
    [anon_sym_mutable] = ACTIONS(3499),
    [anon_sym_constinit] = ACTIONS(3499),
    [anon_sym_consteval] = ACTIONS(3499),
    [anon_sym_PROGMEM] = ACTIONS(3499),
    [aux_sym_primitive_type_token1] = ACTIONS(3499),
    [anon_sym_byte] = ACTIONS(3499),
    [anon_sym_word] = ACTIONS(3499),
    [anon_sym_enum] = ACTIONS(3499),
    [anon_sym_class] = ACTIONS(3499),
    [anon_sym_struct] = ACTIONS(3499),
    [anon_sym_union] = ACTIONS(3499),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3499),
    [anon_sym_decltype] = ACTIONS(3499),
    [anon_sym_virtual] = ACTIONS(3499),
    [anon_sym_alignas] = ACTIONS(3499),
    [anon_sym_explicit] = ACTIONS(3499),
    [anon_sym_typename] = ACTIONS(3499),
    [anon_sym_template] = ACTIONS(3499),
    [anon_sym_operator] = ACTIONS(3499),
    [anon_sym_friend] = ACTIONS(3499),
    [anon_sym_public] = ACTIONS(3499),
    [anon_sym_private] = ACTIONS(3499),
    [anon_sym_protected] = ACTIONS(3499),
    [anon_sym_using] = ACTIONS(3499),
    [anon_sym_static_assert] = ACTIONS(3499),
  },
  [2132] = {
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5601),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5204),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2133] = {
    [sym_identifier] = ACTIONS(3128),
    [aux_sym_preproc_def_token1] = ACTIONS(3128),
    [aux_sym_preproc_if_token1] = ACTIONS(3128),
    [aux_sym_preproc_if_token2] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3128),
    [aux_sym_preproc_else_token1] = ACTIONS(3128),
    [aux_sym_preproc_elif_token1] = ACTIONS(3128),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3128),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3128),
    [sym_preproc_directive] = ACTIONS(3128),
    [anon_sym_LPAREN2] = ACTIONS(3130),
    [anon_sym_TILDE] = ACTIONS(3130),
    [anon_sym_STAR] = ACTIONS(3130),
    [anon_sym_AMP_AMP] = ACTIONS(3130),
    [anon_sym_AMP] = ACTIONS(3128),
    [anon_sym___extension__] = ACTIONS(3128),
    [anon_sym_typedef] = ACTIONS(3128),
    [anon_sym_extern] = ACTIONS(3128),
    [anon_sym___attribute__] = ACTIONS(3128),
    [anon_sym_COLON_COLON] = ACTIONS(3130),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3130),
    [anon_sym___declspec] = ACTIONS(3128),
    [anon_sym___based] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3128),
    [anon_sym_unsigned] = ACTIONS(3128),
    [anon_sym_long] = ACTIONS(3128),
    [anon_sym_short] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3128),
    [anon_sym_static] = ACTIONS(3128),
    [anon_sym_register] = ACTIONS(3128),
    [anon_sym_inline] = ACTIONS(3128),
    [anon_sym___inline] = ACTIONS(3128),
    [anon_sym___inline__] = ACTIONS(3128),
    [anon_sym___forceinline] = ACTIONS(3128),
    [anon_sym_thread_local] = ACTIONS(3128),
    [anon_sym___thread] = ACTIONS(3128),
    [anon_sym_const] = ACTIONS(3128),
    [anon_sym_constexpr] = ACTIONS(3128),
    [anon_sym_volatile] = ACTIONS(3128),
    [anon_sym_restrict] = ACTIONS(3128),
    [anon_sym___restrict__] = ACTIONS(3128),
    [anon_sym__Atomic] = ACTIONS(3128),
    [anon_sym__Noreturn] = ACTIONS(3128),
    [anon_sym_noreturn] = ACTIONS(3128),
    [anon_sym_mutable] = ACTIONS(3128),
    [anon_sym_constinit] = ACTIONS(3128),
    [anon_sym_consteval] = ACTIONS(3128),
    [anon_sym_PROGMEM] = ACTIONS(3128),
    [aux_sym_primitive_type_token1] = ACTIONS(3128),
    [anon_sym_byte] = ACTIONS(3128),
    [anon_sym_word] = ACTIONS(3128),
    [anon_sym_enum] = ACTIONS(3128),
    [anon_sym_class] = ACTIONS(3128),
    [anon_sym_struct] = ACTIONS(3128),
    [anon_sym_union] = ACTIONS(3128),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3128),
    [anon_sym_decltype] = ACTIONS(3128),
    [anon_sym_virtual] = ACTIONS(3128),
    [anon_sym_alignas] = ACTIONS(3128),
    [anon_sym_explicit] = ACTIONS(3128),
    [anon_sym_typename] = ACTIONS(3128),
    [anon_sym_template] = ACTIONS(3128),
    [anon_sym_operator] = ACTIONS(3128),
    [anon_sym_friend] = ACTIONS(3128),
    [anon_sym_public] = ACTIONS(3128),
    [anon_sym_private] = ACTIONS(3128),
    [anon_sym_protected] = ACTIONS(3128),
    [anon_sym_using] = ACTIONS(3128),
    [anon_sym_static_assert] = ACTIONS(3128),
  },
  [2134] = {
    [sym_identifier] = ACTIONS(3144),
    [aux_sym_preproc_def_token1] = ACTIONS(3144),
    [aux_sym_preproc_if_token1] = ACTIONS(3144),
    [aux_sym_preproc_if_token2] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3144),
    [aux_sym_preproc_else_token1] = ACTIONS(3144),
    [aux_sym_preproc_elif_token1] = ACTIONS(3144),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3144),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3144),
    [sym_preproc_directive] = ACTIONS(3144),
    [anon_sym_LPAREN2] = ACTIONS(3146),
    [anon_sym_TILDE] = ACTIONS(3146),
    [anon_sym_STAR] = ACTIONS(3146),
    [anon_sym_AMP_AMP] = ACTIONS(3146),
    [anon_sym_AMP] = ACTIONS(3144),
    [anon_sym___extension__] = ACTIONS(3144),
    [anon_sym_typedef] = ACTIONS(3144),
    [anon_sym_extern] = ACTIONS(3144),
    [anon_sym___attribute__] = ACTIONS(3144),
    [anon_sym_COLON_COLON] = ACTIONS(3146),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3146),
    [anon_sym___declspec] = ACTIONS(3144),
    [anon_sym___based] = ACTIONS(3144),
    [anon_sym_signed] = ACTIONS(3144),
    [anon_sym_unsigned] = ACTIONS(3144),
    [anon_sym_long] = ACTIONS(3144),
    [anon_sym_short] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3144),
    [anon_sym_static] = ACTIONS(3144),
    [anon_sym_register] = ACTIONS(3144),
    [anon_sym_inline] = ACTIONS(3144),
    [anon_sym___inline] = ACTIONS(3144),
    [anon_sym___inline__] = ACTIONS(3144),
    [anon_sym___forceinline] = ACTIONS(3144),
    [anon_sym_thread_local] = ACTIONS(3144),
    [anon_sym___thread] = ACTIONS(3144),
    [anon_sym_const] = ACTIONS(3144),
    [anon_sym_constexpr] = ACTIONS(3144),
    [anon_sym_volatile] = ACTIONS(3144),
    [anon_sym_restrict] = ACTIONS(3144),
    [anon_sym___restrict__] = ACTIONS(3144),
    [anon_sym__Atomic] = ACTIONS(3144),
    [anon_sym__Noreturn] = ACTIONS(3144),
    [anon_sym_noreturn] = ACTIONS(3144),
    [anon_sym_mutable] = ACTIONS(3144),
    [anon_sym_constinit] = ACTIONS(3144),
    [anon_sym_consteval] = ACTIONS(3144),
    [anon_sym_PROGMEM] = ACTIONS(3144),
    [aux_sym_primitive_type_token1] = ACTIONS(3144),
    [anon_sym_byte] = ACTIONS(3144),
    [anon_sym_word] = ACTIONS(3144),
    [anon_sym_enum] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_struct] = ACTIONS(3144),
    [anon_sym_union] = ACTIONS(3144),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3144),
    [anon_sym_decltype] = ACTIONS(3144),
    [anon_sym_virtual] = ACTIONS(3144),
    [anon_sym_alignas] = ACTIONS(3144),
    [anon_sym_explicit] = ACTIONS(3144),
    [anon_sym_typename] = ACTIONS(3144),
    [anon_sym_template] = ACTIONS(3144),
    [anon_sym_operator] = ACTIONS(3144),
    [anon_sym_friend] = ACTIONS(3144),
    [anon_sym_public] = ACTIONS(3144),
    [anon_sym_private] = ACTIONS(3144),
    [anon_sym_protected] = ACTIONS(3144),
    [anon_sym_using] = ACTIONS(3144),
    [anon_sym_static_assert] = ACTIONS(3144),
  },
  [2135] = {
    [sym_identifier] = ACTIONS(3254),
    [aux_sym_preproc_def_token1] = ACTIONS(3254),
    [aux_sym_preproc_if_token1] = ACTIONS(3254),
    [aux_sym_preproc_if_token2] = ACTIONS(3254),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3254),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3254),
    [aux_sym_preproc_else_token1] = ACTIONS(3254),
    [aux_sym_preproc_elif_token1] = ACTIONS(3254),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3254),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3254),
    [sym_preproc_directive] = ACTIONS(3254),
    [anon_sym_LPAREN2] = ACTIONS(3256),
    [anon_sym_TILDE] = ACTIONS(3256),
    [anon_sym_STAR] = ACTIONS(3256),
    [anon_sym_AMP_AMP] = ACTIONS(3256),
    [anon_sym_AMP] = ACTIONS(3254),
    [anon_sym___extension__] = ACTIONS(3254),
    [anon_sym_typedef] = ACTIONS(3254),
    [anon_sym_extern] = ACTIONS(3254),
    [anon_sym___attribute__] = ACTIONS(3254),
    [anon_sym_COLON_COLON] = ACTIONS(3256),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3256),
    [anon_sym___declspec] = ACTIONS(3254),
    [anon_sym___based] = ACTIONS(3254),
    [anon_sym_signed] = ACTIONS(3254),
    [anon_sym_unsigned] = ACTIONS(3254),
    [anon_sym_long] = ACTIONS(3254),
    [anon_sym_short] = ACTIONS(3254),
    [anon_sym_LBRACK] = ACTIONS(3254),
    [anon_sym_static] = ACTIONS(3254),
    [anon_sym_register] = ACTIONS(3254),
    [anon_sym_inline] = ACTIONS(3254),
    [anon_sym___inline] = ACTIONS(3254),
    [anon_sym___inline__] = ACTIONS(3254),
    [anon_sym___forceinline] = ACTIONS(3254),
    [anon_sym_thread_local] = ACTIONS(3254),
    [anon_sym___thread] = ACTIONS(3254),
    [anon_sym_const] = ACTIONS(3254),
    [anon_sym_constexpr] = ACTIONS(3254),
    [anon_sym_volatile] = ACTIONS(3254),
    [anon_sym_restrict] = ACTIONS(3254),
    [anon_sym___restrict__] = ACTIONS(3254),
    [anon_sym__Atomic] = ACTIONS(3254),
    [anon_sym__Noreturn] = ACTIONS(3254),
    [anon_sym_noreturn] = ACTIONS(3254),
    [anon_sym_mutable] = ACTIONS(3254),
    [anon_sym_constinit] = ACTIONS(3254),
    [anon_sym_consteval] = ACTIONS(3254),
    [anon_sym_PROGMEM] = ACTIONS(3254),
    [aux_sym_primitive_type_token1] = ACTIONS(3254),
    [anon_sym_byte] = ACTIONS(3254),
    [anon_sym_word] = ACTIONS(3254),
    [anon_sym_enum] = ACTIONS(3254),
    [anon_sym_class] = ACTIONS(3254),
    [anon_sym_struct] = ACTIONS(3254),
    [anon_sym_union] = ACTIONS(3254),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3254),
    [anon_sym_decltype] = ACTIONS(3254),
    [anon_sym_virtual] = ACTIONS(3254),
    [anon_sym_alignas] = ACTIONS(3254),
    [anon_sym_explicit] = ACTIONS(3254),
    [anon_sym_typename] = ACTIONS(3254),
    [anon_sym_template] = ACTIONS(3254),
    [anon_sym_operator] = ACTIONS(3254),
    [anon_sym_friend] = ACTIONS(3254),
    [anon_sym_public] = ACTIONS(3254),
    [anon_sym_private] = ACTIONS(3254),
    [anon_sym_protected] = ACTIONS(3254),
    [anon_sym_using] = ACTIONS(3254),
    [anon_sym_static_assert] = ACTIONS(3254),
  },
  [2136] = {
    [sym_identifier] = ACTIONS(3192),
    [aux_sym_preproc_def_token1] = ACTIONS(3192),
    [aux_sym_preproc_if_token1] = ACTIONS(3192),
    [aux_sym_preproc_if_token2] = ACTIONS(3192),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3192),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3192),
    [aux_sym_preproc_else_token1] = ACTIONS(3192),
    [aux_sym_preproc_elif_token1] = ACTIONS(3192),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3192),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3192),
    [sym_preproc_directive] = ACTIONS(3192),
    [anon_sym_LPAREN2] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3194),
    [anon_sym_AMP_AMP] = ACTIONS(3194),
    [anon_sym_AMP] = ACTIONS(3192),
    [anon_sym___extension__] = ACTIONS(3192),
    [anon_sym_typedef] = ACTIONS(3192),
    [anon_sym_extern] = ACTIONS(3192),
    [anon_sym___attribute__] = ACTIONS(3192),
    [anon_sym_COLON_COLON] = ACTIONS(3194),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3194),
    [anon_sym___declspec] = ACTIONS(3192),
    [anon_sym___based] = ACTIONS(3192),
    [anon_sym_signed] = ACTIONS(3192),
    [anon_sym_unsigned] = ACTIONS(3192),
    [anon_sym_long] = ACTIONS(3192),
    [anon_sym_short] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [anon_sym_static] = ACTIONS(3192),
    [anon_sym_register] = ACTIONS(3192),
    [anon_sym_inline] = ACTIONS(3192),
    [anon_sym___inline] = ACTIONS(3192),
    [anon_sym___inline__] = ACTIONS(3192),
    [anon_sym___forceinline] = ACTIONS(3192),
    [anon_sym_thread_local] = ACTIONS(3192),
    [anon_sym___thread] = ACTIONS(3192),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_constexpr] = ACTIONS(3192),
    [anon_sym_volatile] = ACTIONS(3192),
    [anon_sym_restrict] = ACTIONS(3192),
    [anon_sym___restrict__] = ACTIONS(3192),
    [anon_sym__Atomic] = ACTIONS(3192),
    [anon_sym__Noreturn] = ACTIONS(3192),
    [anon_sym_noreturn] = ACTIONS(3192),
    [anon_sym_mutable] = ACTIONS(3192),
    [anon_sym_constinit] = ACTIONS(3192),
    [anon_sym_consteval] = ACTIONS(3192),
    [anon_sym_PROGMEM] = ACTIONS(3192),
    [aux_sym_primitive_type_token1] = ACTIONS(3192),
    [anon_sym_byte] = ACTIONS(3192),
    [anon_sym_word] = ACTIONS(3192),
    [anon_sym_enum] = ACTIONS(3192),
    [anon_sym_class] = ACTIONS(3192),
    [anon_sym_struct] = ACTIONS(3192),
    [anon_sym_union] = ACTIONS(3192),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3192),
    [anon_sym_decltype] = ACTIONS(3192),
    [anon_sym_virtual] = ACTIONS(3192),
    [anon_sym_alignas] = ACTIONS(3192),
    [anon_sym_explicit] = ACTIONS(3192),
    [anon_sym_typename] = ACTIONS(3192),
    [anon_sym_template] = ACTIONS(3192),
    [anon_sym_operator] = ACTIONS(3192),
    [anon_sym_friend] = ACTIONS(3192),
    [anon_sym_public] = ACTIONS(3192),
    [anon_sym_private] = ACTIONS(3192),
    [anon_sym_protected] = ACTIONS(3192),
    [anon_sym_using] = ACTIONS(3192),
    [anon_sym_static_assert] = ACTIONS(3192),
  },
  [2137] = {
    [sym_identifier] = ACTIONS(3162),
    [aux_sym_preproc_def_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token2] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3162),
    [aux_sym_preproc_else_token1] = ACTIONS(3162),
    [aux_sym_preproc_elif_token1] = ACTIONS(3162),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3162),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3162),
    [sym_preproc_directive] = ACTIONS(3162),
    [anon_sym_LPAREN2] = ACTIONS(3164),
    [anon_sym_TILDE] = ACTIONS(3164),
    [anon_sym_STAR] = ACTIONS(3164),
    [anon_sym_AMP_AMP] = ACTIONS(3164),
    [anon_sym_AMP] = ACTIONS(3162),
    [anon_sym___extension__] = ACTIONS(3162),
    [anon_sym_typedef] = ACTIONS(3162),
    [anon_sym_extern] = ACTIONS(3162),
    [anon_sym___attribute__] = ACTIONS(3162),
    [anon_sym_COLON_COLON] = ACTIONS(3164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3164),
    [anon_sym___declspec] = ACTIONS(3162),
    [anon_sym___based] = ACTIONS(3162),
    [anon_sym_signed] = ACTIONS(3162),
    [anon_sym_unsigned] = ACTIONS(3162),
    [anon_sym_long] = ACTIONS(3162),
    [anon_sym_short] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_register] = ACTIONS(3162),
    [anon_sym_inline] = ACTIONS(3162),
    [anon_sym___inline] = ACTIONS(3162),
    [anon_sym___inline__] = ACTIONS(3162),
    [anon_sym___forceinline] = ACTIONS(3162),
    [anon_sym_thread_local] = ACTIONS(3162),
    [anon_sym___thread] = ACTIONS(3162),
    [anon_sym_const] = ACTIONS(3162),
    [anon_sym_constexpr] = ACTIONS(3162),
    [anon_sym_volatile] = ACTIONS(3162),
    [anon_sym_restrict] = ACTIONS(3162),
    [anon_sym___restrict__] = ACTIONS(3162),
    [anon_sym__Atomic] = ACTIONS(3162),
    [anon_sym__Noreturn] = ACTIONS(3162),
    [anon_sym_noreturn] = ACTIONS(3162),
    [anon_sym_mutable] = ACTIONS(3162),
    [anon_sym_constinit] = ACTIONS(3162),
    [anon_sym_consteval] = ACTIONS(3162),
    [anon_sym_PROGMEM] = ACTIONS(3162),
    [aux_sym_primitive_type_token1] = ACTIONS(3162),
    [anon_sym_byte] = ACTIONS(3162),
    [anon_sym_word] = ACTIONS(3162),
    [anon_sym_enum] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_struct] = ACTIONS(3162),
    [anon_sym_union] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3162),
    [anon_sym_decltype] = ACTIONS(3162),
    [anon_sym_virtual] = ACTIONS(3162),
    [anon_sym_alignas] = ACTIONS(3162),
    [anon_sym_explicit] = ACTIONS(3162),
    [anon_sym_typename] = ACTIONS(3162),
    [anon_sym_template] = ACTIONS(3162),
    [anon_sym_operator] = ACTIONS(3162),
    [anon_sym_friend] = ACTIONS(3162),
    [anon_sym_public] = ACTIONS(3162),
    [anon_sym_private] = ACTIONS(3162),
    [anon_sym_protected] = ACTIONS(3162),
    [anon_sym_using] = ACTIONS(3162),
    [anon_sym_static_assert] = ACTIONS(3162),
  },
  [2138] = {
    [sym__declaration_modifiers] = STATE(4180),
    [sym_attribute_specifier] = STATE(4180),
    [sym_attribute_declaration] = STATE(4180),
    [sym_ms_declspec_modifier] = STATE(4180),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7048),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(4180),
    [sym_type_qualifier] = STATE(4180),
    [sym_decltype] = STATE(9504),
    [sym_virtual] = STATE(4180),
    [sym_alignas_specifier] = STATE(4180),
    [sym_explicit_function_specifier] = STATE(4180),
    [sym_operator_cast] = STATE(7531),
    [sym__constructor_specifiers] = STATE(4180),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(9504),
    [sym_template_function] = STATE(7008),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6421),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_operator_cast_identifier] = STATE(7531),
    [sym_operator_name] = STATE(7008),
    [aux_sym_operator_cast_definition_repeat1] = STATE(4180),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(5449),
    [anon_sym_extern] = ACTIONS(5451),
    [anon_sym___attribute__] = ACTIONS(5453),
    [anon_sym_COLON_COLON] = ACTIONS(5455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5457),
    [anon_sym___declspec] = ACTIONS(5459),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(5451),
    [anon_sym_register] = ACTIONS(5451),
    [anon_sym_inline] = ACTIONS(5451),
    [anon_sym___inline] = ACTIONS(5451),
    [anon_sym___inline__] = ACTIONS(5451),
    [anon_sym___forceinline] = ACTIONS(5451),
    [anon_sym_thread_local] = ACTIONS(5451),
    [anon_sym___thread] = ACTIONS(5451),
    [anon_sym_const] = ACTIONS(5449),
    [anon_sym_constexpr] = ACTIONS(5449),
    [anon_sym_volatile] = ACTIONS(5449),
    [anon_sym_restrict] = ACTIONS(5449),
    [anon_sym___restrict__] = ACTIONS(5449),
    [anon_sym__Atomic] = ACTIONS(5449),
    [anon_sym__Noreturn] = ACTIONS(5449),
    [anon_sym_noreturn] = ACTIONS(5449),
    [anon_sym_mutable] = ACTIONS(5449),
    [anon_sym_constinit] = ACTIONS(5449),
    [anon_sym_consteval] = ACTIONS(5449),
    [anon_sym_PROGMEM] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_virtual] = ACTIONS(5461),
    [anon_sym_alignas] = ACTIONS(5463),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(133),
  },
  [2139] = {
    [sym_identifier] = ACTIONS(3439),
    [aux_sym_preproc_def_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token2] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3439),
    [aux_sym_preproc_else_token1] = ACTIONS(3439),
    [aux_sym_preproc_elif_token1] = ACTIONS(3439),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3439),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3439),
    [sym_preproc_directive] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3439),
    [anon_sym___extension__] = ACTIONS(3439),
    [anon_sym_typedef] = ACTIONS(3439),
    [anon_sym_extern] = ACTIONS(3439),
    [anon_sym___attribute__] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3441),
    [anon_sym___declspec] = ACTIONS(3439),
    [anon_sym___based] = ACTIONS(3439),
    [anon_sym_signed] = ACTIONS(3439),
    [anon_sym_unsigned] = ACTIONS(3439),
    [anon_sym_long] = ACTIONS(3439),
    [anon_sym_short] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_register] = ACTIONS(3439),
    [anon_sym_inline] = ACTIONS(3439),
    [anon_sym___inline] = ACTIONS(3439),
    [anon_sym___inline__] = ACTIONS(3439),
    [anon_sym___forceinline] = ACTIONS(3439),
    [anon_sym_thread_local] = ACTIONS(3439),
    [anon_sym___thread] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_constexpr] = ACTIONS(3439),
    [anon_sym_volatile] = ACTIONS(3439),
    [anon_sym_restrict] = ACTIONS(3439),
    [anon_sym___restrict__] = ACTIONS(3439),
    [anon_sym__Atomic] = ACTIONS(3439),
    [anon_sym__Noreturn] = ACTIONS(3439),
    [anon_sym_noreturn] = ACTIONS(3439),
    [anon_sym_mutable] = ACTIONS(3439),
    [anon_sym_constinit] = ACTIONS(3439),
    [anon_sym_consteval] = ACTIONS(3439),
    [anon_sym_PROGMEM] = ACTIONS(3439),
    [aux_sym_primitive_type_token1] = ACTIONS(3439),
    [anon_sym_byte] = ACTIONS(3439),
    [anon_sym_word] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_struct] = ACTIONS(3439),
    [anon_sym_union] = ACTIONS(3439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3439),
    [anon_sym_decltype] = ACTIONS(3439),
    [anon_sym_virtual] = ACTIONS(3439),
    [anon_sym_alignas] = ACTIONS(3439),
    [anon_sym_explicit] = ACTIONS(3439),
    [anon_sym_typename] = ACTIONS(3439),
    [anon_sym_template] = ACTIONS(3439),
    [anon_sym_operator] = ACTIONS(3439),
    [anon_sym_friend] = ACTIONS(3439),
    [anon_sym_public] = ACTIONS(3439),
    [anon_sym_private] = ACTIONS(3439),
    [anon_sym_protected] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_static_assert] = ACTIONS(3439),
  },
  [2140] = {
    [sym_identifier] = ACTIONS(3439),
    [aux_sym_preproc_def_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token2] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3439),
    [aux_sym_preproc_else_token1] = ACTIONS(3439),
    [aux_sym_preproc_elif_token1] = ACTIONS(3439),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3439),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3439),
    [sym_preproc_directive] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3439),
    [anon_sym___extension__] = ACTIONS(3439),
    [anon_sym_typedef] = ACTIONS(3439),
    [anon_sym_extern] = ACTIONS(3439),
    [anon_sym___attribute__] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3441),
    [anon_sym___declspec] = ACTIONS(3439),
    [anon_sym___based] = ACTIONS(3439),
    [anon_sym_signed] = ACTIONS(3439),
    [anon_sym_unsigned] = ACTIONS(3439),
    [anon_sym_long] = ACTIONS(3439),
    [anon_sym_short] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_register] = ACTIONS(3439),
    [anon_sym_inline] = ACTIONS(3439),
    [anon_sym___inline] = ACTIONS(3439),
    [anon_sym___inline__] = ACTIONS(3439),
    [anon_sym___forceinline] = ACTIONS(3439),
    [anon_sym_thread_local] = ACTIONS(3439),
    [anon_sym___thread] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_constexpr] = ACTIONS(3439),
    [anon_sym_volatile] = ACTIONS(3439),
    [anon_sym_restrict] = ACTIONS(3439),
    [anon_sym___restrict__] = ACTIONS(3439),
    [anon_sym__Atomic] = ACTIONS(3439),
    [anon_sym__Noreturn] = ACTIONS(3439),
    [anon_sym_noreturn] = ACTIONS(3439),
    [anon_sym_mutable] = ACTIONS(3439),
    [anon_sym_constinit] = ACTIONS(3439),
    [anon_sym_consteval] = ACTIONS(3439),
    [anon_sym_PROGMEM] = ACTIONS(3439),
    [aux_sym_primitive_type_token1] = ACTIONS(3439),
    [anon_sym_byte] = ACTIONS(3439),
    [anon_sym_word] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_struct] = ACTIONS(3439),
    [anon_sym_union] = ACTIONS(3439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3439),
    [anon_sym_decltype] = ACTIONS(3439),
    [anon_sym_virtual] = ACTIONS(3439),
    [anon_sym_alignas] = ACTIONS(3439),
    [anon_sym_explicit] = ACTIONS(3439),
    [anon_sym_typename] = ACTIONS(3439),
    [anon_sym_template] = ACTIONS(3439),
    [anon_sym_operator] = ACTIONS(3439),
    [anon_sym_friend] = ACTIONS(3439),
    [anon_sym_public] = ACTIONS(3439),
    [anon_sym_private] = ACTIONS(3439),
    [anon_sym_protected] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_static_assert] = ACTIONS(3439),
  },
  [2141] = {
    [sym_identifier] = ACTIONS(3435),
    [aux_sym_preproc_def_token1] = ACTIONS(3435),
    [aux_sym_preproc_if_token1] = ACTIONS(3435),
    [aux_sym_preproc_if_token2] = ACTIONS(3435),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3435),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3435),
    [aux_sym_preproc_else_token1] = ACTIONS(3435),
    [aux_sym_preproc_elif_token1] = ACTIONS(3435),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3435),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3435),
    [sym_preproc_directive] = ACTIONS(3435),
    [anon_sym_LPAREN2] = ACTIONS(3437),
    [anon_sym_TILDE] = ACTIONS(3437),
    [anon_sym_STAR] = ACTIONS(3437),
    [anon_sym_AMP_AMP] = ACTIONS(3437),
    [anon_sym_AMP] = ACTIONS(3435),
    [anon_sym___extension__] = ACTIONS(3435),
    [anon_sym_typedef] = ACTIONS(3435),
    [anon_sym_extern] = ACTIONS(3435),
    [anon_sym___attribute__] = ACTIONS(3435),
    [anon_sym_COLON_COLON] = ACTIONS(3437),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3437),
    [anon_sym___declspec] = ACTIONS(3435),
    [anon_sym___based] = ACTIONS(3435),
    [anon_sym_signed] = ACTIONS(3435),
    [anon_sym_unsigned] = ACTIONS(3435),
    [anon_sym_long] = ACTIONS(3435),
    [anon_sym_short] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3435),
    [anon_sym_static] = ACTIONS(3435),
    [anon_sym_register] = ACTIONS(3435),
    [anon_sym_inline] = ACTIONS(3435),
    [anon_sym___inline] = ACTIONS(3435),
    [anon_sym___inline__] = ACTIONS(3435),
    [anon_sym___forceinline] = ACTIONS(3435),
    [anon_sym_thread_local] = ACTIONS(3435),
    [anon_sym___thread] = ACTIONS(3435),
    [anon_sym_const] = ACTIONS(3435),
    [anon_sym_constexpr] = ACTIONS(3435),
    [anon_sym_volatile] = ACTIONS(3435),
    [anon_sym_restrict] = ACTIONS(3435),
    [anon_sym___restrict__] = ACTIONS(3435),
    [anon_sym__Atomic] = ACTIONS(3435),
    [anon_sym__Noreturn] = ACTIONS(3435),
    [anon_sym_noreturn] = ACTIONS(3435),
    [anon_sym_mutable] = ACTIONS(3435),
    [anon_sym_constinit] = ACTIONS(3435),
    [anon_sym_consteval] = ACTIONS(3435),
    [anon_sym_PROGMEM] = ACTIONS(3435),
    [aux_sym_primitive_type_token1] = ACTIONS(3435),
    [anon_sym_byte] = ACTIONS(3435),
    [anon_sym_word] = ACTIONS(3435),
    [anon_sym_enum] = ACTIONS(3435),
    [anon_sym_class] = ACTIONS(3435),
    [anon_sym_struct] = ACTIONS(3435),
    [anon_sym_union] = ACTIONS(3435),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3435),
    [anon_sym_decltype] = ACTIONS(3435),
    [anon_sym_virtual] = ACTIONS(3435),
    [anon_sym_alignas] = ACTIONS(3435),
    [anon_sym_explicit] = ACTIONS(3435),
    [anon_sym_typename] = ACTIONS(3435),
    [anon_sym_template] = ACTIONS(3435),
    [anon_sym_operator] = ACTIONS(3435),
    [anon_sym_friend] = ACTIONS(3435),
    [anon_sym_public] = ACTIONS(3435),
    [anon_sym_private] = ACTIONS(3435),
    [anon_sym_protected] = ACTIONS(3435),
    [anon_sym_using] = ACTIONS(3435),
    [anon_sym_static_assert] = ACTIONS(3435),
  },
  [2142] = {
    [sym_identifier] = ACTIONS(5481),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5483),
    [anon_sym_COMMA] = ACTIONS(5483),
    [anon_sym_RPAREN] = ACTIONS(5483),
    [anon_sym_LPAREN2] = ACTIONS(5483),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_PLUS] = ACTIONS(5481),
    [anon_sym_STAR] = ACTIONS(5483),
    [anon_sym_SLASH] = ACTIONS(5481),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_PIPE_PIPE] = ACTIONS(5483),
    [anon_sym_AMP_AMP] = ACTIONS(5483),
    [anon_sym_PIPE] = ACTIONS(5481),
    [anon_sym_CARET] = ACTIONS(5483),
    [anon_sym_AMP] = ACTIONS(5481),
    [anon_sym_EQ_EQ] = ACTIONS(5483),
    [anon_sym_BANG_EQ] = ACTIONS(5483),
    [anon_sym_GT] = ACTIONS(5481),
    [anon_sym_GT_EQ] = ACTIONS(5483),
    [anon_sym_LT_EQ] = ACTIONS(5481),
    [anon_sym_LT] = ACTIONS(5481),
    [anon_sym_LT_LT] = ACTIONS(5483),
    [anon_sym_GT_GT] = ACTIONS(5483),
    [anon_sym_SEMI] = ACTIONS(5483),
    [anon_sym___extension__] = ACTIONS(5481),
    [anon_sym___attribute__] = ACTIONS(5481),
    [anon_sym_COLON_COLON] = ACTIONS(5485),
    [anon_sym___based] = ACTIONS(5481),
    [anon_sym_LBRACE] = ACTIONS(5483),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_signed] = ACTIONS(5481),
    [anon_sym_unsigned] = ACTIONS(5481),
    [anon_sym_long] = ACTIONS(5481),
    [anon_sym_short] = ACTIONS(5481),
    [anon_sym_LBRACK] = ACTIONS(5483),
    [anon_sym_RBRACK] = ACTIONS(5483),
    [anon_sym_const] = ACTIONS(5481),
    [anon_sym_constexpr] = ACTIONS(5481),
    [anon_sym_volatile] = ACTIONS(5481),
    [anon_sym_restrict] = ACTIONS(5481),
    [anon_sym___restrict__] = ACTIONS(5481),
    [anon_sym__Atomic] = ACTIONS(5481),
    [anon_sym__Noreturn] = ACTIONS(5481),
    [anon_sym_noreturn] = ACTIONS(5481),
    [anon_sym_mutable] = ACTIONS(5481),
    [anon_sym_constinit] = ACTIONS(5481),
    [anon_sym_consteval] = ACTIONS(5481),
    [anon_sym_PROGMEM] = ACTIONS(5481),
    [aux_sym_primitive_type_token1] = ACTIONS(5481),
    [anon_sym_byte] = ACTIONS(5481),
    [anon_sym_word] = ACTIONS(5481),
    [anon_sym_COLON] = ACTIONS(5481),
    [anon_sym_QMARK] = ACTIONS(5483),
    [anon_sym_LT_EQ_GT] = ACTIONS(5483),
    [anon_sym_or] = ACTIONS(5481),
    [anon_sym_and] = ACTIONS(5481),
    [anon_sym_bitor] = ACTIONS(5481),
    [anon_sym_xor] = ACTIONS(5481),
    [anon_sym_bitand] = ACTIONS(5481),
    [anon_sym_not_eq] = ACTIONS(5481),
    [anon_sym_DASH_DASH] = ACTIONS(5483),
    [anon_sym_PLUS_PLUS] = ACTIONS(5483),
    [anon_sym_DOT] = ACTIONS(5481),
    [anon_sym_DOT_STAR] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5481),
    [anon_sym_decltype] = ACTIONS(5481),
    [anon_sym_final] = ACTIONS(5481),
    [anon_sym_override] = ACTIONS(5481),
    [anon_sym_requires] = ACTIONS(5481),
  },
  [2143] = {
    [sym_identifier] = ACTIONS(3186),
    [aux_sym_preproc_def_token1] = ACTIONS(3186),
    [aux_sym_preproc_if_token1] = ACTIONS(3186),
    [aux_sym_preproc_if_token2] = ACTIONS(3186),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3186),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3186),
    [aux_sym_preproc_else_token1] = ACTIONS(3186),
    [aux_sym_preproc_elif_token1] = ACTIONS(3186),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3186),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3186),
    [sym_preproc_directive] = ACTIONS(3186),
    [anon_sym_LPAREN2] = ACTIONS(3188),
    [anon_sym_TILDE] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(3188),
    [anon_sym_AMP_AMP] = ACTIONS(3188),
    [anon_sym_AMP] = ACTIONS(3186),
    [anon_sym___extension__] = ACTIONS(3186),
    [anon_sym_typedef] = ACTIONS(3186),
    [anon_sym_extern] = ACTIONS(3186),
    [anon_sym___attribute__] = ACTIONS(3186),
    [anon_sym_COLON_COLON] = ACTIONS(3188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3188),
    [anon_sym___declspec] = ACTIONS(3186),
    [anon_sym___based] = ACTIONS(3186),
    [anon_sym_signed] = ACTIONS(3186),
    [anon_sym_unsigned] = ACTIONS(3186),
    [anon_sym_long] = ACTIONS(3186),
    [anon_sym_short] = ACTIONS(3186),
    [anon_sym_LBRACK] = ACTIONS(3186),
    [anon_sym_static] = ACTIONS(3186),
    [anon_sym_register] = ACTIONS(3186),
    [anon_sym_inline] = ACTIONS(3186),
    [anon_sym___inline] = ACTIONS(3186),
    [anon_sym___inline__] = ACTIONS(3186),
    [anon_sym___forceinline] = ACTIONS(3186),
    [anon_sym_thread_local] = ACTIONS(3186),
    [anon_sym___thread] = ACTIONS(3186),
    [anon_sym_const] = ACTIONS(3186),
    [anon_sym_constexpr] = ACTIONS(3186),
    [anon_sym_volatile] = ACTIONS(3186),
    [anon_sym_restrict] = ACTIONS(3186),
    [anon_sym___restrict__] = ACTIONS(3186),
    [anon_sym__Atomic] = ACTIONS(3186),
    [anon_sym__Noreturn] = ACTIONS(3186),
    [anon_sym_noreturn] = ACTIONS(3186),
    [anon_sym_mutable] = ACTIONS(3186),
    [anon_sym_constinit] = ACTIONS(3186),
    [anon_sym_consteval] = ACTIONS(3186),
    [anon_sym_PROGMEM] = ACTIONS(3186),
    [aux_sym_primitive_type_token1] = ACTIONS(3186),
    [anon_sym_byte] = ACTIONS(3186),
    [anon_sym_word] = ACTIONS(3186),
    [anon_sym_enum] = ACTIONS(3186),
    [anon_sym_class] = ACTIONS(3186),
    [anon_sym_struct] = ACTIONS(3186),
    [anon_sym_union] = ACTIONS(3186),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3186),
    [anon_sym_decltype] = ACTIONS(3186),
    [anon_sym_virtual] = ACTIONS(3186),
    [anon_sym_alignas] = ACTIONS(3186),
    [anon_sym_explicit] = ACTIONS(3186),
    [anon_sym_typename] = ACTIONS(3186),
    [anon_sym_template] = ACTIONS(3186),
    [anon_sym_operator] = ACTIONS(3186),
    [anon_sym_friend] = ACTIONS(3186),
    [anon_sym_public] = ACTIONS(3186),
    [anon_sym_private] = ACTIONS(3186),
    [anon_sym_protected] = ACTIONS(3186),
    [anon_sym_using] = ACTIONS(3186),
    [anon_sym_static_assert] = ACTIONS(3186),
  },
  [2144] = {
    [sym__declaration_modifiers] = STATE(4180),
    [sym_attribute_specifier] = STATE(4180),
    [sym_attribute_declaration] = STATE(4180),
    [sym_ms_declspec_modifier] = STATE(4180),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7033),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(4180),
    [sym_type_qualifier] = STATE(4180),
    [sym_decltype] = STATE(9504),
    [sym_virtual] = STATE(4180),
    [sym_alignas_specifier] = STATE(4180),
    [sym_explicit_function_specifier] = STATE(4180),
    [sym_operator_cast] = STATE(7517),
    [sym__constructor_specifiers] = STATE(4180),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(9504),
    [sym_template_function] = STATE(7008),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6421),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_operator_cast_identifier] = STATE(7517),
    [sym_operator_name] = STATE(7008),
    [aux_sym_operator_cast_definition_repeat1] = STATE(4180),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(5449),
    [anon_sym_extern] = ACTIONS(5451),
    [anon_sym___attribute__] = ACTIONS(5453),
    [anon_sym_COLON_COLON] = ACTIONS(5455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5457),
    [anon_sym___declspec] = ACTIONS(5459),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(5451),
    [anon_sym_register] = ACTIONS(5451),
    [anon_sym_inline] = ACTIONS(5451),
    [anon_sym___inline] = ACTIONS(5451),
    [anon_sym___inline__] = ACTIONS(5451),
    [anon_sym___forceinline] = ACTIONS(5451),
    [anon_sym_thread_local] = ACTIONS(5451),
    [anon_sym___thread] = ACTIONS(5451),
    [anon_sym_const] = ACTIONS(5449),
    [anon_sym_constexpr] = ACTIONS(5449),
    [anon_sym_volatile] = ACTIONS(5449),
    [anon_sym_restrict] = ACTIONS(5449),
    [anon_sym___restrict__] = ACTIONS(5449),
    [anon_sym__Atomic] = ACTIONS(5449),
    [anon_sym__Noreturn] = ACTIONS(5449),
    [anon_sym_noreturn] = ACTIONS(5449),
    [anon_sym_mutable] = ACTIONS(5449),
    [anon_sym_constinit] = ACTIONS(5449),
    [anon_sym_consteval] = ACTIONS(5449),
    [anon_sym_PROGMEM] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_virtual] = ACTIONS(5461),
    [anon_sym_alignas] = ACTIONS(5463),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(133),
  },
  [2145] = {
    [sym_primitive_type] = STATE(2714),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2281),
    [sym_identifier] = ACTIONS(5487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5489),
    [anon_sym_COMMA] = ACTIONS(5489),
    [anon_sym_RPAREN] = ACTIONS(5489),
    [anon_sym_LPAREN2] = ACTIONS(5489),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_PLUS] = ACTIONS(5491),
    [anon_sym_STAR] = ACTIONS(5489),
    [anon_sym_SLASH] = ACTIONS(5491),
    [anon_sym_PERCENT] = ACTIONS(5489),
    [anon_sym_PIPE_PIPE] = ACTIONS(5489),
    [anon_sym_AMP_AMP] = ACTIONS(5489),
    [anon_sym_PIPE] = ACTIONS(5491),
    [anon_sym_CARET] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_EQ_EQ] = ACTIONS(5489),
    [anon_sym_BANG_EQ] = ACTIONS(5489),
    [anon_sym_GT] = ACTIONS(5491),
    [anon_sym_GT_EQ] = ACTIONS(5489),
    [anon_sym_LT_EQ] = ACTIONS(5491),
    [anon_sym_LT] = ACTIONS(5491),
    [anon_sym_LT_LT] = ACTIONS(5489),
    [anon_sym_GT_GT] = ACTIONS(5489),
    [anon_sym_SEMI] = ACTIONS(5489),
    [anon_sym___extension__] = ACTIONS(5491),
    [anon_sym___attribute__] = ACTIONS(5491),
    [anon_sym_LBRACE] = ACTIONS(5489),
    [anon_sym_RBRACE] = ACTIONS(5489),
    [anon_sym_signed] = ACTIONS(5493),
    [anon_sym_unsigned] = ACTIONS(5493),
    [anon_sym_long] = ACTIONS(5493),
    [anon_sym_short] = ACTIONS(5493),
    [anon_sym_LBRACK] = ACTIONS(5489),
    [anon_sym_RBRACK] = ACTIONS(5489),
    [anon_sym_const] = ACTIONS(5491),
    [anon_sym_constexpr] = ACTIONS(5491),
    [anon_sym_volatile] = ACTIONS(5491),
    [anon_sym_restrict] = ACTIONS(5491),
    [anon_sym___restrict__] = ACTIONS(5491),
    [anon_sym__Atomic] = ACTIONS(5491),
    [anon_sym__Noreturn] = ACTIONS(5491),
    [anon_sym_noreturn] = ACTIONS(5491),
    [anon_sym_mutable] = ACTIONS(5491),
    [anon_sym_constinit] = ACTIONS(5491),
    [anon_sym_consteval] = ACTIONS(5491),
    [anon_sym_PROGMEM] = ACTIONS(5491),
    [aux_sym_primitive_type_token1] = ACTIONS(2097),
    [anon_sym_byte] = ACTIONS(2097),
    [anon_sym_word] = ACTIONS(2097),
    [anon_sym_COLON] = ACTIONS(5489),
    [anon_sym_QMARK] = ACTIONS(5489),
    [anon_sym_LT_EQ_GT] = ACTIONS(5489),
    [anon_sym_or] = ACTIONS(5491),
    [anon_sym_and] = ACTIONS(5491),
    [anon_sym_bitor] = ACTIONS(5491),
    [anon_sym_xor] = ACTIONS(5491),
    [anon_sym_bitand] = ACTIONS(5491),
    [anon_sym_not_eq] = ACTIONS(5491),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_DOT] = ACTIONS(5491),
    [anon_sym_DOT_STAR] = ACTIONS(5489),
    [anon_sym_DASH_GT] = ACTIONS(5489),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5491),
    [anon_sym_decltype] = ACTIONS(5491),
    [anon_sym_final] = ACTIONS(5491),
    [anon_sym_override] = ACTIONS(5491),
    [anon_sym_requires] = ACTIONS(5491),
  },
  [2146] = {
    [sym_identifier] = ACTIONS(3310),
    [aux_sym_preproc_def_token1] = ACTIONS(3310),
    [aux_sym_preproc_if_token1] = ACTIONS(3310),
    [aux_sym_preproc_if_token2] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3310),
    [aux_sym_preproc_else_token1] = ACTIONS(3310),
    [aux_sym_preproc_elif_token1] = ACTIONS(3310),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3310),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3310),
    [sym_preproc_directive] = ACTIONS(3310),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_AMP_AMP] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3310),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_typedef] = ACTIONS(3310),
    [anon_sym_extern] = ACTIONS(3310),
    [anon_sym___attribute__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3312),
    [anon_sym___declspec] = ACTIONS(3310),
    [anon_sym___based] = ACTIONS(3310),
    [anon_sym_signed] = ACTIONS(3310),
    [anon_sym_unsigned] = ACTIONS(3310),
    [anon_sym_long] = ACTIONS(3310),
    [anon_sym_short] = ACTIONS(3310),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [anon_sym_static] = ACTIONS(3310),
    [anon_sym_register] = ACTIONS(3310),
    [anon_sym_inline] = ACTIONS(3310),
    [anon_sym___inline] = ACTIONS(3310),
    [anon_sym___inline__] = ACTIONS(3310),
    [anon_sym___forceinline] = ACTIONS(3310),
    [anon_sym_thread_local] = ACTIONS(3310),
    [anon_sym___thread] = ACTIONS(3310),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_constexpr] = ACTIONS(3310),
    [anon_sym_volatile] = ACTIONS(3310),
    [anon_sym_restrict] = ACTIONS(3310),
    [anon_sym___restrict__] = ACTIONS(3310),
    [anon_sym__Atomic] = ACTIONS(3310),
    [anon_sym__Noreturn] = ACTIONS(3310),
    [anon_sym_noreturn] = ACTIONS(3310),
    [anon_sym_mutable] = ACTIONS(3310),
    [anon_sym_constinit] = ACTIONS(3310),
    [anon_sym_consteval] = ACTIONS(3310),
    [anon_sym_PROGMEM] = ACTIONS(3310),
    [aux_sym_primitive_type_token1] = ACTIONS(3310),
    [anon_sym_byte] = ACTIONS(3310),
    [anon_sym_word] = ACTIONS(3310),
    [anon_sym_enum] = ACTIONS(3310),
    [anon_sym_class] = ACTIONS(3310),
    [anon_sym_struct] = ACTIONS(3310),
    [anon_sym_union] = ACTIONS(3310),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3310),
    [anon_sym_decltype] = ACTIONS(3310),
    [anon_sym_virtual] = ACTIONS(3310),
    [anon_sym_alignas] = ACTIONS(3310),
    [anon_sym_explicit] = ACTIONS(3310),
    [anon_sym_typename] = ACTIONS(3310),
    [anon_sym_template] = ACTIONS(3310),
    [anon_sym_operator] = ACTIONS(3310),
    [anon_sym_friend] = ACTIONS(3310),
    [anon_sym_public] = ACTIONS(3310),
    [anon_sym_private] = ACTIONS(3310),
    [anon_sym_protected] = ACTIONS(3310),
    [anon_sym_using] = ACTIONS(3310),
    [anon_sym_static_assert] = ACTIONS(3310),
  },
  [2147] = {
    [sym_identifier] = ACTIONS(3314),
    [aux_sym_preproc_def_token1] = ACTIONS(3314),
    [aux_sym_preproc_if_token1] = ACTIONS(3314),
    [aux_sym_preproc_if_token2] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3314),
    [aux_sym_preproc_else_token1] = ACTIONS(3314),
    [aux_sym_preproc_elif_token1] = ACTIONS(3314),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3314),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3314),
    [sym_preproc_directive] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_STAR] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym___extension__] = ACTIONS(3314),
    [anon_sym_typedef] = ACTIONS(3314),
    [anon_sym_extern] = ACTIONS(3314),
    [anon_sym___attribute__] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3316),
    [anon_sym___declspec] = ACTIONS(3314),
    [anon_sym___based] = ACTIONS(3314),
    [anon_sym_signed] = ACTIONS(3314),
    [anon_sym_unsigned] = ACTIONS(3314),
    [anon_sym_long] = ACTIONS(3314),
    [anon_sym_short] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_static] = ACTIONS(3314),
    [anon_sym_register] = ACTIONS(3314),
    [anon_sym_inline] = ACTIONS(3314),
    [anon_sym___inline] = ACTIONS(3314),
    [anon_sym___inline__] = ACTIONS(3314),
    [anon_sym___forceinline] = ACTIONS(3314),
    [anon_sym_thread_local] = ACTIONS(3314),
    [anon_sym___thread] = ACTIONS(3314),
    [anon_sym_const] = ACTIONS(3314),
    [anon_sym_constexpr] = ACTIONS(3314),
    [anon_sym_volatile] = ACTIONS(3314),
    [anon_sym_restrict] = ACTIONS(3314),
    [anon_sym___restrict__] = ACTIONS(3314),
    [anon_sym__Atomic] = ACTIONS(3314),
    [anon_sym__Noreturn] = ACTIONS(3314),
    [anon_sym_noreturn] = ACTIONS(3314),
    [anon_sym_mutable] = ACTIONS(3314),
    [anon_sym_constinit] = ACTIONS(3314),
    [anon_sym_consteval] = ACTIONS(3314),
    [anon_sym_PROGMEM] = ACTIONS(3314),
    [aux_sym_primitive_type_token1] = ACTIONS(3314),
    [anon_sym_byte] = ACTIONS(3314),
    [anon_sym_word] = ACTIONS(3314),
    [anon_sym_enum] = ACTIONS(3314),
    [anon_sym_class] = ACTIONS(3314),
    [anon_sym_struct] = ACTIONS(3314),
    [anon_sym_union] = ACTIONS(3314),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3314),
    [anon_sym_decltype] = ACTIONS(3314),
    [anon_sym_virtual] = ACTIONS(3314),
    [anon_sym_alignas] = ACTIONS(3314),
    [anon_sym_explicit] = ACTIONS(3314),
    [anon_sym_typename] = ACTIONS(3314),
    [anon_sym_template] = ACTIONS(3314),
    [anon_sym_operator] = ACTIONS(3314),
    [anon_sym_friend] = ACTIONS(3314),
    [anon_sym_public] = ACTIONS(3314),
    [anon_sym_private] = ACTIONS(3314),
    [anon_sym_protected] = ACTIONS(3314),
    [anon_sym_using] = ACTIONS(3314),
    [anon_sym_static_assert] = ACTIONS(3314),
  },
  [2148] = {
    [sym_identifier] = ACTIONS(5495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5497),
    [anon_sym_COMMA] = ACTIONS(5497),
    [anon_sym_RPAREN] = ACTIONS(5497),
    [anon_sym_LPAREN2] = ACTIONS(5497),
    [anon_sym_DASH] = ACTIONS(5495),
    [anon_sym_PLUS] = ACTIONS(5495),
    [anon_sym_STAR] = ACTIONS(5497),
    [anon_sym_SLASH] = ACTIONS(5495),
    [anon_sym_PERCENT] = ACTIONS(5497),
    [anon_sym_PIPE_PIPE] = ACTIONS(5497),
    [anon_sym_AMP_AMP] = ACTIONS(5497),
    [anon_sym_PIPE] = ACTIONS(5495),
    [anon_sym_CARET] = ACTIONS(5497),
    [anon_sym_AMP] = ACTIONS(5495),
    [anon_sym_EQ_EQ] = ACTIONS(5497),
    [anon_sym_BANG_EQ] = ACTIONS(5497),
    [anon_sym_GT] = ACTIONS(5495),
    [anon_sym_GT_EQ] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5495),
    [anon_sym_LT_LT] = ACTIONS(5497),
    [anon_sym_GT_GT] = ACTIONS(5497),
    [anon_sym_SEMI] = ACTIONS(5497),
    [anon_sym___extension__] = ACTIONS(5495),
    [anon_sym___attribute__] = ACTIONS(5495),
    [anon_sym_COLON_COLON] = ACTIONS(5485),
    [anon_sym___based] = ACTIONS(5495),
    [anon_sym_LBRACE] = ACTIONS(5497),
    [anon_sym_RBRACE] = ACTIONS(5497),
    [anon_sym_signed] = ACTIONS(5495),
    [anon_sym_unsigned] = ACTIONS(5495),
    [anon_sym_long] = ACTIONS(5495),
    [anon_sym_short] = ACTIONS(5495),
    [anon_sym_LBRACK] = ACTIONS(5497),
    [anon_sym_RBRACK] = ACTIONS(5497),
    [anon_sym_const] = ACTIONS(5495),
    [anon_sym_constexpr] = ACTIONS(5495),
    [anon_sym_volatile] = ACTIONS(5495),
    [anon_sym_restrict] = ACTIONS(5495),
    [anon_sym___restrict__] = ACTIONS(5495),
    [anon_sym__Atomic] = ACTIONS(5495),
    [anon_sym__Noreturn] = ACTIONS(5495),
    [anon_sym_noreturn] = ACTIONS(5495),
    [anon_sym_mutable] = ACTIONS(5495),
    [anon_sym_constinit] = ACTIONS(5495),
    [anon_sym_consteval] = ACTIONS(5495),
    [anon_sym_PROGMEM] = ACTIONS(5495),
    [aux_sym_primitive_type_token1] = ACTIONS(5495),
    [anon_sym_byte] = ACTIONS(5495),
    [anon_sym_word] = ACTIONS(5495),
    [anon_sym_COLON] = ACTIONS(5495),
    [anon_sym_QMARK] = ACTIONS(5497),
    [anon_sym_LT_EQ_GT] = ACTIONS(5497),
    [anon_sym_or] = ACTIONS(5495),
    [anon_sym_and] = ACTIONS(5495),
    [anon_sym_bitor] = ACTIONS(5495),
    [anon_sym_xor] = ACTIONS(5495),
    [anon_sym_bitand] = ACTIONS(5495),
    [anon_sym_not_eq] = ACTIONS(5495),
    [anon_sym_DASH_DASH] = ACTIONS(5497),
    [anon_sym_PLUS_PLUS] = ACTIONS(5497),
    [anon_sym_DOT] = ACTIONS(5495),
    [anon_sym_DOT_STAR] = ACTIONS(5497),
    [anon_sym_DASH_GT] = ACTIONS(5497),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5495),
    [anon_sym_decltype] = ACTIONS(5495),
    [anon_sym_final] = ACTIONS(5495),
    [anon_sym_override] = ACTIONS(5495),
    [anon_sym_requires] = ACTIONS(5495),
  },
  [2149] = {
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5599),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5204),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2150] = {
    [sym__declaration_modifiers] = STATE(4180),
    [sym_attribute_specifier] = STATE(4180),
    [sym_attribute_declaration] = STATE(4180),
    [sym_ms_declspec_modifier] = STATE(4180),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7092),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(4180),
    [sym_type_qualifier] = STATE(4180),
    [sym_decltype] = STATE(9504),
    [sym_virtual] = STATE(4180),
    [sym_alignas_specifier] = STATE(4180),
    [sym_explicit_function_specifier] = STATE(4180),
    [sym_operator_cast] = STATE(7511),
    [sym__constructor_specifiers] = STATE(4180),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(9504),
    [sym_template_function] = STATE(7008),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6421),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_operator_cast_identifier] = STATE(7511),
    [sym_operator_name] = STATE(7008),
    [aux_sym_operator_cast_definition_repeat1] = STATE(4180),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(5449),
    [anon_sym_extern] = ACTIONS(5451),
    [anon_sym___attribute__] = ACTIONS(5453),
    [anon_sym_COLON_COLON] = ACTIONS(5455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5457),
    [anon_sym___declspec] = ACTIONS(5459),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(5451),
    [anon_sym_register] = ACTIONS(5451),
    [anon_sym_inline] = ACTIONS(5451),
    [anon_sym___inline] = ACTIONS(5451),
    [anon_sym___inline__] = ACTIONS(5451),
    [anon_sym___forceinline] = ACTIONS(5451),
    [anon_sym_thread_local] = ACTIONS(5451),
    [anon_sym___thread] = ACTIONS(5451),
    [anon_sym_const] = ACTIONS(5449),
    [anon_sym_constexpr] = ACTIONS(5449),
    [anon_sym_volatile] = ACTIONS(5449),
    [anon_sym_restrict] = ACTIONS(5449),
    [anon_sym___restrict__] = ACTIONS(5449),
    [anon_sym__Atomic] = ACTIONS(5449),
    [anon_sym__Noreturn] = ACTIONS(5449),
    [anon_sym_noreturn] = ACTIONS(5449),
    [anon_sym_mutable] = ACTIONS(5449),
    [anon_sym_constinit] = ACTIONS(5449),
    [anon_sym_consteval] = ACTIONS(5449),
    [anon_sym_PROGMEM] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_virtual] = ACTIONS(5461),
    [anon_sym_alignas] = ACTIONS(5463),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(133),
  },
  [2151] = {
    [sym__declaration_modifiers] = STATE(4180),
    [sym_attribute_specifier] = STATE(4180),
    [sym_attribute_declaration] = STATE(4180),
    [sym_ms_declspec_modifier] = STATE(4180),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7084),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(4180),
    [sym_type_qualifier] = STATE(4180),
    [sym_decltype] = STATE(9504),
    [sym_virtual] = STATE(4180),
    [sym_alignas_specifier] = STATE(4180),
    [sym_explicit_function_specifier] = STATE(4180),
    [sym_operator_cast] = STATE(7495),
    [sym__constructor_specifiers] = STATE(4180),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(9504),
    [sym_template_function] = STATE(7008),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6421),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_operator_cast_identifier] = STATE(7495),
    [sym_operator_name] = STATE(7008),
    [aux_sym_operator_cast_definition_repeat1] = STATE(4180),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(5449),
    [anon_sym_extern] = ACTIONS(5451),
    [anon_sym___attribute__] = ACTIONS(5453),
    [anon_sym_COLON_COLON] = ACTIONS(5455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5457),
    [anon_sym___declspec] = ACTIONS(5459),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(5451),
    [anon_sym_register] = ACTIONS(5451),
    [anon_sym_inline] = ACTIONS(5451),
    [anon_sym___inline] = ACTIONS(5451),
    [anon_sym___inline__] = ACTIONS(5451),
    [anon_sym___forceinline] = ACTIONS(5451),
    [anon_sym_thread_local] = ACTIONS(5451),
    [anon_sym___thread] = ACTIONS(5451),
    [anon_sym_const] = ACTIONS(5449),
    [anon_sym_constexpr] = ACTIONS(5449),
    [anon_sym_volatile] = ACTIONS(5449),
    [anon_sym_restrict] = ACTIONS(5449),
    [anon_sym___restrict__] = ACTIONS(5449),
    [anon_sym__Atomic] = ACTIONS(5449),
    [anon_sym__Noreturn] = ACTIONS(5449),
    [anon_sym_noreturn] = ACTIONS(5449),
    [anon_sym_mutable] = ACTIONS(5449),
    [anon_sym_constinit] = ACTIONS(5449),
    [anon_sym_consteval] = ACTIONS(5449),
    [anon_sym_PROGMEM] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_virtual] = ACTIONS(5461),
    [anon_sym_alignas] = ACTIONS(5463),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(133),
  },
  [2152] = {
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5584),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5204),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2153] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5162),
    [anon_sym_COMMA] = ACTIONS(5162),
    [anon_sym_RPAREN] = ACTIONS(5164),
    [anon_sym_LPAREN2] = ACTIONS(5164),
    [anon_sym_DASH] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5169),
    [anon_sym_STAR] = ACTIONS(5171),
    [anon_sym_SLASH] = ACTIONS(5169),
    [anon_sym_PERCENT] = ACTIONS(5169),
    [anon_sym_PIPE_PIPE] = ACTIONS(5162),
    [anon_sym_AMP_AMP] = ACTIONS(5164),
    [anon_sym_PIPE] = ACTIONS(5169),
    [anon_sym_CARET] = ACTIONS(5169),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_EQ] = ACTIONS(5162),
    [anon_sym_GT] = ACTIONS(5169),
    [anon_sym_GT_EQ] = ACTIONS(5162),
    [anon_sym_LT_EQ] = ACTIONS(5169),
    [anon_sym_LT] = ACTIONS(5169),
    [anon_sym_LT_LT] = ACTIONS(5169),
    [anon_sym_GT_GT] = ACTIONS(5169),
    [anon_sym_SEMI] = ACTIONS(5162),
    [anon_sym___extension__] = ACTIONS(5167),
    [anon_sym_COLON_COLON] = ACTIONS(5167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5162),
    [anon_sym_LBRACE] = ACTIONS(5167),
    [anon_sym_LBRACK] = ACTIONS(5171),
    [anon_sym_EQ] = ACTIONS(5169),
    [anon_sym_const] = ACTIONS(5160),
    [anon_sym_constexpr] = ACTIONS(5167),
    [anon_sym_volatile] = ACTIONS(5167),
    [anon_sym_restrict] = ACTIONS(5167),
    [anon_sym___restrict__] = ACTIONS(5167),
    [anon_sym__Atomic] = ACTIONS(5167),
    [anon_sym__Noreturn] = ACTIONS(5167),
    [anon_sym_noreturn] = ACTIONS(5167),
    [anon_sym_mutable] = ACTIONS(5167),
    [anon_sym_constinit] = ACTIONS(5167),
    [anon_sym_consteval] = ACTIONS(5167),
    [anon_sym_PROGMEM] = ACTIONS(5167),
    [anon_sym_QMARK] = ACTIONS(5162),
    [anon_sym_STAR_EQ] = ACTIONS(5162),
    [anon_sym_SLASH_EQ] = ACTIONS(5162),
    [anon_sym_PERCENT_EQ] = ACTIONS(5162),
    [anon_sym_PLUS_EQ] = ACTIONS(5162),
    [anon_sym_DASH_EQ] = ACTIONS(5162),
    [anon_sym_LT_LT_EQ] = ACTIONS(5162),
    [anon_sym_GT_GT_EQ] = ACTIONS(5162),
    [anon_sym_AMP_EQ] = ACTIONS(5162),
    [anon_sym_CARET_EQ] = ACTIONS(5162),
    [anon_sym_PIPE_EQ] = ACTIONS(5162),
    [anon_sym_and_eq] = ACTIONS(5162),
    [anon_sym_or_eq] = ACTIONS(5162),
    [anon_sym_xor_eq] = ACTIONS(5162),
    [anon_sym_LT_EQ_GT] = ACTIONS(5162),
    [anon_sym_or] = ACTIONS(5169),
    [anon_sym_and] = ACTIONS(5169),
    [anon_sym_bitor] = ACTIONS(5162),
    [anon_sym_xor] = ACTIONS(5169),
    [anon_sym_bitand] = ACTIONS(5162),
    [anon_sym_not_eq] = ACTIONS(5162),
    [anon_sym_DASH_DASH] = ACTIONS(5162),
    [anon_sym_PLUS_PLUS] = ACTIONS(5162),
    [anon_sym_DOT] = ACTIONS(5169),
    [anon_sym_DOT_STAR] = ACTIONS(5162),
    [anon_sym_DASH_GT] = ACTIONS(5169),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5167),
    [anon_sym_decltype] = ACTIONS(5167),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5162),
  },
  [2154] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [anon_sym_COMMA] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token2] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [aux_sym_preproc_else_token1] = ACTIONS(2267),
    [aux_sym_preproc_elif_token1] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(5405),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_friend] = ACTIONS(2267),
    [anon_sym_public] = ACTIONS(2267),
    [anon_sym_private] = ACTIONS(2267),
    [anon_sym_protected] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
  },
  [2155] = {
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5574),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5204),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2156] = {
    [sym_identifier] = ACTIONS(5109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5111),
    [anon_sym_COMMA] = ACTIONS(5111),
    [anon_sym_RPAREN] = ACTIONS(5111),
    [anon_sym_LPAREN2] = ACTIONS(5111),
    [anon_sym_DASH] = ACTIONS(5109),
    [anon_sym_PLUS] = ACTIONS(5109),
    [anon_sym_STAR] = ACTIONS(5111),
    [anon_sym_SLASH] = ACTIONS(5109),
    [anon_sym_PERCENT] = ACTIONS(5111),
    [anon_sym_PIPE_PIPE] = ACTIONS(5111),
    [anon_sym_AMP_AMP] = ACTIONS(5111),
    [anon_sym_PIPE] = ACTIONS(5109),
    [anon_sym_CARET] = ACTIONS(5111),
    [anon_sym_AMP] = ACTIONS(5109),
    [anon_sym_EQ_EQ] = ACTIONS(5111),
    [anon_sym_BANG_EQ] = ACTIONS(5111),
    [anon_sym_GT] = ACTIONS(5109),
    [anon_sym_GT_EQ] = ACTIONS(5111),
    [anon_sym_LT_EQ] = ACTIONS(5109),
    [anon_sym_LT] = ACTIONS(5109),
    [anon_sym_LT_LT] = ACTIONS(5111),
    [anon_sym_GT_GT] = ACTIONS(5111),
    [anon_sym_SEMI] = ACTIONS(5111),
    [anon_sym___extension__] = ACTIONS(5109),
    [anon_sym___attribute__] = ACTIONS(5109),
    [anon_sym_COLON_COLON] = ACTIONS(5111),
    [anon_sym___based] = ACTIONS(5109),
    [anon_sym_LBRACE] = ACTIONS(5111),
    [anon_sym_RBRACE] = ACTIONS(5111),
    [anon_sym_signed] = ACTIONS(5109),
    [anon_sym_unsigned] = ACTIONS(5109),
    [anon_sym_long] = ACTIONS(5109),
    [anon_sym_short] = ACTIONS(5109),
    [anon_sym_LBRACK] = ACTIONS(5111),
    [anon_sym_RBRACK] = ACTIONS(5111),
    [anon_sym_const] = ACTIONS(5109),
    [anon_sym_constexpr] = ACTIONS(5109),
    [anon_sym_volatile] = ACTIONS(5109),
    [anon_sym_restrict] = ACTIONS(5109),
    [anon_sym___restrict__] = ACTIONS(5109),
    [anon_sym__Atomic] = ACTIONS(5109),
    [anon_sym__Noreturn] = ACTIONS(5109),
    [anon_sym_noreturn] = ACTIONS(5109),
    [anon_sym_mutable] = ACTIONS(5109),
    [anon_sym_constinit] = ACTIONS(5109),
    [anon_sym_consteval] = ACTIONS(5109),
    [anon_sym_PROGMEM] = ACTIONS(5109),
    [aux_sym_primitive_type_token1] = ACTIONS(5109),
    [anon_sym_byte] = ACTIONS(5109),
    [anon_sym_word] = ACTIONS(5109),
    [anon_sym_COLON] = ACTIONS(5109),
    [anon_sym_QMARK] = ACTIONS(5111),
    [anon_sym_LT_EQ_GT] = ACTIONS(5111),
    [anon_sym_or] = ACTIONS(5109),
    [anon_sym_and] = ACTIONS(5109),
    [anon_sym_bitor] = ACTIONS(5109),
    [anon_sym_xor] = ACTIONS(5109),
    [anon_sym_bitand] = ACTIONS(5109),
    [anon_sym_not_eq] = ACTIONS(5109),
    [anon_sym_DASH_DASH] = ACTIONS(5111),
    [anon_sym_PLUS_PLUS] = ACTIONS(5111),
    [anon_sym_DOT] = ACTIONS(5109),
    [anon_sym_DOT_STAR] = ACTIONS(5111),
    [anon_sym_DASH_GT] = ACTIONS(5111),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5109),
    [anon_sym_decltype] = ACTIONS(5109),
    [anon_sym_final] = ACTIONS(5109),
    [anon_sym_override] = ACTIONS(5109),
    [anon_sym_requires] = ACTIONS(5109),
  },
  [2157] = {
    [sym_decltype_auto] = STATE(2285),
    [sym_identifier] = ACTIONS(5499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5501),
    [anon_sym_COMMA] = ACTIONS(5501),
    [anon_sym_RPAREN] = ACTIONS(5501),
    [anon_sym_LPAREN2] = ACTIONS(5501),
    [anon_sym_DASH] = ACTIONS(5499),
    [anon_sym_PLUS] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5499),
    [anon_sym_PERCENT] = ACTIONS(5501),
    [anon_sym_PIPE_PIPE] = ACTIONS(5501),
    [anon_sym_AMP_AMP] = ACTIONS(5501),
    [anon_sym_PIPE] = ACTIONS(5499),
    [anon_sym_CARET] = ACTIONS(5501),
    [anon_sym_AMP] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5501),
    [anon_sym_BANG_EQ] = ACTIONS(5501),
    [anon_sym_GT] = ACTIONS(5499),
    [anon_sym_GT_EQ] = ACTIONS(5501),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_LT] = ACTIONS(5499),
    [anon_sym_LT_LT] = ACTIONS(5501),
    [anon_sym_GT_GT] = ACTIONS(5501),
    [anon_sym_SEMI] = ACTIONS(5501),
    [anon_sym___extension__] = ACTIONS(5499),
    [anon_sym___attribute__] = ACTIONS(5499),
    [anon_sym___based] = ACTIONS(5499),
    [anon_sym_LBRACE] = ACTIONS(5501),
    [anon_sym_RBRACE] = ACTIONS(5501),
    [anon_sym_signed] = ACTIONS(5499),
    [anon_sym_unsigned] = ACTIONS(5499),
    [anon_sym_long] = ACTIONS(5499),
    [anon_sym_short] = ACTIONS(5499),
    [anon_sym_LBRACK] = ACTIONS(5501),
    [anon_sym_RBRACK] = ACTIONS(5501),
    [anon_sym_const] = ACTIONS(5499),
    [anon_sym_constexpr] = ACTIONS(5499),
    [anon_sym_volatile] = ACTIONS(5499),
    [anon_sym_restrict] = ACTIONS(5499),
    [anon_sym___restrict__] = ACTIONS(5499),
    [anon_sym__Atomic] = ACTIONS(5499),
    [anon_sym__Noreturn] = ACTIONS(5499),
    [anon_sym_noreturn] = ACTIONS(5499),
    [anon_sym_mutable] = ACTIONS(5499),
    [anon_sym_constinit] = ACTIONS(5499),
    [anon_sym_consteval] = ACTIONS(5499),
    [anon_sym_PROGMEM] = ACTIONS(5499),
    [aux_sym_primitive_type_token1] = ACTIONS(5499),
    [anon_sym_byte] = ACTIONS(5499),
    [anon_sym_word] = ACTIONS(5499),
    [anon_sym_COLON] = ACTIONS(5501),
    [anon_sym_QMARK] = ACTIONS(5501),
    [anon_sym_LT_EQ_GT] = ACTIONS(5501),
    [anon_sym_or] = ACTIONS(5499),
    [anon_sym_and] = ACTIONS(5499),
    [anon_sym_bitor] = ACTIONS(5499),
    [anon_sym_xor] = ACTIONS(5499),
    [anon_sym_bitand] = ACTIONS(5499),
    [anon_sym_not_eq] = ACTIONS(5499),
    [anon_sym_DASH_DASH] = ACTIONS(5501),
    [anon_sym_PLUS_PLUS] = ACTIONS(5501),
    [anon_sym_DOT] = ACTIONS(5499),
    [anon_sym_DOT_STAR] = ACTIONS(5501),
    [anon_sym_DASH_GT] = ACTIONS(5501),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5503),
    [anon_sym_decltype] = ACTIONS(5505),
    [anon_sym_final] = ACTIONS(5499),
    [anon_sym_override] = ACTIONS(5499),
    [anon_sym_requires] = ACTIONS(5499),
  },
  [2158] = {
    [sym_identifier] = ACTIONS(3353),
    [aux_sym_preproc_def_token1] = ACTIONS(3353),
    [aux_sym_preproc_if_token1] = ACTIONS(3353),
    [aux_sym_preproc_if_token2] = ACTIONS(3353),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3353),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3353),
    [aux_sym_preproc_else_token1] = ACTIONS(3353),
    [aux_sym_preproc_elif_token1] = ACTIONS(3353),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3353),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3353),
    [sym_preproc_directive] = ACTIONS(3353),
    [anon_sym_LPAREN2] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3355),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_AMP_AMP] = ACTIONS(3355),
    [anon_sym_AMP] = ACTIONS(3353),
    [anon_sym___extension__] = ACTIONS(3353),
    [anon_sym_typedef] = ACTIONS(3353),
    [anon_sym_extern] = ACTIONS(3353),
    [anon_sym___attribute__] = ACTIONS(3353),
    [anon_sym_COLON_COLON] = ACTIONS(3355),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3355),
    [anon_sym___declspec] = ACTIONS(3353),
    [anon_sym___based] = ACTIONS(3353),
    [anon_sym_signed] = ACTIONS(3353),
    [anon_sym_unsigned] = ACTIONS(3353),
    [anon_sym_long] = ACTIONS(3353),
    [anon_sym_short] = ACTIONS(3353),
    [anon_sym_LBRACK] = ACTIONS(3353),
    [anon_sym_static] = ACTIONS(3353),
    [anon_sym_register] = ACTIONS(3353),
    [anon_sym_inline] = ACTIONS(3353),
    [anon_sym___inline] = ACTIONS(3353),
    [anon_sym___inline__] = ACTIONS(3353),
    [anon_sym___forceinline] = ACTIONS(3353),
    [anon_sym_thread_local] = ACTIONS(3353),
    [anon_sym___thread] = ACTIONS(3353),
    [anon_sym_const] = ACTIONS(3353),
    [anon_sym_constexpr] = ACTIONS(3353),
    [anon_sym_volatile] = ACTIONS(3353),
    [anon_sym_restrict] = ACTIONS(3353),
    [anon_sym___restrict__] = ACTIONS(3353),
    [anon_sym__Atomic] = ACTIONS(3353),
    [anon_sym__Noreturn] = ACTIONS(3353),
    [anon_sym_noreturn] = ACTIONS(3353),
    [anon_sym_mutable] = ACTIONS(3353),
    [anon_sym_constinit] = ACTIONS(3353),
    [anon_sym_consteval] = ACTIONS(3353),
    [anon_sym_PROGMEM] = ACTIONS(3353),
    [aux_sym_primitive_type_token1] = ACTIONS(3353),
    [anon_sym_byte] = ACTIONS(3353),
    [anon_sym_word] = ACTIONS(3353),
    [anon_sym_enum] = ACTIONS(3353),
    [anon_sym_class] = ACTIONS(3353),
    [anon_sym_struct] = ACTIONS(3353),
    [anon_sym_union] = ACTIONS(3353),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3353),
    [anon_sym_decltype] = ACTIONS(3353),
    [anon_sym_virtual] = ACTIONS(3353),
    [anon_sym_alignas] = ACTIONS(3353),
    [anon_sym_explicit] = ACTIONS(3353),
    [anon_sym_typename] = ACTIONS(3353),
    [anon_sym_template] = ACTIONS(3353),
    [anon_sym_operator] = ACTIONS(3353),
    [anon_sym_friend] = ACTIONS(3353),
    [anon_sym_public] = ACTIONS(3353),
    [anon_sym_private] = ACTIONS(3353),
    [anon_sym_protected] = ACTIONS(3353),
    [anon_sym_using] = ACTIONS(3353),
    [anon_sym_static_assert] = ACTIONS(3353),
  },
  [2159] = {
    [sym_identifier] = ACTIONS(5507),
    [aux_sym_preproc_def_token1] = ACTIONS(5507),
    [aux_sym_preproc_if_token1] = ACTIONS(5507),
    [aux_sym_preproc_if_token2] = ACTIONS(5507),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5507),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5507),
    [aux_sym_preproc_else_token1] = ACTIONS(5507),
    [aux_sym_preproc_elif_token1] = ACTIONS(5507),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5507),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5507),
    [sym_preproc_directive] = ACTIONS(5507),
    [anon_sym_LPAREN2] = ACTIONS(5509),
    [anon_sym_TILDE] = ACTIONS(5509),
    [anon_sym_STAR] = ACTIONS(5509),
    [anon_sym_AMP_AMP] = ACTIONS(5509),
    [anon_sym_AMP] = ACTIONS(5507),
    [anon_sym___extension__] = ACTIONS(5507),
    [anon_sym_typedef] = ACTIONS(5507),
    [anon_sym_extern] = ACTIONS(5507),
    [anon_sym___attribute__] = ACTIONS(5507),
    [anon_sym_COLON_COLON] = ACTIONS(5509),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5509),
    [anon_sym___declspec] = ACTIONS(5507),
    [anon_sym___based] = ACTIONS(5507),
    [anon_sym_signed] = ACTIONS(5507),
    [anon_sym_unsigned] = ACTIONS(5507),
    [anon_sym_long] = ACTIONS(5507),
    [anon_sym_short] = ACTIONS(5507),
    [anon_sym_LBRACK] = ACTIONS(5507),
    [anon_sym_static] = ACTIONS(5507),
    [anon_sym_register] = ACTIONS(5507),
    [anon_sym_inline] = ACTIONS(5507),
    [anon_sym___inline] = ACTIONS(5507),
    [anon_sym___inline__] = ACTIONS(5507),
    [anon_sym___forceinline] = ACTIONS(5507),
    [anon_sym_thread_local] = ACTIONS(5507),
    [anon_sym___thread] = ACTIONS(5507),
    [anon_sym_const] = ACTIONS(5507),
    [anon_sym_constexpr] = ACTIONS(5507),
    [anon_sym_volatile] = ACTIONS(5507),
    [anon_sym_restrict] = ACTIONS(5507),
    [anon_sym___restrict__] = ACTIONS(5507),
    [anon_sym__Atomic] = ACTIONS(5507),
    [anon_sym__Noreturn] = ACTIONS(5507),
    [anon_sym_noreturn] = ACTIONS(5507),
    [anon_sym_mutable] = ACTIONS(5507),
    [anon_sym_constinit] = ACTIONS(5507),
    [anon_sym_consteval] = ACTIONS(5507),
    [anon_sym_PROGMEM] = ACTIONS(5507),
    [aux_sym_primitive_type_token1] = ACTIONS(5507),
    [anon_sym_byte] = ACTIONS(5507),
    [anon_sym_word] = ACTIONS(5507),
    [anon_sym_enum] = ACTIONS(5507),
    [anon_sym_class] = ACTIONS(5507),
    [anon_sym_struct] = ACTIONS(5507),
    [anon_sym_union] = ACTIONS(5507),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5507),
    [anon_sym_decltype] = ACTIONS(5507),
    [anon_sym_virtual] = ACTIONS(5507),
    [anon_sym_alignas] = ACTIONS(5507),
    [anon_sym_explicit] = ACTIONS(5507),
    [anon_sym_typename] = ACTIONS(5507),
    [anon_sym_template] = ACTIONS(5507),
    [anon_sym_operator] = ACTIONS(5507),
    [anon_sym_friend] = ACTIONS(5507),
    [anon_sym_public] = ACTIONS(5507),
    [anon_sym_private] = ACTIONS(5507),
    [anon_sym_protected] = ACTIONS(5507),
    [anon_sym_using] = ACTIONS(5507),
    [anon_sym_static_assert] = ACTIONS(5507),
  },
  [2160] = {
    [sym_identifier] = ACTIONS(3371),
    [aux_sym_preproc_def_token1] = ACTIONS(3371),
    [aux_sym_preproc_if_token1] = ACTIONS(3371),
    [aux_sym_preproc_if_token2] = ACTIONS(3371),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3371),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3371),
    [aux_sym_preproc_else_token1] = ACTIONS(3371),
    [aux_sym_preproc_elif_token1] = ACTIONS(3371),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3371),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3371),
    [sym_preproc_directive] = ACTIONS(3371),
    [anon_sym_LPAREN2] = ACTIONS(3373),
    [anon_sym_TILDE] = ACTIONS(3373),
    [anon_sym_STAR] = ACTIONS(3373),
    [anon_sym_AMP_AMP] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3371),
    [anon_sym___extension__] = ACTIONS(3371),
    [anon_sym_typedef] = ACTIONS(3371),
    [anon_sym_extern] = ACTIONS(3371),
    [anon_sym___attribute__] = ACTIONS(3371),
    [anon_sym_COLON_COLON] = ACTIONS(3373),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3373),
    [anon_sym___declspec] = ACTIONS(3371),
    [anon_sym___based] = ACTIONS(3371),
    [anon_sym_signed] = ACTIONS(3371),
    [anon_sym_unsigned] = ACTIONS(3371),
    [anon_sym_long] = ACTIONS(3371),
    [anon_sym_short] = ACTIONS(3371),
    [anon_sym_LBRACK] = ACTIONS(3371),
    [anon_sym_static] = ACTIONS(3371),
    [anon_sym_register] = ACTIONS(3371),
    [anon_sym_inline] = ACTIONS(3371),
    [anon_sym___inline] = ACTIONS(3371),
    [anon_sym___inline__] = ACTIONS(3371),
    [anon_sym___forceinline] = ACTIONS(3371),
    [anon_sym_thread_local] = ACTIONS(3371),
    [anon_sym___thread] = ACTIONS(3371),
    [anon_sym_const] = ACTIONS(3371),
    [anon_sym_constexpr] = ACTIONS(3371),
    [anon_sym_volatile] = ACTIONS(3371),
    [anon_sym_restrict] = ACTIONS(3371),
    [anon_sym___restrict__] = ACTIONS(3371),
    [anon_sym__Atomic] = ACTIONS(3371),
    [anon_sym__Noreturn] = ACTIONS(3371),
    [anon_sym_noreturn] = ACTIONS(3371),
    [anon_sym_mutable] = ACTIONS(3371),
    [anon_sym_constinit] = ACTIONS(3371),
    [anon_sym_consteval] = ACTIONS(3371),
    [anon_sym_PROGMEM] = ACTIONS(3371),
    [aux_sym_primitive_type_token1] = ACTIONS(3371),
    [anon_sym_byte] = ACTIONS(3371),
    [anon_sym_word] = ACTIONS(3371),
    [anon_sym_enum] = ACTIONS(3371),
    [anon_sym_class] = ACTIONS(3371),
    [anon_sym_struct] = ACTIONS(3371),
    [anon_sym_union] = ACTIONS(3371),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3371),
    [anon_sym_decltype] = ACTIONS(3371),
    [anon_sym_virtual] = ACTIONS(3371),
    [anon_sym_alignas] = ACTIONS(3371),
    [anon_sym_explicit] = ACTIONS(3371),
    [anon_sym_typename] = ACTIONS(3371),
    [anon_sym_template] = ACTIONS(3371),
    [anon_sym_operator] = ACTIONS(3371),
    [anon_sym_friend] = ACTIONS(3371),
    [anon_sym_public] = ACTIONS(3371),
    [anon_sym_private] = ACTIONS(3371),
    [anon_sym_protected] = ACTIONS(3371),
    [anon_sym_using] = ACTIONS(3371),
    [anon_sym_static_assert] = ACTIONS(3371),
  },
  [2161] = {
    [sym_identifier] = ACTIONS(3297),
    [aux_sym_preproc_def_token1] = ACTIONS(3297),
    [aux_sym_preproc_if_token1] = ACTIONS(3297),
    [aux_sym_preproc_if_token2] = ACTIONS(3297),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3297),
    [aux_sym_preproc_else_token1] = ACTIONS(3297),
    [aux_sym_preproc_elif_token1] = ACTIONS(3297),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3297),
    [sym_preproc_directive] = ACTIONS(3297),
    [anon_sym_LPAREN2] = ACTIONS(3299),
    [anon_sym_TILDE] = ACTIONS(3299),
    [anon_sym_STAR] = ACTIONS(3299),
    [anon_sym_AMP_AMP] = ACTIONS(3299),
    [anon_sym_AMP] = ACTIONS(3297),
    [anon_sym___extension__] = ACTIONS(3297),
    [anon_sym_typedef] = ACTIONS(3297),
    [anon_sym_extern] = ACTIONS(3297),
    [anon_sym___attribute__] = ACTIONS(3297),
    [anon_sym_COLON_COLON] = ACTIONS(3299),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3299),
    [anon_sym___declspec] = ACTIONS(3297),
    [anon_sym___based] = ACTIONS(3297),
    [anon_sym_signed] = ACTIONS(3297),
    [anon_sym_unsigned] = ACTIONS(3297),
    [anon_sym_long] = ACTIONS(3297),
    [anon_sym_short] = ACTIONS(3297),
    [anon_sym_LBRACK] = ACTIONS(3297),
    [anon_sym_static] = ACTIONS(3297),
    [anon_sym_register] = ACTIONS(3297),
    [anon_sym_inline] = ACTIONS(3297),
    [anon_sym___inline] = ACTIONS(3297),
    [anon_sym___inline__] = ACTIONS(3297),
    [anon_sym___forceinline] = ACTIONS(3297),
    [anon_sym_thread_local] = ACTIONS(3297),
    [anon_sym___thread] = ACTIONS(3297),
    [anon_sym_const] = ACTIONS(3297),
    [anon_sym_constexpr] = ACTIONS(3297),
    [anon_sym_volatile] = ACTIONS(3297),
    [anon_sym_restrict] = ACTIONS(3297),
    [anon_sym___restrict__] = ACTIONS(3297),
    [anon_sym__Atomic] = ACTIONS(3297),
    [anon_sym__Noreturn] = ACTIONS(3297),
    [anon_sym_noreturn] = ACTIONS(3297),
    [anon_sym_mutable] = ACTIONS(3297),
    [anon_sym_constinit] = ACTIONS(3297),
    [anon_sym_consteval] = ACTIONS(3297),
    [anon_sym_PROGMEM] = ACTIONS(3297),
    [aux_sym_primitive_type_token1] = ACTIONS(3297),
    [anon_sym_byte] = ACTIONS(3297),
    [anon_sym_word] = ACTIONS(3297),
    [anon_sym_enum] = ACTIONS(3297),
    [anon_sym_class] = ACTIONS(3297),
    [anon_sym_struct] = ACTIONS(3297),
    [anon_sym_union] = ACTIONS(3297),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3297),
    [anon_sym_decltype] = ACTIONS(3297),
    [anon_sym_virtual] = ACTIONS(3297),
    [anon_sym_alignas] = ACTIONS(3297),
    [anon_sym_explicit] = ACTIONS(3297),
    [anon_sym_typename] = ACTIONS(3297),
    [anon_sym_template] = ACTIONS(3297),
    [anon_sym_operator] = ACTIONS(3297),
    [anon_sym_friend] = ACTIONS(3297),
    [anon_sym_public] = ACTIONS(3297),
    [anon_sym_private] = ACTIONS(3297),
    [anon_sym_protected] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3297),
    [anon_sym_static_assert] = ACTIONS(3297),
  },
  [2162] = {
    [sym_identifier] = ACTIONS(3301),
    [aux_sym_preproc_def_token1] = ACTIONS(3301),
    [aux_sym_preproc_if_token1] = ACTIONS(3301),
    [aux_sym_preproc_if_token2] = ACTIONS(3301),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3301),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3301),
    [aux_sym_preproc_else_token1] = ACTIONS(3301),
    [aux_sym_preproc_elif_token1] = ACTIONS(3301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3301),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3301),
    [sym_preproc_directive] = ACTIONS(3301),
    [anon_sym_LPAREN2] = ACTIONS(3303),
    [anon_sym_TILDE] = ACTIONS(3303),
    [anon_sym_STAR] = ACTIONS(3303),
    [anon_sym_AMP_AMP] = ACTIONS(3303),
    [anon_sym_AMP] = ACTIONS(3301),
    [anon_sym___extension__] = ACTIONS(3301),
    [anon_sym_typedef] = ACTIONS(3301),
    [anon_sym_extern] = ACTIONS(3301),
    [anon_sym___attribute__] = ACTIONS(3301),
    [anon_sym_COLON_COLON] = ACTIONS(3303),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3303),
    [anon_sym___declspec] = ACTIONS(3301),
    [anon_sym___based] = ACTIONS(3301),
    [anon_sym_signed] = ACTIONS(3301),
    [anon_sym_unsigned] = ACTIONS(3301),
    [anon_sym_long] = ACTIONS(3301),
    [anon_sym_short] = ACTIONS(3301),
    [anon_sym_LBRACK] = ACTIONS(3301),
    [anon_sym_static] = ACTIONS(3301),
    [anon_sym_register] = ACTIONS(3301),
    [anon_sym_inline] = ACTIONS(3301),
    [anon_sym___inline] = ACTIONS(3301),
    [anon_sym___inline__] = ACTIONS(3301),
    [anon_sym___forceinline] = ACTIONS(3301),
    [anon_sym_thread_local] = ACTIONS(3301),
    [anon_sym___thread] = ACTIONS(3301),
    [anon_sym_const] = ACTIONS(3301),
    [anon_sym_constexpr] = ACTIONS(3301),
    [anon_sym_volatile] = ACTIONS(3301),
    [anon_sym_restrict] = ACTIONS(3301),
    [anon_sym___restrict__] = ACTIONS(3301),
    [anon_sym__Atomic] = ACTIONS(3301),
    [anon_sym__Noreturn] = ACTIONS(3301),
    [anon_sym_noreturn] = ACTIONS(3301),
    [anon_sym_mutable] = ACTIONS(3301),
    [anon_sym_constinit] = ACTIONS(3301),
    [anon_sym_consteval] = ACTIONS(3301),
    [anon_sym_PROGMEM] = ACTIONS(3301),
    [aux_sym_primitive_type_token1] = ACTIONS(3301),
    [anon_sym_byte] = ACTIONS(3301),
    [anon_sym_word] = ACTIONS(3301),
    [anon_sym_enum] = ACTIONS(3301),
    [anon_sym_class] = ACTIONS(3301),
    [anon_sym_struct] = ACTIONS(3301),
    [anon_sym_union] = ACTIONS(3301),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3301),
    [anon_sym_decltype] = ACTIONS(3301),
    [anon_sym_virtual] = ACTIONS(3301),
    [anon_sym_alignas] = ACTIONS(3301),
    [anon_sym_explicit] = ACTIONS(3301),
    [anon_sym_typename] = ACTIONS(3301),
    [anon_sym_template] = ACTIONS(3301),
    [anon_sym_operator] = ACTIONS(3301),
    [anon_sym_friend] = ACTIONS(3301),
    [anon_sym_public] = ACTIONS(3301),
    [anon_sym_private] = ACTIONS(3301),
    [anon_sym_protected] = ACTIONS(3301),
    [anon_sym_using] = ACTIONS(3301),
    [anon_sym_static_assert] = ACTIONS(3301),
  },
  [2163] = {
    [sym_identifier] = ACTIONS(3324),
    [aux_sym_preproc_def_token1] = ACTIONS(3324),
    [aux_sym_preproc_if_token1] = ACTIONS(3324),
    [aux_sym_preproc_if_token2] = ACTIONS(3324),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3324),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3324),
    [aux_sym_preproc_else_token1] = ACTIONS(3324),
    [aux_sym_preproc_elif_token1] = ACTIONS(3324),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3324),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3324),
    [sym_preproc_directive] = ACTIONS(3324),
    [anon_sym_LPAREN2] = ACTIONS(3326),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(3326),
    [anon_sym_AMP_AMP] = ACTIONS(3326),
    [anon_sym_AMP] = ACTIONS(3324),
    [anon_sym___extension__] = ACTIONS(3324),
    [anon_sym_typedef] = ACTIONS(3324),
    [anon_sym_extern] = ACTIONS(3324),
    [anon_sym___attribute__] = ACTIONS(3324),
    [anon_sym_COLON_COLON] = ACTIONS(3326),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3326),
    [anon_sym___declspec] = ACTIONS(3324),
    [anon_sym___based] = ACTIONS(3324),
    [anon_sym_signed] = ACTIONS(3324),
    [anon_sym_unsigned] = ACTIONS(3324),
    [anon_sym_long] = ACTIONS(3324),
    [anon_sym_short] = ACTIONS(3324),
    [anon_sym_LBRACK] = ACTIONS(3324),
    [anon_sym_static] = ACTIONS(3324),
    [anon_sym_register] = ACTIONS(3324),
    [anon_sym_inline] = ACTIONS(3324),
    [anon_sym___inline] = ACTIONS(3324),
    [anon_sym___inline__] = ACTIONS(3324),
    [anon_sym___forceinline] = ACTIONS(3324),
    [anon_sym_thread_local] = ACTIONS(3324),
    [anon_sym___thread] = ACTIONS(3324),
    [anon_sym_const] = ACTIONS(3324),
    [anon_sym_constexpr] = ACTIONS(3324),
    [anon_sym_volatile] = ACTIONS(3324),
    [anon_sym_restrict] = ACTIONS(3324),
    [anon_sym___restrict__] = ACTIONS(3324),
    [anon_sym__Atomic] = ACTIONS(3324),
    [anon_sym__Noreturn] = ACTIONS(3324),
    [anon_sym_noreturn] = ACTIONS(3324),
    [anon_sym_mutable] = ACTIONS(3324),
    [anon_sym_constinit] = ACTIONS(3324),
    [anon_sym_consteval] = ACTIONS(3324),
    [anon_sym_PROGMEM] = ACTIONS(3324),
    [aux_sym_primitive_type_token1] = ACTIONS(3324),
    [anon_sym_byte] = ACTIONS(3324),
    [anon_sym_word] = ACTIONS(3324),
    [anon_sym_enum] = ACTIONS(3324),
    [anon_sym_class] = ACTIONS(3324),
    [anon_sym_struct] = ACTIONS(3324),
    [anon_sym_union] = ACTIONS(3324),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3324),
    [anon_sym_decltype] = ACTIONS(3324),
    [anon_sym_virtual] = ACTIONS(3324),
    [anon_sym_alignas] = ACTIONS(3324),
    [anon_sym_explicit] = ACTIONS(3324),
    [anon_sym_typename] = ACTIONS(3324),
    [anon_sym_template] = ACTIONS(3324),
    [anon_sym_operator] = ACTIONS(3324),
    [anon_sym_friend] = ACTIONS(3324),
    [anon_sym_public] = ACTIONS(3324),
    [anon_sym_private] = ACTIONS(3324),
    [anon_sym_protected] = ACTIONS(3324),
    [anon_sym_using] = ACTIONS(3324),
    [anon_sym_static_assert] = ACTIONS(3324),
  },
  [2164] = {
    [sym_identifier] = ACTIONS(3993),
    [aux_sym_preproc_def_token1] = ACTIONS(3993),
    [aux_sym_preproc_if_token1] = ACTIONS(3993),
    [aux_sym_preproc_if_token2] = ACTIONS(3993),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3993),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3993),
    [aux_sym_preproc_else_token1] = ACTIONS(3993),
    [aux_sym_preproc_elif_token1] = ACTIONS(3993),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3993),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3993),
    [sym_preproc_directive] = ACTIONS(3993),
    [anon_sym_LPAREN2] = ACTIONS(3991),
    [anon_sym_TILDE] = ACTIONS(3991),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym___extension__] = ACTIONS(3993),
    [anon_sym_typedef] = ACTIONS(3993),
    [anon_sym_extern] = ACTIONS(3993),
    [anon_sym___attribute__] = ACTIONS(3993),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3991),
    [anon_sym___declspec] = ACTIONS(3993),
    [anon_sym___based] = ACTIONS(3993),
    [anon_sym_signed] = ACTIONS(3993),
    [anon_sym_unsigned] = ACTIONS(3993),
    [anon_sym_long] = ACTIONS(3993),
    [anon_sym_short] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3993),
    [anon_sym_static] = ACTIONS(3993),
    [anon_sym_register] = ACTIONS(3993),
    [anon_sym_inline] = ACTIONS(3993),
    [anon_sym___inline] = ACTIONS(3993),
    [anon_sym___inline__] = ACTIONS(3993),
    [anon_sym___forceinline] = ACTIONS(3993),
    [anon_sym_thread_local] = ACTIONS(3993),
    [anon_sym___thread] = ACTIONS(3993),
    [anon_sym_const] = ACTIONS(3993),
    [anon_sym_constexpr] = ACTIONS(3993),
    [anon_sym_volatile] = ACTIONS(3993),
    [anon_sym_restrict] = ACTIONS(3993),
    [anon_sym___restrict__] = ACTIONS(3993),
    [anon_sym__Atomic] = ACTIONS(3993),
    [anon_sym__Noreturn] = ACTIONS(3993),
    [anon_sym_noreturn] = ACTIONS(3993),
    [anon_sym_mutable] = ACTIONS(3993),
    [anon_sym_constinit] = ACTIONS(3993),
    [anon_sym_consteval] = ACTIONS(3993),
    [anon_sym_PROGMEM] = ACTIONS(3993),
    [aux_sym_primitive_type_token1] = ACTIONS(3993),
    [anon_sym_byte] = ACTIONS(3993),
    [anon_sym_word] = ACTIONS(3993),
    [anon_sym_enum] = ACTIONS(3993),
    [anon_sym_class] = ACTIONS(3993),
    [anon_sym_struct] = ACTIONS(3993),
    [anon_sym_union] = ACTIONS(3993),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3993),
    [anon_sym_decltype] = ACTIONS(3993),
    [anon_sym_virtual] = ACTIONS(3993),
    [anon_sym_alignas] = ACTIONS(3993),
    [anon_sym_explicit] = ACTIONS(3993),
    [anon_sym_typename] = ACTIONS(3993),
    [anon_sym_template] = ACTIONS(3993),
    [anon_sym_operator] = ACTIONS(3993),
    [anon_sym_friend] = ACTIONS(3993),
    [anon_sym_public] = ACTIONS(3993),
    [anon_sym_private] = ACTIONS(3993),
    [anon_sym_protected] = ACTIONS(3993),
    [anon_sym_using] = ACTIONS(3993),
    [anon_sym_static_assert] = ACTIONS(3993),
  },
  [2165] = {
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token2] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [aux_sym_preproc_else_token1] = ACTIONS(3513),
    [aux_sym_preproc_elif_token1] = ACTIONS(3513),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_PROGMEM] = ACTIONS(3513),
    [aux_sym_primitive_type_token1] = ACTIONS(3513),
    [anon_sym_byte] = ACTIONS(3513),
    [anon_sym_word] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [anon_sym_virtual] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_friend] = ACTIONS(3513),
    [anon_sym_public] = ACTIONS(3513),
    [anon_sym_private] = ACTIONS(3513),
    [anon_sym_protected] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
  },
  [2166] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(4471),
    [sym_raw_string_literal] = STATE(3057),
    [sym_identifier] = ACTIONS(4256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [aux_sym_preproc_if_token2] = ACTIONS(4248),
    [aux_sym_preproc_else_token1] = ACTIONS(4248),
    [aux_sym_preproc_elif_token1] = ACTIONS(4256),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4248),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5511),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(5514),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(5516),
    [anon_sym_SLASH_EQ] = ACTIONS(5516),
    [anon_sym_PERCENT_EQ] = ACTIONS(5516),
    [anon_sym_PLUS_EQ] = ACTIONS(5516),
    [anon_sym_DASH_EQ] = ACTIONS(5516),
    [anon_sym_LT_LT_EQ] = ACTIONS(5516),
    [anon_sym_GT_GT_EQ] = ACTIONS(5516),
    [anon_sym_AMP_EQ] = ACTIONS(5516),
    [anon_sym_CARET_EQ] = ACTIONS(5516),
    [anon_sym_PIPE_EQ] = ACTIONS(5516),
    [anon_sym_and_eq] = ACTIONS(5514),
    [anon_sym_or_eq] = ACTIONS(5514),
    [anon_sym_xor_eq] = ACTIONS(5514),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4256),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4256),
    [anon_sym_not_eq] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [2167] = {
    [sym_identifier] = ACTIONS(5121),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5123),
    [anon_sym_COMMA] = ACTIONS(5123),
    [anon_sym_RPAREN] = ACTIONS(5123),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5121),
    [anon_sym_PLUS] = ACTIONS(5121),
    [anon_sym_STAR] = ACTIONS(5123),
    [anon_sym_SLASH] = ACTIONS(5121),
    [anon_sym_PERCENT] = ACTIONS(5123),
    [anon_sym_PIPE_PIPE] = ACTIONS(5123),
    [anon_sym_AMP_AMP] = ACTIONS(5123),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_CARET] = ACTIONS(5123),
    [anon_sym_AMP] = ACTIONS(5121),
    [anon_sym_EQ_EQ] = ACTIONS(5123),
    [anon_sym_BANG_EQ] = ACTIONS(5123),
    [anon_sym_GT] = ACTIONS(5121),
    [anon_sym_GT_EQ] = ACTIONS(5123),
    [anon_sym_LT_EQ] = ACTIONS(5121),
    [anon_sym_LT] = ACTIONS(5121),
    [anon_sym_LT_LT] = ACTIONS(5123),
    [anon_sym_GT_GT] = ACTIONS(5123),
    [anon_sym_SEMI] = ACTIONS(5123),
    [anon_sym___extension__] = ACTIONS(5121),
    [anon_sym___attribute__] = ACTIONS(5121),
    [anon_sym_COLON_COLON] = ACTIONS(5123),
    [anon_sym___based] = ACTIONS(5121),
    [anon_sym_LBRACE] = ACTIONS(5123),
    [anon_sym_RBRACE] = ACTIONS(5123),
    [anon_sym_signed] = ACTIONS(5121),
    [anon_sym_unsigned] = ACTIONS(5121),
    [anon_sym_long] = ACTIONS(5121),
    [anon_sym_short] = ACTIONS(5121),
    [anon_sym_LBRACK] = ACTIONS(5123),
    [anon_sym_RBRACK] = ACTIONS(5123),
    [anon_sym_const] = ACTIONS(5121),
    [anon_sym_constexpr] = ACTIONS(5121),
    [anon_sym_volatile] = ACTIONS(5121),
    [anon_sym_restrict] = ACTIONS(5121),
    [anon_sym___restrict__] = ACTIONS(5121),
    [anon_sym__Atomic] = ACTIONS(5121),
    [anon_sym__Noreturn] = ACTIONS(5121),
    [anon_sym_noreturn] = ACTIONS(5121),
    [anon_sym_mutable] = ACTIONS(5121),
    [anon_sym_constinit] = ACTIONS(5121),
    [anon_sym_consteval] = ACTIONS(5121),
    [anon_sym_PROGMEM] = ACTIONS(5121),
    [aux_sym_primitive_type_token1] = ACTIONS(5121),
    [anon_sym_byte] = ACTIONS(5121),
    [anon_sym_word] = ACTIONS(5121),
    [anon_sym_COLON] = ACTIONS(5121),
    [anon_sym_QMARK] = ACTIONS(5123),
    [anon_sym_LT_EQ_GT] = ACTIONS(5123),
    [anon_sym_or] = ACTIONS(5121),
    [anon_sym_and] = ACTIONS(5121),
    [anon_sym_bitor] = ACTIONS(5121),
    [anon_sym_xor] = ACTIONS(5121),
    [anon_sym_bitand] = ACTIONS(5121),
    [anon_sym_not_eq] = ACTIONS(5121),
    [anon_sym_DASH_DASH] = ACTIONS(5123),
    [anon_sym_PLUS_PLUS] = ACTIONS(5123),
    [anon_sym_DOT] = ACTIONS(5121),
    [anon_sym_DOT_STAR] = ACTIONS(5123),
    [anon_sym_DASH_GT] = ACTIONS(5123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5121),
    [anon_sym_decltype] = ACTIONS(5121),
    [anon_sym_final] = ACTIONS(5121),
    [anon_sym_override] = ACTIONS(5121),
    [anon_sym_requires] = ACTIONS(5121),
  },
  [2168] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [anon_sym_COMMA] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token2] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [aux_sym_preproc_else_token1] = ACTIONS(2267),
    [aux_sym_preproc_elif_token1] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_friend] = ACTIONS(2267),
    [anon_sym_public] = ACTIONS(2267),
    [anon_sym_private] = ACTIONS(2267),
    [anon_sym_protected] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
  },
  [2169] = {
    [sym__declaration_modifiers] = STATE(4180),
    [sym_attribute_specifier] = STATE(4180),
    [sym_attribute_declaration] = STATE(4180),
    [sym_ms_declspec_modifier] = STATE(4180),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7163),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(4180),
    [sym_type_qualifier] = STATE(4180),
    [sym_decltype] = STATE(9504),
    [sym_virtual] = STATE(4180),
    [sym_alignas_specifier] = STATE(4180),
    [sym_explicit_function_specifier] = STATE(4180),
    [sym_operator_cast] = STATE(7537),
    [sym__constructor_specifiers] = STATE(4180),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(9504),
    [sym_template_function] = STATE(7008),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6421),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_operator_cast_identifier] = STATE(7537),
    [sym_operator_name] = STATE(7008),
    [aux_sym_operator_cast_definition_repeat1] = STATE(4180),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(5449),
    [anon_sym_extern] = ACTIONS(5451),
    [anon_sym___attribute__] = ACTIONS(5453),
    [anon_sym_COLON_COLON] = ACTIONS(5455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5457),
    [anon_sym___declspec] = ACTIONS(5459),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(5451),
    [anon_sym_register] = ACTIONS(5451),
    [anon_sym_inline] = ACTIONS(5451),
    [anon_sym___inline] = ACTIONS(5451),
    [anon_sym___inline__] = ACTIONS(5451),
    [anon_sym___forceinline] = ACTIONS(5451),
    [anon_sym_thread_local] = ACTIONS(5451),
    [anon_sym___thread] = ACTIONS(5451),
    [anon_sym_const] = ACTIONS(5449),
    [anon_sym_constexpr] = ACTIONS(5449),
    [anon_sym_volatile] = ACTIONS(5449),
    [anon_sym_restrict] = ACTIONS(5449),
    [anon_sym___restrict__] = ACTIONS(5449),
    [anon_sym__Atomic] = ACTIONS(5449),
    [anon_sym__Noreturn] = ACTIONS(5449),
    [anon_sym_noreturn] = ACTIONS(5449),
    [anon_sym_mutable] = ACTIONS(5449),
    [anon_sym_constinit] = ACTIONS(5449),
    [anon_sym_consteval] = ACTIONS(5449),
    [anon_sym_PROGMEM] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_virtual] = ACTIONS(5461),
    [anon_sym_alignas] = ACTIONS(5463),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(133),
  },
  [2170] = {
    [sym_identifier] = ACTIONS(5518),
    [aux_sym_preproc_def_token1] = ACTIONS(5518),
    [aux_sym_preproc_if_token1] = ACTIONS(5518),
    [aux_sym_preproc_if_token2] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5518),
    [aux_sym_preproc_else_token1] = ACTIONS(5518),
    [aux_sym_preproc_elif_token1] = ACTIONS(5518),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5518),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5518),
    [sym_preproc_directive] = ACTIONS(5518),
    [anon_sym_LPAREN2] = ACTIONS(5520),
    [anon_sym_TILDE] = ACTIONS(5520),
    [anon_sym_STAR] = ACTIONS(5520),
    [anon_sym_AMP_AMP] = ACTIONS(5520),
    [anon_sym_AMP] = ACTIONS(5518),
    [anon_sym___extension__] = ACTIONS(5518),
    [anon_sym_typedef] = ACTIONS(5518),
    [anon_sym_extern] = ACTIONS(5518),
    [anon_sym___attribute__] = ACTIONS(5518),
    [anon_sym_COLON_COLON] = ACTIONS(5520),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5520),
    [anon_sym___declspec] = ACTIONS(5518),
    [anon_sym___based] = ACTIONS(5518),
    [anon_sym_signed] = ACTIONS(5518),
    [anon_sym_unsigned] = ACTIONS(5518),
    [anon_sym_long] = ACTIONS(5518),
    [anon_sym_short] = ACTIONS(5518),
    [anon_sym_LBRACK] = ACTIONS(5518),
    [anon_sym_static] = ACTIONS(5518),
    [anon_sym_register] = ACTIONS(5518),
    [anon_sym_inline] = ACTIONS(5518),
    [anon_sym___inline] = ACTIONS(5518),
    [anon_sym___inline__] = ACTIONS(5518),
    [anon_sym___forceinline] = ACTIONS(5518),
    [anon_sym_thread_local] = ACTIONS(5518),
    [anon_sym___thread] = ACTIONS(5518),
    [anon_sym_const] = ACTIONS(5518),
    [anon_sym_constexpr] = ACTIONS(5518),
    [anon_sym_volatile] = ACTIONS(5518),
    [anon_sym_restrict] = ACTIONS(5518),
    [anon_sym___restrict__] = ACTIONS(5518),
    [anon_sym__Atomic] = ACTIONS(5518),
    [anon_sym__Noreturn] = ACTIONS(5518),
    [anon_sym_noreturn] = ACTIONS(5518),
    [anon_sym_mutable] = ACTIONS(5518),
    [anon_sym_constinit] = ACTIONS(5518),
    [anon_sym_consteval] = ACTIONS(5518),
    [anon_sym_PROGMEM] = ACTIONS(5518),
    [aux_sym_primitive_type_token1] = ACTIONS(5518),
    [anon_sym_byte] = ACTIONS(5518),
    [anon_sym_word] = ACTIONS(5518),
    [anon_sym_enum] = ACTIONS(5518),
    [anon_sym_class] = ACTIONS(5518),
    [anon_sym_struct] = ACTIONS(5518),
    [anon_sym_union] = ACTIONS(5518),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5518),
    [anon_sym_decltype] = ACTIONS(5518),
    [anon_sym_virtual] = ACTIONS(5518),
    [anon_sym_alignas] = ACTIONS(5518),
    [anon_sym_explicit] = ACTIONS(5518),
    [anon_sym_typename] = ACTIONS(5518),
    [anon_sym_template] = ACTIONS(5518),
    [anon_sym_operator] = ACTIONS(5518),
    [anon_sym_friend] = ACTIONS(5518),
    [anon_sym_public] = ACTIONS(5518),
    [anon_sym_private] = ACTIONS(5518),
    [anon_sym_protected] = ACTIONS(5518),
    [anon_sym_using] = ACTIONS(5518),
    [anon_sym_static_assert] = ACTIONS(5518),
  },
  [2171] = {
    [sym__declaration_modifiers] = STATE(4180),
    [sym_attribute_specifier] = STATE(4180),
    [sym_attribute_declaration] = STATE(4180),
    [sym_ms_declspec_modifier] = STATE(4180),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7034),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(4180),
    [sym_type_qualifier] = STATE(4180),
    [sym_decltype] = STATE(9504),
    [sym_virtual] = STATE(4180),
    [sym_alignas_specifier] = STATE(4180),
    [sym_explicit_function_specifier] = STATE(4180),
    [sym_operator_cast] = STATE(7537),
    [sym__constructor_specifiers] = STATE(4180),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(9504),
    [sym_template_function] = STATE(7008),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6421),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_operator_cast_identifier] = STATE(7537),
    [sym_operator_name] = STATE(7008),
    [aux_sym_operator_cast_definition_repeat1] = STATE(4180),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(5449),
    [anon_sym_extern] = ACTIONS(5451),
    [anon_sym___attribute__] = ACTIONS(5453),
    [anon_sym_COLON_COLON] = ACTIONS(5455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5457),
    [anon_sym___declspec] = ACTIONS(5459),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(5451),
    [anon_sym_register] = ACTIONS(5451),
    [anon_sym_inline] = ACTIONS(5451),
    [anon_sym___inline] = ACTIONS(5451),
    [anon_sym___inline__] = ACTIONS(5451),
    [anon_sym___forceinline] = ACTIONS(5451),
    [anon_sym_thread_local] = ACTIONS(5451),
    [anon_sym___thread] = ACTIONS(5451),
    [anon_sym_const] = ACTIONS(5449),
    [anon_sym_constexpr] = ACTIONS(5449),
    [anon_sym_volatile] = ACTIONS(5449),
    [anon_sym_restrict] = ACTIONS(5449),
    [anon_sym___restrict__] = ACTIONS(5449),
    [anon_sym__Atomic] = ACTIONS(5449),
    [anon_sym__Noreturn] = ACTIONS(5449),
    [anon_sym_noreturn] = ACTIONS(5449),
    [anon_sym_mutable] = ACTIONS(5449),
    [anon_sym_constinit] = ACTIONS(5449),
    [anon_sym_consteval] = ACTIONS(5449),
    [anon_sym_PROGMEM] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_virtual] = ACTIONS(5461),
    [anon_sym_alignas] = ACTIONS(5463),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(133),
  },
  [2172] = {
    [sym_identifier] = ACTIONS(5518),
    [aux_sym_preproc_def_token1] = ACTIONS(5518),
    [aux_sym_preproc_if_token1] = ACTIONS(5518),
    [aux_sym_preproc_if_token2] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5518),
    [aux_sym_preproc_else_token1] = ACTIONS(5518),
    [aux_sym_preproc_elif_token1] = ACTIONS(5518),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5518),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5518),
    [sym_preproc_directive] = ACTIONS(5518),
    [anon_sym_LPAREN2] = ACTIONS(5520),
    [anon_sym_TILDE] = ACTIONS(5520),
    [anon_sym_STAR] = ACTIONS(5520),
    [anon_sym_AMP_AMP] = ACTIONS(5520),
    [anon_sym_AMP] = ACTIONS(5518),
    [anon_sym___extension__] = ACTIONS(5518),
    [anon_sym_typedef] = ACTIONS(5518),
    [anon_sym_extern] = ACTIONS(5518),
    [anon_sym___attribute__] = ACTIONS(5518),
    [anon_sym_COLON_COLON] = ACTIONS(5520),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5520),
    [anon_sym___declspec] = ACTIONS(5518),
    [anon_sym___based] = ACTIONS(5518),
    [anon_sym_signed] = ACTIONS(5518),
    [anon_sym_unsigned] = ACTIONS(5518),
    [anon_sym_long] = ACTIONS(5518),
    [anon_sym_short] = ACTIONS(5518),
    [anon_sym_LBRACK] = ACTIONS(5518),
    [anon_sym_static] = ACTIONS(5518),
    [anon_sym_register] = ACTIONS(5518),
    [anon_sym_inline] = ACTIONS(5518),
    [anon_sym___inline] = ACTIONS(5518),
    [anon_sym___inline__] = ACTIONS(5518),
    [anon_sym___forceinline] = ACTIONS(5518),
    [anon_sym_thread_local] = ACTIONS(5518),
    [anon_sym___thread] = ACTIONS(5518),
    [anon_sym_const] = ACTIONS(5518),
    [anon_sym_constexpr] = ACTIONS(5518),
    [anon_sym_volatile] = ACTIONS(5518),
    [anon_sym_restrict] = ACTIONS(5518),
    [anon_sym___restrict__] = ACTIONS(5518),
    [anon_sym__Atomic] = ACTIONS(5518),
    [anon_sym__Noreturn] = ACTIONS(5518),
    [anon_sym_noreturn] = ACTIONS(5518),
    [anon_sym_mutable] = ACTIONS(5518),
    [anon_sym_constinit] = ACTIONS(5518),
    [anon_sym_consteval] = ACTIONS(5518),
    [anon_sym_PROGMEM] = ACTIONS(5518),
    [aux_sym_primitive_type_token1] = ACTIONS(5518),
    [anon_sym_byte] = ACTIONS(5518),
    [anon_sym_word] = ACTIONS(5518),
    [anon_sym_enum] = ACTIONS(5518),
    [anon_sym_class] = ACTIONS(5518),
    [anon_sym_struct] = ACTIONS(5518),
    [anon_sym_union] = ACTIONS(5518),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5518),
    [anon_sym_decltype] = ACTIONS(5518),
    [anon_sym_virtual] = ACTIONS(5518),
    [anon_sym_alignas] = ACTIONS(5518),
    [anon_sym_explicit] = ACTIONS(5518),
    [anon_sym_typename] = ACTIONS(5518),
    [anon_sym_template] = ACTIONS(5518),
    [anon_sym_operator] = ACTIONS(5518),
    [anon_sym_friend] = ACTIONS(5518),
    [anon_sym_public] = ACTIONS(5518),
    [anon_sym_private] = ACTIONS(5518),
    [anon_sym_protected] = ACTIONS(5518),
    [anon_sym_using] = ACTIONS(5518),
    [anon_sym_static_assert] = ACTIONS(5518),
  },
  [2173] = {
    [sym_identifier] = ACTIONS(3447),
    [aux_sym_preproc_def_token1] = ACTIONS(3447),
    [aux_sym_preproc_if_token1] = ACTIONS(3447),
    [aux_sym_preproc_if_token2] = ACTIONS(3447),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3447),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3447),
    [aux_sym_preproc_else_token1] = ACTIONS(3447),
    [aux_sym_preproc_elif_token1] = ACTIONS(3447),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3447),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3447),
    [sym_preproc_directive] = ACTIONS(3447),
    [anon_sym_LPAREN2] = ACTIONS(3449),
    [anon_sym_TILDE] = ACTIONS(3449),
    [anon_sym_STAR] = ACTIONS(3449),
    [anon_sym_AMP_AMP] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3447),
    [anon_sym___extension__] = ACTIONS(3447),
    [anon_sym_typedef] = ACTIONS(3447),
    [anon_sym_extern] = ACTIONS(3447),
    [anon_sym___attribute__] = ACTIONS(3447),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3449),
    [anon_sym___declspec] = ACTIONS(3447),
    [anon_sym___based] = ACTIONS(3447),
    [anon_sym_signed] = ACTIONS(3447),
    [anon_sym_unsigned] = ACTIONS(3447),
    [anon_sym_long] = ACTIONS(3447),
    [anon_sym_short] = ACTIONS(3447),
    [anon_sym_LBRACK] = ACTIONS(3447),
    [anon_sym_static] = ACTIONS(3447),
    [anon_sym_register] = ACTIONS(3447),
    [anon_sym_inline] = ACTIONS(3447),
    [anon_sym___inline] = ACTIONS(3447),
    [anon_sym___inline__] = ACTIONS(3447),
    [anon_sym___forceinline] = ACTIONS(3447),
    [anon_sym_thread_local] = ACTIONS(3447),
    [anon_sym___thread] = ACTIONS(3447),
    [anon_sym_const] = ACTIONS(3447),
    [anon_sym_constexpr] = ACTIONS(3447),
    [anon_sym_volatile] = ACTIONS(3447),
    [anon_sym_restrict] = ACTIONS(3447),
    [anon_sym___restrict__] = ACTIONS(3447),
    [anon_sym__Atomic] = ACTIONS(3447),
    [anon_sym__Noreturn] = ACTIONS(3447),
    [anon_sym_noreturn] = ACTIONS(3447),
    [anon_sym_mutable] = ACTIONS(3447),
    [anon_sym_constinit] = ACTIONS(3447),
    [anon_sym_consteval] = ACTIONS(3447),
    [anon_sym_PROGMEM] = ACTIONS(3447),
    [aux_sym_primitive_type_token1] = ACTIONS(3447),
    [anon_sym_byte] = ACTIONS(3447),
    [anon_sym_word] = ACTIONS(3447),
    [anon_sym_enum] = ACTIONS(3447),
    [anon_sym_class] = ACTIONS(3447),
    [anon_sym_struct] = ACTIONS(3447),
    [anon_sym_union] = ACTIONS(3447),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3447),
    [anon_sym_decltype] = ACTIONS(3447),
    [anon_sym_virtual] = ACTIONS(3447),
    [anon_sym_alignas] = ACTIONS(3447),
    [anon_sym_explicit] = ACTIONS(3447),
    [anon_sym_typename] = ACTIONS(3447),
    [anon_sym_template] = ACTIONS(3447),
    [anon_sym_operator] = ACTIONS(3447),
    [anon_sym_friend] = ACTIONS(3447),
    [anon_sym_public] = ACTIONS(3447),
    [anon_sym_private] = ACTIONS(3447),
    [anon_sym_protected] = ACTIONS(3447),
    [anon_sym_using] = ACTIONS(3447),
    [anon_sym_static_assert] = ACTIONS(3447),
  },
  [2174] = {
    [sym__declaration_modifiers] = STATE(4180),
    [sym_attribute_specifier] = STATE(4180),
    [sym_attribute_declaration] = STATE(4180),
    [sym_ms_declspec_modifier] = STATE(4180),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7003),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(4180),
    [sym_type_qualifier] = STATE(4180),
    [sym_decltype] = STATE(9504),
    [sym_virtual] = STATE(4180),
    [sym_alignas_specifier] = STATE(4180),
    [sym_explicit_function_specifier] = STATE(4180),
    [sym_operator_cast] = STATE(7539),
    [sym__constructor_specifiers] = STATE(4180),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(9504),
    [sym_template_function] = STATE(7008),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6421),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_operator_cast_identifier] = STATE(7539),
    [sym_operator_name] = STATE(7008),
    [aux_sym_operator_cast_definition_repeat1] = STATE(4180),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(5449),
    [anon_sym_extern] = ACTIONS(5451),
    [anon_sym___attribute__] = ACTIONS(5453),
    [anon_sym_COLON_COLON] = ACTIONS(5455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5457),
    [anon_sym___declspec] = ACTIONS(5459),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(5451),
    [anon_sym_register] = ACTIONS(5451),
    [anon_sym_inline] = ACTIONS(5451),
    [anon_sym___inline] = ACTIONS(5451),
    [anon_sym___inline__] = ACTIONS(5451),
    [anon_sym___forceinline] = ACTIONS(5451),
    [anon_sym_thread_local] = ACTIONS(5451),
    [anon_sym___thread] = ACTIONS(5451),
    [anon_sym_const] = ACTIONS(5449),
    [anon_sym_constexpr] = ACTIONS(5449),
    [anon_sym_volatile] = ACTIONS(5449),
    [anon_sym_restrict] = ACTIONS(5449),
    [anon_sym___restrict__] = ACTIONS(5449),
    [anon_sym__Atomic] = ACTIONS(5449),
    [anon_sym__Noreturn] = ACTIONS(5449),
    [anon_sym_noreturn] = ACTIONS(5449),
    [anon_sym_mutable] = ACTIONS(5449),
    [anon_sym_constinit] = ACTIONS(5449),
    [anon_sym_consteval] = ACTIONS(5449),
    [anon_sym_PROGMEM] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_virtual] = ACTIONS(5461),
    [anon_sym_alignas] = ACTIONS(5463),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(133),
  },
  [2175] = {
    [sym_identifier] = ACTIONS(5522),
    [aux_sym_preproc_def_token1] = ACTIONS(5522),
    [aux_sym_preproc_if_token1] = ACTIONS(5522),
    [aux_sym_preproc_if_token2] = ACTIONS(5522),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5522),
    [aux_sym_preproc_else_token1] = ACTIONS(5522),
    [aux_sym_preproc_elif_token1] = ACTIONS(5522),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5522),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5522),
    [sym_preproc_directive] = ACTIONS(5522),
    [anon_sym_LPAREN2] = ACTIONS(5524),
    [anon_sym_TILDE] = ACTIONS(5524),
    [anon_sym_STAR] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5522),
    [anon_sym___extension__] = ACTIONS(5522),
    [anon_sym_typedef] = ACTIONS(5522),
    [anon_sym_extern] = ACTIONS(5522),
    [anon_sym___attribute__] = ACTIONS(5522),
    [anon_sym_COLON_COLON] = ACTIONS(5524),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5524),
    [anon_sym___declspec] = ACTIONS(5522),
    [anon_sym___based] = ACTIONS(5522),
    [anon_sym_signed] = ACTIONS(5522),
    [anon_sym_unsigned] = ACTIONS(5522),
    [anon_sym_long] = ACTIONS(5522),
    [anon_sym_short] = ACTIONS(5522),
    [anon_sym_LBRACK] = ACTIONS(5522),
    [anon_sym_static] = ACTIONS(5522),
    [anon_sym_register] = ACTIONS(5522),
    [anon_sym_inline] = ACTIONS(5522),
    [anon_sym___inline] = ACTIONS(5522),
    [anon_sym___inline__] = ACTIONS(5522),
    [anon_sym___forceinline] = ACTIONS(5522),
    [anon_sym_thread_local] = ACTIONS(5522),
    [anon_sym___thread] = ACTIONS(5522),
    [anon_sym_const] = ACTIONS(5522),
    [anon_sym_constexpr] = ACTIONS(5522),
    [anon_sym_volatile] = ACTIONS(5522),
    [anon_sym_restrict] = ACTIONS(5522),
    [anon_sym___restrict__] = ACTIONS(5522),
    [anon_sym__Atomic] = ACTIONS(5522),
    [anon_sym__Noreturn] = ACTIONS(5522),
    [anon_sym_noreturn] = ACTIONS(5522),
    [anon_sym_mutable] = ACTIONS(5522),
    [anon_sym_constinit] = ACTIONS(5522),
    [anon_sym_consteval] = ACTIONS(5522),
    [anon_sym_PROGMEM] = ACTIONS(5522),
    [aux_sym_primitive_type_token1] = ACTIONS(5522),
    [anon_sym_byte] = ACTIONS(5522),
    [anon_sym_word] = ACTIONS(5522),
    [anon_sym_enum] = ACTIONS(5522),
    [anon_sym_class] = ACTIONS(5522),
    [anon_sym_struct] = ACTIONS(5522),
    [anon_sym_union] = ACTIONS(5522),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5522),
    [anon_sym_decltype] = ACTIONS(5522),
    [anon_sym_virtual] = ACTIONS(5522),
    [anon_sym_alignas] = ACTIONS(5522),
    [anon_sym_explicit] = ACTIONS(5522),
    [anon_sym_typename] = ACTIONS(5522),
    [anon_sym_template] = ACTIONS(5522),
    [anon_sym_operator] = ACTIONS(5522),
    [anon_sym_friend] = ACTIONS(5522),
    [anon_sym_public] = ACTIONS(5522),
    [anon_sym_private] = ACTIONS(5522),
    [anon_sym_protected] = ACTIONS(5522),
    [anon_sym_using] = ACTIONS(5522),
    [anon_sym_static_assert] = ACTIONS(5522),
  },
  [2176] = {
    [sym_identifier] = ACTIONS(3475),
    [aux_sym_preproc_def_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token2] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3475),
    [aux_sym_preproc_else_token1] = ACTIONS(3475),
    [aux_sym_preproc_elif_token1] = ACTIONS(3475),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3475),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3475),
    [sym_preproc_directive] = ACTIONS(3475),
    [anon_sym_LPAREN2] = ACTIONS(3477),
    [anon_sym_TILDE] = ACTIONS(3477),
    [anon_sym_STAR] = ACTIONS(3477),
    [anon_sym_AMP_AMP] = ACTIONS(3477),
    [anon_sym_AMP] = ACTIONS(3475),
    [anon_sym___extension__] = ACTIONS(3475),
    [anon_sym_typedef] = ACTIONS(3475),
    [anon_sym_extern] = ACTIONS(3475),
    [anon_sym___attribute__] = ACTIONS(3475),
    [anon_sym_COLON_COLON] = ACTIONS(3477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3477),
    [anon_sym___declspec] = ACTIONS(3475),
    [anon_sym___based] = ACTIONS(3475),
    [anon_sym_signed] = ACTIONS(3475),
    [anon_sym_unsigned] = ACTIONS(3475),
    [anon_sym_long] = ACTIONS(3475),
    [anon_sym_short] = ACTIONS(3475),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [anon_sym_static] = ACTIONS(3475),
    [anon_sym_register] = ACTIONS(3475),
    [anon_sym_inline] = ACTIONS(3475),
    [anon_sym___inline] = ACTIONS(3475),
    [anon_sym___inline__] = ACTIONS(3475),
    [anon_sym___forceinline] = ACTIONS(3475),
    [anon_sym_thread_local] = ACTIONS(3475),
    [anon_sym___thread] = ACTIONS(3475),
    [anon_sym_const] = ACTIONS(3475),
    [anon_sym_constexpr] = ACTIONS(3475),
    [anon_sym_volatile] = ACTIONS(3475),
    [anon_sym_restrict] = ACTIONS(3475),
    [anon_sym___restrict__] = ACTIONS(3475),
    [anon_sym__Atomic] = ACTIONS(3475),
    [anon_sym__Noreturn] = ACTIONS(3475),
    [anon_sym_noreturn] = ACTIONS(3475),
    [anon_sym_mutable] = ACTIONS(3475),
    [anon_sym_constinit] = ACTIONS(3475),
    [anon_sym_consteval] = ACTIONS(3475),
    [anon_sym_PROGMEM] = ACTIONS(3475),
    [aux_sym_primitive_type_token1] = ACTIONS(3475),
    [anon_sym_byte] = ACTIONS(3475),
    [anon_sym_word] = ACTIONS(3475),
    [anon_sym_enum] = ACTIONS(3475),
    [anon_sym_class] = ACTIONS(3475),
    [anon_sym_struct] = ACTIONS(3475),
    [anon_sym_union] = ACTIONS(3475),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3475),
    [anon_sym_decltype] = ACTIONS(3475),
    [anon_sym_virtual] = ACTIONS(3475),
    [anon_sym_alignas] = ACTIONS(3475),
    [anon_sym_explicit] = ACTIONS(3475),
    [anon_sym_typename] = ACTIONS(3475),
    [anon_sym_template] = ACTIONS(3475),
    [anon_sym_operator] = ACTIONS(3475),
    [anon_sym_friend] = ACTIONS(3475),
    [anon_sym_public] = ACTIONS(3475),
    [anon_sym_private] = ACTIONS(3475),
    [anon_sym_protected] = ACTIONS(3475),
    [anon_sym_using] = ACTIONS(3475),
    [anon_sym_static_assert] = ACTIONS(3475),
  },
  [2177] = {
    [sym_identifier] = ACTIONS(3293),
    [aux_sym_preproc_def_token1] = ACTIONS(3293),
    [aux_sym_preproc_if_token1] = ACTIONS(3293),
    [aux_sym_preproc_if_token2] = ACTIONS(3293),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3293),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3293),
    [aux_sym_preproc_else_token1] = ACTIONS(3293),
    [aux_sym_preproc_elif_token1] = ACTIONS(3293),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3293),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3293),
    [sym_preproc_directive] = ACTIONS(3293),
    [anon_sym_LPAREN2] = ACTIONS(3295),
    [anon_sym_TILDE] = ACTIONS(3295),
    [anon_sym_STAR] = ACTIONS(3295),
    [anon_sym_AMP_AMP] = ACTIONS(3295),
    [anon_sym_AMP] = ACTIONS(3293),
    [anon_sym___extension__] = ACTIONS(3293),
    [anon_sym_typedef] = ACTIONS(3293),
    [anon_sym_extern] = ACTIONS(3293),
    [anon_sym___attribute__] = ACTIONS(3293),
    [anon_sym_COLON_COLON] = ACTIONS(3295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3295),
    [anon_sym___declspec] = ACTIONS(3293),
    [anon_sym___based] = ACTIONS(3293),
    [anon_sym_signed] = ACTIONS(3293),
    [anon_sym_unsigned] = ACTIONS(3293),
    [anon_sym_long] = ACTIONS(3293),
    [anon_sym_short] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_static] = ACTIONS(3293),
    [anon_sym_register] = ACTIONS(3293),
    [anon_sym_inline] = ACTIONS(3293),
    [anon_sym___inline] = ACTIONS(3293),
    [anon_sym___inline__] = ACTIONS(3293),
    [anon_sym___forceinline] = ACTIONS(3293),
    [anon_sym_thread_local] = ACTIONS(3293),
    [anon_sym___thread] = ACTIONS(3293),
    [anon_sym_const] = ACTIONS(3293),
    [anon_sym_constexpr] = ACTIONS(3293),
    [anon_sym_volatile] = ACTIONS(3293),
    [anon_sym_restrict] = ACTIONS(3293),
    [anon_sym___restrict__] = ACTIONS(3293),
    [anon_sym__Atomic] = ACTIONS(3293),
    [anon_sym__Noreturn] = ACTIONS(3293),
    [anon_sym_noreturn] = ACTIONS(3293),
    [anon_sym_mutable] = ACTIONS(3293),
    [anon_sym_constinit] = ACTIONS(3293),
    [anon_sym_consteval] = ACTIONS(3293),
    [anon_sym_PROGMEM] = ACTIONS(3293),
    [aux_sym_primitive_type_token1] = ACTIONS(3293),
    [anon_sym_byte] = ACTIONS(3293),
    [anon_sym_word] = ACTIONS(3293),
    [anon_sym_enum] = ACTIONS(3293),
    [anon_sym_class] = ACTIONS(3293),
    [anon_sym_struct] = ACTIONS(3293),
    [anon_sym_union] = ACTIONS(3293),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3293),
    [anon_sym_decltype] = ACTIONS(3293),
    [anon_sym_virtual] = ACTIONS(3293),
    [anon_sym_alignas] = ACTIONS(3293),
    [anon_sym_explicit] = ACTIONS(3293),
    [anon_sym_typename] = ACTIONS(3293),
    [anon_sym_template] = ACTIONS(3293),
    [anon_sym_operator] = ACTIONS(3293),
    [anon_sym_friend] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3293),
    [anon_sym_private] = ACTIONS(3293),
    [anon_sym_protected] = ACTIONS(3293),
    [anon_sym_using] = ACTIONS(3293),
    [anon_sym_static_assert] = ACTIONS(3293),
  },
  [2178] = {
    [sym_identifier] = ACTIONS(4031),
    [aux_sym_preproc_def_token1] = ACTIONS(4031),
    [aux_sym_preproc_if_token1] = ACTIONS(4031),
    [aux_sym_preproc_if_token2] = ACTIONS(4031),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4031),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4031),
    [aux_sym_preproc_else_token1] = ACTIONS(4031),
    [aux_sym_preproc_elif_token1] = ACTIONS(4031),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4031),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4031),
    [sym_preproc_directive] = ACTIONS(4031),
    [anon_sym_LPAREN2] = ACTIONS(4029),
    [anon_sym_TILDE] = ACTIONS(4029),
    [anon_sym_STAR] = ACTIONS(4029),
    [anon_sym_AMP_AMP] = ACTIONS(4029),
    [anon_sym_AMP] = ACTIONS(4031),
    [anon_sym___extension__] = ACTIONS(4031),
    [anon_sym_typedef] = ACTIONS(4031),
    [anon_sym_extern] = ACTIONS(4031),
    [anon_sym___attribute__] = ACTIONS(4031),
    [anon_sym_COLON_COLON] = ACTIONS(4029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4029),
    [anon_sym___declspec] = ACTIONS(4031),
    [anon_sym___based] = ACTIONS(4031),
    [anon_sym_signed] = ACTIONS(4031),
    [anon_sym_unsigned] = ACTIONS(4031),
    [anon_sym_long] = ACTIONS(4031),
    [anon_sym_short] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4031),
    [anon_sym_static] = ACTIONS(4031),
    [anon_sym_register] = ACTIONS(4031),
    [anon_sym_inline] = ACTIONS(4031),
    [anon_sym___inline] = ACTIONS(4031),
    [anon_sym___inline__] = ACTIONS(4031),
    [anon_sym___forceinline] = ACTIONS(4031),
    [anon_sym_thread_local] = ACTIONS(4031),
    [anon_sym___thread] = ACTIONS(4031),
    [anon_sym_const] = ACTIONS(4031),
    [anon_sym_constexpr] = ACTIONS(4031),
    [anon_sym_volatile] = ACTIONS(4031),
    [anon_sym_restrict] = ACTIONS(4031),
    [anon_sym___restrict__] = ACTIONS(4031),
    [anon_sym__Atomic] = ACTIONS(4031),
    [anon_sym__Noreturn] = ACTIONS(4031),
    [anon_sym_noreturn] = ACTIONS(4031),
    [anon_sym_mutable] = ACTIONS(4031),
    [anon_sym_constinit] = ACTIONS(4031),
    [anon_sym_consteval] = ACTIONS(4031),
    [anon_sym_PROGMEM] = ACTIONS(4031),
    [aux_sym_primitive_type_token1] = ACTIONS(4031),
    [anon_sym_byte] = ACTIONS(4031),
    [anon_sym_word] = ACTIONS(4031),
    [anon_sym_enum] = ACTIONS(4031),
    [anon_sym_class] = ACTIONS(4031),
    [anon_sym_struct] = ACTIONS(4031),
    [anon_sym_union] = ACTIONS(4031),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4031),
    [anon_sym_decltype] = ACTIONS(4031),
    [anon_sym_virtual] = ACTIONS(4031),
    [anon_sym_alignas] = ACTIONS(4031),
    [anon_sym_explicit] = ACTIONS(4031),
    [anon_sym_typename] = ACTIONS(4031),
    [anon_sym_template] = ACTIONS(4031),
    [anon_sym_operator] = ACTIONS(4031),
    [anon_sym_friend] = ACTIONS(4031),
    [anon_sym_public] = ACTIONS(4031),
    [anon_sym_private] = ACTIONS(4031),
    [anon_sym_protected] = ACTIONS(4031),
    [anon_sym_using] = ACTIONS(4031),
    [anon_sym_static_assert] = ACTIONS(4031),
  },
  [2179] = {
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token2] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [aux_sym_preproc_else_token1] = ACTIONS(3513),
    [aux_sym_preproc_elif_token1] = ACTIONS(3513),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_PROGMEM] = ACTIONS(3513),
    [aux_sym_primitive_type_token1] = ACTIONS(3513),
    [anon_sym_byte] = ACTIONS(3513),
    [anon_sym_word] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [anon_sym_virtual] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_friend] = ACTIONS(3513),
    [anon_sym_public] = ACTIONS(3513),
    [anon_sym_private] = ACTIONS(3513),
    [anon_sym_protected] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
  },
  [2180] = {
    [sym_identifier] = ACTIONS(5526),
    [aux_sym_preproc_def_token1] = ACTIONS(5526),
    [aux_sym_preproc_if_token1] = ACTIONS(5526),
    [aux_sym_preproc_if_token2] = ACTIONS(5526),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5526),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5526),
    [aux_sym_preproc_else_token1] = ACTIONS(5526),
    [aux_sym_preproc_elif_token1] = ACTIONS(5526),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5526),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5526),
    [sym_preproc_directive] = ACTIONS(5526),
    [anon_sym_LPAREN2] = ACTIONS(5528),
    [anon_sym_TILDE] = ACTIONS(5528),
    [anon_sym_STAR] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5526),
    [anon_sym___extension__] = ACTIONS(5526),
    [anon_sym_typedef] = ACTIONS(5526),
    [anon_sym_extern] = ACTIONS(5526),
    [anon_sym___attribute__] = ACTIONS(5526),
    [anon_sym_COLON_COLON] = ACTIONS(5528),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5528),
    [anon_sym___declspec] = ACTIONS(5526),
    [anon_sym___based] = ACTIONS(5526),
    [anon_sym_signed] = ACTIONS(5526),
    [anon_sym_unsigned] = ACTIONS(5526),
    [anon_sym_long] = ACTIONS(5526),
    [anon_sym_short] = ACTIONS(5526),
    [anon_sym_LBRACK] = ACTIONS(5526),
    [anon_sym_static] = ACTIONS(5526),
    [anon_sym_register] = ACTIONS(5526),
    [anon_sym_inline] = ACTIONS(5526),
    [anon_sym___inline] = ACTIONS(5526),
    [anon_sym___inline__] = ACTIONS(5526),
    [anon_sym___forceinline] = ACTIONS(5526),
    [anon_sym_thread_local] = ACTIONS(5526),
    [anon_sym___thread] = ACTIONS(5526),
    [anon_sym_const] = ACTIONS(5526),
    [anon_sym_constexpr] = ACTIONS(5526),
    [anon_sym_volatile] = ACTIONS(5526),
    [anon_sym_restrict] = ACTIONS(5526),
    [anon_sym___restrict__] = ACTIONS(5526),
    [anon_sym__Atomic] = ACTIONS(5526),
    [anon_sym__Noreturn] = ACTIONS(5526),
    [anon_sym_noreturn] = ACTIONS(5526),
    [anon_sym_mutable] = ACTIONS(5526),
    [anon_sym_constinit] = ACTIONS(5526),
    [anon_sym_consteval] = ACTIONS(5526),
    [anon_sym_PROGMEM] = ACTIONS(5526),
    [aux_sym_primitive_type_token1] = ACTIONS(5526),
    [anon_sym_byte] = ACTIONS(5526),
    [anon_sym_word] = ACTIONS(5526),
    [anon_sym_enum] = ACTIONS(5526),
    [anon_sym_class] = ACTIONS(5526),
    [anon_sym_struct] = ACTIONS(5526),
    [anon_sym_union] = ACTIONS(5526),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5526),
    [anon_sym_decltype] = ACTIONS(5526),
    [anon_sym_virtual] = ACTIONS(5526),
    [anon_sym_alignas] = ACTIONS(5526),
    [anon_sym_explicit] = ACTIONS(5526),
    [anon_sym_typename] = ACTIONS(5526),
    [anon_sym_template] = ACTIONS(5526),
    [anon_sym_operator] = ACTIONS(5526),
    [anon_sym_friend] = ACTIONS(5526),
    [anon_sym_public] = ACTIONS(5526),
    [anon_sym_private] = ACTIONS(5526),
    [anon_sym_protected] = ACTIONS(5526),
    [anon_sym_using] = ACTIONS(5526),
    [anon_sym_static_assert] = ACTIONS(5526),
  },
  [2181] = {
    [sym_identifier] = ACTIONS(5530),
    [aux_sym_preproc_def_token1] = ACTIONS(5530),
    [aux_sym_preproc_if_token1] = ACTIONS(5530),
    [aux_sym_preproc_if_token2] = ACTIONS(5530),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5530),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5530),
    [aux_sym_preproc_else_token1] = ACTIONS(5530),
    [aux_sym_preproc_elif_token1] = ACTIONS(5530),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5530),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5530),
    [sym_preproc_directive] = ACTIONS(5530),
    [anon_sym_LPAREN2] = ACTIONS(5532),
    [anon_sym_TILDE] = ACTIONS(5532),
    [anon_sym_STAR] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5530),
    [anon_sym___extension__] = ACTIONS(5530),
    [anon_sym_typedef] = ACTIONS(5530),
    [anon_sym_extern] = ACTIONS(5530),
    [anon_sym___attribute__] = ACTIONS(5530),
    [anon_sym_COLON_COLON] = ACTIONS(5532),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5532),
    [anon_sym___declspec] = ACTIONS(5530),
    [anon_sym___based] = ACTIONS(5530),
    [anon_sym_signed] = ACTIONS(5530),
    [anon_sym_unsigned] = ACTIONS(5530),
    [anon_sym_long] = ACTIONS(5530),
    [anon_sym_short] = ACTIONS(5530),
    [anon_sym_LBRACK] = ACTIONS(5530),
    [anon_sym_static] = ACTIONS(5530),
    [anon_sym_register] = ACTIONS(5530),
    [anon_sym_inline] = ACTIONS(5530),
    [anon_sym___inline] = ACTIONS(5530),
    [anon_sym___inline__] = ACTIONS(5530),
    [anon_sym___forceinline] = ACTIONS(5530),
    [anon_sym_thread_local] = ACTIONS(5530),
    [anon_sym___thread] = ACTIONS(5530),
    [anon_sym_const] = ACTIONS(5530),
    [anon_sym_constexpr] = ACTIONS(5530),
    [anon_sym_volatile] = ACTIONS(5530),
    [anon_sym_restrict] = ACTIONS(5530),
    [anon_sym___restrict__] = ACTIONS(5530),
    [anon_sym__Atomic] = ACTIONS(5530),
    [anon_sym__Noreturn] = ACTIONS(5530),
    [anon_sym_noreturn] = ACTIONS(5530),
    [anon_sym_mutable] = ACTIONS(5530),
    [anon_sym_constinit] = ACTIONS(5530),
    [anon_sym_consteval] = ACTIONS(5530),
    [anon_sym_PROGMEM] = ACTIONS(5530),
    [aux_sym_primitive_type_token1] = ACTIONS(5530),
    [anon_sym_byte] = ACTIONS(5530),
    [anon_sym_word] = ACTIONS(5530),
    [anon_sym_enum] = ACTIONS(5530),
    [anon_sym_class] = ACTIONS(5530),
    [anon_sym_struct] = ACTIONS(5530),
    [anon_sym_union] = ACTIONS(5530),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5530),
    [anon_sym_decltype] = ACTIONS(5530),
    [anon_sym_virtual] = ACTIONS(5530),
    [anon_sym_alignas] = ACTIONS(5530),
    [anon_sym_explicit] = ACTIONS(5530),
    [anon_sym_typename] = ACTIONS(5530),
    [anon_sym_template] = ACTIONS(5530),
    [anon_sym_operator] = ACTIONS(5530),
    [anon_sym_friend] = ACTIONS(5530),
    [anon_sym_public] = ACTIONS(5530),
    [anon_sym_private] = ACTIONS(5530),
    [anon_sym_protected] = ACTIONS(5530),
    [anon_sym_using] = ACTIONS(5530),
    [anon_sym_static_assert] = ACTIONS(5530),
  },
  [2182] = {
    [sym_identifier] = ACTIONS(3336),
    [aux_sym_preproc_def_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token2] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3336),
    [aux_sym_preproc_else_token1] = ACTIONS(3336),
    [aux_sym_preproc_elif_token1] = ACTIONS(3336),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3336),
    [sym_preproc_directive] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym___extension__] = ACTIONS(3336),
    [anon_sym_typedef] = ACTIONS(3336),
    [anon_sym_extern] = ACTIONS(3336),
    [anon_sym___attribute__] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3338),
    [anon_sym___declspec] = ACTIONS(3336),
    [anon_sym___based] = ACTIONS(3336),
    [anon_sym_signed] = ACTIONS(3336),
    [anon_sym_unsigned] = ACTIONS(3336),
    [anon_sym_long] = ACTIONS(3336),
    [anon_sym_short] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_static] = ACTIONS(3336),
    [anon_sym_register] = ACTIONS(3336),
    [anon_sym_inline] = ACTIONS(3336),
    [anon_sym___inline] = ACTIONS(3336),
    [anon_sym___inline__] = ACTIONS(3336),
    [anon_sym___forceinline] = ACTIONS(3336),
    [anon_sym_thread_local] = ACTIONS(3336),
    [anon_sym___thread] = ACTIONS(3336),
    [anon_sym_const] = ACTIONS(3336),
    [anon_sym_constexpr] = ACTIONS(3336),
    [anon_sym_volatile] = ACTIONS(3336),
    [anon_sym_restrict] = ACTIONS(3336),
    [anon_sym___restrict__] = ACTIONS(3336),
    [anon_sym__Atomic] = ACTIONS(3336),
    [anon_sym__Noreturn] = ACTIONS(3336),
    [anon_sym_noreturn] = ACTIONS(3336),
    [anon_sym_mutable] = ACTIONS(3336),
    [anon_sym_constinit] = ACTIONS(3336),
    [anon_sym_consteval] = ACTIONS(3336),
    [anon_sym_PROGMEM] = ACTIONS(3336),
    [aux_sym_primitive_type_token1] = ACTIONS(3336),
    [anon_sym_byte] = ACTIONS(3336),
    [anon_sym_word] = ACTIONS(3336),
    [anon_sym_enum] = ACTIONS(3336),
    [anon_sym_class] = ACTIONS(3336),
    [anon_sym_struct] = ACTIONS(3336),
    [anon_sym_union] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3336),
    [anon_sym_decltype] = ACTIONS(3336),
    [anon_sym_virtual] = ACTIONS(3336),
    [anon_sym_alignas] = ACTIONS(3336),
    [anon_sym_explicit] = ACTIONS(3336),
    [anon_sym_typename] = ACTIONS(3336),
    [anon_sym_template] = ACTIONS(3336),
    [anon_sym_operator] = ACTIONS(3336),
    [anon_sym_friend] = ACTIONS(3336),
    [anon_sym_public] = ACTIONS(3336),
    [anon_sym_private] = ACTIONS(3336),
    [anon_sym_protected] = ACTIONS(3336),
    [anon_sym_using] = ACTIONS(3336),
    [anon_sym_static_assert] = ACTIONS(3336),
  },
  [2183] = {
    [sym_identifier] = ACTIONS(3336),
    [aux_sym_preproc_def_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token2] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3336),
    [aux_sym_preproc_else_token1] = ACTIONS(3336),
    [aux_sym_preproc_elif_token1] = ACTIONS(3336),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3336),
    [sym_preproc_directive] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym___extension__] = ACTIONS(3336),
    [anon_sym_typedef] = ACTIONS(3336),
    [anon_sym_extern] = ACTIONS(3336),
    [anon_sym___attribute__] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3338),
    [anon_sym___declspec] = ACTIONS(3336),
    [anon_sym___based] = ACTIONS(3336),
    [anon_sym_signed] = ACTIONS(3336),
    [anon_sym_unsigned] = ACTIONS(3336),
    [anon_sym_long] = ACTIONS(3336),
    [anon_sym_short] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_static] = ACTIONS(3336),
    [anon_sym_register] = ACTIONS(3336),
    [anon_sym_inline] = ACTIONS(3336),
    [anon_sym___inline] = ACTIONS(3336),
    [anon_sym___inline__] = ACTIONS(3336),
    [anon_sym___forceinline] = ACTIONS(3336),
    [anon_sym_thread_local] = ACTIONS(3336),
    [anon_sym___thread] = ACTIONS(3336),
    [anon_sym_const] = ACTIONS(3336),
    [anon_sym_constexpr] = ACTIONS(3336),
    [anon_sym_volatile] = ACTIONS(3336),
    [anon_sym_restrict] = ACTIONS(3336),
    [anon_sym___restrict__] = ACTIONS(3336),
    [anon_sym__Atomic] = ACTIONS(3336),
    [anon_sym__Noreturn] = ACTIONS(3336),
    [anon_sym_noreturn] = ACTIONS(3336),
    [anon_sym_mutable] = ACTIONS(3336),
    [anon_sym_constinit] = ACTIONS(3336),
    [anon_sym_consteval] = ACTIONS(3336),
    [anon_sym_PROGMEM] = ACTIONS(3336),
    [aux_sym_primitive_type_token1] = ACTIONS(3336),
    [anon_sym_byte] = ACTIONS(3336),
    [anon_sym_word] = ACTIONS(3336),
    [anon_sym_enum] = ACTIONS(3336),
    [anon_sym_class] = ACTIONS(3336),
    [anon_sym_struct] = ACTIONS(3336),
    [anon_sym_union] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3336),
    [anon_sym_decltype] = ACTIONS(3336),
    [anon_sym_virtual] = ACTIONS(3336),
    [anon_sym_alignas] = ACTIONS(3336),
    [anon_sym_explicit] = ACTIONS(3336),
    [anon_sym_typename] = ACTIONS(3336),
    [anon_sym_template] = ACTIONS(3336),
    [anon_sym_operator] = ACTIONS(3336),
    [anon_sym_friend] = ACTIONS(3336),
    [anon_sym_public] = ACTIONS(3336),
    [anon_sym_private] = ACTIONS(3336),
    [anon_sym_protected] = ACTIONS(3336),
    [anon_sym_using] = ACTIONS(3336),
    [anon_sym_static_assert] = ACTIONS(3336),
  },
  [2184] = {
    [sym_identifier] = ACTIONS(5526),
    [aux_sym_preproc_def_token1] = ACTIONS(5526),
    [aux_sym_preproc_if_token1] = ACTIONS(5526),
    [aux_sym_preproc_if_token2] = ACTIONS(5526),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5526),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5526),
    [aux_sym_preproc_else_token1] = ACTIONS(5526),
    [aux_sym_preproc_elif_token1] = ACTIONS(5526),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5526),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5526),
    [sym_preproc_directive] = ACTIONS(5526),
    [anon_sym_LPAREN2] = ACTIONS(5528),
    [anon_sym_TILDE] = ACTIONS(5528),
    [anon_sym_STAR] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5526),
    [anon_sym___extension__] = ACTIONS(5526),
    [anon_sym_typedef] = ACTIONS(5526),
    [anon_sym_extern] = ACTIONS(5526),
    [anon_sym___attribute__] = ACTIONS(5526),
    [anon_sym_COLON_COLON] = ACTIONS(5528),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5528),
    [anon_sym___declspec] = ACTIONS(5526),
    [anon_sym___based] = ACTIONS(5526),
    [anon_sym_signed] = ACTIONS(5526),
    [anon_sym_unsigned] = ACTIONS(5526),
    [anon_sym_long] = ACTIONS(5526),
    [anon_sym_short] = ACTIONS(5526),
    [anon_sym_LBRACK] = ACTIONS(5526),
    [anon_sym_static] = ACTIONS(5526),
    [anon_sym_register] = ACTIONS(5526),
    [anon_sym_inline] = ACTIONS(5526),
    [anon_sym___inline] = ACTIONS(5526),
    [anon_sym___inline__] = ACTIONS(5526),
    [anon_sym___forceinline] = ACTIONS(5526),
    [anon_sym_thread_local] = ACTIONS(5526),
    [anon_sym___thread] = ACTIONS(5526),
    [anon_sym_const] = ACTIONS(5526),
    [anon_sym_constexpr] = ACTIONS(5526),
    [anon_sym_volatile] = ACTIONS(5526),
    [anon_sym_restrict] = ACTIONS(5526),
    [anon_sym___restrict__] = ACTIONS(5526),
    [anon_sym__Atomic] = ACTIONS(5526),
    [anon_sym__Noreturn] = ACTIONS(5526),
    [anon_sym_noreturn] = ACTIONS(5526),
    [anon_sym_mutable] = ACTIONS(5526),
    [anon_sym_constinit] = ACTIONS(5526),
    [anon_sym_consteval] = ACTIONS(5526),
    [anon_sym_PROGMEM] = ACTIONS(5526),
    [aux_sym_primitive_type_token1] = ACTIONS(5526),
    [anon_sym_byte] = ACTIONS(5526),
    [anon_sym_word] = ACTIONS(5526),
    [anon_sym_enum] = ACTIONS(5526),
    [anon_sym_class] = ACTIONS(5526),
    [anon_sym_struct] = ACTIONS(5526),
    [anon_sym_union] = ACTIONS(5526),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5526),
    [anon_sym_decltype] = ACTIONS(5526),
    [anon_sym_virtual] = ACTIONS(5526),
    [anon_sym_alignas] = ACTIONS(5526),
    [anon_sym_explicit] = ACTIONS(5526),
    [anon_sym_typename] = ACTIONS(5526),
    [anon_sym_template] = ACTIONS(5526),
    [anon_sym_operator] = ACTIONS(5526),
    [anon_sym_friend] = ACTIONS(5526),
    [anon_sym_public] = ACTIONS(5526),
    [anon_sym_private] = ACTIONS(5526),
    [anon_sym_protected] = ACTIONS(5526),
    [anon_sym_using] = ACTIONS(5526),
    [anon_sym_static_assert] = ACTIONS(5526),
  },
  [2185] = {
    [sym_identifier] = ACTIONS(5530),
    [aux_sym_preproc_def_token1] = ACTIONS(5530),
    [aux_sym_preproc_if_token1] = ACTIONS(5530),
    [aux_sym_preproc_if_token2] = ACTIONS(5530),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5530),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5530),
    [aux_sym_preproc_else_token1] = ACTIONS(5530),
    [aux_sym_preproc_elif_token1] = ACTIONS(5530),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5530),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5530),
    [sym_preproc_directive] = ACTIONS(5530),
    [anon_sym_LPAREN2] = ACTIONS(5532),
    [anon_sym_TILDE] = ACTIONS(5532),
    [anon_sym_STAR] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5530),
    [anon_sym___extension__] = ACTIONS(5530),
    [anon_sym_typedef] = ACTIONS(5530),
    [anon_sym_extern] = ACTIONS(5530),
    [anon_sym___attribute__] = ACTIONS(5530),
    [anon_sym_COLON_COLON] = ACTIONS(5532),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5532),
    [anon_sym___declspec] = ACTIONS(5530),
    [anon_sym___based] = ACTIONS(5530),
    [anon_sym_signed] = ACTIONS(5530),
    [anon_sym_unsigned] = ACTIONS(5530),
    [anon_sym_long] = ACTIONS(5530),
    [anon_sym_short] = ACTIONS(5530),
    [anon_sym_LBRACK] = ACTIONS(5530),
    [anon_sym_static] = ACTIONS(5530),
    [anon_sym_register] = ACTIONS(5530),
    [anon_sym_inline] = ACTIONS(5530),
    [anon_sym___inline] = ACTIONS(5530),
    [anon_sym___inline__] = ACTIONS(5530),
    [anon_sym___forceinline] = ACTIONS(5530),
    [anon_sym_thread_local] = ACTIONS(5530),
    [anon_sym___thread] = ACTIONS(5530),
    [anon_sym_const] = ACTIONS(5530),
    [anon_sym_constexpr] = ACTIONS(5530),
    [anon_sym_volatile] = ACTIONS(5530),
    [anon_sym_restrict] = ACTIONS(5530),
    [anon_sym___restrict__] = ACTIONS(5530),
    [anon_sym__Atomic] = ACTIONS(5530),
    [anon_sym__Noreturn] = ACTIONS(5530),
    [anon_sym_noreturn] = ACTIONS(5530),
    [anon_sym_mutable] = ACTIONS(5530),
    [anon_sym_constinit] = ACTIONS(5530),
    [anon_sym_consteval] = ACTIONS(5530),
    [anon_sym_PROGMEM] = ACTIONS(5530),
    [aux_sym_primitive_type_token1] = ACTIONS(5530),
    [anon_sym_byte] = ACTIONS(5530),
    [anon_sym_word] = ACTIONS(5530),
    [anon_sym_enum] = ACTIONS(5530),
    [anon_sym_class] = ACTIONS(5530),
    [anon_sym_struct] = ACTIONS(5530),
    [anon_sym_union] = ACTIONS(5530),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5530),
    [anon_sym_decltype] = ACTIONS(5530),
    [anon_sym_virtual] = ACTIONS(5530),
    [anon_sym_alignas] = ACTIONS(5530),
    [anon_sym_explicit] = ACTIONS(5530),
    [anon_sym_typename] = ACTIONS(5530),
    [anon_sym_template] = ACTIONS(5530),
    [anon_sym_operator] = ACTIONS(5530),
    [anon_sym_friend] = ACTIONS(5530),
    [anon_sym_public] = ACTIONS(5530),
    [anon_sym_private] = ACTIONS(5530),
    [anon_sym_protected] = ACTIONS(5530),
    [anon_sym_using] = ACTIONS(5530),
    [anon_sym_static_assert] = ACTIONS(5530),
  },
  [2186] = {
    [sym_identifier] = ACTIONS(5534),
    [aux_sym_preproc_def_token1] = ACTIONS(5534),
    [aux_sym_preproc_if_token1] = ACTIONS(5534),
    [aux_sym_preproc_if_token2] = ACTIONS(5534),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5534),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5534),
    [aux_sym_preproc_else_token1] = ACTIONS(5534),
    [aux_sym_preproc_elif_token1] = ACTIONS(5534),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5534),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5534),
    [sym_preproc_directive] = ACTIONS(5534),
    [anon_sym_LPAREN2] = ACTIONS(5536),
    [anon_sym_TILDE] = ACTIONS(5536),
    [anon_sym_STAR] = ACTIONS(5536),
    [anon_sym_AMP_AMP] = ACTIONS(5536),
    [anon_sym_AMP] = ACTIONS(5534),
    [anon_sym___extension__] = ACTIONS(5534),
    [anon_sym_typedef] = ACTIONS(5534),
    [anon_sym_extern] = ACTIONS(5534),
    [anon_sym___attribute__] = ACTIONS(5534),
    [anon_sym_COLON_COLON] = ACTIONS(5536),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5536),
    [anon_sym___declspec] = ACTIONS(5534),
    [anon_sym___based] = ACTIONS(5534),
    [anon_sym_signed] = ACTIONS(5534),
    [anon_sym_unsigned] = ACTIONS(5534),
    [anon_sym_long] = ACTIONS(5534),
    [anon_sym_short] = ACTIONS(5534),
    [anon_sym_LBRACK] = ACTIONS(5534),
    [anon_sym_static] = ACTIONS(5534),
    [anon_sym_register] = ACTIONS(5534),
    [anon_sym_inline] = ACTIONS(5534),
    [anon_sym___inline] = ACTIONS(5534),
    [anon_sym___inline__] = ACTIONS(5534),
    [anon_sym___forceinline] = ACTIONS(5534),
    [anon_sym_thread_local] = ACTIONS(5534),
    [anon_sym___thread] = ACTIONS(5534),
    [anon_sym_const] = ACTIONS(5534),
    [anon_sym_constexpr] = ACTIONS(5534),
    [anon_sym_volatile] = ACTIONS(5534),
    [anon_sym_restrict] = ACTIONS(5534),
    [anon_sym___restrict__] = ACTIONS(5534),
    [anon_sym__Atomic] = ACTIONS(5534),
    [anon_sym__Noreturn] = ACTIONS(5534),
    [anon_sym_noreturn] = ACTIONS(5534),
    [anon_sym_mutable] = ACTIONS(5534),
    [anon_sym_constinit] = ACTIONS(5534),
    [anon_sym_consteval] = ACTIONS(5534),
    [anon_sym_PROGMEM] = ACTIONS(5534),
    [aux_sym_primitive_type_token1] = ACTIONS(5534),
    [anon_sym_byte] = ACTIONS(5534),
    [anon_sym_word] = ACTIONS(5534),
    [anon_sym_enum] = ACTIONS(5534),
    [anon_sym_class] = ACTIONS(5534),
    [anon_sym_struct] = ACTIONS(5534),
    [anon_sym_union] = ACTIONS(5534),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5534),
    [anon_sym_decltype] = ACTIONS(5534),
    [anon_sym_virtual] = ACTIONS(5534),
    [anon_sym_alignas] = ACTIONS(5534),
    [anon_sym_explicit] = ACTIONS(5534),
    [anon_sym_typename] = ACTIONS(5534),
    [anon_sym_template] = ACTIONS(5534),
    [anon_sym_operator] = ACTIONS(5534),
    [anon_sym_friend] = ACTIONS(5534),
    [anon_sym_public] = ACTIONS(5534),
    [anon_sym_private] = ACTIONS(5534),
    [anon_sym_protected] = ACTIONS(5534),
    [anon_sym_using] = ACTIONS(5534),
    [anon_sym_static_assert] = ACTIONS(5534),
  },
  [2187] = {
    [sym_identifier] = ACTIONS(5538),
    [aux_sym_preproc_def_token1] = ACTIONS(5538),
    [aux_sym_preproc_if_token1] = ACTIONS(5538),
    [aux_sym_preproc_if_token2] = ACTIONS(5538),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5538),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5538),
    [aux_sym_preproc_else_token1] = ACTIONS(5538),
    [aux_sym_preproc_elif_token1] = ACTIONS(5538),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5538),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5538),
    [sym_preproc_directive] = ACTIONS(5538),
    [anon_sym_LPAREN2] = ACTIONS(5540),
    [anon_sym_TILDE] = ACTIONS(5540),
    [anon_sym_STAR] = ACTIONS(5540),
    [anon_sym_AMP_AMP] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5538),
    [anon_sym_typedef] = ACTIONS(5538),
    [anon_sym_extern] = ACTIONS(5538),
    [anon_sym___attribute__] = ACTIONS(5538),
    [anon_sym_COLON_COLON] = ACTIONS(5540),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5540),
    [anon_sym___declspec] = ACTIONS(5538),
    [anon_sym___based] = ACTIONS(5538),
    [anon_sym_signed] = ACTIONS(5538),
    [anon_sym_unsigned] = ACTIONS(5538),
    [anon_sym_long] = ACTIONS(5538),
    [anon_sym_short] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(5538),
    [anon_sym_static] = ACTIONS(5538),
    [anon_sym_register] = ACTIONS(5538),
    [anon_sym_inline] = ACTIONS(5538),
    [anon_sym___inline] = ACTIONS(5538),
    [anon_sym___inline__] = ACTIONS(5538),
    [anon_sym___forceinline] = ACTIONS(5538),
    [anon_sym_thread_local] = ACTIONS(5538),
    [anon_sym___thread] = ACTIONS(5538),
    [anon_sym_const] = ACTIONS(5538),
    [anon_sym_constexpr] = ACTIONS(5538),
    [anon_sym_volatile] = ACTIONS(5538),
    [anon_sym_restrict] = ACTIONS(5538),
    [anon_sym___restrict__] = ACTIONS(5538),
    [anon_sym__Atomic] = ACTIONS(5538),
    [anon_sym__Noreturn] = ACTIONS(5538),
    [anon_sym_noreturn] = ACTIONS(5538),
    [anon_sym_mutable] = ACTIONS(5538),
    [anon_sym_constinit] = ACTIONS(5538),
    [anon_sym_consteval] = ACTIONS(5538),
    [anon_sym_PROGMEM] = ACTIONS(5538),
    [aux_sym_primitive_type_token1] = ACTIONS(5538),
    [anon_sym_byte] = ACTIONS(5538),
    [anon_sym_word] = ACTIONS(5538),
    [anon_sym_enum] = ACTIONS(5538),
    [anon_sym_class] = ACTIONS(5538),
    [anon_sym_struct] = ACTIONS(5538),
    [anon_sym_union] = ACTIONS(5538),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5538),
    [anon_sym_decltype] = ACTIONS(5538),
    [anon_sym_virtual] = ACTIONS(5538),
    [anon_sym_alignas] = ACTIONS(5538),
    [anon_sym_explicit] = ACTIONS(5538),
    [anon_sym_typename] = ACTIONS(5538),
    [anon_sym_template] = ACTIONS(5538),
    [anon_sym_operator] = ACTIONS(5538),
    [anon_sym_friend] = ACTIONS(5538),
    [anon_sym_public] = ACTIONS(5538),
    [anon_sym_private] = ACTIONS(5538),
    [anon_sym_protected] = ACTIONS(5538),
    [anon_sym_using] = ACTIONS(5538),
    [anon_sym_static_assert] = ACTIONS(5538),
  },
  [2188] = {
    [sym_identifier] = ACTIONS(5125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5127),
    [anon_sym_COMMA] = ACTIONS(5127),
    [anon_sym_RPAREN] = ACTIONS(5127),
    [anon_sym_LPAREN2] = ACTIONS(5127),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_PLUS] = ACTIONS(5125),
    [anon_sym_STAR] = ACTIONS(5127),
    [anon_sym_SLASH] = ACTIONS(5125),
    [anon_sym_PERCENT] = ACTIONS(5127),
    [anon_sym_PIPE_PIPE] = ACTIONS(5127),
    [anon_sym_AMP_AMP] = ACTIONS(5127),
    [anon_sym_PIPE] = ACTIONS(5125),
    [anon_sym_CARET] = ACTIONS(5127),
    [anon_sym_AMP] = ACTIONS(5125),
    [anon_sym_EQ_EQ] = ACTIONS(5127),
    [anon_sym_BANG_EQ] = ACTIONS(5127),
    [anon_sym_GT] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5127),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_LT] = ACTIONS(5125),
    [anon_sym_LT_LT] = ACTIONS(5127),
    [anon_sym_GT_GT] = ACTIONS(5127),
    [anon_sym_SEMI] = ACTIONS(5127),
    [anon_sym___extension__] = ACTIONS(5125),
    [anon_sym___attribute__] = ACTIONS(5125),
    [anon_sym_COLON_COLON] = ACTIONS(5127),
    [anon_sym___based] = ACTIONS(5125),
    [anon_sym_LBRACE] = ACTIONS(5127),
    [anon_sym_RBRACE] = ACTIONS(5127),
    [anon_sym_signed] = ACTIONS(5125),
    [anon_sym_unsigned] = ACTIONS(5125),
    [anon_sym_long] = ACTIONS(5125),
    [anon_sym_short] = ACTIONS(5125),
    [anon_sym_LBRACK] = ACTIONS(5127),
    [anon_sym_RBRACK] = ACTIONS(5127),
    [anon_sym_const] = ACTIONS(5125),
    [anon_sym_constexpr] = ACTIONS(5125),
    [anon_sym_volatile] = ACTIONS(5125),
    [anon_sym_restrict] = ACTIONS(5125),
    [anon_sym___restrict__] = ACTIONS(5125),
    [anon_sym__Atomic] = ACTIONS(5125),
    [anon_sym__Noreturn] = ACTIONS(5125),
    [anon_sym_noreturn] = ACTIONS(5125),
    [anon_sym_mutable] = ACTIONS(5125),
    [anon_sym_constinit] = ACTIONS(5125),
    [anon_sym_consteval] = ACTIONS(5125),
    [anon_sym_PROGMEM] = ACTIONS(5125),
    [aux_sym_primitive_type_token1] = ACTIONS(5125),
    [anon_sym_byte] = ACTIONS(5125),
    [anon_sym_word] = ACTIONS(5125),
    [anon_sym_COLON] = ACTIONS(5125),
    [anon_sym_QMARK] = ACTIONS(5127),
    [anon_sym_LT_EQ_GT] = ACTIONS(5127),
    [anon_sym_or] = ACTIONS(5125),
    [anon_sym_and] = ACTIONS(5125),
    [anon_sym_bitor] = ACTIONS(5125),
    [anon_sym_xor] = ACTIONS(5125),
    [anon_sym_bitand] = ACTIONS(5125),
    [anon_sym_not_eq] = ACTIONS(5125),
    [anon_sym_DASH_DASH] = ACTIONS(5127),
    [anon_sym_PLUS_PLUS] = ACTIONS(5127),
    [anon_sym_DOT] = ACTIONS(5125),
    [anon_sym_DOT_STAR] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5127),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5125),
    [anon_sym_decltype] = ACTIONS(5125),
    [anon_sym_final] = ACTIONS(5125),
    [anon_sym_override] = ACTIONS(5125),
    [anon_sym_requires] = ACTIONS(5125),
  },
  [2189] = {
    [sym_identifier] = ACTIONS(5542),
    [aux_sym_preproc_def_token1] = ACTIONS(5542),
    [aux_sym_preproc_if_token1] = ACTIONS(5542),
    [aux_sym_preproc_if_token2] = ACTIONS(5542),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5542),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5542),
    [aux_sym_preproc_else_token1] = ACTIONS(5542),
    [aux_sym_preproc_elif_token1] = ACTIONS(5542),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5542),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5542),
    [sym_preproc_directive] = ACTIONS(5542),
    [anon_sym_LPAREN2] = ACTIONS(5544),
    [anon_sym_TILDE] = ACTIONS(5544),
    [anon_sym_STAR] = ACTIONS(5544),
    [anon_sym_AMP_AMP] = ACTIONS(5544),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5542),
    [anon_sym_typedef] = ACTIONS(5542),
    [anon_sym_extern] = ACTIONS(5542),
    [anon_sym___attribute__] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5544),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5544),
    [anon_sym___declspec] = ACTIONS(5542),
    [anon_sym___based] = ACTIONS(5542),
    [anon_sym_signed] = ACTIONS(5542),
    [anon_sym_unsigned] = ACTIONS(5542),
    [anon_sym_long] = ACTIONS(5542),
    [anon_sym_short] = ACTIONS(5542),
    [anon_sym_LBRACK] = ACTIONS(5542),
    [anon_sym_static] = ACTIONS(5542),
    [anon_sym_register] = ACTIONS(5542),
    [anon_sym_inline] = ACTIONS(5542),
    [anon_sym___inline] = ACTIONS(5542),
    [anon_sym___inline__] = ACTIONS(5542),
    [anon_sym___forceinline] = ACTIONS(5542),
    [anon_sym_thread_local] = ACTIONS(5542),
    [anon_sym___thread] = ACTIONS(5542),
    [anon_sym_const] = ACTIONS(5542),
    [anon_sym_constexpr] = ACTIONS(5542),
    [anon_sym_volatile] = ACTIONS(5542),
    [anon_sym_restrict] = ACTIONS(5542),
    [anon_sym___restrict__] = ACTIONS(5542),
    [anon_sym__Atomic] = ACTIONS(5542),
    [anon_sym__Noreturn] = ACTIONS(5542),
    [anon_sym_noreturn] = ACTIONS(5542),
    [anon_sym_mutable] = ACTIONS(5542),
    [anon_sym_constinit] = ACTIONS(5542),
    [anon_sym_consteval] = ACTIONS(5542),
    [anon_sym_PROGMEM] = ACTIONS(5542),
    [aux_sym_primitive_type_token1] = ACTIONS(5542),
    [anon_sym_byte] = ACTIONS(5542),
    [anon_sym_word] = ACTIONS(5542),
    [anon_sym_enum] = ACTIONS(5542),
    [anon_sym_class] = ACTIONS(5542),
    [anon_sym_struct] = ACTIONS(5542),
    [anon_sym_union] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5542),
    [anon_sym_decltype] = ACTIONS(5542),
    [anon_sym_virtual] = ACTIONS(5542),
    [anon_sym_alignas] = ACTIONS(5542),
    [anon_sym_explicit] = ACTIONS(5542),
    [anon_sym_typename] = ACTIONS(5542),
    [anon_sym_template] = ACTIONS(5542),
    [anon_sym_operator] = ACTIONS(5542),
    [anon_sym_friend] = ACTIONS(5542),
    [anon_sym_public] = ACTIONS(5542),
    [anon_sym_private] = ACTIONS(5542),
    [anon_sym_protected] = ACTIONS(5542),
    [anon_sym_using] = ACTIONS(5542),
    [anon_sym_static_assert] = ACTIONS(5542),
  },
  [2190] = {
    [sym_identifier] = ACTIONS(5546),
    [aux_sym_preproc_def_token1] = ACTIONS(5546),
    [aux_sym_preproc_if_token1] = ACTIONS(5546),
    [aux_sym_preproc_if_token2] = ACTIONS(5546),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5546),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5546),
    [aux_sym_preproc_else_token1] = ACTIONS(5546),
    [aux_sym_preproc_elif_token1] = ACTIONS(5546),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5546),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5546),
    [sym_preproc_directive] = ACTIONS(5546),
    [anon_sym_LPAREN2] = ACTIONS(5548),
    [anon_sym_TILDE] = ACTIONS(5548),
    [anon_sym_STAR] = ACTIONS(5548),
    [anon_sym_AMP_AMP] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5546),
    [anon_sym___extension__] = ACTIONS(5546),
    [anon_sym_typedef] = ACTIONS(5546),
    [anon_sym_extern] = ACTIONS(5546),
    [anon_sym___attribute__] = ACTIONS(5546),
    [anon_sym_COLON_COLON] = ACTIONS(5548),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5548),
    [anon_sym___declspec] = ACTIONS(5546),
    [anon_sym___based] = ACTIONS(5546),
    [anon_sym_signed] = ACTIONS(5546),
    [anon_sym_unsigned] = ACTIONS(5546),
    [anon_sym_long] = ACTIONS(5546),
    [anon_sym_short] = ACTIONS(5546),
    [anon_sym_LBRACK] = ACTIONS(5546),
    [anon_sym_static] = ACTIONS(5546),
    [anon_sym_register] = ACTIONS(5546),
    [anon_sym_inline] = ACTIONS(5546),
    [anon_sym___inline] = ACTIONS(5546),
    [anon_sym___inline__] = ACTIONS(5546),
    [anon_sym___forceinline] = ACTIONS(5546),
    [anon_sym_thread_local] = ACTIONS(5546),
    [anon_sym___thread] = ACTIONS(5546),
    [anon_sym_const] = ACTIONS(5546),
    [anon_sym_constexpr] = ACTIONS(5546),
    [anon_sym_volatile] = ACTIONS(5546),
    [anon_sym_restrict] = ACTIONS(5546),
    [anon_sym___restrict__] = ACTIONS(5546),
    [anon_sym__Atomic] = ACTIONS(5546),
    [anon_sym__Noreturn] = ACTIONS(5546),
    [anon_sym_noreturn] = ACTIONS(5546),
    [anon_sym_mutable] = ACTIONS(5546),
    [anon_sym_constinit] = ACTIONS(5546),
    [anon_sym_consteval] = ACTIONS(5546),
    [anon_sym_PROGMEM] = ACTIONS(5546),
    [aux_sym_primitive_type_token1] = ACTIONS(5546),
    [anon_sym_byte] = ACTIONS(5546),
    [anon_sym_word] = ACTIONS(5546),
    [anon_sym_enum] = ACTIONS(5546),
    [anon_sym_class] = ACTIONS(5546),
    [anon_sym_struct] = ACTIONS(5546),
    [anon_sym_union] = ACTIONS(5546),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5546),
    [anon_sym_decltype] = ACTIONS(5546),
    [anon_sym_virtual] = ACTIONS(5546),
    [anon_sym_alignas] = ACTIONS(5546),
    [anon_sym_explicit] = ACTIONS(5546),
    [anon_sym_typename] = ACTIONS(5546),
    [anon_sym_template] = ACTIONS(5546),
    [anon_sym_operator] = ACTIONS(5546),
    [anon_sym_friend] = ACTIONS(5546),
    [anon_sym_public] = ACTIONS(5546),
    [anon_sym_private] = ACTIONS(5546),
    [anon_sym_protected] = ACTIONS(5546),
    [anon_sym_using] = ACTIONS(5546),
    [anon_sym_static_assert] = ACTIONS(5546),
  },
  [2191] = {
    [sym_identifier] = ACTIONS(5550),
    [aux_sym_preproc_def_token1] = ACTIONS(5550),
    [aux_sym_preproc_if_token1] = ACTIONS(5550),
    [aux_sym_preproc_if_token2] = ACTIONS(5550),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5550),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5550),
    [aux_sym_preproc_else_token1] = ACTIONS(5550),
    [aux_sym_preproc_elif_token1] = ACTIONS(5550),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5550),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5550),
    [sym_preproc_directive] = ACTIONS(5550),
    [anon_sym_LPAREN2] = ACTIONS(5552),
    [anon_sym_TILDE] = ACTIONS(5552),
    [anon_sym_STAR] = ACTIONS(5552),
    [anon_sym_AMP_AMP] = ACTIONS(5552),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym___extension__] = ACTIONS(5550),
    [anon_sym_typedef] = ACTIONS(5550),
    [anon_sym_extern] = ACTIONS(5550),
    [anon_sym___attribute__] = ACTIONS(5550),
    [anon_sym_COLON_COLON] = ACTIONS(5552),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5552),
    [anon_sym___declspec] = ACTIONS(5550),
    [anon_sym___based] = ACTIONS(5550),
    [anon_sym_signed] = ACTIONS(5550),
    [anon_sym_unsigned] = ACTIONS(5550),
    [anon_sym_long] = ACTIONS(5550),
    [anon_sym_short] = ACTIONS(5550),
    [anon_sym_LBRACK] = ACTIONS(5550),
    [anon_sym_static] = ACTIONS(5550),
    [anon_sym_register] = ACTIONS(5550),
    [anon_sym_inline] = ACTIONS(5550),
    [anon_sym___inline] = ACTIONS(5550),
    [anon_sym___inline__] = ACTIONS(5550),
    [anon_sym___forceinline] = ACTIONS(5550),
    [anon_sym_thread_local] = ACTIONS(5550),
    [anon_sym___thread] = ACTIONS(5550),
    [anon_sym_const] = ACTIONS(5550),
    [anon_sym_constexpr] = ACTIONS(5550),
    [anon_sym_volatile] = ACTIONS(5550),
    [anon_sym_restrict] = ACTIONS(5550),
    [anon_sym___restrict__] = ACTIONS(5550),
    [anon_sym__Atomic] = ACTIONS(5550),
    [anon_sym__Noreturn] = ACTIONS(5550),
    [anon_sym_noreturn] = ACTIONS(5550),
    [anon_sym_mutable] = ACTIONS(5550),
    [anon_sym_constinit] = ACTIONS(5550),
    [anon_sym_consteval] = ACTIONS(5550),
    [anon_sym_PROGMEM] = ACTIONS(5550),
    [aux_sym_primitive_type_token1] = ACTIONS(5550),
    [anon_sym_byte] = ACTIONS(5550),
    [anon_sym_word] = ACTIONS(5550),
    [anon_sym_enum] = ACTIONS(5550),
    [anon_sym_class] = ACTIONS(5550),
    [anon_sym_struct] = ACTIONS(5550),
    [anon_sym_union] = ACTIONS(5550),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5550),
    [anon_sym_decltype] = ACTIONS(5550),
    [anon_sym_virtual] = ACTIONS(5550),
    [anon_sym_alignas] = ACTIONS(5550),
    [anon_sym_explicit] = ACTIONS(5550),
    [anon_sym_typename] = ACTIONS(5550),
    [anon_sym_template] = ACTIONS(5550),
    [anon_sym_operator] = ACTIONS(5550),
    [anon_sym_friend] = ACTIONS(5550),
    [anon_sym_public] = ACTIONS(5550),
    [anon_sym_private] = ACTIONS(5550),
    [anon_sym_protected] = ACTIONS(5550),
    [anon_sym_using] = ACTIONS(5550),
    [anon_sym_static_assert] = ACTIONS(5550),
  },
  [2192] = {
    [sym_identifier] = ACTIONS(5554),
    [aux_sym_preproc_def_token1] = ACTIONS(5554),
    [aux_sym_preproc_if_token1] = ACTIONS(5554),
    [aux_sym_preproc_if_token2] = ACTIONS(5554),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5554),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5554),
    [aux_sym_preproc_else_token1] = ACTIONS(5554),
    [aux_sym_preproc_elif_token1] = ACTIONS(5554),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5554),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5554),
    [sym_preproc_directive] = ACTIONS(5554),
    [anon_sym_LPAREN2] = ACTIONS(5556),
    [anon_sym_TILDE] = ACTIONS(5556),
    [anon_sym_STAR] = ACTIONS(5556),
    [anon_sym_AMP_AMP] = ACTIONS(5556),
    [anon_sym_AMP] = ACTIONS(5554),
    [anon_sym___extension__] = ACTIONS(5554),
    [anon_sym_typedef] = ACTIONS(5554),
    [anon_sym_extern] = ACTIONS(5554),
    [anon_sym___attribute__] = ACTIONS(5554),
    [anon_sym_COLON_COLON] = ACTIONS(5556),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5556),
    [anon_sym___declspec] = ACTIONS(5554),
    [anon_sym___based] = ACTIONS(5554),
    [anon_sym_signed] = ACTIONS(5554),
    [anon_sym_unsigned] = ACTIONS(5554),
    [anon_sym_long] = ACTIONS(5554),
    [anon_sym_short] = ACTIONS(5554),
    [anon_sym_LBRACK] = ACTIONS(5554),
    [anon_sym_static] = ACTIONS(5554),
    [anon_sym_register] = ACTIONS(5554),
    [anon_sym_inline] = ACTIONS(5554),
    [anon_sym___inline] = ACTIONS(5554),
    [anon_sym___inline__] = ACTIONS(5554),
    [anon_sym___forceinline] = ACTIONS(5554),
    [anon_sym_thread_local] = ACTIONS(5554),
    [anon_sym___thread] = ACTIONS(5554),
    [anon_sym_const] = ACTIONS(5554),
    [anon_sym_constexpr] = ACTIONS(5554),
    [anon_sym_volatile] = ACTIONS(5554),
    [anon_sym_restrict] = ACTIONS(5554),
    [anon_sym___restrict__] = ACTIONS(5554),
    [anon_sym__Atomic] = ACTIONS(5554),
    [anon_sym__Noreturn] = ACTIONS(5554),
    [anon_sym_noreturn] = ACTIONS(5554),
    [anon_sym_mutable] = ACTIONS(5554),
    [anon_sym_constinit] = ACTIONS(5554),
    [anon_sym_consteval] = ACTIONS(5554),
    [anon_sym_PROGMEM] = ACTIONS(5554),
    [aux_sym_primitive_type_token1] = ACTIONS(5554),
    [anon_sym_byte] = ACTIONS(5554),
    [anon_sym_word] = ACTIONS(5554),
    [anon_sym_enum] = ACTIONS(5554),
    [anon_sym_class] = ACTIONS(5554),
    [anon_sym_struct] = ACTIONS(5554),
    [anon_sym_union] = ACTIONS(5554),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5554),
    [anon_sym_decltype] = ACTIONS(5554),
    [anon_sym_virtual] = ACTIONS(5554),
    [anon_sym_alignas] = ACTIONS(5554),
    [anon_sym_explicit] = ACTIONS(5554),
    [anon_sym_typename] = ACTIONS(5554),
    [anon_sym_template] = ACTIONS(5554),
    [anon_sym_operator] = ACTIONS(5554),
    [anon_sym_friend] = ACTIONS(5554),
    [anon_sym_public] = ACTIONS(5554),
    [anon_sym_private] = ACTIONS(5554),
    [anon_sym_protected] = ACTIONS(5554),
    [anon_sym_using] = ACTIONS(5554),
    [anon_sym_static_assert] = ACTIONS(5554),
  },
  [2193] = {
    [sym_identifier] = ACTIONS(3280),
    [aux_sym_preproc_def_token1] = ACTIONS(3280),
    [aux_sym_preproc_if_token1] = ACTIONS(3280),
    [aux_sym_preproc_if_token2] = ACTIONS(3280),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3280),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3280),
    [aux_sym_preproc_else_token1] = ACTIONS(3280),
    [aux_sym_preproc_elif_token1] = ACTIONS(3280),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3280),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3280),
    [sym_preproc_directive] = ACTIONS(3280),
    [anon_sym_LPAREN2] = ACTIONS(3282),
    [anon_sym_TILDE] = ACTIONS(3282),
    [anon_sym_STAR] = ACTIONS(3282),
    [anon_sym_AMP_AMP] = ACTIONS(3282),
    [anon_sym_AMP] = ACTIONS(3280),
    [anon_sym___extension__] = ACTIONS(3280),
    [anon_sym_typedef] = ACTIONS(3280),
    [anon_sym_extern] = ACTIONS(3280),
    [anon_sym___attribute__] = ACTIONS(3280),
    [anon_sym_COLON_COLON] = ACTIONS(3282),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3282),
    [anon_sym___declspec] = ACTIONS(3280),
    [anon_sym___based] = ACTIONS(3280),
    [anon_sym_signed] = ACTIONS(3280),
    [anon_sym_unsigned] = ACTIONS(3280),
    [anon_sym_long] = ACTIONS(3280),
    [anon_sym_short] = ACTIONS(3280),
    [anon_sym_LBRACK] = ACTIONS(3280),
    [anon_sym_static] = ACTIONS(3280),
    [anon_sym_register] = ACTIONS(3280),
    [anon_sym_inline] = ACTIONS(3280),
    [anon_sym___inline] = ACTIONS(3280),
    [anon_sym___inline__] = ACTIONS(3280),
    [anon_sym___forceinline] = ACTIONS(3280),
    [anon_sym_thread_local] = ACTIONS(3280),
    [anon_sym___thread] = ACTIONS(3280),
    [anon_sym_const] = ACTIONS(3280),
    [anon_sym_constexpr] = ACTIONS(3280),
    [anon_sym_volatile] = ACTIONS(3280),
    [anon_sym_restrict] = ACTIONS(3280),
    [anon_sym___restrict__] = ACTIONS(3280),
    [anon_sym__Atomic] = ACTIONS(3280),
    [anon_sym__Noreturn] = ACTIONS(3280),
    [anon_sym_noreturn] = ACTIONS(3280),
    [anon_sym_mutable] = ACTIONS(3280),
    [anon_sym_constinit] = ACTIONS(3280),
    [anon_sym_consteval] = ACTIONS(3280),
    [anon_sym_PROGMEM] = ACTIONS(3280),
    [aux_sym_primitive_type_token1] = ACTIONS(3280),
    [anon_sym_byte] = ACTIONS(3280),
    [anon_sym_word] = ACTIONS(3280),
    [anon_sym_enum] = ACTIONS(3280),
    [anon_sym_class] = ACTIONS(3280),
    [anon_sym_struct] = ACTIONS(3280),
    [anon_sym_union] = ACTIONS(3280),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3280),
    [anon_sym_decltype] = ACTIONS(3280),
    [anon_sym_virtual] = ACTIONS(3280),
    [anon_sym_alignas] = ACTIONS(3280),
    [anon_sym_explicit] = ACTIONS(3280),
    [anon_sym_typename] = ACTIONS(3280),
    [anon_sym_template] = ACTIONS(3280),
    [anon_sym_operator] = ACTIONS(3280),
    [anon_sym_friend] = ACTIONS(3280),
    [anon_sym_public] = ACTIONS(3280),
    [anon_sym_private] = ACTIONS(3280),
    [anon_sym_protected] = ACTIONS(3280),
    [anon_sym_using] = ACTIONS(3280),
    [anon_sym_static_assert] = ACTIONS(3280),
  },
  [2194] = {
    [sym_identifier] = ACTIONS(5558),
    [aux_sym_preproc_def_token1] = ACTIONS(5558),
    [aux_sym_preproc_if_token1] = ACTIONS(5558),
    [aux_sym_preproc_if_token2] = ACTIONS(5558),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5558),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5558),
    [aux_sym_preproc_else_token1] = ACTIONS(5558),
    [aux_sym_preproc_elif_token1] = ACTIONS(5558),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5558),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5558),
    [sym_preproc_directive] = ACTIONS(5558),
    [anon_sym_LPAREN2] = ACTIONS(5560),
    [anon_sym_TILDE] = ACTIONS(5560),
    [anon_sym_STAR] = ACTIONS(5560),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_AMP] = ACTIONS(5558),
    [anon_sym___extension__] = ACTIONS(5558),
    [anon_sym_typedef] = ACTIONS(5558),
    [anon_sym_extern] = ACTIONS(5558),
    [anon_sym___attribute__] = ACTIONS(5558),
    [anon_sym_COLON_COLON] = ACTIONS(5560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5560),
    [anon_sym___declspec] = ACTIONS(5558),
    [anon_sym___based] = ACTIONS(5558),
    [anon_sym_signed] = ACTIONS(5558),
    [anon_sym_unsigned] = ACTIONS(5558),
    [anon_sym_long] = ACTIONS(5558),
    [anon_sym_short] = ACTIONS(5558),
    [anon_sym_LBRACK] = ACTIONS(5558),
    [anon_sym_static] = ACTIONS(5558),
    [anon_sym_register] = ACTIONS(5558),
    [anon_sym_inline] = ACTIONS(5558),
    [anon_sym___inline] = ACTIONS(5558),
    [anon_sym___inline__] = ACTIONS(5558),
    [anon_sym___forceinline] = ACTIONS(5558),
    [anon_sym_thread_local] = ACTIONS(5558),
    [anon_sym___thread] = ACTIONS(5558),
    [anon_sym_const] = ACTIONS(5558),
    [anon_sym_constexpr] = ACTIONS(5558),
    [anon_sym_volatile] = ACTIONS(5558),
    [anon_sym_restrict] = ACTIONS(5558),
    [anon_sym___restrict__] = ACTIONS(5558),
    [anon_sym__Atomic] = ACTIONS(5558),
    [anon_sym__Noreturn] = ACTIONS(5558),
    [anon_sym_noreturn] = ACTIONS(5558),
    [anon_sym_mutable] = ACTIONS(5558),
    [anon_sym_constinit] = ACTIONS(5558),
    [anon_sym_consteval] = ACTIONS(5558),
    [anon_sym_PROGMEM] = ACTIONS(5558),
    [aux_sym_primitive_type_token1] = ACTIONS(5558),
    [anon_sym_byte] = ACTIONS(5558),
    [anon_sym_word] = ACTIONS(5558),
    [anon_sym_enum] = ACTIONS(5558),
    [anon_sym_class] = ACTIONS(5558),
    [anon_sym_struct] = ACTIONS(5558),
    [anon_sym_union] = ACTIONS(5558),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5558),
    [anon_sym_decltype] = ACTIONS(5558),
    [anon_sym_virtual] = ACTIONS(5558),
    [anon_sym_alignas] = ACTIONS(5558),
    [anon_sym_explicit] = ACTIONS(5558),
    [anon_sym_typename] = ACTIONS(5558),
    [anon_sym_template] = ACTIONS(5558),
    [anon_sym_operator] = ACTIONS(5558),
    [anon_sym_friend] = ACTIONS(5558),
    [anon_sym_public] = ACTIONS(5558),
    [anon_sym_private] = ACTIONS(5558),
    [anon_sym_protected] = ACTIONS(5558),
    [anon_sym_using] = ACTIONS(5558),
    [anon_sym_static_assert] = ACTIONS(5558),
  },
  [2195] = {
    [sym_identifier] = ACTIONS(5558),
    [aux_sym_preproc_def_token1] = ACTIONS(5558),
    [aux_sym_preproc_if_token1] = ACTIONS(5558),
    [aux_sym_preproc_if_token2] = ACTIONS(5558),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5558),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5558),
    [aux_sym_preproc_else_token1] = ACTIONS(5558),
    [aux_sym_preproc_elif_token1] = ACTIONS(5558),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5558),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5558),
    [sym_preproc_directive] = ACTIONS(5558),
    [anon_sym_LPAREN2] = ACTIONS(5560),
    [anon_sym_TILDE] = ACTIONS(5560),
    [anon_sym_STAR] = ACTIONS(5560),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_AMP] = ACTIONS(5558),
    [anon_sym___extension__] = ACTIONS(5558),
    [anon_sym_typedef] = ACTIONS(5558),
    [anon_sym_extern] = ACTIONS(5558),
    [anon_sym___attribute__] = ACTIONS(5558),
    [anon_sym_COLON_COLON] = ACTIONS(5560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5560),
    [anon_sym___declspec] = ACTIONS(5558),
    [anon_sym___based] = ACTIONS(5558),
    [anon_sym_signed] = ACTIONS(5558),
    [anon_sym_unsigned] = ACTIONS(5558),
    [anon_sym_long] = ACTIONS(5558),
    [anon_sym_short] = ACTIONS(5558),
    [anon_sym_LBRACK] = ACTIONS(5558),
    [anon_sym_static] = ACTIONS(5558),
    [anon_sym_register] = ACTIONS(5558),
    [anon_sym_inline] = ACTIONS(5558),
    [anon_sym___inline] = ACTIONS(5558),
    [anon_sym___inline__] = ACTIONS(5558),
    [anon_sym___forceinline] = ACTIONS(5558),
    [anon_sym_thread_local] = ACTIONS(5558),
    [anon_sym___thread] = ACTIONS(5558),
    [anon_sym_const] = ACTIONS(5558),
    [anon_sym_constexpr] = ACTIONS(5558),
    [anon_sym_volatile] = ACTIONS(5558),
    [anon_sym_restrict] = ACTIONS(5558),
    [anon_sym___restrict__] = ACTIONS(5558),
    [anon_sym__Atomic] = ACTIONS(5558),
    [anon_sym__Noreturn] = ACTIONS(5558),
    [anon_sym_noreturn] = ACTIONS(5558),
    [anon_sym_mutable] = ACTIONS(5558),
    [anon_sym_constinit] = ACTIONS(5558),
    [anon_sym_consteval] = ACTIONS(5558),
    [anon_sym_PROGMEM] = ACTIONS(5558),
    [aux_sym_primitive_type_token1] = ACTIONS(5558),
    [anon_sym_byte] = ACTIONS(5558),
    [anon_sym_word] = ACTIONS(5558),
    [anon_sym_enum] = ACTIONS(5558),
    [anon_sym_class] = ACTIONS(5558),
    [anon_sym_struct] = ACTIONS(5558),
    [anon_sym_union] = ACTIONS(5558),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5558),
    [anon_sym_decltype] = ACTIONS(5558),
    [anon_sym_virtual] = ACTIONS(5558),
    [anon_sym_alignas] = ACTIONS(5558),
    [anon_sym_explicit] = ACTIONS(5558),
    [anon_sym_typename] = ACTIONS(5558),
    [anon_sym_template] = ACTIONS(5558),
    [anon_sym_operator] = ACTIONS(5558),
    [anon_sym_friend] = ACTIONS(5558),
    [anon_sym_public] = ACTIONS(5558),
    [anon_sym_private] = ACTIONS(5558),
    [anon_sym_protected] = ACTIONS(5558),
    [anon_sym_using] = ACTIONS(5558),
    [anon_sym_static_assert] = ACTIONS(5558),
  },
  [2196] = {
    [sym_identifier] = ACTIONS(5507),
    [aux_sym_preproc_def_token1] = ACTIONS(5507),
    [aux_sym_preproc_if_token1] = ACTIONS(5507),
    [aux_sym_preproc_if_token2] = ACTIONS(5507),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5507),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5507),
    [aux_sym_preproc_else_token1] = ACTIONS(5507),
    [aux_sym_preproc_elif_token1] = ACTIONS(5507),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5507),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5507),
    [sym_preproc_directive] = ACTIONS(5507),
    [anon_sym_LPAREN2] = ACTIONS(5509),
    [anon_sym_TILDE] = ACTIONS(5509),
    [anon_sym_STAR] = ACTIONS(5509),
    [anon_sym_AMP_AMP] = ACTIONS(5509),
    [anon_sym_AMP] = ACTIONS(5507),
    [anon_sym___extension__] = ACTIONS(5507),
    [anon_sym_typedef] = ACTIONS(5507),
    [anon_sym_extern] = ACTIONS(5507),
    [anon_sym___attribute__] = ACTIONS(5507),
    [anon_sym_COLON_COLON] = ACTIONS(5509),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5509),
    [anon_sym___declspec] = ACTIONS(5507),
    [anon_sym___based] = ACTIONS(5507),
    [anon_sym_signed] = ACTIONS(5507),
    [anon_sym_unsigned] = ACTIONS(5507),
    [anon_sym_long] = ACTIONS(5507),
    [anon_sym_short] = ACTIONS(5507),
    [anon_sym_LBRACK] = ACTIONS(5507),
    [anon_sym_static] = ACTIONS(5507),
    [anon_sym_register] = ACTIONS(5507),
    [anon_sym_inline] = ACTIONS(5507),
    [anon_sym___inline] = ACTIONS(5507),
    [anon_sym___inline__] = ACTIONS(5507),
    [anon_sym___forceinline] = ACTIONS(5507),
    [anon_sym_thread_local] = ACTIONS(5507),
    [anon_sym___thread] = ACTIONS(5507),
    [anon_sym_const] = ACTIONS(5507),
    [anon_sym_constexpr] = ACTIONS(5507),
    [anon_sym_volatile] = ACTIONS(5507),
    [anon_sym_restrict] = ACTIONS(5507),
    [anon_sym___restrict__] = ACTIONS(5507),
    [anon_sym__Atomic] = ACTIONS(5507),
    [anon_sym__Noreturn] = ACTIONS(5507),
    [anon_sym_noreturn] = ACTIONS(5507),
    [anon_sym_mutable] = ACTIONS(5507),
    [anon_sym_constinit] = ACTIONS(5507),
    [anon_sym_consteval] = ACTIONS(5507),
    [anon_sym_PROGMEM] = ACTIONS(5507),
    [aux_sym_primitive_type_token1] = ACTIONS(5507),
    [anon_sym_byte] = ACTIONS(5507),
    [anon_sym_word] = ACTIONS(5507),
    [anon_sym_enum] = ACTIONS(5507),
    [anon_sym_class] = ACTIONS(5507),
    [anon_sym_struct] = ACTIONS(5507),
    [anon_sym_union] = ACTIONS(5507),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5507),
    [anon_sym_decltype] = ACTIONS(5507),
    [anon_sym_virtual] = ACTIONS(5507),
    [anon_sym_alignas] = ACTIONS(5507),
    [anon_sym_explicit] = ACTIONS(5507),
    [anon_sym_typename] = ACTIONS(5507),
    [anon_sym_template] = ACTIONS(5507),
    [anon_sym_operator] = ACTIONS(5507),
    [anon_sym_friend] = ACTIONS(5507),
    [anon_sym_public] = ACTIONS(5507),
    [anon_sym_private] = ACTIONS(5507),
    [anon_sym_protected] = ACTIONS(5507),
    [anon_sym_using] = ACTIONS(5507),
    [anon_sym_static_assert] = ACTIONS(5507),
  },
  [2197] = {
    [sym_identifier] = ACTIONS(5562),
    [aux_sym_preproc_def_token1] = ACTIONS(5562),
    [aux_sym_preproc_if_token1] = ACTIONS(5562),
    [aux_sym_preproc_if_token2] = ACTIONS(5562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5562),
    [aux_sym_preproc_else_token1] = ACTIONS(5562),
    [aux_sym_preproc_elif_token1] = ACTIONS(5562),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5562),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5562),
    [sym_preproc_directive] = ACTIONS(5562),
    [anon_sym_LPAREN2] = ACTIONS(5564),
    [anon_sym_TILDE] = ACTIONS(5564),
    [anon_sym_STAR] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5562),
    [anon_sym___extension__] = ACTIONS(5562),
    [anon_sym_typedef] = ACTIONS(5562),
    [anon_sym_extern] = ACTIONS(5562),
    [anon_sym___attribute__] = ACTIONS(5562),
    [anon_sym_COLON_COLON] = ACTIONS(5564),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5564),
    [anon_sym___declspec] = ACTIONS(5562),
    [anon_sym___based] = ACTIONS(5562),
    [anon_sym_signed] = ACTIONS(5562),
    [anon_sym_unsigned] = ACTIONS(5562),
    [anon_sym_long] = ACTIONS(5562),
    [anon_sym_short] = ACTIONS(5562),
    [anon_sym_LBRACK] = ACTIONS(5562),
    [anon_sym_static] = ACTIONS(5562),
    [anon_sym_register] = ACTIONS(5562),
    [anon_sym_inline] = ACTIONS(5562),
    [anon_sym___inline] = ACTIONS(5562),
    [anon_sym___inline__] = ACTIONS(5562),
    [anon_sym___forceinline] = ACTIONS(5562),
    [anon_sym_thread_local] = ACTIONS(5562),
    [anon_sym___thread] = ACTIONS(5562),
    [anon_sym_const] = ACTIONS(5562),
    [anon_sym_constexpr] = ACTIONS(5562),
    [anon_sym_volatile] = ACTIONS(5562),
    [anon_sym_restrict] = ACTIONS(5562),
    [anon_sym___restrict__] = ACTIONS(5562),
    [anon_sym__Atomic] = ACTIONS(5562),
    [anon_sym__Noreturn] = ACTIONS(5562),
    [anon_sym_noreturn] = ACTIONS(5562),
    [anon_sym_mutable] = ACTIONS(5562),
    [anon_sym_constinit] = ACTIONS(5562),
    [anon_sym_consteval] = ACTIONS(5562),
    [anon_sym_PROGMEM] = ACTIONS(5562),
    [aux_sym_primitive_type_token1] = ACTIONS(5562),
    [anon_sym_byte] = ACTIONS(5562),
    [anon_sym_word] = ACTIONS(5562),
    [anon_sym_enum] = ACTIONS(5562),
    [anon_sym_class] = ACTIONS(5562),
    [anon_sym_struct] = ACTIONS(5562),
    [anon_sym_union] = ACTIONS(5562),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5562),
    [anon_sym_decltype] = ACTIONS(5562),
    [anon_sym_virtual] = ACTIONS(5562),
    [anon_sym_alignas] = ACTIONS(5562),
    [anon_sym_explicit] = ACTIONS(5562),
    [anon_sym_typename] = ACTIONS(5562),
    [anon_sym_template] = ACTIONS(5562),
    [anon_sym_operator] = ACTIONS(5562),
    [anon_sym_friend] = ACTIONS(5562),
    [anon_sym_public] = ACTIONS(5562),
    [anon_sym_private] = ACTIONS(5562),
    [anon_sym_protected] = ACTIONS(5562),
    [anon_sym_using] = ACTIONS(5562),
    [anon_sym_static_assert] = ACTIONS(5562),
  },
  [2198] = {
    [sym_identifier] = ACTIONS(5566),
    [aux_sym_preproc_def_token1] = ACTIONS(5566),
    [aux_sym_preproc_if_token1] = ACTIONS(5566),
    [aux_sym_preproc_if_token2] = ACTIONS(5566),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5566),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5566),
    [aux_sym_preproc_else_token1] = ACTIONS(5566),
    [aux_sym_preproc_elif_token1] = ACTIONS(5566),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5566),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5566),
    [sym_preproc_directive] = ACTIONS(5566),
    [anon_sym_LPAREN2] = ACTIONS(5568),
    [anon_sym_TILDE] = ACTIONS(5568),
    [anon_sym_STAR] = ACTIONS(5568),
    [anon_sym_AMP_AMP] = ACTIONS(5568),
    [anon_sym_AMP] = ACTIONS(5566),
    [anon_sym___extension__] = ACTIONS(5566),
    [anon_sym_typedef] = ACTIONS(5566),
    [anon_sym_extern] = ACTIONS(5566),
    [anon_sym___attribute__] = ACTIONS(5566),
    [anon_sym_COLON_COLON] = ACTIONS(5568),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5568),
    [anon_sym___declspec] = ACTIONS(5566),
    [anon_sym___based] = ACTIONS(5566),
    [anon_sym_signed] = ACTIONS(5566),
    [anon_sym_unsigned] = ACTIONS(5566),
    [anon_sym_long] = ACTIONS(5566),
    [anon_sym_short] = ACTIONS(5566),
    [anon_sym_LBRACK] = ACTIONS(5566),
    [anon_sym_static] = ACTIONS(5566),
    [anon_sym_register] = ACTIONS(5566),
    [anon_sym_inline] = ACTIONS(5566),
    [anon_sym___inline] = ACTIONS(5566),
    [anon_sym___inline__] = ACTIONS(5566),
    [anon_sym___forceinline] = ACTIONS(5566),
    [anon_sym_thread_local] = ACTIONS(5566),
    [anon_sym___thread] = ACTIONS(5566),
    [anon_sym_const] = ACTIONS(5566),
    [anon_sym_constexpr] = ACTIONS(5566),
    [anon_sym_volatile] = ACTIONS(5566),
    [anon_sym_restrict] = ACTIONS(5566),
    [anon_sym___restrict__] = ACTIONS(5566),
    [anon_sym__Atomic] = ACTIONS(5566),
    [anon_sym__Noreturn] = ACTIONS(5566),
    [anon_sym_noreturn] = ACTIONS(5566),
    [anon_sym_mutable] = ACTIONS(5566),
    [anon_sym_constinit] = ACTIONS(5566),
    [anon_sym_consteval] = ACTIONS(5566),
    [anon_sym_PROGMEM] = ACTIONS(5566),
    [aux_sym_primitive_type_token1] = ACTIONS(5566),
    [anon_sym_byte] = ACTIONS(5566),
    [anon_sym_word] = ACTIONS(5566),
    [anon_sym_enum] = ACTIONS(5566),
    [anon_sym_class] = ACTIONS(5566),
    [anon_sym_struct] = ACTIONS(5566),
    [anon_sym_union] = ACTIONS(5566),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5566),
    [anon_sym_decltype] = ACTIONS(5566),
    [anon_sym_virtual] = ACTIONS(5566),
    [anon_sym_alignas] = ACTIONS(5566),
    [anon_sym_explicit] = ACTIONS(5566),
    [anon_sym_typename] = ACTIONS(5566),
    [anon_sym_template] = ACTIONS(5566),
    [anon_sym_operator] = ACTIONS(5566),
    [anon_sym_friend] = ACTIONS(5566),
    [anon_sym_public] = ACTIONS(5566),
    [anon_sym_private] = ACTIONS(5566),
    [anon_sym_protected] = ACTIONS(5566),
    [anon_sym_using] = ACTIONS(5566),
    [anon_sym_static_assert] = ACTIONS(5566),
  },
  [2199] = {
    [sym_identifier] = ACTIONS(5570),
    [aux_sym_preproc_def_token1] = ACTIONS(5570),
    [aux_sym_preproc_if_token1] = ACTIONS(5570),
    [aux_sym_preproc_if_token2] = ACTIONS(5570),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5570),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5570),
    [aux_sym_preproc_else_token1] = ACTIONS(5570),
    [aux_sym_preproc_elif_token1] = ACTIONS(5570),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5570),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5570),
    [sym_preproc_directive] = ACTIONS(5570),
    [anon_sym_LPAREN2] = ACTIONS(5572),
    [anon_sym_TILDE] = ACTIONS(5572),
    [anon_sym_STAR] = ACTIONS(5572),
    [anon_sym_AMP_AMP] = ACTIONS(5572),
    [anon_sym_AMP] = ACTIONS(5570),
    [anon_sym___extension__] = ACTIONS(5570),
    [anon_sym_typedef] = ACTIONS(5570),
    [anon_sym_extern] = ACTIONS(5570),
    [anon_sym___attribute__] = ACTIONS(5570),
    [anon_sym_COLON_COLON] = ACTIONS(5572),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5572),
    [anon_sym___declspec] = ACTIONS(5570),
    [anon_sym___based] = ACTIONS(5570),
    [anon_sym_signed] = ACTIONS(5570),
    [anon_sym_unsigned] = ACTIONS(5570),
    [anon_sym_long] = ACTIONS(5570),
    [anon_sym_short] = ACTIONS(5570),
    [anon_sym_LBRACK] = ACTIONS(5570),
    [anon_sym_static] = ACTIONS(5570),
    [anon_sym_register] = ACTIONS(5570),
    [anon_sym_inline] = ACTIONS(5570),
    [anon_sym___inline] = ACTIONS(5570),
    [anon_sym___inline__] = ACTIONS(5570),
    [anon_sym___forceinline] = ACTIONS(5570),
    [anon_sym_thread_local] = ACTIONS(5570),
    [anon_sym___thread] = ACTIONS(5570),
    [anon_sym_const] = ACTIONS(5570),
    [anon_sym_constexpr] = ACTIONS(5570),
    [anon_sym_volatile] = ACTIONS(5570),
    [anon_sym_restrict] = ACTIONS(5570),
    [anon_sym___restrict__] = ACTIONS(5570),
    [anon_sym__Atomic] = ACTIONS(5570),
    [anon_sym__Noreturn] = ACTIONS(5570),
    [anon_sym_noreturn] = ACTIONS(5570),
    [anon_sym_mutable] = ACTIONS(5570),
    [anon_sym_constinit] = ACTIONS(5570),
    [anon_sym_consteval] = ACTIONS(5570),
    [anon_sym_PROGMEM] = ACTIONS(5570),
    [aux_sym_primitive_type_token1] = ACTIONS(5570),
    [anon_sym_byte] = ACTIONS(5570),
    [anon_sym_word] = ACTIONS(5570),
    [anon_sym_enum] = ACTIONS(5570),
    [anon_sym_class] = ACTIONS(5570),
    [anon_sym_struct] = ACTIONS(5570),
    [anon_sym_union] = ACTIONS(5570),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5570),
    [anon_sym_decltype] = ACTIONS(5570),
    [anon_sym_virtual] = ACTIONS(5570),
    [anon_sym_alignas] = ACTIONS(5570),
    [anon_sym_explicit] = ACTIONS(5570),
    [anon_sym_typename] = ACTIONS(5570),
    [anon_sym_template] = ACTIONS(5570),
    [anon_sym_operator] = ACTIONS(5570),
    [anon_sym_friend] = ACTIONS(5570),
    [anon_sym_public] = ACTIONS(5570),
    [anon_sym_private] = ACTIONS(5570),
    [anon_sym_protected] = ACTIONS(5570),
    [anon_sym_using] = ACTIONS(5570),
    [anon_sym_static_assert] = ACTIONS(5570),
  },
  [2200] = {
    [sym_identifier] = ACTIONS(5574),
    [aux_sym_preproc_def_token1] = ACTIONS(5574),
    [aux_sym_preproc_if_token1] = ACTIONS(5574),
    [aux_sym_preproc_if_token2] = ACTIONS(5574),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5574),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5574),
    [aux_sym_preproc_else_token1] = ACTIONS(5574),
    [aux_sym_preproc_elif_token1] = ACTIONS(5574),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5574),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5574),
    [sym_preproc_directive] = ACTIONS(5574),
    [anon_sym_LPAREN2] = ACTIONS(5576),
    [anon_sym_TILDE] = ACTIONS(5576),
    [anon_sym_STAR] = ACTIONS(5576),
    [anon_sym_AMP_AMP] = ACTIONS(5576),
    [anon_sym_AMP] = ACTIONS(5574),
    [anon_sym___extension__] = ACTIONS(5574),
    [anon_sym_typedef] = ACTIONS(5574),
    [anon_sym_extern] = ACTIONS(5574),
    [anon_sym___attribute__] = ACTIONS(5574),
    [anon_sym_COLON_COLON] = ACTIONS(5576),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5576),
    [anon_sym___declspec] = ACTIONS(5574),
    [anon_sym___based] = ACTIONS(5574),
    [anon_sym_signed] = ACTIONS(5574),
    [anon_sym_unsigned] = ACTIONS(5574),
    [anon_sym_long] = ACTIONS(5574),
    [anon_sym_short] = ACTIONS(5574),
    [anon_sym_LBRACK] = ACTIONS(5574),
    [anon_sym_static] = ACTIONS(5574),
    [anon_sym_register] = ACTIONS(5574),
    [anon_sym_inline] = ACTIONS(5574),
    [anon_sym___inline] = ACTIONS(5574),
    [anon_sym___inline__] = ACTIONS(5574),
    [anon_sym___forceinline] = ACTIONS(5574),
    [anon_sym_thread_local] = ACTIONS(5574),
    [anon_sym___thread] = ACTIONS(5574),
    [anon_sym_const] = ACTIONS(5574),
    [anon_sym_constexpr] = ACTIONS(5574),
    [anon_sym_volatile] = ACTIONS(5574),
    [anon_sym_restrict] = ACTIONS(5574),
    [anon_sym___restrict__] = ACTIONS(5574),
    [anon_sym__Atomic] = ACTIONS(5574),
    [anon_sym__Noreturn] = ACTIONS(5574),
    [anon_sym_noreturn] = ACTIONS(5574),
    [anon_sym_mutable] = ACTIONS(5574),
    [anon_sym_constinit] = ACTIONS(5574),
    [anon_sym_consteval] = ACTIONS(5574),
    [anon_sym_PROGMEM] = ACTIONS(5574),
    [aux_sym_primitive_type_token1] = ACTIONS(5574),
    [anon_sym_byte] = ACTIONS(5574),
    [anon_sym_word] = ACTIONS(5574),
    [anon_sym_enum] = ACTIONS(5574),
    [anon_sym_class] = ACTIONS(5574),
    [anon_sym_struct] = ACTIONS(5574),
    [anon_sym_union] = ACTIONS(5574),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5574),
    [anon_sym_decltype] = ACTIONS(5574),
    [anon_sym_virtual] = ACTIONS(5574),
    [anon_sym_alignas] = ACTIONS(5574),
    [anon_sym_explicit] = ACTIONS(5574),
    [anon_sym_typename] = ACTIONS(5574),
    [anon_sym_template] = ACTIONS(5574),
    [anon_sym_operator] = ACTIONS(5574),
    [anon_sym_friend] = ACTIONS(5574),
    [anon_sym_public] = ACTIONS(5574),
    [anon_sym_private] = ACTIONS(5574),
    [anon_sym_protected] = ACTIONS(5574),
    [anon_sym_using] = ACTIONS(5574),
    [anon_sym_static_assert] = ACTIONS(5574),
  },
  [2201] = {
    [sym_identifier] = ACTIONS(5578),
    [aux_sym_preproc_def_token1] = ACTIONS(5578),
    [aux_sym_preproc_if_token1] = ACTIONS(5578),
    [aux_sym_preproc_if_token2] = ACTIONS(5578),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5578),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5578),
    [aux_sym_preproc_else_token1] = ACTIONS(5578),
    [aux_sym_preproc_elif_token1] = ACTIONS(5578),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5578),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5578),
    [sym_preproc_directive] = ACTIONS(5578),
    [anon_sym_LPAREN2] = ACTIONS(5580),
    [anon_sym_TILDE] = ACTIONS(5580),
    [anon_sym_STAR] = ACTIONS(5580),
    [anon_sym_AMP_AMP] = ACTIONS(5580),
    [anon_sym_AMP] = ACTIONS(5578),
    [anon_sym___extension__] = ACTIONS(5578),
    [anon_sym_typedef] = ACTIONS(5578),
    [anon_sym_extern] = ACTIONS(5578),
    [anon_sym___attribute__] = ACTIONS(5578),
    [anon_sym_COLON_COLON] = ACTIONS(5580),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5580),
    [anon_sym___declspec] = ACTIONS(5578),
    [anon_sym___based] = ACTIONS(5578),
    [anon_sym_signed] = ACTIONS(5578),
    [anon_sym_unsigned] = ACTIONS(5578),
    [anon_sym_long] = ACTIONS(5578),
    [anon_sym_short] = ACTIONS(5578),
    [anon_sym_LBRACK] = ACTIONS(5578),
    [anon_sym_static] = ACTIONS(5578),
    [anon_sym_register] = ACTIONS(5578),
    [anon_sym_inline] = ACTIONS(5578),
    [anon_sym___inline] = ACTIONS(5578),
    [anon_sym___inline__] = ACTIONS(5578),
    [anon_sym___forceinline] = ACTIONS(5578),
    [anon_sym_thread_local] = ACTIONS(5578),
    [anon_sym___thread] = ACTIONS(5578),
    [anon_sym_const] = ACTIONS(5578),
    [anon_sym_constexpr] = ACTIONS(5578),
    [anon_sym_volatile] = ACTIONS(5578),
    [anon_sym_restrict] = ACTIONS(5578),
    [anon_sym___restrict__] = ACTIONS(5578),
    [anon_sym__Atomic] = ACTIONS(5578),
    [anon_sym__Noreturn] = ACTIONS(5578),
    [anon_sym_noreturn] = ACTIONS(5578),
    [anon_sym_mutable] = ACTIONS(5578),
    [anon_sym_constinit] = ACTIONS(5578),
    [anon_sym_consteval] = ACTIONS(5578),
    [anon_sym_PROGMEM] = ACTIONS(5578),
    [aux_sym_primitive_type_token1] = ACTIONS(5578),
    [anon_sym_byte] = ACTIONS(5578),
    [anon_sym_word] = ACTIONS(5578),
    [anon_sym_enum] = ACTIONS(5578),
    [anon_sym_class] = ACTIONS(5578),
    [anon_sym_struct] = ACTIONS(5578),
    [anon_sym_union] = ACTIONS(5578),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5578),
    [anon_sym_decltype] = ACTIONS(5578),
    [anon_sym_virtual] = ACTIONS(5578),
    [anon_sym_alignas] = ACTIONS(5578),
    [anon_sym_explicit] = ACTIONS(5578),
    [anon_sym_typename] = ACTIONS(5578),
    [anon_sym_template] = ACTIONS(5578),
    [anon_sym_operator] = ACTIONS(5578),
    [anon_sym_friend] = ACTIONS(5578),
    [anon_sym_public] = ACTIONS(5578),
    [anon_sym_private] = ACTIONS(5578),
    [anon_sym_protected] = ACTIONS(5578),
    [anon_sym_using] = ACTIONS(5578),
    [anon_sym_static_assert] = ACTIONS(5578),
  },
  [2202] = {
    [sym_identifier] = ACTIONS(5578),
    [aux_sym_preproc_def_token1] = ACTIONS(5578),
    [aux_sym_preproc_if_token1] = ACTIONS(5578),
    [aux_sym_preproc_if_token2] = ACTIONS(5578),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5578),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5578),
    [aux_sym_preproc_else_token1] = ACTIONS(5578),
    [aux_sym_preproc_elif_token1] = ACTIONS(5578),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5578),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5578),
    [sym_preproc_directive] = ACTIONS(5578),
    [anon_sym_LPAREN2] = ACTIONS(5580),
    [anon_sym_TILDE] = ACTIONS(5580),
    [anon_sym_STAR] = ACTIONS(5580),
    [anon_sym_AMP_AMP] = ACTIONS(5580),
    [anon_sym_AMP] = ACTIONS(5578),
    [anon_sym___extension__] = ACTIONS(5578),
    [anon_sym_typedef] = ACTIONS(5578),
    [anon_sym_extern] = ACTIONS(5578),
    [anon_sym___attribute__] = ACTIONS(5578),
    [anon_sym_COLON_COLON] = ACTIONS(5580),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5580),
    [anon_sym___declspec] = ACTIONS(5578),
    [anon_sym___based] = ACTIONS(5578),
    [anon_sym_signed] = ACTIONS(5578),
    [anon_sym_unsigned] = ACTIONS(5578),
    [anon_sym_long] = ACTIONS(5578),
    [anon_sym_short] = ACTIONS(5578),
    [anon_sym_LBRACK] = ACTIONS(5578),
    [anon_sym_static] = ACTIONS(5578),
    [anon_sym_register] = ACTIONS(5578),
    [anon_sym_inline] = ACTIONS(5578),
    [anon_sym___inline] = ACTIONS(5578),
    [anon_sym___inline__] = ACTIONS(5578),
    [anon_sym___forceinline] = ACTIONS(5578),
    [anon_sym_thread_local] = ACTIONS(5578),
    [anon_sym___thread] = ACTIONS(5578),
    [anon_sym_const] = ACTIONS(5578),
    [anon_sym_constexpr] = ACTIONS(5578),
    [anon_sym_volatile] = ACTIONS(5578),
    [anon_sym_restrict] = ACTIONS(5578),
    [anon_sym___restrict__] = ACTIONS(5578),
    [anon_sym__Atomic] = ACTIONS(5578),
    [anon_sym__Noreturn] = ACTIONS(5578),
    [anon_sym_noreturn] = ACTIONS(5578),
    [anon_sym_mutable] = ACTIONS(5578),
    [anon_sym_constinit] = ACTIONS(5578),
    [anon_sym_consteval] = ACTIONS(5578),
    [anon_sym_PROGMEM] = ACTIONS(5578),
    [aux_sym_primitive_type_token1] = ACTIONS(5578),
    [anon_sym_byte] = ACTIONS(5578),
    [anon_sym_word] = ACTIONS(5578),
    [anon_sym_enum] = ACTIONS(5578),
    [anon_sym_class] = ACTIONS(5578),
    [anon_sym_struct] = ACTIONS(5578),
    [anon_sym_union] = ACTIONS(5578),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5578),
    [anon_sym_decltype] = ACTIONS(5578),
    [anon_sym_virtual] = ACTIONS(5578),
    [anon_sym_alignas] = ACTIONS(5578),
    [anon_sym_explicit] = ACTIONS(5578),
    [anon_sym_typename] = ACTIONS(5578),
    [anon_sym_template] = ACTIONS(5578),
    [anon_sym_operator] = ACTIONS(5578),
    [anon_sym_friend] = ACTIONS(5578),
    [anon_sym_public] = ACTIONS(5578),
    [anon_sym_private] = ACTIONS(5578),
    [anon_sym_protected] = ACTIONS(5578),
    [anon_sym_using] = ACTIONS(5578),
    [anon_sym_static_assert] = ACTIONS(5578),
  },
  [2203] = {
    [sym_identifier] = ACTIONS(2970),
    [aux_sym_preproc_def_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token2] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2970),
    [aux_sym_preproc_else_token1] = ACTIONS(2970),
    [aux_sym_preproc_elif_token1] = ACTIONS(2970),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2970),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2970),
    [sym_preproc_directive] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym___extension__] = ACTIONS(2970),
    [anon_sym_typedef] = ACTIONS(2970),
    [anon_sym_extern] = ACTIONS(2970),
    [anon_sym___attribute__] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2970),
    [anon_sym___based] = ACTIONS(2970),
    [anon_sym_signed] = ACTIONS(2970),
    [anon_sym_unsigned] = ACTIONS(2970),
    [anon_sym_long] = ACTIONS(2970),
    [anon_sym_short] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_register] = ACTIONS(2970),
    [anon_sym_inline] = ACTIONS(2970),
    [anon_sym___inline] = ACTIONS(2970),
    [anon_sym___inline__] = ACTIONS(2970),
    [anon_sym___forceinline] = ACTIONS(2970),
    [anon_sym_thread_local] = ACTIONS(2970),
    [anon_sym___thread] = ACTIONS(2970),
    [anon_sym_const] = ACTIONS(2970),
    [anon_sym_constexpr] = ACTIONS(2970),
    [anon_sym_volatile] = ACTIONS(2970),
    [anon_sym_restrict] = ACTIONS(2970),
    [anon_sym___restrict__] = ACTIONS(2970),
    [anon_sym__Atomic] = ACTIONS(2970),
    [anon_sym__Noreturn] = ACTIONS(2970),
    [anon_sym_noreturn] = ACTIONS(2970),
    [anon_sym_mutable] = ACTIONS(2970),
    [anon_sym_constinit] = ACTIONS(2970),
    [anon_sym_consteval] = ACTIONS(2970),
    [anon_sym_PROGMEM] = ACTIONS(2970),
    [aux_sym_primitive_type_token1] = ACTIONS(2970),
    [anon_sym_byte] = ACTIONS(2970),
    [anon_sym_word] = ACTIONS(2970),
    [anon_sym_enum] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_struct] = ACTIONS(2970),
    [anon_sym_union] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2970),
    [anon_sym_decltype] = ACTIONS(2970),
    [anon_sym_virtual] = ACTIONS(2970),
    [anon_sym_alignas] = ACTIONS(2970),
    [anon_sym_explicit] = ACTIONS(2970),
    [anon_sym_typename] = ACTIONS(2970),
    [anon_sym_template] = ACTIONS(2970),
    [anon_sym_operator] = ACTIONS(2970),
    [anon_sym_friend] = ACTIONS(2970),
    [anon_sym_public] = ACTIONS(2970),
    [anon_sym_private] = ACTIONS(2970),
    [anon_sym_protected] = ACTIONS(2970),
    [anon_sym_using] = ACTIONS(2970),
    [anon_sym_static_assert] = ACTIONS(2970),
  },
  [2204] = {
    [sym_identifier] = ACTIONS(5582),
    [aux_sym_preproc_def_token1] = ACTIONS(5582),
    [aux_sym_preproc_if_token1] = ACTIONS(5582),
    [aux_sym_preproc_if_token2] = ACTIONS(5582),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5582),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5582),
    [aux_sym_preproc_else_token1] = ACTIONS(5582),
    [aux_sym_preproc_elif_token1] = ACTIONS(5582),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5582),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5582),
    [sym_preproc_directive] = ACTIONS(5582),
    [anon_sym_LPAREN2] = ACTIONS(5584),
    [anon_sym_TILDE] = ACTIONS(5584),
    [anon_sym_STAR] = ACTIONS(5584),
    [anon_sym_AMP_AMP] = ACTIONS(5584),
    [anon_sym_AMP] = ACTIONS(5582),
    [anon_sym___extension__] = ACTIONS(5582),
    [anon_sym_typedef] = ACTIONS(5582),
    [anon_sym_extern] = ACTIONS(5582),
    [anon_sym___attribute__] = ACTIONS(5582),
    [anon_sym_COLON_COLON] = ACTIONS(5584),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5584),
    [anon_sym___declspec] = ACTIONS(5582),
    [anon_sym___based] = ACTIONS(5582),
    [anon_sym_signed] = ACTIONS(5582),
    [anon_sym_unsigned] = ACTIONS(5582),
    [anon_sym_long] = ACTIONS(5582),
    [anon_sym_short] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(5582),
    [anon_sym_static] = ACTIONS(5582),
    [anon_sym_register] = ACTIONS(5582),
    [anon_sym_inline] = ACTIONS(5582),
    [anon_sym___inline] = ACTIONS(5582),
    [anon_sym___inline__] = ACTIONS(5582),
    [anon_sym___forceinline] = ACTIONS(5582),
    [anon_sym_thread_local] = ACTIONS(5582),
    [anon_sym___thread] = ACTIONS(5582),
    [anon_sym_const] = ACTIONS(5582),
    [anon_sym_constexpr] = ACTIONS(5582),
    [anon_sym_volatile] = ACTIONS(5582),
    [anon_sym_restrict] = ACTIONS(5582),
    [anon_sym___restrict__] = ACTIONS(5582),
    [anon_sym__Atomic] = ACTIONS(5582),
    [anon_sym__Noreturn] = ACTIONS(5582),
    [anon_sym_noreturn] = ACTIONS(5582),
    [anon_sym_mutable] = ACTIONS(5582),
    [anon_sym_constinit] = ACTIONS(5582),
    [anon_sym_consteval] = ACTIONS(5582),
    [anon_sym_PROGMEM] = ACTIONS(5582),
    [aux_sym_primitive_type_token1] = ACTIONS(5582),
    [anon_sym_byte] = ACTIONS(5582),
    [anon_sym_word] = ACTIONS(5582),
    [anon_sym_enum] = ACTIONS(5582),
    [anon_sym_class] = ACTIONS(5582),
    [anon_sym_struct] = ACTIONS(5582),
    [anon_sym_union] = ACTIONS(5582),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5582),
    [anon_sym_decltype] = ACTIONS(5582),
    [anon_sym_virtual] = ACTIONS(5582),
    [anon_sym_alignas] = ACTIONS(5582),
    [anon_sym_explicit] = ACTIONS(5582),
    [anon_sym_typename] = ACTIONS(5582),
    [anon_sym_template] = ACTIONS(5582),
    [anon_sym_operator] = ACTIONS(5582),
    [anon_sym_friend] = ACTIONS(5582),
    [anon_sym_public] = ACTIONS(5582),
    [anon_sym_private] = ACTIONS(5582),
    [anon_sym_protected] = ACTIONS(5582),
    [anon_sym_using] = ACTIONS(5582),
    [anon_sym_static_assert] = ACTIONS(5582),
  },
  [2205] = {
    [sym_identifier] = ACTIONS(5586),
    [aux_sym_preproc_def_token1] = ACTIONS(5586),
    [aux_sym_preproc_if_token1] = ACTIONS(5586),
    [aux_sym_preproc_if_token2] = ACTIONS(5586),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5586),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5586),
    [aux_sym_preproc_else_token1] = ACTIONS(5586),
    [aux_sym_preproc_elif_token1] = ACTIONS(5586),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5586),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5586),
    [sym_preproc_directive] = ACTIONS(5586),
    [anon_sym_LPAREN2] = ACTIONS(5588),
    [anon_sym_TILDE] = ACTIONS(5588),
    [anon_sym_STAR] = ACTIONS(5588),
    [anon_sym_AMP_AMP] = ACTIONS(5588),
    [anon_sym_AMP] = ACTIONS(5586),
    [anon_sym___extension__] = ACTIONS(5586),
    [anon_sym_typedef] = ACTIONS(5586),
    [anon_sym_extern] = ACTIONS(5586),
    [anon_sym___attribute__] = ACTIONS(5586),
    [anon_sym_COLON_COLON] = ACTIONS(5588),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5588),
    [anon_sym___declspec] = ACTIONS(5586),
    [anon_sym___based] = ACTIONS(5586),
    [anon_sym_signed] = ACTIONS(5586),
    [anon_sym_unsigned] = ACTIONS(5586),
    [anon_sym_long] = ACTIONS(5586),
    [anon_sym_short] = ACTIONS(5586),
    [anon_sym_LBRACK] = ACTIONS(5586),
    [anon_sym_static] = ACTIONS(5586),
    [anon_sym_register] = ACTIONS(5586),
    [anon_sym_inline] = ACTIONS(5586),
    [anon_sym___inline] = ACTIONS(5586),
    [anon_sym___inline__] = ACTIONS(5586),
    [anon_sym___forceinline] = ACTIONS(5586),
    [anon_sym_thread_local] = ACTIONS(5586),
    [anon_sym___thread] = ACTIONS(5586),
    [anon_sym_const] = ACTIONS(5586),
    [anon_sym_constexpr] = ACTIONS(5586),
    [anon_sym_volatile] = ACTIONS(5586),
    [anon_sym_restrict] = ACTIONS(5586),
    [anon_sym___restrict__] = ACTIONS(5586),
    [anon_sym__Atomic] = ACTIONS(5586),
    [anon_sym__Noreturn] = ACTIONS(5586),
    [anon_sym_noreturn] = ACTIONS(5586),
    [anon_sym_mutable] = ACTIONS(5586),
    [anon_sym_constinit] = ACTIONS(5586),
    [anon_sym_consteval] = ACTIONS(5586),
    [anon_sym_PROGMEM] = ACTIONS(5586),
    [aux_sym_primitive_type_token1] = ACTIONS(5586),
    [anon_sym_byte] = ACTIONS(5586),
    [anon_sym_word] = ACTIONS(5586),
    [anon_sym_enum] = ACTIONS(5586),
    [anon_sym_class] = ACTIONS(5586),
    [anon_sym_struct] = ACTIONS(5586),
    [anon_sym_union] = ACTIONS(5586),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5586),
    [anon_sym_decltype] = ACTIONS(5586),
    [anon_sym_virtual] = ACTIONS(5586),
    [anon_sym_alignas] = ACTIONS(5586),
    [anon_sym_explicit] = ACTIONS(5586),
    [anon_sym_typename] = ACTIONS(5586),
    [anon_sym_template] = ACTIONS(5586),
    [anon_sym_operator] = ACTIONS(5586),
    [anon_sym_friend] = ACTIONS(5586),
    [anon_sym_public] = ACTIONS(5586),
    [anon_sym_private] = ACTIONS(5586),
    [anon_sym_protected] = ACTIONS(5586),
    [anon_sym_using] = ACTIONS(5586),
    [anon_sym_static_assert] = ACTIONS(5586),
  },
  [2206] = {
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5565),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5204),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2207] = {
    [sym_identifier] = ACTIONS(5590),
    [aux_sym_preproc_def_token1] = ACTIONS(5590),
    [aux_sym_preproc_if_token1] = ACTIONS(5590),
    [aux_sym_preproc_if_token2] = ACTIONS(5590),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5590),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5590),
    [aux_sym_preproc_else_token1] = ACTIONS(5590),
    [aux_sym_preproc_elif_token1] = ACTIONS(5590),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5590),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5590),
    [sym_preproc_directive] = ACTIONS(5590),
    [anon_sym_LPAREN2] = ACTIONS(5592),
    [anon_sym_TILDE] = ACTIONS(5592),
    [anon_sym_STAR] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym___extension__] = ACTIONS(5590),
    [anon_sym_typedef] = ACTIONS(5590),
    [anon_sym_extern] = ACTIONS(5590),
    [anon_sym___attribute__] = ACTIONS(5590),
    [anon_sym_COLON_COLON] = ACTIONS(5592),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5592),
    [anon_sym___declspec] = ACTIONS(5590),
    [anon_sym___based] = ACTIONS(5590),
    [anon_sym_signed] = ACTIONS(5590),
    [anon_sym_unsigned] = ACTIONS(5590),
    [anon_sym_long] = ACTIONS(5590),
    [anon_sym_short] = ACTIONS(5590),
    [anon_sym_LBRACK] = ACTIONS(5590),
    [anon_sym_static] = ACTIONS(5590),
    [anon_sym_register] = ACTIONS(5590),
    [anon_sym_inline] = ACTIONS(5590),
    [anon_sym___inline] = ACTIONS(5590),
    [anon_sym___inline__] = ACTIONS(5590),
    [anon_sym___forceinline] = ACTIONS(5590),
    [anon_sym_thread_local] = ACTIONS(5590),
    [anon_sym___thread] = ACTIONS(5590),
    [anon_sym_const] = ACTIONS(5590),
    [anon_sym_constexpr] = ACTIONS(5590),
    [anon_sym_volatile] = ACTIONS(5590),
    [anon_sym_restrict] = ACTIONS(5590),
    [anon_sym___restrict__] = ACTIONS(5590),
    [anon_sym__Atomic] = ACTIONS(5590),
    [anon_sym__Noreturn] = ACTIONS(5590),
    [anon_sym_noreturn] = ACTIONS(5590),
    [anon_sym_mutable] = ACTIONS(5590),
    [anon_sym_constinit] = ACTIONS(5590),
    [anon_sym_consteval] = ACTIONS(5590),
    [anon_sym_PROGMEM] = ACTIONS(5590),
    [aux_sym_primitive_type_token1] = ACTIONS(5590),
    [anon_sym_byte] = ACTIONS(5590),
    [anon_sym_word] = ACTIONS(5590),
    [anon_sym_enum] = ACTIONS(5590),
    [anon_sym_class] = ACTIONS(5590),
    [anon_sym_struct] = ACTIONS(5590),
    [anon_sym_union] = ACTIONS(5590),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5590),
    [anon_sym_decltype] = ACTIONS(5590),
    [anon_sym_virtual] = ACTIONS(5590),
    [anon_sym_alignas] = ACTIONS(5590),
    [anon_sym_explicit] = ACTIONS(5590),
    [anon_sym_typename] = ACTIONS(5590),
    [anon_sym_template] = ACTIONS(5590),
    [anon_sym_operator] = ACTIONS(5590),
    [anon_sym_friend] = ACTIONS(5590),
    [anon_sym_public] = ACTIONS(5590),
    [anon_sym_private] = ACTIONS(5590),
    [anon_sym_protected] = ACTIONS(5590),
    [anon_sym_using] = ACTIONS(5590),
    [anon_sym_static_assert] = ACTIONS(5590),
  },
  [2208] = {
    [sym_identifier] = ACTIONS(3124),
    [aux_sym_preproc_def_token1] = ACTIONS(3124),
    [aux_sym_preproc_if_token1] = ACTIONS(3124),
    [aux_sym_preproc_if_token2] = ACTIONS(3124),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3124),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3124),
    [aux_sym_preproc_else_token1] = ACTIONS(3124),
    [aux_sym_preproc_elif_token1] = ACTIONS(3124),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3124),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3124),
    [sym_preproc_directive] = ACTIONS(3124),
    [anon_sym_LPAREN2] = ACTIONS(3126),
    [anon_sym_TILDE] = ACTIONS(3126),
    [anon_sym_STAR] = ACTIONS(3126),
    [anon_sym_AMP_AMP] = ACTIONS(3126),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3124),
    [anon_sym_typedef] = ACTIONS(3124),
    [anon_sym_extern] = ACTIONS(3124),
    [anon_sym___attribute__] = ACTIONS(3124),
    [anon_sym_COLON_COLON] = ACTIONS(3126),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3126),
    [anon_sym___declspec] = ACTIONS(3124),
    [anon_sym___based] = ACTIONS(3124),
    [anon_sym_signed] = ACTIONS(3124),
    [anon_sym_unsigned] = ACTIONS(3124),
    [anon_sym_long] = ACTIONS(3124),
    [anon_sym_short] = ACTIONS(3124),
    [anon_sym_LBRACK] = ACTIONS(3124),
    [anon_sym_static] = ACTIONS(3124),
    [anon_sym_register] = ACTIONS(3124),
    [anon_sym_inline] = ACTIONS(3124),
    [anon_sym___inline] = ACTIONS(3124),
    [anon_sym___inline__] = ACTIONS(3124),
    [anon_sym___forceinline] = ACTIONS(3124),
    [anon_sym_thread_local] = ACTIONS(3124),
    [anon_sym___thread] = ACTIONS(3124),
    [anon_sym_const] = ACTIONS(3124),
    [anon_sym_constexpr] = ACTIONS(3124),
    [anon_sym_volatile] = ACTIONS(3124),
    [anon_sym_restrict] = ACTIONS(3124),
    [anon_sym___restrict__] = ACTIONS(3124),
    [anon_sym__Atomic] = ACTIONS(3124),
    [anon_sym__Noreturn] = ACTIONS(3124),
    [anon_sym_noreturn] = ACTIONS(3124),
    [anon_sym_mutable] = ACTIONS(3124),
    [anon_sym_constinit] = ACTIONS(3124),
    [anon_sym_consteval] = ACTIONS(3124),
    [anon_sym_PROGMEM] = ACTIONS(3124),
    [aux_sym_primitive_type_token1] = ACTIONS(3124),
    [anon_sym_byte] = ACTIONS(3124),
    [anon_sym_word] = ACTIONS(3124),
    [anon_sym_enum] = ACTIONS(3124),
    [anon_sym_class] = ACTIONS(3124),
    [anon_sym_struct] = ACTIONS(3124),
    [anon_sym_union] = ACTIONS(3124),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3124),
    [anon_sym_decltype] = ACTIONS(3124),
    [anon_sym_virtual] = ACTIONS(3124),
    [anon_sym_alignas] = ACTIONS(3124),
    [anon_sym_explicit] = ACTIONS(3124),
    [anon_sym_typename] = ACTIONS(3124),
    [anon_sym_template] = ACTIONS(3124),
    [anon_sym_operator] = ACTIONS(3124),
    [anon_sym_friend] = ACTIONS(3124),
    [anon_sym_public] = ACTIONS(3124),
    [anon_sym_private] = ACTIONS(3124),
    [anon_sym_protected] = ACTIONS(3124),
    [anon_sym_using] = ACTIONS(3124),
    [anon_sym_static_assert] = ACTIONS(3124),
  },
  [2209] = {
    [sym_identifier] = ACTIONS(5594),
    [aux_sym_preproc_def_token1] = ACTIONS(5594),
    [aux_sym_preproc_if_token1] = ACTIONS(5594),
    [aux_sym_preproc_if_token2] = ACTIONS(5594),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5594),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5594),
    [aux_sym_preproc_else_token1] = ACTIONS(5594),
    [aux_sym_preproc_elif_token1] = ACTIONS(5594),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5594),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5594),
    [sym_preproc_directive] = ACTIONS(5594),
    [anon_sym_LPAREN2] = ACTIONS(5596),
    [anon_sym_TILDE] = ACTIONS(5596),
    [anon_sym_STAR] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5594),
    [anon_sym___extension__] = ACTIONS(5594),
    [anon_sym_typedef] = ACTIONS(5594),
    [anon_sym_extern] = ACTIONS(5594),
    [anon_sym___attribute__] = ACTIONS(5594),
    [anon_sym_COLON_COLON] = ACTIONS(5596),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5596),
    [anon_sym___declspec] = ACTIONS(5594),
    [anon_sym___based] = ACTIONS(5594),
    [anon_sym_signed] = ACTIONS(5594),
    [anon_sym_unsigned] = ACTIONS(5594),
    [anon_sym_long] = ACTIONS(5594),
    [anon_sym_short] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_static] = ACTIONS(5594),
    [anon_sym_register] = ACTIONS(5594),
    [anon_sym_inline] = ACTIONS(5594),
    [anon_sym___inline] = ACTIONS(5594),
    [anon_sym___inline__] = ACTIONS(5594),
    [anon_sym___forceinline] = ACTIONS(5594),
    [anon_sym_thread_local] = ACTIONS(5594),
    [anon_sym___thread] = ACTIONS(5594),
    [anon_sym_const] = ACTIONS(5594),
    [anon_sym_constexpr] = ACTIONS(5594),
    [anon_sym_volatile] = ACTIONS(5594),
    [anon_sym_restrict] = ACTIONS(5594),
    [anon_sym___restrict__] = ACTIONS(5594),
    [anon_sym__Atomic] = ACTIONS(5594),
    [anon_sym__Noreturn] = ACTIONS(5594),
    [anon_sym_noreturn] = ACTIONS(5594),
    [anon_sym_mutable] = ACTIONS(5594),
    [anon_sym_constinit] = ACTIONS(5594),
    [anon_sym_consteval] = ACTIONS(5594),
    [anon_sym_PROGMEM] = ACTIONS(5594),
    [aux_sym_primitive_type_token1] = ACTIONS(5594),
    [anon_sym_byte] = ACTIONS(5594),
    [anon_sym_word] = ACTIONS(5594),
    [anon_sym_enum] = ACTIONS(5594),
    [anon_sym_class] = ACTIONS(5594),
    [anon_sym_struct] = ACTIONS(5594),
    [anon_sym_union] = ACTIONS(5594),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5594),
    [anon_sym_decltype] = ACTIONS(5594),
    [anon_sym_virtual] = ACTIONS(5594),
    [anon_sym_alignas] = ACTIONS(5594),
    [anon_sym_explicit] = ACTIONS(5594),
    [anon_sym_typename] = ACTIONS(5594),
    [anon_sym_template] = ACTIONS(5594),
    [anon_sym_operator] = ACTIONS(5594),
    [anon_sym_friend] = ACTIONS(5594),
    [anon_sym_public] = ACTIONS(5594),
    [anon_sym_private] = ACTIONS(5594),
    [anon_sym_protected] = ACTIONS(5594),
    [anon_sym_using] = ACTIONS(5594),
    [anon_sym_static_assert] = ACTIONS(5594),
  },
  [2210] = {
    [sym__declaration_modifiers] = STATE(4180),
    [sym_attribute_specifier] = STATE(4180),
    [sym_attribute_declaration] = STATE(4180),
    [sym_ms_declspec_modifier] = STATE(4180),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7081),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(4180),
    [sym_type_qualifier] = STATE(4180),
    [sym_decltype] = STATE(9504),
    [sym_virtual] = STATE(4180),
    [sym_alignas_specifier] = STATE(4180),
    [sym_explicit_function_specifier] = STATE(4180),
    [sym_operator_cast] = STATE(7513),
    [sym__constructor_specifiers] = STATE(4180),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(9504),
    [sym_template_function] = STATE(7008),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6421),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_operator_cast_identifier] = STATE(7513),
    [sym_operator_name] = STATE(7008),
    [aux_sym_operator_cast_definition_repeat1] = STATE(4180),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(5449),
    [anon_sym_extern] = ACTIONS(5451),
    [anon_sym___attribute__] = ACTIONS(5453),
    [anon_sym_COLON_COLON] = ACTIONS(5455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5457),
    [anon_sym___declspec] = ACTIONS(5459),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(5451),
    [anon_sym_register] = ACTIONS(5451),
    [anon_sym_inline] = ACTIONS(5451),
    [anon_sym___inline] = ACTIONS(5451),
    [anon_sym___inline__] = ACTIONS(5451),
    [anon_sym___forceinline] = ACTIONS(5451),
    [anon_sym_thread_local] = ACTIONS(5451),
    [anon_sym___thread] = ACTIONS(5451),
    [anon_sym_const] = ACTIONS(5449),
    [anon_sym_constexpr] = ACTIONS(5449),
    [anon_sym_volatile] = ACTIONS(5449),
    [anon_sym_restrict] = ACTIONS(5449),
    [anon_sym___restrict__] = ACTIONS(5449),
    [anon_sym__Atomic] = ACTIONS(5449),
    [anon_sym__Noreturn] = ACTIONS(5449),
    [anon_sym_noreturn] = ACTIONS(5449),
    [anon_sym_mutable] = ACTIONS(5449),
    [anon_sym_constinit] = ACTIONS(5449),
    [anon_sym_consteval] = ACTIONS(5449),
    [anon_sym_PROGMEM] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_virtual] = ACTIONS(5461),
    [anon_sym_alignas] = ACTIONS(5463),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(133),
  },
  [2211] = {
    [sym_identifier] = ACTIONS(3423),
    [aux_sym_preproc_def_token1] = ACTIONS(3423),
    [aux_sym_preproc_if_token1] = ACTIONS(3423),
    [aux_sym_preproc_if_token2] = ACTIONS(3423),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3423),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3423),
    [aux_sym_preproc_else_token1] = ACTIONS(3423),
    [aux_sym_preproc_elif_token1] = ACTIONS(3423),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3423),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3423),
    [sym_preproc_directive] = ACTIONS(3423),
    [anon_sym_LPAREN2] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [anon_sym_STAR] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3423),
    [anon_sym___extension__] = ACTIONS(3423),
    [anon_sym_typedef] = ACTIONS(3423),
    [anon_sym_extern] = ACTIONS(3423),
    [anon_sym___attribute__] = ACTIONS(3423),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3425),
    [anon_sym___declspec] = ACTIONS(3423),
    [anon_sym___based] = ACTIONS(3423),
    [anon_sym_signed] = ACTIONS(3423),
    [anon_sym_unsigned] = ACTIONS(3423),
    [anon_sym_long] = ACTIONS(3423),
    [anon_sym_short] = ACTIONS(3423),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_static] = ACTIONS(3423),
    [anon_sym_register] = ACTIONS(3423),
    [anon_sym_inline] = ACTIONS(3423),
    [anon_sym___inline] = ACTIONS(3423),
    [anon_sym___inline__] = ACTIONS(3423),
    [anon_sym___forceinline] = ACTIONS(3423),
    [anon_sym_thread_local] = ACTIONS(3423),
    [anon_sym___thread] = ACTIONS(3423),
    [anon_sym_const] = ACTIONS(3423),
    [anon_sym_constexpr] = ACTIONS(3423),
    [anon_sym_volatile] = ACTIONS(3423),
    [anon_sym_restrict] = ACTIONS(3423),
    [anon_sym___restrict__] = ACTIONS(3423),
    [anon_sym__Atomic] = ACTIONS(3423),
    [anon_sym__Noreturn] = ACTIONS(3423),
    [anon_sym_noreturn] = ACTIONS(3423),
    [anon_sym_mutable] = ACTIONS(3423),
    [anon_sym_constinit] = ACTIONS(3423),
    [anon_sym_consteval] = ACTIONS(3423),
    [anon_sym_PROGMEM] = ACTIONS(3423),
    [aux_sym_primitive_type_token1] = ACTIONS(3423),
    [anon_sym_byte] = ACTIONS(3423),
    [anon_sym_word] = ACTIONS(3423),
    [anon_sym_enum] = ACTIONS(3423),
    [anon_sym_class] = ACTIONS(3423),
    [anon_sym_struct] = ACTIONS(3423),
    [anon_sym_union] = ACTIONS(3423),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3423),
    [anon_sym_decltype] = ACTIONS(3423),
    [anon_sym_virtual] = ACTIONS(3423),
    [anon_sym_alignas] = ACTIONS(3423),
    [anon_sym_explicit] = ACTIONS(3423),
    [anon_sym_typename] = ACTIONS(3423),
    [anon_sym_template] = ACTIONS(3423),
    [anon_sym_operator] = ACTIONS(3423),
    [anon_sym_friend] = ACTIONS(3423),
    [anon_sym_public] = ACTIONS(3423),
    [anon_sym_private] = ACTIONS(3423),
    [anon_sym_protected] = ACTIONS(3423),
    [anon_sym_using] = ACTIONS(3423),
    [anon_sym_static_assert] = ACTIONS(3423),
  },
  [2212] = {
    [sym_identifier] = ACTIONS(3403),
    [aux_sym_preproc_def_token1] = ACTIONS(3403),
    [aux_sym_preproc_if_token1] = ACTIONS(3403),
    [aux_sym_preproc_if_token2] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3403),
    [aux_sym_preproc_else_token1] = ACTIONS(3403),
    [aux_sym_preproc_elif_token1] = ACTIONS(3403),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3403),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3403),
    [sym_preproc_directive] = ACTIONS(3403),
    [anon_sym_LPAREN2] = ACTIONS(3405),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_STAR] = ACTIONS(3405),
    [anon_sym_AMP_AMP] = ACTIONS(3405),
    [anon_sym_AMP] = ACTIONS(3403),
    [anon_sym___extension__] = ACTIONS(3403),
    [anon_sym_typedef] = ACTIONS(3403),
    [anon_sym_extern] = ACTIONS(3403),
    [anon_sym___attribute__] = ACTIONS(3403),
    [anon_sym_COLON_COLON] = ACTIONS(3405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3405),
    [anon_sym___declspec] = ACTIONS(3403),
    [anon_sym___based] = ACTIONS(3403),
    [anon_sym_signed] = ACTIONS(3403),
    [anon_sym_unsigned] = ACTIONS(3403),
    [anon_sym_long] = ACTIONS(3403),
    [anon_sym_short] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3403),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_register] = ACTIONS(3403),
    [anon_sym_inline] = ACTIONS(3403),
    [anon_sym___inline] = ACTIONS(3403),
    [anon_sym___inline__] = ACTIONS(3403),
    [anon_sym___forceinline] = ACTIONS(3403),
    [anon_sym_thread_local] = ACTIONS(3403),
    [anon_sym___thread] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_constexpr] = ACTIONS(3403),
    [anon_sym_volatile] = ACTIONS(3403),
    [anon_sym_restrict] = ACTIONS(3403),
    [anon_sym___restrict__] = ACTIONS(3403),
    [anon_sym__Atomic] = ACTIONS(3403),
    [anon_sym__Noreturn] = ACTIONS(3403),
    [anon_sym_noreturn] = ACTIONS(3403),
    [anon_sym_mutable] = ACTIONS(3403),
    [anon_sym_constinit] = ACTIONS(3403),
    [anon_sym_consteval] = ACTIONS(3403),
    [anon_sym_PROGMEM] = ACTIONS(3403),
    [aux_sym_primitive_type_token1] = ACTIONS(3403),
    [anon_sym_byte] = ACTIONS(3403),
    [anon_sym_word] = ACTIONS(3403),
    [anon_sym_enum] = ACTIONS(3403),
    [anon_sym_class] = ACTIONS(3403),
    [anon_sym_struct] = ACTIONS(3403),
    [anon_sym_union] = ACTIONS(3403),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3403),
    [anon_sym_decltype] = ACTIONS(3403),
    [anon_sym_virtual] = ACTIONS(3403),
    [anon_sym_alignas] = ACTIONS(3403),
    [anon_sym_explicit] = ACTIONS(3403),
    [anon_sym_typename] = ACTIONS(3403),
    [anon_sym_template] = ACTIONS(3403),
    [anon_sym_operator] = ACTIONS(3403),
    [anon_sym_friend] = ACTIONS(3403),
    [anon_sym_public] = ACTIONS(3403),
    [anon_sym_private] = ACTIONS(3403),
    [anon_sym_protected] = ACTIONS(3403),
    [anon_sym_using] = ACTIONS(3403),
    [anon_sym_static_assert] = ACTIONS(3403),
  },
  [2213] = {
    [sym_identifier] = ACTIONS(5113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5115),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_RPAREN] = ACTIONS(5115),
    [anon_sym_LPAREN2] = ACTIONS(5115),
    [anon_sym_DASH] = ACTIONS(5113),
    [anon_sym_PLUS] = ACTIONS(5113),
    [anon_sym_STAR] = ACTIONS(5115),
    [anon_sym_SLASH] = ACTIONS(5113),
    [anon_sym_PERCENT] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(5115),
    [anon_sym_AMP_AMP] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(5113),
    [anon_sym_CARET] = ACTIONS(5115),
    [anon_sym_AMP] = ACTIONS(5113),
    [anon_sym_EQ_EQ] = ACTIONS(5115),
    [anon_sym_BANG_EQ] = ACTIONS(5115),
    [anon_sym_GT] = ACTIONS(5113),
    [anon_sym_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_EQ] = ACTIONS(5113),
    [anon_sym_LT] = ACTIONS(5113),
    [anon_sym_LT_LT] = ACTIONS(5115),
    [anon_sym_GT_GT] = ACTIONS(5115),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym___extension__] = ACTIONS(5113),
    [anon_sym___attribute__] = ACTIONS(5113),
    [anon_sym_COLON_COLON] = ACTIONS(5115),
    [anon_sym___based] = ACTIONS(5113),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_RBRACE] = ACTIONS(5115),
    [anon_sym_signed] = ACTIONS(5113),
    [anon_sym_unsigned] = ACTIONS(5113),
    [anon_sym_long] = ACTIONS(5113),
    [anon_sym_short] = ACTIONS(5113),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_RBRACK] = ACTIONS(5115),
    [anon_sym_const] = ACTIONS(5113),
    [anon_sym_constexpr] = ACTIONS(5113),
    [anon_sym_volatile] = ACTIONS(5113),
    [anon_sym_restrict] = ACTIONS(5113),
    [anon_sym___restrict__] = ACTIONS(5113),
    [anon_sym__Atomic] = ACTIONS(5113),
    [anon_sym__Noreturn] = ACTIONS(5113),
    [anon_sym_noreturn] = ACTIONS(5113),
    [anon_sym_mutable] = ACTIONS(5113),
    [anon_sym_constinit] = ACTIONS(5113),
    [anon_sym_consteval] = ACTIONS(5113),
    [anon_sym_PROGMEM] = ACTIONS(5113),
    [aux_sym_primitive_type_token1] = ACTIONS(5113),
    [anon_sym_byte] = ACTIONS(5113),
    [anon_sym_word] = ACTIONS(5113),
    [anon_sym_COLON] = ACTIONS(5113),
    [anon_sym_QMARK] = ACTIONS(5115),
    [anon_sym_LT_EQ_GT] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5113),
    [anon_sym_and] = ACTIONS(5113),
    [anon_sym_bitor] = ACTIONS(5113),
    [anon_sym_xor] = ACTIONS(5113),
    [anon_sym_bitand] = ACTIONS(5113),
    [anon_sym_not_eq] = ACTIONS(5113),
    [anon_sym_DASH_DASH] = ACTIONS(5115),
    [anon_sym_PLUS_PLUS] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(5113),
    [anon_sym_DOT_STAR] = ACTIONS(5115),
    [anon_sym_DASH_GT] = ACTIONS(5115),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5113),
    [anon_sym_decltype] = ACTIONS(5113),
    [anon_sym_final] = ACTIONS(5113),
    [anon_sym_override] = ACTIONS(5113),
    [anon_sym_requires] = ACTIONS(5113),
  },
  [2214] = {
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(6096),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5204),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2215] = {
    [sym_template_argument_list] = STATE(2153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5131),
    [anon_sym_COMMA] = ACTIONS(5131),
    [anon_sym_RPAREN] = ACTIONS(5133),
    [anon_sym_LPAREN2] = ACTIONS(5133),
    [anon_sym_DASH] = ACTIONS(5138),
    [anon_sym_PLUS] = ACTIONS(5138),
    [anon_sym_STAR] = ACTIONS(5140),
    [anon_sym_SLASH] = ACTIONS(5138),
    [anon_sym_PERCENT] = ACTIONS(5138),
    [anon_sym_PIPE_PIPE] = ACTIONS(5131),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5138),
    [anon_sym_CARET] = ACTIONS(5138),
    [anon_sym_AMP] = ACTIONS(5140),
    [anon_sym_EQ_EQ] = ACTIONS(5131),
    [anon_sym_BANG_EQ] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5138),
    [anon_sym_GT_EQ] = ACTIONS(5131),
    [anon_sym_LT_EQ] = ACTIONS(5138),
    [anon_sym_LT] = ACTIONS(5174),
    [anon_sym_LT_LT] = ACTIONS(5138),
    [anon_sym_GT_GT] = ACTIONS(5138),
    [anon_sym___extension__] = ACTIONS(5136),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5131),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_LBRACK] = ACTIONS(5140),
    [anon_sym_EQ] = ACTIONS(5138),
    [anon_sym_const] = ACTIONS(5129),
    [anon_sym_constexpr] = ACTIONS(5136),
    [anon_sym_volatile] = ACTIONS(5136),
    [anon_sym_restrict] = ACTIONS(5136),
    [anon_sym___restrict__] = ACTIONS(5136),
    [anon_sym__Atomic] = ACTIONS(5136),
    [anon_sym__Noreturn] = ACTIONS(5136),
    [anon_sym_noreturn] = ACTIONS(5136),
    [anon_sym_mutable] = ACTIONS(5136),
    [anon_sym_constinit] = ACTIONS(5136),
    [anon_sym_consteval] = ACTIONS(5136),
    [anon_sym_PROGMEM] = ACTIONS(5136),
    [anon_sym_QMARK] = ACTIONS(5131),
    [anon_sym_STAR_EQ] = ACTIONS(5131),
    [anon_sym_SLASH_EQ] = ACTIONS(5131),
    [anon_sym_PERCENT_EQ] = ACTIONS(5131),
    [anon_sym_PLUS_EQ] = ACTIONS(5131),
    [anon_sym_DASH_EQ] = ACTIONS(5131),
    [anon_sym_LT_LT_EQ] = ACTIONS(5131),
    [anon_sym_GT_GT_EQ] = ACTIONS(5131),
    [anon_sym_AMP_EQ] = ACTIONS(5131),
    [anon_sym_CARET_EQ] = ACTIONS(5131),
    [anon_sym_PIPE_EQ] = ACTIONS(5131),
    [anon_sym_and_eq] = ACTIONS(5131),
    [anon_sym_or_eq] = ACTIONS(5131),
    [anon_sym_xor_eq] = ACTIONS(5131),
    [anon_sym_LT_EQ_GT] = ACTIONS(5131),
    [anon_sym_or] = ACTIONS(5138),
    [anon_sym_and] = ACTIONS(5138),
    [anon_sym_bitor] = ACTIONS(5131),
    [anon_sym_xor] = ACTIONS(5138),
    [anon_sym_bitand] = ACTIONS(5131),
    [anon_sym_not_eq] = ACTIONS(5131),
    [anon_sym_DASH_DASH] = ACTIONS(5131),
    [anon_sym_PLUS_PLUS] = ACTIONS(5131),
    [anon_sym_DOT] = ACTIONS(5138),
    [anon_sym_DOT_STAR] = ACTIONS(5131),
    [anon_sym_DASH_GT] = ACTIONS(5138),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5136),
    [anon_sym_decltype] = ACTIONS(5136),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5131),
  },
  [2216] = {
    [sym_identifier] = ACTIONS(5598),
    [aux_sym_preproc_def_token1] = ACTIONS(5598),
    [aux_sym_preproc_if_token1] = ACTIONS(5598),
    [aux_sym_preproc_if_token2] = ACTIONS(5598),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5598),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5598),
    [aux_sym_preproc_else_token1] = ACTIONS(5598),
    [aux_sym_preproc_elif_token1] = ACTIONS(5598),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5598),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5598),
    [sym_preproc_directive] = ACTIONS(5598),
    [anon_sym_LPAREN2] = ACTIONS(5600),
    [anon_sym_TILDE] = ACTIONS(5600),
    [anon_sym_STAR] = ACTIONS(5600),
    [anon_sym_AMP_AMP] = ACTIONS(5600),
    [anon_sym_AMP] = ACTIONS(5598),
    [anon_sym___extension__] = ACTIONS(5598),
    [anon_sym_typedef] = ACTIONS(5598),
    [anon_sym_extern] = ACTIONS(5598),
    [anon_sym___attribute__] = ACTIONS(5598),
    [anon_sym_COLON_COLON] = ACTIONS(5600),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5600),
    [anon_sym___declspec] = ACTIONS(5598),
    [anon_sym___based] = ACTIONS(5598),
    [anon_sym_signed] = ACTIONS(5598),
    [anon_sym_unsigned] = ACTIONS(5598),
    [anon_sym_long] = ACTIONS(5598),
    [anon_sym_short] = ACTIONS(5598),
    [anon_sym_LBRACK] = ACTIONS(5598),
    [anon_sym_static] = ACTIONS(5598),
    [anon_sym_register] = ACTIONS(5598),
    [anon_sym_inline] = ACTIONS(5598),
    [anon_sym___inline] = ACTIONS(5598),
    [anon_sym___inline__] = ACTIONS(5598),
    [anon_sym___forceinline] = ACTIONS(5598),
    [anon_sym_thread_local] = ACTIONS(5598),
    [anon_sym___thread] = ACTIONS(5598),
    [anon_sym_const] = ACTIONS(5598),
    [anon_sym_constexpr] = ACTIONS(5598),
    [anon_sym_volatile] = ACTIONS(5598),
    [anon_sym_restrict] = ACTIONS(5598),
    [anon_sym___restrict__] = ACTIONS(5598),
    [anon_sym__Atomic] = ACTIONS(5598),
    [anon_sym__Noreturn] = ACTIONS(5598),
    [anon_sym_noreturn] = ACTIONS(5598),
    [anon_sym_mutable] = ACTIONS(5598),
    [anon_sym_constinit] = ACTIONS(5598),
    [anon_sym_consteval] = ACTIONS(5598),
    [anon_sym_PROGMEM] = ACTIONS(5598),
    [aux_sym_primitive_type_token1] = ACTIONS(5598),
    [anon_sym_byte] = ACTIONS(5598),
    [anon_sym_word] = ACTIONS(5598),
    [anon_sym_enum] = ACTIONS(5598),
    [anon_sym_class] = ACTIONS(5598),
    [anon_sym_struct] = ACTIONS(5598),
    [anon_sym_union] = ACTIONS(5598),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5598),
    [anon_sym_decltype] = ACTIONS(5598),
    [anon_sym_virtual] = ACTIONS(5598),
    [anon_sym_alignas] = ACTIONS(5598),
    [anon_sym_explicit] = ACTIONS(5598),
    [anon_sym_typename] = ACTIONS(5598),
    [anon_sym_template] = ACTIONS(5598),
    [anon_sym_operator] = ACTIONS(5598),
    [anon_sym_friend] = ACTIONS(5598),
    [anon_sym_public] = ACTIONS(5598),
    [anon_sym_private] = ACTIONS(5598),
    [anon_sym_protected] = ACTIONS(5598),
    [anon_sym_using] = ACTIONS(5598),
    [anon_sym_static_assert] = ACTIONS(5598),
  },
  [2217] = {
    [sym_identifier] = ACTIONS(5602),
    [aux_sym_preproc_def_token1] = ACTIONS(5602),
    [aux_sym_preproc_if_token1] = ACTIONS(5602),
    [aux_sym_preproc_if_token2] = ACTIONS(5602),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5602),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5602),
    [aux_sym_preproc_else_token1] = ACTIONS(5602),
    [aux_sym_preproc_elif_token1] = ACTIONS(5602),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5602),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5602),
    [sym_preproc_directive] = ACTIONS(5602),
    [anon_sym_LPAREN2] = ACTIONS(5604),
    [anon_sym_TILDE] = ACTIONS(5604),
    [anon_sym_STAR] = ACTIONS(5604),
    [anon_sym_AMP_AMP] = ACTIONS(5604),
    [anon_sym_AMP] = ACTIONS(5602),
    [anon_sym___extension__] = ACTIONS(5602),
    [anon_sym_typedef] = ACTIONS(5602),
    [anon_sym_extern] = ACTIONS(5602),
    [anon_sym___attribute__] = ACTIONS(5602),
    [anon_sym_COLON_COLON] = ACTIONS(5604),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5604),
    [anon_sym___declspec] = ACTIONS(5602),
    [anon_sym___based] = ACTIONS(5602),
    [anon_sym_signed] = ACTIONS(5602),
    [anon_sym_unsigned] = ACTIONS(5602),
    [anon_sym_long] = ACTIONS(5602),
    [anon_sym_short] = ACTIONS(5602),
    [anon_sym_LBRACK] = ACTIONS(5602),
    [anon_sym_static] = ACTIONS(5602),
    [anon_sym_register] = ACTIONS(5602),
    [anon_sym_inline] = ACTIONS(5602),
    [anon_sym___inline] = ACTIONS(5602),
    [anon_sym___inline__] = ACTIONS(5602),
    [anon_sym___forceinline] = ACTIONS(5602),
    [anon_sym_thread_local] = ACTIONS(5602),
    [anon_sym___thread] = ACTIONS(5602),
    [anon_sym_const] = ACTIONS(5602),
    [anon_sym_constexpr] = ACTIONS(5602),
    [anon_sym_volatile] = ACTIONS(5602),
    [anon_sym_restrict] = ACTIONS(5602),
    [anon_sym___restrict__] = ACTIONS(5602),
    [anon_sym__Atomic] = ACTIONS(5602),
    [anon_sym__Noreturn] = ACTIONS(5602),
    [anon_sym_noreturn] = ACTIONS(5602),
    [anon_sym_mutable] = ACTIONS(5602),
    [anon_sym_constinit] = ACTIONS(5602),
    [anon_sym_consteval] = ACTIONS(5602),
    [anon_sym_PROGMEM] = ACTIONS(5602),
    [aux_sym_primitive_type_token1] = ACTIONS(5602),
    [anon_sym_byte] = ACTIONS(5602),
    [anon_sym_word] = ACTIONS(5602),
    [anon_sym_enum] = ACTIONS(5602),
    [anon_sym_class] = ACTIONS(5602),
    [anon_sym_struct] = ACTIONS(5602),
    [anon_sym_union] = ACTIONS(5602),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5602),
    [anon_sym_decltype] = ACTIONS(5602),
    [anon_sym_virtual] = ACTIONS(5602),
    [anon_sym_alignas] = ACTIONS(5602),
    [anon_sym_explicit] = ACTIONS(5602),
    [anon_sym_typename] = ACTIONS(5602),
    [anon_sym_template] = ACTIONS(5602),
    [anon_sym_operator] = ACTIONS(5602),
    [anon_sym_friend] = ACTIONS(5602),
    [anon_sym_public] = ACTIONS(5602),
    [anon_sym_private] = ACTIONS(5602),
    [anon_sym_protected] = ACTIONS(5602),
    [anon_sym_using] = ACTIONS(5602),
    [anon_sym_static_assert] = ACTIONS(5602),
  },
  [2218] = {
    [sym_identifier] = ACTIONS(3346),
    [aux_sym_preproc_def_token1] = ACTIONS(3346),
    [aux_sym_preproc_if_token1] = ACTIONS(3346),
    [aux_sym_preproc_if_token2] = ACTIONS(3346),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3346),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3346),
    [aux_sym_preproc_else_token1] = ACTIONS(3346),
    [aux_sym_preproc_elif_token1] = ACTIONS(3346),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3346),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3346),
    [sym_preproc_directive] = ACTIONS(3346),
    [anon_sym_LPAREN2] = ACTIONS(3348),
    [anon_sym_TILDE] = ACTIONS(3348),
    [anon_sym_STAR] = ACTIONS(3348),
    [anon_sym_AMP_AMP] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym___extension__] = ACTIONS(3346),
    [anon_sym_typedef] = ACTIONS(3346),
    [anon_sym_extern] = ACTIONS(3346),
    [anon_sym___attribute__] = ACTIONS(3346),
    [anon_sym_COLON_COLON] = ACTIONS(3348),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3348),
    [anon_sym___declspec] = ACTIONS(3346),
    [anon_sym___based] = ACTIONS(3346),
    [anon_sym_signed] = ACTIONS(3346),
    [anon_sym_unsigned] = ACTIONS(3346),
    [anon_sym_long] = ACTIONS(3346),
    [anon_sym_short] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3346),
    [anon_sym_register] = ACTIONS(3346),
    [anon_sym_inline] = ACTIONS(3346),
    [anon_sym___inline] = ACTIONS(3346),
    [anon_sym___inline__] = ACTIONS(3346),
    [anon_sym___forceinline] = ACTIONS(3346),
    [anon_sym_thread_local] = ACTIONS(3346),
    [anon_sym___thread] = ACTIONS(3346),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_constexpr] = ACTIONS(3346),
    [anon_sym_volatile] = ACTIONS(3346),
    [anon_sym_restrict] = ACTIONS(3346),
    [anon_sym___restrict__] = ACTIONS(3346),
    [anon_sym__Atomic] = ACTIONS(3346),
    [anon_sym__Noreturn] = ACTIONS(3346),
    [anon_sym_noreturn] = ACTIONS(3346),
    [anon_sym_mutable] = ACTIONS(3346),
    [anon_sym_constinit] = ACTIONS(3346),
    [anon_sym_consteval] = ACTIONS(3346),
    [anon_sym_PROGMEM] = ACTIONS(3346),
    [aux_sym_primitive_type_token1] = ACTIONS(3346),
    [anon_sym_byte] = ACTIONS(3346),
    [anon_sym_word] = ACTIONS(3346),
    [anon_sym_enum] = ACTIONS(3346),
    [anon_sym_class] = ACTIONS(3346),
    [anon_sym_struct] = ACTIONS(3346),
    [anon_sym_union] = ACTIONS(3346),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3346),
    [anon_sym_decltype] = ACTIONS(3346),
    [anon_sym_virtual] = ACTIONS(3346),
    [anon_sym_alignas] = ACTIONS(3346),
    [anon_sym_explicit] = ACTIONS(3346),
    [anon_sym_typename] = ACTIONS(3346),
    [anon_sym_template] = ACTIONS(3346),
    [anon_sym_operator] = ACTIONS(3346),
    [anon_sym_friend] = ACTIONS(3346),
    [anon_sym_public] = ACTIONS(3346),
    [anon_sym_private] = ACTIONS(3346),
    [anon_sym_protected] = ACTIONS(3346),
    [anon_sym_using] = ACTIONS(3346),
    [anon_sym_static_assert] = ACTIONS(3346),
  },
  [2219] = {
    [sym_identifier] = ACTIONS(5606),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5608),
    [anon_sym_COMMA] = ACTIONS(5608),
    [anon_sym_RPAREN] = ACTIONS(5608),
    [anon_sym_LPAREN2] = ACTIONS(5608),
    [anon_sym_DASH] = ACTIONS(5606),
    [anon_sym_PLUS] = ACTIONS(5606),
    [anon_sym_STAR] = ACTIONS(5608),
    [anon_sym_SLASH] = ACTIONS(5606),
    [anon_sym_PERCENT] = ACTIONS(5608),
    [anon_sym_PIPE_PIPE] = ACTIONS(5608),
    [anon_sym_AMP_AMP] = ACTIONS(5608),
    [anon_sym_PIPE] = ACTIONS(5606),
    [anon_sym_CARET] = ACTIONS(5608),
    [anon_sym_AMP] = ACTIONS(5606),
    [anon_sym_EQ_EQ] = ACTIONS(5608),
    [anon_sym_BANG_EQ] = ACTIONS(5608),
    [anon_sym_GT] = ACTIONS(5606),
    [anon_sym_GT_EQ] = ACTIONS(5608),
    [anon_sym_LT_EQ] = ACTIONS(5606),
    [anon_sym_LT] = ACTIONS(5606),
    [anon_sym_LT_LT] = ACTIONS(5608),
    [anon_sym_GT_GT] = ACTIONS(5608),
    [anon_sym_SEMI] = ACTIONS(5608),
    [anon_sym___extension__] = ACTIONS(5606),
    [anon_sym___attribute__] = ACTIONS(5606),
    [anon_sym_COLON_COLON] = ACTIONS(5608),
    [anon_sym___based] = ACTIONS(5606),
    [anon_sym_LBRACE] = ACTIONS(5608),
    [anon_sym_RBRACE] = ACTIONS(5608),
    [anon_sym_signed] = ACTIONS(5606),
    [anon_sym_unsigned] = ACTIONS(5606),
    [anon_sym_long] = ACTIONS(5606),
    [anon_sym_short] = ACTIONS(5606),
    [anon_sym_LBRACK] = ACTIONS(5608),
    [anon_sym_RBRACK] = ACTIONS(5608),
    [anon_sym_const] = ACTIONS(5606),
    [anon_sym_constexpr] = ACTIONS(5606),
    [anon_sym_volatile] = ACTIONS(5606),
    [anon_sym_restrict] = ACTIONS(5606),
    [anon_sym___restrict__] = ACTIONS(5606),
    [anon_sym__Atomic] = ACTIONS(5606),
    [anon_sym__Noreturn] = ACTIONS(5606),
    [anon_sym_noreturn] = ACTIONS(5606),
    [anon_sym_mutable] = ACTIONS(5606),
    [anon_sym_constinit] = ACTIONS(5606),
    [anon_sym_consteval] = ACTIONS(5606),
    [anon_sym_PROGMEM] = ACTIONS(5606),
    [aux_sym_primitive_type_token1] = ACTIONS(5606),
    [anon_sym_byte] = ACTIONS(5606),
    [anon_sym_word] = ACTIONS(5606),
    [anon_sym_COLON] = ACTIONS(5606),
    [anon_sym_QMARK] = ACTIONS(5608),
    [anon_sym_LT_EQ_GT] = ACTIONS(5608),
    [anon_sym_or] = ACTIONS(5606),
    [anon_sym_and] = ACTIONS(5606),
    [anon_sym_bitor] = ACTIONS(5606),
    [anon_sym_xor] = ACTIONS(5606),
    [anon_sym_bitand] = ACTIONS(5606),
    [anon_sym_not_eq] = ACTIONS(5606),
    [anon_sym_DASH_DASH] = ACTIONS(5608),
    [anon_sym_PLUS_PLUS] = ACTIONS(5608),
    [anon_sym_DOT] = ACTIONS(5606),
    [anon_sym_DOT_STAR] = ACTIONS(5608),
    [anon_sym_DASH_GT] = ACTIONS(5608),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5606),
    [anon_sym_decltype] = ACTIONS(5606),
    [anon_sym_final] = ACTIONS(5606),
    [anon_sym_override] = ACTIONS(5606),
    [anon_sym_requires] = ACTIONS(5606),
  },
  [2220] = {
    [sym_identifier] = ACTIONS(5610),
    [aux_sym_preproc_def_token1] = ACTIONS(5610),
    [aux_sym_preproc_if_token1] = ACTIONS(5610),
    [aux_sym_preproc_if_token2] = ACTIONS(5610),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5610),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5610),
    [aux_sym_preproc_else_token1] = ACTIONS(5610),
    [aux_sym_preproc_elif_token1] = ACTIONS(5610),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5610),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5610),
    [sym_preproc_directive] = ACTIONS(5610),
    [anon_sym_LPAREN2] = ACTIONS(5612),
    [anon_sym_TILDE] = ACTIONS(5612),
    [anon_sym_STAR] = ACTIONS(5612),
    [anon_sym_AMP_AMP] = ACTIONS(5612),
    [anon_sym_AMP] = ACTIONS(5610),
    [anon_sym___extension__] = ACTIONS(5610),
    [anon_sym_typedef] = ACTIONS(5610),
    [anon_sym_extern] = ACTIONS(5610),
    [anon_sym___attribute__] = ACTIONS(5610),
    [anon_sym_COLON_COLON] = ACTIONS(5612),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5612),
    [anon_sym___declspec] = ACTIONS(5610),
    [anon_sym___based] = ACTIONS(5610),
    [anon_sym_signed] = ACTIONS(5610),
    [anon_sym_unsigned] = ACTIONS(5610),
    [anon_sym_long] = ACTIONS(5610),
    [anon_sym_short] = ACTIONS(5610),
    [anon_sym_LBRACK] = ACTIONS(5610),
    [anon_sym_static] = ACTIONS(5610),
    [anon_sym_register] = ACTIONS(5610),
    [anon_sym_inline] = ACTIONS(5610),
    [anon_sym___inline] = ACTIONS(5610),
    [anon_sym___inline__] = ACTIONS(5610),
    [anon_sym___forceinline] = ACTIONS(5610),
    [anon_sym_thread_local] = ACTIONS(5610),
    [anon_sym___thread] = ACTIONS(5610),
    [anon_sym_const] = ACTIONS(5610),
    [anon_sym_constexpr] = ACTIONS(5610),
    [anon_sym_volatile] = ACTIONS(5610),
    [anon_sym_restrict] = ACTIONS(5610),
    [anon_sym___restrict__] = ACTIONS(5610),
    [anon_sym__Atomic] = ACTIONS(5610),
    [anon_sym__Noreturn] = ACTIONS(5610),
    [anon_sym_noreturn] = ACTIONS(5610),
    [anon_sym_mutable] = ACTIONS(5610),
    [anon_sym_constinit] = ACTIONS(5610),
    [anon_sym_consteval] = ACTIONS(5610),
    [anon_sym_PROGMEM] = ACTIONS(5610),
    [aux_sym_primitive_type_token1] = ACTIONS(5610),
    [anon_sym_byte] = ACTIONS(5610),
    [anon_sym_word] = ACTIONS(5610),
    [anon_sym_enum] = ACTIONS(5610),
    [anon_sym_class] = ACTIONS(5610),
    [anon_sym_struct] = ACTIONS(5610),
    [anon_sym_union] = ACTIONS(5610),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5610),
    [anon_sym_decltype] = ACTIONS(5610),
    [anon_sym_virtual] = ACTIONS(5610),
    [anon_sym_alignas] = ACTIONS(5610),
    [anon_sym_explicit] = ACTIONS(5610),
    [anon_sym_typename] = ACTIONS(5610),
    [anon_sym_template] = ACTIONS(5610),
    [anon_sym_operator] = ACTIONS(5610),
    [anon_sym_friend] = ACTIONS(5610),
    [anon_sym_public] = ACTIONS(5610),
    [anon_sym_private] = ACTIONS(5610),
    [anon_sym_protected] = ACTIONS(5610),
    [anon_sym_using] = ACTIONS(5610),
    [anon_sym_static_assert] = ACTIONS(5610),
  },
  [2221] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token2] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [aux_sym_preproc_else_token1] = ACTIONS(3082),
    [aux_sym_preproc_elif_token1] = ACTIONS(3082),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(3082),
    [anon_sym_private] = ACTIONS(3082),
    [anon_sym_protected] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
  },
  [2222] = {
    [sym_identifier] = ACTIONS(5150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5152),
    [anon_sym_COMMA] = ACTIONS(5152),
    [anon_sym_RPAREN] = ACTIONS(5152),
    [anon_sym_LPAREN2] = ACTIONS(5152),
    [anon_sym_DASH] = ACTIONS(5150),
    [anon_sym_PLUS] = ACTIONS(5150),
    [anon_sym_STAR] = ACTIONS(5152),
    [anon_sym_SLASH] = ACTIONS(5150),
    [anon_sym_PERCENT] = ACTIONS(5152),
    [anon_sym_PIPE_PIPE] = ACTIONS(5152),
    [anon_sym_AMP_AMP] = ACTIONS(5152),
    [anon_sym_PIPE] = ACTIONS(5150),
    [anon_sym_CARET] = ACTIONS(5152),
    [anon_sym_AMP] = ACTIONS(5150),
    [anon_sym_EQ_EQ] = ACTIONS(5152),
    [anon_sym_BANG_EQ] = ACTIONS(5152),
    [anon_sym_GT] = ACTIONS(5150),
    [anon_sym_GT_EQ] = ACTIONS(5152),
    [anon_sym_LT_EQ] = ACTIONS(5150),
    [anon_sym_LT] = ACTIONS(5150),
    [anon_sym_LT_LT] = ACTIONS(5152),
    [anon_sym_GT_GT] = ACTIONS(5152),
    [anon_sym_SEMI] = ACTIONS(5152),
    [anon_sym___extension__] = ACTIONS(5150),
    [anon_sym___attribute__] = ACTIONS(5150),
    [anon_sym_COLON_COLON] = ACTIONS(5152),
    [anon_sym___based] = ACTIONS(5150),
    [anon_sym_LBRACE] = ACTIONS(5152),
    [anon_sym_RBRACE] = ACTIONS(5152),
    [anon_sym_signed] = ACTIONS(5150),
    [anon_sym_unsigned] = ACTIONS(5150),
    [anon_sym_long] = ACTIONS(5150),
    [anon_sym_short] = ACTIONS(5150),
    [anon_sym_LBRACK] = ACTIONS(5152),
    [anon_sym_RBRACK] = ACTIONS(5152),
    [anon_sym_const] = ACTIONS(5150),
    [anon_sym_constexpr] = ACTIONS(5150),
    [anon_sym_volatile] = ACTIONS(5150),
    [anon_sym_restrict] = ACTIONS(5150),
    [anon_sym___restrict__] = ACTIONS(5150),
    [anon_sym__Atomic] = ACTIONS(5150),
    [anon_sym__Noreturn] = ACTIONS(5150),
    [anon_sym_noreturn] = ACTIONS(5150),
    [anon_sym_mutable] = ACTIONS(5150),
    [anon_sym_constinit] = ACTIONS(5150),
    [anon_sym_consteval] = ACTIONS(5150),
    [anon_sym_PROGMEM] = ACTIONS(5150),
    [aux_sym_primitive_type_token1] = ACTIONS(5150),
    [anon_sym_byte] = ACTIONS(5150),
    [anon_sym_word] = ACTIONS(5150),
    [anon_sym_COLON] = ACTIONS(5150),
    [anon_sym_QMARK] = ACTIONS(5152),
    [anon_sym_LT_EQ_GT] = ACTIONS(5152),
    [anon_sym_or] = ACTIONS(5150),
    [anon_sym_and] = ACTIONS(5150),
    [anon_sym_bitor] = ACTIONS(5150),
    [anon_sym_xor] = ACTIONS(5150),
    [anon_sym_bitand] = ACTIONS(5150),
    [anon_sym_not_eq] = ACTIONS(5150),
    [anon_sym_DASH_DASH] = ACTIONS(5152),
    [anon_sym_PLUS_PLUS] = ACTIONS(5152),
    [anon_sym_DOT] = ACTIONS(5150),
    [anon_sym_DOT_STAR] = ACTIONS(5152),
    [anon_sym_DASH_GT] = ACTIONS(5152),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5150),
    [anon_sym_decltype] = ACTIONS(5150),
    [anon_sym_final] = ACTIONS(5150),
    [anon_sym_override] = ACTIONS(5150),
    [anon_sym_requires] = ACTIONS(5150),
  },
  [2223] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token2] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [aux_sym_preproc_else_token1] = ACTIONS(3082),
    [aux_sym_preproc_elif_token1] = ACTIONS(3082),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(3082),
    [anon_sym_private] = ACTIONS(3082),
    [anon_sym_protected] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
  },
  [2224] = {
    [sym_identifier] = ACTIONS(3509),
    [aux_sym_preproc_def_token1] = ACTIONS(3509),
    [aux_sym_preproc_if_token1] = ACTIONS(3509),
    [aux_sym_preproc_if_token2] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3509),
    [aux_sym_preproc_else_token1] = ACTIONS(3509),
    [aux_sym_preproc_elif_token1] = ACTIONS(3509),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3509),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3509),
    [sym_preproc_directive] = ACTIONS(3509),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3511),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym___extension__] = ACTIONS(3509),
    [anon_sym_typedef] = ACTIONS(3509),
    [anon_sym_extern] = ACTIONS(3509),
    [anon_sym___attribute__] = ACTIONS(3509),
    [anon_sym_COLON_COLON] = ACTIONS(3511),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3511),
    [anon_sym___declspec] = ACTIONS(3509),
    [anon_sym___based] = ACTIONS(3509),
    [anon_sym_signed] = ACTIONS(3509),
    [anon_sym_unsigned] = ACTIONS(3509),
    [anon_sym_long] = ACTIONS(3509),
    [anon_sym_short] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(3509),
    [anon_sym_static] = ACTIONS(3509),
    [anon_sym_register] = ACTIONS(3509),
    [anon_sym_inline] = ACTIONS(3509),
    [anon_sym___inline] = ACTIONS(3509),
    [anon_sym___inline__] = ACTIONS(3509),
    [anon_sym___forceinline] = ACTIONS(3509),
    [anon_sym_thread_local] = ACTIONS(3509),
    [anon_sym___thread] = ACTIONS(3509),
    [anon_sym_const] = ACTIONS(3509),
    [anon_sym_constexpr] = ACTIONS(3509),
    [anon_sym_volatile] = ACTIONS(3509),
    [anon_sym_restrict] = ACTIONS(3509),
    [anon_sym___restrict__] = ACTIONS(3509),
    [anon_sym__Atomic] = ACTIONS(3509),
    [anon_sym__Noreturn] = ACTIONS(3509),
    [anon_sym_noreturn] = ACTIONS(3509),
    [anon_sym_mutable] = ACTIONS(3509),
    [anon_sym_constinit] = ACTIONS(3509),
    [anon_sym_consteval] = ACTIONS(3509),
    [anon_sym_PROGMEM] = ACTIONS(3509),
    [aux_sym_primitive_type_token1] = ACTIONS(3509),
    [anon_sym_byte] = ACTIONS(3509),
    [anon_sym_word] = ACTIONS(3509),
    [anon_sym_enum] = ACTIONS(3509),
    [anon_sym_class] = ACTIONS(3509),
    [anon_sym_struct] = ACTIONS(3509),
    [anon_sym_union] = ACTIONS(3509),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3509),
    [anon_sym_decltype] = ACTIONS(3509),
    [anon_sym_virtual] = ACTIONS(3509),
    [anon_sym_alignas] = ACTIONS(3509),
    [anon_sym_explicit] = ACTIONS(3509),
    [anon_sym_typename] = ACTIONS(3509),
    [anon_sym_template] = ACTIONS(3509),
    [anon_sym_operator] = ACTIONS(3509),
    [anon_sym_friend] = ACTIONS(3509),
    [anon_sym_public] = ACTIONS(3509),
    [anon_sym_private] = ACTIONS(3509),
    [anon_sym_protected] = ACTIONS(3509),
    [anon_sym_using] = ACTIONS(3509),
    [anon_sym_static_assert] = ACTIONS(3509),
  },
  [2225] = {
    [sym_identifier] = ACTIONS(5614),
    [aux_sym_preproc_def_token1] = ACTIONS(5614),
    [aux_sym_preproc_if_token1] = ACTIONS(5614),
    [aux_sym_preproc_if_token2] = ACTIONS(5614),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5614),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5614),
    [aux_sym_preproc_else_token1] = ACTIONS(5614),
    [aux_sym_preproc_elif_token1] = ACTIONS(5614),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5614),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5614),
    [sym_preproc_directive] = ACTIONS(5614),
    [anon_sym_LPAREN2] = ACTIONS(5616),
    [anon_sym_TILDE] = ACTIONS(5616),
    [anon_sym_STAR] = ACTIONS(5616),
    [anon_sym_AMP_AMP] = ACTIONS(5616),
    [anon_sym_AMP] = ACTIONS(5614),
    [anon_sym___extension__] = ACTIONS(5614),
    [anon_sym_typedef] = ACTIONS(5614),
    [anon_sym_extern] = ACTIONS(5614),
    [anon_sym___attribute__] = ACTIONS(5614),
    [anon_sym_COLON_COLON] = ACTIONS(5616),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5616),
    [anon_sym___declspec] = ACTIONS(5614),
    [anon_sym___based] = ACTIONS(5614),
    [anon_sym_signed] = ACTIONS(5614),
    [anon_sym_unsigned] = ACTIONS(5614),
    [anon_sym_long] = ACTIONS(5614),
    [anon_sym_short] = ACTIONS(5614),
    [anon_sym_LBRACK] = ACTIONS(5614),
    [anon_sym_static] = ACTIONS(5614),
    [anon_sym_register] = ACTIONS(5614),
    [anon_sym_inline] = ACTIONS(5614),
    [anon_sym___inline] = ACTIONS(5614),
    [anon_sym___inline__] = ACTIONS(5614),
    [anon_sym___forceinline] = ACTIONS(5614),
    [anon_sym_thread_local] = ACTIONS(5614),
    [anon_sym___thread] = ACTIONS(5614),
    [anon_sym_const] = ACTIONS(5614),
    [anon_sym_constexpr] = ACTIONS(5614),
    [anon_sym_volatile] = ACTIONS(5614),
    [anon_sym_restrict] = ACTIONS(5614),
    [anon_sym___restrict__] = ACTIONS(5614),
    [anon_sym__Atomic] = ACTIONS(5614),
    [anon_sym__Noreturn] = ACTIONS(5614),
    [anon_sym_noreturn] = ACTIONS(5614),
    [anon_sym_mutable] = ACTIONS(5614),
    [anon_sym_constinit] = ACTIONS(5614),
    [anon_sym_consteval] = ACTIONS(5614),
    [anon_sym_PROGMEM] = ACTIONS(5614),
    [aux_sym_primitive_type_token1] = ACTIONS(5614),
    [anon_sym_byte] = ACTIONS(5614),
    [anon_sym_word] = ACTIONS(5614),
    [anon_sym_enum] = ACTIONS(5614),
    [anon_sym_class] = ACTIONS(5614),
    [anon_sym_struct] = ACTIONS(5614),
    [anon_sym_union] = ACTIONS(5614),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5614),
    [anon_sym_decltype] = ACTIONS(5614),
    [anon_sym_virtual] = ACTIONS(5614),
    [anon_sym_alignas] = ACTIONS(5614),
    [anon_sym_explicit] = ACTIONS(5614),
    [anon_sym_typename] = ACTIONS(5614),
    [anon_sym_template] = ACTIONS(5614),
    [anon_sym_operator] = ACTIONS(5614),
    [anon_sym_friend] = ACTIONS(5614),
    [anon_sym_public] = ACTIONS(5614),
    [anon_sym_private] = ACTIONS(5614),
    [anon_sym_protected] = ACTIONS(5614),
    [anon_sym_using] = ACTIONS(5614),
    [anon_sym_static_assert] = ACTIONS(5614),
  },
  [2226] = {
    [sym_identifier] = ACTIONS(5614),
    [aux_sym_preproc_def_token1] = ACTIONS(5614),
    [aux_sym_preproc_if_token1] = ACTIONS(5614),
    [aux_sym_preproc_if_token2] = ACTIONS(5614),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5614),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5614),
    [aux_sym_preproc_else_token1] = ACTIONS(5614),
    [aux_sym_preproc_elif_token1] = ACTIONS(5614),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5614),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5614),
    [sym_preproc_directive] = ACTIONS(5614),
    [anon_sym_LPAREN2] = ACTIONS(5616),
    [anon_sym_TILDE] = ACTIONS(5616),
    [anon_sym_STAR] = ACTIONS(5616),
    [anon_sym_AMP_AMP] = ACTIONS(5616),
    [anon_sym_AMP] = ACTIONS(5614),
    [anon_sym___extension__] = ACTIONS(5614),
    [anon_sym_typedef] = ACTIONS(5614),
    [anon_sym_extern] = ACTIONS(5614),
    [anon_sym___attribute__] = ACTIONS(5614),
    [anon_sym_COLON_COLON] = ACTIONS(5616),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5616),
    [anon_sym___declspec] = ACTIONS(5614),
    [anon_sym___based] = ACTIONS(5614),
    [anon_sym_signed] = ACTIONS(5614),
    [anon_sym_unsigned] = ACTIONS(5614),
    [anon_sym_long] = ACTIONS(5614),
    [anon_sym_short] = ACTIONS(5614),
    [anon_sym_LBRACK] = ACTIONS(5614),
    [anon_sym_static] = ACTIONS(5614),
    [anon_sym_register] = ACTIONS(5614),
    [anon_sym_inline] = ACTIONS(5614),
    [anon_sym___inline] = ACTIONS(5614),
    [anon_sym___inline__] = ACTIONS(5614),
    [anon_sym___forceinline] = ACTIONS(5614),
    [anon_sym_thread_local] = ACTIONS(5614),
    [anon_sym___thread] = ACTIONS(5614),
    [anon_sym_const] = ACTIONS(5614),
    [anon_sym_constexpr] = ACTIONS(5614),
    [anon_sym_volatile] = ACTIONS(5614),
    [anon_sym_restrict] = ACTIONS(5614),
    [anon_sym___restrict__] = ACTIONS(5614),
    [anon_sym__Atomic] = ACTIONS(5614),
    [anon_sym__Noreturn] = ACTIONS(5614),
    [anon_sym_noreturn] = ACTIONS(5614),
    [anon_sym_mutable] = ACTIONS(5614),
    [anon_sym_constinit] = ACTIONS(5614),
    [anon_sym_consteval] = ACTIONS(5614),
    [anon_sym_PROGMEM] = ACTIONS(5614),
    [aux_sym_primitive_type_token1] = ACTIONS(5614),
    [anon_sym_byte] = ACTIONS(5614),
    [anon_sym_word] = ACTIONS(5614),
    [anon_sym_enum] = ACTIONS(5614),
    [anon_sym_class] = ACTIONS(5614),
    [anon_sym_struct] = ACTIONS(5614),
    [anon_sym_union] = ACTIONS(5614),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5614),
    [anon_sym_decltype] = ACTIONS(5614),
    [anon_sym_virtual] = ACTIONS(5614),
    [anon_sym_alignas] = ACTIONS(5614),
    [anon_sym_explicit] = ACTIONS(5614),
    [anon_sym_typename] = ACTIONS(5614),
    [anon_sym_template] = ACTIONS(5614),
    [anon_sym_operator] = ACTIONS(5614),
    [anon_sym_friend] = ACTIONS(5614),
    [anon_sym_public] = ACTIONS(5614),
    [anon_sym_private] = ACTIONS(5614),
    [anon_sym_protected] = ACTIONS(5614),
    [anon_sym_using] = ACTIONS(5614),
    [anon_sym_static_assert] = ACTIONS(5614),
  },
  [2227] = {
    [sym_identifier] = ACTIONS(5117),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(5119),
    [anon_sym_RPAREN] = ACTIONS(5119),
    [anon_sym_LPAREN2] = ACTIONS(5119),
    [anon_sym_DASH] = ACTIONS(5117),
    [anon_sym_PLUS] = ACTIONS(5117),
    [anon_sym_STAR] = ACTIONS(5119),
    [anon_sym_SLASH] = ACTIONS(5117),
    [anon_sym_PERCENT] = ACTIONS(5119),
    [anon_sym_PIPE_PIPE] = ACTIONS(5119),
    [anon_sym_AMP_AMP] = ACTIONS(5119),
    [anon_sym_PIPE] = ACTIONS(5117),
    [anon_sym_CARET] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5117),
    [anon_sym_EQ_EQ] = ACTIONS(5119),
    [anon_sym_BANG_EQ] = ACTIONS(5119),
    [anon_sym_GT] = ACTIONS(5117),
    [anon_sym_GT_EQ] = ACTIONS(5119),
    [anon_sym_LT_EQ] = ACTIONS(5117),
    [anon_sym_LT] = ACTIONS(5117),
    [anon_sym_LT_LT] = ACTIONS(5119),
    [anon_sym_GT_GT] = ACTIONS(5119),
    [anon_sym_SEMI] = ACTIONS(5119),
    [anon_sym___extension__] = ACTIONS(5117),
    [anon_sym___attribute__] = ACTIONS(5117),
    [anon_sym_COLON_COLON] = ACTIONS(5119),
    [anon_sym___based] = ACTIONS(5117),
    [anon_sym_LBRACE] = ACTIONS(5119),
    [anon_sym_RBRACE] = ACTIONS(5119),
    [anon_sym_signed] = ACTIONS(5117),
    [anon_sym_unsigned] = ACTIONS(5117),
    [anon_sym_long] = ACTIONS(5117),
    [anon_sym_short] = ACTIONS(5117),
    [anon_sym_LBRACK] = ACTIONS(5119),
    [anon_sym_RBRACK] = ACTIONS(5119),
    [anon_sym_const] = ACTIONS(5117),
    [anon_sym_constexpr] = ACTIONS(5117),
    [anon_sym_volatile] = ACTIONS(5117),
    [anon_sym_restrict] = ACTIONS(5117),
    [anon_sym___restrict__] = ACTIONS(5117),
    [anon_sym__Atomic] = ACTIONS(5117),
    [anon_sym__Noreturn] = ACTIONS(5117),
    [anon_sym_noreturn] = ACTIONS(5117),
    [anon_sym_mutable] = ACTIONS(5117),
    [anon_sym_constinit] = ACTIONS(5117),
    [anon_sym_consteval] = ACTIONS(5117),
    [anon_sym_PROGMEM] = ACTIONS(5117),
    [aux_sym_primitive_type_token1] = ACTIONS(5117),
    [anon_sym_byte] = ACTIONS(5117),
    [anon_sym_word] = ACTIONS(5117),
    [anon_sym_COLON] = ACTIONS(5117),
    [anon_sym_QMARK] = ACTIONS(5119),
    [anon_sym_LT_EQ_GT] = ACTIONS(5119),
    [anon_sym_or] = ACTIONS(5117),
    [anon_sym_and] = ACTIONS(5117),
    [anon_sym_bitor] = ACTIONS(5117),
    [anon_sym_xor] = ACTIONS(5117),
    [anon_sym_bitand] = ACTIONS(5117),
    [anon_sym_not_eq] = ACTIONS(5117),
    [anon_sym_DASH_DASH] = ACTIONS(5119),
    [anon_sym_PLUS_PLUS] = ACTIONS(5119),
    [anon_sym_DOT] = ACTIONS(5117),
    [anon_sym_DOT_STAR] = ACTIONS(5119),
    [anon_sym_DASH_GT] = ACTIONS(5119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5117),
    [anon_sym_decltype] = ACTIONS(5117),
    [anon_sym_final] = ACTIONS(5117),
    [anon_sym_override] = ACTIONS(5117),
    [anon_sym_requires] = ACTIONS(5117),
  },
  [2228] = {
    [sym__declaration_modifiers] = STATE(2265),
    [sym__declaration_specifiers] = STATE(5617),
    [sym_attribute_specifier] = STATE(2265),
    [sym_attribute_declaration] = STATE(2265),
    [sym_ms_declspec_modifier] = STATE(2265),
    [sym_storage_class_specifier] = STATE(2265),
    [sym_type_qualifier] = STATE(2265),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(2265),
    [sym_alignas_specifier] = STATE(2265),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2265),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5204),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2229] = {
    [sym_identifier] = ACTIONS(3503),
    [aux_sym_preproc_def_token1] = ACTIONS(3503),
    [aux_sym_preproc_if_token1] = ACTIONS(3503),
    [aux_sym_preproc_if_token2] = ACTIONS(3503),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3503),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3503),
    [aux_sym_preproc_else_token1] = ACTIONS(3503),
    [aux_sym_preproc_elif_token1] = ACTIONS(3503),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3503),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3503),
    [sym_preproc_directive] = ACTIONS(3503),
    [anon_sym_LPAREN2] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP] = ACTIONS(3503),
    [anon_sym___extension__] = ACTIONS(3503),
    [anon_sym_typedef] = ACTIONS(3503),
    [anon_sym_extern] = ACTIONS(3503),
    [anon_sym___attribute__] = ACTIONS(3503),
    [anon_sym_COLON_COLON] = ACTIONS(3505),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3505),
    [anon_sym___declspec] = ACTIONS(3503),
    [anon_sym___based] = ACTIONS(3503),
    [anon_sym_signed] = ACTIONS(3503),
    [anon_sym_unsigned] = ACTIONS(3503),
    [anon_sym_long] = ACTIONS(3503),
    [anon_sym_short] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3503),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_register] = ACTIONS(3503),
    [anon_sym_inline] = ACTIONS(3503),
    [anon_sym___inline] = ACTIONS(3503),
    [anon_sym___inline__] = ACTIONS(3503),
    [anon_sym___forceinline] = ACTIONS(3503),
    [anon_sym_thread_local] = ACTIONS(3503),
    [anon_sym___thread] = ACTIONS(3503),
    [anon_sym_const] = ACTIONS(3503),
    [anon_sym_constexpr] = ACTIONS(3503),
    [anon_sym_volatile] = ACTIONS(3503),
    [anon_sym_restrict] = ACTIONS(3503),
    [anon_sym___restrict__] = ACTIONS(3503),
    [anon_sym__Atomic] = ACTIONS(3503),
    [anon_sym__Noreturn] = ACTIONS(3503),
    [anon_sym_noreturn] = ACTIONS(3503),
    [anon_sym_mutable] = ACTIONS(3503),
    [anon_sym_constinit] = ACTIONS(3503),
    [anon_sym_consteval] = ACTIONS(3503),
    [anon_sym_PROGMEM] = ACTIONS(3503),
    [aux_sym_primitive_type_token1] = ACTIONS(3503),
    [anon_sym_byte] = ACTIONS(3503),
    [anon_sym_word] = ACTIONS(3503),
    [anon_sym_enum] = ACTIONS(3503),
    [anon_sym_class] = ACTIONS(3503),
    [anon_sym_struct] = ACTIONS(3503),
    [anon_sym_union] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3503),
    [anon_sym_decltype] = ACTIONS(3503),
    [anon_sym_virtual] = ACTIONS(3503),
    [anon_sym_alignas] = ACTIONS(3503),
    [anon_sym_explicit] = ACTIONS(3503),
    [anon_sym_typename] = ACTIONS(3503),
    [anon_sym_template] = ACTIONS(3503),
    [anon_sym_operator] = ACTIONS(3503),
    [anon_sym_friend] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_using] = ACTIONS(3503),
    [anon_sym_static_assert] = ACTIONS(3503),
  },
  [2230] = {
    [sym__declaration_modifiers] = STATE(4180),
    [sym_attribute_specifier] = STATE(4180),
    [sym_attribute_declaration] = STATE(4180),
    [sym_ms_declspec_modifier] = STATE(4180),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7168),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(4180),
    [sym_type_qualifier] = STATE(4180),
    [sym_decltype] = STATE(9504),
    [sym_virtual] = STATE(4180),
    [sym_alignas_specifier] = STATE(4180),
    [sym_explicit_function_specifier] = STATE(4180),
    [sym_operator_cast] = STATE(7539),
    [sym__constructor_specifiers] = STATE(4180),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(9504),
    [sym_template_function] = STATE(7008),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6421),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_operator_cast_identifier] = STATE(7539),
    [sym_operator_name] = STATE(7008),
    [aux_sym_operator_cast_definition_repeat1] = STATE(4180),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(5449),
    [anon_sym_extern] = ACTIONS(5451),
    [anon_sym___attribute__] = ACTIONS(5453),
    [anon_sym_COLON_COLON] = ACTIONS(5455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5457),
    [anon_sym___declspec] = ACTIONS(5459),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(5451),
    [anon_sym_register] = ACTIONS(5451),
    [anon_sym_inline] = ACTIONS(5451),
    [anon_sym___inline] = ACTIONS(5451),
    [anon_sym___inline__] = ACTIONS(5451),
    [anon_sym___forceinline] = ACTIONS(5451),
    [anon_sym_thread_local] = ACTIONS(5451),
    [anon_sym___thread] = ACTIONS(5451),
    [anon_sym_const] = ACTIONS(5449),
    [anon_sym_constexpr] = ACTIONS(5449),
    [anon_sym_volatile] = ACTIONS(5449),
    [anon_sym_restrict] = ACTIONS(5449),
    [anon_sym___restrict__] = ACTIONS(5449),
    [anon_sym__Atomic] = ACTIONS(5449),
    [anon_sym__Noreturn] = ACTIONS(5449),
    [anon_sym_noreturn] = ACTIONS(5449),
    [anon_sym_mutable] = ACTIONS(5449),
    [anon_sym_constinit] = ACTIONS(5449),
    [anon_sym_consteval] = ACTIONS(5449),
    [anon_sym_PROGMEM] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_virtual] = ACTIONS(5461),
    [anon_sym_alignas] = ACTIONS(5463),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(133),
  },
  [2231] = {
    [sym_identifier] = ACTIONS(5618),
    [aux_sym_preproc_def_token1] = ACTIONS(5618),
    [aux_sym_preproc_if_token1] = ACTIONS(5618),
    [aux_sym_preproc_if_token2] = ACTIONS(5618),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5618),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5618),
    [aux_sym_preproc_else_token1] = ACTIONS(5618),
    [aux_sym_preproc_elif_token1] = ACTIONS(5618),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5618),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5618),
    [sym_preproc_directive] = ACTIONS(5618),
    [anon_sym_LPAREN2] = ACTIONS(5620),
    [anon_sym_TILDE] = ACTIONS(5620),
    [anon_sym_STAR] = ACTIONS(5620),
    [anon_sym_AMP_AMP] = ACTIONS(5620),
    [anon_sym_AMP] = ACTIONS(5618),
    [anon_sym___extension__] = ACTIONS(5618),
    [anon_sym_typedef] = ACTIONS(5618),
    [anon_sym_extern] = ACTIONS(5618),
    [anon_sym___attribute__] = ACTIONS(5618),
    [anon_sym_COLON_COLON] = ACTIONS(5620),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5620),
    [anon_sym___declspec] = ACTIONS(5618),
    [anon_sym___based] = ACTIONS(5618),
    [anon_sym_signed] = ACTIONS(5618),
    [anon_sym_unsigned] = ACTIONS(5618),
    [anon_sym_long] = ACTIONS(5618),
    [anon_sym_short] = ACTIONS(5618),
    [anon_sym_LBRACK] = ACTIONS(5618),
    [anon_sym_static] = ACTIONS(5618),
    [anon_sym_register] = ACTIONS(5618),
    [anon_sym_inline] = ACTIONS(5618),
    [anon_sym___inline] = ACTIONS(5618),
    [anon_sym___inline__] = ACTIONS(5618),
    [anon_sym___forceinline] = ACTIONS(5618),
    [anon_sym_thread_local] = ACTIONS(5618),
    [anon_sym___thread] = ACTIONS(5618),
    [anon_sym_const] = ACTIONS(5618),
    [anon_sym_constexpr] = ACTIONS(5618),
    [anon_sym_volatile] = ACTIONS(5618),
    [anon_sym_restrict] = ACTIONS(5618),
    [anon_sym___restrict__] = ACTIONS(5618),
    [anon_sym__Atomic] = ACTIONS(5618),
    [anon_sym__Noreturn] = ACTIONS(5618),
    [anon_sym_noreturn] = ACTIONS(5618),
    [anon_sym_mutable] = ACTIONS(5618),
    [anon_sym_constinit] = ACTIONS(5618),
    [anon_sym_consteval] = ACTIONS(5618),
    [anon_sym_PROGMEM] = ACTIONS(5618),
    [aux_sym_primitive_type_token1] = ACTIONS(5618),
    [anon_sym_byte] = ACTIONS(5618),
    [anon_sym_word] = ACTIONS(5618),
    [anon_sym_enum] = ACTIONS(5618),
    [anon_sym_class] = ACTIONS(5618),
    [anon_sym_struct] = ACTIONS(5618),
    [anon_sym_union] = ACTIONS(5618),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5618),
    [anon_sym_decltype] = ACTIONS(5618),
    [anon_sym_virtual] = ACTIONS(5618),
    [anon_sym_alignas] = ACTIONS(5618),
    [anon_sym_explicit] = ACTIONS(5618),
    [anon_sym_typename] = ACTIONS(5618),
    [anon_sym_template] = ACTIONS(5618),
    [anon_sym_operator] = ACTIONS(5618),
    [anon_sym_friend] = ACTIONS(5618),
    [anon_sym_public] = ACTIONS(5618),
    [anon_sym_private] = ACTIONS(5618),
    [anon_sym_protected] = ACTIONS(5618),
    [anon_sym_using] = ACTIONS(5618),
    [anon_sym_static_assert] = ACTIONS(5618),
  },
  [2232] = {
    [sym__declaration_modifiers] = STATE(4180),
    [sym_attribute_specifier] = STATE(4180),
    [sym_attribute_declaration] = STATE(4180),
    [sym_ms_declspec_modifier] = STATE(4180),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7171),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(4180),
    [sym_type_qualifier] = STATE(4180),
    [sym_decltype] = STATE(9504),
    [sym_virtual] = STATE(4180),
    [sym_alignas_specifier] = STATE(4180),
    [sym_explicit_function_specifier] = STATE(4180),
    [sym_operator_cast] = STATE(7496),
    [sym__constructor_specifiers] = STATE(4180),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(9504),
    [sym_template_function] = STATE(7008),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6421),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_operator_cast_identifier] = STATE(7496),
    [sym_operator_name] = STATE(7008),
    [aux_sym_operator_cast_definition_repeat1] = STATE(4180),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(5449),
    [anon_sym_extern] = ACTIONS(5451),
    [anon_sym___attribute__] = ACTIONS(5453),
    [anon_sym_COLON_COLON] = ACTIONS(5455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5457),
    [anon_sym___declspec] = ACTIONS(5459),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(5451),
    [anon_sym_register] = ACTIONS(5451),
    [anon_sym_inline] = ACTIONS(5451),
    [anon_sym___inline] = ACTIONS(5451),
    [anon_sym___inline__] = ACTIONS(5451),
    [anon_sym___forceinline] = ACTIONS(5451),
    [anon_sym_thread_local] = ACTIONS(5451),
    [anon_sym___thread] = ACTIONS(5451),
    [anon_sym_const] = ACTIONS(5449),
    [anon_sym_constexpr] = ACTIONS(5449),
    [anon_sym_volatile] = ACTIONS(5449),
    [anon_sym_restrict] = ACTIONS(5449),
    [anon_sym___restrict__] = ACTIONS(5449),
    [anon_sym__Atomic] = ACTIONS(5449),
    [anon_sym__Noreturn] = ACTIONS(5449),
    [anon_sym_noreturn] = ACTIONS(5449),
    [anon_sym_mutable] = ACTIONS(5449),
    [anon_sym_constinit] = ACTIONS(5449),
    [anon_sym_consteval] = ACTIONS(5449),
    [anon_sym_PROGMEM] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_virtual] = ACTIONS(5461),
    [anon_sym_alignas] = ACTIONS(5463),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(133),
  },
  [2233] = {
    [sym_identifier] = ACTIONS(5622),
    [aux_sym_preproc_def_token1] = ACTIONS(5622),
    [aux_sym_preproc_if_token1] = ACTIONS(5622),
    [aux_sym_preproc_if_token2] = ACTIONS(5622),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5622),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5622),
    [aux_sym_preproc_else_token1] = ACTIONS(5622),
    [aux_sym_preproc_elif_token1] = ACTIONS(5622),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5622),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5622),
    [sym_preproc_directive] = ACTIONS(5622),
    [anon_sym_LPAREN2] = ACTIONS(5624),
    [anon_sym_TILDE] = ACTIONS(5624),
    [anon_sym_STAR] = ACTIONS(5624),
    [anon_sym_AMP_AMP] = ACTIONS(5624),
    [anon_sym_AMP] = ACTIONS(5622),
    [anon_sym___extension__] = ACTIONS(5622),
    [anon_sym_typedef] = ACTIONS(5622),
    [anon_sym_extern] = ACTIONS(5622),
    [anon_sym___attribute__] = ACTIONS(5622),
    [anon_sym_COLON_COLON] = ACTIONS(5624),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5624),
    [anon_sym___declspec] = ACTIONS(5622),
    [anon_sym___based] = ACTIONS(5622),
    [anon_sym_signed] = ACTIONS(5622),
    [anon_sym_unsigned] = ACTIONS(5622),
    [anon_sym_long] = ACTIONS(5622),
    [anon_sym_short] = ACTIONS(5622),
    [anon_sym_LBRACK] = ACTIONS(5622),
    [anon_sym_static] = ACTIONS(5622),
    [anon_sym_register] = ACTIONS(5622),
    [anon_sym_inline] = ACTIONS(5622),
    [anon_sym___inline] = ACTIONS(5622),
    [anon_sym___inline__] = ACTIONS(5622),
    [anon_sym___forceinline] = ACTIONS(5622),
    [anon_sym_thread_local] = ACTIONS(5622),
    [anon_sym___thread] = ACTIONS(5622),
    [anon_sym_const] = ACTIONS(5622),
    [anon_sym_constexpr] = ACTIONS(5622),
    [anon_sym_volatile] = ACTIONS(5622),
    [anon_sym_restrict] = ACTIONS(5622),
    [anon_sym___restrict__] = ACTIONS(5622),
    [anon_sym__Atomic] = ACTIONS(5622),
    [anon_sym__Noreturn] = ACTIONS(5622),
    [anon_sym_noreturn] = ACTIONS(5622),
    [anon_sym_mutable] = ACTIONS(5622),
    [anon_sym_constinit] = ACTIONS(5622),
    [anon_sym_consteval] = ACTIONS(5622),
    [anon_sym_PROGMEM] = ACTIONS(5622),
    [aux_sym_primitive_type_token1] = ACTIONS(5622),
    [anon_sym_byte] = ACTIONS(5622),
    [anon_sym_word] = ACTIONS(5622),
    [anon_sym_enum] = ACTIONS(5622),
    [anon_sym_class] = ACTIONS(5622),
    [anon_sym_struct] = ACTIONS(5622),
    [anon_sym_union] = ACTIONS(5622),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5622),
    [anon_sym_decltype] = ACTIONS(5622),
    [anon_sym_virtual] = ACTIONS(5622),
    [anon_sym_alignas] = ACTIONS(5622),
    [anon_sym_explicit] = ACTIONS(5622),
    [anon_sym_typename] = ACTIONS(5622),
    [anon_sym_template] = ACTIONS(5622),
    [anon_sym_operator] = ACTIONS(5622),
    [anon_sym_friend] = ACTIONS(5622),
    [anon_sym_public] = ACTIONS(5622),
    [anon_sym_private] = ACTIONS(5622),
    [anon_sym_protected] = ACTIONS(5622),
    [anon_sym_using] = ACTIONS(5622),
    [anon_sym_static_assert] = ACTIONS(5622),
  },
  [2234] = {
    [sym__declaration_modifiers] = STATE(4180),
    [sym_attribute_specifier] = STATE(4180),
    [sym_attribute_declaration] = STATE(4180),
    [sym_ms_declspec_modifier] = STATE(4180),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7017),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(4180),
    [sym_type_qualifier] = STATE(4180),
    [sym_decltype] = STATE(9504),
    [sym_virtual] = STATE(4180),
    [sym_alignas_specifier] = STATE(4180),
    [sym_explicit_function_specifier] = STATE(4180),
    [sym_operator_cast] = STATE(7496),
    [sym__constructor_specifiers] = STATE(4180),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(9504),
    [sym_template_function] = STATE(7008),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6421),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_operator_cast_identifier] = STATE(7496),
    [sym_operator_name] = STATE(7008),
    [aux_sym_operator_cast_definition_repeat1] = STATE(4180),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(5449),
    [anon_sym_extern] = ACTIONS(5451),
    [anon_sym___attribute__] = ACTIONS(5453),
    [anon_sym_COLON_COLON] = ACTIONS(5455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5457),
    [anon_sym___declspec] = ACTIONS(5459),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(5451),
    [anon_sym_register] = ACTIONS(5451),
    [anon_sym_inline] = ACTIONS(5451),
    [anon_sym___inline] = ACTIONS(5451),
    [anon_sym___inline__] = ACTIONS(5451),
    [anon_sym___forceinline] = ACTIONS(5451),
    [anon_sym_thread_local] = ACTIONS(5451),
    [anon_sym___thread] = ACTIONS(5451),
    [anon_sym_const] = ACTIONS(5449),
    [anon_sym_constexpr] = ACTIONS(5449),
    [anon_sym_volatile] = ACTIONS(5449),
    [anon_sym_restrict] = ACTIONS(5449),
    [anon_sym___restrict__] = ACTIONS(5449),
    [anon_sym__Atomic] = ACTIONS(5449),
    [anon_sym__Noreturn] = ACTIONS(5449),
    [anon_sym_noreturn] = ACTIONS(5449),
    [anon_sym_mutable] = ACTIONS(5449),
    [anon_sym_constinit] = ACTIONS(5449),
    [anon_sym_consteval] = ACTIONS(5449),
    [anon_sym_PROGMEM] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_virtual] = ACTIONS(5461),
    [anon_sym_alignas] = ACTIONS(5463),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(133),
  },
  [2235] = {
    [sym_identifier] = ACTIONS(5626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_RPAREN] = ACTIONS(5628),
    [anon_sym_LPAREN2] = ACTIONS(5628),
    [anon_sym_DASH] = ACTIONS(5626),
    [anon_sym_PLUS] = ACTIONS(5626),
    [anon_sym_STAR] = ACTIONS(5628),
    [anon_sym_SLASH] = ACTIONS(5626),
    [anon_sym_PERCENT] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE] = ACTIONS(5628),
    [anon_sym_AMP_AMP] = ACTIONS(5628),
    [anon_sym_PIPE] = ACTIONS(5626),
    [anon_sym_CARET] = ACTIONS(5628),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym_EQ_EQ] = ACTIONS(5628),
    [anon_sym_BANG_EQ] = ACTIONS(5628),
    [anon_sym_GT] = ACTIONS(5626),
    [anon_sym_GT_EQ] = ACTIONS(5628),
    [anon_sym_LT_EQ] = ACTIONS(5626),
    [anon_sym_LT] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym___extension__] = ACTIONS(5626),
    [anon_sym___attribute__] = ACTIONS(5626),
    [anon_sym_COLON_COLON] = ACTIONS(5485),
    [anon_sym___based] = ACTIONS(5626),
    [anon_sym_LBRACE] = ACTIONS(5628),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_signed] = ACTIONS(5626),
    [anon_sym_unsigned] = ACTIONS(5626),
    [anon_sym_long] = ACTIONS(5626),
    [anon_sym_short] = ACTIONS(5626),
    [anon_sym_LBRACK] = ACTIONS(5628),
    [anon_sym_RBRACK] = ACTIONS(5628),
    [anon_sym_const] = ACTIONS(5626),
    [anon_sym_constexpr] = ACTIONS(5626),
    [anon_sym_volatile] = ACTIONS(5626),
    [anon_sym_restrict] = ACTIONS(5626),
    [anon_sym___restrict__] = ACTIONS(5626),
    [anon_sym__Atomic] = ACTIONS(5626),
    [anon_sym__Noreturn] = ACTIONS(5626),
    [anon_sym_noreturn] = ACTIONS(5626),
    [anon_sym_mutable] = ACTIONS(5626),
    [anon_sym_constinit] = ACTIONS(5626),
    [anon_sym_consteval] = ACTIONS(5626),
    [anon_sym_PROGMEM] = ACTIONS(5626),
    [aux_sym_primitive_type_token1] = ACTIONS(5626),
    [anon_sym_byte] = ACTIONS(5626),
    [anon_sym_word] = ACTIONS(5626),
    [anon_sym_COLON] = ACTIONS(5626),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_LT_EQ_GT] = ACTIONS(5628),
    [anon_sym_or] = ACTIONS(5626),
    [anon_sym_and] = ACTIONS(5626),
    [anon_sym_bitor] = ACTIONS(5626),
    [anon_sym_xor] = ACTIONS(5626),
    [anon_sym_bitand] = ACTIONS(5626),
    [anon_sym_not_eq] = ACTIONS(5626),
    [anon_sym_DASH_DASH] = ACTIONS(5628),
    [anon_sym_PLUS_PLUS] = ACTIONS(5628),
    [anon_sym_DOT] = ACTIONS(5626),
    [anon_sym_DOT_STAR] = ACTIONS(5628),
    [anon_sym_DASH_GT] = ACTIONS(5628),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5626),
    [anon_sym_decltype] = ACTIONS(5626),
    [anon_sym_final] = ACTIONS(5626),
    [anon_sym_override] = ACTIONS(5626),
    [anon_sym_requires] = ACTIONS(5626),
  },
  [2236] = {
    [sym_identifier] = ACTIONS(3411),
    [aux_sym_preproc_def_token1] = ACTIONS(3411),
    [aux_sym_preproc_if_token1] = ACTIONS(3411),
    [aux_sym_preproc_if_token2] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3411),
    [aux_sym_preproc_else_token1] = ACTIONS(3411),
    [aux_sym_preproc_elif_token1] = ACTIONS(3411),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3411),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3411),
    [sym_preproc_directive] = ACTIONS(3411),
    [anon_sym_LPAREN2] = ACTIONS(3413),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_STAR] = ACTIONS(3413),
    [anon_sym_AMP_AMP] = ACTIONS(3413),
    [anon_sym_AMP] = ACTIONS(3411),
    [anon_sym___extension__] = ACTIONS(3411),
    [anon_sym_typedef] = ACTIONS(3411),
    [anon_sym_extern] = ACTIONS(3411),
    [anon_sym___attribute__] = ACTIONS(3411),
    [anon_sym_COLON_COLON] = ACTIONS(3413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3413),
    [anon_sym___declspec] = ACTIONS(3411),
    [anon_sym___based] = ACTIONS(3411),
    [anon_sym_signed] = ACTIONS(3411),
    [anon_sym_unsigned] = ACTIONS(3411),
    [anon_sym_long] = ACTIONS(3411),
    [anon_sym_short] = ACTIONS(3411),
    [anon_sym_LBRACK] = ACTIONS(3411),
    [anon_sym_static] = ACTIONS(3411),
    [anon_sym_register] = ACTIONS(3411),
    [anon_sym_inline] = ACTIONS(3411),
    [anon_sym___inline] = ACTIONS(3411),
    [anon_sym___inline__] = ACTIONS(3411),
    [anon_sym___forceinline] = ACTIONS(3411),
    [anon_sym_thread_local] = ACTIONS(3411),
    [anon_sym___thread] = ACTIONS(3411),
    [anon_sym_const] = ACTIONS(3411),
    [anon_sym_constexpr] = ACTIONS(3411),
    [anon_sym_volatile] = ACTIONS(3411),
    [anon_sym_restrict] = ACTIONS(3411),
    [anon_sym___restrict__] = ACTIONS(3411),
    [anon_sym__Atomic] = ACTIONS(3411),
    [anon_sym__Noreturn] = ACTIONS(3411),
    [anon_sym_noreturn] = ACTIONS(3411),
    [anon_sym_mutable] = ACTIONS(3411),
    [anon_sym_constinit] = ACTIONS(3411),
    [anon_sym_consteval] = ACTIONS(3411),
    [anon_sym_PROGMEM] = ACTIONS(3411),
    [aux_sym_primitive_type_token1] = ACTIONS(3411),
    [anon_sym_byte] = ACTIONS(3411),
    [anon_sym_word] = ACTIONS(3411),
    [anon_sym_enum] = ACTIONS(3411),
    [anon_sym_class] = ACTIONS(3411),
    [anon_sym_struct] = ACTIONS(3411),
    [anon_sym_union] = ACTIONS(3411),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3411),
    [anon_sym_decltype] = ACTIONS(3411),
    [anon_sym_virtual] = ACTIONS(3411),
    [anon_sym_alignas] = ACTIONS(3411),
    [anon_sym_explicit] = ACTIONS(3411),
    [anon_sym_typename] = ACTIONS(3411),
    [anon_sym_template] = ACTIONS(3411),
    [anon_sym_operator] = ACTIONS(3411),
    [anon_sym_friend] = ACTIONS(3411),
    [anon_sym_public] = ACTIONS(3411),
    [anon_sym_private] = ACTIONS(3411),
    [anon_sym_protected] = ACTIONS(3411),
    [anon_sym_using] = ACTIONS(3411),
    [anon_sym_static_assert] = ACTIONS(3411),
  },
  [2237] = {
    [sym_identifier] = ACTIONS(5626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_RPAREN] = ACTIONS(5628),
    [anon_sym_LPAREN2] = ACTIONS(5628),
    [anon_sym_DASH] = ACTIONS(5626),
    [anon_sym_PLUS] = ACTIONS(5626),
    [anon_sym_STAR] = ACTIONS(5628),
    [anon_sym_SLASH] = ACTIONS(5626),
    [anon_sym_PERCENT] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE] = ACTIONS(5628),
    [anon_sym_AMP_AMP] = ACTIONS(5628),
    [anon_sym_PIPE] = ACTIONS(5626),
    [anon_sym_CARET] = ACTIONS(5628),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym_EQ_EQ] = ACTIONS(5628),
    [anon_sym_BANG_EQ] = ACTIONS(5628),
    [anon_sym_GT] = ACTIONS(5626),
    [anon_sym_GT_EQ] = ACTIONS(5628),
    [anon_sym_LT_EQ] = ACTIONS(5626),
    [anon_sym_LT] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym___extension__] = ACTIONS(5626),
    [anon_sym___attribute__] = ACTIONS(5626),
    [anon_sym_COLON_COLON] = ACTIONS(5485),
    [anon_sym___based] = ACTIONS(5626),
    [anon_sym_LBRACE] = ACTIONS(5628),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_signed] = ACTIONS(5626),
    [anon_sym_unsigned] = ACTIONS(5626),
    [anon_sym_long] = ACTIONS(5626),
    [anon_sym_short] = ACTIONS(5626),
    [anon_sym_LBRACK] = ACTIONS(5628),
    [anon_sym_RBRACK] = ACTIONS(5628),
    [anon_sym_const] = ACTIONS(5626),
    [anon_sym_constexpr] = ACTIONS(5626),
    [anon_sym_volatile] = ACTIONS(5626),
    [anon_sym_restrict] = ACTIONS(5626),
    [anon_sym___restrict__] = ACTIONS(5626),
    [anon_sym__Atomic] = ACTIONS(5626),
    [anon_sym__Noreturn] = ACTIONS(5626),
    [anon_sym_noreturn] = ACTIONS(5626),
    [anon_sym_mutable] = ACTIONS(5626),
    [anon_sym_constinit] = ACTIONS(5626),
    [anon_sym_consteval] = ACTIONS(5626),
    [anon_sym_PROGMEM] = ACTIONS(5626),
    [aux_sym_primitive_type_token1] = ACTIONS(5626),
    [anon_sym_byte] = ACTIONS(5626),
    [anon_sym_word] = ACTIONS(5626),
    [anon_sym_COLON] = ACTIONS(5626),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_LT_EQ_GT] = ACTIONS(5628),
    [anon_sym_or] = ACTIONS(5626),
    [anon_sym_and] = ACTIONS(5626),
    [anon_sym_bitor] = ACTIONS(5626),
    [anon_sym_xor] = ACTIONS(5626),
    [anon_sym_bitand] = ACTIONS(5626),
    [anon_sym_not_eq] = ACTIONS(5626),
    [anon_sym_DASH_DASH] = ACTIONS(5628),
    [anon_sym_PLUS_PLUS] = ACTIONS(5628),
    [anon_sym_DOT] = ACTIONS(5626),
    [anon_sym_DOT_STAR] = ACTIONS(5628),
    [anon_sym_DASH_GT] = ACTIONS(5628),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5626),
    [anon_sym_decltype] = ACTIONS(5626),
    [anon_sym_final] = ACTIONS(5626),
    [anon_sym_override] = ACTIONS(5626),
    [anon_sym_requires] = ACTIONS(5626),
  },
  [2238] = {
    [sym__declaration_modifiers] = STATE(4180),
    [sym_attribute_specifier] = STATE(4180),
    [sym_attribute_declaration] = STATE(4180),
    [sym_ms_declspec_modifier] = STATE(4180),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7179),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(4180),
    [sym_type_qualifier] = STATE(4180),
    [sym_decltype] = STATE(9504),
    [sym_virtual] = STATE(4180),
    [sym_alignas_specifier] = STATE(4180),
    [sym_explicit_function_specifier] = STATE(4180),
    [sym_operator_cast] = STATE(7495),
    [sym__constructor_specifiers] = STATE(4180),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(9504),
    [sym_template_function] = STATE(7008),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6421),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_operator_cast_identifier] = STATE(7495),
    [sym_operator_name] = STATE(7008),
    [aux_sym_operator_cast_definition_repeat1] = STATE(4180),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(5449),
    [anon_sym_extern] = ACTIONS(5451),
    [anon_sym___attribute__] = ACTIONS(5453),
    [anon_sym_COLON_COLON] = ACTIONS(5455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5457),
    [anon_sym___declspec] = ACTIONS(5459),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(5451),
    [anon_sym_register] = ACTIONS(5451),
    [anon_sym_inline] = ACTIONS(5451),
    [anon_sym___inline] = ACTIONS(5451),
    [anon_sym___inline__] = ACTIONS(5451),
    [anon_sym___forceinline] = ACTIONS(5451),
    [anon_sym_thread_local] = ACTIONS(5451),
    [anon_sym___thread] = ACTIONS(5451),
    [anon_sym_const] = ACTIONS(5449),
    [anon_sym_constexpr] = ACTIONS(5449),
    [anon_sym_volatile] = ACTIONS(5449),
    [anon_sym_restrict] = ACTIONS(5449),
    [anon_sym___restrict__] = ACTIONS(5449),
    [anon_sym__Atomic] = ACTIONS(5449),
    [anon_sym__Noreturn] = ACTIONS(5449),
    [anon_sym_noreturn] = ACTIONS(5449),
    [anon_sym_mutable] = ACTIONS(5449),
    [anon_sym_constinit] = ACTIONS(5449),
    [anon_sym_consteval] = ACTIONS(5449),
    [anon_sym_PROGMEM] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_virtual] = ACTIONS(5461),
    [anon_sym_alignas] = ACTIONS(5463),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(133),
  },
  [2239] = {
    [sym__declaration_modifiers] = STATE(4180),
    [sym_attribute_specifier] = STATE(4180),
    [sym_attribute_declaration] = STATE(4180),
    [sym_ms_declspec_modifier] = STATE(4180),
    [sym_ms_based_modifier] = STATE(9597),
    [sym__declarator] = STATE(7451),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_function_declarator] = STATE(7090),
    [sym_array_declarator] = STATE(7008),
    [sym_storage_class_specifier] = STATE(4180),
    [sym_type_qualifier] = STATE(4180),
    [sym_decltype] = STATE(9504),
    [sym_virtual] = STATE(4180),
    [sym_alignas_specifier] = STATE(4180),
    [sym_explicit_function_specifier] = STATE(4180),
    [sym_operator_cast] = STATE(7544),
    [sym__constructor_specifiers] = STATE(4180),
    [sym_reference_declarator] = STATE(7008),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym_template_type] = STATE(9504),
    [sym_template_function] = STATE(7008),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6421),
    [sym_qualified_identifier] = STATE(7008),
    [sym_qualified_operator_cast_identifier] = STATE(7544),
    [sym_operator_name] = STATE(7008),
    [aux_sym_operator_cast_definition_repeat1] = STATE(4180),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(5449),
    [anon_sym_extern] = ACTIONS(5451),
    [anon_sym___attribute__] = ACTIONS(5453),
    [anon_sym_COLON_COLON] = ACTIONS(5455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5457),
    [anon_sym___declspec] = ACTIONS(5459),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(5451),
    [anon_sym_register] = ACTIONS(5451),
    [anon_sym_inline] = ACTIONS(5451),
    [anon_sym___inline] = ACTIONS(5451),
    [anon_sym___inline__] = ACTIONS(5451),
    [anon_sym___forceinline] = ACTIONS(5451),
    [anon_sym_thread_local] = ACTIONS(5451),
    [anon_sym___thread] = ACTIONS(5451),
    [anon_sym_const] = ACTIONS(5449),
    [anon_sym_constexpr] = ACTIONS(5449),
    [anon_sym_volatile] = ACTIONS(5449),
    [anon_sym_restrict] = ACTIONS(5449),
    [anon_sym___restrict__] = ACTIONS(5449),
    [anon_sym__Atomic] = ACTIONS(5449),
    [anon_sym__Noreturn] = ACTIONS(5449),
    [anon_sym_noreturn] = ACTIONS(5449),
    [anon_sym_mutable] = ACTIONS(5449),
    [anon_sym_constinit] = ACTIONS(5449),
    [anon_sym_consteval] = ACTIONS(5449),
    [anon_sym_PROGMEM] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_virtual] = ACTIONS(5461),
    [anon_sym_alignas] = ACTIONS(5463),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(133),
  },
  [2240] = {
    [sym_identifier] = ACTIONS(3178),
    [aux_sym_preproc_def_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3178),
    [aux_sym_preproc_else_token1] = ACTIONS(3178),
    [aux_sym_preproc_elif_token1] = ACTIONS(3178),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3178),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3178),
    [sym_preproc_directive] = ACTIONS(3178),
    [anon_sym_LPAREN2] = ACTIONS(3180),
    [anon_sym_TILDE] = ACTIONS(3180),
    [anon_sym_STAR] = ACTIONS(3180),
    [anon_sym_AMP_AMP] = ACTIONS(3180),
    [anon_sym_AMP] = ACTIONS(3178),
    [anon_sym___extension__] = ACTIONS(3178),
    [anon_sym_typedef] = ACTIONS(3178),
    [anon_sym_extern] = ACTIONS(3178),
    [anon_sym___attribute__] = ACTIONS(3178),
    [anon_sym_COLON_COLON] = ACTIONS(3180),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3180),
    [anon_sym___declspec] = ACTIONS(3178),
    [anon_sym___based] = ACTIONS(3178),
    [anon_sym_signed] = ACTIONS(3178),
    [anon_sym_unsigned] = ACTIONS(3178),
    [anon_sym_long] = ACTIONS(3178),
    [anon_sym_short] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_static] = ACTIONS(3178),
    [anon_sym_register] = ACTIONS(3178),
    [anon_sym_inline] = ACTIONS(3178),
    [anon_sym___inline] = ACTIONS(3178),
    [anon_sym___inline__] = ACTIONS(3178),
    [anon_sym___forceinline] = ACTIONS(3178),
    [anon_sym_thread_local] = ACTIONS(3178),
    [anon_sym___thread] = ACTIONS(3178),
    [anon_sym_const] = ACTIONS(3178),
    [anon_sym_constexpr] = ACTIONS(3178),
    [anon_sym_volatile] = ACTIONS(3178),
    [anon_sym_restrict] = ACTIONS(3178),
    [anon_sym___restrict__] = ACTIONS(3178),
    [anon_sym__Atomic] = ACTIONS(3178),
    [anon_sym__Noreturn] = ACTIONS(3178),
    [anon_sym_noreturn] = ACTIONS(3178),
    [anon_sym_mutable] = ACTIONS(3178),
    [anon_sym_constinit] = ACTIONS(3178),
    [anon_sym_consteval] = ACTIONS(3178),
    [anon_sym_PROGMEM] = ACTIONS(3178),
    [aux_sym_primitive_type_token1] = ACTIONS(3178),
    [anon_sym_byte] = ACTIONS(3178),
    [anon_sym_word] = ACTIONS(3178),
    [anon_sym_enum] = ACTIONS(3178),
    [anon_sym_class] = ACTIONS(3178),
    [anon_sym_struct] = ACTIONS(3178),
    [anon_sym_union] = ACTIONS(3178),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3178),
    [anon_sym_decltype] = ACTIONS(3178),
    [anon_sym_virtual] = ACTIONS(3178),
    [anon_sym_alignas] = ACTIONS(3178),
    [anon_sym_explicit] = ACTIONS(3178),
    [anon_sym_typename] = ACTIONS(3178),
    [anon_sym_template] = ACTIONS(3178),
    [anon_sym_operator] = ACTIONS(3178),
    [anon_sym_friend] = ACTIONS(3178),
    [anon_sym_public] = ACTIONS(3178),
    [anon_sym_private] = ACTIONS(3178),
    [anon_sym_protected] = ACTIONS(3178),
    [anon_sym_using] = ACTIONS(3178),
    [anon_sym_static_assert] = ACTIONS(3178),
  },
  [2241] = {
    [sym_identifier] = ACTIONS(3415),
    [aux_sym_preproc_def_token1] = ACTIONS(3415),
    [aux_sym_preproc_if_token1] = ACTIONS(3415),
    [aux_sym_preproc_if_token2] = ACTIONS(3415),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3415),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3415),
    [aux_sym_preproc_else_token1] = ACTIONS(3415),
    [aux_sym_preproc_elif_token1] = ACTIONS(3415),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3415),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3415),
    [sym_preproc_directive] = ACTIONS(3415),
    [anon_sym_LPAREN2] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3417),
    [anon_sym_STAR] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3415),
    [anon_sym___extension__] = ACTIONS(3415),
    [anon_sym_typedef] = ACTIONS(3415),
    [anon_sym_extern] = ACTIONS(3415),
    [anon_sym___attribute__] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3417),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3417),
    [anon_sym___declspec] = ACTIONS(3415),
    [anon_sym___based] = ACTIONS(3415),
    [anon_sym_signed] = ACTIONS(3415),
    [anon_sym_unsigned] = ACTIONS(3415),
    [anon_sym_long] = ACTIONS(3415),
    [anon_sym_short] = ACTIONS(3415),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_static] = ACTIONS(3415),
    [anon_sym_register] = ACTIONS(3415),
    [anon_sym_inline] = ACTIONS(3415),
    [anon_sym___inline] = ACTIONS(3415),
    [anon_sym___inline__] = ACTIONS(3415),
    [anon_sym___forceinline] = ACTIONS(3415),
    [anon_sym_thread_local] = ACTIONS(3415),
    [anon_sym___thread] = ACTIONS(3415),
    [anon_sym_const] = ACTIONS(3415),
    [anon_sym_constexpr] = ACTIONS(3415),
    [anon_sym_volatile] = ACTIONS(3415),
    [anon_sym_restrict] = ACTIONS(3415),
    [anon_sym___restrict__] = ACTIONS(3415),
    [anon_sym__Atomic] = ACTIONS(3415),
    [anon_sym__Noreturn] = ACTIONS(3415),
    [anon_sym_noreturn] = ACTIONS(3415),
    [anon_sym_mutable] = ACTIONS(3415),
    [anon_sym_constinit] = ACTIONS(3415),
    [anon_sym_consteval] = ACTIONS(3415),
    [anon_sym_PROGMEM] = ACTIONS(3415),
    [aux_sym_primitive_type_token1] = ACTIONS(3415),
    [anon_sym_byte] = ACTIONS(3415),
    [anon_sym_word] = ACTIONS(3415),
    [anon_sym_enum] = ACTIONS(3415),
    [anon_sym_class] = ACTIONS(3415),
    [anon_sym_struct] = ACTIONS(3415),
    [anon_sym_union] = ACTIONS(3415),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3415),
    [anon_sym_decltype] = ACTIONS(3415),
    [anon_sym_virtual] = ACTIONS(3415),
    [anon_sym_alignas] = ACTIONS(3415),
    [anon_sym_explicit] = ACTIONS(3415),
    [anon_sym_typename] = ACTIONS(3415),
    [anon_sym_template] = ACTIONS(3415),
    [anon_sym_operator] = ACTIONS(3415),
    [anon_sym_friend] = ACTIONS(3415),
    [anon_sym_public] = ACTIONS(3415),
    [anon_sym_private] = ACTIONS(3415),
    [anon_sym_protected] = ACTIONS(3415),
    [anon_sym_using] = ACTIONS(3415),
    [anon_sym_static_assert] = ACTIONS(3415),
  },
  [2242] = {
    [sym_identifier] = ACTIONS(3387),
    [aux_sym_preproc_def_token1] = ACTIONS(3387),
    [aux_sym_preproc_if_token1] = ACTIONS(3387),
    [aux_sym_preproc_if_token2] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3387),
    [aux_sym_preproc_else_token1] = ACTIONS(3387),
    [aux_sym_preproc_elif_token1] = ACTIONS(3387),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3387),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3387),
    [sym_preproc_directive] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_STAR] = ACTIONS(3389),
    [anon_sym_AMP_AMP] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym___extension__] = ACTIONS(3387),
    [anon_sym_typedef] = ACTIONS(3387),
    [anon_sym_extern] = ACTIONS(3387),
    [anon_sym___attribute__] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3389),
    [anon_sym___declspec] = ACTIONS(3387),
    [anon_sym___based] = ACTIONS(3387),
    [anon_sym_signed] = ACTIONS(3387),
    [anon_sym_unsigned] = ACTIONS(3387),
    [anon_sym_long] = ACTIONS(3387),
    [anon_sym_short] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_register] = ACTIONS(3387),
    [anon_sym_inline] = ACTIONS(3387),
    [anon_sym___inline] = ACTIONS(3387),
    [anon_sym___inline__] = ACTIONS(3387),
    [anon_sym___forceinline] = ACTIONS(3387),
    [anon_sym_thread_local] = ACTIONS(3387),
    [anon_sym___thread] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_constexpr] = ACTIONS(3387),
    [anon_sym_volatile] = ACTIONS(3387),
    [anon_sym_restrict] = ACTIONS(3387),
    [anon_sym___restrict__] = ACTIONS(3387),
    [anon_sym__Atomic] = ACTIONS(3387),
    [anon_sym__Noreturn] = ACTIONS(3387),
    [anon_sym_noreturn] = ACTIONS(3387),
    [anon_sym_mutable] = ACTIONS(3387),
    [anon_sym_constinit] = ACTIONS(3387),
    [anon_sym_consteval] = ACTIONS(3387),
    [anon_sym_PROGMEM] = ACTIONS(3387),
    [aux_sym_primitive_type_token1] = ACTIONS(3387),
    [anon_sym_byte] = ACTIONS(3387),
    [anon_sym_word] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [anon_sym_class] = ACTIONS(3387),
    [anon_sym_struct] = ACTIONS(3387),
    [anon_sym_union] = ACTIONS(3387),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3387),
    [anon_sym_decltype] = ACTIONS(3387),
    [anon_sym_virtual] = ACTIONS(3387),
    [anon_sym_alignas] = ACTIONS(3387),
    [anon_sym_explicit] = ACTIONS(3387),
    [anon_sym_typename] = ACTIONS(3387),
    [anon_sym_template] = ACTIONS(3387),
    [anon_sym_operator] = ACTIONS(3387),
    [anon_sym_friend] = ACTIONS(3387),
    [anon_sym_public] = ACTIONS(3387),
    [anon_sym_private] = ACTIONS(3387),
    [anon_sym_protected] = ACTIONS(3387),
    [anon_sym_using] = ACTIONS(3387),
    [anon_sym_static_assert] = ACTIONS(3387),
  },
  [2243] = {
    [sym_identifier] = ACTIONS(3419),
    [aux_sym_preproc_def_token1] = ACTIONS(3419),
    [aux_sym_preproc_if_token1] = ACTIONS(3419),
    [aux_sym_preproc_if_token2] = ACTIONS(3419),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3419),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3419),
    [aux_sym_preproc_else_token1] = ACTIONS(3419),
    [aux_sym_preproc_elif_token1] = ACTIONS(3419),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3419),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3419),
    [sym_preproc_directive] = ACTIONS(3419),
    [anon_sym_LPAREN2] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym___extension__] = ACTIONS(3419),
    [anon_sym_typedef] = ACTIONS(3419),
    [anon_sym_extern] = ACTIONS(3419),
    [anon_sym___attribute__] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3421),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3421),
    [anon_sym___declspec] = ACTIONS(3419),
    [anon_sym___based] = ACTIONS(3419),
    [anon_sym_signed] = ACTIONS(3419),
    [anon_sym_unsigned] = ACTIONS(3419),
    [anon_sym_long] = ACTIONS(3419),
    [anon_sym_short] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_register] = ACTIONS(3419),
    [anon_sym_inline] = ACTIONS(3419),
    [anon_sym___inline] = ACTIONS(3419),
    [anon_sym___inline__] = ACTIONS(3419),
    [anon_sym___forceinline] = ACTIONS(3419),
    [anon_sym_thread_local] = ACTIONS(3419),
    [anon_sym___thread] = ACTIONS(3419),
    [anon_sym_const] = ACTIONS(3419),
    [anon_sym_constexpr] = ACTIONS(3419),
    [anon_sym_volatile] = ACTIONS(3419),
    [anon_sym_restrict] = ACTIONS(3419),
    [anon_sym___restrict__] = ACTIONS(3419),
    [anon_sym__Atomic] = ACTIONS(3419),
    [anon_sym__Noreturn] = ACTIONS(3419),
    [anon_sym_noreturn] = ACTIONS(3419),
    [anon_sym_mutable] = ACTIONS(3419),
    [anon_sym_constinit] = ACTIONS(3419),
    [anon_sym_consteval] = ACTIONS(3419),
    [anon_sym_PROGMEM] = ACTIONS(3419),
    [aux_sym_primitive_type_token1] = ACTIONS(3419),
    [anon_sym_byte] = ACTIONS(3419),
    [anon_sym_word] = ACTIONS(3419),
    [anon_sym_enum] = ACTIONS(3419),
    [anon_sym_class] = ACTIONS(3419),
    [anon_sym_struct] = ACTIONS(3419),
    [anon_sym_union] = ACTIONS(3419),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3419),
    [anon_sym_decltype] = ACTIONS(3419),
    [anon_sym_virtual] = ACTIONS(3419),
    [anon_sym_alignas] = ACTIONS(3419),
    [anon_sym_explicit] = ACTIONS(3419),
    [anon_sym_typename] = ACTIONS(3419),
    [anon_sym_template] = ACTIONS(3419),
    [anon_sym_operator] = ACTIONS(3419),
    [anon_sym_friend] = ACTIONS(3419),
    [anon_sym_public] = ACTIONS(3419),
    [anon_sym_private] = ACTIONS(3419),
    [anon_sym_protected] = ACTIONS(3419),
    [anon_sym_using] = ACTIONS(3419),
    [anon_sym_static_assert] = ACTIONS(3419),
  },
  [2244] = {
    [sym_identifier] = ACTIONS(5630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5632),
    [anon_sym_COMMA] = ACTIONS(5632),
    [anon_sym_RPAREN] = ACTIONS(5632),
    [anon_sym_LPAREN2] = ACTIONS(5632),
    [anon_sym_DASH] = ACTIONS(5630),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_STAR] = ACTIONS(5632),
    [anon_sym_SLASH] = ACTIONS(5630),
    [anon_sym_PERCENT] = ACTIONS(5632),
    [anon_sym_PIPE_PIPE] = ACTIONS(5632),
    [anon_sym_AMP_AMP] = ACTIONS(5632),
    [anon_sym_PIPE] = ACTIONS(5630),
    [anon_sym_CARET] = ACTIONS(5632),
    [anon_sym_AMP] = ACTIONS(5630),
    [anon_sym_EQ_EQ] = ACTIONS(5632),
    [anon_sym_BANG_EQ] = ACTIONS(5632),
    [anon_sym_GT] = ACTIONS(5630),
    [anon_sym_GT_EQ] = ACTIONS(5632),
    [anon_sym_LT_EQ] = ACTIONS(5630),
    [anon_sym_LT] = ACTIONS(5630),
    [anon_sym_LT_LT] = ACTIONS(5632),
    [anon_sym_GT_GT] = ACTIONS(5632),
    [anon_sym_SEMI] = ACTIONS(5632),
    [anon_sym___extension__] = ACTIONS(5630),
    [anon_sym___attribute__] = ACTIONS(5630),
    [anon_sym___based] = ACTIONS(5630),
    [anon_sym_LBRACE] = ACTIONS(5632),
    [anon_sym_RBRACE] = ACTIONS(5632),
    [anon_sym_signed] = ACTIONS(5630),
    [anon_sym_unsigned] = ACTIONS(5630),
    [anon_sym_long] = ACTIONS(5630),
    [anon_sym_short] = ACTIONS(5630),
    [anon_sym_LBRACK] = ACTIONS(5632),
    [anon_sym_RBRACK] = ACTIONS(5632),
    [anon_sym_const] = ACTIONS(5630),
    [anon_sym_constexpr] = ACTIONS(5630),
    [anon_sym_volatile] = ACTIONS(5630),
    [anon_sym_restrict] = ACTIONS(5630),
    [anon_sym___restrict__] = ACTIONS(5630),
    [anon_sym__Atomic] = ACTIONS(5630),
    [anon_sym__Noreturn] = ACTIONS(5630),
    [anon_sym_noreturn] = ACTIONS(5630),
    [anon_sym_mutable] = ACTIONS(5630),
    [anon_sym_constinit] = ACTIONS(5630),
    [anon_sym_consteval] = ACTIONS(5630),
    [anon_sym_PROGMEM] = ACTIONS(5630),
    [aux_sym_primitive_type_token1] = ACTIONS(5630),
    [anon_sym_byte] = ACTIONS(5630),
    [anon_sym_word] = ACTIONS(5630),
    [anon_sym_COLON] = ACTIONS(5632),
    [anon_sym_QMARK] = ACTIONS(5632),
    [anon_sym_LT_EQ_GT] = ACTIONS(5632),
    [anon_sym_or] = ACTIONS(5630),
    [anon_sym_and] = ACTIONS(5630),
    [anon_sym_bitor] = ACTIONS(5630),
    [anon_sym_xor] = ACTIONS(5630),
    [anon_sym_bitand] = ACTIONS(5630),
    [anon_sym_not_eq] = ACTIONS(5630),
    [anon_sym_DASH_DASH] = ACTIONS(5632),
    [anon_sym_PLUS_PLUS] = ACTIONS(5632),
    [anon_sym_DOT] = ACTIONS(5630),
    [anon_sym_DOT_STAR] = ACTIONS(5632),
    [anon_sym_DASH_GT] = ACTIONS(5632),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5630),
    [anon_sym_decltype] = ACTIONS(5630),
    [anon_sym_final] = ACTIONS(5630),
    [anon_sym_override] = ACTIONS(5630),
    [anon_sym_requires] = ACTIONS(5630),
  },
  [2245] = {
    [sym_identifier] = ACTIONS(5634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5636),
    [anon_sym_COMMA] = ACTIONS(5636),
    [anon_sym_RPAREN] = ACTIONS(5636),
    [anon_sym_LPAREN2] = ACTIONS(5636),
    [anon_sym_DASH] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(5634),
    [anon_sym_STAR] = ACTIONS(5636),
    [anon_sym_SLASH] = ACTIONS(5634),
    [anon_sym_PERCENT] = ACTIONS(5636),
    [anon_sym_PIPE_PIPE] = ACTIONS(5636),
    [anon_sym_AMP_AMP] = ACTIONS(5636),
    [anon_sym_PIPE] = ACTIONS(5634),
    [anon_sym_CARET] = ACTIONS(5636),
    [anon_sym_AMP] = ACTIONS(5634),
    [anon_sym_EQ_EQ] = ACTIONS(5636),
    [anon_sym_BANG_EQ] = ACTIONS(5636),
    [anon_sym_GT] = ACTIONS(5634),
    [anon_sym_GT_EQ] = ACTIONS(5636),
    [anon_sym_LT_EQ] = ACTIONS(5634),
    [anon_sym_LT] = ACTIONS(5634),
    [anon_sym_LT_LT] = ACTIONS(5636),
    [anon_sym_GT_GT] = ACTIONS(5636),
    [anon_sym_SEMI] = ACTIONS(5636),
    [anon_sym___extension__] = ACTIONS(5634),
    [anon_sym___attribute__] = ACTIONS(5634),
    [anon_sym___based] = ACTIONS(5634),
    [anon_sym_LBRACE] = ACTIONS(5636),
    [anon_sym_RBRACE] = ACTIONS(5636),
    [anon_sym_signed] = ACTIONS(5634),
    [anon_sym_unsigned] = ACTIONS(5634),
    [anon_sym_long] = ACTIONS(5634),
    [anon_sym_short] = ACTIONS(5634),
    [anon_sym_LBRACK] = ACTIONS(5636),
    [anon_sym_RBRACK] = ACTIONS(5636),
    [anon_sym_const] = ACTIONS(5634),
    [anon_sym_constexpr] = ACTIONS(5634),
    [anon_sym_volatile] = ACTIONS(5634),
    [anon_sym_restrict] = ACTIONS(5634),
    [anon_sym___restrict__] = ACTIONS(5634),
    [anon_sym__Atomic] = ACTIONS(5634),
    [anon_sym__Noreturn] = ACTIONS(5634),
    [anon_sym_noreturn] = ACTIONS(5634),
    [anon_sym_mutable] = ACTIONS(5634),
    [anon_sym_constinit] = ACTIONS(5634),
    [anon_sym_consteval] = ACTIONS(5634),
    [anon_sym_PROGMEM] = ACTIONS(5634),
    [aux_sym_primitive_type_token1] = ACTIONS(5634),
    [anon_sym_byte] = ACTIONS(5634),
    [anon_sym_word] = ACTIONS(5634),
    [anon_sym_COLON] = ACTIONS(5636),
    [anon_sym_QMARK] = ACTIONS(5636),
    [anon_sym_LT_EQ_GT] = ACTIONS(5636),
    [anon_sym_or] = ACTIONS(5634),
    [anon_sym_and] = ACTIONS(5634),
    [anon_sym_bitor] = ACTIONS(5634),
    [anon_sym_xor] = ACTIONS(5634),
    [anon_sym_bitand] = ACTIONS(5634),
    [anon_sym_not_eq] = ACTIONS(5634),
    [anon_sym_DASH_DASH] = ACTIONS(5636),
    [anon_sym_PLUS_PLUS] = ACTIONS(5636),
    [anon_sym_DOT] = ACTIONS(5634),
    [anon_sym_DOT_STAR] = ACTIONS(5636),
    [anon_sym_DASH_GT] = ACTIONS(5636),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5634),
    [anon_sym_decltype] = ACTIONS(5634),
    [anon_sym_final] = ACTIONS(5634),
    [anon_sym_override] = ACTIONS(5634),
    [anon_sym_requires] = ACTIONS(5634),
  },
  [2246] = {
    [sym_identifier] = ACTIONS(5638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5640),
    [anon_sym_COMMA] = ACTIONS(5640),
    [anon_sym_RPAREN] = ACTIONS(5640),
    [anon_sym_LPAREN2] = ACTIONS(5640),
    [anon_sym_DASH] = ACTIONS(5638),
    [anon_sym_PLUS] = ACTIONS(5638),
    [anon_sym_STAR] = ACTIONS(5640),
    [anon_sym_SLASH] = ACTIONS(5638),
    [anon_sym_PERCENT] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE] = ACTIONS(5638),
    [anon_sym_CARET] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5638),
    [anon_sym_EQ_EQ] = ACTIONS(5640),
    [anon_sym_BANG_EQ] = ACTIONS(5640),
    [anon_sym_GT] = ACTIONS(5638),
    [anon_sym_GT_EQ] = ACTIONS(5640),
    [anon_sym_LT_EQ] = ACTIONS(5638),
    [anon_sym_LT] = ACTIONS(5638),
    [anon_sym_LT_LT] = ACTIONS(5640),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5640),
    [anon_sym___extension__] = ACTIONS(5638),
    [anon_sym___attribute__] = ACTIONS(5638),
    [anon_sym___based] = ACTIONS(5638),
    [anon_sym_LBRACE] = ACTIONS(5640),
    [anon_sym_RBRACE] = ACTIONS(5640),
    [anon_sym_signed] = ACTIONS(5638),
    [anon_sym_unsigned] = ACTIONS(5638),
    [anon_sym_long] = ACTIONS(5638),
    [anon_sym_short] = ACTIONS(5638),
    [anon_sym_LBRACK] = ACTIONS(5640),
    [anon_sym_RBRACK] = ACTIONS(5640),
    [anon_sym_const] = ACTIONS(5638),
    [anon_sym_constexpr] = ACTIONS(5638),
    [anon_sym_volatile] = ACTIONS(5638),
    [anon_sym_restrict] = ACTIONS(5638),
    [anon_sym___restrict__] = ACTIONS(5638),
    [anon_sym__Atomic] = ACTIONS(5638),
    [anon_sym__Noreturn] = ACTIONS(5638),
    [anon_sym_noreturn] = ACTIONS(5638),
    [anon_sym_mutable] = ACTIONS(5638),
    [anon_sym_constinit] = ACTIONS(5638),
    [anon_sym_consteval] = ACTIONS(5638),
    [anon_sym_PROGMEM] = ACTIONS(5638),
    [aux_sym_primitive_type_token1] = ACTIONS(5638),
    [anon_sym_byte] = ACTIONS(5638),
    [anon_sym_word] = ACTIONS(5638),
    [anon_sym_COLON] = ACTIONS(5640),
    [anon_sym_QMARK] = ACTIONS(5640),
    [anon_sym_LT_EQ_GT] = ACTIONS(5640),
    [anon_sym_or] = ACTIONS(5638),
    [anon_sym_and] = ACTIONS(5638),
    [anon_sym_bitor] = ACTIONS(5638),
    [anon_sym_xor] = ACTIONS(5638),
    [anon_sym_bitand] = ACTIONS(5638),
    [anon_sym_not_eq] = ACTIONS(5638),
    [anon_sym_DASH_DASH] = ACTIONS(5640),
    [anon_sym_PLUS_PLUS] = ACTIONS(5640),
    [anon_sym_DOT] = ACTIONS(5638),
    [anon_sym_DOT_STAR] = ACTIONS(5640),
    [anon_sym_DASH_GT] = ACTIONS(5640),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5638),
    [anon_sym_decltype] = ACTIONS(5638),
    [anon_sym_final] = ACTIONS(5638),
    [anon_sym_override] = ACTIONS(5638),
    [anon_sym_requires] = ACTIONS(5638),
  },
  [2247] = {
    [sym_identifier] = ACTIONS(5642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5644),
    [anon_sym_COMMA] = ACTIONS(5644),
    [anon_sym_RPAREN] = ACTIONS(5644),
    [anon_sym_LPAREN2] = ACTIONS(5644),
    [anon_sym_DASH] = ACTIONS(5642),
    [anon_sym_PLUS] = ACTIONS(5642),
    [anon_sym_STAR] = ACTIONS(5644),
    [anon_sym_SLASH] = ACTIONS(5642),
    [anon_sym_PERCENT] = ACTIONS(5644),
    [anon_sym_PIPE_PIPE] = ACTIONS(5644),
    [anon_sym_AMP_AMP] = ACTIONS(5644),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_CARET] = ACTIONS(5644),
    [anon_sym_AMP] = ACTIONS(5642),
    [anon_sym_EQ_EQ] = ACTIONS(5644),
    [anon_sym_BANG_EQ] = ACTIONS(5644),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_EQ] = ACTIONS(5644),
    [anon_sym_LT_EQ] = ACTIONS(5642),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_LT_LT] = ACTIONS(5644),
    [anon_sym_GT_GT] = ACTIONS(5644),
    [anon_sym_SEMI] = ACTIONS(5644),
    [anon_sym___extension__] = ACTIONS(5642),
    [anon_sym___attribute__] = ACTIONS(5642),
    [anon_sym___based] = ACTIONS(5642),
    [anon_sym_LBRACE] = ACTIONS(5644),
    [anon_sym_RBRACE] = ACTIONS(5644),
    [anon_sym_signed] = ACTIONS(5642),
    [anon_sym_unsigned] = ACTIONS(5642),
    [anon_sym_long] = ACTIONS(5642),
    [anon_sym_short] = ACTIONS(5642),
    [anon_sym_LBRACK] = ACTIONS(5644),
    [anon_sym_RBRACK] = ACTIONS(5644),
    [anon_sym_const] = ACTIONS(5642),
    [anon_sym_constexpr] = ACTIONS(5642),
    [anon_sym_volatile] = ACTIONS(5642),
    [anon_sym_restrict] = ACTIONS(5642),
    [anon_sym___restrict__] = ACTIONS(5642),
    [anon_sym__Atomic] = ACTIONS(5642),
    [anon_sym__Noreturn] = ACTIONS(5642),
    [anon_sym_noreturn] = ACTIONS(5642),
    [anon_sym_mutable] = ACTIONS(5642),
    [anon_sym_constinit] = ACTIONS(5642),
    [anon_sym_consteval] = ACTIONS(5642),
    [anon_sym_PROGMEM] = ACTIONS(5642),
    [aux_sym_primitive_type_token1] = ACTIONS(5642),
    [anon_sym_byte] = ACTIONS(5642),
    [anon_sym_word] = ACTIONS(5642),
    [anon_sym_COLON] = ACTIONS(5644),
    [anon_sym_QMARK] = ACTIONS(5644),
    [anon_sym_LT_EQ_GT] = ACTIONS(5644),
    [anon_sym_or] = ACTIONS(5642),
    [anon_sym_and] = ACTIONS(5642),
    [anon_sym_bitor] = ACTIONS(5642),
    [anon_sym_xor] = ACTIONS(5642),
    [anon_sym_bitand] = ACTIONS(5642),
    [anon_sym_not_eq] = ACTIONS(5642),
    [anon_sym_DASH_DASH] = ACTIONS(5644),
    [anon_sym_PLUS_PLUS] = ACTIONS(5644),
    [anon_sym_DOT] = ACTIONS(5642),
    [anon_sym_DOT_STAR] = ACTIONS(5644),
    [anon_sym_DASH_GT] = ACTIONS(5644),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5642),
    [anon_sym_decltype] = ACTIONS(5642),
    [anon_sym_final] = ACTIONS(5642),
    [anon_sym_override] = ACTIONS(5642),
    [anon_sym_requires] = ACTIONS(5642),
  },
  [2248] = {
    [sym_identifier] = ACTIONS(5646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5648),
    [anon_sym_COMMA] = ACTIONS(5648),
    [anon_sym_RPAREN] = ACTIONS(5648),
    [anon_sym_LPAREN2] = ACTIONS(5648),
    [anon_sym_DASH] = ACTIONS(5646),
    [anon_sym_PLUS] = ACTIONS(5646),
    [anon_sym_STAR] = ACTIONS(5648),
    [anon_sym_SLASH] = ACTIONS(5646),
    [anon_sym_PERCENT] = ACTIONS(5648),
    [anon_sym_PIPE_PIPE] = ACTIONS(5648),
    [anon_sym_AMP_AMP] = ACTIONS(5648),
    [anon_sym_PIPE] = ACTIONS(5646),
    [anon_sym_CARET] = ACTIONS(5648),
    [anon_sym_AMP] = ACTIONS(5646),
    [anon_sym_EQ_EQ] = ACTIONS(5648),
    [anon_sym_BANG_EQ] = ACTIONS(5648),
    [anon_sym_GT] = ACTIONS(5646),
    [anon_sym_GT_EQ] = ACTIONS(5648),
    [anon_sym_LT_EQ] = ACTIONS(5646),
    [anon_sym_LT] = ACTIONS(5646),
    [anon_sym_LT_LT] = ACTIONS(5648),
    [anon_sym_GT_GT] = ACTIONS(5648),
    [anon_sym_SEMI] = ACTIONS(5648),
    [anon_sym___extension__] = ACTIONS(5646),
    [anon_sym___attribute__] = ACTIONS(5646),
    [anon_sym___based] = ACTIONS(5646),
    [anon_sym_LBRACE] = ACTIONS(5648),
    [anon_sym_RBRACE] = ACTIONS(5648),
    [anon_sym_signed] = ACTIONS(5646),
    [anon_sym_unsigned] = ACTIONS(5646),
    [anon_sym_long] = ACTIONS(5646),
    [anon_sym_short] = ACTIONS(5646),
    [anon_sym_LBRACK] = ACTIONS(5648),
    [anon_sym_RBRACK] = ACTIONS(5648),
    [anon_sym_const] = ACTIONS(5646),
    [anon_sym_constexpr] = ACTIONS(5646),
    [anon_sym_volatile] = ACTIONS(5646),
    [anon_sym_restrict] = ACTIONS(5646),
    [anon_sym___restrict__] = ACTIONS(5646),
    [anon_sym__Atomic] = ACTIONS(5646),
    [anon_sym__Noreturn] = ACTIONS(5646),
    [anon_sym_noreturn] = ACTIONS(5646),
    [anon_sym_mutable] = ACTIONS(5646),
    [anon_sym_constinit] = ACTIONS(5646),
    [anon_sym_consteval] = ACTIONS(5646),
    [anon_sym_PROGMEM] = ACTIONS(5646),
    [aux_sym_primitive_type_token1] = ACTIONS(5646),
    [anon_sym_byte] = ACTIONS(5646),
    [anon_sym_word] = ACTIONS(5646),
    [anon_sym_COLON] = ACTIONS(5648),
    [anon_sym_QMARK] = ACTIONS(5648),
    [anon_sym_LT_EQ_GT] = ACTIONS(5648),
    [anon_sym_or] = ACTIONS(5646),
    [anon_sym_and] = ACTIONS(5646),
    [anon_sym_bitor] = ACTIONS(5646),
    [anon_sym_xor] = ACTIONS(5646),
    [anon_sym_bitand] = ACTIONS(5646),
    [anon_sym_not_eq] = ACTIONS(5646),
    [anon_sym_DASH_DASH] = ACTIONS(5648),
    [anon_sym_PLUS_PLUS] = ACTIONS(5648),
    [anon_sym_DOT] = ACTIONS(5646),
    [anon_sym_DOT_STAR] = ACTIONS(5648),
    [anon_sym_DASH_GT] = ACTIONS(5648),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5646),
    [anon_sym_decltype] = ACTIONS(5646),
    [anon_sym_final] = ACTIONS(5646),
    [anon_sym_override] = ACTIONS(5646),
    [anon_sym_requires] = ACTIONS(5646),
  },
  [2249] = {
    [sym_template_argument_list] = STATE(2408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5131),
    [anon_sym_COMMA] = ACTIONS(5131),
    [anon_sym_RPAREN] = ACTIONS(5133),
    [anon_sym_LPAREN2] = ACTIONS(5133),
    [anon_sym_DASH] = ACTIONS(5138),
    [anon_sym_PLUS] = ACTIONS(5138),
    [anon_sym_STAR] = ACTIONS(5140),
    [anon_sym_SLASH] = ACTIONS(5138),
    [anon_sym_PERCENT] = ACTIONS(5138),
    [anon_sym_PIPE_PIPE] = ACTIONS(5131),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5138),
    [anon_sym_CARET] = ACTIONS(5138),
    [anon_sym_AMP] = ACTIONS(5140),
    [anon_sym_EQ_EQ] = ACTIONS(5131),
    [anon_sym_BANG_EQ] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5138),
    [anon_sym_GT_EQ] = ACTIONS(5131),
    [anon_sym_LT_EQ] = ACTIONS(5138),
    [anon_sym_LT] = ACTIONS(5650),
    [anon_sym_LT_LT] = ACTIONS(5138),
    [anon_sym_GT_GT] = ACTIONS(5138),
    [anon_sym___extension__] = ACTIONS(5136),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_LBRACK] = ACTIONS(5133),
    [anon_sym_EQ] = ACTIONS(5138),
    [anon_sym_const] = ACTIONS(5129),
    [anon_sym_constexpr] = ACTIONS(5136),
    [anon_sym_volatile] = ACTIONS(5136),
    [anon_sym_restrict] = ACTIONS(5136),
    [anon_sym___restrict__] = ACTIONS(5136),
    [anon_sym__Atomic] = ACTIONS(5136),
    [anon_sym__Noreturn] = ACTIONS(5136),
    [anon_sym_noreturn] = ACTIONS(5136),
    [anon_sym_mutable] = ACTIONS(5136),
    [anon_sym_constinit] = ACTIONS(5136),
    [anon_sym_consteval] = ACTIONS(5136),
    [anon_sym_PROGMEM] = ACTIONS(5136),
    [anon_sym_QMARK] = ACTIONS(5131),
    [anon_sym_STAR_EQ] = ACTIONS(5131),
    [anon_sym_SLASH_EQ] = ACTIONS(5131),
    [anon_sym_PERCENT_EQ] = ACTIONS(5131),
    [anon_sym_PLUS_EQ] = ACTIONS(5131),
    [anon_sym_DASH_EQ] = ACTIONS(5131),
    [anon_sym_LT_LT_EQ] = ACTIONS(5131),
    [anon_sym_GT_GT_EQ] = ACTIONS(5131),
    [anon_sym_AMP_EQ] = ACTIONS(5131),
    [anon_sym_CARET_EQ] = ACTIONS(5131),
    [anon_sym_PIPE_EQ] = ACTIONS(5131),
    [anon_sym_and_eq] = ACTIONS(5131),
    [anon_sym_or_eq] = ACTIONS(5131),
    [anon_sym_xor_eq] = ACTIONS(5131),
    [anon_sym_LT_EQ_GT] = ACTIONS(5131),
    [anon_sym_or] = ACTIONS(5138),
    [anon_sym_and] = ACTIONS(5138),
    [anon_sym_bitor] = ACTIONS(5131),
    [anon_sym_xor] = ACTIONS(5138),
    [anon_sym_bitand] = ACTIONS(5131),
    [anon_sym_not_eq] = ACTIONS(5131),
    [anon_sym_DASH_DASH] = ACTIONS(5131),
    [anon_sym_PLUS_PLUS] = ACTIONS(5131),
    [anon_sym_DOT] = ACTIONS(5138),
    [anon_sym_DOT_STAR] = ACTIONS(5131),
    [anon_sym_DASH_GT] = ACTIONS(5138),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5136),
    [anon_sym_decltype] = ACTIONS(5136),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5131),
  },
  [2250] = {
    [sym_identifier] = ACTIONS(5638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5640),
    [anon_sym_COMMA] = ACTIONS(5640),
    [anon_sym_RPAREN] = ACTIONS(5640),
    [anon_sym_LPAREN2] = ACTIONS(5640),
    [anon_sym_DASH] = ACTIONS(5638),
    [anon_sym_PLUS] = ACTIONS(5638),
    [anon_sym_STAR] = ACTIONS(5640),
    [anon_sym_SLASH] = ACTIONS(5638),
    [anon_sym_PERCENT] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE] = ACTIONS(5638),
    [anon_sym_CARET] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5638),
    [anon_sym_EQ_EQ] = ACTIONS(5640),
    [anon_sym_BANG_EQ] = ACTIONS(5640),
    [anon_sym_GT] = ACTIONS(5638),
    [anon_sym_GT_EQ] = ACTIONS(5640),
    [anon_sym_LT_EQ] = ACTIONS(5638),
    [anon_sym_LT] = ACTIONS(5638),
    [anon_sym_LT_LT] = ACTIONS(5640),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5640),
    [anon_sym___extension__] = ACTIONS(5638),
    [anon_sym___attribute__] = ACTIONS(5638),
    [anon_sym___based] = ACTIONS(5638),
    [anon_sym_LBRACE] = ACTIONS(5640),
    [anon_sym_RBRACE] = ACTIONS(5640),
    [anon_sym_signed] = ACTIONS(5638),
    [anon_sym_unsigned] = ACTIONS(5638),
    [anon_sym_long] = ACTIONS(5638),
    [anon_sym_short] = ACTIONS(5638),
    [anon_sym_LBRACK] = ACTIONS(5640),
    [anon_sym_RBRACK] = ACTIONS(5640),
    [anon_sym_const] = ACTIONS(5638),
    [anon_sym_constexpr] = ACTIONS(5638),
    [anon_sym_volatile] = ACTIONS(5638),
    [anon_sym_restrict] = ACTIONS(5638),
    [anon_sym___restrict__] = ACTIONS(5638),
    [anon_sym__Atomic] = ACTIONS(5638),
    [anon_sym__Noreturn] = ACTIONS(5638),
    [anon_sym_noreturn] = ACTIONS(5638),
    [anon_sym_mutable] = ACTIONS(5638),
    [anon_sym_constinit] = ACTIONS(5638),
    [anon_sym_consteval] = ACTIONS(5638),
    [anon_sym_PROGMEM] = ACTIONS(5638),
    [aux_sym_primitive_type_token1] = ACTIONS(5638),
    [anon_sym_byte] = ACTIONS(5638),
    [anon_sym_word] = ACTIONS(5638),
    [anon_sym_COLON] = ACTIONS(5640),
    [anon_sym_QMARK] = ACTIONS(5640),
    [anon_sym_LT_EQ_GT] = ACTIONS(5640),
    [anon_sym_or] = ACTIONS(5638),
    [anon_sym_and] = ACTIONS(5638),
    [anon_sym_bitor] = ACTIONS(5638),
    [anon_sym_xor] = ACTIONS(5638),
    [anon_sym_bitand] = ACTIONS(5638),
    [anon_sym_not_eq] = ACTIONS(5638),
    [anon_sym_DASH_DASH] = ACTIONS(5640),
    [anon_sym_PLUS_PLUS] = ACTIONS(5640),
    [anon_sym_DOT] = ACTIONS(5638),
    [anon_sym_DOT_STAR] = ACTIONS(5640),
    [anon_sym_DASH_GT] = ACTIONS(5640),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5638),
    [anon_sym_decltype] = ACTIONS(5638),
    [anon_sym_final] = ACTIONS(5638),
    [anon_sym_override] = ACTIONS(5638),
    [anon_sym_requires] = ACTIONS(5638),
  },
  [2251] = {
    [sym_identifier] = ACTIONS(5653),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5655),
    [anon_sym_COMMA] = ACTIONS(5655),
    [anon_sym_RPAREN] = ACTIONS(5655),
    [anon_sym_LPAREN2] = ACTIONS(5655),
    [anon_sym_DASH] = ACTIONS(5653),
    [anon_sym_PLUS] = ACTIONS(5653),
    [anon_sym_STAR] = ACTIONS(5655),
    [anon_sym_SLASH] = ACTIONS(5653),
    [anon_sym_PERCENT] = ACTIONS(5655),
    [anon_sym_PIPE_PIPE] = ACTIONS(5655),
    [anon_sym_AMP_AMP] = ACTIONS(5655),
    [anon_sym_PIPE] = ACTIONS(5653),
    [anon_sym_CARET] = ACTIONS(5655),
    [anon_sym_AMP] = ACTIONS(5653),
    [anon_sym_EQ_EQ] = ACTIONS(5655),
    [anon_sym_BANG_EQ] = ACTIONS(5655),
    [anon_sym_GT] = ACTIONS(5653),
    [anon_sym_GT_EQ] = ACTIONS(5655),
    [anon_sym_LT_EQ] = ACTIONS(5653),
    [anon_sym_LT] = ACTIONS(5653),
    [anon_sym_LT_LT] = ACTIONS(5655),
    [anon_sym_GT_GT] = ACTIONS(5655),
    [anon_sym_SEMI] = ACTIONS(5655),
    [anon_sym___extension__] = ACTIONS(5653),
    [anon_sym___attribute__] = ACTIONS(5653),
    [anon_sym___based] = ACTIONS(5653),
    [anon_sym_LBRACE] = ACTIONS(5655),
    [anon_sym_RBRACE] = ACTIONS(5655),
    [anon_sym_signed] = ACTIONS(5653),
    [anon_sym_unsigned] = ACTIONS(5653),
    [anon_sym_long] = ACTIONS(5653),
    [anon_sym_short] = ACTIONS(5653),
    [anon_sym_LBRACK] = ACTIONS(5655),
    [anon_sym_RBRACK] = ACTIONS(5655),
    [anon_sym_const] = ACTIONS(5653),
    [anon_sym_constexpr] = ACTIONS(5653),
    [anon_sym_volatile] = ACTIONS(5653),
    [anon_sym_restrict] = ACTIONS(5653),
    [anon_sym___restrict__] = ACTIONS(5653),
    [anon_sym__Atomic] = ACTIONS(5653),
    [anon_sym__Noreturn] = ACTIONS(5653),
    [anon_sym_noreturn] = ACTIONS(5653),
    [anon_sym_mutable] = ACTIONS(5653),
    [anon_sym_constinit] = ACTIONS(5653),
    [anon_sym_consteval] = ACTIONS(5653),
    [anon_sym_PROGMEM] = ACTIONS(5653),
    [aux_sym_primitive_type_token1] = ACTIONS(5653),
    [anon_sym_byte] = ACTIONS(5653),
    [anon_sym_word] = ACTIONS(5653),
    [anon_sym_COLON] = ACTIONS(5655),
    [anon_sym_QMARK] = ACTIONS(5655),
    [anon_sym_LT_EQ_GT] = ACTIONS(5655),
    [anon_sym_or] = ACTIONS(5653),
    [anon_sym_and] = ACTIONS(5653),
    [anon_sym_bitor] = ACTIONS(5653),
    [anon_sym_xor] = ACTIONS(5653),
    [anon_sym_bitand] = ACTIONS(5653),
    [anon_sym_not_eq] = ACTIONS(5653),
    [anon_sym_DASH_DASH] = ACTIONS(5655),
    [anon_sym_PLUS_PLUS] = ACTIONS(5655),
    [anon_sym_DOT] = ACTIONS(5653),
    [anon_sym_DOT_STAR] = ACTIONS(5655),
    [anon_sym_DASH_GT] = ACTIONS(5655),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5653),
    [anon_sym_decltype] = ACTIONS(5653),
    [anon_sym_final] = ACTIONS(5653),
    [anon_sym_override] = ACTIONS(5653),
    [anon_sym_requires] = ACTIONS(5653),
  },
  [2252] = {
    [sym_identifier] = ACTIONS(5657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5659),
    [anon_sym_COMMA] = ACTIONS(5659),
    [anon_sym_RPAREN] = ACTIONS(5659),
    [anon_sym_LPAREN2] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5657),
    [anon_sym_PLUS] = ACTIONS(5657),
    [anon_sym_STAR] = ACTIONS(5659),
    [anon_sym_SLASH] = ACTIONS(5657),
    [anon_sym_PERCENT] = ACTIONS(5659),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5657),
    [anon_sym_CARET] = ACTIONS(5659),
    [anon_sym_AMP] = ACTIONS(5657),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5657),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_LT_EQ] = ACTIONS(5657),
    [anon_sym_LT] = ACTIONS(5657),
    [anon_sym_LT_LT] = ACTIONS(5659),
    [anon_sym_GT_GT] = ACTIONS(5659),
    [anon_sym_SEMI] = ACTIONS(5659),
    [anon_sym___extension__] = ACTIONS(5657),
    [anon_sym___attribute__] = ACTIONS(5657),
    [anon_sym___based] = ACTIONS(5657),
    [anon_sym_LBRACE] = ACTIONS(5659),
    [anon_sym_RBRACE] = ACTIONS(5659),
    [anon_sym_signed] = ACTIONS(5657),
    [anon_sym_unsigned] = ACTIONS(5657),
    [anon_sym_long] = ACTIONS(5657),
    [anon_sym_short] = ACTIONS(5657),
    [anon_sym_LBRACK] = ACTIONS(5659),
    [anon_sym_RBRACK] = ACTIONS(5659),
    [anon_sym_const] = ACTIONS(5657),
    [anon_sym_constexpr] = ACTIONS(5657),
    [anon_sym_volatile] = ACTIONS(5657),
    [anon_sym_restrict] = ACTIONS(5657),
    [anon_sym___restrict__] = ACTIONS(5657),
    [anon_sym__Atomic] = ACTIONS(5657),
    [anon_sym__Noreturn] = ACTIONS(5657),
    [anon_sym_noreturn] = ACTIONS(5657),
    [anon_sym_mutable] = ACTIONS(5657),
    [anon_sym_constinit] = ACTIONS(5657),
    [anon_sym_consteval] = ACTIONS(5657),
    [anon_sym_PROGMEM] = ACTIONS(5657),
    [aux_sym_primitive_type_token1] = ACTIONS(5657),
    [anon_sym_byte] = ACTIONS(5657),
    [anon_sym_word] = ACTIONS(5657),
    [anon_sym_COLON] = ACTIONS(5659),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_LT_EQ_GT] = ACTIONS(5659),
    [anon_sym_or] = ACTIONS(5657),
    [anon_sym_and] = ACTIONS(5657),
    [anon_sym_bitor] = ACTIONS(5657),
    [anon_sym_xor] = ACTIONS(5657),
    [anon_sym_bitand] = ACTIONS(5657),
    [anon_sym_not_eq] = ACTIONS(5657),
    [anon_sym_DASH_DASH] = ACTIONS(5659),
    [anon_sym_PLUS_PLUS] = ACTIONS(5659),
    [anon_sym_DOT] = ACTIONS(5657),
    [anon_sym_DOT_STAR] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5657),
    [anon_sym_decltype] = ACTIONS(5657),
    [anon_sym_final] = ACTIONS(5657),
    [anon_sym_override] = ACTIONS(5657),
    [anon_sym_requires] = ACTIONS(5657),
  },
  [2253] = {
    [sym_identifier] = ACTIONS(5661),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_COMMA] = ACTIONS(5663),
    [anon_sym_RPAREN] = ACTIONS(5663),
    [anon_sym_LPAREN2] = ACTIONS(5663),
    [anon_sym_DASH] = ACTIONS(5661),
    [anon_sym_PLUS] = ACTIONS(5661),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5661),
    [anon_sym_PERCENT] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_AMP_AMP] = ACTIONS(5663),
    [anon_sym_PIPE] = ACTIONS(5661),
    [anon_sym_CARET] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5661),
    [anon_sym_EQ_EQ] = ACTIONS(5663),
    [anon_sym_BANG_EQ] = ACTIONS(5663),
    [anon_sym_GT] = ACTIONS(5661),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5661),
    [anon_sym_LT] = ACTIONS(5661),
    [anon_sym_LT_LT] = ACTIONS(5663),
    [anon_sym_GT_GT] = ACTIONS(5663),
    [anon_sym_SEMI] = ACTIONS(5663),
    [anon_sym___extension__] = ACTIONS(5661),
    [anon_sym___attribute__] = ACTIONS(5661),
    [anon_sym___based] = ACTIONS(5661),
    [anon_sym_LBRACE] = ACTIONS(5663),
    [anon_sym_RBRACE] = ACTIONS(5663),
    [anon_sym_signed] = ACTIONS(5661),
    [anon_sym_unsigned] = ACTIONS(5661),
    [anon_sym_long] = ACTIONS(5661),
    [anon_sym_short] = ACTIONS(5661),
    [anon_sym_LBRACK] = ACTIONS(5663),
    [anon_sym_RBRACK] = ACTIONS(5663),
    [anon_sym_const] = ACTIONS(5661),
    [anon_sym_constexpr] = ACTIONS(5661),
    [anon_sym_volatile] = ACTIONS(5661),
    [anon_sym_restrict] = ACTIONS(5661),
    [anon_sym___restrict__] = ACTIONS(5661),
    [anon_sym__Atomic] = ACTIONS(5661),
    [anon_sym__Noreturn] = ACTIONS(5661),
    [anon_sym_noreturn] = ACTIONS(5661),
    [anon_sym_mutable] = ACTIONS(5661),
    [anon_sym_constinit] = ACTIONS(5661),
    [anon_sym_consteval] = ACTIONS(5661),
    [anon_sym_PROGMEM] = ACTIONS(5661),
    [aux_sym_primitive_type_token1] = ACTIONS(5661),
    [anon_sym_byte] = ACTIONS(5661),
    [anon_sym_word] = ACTIONS(5661),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_or] = ACTIONS(5661),
    [anon_sym_and] = ACTIONS(5661),
    [anon_sym_bitor] = ACTIONS(5661),
    [anon_sym_xor] = ACTIONS(5661),
    [anon_sym_bitand] = ACTIONS(5661),
    [anon_sym_not_eq] = ACTIONS(5661),
    [anon_sym_DASH_DASH] = ACTIONS(5663),
    [anon_sym_PLUS_PLUS] = ACTIONS(5663),
    [anon_sym_DOT] = ACTIONS(5661),
    [anon_sym_DOT_STAR] = ACTIONS(5663),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5661),
    [anon_sym_decltype] = ACTIONS(5661),
    [anon_sym_final] = ACTIONS(5661),
    [anon_sym_override] = ACTIONS(5661),
    [anon_sym_requires] = ACTIONS(5661),
  },
  [2254] = {
    [sym_identifier] = ACTIONS(5665),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5667),
    [anon_sym_COMMA] = ACTIONS(5667),
    [anon_sym_RPAREN] = ACTIONS(5667),
    [anon_sym_LPAREN2] = ACTIONS(5667),
    [anon_sym_DASH] = ACTIONS(5665),
    [anon_sym_PLUS] = ACTIONS(5665),
    [anon_sym_STAR] = ACTIONS(5667),
    [anon_sym_SLASH] = ACTIONS(5665),
    [anon_sym_PERCENT] = ACTIONS(5667),
    [anon_sym_PIPE_PIPE] = ACTIONS(5667),
    [anon_sym_AMP_AMP] = ACTIONS(5667),
    [anon_sym_PIPE] = ACTIONS(5665),
    [anon_sym_CARET] = ACTIONS(5667),
    [anon_sym_AMP] = ACTIONS(5665),
    [anon_sym_EQ_EQ] = ACTIONS(5667),
    [anon_sym_BANG_EQ] = ACTIONS(5667),
    [anon_sym_GT] = ACTIONS(5665),
    [anon_sym_GT_EQ] = ACTIONS(5667),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_LT] = ACTIONS(5665),
    [anon_sym_LT_LT] = ACTIONS(5667),
    [anon_sym_GT_GT] = ACTIONS(5667),
    [anon_sym_SEMI] = ACTIONS(5667),
    [anon_sym___extension__] = ACTIONS(5665),
    [anon_sym___attribute__] = ACTIONS(5665),
    [anon_sym___based] = ACTIONS(5665),
    [anon_sym_LBRACE] = ACTIONS(5667),
    [anon_sym_RBRACE] = ACTIONS(5667),
    [anon_sym_signed] = ACTIONS(5665),
    [anon_sym_unsigned] = ACTIONS(5665),
    [anon_sym_long] = ACTIONS(5665),
    [anon_sym_short] = ACTIONS(5665),
    [anon_sym_LBRACK] = ACTIONS(5667),
    [anon_sym_RBRACK] = ACTIONS(5667),
    [anon_sym_const] = ACTIONS(5665),
    [anon_sym_constexpr] = ACTIONS(5665),
    [anon_sym_volatile] = ACTIONS(5665),
    [anon_sym_restrict] = ACTIONS(5665),
    [anon_sym___restrict__] = ACTIONS(5665),
    [anon_sym__Atomic] = ACTIONS(5665),
    [anon_sym__Noreturn] = ACTIONS(5665),
    [anon_sym_noreturn] = ACTIONS(5665),
    [anon_sym_mutable] = ACTIONS(5665),
    [anon_sym_constinit] = ACTIONS(5665),
    [anon_sym_consteval] = ACTIONS(5665),
    [anon_sym_PROGMEM] = ACTIONS(5665),
    [aux_sym_primitive_type_token1] = ACTIONS(5665),
    [anon_sym_byte] = ACTIONS(5665),
    [anon_sym_word] = ACTIONS(5665),
    [anon_sym_COLON] = ACTIONS(5667),
    [anon_sym_QMARK] = ACTIONS(5667),
    [anon_sym_LT_EQ_GT] = ACTIONS(5667),
    [anon_sym_or] = ACTIONS(5665),
    [anon_sym_and] = ACTIONS(5665),
    [anon_sym_bitor] = ACTIONS(5665),
    [anon_sym_xor] = ACTIONS(5665),
    [anon_sym_bitand] = ACTIONS(5665),
    [anon_sym_not_eq] = ACTIONS(5665),
    [anon_sym_DASH_DASH] = ACTIONS(5667),
    [anon_sym_PLUS_PLUS] = ACTIONS(5667),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_DOT_STAR] = ACTIONS(5667),
    [anon_sym_DASH_GT] = ACTIONS(5667),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5665),
    [anon_sym_decltype] = ACTIONS(5665),
    [anon_sym_final] = ACTIONS(5665),
    [anon_sym_override] = ACTIONS(5665),
    [anon_sym_requires] = ACTIONS(5665),
  },
  [2255] = {
    [sym__declaration_modifiers] = STATE(3676),
    [sym_attribute_specifier] = STATE(3676),
    [sym_attribute_declaration] = STATE(3676),
    [sym_ms_declspec_modifier] = STATE(3676),
    [sym_storage_class_specifier] = STATE(3676),
    [sym_type_qualifier] = STATE(3676),
    [sym__type_specifier] = STATE(4777),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(4130),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3676),
    [sym_alignas_specifier] = STATE(3676),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7352),
    [sym_qualified_type_identifier] = STATE(3374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(3676),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3331),
    [sym_identifier] = ACTIONS(4041),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4047),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(4049),
    [anon_sym_unsigned] = ACTIONS(4049),
    [anon_sym_long] = ACTIONS(4049),
    [anon_sym_short] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(4051),
    [anon_sym_class] = ACTIONS(4053),
    [anon_sym_struct] = ACTIONS(4055),
    [anon_sym_union] = ACTIONS(4057),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(4059),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2256] = {
    [sym_identifier] = ACTIONS(5669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5671),
    [anon_sym_COMMA] = ACTIONS(5671),
    [anon_sym_RPAREN] = ACTIONS(5671),
    [anon_sym_LPAREN2] = ACTIONS(5671),
    [anon_sym_DASH] = ACTIONS(5669),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5671),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_PERCENT] = ACTIONS(5671),
    [anon_sym_PIPE_PIPE] = ACTIONS(5671),
    [anon_sym_AMP_AMP] = ACTIONS(5671),
    [anon_sym_PIPE] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5671),
    [anon_sym_AMP] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5671),
    [anon_sym_BANG_EQ] = ACTIONS(5671),
    [anon_sym_GT] = ACTIONS(5669),
    [anon_sym_GT_EQ] = ACTIONS(5671),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5669),
    [anon_sym_LT_LT] = ACTIONS(5671),
    [anon_sym_GT_GT] = ACTIONS(5671),
    [anon_sym_SEMI] = ACTIONS(5671),
    [anon_sym___extension__] = ACTIONS(5669),
    [anon_sym___attribute__] = ACTIONS(5669),
    [anon_sym___based] = ACTIONS(5669),
    [anon_sym_LBRACE] = ACTIONS(5671),
    [anon_sym_RBRACE] = ACTIONS(5671),
    [anon_sym_signed] = ACTIONS(5669),
    [anon_sym_unsigned] = ACTIONS(5669),
    [anon_sym_long] = ACTIONS(5669),
    [anon_sym_short] = ACTIONS(5669),
    [anon_sym_LBRACK] = ACTIONS(5671),
    [anon_sym_RBRACK] = ACTIONS(5671),
    [anon_sym_const] = ACTIONS(5669),
    [anon_sym_constexpr] = ACTIONS(5669),
    [anon_sym_volatile] = ACTIONS(5669),
    [anon_sym_restrict] = ACTIONS(5669),
    [anon_sym___restrict__] = ACTIONS(5669),
    [anon_sym__Atomic] = ACTIONS(5669),
    [anon_sym__Noreturn] = ACTIONS(5669),
    [anon_sym_noreturn] = ACTIONS(5669),
    [anon_sym_mutable] = ACTIONS(5669),
    [anon_sym_constinit] = ACTIONS(5669),
    [anon_sym_consteval] = ACTIONS(5669),
    [anon_sym_PROGMEM] = ACTIONS(5669),
    [aux_sym_primitive_type_token1] = ACTIONS(5669),
    [anon_sym_byte] = ACTIONS(5669),
    [anon_sym_word] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5671),
    [anon_sym_QMARK] = ACTIONS(5671),
    [anon_sym_LT_EQ_GT] = ACTIONS(5671),
    [anon_sym_or] = ACTIONS(5669),
    [anon_sym_and] = ACTIONS(5669),
    [anon_sym_bitor] = ACTIONS(5669),
    [anon_sym_xor] = ACTIONS(5669),
    [anon_sym_bitand] = ACTIONS(5669),
    [anon_sym_not_eq] = ACTIONS(5669),
    [anon_sym_DASH_DASH] = ACTIONS(5671),
    [anon_sym_PLUS_PLUS] = ACTIONS(5671),
    [anon_sym_DOT] = ACTIONS(5669),
    [anon_sym_DOT_STAR] = ACTIONS(5671),
    [anon_sym_DASH_GT] = ACTIONS(5671),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5669),
    [anon_sym_decltype] = ACTIONS(5669),
    [anon_sym_final] = ACTIONS(5669),
    [anon_sym_override] = ACTIONS(5669),
    [anon_sym_requires] = ACTIONS(5669),
  },
  [2257] = {
    [sym_catch_clause] = STATE(2286),
    [aux_sym_constructor_try_statement_repeat1] = STATE(2286),
    [sym_identifier] = ACTIONS(2856),
    [aux_sym_preproc_def_token1] = ACTIONS(2856),
    [aux_sym_preproc_if_token1] = ACTIONS(2856),
    [aux_sym_preproc_if_token2] = ACTIONS(2856),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2856),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2856),
    [sym_preproc_directive] = ACTIONS(2856),
    [anon_sym_LPAREN2] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_STAR] = ACTIONS(2858),
    [anon_sym_AMP_AMP] = ACTIONS(2858),
    [anon_sym_AMP] = ACTIONS(2856),
    [anon_sym___extension__] = ACTIONS(2856),
    [anon_sym_typedef] = ACTIONS(2856),
    [anon_sym_extern] = ACTIONS(2856),
    [anon_sym___attribute__] = ACTIONS(2856),
    [anon_sym_COLON_COLON] = ACTIONS(2858),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2858),
    [anon_sym___declspec] = ACTIONS(2856),
    [anon_sym___based] = ACTIONS(2856),
    [anon_sym_signed] = ACTIONS(2856),
    [anon_sym_unsigned] = ACTIONS(2856),
    [anon_sym_long] = ACTIONS(2856),
    [anon_sym_short] = ACTIONS(2856),
    [anon_sym_LBRACK] = ACTIONS(2856),
    [anon_sym_static] = ACTIONS(2856),
    [anon_sym_register] = ACTIONS(2856),
    [anon_sym_inline] = ACTIONS(2856),
    [anon_sym___inline] = ACTIONS(2856),
    [anon_sym___inline__] = ACTIONS(2856),
    [anon_sym___forceinline] = ACTIONS(2856),
    [anon_sym_thread_local] = ACTIONS(2856),
    [anon_sym___thread] = ACTIONS(2856),
    [anon_sym_const] = ACTIONS(2856),
    [anon_sym_constexpr] = ACTIONS(2856),
    [anon_sym_volatile] = ACTIONS(2856),
    [anon_sym_restrict] = ACTIONS(2856),
    [anon_sym___restrict__] = ACTIONS(2856),
    [anon_sym__Atomic] = ACTIONS(2856),
    [anon_sym__Noreturn] = ACTIONS(2856),
    [anon_sym_noreturn] = ACTIONS(2856),
    [anon_sym_mutable] = ACTIONS(2856),
    [anon_sym_constinit] = ACTIONS(2856),
    [anon_sym_consteval] = ACTIONS(2856),
    [anon_sym_PROGMEM] = ACTIONS(2856),
    [aux_sym_primitive_type_token1] = ACTIONS(2856),
    [anon_sym_byte] = ACTIONS(2856),
    [anon_sym_word] = ACTIONS(2856),
    [anon_sym_enum] = ACTIONS(2856),
    [anon_sym_class] = ACTIONS(2856),
    [anon_sym_struct] = ACTIONS(2856),
    [anon_sym_union] = ACTIONS(2856),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2856),
    [anon_sym_decltype] = ACTIONS(2856),
    [anon_sym_virtual] = ACTIONS(2856),
    [anon_sym_alignas] = ACTIONS(2856),
    [anon_sym_explicit] = ACTIONS(2856),
    [anon_sym_typename] = ACTIONS(2856),
    [anon_sym_template] = ACTIONS(2856),
    [anon_sym_operator] = ACTIONS(2856),
    [anon_sym_friend] = ACTIONS(2856),
    [anon_sym_public] = ACTIONS(2856),
    [anon_sym_private] = ACTIONS(2856),
    [anon_sym_protected] = ACTIONS(2856),
    [anon_sym_using] = ACTIONS(2856),
    [anon_sym_static_assert] = ACTIONS(2856),
    [anon_sym_catch] = ACTIONS(5673),
  },
  [2258] = {
    [sym_identifier] = ACTIONS(5481),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5483),
    [anon_sym_COMMA] = ACTIONS(5483),
    [anon_sym_RPAREN] = ACTIONS(5483),
    [anon_sym_LPAREN2] = ACTIONS(5483),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_PLUS] = ACTIONS(5481),
    [anon_sym_STAR] = ACTIONS(5483),
    [anon_sym_SLASH] = ACTIONS(5481),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_PIPE_PIPE] = ACTIONS(5483),
    [anon_sym_AMP_AMP] = ACTIONS(5483),
    [anon_sym_PIPE] = ACTIONS(5481),
    [anon_sym_CARET] = ACTIONS(5483),
    [anon_sym_AMP] = ACTIONS(5481),
    [anon_sym_EQ_EQ] = ACTIONS(5483),
    [anon_sym_BANG_EQ] = ACTIONS(5483),
    [anon_sym_GT] = ACTIONS(5481),
    [anon_sym_GT_EQ] = ACTIONS(5483),
    [anon_sym_LT_EQ] = ACTIONS(5481),
    [anon_sym_LT] = ACTIONS(5481),
    [anon_sym_LT_LT] = ACTIONS(5483),
    [anon_sym_GT_GT] = ACTIONS(5483),
    [anon_sym_SEMI] = ACTIONS(5483),
    [anon_sym___extension__] = ACTIONS(5481),
    [anon_sym___attribute__] = ACTIONS(5481),
    [anon_sym___based] = ACTIONS(5481),
    [anon_sym_LBRACE] = ACTIONS(5483),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_signed] = ACTIONS(5481),
    [anon_sym_unsigned] = ACTIONS(5481),
    [anon_sym_long] = ACTIONS(5481),
    [anon_sym_short] = ACTIONS(5481),
    [anon_sym_LBRACK] = ACTIONS(5483),
    [anon_sym_RBRACK] = ACTIONS(5483),
    [anon_sym_const] = ACTIONS(5481),
    [anon_sym_constexpr] = ACTIONS(5481),
    [anon_sym_volatile] = ACTIONS(5481),
    [anon_sym_restrict] = ACTIONS(5481),
    [anon_sym___restrict__] = ACTIONS(5481),
    [anon_sym__Atomic] = ACTIONS(5481),
    [anon_sym__Noreturn] = ACTIONS(5481),
    [anon_sym_noreturn] = ACTIONS(5481),
    [anon_sym_mutable] = ACTIONS(5481),
    [anon_sym_constinit] = ACTIONS(5481),
    [anon_sym_consteval] = ACTIONS(5481),
    [anon_sym_PROGMEM] = ACTIONS(5481),
    [aux_sym_primitive_type_token1] = ACTIONS(5481),
    [anon_sym_byte] = ACTIONS(5481),
    [anon_sym_word] = ACTIONS(5481),
    [anon_sym_COLON] = ACTIONS(5483),
    [anon_sym_QMARK] = ACTIONS(5483),
    [anon_sym_LT_EQ_GT] = ACTIONS(5483),
    [anon_sym_or] = ACTIONS(5481),
    [anon_sym_and] = ACTIONS(5481),
    [anon_sym_bitor] = ACTIONS(5481),
    [anon_sym_xor] = ACTIONS(5481),
    [anon_sym_bitand] = ACTIONS(5481),
    [anon_sym_not_eq] = ACTIONS(5481),
    [anon_sym_DASH_DASH] = ACTIONS(5483),
    [anon_sym_PLUS_PLUS] = ACTIONS(5483),
    [anon_sym_DOT] = ACTIONS(5481),
    [anon_sym_DOT_STAR] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5481),
    [anon_sym_decltype] = ACTIONS(5481),
    [anon_sym_final] = ACTIONS(5481),
    [anon_sym_override] = ACTIONS(5481),
    [anon_sym_requires] = ACTIONS(5481),
  },
  [2259] = {
    [sym_identifier] = ACTIONS(5675),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5677),
    [anon_sym_COMMA] = ACTIONS(5677),
    [anon_sym_RPAREN] = ACTIONS(5677),
    [anon_sym_LPAREN2] = ACTIONS(5677),
    [anon_sym_DASH] = ACTIONS(5675),
    [anon_sym_PLUS] = ACTIONS(5675),
    [anon_sym_STAR] = ACTIONS(5677),
    [anon_sym_SLASH] = ACTIONS(5675),
    [anon_sym_PERCENT] = ACTIONS(5677),
    [anon_sym_PIPE_PIPE] = ACTIONS(5677),
    [anon_sym_AMP_AMP] = ACTIONS(5677),
    [anon_sym_PIPE] = ACTIONS(5675),
    [anon_sym_CARET] = ACTIONS(5677),
    [anon_sym_AMP] = ACTIONS(5675),
    [anon_sym_EQ_EQ] = ACTIONS(5677),
    [anon_sym_BANG_EQ] = ACTIONS(5677),
    [anon_sym_GT] = ACTIONS(5675),
    [anon_sym_GT_EQ] = ACTIONS(5677),
    [anon_sym_LT_EQ] = ACTIONS(5675),
    [anon_sym_LT] = ACTIONS(5675),
    [anon_sym_LT_LT] = ACTIONS(5677),
    [anon_sym_GT_GT] = ACTIONS(5677),
    [anon_sym_SEMI] = ACTIONS(5677),
    [anon_sym___extension__] = ACTIONS(5675),
    [anon_sym___attribute__] = ACTIONS(5675),
    [anon_sym___based] = ACTIONS(5675),
    [anon_sym_LBRACE] = ACTIONS(5677),
    [anon_sym_RBRACE] = ACTIONS(5677),
    [anon_sym_signed] = ACTIONS(5675),
    [anon_sym_unsigned] = ACTIONS(5675),
    [anon_sym_long] = ACTIONS(5675),
    [anon_sym_short] = ACTIONS(5675),
    [anon_sym_LBRACK] = ACTIONS(5677),
    [anon_sym_RBRACK] = ACTIONS(5677),
    [anon_sym_const] = ACTIONS(5675),
    [anon_sym_constexpr] = ACTIONS(5675),
    [anon_sym_volatile] = ACTIONS(5675),
    [anon_sym_restrict] = ACTIONS(5675),
    [anon_sym___restrict__] = ACTIONS(5675),
    [anon_sym__Atomic] = ACTIONS(5675),
    [anon_sym__Noreturn] = ACTIONS(5675),
    [anon_sym_noreturn] = ACTIONS(5675),
    [anon_sym_mutable] = ACTIONS(5675),
    [anon_sym_constinit] = ACTIONS(5675),
    [anon_sym_consteval] = ACTIONS(5675),
    [anon_sym_PROGMEM] = ACTIONS(5675),
    [aux_sym_primitive_type_token1] = ACTIONS(5675),
    [anon_sym_byte] = ACTIONS(5675),
    [anon_sym_word] = ACTIONS(5675),
    [anon_sym_COLON] = ACTIONS(5677),
    [anon_sym_QMARK] = ACTIONS(5677),
    [anon_sym_LT_EQ_GT] = ACTIONS(5677),
    [anon_sym_or] = ACTIONS(5675),
    [anon_sym_and] = ACTIONS(5675),
    [anon_sym_bitor] = ACTIONS(5675),
    [anon_sym_xor] = ACTIONS(5675),
    [anon_sym_bitand] = ACTIONS(5675),
    [anon_sym_not_eq] = ACTIONS(5675),
    [anon_sym_DASH_DASH] = ACTIONS(5677),
    [anon_sym_PLUS_PLUS] = ACTIONS(5677),
    [anon_sym_DOT] = ACTIONS(5675),
    [anon_sym_DOT_STAR] = ACTIONS(5677),
    [anon_sym_DASH_GT] = ACTIONS(5677),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5675),
    [anon_sym_decltype] = ACTIONS(5675),
    [anon_sym_final] = ACTIONS(5675),
    [anon_sym_override] = ACTIONS(5675),
    [anon_sym_requires] = ACTIONS(5675),
  },
  [2260] = {
    [sym_identifier] = ACTIONS(2887),
    [aux_sym_preproc_def_token1] = ACTIONS(2887),
    [aux_sym_preproc_if_token1] = ACTIONS(2887),
    [aux_sym_preproc_if_token2] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2887),
    [aux_sym_preproc_else_token1] = ACTIONS(2887),
    [aux_sym_preproc_elif_token1] = ACTIONS(2887),
    [sym_preproc_directive] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2889),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym___extension__] = ACTIONS(2887),
    [anon_sym_typedef] = ACTIONS(2887),
    [anon_sym_extern] = ACTIONS(2887),
    [anon_sym___attribute__] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2889),
    [anon_sym___declspec] = ACTIONS(2887),
    [anon_sym___based] = ACTIONS(2887),
    [anon_sym_signed] = ACTIONS(2887),
    [anon_sym_unsigned] = ACTIONS(2887),
    [anon_sym_long] = ACTIONS(2887),
    [anon_sym_short] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_static] = ACTIONS(2887),
    [anon_sym_register] = ACTIONS(2887),
    [anon_sym_inline] = ACTIONS(2887),
    [anon_sym___inline] = ACTIONS(2887),
    [anon_sym___inline__] = ACTIONS(2887),
    [anon_sym___forceinline] = ACTIONS(2887),
    [anon_sym_thread_local] = ACTIONS(2887),
    [anon_sym___thread] = ACTIONS(2887),
    [anon_sym_const] = ACTIONS(2887),
    [anon_sym_constexpr] = ACTIONS(2887),
    [anon_sym_volatile] = ACTIONS(2887),
    [anon_sym_restrict] = ACTIONS(2887),
    [anon_sym___restrict__] = ACTIONS(2887),
    [anon_sym__Atomic] = ACTIONS(2887),
    [anon_sym__Noreturn] = ACTIONS(2887),
    [anon_sym_noreturn] = ACTIONS(2887),
    [anon_sym_mutable] = ACTIONS(2887),
    [anon_sym_constinit] = ACTIONS(2887),
    [anon_sym_consteval] = ACTIONS(2887),
    [anon_sym_PROGMEM] = ACTIONS(2887),
    [aux_sym_primitive_type_token1] = ACTIONS(2887),
    [anon_sym_byte] = ACTIONS(2887),
    [anon_sym_word] = ACTIONS(2887),
    [anon_sym_enum] = ACTIONS(2887),
    [anon_sym_class] = ACTIONS(2887),
    [anon_sym_struct] = ACTIONS(2887),
    [anon_sym_union] = ACTIONS(2887),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2887),
    [anon_sym_decltype] = ACTIONS(2887),
    [anon_sym_virtual] = ACTIONS(2887),
    [anon_sym_alignas] = ACTIONS(2887),
    [anon_sym_explicit] = ACTIONS(2887),
    [anon_sym_typename] = ACTIONS(2887),
    [anon_sym_template] = ACTIONS(2887),
    [anon_sym_operator] = ACTIONS(2887),
    [anon_sym_friend] = ACTIONS(2887),
    [anon_sym_public] = ACTIONS(2887),
    [anon_sym_private] = ACTIONS(2887),
    [anon_sym_protected] = ACTIONS(2887),
    [anon_sym_using] = ACTIONS(2887),
    [anon_sym_static_assert] = ACTIONS(2887),
    [anon_sym_catch] = ACTIONS(2887),
  },
  [2261] = {
    [sym_catch_clause] = STATE(2261),
    [aux_sym_constructor_try_statement_repeat1] = STATE(2261),
    [sym_identifier] = ACTIONS(2843),
    [aux_sym_preproc_def_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2843),
    [sym_preproc_directive] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym___extension__] = ACTIONS(2843),
    [anon_sym_typedef] = ACTIONS(2843),
    [anon_sym_extern] = ACTIONS(2843),
    [anon_sym___attribute__] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2845),
    [anon_sym___declspec] = ACTIONS(2843),
    [anon_sym___based] = ACTIONS(2843),
    [anon_sym_RBRACE] = ACTIONS(2845),
    [anon_sym_signed] = ACTIONS(2843),
    [anon_sym_unsigned] = ACTIONS(2843),
    [anon_sym_long] = ACTIONS(2843),
    [anon_sym_short] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_register] = ACTIONS(2843),
    [anon_sym_inline] = ACTIONS(2843),
    [anon_sym___inline] = ACTIONS(2843),
    [anon_sym___inline__] = ACTIONS(2843),
    [anon_sym___forceinline] = ACTIONS(2843),
    [anon_sym_thread_local] = ACTIONS(2843),
    [anon_sym___thread] = ACTIONS(2843),
    [anon_sym_const] = ACTIONS(2843),
    [anon_sym_constexpr] = ACTIONS(2843),
    [anon_sym_volatile] = ACTIONS(2843),
    [anon_sym_restrict] = ACTIONS(2843),
    [anon_sym___restrict__] = ACTIONS(2843),
    [anon_sym__Atomic] = ACTIONS(2843),
    [anon_sym__Noreturn] = ACTIONS(2843),
    [anon_sym_noreturn] = ACTIONS(2843),
    [anon_sym_mutable] = ACTIONS(2843),
    [anon_sym_constinit] = ACTIONS(2843),
    [anon_sym_consteval] = ACTIONS(2843),
    [anon_sym_PROGMEM] = ACTIONS(2843),
    [aux_sym_primitive_type_token1] = ACTIONS(2843),
    [anon_sym_byte] = ACTIONS(2843),
    [anon_sym_word] = ACTIONS(2843),
    [anon_sym_enum] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2843),
    [anon_sym_union] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2843),
    [anon_sym_decltype] = ACTIONS(2843),
    [anon_sym_virtual] = ACTIONS(2843),
    [anon_sym_alignas] = ACTIONS(2843),
    [anon_sym_explicit] = ACTIONS(2843),
    [anon_sym_typename] = ACTIONS(2843),
    [anon_sym_template] = ACTIONS(2843),
    [anon_sym_operator] = ACTIONS(2843),
    [anon_sym_friend] = ACTIONS(2843),
    [anon_sym_public] = ACTIONS(2843),
    [anon_sym_private] = ACTIONS(2843),
    [anon_sym_protected] = ACTIONS(2843),
    [anon_sym_using] = ACTIONS(2843),
    [anon_sym_static_assert] = ACTIONS(2843),
    [anon_sym_catch] = ACTIONS(5679),
  },
  [2262] = {
    [sym_identifier] = ACTIONS(3427),
    [aux_sym_preproc_def_token1] = ACTIONS(3427),
    [aux_sym_preproc_if_token1] = ACTIONS(3427),
    [aux_sym_preproc_if_token2] = ACTIONS(3427),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3427),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3427),
    [aux_sym_preproc_else_token1] = ACTIONS(3427),
    [aux_sym_preproc_elif_token1] = ACTIONS(3427),
    [sym_preproc_directive] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3429),
    [anon_sym_TILDE] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(3429),
    [anon_sym_AMP_AMP] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(5682),
    [anon_sym___extension__] = ACTIONS(3427),
    [anon_sym_typedef] = ACTIONS(3427),
    [anon_sym_extern] = ACTIONS(3427),
    [anon_sym___attribute__] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3429),
    [anon_sym___declspec] = ACTIONS(3427),
    [anon_sym___based] = ACTIONS(3427),
    [anon_sym_signed] = ACTIONS(3427),
    [anon_sym_unsigned] = ACTIONS(3427),
    [anon_sym_long] = ACTIONS(3427),
    [anon_sym_short] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_register] = ACTIONS(3427),
    [anon_sym_inline] = ACTIONS(3427),
    [anon_sym___inline] = ACTIONS(3427),
    [anon_sym___inline__] = ACTIONS(3427),
    [anon_sym___forceinline] = ACTIONS(3427),
    [anon_sym_thread_local] = ACTIONS(3427),
    [anon_sym___thread] = ACTIONS(3427),
    [anon_sym_const] = ACTIONS(3427),
    [anon_sym_constexpr] = ACTIONS(3427),
    [anon_sym_volatile] = ACTIONS(3427),
    [anon_sym_restrict] = ACTIONS(3427),
    [anon_sym___restrict__] = ACTIONS(3427),
    [anon_sym__Atomic] = ACTIONS(3427),
    [anon_sym__Noreturn] = ACTIONS(3427),
    [anon_sym_noreturn] = ACTIONS(3427),
    [anon_sym_mutable] = ACTIONS(3427),
    [anon_sym_constinit] = ACTIONS(3427),
    [anon_sym_consteval] = ACTIONS(3427),
    [anon_sym_PROGMEM] = ACTIONS(3427),
    [aux_sym_primitive_type_token1] = ACTIONS(3427),
    [anon_sym_byte] = ACTIONS(3427),
    [anon_sym_word] = ACTIONS(3427),
    [anon_sym_enum] = ACTIONS(3427),
    [anon_sym_class] = ACTIONS(3427),
    [anon_sym_struct] = ACTIONS(3427),
    [anon_sym_union] = ACTIONS(3427),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3427),
    [anon_sym_decltype] = ACTIONS(3427),
    [anon_sym_virtual] = ACTIONS(3427),
    [anon_sym_alignas] = ACTIONS(3427),
    [anon_sym_explicit] = ACTIONS(3427),
    [anon_sym_typename] = ACTIONS(3427),
    [anon_sym_template] = ACTIONS(3427),
    [anon_sym_operator] = ACTIONS(3427),
    [anon_sym_friend] = ACTIONS(3427),
    [anon_sym_public] = ACTIONS(3427),
    [anon_sym_private] = ACTIONS(3427),
    [anon_sym_protected] = ACTIONS(3427),
    [anon_sym_using] = ACTIONS(3427),
    [anon_sym_static_assert] = ACTIONS(3427),
  },
  [2263] = {
    [sym_catch_clause] = STATE(2286),
    [aux_sym_constructor_try_statement_repeat1] = STATE(2286),
    [sym_identifier] = ACTIONS(2860),
    [aux_sym_preproc_def_token1] = ACTIONS(2860),
    [aux_sym_preproc_if_token1] = ACTIONS(2860),
    [aux_sym_preproc_if_token2] = ACTIONS(2860),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2860),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2860),
    [sym_preproc_directive] = ACTIONS(2860),
    [anon_sym_LPAREN2] = ACTIONS(2862),
    [anon_sym_TILDE] = ACTIONS(2862),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP_AMP] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2860),
    [anon_sym___extension__] = ACTIONS(2860),
    [anon_sym_typedef] = ACTIONS(2860),
    [anon_sym_extern] = ACTIONS(2860),
    [anon_sym___attribute__] = ACTIONS(2860),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2862),
    [anon_sym___declspec] = ACTIONS(2860),
    [anon_sym___based] = ACTIONS(2860),
    [anon_sym_signed] = ACTIONS(2860),
    [anon_sym_unsigned] = ACTIONS(2860),
    [anon_sym_long] = ACTIONS(2860),
    [anon_sym_short] = ACTIONS(2860),
    [anon_sym_LBRACK] = ACTIONS(2860),
    [anon_sym_static] = ACTIONS(2860),
    [anon_sym_register] = ACTIONS(2860),
    [anon_sym_inline] = ACTIONS(2860),
    [anon_sym___inline] = ACTIONS(2860),
    [anon_sym___inline__] = ACTIONS(2860),
    [anon_sym___forceinline] = ACTIONS(2860),
    [anon_sym_thread_local] = ACTIONS(2860),
    [anon_sym___thread] = ACTIONS(2860),
    [anon_sym_const] = ACTIONS(2860),
    [anon_sym_constexpr] = ACTIONS(2860),
    [anon_sym_volatile] = ACTIONS(2860),
    [anon_sym_restrict] = ACTIONS(2860),
    [anon_sym___restrict__] = ACTIONS(2860),
    [anon_sym__Atomic] = ACTIONS(2860),
    [anon_sym__Noreturn] = ACTIONS(2860),
    [anon_sym_noreturn] = ACTIONS(2860),
    [anon_sym_mutable] = ACTIONS(2860),
    [anon_sym_constinit] = ACTIONS(2860),
    [anon_sym_consteval] = ACTIONS(2860),
    [anon_sym_PROGMEM] = ACTIONS(2860),
    [aux_sym_primitive_type_token1] = ACTIONS(2860),
    [anon_sym_byte] = ACTIONS(2860),
    [anon_sym_word] = ACTIONS(2860),
    [anon_sym_enum] = ACTIONS(2860),
    [anon_sym_class] = ACTIONS(2860),
    [anon_sym_struct] = ACTIONS(2860),
    [anon_sym_union] = ACTIONS(2860),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2860),
    [anon_sym_decltype] = ACTIONS(2860),
    [anon_sym_virtual] = ACTIONS(2860),
    [anon_sym_alignas] = ACTIONS(2860),
    [anon_sym_explicit] = ACTIONS(2860),
    [anon_sym_typename] = ACTIONS(2860),
    [anon_sym_template] = ACTIONS(2860),
    [anon_sym_operator] = ACTIONS(2860),
    [anon_sym_friend] = ACTIONS(2860),
    [anon_sym_public] = ACTIONS(2860),
    [anon_sym_private] = ACTIONS(2860),
    [anon_sym_protected] = ACTIONS(2860),
    [anon_sym_using] = ACTIONS(2860),
    [anon_sym_static_assert] = ACTIONS(2860),
    [anon_sym_catch] = ACTIONS(5673),
  },
  [2264] = {
    [sym_identifier] = ACTIONS(5684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5686),
    [anon_sym_COMMA] = ACTIONS(5686),
    [anon_sym_RPAREN] = ACTIONS(5686),
    [anon_sym_LPAREN2] = ACTIONS(5686),
    [anon_sym_DASH] = ACTIONS(5684),
    [anon_sym_PLUS] = ACTIONS(5684),
    [anon_sym_STAR] = ACTIONS(5686),
    [anon_sym_SLASH] = ACTIONS(5684),
    [anon_sym_PERCENT] = ACTIONS(5686),
    [anon_sym_PIPE_PIPE] = ACTIONS(5686),
    [anon_sym_AMP_AMP] = ACTIONS(5686),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_CARET] = ACTIONS(5686),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_EQ_EQ] = ACTIONS(5686),
    [anon_sym_BANG_EQ] = ACTIONS(5686),
    [anon_sym_GT] = ACTIONS(5684),
    [anon_sym_GT_EQ] = ACTIONS(5686),
    [anon_sym_LT_EQ] = ACTIONS(5684),
    [anon_sym_LT] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(5686),
    [anon_sym_GT_GT] = ACTIONS(5686),
    [anon_sym_SEMI] = ACTIONS(5686),
    [anon_sym___extension__] = ACTIONS(5684),
    [anon_sym___attribute__] = ACTIONS(5684),
    [anon_sym___based] = ACTIONS(5684),
    [anon_sym_LBRACE] = ACTIONS(5686),
    [anon_sym_RBRACE] = ACTIONS(5686),
    [anon_sym_signed] = ACTIONS(5684),
    [anon_sym_unsigned] = ACTIONS(5684),
    [anon_sym_long] = ACTIONS(5684),
    [anon_sym_short] = ACTIONS(5684),
    [anon_sym_LBRACK] = ACTIONS(5686),
    [anon_sym_RBRACK] = ACTIONS(5686),
    [anon_sym_const] = ACTIONS(5684),
    [anon_sym_constexpr] = ACTIONS(5684),
    [anon_sym_volatile] = ACTIONS(5684),
    [anon_sym_restrict] = ACTIONS(5684),
    [anon_sym___restrict__] = ACTIONS(5684),
    [anon_sym__Atomic] = ACTIONS(5684),
    [anon_sym__Noreturn] = ACTIONS(5684),
    [anon_sym_noreturn] = ACTIONS(5684),
    [anon_sym_mutable] = ACTIONS(5684),
    [anon_sym_constinit] = ACTIONS(5684),
    [anon_sym_consteval] = ACTIONS(5684),
    [anon_sym_PROGMEM] = ACTIONS(5684),
    [aux_sym_primitive_type_token1] = ACTIONS(5684),
    [anon_sym_byte] = ACTIONS(5684),
    [anon_sym_word] = ACTIONS(5684),
    [anon_sym_COLON] = ACTIONS(5686),
    [anon_sym_QMARK] = ACTIONS(5686),
    [anon_sym_LT_EQ_GT] = ACTIONS(5686),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_and] = ACTIONS(5684),
    [anon_sym_bitor] = ACTIONS(5684),
    [anon_sym_xor] = ACTIONS(5684),
    [anon_sym_bitand] = ACTIONS(5684),
    [anon_sym_not_eq] = ACTIONS(5684),
    [anon_sym_DASH_DASH] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5686),
    [anon_sym_DOT] = ACTIONS(5684),
    [anon_sym_DOT_STAR] = ACTIONS(5686),
    [anon_sym_DASH_GT] = ACTIONS(5686),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5684),
    [anon_sym_decltype] = ACTIONS(5684),
    [anon_sym_final] = ACTIONS(5684),
    [anon_sym_override] = ACTIONS(5684),
    [anon_sym_requires] = ACTIONS(5684),
  },
  [2265] = {
    [sym__declaration_modifiers] = STATE(3676),
    [sym_attribute_specifier] = STATE(3676),
    [sym_attribute_declaration] = STATE(3676),
    [sym_ms_declspec_modifier] = STATE(3676),
    [sym_storage_class_specifier] = STATE(3676),
    [sym_type_qualifier] = STATE(3676),
    [sym__type_specifier] = STATE(2892),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3676),
    [sym_alignas_specifier] = STATE(3676),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(3676),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5204),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2266] = {
    [sym_identifier] = ACTIONS(5688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_RPAREN] = ACTIONS(5690),
    [anon_sym_LPAREN2] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5688),
    [anon_sym_STAR] = ACTIONS(5690),
    [anon_sym_SLASH] = ACTIONS(5688),
    [anon_sym_PERCENT] = ACTIONS(5690),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_AMP_AMP] = ACTIONS(5690),
    [anon_sym_PIPE] = ACTIONS(5688),
    [anon_sym_CARET] = ACTIONS(5690),
    [anon_sym_AMP] = ACTIONS(5688),
    [anon_sym_EQ_EQ] = ACTIONS(5690),
    [anon_sym_BANG_EQ] = ACTIONS(5690),
    [anon_sym_GT] = ACTIONS(5688),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_LT] = ACTIONS(5688),
    [anon_sym_LT_LT] = ACTIONS(5690),
    [anon_sym_GT_GT] = ACTIONS(5690),
    [anon_sym_SEMI] = ACTIONS(5690),
    [anon_sym___extension__] = ACTIONS(5688),
    [anon_sym___attribute__] = ACTIONS(5688),
    [anon_sym___based] = ACTIONS(5688),
    [anon_sym_LBRACE] = ACTIONS(5690),
    [anon_sym_RBRACE] = ACTIONS(5690),
    [anon_sym_signed] = ACTIONS(5688),
    [anon_sym_unsigned] = ACTIONS(5688),
    [anon_sym_long] = ACTIONS(5688),
    [anon_sym_short] = ACTIONS(5688),
    [anon_sym_LBRACK] = ACTIONS(5690),
    [anon_sym_RBRACK] = ACTIONS(5690),
    [anon_sym_const] = ACTIONS(5688),
    [anon_sym_constexpr] = ACTIONS(5688),
    [anon_sym_volatile] = ACTIONS(5688),
    [anon_sym_restrict] = ACTIONS(5688),
    [anon_sym___restrict__] = ACTIONS(5688),
    [anon_sym__Atomic] = ACTIONS(5688),
    [anon_sym__Noreturn] = ACTIONS(5688),
    [anon_sym_noreturn] = ACTIONS(5688),
    [anon_sym_mutable] = ACTIONS(5688),
    [anon_sym_constinit] = ACTIONS(5688),
    [anon_sym_consteval] = ACTIONS(5688),
    [anon_sym_PROGMEM] = ACTIONS(5688),
    [aux_sym_primitive_type_token1] = ACTIONS(5688),
    [anon_sym_byte] = ACTIONS(5688),
    [anon_sym_word] = ACTIONS(5688),
    [anon_sym_COLON] = ACTIONS(5690),
    [anon_sym_QMARK] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_or] = ACTIONS(5688),
    [anon_sym_and] = ACTIONS(5688),
    [anon_sym_bitor] = ACTIONS(5688),
    [anon_sym_xor] = ACTIONS(5688),
    [anon_sym_bitand] = ACTIONS(5688),
    [anon_sym_not_eq] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5690),
    [anon_sym_PLUS_PLUS] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_DOT_STAR] = ACTIONS(5690),
    [anon_sym_DASH_GT] = ACTIONS(5690),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5688),
    [anon_sym_decltype] = ACTIONS(5688),
    [anon_sym_final] = ACTIONS(5688),
    [anon_sym_override] = ACTIONS(5688),
    [anon_sym_requires] = ACTIONS(5688),
  },
  [2267] = {
    [sym_identifier] = ACTIONS(5692),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5694),
    [anon_sym_COMMA] = ACTIONS(5694),
    [anon_sym_RPAREN] = ACTIONS(5694),
    [anon_sym_LPAREN2] = ACTIONS(5694),
    [anon_sym_DASH] = ACTIONS(5692),
    [anon_sym_PLUS] = ACTIONS(5692),
    [anon_sym_STAR] = ACTIONS(5694),
    [anon_sym_SLASH] = ACTIONS(5692),
    [anon_sym_PERCENT] = ACTIONS(5694),
    [anon_sym_PIPE_PIPE] = ACTIONS(5694),
    [anon_sym_AMP_AMP] = ACTIONS(5694),
    [anon_sym_PIPE] = ACTIONS(5692),
    [anon_sym_CARET] = ACTIONS(5694),
    [anon_sym_AMP] = ACTIONS(5692),
    [anon_sym_EQ_EQ] = ACTIONS(5694),
    [anon_sym_BANG_EQ] = ACTIONS(5694),
    [anon_sym_GT] = ACTIONS(5692),
    [anon_sym_GT_EQ] = ACTIONS(5694),
    [anon_sym_LT_EQ] = ACTIONS(5692),
    [anon_sym_LT] = ACTIONS(5692),
    [anon_sym_LT_LT] = ACTIONS(5694),
    [anon_sym_GT_GT] = ACTIONS(5694),
    [anon_sym_SEMI] = ACTIONS(5694),
    [anon_sym___extension__] = ACTIONS(5692),
    [anon_sym___attribute__] = ACTIONS(5692),
    [anon_sym___based] = ACTIONS(5692),
    [anon_sym_LBRACE] = ACTIONS(5694),
    [anon_sym_RBRACE] = ACTIONS(5694),
    [anon_sym_signed] = ACTIONS(5692),
    [anon_sym_unsigned] = ACTIONS(5692),
    [anon_sym_long] = ACTIONS(5692),
    [anon_sym_short] = ACTIONS(5692),
    [anon_sym_LBRACK] = ACTIONS(5694),
    [anon_sym_RBRACK] = ACTIONS(5694),
    [anon_sym_const] = ACTIONS(5692),
    [anon_sym_constexpr] = ACTIONS(5692),
    [anon_sym_volatile] = ACTIONS(5692),
    [anon_sym_restrict] = ACTIONS(5692),
    [anon_sym___restrict__] = ACTIONS(5692),
    [anon_sym__Atomic] = ACTIONS(5692),
    [anon_sym__Noreturn] = ACTIONS(5692),
    [anon_sym_noreturn] = ACTIONS(5692),
    [anon_sym_mutable] = ACTIONS(5692),
    [anon_sym_constinit] = ACTIONS(5692),
    [anon_sym_consteval] = ACTIONS(5692),
    [anon_sym_PROGMEM] = ACTIONS(5692),
    [aux_sym_primitive_type_token1] = ACTIONS(5692),
    [anon_sym_byte] = ACTIONS(5692),
    [anon_sym_word] = ACTIONS(5692),
    [anon_sym_COLON] = ACTIONS(5694),
    [anon_sym_QMARK] = ACTIONS(5694),
    [anon_sym_LT_EQ_GT] = ACTIONS(5694),
    [anon_sym_or] = ACTIONS(5692),
    [anon_sym_and] = ACTIONS(5692),
    [anon_sym_bitor] = ACTIONS(5692),
    [anon_sym_xor] = ACTIONS(5692),
    [anon_sym_bitand] = ACTIONS(5692),
    [anon_sym_not_eq] = ACTIONS(5692),
    [anon_sym_DASH_DASH] = ACTIONS(5694),
    [anon_sym_PLUS_PLUS] = ACTIONS(5694),
    [anon_sym_DOT] = ACTIONS(5692),
    [anon_sym_DOT_STAR] = ACTIONS(5694),
    [anon_sym_DASH_GT] = ACTIONS(5694),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5692),
    [anon_sym_decltype] = ACTIONS(5692),
    [anon_sym_final] = ACTIONS(5692),
    [anon_sym_override] = ACTIONS(5692),
    [anon_sym_requires] = ACTIONS(5692),
  },
  [2268] = {
    [sym_identifier] = ACTIONS(5696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5698),
    [anon_sym_RPAREN] = ACTIONS(5698),
    [anon_sym_LPAREN2] = ACTIONS(5698),
    [anon_sym_DASH] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_STAR] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_PIPE] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_AMP] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5696),
    [anon_sym_GT_EQ] = ACTIONS(5698),
    [anon_sym_LT_EQ] = ACTIONS(5696),
    [anon_sym_LT] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5698),
    [anon_sym___extension__] = ACTIONS(5696),
    [anon_sym___attribute__] = ACTIONS(5696),
    [anon_sym___based] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5698),
    [anon_sym_RBRACE] = ACTIONS(5698),
    [anon_sym_signed] = ACTIONS(5696),
    [anon_sym_unsigned] = ACTIONS(5696),
    [anon_sym_long] = ACTIONS(5696),
    [anon_sym_short] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5698),
    [anon_sym_RBRACK] = ACTIONS(5698),
    [anon_sym_const] = ACTIONS(5696),
    [anon_sym_constexpr] = ACTIONS(5696),
    [anon_sym_volatile] = ACTIONS(5696),
    [anon_sym_restrict] = ACTIONS(5696),
    [anon_sym___restrict__] = ACTIONS(5696),
    [anon_sym__Atomic] = ACTIONS(5696),
    [anon_sym__Noreturn] = ACTIONS(5696),
    [anon_sym_noreturn] = ACTIONS(5696),
    [anon_sym_mutable] = ACTIONS(5696),
    [anon_sym_constinit] = ACTIONS(5696),
    [anon_sym_consteval] = ACTIONS(5696),
    [anon_sym_PROGMEM] = ACTIONS(5696),
    [aux_sym_primitive_type_token1] = ACTIONS(5696),
    [anon_sym_byte] = ACTIONS(5696),
    [anon_sym_word] = ACTIONS(5696),
    [anon_sym_COLON] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5698),
    [anon_sym_LT_EQ_GT] = ACTIONS(5698),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_bitor] = ACTIONS(5696),
    [anon_sym_xor] = ACTIONS(5696),
    [anon_sym_bitand] = ACTIONS(5696),
    [anon_sym_not_eq] = ACTIONS(5696),
    [anon_sym_DASH_DASH] = ACTIONS(5698),
    [anon_sym_PLUS_PLUS] = ACTIONS(5698),
    [anon_sym_DOT] = ACTIONS(5696),
    [anon_sym_DOT_STAR] = ACTIONS(5698),
    [anon_sym_DASH_GT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5696),
    [anon_sym_decltype] = ACTIONS(5696),
    [anon_sym_final] = ACTIONS(5696),
    [anon_sym_override] = ACTIONS(5696),
    [anon_sym_requires] = ACTIONS(5696),
  },
  [2269] = {
    [sym_identifier] = ACTIONS(5700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5702),
    [anon_sym_COMMA] = ACTIONS(5702),
    [anon_sym_RPAREN] = ACTIONS(5702),
    [anon_sym_LPAREN2] = ACTIONS(5702),
    [anon_sym_DASH] = ACTIONS(5700),
    [anon_sym_PLUS] = ACTIONS(5700),
    [anon_sym_STAR] = ACTIONS(5702),
    [anon_sym_SLASH] = ACTIONS(5700),
    [anon_sym_PERCENT] = ACTIONS(5702),
    [anon_sym_PIPE_PIPE] = ACTIONS(5702),
    [anon_sym_AMP_AMP] = ACTIONS(5702),
    [anon_sym_PIPE] = ACTIONS(5700),
    [anon_sym_CARET] = ACTIONS(5702),
    [anon_sym_AMP] = ACTIONS(5700),
    [anon_sym_EQ_EQ] = ACTIONS(5702),
    [anon_sym_BANG_EQ] = ACTIONS(5702),
    [anon_sym_GT] = ACTIONS(5700),
    [anon_sym_GT_EQ] = ACTIONS(5702),
    [anon_sym_LT_EQ] = ACTIONS(5700),
    [anon_sym_LT] = ACTIONS(5700),
    [anon_sym_LT_LT] = ACTIONS(5702),
    [anon_sym_GT_GT] = ACTIONS(5702),
    [anon_sym_SEMI] = ACTIONS(5702),
    [anon_sym___extension__] = ACTIONS(5700),
    [anon_sym___attribute__] = ACTIONS(5700),
    [anon_sym___based] = ACTIONS(5700),
    [anon_sym_LBRACE] = ACTIONS(5702),
    [anon_sym_RBRACE] = ACTIONS(5702),
    [anon_sym_signed] = ACTIONS(5700),
    [anon_sym_unsigned] = ACTIONS(5700),
    [anon_sym_long] = ACTIONS(5700),
    [anon_sym_short] = ACTIONS(5700),
    [anon_sym_LBRACK] = ACTIONS(5702),
    [anon_sym_RBRACK] = ACTIONS(5702),
    [anon_sym_const] = ACTIONS(5700),
    [anon_sym_constexpr] = ACTIONS(5700),
    [anon_sym_volatile] = ACTIONS(5700),
    [anon_sym_restrict] = ACTIONS(5700),
    [anon_sym___restrict__] = ACTIONS(5700),
    [anon_sym__Atomic] = ACTIONS(5700),
    [anon_sym__Noreturn] = ACTIONS(5700),
    [anon_sym_noreturn] = ACTIONS(5700),
    [anon_sym_mutable] = ACTIONS(5700),
    [anon_sym_constinit] = ACTIONS(5700),
    [anon_sym_consteval] = ACTIONS(5700),
    [anon_sym_PROGMEM] = ACTIONS(5700),
    [aux_sym_primitive_type_token1] = ACTIONS(5700),
    [anon_sym_byte] = ACTIONS(5700),
    [anon_sym_word] = ACTIONS(5700),
    [anon_sym_COLON] = ACTIONS(5702),
    [anon_sym_QMARK] = ACTIONS(5702),
    [anon_sym_LT_EQ_GT] = ACTIONS(5702),
    [anon_sym_or] = ACTIONS(5700),
    [anon_sym_and] = ACTIONS(5700),
    [anon_sym_bitor] = ACTIONS(5700),
    [anon_sym_xor] = ACTIONS(5700),
    [anon_sym_bitand] = ACTIONS(5700),
    [anon_sym_not_eq] = ACTIONS(5700),
    [anon_sym_DASH_DASH] = ACTIONS(5702),
    [anon_sym_PLUS_PLUS] = ACTIONS(5702),
    [anon_sym_DOT] = ACTIONS(5700),
    [anon_sym_DOT_STAR] = ACTIONS(5702),
    [anon_sym_DASH_GT] = ACTIONS(5702),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5700),
    [anon_sym_decltype] = ACTIONS(5700),
    [anon_sym_final] = ACTIONS(5700),
    [anon_sym_override] = ACTIONS(5700),
    [anon_sym_requires] = ACTIONS(5700),
  },
  [2270] = {
    [sym_identifier] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5706),
    [anon_sym_COMMA] = ACTIONS(5706),
    [anon_sym_RPAREN] = ACTIONS(5706),
    [anon_sym_LPAREN2] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5704),
    [anon_sym_STAR] = ACTIONS(5706),
    [anon_sym_SLASH] = ACTIONS(5704),
    [anon_sym_PERCENT] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5706),
    [anon_sym_AMP_AMP] = ACTIONS(5706),
    [anon_sym_PIPE] = ACTIONS(5704),
    [anon_sym_CARET] = ACTIONS(5706),
    [anon_sym_AMP] = ACTIONS(5704),
    [anon_sym_EQ_EQ] = ACTIONS(5706),
    [anon_sym_BANG_EQ] = ACTIONS(5706),
    [anon_sym_GT] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5704),
    [anon_sym_LT_LT] = ACTIONS(5706),
    [anon_sym_GT_GT] = ACTIONS(5706),
    [anon_sym_SEMI] = ACTIONS(5706),
    [anon_sym___extension__] = ACTIONS(5704),
    [anon_sym___attribute__] = ACTIONS(5704),
    [anon_sym___based] = ACTIONS(5704),
    [anon_sym_LBRACE] = ACTIONS(5706),
    [anon_sym_RBRACE] = ACTIONS(5706),
    [anon_sym_signed] = ACTIONS(5704),
    [anon_sym_unsigned] = ACTIONS(5704),
    [anon_sym_long] = ACTIONS(5704),
    [anon_sym_short] = ACTIONS(5704),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_RBRACK] = ACTIONS(5706),
    [anon_sym_const] = ACTIONS(5704),
    [anon_sym_constexpr] = ACTIONS(5704),
    [anon_sym_volatile] = ACTIONS(5704),
    [anon_sym_restrict] = ACTIONS(5704),
    [anon_sym___restrict__] = ACTIONS(5704),
    [anon_sym__Atomic] = ACTIONS(5704),
    [anon_sym__Noreturn] = ACTIONS(5704),
    [anon_sym_noreturn] = ACTIONS(5704),
    [anon_sym_mutable] = ACTIONS(5704),
    [anon_sym_constinit] = ACTIONS(5704),
    [anon_sym_consteval] = ACTIONS(5704),
    [anon_sym_PROGMEM] = ACTIONS(5704),
    [aux_sym_primitive_type_token1] = ACTIONS(5704),
    [anon_sym_byte] = ACTIONS(5704),
    [anon_sym_word] = ACTIONS(5704),
    [anon_sym_COLON] = ACTIONS(5706),
    [anon_sym_QMARK] = ACTIONS(5706),
    [anon_sym_LT_EQ_GT] = ACTIONS(5706),
    [anon_sym_or] = ACTIONS(5704),
    [anon_sym_and] = ACTIONS(5704),
    [anon_sym_bitor] = ACTIONS(5704),
    [anon_sym_xor] = ACTIONS(5704),
    [anon_sym_bitand] = ACTIONS(5704),
    [anon_sym_not_eq] = ACTIONS(5704),
    [anon_sym_DASH_DASH] = ACTIONS(5706),
    [anon_sym_PLUS_PLUS] = ACTIONS(5706),
    [anon_sym_DOT] = ACTIONS(5704),
    [anon_sym_DOT_STAR] = ACTIONS(5706),
    [anon_sym_DASH_GT] = ACTIONS(5706),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5704),
    [anon_sym_decltype] = ACTIONS(5704),
    [anon_sym_final] = ACTIONS(5704),
    [anon_sym_override] = ACTIONS(5704),
    [anon_sym_requires] = ACTIONS(5704),
  },
  [2271] = {
    [sym_identifier] = ACTIONS(5688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_RPAREN] = ACTIONS(5690),
    [anon_sym_LPAREN2] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5688),
    [anon_sym_STAR] = ACTIONS(5690),
    [anon_sym_SLASH] = ACTIONS(5688),
    [anon_sym_PERCENT] = ACTIONS(5690),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_AMP_AMP] = ACTIONS(5690),
    [anon_sym_PIPE] = ACTIONS(5688),
    [anon_sym_CARET] = ACTIONS(5690),
    [anon_sym_AMP] = ACTIONS(5688),
    [anon_sym_EQ_EQ] = ACTIONS(5690),
    [anon_sym_BANG_EQ] = ACTIONS(5690),
    [anon_sym_GT] = ACTIONS(5688),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_LT] = ACTIONS(5688),
    [anon_sym_LT_LT] = ACTIONS(5690),
    [anon_sym_GT_GT] = ACTIONS(5690),
    [anon_sym_SEMI] = ACTIONS(5690),
    [anon_sym___extension__] = ACTIONS(5688),
    [anon_sym___attribute__] = ACTIONS(5688),
    [anon_sym___based] = ACTIONS(5688),
    [anon_sym_LBRACE] = ACTIONS(5690),
    [anon_sym_RBRACE] = ACTIONS(5690),
    [anon_sym_signed] = ACTIONS(5688),
    [anon_sym_unsigned] = ACTIONS(5688),
    [anon_sym_long] = ACTIONS(5688),
    [anon_sym_short] = ACTIONS(5688),
    [anon_sym_LBRACK] = ACTIONS(5690),
    [anon_sym_RBRACK] = ACTIONS(5690),
    [anon_sym_const] = ACTIONS(5688),
    [anon_sym_constexpr] = ACTIONS(5688),
    [anon_sym_volatile] = ACTIONS(5688),
    [anon_sym_restrict] = ACTIONS(5688),
    [anon_sym___restrict__] = ACTIONS(5688),
    [anon_sym__Atomic] = ACTIONS(5688),
    [anon_sym__Noreturn] = ACTIONS(5688),
    [anon_sym_noreturn] = ACTIONS(5688),
    [anon_sym_mutable] = ACTIONS(5688),
    [anon_sym_constinit] = ACTIONS(5688),
    [anon_sym_consteval] = ACTIONS(5688),
    [anon_sym_PROGMEM] = ACTIONS(5688),
    [aux_sym_primitive_type_token1] = ACTIONS(5688),
    [anon_sym_byte] = ACTIONS(5688),
    [anon_sym_word] = ACTIONS(5688),
    [anon_sym_COLON] = ACTIONS(5690),
    [anon_sym_QMARK] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_or] = ACTIONS(5688),
    [anon_sym_and] = ACTIONS(5688),
    [anon_sym_bitor] = ACTIONS(5688),
    [anon_sym_xor] = ACTIONS(5688),
    [anon_sym_bitand] = ACTIONS(5688),
    [anon_sym_not_eq] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5690),
    [anon_sym_PLUS_PLUS] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_DOT_STAR] = ACTIONS(5690),
    [anon_sym_DASH_GT] = ACTIONS(5690),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5688),
    [anon_sym_decltype] = ACTIONS(5688),
    [anon_sym_final] = ACTIONS(5688),
    [anon_sym_override] = ACTIONS(5688),
    [anon_sym_requires] = ACTIONS(5688),
  },
  [2272] = {
    [sym_identifier] = ACTIONS(5708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5710),
    [anon_sym_COMMA] = ACTIONS(5710),
    [anon_sym_RPAREN] = ACTIONS(5710),
    [anon_sym_LPAREN2] = ACTIONS(5710),
    [anon_sym_DASH] = ACTIONS(5708),
    [anon_sym_PLUS] = ACTIONS(5708),
    [anon_sym_STAR] = ACTIONS(5710),
    [anon_sym_SLASH] = ACTIONS(5708),
    [anon_sym_PERCENT] = ACTIONS(5710),
    [anon_sym_PIPE_PIPE] = ACTIONS(5710),
    [anon_sym_AMP_AMP] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5708),
    [anon_sym_CARET] = ACTIONS(5710),
    [anon_sym_AMP] = ACTIONS(5708),
    [anon_sym_EQ_EQ] = ACTIONS(5710),
    [anon_sym_BANG_EQ] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5710),
    [anon_sym_LT_EQ] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5710),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym___extension__] = ACTIONS(5708),
    [anon_sym___attribute__] = ACTIONS(5708),
    [anon_sym___based] = ACTIONS(5708),
    [anon_sym_LBRACE] = ACTIONS(5710),
    [anon_sym_RBRACE] = ACTIONS(5710),
    [anon_sym_signed] = ACTIONS(5708),
    [anon_sym_unsigned] = ACTIONS(5708),
    [anon_sym_long] = ACTIONS(5708),
    [anon_sym_short] = ACTIONS(5708),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_RBRACK] = ACTIONS(5710),
    [anon_sym_const] = ACTIONS(5708),
    [anon_sym_constexpr] = ACTIONS(5708),
    [anon_sym_volatile] = ACTIONS(5708),
    [anon_sym_restrict] = ACTIONS(5708),
    [anon_sym___restrict__] = ACTIONS(5708),
    [anon_sym__Atomic] = ACTIONS(5708),
    [anon_sym__Noreturn] = ACTIONS(5708),
    [anon_sym_noreturn] = ACTIONS(5708),
    [anon_sym_mutable] = ACTIONS(5708),
    [anon_sym_constinit] = ACTIONS(5708),
    [anon_sym_consteval] = ACTIONS(5708),
    [anon_sym_PROGMEM] = ACTIONS(5708),
    [aux_sym_primitive_type_token1] = ACTIONS(5708),
    [anon_sym_byte] = ACTIONS(5708),
    [anon_sym_word] = ACTIONS(5708),
    [anon_sym_COLON] = ACTIONS(5710),
    [anon_sym_QMARK] = ACTIONS(5710),
    [anon_sym_LT_EQ_GT] = ACTIONS(5710),
    [anon_sym_or] = ACTIONS(5708),
    [anon_sym_and] = ACTIONS(5708),
    [anon_sym_bitor] = ACTIONS(5708),
    [anon_sym_xor] = ACTIONS(5708),
    [anon_sym_bitand] = ACTIONS(5708),
    [anon_sym_not_eq] = ACTIONS(5708),
    [anon_sym_DASH_DASH] = ACTIONS(5710),
    [anon_sym_PLUS_PLUS] = ACTIONS(5710),
    [anon_sym_DOT] = ACTIONS(5708),
    [anon_sym_DOT_STAR] = ACTIONS(5710),
    [anon_sym_DASH_GT] = ACTIONS(5710),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5708),
    [anon_sym_decltype] = ACTIONS(5708),
    [anon_sym_final] = ACTIONS(5708),
    [anon_sym_override] = ACTIONS(5708),
    [anon_sym_requires] = ACTIONS(5708),
  },
  [2273] = {
    [sym_identifier] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5714),
    [anon_sym_COMMA] = ACTIONS(5714),
    [anon_sym_RPAREN] = ACTIONS(5714),
    [anon_sym_LPAREN2] = ACTIONS(5714),
    [anon_sym_DASH] = ACTIONS(5712),
    [anon_sym_PLUS] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_SLASH] = ACTIONS(5712),
    [anon_sym_PERCENT] = ACTIONS(5714),
    [anon_sym_PIPE_PIPE] = ACTIONS(5714),
    [anon_sym_AMP_AMP] = ACTIONS(5714),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_CARET] = ACTIONS(5714),
    [anon_sym_AMP] = ACTIONS(5712),
    [anon_sym_EQ_EQ] = ACTIONS(5714),
    [anon_sym_BANG_EQ] = ACTIONS(5714),
    [anon_sym_GT] = ACTIONS(5712),
    [anon_sym_GT_EQ] = ACTIONS(5714),
    [anon_sym_LT_EQ] = ACTIONS(5712),
    [anon_sym_LT] = ACTIONS(5712),
    [anon_sym_LT_LT] = ACTIONS(5714),
    [anon_sym_GT_GT] = ACTIONS(5714),
    [anon_sym_SEMI] = ACTIONS(5714),
    [anon_sym___extension__] = ACTIONS(5712),
    [anon_sym___attribute__] = ACTIONS(5712),
    [anon_sym___based] = ACTIONS(5712),
    [anon_sym_LBRACE] = ACTIONS(5714),
    [anon_sym_RBRACE] = ACTIONS(5714),
    [anon_sym_signed] = ACTIONS(5712),
    [anon_sym_unsigned] = ACTIONS(5712),
    [anon_sym_long] = ACTIONS(5712),
    [anon_sym_short] = ACTIONS(5712),
    [anon_sym_LBRACK] = ACTIONS(5714),
    [anon_sym_RBRACK] = ACTIONS(5714),
    [anon_sym_const] = ACTIONS(5712),
    [anon_sym_constexpr] = ACTIONS(5712),
    [anon_sym_volatile] = ACTIONS(5712),
    [anon_sym_restrict] = ACTIONS(5712),
    [anon_sym___restrict__] = ACTIONS(5712),
    [anon_sym__Atomic] = ACTIONS(5712),
    [anon_sym__Noreturn] = ACTIONS(5712),
    [anon_sym_noreturn] = ACTIONS(5712),
    [anon_sym_mutable] = ACTIONS(5712),
    [anon_sym_constinit] = ACTIONS(5712),
    [anon_sym_consteval] = ACTIONS(5712),
    [anon_sym_PROGMEM] = ACTIONS(5712),
    [aux_sym_primitive_type_token1] = ACTIONS(5712),
    [anon_sym_byte] = ACTIONS(5712),
    [anon_sym_word] = ACTIONS(5712),
    [anon_sym_COLON] = ACTIONS(5714),
    [anon_sym_QMARK] = ACTIONS(5714),
    [anon_sym_LT_EQ_GT] = ACTIONS(5714),
    [anon_sym_or] = ACTIONS(5712),
    [anon_sym_and] = ACTIONS(5712),
    [anon_sym_bitor] = ACTIONS(5712),
    [anon_sym_xor] = ACTIONS(5712),
    [anon_sym_bitand] = ACTIONS(5712),
    [anon_sym_not_eq] = ACTIONS(5712),
    [anon_sym_DASH_DASH] = ACTIONS(5714),
    [anon_sym_PLUS_PLUS] = ACTIONS(5714),
    [anon_sym_DOT] = ACTIONS(5712),
    [anon_sym_DOT_STAR] = ACTIONS(5714),
    [anon_sym_DASH_GT] = ACTIONS(5714),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5712),
    [anon_sym_decltype] = ACTIONS(5712),
    [anon_sym_final] = ACTIONS(5712),
    [anon_sym_override] = ACTIONS(5712),
    [anon_sym_requires] = ACTIONS(5712),
  },
  [2274] = {
    [sym_identifier] = ACTIONS(3320),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3322),
    [anon_sym_COMMA] = ACTIONS(3322),
    [anon_sym_RPAREN] = ACTIONS(3322),
    [anon_sym_LPAREN2] = ACTIONS(3322),
    [anon_sym_TILDE] = ACTIONS(3322),
    [anon_sym_STAR] = ACTIONS(3322),
    [anon_sym_AMP_AMP] = ACTIONS(3322),
    [anon_sym_AMP] = ACTIONS(3320),
    [anon_sym_SEMI] = ACTIONS(3322),
    [anon_sym___extension__] = ACTIONS(3320),
    [anon_sym_extern] = ACTIONS(3320),
    [anon_sym___attribute__] = ACTIONS(3320),
    [anon_sym_COLON_COLON] = ACTIONS(3322),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3322),
    [anon_sym___declspec] = ACTIONS(3320),
    [anon_sym___based] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_signed] = ACTIONS(3320),
    [anon_sym_unsigned] = ACTIONS(3320),
    [anon_sym_long] = ACTIONS(3320),
    [anon_sym_short] = ACTIONS(3320),
    [anon_sym_LBRACK] = ACTIONS(3320),
    [anon_sym_EQ] = ACTIONS(3322),
    [anon_sym_static] = ACTIONS(3320),
    [anon_sym_register] = ACTIONS(3320),
    [anon_sym_inline] = ACTIONS(3320),
    [anon_sym___inline] = ACTIONS(3320),
    [anon_sym___inline__] = ACTIONS(3320),
    [anon_sym___forceinline] = ACTIONS(3320),
    [anon_sym_thread_local] = ACTIONS(3320),
    [anon_sym___thread] = ACTIONS(3320),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_constexpr] = ACTIONS(3320),
    [anon_sym_volatile] = ACTIONS(3320),
    [anon_sym_restrict] = ACTIONS(3320),
    [anon_sym___restrict__] = ACTIONS(3320),
    [anon_sym__Atomic] = ACTIONS(3320),
    [anon_sym__Noreturn] = ACTIONS(3320),
    [anon_sym_noreturn] = ACTIONS(3320),
    [anon_sym_mutable] = ACTIONS(3320),
    [anon_sym_constinit] = ACTIONS(3320),
    [anon_sym_consteval] = ACTIONS(3320),
    [anon_sym_PROGMEM] = ACTIONS(3320),
    [aux_sym_primitive_type_token1] = ACTIONS(3320),
    [anon_sym_byte] = ACTIONS(3320),
    [anon_sym_word] = ACTIONS(3320),
    [anon_sym_enum] = ACTIONS(3320),
    [anon_sym_class] = ACTIONS(3320),
    [anon_sym_struct] = ACTIONS(3320),
    [anon_sym_union] = ACTIONS(3320),
    [anon_sym_asm] = ACTIONS(3320),
    [anon_sym___asm__] = ACTIONS(3320),
    [anon_sym_DASH_GT] = ACTIONS(3322),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3320),
    [anon_sym_decltype] = ACTIONS(3320),
    [anon_sym_final] = ACTIONS(3320),
    [anon_sym_override] = ACTIONS(3320),
    [anon_sym_virtual] = ACTIONS(3320),
    [anon_sym_alignas] = ACTIONS(3320),
    [anon_sym_explicit] = ACTIONS(3320),
    [anon_sym_typename] = ACTIONS(3320),
    [anon_sym_template] = ACTIONS(3320),
    [anon_sym_GT2] = ACTIONS(3322),
    [anon_sym_operator] = ACTIONS(3320),
    [anon_sym_try] = ACTIONS(3320),
    [anon_sym_noexcept] = ACTIONS(3320),
    [anon_sym_throw] = ACTIONS(3320),
    [anon_sym_requires] = ACTIONS(3320),
  },
  [2275] = {
    [sym_catch_clause] = STATE(2286),
    [aux_sym_constructor_try_statement_repeat1] = STATE(2286),
    [sym_identifier] = ACTIONS(2850),
    [aux_sym_preproc_def_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token2] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2850),
    [sym_preproc_directive] = ACTIONS(2850),
    [anon_sym_LPAREN2] = ACTIONS(2852),
    [anon_sym_TILDE] = ACTIONS(2852),
    [anon_sym_STAR] = ACTIONS(2852),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_AMP] = ACTIONS(2850),
    [anon_sym___extension__] = ACTIONS(2850),
    [anon_sym_typedef] = ACTIONS(2850),
    [anon_sym_extern] = ACTIONS(2850),
    [anon_sym___attribute__] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2852),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2852),
    [anon_sym___declspec] = ACTIONS(2850),
    [anon_sym___based] = ACTIONS(2850),
    [anon_sym_signed] = ACTIONS(2850),
    [anon_sym_unsigned] = ACTIONS(2850),
    [anon_sym_long] = ACTIONS(2850),
    [anon_sym_short] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2850),
    [anon_sym_register] = ACTIONS(2850),
    [anon_sym_inline] = ACTIONS(2850),
    [anon_sym___inline] = ACTIONS(2850),
    [anon_sym___inline__] = ACTIONS(2850),
    [anon_sym___forceinline] = ACTIONS(2850),
    [anon_sym_thread_local] = ACTIONS(2850),
    [anon_sym___thread] = ACTIONS(2850),
    [anon_sym_const] = ACTIONS(2850),
    [anon_sym_constexpr] = ACTIONS(2850),
    [anon_sym_volatile] = ACTIONS(2850),
    [anon_sym_restrict] = ACTIONS(2850),
    [anon_sym___restrict__] = ACTIONS(2850),
    [anon_sym__Atomic] = ACTIONS(2850),
    [anon_sym__Noreturn] = ACTIONS(2850),
    [anon_sym_noreturn] = ACTIONS(2850),
    [anon_sym_mutable] = ACTIONS(2850),
    [anon_sym_constinit] = ACTIONS(2850),
    [anon_sym_consteval] = ACTIONS(2850),
    [anon_sym_PROGMEM] = ACTIONS(2850),
    [aux_sym_primitive_type_token1] = ACTIONS(2850),
    [anon_sym_byte] = ACTIONS(2850),
    [anon_sym_word] = ACTIONS(2850),
    [anon_sym_enum] = ACTIONS(2850),
    [anon_sym_class] = ACTIONS(2850),
    [anon_sym_struct] = ACTIONS(2850),
    [anon_sym_union] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2850),
    [anon_sym_decltype] = ACTIONS(2850),
    [anon_sym_virtual] = ACTIONS(2850),
    [anon_sym_alignas] = ACTIONS(2850),
    [anon_sym_explicit] = ACTIONS(2850),
    [anon_sym_typename] = ACTIONS(2850),
    [anon_sym_template] = ACTIONS(2850),
    [anon_sym_operator] = ACTIONS(2850),
    [anon_sym_friend] = ACTIONS(2850),
    [anon_sym_public] = ACTIONS(2850),
    [anon_sym_private] = ACTIONS(2850),
    [anon_sym_protected] = ACTIONS(2850),
    [anon_sym_using] = ACTIONS(2850),
    [anon_sym_static_assert] = ACTIONS(2850),
    [anon_sym_catch] = ACTIONS(5673),
  },
  [2276] = {
    [sym_identifier] = ACTIONS(5716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5718),
    [anon_sym_COMMA] = ACTIONS(5718),
    [anon_sym_RPAREN] = ACTIONS(5718),
    [anon_sym_LPAREN2] = ACTIONS(5718),
    [anon_sym_DASH] = ACTIONS(5716),
    [anon_sym_PLUS] = ACTIONS(5716),
    [anon_sym_STAR] = ACTIONS(5718),
    [anon_sym_SLASH] = ACTIONS(5716),
    [anon_sym_PERCENT] = ACTIONS(5718),
    [anon_sym_PIPE_PIPE] = ACTIONS(5718),
    [anon_sym_AMP_AMP] = ACTIONS(5718),
    [anon_sym_PIPE] = ACTIONS(5716),
    [anon_sym_CARET] = ACTIONS(5718),
    [anon_sym_AMP] = ACTIONS(5716),
    [anon_sym_EQ_EQ] = ACTIONS(5718),
    [anon_sym_BANG_EQ] = ACTIONS(5718),
    [anon_sym_GT] = ACTIONS(5716),
    [anon_sym_GT_EQ] = ACTIONS(5718),
    [anon_sym_LT_EQ] = ACTIONS(5716),
    [anon_sym_LT] = ACTIONS(5716),
    [anon_sym_LT_LT] = ACTIONS(5718),
    [anon_sym_GT_GT] = ACTIONS(5718),
    [anon_sym_SEMI] = ACTIONS(5718),
    [anon_sym___extension__] = ACTIONS(5716),
    [anon_sym___attribute__] = ACTIONS(5716),
    [anon_sym___based] = ACTIONS(5716),
    [anon_sym_LBRACE] = ACTIONS(5718),
    [anon_sym_RBRACE] = ACTIONS(5718),
    [anon_sym_signed] = ACTIONS(5716),
    [anon_sym_unsigned] = ACTIONS(5716),
    [anon_sym_long] = ACTIONS(5716),
    [anon_sym_short] = ACTIONS(5716),
    [anon_sym_LBRACK] = ACTIONS(5718),
    [anon_sym_RBRACK] = ACTIONS(5718),
    [anon_sym_const] = ACTIONS(5716),
    [anon_sym_constexpr] = ACTIONS(5716),
    [anon_sym_volatile] = ACTIONS(5716),
    [anon_sym_restrict] = ACTIONS(5716),
    [anon_sym___restrict__] = ACTIONS(5716),
    [anon_sym__Atomic] = ACTIONS(5716),
    [anon_sym__Noreturn] = ACTIONS(5716),
    [anon_sym_noreturn] = ACTIONS(5716),
    [anon_sym_mutable] = ACTIONS(5716),
    [anon_sym_constinit] = ACTIONS(5716),
    [anon_sym_consteval] = ACTIONS(5716),
    [anon_sym_PROGMEM] = ACTIONS(5716),
    [aux_sym_primitive_type_token1] = ACTIONS(5716),
    [anon_sym_byte] = ACTIONS(5716),
    [anon_sym_word] = ACTIONS(5716),
    [anon_sym_COLON] = ACTIONS(5718),
    [anon_sym_QMARK] = ACTIONS(5718),
    [anon_sym_LT_EQ_GT] = ACTIONS(5718),
    [anon_sym_or] = ACTIONS(5716),
    [anon_sym_and] = ACTIONS(5716),
    [anon_sym_bitor] = ACTIONS(5716),
    [anon_sym_xor] = ACTIONS(5716),
    [anon_sym_bitand] = ACTIONS(5716),
    [anon_sym_not_eq] = ACTIONS(5716),
    [anon_sym_DASH_DASH] = ACTIONS(5718),
    [anon_sym_PLUS_PLUS] = ACTIONS(5718),
    [anon_sym_DOT] = ACTIONS(5716),
    [anon_sym_DOT_STAR] = ACTIONS(5718),
    [anon_sym_DASH_GT] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5716),
    [anon_sym_decltype] = ACTIONS(5716),
    [anon_sym_final] = ACTIONS(5716),
    [anon_sym_override] = ACTIONS(5716),
    [anon_sym_requires] = ACTIONS(5716),
  },
  [2277] = {
    [sym_identifier] = ACTIONS(5720),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5722),
    [anon_sym_COMMA] = ACTIONS(5722),
    [anon_sym_RPAREN] = ACTIONS(5722),
    [anon_sym_LPAREN2] = ACTIONS(5722),
    [anon_sym_DASH] = ACTIONS(5720),
    [anon_sym_PLUS] = ACTIONS(5720),
    [anon_sym_STAR] = ACTIONS(5722),
    [anon_sym_SLASH] = ACTIONS(5720),
    [anon_sym_PERCENT] = ACTIONS(5722),
    [anon_sym_PIPE_PIPE] = ACTIONS(5722),
    [anon_sym_AMP_AMP] = ACTIONS(5722),
    [anon_sym_PIPE] = ACTIONS(5720),
    [anon_sym_CARET] = ACTIONS(5722),
    [anon_sym_AMP] = ACTIONS(5720),
    [anon_sym_EQ_EQ] = ACTIONS(5722),
    [anon_sym_BANG_EQ] = ACTIONS(5722),
    [anon_sym_GT] = ACTIONS(5720),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_LT_EQ] = ACTIONS(5720),
    [anon_sym_LT] = ACTIONS(5720),
    [anon_sym_LT_LT] = ACTIONS(5722),
    [anon_sym_GT_GT] = ACTIONS(5722),
    [anon_sym_SEMI] = ACTIONS(5722),
    [anon_sym___extension__] = ACTIONS(5720),
    [anon_sym___attribute__] = ACTIONS(5720),
    [anon_sym___based] = ACTIONS(5720),
    [anon_sym_LBRACE] = ACTIONS(5722),
    [anon_sym_RBRACE] = ACTIONS(5722),
    [anon_sym_signed] = ACTIONS(5720),
    [anon_sym_unsigned] = ACTIONS(5720),
    [anon_sym_long] = ACTIONS(5720),
    [anon_sym_short] = ACTIONS(5720),
    [anon_sym_LBRACK] = ACTIONS(5722),
    [anon_sym_RBRACK] = ACTIONS(5722),
    [anon_sym_const] = ACTIONS(5720),
    [anon_sym_constexpr] = ACTIONS(5720),
    [anon_sym_volatile] = ACTIONS(5720),
    [anon_sym_restrict] = ACTIONS(5720),
    [anon_sym___restrict__] = ACTIONS(5720),
    [anon_sym__Atomic] = ACTIONS(5720),
    [anon_sym__Noreturn] = ACTIONS(5720),
    [anon_sym_noreturn] = ACTIONS(5720),
    [anon_sym_mutable] = ACTIONS(5720),
    [anon_sym_constinit] = ACTIONS(5720),
    [anon_sym_consteval] = ACTIONS(5720),
    [anon_sym_PROGMEM] = ACTIONS(5720),
    [aux_sym_primitive_type_token1] = ACTIONS(5720),
    [anon_sym_byte] = ACTIONS(5720),
    [anon_sym_word] = ACTIONS(5720),
    [anon_sym_COLON] = ACTIONS(5722),
    [anon_sym_QMARK] = ACTIONS(5722),
    [anon_sym_LT_EQ_GT] = ACTIONS(5722),
    [anon_sym_or] = ACTIONS(5720),
    [anon_sym_and] = ACTIONS(5720),
    [anon_sym_bitor] = ACTIONS(5720),
    [anon_sym_xor] = ACTIONS(5720),
    [anon_sym_bitand] = ACTIONS(5720),
    [anon_sym_not_eq] = ACTIONS(5720),
    [anon_sym_DASH_DASH] = ACTIONS(5722),
    [anon_sym_PLUS_PLUS] = ACTIONS(5722),
    [anon_sym_DOT] = ACTIONS(5720),
    [anon_sym_DOT_STAR] = ACTIONS(5722),
    [anon_sym_DASH_GT] = ACTIONS(5722),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5720),
    [anon_sym_decltype] = ACTIONS(5720),
    [anon_sym_final] = ACTIONS(5720),
    [anon_sym_override] = ACTIONS(5720),
    [anon_sym_requires] = ACTIONS(5720),
  },
  [2278] = {
    [sym_identifier] = ACTIONS(5724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5726),
    [anon_sym_COMMA] = ACTIONS(5726),
    [anon_sym_RPAREN] = ACTIONS(5726),
    [anon_sym_LPAREN2] = ACTIONS(5726),
    [anon_sym_DASH] = ACTIONS(5724),
    [anon_sym_PLUS] = ACTIONS(5724),
    [anon_sym_STAR] = ACTIONS(5726),
    [anon_sym_SLASH] = ACTIONS(5724),
    [anon_sym_PERCENT] = ACTIONS(5726),
    [anon_sym_PIPE_PIPE] = ACTIONS(5726),
    [anon_sym_AMP_AMP] = ACTIONS(5726),
    [anon_sym_PIPE] = ACTIONS(5724),
    [anon_sym_CARET] = ACTIONS(5726),
    [anon_sym_AMP] = ACTIONS(5724),
    [anon_sym_EQ_EQ] = ACTIONS(5726),
    [anon_sym_BANG_EQ] = ACTIONS(5726),
    [anon_sym_GT] = ACTIONS(5724),
    [anon_sym_GT_EQ] = ACTIONS(5726),
    [anon_sym_LT_EQ] = ACTIONS(5724),
    [anon_sym_LT] = ACTIONS(5724),
    [anon_sym_LT_LT] = ACTIONS(5726),
    [anon_sym_GT_GT] = ACTIONS(5726),
    [anon_sym_SEMI] = ACTIONS(5726),
    [anon_sym___extension__] = ACTIONS(5724),
    [anon_sym___attribute__] = ACTIONS(5724),
    [anon_sym___based] = ACTIONS(5724),
    [anon_sym_LBRACE] = ACTIONS(5726),
    [anon_sym_RBRACE] = ACTIONS(5726),
    [anon_sym_signed] = ACTIONS(5724),
    [anon_sym_unsigned] = ACTIONS(5724),
    [anon_sym_long] = ACTIONS(5724),
    [anon_sym_short] = ACTIONS(5724),
    [anon_sym_LBRACK] = ACTIONS(5726),
    [anon_sym_RBRACK] = ACTIONS(5726),
    [anon_sym_const] = ACTIONS(5724),
    [anon_sym_constexpr] = ACTIONS(5724),
    [anon_sym_volatile] = ACTIONS(5724),
    [anon_sym_restrict] = ACTIONS(5724),
    [anon_sym___restrict__] = ACTIONS(5724),
    [anon_sym__Atomic] = ACTIONS(5724),
    [anon_sym__Noreturn] = ACTIONS(5724),
    [anon_sym_noreturn] = ACTIONS(5724),
    [anon_sym_mutable] = ACTIONS(5724),
    [anon_sym_constinit] = ACTIONS(5724),
    [anon_sym_consteval] = ACTIONS(5724),
    [anon_sym_PROGMEM] = ACTIONS(5724),
    [aux_sym_primitive_type_token1] = ACTIONS(5724),
    [anon_sym_byte] = ACTIONS(5724),
    [anon_sym_word] = ACTIONS(5724),
    [anon_sym_COLON] = ACTIONS(5726),
    [anon_sym_QMARK] = ACTIONS(5726),
    [anon_sym_LT_EQ_GT] = ACTIONS(5726),
    [anon_sym_or] = ACTIONS(5724),
    [anon_sym_and] = ACTIONS(5724),
    [anon_sym_bitor] = ACTIONS(5724),
    [anon_sym_xor] = ACTIONS(5724),
    [anon_sym_bitand] = ACTIONS(5724),
    [anon_sym_not_eq] = ACTIONS(5724),
    [anon_sym_DASH_DASH] = ACTIONS(5726),
    [anon_sym_PLUS_PLUS] = ACTIONS(5726),
    [anon_sym_DOT] = ACTIONS(5724),
    [anon_sym_DOT_STAR] = ACTIONS(5726),
    [anon_sym_DASH_GT] = ACTIONS(5726),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5724),
    [anon_sym_decltype] = ACTIONS(5724),
    [anon_sym_final] = ACTIONS(5724),
    [anon_sym_override] = ACTIONS(5724),
    [anon_sym_requires] = ACTIONS(5724),
  },
  [2279] = {
    [sym_catch_clause] = STATE(2261),
    [aux_sym_constructor_try_statement_repeat1] = STATE(2261),
    [sym_identifier] = ACTIONS(2850),
    [aux_sym_preproc_def_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2850),
    [sym_preproc_directive] = ACTIONS(2850),
    [anon_sym_LPAREN2] = ACTIONS(2852),
    [anon_sym_TILDE] = ACTIONS(2852),
    [anon_sym_STAR] = ACTIONS(2852),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_AMP] = ACTIONS(2850),
    [anon_sym___extension__] = ACTIONS(2850),
    [anon_sym_typedef] = ACTIONS(2850),
    [anon_sym_extern] = ACTIONS(2850),
    [anon_sym___attribute__] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2852),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2852),
    [anon_sym___declspec] = ACTIONS(2850),
    [anon_sym___based] = ACTIONS(2850),
    [anon_sym_RBRACE] = ACTIONS(2852),
    [anon_sym_signed] = ACTIONS(2850),
    [anon_sym_unsigned] = ACTIONS(2850),
    [anon_sym_long] = ACTIONS(2850),
    [anon_sym_short] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2850),
    [anon_sym_register] = ACTIONS(2850),
    [anon_sym_inline] = ACTIONS(2850),
    [anon_sym___inline] = ACTIONS(2850),
    [anon_sym___inline__] = ACTIONS(2850),
    [anon_sym___forceinline] = ACTIONS(2850),
    [anon_sym_thread_local] = ACTIONS(2850),
    [anon_sym___thread] = ACTIONS(2850),
    [anon_sym_const] = ACTIONS(2850),
    [anon_sym_constexpr] = ACTIONS(2850),
    [anon_sym_volatile] = ACTIONS(2850),
    [anon_sym_restrict] = ACTIONS(2850),
    [anon_sym___restrict__] = ACTIONS(2850),
    [anon_sym__Atomic] = ACTIONS(2850),
    [anon_sym__Noreturn] = ACTIONS(2850),
    [anon_sym_noreturn] = ACTIONS(2850),
    [anon_sym_mutable] = ACTIONS(2850),
    [anon_sym_constinit] = ACTIONS(2850),
    [anon_sym_consteval] = ACTIONS(2850),
    [anon_sym_PROGMEM] = ACTIONS(2850),
    [aux_sym_primitive_type_token1] = ACTIONS(2850),
    [anon_sym_byte] = ACTIONS(2850),
    [anon_sym_word] = ACTIONS(2850),
    [anon_sym_enum] = ACTIONS(2850),
    [anon_sym_class] = ACTIONS(2850),
    [anon_sym_struct] = ACTIONS(2850),
    [anon_sym_union] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2850),
    [anon_sym_decltype] = ACTIONS(2850),
    [anon_sym_virtual] = ACTIONS(2850),
    [anon_sym_alignas] = ACTIONS(2850),
    [anon_sym_explicit] = ACTIONS(2850),
    [anon_sym_typename] = ACTIONS(2850),
    [anon_sym_template] = ACTIONS(2850),
    [anon_sym_operator] = ACTIONS(2850),
    [anon_sym_friend] = ACTIONS(2850),
    [anon_sym_public] = ACTIONS(2850),
    [anon_sym_private] = ACTIONS(2850),
    [anon_sym_protected] = ACTIONS(2850),
    [anon_sym_using] = ACTIONS(2850),
    [anon_sym_static_assert] = ACTIONS(2850),
    [anon_sym_catch] = ACTIONS(5728),
  },
  [2280] = {
    [sym_identifier] = ACTIONS(3320),
    [anon_sym_LPAREN2] = ACTIONS(3322),
    [anon_sym_BANG] = ACTIONS(3322),
    [anon_sym_TILDE] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3320),
    [anon_sym_PLUS] = ACTIONS(3320),
    [anon_sym_STAR] = ACTIONS(3322),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym___extension__] = ACTIONS(3320),
    [anon_sym_COLON_COLON] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_RBRACK] = ACTIONS(3322),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_constexpr] = ACTIONS(3320),
    [anon_sym_volatile] = ACTIONS(3320),
    [anon_sym_restrict] = ACTIONS(3320),
    [anon_sym___restrict__] = ACTIONS(3320),
    [anon_sym__Atomic] = ACTIONS(3320),
    [anon_sym__Noreturn] = ACTIONS(3320),
    [anon_sym_noreturn] = ACTIONS(3320),
    [anon_sym_mutable] = ACTIONS(3320),
    [anon_sym_constinit] = ACTIONS(3320),
    [anon_sym_consteval] = ACTIONS(3320),
    [anon_sym_PROGMEM] = ACTIONS(3320),
    [aux_sym_primitive_type_token1] = ACTIONS(3320),
    [anon_sym_byte] = ACTIONS(3320),
    [anon_sym_word] = ACTIONS(3320),
    [anon_sym_not] = ACTIONS(3320),
    [anon_sym_compl] = ACTIONS(3320),
    [anon_sym_DASH_DASH] = ACTIONS(3322),
    [anon_sym_PLUS_PLUS] = ACTIONS(3322),
    [anon_sym_sizeof] = ACTIONS(3320),
    [anon_sym___alignof__] = ACTIONS(3320),
    [anon_sym___alignof] = ACTIONS(3320),
    [anon_sym__alignof] = ACTIONS(3320),
    [anon_sym_alignof] = ACTIONS(3320),
    [anon_sym__Alignof] = ACTIONS(3320),
    [anon_sym_offsetof] = ACTIONS(3320),
    [anon_sym__Generic] = ACTIONS(3320),
    [anon_sym_asm] = ACTIONS(3320),
    [anon_sym___asm__] = ACTIONS(3320),
    [aux_sym_number_literal_token1] = ACTIONS(3322),
    [aux_sym_number_literal_token2] = ACTIONS(3320),
    [anon_sym_L_SQUOTE] = ACTIONS(3322),
    [anon_sym_u_SQUOTE] = ACTIONS(3322),
    [anon_sym_U_SQUOTE] = ACTIONS(3322),
    [anon_sym_u8_SQUOTE] = ACTIONS(3322),
    [anon_sym_SQUOTE] = ACTIONS(3322),
    [anon_sym_L_DQUOTE] = ACTIONS(3322),
    [anon_sym_u_DQUOTE] = ACTIONS(3322),
    [anon_sym_U_DQUOTE] = ACTIONS(3322),
    [anon_sym_u8_DQUOTE] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [sym_true] = ACTIONS(3320),
    [sym_false] = ACTIONS(3320),
    [anon_sym_NULL] = ACTIONS(3320),
    [anon_sym_nullptr] = ACTIONS(3320),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3320),
    [anon_sym_template] = ACTIONS(3320),
    [anon_sym_delete] = ACTIONS(3320),
    [anon_sym_R_DQUOTE] = ACTIONS(3322),
    [anon_sym_LR_DQUOTE] = ACTIONS(3322),
    [anon_sym_uR_DQUOTE] = ACTIONS(3322),
    [anon_sym_UR_DQUOTE] = ACTIONS(3322),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3322),
    [anon_sym_co_await] = ACTIONS(3320),
    [anon_sym_new] = ACTIONS(3320),
    [anon_sym_requires] = ACTIONS(3320),
    [sym_this] = ACTIONS(3320),
  },
  [2281] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2063),
    [sym_identifier] = ACTIONS(5363),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5730),
    [anon_sym_COMMA] = ACTIONS(5730),
    [anon_sym_RPAREN] = ACTIONS(5730),
    [anon_sym_LPAREN2] = ACTIONS(5730),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_PLUS] = ACTIONS(5733),
    [anon_sym_STAR] = ACTIONS(5730),
    [anon_sym_SLASH] = ACTIONS(5733),
    [anon_sym_PERCENT] = ACTIONS(5730),
    [anon_sym_PIPE_PIPE] = ACTIONS(5730),
    [anon_sym_AMP_AMP] = ACTIONS(5730),
    [anon_sym_PIPE] = ACTIONS(5733),
    [anon_sym_CARET] = ACTIONS(5730),
    [anon_sym_AMP] = ACTIONS(5733),
    [anon_sym_EQ_EQ] = ACTIONS(5730),
    [anon_sym_BANG_EQ] = ACTIONS(5730),
    [anon_sym_GT] = ACTIONS(5733),
    [anon_sym_GT_EQ] = ACTIONS(5730),
    [anon_sym_LT_EQ] = ACTIONS(5733),
    [anon_sym_LT] = ACTIONS(5733),
    [anon_sym_LT_LT] = ACTIONS(5730),
    [anon_sym_GT_GT] = ACTIONS(5730),
    [anon_sym_SEMI] = ACTIONS(5730),
    [anon_sym___extension__] = ACTIONS(5733),
    [anon_sym___attribute__] = ACTIONS(5733),
    [anon_sym_LBRACE] = ACTIONS(5730),
    [anon_sym_RBRACE] = ACTIONS(5730),
    [anon_sym_signed] = ACTIONS(5367),
    [anon_sym_unsigned] = ACTIONS(5367),
    [anon_sym_long] = ACTIONS(5367),
    [anon_sym_short] = ACTIONS(5367),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_RBRACK] = ACTIONS(5730),
    [anon_sym_const] = ACTIONS(5733),
    [anon_sym_constexpr] = ACTIONS(5733),
    [anon_sym_volatile] = ACTIONS(5733),
    [anon_sym_restrict] = ACTIONS(5733),
    [anon_sym___restrict__] = ACTIONS(5733),
    [anon_sym__Atomic] = ACTIONS(5733),
    [anon_sym__Noreturn] = ACTIONS(5733),
    [anon_sym_noreturn] = ACTIONS(5733),
    [anon_sym_mutable] = ACTIONS(5733),
    [anon_sym_constinit] = ACTIONS(5733),
    [anon_sym_consteval] = ACTIONS(5733),
    [anon_sym_PROGMEM] = ACTIONS(5733),
    [aux_sym_primitive_type_token1] = ACTIONS(5363),
    [anon_sym_byte] = ACTIONS(5363),
    [anon_sym_word] = ACTIONS(5363),
    [anon_sym_COLON] = ACTIONS(5730),
    [anon_sym_QMARK] = ACTIONS(5730),
    [anon_sym_LT_EQ_GT] = ACTIONS(5730),
    [anon_sym_or] = ACTIONS(5733),
    [anon_sym_and] = ACTIONS(5733),
    [anon_sym_bitor] = ACTIONS(5733),
    [anon_sym_xor] = ACTIONS(5733),
    [anon_sym_bitand] = ACTIONS(5733),
    [anon_sym_not_eq] = ACTIONS(5733),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_DOT] = ACTIONS(5733),
    [anon_sym_DOT_STAR] = ACTIONS(5730),
    [anon_sym_DASH_GT] = ACTIONS(5730),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5733),
    [anon_sym_decltype] = ACTIONS(5733),
    [anon_sym_final] = ACTIONS(5733),
    [anon_sym_override] = ACTIONS(5733),
    [anon_sym_requires] = ACTIONS(5733),
  },
  [2282] = {
    [sym__declaration_modifiers] = STATE(3676),
    [sym_attribute_specifier] = STATE(3676),
    [sym_attribute_declaration] = STATE(3676),
    [sym_ms_declspec_modifier] = STATE(3676),
    [sym_storage_class_specifier] = STATE(3676),
    [sym_type_qualifier] = STATE(3676),
    [sym__type_specifier] = STATE(2892),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3676),
    [sym_alignas_specifier] = STATE(3676),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7326),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(3676),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5095),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5105),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2023),
    [anon_sym_struct] = ACTIONS(2025),
    [anon_sym_union] = ACTIONS(2027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2053),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2283] = {
    [sym__declaration_modifiers] = STATE(3676),
    [sym_attribute_specifier] = STATE(3676),
    [sym_attribute_declaration] = STATE(3676),
    [sym_ms_declspec_modifier] = STATE(3676),
    [sym_storage_class_specifier] = STATE(3676),
    [sym_type_qualifier] = STATE(3676),
    [sym__type_specifier] = STATE(2892),
    [sym_sized_type_specifier] = STATE(3087),
    [sym_primitive_type] = STATE(3282),
    [sym_enum_specifier] = STATE(3087),
    [sym_struct_specifier] = STATE(3087),
    [sym_union_specifier] = STATE(3087),
    [sym_placeholder_type_specifier] = STATE(3087),
    [sym_decltype_auto] = STATE(3140),
    [sym_decltype] = STATE(3039),
    [sym_class_specifier] = STATE(3087),
    [sym_virtual] = STATE(3676),
    [sym_alignas_specifier] = STATE(3676),
    [sym_dependent_type] = STATE(3087),
    [sym_template_type] = STATE(3039),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(7338),
    [sym_qualified_type_identifier] = STATE(3893),
    [aux_sym__declaration_specifiers_repeat1] = STATE(3676),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2899),
    [sym_identifier] = ACTIONS(5204),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(5206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(1436),
  },
  [2284] = {
    [sym_identifier] = ACTIONS(5736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5738),
    [anon_sym_COMMA] = ACTIONS(5738),
    [anon_sym_RPAREN] = ACTIONS(5738),
    [anon_sym_LPAREN2] = ACTIONS(5738),
    [anon_sym_DASH] = ACTIONS(5736),
    [anon_sym_PLUS] = ACTIONS(5736),
    [anon_sym_STAR] = ACTIONS(5738),
    [anon_sym_SLASH] = ACTIONS(5736),
    [anon_sym_PERCENT] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5738),
    [anon_sym_AMP_AMP] = ACTIONS(5738),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_CARET] = ACTIONS(5738),
    [anon_sym_AMP] = ACTIONS(5736),
    [anon_sym_EQ_EQ] = ACTIONS(5738),
    [anon_sym_BANG_EQ] = ACTIONS(5738),
    [anon_sym_GT] = ACTIONS(5736),
    [anon_sym_GT_EQ] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5736),
    [anon_sym_LT] = ACTIONS(5736),
    [anon_sym_LT_LT] = ACTIONS(5738),
    [anon_sym_GT_GT] = ACTIONS(5738),
    [anon_sym_SEMI] = ACTIONS(5738),
    [anon_sym___extension__] = ACTIONS(5736),
    [anon_sym___attribute__] = ACTIONS(5736),
    [anon_sym___based] = ACTIONS(5736),
    [anon_sym_LBRACE] = ACTIONS(5738),
    [anon_sym_RBRACE] = ACTIONS(5738),
    [anon_sym_signed] = ACTIONS(5736),
    [anon_sym_unsigned] = ACTIONS(5736),
    [anon_sym_long] = ACTIONS(5736),
    [anon_sym_short] = ACTIONS(5736),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_RBRACK] = ACTIONS(5738),
    [anon_sym_const] = ACTIONS(5736),
    [anon_sym_constexpr] = ACTIONS(5736),
    [anon_sym_volatile] = ACTIONS(5736),
    [anon_sym_restrict] = ACTIONS(5736),
    [anon_sym___restrict__] = ACTIONS(5736),
    [anon_sym__Atomic] = ACTIONS(5736),
    [anon_sym__Noreturn] = ACTIONS(5736),
    [anon_sym_noreturn] = ACTIONS(5736),
    [anon_sym_mutable] = ACTIONS(5736),
    [anon_sym_constinit] = ACTIONS(5736),
    [anon_sym_consteval] = ACTIONS(5736),
    [anon_sym_PROGMEM] = ACTIONS(5736),
    [aux_sym_primitive_type_token1] = ACTIONS(5736),
    [anon_sym_byte] = ACTIONS(5736),
    [anon_sym_word] = ACTIONS(5736),
    [anon_sym_COLON] = ACTIONS(5738),
    [anon_sym_QMARK] = ACTIONS(5738),
    [anon_sym_LT_EQ_GT] = ACTIONS(5738),
    [anon_sym_or] = ACTIONS(5736),
    [anon_sym_and] = ACTIONS(5736),
    [anon_sym_bitor] = ACTIONS(5736),
    [anon_sym_xor] = ACTIONS(5736),
    [anon_sym_bitand] = ACTIONS(5736),
    [anon_sym_not_eq] = ACTIONS(5736),
    [anon_sym_DASH_DASH] = ACTIONS(5738),
    [anon_sym_PLUS_PLUS] = ACTIONS(5738),
    [anon_sym_DOT] = ACTIONS(5736),
    [anon_sym_DOT_STAR] = ACTIONS(5738),
    [anon_sym_DASH_GT] = ACTIONS(5738),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5736),
    [anon_sym_decltype] = ACTIONS(5736),
    [anon_sym_final] = ACTIONS(5736),
    [anon_sym_override] = ACTIONS(5736),
    [anon_sym_requires] = ACTIONS(5736),
  },
  [2285] = {
    [sym_identifier] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5742),
    [anon_sym_COMMA] = ACTIONS(5742),
    [anon_sym_RPAREN] = ACTIONS(5742),
    [anon_sym_LPAREN2] = ACTIONS(5742),
    [anon_sym_DASH] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5740),
    [anon_sym_STAR] = ACTIONS(5742),
    [anon_sym_SLASH] = ACTIONS(5740),
    [anon_sym_PERCENT] = ACTIONS(5742),
    [anon_sym_PIPE_PIPE] = ACTIONS(5742),
    [anon_sym_AMP_AMP] = ACTIONS(5742),
    [anon_sym_PIPE] = ACTIONS(5740),
    [anon_sym_CARET] = ACTIONS(5742),
    [anon_sym_AMP] = ACTIONS(5740),
    [anon_sym_EQ_EQ] = ACTIONS(5742),
    [anon_sym_BANG_EQ] = ACTIONS(5742),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5742),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_LT_LT] = ACTIONS(5742),
    [anon_sym_GT_GT] = ACTIONS(5742),
    [anon_sym_SEMI] = ACTIONS(5742),
    [anon_sym___extension__] = ACTIONS(5740),
    [anon_sym___attribute__] = ACTIONS(5740),
    [anon_sym___based] = ACTIONS(5740),
    [anon_sym_LBRACE] = ACTIONS(5742),
    [anon_sym_RBRACE] = ACTIONS(5742),
    [anon_sym_signed] = ACTIONS(5740),
    [anon_sym_unsigned] = ACTIONS(5740),
    [anon_sym_long] = ACTIONS(5740),
    [anon_sym_short] = ACTIONS(5740),
    [anon_sym_LBRACK] = ACTIONS(5742),
    [anon_sym_RBRACK] = ACTIONS(5742),
    [anon_sym_const] = ACTIONS(5740),
    [anon_sym_constexpr] = ACTIONS(5740),
    [anon_sym_volatile] = ACTIONS(5740),
    [anon_sym_restrict] = ACTIONS(5740),
    [anon_sym___restrict__] = ACTIONS(5740),
    [anon_sym__Atomic] = ACTIONS(5740),
    [anon_sym__Noreturn] = ACTIONS(5740),
    [anon_sym_noreturn] = ACTIONS(5740),
    [anon_sym_mutable] = ACTIONS(5740),
    [anon_sym_constinit] = ACTIONS(5740),
    [anon_sym_consteval] = ACTIONS(5740),
    [anon_sym_PROGMEM] = ACTIONS(5740),
    [aux_sym_primitive_type_token1] = ACTIONS(5740),
    [anon_sym_byte] = ACTIONS(5740),
    [anon_sym_word] = ACTIONS(5740),
    [anon_sym_COLON] = ACTIONS(5742),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_LT_EQ_GT] = ACTIONS(5742),
    [anon_sym_or] = ACTIONS(5740),
    [anon_sym_and] = ACTIONS(5740),
    [anon_sym_bitor] = ACTIONS(5740),
    [anon_sym_xor] = ACTIONS(5740),
    [anon_sym_bitand] = ACTIONS(5740),
    [anon_sym_not_eq] = ACTIONS(5740),
    [anon_sym_DASH_DASH] = ACTIONS(5742),
    [anon_sym_PLUS_PLUS] = ACTIONS(5742),
    [anon_sym_DOT] = ACTIONS(5740),
    [anon_sym_DOT_STAR] = ACTIONS(5742),
    [anon_sym_DASH_GT] = ACTIONS(5742),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5740),
    [anon_sym_decltype] = ACTIONS(5740),
    [anon_sym_final] = ACTIONS(5740),
    [anon_sym_override] = ACTIONS(5740),
    [anon_sym_requires] = ACTIONS(5740),
  },
  [2286] = {
    [sym_catch_clause] = STATE(2286),
    [aux_sym_constructor_try_statement_repeat1] = STATE(2286),
    [sym_identifier] = ACTIONS(2843),
    [aux_sym_preproc_def_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token2] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2843),
    [sym_preproc_directive] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym___extension__] = ACTIONS(2843),
    [anon_sym_typedef] = ACTIONS(2843),
    [anon_sym_extern] = ACTIONS(2843),
    [anon_sym___attribute__] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2845),
    [anon_sym___declspec] = ACTIONS(2843),
    [anon_sym___based] = ACTIONS(2843),
    [anon_sym_signed] = ACTIONS(2843),
    [anon_sym_unsigned] = ACTIONS(2843),
    [anon_sym_long] = ACTIONS(2843),
    [anon_sym_short] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_register] = ACTIONS(2843),
    [anon_sym_inline] = ACTIONS(2843),
    [anon_sym___inline] = ACTIONS(2843),
    [anon_sym___inline__] = ACTIONS(2843),
    [anon_sym___forceinline] = ACTIONS(2843),
    [anon_sym_thread_local] = ACTIONS(2843),
    [anon_sym___thread] = ACTIONS(2843),
    [anon_sym_const] = ACTIONS(2843),
    [anon_sym_constexpr] = ACTIONS(2843),
    [anon_sym_volatile] = ACTIONS(2843),
    [anon_sym_restrict] = ACTIONS(2843),
    [anon_sym___restrict__] = ACTIONS(2843),
    [anon_sym__Atomic] = ACTIONS(2843),
    [anon_sym__Noreturn] = ACTIONS(2843),
    [anon_sym_noreturn] = ACTIONS(2843),
    [anon_sym_mutable] = ACTIONS(2843),
    [anon_sym_constinit] = ACTIONS(2843),
    [anon_sym_consteval] = ACTIONS(2843),
    [anon_sym_PROGMEM] = ACTIONS(2843),
    [aux_sym_primitive_type_token1] = ACTIONS(2843),
    [anon_sym_byte] = ACTIONS(2843),
    [anon_sym_word] = ACTIONS(2843),
    [anon_sym_enum] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2843),
    [anon_sym_union] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2843),
    [anon_sym_decltype] = ACTIONS(2843),
    [anon_sym_virtual] = ACTIONS(2843),
    [anon_sym_alignas] = ACTIONS(2843),
    [anon_sym_explicit] = ACTIONS(2843),
    [anon_sym_typename] = ACTIONS(2843),
    [anon_sym_template] = ACTIONS(2843),
    [anon_sym_operator] = ACTIONS(2843),
    [anon_sym_friend] = ACTIONS(2843),
    [anon_sym_public] = ACTIONS(2843),
    [anon_sym_private] = ACTIONS(2843),
    [anon_sym_protected] = ACTIONS(2843),
    [anon_sym_using] = ACTIONS(2843),
    [anon_sym_static_assert] = ACTIONS(2843),
    [anon_sym_catch] = ACTIONS(5744),
  },
  [2287] = {
    [sym_identifier] = ACTIONS(5747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5749),
    [anon_sym_COMMA] = ACTIONS(5749),
    [anon_sym_RPAREN] = ACTIONS(5749),
    [anon_sym_LPAREN2] = ACTIONS(5749),
    [anon_sym_DASH] = ACTIONS(5747),
    [anon_sym_PLUS] = ACTIONS(5747),
    [anon_sym_STAR] = ACTIONS(5749),
    [anon_sym_SLASH] = ACTIONS(5747),
    [anon_sym_PERCENT] = ACTIONS(5749),
    [anon_sym_PIPE_PIPE] = ACTIONS(5749),
    [anon_sym_AMP_AMP] = ACTIONS(5749),
    [anon_sym_PIPE] = ACTIONS(5747),
    [anon_sym_CARET] = ACTIONS(5749),
    [anon_sym_AMP] = ACTIONS(5747),
    [anon_sym_EQ_EQ] = ACTIONS(5749),
    [anon_sym_BANG_EQ] = ACTIONS(5749),
    [anon_sym_GT] = ACTIONS(5747),
    [anon_sym_GT_EQ] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5747),
    [anon_sym_LT_LT] = ACTIONS(5749),
    [anon_sym_GT_GT] = ACTIONS(5749),
    [anon_sym_SEMI] = ACTIONS(5749),
    [anon_sym___extension__] = ACTIONS(5747),
    [anon_sym___attribute__] = ACTIONS(5747),
    [anon_sym___based] = ACTIONS(5747),
    [anon_sym_LBRACE] = ACTIONS(5749),
    [anon_sym_RBRACE] = ACTIONS(5749),
    [anon_sym_signed] = ACTIONS(5747),
    [anon_sym_unsigned] = ACTIONS(5747),
    [anon_sym_long] = ACTIONS(5747),
    [anon_sym_short] = ACTIONS(5747),
    [anon_sym_LBRACK] = ACTIONS(5749),
    [anon_sym_RBRACK] = ACTIONS(5749),
    [anon_sym_const] = ACTIONS(5747),
    [anon_sym_constexpr] = ACTIONS(5747),
    [anon_sym_volatile] = ACTIONS(5747),
    [anon_sym_restrict] = ACTIONS(5747),
    [anon_sym___restrict__] = ACTIONS(5747),
    [anon_sym__Atomic] = ACTIONS(5747),
    [anon_sym__Noreturn] = ACTIONS(5747),
    [anon_sym_noreturn] = ACTIONS(5747),
    [anon_sym_mutable] = ACTIONS(5747),
    [anon_sym_constinit] = ACTIONS(5747),
    [anon_sym_consteval] = ACTIONS(5747),
    [anon_sym_PROGMEM] = ACTIONS(5747),
    [aux_sym_primitive_type_token1] = ACTIONS(5747),
    [anon_sym_byte] = ACTIONS(5747),
    [anon_sym_word] = ACTIONS(5747),
    [anon_sym_COLON] = ACTIONS(5749),
    [anon_sym_QMARK] = ACTIONS(5749),
    [anon_sym_LT_EQ_GT] = ACTIONS(5749),
    [anon_sym_or] = ACTIONS(5747),
    [anon_sym_and] = ACTIONS(5747),
    [anon_sym_bitor] = ACTIONS(5747),
    [anon_sym_xor] = ACTIONS(5747),
    [anon_sym_bitand] = ACTIONS(5747),
    [anon_sym_not_eq] = ACTIONS(5747),
    [anon_sym_DASH_DASH] = ACTIONS(5749),
    [anon_sym_PLUS_PLUS] = ACTIONS(5749),
    [anon_sym_DOT] = ACTIONS(5747),
    [anon_sym_DOT_STAR] = ACTIONS(5749),
    [anon_sym_DASH_GT] = ACTIONS(5749),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5747),
    [anon_sym_decltype] = ACTIONS(5747),
    [anon_sym_final] = ACTIONS(5747),
    [anon_sym_override] = ACTIONS(5747),
    [anon_sym_requires] = ACTIONS(5747),
  },
  [2288] = {
    [sym_catch_clause] = STATE(2261),
    [aux_sym_constructor_try_statement_repeat1] = STATE(2261),
    [sym_identifier] = ACTIONS(2856),
    [aux_sym_preproc_def_token1] = ACTIONS(2856),
    [aux_sym_preproc_if_token1] = ACTIONS(2856),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2856),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2856),
    [sym_preproc_directive] = ACTIONS(2856),
    [anon_sym_LPAREN2] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_STAR] = ACTIONS(2858),
    [anon_sym_AMP_AMP] = ACTIONS(2858),
    [anon_sym_AMP] = ACTIONS(2856),
    [anon_sym___extension__] = ACTIONS(2856),
    [anon_sym_typedef] = ACTIONS(2856),
    [anon_sym_extern] = ACTIONS(2856),
    [anon_sym___attribute__] = ACTIONS(2856),
    [anon_sym_COLON_COLON] = ACTIONS(2858),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2858),
    [anon_sym___declspec] = ACTIONS(2856),
    [anon_sym___based] = ACTIONS(2856),
    [anon_sym_RBRACE] = ACTIONS(2858),
    [anon_sym_signed] = ACTIONS(2856),
    [anon_sym_unsigned] = ACTIONS(2856),
    [anon_sym_long] = ACTIONS(2856),
    [anon_sym_short] = ACTIONS(2856),
    [anon_sym_LBRACK] = ACTIONS(2856),
    [anon_sym_static] = ACTIONS(2856),
    [anon_sym_register] = ACTIONS(2856),
    [anon_sym_inline] = ACTIONS(2856),
    [anon_sym___inline] = ACTIONS(2856),
    [anon_sym___inline__] = ACTIONS(2856),
    [anon_sym___forceinline] = ACTIONS(2856),
    [anon_sym_thread_local] = ACTIONS(2856),
    [anon_sym___thread] = ACTIONS(2856),
    [anon_sym_const] = ACTIONS(2856),
    [anon_sym_constexpr] = ACTIONS(2856),
    [anon_sym_volatile] = ACTIONS(2856),
    [anon_sym_restrict] = ACTIONS(2856),
    [anon_sym___restrict__] = ACTIONS(2856),
    [anon_sym__Atomic] = ACTIONS(2856),
    [anon_sym__Noreturn] = ACTIONS(2856),
    [anon_sym_noreturn] = ACTIONS(2856),
    [anon_sym_mutable] = ACTIONS(2856),
    [anon_sym_constinit] = ACTIONS(2856),
    [anon_sym_consteval] = ACTIONS(2856),
    [anon_sym_PROGMEM] = ACTIONS(2856),
    [aux_sym_primitive_type_token1] = ACTIONS(2856),
    [anon_sym_byte] = ACTIONS(2856),
    [anon_sym_word] = ACTIONS(2856),
    [anon_sym_enum] = ACTIONS(2856),
    [anon_sym_class] = ACTIONS(2856),
    [anon_sym_struct] = ACTIONS(2856),
    [anon_sym_union] = ACTIONS(2856),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2856),
    [anon_sym_decltype] = ACTIONS(2856),
    [anon_sym_virtual] = ACTIONS(2856),
    [anon_sym_alignas] = ACTIONS(2856),
    [anon_sym_explicit] = ACTIONS(2856),
    [anon_sym_typename] = ACTIONS(2856),
    [anon_sym_template] = ACTIONS(2856),
    [anon_sym_operator] = ACTIONS(2856),
    [anon_sym_friend] = ACTIONS(2856),
    [anon_sym_public] = ACTIONS(2856),
    [anon_sym_private] = ACTIONS(2856),
    [anon_sym_protected] = ACTIONS(2856),
    [anon_sym_using] = ACTIONS(2856),
    [anon_sym_static_assert] = ACTIONS(2856),
    [anon_sym_catch] = ACTIONS(5728),
  },
  [2289] = {
    [sym_identifier] = ACTIONS(5751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5753),
    [anon_sym_COMMA] = ACTIONS(5753),
    [anon_sym_RPAREN] = ACTIONS(5753),
    [anon_sym_LPAREN2] = ACTIONS(5753),
    [anon_sym_DASH] = ACTIONS(5751),
    [anon_sym_PLUS] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5751),
    [anon_sym_PERCENT] = ACTIONS(5753),
    [anon_sym_PIPE_PIPE] = ACTIONS(5753),
    [anon_sym_AMP_AMP] = ACTIONS(5753),
    [anon_sym_PIPE] = ACTIONS(5751),
    [anon_sym_CARET] = ACTIONS(5753),
    [anon_sym_AMP] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5753),
    [anon_sym_BANG_EQ] = ACTIONS(5753),
    [anon_sym_GT] = ACTIONS(5751),
    [anon_sym_GT_EQ] = ACTIONS(5753),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_LT] = ACTIONS(5751),
    [anon_sym_LT_LT] = ACTIONS(5753),
    [anon_sym_GT_GT] = ACTIONS(5753),
    [anon_sym_SEMI] = ACTIONS(5753),
    [anon_sym___extension__] = ACTIONS(5751),
    [anon_sym___attribute__] = ACTIONS(5751),
    [anon_sym___based] = ACTIONS(5751),
    [anon_sym_LBRACE] = ACTIONS(5753),
    [anon_sym_RBRACE] = ACTIONS(5753),
    [anon_sym_signed] = ACTIONS(5751),
    [anon_sym_unsigned] = ACTIONS(5751),
    [anon_sym_long] = ACTIONS(5751),
    [anon_sym_short] = ACTIONS(5751),
    [anon_sym_LBRACK] = ACTIONS(5753),
    [anon_sym_RBRACK] = ACTIONS(5753),
    [anon_sym_const] = ACTIONS(5751),
    [anon_sym_constexpr] = ACTIONS(5751),
    [anon_sym_volatile] = ACTIONS(5751),
    [anon_sym_restrict] = ACTIONS(5751),
    [anon_sym___restrict__] = ACTIONS(5751),
    [anon_sym__Atomic] = ACTIONS(5751),
    [anon_sym__Noreturn] = ACTIONS(5751),
    [anon_sym_noreturn] = ACTIONS(5751),
    [anon_sym_mutable] = ACTIONS(5751),
    [anon_sym_constinit] = ACTIONS(5751),
    [anon_sym_consteval] = ACTIONS(5751),
    [anon_sym_PROGMEM] = ACTIONS(5751),
    [aux_sym_primitive_type_token1] = ACTIONS(5751),
    [anon_sym_byte] = ACTIONS(5751),
    [anon_sym_word] = ACTIONS(5751),
    [anon_sym_COLON] = ACTIONS(5753),
    [anon_sym_QMARK] = ACTIONS(5753),
    [anon_sym_LT_EQ_GT] = ACTIONS(5753),
    [anon_sym_or] = ACTIONS(5751),
    [anon_sym_and] = ACTIONS(5751),
    [anon_sym_bitor] = ACTIONS(5751),
    [anon_sym_xor] = ACTIONS(5751),
    [anon_sym_bitand] = ACTIONS(5751),
    [anon_sym_not_eq] = ACTIONS(5751),
    [anon_sym_DASH_DASH] = ACTIONS(5753),
    [anon_sym_PLUS_PLUS] = ACTIONS(5753),
    [anon_sym_DOT] = ACTIONS(5751),
    [anon_sym_DOT_STAR] = ACTIONS(5753),
    [anon_sym_DASH_GT] = ACTIONS(5753),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5751),
    [anon_sym_decltype] = ACTIONS(5751),
    [anon_sym_final] = ACTIONS(5751),
    [anon_sym_override] = ACTIONS(5751),
    [anon_sym_requires] = ACTIONS(5751),
  },
  [2290] = {
    [sym_identifier] = ACTIONS(5755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5757),
    [anon_sym_COMMA] = ACTIONS(5757),
    [anon_sym_RPAREN] = ACTIONS(5757),
    [anon_sym_LPAREN2] = ACTIONS(5757),
    [anon_sym_DASH] = ACTIONS(5755),
    [anon_sym_PLUS] = ACTIONS(5755),
    [anon_sym_STAR] = ACTIONS(5757),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_PERCENT] = ACTIONS(5757),
    [anon_sym_PIPE_PIPE] = ACTIONS(5757),
    [anon_sym_AMP_AMP] = ACTIONS(5757),
    [anon_sym_PIPE] = ACTIONS(5755),
    [anon_sym_CARET] = ACTIONS(5757),
    [anon_sym_AMP] = ACTIONS(5755),
    [anon_sym_EQ_EQ] = ACTIONS(5757),
    [anon_sym_BANG_EQ] = ACTIONS(5757),
    [anon_sym_GT] = ACTIONS(5755),
    [anon_sym_GT_EQ] = ACTIONS(5757),
    [anon_sym_LT_EQ] = ACTIONS(5755),
    [anon_sym_LT] = ACTIONS(5755),
    [anon_sym_LT_LT] = ACTIONS(5757),
    [anon_sym_GT_GT] = ACTIONS(5757),
    [anon_sym_SEMI] = ACTIONS(5757),
    [anon_sym___extension__] = ACTIONS(5755),
    [anon_sym___attribute__] = ACTIONS(5755),
    [anon_sym___based] = ACTIONS(5755),
    [anon_sym_LBRACE] = ACTIONS(5757),
    [anon_sym_RBRACE] = ACTIONS(5757),
    [anon_sym_signed] = ACTIONS(5755),
    [anon_sym_unsigned] = ACTIONS(5755),
    [anon_sym_long] = ACTIONS(5755),
    [anon_sym_short] = ACTIONS(5755),
    [anon_sym_LBRACK] = ACTIONS(5757),
    [anon_sym_RBRACK] = ACTIONS(5757),
    [anon_sym_const] = ACTIONS(5755),
    [anon_sym_constexpr] = ACTIONS(5755),
    [anon_sym_volatile] = ACTIONS(5755),
    [anon_sym_restrict] = ACTIONS(5755),
    [anon_sym___restrict__] = ACTIONS(5755),
    [anon_sym__Atomic] = ACTIONS(5755),
    [anon_sym__Noreturn] = ACTIONS(5755),
    [anon_sym_noreturn] = ACTIONS(5755),
    [anon_sym_mutable] = ACTIONS(5755),
    [anon_sym_constinit] = ACTIONS(5755),
    [anon_sym_consteval] = ACTIONS(5755),
    [anon_sym_PROGMEM] = ACTIONS(5755),
    [aux_sym_primitive_type_token1] = ACTIONS(5755),
    [anon_sym_byte] = ACTIONS(5755),
    [anon_sym_word] = ACTIONS(5755),
    [anon_sym_COLON] = ACTIONS(5757),
    [anon_sym_QMARK] = ACTIONS(5757),
    [anon_sym_LT_EQ_GT] = ACTIONS(5757),
    [anon_sym_or] = ACTIONS(5755),
    [anon_sym_and] = ACTIONS(5755),
    [anon_sym_bitor] = ACTIONS(5755),
    [anon_sym_xor] = ACTIONS(5755),
    [anon_sym_bitand] = ACTIONS(5755),
    [anon_sym_not_eq] = ACTIONS(5755),
    [anon_sym_DASH_DASH] = ACTIONS(5757),
    [anon_sym_PLUS_PLUS] = ACTIONS(5757),
    [anon_sym_DOT] = ACTIONS(5755),
    [anon_sym_DOT_STAR] = ACTIONS(5757),
    [anon_sym_DASH_GT] = ACTIONS(5757),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5755),
    [anon_sym_decltype] = ACTIONS(5755),
    [anon_sym_final] = ACTIONS(5755),
    [anon_sym_override] = ACTIONS(5755),
    [anon_sym_requires] = ACTIONS(5755),
  },
  [2291] = {
    [sym_identifier] = ACTIONS(5759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5761),
    [anon_sym_COMMA] = ACTIONS(5761),
    [anon_sym_RPAREN] = ACTIONS(5761),
    [anon_sym_LPAREN2] = ACTIONS(5761),
    [anon_sym_TILDE] = ACTIONS(5761),
    [anon_sym_STAR] = ACTIONS(5761),
    [anon_sym_AMP_AMP] = ACTIONS(5761),
    [anon_sym_AMP] = ACTIONS(5759),
    [anon_sym_SEMI] = ACTIONS(5761),
    [anon_sym___extension__] = ACTIONS(5759),
    [anon_sym_extern] = ACTIONS(5759),
    [anon_sym___attribute__] = ACTIONS(5759),
    [anon_sym_COLON_COLON] = ACTIONS(5761),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5761),
    [anon_sym___declspec] = ACTIONS(5759),
    [anon_sym___based] = ACTIONS(5759),
    [anon_sym_LBRACE] = ACTIONS(5761),
    [anon_sym_signed] = ACTIONS(5759),
    [anon_sym_unsigned] = ACTIONS(5759),
    [anon_sym_long] = ACTIONS(5759),
    [anon_sym_short] = ACTIONS(5759),
    [anon_sym_LBRACK] = ACTIONS(5759),
    [anon_sym_EQ] = ACTIONS(5761),
    [anon_sym_static] = ACTIONS(5759),
    [anon_sym_register] = ACTIONS(5759),
    [anon_sym_inline] = ACTIONS(5759),
    [anon_sym___inline] = ACTIONS(5759),
    [anon_sym___inline__] = ACTIONS(5759),
    [anon_sym___forceinline] = ACTIONS(5759),
    [anon_sym_thread_local] = ACTIONS(5759),
    [anon_sym___thread] = ACTIONS(5759),
    [anon_sym_const] = ACTIONS(5759),
    [anon_sym_constexpr] = ACTIONS(5759),
    [anon_sym_volatile] = ACTIONS(5759),
    [anon_sym_restrict] = ACTIONS(5759),
    [anon_sym___restrict__] = ACTIONS(5759),
    [anon_sym__Atomic] = ACTIONS(5759),
    [anon_sym__Noreturn] = ACTIONS(5759),
    [anon_sym_noreturn] = ACTIONS(5759),
    [anon_sym_mutable] = ACTIONS(5759),
    [anon_sym_constinit] = ACTIONS(5759),
    [anon_sym_consteval] = ACTIONS(5759),
    [anon_sym_PROGMEM] = ACTIONS(5759),
    [aux_sym_primitive_type_token1] = ACTIONS(5759),
    [anon_sym_byte] = ACTIONS(5759),
    [anon_sym_word] = ACTIONS(5759),
    [anon_sym_enum] = ACTIONS(5759),
    [anon_sym_class] = ACTIONS(5759),
    [anon_sym_struct] = ACTIONS(5759),
    [anon_sym_union] = ACTIONS(5759),
    [anon_sym_asm] = ACTIONS(5759),
    [anon_sym___asm__] = ACTIONS(5759),
    [anon_sym_DASH_GT] = ACTIONS(5761),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5759),
    [anon_sym_decltype] = ACTIONS(5759),
    [anon_sym_final] = ACTIONS(5759),
    [anon_sym_override] = ACTIONS(5759),
    [anon_sym_virtual] = ACTIONS(5759),
    [anon_sym_alignas] = ACTIONS(5759),
    [anon_sym_explicit] = ACTIONS(5759),
    [anon_sym_typename] = ACTIONS(5759),
    [anon_sym_template] = ACTIONS(5759),
    [anon_sym_GT2] = ACTIONS(5761),
    [anon_sym_operator] = ACTIONS(5759),
    [anon_sym_try] = ACTIONS(5759),
    [anon_sym_noexcept] = ACTIONS(5759),
    [anon_sym_throw] = ACTIONS(5759),
    [anon_sym_requires] = ACTIONS(5759),
  },
  [2292] = {
    [sym_identifier] = ACTIONS(5763),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5765),
    [anon_sym_COMMA] = ACTIONS(5765),
    [anon_sym_RPAREN] = ACTIONS(5765),
    [anon_sym_LPAREN2] = ACTIONS(5765),
    [anon_sym_DASH] = ACTIONS(5763),
    [anon_sym_PLUS] = ACTIONS(5763),
    [anon_sym_STAR] = ACTIONS(5765),
    [anon_sym_SLASH] = ACTIONS(5763),
    [anon_sym_PERCENT] = ACTIONS(5765),
    [anon_sym_PIPE_PIPE] = ACTIONS(5765),
    [anon_sym_AMP_AMP] = ACTIONS(5765),
    [anon_sym_PIPE] = ACTIONS(5763),
    [anon_sym_CARET] = ACTIONS(5765),
    [anon_sym_AMP] = ACTIONS(5763),
    [anon_sym_EQ_EQ] = ACTIONS(5765),
    [anon_sym_BANG_EQ] = ACTIONS(5765),
    [anon_sym_GT] = ACTIONS(5763),
    [anon_sym_GT_EQ] = ACTIONS(5765),
    [anon_sym_LT_EQ] = ACTIONS(5763),
    [anon_sym_LT] = ACTIONS(5763),
    [anon_sym_LT_LT] = ACTIONS(5765),
    [anon_sym_GT_GT] = ACTIONS(5765),
    [anon_sym_SEMI] = ACTIONS(5765),
    [anon_sym___extension__] = ACTIONS(5763),
    [anon_sym___attribute__] = ACTIONS(5763),
    [anon_sym___based] = ACTIONS(5763),
    [anon_sym_LBRACE] = ACTIONS(5765),
    [anon_sym_RBRACE] = ACTIONS(5765),
    [anon_sym_signed] = ACTIONS(5763),
    [anon_sym_unsigned] = ACTIONS(5763),
    [anon_sym_long] = ACTIONS(5763),
    [anon_sym_short] = ACTIONS(5763),
    [anon_sym_LBRACK] = ACTIONS(5765),
    [anon_sym_RBRACK] = ACTIONS(5765),
    [anon_sym_const] = ACTIONS(5763),
    [anon_sym_constexpr] = ACTIONS(5763),
    [anon_sym_volatile] = ACTIONS(5763),
    [anon_sym_restrict] = ACTIONS(5763),
    [anon_sym___restrict__] = ACTIONS(5763),
    [anon_sym__Atomic] = ACTIONS(5763),
    [anon_sym__Noreturn] = ACTIONS(5763),
    [anon_sym_noreturn] = ACTIONS(5763),
    [anon_sym_mutable] = ACTIONS(5763),
    [anon_sym_constinit] = ACTIONS(5763),
    [anon_sym_consteval] = ACTIONS(5763),
    [anon_sym_PROGMEM] = ACTIONS(5763),
    [aux_sym_primitive_type_token1] = ACTIONS(5763),
    [anon_sym_byte] = ACTIONS(5763),
    [anon_sym_word] = ACTIONS(5763),
    [anon_sym_COLON] = ACTIONS(5765),
    [anon_sym_QMARK] = ACTIONS(5765),
    [anon_sym_LT_EQ_GT] = ACTIONS(5765),
    [anon_sym_or] = ACTIONS(5763),
    [anon_sym_and] = ACTIONS(5763),
    [anon_sym_bitor] = ACTIONS(5763),
    [anon_sym_xor] = ACTIONS(5763),
    [anon_sym_bitand] = ACTIONS(5763),
    [anon_sym_not_eq] = ACTIONS(5763),
    [anon_sym_DASH_DASH] = ACTIONS(5765),
    [anon_sym_PLUS_PLUS] = ACTIONS(5765),
    [anon_sym_DOT] = ACTIONS(5763),
    [anon_sym_DOT_STAR] = ACTIONS(5765),
    [anon_sym_DASH_GT] = ACTIONS(5765),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5763),
    [anon_sym_decltype] = ACTIONS(5763),
    [anon_sym_final] = ACTIONS(5763),
    [anon_sym_override] = ACTIONS(5763),
    [anon_sym_requires] = ACTIONS(5763),
  },
  [2293] = {
    [sym_identifier] = ACTIONS(3471),
    [aux_sym_preproc_def_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token2] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3471),
    [aux_sym_preproc_else_token1] = ACTIONS(3471),
    [aux_sym_preproc_elif_token1] = ACTIONS(3471),
    [sym_preproc_directive] = ACTIONS(3471),
    [anon_sym_LPAREN2] = ACTIONS(3473),
    [anon_sym_TILDE] = ACTIONS(3473),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_AMP_AMP] = ACTIONS(3473),
    [anon_sym_AMP] = ACTIONS(3471),
    [anon_sym_SEMI] = ACTIONS(5767),
    [anon_sym___extension__] = ACTIONS(3471),
    [anon_sym_typedef] = ACTIONS(3471),
    [anon_sym_extern] = ACTIONS(3471),
    [anon_sym___attribute__] = ACTIONS(3471),
    [anon_sym_COLON_COLON] = ACTIONS(3473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3473),
    [anon_sym___declspec] = ACTIONS(3471),
    [anon_sym___based] = ACTIONS(3471),
    [anon_sym_signed] = ACTIONS(3471),
    [anon_sym_unsigned] = ACTIONS(3471),
    [anon_sym_long] = ACTIONS(3471),
    [anon_sym_short] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [anon_sym_static] = ACTIONS(3471),
    [anon_sym_register] = ACTIONS(3471),
    [anon_sym_inline] = ACTIONS(3471),
    [anon_sym___inline] = ACTIONS(3471),
    [anon_sym___inline__] = ACTIONS(3471),
    [anon_sym___forceinline] = ACTIONS(3471),
    [anon_sym_thread_local] = ACTIONS(3471),
    [anon_sym___thread] = ACTIONS(3471),
    [anon_sym_const] = ACTIONS(3471),
    [anon_sym_constexpr] = ACTIONS(3471),
    [anon_sym_volatile] = ACTIONS(3471),
    [anon_sym_restrict] = ACTIONS(3471),
    [anon_sym___restrict__] = ACTIONS(3471),
    [anon_sym__Atomic] = ACTIONS(3471),
    [anon_sym__Noreturn] = ACTIONS(3471),
    [anon_sym_noreturn] = ACTIONS(3471),
    [anon_sym_mutable] = ACTIONS(3471),
    [anon_sym_constinit] = ACTIONS(3471),
    [anon_sym_consteval] = ACTIONS(3471),
    [anon_sym_PROGMEM] = ACTIONS(3471),
    [aux_sym_primitive_type_token1] = ACTIONS(3471),
    [anon_sym_byte] = ACTIONS(3471),
    [anon_sym_word] = ACTIONS(3471),
    [anon_sym_enum] = ACTIONS(3471),
    [anon_sym_class] = ACTIONS(3471),
    [anon_sym_struct] = ACTIONS(3471),
    [anon_sym_union] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3471),
    [anon_sym_decltype] = ACTIONS(3471),
    [anon_sym_virtual] = ACTIONS(3471),
    [anon_sym_alignas] = ACTIONS(3471),
    [anon_sym_explicit] = ACTIONS(3471),
    [anon_sym_typename] = ACTIONS(3471),
    [anon_sym_template] = ACTIONS(3471),
    [anon_sym_operator] = ACTIONS(3471),
    [anon_sym_friend] = ACTIONS(3471),
    [anon_sym_public] = ACTIONS(3471),
    [anon_sym_private] = ACTIONS(3471),
    [anon_sym_protected] = ACTIONS(3471),
    [anon_sym_using] = ACTIONS(3471),
    [anon_sym_static_assert] = ACTIONS(3471),
  },
  [2294] = {
    [sym_identifier] = ACTIONS(5626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_RPAREN] = ACTIONS(5628),
    [anon_sym_LPAREN2] = ACTIONS(5628),
    [anon_sym_DASH] = ACTIONS(5626),
    [anon_sym_PLUS] = ACTIONS(5626),
    [anon_sym_STAR] = ACTIONS(5628),
    [anon_sym_SLASH] = ACTIONS(5626),
    [anon_sym_PERCENT] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE] = ACTIONS(5628),
    [anon_sym_AMP_AMP] = ACTIONS(5628),
    [anon_sym_PIPE] = ACTIONS(5626),
    [anon_sym_CARET] = ACTIONS(5628),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym_EQ_EQ] = ACTIONS(5628),
    [anon_sym_BANG_EQ] = ACTIONS(5628),
    [anon_sym_GT] = ACTIONS(5626),
    [anon_sym_GT_EQ] = ACTIONS(5628),
    [anon_sym_LT_EQ] = ACTIONS(5626),
    [anon_sym_LT] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym___extension__] = ACTIONS(5626),
    [anon_sym___attribute__] = ACTIONS(5626),
    [anon_sym___based] = ACTIONS(5626),
    [anon_sym_LBRACE] = ACTIONS(5628),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_signed] = ACTIONS(5626),
    [anon_sym_unsigned] = ACTIONS(5626),
    [anon_sym_long] = ACTIONS(5626),
    [anon_sym_short] = ACTIONS(5626),
    [anon_sym_LBRACK] = ACTIONS(5628),
    [anon_sym_RBRACK] = ACTIONS(5628),
    [anon_sym_const] = ACTIONS(5626),
    [anon_sym_constexpr] = ACTIONS(5626),
    [anon_sym_volatile] = ACTIONS(5626),
    [anon_sym_restrict] = ACTIONS(5626),
    [anon_sym___restrict__] = ACTIONS(5626),
    [anon_sym__Atomic] = ACTIONS(5626),
    [anon_sym__Noreturn] = ACTIONS(5626),
    [anon_sym_noreturn] = ACTIONS(5626),
    [anon_sym_mutable] = ACTIONS(5626),
    [anon_sym_constinit] = ACTIONS(5626),
    [anon_sym_consteval] = ACTIONS(5626),
    [anon_sym_PROGMEM] = ACTIONS(5626),
    [aux_sym_primitive_type_token1] = ACTIONS(5626),
    [anon_sym_byte] = ACTIONS(5626),
    [anon_sym_word] = ACTIONS(5626),
    [anon_sym_COLON] = ACTIONS(5628),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_LT_EQ_GT] = ACTIONS(5628),
    [anon_sym_or] = ACTIONS(5626),
    [anon_sym_and] = ACTIONS(5626),
    [anon_sym_bitor] = ACTIONS(5626),
    [anon_sym_xor] = ACTIONS(5626),
    [anon_sym_bitand] = ACTIONS(5626),
    [anon_sym_not_eq] = ACTIONS(5626),
    [anon_sym_DASH_DASH] = ACTIONS(5628),
    [anon_sym_PLUS_PLUS] = ACTIONS(5628),
    [anon_sym_DOT] = ACTIONS(5626),
    [anon_sym_DOT_STAR] = ACTIONS(5628),
    [anon_sym_DASH_GT] = ACTIONS(5628),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5626),
    [anon_sym_decltype] = ACTIONS(5626),
    [anon_sym_final] = ACTIONS(5626),
    [anon_sym_override] = ACTIONS(5626),
    [anon_sym_requires] = ACTIONS(5626),
  },
  [2295] = {
    [sym_identifier] = ACTIONS(3332),
    [aux_sym_preproc_def_token1] = ACTIONS(3332),
    [aux_sym_preproc_if_token1] = ACTIONS(3332),
    [aux_sym_preproc_if_token2] = ACTIONS(3332),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3332),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3332),
    [aux_sym_preproc_else_token1] = ACTIONS(3332),
    [aux_sym_preproc_elif_token1] = ACTIONS(3332),
    [sym_preproc_directive] = ACTIONS(3332),
    [anon_sym_LPAREN2] = ACTIONS(3334),
    [anon_sym_TILDE] = ACTIONS(3334),
    [anon_sym_STAR] = ACTIONS(3334),
    [anon_sym_AMP_AMP] = ACTIONS(3334),
    [anon_sym_AMP] = ACTIONS(3332),
    [anon_sym_SEMI] = ACTIONS(5769),
    [anon_sym___extension__] = ACTIONS(3332),
    [anon_sym_typedef] = ACTIONS(3332),
    [anon_sym_extern] = ACTIONS(3332),
    [anon_sym___attribute__] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(3334),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3334),
    [anon_sym___declspec] = ACTIONS(3332),
    [anon_sym___based] = ACTIONS(3332),
    [anon_sym_signed] = ACTIONS(3332),
    [anon_sym_unsigned] = ACTIONS(3332),
    [anon_sym_long] = ACTIONS(3332),
    [anon_sym_short] = ACTIONS(3332),
    [anon_sym_LBRACK] = ACTIONS(3332),
    [anon_sym_static] = ACTIONS(3332),
    [anon_sym_register] = ACTIONS(3332),
    [anon_sym_inline] = ACTIONS(3332),
    [anon_sym___inline] = ACTIONS(3332),
    [anon_sym___inline__] = ACTIONS(3332),
    [anon_sym___forceinline] = ACTIONS(3332),
    [anon_sym_thread_local] = ACTIONS(3332),
    [anon_sym___thread] = ACTIONS(3332),
    [anon_sym_const] = ACTIONS(3332),
    [anon_sym_constexpr] = ACTIONS(3332),
    [anon_sym_volatile] = ACTIONS(3332),
    [anon_sym_restrict] = ACTIONS(3332),
    [anon_sym___restrict__] = ACTIONS(3332),
    [anon_sym__Atomic] = ACTIONS(3332),
    [anon_sym__Noreturn] = ACTIONS(3332),
    [anon_sym_noreturn] = ACTIONS(3332),
    [anon_sym_mutable] = ACTIONS(3332),
    [anon_sym_constinit] = ACTIONS(3332),
    [anon_sym_consteval] = ACTIONS(3332),
    [anon_sym_PROGMEM] = ACTIONS(3332),
    [aux_sym_primitive_type_token1] = ACTIONS(3332),
    [anon_sym_byte] = ACTIONS(3332),
    [anon_sym_word] = ACTIONS(3332),
    [anon_sym_enum] = ACTIONS(3332),
    [anon_sym_class] = ACTIONS(3332),
    [anon_sym_struct] = ACTIONS(3332),
    [anon_sym_union] = ACTIONS(3332),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3332),
    [anon_sym_decltype] = ACTIONS(3332),
    [anon_sym_virtual] = ACTIONS(3332),
    [anon_sym_alignas] = ACTIONS(3332),
    [anon_sym_explicit] = ACTIONS(3332),
    [anon_sym_typename] = ACTIONS(3332),
    [anon_sym_template] = ACTIONS(3332),
    [anon_sym_operator] = ACTIONS(3332),
    [anon_sym_friend] = ACTIONS(3332),
    [anon_sym_public] = ACTIONS(3332),
    [anon_sym_private] = ACTIONS(3332),
    [anon_sym_protected] = ACTIONS(3332),
    [anon_sym_using] = ACTIONS(3332),
    [anon_sym_static_assert] = ACTIONS(3332),
  },
  [2296] = {
    [sym_identifier] = ACTIONS(5771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5773),
    [anon_sym_COMMA] = ACTIONS(5773),
    [anon_sym_RPAREN] = ACTIONS(5773),
    [anon_sym_LPAREN2] = ACTIONS(5773),
    [anon_sym_DASH] = ACTIONS(5771),
    [anon_sym_PLUS] = ACTIONS(5771),
    [anon_sym_STAR] = ACTIONS(5773),
    [anon_sym_SLASH] = ACTIONS(5771),
    [anon_sym_PERCENT] = ACTIONS(5773),
    [anon_sym_PIPE_PIPE] = ACTIONS(5773),
    [anon_sym_AMP_AMP] = ACTIONS(5773),
    [anon_sym_PIPE] = ACTIONS(5771),
    [anon_sym_CARET] = ACTIONS(5773),
    [anon_sym_AMP] = ACTIONS(5771),
    [anon_sym_EQ_EQ] = ACTIONS(5773),
    [anon_sym_BANG_EQ] = ACTIONS(5773),
    [anon_sym_GT] = ACTIONS(5771),
    [anon_sym_GT_EQ] = ACTIONS(5773),
    [anon_sym_LT_EQ] = ACTIONS(5771),
    [anon_sym_LT] = ACTIONS(5771),
    [anon_sym_LT_LT] = ACTIONS(5773),
    [anon_sym_GT_GT] = ACTIONS(5773),
    [anon_sym_SEMI] = ACTIONS(5773),
    [anon_sym___extension__] = ACTIONS(5771),
    [anon_sym___attribute__] = ACTIONS(5771),
    [anon_sym___based] = ACTIONS(5771),
    [anon_sym_LBRACE] = ACTIONS(5773),
    [anon_sym_RBRACE] = ACTIONS(5773),
    [anon_sym_signed] = ACTIONS(5771),
    [anon_sym_unsigned] = ACTIONS(5771),
    [anon_sym_long] = ACTIONS(5771),
    [anon_sym_short] = ACTIONS(5771),
    [anon_sym_LBRACK] = ACTIONS(5773),
    [anon_sym_RBRACK] = ACTIONS(5773),
    [anon_sym_const] = ACTIONS(5771),
    [anon_sym_constexpr] = ACTIONS(5771),
    [anon_sym_volatile] = ACTIONS(5771),
    [anon_sym_restrict] = ACTIONS(5771),
    [anon_sym___restrict__] = ACTIONS(5771),
    [anon_sym__Atomic] = ACTIONS(5771),
    [anon_sym__Noreturn] = ACTIONS(5771),
    [anon_sym_noreturn] = ACTIONS(5771),
    [anon_sym_mutable] = ACTIONS(5771),
    [anon_sym_constinit] = ACTIONS(5771),
    [anon_sym_consteval] = ACTIONS(5771),
    [anon_sym_PROGMEM] = ACTIONS(5771),
    [aux_sym_primitive_type_token1] = ACTIONS(5771),
    [anon_sym_byte] = ACTIONS(5771),
    [anon_sym_word] = ACTIONS(5771),
    [anon_sym_COLON] = ACTIONS(5773),
    [anon_sym_QMARK] = ACTIONS(5773),
    [anon_sym_LT_EQ_GT] = ACTIONS(5773),
    [anon_sym_or] = ACTIONS(5771),
    [anon_sym_and] = ACTIONS(5771),
    [anon_sym_bitor] = ACTIONS(5771),
    [anon_sym_xor] = ACTIONS(5771),
    [anon_sym_bitand] = ACTIONS(5771),
    [anon_sym_not_eq] = ACTIONS(5771),
    [anon_sym_DASH_DASH] = ACTIONS(5773),
    [anon_sym_PLUS_PLUS] = ACTIONS(5773),
    [anon_sym_DOT] = ACTIONS(5771),
    [anon_sym_DOT_STAR] = ACTIONS(5773),
    [anon_sym_DASH_GT] = ACTIONS(5773),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5771),
    [anon_sym_decltype] = ACTIONS(5771),
    [anon_sym_final] = ACTIONS(5771),
    [anon_sym_override] = ACTIONS(5771),
    [anon_sym_requires] = ACTIONS(5771),
  },
  [2297] = {
    [sym_identifier] = ACTIONS(3328),
    [aux_sym_preproc_def_token1] = ACTIONS(3328),
    [aux_sym_preproc_if_token1] = ACTIONS(3328),
    [aux_sym_preproc_if_token2] = ACTIONS(3328),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3328),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3328),
    [aux_sym_preproc_else_token1] = ACTIONS(3328),
    [aux_sym_preproc_elif_token1] = ACTIONS(3328),
    [sym_preproc_directive] = ACTIONS(3328),
    [anon_sym_LPAREN2] = ACTIONS(3330),
    [anon_sym_TILDE] = ACTIONS(3330),
    [anon_sym_STAR] = ACTIONS(3330),
    [anon_sym_AMP_AMP] = ACTIONS(3330),
    [anon_sym_AMP] = ACTIONS(3328),
    [anon_sym_SEMI] = ACTIONS(5775),
    [anon_sym___extension__] = ACTIONS(3328),
    [anon_sym_typedef] = ACTIONS(3328),
    [anon_sym_extern] = ACTIONS(3328),
    [anon_sym___attribute__] = ACTIONS(3328),
    [anon_sym_COLON_COLON] = ACTIONS(3330),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3330),
    [anon_sym___declspec] = ACTIONS(3328),
    [anon_sym___based] = ACTIONS(3328),
    [anon_sym_signed] = ACTIONS(3328),
    [anon_sym_unsigned] = ACTIONS(3328),
    [anon_sym_long] = ACTIONS(3328),
    [anon_sym_short] = ACTIONS(3328),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_static] = ACTIONS(3328),
    [anon_sym_register] = ACTIONS(3328),
    [anon_sym_inline] = ACTIONS(3328),
    [anon_sym___inline] = ACTIONS(3328),
    [anon_sym___inline__] = ACTIONS(3328),
    [anon_sym___forceinline] = ACTIONS(3328),
    [anon_sym_thread_local] = ACTIONS(3328),
    [anon_sym___thread] = ACTIONS(3328),
    [anon_sym_const] = ACTIONS(3328),
    [anon_sym_constexpr] = ACTIONS(3328),
    [anon_sym_volatile] = ACTIONS(3328),
    [anon_sym_restrict] = ACTIONS(3328),
    [anon_sym___restrict__] = ACTIONS(3328),
    [anon_sym__Atomic] = ACTIONS(3328),
    [anon_sym__Noreturn] = ACTIONS(3328),
    [anon_sym_noreturn] = ACTIONS(3328),
    [anon_sym_mutable] = ACTIONS(3328),
    [anon_sym_constinit] = ACTIONS(3328),
    [anon_sym_consteval] = ACTIONS(3328),
    [anon_sym_PROGMEM] = ACTIONS(3328),
    [aux_sym_primitive_type_token1] = ACTIONS(3328),
    [anon_sym_byte] = ACTIONS(3328),
    [anon_sym_word] = ACTIONS(3328),
    [anon_sym_enum] = ACTIONS(3328),
    [anon_sym_class] = ACTIONS(3328),
    [anon_sym_struct] = ACTIONS(3328),
    [anon_sym_union] = ACTIONS(3328),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3328),
    [anon_sym_decltype] = ACTIONS(3328),
    [anon_sym_virtual] = ACTIONS(3328),
    [anon_sym_alignas] = ACTIONS(3328),
    [anon_sym_explicit] = ACTIONS(3328),
    [anon_sym_typename] = ACTIONS(3328),
    [anon_sym_template] = ACTIONS(3328),
    [anon_sym_operator] = ACTIONS(3328),
    [anon_sym_friend] = ACTIONS(3328),
    [anon_sym_public] = ACTIONS(3328),
    [anon_sym_private] = ACTIONS(3328),
    [anon_sym_protected] = ACTIONS(3328),
    [anon_sym_using] = ACTIONS(3328),
    [anon_sym_static_assert] = ACTIONS(3328),
  },
  [2298] = {
    [sym_identifier] = ACTIONS(5777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5779),
    [anon_sym_COMMA] = ACTIONS(5779),
    [anon_sym_RPAREN] = ACTIONS(5779),
    [anon_sym_LPAREN2] = ACTIONS(5779),
    [anon_sym_DASH] = ACTIONS(5777),
    [anon_sym_PLUS] = ACTIONS(5777),
    [anon_sym_STAR] = ACTIONS(5779),
    [anon_sym_SLASH] = ACTIONS(5777),
    [anon_sym_PERCENT] = ACTIONS(5779),
    [anon_sym_PIPE_PIPE] = ACTIONS(5779),
    [anon_sym_AMP_AMP] = ACTIONS(5779),
    [anon_sym_PIPE] = ACTIONS(5777),
    [anon_sym_CARET] = ACTIONS(5779),
    [anon_sym_AMP] = ACTIONS(5777),
    [anon_sym_EQ_EQ] = ACTIONS(5779),
    [anon_sym_BANG_EQ] = ACTIONS(5779),
    [anon_sym_GT] = ACTIONS(5777),
    [anon_sym_GT_EQ] = ACTIONS(5779),
    [anon_sym_LT_EQ] = ACTIONS(5777),
    [anon_sym_LT] = ACTIONS(5777),
    [anon_sym_LT_LT] = ACTIONS(5779),
    [anon_sym_GT_GT] = ACTIONS(5779),
    [anon_sym_SEMI] = ACTIONS(5779),
    [anon_sym___extension__] = ACTIONS(5777),
    [anon_sym___attribute__] = ACTIONS(5777),
    [anon_sym___based] = ACTIONS(5777),
    [anon_sym_LBRACE] = ACTIONS(5779),
    [anon_sym_RBRACE] = ACTIONS(5779),
    [anon_sym_signed] = ACTIONS(5777),
    [anon_sym_unsigned] = ACTIONS(5777),
    [anon_sym_long] = ACTIONS(5777),
    [anon_sym_short] = ACTIONS(5777),
    [anon_sym_LBRACK] = ACTIONS(5779),
    [anon_sym_RBRACK] = ACTIONS(5779),
    [anon_sym_const] = ACTIONS(5777),
    [anon_sym_constexpr] = ACTIONS(5777),
    [anon_sym_volatile] = ACTIONS(5777),
    [anon_sym_restrict] = ACTIONS(5777),
    [anon_sym___restrict__] = ACTIONS(5777),
    [anon_sym__Atomic] = ACTIONS(5777),
    [anon_sym__Noreturn] = ACTIONS(5777),
    [anon_sym_noreturn] = ACTIONS(5777),
    [anon_sym_mutable] = ACTIONS(5777),
    [anon_sym_constinit] = ACTIONS(5777),
    [anon_sym_consteval] = ACTIONS(5777),
    [anon_sym_PROGMEM] = ACTIONS(5777),
    [aux_sym_primitive_type_token1] = ACTIONS(5777),
    [anon_sym_byte] = ACTIONS(5777),
    [anon_sym_word] = ACTIONS(5777),
    [anon_sym_COLON] = ACTIONS(5779),
    [anon_sym_QMARK] = ACTIONS(5779),
    [anon_sym_LT_EQ_GT] = ACTIONS(5779),
    [anon_sym_or] = ACTIONS(5777),
    [anon_sym_and] = ACTIONS(5777),
    [anon_sym_bitor] = ACTIONS(5777),
    [anon_sym_xor] = ACTIONS(5777),
    [anon_sym_bitand] = ACTIONS(5777),
    [anon_sym_not_eq] = ACTIONS(5777),
    [anon_sym_DASH_DASH] = ACTIONS(5779),
    [anon_sym_PLUS_PLUS] = ACTIONS(5779),
    [anon_sym_DOT] = ACTIONS(5777),
    [anon_sym_DOT_STAR] = ACTIONS(5779),
    [anon_sym_DASH_GT] = ACTIONS(5779),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5777),
    [anon_sym_decltype] = ACTIONS(5777),
    [anon_sym_final] = ACTIONS(5777),
    [anon_sym_override] = ACTIONS(5777),
    [anon_sym_requires] = ACTIONS(5777),
  },
  [2299] = {
    [sym_identifier] = ACTIONS(5781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5783),
    [anon_sym_COMMA] = ACTIONS(5783),
    [anon_sym_RPAREN] = ACTIONS(5783),
    [anon_sym_LPAREN2] = ACTIONS(5783),
    [anon_sym_DASH] = ACTIONS(5781),
    [anon_sym_PLUS] = ACTIONS(5781),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_SLASH] = ACTIONS(5781),
    [anon_sym_PERCENT] = ACTIONS(5783),
    [anon_sym_PIPE_PIPE] = ACTIONS(5783),
    [anon_sym_AMP_AMP] = ACTIONS(5783),
    [anon_sym_PIPE] = ACTIONS(5781),
    [anon_sym_CARET] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5781),
    [anon_sym_EQ_EQ] = ACTIONS(5783),
    [anon_sym_BANG_EQ] = ACTIONS(5783),
    [anon_sym_GT] = ACTIONS(5781),
    [anon_sym_GT_EQ] = ACTIONS(5783),
    [anon_sym_LT_EQ] = ACTIONS(5781),
    [anon_sym_LT] = ACTIONS(5781),
    [anon_sym_LT_LT] = ACTIONS(5783),
    [anon_sym_GT_GT] = ACTIONS(5783),
    [anon_sym_SEMI] = ACTIONS(5783),
    [anon_sym___extension__] = ACTIONS(5781),
    [anon_sym___attribute__] = ACTIONS(5781),
    [anon_sym___based] = ACTIONS(5781),
    [anon_sym_LBRACE] = ACTIONS(5783),
    [anon_sym_RBRACE] = ACTIONS(5783),
    [anon_sym_signed] = ACTIONS(5781),
    [anon_sym_unsigned] = ACTIONS(5781),
    [anon_sym_long] = ACTIONS(5781),
    [anon_sym_short] = ACTIONS(5781),
    [anon_sym_LBRACK] = ACTIONS(5783),
    [anon_sym_RBRACK] = ACTIONS(5783),
    [anon_sym_const] = ACTIONS(5781),
    [anon_sym_constexpr] = ACTIONS(5781),
    [anon_sym_volatile] = ACTIONS(5781),
    [anon_sym_restrict] = ACTIONS(5781),
    [anon_sym___restrict__] = ACTIONS(5781),
    [anon_sym__Atomic] = ACTIONS(5781),
    [anon_sym__Noreturn] = ACTIONS(5781),
    [anon_sym_noreturn] = ACTIONS(5781),
    [anon_sym_mutable] = ACTIONS(5781),
    [anon_sym_constinit] = ACTIONS(5781),
    [anon_sym_consteval] = ACTIONS(5781),
    [anon_sym_PROGMEM] = ACTIONS(5781),
    [aux_sym_primitive_type_token1] = ACTIONS(5781),
    [anon_sym_byte] = ACTIONS(5781),
    [anon_sym_word] = ACTIONS(5781),
    [anon_sym_COLON] = ACTIONS(5783),
    [anon_sym_QMARK] = ACTIONS(5783),
    [anon_sym_LT_EQ_GT] = ACTIONS(5783),
    [anon_sym_or] = ACTIONS(5781),
    [anon_sym_and] = ACTIONS(5781),
    [anon_sym_bitor] = ACTIONS(5781),
    [anon_sym_xor] = ACTIONS(5781),
    [anon_sym_bitand] = ACTIONS(5781),
    [anon_sym_not_eq] = ACTIONS(5781),
    [anon_sym_DASH_DASH] = ACTIONS(5783),
    [anon_sym_PLUS_PLUS] = ACTIONS(5783),
    [anon_sym_DOT] = ACTIONS(5781),
    [anon_sym_DOT_STAR] = ACTIONS(5783),
    [anon_sym_DASH_GT] = ACTIONS(5783),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5781),
    [anon_sym_decltype] = ACTIONS(5781),
    [anon_sym_final] = ACTIONS(5781),
    [anon_sym_override] = ACTIONS(5781),
    [anon_sym_requires] = ACTIONS(5781),
  },
  [2300] = {
    [sym_identifier] = ACTIONS(5785),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5787),
    [anon_sym_COMMA] = ACTIONS(5787),
    [anon_sym_RPAREN] = ACTIONS(5787),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5785),
    [anon_sym_PLUS] = ACTIONS(5785),
    [anon_sym_STAR] = ACTIONS(5787),
    [anon_sym_SLASH] = ACTIONS(5785),
    [anon_sym_PERCENT] = ACTIONS(5787),
    [anon_sym_PIPE_PIPE] = ACTIONS(5787),
    [anon_sym_AMP_AMP] = ACTIONS(5787),
    [anon_sym_PIPE] = ACTIONS(5785),
    [anon_sym_CARET] = ACTIONS(5787),
    [anon_sym_AMP] = ACTIONS(5785),
    [anon_sym_EQ_EQ] = ACTIONS(5787),
    [anon_sym_BANG_EQ] = ACTIONS(5787),
    [anon_sym_GT] = ACTIONS(5785),
    [anon_sym_GT_EQ] = ACTIONS(5787),
    [anon_sym_LT_EQ] = ACTIONS(5785),
    [anon_sym_LT] = ACTIONS(5785),
    [anon_sym_LT_LT] = ACTIONS(5787),
    [anon_sym_GT_GT] = ACTIONS(5787),
    [anon_sym_SEMI] = ACTIONS(5787),
    [anon_sym___extension__] = ACTIONS(5785),
    [anon_sym___attribute__] = ACTIONS(5785),
    [anon_sym___based] = ACTIONS(5785),
    [anon_sym_LBRACE] = ACTIONS(5787),
    [anon_sym_RBRACE] = ACTIONS(5787),
    [anon_sym_signed] = ACTIONS(5785),
    [anon_sym_unsigned] = ACTIONS(5785),
    [anon_sym_long] = ACTIONS(5785),
    [anon_sym_short] = ACTIONS(5785),
    [anon_sym_LBRACK] = ACTIONS(5787),
    [anon_sym_RBRACK] = ACTIONS(5787),
    [anon_sym_const] = ACTIONS(5785),
    [anon_sym_constexpr] = ACTIONS(5785),
    [anon_sym_volatile] = ACTIONS(5785),
    [anon_sym_restrict] = ACTIONS(5785),
    [anon_sym___restrict__] = ACTIONS(5785),
    [anon_sym__Atomic] = ACTIONS(5785),
    [anon_sym__Noreturn] = ACTIONS(5785),
    [anon_sym_noreturn] = ACTIONS(5785),
    [anon_sym_mutable] = ACTIONS(5785),
    [anon_sym_constinit] = ACTIONS(5785),
    [anon_sym_consteval] = ACTIONS(5785),
    [anon_sym_PROGMEM] = ACTIONS(5785),
    [aux_sym_primitive_type_token1] = ACTIONS(5785),
    [anon_sym_byte] = ACTIONS(5785),
    [anon_sym_word] = ACTIONS(5785),
    [anon_sym_COLON] = ACTIONS(5787),
    [anon_sym_QMARK] = ACTIONS(5787),
    [anon_sym_LT_EQ_GT] = ACTIONS(5787),
    [anon_sym_or] = ACTIONS(5785),
    [anon_sym_and] = ACTIONS(5785),
    [anon_sym_bitor] = ACTIONS(5785),
    [anon_sym_xor] = ACTIONS(5785),
    [anon_sym_bitand] = ACTIONS(5785),
    [anon_sym_not_eq] = ACTIONS(5785),
    [anon_sym_DASH_DASH] = ACTIONS(5787),
    [anon_sym_PLUS_PLUS] = ACTIONS(5787),
    [anon_sym_DOT] = ACTIONS(5785),
    [anon_sym_DOT_STAR] = ACTIONS(5787),
    [anon_sym_DASH_GT] = ACTIONS(5787),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5785),
    [anon_sym_decltype] = ACTIONS(5785),
    [anon_sym_final] = ACTIONS(5785),
    [anon_sym_override] = ACTIONS(5785),
    [anon_sym_requires] = ACTIONS(5785),
  },
  [2301] = {
    [sym_catch_clause] = STATE(2261),
    [aux_sym_constructor_try_statement_repeat1] = STATE(2261),
    [sym_identifier] = ACTIONS(2860),
    [aux_sym_preproc_def_token1] = ACTIONS(2860),
    [aux_sym_preproc_if_token1] = ACTIONS(2860),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2860),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2860),
    [sym_preproc_directive] = ACTIONS(2860),
    [anon_sym_LPAREN2] = ACTIONS(2862),
    [anon_sym_TILDE] = ACTIONS(2862),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP_AMP] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2860),
    [anon_sym___extension__] = ACTIONS(2860),
    [anon_sym_typedef] = ACTIONS(2860),
    [anon_sym_extern] = ACTIONS(2860),
    [anon_sym___attribute__] = ACTIONS(2860),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2862),
    [anon_sym___declspec] = ACTIONS(2860),
    [anon_sym___based] = ACTIONS(2860),
    [anon_sym_RBRACE] = ACTIONS(2862),
    [anon_sym_signed] = ACTIONS(2860),
    [anon_sym_unsigned] = ACTIONS(2860),
    [anon_sym_long] = ACTIONS(2860),
    [anon_sym_short] = ACTIONS(2860),
    [anon_sym_LBRACK] = ACTIONS(2860),
    [anon_sym_static] = ACTIONS(2860),
    [anon_sym_register] = ACTIONS(2860),
    [anon_sym_inline] = ACTIONS(2860),
    [anon_sym___inline] = ACTIONS(2860),
    [anon_sym___inline__] = ACTIONS(2860),
    [anon_sym___forceinline] = ACTIONS(2860),
    [anon_sym_thread_local] = ACTIONS(2860),
    [anon_sym___thread] = ACTIONS(2860),
    [anon_sym_const] = ACTIONS(2860),
    [anon_sym_constexpr] = ACTIONS(2860),
    [anon_sym_volatile] = ACTIONS(2860),
    [anon_sym_restrict] = ACTIONS(2860),
    [anon_sym___restrict__] = ACTIONS(2860),
    [anon_sym__Atomic] = ACTIONS(2860),
    [anon_sym__Noreturn] = ACTIONS(2860),
    [anon_sym_noreturn] = ACTIONS(2860),
    [anon_sym_mutable] = ACTIONS(2860),
    [anon_sym_constinit] = ACTIONS(2860),
    [anon_sym_consteval] = ACTIONS(2860),
    [anon_sym_PROGMEM] = ACTIONS(2860),
    [aux_sym_primitive_type_token1] = ACTIONS(2860),
    [anon_sym_byte] = ACTIONS(2860),
    [anon_sym_word] = ACTIONS(2860),
    [anon_sym_enum] = ACTIONS(2860),
    [anon_sym_class] = ACTIONS(2860),
    [anon_sym_struct] = ACTIONS(2860),
    [anon_sym_union] = ACTIONS(2860),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2860),
    [anon_sym_decltype] = ACTIONS(2860),
    [anon_sym_virtual] = ACTIONS(2860),
    [anon_sym_alignas] = ACTIONS(2860),
    [anon_sym_explicit] = ACTIONS(2860),
    [anon_sym_typename] = ACTIONS(2860),
    [anon_sym_template] = ACTIONS(2860),
    [anon_sym_operator] = ACTIONS(2860),
    [anon_sym_friend] = ACTIONS(2860),
    [anon_sym_public] = ACTIONS(2860),
    [anon_sym_private] = ACTIONS(2860),
    [anon_sym_protected] = ACTIONS(2860),
    [anon_sym_using] = ACTIONS(2860),
    [anon_sym_static_assert] = ACTIONS(2860),
    [anon_sym_catch] = ACTIONS(5728),
  },
  [2302] = {
    [sym_identifier] = ACTIONS(5789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5791),
    [anon_sym_COMMA] = ACTIONS(5791),
    [anon_sym_RPAREN] = ACTIONS(5791),
    [anon_sym_LPAREN2] = ACTIONS(5791),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_PLUS] = ACTIONS(5789),
    [anon_sym_STAR] = ACTIONS(5791),
    [anon_sym_SLASH] = ACTIONS(5789),
    [anon_sym_PERCENT] = ACTIONS(5791),
    [anon_sym_PIPE_PIPE] = ACTIONS(5791),
    [anon_sym_AMP_AMP] = ACTIONS(5791),
    [anon_sym_PIPE] = ACTIONS(5789),
    [anon_sym_CARET] = ACTIONS(5791),
    [anon_sym_AMP] = ACTIONS(5789),
    [anon_sym_EQ_EQ] = ACTIONS(5791),
    [anon_sym_BANG_EQ] = ACTIONS(5791),
    [anon_sym_GT] = ACTIONS(5789),
    [anon_sym_GT_EQ] = ACTIONS(5791),
    [anon_sym_LT_EQ] = ACTIONS(5789),
    [anon_sym_LT] = ACTIONS(5789),
    [anon_sym_LT_LT] = ACTIONS(5791),
    [anon_sym_GT_GT] = ACTIONS(5791),
    [anon_sym_SEMI] = ACTIONS(5791),
    [anon_sym___extension__] = ACTIONS(5789),
    [anon_sym___attribute__] = ACTIONS(5789),
    [anon_sym___based] = ACTIONS(5789),
    [anon_sym_LBRACE] = ACTIONS(5791),
    [anon_sym_RBRACE] = ACTIONS(5791),
    [anon_sym_signed] = ACTIONS(5789),
    [anon_sym_unsigned] = ACTIONS(5789),
    [anon_sym_long] = ACTIONS(5789),
    [anon_sym_short] = ACTIONS(5789),
    [anon_sym_LBRACK] = ACTIONS(5791),
    [anon_sym_RBRACK] = ACTIONS(5791),
    [anon_sym_const] = ACTIONS(5789),
    [anon_sym_constexpr] = ACTIONS(5789),
    [anon_sym_volatile] = ACTIONS(5789),
    [anon_sym_restrict] = ACTIONS(5789),
    [anon_sym___restrict__] = ACTIONS(5789),
    [anon_sym__Atomic] = ACTIONS(5789),
    [anon_sym__Noreturn] = ACTIONS(5789),
    [anon_sym_noreturn] = ACTIONS(5789),
    [anon_sym_mutable] = ACTIONS(5789),
    [anon_sym_constinit] = ACTIONS(5789),
    [anon_sym_consteval] = ACTIONS(5789),
    [anon_sym_PROGMEM] = ACTIONS(5789),
    [aux_sym_primitive_type_token1] = ACTIONS(5789),
    [anon_sym_byte] = ACTIONS(5789),
    [anon_sym_word] = ACTIONS(5789),
    [anon_sym_COLON] = ACTIONS(5791),
    [anon_sym_QMARK] = ACTIONS(5791),
    [anon_sym_LT_EQ_GT] = ACTIONS(5791),
    [anon_sym_or] = ACTIONS(5789),
    [anon_sym_and] = ACTIONS(5789),
    [anon_sym_bitor] = ACTIONS(5789),
    [anon_sym_xor] = ACTIONS(5789),
    [anon_sym_bitand] = ACTIONS(5789),
    [anon_sym_not_eq] = ACTIONS(5789),
    [anon_sym_DASH_DASH] = ACTIONS(5791),
    [anon_sym_PLUS_PLUS] = ACTIONS(5791),
    [anon_sym_DOT] = ACTIONS(5789),
    [anon_sym_DOT_STAR] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5791),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5789),
    [anon_sym_decltype] = ACTIONS(5789),
    [anon_sym_final] = ACTIONS(5789),
    [anon_sym_override] = ACTIONS(5789),
    [anon_sym_requires] = ACTIONS(5789),
  },
  [2303] = {
    [sym_identifier] = ACTIONS(5638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5640),
    [anon_sym_COMMA] = ACTIONS(5640),
    [anon_sym_RPAREN] = ACTIONS(5640),
    [anon_sym_LPAREN2] = ACTIONS(5640),
    [anon_sym_DASH] = ACTIONS(5638),
    [anon_sym_PLUS] = ACTIONS(5638),
    [anon_sym_STAR] = ACTIONS(5640),
    [anon_sym_SLASH] = ACTIONS(5638),
    [anon_sym_PERCENT] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE] = ACTIONS(5638),
    [anon_sym_CARET] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5638),
    [anon_sym_EQ_EQ] = ACTIONS(5640),
    [anon_sym_BANG_EQ] = ACTIONS(5640),
    [anon_sym_GT] = ACTIONS(5638),
    [anon_sym_GT_EQ] = ACTIONS(5640),
    [anon_sym_LT_EQ] = ACTIONS(5638),
    [anon_sym_LT] = ACTIONS(5638),
    [anon_sym_LT_LT] = ACTIONS(5640),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5640),
    [anon_sym___extension__] = ACTIONS(5638),
    [anon_sym___attribute__] = ACTIONS(5638),
    [anon_sym___based] = ACTIONS(5638),
    [anon_sym_LBRACE] = ACTIONS(5640),
    [anon_sym_RBRACE] = ACTIONS(5640),
    [anon_sym_signed] = ACTIONS(5638),
    [anon_sym_unsigned] = ACTIONS(5638),
    [anon_sym_long] = ACTIONS(5638),
    [anon_sym_short] = ACTIONS(5638),
    [anon_sym_LBRACK] = ACTIONS(5640),
    [anon_sym_RBRACK] = ACTIONS(5640),
    [anon_sym_const] = ACTIONS(5638),
    [anon_sym_constexpr] = ACTIONS(5638),
    [anon_sym_volatile] = ACTIONS(5638),
    [anon_sym_restrict] = ACTIONS(5638),
    [anon_sym___restrict__] = ACTIONS(5638),
    [anon_sym__Atomic] = ACTIONS(5638),
    [anon_sym__Noreturn] = ACTIONS(5638),
    [anon_sym_noreturn] = ACTIONS(5638),
    [anon_sym_mutable] = ACTIONS(5638),
    [anon_sym_constinit] = ACTIONS(5638),
    [anon_sym_consteval] = ACTIONS(5638),
    [anon_sym_PROGMEM] = ACTIONS(5638),
    [aux_sym_primitive_type_token1] = ACTIONS(5638),
    [anon_sym_byte] = ACTIONS(5638),
    [anon_sym_word] = ACTIONS(5638),
    [anon_sym_COLON] = ACTIONS(5640),
    [anon_sym_QMARK] = ACTIONS(5640),
    [anon_sym_LT_EQ_GT] = ACTIONS(5640),
    [anon_sym_or] = ACTIONS(5638),
    [anon_sym_and] = ACTIONS(5638),
    [anon_sym_bitor] = ACTIONS(5638),
    [anon_sym_xor] = ACTIONS(5638),
    [anon_sym_bitand] = ACTIONS(5638),
    [anon_sym_not_eq] = ACTIONS(5638),
    [anon_sym_DASH_DASH] = ACTIONS(5640),
    [anon_sym_PLUS_PLUS] = ACTIONS(5640),
    [anon_sym_DOT] = ACTIONS(5638),
    [anon_sym_DOT_STAR] = ACTIONS(5640),
    [anon_sym_DASH_GT] = ACTIONS(5640),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5638),
    [anon_sym_decltype] = ACTIONS(5638),
    [anon_sym_final] = ACTIONS(5638),
    [anon_sym_override] = ACTIONS(5638),
    [anon_sym_requires] = ACTIONS(5638),
  },
  [2304] = {
    [sym_identifier] = ACTIONS(5793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5795),
    [anon_sym_COMMA] = ACTIONS(5795),
    [anon_sym_RPAREN] = ACTIONS(5795),
    [anon_sym_LPAREN2] = ACTIONS(5795),
    [anon_sym_DASH] = ACTIONS(5793),
    [anon_sym_PLUS] = ACTIONS(5793),
    [anon_sym_STAR] = ACTIONS(5795),
    [anon_sym_SLASH] = ACTIONS(5793),
    [anon_sym_PERCENT] = ACTIONS(5795),
    [anon_sym_PIPE_PIPE] = ACTIONS(5795),
    [anon_sym_AMP_AMP] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5793),
    [anon_sym_CARET] = ACTIONS(5795),
    [anon_sym_AMP] = ACTIONS(5793),
    [anon_sym_EQ_EQ] = ACTIONS(5795),
    [anon_sym_BANG_EQ] = ACTIONS(5795),
    [anon_sym_GT] = ACTIONS(5793),
    [anon_sym_GT_EQ] = ACTIONS(5795),
    [anon_sym_LT_EQ] = ACTIONS(5793),
    [anon_sym_LT] = ACTIONS(5793),
    [anon_sym_LT_LT] = ACTIONS(5795),
    [anon_sym_GT_GT] = ACTIONS(5795),
    [anon_sym_SEMI] = ACTIONS(5795),
    [anon_sym___extension__] = ACTIONS(5793),
    [anon_sym___attribute__] = ACTIONS(5793),
    [anon_sym___based] = ACTIONS(5793),
    [anon_sym_LBRACE] = ACTIONS(5795),
    [anon_sym_RBRACE] = ACTIONS(5795),
    [anon_sym_signed] = ACTIONS(5793),
    [anon_sym_unsigned] = ACTIONS(5793),
    [anon_sym_long] = ACTIONS(5793),
    [anon_sym_short] = ACTIONS(5793),
    [anon_sym_LBRACK] = ACTIONS(5795),
    [anon_sym_RBRACK] = ACTIONS(5795),
    [anon_sym_const] = ACTIONS(5793),
    [anon_sym_constexpr] = ACTIONS(5793),
    [anon_sym_volatile] = ACTIONS(5793),
    [anon_sym_restrict] = ACTIONS(5793),
    [anon_sym___restrict__] = ACTIONS(5793),
    [anon_sym__Atomic] = ACTIONS(5793),
    [anon_sym__Noreturn] = ACTIONS(5793),
    [anon_sym_noreturn] = ACTIONS(5793),
    [anon_sym_mutable] = ACTIONS(5793),
    [anon_sym_constinit] = ACTIONS(5793),
    [anon_sym_consteval] = ACTIONS(5793),
    [anon_sym_PROGMEM] = ACTIONS(5793),
    [aux_sym_primitive_type_token1] = ACTIONS(5793),
    [anon_sym_byte] = ACTIONS(5793),
    [anon_sym_word] = ACTIONS(5793),
    [anon_sym_COLON] = ACTIONS(5795),
    [anon_sym_QMARK] = ACTIONS(5795),
    [anon_sym_LT_EQ_GT] = ACTIONS(5795),
    [anon_sym_or] = ACTIONS(5793),
    [anon_sym_and] = ACTIONS(5793),
    [anon_sym_bitor] = ACTIONS(5793),
    [anon_sym_xor] = ACTIONS(5793),
    [anon_sym_bitand] = ACTIONS(5793),
    [anon_sym_not_eq] = ACTIONS(5793),
    [anon_sym_DASH_DASH] = ACTIONS(5795),
    [anon_sym_PLUS_PLUS] = ACTIONS(5795),
    [anon_sym_DOT] = ACTIONS(5793),
    [anon_sym_DOT_STAR] = ACTIONS(5795),
    [anon_sym_DASH_GT] = ACTIONS(5795),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5793),
    [anon_sym_decltype] = ACTIONS(5793),
    [anon_sym_final] = ACTIONS(5793),
    [anon_sym_override] = ACTIONS(5793),
    [anon_sym_requires] = ACTIONS(5793),
  },
  [2305] = {
    [sym_identifier] = ACTIONS(5566),
    [aux_sym_preproc_def_token1] = ACTIONS(5566),
    [aux_sym_preproc_if_token1] = ACTIONS(5566),
    [aux_sym_preproc_if_token2] = ACTIONS(5566),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5566),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5566),
    [aux_sym_preproc_else_token1] = ACTIONS(5566),
    [aux_sym_preproc_elif_token1] = ACTIONS(5566),
    [sym_preproc_directive] = ACTIONS(5566),
    [anon_sym_LPAREN2] = ACTIONS(5568),
    [anon_sym_TILDE] = ACTIONS(5568),
    [anon_sym_STAR] = ACTIONS(5568),
    [anon_sym_AMP_AMP] = ACTIONS(5568),
    [anon_sym_AMP] = ACTIONS(5566),
    [anon_sym___extension__] = ACTIONS(5566),
    [anon_sym_typedef] = ACTIONS(5566),
    [anon_sym_extern] = ACTIONS(5566),
    [anon_sym___attribute__] = ACTIONS(5566),
    [anon_sym_COLON_COLON] = ACTIONS(5568),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5568),
    [anon_sym___declspec] = ACTIONS(5566),
    [anon_sym___based] = ACTIONS(5566),
    [anon_sym_signed] = ACTIONS(5566),
    [anon_sym_unsigned] = ACTIONS(5566),
    [anon_sym_long] = ACTIONS(5566),
    [anon_sym_short] = ACTIONS(5566),
    [anon_sym_LBRACK] = ACTIONS(5566),
    [anon_sym_static] = ACTIONS(5566),
    [anon_sym_register] = ACTIONS(5566),
    [anon_sym_inline] = ACTIONS(5566),
    [anon_sym___inline] = ACTIONS(5566),
    [anon_sym___inline__] = ACTIONS(5566),
    [anon_sym___forceinline] = ACTIONS(5566),
    [anon_sym_thread_local] = ACTIONS(5566),
    [anon_sym___thread] = ACTIONS(5566),
    [anon_sym_const] = ACTIONS(5566),
    [anon_sym_constexpr] = ACTIONS(5566),
    [anon_sym_volatile] = ACTIONS(5566),
    [anon_sym_restrict] = ACTIONS(5566),
    [anon_sym___restrict__] = ACTIONS(5566),
    [anon_sym__Atomic] = ACTIONS(5566),
    [anon_sym__Noreturn] = ACTIONS(5566),
    [anon_sym_noreturn] = ACTIONS(5566),
    [anon_sym_mutable] = ACTIONS(5566),
    [anon_sym_constinit] = ACTIONS(5566),
    [anon_sym_consteval] = ACTIONS(5566),
    [anon_sym_PROGMEM] = ACTIONS(5566),
    [aux_sym_primitive_type_token1] = ACTIONS(5566),
    [anon_sym_byte] = ACTIONS(5566),
    [anon_sym_word] = ACTIONS(5566),
    [anon_sym_enum] = ACTIONS(5566),
    [anon_sym_class] = ACTIONS(5566),
    [anon_sym_struct] = ACTIONS(5566),
    [anon_sym_union] = ACTIONS(5566),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5566),
    [anon_sym_decltype] = ACTIONS(5566),
    [anon_sym_virtual] = ACTIONS(5566),
    [anon_sym_alignas] = ACTIONS(5566),
    [anon_sym_explicit] = ACTIONS(5566),
    [anon_sym_typename] = ACTIONS(5566),
    [anon_sym_template] = ACTIONS(5566),
    [anon_sym_operator] = ACTIONS(5566),
    [anon_sym_friend] = ACTIONS(5566),
    [anon_sym_public] = ACTIONS(5566),
    [anon_sym_private] = ACTIONS(5566),
    [anon_sym_protected] = ACTIONS(5566),
    [anon_sym_using] = ACTIONS(5566),
    [anon_sym_static_assert] = ACTIONS(5566),
  },
  [2306] = {
    [sym_identifier] = ACTIONS(3999),
    [aux_sym_preproc_def_token1] = ACTIONS(3999),
    [aux_sym_preproc_if_token1] = ACTIONS(3999),
    [aux_sym_preproc_if_token2] = ACTIONS(3999),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3999),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3999),
    [aux_sym_preproc_else_token1] = ACTIONS(3999),
    [aux_sym_preproc_elif_token1] = ACTIONS(3999),
    [sym_preproc_directive] = ACTIONS(3999),
    [anon_sym_LPAREN2] = ACTIONS(3997),
    [anon_sym_TILDE] = ACTIONS(3997),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_AMP] = ACTIONS(3999),
    [anon_sym___extension__] = ACTIONS(3999),
    [anon_sym_typedef] = ACTIONS(3999),
    [anon_sym_extern] = ACTIONS(3999),
    [anon_sym___attribute__] = ACTIONS(3999),
    [anon_sym_COLON_COLON] = ACTIONS(3997),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3997),
    [anon_sym___declspec] = ACTIONS(3999),
    [anon_sym___based] = ACTIONS(3999),
    [anon_sym_signed] = ACTIONS(3999),
    [anon_sym_unsigned] = ACTIONS(3999),
    [anon_sym_long] = ACTIONS(3999),
    [anon_sym_short] = ACTIONS(3999),
    [anon_sym_LBRACK] = ACTIONS(3999),
    [anon_sym_static] = ACTIONS(3999),
    [anon_sym_register] = ACTIONS(3999),
    [anon_sym_inline] = ACTIONS(3999),
    [anon_sym___inline] = ACTIONS(3999),
    [anon_sym___inline__] = ACTIONS(3999),
    [anon_sym___forceinline] = ACTIONS(3999),
    [anon_sym_thread_local] = ACTIONS(3999),
    [anon_sym___thread] = ACTIONS(3999),
    [anon_sym_const] = ACTIONS(3999),
    [anon_sym_constexpr] = ACTIONS(3999),
    [anon_sym_volatile] = ACTIONS(3999),
    [anon_sym_restrict] = ACTIONS(3999),
    [anon_sym___restrict__] = ACTIONS(3999),
    [anon_sym__Atomic] = ACTIONS(3999),
    [anon_sym__Noreturn] = ACTIONS(3999),
    [anon_sym_noreturn] = ACTIONS(3999),
    [anon_sym_mutable] = ACTIONS(3999),
    [anon_sym_constinit] = ACTIONS(3999),
    [anon_sym_consteval] = ACTIONS(3999),
    [anon_sym_PROGMEM] = ACTIONS(3999),
    [aux_sym_primitive_type_token1] = ACTIONS(3999),
    [anon_sym_byte] = ACTIONS(3999),
    [anon_sym_word] = ACTIONS(3999),
    [anon_sym_enum] = ACTIONS(3999),
    [anon_sym_class] = ACTIONS(3999),
    [anon_sym_struct] = ACTIONS(3999),
    [anon_sym_union] = ACTIONS(3999),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3999),
    [anon_sym_decltype] = ACTIONS(3999),
    [anon_sym_virtual] = ACTIONS(3999),
    [anon_sym_alignas] = ACTIONS(3999),
    [anon_sym_explicit] = ACTIONS(3999),
    [anon_sym_typename] = ACTIONS(3999),
    [anon_sym_template] = ACTIONS(3999),
    [anon_sym_operator] = ACTIONS(3999),
    [anon_sym_friend] = ACTIONS(3999),
    [anon_sym_public] = ACTIONS(3999),
    [anon_sym_private] = ACTIONS(3999),
    [anon_sym_protected] = ACTIONS(3999),
    [anon_sym_using] = ACTIONS(3999),
    [anon_sym_static_assert] = ACTIONS(3999),
  },
  [2307] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token2] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [aux_sym_preproc_else_token1] = ACTIONS(3082),
    [aux_sym_preproc_elif_token1] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(3082),
    [anon_sym_private] = ACTIONS(3082),
    [anon_sym_protected] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
  },
  [2308] = {
    [sym_identifier] = ACTIONS(3324),
    [aux_sym_preproc_def_token1] = ACTIONS(3324),
    [aux_sym_preproc_if_token1] = ACTIONS(3324),
    [aux_sym_preproc_if_token2] = ACTIONS(3324),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3324),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3324),
    [aux_sym_preproc_else_token1] = ACTIONS(3324),
    [aux_sym_preproc_elif_token1] = ACTIONS(3324),
    [sym_preproc_directive] = ACTIONS(3324),
    [anon_sym_LPAREN2] = ACTIONS(3326),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(3326),
    [anon_sym_AMP_AMP] = ACTIONS(3326),
    [anon_sym_AMP] = ACTIONS(3324),
    [anon_sym___extension__] = ACTIONS(3324),
    [anon_sym_typedef] = ACTIONS(3324),
    [anon_sym_extern] = ACTIONS(3324),
    [anon_sym___attribute__] = ACTIONS(3324),
    [anon_sym_COLON_COLON] = ACTIONS(3326),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3326),
    [anon_sym___declspec] = ACTIONS(3324),
    [anon_sym___based] = ACTIONS(3324),
    [anon_sym_signed] = ACTIONS(3324),
    [anon_sym_unsigned] = ACTIONS(3324),
    [anon_sym_long] = ACTIONS(3324),
    [anon_sym_short] = ACTIONS(3324),
    [anon_sym_LBRACK] = ACTIONS(3324),
    [anon_sym_static] = ACTIONS(3324),
    [anon_sym_register] = ACTIONS(3324),
    [anon_sym_inline] = ACTIONS(3324),
    [anon_sym___inline] = ACTIONS(3324),
    [anon_sym___inline__] = ACTIONS(3324),
    [anon_sym___forceinline] = ACTIONS(3324),
    [anon_sym_thread_local] = ACTIONS(3324),
    [anon_sym___thread] = ACTIONS(3324),
    [anon_sym_const] = ACTIONS(3324),
    [anon_sym_constexpr] = ACTIONS(3324),
    [anon_sym_volatile] = ACTIONS(3324),
    [anon_sym_restrict] = ACTIONS(3324),
    [anon_sym___restrict__] = ACTIONS(3324),
    [anon_sym__Atomic] = ACTIONS(3324),
    [anon_sym__Noreturn] = ACTIONS(3324),
    [anon_sym_noreturn] = ACTIONS(3324),
    [anon_sym_mutable] = ACTIONS(3324),
    [anon_sym_constinit] = ACTIONS(3324),
    [anon_sym_consteval] = ACTIONS(3324),
    [anon_sym_PROGMEM] = ACTIONS(3324),
    [aux_sym_primitive_type_token1] = ACTIONS(3324),
    [anon_sym_byte] = ACTIONS(3324),
    [anon_sym_word] = ACTIONS(3324),
    [anon_sym_enum] = ACTIONS(3324),
    [anon_sym_class] = ACTIONS(3324),
    [anon_sym_struct] = ACTIONS(3324),
    [anon_sym_union] = ACTIONS(3324),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3324),
    [anon_sym_decltype] = ACTIONS(3324),
    [anon_sym_virtual] = ACTIONS(3324),
    [anon_sym_alignas] = ACTIONS(3324),
    [anon_sym_explicit] = ACTIONS(3324),
    [anon_sym_typename] = ACTIONS(3324),
    [anon_sym_template] = ACTIONS(3324),
    [anon_sym_operator] = ACTIONS(3324),
    [anon_sym_friend] = ACTIONS(3324),
    [anon_sym_public] = ACTIONS(3324),
    [anon_sym_private] = ACTIONS(3324),
    [anon_sym_protected] = ACTIONS(3324),
    [anon_sym_using] = ACTIONS(3324),
    [anon_sym_static_assert] = ACTIONS(3324),
  },
  [2309] = {
    [sym_identifier] = ACTIONS(3086),
    [aux_sym_preproc_def_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token2] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3086),
    [aux_sym_preproc_else_token1] = ACTIONS(3086),
    [aux_sym_preproc_elif_token1] = ACTIONS(3086),
    [sym_preproc_directive] = ACTIONS(3086),
    [anon_sym_LPAREN2] = ACTIONS(3088),
    [anon_sym_TILDE] = ACTIONS(3088),
    [anon_sym_STAR] = ACTIONS(3088),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym___extension__] = ACTIONS(3086),
    [anon_sym_typedef] = ACTIONS(3086),
    [anon_sym_extern] = ACTIONS(3086),
    [anon_sym___attribute__] = ACTIONS(3086),
    [anon_sym_COLON_COLON] = ACTIONS(3088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3088),
    [anon_sym___declspec] = ACTIONS(3086),
    [anon_sym___based] = ACTIONS(3086),
    [anon_sym_signed] = ACTIONS(3086),
    [anon_sym_unsigned] = ACTIONS(3086),
    [anon_sym_long] = ACTIONS(3086),
    [anon_sym_short] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(3086),
    [anon_sym_static] = ACTIONS(3086),
    [anon_sym_register] = ACTIONS(3086),
    [anon_sym_inline] = ACTIONS(3086),
    [anon_sym___inline] = ACTIONS(3086),
    [anon_sym___inline__] = ACTIONS(3086),
    [anon_sym___forceinline] = ACTIONS(3086),
    [anon_sym_thread_local] = ACTIONS(3086),
    [anon_sym___thread] = ACTIONS(3086),
    [anon_sym_const] = ACTIONS(3086),
    [anon_sym_constexpr] = ACTIONS(3086),
    [anon_sym_volatile] = ACTIONS(3086),
    [anon_sym_restrict] = ACTIONS(3086),
    [anon_sym___restrict__] = ACTIONS(3086),
    [anon_sym__Atomic] = ACTIONS(3086),
    [anon_sym__Noreturn] = ACTIONS(3086),
    [anon_sym_noreturn] = ACTIONS(3086),
    [anon_sym_mutable] = ACTIONS(3086),
    [anon_sym_constinit] = ACTIONS(3086),
    [anon_sym_consteval] = ACTIONS(3086),
    [anon_sym_PROGMEM] = ACTIONS(3086),
    [aux_sym_primitive_type_token1] = ACTIONS(3086),
    [anon_sym_byte] = ACTIONS(3086),
    [anon_sym_word] = ACTIONS(3086),
    [anon_sym_enum] = ACTIONS(3086),
    [anon_sym_class] = ACTIONS(3086),
    [anon_sym_struct] = ACTIONS(3086),
    [anon_sym_union] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3086),
    [anon_sym_decltype] = ACTIONS(3086),
    [anon_sym_virtual] = ACTIONS(3086),
    [anon_sym_alignas] = ACTIONS(3086),
    [anon_sym_explicit] = ACTIONS(3086),
    [anon_sym_typename] = ACTIONS(3086),
    [anon_sym_template] = ACTIONS(3086),
    [anon_sym_operator] = ACTIONS(3086),
    [anon_sym_friend] = ACTIONS(3086),
    [anon_sym_public] = ACTIONS(3086),
    [anon_sym_private] = ACTIONS(3086),
    [anon_sym_protected] = ACTIONS(3086),
    [anon_sym_using] = ACTIONS(3086),
    [anon_sym_static_assert] = ACTIONS(3086),
  },
  [2310] = {
    [sym_string_literal] = STATE(2067),
    [sym_raw_string_literal] = STATE(2067),
    [sym_identifier] = ACTIONS(5797),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5799),
    [anon_sym_COMMA] = ACTIONS(5799),
    [aux_sym_preproc_if_token2] = ACTIONS(5799),
    [aux_sym_preproc_else_token1] = ACTIONS(5799),
    [aux_sym_preproc_elif_token1] = ACTIONS(5797),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5799),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5799),
    [anon_sym_LPAREN2] = ACTIONS(5799),
    [anon_sym_DASH] = ACTIONS(5797),
    [anon_sym_PLUS] = ACTIONS(5797),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_SLASH] = ACTIONS(5797),
    [anon_sym_PERCENT] = ACTIONS(5797),
    [anon_sym_PIPE_PIPE] = ACTIONS(5799),
    [anon_sym_AMP_AMP] = ACTIONS(5799),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_CARET] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_EQ_EQ] = ACTIONS(5799),
    [anon_sym_BANG_EQ] = ACTIONS(5799),
    [anon_sym_GT] = ACTIONS(5797),
    [anon_sym_GT_EQ] = ACTIONS(5799),
    [anon_sym_LT_EQ] = ACTIONS(5797),
    [anon_sym_LT] = ACTIONS(5797),
    [anon_sym_LT_LT] = ACTIONS(5797),
    [anon_sym_GT_GT] = ACTIONS(5797),
    [anon_sym_LBRACK] = ACTIONS(5799),
    [anon_sym_EQ] = ACTIONS(5797),
    [anon_sym_QMARK] = ACTIONS(5799),
    [anon_sym_STAR_EQ] = ACTIONS(5799),
    [anon_sym_SLASH_EQ] = ACTIONS(5799),
    [anon_sym_PERCENT_EQ] = ACTIONS(5799),
    [anon_sym_PLUS_EQ] = ACTIONS(5799),
    [anon_sym_DASH_EQ] = ACTIONS(5799),
    [anon_sym_LT_LT_EQ] = ACTIONS(5799),
    [anon_sym_GT_GT_EQ] = ACTIONS(5799),
    [anon_sym_AMP_EQ] = ACTIONS(5799),
    [anon_sym_CARET_EQ] = ACTIONS(5799),
    [anon_sym_PIPE_EQ] = ACTIONS(5799),
    [anon_sym_and_eq] = ACTIONS(5797),
    [anon_sym_or_eq] = ACTIONS(5797),
    [anon_sym_xor_eq] = ACTIONS(5797),
    [anon_sym_LT_EQ_GT] = ACTIONS(5799),
    [anon_sym_or] = ACTIONS(5797),
    [anon_sym_and] = ACTIONS(5797),
    [anon_sym_bitor] = ACTIONS(5797),
    [anon_sym_xor] = ACTIONS(5797),
    [anon_sym_bitand] = ACTIONS(5797),
    [anon_sym_not_eq] = ACTIONS(5797),
    [anon_sym_DASH_DASH] = ACTIONS(5799),
    [anon_sym_PLUS_PLUS] = ACTIONS(5799),
    [anon_sym_DOT] = ACTIONS(5797),
    [anon_sym_DOT_STAR] = ACTIONS(5799),
    [anon_sym_DASH_GT] = ACTIONS(5799),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [sym_literal_suffix] = ACTIONS(5801),
  },
  [2311] = {
    [sym_identifier] = ACTIONS(3869),
    [aux_sym_preproc_def_token1] = ACTIONS(3869),
    [aux_sym_preproc_if_token1] = ACTIONS(3869),
    [aux_sym_preproc_if_token2] = ACTIONS(3869),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3869),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3869),
    [aux_sym_preproc_else_token1] = ACTIONS(3869),
    [aux_sym_preproc_elif_token1] = ACTIONS(3869),
    [sym_preproc_directive] = ACTIONS(3869),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3867),
    [anon_sym_STAR] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_AMP] = ACTIONS(3869),
    [anon_sym___extension__] = ACTIONS(3869),
    [anon_sym_typedef] = ACTIONS(3869),
    [anon_sym_extern] = ACTIONS(3869),
    [anon_sym___attribute__] = ACTIONS(3869),
    [anon_sym_COLON_COLON] = ACTIONS(3867),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3867),
    [anon_sym___declspec] = ACTIONS(3869),
    [anon_sym___based] = ACTIONS(3869),
    [anon_sym_signed] = ACTIONS(3869),
    [anon_sym_unsigned] = ACTIONS(3869),
    [anon_sym_long] = ACTIONS(3869),
    [anon_sym_short] = ACTIONS(3869),
    [anon_sym_LBRACK] = ACTIONS(3869),
    [anon_sym_static] = ACTIONS(3869),
    [anon_sym_register] = ACTIONS(3869),
    [anon_sym_inline] = ACTIONS(3869),
    [anon_sym___inline] = ACTIONS(3869),
    [anon_sym___inline__] = ACTIONS(3869),
    [anon_sym___forceinline] = ACTIONS(3869),
    [anon_sym_thread_local] = ACTIONS(3869),
    [anon_sym___thread] = ACTIONS(3869),
    [anon_sym_const] = ACTIONS(3869),
    [anon_sym_constexpr] = ACTIONS(3869),
    [anon_sym_volatile] = ACTIONS(3869),
    [anon_sym_restrict] = ACTIONS(3869),
    [anon_sym___restrict__] = ACTIONS(3869),
    [anon_sym__Atomic] = ACTIONS(3869),
    [anon_sym__Noreturn] = ACTIONS(3869),
    [anon_sym_noreturn] = ACTIONS(3869),
    [anon_sym_mutable] = ACTIONS(3869),
    [anon_sym_constinit] = ACTIONS(3869),
    [anon_sym_consteval] = ACTIONS(3869),
    [anon_sym_PROGMEM] = ACTIONS(3869),
    [aux_sym_primitive_type_token1] = ACTIONS(3869),
    [anon_sym_byte] = ACTIONS(3869),
    [anon_sym_word] = ACTIONS(3869),
    [anon_sym_enum] = ACTIONS(3869),
    [anon_sym_class] = ACTIONS(3869),
    [anon_sym_struct] = ACTIONS(3869),
    [anon_sym_union] = ACTIONS(3869),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3869),
    [anon_sym_decltype] = ACTIONS(3869),
    [anon_sym_virtual] = ACTIONS(3869),
    [anon_sym_alignas] = ACTIONS(3869),
    [anon_sym_explicit] = ACTIONS(3869),
    [anon_sym_typename] = ACTIONS(3869),
    [anon_sym_template] = ACTIONS(3869),
    [anon_sym_operator] = ACTIONS(3869),
    [anon_sym_friend] = ACTIONS(3869),
    [anon_sym_public] = ACTIONS(3869),
    [anon_sym_private] = ACTIONS(3869),
    [anon_sym_protected] = ACTIONS(3869),
    [anon_sym_using] = ACTIONS(3869),
    [anon_sym_static_assert] = ACTIONS(3869),
  },
  [2312] = {
    [sym_identifier] = ACTIONS(3411),
    [aux_sym_preproc_def_token1] = ACTIONS(3411),
    [aux_sym_preproc_if_token1] = ACTIONS(3411),
    [aux_sym_preproc_if_token2] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3411),
    [aux_sym_preproc_else_token1] = ACTIONS(3411),
    [aux_sym_preproc_elif_token1] = ACTIONS(3411),
    [sym_preproc_directive] = ACTIONS(3411),
    [anon_sym_LPAREN2] = ACTIONS(3413),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_STAR] = ACTIONS(3413),
    [anon_sym_AMP_AMP] = ACTIONS(3413),
    [anon_sym_AMP] = ACTIONS(3411),
    [anon_sym___extension__] = ACTIONS(3411),
    [anon_sym_typedef] = ACTIONS(3411),
    [anon_sym_extern] = ACTIONS(3411),
    [anon_sym___attribute__] = ACTIONS(3411),
    [anon_sym_COLON_COLON] = ACTIONS(3413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3413),
    [anon_sym___declspec] = ACTIONS(3411),
    [anon_sym___based] = ACTIONS(3411),
    [anon_sym_signed] = ACTIONS(3411),
    [anon_sym_unsigned] = ACTIONS(3411),
    [anon_sym_long] = ACTIONS(3411),
    [anon_sym_short] = ACTIONS(3411),
    [anon_sym_LBRACK] = ACTIONS(3411),
    [anon_sym_static] = ACTIONS(3411),
    [anon_sym_register] = ACTIONS(3411),
    [anon_sym_inline] = ACTIONS(3411),
    [anon_sym___inline] = ACTIONS(3411),
    [anon_sym___inline__] = ACTIONS(3411),
    [anon_sym___forceinline] = ACTIONS(3411),
    [anon_sym_thread_local] = ACTIONS(3411),
    [anon_sym___thread] = ACTIONS(3411),
    [anon_sym_const] = ACTIONS(3411),
    [anon_sym_constexpr] = ACTIONS(3411),
    [anon_sym_volatile] = ACTIONS(3411),
    [anon_sym_restrict] = ACTIONS(3411),
    [anon_sym___restrict__] = ACTIONS(3411),
    [anon_sym__Atomic] = ACTIONS(3411),
    [anon_sym__Noreturn] = ACTIONS(3411),
    [anon_sym_noreturn] = ACTIONS(3411),
    [anon_sym_mutable] = ACTIONS(3411),
    [anon_sym_constinit] = ACTIONS(3411),
    [anon_sym_consteval] = ACTIONS(3411),
    [anon_sym_PROGMEM] = ACTIONS(3411),
    [aux_sym_primitive_type_token1] = ACTIONS(3411),
    [anon_sym_byte] = ACTIONS(3411),
    [anon_sym_word] = ACTIONS(3411),
    [anon_sym_enum] = ACTIONS(3411),
    [anon_sym_class] = ACTIONS(3411),
    [anon_sym_struct] = ACTIONS(3411),
    [anon_sym_union] = ACTIONS(3411),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3411),
    [anon_sym_decltype] = ACTIONS(3411),
    [anon_sym_virtual] = ACTIONS(3411),
    [anon_sym_alignas] = ACTIONS(3411),
    [anon_sym_explicit] = ACTIONS(3411),
    [anon_sym_typename] = ACTIONS(3411),
    [anon_sym_template] = ACTIONS(3411),
    [anon_sym_operator] = ACTIONS(3411),
    [anon_sym_friend] = ACTIONS(3411),
    [anon_sym_public] = ACTIONS(3411),
    [anon_sym_private] = ACTIONS(3411),
    [anon_sym_protected] = ACTIONS(3411),
    [anon_sym_using] = ACTIONS(3411),
    [anon_sym_static_assert] = ACTIONS(3411),
  },
  [2313] = {
    [sym_identifier] = ACTIONS(3521),
    [aux_sym_preproc_def_token1] = ACTIONS(3521),
    [aux_sym_preproc_if_token1] = ACTIONS(3521),
    [aux_sym_preproc_if_token2] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3521),
    [aux_sym_preproc_else_token1] = ACTIONS(3521),
    [aux_sym_preproc_elif_token1] = ACTIONS(3521),
    [sym_preproc_directive] = ACTIONS(3521),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3521),
    [anon_sym___extension__] = ACTIONS(3521),
    [anon_sym_typedef] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym___attribute__] = ACTIONS(3521),
    [anon_sym_COLON_COLON] = ACTIONS(3523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3523),
    [anon_sym___declspec] = ACTIONS(3521),
    [anon_sym___based] = ACTIONS(3521),
    [anon_sym_signed] = ACTIONS(3521),
    [anon_sym_unsigned] = ACTIONS(3521),
    [anon_sym_long] = ACTIONS(3521),
    [anon_sym_short] = ACTIONS(3521),
    [anon_sym_LBRACK] = ACTIONS(3521),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_register] = ACTIONS(3521),
    [anon_sym_inline] = ACTIONS(3521),
    [anon_sym___inline] = ACTIONS(3521),
    [anon_sym___inline__] = ACTIONS(3521),
    [anon_sym___forceinline] = ACTIONS(3521),
    [anon_sym_thread_local] = ACTIONS(3521),
    [anon_sym___thread] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_constexpr] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym_restrict] = ACTIONS(3521),
    [anon_sym___restrict__] = ACTIONS(3521),
    [anon_sym__Atomic] = ACTIONS(3521),
    [anon_sym__Noreturn] = ACTIONS(3521),
    [anon_sym_noreturn] = ACTIONS(3521),
    [anon_sym_mutable] = ACTIONS(3521),
    [anon_sym_constinit] = ACTIONS(3521),
    [anon_sym_consteval] = ACTIONS(3521),
    [anon_sym_PROGMEM] = ACTIONS(3521),
    [aux_sym_primitive_type_token1] = ACTIONS(3521),
    [anon_sym_byte] = ACTIONS(3521),
    [anon_sym_word] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_class] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_union] = ACTIONS(3521),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3521),
    [anon_sym_decltype] = ACTIONS(3521),
    [anon_sym_virtual] = ACTIONS(3521),
    [anon_sym_alignas] = ACTIONS(3521),
    [anon_sym_explicit] = ACTIONS(3521),
    [anon_sym_typename] = ACTIONS(3521),
    [anon_sym_template] = ACTIONS(3521),
    [anon_sym_operator] = ACTIONS(3521),
    [anon_sym_friend] = ACTIONS(3521),
    [anon_sym_public] = ACTIONS(3521),
    [anon_sym_private] = ACTIONS(3521),
    [anon_sym_protected] = ACTIONS(3521),
    [anon_sym_using] = ACTIONS(3521),
    [anon_sym_static_assert] = ACTIONS(3521),
  },
  [2314] = {
    [sym_identifier] = ACTIONS(3475),
    [aux_sym_preproc_def_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token2] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3475),
    [aux_sym_preproc_else_token1] = ACTIONS(3475),
    [aux_sym_preproc_elif_token1] = ACTIONS(3475),
    [sym_preproc_directive] = ACTIONS(3475),
    [anon_sym_LPAREN2] = ACTIONS(3477),
    [anon_sym_TILDE] = ACTIONS(3477),
    [anon_sym_STAR] = ACTIONS(3477),
    [anon_sym_AMP_AMP] = ACTIONS(3477),
    [anon_sym_AMP] = ACTIONS(3475),
    [anon_sym___extension__] = ACTIONS(3475),
    [anon_sym_typedef] = ACTIONS(3475),
    [anon_sym_extern] = ACTIONS(3475),
    [anon_sym___attribute__] = ACTIONS(3475),
    [anon_sym_COLON_COLON] = ACTIONS(3477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3477),
    [anon_sym___declspec] = ACTIONS(3475),
    [anon_sym___based] = ACTIONS(3475),
    [anon_sym_signed] = ACTIONS(3475),
    [anon_sym_unsigned] = ACTIONS(3475),
    [anon_sym_long] = ACTIONS(3475),
    [anon_sym_short] = ACTIONS(3475),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [anon_sym_static] = ACTIONS(3475),
    [anon_sym_register] = ACTIONS(3475),
    [anon_sym_inline] = ACTIONS(3475),
    [anon_sym___inline] = ACTIONS(3475),
    [anon_sym___inline__] = ACTIONS(3475),
    [anon_sym___forceinline] = ACTIONS(3475),
    [anon_sym_thread_local] = ACTIONS(3475),
    [anon_sym___thread] = ACTIONS(3475),
    [anon_sym_const] = ACTIONS(3475),
    [anon_sym_constexpr] = ACTIONS(3475),
    [anon_sym_volatile] = ACTIONS(3475),
    [anon_sym_restrict] = ACTIONS(3475),
    [anon_sym___restrict__] = ACTIONS(3475),
    [anon_sym__Atomic] = ACTIONS(3475),
    [anon_sym__Noreturn] = ACTIONS(3475),
    [anon_sym_noreturn] = ACTIONS(3475),
    [anon_sym_mutable] = ACTIONS(3475),
    [anon_sym_constinit] = ACTIONS(3475),
    [anon_sym_consteval] = ACTIONS(3475),
    [anon_sym_PROGMEM] = ACTIONS(3475),
    [aux_sym_primitive_type_token1] = ACTIONS(3475),
    [anon_sym_byte] = ACTIONS(3475),
    [anon_sym_word] = ACTIONS(3475),
    [anon_sym_enum] = ACTIONS(3475),
    [anon_sym_class] = ACTIONS(3475),
    [anon_sym_struct] = ACTIONS(3475),
    [anon_sym_union] = ACTIONS(3475),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3475),
    [anon_sym_decltype] = ACTIONS(3475),
    [anon_sym_virtual] = ACTIONS(3475),
    [anon_sym_alignas] = ACTIONS(3475),
    [anon_sym_explicit] = ACTIONS(3475),
    [anon_sym_typename] = ACTIONS(3475),
    [anon_sym_template] = ACTIONS(3475),
    [anon_sym_operator] = ACTIONS(3475),
    [anon_sym_friend] = ACTIONS(3475),
    [anon_sym_public] = ACTIONS(3475),
    [anon_sym_private] = ACTIONS(3475),
    [anon_sym_protected] = ACTIONS(3475),
    [anon_sym_using] = ACTIONS(3475),
    [anon_sym_static_assert] = ACTIONS(3475),
  },
  [2315] = {
    [sym_identifier] = ACTIONS(3134),
    [aux_sym_preproc_def_token1] = ACTIONS(3134),
    [aux_sym_preproc_if_token1] = ACTIONS(3134),
    [aux_sym_preproc_if_token2] = ACTIONS(3134),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3134),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3134),
    [aux_sym_preproc_else_token1] = ACTIONS(3134),
    [aux_sym_preproc_elif_token1] = ACTIONS(3134),
    [sym_preproc_directive] = ACTIONS(3134),
    [anon_sym_LPAREN2] = ACTIONS(3136),
    [anon_sym_TILDE] = ACTIONS(3136),
    [anon_sym_STAR] = ACTIONS(3136),
    [anon_sym_AMP_AMP] = ACTIONS(3136),
    [anon_sym_AMP] = ACTIONS(3134),
    [anon_sym___extension__] = ACTIONS(3134),
    [anon_sym_typedef] = ACTIONS(3134),
    [anon_sym_extern] = ACTIONS(3134),
    [anon_sym___attribute__] = ACTIONS(3134),
    [anon_sym_COLON_COLON] = ACTIONS(3136),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3136),
    [anon_sym___declspec] = ACTIONS(3134),
    [anon_sym___based] = ACTIONS(3134),
    [anon_sym_signed] = ACTIONS(3134),
    [anon_sym_unsigned] = ACTIONS(3134),
    [anon_sym_long] = ACTIONS(3134),
    [anon_sym_short] = ACTIONS(3134),
    [anon_sym_LBRACK] = ACTIONS(3134),
    [anon_sym_static] = ACTIONS(3134),
    [anon_sym_register] = ACTIONS(3134),
    [anon_sym_inline] = ACTIONS(3134),
    [anon_sym___inline] = ACTIONS(3134),
    [anon_sym___inline__] = ACTIONS(3134),
    [anon_sym___forceinline] = ACTIONS(3134),
    [anon_sym_thread_local] = ACTIONS(3134),
    [anon_sym___thread] = ACTIONS(3134),
    [anon_sym_const] = ACTIONS(3134),
    [anon_sym_constexpr] = ACTIONS(3134),
    [anon_sym_volatile] = ACTIONS(3134),
    [anon_sym_restrict] = ACTIONS(3134),
    [anon_sym___restrict__] = ACTIONS(3134),
    [anon_sym__Atomic] = ACTIONS(3134),
    [anon_sym__Noreturn] = ACTIONS(3134),
    [anon_sym_noreturn] = ACTIONS(3134),
    [anon_sym_mutable] = ACTIONS(3134),
    [anon_sym_constinit] = ACTIONS(3134),
    [anon_sym_consteval] = ACTIONS(3134),
    [anon_sym_PROGMEM] = ACTIONS(3134),
    [aux_sym_primitive_type_token1] = ACTIONS(3134),
    [anon_sym_byte] = ACTIONS(3134),
    [anon_sym_word] = ACTIONS(3134),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3134),
    [anon_sym_struct] = ACTIONS(3134),
    [anon_sym_union] = ACTIONS(3134),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3134),
    [anon_sym_decltype] = ACTIONS(3134),
    [anon_sym_virtual] = ACTIONS(3134),
    [anon_sym_alignas] = ACTIONS(3134),
    [anon_sym_explicit] = ACTIONS(3134),
    [anon_sym_typename] = ACTIONS(3134),
    [anon_sym_template] = ACTIONS(3134),
    [anon_sym_operator] = ACTIONS(3134),
    [anon_sym_friend] = ACTIONS(3134),
    [anon_sym_public] = ACTIONS(3134),
    [anon_sym_private] = ACTIONS(3134),
    [anon_sym_protected] = ACTIONS(3134),
    [anon_sym_using] = ACTIONS(3134),
    [anon_sym_static_assert] = ACTIONS(3134),
  },
  [2316] = {
    [sym_identifier] = ACTIONS(3439),
    [aux_sym_preproc_def_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token2] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3439),
    [aux_sym_preproc_else_token1] = ACTIONS(3439),
    [aux_sym_preproc_elif_token1] = ACTIONS(3439),
    [sym_preproc_directive] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3439),
    [anon_sym___extension__] = ACTIONS(3439),
    [anon_sym_typedef] = ACTIONS(3439),
    [anon_sym_extern] = ACTIONS(3439),
    [anon_sym___attribute__] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3441),
    [anon_sym___declspec] = ACTIONS(3439),
    [anon_sym___based] = ACTIONS(3439),
    [anon_sym_signed] = ACTIONS(3439),
    [anon_sym_unsigned] = ACTIONS(3439),
    [anon_sym_long] = ACTIONS(3439),
    [anon_sym_short] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_register] = ACTIONS(3439),
    [anon_sym_inline] = ACTIONS(3439),
    [anon_sym___inline] = ACTIONS(3439),
    [anon_sym___inline__] = ACTIONS(3439),
    [anon_sym___forceinline] = ACTIONS(3439),
    [anon_sym_thread_local] = ACTIONS(3439),
    [anon_sym___thread] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_constexpr] = ACTIONS(3439),
    [anon_sym_volatile] = ACTIONS(3439),
    [anon_sym_restrict] = ACTIONS(3439),
    [anon_sym___restrict__] = ACTIONS(3439),
    [anon_sym__Atomic] = ACTIONS(3439),
    [anon_sym__Noreturn] = ACTIONS(3439),
    [anon_sym_noreturn] = ACTIONS(3439),
    [anon_sym_mutable] = ACTIONS(3439),
    [anon_sym_constinit] = ACTIONS(3439),
    [anon_sym_consteval] = ACTIONS(3439),
    [anon_sym_PROGMEM] = ACTIONS(3439),
    [aux_sym_primitive_type_token1] = ACTIONS(3439),
    [anon_sym_byte] = ACTIONS(3439),
    [anon_sym_word] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_struct] = ACTIONS(3439),
    [anon_sym_union] = ACTIONS(3439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3439),
    [anon_sym_decltype] = ACTIONS(3439),
    [anon_sym_virtual] = ACTIONS(3439),
    [anon_sym_alignas] = ACTIONS(3439),
    [anon_sym_explicit] = ACTIONS(3439),
    [anon_sym_typename] = ACTIONS(3439),
    [anon_sym_template] = ACTIONS(3439),
    [anon_sym_operator] = ACTIONS(3439),
    [anon_sym_friend] = ACTIONS(3439),
    [anon_sym_public] = ACTIONS(3439),
    [anon_sym_private] = ACTIONS(3439),
    [anon_sym_protected] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_static_assert] = ACTIONS(3439),
  },
  [2317] = {
    [sym_identifier] = ACTIONS(3192),
    [aux_sym_preproc_def_token1] = ACTIONS(3192),
    [aux_sym_preproc_if_token1] = ACTIONS(3192),
    [aux_sym_preproc_if_token2] = ACTIONS(3192),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3192),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3192),
    [aux_sym_preproc_else_token1] = ACTIONS(3192),
    [aux_sym_preproc_elif_token1] = ACTIONS(3192),
    [sym_preproc_directive] = ACTIONS(3192),
    [anon_sym_LPAREN2] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3194),
    [anon_sym_AMP_AMP] = ACTIONS(3194),
    [anon_sym_AMP] = ACTIONS(3192),
    [anon_sym___extension__] = ACTIONS(3192),
    [anon_sym_typedef] = ACTIONS(3192),
    [anon_sym_extern] = ACTIONS(3192),
    [anon_sym___attribute__] = ACTIONS(3192),
    [anon_sym_COLON_COLON] = ACTIONS(3194),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3194),
    [anon_sym___declspec] = ACTIONS(3192),
    [anon_sym___based] = ACTIONS(3192),
    [anon_sym_signed] = ACTIONS(3192),
    [anon_sym_unsigned] = ACTIONS(3192),
    [anon_sym_long] = ACTIONS(3192),
    [anon_sym_short] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [anon_sym_static] = ACTIONS(3192),
    [anon_sym_register] = ACTIONS(3192),
    [anon_sym_inline] = ACTIONS(3192),
    [anon_sym___inline] = ACTIONS(3192),
    [anon_sym___inline__] = ACTIONS(3192),
    [anon_sym___forceinline] = ACTIONS(3192),
    [anon_sym_thread_local] = ACTIONS(3192),
    [anon_sym___thread] = ACTIONS(3192),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_constexpr] = ACTIONS(3192),
    [anon_sym_volatile] = ACTIONS(3192),
    [anon_sym_restrict] = ACTIONS(3192),
    [anon_sym___restrict__] = ACTIONS(3192),
    [anon_sym__Atomic] = ACTIONS(3192),
    [anon_sym__Noreturn] = ACTIONS(3192),
    [anon_sym_noreturn] = ACTIONS(3192),
    [anon_sym_mutable] = ACTIONS(3192),
    [anon_sym_constinit] = ACTIONS(3192),
    [anon_sym_consteval] = ACTIONS(3192),
    [anon_sym_PROGMEM] = ACTIONS(3192),
    [aux_sym_primitive_type_token1] = ACTIONS(3192),
    [anon_sym_byte] = ACTIONS(3192),
    [anon_sym_word] = ACTIONS(3192),
    [anon_sym_enum] = ACTIONS(3192),
    [anon_sym_class] = ACTIONS(3192),
    [anon_sym_struct] = ACTIONS(3192),
    [anon_sym_union] = ACTIONS(3192),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3192),
    [anon_sym_decltype] = ACTIONS(3192),
    [anon_sym_virtual] = ACTIONS(3192),
    [anon_sym_alignas] = ACTIONS(3192),
    [anon_sym_explicit] = ACTIONS(3192),
    [anon_sym_typename] = ACTIONS(3192),
    [anon_sym_template] = ACTIONS(3192),
    [anon_sym_operator] = ACTIONS(3192),
    [anon_sym_friend] = ACTIONS(3192),
    [anon_sym_public] = ACTIONS(3192),
    [anon_sym_private] = ACTIONS(3192),
    [anon_sym_protected] = ACTIONS(3192),
    [anon_sym_using] = ACTIONS(3192),
    [anon_sym_static_assert] = ACTIONS(3192),
  },
  [2318] = {
    [sym_identifier] = ACTIONS(3254),
    [aux_sym_preproc_def_token1] = ACTIONS(3254),
    [aux_sym_preproc_if_token1] = ACTIONS(3254),
    [aux_sym_preproc_if_token2] = ACTIONS(3254),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3254),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3254),
    [aux_sym_preproc_else_token1] = ACTIONS(3254),
    [aux_sym_preproc_elif_token1] = ACTIONS(3254),
    [sym_preproc_directive] = ACTIONS(3254),
    [anon_sym_LPAREN2] = ACTIONS(3256),
    [anon_sym_TILDE] = ACTIONS(3256),
    [anon_sym_STAR] = ACTIONS(3256),
    [anon_sym_AMP_AMP] = ACTIONS(3256),
    [anon_sym_AMP] = ACTIONS(3254),
    [anon_sym___extension__] = ACTIONS(3254),
    [anon_sym_typedef] = ACTIONS(3254),
    [anon_sym_extern] = ACTIONS(3254),
    [anon_sym___attribute__] = ACTIONS(3254),
    [anon_sym_COLON_COLON] = ACTIONS(3256),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3256),
    [anon_sym___declspec] = ACTIONS(3254),
    [anon_sym___based] = ACTIONS(3254),
    [anon_sym_signed] = ACTIONS(3254),
    [anon_sym_unsigned] = ACTIONS(3254),
    [anon_sym_long] = ACTIONS(3254),
    [anon_sym_short] = ACTIONS(3254),
    [anon_sym_LBRACK] = ACTIONS(3254),
    [anon_sym_static] = ACTIONS(3254),
    [anon_sym_register] = ACTIONS(3254),
    [anon_sym_inline] = ACTIONS(3254),
    [anon_sym___inline] = ACTIONS(3254),
    [anon_sym___inline__] = ACTIONS(3254),
    [anon_sym___forceinline] = ACTIONS(3254),
    [anon_sym_thread_local] = ACTIONS(3254),
    [anon_sym___thread] = ACTIONS(3254),
    [anon_sym_const] = ACTIONS(3254),
    [anon_sym_constexpr] = ACTIONS(3254),
    [anon_sym_volatile] = ACTIONS(3254),
    [anon_sym_restrict] = ACTIONS(3254),
    [anon_sym___restrict__] = ACTIONS(3254),
    [anon_sym__Atomic] = ACTIONS(3254),
    [anon_sym__Noreturn] = ACTIONS(3254),
    [anon_sym_noreturn] = ACTIONS(3254),
    [anon_sym_mutable] = ACTIONS(3254),
    [anon_sym_constinit] = ACTIONS(3254),
    [anon_sym_consteval] = ACTIONS(3254),
    [anon_sym_PROGMEM] = ACTIONS(3254),
    [aux_sym_primitive_type_token1] = ACTIONS(3254),
    [anon_sym_byte] = ACTIONS(3254),
    [anon_sym_word] = ACTIONS(3254),
    [anon_sym_enum] = ACTIONS(3254),
    [anon_sym_class] = ACTIONS(3254),
    [anon_sym_struct] = ACTIONS(3254),
    [anon_sym_union] = ACTIONS(3254),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3254),
    [anon_sym_decltype] = ACTIONS(3254),
    [anon_sym_virtual] = ACTIONS(3254),
    [anon_sym_alignas] = ACTIONS(3254),
    [anon_sym_explicit] = ACTIONS(3254),
    [anon_sym_typename] = ACTIONS(3254),
    [anon_sym_template] = ACTIONS(3254),
    [anon_sym_operator] = ACTIONS(3254),
    [anon_sym_friend] = ACTIONS(3254),
    [anon_sym_public] = ACTIONS(3254),
    [anon_sym_private] = ACTIONS(3254),
    [anon_sym_protected] = ACTIONS(3254),
    [anon_sym_using] = ACTIONS(3254),
    [anon_sym_static_assert] = ACTIONS(3254),
  },
  [2319] = {
    [sym_identifier] = ACTIONS(5598),
    [aux_sym_preproc_def_token1] = ACTIONS(5598),
    [aux_sym_preproc_if_token1] = ACTIONS(5598),
    [aux_sym_preproc_if_token2] = ACTIONS(5598),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5598),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5598),
    [aux_sym_preproc_else_token1] = ACTIONS(5598),
    [aux_sym_preproc_elif_token1] = ACTIONS(5598),
    [sym_preproc_directive] = ACTIONS(5598),
    [anon_sym_LPAREN2] = ACTIONS(5600),
    [anon_sym_TILDE] = ACTIONS(5600),
    [anon_sym_STAR] = ACTIONS(5600),
    [anon_sym_AMP_AMP] = ACTIONS(5600),
    [anon_sym_AMP] = ACTIONS(5598),
    [anon_sym___extension__] = ACTIONS(5598),
    [anon_sym_typedef] = ACTIONS(5598),
    [anon_sym_extern] = ACTIONS(5598),
    [anon_sym___attribute__] = ACTIONS(5598),
    [anon_sym_COLON_COLON] = ACTIONS(5600),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5600),
    [anon_sym___declspec] = ACTIONS(5598),
    [anon_sym___based] = ACTIONS(5598),
    [anon_sym_signed] = ACTIONS(5598),
    [anon_sym_unsigned] = ACTIONS(5598),
    [anon_sym_long] = ACTIONS(5598),
    [anon_sym_short] = ACTIONS(5598),
    [anon_sym_LBRACK] = ACTIONS(5598),
    [anon_sym_static] = ACTIONS(5598),
    [anon_sym_register] = ACTIONS(5598),
    [anon_sym_inline] = ACTIONS(5598),
    [anon_sym___inline] = ACTIONS(5598),
    [anon_sym___inline__] = ACTIONS(5598),
    [anon_sym___forceinline] = ACTIONS(5598),
    [anon_sym_thread_local] = ACTIONS(5598),
    [anon_sym___thread] = ACTIONS(5598),
    [anon_sym_const] = ACTIONS(5598),
    [anon_sym_constexpr] = ACTIONS(5598),
    [anon_sym_volatile] = ACTIONS(5598),
    [anon_sym_restrict] = ACTIONS(5598),
    [anon_sym___restrict__] = ACTIONS(5598),
    [anon_sym__Atomic] = ACTIONS(5598),
    [anon_sym__Noreturn] = ACTIONS(5598),
    [anon_sym_noreturn] = ACTIONS(5598),
    [anon_sym_mutable] = ACTIONS(5598),
    [anon_sym_constinit] = ACTIONS(5598),
    [anon_sym_consteval] = ACTIONS(5598),
    [anon_sym_PROGMEM] = ACTIONS(5598),
    [aux_sym_primitive_type_token1] = ACTIONS(5598),
    [anon_sym_byte] = ACTIONS(5598),
    [anon_sym_word] = ACTIONS(5598),
    [anon_sym_enum] = ACTIONS(5598),
    [anon_sym_class] = ACTIONS(5598),
    [anon_sym_struct] = ACTIONS(5598),
    [anon_sym_union] = ACTIONS(5598),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5598),
    [anon_sym_decltype] = ACTIONS(5598),
    [anon_sym_virtual] = ACTIONS(5598),
    [anon_sym_alignas] = ACTIONS(5598),
    [anon_sym_explicit] = ACTIONS(5598),
    [anon_sym_typename] = ACTIONS(5598),
    [anon_sym_template] = ACTIONS(5598),
    [anon_sym_operator] = ACTIONS(5598),
    [anon_sym_friend] = ACTIONS(5598),
    [anon_sym_public] = ACTIONS(5598),
    [anon_sym_private] = ACTIONS(5598),
    [anon_sym_protected] = ACTIONS(5598),
    [anon_sym_using] = ACTIONS(5598),
    [anon_sym_static_assert] = ACTIONS(5598),
  },
  [2320] = {
    [sym_identifier] = ACTIONS(5602),
    [aux_sym_preproc_def_token1] = ACTIONS(5602),
    [aux_sym_preproc_if_token1] = ACTIONS(5602),
    [aux_sym_preproc_if_token2] = ACTIONS(5602),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5602),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5602),
    [aux_sym_preproc_else_token1] = ACTIONS(5602),
    [aux_sym_preproc_elif_token1] = ACTIONS(5602),
    [sym_preproc_directive] = ACTIONS(5602),
    [anon_sym_LPAREN2] = ACTIONS(5604),
    [anon_sym_TILDE] = ACTIONS(5604),
    [anon_sym_STAR] = ACTIONS(5604),
    [anon_sym_AMP_AMP] = ACTIONS(5604),
    [anon_sym_AMP] = ACTIONS(5602),
    [anon_sym___extension__] = ACTIONS(5602),
    [anon_sym_typedef] = ACTIONS(5602),
    [anon_sym_extern] = ACTIONS(5602),
    [anon_sym___attribute__] = ACTIONS(5602),
    [anon_sym_COLON_COLON] = ACTIONS(5604),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5604),
    [anon_sym___declspec] = ACTIONS(5602),
    [anon_sym___based] = ACTIONS(5602),
    [anon_sym_signed] = ACTIONS(5602),
    [anon_sym_unsigned] = ACTIONS(5602),
    [anon_sym_long] = ACTIONS(5602),
    [anon_sym_short] = ACTIONS(5602),
    [anon_sym_LBRACK] = ACTIONS(5602),
    [anon_sym_static] = ACTIONS(5602),
    [anon_sym_register] = ACTIONS(5602),
    [anon_sym_inline] = ACTIONS(5602),
    [anon_sym___inline] = ACTIONS(5602),
    [anon_sym___inline__] = ACTIONS(5602),
    [anon_sym___forceinline] = ACTIONS(5602),
    [anon_sym_thread_local] = ACTIONS(5602),
    [anon_sym___thread] = ACTIONS(5602),
    [anon_sym_const] = ACTIONS(5602),
    [anon_sym_constexpr] = ACTIONS(5602),
    [anon_sym_volatile] = ACTIONS(5602),
    [anon_sym_restrict] = ACTIONS(5602),
    [anon_sym___restrict__] = ACTIONS(5602),
    [anon_sym__Atomic] = ACTIONS(5602),
    [anon_sym__Noreturn] = ACTIONS(5602),
    [anon_sym_noreturn] = ACTIONS(5602),
    [anon_sym_mutable] = ACTIONS(5602),
    [anon_sym_constinit] = ACTIONS(5602),
    [anon_sym_consteval] = ACTIONS(5602),
    [anon_sym_PROGMEM] = ACTIONS(5602),
    [aux_sym_primitive_type_token1] = ACTIONS(5602),
    [anon_sym_byte] = ACTIONS(5602),
    [anon_sym_word] = ACTIONS(5602),
    [anon_sym_enum] = ACTIONS(5602),
    [anon_sym_class] = ACTIONS(5602),
    [anon_sym_struct] = ACTIONS(5602),
    [anon_sym_union] = ACTIONS(5602),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5602),
    [anon_sym_decltype] = ACTIONS(5602),
    [anon_sym_virtual] = ACTIONS(5602),
    [anon_sym_alignas] = ACTIONS(5602),
    [anon_sym_explicit] = ACTIONS(5602),
    [anon_sym_typename] = ACTIONS(5602),
    [anon_sym_template] = ACTIONS(5602),
    [anon_sym_operator] = ACTIONS(5602),
    [anon_sym_friend] = ACTIONS(5602),
    [anon_sym_public] = ACTIONS(5602),
    [anon_sym_private] = ACTIONS(5602),
    [anon_sym_protected] = ACTIONS(5602),
    [anon_sym_using] = ACTIONS(5602),
    [anon_sym_static_assert] = ACTIONS(5602),
  },
  [2321] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token2] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(2265),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_friend] = ACTIONS(2267),
    [anon_sym_public] = ACTIONS(2267),
    [anon_sym_private] = ACTIONS(2267),
    [anon_sym_protected] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym_catch] = ACTIONS(2267),
  },
  [2322] = {
    [sym_identifier] = ACTIONS(3499),
    [aux_sym_preproc_def_token1] = ACTIONS(3499),
    [aux_sym_preproc_if_token1] = ACTIONS(3499),
    [aux_sym_preproc_if_token2] = ACTIONS(3499),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3499),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3499),
    [aux_sym_preproc_else_token1] = ACTIONS(3499),
    [aux_sym_preproc_elif_token1] = ACTIONS(3499),
    [sym_preproc_directive] = ACTIONS(3499),
    [anon_sym_LPAREN2] = ACTIONS(3501),
    [anon_sym_TILDE] = ACTIONS(3501),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_AMP_AMP] = ACTIONS(3501),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym___extension__] = ACTIONS(3499),
    [anon_sym_typedef] = ACTIONS(3499),
    [anon_sym_extern] = ACTIONS(3499),
    [anon_sym___attribute__] = ACTIONS(3499),
    [anon_sym_COLON_COLON] = ACTIONS(3501),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3501),
    [anon_sym___declspec] = ACTIONS(3499),
    [anon_sym___based] = ACTIONS(3499),
    [anon_sym_signed] = ACTIONS(3499),
    [anon_sym_unsigned] = ACTIONS(3499),
    [anon_sym_long] = ACTIONS(3499),
    [anon_sym_short] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(3499),
    [anon_sym_static] = ACTIONS(3499),
    [anon_sym_register] = ACTIONS(3499),
    [anon_sym_inline] = ACTIONS(3499),
    [anon_sym___inline] = ACTIONS(3499),
    [anon_sym___inline__] = ACTIONS(3499),
    [anon_sym___forceinline] = ACTIONS(3499),
    [anon_sym_thread_local] = ACTIONS(3499),
    [anon_sym___thread] = ACTIONS(3499),
    [anon_sym_const] = ACTIONS(3499),
    [anon_sym_constexpr] = ACTIONS(3499),
    [anon_sym_volatile] = ACTIONS(3499),
    [anon_sym_restrict] = ACTIONS(3499),
    [anon_sym___restrict__] = ACTIONS(3499),
    [anon_sym__Atomic] = ACTIONS(3499),
    [anon_sym__Noreturn] = ACTIONS(3499),
    [anon_sym_noreturn] = ACTIONS(3499),
    [anon_sym_mutable] = ACTIONS(3499),
    [anon_sym_constinit] = ACTIONS(3499),
    [anon_sym_consteval] = ACTIONS(3499),
    [anon_sym_PROGMEM] = ACTIONS(3499),
    [aux_sym_primitive_type_token1] = ACTIONS(3499),
    [anon_sym_byte] = ACTIONS(3499),
    [anon_sym_word] = ACTIONS(3499),
    [anon_sym_enum] = ACTIONS(3499),
    [anon_sym_class] = ACTIONS(3499),
    [anon_sym_struct] = ACTIONS(3499),
    [anon_sym_union] = ACTIONS(3499),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3499),
    [anon_sym_decltype] = ACTIONS(3499),
    [anon_sym_virtual] = ACTIONS(3499),
    [anon_sym_alignas] = ACTIONS(3499),
    [anon_sym_explicit] = ACTIONS(3499),
    [anon_sym_typename] = ACTIONS(3499),
    [anon_sym_template] = ACTIONS(3499),
    [anon_sym_operator] = ACTIONS(3499),
    [anon_sym_friend] = ACTIONS(3499),
    [anon_sym_public] = ACTIONS(3499),
    [anon_sym_private] = ACTIONS(3499),
    [anon_sym_protected] = ACTIONS(3499),
    [anon_sym_using] = ACTIONS(3499),
    [anon_sym_static_assert] = ACTIONS(3499),
  },
  [2323] = {
    [sym_identifier] = ACTIONS(2970),
    [aux_sym_preproc_def_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token2] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2970),
    [aux_sym_preproc_else_token1] = ACTIONS(2970),
    [aux_sym_preproc_elif_token1] = ACTIONS(2970),
    [sym_preproc_directive] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym___extension__] = ACTIONS(2970),
    [anon_sym_typedef] = ACTIONS(2970),
    [anon_sym_extern] = ACTIONS(2970),
    [anon_sym___attribute__] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2970),
    [anon_sym___based] = ACTIONS(2970),
    [anon_sym_signed] = ACTIONS(2970),
    [anon_sym_unsigned] = ACTIONS(2970),
    [anon_sym_long] = ACTIONS(2970),
    [anon_sym_short] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_register] = ACTIONS(2970),
    [anon_sym_inline] = ACTIONS(2970),
    [anon_sym___inline] = ACTIONS(2970),
    [anon_sym___inline__] = ACTIONS(2970),
    [anon_sym___forceinline] = ACTIONS(2970),
    [anon_sym_thread_local] = ACTIONS(2970),
    [anon_sym___thread] = ACTIONS(2970),
    [anon_sym_const] = ACTIONS(2970),
    [anon_sym_constexpr] = ACTIONS(2970),
    [anon_sym_volatile] = ACTIONS(2970),
    [anon_sym_restrict] = ACTIONS(2970),
    [anon_sym___restrict__] = ACTIONS(2970),
    [anon_sym__Atomic] = ACTIONS(2970),
    [anon_sym__Noreturn] = ACTIONS(2970),
    [anon_sym_noreturn] = ACTIONS(2970),
    [anon_sym_mutable] = ACTIONS(2970),
    [anon_sym_constinit] = ACTIONS(2970),
    [anon_sym_consteval] = ACTIONS(2970),
    [anon_sym_PROGMEM] = ACTIONS(2970),
    [aux_sym_primitive_type_token1] = ACTIONS(2970),
    [anon_sym_byte] = ACTIONS(2970),
    [anon_sym_word] = ACTIONS(2970),
    [anon_sym_enum] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_struct] = ACTIONS(2970),
    [anon_sym_union] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2970),
    [anon_sym_decltype] = ACTIONS(2970),
    [anon_sym_virtual] = ACTIONS(2970),
    [anon_sym_alignas] = ACTIONS(2970),
    [anon_sym_explicit] = ACTIONS(2970),
    [anon_sym_typename] = ACTIONS(2970),
    [anon_sym_template] = ACTIONS(2970),
    [anon_sym_operator] = ACTIONS(2970),
    [anon_sym_friend] = ACTIONS(2970),
    [anon_sym_public] = ACTIONS(2970),
    [anon_sym_private] = ACTIONS(2970),
    [anon_sym_protected] = ACTIONS(2970),
    [anon_sym_using] = ACTIONS(2970),
    [anon_sym_static_assert] = ACTIONS(2970),
  },
  [2324] = {
    [sym_identifier] = ACTIONS(5610),
    [aux_sym_preproc_def_token1] = ACTIONS(5610),
    [aux_sym_preproc_if_token1] = ACTIONS(5610),
    [aux_sym_preproc_if_token2] = ACTIONS(5610),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5610),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5610),
    [aux_sym_preproc_else_token1] = ACTIONS(5610),
    [aux_sym_preproc_elif_token1] = ACTIONS(5610),
    [sym_preproc_directive] = ACTIONS(5610),
    [anon_sym_LPAREN2] = ACTIONS(5612),
    [anon_sym_TILDE] = ACTIONS(5612),
    [anon_sym_STAR] = ACTIONS(5612),
    [anon_sym_AMP_AMP] = ACTIONS(5612),
    [anon_sym_AMP] = ACTIONS(5610),
    [anon_sym___extension__] = ACTIONS(5610),
    [anon_sym_typedef] = ACTIONS(5610),
    [anon_sym_extern] = ACTIONS(5610),
    [anon_sym___attribute__] = ACTIONS(5610),
    [anon_sym_COLON_COLON] = ACTIONS(5612),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5612),
    [anon_sym___declspec] = ACTIONS(5610),
    [anon_sym___based] = ACTIONS(5610),
    [anon_sym_signed] = ACTIONS(5610),
    [anon_sym_unsigned] = ACTIONS(5610),
    [anon_sym_long] = ACTIONS(5610),
    [anon_sym_short] = ACTIONS(5610),
    [anon_sym_LBRACK] = ACTIONS(5610),
    [anon_sym_static] = ACTIONS(5610),
    [anon_sym_register] = ACTIONS(5610),
    [anon_sym_inline] = ACTIONS(5610),
    [anon_sym___inline] = ACTIONS(5610),
    [anon_sym___inline__] = ACTIONS(5610),
    [anon_sym___forceinline] = ACTIONS(5610),
    [anon_sym_thread_local] = ACTIONS(5610),
    [anon_sym___thread] = ACTIONS(5610),
    [anon_sym_const] = ACTIONS(5610),
    [anon_sym_constexpr] = ACTIONS(5610),
    [anon_sym_volatile] = ACTIONS(5610),
    [anon_sym_restrict] = ACTIONS(5610),
    [anon_sym___restrict__] = ACTIONS(5610),
    [anon_sym__Atomic] = ACTIONS(5610),
    [anon_sym__Noreturn] = ACTIONS(5610),
    [anon_sym_noreturn] = ACTIONS(5610),
    [anon_sym_mutable] = ACTIONS(5610),
    [anon_sym_constinit] = ACTIONS(5610),
    [anon_sym_consteval] = ACTIONS(5610),
    [anon_sym_PROGMEM] = ACTIONS(5610),
    [aux_sym_primitive_type_token1] = ACTIONS(5610),
    [anon_sym_byte] = ACTIONS(5610),
    [anon_sym_word] = ACTIONS(5610),
    [anon_sym_enum] = ACTIONS(5610),
    [anon_sym_class] = ACTIONS(5610),
    [anon_sym_struct] = ACTIONS(5610),
    [anon_sym_union] = ACTIONS(5610),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5610),
    [anon_sym_decltype] = ACTIONS(5610),
    [anon_sym_virtual] = ACTIONS(5610),
    [anon_sym_alignas] = ACTIONS(5610),
    [anon_sym_explicit] = ACTIONS(5610),
    [anon_sym_typename] = ACTIONS(5610),
    [anon_sym_template] = ACTIONS(5610),
    [anon_sym_operator] = ACTIONS(5610),
    [anon_sym_friend] = ACTIONS(5610),
    [anon_sym_public] = ACTIONS(5610),
    [anon_sym_private] = ACTIONS(5610),
    [anon_sym_protected] = ACTIONS(5610),
    [anon_sym_using] = ACTIONS(5610),
    [anon_sym_static_assert] = ACTIONS(5610),
  },
  [2325] = {
    [sym_identifier] = ACTIONS(5614),
    [aux_sym_preproc_def_token1] = ACTIONS(5614),
    [aux_sym_preproc_if_token1] = ACTIONS(5614),
    [aux_sym_preproc_if_token2] = ACTIONS(5614),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5614),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5614),
    [aux_sym_preproc_else_token1] = ACTIONS(5614),
    [aux_sym_preproc_elif_token1] = ACTIONS(5614),
    [sym_preproc_directive] = ACTIONS(5614),
    [anon_sym_LPAREN2] = ACTIONS(5616),
    [anon_sym_TILDE] = ACTIONS(5616),
    [anon_sym_STAR] = ACTIONS(5616),
    [anon_sym_AMP_AMP] = ACTIONS(5616),
    [anon_sym_AMP] = ACTIONS(5614),
    [anon_sym___extension__] = ACTIONS(5614),
    [anon_sym_typedef] = ACTIONS(5614),
    [anon_sym_extern] = ACTIONS(5614),
    [anon_sym___attribute__] = ACTIONS(5614),
    [anon_sym_COLON_COLON] = ACTIONS(5616),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5616),
    [anon_sym___declspec] = ACTIONS(5614),
    [anon_sym___based] = ACTIONS(5614),
    [anon_sym_signed] = ACTIONS(5614),
    [anon_sym_unsigned] = ACTIONS(5614),
    [anon_sym_long] = ACTIONS(5614),
    [anon_sym_short] = ACTIONS(5614),
    [anon_sym_LBRACK] = ACTIONS(5614),
    [anon_sym_static] = ACTIONS(5614),
    [anon_sym_register] = ACTIONS(5614),
    [anon_sym_inline] = ACTIONS(5614),
    [anon_sym___inline] = ACTIONS(5614),
    [anon_sym___inline__] = ACTIONS(5614),
    [anon_sym___forceinline] = ACTIONS(5614),
    [anon_sym_thread_local] = ACTIONS(5614),
    [anon_sym___thread] = ACTIONS(5614),
    [anon_sym_const] = ACTIONS(5614),
    [anon_sym_constexpr] = ACTIONS(5614),
    [anon_sym_volatile] = ACTIONS(5614),
    [anon_sym_restrict] = ACTIONS(5614),
    [anon_sym___restrict__] = ACTIONS(5614),
    [anon_sym__Atomic] = ACTIONS(5614),
    [anon_sym__Noreturn] = ACTIONS(5614),
    [anon_sym_noreturn] = ACTIONS(5614),
    [anon_sym_mutable] = ACTIONS(5614),
    [anon_sym_constinit] = ACTIONS(5614),
    [anon_sym_consteval] = ACTIONS(5614),
    [anon_sym_PROGMEM] = ACTIONS(5614),
    [aux_sym_primitive_type_token1] = ACTIONS(5614),
    [anon_sym_byte] = ACTIONS(5614),
    [anon_sym_word] = ACTIONS(5614),
    [anon_sym_enum] = ACTIONS(5614),
    [anon_sym_class] = ACTIONS(5614),
    [anon_sym_struct] = ACTIONS(5614),
    [anon_sym_union] = ACTIONS(5614),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5614),
    [anon_sym_decltype] = ACTIONS(5614),
    [anon_sym_virtual] = ACTIONS(5614),
    [anon_sym_alignas] = ACTIONS(5614),
    [anon_sym_explicit] = ACTIONS(5614),
    [anon_sym_typename] = ACTIONS(5614),
    [anon_sym_template] = ACTIONS(5614),
    [anon_sym_operator] = ACTIONS(5614),
    [anon_sym_friend] = ACTIONS(5614),
    [anon_sym_public] = ACTIONS(5614),
    [anon_sym_private] = ACTIONS(5614),
    [anon_sym_protected] = ACTIONS(5614),
    [anon_sym_using] = ACTIONS(5614),
    [anon_sym_static_assert] = ACTIONS(5614),
  },
  [2326] = {
    [sym_identifier] = ACTIONS(5614),
    [aux_sym_preproc_def_token1] = ACTIONS(5614),
    [aux_sym_preproc_if_token1] = ACTIONS(5614),
    [aux_sym_preproc_if_token2] = ACTIONS(5614),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5614),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5614),
    [aux_sym_preproc_else_token1] = ACTIONS(5614),
    [aux_sym_preproc_elif_token1] = ACTIONS(5614),
    [sym_preproc_directive] = ACTIONS(5614),
    [anon_sym_LPAREN2] = ACTIONS(5616),
    [anon_sym_TILDE] = ACTIONS(5616),
    [anon_sym_STAR] = ACTIONS(5616),
    [anon_sym_AMP_AMP] = ACTIONS(5616),
    [anon_sym_AMP] = ACTIONS(5614),
    [anon_sym___extension__] = ACTIONS(5614),
    [anon_sym_typedef] = ACTIONS(5614),
    [anon_sym_extern] = ACTIONS(5614),
    [anon_sym___attribute__] = ACTIONS(5614),
    [anon_sym_COLON_COLON] = ACTIONS(5616),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5616),
    [anon_sym___declspec] = ACTIONS(5614),
    [anon_sym___based] = ACTIONS(5614),
    [anon_sym_signed] = ACTIONS(5614),
    [anon_sym_unsigned] = ACTIONS(5614),
    [anon_sym_long] = ACTIONS(5614),
    [anon_sym_short] = ACTIONS(5614),
    [anon_sym_LBRACK] = ACTIONS(5614),
    [anon_sym_static] = ACTIONS(5614),
    [anon_sym_register] = ACTIONS(5614),
    [anon_sym_inline] = ACTIONS(5614),
    [anon_sym___inline] = ACTIONS(5614),
    [anon_sym___inline__] = ACTIONS(5614),
    [anon_sym___forceinline] = ACTIONS(5614),
    [anon_sym_thread_local] = ACTIONS(5614),
    [anon_sym___thread] = ACTIONS(5614),
    [anon_sym_const] = ACTIONS(5614),
    [anon_sym_constexpr] = ACTIONS(5614),
    [anon_sym_volatile] = ACTIONS(5614),
    [anon_sym_restrict] = ACTIONS(5614),
    [anon_sym___restrict__] = ACTIONS(5614),
    [anon_sym__Atomic] = ACTIONS(5614),
    [anon_sym__Noreturn] = ACTIONS(5614),
    [anon_sym_noreturn] = ACTIONS(5614),
    [anon_sym_mutable] = ACTIONS(5614),
    [anon_sym_constinit] = ACTIONS(5614),
    [anon_sym_consteval] = ACTIONS(5614),
    [anon_sym_PROGMEM] = ACTIONS(5614),
    [aux_sym_primitive_type_token1] = ACTIONS(5614),
    [anon_sym_byte] = ACTIONS(5614),
    [anon_sym_word] = ACTIONS(5614),
    [anon_sym_enum] = ACTIONS(5614),
    [anon_sym_class] = ACTIONS(5614),
    [anon_sym_struct] = ACTIONS(5614),
    [anon_sym_union] = ACTIONS(5614),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5614),
    [anon_sym_decltype] = ACTIONS(5614),
    [anon_sym_virtual] = ACTIONS(5614),
    [anon_sym_alignas] = ACTIONS(5614),
    [anon_sym_explicit] = ACTIONS(5614),
    [anon_sym_typename] = ACTIONS(5614),
    [anon_sym_template] = ACTIONS(5614),
    [anon_sym_operator] = ACTIONS(5614),
    [anon_sym_friend] = ACTIONS(5614),
    [anon_sym_public] = ACTIONS(5614),
    [anon_sym_private] = ACTIONS(5614),
    [anon_sym_protected] = ACTIONS(5614),
    [anon_sym_using] = ACTIONS(5614),
    [anon_sym_static_assert] = ACTIONS(5614),
  },
  [2327] = {
    [sym_identifier] = ACTIONS(2223),
    [aux_sym_preproc_def_token1] = ACTIONS(2223),
    [aux_sym_preproc_if_token1] = ACTIONS(2223),
    [aux_sym_preproc_if_token2] = ACTIONS(2223),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2223),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2223),
    [sym_preproc_directive] = ACTIONS(2223),
    [anon_sym_LPAREN2] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2221),
    [anon_sym_AMP_AMP] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym___extension__] = ACTIONS(2223),
    [anon_sym_typedef] = ACTIONS(2223),
    [anon_sym_extern] = ACTIONS(2223),
    [anon_sym___attribute__] = ACTIONS(2223),
    [anon_sym_COLON_COLON] = ACTIONS(2221),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym___declspec] = ACTIONS(2223),
    [anon_sym___based] = ACTIONS(2223),
    [anon_sym_signed] = ACTIONS(2223),
    [anon_sym_unsigned] = ACTIONS(2223),
    [anon_sym_long] = ACTIONS(2223),
    [anon_sym_short] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(2223),
    [anon_sym_static] = ACTIONS(2223),
    [anon_sym_register] = ACTIONS(2223),
    [anon_sym_inline] = ACTIONS(2223),
    [anon_sym___inline] = ACTIONS(2223),
    [anon_sym___inline__] = ACTIONS(2223),
    [anon_sym___forceinline] = ACTIONS(2223),
    [anon_sym_thread_local] = ACTIONS(2223),
    [anon_sym___thread] = ACTIONS(2223),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_constexpr] = ACTIONS(2223),
    [anon_sym_volatile] = ACTIONS(2223),
    [anon_sym_restrict] = ACTIONS(2223),
    [anon_sym___restrict__] = ACTIONS(2223),
    [anon_sym__Atomic] = ACTIONS(2223),
    [anon_sym__Noreturn] = ACTIONS(2223),
    [anon_sym_noreturn] = ACTIONS(2223),
    [anon_sym_mutable] = ACTIONS(2223),
    [anon_sym_constinit] = ACTIONS(2223),
    [anon_sym_consteval] = ACTIONS(2223),
    [anon_sym_PROGMEM] = ACTIONS(2223),
    [aux_sym_primitive_type_token1] = ACTIONS(2223),
    [anon_sym_byte] = ACTIONS(2223),
    [anon_sym_word] = ACTIONS(2223),
    [anon_sym_enum] = ACTIONS(2223),
    [anon_sym_class] = ACTIONS(2223),
    [anon_sym_struct] = ACTIONS(2223),
    [anon_sym_union] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2223),
    [anon_sym_decltype] = ACTIONS(2223),
    [anon_sym_virtual] = ACTIONS(2223),
    [anon_sym_alignas] = ACTIONS(2223),
    [anon_sym_explicit] = ACTIONS(2223),
    [anon_sym_typename] = ACTIONS(2223),
    [anon_sym_template] = ACTIONS(2223),
    [anon_sym_operator] = ACTIONS(2223),
    [anon_sym_friend] = ACTIONS(2223),
    [anon_sym_public] = ACTIONS(2223),
    [anon_sym_private] = ACTIONS(2223),
    [anon_sym_protected] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_static_assert] = ACTIONS(2223),
    [anon_sym_catch] = ACTIONS(2223),
  },
  [2328] = {
    [sym_identifier] = ACTIONS(3503),
    [aux_sym_preproc_def_token1] = ACTIONS(3503),
    [aux_sym_preproc_if_token1] = ACTIONS(3503),
    [aux_sym_preproc_if_token2] = ACTIONS(3503),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3503),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3503),
    [aux_sym_preproc_else_token1] = ACTIONS(3503),
    [aux_sym_preproc_elif_token1] = ACTIONS(3503),
    [sym_preproc_directive] = ACTIONS(3503),
    [anon_sym_LPAREN2] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP] = ACTIONS(3503),
    [anon_sym___extension__] = ACTIONS(3503),
    [anon_sym_typedef] = ACTIONS(3503),
    [anon_sym_extern] = ACTIONS(3503),
    [anon_sym___attribute__] = ACTIONS(3503),
    [anon_sym_COLON_COLON] = ACTIONS(3505),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3505),
    [anon_sym___declspec] = ACTIONS(3503),
    [anon_sym___based] = ACTIONS(3503),
    [anon_sym_signed] = ACTIONS(3503),
    [anon_sym_unsigned] = ACTIONS(3503),
    [anon_sym_long] = ACTIONS(3503),
    [anon_sym_short] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3503),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_register] = ACTIONS(3503),
    [anon_sym_inline] = ACTIONS(3503),
    [anon_sym___inline] = ACTIONS(3503),
    [anon_sym___inline__] = ACTIONS(3503),
    [anon_sym___forceinline] = ACTIONS(3503),
    [anon_sym_thread_local] = ACTIONS(3503),
    [anon_sym___thread] = ACTIONS(3503),
    [anon_sym_const] = ACTIONS(3503),
    [anon_sym_constexpr] = ACTIONS(3503),
    [anon_sym_volatile] = ACTIONS(3503),
    [anon_sym_restrict] = ACTIONS(3503),
    [anon_sym___restrict__] = ACTIONS(3503),
    [anon_sym__Atomic] = ACTIONS(3503),
    [anon_sym__Noreturn] = ACTIONS(3503),
    [anon_sym_noreturn] = ACTIONS(3503),
    [anon_sym_mutable] = ACTIONS(3503),
    [anon_sym_constinit] = ACTIONS(3503),
    [anon_sym_consteval] = ACTIONS(3503),
    [anon_sym_PROGMEM] = ACTIONS(3503),
    [aux_sym_primitive_type_token1] = ACTIONS(3503),
    [anon_sym_byte] = ACTIONS(3503),
    [anon_sym_word] = ACTIONS(3503),
    [anon_sym_enum] = ACTIONS(3503),
    [anon_sym_class] = ACTIONS(3503),
    [anon_sym_struct] = ACTIONS(3503),
    [anon_sym_union] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3503),
    [anon_sym_decltype] = ACTIONS(3503),
    [anon_sym_virtual] = ACTIONS(3503),
    [anon_sym_alignas] = ACTIONS(3503),
    [anon_sym_explicit] = ACTIONS(3503),
    [anon_sym_typename] = ACTIONS(3503),
    [anon_sym_template] = ACTIONS(3503),
    [anon_sym_operator] = ACTIONS(3503),
    [anon_sym_friend] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_using] = ACTIONS(3503),
    [anon_sym_static_assert] = ACTIONS(3503),
  },
  [2329] = {
    [sym_identifier] = ACTIONS(3509),
    [aux_sym_preproc_def_token1] = ACTIONS(3509),
    [aux_sym_preproc_if_token1] = ACTIONS(3509),
    [aux_sym_preproc_if_token2] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3509),
    [aux_sym_preproc_else_token1] = ACTIONS(3509),
    [aux_sym_preproc_elif_token1] = ACTIONS(3509),
    [sym_preproc_directive] = ACTIONS(3509),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3511),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym___extension__] = ACTIONS(3509),
    [anon_sym_typedef] = ACTIONS(3509),
    [anon_sym_extern] = ACTIONS(3509),
    [anon_sym___attribute__] = ACTIONS(3509),
    [anon_sym_COLON_COLON] = ACTIONS(3511),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3511),
    [anon_sym___declspec] = ACTIONS(3509),
    [anon_sym___based] = ACTIONS(3509),
    [anon_sym_signed] = ACTIONS(3509),
    [anon_sym_unsigned] = ACTIONS(3509),
    [anon_sym_long] = ACTIONS(3509),
    [anon_sym_short] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(3509),
    [anon_sym_static] = ACTIONS(3509),
    [anon_sym_register] = ACTIONS(3509),
    [anon_sym_inline] = ACTIONS(3509),
    [anon_sym___inline] = ACTIONS(3509),
    [anon_sym___inline__] = ACTIONS(3509),
    [anon_sym___forceinline] = ACTIONS(3509),
    [anon_sym_thread_local] = ACTIONS(3509),
    [anon_sym___thread] = ACTIONS(3509),
    [anon_sym_const] = ACTIONS(3509),
    [anon_sym_constexpr] = ACTIONS(3509),
    [anon_sym_volatile] = ACTIONS(3509),
    [anon_sym_restrict] = ACTIONS(3509),
    [anon_sym___restrict__] = ACTIONS(3509),
    [anon_sym__Atomic] = ACTIONS(3509),
    [anon_sym__Noreturn] = ACTIONS(3509),
    [anon_sym_noreturn] = ACTIONS(3509),
    [anon_sym_mutable] = ACTIONS(3509),
    [anon_sym_constinit] = ACTIONS(3509),
    [anon_sym_consteval] = ACTIONS(3509),
    [anon_sym_PROGMEM] = ACTIONS(3509),
    [aux_sym_primitive_type_token1] = ACTIONS(3509),
    [anon_sym_byte] = ACTIONS(3509),
    [anon_sym_word] = ACTIONS(3509),
    [anon_sym_enum] = ACTIONS(3509),
    [anon_sym_class] = ACTIONS(3509),
    [anon_sym_struct] = ACTIONS(3509),
    [anon_sym_union] = ACTIONS(3509),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3509),
    [anon_sym_decltype] = ACTIONS(3509),
    [anon_sym_virtual] = ACTIONS(3509),
    [anon_sym_alignas] = ACTIONS(3509),
    [anon_sym_explicit] = ACTIONS(3509),
    [anon_sym_typename] = ACTIONS(3509),
    [anon_sym_template] = ACTIONS(3509),
    [anon_sym_operator] = ACTIONS(3509),
    [anon_sym_friend] = ACTIONS(3509),
    [anon_sym_public] = ACTIONS(3509),
    [anon_sym_private] = ACTIONS(3509),
    [anon_sym_protected] = ACTIONS(3509),
    [anon_sym_using] = ACTIONS(3509),
    [anon_sym_static_assert] = ACTIONS(3509),
  },
  [2330] = {
    [sym_identifier] = ACTIONS(5618),
    [aux_sym_preproc_def_token1] = ACTIONS(5618),
    [aux_sym_preproc_if_token1] = ACTIONS(5618),
    [aux_sym_preproc_if_token2] = ACTIONS(5618),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5618),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5618),
    [aux_sym_preproc_else_token1] = ACTIONS(5618),
    [aux_sym_preproc_elif_token1] = ACTIONS(5618),
    [sym_preproc_directive] = ACTIONS(5618),
    [anon_sym_LPAREN2] = ACTIONS(5620),
    [anon_sym_TILDE] = ACTIONS(5620),
    [anon_sym_STAR] = ACTIONS(5620),
    [anon_sym_AMP_AMP] = ACTIONS(5620),
    [anon_sym_AMP] = ACTIONS(5618),
    [anon_sym___extension__] = ACTIONS(5618),
    [anon_sym_typedef] = ACTIONS(5618),
    [anon_sym_extern] = ACTIONS(5618),
    [anon_sym___attribute__] = ACTIONS(5618),
    [anon_sym_COLON_COLON] = ACTIONS(5620),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5620),
    [anon_sym___declspec] = ACTIONS(5618),
    [anon_sym___based] = ACTIONS(5618),
    [anon_sym_signed] = ACTIONS(5618),
    [anon_sym_unsigned] = ACTIONS(5618),
    [anon_sym_long] = ACTIONS(5618),
    [anon_sym_short] = ACTIONS(5618),
    [anon_sym_LBRACK] = ACTIONS(5618),
    [anon_sym_static] = ACTIONS(5618),
    [anon_sym_register] = ACTIONS(5618),
    [anon_sym_inline] = ACTIONS(5618),
    [anon_sym___inline] = ACTIONS(5618),
    [anon_sym___inline__] = ACTIONS(5618),
    [anon_sym___forceinline] = ACTIONS(5618),
    [anon_sym_thread_local] = ACTIONS(5618),
    [anon_sym___thread] = ACTIONS(5618),
    [anon_sym_const] = ACTIONS(5618),
    [anon_sym_constexpr] = ACTIONS(5618),
    [anon_sym_volatile] = ACTIONS(5618),
    [anon_sym_restrict] = ACTIONS(5618),
    [anon_sym___restrict__] = ACTIONS(5618),
    [anon_sym__Atomic] = ACTIONS(5618),
    [anon_sym__Noreturn] = ACTIONS(5618),
    [anon_sym_noreturn] = ACTIONS(5618),
    [anon_sym_mutable] = ACTIONS(5618),
    [anon_sym_constinit] = ACTIONS(5618),
    [anon_sym_consteval] = ACTIONS(5618),
    [anon_sym_PROGMEM] = ACTIONS(5618),
    [aux_sym_primitive_type_token1] = ACTIONS(5618),
    [anon_sym_byte] = ACTIONS(5618),
    [anon_sym_word] = ACTIONS(5618),
    [anon_sym_enum] = ACTIONS(5618),
    [anon_sym_class] = ACTIONS(5618),
    [anon_sym_struct] = ACTIONS(5618),
    [anon_sym_union] = ACTIONS(5618),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5618),
    [anon_sym_decltype] = ACTIONS(5618),
    [anon_sym_virtual] = ACTIONS(5618),
    [anon_sym_alignas] = ACTIONS(5618),
    [anon_sym_explicit] = ACTIONS(5618),
    [anon_sym_typename] = ACTIONS(5618),
    [anon_sym_template] = ACTIONS(5618),
    [anon_sym_operator] = ACTIONS(5618),
    [anon_sym_friend] = ACTIONS(5618),
    [anon_sym_public] = ACTIONS(5618),
    [anon_sym_private] = ACTIONS(5618),
    [anon_sym_protected] = ACTIONS(5618),
    [anon_sym_using] = ACTIONS(5618),
    [anon_sym_static_assert] = ACTIONS(5618),
  },
  [2331] = {
    [sym_identifier] = ACTIONS(5622),
    [aux_sym_preproc_def_token1] = ACTIONS(5622),
    [aux_sym_preproc_if_token1] = ACTIONS(5622),
    [aux_sym_preproc_if_token2] = ACTIONS(5622),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5622),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5622),
    [aux_sym_preproc_else_token1] = ACTIONS(5622),
    [aux_sym_preproc_elif_token1] = ACTIONS(5622),
    [sym_preproc_directive] = ACTIONS(5622),
    [anon_sym_LPAREN2] = ACTIONS(5624),
    [anon_sym_TILDE] = ACTIONS(5624),
    [anon_sym_STAR] = ACTIONS(5624),
    [anon_sym_AMP_AMP] = ACTIONS(5624),
    [anon_sym_AMP] = ACTIONS(5622),
    [anon_sym___extension__] = ACTIONS(5622),
    [anon_sym_typedef] = ACTIONS(5622),
    [anon_sym_extern] = ACTIONS(5622),
    [anon_sym___attribute__] = ACTIONS(5622),
    [anon_sym_COLON_COLON] = ACTIONS(5624),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5624),
    [anon_sym___declspec] = ACTIONS(5622),
    [anon_sym___based] = ACTIONS(5622),
    [anon_sym_signed] = ACTIONS(5622),
    [anon_sym_unsigned] = ACTIONS(5622),
    [anon_sym_long] = ACTIONS(5622),
    [anon_sym_short] = ACTIONS(5622),
    [anon_sym_LBRACK] = ACTIONS(5622),
    [anon_sym_static] = ACTIONS(5622),
    [anon_sym_register] = ACTIONS(5622),
    [anon_sym_inline] = ACTIONS(5622),
    [anon_sym___inline] = ACTIONS(5622),
    [anon_sym___inline__] = ACTIONS(5622),
    [anon_sym___forceinline] = ACTIONS(5622),
    [anon_sym_thread_local] = ACTIONS(5622),
    [anon_sym___thread] = ACTIONS(5622),
    [anon_sym_const] = ACTIONS(5622),
    [anon_sym_constexpr] = ACTIONS(5622),
    [anon_sym_volatile] = ACTIONS(5622),
    [anon_sym_restrict] = ACTIONS(5622),
    [anon_sym___restrict__] = ACTIONS(5622),
    [anon_sym__Atomic] = ACTIONS(5622),
    [anon_sym__Noreturn] = ACTIONS(5622),
    [anon_sym_noreturn] = ACTIONS(5622),
    [anon_sym_mutable] = ACTIONS(5622),
    [anon_sym_constinit] = ACTIONS(5622),
    [anon_sym_consteval] = ACTIONS(5622),
    [anon_sym_PROGMEM] = ACTIONS(5622),
    [aux_sym_primitive_type_token1] = ACTIONS(5622),
    [anon_sym_byte] = ACTIONS(5622),
    [anon_sym_word] = ACTIONS(5622),
    [anon_sym_enum] = ACTIONS(5622),
    [anon_sym_class] = ACTIONS(5622),
    [anon_sym_struct] = ACTIONS(5622),
    [anon_sym_union] = ACTIONS(5622),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5622),
    [anon_sym_decltype] = ACTIONS(5622),
    [anon_sym_virtual] = ACTIONS(5622),
    [anon_sym_alignas] = ACTIONS(5622),
    [anon_sym_explicit] = ACTIONS(5622),
    [anon_sym_typename] = ACTIONS(5622),
    [anon_sym_template] = ACTIONS(5622),
    [anon_sym_operator] = ACTIONS(5622),
    [anon_sym_friend] = ACTIONS(5622),
    [anon_sym_public] = ACTIONS(5622),
    [anon_sym_private] = ACTIONS(5622),
    [anon_sym_protected] = ACTIONS(5622),
    [anon_sym_using] = ACTIONS(5622),
    [anon_sym_static_assert] = ACTIONS(5622),
  },
  [2332] = {
    [sym_primitive_type] = STATE(2833),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2453),
    [sym_identifier] = ACTIONS(5803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5489),
    [anon_sym_COMMA] = ACTIONS(5489),
    [anon_sym_RPAREN] = ACTIONS(5489),
    [anon_sym_LPAREN2] = ACTIONS(5489),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_PLUS] = ACTIONS(5491),
    [anon_sym_STAR] = ACTIONS(5491),
    [anon_sym_SLASH] = ACTIONS(5491),
    [anon_sym_PERCENT] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5489),
    [anon_sym_AMP_AMP] = ACTIONS(5489),
    [anon_sym_PIPE] = ACTIONS(5491),
    [anon_sym_CARET] = ACTIONS(5491),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_EQ_EQ] = ACTIONS(5489),
    [anon_sym_BANG_EQ] = ACTIONS(5489),
    [anon_sym_GT] = ACTIONS(5491),
    [anon_sym_GT_EQ] = ACTIONS(5489),
    [anon_sym_LT_EQ] = ACTIONS(5491),
    [anon_sym_LT] = ACTIONS(5491),
    [anon_sym_LT_LT] = ACTIONS(5491),
    [anon_sym_GT_GT] = ACTIONS(5491),
    [anon_sym_SEMI] = ACTIONS(5489),
    [anon_sym___attribute__] = ACTIONS(5491),
    [anon_sym_LBRACE] = ACTIONS(5489),
    [anon_sym_RBRACE] = ACTIONS(5489),
    [anon_sym_signed] = ACTIONS(5805),
    [anon_sym_unsigned] = ACTIONS(5805),
    [anon_sym_long] = ACTIONS(5805),
    [anon_sym_short] = ACTIONS(5805),
    [anon_sym_LBRACK] = ACTIONS(5489),
    [anon_sym_RBRACK] = ACTIONS(5489),
    [anon_sym_EQ] = ACTIONS(5491),
    [aux_sym_primitive_type_token1] = ACTIONS(5807),
    [anon_sym_byte] = ACTIONS(5807),
    [anon_sym_word] = ACTIONS(5807),
    [anon_sym_COLON] = ACTIONS(5489),
    [anon_sym_QMARK] = ACTIONS(5489),
    [anon_sym_STAR_EQ] = ACTIONS(5489),
    [anon_sym_SLASH_EQ] = ACTIONS(5489),
    [anon_sym_PERCENT_EQ] = ACTIONS(5489),
    [anon_sym_PLUS_EQ] = ACTIONS(5489),
    [anon_sym_DASH_EQ] = ACTIONS(5489),
    [anon_sym_LT_LT_EQ] = ACTIONS(5489),
    [anon_sym_GT_GT_EQ] = ACTIONS(5489),
    [anon_sym_AMP_EQ] = ACTIONS(5489),
    [anon_sym_CARET_EQ] = ACTIONS(5489),
    [anon_sym_PIPE_EQ] = ACTIONS(5489),
    [anon_sym_and_eq] = ACTIONS(5491),
    [anon_sym_or_eq] = ACTIONS(5491),
    [anon_sym_xor_eq] = ACTIONS(5491),
    [anon_sym_LT_EQ_GT] = ACTIONS(5489),
    [anon_sym_or] = ACTIONS(5491),
    [anon_sym_and] = ACTIONS(5491),
    [anon_sym_bitor] = ACTIONS(5491),
    [anon_sym_xor] = ACTIONS(5491),
    [anon_sym_bitand] = ACTIONS(5491),
    [anon_sym_not_eq] = ACTIONS(5491),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_DOT] = ACTIONS(5491),
    [anon_sym_DOT_STAR] = ACTIONS(5489),
    [anon_sym_DASH_GT] = ACTIONS(5489),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5491),
    [anon_sym_decltype] = ACTIONS(5491),
  },
  [2333] = {
    [sym_identifier] = ACTIONS(5590),
    [aux_sym_preproc_def_token1] = ACTIONS(5590),
    [aux_sym_preproc_if_token1] = ACTIONS(5590),
    [aux_sym_preproc_if_token2] = ACTIONS(5590),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5590),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5590),
    [aux_sym_preproc_else_token1] = ACTIONS(5590),
    [aux_sym_preproc_elif_token1] = ACTIONS(5590),
    [sym_preproc_directive] = ACTIONS(5590),
    [anon_sym_LPAREN2] = ACTIONS(5592),
    [anon_sym_TILDE] = ACTIONS(5592),
    [anon_sym_STAR] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym___extension__] = ACTIONS(5590),
    [anon_sym_typedef] = ACTIONS(5590),
    [anon_sym_extern] = ACTIONS(5590),
    [anon_sym___attribute__] = ACTIONS(5590),
    [anon_sym_COLON_COLON] = ACTIONS(5592),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5592),
    [anon_sym___declspec] = ACTIONS(5590),
    [anon_sym___based] = ACTIONS(5590),
    [anon_sym_signed] = ACTIONS(5590),
    [anon_sym_unsigned] = ACTIONS(5590),
    [anon_sym_long] = ACTIONS(5590),
    [anon_sym_short] = ACTIONS(5590),
    [anon_sym_LBRACK] = ACTIONS(5590),
    [anon_sym_static] = ACTIONS(5590),
    [anon_sym_register] = ACTIONS(5590),
    [anon_sym_inline] = ACTIONS(5590),
    [anon_sym___inline] = ACTIONS(5590),
    [anon_sym___inline__] = ACTIONS(5590),
    [anon_sym___forceinline] = ACTIONS(5590),
    [anon_sym_thread_local] = ACTIONS(5590),
    [anon_sym___thread] = ACTIONS(5590),
    [anon_sym_const] = ACTIONS(5590),
    [anon_sym_constexpr] = ACTIONS(5590),
    [anon_sym_volatile] = ACTIONS(5590),
    [anon_sym_restrict] = ACTIONS(5590),
    [anon_sym___restrict__] = ACTIONS(5590),
    [anon_sym__Atomic] = ACTIONS(5590),
    [anon_sym__Noreturn] = ACTIONS(5590),
    [anon_sym_noreturn] = ACTIONS(5590),
    [anon_sym_mutable] = ACTIONS(5590),
    [anon_sym_constinit] = ACTIONS(5590),
    [anon_sym_consteval] = ACTIONS(5590),
    [anon_sym_PROGMEM] = ACTIONS(5590),
    [aux_sym_primitive_type_token1] = ACTIONS(5590),
    [anon_sym_byte] = ACTIONS(5590),
    [anon_sym_word] = ACTIONS(5590),
    [anon_sym_enum] = ACTIONS(5590),
    [anon_sym_class] = ACTIONS(5590),
    [anon_sym_struct] = ACTIONS(5590),
    [anon_sym_union] = ACTIONS(5590),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5590),
    [anon_sym_decltype] = ACTIONS(5590),
    [anon_sym_virtual] = ACTIONS(5590),
    [anon_sym_alignas] = ACTIONS(5590),
    [anon_sym_explicit] = ACTIONS(5590),
    [anon_sym_typename] = ACTIONS(5590),
    [anon_sym_template] = ACTIONS(5590),
    [anon_sym_operator] = ACTIONS(5590),
    [anon_sym_friend] = ACTIONS(5590),
    [anon_sym_public] = ACTIONS(5590),
    [anon_sym_private] = ACTIONS(5590),
    [anon_sym_protected] = ACTIONS(5590),
    [anon_sym_using] = ACTIONS(5590),
    [anon_sym_static_assert] = ACTIONS(5590),
  },
  [2334] = {
    [sym_identifier] = ACTIONS(5586),
    [aux_sym_preproc_def_token1] = ACTIONS(5586),
    [aux_sym_preproc_if_token1] = ACTIONS(5586),
    [aux_sym_preproc_if_token2] = ACTIONS(5586),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5586),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5586),
    [aux_sym_preproc_else_token1] = ACTIONS(5586),
    [aux_sym_preproc_elif_token1] = ACTIONS(5586),
    [sym_preproc_directive] = ACTIONS(5586),
    [anon_sym_LPAREN2] = ACTIONS(5588),
    [anon_sym_TILDE] = ACTIONS(5588),
    [anon_sym_STAR] = ACTIONS(5588),
    [anon_sym_AMP_AMP] = ACTIONS(5588),
    [anon_sym_AMP] = ACTIONS(5586),
    [anon_sym___extension__] = ACTIONS(5586),
    [anon_sym_typedef] = ACTIONS(5586),
    [anon_sym_extern] = ACTIONS(5586),
    [anon_sym___attribute__] = ACTIONS(5586),
    [anon_sym_COLON_COLON] = ACTIONS(5588),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5588),
    [anon_sym___declspec] = ACTIONS(5586),
    [anon_sym___based] = ACTIONS(5586),
    [anon_sym_signed] = ACTIONS(5586),
    [anon_sym_unsigned] = ACTIONS(5586),
    [anon_sym_long] = ACTIONS(5586),
    [anon_sym_short] = ACTIONS(5586),
    [anon_sym_LBRACK] = ACTIONS(5586),
    [anon_sym_static] = ACTIONS(5586),
    [anon_sym_register] = ACTIONS(5586),
    [anon_sym_inline] = ACTIONS(5586),
    [anon_sym___inline] = ACTIONS(5586),
    [anon_sym___inline__] = ACTIONS(5586),
    [anon_sym___forceinline] = ACTIONS(5586),
    [anon_sym_thread_local] = ACTIONS(5586),
    [anon_sym___thread] = ACTIONS(5586),
    [anon_sym_const] = ACTIONS(5586),
    [anon_sym_constexpr] = ACTIONS(5586),
    [anon_sym_volatile] = ACTIONS(5586),
    [anon_sym_restrict] = ACTIONS(5586),
    [anon_sym___restrict__] = ACTIONS(5586),
    [anon_sym__Atomic] = ACTIONS(5586),
    [anon_sym__Noreturn] = ACTIONS(5586),
    [anon_sym_noreturn] = ACTIONS(5586),
    [anon_sym_mutable] = ACTIONS(5586),
    [anon_sym_constinit] = ACTIONS(5586),
    [anon_sym_consteval] = ACTIONS(5586),
    [anon_sym_PROGMEM] = ACTIONS(5586),
    [aux_sym_primitive_type_token1] = ACTIONS(5586),
    [anon_sym_byte] = ACTIONS(5586),
    [anon_sym_word] = ACTIONS(5586),
    [anon_sym_enum] = ACTIONS(5586),
    [anon_sym_class] = ACTIONS(5586),
    [anon_sym_struct] = ACTIONS(5586),
    [anon_sym_union] = ACTIONS(5586),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5586),
    [anon_sym_decltype] = ACTIONS(5586),
    [anon_sym_virtual] = ACTIONS(5586),
    [anon_sym_alignas] = ACTIONS(5586),
    [anon_sym_explicit] = ACTIONS(5586),
    [anon_sym_typename] = ACTIONS(5586),
    [anon_sym_template] = ACTIONS(5586),
    [anon_sym_operator] = ACTIONS(5586),
    [anon_sym_friend] = ACTIONS(5586),
    [anon_sym_public] = ACTIONS(5586),
    [anon_sym_private] = ACTIONS(5586),
    [anon_sym_protected] = ACTIONS(5586),
    [anon_sym_using] = ACTIONS(5586),
    [anon_sym_static_assert] = ACTIONS(5586),
  },
  [2335] = {
    [sym_identifier] = ACTIONS(3301),
    [aux_sym_preproc_def_token1] = ACTIONS(3301),
    [aux_sym_preproc_if_token1] = ACTIONS(3301),
    [aux_sym_preproc_if_token2] = ACTIONS(3301),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3301),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3301),
    [aux_sym_preproc_else_token1] = ACTIONS(3301),
    [aux_sym_preproc_elif_token1] = ACTIONS(3301),
    [sym_preproc_directive] = ACTIONS(3301),
    [anon_sym_LPAREN2] = ACTIONS(3303),
    [anon_sym_TILDE] = ACTIONS(3303),
    [anon_sym_STAR] = ACTIONS(3303),
    [anon_sym_AMP_AMP] = ACTIONS(3303),
    [anon_sym_AMP] = ACTIONS(3301),
    [anon_sym___extension__] = ACTIONS(3301),
    [anon_sym_typedef] = ACTIONS(3301),
    [anon_sym_extern] = ACTIONS(3301),
    [anon_sym___attribute__] = ACTIONS(3301),
    [anon_sym_COLON_COLON] = ACTIONS(3303),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3303),
    [anon_sym___declspec] = ACTIONS(3301),
    [anon_sym___based] = ACTIONS(3301),
    [anon_sym_signed] = ACTIONS(3301),
    [anon_sym_unsigned] = ACTIONS(3301),
    [anon_sym_long] = ACTIONS(3301),
    [anon_sym_short] = ACTIONS(3301),
    [anon_sym_LBRACK] = ACTIONS(3301),
    [anon_sym_static] = ACTIONS(3301),
    [anon_sym_register] = ACTIONS(3301),
    [anon_sym_inline] = ACTIONS(3301),
    [anon_sym___inline] = ACTIONS(3301),
    [anon_sym___inline__] = ACTIONS(3301),
    [anon_sym___forceinline] = ACTIONS(3301),
    [anon_sym_thread_local] = ACTIONS(3301),
    [anon_sym___thread] = ACTIONS(3301),
    [anon_sym_const] = ACTIONS(3301),
    [anon_sym_constexpr] = ACTIONS(3301),
    [anon_sym_volatile] = ACTIONS(3301),
    [anon_sym_restrict] = ACTIONS(3301),
    [anon_sym___restrict__] = ACTIONS(3301),
    [anon_sym__Atomic] = ACTIONS(3301),
    [anon_sym__Noreturn] = ACTIONS(3301),
    [anon_sym_noreturn] = ACTIONS(3301),
    [anon_sym_mutable] = ACTIONS(3301),
    [anon_sym_constinit] = ACTIONS(3301),
    [anon_sym_consteval] = ACTIONS(3301),
    [anon_sym_PROGMEM] = ACTIONS(3301),
    [aux_sym_primitive_type_token1] = ACTIONS(3301),
    [anon_sym_byte] = ACTIONS(3301),
    [anon_sym_word] = ACTIONS(3301),
    [anon_sym_enum] = ACTIONS(3301),
    [anon_sym_class] = ACTIONS(3301),
    [anon_sym_struct] = ACTIONS(3301),
    [anon_sym_union] = ACTIONS(3301),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3301),
    [anon_sym_decltype] = ACTIONS(3301),
    [anon_sym_virtual] = ACTIONS(3301),
    [anon_sym_alignas] = ACTIONS(3301),
    [anon_sym_explicit] = ACTIONS(3301),
    [anon_sym_typename] = ACTIONS(3301),
    [anon_sym_template] = ACTIONS(3301),
    [anon_sym_operator] = ACTIONS(3301),
    [anon_sym_friend] = ACTIONS(3301),
    [anon_sym_public] = ACTIONS(3301),
    [anon_sym_private] = ACTIONS(3301),
    [anon_sym_protected] = ACTIONS(3301),
    [anon_sym_using] = ACTIONS(3301),
    [anon_sym_static_assert] = ACTIONS(3301),
  },
  [2336] = {
    [sym_identifier] = ACTIONS(3128),
    [aux_sym_preproc_def_token1] = ACTIONS(3128),
    [aux_sym_preproc_if_token1] = ACTIONS(3128),
    [aux_sym_preproc_if_token2] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3128),
    [aux_sym_preproc_else_token1] = ACTIONS(3128),
    [aux_sym_preproc_elif_token1] = ACTIONS(3128),
    [sym_preproc_directive] = ACTIONS(3128),
    [anon_sym_LPAREN2] = ACTIONS(3130),
    [anon_sym_TILDE] = ACTIONS(3130),
    [anon_sym_STAR] = ACTIONS(3130),
    [anon_sym_AMP_AMP] = ACTIONS(3130),
    [anon_sym_AMP] = ACTIONS(3128),
    [anon_sym___extension__] = ACTIONS(3128),
    [anon_sym_typedef] = ACTIONS(3128),
    [anon_sym_extern] = ACTIONS(3128),
    [anon_sym___attribute__] = ACTIONS(3128),
    [anon_sym_COLON_COLON] = ACTIONS(3130),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3130),
    [anon_sym___declspec] = ACTIONS(3128),
    [anon_sym___based] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3128),
    [anon_sym_unsigned] = ACTIONS(3128),
    [anon_sym_long] = ACTIONS(3128),
    [anon_sym_short] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3128),
    [anon_sym_static] = ACTIONS(3128),
    [anon_sym_register] = ACTIONS(3128),
    [anon_sym_inline] = ACTIONS(3128),
    [anon_sym___inline] = ACTIONS(3128),
    [anon_sym___inline__] = ACTIONS(3128),
    [anon_sym___forceinline] = ACTIONS(3128),
    [anon_sym_thread_local] = ACTIONS(3128),
    [anon_sym___thread] = ACTIONS(3128),
    [anon_sym_const] = ACTIONS(3128),
    [anon_sym_constexpr] = ACTIONS(3128),
    [anon_sym_volatile] = ACTIONS(3128),
    [anon_sym_restrict] = ACTIONS(3128),
    [anon_sym___restrict__] = ACTIONS(3128),
    [anon_sym__Atomic] = ACTIONS(3128),
    [anon_sym__Noreturn] = ACTIONS(3128),
    [anon_sym_noreturn] = ACTIONS(3128),
    [anon_sym_mutable] = ACTIONS(3128),
    [anon_sym_constinit] = ACTIONS(3128),
    [anon_sym_consteval] = ACTIONS(3128),
    [anon_sym_PROGMEM] = ACTIONS(3128),
    [aux_sym_primitive_type_token1] = ACTIONS(3128),
    [anon_sym_byte] = ACTIONS(3128),
    [anon_sym_word] = ACTIONS(3128),
    [anon_sym_enum] = ACTIONS(3128),
    [anon_sym_class] = ACTIONS(3128),
    [anon_sym_struct] = ACTIONS(3128),
    [anon_sym_union] = ACTIONS(3128),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3128),
    [anon_sym_decltype] = ACTIONS(3128),
    [anon_sym_virtual] = ACTIONS(3128),
    [anon_sym_alignas] = ACTIONS(3128),
    [anon_sym_explicit] = ACTIONS(3128),
    [anon_sym_typename] = ACTIONS(3128),
    [anon_sym_template] = ACTIONS(3128),
    [anon_sym_operator] = ACTIONS(3128),
    [anon_sym_friend] = ACTIONS(3128),
    [anon_sym_public] = ACTIONS(3128),
    [anon_sym_private] = ACTIONS(3128),
    [anon_sym_protected] = ACTIONS(3128),
    [anon_sym_using] = ACTIONS(3128),
    [anon_sym_static_assert] = ACTIONS(3128),
  },
  [2337] = {
    [sym_identifier] = ACTIONS(2970),
    [aux_sym_preproc_def_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token2] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2970),
    [aux_sym_preproc_else_token1] = ACTIONS(2970),
    [aux_sym_preproc_elif_token1] = ACTIONS(2970),
    [sym_preproc_directive] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym___extension__] = ACTIONS(2970),
    [anon_sym_typedef] = ACTIONS(2970),
    [anon_sym_extern] = ACTIONS(2970),
    [anon_sym___attribute__] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2970),
    [anon_sym___based] = ACTIONS(2970),
    [anon_sym_signed] = ACTIONS(2970),
    [anon_sym_unsigned] = ACTIONS(2970),
    [anon_sym_long] = ACTIONS(2970),
    [anon_sym_short] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_register] = ACTIONS(2970),
    [anon_sym_inline] = ACTIONS(2970),
    [anon_sym___inline] = ACTIONS(2970),
    [anon_sym___inline__] = ACTIONS(2970),
    [anon_sym___forceinline] = ACTIONS(2970),
    [anon_sym_thread_local] = ACTIONS(2970),
    [anon_sym___thread] = ACTIONS(2970),
    [anon_sym_const] = ACTIONS(2970),
    [anon_sym_constexpr] = ACTIONS(2970),
    [anon_sym_volatile] = ACTIONS(2970),
    [anon_sym_restrict] = ACTIONS(2970),
    [anon_sym___restrict__] = ACTIONS(2970),
    [anon_sym__Atomic] = ACTIONS(2970),
    [anon_sym__Noreturn] = ACTIONS(2970),
    [anon_sym_noreturn] = ACTIONS(2970),
    [anon_sym_mutable] = ACTIONS(2970),
    [anon_sym_constinit] = ACTIONS(2970),
    [anon_sym_consteval] = ACTIONS(2970),
    [anon_sym_PROGMEM] = ACTIONS(2970),
    [aux_sym_primitive_type_token1] = ACTIONS(2970),
    [anon_sym_byte] = ACTIONS(2970),
    [anon_sym_word] = ACTIONS(2970),
    [anon_sym_enum] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_struct] = ACTIONS(2970),
    [anon_sym_union] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2970),
    [anon_sym_decltype] = ACTIONS(2970),
    [anon_sym_virtual] = ACTIONS(2970),
    [anon_sym_alignas] = ACTIONS(2970),
    [anon_sym_explicit] = ACTIONS(2970),
    [anon_sym_typename] = ACTIONS(2970),
    [anon_sym_template] = ACTIONS(2970),
    [anon_sym_operator] = ACTIONS(2970),
    [anon_sym_friend] = ACTIONS(2970),
    [anon_sym_public] = ACTIONS(2970),
    [anon_sym_private] = ACTIONS(2970),
    [anon_sym_protected] = ACTIONS(2970),
    [anon_sym_using] = ACTIONS(2970),
    [anon_sym_static_assert] = ACTIONS(2970),
  },
  [2338] = {
    [sym_identifier] = ACTIONS(4031),
    [aux_sym_preproc_def_token1] = ACTIONS(4031),
    [aux_sym_preproc_if_token1] = ACTIONS(4031),
    [aux_sym_preproc_if_token2] = ACTIONS(4031),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4031),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4031),
    [aux_sym_preproc_else_token1] = ACTIONS(4031),
    [aux_sym_preproc_elif_token1] = ACTIONS(4031),
    [sym_preproc_directive] = ACTIONS(4031),
    [anon_sym_LPAREN2] = ACTIONS(4029),
    [anon_sym_TILDE] = ACTIONS(4029),
    [anon_sym_STAR] = ACTIONS(4029),
    [anon_sym_AMP_AMP] = ACTIONS(4029),
    [anon_sym_AMP] = ACTIONS(4031),
    [anon_sym___extension__] = ACTIONS(4031),
    [anon_sym_typedef] = ACTIONS(4031),
    [anon_sym_extern] = ACTIONS(4031),
    [anon_sym___attribute__] = ACTIONS(4031),
    [anon_sym_COLON_COLON] = ACTIONS(4029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4029),
    [anon_sym___declspec] = ACTIONS(4031),
    [anon_sym___based] = ACTIONS(4031),
    [anon_sym_signed] = ACTIONS(4031),
    [anon_sym_unsigned] = ACTIONS(4031),
    [anon_sym_long] = ACTIONS(4031),
    [anon_sym_short] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4031),
    [anon_sym_static] = ACTIONS(4031),
    [anon_sym_register] = ACTIONS(4031),
    [anon_sym_inline] = ACTIONS(4031),
    [anon_sym___inline] = ACTIONS(4031),
    [anon_sym___inline__] = ACTIONS(4031),
    [anon_sym___forceinline] = ACTIONS(4031),
    [anon_sym_thread_local] = ACTIONS(4031),
    [anon_sym___thread] = ACTIONS(4031),
    [anon_sym_const] = ACTIONS(4031),
    [anon_sym_constexpr] = ACTIONS(4031),
    [anon_sym_volatile] = ACTIONS(4031),
    [anon_sym_restrict] = ACTIONS(4031),
    [anon_sym___restrict__] = ACTIONS(4031),
    [anon_sym__Atomic] = ACTIONS(4031),
    [anon_sym__Noreturn] = ACTIONS(4031),
    [anon_sym_noreturn] = ACTIONS(4031),
    [anon_sym_mutable] = ACTIONS(4031),
    [anon_sym_constinit] = ACTIONS(4031),
    [anon_sym_consteval] = ACTIONS(4031),
    [anon_sym_PROGMEM] = ACTIONS(4031),
    [aux_sym_primitive_type_token1] = ACTIONS(4031),
    [anon_sym_byte] = ACTIONS(4031),
    [anon_sym_word] = ACTIONS(4031),
    [anon_sym_enum] = ACTIONS(4031),
    [anon_sym_class] = ACTIONS(4031),
    [anon_sym_struct] = ACTIONS(4031),
    [anon_sym_union] = ACTIONS(4031),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4031),
    [anon_sym_decltype] = ACTIONS(4031),
    [anon_sym_virtual] = ACTIONS(4031),
    [anon_sym_alignas] = ACTIONS(4031),
    [anon_sym_explicit] = ACTIONS(4031),
    [anon_sym_typename] = ACTIONS(4031),
    [anon_sym_template] = ACTIONS(4031),
    [anon_sym_operator] = ACTIONS(4031),
    [anon_sym_friend] = ACTIONS(4031),
    [anon_sym_public] = ACTIONS(4031),
    [anon_sym_private] = ACTIONS(4031),
    [anon_sym_protected] = ACTIONS(4031),
    [anon_sym_using] = ACTIONS(4031),
    [anon_sym_static_assert] = ACTIONS(4031),
  },
  [2339] = {
    [sym_identifier] = ACTIONS(3336),
    [aux_sym_preproc_def_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token2] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3336),
    [aux_sym_preproc_else_token1] = ACTIONS(3336),
    [aux_sym_preproc_elif_token1] = ACTIONS(3336),
    [sym_preproc_directive] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym___extension__] = ACTIONS(3336),
    [anon_sym_typedef] = ACTIONS(3336),
    [anon_sym_extern] = ACTIONS(3336),
    [anon_sym___attribute__] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3338),
    [anon_sym___declspec] = ACTIONS(3336),
    [anon_sym___based] = ACTIONS(3336),
    [anon_sym_signed] = ACTIONS(3336),
    [anon_sym_unsigned] = ACTIONS(3336),
    [anon_sym_long] = ACTIONS(3336),
    [anon_sym_short] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_static] = ACTIONS(3336),
    [anon_sym_register] = ACTIONS(3336),
    [anon_sym_inline] = ACTIONS(3336),
    [anon_sym___inline] = ACTIONS(3336),
    [anon_sym___inline__] = ACTIONS(3336),
    [anon_sym___forceinline] = ACTIONS(3336),
    [anon_sym_thread_local] = ACTIONS(3336),
    [anon_sym___thread] = ACTIONS(3336),
    [anon_sym_const] = ACTIONS(3336),
    [anon_sym_constexpr] = ACTIONS(3336),
    [anon_sym_volatile] = ACTIONS(3336),
    [anon_sym_restrict] = ACTIONS(3336),
    [anon_sym___restrict__] = ACTIONS(3336),
    [anon_sym__Atomic] = ACTIONS(3336),
    [anon_sym__Noreturn] = ACTIONS(3336),
    [anon_sym_noreturn] = ACTIONS(3336),
    [anon_sym_mutable] = ACTIONS(3336),
    [anon_sym_constinit] = ACTIONS(3336),
    [anon_sym_consteval] = ACTIONS(3336),
    [anon_sym_PROGMEM] = ACTIONS(3336),
    [aux_sym_primitive_type_token1] = ACTIONS(3336),
    [anon_sym_byte] = ACTIONS(3336),
    [anon_sym_word] = ACTIONS(3336),
    [anon_sym_enum] = ACTIONS(3336),
    [anon_sym_class] = ACTIONS(3336),
    [anon_sym_struct] = ACTIONS(3336),
    [anon_sym_union] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3336),
    [anon_sym_decltype] = ACTIONS(3336),
    [anon_sym_virtual] = ACTIONS(3336),
    [anon_sym_alignas] = ACTIONS(3336),
    [anon_sym_explicit] = ACTIONS(3336),
    [anon_sym_typename] = ACTIONS(3336),
    [anon_sym_template] = ACTIONS(3336),
    [anon_sym_operator] = ACTIONS(3336),
    [anon_sym_friend] = ACTIONS(3336),
    [anon_sym_public] = ACTIONS(3336),
    [anon_sym_private] = ACTIONS(3336),
    [anon_sym_protected] = ACTIONS(3336),
    [anon_sym_using] = ACTIONS(3336),
    [anon_sym_static_assert] = ACTIONS(3336),
  },
  [2340] = {
    [sym_identifier] = ACTIONS(3144),
    [aux_sym_preproc_def_token1] = ACTIONS(3144),
    [aux_sym_preproc_if_token1] = ACTIONS(3144),
    [aux_sym_preproc_if_token2] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3144),
    [aux_sym_preproc_else_token1] = ACTIONS(3144),
    [aux_sym_preproc_elif_token1] = ACTIONS(3144),
    [sym_preproc_directive] = ACTIONS(3144),
    [anon_sym_LPAREN2] = ACTIONS(3146),
    [anon_sym_TILDE] = ACTIONS(3146),
    [anon_sym_STAR] = ACTIONS(3146),
    [anon_sym_AMP_AMP] = ACTIONS(3146),
    [anon_sym_AMP] = ACTIONS(3144),
    [anon_sym___extension__] = ACTIONS(3144),
    [anon_sym_typedef] = ACTIONS(3144),
    [anon_sym_extern] = ACTIONS(3144),
    [anon_sym___attribute__] = ACTIONS(3144),
    [anon_sym_COLON_COLON] = ACTIONS(3146),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3146),
    [anon_sym___declspec] = ACTIONS(3144),
    [anon_sym___based] = ACTIONS(3144),
    [anon_sym_signed] = ACTIONS(3144),
    [anon_sym_unsigned] = ACTIONS(3144),
    [anon_sym_long] = ACTIONS(3144),
    [anon_sym_short] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3144),
    [anon_sym_static] = ACTIONS(3144),
    [anon_sym_register] = ACTIONS(3144),
    [anon_sym_inline] = ACTIONS(3144),
    [anon_sym___inline] = ACTIONS(3144),
    [anon_sym___inline__] = ACTIONS(3144),
    [anon_sym___forceinline] = ACTIONS(3144),
    [anon_sym_thread_local] = ACTIONS(3144),
    [anon_sym___thread] = ACTIONS(3144),
    [anon_sym_const] = ACTIONS(3144),
    [anon_sym_constexpr] = ACTIONS(3144),
    [anon_sym_volatile] = ACTIONS(3144),
    [anon_sym_restrict] = ACTIONS(3144),
    [anon_sym___restrict__] = ACTIONS(3144),
    [anon_sym__Atomic] = ACTIONS(3144),
    [anon_sym__Noreturn] = ACTIONS(3144),
    [anon_sym_noreturn] = ACTIONS(3144),
    [anon_sym_mutable] = ACTIONS(3144),
    [anon_sym_constinit] = ACTIONS(3144),
    [anon_sym_consteval] = ACTIONS(3144),
    [anon_sym_PROGMEM] = ACTIONS(3144),
    [aux_sym_primitive_type_token1] = ACTIONS(3144),
    [anon_sym_byte] = ACTIONS(3144),
    [anon_sym_word] = ACTIONS(3144),
    [anon_sym_enum] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_struct] = ACTIONS(3144),
    [anon_sym_union] = ACTIONS(3144),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3144),
    [anon_sym_decltype] = ACTIONS(3144),
    [anon_sym_virtual] = ACTIONS(3144),
    [anon_sym_alignas] = ACTIONS(3144),
    [anon_sym_explicit] = ACTIONS(3144),
    [anon_sym_typename] = ACTIONS(3144),
    [anon_sym_template] = ACTIONS(3144),
    [anon_sym_operator] = ACTIONS(3144),
    [anon_sym_friend] = ACTIONS(3144),
    [anon_sym_public] = ACTIONS(3144),
    [anon_sym_private] = ACTIONS(3144),
    [anon_sym_protected] = ACTIONS(3144),
    [anon_sym_using] = ACTIONS(3144),
    [anon_sym_static_assert] = ACTIONS(3144),
  },
  [2341] = {
    [sym_identifier] = ACTIONS(5582),
    [aux_sym_preproc_def_token1] = ACTIONS(5582),
    [aux_sym_preproc_if_token1] = ACTIONS(5582),
    [aux_sym_preproc_if_token2] = ACTIONS(5582),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5582),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5582),
    [aux_sym_preproc_else_token1] = ACTIONS(5582),
    [aux_sym_preproc_elif_token1] = ACTIONS(5582),
    [sym_preproc_directive] = ACTIONS(5582),
    [anon_sym_LPAREN2] = ACTIONS(5584),
    [anon_sym_TILDE] = ACTIONS(5584),
    [anon_sym_STAR] = ACTIONS(5584),
    [anon_sym_AMP_AMP] = ACTIONS(5584),
    [anon_sym_AMP] = ACTIONS(5582),
    [anon_sym___extension__] = ACTIONS(5582),
    [anon_sym_typedef] = ACTIONS(5582),
    [anon_sym_extern] = ACTIONS(5582),
    [anon_sym___attribute__] = ACTIONS(5582),
    [anon_sym_COLON_COLON] = ACTIONS(5584),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5584),
    [anon_sym___declspec] = ACTIONS(5582),
    [anon_sym___based] = ACTIONS(5582),
    [anon_sym_signed] = ACTIONS(5582),
    [anon_sym_unsigned] = ACTIONS(5582),
    [anon_sym_long] = ACTIONS(5582),
    [anon_sym_short] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(5582),
    [anon_sym_static] = ACTIONS(5582),
    [anon_sym_register] = ACTIONS(5582),
    [anon_sym_inline] = ACTIONS(5582),
    [anon_sym___inline] = ACTIONS(5582),
    [anon_sym___inline__] = ACTIONS(5582),
    [anon_sym___forceinline] = ACTIONS(5582),
    [anon_sym_thread_local] = ACTIONS(5582),
    [anon_sym___thread] = ACTIONS(5582),
    [anon_sym_const] = ACTIONS(5582),
    [anon_sym_constexpr] = ACTIONS(5582),
    [anon_sym_volatile] = ACTIONS(5582),
    [anon_sym_restrict] = ACTIONS(5582),
    [anon_sym___restrict__] = ACTIONS(5582),
    [anon_sym__Atomic] = ACTIONS(5582),
    [anon_sym__Noreturn] = ACTIONS(5582),
    [anon_sym_noreturn] = ACTIONS(5582),
    [anon_sym_mutable] = ACTIONS(5582),
    [anon_sym_constinit] = ACTIONS(5582),
    [anon_sym_consteval] = ACTIONS(5582),
    [anon_sym_PROGMEM] = ACTIONS(5582),
    [aux_sym_primitive_type_token1] = ACTIONS(5582),
    [anon_sym_byte] = ACTIONS(5582),
    [anon_sym_word] = ACTIONS(5582),
    [anon_sym_enum] = ACTIONS(5582),
    [anon_sym_class] = ACTIONS(5582),
    [anon_sym_struct] = ACTIONS(5582),
    [anon_sym_union] = ACTIONS(5582),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5582),
    [anon_sym_decltype] = ACTIONS(5582),
    [anon_sym_virtual] = ACTIONS(5582),
    [anon_sym_alignas] = ACTIONS(5582),
    [anon_sym_explicit] = ACTIONS(5582),
    [anon_sym_typename] = ACTIONS(5582),
    [anon_sym_template] = ACTIONS(5582),
    [anon_sym_operator] = ACTIONS(5582),
    [anon_sym_friend] = ACTIONS(5582),
    [anon_sym_public] = ACTIONS(5582),
    [anon_sym_private] = ACTIONS(5582),
    [anon_sym_protected] = ACTIONS(5582),
    [anon_sym_using] = ACTIONS(5582),
    [anon_sym_static_assert] = ACTIONS(5582),
  },
  [2342] = {
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token2] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [aux_sym_preproc_else_token1] = ACTIONS(3513),
    [aux_sym_preproc_elif_token1] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_PROGMEM] = ACTIONS(3513),
    [aux_sym_primitive_type_token1] = ACTIONS(3513),
    [anon_sym_byte] = ACTIONS(3513),
    [anon_sym_word] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [anon_sym_virtual] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_friend] = ACTIONS(3513),
    [anon_sym_public] = ACTIONS(3513),
    [anon_sym_private] = ACTIONS(3513),
    [anon_sym_protected] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
  },
  [2343] = {
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token2] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [aux_sym_preproc_else_token1] = ACTIONS(3513),
    [aux_sym_preproc_elif_token1] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_PROGMEM] = ACTIONS(3513),
    [aux_sym_primitive_type_token1] = ACTIONS(3513),
    [anon_sym_byte] = ACTIONS(3513),
    [anon_sym_word] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [anon_sym_virtual] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_friend] = ACTIONS(3513),
    [anon_sym_public] = ACTIONS(3513),
    [anon_sym_private] = ACTIONS(3513),
    [anon_sym_protected] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
  },
  [2344] = {
    [sym_identifier] = ACTIONS(5578),
    [aux_sym_preproc_def_token1] = ACTIONS(5578),
    [aux_sym_preproc_if_token1] = ACTIONS(5578),
    [aux_sym_preproc_if_token2] = ACTIONS(5578),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5578),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5578),
    [aux_sym_preproc_else_token1] = ACTIONS(5578),
    [aux_sym_preproc_elif_token1] = ACTIONS(5578),
    [sym_preproc_directive] = ACTIONS(5578),
    [anon_sym_LPAREN2] = ACTIONS(5580),
    [anon_sym_TILDE] = ACTIONS(5580),
    [anon_sym_STAR] = ACTIONS(5580),
    [anon_sym_AMP_AMP] = ACTIONS(5580),
    [anon_sym_AMP] = ACTIONS(5578),
    [anon_sym___extension__] = ACTIONS(5578),
    [anon_sym_typedef] = ACTIONS(5578),
    [anon_sym_extern] = ACTIONS(5578),
    [anon_sym___attribute__] = ACTIONS(5578),
    [anon_sym_COLON_COLON] = ACTIONS(5580),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5580),
    [anon_sym___declspec] = ACTIONS(5578),
    [anon_sym___based] = ACTIONS(5578),
    [anon_sym_signed] = ACTIONS(5578),
    [anon_sym_unsigned] = ACTIONS(5578),
    [anon_sym_long] = ACTIONS(5578),
    [anon_sym_short] = ACTIONS(5578),
    [anon_sym_LBRACK] = ACTIONS(5578),
    [anon_sym_static] = ACTIONS(5578),
    [anon_sym_register] = ACTIONS(5578),
    [anon_sym_inline] = ACTIONS(5578),
    [anon_sym___inline] = ACTIONS(5578),
    [anon_sym___inline__] = ACTIONS(5578),
    [anon_sym___forceinline] = ACTIONS(5578),
    [anon_sym_thread_local] = ACTIONS(5578),
    [anon_sym___thread] = ACTIONS(5578),
    [anon_sym_const] = ACTIONS(5578),
    [anon_sym_constexpr] = ACTIONS(5578),
    [anon_sym_volatile] = ACTIONS(5578),
    [anon_sym_restrict] = ACTIONS(5578),
    [anon_sym___restrict__] = ACTIONS(5578),
    [anon_sym__Atomic] = ACTIONS(5578),
    [anon_sym__Noreturn] = ACTIONS(5578),
    [anon_sym_noreturn] = ACTIONS(5578),
    [anon_sym_mutable] = ACTIONS(5578),
    [anon_sym_constinit] = ACTIONS(5578),
    [anon_sym_consteval] = ACTIONS(5578),
    [anon_sym_PROGMEM] = ACTIONS(5578),
    [aux_sym_primitive_type_token1] = ACTIONS(5578),
    [anon_sym_byte] = ACTIONS(5578),
    [anon_sym_word] = ACTIONS(5578),
    [anon_sym_enum] = ACTIONS(5578),
    [anon_sym_class] = ACTIONS(5578),
    [anon_sym_struct] = ACTIONS(5578),
    [anon_sym_union] = ACTIONS(5578),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5578),
    [anon_sym_decltype] = ACTIONS(5578),
    [anon_sym_virtual] = ACTIONS(5578),
    [anon_sym_alignas] = ACTIONS(5578),
    [anon_sym_explicit] = ACTIONS(5578),
    [anon_sym_typename] = ACTIONS(5578),
    [anon_sym_template] = ACTIONS(5578),
    [anon_sym_operator] = ACTIONS(5578),
    [anon_sym_friend] = ACTIONS(5578),
    [anon_sym_public] = ACTIONS(5578),
    [anon_sym_private] = ACTIONS(5578),
    [anon_sym_protected] = ACTIONS(5578),
    [anon_sym_using] = ACTIONS(5578),
    [anon_sym_static_assert] = ACTIONS(5578),
  },
  [2345] = {
    [sym_argument_list] = STATE(2909),
    [sym_initializer_list] = STATE(2909),
    [sym_decltype_auto] = STATE(2728),
    [sym_new_declarator] = STATE(2744),
    [sym_identifier] = ACTIONS(5809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5811),
    [anon_sym_COMMA] = ACTIONS(5811),
    [anon_sym_RPAREN] = ACTIONS(5811),
    [aux_sym_preproc_if_token2] = ACTIONS(5811),
    [aux_sym_preproc_else_token1] = ACTIONS(5811),
    [aux_sym_preproc_elif_token1] = ACTIONS(5809),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5811),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5811),
    [anon_sym_LPAREN2] = ACTIONS(5813),
    [anon_sym_DASH] = ACTIONS(5809),
    [anon_sym_PLUS] = ACTIONS(5809),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5809),
    [anon_sym_PERCENT] = ACTIONS(5809),
    [anon_sym_PIPE_PIPE] = ACTIONS(5811),
    [anon_sym_AMP_AMP] = ACTIONS(5811),
    [anon_sym_PIPE] = ACTIONS(5809),
    [anon_sym_CARET] = ACTIONS(5809),
    [anon_sym_AMP] = ACTIONS(5809),
    [anon_sym_EQ_EQ] = ACTIONS(5811),
    [anon_sym_BANG_EQ] = ACTIONS(5811),
    [anon_sym_GT] = ACTIONS(5809),
    [anon_sym_GT_EQ] = ACTIONS(5811),
    [anon_sym_LT_EQ] = ACTIONS(5809),
    [anon_sym_LT] = ACTIONS(5809),
    [anon_sym_LT_LT] = ACTIONS(5809),
    [anon_sym_GT_GT] = ACTIONS(5809),
    [anon_sym_SEMI] = ACTIONS(5811),
    [anon_sym___attribute__] = ACTIONS(5809),
    [anon_sym_LBRACE] = ACTIONS(2159),
    [anon_sym_RBRACE] = ACTIONS(5811),
    [anon_sym_LBRACK] = ACTIONS(5815),
    [anon_sym_RBRACK] = ACTIONS(5811),
    [anon_sym_EQ] = ACTIONS(5809),
    [anon_sym_COLON] = ACTIONS(5811),
    [anon_sym_QMARK] = ACTIONS(5811),
    [anon_sym_STAR_EQ] = ACTIONS(5811),
    [anon_sym_SLASH_EQ] = ACTIONS(5811),
    [anon_sym_PERCENT_EQ] = ACTIONS(5811),
    [anon_sym_PLUS_EQ] = ACTIONS(5811),
    [anon_sym_DASH_EQ] = ACTIONS(5811),
    [anon_sym_LT_LT_EQ] = ACTIONS(5811),
    [anon_sym_GT_GT_EQ] = ACTIONS(5811),
    [anon_sym_AMP_EQ] = ACTIONS(5811),
    [anon_sym_CARET_EQ] = ACTIONS(5811),
    [anon_sym_PIPE_EQ] = ACTIONS(5811),
    [anon_sym_and_eq] = ACTIONS(5809),
    [anon_sym_or_eq] = ACTIONS(5809),
    [anon_sym_xor_eq] = ACTIONS(5809),
    [anon_sym_LT_EQ_GT] = ACTIONS(5811),
    [anon_sym_or] = ACTIONS(5809),
    [anon_sym_and] = ACTIONS(5809),
    [anon_sym_bitor] = ACTIONS(5809),
    [anon_sym_xor] = ACTIONS(5809),
    [anon_sym_bitand] = ACTIONS(5809),
    [anon_sym_not_eq] = ACTIONS(5809),
    [anon_sym_DASH_DASH] = ACTIONS(5811),
    [anon_sym_PLUS_PLUS] = ACTIONS(5811),
    [anon_sym_DOT] = ACTIONS(5809),
    [anon_sym_DOT_STAR] = ACTIONS(5811),
    [anon_sym_DASH_GT] = ACTIONS(5811),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5817),
    [anon_sym_decltype] = ACTIONS(5819),
  },
  [2346] = {
    [sym_identifier] = ACTIONS(3336),
    [aux_sym_preproc_def_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token2] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3336),
    [aux_sym_preproc_else_token1] = ACTIONS(3336),
    [aux_sym_preproc_elif_token1] = ACTIONS(3336),
    [sym_preproc_directive] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym___extension__] = ACTIONS(3336),
    [anon_sym_typedef] = ACTIONS(3336),
    [anon_sym_extern] = ACTIONS(3336),
    [anon_sym___attribute__] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3338),
    [anon_sym___declspec] = ACTIONS(3336),
    [anon_sym___based] = ACTIONS(3336),
    [anon_sym_signed] = ACTIONS(3336),
    [anon_sym_unsigned] = ACTIONS(3336),
    [anon_sym_long] = ACTIONS(3336),
    [anon_sym_short] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_static] = ACTIONS(3336),
    [anon_sym_register] = ACTIONS(3336),
    [anon_sym_inline] = ACTIONS(3336),
    [anon_sym___inline] = ACTIONS(3336),
    [anon_sym___inline__] = ACTIONS(3336),
    [anon_sym___forceinline] = ACTIONS(3336),
    [anon_sym_thread_local] = ACTIONS(3336),
    [anon_sym___thread] = ACTIONS(3336),
    [anon_sym_const] = ACTIONS(3336),
    [anon_sym_constexpr] = ACTIONS(3336),
    [anon_sym_volatile] = ACTIONS(3336),
    [anon_sym_restrict] = ACTIONS(3336),
    [anon_sym___restrict__] = ACTIONS(3336),
    [anon_sym__Atomic] = ACTIONS(3336),
    [anon_sym__Noreturn] = ACTIONS(3336),
    [anon_sym_noreturn] = ACTIONS(3336),
    [anon_sym_mutable] = ACTIONS(3336),
    [anon_sym_constinit] = ACTIONS(3336),
    [anon_sym_consteval] = ACTIONS(3336),
    [anon_sym_PROGMEM] = ACTIONS(3336),
    [aux_sym_primitive_type_token1] = ACTIONS(3336),
    [anon_sym_byte] = ACTIONS(3336),
    [anon_sym_word] = ACTIONS(3336),
    [anon_sym_enum] = ACTIONS(3336),
    [anon_sym_class] = ACTIONS(3336),
    [anon_sym_struct] = ACTIONS(3336),
    [anon_sym_union] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3336),
    [anon_sym_decltype] = ACTIONS(3336),
    [anon_sym_virtual] = ACTIONS(3336),
    [anon_sym_alignas] = ACTIONS(3336),
    [anon_sym_explicit] = ACTIONS(3336),
    [anon_sym_typename] = ACTIONS(3336),
    [anon_sym_template] = ACTIONS(3336),
    [anon_sym_operator] = ACTIONS(3336),
    [anon_sym_friend] = ACTIONS(3336),
    [anon_sym_public] = ACTIONS(3336),
    [anon_sym_private] = ACTIONS(3336),
    [anon_sym_protected] = ACTIONS(3336),
    [anon_sym_using] = ACTIONS(3336),
    [anon_sym_static_assert] = ACTIONS(3336),
  },
  [2347] = {
    [sym_identifier] = ACTIONS(5578),
    [aux_sym_preproc_def_token1] = ACTIONS(5578),
    [aux_sym_preproc_if_token1] = ACTIONS(5578),
    [aux_sym_preproc_if_token2] = ACTIONS(5578),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5578),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5578),
    [aux_sym_preproc_else_token1] = ACTIONS(5578),
    [aux_sym_preproc_elif_token1] = ACTIONS(5578),
    [sym_preproc_directive] = ACTIONS(5578),
    [anon_sym_LPAREN2] = ACTIONS(5580),
    [anon_sym_TILDE] = ACTIONS(5580),
    [anon_sym_STAR] = ACTIONS(5580),
    [anon_sym_AMP_AMP] = ACTIONS(5580),
    [anon_sym_AMP] = ACTIONS(5578),
    [anon_sym___extension__] = ACTIONS(5578),
    [anon_sym_typedef] = ACTIONS(5578),
    [anon_sym_extern] = ACTIONS(5578),
    [anon_sym___attribute__] = ACTIONS(5578),
    [anon_sym_COLON_COLON] = ACTIONS(5580),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5580),
    [anon_sym___declspec] = ACTIONS(5578),
    [anon_sym___based] = ACTIONS(5578),
    [anon_sym_signed] = ACTIONS(5578),
    [anon_sym_unsigned] = ACTIONS(5578),
    [anon_sym_long] = ACTIONS(5578),
    [anon_sym_short] = ACTIONS(5578),
    [anon_sym_LBRACK] = ACTIONS(5578),
    [anon_sym_static] = ACTIONS(5578),
    [anon_sym_register] = ACTIONS(5578),
    [anon_sym_inline] = ACTIONS(5578),
    [anon_sym___inline] = ACTIONS(5578),
    [anon_sym___inline__] = ACTIONS(5578),
    [anon_sym___forceinline] = ACTIONS(5578),
    [anon_sym_thread_local] = ACTIONS(5578),
    [anon_sym___thread] = ACTIONS(5578),
    [anon_sym_const] = ACTIONS(5578),
    [anon_sym_constexpr] = ACTIONS(5578),
    [anon_sym_volatile] = ACTIONS(5578),
    [anon_sym_restrict] = ACTIONS(5578),
    [anon_sym___restrict__] = ACTIONS(5578),
    [anon_sym__Atomic] = ACTIONS(5578),
    [anon_sym__Noreturn] = ACTIONS(5578),
    [anon_sym_noreturn] = ACTIONS(5578),
    [anon_sym_mutable] = ACTIONS(5578),
    [anon_sym_constinit] = ACTIONS(5578),
    [anon_sym_consteval] = ACTIONS(5578),
    [anon_sym_PROGMEM] = ACTIONS(5578),
    [aux_sym_primitive_type_token1] = ACTIONS(5578),
    [anon_sym_byte] = ACTIONS(5578),
    [anon_sym_word] = ACTIONS(5578),
    [anon_sym_enum] = ACTIONS(5578),
    [anon_sym_class] = ACTIONS(5578),
    [anon_sym_struct] = ACTIONS(5578),
    [anon_sym_union] = ACTIONS(5578),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5578),
    [anon_sym_decltype] = ACTIONS(5578),
    [anon_sym_virtual] = ACTIONS(5578),
    [anon_sym_alignas] = ACTIONS(5578),
    [anon_sym_explicit] = ACTIONS(5578),
    [anon_sym_typename] = ACTIONS(5578),
    [anon_sym_template] = ACTIONS(5578),
    [anon_sym_operator] = ACTIONS(5578),
    [anon_sym_friend] = ACTIONS(5578),
    [anon_sym_public] = ACTIONS(5578),
    [anon_sym_private] = ACTIONS(5578),
    [anon_sym_protected] = ACTIONS(5578),
    [anon_sym_using] = ACTIONS(5578),
    [anon_sym_static_assert] = ACTIONS(5578),
  },
  [2348] = {
    [sym_identifier] = ACTIONS(5574),
    [aux_sym_preproc_def_token1] = ACTIONS(5574),
    [aux_sym_preproc_if_token1] = ACTIONS(5574),
    [aux_sym_preproc_if_token2] = ACTIONS(5574),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5574),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5574),
    [aux_sym_preproc_else_token1] = ACTIONS(5574),
    [aux_sym_preproc_elif_token1] = ACTIONS(5574),
    [sym_preproc_directive] = ACTIONS(5574),
    [anon_sym_LPAREN2] = ACTIONS(5576),
    [anon_sym_TILDE] = ACTIONS(5576),
    [anon_sym_STAR] = ACTIONS(5576),
    [anon_sym_AMP_AMP] = ACTIONS(5576),
    [anon_sym_AMP] = ACTIONS(5574),
    [anon_sym___extension__] = ACTIONS(5574),
    [anon_sym_typedef] = ACTIONS(5574),
    [anon_sym_extern] = ACTIONS(5574),
    [anon_sym___attribute__] = ACTIONS(5574),
    [anon_sym_COLON_COLON] = ACTIONS(5576),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5576),
    [anon_sym___declspec] = ACTIONS(5574),
    [anon_sym___based] = ACTIONS(5574),
    [anon_sym_signed] = ACTIONS(5574),
    [anon_sym_unsigned] = ACTIONS(5574),
    [anon_sym_long] = ACTIONS(5574),
    [anon_sym_short] = ACTIONS(5574),
    [anon_sym_LBRACK] = ACTIONS(5574),
    [anon_sym_static] = ACTIONS(5574),
    [anon_sym_register] = ACTIONS(5574),
    [anon_sym_inline] = ACTIONS(5574),
    [anon_sym___inline] = ACTIONS(5574),
    [anon_sym___inline__] = ACTIONS(5574),
    [anon_sym___forceinline] = ACTIONS(5574),
    [anon_sym_thread_local] = ACTIONS(5574),
    [anon_sym___thread] = ACTIONS(5574),
    [anon_sym_const] = ACTIONS(5574),
    [anon_sym_constexpr] = ACTIONS(5574),
    [anon_sym_volatile] = ACTIONS(5574),
    [anon_sym_restrict] = ACTIONS(5574),
    [anon_sym___restrict__] = ACTIONS(5574),
    [anon_sym__Atomic] = ACTIONS(5574),
    [anon_sym__Noreturn] = ACTIONS(5574),
    [anon_sym_noreturn] = ACTIONS(5574),
    [anon_sym_mutable] = ACTIONS(5574),
    [anon_sym_constinit] = ACTIONS(5574),
    [anon_sym_consteval] = ACTIONS(5574),
    [anon_sym_PROGMEM] = ACTIONS(5574),
    [aux_sym_primitive_type_token1] = ACTIONS(5574),
    [anon_sym_byte] = ACTIONS(5574),
    [anon_sym_word] = ACTIONS(5574),
    [anon_sym_enum] = ACTIONS(5574),
    [anon_sym_class] = ACTIONS(5574),
    [anon_sym_struct] = ACTIONS(5574),
    [anon_sym_union] = ACTIONS(5574),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5574),
    [anon_sym_decltype] = ACTIONS(5574),
    [anon_sym_virtual] = ACTIONS(5574),
    [anon_sym_alignas] = ACTIONS(5574),
    [anon_sym_explicit] = ACTIONS(5574),
    [anon_sym_typename] = ACTIONS(5574),
    [anon_sym_template] = ACTIONS(5574),
    [anon_sym_operator] = ACTIONS(5574),
    [anon_sym_friend] = ACTIONS(5574),
    [anon_sym_public] = ACTIONS(5574),
    [anon_sym_private] = ACTIONS(5574),
    [anon_sym_protected] = ACTIONS(5574),
    [anon_sym_using] = ACTIONS(5574),
    [anon_sym_static_assert] = ACTIONS(5574),
  },
  [2349] = {
    [sym_string_literal] = STATE(3782),
    [sym_template_argument_list] = STATE(4984),
    [sym_raw_string_literal] = STATE(3782),
    [sym_identifier] = ACTIONS(4256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [aux_sym_preproc_if_token2] = ACTIONS(4248),
    [aux_sym_preproc_else_token1] = ACTIONS(4248),
    [aux_sym_preproc_elif_token1] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5821),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(5826),
    [anon_sym_SLASH_EQ] = ACTIONS(5826),
    [anon_sym_PERCENT_EQ] = ACTIONS(5826),
    [anon_sym_PLUS_EQ] = ACTIONS(5826),
    [anon_sym_DASH_EQ] = ACTIONS(5826),
    [anon_sym_LT_LT_EQ] = ACTIONS(5826),
    [anon_sym_GT_GT_EQ] = ACTIONS(5826),
    [anon_sym_AMP_EQ] = ACTIONS(5826),
    [anon_sym_CARET_EQ] = ACTIONS(5826),
    [anon_sym_PIPE_EQ] = ACTIONS(5826),
    [anon_sym_and_eq] = ACTIONS(5824),
    [anon_sym_or_eq] = ACTIONS(5824),
    [anon_sym_xor_eq] = ACTIONS(5824),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4256),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4256),
    [anon_sym_not_eq] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3747),
    [anon_sym_u_DQUOTE] = ACTIONS(3747),
    [anon_sym_U_DQUOTE] = ACTIONS(3747),
    [anon_sym_u8_DQUOTE] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3755),
    [anon_sym_LR_DQUOTE] = ACTIONS(3755),
    [anon_sym_uR_DQUOTE] = ACTIONS(3755),
    [anon_sym_UR_DQUOTE] = ACTIONS(3755),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3755),
  },
  [2350] = {
    [sym_identifier] = ACTIONS(5570),
    [aux_sym_preproc_def_token1] = ACTIONS(5570),
    [aux_sym_preproc_if_token1] = ACTIONS(5570),
    [aux_sym_preproc_if_token2] = ACTIONS(5570),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5570),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5570),
    [aux_sym_preproc_else_token1] = ACTIONS(5570),
    [aux_sym_preproc_elif_token1] = ACTIONS(5570),
    [sym_preproc_directive] = ACTIONS(5570),
    [anon_sym_LPAREN2] = ACTIONS(5572),
    [anon_sym_TILDE] = ACTIONS(5572),
    [anon_sym_STAR] = ACTIONS(5572),
    [anon_sym_AMP_AMP] = ACTIONS(5572),
    [anon_sym_AMP] = ACTIONS(5570),
    [anon_sym___extension__] = ACTIONS(5570),
    [anon_sym_typedef] = ACTIONS(5570),
    [anon_sym_extern] = ACTIONS(5570),
    [anon_sym___attribute__] = ACTIONS(5570),
    [anon_sym_COLON_COLON] = ACTIONS(5572),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5572),
    [anon_sym___declspec] = ACTIONS(5570),
    [anon_sym___based] = ACTIONS(5570),
    [anon_sym_signed] = ACTIONS(5570),
    [anon_sym_unsigned] = ACTIONS(5570),
    [anon_sym_long] = ACTIONS(5570),
    [anon_sym_short] = ACTIONS(5570),
    [anon_sym_LBRACK] = ACTIONS(5570),
    [anon_sym_static] = ACTIONS(5570),
    [anon_sym_register] = ACTIONS(5570),
    [anon_sym_inline] = ACTIONS(5570),
    [anon_sym___inline] = ACTIONS(5570),
    [anon_sym___inline__] = ACTIONS(5570),
    [anon_sym___forceinline] = ACTIONS(5570),
    [anon_sym_thread_local] = ACTIONS(5570),
    [anon_sym___thread] = ACTIONS(5570),
    [anon_sym_const] = ACTIONS(5570),
    [anon_sym_constexpr] = ACTIONS(5570),
    [anon_sym_volatile] = ACTIONS(5570),
    [anon_sym_restrict] = ACTIONS(5570),
    [anon_sym___restrict__] = ACTIONS(5570),
    [anon_sym__Atomic] = ACTIONS(5570),
    [anon_sym__Noreturn] = ACTIONS(5570),
    [anon_sym_noreturn] = ACTIONS(5570),
    [anon_sym_mutable] = ACTIONS(5570),
    [anon_sym_constinit] = ACTIONS(5570),
    [anon_sym_consteval] = ACTIONS(5570),
    [anon_sym_PROGMEM] = ACTIONS(5570),
    [aux_sym_primitive_type_token1] = ACTIONS(5570),
    [anon_sym_byte] = ACTIONS(5570),
    [anon_sym_word] = ACTIONS(5570),
    [anon_sym_enum] = ACTIONS(5570),
    [anon_sym_class] = ACTIONS(5570),
    [anon_sym_struct] = ACTIONS(5570),
    [anon_sym_union] = ACTIONS(5570),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5570),
    [anon_sym_decltype] = ACTIONS(5570),
    [anon_sym_virtual] = ACTIONS(5570),
    [anon_sym_alignas] = ACTIONS(5570),
    [anon_sym_explicit] = ACTIONS(5570),
    [anon_sym_typename] = ACTIONS(5570),
    [anon_sym_template] = ACTIONS(5570),
    [anon_sym_operator] = ACTIONS(5570),
    [anon_sym_friend] = ACTIONS(5570),
    [anon_sym_public] = ACTIONS(5570),
    [anon_sym_private] = ACTIONS(5570),
    [anon_sym_protected] = ACTIONS(5570),
    [anon_sym_using] = ACTIONS(5570),
    [anon_sym_static_assert] = ACTIONS(5570),
  },
  [2351] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token2] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [aux_sym_preproc_else_token1] = ACTIONS(3082),
    [aux_sym_preproc_elif_token1] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(3082),
    [anon_sym_private] = ACTIONS(3082),
    [anon_sym_protected] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
  },
  [2352] = {
    [sym_identifier] = ACTIONS(5562),
    [aux_sym_preproc_def_token1] = ACTIONS(5562),
    [aux_sym_preproc_if_token1] = ACTIONS(5562),
    [aux_sym_preproc_if_token2] = ACTIONS(5562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5562),
    [aux_sym_preproc_else_token1] = ACTIONS(5562),
    [aux_sym_preproc_elif_token1] = ACTIONS(5562),
    [sym_preproc_directive] = ACTIONS(5562),
    [anon_sym_LPAREN2] = ACTIONS(5564),
    [anon_sym_TILDE] = ACTIONS(5564),
    [anon_sym_STAR] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5562),
    [anon_sym___extension__] = ACTIONS(5562),
    [anon_sym_typedef] = ACTIONS(5562),
    [anon_sym_extern] = ACTIONS(5562),
    [anon_sym___attribute__] = ACTIONS(5562),
    [anon_sym_COLON_COLON] = ACTIONS(5564),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5564),
    [anon_sym___declspec] = ACTIONS(5562),
    [anon_sym___based] = ACTIONS(5562),
    [anon_sym_signed] = ACTIONS(5562),
    [anon_sym_unsigned] = ACTIONS(5562),
    [anon_sym_long] = ACTIONS(5562),
    [anon_sym_short] = ACTIONS(5562),
    [anon_sym_LBRACK] = ACTIONS(5562),
    [anon_sym_static] = ACTIONS(5562),
    [anon_sym_register] = ACTIONS(5562),
    [anon_sym_inline] = ACTIONS(5562),
    [anon_sym___inline] = ACTIONS(5562),
    [anon_sym___inline__] = ACTIONS(5562),
    [anon_sym___forceinline] = ACTIONS(5562),
    [anon_sym_thread_local] = ACTIONS(5562),
    [anon_sym___thread] = ACTIONS(5562),
    [anon_sym_const] = ACTIONS(5562),
    [anon_sym_constexpr] = ACTIONS(5562),
    [anon_sym_volatile] = ACTIONS(5562),
    [anon_sym_restrict] = ACTIONS(5562),
    [anon_sym___restrict__] = ACTIONS(5562),
    [anon_sym__Atomic] = ACTIONS(5562),
    [anon_sym__Noreturn] = ACTIONS(5562),
    [anon_sym_noreturn] = ACTIONS(5562),
    [anon_sym_mutable] = ACTIONS(5562),
    [anon_sym_constinit] = ACTIONS(5562),
    [anon_sym_consteval] = ACTIONS(5562),
    [anon_sym_PROGMEM] = ACTIONS(5562),
    [aux_sym_primitive_type_token1] = ACTIONS(5562),
    [anon_sym_byte] = ACTIONS(5562),
    [anon_sym_word] = ACTIONS(5562),
    [anon_sym_enum] = ACTIONS(5562),
    [anon_sym_class] = ACTIONS(5562),
    [anon_sym_struct] = ACTIONS(5562),
    [anon_sym_union] = ACTIONS(5562),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5562),
    [anon_sym_decltype] = ACTIONS(5562),
    [anon_sym_virtual] = ACTIONS(5562),
    [anon_sym_alignas] = ACTIONS(5562),
    [anon_sym_explicit] = ACTIONS(5562),
    [anon_sym_typename] = ACTIONS(5562),
    [anon_sym_template] = ACTIONS(5562),
    [anon_sym_operator] = ACTIONS(5562),
    [anon_sym_friend] = ACTIONS(5562),
    [anon_sym_public] = ACTIONS(5562),
    [anon_sym_private] = ACTIONS(5562),
    [anon_sym_protected] = ACTIONS(5562),
    [anon_sym_using] = ACTIONS(5562),
    [anon_sym_static_assert] = ACTIONS(5562),
  },
  [2353] = {
    [sym_identifier] = ACTIONS(5546),
    [aux_sym_preproc_def_token1] = ACTIONS(5546),
    [aux_sym_preproc_if_token1] = ACTIONS(5546),
    [aux_sym_preproc_if_token2] = ACTIONS(5546),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5546),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5546),
    [aux_sym_preproc_else_token1] = ACTIONS(5546),
    [aux_sym_preproc_elif_token1] = ACTIONS(5546),
    [sym_preproc_directive] = ACTIONS(5546),
    [anon_sym_LPAREN2] = ACTIONS(5548),
    [anon_sym_TILDE] = ACTIONS(5548),
    [anon_sym_STAR] = ACTIONS(5548),
    [anon_sym_AMP_AMP] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5546),
    [anon_sym___extension__] = ACTIONS(5546),
    [anon_sym_typedef] = ACTIONS(5546),
    [anon_sym_extern] = ACTIONS(5546),
    [anon_sym___attribute__] = ACTIONS(5546),
    [anon_sym_COLON_COLON] = ACTIONS(5548),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5548),
    [anon_sym___declspec] = ACTIONS(5546),
    [anon_sym___based] = ACTIONS(5546),
    [anon_sym_signed] = ACTIONS(5546),
    [anon_sym_unsigned] = ACTIONS(5546),
    [anon_sym_long] = ACTIONS(5546),
    [anon_sym_short] = ACTIONS(5546),
    [anon_sym_LBRACK] = ACTIONS(5546),
    [anon_sym_static] = ACTIONS(5546),
    [anon_sym_register] = ACTIONS(5546),
    [anon_sym_inline] = ACTIONS(5546),
    [anon_sym___inline] = ACTIONS(5546),
    [anon_sym___inline__] = ACTIONS(5546),
    [anon_sym___forceinline] = ACTIONS(5546),
    [anon_sym_thread_local] = ACTIONS(5546),
    [anon_sym___thread] = ACTIONS(5546),
    [anon_sym_const] = ACTIONS(5546),
    [anon_sym_constexpr] = ACTIONS(5546),
    [anon_sym_volatile] = ACTIONS(5546),
    [anon_sym_restrict] = ACTIONS(5546),
    [anon_sym___restrict__] = ACTIONS(5546),
    [anon_sym__Atomic] = ACTIONS(5546),
    [anon_sym__Noreturn] = ACTIONS(5546),
    [anon_sym_noreturn] = ACTIONS(5546),
    [anon_sym_mutable] = ACTIONS(5546),
    [anon_sym_constinit] = ACTIONS(5546),
    [anon_sym_consteval] = ACTIONS(5546),
    [anon_sym_PROGMEM] = ACTIONS(5546),
    [aux_sym_primitive_type_token1] = ACTIONS(5546),
    [anon_sym_byte] = ACTIONS(5546),
    [anon_sym_word] = ACTIONS(5546),
    [anon_sym_enum] = ACTIONS(5546),
    [anon_sym_class] = ACTIONS(5546),
    [anon_sym_struct] = ACTIONS(5546),
    [anon_sym_union] = ACTIONS(5546),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5546),
    [anon_sym_decltype] = ACTIONS(5546),
    [anon_sym_virtual] = ACTIONS(5546),
    [anon_sym_alignas] = ACTIONS(5546),
    [anon_sym_explicit] = ACTIONS(5546),
    [anon_sym_typename] = ACTIONS(5546),
    [anon_sym_template] = ACTIONS(5546),
    [anon_sym_operator] = ACTIONS(5546),
    [anon_sym_friend] = ACTIONS(5546),
    [anon_sym_public] = ACTIONS(5546),
    [anon_sym_private] = ACTIONS(5546),
    [anon_sym_protected] = ACTIONS(5546),
    [anon_sym_using] = ACTIONS(5546),
    [anon_sym_static_assert] = ACTIONS(5546),
  },
  [2354] = {
    [sym_identifier] = ACTIONS(3993),
    [aux_sym_preproc_def_token1] = ACTIONS(3993),
    [aux_sym_preproc_if_token1] = ACTIONS(3993),
    [aux_sym_preproc_if_token2] = ACTIONS(3993),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3993),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3993),
    [aux_sym_preproc_else_token1] = ACTIONS(3993),
    [aux_sym_preproc_elif_token1] = ACTIONS(3993),
    [sym_preproc_directive] = ACTIONS(3993),
    [anon_sym_LPAREN2] = ACTIONS(3991),
    [anon_sym_TILDE] = ACTIONS(3991),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym___extension__] = ACTIONS(3993),
    [anon_sym_typedef] = ACTIONS(3993),
    [anon_sym_extern] = ACTIONS(3993),
    [anon_sym___attribute__] = ACTIONS(3993),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3991),
    [anon_sym___declspec] = ACTIONS(3993),
    [anon_sym___based] = ACTIONS(3993),
    [anon_sym_signed] = ACTIONS(3993),
    [anon_sym_unsigned] = ACTIONS(3993),
    [anon_sym_long] = ACTIONS(3993),
    [anon_sym_short] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3993),
    [anon_sym_static] = ACTIONS(3993),
    [anon_sym_register] = ACTIONS(3993),
    [anon_sym_inline] = ACTIONS(3993),
    [anon_sym___inline] = ACTIONS(3993),
    [anon_sym___inline__] = ACTIONS(3993),
    [anon_sym___forceinline] = ACTIONS(3993),
    [anon_sym_thread_local] = ACTIONS(3993),
    [anon_sym___thread] = ACTIONS(3993),
    [anon_sym_const] = ACTIONS(3993),
    [anon_sym_constexpr] = ACTIONS(3993),
    [anon_sym_volatile] = ACTIONS(3993),
    [anon_sym_restrict] = ACTIONS(3993),
    [anon_sym___restrict__] = ACTIONS(3993),
    [anon_sym__Atomic] = ACTIONS(3993),
    [anon_sym__Noreturn] = ACTIONS(3993),
    [anon_sym_noreturn] = ACTIONS(3993),
    [anon_sym_mutable] = ACTIONS(3993),
    [anon_sym_constinit] = ACTIONS(3993),
    [anon_sym_consteval] = ACTIONS(3993),
    [anon_sym_PROGMEM] = ACTIONS(3993),
    [aux_sym_primitive_type_token1] = ACTIONS(3993),
    [anon_sym_byte] = ACTIONS(3993),
    [anon_sym_word] = ACTIONS(3993),
    [anon_sym_enum] = ACTIONS(3993),
    [anon_sym_class] = ACTIONS(3993),
    [anon_sym_struct] = ACTIONS(3993),
    [anon_sym_union] = ACTIONS(3993),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3993),
    [anon_sym_decltype] = ACTIONS(3993),
    [anon_sym_virtual] = ACTIONS(3993),
    [anon_sym_alignas] = ACTIONS(3993),
    [anon_sym_explicit] = ACTIONS(3993),
    [anon_sym_typename] = ACTIONS(3993),
    [anon_sym_template] = ACTIONS(3993),
    [anon_sym_operator] = ACTIONS(3993),
    [anon_sym_friend] = ACTIONS(3993),
    [anon_sym_public] = ACTIONS(3993),
    [anon_sym_private] = ACTIONS(3993),
    [anon_sym_protected] = ACTIONS(3993),
    [anon_sym_using] = ACTIONS(3993),
    [anon_sym_static_assert] = ACTIONS(3993),
  },
  [2355] = {
    [sym_template_argument_list] = STATE(2436),
    [sym_identifier] = ACTIONS(5129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5136),
    [anon_sym_COMMA] = ACTIONS(5136),
    [anon_sym_RPAREN] = ACTIONS(5136),
    [aux_sym_preproc_if_token2] = ACTIONS(5136),
    [aux_sym_preproc_else_token1] = ACTIONS(5136),
    [aux_sym_preproc_elif_token1] = ACTIONS(5129),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5136),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5136),
    [anon_sym_LPAREN2] = ACTIONS(5136),
    [anon_sym_DASH] = ACTIONS(5129),
    [anon_sym_PLUS] = ACTIONS(5129),
    [anon_sym_STAR] = ACTIONS(5129),
    [anon_sym_SLASH] = ACTIONS(5129),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5136),
    [anon_sym_AMP_AMP] = ACTIONS(5136),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_CARET] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_EQ_EQ] = ACTIONS(5136),
    [anon_sym_BANG_EQ] = ACTIONS(5136),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_GT_EQ] = ACTIONS(5136),
    [anon_sym_LT_EQ] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5828),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [anon_sym_SEMI] = ACTIONS(5136),
    [anon_sym___attribute__] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_RBRACE] = ACTIONS(5136),
    [anon_sym_LBRACK] = ACTIONS(5136),
    [anon_sym_RBRACK] = ACTIONS(5136),
    [anon_sym_EQ] = ACTIONS(5129),
    [anon_sym_COLON] = ACTIONS(5129),
    [anon_sym_QMARK] = ACTIONS(5136),
    [anon_sym_STAR_EQ] = ACTIONS(5136),
    [anon_sym_SLASH_EQ] = ACTIONS(5136),
    [anon_sym_PERCENT_EQ] = ACTIONS(5136),
    [anon_sym_PLUS_EQ] = ACTIONS(5136),
    [anon_sym_DASH_EQ] = ACTIONS(5136),
    [anon_sym_LT_LT_EQ] = ACTIONS(5136),
    [anon_sym_GT_GT_EQ] = ACTIONS(5136),
    [anon_sym_AMP_EQ] = ACTIONS(5136),
    [anon_sym_CARET_EQ] = ACTIONS(5136),
    [anon_sym_PIPE_EQ] = ACTIONS(5136),
    [anon_sym_and_eq] = ACTIONS(5129),
    [anon_sym_or_eq] = ACTIONS(5129),
    [anon_sym_xor_eq] = ACTIONS(5129),
    [anon_sym_LT_EQ_GT] = ACTIONS(5136),
    [anon_sym_or] = ACTIONS(5129),
    [anon_sym_and] = ACTIONS(5129),
    [anon_sym_bitor] = ACTIONS(5129),
    [anon_sym_xor] = ACTIONS(5129),
    [anon_sym_bitand] = ACTIONS(5129),
    [anon_sym_not_eq] = ACTIONS(5129),
    [anon_sym_DASH_DASH] = ACTIONS(5136),
    [anon_sym_PLUS_PLUS] = ACTIONS(5136),
    [anon_sym_DOT] = ACTIONS(5129),
    [anon_sym_DOT_STAR] = ACTIONS(5136),
    [anon_sym_DASH_GT] = ACTIONS(5136),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5129),
    [anon_sym_decltype] = ACTIONS(5129),
    [anon_sym_final] = ACTIONS(5129),
    [anon_sym_override] = ACTIONS(5129),
  },
  [2356] = {
    [sym_identifier] = ACTIONS(3297),
    [aux_sym_preproc_def_token1] = ACTIONS(3297),
    [aux_sym_preproc_if_token1] = ACTIONS(3297),
    [aux_sym_preproc_if_token2] = ACTIONS(3297),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3297),
    [aux_sym_preproc_else_token1] = ACTIONS(3297),
    [aux_sym_preproc_elif_token1] = ACTIONS(3297),
    [sym_preproc_directive] = ACTIONS(3297),
    [anon_sym_LPAREN2] = ACTIONS(3299),
    [anon_sym_TILDE] = ACTIONS(3299),
    [anon_sym_STAR] = ACTIONS(3299),
    [anon_sym_AMP_AMP] = ACTIONS(3299),
    [anon_sym_AMP] = ACTIONS(3297),
    [anon_sym___extension__] = ACTIONS(3297),
    [anon_sym_typedef] = ACTIONS(3297),
    [anon_sym_extern] = ACTIONS(3297),
    [anon_sym___attribute__] = ACTIONS(3297),
    [anon_sym_COLON_COLON] = ACTIONS(3299),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3299),
    [anon_sym___declspec] = ACTIONS(3297),
    [anon_sym___based] = ACTIONS(3297),
    [anon_sym_signed] = ACTIONS(3297),
    [anon_sym_unsigned] = ACTIONS(3297),
    [anon_sym_long] = ACTIONS(3297),
    [anon_sym_short] = ACTIONS(3297),
    [anon_sym_LBRACK] = ACTIONS(3297),
    [anon_sym_static] = ACTIONS(3297),
    [anon_sym_register] = ACTIONS(3297),
    [anon_sym_inline] = ACTIONS(3297),
    [anon_sym___inline] = ACTIONS(3297),
    [anon_sym___inline__] = ACTIONS(3297),
    [anon_sym___forceinline] = ACTIONS(3297),
    [anon_sym_thread_local] = ACTIONS(3297),
    [anon_sym___thread] = ACTIONS(3297),
    [anon_sym_const] = ACTIONS(3297),
    [anon_sym_constexpr] = ACTIONS(3297),
    [anon_sym_volatile] = ACTIONS(3297),
    [anon_sym_restrict] = ACTIONS(3297),
    [anon_sym___restrict__] = ACTIONS(3297),
    [anon_sym__Atomic] = ACTIONS(3297),
    [anon_sym__Noreturn] = ACTIONS(3297),
    [anon_sym_noreturn] = ACTIONS(3297),
    [anon_sym_mutable] = ACTIONS(3297),
    [anon_sym_constinit] = ACTIONS(3297),
    [anon_sym_consteval] = ACTIONS(3297),
    [anon_sym_PROGMEM] = ACTIONS(3297),
    [aux_sym_primitive_type_token1] = ACTIONS(3297),
    [anon_sym_byte] = ACTIONS(3297),
    [anon_sym_word] = ACTIONS(3297),
    [anon_sym_enum] = ACTIONS(3297),
    [anon_sym_class] = ACTIONS(3297),
    [anon_sym_struct] = ACTIONS(3297),
    [anon_sym_union] = ACTIONS(3297),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3297),
    [anon_sym_decltype] = ACTIONS(3297),
    [anon_sym_virtual] = ACTIONS(3297),
    [anon_sym_alignas] = ACTIONS(3297),
    [anon_sym_explicit] = ACTIONS(3297),
    [anon_sym_typename] = ACTIONS(3297),
    [anon_sym_template] = ACTIONS(3297),
    [anon_sym_operator] = ACTIONS(3297),
    [anon_sym_friend] = ACTIONS(3297),
    [anon_sym_public] = ACTIONS(3297),
    [anon_sym_private] = ACTIONS(3297),
    [anon_sym_protected] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3297),
    [anon_sym_static_assert] = ACTIONS(3297),
  },
  [2357] = {
    [sym_identifier] = ACTIONS(5534),
    [aux_sym_preproc_def_token1] = ACTIONS(5534),
    [aux_sym_preproc_if_token1] = ACTIONS(5534),
    [aux_sym_preproc_if_token2] = ACTIONS(5534),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5534),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5534),
    [aux_sym_preproc_else_token1] = ACTIONS(5534),
    [aux_sym_preproc_elif_token1] = ACTIONS(5534),
    [sym_preproc_directive] = ACTIONS(5534),
    [anon_sym_LPAREN2] = ACTIONS(5536),
    [anon_sym_TILDE] = ACTIONS(5536),
    [anon_sym_STAR] = ACTIONS(5536),
    [anon_sym_AMP_AMP] = ACTIONS(5536),
    [anon_sym_AMP] = ACTIONS(5534),
    [anon_sym___extension__] = ACTIONS(5534),
    [anon_sym_typedef] = ACTIONS(5534),
    [anon_sym_extern] = ACTIONS(5534),
    [anon_sym___attribute__] = ACTIONS(5534),
    [anon_sym_COLON_COLON] = ACTIONS(5536),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5536),
    [anon_sym___declspec] = ACTIONS(5534),
    [anon_sym___based] = ACTIONS(5534),
    [anon_sym_signed] = ACTIONS(5534),
    [anon_sym_unsigned] = ACTIONS(5534),
    [anon_sym_long] = ACTIONS(5534),
    [anon_sym_short] = ACTIONS(5534),
    [anon_sym_LBRACK] = ACTIONS(5534),
    [anon_sym_static] = ACTIONS(5534),
    [anon_sym_register] = ACTIONS(5534),
    [anon_sym_inline] = ACTIONS(5534),
    [anon_sym___inline] = ACTIONS(5534),
    [anon_sym___inline__] = ACTIONS(5534),
    [anon_sym___forceinline] = ACTIONS(5534),
    [anon_sym_thread_local] = ACTIONS(5534),
    [anon_sym___thread] = ACTIONS(5534),
    [anon_sym_const] = ACTIONS(5534),
    [anon_sym_constexpr] = ACTIONS(5534),
    [anon_sym_volatile] = ACTIONS(5534),
    [anon_sym_restrict] = ACTIONS(5534),
    [anon_sym___restrict__] = ACTIONS(5534),
    [anon_sym__Atomic] = ACTIONS(5534),
    [anon_sym__Noreturn] = ACTIONS(5534),
    [anon_sym_noreturn] = ACTIONS(5534),
    [anon_sym_mutable] = ACTIONS(5534),
    [anon_sym_constinit] = ACTIONS(5534),
    [anon_sym_consteval] = ACTIONS(5534),
    [anon_sym_PROGMEM] = ACTIONS(5534),
    [aux_sym_primitive_type_token1] = ACTIONS(5534),
    [anon_sym_byte] = ACTIONS(5534),
    [anon_sym_word] = ACTIONS(5534),
    [anon_sym_enum] = ACTIONS(5534),
    [anon_sym_class] = ACTIONS(5534),
    [anon_sym_struct] = ACTIONS(5534),
    [anon_sym_union] = ACTIONS(5534),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5534),
    [anon_sym_decltype] = ACTIONS(5534),
    [anon_sym_virtual] = ACTIONS(5534),
    [anon_sym_alignas] = ACTIONS(5534),
    [anon_sym_explicit] = ACTIONS(5534),
    [anon_sym_typename] = ACTIONS(5534),
    [anon_sym_template] = ACTIONS(5534),
    [anon_sym_operator] = ACTIONS(5534),
    [anon_sym_friend] = ACTIONS(5534),
    [anon_sym_public] = ACTIONS(5534),
    [anon_sym_private] = ACTIONS(5534),
    [anon_sym_protected] = ACTIONS(5534),
    [anon_sym_using] = ACTIONS(5534),
    [anon_sym_static_assert] = ACTIONS(5534),
  },
  [2358] = {
    [sym_identifier] = ACTIONS(5530),
    [aux_sym_preproc_def_token1] = ACTIONS(5530),
    [aux_sym_preproc_if_token1] = ACTIONS(5530),
    [aux_sym_preproc_if_token2] = ACTIONS(5530),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5530),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5530),
    [aux_sym_preproc_else_token1] = ACTIONS(5530),
    [aux_sym_preproc_elif_token1] = ACTIONS(5530),
    [sym_preproc_directive] = ACTIONS(5530),
    [anon_sym_LPAREN2] = ACTIONS(5532),
    [anon_sym_TILDE] = ACTIONS(5532),
    [anon_sym_STAR] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5530),
    [anon_sym___extension__] = ACTIONS(5530),
    [anon_sym_typedef] = ACTIONS(5530),
    [anon_sym_extern] = ACTIONS(5530),
    [anon_sym___attribute__] = ACTIONS(5530),
    [anon_sym_COLON_COLON] = ACTIONS(5532),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5532),
    [anon_sym___declspec] = ACTIONS(5530),
    [anon_sym___based] = ACTIONS(5530),
    [anon_sym_signed] = ACTIONS(5530),
    [anon_sym_unsigned] = ACTIONS(5530),
    [anon_sym_long] = ACTIONS(5530),
    [anon_sym_short] = ACTIONS(5530),
    [anon_sym_LBRACK] = ACTIONS(5530),
    [anon_sym_static] = ACTIONS(5530),
    [anon_sym_register] = ACTIONS(5530),
    [anon_sym_inline] = ACTIONS(5530),
    [anon_sym___inline] = ACTIONS(5530),
    [anon_sym___inline__] = ACTIONS(5530),
    [anon_sym___forceinline] = ACTIONS(5530),
    [anon_sym_thread_local] = ACTIONS(5530),
    [anon_sym___thread] = ACTIONS(5530),
    [anon_sym_const] = ACTIONS(5530),
    [anon_sym_constexpr] = ACTIONS(5530),
    [anon_sym_volatile] = ACTIONS(5530),
    [anon_sym_restrict] = ACTIONS(5530),
    [anon_sym___restrict__] = ACTIONS(5530),
    [anon_sym__Atomic] = ACTIONS(5530),
    [anon_sym__Noreturn] = ACTIONS(5530),
    [anon_sym_noreturn] = ACTIONS(5530),
    [anon_sym_mutable] = ACTIONS(5530),
    [anon_sym_constinit] = ACTIONS(5530),
    [anon_sym_consteval] = ACTIONS(5530),
    [anon_sym_PROGMEM] = ACTIONS(5530),
    [aux_sym_primitive_type_token1] = ACTIONS(5530),
    [anon_sym_byte] = ACTIONS(5530),
    [anon_sym_word] = ACTIONS(5530),
    [anon_sym_enum] = ACTIONS(5530),
    [anon_sym_class] = ACTIONS(5530),
    [anon_sym_struct] = ACTIONS(5530),
    [anon_sym_union] = ACTIONS(5530),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5530),
    [anon_sym_decltype] = ACTIONS(5530),
    [anon_sym_virtual] = ACTIONS(5530),
    [anon_sym_alignas] = ACTIONS(5530),
    [anon_sym_explicit] = ACTIONS(5530),
    [anon_sym_typename] = ACTIONS(5530),
    [anon_sym_template] = ACTIONS(5530),
    [anon_sym_operator] = ACTIONS(5530),
    [anon_sym_friend] = ACTIONS(5530),
    [anon_sym_public] = ACTIONS(5530),
    [anon_sym_private] = ACTIONS(5530),
    [anon_sym_protected] = ACTIONS(5530),
    [anon_sym_using] = ACTIONS(5530),
    [anon_sym_static_assert] = ACTIONS(5530),
  },
  [2359] = {
    [sym_identifier] = ACTIONS(3346),
    [aux_sym_preproc_def_token1] = ACTIONS(3346),
    [aux_sym_preproc_if_token1] = ACTIONS(3346),
    [aux_sym_preproc_if_token2] = ACTIONS(3346),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3346),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3346),
    [aux_sym_preproc_else_token1] = ACTIONS(3346),
    [aux_sym_preproc_elif_token1] = ACTIONS(3346),
    [sym_preproc_directive] = ACTIONS(3346),
    [anon_sym_LPAREN2] = ACTIONS(3348),
    [anon_sym_TILDE] = ACTIONS(3348),
    [anon_sym_STAR] = ACTIONS(3348),
    [anon_sym_AMP_AMP] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym___extension__] = ACTIONS(3346),
    [anon_sym_typedef] = ACTIONS(3346),
    [anon_sym_extern] = ACTIONS(3346),
    [anon_sym___attribute__] = ACTIONS(3346),
    [anon_sym_COLON_COLON] = ACTIONS(3348),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3348),
    [anon_sym___declspec] = ACTIONS(3346),
    [anon_sym___based] = ACTIONS(3346),
    [anon_sym_signed] = ACTIONS(3346),
    [anon_sym_unsigned] = ACTIONS(3346),
    [anon_sym_long] = ACTIONS(3346),
    [anon_sym_short] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3346),
    [anon_sym_register] = ACTIONS(3346),
    [anon_sym_inline] = ACTIONS(3346),
    [anon_sym___inline] = ACTIONS(3346),
    [anon_sym___inline__] = ACTIONS(3346),
    [anon_sym___forceinline] = ACTIONS(3346),
    [anon_sym_thread_local] = ACTIONS(3346),
    [anon_sym___thread] = ACTIONS(3346),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_constexpr] = ACTIONS(3346),
    [anon_sym_volatile] = ACTIONS(3346),
    [anon_sym_restrict] = ACTIONS(3346),
    [anon_sym___restrict__] = ACTIONS(3346),
    [anon_sym__Atomic] = ACTIONS(3346),
    [anon_sym__Noreturn] = ACTIONS(3346),
    [anon_sym_noreturn] = ACTIONS(3346),
    [anon_sym_mutable] = ACTIONS(3346),
    [anon_sym_constinit] = ACTIONS(3346),
    [anon_sym_consteval] = ACTIONS(3346),
    [anon_sym_PROGMEM] = ACTIONS(3346),
    [aux_sym_primitive_type_token1] = ACTIONS(3346),
    [anon_sym_byte] = ACTIONS(3346),
    [anon_sym_word] = ACTIONS(3346),
    [anon_sym_enum] = ACTIONS(3346),
    [anon_sym_class] = ACTIONS(3346),
    [anon_sym_struct] = ACTIONS(3346),
    [anon_sym_union] = ACTIONS(3346),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3346),
    [anon_sym_decltype] = ACTIONS(3346),
    [anon_sym_virtual] = ACTIONS(3346),
    [anon_sym_alignas] = ACTIONS(3346),
    [anon_sym_explicit] = ACTIONS(3346),
    [anon_sym_typename] = ACTIONS(3346),
    [anon_sym_template] = ACTIONS(3346),
    [anon_sym_operator] = ACTIONS(3346),
    [anon_sym_friend] = ACTIONS(3346),
    [anon_sym_public] = ACTIONS(3346),
    [anon_sym_private] = ACTIONS(3346),
    [anon_sym_protected] = ACTIONS(3346),
    [anon_sym_using] = ACTIONS(3346),
    [anon_sym_static_assert] = ACTIONS(3346),
  },
  [2360] = {
    [sym_identifier] = ACTIONS(3371),
    [aux_sym_preproc_def_token1] = ACTIONS(3371),
    [aux_sym_preproc_if_token1] = ACTIONS(3371),
    [aux_sym_preproc_if_token2] = ACTIONS(3371),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3371),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3371),
    [aux_sym_preproc_else_token1] = ACTIONS(3371),
    [aux_sym_preproc_elif_token1] = ACTIONS(3371),
    [sym_preproc_directive] = ACTIONS(3371),
    [anon_sym_LPAREN2] = ACTIONS(3373),
    [anon_sym_TILDE] = ACTIONS(3373),
    [anon_sym_STAR] = ACTIONS(3373),
    [anon_sym_AMP_AMP] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3371),
    [anon_sym___extension__] = ACTIONS(3371),
    [anon_sym_typedef] = ACTIONS(3371),
    [anon_sym_extern] = ACTIONS(3371),
    [anon_sym___attribute__] = ACTIONS(3371),
    [anon_sym_COLON_COLON] = ACTIONS(3373),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3373),
    [anon_sym___declspec] = ACTIONS(3371),
    [anon_sym___based] = ACTIONS(3371),
    [anon_sym_signed] = ACTIONS(3371),
    [anon_sym_unsigned] = ACTIONS(3371),
    [anon_sym_long] = ACTIONS(3371),
    [anon_sym_short] = ACTIONS(3371),
    [anon_sym_LBRACK] = ACTIONS(3371),
    [anon_sym_static] = ACTIONS(3371),
    [anon_sym_register] = ACTIONS(3371),
    [anon_sym_inline] = ACTIONS(3371),
    [anon_sym___inline] = ACTIONS(3371),
    [anon_sym___inline__] = ACTIONS(3371),
    [anon_sym___forceinline] = ACTIONS(3371),
    [anon_sym_thread_local] = ACTIONS(3371),
    [anon_sym___thread] = ACTIONS(3371),
    [anon_sym_const] = ACTIONS(3371),
    [anon_sym_constexpr] = ACTIONS(3371),
    [anon_sym_volatile] = ACTIONS(3371),
    [anon_sym_restrict] = ACTIONS(3371),
    [anon_sym___restrict__] = ACTIONS(3371),
    [anon_sym__Atomic] = ACTIONS(3371),
    [anon_sym__Noreturn] = ACTIONS(3371),
    [anon_sym_noreturn] = ACTIONS(3371),
    [anon_sym_mutable] = ACTIONS(3371),
    [anon_sym_constinit] = ACTIONS(3371),
    [anon_sym_consteval] = ACTIONS(3371),
    [anon_sym_PROGMEM] = ACTIONS(3371),
    [aux_sym_primitive_type_token1] = ACTIONS(3371),
    [anon_sym_byte] = ACTIONS(3371),
    [anon_sym_word] = ACTIONS(3371),
    [anon_sym_enum] = ACTIONS(3371),
    [anon_sym_class] = ACTIONS(3371),
    [anon_sym_struct] = ACTIONS(3371),
    [anon_sym_union] = ACTIONS(3371),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3371),
    [anon_sym_decltype] = ACTIONS(3371),
    [anon_sym_virtual] = ACTIONS(3371),
    [anon_sym_alignas] = ACTIONS(3371),
    [anon_sym_explicit] = ACTIONS(3371),
    [anon_sym_typename] = ACTIONS(3371),
    [anon_sym_template] = ACTIONS(3371),
    [anon_sym_operator] = ACTIONS(3371),
    [anon_sym_friend] = ACTIONS(3371),
    [anon_sym_public] = ACTIONS(3371),
    [anon_sym_private] = ACTIONS(3371),
    [anon_sym_protected] = ACTIONS(3371),
    [anon_sym_using] = ACTIONS(3371),
    [anon_sym_static_assert] = ACTIONS(3371),
  },
  [2361] = {
    [sym_identifier] = ACTIONS(3178),
    [aux_sym_preproc_def_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3178),
    [aux_sym_preproc_else_token1] = ACTIONS(3178),
    [aux_sym_preproc_elif_token1] = ACTIONS(3178),
    [sym_preproc_directive] = ACTIONS(3178),
    [anon_sym_LPAREN2] = ACTIONS(3180),
    [anon_sym_TILDE] = ACTIONS(3180),
    [anon_sym_STAR] = ACTIONS(3180),
    [anon_sym_AMP_AMP] = ACTIONS(3180),
    [anon_sym_AMP] = ACTIONS(3178),
    [anon_sym___extension__] = ACTIONS(3178),
    [anon_sym_typedef] = ACTIONS(3178),
    [anon_sym_extern] = ACTIONS(3178),
    [anon_sym___attribute__] = ACTIONS(3178),
    [anon_sym_COLON_COLON] = ACTIONS(3180),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3180),
    [anon_sym___declspec] = ACTIONS(3178),
    [anon_sym___based] = ACTIONS(3178),
    [anon_sym_signed] = ACTIONS(3178),
    [anon_sym_unsigned] = ACTIONS(3178),
    [anon_sym_long] = ACTIONS(3178),
    [anon_sym_short] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_static] = ACTIONS(3178),
    [anon_sym_register] = ACTIONS(3178),
    [anon_sym_inline] = ACTIONS(3178),
    [anon_sym___inline] = ACTIONS(3178),
    [anon_sym___inline__] = ACTIONS(3178),
    [anon_sym___forceinline] = ACTIONS(3178),
    [anon_sym_thread_local] = ACTIONS(3178),
    [anon_sym___thread] = ACTIONS(3178),
    [anon_sym_const] = ACTIONS(3178),
    [anon_sym_constexpr] = ACTIONS(3178),
    [anon_sym_volatile] = ACTIONS(3178),
    [anon_sym_restrict] = ACTIONS(3178),
    [anon_sym___restrict__] = ACTIONS(3178),
    [anon_sym__Atomic] = ACTIONS(3178),
    [anon_sym__Noreturn] = ACTIONS(3178),
    [anon_sym_noreturn] = ACTIONS(3178),
    [anon_sym_mutable] = ACTIONS(3178),
    [anon_sym_constinit] = ACTIONS(3178),
    [anon_sym_consteval] = ACTIONS(3178),
    [anon_sym_PROGMEM] = ACTIONS(3178),
    [aux_sym_primitive_type_token1] = ACTIONS(3178),
    [anon_sym_byte] = ACTIONS(3178),
    [anon_sym_word] = ACTIONS(3178),
    [anon_sym_enum] = ACTIONS(3178),
    [anon_sym_class] = ACTIONS(3178),
    [anon_sym_struct] = ACTIONS(3178),
    [anon_sym_union] = ACTIONS(3178),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3178),
    [anon_sym_decltype] = ACTIONS(3178),
    [anon_sym_virtual] = ACTIONS(3178),
    [anon_sym_alignas] = ACTIONS(3178),
    [anon_sym_explicit] = ACTIONS(3178),
    [anon_sym_typename] = ACTIONS(3178),
    [anon_sym_template] = ACTIONS(3178),
    [anon_sym_operator] = ACTIONS(3178),
    [anon_sym_friend] = ACTIONS(3178),
    [anon_sym_public] = ACTIONS(3178),
    [anon_sym_private] = ACTIONS(3178),
    [anon_sym_protected] = ACTIONS(3178),
    [anon_sym_using] = ACTIONS(3178),
    [anon_sym_static_assert] = ACTIONS(3178),
  },
  [2362] = {
    [sym_identifier] = ACTIONS(5526),
    [aux_sym_preproc_def_token1] = ACTIONS(5526),
    [aux_sym_preproc_if_token1] = ACTIONS(5526),
    [aux_sym_preproc_if_token2] = ACTIONS(5526),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5526),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5526),
    [aux_sym_preproc_else_token1] = ACTIONS(5526),
    [aux_sym_preproc_elif_token1] = ACTIONS(5526),
    [sym_preproc_directive] = ACTIONS(5526),
    [anon_sym_LPAREN2] = ACTIONS(5528),
    [anon_sym_TILDE] = ACTIONS(5528),
    [anon_sym_STAR] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5526),
    [anon_sym___extension__] = ACTIONS(5526),
    [anon_sym_typedef] = ACTIONS(5526),
    [anon_sym_extern] = ACTIONS(5526),
    [anon_sym___attribute__] = ACTIONS(5526),
    [anon_sym_COLON_COLON] = ACTIONS(5528),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5528),
    [anon_sym___declspec] = ACTIONS(5526),
    [anon_sym___based] = ACTIONS(5526),
    [anon_sym_signed] = ACTIONS(5526),
    [anon_sym_unsigned] = ACTIONS(5526),
    [anon_sym_long] = ACTIONS(5526),
    [anon_sym_short] = ACTIONS(5526),
    [anon_sym_LBRACK] = ACTIONS(5526),
    [anon_sym_static] = ACTIONS(5526),
    [anon_sym_register] = ACTIONS(5526),
    [anon_sym_inline] = ACTIONS(5526),
    [anon_sym___inline] = ACTIONS(5526),
    [anon_sym___inline__] = ACTIONS(5526),
    [anon_sym___forceinline] = ACTIONS(5526),
    [anon_sym_thread_local] = ACTIONS(5526),
    [anon_sym___thread] = ACTIONS(5526),
    [anon_sym_const] = ACTIONS(5526),
    [anon_sym_constexpr] = ACTIONS(5526),
    [anon_sym_volatile] = ACTIONS(5526),
    [anon_sym_restrict] = ACTIONS(5526),
    [anon_sym___restrict__] = ACTIONS(5526),
    [anon_sym__Atomic] = ACTIONS(5526),
    [anon_sym__Noreturn] = ACTIONS(5526),
    [anon_sym_noreturn] = ACTIONS(5526),
    [anon_sym_mutable] = ACTIONS(5526),
    [anon_sym_constinit] = ACTIONS(5526),
    [anon_sym_consteval] = ACTIONS(5526),
    [anon_sym_PROGMEM] = ACTIONS(5526),
    [aux_sym_primitive_type_token1] = ACTIONS(5526),
    [anon_sym_byte] = ACTIONS(5526),
    [anon_sym_word] = ACTIONS(5526),
    [anon_sym_enum] = ACTIONS(5526),
    [anon_sym_class] = ACTIONS(5526),
    [anon_sym_struct] = ACTIONS(5526),
    [anon_sym_union] = ACTIONS(5526),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5526),
    [anon_sym_decltype] = ACTIONS(5526),
    [anon_sym_virtual] = ACTIONS(5526),
    [anon_sym_alignas] = ACTIONS(5526),
    [anon_sym_explicit] = ACTIONS(5526),
    [anon_sym_typename] = ACTIONS(5526),
    [anon_sym_template] = ACTIONS(5526),
    [anon_sym_operator] = ACTIONS(5526),
    [anon_sym_friend] = ACTIONS(5526),
    [anon_sym_public] = ACTIONS(5526),
    [anon_sym_private] = ACTIONS(5526),
    [anon_sym_protected] = ACTIONS(5526),
    [anon_sym_using] = ACTIONS(5526),
    [anon_sym_static_assert] = ACTIONS(5526),
  },
  [2363] = {
    [sym_identifier] = ACTIONS(3517),
    [aux_sym_preproc_def_token1] = ACTIONS(3517),
    [aux_sym_preproc_if_token1] = ACTIONS(3517),
    [aux_sym_preproc_if_token2] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3517),
    [aux_sym_preproc_else_token1] = ACTIONS(3517),
    [aux_sym_preproc_elif_token1] = ACTIONS(3517),
    [sym_preproc_directive] = ACTIONS(3517),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym___extension__] = ACTIONS(3517),
    [anon_sym_typedef] = ACTIONS(3517),
    [anon_sym_extern] = ACTIONS(3517),
    [anon_sym___attribute__] = ACTIONS(3517),
    [anon_sym_COLON_COLON] = ACTIONS(3519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3519),
    [anon_sym___declspec] = ACTIONS(3517),
    [anon_sym___based] = ACTIONS(3517),
    [anon_sym_signed] = ACTIONS(3517),
    [anon_sym_unsigned] = ACTIONS(3517),
    [anon_sym_long] = ACTIONS(3517),
    [anon_sym_short] = ACTIONS(3517),
    [anon_sym_LBRACK] = ACTIONS(3517),
    [anon_sym_static] = ACTIONS(3517),
    [anon_sym_register] = ACTIONS(3517),
    [anon_sym_inline] = ACTIONS(3517),
    [anon_sym___inline] = ACTIONS(3517),
    [anon_sym___inline__] = ACTIONS(3517),
    [anon_sym___forceinline] = ACTIONS(3517),
    [anon_sym_thread_local] = ACTIONS(3517),
    [anon_sym___thread] = ACTIONS(3517),
    [anon_sym_const] = ACTIONS(3517),
    [anon_sym_constexpr] = ACTIONS(3517),
    [anon_sym_volatile] = ACTIONS(3517),
    [anon_sym_restrict] = ACTIONS(3517),
    [anon_sym___restrict__] = ACTIONS(3517),
    [anon_sym__Atomic] = ACTIONS(3517),
    [anon_sym__Noreturn] = ACTIONS(3517),
    [anon_sym_noreturn] = ACTIONS(3517),
    [anon_sym_mutable] = ACTIONS(3517),
    [anon_sym_constinit] = ACTIONS(3517),
    [anon_sym_consteval] = ACTIONS(3517),
    [anon_sym_PROGMEM] = ACTIONS(3517),
    [aux_sym_primitive_type_token1] = ACTIONS(3517),
    [anon_sym_byte] = ACTIONS(3517),
    [anon_sym_word] = ACTIONS(3517),
    [anon_sym_enum] = ACTIONS(3517),
    [anon_sym_class] = ACTIONS(3517),
    [anon_sym_struct] = ACTIONS(3517),
    [anon_sym_union] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3517),
    [anon_sym_decltype] = ACTIONS(3517),
    [anon_sym_virtual] = ACTIONS(3517),
    [anon_sym_alignas] = ACTIONS(3517),
    [anon_sym_explicit] = ACTIONS(3517),
    [anon_sym_typename] = ACTIONS(3517),
    [anon_sym_template] = ACTIONS(3517),
    [anon_sym_operator] = ACTIONS(3517),
    [anon_sym_friend] = ACTIONS(3517),
    [anon_sym_public] = ACTIONS(3517),
    [anon_sym_private] = ACTIONS(3517),
    [anon_sym_protected] = ACTIONS(3517),
    [anon_sym_using] = ACTIONS(3517),
    [anon_sym_static_assert] = ACTIONS(3517),
  },
  [2364] = {
    [sym_identifier] = ACTIONS(5530),
    [aux_sym_preproc_def_token1] = ACTIONS(5530),
    [aux_sym_preproc_if_token1] = ACTIONS(5530),
    [aux_sym_preproc_if_token2] = ACTIONS(5530),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5530),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5530),
    [aux_sym_preproc_else_token1] = ACTIONS(5530),
    [aux_sym_preproc_elif_token1] = ACTIONS(5530),
    [sym_preproc_directive] = ACTIONS(5530),
    [anon_sym_LPAREN2] = ACTIONS(5532),
    [anon_sym_TILDE] = ACTIONS(5532),
    [anon_sym_STAR] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5530),
    [anon_sym___extension__] = ACTIONS(5530),
    [anon_sym_typedef] = ACTIONS(5530),
    [anon_sym_extern] = ACTIONS(5530),
    [anon_sym___attribute__] = ACTIONS(5530),
    [anon_sym_COLON_COLON] = ACTIONS(5532),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5532),
    [anon_sym___declspec] = ACTIONS(5530),
    [anon_sym___based] = ACTIONS(5530),
    [anon_sym_signed] = ACTIONS(5530),
    [anon_sym_unsigned] = ACTIONS(5530),
    [anon_sym_long] = ACTIONS(5530),
    [anon_sym_short] = ACTIONS(5530),
    [anon_sym_LBRACK] = ACTIONS(5530),
    [anon_sym_static] = ACTIONS(5530),
    [anon_sym_register] = ACTIONS(5530),
    [anon_sym_inline] = ACTIONS(5530),
    [anon_sym___inline] = ACTIONS(5530),
    [anon_sym___inline__] = ACTIONS(5530),
    [anon_sym___forceinline] = ACTIONS(5530),
    [anon_sym_thread_local] = ACTIONS(5530),
    [anon_sym___thread] = ACTIONS(5530),
    [anon_sym_const] = ACTIONS(5530),
    [anon_sym_constexpr] = ACTIONS(5530),
    [anon_sym_volatile] = ACTIONS(5530),
    [anon_sym_restrict] = ACTIONS(5530),
    [anon_sym___restrict__] = ACTIONS(5530),
    [anon_sym__Atomic] = ACTIONS(5530),
    [anon_sym__Noreturn] = ACTIONS(5530),
    [anon_sym_noreturn] = ACTIONS(5530),
    [anon_sym_mutable] = ACTIONS(5530),
    [anon_sym_constinit] = ACTIONS(5530),
    [anon_sym_consteval] = ACTIONS(5530),
    [anon_sym_PROGMEM] = ACTIONS(5530),
    [aux_sym_primitive_type_token1] = ACTIONS(5530),
    [anon_sym_byte] = ACTIONS(5530),
    [anon_sym_word] = ACTIONS(5530),
    [anon_sym_enum] = ACTIONS(5530),
    [anon_sym_class] = ACTIONS(5530),
    [anon_sym_struct] = ACTIONS(5530),
    [anon_sym_union] = ACTIONS(5530),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5530),
    [anon_sym_decltype] = ACTIONS(5530),
    [anon_sym_virtual] = ACTIONS(5530),
    [anon_sym_alignas] = ACTIONS(5530),
    [anon_sym_explicit] = ACTIONS(5530),
    [anon_sym_typename] = ACTIONS(5530),
    [anon_sym_template] = ACTIONS(5530),
    [anon_sym_operator] = ACTIONS(5530),
    [anon_sym_friend] = ACTIONS(5530),
    [anon_sym_public] = ACTIONS(5530),
    [anon_sym_private] = ACTIONS(5530),
    [anon_sym_protected] = ACTIONS(5530),
    [anon_sym_using] = ACTIONS(5530),
    [anon_sym_static_assert] = ACTIONS(5530),
  },
  [2365] = {
    [sym_string_literal] = STATE(2067),
    [sym_raw_string_literal] = STATE(2067),
    [sym_identifier] = ACTIONS(4256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [aux_sym_preproc_if_token2] = ACTIONS(4248),
    [aux_sym_preproc_else_token1] = ACTIONS(4248),
    [aux_sym_preproc_elif_token1] = ACTIONS(4256),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4248),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(4256),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4256),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4248),
    [anon_sym_SLASH_EQ] = ACTIONS(4248),
    [anon_sym_PERCENT_EQ] = ACTIONS(4248),
    [anon_sym_PLUS_EQ] = ACTIONS(4248),
    [anon_sym_DASH_EQ] = ACTIONS(4248),
    [anon_sym_LT_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT_GT_EQ] = ACTIONS(4248),
    [anon_sym_AMP_EQ] = ACTIONS(4248),
    [anon_sym_CARET_EQ] = ACTIONS(4248),
    [anon_sym_PIPE_EQ] = ACTIONS(4248),
    [anon_sym_and_eq] = ACTIONS(4256),
    [anon_sym_or_eq] = ACTIONS(4256),
    [anon_sym_xor_eq] = ACTIONS(4256),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4256),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4256),
    [anon_sym_not_eq] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [sym_literal_suffix] = ACTIONS(5801),
  },
  [2366] = {
    [sym_identifier] = ACTIONS(5526),
    [aux_sym_preproc_def_token1] = ACTIONS(5526),
    [aux_sym_preproc_if_token1] = ACTIONS(5526),
    [aux_sym_preproc_if_token2] = ACTIONS(5526),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5526),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5526),
    [aux_sym_preproc_else_token1] = ACTIONS(5526),
    [aux_sym_preproc_elif_token1] = ACTIONS(5526),
    [sym_preproc_directive] = ACTIONS(5526),
    [anon_sym_LPAREN2] = ACTIONS(5528),
    [anon_sym_TILDE] = ACTIONS(5528),
    [anon_sym_STAR] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5526),
    [anon_sym___extension__] = ACTIONS(5526),
    [anon_sym_typedef] = ACTIONS(5526),
    [anon_sym_extern] = ACTIONS(5526),
    [anon_sym___attribute__] = ACTIONS(5526),
    [anon_sym_COLON_COLON] = ACTIONS(5528),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5528),
    [anon_sym___declspec] = ACTIONS(5526),
    [anon_sym___based] = ACTIONS(5526),
    [anon_sym_signed] = ACTIONS(5526),
    [anon_sym_unsigned] = ACTIONS(5526),
    [anon_sym_long] = ACTIONS(5526),
    [anon_sym_short] = ACTIONS(5526),
    [anon_sym_LBRACK] = ACTIONS(5526),
    [anon_sym_static] = ACTIONS(5526),
    [anon_sym_register] = ACTIONS(5526),
    [anon_sym_inline] = ACTIONS(5526),
    [anon_sym___inline] = ACTIONS(5526),
    [anon_sym___inline__] = ACTIONS(5526),
    [anon_sym___forceinline] = ACTIONS(5526),
    [anon_sym_thread_local] = ACTIONS(5526),
    [anon_sym___thread] = ACTIONS(5526),
    [anon_sym_const] = ACTIONS(5526),
    [anon_sym_constexpr] = ACTIONS(5526),
    [anon_sym_volatile] = ACTIONS(5526),
    [anon_sym_restrict] = ACTIONS(5526),
    [anon_sym___restrict__] = ACTIONS(5526),
    [anon_sym__Atomic] = ACTIONS(5526),
    [anon_sym__Noreturn] = ACTIONS(5526),
    [anon_sym_noreturn] = ACTIONS(5526),
    [anon_sym_mutable] = ACTIONS(5526),
    [anon_sym_constinit] = ACTIONS(5526),
    [anon_sym_consteval] = ACTIONS(5526),
    [anon_sym_PROGMEM] = ACTIONS(5526),
    [aux_sym_primitive_type_token1] = ACTIONS(5526),
    [anon_sym_byte] = ACTIONS(5526),
    [anon_sym_word] = ACTIONS(5526),
    [anon_sym_enum] = ACTIONS(5526),
    [anon_sym_class] = ACTIONS(5526),
    [anon_sym_struct] = ACTIONS(5526),
    [anon_sym_union] = ACTIONS(5526),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5526),
    [anon_sym_decltype] = ACTIONS(5526),
    [anon_sym_virtual] = ACTIONS(5526),
    [anon_sym_alignas] = ACTIONS(5526),
    [anon_sym_explicit] = ACTIONS(5526),
    [anon_sym_typename] = ACTIONS(5526),
    [anon_sym_template] = ACTIONS(5526),
    [anon_sym_operator] = ACTIONS(5526),
    [anon_sym_friend] = ACTIONS(5526),
    [anon_sym_public] = ACTIONS(5526),
    [anon_sym_private] = ACTIONS(5526),
    [anon_sym_protected] = ACTIONS(5526),
    [anon_sym_using] = ACTIONS(5526),
    [anon_sym_static_assert] = ACTIONS(5526),
  },
  [2367] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [anon_sym_COMMA] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token2] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(5405),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_friend] = ACTIONS(2267),
    [anon_sym_public] = ACTIONS(2267),
    [anon_sym_private] = ACTIONS(2267),
    [anon_sym_protected] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
  },
  [2368] = {
    [sym_identifier] = ACTIONS(3293),
    [aux_sym_preproc_def_token1] = ACTIONS(3293),
    [aux_sym_preproc_if_token1] = ACTIONS(3293),
    [aux_sym_preproc_if_token2] = ACTIONS(3293),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3293),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3293),
    [aux_sym_preproc_else_token1] = ACTIONS(3293),
    [aux_sym_preproc_elif_token1] = ACTIONS(3293),
    [sym_preproc_directive] = ACTIONS(3293),
    [anon_sym_LPAREN2] = ACTIONS(3295),
    [anon_sym_TILDE] = ACTIONS(3295),
    [anon_sym_STAR] = ACTIONS(3295),
    [anon_sym_AMP_AMP] = ACTIONS(3295),
    [anon_sym_AMP] = ACTIONS(3293),
    [anon_sym___extension__] = ACTIONS(3293),
    [anon_sym_typedef] = ACTIONS(3293),
    [anon_sym_extern] = ACTIONS(3293),
    [anon_sym___attribute__] = ACTIONS(3293),
    [anon_sym_COLON_COLON] = ACTIONS(3295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3295),
    [anon_sym___declspec] = ACTIONS(3293),
    [anon_sym___based] = ACTIONS(3293),
    [anon_sym_signed] = ACTIONS(3293),
    [anon_sym_unsigned] = ACTIONS(3293),
    [anon_sym_long] = ACTIONS(3293),
    [anon_sym_short] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_static] = ACTIONS(3293),
    [anon_sym_register] = ACTIONS(3293),
    [anon_sym_inline] = ACTIONS(3293),
    [anon_sym___inline] = ACTIONS(3293),
    [anon_sym___inline__] = ACTIONS(3293),
    [anon_sym___forceinline] = ACTIONS(3293),
    [anon_sym_thread_local] = ACTIONS(3293),
    [anon_sym___thread] = ACTIONS(3293),
    [anon_sym_const] = ACTIONS(3293),
    [anon_sym_constexpr] = ACTIONS(3293),
    [anon_sym_volatile] = ACTIONS(3293),
    [anon_sym_restrict] = ACTIONS(3293),
    [anon_sym___restrict__] = ACTIONS(3293),
    [anon_sym__Atomic] = ACTIONS(3293),
    [anon_sym__Noreturn] = ACTIONS(3293),
    [anon_sym_noreturn] = ACTIONS(3293),
    [anon_sym_mutable] = ACTIONS(3293),
    [anon_sym_constinit] = ACTIONS(3293),
    [anon_sym_consteval] = ACTIONS(3293),
    [anon_sym_PROGMEM] = ACTIONS(3293),
    [aux_sym_primitive_type_token1] = ACTIONS(3293),
    [anon_sym_byte] = ACTIONS(3293),
    [anon_sym_word] = ACTIONS(3293),
    [anon_sym_enum] = ACTIONS(3293),
    [anon_sym_class] = ACTIONS(3293),
    [anon_sym_struct] = ACTIONS(3293),
    [anon_sym_union] = ACTIONS(3293),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3293),
    [anon_sym_decltype] = ACTIONS(3293),
    [anon_sym_virtual] = ACTIONS(3293),
    [anon_sym_alignas] = ACTIONS(3293),
    [anon_sym_explicit] = ACTIONS(3293),
    [anon_sym_typename] = ACTIONS(3293),
    [anon_sym_template] = ACTIONS(3293),
    [anon_sym_operator] = ACTIONS(3293),
    [anon_sym_friend] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3293),
    [anon_sym_private] = ACTIONS(3293),
    [anon_sym_protected] = ACTIONS(3293),
    [anon_sym_using] = ACTIONS(3293),
    [anon_sym_static_assert] = ACTIONS(3293),
  },
  [2369] = {
    [sym_identifier] = ACTIONS(5538),
    [aux_sym_preproc_def_token1] = ACTIONS(5538),
    [aux_sym_preproc_if_token1] = ACTIONS(5538),
    [aux_sym_preproc_if_token2] = ACTIONS(5538),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5538),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5538),
    [aux_sym_preproc_else_token1] = ACTIONS(5538),
    [aux_sym_preproc_elif_token1] = ACTIONS(5538),
    [sym_preproc_directive] = ACTIONS(5538),
    [anon_sym_LPAREN2] = ACTIONS(5540),
    [anon_sym_TILDE] = ACTIONS(5540),
    [anon_sym_STAR] = ACTIONS(5540),
    [anon_sym_AMP_AMP] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5538),
    [anon_sym_typedef] = ACTIONS(5538),
    [anon_sym_extern] = ACTIONS(5538),
    [anon_sym___attribute__] = ACTIONS(5538),
    [anon_sym_COLON_COLON] = ACTIONS(5540),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5540),
    [anon_sym___declspec] = ACTIONS(5538),
    [anon_sym___based] = ACTIONS(5538),
    [anon_sym_signed] = ACTIONS(5538),
    [anon_sym_unsigned] = ACTIONS(5538),
    [anon_sym_long] = ACTIONS(5538),
    [anon_sym_short] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(5538),
    [anon_sym_static] = ACTIONS(5538),
    [anon_sym_register] = ACTIONS(5538),
    [anon_sym_inline] = ACTIONS(5538),
    [anon_sym___inline] = ACTIONS(5538),
    [anon_sym___inline__] = ACTIONS(5538),
    [anon_sym___forceinline] = ACTIONS(5538),
    [anon_sym_thread_local] = ACTIONS(5538),
    [anon_sym___thread] = ACTIONS(5538),
    [anon_sym_const] = ACTIONS(5538),
    [anon_sym_constexpr] = ACTIONS(5538),
    [anon_sym_volatile] = ACTIONS(5538),
    [anon_sym_restrict] = ACTIONS(5538),
    [anon_sym___restrict__] = ACTIONS(5538),
    [anon_sym__Atomic] = ACTIONS(5538),
    [anon_sym__Noreturn] = ACTIONS(5538),
    [anon_sym_noreturn] = ACTIONS(5538),
    [anon_sym_mutable] = ACTIONS(5538),
    [anon_sym_constinit] = ACTIONS(5538),
    [anon_sym_consteval] = ACTIONS(5538),
    [anon_sym_PROGMEM] = ACTIONS(5538),
    [aux_sym_primitive_type_token1] = ACTIONS(5538),
    [anon_sym_byte] = ACTIONS(5538),
    [anon_sym_word] = ACTIONS(5538),
    [anon_sym_enum] = ACTIONS(5538),
    [anon_sym_class] = ACTIONS(5538),
    [anon_sym_struct] = ACTIONS(5538),
    [anon_sym_union] = ACTIONS(5538),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5538),
    [anon_sym_decltype] = ACTIONS(5538),
    [anon_sym_virtual] = ACTIONS(5538),
    [anon_sym_alignas] = ACTIONS(5538),
    [anon_sym_explicit] = ACTIONS(5538),
    [anon_sym_typename] = ACTIONS(5538),
    [anon_sym_template] = ACTIONS(5538),
    [anon_sym_operator] = ACTIONS(5538),
    [anon_sym_friend] = ACTIONS(5538),
    [anon_sym_public] = ACTIONS(5538),
    [anon_sym_private] = ACTIONS(5538),
    [anon_sym_protected] = ACTIONS(5538),
    [anon_sym_using] = ACTIONS(5538),
    [anon_sym_static_assert] = ACTIONS(5538),
  },
  [2370] = {
    [sym_identifier] = ACTIONS(5443),
    [aux_sym_preproc_def_token1] = ACTIONS(5443),
    [aux_sym_preproc_if_token1] = ACTIONS(5443),
    [aux_sym_preproc_if_token2] = ACTIONS(5443),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5443),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5443),
    [aux_sym_preproc_else_token1] = ACTIONS(5443),
    [aux_sym_preproc_elif_token1] = ACTIONS(5443),
    [sym_preproc_directive] = ACTIONS(5443),
    [anon_sym_LPAREN2] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_STAR] = ACTIONS(5445),
    [anon_sym_AMP_AMP] = ACTIONS(5445),
    [anon_sym_AMP] = ACTIONS(5443),
    [anon_sym___extension__] = ACTIONS(5443),
    [anon_sym_typedef] = ACTIONS(5443),
    [anon_sym_extern] = ACTIONS(5443),
    [anon_sym___attribute__] = ACTIONS(5443),
    [anon_sym_COLON_COLON] = ACTIONS(5445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5445),
    [anon_sym___declspec] = ACTIONS(5443),
    [anon_sym___based] = ACTIONS(5443),
    [anon_sym_signed] = ACTIONS(5443),
    [anon_sym_unsigned] = ACTIONS(5443),
    [anon_sym_long] = ACTIONS(5443),
    [anon_sym_short] = ACTIONS(5443),
    [anon_sym_LBRACK] = ACTIONS(5443),
    [anon_sym_static] = ACTIONS(5443),
    [anon_sym_register] = ACTIONS(5443),
    [anon_sym_inline] = ACTIONS(5443),
    [anon_sym___inline] = ACTIONS(5443),
    [anon_sym___inline__] = ACTIONS(5443),
    [anon_sym___forceinline] = ACTIONS(5443),
    [anon_sym_thread_local] = ACTIONS(5443),
    [anon_sym___thread] = ACTIONS(5443),
    [anon_sym_const] = ACTIONS(5443),
    [anon_sym_constexpr] = ACTIONS(5443),
    [anon_sym_volatile] = ACTIONS(5443),
    [anon_sym_restrict] = ACTIONS(5443),
    [anon_sym___restrict__] = ACTIONS(5443),
    [anon_sym__Atomic] = ACTIONS(5443),
    [anon_sym__Noreturn] = ACTIONS(5443),
    [anon_sym_noreturn] = ACTIONS(5443),
    [anon_sym_mutable] = ACTIONS(5443),
    [anon_sym_constinit] = ACTIONS(5443),
    [anon_sym_consteval] = ACTIONS(5443),
    [anon_sym_PROGMEM] = ACTIONS(5443),
    [aux_sym_primitive_type_token1] = ACTIONS(5443),
    [anon_sym_byte] = ACTIONS(5443),
    [anon_sym_word] = ACTIONS(5443),
    [anon_sym_enum] = ACTIONS(5443),
    [anon_sym_class] = ACTIONS(5443),
    [anon_sym_struct] = ACTIONS(5443),
    [anon_sym_union] = ACTIONS(5443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5443),
    [anon_sym_decltype] = ACTIONS(5443),
    [anon_sym_virtual] = ACTIONS(5443),
    [anon_sym_alignas] = ACTIONS(5443),
    [anon_sym_explicit] = ACTIONS(5443),
    [anon_sym_typename] = ACTIONS(5443),
    [anon_sym_template] = ACTIONS(5443),
    [anon_sym_operator] = ACTIONS(5443),
    [anon_sym_friend] = ACTIONS(5443),
    [anon_sym_public] = ACTIONS(5443),
    [anon_sym_private] = ACTIONS(5443),
    [anon_sym_protected] = ACTIONS(5443),
    [anon_sym_using] = ACTIONS(5443),
    [anon_sym_static_assert] = ACTIONS(5443),
  },
  [2371] = {
    [sym_identifier] = ACTIONS(5594),
    [aux_sym_preproc_def_token1] = ACTIONS(5594),
    [aux_sym_preproc_if_token1] = ACTIONS(5594),
    [aux_sym_preproc_if_token2] = ACTIONS(5594),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5594),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5594),
    [aux_sym_preproc_else_token1] = ACTIONS(5594),
    [aux_sym_preproc_elif_token1] = ACTIONS(5594),
    [sym_preproc_directive] = ACTIONS(5594),
    [anon_sym_LPAREN2] = ACTIONS(5596),
    [anon_sym_TILDE] = ACTIONS(5596),
    [anon_sym_STAR] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5594),
    [anon_sym___extension__] = ACTIONS(5594),
    [anon_sym_typedef] = ACTIONS(5594),
    [anon_sym_extern] = ACTIONS(5594),
    [anon_sym___attribute__] = ACTIONS(5594),
    [anon_sym_COLON_COLON] = ACTIONS(5596),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5596),
    [anon_sym___declspec] = ACTIONS(5594),
    [anon_sym___based] = ACTIONS(5594),
    [anon_sym_signed] = ACTIONS(5594),
    [anon_sym_unsigned] = ACTIONS(5594),
    [anon_sym_long] = ACTIONS(5594),
    [anon_sym_short] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_static] = ACTIONS(5594),
    [anon_sym_register] = ACTIONS(5594),
    [anon_sym_inline] = ACTIONS(5594),
    [anon_sym___inline] = ACTIONS(5594),
    [anon_sym___inline__] = ACTIONS(5594),
    [anon_sym___forceinline] = ACTIONS(5594),
    [anon_sym_thread_local] = ACTIONS(5594),
    [anon_sym___thread] = ACTIONS(5594),
    [anon_sym_const] = ACTIONS(5594),
    [anon_sym_constexpr] = ACTIONS(5594),
    [anon_sym_volatile] = ACTIONS(5594),
    [anon_sym_restrict] = ACTIONS(5594),
    [anon_sym___restrict__] = ACTIONS(5594),
    [anon_sym__Atomic] = ACTIONS(5594),
    [anon_sym__Noreturn] = ACTIONS(5594),
    [anon_sym_noreturn] = ACTIONS(5594),
    [anon_sym_mutable] = ACTIONS(5594),
    [anon_sym_constinit] = ACTIONS(5594),
    [anon_sym_consteval] = ACTIONS(5594),
    [anon_sym_PROGMEM] = ACTIONS(5594),
    [aux_sym_primitive_type_token1] = ACTIONS(5594),
    [anon_sym_byte] = ACTIONS(5594),
    [anon_sym_word] = ACTIONS(5594),
    [anon_sym_enum] = ACTIONS(5594),
    [anon_sym_class] = ACTIONS(5594),
    [anon_sym_struct] = ACTIONS(5594),
    [anon_sym_union] = ACTIONS(5594),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5594),
    [anon_sym_decltype] = ACTIONS(5594),
    [anon_sym_virtual] = ACTIONS(5594),
    [anon_sym_alignas] = ACTIONS(5594),
    [anon_sym_explicit] = ACTIONS(5594),
    [anon_sym_typename] = ACTIONS(5594),
    [anon_sym_template] = ACTIONS(5594),
    [anon_sym_operator] = ACTIONS(5594),
    [anon_sym_friend] = ACTIONS(5594),
    [anon_sym_public] = ACTIONS(5594),
    [anon_sym_private] = ACTIONS(5594),
    [anon_sym_protected] = ACTIONS(5594),
    [anon_sym_using] = ACTIONS(5594),
    [anon_sym_static_assert] = ACTIONS(5594),
  },
  [2372] = {
    [sym_identifier] = ACTIONS(3280),
    [aux_sym_preproc_def_token1] = ACTIONS(3280),
    [aux_sym_preproc_if_token1] = ACTIONS(3280),
    [aux_sym_preproc_if_token2] = ACTIONS(3280),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3280),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3280),
    [aux_sym_preproc_else_token1] = ACTIONS(3280),
    [aux_sym_preproc_elif_token1] = ACTIONS(3280),
    [sym_preproc_directive] = ACTIONS(3280),
    [anon_sym_LPAREN2] = ACTIONS(3282),
    [anon_sym_TILDE] = ACTIONS(3282),
    [anon_sym_STAR] = ACTIONS(3282),
    [anon_sym_AMP_AMP] = ACTIONS(3282),
    [anon_sym_AMP] = ACTIONS(3280),
    [anon_sym___extension__] = ACTIONS(3280),
    [anon_sym_typedef] = ACTIONS(3280),
    [anon_sym_extern] = ACTIONS(3280),
    [anon_sym___attribute__] = ACTIONS(3280),
    [anon_sym_COLON_COLON] = ACTIONS(3282),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3282),
    [anon_sym___declspec] = ACTIONS(3280),
    [anon_sym___based] = ACTIONS(3280),
    [anon_sym_signed] = ACTIONS(3280),
    [anon_sym_unsigned] = ACTIONS(3280),
    [anon_sym_long] = ACTIONS(3280),
    [anon_sym_short] = ACTIONS(3280),
    [anon_sym_LBRACK] = ACTIONS(3280),
    [anon_sym_static] = ACTIONS(3280),
    [anon_sym_register] = ACTIONS(3280),
    [anon_sym_inline] = ACTIONS(3280),
    [anon_sym___inline] = ACTIONS(3280),
    [anon_sym___inline__] = ACTIONS(3280),
    [anon_sym___forceinline] = ACTIONS(3280),
    [anon_sym_thread_local] = ACTIONS(3280),
    [anon_sym___thread] = ACTIONS(3280),
    [anon_sym_const] = ACTIONS(3280),
    [anon_sym_constexpr] = ACTIONS(3280),
    [anon_sym_volatile] = ACTIONS(3280),
    [anon_sym_restrict] = ACTIONS(3280),
    [anon_sym___restrict__] = ACTIONS(3280),
    [anon_sym__Atomic] = ACTIONS(3280),
    [anon_sym__Noreturn] = ACTIONS(3280),
    [anon_sym_noreturn] = ACTIONS(3280),
    [anon_sym_mutable] = ACTIONS(3280),
    [anon_sym_constinit] = ACTIONS(3280),
    [anon_sym_consteval] = ACTIONS(3280),
    [anon_sym_PROGMEM] = ACTIONS(3280),
    [aux_sym_primitive_type_token1] = ACTIONS(3280),
    [anon_sym_byte] = ACTIONS(3280),
    [anon_sym_word] = ACTIONS(3280),
    [anon_sym_enum] = ACTIONS(3280),
    [anon_sym_class] = ACTIONS(3280),
    [anon_sym_struct] = ACTIONS(3280),
    [anon_sym_union] = ACTIONS(3280),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3280),
    [anon_sym_decltype] = ACTIONS(3280),
    [anon_sym_virtual] = ACTIONS(3280),
    [anon_sym_alignas] = ACTIONS(3280),
    [anon_sym_explicit] = ACTIONS(3280),
    [anon_sym_typename] = ACTIONS(3280),
    [anon_sym_template] = ACTIONS(3280),
    [anon_sym_operator] = ACTIONS(3280),
    [anon_sym_friend] = ACTIONS(3280),
    [anon_sym_public] = ACTIONS(3280),
    [anon_sym_private] = ACTIONS(3280),
    [anon_sym_protected] = ACTIONS(3280),
    [anon_sym_using] = ACTIONS(3280),
    [anon_sym_static_assert] = ACTIONS(3280),
  },
  [2373] = {
    [sym_identifier] = ACTIONS(5554),
    [aux_sym_preproc_def_token1] = ACTIONS(5554),
    [aux_sym_preproc_if_token1] = ACTIONS(5554),
    [aux_sym_preproc_if_token2] = ACTIONS(5554),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5554),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5554),
    [aux_sym_preproc_else_token1] = ACTIONS(5554),
    [aux_sym_preproc_elif_token1] = ACTIONS(5554),
    [sym_preproc_directive] = ACTIONS(5554),
    [anon_sym_LPAREN2] = ACTIONS(5556),
    [anon_sym_TILDE] = ACTIONS(5556),
    [anon_sym_STAR] = ACTIONS(5556),
    [anon_sym_AMP_AMP] = ACTIONS(5556),
    [anon_sym_AMP] = ACTIONS(5554),
    [anon_sym___extension__] = ACTIONS(5554),
    [anon_sym_typedef] = ACTIONS(5554),
    [anon_sym_extern] = ACTIONS(5554),
    [anon_sym___attribute__] = ACTIONS(5554),
    [anon_sym_COLON_COLON] = ACTIONS(5556),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5556),
    [anon_sym___declspec] = ACTIONS(5554),
    [anon_sym___based] = ACTIONS(5554),
    [anon_sym_signed] = ACTIONS(5554),
    [anon_sym_unsigned] = ACTIONS(5554),
    [anon_sym_long] = ACTIONS(5554),
    [anon_sym_short] = ACTIONS(5554),
    [anon_sym_LBRACK] = ACTIONS(5554),
    [anon_sym_static] = ACTIONS(5554),
    [anon_sym_register] = ACTIONS(5554),
    [anon_sym_inline] = ACTIONS(5554),
    [anon_sym___inline] = ACTIONS(5554),
    [anon_sym___inline__] = ACTIONS(5554),
    [anon_sym___forceinline] = ACTIONS(5554),
    [anon_sym_thread_local] = ACTIONS(5554),
    [anon_sym___thread] = ACTIONS(5554),
    [anon_sym_const] = ACTIONS(5554),
    [anon_sym_constexpr] = ACTIONS(5554),
    [anon_sym_volatile] = ACTIONS(5554),
    [anon_sym_restrict] = ACTIONS(5554),
    [anon_sym___restrict__] = ACTIONS(5554),
    [anon_sym__Atomic] = ACTIONS(5554),
    [anon_sym__Noreturn] = ACTIONS(5554),
    [anon_sym_noreturn] = ACTIONS(5554),
    [anon_sym_mutable] = ACTIONS(5554),
    [anon_sym_constinit] = ACTIONS(5554),
    [anon_sym_consteval] = ACTIONS(5554),
    [anon_sym_PROGMEM] = ACTIONS(5554),
    [aux_sym_primitive_type_token1] = ACTIONS(5554),
    [anon_sym_byte] = ACTIONS(5554),
    [anon_sym_word] = ACTIONS(5554),
    [anon_sym_enum] = ACTIONS(5554),
    [anon_sym_class] = ACTIONS(5554),
    [anon_sym_struct] = ACTIONS(5554),
    [anon_sym_union] = ACTIONS(5554),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5554),
    [anon_sym_decltype] = ACTIONS(5554),
    [anon_sym_virtual] = ACTIONS(5554),
    [anon_sym_alignas] = ACTIONS(5554),
    [anon_sym_explicit] = ACTIONS(5554),
    [anon_sym_typename] = ACTIONS(5554),
    [anon_sym_template] = ACTIONS(5554),
    [anon_sym_operator] = ACTIONS(5554),
    [anon_sym_friend] = ACTIONS(5554),
    [anon_sym_public] = ACTIONS(5554),
    [anon_sym_private] = ACTIONS(5554),
    [anon_sym_protected] = ACTIONS(5554),
    [anon_sym_using] = ACTIONS(5554),
    [anon_sym_static_assert] = ACTIONS(5554),
  },
  [2374] = {
    [sym_identifier] = ACTIONS(5522),
    [aux_sym_preproc_def_token1] = ACTIONS(5522),
    [aux_sym_preproc_if_token1] = ACTIONS(5522),
    [aux_sym_preproc_if_token2] = ACTIONS(5522),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5522),
    [aux_sym_preproc_else_token1] = ACTIONS(5522),
    [aux_sym_preproc_elif_token1] = ACTIONS(5522),
    [sym_preproc_directive] = ACTIONS(5522),
    [anon_sym_LPAREN2] = ACTIONS(5524),
    [anon_sym_TILDE] = ACTIONS(5524),
    [anon_sym_STAR] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5522),
    [anon_sym___extension__] = ACTIONS(5522),
    [anon_sym_typedef] = ACTIONS(5522),
    [anon_sym_extern] = ACTIONS(5522),
    [anon_sym___attribute__] = ACTIONS(5522),
    [anon_sym_COLON_COLON] = ACTIONS(5524),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5524),
    [anon_sym___declspec] = ACTIONS(5522),
    [anon_sym___based] = ACTIONS(5522),
    [anon_sym_signed] = ACTIONS(5522),
    [anon_sym_unsigned] = ACTIONS(5522),
    [anon_sym_long] = ACTIONS(5522),
    [anon_sym_short] = ACTIONS(5522),
    [anon_sym_LBRACK] = ACTIONS(5522),
    [anon_sym_static] = ACTIONS(5522),
    [anon_sym_register] = ACTIONS(5522),
    [anon_sym_inline] = ACTIONS(5522),
    [anon_sym___inline] = ACTIONS(5522),
    [anon_sym___inline__] = ACTIONS(5522),
    [anon_sym___forceinline] = ACTIONS(5522),
    [anon_sym_thread_local] = ACTIONS(5522),
    [anon_sym___thread] = ACTIONS(5522),
    [anon_sym_const] = ACTIONS(5522),
    [anon_sym_constexpr] = ACTIONS(5522),
    [anon_sym_volatile] = ACTIONS(5522),
    [anon_sym_restrict] = ACTIONS(5522),
    [anon_sym___restrict__] = ACTIONS(5522),
    [anon_sym__Atomic] = ACTIONS(5522),
    [anon_sym__Noreturn] = ACTIONS(5522),
    [anon_sym_noreturn] = ACTIONS(5522),
    [anon_sym_mutable] = ACTIONS(5522),
    [anon_sym_constinit] = ACTIONS(5522),
    [anon_sym_consteval] = ACTIONS(5522),
    [anon_sym_PROGMEM] = ACTIONS(5522),
    [aux_sym_primitive_type_token1] = ACTIONS(5522),
    [anon_sym_byte] = ACTIONS(5522),
    [anon_sym_word] = ACTIONS(5522),
    [anon_sym_enum] = ACTIONS(5522),
    [anon_sym_class] = ACTIONS(5522),
    [anon_sym_struct] = ACTIONS(5522),
    [anon_sym_union] = ACTIONS(5522),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5522),
    [anon_sym_decltype] = ACTIONS(5522),
    [anon_sym_virtual] = ACTIONS(5522),
    [anon_sym_alignas] = ACTIONS(5522),
    [anon_sym_explicit] = ACTIONS(5522),
    [anon_sym_typename] = ACTIONS(5522),
    [anon_sym_template] = ACTIONS(5522),
    [anon_sym_operator] = ACTIONS(5522),
    [anon_sym_friend] = ACTIONS(5522),
    [anon_sym_public] = ACTIONS(5522),
    [anon_sym_private] = ACTIONS(5522),
    [anon_sym_protected] = ACTIONS(5522),
    [anon_sym_using] = ACTIONS(5522),
    [anon_sym_static_assert] = ACTIONS(5522),
  },
  [2375] = {
    [sym_identifier] = ACTIONS(5518),
    [aux_sym_preproc_def_token1] = ACTIONS(5518),
    [aux_sym_preproc_if_token1] = ACTIONS(5518),
    [aux_sym_preproc_if_token2] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5518),
    [aux_sym_preproc_else_token1] = ACTIONS(5518),
    [aux_sym_preproc_elif_token1] = ACTIONS(5518),
    [sym_preproc_directive] = ACTIONS(5518),
    [anon_sym_LPAREN2] = ACTIONS(5520),
    [anon_sym_TILDE] = ACTIONS(5520),
    [anon_sym_STAR] = ACTIONS(5520),
    [anon_sym_AMP_AMP] = ACTIONS(5520),
    [anon_sym_AMP] = ACTIONS(5518),
    [anon_sym___extension__] = ACTIONS(5518),
    [anon_sym_typedef] = ACTIONS(5518),
    [anon_sym_extern] = ACTIONS(5518),
    [anon_sym___attribute__] = ACTIONS(5518),
    [anon_sym_COLON_COLON] = ACTIONS(5520),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5520),
    [anon_sym___declspec] = ACTIONS(5518),
    [anon_sym___based] = ACTIONS(5518),
    [anon_sym_signed] = ACTIONS(5518),
    [anon_sym_unsigned] = ACTIONS(5518),
    [anon_sym_long] = ACTIONS(5518),
    [anon_sym_short] = ACTIONS(5518),
    [anon_sym_LBRACK] = ACTIONS(5518),
    [anon_sym_static] = ACTIONS(5518),
    [anon_sym_register] = ACTIONS(5518),
    [anon_sym_inline] = ACTIONS(5518),
    [anon_sym___inline] = ACTIONS(5518),
    [anon_sym___inline__] = ACTIONS(5518),
    [anon_sym___forceinline] = ACTIONS(5518),
    [anon_sym_thread_local] = ACTIONS(5518),
    [anon_sym___thread] = ACTIONS(5518),
    [anon_sym_const] = ACTIONS(5518),
    [anon_sym_constexpr] = ACTIONS(5518),
    [anon_sym_volatile] = ACTIONS(5518),
    [anon_sym_restrict] = ACTIONS(5518),
    [anon_sym___restrict__] = ACTIONS(5518),
    [anon_sym__Atomic] = ACTIONS(5518),
    [anon_sym__Noreturn] = ACTIONS(5518),
    [anon_sym_noreturn] = ACTIONS(5518),
    [anon_sym_mutable] = ACTIONS(5518),
    [anon_sym_constinit] = ACTIONS(5518),
    [anon_sym_consteval] = ACTIONS(5518),
    [anon_sym_PROGMEM] = ACTIONS(5518),
    [aux_sym_primitive_type_token1] = ACTIONS(5518),
    [anon_sym_byte] = ACTIONS(5518),
    [anon_sym_word] = ACTIONS(5518),
    [anon_sym_enum] = ACTIONS(5518),
    [anon_sym_class] = ACTIONS(5518),
    [anon_sym_struct] = ACTIONS(5518),
    [anon_sym_union] = ACTIONS(5518),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5518),
    [anon_sym_decltype] = ACTIONS(5518),
    [anon_sym_virtual] = ACTIONS(5518),
    [anon_sym_alignas] = ACTIONS(5518),
    [anon_sym_explicit] = ACTIONS(5518),
    [anon_sym_typename] = ACTIONS(5518),
    [anon_sym_template] = ACTIONS(5518),
    [anon_sym_operator] = ACTIONS(5518),
    [anon_sym_friend] = ACTIONS(5518),
    [anon_sym_public] = ACTIONS(5518),
    [anon_sym_private] = ACTIONS(5518),
    [anon_sym_protected] = ACTIONS(5518),
    [anon_sym_using] = ACTIONS(5518),
    [anon_sym_static_assert] = ACTIONS(5518),
  },
  [2376] = {
    [sym_identifier] = ACTIONS(5518),
    [aux_sym_preproc_def_token1] = ACTIONS(5518),
    [aux_sym_preproc_if_token1] = ACTIONS(5518),
    [aux_sym_preproc_if_token2] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5518),
    [aux_sym_preproc_else_token1] = ACTIONS(5518),
    [aux_sym_preproc_elif_token1] = ACTIONS(5518),
    [sym_preproc_directive] = ACTIONS(5518),
    [anon_sym_LPAREN2] = ACTIONS(5520),
    [anon_sym_TILDE] = ACTIONS(5520),
    [anon_sym_STAR] = ACTIONS(5520),
    [anon_sym_AMP_AMP] = ACTIONS(5520),
    [anon_sym_AMP] = ACTIONS(5518),
    [anon_sym___extension__] = ACTIONS(5518),
    [anon_sym_typedef] = ACTIONS(5518),
    [anon_sym_extern] = ACTIONS(5518),
    [anon_sym___attribute__] = ACTIONS(5518),
    [anon_sym_COLON_COLON] = ACTIONS(5520),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5520),
    [anon_sym___declspec] = ACTIONS(5518),
    [anon_sym___based] = ACTIONS(5518),
    [anon_sym_signed] = ACTIONS(5518),
    [anon_sym_unsigned] = ACTIONS(5518),
    [anon_sym_long] = ACTIONS(5518),
    [anon_sym_short] = ACTIONS(5518),
    [anon_sym_LBRACK] = ACTIONS(5518),
    [anon_sym_static] = ACTIONS(5518),
    [anon_sym_register] = ACTIONS(5518),
    [anon_sym_inline] = ACTIONS(5518),
    [anon_sym___inline] = ACTIONS(5518),
    [anon_sym___inline__] = ACTIONS(5518),
    [anon_sym___forceinline] = ACTIONS(5518),
    [anon_sym_thread_local] = ACTIONS(5518),
    [anon_sym___thread] = ACTIONS(5518),
    [anon_sym_const] = ACTIONS(5518),
    [anon_sym_constexpr] = ACTIONS(5518),
    [anon_sym_volatile] = ACTIONS(5518),
    [anon_sym_restrict] = ACTIONS(5518),
    [anon_sym___restrict__] = ACTIONS(5518),
    [anon_sym__Atomic] = ACTIONS(5518),
    [anon_sym__Noreturn] = ACTIONS(5518),
    [anon_sym_noreturn] = ACTIONS(5518),
    [anon_sym_mutable] = ACTIONS(5518),
    [anon_sym_constinit] = ACTIONS(5518),
    [anon_sym_consteval] = ACTIONS(5518),
    [anon_sym_PROGMEM] = ACTIONS(5518),
    [aux_sym_primitive_type_token1] = ACTIONS(5518),
    [anon_sym_byte] = ACTIONS(5518),
    [anon_sym_word] = ACTIONS(5518),
    [anon_sym_enum] = ACTIONS(5518),
    [anon_sym_class] = ACTIONS(5518),
    [anon_sym_struct] = ACTIONS(5518),
    [anon_sym_union] = ACTIONS(5518),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5518),
    [anon_sym_decltype] = ACTIONS(5518),
    [anon_sym_virtual] = ACTIONS(5518),
    [anon_sym_alignas] = ACTIONS(5518),
    [anon_sym_explicit] = ACTIONS(5518),
    [anon_sym_typename] = ACTIONS(5518),
    [anon_sym_template] = ACTIONS(5518),
    [anon_sym_operator] = ACTIONS(5518),
    [anon_sym_friend] = ACTIONS(5518),
    [anon_sym_public] = ACTIONS(5518),
    [anon_sym_private] = ACTIONS(5518),
    [anon_sym_protected] = ACTIONS(5518),
    [anon_sym_using] = ACTIONS(5518),
    [anon_sym_static_assert] = ACTIONS(5518),
  },
  [2377] = {
    [sym_identifier] = ACTIONS(2223),
    [aux_sym_preproc_def_token1] = ACTIONS(2223),
    [aux_sym_preproc_if_token1] = ACTIONS(2223),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2223),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2223),
    [sym_preproc_directive] = ACTIONS(2223),
    [anon_sym_LPAREN2] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2221),
    [anon_sym_AMP_AMP] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym___extension__] = ACTIONS(2223),
    [anon_sym_typedef] = ACTIONS(2223),
    [anon_sym_extern] = ACTIONS(2223),
    [anon_sym___attribute__] = ACTIONS(2223),
    [anon_sym_COLON_COLON] = ACTIONS(2221),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym___declspec] = ACTIONS(2223),
    [anon_sym___based] = ACTIONS(2223),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [anon_sym_signed] = ACTIONS(2223),
    [anon_sym_unsigned] = ACTIONS(2223),
    [anon_sym_long] = ACTIONS(2223),
    [anon_sym_short] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(2223),
    [anon_sym_static] = ACTIONS(2223),
    [anon_sym_register] = ACTIONS(2223),
    [anon_sym_inline] = ACTIONS(2223),
    [anon_sym___inline] = ACTIONS(2223),
    [anon_sym___inline__] = ACTIONS(2223),
    [anon_sym___forceinline] = ACTIONS(2223),
    [anon_sym_thread_local] = ACTIONS(2223),
    [anon_sym___thread] = ACTIONS(2223),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_constexpr] = ACTIONS(2223),
    [anon_sym_volatile] = ACTIONS(2223),
    [anon_sym_restrict] = ACTIONS(2223),
    [anon_sym___restrict__] = ACTIONS(2223),
    [anon_sym__Atomic] = ACTIONS(2223),
    [anon_sym__Noreturn] = ACTIONS(2223),
    [anon_sym_noreturn] = ACTIONS(2223),
    [anon_sym_mutable] = ACTIONS(2223),
    [anon_sym_constinit] = ACTIONS(2223),
    [anon_sym_consteval] = ACTIONS(2223),
    [anon_sym_PROGMEM] = ACTIONS(2223),
    [aux_sym_primitive_type_token1] = ACTIONS(2223),
    [anon_sym_byte] = ACTIONS(2223),
    [anon_sym_word] = ACTIONS(2223),
    [anon_sym_enum] = ACTIONS(2223),
    [anon_sym_class] = ACTIONS(2223),
    [anon_sym_struct] = ACTIONS(2223),
    [anon_sym_union] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2223),
    [anon_sym_decltype] = ACTIONS(2223),
    [anon_sym_virtual] = ACTIONS(2223),
    [anon_sym_alignas] = ACTIONS(2223),
    [anon_sym_explicit] = ACTIONS(2223),
    [anon_sym_typename] = ACTIONS(2223),
    [anon_sym_template] = ACTIONS(2223),
    [anon_sym_operator] = ACTIONS(2223),
    [anon_sym_friend] = ACTIONS(2223),
    [anon_sym_public] = ACTIONS(2223),
    [anon_sym_private] = ACTIONS(2223),
    [anon_sym_protected] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_static_assert] = ACTIONS(2223),
    [anon_sym_catch] = ACTIONS(2223),
  },
  [2378] = {
    [sym_identifier] = ACTIONS(3415),
    [aux_sym_preproc_def_token1] = ACTIONS(3415),
    [aux_sym_preproc_if_token1] = ACTIONS(3415),
    [aux_sym_preproc_if_token2] = ACTIONS(3415),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3415),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3415),
    [aux_sym_preproc_else_token1] = ACTIONS(3415),
    [aux_sym_preproc_elif_token1] = ACTIONS(3415),
    [sym_preproc_directive] = ACTIONS(3415),
    [anon_sym_LPAREN2] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3417),
    [anon_sym_STAR] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3415),
    [anon_sym___extension__] = ACTIONS(3415),
    [anon_sym_typedef] = ACTIONS(3415),
    [anon_sym_extern] = ACTIONS(3415),
    [anon_sym___attribute__] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3417),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3417),
    [anon_sym___declspec] = ACTIONS(3415),
    [anon_sym___based] = ACTIONS(3415),
    [anon_sym_signed] = ACTIONS(3415),
    [anon_sym_unsigned] = ACTIONS(3415),
    [anon_sym_long] = ACTIONS(3415),
    [anon_sym_short] = ACTIONS(3415),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_static] = ACTIONS(3415),
    [anon_sym_register] = ACTIONS(3415),
    [anon_sym_inline] = ACTIONS(3415),
    [anon_sym___inline] = ACTIONS(3415),
    [anon_sym___inline__] = ACTIONS(3415),
    [anon_sym___forceinline] = ACTIONS(3415),
    [anon_sym_thread_local] = ACTIONS(3415),
    [anon_sym___thread] = ACTIONS(3415),
    [anon_sym_const] = ACTIONS(3415),
    [anon_sym_constexpr] = ACTIONS(3415),
    [anon_sym_volatile] = ACTIONS(3415),
    [anon_sym_restrict] = ACTIONS(3415),
    [anon_sym___restrict__] = ACTIONS(3415),
    [anon_sym__Atomic] = ACTIONS(3415),
    [anon_sym__Noreturn] = ACTIONS(3415),
    [anon_sym_noreturn] = ACTIONS(3415),
    [anon_sym_mutable] = ACTIONS(3415),
    [anon_sym_constinit] = ACTIONS(3415),
    [anon_sym_consteval] = ACTIONS(3415),
    [anon_sym_PROGMEM] = ACTIONS(3415),
    [aux_sym_primitive_type_token1] = ACTIONS(3415),
    [anon_sym_byte] = ACTIONS(3415),
    [anon_sym_word] = ACTIONS(3415),
    [anon_sym_enum] = ACTIONS(3415),
    [anon_sym_class] = ACTIONS(3415),
    [anon_sym_struct] = ACTIONS(3415),
    [anon_sym_union] = ACTIONS(3415),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3415),
    [anon_sym_decltype] = ACTIONS(3415),
    [anon_sym_virtual] = ACTIONS(3415),
    [anon_sym_alignas] = ACTIONS(3415),
    [anon_sym_explicit] = ACTIONS(3415),
    [anon_sym_typename] = ACTIONS(3415),
    [anon_sym_template] = ACTIONS(3415),
    [anon_sym_operator] = ACTIONS(3415),
    [anon_sym_friend] = ACTIONS(3415),
    [anon_sym_public] = ACTIONS(3415),
    [anon_sym_private] = ACTIONS(3415),
    [anon_sym_protected] = ACTIONS(3415),
    [anon_sym_using] = ACTIONS(3415),
    [anon_sym_static_assert] = ACTIONS(3415),
  },
  [2379] = {
    [sym_identifier] = ACTIONS(3439),
    [aux_sym_preproc_def_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token2] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3439),
    [aux_sym_preproc_else_token1] = ACTIONS(3439),
    [aux_sym_preproc_elif_token1] = ACTIONS(3439),
    [sym_preproc_directive] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3439),
    [anon_sym___extension__] = ACTIONS(3439),
    [anon_sym_typedef] = ACTIONS(3439),
    [anon_sym_extern] = ACTIONS(3439),
    [anon_sym___attribute__] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3441),
    [anon_sym___declspec] = ACTIONS(3439),
    [anon_sym___based] = ACTIONS(3439),
    [anon_sym_signed] = ACTIONS(3439),
    [anon_sym_unsigned] = ACTIONS(3439),
    [anon_sym_long] = ACTIONS(3439),
    [anon_sym_short] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_register] = ACTIONS(3439),
    [anon_sym_inline] = ACTIONS(3439),
    [anon_sym___inline] = ACTIONS(3439),
    [anon_sym___inline__] = ACTIONS(3439),
    [anon_sym___forceinline] = ACTIONS(3439),
    [anon_sym_thread_local] = ACTIONS(3439),
    [anon_sym___thread] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_constexpr] = ACTIONS(3439),
    [anon_sym_volatile] = ACTIONS(3439),
    [anon_sym_restrict] = ACTIONS(3439),
    [anon_sym___restrict__] = ACTIONS(3439),
    [anon_sym__Atomic] = ACTIONS(3439),
    [anon_sym__Noreturn] = ACTIONS(3439),
    [anon_sym_noreturn] = ACTIONS(3439),
    [anon_sym_mutable] = ACTIONS(3439),
    [anon_sym_constinit] = ACTIONS(3439),
    [anon_sym_consteval] = ACTIONS(3439),
    [anon_sym_PROGMEM] = ACTIONS(3439),
    [aux_sym_primitive_type_token1] = ACTIONS(3439),
    [anon_sym_byte] = ACTIONS(3439),
    [anon_sym_word] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_struct] = ACTIONS(3439),
    [anon_sym_union] = ACTIONS(3439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3439),
    [anon_sym_decltype] = ACTIONS(3439),
    [anon_sym_virtual] = ACTIONS(3439),
    [anon_sym_alignas] = ACTIONS(3439),
    [anon_sym_explicit] = ACTIONS(3439),
    [anon_sym_typename] = ACTIONS(3439),
    [anon_sym_template] = ACTIONS(3439),
    [anon_sym_operator] = ACTIONS(3439),
    [anon_sym_friend] = ACTIONS(3439),
    [anon_sym_public] = ACTIONS(3439),
    [anon_sym_private] = ACTIONS(3439),
    [anon_sym_protected] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_static_assert] = ACTIONS(3439),
  },
  [2380] = {
    [sym_identifier] = ACTIONS(5653),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5655),
    [anon_sym_COMMA] = ACTIONS(5655),
    [anon_sym_RPAREN] = ACTIONS(5655),
    [aux_sym_preproc_if_token2] = ACTIONS(5655),
    [aux_sym_preproc_else_token1] = ACTIONS(5655),
    [aux_sym_preproc_elif_token1] = ACTIONS(5653),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5655),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5655),
    [anon_sym_LPAREN2] = ACTIONS(5655),
    [anon_sym_DASH] = ACTIONS(5653),
    [anon_sym_PLUS] = ACTIONS(5653),
    [anon_sym_STAR] = ACTIONS(5653),
    [anon_sym_SLASH] = ACTIONS(5653),
    [anon_sym_PERCENT] = ACTIONS(5653),
    [anon_sym_PIPE_PIPE] = ACTIONS(5655),
    [anon_sym_AMP_AMP] = ACTIONS(5655),
    [anon_sym_PIPE] = ACTIONS(5653),
    [anon_sym_CARET] = ACTIONS(5653),
    [anon_sym_AMP] = ACTIONS(5653),
    [anon_sym_EQ_EQ] = ACTIONS(5655),
    [anon_sym_BANG_EQ] = ACTIONS(5655),
    [anon_sym_GT] = ACTIONS(5653),
    [anon_sym_GT_EQ] = ACTIONS(5655),
    [anon_sym_LT_EQ] = ACTIONS(5653),
    [anon_sym_LT] = ACTIONS(5653),
    [anon_sym_LT_LT] = ACTIONS(5653),
    [anon_sym_GT_GT] = ACTIONS(5653),
    [anon_sym_SEMI] = ACTIONS(5655),
    [anon_sym___attribute__] = ACTIONS(5653),
    [anon_sym_LBRACE] = ACTIONS(5655),
    [anon_sym_RBRACE] = ACTIONS(5655),
    [anon_sym_signed] = ACTIONS(5653),
    [anon_sym_unsigned] = ACTIONS(5653),
    [anon_sym_long] = ACTIONS(5653),
    [anon_sym_short] = ACTIONS(5653),
    [anon_sym_LBRACK] = ACTIONS(5655),
    [anon_sym_RBRACK] = ACTIONS(5655),
    [anon_sym_EQ] = ACTIONS(5653),
    [anon_sym_COLON] = ACTIONS(5655),
    [anon_sym_QMARK] = ACTIONS(5655),
    [anon_sym_STAR_EQ] = ACTIONS(5655),
    [anon_sym_SLASH_EQ] = ACTIONS(5655),
    [anon_sym_PERCENT_EQ] = ACTIONS(5655),
    [anon_sym_PLUS_EQ] = ACTIONS(5655),
    [anon_sym_DASH_EQ] = ACTIONS(5655),
    [anon_sym_LT_LT_EQ] = ACTIONS(5655),
    [anon_sym_GT_GT_EQ] = ACTIONS(5655),
    [anon_sym_AMP_EQ] = ACTIONS(5655),
    [anon_sym_CARET_EQ] = ACTIONS(5655),
    [anon_sym_PIPE_EQ] = ACTIONS(5655),
    [anon_sym_and_eq] = ACTIONS(5653),
    [anon_sym_or_eq] = ACTIONS(5653),
    [anon_sym_xor_eq] = ACTIONS(5653),
    [anon_sym_LT_EQ_GT] = ACTIONS(5655),
    [anon_sym_or] = ACTIONS(5653),
    [anon_sym_and] = ACTIONS(5653),
    [anon_sym_bitor] = ACTIONS(5653),
    [anon_sym_xor] = ACTIONS(5653),
    [anon_sym_bitand] = ACTIONS(5653),
    [anon_sym_not_eq] = ACTIONS(5653),
    [anon_sym_DASH_DASH] = ACTIONS(5655),
    [anon_sym_PLUS_PLUS] = ACTIONS(5655),
    [anon_sym_DOT] = ACTIONS(5653),
    [anon_sym_DOT_STAR] = ACTIONS(5655),
    [anon_sym_DASH_GT] = ACTIONS(5655),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5653),
    [anon_sym_decltype] = ACTIONS(5653),
  },
  [2381] = {
    [sym_identifier] = ACTIONS(3353),
    [aux_sym_preproc_def_token1] = ACTIONS(3353),
    [aux_sym_preproc_if_token1] = ACTIONS(3353),
    [aux_sym_preproc_if_token2] = ACTIONS(3353),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3353),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3353),
    [aux_sym_preproc_else_token1] = ACTIONS(3353),
    [aux_sym_preproc_elif_token1] = ACTIONS(3353),
    [sym_preproc_directive] = ACTIONS(3353),
    [anon_sym_LPAREN2] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3355),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_AMP_AMP] = ACTIONS(3355),
    [anon_sym_AMP] = ACTIONS(3353),
    [anon_sym___extension__] = ACTIONS(3353),
    [anon_sym_typedef] = ACTIONS(3353),
    [anon_sym_extern] = ACTIONS(3353),
    [anon_sym___attribute__] = ACTIONS(3353),
    [anon_sym_COLON_COLON] = ACTIONS(3355),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3355),
    [anon_sym___declspec] = ACTIONS(3353),
    [anon_sym___based] = ACTIONS(3353),
    [anon_sym_signed] = ACTIONS(3353),
    [anon_sym_unsigned] = ACTIONS(3353),
    [anon_sym_long] = ACTIONS(3353),
    [anon_sym_short] = ACTIONS(3353),
    [anon_sym_LBRACK] = ACTIONS(3353),
    [anon_sym_static] = ACTIONS(3353),
    [anon_sym_register] = ACTIONS(3353),
    [anon_sym_inline] = ACTIONS(3353),
    [anon_sym___inline] = ACTIONS(3353),
    [anon_sym___inline__] = ACTIONS(3353),
    [anon_sym___forceinline] = ACTIONS(3353),
    [anon_sym_thread_local] = ACTIONS(3353),
    [anon_sym___thread] = ACTIONS(3353),
    [anon_sym_const] = ACTIONS(3353),
    [anon_sym_constexpr] = ACTIONS(3353),
    [anon_sym_volatile] = ACTIONS(3353),
    [anon_sym_restrict] = ACTIONS(3353),
    [anon_sym___restrict__] = ACTIONS(3353),
    [anon_sym__Atomic] = ACTIONS(3353),
    [anon_sym__Noreturn] = ACTIONS(3353),
    [anon_sym_noreturn] = ACTIONS(3353),
    [anon_sym_mutable] = ACTIONS(3353),
    [anon_sym_constinit] = ACTIONS(3353),
    [anon_sym_consteval] = ACTIONS(3353),
    [anon_sym_PROGMEM] = ACTIONS(3353),
    [aux_sym_primitive_type_token1] = ACTIONS(3353),
    [anon_sym_byte] = ACTIONS(3353),
    [anon_sym_word] = ACTIONS(3353),
    [anon_sym_enum] = ACTIONS(3353),
    [anon_sym_class] = ACTIONS(3353),
    [anon_sym_struct] = ACTIONS(3353),
    [anon_sym_union] = ACTIONS(3353),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3353),
    [anon_sym_decltype] = ACTIONS(3353),
    [anon_sym_virtual] = ACTIONS(3353),
    [anon_sym_alignas] = ACTIONS(3353),
    [anon_sym_explicit] = ACTIONS(3353),
    [anon_sym_typename] = ACTIONS(3353),
    [anon_sym_template] = ACTIONS(3353),
    [anon_sym_operator] = ACTIONS(3353),
    [anon_sym_friend] = ACTIONS(3353),
    [anon_sym_public] = ACTIONS(3353),
    [anon_sym_private] = ACTIONS(3353),
    [anon_sym_protected] = ACTIONS(3353),
    [anon_sym_using] = ACTIONS(3353),
    [anon_sym_static_assert] = ACTIONS(3353),
  },
  [2382] = {
    [sym_identifier] = ACTIONS(3467),
    [aux_sym_preproc_def_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token2] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3467),
    [aux_sym_preproc_else_token1] = ACTIONS(3467),
    [aux_sym_preproc_elif_token1] = ACTIONS(3467),
    [sym_preproc_directive] = ACTIONS(3467),
    [anon_sym_LPAREN2] = ACTIONS(3469),
    [anon_sym_TILDE] = ACTIONS(3469),
    [anon_sym_STAR] = ACTIONS(3469),
    [anon_sym_AMP_AMP] = ACTIONS(3469),
    [anon_sym_AMP] = ACTIONS(3467),
    [anon_sym___extension__] = ACTIONS(3467),
    [anon_sym_typedef] = ACTIONS(3467),
    [anon_sym_extern] = ACTIONS(3467),
    [anon_sym___attribute__] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(3469),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3469),
    [anon_sym___declspec] = ACTIONS(3467),
    [anon_sym___based] = ACTIONS(3467),
    [anon_sym_signed] = ACTIONS(3467),
    [anon_sym_unsigned] = ACTIONS(3467),
    [anon_sym_long] = ACTIONS(3467),
    [anon_sym_short] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [anon_sym_static] = ACTIONS(3467),
    [anon_sym_register] = ACTIONS(3467),
    [anon_sym_inline] = ACTIONS(3467),
    [anon_sym___inline] = ACTIONS(3467),
    [anon_sym___inline__] = ACTIONS(3467),
    [anon_sym___forceinline] = ACTIONS(3467),
    [anon_sym_thread_local] = ACTIONS(3467),
    [anon_sym___thread] = ACTIONS(3467),
    [anon_sym_const] = ACTIONS(3467),
    [anon_sym_constexpr] = ACTIONS(3467),
    [anon_sym_volatile] = ACTIONS(3467),
    [anon_sym_restrict] = ACTIONS(3467),
    [anon_sym___restrict__] = ACTIONS(3467),
    [anon_sym__Atomic] = ACTIONS(3467),
    [anon_sym__Noreturn] = ACTIONS(3467),
    [anon_sym_noreturn] = ACTIONS(3467),
    [anon_sym_mutable] = ACTIONS(3467),
    [anon_sym_constinit] = ACTIONS(3467),
    [anon_sym_consteval] = ACTIONS(3467),
    [anon_sym_PROGMEM] = ACTIONS(3467),
    [aux_sym_primitive_type_token1] = ACTIONS(3467),
    [anon_sym_byte] = ACTIONS(3467),
    [anon_sym_word] = ACTIONS(3467),
    [anon_sym_enum] = ACTIONS(3467),
    [anon_sym_class] = ACTIONS(3467),
    [anon_sym_struct] = ACTIONS(3467),
    [anon_sym_union] = ACTIONS(3467),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3467),
    [anon_sym_decltype] = ACTIONS(3467),
    [anon_sym_virtual] = ACTIONS(3467),
    [anon_sym_alignas] = ACTIONS(3467),
    [anon_sym_explicit] = ACTIONS(3467),
    [anon_sym_typename] = ACTIONS(3467),
    [anon_sym_template] = ACTIONS(3467),
    [anon_sym_operator] = ACTIONS(3467),
    [anon_sym_friend] = ACTIONS(3467),
    [anon_sym_public] = ACTIONS(3467),
    [anon_sym_private] = ACTIONS(3467),
    [anon_sym_protected] = ACTIONS(3467),
    [anon_sym_using] = ACTIONS(3467),
    [anon_sym_static_assert] = ACTIONS(3467),
  },
  [2383] = {
    [sym_identifier] = ACTIONS(3419),
    [aux_sym_preproc_def_token1] = ACTIONS(3419),
    [aux_sym_preproc_if_token1] = ACTIONS(3419),
    [aux_sym_preproc_if_token2] = ACTIONS(3419),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3419),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3419),
    [aux_sym_preproc_else_token1] = ACTIONS(3419),
    [aux_sym_preproc_elif_token1] = ACTIONS(3419),
    [sym_preproc_directive] = ACTIONS(3419),
    [anon_sym_LPAREN2] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym___extension__] = ACTIONS(3419),
    [anon_sym_typedef] = ACTIONS(3419),
    [anon_sym_extern] = ACTIONS(3419),
    [anon_sym___attribute__] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3421),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3421),
    [anon_sym___declspec] = ACTIONS(3419),
    [anon_sym___based] = ACTIONS(3419),
    [anon_sym_signed] = ACTIONS(3419),
    [anon_sym_unsigned] = ACTIONS(3419),
    [anon_sym_long] = ACTIONS(3419),
    [anon_sym_short] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_register] = ACTIONS(3419),
    [anon_sym_inline] = ACTIONS(3419),
    [anon_sym___inline] = ACTIONS(3419),
    [anon_sym___inline__] = ACTIONS(3419),
    [anon_sym___forceinline] = ACTIONS(3419),
    [anon_sym_thread_local] = ACTIONS(3419),
    [anon_sym___thread] = ACTIONS(3419),
    [anon_sym_const] = ACTIONS(3419),
    [anon_sym_constexpr] = ACTIONS(3419),
    [anon_sym_volatile] = ACTIONS(3419),
    [anon_sym_restrict] = ACTIONS(3419),
    [anon_sym___restrict__] = ACTIONS(3419),
    [anon_sym__Atomic] = ACTIONS(3419),
    [anon_sym__Noreturn] = ACTIONS(3419),
    [anon_sym_noreturn] = ACTIONS(3419),
    [anon_sym_mutable] = ACTIONS(3419),
    [anon_sym_constinit] = ACTIONS(3419),
    [anon_sym_consteval] = ACTIONS(3419),
    [anon_sym_PROGMEM] = ACTIONS(3419),
    [aux_sym_primitive_type_token1] = ACTIONS(3419),
    [anon_sym_byte] = ACTIONS(3419),
    [anon_sym_word] = ACTIONS(3419),
    [anon_sym_enum] = ACTIONS(3419),
    [anon_sym_class] = ACTIONS(3419),
    [anon_sym_struct] = ACTIONS(3419),
    [anon_sym_union] = ACTIONS(3419),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3419),
    [anon_sym_decltype] = ACTIONS(3419),
    [anon_sym_virtual] = ACTIONS(3419),
    [anon_sym_alignas] = ACTIONS(3419),
    [anon_sym_explicit] = ACTIONS(3419),
    [anon_sym_typename] = ACTIONS(3419),
    [anon_sym_template] = ACTIONS(3419),
    [anon_sym_operator] = ACTIONS(3419),
    [anon_sym_friend] = ACTIONS(3419),
    [anon_sym_public] = ACTIONS(3419),
    [anon_sym_private] = ACTIONS(3419),
    [anon_sym_protected] = ACTIONS(3419),
    [anon_sym_using] = ACTIONS(3419),
    [anon_sym_static_assert] = ACTIONS(3419),
  },
  [2384] = {
    [sym_identifier] = ACTIONS(3162),
    [aux_sym_preproc_def_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token2] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3162),
    [aux_sym_preproc_else_token1] = ACTIONS(3162),
    [aux_sym_preproc_elif_token1] = ACTIONS(3162),
    [sym_preproc_directive] = ACTIONS(3162),
    [anon_sym_LPAREN2] = ACTIONS(3164),
    [anon_sym_TILDE] = ACTIONS(3164),
    [anon_sym_STAR] = ACTIONS(3164),
    [anon_sym_AMP_AMP] = ACTIONS(3164),
    [anon_sym_AMP] = ACTIONS(3162),
    [anon_sym___extension__] = ACTIONS(3162),
    [anon_sym_typedef] = ACTIONS(3162),
    [anon_sym_extern] = ACTIONS(3162),
    [anon_sym___attribute__] = ACTIONS(3162),
    [anon_sym_COLON_COLON] = ACTIONS(3164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3164),
    [anon_sym___declspec] = ACTIONS(3162),
    [anon_sym___based] = ACTIONS(3162),
    [anon_sym_signed] = ACTIONS(3162),
    [anon_sym_unsigned] = ACTIONS(3162),
    [anon_sym_long] = ACTIONS(3162),
    [anon_sym_short] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_register] = ACTIONS(3162),
    [anon_sym_inline] = ACTIONS(3162),
    [anon_sym___inline] = ACTIONS(3162),
    [anon_sym___inline__] = ACTIONS(3162),
    [anon_sym___forceinline] = ACTIONS(3162),
    [anon_sym_thread_local] = ACTIONS(3162),
    [anon_sym___thread] = ACTIONS(3162),
    [anon_sym_const] = ACTIONS(3162),
    [anon_sym_constexpr] = ACTIONS(3162),
    [anon_sym_volatile] = ACTIONS(3162),
    [anon_sym_restrict] = ACTIONS(3162),
    [anon_sym___restrict__] = ACTIONS(3162),
    [anon_sym__Atomic] = ACTIONS(3162),
    [anon_sym__Noreturn] = ACTIONS(3162),
    [anon_sym_noreturn] = ACTIONS(3162),
    [anon_sym_mutable] = ACTIONS(3162),
    [anon_sym_constinit] = ACTIONS(3162),
    [anon_sym_consteval] = ACTIONS(3162),
    [anon_sym_PROGMEM] = ACTIONS(3162),
    [aux_sym_primitive_type_token1] = ACTIONS(3162),
    [anon_sym_byte] = ACTIONS(3162),
    [anon_sym_word] = ACTIONS(3162),
    [anon_sym_enum] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_struct] = ACTIONS(3162),
    [anon_sym_union] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3162),
    [anon_sym_decltype] = ACTIONS(3162),
    [anon_sym_virtual] = ACTIONS(3162),
    [anon_sym_alignas] = ACTIONS(3162),
    [anon_sym_explicit] = ACTIONS(3162),
    [anon_sym_typename] = ACTIONS(3162),
    [anon_sym_template] = ACTIONS(3162),
    [anon_sym_operator] = ACTIONS(3162),
    [anon_sym_friend] = ACTIONS(3162),
    [anon_sym_public] = ACTIONS(3162),
    [anon_sym_private] = ACTIONS(3162),
    [anon_sym_protected] = ACTIONS(3162),
    [anon_sym_using] = ACTIONS(3162),
    [anon_sym_static_assert] = ACTIONS(3162),
  },
  [2385] = {
    [sym_argument_list] = STATE(3030),
    [sym_initializer_list] = STATE(3030),
    [sym_decltype_auto] = STATE(2728),
    [sym_new_declarator] = STATE(2724),
    [sym_identifier] = ACTIONS(5831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5833),
    [anon_sym_COMMA] = ACTIONS(5833),
    [anon_sym_RPAREN] = ACTIONS(5833),
    [aux_sym_preproc_if_token2] = ACTIONS(5833),
    [aux_sym_preproc_else_token1] = ACTIONS(5833),
    [aux_sym_preproc_elif_token1] = ACTIONS(5831),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5833),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5833),
    [anon_sym_LPAREN2] = ACTIONS(5813),
    [anon_sym_DASH] = ACTIONS(5831),
    [anon_sym_PLUS] = ACTIONS(5831),
    [anon_sym_STAR] = ACTIONS(5831),
    [anon_sym_SLASH] = ACTIONS(5831),
    [anon_sym_PERCENT] = ACTIONS(5831),
    [anon_sym_PIPE_PIPE] = ACTIONS(5833),
    [anon_sym_AMP_AMP] = ACTIONS(5833),
    [anon_sym_PIPE] = ACTIONS(5831),
    [anon_sym_CARET] = ACTIONS(5831),
    [anon_sym_AMP] = ACTIONS(5831),
    [anon_sym_EQ_EQ] = ACTIONS(5833),
    [anon_sym_BANG_EQ] = ACTIONS(5833),
    [anon_sym_GT] = ACTIONS(5831),
    [anon_sym_GT_EQ] = ACTIONS(5833),
    [anon_sym_LT_EQ] = ACTIONS(5831),
    [anon_sym_LT] = ACTIONS(5831),
    [anon_sym_LT_LT] = ACTIONS(5831),
    [anon_sym_GT_GT] = ACTIONS(5831),
    [anon_sym_SEMI] = ACTIONS(5833),
    [anon_sym___attribute__] = ACTIONS(5831),
    [anon_sym_LBRACE] = ACTIONS(2159),
    [anon_sym_RBRACE] = ACTIONS(5833),
    [anon_sym_LBRACK] = ACTIONS(5815),
    [anon_sym_RBRACK] = ACTIONS(5833),
    [anon_sym_EQ] = ACTIONS(5831),
    [anon_sym_COLON] = ACTIONS(5833),
    [anon_sym_QMARK] = ACTIONS(5833),
    [anon_sym_STAR_EQ] = ACTIONS(5833),
    [anon_sym_SLASH_EQ] = ACTIONS(5833),
    [anon_sym_PERCENT_EQ] = ACTIONS(5833),
    [anon_sym_PLUS_EQ] = ACTIONS(5833),
    [anon_sym_DASH_EQ] = ACTIONS(5833),
    [anon_sym_LT_LT_EQ] = ACTIONS(5833),
    [anon_sym_GT_GT_EQ] = ACTIONS(5833),
    [anon_sym_AMP_EQ] = ACTIONS(5833),
    [anon_sym_CARET_EQ] = ACTIONS(5833),
    [anon_sym_PIPE_EQ] = ACTIONS(5833),
    [anon_sym_and_eq] = ACTIONS(5831),
    [anon_sym_or_eq] = ACTIONS(5831),
    [anon_sym_xor_eq] = ACTIONS(5831),
    [anon_sym_LT_EQ_GT] = ACTIONS(5833),
    [anon_sym_or] = ACTIONS(5831),
    [anon_sym_and] = ACTIONS(5831),
    [anon_sym_bitor] = ACTIONS(5831),
    [anon_sym_xor] = ACTIONS(5831),
    [anon_sym_bitand] = ACTIONS(5831),
    [anon_sym_not_eq] = ACTIONS(5831),
    [anon_sym_DASH_DASH] = ACTIONS(5833),
    [anon_sym_PLUS_PLUS] = ACTIONS(5833),
    [anon_sym_DOT] = ACTIONS(5831),
    [anon_sym_DOT_STAR] = ACTIONS(5833),
    [anon_sym_DASH_GT] = ACTIONS(5833),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5817),
    [anon_sym_decltype] = ACTIONS(5819),
  },
  [2386] = {
    [sym_identifier] = ACTIONS(3423),
    [aux_sym_preproc_def_token1] = ACTIONS(3423),
    [aux_sym_preproc_if_token1] = ACTIONS(3423),
    [aux_sym_preproc_if_token2] = ACTIONS(3423),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3423),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3423),
    [aux_sym_preproc_else_token1] = ACTIONS(3423),
    [aux_sym_preproc_elif_token1] = ACTIONS(3423),
    [sym_preproc_directive] = ACTIONS(3423),
    [anon_sym_LPAREN2] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [anon_sym_STAR] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3423),
    [anon_sym___extension__] = ACTIONS(3423),
    [anon_sym_typedef] = ACTIONS(3423),
    [anon_sym_extern] = ACTIONS(3423),
    [anon_sym___attribute__] = ACTIONS(3423),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3425),
    [anon_sym___declspec] = ACTIONS(3423),
    [anon_sym___based] = ACTIONS(3423),
    [anon_sym_signed] = ACTIONS(3423),
    [anon_sym_unsigned] = ACTIONS(3423),
    [anon_sym_long] = ACTIONS(3423),
    [anon_sym_short] = ACTIONS(3423),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_static] = ACTIONS(3423),
    [anon_sym_register] = ACTIONS(3423),
    [anon_sym_inline] = ACTIONS(3423),
    [anon_sym___inline] = ACTIONS(3423),
    [anon_sym___inline__] = ACTIONS(3423),
    [anon_sym___forceinline] = ACTIONS(3423),
    [anon_sym_thread_local] = ACTIONS(3423),
    [anon_sym___thread] = ACTIONS(3423),
    [anon_sym_const] = ACTIONS(3423),
    [anon_sym_constexpr] = ACTIONS(3423),
    [anon_sym_volatile] = ACTIONS(3423),
    [anon_sym_restrict] = ACTIONS(3423),
    [anon_sym___restrict__] = ACTIONS(3423),
    [anon_sym__Atomic] = ACTIONS(3423),
    [anon_sym__Noreturn] = ACTIONS(3423),
    [anon_sym_noreturn] = ACTIONS(3423),
    [anon_sym_mutable] = ACTIONS(3423),
    [anon_sym_constinit] = ACTIONS(3423),
    [anon_sym_consteval] = ACTIONS(3423),
    [anon_sym_PROGMEM] = ACTIONS(3423),
    [aux_sym_primitive_type_token1] = ACTIONS(3423),
    [anon_sym_byte] = ACTIONS(3423),
    [anon_sym_word] = ACTIONS(3423),
    [anon_sym_enum] = ACTIONS(3423),
    [anon_sym_class] = ACTIONS(3423),
    [anon_sym_struct] = ACTIONS(3423),
    [anon_sym_union] = ACTIONS(3423),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3423),
    [anon_sym_decltype] = ACTIONS(3423),
    [anon_sym_virtual] = ACTIONS(3423),
    [anon_sym_alignas] = ACTIONS(3423),
    [anon_sym_explicit] = ACTIONS(3423),
    [anon_sym_typename] = ACTIONS(3423),
    [anon_sym_template] = ACTIONS(3423),
    [anon_sym_operator] = ACTIONS(3423),
    [anon_sym_friend] = ACTIONS(3423),
    [anon_sym_public] = ACTIONS(3423),
    [anon_sym_private] = ACTIONS(3423),
    [anon_sym_protected] = ACTIONS(3423),
    [anon_sym_using] = ACTIONS(3423),
    [anon_sym_static_assert] = ACTIONS(3423),
  },
  [2387] = {
    [sym_identifier] = ACTIONS(3455),
    [aux_sym_preproc_def_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token2] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3455),
    [aux_sym_preproc_else_token1] = ACTIONS(3455),
    [aux_sym_preproc_elif_token1] = ACTIONS(3455),
    [sym_preproc_directive] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3457),
    [anon_sym_STAR] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym___extension__] = ACTIONS(3455),
    [anon_sym_typedef] = ACTIONS(3455),
    [anon_sym_extern] = ACTIONS(3455),
    [anon_sym___attribute__] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3457),
    [anon_sym___declspec] = ACTIONS(3455),
    [anon_sym___based] = ACTIONS(3455),
    [anon_sym_signed] = ACTIONS(3455),
    [anon_sym_unsigned] = ACTIONS(3455),
    [anon_sym_long] = ACTIONS(3455),
    [anon_sym_short] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_static] = ACTIONS(3455),
    [anon_sym_register] = ACTIONS(3455),
    [anon_sym_inline] = ACTIONS(3455),
    [anon_sym___inline] = ACTIONS(3455),
    [anon_sym___inline__] = ACTIONS(3455),
    [anon_sym___forceinline] = ACTIONS(3455),
    [anon_sym_thread_local] = ACTIONS(3455),
    [anon_sym___thread] = ACTIONS(3455),
    [anon_sym_const] = ACTIONS(3455),
    [anon_sym_constexpr] = ACTIONS(3455),
    [anon_sym_volatile] = ACTIONS(3455),
    [anon_sym_restrict] = ACTIONS(3455),
    [anon_sym___restrict__] = ACTIONS(3455),
    [anon_sym__Atomic] = ACTIONS(3455),
    [anon_sym__Noreturn] = ACTIONS(3455),
    [anon_sym_noreturn] = ACTIONS(3455),
    [anon_sym_mutable] = ACTIONS(3455),
    [anon_sym_constinit] = ACTIONS(3455),
    [anon_sym_consteval] = ACTIONS(3455),
    [anon_sym_PROGMEM] = ACTIONS(3455),
    [aux_sym_primitive_type_token1] = ACTIONS(3455),
    [anon_sym_byte] = ACTIONS(3455),
    [anon_sym_word] = ACTIONS(3455),
    [anon_sym_enum] = ACTIONS(3455),
    [anon_sym_class] = ACTIONS(3455),
    [anon_sym_struct] = ACTIONS(3455),
    [anon_sym_union] = ACTIONS(3455),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3455),
    [anon_sym_decltype] = ACTIONS(3455),
    [anon_sym_virtual] = ACTIONS(3455),
    [anon_sym_alignas] = ACTIONS(3455),
    [anon_sym_explicit] = ACTIONS(3455),
    [anon_sym_typename] = ACTIONS(3455),
    [anon_sym_template] = ACTIONS(3455),
    [anon_sym_operator] = ACTIONS(3455),
    [anon_sym_friend] = ACTIONS(3455),
    [anon_sym_public] = ACTIONS(3455),
    [anon_sym_private] = ACTIONS(3455),
    [anon_sym_protected] = ACTIONS(3455),
    [anon_sym_using] = ACTIONS(3455),
    [anon_sym_static_assert] = ACTIONS(3455),
  },
  [2388] = {
    [sym_identifier] = ACTIONS(3451),
    [aux_sym_preproc_def_token1] = ACTIONS(3451),
    [aux_sym_preproc_if_token1] = ACTIONS(3451),
    [aux_sym_preproc_if_token2] = ACTIONS(3451),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3451),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3451),
    [aux_sym_preproc_else_token1] = ACTIONS(3451),
    [aux_sym_preproc_elif_token1] = ACTIONS(3451),
    [sym_preproc_directive] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3453),
    [anon_sym_TILDE] = ACTIONS(3453),
    [anon_sym_STAR] = ACTIONS(3453),
    [anon_sym_AMP_AMP] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym___extension__] = ACTIONS(3451),
    [anon_sym_typedef] = ACTIONS(3451),
    [anon_sym_extern] = ACTIONS(3451),
    [anon_sym___attribute__] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3453),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3453),
    [anon_sym___declspec] = ACTIONS(3451),
    [anon_sym___based] = ACTIONS(3451),
    [anon_sym_signed] = ACTIONS(3451),
    [anon_sym_unsigned] = ACTIONS(3451),
    [anon_sym_long] = ACTIONS(3451),
    [anon_sym_short] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_register] = ACTIONS(3451),
    [anon_sym_inline] = ACTIONS(3451),
    [anon_sym___inline] = ACTIONS(3451),
    [anon_sym___inline__] = ACTIONS(3451),
    [anon_sym___forceinline] = ACTIONS(3451),
    [anon_sym_thread_local] = ACTIONS(3451),
    [anon_sym___thread] = ACTIONS(3451),
    [anon_sym_const] = ACTIONS(3451),
    [anon_sym_constexpr] = ACTIONS(3451),
    [anon_sym_volatile] = ACTIONS(3451),
    [anon_sym_restrict] = ACTIONS(3451),
    [anon_sym___restrict__] = ACTIONS(3451),
    [anon_sym__Atomic] = ACTIONS(3451),
    [anon_sym__Noreturn] = ACTIONS(3451),
    [anon_sym_noreturn] = ACTIONS(3451),
    [anon_sym_mutable] = ACTIONS(3451),
    [anon_sym_constinit] = ACTIONS(3451),
    [anon_sym_consteval] = ACTIONS(3451),
    [anon_sym_PROGMEM] = ACTIONS(3451),
    [aux_sym_primitive_type_token1] = ACTIONS(3451),
    [anon_sym_byte] = ACTIONS(3451),
    [anon_sym_word] = ACTIONS(3451),
    [anon_sym_enum] = ACTIONS(3451),
    [anon_sym_class] = ACTIONS(3451),
    [anon_sym_struct] = ACTIONS(3451),
    [anon_sym_union] = ACTIONS(3451),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3451),
    [anon_sym_decltype] = ACTIONS(3451),
    [anon_sym_virtual] = ACTIONS(3451),
    [anon_sym_alignas] = ACTIONS(3451),
    [anon_sym_explicit] = ACTIONS(3451),
    [anon_sym_typename] = ACTIONS(3451),
    [anon_sym_template] = ACTIONS(3451),
    [anon_sym_operator] = ACTIONS(3451),
    [anon_sym_friend] = ACTIONS(3451),
    [anon_sym_public] = ACTIONS(3451),
    [anon_sym_private] = ACTIONS(3451),
    [anon_sym_protected] = ACTIONS(3451),
    [anon_sym_using] = ACTIONS(3451),
    [anon_sym_static_assert] = ACTIONS(3451),
  },
  [2389] = {
    [sym_identifier] = ACTIONS(3443),
    [aux_sym_preproc_def_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token2] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3443),
    [aux_sym_preproc_else_token1] = ACTIONS(3443),
    [aux_sym_preproc_elif_token1] = ACTIONS(3443),
    [sym_preproc_directive] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_AMP_AMP] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym___extension__] = ACTIONS(3443),
    [anon_sym_typedef] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym___attribute__] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3445),
    [anon_sym___declspec] = ACTIONS(3443),
    [anon_sym___based] = ACTIONS(3443),
    [anon_sym_signed] = ACTIONS(3443),
    [anon_sym_unsigned] = ACTIONS(3443),
    [anon_sym_long] = ACTIONS(3443),
    [anon_sym_short] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_register] = ACTIONS(3443),
    [anon_sym_inline] = ACTIONS(3443),
    [anon_sym___inline] = ACTIONS(3443),
    [anon_sym___inline__] = ACTIONS(3443),
    [anon_sym___forceinline] = ACTIONS(3443),
    [anon_sym_thread_local] = ACTIONS(3443),
    [anon_sym___thread] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_constexpr] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_restrict] = ACTIONS(3443),
    [anon_sym___restrict__] = ACTIONS(3443),
    [anon_sym__Atomic] = ACTIONS(3443),
    [anon_sym__Noreturn] = ACTIONS(3443),
    [anon_sym_noreturn] = ACTIONS(3443),
    [anon_sym_mutable] = ACTIONS(3443),
    [anon_sym_constinit] = ACTIONS(3443),
    [anon_sym_consteval] = ACTIONS(3443),
    [anon_sym_PROGMEM] = ACTIONS(3443),
    [aux_sym_primitive_type_token1] = ACTIONS(3443),
    [anon_sym_byte] = ACTIONS(3443),
    [anon_sym_word] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_union] = ACTIONS(3443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3443),
    [anon_sym_decltype] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_alignas] = ACTIONS(3443),
    [anon_sym_explicit] = ACTIONS(3443),
    [anon_sym_typename] = ACTIONS(3443),
    [anon_sym_template] = ACTIONS(3443),
    [anon_sym_operator] = ACTIONS(3443),
    [anon_sym_friend] = ACTIONS(3443),
    [anon_sym_public] = ACTIONS(3443),
    [anon_sym_private] = ACTIONS(3443),
    [anon_sym_protected] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_static_assert] = ACTIONS(3443),
  },
  [2390] = {
    [sym_identifier] = ACTIONS(5550),
    [aux_sym_preproc_def_token1] = ACTIONS(5550),
    [aux_sym_preproc_if_token1] = ACTIONS(5550),
    [aux_sym_preproc_if_token2] = ACTIONS(5550),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5550),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5550),
    [aux_sym_preproc_else_token1] = ACTIONS(5550),
    [aux_sym_preproc_elif_token1] = ACTIONS(5550),
    [sym_preproc_directive] = ACTIONS(5550),
    [anon_sym_LPAREN2] = ACTIONS(5552),
    [anon_sym_TILDE] = ACTIONS(5552),
    [anon_sym_STAR] = ACTIONS(5552),
    [anon_sym_AMP_AMP] = ACTIONS(5552),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym___extension__] = ACTIONS(5550),
    [anon_sym_typedef] = ACTIONS(5550),
    [anon_sym_extern] = ACTIONS(5550),
    [anon_sym___attribute__] = ACTIONS(5550),
    [anon_sym_COLON_COLON] = ACTIONS(5552),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5552),
    [anon_sym___declspec] = ACTIONS(5550),
    [anon_sym___based] = ACTIONS(5550),
    [anon_sym_signed] = ACTIONS(5550),
    [anon_sym_unsigned] = ACTIONS(5550),
    [anon_sym_long] = ACTIONS(5550),
    [anon_sym_short] = ACTIONS(5550),
    [anon_sym_LBRACK] = ACTIONS(5550),
    [anon_sym_static] = ACTIONS(5550),
    [anon_sym_register] = ACTIONS(5550),
    [anon_sym_inline] = ACTIONS(5550),
    [anon_sym___inline] = ACTIONS(5550),
    [anon_sym___inline__] = ACTIONS(5550),
    [anon_sym___forceinline] = ACTIONS(5550),
    [anon_sym_thread_local] = ACTIONS(5550),
    [anon_sym___thread] = ACTIONS(5550),
    [anon_sym_const] = ACTIONS(5550),
    [anon_sym_constexpr] = ACTIONS(5550),
    [anon_sym_volatile] = ACTIONS(5550),
    [anon_sym_restrict] = ACTIONS(5550),
    [anon_sym___restrict__] = ACTIONS(5550),
    [anon_sym__Atomic] = ACTIONS(5550),
    [anon_sym__Noreturn] = ACTIONS(5550),
    [anon_sym_noreturn] = ACTIONS(5550),
    [anon_sym_mutable] = ACTIONS(5550),
    [anon_sym_constinit] = ACTIONS(5550),
    [anon_sym_consteval] = ACTIONS(5550),
    [anon_sym_PROGMEM] = ACTIONS(5550),
    [aux_sym_primitive_type_token1] = ACTIONS(5550),
    [anon_sym_byte] = ACTIONS(5550),
    [anon_sym_word] = ACTIONS(5550),
    [anon_sym_enum] = ACTIONS(5550),
    [anon_sym_class] = ACTIONS(5550),
    [anon_sym_struct] = ACTIONS(5550),
    [anon_sym_union] = ACTIONS(5550),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5550),
    [anon_sym_decltype] = ACTIONS(5550),
    [anon_sym_virtual] = ACTIONS(5550),
    [anon_sym_alignas] = ACTIONS(5550),
    [anon_sym_explicit] = ACTIONS(5550),
    [anon_sym_typename] = ACTIONS(5550),
    [anon_sym_template] = ACTIONS(5550),
    [anon_sym_operator] = ACTIONS(5550),
    [anon_sym_friend] = ACTIONS(5550),
    [anon_sym_public] = ACTIONS(5550),
    [anon_sym_private] = ACTIONS(5550),
    [anon_sym_protected] = ACTIONS(5550),
    [anon_sym_using] = ACTIONS(5550),
    [anon_sym_static_assert] = ACTIONS(5550),
  },
  [2391] = {
    [sym_identifier] = ACTIONS(3443),
    [aux_sym_preproc_def_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token2] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3443),
    [aux_sym_preproc_else_token1] = ACTIONS(3443),
    [aux_sym_preproc_elif_token1] = ACTIONS(3443),
    [sym_preproc_directive] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_AMP_AMP] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym___extension__] = ACTIONS(3443),
    [anon_sym_typedef] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym___attribute__] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3445),
    [anon_sym___declspec] = ACTIONS(3443),
    [anon_sym___based] = ACTIONS(3443),
    [anon_sym_signed] = ACTIONS(3443),
    [anon_sym_unsigned] = ACTIONS(3443),
    [anon_sym_long] = ACTIONS(3443),
    [anon_sym_short] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_register] = ACTIONS(3443),
    [anon_sym_inline] = ACTIONS(3443),
    [anon_sym___inline] = ACTIONS(3443),
    [anon_sym___inline__] = ACTIONS(3443),
    [anon_sym___forceinline] = ACTIONS(3443),
    [anon_sym_thread_local] = ACTIONS(3443),
    [anon_sym___thread] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_constexpr] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_restrict] = ACTIONS(3443),
    [anon_sym___restrict__] = ACTIONS(3443),
    [anon_sym__Atomic] = ACTIONS(3443),
    [anon_sym__Noreturn] = ACTIONS(3443),
    [anon_sym_noreturn] = ACTIONS(3443),
    [anon_sym_mutable] = ACTIONS(3443),
    [anon_sym_constinit] = ACTIONS(3443),
    [anon_sym_consteval] = ACTIONS(3443),
    [anon_sym_PROGMEM] = ACTIONS(3443),
    [aux_sym_primitive_type_token1] = ACTIONS(3443),
    [anon_sym_byte] = ACTIONS(3443),
    [anon_sym_word] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_union] = ACTIONS(3443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3443),
    [anon_sym_decltype] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_alignas] = ACTIONS(3443),
    [anon_sym_explicit] = ACTIONS(3443),
    [anon_sym_typename] = ACTIONS(3443),
    [anon_sym_template] = ACTIONS(3443),
    [anon_sym_operator] = ACTIONS(3443),
    [anon_sym_friend] = ACTIONS(3443),
    [anon_sym_public] = ACTIONS(3443),
    [anon_sym_private] = ACTIONS(3443),
    [anon_sym_protected] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_static_assert] = ACTIONS(3443),
  },
  [2392] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [anon_sym_COMMA] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym_RBRACE] = ACTIONS(2265),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_friend] = ACTIONS(2267),
    [anon_sym_public] = ACTIONS(2267),
    [anon_sym_private] = ACTIONS(2267),
    [anon_sym_protected] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
  },
  [2393] = {
    [sym_identifier] = ACTIONS(5507),
    [aux_sym_preproc_def_token1] = ACTIONS(5507),
    [aux_sym_preproc_if_token1] = ACTIONS(5507),
    [aux_sym_preproc_if_token2] = ACTIONS(5507),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5507),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5507),
    [aux_sym_preproc_else_token1] = ACTIONS(5507),
    [aux_sym_preproc_elif_token1] = ACTIONS(5507),
    [sym_preproc_directive] = ACTIONS(5507),
    [anon_sym_LPAREN2] = ACTIONS(5509),
    [anon_sym_TILDE] = ACTIONS(5509),
    [anon_sym_STAR] = ACTIONS(5509),
    [anon_sym_AMP_AMP] = ACTIONS(5509),
    [anon_sym_AMP] = ACTIONS(5507),
    [anon_sym___extension__] = ACTIONS(5507),
    [anon_sym_typedef] = ACTIONS(5507),
    [anon_sym_extern] = ACTIONS(5507),
    [anon_sym___attribute__] = ACTIONS(5507),
    [anon_sym_COLON_COLON] = ACTIONS(5509),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5509),
    [anon_sym___declspec] = ACTIONS(5507),
    [anon_sym___based] = ACTIONS(5507),
    [anon_sym_signed] = ACTIONS(5507),
    [anon_sym_unsigned] = ACTIONS(5507),
    [anon_sym_long] = ACTIONS(5507),
    [anon_sym_short] = ACTIONS(5507),
    [anon_sym_LBRACK] = ACTIONS(5507),
    [anon_sym_static] = ACTIONS(5507),
    [anon_sym_register] = ACTIONS(5507),
    [anon_sym_inline] = ACTIONS(5507),
    [anon_sym___inline] = ACTIONS(5507),
    [anon_sym___inline__] = ACTIONS(5507),
    [anon_sym___forceinline] = ACTIONS(5507),
    [anon_sym_thread_local] = ACTIONS(5507),
    [anon_sym___thread] = ACTIONS(5507),
    [anon_sym_const] = ACTIONS(5507),
    [anon_sym_constexpr] = ACTIONS(5507),
    [anon_sym_volatile] = ACTIONS(5507),
    [anon_sym_restrict] = ACTIONS(5507),
    [anon_sym___restrict__] = ACTIONS(5507),
    [anon_sym__Atomic] = ACTIONS(5507),
    [anon_sym__Noreturn] = ACTIONS(5507),
    [anon_sym_noreturn] = ACTIONS(5507),
    [anon_sym_mutable] = ACTIONS(5507),
    [anon_sym_constinit] = ACTIONS(5507),
    [anon_sym_consteval] = ACTIONS(5507),
    [anon_sym_PROGMEM] = ACTIONS(5507),
    [aux_sym_primitive_type_token1] = ACTIONS(5507),
    [anon_sym_byte] = ACTIONS(5507),
    [anon_sym_word] = ACTIONS(5507),
    [anon_sym_enum] = ACTIONS(5507),
    [anon_sym_class] = ACTIONS(5507),
    [anon_sym_struct] = ACTIONS(5507),
    [anon_sym_union] = ACTIONS(5507),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5507),
    [anon_sym_decltype] = ACTIONS(5507),
    [anon_sym_virtual] = ACTIONS(5507),
    [anon_sym_alignas] = ACTIONS(5507),
    [anon_sym_explicit] = ACTIONS(5507),
    [anon_sym_typename] = ACTIONS(5507),
    [anon_sym_template] = ACTIONS(5507),
    [anon_sym_operator] = ACTIONS(5507),
    [anon_sym_friend] = ACTIONS(5507),
    [anon_sym_public] = ACTIONS(5507),
    [anon_sym_private] = ACTIONS(5507),
    [anon_sym_protected] = ACTIONS(5507),
    [anon_sym_using] = ACTIONS(5507),
    [anon_sym_static_assert] = ACTIONS(5507),
  },
  [2394] = {
    [sym_identifier] = ACTIONS(5558),
    [aux_sym_preproc_def_token1] = ACTIONS(5558),
    [aux_sym_preproc_if_token1] = ACTIONS(5558),
    [aux_sym_preproc_if_token2] = ACTIONS(5558),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5558),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5558),
    [aux_sym_preproc_else_token1] = ACTIONS(5558),
    [aux_sym_preproc_elif_token1] = ACTIONS(5558),
    [sym_preproc_directive] = ACTIONS(5558),
    [anon_sym_LPAREN2] = ACTIONS(5560),
    [anon_sym_TILDE] = ACTIONS(5560),
    [anon_sym_STAR] = ACTIONS(5560),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_AMP] = ACTIONS(5558),
    [anon_sym___extension__] = ACTIONS(5558),
    [anon_sym_typedef] = ACTIONS(5558),
    [anon_sym_extern] = ACTIONS(5558),
    [anon_sym___attribute__] = ACTIONS(5558),
    [anon_sym_COLON_COLON] = ACTIONS(5560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5560),
    [anon_sym___declspec] = ACTIONS(5558),
    [anon_sym___based] = ACTIONS(5558),
    [anon_sym_signed] = ACTIONS(5558),
    [anon_sym_unsigned] = ACTIONS(5558),
    [anon_sym_long] = ACTIONS(5558),
    [anon_sym_short] = ACTIONS(5558),
    [anon_sym_LBRACK] = ACTIONS(5558),
    [anon_sym_static] = ACTIONS(5558),
    [anon_sym_register] = ACTIONS(5558),
    [anon_sym_inline] = ACTIONS(5558),
    [anon_sym___inline] = ACTIONS(5558),
    [anon_sym___inline__] = ACTIONS(5558),
    [anon_sym___forceinline] = ACTIONS(5558),
    [anon_sym_thread_local] = ACTIONS(5558),
    [anon_sym___thread] = ACTIONS(5558),
    [anon_sym_const] = ACTIONS(5558),
    [anon_sym_constexpr] = ACTIONS(5558),
    [anon_sym_volatile] = ACTIONS(5558),
    [anon_sym_restrict] = ACTIONS(5558),
    [anon_sym___restrict__] = ACTIONS(5558),
    [anon_sym__Atomic] = ACTIONS(5558),
    [anon_sym__Noreturn] = ACTIONS(5558),
    [anon_sym_noreturn] = ACTIONS(5558),
    [anon_sym_mutable] = ACTIONS(5558),
    [anon_sym_constinit] = ACTIONS(5558),
    [anon_sym_consteval] = ACTIONS(5558),
    [anon_sym_PROGMEM] = ACTIONS(5558),
    [aux_sym_primitive_type_token1] = ACTIONS(5558),
    [anon_sym_byte] = ACTIONS(5558),
    [anon_sym_word] = ACTIONS(5558),
    [anon_sym_enum] = ACTIONS(5558),
    [anon_sym_class] = ACTIONS(5558),
    [anon_sym_struct] = ACTIONS(5558),
    [anon_sym_union] = ACTIONS(5558),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5558),
    [anon_sym_decltype] = ACTIONS(5558),
    [anon_sym_virtual] = ACTIONS(5558),
    [anon_sym_alignas] = ACTIONS(5558),
    [anon_sym_explicit] = ACTIONS(5558),
    [anon_sym_typename] = ACTIONS(5558),
    [anon_sym_template] = ACTIONS(5558),
    [anon_sym_operator] = ACTIONS(5558),
    [anon_sym_friend] = ACTIONS(5558),
    [anon_sym_public] = ACTIONS(5558),
    [anon_sym_private] = ACTIONS(5558),
    [anon_sym_protected] = ACTIONS(5558),
    [anon_sym_using] = ACTIONS(5558),
    [anon_sym_static_assert] = ACTIONS(5558),
  },
  [2395] = {
    [sym_identifier] = ACTIONS(3435),
    [aux_sym_preproc_def_token1] = ACTIONS(3435),
    [aux_sym_preproc_if_token1] = ACTIONS(3435),
    [aux_sym_preproc_if_token2] = ACTIONS(3435),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3435),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3435),
    [aux_sym_preproc_else_token1] = ACTIONS(3435),
    [aux_sym_preproc_elif_token1] = ACTIONS(3435),
    [sym_preproc_directive] = ACTIONS(3435),
    [anon_sym_LPAREN2] = ACTIONS(3437),
    [anon_sym_TILDE] = ACTIONS(3437),
    [anon_sym_STAR] = ACTIONS(3437),
    [anon_sym_AMP_AMP] = ACTIONS(3437),
    [anon_sym_AMP] = ACTIONS(3435),
    [anon_sym___extension__] = ACTIONS(3435),
    [anon_sym_typedef] = ACTIONS(3435),
    [anon_sym_extern] = ACTIONS(3435),
    [anon_sym___attribute__] = ACTIONS(3435),
    [anon_sym_COLON_COLON] = ACTIONS(3437),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3437),
    [anon_sym___declspec] = ACTIONS(3435),
    [anon_sym___based] = ACTIONS(3435),
    [anon_sym_signed] = ACTIONS(3435),
    [anon_sym_unsigned] = ACTIONS(3435),
    [anon_sym_long] = ACTIONS(3435),
    [anon_sym_short] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3435),
    [anon_sym_static] = ACTIONS(3435),
    [anon_sym_register] = ACTIONS(3435),
    [anon_sym_inline] = ACTIONS(3435),
    [anon_sym___inline] = ACTIONS(3435),
    [anon_sym___inline__] = ACTIONS(3435),
    [anon_sym___forceinline] = ACTIONS(3435),
    [anon_sym_thread_local] = ACTIONS(3435),
    [anon_sym___thread] = ACTIONS(3435),
    [anon_sym_const] = ACTIONS(3435),
    [anon_sym_constexpr] = ACTIONS(3435),
    [anon_sym_volatile] = ACTIONS(3435),
    [anon_sym_restrict] = ACTIONS(3435),
    [anon_sym___restrict__] = ACTIONS(3435),
    [anon_sym__Atomic] = ACTIONS(3435),
    [anon_sym__Noreturn] = ACTIONS(3435),
    [anon_sym_noreturn] = ACTIONS(3435),
    [anon_sym_mutable] = ACTIONS(3435),
    [anon_sym_constinit] = ACTIONS(3435),
    [anon_sym_consteval] = ACTIONS(3435),
    [anon_sym_PROGMEM] = ACTIONS(3435),
    [aux_sym_primitive_type_token1] = ACTIONS(3435),
    [anon_sym_byte] = ACTIONS(3435),
    [anon_sym_word] = ACTIONS(3435),
    [anon_sym_enum] = ACTIONS(3435),
    [anon_sym_class] = ACTIONS(3435),
    [anon_sym_struct] = ACTIONS(3435),
    [anon_sym_union] = ACTIONS(3435),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3435),
    [anon_sym_decltype] = ACTIONS(3435),
    [anon_sym_virtual] = ACTIONS(3435),
    [anon_sym_alignas] = ACTIONS(3435),
    [anon_sym_explicit] = ACTIONS(3435),
    [anon_sym_typename] = ACTIONS(3435),
    [anon_sym_template] = ACTIONS(3435),
    [anon_sym_operator] = ACTIONS(3435),
    [anon_sym_friend] = ACTIONS(3435),
    [anon_sym_public] = ACTIONS(3435),
    [anon_sym_private] = ACTIONS(3435),
    [anon_sym_protected] = ACTIONS(3435),
    [anon_sym_using] = ACTIONS(3435),
    [anon_sym_static_assert] = ACTIONS(3435),
  },
  [2396] = {
    [sym_identifier] = ACTIONS(5558),
    [aux_sym_preproc_def_token1] = ACTIONS(5558),
    [aux_sym_preproc_if_token1] = ACTIONS(5558),
    [aux_sym_preproc_if_token2] = ACTIONS(5558),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5558),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5558),
    [aux_sym_preproc_else_token1] = ACTIONS(5558),
    [aux_sym_preproc_elif_token1] = ACTIONS(5558),
    [sym_preproc_directive] = ACTIONS(5558),
    [anon_sym_LPAREN2] = ACTIONS(5560),
    [anon_sym_TILDE] = ACTIONS(5560),
    [anon_sym_STAR] = ACTIONS(5560),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_AMP] = ACTIONS(5558),
    [anon_sym___extension__] = ACTIONS(5558),
    [anon_sym_typedef] = ACTIONS(5558),
    [anon_sym_extern] = ACTIONS(5558),
    [anon_sym___attribute__] = ACTIONS(5558),
    [anon_sym_COLON_COLON] = ACTIONS(5560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5560),
    [anon_sym___declspec] = ACTIONS(5558),
    [anon_sym___based] = ACTIONS(5558),
    [anon_sym_signed] = ACTIONS(5558),
    [anon_sym_unsigned] = ACTIONS(5558),
    [anon_sym_long] = ACTIONS(5558),
    [anon_sym_short] = ACTIONS(5558),
    [anon_sym_LBRACK] = ACTIONS(5558),
    [anon_sym_static] = ACTIONS(5558),
    [anon_sym_register] = ACTIONS(5558),
    [anon_sym_inline] = ACTIONS(5558),
    [anon_sym___inline] = ACTIONS(5558),
    [anon_sym___inline__] = ACTIONS(5558),
    [anon_sym___forceinline] = ACTIONS(5558),
    [anon_sym_thread_local] = ACTIONS(5558),
    [anon_sym___thread] = ACTIONS(5558),
    [anon_sym_const] = ACTIONS(5558),
    [anon_sym_constexpr] = ACTIONS(5558),
    [anon_sym_volatile] = ACTIONS(5558),
    [anon_sym_restrict] = ACTIONS(5558),
    [anon_sym___restrict__] = ACTIONS(5558),
    [anon_sym__Atomic] = ACTIONS(5558),
    [anon_sym__Noreturn] = ACTIONS(5558),
    [anon_sym_noreturn] = ACTIONS(5558),
    [anon_sym_mutable] = ACTIONS(5558),
    [anon_sym_constinit] = ACTIONS(5558),
    [anon_sym_consteval] = ACTIONS(5558),
    [anon_sym_PROGMEM] = ACTIONS(5558),
    [aux_sym_primitive_type_token1] = ACTIONS(5558),
    [anon_sym_byte] = ACTIONS(5558),
    [anon_sym_word] = ACTIONS(5558),
    [anon_sym_enum] = ACTIONS(5558),
    [anon_sym_class] = ACTIONS(5558),
    [anon_sym_struct] = ACTIONS(5558),
    [anon_sym_union] = ACTIONS(5558),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5558),
    [anon_sym_decltype] = ACTIONS(5558),
    [anon_sym_virtual] = ACTIONS(5558),
    [anon_sym_alignas] = ACTIONS(5558),
    [anon_sym_explicit] = ACTIONS(5558),
    [anon_sym_typename] = ACTIONS(5558),
    [anon_sym_template] = ACTIONS(5558),
    [anon_sym_operator] = ACTIONS(5558),
    [anon_sym_friend] = ACTIONS(5558),
    [anon_sym_public] = ACTIONS(5558),
    [anon_sym_private] = ACTIONS(5558),
    [anon_sym_protected] = ACTIONS(5558),
    [anon_sym_using] = ACTIONS(5558),
    [anon_sym_static_assert] = ACTIONS(5558),
  },
  [2397] = {
    [sym_identifier] = ACTIONS(3186),
    [aux_sym_preproc_def_token1] = ACTIONS(3186),
    [aux_sym_preproc_if_token1] = ACTIONS(3186),
    [aux_sym_preproc_if_token2] = ACTIONS(3186),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3186),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3186),
    [aux_sym_preproc_else_token1] = ACTIONS(3186),
    [aux_sym_preproc_elif_token1] = ACTIONS(3186),
    [sym_preproc_directive] = ACTIONS(3186),
    [anon_sym_LPAREN2] = ACTIONS(3188),
    [anon_sym_TILDE] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(3188),
    [anon_sym_AMP_AMP] = ACTIONS(3188),
    [anon_sym_AMP] = ACTIONS(3186),
    [anon_sym___extension__] = ACTIONS(3186),
    [anon_sym_typedef] = ACTIONS(3186),
    [anon_sym_extern] = ACTIONS(3186),
    [anon_sym___attribute__] = ACTIONS(3186),
    [anon_sym_COLON_COLON] = ACTIONS(3188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3188),
    [anon_sym___declspec] = ACTIONS(3186),
    [anon_sym___based] = ACTIONS(3186),
    [anon_sym_signed] = ACTIONS(3186),
    [anon_sym_unsigned] = ACTIONS(3186),
    [anon_sym_long] = ACTIONS(3186),
    [anon_sym_short] = ACTIONS(3186),
    [anon_sym_LBRACK] = ACTIONS(3186),
    [anon_sym_static] = ACTIONS(3186),
    [anon_sym_register] = ACTIONS(3186),
    [anon_sym_inline] = ACTIONS(3186),
    [anon_sym___inline] = ACTIONS(3186),
    [anon_sym___inline__] = ACTIONS(3186),
    [anon_sym___forceinline] = ACTIONS(3186),
    [anon_sym_thread_local] = ACTIONS(3186),
    [anon_sym___thread] = ACTIONS(3186),
    [anon_sym_const] = ACTIONS(3186),
    [anon_sym_constexpr] = ACTIONS(3186),
    [anon_sym_volatile] = ACTIONS(3186),
    [anon_sym_restrict] = ACTIONS(3186),
    [anon_sym___restrict__] = ACTIONS(3186),
    [anon_sym__Atomic] = ACTIONS(3186),
    [anon_sym__Noreturn] = ACTIONS(3186),
    [anon_sym_noreturn] = ACTIONS(3186),
    [anon_sym_mutable] = ACTIONS(3186),
    [anon_sym_constinit] = ACTIONS(3186),
    [anon_sym_consteval] = ACTIONS(3186),
    [anon_sym_PROGMEM] = ACTIONS(3186),
    [aux_sym_primitive_type_token1] = ACTIONS(3186),
    [anon_sym_byte] = ACTIONS(3186),
    [anon_sym_word] = ACTIONS(3186),
    [anon_sym_enum] = ACTIONS(3186),
    [anon_sym_class] = ACTIONS(3186),
    [anon_sym_struct] = ACTIONS(3186),
    [anon_sym_union] = ACTIONS(3186),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3186),
    [anon_sym_decltype] = ACTIONS(3186),
    [anon_sym_virtual] = ACTIONS(3186),
    [anon_sym_alignas] = ACTIONS(3186),
    [anon_sym_explicit] = ACTIONS(3186),
    [anon_sym_typename] = ACTIONS(3186),
    [anon_sym_template] = ACTIONS(3186),
    [anon_sym_operator] = ACTIONS(3186),
    [anon_sym_friend] = ACTIONS(3186),
    [anon_sym_public] = ACTIONS(3186),
    [anon_sym_private] = ACTIONS(3186),
    [anon_sym_protected] = ACTIONS(3186),
    [anon_sym_using] = ACTIONS(3186),
    [anon_sym_static_assert] = ACTIONS(3186),
  },
  [2398] = {
    [sym_identifier] = ACTIONS(3387),
    [aux_sym_preproc_def_token1] = ACTIONS(3387),
    [aux_sym_preproc_if_token1] = ACTIONS(3387),
    [aux_sym_preproc_if_token2] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3387),
    [aux_sym_preproc_else_token1] = ACTIONS(3387),
    [aux_sym_preproc_elif_token1] = ACTIONS(3387),
    [sym_preproc_directive] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_STAR] = ACTIONS(3389),
    [anon_sym_AMP_AMP] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym___extension__] = ACTIONS(3387),
    [anon_sym_typedef] = ACTIONS(3387),
    [anon_sym_extern] = ACTIONS(3387),
    [anon_sym___attribute__] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3389),
    [anon_sym___declspec] = ACTIONS(3387),
    [anon_sym___based] = ACTIONS(3387),
    [anon_sym_signed] = ACTIONS(3387),
    [anon_sym_unsigned] = ACTIONS(3387),
    [anon_sym_long] = ACTIONS(3387),
    [anon_sym_short] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_register] = ACTIONS(3387),
    [anon_sym_inline] = ACTIONS(3387),
    [anon_sym___inline] = ACTIONS(3387),
    [anon_sym___inline__] = ACTIONS(3387),
    [anon_sym___forceinline] = ACTIONS(3387),
    [anon_sym_thread_local] = ACTIONS(3387),
    [anon_sym___thread] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_constexpr] = ACTIONS(3387),
    [anon_sym_volatile] = ACTIONS(3387),
    [anon_sym_restrict] = ACTIONS(3387),
    [anon_sym___restrict__] = ACTIONS(3387),
    [anon_sym__Atomic] = ACTIONS(3387),
    [anon_sym__Noreturn] = ACTIONS(3387),
    [anon_sym_noreturn] = ACTIONS(3387),
    [anon_sym_mutable] = ACTIONS(3387),
    [anon_sym_constinit] = ACTIONS(3387),
    [anon_sym_consteval] = ACTIONS(3387),
    [anon_sym_PROGMEM] = ACTIONS(3387),
    [aux_sym_primitive_type_token1] = ACTIONS(3387),
    [anon_sym_byte] = ACTIONS(3387),
    [anon_sym_word] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [anon_sym_class] = ACTIONS(3387),
    [anon_sym_struct] = ACTIONS(3387),
    [anon_sym_union] = ACTIONS(3387),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3387),
    [anon_sym_decltype] = ACTIONS(3387),
    [anon_sym_virtual] = ACTIONS(3387),
    [anon_sym_alignas] = ACTIONS(3387),
    [anon_sym_explicit] = ACTIONS(3387),
    [anon_sym_typename] = ACTIONS(3387),
    [anon_sym_template] = ACTIONS(3387),
    [anon_sym_operator] = ACTIONS(3387),
    [anon_sym_friend] = ACTIONS(3387),
    [anon_sym_public] = ACTIONS(3387),
    [anon_sym_private] = ACTIONS(3387),
    [anon_sym_protected] = ACTIONS(3387),
    [anon_sym_using] = ACTIONS(3387),
    [anon_sym_static_assert] = ACTIONS(3387),
  },
  [2399] = {
    [sym_identifier] = ACTIONS(5507),
    [aux_sym_preproc_def_token1] = ACTIONS(5507),
    [aux_sym_preproc_if_token1] = ACTIONS(5507),
    [aux_sym_preproc_if_token2] = ACTIONS(5507),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5507),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5507),
    [aux_sym_preproc_else_token1] = ACTIONS(5507),
    [aux_sym_preproc_elif_token1] = ACTIONS(5507),
    [sym_preproc_directive] = ACTIONS(5507),
    [anon_sym_LPAREN2] = ACTIONS(5509),
    [anon_sym_TILDE] = ACTIONS(5509),
    [anon_sym_STAR] = ACTIONS(5509),
    [anon_sym_AMP_AMP] = ACTIONS(5509),
    [anon_sym_AMP] = ACTIONS(5507),
    [anon_sym___extension__] = ACTIONS(5507),
    [anon_sym_typedef] = ACTIONS(5507),
    [anon_sym_extern] = ACTIONS(5507),
    [anon_sym___attribute__] = ACTIONS(5507),
    [anon_sym_COLON_COLON] = ACTIONS(5509),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5509),
    [anon_sym___declspec] = ACTIONS(5507),
    [anon_sym___based] = ACTIONS(5507),
    [anon_sym_signed] = ACTIONS(5507),
    [anon_sym_unsigned] = ACTIONS(5507),
    [anon_sym_long] = ACTIONS(5507),
    [anon_sym_short] = ACTIONS(5507),
    [anon_sym_LBRACK] = ACTIONS(5507),
    [anon_sym_static] = ACTIONS(5507),
    [anon_sym_register] = ACTIONS(5507),
    [anon_sym_inline] = ACTIONS(5507),
    [anon_sym___inline] = ACTIONS(5507),
    [anon_sym___inline__] = ACTIONS(5507),
    [anon_sym___forceinline] = ACTIONS(5507),
    [anon_sym_thread_local] = ACTIONS(5507),
    [anon_sym___thread] = ACTIONS(5507),
    [anon_sym_const] = ACTIONS(5507),
    [anon_sym_constexpr] = ACTIONS(5507),
    [anon_sym_volatile] = ACTIONS(5507),
    [anon_sym_restrict] = ACTIONS(5507),
    [anon_sym___restrict__] = ACTIONS(5507),
    [anon_sym__Atomic] = ACTIONS(5507),
    [anon_sym__Noreturn] = ACTIONS(5507),
    [anon_sym_noreturn] = ACTIONS(5507),
    [anon_sym_mutable] = ACTIONS(5507),
    [anon_sym_constinit] = ACTIONS(5507),
    [anon_sym_consteval] = ACTIONS(5507),
    [anon_sym_PROGMEM] = ACTIONS(5507),
    [aux_sym_primitive_type_token1] = ACTIONS(5507),
    [anon_sym_byte] = ACTIONS(5507),
    [anon_sym_word] = ACTIONS(5507),
    [anon_sym_enum] = ACTIONS(5507),
    [anon_sym_class] = ACTIONS(5507),
    [anon_sym_struct] = ACTIONS(5507),
    [anon_sym_union] = ACTIONS(5507),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5507),
    [anon_sym_decltype] = ACTIONS(5507),
    [anon_sym_virtual] = ACTIONS(5507),
    [anon_sym_alignas] = ACTIONS(5507),
    [anon_sym_explicit] = ACTIONS(5507),
    [anon_sym_typename] = ACTIONS(5507),
    [anon_sym_template] = ACTIONS(5507),
    [anon_sym_operator] = ACTIONS(5507),
    [anon_sym_friend] = ACTIONS(5507),
    [anon_sym_public] = ACTIONS(5507),
    [anon_sym_private] = ACTIONS(5507),
    [anon_sym_protected] = ACTIONS(5507),
    [anon_sym_using] = ACTIONS(5507),
    [anon_sym_static_assert] = ACTIONS(5507),
  },
  [2400] = {
    [sym_template_argument_list] = STATE(2436),
    [sym_identifier] = ACTIONS(5835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4272),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_RPAREN] = ACTIONS(4272),
    [aux_sym_preproc_if_token2] = ACTIONS(4272),
    [aux_sym_preproc_else_token1] = ACTIONS(4272),
    [aux_sym_preproc_elif_token1] = ACTIONS(5835),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4272),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4272),
    [anon_sym_LPAREN2] = ACTIONS(4272),
    [anon_sym_DASH] = ACTIONS(5835),
    [anon_sym_PLUS] = ACTIONS(5835),
    [anon_sym_STAR] = ACTIONS(5835),
    [anon_sym_SLASH] = ACTIONS(5835),
    [anon_sym_PERCENT] = ACTIONS(5835),
    [anon_sym_PIPE_PIPE] = ACTIONS(4272),
    [anon_sym_AMP_AMP] = ACTIONS(4272),
    [anon_sym_PIPE] = ACTIONS(5835),
    [anon_sym_CARET] = ACTIONS(5835),
    [anon_sym_AMP] = ACTIONS(5835),
    [anon_sym_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(5835),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(5835),
    [anon_sym_LT] = ACTIONS(5837),
    [anon_sym_LT_LT] = ACTIONS(5835),
    [anon_sym_GT_GT] = ACTIONS(5835),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym___attribute__] = ACTIONS(5835),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_RBRACE] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_RBRACK] = ACTIONS(4272),
    [anon_sym_EQ] = ACTIONS(5835),
    [anon_sym_COLON] = ACTIONS(5835),
    [anon_sym_QMARK] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_and_eq] = ACTIONS(5835),
    [anon_sym_or_eq] = ACTIONS(5835),
    [anon_sym_xor_eq] = ACTIONS(5835),
    [anon_sym_LT_EQ_GT] = ACTIONS(4272),
    [anon_sym_or] = ACTIONS(5835),
    [anon_sym_and] = ACTIONS(5835),
    [anon_sym_bitor] = ACTIONS(5835),
    [anon_sym_xor] = ACTIONS(5835),
    [anon_sym_bitand] = ACTIONS(5835),
    [anon_sym_not_eq] = ACTIONS(5835),
    [anon_sym_DASH_DASH] = ACTIONS(4272),
    [anon_sym_PLUS_PLUS] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5835),
    [anon_sym_DOT_STAR] = ACTIONS(4272),
    [anon_sym_DASH_GT] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5835),
    [anon_sym_decltype] = ACTIONS(5835),
    [anon_sym_final] = ACTIONS(5835),
    [anon_sym_override] = ACTIONS(5835),
  },
  [2401] = {
    [sym_primitive_type] = STATE(2760),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2427),
    [sym_identifier] = ACTIONS(5839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5489),
    [anon_sym_COMMA] = ACTIONS(5489),
    [aux_sym_preproc_if_token2] = ACTIONS(5489),
    [aux_sym_preproc_else_token1] = ACTIONS(5489),
    [aux_sym_preproc_elif_token1] = ACTIONS(5491),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5489),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5489),
    [anon_sym_LPAREN2] = ACTIONS(5489),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_PLUS] = ACTIONS(5491),
    [anon_sym_STAR] = ACTIONS(5491),
    [anon_sym_SLASH] = ACTIONS(5491),
    [anon_sym_PERCENT] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5489),
    [anon_sym_AMP_AMP] = ACTIONS(5489),
    [anon_sym_PIPE] = ACTIONS(5491),
    [anon_sym_CARET] = ACTIONS(5491),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_EQ_EQ] = ACTIONS(5489),
    [anon_sym_BANG_EQ] = ACTIONS(5489),
    [anon_sym_GT] = ACTIONS(5491),
    [anon_sym_GT_EQ] = ACTIONS(5489),
    [anon_sym_LT_EQ] = ACTIONS(5491),
    [anon_sym_LT] = ACTIONS(5491),
    [anon_sym_LT_LT] = ACTIONS(5491),
    [anon_sym_GT_GT] = ACTIONS(5491),
    [anon_sym___attribute__] = ACTIONS(5491),
    [anon_sym_LBRACE] = ACTIONS(5489),
    [anon_sym_signed] = ACTIONS(5842),
    [anon_sym_unsigned] = ACTIONS(5842),
    [anon_sym_long] = ACTIONS(5842),
    [anon_sym_short] = ACTIONS(5842),
    [anon_sym_LBRACK] = ACTIONS(5489),
    [anon_sym_EQ] = ACTIONS(5491),
    [aux_sym_primitive_type_token1] = ACTIONS(5807),
    [anon_sym_byte] = ACTIONS(5807),
    [anon_sym_word] = ACTIONS(5807),
    [anon_sym_QMARK] = ACTIONS(5489),
    [anon_sym_STAR_EQ] = ACTIONS(5489),
    [anon_sym_SLASH_EQ] = ACTIONS(5489),
    [anon_sym_PERCENT_EQ] = ACTIONS(5489),
    [anon_sym_PLUS_EQ] = ACTIONS(5489),
    [anon_sym_DASH_EQ] = ACTIONS(5489),
    [anon_sym_LT_LT_EQ] = ACTIONS(5489),
    [anon_sym_GT_GT_EQ] = ACTIONS(5489),
    [anon_sym_AMP_EQ] = ACTIONS(5489),
    [anon_sym_CARET_EQ] = ACTIONS(5489),
    [anon_sym_PIPE_EQ] = ACTIONS(5489),
    [anon_sym_and_eq] = ACTIONS(5491),
    [anon_sym_or_eq] = ACTIONS(5491),
    [anon_sym_xor_eq] = ACTIONS(5491),
    [anon_sym_LT_EQ_GT] = ACTIONS(5489),
    [anon_sym_or] = ACTIONS(5491),
    [anon_sym_and] = ACTIONS(5491),
    [anon_sym_bitor] = ACTIONS(5491),
    [anon_sym_xor] = ACTIONS(5491),
    [anon_sym_bitand] = ACTIONS(5491),
    [anon_sym_not_eq] = ACTIONS(5491),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_DOT] = ACTIONS(5491),
    [anon_sym_DOT_STAR] = ACTIONS(5489),
    [anon_sym_DASH_GT] = ACTIONS(5489),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5491),
    [anon_sym_decltype] = ACTIONS(5491),
  },
  [2402] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [anon_sym_COMMA] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(5405),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym_RBRACE] = ACTIONS(2265),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_friend] = ACTIONS(2267),
    [anon_sym_public] = ACTIONS(2267),
    [anon_sym_private] = ACTIONS(2267),
    [anon_sym_protected] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
  },
  [2403] = {
    [sym_identifier] = ACTIONS(3124),
    [aux_sym_preproc_def_token1] = ACTIONS(3124),
    [aux_sym_preproc_if_token1] = ACTIONS(3124),
    [aux_sym_preproc_if_token2] = ACTIONS(3124),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3124),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3124),
    [aux_sym_preproc_else_token1] = ACTIONS(3124),
    [aux_sym_preproc_elif_token1] = ACTIONS(3124),
    [sym_preproc_directive] = ACTIONS(3124),
    [anon_sym_LPAREN2] = ACTIONS(3126),
    [anon_sym_TILDE] = ACTIONS(3126),
    [anon_sym_STAR] = ACTIONS(3126),
    [anon_sym_AMP_AMP] = ACTIONS(3126),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3124),
    [anon_sym_typedef] = ACTIONS(3124),
    [anon_sym_extern] = ACTIONS(3124),
    [anon_sym___attribute__] = ACTIONS(3124),
    [anon_sym_COLON_COLON] = ACTIONS(3126),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3126),
    [anon_sym___declspec] = ACTIONS(3124),
    [anon_sym___based] = ACTIONS(3124),
    [anon_sym_signed] = ACTIONS(3124),
    [anon_sym_unsigned] = ACTIONS(3124),
    [anon_sym_long] = ACTIONS(3124),
    [anon_sym_short] = ACTIONS(3124),
    [anon_sym_LBRACK] = ACTIONS(3124),
    [anon_sym_static] = ACTIONS(3124),
    [anon_sym_register] = ACTIONS(3124),
    [anon_sym_inline] = ACTIONS(3124),
    [anon_sym___inline] = ACTIONS(3124),
    [anon_sym___inline__] = ACTIONS(3124),
    [anon_sym___forceinline] = ACTIONS(3124),
    [anon_sym_thread_local] = ACTIONS(3124),
    [anon_sym___thread] = ACTIONS(3124),
    [anon_sym_const] = ACTIONS(3124),
    [anon_sym_constexpr] = ACTIONS(3124),
    [anon_sym_volatile] = ACTIONS(3124),
    [anon_sym_restrict] = ACTIONS(3124),
    [anon_sym___restrict__] = ACTIONS(3124),
    [anon_sym__Atomic] = ACTIONS(3124),
    [anon_sym__Noreturn] = ACTIONS(3124),
    [anon_sym_noreturn] = ACTIONS(3124),
    [anon_sym_mutable] = ACTIONS(3124),
    [anon_sym_constinit] = ACTIONS(3124),
    [anon_sym_consteval] = ACTIONS(3124),
    [anon_sym_PROGMEM] = ACTIONS(3124),
    [aux_sym_primitive_type_token1] = ACTIONS(3124),
    [anon_sym_byte] = ACTIONS(3124),
    [anon_sym_word] = ACTIONS(3124),
    [anon_sym_enum] = ACTIONS(3124),
    [anon_sym_class] = ACTIONS(3124),
    [anon_sym_struct] = ACTIONS(3124),
    [anon_sym_union] = ACTIONS(3124),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3124),
    [anon_sym_decltype] = ACTIONS(3124),
    [anon_sym_virtual] = ACTIONS(3124),
    [anon_sym_alignas] = ACTIONS(3124),
    [anon_sym_explicit] = ACTIONS(3124),
    [anon_sym_typename] = ACTIONS(3124),
    [anon_sym_template] = ACTIONS(3124),
    [anon_sym_operator] = ACTIONS(3124),
    [anon_sym_friend] = ACTIONS(3124),
    [anon_sym_public] = ACTIONS(3124),
    [anon_sym_private] = ACTIONS(3124),
    [anon_sym_protected] = ACTIONS(3124),
    [anon_sym_using] = ACTIONS(3124),
    [anon_sym_static_assert] = ACTIONS(3124),
  },
  [2404] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(2265),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym_RBRACE] = ACTIONS(2265),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_friend] = ACTIONS(2267),
    [anon_sym_public] = ACTIONS(2267),
    [anon_sym_private] = ACTIONS(2267),
    [anon_sym_protected] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym_catch] = ACTIONS(2267),
  },
  [2405] = {
    [sym_template_argument_list] = STATE(2417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5133),
    [anon_sym_COMMA] = ACTIONS(5133),
    [anon_sym_LPAREN2] = ACTIONS(5133),
    [anon_sym_DASH] = ACTIONS(5138),
    [anon_sym_PLUS] = ACTIONS(5138),
    [anon_sym_STAR] = ACTIONS(5140),
    [anon_sym_SLASH] = ACTIONS(5138),
    [anon_sym_PERCENT] = ACTIONS(5138),
    [anon_sym_PIPE_PIPE] = ACTIONS(5131),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5138),
    [anon_sym_CARET] = ACTIONS(5138),
    [anon_sym_AMP] = ACTIONS(5140),
    [anon_sym_EQ_EQ] = ACTIONS(5131),
    [anon_sym_BANG_EQ] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5138),
    [anon_sym_GT_EQ] = ACTIONS(5138),
    [anon_sym_LT_EQ] = ACTIONS(5138),
    [anon_sym_LT] = ACTIONS(5844),
    [anon_sym_LT_LT] = ACTIONS(5138),
    [anon_sym_GT_GT] = ACTIONS(5138),
    [anon_sym___extension__] = ACTIONS(5136),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_LBRACK] = ACTIONS(5133),
    [anon_sym_EQ] = ACTIONS(5138),
    [anon_sym_const] = ACTIONS(5129),
    [anon_sym_constexpr] = ACTIONS(5136),
    [anon_sym_volatile] = ACTIONS(5136),
    [anon_sym_restrict] = ACTIONS(5136),
    [anon_sym___restrict__] = ACTIONS(5136),
    [anon_sym__Atomic] = ACTIONS(5136),
    [anon_sym__Noreturn] = ACTIONS(5136),
    [anon_sym_noreturn] = ACTIONS(5136),
    [anon_sym_mutable] = ACTIONS(5136),
    [anon_sym_constinit] = ACTIONS(5136),
    [anon_sym_consteval] = ACTIONS(5136),
    [anon_sym_PROGMEM] = ACTIONS(5136),
    [anon_sym_QMARK] = ACTIONS(5131),
    [anon_sym_STAR_EQ] = ACTIONS(5131),
    [anon_sym_SLASH_EQ] = ACTIONS(5131),
    [anon_sym_PERCENT_EQ] = ACTIONS(5131),
    [anon_sym_PLUS_EQ] = ACTIONS(5131),
    [anon_sym_DASH_EQ] = ACTIONS(5131),
    [anon_sym_LT_LT_EQ] = ACTIONS(5131),
    [anon_sym_GT_GT_EQ] = ACTIONS(5138),
    [anon_sym_AMP_EQ] = ACTIONS(5131),
    [anon_sym_CARET_EQ] = ACTIONS(5131),
    [anon_sym_PIPE_EQ] = ACTIONS(5131),
    [anon_sym_and_eq] = ACTIONS(5131),
    [anon_sym_or_eq] = ACTIONS(5131),
    [anon_sym_xor_eq] = ACTIONS(5131),
    [anon_sym_LT_EQ_GT] = ACTIONS(5131),
    [anon_sym_or] = ACTIONS(5138),
    [anon_sym_and] = ACTIONS(5138),
    [anon_sym_bitor] = ACTIONS(5131),
    [anon_sym_xor] = ACTIONS(5138),
    [anon_sym_bitand] = ACTIONS(5131),
    [anon_sym_not_eq] = ACTIONS(5131),
    [anon_sym_DASH_DASH] = ACTIONS(5131),
    [anon_sym_PLUS_PLUS] = ACTIONS(5131),
    [anon_sym_DOT] = ACTIONS(5138),
    [anon_sym_DOT_STAR] = ACTIONS(5131),
    [anon_sym_DASH_GT] = ACTIONS(5131),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5136),
    [anon_sym_decltype] = ACTIONS(5136),
    [anon_sym_GT2] = ACTIONS(5133),
  },
  [2406] = {
    [sym_identifier] = ACTIONS(3314),
    [aux_sym_preproc_def_token1] = ACTIONS(3314),
    [aux_sym_preproc_if_token1] = ACTIONS(3314),
    [aux_sym_preproc_if_token2] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3314),
    [aux_sym_preproc_else_token1] = ACTIONS(3314),
    [aux_sym_preproc_elif_token1] = ACTIONS(3314),
    [sym_preproc_directive] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_STAR] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym___extension__] = ACTIONS(3314),
    [anon_sym_typedef] = ACTIONS(3314),
    [anon_sym_extern] = ACTIONS(3314),
    [anon_sym___attribute__] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3316),
    [anon_sym___declspec] = ACTIONS(3314),
    [anon_sym___based] = ACTIONS(3314),
    [anon_sym_signed] = ACTIONS(3314),
    [anon_sym_unsigned] = ACTIONS(3314),
    [anon_sym_long] = ACTIONS(3314),
    [anon_sym_short] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_static] = ACTIONS(3314),
    [anon_sym_register] = ACTIONS(3314),
    [anon_sym_inline] = ACTIONS(3314),
    [anon_sym___inline] = ACTIONS(3314),
    [anon_sym___inline__] = ACTIONS(3314),
    [anon_sym___forceinline] = ACTIONS(3314),
    [anon_sym_thread_local] = ACTIONS(3314),
    [anon_sym___thread] = ACTIONS(3314),
    [anon_sym_const] = ACTIONS(3314),
    [anon_sym_constexpr] = ACTIONS(3314),
    [anon_sym_volatile] = ACTIONS(3314),
    [anon_sym_restrict] = ACTIONS(3314),
    [anon_sym___restrict__] = ACTIONS(3314),
    [anon_sym__Atomic] = ACTIONS(3314),
    [anon_sym__Noreturn] = ACTIONS(3314),
    [anon_sym_noreturn] = ACTIONS(3314),
    [anon_sym_mutable] = ACTIONS(3314),
    [anon_sym_constinit] = ACTIONS(3314),
    [anon_sym_consteval] = ACTIONS(3314),
    [anon_sym_PROGMEM] = ACTIONS(3314),
    [aux_sym_primitive_type_token1] = ACTIONS(3314),
    [anon_sym_byte] = ACTIONS(3314),
    [anon_sym_word] = ACTIONS(3314),
    [anon_sym_enum] = ACTIONS(3314),
    [anon_sym_class] = ACTIONS(3314),
    [anon_sym_struct] = ACTIONS(3314),
    [anon_sym_union] = ACTIONS(3314),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3314),
    [anon_sym_decltype] = ACTIONS(3314),
    [anon_sym_virtual] = ACTIONS(3314),
    [anon_sym_alignas] = ACTIONS(3314),
    [anon_sym_explicit] = ACTIONS(3314),
    [anon_sym_typename] = ACTIONS(3314),
    [anon_sym_template] = ACTIONS(3314),
    [anon_sym_operator] = ACTIONS(3314),
    [anon_sym_friend] = ACTIONS(3314),
    [anon_sym_public] = ACTIONS(3314),
    [anon_sym_private] = ACTIONS(3314),
    [anon_sym_protected] = ACTIONS(3314),
    [anon_sym_using] = ACTIONS(3314),
    [anon_sym_static_assert] = ACTIONS(3314),
  },
  [2407] = {
    [sym_argument_list] = STATE(2946),
    [sym_initializer_list] = STATE(2946),
    [sym_decltype_auto] = STATE(2728),
    [sym_new_declarator] = STATE(2748),
    [sym_identifier] = ACTIONS(5847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5849),
    [anon_sym_COMMA] = ACTIONS(5849),
    [anon_sym_RPAREN] = ACTIONS(5849),
    [aux_sym_preproc_if_token2] = ACTIONS(5849),
    [aux_sym_preproc_else_token1] = ACTIONS(5849),
    [aux_sym_preproc_elif_token1] = ACTIONS(5847),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5849),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5849),
    [anon_sym_LPAREN2] = ACTIONS(5813),
    [anon_sym_DASH] = ACTIONS(5847),
    [anon_sym_PLUS] = ACTIONS(5847),
    [anon_sym_STAR] = ACTIONS(5847),
    [anon_sym_SLASH] = ACTIONS(5847),
    [anon_sym_PERCENT] = ACTIONS(5847),
    [anon_sym_PIPE_PIPE] = ACTIONS(5849),
    [anon_sym_AMP_AMP] = ACTIONS(5849),
    [anon_sym_PIPE] = ACTIONS(5847),
    [anon_sym_CARET] = ACTIONS(5847),
    [anon_sym_AMP] = ACTIONS(5847),
    [anon_sym_EQ_EQ] = ACTIONS(5849),
    [anon_sym_BANG_EQ] = ACTIONS(5849),
    [anon_sym_GT] = ACTIONS(5847),
    [anon_sym_GT_EQ] = ACTIONS(5849),
    [anon_sym_LT_EQ] = ACTIONS(5847),
    [anon_sym_LT] = ACTIONS(5847),
    [anon_sym_LT_LT] = ACTIONS(5847),
    [anon_sym_GT_GT] = ACTIONS(5847),
    [anon_sym_SEMI] = ACTIONS(5849),
    [anon_sym___attribute__] = ACTIONS(5847),
    [anon_sym_LBRACE] = ACTIONS(2159),
    [anon_sym_RBRACE] = ACTIONS(5849),
    [anon_sym_LBRACK] = ACTIONS(5815),
    [anon_sym_RBRACK] = ACTIONS(5849),
    [anon_sym_EQ] = ACTIONS(5847),
    [anon_sym_COLON] = ACTIONS(5849),
    [anon_sym_QMARK] = ACTIONS(5849),
    [anon_sym_STAR_EQ] = ACTIONS(5849),
    [anon_sym_SLASH_EQ] = ACTIONS(5849),
    [anon_sym_PERCENT_EQ] = ACTIONS(5849),
    [anon_sym_PLUS_EQ] = ACTIONS(5849),
    [anon_sym_DASH_EQ] = ACTIONS(5849),
    [anon_sym_LT_LT_EQ] = ACTIONS(5849),
    [anon_sym_GT_GT_EQ] = ACTIONS(5849),
    [anon_sym_AMP_EQ] = ACTIONS(5849),
    [anon_sym_CARET_EQ] = ACTIONS(5849),
    [anon_sym_PIPE_EQ] = ACTIONS(5849),
    [anon_sym_and_eq] = ACTIONS(5847),
    [anon_sym_or_eq] = ACTIONS(5847),
    [anon_sym_xor_eq] = ACTIONS(5847),
    [anon_sym_LT_EQ_GT] = ACTIONS(5849),
    [anon_sym_or] = ACTIONS(5847),
    [anon_sym_and] = ACTIONS(5847),
    [anon_sym_bitor] = ACTIONS(5847),
    [anon_sym_xor] = ACTIONS(5847),
    [anon_sym_bitand] = ACTIONS(5847),
    [anon_sym_not_eq] = ACTIONS(5847),
    [anon_sym_DASH_DASH] = ACTIONS(5849),
    [anon_sym_PLUS_PLUS] = ACTIONS(5849),
    [anon_sym_DOT] = ACTIONS(5847),
    [anon_sym_DOT_STAR] = ACTIONS(5849),
    [anon_sym_DASH_GT] = ACTIONS(5849),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5817),
    [anon_sym_decltype] = ACTIONS(5819),
  },
  [2408] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5162),
    [anon_sym_COMMA] = ACTIONS(5162),
    [anon_sym_RPAREN] = ACTIONS(5164),
    [anon_sym_LPAREN2] = ACTIONS(5164),
    [anon_sym_DASH] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5169),
    [anon_sym_STAR] = ACTIONS(5171),
    [anon_sym_SLASH] = ACTIONS(5169),
    [anon_sym_PERCENT] = ACTIONS(5169),
    [anon_sym_PIPE_PIPE] = ACTIONS(5162),
    [anon_sym_AMP_AMP] = ACTIONS(5164),
    [anon_sym_PIPE] = ACTIONS(5169),
    [anon_sym_CARET] = ACTIONS(5169),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_EQ] = ACTIONS(5162),
    [anon_sym_GT] = ACTIONS(5169),
    [anon_sym_GT_EQ] = ACTIONS(5162),
    [anon_sym_LT_EQ] = ACTIONS(5169),
    [anon_sym_LT] = ACTIONS(5169),
    [anon_sym_LT_LT] = ACTIONS(5169),
    [anon_sym_GT_GT] = ACTIONS(5169),
    [anon_sym___extension__] = ACTIONS(5167),
    [anon_sym_COLON_COLON] = ACTIONS(5167),
    [anon_sym_LBRACE] = ACTIONS(5167),
    [anon_sym_LBRACK] = ACTIONS(5164),
    [anon_sym_EQ] = ACTIONS(5169),
    [anon_sym_const] = ACTIONS(5160),
    [anon_sym_constexpr] = ACTIONS(5167),
    [anon_sym_volatile] = ACTIONS(5167),
    [anon_sym_restrict] = ACTIONS(5167),
    [anon_sym___restrict__] = ACTIONS(5167),
    [anon_sym__Atomic] = ACTIONS(5167),
    [anon_sym__Noreturn] = ACTIONS(5167),
    [anon_sym_noreturn] = ACTIONS(5167),
    [anon_sym_mutable] = ACTIONS(5167),
    [anon_sym_constinit] = ACTIONS(5167),
    [anon_sym_consteval] = ACTIONS(5167),
    [anon_sym_PROGMEM] = ACTIONS(5167),
    [anon_sym_QMARK] = ACTIONS(5162),
    [anon_sym_STAR_EQ] = ACTIONS(5162),
    [anon_sym_SLASH_EQ] = ACTIONS(5162),
    [anon_sym_PERCENT_EQ] = ACTIONS(5162),
    [anon_sym_PLUS_EQ] = ACTIONS(5162),
    [anon_sym_DASH_EQ] = ACTIONS(5162),
    [anon_sym_LT_LT_EQ] = ACTIONS(5162),
    [anon_sym_GT_GT_EQ] = ACTIONS(5162),
    [anon_sym_AMP_EQ] = ACTIONS(5162),
    [anon_sym_CARET_EQ] = ACTIONS(5162),
    [anon_sym_PIPE_EQ] = ACTIONS(5162),
    [anon_sym_and_eq] = ACTIONS(5162),
    [anon_sym_or_eq] = ACTIONS(5162),
    [anon_sym_xor_eq] = ACTIONS(5162),
    [anon_sym_LT_EQ_GT] = ACTIONS(5162),
    [anon_sym_or] = ACTIONS(5169),
    [anon_sym_and] = ACTIONS(5169),
    [anon_sym_bitor] = ACTIONS(5162),
    [anon_sym_xor] = ACTIONS(5169),
    [anon_sym_bitand] = ACTIONS(5162),
    [anon_sym_not_eq] = ACTIONS(5162),
    [anon_sym_DASH_DASH] = ACTIONS(5162),
    [anon_sym_PLUS_PLUS] = ACTIONS(5162),
    [anon_sym_DOT] = ACTIONS(5169),
    [anon_sym_DOT_STAR] = ACTIONS(5162),
    [anon_sym_DASH_GT] = ACTIONS(5169),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5167),
    [anon_sym_decltype] = ACTIONS(5167),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5162),
  },
  [2409] = {
    [sym_string_literal] = STATE(2432),
    [sym_template_argument_list] = STATE(3450),
    [sym_raw_string_literal] = STATE(2432),
    [sym_identifier] = ACTIONS(4256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [aux_sym_preproc_if_token2] = ACTIONS(4248),
    [aux_sym_preproc_else_token1] = ACTIONS(4248),
    [aux_sym_preproc_elif_token1] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5851),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4256),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4248),
    [anon_sym_SLASH_EQ] = ACTIONS(4248),
    [anon_sym_PERCENT_EQ] = ACTIONS(4248),
    [anon_sym_PLUS_EQ] = ACTIONS(4248),
    [anon_sym_DASH_EQ] = ACTIONS(4248),
    [anon_sym_LT_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT_GT_EQ] = ACTIONS(4248),
    [anon_sym_AMP_EQ] = ACTIONS(4248),
    [anon_sym_CARET_EQ] = ACTIONS(4248),
    [anon_sym_PIPE_EQ] = ACTIONS(4248),
    [anon_sym_and_eq] = ACTIONS(4256),
    [anon_sym_or_eq] = ACTIONS(4256),
    [anon_sym_xor_eq] = ACTIONS(4256),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4256),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4256),
    [anon_sym_not_eq] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
  },
  [2410] = {
    [sym_identifier] = ACTIONS(3403),
    [aux_sym_preproc_def_token1] = ACTIONS(3403),
    [aux_sym_preproc_if_token1] = ACTIONS(3403),
    [aux_sym_preproc_if_token2] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3403),
    [aux_sym_preproc_else_token1] = ACTIONS(3403),
    [aux_sym_preproc_elif_token1] = ACTIONS(3403),
    [sym_preproc_directive] = ACTIONS(3403),
    [anon_sym_LPAREN2] = ACTIONS(3405),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_STAR] = ACTIONS(3405),
    [anon_sym_AMP_AMP] = ACTIONS(3405),
    [anon_sym_AMP] = ACTIONS(3403),
    [anon_sym___extension__] = ACTIONS(3403),
    [anon_sym_typedef] = ACTIONS(3403),
    [anon_sym_extern] = ACTIONS(3403),
    [anon_sym___attribute__] = ACTIONS(3403),
    [anon_sym_COLON_COLON] = ACTIONS(3405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3405),
    [anon_sym___declspec] = ACTIONS(3403),
    [anon_sym___based] = ACTIONS(3403),
    [anon_sym_signed] = ACTIONS(3403),
    [anon_sym_unsigned] = ACTIONS(3403),
    [anon_sym_long] = ACTIONS(3403),
    [anon_sym_short] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3403),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_register] = ACTIONS(3403),
    [anon_sym_inline] = ACTIONS(3403),
    [anon_sym___inline] = ACTIONS(3403),
    [anon_sym___inline__] = ACTIONS(3403),
    [anon_sym___forceinline] = ACTIONS(3403),
    [anon_sym_thread_local] = ACTIONS(3403),
    [anon_sym___thread] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_constexpr] = ACTIONS(3403),
    [anon_sym_volatile] = ACTIONS(3403),
    [anon_sym_restrict] = ACTIONS(3403),
    [anon_sym___restrict__] = ACTIONS(3403),
    [anon_sym__Atomic] = ACTIONS(3403),
    [anon_sym__Noreturn] = ACTIONS(3403),
    [anon_sym_noreturn] = ACTIONS(3403),
    [anon_sym_mutable] = ACTIONS(3403),
    [anon_sym_constinit] = ACTIONS(3403),
    [anon_sym_consteval] = ACTIONS(3403),
    [anon_sym_PROGMEM] = ACTIONS(3403),
    [aux_sym_primitive_type_token1] = ACTIONS(3403),
    [anon_sym_byte] = ACTIONS(3403),
    [anon_sym_word] = ACTIONS(3403),
    [anon_sym_enum] = ACTIONS(3403),
    [anon_sym_class] = ACTIONS(3403),
    [anon_sym_struct] = ACTIONS(3403),
    [anon_sym_union] = ACTIONS(3403),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3403),
    [anon_sym_decltype] = ACTIONS(3403),
    [anon_sym_virtual] = ACTIONS(3403),
    [anon_sym_alignas] = ACTIONS(3403),
    [anon_sym_explicit] = ACTIONS(3403),
    [anon_sym_typename] = ACTIONS(3403),
    [anon_sym_template] = ACTIONS(3403),
    [anon_sym_operator] = ACTIONS(3403),
    [anon_sym_friend] = ACTIONS(3403),
    [anon_sym_public] = ACTIONS(3403),
    [anon_sym_private] = ACTIONS(3403),
    [anon_sym_protected] = ACTIONS(3403),
    [anon_sym_using] = ACTIONS(3403),
    [anon_sym_static_assert] = ACTIONS(3403),
  },
  [2411] = {
    [sym_argument_list] = STATE(3031),
    [sym_initializer_list] = STATE(3031),
    [sym_decltype_auto] = STATE(2728),
    [sym_new_declarator] = STATE(2736),
    [sym_identifier] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_RPAREN] = ACTIONS(5856),
    [aux_sym_preproc_if_token2] = ACTIONS(5856),
    [aux_sym_preproc_else_token1] = ACTIONS(5856),
    [aux_sym_preproc_elif_token1] = ACTIONS(5854),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5856),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5856),
    [anon_sym_LPAREN2] = ACTIONS(5813),
    [anon_sym_DASH] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_STAR] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(5854),
    [anon_sym_PERCENT] = ACTIONS(5854),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5856),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym___attribute__] = ACTIONS(5854),
    [anon_sym_LBRACE] = ACTIONS(2159),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5815),
    [anon_sym_RBRACK] = ACTIONS(5856),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_COLON] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_and_eq] = ACTIONS(5854),
    [anon_sym_or_eq] = ACTIONS(5854),
    [anon_sym_xor_eq] = ACTIONS(5854),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5854),
    [anon_sym_and] = ACTIONS(5854),
    [anon_sym_bitor] = ACTIONS(5854),
    [anon_sym_xor] = ACTIONS(5854),
    [anon_sym_bitand] = ACTIONS(5854),
    [anon_sym_not_eq] = ACTIONS(5854),
    [anon_sym_DASH_DASH] = ACTIONS(5856),
    [anon_sym_PLUS_PLUS] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_DOT_STAR] = ACTIONS(5856),
    [anon_sym_DASH_GT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5817),
    [anon_sym_decltype] = ACTIONS(5819),
  },
  [2412] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [anon_sym_COMMA] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token2] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_friend] = ACTIONS(2267),
    [anon_sym_public] = ACTIONS(2267),
    [anon_sym_private] = ACTIONS(2267),
    [anon_sym_protected] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
  },
  [2413] = {
    [sym_identifier] = ACTIONS(3447),
    [aux_sym_preproc_def_token1] = ACTIONS(3447),
    [aux_sym_preproc_if_token1] = ACTIONS(3447),
    [aux_sym_preproc_if_token2] = ACTIONS(3447),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3447),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3447),
    [aux_sym_preproc_else_token1] = ACTIONS(3447),
    [aux_sym_preproc_elif_token1] = ACTIONS(3447),
    [sym_preproc_directive] = ACTIONS(3447),
    [anon_sym_LPAREN2] = ACTIONS(3449),
    [anon_sym_TILDE] = ACTIONS(3449),
    [anon_sym_STAR] = ACTIONS(3449),
    [anon_sym_AMP_AMP] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3447),
    [anon_sym___extension__] = ACTIONS(3447),
    [anon_sym_typedef] = ACTIONS(3447),
    [anon_sym_extern] = ACTIONS(3447),
    [anon_sym___attribute__] = ACTIONS(3447),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3449),
    [anon_sym___declspec] = ACTIONS(3447),
    [anon_sym___based] = ACTIONS(3447),
    [anon_sym_signed] = ACTIONS(3447),
    [anon_sym_unsigned] = ACTIONS(3447),
    [anon_sym_long] = ACTIONS(3447),
    [anon_sym_short] = ACTIONS(3447),
    [anon_sym_LBRACK] = ACTIONS(3447),
    [anon_sym_static] = ACTIONS(3447),
    [anon_sym_register] = ACTIONS(3447),
    [anon_sym_inline] = ACTIONS(3447),
    [anon_sym___inline] = ACTIONS(3447),
    [anon_sym___inline__] = ACTIONS(3447),
    [anon_sym___forceinline] = ACTIONS(3447),
    [anon_sym_thread_local] = ACTIONS(3447),
    [anon_sym___thread] = ACTIONS(3447),
    [anon_sym_const] = ACTIONS(3447),
    [anon_sym_constexpr] = ACTIONS(3447),
    [anon_sym_volatile] = ACTIONS(3447),
    [anon_sym_restrict] = ACTIONS(3447),
    [anon_sym___restrict__] = ACTIONS(3447),
    [anon_sym__Atomic] = ACTIONS(3447),
    [anon_sym__Noreturn] = ACTIONS(3447),
    [anon_sym_noreturn] = ACTIONS(3447),
    [anon_sym_mutable] = ACTIONS(3447),
    [anon_sym_constinit] = ACTIONS(3447),
    [anon_sym_consteval] = ACTIONS(3447),
    [anon_sym_PROGMEM] = ACTIONS(3447),
    [aux_sym_primitive_type_token1] = ACTIONS(3447),
    [anon_sym_byte] = ACTIONS(3447),
    [anon_sym_word] = ACTIONS(3447),
    [anon_sym_enum] = ACTIONS(3447),
    [anon_sym_class] = ACTIONS(3447),
    [anon_sym_struct] = ACTIONS(3447),
    [anon_sym_union] = ACTIONS(3447),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3447),
    [anon_sym_decltype] = ACTIONS(3447),
    [anon_sym_virtual] = ACTIONS(3447),
    [anon_sym_alignas] = ACTIONS(3447),
    [anon_sym_explicit] = ACTIONS(3447),
    [anon_sym_typename] = ACTIONS(3447),
    [anon_sym_template] = ACTIONS(3447),
    [anon_sym_operator] = ACTIONS(3447),
    [anon_sym_friend] = ACTIONS(3447),
    [anon_sym_public] = ACTIONS(3447),
    [anon_sym_private] = ACTIONS(3447),
    [anon_sym_protected] = ACTIONS(3447),
    [anon_sym_using] = ACTIONS(3447),
    [anon_sym_static_assert] = ACTIONS(3447),
  },
  [2414] = {
    [sym_identifier] = ACTIONS(3310),
    [aux_sym_preproc_def_token1] = ACTIONS(3310),
    [aux_sym_preproc_if_token1] = ACTIONS(3310),
    [aux_sym_preproc_if_token2] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3310),
    [aux_sym_preproc_else_token1] = ACTIONS(3310),
    [aux_sym_preproc_elif_token1] = ACTIONS(3310),
    [sym_preproc_directive] = ACTIONS(3310),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_AMP_AMP] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3310),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_typedef] = ACTIONS(3310),
    [anon_sym_extern] = ACTIONS(3310),
    [anon_sym___attribute__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3312),
    [anon_sym___declspec] = ACTIONS(3310),
    [anon_sym___based] = ACTIONS(3310),
    [anon_sym_signed] = ACTIONS(3310),
    [anon_sym_unsigned] = ACTIONS(3310),
    [anon_sym_long] = ACTIONS(3310),
    [anon_sym_short] = ACTIONS(3310),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [anon_sym_static] = ACTIONS(3310),
    [anon_sym_register] = ACTIONS(3310),
    [anon_sym_inline] = ACTIONS(3310),
    [anon_sym___inline] = ACTIONS(3310),
    [anon_sym___inline__] = ACTIONS(3310),
    [anon_sym___forceinline] = ACTIONS(3310),
    [anon_sym_thread_local] = ACTIONS(3310),
    [anon_sym___thread] = ACTIONS(3310),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_constexpr] = ACTIONS(3310),
    [anon_sym_volatile] = ACTIONS(3310),
    [anon_sym_restrict] = ACTIONS(3310),
    [anon_sym___restrict__] = ACTIONS(3310),
    [anon_sym__Atomic] = ACTIONS(3310),
    [anon_sym__Noreturn] = ACTIONS(3310),
    [anon_sym_noreturn] = ACTIONS(3310),
    [anon_sym_mutable] = ACTIONS(3310),
    [anon_sym_constinit] = ACTIONS(3310),
    [anon_sym_consteval] = ACTIONS(3310),
    [anon_sym_PROGMEM] = ACTIONS(3310),
    [aux_sym_primitive_type_token1] = ACTIONS(3310),
    [anon_sym_byte] = ACTIONS(3310),
    [anon_sym_word] = ACTIONS(3310),
    [anon_sym_enum] = ACTIONS(3310),
    [anon_sym_class] = ACTIONS(3310),
    [anon_sym_struct] = ACTIONS(3310),
    [anon_sym_union] = ACTIONS(3310),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3310),
    [anon_sym_decltype] = ACTIONS(3310),
    [anon_sym_virtual] = ACTIONS(3310),
    [anon_sym_alignas] = ACTIONS(3310),
    [anon_sym_explicit] = ACTIONS(3310),
    [anon_sym_typename] = ACTIONS(3310),
    [anon_sym_template] = ACTIONS(3310),
    [anon_sym_operator] = ACTIONS(3310),
    [anon_sym_friend] = ACTIONS(3310),
    [anon_sym_public] = ACTIONS(3310),
    [anon_sym_private] = ACTIONS(3310),
    [anon_sym_protected] = ACTIONS(3310),
    [anon_sym_using] = ACTIONS(3310),
    [anon_sym_static_assert] = ACTIONS(3310),
  },
  [2415] = {
    [sym_identifier] = ACTIONS(5542),
    [aux_sym_preproc_def_token1] = ACTIONS(5542),
    [aux_sym_preproc_if_token1] = ACTIONS(5542),
    [aux_sym_preproc_if_token2] = ACTIONS(5542),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5542),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5542),
    [aux_sym_preproc_else_token1] = ACTIONS(5542),
    [aux_sym_preproc_elif_token1] = ACTIONS(5542),
    [sym_preproc_directive] = ACTIONS(5542),
    [anon_sym_LPAREN2] = ACTIONS(5544),
    [anon_sym_TILDE] = ACTIONS(5544),
    [anon_sym_STAR] = ACTIONS(5544),
    [anon_sym_AMP_AMP] = ACTIONS(5544),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5542),
    [anon_sym_typedef] = ACTIONS(5542),
    [anon_sym_extern] = ACTIONS(5542),
    [anon_sym___attribute__] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5544),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5544),
    [anon_sym___declspec] = ACTIONS(5542),
    [anon_sym___based] = ACTIONS(5542),
    [anon_sym_signed] = ACTIONS(5542),
    [anon_sym_unsigned] = ACTIONS(5542),
    [anon_sym_long] = ACTIONS(5542),
    [anon_sym_short] = ACTIONS(5542),
    [anon_sym_LBRACK] = ACTIONS(5542),
    [anon_sym_static] = ACTIONS(5542),
    [anon_sym_register] = ACTIONS(5542),
    [anon_sym_inline] = ACTIONS(5542),
    [anon_sym___inline] = ACTIONS(5542),
    [anon_sym___inline__] = ACTIONS(5542),
    [anon_sym___forceinline] = ACTIONS(5542),
    [anon_sym_thread_local] = ACTIONS(5542),
    [anon_sym___thread] = ACTIONS(5542),
    [anon_sym_const] = ACTIONS(5542),
    [anon_sym_constexpr] = ACTIONS(5542),
    [anon_sym_volatile] = ACTIONS(5542),
    [anon_sym_restrict] = ACTIONS(5542),
    [anon_sym___restrict__] = ACTIONS(5542),
    [anon_sym__Atomic] = ACTIONS(5542),
    [anon_sym__Noreturn] = ACTIONS(5542),
    [anon_sym_noreturn] = ACTIONS(5542),
    [anon_sym_mutable] = ACTIONS(5542),
    [anon_sym_constinit] = ACTIONS(5542),
    [anon_sym_consteval] = ACTIONS(5542),
    [anon_sym_PROGMEM] = ACTIONS(5542),
    [aux_sym_primitive_type_token1] = ACTIONS(5542),
    [anon_sym_byte] = ACTIONS(5542),
    [anon_sym_word] = ACTIONS(5542),
    [anon_sym_enum] = ACTIONS(5542),
    [anon_sym_class] = ACTIONS(5542),
    [anon_sym_struct] = ACTIONS(5542),
    [anon_sym_union] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5542),
    [anon_sym_decltype] = ACTIONS(5542),
    [anon_sym_virtual] = ACTIONS(5542),
    [anon_sym_alignas] = ACTIONS(5542),
    [anon_sym_explicit] = ACTIONS(5542),
    [anon_sym_typename] = ACTIONS(5542),
    [anon_sym_template] = ACTIONS(5542),
    [anon_sym_operator] = ACTIONS(5542),
    [anon_sym_friend] = ACTIONS(5542),
    [anon_sym_public] = ACTIONS(5542),
    [anon_sym_private] = ACTIONS(5542),
    [anon_sym_protected] = ACTIONS(5542),
    [anon_sym_using] = ACTIONS(5542),
    [anon_sym_static_assert] = ACTIONS(5542),
  },
  [2416] = {
    [sym_string_literal] = STATE(2443),
    [sym_raw_string_literal] = STATE(2443),
    [aux_sym_concatenated_string_repeat1] = STATE(2443),
    [sym_identifier] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5393),
    [anon_sym_COMMA] = ACTIONS(5393),
    [aux_sym_preproc_if_token2] = ACTIONS(5393),
    [aux_sym_preproc_else_token1] = ACTIONS(5393),
    [aux_sym_preproc_elif_token1] = ACTIONS(5393),
    [anon_sym_LPAREN2] = ACTIONS(5393),
    [anon_sym_DASH] = ACTIONS(5395),
    [anon_sym_PLUS] = ACTIONS(5395),
    [anon_sym_STAR] = ACTIONS(5395),
    [anon_sym_SLASH] = ACTIONS(5395),
    [anon_sym_PERCENT] = ACTIONS(5395),
    [anon_sym_PIPE_PIPE] = ACTIONS(5393),
    [anon_sym_AMP_AMP] = ACTIONS(5393),
    [anon_sym_PIPE] = ACTIONS(5395),
    [anon_sym_CARET] = ACTIONS(5395),
    [anon_sym_AMP] = ACTIONS(5395),
    [anon_sym_EQ_EQ] = ACTIONS(5393),
    [anon_sym_BANG_EQ] = ACTIONS(5393),
    [anon_sym_GT] = ACTIONS(5395),
    [anon_sym_GT_EQ] = ACTIONS(5393),
    [anon_sym_LT_EQ] = ACTIONS(5395),
    [anon_sym_LT] = ACTIONS(5395),
    [anon_sym_LT_LT] = ACTIONS(5395),
    [anon_sym_GT_GT] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(5393),
    [anon_sym_EQ] = ACTIONS(5395),
    [anon_sym_QMARK] = ACTIONS(5393),
    [anon_sym_STAR_EQ] = ACTIONS(5393),
    [anon_sym_SLASH_EQ] = ACTIONS(5393),
    [anon_sym_PERCENT_EQ] = ACTIONS(5393),
    [anon_sym_PLUS_EQ] = ACTIONS(5393),
    [anon_sym_DASH_EQ] = ACTIONS(5393),
    [anon_sym_LT_LT_EQ] = ACTIONS(5393),
    [anon_sym_GT_GT_EQ] = ACTIONS(5393),
    [anon_sym_AMP_EQ] = ACTIONS(5393),
    [anon_sym_CARET_EQ] = ACTIONS(5393),
    [anon_sym_PIPE_EQ] = ACTIONS(5393),
    [anon_sym_and_eq] = ACTIONS(5395),
    [anon_sym_or_eq] = ACTIONS(5395),
    [anon_sym_xor_eq] = ACTIONS(5395),
    [anon_sym_LT_EQ_GT] = ACTIONS(5393),
    [anon_sym_or] = ACTIONS(5395),
    [anon_sym_and] = ACTIONS(5395),
    [anon_sym_bitor] = ACTIONS(5395),
    [anon_sym_xor] = ACTIONS(5395),
    [anon_sym_bitand] = ACTIONS(5395),
    [anon_sym_not_eq] = ACTIONS(5395),
    [anon_sym_DASH_DASH] = ACTIONS(5393),
    [anon_sym_PLUS_PLUS] = ACTIONS(5393),
    [anon_sym_DOT] = ACTIONS(5395),
    [anon_sym_DOT_STAR] = ACTIONS(5393),
    [anon_sym_DASH_GT] = ACTIONS(5393),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [sym_literal_suffix] = ACTIONS(5395),
  },
  [2417] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5164),
    [anon_sym_COMMA] = ACTIONS(5164),
    [anon_sym_LPAREN2] = ACTIONS(5164),
    [anon_sym_DASH] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5169),
    [anon_sym_STAR] = ACTIONS(5171),
    [anon_sym_SLASH] = ACTIONS(5169),
    [anon_sym_PERCENT] = ACTIONS(5169),
    [anon_sym_PIPE_PIPE] = ACTIONS(5162),
    [anon_sym_AMP_AMP] = ACTIONS(5164),
    [anon_sym_PIPE] = ACTIONS(5169),
    [anon_sym_CARET] = ACTIONS(5169),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_EQ] = ACTIONS(5162),
    [anon_sym_GT] = ACTIONS(5169),
    [anon_sym_GT_EQ] = ACTIONS(5169),
    [anon_sym_LT_EQ] = ACTIONS(5169),
    [anon_sym_LT] = ACTIONS(5169),
    [anon_sym_LT_LT] = ACTIONS(5169),
    [anon_sym_GT_GT] = ACTIONS(5169),
    [anon_sym___extension__] = ACTIONS(5167),
    [anon_sym_COLON_COLON] = ACTIONS(5167),
    [anon_sym_LBRACE] = ACTIONS(5167),
    [anon_sym_LBRACK] = ACTIONS(5164),
    [anon_sym_EQ] = ACTIONS(5169),
    [anon_sym_const] = ACTIONS(5160),
    [anon_sym_constexpr] = ACTIONS(5167),
    [anon_sym_volatile] = ACTIONS(5167),
    [anon_sym_restrict] = ACTIONS(5167),
    [anon_sym___restrict__] = ACTIONS(5167),
    [anon_sym__Atomic] = ACTIONS(5167),
    [anon_sym__Noreturn] = ACTIONS(5167),
    [anon_sym_noreturn] = ACTIONS(5167),
    [anon_sym_mutable] = ACTIONS(5167),
    [anon_sym_constinit] = ACTIONS(5167),
    [anon_sym_consteval] = ACTIONS(5167),
    [anon_sym_PROGMEM] = ACTIONS(5167),
    [anon_sym_QMARK] = ACTIONS(5162),
    [anon_sym_STAR_EQ] = ACTIONS(5162),
    [anon_sym_SLASH_EQ] = ACTIONS(5162),
    [anon_sym_PERCENT_EQ] = ACTIONS(5162),
    [anon_sym_PLUS_EQ] = ACTIONS(5162),
    [anon_sym_DASH_EQ] = ACTIONS(5162),
    [anon_sym_LT_LT_EQ] = ACTIONS(5162),
    [anon_sym_GT_GT_EQ] = ACTIONS(5169),
    [anon_sym_AMP_EQ] = ACTIONS(5162),
    [anon_sym_CARET_EQ] = ACTIONS(5162),
    [anon_sym_PIPE_EQ] = ACTIONS(5162),
    [anon_sym_and_eq] = ACTIONS(5162),
    [anon_sym_or_eq] = ACTIONS(5162),
    [anon_sym_xor_eq] = ACTIONS(5162),
    [anon_sym_LT_EQ_GT] = ACTIONS(5162),
    [anon_sym_or] = ACTIONS(5169),
    [anon_sym_and] = ACTIONS(5169),
    [anon_sym_bitor] = ACTIONS(5162),
    [anon_sym_xor] = ACTIONS(5169),
    [anon_sym_bitand] = ACTIONS(5162),
    [anon_sym_not_eq] = ACTIONS(5162),
    [anon_sym_DASH_DASH] = ACTIONS(5162),
    [anon_sym_PLUS_PLUS] = ACTIONS(5162),
    [anon_sym_DOT] = ACTIONS(5169),
    [anon_sym_DOT_STAR] = ACTIONS(5162),
    [anon_sym_DASH_GT] = ACTIONS(5162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5167),
    [anon_sym_decltype] = ACTIONS(5167),
    [anon_sym_GT2] = ACTIONS(5164),
  },
  [2418] = {
    [sym_identifier] = ACTIONS(2887),
    [aux_sym_preproc_def_token1] = ACTIONS(2887),
    [aux_sym_preproc_if_token1] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2887),
    [sym_preproc_directive] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2889),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym___extension__] = ACTIONS(2887),
    [anon_sym_typedef] = ACTIONS(2887),
    [anon_sym_extern] = ACTIONS(2887),
    [anon_sym___attribute__] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2889),
    [anon_sym___declspec] = ACTIONS(2887),
    [anon_sym___based] = ACTIONS(2887),
    [anon_sym_RBRACE] = ACTIONS(2889),
    [anon_sym_signed] = ACTIONS(2887),
    [anon_sym_unsigned] = ACTIONS(2887),
    [anon_sym_long] = ACTIONS(2887),
    [anon_sym_short] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_static] = ACTIONS(2887),
    [anon_sym_register] = ACTIONS(2887),
    [anon_sym_inline] = ACTIONS(2887),
    [anon_sym___inline] = ACTIONS(2887),
    [anon_sym___inline__] = ACTIONS(2887),
    [anon_sym___forceinline] = ACTIONS(2887),
    [anon_sym_thread_local] = ACTIONS(2887),
    [anon_sym___thread] = ACTIONS(2887),
    [anon_sym_const] = ACTIONS(2887),
    [anon_sym_constexpr] = ACTIONS(2887),
    [anon_sym_volatile] = ACTIONS(2887),
    [anon_sym_restrict] = ACTIONS(2887),
    [anon_sym___restrict__] = ACTIONS(2887),
    [anon_sym__Atomic] = ACTIONS(2887),
    [anon_sym__Noreturn] = ACTIONS(2887),
    [anon_sym_noreturn] = ACTIONS(2887),
    [anon_sym_mutable] = ACTIONS(2887),
    [anon_sym_constinit] = ACTIONS(2887),
    [anon_sym_consteval] = ACTIONS(2887),
    [anon_sym_PROGMEM] = ACTIONS(2887),
    [aux_sym_primitive_type_token1] = ACTIONS(2887),
    [anon_sym_byte] = ACTIONS(2887),
    [anon_sym_word] = ACTIONS(2887),
    [anon_sym_enum] = ACTIONS(2887),
    [anon_sym_class] = ACTIONS(2887),
    [anon_sym_struct] = ACTIONS(2887),
    [anon_sym_union] = ACTIONS(2887),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2887),
    [anon_sym_decltype] = ACTIONS(2887),
    [anon_sym_virtual] = ACTIONS(2887),
    [anon_sym_alignas] = ACTIONS(2887),
    [anon_sym_explicit] = ACTIONS(2887),
    [anon_sym_typename] = ACTIONS(2887),
    [anon_sym_template] = ACTIONS(2887),
    [anon_sym_operator] = ACTIONS(2887),
    [anon_sym_friend] = ACTIONS(2887),
    [anon_sym_public] = ACTIONS(2887),
    [anon_sym_private] = ACTIONS(2887),
    [anon_sym_protected] = ACTIONS(2887),
    [anon_sym_using] = ACTIONS(2887),
    [anon_sym_static_assert] = ACTIONS(2887),
    [anon_sym_catch] = ACTIONS(2887),
  },
  [2419] = {
    [sym_identifier] = ACTIONS(3427),
    [aux_sym_preproc_def_token1] = ACTIONS(3427),
    [aux_sym_preproc_if_token1] = ACTIONS(3427),
    [aux_sym_preproc_if_token2] = ACTIONS(3427),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3427),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3427),
    [sym_preproc_directive] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3429),
    [anon_sym_TILDE] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(3429),
    [anon_sym_AMP_AMP] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym___extension__] = ACTIONS(3427),
    [anon_sym_typedef] = ACTIONS(3427),
    [anon_sym_extern] = ACTIONS(3427),
    [anon_sym___attribute__] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3429),
    [anon_sym___declspec] = ACTIONS(3427),
    [anon_sym___based] = ACTIONS(3427),
    [anon_sym_signed] = ACTIONS(3427),
    [anon_sym_unsigned] = ACTIONS(3427),
    [anon_sym_long] = ACTIONS(3427),
    [anon_sym_short] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_register] = ACTIONS(3427),
    [anon_sym_inline] = ACTIONS(3427),
    [anon_sym___inline] = ACTIONS(3427),
    [anon_sym___inline__] = ACTIONS(3427),
    [anon_sym___forceinline] = ACTIONS(3427),
    [anon_sym_thread_local] = ACTIONS(3427),
    [anon_sym___thread] = ACTIONS(3427),
    [anon_sym_const] = ACTIONS(3427),
    [anon_sym_constexpr] = ACTIONS(3427),
    [anon_sym_volatile] = ACTIONS(3427),
    [anon_sym_restrict] = ACTIONS(3427),
    [anon_sym___restrict__] = ACTIONS(3427),
    [anon_sym__Atomic] = ACTIONS(3427),
    [anon_sym__Noreturn] = ACTIONS(3427),
    [anon_sym_noreturn] = ACTIONS(3427),
    [anon_sym_mutable] = ACTIONS(3427),
    [anon_sym_constinit] = ACTIONS(3427),
    [anon_sym_consteval] = ACTIONS(3427),
    [anon_sym_PROGMEM] = ACTIONS(3427),
    [aux_sym_primitive_type_token1] = ACTIONS(3427),
    [anon_sym_byte] = ACTIONS(3427),
    [anon_sym_word] = ACTIONS(3427),
    [anon_sym_enum] = ACTIONS(3427),
    [anon_sym_class] = ACTIONS(3427),
    [anon_sym_struct] = ACTIONS(3427),
    [anon_sym_union] = ACTIONS(3427),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3427),
    [anon_sym_decltype] = ACTIONS(3427),
    [anon_sym_virtual] = ACTIONS(3427),
    [anon_sym_alignas] = ACTIONS(3427),
    [anon_sym_explicit] = ACTIONS(3427),
    [anon_sym_typename] = ACTIONS(3427),
    [anon_sym_template] = ACTIONS(3427),
    [anon_sym_operator] = ACTIONS(3427),
    [anon_sym_friend] = ACTIONS(3427),
    [anon_sym_public] = ACTIONS(3427),
    [anon_sym_private] = ACTIONS(3427),
    [anon_sym_protected] = ACTIONS(3427),
    [anon_sym_using] = ACTIONS(3427),
    [anon_sym_static_assert] = ACTIONS(3427),
  },
  [2420] = {
    [sym_string_literal] = STATE(2616),
    [sym_template_argument_list] = STATE(3568),
    [sym_raw_string_literal] = STATE(2616),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_RPAREN] = ACTIONS(5862),
    [anon_sym_LPAREN2] = ACTIONS(5862),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5177),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5180),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(5865),
    [anon_sym_EQ] = ACTIONS(4256),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4248),
    [anon_sym_SLASH_EQ] = ACTIONS(4248),
    [anon_sym_PERCENT_EQ] = ACTIONS(4248),
    [anon_sym_PLUS_EQ] = ACTIONS(4248),
    [anon_sym_DASH_EQ] = ACTIONS(4248),
    [anon_sym_LT_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT_GT_EQ] = ACTIONS(4248),
    [anon_sym_AMP_EQ] = ACTIONS(4248),
    [anon_sym_CARET_EQ] = ACTIONS(4248),
    [anon_sym_PIPE_EQ] = ACTIONS(4248),
    [anon_sym_and_eq] = ACTIONS(4248),
    [anon_sym_or_eq] = ACTIONS(4248),
    [anon_sym_xor_eq] = ACTIONS(4248),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4256),
    [anon_sym_L_DQUOTE] = ACTIONS(5184),
    [anon_sym_u_DQUOTE] = ACTIONS(5184),
    [anon_sym_U_DQUOTE] = ACTIONS(5184),
    [anon_sym_u8_DQUOTE] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5186),
    [anon_sym_LR_DQUOTE] = ACTIONS(5186),
    [anon_sym_uR_DQUOTE] = ACTIONS(5186),
    [anon_sym_UR_DQUOTE] = ACTIONS(5186),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5186),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4248),
  },
  [2421] = {
    [sym_identifier] = ACTIONS(3328),
    [aux_sym_preproc_def_token1] = ACTIONS(3328),
    [aux_sym_preproc_if_token1] = ACTIONS(3328),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3328),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3328),
    [sym_preproc_directive] = ACTIONS(3328),
    [anon_sym_LPAREN2] = ACTIONS(3330),
    [anon_sym_TILDE] = ACTIONS(3330),
    [anon_sym_STAR] = ACTIONS(3330),
    [anon_sym_AMP_AMP] = ACTIONS(3330),
    [anon_sym_AMP] = ACTIONS(3328),
    [anon_sym_SEMI] = ACTIONS(5868),
    [anon_sym___extension__] = ACTIONS(3328),
    [anon_sym_typedef] = ACTIONS(3328),
    [anon_sym_extern] = ACTIONS(3328),
    [anon_sym___attribute__] = ACTIONS(3328),
    [anon_sym_COLON_COLON] = ACTIONS(3330),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3330),
    [anon_sym___declspec] = ACTIONS(3328),
    [anon_sym___based] = ACTIONS(3328),
    [anon_sym_RBRACE] = ACTIONS(3330),
    [anon_sym_signed] = ACTIONS(3328),
    [anon_sym_unsigned] = ACTIONS(3328),
    [anon_sym_long] = ACTIONS(3328),
    [anon_sym_short] = ACTIONS(3328),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_static] = ACTIONS(3328),
    [anon_sym_register] = ACTIONS(3328),
    [anon_sym_inline] = ACTIONS(3328),
    [anon_sym___inline] = ACTIONS(3328),
    [anon_sym___inline__] = ACTIONS(3328),
    [anon_sym___forceinline] = ACTIONS(3328),
    [anon_sym_thread_local] = ACTIONS(3328),
    [anon_sym___thread] = ACTIONS(3328),
    [anon_sym_const] = ACTIONS(3328),
    [anon_sym_constexpr] = ACTIONS(3328),
    [anon_sym_volatile] = ACTIONS(3328),
    [anon_sym_restrict] = ACTIONS(3328),
    [anon_sym___restrict__] = ACTIONS(3328),
    [anon_sym__Atomic] = ACTIONS(3328),
    [anon_sym__Noreturn] = ACTIONS(3328),
    [anon_sym_noreturn] = ACTIONS(3328),
    [anon_sym_mutable] = ACTIONS(3328),
    [anon_sym_constinit] = ACTIONS(3328),
    [anon_sym_consteval] = ACTIONS(3328),
    [anon_sym_PROGMEM] = ACTIONS(3328),
    [aux_sym_primitive_type_token1] = ACTIONS(3328),
    [anon_sym_byte] = ACTIONS(3328),
    [anon_sym_word] = ACTIONS(3328),
    [anon_sym_enum] = ACTIONS(3328),
    [anon_sym_class] = ACTIONS(3328),
    [anon_sym_struct] = ACTIONS(3328),
    [anon_sym_union] = ACTIONS(3328),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3328),
    [anon_sym_decltype] = ACTIONS(3328),
    [anon_sym_virtual] = ACTIONS(3328),
    [anon_sym_alignas] = ACTIONS(3328),
    [anon_sym_explicit] = ACTIONS(3328),
    [anon_sym_typename] = ACTIONS(3328),
    [anon_sym_template] = ACTIONS(3328),
    [anon_sym_operator] = ACTIONS(3328),
    [anon_sym_friend] = ACTIONS(3328),
    [anon_sym_public] = ACTIONS(3328),
    [anon_sym_private] = ACTIONS(3328),
    [anon_sym_protected] = ACTIONS(3328),
    [anon_sym_using] = ACTIONS(3328),
    [anon_sym_static_assert] = ACTIONS(3328),
  },
  [2422] = {
    [sym_identifier] = ACTIONS(5606),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5608),
    [anon_sym_COMMA] = ACTIONS(5608),
    [anon_sym_RPAREN] = ACTIONS(5608),
    [aux_sym_preproc_if_token2] = ACTIONS(5608),
    [aux_sym_preproc_else_token1] = ACTIONS(5608),
    [aux_sym_preproc_elif_token1] = ACTIONS(5606),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5608),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5608),
    [anon_sym_LPAREN2] = ACTIONS(5608),
    [anon_sym_DASH] = ACTIONS(5606),
    [anon_sym_PLUS] = ACTIONS(5606),
    [anon_sym_STAR] = ACTIONS(5606),
    [anon_sym_SLASH] = ACTIONS(5606),
    [anon_sym_PERCENT] = ACTIONS(5606),
    [anon_sym_PIPE_PIPE] = ACTIONS(5608),
    [anon_sym_AMP_AMP] = ACTIONS(5608),
    [anon_sym_PIPE] = ACTIONS(5606),
    [anon_sym_CARET] = ACTIONS(5606),
    [anon_sym_AMP] = ACTIONS(5606),
    [anon_sym_EQ_EQ] = ACTIONS(5608),
    [anon_sym_BANG_EQ] = ACTIONS(5608),
    [anon_sym_GT] = ACTIONS(5606),
    [anon_sym_GT_EQ] = ACTIONS(5608),
    [anon_sym_LT_EQ] = ACTIONS(5606),
    [anon_sym_LT] = ACTIONS(5606),
    [anon_sym_LT_LT] = ACTIONS(5606),
    [anon_sym_GT_GT] = ACTIONS(5606),
    [anon_sym_SEMI] = ACTIONS(5608),
    [anon_sym___attribute__] = ACTIONS(5606),
    [anon_sym_COLON_COLON] = ACTIONS(5608),
    [anon_sym_LBRACE] = ACTIONS(5608),
    [anon_sym_RBRACE] = ACTIONS(5608),
    [anon_sym_LBRACK] = ACTIONS(5608),
    [anon_sym_RBRACK] = ACTIONS(5608),
    [anon_sym_EQ] = ACTIONS(5606),
    [anon_sym_COLON] = ACTIONS(5606),
    [anon_sym_QMARK] = ACTIONS(5608),
    [anon_sym_STAR_EQ] = ACTIONS(5608),
    [anon_sym_SLASH_EQ] = ACTIONS(5608),
    [anon_sym_PERCENT_EQ] = ACTIONS(5608),
    [anon_sym_PLUS_EQ] = ACTIONS(5608),
    [anon_sym_DASH_EQ] = ACTIONS(5608),
    [anon_sym_LT_LT_EQ] = ACTIONS(5608),
    [anon_sym_GT_GT_EQ] = ACTIONS(5608),
    [anon_sym_AMP_EQ] = ACTIONS(5608),
    [anon_sym_CARET_EQ] = ACTIONS(5608),
    [anon_sym_PIPE_EQ] = ACTIONS(5608),
    [anon_sym_and_eq] = ACTIONS(5606),
    [anon_sym_or_eq] = ACTIONS(5606),
    [anon_sym_xor_eq] = ACTIONS(5606),
    [anon_sym_LT_EQ_GT] = ACTIONS(5608),
    [anon_sym_or] = ACTIONS(5606),
    [anon_sym_and] = ACTIONS(5606),
    [anon_sym_bitor] = ACTIONS(5606),
    [anon_sym_xor] = ACTIONS(5606),
    [anon_sym_bitand] = ACTIONS(5606),
    [anon_sym_not_eq] = ACTIONS(5606),
    [anon_sym_DASH_DASH] = ACTIONS(5608),
    [anon_sym_PLUS_PLUS] = ACTIONS(5608),
    [anon_sym_DOT] = ACTIONS(5606),
    [anon_sym_DOT_STAR] = ACTIONS(5608),
    [anon_sym_DASH_GT] = ACTIONS(5608),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5606),
    [anon_sym_decltype] = ACTIONS(5606),
    [anon_sym_final] = ACTIONS(5606),
    [anon_sym_override] = ACTIONS(5606),
  },
  [2423] = {
    [sym_identifier] = ACTIONS(5109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5111),
    [anon_sym_COMMA] = ACTIONS(5111),
    [anon_sym_RPAREN] = ACTIONS(5111),
    [aux_sym_preproc_if_token2] = ACTIONS(5111),
    [aux_sym_preproc_else_token1] = ACTIONS(5111),
    [aux_sym_preproc_elif_token1] = ACTIONS(5109),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5111),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5111),
    [anon_sym_LPAREN2] = ACTIONS(5111),
    [anon_sym_DASH] = ACTIONS(5109),
    [anon_sym_PLUS] = ACTIONS(5109),
    [anon_sym_STAR] = ACTIONS(5109),
    [anon_sym_SLASH] = ACTIONS(5109),
    [anon_sym_PERCENT] = ACTIONS(5109),
    [anon_sym_PIPE_PIPE] = ACTIONS(5111),
    [anon_sym_AMP_AMP] = ACTIONS(5111),
    [anon_sym_PIPE] = ACTIONS(5109),
    [anon_sym_CARET] = ACTIONS(5109),
    [anon_sym_AMP] = ACTIONS(5109),
    [anon_sym_EQ_EQ] = ACTIONS(5111),
    [anon_sym_BANG_EQ] = ACTIONS(5111),
    [anon_sym_GT] = ACTIONS(5109),
    [anon_sym_GT_EQ] = ACTIONS(5111),
    [anon_sym_LT_EQ] = ACTIONS(5109),
    [anon_sym_LT] = ACTIONS(5109),
    [anon_sym_LT_LT] = ACTIONS(5109),
    [anon_sym_GT_GT] = ACTIONS(5109),
    [anon_sym_SEMI] = ACTIONS(5111),
    [anon_sym___attribute__] = ACTIONS(5109),
    [anon_sym_COLON_COLON] = ACTIONS(5111),
    [anon_sym_LBRACE] = ACTIONS(5111),
    [anon_sym_RBRACE] = ACTIONS(5111),
    [anon_sym_LBRACK] = ACTIONS(5111),
    [anon_sym_RBRACK] = ACTIONS(5111),
    [anon_sym_EQ] = ACTIONS(5109),
    [anon_sym_COLON] = ACTIONS(5109),
    [anon_sym_QMARK] = ACTIONS(5111),
    [anon_sym_STAR_EQ] = ACTIONS(5111),
    [anon_sym_SLASH_EQ] = ACTIONS(5111),
    [anon_sym_PERCENT_EQ] = ACTIONS(5111),
    [anon_sym_PLUS_EQ] = ACTIONS(5111),
    [anon_sym_DASH_EQ] = ACTIONS(5111),
    [anon_sym_LT_LT_EQ] = ACTIONS(5111),
    [anon_sym_GT_GT_EQ] = ACTIONS(5111),
    [anon_sym_AMP_EQ] = ACTIONS(5111),
    [anon_sym_CARET_EQ] = ACTIONS(5111),
    [anon_sym_PIPE_EQ] = ACTIONS(5111),
    [anon_sym_and_eq] = ACTIONS(5109),
    [anon_sym_or_eq] = ACTIONS(5109),
    [anon_sym_xor_eq] = ACTIONS(5109),
    [anon_sym_LT_EQ_GT] = ACTIONS(5111),
    [anon_sym_or] = ACTIONS(5109),
    [anon_sym_and] = ACTIONS(5109),
    [anon_sym_bitor] = ACTIONS(5109),
    [anon_sym_xor] = ACTIONS(5109),
    [anon_sym_bitand] = ACTIONS(5109),
    [anon_sym_not_eq] = ACTIONS(5109),
    [anon_sym_DASH_DASH] = ACTIONS(5111),
    [anon_sym_PLUS_PLUS] = ACTIONS(5111),
    [anon_sym_DOT] = ACTIONS(5109),
    [anon_sym_DOT_STAR] = ACTIONS(5111),
    [anon_sym_DASH_GT] = ACTIONS(5111),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5109),
    [anon_sym_decltype] = ACTIONS(5109),
    [anon_sym_final] = ACTIONS(5109),
    [anon_sym_override] = ACTIONS(5109),
  },
  [2424] = {
    [sym_identifier] = ACTIONS(5121),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5123),
    [anon_sym_COMMA] = ACTIONS(5123),
    [anon_sym_RPAREN] = ACTIONS(5123),
    [aux_sym_preproc_if_token2] = ACTIONS(5123),
    [aux_sym_preproc_else_token1] = ACTIONS(5123),
    [aux_sym_preproc_elif_token1] = ACTIONS(5121),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5123),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5123),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5121),
    [anon_sym_PLUS] = ACTIONS(5121),
    [anon_sym_STAR] = ACTIONS(5121),
    [anon_sym_SLASH] = ACTIONS(5121),
    [anon_sym_PERCENT] = ACTIONS(5121),
    [anon_sym_PIPE_PIPE] = ACTIONS(5123),
    [anon_sym_AMP_AMP] = ACTIONS(5123),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_CARET] = ACTIONS(5121),
    [anon_sym_AMP] = ACTIONS(5121),
    [anon_sym_EQ_EQ] = ACTIONS(5123),
    [anon_sym_BANG_EQ] = ACTIONS(5123),
    [anon_sym_GT] = ACTIONS(5121),
    [anon_sym_GT_EQ] = ACTIONS(5123),
    [anon_sym_LT_EQ] = ACTIONS(5121),
    [anon_sym_LT] = ACTIONS(5121),
    [anon_sym_LT_LT] = ACTIONS(5121),
    [anon_sym_GT_GT] = ACTIONS(5121),
    [anon_sym_SEMI] = ACTIONS(5123),
    [anon_sym___attribute__] = ACTIONS(5121),
    [anon_sym_COLON_COLON] = ACTIONS(5123),
    [anon_sym_LBRACE] = ACTIONS(5123),
    [anon_sym_RBRACE] = ACTIONS(5123),
    [anon_sym_LBRACK] = ACTIONS(5123),
    [anon_sym_RBRACK] = ACTIONS(5123),
    [anon_sym_EQ] = ACTIONS(5121),
    [anon_sym_COLON] = ACTIONS(5121),
    [anon_sym_QMARK] = ACTIONS(5123),
    [anon_sym_STAR_EQ] = ACTIONS(5123),
    [anon_sym_SLASH_EQ] = ACTIONS(5123),
    [anon_sym_PERCENT_EQ] = ACTIONS(5123),
    [anon_sym_PLUS_EQ] = ACTIONS(5123),
    [anon_sym_DASH_EQ] = ACTIONS(5123),
    [anon_sym_LT_LT_EQ] = ACTIONS(5123),
    [anon_sym_GT_GT_EQ] = ACTIONS(5123),
    [anon_sym_AMP_EQ] = ACTIONS(5123),
    [anon_sym_CARET_EQ] = ACTIONS(5123),
    [anon_sym_PIPE_EQ] = ACTIONS(5123),
    [anon_sym_and_eq] = ACTIONS(5121),
    [anon_sym_or_eq] = ACTIONS(5121),
    [anon_sym_xor_eq] = ACTIONS(5121),
    [anon_sym_LT_EQ_GT] = ACTIONS(5123),
    [anon_sym_or] = ACTIONS(5121),
    [anon_sym_and] = ACTIONS(5121),
    [anon_sym_bitor] = ACTIONS(5121),
    [anon_sym_xor] = ACTIONS(5121),
    [anon_sym_bitand] = ACTIONS(5121),
    [anon_sym_not_eq] = ACTIONS(5121),
    [anon_sym_DASH_DASH] = ACTIONS(5123),
    [anon_sym_PLUS_PLUS] = ACTIONS(5123),
    [anon_sym_DOT] = ACTIONS(5121),
    [anon_sym_DOT_STAR] = ACTIONS(5123),
    [anon_sym_DASH_GT] = ACTIONS(5123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5121),
    [anon_sym_decltype] = ACTIONS(5121),
    [anon_sym_final] = ACTIONS(5121),
    [anon_sym_override] = ACTIONS(5121),
  },
  [2425] = {
    [sym_identifier] = ACTIONS(5626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_RPAREN] = ACTIONS(5628),
    [aux_sym_preproc_if_token2] = ACTIONS(5628),
    [aux_sym_preproc_else_token1] = ACTIONS(5628),
    [aux_sym_preproc_elif_token1] = ACTIONS(5626),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5628),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5628),
    [anon_sym_LPAREN2] = ACTIONS(5628),
    [anon_sym_DASH] = ACTIONS(5626),
    [anon_sym_PLUS] = ACTIONS(5626),
    [anon_sym_STAR] = ACTIONS(5626),
    [anon_sym_SLASH] = ACTIONS(5626),
    [anon_sym_PERCENT] = ACTIONS(5626),
    [anon_sym_PIPE_PIPE] = ACTIONS(5628),
    [anon_sym_AMP_AMP] = ACTIONS(5628),
    [anon_sym_PIPE] = ACTIONS(5626),
    [anon_sym_CARET] = ACTIONS(5626),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym_EQ_EQ] = ACTIONS(5628),
    [anon_sym_BANG_EQ] = ACTIONS(5628),
    [anon_sym_GT] = ACTIONS(5626),
    [anon_sym_GT_EQ] = ACTIONS(5628),
    [anon_sym_LT_EQ] = ACTIONS(5626),
    [anon_sym_LT] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5626),
    [anon_sym_GT_GT] = ACTIONS(5626),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym___attribute__] = ACTIONS(5626),
    [anon_sym_COLON_COLON] = ACTIONS(5485),
    [anon_sym_LBRACE] = ACTIONS(5628),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_LBRACK] = ACTIONS(5628),
    [anon_sym_RBRACK] = ACTIONS(5628),
    [anon_sym_EQ] = ACTIONS(5626),
    [anon_sym_COLON] = ACTIONS(5626),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_STAR_EQ] = ACTIONS(5628),
    [anon_sym_SLASH_EQ] = ACTIONS(5628),
    [anon_sym_PERCENT_EQ] = ACTIONS(5628),
    [anon_sym_PLUS_EQ] = ACTIONS(5628),
    [anon_sym_DASH_EQ] = ACTIONS(5628),
    [anon_sym_LT_LT_EQ] = ACTIONS(5628),
    [anon_sym_GT_GT_EQ] = ACTIONS(5628),
    [anon_sym_AMP_EQ] = ACTIONS(5628),
    [anon_sym_CARET_EQ] = ACTIONS(5628),
    [anon_sym_PIPE_EQ] = ACTIONS(5628),
    [anon_sym_and_eq] = ACTIONS(5626),
    [anon_sym_or_eq] = ACTIONS(5626),
    [anon_sym_xor_eq] = ACTIONS(5626),
    [anon_sym_LT_EQ_GT] = ACTIONS(5628),
    [anon_sym_or] = ACTIONS(5626),
    [anon_sym_and] = ACTIONS(5626),
    [anon_sym_bitor] = ACTIONS(5626),
    [anon_sym_xor] = ACTIONS(5626),
    [anon_sym_bitand] = ACTIONS(5626),
    [anon_sym_not_eq] = ACTIONS(5626),
    [anon_sym_DASH_DASH] = ACTIONS(5628),
    [anon_sym_PLUS_PLUS] = ACTIONS(5628),
    [anon_sym_DOT] = ACTIONS(5626),
    [anon_sym_DOT_STAR] = ACTIONS(5628),
    [anon_sym_DASH_GT] = ACTIONS(5628),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5626),
    [anon_sym_decltype] = ACTIONS(5626),
    [anon_sym_final] = ACTIONS(5626),
    [anon_sym_override] = ACTIONS(5626),
  },
  [2426] = {
    [sym_identifier] = ACTIONS(5626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_RPAREN] = ACTIONS(5628),
    [aux_sym_preproc_if_token2] = ACTIONS(5628),
    [aux_sym_preproc_else_token1] = ACTIONS(5628),
    [aux_sym_preproc_elif_token1] = ACTIONS(5626),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5628),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5628),
    [anon_sym_LPAREN2] = ACTIONS(5628),
    [anon_sym_DASH] = ACTIONS(5626),
    [anon_sym_PLUS] = ACTIONS(5626),
    [anon_sym_STAR] = ACTIONS(5626),
    [anon_sym_SLASH] = ACTIONS(5626),
    [anon_sym_PERCENT] = ACTIONS(5626),
    [anon_sym_PIPE_PIPE] = ACTIONS(5628),
    [anon_sym_AMP_AMP] = ACTIONS(5628),
    [anon_sym_PIPE] = ACTIONS(5626),
    [anon_sym_CARET] = ACTIONS(5626),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym_EQ_EQ] = ACTIONS(5628),
    [anon_sym_BANG_EQ] = ACTIONS(5628),
    [anon_sym_GT] = ACTIONS(5626),
    [anon_sym_GT_EQ] = ACTIONS(5628),
    [anon_sym_LT_EQ] = ACTIONS(5626),
    [anon_sym_LT] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5626),
    [anon_sym_GT_GT] = ACTIONS(5626),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym___attribute__] = ACTIONS(5626),
    [anon_sym_COLON_COLON] = ACTIONS(5485),
    [anon_sym_LBRACE] = ACTIONS(5628),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_LBRACK] = ACTIONS(5628),
    [anon_sym_RBRACK] = ACTIONS(5628),
    [anon_sym_EQ] = ACTIONS(5626),
    [anon_sym_COLON] = ACTIONS(5626),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_STAR_EQ] = ACTIONS(5628),
    [anon_sym_SLASH_EQ] = ACTIONS(5628),
    [anon_sym_PERCENT_EQ] = ACTIONS(5628),
    [anon_sym_PLUS_EQ] = ACTIONS(5628),
    [anon_sym_DASH_EQ] = ACTIONS(5628),
    [anon_sym_LT_LT_EQ] = ACTIONS(5628),
    [anon_sym_GT_GT_EQ] = ACTIONS(5628),
    [anon_sym_AMP_EQ] = ACTIONS(5628),
    [anon_sym_CARET_EQ] = ACTIONS(5628),
    [anon_sym_PIPE_EQ] = ACTIONS(5628),
    [anon_sym_and_eq] = ACTIONS(5626),
    [anon_sym_or_eq] = ACTIONS(5626),
    [anon_sym_xor_eq] = ACTIONS(5626),
    [anon_sym_LT_EQ_GT] = ACTIONS(5628),
    [anon_sym_or] = ACTIONS(5626),
    [anon_sym_and] = ACTIONS(5626),
    [anon_sym_bitor] = ACTIONS(5626),
    [anon_sym_xor] = ACTIONS(5626),
    [anon_sym_bitand] = ACTIONS(5626),
    [anon_sym_not_eq] = ACTIONS(5626),
    [anon_sym_DASH_DASH] = ACTIONS(5628),
    [anon_sym_PLUS_PLUS] = ACTIONS(5628),
    [anon_sym_DOT] = ACTIONS(5626),
    [anon_sym_DOT_STAR] = ACTIONS(5628),
    [anon_sym_DASH_GT] = ACTIONS(5628),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5626),
    [anon_sym_decltype] = ACTIONS(5626),
    [anon_sym_final] = ACTIONS(5626),
    [anon_sym_override] = ACTIONS(5626),
  },
  [2427] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2079),
    [sym_identifier] = ACTIONS(5733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5730),
    [anon_sym_COMMA] = ACTIONS(5730),
    [aux_sym_preproc_if_token2] = ACTIONS(5730),
    [aux_sym_preproc_else_token1] = ACTIONS(5730),
    [aux_sym_preproc_elif_token1] = ACTIONS(5733),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5730),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5730),
    [anon_sym_LPAREN2] = ACTIONS(5730),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_PLUS] = ACTIONS(5733),
    [anon_sym_STAR] = ACTIONS(5733),
    [anon_sym_SLASH] = ACTIONS(5733),
    [anon_sym_PERCENT] = ACTIONS(5733),
    [anon_sym_PIPE_PIPE] = ACTIONS(5730),
    [anon_sym_AMP_AMP] = ACTIONS(5730),
    [anon_sym_PIPE] = ACTIONS(5733),
    [anon_sym_CARET] = ACTIONS(5733),
    [anon_sym_AMP] = ACTIONS(5733),
    [anon_sym_EQ_EQ] = ACTIONS(5730),
    [anon_sym_BANG_EQ] = ACTIONS(5730),
    [anon_sym_GT] = ACTIONS(5733),
    [anon_sym_GT_EQ] = ACTIONS(5730),
    [anon_sym_LT_EQ] = ACTIONS(5733),
    [anon_sym_LT] = ACTIONS(5733),
    [anon_sym_LT_LT] = ACTIONS(5733),
    [anon_sym_GT_GT] = ACTIONS(5733),
    [anon_sym___attribute__] = ACTIONS(5733),
    [anon_sym_LBRACE] = ACTIONS(5730),
    [anon_sym_signed] = ACTIONS(5402),
    [anon_sym_unsigned] = ACTIONS(5402),
    [anon_sym_long] = ACTIONS(5402),
    [anon_sym_short] = ACTIONS(5402),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_EQ] = ACTIONS(5733),
    [aux_sym_primitive_type_token1] = ACTIONS(5363),
    [anon_sym_byte] = ACTIONS(5363),
    [anon_sym_word] = ACTIONS(5363),
    [anon_sym_QMARK] = ACTIONS(5730),
    [anon_sym_STAR_EQ] = ACTIONS(5730),
    [anon_sym_SLASH_EQ] = ACTIONS(5730),
    [anon_sym_PERCENT_EQ] = ACTIONS(5730),
    [anon_sym_PLUS_EQ] = ACTIONS(5730),
    [anon_sym_DASH_EQ] = ACTIONS(5730),
    [anon_sym_LT_LT_EQ] = ACTIONS(5730),
    [anon_sym_GT_GT_EQ] = ACTIONS(5730),
    [anon_sym_AMP_EQ] = ACTIONS(5730),
    [anon_sym_CARET_EQ] = ACTIONS(5730),
    [anon_sym_PIPE_EQ] = ACTIONS(5730),
    [anon_sym_and_eq] = ACTIONS(5733),
    [anon_sym_or_eq] = ACTIONS(5733),
    [anon_sym_xor_eq] = ACTIONS(5733),
    [anon_sym_LT_EQ_GT] = ACTIONS(5730),
    [anon_sym_or] = ACTIONS(5733),
    [anon_sym_and] = ACTIONS(5733),
    [anon_sym_bitor] = ACTIONS(5733),
    [anon_sym_xor] = ACTIONS(5733),
    [anon_sym_bitand] = ACTIONS(5733),
    [anon_sym_not_eq] = ACTIONS(5733),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_DOT] = ACTIONS(5733),
    [anon_sym_DOT_STAR] = ACTIONS(5730),
    [anon_sym_DASH_GT] = ACTIONS(5730),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5733),
    [anon_sym_decltype] = ACTIONS(5733),
  },
  [2428] = {
    [sym_identifier] = ACTIONS(5125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5127),
    [anon_sym_COMMA] = ACTIONS(5127),
    [anon_sym_RPAREN] = ACTIONS(5127),
    [aux_sym_preproc_if_token2] = ACTIONS(5127),
    [aux_sym_preproc_else_token1] = ACTIONS(5127),
    [aux_sym_preproc_elif_token1] = ACTIONS(5125),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5127),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5127),
    [anon_sym_LPAREN2] = ACTIONS(5127),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_PLUS] = ACTIONS(5125),
    [anon_sym_STAR] = ACTIONS(5125),
    [anon_sym_SLASH] = ACTIONS(5125),
    [anon_sym_PERCENT] = ACTIONS(5125),
    [anon_sym_PIPE_PIPE] = ACTIONS(5127),
    [anon_sym_AMP_AMP] = ACTIONS(5127),
    [anon_sym_PIPE] = ACTIONS(5125),
    [anon_sym_CARET] = ACTIONS(5125),
    [anon_sym_AMP] = ACTIONS(5125),
    [anon_sym_EQ_EQ] = ACTIONS(5127),
    [anon_sym_BANG_EQ] = ACTIONS(5127),
    [anon_sym_GT] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5127),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_LT] = ACTIONS(5125),
    [anon_sym_LT_LT] = ACTIONS(5125),
    [anon_sym_GT_GT] = ACTIONS(5125),
    [anon_sym_SEMI] = ACTIONS(5127),
    [anon_sym___attribute__] = ACTIONS(5125),
    [anon_sym_COLON_COLON] = ACTIONS(5127),
    [anon_sym_LBRACE] = ACTIONS(5127),
    [anon_sym_RBRACE] = ACTIONS(5127),
    [anon_sym_LBRACK] = ACTIONS(5127),
    [anon_sym_RBRACK] = ACTIONS(5127),
    [anon_sym_EQ] = ACTIONS(5125),
    [anon_sym_COLON] = ACTIONS(5125),
    [anon_sym_QMARK] = ACTIONS(5127),
    [anon_sym_STAR_EQ] = ACTIONS(5127),
    [anon_sym_SLASH_EQ] = ACTIONS(5127),
    [anon_sym_PERCENT_EQ] = ACTIONS(5127),
    [anon_sym_PLUS_EQ] = ACTIONS(5127),
    [anon_sym_DASH_EQ] = ACTIONS(5127),
    [anon_sym_LT_LT_EQ] = ACTIONS(5127),
    [anon_sym_GT_GT_EQ] = ACTIONS(5127),
    [anon_sym_AMP_EQ] = ACTIONS(5127),
    [anon_sym_CARET_EQ] = ACTIONS(5127),
    [anon_sym_PIPE_EQ] = ACTIONS(5127),
    [anon_sym_and_eq] = ACTIONS(5125),
    [anon_sym_or_eq] = ACTIONS(5125),
    [anon_sym_xor_eq] = ACTIONS(5125),
    [anon_sym_LT_EQ_GT] = ACTIONS(5127),
    [anon_sym_or] = ACTIONS(5125),
    [anon_sym_and] = ACTIONS(5125),
    [anon_sym_bitor] = ACTIONS(5125),
    [anon_sym_xor] = ACTIONS(5125),
    [anon_sym_bitand] = ACTIONS(5125),
    [anon_sym_not_eq] = ACTIONS(5125),
    [anon_sym_DASH_DASH] = ACTIONS(5127),
    [anon_sym_PLUS_PLUS] = ACTIONS(5127),
    [anon_sym_DOT] = ACTIONS(5125),
    [anon_sym_DOT_STAR] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5127),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5125),
    [anon_sym_decltype] = ACTIONS(5125),
    [anon_sym_final] = ACTIONS(5125),
    [anon_sym_override] = ACTIONS(5125),
  },
  [2429] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(4471),
    [sym_raw_string_literal] = STATE(3057),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5870),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_RBRACE] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4280),
    [anon_sym_COLON] = ACTIONS(4290),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_and_eq] = ACTIONS(4284),
    [anon_sym_or_eq] = ACTIONS(4284),
    [anon_sym_xor_eq] = ACTIONS(4284),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [2430] = {
    [sym_identifier] = ACTIONS(3427),
    [aux_sym_preproc_def_token1] = ACTIONS(3427),
    [aux_sym_preproc_if_token1] = ACTIONS(3427),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3427),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3427),
    [sym_preproc_directive] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3429),
    [anon_sym_TILDE] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(3429),
    [anon_sym_AMP_AMP] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(5873),
    [anon_sym___extension__] = ACTIONS(3427),
    [anon_sym_typedef] = ACTIONS(3427),
    [anon_sym_extern] = ACTIONS(3427),
    [anon_sym___attribute__] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3429),
    [anon_sym___declspec] = ACTIONS(3427),
    [anon_sym___based] = ACTIONS(3427),
    [anon_sym_RBRACE] = ACTIONS(3429),
    [anon_sym_signed] = ACTIONS(3427),
    [anon_sym_unsigned] = ACTIONS(3427),
    [anon_sym_long] = ACTIONS(3427),
    [anon_sym_short] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_register] = ACTIONS(3427),
    [anon_sym_inline] = ACTIONS(3427),
    [anon_sym___inline] = ACTIONS(3427),
    [anon_sym___inline__] = ACTIONS(3427),
    [anon_sym___forceinline] = ACTIONS(3427),
    [anon_sym_thread_local] = ACTIONS(3427),
    [anon_sym___thread] = ACTIONS(3427),
    [anon_sym_const] = ACTIONS(3427),
    [anon_sym_constexpr] = ACTIONS(3427),
    [anon_sym_volatile] = ACTIONS(3427),
    [anon_sym_restrict] = ACTIONS(3427),
    [anon_sym___restrict__] = ACTIONS(3427),
    [anon_sym__Atomic] = ACTIONS(3427),
    [anon_sym__Noreturn] = ACTIONS(3427),
    [anon_sym_noreturn] = ACTIONS(3427),
    [anon_sym_mutable] = ACTIONS(3427),
    [anon_sym_constinit] = ACTIONS(3427),
    [anon_sym_consteval] = ACTIONS(3427),
    [anon_sym_PROGMEM] = ACTIONS(3427),
    [aux_sym_primitive_type_token1] = ACTIONS(3427),
    [anon_sym_byte] = ACTIONS(3427),
    [anon_sym_word] = ACTIONS(3427),
    [anon_sym_enum] = ACTIONS(3427),
    [anon_sym_class] = ACTIONS(3427),
    [anon_sym_struct] = ACTIONS(3427),
    [anon_sym_union] = ACTIONS(3427),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3427),
    [anon_sym_decltype] = ACTIONS(3427),
    [anon_sym_virtual] = ACTIONS(3427),
    [anon_sym_alignas] = ACTIONS(3427),
    [anon_sym_explicit] = ACTIONS(3427),
    [anon_sym_typename] = ACTIONS(3427),
    [anon_sym_template] = ACTIONS(3427),
    [anon_sym_operator] = ACTIONS(3427),
    [anon_sym_friend] = ACTIONS(3427),
    [anon_sym_public] = ACTIONS(3427),
    [anon_sym_private] = ACTIONS(3427),
    [anon_sym_protected] = ACTIONS(3427),
    [anon_sym_using] = ACTIONS(3427),
    [anon_sym_static_assert] = ACTIONS(3427),
  },
  [2431] = {
    [sym_identifier] = ACTIONS(5160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5167),
    [anon_sym_COMMA] = ACTIONS(5167),
    [anon_sym_RPAREN] = ACTIONS(5167),
    [aux_sym_preproc_if_token2] = ACTIONS(5167),
    [aux_sym_preproc_else_token1] = ACTIONS(5167),
    [aux_sym_preproc_elif_token1] = ACTIONS(5160),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5167),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5167),
    [anon_sym_LPAREN2] = ACTIONS(5167),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_PLUS] = ACTIONS(5160),
    [anon_sym_STAR] = ACTIONS(5167),
    [anon_sym_SLASH] = ACTIONS(5160),
    [anon_sym_PERCENT] = ACTIONS(5167),
    [anon_sym_PIPE_PIPE] = ACTIONS(5167),
    [anon_sym_AMP_AMP] = ACTIONS(5167),
    [anon_sym_PIPE] = ACTIONS(5160),
    [anon_sym_CARET] = ACTIONS(5167),
    [anon_sym_AMP] = ACTIONS(5160),
    [anon_sym_EQ_EQ] = ACTIONS(5167),
    [anon_sym_BANG_EQ] = ACTIONS(5167),
    [anon_sym_GT] = ACTIONS(5160),
    [anon_sym_GT_EQ] = ACTIONS(5167),
    [anon_sym_LT_EQ] = ACTIONS(5160),
    [anon_sym_LT] = ACTIONS(5160),
    [anon_sym_LT_LT] = ACTIONS(5167),
    [anon_sym_GT_GT] = ACTIONS(5167),
    [anon_sym_SEMI] = ACTIONS(5167),
    [anon_sym___extension__] = ACTIONS(5160),
    [anon_sym___attribute__] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5167),
    [anon_sym_LBRACE] = ACTIONS(5167),
    [anon_sym_RBRACE] = ACTIONS(5167),
    [anon_sym_LBRACK] = ACTIONS(5167),
    [anon_sym_RBRACK] = ACTIONS(5167),
    [anon_sym_const] = ACTIONS(5160),
    [anon_sym_constexpr] = ACTIONS(5160),
    [anon_sym_volatile] = ACTIONS(5160),
    [anon_sym_restrict] = ACTIONS(5160),
    [anon_sym___restrict__] = ACTIONS(5160),
    [anon_sym__Atomic] = ACTIONS(5160),
    [anon_sym__Noreturn] = ACTIONS(5160),
    [anon_sym_noreturn] = ACTIONS(5160),
    [anon_sym_mutable] = ACTIONS(5160),
    [anon_sym_constinit] = ACTIONS(5160),
    [anon_sym_consteval] = ACTIONS(5160),
    [anon_sym_PROGMEM] = ACTIONS(5160),
    [anon_sym_COLON] = ACTIONS(5160),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_LT_EQ_GT] = ACTIONS(5167),
    [anon_sym_or] = ACTIONS(5160),
    [anon_sym_and] = ACTIONS(5160),
    [anon_sym_bitor] = ACTIONS(5160),
    [anon_sym_xor] = ACTIONS(5160),
    [anon_sym_bitand] = ACTIONS(5160),
    [anon_sym_not_eq] = ACTIONS(5160),
    [anon_sym_DASH_DASH] = ACTIONS(5167),
    [anon_sym_PLUS_PLUS] = ACTIONS(5167),
    [anon_sym_DOT] = ACTIONS(5160),
    [anon_sym_DOT_STAR] = ACTIONS(5167),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5160),
    [anon_sym_decltype] = ACTIONS(5160),
    [anon_sym_final] = ACTIONS(5160),
    [anon_sym_override] = ACTIONS(5160),
    [anon_sym_requires] = ACTIONS(5160),
  },
  [2432] = {
    [sym_string_literal] = STATE(2416),
    [sym_raw_string_literal] = STATE(2416),
    [aux_sym_concatenated_string_repeat1] = STATE(2416),
    [sym_identifier] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5387),
    [anon_sym_COMMA] = ACTIONS(5387),
    [aux_sym_preproc_if_token2] = ACTIONS(5387),
    [aux_sym_preproc_else_token1] = ACTIONS(5387),
    [aux_sym_preproc_elif_token1] = ACTIONS(5387),
    [anon_sym_LPAREN2] = ACTIONS(5387),
    [anon_sym_DASH] = ACTIONS(5389),
    [anon_sym_PLUS] = ACTIONS(5389),
    [anon_sym_STAR] = ACTIONS(5389),
    [anon_sym_SLASH] = ACTIONS(5389),
    [anon_sym_PERCENT] = ACTIONS(5389),
    [anon_sym_PIPE_PIPE] = ACTIONS(5387),
    [anon_sym_AMP_AMP] = ACTIONS(5387),
    [anon_sym_PIPE] = ACTIONS(5389),
    [anon_sym_CARET] = ACTIONS(5389),
    [anon_sym_AMP] = ACTIONS(5389),
    [anon_sym_EQ_EQ] = ACTIONS(5387),
    [anon_sym_BANG_EQ] = ACTIONS(5387),
    [anon_sym_GT] = ACTIONS(5389),
    [anon_sym_GT_EQ] = ACTIONS(5387),
    [anon_sym_LT_EQ] = ACTIONS(5389),
    [anon_sym_LT] = ACTIONS(5389),
    [anon_sym_LT_LT] = ACTIONS(5389),
    [anon_sym_GT_GT] = ACTIONS(5389),
    [anon_sym_LBRACK] = ACTIONS(5387),
    [anon_sym_EQ] = ACTIONS(5389),
    [anon_sym_QMARK] = ACTIONS(5387),
    [anon_sym_STAR_EQ] = ACTIONS(5387),
    [anon_sym_SLASH_EQ] = ACTIONS(5387),
    [anon_sym_PERCENT_EQ] = ACTIONS(5387),
    [anon_sym_PLUS_EQ] = ACTIONS(5387),
    [anon_sym_DASH_EQ] = ACTIONS(5387),
    [anon_sym_LT_LT_EQ] = ACTIONS(5387),
    [anon_sym_GT_GT_EQ] = ACTIONS(5387),
    [anon_sym_AMP_EQ] = ACTIONS(5387),
    [anon_sym_CARET_EQ] = ACTIONS(5387),
    [anon_sym_PIPE_EQ] = ACTIONS(5387),
    [anon_sym_and_eq] = ACTIONS(5389),
    [anon_sym_or_eq] = ACTIONS(5389),
    [anon_sym_xor_eq] = ACTIONS(5389),
    [anon_sym_LT_EQ_GT] = ACTIONS(5387),
    [anon_sym_or] = ACTIONS(5389),
    [anon_sym_and] = ACTIONS(5389),
    [anon_sym_bitor] = ACTIONS(5389),
    [anon_sym_xor] = ACTIONS(5389),
    [anon_sym_bitand] = ACTIONS(5389),
    [anon_sym_not_eq] = ACTIONS(5389),
    [anon_sym_DASH_DASH] = ACTIONS(5387),
    [anon_sym_PLUS_PLUS] = ACTIONS(5387),
    [anon_sym_DOT] = ACTIONS(5389),
    [anon_sym_DOT_STAR] = ACTIONS(5387),
    [anon_sym_DASH_GT] = ACTIONS(5387),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [sym_literal_suffix] = ACTIONS(5389),
  },
  [2433] = {
    [sym_identifier] = ACTIONS(5495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5497),
    [anon_sym_COMMA] = ACTIONS(5497),
    [anon_sym_RPAREN] = ACTIONS(5497),
    [aux_sym_preproc_if_token2] = ACTIONS(5497),
    [aux_sym_preproc_else_token1] = ACTIONS(5497),
    [aux_sym_preproc_elif_token1] = ACTIONS(5495),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5497),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5497),
    [anon_sym_LPAREN2] = ACTIONS(5497),
    [anon_sym_DASH] = ACTIONS(5495),
    [anon_sym_PLUS] = ACTIONS(5495),
    [anon_sym_STAR] = ACTIONS(5495),
    [anon_sym_SLASH] = ACTIONS(5495),
    [anon_sym_PERCENT] = ACTIONS(5495),
    [anon_sym_PIPE_PIPE] = ACTIONS(5497),
    [anon_sym_AMP_AMP] = ACTIONS(5497),
    [anon_sym_PIPE] = ACTIONS(5495),
    [anon_sym_CARET] = ACTIONS(5495),
    [anon_sym_AMP] = ACTIONS(5495),
    [anon_sym_EQ_EQ] = ACTIONS(5497),
    [anon_sym_BANG_EQ] = ACTIONS(5497),
    [anon_sym_GT] = ACTIONS(5495),
    [anon_sym_GT_EQ] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5495),
    [anon_sym_LT_LT] = ACTIONS(5495),
    [anon_sym_GT_GT] = ACTIONS(5495),
    [anon_sym_SEMI] = ACTIONS(5497),
    [anon_sym___attribute__] = ACTIONS(5495),
    [anon_sym_COLON_COLON] = ACTIONS(5485),
    [anon_sym_LBRACE] = ACTIONS(5497),
    [anon_sym_RBRACE] = ACTIONS(5497),
    [anon_sym_LBRACK] = ACTIONS(5497),
    [anon_sym_RBRACK] = ACTIONS(5497),
    [anon_sym_EQ] = ACTIONS(5495),
    [anon_sym_COLON] = ACTIONS(5495),
    [anon_sym_QMARK] = ACTIONS(5497),
    [anon_sym_STAR_EQ] = ACTIONS(5497),
    [anon_sym_SLASH_EQ] = ACTIONS(5497),
    [anon_sym_PERCENT_EQ] = ACTIONS(5497),
    [anon_sym_PLUS_EQ] = ACTIONS(5497),
    [anon_sym_DASH_EQ] = ACTIONS(5497),
    [anon_sym_LT_LT_EQ] = ACTIONS(5497),
    [anon_sym_GT_GT_EQ] = ACTIONS(5497),
    [anon_sym_AMP_EQ] = ACTIONS(5497),
    [anon_sym_CARET_EQ] = ACTIONS(5497),
    [anon_sym_PIPE_EQ] = ACTIONS(5497),
    [anon_sym_and_eq] = ACTIONS(5495),
    [anon_sym_or_eq] = ACTIONS(5495),
    [anon_sym_xor_eq] = ACTIONS(5495),
    [anon_sym_LT_EQ_GT] = ACTIONS(5497),
    [anon_sym_or] = ACTIONS(5495),
    [anon_sym_and] = ACTIONS(5495),
    [anon_sym_bitor] = ACTIONS(5495),
    [anon_sym_xor] = ACTIONS(5495),
    [anon_sym_bitand] = ACTIONS(5495),
    [anon_sym_not_eq] = ACTIONS(5495),
    [anon_sym_DASH_DASH] = ACTIONS(5497),
    [anon_sym_PLUS_PLUS] = ACTIONS(5497),
    [anon_sym_DOT] = ACTIONS(5495),
    [anon_sym_DOT_STAR] = ACTIONS(5497),
    [anon_sym_DASH_GT] = ACTIONS(5497),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5495),
    [anon_sym_decltype] = ACTIONS(5495),
    [anon_sym_final] = ACTIONS(5495),
    [anon_sym_override] = ACTIONS(5495),
  },
  [2434] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(4471),
    [sym_raw_string_literal] = STATE(3057),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(5877),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5870),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5877),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_RBRACE] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(5879),
    [anon_sym_EQ] = ACTIONS(4280),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_and_eq] = ACTIONS(4284),
    [anon_sym_or_eq] = ACTIONS(4284),
    [anon_sym_xor_eq] = ACTIONS(4284),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [2435] = {
    [sym_string_literal] = STATE(2067),
    [sym_template_argument_list] = STATE(2840),
    [sym_raw_string_literal] = STATE(2067),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(5877),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5348),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5877),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_RBRACE] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(5879),
    [anon_sym_EQ] = ACTIONS(4256),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4248),
    [anon_sym_SLASH_EQ] = ACTIONS(4248),
    [anon_sym_PERCENT_EQ] = ACTIONS(4248),
    [anon_sym_PLUS_EQ] = ACTIONS(4248),
    [anon_sym_DASH_EQ] = ACTIONS(4248),
    [anon_sym_LT_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT_GT_EQ] = ACTIONS(4248),
    [anon_sym_AMP_EQ] = ACTIONS(4248),
    [anon_sym_CARET_EQ] = ACTIONS(4248),
    [anon_sym_PIPE_EQ] = ACTIONS(4248),
    [anon_sym_and_eq] = ACTIONS(4248),
    [anon_sym_or_eq] = ACTIONS(4248),
    [anon_sym_xor_eq] = ACTIONS(4248),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
  },
  [2436] = {
    [sym_identifier] = ACTIONS(5160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5167),
    [anon_sym_COMMA] = ACTIONS(5167),
    [anon_sym_RPAREN] = ACTIONS(5167),
    [aux_sym_preproc_if_token2] = ACTIONS(5167),
    [aux_sym_preproc_else_token1] = ACTIONS(5167),
    [aux_sym_preproc_elif_token1] = ACTIONS(5160),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5167),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5167),
    [anon_sym_LPAREN2] = ACTIONS(5167),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_PLUS] = ACTIONS(5160),
    [anon_sym_STAR] = ACTIONS(5160),
    [anon_sym_SLASH] = ACTIONS(5160),
    [anon_sym_PERCENT] = ACTIONS(5160),
    [anon_sym_PIPE_PIPE] = ACTIONS(5167),
    [anon_sym_AMP_AMP] = ACTIONS(5167),
    [anon_sym_PIPE] = ACTIONS(5160),
    [anon_sym_CARET] = ACTIONS(5160),
    [anon_sym_AMP] = ACTIONS(5160),
    [anon_sym_EQ_EQ] = ACTIONS(5167),
    [anon_sym_BANG_EQ] = ACTIONS(5167),
    [anon_sym_GT] = ACTIONS(5160),
    [anon_sym_GT_EQ] = ACTIONS(5167),
    [anon_sym_LT_EQ] = ACTIONS(5160),
    [anon_sym_LT] = ACTIONS(5160),
    [anon_sym_LT_LT] = ACTIONS(5160),
    [anon_sym_GT_GT] = ACTIONS(5160),
    [anon_sym_SEMI] = ACTIONS(5167),
    [anon_sym___attribute__] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5167),
    [anon_sym_LBRACE] = ACTIONS(5167),
    [anon_sym_RBRACE] = ACTIONS(5167),
    [anon_sym_LBRACK] = ACTIONS(5167),
    [anon_sym_RBRACK] = ACTIONS(5167),
    [anon_sym_EQ] = ACTIONS(5160),
    [anon_sym_COLON] = ACTIONS(5160),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_STAR_EQ] = ACTIONS(5167),
    [anon_sym_SLASH_EQ] = ACTIONS(5167),
    [anon_sym_PERCENT_EQ] = ACTIONS(5167),
    [anon_sym_PLUS_EQ] = ACTIONS(5167),
    [anon_sym_DASH_EQ] = ACTIONS(5167),
    [anon_sym_LT_LT_EQ] = ACTIONS(5167),
    [anon_sym_GT_GT_EQ] = ACTIONS(5167),
    [anon_sym_AMP_EQ] = ACTIONS(5167),
    [anon_sym_CARET_EQ] = ACTIONS(5167),
    [anon_sym_PIPE_EQ] = ACTIONS(5167),
    [anon_sym_and_eq] = ACTIONS(5160),
    [anon_sym_or_eq] = ACTIONS(5160),
    [anon_sym_xor_eq] = ACTIONS(5160),
    [anon_sym_LT_EQ_GT] = ACTIONS(5167),
    [anon_sym_or] = ACTIONS(5160),
    [anon_sym_and] = ACTIONS(5160),
    [anon_sym_bitor] = ACTIONS(5160),
    [anon_sym_xor] = ACTIONS(5160),
    [anon_sym_bitand] = ACTIONS(5160),
    [anon_sym_not_eq] = ACTIONS(5160),
    [anon_sym_DASH_DASH] = ACTIONS(5167),
    [anon_sym_PLUS_PLUS] = ACTIONS(5167),
    [anon_sym_DOT] = ACTIONS(5160),
    [anon_sym_DOT_STAR] = ACTIONS(5167),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5160),
    [anon_sym_decltype] = ACTIONS(5160),
    [anon_sym_final] = ACTIONS(5160),
    [anon_sym_override] = ACTIONS(5160),
  },
  [2437] = {
    [sym_string_literal] = STATE(2616),
    [sym_template_argument_list] = STATE(3687),
    [sym_raw_string_literal] = STATE(2616),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_RPAREN] = ACTIONS(5877),
    [anon_sym_LPAREN2] = ACTIONS(5877),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5188),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5877),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(5879),
    [anon_sym_EQ] = ACTIONS(4256),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4248),
    [anon_sym_SLASH_EQ] = ACTIONS(4248),
    [anon_sym_PERCENT_EQ] = ACTIONS(4248),
    [anon_sym_PLUS_EQ] = ACTIONS(4248),
    [anon_sym_DASH_EQ] = ACTIONS(4248),
    [anon_sym_LT_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT_GT_EQ] = ACTIONS(4248),
    [anon_sym_AMP_EQ] = ACTIONS(4248),
    [anon_sym_CARET_EQ] = ACTIONS(4248),
    [anon_sym_PIPE_EQ] = ACTIONS(4248),
    [anon_sym_and_eq] = ACTIONS(4248),
    [anon_sym_or_eq] = ACTIONS(4248),
    [anon_sym_xor_eq] = ACTIONS(4248),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4256),
    [anon_sym_L_DQUOTE] = ACTIONS(5184),
    [anon_sym_u_DQUOTE] = ACTIONS(5184),
    [anon_sym_U_DQUOTE] = ACTIONS(5184),
    [anon_sym_u8_DQUOTE] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5186),
    [anon_sym_LR_DQUOTE] = ACTIONS(5186),
    [anon_sym_uR_DQUOTE] = ACTIONS(5186),
    [anon_sym_UR_DQUOTE] = ACTIONS(5186),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5186),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4248),
  },
  [2438] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(4471),
    [sym_raw_string_literal] = STATE(3057),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_RPAREN] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5870),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_RBRACE] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4280),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_and_eq] = ACTIONS(4284),
    [anon_sym_or_eq] = ACTIONS(4284),
    [anon_sym_xor_eq] = ACTIONS(4284),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [2439] = {
    [sym_identifier] = ACTIONS(3332),
    [aux_sym_preproc_def_token1] = ACTIONS(3332),
    [aux_sym_preproc_if_token1] = ACTIONS(3332),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3332),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3332),
    [sym_preproc_directive] = ACTIONS(3332),
    [anon_sym_LPAREN2] = ACTIONS(3334),
    [anon_sym_TILDE] = ACTIONS(3334),
    [anon_sym_STAR] = ACTIONS(3334),
    [anon_sym_AMP_AMP] = ACTIONS(3334),
    [anon_sym_AMP] = ACTIONS(3332),
    [anon_sym_SEMI] = ACTIONS(5881),
    [anon_sym___extension__] = ACTIONS(3332),
    [anon_sym_typedef] = ACTIONS(3332),
    [anon_sym_extern] = ACTIONS(3332),
    [anon_sym___attribute__] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(3334),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3334),
    [anon_sym___declspec] = ACTIONS(3332),
    [anon_sym___based] = ACTIONS(3332),
    [anon_sym_RBRACE] = ACTIONS(3334),
    [anon_sym_signed] = ACTIONS(3332),
    [anon_sym_unsigned] = ACTIONS(3332),
    [anon_sym_long] = ACTIONS(3332),
    [anon_sym_short] = ACTIONS(3332),
    [anon_sym_LBRACK] = ACTIONS(3332),
    [anon_sym_static] = ACTIONS(3332),
    [anon_sym_register] = ACTIONS(3332),
    [anon_sym_inline] = ACTIONS(3332),
    [anon_sym___inline] = ACTIONS(3332),
    [anon_sym___inline__] = ACTIONS(3332),
    [anon_sym___forceinline] = ACTIONS(3332),
    [anon_sym_thread_local] = ACTIONS(3332),
    [anon_sym___thread] = ACTIONS(3332),
    [anon_sym_const] = ACTIONS(3332),
    [anon_sym_constexpr] = ACTIONS(3332),
    [anon_sym_volatile] = ACTIONS(3332),
    [anon_sym_restrict] = ACTIONS(3332),
    [anon_sym___restrict__] = ACTIONS(3332),
    [anon_sym__Atomic] = ACTIONS(3332),
    [anon_sym__Noreturn] = ACTIONS(3332),
    [anon_sym_noreturn] = ACTIONS(3332),
    [anon_sym_mutable] = ACTIONS(3332),
    [anon_sym_constinit] = ACTIONS(3332),
    [anon_sym_consteval] = ACTIONS(3332),
    [anon_sym_PROGMEM] = ACTIONS(3332),
    [aux_sym_primitive_type_token1] = ACTIONS(3332),
    [anon_sym_byte] = ACTIONS(3332),
    [anon_sym_word] = ACTIONS(3332),
    [anon_sym_enum] = ACTIONS(3332),
    [anon_sym_class] = ACTIONS(3332),
    [anon_sym_struct] = ACTIONS(3332),
    [anon_sym_union] = ACTIONS(3332),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3332),
    [anon_sym_decltype] = ACTIONS(3332),
    [anon_sym_virtual] = ACTIONS(3332),
    [anon_sym_alignas] = ACTIONS(3332),
    [anon_sym_explicit] = ACTIONS(3332),
    [anon_sym_typename] = ACTIONS(3332),
    [anon_sym_template] = ACTIONS(3332),
    [anon_sym_operator] = ACTIONS(3332),
    [anon_sym_friend] = ACTIONS(3332),
    [anon_sym_public] = ACTIONS(3332),
    [anon_sym_private] = ACTIONS(3332),
    [anon_sym_protected] = ACTIONS(3332),
    [anon_sym_using] = ACTIONS(3332),
    [anon_sym_static_assert] = ACTIONS(3332),
  },
  [2440] = {
    [sym_template_argument_list] = STATE(2036),
    [sym_identifier] = ACTIONS(5129),
    [anon_sym_LPAREN2] = ACTIONS(5136),
    [anon_sym_TILDE] = ACTIONS(5136),
    [anon_sym_STAR] = ACTIONS(5136),
    [anon_sym_PIPE_PIPE] = ACTIONS(5136),
    [anon_sym_AMP_AMP] = ACTIONS(5136),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5883),
    [anon_sym___extension__] = ACTIONS(5129),
    [anon_sym_extern] = ACTIONS(5129),
    [anon_sym___attribute__] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5136),
    [anon_sym___declspec] = ACTIONS(5129),
    [anon_sym___based] = ACTIONS(5129),
    [anon_sym___cdecl] = ACTIONS(5129),
    [anon_sym___clrcall] = ACTIONS(5129),
    [anon_sym___stdcall] = ACTIONS(5129),
    [anon_sym___fastcall] = ACTIONS(5129),
    [anon_sym___thiscall] = ACTIONS(5129),
    [anon_sym___vectorcall] = ACTIONS(5129),
    [anon_sym_signed] = ACTIONS(5129),
    [anon_sym_unsigned] = ACTIONS(5129),
    [anon_sym_long] = ACTIONS(5129),
    [anon_sym_short] = ACTIONS(5129),
    [anon_sym_LBRACK] = ACTIONS(5129),
    [anon_sym_static] = ACTIONS(5129),
    [anon_sym_register] = ACTIONS(5129),
    [anon_sym_inline] = ACTIONS(5129),
    [anon_sym___inline] = ACTIONS(5129),
    [anon_sym___inline__] = ACTIONS(5129),
    [anon_sym___forceinline] = ACTIONS(5129),
    [anon_sym_thread_local] = ACTIONS(5129),
    [anon_sym___thread] = ACTIONS(5129),
    [anon_sym_const] = ACTIONS(5129),
    [anon_sym_constexpr] = ACTIONS(5129),
    [anon_sym_volatile] = ACTIONS(5129),
    [anon_sym_restrict] = ACTIONS(5129),
    [anon_sym___restrict__] = ACTIONS(5129),
    [anon_sym__Atomic] = ACTIONS(5129),
    [anon_sym__Noreturn] = ACTIONS(5129),
    [anon_sym_noreturn] = ACTIONS(5129),
    [anon_sym_mutable] = ACTIONS(5129),
    [anon_sym_constinit] = ACTIONS(5129),
    [anon_sym_consteval] = ACTIONS(5129),
    [anon_sym_PROGMEM] = ACTIONS(5129),
    [aux_sym_primitive_type_token1] = ACTIONS(5129),
    [anon_sym_byte] = ACTIONS(5129),
    [anon_sym_word] = ACTIONS(5129),
    [anon_sym_enum] = ACTIONS(5129),
    [anon_sym_class] = ACTIONS(5129),
    [anon_sym_struct] = ACTIONS(5129),
    [anon_sym_union] = ACTIONS(5129),
    [anon_sym_or] = ACTIONS(5129),
    [anon_sym_and] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5129),
    [anon_sym_decltype] = ACTIONS(5129),
    [anon_sym_virtual] = ACTIONS(5129),
    [anon_sym_alignas] = ACTIONS(5129),
    [anon_sym_explicit] = ACTIONS(5129),
    [anon_sym_typename] = ACTIONS(5129),
    [anon_sym_template] = ACTIONS(5129),
    [anon_sym_operator] = ACTIONS(5129),
    [anon_sym_friend] = ACTIONS(5129),
    [anon_sym_using] = ACTIONS(5129),
    [anon_sym_concept] = ACTIONS(5129),
  },
  [2441] = {
    [sym_string_literal] = STATE(2067),
    [sym_raw_string_literal] = STATE(2067),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_RPAREN] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(4256),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym_RBRACE] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_RBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4256),
    [anon_sym_COLON] = ACTIONS(4248),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4248),
    [anon_sym_SLASH_EQ] = ACTIONS(4248),
    [anon_sym_PERCENT_EQ] = ACTIONS(4248),
    [anon_sym_PLUS_EQ] = ACTIONS(4248),
    [anon_sym_DASH_EQ] = ACTIONS(4248),
    [anon_sym_LT_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT_GT_EQ] = ACTIONS(4248),
    [anon_sym_AMP_EQ] = ACTIONS(4248),
    [anon_sym_CARET_EQ] = ACTIONS(4248),
    [anon_sym_PIPE_EQ] = ACTIONS(4248),
    [anon_sym_and_eq] = ACTIONS(4256),
    [anon_sym_or_eq] = ACTIONS(4256),
    [anon_sym_xor_eq] = ACTIONS(4256),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4256),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4256),
    [anon_sym_not_eq] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [sym_literal_suffix] = ACTIONS(5801),
  },
  [2442] = {
    [sym_string_literal] = STATE(2067),
    [sym_raw_string_literal] = STATE(2067),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5799),
    [anon_sym_COMMA] = ACTIONS(5799),
    [anon_sym_RPAREN] = ACTIONS(5799),
    [anon_sym_LPAREN2] = ACTIONS(5799),
    [anon_sym_DASH] = ACTIONS(5797),
    [anon_sym_PLUS] = ACTIONS(5797),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_SLASH] = ACTIONS(5797),
    [anon_sym_PERCENT] = ACTIONS(5797),
    [anon_sym_PIPE_PIPE] = ACTIONS(5799),
    [anon_sym_AMP_AMP] = ACTIONS(5799),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_CARET] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_EQ_EQ] = ACTIONS(5799),
    [anon_sym_BANG_EQ] = ACTIONS(5799),
    [anon_sym_GT] = ACTIONS(5797),
    [anon_sym_GT_EQ] = ACTIONS(5799),
    [anon_sym_LT_EQ] = ACTIONS(5797),
    [anon_sym_LT] = ACTIONS(5797),
    [anon_sym_LT_LT] = ACTIONS(5797),
    [anon_sym_GT_GT] = ACTIONS(5797),
    [anon_sym_SEMI] = ACTIONS(5799),
    [anon_sym_RBRACE] = ACTIONS(5799),
    [anon_sym_LBRACK] = ACTIONS(5799),
    [anon_sym_RBRACK] = ACTIONS(5799),
    [anon_sym_EQ] = ACTIONS(5797),
    [anon_sym_COLON] = ACTIONS(5799),
    [anon_sym_QMARK] = ACTIONS(5799),
    [anon_sym_STAR_EQ] = ACTIONS(5799),
    [anon_sym_SLASH_EQ] = ACTIONS(5799),
    [anon_sym_PERCENT_EQ] = ACTIONS(5799),
    [anon_sym_PLUS_EQ] = ACTIONS(5799),
    [anon_sym_DASH_EQ] = ACTIONS(5799),
    [anon_sym_LT_LT_EQ] = ACTIONS(5799),
    [anon_sym_GT_GT_EQ] = ACTIONS(5799),
    [anon_sym_AMP_EQ] = ACTIONS(5799),
    [anon_sym_CARET_EQ] = ACTIONS(5799),
    [anon_sym_PIPE_EQ] = ACTIONS(5799),
    [anon_sym_and_eq] = ACTIONS(5797),
    [anon_sym_or_eq] = ACTIONS(5797),
    [anon_sym_xor_eq] = ACTIONS(5797),
    [anon_sym_LT_EQ_GT] = ACTIONS(5799),
    [anon_sym_or] = ACTIONS(5797),
    [anon_sym_and] = ACTIONS(5797),
    [anon_sym_bitor] = ACTIONS(5797),
    [anon_sym_xor] = ACTIONS(5797),
    [anon_sym_bitand] = ACTIONS(5797),
    [anon_sym_not_eq] = ACTIONS(5797),
    [anon_sym_DASH_DASH] = ACTIONS(5799),
    [anon_sym_PLUS_PLUS] = ACTIONS(5799),
    [anon_sym_DOT] = ACTIONS(5797),
    [anon_sym_DOT_STAR] = ACTIONS(5799),
    [anon_sym_DASH_GT] = ACTIONS(5799),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [sym_literal_suffix] = ACTIONS(5801),
  },
  [2443] = {
    [sym_string_literal] = STATE(2443),
    [sym_raw_string_literal] = STATE(2443),
    [aux_sym_concatenated_string_repeat1] = STATE(2443),
    [sym_identifier] = ACTIONS(5885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5373),
    [anon_sym_COMMA] = ACTIONS(5373),
    [aux_sym_preproc_if_token2] = ACTIONS(5373),
    [aux_sym_preproc_else_token1] = ACTIONS(5373),
    [aux_sym_preproc_elif_token1] = ACTIONS(5373),
    [anon_sym_LPAREN2] = ACTIONS(5373),
    [anon_sym_DASH] = ACTIONS(5375),
    [anon_sym_PLUS] = ACTIONS(5375),
    [anon_sym_STAR] = ACTIONS(5375),
    [anon_sym_SLASH] = ACTIONS(5375),
    [anon_sym_PERCENT] = ACTIONS(5375),
    [anon_sym_PIPE_PIPE] = ACTIONS(5373),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_PIPE] = ACTIONS(5375),
    [anon_sym_CARET] = ACTIONS(5375),
    [anon_sym_AMP] = ACTIONS(5375),
    [anon_sym_EQ_EQ] = ACTIONS(5373),
    [anon_sym_BANG_EQ] = ACTIONS(5373),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5373),
    [anon_sym_LT_EQ] = ACTIONS(5375),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_LT] = ACTIONS(5375),
    [anon_sym_GT_GT] = ACTIONS(5375),
    [anon_sym_LBRACK] = ACTIONS(5373),
    [anon_sym_EQ] = ACTIONS(5375),
    [anon_sym_QMARK] = ACTIONS(5373),
    [anon_sym_STAR_EQ] = ACTIONS(5373),
    [anon_sym_SLASH_EQ] = ACTIONS(5373),
    [anon_sym_PERCENT_EQ] = ACTIONS(5373),
    [anon_sym_PLUS_EQ] = ACTIONS(5373),
    [anon_sym_DASH_EQ] = ACTIONS(5373),
    [anon_sym_LT_LT_EQ] = ACTIONS(5373),
    [anon_sym_GT_GT_EQ] = ACTIONS(5373),
    [anon_sym_AMP_EQ] = ACTIONS(5373),
    [anon_sym_CARET_EQ] = ACTIONS(5373),
    [anon_sym_PIPE_EQ] = ACTIONS(5373),
    [anon_sym_and_eq] = ACTIONS(5375),
    [anon_sym_or_eq] = ACTIONS(5375),
    [anon_sym_xor_eq] = ACTIONS(5375),
    [anon_sym_LT_EQ_GT] = ACTIONS(5373),
    [anon_sym_or] = ACTIONS(5375),
    [anon_sym_and] = ACTIONS(5375),
    [anon_sym_bitor] = ACTIONS(5375),
    [anon_sym_xor] = ACTIONS(5375),
    [anon_sym_bitand] = ACTIONS(5375),
    [anon_sym_not_eq] = ACTIONS(5375),
    [anon_sym_DASH_DASH] = ACTIONS(5373),
    [anon_sym_PLUS_PLUS] = ACTIONS(5373),
    [anon_sym_DOT] = ACTIONS(5375),
    [anon_sym_DOT_STAR] = ACTIONS(5373),
    [anon_sym_DASH_GT] = ACTIONS(5373),
    [anon_sym_L_DQUOTE] = ACTIONS(5888),
    [anon_sym_u_DQUOTE] = ACTIONS(5888),
    [anon_sym_U_DQUOTE] = ACTIONS(5888),
    [anon_sym_u8_DQUOTE] = ACTIONS(5888),
    [anon_sym_DQUOTE] = ACTIONS(5888),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5891),
    [anon_sym_LR_DQUOTE] = ACTIONS(5891),
    [anon_sym_uR_DQUOTE] = ACTIONS(5891),
    [anon_sym_UR_DQUOTE] = ACTIONS(5891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5891),
    [sym_literal_suffix] = ACTIONS(5375),
  },
  [2444] = {
    [sym_identifier] = ACTIONS(5113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5115),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_RPAREN] = ACTIONS(5115),
    [aux_sym_preproc_if_token2] = ACTIONS(5115),
    [aux_sym_preproc_else_token1] = ACTIONS(5115),
    [aux_sym_preproc_elif_token1] = ACTIONS(5113),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5115),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5115),
    [anon_sym_LPAREN2] = ACTIONS(5115),
    [anon_sym_DASH] = ACTIONS(5113),
    [anon_sym_PLUS] = ACTIONS(5113),
    [anon_sym_STAR] = ACTIONS(5113),
    [anon_sym_SLASH] = ACTIONS(5113),
    [anon_sym_PERCENT] = ACTIONS(5113),
    [anon_sym_PIPE_PIPE] = ACTIONS(5115),
    [anon_sym_AMP_AMP] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(5113),
    [anon_sym_CARET] = ACTIONS(5113),
    [anon_sym_AMP] = ACTIONS(5113),
    [anon_sym_EQ_EQ] = ACTIONS(5115),
    [anon_sym_BANG_EQ] = ACTIONS(5115),
    [anon_sym_GT] = ACTIONS(5113),
    [anon_sym_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_EQ] = ACTIONS(5113),
    [anon_sym_LT] = ACTIONS(5113),
    [anon_sym_LT_LT] = ACTIONS(5113),
    [anon_sym_GT_GT] = ACTIONS(5113),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym___attribute__] = ACTIONS(5113),
    [anon_sym_COLON_COLON] = ACTIONS(5115),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_RBRACE] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_RBRACK] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5113),
    [anon_sym_COLON] = ACTIONS(5113),
    [anon_sym_QMARK] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_and_eq] = ACTIONS(5113),
    [anon_sym_or_eq] = ACTIONS(5113),
    [anon_sym_xor_eq] = ACTIONS(5113),
    [anon_sym_LT_EQ_GT] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5113),
    [anon_sym_and] = ACTIONS(5113),
    [anon_sym_bitor] = ACTIONS(5113),
    [anon_sym_xor] = ACTIONS(5113),
    [anon_sym_bitand] = ACTIONS(5113),
    [anon_sym_not_eq] = ACTIONS(5113),
    [anon_sym_DASH_DASH] = ACTIONS(5115),
    [anon_sym_PLUS_PLUS] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(5113),
    [anon_sym_DOT_STAR] = ACTIONS(5115),
    [anon_sym_DASH_GT] = ACTIONS(5115),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5113),
    [anon_sym_decltype] = ACTIONS(5113),
    [anon_sym_final] = ACTIONS(5113),
    [anon_sym_override] = ACTIONS(5113),
  },
  [2445] = {
    [sym_identifier] = ACTIONS(3471),
    [aux_sym_preproc_def_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token2] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3471),
    [sym_preproc_directive] = ACTIONS(3471),
    [anon_sym_LPAREN2] = ACTIONS(3473),
    [anon_sym_TILDE] = ACTIONS(3473),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_AMP_AMP] = ACTIONS(3473),
    [anon_sym_AMP] = ACTIONS(3471),
    [anon_sym_SEMI] = ACTIONS(5894),
    [anon_sym___extension__] = ACTIONS(3471),
    [anon_sym_typedef] = ACTIONS(3471),
    [anon_sym_extern] = ACTIONS(3471),
    [anon_sym___attribute__] = ACTIONS(3471),
    [anon_sym_COLON_COLON] = ACTIONS(3473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3473),
    [anon_sym___declspec] = ACTIONS(3471),
    [anon_sym___based] = ACTIONS(3471),
    [anon_sym_signed] = ACTIONS(3471),
    [anon_sym_unsigned] = ACTIONS(3471),
    [anon_sym_long] = ACTIONS(3471),
    [anon_sym_short] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [anon_sym_static] = ACTIONS(3471),
    [anon_sym_register] = ACTIONS(3471),
    [anon_sym_inline] = ACTIONS(3471),
    [anon_sym___inline] = ACTIONS(3471),
    [anon_sym___inline__] = ACTIONS(3471),
    [anon_sym___forceinline] = ACTIONS(3471),
    [anon_sym_thread_local] = ACTIONS(3471),
    [anon_sym___thread] = ACTIONS(3471),
    [anon_sym_const] = ACTIONS(3471),
    [anon_sym_constexpr] = ACTIONS(3471),
    [anon_sym_volatile] = ACTIONS(3471),
    [anon_sym_restrict] = ACTIONS(3471),
    [anon_sym___restrict__] = ACTIONS(3471),
    [anon_sym__Atomic] = ACTIONS(3471),
    [anon_sym__Noreturn] = ACTIONS(3471),
    [anon_sym_noreturn] = ACTIONS(3471),
    [anon_sym_mutable] = ACTIONS(3471),
    [anon_sym_constinit] = ACTIONS(3471),
    [anon_sym_consteval] = ACTIONS(3471),
    [anon_sym_PROGMEM] = ACTIONS(3471),
    [aux_sym_primitive_type_token1] = ACTIONS(3471),
    [anon_sym_byte] = ACTIONS(3471),
    [anon_sym_word] = ACTIONS(3471),
    [anon_sym_enum] = ACTIONS(3471),
    [anon_sym_class] = ACTIONS(3471),
    [anon_sym_struct] = ACTIONS(3471),
    [anon_sym_union] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3471),
    [anon_sym_decltype] = ACTIONS(3471),
    [anon_sym_virtual] = ACTIONS(3471),
    [anon_sym_alignas] = ACTIONS(3471),
    [anon_sym_explicit] = ACTIONS(3471),
    [anon_sym_typename] = ACTIONS(3471),
    [anon_sym_template] = ACTIONS(3471),
    [anon_sym_operator] = ACTIONS(3471),
    [anon_sym_friend] = ACTIONS(3471),
    [anon_sym_public] = ACTIONS(3471),
    [anon_sym_private] = ACTIONS(3471),
    [anon_sym_protected] = ACTIONS(3471),
    [anon_sym_using] = ACTIONS(3471),
    [anon_sym_static_assert] = ACTIONS(3471),
  },
  [2446] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(4471),
    [sym_raw_string_literal] = STATE(3057),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5870),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_RBRACE] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4280),
    [anon_sym_COLON] = ACTIONS(5896),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_and_eq] = ACTIONS(4284),
    [anon_sym_or_eq] = ACTIONS(4284),
    [anon_sym_xor_eq] = ACTIONS(4284),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [2447] = {
    [sym_identifier] = ACTIONS(3328),
    [aux_sym_preproc_def_token1] = ACTIONS(3328),
    [aux_sym_preproc_if_token1] = ACTIONS(3328),
    [aux_sym_preproc_if_token2] = ACTIONS(3328),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3328),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3328),
    [sym_preproc_directive] = ACTIONS(3328),
    [anon_sym_LPAREN2] = ACTIONS(3330),
    [anon_sym_TILDE] = ACTIONS(3330),
    [anon_sym_STAR] = ACTIONS(3330),
    [anon_sym_AMP_AMP] = ACTIONS(3330),
    [anon_sym_AMP] = ACTIONS(3328),
    [anon_sym_SEMI] = ACTIONS(5898),
    [anon_sym___extension__] = ACTIONS(3328),
    [anon_sym_typedef] = ACTIONS(3328),
    [anon_sym_extern] = ACTIONS(3328),
    [anon_sym___attribute__] = ACTIONS(3328),
    [anon_sym_COLON_COLON] = ACTIONS(3330),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3330),
    [anon_sym___declspec] = ACTIONS(3328),
    [anon_sym___based] = ACTIONS(3328),
    [anon_sym_signed] = ACTIONS(3328),
    [anon_sym_unsigned] = ACTIONS(3328),
    [anon_sym_long] = ACTIONS(3328),
    [anon_sym_short] = ACTIONS(3328),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_static] = ACTIONS(3328),
    [anon_sym_register] = ACTIONS(3328),
    [anon_sym_inline] = ACTIONS(3328),
    [anon_sym___inline] = ACTIONS(3328),
    [anon_sym___inline__] = ACTIONS(3328),
    [anon_sym___forceinline] = ACTIONS(3328),
    [anon_sym_thread_local] = ACTIONS(3328),
    [anon_sym___thread] = ACTIONS(3328),
    [anon_sym_const] = ACTIONS(3328),
    [anon_sym_constexpr] = ACTIONS(3328),
    [anon_sym_volatile] = ACTIONS(3328),
    [anon_sym_restrict] = ACTIONS(3328),
    [anon_sym___restrict__] = ACTIONS(3328),
    [anon_sym__Atomic] = ACTIONS(3328),
    [anon_sym__Noreturn] = ACTIONS(3328),
    [anon_sym_noreturn] = ACTIONS(3328),
    [anon_sym_mutable] = ACTIONS(3328),
    [anon_sym_constinit] = ACTIONS(3328),
    [anon_sym_consteval] = ACTIONS(3328),
    [anon_sym_PROGMEM] = ACTIONS(3328),
    [aux_sym_primitive_type_token1] = ACTIONS(3328),
    [anon_sym_byte] = ACTIONS(3328),
    [anon_sym_word] = ACTIONS(3328),
    [anon_sym_enum] = ACTIONS(3328),
    [anon_sym_class] = ACTIONS(3328),
    [anon_sym_struct] = ACTIONS(3328),
    [anon_sym_union] = ACTIONS(3328),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3328),
    [anon_sym_decltype] = ACTIONS(3328),
    [anon_sym_virtual] = ACTIONS(3328),
    [anon_sym_alignas] = ACTIONS(3328),
    [anon_sym_explicit] = ACTIONS(3328),
    [anon_sym_typename] = ACTIONS(3328),
    [anon_sym_template] = ACTIONS(3328),
    [anon_sym_operator] = ACTIONS(3328),
    [anon_sym_friend] = ACTIONS(3328),
    [anon_sym_public] = ACTIONS(3328),
    [anon_sym_private] = ACTIONS(3328),
    [anon_sym_protected] = ACTIONS(3328),
    [anon_sym_using] = ACTIONS(3328),
    [anon_sym_static_assert] = ACTIONS(3328),
  },
  [2448] = {
    [sym_string_literal] = STATE(2067),
    [sym_template_argument_list] = STATE(3341),
    [sym_raw_string_literal] = STATE(2067),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(5862),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5180),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_RBRACE] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(5865),
    [anon_sym_EQ] = ACTIONS(4256),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4248),
    [anon_sym_SLASH_EQ] = ACTIONS(4248),
    [anon_sym_PERCENT_EQ] = ACTIONS(4248),
    [anon_sym_PLUS_EQ] = ACTIONS(4248),
    [anon_sym_DASH_EQ] = ACTIONS(4248),
    [anon_sym_LT_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT_GT_EQ] = ACTIONS(4248),
    [anon_sym_AMP_EQ] = ACTIONS(4248),
    [anon_sym_CARET_EQ] = ACTIONS(4248),
    [anon_sym_PIPE_EQ] = ACTIONS(4248),
    [anon_sym_and_eq] = ACTIONS(4248),
    [anon_sym_or_eq] = ACTIONS(4248),
    [anon_sym_xor_eq] = ACTIONS(4248),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(2177),
    [anon_sym_u_DQUOTE] = ACTIONS(2177),
    [anon_sym_U_DQUOTE] = ACTIONS(2177),
    [anon_sym_u8_DQUOTE] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
  },
  [2449] = {
    [sym_template_argument_list] = STATE(2036),
    [sym_identifier] = ACTIONS(5835),
    [anon_sym_LPAREN2] = ACTIONS(4272),
    [anon_sym_TILDE] = ACTIONS(4272),
    [anon_sym_STAR] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(4272),
    [anon_sym_AMP_AMP] = ACTIONS(4272),
    [anon_sym_AMP] = ACTIONS(5835),
    [anon_sym_LT] = ACTIONS(5883),
    [anon_sym___extension__] = ACTIONS(5835),
    [anon_sym_extern] = ACTIONS(5835),
    [anon_sym___attribute__] = ACTIONS(5835),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4272),
    [anon_sym___declspec] = ACTIONS(5835),
    [anon_sym___based] = ACTIONS(5835),
    [anon_sym___cdecl] = ACTIONS(5835),
    [anon_sym___clrcall] = ACTIONS(5835),
    [anon_sym___stdcall] = ACTIONS(5835),
    [anon_sym___fastcall] = ACTIONS(5835),
    [anon_sym___thiscall] = ACTIONS(5835),
    [anon_sym___vectorcall] = ACTIONS(5835),
    [anon_sym_signed] = ACTIONS(5835),
    [anon_sym_unsigned] = ACTIONS(5835),
    [anon_sym_long] = ACTIONS(5835),
    [anon_sym_short] = ACTIONS(5835),
    [anon_sym_LBRACK] = ACTIONS(5835),
    [anon_sym_static] = ACTIONS(5835),
    [anon_sym_register] = ACTIONS(5835),
    [anon_sym_inline] = ACTIONS(5835),
    [anon_sym___inline] = ACTIONS(5835),
    [anon_sym___inline__] = ACTIONS(5835),
    [anon_sym___forceinline] = ACTIONS(5835),
    [anon_sym_thread_local] = ACTIONS(5835),
    [anon_sym___thread] = ACTIONS(5835),
    [anon_sym_const] = ACTIONS(5835),
    [anon_sym_constexpr] = ACTIONS(5835),
    [anon_sym_volatile] = ACTIONS(5835),
    [anon_sym_restrict] = ACTIONS(5835),
    [anon_sym___restrict__] = ACTIONS(5835),
    [anon_sym__Atomic] = ACTIONS(5835),
    [anon_sym__Noreturn] = ACTIONS(5835),
    [anon_sym_noreturn] = ACTIONS(5835),
    [anon_sym_mutable] = ACTIONS(5835),
    [anon_sym_constinit] = ACTIONS(5835),
    [anon_sym_consteval] = ACTIONS(5835),
    [anon_sym_PROGMEM] = ACTIONS(5835),
    [aux_sym_primitive_type_token1] = ACTIONS(5835),
    [anon_sym_byte] = ACTIONS(5835),
    [anon_sym_word] = ACTIONS(5835),
    [anon_sym_enum] = ACTIONS(5835),
    [anon_sym_class] = ACTIONS(5835),
    [anon_sym_struct] = ACTIONS(5835),
    [anon_sym_union] = ACTIONS(5835),
    [anon_sym_or] = ACTIONS(5835),
    [anon_sym_and] = ACTIONS(5835),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5835),
    [anon_sym_decltype] = ACTIONS(5835),
    [anon_sym_virtual] = ACTIONS(5835),
    [anon_sym_alignas] = ACTIONS(5835),
    [anon_sym_explicit] = ACTIONS(5835),
    [anon_sym_typename] = ACTIONS(5835),
    [anon_sym_template] = ACTIONS(5835),
    [anon_sym_operator] = ACTIONS(5835),
    [anon_sym_friend] = ACTIONS(5835),
    [anon_sym_using] = ACTIONS(5835),
    [anon_sym_concept] = ACTIONS(5835),
  },
  [2450] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2450),
    [sym_identifier] = ACTIONS(5363),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5365),
    [anon_sym_COMMA] = ACTIONS(5365),
    [anon_sym_RPAREN] = ACTIONS(5365),
    [anon_sym_LPAREN2] = ACTIONS(5365),
    [anon_sym_TILDE] = ACTIONS(5365),
    [anon_sym_STAR] = ACTIONS(5365),
    [anon_sym_AMP_AMP] = ACTIONS(5365),
    [anon_sym_AMP] = ACTIONS(5363),
    [anon_sym_SEMI] = ACTIONS(5365),
    [anon_sym___extension__] = ACTIONS(5363),
    [anon_sym_extern] = ACTIONS(5363),
    [anon_sym___attribute__] = ACTIONS(5363),
    [anon_sym_COLON_COLON] = ACTIONS(5365),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5365),
    [anon_sym___declspec] = ACTIONS(5363),
    [anon_sym___based] = ACTIONS(5363),
    [anon_sym___cdecl] = ACTIONS(5363),
    [anon_sym___clrcall] = ACTIONS(5363),
    [anon_sym___stdcall] = ACTIONS(5363),
    [anon_sym___fastcall] = ACTIONS(5363),
    [anon_sym___thiscall] = ACTIONS(5363),
    [anon_sym___vectorcall] = ACTIONS(5363),
    [anon_sym_LBRACE] = ACTIONS(5365),
    [anon_sym_signed] = ACTIONS(5903),
    [anon_sym_unsigned] = ACTIONS(5903),
    [anon_sym_long] = ACTIONS(5903),
    [anon_sym_short] = ACTIONS(5903),
    [anon_sym_LBRACK] = ACTIONS(5363),
    [anon_sym_EQ] = ACTIONS(5365),
    [anon_sym_static] = ACTIONS(5363),
    [anon_sym_register] = ACTIONS(5363),
    [anon_sym_inline] = ACTIONS(5363),
    [anon_sym___inline] = ACTIONS(5363),
    [anon_sym___inline__] = ACTIONS(5363),
    [anon_sym___forceinline] = ACTIONS(5363),
    [anon_sym_thread_local] = ACTIONS(5363),
    [anon_sym___thread] = ACTIONS(5363),
    [anon_sym_const] = ACTIONS(5363),
    [anon_sym_constexpr] = ACTIONS(5363),
    [anon_sym_volatile] = ACTIONS(5363),
    [anon_sym_restrict] = ACTIONS(5363),
    [anon_sym___restrict__] = ACTIONS(5363),
    [anon_sym__Atomic] = ACTIONS(5363),
    [anon_sym__Noreturn] = ACTIONS(5363),
    [anon_sym_noreturn] = ACTIONS(5363),
    [anon_sym_mutable] = ACTIONS(5363),
    [anon_sym_constinit] = ACTIONS(5363),
    [anon_sym_consteval] = ACTIONS(5363),
    [anon_sym_PROGMEM] = ACTIONS(5363),
    [aux_sym_primitive_type_token1] = ACTIONS(5363),
    [anon_sym_byte] = ACTIONS(5363),
    [anon_sym_word] = ACTIONS(5363),
    [anon_sym_asm] = ACTIONS(5363),
    [anon_sym___asm__] = ACTIONS(5363),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5363),
    [anon_sym_decltype] = ACTIONS(5363),
    [anon_sym_final] = ACTIONS(5363),
    [anon_sym_override] = ACTIONS(5363),
    [anon_sym_virtual] = ACTIONS(5363),
    [anon_sym_alignas] = ACTIONS(5363),
    [anon_sym_template] = ACTIONS(5363),
    [anon_sym_GT2] = ACTIONS(5365),
    [anon_sym_operator] = ACTIONS(5363),
    [anon_sym_try] = ACTIONS(5363),
    [anon_sym_requires] = ACTIONS(5363),
  },
  [2451] = {
    [sym_identifier] = ACTIONS(2887),
    [aux_sym_preproc_def_token1] = ACTIONS(2887),
    [aux_sym_preproc_if_token1] = ACTIONS(2887),
    [aux_sym_preproc_if_token2] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2887),
    [sym_preproc_directive] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2889),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym___extension__] = ACTIONS(2887),
    [anon_sym_typedef] = ACTIONS(2887),
    [anon_sym_extern] = ACTIONS(2887),
    [anon_sym___attribute__] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2889),
    [anon_sym___declspec] = ACTIONS(2887),
    [anon_sym___based] = ACTIONS(2887),
    [anon_sym_signed] = ACTIONS(2887),
    [anon_sym_unsigned] = ACTIONS(2887),
    [anon_sym_long] = ACTIONS(2887),
    [anon_sym_short] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_static] = ACTIONS(2887),
    [anon_sym_register] = ACTIONS(2887),
    [anon_sym_inline] = ACTIONS(2887),
    [anon_sym___inline] = ACTIONS(2887),
    [anon_sym___inline__] = ACTIONS(2887),
    [anon_sym___forceinline] = ACTIONS(2887),
    [anon_sym_thread_local] = ACTIONS(2887),
    [anon_sym___thread] = ACTIONS(2887),
    [anon_sym_const] = ACTIONS(2887),
    [anon_sym_constexpr] = ACTIONS(2887),
    [anon_sym_volatile] = ACTIONS(2887),
    [anon_sym_restrict] = ACTIONS(2887),
    [anon_sym___restrict__] = ACTIONS(2887),
    [anon_sym__Atomic] = ACTIONS(2887),
    [anon_sym__Noreturn] = ACTIONS(2887),
    [anon_sym_noreturn] = ACTIONS(2887),
    [anon_sym_mutable] = ACTIONS(2887),
    [anon_sym_constinit] = ACTIONS(2887),
    [anon_sym_consteval] = ACTIONS(2887),
    [anon_sym_PROGMEM] = ACTIONS(2887),
    [aux_sym_primitive_type_token1] = ACTIONS(2887),
    [anon_sym_byte] = ACTIONS(2887),
    [anon_sym_word] = ACTIONS(2887),
    [anon_sym_enum] = ACTIONS(2887),
    [anon_sym_class] = ACTIONS(2887),
    [anon_sym_struct] = ACTIONS(2887),
    [anon_sym_union] = ACTIONS(2887),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2887),
    [anon_sym_decltype] = ACTIONS(2887),
    [anon_sym_virtual] = ACTIONS(2887),
    [anon_sym_alignas] = ACTIONS(2887),
    [anon_sym_explicit] = ACTIONS(2887),
    [anon_sym_typename] = ACTIONS(2887),
    [anon_sym_template] = ACTIONS(2887),
    [anon_sym_operator] = ACTIONS(2887),
    [anon_sym_friend] = ACTIONS(2887),
    [anon_sym_public] = ACTIONS(2887),
    [anon_sym_private] = ACTIONS(2887),
    [anon_sym_protected] = ACTIONS(2887),
    [anon_sym_using] = ACTIONS(2887),
    [anon_sym_static_assert] = ACTIONS(2887),
    [anon_sym_catch] = ACTIONS(2887),
  },
  [2452] = {
    [sym_identifier] = ACTIONS(3471),
    [aux_sym_preproc_def_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token1] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3471),
    [sym_preproc_directive] = ACTIONS(3471),
    [anon_sym_LPAREN2] = ACTIONS(3473),
    [anon_sym_TILDE] = ACTIONS(3473),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_AMP_AMP] = ACTIONS(3473),
    [anon_sym_AMP] = ACTIONS(3471),
    [anon_sym_SEMI] = ACTIONS(5906),
    [anon_sym___extension__] = ACTIONS(3471),
    [anon_sym_typedef] = ACTIONS(3471),
    [anon_sym_extern] = ACTIONS(3471),
    [anon_sym___attribute__] = ACTIONS(3471),
    [anon_sym_COLON_COLON] = ACTIONS(3473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3473),
    [anon_sym___declspec] = ACTIONS(3471),
    [anon_sym___based] = ACTIONS(3471),
    [anon_sym_RBRACE] = ACTIONS(3473),
    [anon_sym_signed] = ACTIONS(3471),
    [anon_sym_unsigned] = ACTIONS(3471),
    [anon_sym_long] = ACTIONS(3471),
    [anon_sym_short] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [anon_sym_static] = ACTIONS(3471),
    [anon_sym_register] = ACTIONS(3471),
    [anon_sym_inline] = ACTIONS(3471),
    [anon_sym___inline] = ACTIONS(3471),
    [anon_sym___inline__] = ACTIONS(3471),
    [anon_sym___forceinline] = ACTIONS(3471),
    [anon_sym_thread_local] = ACTIONS(3471),
    [anon_sym___thread] = ACTIONS(3471),
    [anon_sym_const] = ACTIONS(3471),
    [anon_sym_constexpr] = ACTIONS(3471),
    [anon_sym_volatile] = ACTIONS(3471),
    [anon_sym_restrict] = ACTIONS(3471),
    [anon_sym___restrict__] = ACTIONS(3471),
    [anon_sym__Atomic] = ACTIONS(3471),
    [anon_sym__Noreturn] = ACTIONS(3471),
    [anon_sym_noreturn] = ACTIONS(3471),
    [anon_sym_mutable] = ACTIONS(3471),
    [anon_sym_constinit] = ACTIONS(3471),
    [anon_sym_consteval] = ACTIONS(3471),
    [anon_sym_PROGMEM] = ACTIONS(3471),
    [aux_sym_primitive_type_token1] = ACTIONS(3471),
    [anon_sym_byte] = ACTIONS(3471),
    [anon_sym_word] = ACTIONS(3471),
    [anon_sym_enum] = ACTIONS(3471),
    [anon_sym_class] = ACTIONS(3471),
    [anon_sym_struct] = ACTIONS(3471),
    [anon_sym_union] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3471),
    [anon_sym_decltype] = ACTIONS(3471),
    [anon_sym_virtual] = ACTIONS(3471),
    [anon_sym_alignas] = ACTIONS(3471),
    [anon_sym_explicit] = ACTIONS(3471),
    [anon_sym_typename] = ACTIONS(3471),
    [anon_sym_template] = ACTIONS(3471),
    [anon_sym_operator] = ACTIONS(3471),
    [anon_sym_friend] = ACTIONS(3471),
    [anon_sym_public] = ACTIONS(3471),
    [anon_sym_private] = ACTIONS(3471),
    [anon_sym_protected] = ACTIONS(3471),
    [anon_sym_using] = ACTIONS(3471),
    [anon_sym_static_assert] = ACTIONS(3471),
  },
  [2453] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2079),
    [sym_identifier] = ACTIONS(5363),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5730),
    [anon_sym_COMMA] = ACTIONS(5730),
    [anon_sym_RPAREN] = ACTIONS(5730),
    [anon_sym_LPAREN2] = ACTIONS(5730),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_PLUS] = ACTIONS(5733),
    [anon_sym_STAR] = ACTIONS(5733),
    [anon_sym_SLASH] = ACTIONS(5733),
    [anon_sym_PERCENT] = ACTIONS(5733),
    [anon_sym_PIPE_PIPE] = ACTIONS(5730),
    [anon_sym_AMP_AMP] = ACTIONS(5730),
    [anon_sym_PIPE] = ACTIONS(5733),
    [anon_sym_CARET] = ACTIONS(5733),
    [anon_sym_AMP] = ACTIONS(5733),
    [anon_sym_EQ_EQ] = ACTIONS(5730),
    [anon_sym_BANG_EQ] = ACTIONS(5730),
    [anon_sym_GT] = ACTIONS(5733),
    [anon_sym_GT_EQ] = ACTIONS(5730),
    [anon_sym_LT_EQ] = ACTIONS(5733),
    [anon_sym_LT] = ACTIONS(5733),
    [anon_sym_LT_LT] = ACTIONS(5733),
    [anon_sym_GT_GT] = ACTIONS(5733),
    [anon_sym_SEMI] = ACTIONS(5730),
    [anon_sym___attribute__] = ACTIONS(5733),
    [anon_sym_LBRACE] = ACTIONS(5730),
    [anon_sym_RBRACE] = ACTIONS(5730),
    [anon_sym_signed] = ACTIONS(5402),
    [anon_sym_unsigned] = ACTIONS(5402),
    [anon_sym_long] = ACTIONS(5402),
    [anon_sym_short] = ACTIONS(5402),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_RBRACK] = ACTIONS(5730),
    [anon_sym_EQ] = ACTIONS(5733),
    [aux_sym_primitive_type_token1] = ACTIONS(5363),
    [anon_sym_byte] = ACTIONS(5363),
    [anon_sym_word] = ACTIONS(5363),
    [anon_sym_COLON] = ACTIONS(5730),
    [anon_sym_QMARK] = ACTIONS(5730),
    [anon_sym_STAR_EQ] = ACTIONS(5730),
    [anon_sym_SLASH_EQ] = ACTIONS(5730),
    [anon_sym_PERCENT_EQ] = ACTIONS(5730),
    [anon_sym_PLUS_EQ] = ACTIONS(5730),
    [anon_sym_DASH_EQ] = ACTIONS(5730),
    [anon_sym_LT_LT_EQ] = ACTIONS(5730),
    [anon_sym_GT_GT_EQ] = ACTIONS(5730),
    [anon_sym_AMP_EQ] = ACTIONS(5730),
    [anon_sym_CARET_EQ] = ACTIONS(5730),
    [anon_sym_PIPE_EQ] = ACTIONS(5730),
    [anon_sym_and_eq] = ACTIONS(5733),
    [anon_sym_or_eq] = ACTIONS(5733),
    [anon_sym_xor_eq] = ACTIONS(5733),
    [anon_sym_LT_EQ_GT] = ACTIONS(5730),
    [anon_sym_or] = ACTIONS(5733),
    [anon_sym_and] = ACTIONS(5733),
    [anon_sym_bitor] = ACTIONS(5733),
    [anon_sym_xor] = ACTIONS(5733),
    [anon_sym_bitand] = ACTIONS(5733),
    [anon_sym_not_eq] = ACTIONS(5733),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_DOT] = ACTIONS(5733),
    [anon_sym_DOT_STAR] = ACTIONS(5730),
    [anon_sym_DASH_GT] = ACTIONS(5730),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5733),
    [anon_sym_decltype] = ACTIONS(5733),
  },
  [2454] = {
    [sym_identifier] = ACTIONS(3332),
    [aux_sym_preproc_def_token1] = ACTIONS(3332),
    [aux_sym_preproc_if_token1] = ACTIONS(3332),
    [aux_sym_preproc_if_token2] = ACTIONS(3332),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3332),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3332),
    [sym_preproc_directive] = ACTIONS(3332),
    [anon_sym_LPAREN2] = ACTIONS(3334),
    [anon_sym_TILDE] = ACTIONS(3334),
    [anon_sym_STAR] = ACTIONS(3334),
    [anon_sym_AMP_AMP] = ACTIONS(3334),
    [anon_sym_AMP] = ACTIONS(3332),
    [anon_sym_SEMI] = ACTIONS(5908),
    [anon_sym___extension__] = ACTIONS(3332),
    [anon_sym_typedef] = ACTIONS(3332),
    [anon_sym_extern] = ACTIONS(3332),
    [anon_sym___attribute__] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(3334),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3334),
    [anon_sym___declspec] = ACTIONS(3332),
    [anon_sym___based] = ACTIONS(3332),
    [anon_sym_signed] = ACTIONS(3332),
    [anon_sym_unsigned] = ACTIONS(3332),
    [anon_sym_long] = ACTIONS(3332),
    [anon_sym_short] = ACTIONS(3332),
    [anon_sym_LBRACK] = ACTIONS(3332),
    [anon_sym_static] = ACTIONS(3332),
    [anon_sym_register] = ACTIONS(3332),
    [anon_sym_inline] = ACTIONS(3332),
    [anon_sym___inline] = ACTIONS(3332),
    [anon_sym___inline__] = ACTIONS(3332),
    [anon_sym___forceinline] = ACTIONS(3332),
    [anon_sym_thread_local] = ACTIONS(3332),
    [anon_sym___thread] = ACTIONS(3332),
    [anon_sym_const] = ACTIONS(3332),
    [anon_sym_constexpr] = ACTIONS(3332),
    [anon_sym_volatile] = ACTIONS(3332),
    [anon_sym_restrict] = ACTIONS(3332),
    [anon_sym___restrict__] = ACTIONS(3332),
    [anon_sym__Atomic] = ACTIONS(3332),
    [anon_sym__Noreturn] = ACTIONS(3332),
    [anon_sym_noreturn] = ACTIONS(3332),
    [anon_sym_mutable] = ACTIONS(3332),
    [anon_sym_constinit] = ACTIONS(3332),
    [anon_sym_consteval] = ACTIONS(3332),
    [anon_sym_PROGMEM] = ACTIONS(3332),
    [aux_sym_primitive_type_token1] = ACTIONS(3332),
    [anon_sym_byte] = ACTIONS(3332),
    [anon_sym_word] = ACTIONS(3332),
    [anon_sym_enum] = ACTIONS(3332),
    [anon_sym_class] = ACTIONS(3332),
    [anon_sym_struct] = ACTIONS(3332),
    [anon_sym_union] = ACTIONS(3332),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3332),
    [anon_sym_decltype] = ACTIONS(3332),
    [anon_sym_virtual] = ACTIONS(3332),
    [anon_sym_alignas] = ACTIONS(3332),
    [anon_sym_explicit] = ACTIONS(3332),
    [anon_sym_typename] = ACTIONS(3332),
    [anon_sym_template] = ACTIONS(3332),
    [anon_sym_operator] = ACTIONS(3332),
    [anon_sym_friend] = ACTIONS(3332),
    [anon_sym_public] = ACTIONS(3332),
    [anon_sym_private] = ACTIONS(3332),
    [anon_sym_protected] = ACTIONS(3332),
    [anon_sym_using] = ACTIONS(3332),
    [anon_sym_static_assert] = ACTIONS(3332),
  },
  [2455] = {
    [sym_identifier] = ACTIONS(5146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5148),
    [anon_sym_COMMA] = ACTIONS(5148),
    [anon_sym_RPAREN] = ACTIONS(5148),
    [aux_sym_preproc_if_token2] = ACTIONS(5148),
    [aux_sym_preproc_else_token1] = ACTIONS(5148),
    [aux_sym_preproc_elif_token1] = ACTIONS(5146),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5148),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5148),
    [anon_sym_LPAREN2] = ACTIONS(5148),
    [anon_sym_DASH] = ACTIONS(5146),
    [anon_sym_PLUS] = ACTIONS(5146),
    [anon_sym_STAR] = ACTIONS(5146),
    [anon_sym_SLASH] = ACTIONS(5146),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [anon_sym_PIPE_PIPE] = ACTIONS(5148),
    [anon_sym_AMP_AMP] = ACTIONS(5148),
    [anon_sym_PIPE] = ACTIONS(5146),
    [anon_sym_CARET] = ACTIONS(5146),
    [anon_sym_AMP] = ACTIONS(5146),
    [anon_sym_EQ_EQ] = ACTIONS(5148),
    [anon_sym_BANG_EQ] = ACTIONS(5148),
    [anon_sym_GT] = ACTIONS(5146),
    [anon_sym_GT_EQ] = ACTIONS(5148),
    [anon_sym_LT_EQ] = ACTIONS(5146),
    [anon_sym_LT] = ACTIONS(5146),
    [anon_sym_LT_LT] = ACTIONS(5146),
    [anon_sym_GT_GT] = ACTIONS(5146),
    [anon_sym_SEMI] = ACTIONS(5148),
    [anon_sym___attribute__] = ACTIONS(5146),
    [anon_sym_COLON_COLON] = ACTIONS(5148),
    [anon_sym_LBRACE] = ACTIONS(5148),
    [anon_sym_RBRACE] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5148),
    [anon_sym_RBRACK] = ACTIONS(5148),
    [anon_sym_EQ] = ACTIONS(5146),
    [anon_sym_COLON] = ACTIONS(5146),
    [anon_sym_QMARK] = ACTIONS(5148),
    [anon_sym_STAR_EQ] = ACTIONS(5148),
    [anon_sym_SLASH_EQ] = ACTIONS(5148),
    [anon_sym_PERCENT_EQ] = ACTIONS(5148),
    [anon_sym_PLUS_EQ] = ACTIONS(5148),
    [anon_sym_DASH_EQ] = ACTIONS(5148),
    [anon_sym_LT_LT_EQ] = ACTIONS(5148),
    [anon_sym_GT_GT_EQ] = ACTIONS(5148),
    [anon_sym_AMP_EQ] = ACTIONS(5148),
    [anon_sym_CARET_EQ] = ACTIONS(5148),
    [anon_sym_PIPE_EQ] = ACTIONS(5148),
    [anon_sym_and_eq] = ACTIONS(5146),
    [anon_sym_or_eq] = ACTIONS(5146),
    [anon_sym_xor_eq] = ACTIONS(5146),
    [anon_sym_LT_EQ_GT] = ACTIONS(5148),
    [anon_sym_or] = ACTIONS(5146),
    [anon_sym_and] = ACTIONS(5146),
    [anon_sym_bitor] = ACTIONS(5146),
    [anon_sym_xor] = ACTIONS(5146),
    [anon_sym_bitand] = ACTIONS(5146),
    [anon_sym_not_eq] = ACTIONS(5146),
    [anon_sym_DASH_DASH] = ACTIONS(5148),
    [anon_sym_PLUS_PLUS] = ACTIONS(5148),
    [anon_sym_DOT] = ACTIONS(5146),
    [anon_sym_DOT_STAR] = ACTIONS(5148),
    [anon_sym_DASH_GT] = ACTIONS(5148),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5146),
    [anon_sym_decltype] = ACTIONS(5146),
    [anon_sym_final] = ACTIONS(5146),
    [anon_sym_override] = ACTIONS(5146),
  },
  [2456] = {
    [sym_identifier] = ACTIONS(5117),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(5119),
    [anon_sym_RPAREN] = ACTIONS(5119),
    [aux_sym_preproc_if_token2] = ACTIONS(5119),
    [aux_sym_preproc_else_token1] = ACTIONS(5119),
    [aux_sym_preproc_elif_token1] = ACTIONS(5117),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5119),
    [anon_sym_LPAREN2] = ACTIONS(5119),
    [anon_sym_DASH] = ACTIONS(5117),
    [anon_sym_PLUS] = ACTIONS(5117),
    [anon_sym_STAR] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5117),
    [anon_sym_PERCENT] = ACTIONS(5117),
    [anon_sym_PIPE_PIPE] = ACTIONS(5119),
    [anon_sym_AMP_AMP] = ACTIONS(5119),
    [anon_sym_PIPE] = ACTIONS(5117),
    [anon_sym_CARET] = ACTIONS(5117),
    [anon_sym_AMP] = ACTIONS(5117),
    [anon_sym_EQ_EQ] = ACTIONS(5119),
    [anon_sym_BANG_EQ] = ACTIONS(5119),
    [anon_sym_GT] = ACTIONS(5117),
    [anon_sym_GT_EQ] = ACTIONS(5119),
    [anon_sym_LT_EQ] = ACTIONS(5117),
    [anon_sym_LT] = ACTIONS(5117),
    [anon_sym_LT_LT] = ACTIONS(5117),
    [anon_sym_GT_GT] = ACTIONS(5117),
    [anon_sym_SEMI] = ACTIONS(5119),
    [anon_sym___attribute__] = ACTIONS(5117),
    [anon_sym_COLON_COLON] = ACTIONS(5119),
    [anon_sym_LBRACE] = ACTIONS(5119),
    [anon_sym_RBRACE] = ACTIONS(5119),
    [anon_sym_LBRACK] = ACTIONS(5119),
    [anon_sym_RBRACK] = ACTIONS(5119),
    [anon_sym_EQ] = ACTIONS(5117),
    [anon_sym_COLON] = ACTIONS(5117),
    [anon_sym_QMARK] = ACTIONS(5119),
    [anon_sym_STAR_EQ] = ACTIONS(5119),
    [anon_sym_SLASH_EQ] = ACTIONS(5119),
    [anon_sym_PERCENT_EQ] = ACTIONS(5119),
    [anon_sym_PLUS_EQ] = ACTIONS(5119),
    [anon_sym_DASH_EQ] = ACTIONS(5119),
    [anon_sym_LT_LT_EQ] = ACTIONS(5119),
    [anon_sym_GT_GT_EQ] = ACTIONS(5119),
    [anon_sym_AMP_EQ] = ACTIONS(5119),
    [anon_sym_CARET_EQ] = ACTIONS(5119),
    [anon_sym_PIPE_EQ] = ACTIONS(5119),
    [anon_sym_and_eq] = ACTIONS(5117),
    [anon_sym_or_eq] = ACTIONS(5117),
    [anon_sym_xor_eq] = ACTIONS(5117),
    [anon_sym_LT_EQ_GT] = ACTIONS(5119),
    [anon_sym_or] = ACTIONS(5117),
    [anon_sym_and] = ACTIONS(5117),
    [anon_sym_bitor] = ACTIONS(5117),
    [anon_sym_xor] = ACTIONS(5117),
    [anon_sym_bitand] = ACTIONS(5117),
    [anon_sym_not_eq] = ACTIONS(5117),
    [anon_sym_DASH_DASH] = ACTIONS(5119),
    [anon_sym_PLUS_PLUS] = ACTIONS(5119),
    [anon_sym_DOT] = ACTIONS(5117),
    [anon_sym_DOT_STAR] = ACTIONS(5119),
    [anon_sym_DASH_GT] = ACTIONS(5119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5117),
    [anon_sym_decltype] = ACTIONS(5117),
    [anon_sym_final] = ACTIONS(5117),
    [anon_sym_override] = ACTIONS(5117),
  },
  [2457] = {
    [sym_identifier] = ACTIONS(5150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5152),
    [anon_sym_COMMA] = ACTIONS(5152),
    [anon_sym_RPAREN] = ACTIONS(5152),
    [aux_sym_preproc_if_token2] = ACTIONS(5152),
    [aux_sym_preproc_else_token1] = ACTIONS(5152),
    [aux_sym_preproc_elif_token1] = ACTIONS(5150),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5152),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5152),
    [anon_sym_LPAREN2] = ACTIONS(5152),
    [anon_sym_DASH] = ACTIONS(5150),
    [anon_sym_PLUS] = ACTIONS(5150),
    [anon_sym_STAR] = ACTIONS(5150),
    [anon_sym_SLASH] = ACTIONS(5150),
    [anon_sym_PERCENT] = ACTIONS(5150),
    [anon_sym_PIPE_PIPE] = ACTIONS(5152),
    [anon_sym_AMP_AMP] = ACTIONS(5152),
    [anon_sym_PIPE] = ACTIONS(5150),
    [anon_sym_CARET] = ACTIONS(5150),
    [anon_sym_AMP] = ACTIONS(5150),
    [anon_sym_EQ_EQ] = ACTIONS(5152),
    [anon_sym_BANG_EQ] = ACTIONS(5152),
    [anon_sym_GT] = ACTIONS(5150),
    [anon_sym_GT_EQ] = ACTIONS(5152),
    [anon_sym_LT_EQ] = ACTIONS(5150),
    [anon_sym_LT] = ACTIONS(5150),
    [anon_sym_LT_LT] = ACTIONS(5150),
    [anon_sym_GT_GT] = ACTIONS(5150),
    [anon_sym_SEMI] = ACTIONS(5152),
    [anon_sym___attribute__] = ACTIONS(5150),
    [anon_sym_COLON_COLON] = ACTIONS(5152),
    [anon_sym_LBRACE] = ACTIONS(5152),
    [anon_sym_RBRACE] = ACTIONS(5152),
    [anon_sym_LBRACK] = ACTIONS(5152),
    [anon_sym_RBRACK] = ACTIONS(5152),
    [anon_sym_EQ] = ACTIONS(5150),
    [anon_sym_COLON] = ACTIONS(5150),
    [anon_sym_QMARK] = ACTIONS(5152),
    [anon_sym_STAR_EQ] = ACTIONS(5152),
    [anon_sym_SLASH_EQ] = ACTIONS(5152),
    [anon_sym_PERCENT_EQ] = ACTIONS(5152),
    [anon_sym_PLUS_EQ] = ACTIONS(5152),
    [anon_sym_DASH_EQ] = ACTIONS(5152),
    [anon_sym_LT_LT_EQ] = ACTIONS(5152),
    [anon_sym_GT_GT_EQ] = ACTIONS(5152),
    [anon_sym_AMP_EQ] = ACTIONS(5152),
    [anon_sym_CARET_EQ] = ACTIONS(5152),
    [anon_sym_PIPE_EQ] = ACTIONS(5152),
    [anon_sym_and_eq] = ACTIONS(5150),
    [anon_sym_or_eq] = ACTIONS(5150),
    [anon_sym_xor_eq] = ACTIONS(5150),
    [anon_sym_LT_EQ_GT] = ACTIONS(5152),
    [anon_sym_or] = ACTIONS(5150),
    [anon_sym_and] = ACTIONS(5150),
    [anon_sym_bitor] = ACTIONS(5150),
    [anon_sym_xor] = ACTIONS(5150),
    [anon_sym_bitand] = ACTIONS(5150),
    [anon_sym_not_eq] = ACTIONS(5150),
    [anon_sym_DASH_DASH] = ACTIONS(5152),
    [anon_sym_PLUS_PLUS] = ACTIONS(5152),
    [anon_sym_DOT] = ACTIONS(5150),
    [anon_sym_DOT_STAR] = ACTIONS(5152),
    [anon_sym_DASH_GT] = ACTIONS(5152),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5150),
    [anon_sym_decltype] = ACTIONS(5150),
    [anon_sym_final] = ACTIONS(5150),
    [anon_sym_override] = ACTIONS(5150),
  },
  [2458] = {
    [sym_identifier] = ACTIONS(5578),
    [aux_sym_preproc_def_token1] = ACTIONS(5578),
    [aux_sym_preproc_if_token1] = ACTIONS(5578),
    [aux_sym_preproc_if_token2] = ACTIONS(5578),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5578),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5578),
    [sym_preproc_directive] = ACTIONS(5578),
    [anon_sym_LPAREN2] = ACTIONS(5580),
    [anon_sym_TILDE] = ACTIONS(5580),
    [anon_sym_STAR] = ACTIONS(5580),
    [anon_sym_AMP_AMP] = ACTIONS(5580),
    [anon_sym_AMP] = ACTIONS(5578),
    [anon_sym___extension__] = ACTIONS(5578),
    [anon_sym_typedef] = ACTIONS(5578),
    [anon_sym_extern] = ACTIONS(5578),
    [anon_sym___attribute__] = ACTIONS(5578),
    [anon_sym_COLON_COLON] = ACTIONS(5580),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5580),
    [anon_sym___declspec] = ACTIONS(5578),
    [anon_sym___based] = ACTIONS(5578),
    [anon_sym_signed] = ACTIONS(5578),
    [anon_sym_unsigned] = ACTIONS(5578),
    [anon_sym_long] = ACTIONS(5578),
    [anon_sym_short] = ACTIONS(5578),
    [anon_sym_LBRACK] = ACTIONS(5578),
    [anon_sym_static] = ACTIONS(5578),
    [anon_sym_register] = ACTIONS(5578),
    [anon_sym_inline] = ACTIONS(5578),
    [anon_sym___inline] = ACTIONS(5578),
    [anon_sym___inline__] = ACTIONS(5578),
    [anon_sym___forceinline] = ACTIONS(5578),
    [anon_sym_thread_local] = ACTIONS(5578),
    [anon_sym___thread] = ACTIONS(5578),
    [anon_sym_const] = ACTIONS(5578),
    [anon_sym_constexpr] = ACTIONS(5578),
    [anon_sym_volatile] = ACTIONS(5578),
    [anon_sym_restrict] = ACTIONS(5578),
    [anon_sym___restrict__] = ACTIONS(5578),
    [anon_sym__Atomic] = ACTIONS(5578),
    [anon_sym__Noreturn] = ACTIONS(5578),
    [anon_sym_noreturn] = ACTIONS(5578),
    [anon_sym_mutable] = ACTIONS(5578),
    [anon_sym_constinit] = ACTIONS(5578),
    [anon_sym_consteval] = ACTIONS(5578),
    [anon_sym_PROGMEM] = ACTIONS(5578),
    [aux_sym_primitive_type_token1] = ACTIONS(5578),
    [anon_sym_byte] = ACTIONS(5578),
    [anon_sym_word] = ACTIONS(5578),
    [anon_sym_enum] = ACTIONS(5578),
    [anon_sym_class] = ACTIONS(5578),
    [anon_sym_struct] = ACTIONS(5578),
    [anon_sym_union] = ACTIONS(5578),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5578),
    [anon_sym_decltype] = ACTIONS(5578),
    [anon_sym_virtual] = ACTIONS(5578),
    [anon_sym_alignas] = ACTIONS(5578),
    [anon_sym_explicit] = ACTIONS(5578),
    [anon_sym_typename] = ACTIONS(5578),
    [anon_sym_template] = ACTIONS(5578),
    [anon_sym_operator] = ACTIONS(5578),
    [anon_sym_friend] = ACTIONS(5578),
    [anon_sym_public] = ACTIONS(5578),
    [anon_sym_private] = ACTIONS(5578),
    [anon_sym_protected] = ACTIONS(5578),
    [anon_sym_using] = ACTIONS(5578),
    [anon_sym_static_assert] = ACTIONS(5578),
  },
  [2459] = {
    [sym_identifier] = ACTIONS(3162),
    [aux_sym_preproc_def_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token1] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3162),
    [sym_preproc_directive] = ACTIONS(3162),
    [anon_sym_LPAREN2] = ACTIONS(3164),
    [anon_sym_TILDE] = ACTIONS(3164),
    [anon_sym_STAR] = ACTIONS(3164),
    [anon_sym_AMP_AMP] = ACTIONS(3164),
    [anon_sym_AMP] = ACTIONS(3162),
    [anon_sym___extension__] = ACTIONS(3162),
    [anon_sym_typedef] = ACTIONS(3162),
    [anon_sym_extern] = ACTIONS(3162),
    [anon_sym___attribute__] = ACTIONS(3162),
    [anon_sym_COLON_COLON] = ACTIONS(3164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3164),
    [anon_sym___declspec] = ACTIONS(3162),
    [anon_sym___based] = ACTIONS(3162),
    [anon_sym_RBRACE] = ACTIONS(3164),
    [anon_sym_signed] = ACTIONS(3162),
    [anon_sym_unsigned] = ACTIONS(3162),
    [anon_sym_long] = ACTIONS(3162),
    [anon_sym_short] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_register] = ACTIONS(3162),
    [anon_sym_inline] = ACTIONS(3162),
    [anon_sym___inline] = ACTIONS(3162),
    [anon_sym___inline__] = ACTIONS(3162),
    [anon_sym___forceinline] = ACTIONS(3162),
    [anon_sym_thread_local] = ACTIONS(3162),
    [anon_sym___thread] = ACTIONS(3162),
    [anon_sym_const] = ACTIONS(3162),
    [anon_sym_constexpr] = ACTIONS(3162),
    [anon_sym_volatile] = ACTIONS(3162),
    [anon_sym_restrict] = ACTIONS(3162),
    [anon_sym___restrict__] = ACTIONS(3162),
    [anon_sym__Atomic] = ACTIONS(3162),
    [anon_sym__Noreturn] = ACTIONS(3162),
    [anon_sym_noreturn] = ACTIONS(3162),
    [anon_sym_mutable] = ACTIONS(3162),
    [anon_sym_constinit] = ACTIONS(3162),
    [anon_sym_consteval] = ACTIONS(3162),
    [anon_sym_PROGMEM] = ACTIONS(3162),
    [aux_sym_primitive_type_token1] = ACTIONS(3162),
    [anon_sym_byte] = ACTIONS(3162),
    [anon_sym_word] = ACTIONS(3162),
    [anon_sym_enum] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_struct] = ACTIONS(3162),
    [anon_sym_union] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3162),
    [anon_sym_decltype] = ACTIONS(3162),
    [anon_sym_virtual] = ACTIONS(3162),
    [anon_sym_alignas] = ACTIONS(3162),
    [anon_sym_explicit] = ACTIONS(3162),
    [anon_sym_typename] = ACTIONS(3162),
    [anon_sym_template] = ACTIONS(3162),
    [anon_sym_operator] = ACTIONS(3162),
    [anon_sym_friend] = ACTIONS(3162),
    [anon_sym_public] = ACTIONS(3162),
    [anon_sym_private] = ACTIONS(3162),
    [anon_sym_protected] = ACTIONS(3162),
    [anon_sym_using] = ACTIONS(3162),
    [anon_sym_static_assert] = ACTIONS(3162),
  },
  [2460] = {
    [sym_string_literal] = STATE(2490),
    [sym_raw_string_literal] = STATE(2490),
    [aux_sym_concatenated_string_repeat1] = STATE(2490),
    [sym_identifier] = ACTIONS(5910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5393),
    [anon_sym_COMMA] = ACTIONS(5393),
    [anon_sym_LPAREN2] = ACTIONS(5393),
    [anon_sym_DASH] = ACTIONS(5395),
    [anon_sym_PLUS] = ACTIONS(5395),
    [anon_sym_STAR] = ACTIONS(5395),
    [anon_sym_SLASH] = ACTIONS(5395),
    [anon_sym_PERCENT] = ACTIONS(5395),
    [anon_sym_PIPE_PIPE] = ACTIONS(5393),
    [anon_sym_AMP_AMP] = ACTIONS(5393),
    [anon_sym_PIPE] = ACTIONS(5395),
    [anon_sym_CARET] = ACTIONS(5395),
    [anon_sym_AMP] = ACTIONS(5395),
    [anon_sym_EQ_EQ] = ACTIONS(5393),
    [anon_sym_BANG_EQ] = ACTIONS(5393),
    [anon_sym_GT] = ACTIONS(5395),
    [anon_sym_GT_EQ] = ACTIONS(5393),
    [anon_sym_LT_EQ] = ACTIONS(5395),
    [anon_sym_LT] = ACTIONS(5395),
    [anon_sym_LT_LT] = ACTIONS(5395),
    [anon_sym_GT_GT] = ACTIONS(5395),
    [anon_sym_SEMI] = ACTIONS(5393),
    [anon_sym___attribute__] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(5393),
    [anon_sym_EQ] = ACTIONS(5395),
    [anon_sym_QMARK] = ACTIONS(5393),
    [anon_sym_STAR_EQ] = ACTIONS(5393),
    [anon_sym_SLASH_EQ] = ACTIONS(5393),
    [anon_sym_PERCENT_EQ] = ACTIONS(5393),
    [anon_sym_PLUS_EQ] = ACTIONS(5393),
    [anon_sym_DASH_EQ] = ACTIONS(5393),
    [anon_sym_LT_LT_EQ] = ACTIONS(5393),
    [anon_sym_GT_GT_EQ] = ACTIONS(5393),
    [anon_sym_AMP_EQ] = ACTIONS(5393),
    [anon_sym_CARET_EQ] = ACTIONS(5393),
    [anon_sym_PIPE_EQ] = ACTIONS(5393),
    [anon_sym_and_eq] = ACTIONS(5395),
    [anon_sym_or_eq] = ACTIONS(5395),
    [anon_sym_xor_eq] = ACTIONS(5395),
    [anon_sym_LT_EQ_GT] = ACTIONS(5393),
    [anon_sym_or] = ACTIONS(5395),
    [anon_sym_and] = ACTIONS(5395),
    [anon_sym_bitor] = ACTIONS(5395),
    [anon_sym_xor] = ACTIONS(5395),
    [anon_sym_bitand] = ACTIONS(5395),
    [anon_sym_not_eq] = ACTIONS(5395),
    [anon_sym_DASH_DASH] = ACTIONS(5393),
    [anon_sym_PLUS_PLUS] = ACTIONS(5393),
    [anon_sym_DOT] = ACTIONS(5395),
    [anon_sym_DOT_STAR] = ACTIONS(5393),
    [anon_sym_DASH_GT] = ACTIONS(5393),
    [anon_sym_L_DQUOTE] = ACTIONS(5912),
    [anon_sym_u_DQUOTE] = ACTIONS(5912),
    [anon_sym_U_DQUOTE] = ACTIONS(5912),
    [anon_sym_u8_DQUOTE] = ACTIONS(5912),
    [anon_sym_DQUOTE] = ACTIONS(5912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5914),
    [anon_sym_LR_DQUOTE] = ACTIONS(5914),
    [anon_sym_uR_DQUOTE] = ACTIONS(5914),
    [anon_sym_UR_DQUOTE] = ACTIONS(5914),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5914),
    [sym_literal_suffix] = ACTIONS(5395),
  },
  [2461] = {
    [sym_identifier] = ACTIONS(5550),
    [aux_sym_preproc_def_token1] = ACTIONS(5550),
    [aux_sym_preproc_if_token1] = ACTIONS(5550),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5550),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5550),
    [sym_preproc_directive] = ACTIONS(5550),
    [anon_sym_LPAREN2] = ACTIONS(5552),
    [anon_sym_TILDE] = ACTIONS(5552),
    [anon_sym_STAR] = ACTIONS(5552),
    [anon_sym_AMP_AMP] = ACTIONS(5552),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym___extension__] = ACTIONS(5550),
    [anon_sym_typedef] = ACTIONS(5550),
    [anon_sym_extern] = ACTIONS(5550),
    [anon_sym___attribute__] = ACTIONS(5550),
    [anon_sym_COLON_COLON] = ACTIONS(5552),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5552),
    [anon_sym___declspec] = ACTIONS(5550),
    [anon_sym___based] = ACTIONS(5550),
    [anon_sym_RBRACE] = ACTIONS(5552),
    [anon_sym_signed] = ACTIONS(5550),
    [anon_sym_unsigned] = ACTIONS(5550),
    [anon_sym_long] = ACTIONS(5550),
    [anon_sym_short] = ACTIONS(5550),
    [anon_sym_LBRACK] = ACTIONS(5550),
    [anon_sym_static] = ACTIONS(5550),
    [anon_sym_register] = ACTIONS(5550),
    [anon_sym_inline] = ACTIONS(5550),
    [anon_sym___inline] = ACTIONS(5550),
    [anon_sym___inline__] = ACTIONS(5550),
    [anon_sym___forceinline] = ACTIONS(5550),
    [anon_sym_thread_local] = ACTIONS(5550),
    [anon_sym___thread] = ACTIONS(5550),
    [anon_sym_const] = ACTIONS(5550),
    [anon_sym_constexpr] = ACTIONS(5550),
    [anon_sym_volatile] = ACTIONS(5550),
    [anon_sym_restrict] = ACTIONS(5550),
    [anon_sym___restrict__] = ACTIONS(5550),
    [anon_sym__Atomic] = ACTIONS(5550),
    [anon_sym__Noreturn] = ACTIONS(5550),
    [anon_sym_noreturn] = ACTIONS(5550),
    [anon_sym_mutable] = ACTIONS(5550),
    [anon_sym_constinit] = ACTIONS(5550),
    [anon_sym_consteval] = ACTIONS(5550),
    [anon_sym_PROGMEM] = ACTIONS(5550),
    [aux_sym_primitive_type_token1] = ACTIONS(5550),
    [anon_sym_byte] = ACTIONS(5550),
    [anon_sym_word] = ACTIONS(5550),
    [anon_sym_enum] = ACTIONS(5550),
    [anon_sym_class] = ACTIONS(5550),
    [anon_sym_struct] = ACTIONS(5550),
    [anon_sym_union] = ACTIONS(5550),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5550),
    [anon_sym_decltype] = ACTIONS(5550),
    [anon_sym_virtual] = ACTIONS(5550),
    [anon_sym_alignas] = ACTIONS(5550),
    [anon_sym_explicit] = ACTIONS(5550),
    [anon_sym_typename] = ACTIONS(5550),
    [anon_sym_template] = ACTIONS(5550),
    [anon_sym_operator] = ACTIONS(5550),
    [anon_sym_friend] = ACTIONS(5550),
    [anon_sym_public] = ACTIONS(5550),
    [anon_sym_private] = ACTIONS(5550),
    [anon_sym_protected] = ACTIONS(5550),
    [anon_sym_using] = ACTIONS(5550),
    [anon_sym_static_assert] = ACTIONS(5550),
  },
  [2462] = {
    [sym_identifier] = ACTIONS(3178),
    [aux_sym_preproc_def_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3178),
    [sym_preproc_directive] = ACTIONS(3178),
    [anon_sym_LPAREN2] = ACTIONS(3180),
    [anon_sym_TILDE] = ACTIONS(3180),
    [anon_sym_STAR] = ACTIONS(3180),
    [anon_sym_AMP_AMP] = ACTIONS(3180),
    [anon_sym_AMP] = ACTIONS(3178),
    [anon_sym___extension__] = ACTIONS(3178),
    [anon_sym_typedef] = ACTIONS(3178),
    [anon_sym_extern] = ACTIONS(3178),
    [anon_sym___attribute__] = ACTIONS(3178),
    [anon_sym_COLON_COLON] = ACTIONS(3180),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3180),
    [anon_sym___declspec] = ACTIONS(3178),
    [anon_sym___based] = ACTIONS(3178),
    [anon_sym_signed] = ACTIONS(3178),
    [anon_sym_unsigned] = ACTIONS(3178),
    [anon_sym_long] = ACTIONS(3178),
    [anon_sym_short] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_static] = ACTIONS(3178),
    [anon_sym_register] = ACTIONS(3178),
    [anon_sym_inline] = ACTIONS(3178),
    [anon_sym___inline] = ACTIONS(3178),
    [anon_sym___inline__] = ACTIONS(3178),
    [anon_sym___forceinline] = ACTIONS(3178),
    [anon_sym_thread_local] = ACTIONS(3178),
    [anon_sym___thread] = ACTIONS(3178),
    [anon_sym_const] = ACTIONS(3178),
    [anon_sym_constexpr] = ACTIONS(3178),
    [anon_sym_volatile] = ACTIONS(3178),
    [anon_sym_restrict] = ACTIONS(3178),
    [anon_sym___restrict__] = ACTIONS(3178),
    [anon_sym__Atomic] = ACTIONS(3178),
    [anon_sym__Noreturn] = ACTIONS(3178),
    [anon_sym_noreturn] = ACTIONS(3178),
    [anon_sym_mutable] = ACTIONS(3178),
    [anon_sym_constinit] = ACTIONS(3178),
    [anon_sym_consteval] = ACTIONS(3178),
    [anon_sym_PROGMEM] = ACTIONS(3178),
    [aux_sym_primitive_type_token1] = ACTIONS(3178),
    [anon_sym_byte] = ACTIONS(3178),
    [anon_sym_word] = ACTIONS(3178),
    [anon_sym_enum] = ACTIONS(3178),
    [anon_sym_class] = ACTIONS(3178),
    [anon_sym_struct] = ACTIONS(3178),
    [anon_sym_union] = ACTIONS(3178),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3178),
    [anon_sym_decltype] = ACTIONS(3178),
    [anon_sym_virtual] = ACTIONS(3178),
    [anon_sym_alignas] = ACTIONS(3178),
    [anon_sym_explicit] = ACTIONS(3178),
    [anon_sym_typename] = ACTIONS(3178),
    [anon_sym_template] = ACTIONS(3178),
    [anon_sym_operator] = ACTIONS(3178),
    [anon_sym_friend] = ACTIONS(3178),
    [anon_sym_public] = ACTIONS(3178),
    [anon_sym_private] = ACTIONS(3178),
    [anon_sym_protected] = ACTIONS(3178),
    [anon_sym_using] = ACTIONS(3178),
    [anon_sym_static_assert] = ACTIONS(3178),
  },
  [2463] = {
    [sym_identifier] = ACTIONS(5586),
    [aux_sym_preproc_def_token1] = ACTIONS(5586),
    [aux_sym_preproc_if_token1] = ACTIONS(5586),
    [aux_sym_preproc_if_token2] = ACTIONS(5586),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5586),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5586),
    [sym_preproc_directive] = ACTIONS(5586),
    [anon_sym_LPAREN2] = ACTIONS(5588),
    [anon_sym_TILDE] = ACTIONS(5588),
    [anon_sym_STAR] = ACTIONS(5588),
    [anon_sym_AMP_AMP] = ACTIONS(5588),
    [anon_sym_AMP] = ACTIONS(5586),
    [anon_sym___extension__] = ACTIONS(5586),
    [anon_sym_typedef] = ACTIONS(5586),
    [anon_sym_extern] = ACTIONS(5586),
    [anon_sym___attribute__] = ACTIONS(5586),
    [anon_sym_COLON_COLON] = ACTIONS(5588),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5588),
    [anon_sym___declspec] = ACTIONS(5586),
    [anon_sym___based] = ACTIONS(5586),
    [anon_sym_signed] = ACTIONS(5586),
    [anon_sym_unsigned] = ACTIONS(5586),
    [anon_sym_long] = ACTIONS(5586),
    [anon_sym_short] = ACTIONS(5586),
    [anon_sym_LBRACK] = ACTIONS(5586),
    [anon_sym_static] = ACTIONS(5586),
    [anon_sym_register] = ACTIONS(5586),
    [anon_sym_inline] = ACTIONS(5586),
    [anon_sym___inline] = ACTIONS(5586),
    [anon_sym___inline__] = ACTIONS(5586),
    [anon_sym___forceinline] = ACTIONS(5586),
    [anon_sym_thread_local] = ACTIONS(5586),
    [anon_sym___thread] = ACTIONS(5586),
    [anon_sym_const] = ACTIONS(5586),
    [anon_sym_constexpr] = ACTIONS(5586),
    [anon_sym_volatile] = ACTIONS(5586),
    [anon_sym_restrict] = ACTIONS(5586),
    [anon_sym___restrict__] = ACTIONS(5586),
    [anon_sym__Atomic] = ACTIONS(5586),
    [anon_sym__Noreturn] = ACTIONS(5586),
    [anon_sym_noreturn] = ACTIONS(5586),
    [anon_sym_mutable] = ACTIONS(5586),
    [anon_sym_constinit] = ACTIONS(5586),
    [anon_sym_consteval] = ACTIONS(5586),
    [anon_sym_PROGMEM] = ACTIONS(5586),
    [aux_sym_primitive_type_token1] = ACTIONS(5586),
    [anon_sym_byte] = ACTIONS(5586),
    [anon_sym_word] = ACTIONS(5586),
    [anon_sym_enum] = ACTIONS(5586),
    [anon_sym_class] = ACTIONS(5586),
    [anon_sym_struct] = ACTIONS(5586),
    [anon_sym_union] = ACTIONS(5586),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5586),
    [anon_sym_decltype] = ACTIONS(5586),
    [anon_sym_virtual] = ACTIONS(5586),
    [anon_sym_alignas] = ACTIONS(5586),
    [anon_sym_explicit] = ACTIONS(5586),
    [anon_sym_typename] = ACTIONS(5586),
    [anon_sym_template] = ACTIONS(5586),
    [anon_sym_operator] = ACTIONS(5586),
    [anon_sym_friend] = ACTIONS(5586),
    [anon_sym_public] = ACTIONS(5586),
    [anon_sym_private] = ACTIONS(5586),
    [anon_sym_protected] = ACTIONS(5586),
    [anon_sym_using] = ACTIONS(5586),
    [anon_sym_static_assert] = ACTIONS(5586),
  },
  [2464] = {
    [sym_identifier] = ACTIONS(5554),
    [aux_sym_preproc_def_token1] = ACTIONS(5554),
    [aux_sym_preproc_if_token1] = ACTIONS(5554),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5554),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5554),
    [sym_preproc_directive] = ACTIONS(5554),
    [anon_sym_LPAREN2] = ACTIONS(5556),
    [anon_sym_TILDE] = ACTIONS(5556),
    [anon_sym_STAR] = ACTIONS(5556),
    [anon_sym_AMP_AMP] = ACTIONS(5556),
    [anon_sym_AMP] = ACTIONS(5554),
    [anon_sym___extension__] = ACTIONS(5554),
    [anon_sym_typedef] = ACTIONS(5554),
    [anon_sym_extern] = ACTIONS(5554),
    [anon_sym___attribute__] = ACTIONS(5554),
    [anon_sym_COLON_COLON] = ACTIONS(5556),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5556),
    [anon_sym___declspec] = ACTIONS(5554),
    [anon_sym___based] = ACTIONS(5554),
    [anon_sym_RBRACE] = ACTIONS(5556),
    [anon_sym_signed] = ACTIONS(5554),
    [anon_sym_unsigned] = ACTIONS(5554),
    [anon_sym_long] = ACTIONS(5554),
    [anon_sym_short] = ACTIONS(5554),
    [anon_sym_LBRACK] = ACTIONS(5554),
    [anon_sym_static] = ACTIONS(5554),
    [anon_sym_register] = ACTIONS(5554),
    [anon_sym_inline] = ACTIONS(5554),
    [anon_sym___inline] = ACTIONS(5554),
    [anon_sym___inline__] = ACTIONS(5554),
    [anon_sym___forceinline] = ACTIONS(5554),
    [anon_sym_thread_local] = ACTIONS(5554),
    [anon_sym___thread] = ACTIONS(5554),
    [anon_sym_const] = ACTIONS(5554),
    [anon_sym_constexpr] = ACTIONS(5554),
    [anon_sym_volatile] = ACTIONS(5554),
    [anon_sym_restrict] = ACTIONS(5554),
    [anon_sym___restrict__] = ACTIONS(5554),
    [anon_sym__Atomic] = ACTIONS(5554),
    [anon_sym__Noreturn] = ACTIONS(5554),
    [anon_sym_noreturn] = ACTIONS(5554),
    [anon_sym_mutable] = ACTIONS(5554),
    [anon_sym_constinit] = ACTIONS(5554),
    [anon_sym_consteval] = ACTIONS(5554),
    [anon_sym_PROGMEM] = ACTIONS(5554),
    [aux_sym_primitive_type_token1] = ACTIONS(5554),
    [anon_sym_byte] = ACTIONS(5554),
    [anon_sym_word] = ACTIONS(5554),
    [anon_sym_enum] = ACTIONS(5554),
    [anon_sym_class] = ACTIONS(5554),
    [anon_sym_struct] = ACTIONS(5554),
    [anon_sym_union] = ACTIONS(5554),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5554),
    [anon_sym_decltype] = ACTIONS(5554),
    [anon_sym_virtual] = ACTIONS(5554),
    [anon_sym_alignas] = ACTIONS(5554),
    [anon_sym_explicit] = ACTIONS(5554),
    [anon_sym_typename] = ACTIONS(5554),
    [anon_sym_template] = ACTIONS(5554),
    [anon_sym_operator] = ACTIONS(5554),
    [anon_sym_friend] = ACTIONS(5554),
    [anon_sym_public] = ACTIONS(5554),
    [anon_sym_private] = ACTIONS(5554),
    [anon_sym_protected] = ACTIONS(5554),
    [anon_sym_using] = ACTIONS(5554),
    [anon_sym_static_assert] = ACTIONS(5554),
  },
  [2465] = {
    [sym_identifier] = ACTIONS(3346),
    [aux_sym_preproc_def_token1] = ACTIONS(3346),
    [aux_sym_preproc_if_token1] = ACTIONS(3346),
    [aux_sym_preproc_if_token2] = ACTIONS(3346),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3346),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3346),
    [sym_preproc_directive] = ACTIONS(3346),
    [anon_sym_LPAREN2] = ACTIONS(3348),
    [anon_sym_TILDE] = ACTIONS(3348),
    [anon_sym_STAR] = ACTIONS(3348),
    [anon_sym_AMP_AMP] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym___extension__] = ACTIONS(3346),
    [anon_sym_typedef] = ACTIONS(3346),
    [anon_sym_extern] = ACTIONS(3346),
    [anon_sym___attribute__] = ACTIONS(3346),
    [anon_sym_COLON_COLON] = ACTIONS(3348),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3348),
    [anon_sym___declspec] = ACTIONS(3346),
    [anon_sym___based] = ACTIONS(3346),
    [anon_sym_signed] = ACTIONS(3346),
    [anon_sym_unsigned] = ACTIONS(3346),
    [anon_sym_long] = ACTIONS(3346),
    [anon_sym_short] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3346),
    [anon_sym_register] = ACTIONS(3346),
    [anon_sym_inline] = ACTIONS(3346),
    [anon_sym___inline] = ACTIONS(3346),
    [anon_sym___inline__] = ACTIONS(3346),
    [anon_sym___forceinline] = ACTIONS(3346),
    [anon_sym_thread_local] = ACTIONS(3346),
    [anon_sym___thread] = ACTIONS(3346),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_constexpr] = ACTIONS(3346),
    [anon_sym_volatile] = ACTIONS(3346),
    [anon_sym_restrict] = ACTIONS(3346),
    [anon_sym___restrict__] = ACTIONS(3346),
    [anon_sym__Atomic] = ACTIONS(3346),
    [anon_sym__Noreturn] = ACTIONS(3346),
    [anon_sym_noreturn] = ACTIONS(3346),
    [anon_sym_mutable] = ACTIONS(3346),
    [anon_sym_constinit] = ACTIONS(3346),
    [anon_sym_consteval] = ACTIONS(3346),
    [anon_sym_PROGMEM] = ACTIONS(3346),
    [aux_sym_primitive_type_token1] = ACTIONS(3346),
    [anon_sym_byte] = ACTIONS(3346),
    [anon_sym_word] = ACTIONS(3346),
    [anon_sym_enum] = ACTIONS(3346),
    [anon_sym_class] = ACTIONS(3346),
    [anon_sym_struct] = ACTIONS(3346),
    [anon_sym_union] = ACTIONS(3346),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3346),
    [anon_sym_decltype] = ACTIONS(3346),
    [anon_sym_virtual] = ACTIONS(3346),
    [anon_sym_alignas] = ACTIONS(3346),
    [anon_sym_explicit] = ACTIONS(3346),
    [anon_sym_typename] = ACTIONS(3346),
    [anon_sym_template] = ACTIONS(3346),
    [anon_sym_operator] = ACTIONS(3346),
    [anon_sym_friend] = ACTIONS(3346),
    [anon_sym_public] = ACTIONS(3346),
    [anon_sym_private] = ACTIONS(3346),
    [anon_sym_protected] = ACTIONS(3346),
    [anon_sym_using] = ACTIONS(3346),
    [anon_sym_static_assert] = ACTIONS(3346),
  },
  [2466] = {
    [sym_identifier] = ACTIONS(3336),
    [aux_sym_preproc_def_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token2] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3336),
    [sym_preproc_directive] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym___extension__] = ACTIONS(3336),
    [anon_sym_typedef] = ACTIONS(3336),
    [anon_sym_extern] = ACTIONS(3336),
    [anon_sym___attribute__] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3338),
    [anon_sym___declspec] = ACTIONS(3336),
    [anon_sym___based] = ACTIONS(3336),
    [anon_sym_signed] = ACTIONS(3336),
    [anon_sym_unsigned] = ACTIONS(3336),
    [anon_sym_long] = ACTIONS(3336),
    [anon_sym_short] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_static] = ACTIONS(3336),
    [anon_sym_register] = ACTIONS(3336),
    [anon_sym_inline] = ACTIONS(3336),
    [anon_sym___inline] = ACTIONS(3336),
    [anon_sym___inline__] = ACTIONS(3336),
    [anon_sym___forceinline] = ACTIONS(3336),
    [anon_sym_thread_local] = ACTIONS(3336),
    [anon_sym___thread] = ACTIONS(3336),
    [anon_sym_const] = ACTIONS(3336),
    [anon_sym_constexpr] = ACTIONS(3336),
    [anon_sym_volatile] = ACTIONS(3336),
    [anon_sym_restrict] = ACTIONS(3336),
    [anon_sym___restrict__] = ACTIONS(3336),
    [anon_sym__Atomic] = ACTIONS(3336),
    [anon_sym__Noreturn] = ACTIONS(3336),
    [anon_sym_noreturn] = ACTIONS(3336),
    [anon_sym_mutable] = ACTIONS(3336),
    [anon_sym_constinit] = ACTIONS(3336),
    [anon_sym_consteval] = ACTIONS(3336),
    [anon_sym_PROGMEM] = ACTIONS(3336),
    [aux_sym_primitive_type_token1] = ACTIONS(3336),
    [anon_sym_byte] = ACTIONS(3336),
    [anon_sym_word] = ACTIONS(3336),
    [anon_sym_enum] = ACTIONS(3336),
    [anon_sym_class] = ACTIONS(3336),
    [anon_sym_struct] = ACTIONS(3336),
    [anon_sym_union] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3336),
    [anon_sym_decltype] = ACTIONS(3336),
    [anon_sym_virtual] = ACTIONS(3336),
    [anon_sym_alignas] = ACTIONS(3336),
    [anon_sym_explicit] = ACTIONS(3336),
    [anon_sym_typename] = ACTIONS(3336),
    [anon_sym_template] = ACTIONS(3336),
    [anon_sym_operator] = ACTIONS(3336),
    [anon_sym_friend] = ACTIONS(3336),
    [anon_sym_public] = ACTIONS(3336),
    [anon_sym_private] = ACTIONS(3336),
    [anon_sym_protected] = ACTIONS(3336),
    [anon_sym_using] = ACTIONS(3336),
    [anon_sym_static_assert] = ACTIONS(3336),
  },
  [2467] = {
    [sym_identifier] = ACTIONS(3336),
    [aux_sym_preproc_def_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token2] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3336),
    [sym_preproc_directive] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym___extension__] = ACTIONS(3336),
    [anon_sym_typedef] = ACTIONS(3336),
    [anon_sym_extern] = ACTIONS(3336),
    [anon_sym___attribute__] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3338),
    [anon_sym___declspec] = ACTIONS(3336),
    [anon_sym___based] = ACTIONS(3336),
    [anon_sym_signed] = ACTIONS(3336),
    [anon_sym_unsigned] = ACTIONS(3336),
    [anon_sym_long] = ACTIONS(3336),
    [anon_sym_short] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_static] = ACTIONS(3336),
    [anon_sym_register] = ACTIONS(3336),
    [anon_sym_inline] = ACTIONS(3336),
    [anon_sym___inline] = ACTIONS(3336),
    [anon_sym___inline__] = ACTIONS(3336),
    [anon_sym___forceinline] = ACTIONS(3336),
    [anon_sym_thread_local] = ACTIONS(3336),
    [anon_sym___thread] = ACTIONS(3336),
    [anon_sym_const] = ACTIONS(3336),
    [anon_sym_constexpr] = ACTIONS(3336),
    [anon_sym_volatile] = ACTIONS(3336),
    [anon_sym_restrict] = ACTIONS(3336),
    [anon_sym___restrict__] = ACTIONS(3336),
    [anon_sym__Atomic] = ACTIONS(3336),
    [anon_sym__Noreturn] = ACTIONS(3336),
    [anon_sym_noreturn] = ACTIONS(3336),
    [anon_sym_mutable] = ACTIONS(3336),
    [anon_sym_constinit] = ACTIONS(3336),
    [anon_sym_consteval] = ACTIONS(3336),
    [anon_sym_PROGMEM] = ACTIONS(3336),
    [aux_sym_primitive_type_token1] = ACTIONS(3336),
    [anon_sym_byte] = ACTIONS(3336),
    [anon_sym_word] = ACTIONS(3336),
    [anon_sym_enum] = ACTIONS(3336),
    [anon_sym_class] = ACTIONS(3336),
    [anon_sym_struct] = ACTIONS(3336),
    [anon_sym_union] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3336),
    [anon_sym_decltype] = ACTIONS(3336),
    [anon_sym_virtual] = ACTIONS(3336),
    [anon_sym_alignas] = ACTIONS(3336),
    [anon_sym_explicit] = ACTIONS(3336),
    [anon_sym_typename] = ACTIONS(3336),
    [anon_sym_template] = ACTIONS(3336),
    [anon_sym_operator] = ACTIONS(3336),
    [anon_sym_friend] = ACTIONS(3336),
    [anon_sym_public] = ACTIONS(3336),
    [anon_sym_private] = ACTIONS(3336),
    [anon_sym_protected] = ACTIONS(3336),
    [anon_sym_using] = ACTIONS(3336),
    [anon_sym_static_assert] = ACTIONS(3336),
  },
  [2468] = {
    [sym_identifier] = ACTIONS(4031),
    [aux_sym_preproc_def_token1] = ACTIONS(4031),
    [aux_sym_preproc_if_token1] = ACTIONS(4031),
    [aux_sym_preproc_if_token2] = ACTIONS(4031),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4031),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4031),
    [sym_preproc_directive] = ACTIONS(4031),
    [anon_sym_LPAREN2] = ACTIONS(4029),
    [anon_sym_TILDE] = ACTIONS(4029),
    [anon_sym_STAR] = ACTIONS(4029),
    [anon_sym_AMP_AMP] = ACTIONS(4029),
    [anon_sym_AMP] = ACTIONS(4031),
    [anon_sym___extension__] = ACTIONS(4031),
    [anon_sym_typedef] = ACTIONS(4031),
    [anon_sym_extern] = ACTIONS(4031),
    [anon_sym___attribute__] = ACTIONS(4031),
    [anon_sym_COLON_COLON] = ACTIONS(4029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4029),
    [anon_sym___declspec] = ACTIONS(4031),
    [anon_sym___based] = ACTIONS(4031),
    [anon_sym_signed] = ACTIONS(4031),
    [anon_sym_unsigned] = ACTIONS(4031),
    [anon_sym_long] = ACTIONS(4031),
    [anon_sym_short] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4031),
    [anon_sym_static] = ACTIONS(4031),
    [anon_sym_register] = ACTIONS(4031),
    [anon_sym_inline] = ACTIONS(4031),
    [anon_sym___inline] = ACTIONS(4031),
    [anon_sym___inline__] = ACTIONS(4031),
    [anon_sym___forceinline] = ACTIONS(4031),
    [anon_sym_thread_local] = ACTIONS(4031),
    [anon_sym___thread] = ACTIONS(4031),
    [anon_sym_const] = ACTIONS(4031),
    [anon_sym_constexpr] = ACTIONS(4031),
    [anon_sym_volatile] = ACTIONS(4031),
    [anon_sym_restrict] = ACTIONS(4031),
    [anon_sym___restrict__] = ACTIONS(4031),
    [anon_sym__Atomic] = ACTIONS(4031),
    [anon_sym__Noreturn] = ACTIONS(4031),
    [anon_sym_noreturn] = ACTIONS(4031),
    [anon_sym_mutable] = ACTIONS(4031),
    [anon_sym_constinit] = ACTIONS(4031),
    [anon_sym_consteval] = ACTIONS(4031),
    [anon_sym_PROGMEM] = ACTIONS(4031),
    [aux_sym_primitive_type_token1] = ACTIONS(4031),
    [anon_sym_byte] = ACTIONS(4031),
    [anon_sym_word] = ACTIONS(4031),
    [anon_sym_enum] = ACTIONS(4031),
    [anon_sym_class] = ACTIONS(4031),
    [anon_sym_struct] = ACTIONS(4031),
    [anon_sym_union] = ACTIONS(4031),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4031),
    [anon_sym_decltype] = ACTIONS(4031),
    [anon_sym_virtual] = ACTIONS(4031),
    [anon_sym_alignas] = ACTIONS(4031),
    [anon_sym_explicit] = ACTIONS(4031),
    [anon_sym_typename] = ACTIONS(4031),
    [anon_sym_template] = ACTIONS(4031),
    [anon_sym_operator] = ACTIONS(4031),
    [anon_sym_friend] = ACTIONS(4031),
    [anon_sym_public] = ACTIONS(4031),
    [anon_sym_private] = ACTIONS(4031),
    [anon_sym_protected] = ACTIONS(4031),
    [anon_sym_using] = ACTIONS(4031),
    [anon_sym_static_assert] = ACTIONS(4031),
  },
  [2469] = {
    [sym_identifier] = ACTIONS(5507),
    [aux_sym_preproc_def_token1] = ACTIONS(5507),
    [aux_sym_preproc_if_token1] = ACTIONS(5507),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5507),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5507),
    [sym_preproc_directive] = ACTIONS(5507),
    [anon_sym_LPAREN2] = ACTIONS(5509),
    [anon_sym_TILDE] = ACTIONS(5509),
    [anon_sym_STAR] = ACTIONS(5509),
    [anon_sym_AMP_AMP] = ACTIONS(5509),
    [anon_sym_AMP] = ACTIONS(5507),
    [anon_sym___extension__] = ACTIONS(5507),
    [anon_sym_typedef] = ACTIONS(5507),
    [anon_sym_extern] = ACTIONS(5507),
    [anon_sym___attribute__] = ACTIONS(5507),
    [anon_sym_COLON_COLON] = ACTIONS(5509),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5509),
    [anon_sym___declspec] = ACTIONS(5507),
    [anon_sym___based] = ACTIONS(5507),
    [anon_sym_RBRACE] = ACTIONS(5509),
    [anon_sym_signed] = ACTIONS(5507),
    [anon_sym_unsigned] = ACTIONS(5507),
    [anon_sym_long] = ACTIONS(5507),
    [anon_sym_short] = ACTIONS(5507),
    [anon_sym_LBRACK] = ACTIONS(5507),
    [anon_sym_static] = ACTIONS(5507),
    [anon_sym_register] = ACTIONS(5507),
    [anon_sym_inline] = ACTIONS(5507),
    [anon_sym___inline] = ACTIONS(5507),
    [anon_sym___inline__] = ACTIONS(5507),
    [anon_sym___forceinline] = ACTIONS(5507),
    [anon_sym_thread_local] = ACTIONS(5507),
    [anon_sym___thread] = ACTIONS(5507),
    [anon_sym_const] = ACTIONS(5507),
    [anon_sym_constexpr] = ACTIONS(5507),
    [anon_sym_volatile] = ACTIONS(5507),
    [anon_sym_restrict] = ACTIONS(5507),
    [anon_sym___restrict__] = ACTIONS(5507),
    [anon_sym__Atomic] = ACTIONS(5507),
    [anon_sym__Noreturn] = ACTIONS(5507),
    [anon_sym_noreturn] = ACTIONS(5507),
    [anon_sym_mutable] = ACTIONS(5507),
    [anon_sym_constinit] = ACTIONS(5507),
    [anon_sym_consteval] = ACTIONS(5507),
    [anon_sym_PROGMEM] = ACTIONS(5507),
    [aux_sym_primitive_type_token1] = ACTIONS(5507),
    [anon_sym_byte] = ACTIONS(5507),
    [anon_sym_word] = ACTIONS(5507),
    [anon_sym_enum] = ACTIONS(5507),
    [anon_sym_class] = ACTIONS(5507),
    [anon_sym_struct] = ACTIONS(5507),
    [anon_sym_union] = ACTIONS(5507),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5507),
    [anon_sym_decltype] = ACTIONS(5507),
    [anon_sym_virtual] = ACTIONS(5507),
    [anon_sym_alignas] = ACTIONS(5507),
    [anon_sym_explicit] = ACTIONS(5507),
    [anon_sym_typename] = ACTIONS(5507),
    [anon_sym_template] = ACTIONS(5507),
    [anon_sym_operator] = ACTIONS(5507),
    [anon_sym_friend] = ACTIONS(5507),
    [anon_sym_public] = ACTIONS(5507),
    [anon_sym_private] = ACTIONS(5507),
    [anon_sym_protected] = ACTIONS(5507),
    [anon_sym_using] = ACTIONS(5507),
    [anon_sym_static_assert] = ACTIONS(5507),
  },
  [2470] = {
    [sym_identifier] = ACTIONS(5558),
    [aux_sym_preproc_def_token1] = ACTIONS(5558),
    [aux_sym_preproc_if_token1] = ACTIONS(5558),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5558),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5558),
    [sym_preproc_directive] = ACTIONS(5558),
    [anon_sym_LPAREN2] = ACTIONS(5560),
    [anon_sym_TILDE] = ACTIONS(5560),
    [anon_sym_STAR] = ACTIONS(5560),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_AMP] = ACTIONS(5558),
    [anon_sym___extension__] = ACTIONS(5558),
    [anon_sym_typedef] = ACTIONS(5558),
    [anon_sym_extern] = ACTIONS(5558),
    [anon_sym___attribute__] = ACTIONS(5558),
    [anon_sym_COLON_COLON] = ACTIONS(5560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5560),
    [anon_sym___declspec] = ACTIONS(5558),
    [anon_sym___based] = ACTIONS(5558),
    [anon_sym_RBRACE] = ACTIONS(5560),
    [anon_sym_signed] = ACTIONS(5558),
    [anon_sym_unsigned] = ACTIONS(5558),
    [anon_sym_long] = ACTIONS(5558),
    [anon_sym_short] = ACTIONS(5558),
    [anon_sym_LBRACK] = ACTIONS(5558),
    [anon_sym_static] = ACTIONS(5558),
    [anon_sym_register] = ACTIONS(5558),
    [anon_sym_inline] = ACTIONS(5558),
    [anon_sym___inline] = ACTIONS(5558),
    [anon_sym___inline__] = ACTIONS(5558),
    [anon_sym___forceinline] = ACTIONS(5558),
    [anon_sym_thread_local] = ACTIONS(5558),
    [anon_sym___thread] = ACTIONS(5558),
    [anon_sym_const] = ACTIONS(5558),
    [anon_sym_constexpr] = ACTIONS(5558),
    [anon_sym_volatile] = ACTIONS(5558),
    [anon_sym_restrict] = ACTIONS(5558),
    [anon_sym___restrict__] = ACTIONS(5558),
    [anon_sym__Atomic] = ACTIONS(5558),
    [anon_sym__Noreturn] = ACTIONS(5558),
    [anon_sym_noreturn] = ACTIONS(5558),
    [anon_sym_mutable] = ACTIONS(5558),
    [anon_sym_constinit] = ACTIONS(5558),
    [anon_sym_consteval] = ACTIONS(5558),
    [anon_sym_PROGMEM] = ACTIONS(5558),
    [aux_sym_primitive_type_token1] = ACTIONS(5558),
    [anon_sym_byte] = ACTIONS(5558),
    [anon_sym_word] = ACTIONS(5558),
    [anon_sym_enum] = ACTIONS(5558),
    [anon_sym_class] = ACTIONS(5558),
    [anon_sym_struct] = ACTIONS(5558),
    [anon_sym_union] = ACTIONS(5558),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5558),
    [anon_sym_decltype] = ACTIONS(5558),
    [anon_sym_virtual] = ACTIONS(5558),
    [anon_sym_alignas] = ACTIONS(5558),
    [anon_sym_explicit] = ACTIONS(5558),
    [anon_sym_typename] = ACTIONS(5558),
    [anon_sym_template] = ACTIONS(5558),
    [anon_sym_operator] = ACTIONS(5558),
    [anon_sym_friend] = ACTIONS(5558),
    [anon_sym_public] = ACTIONS(5558),
    [anon_sym_private] = ACTIONS(5558),
    [anon_sym_protected] = ACTIONS(5558),
    [anon_sym_using] = ACTIONS(5558),
    [anon_sym_static_assert] = ACTIONS(5558),
  },
  [2471] = {
    [sym_identifier] = ACTIONS(5558),
    [aux_sym_preproc_def_token1] = ACTIONS(5558),
    [aux_sym_preproc_if_token1] = ACTIONS(5558),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5558),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5558),
    [sym_preproc_directive] = ACTIONS(5558),
    [anon_sym_LPAREN2] = ACTIONS(5560),
    [anon_sym_TILDE] = ACTIONS(5560),
    [anon_sym_STAR] = ACTIONS(5560),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_AMP] = ACTIONS(5558),
    [anon_sym___extension__] = ACTIONS(5558),
    [anon_sym_typedef] = ACTIONS(5558),
    [anon_sym_extern] = ACTIONS(5558),
    [anon_sym___attribute__] = ACTIONS(5558),
    [anon_sym_COLON_COLON] = ACTIONS(5560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5560),
    [anon_sym___declspec] = ACTIONS(5558),
    [anon_sym___based] = ACTIONS(5558),
    [anon_sym_RBRACE] = ACTIONS(5560),
    [anon_sym_signed] = ACTIONS(5558),
    [anon_sym_unsigned] = ACTIONS(5558),
    [anon_sym_long] = ACTIONS(5558),
    [anon_sym_short] = ACTIONS(5558),
    [anon_sym_LBRACK] = ACTIONS(5558),
    [anon_sym_static] = ACTIONS(5558),
    [anon_sym_register] = ACTIONS(5558),
    [anon_sym_inline] = ACTIONS(5558),
    [anon_sym___inline] = ACTIONS(5558),
    [anon_sym___inline__] = ACTIONS(5558),
    [anon_sym___forceinline] = ACTIONS(5558),
    [anon_sym_thread_local] = ACTIONS(5558),
    [anon_sym___thread] = ACTIONS(5558),
    [anon_sym_const] = ACTIONS(5558),
    [anon_sym_constexpr] = ACTIONS(5558),
    [anon_sym_volatile] = ACTIONS(5558),
    [anon_sym_restrict] = ACTIONS(5558),
    [anon_sym___restrict__] = ACTIONS(5558),
    [anon_sym__Atomic] = ACTIONS(5558),
    [anon_sym__Noreturn] = ACTIONS(5558),
    [anon_sym_noreturn] = ACTIONS(5558),
    [anon_sym_mutable] = ACTIONS(5558),
    [anon_sym_constinit] = ACTIONS(5558),
    [anon_sym_consteval] = ACTIONS(5558),
    [anon_sym_PROGMEM] = ACTIONS(5558),
    [aux_sym_primitive_type_token1] = ACTIONS(5558),
    [anon_sym_byte] = ACTIONS(5558),
    [anon_sym_word] = ACTIONS(5558),
    [anon_sym_enum] = ACTIONS(5558),
    [anon_sym_class] = ACTIONS(5558),
    [anon_sym_struct] = ACTIONS(5558),
    [anon_sym_union] = ACTIONS(5558),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5558),
    [anon_sym_decltype] = ACTIONS(5558),
    [anon_sym_virtual] = ACTIONS(5558),
    [anon_sym_alignas] = ACTIONS(5558),
    [anon_sym_explicit] = ACTIONS(5558),
    [anon_sym_typename] = ACTIONS(5558),
    [anon_sym_template] = ACTIONS(5558),
    [anon_sym_operator] = ACTIONS(5558),
    [anon_sym_friend] = ACTIONS(5558),
    [anon_sym_public] = ACTIONS(5558),
    [anon_sym_private] = ACTIONS(5558),
    [anon_sym_protected] = ACTIONS(5558),
    [anon_sym_using] = ACTIONS(5558),
    [anon_sym_static_assert] = ACTIONS(5558),
  },
  [2472] = {
    [sym_identifier] = ACTIONS(5507),
    [aux_sym_preproc_def_token1] = ACTIONS(5507),
    [aux_sym_preproc_if_token1] = ACTIONS(5507),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5507),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5507),
    [sym_preproc_directive] = ACTIONS(5507),
    [anon_sym_LPAREN2] = ACTIONS(5509),
    [anon_sym_TILDE] = ACTIONS(5509),
    [anon_sym_STAR] = ACTIONS(5509),
    [anon_sym_AMP_AMP] = ACTIONS(5509),
    [anon_sym_AMP] = ACTIONS(5507),
    [anon_sym___extension__] = ACTIONS(5507),
    [anon_sym_typedef] = ACTIONS(5507),
    [anon_sym_extern] = ACTIONS(5507),
    [anon_sym___attribute__] = ACTIONS(5507),
    [anon_sym_COLON_COLON] = ACTIONS(5509),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5509),
    [anon_sym___declspec] = ACTIONS(5507),
    [anon_sym___based] = ACTIONS(5507),
    [anon_sym_RBRACE] = ACTIONS(5509),
    [anon_sym_signed] = ACTIONS(5507),
    [anon_sym_unsigned] = ACTIONS(5507),
    [anon_sym_long] = ACTIONS(5507),
    [anon_sym_short] = ACTIONS(5507),
    [anon_sym_LBRACK] = ACTIONS(5507),
    [anon_sym_static] = ACTIONS(5507),
    [anon_sym_register] = ACTIONS(5507),
    [anon_sym_inline] = ACTIONS(5507),
    [anon_sym___inline] = ACTIONS(5507),
    [anon_sym___inline__] = ACTIONS(5507),
    [anon_sym___forceinline] = ACTIONS(5507),
    [anon_sym_thread_local] = ACTIONS(5507),
    [anon_sym___thread] = ACTIONS(5507),
    [anon_sym_const] = ACTIONS(5507),
    [anon_sym_constexpr] = ACTIONS(5507),
    [anon_sym_volatile] = ACTIONS(5507),
    [anon_sym_restrict] = ACTIONS(5507),
    [anon_sym___restrict__] = ACTIONS(5507),
    [anon_sym__Atomic] = ACTIONS(5507),
    [anon_sym__Noreturn] = ACTIONS(5507),
    [anon_sym_noreturn] = ACTIONS(5507),
    [anon_sym_mutable] = ACTIONS(5507),
    [anon_sym_constinit] = ACTIONS(5507),
    [anon_sym_consteval] = ACTIONS(5507),
    [anon_sym_PROGMEM] = ACTIONS(5507),
    [aux_sym_primitive_type_token1] = ACTIONS(5507),
    [anon_sym_byte] = ACTIONS(5507),
    [anon_sym_word] = ACTIONS(5507),
    [anon_sym_enum] = ACTIONS(5507),
    [anon_sym_class] = ACTIONS(5507),
    [anon_sym_struct] = ACTIONS(5507),
    [anon_sym_union] = ACTIONS(5507),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5507),
    [anon_sym_decltype] = ACTIONS(5507),
    [anon_sym_virtual] = ACTIONS(5507),
    [anon_sym_alignas] = ACTIONS(5507),
    [anon_sym_explicit] = ACTIONS(5507),
    [anon_sym_typename] = ACTIONS(5507),
    [anon_sym_template] = ACTIONS(5507),
    [anon_sym_operator] = ACTIONS(5507),
    [anon_sym_friend] = ACTIONS(5507),
    [anon_sym_public] = ACTIONS(5507),
    [anon_sym_private] = ACTIONS(5507),
    [anon_sym_protected] = ACTIONS(5507),
    [anon_sym_using] = ACTIONS(5507),
    [anon_sym_static_assert] = ACTIONS(5507),
  },
  [2473] = {
    [sym_string_literal] = STATE(3952),
    [sym_template_argument_list] = STATE(4471),
    [sym_raw_string_literal] = STATE(3952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5870),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym___attribute__] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(5916),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(5918),
    [anon_sym_SLASH_EQ] = ACTIONS(5918),
    [anon_sym_PERCENT_EQ] = ACTIONS(5918),
    [anon_sym_PLUS_EQ] = ACTIONS(5918),
    [anon_sym_DASH_EQ] = ACTIONS(5918),
    [anon_sym_LT_LT_EQ] = ACTIONS(5918),
    [anon_sym_GT_GT_EQ] = ACTIONS(5918),
    [anon_sym_AMP_EQ] = ACTIONS(5918),
    [anon_sym_CARET_EQ] = ACTIONS(5918),
    [anon_sym_PIPE_EQ] = ACTIONS(5918),
    [anon_sym_and_eq] = ACTIONS(5918),
    [anon_sym_or_eq] = ACTIONS(5918),
    [anon_sym_xor_eq] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(5920),
    [anon_sym_u_DQUOTE] = ACTIONS(5920),
    [anon_sym_U_DQUOTE] = ACTIONS(5920),
    [anon_sym_u8_DQUOTE] = ACTIONS(5920),
    [anon_sym_DQUOTE] = ACTIONS(5920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5922),
    [anon_sym_LR_DQUOTE] = ACTIONS(5922),
    [anon_sym_uR_DQUOTE] = ACTIONS(5922),
    [anon_sym_UR_DQUOTE] = ACTIONS(5922),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5922),
  },
  [2474] = {
    [sym_identifier] = ACTIONS(3254),
    [aux_sym_preproc_def_token1] = ACTIONS(3254),
    [aux_sym_preproc_if_token1] = ACTIONS(3254),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3254),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3254),
    [sym_preproc_directive] = ACTIONS(3254),
    [anon_sym_LPAREN2] = ACTIONS(3256),
    [anon_sym_TILDE] = ACTIONS(3256),
    [anon_sym_STAR] = ACTIONS(3256),
    [anon_sym_AMP_AMP] = ACTIONS(3256),
    [anon_sym_AMP] = ACTIONS(3254),
    [anon_sym___extension__] = ACTIONS(3254),
    [anon_sym_typedef] = ACTIONS(3254),
    [anon_sym_extern] = ACTIONS(3254),
    [anon_sym___attribute__] = ACTIONS(3254),
    [anon_sym_COLON_COLON] = ACTIONS(3256),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3256),
    [anon_sym___declspec] = ACTIONS(3254),
    [anon_sym___based] = ACTIONS(3254),
    [anon_sym_RBRACE] = ACTIONS(3256),
    [anon_sym_signed] = ACTIONS(3254),
    [anon_sym_unsigned] = ACTIONS(3254),
    [anon_sym_long] = ACTIONS(3254),
    [anon_sym_short] = ACTIONS(3254),
    [anon_sym_LBRACK] = ACTIONS(3254),
    [anon_sym_static] = ACTIONS(3254),
    [anon_sym_register] = ACTIONS(3254),
    [anon_sym_inline] = ACTIONS(3254),
    [anon_sym___inline] = ACTIONS(3254),
    [anon_sym___inline__] = ACTIONS(3254),
    [anon_sym___forceinline] = ACTIONS(3254),
    [anon_sym_thread_local] = ACTIONS(3254),
    [anon_sym___thread] = ACTIONS(3254),
    [anon_sym_const] = ACTIONS(3254),
    [anon_sym_constexpr] = ACTIONS(3254),
    [anon_sym_volatile] = ACTIONS(3254),
    [anon_sym_restrict] = ACTIONS(3254),
    [anon_sym___restrict__] = ACTIONS(3254),
    [anon_sym__Atomic] = ACTIONS(3254),
    [anon_sym__Noreturn] = ACTIONS(3254),
    [anon_sym_noreturn] = ACTIONS(3254),
    [anon_sym_mutable] = ACTIONS(3254),
    [anon_sym_constinit] = ACTIONS(3254),
    [anon_sym_consteval] = ACTIONS(3254),
    [anon_sym_PROGMEM] = ACTIONS(3254),
    [aux_sym_primitive_type_token1] = ACTIONS(3254),
    [anon_sym_byte] = ACTIONS(3254),
    [anon_sym_word] = ACTIONS(3254),
    [anon_sym_enum] = ACTIONS(3254),
    [anon_sym_class] = ACTIONS(3254),
    [anon_sym_struct] = ACTIONS(3254),
    [anon_sym_union] = ACTIONS(3254),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3254),
    [anon_sym_decltype] = ACTIONS(3254),
    [anon_sym_virtual] = ACTIONS(3254),
    [anon_sym_alignas] = ACTIONS(3254),
    [anon_sym_explicit] = ACTIONS(3254),
    [anon_sym_typename] = ACTIONS(3254),
    [anon_sym_template] = ACTIONS(3254),
    [anon_sym_operator] = ACTIONS(3254),
    [anon_sym_friend] = ACTIONS(3254),
    [anon_sym_public] = ACTIONS(3254),
    [anon_sym_private] = ACTIONS(3254),
    [anon_sym_protected] = ACTIONS(3254),
    [anon_sym_using] = ACTIONS(3254),
    [anon_sym_static_assert] = ACTIONS(3254),
  },
  [2475] = {
    [sym_identifier] = ACTIONS(4031),
    [aux_sym_preproc_def_token1] = ACTIONS(4031),
    [aux_sym_preproc_if_token1] = ACTIONS(4031),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4031),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4031),
    [sym_preproc_directive] = ACTIONS(4031),
    [anon_sym_LPAREN2] = ACTIONS(4029),
    [anon_sym_TILDE] = ACTIONS(4029),
    [anon_sym_STAR] = ACTIONS(4029),
    [anon_sym_AMP_AMP] = ACTIONS(4029),
    [anon_sym_AMP] = ACTIONS(4031),
    [anon_sym___extension__] = ACTIONS(4031),
    [anon_sym_typedef] = ACTIONS(4031),
    [anon_sym_extern] = ACTIONS(4031),
    [anon_sym___attribute__] = ACTIONS(4031),
    [anon_sym_COLON_COLON] = ACTIONS(4029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4029),
    [anon_sym___declspec] = ACTIONS(4031),
    [anon_sym___based] = ACTIONS(4031),
    [anon_sym_RBRACE] = ACTIONS(4029),
    [anon_sym_signed] = ACTIONS(4031),
    [anon_sym_unsigned] = ACTIONS(4031),
    [anon_sym_long] = ACTIONS(4031),
    [anon_sym_short] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4031),
    [anon_sym_static] = ACTIONS(4031),
    [anon_sym_register] = ACTIONS(4031),
    [anon_sym_inline] = ACTIONS(4031),
    [anon_sym___inline] = ACTIONS(4031),
    [anon_sym___inline__] = ACTIONS(4031),
    [anon_sym___forceinline] = ACTIONS(4031),
    [anon_sym_thread_local] = ACTIONS(4031),
    [anon_sym___thread] = ACTIONS(4031),
    [anon_sym_const] = ACTIONS(4031),
    [anon_sym_constexpr] = ACTIONS(4031),
    [anon_sym_volatile] = ACTIONS(4031),
    [anon_sym_restrict] = ACTIONS(4031),
    [anon_sym___restrict__] = ACTIONS(4031),
    [anon_sym__Atomic] = ACTIONS(4031),
    [anon_sym__Noreturn] = ACTIONS(4031),
    [anon_sym_noreturn] = ACTIONS(4031),
    [anon_sym_mutable] = ACTIONS(4031),
    [anon_sym_constinit] = ACTIONS(4031),
    [anon_sym_consteval] = ACTIONS(4031),
    [anon_sym_PROGMEM] = ACTIONS(4031),
    [aux_sym_primitive_type_token1] = ACTIONS(4031),
    [anon_sym_byte] = ACTIONS(4031),
    [anon_sym_word] = ACTIONS(4031),
    [anon_sym_enum] = ACTIONS(4031),
    [anon_sym_class] = ACTIONS(4031),
    [anon_sym_struct] = ACTIONS(4031),
    [anon_sym_union] = ACTIONS(4031),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4031),
    [anon_sym_decltype] = ACTIONS(4031),
    [anon_sym_virtual] = ACTIONS(4031),
    [anon_sym_alignas] = ACTIONS(4031),
    [anon_sym_explicit] = ACTIONS(4031),
    [anon_sym_typename] = ACTIONS(4031),
    [anon_sym_template] = ACTIONS(4031),
    [anon_sym_operator] = ACTIONS(4031),
    [anon_sym_friend] = ACTIONS(4031),
    [anon_sym_public] = ACTIONS(4031),
    [anon_sym_private] = ACTIONS(4031),
    [anon_sym_protected] = ACTIONS(4031),
    [anon_sym_using] = ACTIONS(4031),
    [anon_sym_static_assert] = ACTIONS(4031),
  },
  [2476] = {
    [sym_identifier] = ACTIONS(5522),
    [aux_sym_preproc_def_token1] = ACTIONS(5522),
    [aux_sym_preproc_if_token1] = ACTIONS(5522),
    [aux_sym_preproc_if_token2] = ACTIONS(5522),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5522),
    [sym_preproc_directive] = ACTIONS(5522),
    [anon_sym_LPAREN2] = ACTIONS(5524),
    [anon_sym_TILDE] = ACTIONS(5524),
    [anon_sym_STAR] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5522),
    [anon_sym___extension__] = ACTIONS(5522),
    [anon_sym_typedef] = ACTIONS(5522),
    [anon_sym_extern] = ACTIONS(5522),
    [anon_sym___attribute__] = ACTIONS(5522),
    [anon_sym_COLON_COLON] = ACTIONS(5524),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5524),
    [anon_sym___declspec] = ACTIONS(5522),
    [anon_sym___based] = ACTIONS(5522),
    [anon_sym_signed] = ACTIONS(5522),
    [anon_sym_unsigned] = ACTIONS(5522),
    [anon_sym_long] = ACTIONS(5522),
    [anon_sym_short] = ACTIONS(5522),
    [anon_sym_LBRACK] = ACTIONS(5522),
    [anon_sym_static] = ACTIONS(5522),
    [anon_sym_register] = ACTIONS(5522),
    [anon_sym_inline] = ACTIONS(5522),
    [anon_sym___inline] = ACTIONS(5522),
    [anon_sym___inline__] = ACTIONS(5522),
    [anon_sym___forceinline] = ACTIONS(5522),
    [anon_sym_thread_local] = ACTIONS(5522),
    [anon_sym___thread] = ACTIONS(5522),
    [anon_sym_const] = ACTIONS(5522),
    [anon_sym_constexpr] = ACTIONS(5522),
    [anon_sym_volatile] = ACTIONS(5522),
    [anon_sym_restrict] = ACTIONS(5522),
    [anon_sym___restrict__] = ACTIONS(5522),
    [anon_sym__Atomic] = ACTIONS(5522),
    [anon_sym__Noreturn] = ACTIONS(5522),
    [anon_sym_noreturn] = ACTIONS(5522),
    [anon_sym_mutable] = ACTIONS(5522),
    [anon_sym_constinit] = ACTIONS(5522),
    [anon_sym_consteval] = ACTIONS(5522),
    [anon_sym_PROGMEM] = ACTIONS(5522),
    [aux_sym_primitive_type_token1] = ACTIONS(5522),
    [anon_sym_byte] = ACTIONS(5522),
    [anon_sym_word] = ACTIONS(5522),
    [anon_sym_enum] = ACTIONS(5522),
    [anon_sym_class] = ACTIONS(5522),
    [anon_sym_struct] = ACTIONS(5522),
    [anon_sym_union] = ACTIONS(5522),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5522),
    [anon_sym_decltype] = ACTIONS(5522),
    [anon_sym_virtual] = ACTIONS(5522),
    [anon_sym_alignas] = ACTIONS(5522),
    [anon_sym_explicit] = ACTIONS(5522),
    [anon_sym_typename] = ACTIONS(5522),
    [anon_sym_template] = ACTIONS(5522),
    [anon_sym_operator] = ACTIONS(5522),
    [anon_sym_friend] = ACTIONS(5522),
    [anon_sym_public] = ACTIONS(5522),
    [anon_sym_private] = ACTIONS(5522),
    [anon_sym_protected] = ACTIONS(5522),
    [anon_sym_using] = ACTIONS(5522),
    [anon_sym_static_assert] = ACTIONS(5522),
  },
  [2477] = {
    [sym_identifier] = ACTIONS(5578),
    [aux_sym_preproc_def_token1] = ACTIONS(5578),
    [aux_sym_preproc_if_token1] = ACTIONS(5578),
    [aux_sym_preproc_if_token2] = ACTIONS(5578),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5578),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5578),
    [sym_preproc_directive] = ACTIONS(5578),
    [anon_sym_LPAREN2] = ACTIONS(5580),
    [anon_sym_TILDE] = ACTIONS(5580),
    [anon_sym_STAR] = ACTIONS(5580),
    [anon_sym_AMP_AMP] = ACTIONS(5580),
    [anon_sym_AMP] = ACTIONS(5578),
    [anon_sym___extension__] = ACTIONS(5578),
    [anon_sym_typedef] = ACTIONS(5578),
    [anon_sym_extern] = ACTIONS(5578),
    [anon_sym___attribute__] = ACTIONS(5578),
    [anon_sym_COLON_COLON] = ACTIONS(5580),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5580),
    [anon_sym___declspec] = ACTIONS(5578),
    [anon_sym___based] = ACTIONS(5578),
    [anon_sym_signed] = ACTIONS(5578),
    [anon_sym_unsigned] = ACTIONS(5578),
    [anon_sym_long] = ACTIONS(5578),
    [anon_sym_short] = ACTIONS(5578),
    [anon_sym_LBRACK] = ACTIONS(5578),
    [anon_sym_static] = ACTIONS(5578),
    [anon_sym_register] = ACTIONS(5578),
    [anon_sym_inline] = ACTIONS(5578),
    [anon_sym___inline] = ACTIONS(5578),
    [anon_sym___inline__] = ACTIONS(5578),
    [anon_sym___forceinline] = ACTIONS(5578),
    [anon_sym_thread_local] = ACTIONS(5578),
    [anon_sym___thread] = ACTIONS(5578),
    [anon_sym_const] = ACTIONS(5578),
    [anon_sym_constexpr] = ACTIONS(5578),
    [anon_sym_volatile] = ACTIONS(5578),
    [anon_sym_restrict] = ACTIONS(5578),
    [anon_sym___restrict__] = ACTIONS(5578),
    [anon_sym__Atomic] = ACTIONS(5578),
    [anon_sym__Noreturn] = ACTIONS(5578),
    [anon_sym_noreturn] = ACTIONS(5578),
    [anon_sym_mutable] = ACTIONS(5578),
    [anon_sym_constinit] = ACTIONS(5578),
    [anon_sym_consteval] = ACTIONS(5578),
    [anon_sym_PROGMEM] = ACTIONS(5578),
    [aux_sym_primitive_type_token1] = ACTIONS(5578),
    [anon_sym_byte] = ACTIONS(5578),
    [anon_sym_word] = ACTIONS(5578),
    [anon_sym_enum] = ACTIONS(5578),
    [anon_sym_class] = ACTIONS(5578),
    [anon_sym_struct] = ACTIONS(5578),
    [anon_sym_union] = ACTIONS(5578),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5578),
    [anon_sym_decltype] = ACTIONS(5578),
    [anon_sym_virtual] = ACTIONS(5578),
    [anon_sym_alignas] = ACTIONS(5578),
    [anon_sym_explicit] = ACTIONS(5578),
    [anon_sym_typename] = ACTIONS(5578),
    [anon_sym_template] = ACTIONS(5578),
    [anon_sym_operator] = ACTIONS(5578),
    [anon_sym_friend] = ACTIONS(5578),
    [anon_sym_public] = ACTIONS(5578),
    [anon_sym_private] = ACTIONS(5578),
    [anon_sym_protected] = ACTIONS(5578),
    [anon_sym_using] = ACTIONS(5578),
    [anon_sym_static_assert] = ACTIONS(5578),
  },
  [2478] = {
    [sym_identifier] = ACTIONS(3324),
    [aux_sym_preproc_def_token1] = ACTIONS(3324),
    [aux_sym_preproc_if_token1] = ACTIONS(3324),
    [aux_sym_preproc_if_token2] = ACTIONS(3324),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3324),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3324),
    [sym_preproc_directive] = ACTIONS(3324),
    [anon_sym_LPAREN2] = ACTIONS(3326),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(3326),
    [anon_sym_AMP_AMP] = ACTIONS(3326),
    [anon_sym_AMP] = ACTIONS(3324),
    [anon_sym___extension__] = ACTIONS(3324),
    [anon_sym_typedef] = ACTIONS(3324),
    [anon_sym_extern] = ACTIONS(3324),
    [anon_sym___attribute__] = ACTIONS(3324),
    [anon_sym_COLON_COLON] = ACTIONS(3326),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3326),
    [anon_sym___declspec] = ACTIONS(3324),
    [anon_sym___based] = ACTIONS(3324),
    [anon_sym_signed] = ACTIONS(3324),
    [anon_sym_unsigned] = ACTIONS(3324),
    [anon_sym_long] = ACTIONS(3324),
    [anon_sym_short] = ACTIONS(3324),
    [anon_sym_LBRACK] = ACTIONS(3324),
    [anon_sym_static] = ACTIONS(3324),
    [anon_sym_register] = ACTIONS(3324),
    [anon_sym_inline] = ACTIONS(3324),
    [anon_sym___inline] = ACTIONS(3324),
    [anon_sym___inline__] = ACTIONS(3324),
    [anon_sym___forceinline] = ACTIONS(3324),
    [anon_sym_thread_local] = ACTIONS(3324),
    [anon_sym___thread] = ACTIONS(3324),
    [anon_sym_const] = ACTIONS(3324),
    [anon_sym_constexpr] = ACTIONS(3324),
    [anon_sym_volatile] = ACTIONS(3324),
    [anon_sym_restrict] = ACTIONS(3324),
    [anon_sym___restrict__] = ACTIONS(3324),
    [anon_sym__Atomic] = ACTIONS(3324),
    [anon_sym__Noreturn] = ACTIONS(3324),
    [anon_sym_noreturn] = ACTIONS(3324),
    [anon_sym_mutable] = ACTIONS(3324),
    [anon_sym_constinit] = ACTIONS(3324),
    [anon_sym_consteval] = ACTIONS(3324),
    [anon_sym_PROGMEM] = ACTIONS(3324),
    [aux_sym_primitive_type_token1] = ACTIONS(3324),
    [anon_sym_byte] = ACTIONS(3324),
    [anon_sym_word] = ACTIONS(3324),
    [anon_sym_enum] = ACTIONS(3324),
    [anon_sym_class] = ACTIONS(3324),
    [anon_sym_struct] = ACTIONS(3324),
    [anon_sym_union] = ACTIONS(3324),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3324),
    [anon_sym_decltype] = ACTIONS(3324),
    [anon_sym_virtual] = ACTIONS(3324),
    [anon_sym_alignas] = ACTIONS(3324),
    [anon_sym_explicit] = ACTIONS(3324),
    [anon_sym_typename] = ACTIONS(3324),
    [anon_sym_template] = ACTIONS(3324),
    [anon_sym_operator] = ACTIONS(3324),
    [anon_sym_friend] = ACTIONS(3324),
    [anon_sym_public] = ACTIONS(3324),
    [anon_sym_private] = ACTIONS(3324),
    [anon_sym_protected] = ACTIONS(3324),
    [anon_sym_using] = ACTIONS(3324),
    [anon_sym_static_assert] = ACTIONS(3324),
  },
  [2479] = {
    [sym_identifier] = ACTIONS(3301),
    [aux_sym_preproc_def_token1] = ACTIONS(3301),
    [aux_sym_preproc_if_token1] = ACTIONS(3301),
    [aux_sym_preproc_if_token2] = ACTIONS(3301),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3301),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3301),
    [sym_preproc_directive] = ACTIONS(3301),
    [anon_sym_LPAREN2] = ACTIONS(3303),
    [anon_sym_TILDE] = ACTIONS(3303),
    [anon_sym_STAR] = ACTIONS(3303),
    [anon_sym_AMP_AMP] = ACTIONS(3303),
    [anon_sym_AMP] = ACTIONS(3301),
    [anon_sym___extension__] = ACTIONS(3301),
    [anon_sym_typedef] = ACTIONS(3301),
    [anon_sym_extern] = ACTIONS(3301),
    [anon_sym___attribute__] = ACTIONS(3301),
    [anon_sym_COLON_COLON] = ACTIONS(3303),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3303),
    [anon_sym___declspec] = ACTIONS(3301),
    [anon_sym___based] = ACTIONS(3301),
    [anon_sym_signed] = ACTIONS(3301),
    [anon_sym_unsigned] = ACTIONS(3301),
    [anon_sym_long] = ACTIONS(3301),
    [anon_sym_short] = ACTIONS(3301),
    [anon_sym_LBRACK] = ACTIONS(3301),
    [anon_sym_static] = ACTIONS(3301),
    [anon_sym_register] = ACTIONS(3301),
    [anon_sym_inline] = ACTIONS(3301),
    [anon_sym___inline] = ACTIONS(3301),
    [anon_sym___inline__] = ACTIONS(3301),
    [anon_sym___forceinline] = ACTIONS(3301),
    [anon_sym_thread_local] = ACTIONS(3301),
    [anon_sym___thread] = ACTIONS(3301),
    [anon_sym_const] = ACTIONS(3301),
    [anon_sym_constexpr] = ACTIONS(3301),
    [anon_sym_volatile] = ACTIONS(3301),
    [anon_sym_restrict] = ACTIONS(3301),
    [anon_sym___restrict__] = ACTIONS(3301),
    [anon_sym__Atomic] = ACTIONS(3301),
    [anon_sym__Noreturn] = ACTIONS(3301),
    [anon_sym_noreturn] = ACTIONS(3301),
    [anon_sym_mutable] = ACTIONS(3301),
    [anon_sym_constinit] = ACTIONS(3301),
    [anon_sym_consteval] = ACTIONS(3301),
    [anon_sym_PROGMEM] = ACTIONS(3301),
    [aux_sym_primitive_type_token1] = ACTIONS(3301),
    [anon_sym_byte] = ACTIONS(3301),
    [anon_sym_word] = ACTIONS(3301),
    [anon_sym_enum] = ACTIONS(3301),
    [anon_sym_class] = ACTIONS(3301),
    [anon_sym_struct] = ACTIONS(3301),
    [anon_sym_union] = ACTIONS(3301),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3301),
    [anon_sym_decltype] = ACTIONS(3301),
    [anon_sym_virtual] = ACTIONS(3301),
    [anon_sym_alignas] = ACTIONS(3301),
    [anon_sym_explicit] = ACTIONS(3301),
    [anon_sym_typename] = ACTIONS(3301),
    [anon_sym_template] = ACTIONS(3301),
    [anon_sym_operator] = ACTIONS(3301),
    [anon_sym_friend] = ACTIONS(3301),
    [anon_sym_public] = ACTIONS(3301),
    [anon_sym_private] = ACTIONS(3301),
    [anon_sym_protected] = ACTIONS(3301),
    [anon_sym_using] = ACTIONS(3301),
    [anon_sym_static_assert] = ACTIONS(3301),
  },
  [2480] = {
    [sym_identifier] = ACTIONS(3297),
    [aux_sym_preproc_def_token1] = ACTIONS(3297),
    [aux_sym_preproc_if_token1] = ACTIONS(3297),
    [aux_sym_preproc_if_token2] = ACTIONS(3297),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3297),
    [sym_preproc_directive] = ACTIONS(3297),
    [anon_sym_LPAREN2] = ACTIONS(3299),
    [anon_sym_TILDE] = ACTIONS(3299),
    [anon_sym_STAR] = ACTIONS(3299),
    [anon_sym_AMP_AMP] = ACTIONS(3299),
    [anon_sym_AMP] = ACTIONS(3297),
    [anon_sym___extension__] = ACTIONS(3297),
    [anon_sym_typedef] = ACTIONS(3297),
    [anon_sym_extern] = ACTIONS(3297),
    [anon_sym___attribute__] = ACTIONS(3297),
    [anon_sym_COLON_COLON] = ACTIONS(3299),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3299),
    [anon_sym___declspec] = ACTIONS(3297),
    [anon_sym___based] = ACTIONS(3297),
    [anon_sym_signed] = ACTIONS(3297),
    [anon_sym_unsigned] = ACTIONS(3297),
    [anon_sym_long] = ACTIONS(3297),
    [anon_sym_short] = ACTIONS(3297),
    [anon_sym_LBRACK] = ACTIONS(3297),
    [anon_sym_static] = ACTIONS(3297),
    [anon_sym_register] = ACTIONS(3297),
    [anon_sym_inline] = ACTIONS(3297),
    [anon_sym___inline] = ACTIONS(3297),
    [anon_sym___inline__] = ACTIONS(3297),
    [anon_sym___forceinline] = ACTIONS(3297),
    [anon_sym_thread_local] = ACTIONS(3297),
    [anon_sym___thread] = ACTIONS(3297),
    [anon_sym_const] = ACTIONS(3297),
    [anon_sym_constexpr] = ACTIONS(3297),
    [anon_sym_volatile] = ACTIONS(3297),
    [anon_sym_restrict] = ACTIONS(3297),
    [anon_sym___restrict__] = ACTIONS(3297),
    [anon_sym__Atomic] = ACTIONS(3297),
    [anon_sym__Noreturn] = ACTIONS(3297),
    [anon_sym_noreturn] = ACTIONS(3297),
    [anon_sym_mutable] = ACTIONS(3297),
    [anon_sym_constinit] = ACTIONS(3297),
    [anon_sym_consteval] = ACTIONS(3297),
    [anon_sym_PROGMEM] = ACTIONS(3297),
    [aux_sym_primitive_type_token1] = ACTIONS(3297),
    [anon_sym_byte] = ACTIONS(3297),
    [anon_sym_word] = ACTIONS(3297),
    [anon_sym_enum] = ACTIONS(3297),
    [anon_sym_class] = ACTIONS(3297),
    [anon_sym_struct] = ACTIONS(3297),
    [anon_sym_union] = ACTIONS(3297),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3297),
    [anon_sym_decltype] = ACTIONS(3297),
    [anon_sym_virtual] = ACTIONS(3297),
    [anon_sym_alignas] = ACTIONS(3297),
    [anon_sym_explicit] = ACTIONS(3297),
    [anon_sym_typename] = ACTIONS(3297),
    [anon_sym_template] = ACTIONS(3297),
    [anon_sym_operator] = ACTIONS(3297),
    [anon_sym_friend] = ACTIONS(3297),
    [anon_sym_public] = ACTIONS(3297),
    [anon_sym_private] = ACTIONS(3297),
    [anon_sym_protected] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3297),
    [anon_sym_static_assert] = ACTIONS(3297),
  },
  [2481] = {
    [sym_identifier] = ACTIONS(3293),
    [aux_sym_preproc_def_token1] = ACTIONS(3293),
    [aux_sym_preproc_if_token1] = ACTIONS(3293),
    [aux_sym_preproc_if_token2] = ACTIONS(3293),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3293),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3293),
    [sym_preproc_directive] = ACTIONS(3293),
    [anon_sym_LPAREN2] = ACTIONS(3295),
    [anon_sym_TILDE] = ACTIONS(3295),
    [anon_sym_STAR] = ACTIONS(3295),
    [anon_sym_AMP_AMP] = ACTIONS(3295),
    [anon_sym_AMP] = ACTIONS(3293),
    [anon_sym___extension__] = ACTIONS(3293),
    [anon_sym_typedef] = ACTIONS(3293),
    [anon_sym_extern] = ACTIONS(3293),
    [anon_sym___attribute__] = ACTIONS(3293),
    [anon_sym_COLON_COLON] = ACTIONS(3295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3295),
    [anon_sym___declspec] = ACTIONS(3293),
    [anon_sym___based] = ACTIONS(3293),
    [anon_sym_signed] = ACTIONS(3293),
    [anon_sym_unsigned] = ACTIONS(3293),
    [anon_sym_long] = ACTIONS(3293),
    [anon_sym_short] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_static] = ACTIONS(3293),
    [anon_sym_register] = ACTIONS(3293),
    [anon_sym_inline] = ACTIONS(3293),
    [anon_sym___inline] = ACTIONS(3293),
    [anon_sym___inline__] = ACTIONS(3293),
    [anon_sym___forceinline] = ACTIONS(3293),
    [anon_sym_thread_local] = ACTIONS(3293),
    [anon_sym___thread] = ACTIONS(3293),
    [anon_sym_const] = ACTIONS(3293),
    [anon_sym_constexpr] = ACTIONS(3293),
    [anon_sym_volatile] = ACTIONS(3293),
    [anon_sym_restrict] = ACTIONS(3293),
    [anon_sym___restrict__] = ACTIONS(3293),
    [anon_sym__Atomic] = ACTIONS(3293),
    [anon_sym__Noreturn] = ACTIONS(3293),
    [anon_sym_noreturn] = ACTIONS(3293),
    [anon_sym_mutable] = ACTIONS(3293),
    [anon_sym_constinit] = ACTIONS(3293),
    [anon_sym_consteval] = ACTIONS(3293),
    [anon_sym_PROGMEM] = ACTIONS(3293),
    [aux_sym_primitive_type_token1] = ACTIONS(3293),
    [anon_sym_byte] = ACTIONS(3293),
    [anon_sym_word] = ACTIONS(3293),
    [anon_sym_enum] = ACTIONS(3293),
    [anon_sym_class] = ACTIONS(3293),
    [anon_sym_struct] = ACTIONS(3293),
    [anon_sym_union] = ACTIONS(3293),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3293),
    [anon_sym_decltype] = ACTIONS(3293),
    [anon_sym_virtual] = ACTIONS(3293),
    [anon_sym_alignas] = ACTIONS(3293),
    [anon_sym_explicit] = ACTIONS(3293),
    [anon_sym_typename] = ACTIONS(3293),
    [anon_sym_template] = ACTIONS(3293),
    [anon_sym_operator] = ACTIONS(3293),
    [anon_sym_friend] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3293),
    [anon_sym_private] = ACTIONS(3293),
    [anon_sym_protected] = ACTIONS(3293),
    [anon_sym_using] = ACTIONS(3293),
    [anon_sym_static_assert] = ACTIONS(3293),
  },
  [2482] = {
    [sym_identifier] = ACTIONS(3280),
    [aux_sym_preproc_def_token1] = ACTIONS(3280),
    [aux_sym_preproc_if_token1] = ACTIONS(3280),
    [aux_sym_preproc_if_token2] = ACTIONS(3280),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3280),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3280),
    [sym_preproc_directive] = ACTIONS(3280),
    [anon_sym_LPAREN2] = ACTIONS(3282),
    [anon_sym_TILDE] = ACTIONS(3282),
    [anon_sym_STAR] = ACTIONS(3282),
    [anon_sym_AMP_AMP] = ACTIONS(3282),
    [anon_sym_AMP] = ACTIONS(3280),
    [anon_sym___extension__] = ACTIONS(3280),
    [anon_sym_typedef] = ACTIONS(3280),
    [anon_sym_extern] = ACTIONS(3280),
    [anon_sym___attribute__] = ACTIONS(3280),
    [anon_sym_COLON_COLON] = ACTIONS(3282),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3282),
    [anon_sym___declspec] = ACTIONS(3280),
    [anon_sym___based] = ACTIONS(3280),
    [anon_sym_signed] = ACTIONS(3280),
    [anon_sym_unsigned] = ACTIONS(3280),
    [anon_sym_long] = ACTIONS(3280),
    [anon_sym_short] = ACTIONS(3280),
    [anon_sym_LBRACK] = ACTIONS(3280),
    [anon_sym_static] = ACTIONS(3280),
    [anon_sym_register] = ACTIONS(3280),
    [anon_sym_inline] = ACTIONS(3280),
    [anon_sym___inline] = ACTIONS(3280),
    [anon_sym___inline__] = ACTIONS(3280),
    [anon_sym___forceinline] = ACTIONS(3280),
    [anon_sym_thread_local] = ACTIONS(3280),
    [anon_sym___thread] = ACTIONS(3280),
    [anon_sym_const] = ACTIONS(3280),
    [anon_sym_constexpr] = ACTIONS(3280),
    [anon_sym_volatile] = ACTIONS(3280),
    [anon_sym_restrict] = ACTIONS(3280),
    [anon_sym___restrict__] = ACTIONS(3280),
    [anon_sym__Atomic] = ACTIONS(3280),
    [anon_sym__Noreturn] = ACTIONS(3280),
    [anon_sym_noreturn] = ACTIONS(3280),
    [anon_sym_mutable] = ACTIONS(3280),
    [anon_sym_constinit] = ACTIONS(3280),
    [anon_sym_consteval] = ACTIONS(3280),
    [anon_sym_PROGMEM] = ACTIONS(3280),
    [aux_sym_primitive_type_token1] = ACTIONS(3280),
    [anon_sym_byte] = ACTIONS(3280),
    [anon_sym_word] = ACTIONS(3280),
    [anon_sym_enum] = ACTIONS(3280),
    [anon_sym_class] = ACTIONS(3280),
    [anon_sym_struct] = ACTIONS(3280),
    [anon_sym_union] = ACTIONS(3280),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3280),
    [anon_sym_decltype] = ACTIONS(3280),
    [anon_sym_virtual] = ACTIONS(3280),
    [anon_sym_alignas] = ACTIONS(3280),
    [anon_sym_explicit] = ACTIONS(3280),
    [anon_sym_typename] = ACTIONS(3280),
    [anon_sym_template] = ACTIONS(3280),
    [anon_sym_operator] = ACTIONS(3280),
    [anon_sym_friend] = ACTIONS(3280),
    [anon_sym_public] = ACTIONS(3280),
    [anon_sym_private] = ACTIONS(3280),
    [anon_sym_protected] = ACTIONS(3280),
    [anon_sym_using] = ACTIONS(3280),
    [anon_sym_static_assert] = ACTIONS(3280),
  },
  [2483] = {
    [sym_identifier] = ACTIONS(3086),
    [aux_sym_preproc_def_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3086),
    [sym_preproc_directive] = ACTIONS(3086),
    [anon_sym_LPAREN2] = ACTIONS(3088),
    [anon_sym_TILDE] = ACTIONS(3088),
    [anon_sym_STAR] = ACTIONS(3088),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym___extension__] = ACTIONS(3086),
    [anon_sym_typedef] = ACTIONS(3086),
    [anon_sym_extern] = ACTIONS(3086),
    [anon_sym___attribute__] = ACTIONS(3086),
    [anon_sym_COLON_COLON] = ACTIONS(3088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3088),
    [anon_sym___declspec] = ACTIONS(3086),
    [anon_sym___based] = ACTIONS(3086),
    [anon_sym_RBRACE] = ACTIONS(3088),
    [anon_sym_signed] = ACTIONS(3086),
    [anon_sym_unsigned] = ACTIONS(3086),
    [anon_sym_long] = ACTIONS(3086),
    [anon_sym_short] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(3086),
    [anon_sym_static] = ACTIONS(3086),
    [anon_sym_register] = ACTIONS(3086),
    [anon_sym_inline] = ACTIONS(3086),
    [anon_sym___inline] = ACTIONS(3086),
    [anon_sym___inline__] = ACTIONS(3086),
    [anon_sym___forceinline] = ACTIONS(3086),
    [anon_sym_thread_local] = ACTIONS(3086),
    [anon_sym___thread] = ACTIONS(3086),
    [anon_sym_const] = ACTIONS(3086),
    [anon_sym_constexpr] = ACTIONS(3086),
    [anon_sym_volatile] = ACTIONS(3086),
    [anon_sym_restrict] = ACTIONS(3086),
    [anon_sym___restrict__] = ACTIONS(3086),
    [anon_sym__Atomic] = ACTIONS(3086),
    [anon_sym__Noreturn] = ACTIONS(3086),
    [anon_sym_noreturn] = ACTIONS(3086),
    [anon_sym_mutable] = ACTIONS(3086),
    [anon_sym_constinit] = ACTIONS(3086),
    [anon_sym_consteval] = ACTIONS(3086),
    [anon_sym_PROGMEM] = ACTIONS(3086),
    [aux_sym_primitive_type_token1] = ACTIONS(3086),
    [anon_sym_byte] = ACTIONS(3086),
    [anon_sym_word] = ACTIONS(3086),
    [anon_sym_enum] = ACTIONS(3086),
    [anon_sym_class] = ACTIONS(3086),
    [anon_sym_struct] = ACTIONS(3086),
    [anon_sym_union] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3086),
    [anon_sym_decltype] = ACTIONS(3086),
    [anon_sym_virtual] = ACTIONS(3086),
    [anon_sym_alignas] = ACTIONS(3086),
    [anon_sym_explicit] = ACTIONS(3086),
    [anon_sym_typename] = ACTIONS(3086),
    [anon_sym_template] = ACTIONS(3086),
    [anon_sym_operator] = ACTIONS(3086),
    [anon_sym_friend] = ACTIONS(3086),
    [anon_sym_public] = ACTIONS(3086),
    [anon_sym_private] = ACTIONS(3086),
    [anon_sym_protected] = ACTIONS(3086),
    [anon_sym_using] = ACTIONS(3086),
    [anon_sym_static_assert] = ACTIONS(3086),
  },
  [2484] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym_RBRACE] = ACTIONS(3084),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(3082),
    [anon_sym_private] = ACTIONS(3082),
    [anon_sym_protected] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
  },
  [2485] = {
    [sym_identifier] = ACTIONS(3314),
    [aux_sym_preproc_def_token1] = ACTIONS(3314),
    [aux_sym_preproc_if_token1] = ACTIONS(3314),
    [aux_sym_preproc_if_token2] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3314),
    [sym_preproc_directive] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_STAR] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym___extension__] = ACTIONS(3314),
    [anon_sym_typedef] = ACTIONS(3314),
    [anon_sym_extern] = ACTIONS(3314),
    [anon_sym___attribute__] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3316),
    [anon_sym___declspec] = ACTIONS(3314),
    [anon_sym___based] = ACTIONS(3314),
    [anon_sym_signed] = ACTIONS(3314),
    [anon_sym_unsigned] = ACTIONS(3314),
    [anon_sym_long] = ACTIONS(3314),
    [anon_sym_short] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_static] = ACTIONS(3314),
    [anon_sym_register] = ACTIONS(3314),
    [anon_sym_inline] = ACTIONS(3314),
    [anon_sym___inline] = ACTIONS(3314),
    [anon_sym___inline__] = ACTIONS(3314),
    [anon_sym___forceinline] = ACTIONS(3314),
    [anon_sym_thread_local] = ACTIONS(3314),
    [anon_sym___thread] = ACTIONS(3314),
    [anon_sym_const] = ACTIONS(3314),
    [anon_sym_constexpr] = ACTIONS(3314),
    [anon_sym_volatile] = ACTIONS(3314),
    [anon_sym_restrict] = ACTIONS(3314),
    [anon_sym___restrict__] = ACTIONS(3314),
    [anon_sym__Atomic] = ACTIONS(3314),
    [anon_sym__Noreturn] = ACTIONS(3314),
    [anon_sym_noreturn] = ACTIONS(3314),
    [anon_sym_mutable] = ACTIONS(3314),
    [anon_sym_constinit] = ACTIONS(3314),
    [anon_sym_consteval] = ACTIONS(3314),
    [anon_sym_PROGMEM] = ACTIONS(3314),
    [aux_sym_primitive_type_token1] = ACTIONS(3314),
    [anon_sym_byte] = ACTIONS(3314),
    [anon_sym_word] = ACTIONS(3314),
    [anon_sym_enum] = ACTIONS(3314),
    [anon_sym_class] = ACTIONS(3314),
    [anon_sym_struct] = ACTIONS(3314),
    [anon_sym_union] = ACTIONS(3314),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3314),
    [anon_sym_decltype] = ACTIONS(3314),
    [anon_sym_virtual] = ACTIONS(3314),
    [anon_sym_alignas] = ACTIONS(3314),
    [anon_sym_explicit] = ACTIONS(3314),
    [anon_sym_typename] = ACTIONS(3314),
    [anon_sym_template] = ACTIONS(3314),
    [anon_sym_operator] = ACTIONS(3314),
    [anon_sym_friend] = ACTIONS(3314),
    [anon_sym_public] = ACTIONS(3314),
    [anon_sym_private] = ACTIONS(3314),
    [anon_sym_protected] = ACTIONS(3314),
    [anon_sym_using] = ACTIONS(3314),
    [anon_sym_static_assert] = ACTIONS(3314),
  },
  [2486] = {
    [sym_identifier] = ACTIONS(3310),
    [aux_sym_preproc_def_token1] = ACTIONS(3310),
    [aux_sym_preproc_if_token1] = ACTIONS(3310),
    [aux_sym_preproc_if_token2] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3310),
    [sym_preproc_directive] = ACTIONS(3310),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_AMP_AMP] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3310),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_typedef] = ACTIONS(3310),
    [anon_sym_extern] = ACTIONS(3310),
    [anon_sym___attribute__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3312),
    [anon_sym___declspec] = ACTIONS(3310),
    [anon_sym___based] = ACTIONS(3310),
    [anon_sym_signed] = ACTIONS(3310),
    [anon_sym_unsigned] = ACTIONS(3310),
    [anon_sym_long] = ACTIONS(3310),
    [anon_sym_short] = ACTIONS(3310),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [anon_sym_static] = ACTIONS(3310),
    [anon_sym_register] = ACTIONS(3310),
    [anon_sym_inline] = ACTIONS(3310),
    [anon_sym___inline] = ACTIONS(3310),
    [anon_sym___inline__] = ACTIONS(3310),
    [anon_sym___forceinline] = ACTIONS(3310),
    [anon_sym_thread_local] = ACTIONS(3310),
    [anon_sym___thread] = ACTIONS(3310),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_constexpr] = ACTIONS(3310),
    [anon_sym_volatile] = ACTIONS(3310),
    [anon_sym_restrict] = ACTIONS(3310),
    [anon_sym___restrict__] = ACTIONS(3310),
    [anon_sym__Atomic] = ACTIONS(3310),
    [anon_sym__Noreturn] = ACTIONS(3310),
    [anon_sym_noreturn] = ACTIONS(3310),
    [anon_sym_mutable] = ACTIONS(3310),
    [anon_sym_constinit] = ACTIONS(3310),
    [anon_sym_consteval] = ACTIONS(3310),
    [anon_sym_PROGMEM] = ACTIONS(3310),
    [aux_sym_primitive_type_token1] = ACTIONS(3310),
    [anon_sym_byte] = ACTIONS(3310),
    [anon_sym_word] = ACTIONS(3310),
    [anon_sym_enum] = ACTIONS(3310),
    [anon_sym_class] = ACTIONS(3310),
    [anon_sym_struct] = ACTIONS(3310),
    [anon_sym_union] = ACTIONS(3310),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3310),
    [anon_sym_decltype] = ACTIONS(3310),
    [anon_sym_virtual] = ACTIONS(3310),
    [anon_sym_alignas] = ACTIONS(3310),
    [anon_sym_explicit] = ACTIONS(3310),
    [anon_sym_typename] = ACTIONS(3310),
    [anon_sym_template] = ACTIONS(3310),
    [anon_sym_operator] = ACTIONS(3310),
    [anon_sym_friend] = ACTIONS(3310),
    [anon_sym_public] = ACTIONS(3310),
    [anon_sym_private] = ACTIONS(3310),
    [anon_sym_protected] = ACTIONS(3310),
    [anon_sym_using] = ACTIONS(3310),
    [anon_sym_static_assert] = ACTIONS(3310),
  },
  [2487] = {
    [sym_identifier] = ACTIONS(5518),
    [aux_sym_preproc_def_token1] = ACTIONS(5518),
    [aux_sym_preproc_if_token1] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5518),
    [sym_preproc_directive] = ACTIONS(5518),
    [anon_sym_LPAREN2] = ACTIONS(5520),
    [anon_sym_TILDE] = ACTIONS(5520),
    [anon_sym_STAR] = ACTIONS(5520),
    [anon_sym_AMP_AMP] = ACTIONS(5520),
    [anon_sym_AMP] = ACTIONS(5518),
    [anon_sym___extension__] = ACTIONS(5518),
    [anon_sym_typedef] = ACTIONS(5518),
    [anon_sym_extern] = ACTIONS(5518),
    [anon_sym___attribute__] = ACTIONS(5518),
    [anon_sym_COLON_COLON] = ACTIONS(5520),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5520),
    [anon_sym___declspec] = ACTIONS(5518),
    [anon_sym___based] = ACTIONS(5518),
    [anon_sym_RBRACE] = ACTIONS(5520),
    [anon_sym_signed] = ACTIONS(5518),
    [anon_sym_unsigned] = ACTIONS(5518),
    [anon_sym_long] = ACTIONS(5518),
    [anon_sym_short] = ACTIONS(5518),
    [anon_sym_LBRACK] = ACTIONS(5518),
    [anon_sym_static] = ACTIONS(5518),
    [anon_sym_register] = ACTIONS(5518),
    [anon_sym_inline] = ACTIONS(5518),
    [anon_sym___inline] = ACTIONS(5518),
    [anon_sym___inline__] = ACTIONS(5518),
    [anon_sym___forceinline] = ACTIONS(5518),
    [anon_sym_thread_local] = ACTIONS(5518),
    [anon_sym___thread] = ACTIONS(5518),
    [anon_sym_const] = ACTIONS(5518),
    [anon_sym_constexpr] = ACTIONS(5518),
    [anon_sym_volatile] = ACTIONS(5518),
    [anon_sym_restrict] = ACTIONS(5518),
    [anon_sym___restrict__] = ACTIONS(5518),
    [anon_sym__Atomic] = ACTIONS(5518),
    [anon_sym__Noreturn] = ACTIONS(5518),
    [anon_sym_noreturn] = ACTIONS(5518),
    [anon_sym_mutable] = ACTIONS(5518),
    [anon_sym_constinit] = ACTIONS(5518),
    [anon_sym_consteval] = ACTIONS(5518),
    [anon_sym_PROGMEM] = ACTIONS(5518),
    [aux_sym_primitive_type_token1] = ACTIONS(5518),
    [anon_sym_byte] = ACTIONS(5518),
    [anon_sym_word] = ACTIONS(5518),
    [anon_sym_enum] = ACTIONS(5518),
    [anon_sym_class] = ACTIONS(5518),
    [anon_sym_struct] = ACTIONS(5518),
    [anon_sym_union] = ACTIONS(5518),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5518),
    [anon_sym_decltype] = ACTIONS(5518),
    [anon_sym_virtual] = ACTIONS(5518),
    [anon_sym_alignas] = ACTIONS(5518),
    [anon_sym_explicit] = ACTIONS(5518),
    [anon_sym_typename] = ACTIONS(5518),
    [anon_sym_template] = ACTIONS(5518),
    [anon_sym_operator] = ACTIONS(5518),
    [anon_sym_friend] = ACTIONS(5518),
    [anon_sym_public] = ACTIONS(5518),
    [anon_sym_private] = ACTIONS(5518),
    [anon_sym_protected] = ACTIONS(5518),
    [anon_sym_using] = ACTIONS(5518),
    [anon_sym_static_assert] = ACTIONS(5518),
  },
  [2488] = {
    [sym_identifier] = ACTIONS(5518),
    [aux_sym_preproc_def_token1] = ACTIONS(5518),
    [aux_sym_preproc_if_token1] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5518),
    [sym_preproc_directive] = ACTIONS(5518),
    [anon_sym_LPAREN2] = ACTIONS(5520),
    [anon_sym_TILDE] = ACTIONS(5520),
    [anon_sym_STAR] = ACTIONS(5520),
    [anon_sym_AMP_AMP] = ACTIONS(5520),
    [anon_sym_AMP] = ACTIONS(5518),
    [anon_sym___extension__] = ACTIONS(5518),
    [anon_sym_typedef] = ACTIONS(5518),
    [anon_sym_extern] = ACTIONS(5518),
    [anon_sym___attribute__] = ACTIONS(5518),
    [anon_sym_COLON_COLON] = ACTIONS(5520),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5520),
    [anon_sym___declspec] = ACTIONS(5518),
    [anon_sym___based] = ACTIONS(5518),
    [anon_sym_RBRACE] = ACTIONS(5520),
    [anon_sym_signed] = ACTIONS(5518),
    [anon_sym_unsigned] = ACTIONS(5518),
    [anon_sym_long] = ACTIONS(5518),
    [anon_sym_short] = ACTIONS(5518),
    [anon_sym_LBRACK] = ACTIONS(5518),
    [anon_sym_static] = ACTIONS(5518),
    [anon_sym_register] = ACTIONS(5518),
    [anon_sym_inline] = ACTIONS(5518),
    [anon_sym___inline] = ACTIONS(5518),
    [anon_sym___inline__] = ACTIONS(5518),
    [anon_sym___forceinline] = ACTIONS(5518),
    [anon_sym_thread_local] = ACTIONS(5518),
    [anon_sym___thread] = ACTIONS(5518),
    [anon_sym_const] = ACTIONS(5518),
    [anon_sym_constexpr] = ACTIONS(5518),
    [anon_sym_volatile] = ACTIONS(5518),
    [anon_sym_restrict] = ACTIONS(5518),
    [anon_sym___restrict__] = ACTIONS(5518),
    [anon_sym__Atomic] = ACTIONS(5518),
    [anon_sym__Noreturn] = ACTIONS(5518),
    [anon_sym_noreturn] = ACTIONS(5518),
    [anon_sym_mutable] = ACTIONS(5518),
    [anon_sym_constinit] = ACTIONS(5518),
    [anon_sym_consteval] = ACTIONS(5518),
    [anon_sym_PROGMEM] = ACTIONS(5518),
    [aux_sym_primitive_type_token1] = ACTIONS(5518),
    [anon_sym_byte] = ACTIONS(5518),
    [anon_sym_word] = ACTIONS(5518),
    [anon_sym_enum] = ACTIONS(5518),
    [anon_sym_class] = ACTIONS(5518),
    [anon_sym_struct] = ACTIONS(5518),
    [anon_sym_union] = ACTIONS(5518),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5518),
    [anon_sym_decltype] = ACTIONS(5518),
    [anon_sym_virtual] = ACTIONS(5518),
    [anon_sym_alignas] = ACTIONS(5518),
    [anon_sym_explicit] = ACTIONS(5518),
    [anon_sym_typename] = ACTIONS(5518),
    [anon_sym_template] = ACTIONS(5518),
    [anon_sym_operator] = ACTIONS(5518),
    [anon_sym_friend] = ACTIONS(5518),
    [anon_sym_public] = ACTIONS(5518),
    [anon_sym_private] = ACTIONS(5518),
    [anon_sym_protected] = ACTIONS(5518),
    [anon_sym_using] = ACTIONS(5518),
    [anon_sym_static_assert] = ACTIONS(5518),
  },
  [2489] = {
    [sym_identifier] = ACTIONS(3346),
    [aux_sym_preproc_def_token1] = ACTIONS(3346),
    [aux_sym_preproc_if_token1] = ACTIONS(3346),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3346),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3346),
    [sym_preproc_directive] = ACTIONS(3346),
    [anon_sym_LPAREN2] = ACTIONS(3348),
    [anon_sym_TILDE] = ACTIONS(3348),
    [anon_sym_STAR] = ACTIONS(3348),
    [anon_sym_AMP_AMP] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym___extension__] = ACTIONS(3346),
    [anon_sym_typedef] = ACTIONS(3346),
    [anon_sym_extern] = ACTIONS(3346),
    [anon_sym___attribute__] = ACTIONS(3346),
    [anon_sym_COLON_COLON] = ACTIONS(3348),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3348),
    [anon_sym___declspec] = ACTIONS(3346),
    [anon_sym___based] = ACTIONS(3346),
    [anon_sym_RBRACE] = ACTIONS(3348),
    [anon_sym_signed] = ACTIONS(3346),
    [anon_sym_unsigned] = ACTIONS(3346),
    [anon_sym_long] = ACTIONS(3346),
    [anon_sym_short] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3346),
    [anon_sym_register] = ACTIONS(3346),
    [anon_sym_inline] = ACTIONS(3346),
    [anon_sym___inline] = ACTIONS(3346),
    [anon_sym___inline__] = ACTIONS(3346),
    [anon_sym___forceinline] = ACTIONS(3346),
    [anon_sym_thread_local] = ACTIONS(3346),
    [anon_sym___thread] = ACTIONS(3346),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_constexpr] = ACTIONS(3346),
    [anon_sym_volatile] = ACTIONS(3346),
    [anon_sym_restrict] = ACTIONS(3346),
    [anon_sym___restrict__] = ACTIONS(3346),
    [anon_sym__Atomic] = ACTIONS(3346),
    [anon_sym__Noreturn] = ACTIONS(3346),
    [anon_sym_noreturn] = ACTIONS(3346),
    [anon_sym_mutable] = ACTIONS(3346),
    [anon_sym_constinit] = ACTIONS(3346),
    [anon_sym_consteval] = ACTIONS(3346),
    [anon_sym_PROGMEM] = ACTIONS(3346),
    [aux_sym_primitive_type_token1] = ACTIONS(3346),
    [anon_sym_byte] = ACTIONS(3346),
    [anon_sym_word] = ACTIONS(3346),
    [anon_sym_enum] = ACTIONS(3346),
    [anon_sym_class] = ACTIONS(3346),
    [anon_sym_struct] = ACTIONS(3346),
    [anon_sym_union] = ACTIONS(3346),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3346),
    [anon_sym_decltype] = ACTIONS(3346),
    [anon_sym_virtual] = ACTIONS(3346),
    [anon_sym_alignas] = ACTIONS(3346),
    [anon_sym_explicit] = ACTIONS(3346),
    [anon_sym_typename] = ACTIONS(3346),
    [anon_sym_template] = ACTIONS(3346),
    [anon_sym_operator] = ACTIONS(3346),
    [anon_sym_friend] = ACTIONS(3346),
    [anon_sym_public] = ACTIONS(3346),
    [anon_sym_private] = ACTIONS(3346),
    [anon_sym_protected] = ACTIONS(3346),
    [anon_sym_using] = ACTIONS(3346),
    [anon_sym_static_assert] = ACTIONS(3346),
  },
  [2490] = {
    [sym_string_literal] = STATE(2490),
    [sym_raw_string_literal] = STATE(2490),
    [aux_sym_concatenated_string_repeat1] = STATE(2490),
    [sym_identifier] = ACTIONS(5924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5373),
    [anon_sym_COMMA] = ACTIONS(5373),
    [anon_sym_LPAREN2] = ACTIONS(5373),
    [anon_sym_DASH] = ACTIONS(5375),
    [anon_sym_PLUS] = ACTIONS(5375),
    [anon_sym_STAR] = ACTIONS(5375),
    [anon_sym_SLASH] = ACTIONS(5375),
    [anon_sym_PERCENT] = ACTIONS(5375),
    [anon_sym_PIPE_PIPE] = ACTIONS(5373),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_PIPE] = ACTIONS(5375),
    [anon_sym_CARET] = ACTIONS(5375),
    [anon_sym_AMP] = ACTIONS(5375),
    [anon_sym_EQ_EQ] = ACTIONS(5373),
    [anon_sym_BANG_EQ] = ACTIONS(5373),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5373),
    [anon_sym_LT_EQ] = ACTIONS(5375),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_LT] = ACTIONS(5375),
    [anon_sym_GT_GT] = ACTIONS(5375),
    [anon_sym_SEMI] = ACTIONS(5373),
    [anon_sym___attribute__] = ACTIONS(5375),
    [anon_sym_LBRACK] = ACTIONS(5373),
    [anon_sym_EQ] = ACTIONS(5375),
    [anon_sym_QMARK] = ACTIONS(5373),
    [anon_sym_STAR_EQ] = ACTIONS(5373),
    [anon_sym_SLASH_EQ] = ACTIONS(5373),
    [anon_sym_PERCENT_EQ] = ACTIONS(5373),
    [anon_sym_PLUS_EQ] = ACTIONS(5373),
    [anon_sym_DASH_EQ] = ACTIONS(5373),
    [anon_sym_LT_LT_EQ] = ACTIONS(5373),
    [anon_sym_GT_GT_EQ] = ACTIONS(5373),
    [anon_sym_AMP_EQ] = ACTIONS(5373),
    [anon_sym_CARET_EQ] = ACTIONS(5373),
    [anon_sym_PIPE_EQ] = ACTIONS(5373),
    [anon_sym_and_eq] = ACTIONS(5375),
    [anon_sym_or_eq] = ACTIONS(5375),
    [anon_sym_xor_eq] = ACTIONS(5375),
    [anon_sym_LT_EQ_GT] = ACTIONS(5373),
    [anon_sym_or] = ACTIONS(5375),
    [anon_sym_and] = ACTIONS(5375),
    [anon_sym_bitor] = ACTIONS(5375),
    [anon_sym_xor] = ACTIONS(5375),
    [anon_sym_bitand] = ACTIONS(5375),
    [anon_sym_not_eq] = ACTIONS(5375),
    [anon_sym_DASH_DASH] = ACTIONS(5373),
    [anon_sym_PLUS_PLUS] = ACTIONS(5373),
    [anon_sym_DOT] = ACTIONS(5375),
    [anon_sym_DOT_STAR] = ACTIONS(5373),
    [anon_sym_DASH_GT] = ACTIONS(5373),
    [anon_sym_L_DQUOTE] = ACTIONS(5927),
    [anon_sym_u_DQUOTE] = ACTIONS(5927),
    [anon_sym_U_DQUOTE] = ACTIONS(5927),
    [anon_sym_u8_DQUOTE] = ACTIONS(5927),
    [anon_sym_DQUOTE] = ACTIONS(5927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5930),
    [anon_sym_LR_DQUOTE] = ACTIONS(5930),
    [anon_sym_uR_DQUOTE] = ACTIONS(5930),
    [anon_sym_UR_DQUOTE] = ACTIONS(5930),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5930),
    [sym_literal_suffix] = ACTIONS(5375),
  },
  [2491] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym_RBRACE] = ACTIONS(3084),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(3082),
    [anon_sym_private] = ACTIONS(3082),
    [anon_sym_protected] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
  },
  [2492] = {
    [sym_identifier] = ACTIONS(3178),
    [aux_sym_preproc_def_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3178),
    [sym_preproc_directive] = ACTIONS(3178),
    [anon_sym_LPAREN2] = ACTIONS(3180),
    [anon_sym_TILDE] = ACTIONS(3180),
    [anon_sym_STAR] = ACTIONS(3180),
    [anon_sym_AMP_AMP] = ACTIONS(3180),
    [anon_sym_AMP] = ACTIONS(3178),
    [anon_sym___extension__] = ACTIONS(3178),
    [anon_sym_typedef] = ACTIONS(3178),
    [anon_sym_extern] = ACTIONS(3178),
    [anon_sym___attribute__] = ACTIONS(3178),
    [anon_sym_COLON_COLON] = ACTIONS(3180),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3180),
    [anon_sym___declspec] = ACTIONS(3178),
    [anon_sym___based] = ACTIONS(3178),
    [anon_sym_RBRACE] = ACTIONS(3180),
    [anon_sym_signed] = ACTIONS(3178),
    [anon_sym_unsigned] = ACTIONS(3178),
    [anon_sym_long] = ACTIONS(3178),
    [anon_sym_short] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_static] = ACTIONS(3178),
    [anon_sym_register] = ACTIONS(3178),
    [anon_sym_inline] = ACTIONS(3178),
    [anon_sym___inline] = ACTIONS(3178),
    [anon_sym___inline__] = ACTIONS(3178),
    [anon_sym___forceinline] = ACTIONS(3178),
    [anon_sym_thread_local] = ACTIONS(3178),
    [anon_sym___thread] = ACTIONS(3178),
    [anon_sym_const] = ACTIONS(3178),
    [anon_sym_constexpr] = ACTIONS(3178),
    [anon_sym_volatile] = ACTIONS(3178),
    [anon_sym_restrict] = ACTIONS(3178),
    [anon_sym___restrict__] = ACTIONS(3178),
    [anon_sym__Atomic] = ACTIONS(3178),
    [anon_sym__Noreturn] = ACTIONS(3178),
    [anon_sym_noreturn] = ACTIONS(3178),
    [anon_sym_mutable] = ACTIONS(3178),
    [anon_sym_constinit] = ACTIONS(3178),
    [anon_sym_consteval] = ACTIONS(3178),
    [anon_sym_PROGMEM] = ACTIONS(3178),
    [aux_sym_primitive_type_token1] = ACTIONS(3178),
    [anon_sym_byte] = ACTIONS(3178),
    [anon_sym_word] = ACTIONS(3178),
    [anon_sym_enum] = ACTIONS(3178),
    [anon_sym_class] = ACTIONS(3178),
    [anon_sym_struct] = ACTIONS(3178),
    [anon_sym_union] = ACTIONS(3178),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3178),
    [anon_sym_decltype] = ACTIONS(3178),
    [anon_sym_virtual] = ACTIONS(3178),
    [anon_sym_alignas] = ACTIONS(3178),
    [anon_sym_explicit] = ACTIONS(3178),
    [anon_sym_typename] = ACTIONS(3178),
    [anon_sym_template] = ACTIONS(3178),
    [anon_sym_operator] = ACTIONS(3178),
    [anon_sym_friend] = ACTIONS(3178),
    [anon_sym_public] = ACTIONS(3178),
    [anon_sym_private] = ACTIONS(3178),
    [anon_sym_protected] = ACTIONS(3178),
    [anon_sym_using] = ACTIONS(3178),
    [anon_sym_static_assert] = ACTIONS(3178),
  },
  [2493] = {
    [sym_identifier] = ACTIONS(3186),
    [aux_sym_preproc_def_token1] = ACTIONS(3186),
    [aux_sym_preproc_if_token1] = ACTIONS(3186),
    [aux_sym_preproc_if_token2] = ACTIONS(3186),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3186),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3186),
    [sym_preproc_directive] = ACTIONS(3186),
    [anon_sym_LPAREN2] = ACTIONS(3188),
    [anon_sym_TILDE] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(3188),
    [anon_sym_AMP_AMP] = ACTIONS(3188),
    [anon_sym_AMP] = ACTIONS(3186),
    [anon_sym___extension__] = ACTIONS(3186),
    [anon_sym_typedef] = ACTIONS(3186),
    [anon_sym_extern] = ACTIONS(3186),
    [anon_sym___attribute__] = ACTIONS(3186),
    [anon_sym_COLON_COLON] = ACTIONS(3188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3188),
    [anon_sym___declspec] = ACTIONS(3186),
    [anon_sym___based] = ACTIONS(3186),
    [anon_sym_signed] = ACTIONS(3186),
    [anon_sym_unsigned] = ACTIONS(3186),
    [anon_sym_long] = ACTIONS(3186),
    [anon_sym_short] = ACTIONS(3186),
    [anon_sym_LBRACK] = ACTIONS(3186),
    [anon_sym_static] = ACTIONS(3186),
    [anon_sym_register] = ACTIONS(3186),
    [anon_sym_inline] = ACTIONS(3186),
    [anon_sym___inline] = ACTIONS(3186),
    [anon_sym___inline__] = ACTIONS(3186),
    [anon_sym___forceinline] = ACTIONS(3186),
    [anon_sym_thread_local] = ACTIONS(3186),
    [anon_sym___thread] = ACTIONS(3186),
    [anon_sym_const] = ACTIONS(3186),
    [anon_sym_constexpr] = ACTIONS(3186),
    [anon_sym_volatile] = ACTIONS(3186),
    [anon_sym_restrict] = ACTIONS(3186),
    [anon_sym___restrict__] = ACTIONS(3186),
    [anon_sym__Atomic] = ACTIONS(3186),
    [anon_sym__Noreturn] = ACTIONS(3186),
    [anon_sym_noreturn] = ACTIONS(3186),
    [anon_sym_mutable] = ACTIONS(3186),
    [anon_sym_constinit] = ACTIONS(3186),
    [anon_sym_consteval] = ACTIONS(3186),
    [anon_sym_PROGMEM] = ACTIONS(3186),
    [aux_sym_primitive_type_token1] = ACTIONS(3186),
    [anon_sym_byte] = ACTIONS(3186),
    [anon_sym_word] = ACTIONS(3186),
    [anon_sym_enum] = ACTIONS(3186),
    [anon_sym_class] = ACTIONS(3186),
    [anon_sym_struct] = ACTIONS(3186),
    [anon_sym_union] = ACTIONS(3186),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3186),
    [anon_sym_decltype] = ACTIONS(3186),
    [anon_sym_virtual] = ACTIONS(3186),
    [anon_sym_alignas] = ACTIONS(3186),
    [anon_sym_explicit] = ACTIONS(3186),
    [anon_sym_typename] = ACTIONS(3186),
    [anon_sym_template] = ACTIONS(3186),
    [anon_sym_operator] = ACTIONS(3186),
    [anon_sym_friend] = ACTIONS(3186),
    [anon_sym_public] = ACTIONS(3186),
    [anon_sym_private] = ACTIONS(3186),
    [anon_sym_protected] = ACTIONS(3186),
    [anon_sym_using] = ACTIONS(3186),
    [anon_sym_static_assert] = ACTIONS(3186),
  },
  [2494] = {
    [sym_identifier] = ACTIONS(5574),
    [aux_sym_preproc_def_token1] = ACTIONS(5574),
    [aux_sym_preproc_if_token1] = ACTIONS(5574),
    [aux_sym_preproc_if_token2] = ACTIONS(5574),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5574),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5574),
    [sym_preproc_directive] = ACTIONS(5574),
    [anon_sym_LPAREN2] = ACTIONS(5576),
    [anon_sym_TILDE] = ACTIONS(5576),
    [anon_sym_STAR] = ACTIONS(5576),
    [anon_sym_AMP_AMP] = ACTIONS(5576),
    [anon_sym_AMP] = ACTIONS(5574),
    [anon_sym___extension__] = ACTIONS(5574),
    [anon_sym_typedef] = ACTIONS(5574),
    [anon_sym_extern] = ACTIONS(5574),
    [anon_sym___attribute__] = ACTIONS(5574),
    [anon_sym_COLON_COLON] = ACTIONS(5576),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5576),
    [anon_sym___declspec] = ACTIONS(5574),
    [anon_sym___based] = ACTIONS(5574),
    [anon_sym_signed] = ACTIONS(5574),
    [anon_sym_unsigned] = ACTIONS(5574),
    [anon_sym_long] = ACTIONS(5574),
    [anon_sym_short] = ACTIONS(5574),
    [anon_sym_LBRACK] = ACTIONS(5574),
    [anon_sym_static] = ACTIONS(5574),
    [anon_sym_register] = ACTIONS(5574),
    [anon_sym_inline] = ACTIONS(5574),
    [anon_sym___inline] = ACTIONS(5574),
    [anon_sym___inline__] = ACTIONS(5574),
    [anon_sym___forceinline] = ACTIONS(5574),
    [anon_sym_thread_local] = ACTIONS(5574),
    [anon_sym___thread] = ACTIONS(5574),
    [anon_sym_const] = ACTIONS(5574),
    [anon_sym_constexpr] = ACTIONS(5574),
    [anon_sym_volatile] = ACTIONS(5574),
    [anon_sym_restrict] = ACTIONS(5574),
    [anon_sym___restrict__] = ACTIONS(5574),
    [anon_sym__Atomic] = ACTIONS(5574),
    [anon_sym__Noreturn] = ACTIONS(5574),
    [anon_sym_noreturn] = ACTIONS(5574),
    [anon_sym_mutable] = ACTIONS(5574),
    [anon_sym_constinit] = ACTIONS(5574),
    [anon_sym_consteval] = ACTIONS(5574),
    [anon_sym_PROGMEM] = ACTIONS(5574),
    [aux_sym_primitive_type_token1] = ACTIONS(5574),
    [anon_sym_byte] = ACTIONS(5574),
    [anon_sym_word] = ACTIONS(5574),
    [anon_sym_enum] = ACTIONS(5574),
    [anon_sym_class] = ACTIONS(5574),
    [anon_sym_struct] = ACTIONS(5574),
    [anon_sym_union] = ACTIONS(5574),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5574),
    [anon_sym_decltype] = ACTIONS(5574),
    [anon_sym_virtual] = ACTIONS(5574),
    [anon_sym_alignas] = ACTIONS(5574),
    [anon_sym_explicit] = ACTIONS(5574),
    [anon_sym_typename] = ACTIONS(5574),
    [anon_sym_template] = ACTIONS(5574),
    [anon_sym_operator] = ACTIONS(5574),
    [anon_sym_friend] = ACTIONS(5574),
    [anon_sym_public] = ACTIONS(5574),
    [anon_sym_private] = ACTIONS(5574),
    [anon_sym_protected] = ACTIONS(5574),
    [anon_sym_using] = ACTIONS(5574),
    [anon_sym_static_assert] = ACTIONS(5574),
  },
  [2495] = {
    [sym_identifier] = ACTIONS(3419),
    [aux_sym_preproc_def_token1] = ACTIONS(3419),
    [aux_sym_preproc_if_token1] = ACTIONS(3419),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3419),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3419),
    [sym_preproc_directive] = ACTIONS(3419),
    [anon_sym_LPAREN2] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym___extension__] = ACTIONS(3419),
    [anon_sym_typedef] = ACTIONS(3419),
    [anon_sym_extern] = ACTIONS(3419),
    [anon_sym___attribute__] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3421),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3421),
    [anon_sym___declspec] = ACTIONS(3419),
    [anon_sym___based] = ACTIONS(3419),
    [anon_sym_RBRACE] = ACTIONS(3421),
    [anon_sym_signed] = ACTIONS(3419),
    [anon_sym_unsigned] = ACTIONS(3419),
    [anon_sym_long] = ACTIONS(3419),
    [anon_sym_short] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_register] = ACTIONS(3419),
    [anon_sym_inline] = ACTIONS(3419),
    [anon_sym___inline] = ACTIONS(3419),
    [anon_sym___inline__] = ACTIONS(3419),
    [anon_sym___forceinline] = ACTIONS(3419),
    [anon_sym_thread_local] = ACTIONS(3419),
    [anon_sym___thread] = ACTIONS(3419),
    [anon_sym_const] = ACTIONS(3419),
    [anon_sym_constexpr] = ACTIONS(3419),
    [anon_sym_volatile] = ACTIONS(3419),
    [anon_sym_restrict] = ACTIONS(3419),
    [anon_sym___restrict__] = ACTIONS(3419),
    [anon_sym__Atomic] = ACTIONS(3419),
    [anon_sym__Noreturn] = ACTIONS(3419),
    [anon_sym_noreturn] = ACTIONS(3419),
    [anon_sym_mutable] = ACTIONS(3419),
    [anon_sym_constinit] = ACTIONS(3419),
    [anon_sym_consteval] = ACTIONS(3419),
    [anon_sym_PROGMEM] = ACTIONS(3419),
    [aux_sym_primitive_type_token1] = ACTIONS(3419),
    [anon_sym_byte] = ACTIONS(3419),
    [anon_sym_word] = ACTIONS(3419),
    [anon_sym_enum] = ACTIONS(3419),
    [anon_sym_class] = ACTIONS(3419),
    [anon_sym_struct] = ACTIONS(3419),
    [anon_sym_union] = ACTIONS(3419),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3419),
    [anon_sym_decltype] = ACTIONS(3419),
    [anon_sym_virtual] = ACTIONS(3419),
    [anon_sym_alignas] = ACTIONS(3419),
    [anon_sym_explicit] = ACTIONS(3419),
    [anon_sym_typename] = ACTIONS(3419),
    [anon_sym_template] = ACTIONS(3419),
    [anon_sym_operator] = ACTIONS(3419),
    [anon_sym_friend] = ACTIONS(3419),
    [anon_sym_public] = ACTIONS(3419),
    [anon_sym_private] = ACTIONS(3419),
    [anon_sym_protected] = ACTIONS(3419),
    [anon_sym_using] = ACTIONS(3419),
    [anon_sym_static_assert] = ACTIONS(3419),
  },
  [2496] = {
    [sym_identifier] = ACTIONS(3435),
    [aux_sym_preproc_def_token1] = ACTIONS(3435),
    [aux_sym_preproc_if_token1] = ACTIONS(3435),
    [aux_sym_preproc_if_token2] = ACTIONS(3435),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3435),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3435),
    [sym_preproc_directive] = ACTIONS(3435),
    [anon_sym_LPAREN2] = ACTIONS(3437),
    [anon_sym_TILDE] = ACTIONS(3437),
    [anon_sym_STAR] = ACTIONS(3437),
    [anon_sym_AMP_AMP] = ACTIONS(3437),
    [anon_sym_AMP] = ACTIONS(3435),
    [anon_sym___extension__] = ACTIONS(3435),
    [anon_sym_typedef] = ACTIONS(3435),
    [anon_sym_extern] = ACTIONS(3435),
    [anon_sym___attribute__] = ACTIONS(3435),
    [anon_sym_COLON_COLON] = ACTIONS(3437),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3437),
    [anon_sym___declspec] = ACTIONS(3435),
    [anon_sym___based] = ACTIONS(3435),
    [anon_sym_signed] = ACTIONS(3435),
    [anon_sym_unsigned] = ACTIONS(3435),
    [anon_sym_long] = ACTIONS(3435),
    [anon_sym_short] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3435),
    [anon_sym_static] = ACTIONS(3435),
    [anon_sym_register] = ACTIONS(3435),
    [anon_sym_inline] = ACTIONS(3435),
    [anon_sym___inline] = ACTIONS(3435),
    [anon_sym___inline__] = ACTIONS(3435),
    [anon_sym___forceinline] = ACTIONS(3435),
    [anon_sym_thread_local] = ACTIONS(3435),
    [anon_sym___thread] = ACTIONS(3435),
    [anon_sym_const] = ACTIONS(3435),
    [anon_sym_constexpr] = ACTIONS(3435),
    [anon_sym_volatile] = ACTIONS(3435),
    [anon_sym_restrict] = ACTIONS(3435),
    [anon_sym___restrict__] = ACTIONS(3435),
    [anon_sym__Atomic] = ACTIONS(3435),
    [anon_sym__Noreturn] = ACTIONS(3435),
    [anon_sym_noreturn] = ACTIONS(3435),
    [anon_sym_mutable] = ACTIONS(3435),
    [anon_sym_constinit] = ACTIONS(3435),
    [anon_sym_consteval] = ACTIONS(3435),
    [anon_sym_PROGMEM] = ACTIONS(3435),
    [aux_sym_primitive_type_token1] = ACTIONS(3435),
    [anon_sym_byte] = ACTIONS(3435),
    [anon_sym_word] = ACTIONS(3435),
    [anon_sym_enum] = ACTIONS(3435),
    [anon_sym_class] = ACTIONS(3435),
    [anon_sym_struct] = ACTIONS(3435),
    [anon_sym_union] = ACTIONS(3435),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3435),
    [anon_sym_decltype] = ACTIONS(3435),
    [anon_sym_virtual] = ACTIONS(3435),
    [anon_sym_alignas] = ACTIONS(3435),
    [anon_sym_explicit] = ACTIONS(3435),
    [anon_sym_typename] = ACTIONS(3435),
    [anon_sym_template] = ACTIONS(3435),
    [anon_sym_operator] = ACTIONS(3435),
    [anon_sym_friend] = ACTIONS(3435),
    [anon_sym_public] = ACTIONS(3435),
    [anon_sym_private] = ACTIONS(3435),
    [anon_sym_protected] = ACTIONS(3435),
    [anon_sym_using] = ACTIONS(3435),
    [anon_sym_static_assert] = ACTIONS(3435),
  },
  [2497] = {
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token2] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_PROGMEM] = ACTIONS(3513),
    [aux_sym_primitive_type_token1] = ACTIONS(3513),
    [anon_sym_byte] = ACTIONS(3513),
    [anon_sym_word] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [anon_sym_virtual] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_friend] = ACTIONS(3513),
    [anon_sym_public] = ACTIONS(3513),
    [anon_sym_private] = ACTIONS(3513),
    [anon_sym_protected] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
  },
  [2498] = {
    [sym_identifier] = ACTIONS(3439),
    [aux_sym_preproc_def_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token2] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3439),
    [sym_preproc_directive] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3439),
    [anon_sym___extension__] = ACTIONS(3439),
    [anon_sym_typedef] = ACTIONS(3439),
    [anon_sym_extern] = ACTIONS(3439),
    [anon_sym___attribute__] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3441),
    [anon_sym___declspec] = ACTIONS(3439),
    [anon_sym___based] = ACTIONS(3439),
    [anon_sym_signed] = ACTIONS(3439),
    [anon_sym_unsigned] = ACTIONS(3439),
    [anon_sym_long] = ACTIONS(3439),
    [anon_sym_short] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_register] = ACTIONS(3439),
    [anon_sym_inline] = ACTIONS(3439),
    [anon_sym___inline] = ACTIONS(3439),
    [anon_sym___inline__] = ACTIONS(3439),
    [anon_sym___forceinline] = ACTIONS(3439),
    [anon_sym_thread_local] = ACTIONS(3439),
    [anon_sym___thread] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_constexpr] = ACTIONS(3439),
    [anon_sym_volatile] = ACTIONS(3439),
    [anon_sym_restrict] = ACTIONS(3439),
    [anon_sym___restrict__] = ACTIONS(3439),
    [anon_sym__Atomic] = ACTIONS(3439),
    [anon_sym__Noreturn] = ACTIONS(3439),
    [anon_sym_noreturn] = ACTIONS(3439),
    [anon_sym_mutable] = ACTIONS(3439),
    [anon_sym_constinit] = ACTIONS(3439),
    [anon_sym_consteval] = ACTIONS(3439),
    [anon_sym_PROGMEM] = ACTIONS(3439),
    [aux_sym_primitive_type_token1] = ACTIONS(3439),
    [anon_sym_byte] = ACTIONS(3439),
    [anon_sym_word] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_struct] = ACTIONS(3439),
    [anon_sym_union] = ACTIONS(3439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3439),
    [anon_sym_decltype] = ACTIONS(3439),
    [anon_sym_virtual] = ACTIONS(3439),
    [anon_sym_alignas] = ACTIONS(3439),
    [anon_sym_explicit] = ACTIONS(3439),
    [anon_sym_typename] = ACTIONS(3439),
    [anon_sym_template] = ACTIONS(3439),
    [anon_sym_operator] = ACTIONS(3439),
    [anon_sym_friend] = ACTIONS(3439),
    [anon_sym_public] = ACTIONS(3439),
    [anon_sym_private] = ACTIONS(3439),
    [anon_sym_protected] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_static_assert] = ACTIONS(3439),
  },
  [2499] = {
    [sym_identifier] = ACTIONS(3443),
    [aux_sym_preproc_def_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token2] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3443),
    [sym_preproc_directive] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_AMP_AMP] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym___extension__] = ACTIONS(3443),
    [anon_sym_typedef] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym___attribute__] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3445),
    [anon_sym___declspec] = ACTIONS(3443),
    [anon_sym___based] = ACTIONS(3443),
    [anon_sym_signed] = ACTIONS(3443),
    [anon_sym_unsigned] = ACTIONS(3443),
    [anon_sym_long] = ACTIONS(3443),
    [anon_sym_short] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_register] = ACTIONS(3443),
    [anon_sym_inline] = ACTIONS(3443),
    [anon_sym___inline] = ACTIONS(3443),
    [anon_sym___inline__] = ACTIONS(3443),
    [anon_sym___forceinline] = ACTIONS(3443),
    [anon_sym_thread_local] = ACTIONS(3443),
    [anon_sym___thread] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_constexpr] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_restrict] = ACTIONS(3443),
    [anon_sym___restrict__] = ACTIONS(3443),
    [anon_sym__Atomic] = ACTIONS(3443),
    [anon_sym__Noreturn] = ACTIONS(3443),
    [anon_sym_noreturn] = ACTIONS(3443),
    [anon_sym_mutable] = ACTIONS(3443),
    [anon_sym_constinit] = ACTIONS(3443),
    [anon_sym_consteval] = ACTIONS(3443),
    [anon_sym_PROGMEM] = ACTIONS(3443),
    [aux_sym_primitive_type_token1] = ACTIONS(3443),
    [anon_sym_byte] = ACTIONS(3443),
    [anon_sym_word] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_union] = ACTIONS(3443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3443),
    [anon_sym_decltype] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_alignas] = ACTIONS(3443),
    [anon_sym_explicit] = ACTIONS(3443),
    [anon_sym_typename] = ACTIONS(3443),
    [anon_sym_template] = ACTIONS(3443),
    [anon_sym_operator] = ACTIONS(3443),
    [anon_sym_friend] = ACTIONS(3443),
    [anon_sym_public] = ACTIONS(3443),
    [anon_sym_private] = ACTIONS(3443),
    [anon_sym_protected] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_static_assert] = ACTIONS(3443),
  },
  [2500] = {
    [sym_identifier] = ACTIONS(3443),
    [aux_sym_preproc_def_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token2] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3443),
    [sym_preproc_directive] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_AMP_AMP] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym___extension__] = ACTIONS(3443),
    [anon_sym_typedef] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym___attribute__] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3445),
    [anon_sym___declspec] = ACTIONS(3443),
    [anon_sym___based] = ACTIONS(3443),
    [anon_sym_signed] = ACTIONS(3443),
    [anon_sym_unsigned] = ACTIONS(3443),
    [anon_sym_long] = ACTIONS(3443),
    [anon_sym_short] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_register] = ACTIONS(3443),
    [anon_sym_inline] = ACTIONS(3443),
    [anon_sym___inline] = ACTIONS(3443),
    [anon_sym___inline__] = ACTIONS(3443),
    [anon_sym___forceinline] = ACTIONS(3443),
    [anon_sym_thread_local] = ACTIONS(3443),
    [anon_sym___thread] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_constexpr] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_restrict] = ACTIONS(3443),
    [anon_sym___restrict__] = ACTIONS(3443),
    [anon_sym__Atomic] = ACTIONS(3443),
    [anon_sym__Noreturn] = ACTIONS(3443),
    [anon_sym_noreturn] = ACTIONS(3443),
    [anon_sym_mutable] = ACTIONS(3443),
    [anon_sym_constinit] = ACTIONS(3443),
    [anon_sym_consteval] = ACTIONS(3443),
    [anon_sym_PROGMEM] = ACTIONS(3443),
    [aux_sym_primitive_type_token1] = ACTIONS(3443),
    [anon_sym_byte] = ACTIONS(3443),
    [anon_sym_word] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_union] = ACTIONS(3443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3443),
    [anon_sym_decltype] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_alignas] = ACTIONS(3443),
    [anon_sym_explicit] = ACTIONS(3443),
    [anon_sym_typename] = ACTIONS(3443),
    [anon_sym_template] = ACTIONS(3443),
    [anon_sym_operator] = ACTIONS(3443),
    [anon_sym_friend] = ACTIONS(3443),
    [anon_sym_public] = ACTIONS(3443),
    [anon_sym_private] = ACTIONS(3443),
    [anon_sym_protected] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_static_assert] = ACTIONS(3443),
  },
  [2501] = {
    [sym_identifier] = ACTIONS(3451),
    [aux_sym_preproc_def_token1] = ACTIONS(3451),
    [aux_sym_preproc_if_token1] = ACTIONS(3451),
    [aux_sym_preproc_if_token2] = ACTIONS(3451),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3451),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3451),
    [sym_preproc_directive] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3453),
    [anon_sym_TILDE] = ACTIONS(3453),
    [anon_sym_STAR] = ACTIONS(3453),
    [anon_sym_AMP_AMP] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym___extension__] = ACTIONS(3451),
    [anon_sym_typedef] = ACTIONS(3451),
    [anon_sym_extern] = ACTIONS(3451),
    [anon_sym___attribute__] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3453),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3453),
    [anon_sym___declspec] = ACTIONS(3451),
    [anon_sym___based] = ACTIONS(3451),
    [anon_sym_signed] = ACTIONS(3451),
    [anon_sym_unsigned] = ACTIONS(3451),
    [anon_sym_long] = ACTIONS(3451),
    [anon_sym_short] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_register] = ACTIONS(3451),
    [anon_sym_inline] = ACTIONS(3451),
    [anon_sym___inline] = ACTIONS(3451),
    [anon_sym___inline__] = ACTIONS(3451),
    [anon_sym___forceinline] = ACTIONS(3451),
    [anon_sym_thread_local] = ACTIONS(3451),
    [anon_sym___thread] = ACTIONS(3451),
    [anon_sym_const] = ACTIONS(3451),
    [anon_sym_constexpr] = ACTIONS(3451),
    [anon_sym_volatile] = ACTIONS(3451),
    [anon_sym_restrict] = ACTIONS(3451),
    [anon_sym___restrict__] = ACTIONS(3451),
    [anon_sym__Atomic] = ACTIONS(3451),
    [anon_sym__Noreturn] = ACTIONS(3451),
    [anon_sym_noreturn] = ACTIONS(3451),
    [anon_sym_mutable] = ACTIONS(3451),
    [anon_sym_constinit] = ACTIONS(3451),
    [anon_sym_consteval] = ACTIONS(3451),
    [anon_sym_PROGMEM] = ACTIONS(3451),
    [aux_sym_primitive_type_token1] = ACTIONS(3451),
    [anon_sym_byte] = ACTIONS(3451),
    [anon_sym_word] = ACTIONS(3451),
    [anon_sym_enum] = ACTIONS(3451),
    [anon_sym_class] = ACTIONS(3451),
    [anon_sym_struct] = ACTIONS(3451),
    [anon_sym_union] = ACTIONS(3451),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3451),
    [anon_sym_decltype] = ACTIONS(3451),
    [anon_sym_virtual] = ACTIONS(3451),
    [anon_sym_alignas] = ACTIONS(3451),
    [anon_sym_explicit] = ACTIONS(3451),
    [anon_sym_typename] = ACTIONS(3451),
    [anon_sym_template] = ACTIONS(3451),
    [anon_sym_operator] = ACTIONS(3451),
    [anon_sym_friend] = ACTIONS(3451),
    [anon_sym_public] = ACTIONS(3451),
    [anon_sym_private] = ACTIONS(3451),
    [anon_sym_protected] = ACTIONS(3451),
    [anon_sym_using] = ACTIONS(3451),
    [anon_sym_static_assert] = ACTIONS(3451),
  },
  [2502] = {
    [sym_identifier] = ACTIONS(3455),
    [aux_sym_preproc_def_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token2] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3455),
    [sym_preproc_directive] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3457),
    [anon_sym_STAR] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym___extension__] = ACTIONS(3455),
    [anon_sym_typedef] = ACTIONS(3455),
    [anon_sym_extern] = ACTIONS(3455),
    [anon_sym___attribute__] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3457),
    [anon_sym___declspec] = ACTIONS(3455),
    [anon_sym___based] = ACTIONS(3455),
    [anon_sym_signed] = ACTIONS(3455),
    [anon_sym_unsigned] = ACTIONS(3455),
    [anon_sym_long] = ACTIONS(3455),
    [anon_sym_short] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_static] = ACTIONS(3455),
    [anon_sym_register] = ACTIONS(3455),
    [anon_sym_inline] = ACTIONS(3455),
    [anon_sym___inline] = ACTIONS(3455),
    [anon_sym___inline__] = ACTIONS(3455),
    [anon_sym___forceinline] = ACTIONS(3455),
    [anon_sym_thread_local] = ACTIONS(3455),
    [anon_sym___thread] = ACTIONS(3455),
    [anon_sym_const] = ACTIONS(3455),
    [anon_sym_constexpr] = ACTIONS(3455),
    [anon_sym_volatile] = ACTIONS(3455),
    [anon_sym_restrict] = ACTIONS(3455),
    [anon_sym___restrict__] = ACTIONS(3455),
    [anon_sym__Atomic] = ACTIONS(3455),
    [anon_sym__Noreturn] = ACTIONS(3455),
    [anon_sym_noreturn] = ACTIONS(3455),
    [anon_sym_mutable] = ACTIONS(3455),
    [anon_sym_constinit] = ACTIONS(3455),
    [anon_sym_consteval] = ACTIONS(3455),
    [anon_sym_PROGMEM] = ACTIONS(3455),
    [aux_sym_primitive_type_token1] = ACTIONS(3455),
    [anon_sym_byte] = ACTIONS(3455),
    [anon_sym_word] = ACTIONS(3455),
    [anon_sym_enum] = ACTIONS(3455),
    [anon_sym_class] = ACTIONS(3455),
    [anon_sym_struct] = ACTIONS(3455),
    [anon_sym_union] = ACTIONS(3455),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3455),
    [anon_sym_decltype] = ACTIONS(3455),
    [anon_sym_virtual] = ACTIONS(3455),
    [anon_sym_alignas] = ACTIONS(3455),
    [anon_sym_explicit] = ACTIONS(3455),
    [anon_sym_typename] = ACTIONS(3455),
    [anon_sym_template] = ACTIONS(3455),
    [anon_sym_operator] = ACTIONS(3455),
    [anon_sym_friend] = ACTIONS(3455),
    [anon_sym_public] = ACTIONS(3455),
    [anon_sym_private] = ACTIONS(3455),
    [anon_sym_protected] = ACTIONS(3455),
    [anon_sym_using] = ACTIONS(3455),
    [anon_sym_static_assert] = ACTIONS(3455),
  },
  [2503] = {
    [sym_identifier] = ACTIONS(3999),
    [aux_sym_preproc_def_token1] = ACTIONS(3999),
    [aux_sym_preproc_if_token1] = ACTIONS(3999),
    [aux_sym_preproc_if_token2] = ACTIONS(3999),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3999),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3999),
    [sym_preproc_directive] = ACTIONS(3999),
    [anon_sym_LPAREN2] = ACTIONS(3997),
    [anon_sym_TILDE] = ACTIONS(3997),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_AMP] = ACTIONS(3999),
    [anon_sym___extension__] = ACTIONS(3999),
    [anon_sym_typedef] = ACTIONS(3999),
    [anon_sym_extern] = ACTIONS(3999),
    [anon_sym___attribute__] = ACTIONS(3999),
    [anon_sym_COLON_COLON] = ACTIONS(3997),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3997),
    [anon_sym___declspec] = ACTIONS(3999),
    [anon_sym___based] = ACTIONS(3999),
    [anon_sym_signed] = ACTIONS(3999),
    [anon_sym_unsigned] = ACTIONS(3999),
    [anon_sym_long] = ACTIONS(3999),
    [anon_sym_short] = ACTIONS(3999),
    [anon_sym_LBRACK] = ACTIONS(3999),
    [anon_sym_static] = ACTIONS(3999),
    [anon_sym_register] = ACTIONS(3999),
    [anon_sym_inline] = ACTIONS(3999),
    [anon_sym___inline] = ACTIONS(3999),
    [anon_sym___inline__] = ACTIONS(3999),
    [anon_sym___forceinline] = ACTIONS(3999),
    [anon_sym_thread_local] = ACTIONS(3999),
    [anon_sym___thread] = ACTIONS(3999),
    [anon_sym_const] = ACTIONS(3999),
    [anon_sym_constexpr] = ACTIONS(3999),
    [anon_sym_volatile] = ACTIONS(3999),
    [anon_sym_restrict] = ACTIONS(3999),
    [anon_sym___restrict__] = ACTIONS(3999),
    [anon_sym__Atomic] = ACTIONS(3999),
    [anon_sym__Noreturn] = ACTIONS(3999),
    [anon_sym_noreturn] = ACTIONS(3999),
    [anon_sym_mutable] = ACTIONS(3999),
    [anon_sym_constinit] = ACTIONS(3999),
    [anon_sym_consteval] = ACTIONS(3999),
    [anon_sym_PROGMEM] = ACTIONS(3999),
    [aux_sym_primitive_type_token1] = ACTIONS(3999),
    [anon_sym_byte] = ACTIONS(3999),
    [anon_sym_word] = ACTIONS(3999),
    [anon_sym_enum] = ACTIONS(3999),
    [anon_sym_class] = ACTIONS(3999),
    [anon_sym_struct] = ACTIONS(3999),
    [anon_sym_union] = ACTIONS(3999),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3999),
    [anon_sym_decltype] = ACTIONS(3999),
    [anon_sym_virtual] = ACTIONS(3999),
    [anon_sym_alignas] = ACTIONS(3999),
    [anon_sym_explicit] = ACTIONS(3999),
    [anon_sym_typename] = ACTIONS(3999),
    [anon_sym_template] = ACTIONS(3999),
    [anon_sym_operator] = ACTIONS(3999),
    [anon_sym_friend] = ACTIONS(3999),
    [anon_sym_public] = ACTIONS(3999),
    [anon_sym_private] = ACTIONS(3999),
    [anon_sym_protected] = ACTIONS(3999),
    [anon_sym_using] = ACTIONS(3999),
    [anon_sym_static_assert] = ACTIONS(3999),
  },
  [2504] = {
    [sym_identifier] = ACTIONS(3467),
    [aux_sym_preproc_def_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token2] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3467),
    [sym_preproc_directive] = ACTIONS(3467),
    [anon_sym_LPAREN2] = ACTIONS(3469),
    [anon_sym_TILDE] = ACTIONS(3469),
    [anon_sym_STAR] = ACTIONS(3469),
    [anon_sym_AMP_AMP] = ACTIONS(3469),
    [anon_sym_AMP] = ACTIONS(3467),
    [anon_sym___extension__] = ACTIONS(3467),
    [anon_sym_typedef] = ACTIONS(3467),
    [anon_sym_extern] = ACTIONS(3467),
    [anon_sym___attribute__] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(3469),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3469),
    [anon_sym___declspec] = ACTIONS(3467),
    [anon_sym___based] = ACTIONS(3467),
    [anon_sym_signed] = ACTIONS(3467),
    [anon_sym_unsigned] = ACTIONS(3467),
    [anon_sym_long] = ACTIONS(3467),
    [anon_sym_short] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [anon_sym_static] = ACTIONS(3467),
    [anon_sym_register] = ACTIONS(3467),
    [anon_sym_inline] = ACTIONS(3467),
    [anon_sym___inline] = ACTIONS(3467),
    [anon_sym___inline__] = ACTIONS(3467),
    [anon_sym___forceinline] = ACTIONS(3467),
    [anon_sym_thread_local] = ACTIONS(3467),
    [anon_sym___thread] = ACTIONS(3467),
    [anon_sym_const] = ACTIONS(3467),
    [anon_sym_constexpr] = ACTIONS(3467),
    [anon_sym_volatile] = ACTIONS(3467),
    [anon_sym_restrict] = ACTIONS(3467),
    [anon_sym___restrict__] = ACTIONS(3467),
    [anon_sym__Atomic] = ACTIONS(3467),
    [anon_sym__Noreturn] = ACTIONS(3467),
    [anon_sym_noreturn] = ACTIONS(3467),
    [anon_sym_mutable] = ACTIONS(3467),
    [anon_sym_constinit] = ACTIONS(3467),
    [anon_sym_consteval] = ACTIONS(3467),
    [anon_sym_PROGMEM] = ACTIONS(3467),
    [aux_sym_primitive_type_token1] = ACTIONS(3467),
    [anon_sym_byte] = ACTIONS(3467),
    [anon_sym_word] = ACTIONS(3467),
    [anon_sym_enum] = ACTIONS(3467),
    [anon_sym_class] = ACTIONS(3467),
    [anon_sym_struct] = ACTIONS(3467),
    [anon_sym_union] = ACTIONS(3467),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3467),
    [anon_sym_decltype] = ACTIONS(3467),
    [anon_sym_virtual] = ACTIONS(3467),
    [anon_sym_alignas] = ACTIONS(3467),
    [anon_sym_explicit] = ACTIONS(3467),
    [anon_sym_typename] = ACTIONS(3467),
    [anon_sym_template] = ACTIONS(3467),
    [anon_sym_operator] = ACTIONS(3467),
    [anon_sym_friend] = ACTIONS(3467),
    [anon_sym_public] = ACTIONS(3467),
    [anon_sym_private] = ACTIONS(3467),
    [anon_sym_protected] = ACTIONS(3467),
    [anon_sym_using] = ACTIONS(3467),
    [anon_sym_static_assert] = ACTIONS(3467),
  },
  [2505] = {
    [sym_identifier] = ACTIONS(3869),
    [aux_sym_preproc_def_token1] = ACTIONS(3869),
    [aux_sym_preproc_if_token1] = ACTIONS(3869),
    [aux_sym_preproc_if_token2] = ACTIONS(3869),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3869),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3869),
    [sym_preproc_directive] = ACTIONS(3869),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3867),
    [anon_sym_STAR] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_AMP] = ACTIONS(3869),
    [anon_sym___extension__] = ACTIONS(3869),
    [anon_sym_typedef] = ACTIONS(3869),
    [anon_sym_extern] = ACTIONS(3869),
    [anon_sym___attribute__] = ACTIONS(3869),
    [anon_sym_COLON_COLON] = ACTIONS(3867),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3867),
    [anon_sym___declspec] = ACTIONS(3869),
    [anon_sym___based] = ACTIONS(3869),
    [anon_sym_signed] = ACTIONS(3869),
    [anon_sym_unsigned] = ACTIONS(3869),
    [anon_sym_long] = ACTIONS(3869),
    [anon_sym_short] = ACTIONS(3869),
    [anon_sym_LBRACK] = ACTIONS(3869),
    [anon_sym_static] = ACTIONS(3869),
    [anon_sym_register] = ACTIONS(3869),
    [anon_sym_inline] = ACTIONS(3869),
    [anon_sym___inline] = ACTIONS(3869),
    [anon_sym___inline__] = ACTIONS(3869),
    [anon_sym___forceinline] = ACTIONS(3869),
    [anon_sym_thread_local] = ACTIONS(3869),
    [anon_sym___thread] = ACTIONS(3869),
    [anon_sym_const] = ACTIONS(3869),
    [anon_sym_constexpr] = ACTIONS(3869),
    [anon_sym_volatile] = ACTIONS(3869),
    [anon_sym_restrict] = ACTIONS(3869),
    [anon_sym___restrict__] = ACTIONS(3869),
    [anon_sym__Atomic] = ACTIONS(3869),
    [anon_sym__Noreturn] = ACTIONS(3869),
    [anon_sym_noreturn] = ACTIONS(3869),
    [anon_sym_mutable] = ACTIONS(3869),
    [anon_sym_constinit] = ACTIONS(3869),
    [anon_sym_consteval] = ACTIONS(3869),
    [anon_sym_PROGMEM] = ACTIONS(3869),
    [aux_sym_primitive_type_token1] = ACTIONS(3869),
    [anon_sym_byte] = ACTIONS(3869),
    [anon_sym_word] = ACTIONS(3869),
    [anon_sym_enum] = ACTIONS(3869),
    [anon_sym_class] = ACTIONS(3869),
    [anon_sym_struct] = ACTIONS(3869),
    [anon_sym_union] = ACTIONS(3869),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3869),
    [anon_sym_decltype] = ACTIONS(3869),
    [anon_sym_virtual] = ACTIONS(3869),
    [anon_sym_alignas] = ACTIONS(3869),
    [anon_sym_explicit] = ACTIONS(3869),
    [anon_sym_typename] = ACTIONS(3869),
    [anon_sym_template] = ACTIONS(3869),
    [anon_sym_operator] = ACTIONS(3869),
    [anon_sym_friend] = ACTIONS(3869),
    [anon_sym_public] = ACTIONS(3869),
    [anon_sym_private] = ACTIONS(3869),
    [anon_sym_protected] = ACTIONS(3869),
    [anon_sym_using] = ACTIONS(3869),
    [anon_sym_static_assert] = ACTIONS(3869),
  },
  [2506] = {
    [sym_identifier] = ACTIONS(5522),
    [aux_sym_preproc_def_token1] = ACTIONS(5522),
    [aux_sym_preproc_if_token1] = ACTIONS(5522),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5522),
    [sym_preproc_directive] = ACTIONS(5522),
    [anon_sym_LPAREN2] = ACTIONS(5524),
    [anon_sym_TILDE] = ACTIONS(5524),
    [anon_sym_STAR] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5522),
    [anon_sym___extension__] = ACTIONS(5522),
    [anon_sym_typedef] = ACTIONS(5522),
    [anon_sym_extern] = ACTIONS(5522),
    [anon_sym___attribute__] = ACTIONS(5522),
    [anon_sym_COLON_COLON] = ACTIONS(5524),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5524),
    [anon_sym___declspec] = ACTIONS(5522),
    [anon_sym___based] = ACTIONS(5522),
    [anon_sym_RBRACE] = ACTIONS(5524),
    [anon_sym_signed] = ACTIONS(5522),
    [anon_sym_unsigned] = ACTIONS(5522),
    [anon_sym_long] = ACTIONS(5522),
    [anon_sym_short] = ACTIONS(5522),
    [anon_sym_LBRACK] = ACTIONS(5522),
    [anon_sym_static] = ACTIONS(5522),
    [anon_sym_register] = ACTIONS(5522),
    [anon_sym_inline] = ACTIONS(5522),
    [anon_sym___inline] = ACTIONS(5522),
    [anon_sym___inline__] = ACTIONS(5522),
    [anon_sym___forceinline] = ACTIONS(5522),
    [anon_sym_thread_local] = ACTIONS(5522),
    [anon_sym___thread] = ACTIONS(5522),
    [anon_sym_const] = ACTIONS(5522),
    [anon_sym_constexpr] = ACTIONS(5522),
    [anon_sym_volatile] = ACTIONS(5522),
    [anon_sym_restrict] = ACTIONS(5522),
    [anon_sym___restrict__] = ACTIONS(5522),
    [anon_sym__Atomic] = ACTIONS(5522),
    [anon_sym__Noreturn] = ACTIONS(5522),
    [anon_sym_noreturn] = ACTIONS(5522),
    [anon_sym_mutable] = ACTIONS(5522),
    [anon_sym_constinit] = ACTIONS(5522),
    [anon_sym_consteval] = ACTIONS(5522),
    [anon_sym_PROGMEM] = ACTIONS(5522),
    [aux_sym_primitive_type_token1] = ACTIONS(5522),
    [anon_sym_byte] = ACTIONS(5522),
    [anon_sym_word] = ACTIONS(5522),
    [anon_sym_enum] = ACTIONS(5522),
    [anon_sym_class] = ACTIONS(5522),
    [anon_sym_struct] = ACTIONS(5522),
    [anon_sym_union] = ACTIONS(5522),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5522),
    [anon_sym_decltype] = ACTIONS(5522),
    [anon_sym_virtual] = ACTIONS(5522),
    [anon_sym_alignas] = ACTIONS(5522),
    [anon_sym_explicit] = ACTIONS(5522),
    [anon_sym_typename] = ACTIONS(5522),
    [anon_sym_template] = ACTIONS(5522),
    [anon_sym_operator] = ACTIONS(5522),
    [anon_sym_friend] = ACTIONS(5522),
    [anon_sym_public] = ACTIONS(5522),
    [anon_sym_private] = ACTIONS(5522),
    [anon_sym_protected] = ACTIONS(5522),
    [anon_sym_using] = ACTIONS(5522),
    [anon_sym_static_assert] = ACTIONS(5522),
  },
  [2507] = {
    [sym_identifier] = ACTIONS(5443),
    [aux_sym_preproc_def_token1] = ACTIONS(5443),
    [aux_sym_preproc_if_token1] = ACTIONS(5443),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5443),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5443),
    [sym_preproc_directive] = ACTIONS(5443),
    [anon_sym_LPAREN2] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_STAR] = ACTIONS(5445),
    [anon_sym_AMP_AMP] = ACTIONS(5445),
    [anon_sym_AMP] = ACTIONS(5443),
    [anon_sym___extension__] = ACTIONS(5443),
    [anon_sym_typedef] = ACTIONS(5443),
    [anon_sym_extern] = ACTIONS(5443),
    [anon_sym___attribute__] = ACTIONS(5443),
    [anon_sym_COLON_COLON] = ACTIONS(5445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5445),
    [anon_sym___declspec] = ACTIONS(5443),
    [anon_sym___based] = ACTIONS(5443),
    [anon_sym_RBRACE] = ACTIONS(5445),
    [anon_sym_signed] = ACTIONS(5443),
    [anon_sym_unsigned] = ACTIONS(5443),
    [anon_sym_long] = ACTIONS(5443),
    [anon_sym_short] = ACTIONS(5443),
    [anon_sym_LBRACK] = ACTIONS(5443),
    [anon_sym_static] = ACTIONS(5443),
    [anon_sym_register] = ACTIONS(5443),
    [anon_sym_inline] = ACTIONS(5443),
    [anon_sym___inline] = ACTIONS(5443),
    [anon_sym___inline__] = ACTIONS(5443),
    [anon_sym___forceinline] = ACTIONS(5443),
    [anon_sym_thread_local] = ACTIONS(5443),
    [anon_sym___thread] = ACTIONS(5443),
    [anon_sym_const] = ACTIONS(5443),
    [anon_sym_constexpr] = ACTIONS(5443),
    [anon_sym_volatile] = ACTIONS(5443),
    [anon_sym_restrict] = ACTIONS(5443),
    [anon_sym___restrict__] = ACTIONS(5443),
    [anon_sym__Atomic] = ACTIONS(5443),
    [anon_sym__Noreturn] = ACTIONS(5443),
    [anon_sym_noreturn] = ACTIONS(5443),
    [anon_sym_mutable] = ACTIONS(5443),
    [anon_sym_constinit] = ACTIONS(5443),
    [anon_sym_consteval] = ACTIONS(5443),
    [anon_sym_PROGMEM] = ACTIONS(5443),
    [aux_sym_primitive_type_token1] = ACTIONS(5443),
    [anon_sym_byte] = ACTIONS(5443),
    [anon_sym_word] = ACTIONS(5443),
    [anon_sym_enum] = ACTIONS(5443),
    [anon_sym_class] = ACTIONS(5443),
    [anon_sym_struct] = ACTIONS(5443),
    [anon_sym_union] = ACTIONS(5443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5443),
    [anon_sym_decltype] = ACTIONS(5443),
    [anon_sym_virtual] = ACTIONS(5443),
    [anon_sym_alignas] = ACTIONS(5443),
    [anon_sym_explicit] = ACTIONS(5443),
    [anon_sym_typename] = ACTIONS(5443),
    [anon_sym_template] = ACTIONS(5443),
    [anon_sym_operator] = ACTIONS(5443),
    [anon_sym_friend] = ACTIONS(5443),
    [anon_sym_public] = ACTIONS(5443),
    [anon_sym_private] = ACTIONS(5443),
    [anon_sym_protected] = ACTIONS(5443),
    [anon_sym_using] = ACTIONS(5443),
    [anon_sym_static_assert] = ACTIONS(5443),
  },
  [2508] = {
    [sym_identifier] = ACTIONS(3475),
    [aux_sym_preproc_def_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token2] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3475),
    [sym_preproc_directive] = ACTIONS(3475),
    [anon_sym_LPAREN2] = ACTIONS(3477),
    [anon_sym_TILDE] = ACTIONS(3477),
    [anon_sym_STAR] = ACTIONS(3477),
    [anon_sym_AMP_AMP] = ACTIONS(3477),
    [anon_sym_AMP] = ACTIONS(3475),
    [anon_sym___extension__] = ACTIONS(3475),
    [anon_sym_typedef] = ACTIONS(3475),
    [anon_sym_extern] = ACTIONS(3475),
    [anon_sym___attribute__] = ACTIONS(3475),
    [anon_sym_COLON_COLON] = ACTIONS(3477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3477),
    [anon_sym___declspec] = ACTIONS(3475),
    [anon_sym___based] = ACTIONS(3475),
    [anon_sym_signed] = ACTIONS(3475),
    [anon_sym_unsigned] = ACTIONS(3475),
    [anon_sym_long] = ACTIONS(3475),
    [anon_sym_short] = ACTIONS(3475),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [anon_sym_static] = ACTIONS(3475),
    [anon_sym_register] = ACTIONS(3475),
    [anon_sym_inline] = ACTIONS(3475),
    [anon_sym___inline] = ACTIONS(3475),
    [anon_sym___inline__] = ACTIONS(3475),
    [anon_sym___forceinline] = ACTIONS(3475),
    [anon_sym_thread_local] = ACTIONS(3475),
    [anon_sym___thread] = ACTIONS(3475),
    [anon_sym_const] = ACTIONS(3475),
    [anon_sym_constexpr] = ACTIONS(3475),
    [anon_sym_volatile] = ACTIONS(3475),
    [anon_sym_restrict] = ACTIONS(3475),
    [anon_sym___restrict__] = ACTIONS(3475),
    [anon_sym__Atomic] = ACTIONS(3475),
    [anon_sym__Noreturn] = ACTIONS(3475),
    [anon_sym_noreturn] = ACTIONS(3475),
    [anon_sym_mutable] = ACTIONS(3475),
    [anon_sym_constinit] = ACTIONS(3475),
    [anon_sym_consteval] = ACTIONS(3475),
    [anon_sym_PROGMEM] = ACTIONS(3475),
    [aux_sym_primitive_type_token1] = ACTIONS(3475),
    [anon_sym_byte] = ACTIONS(3475),
    [anon_sym_word] = ACTIONS(3475),
    [anon_sym_enum] = ACTIONS(3475),
    [anon_sym_class] = ACTIONS(3475),
    [anon_sym_struct] = ACTIONS(3475),
    [anon_sym_union] = ACTIONS(3475),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3475),
    [anon_sym_decltype] = ACTIONS(3475),
    [anon_sym_virtual] = ACTIONS(3475),
    [anon_sym_alignas] = ACTIONS(3475),
    [anon_sym_explicit] = ACTIONS(3475),
    [anon_sym_typename] = ACTIONS(3475),
    [anon_sym_template] = ACTIONS(3475),
    [anon_sym_operator] = ACTIONS(3475),
    [anon_sym_friend] = ACTIONS(3475),
    [anon_sym_public] = ACTIONS(3475),
    [anon_sym_private] = ACTIONS(3475),
    [anon_sym_protected] = ACTIONS(3475),
    [anon_sym_using] = ACTIONS(3475),
    [anon_sym_static_assert] = ACTIONS(3475),
  },
  [2509] = {
    [sym_identifier] = ACTIONS(5526),
    [aux_sym_preproc_def_token1] = ACTIONS(5526),
    [aux_sym_preproc_if_token1] = ACTIONS(5526),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5526),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5526),
    [sym_preproc_directive] = ACTIONS(5526),
    [anon_sym_LPAREN2] = ACTIONS(5528),
    [anon_sym_TILDE] = ACTIONS(5528),
    [anon_sym_STAR] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5526),
    [anon_sym___extension__] = ACTIONS(5526),
    [anon_sym_typedef] = ACTIONS(5526),
    [anon_sym_extern] = ACTIONS(5526),
    [anon_sym___attribute__] = ACTIONS(5526),
    [anon_sym_COLON_COLON] = ACTIONS(5528),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5528),
    [anon_sym___declspec] = ACTIONS(5526),
    [anon_sym___based] = ACTIONS(5526),
    [anon_sym_RBRACE] = ACTIONS(5528),
    [anon_sym_signed] = ACTIONS(5526),
    [anon_sym_unsigned] = ACTIONS(5526),
    [anon_sym_long] = ACTIONS(5526),
    [anon_sym_short] = ACTIONS(5526),
    [anon_sym_LBRACK] = ACTIONS(5526),
    [anon_sym_static] = ACTIONS(5526),
    [anon_sym_register] = ACTIONS(5526),
    [anon_sym_inline] = ACTIONS(5526),
    [anon_sym___inline] = ACTIONS(5526),
    [anon_sym___inline__] = ACTIONS(5526),
    [anon_sym___forceinline] = ACTIONS(5526),
    [anon_sym_thread_local] = ACTIONS(5526),
    [anon_sym___thread] = ACTIONS(5526),
    [anon_sym_const] = ACTIONS(5526),
    [anon_sym_constexpr] = ACTIONS(5526),
    [anon_sym_volatile] = ACTIONS(5526),
    [anon_sym_restrict] = ACTIONS(5526),
    [anon_sym___restrict__] = ACTIONS(5526),
    [anon_sym__Atomic] = ACTIONS(5526),
    [anon_sym__Noreturn] = ACTIONS(5526),
    [anon_sym_noreturn] = ACTIONS(5526),
    [anon_sym_mutable] = ACTIONS(5526),
    [anon_sym_constinit] = ACTIONS(5526),
    [anon_sym_consteval] = ACTIONS(5526),
    [anon_sym_PROGMEM] = ACTIONS(5526),
    [aux_sym_primitive_type_token1] = ACTIONS(5526),
    [anon_sym_byte] = ACTIONS(5526),
    [anon_sym_word] = ACTIONS(5526),
    [anon_sym_enum] = ACTIONS(5526),
    [anon_sym_class] = ACTIONS(5526),
    [anon_sym_struct] = ACTIONS(5526),
    [anon_sym_union] = ACTIONS(5526),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5526),
    [anon_sym_decltype] = ACTIONS(5526),
    [anon_sym_virtual] = ACTIONS(5526),
    [anon_sym_alignas] = ACTIONS(5526),
    [anon_sym_explicit] = ACTIONS(5526),
    [anon_sym_typename] = ACTIONS(5526),
    [anon_sym_template] = ACTIONS(5526),
    [anon_sym_operator] = ACTIONS(5526),
    [anon_sym_friend] = ACTIONS(5526),
    [anon_sym_public] = ACTIONS(5526),
    [anon_sym_private] = ACTIONS(5526),
    [anon_sym_protected] = ACTIONS(5526),
    [anon_sym_using] = ACTIONS(5526),
    [anon_sym_static_assert] = ACTIONS(5526),
  },
  [2510] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(4471),
    [sym_raw_string_literal] = STATE(3057),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5870),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4280),
    [anon_sym_COLON] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_and_eq] = ACTIONS(4284),
    [anon_sym_or_eq] = ACTIONS(4284),
    [anon_sym_xor_eq] = ACTIONS(4284),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [2511] = {
    [sym_identifier] = ACTIONS(5507),
    [aux_sym_preproc_def_token1] = ACTIONS(5507),
    [aux_sym_preproc_if_token1] = ACTIONS(5507),
    [aux_sym_preproc_if_token2] = ACTIONS(5507),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5507),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5507),
    [sym_preproc_directive] = ACTIONS(5507),
    [anon_sym_LPAREN2] = ACTIONS(5509),
    [anon_sym_TILDE] = ACTIONS(5509),
    [anon_sym_STAR] = ACTIONS(5509),
    [anon_sym_AMP_AMP] = ACTIONS(5509),
    [anon_sym_AMP] = ACTIONS(5507),
    [anon_sym___extension__] = ACTIONS(5507),
    [anon_sym_typedef] = ACTIONS(5507),
    [anon_sym_extern] = ACTIONS(5507),
    [anon_sym___attribute__] = ACTIONS(5507),
    [anon_sym_COLON_COLON] = ACTIONS(5509),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5509),
    [anon_sym___declspec] = ACTIONS(5507),
    [anon_sym___based] = ACTIONS(5507),
    [anon_sym_signed] = ACTIONS(5507),
    [anon_sym_unsigned] = ACTIONS(5507),
    [anon_sym_long] = ACTIONS(5507),
    [anon_sym_short] = ACTIONS(5507),
    [anon_sym_LBRACK] = ACTIONS(5507),
    [anon_sym_static] = ACTIONS(5507),
    [anon_sym_register] = ACTIONS(5507),
    [anon_sym_inline] = ACTIONS(5507),
    [anon_sym___inline] = ACTIONS(5507),
    [anon_sym___inline__] = ACTIONS(5507),
    [anon_sym___forceinline] = ACTIONS(5507),
    [anon_sym_thread_local] = ACTIONS(5507),
    [anon_sym___thread] = ACTIONS(5507),
    [anon_sym_const] = ACTIONS(5507),
    [anon_sym_constexpr] = ACTIONS(5507),
    [anon_sym_volatile] = ACTIONS(5507),
    [anon_sym_restrict] = ACTIONS(5507),
    [anon_sym___restrict__] = ACTIONS(5507),
    [anon_sym__Atomic] = ACTIONS(5507),
    [anon_sym__Noreturn] = ACTIONS(5507),
    [anon_sym_noreturn] = ACTIONS(5507),
    [anon_sym_mutable] = ACTIONS(5507),
    [anon_sym_constinit] = ACTIONS(5507),
    [anon_sym_consteval] = ACTIONS(5507),
    [anon_sym_PROGMEM] = ACTIONS(5507),
    [aux_sym_primitive_type_token1] = ACTIONS(5507),
    [anon_sym_byte] = ACTIONS(5507),
    [anon_sym_word] = ACTIONS(5507),
    [anon_sym_enum] = ACTIONS(5507),
    [anon_sym_class] = ACTIONS(5507),
    [anon_sym_struct] = ACTIONS(5507),
    [anon_sym_union] = ACTIONS(5507),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5507),
    [anon_sym_decltype] = ACTIONS(5507),
    [anon_sym_virtual] = ACTIONS(5507),
    [anon_sym_alignas] = ACTIONS(5507),
    [anon_sym_explicit] = ACTIONS(5507),
    [anon_sym_typename] = ACTIONS(5507),
    [anon_sym_template] = ACTIONS(5507),
    [anon_sym_operator] = ACTIONS(5507),
    [anon_sym_friend] = ACTIONS(5507),
    [anon_sym_public] = ACTIONS(5507),
    [anon_sym_private] = ACTIONS(5507),
    [anon_sym_protected] = ACTIONS(5507),
    [anon_sym_using] = ACTIONS(5507),
    [anon_sym_static_assert] = ACTIONS(5507),
  },
  [2512] = {
    [sym_identifier] = ACTIONS(5530),
    [aux_sym_preproc_def_token1] = ACTIONS(5530),
    [aux_sym_preproc_if_token1] = ACTIONS(5530),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5530),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5530),
    [sym_preproc_directive] = ACTIONS(5530),
    [anon_sym_LPAREN2] = ACTIONS(5532),
    [anon_sym_TILDE] = ACTIONS(5532),
    [anon_sym_STAR] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5530),
    [anon_sym___extension__] = ACTIONS(5530),
    [anon_sym_typedef] = ACTIONS(5530),
    [anon_sym_extern] = ACTIONS(5530),
    [anon_sym___attribute__] = ACTIONS(5530),
    [anon_sym_COLON_COLON] = ACTIONS(5532),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5532),
    [anon_sym___declspec] = ACTIONS(5530),
    [anon_sym___based] = ACTIONS(5530),
    [anon_sym_RBRACE] = ACTIONS(5532),
    [anon_sym_signed] = ACTIONS(5530),
    [anon_sym_unsigned] = ACTIONS(5530),
    [anon_sym_long] = ACTIONS(5530),
    [anon_sym_short] = ACTIONS(5530),
    [anon_sym_LBRACK] = ACTIONS(5530),
    [anon_sym_static] = ACTIONS(5530),
    [anon_sym_register] = ACTIONS(5530),
    [anon_sym_inline] = ACTIONS(5530),
    [anon_sym___inline] = ACTIONS(5530),
    [anon_sym___inline__] = ACTIONS(5530),
    [anon_sym___forceinline] = ACTIONS(5530),
    [anon_sym_thread_local] = ACTIONS(5530),
    [anon_sym___thread] = ACTIONS(5530),
    [anon_sym_const] = ACTIONS(5530),
    [anon_sym_constexpr] = ACTIONS(5530),
    [anon_sym_volatile] = ACTIONS(5530),
    [anon_sym_restrict] = ACTIONS(5530),
    [anon_sym___restrict__] = ACTIONS(5530),
    [anon_sym__Atomic] = ACTIONS(5530),
    [anon_sym__Noreturn] = ACTIONS(5530),
    [anon_sym_noreturn] = ACTIONS(5530),
    [anon_sym_mutable] = ACTIONS(5530),
    [anon_sym_constinit] = ACTIONS(5530),
    [anon_sym_consteval] = ACTIONS(5530),
    [anon_sym_PROGMEM] = ACTIONS(5530),
    [aux_sym_primitive_type_token1] = ACTIONS(5530),
    [anon_sym_byte] = ACTIONS(5530),
    [anon_sym_word] = ACTIONS(5530),
    [anon_sym_enum] = ACTIONS(5530),
    [anon_sym_class] = ACTIONS(5530),
    [anon_sym_struct] = ACTIONS(5530),
    [anon_sym_union] = ACTIONS(5530),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5530),
    [anon_sym_decltype] = ACTIONS(5530),
    [anon_sym_virtual] = ACTIONS(5530),
    [anon_sym_alignas] = ACTIONS(5530),
    [anon_sym_explicit] = ACTIONS(5530),
    [anon_sym_typename] = ACTIONS(5530),
    [anon_sym_template] = ACTIONS(5530),
    [anon_sym_operator] = ACTIONS(5530),
    [anon_sym_friend] = ACTIONS(5530),
    [anon_sym_public] = ACTIONS(5530),
    [anon_sym_private] = ACTIONS(5530),
    [anon_sym_protected] = ACTIONS(5530),
    [anon_sym_using] = ACTIONS(5530),
    [anon_sym_static_assert] = ACTIONS(5530),
  },
  [2513] = {
    [sym_identifier] = ACTIONS(3443),
    [aux_sym_preproc_def_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3443),
    [sym_preproc_directive] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_AMP_AMP] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym___extension__] = ACTIONS(3443),
    [anon_sym_typedef] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym___attribute__] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3445),
    [anon_sym___declspec] = ACTIONS(3443),
    [anon_sym___based] = ACTIONS(3443),
    [anon_sym_RBRACE] = ACTIONS(3445),
    [anon_sym_signed] = ACTIONS(3443),
    [anon_sym_unsigned] = ACTIONS(3443),
    [anon_sym_long] = ACTIONS(3443),
    [anon_sym_short] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_register] = ACTIONS(3443),
    [anon_sym_inline] = ACTIONS(3443),
    [anon_sym___inline] = ACTIONS(3443),
    [anon_sym___inline__] = ACTIONS(3443),
    [anon_sym___forceinline] = ACTIONS(3443),
    [anon_sym_thread_local] = ACTIONS(3443),
    [anon_sym___thread] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_constexpr] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_restrict] = ACTIONS(3443),
    [anon_sym___restrict__] = ACTIONS(3443),
    [anon_sym__Atomic] = ACTIONS(3443),
    [anon_sym__Noreturn] = ACTIONS(3443),
    [anon_sym_noreturn] = ACTIONS(3443),
    [anon_sym_mutable] = ACTIONS(3443),
    [anon_sym_constinit] = ACTIONS(3443),
    [anon_sym_consteval] = ACTIONS(3443),
    [anon_sym_PROGMEM] = ACTIONS(3443),
    [aux_sym_primitive_type_token1] = ACTIONS(3443),
    [anon_sym_byte] = ACTIONS(3443),
    [anon_sym_word] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_union] = ACTIONS(3443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3443),
    [anon_sym_decltype] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_alignas] = ACTIONS(3443),
    [anon_sym_explicit] = ACTIONS(3443),
    [anon_sym_typename] = ACTIONS(3443),
    [anon_sym_template] = ACTIONS(3443),
    [anon_sym_operator] = ACTIONS(3443),
    [anon_sym_friend] = ACTIONS(3443),
    [anon_sym_public] = ACTIONS(3443),
    [anon_sym_private] = ACTIONS(3443),
    [anon_sym_protected] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_static_assert] = ACTIONS(3443),
  },
  [2514] = {
    [sym_identifier] = ACTIONS(3443),
    [aux_sym_preproc_def_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3443),
    [sym_preproc_directive] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_AMP_AMP] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym___extension__] = ACTIONS(3443),
    [anon_sym_typedef] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym___attribute__] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3445),
    [anon_sym___declspec] = ACTIONS(3443),
    [anon_sym___based] = ACTIONS(3443),
    [anon_sym_RBRACE] = ACTIONS(3445),
    [anon_sym_signed] = ACTIONS(3443),
    [anon_sym_unsigned] = ACTIONS(3443),
    [anon_sym_long] = ACTIONS(3443),
    [anon_sym_short] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_register] = ACTIONS(3443),
    [anon_sym_inline] = ACTIONS(3443),
    [anon_sym___inline] = ACTIONS(3443),
    [anon_sym___inline__] = ACTIONS(3443),
    [anon_sym___forceinline] = ACTIONS(3443),
    [anon_sym_thread_local] = ACTIONS(3443),
    [anon_sym___thread] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_constexpr] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_restrict] = ACTIONS(3443),
    [anon_sym___restrict__] = ACTIONS(3443),
    [anon_sym__Atomic] = ACTIONS(3443),
    [anon_sym__Noreturn] = ACTIONS(3443),
    [anon_sym_noreturn] = ACTIONS(3443),
    [anon_sym_mutable] = ACTIONS(3443),
    [anon_sym_constinit] = ACTIONS(3443),
    [anon_sym_consteval] = ACTIONS(3443),
    [anon_sym_PROGMEM] = ACTIONS(3443),
    [aux_sym_primitive_type_token1] = ACTIONS(3443),
    [anon_sym_byte] = ACTIONS(3443),
    [anon_sym_word] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_union] = ACTIONS(3443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3443),
    [anon_sym_decltype] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_alignas] = ACTIONS(3443),
    [anon_sym_explicit] = ACTIONS(3443),
    [anon_sym_typename] = ACTIONS(3443),
    [anon_sym_template] = ACTIONS(3443),
    [anon_sym_operator] = ACTIONS(3443),
    [anon_sym_friend] = ACTIONS(3443),
    [anon_sym_public] = ACTIONS(3443),
    [anon_sym_private] = ACTIONS(3443),
    [anon_sym_protected] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_static_assert] = ACTIONS(3443),
  },
  [2515] = {
    [sym_identifier] = ACTIONS(5526),
    [aux_sym_preproc_def_token1] = ACTIONS(5526),
    [aux_sym_preproc_if_token1] = ACTIONS(5526),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5526),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5526),
    [sym_preproc_directive] = ACTIONS(5526),
    [anon_sym_LPAREN2] = ACTIONS(5528),
    [anon_sym_TILDE] = ACTIONS(5528),
    [anon_sym_STAR] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5526),
    [anon_sym___extension__] = ACTIONS(5526),
    [anon_sym_typedef] = ACTIONS(5526),
    [anon_sym_extern] = ACTIONS(5526),
    [anon_sym___attribute__] = ACTIONS(5526),
    [anon_sym_COLON_COLON] = ACTIONS(5528),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5528),
    [anon_sym___declspec] = ACTIONS(5526),
    [anon_sym___based] = ACTIONS(5526),
    [anon_sym_RBRACE] = ACTIONS(5528),
    [anon_sym_signed] = ACTIONS(5526),
    [anon_sym_unsigned] = ACTIONS(5526),
    [anon_sym_long] = ACTIONS(5526),
    [anon_sym_short] = ACTIONS(5526),
    [anon_sym_LBRACK] = ACTIONS(5526),
    [anon_sym_static] = ACTIONS(5526),
    [anon_sym_register] = ACTIONS(5526),
    [anon_sym_inline] = ACTIONS(5526),
    [anon_sym___inline] = ACTIONS(5526),
    [anon_sym___inline__] = ACTIONS(5526),
    [anon_sym___forceinline] = ACTIONS(5526),
    [anon_sym_thread_local] = ACTIONS(5526),
    [anon_sym___thread] = ACTIONS(5526),
    [anon_sym_const] = ACTIONS(5526),
    [anon_sym_constexpr] = ACTIONS(5526),
    [anon_sym_volatile] = ACTIONS(5526),
    [anon_sym_restrict] = ACTIONS(5526),
    [anon_sym___restrict__] = ACTIONS(5526),
    [anon_sym__Atomic] = ACTIONS(5526),
    [anon_sym__Noreturn] = ACTIONS(5526),
    [anon_sym_noreturn] = ACTIONS(5526),
    [anon_sym_mutable] = ACTIONS(5526),
    [anon_sym_constinit] = ACTIONS(5526),
    [anon_sym_consteval] = ACTIONS(5526),
    [anon_sym_PROGMEM] = ACTIONS(5526),
    [aux_sym_primitive_type_token1] = ACTIONS(5526),
    [anon_sym_byte] = ACTIONS(5526),
    [anon_sym_word] = ACTIONS(5526),
    [anon_sym_enum] = ACTIONS(5526),
    [anon_sym_class] = ACTIONS(5526),
    [anon_sym_struct] = ACTIONS(5526),
    [anon_sym_union] = ACTIONS(5526),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5526),
    [anon_sym_decltype] = ACTIONS(5526),
    [anon_sym_virtual] = ACTIONS(5526),
    [anon_sym_alignas] = ACTIONS(5526),
    [anon_sym_explicit] = ACTIONS(5526),
    [anon_sym_typename] = ACTIONS(5526),
    [anon_sym_template] = ACTIONS(5526),
    [anon_sym_operator] = ACTIONS(5526),
    [anon_sym_friend] = ACTIONS(5526),
    [anon_sym_public] = ACTIONS(5526),
    [anon_sym_private] = ACTIONS(5526),
    [anon_sym_protected] = ACTIONS(5526),
    [anon_sym_using] = ACTIONS(5526),
    [anon_sym_static_assert] = ACTIONS(5526),
  },
  [2516] = {
    [sym_identifier] = ACTIONS(5558),
    [aux_sym_preproc_def_token1] = ACTIONS(5558),
    [aux_sym_preproc_if_token1] = ACTIONS(5558),
    [aux_sym_preproc_if_token2] = ACTIONS(5558),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5558),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5558),
    [sym_preproc_directive] = ACTIONS(5558),
    [anon_sym_LPAREN2] = ACTIONS(5560),
    [anon_sym_TILDE] = ACTIONS(5560),
    [anon_sym_STAR] = ACTIONS(5560),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_AMP] = ACTIONS(5558),
    [anon_sym___extension__] = ACTIONS(5558),
    [anon_sym_typedef] = ACTIONS(5558),
    [anon_sym_extern] = ACTIONS(5558),
    [anon_sym___attribute__] = ACTIONS(5558),
    [anon_sym_COLON_COLON] = ACTIONS(5560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5560),
    [anon_sym___declspec] = ACTIONS(5558),
    [anon_sym___based] = ACTIONS(5558),
    [anon_sym_signed] = ACTIONS(5558),
    [anon_sym_unsigned] = ACTIONS(5558),
    [anon_sym_long] = ACTIONS(5558),
    [anon_sym_short] = ACTIONS(5558),
    [anon_sym_LBRACK] = ACTIONS(5558),
    [anon_sym_static] = ACTIONS(5558),
    [anon_sym_register] = ACTIONS(5558),
    [anon_sym_inline] = ACTIONS(5558),
    [anon_sym___inline] = ACTIONS(5558),
    [anon_sym___inline__] = ACTIONS(5558),
    [anon_sym___forceinline] = ACTIONS(5558),
    [anon_sym_thread_local] = ACTIONS(5558),
    [anon_sym___thread] = ACTIONS(5558),
    [anon_sym_const] = ACTIONS(5558),
    [anon_sym_constexpr] = ACTIONS(5558),
    [anon_sym_volatile] = ACTIONS(5558),
    [anon_sym_restrict] = ACTIONS(5558),
    [anon_sym___restrict__] = ACTIONS(5558),
    [anon_sym__Atomic] = ACTIONS(5558),
    [anon_sym__Noreturn] = ACTIONS(5558),
    [anon_sym_noreturn] = ACTIONS(5558),
    [anon_sym_mutable] = ACTIONS(5558),
    [anon_sym_constinit] = ACTIONS(5558),
    [anon_sym_consteval] = ACTIONS(5558),
    [anon_sym_PROGMEM] = ACTIONS(5558),
    [aux_sym_primitive_type_token1] = ACTIONS(5558),
    [anon_sym_byte] = ACTIONS(5558),
    [anon_sym_word] = ACTIONS(5558),
    [anon_sym_enum] = ACTIONS(5558),
    [anon_sym_class] = ACTIONS(5558),
    [anon_sym_struct] = ACTIONS(5558),
    [anon_sym_union] = ACTIONS(5558),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5558),
    [anon_sym_decltype] = ACTIONS(5558),
    [anon_sym_virtual] = ACTIONS(5558),
    [anon_sym_alignas] = ACTIONS(5558),
    [anon_sym_explicit] = ACTIONS(5558),
    [anon_sym_typename] = ACTIONS(5558),
    [anon_sym_template] = ACTIONS(5558),
    [anon_sym_operator] = ACTIONS(5558),
    [anon_sym_friend] = ACTIONS(5558),
    [anon_sym_public] = ACTIONS(5558),
    [anon_sym_private] = ACTIONS(5558),
    [anon_sym_protected] = ACTIONS(5558),
    [anon_sym_using] = ACTIONS(5558),
    [anon_sym_static_assert] = ACTIONS(5558),
  },
  [2517] = {
    [sym_identifier] = ACTIONS(2970),
    [aux_sym_preproc_def_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token1] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2970),
    [sym_preproc_directive] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym___extension__] = ACTIONS(2970),
    [anon_sym_typedef] = ACTIONS(2970),
    [anon_sym_extern] = ACTIONS(2970),
    [anon_sym___attribute__] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2970),
    [anon_sym___based] = ACTIONS(2970),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_signed] = ACTIONS(2970),
    [anon_sym_unsigned] = ACTIONS(2970),
    [anon_sym_long] = ACTIONS(2970),
    [anon_sym_short] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_register] = ACTIONS(2970),
    [anon_sym_inline] = ACTIONS(2970),
    [anon_sym___inline] = ACTIONS(2970),
    [anon_sym___inline__] = ACTIONS(2970),
    [anon_sym___forceinline] = ACTIONS(2970),
    [anon_sym_thread_local] = ACTIONS(2970),
    [anon_sym___thread] = ACTIONS(2970),
    [anon_sym_const] = ACTIONS(2970),
    [anon_sym_constexpr] = ACTIONS(2970),
    [anon_sym_volatile] = ACTIONS(2970),
    [anon_sym_restrict] = ACTIONS(2970),
    [anon_sym___restrict__] = ACTIONS(2970),
    [anon_sym__Atomic] = ACTIONS(2970),
    [anon_sym__Noreturn] = ACTIONS(2970),
    [anon_sym_noreturn] = ACTIONS(2970),
    [anon_sym_mutable] = ACTIONS(2970),
    [anon_sym_constinit] = ACTIONS(2970),
    [anon_sym_consteval] = ACTIONS(2970),
    [anon_sym_PROGMEM] = ACTIONS(2970),
    [aux_sym_primitive_type_token1] = ACTIONS(2970),
    [anon_sym_byte] = ACTIONS(2970),
    [anon_sym_word] = ACTIONS(2970),
    [anon_sym_enum] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_struct] = ACTIONS(2970),
    [anon_sym_union] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2970),
    [anon_sym_decltype] = ACTIONS(2970),
    [anon_sym_virtual] = ACTIONS(2970),
    [anon_sym_alignas] = ACTIONS(2970),
    [anon_sym_explicit] = ACTIONS(2970),
    [anon_sym_typename] = ACTIONS(2970),
    [anon_sym_template] = ACTIONS(2970),
    [anon_sym_operator] = ACTIONS(2970),
    [anon_sym_friend] = ACTIONS(2970),
    [anon_sym_public] = ACTIONS(2970),
    [anon_sym_private] = ACTIONS(2970),
    [anon_sym_protected] = ACTIONS(2970),
    [anon_sym_using] = ACTIONS(2970),
    [anon_sym_static_assert] = ACTIONS(2970),
  },
  [2518] = {
    [sym_identifier] = ACTIONS(5530),
    [aux_sym_preproc_def_token1] = ACTIONS(5530),
    [aux_sym_preproc_if_token1] = ACTIONS(5530),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5530),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5530),
    [sym_preproc_directive] = ACTIONS(5530),
    [anon_sym_LPAREN2] = ACTIONS(5532),
    [anon_sym_TILDE] = ACTIONS(5532),
    [anon_sym_STAR] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5530),
    [anon_sym___extension__] = ACTIONS(5530),
    [anon_sym_typedef] = ACTIONS(5530),
    [anon_sym_extern] = ACTIONS(5530),
    [anon_sym___attribute__] = ACTIONS(5530),
    [anon_sym_COLON_COLON] = ACTIONS(5532),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5532),
    [anon_sym___declspec] = ACTIONS(5530),
    [anon_sym___based] = ACTIONS(5530),
    [anon_sym_RBRACE] = ACTIONS(5532),
    [anon_sym_signed] = ACTIONS(5530),
    [anon_sym_unsigned] = ACTIONS(5530),
    [anon_sym_long] = ACTIONS(5530),
    [anon_sym_short] = ACTIONS(5530),
    [anon_sym_LBRACK] = ACTIONS(5530),
    [anon_sym_static] = ACTIONS(5530),
    [anon_sym_register] = ACTIONS(5530),
    [anon_sym_inline] = ACTIONS(5530),
    [anon_sym___inline] = ACTIONS(5530),
    [anon_sym___inline__] = ACTIONS(5530),
    [anon_sym___forceinline] = ACTIONS(5530),
    [anon_sym_thread_local] = ACTIONS(5530),
    [anon_sym___thread] = ACTIONS(5530),
    [anon_sym_const] = ACTIONS(5530),
    [anon_sym_constexpr] = ACTIONS(5530),
    [anon_sym_volatile] = ACTIONS(5530),
    [anon_sym_restrict] = ACTIONS(5530),
    [anon_sym___restrict__] = ACTIONS(5530),
    [anon_sym__Atomic] = ACTIONS(5530),
    [anon_sym__Noreturn] = ACTIONS(5530),
    [anon_sym_noreturn] = ACTIONS(5530),
    [anon_sym_mutable] = ACTIONS(5530),
    [anon_sym_constinit] = ACTIONS(5530),
    [anon_sym_consteval] = ACTIONS(5530),
    [anon_sym_PROGMEM] = ACTIONS(5530),
    [aux_sym_primitive_type_token1] = ACTIONS(5530),
    [anon_sym_byte] = ACTIONS(5530),
    [anon_sym_word] = ACTIONS(5530),
    [anon_sym_enum] = ACTIONS(5530),
    [anon_sym_class] = ACTIONS(5530),
    [anon_sym_struct] = ACTIONS(5530),
    [anon_sym_union] = ACTIONS(5530),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5530),
    [anon_sym_decltype] = ACTIONS(5530),
    [anon_sym_virtual] = ACTIONS(5530),
    [anon_sym_alignas] = ACTIONS(5530),
    [anon_sym_explicit] = ACTIONS(5530),
    [anon_sym_typename] = ACTIONS(5530),
    [anon_sym_template] = ACTIONS(5530),
    [anon_sym_operator] = ACTIONS(5530),
    [anon_sym_friend] = ACTIONS(5530),
    [anon_sym_public] = ACTIONS(5530),
    [anon_sym_private] = ACTIONS(5530),
    [anon_sym_protected] = ACTIONS(5530),
    [anon_sym_using] = ACTIONS(5530),
    [anon_sym_static_assert] = ACTIONS(5530),
  },
  [2519] = {
    [sym_identifier] = ACTIONS(5558),
    [aux_sym_preproc_def_token1] = ACTIONS(5558),
    [aux_sym_preproc_if_token1] = ACTIONS(5558),
    [aux_sym_preproc_if_token2] = ACTIONS(5558),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5558),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5558),
    [sym_preproc_directive] = ACTIONS(5558),
    [anon_sym_LPAREN2] = ACTIONS(5560),
    [anon_sym_TILDE] = ACTIONS(5560),
    [anon_sym_STAR] = ACTIONS(5560),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_AMP] = ACTIONS(5558),
    [anon_sym___extension__] = ACTIONS(5558),
    [anon_sym_typedef] = ACTIONS(5558),
    [anon_sym_extern] = ACTIONS(5558),
    [anon_sym___attribute__] = ACTIONS(5558),
    [anon_sym_COLON_COLON] = ACTIONS(5560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5560),
    [anon_sym___declspec] = ACTIONS(5558),
    [anon_sym___based] = ACTIONS(5558),
    [anon_sym_signed] = ACTIONS(5558),
    [anon_sym_unsigned] = ACTIONS(5558),
    [anon_sym_long] = ACTIONS(5558),
    [anon_sym_short] = ACTIONS(5558),
    [anon_sym_LBRACK] = ACTIONS(5558),
    [anon_sym_static] = ACTIONS(5558),
    [anon_sym_register] = ACTIONS(5558),
    [anon_sym_inline] = ACTIONS(5558),
    [anon_sym___inline] = ACTIONS(5558),
    [anon_sym___inline__] = ACTIONS(5558),
    [anon_sym___forceinline] = ACTIONS(5558),
    [anon_sym_thread_local] = ACTIONS(5558),
    [anon_sym___thread] = ACTIONS(5558),
    [anon_sym_const] = ACTIONS(5558),
    [anon_sym_constexpr] = ACTIONS(5558),
    [anon_sym_volatile] = ACTIONS(5558),
    [anon_sym_restrict] = ACTIONS(5558),
    [anon_sym___restrict__] = ACTIONS(5558),
    [anon_sym__Atomic] = ACTIONS(5558),
    [anon_sym__Noreturn] = ACTIONS(5558),
    [anon_sym_noreturn] = ACTIONS(5558),
    [anon_sym_mutable] = ACTIONS(5558),
    [anon_sym_constinit] = ACTIONS(5558),
    [anon_sym_consteval] = ACTIONS(5558),
    [anon_sym_PROGMEM] = ACTIONS(5558),
    [aux_sym_primitive_type_token1] = ACTIONS(5558),
    [anon_sym_byte] = ACTIONS(5558),
    [anon_sym_word] = ACTIONS(5558),
    [anon_sym_enum] = ACTIONS(5558),
    [anon_sym_class] = ACTIONS(5558),
    [anon_sym_struct] = ACTIONS(5558),
    [anon_sym_union] = ACTIONS(5558),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5558),
    [anon_sym_decltype] = ACTIONS(5558),
    [anon_sym_virtual] = ACTIONS(5558),
    [anon_sym_alignas] = ACTIONS(5558),
    [anon_sym_explicit] = ACTIONS(5558),
    [anon_sym_typename] = ACTIONS(5558),
    [anon_sym_template] = ACTIONS(5558),
    [anon_sym_operator] = ACTIONS(5558),
    [anon_sym_friend] = ACTIONS(5558),
    [anon_sym_public] = ACTIONS(5558),
    [anon_sym_private] = ACTIONS(5558),
    [anon_sym_protected] = ACTIONS(5558),
    [anon_sym_using] = ACTIONS(5558),
    [anon_sym_static_assert] = ACTIONS(5558),
  },
  [2520] = {
    [sym_identifier] = ACTIONS(3439),
    [aux_sym_preproc_def_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3439),
    [sym_preproc_directive] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3439),
    [anon_sym___extension__] = ACTIONS(3439),
    [anon_sym_typedef] = ACTIONS(3439),
    [anon_sym_extern] = ACTIONS(3439),
    [anon_sym___attribute__] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3441),
    [anon_sym___declspec] = ACTIONS(3439),
    [anon_sym___based] = ACTIONS(3439),
    [anon_sym_RBRACE] = ACTIONS(3441),
    [anon_sym_signed] = ACTIONS(3439),
    [anon_sym_unsigned] = ACTIONS(3439),
    [anon_sym_long] = ACTIONS(3439),
    [anon_sym_short] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_register] = ACTIONS(3439),
    [anon_sym_inline] = ACTIONS(3439),
    [anon_sym___inline] = ACTIONS(3439),
    [anon_sym___inline__] = ACTIONS(3439),
    [anon_sym___forceinline] = ACTIONS(3439),
    [anon_sym_thread_local] = ACTIONS(3439),
    [anon_sym___thread] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_constexpr] = ACTIONS(3439),
    [anon_sym_volatile] = ACTIONS(3439),
    [anon_sym_restrict] = ACTIONS(3439),
    [anon_sym___restrict__] = ACTIONS(3439),
    [anon_sym__Atomic] = ACTIONS(3439),
    [anon_sym__Noreturn] = ACTIONS(3439),
    [anon_sym_noreturn] = ACTIONS(3439),
    [anon_sym_mutable] = ACTIONS(3439),
    [anon_sym_constinit] = ACTIONS(3439),
    [anon_sym_consteval] = ACTIONS(3439),
    [anon_sym_PROGMEM] = ACTIONS(3439),
    [aux_sym_primitive_type_token1] = ACTIONS(3439),
    [anon_sym_byte] = ACTIONS(3439),
    [anon_sym_word] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_struct] = ACTIONS(3439),
    [anon_sym_union] = ACTIONS(3439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3439),
    [anon_sym_decltype] = ACTIONS(3439),
    [anon_sym_virtual] = ACTIONS(3439),
    [anon_sym_alignas] = ACTIONS(3439),
    [anon_sym_explicit] = ACTIONS(3439),
    [anon_sym_typename] = ACTIONS(3439),
    [anon_sym_template] = ACTIONS(3439),
    [anon_sym_operator] = ACTIONS(3439),
    [anon_sym_friend] = ACTIONS(3439),
    [anon_sym_public] = ACTIONS(3439),
    [anon_sym_private] = ACTIONS(3439),
    [anon_sym_protected] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_static_assert] = ACTIONS(3439),
  },
  [2521] = {
    [sym_identifier] = ACTIONS(3439),
    [aux_sym_preproc_def_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3439),
    [sym_preproc_directive] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3439),
    [anon_sym___extension__] = ACTIONS(3439),
    [anon_sym_typedef] = ACTIONS(3439),
    [anon_sym_extern] = ACTIONS(3439),
    [anon_sym___attribute__] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3441),
    [anon_sym___declspec] = ACTIONS(3439),
    [anon_sym___based] = ACTIONS(3439),
    [anon_sym_RBRACE] = ACTIONS(3441),
    [anon_sym_signed] = ACTIONS(3439),
    [anon_sym_unsigned] = ACTIONS(3439),
    [anon_sym_long] = ACTIONS(3439),
    [anon_sym_short] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_register] = ACTIONS(3439),
    [anon_sym_inline] = ACTIONS(3439),
    [anon_sym___inline] = ACTIONS(3439),
    [anon_sym___inline__] = ACTIONS(3439),
    [anon_sym___forceinline] = ACTIONS(3439),
    [anon_sym_thread_local] = ACTIONS(3439),
    [anon_sym___thread] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_constexpr] = ACTIONS(3439),
    [anon_sym_volatile] = ACTIONS(3439),
    [anon_sym_restrict] = ACTIONS(3439),
    [anon_sym___restrict__] = ACTIONS(3439),
    [anon_sym__Atomic] = ACTIONS(3439),
    [anon_sym__Noreturn] = ACTIONS(3439),
    [anon_sym_noreturn] = ACTIONS(3439),
    [anon_sym_mutable] = ACTIONS(3439),
    [anon_sym_constinit] = ACTIONS(3439),
    [anon_sym_consteval] = ACTIONS(3439),
    [anon_sym_PROGMEM] = ACTIONS(3439),
    [aux_sym_primitive_type_token1] = ACTIONS(3439),
    [anon_sym_byte] = ACTIONS(3439),
    [anon_sym_word] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_struct] = ACTIONS(3439),
    [anon_sym_union] = ACTIONS(3439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3439),
    [anon_sym_decltype] = ACTIONS(3439),
    [anon_sym_virtual] = ACTIONS(3439),
    [anon_sym_alignas] = ACTIONS(3439),
    [anon_sym_explicit] = ACTIONS(3439),
    [anon_sym_typename] = ACTIONS(3439),
    [anon_sym_template] = ACTIONS(3439),
    [anon_sym_operator] = ACTIONS(3439),
    [anon_sym_friend] = ACTIONS(3439),
    [anon_sym_public] = ACTIONS(3439),
    [anon_sym_private] = ACTIONS(3439),
    [anon_sym_protected] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_static_assert] = ACTIONS(3439),
  },
  [2522] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(4471),
    [sym_raw_string_literal] = STATE(3057),
    [aux_sym_structured_binding_declarator_repeat1] = STATE(8134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(5933),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5870),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_RBRACK] = ACTIONS(5936),
    [anon_sym_EQ] = ACTIONS(5939),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(5941),
    [anon_sym_SLASH_EQ] = ACTIONS(5941),
    [anon_sym_PERCENT_EQ] = ACTIONS(5941),
    [anon_sym_PLUS_EQ] = ACTIONS(5941),
    [anon_sym_DASH_EQ] = ACTIONS(5941),
    [anon_sym_LT_LT_EQ] = ACTIONS(5941),
    [anon_sym_GT_GT_EQ] = ACTIONS(5941),
    [anon_sym_AMP_EQ] = ACTIONS(5941),
    [anon_sym_CARET_EQ] = ACTIONS(5941),
    [anon_sym_PIPE_EQ] = ACTIONS(5941),
    [anon_sym_and_eq] = ACTIONS(5941),
    [anon_sym_or_eq] = ACTIONS(5941),
    [anon_sym_xor_eq] = ACTIONS(5941),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [2523] = {
    [sym_identifier] = ACTIONS(3192),
    [aux_sym_preproc_def_token1] = ACTIONS(3192),
    [aux_sym_preproc_if_token1] = ACTIONS(3192),
    [aux_sym_preproc_if_token2] = ACTIONS(3192),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3192),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3192),
    [sym_preproc_directive] = ACTIONS(3192),
    [anon_sym_LPAREN2] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3194),
    [anon_sym_AMP_AMP] = ACTIONS(3194),
    [anon_sym_AMP] = ACTIONS(3192),
    [anon_sym___extension__] = ACTIONS(3192),
    [anon_sym_typedef] = ACTIONS(3192),
    [anon_sym_extern] = ACTIONS(3192),
    [anon_sym___attribute__] = ACTIONS(3192),
    [anon_sym_COLON_COLON] = ACTIONS(3194),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3194),
    [anon_sym___declspec] = ACTIONS(3192),
    [anon_sym___based] = ACTIONS(3192),
    [anon_sym_signed] = ACTIONS(3192),
    [anon_sym_unsigned] = ACTIONS(3192),
    [anon_sym_long] = ACTIONS(3192),
    [anon_sym_short] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [anon_sym_static] = ACTIONS(3192),
    [anon_sym_register] = ACTIONS(3192),
    [anon_sym_inline] = ACTIONS(3192),
    [anon_sym___inline] = ACTIONS(3192),
    [anon_sym___inline__] = ACTIONS(3192),
    [anon_sym___forceinline] = ACTIONS(3192),
    [anon_sym_thread_local] = ACTIONS(3192),
    [anon_sym___thread] = ACTIONS(3192),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_constexpr] = ACTIONS(3192),
    [anon_sym_volatile] = ACTIONS(3192),
    [anon_sym_restrict] = ACTIONS(3192),
    [anon_sym___restrict__] = ACTIONS(3192),
    [anon_sym__Atomic] = ACTIONS(3192),
    [anon_sym__Noreturn] = ACTIONS(3192),
    [anon_sym_noreturn] = ACTIONS(3192),
    [anon_sym_mutable] = ACTIONS(3192),
    [anon_sym_constinit] = ACTIONS(3192),
    [anon_sym_consteval] = ACTIONS(3192),
    [anon_sym_PROGMEM] = ACTIONS(3192),
    [aux_sym_primitive_type_token1] = ACTIONS(3192),
    [anon_sym_byte] = ACTIONS(3192),
    [anon_sym_word] = ACTIONS(3192),
    [anon_sym_enum] = ACTIONS(3192),
    [anon_sym_class] = ACTIONS(3192),
    [anon_sym_struct] = ACTIONS(3192),
    [anon_sym_union] = ACTIONS(3192),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3192),
    [anon_sym_decltype] = ACTIONS(3192),
    [anon_sym_virtual] = ACTIONS(3192),
    [anon_sym_alignas] = ACTIONS(3192),
    [anon_sym_explicit] = ACTIONS(3192),
    [anon_sym_typename] = ACTIONS(3192),
    [anon_sym_template] = ACTIONS(3192),
    [anon_sym_operator] = ACTIONS(3192),
    [anon_sym_friend] = ACTIONS(3192),
    [anon_sym_public] = ACTIONS(3192),
    [anon_sym_private] = ACTIONS(3192),
    [anon_sym_protected] = ACTIONS(3192),
    [anon_sym_using] = ACTIONS(3192),
    [anon_sym_static_assert] = ACTIONS(3192),
  },
  [2524] = {
    [sym_identifier] = ACTIONS(3254),
    [aux_sym_preproc_def_token1] = ACTIONS(3254),
    [aux_sym_preproc_if_token1] = ACTIONS(3254),
    [aux_sym_preproc_if_token2] = ACTIONS(3254),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3254),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3254),
    [sym_preproc_directive] = ACTIONS(3254),
    [anon_sym_LPAREN2] = ACTIONS(3256),
    [anon_sym_TILDE] = ACTIONS(3256),
    [anon_sym_STAR] = ACTIONS(3256),
    [anon_sym_AMP_AMP] = ACTIONS(3256),
    [anon_sym_AMP] = ACTIONS(3254),
    [anon_sym___extension__] = ACTIONS(3254),
    [anon_sym_typedef] = ACTIONS(3254),
    [anon_sym_extern] = ACTIONS(3254),
    [anon_sym___attribute__] = ACTIONS(3254),
    [anon_sym_COLON_COLON] = ACTIONS(3256),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3256),
    [anon_sym___declspec] = ACTIONS(3254),
    [anon_sym___based] = ACTIONS(3254),
    [anon_sym_signed] = ACTIONS(3254),
    [anon_sym_unsigned] = ACTIONS(3254),
    [anon_sym_long] = ACTIONS(3254),
    [anon_sym_short] = ACTIONS(3254),
    [anon_sym_LBRACK] = ACTIONS(3254),
    [anon_sym_static] = ACTIONS(3254),
    [anon_sym_register] = ACTIONS(3254),
    [anon_sym_inline] = ACTIONS(3254),
    [anon_sym___inline] = ACTIONS(3254),
    [anon_sym___inline__] = ACTIONS(3254),
    [anon_sym___forceinline] = ACTIONS(3254),
    [anon_sym_thread_local] = ACTIONS(3254),
    [anon_sym___thread] = ACTIONS(3254),
    [anon_sym_const] = ACTIONS(3254),
    [anon_sym_constexpr] = ACTIONS(3254),
    [anon_sym_volatile] = ACTIONS(3254),
    [anon_sym_restrict] = ACTIONS(3254),
    [anon_sym___restrict__] = ACTIONS(3254),
    [anon_sym__Atomic] = ACTIONS(3254),
    [anon_sym__Noreturn] = ACTIONS(3254),
    [anon_sym_noreturn] = ACTIONS(3254),
    [anon_sym_mutable] = ACTIONS(3254),
    [anon_sym_constinit] = ACTIONS(3254),
    [anon_sym_consteval] = ACTIONS(3254),
    [anon_sym_PROGMEM] = ACTIONS(3254),
    [aux_sym_primitive_type_token1] = ACTIONS(3254),
    [anon_sym_byte] = ACTIONS(3254),
    [anon_sym_word] = ACTIONS(3254),
    [anon_sym_enum] = ACTIONS(3254),
    [anon_sym_class] = ACTIONS(3254),
    [anon_sym_struct] = ACTIONS(3254),
    [anon_sym_union] = ACTIONS(3254),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3254),
    [anon_sym_decltype] = ACTIONS(3254),
    [anon_sym_virtual] = ACTIONS(3254),
    [anon_sym_alignas] = ACTIONS(3254),
    [anon_sym_explicit] = ACTIONS(3254),
    [anon_sym_typename] = ACTIONS(3254),
    [anon_sym_template] = ACTIONS(3254),
    [anon_sym_operator] = ACTIONS(3254),
    [anon_sym_friend] = ACTIONS(3254),
    [anon_sym_public] = ACTIONS(3254),
    [anon_sym_private] = ACTIONS(3254),
    [anon_sym_protected] = ACTIONS(3254),
    [anon_sym_using] = ACTIONS(3254),
    [anon_sym_static_assert] = ACTIONS(3254),
  },
  [2525] = {
    [sym_identifier] = ACTIONS(5534),
    [aux_sym_preproc_def_token1] = ACTIONS(5534),
    [aux_sym_preproc_if_token1] = ACTIONS(5534),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5534),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5534),
    [sym_preproc_directive] = ACTIONS(5534),
    [anon_sym_LPAREN2] = ACTIONS(5536),
    [anon_sym_TILDE] = ACTIONS(5536),
    [anon_sym_STAR] = ACTIONS(5536),
    [anon_sym_AMP_AMP] = ACTIONS(5536),
    [anon_sym_AMP] = ACTIONS(5534),
    [anon_sym___extension__] = ACTIONS(5534),
    [anon_sym_typedef] = ACTIONS(5534),
    [anon_sym_extern] = ACTIONS(5534),
    [anon_sym___attribute__] = ACTIONS(5534),
    [anon_sym_COLON_COLON] = ACTIONS(5536),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5536),
    [anon_sym___declspec] = ACTIONS(5534),
    [anon_sym___based] = ACTIONS(5534),
    [anon_sym_RBRACE] = ACTIONS(5536),
    [anon_sym_signed] = ACTIONS(5534),
    [anon_sym_unsigned] = ACTIONS(5534),
    [anon_sym_long] = ACTIONS(5534),
    [anon_sym_short] = ACTIONS(5534),
    [anon_sym_LBRACK] = ACTIONS(5534),
    [anon_sym_static] = ACTIONS(5534),
    [anon_sym_register] = ACTIONS(5534),
    [anon_sym_inline] = ACTIONS(5534),
    [anon_sym___inline] = ACTIONS(5534),
    [anon_sym___inline__] = ACTIONS(5534),
    [anon_sym___forceinline] = ACTIONS(5534),
    [anon_sym_thread_local] = ACTIONS(5534),
    [anon_sym___thread] = ACTIONS(5534),
    [anon_sym_const] = ACTIONS(5534),
    [anon_sym_constexpr] = ACTIONS(5534),
    [anon_sym_volatile] = ACTIONS(5534),
    [anon_sym_restrict] = ACTIONS(5534),
    [anon_sym___restrict__] = ACTIONS(5534),
    [anon_sym__Atomic] = ACTIONS(5534),
    [anon_sym__Noreturn] = ACTIONS(5534),
    [anon_sym_noreturn] = ACTIONS(5534),
    [anon_sym_mutable] = ACTIONS(5534),
    [anon_sym_constinit] = ACTIONS(5534),
    [anon_sym_consteval] = ACTIONS(5534),
    [anon_sym_PROGMEM] = ACTIONS(5534),
    [aux_sym_primitive_type_token1] = ACTIONS(5534),
    [anon_sym_byte] = ACTIONS(5534),
    [anon_sym_word] = ACTIONS(5534),
    [anon_sym_enum] = ACTIONS(5534),
    [anon_sym_class] = ACTIONS(5534),
    [anon_sym_struct] = ACTIONS(5534),
    [anon_sym_union] = ACTIONS(5534),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5534),
    [anon_sym_decltype] = ACTIONS(5534),
    [anon_sym_virtual] = ACTIONS(5534),
    [anon_sym_alignas] = ACTIONS(5534),
    [anon_sym_explicit] = ACTIONS(5534),
    [anon_sym_typename] = ACTIONS(5534),
    [anon_sym_template] = ACTIONS(5534),
    [anon_sym_operator] = ACTIONS(5534),
    [anon_sym_friend] = ACTIONS(5534),
    [anon_sym_public] = ACTIONS(5534),
    [anon_sym_private] = ACTIONS(5534),
    [anon_sym_protected] = ACTIONS(5534),
    [anon_sym_using] = ACTIONS(5534),
    [anon_sym_static_assert] = ACTIONS(5534),
  },
  [2526] = {
    [sym_identifier] = ACTIONS(5570),
    [aux_sym_preproc_def_token1] = ACTIONS(5570),
    [aux_sym_preproc_if_token1] = ACTIONS(5570),
    [aux_sym_preproc_if_token2] = ACTIONS(5570),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5570),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5570),
    [sym_preproc_directive] = ACTIONS(5570),
    [anon_sym_LPAREN2] = ACTIONS(5572),
    [anon_sym_TILDE] = ACTIONS(5572),
    [anon_sym_STAR] = ACTIONS(5572),
    [anon_sym_AMP_AMP] = ACTIONS(5572),
    [anon_sym_AMP] = ACTIONS(5570),
    [anon_sym___extension__] = ACTIONS(5570),
    [anon_sym_typedef] = ACTIONS(5570),
    [anon_sym_extern] = ACTIONS(5570),
    [anon_sym___attribute__] = ACTIONS(5570),
    [anon_sym_COLON_COLON] = ACTIONS(5572),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5572),
    [anon_sym___declspec] = ACTIONS(5570),
    [anon_sym___based] = ACTIONS(5570),
    [anon_sym_signed] = ACTIONS(5570),
    [anon_sym_unsigned] = ACTIONS(5570),
    [anon_sym_long] = ACTIONS(5570),
    [anon_sym_short] = ACTIONS(5570),
    [anon_sym_LBRACK] = ACTIONS(5570),
    [anon_sym_static] = ACTIONS(5570),
    [anon_sym_register] = ACTIONS(5570),
    [anon_sym_inline] = ACTIONS(5570),
    [anon_sym___inline] = ACTIONS(5570),
    [anon_sym___inline__] = ACTIONS(5570),
    [anon_sym___forceinline] = ACTIONS(5570),
    [anon_sym_thread_local] = ACTIONS(5570),
    [anon_sym___thread] = ACTIONS(5570),
    [anon_sym_const] = ACTIONS(5570),
    [anon_sym_constexpr] = ACTIONS(5570),
    [anon_sym_volatile] = ACTIONS(5570),
    [anon_sym_restrict] = ACTIONS(5570),
    [anon_sym___restrict__] = ACTIONS(5570),
    [anon_sym__Atomic] = ACTIONS(5570),
    [anon_sym__Noreturn] = ACTIONS(5570),
    [anon_sym_noreturn] = ACTIONS(5570),
    [anon_sym_mutable] = ACTIONS(5570),
    [anon_sym_constinit] = ACTIONS(5570),
    [anon_sym_consteval] = ACTIONS(5570),
    [anon_sym_PROGMEM] = ACTIONS(5570),
    [aux_sym_primitive_type_token1] = ACTIONS(5570),
    [anon_sym_byte] = ACTIONS(5570),
    [anon_sym_word] = ACTIONS(5570),
    [anon_sym_enum] = ACTIONS(5570),
    [anon_sym_class] = ACTIONS(5570),
    [anon_sym_struct] = ACTIONS(5570),
    [anon_sym_union] = ACTIONS(5570),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5570),
    [anon_sym_decltype] = ACTIONS(5570),
    [anon_sym_virtual] = ACTIONS(5570),
    [anon_sym_alignas] = ACTIONS(5570),
    [anon_sym_explicit] = ACTIONS(5570),
    [anon_sym_typename] = ACTIONS(5570),
    [anon_sym_template] = ACTIONS(5570),
    [anon_sym_operator] = ACTIONS(5570),
    [anon_sym_friend] = ACTIONS(5570),
    [anon_sym_public] = ACTIONS(5570),
    [anon_sym_private] = ACTIONS(5570),
    [anon_sym_protected] = ACTIONS(5570),
    [anon_sym_using] = ACTIONS(5570),
    [anon_sym_static_assert] = ACTIONS(5570),
  },
  [2527] = {
    [sym_identifier] = ACTIONS(5507),
    [aux_sym_preproc_def_token1] = ACTIONS(5507),
    [aux_sym_preproc_if_token1] = ACTIONS(5507),
    [aux_sym_preproc_if_token2] = ACTIONS(5507),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5507),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5507),
    [sym_preproc_directive] = ACTIONS(5507),
    [anon_sym_LPAREN2] = ACTIONS(5509),
    [anon_sym_TILDE] = ACTIONS(5509),
    [anon_sym_STAR] = ACTIONS(5509),
    [anon_sym_AMP_AMP] = ACTIONS(5509),
    [anon_sym_AMP] = ACTIONS(5507),
    [anon_sym___extension__] = ACTIONS(5507),
    [anon_sym_typedef] = ACTIONS(5507),
    [anon_sym_extern] = ACTIONS(5507),
    [anon_sym___attribute__] = ACTIONS(5507),
    [anon_sym_COLON_COLON] = ACTIONS(5509),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5509),
    [anon_sym___declspec] = ACTIONS(5507),
    [anon_sym___based] = ACTIONS(5507),
    [anon_sym_signed] = ACTIONS(5507),
    [anon_sym_unsigned] = ACTIONS(5507),
    [anon_sym_long] = ACTIONS(5507),
    [anon_sym_short] = ACTIONS(5507),
    [anon_sym_LBRACK] = ACTIONS(5507),
    [anon_sym_static] = ACTIONS(5507),
    [anon_sym_register] = ACTIONS(5507),
    [anon_sym_inline] = ACTIONS(5507),
    [anon_sym___inline] = ACTIONS(5507),
    [anon_sym___inline__] = ACTIONS(5507),
    [anon_sym___forceinline] = ACTIONS(5507),
    [anon_sym_thread_local] = ACTIONS(5507),
    [anon_sym___thread] = ACTIONS(5507),
    [anon_sym_const] = ACTIONS(5507),
    [anon_sym_constexpr] = ACTIONS(5507),
    [anon_sym_volatile] = ACTIONS(5507),
    [anon_sym_restrict] = ACTIONS(5507),
    [anon_sym___restrict__] = ACTIONS(5507),
    [anon_sym__Atomic] = ACTIONS(5507),
    [anon_sym__Noreturn] = ACTIONS(5507),
    [anon_sym_noreturn] = ACTIONS(5507),
    [anon_sym_mutable] = ACTIONS(5507),
    [anon_sym_constinit] = ACTIONS(5507),
    [anon_sym_consteval] = ACTIONS(5507),
    [anon_sym_PROGMEM] = ACTIONS(5507),
    [aux_sym_primitive_type_token1] = ACTIONS(5507),
    [anon_sym_byte] = ACTIONS(5507),
    [anon_sym_word] = ACTIONS(5507),
    [anon_sym_enum] = ACTIONS(5507),
    [anon_sym_class] = ACTIONS(5507),
    [anon_sym_struct] = ACTIONS(5507),
    [anon_sym_union] = ACTIONS(5507),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5507),
    [anon_sym_decltype] = ACTIONS(5507),
    [anon_sym_virtual] = ACTIONS(5507),
    [anon_sym_alignas] = ACTIONS(5507),
    [anon_sym_explicit] = ACTIONS(5507),
    [anon_sym_typename] = ACTIONS(5507),
    [anon_sym_template] = ACTIONS(5507),
    [anon_sym_operator] = ACTIONS(5507),
    [anon_sym_friend] = ACTIONS(5507),
    [anon_sym_public] = ACTIONS(5507),
    [anon_sym_private] = ACTIONS(5507),
    [anon_sym_protected] = ACTIONS(5507),
    [anon_sym_using] = ACTIONS(5507),
    [anon_sym_static_assert] = ACTIONS(5507),
  },
  [2528] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(4471),
    [sym_raw_string_literal] = STATE(3057),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5870),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4280),
    [anon_sym_COLON] = ACTIONS(4310),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_and_eq] = ACTIONS(4284),
    [anon_sym_or_eq] = ACTIONS(4284),
    [anon_sym_xor_eq] = ACTIONS(4284),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [2529] = {
    [sym_identifier] = ACTIONS(5590),
    [aux_sym_preproc_def_token1] = ACTIONS(5590),
    [aux_sym_preproc_if_token1] = ACTIONS(5590),
    [aux_sym_preproc_if_token2] = ACTIONS(5590),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5590),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5590),
    [sym_preproc_directive] = ACTIONS(5590),
    [anon_sym_LPAREN2] = ACTIONS(5592),
    [anon_sym_TILDE] = ACTIONS(5592),
    [anon_sym_STAR] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym___extension__] = ACTIONS(5590),
    [anon_sym_typedef] = ACTIONS(5590),
    [anon_sym_extern] = ACTIONS(5590),
    [anon_sym___attribute__] = ACTIONS(5590),
    [anon_sym_COLON_COLON] = ACTIONS(5592),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5592),
    [anon_sym___declspec] = ACTIONS(5590),
    [anon_sym___based] = ACTIONS(5590),
    [anon_sym_signed] = ACTIONS(5590),
    [anon_sym_unsigned] = ACTIONS(5590),
    [anon_sym_long] = ACTIONS(5590),
    [anon_sym_short] = ACTIONS(5590),
    [anon_sym_LBRACK] = ACTIONS(5590),
    [anon_sym_static] = ACTIONS(5590),
    [anon_sym_register] = ACTIONS(5590),
    [anon_sym_inline] = ACTIONS(5590),
    [anon_sym___inline] = ACTIONS(5590),
    [anon_sym___inline__] = ACTIONS(5590),
    [anon_sym___forceinline] = ACTIONS(5590),
    [anon_sym_thread_local] = ACTIONS(5590),
    [anon_sym___thread] = ACTIONS(5590),
    [anon_sym_const] = ACTIONS(5590),
    [anon_sym_constexpr] = ACTIONS(5590),
    [anon_sym_volatile] = ACTIONS(5590),
    [anon_sym_restrict] = ACTIONS(5590),
    [anon_sym___restrict__] = ACTIONS(5590),
    [anon_sym__Atomic] = ACTIONS(5590),
    [anon_sym__Noreturn] = ACTIONS(5590),
    [anon_sym_noreturn] = ACTIONS(5590),
    [anon_sym_mutable] = ACTIONS(5590),
    [anon_sym_constinit] = ACTIONS(5590),
    [anon_sym_consteval] = ACTIONS(5590),
    [anon_sym_PROGMEM] = ACTIONS(5590),
    [aux_sym_primitive_type_token1] = ACTIONS(5590),
    [anon_sym_byte] = ACTIONS(5590),
    [anon_sym_word] = ACTIONS(5590),
    [anon_sym_enum] = ACTIONS(5590),
    [anon_sym_class] = ACTIONS(5590),
    [anon_sym_struct] = ACTIONS(5590),
    [anon_sym_union] = ACTIONS(5590),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5590),
    [anon_sym_decltype] = ACTIONS(5590),
    [anon_sym_virtual] = ACTIONS(5590),
    [anon_sym_alignas] = ACTIONS(5590),
    [anon_sym_explicit] = ACTIONS(5590),
    [anon_sym_typename] = ACTIONS(5590),
    [anon_sym_template] = ACTIONS(5590),
    [anon_sym_operator] = ACTIONS(5590),
    [anon_sym_friend] = ACTIONS(5590),
    [anon_sym_public] = ACTIONS(5590),
    [anon_sym_private] = ACTIONS(5590),
    [anon_sym_protected] = ACTIONS(5590),
    [anon_sym_using] = ACTIONS(5590),
    [anon_sym_static_assert] = ACTIONS(5590),
  },
  [2530] = {
    [sym_identifier] = ACTIONS(3503),
    [aux_sym_preproc_def_token1] = ACTIONS(3503),
    [aux_sym_preproc_if_token1] = ACTIONS(3503),
    [aux_sym_preproc_if_token2] = ACTIONS(3503),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3503),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3503),
    [sym_preproc_directive] = ACTIONS(3503),
    [anon_sym_LPAREN2] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP] = ACTIONS(3503),
    [anon_sym___extension__] = ACTIONS(3503),
    [anon_sym_typedef] = ACTIONS(3503),
    [anon_sym_extern] = ACTIONS(3503),
    [anon_sym___attribute__] = ACTIONS(3503),
    [anon_sym_COLON_COLON] = ACTIONS(3505),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3505),
    [anon_sym___declspec] = ACTIONS(3503),
    [anon_sym___based] = ACTIONS(3503),
    [anon_sym_signed] = ACTIONS(3503),
    [anon_sym_unsigned] = ACTIONS(3503),
    [anon_sym_long] = ACTIONS(3503),
    [anon_sym_short] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3503),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_register] = ACTIONS(3503),
    [anon_sym_inline] = ACTIONS(3503),
    [anon_sym___inline] = ACTIONS(3503),
    [anon_sym___inline__] = ACTIONS(3503),
    [anon_sym___forceinline] = ACTIONS(3503),
    [anon_sym_thread_local] = ACTIONS(3503),
    [anon_sym___thread] = ACTIONS(3503),
    [anon_sym_const] = ACTIONS(3503),
    [anon_sym_constexpr] = ACTIONS(3503),
    [anon_sym_volatile] = ACTIONS(3503),
    [anon_sym_restrict] = ACTIONS(3503),
    [anon_sym___restrict__] = ACTIONS(3503),
    [anon_sym__Atomic] = ACTIONS(3503),
    [anon_sym__Noreturn] = ACTIONS(3503),
    [anon_sym_noreturn] = ACTIONS(3503),
    [anon_sym_mutable] = ACTIONS(3503),
    [anon_sym_constinit] = ACTIONS(3503),
    [anon_sym_consteval] = ACTIONS(3503),
    [anon_sym_PROGMEM] = ACTIONS(3503),
    [aux_sym_primitive_type_token1] = ACTIONS(3503),
    [anon_sym_byte] = ACTIONS(3503),
    [anon_sym_word] = ACTIONS(3503),
    [anon_sym_enum] = ACTIONS(3503),
    [anon_sym_class] = ACTIONS(3503),
    [anon_sym_struct] = ACTIONS(3503),
    [anon_sym_union] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3503),
    [anon_sym_decltype] = ACTIONS(3503),
    [anon_sym_virtual] = ACTIONS(3503),
    [anon_sym_alignas] = ACTIONS(3503),
    [anon_sym_explicit] = ACTIONS(3503),
    [anon_sym_typename] = ACTIONS(3503),
    [anon_sym_template] = ACTIONS(3503),
    [anon_sym_operator] = ACTIONS(3503),
    [anon_sym_friend] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_using] = ACTIONS(3503),
    [anon_sym_static_assert] = ACTIONS(3503),
  },
  [2531] = {
    [sym_identifier] = ACTIONS(5554),
    [aux_sym_preproc_def_token1] = ACTIONS(5554),
    [aux_sym_preproc_if_token1] = ACTIONS(5554),
    [aux_sym_preproc_if_token2] = ACTIONS(5554),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5554),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5554),
    [sym_preproc_directive] = ACTIONS(5554),
    [anon_sym_LPAREN2] = ACTIONS(5556),
    [anon_sym_TILDE] = ACTIONS(5556),
    [anon_sym_STAR] = ACTIONS(5556),
    [anon_sym_AMP_AMP] = ACTIONS(5556),
    [anon_sym_AMP] = ACTIONS(5554),
    [anon_sym___extension__] = ACTIONS(5554),
    [anon_sym_typedef] = ACTIONS(5554),
    [anon_sym_extern] = ACTIONS(5554),
    [anon_sym___attribute__] = ACTIONS(5554),
    [anon_sym_COLON_COLON] = ACTIONS(5556),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5556),
    [anon_sym___declspec] = ACTIONS(5554),
    [anon_sym___based] = ACTIONS(5554),
    [anon_sym_signed] = ACTIONS(5554),
    [anon_sym_unsigned] = ACTIONS(5554),
    [anon_sym_long] = ACTIONS(5554),
    [anon_sym_short] = ACTIONS(5554),
    [anon_sym_LBRACK] = ACTIONS(5554),
    [anon_sym_static] = ACTIONS(5554),
    [anon_sym_register] = ACTIONS(5554),
    [anon_sym_inline] = ACTIONS(5554),
    [anon_sym___inline] = ACTIONS(5554),
    [anon_sym___inline__] = ACTIONS(5554),
    [anon_sym___forceinline] = ACTIONS(5554),
    [anon_sym_thread_local] = ACTIONS(5554),
    [anon_sym___thread] = ACTIONS(5554),
    [anon_sym_const] = ACTIONS(5554),
    [anon_sym_constexpr] = ACTIONS(5554),
    [anon_sym_volatile] = ACTIONS(5554),
    [anon_sym_restrict] = ACTIONS(5554),
    [anon_sym___restrict__] = ACTIONS(5554),
    [anon_sym__Atomic] = ACTIONS(5554),
    [anon_sym__Noreturn] = ACTIONS(5554),
    [anon_sym_noreturn] = ACTIONS(5554),
    [anon_sym_mutable] = ACTIONS(5554),
    [anon_sym_constinit] = ACTIONS(5554),
    [anon_sym_consteval] = ACTIONS(5554),
    [anon_sym_PROGMEM] = ACTIONS(5554),
    [aux_sym_primitive_type_token1] = ACTIONS(5554),
    [anon_sym_byte] = ACTIONS(5554),
    [anon_sym_word] = ACTIONS(5554),
    [anon_sym_enum] = ACTIONS(5554),
    [anon_sym_class] = ACTIONS(5554),
    [anon_sym_struct] = ACTIONS(5554),
    [anon_sym_union] = ACTIONS(5554),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5554),
    [anon_sym_decltype] = ACTIONS(5554),
    [anon_sym_virtual] = ACTIONS(5554),
    [anon_sym_alignas] = ACTIONS(5554),
    [anon_sym_explicit] = ACTIONS(5554),
    [anon_sym_typename] = ACTIONS(5554),
    [anon_sym_template] = ACTIONS(5554),
    [anon_sym_operator] = ACTIONS(5554),
    [anon_sym_friend] = ACTIONS(5554),
    [anon_sym_public] = ACTIONS(5554),
    [anon_sym_private] = ACTIONS(5554),
    [anon_sym_protected] = ACTIONS(5554),
    [anon_sym_using] = ACTIONS(5554),
    [anon_sym_static_assert] = ACTIONS(5554),
  },
  [2532] = {
    [sym_identifier] = ACTIONS(3387),
    [aux_sym_preproc_def_token1] = ACTIONS(3387),
    [aux_sym_preproc_if_token1] = ACTIONS(3387),
    [aux_sym_preproc_if_token2] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3387),
    [sym_preproc_directive] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_STAR] = ACTIONS(3389),
    [anon_sym_AMP_AMP] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym___extension__] = ACTIONS(3387),
    [anon_sym_typedef] = ACTIONS(3387),
    [anon_sym_extern] = ACTIONS(3387),
    [anon_sym___attribute__] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3389),
    [anon_sym___declspec] = ACTIONS(3387),
    [anon_sym___based] = ACTIONS(3387),
    [anon_sym_signed] = ACTIONS(3387),
    [anon_sym_unsigned] = ACTIONS(3387),
    [anon_sym_long] = ACTIONS(3387),
    [anon_sym_short] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_register] = ACTIONS(3387),
    [anon_sym_inline] = ACTIONS(3387),
    [anon_sym___inline] = ACTIONS(3387),
    [anon_sym___inline__] = ACTIONS(3387),
    [anon_sym___forceinline] = ACTIONS(3387),
    [anon_sym_thread_local] = ACTIONS(3387),
    [anon_sym___thread] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_constexpr] = ACTIONS(3387),
    [anon_sym_volatile] = ACTIONS(3387),
    [anon_sym_restrict] = ACTIONS(3387),
    [anon_sym___restrict__] = ACTIONS(3387),
    [anon_sym__Atomic] = ACTIONS(3387),
    [anon_sym__Noreturn] = ACTIONS(3387),
    [anon_sym_noreturn] = ACTIONS(3387),
    [anon_sym_mutable] = ACTIONS(3387),
    [anon_sym_constinit] = ACTIONS(3387),
    [anon_sym_consteval] = ACTIONS(3387),
    [anon_sym_PROGMEM] = ACTIONS(3387),
    [aux_sym_primitive_type_token1] = ACTIONS(3387),
    [anon_sym_byte] = ACTIONS(3387),
    [anon_sym_word] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [anon_sym_class] = ACTIONS(3387),
    [anon_sym_struct] = ACTIONS(3387),
    [anon_sym_union] = ACTIONS(3387),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3387),
    [anon_sym_decltype] = ACTIONS(3387),
    [anon_sym_virtual] = ACTIONS(3387),
    [anon_sym_alignas] = ACTIONS(3387),
    [anon_sym_explicit] = ACTIONS(3387),
    [anon_sym_typename] = ACTIONS(3387),
    [anon_sym_template] = ACTIONS(3387),
    [anon_sym_operator] = ACTIONS(3387),
    [anon_sym_friend] = ACTIONS(3387),
    [anon_sym_public] = ACTIONS(3387),
    [anon_sym_private] = ACTIONS(3387),
    [anon_sym_protected] = ACTIONS(3387),
    [anon_sym_using] = ACTIONS(3387),
    [anon_sym_static_assert] = ACTIONS(3387),
  },
  [2533] = {
    [sym_identifier] = ACTIONS(3192),
    [aux_sym_preproc_def_token1] = ACTIONS(3192),
    [aux_sym_preproc_if_token1] = ACTIONS(3192),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3192),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3192),
    [sym_preproc_directive] = ACTIONS(3192),
    [anon_sym_LPAREN2] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3194),
    [anon_sym_AMP_AMP] = ACTIONS(3194),
    [anon_sym_AMP] = ACTIONS(3192),
    [anon_sym___extension__] = ACTIONS(3192),
    [anon_sym_typedef] = ACTIONS(3192),
    [anon_sym_extern] = ACTIONS(3192),
    [anon_sym___attribute__] = ACTIONS(3192),
    [anon_sym_COLON_COLON] = ACTIONS(3194),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3194),
    [anon_sym___declspec] = ACTIONS(3192),
    [anon_sym___based] = ACTIONS(3192),
    [anon_sym_RBRACE] = ACTIONS(3194),
    [anon_sym_signed] = ACTIONS(3192),
    [anon_sym_unsigned] = ACTIONS(3192),
    [anon_sym_long] = ACTIONS(3192),
    [anon_sym_short] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [anon_sym_static] = ACTIONS(3192),
    [anon_sym_register] = ACTIONS(3192),
    [anon_sym_inline] = ACTIONS(3192),
    [anon_sym___inline] = ACTIONS(3192),
    [anon_sym___inline__] = ACTIONS(3192),
    [anon_sym___forceinline] = ACTIONS(3192),
    [anon_sym_thread_local] = ACTIONS(3192),
    [anon_sym___thread] = ACTIONS(3192),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_constexpr] = ACTIONS(3192),
    [anon_sym_volatile] = ACTIONS(3192),
    [anon_sym_restrict] = ACTIONS(3192),
    [anon_sym___restrict__] = ACTIONS(3192),
    [anon_sym__Atomic] = ACTIONS(3192),
    [anon_sym__Noreturn] = ACTIONS(3192),
    [anon_sym_noreturn] = ACTIONS(3192),
    [anon_sym_mutable] = ACTIONS(3192),
    [anon_sym_constinit] = ACTIONS(3192),
    [anon_sym_consteval] = ACTIONS(3192),
    [anon_sym_PROGMEM] = ACTIONS(3192),
    [aux_sym_primitive_type_token1] = ACTIONS(3192),
    [anon_sym_byte] = ACTIONS(3192),
    [anon_sym_word] = ACTIONS(3192),
    [anon_sym_enum] = ACTIONS(3192),
    [anon_sym_class] = ACTIONS(3192),
    [anon_sym_struct] = ACTIONS(3192),
    [anon_sym_union] = ACTIONS(3192),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3192),
    [anon_sym_decltype] = ACTIONS(3192),
    [anon_sym_virtual] = ACTIONS(3192),
    [anon_sym_alignas] = ACTIONS(3192),
    [anon_sym_explicit] = ACTIONS(3192),
    [anon_sym_typename] = ACTIONS(3192),
    [anon_sym_template] = ACTIONS(3192),
    [anon_sym_operator] = ACTIONS(3192),
    [anon_sym_friend] = ACTIONS(3192),
    [anon_sym_public] = ACTIONS(3192),
    [anon_sym_private] = ACTIONS(3192),
    [anon_sym_protected] = ACTIONS(3192),
    [anon_sym_using] = ACTIONS(3192),
    [anon_sym_static_assert] = ACTIONS(3192),
  },
  [2534] = {
    [sym_identifier] = ACTIONS(5542),
    [aux_sym_preproc_def_token1] = ACTIONS(5542),
    [aux_sym_preproc_if_token1] = ACTIONS(5542),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5542),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5542),
    [sym_preproc_directive] = ACTIONS(5542),
    [anon_sym_LPAREN2] = ACTIONS(5544),
    [anon_sym_TILDE] = ACTIONS(5544),
    [anon_sym_STAR] = ACTIONS(5544),
    [anon_sym_AMP_AMP] = ACTIONS(5544),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5542),
    [anon_sym_typedef] = ACTIONS(5542),
    [anon_sym_extern] = ACTIONS(5542),
    [anon_sym___attribute__] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5544),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5544),
    [anon_sym___declspec] = ACTIONS(5542),
    [anon_sym___based] = ACTIONS(5542),
    [anon_sym_RBRACE] = ACTIONS(5544),
    [anon_sym_signed] = ACTIONS(5542),
    [anon_sym_unsigned] = ACTIONS(5542),
    [anon_sym_long] = ACTIONS(5542),
    [anon_sym_short] = ACTIONS(5542),
    [anon_sym_LBRACK] = ACTIONS(5542),
    [anon_sym_static] = ACTIONS(5542),
    [anon_sym_register] = ACTIONS(5542),
    [anon_sym_inline] = ACTIONS(5542),
    [anon_sym___inline] = ACTIONS(5542),
    [anon_sym___inline__] = ACTIONS(5542),
    [anon_sym___forceinline] = ACTIONS(5542),
    [anon_sym_thread_local] = ACTIONS(5542),
    [anon_sym___thread] = ACTIONS(5542),
    [anon_sym_const] = ACTIONS(5542),
    [anon_sym_constexpr] = ACTIONS(5542),
    [anon_sym_volatile] = ACTIONS(5542),
    [anon_sym_restrict] = ACTIONS(5542),
    [anon_sym___restrict__] = ACTIONS(5542),
    [anon_sym__Atomic] = ACTIONS(5542),
    [anon_sym__Noreturn] = ACTIONS(5542),
    [anon_sym_noreturn] = ACTIONS(5542),
    [anon_sym_mutable] = ACTIONS(5542),
    [anon_sym_constinit] = ACTIONS(5542),
    [anon_sym_consteval] = ACTIONS(5542),
    [anon_sym_PROGMEM] = ACTIONS(5542),
    [aux_sym_primitive_type_token1] = ACTIONS(5542),
    [anon_sym_byte] = ACTIONS(5542),
    [anon_sym_word] = ACTIONS(5542),
    [anon_sym_enum] = ACTIONS(5542),
    [anon_sym_class] = ACTIONS(5542),
    [anon_sym_struct] = ACTIONS(5542),
    [anon_sym_union] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5542),
    [anon_sym_decltype] = ACTIONS(5542),
    [anon_sym_virtual] = ACTIONS(5542),
    [anon_sym_alignas] = ACTIONS(5542),
    [anon_sym_explicit] = ACTIONS(5542),
    [anon_sym_typename] = ACTIONS(5542),
    [anon_sym_template] = ACTIONS(5542),
    [anon_sym_operator] = ACTIONS(5542),
    [anon_sym_friend] = ACTIONS(5542),
    [anon_sym_public] = ACTIONS(5542),
    [anon_sym_private] = ACTIONS(5542),
    [anon_sym_protected] = ACTIONS(5542),
    [anon_sym_using] = ACTIONS(5542),
    [anon_sym_static_assert] = ACTIONS(5542),
  },
  [2535] = {
    [sym_identifier] = ACTIONS(5566),
    [aux_sym_preproc_def_token1] = ACTIONS(5566),
    [aux_sym_preproc_if_token1] = ACTIONS(5566),
    [aux_sym_preproc_if_token2] = ACTIONS(5566),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5566),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5566),
    [sym_preproc_directive] = ACTIONS(5566),
    [anon_sym_LPAREN2] = ACTIONS(5568),
    [anon_sym_TILDE] = ACTIONS(5568),
    [anon_sym_STAR] = ACTIONS(5568),
    [anon_sym_AMP_AMP] = ACTIONS(5568),
    [anon_sym_AMP] = ACTIONS(5566),
    [anon_sym___extension__] = ACTIONS(5566),
    [anon_sym_typedef] = ACTIONS(5566),
    [anon_sym_extern] = ACTIONS(5566),
    [anon_sym___attribute__] = ACTIONS(5566),
    [anon_sym_COLON_COLON] = ACTIONS(5568),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5568),
    [anon_sym___declspec] = ACTIONS(5566),
    [anon_sym___based] = ACTIONS(5566),
    [anon_sym_signed] = ACTIONS(5566),
    [anon_sym_unsigned] = ACTIONS(5566),
    [anon_sym_long] = ACTIONS(5566),
    [anon_sym_short] = ACTIONS(5566),
    [anon_sym_LBRACK] = ACTIONS(5566),
    [anon_sym_static] = ACTIONS(5566),
    [anon_sym_register] = ACTIONS(5566),
    [anon_sym_inline] = ACTIONS(5566),
    [anon_sym___inline] = ACTIONS(5566),
    [anon_sym___inline__] = ACTIONS(5566),
    [anon_sym___forceinline] = ACTIONS(5566),
    [anon_sym_thread_local] = ACTIONS(5566),
    [anon_sym___thread] = ACTIONS(5566),
    [anon_sym_const] = ACTIONS(5566),
    [anon_sym_constexpr] = ACTIONS(5566),
    [anon_sym_volatile] = ACTIONS(5566),
    [anon_sym_restrict] = ACTIONS(5566),
    [anon_sym___restrict__] = ACTIONS(5566),
    [anon_sym__Atomic] = ACTIONS(5566),
    [anon_sym__Noreturn] = ACTIONS(5566),
    [anon_sym_noreturn] = ACTIONS(5566),
    [anon_sym_mutable] = ACTIONS(5566),
    [anon_sym_constinit] = ACTIONS(5566),
    [anon_sym_consteval] = ACTIONS(5566),
    [anon_sym_PROGMEM] = ACTIONS(5566),
    [aux_sym_primitive_type_token1] = ACTIONS(5566),
    [anon_sym_byte] = ACTIONS(5566),
    [anon_sym_word] = ACTIONS(5566),
    [anon_sym_enum] = ACTIONS(5566),
    [anon_sym_class] = ACTIONS(5566),
    [anon_sym_struct] = ACTIONS(5566),
    [anon_sym_union] = ACTIONS(5566),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5566),
    [anon_sym_decltype] = ACTIONS(5566),
    [anon_sym_virtual] = ACTIONS(5566),
    [anon_sym_alignas] = ACTIONS(5566),
    [anon_sym_explicit] = ACTIONS(5566),
    [anon_sym_typename] = ACTIONS(5566),
    [anon_sym_template] = ACTIONS(5566),
    [anon_sym_operator] = ACTIONS(5566),
    [anon_sym_friend] = ACTIONS(5566),
    [anon_sym_public] = ACTIONS(5566),
    [anon_sym_private] = ACTIONS(5566),
    [anon_sym_protected] = ACTIONS(5566),
    [anon_sym_using] = ACTIONS(5566),
    [anon_sym_static_assert] = ACTIONS(5566),
  },
  [2536] = {
    [sym_identifier] = ACTIONS(5562),
    [aux_sym_preproc_def_token1] = ACTIONS(5562),
    [aux_sym_preproc_if_token1] = ACTIONS(5562),
    [aux_sym_preproc_if_token2] = ACTIONS(5562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5562),
    [sym_preproc_directive] = ACTIONS(5562),
    [anon_sym_LPAREN2] = ACTIONS(5564),
    [anon_sym_TILDE] = ACTIONS(5564),
    [anon_sym_STAR] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5562),
    [anon_sym___extension__] = ACTIONS(5562),
    [anon_sym_typedef] = ACTIONS(5562),
    [anon_sym_extern] = ACTIONS(5562),
    [anon_sym___attribute__] = ACTIONS(5562),
    [anon_sym_COLON_COLON] = ACTIONS(5564),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5564),
    [anon_sym___declspec] = ACTIONS(5562),
    [anon_sym___based] = ACTIONS(5562),
    [anon_sym_signed] = ACTIONS(5562),
    [anon_sym_unsigned] = ACTIONS(5562),
    [anon_sym_long] = ACTIONS(5562),
    [anon_sym_short] = ACTIONS(5562),
    [anon_sym_LBRACK] = ACTIONS(5562),
    [anon_sym_static] = ACTIONS(5562),
    [anon_sym_register] = ACTIONS(5562),
    [anon_sym_inline] = ACTIONS(5562),
    [anon_sym___inline] = ACTIONS(5562),
    [anon_sym___inline__] = ACTIONS(5562),
    [anon_sym___forceinline] = ACTIONS(5562),
    [anon_sym_thread_local] = ACTIONS(5562),
    [anon_sym___thread] = ACTIONS(5562),
    [anon_sym_const] = ACTIONS(5562),
    [anon_sym_constexpr] = ACTIONS(5562),
    [anon_sym_volatile] = ACTIONS(5562),
    [anon_sym_restrict] = ACTIONS(5562),
    [anon_sym___restrict__] = ACTIONS(5562),
    [anon_sym__Atomic] = ACTIONS(5562),
    [anon_sym__Noreturn] = ACTIONS(5562),
    [anon_sym_noreturn] = ACTIONS(5562),
    [anon_sym_mutable] = ACTIONS(5562),
    [anon_sym_constinit] = ACTIONS(5562),
    [anon_sym_consteval] = ACTIONS(5562),
    [anon_sym_PROGMEM] = ACTIONS(5562),
    [aux_sym_primitive_type_token1] = ACTIONS(5562),
    [anon_sym_byte] = ACTIONS(5562),
    [anon_sym_word] = ACTIONS(5562),
    [anon_sym_enum] = ACTIONS(5562),
    [anon_sym_class] = ACTIONS(5562),
    [anon_sym_struct] = ACTIONS(5562),
    [anon_sym_union] = ACTIONS(5562),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5562),
    [anon_sym_decltype] = ACTIONS(5562),
    [anon_sym_virtual] = ACTIONS(5562),
    [anon_sym_alignas] = ACTIONS(5562),
    [anon_sym_explicit] = ACTIONS(5562),
    [anon_sym_typename] = ACTIONS(5562),
    [anon_sym_template] = ACTIONS(5562),
    [anon_sym_operator] = ACTIONS(5562),
    [anon_sym_friend] = ACTIONS(5562),
    [anon_sym_public] = ACTIONS(5562),
    [anon_sym_private] = ACTIONS(5562),
    [anon_sym_protected] = ACTIONS(5562),
    [anon_sym_using] = ACTIONS(5562),
    [anon_sym_static_assert] = ACTIONS(5562),
  },
  [2537] = {
    [sym_identifier] = ACTIONS(5546),
    [aux_sym_preproc_def_token1] = ACTIONS(5546),
    [aux_sym_preproc_if_token1] = ACTIONS(5546),
    [aux_sym_preproc_if_token2] = ACTIONS(5546),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5546),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5546),
    [sym_preproc_directive] = ACTIONS(5546),
    [anon_sym_LPAREN2] = ACTIONS(5548),
    [anon_sym_TILDE] = ACTIONS(5548),
    [anon_sym_STAR] = ACTIONS(5548),
    [anon_sym_AMP_AMP] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5546),
    [anon_sym___extension__] = ACTIONS(5546),
    [anon_sym_typedef] = ACTIONS(5546),
    [anon_sym_extern] = ACTIONS(5546),
    [anon_sym___attribute__] = ACTIONS(5546),
    [anon_sym_COLON_COLON] = ACTIONS(5548),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5548),
    [anon_sym___declspec] = ACTIONS(5546),
    [anon_sym___based] = ACTIONS(5546),
    [anon_sym_signed] = ACTIONS(5546),
    [anon_sym_unsigned] = ACTIONS(5546),
    [anon_sym_long] = ACTIONS(5546),
    [anon_sym_short] = ACTIONS(5546),
    [anon_sym_LBRACK] = ACTIONS(5546),
    [anon_sym_static] = ACTIONS(5546),
    [anon_sym_register] = ACTIONS(5546),
    [anon_sym_inline] = ACTIONS(5546),
    [anon_sym___inline] = ACTIONS(5546),
    [anon_sym___inline__] = ACTIONS(5546),
    [anon_sym___forceinline] = ACTIONS(5546),
    [anon_sym_thread_local] = ACTIONS(5546),
    [anon_sym___thread] = ACTIONS(5546),
    [anon_sym_const] = ACTIONS(5546),
    [anon_sym_constexpr] = ACTIONS(5546),
    [anon_sym_volatile] = ACTIONS(5546),
    [anon_sym_restrict] = ACTIONS(5546),
    [anon_sym___restrict__] = ACTIONS(5546),
    [anon_sym__Atomic] = ACTIONS(5546),
    [anon_sym__Noreturn] = ACTIONS(5546),
    [anon_sym_noreturn] = ACTIONS(5546),
    [anon_sym_mutable] = ACTIONS(5546),
    [anon_sym_constinit] = ACTIONS(5546),
    [anon_sym_consteval] = ACTIONS(5546),
    [anon_sym_PROGMEM] = ACTIONS(5546),
    [aux_sym_primitive_type_token1] = ACTIONS(5546),
    [anon_sym_byte] = ACTIONS(5546),
    [anon_sym_word] = ACTIONS(5546),
    [anon_sym_enum] = ACTIONS(5546),
    [anon_sym_class] = ACTIONS(5546),
    [anon_sym_struct] = ACTIONS(5546),
    [anon_sym_union] = ACTIONS(5546),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5546),
    [anon_sym_decltype] = ACTIONS(5546),
    [anon_sym_virtual] = ACTIONS(5546),
    [anon_sym_alignas] = ACTIONS(5546),
    [anon_sym_explicit] = ACTIONS(5546),
    [anon_sym_typename] = ACTIONS(5546),
    [anon_sym_template] = ACTIONS(5546),
    [anon_sym_operator] = ACTIONS(5546),
    [anon_sym_friend] = ACTIONS(5546),
    [anon_sym_public] = ACTIONS(5546),
    [anon_sym_private] = ACTIONS(5546),
    [anon_sym_protected] = ACTIONS(5546),
    [anon_sym_using] = ACTIONS(5546),
    [anon_sym_static_assert] = ACTIONS(5546),
  },
  [2538] = {
    [sym_identifier] = ACTIONS(3509),
    [aux_sym_preproc_def_token1] = ACTIONS(3509),
    [aux_sym_preproc_if_token1] = ACTIONS(3509),
    [aux_sym_preproc_if_token2] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3509),
    [sym_preproc_directive] = ACTIONS(3509),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3511),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym___extension__] = ACTIONS(3509),
    [anon_sym_typedef] = ACTIONS(3509),
    [anon_sym_extern] = ACTIONS(3509),
    [anon_sym___attribute__] = ACTIONS(3509),
    [anon_sym_COLON_COLON] = ACTIONS(3511),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3511),
    [anon_sym___declspec] = ACTIONS(3509),
    [anon_sym___based] = ACTIONS(3509),
    [anon_sym_signed] = ACTIONS(3509),
    [anon_sym_unsigned] = ACTIONS(3509),
    [anon_sym_long] = ACTIONS(3509),
    [anon_sym_short] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(3509),
    [anon_sym_static] = ACTIONS(3509),
    [anon_sym_register] = ACTIONS(3509),
    [anon_sym_inline] = ACTIONS(3509),
    [anon_sym___inline] = ACTIONS(3509),
    [anon_sym___inline__] = ACTIONS(3509),
    [anon_sym___forceinline] = ACTIONS(3509),
    [anon_sym_thread_local] = ACTIONS(3509),
    [anon_sym___thread] = ACTIONS(3509),
    [anon_sym_const] = ACTIONS(3509),
    [anon_sym_constexpr] = ACTIONS(3509),
    [anon_sym_volatile] = ACTIONS(3509),
    [anon_sym_restrict] = ACTIONS(3509),
    [anon_sym___restrict__] = ACTIONS(3509),
    [anon_sym__Atomic] = ACTIONS(3509),
    [anon_sym__Noreturn] = ACTIONS(3509),
    [anon_sym_noreturn] = ACTIONS(3509),
    [anon_sym_mutable] = ACTIONS(3509),
    [anon_sym_constinit] = ACTIONS(3509),
    [anon_sym_consteval] = ACTIONS(3509),
    [anon_sym_PROGMEM] = ACTIONS(3509),
    [aux_sym_primitive_type_token1] = ACTIONS(3509),
    [anon_sym_byte] = ACTIONS(3509),
    [anon_sym_word] = ACTIONS(3509),
    [anon_sym_enum] = ACTIONS(3509),
    [anon_sym_class] = ACTIONS(3509),
    [anon_sym_struct] = ACTIONS(3509),
    [anon_sym_union] = ACTIONS(3509),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3509),
    [anon_sym_decltype] = ACTIONS(3509),
    [anon_sym_virtual] = ACTIONS(3509),
    [anon_sym_alignas] = ACTIONS(3509),
    [anon_sym_explicit] = ACTIONS(3509),
    [anon_sym_typename] = ACTIONS(3509),
    [anon_sym_template] = ACTIONS(3509),
    [anon_sym_operator] = ACTIONS(3509),
    [anon_sym_friend] = ACTIONS(3509),
    [anon_sym_public] = ACTIONS(3509),
    [anon_sym_private] = ACTIONS(3509),
    [anon_sym_protected] = ACTIONS(3509),
    [anon_sym_using] = ACTIONS(3509),
    [anon_sym_static_assert] = ACTIONS(3509),
  },
  [2539] = {
    [sym_identifier] = ACTIONS(3521),
    [aux_sym_preproc_def_token1] = ACTIONS(3521),
    [aux_sym_preproc_if_token1] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3521),
    [sym_preproc_directive] = ACTIONS(3521),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3521),
    [anon_sym___extension__] = ACTIONS(3521),
    [anon_sym_typedef] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym___attribute__] = ACTIONS(3521),
    [anon_sym_COLON_COLON] = ACTIONS(3523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3523),
    [anon_sym___declspec] = ACTIONS(3521),
    [anon_sym___based] = ACTIONS(3521),
    [anon_sym_RBRACE] = ACTIONS(3523),
    [anon_sym_signed] = ACTIONS(3521),
    [anon_sym_unsigned] = ACTIONS(3521),
    [anon_sym_long] = ACTIONS(3521),
    [anon_sym_short] = ACTIONS(3521),
    [anon_sym_LBRACK] = ACTIONS(3521),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_register] = ACTIONS(3521),
    [anon_sym_inline] = ACTIONS(3521),
    [anon_sym___inline] = ACTIONS(3521),
    [anon_sym___inline__] = ACTIONS(3521),
    [anon_sym___forceinline] = ACTIONS(3521),
    [anon_sym_thread_local] = ACTIONS(3521),
    [anon_sym___thread] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_constexpr] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym_restrict] = ACTIONS(3521),
    [anon_sym___restrict__] = ACTIONS(3521),
    [anon_sym__Atomic] = ACTIONS(3521),
    [anon_sym__Noreturn] = ACTIONS(3521),
    [anon_sym_noreturn] = ACTIONS(3521),
    [anon_sym_mutable] = ACTIONS(3521),
    [anon_sym_constinit] = ACTIONS(3521),
    [anon_sym_consteval] = ACTIONS(3521),
    [anon_sym_PROGMEM] = ACTIONS(3521),
    [aux_sym_primitive_type_token1] = ACTIONS(3521),
    [anon_sym_byte] = ACTIONS(3521),
    [anon_sym_word] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_class] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_union] = ACTIONS(3521),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3521),
    [anon_sym_decltype] = ACTIONS(3521),
    [anon_sym_virtual] = ACTIONS(3521),
    [anon_sym_alignas] = ACTIONS(3521),
    [anon_sym_explicit] = ACTIONS(3521),
    [anon_sym_typename] = ACTIONS(3521),
    [anon_sym_template] = ACTIONS(3521),
    [anon_sym_operator] = ACTIONS(3521),
    [anon_sym_friend] = ACTIONS(3521),
    [anon_sym_public] = ACTIONS(3521),
    [anon_sym_private] = ACTIONS(3521),
    [anon_sym_protected] = ACTIONS(3521),
    [anon_sym_using] = ACTIONS(3521),
    [anon_sym_static_assert] = ACTIONS(3521),
  },
  [2540] = {
    [sym_identifier] = ACTIONS(3517),
    [aux_sym_preproc_def_token1] = ACTIONS(3517),
    [aux_sym_preproc_if_token1] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3517),
    [sym_preproc_directive] = ACTIONS(3517),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym___extension__] = ACTIONS(3517),
    [anon_sym_typedef] = ACTIONS(3517),
    [anon_sym_extern] = ACTIONS(3517),
    [anon_sym___attribute__] = ACTIONS(3517),
    [anon_sym_COLON_COLON] = ACTIONS(3519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3519),
    [anon_sym___declspec] = ACTIONS(3517),
    [anon_sym___based] = ACTIONS(3517),
    [anon_sym_RBRACE] = ACTIONS(3519),
    [anon_sym_signed] = ACTIONS(3517),
    [anon_sym_unsigned] = ACTIONS(3517),
    [anon_sym_long] = ACTIONS(3517),
    [anon_sym_short] = ACTIONS(3517),
    [anon_sym_LBRACK] = ACTIONS(3517),
    [anon_sym_static] = ACTIONS(3517),
    [anon_sym_register] = ACTIONS(3517),
    [anon_sym_inline] = ACTIONS(3517),
    [anon_sym___inline] = ACTIONS(3517),
    [anon_sym___inline__] = ACTIONS(3517),
    [anon_sym___forceinline] = ACTIONS(3517),
    [anon_sym_thread_local] = ACTIONS(3517),
    [anon_sym___thread] = ACTIONS(3517),
    [anon_sym_const] = ACTIONS(3517),
    [anon_sym_constexpr] = ACTIONS(3517),
    [anon_sym_volatile] = ACTIONS(3517),
    [anon_sym_restrict] = ACTIONS(3517),
    [anon_sym___restrict__] = ACTIONS(3517),
    [anon_sym__Atomic] = ACTIONS(3517),
    [anon_sym__Noreturn] = ACTIONS(3517),
    [anon_sym_noreturn] = ACTIONS(3517),
    [anon_sym_mutable] = ACTIONS(3517),
    [anon_sym_constinit] = ACTIONS(3517),
    [anon_sym_consteval] = ACTIONS(3517),
    [anon_sym_PROGMEM] = ACTIONS(3517),
    [aux_sym_primitive_type_token1] = ACTIONS(3517),
    [anon_sym_byte] = ACTIONS(3517),
    [anon_sym_word] = ACTIONS(3517),
    [anon_sym_enum] = ACTIONS(3517),
    [anon_sym_class] = ACTIONS(3517),
    [anon_sym_struct] = ACTIONS(3517),
    [anon_sym_union] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3517),
    [anon_sym_decltype] = ACTIONS(3517),
    [anon_sym_virtual] = ACTIONS(3517),
    [anon_sym_alignas] = ACTIONS(3517),
    [anon_sym_explicit] = ACTIONS(3517),
    [anon_sym_typename] = ACTIONS(3517),
    [anon_sym_template] = ACTIONS(3517),
    [anon_sym_operator] = ACTIONS(3517),
    [anon_sym_friend] = ACTIONS(3517),
    [anon_sym_public] = ACTIONS(3517),
    [anon_sym_private] = ACTIONS(3517),
    [anon_sym_protected] = ACTIONS(3517),
    [anon_sym_using] = ACTIONS(3517),
    [anon_sym_static_assert] = ACTIONS(3517),
  },
  [2541] = {
    [sym_identifier] = ACTIONS(5534),
    [aux_sym_preproc_def_token1] = ACTIONS(5534),
    [aux_sym_preproc_if_token1] = ACTIONS(5534),
    [aux_sym_preproc_if_token2] = ACTIONS(5534),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5534),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5534),
    [sym_preproc_directive] = ACTIONS(5534),
    [anon_sym_LPAREN2] = ACTIONS(5536),
    [anon_sym_TILDE] = ACTIONS(5536),
    [anon_sym_STAR] = ACTIONS(5536),
    [anon_sym_AMP_AMP] = ACTIONS(5536),
    [anon_sym_AMP] = ACTIONS(5534),
    [anon_sym___extension__] = ACTIONS(5534),
    [anon_sym_typedef] = ACTIONS(5534),
    [anon_sym_extern] = ACTIONS(5534),
    [anon_sym___attribute__] = ACTIONS(5534),
    [anon_sym_COLON_COLON] = ACTIONS(5536),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5536),
    [anon_sym___declspec] = ACTIONS(5534),
    [anon_sym___based] = ACTIONS(5534),
    [anon_sym_signed] = ACTIONS(5534),
    [anon_sym_unsigned] = ACTIONS(5534),
    [anon_sym_long] = ACTIONS(5534),
    [anon_sym_short] = ACTIONS(5534),
    [anon_sym_LBRACK] = ACTIONS(5534),
    [anon_sym_static] = ACTIONS(5534),
    [anon_sym_register] = ACTIONS(5534),
    [anon_sym_inline] = ACTIONS(5534),
    [anon_sym___inline] = ACTIONS(5534),
    [anon_sym___inline__] = ACTIONS(5534),
    [anon_sym___forceinline] = ACTIONS(5534),
    [anon_sym_thread_local] = ACTIONS(5534),
    [anon_sym___thread] = ACTIONS(5534),
    [anon_sym_const] = ACTIONS(5534),
    [anon_sym_constexpr] = ACTIONS(5534),
    [anon_sym_volatile] = ACTIONS(5534),
    [anon_sym_restrict] = ACTIONS(5534),
    [anon_sym___restrict__] = ACTIONS(5534),
    [anon_sym__Atomic] = ACTIONS(5534),
    [anon_sym__Noreturn] = ACTIONS(5534),
    [anon_sym_noreturn] = ACTIONS(5534),
    [anon_sym_mutable] = ACTIONS(5534),
    [anon_sym_constinit] = ACTIONS(5534),
    [anon_sym_consteval] = ACTIONS(5534),
    [anon_sym_PROGMEM] = ACTIONS(5534),
    [aux_sym_primitive_type_token1] = ACTIONS(5534),
    [anon_sym_byte] = ACTIONS(5534),
    [anon_sym_word] = ACTIONS(5534),
    [anon_sym_enum] = ACTIONS(5534),
    [anon_sym_class] = ACTIONS(5534),
    [anon_sym_struct] = ACTIONS(5534),
    [anon_sym_union] = ACTIONS(5534),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5534),
    [anon_sym_decltype] = ACTIONS(5534),
    [anon_sym_virtual] = ACTIONS(5534),
    [anon_sym_alignas] = ACTIONS(5534),
    [anon_sym_explicit] = ACTIONS(5534),
    [anon_sym_typename] = ACTIONS(5534),
    [anon_sym_template] = ACTIONS(5534),
    [anon_sym_operator] = ACTIONS(5534),
    [anon_sym_friend] = ACTIONS(5534),
    [anon_sym_public] = ACTIONS(5534),
    [anon_sym_private] = ACTIONS(5534),
    [anon_sym_protected] = ACTIONS(5534),
    [anon_sym_using] = ACTIONS(5534),
    [anon_sym_static_assert] = ACTIONS(5534),
  },
  [2542] = {
    [sym_identifier] = ACTIONS(5570),
    [aux_sym_preproc_def_token1] = ACTIONS(5570),
    [aux_sym_preproc_if_token1] = ACTIONS(5570),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5570),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5570),
    [sym_preproc_directive] = ACTIONS(5570),
    [anon_sym_LPAREN2] = ACTIONS(5572),
    [anon_sym_TILDE] = ACTIONS(5572),
    [anon_sym_STAR] = ACTIONS(5572),
    [anon_sym_AMP_AMP] = ACTIONS(5572),
    [anon_sym_AMP] = ACTIONS(5570),
    [anon_sym___extension__] = ACTIONS(5570),
    [anon_sym_typedef] = ACTIONS(5570),
    [anon_sym_extern] = ACTIONS(5570),
    [anon_sym___attribute__] = ACTIONS(5570),
    [anon_sym_COLON_COLON] = ACTIONS(5572),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5572),
    [anon_sym___declspec] = ACTIONS(5570),
    [anon_sym___based] = ACTIONS(5570),
    [anon_sym_RBRACE] = ACTIONS(5572),
    [anon_sym_signed] = ACTIONS(5570),
    [anon_sym_unsigned] = ACTIONS(5570),
    [anon_sym_long] = ACTIONS(5570),
    [anon_sym_short] = ACTIONS(5570),
    [anon_sym_LBRACK] = ACTIONS(5570),
    [anon_sym_static] = ACTIONS(5570),
    [anon_sym_register] = ACTIONS(5570),
    [anon_sym_inline] = ACTIONS(5570),
    [anon_sym___inline] = ACTIONS(5570),
    [anon_sym___inline__] = ACTIONS(5570),
    [anon_sym___forceinline] = ACTIONS(5570),
    [anon_sym_thread_local] = ACTIONS(5570),
    [anon_sym___thread] = ACTIONS(5570),
    [anon_sym_const] = ACTIONS(5570),
    [anon_sym_constexpr] = ACTIONS(5570),
    [anon_sym_volatile] = ACTIONS(5570),
    [anon_sym_restrict] = ACTIONS(5570),
    [anon_sym___restrict__] = ACTIONS(5570),
    [anon_sym__Atomic] = ACTIONS(5570),
    [anon_sym__Noreturn] = ACTIONS(5570),
    [anon_sym_noreturn] = ACTIONS(5570),
    [anon_sym_mutable] = ACTIONS(5570),
    [anon_sym_constinit] = ACTIONS(5570),
    [anon_sym_consteval] = ACTIONS(5570),
    [anon_sym_PROGMEM] = ACTIONS(5570),
    [aux_sym_primitive_type_token1] = ACTIONS(5570),
    [anon_sym_byte] = ACTIONS(5570),
    [anon_sym_word] = ACTIONS(5570),
    [anon_sym_enum] = ACTIONS(5570),
    [anon_sym_class] = ACTIONS(5570),
    [anon_sym_struct] = ACTIONS(5570),
    [anon_sym_union] = ACTIONS(5570),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5570),
    [anon_sym_decltype] = ACTIONS(5570),
    [anon_sym_virtual] = ACTIONS(5570),
    [anon_sym_alignas] = ACTIONS(5570),
    [anon_sym_explicit] = ACTIONS(5570),
    [anon_sym_typename] = ACTIONS(5570),
    [anon_sym_template] = ACTIONS(5570),
    [anon_sym_operator] = ACTIONS(5570),
    [anon_sym_friend] = ACTIONS(5570),
    [anon_sym_public] = ACTIONS(5570),
    [anon_sym_private] = ACTIONS(5570),
    [anon_sym_protected] = ACTIONS(5570),
    [anon_sym_using] = ACTIONS(5570),
    [anon_sym_static_assert] = ACTIONS(5570),
  },
  [2543] = {
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token2] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_PROGMEM] = ACTIONS(3513),
    [aux_sym_primitive_type_token1] = ACTIONS(3513),
    [anon_sym_byte] = ACTIONS(3513),
    [anon_sym_word] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [anon_sym_virtual] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_friend] = ACTIONS(3513),
    [anon_sym_public] = ACTIONS(3513),
    [anon_sym_private] = ACTIONS(3513),
    [anon_sym_protected] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
  },
  [2544] = {
    [sym_identifier] = ACTIONS(5530),
    [aux_sym_preproc_def_token1] = ACTIONS(5530),
    [aux_sym_preproc_if_token1] = ACTIONS(5530),
    [aux_sym_preproc_if_token2] = ACTIONS(5530),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5530),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5530),
    [sym_preproc_directive] = ACTIONS(5530),
    [anon_sym_LPAREN2] = ACTIONS(5532),
    [anon_sym_TILDE] = ACTIONS(5532),
    [anon_sym_STAR] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5530),
    [anon_sym___extension__] = ACTIONS(5530),
    [anon_sym_typedef] = ACTIONS(5530),
    [anon_sym_extern] = ACTIONS(5530),
    [anon_sym___attribute__] = ACTIONS(5530),
    [anon_sym_COLON_COLON] = ACTIONS(5532),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5532),
    [anon_sym___declspec] = ACTIONS(5530),
    [anon_sym___based] = ACTIONS(5530),
    [anon_sym_signed] = ACTIONS(5530),
    [anon_sym_unsigned] = ACTIONS(5530),
    [anon_sym_long] = ACTIONS(5530),
    [anon_sym_short] = ACTIONS(5530),
    [anon_sym_LBRACK] = ACTIONS(5530),
    [anon_sym_static] = ACTIONS(5530),
    [anon_sym_register] = ACTIONS(5530),
    [anon_sym_inline] = ACTIONS(5530),
    [anon_sym___inline] = ACTIONS(5530),
    [anon_sym___inline__] = ACTIONS(5530),
    [anon_sym___forceinline] = ACTIONS(5530),
    [anon_sym_thread_local] = ACTIONS(5530),
    [anon_sym___thread] = ACTIONS(5530),
    [anon_sym_const] = ACTIONS(5530),
    [anon_sym_constexpr] = ACTIONS(5530),
    [anon_sym_volatile] = ACTIONS(5530),
    [anon_sym_restrict] = ACTIONS(5530),
    [anon_sym___restrict__] = ACTIONS(5530),
    [anon_sym__Atomic] = ACTIONS(5530),
    [anon_sym__Noreturn] = ACTIONS(5530),
    [anon_sym_noreturn] = ACTIONS(5530),
    [anon_sym_mutable] = ACTIONS(5530),
    [anon_sym_constinit] = ACTIONS(5530),
    [anon_sym_consteval] = ACTIONS(5530),
    [anon_sym_PROGMEM] = ACTIONS(5530),
    [aux_sym_primitive_type_token1] = ACTIONS(5530),
    [anon_sym_byte] = ACTIONS(5530),
    [anon_sym_word] = ACTIONS(5530),
    [anon_sym_enum] = ACTIONS(5530),
    [anon_sym_class] = ACTIONS(5530),
    [anon_sym_struct] = ACTIONS(5530),
    [anon_sym_union] = ACTIONS(5530),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5530),
    [anon_sym_decltype] = ACTIONS(5530),
    [anon_sym_virtual] = ACTIONS(5530),
    [anon_sym_alignas] = ACTIONS(5530),
    [anon_sym_explicit] = ACTIONS(5530),
    [anon_sym_typename] = ACTIONS(5530),
    [anon_sym_template] = ACTIONS(5530),
    [anon_sym_operator] = ACTIONS(5530),
    [anon_sym_friend] = ACTIONS(5530),
    [anon_sym_public] = ACTIONS(5530),
    [anon_sym_private] = ACTIONS(5530),
    [anon_sym_protected] = ACTIONS(5530),
    [anon_sym_using] = ACTIONS(5530),
    [anon_sym_static_assert] = ACTIONS(5530),
  },
  [2545] = {
    [sym_identifier] = ACTIONS(3403),
    [aux_sym_preproc_def_token1] = ACTIONS(3403),
    [aux_sym_preproc_if_token1] = ACTIONS(3403),
    [aux_sym_preproc_if_token2] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3403),
    [sym_preproc_directive] = ACTIONS(3403),
    [anon_sym_LPAREN2] = ACTIONS(3405),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_STAR] = ACTIONS(3405),
    [anon_sym_AMP_AMP] = ACTIONS(3405),
    [anon_sym_AMP] = ACTIONS(3403),
    [anon_sym___extension__] = ACTIONS(3403),
    [anon_sym_typedef] = ACTIONS(3403),
    [anon_sym_extern] = ACTIONS(3403),
    [anon_sym___attribute__] = ACTIONS(3403),
    [anon_sym_COLON_COLON] = ACTIONS(3405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3405),
    [anon_sym___declspec] = ACTIONS(3403),
    [anon_sym___based] = ACTIONS(3403),
    [anon_sym_signed] = ACTIONS(3403),
    [anon_sym_unsigned] = ACTIONS(3403),
    [anon_sym_long] = ACTIONS(3403),
    [anon_sym_short] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3403),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_register] = ACTIONS(3403),
    [anon_sym_inline] = ACTIONS(3403),
    [anon_sym___inline] = ACTIONS(3403),
    [anon_sym___inline__] = ACTIONS(3403),
    [anon_sym___forceinline] = ACTIONS(3403),
    [anon_sym_thread_local] = ACTIONS(3403),
    [anon_sym___thread] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_constexpr] = ACTIONS(3403),
    [anon_sym_volatile] = ACTIONS(3403),
    [anon_sym_restrict] = ACTIONS(3403),
    [anon_sym___restrict__] = ACTIONS(3403),
    [anon_sym__Atomic] = ACTIONS(3403),
    [anon_sym__Noreturn] = ACTIONS(3403),
    [anon_sym_noreturn] = ACTIONS(3403),
    [anon_sym_mutable] = ACTIONS(3403),
    [anon_sym_constinit] = ACTIONS(3403),
    [anon_sym_consteval] = ACTIONS(3403),
    [anon_sym_PROGMEM] = ACTIONS(3403),
    [aux_sym_primitive_type_token1] = ACTIONS(3403),
    [anon_sym_byte] = ACTIONS(3403),
    [anon_sym_word] = ACTIONS(3403),
    [anon_sym_enum] = ACTIONS(3403),
    [anon_sym_class] = ACTIONS(3403),
    [anon_sym_struct] = ACTIONS(3403),
    [anon_sym_union] = ACTIONS(3403),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3403),
    [anon_sym_decltype] = ACTIONS(3403),
    [anon_sym_virtual] = ACTIONS(3403),
    [anon_sym_alignas] = ACTIONS(3403),
    [anon_sym_explicit] = ACTIONS(3403),
    [anon_sym_typename] = ACTIONS(3403),
    [anon_sym_template] = ACTIONS(3403),
    [anon_sym_operator] = ACTIONS(3403),
    [anon_sym_friend] = ACTIONS(3403),
    [anon_sym_public] = ACTIONS(3403),
    [anon_sym_private] = ACTIONS(3403),
    [anon_sym_protected] = ACTIONS(3403),
    [anon_sym_using] = ACTIONS(3403),
    [anon_sym_static_assert] = ACTIONS(3403),
  },
  [2546] = {
    [sym_identifier] = ACTIONS(3993),
    [aux_sym_preproc_def_token1] = ACTIONS(3993),
    [aux_sym_preproc_if_token1] = ACTIONS(3993),
    [aux_sym_preproc_if_token2] = ACTIONS(3993),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3993),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3993),
    [sym_preproc_directive] = ACTIONS(3993),
    [anon_sym_LPAREN2] = ACTIONS(3991),
    [anon_sym_TILDE] = ACTIONS(3991),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym___extension__] = ACTIONS(3993),
    [anon_sym_typedef] = ACTIONS(3993),
    [anon_sym_extern] = ACTIONS(3993),
    [anon_sym___attribute__] = ACTIONS(3993),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3991),
    [anon_sym___declspec] = ACTIONS(3993),
    [anon_sym___based] = ACTIONS(3993),
    [anon_sym_signed] = ACTIONS(3993),
    [anon_sym_unsigned] = ACTIONS(3993),
    [anon_sym_long] = ACTIONS(3993),
    [anon_sym_short] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3993),
    [anon_sym_static] = ACTIONS(3993),
    [anon_sym_register] = ACTIONS(3993),
    [anon_sym_inline] = ACTIONS(3993),
    [anon_sym___inline] = ACTIONS(3993),
    [anon_sym___inline__] = ACTIONS(3993),
    [anon_sym___forceinline] = ACTIONS(3993),
    [anon_sym_thread_local] = ACTIONS(3993),
    [anon_sym___thread] = ACTIONS(3993),
    [anon_sym_const] = ACTIONS(3993),
    [anon_sym_constexpr] = ACTIONS(3993),
    [anon_sym_volatile] = ACTIONS(3993),
    [anon_sym_restrict] = ACTIONS(3993),
    [anon_sym___restrict__] = ACTIONS(3993),
    [anon_sym__Atomic] = ACTIONS(3993),
    [anon_sym__Noreturn] = ACTIONS(3993),
    [anon_sym_noreturn] = ACTIONS(3993),
    [anon_sym_mutable] = ACTIONS(3993),
    [anon_sym_constinit] = ACTIONS(3993),
    [anon_sym_consteval] = ACTIONS(3993),
    [anon_sym_PROGMEM] = ACTIONS(3993),
    [aux_sym_primitive_type_token1] = ACTIONS(3993),
    [anon_sym_byte] = ACTIONS(3993),
    [anon_sym_word] = ACTIONS(3993),
    [anon_sym_enum] = ACTIONS(3993),
    [anon_sym_class] = ACTIONS(3993),
    [anon_sym_struct] = ACTIONS(3993),
    [anon_sym_union] = ACTIONS(3993),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3993),
    [anon_sym_decltype] = ACTIONS(3993),
    [anon_sym_virtual] = ACTIONS(3993),
    [anon_sym_alignas] = ACTIONS(3993),
    [anon_sym_explicit] = ACTIONS(3993),
    [anon_sym_typename] = ACTIONS(3993),
    [anon_sym_template] = ACTIONS(3993),
    [anon_sym_operator] = ACTIONS(3993),
    [anon_sym_friend] = ACTIONS(3993),
    [anon_sym_public] = ACTIONS(3993),
    [anon_sym_private] = ACTIONS(3993),
    [anon_sym_protected] = ACTIONS(3993),
    [anon_sym_using] = ACTIONS(3993),
    [anon_sym_static_assert] = ACTIONS(3993),
  },
  [2547] = {
    [sym_identifier] = ACTIONS(3371),
    [aux_sym_preproc_def_token1] = ACTIONS(3371),
    [aux_sym_preproc_if_token1] = ACTIONS(3371),
    [aux_sym_preproc_if_token2] = ACTIONS(3371),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3371),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3371),
    [sym_preproc_directive] = ACTIONS(3371),
    [anon_sym_LPAREN2] = ACTIONS(3373),
    [anon_sym_TILDE] = ACTIONS(3373),
    [anon_sym_STAR] = ACTIONS(3373),
    [anon_sym_AMP_AMP] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3371),
    [anon_sym___extension__] = ACTIONS(3371),
    [anon_sym_typedef] = ACTIONS(3371),
    [anon_sym_extern] = ACTIONS(3371),
    [anon_sym___attribute__] = ACTIONS(3371),
    [anon_sym_COLON_COLON] = ACTIONS(3373),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3373),
    [anon_sym___declspec] = ACTIONS(3371),
    [anon_sym___based] = ACTIONS(3371),
    [anon_sym_signed] = ACTIONS(3371),
    [anon_sym_unsigned] = ACTIONS(3371),
    [anon_sym_long] = ACTIONS(3371),
    [anon_sym_short] = ACTIONS(3371),
    [anon_sym_LBRACK] = ACTIONS(3371),
    [anon_sym_static] = ACTIONS(3371),
    [anon_sym_register] = ACTIONS(3371),
    [anon_sym_inline] = ACTIONS(3371),
    [anon_sym___inline] = ACTIONS(3371),
    [anon_sym___inline__] = ACTIONS(3371),
    [anon_sym___forceinline] = ACTIONS(3371),
    [anon_sym_thread_local] = ACTIONS(3371),
    [anon_sym___thread] = ACTIONS(3371),
    [anon_sym_const] = ACTIONS(3371),
    [anon_sym_constexpr] = ACTIONS(3371),
    [anon_sym_volatile] = ACTIONS(3371),
    [anon_sym_restrict] = ACTIONS(3371),
    [anon_sym___restrict__] = ACTIONS(3371),
    [anon_sym__Atomic] = ACTIONS(3371),
    [anon_sym__Noreturn] = ACTIONS(3371),
    [anon_sym_noreturn] = ACTIONS(3371),
    [anon_sym_mutable] = ACTIONS(3371),
    [anon_sym_constinit] = ACTIONS(3371),
    [anon_sym_consteval] = ACTIONS(3371),
    [anon_sym_PROGMEM] = ACTIONS(3371),
    [aux_sym_primitive_type_token1] = ACTIONS(3371),
    [anon_sym_byte] = ACTIONS(3371),
    [anon_sym_word] = ACTIONS(3371),
    [anon_sym_enum] = ACTIONS(3371),
    [anon_sym_class] = ACTIONS(3371),
    [anon_sym_struct] = ACTIONS(3371),
    [anon_sym_union] = ACTIONS(3371),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3371),
    [anon_sym_decltype] = ACTIONS(3371),
    [anon_sym_virtual] = ACTIONS(3371),
    [anon_sym_alignas] = ACTIONS(3371),
    [anon_sym_explicit] = ACTIONS(3371),
    [anon_sym_typename] = ACTIONS(3371),
    [anon_sym_template] = ACTIONS(3371),
    [anon_sym_operator] = ACTIONS(3371),
    [anon_sym_friend] = ACTIONS(3371),
    [anon_sym_public] = ACTIONS(3371),
    [anon_sym_private] = ACTIONS(3371),
    [anon_sym_protected] = ACTIONS(3371),
    [anon_sym_using] = ACTIONS(3371),
    [anon_sym_static_assert] = ACTIONS(3371),
  },
  [2548] = {
    [sym_identifier] = ACTIONS(5526),
    [aux_sym_preproc_def_token1] = ACTIONS(5526),
    [aux_sym_preproc_if_token1] = ACTIONS(5526),
    [aux_sym_preproc_if_token2] = ACTIONS(5526),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5526),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5526),
    [sym_preproc_directive] = ACTIONS(5526),
    [anon_sym_LPAREN2] = ACTIONS(5528),
    [anon_sym_TILDE] = ACTIONS(5528),
    [anon_sym_STAR] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5526),
    [anon_sym___extension__] = ACTIONS(5526),
    [anon_sym_typedef] = ACTIONS(5526),
    [anon_sym_extern] = ACTIONS(5526),
    [anon_sym___attribute__] = ACTIONS(5526),
    [anon_sym_COLON_COLON] = ACTIONS(5528),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5528),
    [anon_sym___declspec] = ACTIONS(5526),
    [anon_sym___based] = ACTIONS(5526),
    [anon_sym_signed] = ACTIONS(5526),
    [anon_sym_unsigned] = ACTIONS(5526),
    [anon_sym_long] = ACTIONS(5526),
    [anon_sym_short] = ACTIONS(5526),
    [anon_sym_LBRACK] = ACTIONS(5526),
    [anon_sym_static] = ACTIONS(5526),
    [anon_sym_register] = ACTIONS(5526),
    [anon_sym_inline] = ACTIONS(5526),
    [anon_sym___inline] = ACTIONS(5526),
    [anon_sym___inline__] = ACTIONS(5526),
    [anon_sym___forceinline] = ACTIONS(5526),
    [anon_sym_thread_local] = ACTIONS(5526),
    [anon_sym___thread] = ACTIONS(5526),
    [anon_sym_const] = ACTIONS(5526),
    [anon_sym_constexpr] = ACTIONS(5526),
    [anon_sym_volatile] = ACTIONS(5526),
    [anon_sym_restrict] = ACTIONS(5526),
    [anon_sym___restrict__] = ACTIONS(5526),
    [anon_sym__Atomic] = ACTIONS(5526),
    [anon_sym__Noreturn] = ACTIONS(5526),
    [anon_sym_noreturn] = ACTIONS(5526),
    [anon_sym_mutable] = ACTIONS(5526),
    [anon_sym_constinit] = ACTIONS(5526),
    [anon_sym_consteval] = ACTIONS(5526),
    [anon_sym_PROGMEM] = ACTIONS(5526),
    [aux_sym_primitive_type_token1] = ACTIONS(5526),
    [anon_sym_byte] = ACTIONS(5526),
    [anon_sym_word] = ACTIONS(5526),
    [anon_sym_enum] = ACTIONS(5526),
    [anon_sym_class] = ACTIONS(5526),
    [anon_sym_struct] = ACTIONS(5526),
    [anon_sym_union] = ACTIONS(5526),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5526),
    [anon_sym_decltype] = ACTIONS(5526),
    [anon_sym_virtual] = ACTIONS(5526),
    [anon_sym_alignas] = ACTIONS(5526),
    [anon_sym_explicit] = ACTIONS(5526),
    [anon_sym_typename] = ACTIONS(5526),
    [anon_sym_template] = ACTIONS(5526),
    [anon_sym_operator] = ACTIONS(5526),
    [anon_sym_friend] = ACTIONS(5526),
    [anon_sym_public] = ACTIONS(5526),
    [anon_sym_private] = ACTIONS(5526),
    [anon_sym_protected] = ACTIONS(5526),
    [anon_sym_using] = ACTIONS(5526),
    [anon_sym_static_assert] = ACTIONS(5526),
  },
  [2549] = {
    [sym_identifier] = ACTIONS(3353),
    [aux_sym_preproc_def_token1] = ACTIONS(3353),
    [aux_sym_preproc_if_token1] = ACTIONS(3353),
    [aux_sym_preproc_if_token2] = ACTIONS(3353),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3353),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3353),
    [sym_preproc_directive] = ACTIONS(3353),
    [anon_sym_LPAREN2] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3355),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_AMP_AMP] = ACTIONS(3355),
    [anon_sym_AMP] = ACTIONS(3353),
    [anon_sym___extension__] = ACTIONS(3353),
    [anon_sym_typedef] = ACTIONS(3353),
    [anon_sym_extern] = ACTIONS(3353),
    [anon_sym___attribute__] = ACTIONS(3353),
    [anon_sym_COLON_COLON] = ACTIONS(3355),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3355),
    [anon_sym___declspec] = ACTIONS(3353),
    [anon_sym___based] = ACTIONS(3353),
    [anon_sym_signed] = ACTIONS(3353),
    [anon_sym_unsigned] = ACTIONS(3353),
    [anon_sym_long] = ACTIONS(3353),
    [anon_sym_short] = ACTIONS(3353),
    [anon_sym_LBRACK] = ACTIONS(3353),
    [anon_sym_static] = ACTIONS(3353),
    [anon_sym_register] = ACTIONS(3353),
    [anon_sym_inline] = ACTIONS(3353),
    [anon_sym___inline] = ACTIONS(3353),
    [anon_sym___inline__] = ACTIONS(3353),
    [anon_sym___forceinline] = ACTIONS(3353),
    [anon_sym_thread_local] = ACTIONS(3353),
    [anon_sym___thread] = ACTIONS(3353),
    [anon_sym_const] = ACTIONS(3353),
    [anon_sym_constexpr] = ACTIONS(3353),
    [anon_sym_volatile] = ACTIONS(3353),
    [anon_sym_restrict] = ACTIONS(3353),
    [anon_sym___restrict__] = ACTIONS(3353),
    [anon_sym__Atomic] = ACTIONS(3353),
    [anon_sym__Noreturn] = ACTIONS(3353),
    [anon_sym_noreturn] = ACTIONS(3353),
    [anon_sym_mutable] = ACTIONS(3353),
    [anon_sym_constinit] = ACTIONS(3353),
    [anon_sym_consteval] = ACTIONS(3353),
    [anon_sym_PROGMEM] = ACTIONS(3353),
    [aux_sym_primitive_type_token1] = ACTIONS(3353),
    [anon_sym_byte] = ACTIONS(3353),
    [anon_sym_word] = ACTIONS(3353),
    [anon_sym_enum] = ACTIONS(3353),
    [anon_sym_class] = ACTIONS(3353),
    [anon_sym_struct] = ACTIONS(3353),
    [anon_sym_union] = ACTIONS(3353),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3353),
    [anon_sym_decltype] = ACTIONS(3353),
    [anon_sym_virtual] = ACTIONS(3353),
    [anon_sym_alignas] = ACTIONS(3353),
    [anon_sym_explicit] = ACTIONS(3353),
    [anon_sym_typename] = ACTIONS(3353),
    [anon_sym_template] = ACTIONS(3353),
    [anon_sym_operator] = ACTIONS(3353),
    [anon_sym_friend] = ACTIONS(3353),
    [anon_sym_public] = ACTIONS(3353),
    [anon_sym_private] = ACTIONS(3353),
    [anon_sym_protected] = ACTIONS(3353),
    [anon_sym_using] = ACTIONS(3353),
    [anon_sym_static_assert] = ACTIONS(3353),
  },
  [2550] = {
    [sym_identifier] = ACTIONS(3162),
    [aux_sym_preproc_def_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token2] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3162),
    [sym_preproc_directive] = ACTIONS(3162),
    [anon_sym_LPAREN2] = ACTIONS(3164),
    [anon_sym_TILDE] = ACTIONS(3164),
    [anon_sym_STAR] = ACTIONS(3164),
    [anon_sym_AMP_AMP] = ACTIONS(3164),
    [anon_sym_AMP] = ACTIONS(3162),
    [anon_sym___extension__] = ACTIONS(3162),
    [anon_sym_typedef] = ACTIONS(3162),
    [anon_sym_extern] = ACTIONS(3162),
    [anon_sym___attribute__] = ACTIONS(3162),
    [anon_sym_COLON_COLON] = ACTIONS(3164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3164),
    [anon_sym___declspec] = ACTIONS(3162),
    [anon_sym___based] = ACTIONS(3162),
    [anon_sym_signed] = ACTIONS(3162),
    [anon_sym_unsigned] = ACTIONS(3162),
    [anon_sym_long] = ACTIONS(3162),
    [anon_sym_short] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_register] = ACTIONS(3162),
    [anon_sym_inline] = ACTIONS(3162),
    [anon_sym___inline] = ACTIONS(3162),
    [anon_sym___inline__] = ACTIONS(3162),
    [anon_sym___forceinline] = ACTIONS(3162),
    [anon_sym_thread_local] = ACTIONS(3162),
    [anon_sym___thread] = ACTIONS(3162),
    [anon_sym_const] = ACTIONS(3162),
    [anon_sym_constexpr] = ACTIONS(3162),
    [anon_sym_volatile] = ACTIONS(3162),
    [anon_sym_restrict] = ACTIONS(3162),
    [anon_sym___restrict__] = ACTIONS(3162),
    [anon_sym__Atomic] = ACTIONS(3162),
    [anon_sym__Noreturn] = ACTIONS(3162),
    [anon_sym_noreturn] = ACTIONS(3162),
    [anon_sym_mutable] = ACTIONS(3162),
    [anon_sym_constinit] = ACTIONS(3162),
    [anon_sym_consteval] = ACTIONS(3162),
    [anon_sym_PROGMEM] = ACTIONS(3162),
    [aux_sym_primitive_type_token1] = ACTIONS(3162),
    [anon_sym_byte] = ACTIONS(3162),
    [anon_sym_word] = ACTIONS(3162),
    [anon_sym_enum] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_struct] = ACTIONS(3162),
    [anon_sym_union] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3162),
    [anon_sym_decltype] = ACTIONS(3162),
    [anon_sym_virtual] = ACTIONS(3162),
    [anon_sym_alignas] = ACTIONS(3162),
    [anon_sym_explicit] = ACTIONS(3162),
    [anon_sym_typename] = ACTIONS(3162),
    [anon_sym_template] = ACTIONS(3162),
    [anon_sym_operator] = ACTIONS(3162),
    [anon_sym_friend] = ACTIONS(3162),
    [anon_sym_public] = ACTIONS(3162),
    [anon_sym_private] = ACTIONS(3162),
    [anon_sym_protected] = ACTIONS(3162),
    [anon_sym_using] = ACTIONS(3162),
    [anon_sym_static_assert] = ACTIONS(3162),
  },
  [2551] = {
    [sym_string_literal] = STATE(2551),
    [sym_raw_string_literal] = STATE(2551),
    [aux_sym_concatenated_string_repeat1] = STATE(2551),
    [sym_identifier] = ACTIONS(5943),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5373),
    [anon_sym_COMMA] = ACTIONS(5373),
    [anon_sym_RPAREN] = ACTIONS(5373),
    [anon_sym_LPAREN2] = ACTIONS(5373),
    [anon_sym_DASH] = ACTIONS(5375),
    [anon_sym_PLUS] = ACTIONS(5375),
    [anon_sym_STAR] = ACTIONS(5375),
    [anon_sym_SLASH] = ACTIONS(5375),
    [anon_sym_PERCENT] = ACTIONS(5375),
    [anon_sym_PIPE_PIPE] = ACTIONS(5373),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_PIPE] = ACTIONS(5375),
    [anon_sym_CARET] = ACTIONS(5375),
    [anon_sym_AMP] = ACTIONS(5375),
    [anon_sym_EQ_EQ] = ACTIONS(5373),
    [anon_sym_BANG_EQ] = ACTIONS(5373),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5373),
    [anon_sym_LT_EQ] = ACTIONS(5375),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_LT] = ACTIONS(5375),
    [anon_sym_GT_GT] = ACTIONS(5375),
    [anon_sym_LBRACK] = ACTIONS(5373),
    [anon_sym_EQ] = ACTIONS(5375),
    [anon_sym_QMARK] = ACTIONS(5373),
    [anon_sym_STAR_EQ] = ACTIONS(5373),
    [anon_sym_SLASH_EQ] = ACTIONS(5373),
    [anon_sym_PERCENT_EQ] = ACTIONS(5373),
    [anon_sym_PLUS_EQ] = ACTIONS(5373),
    [anon_sym_DASH_EQ] = ACTIONS(5373),
    [anon_sym_LT_LT_EQ] = ACTIONS(5373),
    [anon_sym_GT_GT_EQ] = ACTIONS(5373),
    [anon_sym_AMP_EQ] = ACTIONS(5373),
    [anon_sym_CARET_EQ] = ACTIONS(5373),
    [anon_sym_PIPE_EQ] = ACTIONS(5373),
    [anon_sym_and_eq] = ACTIONS(5375),
    [anon_sym_or_eq] = ACTIONS(5375),
    [anon_sym_xor_eq] = ACTIONS(5375),
    [anon_sym_LT_EQ_GT] = ACTIONS(5373),
    [anon_sym_or] = ACTIONS(5375),
    [anon_sym_and] = ACTIONS(5375),
    [anon_sym_bitor] = ACTIONS(5375),
    [anon_sym_xor] = ACTIONS(5375),
    [anon_sym_bitand] = ACTIONS(5375),
    [anon_sym_not_eq] = ACTIONS(5375),
    [anon_sym_DASH_DASH] = ACTIONS(5373),
    [anon_sym_PLUS_PLUS] = ACTIONS(5373),
    [anon_sym_DOT] = ACTIONS(5375),
    [anon_sym_DOT_STAR] = ACTIONS(5373),
    [anon_sym_DASH_GT] = ACTIONS(5375),
    [anon_sym_L_DQUOTE] = ACTIONS(5946),
    [anon_sym_u_DQUOTE] = ACTIONS(5946),
    [anon_sym_U_DQUOTE] = ACTIONS(5946),
    [anon_sym_u8_DQUOTE] = ACTIONS(5946),
    [anon_sym_DQUOTE] = ACTIONS(5946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5949),
    [anon_sym_LR_DQUOTE] = ACTIONS(5949),
    [anon_sym_uR_DQUOTE] = ACTIONS(5949),
    [anon_sym_UR_DQUOTE] = ACTIONS(5949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5949),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5373),
    [sym_literal_suffix] = ACTIONS(5375),
  },
  [2552] = {
    [sym_identifier] = ACTIONS(5550),
    [aux_sym_preproc_def_token1] = ACTIONS(5550),
    [aux_sym_preproc_if_token1] = ACTIONS(5550),
    [aux_sym_preproc_if_token2] = ACTIONS(5550),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5550),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5550),
    [sym_preproc_directive] = ACTIONS(5550),
    [anon_sym_LPAREN2] = ACTIONS(5552),
    [anon_sym_TILDE] = ACTIONS(5552),
    [anon_sym_STAR] = ACTIONS(5552),
    [anon_sym_AMP_AMP] = ACTIONS(5552),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym___extension__] = ACTIONS(5550),
    [anon_sym_typedef] = ACTIONS(5550),
    [anon_sym_extern] = ACTIONS(5550),
    [anon_sym___attribute__] = ACTIONS(5550),
    [anon_sym_COLON_COLON] = ACTIONS(5552),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5552),
    [anon_sym___declspec] = ACTIONS(5550),
    [anon_sym___based] = ACTIONS(5550),
    [anon_sym_signed] = ACTIONS(5550),
    [anon_sym_unsigned] = ACTIONS(5550),
    [anon_sym_long] = ACTIONS(5550),
    [anon_sym_short] = ACTIONS(5550),
    [anon_sym_LBRACK] = ACTIONS(5550),
    [anon_sym_static] = ACTIONS(5550),
    [anon_sym_register] = ACTIONS(5550),
    [anon_sym_inline] = ACTIONS(5550),
    [anon_sym___inline] = ACTIONS(5550),
    [anon_sym___inline__] = ACTIONS(5550),
    [anon_sym___forceinline] = ACTIONS(5550),
    [anon_sym_thread_local] = ACTIONS(5550),
    [anon_sym___thread] = ACTIONS(5550),
    [anon_sym_const] = ACTIONS(5550),
    [anon_sym_constexpr] = ACTIONS(5550),
    [anon_sym_volatile] = ACTIONS(5550),
    [anon_sym_restrict] = ACTIONS(5550),
    [anon_sym___restrict__] = ACTIONS(5550),
    [anon_sym__Atomic] = ACTIONS(5550),
    [anon_sym__Noreturn] = ACTIONS(5550),
    [anon_sym_noreturn] = ACTIONS(5550),
    [anon_sym_mutable] = ACTIONS(5550),
    [anon_sym_constinit] = ACTIONS(5550),
    [anon_sym_consteval] = ACTIONS(5550),
    [anon_sym_PROGMEM] = ACTIONS(5550),
    [aux_sym_primitive_type_token1] = ACTIONS(5550),
    [anon_sym_byte] = ACTIONS(5550),
    [anon_sym_word] = ACTIONS(5550),
    [anon_sym_enum] = ACTIONS(5550),
    [anon_sym_class] = ACTIONS(5550),
    [anon_sym_struct] = ACTIONS(5550),
    [anon_sym_union] = ACTIONS(5550),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5550),
    [anon_sym_decltype] = ACTIONS(5550),
    [anon_sym_virtual] = ACTIONS(5550),
    [anon_sym_alignas] = ACTIONS(5550),
    [anon_sym_explicit] = ACTIONS(5550),
    [anon_sym_typename] = ACTIONS(5550),
    [anon_sym_template] = ACTIONS(5550),
    [anon_sym_operator] = ACTIONS(5550),
    [anon_sym_friend] = ACTIONS(5550),
    [anon_sym_public] = ACTIONS(5550),
    [anon_sym_private] = ACTIONS(5550),
    [anon_sym_protected] = ACTIONS(5550),
    [anon_sym_using] = ACTIONS(5550),
    [anon_sym_static_assert] = ACTIONS(5550),
  },
  [2553] = {
    [sym_identifier] = ACTIONS(3411),
    [aux_sym_preproc_def_token1] = ACTIONS(3411),
    [aux_sym_preproc_if_token1] = ACTIONS(3411),
    [aux_sym_preproc_if_token2] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3411),
    [sym_preproc_directive] = ACTIONS(3411),
    [anon_sym_LPAREN2] = ACTIONS(3413),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_STAR] = ACTIONS(3413),
    [anon_sym_AMP_AMP] = ACTIONS(3413),
    [anon_sym_AMP] = ACTIONS(3411),
    [anon_sym___extension__] = ACTIONS(3411),
    [anon_sym_typedef] = ACTIONS(3411),
    [anon_sym_extern] = ACTIONS(3411),
    [anon_sym___attribute__] = ACTIONS(3411),
    [anon_sym_COLON_COLON] = ACTIONS(3413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3413),
    [anon_sym___declspec] = ACTIONS(3411),
    [anon_sym___based] = ACTIONS(3411),
    [anon_sym_signed] = ACTIONS(3411),
    [anon_sym_unsigned] = ACTIONS(3411),
    [anon_sym_long] = ACTIONS(3411),
    [anon_sym_short] = ACTIONS(3411),
    [anon_sym_LBRACK] = ACTIONS(3411),
    [anon_sym_static] = ACTIONS(3411),
    [anon_sym_register] = ACTIONS(3411),
    [anon_sym_inline] = ACTIONS(3411),
    [anon_sym___inline] = ACTIONS(3411),
    [anon_sym___inline__] = ACTIONS(3411),
    [anon_sym___forceinline] = ACTIONS(3411),
    [anon_sym_thread_local] = ACTIONS(3411),
    [anon_sym___thread] = ACTIONS(3411),
    [anon_sym_const] = ACTIONS(3411),
    [anon_sym_constexpr] = ACTIONS(3411),
    [anon_sym_volatile] = ACTIONS(3411),
    [anon_sym_restrict] = ACTIONS(3411),
    [anon_sym___restrict__] = ACTIONS(3411),
    [anon_sym__Atomic] = ACTIONS(3411),
    [anon_sym__Noreturn] = ACTIONS(3411),
    [anon_sym_noreturn] = ACTIONS(3411),
    [anon_sym_mutable] = ACTIONS(3411),
    [anon_sym_constinit] = ACTIONS(3411),
    [anon_sym_consteval] = ACTIONS(3411),
    [anon_sym_PROGMEM] = ACTIONS(3411),
    [aux_sym_primitive_type_token1] = ACTIONS(3411),
    [anon_sym_byte] = ACTIONS(3411),
    [anon_sym_word] = ACTIONS(3411),
    [anon_sym_enum] = ACTIONS(3411),
    [anon_sym_class] = ACTIONS(3411),
    [anon_sym_struct] = ACTIONS(3411),
    [anon_sym_union] = ACTIONS(3411),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3411),
    [anon_sym_decltype] = ACTIONS(3411),
    [anon_sym_virtual] = ACTIONS(3411),
    [anon_sym_alignas] = ACTIONS(3411),
    [anon_sym_explicit] = ACTIONS(3411),
    [anon_sym_typename] = ACTIONS(3411),
    [anon_sym_template] = ACTIONS(3411),
    [anon_sym_operator] = ACTIONS(3411),
    [anon_sym_friend] = ACTIONS(3411),
    [anon_sym_public] = ACTIONS(3411),
    [anon_sym_private] = ACTIONS(3411),
    [anon_sym_protected] = ACTIONS(3411),
    [anon_sym_using] = ACTIONS(3411),
    [anon_sym_static_assert] = ACTIONS(3411),
  },
  [2554] = {
    [sym_identifier] = ACTIONS(5622),
    [aux_sym_preproc_def_token1] = ACTIONS(5622),
    [aux_sym_preproc_if_token1] = ACTIONS(5622),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5622),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5622),
    [sym_preproc_directive] = ACTIONS(5622),
    [anon_sym_LPAREN2] = ACTIONS(5624),
    [anon_sym_TILDE] = ACTIONS(5624),
    [anon_sym_STAR] = ACTIONS(5624),
    [anon_sym_AMP_AMP] = ACTIONS(5624),
    [anon_sym_AMP] = ACTIONS(5622),
    [anon_sym___extension__] = ACTIONS(5622),
    [anon_sym_typedef] = ACTIONS(5622),
    [anon_sym_extern] = ACTIONS(5622),
    [anon_sym___attribute__] = ACTIONS(5622),
    [anon_sym_COLON_COLON] = ACTIONS(5624),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5624),
    [anon_sym___declspec] = ACTIONS(5622),
    [anon_sym___based] = ACTIONS(5622),
    [anon_sym_RBRACE] = ACTIONS(5624),
    [anon_sym_signed] = ACTIONS(5622),
    [anon_sym_unsigned] = ACTIONS(5622),
    [anon_sym_long] = ACTIONS(5622),
    [anon_sym_short] = ACTIONS(5622),
    [anon_sym_LBRACK] = ACTIONS(5622),
    [anon_sym_static] = ACTIONS(5622),
    [anon_sym_register] = ACTIONS(5622),
    [anon_sym_inline] = ACTIONS(5622),
    [anon_sym___inline] = ACTIONS(5622),
    [anon_sym___inline__] = ACTIONS(5622),
    [anon_sym___forceinline] = ACTIONS(5622),
    [anon_sym_thread_local] = ACTIONS(5622),
    [anon_sym___thread] = ACTIONS(5622),
    [anon_sym_const] = ACTIONS(5622),
    [anon_sym_constexpr] = ACTIONS(5622),
    [anon_sym_volatile] = ACTIONS(5622),
    [anon_sym_restrict] = ACTIONS(5622),
    [anon_sym___restrict__] = ACTIONS(5622),
    [anon_sym__Atomic] = ACTIONS(5622),
    [anon_sym__Noreturn] = ACTIONS(5622),
    [anon_sym_noreturn] = ACTIONS(5622),
    [anon_sym_mutable] = ACTIONS(5622),
    [anon_sym_constinit] = ACTIONS(5622),
    [anon_sym_consteval] = ACTIONS(5622),
    [anon_sym_PROGMEM] = ACTIONS(5622),
    [aux_sym_primitive_type_token1] = ACTIONS(5622),
    [anon_sym_byte] = ACTIONS(5622),
    [anon_sym_word] = ACTIONS(5622),
    [anon_sym_enum] = ACTIONS(5622),
    [anon_sym_class] = ACTIONS(5622),
    [anon_sym_struct] = ACTIONS(5622),
    [anon_sym_union] = ACTIONS(5622),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5622),
    [anon_sym_decltype] = ACTIONS(5622),
    [anon_sym_virtual] = ACTIONS(5622),
    [anon_sym_alignas] = ACTIONS(5622),
    [anon_sym_explicit] = ACTIONS(5622),
    [anon_sym_typename] = ACTIONS(5622),
    [anon_sym_template] = ACTIONS(5622),
    [anon_sym_operator] = ACTIONS(5622),
    [anon_sym_friend] = ACTIONS(5622),
    [anon_sym_public] = ACTIONS(5622),
    [anon_sym_private] = ACTIONS(5622),
    [anon_sym_protected] = ACTIONS(5622),
    [anon_sym_using] = ACTIONS(5622),
    [anon_sym_static_assert] = ACTIONS(5622),
  },
  [2555] = {
    [sym_identifier] = ACTIONS(3415),
    [aux_sym_preproc_def_token1] = ACTIONS(3415),
    [aux_sym_preproc_if_token1] = ACTIONS(3415),
    [aux_sym_preproc_if_token2] = ACTIONS(3415),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3415),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3415),
    [sym_preproc_directive] = ACTIONS(3415),
    [anon_sym_LPAREN2] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3417),
    [anon_sym_STAR] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3415),
    [anon_sym___extension__] = ACTIONS(3415),
    [anon_sym_typedef] = ACTIONS(3415),
    [anon_sym_extern] = ACTIONS(3415),
    [anon_sym___attribute__] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3417),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3417),
    [anon_sym___declspec] = ACTIONS(3415),
    [anon_sym___based] = ACTIONS(3415),
    [anon_sym_signed] = ACTIONS(3415),
    [anon_sym_unsigned] = ACTIONS(3415),
    [anon_sym_long] = ACTIONS(3415),
    [anon_sym_short] = ACTIONS(3415),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_static] = ACTIONS(3415),
    [anon_sym_register] = ACTIONS(3415),
    [anon_sym_inline] = ACTIONS(3415),
    [anon_sym___inline] = ACTIONS(3415),
    [anon_sym___inline__] = ACTIONS(3415),
    [anon_sym___forceinline] = ACTIONS(3415),
    [anon_sym_thread_local] = ACTIONS(3415),
    [anon_sym___thread] = ACTIONS(3415),
    [anon_sym_const] = ACTIONS(3415),
    [anon_sym_constexpr] = ACTIONS(3415),
    [anon_sym_volatile] = ACTIONS(3415),
    [anon_sym_restrict] = ACTIONS(3415),
    [anon_sym___restrict__] = ACTIONS(3415),
    [anon_sym__Atomic] = ACTIONS(3415),
    [anon_sym__Noreturn] = ACTIONS(3415),
    [anon_sym_noreturn] = ACTIONS(3415),
    [anon_sym_mutable] = ACTIONS(3415),
    [anon_sym_constinit] = ACTIONS(3415),
    [anon_sym_consteval] = ACTIONS(3415),
    [anon_sym_PROGMEM] = ACTIONS(3415),
    [aux_sym_primitive_type_token1] = ACTIONS(3415),
    [anon_sym_byte] = ACTIONS(3415),
    [anon_sym_word] = ACTIONS(3415),
    [anon_sym_enum] = ACTIONS(3415),
    [anon_sym_class] = ACTIONS(3415),
    [anon_sym_struct] = ACTIONS(3415),
    [anon_sym_union] = ACTIONS(3415),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3415),
    [anon_sym_decltype] = ACTIONS(3415),
    [anon_sym_virtual] = ACTIONS(3415),
    [anon_sym_alignas] = ACTIONS(3415),
    [anon_sym_explicit] = ACTIONS(3415),
    [anon_sym_typename] = ACTIONS(3415),
    [anon_sym_template] = ACTIONS(3415),
    [anon_sym_operator] = ACTIONS(3415),
    [anon_sym_friend] = ACTIONS(3415),
    [anon_sym_public] = ACTIONS(3415),
    [anon_sym_private] = ACTIONS(3415),
    [anon_sym_protected] = ACTIONS(3415),
    [anon_sym_using] = ACTIONS(3415),
    [anon_sym_static_assert] = ACTIONS(3415),
  },
  [2556] = {
    [sym_string_literal] = STATE(2616),
    [sym_template_argument_list] = STATE(3687),
    [sym_raw_string_literal] = STATE(2616),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_RPAREN] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5188),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4256),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4248),
    [anon_sym_SLASH_EQ] = ACTIONS(4248),
    [anon_sym_PERCENT_EQ] = ACTIONS(4248),
    [anon_sym_PLUS_EQ] = ACTIONS(4248),
    [anon_sym_DASH_EQ] = ACTIONS(4248),
    [anon_sym_LT_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT_GT_EQ] = ACTIONS(4248),
    [anon_sym_AMP_EQ] = ACTIONS(4248),
    [anon_sym_CARET_EQ] = ACTIONS(4248),
    [anon_sym_PIPE_EQ] = ACTIONS(4248),
    [anon_sym_and_eq] = ACTIONS(4248),
    [anon_sym_or_eq] = ACTIONS(4248),
    [anon_sym_xor_eq] = ACTIONS(4248),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4256),
    [anon_sym_L_DQUOTE] = ACTIONS(5184),
    [anon_sym_u_DQUOTE] = ACTIONS(5184),
    [anon_sym_U_DQUOTE] = ACTIONS(5184),
    [anon_sym_u8_DQUOTE] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5186),
    [anon_sym_LR_DQUOTE] = ACTIONS(5186),
    [anon_sym_uR_DQUOTE] = ACTIONS(5186),
    [anon_sym_UR_DQUOTE] = ACTIONS(5186),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5186),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4248),
  },
  [2557] = {
    [sym_attribute_specifier] = STATE(2771),
    [sym_enumerator_list] = STATE(2680),
    [sym_identifier] = ACTIONS(5952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5954),
    [anon_sym_COMMA] = ACTIONS(5954),
    [anon_sym_RPAREN] = ACTIONS(5954),
    [aux_sym_preproc_if_token2] = ACTIONS(5954),
    [aux_sym_preproc_else_token1] = ACTIONS(5954),
    [aux_sym_preproc_elif_token1] = ACTIONS(5952),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5954),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5954),
    [anon_sym_LPAREN2] = ACTIONS(5954),
    [anon_sym_DASH] = ACTIONS(5952),
    [anon_sym_PLUS] = ACTIONS(5952),
    [anon_sym_STAR] = ACTIONS(5952),
    [anon_sym_SLASH] = ACTIONS(5952),
    [anon_sym_PERCENT] = ACTIONS(5952),
    [anon_sym_PIPE_PIPE] = ACTIONS(5954),
    [anon_sym_AMP_AMP] = ACTIONS(5954),
    [anon_sym_PIPE] = ACTIONS(5952),
    [anon_sym_CARET] = ACTIONS(5952),
    [anon_sym_AMP] = ACTIONS(5952),
    [anon_sym_EQ_EQ] = ACTIONS(5954),
    [anon_sym_BANG_EQ] = ACTIONS(5954),
    [anon_sym_GT] = ACTIONS(5952),
    [anon_sym_GT_EQ] = ACTIONS(5954),
    [anon_sym_LT_EQ] = ACTIONS(5952),
    [anon_sym_LT] = ACTIONS(5952),
    [anon_sym_LT_LT] = ACTIONS(5952),
    [anon_sym_GT_GT] = ACTIONS(5952),
    [anon_sym_SEMI] = ACTIONS(5954),
    [anon_sym___attribute__] = ACTIONS(5473),
    [anon_sym_LBRACE] = ACTIONS(5956),
    [anon_sym_RBRACE] = ACTIONS(5954),
    [anon_sym_LBRACK] = ACTIONS(5954),
    [anon_sym_RBRACK] = ACTIONS(5954),
    [anon_sym_EQ] = ACTIONS(5952),
    [anon_sym_COLON] = ACTIONS(5954),
    [anon_sym_QMARK] = ACTIONS(5954),
    [anon_sym_STAR_EQ] = ACTIONS(5954),
    [anon_sym_SLASH_EQ] = ACTIONS(5954),
    [anon_sym_PERCENT_EQ] = ACTIONS(5954),
    [anon_sym_PLUS_EQ] = ACTIONS(5954),
    [anon_sym_DASH_EQ] = ACTIONS(5954),
    [anon_sym_LT_LT_EQ] = ACTIONS(5954),
    [anon_sym_GT_GT_EQ] = ACTIONS(5954),
    [anon_sym_AMP_EQ] = ACTIONS(5954),
    [anon_sym_CARET_EQ] = ACTIONS(5954),
    [anon_sym_PIPE_EQ] = ACTIONS(5954),
    [anon_sym_and_eq] = ACTIONS(5952),
    [anon_sym_or_eq] = ACTIONS(5952),
    [anon_sym_xor_eq] = ACTIONS(5952),
    [anon_sym_LT_EQ_GT] = ACTIONS(5954),
    [anon_sym_or] = ACTIONS(5952),
    [anon_sym_and] = ACTIONS(5952),
    [anon_sym_bitor] = ACTIONS(5952),
    [anon_sym_xor] = ACTIONS(5952),
    [anon_sym_bitand] = ACTIONS(5952),
    [anon_sym_not_eq] = ACTIONS(5952),
    [anon_sym_DASH_DASH] = ACTIONS(5954),
    [anon_sym_PLUS_PLUS] = ACTIONS(5954),
    [anon_sym_DOT] = ACTIONS(5952),
    [anon_sym_DOT_STAR] = ACTIONS(5954),
    [anon_sym_DASH_GT] = ACTIONS(5954),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5952),
    [anon_sym_decltype] = ACTIONS(5952),
  },
  [2558] = {
    [sym_identifier] = ACTIONS(5618),
    [aux_sym_preproc_def_token1] = ACTIONS(5618),
    [aux_sym_preproc_if_token1] = ACTIONS(5618),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5618),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5618),
    [sym_preproc_directive] = ACTIONS(5618),
    [anon_sym_LPAREN2] = ACTIONS(5620),
    [anon_sym_TILDE] = ACTIONS(5620),
    [anon_sym_STAR] = ACTIONS(5620),
    [anon_sym_AMP_AMP] = ACTIONS(5620),
    [anon_sym_AMP] = ACTIONS(5618),
    [anon_sym___extension__] = ACTIONS(5618),
    [anon_sym_typedef] = ACTIONS(5618),
    [anon_sym_extern] = ACTIONS(5618),
    [anon_sym___attribute__] = ACTIONS(5618),
    [anon_sym_COLON_COLON] = ACTIONS(5620),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5620),
    [anon_sym___declspec] = ACTIONS(5618),
    [anon_sym___based] = ACTIONS(5618),
    [anon_sym_RBRACE] = ACTIONS(5620),
    [anon_sym_signed] = ACTIONS(5618),
    [anon_sym_unsigned] = ACTIONS(5618),
    [anon_sym_long] = ACTIONS(5618),
    [anon_sym_short] = ACTIONS(5618),
    [anon_sym_LBRACK] = ACTIONS(5618),
    [anon_sym_static] = ACTIONS(5618),
    [anon_sym_register] = ACTIONS(5618),
    [anon_sym_inline] = ACTIONS(5618),
    [anon_sym___inline] = ACTIONS(5618),
    [anon_sym___inline__] = ACTIONS(5618),
    [anon_sym___forceinline] = ACTIONS(5618),
    [anon_sym_thread_local] = ACTIONS(5618),
    [anon_sym___thread] = ACTIONS(5618),
    [anon_sym_const] = ACTIONS(5618),
    [anon_sym_constexpr] = ACTIONS(5618),
    [anon_sym_volatile] = ACTIONS(5618),
    [anon_sym_restrict] = ACTIONS(5618),
    [anon_sym___restrict__] = ACTIONS(5618),
    [anon_sym__Atomic] = ACTIONS(5618),
    [anon_sym__Noreturn] = ACTIONS(5618),
    [anon_sym_noreturn] = ACTIONS(5618),
    [anon_sym_mutable] = ACTIONS(5618),
    [anon_sym_constinit] = ACTIONS(5618),
    [anon_sym_consteval] = ACTIONS(5618),
    [anon_sym_PROGMEM] = ACTIONS(5618),
    [aux_sym_primitive_type_token1] = ACTIONS(5618),
    [anon_sym_byte] = ACTIONS(5618),
    [anon_sym_word] = ACTIONS(5618),
    [anon_sym_enum] = ACTIONS(5618),
    [anon_sym_class] = ACTIONS(5618),
    [anon_sym_struct] = ACTIONS(5618),
    [anon_sym_union] = ACTIONS(5618),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5618),
    [anon_sym_decltype] = ACTIONS(5618),
    [anon_sym_virtual] = ACTIONS(5618),
    [anon_sym_alignas] = ACTIONS(5618),
    [anon_sym_explicit] = ACTIONS(5618),
    [anon_sym_typename] = ACTIONS(5618),
    [anon_sym_template] = ACTIONS(5618),
    [anon_sym_operator] = ACTIONS(5618),
    [anon_sym_friend] = ACTIONS(5618),
    [anon_sym_public] = ACTIONS(5618),
    [anon_sym_private] = ACTIONS(5618),
    [anon_sym_protected] = ACTIONS(5618),
    [anon_sym_using] = ACTIONS(5618),
    [anon_sym_static_assert] = ACTIONS(5618),
  },
  [2559] = {
    [sym_identifier] = ACTIONS(5530),
    [aux_sym_preproc_def_token1] = ACTIONS(5530),
    [aux_sym_preproc_if_token1] = ACTIONS(5530),
    [aux_sym_preproc_if_token2] = ACTIONS(5530),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5530),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5530),
    [sym_preproc_directive] = ACTIONS(5530),
    [anon_sym_LPAREN2] = ACTIONS(5532),
    [anon_sym_TILDE] = ACTIONS(5532),
    [anon_sym_STAR] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5530),
    [anon_sym___extension__] = ACTIONS(5530),
    [anon_sym_typedef] = ACTIONS(5530),
    [anon_sym_extern] = ACTIONS(5530),
    [anon_sym___attribute__] = ACTIONS(5530),
    [anon_sym_COLON_COLON] = ACTIONS(5532),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5532),
    [anon_sym___declspec] = ACTIONS(5530),
    [anon_sym___based] = ACTIONS(5530),
    [anon_sym_signed] = ACTIONS(5530),
    [anon_sym_unsigned] = ACTIONS(5530),
    [anon_sym_long] = ACTIONS(5530),
    [anon_sym_short] = ACTIONS(5530),
    [anon_sym_LBRACK] = ACTIONS(5530),
    [anon_sym_static] = ACTIONS(5530),
    [anon_sym_register] = ACTIONS(5530),
    [anon_sym_inline] = ACTIONS(5530),
    [anon_sym___inline] = ACTIONS(5530),
    [anon_sym___inline__] = ACTIONS(5530),
    [anon_sym___forceinline] = ACTIONS(5530),
    [anon_sym_thread_local] = ACTIONS(5530),
    [anon_sym___thread] = ACTIONS(5530),
    [anon_sym_const] = ACTIONS(5530),
    [anon_sym_constexpr] = ACTIONS(5530),
    [anon_sym_volatile] = ACTIONS(5530),
    [anon_sym_restrict] = ACTIONS(5530),
    [anon_sym___restrict__] = ACTIONS(5530),
    [anon_sym__Atomic] = ACTIONS(5530),
    [anon_sym__Noreturn] = ACTIONS(5530),
    [anon_sym_noreturn] = ACTIONS(5530),
    [anon_sym_mutable] = ACTIONS(5530),
    [anon_sym_constinit] = ACTIONS(5530),
    [anon_sym_consteval] = ACTIONS(5530),
    [anon_sym_PROGMEM] = ACTIONS(5530),
    [aux_sym_primitive_type_token1] = ACTIONS(5530),
    [anon_sym_byte] = ACTIONS(5530),
    [anon_sym_word] = ACTIONS(5530),
    [anon_sym_enum] = ACTIONS(5530),
    [anon_sym_class] = ACTIONS(5530),
    [anon_sym_struct] = ACTIONS(5530),
    [anon_sym_union] = ACTIONS(5530),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5530),
    [anon_sym_decltype] = ACTIONS(5530),
    [anon_sym_virtual] = ACTIONS(5530),
    [anon_sym_alignas] = ACTIONS(5530),
    [anon_sym_explicit] = ACTIONS(5530),
    [anon_sym_typename] = ACTIONS(5530),
    [anon_sym_template] = ACTIONS(5530),
    [anon_sym_operator] = ACTIONS(5530),
    [anon_sym_friend] = ACTIONS(5530),
    [anon_sym_public] = ACTIONS(5530),
    [anon_sym_private] = ACTIONS(5530),
    [anon_sym_protected] = ACTIONS(5530),
    [anon_sym_using] = ACTIONS(5530),
    [anon_sym_static_assert] = ACTIONS(5530),
  },
  [2560] = {
    [sym_identifier] = ACTIONS(3517),
    [aux_sym_preproc_def_token1] = ACTIONS(3517),
    [aux_sym_preproc_if_token1] = ACTIONS(3517),
    [aux_sym_preproc_if_token2] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3517),
    [sym_preproc_directive] = ACTIONS(3517),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym___extension__] = ACTIONS(3517),
    [anon_sym_typedef] = ACTIONS(3517),
    [anon_sym_extern] = ACTIONS(3517),
    [anon_sym___attribute__] = ACTIONS(3517),
    [anon_sym_COLON_COLON] = ACTIONS(3519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3519),
    [anon_sym___declspec] = ACTIONS(3517),
    [anon_sym___based] = ACTIONS(3517),
    [anon_sym_signed] = ACTIONS(3517),
    [anon_sym_unsigned] = ACTIONS(3517),
    [anon_sym_long] = ACTIONS(3517),
    [anon_sym_short] = ACTIONS(3517),
    [anon_sym_LBRACK] = ACTIONS(3517),
    [anon_sym_static] = ACTIONS(3517),
    [anon_sym_register] = ACTIONS(3517),
    [anon_sym_inline] = ACTIONS(3517),
    [anon_sym___inline] = ACTIONS(3517),
    [anon_sym___inline__] = ACTIONS(3517),
    [anon_sym___forceinline] = ACTIONS(3517),
    [anon_sym_thread_local] = ACTIONS(3517),
    [anon_sym___thread] = ACTIONS(3517),
    [anon_sym_const] = ACTIONS(3517),
    [anon_sym_constexpr] = ACTIONS(3517),
    [anon_sym_volatile] = ACTIONS(3517),
    [anon_sym_restrict] = ACTIONS(3517),
    [anon_sym___restrict__] = ACTIONS(3517),
    [anon_sym__Atomic] = ACTIONS(3517),
    [anon_sym__Noreturn] = ACTIONS(3517),
    [anon_sym_noreturn] = ACTIONS(3517),
    [anon_sym_mutable] = ACTIONS(3517),
    [anon_sym_constinit] = ACTIONS(3517),
    [anon_sym_consteval] = ACTIONS(3517),
    [anon_sym_PROGMEM] = ACTIONS(3517),
    [aux_sym_primitive_type_token1] = ACTIONS(3517),
    [anon_sym_byte] = ACTIONS(3517),
    [anon_sym_word] = ACTIONS(3517),
    [anon_sym_enum] = ACTIONS(3517),
    [anon_sym_class] = ACTIONS(3517),
    [anon_sym_struct] = ACTIONS(3517),
    [anon_sym_union] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3517),
    [anon_sym_decltype] = ACTIONS(3517),
    [anon_sym_virtual] = ACTIONS(3517),
    [anon_sym_alignas] = ACTIONS(3517),
    [anon_sym_explicit] = ACTIONS(3517),
    [anon_sym_typename] = ACTIONS(3517),
    [anon_sym_template] = ACTIONS(3517),
    [anon_sym_operator] = ACTIONS(3517),
    [anon_sym_friend] = ACTIONS(3517),
    [anon_sym_public] = ACTIONS(3517),
    [anon_sym_private] = ACTIONS(3517),
    [anon_sym_protected] = ACTIONS(3517),
    [anon_sym_using] = ACTIONS(3517),
    [anon_sym_static_assert] = ACTIONS(3517),
  },
  [2561] = {
    [sym_identifier] = ACTIONS(3324),
    [aux_sym_preproc_def_token1] = ACTIONS(3324),
    [aux_sym_preproc_if_token1] = ACTIONS(3324),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3324),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3324),
    [sym_preproc_directive] = ACTIONS(3324),
    [anon_sym_LPAREN2] = ACTIONS(3326),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(3326),
    [anon_sym_AMP_AMP] = ACTIONS(3326),
    [anon_sym_AMP] = ACTIONS(3324),
    [anon_sym___extension__] = ACTIONS(3324),
    [anon_sym_typedef] = ACTIONS(3324),
    [anon_sym_extern] = ACTIONS(3324),
    [anon_sym___attribute__] = ACTIONS(3324),
    [anon_sym_COLON_COLON] = ACTIONS(3326),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3326),
    [anon_sym___declspec] = ACTIONS(3324),
    [anon_sym___based] = ACTIONS(3324),
    [anon_sym_RBRACE] = ACTIONS(3326),
    [anon_sym_signed] = ACTIONS(3324),
    [anon_sym_unsigned] = ACTIONS(3324),
    [anon_sym_long] = ACTIONS(3324),
    [anon_sym_short] = ACTIONS(3324),
    [anon_sym_LBRACK] = ACTIONS(3324),
    [anon_sym_static] = ACTIONS(3324),
    [anon_sym_register] = ACTIONS(3324),
    [anon_sym_inline] = ACTIONS(3324),
    [anon_sym___inline] = ACTIONS(3324),
    [anon_sym___inline__] = ACTIONS(3324),
    [anon_sym___forceinline] = ACTIONS(3324),
    [anon_sym_thread_local] = ACTIONS(3324),
    [anon_sym___thread] = ACTIONS(3324),
    [anon_sym_const] = ACTIONS(3324),
    [anon_sym_constexpr] = ACTIONS(3324),
    [anon_sym_volatile] = ACTIONS(3324),
    [anon_sym_restrict] = ACTIONS(3324),
    [anon_sym___restrict__] = ACTIONS(3324),
    [anon_sym__Atomic] = ACTIONS(3324),
    [anon_sym__Noreturn] = ACTIONS(3324),
    [anon_sym_noreturn] = ACTIONS(3324),
    [anon_sym_mutable] = ACTIONS(3324),
    [anon_sym_constinit] = ACTIONS(3324),
    [anon_sym_consteval] = ACTIONS(3324),
    [anon_sym_PROGMEM] = ACTIONS(3324),
    [aux_sym_primitive_type_token1] = ACTIONS(3324),
    [anon_sym_byte] = ACTIONS(3324),
    [anon_sym_word] = ACTIONS(3324),
    [anon_sym_enum] = ACTIONS(3324),
    [anon_sym_class] = ACTIONS(3324),
    [anon_sym_struct] = ACTIONS(3324),
    [anon_sym_union] = ACTIONS(3324),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3324),
    [anon_sym_decltype] = ACTIONS(3324),
    [anon_sym_virtual] = ACTIONS(3324),
    [anon_sym_alignas] = ACTIONS(3324),
    [anon_sym_explicit] = ACTIONS(3324),
    [anon_sym_typename] = ACTIONS(3324),
    [anon_sym_template] = ACTIONS(3324),
    [anon_sym_operator] = ACTIONS(3324),
    [anon_sym_friend] = ACTIONS(3324),
    [anon_sym_public] = ACTIONS(3324),
    [anon_sym_private] = ACTIONS(3324),
    [anon_sym_protected] = ACTIONS(3324),
    [anon_sym_using] = ACTIONS(3324),
    [anon_sym_static_assert] = ACTIONS(3324),
  },
  [2562] = {
    [sym_identifier] = ACTIONS(5542),
    [aux_sym_preproc_def_token1] = ACTIONS(5542),
    [aux_sym_preproc_if_token1] = ACTIONS(5542),
    [aux_sym_preproc_if_token2] = ACTIONS(5542),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5542),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5542),
    [sym_preproc_directive] = ACTIONS(5542),
    [anon_sym_LPAREN2] = ACTIONS(5544),
    [anon_sym_TILDE] = ACTIONS(5544),
    [anon_sym_STAR] = ACTIONS(5544),
    [anon_sym_AMP_AMP] = ACTIONS(5544),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5542),
    [anon_sym_typedef] = ACTIONS(5542),
    [anon_sym_extern] = ACTIONS(5542),
    [anon_sym___attribute__] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5544),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5544),
    [anon_sym___declspec] = ACTIONS(5542),
    [anon_sym___based] = ACTIONS(5542),
    [anon_sym_signed] = ACTIONS(5542),
    [anon_sym_unsigned] = ACTIONS(5542),
    [anon_sym_long] = ACTIONS(5542),
    [anon_sym_short] = ACTIONS(5542),
    [anon_sym_LBRACK] = ACTIONS(5542),
    [anon_sym_static] = ACTIONS(5542),
    [anon_sym_register] = ACTIONS(5542),
    [anon_sym_inline] = ACTIONS(5542),
    [anon_sym___inline] = ACTIONS(5542),
    [anon_sym___inline__] = ACTIONS(5542),
    [anon_sym___forceinline] = ACTIONS(5542),
    [anon_sym_thread_local] = ACTIONS(5542),
    [anon_sym___thread] = ACTIONS(5542),
    [anon_sym_const] = ACTIONS(5542),
    [anon_sym_constexpr] = ACTIONS(5542),
    [anon_sym_volatile] = ACTIONS(5542),
    [anon_sym_restrict] = ACTIONS(5542),
    [anon_sym___restrict__] = ACTIONS(5542),
    [anon_sym__Atomic] = ACTIONS(5542),
    [anon_sym__Noreturn] = ACTIONS(5542),
    [anon_sym_noreturn] = ACTIONS(5542),
    [anon_sym_mutable] = ACTIONS(5542),
    [anon_sym_constinit] = ACTIONS(5542),
    [anon_sym_consteval] = ACTIONS(5542),
    [anon_sym_PROGMEM] = ACTIONS(5542),
    [aux_sym_primitive_type_token1] = ACTIONS(5542),
    [anon_sym_byte] = ACTIONS(5542),
    [anon_sym_word] = ACTIONS(5542),
    [anon_sym_enum] = ACTIONS(5542),
    [anon_sym_class] = ACTIONS(5542),
    [anon_sym_struct] = ACTIONS(5542),
    [anon_sym_union] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5542),
    [anon_sym_decltype] = ACTIONS(5542),
    [anon_sym_virtual] = ACTIONS(5542),
    [anon_sym_alignas] = ACTIONS(5542),
    [anon_sym_explicit] = ACTIONS(5542),
    [anon_sym_typename] = ACTIONS(5542),
    [anon_sym_template] = ACTIONS(5542),
    [anon_sym_operator] = ACTIONS(5542),
    [anon_sym_friend] = ACTIONS(5542),
    [anon_sym_public] = ACTIONS(5542),
    [anon_sym_private] = ACTIONS(5542),
    [anon_sym_protected] = ACTIONS(5542),
    [anon_sym_using] = ACTIONS(5542),
    [anon_sym_static_assert] = ACTIONS(5542),
  },
  [2563] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(4471),
    [sym_raw_string_literal] = STATE(3057),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5870),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4280),
    [anon_sym_COLON] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_and_eq] = ACTIONS(4284),
    [anon_sym_or_eq] = ACTIONS(4284),
    [anon_sym_xor_eq] = ACTIONS(4284),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [2564] = {
    [sym_identifier] = ACTIONS(3419),
    [aux_sym_preproc_def_token1] = ACTIONS(3419),
    [aux_sym_preproc_if_token1] = ACTIONS(3419),
    [aux_sym_preproc_if_token2] = ACTIONS(3419),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3419),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3419),
    [sym_preproc_directive] = ACTIONS(3419),
    [anon_sym_LPAREN2] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym___extension__] = ACTIONS(3419),
    [anon_sym_typedef] = ACTIONS(3419),
    [anon_sym_extern] = ACTIONS(3419),
    [anon_sym___attribute__] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3421),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3421),
    [anon_sym___declspec] = ACTIONS(3419),
    [anon_sym___based] = ACTIONS(3419),
    [anon_sym_signed] = ACTIONS(3419),
    [anon_sym_unsigned] = ACTIONS(3419),
    [anon_sym_long] = ACTIONS(3419),
    [anon_sym_short] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_register] = ACTIONS(3419),
    [anon_sym_inline] = ACTIONS(3419),
    [anon_sym___inline] = ACTIONS(3419),
    [anon_sym___inline__] = ACTIONS(3419),
    [anon_sym___forceinline] = ACTIONS(3419),
    [anon_sym_thread_local] = ACTIONS(3419),
    [anon_sym___thread] = ACTIONS(3419),
    [anon_sym_const] = ACTIONS(3419),
    [anon_sym_constexpr] = ACTIONS(3419),
    [anon_sym_volatile] = ACTIONS(3419),
    [anon_sym_restrict] = ACTIONS(3419),
    [anon_sym___restrict__] = ACTIONS(3419),
    [anon_sym__Atomic] = ACTIONS(3419),
    [anon_sym__Noreturn] = ACTIONS(3419),
    [anon_sym_noreturn] = ACTIONS(3419),
    [anon_sym_mutable] = ACTIONS(3419),
    [anon_sym_constinit] = ACTIONS(3419),
    [anon_sym_consteval] = ACTIONS(3419),
    [anon_sym_PROGMEM] = ACTIONS(3419),
    [aux_sym_primitive_type_token1] = ACTIONS(3419),
    [anon_sym_byte] = ACTIONS(3419),
    [anon_sym_word] = ACTIONS(3419),
    [anon_sym_enum] = ACTIONS(3419),
    [anon_sym_class] = ACTIONS(3419),
    [anon_sym_struct] = ACTIONS(3419),
    [anon_sym_union] = ACTIONS(3419),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3419),
    [anon_sym_decltype] = ACTIONS(3419),
    [anon_sym_virtual] = ACTIONS(3419),
    [anon_sym_alignas] = ACTIONS(3419),
    [anon_sym_explicit] = ACTIONS(3419),
    [anon_sym_typename] = ACTIONS(3419),
    [anon_sym_template] = ACTIONS(3419),
    [anon_sym_operator] = ACTIONS(3419),
    [anon_sym_friend] = ACTIONS(3419),
    [anon_sym_public] = ACTIONS(3419),
    [anon_sym_private] = ACTIONS(3419),
    [anon_sym_protected] = ACTIONS(3419),
    [anon_sym_using] = ACTIONS(3419),
    [anon_sym_static_assert] = ACTIONS(3419),
  },
  [2565] = {
    [sym_identifier] = ACTIONS(5614),
    [aux_sym_preproc_def_token1] = ACTIONS(5614),
    [aux_sym_preproc_if_token1] = ACTIONS(5614),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5614),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5614),
    [sym_preproc_directive] = ACTIONS(5614),
    [anon_sym_LPAREN2] = ACTIONS(5616),
    [anon_sym_TILDE] = ACTIONS(5616),
    [anon_sym_STAR] = ACTIONS(5616),
    [anon_sym_AMP_AMP] = ACTIONS(5616),
    [anon_sym_AMP] = ACTIONS(5614),
    [anon_sym___extension__] = ACTIONS(5614),
    [anon_sym_typedef] = ACTIONS(5614),
    [anon_sym_extern] = ACTIONS(5614),
    [anon_sym___attribute__] = ACTIONS(5614),
    [anon_sym_COLON_COLON] = ACTIONS(5616),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5616),
    [anon_sym___declspec] = ACTIONS(5614),
    [anon_sym___based] = ACTIONS(5614),
    [anon_sym_RBRACE] = ACTIONS(5616),
    [anon_sym_signed] = ACTIONS(5614),
    [anon_sym_unsigned] = ACTIONS(5614),
    [anon_sym_long] = ACTIONS(5614),
    [anon_sym_short] = ACTIONS(5614),
    [anon_sym_LBRACK] = ACTIONS(5614),
    [anon_sym_static] = ACTIONS(5614),
    [anon_sym_register] = ACTIONS(5614),
    [anon_sym_inline] = ACTIONS(5614),
    [anon_sym___inline] = ACTIONS(5614),
    [anon_sym___inline__] = ACTIONS(5614),
    [anon_sym___forceinline] = ACTIONS(5614),
    [anon_sym_thread_local] = ACTIONS(5614),
    [anon_sym___thread] = ACTIONS(5614),
    [anon_sym_const] = ACTIONS(5614),
    [anon_sym_constexpr] = ACTIONS(5614),
    [anon_sym_volatile] = ACTIONS(5614),
    [anon_sym_restrict] = ACTIONS(5614),
    [anon_sym___restrict__] = ACTIONS(5614),
    [anon_sym__Atomic] = ACTIONS(5614),
    [anon_sym__Noreturn] = ACTIONS(5614),
    [anon_sym_noreturn] = ACTIONS(5614),
    [anon_sym_mutable] = ACTIONS(5614),
    [anon_sym_constinit] = ACTIONS(5614),
    [anon_sym_consteval] = ACTIONS(5614),
    [anon_sym_PROGMEM] = ACTIONS(5614),
    [aux_sym_primitive_type_token1] = ACTIONS(5614),
    [anon_sym_byte] = ACTIONS(5614),
    [anon_sym_word] = ACTIONS(5614),
    [anon_sym_enum] = ACTIONS(5614),
    [anon_sym_class] = ACTIONS(5614),
    [anon_sym_struct] = ACTIONS(5614),
    [anon_sym_union] = ACTIONS(5614),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5614),
    [anon_sym_decltype] = ACTIONS(5614),
    [anon_sym_virtual] = ACTIONS(5614),
    [anon_sym_alignas] = ACTIONS(5614),
    [anon_sym_explicit] = ACTIONS(5614),
    [anon_sym_typename] = ACTIONS(5614),
    [anon_sym_template] = ACTIONS(5614),
    [anon_sym_operator] = ACTIONS(5614),
    [anon_sym_friend] = ACTIONS(5614),
    [anon_sym_public] = ACTIONS(5614),
    [anon_sym_private] = ACTIONS(5614),
    [anon_sym_protected] = ACTIONS(5614),
    [anon_sym_using] = ACTIONS(5614),
    [anon_sym_static_assert] = ACTIONS(5614),
  },
  [2566] = {
    [sym_identifier] = ACTIONS(5526),
    [aux_sym_preproc_def_token1] = ACTIONS(5526),
    [aux_sym_preproc_if_token1] = ACTIONS(5526),
    [aux_sym_preproc_if_token2] = ACTIONS(5526),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5526),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5526),
    [sym_preproc_directive] = ACTIONS(5526),
    [anon_sym_LPAREN2] = ACTIONS(5528),
    [anon_sym_TILDE] = ACTIONS(5528),
    [anon_sym_STAR] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5526),
    [anon_sym___extension__] = ACTIONS(5526),
    [anon_sym_typedef] = ACTIONS(5526),
    [anon_sym_extern] = ACTIONS(5526),
    [anon_sym___attribute__] = ACTIONS(5526),
    [anon_sym_COLON_COLON] = ACTIONS(5528),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5528),
    [anon_sym___declspec] = ACTIONS(5526),
    [anon_sym___based] = ACTIONS(5526),
    [anon_sym_signed] = ACTIONS(5526),
    [anon_sym_unsigned] = ACTIONS(5526),
    [anon_sym_long] = ACTIONS(5526),
    [anon_sym_short] = ACTIONS(5526),
    [anon_sym_LBRACK] = ACTIONS(5526),
    [anon_sym_static] = ACTIONS(5526),
    [anon_sym_register] = ACTIONS(5526),
    [anon_sym_inline] = ACTIONS(5526),
    [anon_sym___inline] = ACTIONS(5526),
    [anon_sym___inline__] = ACTIONS(5526),
    [anon_sym___forceinline] = ACTIONS(5526),
    [anon_sym_thread_local] = ACTIONS(5526),
    [anon_sym___thread] = ACTIONS(5526),
    [anon_sym_const] = ACTIONS(5526),
    [anon_sym_constexpr] = ACTIONS(5526),
    [anon_sym_volatile] = ACTIONS(5526),
    [anon_sym_restrict] = ACTIONS(5526),
    [anon_sym___restrict__] = ACTIONS(5526),
    [anon_sym__Atomic] = ACTIONS(5526),
    [anon_sym__Noreturn] = ACTIONS(5526),
    [anon_sym_noreturn] = ACTIONS(5526),
    [anon_sym_mutable] = ACTIONS(5526),
    [anon_sym_constinit] = ACTIONS(5526),
    [anon_sym_consteval] = ACTIONS(5526),
    [anon_sym_PROGMEM] = ACTIONS(5526),
    [aux_sym_primitive_type_token1] = ACTIONS(5526),
    [anon_sym_byte] = ACTIONS(5526),
    [anon_sym_word] = ACTIONS(5526),
    [anon_sym_enum] = ACTIONS(5526),
    [anon_sym_class] = ACTIONS(5526),
    [anon_sym_struct] = ACTIONS(5526),
    [anon_sym_union] = ACTIONS(5526),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5526),
    [anon_sym_decltype] = ACTIONS(5526),
    [anon_sym_virtual] = ACTIONS(5526),
    [anon_sym_alignas] = ACTIONS(5526),
    [anon_sym_explicit] = ACTIONS(5526),
    [anon_sym_typename] = ACTIONS(5526),
    [anon_sym_template] = ACTIONS(5526),
    [anon_sym_operator] = ACTIONS(5526),
    [anon_sym_friend] = ACTIONS(5526),
    [anon_sym_public] = ACTIONS(5526),
    [anon_sym_private] = ACTIONS(5526),
    [anon_sym_protected] = ACTIONS(5526),
    [anon_sym_using] = ACTIONS(5526),
    [anon_sym_static_assert] = ACTIONS(5526),
  },
  [2567] = {
    [sym_identifier] = ACTIONS(5614),
    [aux_sym_preproc_def_token1] = ACTIONS(5614),
    [aux_sym_preproc_if_token1] = ACTIONS(5614),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5614),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5614),
    [sym_preproc_directive] = ACTIONS(5614),
    [anon_sym_LPAREN2] = ACTIONS(5616),
    [anon_sym_TILDE] = ACTIONS(5616),
    [anon_sym_STAR] = ACTIONS(5616),
    [anon_sym_AMP_AMP] = ACTIONS(5616),
    [anon_sym_AMP] = ACTIONS(5614),
    [anon_sym___extension__] = ACTIONS(5614),
    [anon_sym_typedef] = ACTIONS(5614),
    [anon_sym_extern] = ACTIONS(5614),
    [anon_sym___attribute__] = ACTIONS(5614),
    [anon_sym_COLON_COLON] = ACTIONS(5616),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5616),
    [anon_sym___declspec] = ACTIONS(5614),
    [anon_sym___based] = ACTIONS(5614),
    [anon_sym_RBRACE] = ACTIONS(5616),
    [anon_sym_signed] = ACTIONS(5614),
    [anon_sym_unsigned] = ACTIONS(5614),
    [anon_sym_long] = ACTIONS(5614),
    [anon_sym_short] = ACTIONS(5614),
    [anon_sym_LBRACK] = ACTIONS(5614),
    [anon_sym_static] = ACTIONS(5614),
    [anon_sym_register] = ACTIONS(5614),
    [anon_sym_inline] = ACTIONS(5614),
    [anon_sym___inline] = ACTIONS(5614),
    [anon_sym___inline__] = ACTIONS(5614),
    [anon_sym___forceinline] = ACTIONS(5614),
    [anon_sym_thread_local] = ACTIONS(5614),
    [anon_sym___thread] = ACTIONS(5614),
    [anon_sym_const] = ACTIONS(5614),
    [anon_sym_constexpr] = ACTIONS(5614),
    [anon_sym_volatile] = ACTIONS(5614),
    [anon_sym_restrict] = ACTIONS(5614),
    [anon_sym___restrict__] = ACTIONS(5614),
    [anon_sym__Atomic] = ACTIONS(5614),
    [anon_sym__Noreturn] = ACTIONS(5614),
    [anon_sym_noreturn] = ACTIONS(5614),
    [anon_sym_mutable] = ACTIONS(5614),
    [anon_sym_constinit] = ACTIONS(5614),
    [anon_sym_consteval] = ACTIONS(5614),
    [anon_sym_PROGMEM] = ACTIONS(5614),
    [aux_sym_primitive_type_token1] = ACTIONS(5614),
    [anon_sym_byte] = ACTIONS(5614),
    [anon_sym_word] = ACTIONS(5614),
    [anon_sym_enum] = ACTIONS(5614),
    [anon_sym_class] = ACTIONS(5614),
    [anon_sym_struct] = ACTIONS(5614),
    [anon_sym_union] = ACTIONS(5614),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5614),
    [anon_sym_decltype] = ACTIONS(5614),
    [anon_sym_virtual] = ACTIONS(5614),
    [anon_sym_alignas] = ACTIONS(5614),
    [anon_sym_explicit] = ACTIONS(5614),
    [anon_sym_typename] = ACTIONS(5614),
    [anon_sym_template] = ACTIONS(5614),
    [anon_sym_operator] = ACTIONS(5614),
    [anon_sym_friend] = ACTIONS(5614),
    [anon_sym_public] = ACTIONS(5614),
    [anon_sym_private] = ACTIONS(5614),
    [anon_sym_protected] = ACTIONS(5614),
    [anon_sym_using] = ACTIONS(5614),
    [anon_sym_static_assert] = ACTIONS(5614),
  },
  [2568] = {
    [sym_identifier] = ACTIONS(3144),
    [aux_sym_preproc_def_token1] = ACTIONS(3144),
    [aux_sym_preproc_if_token1] = ACTIONS(3144),
    [aux_sym_preproc_if_token2] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3144),
    [sym_preproc_directive] = ACTIONS(3144),
    [anon_sym_LPAREN2] = ACTIONS(3146),
    [anon_sym_TILDE] = ACTIONS(3146),
    [anon_sym_STAR] = ACTIONS(3146),
    [anon_sym_AMP_AMP] = ACTIONS(3146),
    [anon_sym_AMP] = ACTIONS(3144),
    [anon_sym___extension__] = ACTIONS(3144),
    [anon_sym_typedef] = ACTIONS(3144),
    [anon_sym_extern] = ACTIONS(3144),
    [anon_sym___attribute__] = ACTIONS(3144),
    [anon_sym_COLON_COLON] = ACTIONS(3146),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3146),
    [anon_sym___declspec] = ACTIONS(3144),
    [anon_sym___based] = ACTIONS(3144),
    [anon_sym_signed] = ACTIONS(3144),
    [anon_sym_unsigned] = ACTIONS(3144),
    [anon_sym_long] = ACTIONS(3144),
    [anon_sym_short] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3144),
    [anon_sym_static] = ACTIONS(3144),
    [anon_sym_register] = ACTIONS(3144),
    [anon_sym_inline] = ACTIONS(3144),
    [anon_sym___inline] = ACTIONS(3144),
    [anon_sym___inline__] = ACTIONS(3144),
    [anon_sym___forceinline] = ACTIONS(3144),
    [anon_sym_thread_local] = ACTIONS(3144),
    [anon_sym___thread] = ACTIONS(3144),
    [anon_sym_const] = ACTIONS(3144),
    [anon_sym_constexpr] = ACTIONS(3144),
    [anon_sym_volatile] = ACTIONS(3144),
    [anon_sym_restrict] = ACTIONS(3144),
    [anon_sym___restrict__] = ACTIONS(3144),
    [anon_sym__Atomic] = ACTIONS(3144),
    [anon_sym__Noreturn] = ACTIONS(3144),
    [anon_sym_noreturn] = ACTIONS(3144),
    [anon_sym_mutable] = ACTIONS(3144),
    [anon_sym_constinit] = ACTIONS(3144),
    [anon_sym_consteval] = ACTIONS(3144),
    [anon_sym_PROGMEM] = ACTIONS(3144),
    [aux_sym_primitive_type_token1] = ACTIONS(3144),
    [anon_sym_byte] = ACTIONS(3144),
    [anon_sym_word] = ACTIONS(3144),
    [anon_sym_enum] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_struct] = ACTIONS(3144),
    [anon_sym_union] = ACTIONS(3144),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3144),
    [anon_sym_decltype] = ACTIONS(3144),
    [anon_sym_virtual] = ACTIONS(3144),
    [anon_sym_alignas] = ACTIONS(3144),
    [anon_sym_explicit] = ACTIONS(3144),
    [anon_sym_typename] = ACTIONS(3144),
    [anon_sym_template] = ACTIONS(3144),
    [anon_sym_operator] = ACTIONS(3144),
    [anon_sym_friend] = ACTIONS(3144),
    [anon_sym_public] = ACTIONS(3144),
    [anon_sym_private] = ACTIONS(3144),
    [anon_sym_protected] = ACTIONS(3144),
    [anon_sym_using] = ACTIONS(3144),
    [anon_sym_static_assert] = ACTIONS(3144),
  },
  [2569] = {
    [sym_identifier] = ACTIONS(3301),
    [aux_sym_preproc_def_token1] = ACTIONS(3301),
    [aux_sym_preproc_if_token1] = ACTIONS(3301),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3301),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3301),
    [sym_preproc_directive] = ACTIONS(3301),
    [anon_sym_LPAREN2] = ACTIONS(3303),
    [anon_sym_TILDE] = ACTIONS(3303),
    [anon_sym_STAR] = ACTIONS(3303),
    [anon_sym_AMP_AMP] = ACTIONS(3303),
    [anon_sym_AMP] = ACTIONS(3301),
    [anon_sym___extension__] = ACTIONS(3301),
    [anon_sym_typedef] = ACTIONS(3301),
    [anon_sym_extern] = ACTIONS(3301),
    [anon_sym___attribute__] = ACTIONS(3301),
    [anon_sym_COLON_COLON] = ACTIONS(3303),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3303),
    [anon_sym___declspec] = ACTIONS(3301),
    [anon_sym___based] = ACTIONS(3301),
    [anon_sym_RBRACE] = ACTIONS(3303),
    [anon_sym_signed] = ACTIONS(3301),
    [anon_sym_unsigned] = ACTIONS(3301),
    [anon_sym_long] = ACTIONS(3301),
    [anon_sym_short] = ACTIONS(3301),
    [anon_sym_LBRACK] = ACTIONS(3301),
    [anon_sym_static] = ACTIONS(3301),
    [anon_sym_register] = ACTIONS(3301),
    [anon_sym_inline] = ACTIONS(3301),
    [anon_sym___inline] = ACTIONS(3301),
    [anon_sym___inline__] = ACTIONS(3301),
    [anon_sym___forceinline] = ACTIONS(3301),
    [anon_sym_thread_local] = ACTIONS(3301),
    [anon_sym___thread] = ACTIONS(3301),
    [anon_sym_const] = ACTIONS(3301),
    [anon_sym_constexpr] = ACTIONS(3301),
    [anon_sym_volatile] = ACTIONS(3301),
    [anon_sym_restrict] = ACTIONS(3301),
    [anon_sym___restrict__] = ACTIONS(3301),
    [anon_sym__Atomic] = ACTIONS(3301),
    [anon_sym__Noreturn] = ACTIONS(3301),
    [anon_sym_noreturn] = ACTIONS(3301),
    [anon_sym_mutable] = ACTIONS(3301),
    [anon_sym_constinit] = ACTIONS(3301),
    [anon_sym_consteval] = ACTIONS(3301),
    [anon_sym_PROGMEM] = ACTIONS(3301),
    [aux_sym_primitive_type_token1] = ACTIONS(3301),
    [anon_sym_byte] = ACTIONS(3301),
    [anon_sym_word] = ACTIONS(3301),
    [anon_sym_enum] = ACTIONS(3301),
    [anon_sym_class] = ACTIONS(3301),
    [anon_sym_struct] = ACTIONS(3301),
    [anon_sym_union] = ACTIONS(3301),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3301),
    [anon_sym_decltype] = ACTIONS(3301),
    [anon_sym_virtual] = ACTIONS(3301),
    [anon_sym_alignas] = ACTIONS(3301),
    [anon_sym_explicit] = ACTIONS(3301),
    [anon_sym_typename] = ACTIONS(3301),
    [anon_sym_template] = ACTIONS(3301),
    [anon_sym_operator] = ACTIONS(3301),
    [anon_sym_friend] = ACTIONS(3301),
    [anon_sym_public] = ACTIONS(3301),
    [anon_sym_private] = ACTIONS(3301),
    [anon_sym_protected] = ACTIONS(3301),
    [anon_sym_using] = ACTIONS(3301),
    [anon_sym_static_assert] = ACTIONS(3301),
  },
  [2570] = {
    [sym_identifier] = ACTIONS(3128),
    [aux_sym_preproc_def_token1] = ACTIONS(3128),
    [aux_sym_preproc_if_token1] = ACTIONS(3128),
    [aux_sym_preproc_if_token2] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3128),
    [sym_preproc_directive] = ACTIONS(3128),
    [anon_sym_LPAREN2] = ACTIONS(3130),
    [anon_sym_TILDE] = ACTIONS(3130),
    [anon_sym_STAR] = ACTIONS(3130),
    [anon_sym_AMP_AMP] = ACTIONS(3130),
    [anon_sym_AMP] = ACTIONS(3128),
    [anon_sym___extension__] = ACTIONS(3128),
    [anon_sym_typedef] = ACTIONS(3128),
    [anon_sym_extern] = ACTIONS(3128),
    [anon_sym___attribute__] = ACTIONS(3128),
    [anon_sym_COLON_COLON] = ACTIONS(3130),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3130),
    [anon_sym___declspec] = ACTIONS(3128),
    [anon_sym___based] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3128),
    [anon_sym_unsigned] = ACTIONS(3128),
    [anon_sym_long] = ACTIONS(3128),
    [anon_sym_short] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3128),
    [anon_sym_static] = ACTIONS(3128),
    [anon_sym_register] = ACTIONS(3128),
    [anon_sym_inline] = ACTIONS(3128),
    [anon_sym___inline] = ACTIONS(3128),
    [anon_sym___inline__] = ACTIONS(3128),
    [anon_sym___forceinline] = ACTIONS(3128),
    [anon_sym_thread_local] = ACTIONS(3128),
    [anon_sym___thread] = ACTIONS(3128),
    [anon_sym_const] = ACTIONS(3128),
    [anon_sym_constexpr] = ACTIONS(3128),
    [anon_sym_volatile] = ACTIONS(3128),
    [anon_sym_restrict] = ACTIONS(3128),
    [anon_sym___restrict__] = ACTIONS(3128),
    [anon_sym__Atomic] = ACTIONS(3128),
    [anon_sym__Noreturn] = ACTIONS(3128),
    [anon_sym_noreturn] = ACTIONS(3128),
    [anon_sym_mutable] = ACTIONS(3128),
    [anon_sym_constinit] = ACTIONS(3128),
    [anon_sym_consteval] = ACTIONS(3128),
    [anon_sym_PROGMEM] = ACTIONS(3128),
    [aux_sym_primitive_type_token1] = ACTIONS(3128),
    [anon_sym_byte] = ACTIONS(3128),
    [anon_sym_word] = ACTIONS(3128),
    [anon_sym_enum] = ACTIONS(3128),
    [anon_sym_class] = ACTIONS(3128),
    [anon_sym_struct] = ACTIONS(3128),
    [anon_sym_union] = ACTIONS(3128),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3128),
    [anon_sym_decltype] = ACTIONS(3128),
    [anon_sym_virtual] = ACTIONS(3128),
    [anon_sym_alignas] = ACTIONS(3128),
    [anon_sym_explicit] = ACTIONS(3128),
    [anon_sym_typename] = ACTIONS(3128),
    [anon_sym_template] = ACTIONS(3128),
    [anon_sym_operator] = ACTIONS(3128),
    [anon_sym_friend] = ACTIONS(3128),
    [anon_sym_public] = ACTIONS(3128),
    [anon_sym_private] = ACTIONS(3128),
    [anon_sym_protected] = ACTIONS(3128),
    [anon_sym_using] = ACTIONS(3128),
    [anon_sym_static_assert] = ACTIONS(3128),
  },
  [2571] = {
    [sym_template_argument_list] = STATE(2036),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2730),
    [sym_identifier] = ACTIONS(5958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5960),
    [anon_sym_COMMA] = ACTIONS(5960),
    [aux_sym_preproc_if_token2] = ACTIONS(5960),
    [aux_sym_preproc_else_token1] = ACTIONS(5960),
    [aux_sym_preproc_elif_token1] = ACTIONS(5958),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5960),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5960),
    [anon_sym_LPAREN2] = ACTIONS(5960),
    [anon_sym_DASH] = ACTIONS(5958),
    [anon_sym_PLUS] = ACTIONS(5958),
    [anon_sym_STAR] = ACTIONS(5958),
    [anon_sym_SLASH] = ACTIONS(5958),
    [anon_sym_PERCENT] = ACTIONS(5958),
    [anon_sym_PIPE_PIPE] = ACTIONS(5960),
    [anon_sym_AMP_AMP] = ACTIONS(5960),
    [anon_sym_PIPE] = ACTIONS(5958),
    [anon_sym_CARET] = ACTIONS(5958),
    [anon_sym_AMP] = ACTIONS(5958),
    [anon_sym_EQ_EQ] = ACTIONS(5960),
    [anon_sym_BANG_EQ] = ACTIONS(5960),
    [anon_sym_GT] = ACTIONS(5958),
    [anon_sym_GT_EQ] = ACTIONS(5960),
    [anon_sym_LT_EQ] = ACTIONS(5958),
    [anon_sym_LT] = ACTIONS(5958),
    [anon_sym_LT_LT] = ACTIONS(5958),
    [anon_sym_GT_GT] = ACTIONS(5958),
    [anon_sym___attribute__] = ACTIONS(5958),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(5960),
    [anon_sym_signed] = ACTIONS(5962),
    [anon_sym_unsigned] = ACTIONS(5962),
    [anon_sym_long] = ACTIONS(5962),
    [anon_sym_short] = ACTIONS(5962),
    [anon_sym_LBRACK] = ACTIONS(5960),
    [anon_sym_EQ] = ACTIONS(5958),
    [anon_sym_QMARK] = ACTIONS(5960),
    [anon_sym_STAR_EQ] = ACTIONS(5960),
    [anon_sym_SLASH_EQ] = ACTIONS(5960),
    [anon_sym_PERCENT_EQ] = ACTIONS(5960),
    [anon_sym_PLUS_EQ] = ACTIONS(5960),
    [anon_sym_DASH_EQ] = ACTIONS(5960),
    [anon_sym_LT_LT_EQ] = ACTIONS(5960),
    [anon_sym_GT_GT_EQ] = ACTIONS(5960),
    [anon_sym_AMP_EQ] = ACTIONS(5960),
    [anon_sym_CARET_EQ] = ACTIONS(5960),
    [anon_sym_PIPE_EQ] = ACTIONS(5960),
    [anon_sym_and_eq] = ACTIONS(5958),
    [anon_sym_or_eq] = ACTIONS(5958),
    [anon_sym_xor_eq] = ACTIONS(5958),
    [anon_sym_LT_EQ_GT] = ACTIONS(5960),
    [anon_sym_or] = ACTIONS(5958),
    [anon_sym_and] = ACTIONS(5958),
    [anon_sym_bitor] = ACTIONS(5958),
    [anon_sym_xor] = ACTIONS(5958),
    [anon_sym_bitand] = ACTIONS(5958),
    [anon_sym_not_eq] = ACTIONS(5958),
    [anon_sym_DASH_DASH] = ACTIONS(5960),
    [anon_sym_PLUS_PLUS] = ACTIONS(5960),
    [anon_sym_DOT] = ACTIONS(5958),
    [anon_sym_DOT_STAR] = ACTIONS(5960),
    [anon_sym_DASH_GT] = ACTIONS(5960),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5958),
    [anon_sym_decltype] = ACTIONS(5958),
  },
  [2572] = {
    [sym_identifier] = ACTIONS(3423),
    [aux_sym_preproc_def_token1] = ACTIONS(3423),
    [aux_sym_preproc_if_token1] = ACTIONS(3423),
    [aux_sym_preproc_if_token2] = ACTIONS(3423),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3423),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3423),
    [sym_preproc_directive] = ACTIONS(3423),
    [anon_sym_LPAREN2] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [anon_sym_STAR] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3423),
    [anon_sym___extension__] = ACTIONS(3423),
    [anon_sym_typedef] = ACTIONS(3423),
    [anon_sym_extern] = ACTIONS(3423),
    [anon_sym___attribute__] = ACTIONS(3423),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3425),
    [anon_sym___declspec] = ACTIONS(3423),
    [anon_sym___based] = ACTIONS(3423),
    [anon_sym_signed] = ACTIONS(3423),
    [anon_sym_unsigned] = ACTIONS(3423),
    [anon_sym_long] = ACTIONS(3423),
    [anon_sym_short] = ACTIONS(3423),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_static] = ACTIONS(3423),
    [anon_sym_register] = ACTIONS(3423),
    [anon_sym_inline] = ACTIONS(3423),
    [anon_sym___inline] = ACTIONS(3423),
    [anon_sym___inline__] = ACTIONS(3423),
    [anon_sym___forceinline] = ACTIONS(3423),
    [anon_sym_thread_local] = ACTIONS(3423),
    [anon_sym___thread] = ACTIONS(3423),
    [anon_sym_const] = ACTIONS(3423),
    [anon_sym_constexpr] = ACTIONS(3423),
    [anon_sym_volatile] = ACTIONS(3423),
    [anon_sym_restrict] = ACTIONS(3423),
    [anon_sym___restrict__] = ACTIONS(3423),
    [anon_sym__Atomic] = ACTIONS(3423),
    [anon_sym__Noreturn] = ACTIONS(3423),
    [anon_sym_noreturn] = ACTIONS(3423),
    [anon_sym_mutable] = ACTIONS(3423),
    [anon_sym_constinit] = ACTIONS(3423),
    [anon_sym_consteval] = ACTIONS(3423),
    [anon_sym_PROGMEM] = ACTIONS(3423),
    [aux_sym_primitive_type_token1] = ACTIONS(3423),
    [anon_sym_byte] = ACTIONS(3423),
    [anon_sym_word] = ACTIONS(3423),
    [anon_sym_enum] = ACTIONS(3423),
    [anon_sym_class] = ACTIONS(3423),
    [anon_sym_struct] = ACTIONS(3423),
    [anon_sym_union] = ACTIONS(3423),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3423),
    [anon_sym_decltype] = ACTIONS(3423),
    [anon_sym_virtual] = ACTIONS(3423),
    [anon_sym_alignas] = ACTIONS(3423),
    [anon_sym_explicit] = ACTIONS(3423),
    [anon_sym_typename] = ACTIONS(3423),
    [anon_sym_template] = ACTIONS(3423),
    [anon_sym_operator] = ACTIONS(3423),
    [anon_sym_friend] = ACTIONS(3423),
    [anon_sym_public] = ACTIONS(3423),
    [anon_sym_private] = ACTIONS(3423),
    [anon_sym_protected] = ACTIONS(3423),
    [anon_sym_using] = ACTIONS(3423),
    [anon_sym_static_assert] = ACTIONS(3423),
  },
  [2573] = {
    [sym_identifier] = ACTIONS(3128),
    [aux_sym_preproc_def_token1] = ACTIONS(3128),
    [aux_sym_preproc_if_token1] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3128),
    [sym_preproc_directive] = ACTIONS(3128),
    [anon_sym_LPAREN2] = ACTIONS(3130),
    [anon_sym_TILDE] = ACTIONS(3130),
    [anon_sym_STAR] = ACTIONS(3130),
    [anon_sym_AMP_AMP] = ACTIONS(3130),
    [anon_sym_AMP] = ACTIONS(3128),
    [anon_sym___extension__] = ACTIONS(3128),
    [anon_sym_typedef] = ACTIONS(3128),
    [anon_sym_extern] = ACTIONS(3128),
    [anon_sym___attribute__] = ACTIONS(3128),
    [anon_sym_COLON_COLON] = ACTIONS(3130),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3130),
    [anon_sym___declspec] = ACTIONS(3128),
    [anon_sym___based] = ACTIONS(3128),
    [anon_sym_RBRACE] = ACTIONS(3130),
    [anon_sym_signed] = ACTIONS(3128),
    [anon_sym_unsigned] = ACTIONS(3128),
    [anon_sym_long] = ACTIONS(3128),
    [anon_sym_short] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3128),
    [anon_sym_static] = ACTIONS(3128),
    [anon_sym_register] = ACTIONS(3128),
    [anon_sym_inline] = ACTIONS(3128),
    [anon_sym___inline] = ACTIONS(3128),
    [anon_sym___inline__] = ACTIONS(3128),
    [anon_sym___forceinline] = ACTIONS(3128),
    [anon_sym_thread_local] = ACTIONS(3128),
    [anon_sym___thread] = ACTIONS(3128),
    [anon_sym_const] = ACTIONS(3128),
    [anon_sym_constexpr] = ACTIONS(3128),
    [anon_sym_volatile] = ACTIONS(3128),
    [anon_sym_restrict] = ACTIONS(3128),
    [anon_sym___restrict__] = ACTIONS(3128),
    [anon_sym__Atomic] = ACTIONS(3128),
    [anon_sym__Noreturn] = ACTIONS(3128),
    [anon_sym_noreturn] = ACTIONS(3128),
    [anon_sym_mutable] = ACTIONS(3128),
    [anon_sym_constinit] = ACTIONS(3128),
    [anon_sym_consteval] = ACTIONS(3128),
    [anon_sym_PROGMEM] = ACTIONS(3128),
    [aux_sym_primitive_type_token1] = ACTIONS(3128),
    [anon_sym_byte] = ACTIONS(3128),
    [anon_sym_word] = ACTIONS(3128),
    [anon_sym_enum] = ACTIONS(3128),
    [anon_sym_class] = ACTIONS(3128),
    [anon_sym_struct] = ACTIONS(3128),
    [anon_sym_union] = ACTIONS(3128),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3128),
    [anon_sym_decltype] = ACTIONS(3128),
    [anon_sym_virtual] = ACTIONS(3128),
    [anon_sym_alignas] = ACTIONS(3128),
    [anon_sym_explicit] = ACTIONS(3128),
    [anon_sym_typename] = ACTIONS(3128),
    [anon_sym_template] = ACTIONS(3128),
    [anon_sym_operator] = ACTIONS(3128),
    [anon_sym_friend] = ACTIONS(3128),
    [anon_sym_public] = ACTIONS(3128),
    [anon_sym_private] = ACTIONS(3128),
    [anon_sym_protected] = ACTIONS(3128),
    [anon_sym_using] = ACTIONS(3128),
    [anon_sym_static_assert] = ACTIONS(3128),
  },
  [2574] = {
    [sym_identifier] = ACTIONS(3353),
    [aux_sym_preproc_def_token1] = ACTIONS(3353),
    [aux_sym_preproc_if_token1] = ACTIONS(3353),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3353),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3353),
    [sym_preproc_directive] = ACTIONS(3353),
    [anon_sym_LPAREN2] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3355),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_AMP_AMP] = ACTIONS(3355),
    [anon_sym_AMP] = ACTIONS(3353),
    [anon_sym___extension__] = ACTIONS(3353),
    [anon_sym_typedef] = ACTIONS(3353),
    [anon_sym_extern] = ACTIONS(3353),
    [anon_sym___attribute__] = ACTIONS(3353),
    [anon_sym_COLON_COLON] = ACTIONS(3355),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3355),
    [anon_sym___declspec] = ACTIONS(3353),
    [anon_sym___based] = ACTIONS(3353),
    [anon_sym_RBRACE] = ACTIONS(3355),
    [anon_sym_signed] = ACTIONS(3353),
    [anon_sym_unsigned] = ACTIONS(3353),
    [anon_sym_long] = ACTIONS(3353),
    [anon_sym_short] = ACTIONS(3353),
    [anon_sym_LBRACK] = ACTIONS(3353),
    [anon_sym_static] = ACTIONS(3353),
    [anon_sym_register] = ACTIONS(3353),
    [anon_sym_inline] = ACTIONS(3353),
    [anon_sym___inline] = ACTIONS(3353),
    [anon_sym___inline__] = ACTIONS(3353),
    [anon_sym___forceinline] = ACTIONS(3353),
    [anon_sym_thread_local] = ACTIONS(3353),
    [anon_sym___thread] = ACTIONS(3353),
    [anon_sym_const] = ACTIONS(3353),
    [anon_sym_constexpr] = ACTIONS(3353),
    [anon_sym_volatile] = ACTIONS(3353),
    [anon_sym_restrict] = ACTIONS(3353),
    [anon_sym___restrict__] = ACTIONS(3353),
    [anon_sym__Atomic] = ACTIONS(3353),
    [anon_sym__Noreturn] = ACTIONS(3353),
    [anon_sym_noreturn] = ACTIONS(3353),
    [anon_sym_mutable] = ACTIONS(3353),
    [anon_sym_constinit] = ACTIONS(3353),
    [anon_sym_consteval] = ACTIONS(3353),
    [anon_sym_PROGMEM] = ACTIONS(3353),
    [aux_sym_primitive_type_token1] = ACTIONS(3353),
    [anon_sym_byte] = ACTIONS(3353),
    [anon_sym_word] = ACTIONS(3353),
    [anon_sym_enum] = ACTIONS(3353),
    [anon_sym_class] = ACTIONS(3353),
    [anon_sym_struct] = ACTIONS(3353),
    [anon_sym_union] = ACTIONS(3353),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3353),
    [anon_sym_decltype] = ACTIONS(3353),
    [anon_sym_virtual] = ACTIONS(3353),
    [anon_sym_alignas] = ACTIONS(3353),
    [anon_sym_explicit] = ACTIONS(3353),
    [anon_sym_typename] = ACTIONS(3353),
    [anon_sym_template] = ACTIONS(3353),
    [anon_sym_operator] = ACTIONS(3353),
    [anon_sym_friend] = ACTIONS(3353),
    [anon_sym_public] = ACTIONS(3353),
    [anon_sym_private] = ACTIONS(3353),
    [anon_sym_protected] = ACTIONS(3353),
    [anon_sym_using] = ACTIONS(3353),
    [anon_sym_static_assert] = ACTIONS(3353),
  },
  [2575] = {
    [sym_string_literal] = STATE(2460),
    [sym_raw_string_literal] = STATE(2460),
    [aux_sym_concatenated_string_repeat1] = STATE(2460),
    [sym_identifier] = ACTIONS(5964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5387),
    [anon_sym_COMMA] = ACTIONS(5387),
    [anon_sym_LPAREN2] = ACTIONS(5387),
    [anon_sym_DASH] = ACTIONS(5389),
    [anon_sym_PLUS] = ACTIONS(5389),
    [anon_sym_STAR] = ACTIONS(5389),
    [anon_sym_SLASH] = ACTIONS(5389),
    [anon_sym_PERCENT] = ACTIONS(5389),
    [anon_sym_PIPE_PIPE] = ACTIONS(5387),
    [anon_sym_AMP_AMP] = ACTIONS(5387),
    [anon_sym_PIPE] = ACTIONS(5389),
    [anon_sym_CARET] = ACTIONS(5389),
    [anon_sym_AMP] = ACTIONS(5389),
    [anon_sym_EQ_EQ] = ACTIONS(5387),
    [anon_sym_BANG_EQ] = ACTIONS(5387),
    [anon_sym_GT] = ACTIONS(5389),
    [anon_sym_GT_EQ] = ACTIONS(5387),
    [anon_sym_LT_EQ] = ACTIONS(5389),
    [anon_sym_LT] = ACTIONS(5389),
    [anon_sym_LT_LT] = ACTIONS(5389),
    [anon_sym_GT_GT] = ACTIONS(5389),
    [anon_sym_SEMI] = ACTIONS(5387),
    [anon_sym___attribute__] = ACTIONS(5389),
    [anon_sym_LBRACK] = ACTIONS(5387),
    [anon_sym_EQ] = ACTIONS(5389),
    [anon_sym_QMARK] = ACTIONS(5387),
    [anon_sym_STAR_EQ] = ACTIONS(5387),
    [anon_sym_SLASH_EQ] = ACTIONS(5387),
    [anon_sym_PERCENT_EQ] = ACTIONS(5387),
    [anon_sym_PLUS_EQ] = ACTIONS(5387),
    [anon_sym_DASH_EQ] = ACTIONS(5387),
    [anon_sym_LT_LT_EQ] = ACTIONS(5387),
    [anon_sym_GT_GT_EQ] = ACTIONS(5387),
    [anon_sym_AMP_EQ] = ACTIONS(5387),
    [anon_sym_CARET_EQ] = ACTIONS(5387),
    [anon_sym_PIPE_EQ] = ACTIONS(5387),
    [anon_sym_and_eq] = ACTIONS(5389),
    [anon_sym_or_eq] = ACTIONS(5389),
    [anon_sym_xor_eq] = ACTIONS(5389),
    [anon_sym_LT_EQ_GT] = ACTIONS(5387),
    [anon_sym_or] = ACTIONS(5389),
    [anon_sym_and] = ACTIONS(5389),
    [anon_sym_bitor] = ACTIONS(5389),
    [anon_sym_xor] = ACTIONS(5389),
    [anon_sym_bitand] = ACTIONS(5389),
    [anon_sym_not_eq] = ACTIONS(5389),
    [anon_sym_DASH_DASH] = ACTIONS(5387),
    [anon_sym_PLUS_PLUS] = ACTIONS(5387),
    [anon_sym_DOT] = ACTIONS(5389),
    [anon_sym_DOT_STAR] = ACTIONS(5387),
    [anon_sym_DASH_GT] = ACTIONS(5387),
    [anon_sym_L_DQUOTE] = ACTIONS(5912),
    [anon_sym_u_DQUOTE] = ACTIONS(5912),
    [anon_sym_U_DQUOTE] = ACTIONS(5912),
    [anon_sym_u8_DQUOTE] = ACTIONS(5912),
    [anon_sym_DQUOTE] = ACTIONS(5912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5914),
    [anon_sym_LR_DQUOTE] = ACTIONS(5914),
    [anon_sym_uR_DQUOTE] = ACTIONS(5914),
    [anon_sym_UR_DQUOTE] = ACTIONS(5914),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5914),
    [sym_literal_suffix] = ACTIONS(5389),
  },
  [2576] = {
    [sym_identifier] = ACTIONS(3387),
    [aux_sym_preproc_def_token1] = ACTIONS(3387),
    [aux_sym_preproc_if_token1] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3387),
    [sym_preproc_directive] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_STAR] = ACTIONS(3389),
    [anon_sym_AMP_AMP] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym___extension__] = ACTIONS(3387),
    [anon_sym_typedef] = ACTIONS(3387),
    [anon_sym_extern] = ACTIONS(3387),
    [anon_sym___attribute__] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3389),
    [anon_sym___declspec] = ACTIONS(3387),
    [anon_sym___based] = ACTIONS(3387),
    [anon_sym_RBRACE] = ACTIONS(3389),
    [anon_sym_signed] = ACTIONS(3387),
    [anon_sym_unsigned] = ACTIONS(3387),
    [anon_sym_long] = ACTIONS(3387),
    [anon_sym_short] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_register] = ACTIONS(3387),
    [anon_sym_inline] = ACTIONS(3387),
    [anon_sym___inline] = ACTIONS(3387),
    [anon_sym___inline__] = ACTIONS(3387),
    [anon_sym___forceinline] = ACTIONS(3387),
    [anon_sym_thread_local] = ACTIONS(3387),
    [anon_sym___thread] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_constexpr] = ACTIONS(3387),
    [anon_sym_volatile] = ACTIONS(3387),
    [anon_sym_restrict] = ACTIONS(3387),
    [anon_sym___restrict__] = ACTIONS(3387),
    [anon_sym__Atomic] = ACTIONS(3387),
    [anon_sym__Noreturn] = ACTIONS(3387),
    [anon_sym_noreturn] = ACTIONS(3387),
    [anon_sym_mutable] = ACTIONS(3387),
    [anon_sym_constinit] = ACTIONS(3387),
    [anon_sym_consteval] = ACTIONS(3387),
    [anon_sym_PROGMEM] = ACTIONS(3387),
    [aux_sym_primitive_type_token1] = ACTIONS(3387),
    [anon_sym_byte] = ACTIONS(3387),
    [anon_sym_word] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [anon_sym_class] = ACTIONS(3387),
    [anon_sym_struct] = ACTIONS(3387),
    [anon_sym_union] = ACTIONS(3387),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3387),
    [anon_sym_decltype] = ACTIONS(3387),
    [anon_sym_virtual] = ACTIONS(3387),
    [anon_sym_alignas] = ACTIONS(3387),
    [anon_sym_explicit] = ACTIONS(3387),
    [anon_sym_typename] = ACTIONS(3387),
    [anon_sym_template] = ACTIONS(3387),
    [anon_sym_operator] = ACTIONS(3387),
    [anon_sym_friend] = ACTIONS(3387),
    [anon_sym_public] = ACTIONS(3387),
    [anon_sym_private] = ACTIONS(3387),
    [anon_sym_protected] = ACTIONS(3387),
    [anon_sym_using] = ACTIONS(3387),
    [anon_sym_static_assert] = ACTIONS(3387),
  },
  [2577] = {
    [sym_identifier] = ACTIONS(3403),
    [aux_sym_preproc_def_token1] = ACTIONS(3403),
    [aux_sym_preproc_if_token1] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3403),
    [sym_preproc_directive] = ACTIONS(3403),
    [anon_sym_LPAREN2] = ACTIONS(3405),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_STAR] = ACTIONS(3405),
    [anon_sym_AMP_AMP] = ACTIONS(3405),
    [anon_sym_AMP] = ACTIONS(3403),
    [anon_sym___extension__] = ACTIONS(3403),
    [anon_sym_typedef] = ACTIONS(3403),
    [anon_sym_extern] = ACTIONS(3403),
    [anon_sym___attribute__] = ACTIONS(3403),
    [anon_sym_COLON_COLON] = ACTIONS(3405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3405),
    [anon_sym___declspec] = ACTIONS(3403),
    [anon_sym___based] = ACTIONS(3403),
    [anon_sym_RBRACE] = ACTIONS(3405),
    [anon_sym_signed] = ACTIONS(3403),
    [anon_sym_unsigned] = ACTIONS(3403),
    [anon_sym_long] = ACTIONS(3403),
    [anon_sym_short] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3403),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_register] = ACTIONS(3403),
    [anon_sym_inline] = ACTIONS(3403),
    [anon_sym___inline] = ACTIONS(3403),
    [anon_sym___inline__] = ACTIONS(3403),
    [anon_sym___forceinline] = ACTIONS(3403),
    [anon_sym_thread_local] = ACTIONS(3403),
    [anon_sym___thread] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_constexpr] = ACTIONS(3403),
    [anon_sym_volatile] = ACTIONS(3403),
    [anon_sym_restrict] = ACTIONS(3403),
    [anon_sym___restrict__] = ACTIONS(3403),
    [anon_sym__Atomic] = ACTIONS(3403),
    [anon_sym__Noreturn] = ACTIONS(3403),
    [anon_sym_noreturn] = ACTIONS(3403),
    [anon_sym_mutable] = ACTIONS(3403),
    [anon_sym_constinit] = ACTIONS(3403),
    [anon_sym_consteval] = ACTIONS(3403),
    [anon_sym_PROGMEM] = ACTIONS(3403),
    [aux_sym_primitive_type_token1] = ACTIONS(3403),
    [anon_sym_byte] = ACTIONS(3403),
    [anon_sym_word] = ACTIONS(3403),
    [anon_sym_enum] = ACTIONS(3403),
    [anon_sym_class] = ACTIONS(3403),
    [anon_sym_struct] = ACTIONS(3403),
    [anon_sym_union] = ACTIONS(3403),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3403),
    [anon_sym_decltype] = ACTIONS(3403),
    [anon_sym_virtual] = ACTIONS(3403),
    [anon_sym_alignas] = ACTIONS(3403),
    [anon_sym_explicit] = ACTIONS(3403),
    [anon_sym_typename] = ACTIONS(3403),
    [anon_sym_template] = ACTIONS(3403),
    [anon_sym_operator] = ACTIONS(3403),
    [anon_sym_friend] = ACTIONS(3403),
    [anon_sym_public] = ACTIONS(3403),
    [anon_sym_private] = ACTIONS(3403),
    [anon_sym_protected] = ACTIONS(3403),
    [anon_sym_using] = ACTIONS(3403),
    [anon_sym_static_assert] = ACTIONS(3403),
  },
  [2578] = {
    [sym_identifier] = ACTIONS(5610),
    [aux_sym_preproc_def_token1] = ACTIONS(5610),
    [aux_sym_preproc_if_token1] = ACTIONS(5610),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5610),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5610),
    [sym_preproc_directive] = ACTIONS(5610),
    [anon_sym_LPAREN2] = ACTIONS(5612),
    [anon_sym_TILDE] = ACTIONS(5612),
    [anon_sym_STAR] = ACTIONS(5612),
    [anon_sym_AMP_AMP] = ACTIONS(5612),
    [anon_sym_AMP] = ACTIONS(5610),
    [anon_sym___extension__] = ACTIONS(5610),
    [anon_sym_typedef] = ACTIONS(5610),
    [anon_sym_extern] = ACTIONS(5610),
    [anon_sym___attribute__] = ACTIONS(5610),
    [anon_sym_COLON_COLON] = ACTIONS(5612),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5612),
    [anon_sym___declspec] = ACTIONS(5610),
    [anon_sym___based] = ACTIONS(5610),
    [anon_sym_RBRACE] = ACTIONS(5612),
    [anon_sym_signed] = ACTIONS(5610),
    [anon_sym_unsigned] = ACTIONS(5610),
    [anon_sym_long] = ACTIONS(5610),
    [anon_sym_short] = ACTIONS(5610),
    [anon_sym_LBRACK] = ACTIONS(5610),
    [anon_sym_static] = ACTIONS(5610),
    [anon_sym_register] = ACTIONS(5610),
    [anon_sym_inline] = ACTIONS(5610),
    [anon_sym___inline] = ACTIONS(5610),
    [anon_sym___inline__] = ACTIONS(5610),
    [anon_sym___forceinline] = ACTIONS(5610),
    [anon_sym_thread_local] = ACTIONS(5610),
    [anon_sym___thread] = ACTIONS(5610),
    [anon_sym_const] = ACTIONS(5610),
    [anon_sym_constexpr] = ACTIONS(5610),
    [anon_sym_volatile] = ACTIONS(5610),
    [anon_sym_restrict] = ACTIONS(5610),
    [anon_sym___restrict__] = ACTIONS(5610),
    [anon_sym__Atomic] = ACTIONS(5610),
    [anon_sym__Noreturn] = ACTIONS(5610),
    [anon_sym_noreturn] = ACTIONS(5610),
    [anon_sym_mutable] = ACTIONS(5610),
    [anon_sym_constinit] = ACTIONS(5610),
    [anon_sym_consteval] = ACTIONS(5610),
    [anon_sym_PROGMEM] = ACTIONS(5610),
    [aux_sym_primitive_type_token1] = ACTIONS(5610),
    [anon_sym_byte] = ACTIONS(5610),
    [anon_sym_word] = ACTIONS(5610),
    [anon_sym_enum] = ACTIONS(5610),
    [anon_sym_class] = ACTIONS(5610),
    [anon_sym_struct] = ACTIONS(5610),
    [anon_sym_union] = ACTIONS(5610),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5610),
    [anon_sym_decltype] = ACTIONS(5610),
    [anon_sym_virtual] = ACTIONS(5610),
    [anon_sym_alignas] = ACTIONS(5610),
    [anon_sym_explicit] = ACTIONS(5610),
    [anon_sym_typename] = ACTIONS(5610),
    [anon_sym_template] = ACTIONS(5610),
    [anon_sym_operator] = ACTIONS(5610),
    [anon_sym_friend] = ACTIONS(5610),
    [anon_sym_public] = ACTIONS(5610),
    [anon_sym_private] = ACTIONS(5610),
    [anon_sym_protected] = ACTIONS(5610),
    [anon_sym_using] = ACTIONS(5610),
    [anon_sym_static_assert] = ACTIONS(5610),
  },
  [2579] = {
    [sym_identifier] = ACTIONS(5626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_RPAREN] = ACTIONS(5628),
    [aux_sym_preproc_if_token2] = ACTIONS(5628),
    [aux_sym_preproc_else_token1] = ACTIONS(5628),
    [aux_sym_preproc_elif_token1] = ACTIONS(5626),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5628),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5628),
    [anon_sym_LPAREN2] = ACTIONS(5628),
    [anon_sym_DASH] = ACTIONS(5626),
    [anon_sym_PLUS] = ACTIONS(5626),
    [anon_sym_STAR] = ACTIONS(5626),
    [anon_sym_SLASH] = ACTIONS(5626),
    [anon_sym_PERCENT] = ACTIONS(5626),
    [anon_sym_PIPE_PIPE] = ACTIONS(5628),
    [anon_sym_AMP_AMP] = ACTIONS(5628),
    [anon_sym_PIPE] = ACTIONS(5626),
    [anon_sym_CARET] = ACTIONS(5626),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym_EQ_EQ] = ACTIONS(5628),
    [anon_sym_BANG_EQ] = ACTIONS(5628),
    [anon_sym_GT] = ACTIONS(5626),
    [anon_sym_GT_EQ] = ACTIONS(5628),
    [anon_sym_LT_EQ] = ACTIONS(5626),
    [anon_sym_LT] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5626),
    [anon_sym_GT_GT] = ACTIONS(5626),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym___attribute__] = ACTIONS(5626),
    [anon_sym_LBRACE] = ACTIONS(5628),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_LBRACK] = ACTIONS(5628),
    [anon_sym_RBRACK] = ACTIONS(5628),
    [anon_sym_EQ] = ACTIONS(5626),
    [anon_sym_COLON] = ACTIONS(5628),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_STAR_EQ] = ACTIONS(5628),
    [anon_sym_SLASH_EQ] = ACTIONS(5628),
    [anon_sym_PERCENT_EQ] = ACTIONS(5628),
    [anon_sym_PLUS_EQ] = ACTIONS(5628),
    [anon_sym_DASH_EQ] = ACTIONS(5628),
    [anon_sym_LT_LT_EQ] = ACTIONS(5628),
    [anon_sym_GT_GT_EQ] = ACTIONS(5628),
    [anon_sym_AMP_EQ] = ACTIONS(5628),
    [anon_sym_CARET_EQ] = ACTIONS(5628),
    [anon_sym_PIPE_EQ] = ACTIONS(5628),
    [anon_sym_and_eq] = ACTIONS(5626),
    [anon_sym_or_eq] = ACTIONS(5626),
    [anon_sym_xor_eq] = ACTIONS(5626),
    [anon_sym_LT_EQ_GT] = ACTIONS(5628),
    [anon_sym_or] = ACTIONS(5626),
    [anon_sym_and] = ACTIONS(5626),
    [anon_sym_bitor] = ACTIONS(5626),
    [anon_sym_xor] = ACTIONS(5626),
    [anon_sym_bitand] = ACTIONS(5626),
    [anon_sym_not_eq] = ACTIONS(5626),
    [anon_sym_DASH_DASH] = ACTIONS(5628),
    [anon_sym_PLUS_PLUS] = ACTIONS(5628),
    [anon_sym_DOT] = ACTIONS(5626),
    [anon_sym_DOT_STAR] = ACTIONS(5628),
    [anon_sym_DASH_GT] = ACTIONS(5628),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5626),
    [anon_sym_decltype] = ACTIONS(5626),
    [anon_sym_final] = ACTIONS(5626),
    [anon_sym_override] = ACTIONS(5626),
  },
  [2580] = {
    [sym_primitive_type] = STATE(2848),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2695),
    [sym_identifier] = ACTIONS(5966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5489),
    [anon_sym_COMMA] = ACTIONS(5489),
    [aux_sym_preproc_if_token2] = ACTIONS(5489),
    [aux_sym_preproc_else_token1] = ACTIONS(5489),
    [aux_sym_preproc_elif_token1] = ACTIONS(5489),
    [anon_sym_LPAREN2] = ACTIONS(5489),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_PLUS] = ACTIONS(5491),
    [anon_sym_STAR] = ACTIONS(5491),
    [anon_sym_SLASH] = ACTIONS(5491),
    [anon_sym_PERCENT] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5489),
    [anon_sym_AMP_AMP] = ACTIONS(5489),
    [anon_sym_PIPE] = ACTIONS(5491),
    [anon_sym_CARET] = ACTIONS(5491),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_EQ_EQ] = ACTIONS(5489),
    [anon_sym_BANG_EQ] = ACTIONS(5489),
    [anon_sym_GT] = ACTIONS(5491),
    [anon_sym_GT_EQ] = ACTIONS(5489),
    [anon_sym_LT_EQ] = ACTIONS(5491),
    [anon_sym_LT] = ACTIONS(5491),
    [anon_sym_LT_LT] = ACTIONS(5491),
    [anon_sym_GT_GT] = ACTIONS(5491),
    [anon_sym___attribute__] = ACTIONS(5491),
    [anon_sym_LBRACE] = ACTIONS(5489),
    [anon_sym_signed] = ACTIONS(5969),
    [anon_sym_unsigned] = ACTIONS(5969),
    [anon_sym_long] = ACTIONS(5969),
    [anon_sym_short] = ACTIONS(5969),
    [anon_sym_LBRACK] = ACTIONS(5489),
    [anon_sym_EQ] = ACTIONS(5491),
    [aux_sym_primitive_type_token1] = ACTIONS(5971),
    [anon_sym_byte] = ACTIONS(5971),
    [anon_sym_word] = ACTIONS(5971),
    [anon_sym_QMARK] = ACTIONS(5489),
    [anon_sym_STAR_EQ] = ACTIONS(5489),
    [anon_sym_SLASH_EQ] = ACTIONS(5489),
    [anon_sym_PERCENT_EQ] = ACTIONS(5489),
    [anon_sym_PLUS_EQ] = ACTIONS(5489),
    [anon_sym_DASH_EQ] = ACTIONS(5489),
    [anon_sym_LT_LT_EQ] = ACTIONS(5489),
    [anon_sym_GT_GT_EQ] = ACTIONS(5489),
    [anon_sym_AMP_EQ] = ACTIONS(5489),
    [anon_sym_CARET_EQ] = ACTIONS(5489),
    [anon_sym_PIPE_EQ] = ACTIONS(5489),
    [anon_sym_and_eq] = ACTIONS(5491),
    [anon_sym_or_eq] = ACTIONS(5491),
    [anon_sym_xor_eq] = ACTIONS(5491),
    [anon_sym_LT_EQ_GT] = ACTIONS(5489),
    [anon_sym_or] = ACTIONS(5491),
    [anon_sym_and] = ACTIONS(5491),
    [anon_sym_bitor] = ACTIONS(5491),
    [anon_sym_xor] = ACTIONS(5491),
    [anon_sym_bitand] = ACTIONS(5491),
    [anon_sym_not_eq] = ACTIONS(5491),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_DOT] = ACTIONS(5491),
    [anon_sym_DOT_STAR] = ACTIONS(5489),
    [anon_sym_DASH_GT] = ACTIONS(5489),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5491),
    [anon_sym_decltype] = ACTIONS(5491),
  },
  [2581] = {
    [sym_identifier] = ACTIONS(3297),
    [aux_sym_preproc_def_token1] = ACTIONS(3297),
    [aux_sym_preproc_if_token1] = ACTIONS(3297),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3297),
    [sym_preproc_directive] = ACTIONS(3297),
    [anon_sym_LPAREN2] = ACTIONS(3299),
    [anon_sym_TILDE] = ACTIONS(3299),
    [anon_sym_STAR] = ACTIONS(3299),
    [anon_sym_AMP_AMP] = ACTIONS(3299),
    [anon_sym_AMP] = ACTIONS(3297),
    [anon_sym___extension__] = ACTIONS(3297),
    [anon_sym_typedef] = ACTIONS(3297),
    [anon_sym_extern] = ACTIONS(3297),
    [anon_sym___attribute__] = ACTIONS(3297),
    [anon_sym_COLON_COLON] = ACTIONS(3299),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3299),
    [anon_sym___declspec] = ACTIONS(3297),
    [anon_sym___based] = ACTIONS(3297),
    [anon_sym_RBRACE] = ACTIONS(3299),
    [anon_sym_signed] = ACTIONS(3297),
    [anon_sym_unsigned] = ACTIONS(3297),
    [anon_sym_long] = ACTIONS(3297),
    [anon_sym_short] = ACTIONS(3297),
    [anon_sym_LBRACK] = ACTIONS(3297),
    [anon_sym_static] = ACTIONS(3297),
    [anon_sym_register] = ACTIONS(3297),
    [anon_sym_inline] = ACTIONS(3297),
    [anon_sym___inline] = ACTIONS(3297),
    [anon_sym___inline__] = ACTIONS(3297),
    [anon_sym___forceinline] = ACTIONS(3297),
    [anon_sym_thread_local] = ACTIONS(3297),
    [anon_sym___thread] = ACTIONS(3297),
    [anon_sym_const] = ACTIONS(3297),
    [anon_sym_constexpr] = ACTIONS(3297),
    [anon_sym_volatile] = ACTIONS(3297),
    [anon_sym_restrict] = ACTIONS(3297),
    [anon_sym___restrict__] = ACTIONS(3297),
    [anon_sym__Atomic] = ACTIONS(3297),
    [anon_sym__Noreturn] = ACTIONS(3297),
    [anon_sym_noreturn] = ACTIONS(3297),
    [anon_sym_mutable] = ACTIONS(3297),
    [anon_sym_constinit] = ACTIONS(3297),
    [anon_sym_consteval] = ACTIONS(3297),
    [anon_sym_PROGMEM] = ACTIONS(3297),
    [aux_sym_primitive_type_token1] = ACTIONS(3297),
    [anon_sym_byte] = ACTIONS(3297),
    [anon_sym_word] = ACTIONS(3297),
    [anon_sym_enum] = ACTIONS(3297),
    [anon_sym_class] = ACTIONS(3297),
    [anon_sym_struct] = ACTIONS(3297),
    [anon_sym_union] = ACTIONS(3297),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3297),
    [anon_sym_decltype] = ACTIONS(3297),
    [anon_sym_virtual] = ACTIONS(3297),
    [anon_sym_alignas] = ACTIONS(3297),
    [anon_sym_explicit] = ACTIONS(3297),
    [anon_sym_typename] = ACTIONS(3297),
    [anon_sym_template] = ACTIONS(3297),
    [anon_sym_operator] = ACTIONS(3297),
    [anon_sym_friend] = ACTIONS(3297),
    [anon_sym_public] = ACTIONS(3297),
    [anon_sym_private] = ACTIONS(3297),
    [anon_sym_protected] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3297),
    [anon_sym_static_assert] = ACTIONS(3297),
  },
  [2582] = {
    [sym_identifier] = ACTIONS(3293),
    [aux_sym_preproc_def_token1] = ACTIONS(3293),
    [aux_sym_preproc_if_token1] = ACTIONS(3293),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3293),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3293),
    [sym_preproc_directive] = ACTIONS(3293),
    [anon_sym_LPAREN2] = ACTIONS(3295),
    [anon_sym_TILDE] = ACTIONS(3295),
    [anon_sym_STAR] = ACTIONS(3295),
    [anon_sym_AMP_AMP] = ACTIONS(3295),
    [anon_sym_AMP] = ACTIONS(3293),
    [anon_sym___extension__] = ACTIONS(3293),
    [anon_sym_typedef] = ACTIONS(3293),
    [anon_sym_extern] = ACTIONS(3293),
    [anon_sym___attribute__] = ACTIONS(3293),
    [anon_sym_COLON_COLON] = ACTIONS(3295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3295),
    [anon_sym___declspec] = ACTIONS(3293),
    [anon_sym___based] = ACTIONS(3293),
    [anon_sym_RBRACE] = ACTIONS(3295),
    [anon_sym_signed] = ACTIONS(3293),
    [anon_sym_unsigned] = ACTIONS(3293),
    [anon_sym_long] = ACTIONS(3293),
    [anon_sym_short] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_static] = ACTIONS(3293),
    [anon_sym_register] = ACTIONS(3293),
    [anon_sym_inline] = ACTIONS(3293),
    [anon_sym___inline] = ACTIONS(3293),
    [anon_sym___inline__] = ACTIONS(3293),
    [anon_sym___forceinline] = ACTIONS(3293),
    [anon_sym_thread_local] = ACTIONS(3293),
    [anon_sym___thread] = ACTIONS(3293),
    [anon_sym_const] = ACTIONS(3293),
    [anon_sym_constexpr] = ACTIONS(3293),
    [anon_sym_volatile] = ACTIONS(3293),
    [anon_sym_restrict] = ACTIONS(3293),
    [anon_sym___restrict__] = ACTIONS(3293),
    [anon_sym__Atomic] = ACTIONS(3293),
    [anon_sym__Noreturn] = ACTIONS(3293),
    [anon_sym_noreturn] = ACTIONS(3293),
    [anon_sym_mutable] = ACTIONS(3293),
    [anon_sym_constinit] = ACTIONS(3293),
    [anon_sym_consteval] = ACTIONS(3293),
    [anon_sym_PROGMEM] = ACTIONS(3293),
    [aux_sym_primitive_type_token1] = ACTIONS(3293),
    [anon_sym_byte] = ACTIONS(3293),
    [anon_sym_word] = ACTIONS(3293),
    [anon_sym_enum] = ACTIONS(3293),
    [anon_sym_class] = ACTIONS(3293),
    [anon_sym_struct] = ACTIONS(3293),
    [anon_sym_union] = ACTIONS(3293),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3293),
    [anon_sym_decltype] = ACTIONS(3293),
    [anon_sym_virtual] = ACTIONS(3293),
    [anon_sym_alignas] = ACTIONS(3293),
    [anon_sym_explicit] = ACTIONS(3293),
    [anon_sym_typename] = ACTIONS(3293),
    [anon_sym_template] = ACTIONS(3293),
    [anon_sym_operator] = ACTIONS(3293),
    [anon_sym_friend] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3293),
    [anon_sym_private] = ACTIONS(3293),
    [anon_sym_protected] = ACTIONS(3293),
    [anon_sym_using] = ACTIONS(3293),
    [anon_sym_static_assert] = ACTIONS(3293),
  },
  [2583] = {
    [sym_identifier] = ACTIONS(3280),
    [aux_sym_preproc_def_token1] = ACTIONS(3280),
    [aux_sym_preproc_if_token1] = ACTIONS(3280),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3280),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3280),
    [sym_preproc_directive] = ACTIONS(3280),
    [anon_sym_LPAREN2] = ACTIONS(3282),
    [anon_sym_TILDE] = ACTIONS(3282),
    [anon_sym_STAR] = ACTIONS(3282),
    [anon_sym_AMP_AMP] = ACTIONS(3282),
    [anon_sym_AMP] = ACTIONS(3280),
    [anon_sym___extension__] = ACTIONS(3280),
    [anon_sym_typedef] = ACTIONS(3280),
    [anon_sym_extern] = ACTIONS(3280),
    [anon_sym___attribute__] = ACTIONS(3280),
    [anon_sym_COLON_COLON] = ACTIONS(3282),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3282),
    [anon_sym___declspec] = ACTIONS(3280),
    [anon_sym___based] = ACTIONS(3280),
    [anon_sym_RBRACE] = ACTIONS(3282),
    [anon_sym_signed] = ACTIONS(3280),
    [anon_sym_unsigned] = ACTIONS(3280),
    [anon_sym_long] = ACTIONS(3280),
    [anon_sym_short] = ACTIONS(3280),
    [anon_sym_LBRACK] = ACTIONS(3280),
    [anon_sym_static] = ACTIONS(3280),
    [anon_sym_register] = ACTIONS(3280),
    [anon_sym_inline] = ACTIONS(3280),
    [anon_sym___inline] = ACTIONS(3280),
    [anon_sym___inline__] = ACTIONS(3280),
    [anon_sym___forceinline] = ACTIONS(3280),
    [anon_sym_thread_local] = ACTIONS(3280),
    [anon_sym___thread] = ACTIONS(3280),
    [anon_sym_const] = ACTIONS(3280),
    [anon_sym_constexpr] = ACTIONS(3280),
    [anon_sym_volatile] = ACTIONS(3280),
    [anon_sym_restrict] = ACTIONS(3280),
    [anon_sym___restrict__] = ACTIONS(3280),
    [anon_sym__Atomic] = ACTIONS(3280),
    [anon_sym__Noreturn] = ACTIONS(3280),
    [anon_sym_noreturn] = ACTIONS(3280),
    [anon_sym_mutable] = ACTIONS(3280),
    [anon_sym_constinit] = ACTIONS(3280),
    [anon_sym_consteval] = ACTIONS(3280),
    [anon_sym_PROGMEM] = ACTIONS(3280),
    [aux_sym_primitive_type_token1] = ACTIONS(3280),
    [anon_sym_byte] = ACTIONS(3280),
    [anon_sym_word] = ACTIONS(3280),
    [anon_sym_enum] = ACTIONS(3280),
    [anon_sym_class] = ACTIONS(3280),
    [anon_sym_struct] = ACTIONS(3280),
    [anon_sym_union] = ACTIONS(3280),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3280),
    [anon_sym_decltype] = ACTIONS(3280),
    [anon_sym_virtual] = ACTIONS(3280),
    [anon_sym_alignas] = ACTIONS(3280),
    [anon_sym_explicit] = ACTIONS(3280),
    [anon_sym_typename] = ACTIONS(3280),
    [anon_sym_template] = ACTIONS(3280),
    [anon_sym_operator] = ACTIONS(3280),
    [anon_sym_friend] = ACTIONS(3280),
    [anon_sym_public] = ACTIONS(3280),
    [anon_sym_private] = ACTIONS(3280),
    [anon_sym_protected] = ACTIONS(3280),
    [anon_sym_using] = ACTIONS(3280),
    [anon_sym_static_assert] = ACTIONS(3280),
  },
  [2584] = {
    [sym_identifier] = ACTIONS(3411),
    [aux_sym_preproc_def_token1] = ACTIONS(3411),
    [aux_sym_preproc_if_token1] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3411),
    [sym_preproc_directive] = ACTIONS(3411),
    [anon_sym_LPAREN2] = ACTIONS(3413),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_STAR] = ACTIONS(3413),
    [anon_sym_AMP_AMP] = ACTIONS(3413),
    [anon_sym_AMP] = ACTIONS(3411),
    [anon_sym___extension__] = ACTIONS(3411),
    [anon_sym_typedef] = ACTIONS(3411),
    [anon_sym_extern] = ACTIONS(3411),
    [anon_sym___attribute__] = ACTIONS(3411),
    [anon_sym_COLON_COLON] = ACTIONS(3413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3413),
    [anon_sym___declspec] = ACTIONS(3411),
    [anon_sym___based] = ACTIONS(3411),
    [anon_sym_RBRACE] = ACTIONS(3413),
    [anon_sym_signed] = ACTIONS(3411),
    [anon_sym_unsigned] = ACTIONS(3411),
    [anon_sym_long] = ACTIONS(3411),
    [anon_sym_short] = ACTIONS(3411),
    [anon_sym_LBRACK] = ACTIONS(3411),
    [anon_sym_static] = ACTIONS(3411),
    [anon_sym_register] = ACTIONS(3411),
    [anon_sym_inline] = ACTIONS(3411),
    [anon_sym___inline] = ACTIONS(3411),
    [anon_sym___inline__] = ACTIONS(3411),
    [anon_sym___forceinline] = ACTIONS(3411),
    [anon_sym_thread_local] = ACTIONS(3411),
    [anon_sym___thread] = ACTIONS(3411),
    [anon_sym_const] = ACTIONS(3411),
    [anon_sym_constexpr] = ACTIONS(3411),
    [anon_sym_volatile] = ACTIONS(3411),
    [anon_sym_restrict] = ACTIONS(3411),
    [anon_sym___restrict__] = ACTIONS(3411),
    [anon_sym__Atomic] = ACTIONS(3411),
    [anon_sym__Noreturn] = ACTIONS(3411),
    [anon_sym_noreturn] = ACTIONS(3411),
    [anon_sym_mutable] = ACTIONS(3411),
    [anon_sym_constinit] = ACTIONS(3411),
    [anon_sym_consteval] = ACTIONS(3411),
    [anon_sym_PROGMEM] = ACTIONS(3411),
    [aux_sym_primitive_type_token1] = ACTIONS(3411),
    [anon_sym_byte] = ACTIONS(3411),
    [anon_sym_word] = ACTIONS(3411),
    [anon_sym_enum] = ACTIONS(3411),
    [anon_sym_class] = ACTIONS(3411),
    [anon_sym_struct] = ACTIONS(3411),
    [anon_sym_union] = ACTIONS(3411),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3411),
    [anon_sym_decltype] = ACTIONS(3411),
    [anon_sym_virtual] = ACTIONS(3411),
    [anon_sym_alignas] = ACTIONS(3411),
    [anon_sym_explicit] = ACTIONS(3411),
    [anon_sym_typename] = ACTIONS(3411),
    [anon_sym_template] = ACTIONS(3411),
    [anon_sym_operator] = ACTIONS(3411),
    [anon_sym_friend] = ACTIONS(3411),
    [anon_sym_public] = ACTIONS(3411),
    [anon_sym_private] = ACTIONS(3411),
    [anon_sym_protected] = ACTIONS(3411),
    [anon_sym_using] = ACTIONS(3411),
    [anon_sym_static_assert] = ACTIONS(3411),
  },
  [2585] = {
    [sym_identifier] = ACTIONS(3415),
    [aux_sym_preproc_def_token1] = ACTIONS(3415),
    [aux_sym_preproc_if_token1] = ACTIONS(3415),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3415),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3415),
    [sym_preproc_directive] = ACTIONS(3415),
    [anon_sym_LPAREN2] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3417),
    [anon_sym_STAR] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3415),
    [anon_sym___extension__] = ACTIONS(3415),
    [anon_sym_typedef] = ACTIONS(3415),
    [anon_sym_extern] = ACTIONS(3415),
    [anon_sym___attribute__] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3417),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3417),
    [anon_sym___declspec] = ACTIONS(3415),
    [anon_sym___based] = ACTIONS(3415),
    [anon_sym_RBRACE] = ACTIONS(3417),
    [anon_sym_signed] = ACTIONS(3415),
    [anon_sym_unsigned] = ACTIONS(3415),
    [anon_sym_long] = ACTIONS(3415),
    [anon_sym_short] = ACTIONS(3415),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_static] = ACTIONS(3415),
    [anon_sym_register] = ACTIONS(3415),
    [anon_sym_inline] = ACTIONS(3415),
    [anon_sym___inline] = ACTIONS(3415),
    [anon_sym___inline__] = ACTIONS(3415),
    [anon_sym___forceinline] = ACTIONS(3415),
    [anon_sym_thread_local] = ACTIONS(3415),
    [anon_sym___thread] = ACTIONS(3415),
    [anon_sym_const] = ACTIONS(3415),
    [anon_sym_constexpr] = ACTIONS(3415),
    [anon_sym_volatile] = ACTIONS(3415),
    [anon_sym_restrict] = ACTIONS(3415),
    [anon_sym___restrict__] = ACTIONS(3415),
    [anon_sym__Atomic] = ACTIONS(3415),
    [anon_sym__Noreturn] = ACTIONS(3415),
    [anon_sym_noreturn] = ACTIONS(3415),
    [anon_sym_mutable] = ACTIONS(3415),
    [anon_sym_constinit] = ACTIONS(3415),
    [anon_sym_consteval] = ACTIONS(3415),
    [anon_sym_PROGMEM] = ACTIONS(3415),
    [aux_sym_primitive_type_token1] = ACTIONS(3415),
    [anon_sym_byte] = ACTIONS(3415),
    [anon_sym_word] = ACTIONS(3415),
    [anon_sym_enum] = ACTIONS(3415),
    [anon_sym_class] = ACTIONS(3415),
    [anon_sym_struct] = ACTIONS(3415),
    [anon_sym_union] = ACTIONS(3415),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3415),
    [anon_sym_decltype] = ACTIONS(3415),
    [anon_sym_virtual] = ACTIONS(3415),
    [anon_sym_alignas] = ACTIONS(3415),
    [anon_sym_explicit] = ACTIONS(3415),
    [anon_sym_typename] = ACTIONS(3415),
    [anon_sym_template] = ACTIONS(3415),
    [anon_sym_operator] = ACTIONS(3415),
    [anon_sym_friend] = ACTIONS(3415),
    [anon_sym_public] = ACTIONS(3415),
    [anon_sym_private] = ACTIONS(3415),
    [anon_sym_protected] = ACTIONS(3415),
    [anon_sym_using] = ACTIONS(3415),
    [anon_sym_static_assert] = ACTIONS(3415),
  },
  [2586] = {
    [sym_identifier] = ACTIONS(5443),
    [aux_sym_preproc_def_token1] = ACTIONS(5443),
    [aux_sym_preproc_if_token1] = ACTIONS(5443),
    [aux_sym_preproc_if_token2] = ACTIONS(5443),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5443),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5443),
    [sym_preproc_directive] = ACTIONS(5443),
    [anon_sym_LPAREN2] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_STAR] = ACTIONS(5445),
    [anon_sym_AMP_AMP] = ACTIONS(5445),
    [anon_sym_AMP] = ACTIONS(5443),
    [anon_sym___extension__] = ACTIONS(5443),
    [anon_sym_typedef] = ACTIONS(5443),
    [anon_sym_extern] = ACTIONS(5443),
    [anon_sym___attribute__] = ACTIONS(5443),
    [anon_sym_COLON_COLON] = ACTIONS(5445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5445),
    [anon_sym___declspec] = ACTIONS(5443),
    [anon_sym___based] = ACTIONS(5443),
    [anon_sym_signed] = ACTIONS(5443),
    [anon_sym_unsigned] = ACTIONS(5443),
    [anon_sym_long] = ACTIONS(5443),
    [anon_sym_short] = ACTIONS(5443),
    [anon_sym_LBRACK] = ACTIONS(5443),
    [anon_sym_static] = ACTIONS(5443),
    [anon_sym_register] = ACTIONS(5443),
    [anon_sym_inline] = ACTIONS(5443),
    [anon_sym___inline] = ACTIONS(5443),
    [anon_sym___inline__] = ACTIONS(5443),
    [anon_sym___forceinline] = ACTIONS(5443),
    [anon_sym_thread_local] = ACTIONS(5443),
    [anon_sym___thread] = ACTIONS(5443),
    [anon_sym_const] = ACTIONS(5443),
    [anon_sym_constexpr] = ACTIONS(5443),
    [anon_sym_volatile] = ACTIONS(5443),
    [anon_sym_restrict] = ACTIONS(5443),
    [anon_sym___restrict__] = ACTIONS(5443),
    [anon_sym__Atomic] = ACTIONS(5443),
    [anon_sym__Noreturn] = ACTIONS(5443),
    [anon_sym_noreturn] = ACTIONS(5443),
    [anon_sym_mutable] = ACTIONS(5443),
    [anon_sym_constinit] = ACTIONS(5443),
    [anon_sym_consteval] = ACTIONS(5443),
    [anon_sym_PROGMEM] = ACTIONS(5443),
    [aux_sym_primitive_type_token1] = ACTIONS(5443),
    [anon_sym_byte] = ACTIONS(5443),
    [anon_sym_word] = ACTIONS(5443),
    [anon_sym_enum] = ACTIONS(5443),
    [anon_sym_class] = ACTIONS(5443),
    [anon_sym_struct] = ACTIONS(5443),
    [anon_sym_union] = ACTIONS(5443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5443),
    [anon_sym_decltype] = ACTIONS(5443),
    [anon_sym_virtual] = ACTIONS(5443),
    [anon_sym_alignas] = ACTIONS(5443),
    [anon_sym_explicit] = ACTIONS(5443),
    [anon_sym_typename] = ACTIONS(5443),
    [anon_sym_template] = ACTIONS(5443),
    [anon_sym_operator] = ACTIONS(5443),
    [anon_sym_friend] = ACTIONS(5443),
    [anon_sym_public] = ACTIONS(5443),
    [anon_sym_private] = ACTIONS(5443),
    [anon_sym_protected] = ACTIONS(5443),
    [anon_sym_using] = ACTIONS(5443),
    [anon_sym_static_assert] = ACTIONS(5443),
  },
  [2587] = {
    [sym_identifier] = ACTIONS(5602),
    [aux_sym_preproc_def_token1] = ACTIONS(5602),
    [aux_sym_preproc_if_token1] = ACTIONS(5602),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5602),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5602),
    [sym_preproc_directive] = ACTIONS(5602),
    [anon_sym_LPAREN2] = ACTIONS(5604),
    [anon_sym_TILDE] = ACTIONS(5604),
    [anon_sym_STAR] = ACTIONS(5604),
    [anon_sym_AMP_AMP] = ACTIONS(5604),
    [anon_sym_AMP] = ACTIONS(5602),
    [anon_sym___extension__] = ACTIONS(5602),
    [anon_sym_typedef] = ACTIONS(5602),
    [anon_sym_extern] = ACTIONS(5602),
    [anon_sym___attribute__] = ACTIONS(5602),
    [anon_sym_COLON_COLON] = ACTIONS(5604),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5604),
    [anon_sym___declspec] = ACTIONS(5602),
    [anon_sym___based] = ACTIONS(5602),
    [anon_sym_RBRACE] = ACTIONS(5604),
    [anon_sym_signed] = ACTIONS(5602),
    [anon_sym_unsigned] = ACTIONS(5602),
    [anon_sym_long] = ACTIONS(5602),
    [anon_sym_short] = ACTIONS(5602),
    [anon_sym_LBRACK] = ACTIONS(5602),
    [anon_sym_static] = ACTIONS(5602),
    [anon_sym_register] = ACTIONS(5602),
    [anon_sym_inline] = ACTIONS(5602),
    [anon_sym___inline] = ACTIONS(5602),
    [anon_sym___inline__] = ACTIONS(5602),
    [anon_sym___forceinline] = ACTIONS(5602),
    [anon_sym_thread_local] = ACTIONS(5602),
    [anon_sym___thread] = ACTIONS(5602),
    [anon_sym_const] = ACTIONS(5602),
    [anon_sym_constexpr] = ACTIONS(5602),
    [anon_sym_volatile] = ACTIONS(5602),
    [anon_sym_restrict] = ACTIONS(5602),
    [anon_sym___restrict__] = ACTIONS(5602),
    [anon_sym__Atomic] = ACTIONS(5602),
    [anon_sym__Noreturn] = ACTIONS(5602),
    [anon_sym_noreturn] = ACTIONS(5602),
    [anon_sym_mutable] = ACTIONS(5602),
    [anon_sym_constinit] = ACTIONS(5602),
    [anon_sym_consteval] = ACTIONS(5602),
    [anon_sym_PROGMEM] = ACTIONS(5602),
    [aux_sym_primitive_type_token1] = ACTIONS(5602),
    [anon_sym_byte] = ACTIONS(5602),
    [anon_sym_word] = ACTIONS(5602),
    [anon_sym_enum] = ACTIONS(5602),
    [anon_sym_class] = ACTIONS(5602),
    [anon_sym_struct] = ACTIONS(5602),
    [anon_sym_union] = ACTIONS(5602),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5602),
    [anon_sym_decltype] = ACTIONS(5602),
    [anon_sym_virtual] = ACTIONS(5602),
    [anon_sym_alignas] = ACTIONS(5602),
    [anon_sym_explicit] = ACTIONS(5602),
    [anon_sym_typename] = ACTIONS(5602),
    [anon_sym_template] = ACTIONS(5602),
    [anon_sym_operator] = ACTIONS(5602),
    [anon_sym_friend] = ACTIONS(5602),
    [anon_sym_public] = ACTIONS(5602),
    [anon_sym_private] = ACTIONS(5602),
    [anon_sym_protected] = ACTIONS(5602),
    [anon_sym_using] = ACTIONS(5602),
    [anon_sym_static_assert] = ACTIONS(5602),
  },
  [2588] = {
    [sym_string_literal] = STATE(2575),
    [sym_template_argument_list] = STATE(2840),
    [sym_raw_string_literal] = STATE(2575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5348),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym___attribute__] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4256),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4248),
    [anon_sym_SLASH_EQ] = ACTIONS(4248),
    [anon_sym_PERCENT_EQ] = ACTIONS(4248),
    [anon_sym_PLUS_EQ] = ACTIONS(4248),
    [anon_sym_DASH_EQ] = ACTIONS(4248),
    [anon_sym_LT_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT_GT_EQ] = ACTIONS(4248),
    [anon_sym_AMP_EQ] = ACTIONS(4248),
    [anon_sym_CARET_EQ] = ACTIONS(4248),
    [anon_sym_PIPE_EQ] = ACTIONS(4248),
    [anon_sym_and_eq] = ACTIONS(4248),
    [anon_sym_or_eq] = ACTIONS(4248),
    [anon_sym_xor_eq] = ACTIONS(4248),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(5912),
    [anon_sym_u_DQUOTE] = ACTIONS(5912),
    [anon_sym_U_DQUOTE] = ACTIONS(5912),
    [anon_sym_u8_DQUOTE] = ACTIONS(5912),
    [anon_sym_DQUOTE] = ACTIONS(5912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5914),
    [anon_sym_LR_DQUOTE] = ACTIONS(5914),
    [anon_sym_uR_DQUOTE] = ACTIONS(5914),
    [anon_sym_UR_DQUOTE] = ACTIONS(5914),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5914),
  },
  [2589] = {
    [sym_identifier] = ACTIONS(3499),
    [aux_sym_preproc_def_token1] = ACTIONS(3499),
    [aux_sym_preproc_if_token1] = ACTIONS(3499),
    [aux_sym_preproc_if_token2] = ACTIONS(3499),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3499),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3499),
    [sym_preproc_directive] = ACTIONS(3499),
    [anon_sym_LPAREN2] = ACTIONS(3501),
    [anon_sym_TILDE] = ACTIONS(3501),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_AMP_AMP] = ACTIONS(3501),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym___extension__] = ACTIONS(3499),
    [anon_sym_typedef] = ACTIONS(3499),
    [anon_sym_extern] = ACTIONS(3499),
    [anon_sym___attribute__] = ACTIONS(3499),
    [anon_sym_COLON_COLON] = ACTIONS(3501),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3501),
    [anon_sym___declspec] = ACTIONS(3499),
    [anon_sym___based] = ACTIONS(3499),
    [anon_sym_signed] = ACTIONS(3499),
    [anon_sym_unsigned] = ACTIONS(3499),
    [anon_sym_long] = ACTIONS(3499),
    [anon_sym_short] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(3499),
    [anon_sym_static] = ACTIONS(3499),
    [anon_sym_register] = ACTIONS(3499),
    [anon_sym_inline] = ACTIONS(3499),
    [anon_sym___inline] = ACTIONS(3499),
    [anon_sym___inline__] = ACTIONS(3499),
    [anon_sym___forceinline] = ACTIONS(3499),
    [anon_sym_thread_local] = ACTIONS(3499),
    [anon_sym___thread] = ACTIONS(3499),
    [anon_sym_const] = ACTIONS(3499),
    [anon_sym_constexpr] = ACTIONS(3499),
    [anon_sym_volatile] = ACTIONS(3499),
    [anon_sym_restrict] = ACTIONS(3499),
    [anon_sym___restrict__] = ACTIONS(3499),
    [anon_sym__Atomic] = ACTIONS(3499),
    [anon_sym__Noreturn] = ACTIONS(3499),
    [anon_sym_noreturn] = ACTIONS(3499),
    [anon_sym_mutable] = ACTIONS(3499),
    [anon_sym_constinit] = ACTIONS(3499),
    [anon_sym_consteval] = ACTIONS(3499),
    [anon_sym_PROGMEM] = ACTIONS(3499),
    [aux_sym_primitive_type_token1] = ACTIONS(3499),
    [anon_sym_byte] = ACTIONS(3499),
    [anon_sym_word] = ACTIONS(3499),
    [anon_sym_enum] = ACTIONS(3499),
    [anon_sym_class] = ACTIONS(3499),
    [anon_sym_struct] = ACTIONS(3499),
    [anon_sym_union] = ACTIONS(3499),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3499),
    [anon_sym_decltype] = ACTIONS(3499),
    [anon_sym_virtual] = ACTIONS(3499),
    [anon_sym_alignas] = ACTIONS(3499),
    [anon_sym_explicit] = ACTIONS(3499),
    [anon_sym_typename] = ACTIONS(3499),
    [anon_sym_template] = ACTIONS(3499),
    [anon_sym_operator] = ACTIONS(3499),
    [anon_sym_friend] = ACTIONS(3499),
    [anon_sym_public] = ACTIONS(3499),
    [anon_sym_private] = ACTIONS(3499),
    [anon_sym_protected] = ACTIONS(3499),
    [anon_sym_using] = ACTIONS(3499),
    [anon_sym_static_assert] = ACTIONS(3499),
  },
  [2590] = {
    [sym_identifier] = ACTIONS(3423),
    [aux_sym_preproc_def_token1] = ACTIONS(3423),
    [aux_sym_preproc_if_token1] = ACTIONS(3423),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3423),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3423),
    [sym_preproc_directive] = ACTIONS(3423),
    [anon_sym_LPAREN2] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [anon_sym_STAR] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3423),
    [anon_sym___extension__] = ACTIONS(3423),
    [anon_sym_typedef] = ACTIONS(3423),
    [anon_sym_extern] = ACTIONS(3423),
    [anon_sym___attribute__] = ACTIONS(3423),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3425),
    [anon_sym___declspec] = ACTIONS(3423),
    [anon_sym___based] = ACTIONS(3423),
    [anon_sym_RBRACE] = ACTIONS(3425),
    [anon_sym_signed] = ACTIONS(3423),
    [anon_sym_unsigned] = ACTIONS(3423),
    [anon_sym_long] = ACTIONS(3423),
    [anon_sym_short] = ACTIONS(3423),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_static] = ACTIONS(3423),
    [anon_sym_register] = ACTIONS(3423),
    [anon_sym_inline] = ACTIONS(3423),
    [anon_sym___inline] = ACTIONS(3423),
    [anon_sym___inline__] = ACTIONS(3423),
    [anon_sym___forceinline] = ACTIONS(3423),
    [anon_sym_thread_local] = ACTIONS(3423),
    [anon_sym___thread] = ACTIONS(3423),
    [anon_sym_const] = ACTIONS(3423),
    [anon_sym_constexpr] = ACTIONS(3423),
    [anon_sym_volatile] = ACTIONS(3423),
    [anon_sym_restrict] = ACTIONS(3423),
    [anon_sym___restrict__] = ACTIONS(3423),
    [anon_sym__Atomic] = ACTIONS(3423),
    [anon_sym__Noreturn] = ACTIONS(3423),
    [anon_sym_noreturn] = ACTIONS(3423),
    [anon_sym_mutable] = ACTIONS(3423),
    [anon_sym_constinit] = ACTIONS(3423),
    [anon_sym_consteval] = ACTIONS(3423),
    [anon_sym_PROGMEM] = ACTIONS(3423),
    [aux_sym_primitive_type_token1] = ACTIONS(3423),
    [anon_sym_byte] = ACTIONS(3423),
    [anon_sym_word] = ACTIONS(3423),
    [anon_sym_enum] = ACTIONS(3423),
    [anon_sym_class] = ACTIONS(3423),
    [anon_sym_struct] = ACTIONS(3423),
    [anon_sym_union] = ACTIONS(3423),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3423),
    [anon_sym_decltype] = ACTIONS(3423),
    [anon_sym_virtual] = ACTIONS(3423),
    [anon_sym_alignas] = ACTIONS(3423),
    [anon_sym_explicit] = ACTIONS(3423),
    [anon_sym_typename] = ACTIONS(3423),
    [anon_sym_template] = ACTIONS(3423),
    [anon_sym_operator] = ACTIONS(3423),
    [anon_sym_friend] = ACTIONS(3423),
    [anon_sym_public] = ACTIONS(3423),
    [anon_sym_private] = ACTIONS(3423),
    [anon_sym_protected] = ACTIONS(3423),
    [anon_sym_using] = ACTIONS(3423),
    [anon_sym_static_assert] = ACTIONS(3423),
  },
  [2591] = {
    [sym_identifier] = ACTIONS(3134),
    [aux_sym_preproc_def_token1] = ACTIONS(3134),
    [aux_sym_preproc_if_token1] = ACTIONS(3134),
    [aux_sym_preproc_if_token2] = ACTIONS(3134),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3134),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3134),
    [sym_preproc_directive] = ACTIONS(3134),
    [anon_sym_LPAREN2] = ACTIONS(3136),
    [anon_sym_TILDE] = ACTIONS(3136),
    [anon_sym_STAR] = ACTIONS(3136),
    [anon_sym_AMP_AMP] = ACTIONS(3136),
    [anon_sym_AMP] = ACTIONS(3134),
    [anon_sym___extension__] = ACTIONS(3134),
    [anon_sym_typedef] = ACTIONS(3134),
    [anon_sym_extern] = ACTIONS(3134),
    [anon_sym___attribute__] = ACTIONS(3134),
    [anon_sym_COLON_COLON] = ACTIONS(3136),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3136),
    [anon_sym___declspec] = ACTIONS(3134),
    [anon_sym___based] = ACTIONS(3134),
    [anon_sym_signed] = ACTIONS(3134),
    [anon_sym_unsigned] = ACTIONS(3134),
    [anon_sym_long] = ACTIONS(3134),
    [anon_sym_short] = ACTIONS(3134),
    [anon_sym_LBRACK] = ACTIONS(3134),
    [anon_sym_static] = ACTIONS(3134),
    [anon_sym_register] = ACTIONS(3134),
    [anon_sym_inline] = ACTIONS(3134),
    [anon_sym___inline] = ACTIONS(3134),
    [anon_sym___inline__] = ACTIONS(3134),
    [anon_sym___forceinline] = ACTIONS(3134),
    [anon_sym_thread_local] = ACTIONS(3134),
    [anon_sym___thread] = ACTIONS(3134),
    [anon_sym_const] = ACTIONS(3134),
    [anon_sym_constexpr] = ACTIONS(3134),
    [anon_sym_volatile] = ACTIONS(3134),
    [anon_sym_restrict] = ACTIONS(3134),
    [anon_sym___restrict__] = ACTIONS(3134),
    [anon_sym__Atomic] = ACTIONS(3134),
    [anon_sym__Noreturn] = ACTIONS(3134),
    [anon_sym_noreturn] = ACTIONS(3134),
    [anon_sym_mutable] = ACTIONS(3134),
    [anon_sym_constinit] = ACTIONS(3134),
    [anon_sym_consteval] = ACTIONS(3134),
    [anon_sym_PROGMEM] = ACTIONS(3134),
    [aux_sym_primitive_type_token1] = ACTIONS(3134),
    [anon_sym_byte] = ACTIONS(3134),
    [anon_sym_word] = ACTIONS(3134),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3134),
    [anon_sym_struct] = ACTIONS(3134),
    [anon_sym_union] = ACTIONS(3134),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3134),
    [anon_sym_decltype] = ACTIONS(3134),
    [anon_sym_virtual] = ACTIONS(3134),
    [anon_sym_alignas] = ACTIONS(3134),
    [anon_sym_explicit] = ACTIONS(3134),
    [anon_sym_typename] = ACTIONS(3134),
    [anon_sym_template] = ACTIONS(3134),
    [anon_sym_operator] = ACTIONS(3134),
    [anon_sym_friend] = ACTIONS(3134),
    [anon_sym_public] = ACTIONS(3134),
    [anon_sym_private] = ACTIONS(3134),
    [anon_sym_protected] = ACTIONS(3134),
    [anon_sym_using] = ACTIONS(3134),
    [anon_sym_static_assert] = ACTIONS(3134),
  },
  [2592] = {
    [sym_string_literal] = STATE(2837),
    [sym_template_argument_list] = STATE(4220),
    [sym_raw_string_literal] = STATE(2837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_RPAREN] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5973),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4256),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4248),
    [anon_sym_SLASH_EQ] = ACTIONS(4248),
    [anon_sym_PERCENT_EQ] = ACTIONS(4248),
    [anon_sym_PLUS_EQ] = ACTIONS(4248),
    [anon_sym_DASH_EQ] = ACTIONS(4248),
    [anon_sym_LT_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT_GT_EQ] = ACTIONS(4248),
    [anon_sym_AMP_EQ] = ACTIONS(4248),
    [anon_sym_CARET_EQ] = ACTIONS(4248),
    [anon_sym_PIPE_EQ] = ACTIONS(4248),
    [anon_sym_and_eq] = ACTIONS(5976),
    [anon_sym_or_eq] = ACTIONS(5976),
    [anon_sym_xor_eq] = ACTIONS(5976),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4256),
    [anon_sym_L_DQUOTE] = ACTIONS(4525),
    [anon_sym_u_DQUOTE] = ACTIONS(4525),
    [anon_sym_U_DQUOTE] = ACTIONS(4525),
    [anon_sym_u8_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4527),
    [anon_sym_LR_DQUOTE] = ACTIONS(4527),
    [anon_sym_uR_DQUOTE] = ACTIONS(4527),
    [anon_sym_UR_DQUOTE] = ACTIONS(4527),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4527),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4248),
  },
  [2593] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(4471),
    [sym_raw_string_literal] = STATE(3057),
    [aux_sym_structured_binding_declarator_repeat1] = STATE(8134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(5978),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5870),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_RBRACK] = ACTIONS(5936),
    [anon_sym_EQ] = ACTIONS(5939),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(5941),
    [anon_sym_SLASH_EQ] = ACTIONS(5941),
    [anon_sym_PERCENT_EQ] = ACTIONS(5941),
    [anon_sym_PLUS_EQ] = ACTIONS(5941),
    [anon_sym_DASH_EQ] = ACTIONS(5941),
    [anon_sym_LT_LT_EQ] = ACTIONS(5941),
    [anon_sym_GT_GT_EQ] = ACTIONS(5941),
    [anon_sym_AMP_EQ] = ACTIONS(5941),
    [anon_sym_CARET_EQ] = ACTIONS(5941),
    [anon_sym_PIPE_EQ] = ACTIONS(5941),
    [anon_sym_and_eq] = ACTIONS(5941),
    [anon_sym_or_eq] = ACTIONS(5941),
    [anon_sym_xor_eq] = ACTIONS(5941),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [2594] = {
    [sym_identifier] = ACTIONS(3144),
    [aux_sym_preproc_def_token1] = ACTIONS(3144),
    [aux_sym_preproc_if_token1] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3144),
    [sym_preproc_directive] = ACTIONS(3144),
    [anon_sym_LPAREN2] = ACTIONS(3146),
    [anon_sym_TILDE] = ACTIONS(3146),
    [anon_sym_STAR] = ACTIONS(3146),
    [anon_sym_AMP_AMP] = ACTIONS(3146),
    [anon_sym_AMP] = ACTIONS(3144),
    [anon_sym___extension__] = ACTIONS(3144),
    [anon_sym_typedef] = ACTIONS(3144),
    [anon_sym_extern] = ACTIONS(3144),
    [anon_sym___attribute__] = ACTIONS(3144),
    [anon_sym_COLON_COLON] = ACTIONS(3146),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3146),
    [anon_sym___declspec] = ACTIONS(3144),
    [anon_sym___based] = ACTIONS(3144),
    [anon_sym_RBRACE] = ACTIONS(3146),
    [anon_sym_signed] = ACTIONS(3144),
    [anon_sym_unsigned] = ACTIONS(3144),
    [anon_sym_long] = ACTIONS(3144),
    [anon_sym_short] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3144),
    [anon_sym_static] = ACTIONS(3144),
    [anon_sym_register] = ACTIONS(3144),
    [anon_sym_inline] = ACTIONS(3144),
    [anon_sym___inline] = ACTIONS(3144),
    [anon_sym___inline__] = ACTIONS(3144),
    [anon_sym___forceinline] = ACTIONS(3144),
    [anon_sym_thread_local] = ACTIONS(3144),
    [anon_sym___thread] = ACTIONS(3144),
    [anon_sym_const] = ACTIONS(3144),
    [anon_sym_constexpr] = ACTIONS(3144),
    [anon_sym_volatile] = ACTIONS(3144),
    [anon_sym_restrict] = ACTIONS(3144),
    [anon_sym___restrict__] = ACTIONS(3144),
    [anon_sym__Atomic] = ACTIONS(3144),
    [anon_sym__Noreturn] = ACTIONS(3144),
    [anon_sym_noreturn] = ACTIONS(3144),
    [anon_sym_mutable] = ACTIONS(3144),
    [anon_sym_constinit] = ACTIONS(3144),
    [anon_sym_consteval] = ACTIONS(3144),
    [anon_sym_PROGMEM] = ACTIONS(3144),
    [aux_sym_primitive_type_token1] = ACTIONS(3144),
    [anon_sym_byte] = ACTIONS(3144),
    [anon_sym_word] = ACTIONS(3144),
    [anon_sym_enum] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_struct] = ACTIONS(3144),
    [anon_sym_union] = ACTIONS(3144),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3144),
    [anon_sym_decltype] = ACTIONS(3144),
    [anon_sym_virtual] = ACTIONS(3144),
    [anon_sym_alignas] = ACTIONS(3144),
    [anon_sym_explicit] = ACTIONS(3144),
    [anon_sym_typename] = ACTIONS(3144),
    [anon_sym_template] = ACTIONS(3144),
    [anon_sym_operator] = ACTIONS(3144),
    [anon_sym_friend] = ACTIONS(3144),
    [anon_sym_public] = ACTIONS(3144),
    [anon_sym_private] = ACTIONS(3144),
    [anon_sym_protected] = ACTIONS(3144),
    [anon_sym_using] = ACTIONS(3144),
    [anon_sym_static_assert] = ACTIONS(3144),
  },
  [2595] = {
    [sym_identifier] = ACTIONS(5759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5761),
    [anon_sym_COMMA] = ACTIONS(5761),
    [anon_sym_RPAREN] = ACTIONS(5761),
    [aux_sym_preproc_if_token2] = ACTIONS(5761),
    [aux_sym_preproc_else_token1] = ACTIONS(5761),
    [aux_sym_preproc_elif_token1] = ACTIONS(5759),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5761),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5761),
    [anon_sym_LPAREN2] = ACTIONS(5761),
    [anon_sym_DASH] = ACTIONS(5759),
    [anon_sym_PLUS] = ACTIONS(5759),
    [anon_sym_STAR] = ACTIONS(5761),
    [anon_sym_SLASH] = ACTIONS(5759),
    [anon_sym_PERCENT] = ACTIONS(5761),
    [anon_sym_PIPE_PIPE] = ACTIONS(5761),
    [anon_sym_AMP_AMP] = ACTIONS(5761),
    [anon_sym_PIPE] = ACTIONS(5759),
    [anon_sym_CARET] = ACTIONS(5761),
    [anon_sym_AMP] = ACTIONS(5759),
    [anon_sym_EQ_EQ] = ACTIONS(5761),
    [anon_sym_BANG_EQ] = ACTIONS(5761),
    [anon_sym_GT] = ACTIONS(5759),
    [anon_sym_GT_EQ] = ACTIONS(5761),
    [anon_sym_LT_EQ] = ACTIONS(5759),
    [anon_sym_LT] = ACTIONS(5759),
    [anon_sym_LT_LT] = ACTIONS(5761),
    [anon_sym_GT_GT] = ACTIONS(5761),
    [anon_sym_SEMI] = ACTIONS(5761),
    [anon_sym___extension__] = ACTIONS(5759),
    [anon_sym___attribute__] = ACTIONS(5759),
    [anon_sym_LBRACE] = ACTIONS(5761),
    [anon_sym_RBRACE] = ACTIONS(5761),
    [anon_sym_LBRACK] = ACTIONS(5761),
    [anon_sym_RBRACK] = ACTIONS(5761),
    [anon_sym_const] = ACTIONS(5759),
    [anon_sym_constexpr] = ACTIONS(5759),
    [anon_sym_volatile] = ACTIONS(5759),
    [anon_sym_restrict] = ACTIONS(5759),
    [anon_sym___restrict__] = ACTIONS(5759),
    [anon_sym__Atomic] = ACTIONS(5759),
    [anon_sym__Noreturn] = ACTIONS(5759),
    [anon_sym_noreturn] = ACTIONS(5759),
    [anon_sym_mutable] = ACTIONS(5759),
    [anon_sym_constinit] = ACTIONS(5759),
    [anon_sym_consteval] = ACTIONS(5759),
    [anon_sym_PROGMEM] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_QMARK] = ACTIONS(5761),
    [anon_sym_LT_EQ_GT] = ACTIONS(5761),
    [anon_sym_or] = ACTIONS(5759),
    [anon_sym_and] = ACTIONS(5759),
    [anon_sym_bitor] = ACTIONS(5759),
    [anon_sym_xor] = ACTIONS(5759),
    [anon_sym_bitand] = ACTIONS(5759),
    [anon_sym_not_eq] = ACTIONS(5759),
    [anon_sym_DASH_DASH] = ACTIONS(5761),
    [anon_sym_PLUS_PLUS] = ACTIONS(5761),
    [anon_sym_DOT] = ACTIONS(5759),
    [anon_sym_DOT_STAR] = ACTIONS(5761),
    [anon_sym_DASH_GT] = ACTIONS(5761),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5759),
    [anon_sym_decltype] = ACTIONS(5759),
    [anon_sym_final] = ACTIONS(5759),
    [anon_sym_override] = ACTIONS(5759),
    [anon_sym_requires] = ACTIONS(5759),
  },
  [2596] = {
    [sym_identifier] = ACTIONS(5618),
    [aux_sym_preproc_def_token1] = ACTIONS(5618),
    [aux_sym_preproc_if_token1] = ACTIONS(5618),
    [aux_sym_preproc_if_token2] = ACTIONS(5618),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5618),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5618),
    [sym_preproc_directive] = ACTIONS(5618),
    [anon_sym_LPAREN2] = ACTIONS(5620),
    [anon_sym_TILDE] = ACTIONS(5620),
    [anon_sym_STAR] = ACTIONS(5620),
    [anon_sym_AMP_AMP] = ACTIONS(5620),
    [anon_sym_AMP] = ACTIONS(5618),
    [anon_sym___extension__] = ACTIONS(5618),
    [anon_sym_typedef] = ACTIONS(5618),
    [anon_sym_extern] = ACTIONS(5618),
    [anon_sym___attribute__] = ACTIONS(5618),
    [anon_sym_COLON_COLON] = ACTIONS(5620),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5620),
    [anon_sym___declspec] = ACTIONS(5618),
    [anon_sym___based] = ACTIONS(5618),
    [anon_sym_signed] = ACTIONS(5618),
    [anon_sym_unsigned] = ACTIONS(5618),
    [anon_sym_long] = ACTIONS(5618),
    [anon_sym_short] = ACTIONS(5618),
    [anon_sym_LBRACK] = ACTIONS(5618),
    [anon_sym_static] = ACTIONS(5618),
    [anon_sym_register] = ACTIONS(5618),
    [anon_sym_inline] = ACTIONS(5618),
    [anon_sym___inline] = ACTIONS(5618),
    [anon_sym___inline__] = ACTIONS(5618),
    [anon_sym___forceinline] = ACTIONS(5618),
    [anon_sym_thread_local] = ACTIONS(5618),
    [anon_sym___thread] = ACTIONS(5618),
    [anon_sym_const] = ACTIONS(5618),
    [anon_sym_constexpr] = ACTIONS(5618),
    [anon_sym_volatile] = ACTIONS(5618),
    [anon_sym_restrict] = ACTIONS(5618),
    [anon_sym___restrict__] = ACTIONS(5618),
    [anon_sym__Atomic] = ACTIONS(5618),
    [anon_sym__Noreturn] = ACTIONS(5618),
    [anon_sym_noreturn] = ACTIONS(5618),
    [anon_sym_mutable] = ACTIONS(5618),
    [anon_sym_constinit] = ACTIONS(5618),
    [anon_sym_consteval] = ACTIONS(5618),
    [anon_sym_PROGMEM] = ACTIONS(5618),
    [aux_sym_primitive_type_token1] = ACTIONS(5618),
    [anon_sym_byte] = ACTIONS(5618),
    [anon_sym_word] = ACTIONS(5618),
    [anon_sym_enum] = ACTIONS(5618),
    [anon_sym_class] = ACTIONS(5618),
    [anon_sym_struct] = ACTIONS(5618),
    [anon_sym_union] = ACTIONS(5618),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5618),
    [anon_sym_decltype] = ACTIONS(5618),
    [anon_sym_virtual] = ACTIONS(5618),
    [anon_sym_alignas] = ACTIONS(5618),
    [anon_sym_explicit] = ACTIONS(5618),
    [anon_sym_typename] = ACTIONS(5618),
    [anon_sym_template] = ACTIONS(5618),
    [anon_sym_operator] = ACTIONS(5618),
    [anon_sym_friend] = ACTIONS(5618),
    [anon_sym_public] = ACTIONS(5618),
    [anon_sym_private] = ACTIONS(5618),
    [anon_sym_protected] = ACTIONS(5618),
    [anon_sym_using] = ACTIONS(5618),
    [anon_sym_static_assert] = ACTIONS(5618),
  },
  [2597] = {
    [sym_identifier] = ACTIONS(3447),
    [aux_sym_preproc_def_token1] = ACTIONS(3447),
    [aux_sym_preproc_if_token1] = ACTIONS(3447),
    [aux_sym_preproc_if_token2] = ACTIONS(3447),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3447),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3447),
    [sym_preproc_directive] = ACTIONS(3447),
    [anon_sym_LPAREN2] = ACTIONS(3449),
    [anon_sym_TILDE] = ACTIONS(3449),
    [anon_sym_STAR] = ACTIONS(3449),
    [anon_sym_AMP_AMP] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3447),
    [anon_sym___extension__] = ACTIONS(3447),
    [anon_sym_typedef] = ACTIONS(3447),
    [anon_sym_extern] = ACTIONS(3447),
    [anon_sym___attribute__] = ACTIONS(3447),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3449),
    [anon_sym___declspec] = ACTIONS(3447),
    [anon_sym___based] = ACTIONS(3447),
    [anon_sym_signed] = ACTIONS(3447),
    [anon_sym_unsigned] = ACTIONS(3447),
    [anon_sym_long] = ACTIONS(3447),
    [anon_sym_short] = ACTIONS(3447),
    [anon_sym_LBRACK] = ACTIONS(3447),
    [anon_sym_static] = ACTIONS(3447),
    [anon_sym_register] = ACTIONS(3447),
    [anon_sym_inline] = ACTIONS(3447),
    [anon_sym___inline] = ACTIONS(3447),
    [anon_sym___inline__] = ACTIONS(3447),
    [anon_sym___forceinline] = ACTIONS(3447),
    [anon_sym_thread_local] = ACTIONS(3447),
    [anon_sym___thread] = ACTIONS(3447),
    [anon_sym_const] = ACTIONS(3447),
    [anon_sym_constexpr] = ACTIONS(3447),
    [anon_sym_volatile] = ACTIONS(3447),
    [anon_sym_restrict] = ACTIONS(3447),
    [anon_sym___restrict__] = ACTIONS(3447),
    [anon_sym__Atomic] = ACTIONS(3447),
    [anon_sym__Noreturn] = ACTIONS(3447),
    [anon_sym_noreturn] = ACTIONS(3447),
    [anon_sym_mutable] = ACTIONS(3447),
    [anon_sym_constinit] = ACTIONS(3447),
    [anon_sym_consteval] = ACTIONS(3447),
    [anon_sym_PROGMEM] = ACTIONS(3447),
    [aux_sym_primitive_type_token1] = ACTIONS(3447),
    [anon_sym_byte] = ACTIONS(3447),
    [anon_sym_word] = ACTIONS(3447),
    [anon_sym_enum] = ACTIONS(3447),
    [anon_sym_class] = ACTIONS(3447),
    [anon_sym_struct] = ACTIONS(3447),
    [anon_sym_union] = ACTIONS(3447),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3447),
    [anon_sym_decltype] = ACTIONS(3447),
    [anon_sym_virtual] = ACTIONS(3447),
    [anon_sym_alignas] = ACTIONS(3447),
    [anon_sym_explicit] = ACTIONS(3447),
    [anon_sym_typename] = ACTIONS(3447),
    [anon_sym_template] = ACTIONS(3447),
    [anon_sym_operator] = ACTIONS(3447),
    [anon_sym_friend] = ACTIONS(3447),
    [anon_sym_public] = ACTIONS(3447),
    [anon_sym_private] = ACTIONS(3447),
    [anon_sym_protected] = ACTIONS(3447),
    [anon_sym_using] = ACTIONS(3447),
    [anon_sym_static_assert] = ACTIONS(3447),
  },
  [2598] = {
    [sym_identifier] = ACTIONS(5598),
    [aux_sym_preproc_def_token1] = ACTIONS(5598),
    [aux_sym_preproc_if_token1] = ACTIONS(5598),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5598),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5598),
    [sym_preproc_directive] = ACTIONS(5598),
    [anon_sym_LPAREN2] = ACTIONS(5600),
    [anon_sym_TILDE] = ACTIONS(5600),
    [anon_sym_STAR] = ACTIONS(5600),
    [anon_sym_AMP_AMP] = ACTIONS(5600),
    [anon_sym_AMP] = ACTIONS(5598),
    [anon_sym___extension__] = ACTIONS(5598),
    [anon_sym_typedef] = ACTIONS(5598),
    [anon_sym_extern] = ACTIONS(5598),
    [anon_sym___attribute__] = ACTIONS(5598),
    [anon_sym_COLON_COLON] = ACTIONS(5600),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5600),
    [anon_sym___declspec] = ACTIONS(5598),
    [anon_sym___based] = ACTIONS(5598),
    [anon_sym_RBRACE] = ACTIONS(5600),
    [anon_sym_signed] = ACTIONS(5598),
    [anon_sym_unsigned] = ACTIONS(5598),
    [anon_sym_long] = ACTIONS(5598),
    [anon_sym_short] = ACTIONS(5598),
    [anon_sym_LBRACK] = ACTIONS(5598),
    [anon_sym_static] = ACTIONS(5598),
    [anon_sym_register] = ACTIONS(5598),
    [anon_sym_inline] = ACTIONS(5598),
    [anon_sym___inline] = ACTIONS(5598),
    [anon_sym___inline__] = ACTIONS(5598),
    [anon_sym___forceinline] = ACTIONS(5598),
    [anon_sym_thread_local] = ACTIONS(5598),
    [anon_sym___thread] = ACTIONS(5598),
    [anon_sym_const] = ACTIONS(5598),
    [anon_sym_constexpr] = ACTIONS(5598),
    [anon_sym_volatile] = ACTIONS(5598),
    [anon_sym_restrict] = ACTIONS(5598),
    [anon_sym___restrict__] = ACTIONS(5598),
    [anon_sym__Atomic] = ACTIONS(5598),
    [anon_sym__Noreturn] = ACTIONS(5598),
    [anon_sym_noreturn] = ACTIONS(5598),
    [anon_sym_mutable] = ACTIONS(5598),
    [anon_sym_constinit] = ACTIONS(5598),
    [anon_sym_consteval] = ACTIONS(5598),
    [anon_sym_PROGMEM] = ACTIONS(5598),
    [aux_sym_primitive_type_token1] = ACTIONS(5598),
    [anon_sym_byte] = ACTIONS(5598),
    [anon_sym_word] = ACTIONS(5598),
    [anon_sym_enum] = ACTIONS(5598),
    [anon_sym_class] = ACTIONS(5598),
    [anon_sym_struct] = ACTIONS(5598),
    [anon_sym_union] = ACTIONS(5598),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5598),
    [anon_sym_decltype] = ACTIONS(5598),
    [anon_sym_virtual] = ACTIONS(5598),
    [anon_sym_alignas] = ACTIONS(5598),
    [anon_sym_explicit] = ACTIONS(5598),
    [anon_sym_typename] = ACTIONS(5598),
    [anon_sym_template] = ACTIONS(5598),
    [anon_sym_operator] = ACTIONS(5598),
    [anon_sym_friend] = ACTIONS(5598),
    [anon_sym_public] = ACTIONS(5598),
    [anon_sym_private] = ACTIONS(5598),
    [anon_sym_protected] = ACTIONS(5598),
    [anon_sym_using] = ACTIONS(5598),
    [anon_sym_static_assert] = ACTIONS(5598),
  },
  [2599] = {
    [sym_identifier] = ACTIONS(5622),
    [aux_sym_preproc_def_token1] = ACTIONS(5622),
    [aux_sym_preproc_if_token1] = ACTIONS(5622),
    [aux_sym_preproc_if_token2] = ACTIONS(5622),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5622),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5622),
    [sym_preproc_directive] = ACTIONS(5622),
    [anon_sym_LPAREN2] = ACTIONS(5624),
    [anon_sym_TILDE] = ACTIONS(5624),
    [anon_sym_STAR] = ACTIONS(5624),
    [anon_sym_AMP_AMP] = ACTIONS(5624),
    [anon_sym_AMP] = ACTIONS(5622),
    [anon_sym___extension__] = ACTIONS(5622),
    [anon_sym_typedef] = ACTIONS(5622),
    [anon_sym_extern] = ACTIONS(5622),
    [anon_sym___attribute__] = ACTIONS(5622),
    [anon_sym_COLON_COLON] = ACTIONS(5624),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5624),
    [anon_sym___declspec] = ACTIONS(5622),
    [anon_sym___based] = ACTIONS(5622),
    [anon_sym_signed] = ACTIONS(5622),
    [anon_sym_unsigned] = ACTIONS(5622),
    [anon_sym_long] = ACTIONS(5622),
    [anon_sym_short] = ACTIONS(5622),
    [anon_sym_LBRACK] = ACTIONS(5622),
    [anon_sym_static] = ACTIONS(5622),
    [anon_sym_register] = ACTIONS(5622),
    [anon_sym_inline] = ACTIONS(5622),
    [anon_sym___inline] = ACTIONS(5622),
    [anon_sym___inline__] = ACTIONS(5622),
    [anon_sym___forceinline] = ACTIONS(5622),
    [anon_sym_thread_local] = ACTIONS(5622),
    [anon_sym___thread] = ACTIONS(5622),
    [anon_sym_const] = ACTIONS(5622),
    [anon_sym_constexpr] = ACTIONS(5622),
    [anon_sym_volatile] = ACTIONS(5622),
    [anon_sym_restrict] = ACTIONS(5622),
    [anon_sym___restrict__] = ACTIONS(5622),
    [anon_sym__Atomic] = ACTIONS(5622),
    [anon_sym__Noreturn] = ACTIONS(5622),
    [anon_sym_noreturn] = ACTIONS(5622),
    [anon_sym_mutable] = ACTIONS(5622),
    [anon_sym_constinit] = ACTIONS(5622),
    [anon_sym_consteval] = ACTIONS(5622),
    [anon_sym_PROGMEM] = ACTIONS(5622),
    [aux_sym_primitive_type_token1] = ACTIONS(5622),
    [anon_sym_byte] = ACTIONS(5622),
    [anon_sym_word] = ACTIONS(5622),
    [anon_sym_enum] = ACTIONS(5622),
    [anon_sym_class] = ACTIONS(5622),
    [anon_sym_struct] = ACTIONS(5622),
    [anon_sym_union] = ACTIONS(5622),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5622),
    [anon_sym_decltype] = ACTIONS(5622),
    [anon_sym_virtual] = ACTIONS(5622),
    [anon_sym_alignas] = ACTIONS(5622),
    [anon_sym_explicit] = ACTIONS(5622),
    [anon_sym_typename] = ACTIONS(5622),
    [anon_sym_template] = ACTIONS(5622),
    [anon_sym_operator] = ACTIONS(5622),
    [anon_sym_friend] = ACTIONS(5622),
    [anon_sym_public] = ACTIONS(5622),
    [anon_sym_private] = ACTIONS(5622),
    [anon_sym_protected] = ACTIONS(5622),
    [anon_sym_using] = ACTIONS(5622),
    [anon_sym_static_assert] = ACTIONS(5622),
  },
  [2600] = {
    [sym_identifier] = ACTIONS(3336),
    [aux_sym_preproc_def_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token1] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3336),
    [sym_preproc_directive] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym___extension__] = ACTIONS(3336),
    [anon_sym_typedef] = ACTIONS(3336),
    [anon_sym_extern] = ACTIONS(3336),
    [anon_sym___attribute__] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3338),
    [anon_sym___declspec] = ACTIONS(3336),
    [anon_sym___based] = ACTIONS(3336),
    [anon_sym_RBRACE] = ACTIONS(3338),
    [anon_sym_signed] = ACTIONS(3336),
    [anon_sym_unsigned] = ACTIONS(3336),
    [anon_sym_long] = ACTIONS(3336),
    [anon_sym_short] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_static] = ACTIONS(3336),
    [anon_sym_register] = ACTIONS(3336),
    [anon_sym_inline] = ACTIONS(3336),
    [anon_sym___inline] = ACTIONS(3336),
    [anon_sym___inline__] = ACTIONS(3336),
    [anon_sym___forceinline] = ACTIONS(3336),
    [anon_sym_thread_local] = ACTIONS(3336),
    [anon_sym___thread] = ACTIONS(3336),
    [anon_sym_const] = ACTIONS(3336),
    [anon_sym_constexpr] = ACTIONS(3336),
    [anon_sym_volatile] = ACTIONS(3336),
    [anon_sym_restrict] = ACTIONS(3336),
    [anon_sym___restrict__] = ACTIONS(3336),
    [anon_sym__Atomic] = ACTIONS(3336),
    [anon_sym__Noreturn] = ACTIONS(3336),
    [anon_sym_noreturn] = ACTIONS(3336),
    [anon_sym_mutable] = ACTIONS(3336),
    [anon_sym_constinit] = ACTIONS(3336),
    [anon_sym_consteval] = ACTIONS(3336),
    [anon_sym_PROGMEM] = ACTIONS(3336),
    [aux_sym_primitive_type_token1] = ACTIONS(3336),
    [anon_sym_byte] = ACTIONS(3336),
    [anon_sym_word] = ACTIONS(3336),
    [anon_sym_enum] = ACTIONS(3336),
    [anon_sym_class] = ACTIONS(3336),
    [anon_sym_struct] = ACTIONS(3336),
    [anon_sym_union] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3336),
    [anon_sym_decltype] = ACTIONS(3336),
    [anon_sym_virtual] = ACTIONS(3336),
    [anon_sym_alignas] = ACTIONS(3336),
    [anon_sym_explicit] = ACTIONS(3336),
    [anon_sym_typename] = ACTIONS(3336),
    [anon_sym_template] = ACTIONS(3336),
    [anon_sym_operator] = ACTIONS(3336),
    [anon_sym_friend] = ACTIONS(3336),
    [anon_sym_public] = ACTIONS(3336),
    [anon_sym_private] = ACTIONS(3336),
    [anon_sym_protected] = ACTIONS(3336),
    [anon_sym_using] = ACTIONS(3336),
    [anon_sym_static_assert] = ACTIONS(3336),
  },
  [2601] = {
    [sym_identifier] = ACTIONS(3124),
    [aux_sym_preproc_def_token1] = ACTIONS(3124),
    [aux_sym_preproc_if_token1] = ACTIONS(3124),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3124),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3124),
    [sym_preproc_directive] = ACTIONS(3124),
    [anon_sym_LPAREN2] = ACTIONS(3126),
    [anon_sym_TILDE] = ACTIONS(3126),
    [anon_sym_STAR] = ACTIONS(3126),
    [anon_sym_AMP_AMP] = ACTIONS(3126),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3124),
    [anon_sym_typedef] = ACTIONS(3124),
    [anon_sym_extern] = ACTIONS(3124),
    [anon_sym___attribute__] = ACTIONS(3124),
    [anon_sym_COLON_COLON] = ACTIONS(3126),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3126),
    [anon_sym___declspec] = ACTIONS(3124),
    [anon_sym___based] = ACTIONS(3124),
    [anon_sym_RBRACE] = ACTIONS(3126),
    [anon_sym_signed] = ACTIONS(3124),
    [anon_sym_unsigned] = ACTIONS(3124),
    [anon_sym_long] = ACTIONS(3124),
    [anon_sym_short] = ACTIONS(3124),
    [anon_sym_LBRACK] = ACTIONS(3124),
    [anon_sym_static] = ACTIONS(3124),
    [anon_sym_register] = ACTIONS(3124),
    [anon_sym_inline] = ACTIONS(3124),
    [anon_sym___inline] = ACTIONS(3124),
    [anon_sym___inline__] = ACTIONS(3124),
    [anon_sym___forceinline] = ACTIONS(3124),
    [anon_sym_thread_local] = ACTIONS(3124),
    [anon_sym___thread] = ACTIONS(3124),
    [anon_sym_const] = ACTIONS(3124),
    [anon_sym_constexpr] = ACTIONS(3124),
    [anon_sym_volatile] = ACTIONS(3124),
    [anon_sym_restrict] = ACTIONS(3124),
    [anon_sym___restrict__] = ACTIONS(3124),
    [anon_sym__Atomic] = ACTIONS(3124),
    [anon_sym__Noreturn] = ACTIONS(3124),
    [anon_sym_noreturn] = ACTIONS(3124),
    [anon_sym_mutable] = ACTIONS(3124),
    [anon_sym_constinit] = ACTIONS(3124),
    [anon_sym_consteval] = ACTIONS(3124),
    [anon_sym_PROGMEM] = ACTIONS(3124),
    [aux_sym_primitive_type_token1] = ACTIONS(3124),
    [anon_sym_byte] = ACTIONS(3124),
    [anon_sym_word] = ACTIONS(3124),
    [anon_sym_enum] = ACTIONS(3124),
    [anon_sym_class] = ACTIONS(3124),
    [anon_sym_struct] = ACTIONS(3124),
    [anon_sym_union] = ACTIONS(3124),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3124),
    [anon_sym_decltype] = ACTIONS(3124),
    [anon_sym_virtual] = ACTIONS(3124),
    [anon_sym_alignas] = ACTIONS(3124),
    [anon_sym_explicit] = ACTIONS(3124),
    [anon_sym_typename] = ACTIONS(3124),
    [anon_sym_template] = ACTIONS(3124),
    [anon_sym_operator] = ACTIONS(3124),
    [anon_sym_friend] = ACTIONS(3124),
    [anon_sym_public] = ACTIONS(3124),
    [anon_sym_private] = ACTIONS(3124),
    [anon_sym_protected] = ACTIONS(3124),
    [anon_sym_using] = ACTIONS(3124),
    [anon_sym_static_assert] = ACTIONS(3124),
  },
  [2602] = {
    [sym_identifier] = ACTIONS(5518),
    [aux_sym_preproc_def_token1] = ACTIONS(5518),
    [aux_sym_preproc_if_token1] = ACTIONS(5518),
    [aux_sym_preproc_if_token2] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5518),
    [sym_preproc_directive] = ACTIONS(5518),
    [anon_sym_LPAREN2] = ACTIONS(5520),
    [anon_sym_TILDE] = ACTIONS(5520),
    [anon_sym_STAR] = ACTIONS(5520),
    [anon_sym_AMP_AMP] = ACTIONS(5520),
    [anon_sym_AMP] = ACTIONS(5518),
    [anon_sym___extension__] = ACTIONS(5518),
    [anon_sym_typedef] = ACTIONS(5518),
    [anon_sym_extern] = ACTIONS(5518),
    [anon_sym___attribute__] = ACTIONS(5518),
    [anon_sym_COLON_COLON] = ACTIONS(5520),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5520),
    [anon_sym___declspec] = ACTIONS(5518),
    [anon_sym___based] = ACTIONS(5518),
    [anon_sym_signed] = ACTIONS(5518),
    [anon_sym_unsigned] = ACTIONS(5518),
    [anon_sym_long] = ACTIONS(5518),
    [anon_sym_short] = ACTIONS(5518),
    [anon_sym_LBRACK] = ACTIONS(5518),
    [anon_sym_static] = ACTIONS(5518),
    [anon_sym_register] = ACTIONS(5518),
    [anon_sym_inline] = ACTIONS(5518),
    [anon_sym___inline] = ACTIONS(5518),
    [anon_sym___inline__] = ACTIONS(5518),
    [anon_sym___forceinline] = ACTIONS(5518),
    [anon_sym_thread_local] = ACTIONS(5518),
    [anon_sym___thread] = ACTIONS(5518),
    [anon_sym_const] = ACTIONS(5518),
    [anon_sym_constexpr] = ACTIONS(5518),
    [anon_sym_volatile] = ACTIONS(5518),
    [anon_sym_restrict] = ACTIONS(5518),
    [anon_sym___restrict__] = ACTIONS(5518),
    [anon_sym__Atomic] = ACTIONS(5518),
    [anon_sym__Noreturn] = ACTIONS(5518),
    [anon_sym_noreturn] = ACTIONS(5518),
    [anon_sym_mutable] = ACTIONS(5518),
    [anon_sym_constinit] = ACTIONS(5518),
    [anon_sym_consteval] = ACTIONS(5518),
    [anon_sym_PROGMEM] = ACTIONS(5518),
    [aux_sym_primitive_type_token1] = ACTIONS(5518),
    [anon_sym_byte] = ACTIONS(5518),
    [anon_sym_word] = ACTIONS(5518),
    [anon_sym_enum] = ACTIONS(5518),
    [anon_sym_class] = ACTIONS(5518),
    [anon_sym_struct] = ACTIONS(5518),
    [anon_sym_union] = ACTIONS(5518),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5518),
    [anon_sym_decltype] = ACTIONS(5518),
    [anon_sym_virtual] = ACTIONS(5518),
    [anon_sym_alignas] = ACTIONS(5518),
    [anon_sym_explicit] = ACTIONS(5518),
    [anon_sym_typename] = ACTIONS(5518),
    [anon_sym_template] = ACTIONS(5518),
    [anon_sym_operator] = ACTIONS(5518),
    [anon_sym_friend] = ACTIONS(5518),
    [anon_sym_public] = ACTIONS(5518),
    [anon_sym_private] = ACTIONS(5518),
    [anon_sym_protected] = ACTIONS(5518),
    [anon_sym_using] = ACTIONS(5518),
    [anon_sym_static_assert] = ACTIONS(5518),
  },
  [2603] = {
    [sym_identifier] = ACTIONS(3475),
    [aux_sym_preproc_def_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token1] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3475),
    [sym_preproc_directive] = ACTIONS(3475),
    [anon_sym_LPAREN2] = ACTIONS(3477),
    [anon_sym_TILDE] = ACTIONS(3477),
    [anon_sym_STAR] = ACTIONS(3477),
    [anon_sym_AMP_AMP] = ACTIONS(3477),
    [anon_sym_AMP] = ACTIONS(3475),
    [anon_sym___extension__] = ACTIONS(3475),
    [anon_sym_typedef] = ACTIONS(3475),
    [anon_sym_extern] = ACTIONS(3475),
    [anon_sym___attribute__] = ACTIONS(3475),
    [anon_sym_COLON_COLON] = ACTIONS(3477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3477),
    [anon_sym___declspec] = ACTIONS(3475),
    [anon_sym___based] = ACTIONS(3475),
    [anon_sym_RBRACE] = ACTIONS(3477),
    [anon_sym_signed] = ACTIONS(3475),
    [anon_sym_unsigned] = ACTIONS(3475),
    [anon_sym_long] = ACTIONS(3475),
    [anon_sym_short] = ACTIONS(3475),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [anon_sym_static] = ACTIONS(3475),
    [anon_sym_register] = ACTIONS(3475),
    [anon_sym_inline] = ACTIONS(3475),
    [anon_sym___inline] = ACTIONS(3475),
    [anon_sym___inline__] = ACTIONS(3475),
    [anon_sym___forceinline] = ACTIONS(3475),
    [anon_sym_thread_local] = ACTIONS(3475),
    [anon_sym___thread] = ACTIONS(3475),
    [anon_sym_const] = ACTIONS(3475),
    [anon_sym_constexpr] = ACTIONS(3475),
    [anon_sym_volatile] = ACTIONS(3475),
    [anon_sym_restrict] = ACTIONS(3475),
    [anon_sym___restrict__] = ACTIONS(3475),
    [anon_sym__Atomic] = ACTIONS(3475),
    [anon_sym__Noreturn] = ACTIONS(3475),
    [anon_sym_noreturn] = ACTIONS(3475),
    [anon_sym_mutable] = ACTIONS(3475),
    [anon_sym_constinit] = ACTIONS(3475),
    [anon_sym_consteval] = ACTIONS(3475),
    [anon_sym_PROGMEM] = ACTIONS(3475),
    [aux_sym_primitive_type_token1] = ACTIONS(3475),
    [anon_sym_byte] = ACTIONS(3475),
    [anon_sym_word] = ACTIONS(3475),
    [anon_sym_enum] = ACTIONS(3475),
    [anon_sym_class] = ACTIONS(3475),
    [anon_sym_struct] = ACTIONS(3475),
    [anon_sym_union] = ACTIONS(3475),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3475),
    [anon_sym_decltype] = ACTIONS(3475),
    [anon_sym_virtual] = ACTIONS(3475),
    [anon_sym_alignas] = ACTIONS(3475),
    [anon_sym_explicit] = ACTIONS(3475),
    [anon_sym_typename] = ACTIONS(3475),
    [anon_sym_template] = ACTIONS(3475),
    [anon_sym_operator] = ACTIONS(3475),
    [anon_sym_friend] = ACTIONS(3475),
    [anon_sym_public] = ACTIONS(3475),
    [anon_sym_private] = ACTIONS(3475),
    [anon_sym_protected] = ACTIONS(3475),
    [anon_sym_using] = ACTIONS(3475),
    [anon_sym_static_assert] = ACTIONS(3475),
  },
  [2604] = {
    [sym_attribute_specifier] = STATE(2789),
    [sym_enumerator_list] = STATE(2703),
    [sym_identifier] = ACTIONS(5980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5982),
    [anon_sym_COMMA] = ACTIONS(5982),
    [anon_sym_RPAREN] = ACTIONS(5982),
    [aux_sym_preproc_if_token2] = ACTIONS(5982),
    [aux_sym_preproc_else_token1] = ACTIONS(5982),
    [aux_sym_preproc_elif_token1] = ACTIONS(5980),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5982),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5982),
    [anon_sym_LPAREN2] = ACTIONS(5982),
    [anon_sym_DASH] = ACTIONS(5980),
    [anon_sym_PLUS] = ACTIONS(5980),
    [anon_sym_STAR] = ACTIONS(5980),
    [anon_sym_SLASH] = ACTIONS(5980),
    [anon_sym_PERCENT] = ACTIONS(5980),
    [anon_sym_PIPE_PIPE] = ACTIONS(5982),
    [anon_sym_AMP_AMP] = ACTIONS(5982),
    [anon_sym_PIPE] = ACTIONS(5980),
    [anon_sym_CARET] = ACTIONS(5980),
    [anon_sym_AMP] = ACTIONS(5980),
    [anon_sym_EQ_EQ] = ACTIONS(5982),
    [anon_sym_BANG_EQ] = ACTIONS(5982),
    [anon_sym_GT] = ACTIONS(5980),
    [anon_sym_GT_EQ] = ACTIONS(5982),
    [anon_sym_LT_EQ] = ACTIONS(5980),
    [anon_sym_LT] = ACTIONS(5980),
    [anon_sym_LT_LT] = ACTIONS(5980),
    [anon_sym_GT_GT] = ACTIONS(5980),
    [anon_sym_SEMI] = ACTIONS(5982),
    [anon_sym___attribute__] = ACTIONS(5473),
    [anon_sym_LBRACE] = ACTIONS(5956),
    [anon_sym_RBRACE] = ACTIONS(5982),
    [anon_sym_LBRACK] = ACTIONS(5982),
    [anon_sym_RBRACK] = ACTIONS(5982),
    [anon_sym_EQ] = ACTIONS(5980),
    [anon_sym_COLON] = ACTIONS(5982),
    [anon_sym_QMARK] = ACTIONS(5982),
    [anon_sym_STAR_EQ] = ACTIONS(5982),
    [anon_sym_SLASH_EQ] = ACTIONS(5982),
    [anon_sym_PERCENT_EQ] = ACTIONS(5982),
    [anon_sym_PLUS_EQ] = ACTIONS(5982),
    [anon_sym_DASH_EQ] = ACTIONS(5982),
    [anon_sym_LT_LT_EQ] = ACTIONS(5982),
    [anon_sym_GT_GT_EQ] = ACTIONS(5982),
    [anon_sym_AMP_EQ] = ACTIONS(5982),
    [anon_sym_CARET_EQ] = ACTIONS(5982),
    [anon_sym_PIPE_EQ] = ACTIONS(5982),
    [anon_sym_and_eq] = ACTIONS(5980),
    [anon_sym_or_eq] = ACTIONS(5980),
    [anon_sym_xor_eq] = ACTIONS(5980),
    [anon_sym_LT_EQ_GT] = ACTIONS(5982),
    [anon_sym_or] = ACTIONS(5980),
    [anon_sym_and] = ACTIONS(5980),
    [anon_sym_bitor] = ACTIONS(5980),
    [anon_sym_xor] = ACTIONS(5980),
    [anon_sym_bitand] = ACTIONS(5980),
    [anon_sym_not_eq] = ACTIONS(5980),
    [anon_sym_DASH_DASH] = ACTIONS(5982),
    [anon_sym_PLUS_PLUS] = ACTIONS(5982),
    [anon_sym_DOT] = ACTIONS(5980),
    [anon_sym_DOT_STAR] = ACTIONS(5982),
    [anon_sym_DASH_GT] = ACTIONS(5982),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5980),
    [anon_sym_decltype] = ACTIONS(5980),
  },
  [2605] = {
    [sym_identifier] = ACTIONS(5546),
    [aux_sym_preproc_def_token1] = ACTIONS(5546),
    [aux_sym_preproc_if_token1] = ACTIONS(5546),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5546),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5546),
    [sym_preproc_directive] = ACTIONS(5546),
    [anon_sym_LPAREN2] = ACTIONS(5548),
    [anon_sym_TILDE] = ACTIONS(5548),
    [anon_sym_STAR] = ACTIONS(5548),
    [anon_sym_AMP_AMP] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5546),
    [anon_sym___extension__] = ACTIONS(5546),
    [anon_sym_typedef] = ACTIONS(5546),
    [anon_sym_extern] = ACTIONS(5546),
    [anon_sym___attribute__] = ACTIONS(5546),
    [anon_sym_COLON_COLON] = ACTIONS(5548),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5548),
    [anon_sym___declspec] = ACTIONS(5546),
    [anon_sym___based] = ACTIONS(5546),
    [anon_sym_RBRACE] = ACTIONS(5548),
    [anon_sym_signed] = ACTIONS(5546),
    [anon_sym_unsigned] = ACTIONS(5546),
    [anon_sym_long] = ACTIONS(5546),
    [anon_sym_short] = ACTIONS(5546),
    [anon_sym_LBRACK] = ACTIONS(5546),
    [anon_sym_static] = ACTIONS(5546),
    [anon_sym_register] = ACTIONS(5546),
    [anon_sym_inline] = ACTIONS(5546),
    [anon_sym___inline] = ACTIONS(5546),
    [anon_sym___inline__] = ACTIONS(5546),
    [anon_sym___forceinline] = ACTIONS(5546),
    [anon_sym_thread_local] = ACTIONS(5546),
    [anon_sym___thread] = ACTIONS(5546),
    [anon_sym_const] = ACTIONS(5546),
    [anon_sym_constexpr] = ACTIONS(5546),
    [anon_sym_volatile] = ACTIONS(5546),
    [anon_sym_restrict] = ACTIONS(5546),
    [anon_sym___restrict__] = ACTIONS(5546),
    [anon_sym__Atomic] = ACTIONS(5546),
    [anon_sym__Noreturn] = ACTIONS(5546),
    [anon_sym_noreturn] = ACTIONS(5546),
    [anon_sym_mutable] = ACTIONS(5546),
    [anon_sym_constinit] = ACTIONS(5546),
    [anon_sym_consteval] = ACTIONS(5546),
    [anon_sym_PROGMEM] = ACTIONS(5546),
    [aux_sym_primitive_type_token1] = ACTIONS(5546),
    [anon_sym_byte] = ACTIONS(5546),
    [anon_sym_word] = ACTIONS(5546),
    [anon_sym_enum] = ACTIONS(5546),
    [anon_sym_class] = ACTIONS(5546),
    [anon_sym_struct] = ACTIONS(5546),
    [anon_sym_union] = ACTIONS(5546),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5546),
    [anon_sym_decltype] = ACTIONS(5546),
    [anon_sym_virtual] = ACTIONS(5546),
    [anon_sym_alignas] = ACTIONS(5546),
    [anon_sym_explicit] = ACTIONS(5546),
    [anon_sym_typename] = ACTIONS(5546),
    [anon_sym_template] = ACTIONS(5546),
    [anon_sym_operator] = ACTIONS(5546),
    [anon_sym_friend] = ACTIONS(5546),
    [anon_sym_public] = ACTIONS(5546),
    [anon_sym_private] = ACTIONS(5546),
    [anon_sym_protected] = ACTIONS(5546),
    [anon_sym_using] = ACTIONS(5546),
    [anon_sym_static_assert] = ACTIONS(5546),
  },
  [2606] = {
    [sym_identifier] = ACTIONS(3124),
    [aux_sym_preproc_def_token1] = ACTIONS(3124),
    [aux_sym_preproc_if_token1] = ACTIONS(3124),
    [aux_sym_preproc_if_token2] = ACTIONS(3124),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3124),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3124),
    [sym_preproc_directive] = ACTIONS(3124),
    [anon_sym_LPAREN2] = ACTIONS(3126),
    [anon_sym_TILDE] = ACTIONS(3126),
    [anon_sym_STAR] = ACTIONS(3126),
    [anon_sym_AMP_AMP] = ACTIONS(3126),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3124),
    [anon_sym_typedef] = ACTIONS(3124),
    [anon_sym_extern] = ACTIONS(3124),
    [anon_sym___attribute__] = ACTIONS(3124),
    [anon_sym_COLON_COLON] = ACTIONS(3126),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3126),
    [anon_sym___declspec] = ACTIONS(3124),
    [anon_sym___based] = ACTIONS(3124),
    [anon_sym_signed] = ACTIONS(3124),
    [anon_sym_unsigned] = ACTIONS(3124),
    [anon_sym_long] = ACTIONS(3124),
    [anon_sym_short] = ACTIONS(3124),
    [anon_sym_LBRACK] = ACTIONS(3124),
    [anon_sym_static] = ACTIONS(3124),
    [anon_sym_register] = ACTIONS(3124),
    [anon_sym_inline] = ACTIONS(3124),
    [anon_sym___inline] = ACTIONS(3124),
    [anon_sym___inline__] = ACTIONS(3124),
    [anon_sym___forceinline] = ACTIONS(3124),
    [anon_sym_thread_local] = ACTIONS(3124),
    [anon_sym___thread] = ACTIONS(3124),
    [anon_sym_const] = ACTIONS(3124),
    [anon_sym_constexpr] = ACTIONS(3124),
    [anon_sym_volatile] = ACTIONS(3124),
    [anon_sym_restrict] = ACTIONS(3124),
    [anon_sym___restrict__] = ACTIONS(3124),
    [anon_sym__Atomic] = ACTIONS(3124),
    [anon_sym__Noreturn] = ACTIONS(3124),
    [anon_sym_noreturn] = ACTIONS(3124),
    [anon_sym_mutable] = ACTIONS(3124),
    [anon_sym_constinit] = ACTIONS(3124),
    [anon_sym_consteval] = ACTIONS(3124),
    [anon_sym_PROGMEM] = ACTIONS(3124),
    [aux_sym_primitive_type_token1] = ACTIONS(3124),
    [anon_sym_byte] = ACTIONS(3124),
    [anon_sym_word] = ACTIONS(3124),
    [anon_sym_enum] = ACTIONS(3124),
    [anon_sym_class] = ACTIONS(3124),
    [anon_sym_struct] = ACTIONS(3124),
    [anon_sym_union] = ACTIONS(3124),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3124),
    [anon_sym_decltype] = ACTIONS(3124),
    [anon_sym_virtual] = ACTIONS(3124),
    [anon_sym_alignas] = ACTIONS(3124),
    [anon_sym_explicit] = ACTIONS(3124),
    [anon_sym_typename] = ACTIONS(3124),
    [anon_sym_template] = ACTIONS(3124),
    [anon_sym_operator] = ACTIONS(3124),
    [anon_sym_friend] = ACTIONS(3124),
    [anon_sym_public] = ACTIONS(3124),
    [anon_sym_private] = ACTIONS(3124),
    [anon_sym_protected] = ACTIONS(3124),
    [anon_sym_using] = ACTIONS(3124),
    [anon_sym_static_assert] = ACTIONS(3124),
  },
  [2607] = {
    [sym_identifier] = ACTIONS(3869),
    [aux_sym_preproc_def_token1] = ACTIONS(3869),
    [aux_sym_preproc_if_token1] = ACTIONS(3869),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3869),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3869),
    [sym_preproc_directive] = ACTIONS(3869),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3867),
    [anon_sym_STAR] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_AMP] = ACTIONS(3869),
    [anon_sym___extension__] = ACTIONS(3869),
    [anon_sym_typedef] = ACTIONS(3869),
    [anon_sym_extern] = ACTIONS(3869),
    [anon_sym___attribute__] = ACTIONS(3869),
    [anon_sym_COLON_COLON] = ACTIONS(3867),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3867),
    [anon_sym___declspec] = ACTIONS(3869),
    [anon_sym___based] = ACTIONS(3869),
    [anon_sym_RBRACE] = ACTIONS(3867),
    [anon_sym_signed] = ACTIONS(3869),
    [anon_sym_unsigned] = ACTIONS(3869),
    [anon_sym_long] = ACTIONS(3869),
    [anon_sym_short] = ACTIONS(3869),
    [anon_sym_LBRACK] = ACTIONS(3869),
    [anon_sym_static] = ACTIONS(3869),
    [anon_sym_register] = ACTIONS(3869),
    [anon_sym_inline] = ACTIONS(3869),
    [anon_sym___inline] = ACTIONS(3869),
    [anon_sym___inline__] = ACTIONS(3869),
    [anon_sym___forceinline] = ACTIONS(3869),
    [anon_sym_thread_local] = ACTIONS(3869),
    [anon_sym___thread] = ACTIONS(3869),
    [anon_sym_const] = ACTIONS(3869),
    [anon_sym_constexpr] = ACTIONS(3869),
    [anon_sym_volatile] = ACTIONS(3869),
    [anon_sym_restrict] = ACTIONS(3869),
    [anon_sym___restrict__] = ACTIONS(3869),
    [anon_sym__Atomic] = ACTIONS(3869),
    [anon_sym__Noreturn] = ACTIONS(3869),
    [anon_sym_noreturn] = ACTIONS(3869),
    [anon_sym_mutable] = ACTIONS(3869),
    [anon_sym_constinit] = ACTIONS(3869),
    [anon_sym_consteval] = ACTIONS(3869),
    [anon_sym_PROGMEM] = ACTIONS(3869),
    [aux_sym_primitive_type_token1] = ACTIONS(3869),
    [anon_sym_byte] = ACTIONS(3869),
    [anon_sym_word] = ACTIONS(3869),
    [anon_sym_enum] = ACTIONS(3869),
    [anon_sym_class] = ACTIONS(3869),
    [anon_sym_struct] = ACTIONS(3869),
    [anon_sym_union] = ACTIONS(3869),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3869),
    [anon_sym_decltype] = ACTIONS(3869),
    [anon_sym_virtual] = ACTIONS(3869),
    [anon_sym_alignas] = ACTIONS(3869),
    [anon_sym_explicit] = ACTIONS(3869),
    [anon_sym_typename] = ACTIONS(3869),
    [anon_sym_template] = ACTIONS(3869),
    [anon_sym_operator] = ACTIONS(3869),
    [anon_sym_friend] = ACTIONS(3869),
    [anon_sym_public] = ACTIONS(3869),
    [anon_sym_private] = ACTIONS(3869),
    [anon_sym_protected] = ACTIONS(3869),
    [anon_sym_using] = ACTIONS(3869),
    [anon_sym_static_assert] = ACTIONS(3869),
  },
  [2608] = {
    [sym_identifier] = ACTIONS(3336),
    [aux_sym_preproc_def_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token1] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3336),
    [sym_preproc_directive] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym___extension__] = ACTIONS(3336),
    [anon_sym_typedef] = ACTIONS(3336),
    [anon_sym_extern] = ACTIONS(3336),
    [anon_sym___attribute__] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3338),
    [anon_sym___declspec] = ACTIONS(3336),
    [anon_sym___based] = ACTIONS(3336),
    [anon_sym_RBRACE] = ACTIONS(3338),
    [anon_sym_signed] = ACTIONS(3336),
    [anon_sym_unsigned] = ACTIONS(3336),
    [anon_sym_long] = ACTIONS(3336),
    [anon_sym_short] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_static] = ACTIONS(3336),
    [anon_sym_register] = ACTIONS(3336),
    [anon_sym_inline] = ACTIONS(3336),
    [anon_sym___inline] = ACTIONS(3336),
    [anon_sym___inline__] = ACTIONS(3336),
    [anon_sym___forceinline] = ACTIONS(3336),
    [anon_sym_thread_local] = ACTIONS(3336),
    [anon_sym___thread] = ACTIONS(3336),
    [anon_sym_const] = ACTIONS(3336),
    [anon_sym_constexpr] = ACTIONS(3336),
    [anon_sym_volatile] = ACTIONS(3336),
    [anon_sym_restrict] = ACTIONS(3336),
    [anon_sym___restrict__] = ACTIONS(3336),
    [anon_sym__Atomic] = ACTIONS(3336),
    [anon_sym__Noreturn] = ACTIONS(3336),
    [anon_sym_noreturn] = ACTIONS(3336),
    [anon_sym_mutable] = ACTIONS(3336),
    [anon_sym_constinit] = ACTIONS(3336),
    [anon_sym_consteval] = ACTIONS(3336),
    [anon_sym_PROGMEM] = ACTIONS(3336),
    [aux_sym_primitive_type_token1] = ACTIONS(3336),
    [anon_sym_byte] = ACTIONS(3336),
    [anon_sym_word] = ACTIONS(3336),
    [anon_sym_enum] = ACTIONS(3336),
    [anon_sym_class] = ACTIONS(3336),
    [anon_sym_struct] = ACTIONS(3336),
    [anon_sym_union] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3336),
    [anon_sym_decltype] = ACTIONS(3336),
    [anon_sym_virtual] = ACTIONS(3336),
    [anon_sym_alignas] = ACTIONS(3336),
    [anon_sym_explicit] = ACTIONS(3336),
    [anon_sym_typename] = ACTIONS(3336),
    [anon_sym_template] = ACTIONS(3336),
    [anon_sym_operator] = ACTIONS(3336),
    [anon_sym_friend] = ACTIONS(3336),
    [anon_sym_public] = ACTIONS(3336),
    [anon_sym_private] = ACTIONS(3336),
    [anon_sym_protected] = ACTIONS(3336),
    [anon_sym_using] = ACTIONS(3336),
    [anon_sym_static_assert] = ACTIONS(3336),
  },
  [2609] = {
    [sym_identifier] = ACTIONS(3467),
    [aux_sym_preproc_def_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token1] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3467),
    [sym_preproc_directive] = ACTIONS(3467),
    [anon_sym_LPAREN2] = ACTIONS(3469),
    [anon_sym_TILDE] = ACTIONS(3469),
    [anon_sym_STAR] = ACTIONS(3469),
    [anon_sym_AMP_AMP] = ACTIONS(3469),
    [anon_sym_AMP] = ACTIONS(3467),
    [anon_sym___extension__] = ACTIONS(3467),
    [anon_sym_typedef] = ACTIONS(3467),
    [anon_sym_extern] = ACTIONS(3467),
    [anon_sym___attribute__] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(3469),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3469),
    [anon_sym___declspec] = ACTIONS(3467),
    [anon_sym___based] = ACTIONS(3467),
    [anon_sym_RBRACE] = ACTIONS(3469),
    [anon_sym_signed] = ACTIONS(3467),
    [anon_sym_unsigned] = ACTIONS(3467),
    [anon_sym_long] = ACTIONS(3467),
    [anon_sym_short] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [anon_sym_static] = ACTIONS(3467),
    [anon_sym_register] = ACTIONS(3467),
    [anon_sym_inline] = ACTIONS(3467),
    [anon_sym___inline] = ACTIONS(3467),
    [anon_sym___inline__] = ACTIONS(3467),
    [anon_sym___forceinline] = ACTIONS(3467),
    [anon_sym_thread_local] = ACTIONS(3467),
    [anon_sym___thread] = ACTIONS(3467),
    [anon_sym_const] = ACTIONS(3467),
    [anon_sym_constexpr] = ACTIONS(3467),
    [anon_sym_volatile] = ACTIONS(3467),
    [anon_sym_restrict] = ACTIONS(3467),
    [anon_sym___restrict__] = ACTIONS(3467),
    [anon_sym__Atomic] = ACTIONS(3467),
    [anon_sym__Noreturn] = ACTIONS(3467),
    [anon_sym_noreturn] = ACTIONS(3467),
    [anon_sym_mutable] = ACTIONS(3467),
    [anon_sym_constinit] = ACTIONS(3467),
    [anon_sym_consteval] = ACTIONS(3467),
    [anon_sym_PROGMEM] = ACTIONS(3467),
    [aux_sym_primitive_type_token1] = ACTIONS(3467),
    [anon_sym_byte] = ACTIONS(3467),
    [anon_sym_word] = ACTIONS(3467),
    [anon_sym_enum] = ACTIONS(3467),
    [anon_sym_class] = ACTIONS(3467),
    [anon_sym_struct] = ACTIONS(3467),
    [anon_sym_union] = ACTIONS(3467),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3467),
    [anon_sym_decltype] = ACTIONS(3467),
    [anon_sym_virtual] = ACTIONS(3467),
    [anon_sym_alignas] = ACTIONS(3467),
    [anon_sym_explicit] = ACTIONS(3467),
    [anon_sym_typename] = ACTIONS(3467),
    [anon_sym_template] = ACTIONS(3467),
    [anon_sym_operator] = ACTIONS(3467),
    [anon_sym_friend] = ACTIONS(3467),
    [anon_sym_public] = ACTIONS(3467),
    [anon_sym_private] = ACTIONS(3467),
    [anon_sym_protected] = ACTIONS(3467),
    [anon_sym_using] = ACTIONS(3467),
    [anon_sym_static_assert] = ACTIONS(3467),
  },
  [2610] = {
    [sym_identifier] = ACTIONS(5562),
    [aux_sym_preproc_def_token1] = ACTIONS(5562),
    [aux_sym_preproc_if_token1] = ACTIONS(5562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5562),
    [sym_preproc_directive] = ACTIONS(5562),
    [anon_sym_LPAREN2] = ACTIONS(5564),
    [anon_sym_TILDE] = ACTIONS(5564),
    [anon_sym_STAR] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5562),
    [anon_sym___extension__] = ACTIONS(5562),
    [anon_sym_typedef] = ACTIONS(5562),
    [anon_sym_extern] = ACTIONS(5562),
    [anon_sym___attribute__] = ACTIONS(5562),
    [anon_sym_COLON_COLON] = ACTIONS(5564),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5564),
    [anon_sym___declspec] = ACTIONS(5562),
    [anon_sym___based] = ACTIONS(5562),
    [anon_sym_RBRACE] = ACTIONS(5564),
    [anon_sym_signed] = ACTIONS(5562),
    [anon_sym_unsigned] = ACTIONS(5562),
    [anon_sym_long] = ACTIONS(5562),
    [anon_sym_short] = ACTIONS(5562),
    [anon_sym_LBRACK] = ACTIONS(5562),
    [anon_sym_static] = ACTIONS(5562),
    [anon_sym_register] = ACTIONS(5562),
    [anon_sym_inline] = ACTIONS(5562),
    [anon_sym___inline] = ACTIONS(5562),
    [anon_sym___inline__] = ACTIONS(5562),
    [anon_sym___forceinline] = ACTIONS(5562),
    [anon_sym_thread_local] = ACTIONS(5562),
    [anon_sym___thread] = ACTIONS(5562),
    [anon_sym_const] = ACTIONS(5562),
    [anon_sym_constexpr] = ACTIONS(5562),
    [anon_sym_volatile] = ACTIONS(5562),
    [anon_sym_restrict] = ACTIONS(5562),
    [anon_sym___restrict__] = ACTIONS(5562),
    [anon_sym__Atomic] = ACTIONS(5562),
    [anon_sym__Noreturn] = ACTIONS(5562),
    [anon_sym_noreturn] = ACTIONS(5562),
    [anon_sym_mutable] = ACTIONS(5562),
    [anon_sym_constinit] = ACTIONS(5562),
    [anon_sym_consteval] = ACTIONS(5562),
    [anon_sym_PROGMEM] = ACTIONS(5562),
    [aux_sym_primitive_type_token1] = ACTIONS(5562),
    [anon_sym_byte] = ACTIONS(5562),
    [anon_sym_word] = ACTIONS(5562),
    [anon_sym_enum] = ACTIONS(5562),
    [anon_sym_class] = ACTIONS(5562),
    [anon_sym_struct] = ACTIONS(5562),
    [anon_sym_union] = ACTIONS(5562),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5562),
    [anon_sym_decltype] = ACTIONS(5562),
    [anon_sym_virtual] = ACTIONS(5562),
    [anon_sym_alignas] = ACTIONS(5562),
    [anon_sym_explicit] = ACTIONS(5562),
    [anon_sym_typename] = ACTIONS(5562),
    [anon_sym_template] = ACTIONS(5562),
    [anon_sym_operator] = ACTIONS(5562),
    [anon_sym_friend] = ACTIONS(5562),
    [anon_sym_public] = ACTIONS(5562),
    [anon_sym_private] = ACTIONS(5562),
    [anon_sym_protected] = ACTIONS(5562),
    [anon_sym_using] = ACTIONS(5562),
    [anon_sym_static_assert] = ACTIONS(5562),
  },
  [2611] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(4471),
    [sym_raw_string_literal] = STATE(3057),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5870),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4280),
    [anon_sym_COLON] = ACTIONS(4565),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_and_eq] = ACTIONS(4284),
    [anon_sym_or_eq] = ACTIONS(4284),
    [anon_sym_xor_eq] = ACTIONS(4284),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [2612] = {
    [sym_identifier] = ACTIONS(5566),
    [aux_sym_preproc_def_token1] = ACTIONS(5566),
    [aux_sym_preproc_if_token1] = ACTIONS(5566),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5566),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5566),
    [sym_preproc_directive] = ACTIONS(5566),
    [anon_sym_LPAREN2] = ACTIONS(5568),
    [anon_sym_TILDE] = ACTIONS(5568),
    [anon_sym_STAR] = ACTIONS(5568),
    [anon_sym_AMP_AMP] = ACTIONS(5568),
    [anon_sym_AMP] = ACTIONS(5566),
    [anon_sym___extension__] = ACTIONS(5566),
    [anon_sym_typedef] = ACTIONS(5566),
    [anon_sym_extern] = ACTIONS(5566),
    [anon_sym___attribute__] = ACTIONS(5566),
    [anon_sym_COLON_COLON] = ACTIONS(5568),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5568),
    [anon_sym___declspec] = ACTIONS(5566),
    [anon_sym___based] = ACTIONS(5566),
    [anon_sym_RBRACE] = ACTIONS(5568),
    [anon_sym_signed] = ACTIONS(5566),
    [anon_sym_unsigned] = ACTIONS(5566),
    [anon_sym_long] = ACTIONS(5566),
    [anon_sym_short] = ACTIONS(5566),
    [anon_sym_LBRACK] = ACTIONS(5566),
    [anon_sym_static] = ACTIONS(5566),
    [anon_sym_register] = ACTIONS(5566),
    [anon_sym_inline] = ACTIONS(5566),
    [anon_sym___inline] = ACTIONS(5566),
    [anon_sym___inline__] = ACTIONS(5566),
    [anon_sym___forceinline] = ACTIONS(5566),
    [anon_sym_thread_local] = ACTIONS(5566),
    [anon_sym___thread] = ACTIONS(5566),
    [anon_sym_const] = ACTIONS(5566),
    [anon_sym_constexpr] = ACTIONS(5566),
    [anon_sym_volatile] = ACTIONS(5566),
    [anon_sym_restrict] = ACTIONS(5566),
    [anon_sym___restrict__] = ACTIONS(5566),
    [anon_sym__Atomic] = ACTIONS(5566),
    [anon_sym__Noreturn] = ACTIONS(5566),
    [anon_sym_noreturn] = ACTIONS(5566),
    [anon_sym_mutable] = ACTIONS(5566),
    [anon_sym_constinit] = ACTIONS(5566),
    [anon_sym_consteval] = ACTIONS(5566),
    [anon_sym_PROGMEM] = ACTIONS(5566),
    [aux_sym_primitive_type_token1] = ACTIONS(5566),
    [anon_sym_byte] = ACTIONS(5566),
    [anon_sym_word] = ACTIONS(5566),
    [anon_sym_enum] = ACTIONS(5566),
    [anon_sym_class] = ACTIONS(5566),
    [anon_sym_struct] = ACTIONS(5566),
    [anon_sym_union] = ACTIONS(5566),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5566),
    [anon_sym_decltype] = ACTIONS(5566),
    [anon_sym_virtual] = ACTIONS(5566),
    [anon_sym_alignas] = ACTIONS(5566),
    [anon_sym_explicit] = ACTIONS(5566),
    [anon_sym_typename] = ACTIONS(5566),
    [anon_sym_template] = ACTIONS(5566),
    [anon_sym_operator] = ACTIONS(5566),
    [anon_sym_friend] = ACTIONS(5566),
    [anon_sym_public] = ACTIONS(5566),
    [anon_sym_private] = ACTIONS(5566),
    [anon_sym_protected] = ACTIONS(5566),
    [anon_sym_using] = ACTIONS(5566),
    [anon_sym_static_assert] = ACTIONS(5566),
  },
  [2613] = {
    [sym_identifier] = ACTIONS(2970),
    [aux_sym_preproc_def_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token2] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2970),
    [sym_preproc_directive] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym___extension__] = ACTIONS(2970),
    [anon_sym_typedef] = ACTIONS(2970),
    [anon_sym_extern] = ACTIONS(2970),
    [anon_sym___attribute__] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2970),
    [anon_sym___based] = ACTIONS(2970),
    [anon_sym_signed] = ACTIONS(2970),
    [anon_sym_unsigned] = ACTIONS(2970),
    [anon_sym_long] = ACTIONS(2970),
    [anon_sym_short] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_register] = ACTIONS(2970),
    [anon_sym_inline] = ACTIONS(2970),
    [anon_sym___inline] = ACTIONS(2970),
    [anon_sym___inline__] = ACTIONS(2970),
    [anon_sym___forceinline] = ACTIONS(2970),
    [anon_sym_thread_local] = ACTIONS(2970),
    [anon_sym___thread] = ACTIONS(2970),
    [anon_sym_const] = ACTIONS(2970),
    [anon_sym_constexpr] = ACTIONS(2970),
    [anon_sym_volatile] = ACTIONS(2970),
    [anon_sym_restrict] = ACTIONS(2970),
    [anon_sym___restrict__] = ACTIONS(2970),
    [anon_sym__Atomic] = ACTIONS(2970),
    [anon_sym__Noreturn] = ACTIONS(2970),
    [anon_sym_noreturn] = ACTIONS(2970),
    [anon_sym_mutable] = ACTIONS(2970),
    [anon_sym_constinit] = ACTIONS(2970),
    [anon_sym_consteval] = ACTIONS(2970),
    [anon_sym_PROGMEM] = ACTIONS(2970),
    [aux_sym_primitive_type_token1] = ACTIONS(2970),
    [anon_sym_byte] = ACTIONS(2970),
    [anon_sym_word] = ACTIONS(2970),
    [anon_sym_enum] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_struct] = ACTIONS(2970),
    [anon_sym_union] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2970),
    [anon_sym_decltype] = ACTIONS(2970),
    [anon_sym_virtual] = ACTIONS(2970),
    [anon_sym_alignas] = ACTIONS(2970),
    [anon_sym_explicit] = ACTIONS(2970),
    [anon_sym_typename] = ACTIONS(2970),
    [anon_sym_template] = ACTIONS(2970),
    [anon_sym_operator] = ACTIONS(2970),
    [anon_sym_friend] = ACTIONS(2970),
    [anon_sym_public] = ACTIONS(2970),
    [anon_sym_private] = ACTIONS(2970),
    [anon_sym_protected] = ACTIONS(2970),
    [anon_sym_using] = ACTIONS(2970),
    [anon_sym_static_assert] = ACTIONS(2970),
  },
  [2614] = {
    [sym_identifier] = ACTIONS(3999),
    [aux_sym_preproc_def_token1] = ACTIONS(3999),
    [aux_sym_preproc_if_token1] = ACTIONS(3999),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3999),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3999),
    [sym_preproc_directive] = ACTIONS(3999),
    [anon_sym_LPAREN2] = ACTIONS(3997),
    [anon_sym_TILDE] = ACTIONS(3997),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_AMP] = ACTIONS(3999),
    [anon_sym___extension__] = ACTIONS(3999),
    [anon_sym_typedef] = ACTIONS(3999),
    [anon_sym_extern] = ACTIONS(3999),
    [anon_sym___attribute__] = ACTIONS(3999),
    [anon_sym_COLON_COLON] = ACTIONS(3997),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3997),
    [anon_sym___declspec] = ACTIONS(3999),
    [anon_sym___based] = ACTIONS(3999),
    [anon_sym_RBRACE] = ACTIONS(3997),
    [anon_sym_signed] = ACTIONS(3999),
    [anon_sym_unsigned] = ACTIONS(3999),
    [anon_sym_long] = ACTIONS(3999),
    [anon_sym_short] = ACTIONS(3999),
    [anon_sym_LBRACK] = ACTIONS(3999),
    [anon_sym_static] = ACTIONS(3999),
    [anon_sym_register] = ACTIONS(3999),
    [anon_sym_inline] = ACTIONS(3999),
    [anon_sym___inline] = ACTIONS(3999),
    [anon_sym___inline__] = ACTIONS(3999),
    [anon_sym___forceinline] = ACTIONS(3999),
    [anon_sym_thread_local] = ACTIONS(3999),
    [anon_sym___thread] = ACTIONS(3999),
    [anon_sym_const] = ACTIONS(3999),
    [anon_sym_constexpr] = ACTIONS(3999),
    [anon_sym_volatile] = ACTIONS(3999),
    [anon_sym_restrict] = ACTIONS(3999),
    [anon_sym___restrict__] = ACTIONS(3999),
    [anon_sym__Atomic] = ACTIONS(3999),
    [anon_sym__Noreturn] = ACTIONS(3999),
    [anon_sym_noreturn] = ACTIONS(3999),
    [anon_sym_mutable] = ACTIONS(3999),
    [anon_sym_constinit] = ACTIONS(3999),
    [anon_sym_consteval] = ACTIONS(3999),
    [anon_sym_PROGMEM] = ACTIONS(3999),
    [aux_sym_primitive_type_token1] = ACTIONS(3999),
    [anon_sym_byte] = ACTIONS(3999),
    [anon_sym_word] = ACTIONS(3999),
    [anon_sym_enum] = ACTIONS(3999),
    [anon_sym_class] = ACTIONS(3999),
    [anon_sym_struct] = ACTIONS(3999),
    [anon_sym_union] = ACTIONS(3999),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3999),
    [anon_sym_decltype] = ACTIONS(3999),
    [anon_sym_virtual] = ACTIONS(3999),
    [anon_sym_alignas] = ACTIONS(3999),
    [anon_sym_explicit] = ACTIONS(3999),
    [anon_sym_typename] = ACTIONS(3999),
    [anon_sym_template] = ACTIONS(3999),
    [anon_sym_operator] = ACTIONS(3999),
    [anon_sym_friend] = ACTIONS(3999),
    [anon_sym_public] = ACTIONS(3999),
    [anon_sym_private] = ACTIONS(3999),
    [anon_sym_protected] = ACTIONS(3999),
    [anon_sym_using] = ACTIONS(3999),
    [anon_sym_static_assert] = ACTIONS(3999),
  },
  [2615] = {
    [sym_identifier] = ACTIONS(3439),
    [aux_sym_preproc_def_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token2] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3439),
    [sym_preproc_directive] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3439),
    [anon_sym___extension__] = ACTIONS(3439),
    [anon_sym_typedef] = ACTIONS(3439),
    [anon_sym_extern] = ACTIONS(3439),
    [anon_sym___attribute__] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3441),
    [anon_sym___declspec] = ACTIONS(3439),
    [anon_sym___based] = ACTIONS(3439),
    [anon_sym_signed] = ACTIONS(3439),
    [anon_sym_unsigned] = ACTIONS(3439),
    [anon_sym_long] = ACTIONS(3439),
    [anon_sym_short] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_register] = ACTIONS(3439),
    [anon_sym_inline] = ACTIONS(3439),
    [anon_sym___inline] = ACTIONS(3439),
    [anon_sym___inline__] = ACTIONS(3439),
    [anon_sym___forceinline] = ACTIONS(3439),
    [anon_sym_thread_local] = ACTIONS(3439),
    [anon_sym___thread] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_constexpr] = ACTIONS(3439),
    [anon_sym_volatile] = ACTIONS(3439),
    [anon_sym_restrict] = ACTIONS(3439),
    [anon_sym___restrict__] = ACTIONS(3439),
    [anon_sym__Atomic] = ACTIONS(3439),
    [anon_sym__Noreturn] = ACTIONS(3439),
    [anon_sym_noreturn] = ACTIONS(3439),
    [anon_sym_mutable] = ACTIONS(3439),
    [anon_sym_constinit] = ACTIONS(3439),
    [anon_sym_consteval] = ACTIONS(3439),
    [anon_sym_PROGMEM] = ACTIONS(3439),
    [aux_sym_primitive_type_token1] = ACTIONS(3439),
    [anon_sym_byte] = ACTIONS(3439),
    [anon_sym_word] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_struct] = ACTIONS(3439),
    [anon_sym_union] = ACTIONS(3439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3439),
    [anon_sym_decltype] = ACTIONS(3439),
    [anon_sym_virtual] = ACTIONS(3439),
    [anon_sym_alignas] = ACTIONS(3439),
    [anon_sym_explicit] = ACTIONS(3439),
    [anon_sym_typename] = ACTIONS(3439),
    [anon_sym_template] = ACTIONS(3439),
    [anon_sym_operator] = ACTIONS(3439),
    [anon_sym_friend] = ACTIONS(3439),
    [anon_sym_public] = ACTIONS(3439),
    [anon_sym_private] = ACTIONS(3439),
    [anon_sym_protected] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_static_assert] = ACTIONS(3439),
  },
  [2616] = {
    [sym_string_literal] = STATE(2645),
    [sym_raw_string_literal] = STATE(2645),
    [aux_sym_concatenated_string_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(5984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5387),
    [anon_sym_COMMA] = ACTIONS(5387),
    [anon_sym_RPAREN] = ACTIONS(5387),
    [anon_sym_LPAREN2] = ACTIONS(5387),
    [anon_sym_DASH] = ACTIONS(5389),
    [anon_sym_PLUS] = ACTIONS(5389),
    [anon_sym_STAR] = ACTIONS(5389),
    [anon_sym_SLASH] = ACTIONS(5389),
    [anon_sym_PERCENT] = ACTIONS(5389),
    [anon_sym_PIPE_PIPE] = ACTIONS(5387),
    [anon_sym_AMP_AMP] = ACTIONS(5387),
    [anon_sym_PIPE] = ACTIONS(5389),
    [anon_sym_CARET] = ACTIONS(5389),
    [anon_sym_AMP] = ACTIONS(5389),
    [anon_sym_EQ_EQ] = ACTIONS(5387),
    [anon_sym_BANG_EQ] = ACTIONS(5387),
    [anon_sym_GT] = ACTIONS(5389),
    [anon_sym_GT_EQ] = ACTIONS(5387),
    [anon_sym_LT_EQ] = ACTIONS(5389),
    [anon_sym_LT] = ACTIONS(5389),
    [anon_sym_LT_LT] = ACTIONS(5389),
    [anon_sym_GT_GT] = ACTIONS(5389),
    [anon_sym_LBRACK] = ACTIONS(5387),
    [anon_sym_EQ] = ACTIONS(5389),
    [anon_sym_QMARK] = ACTIONS(5387),
    [anon_sym_STAR_EQ] = ACTIONS(5387),
    [anon_sym_SLASH_EQ] = ACTIONS(5387),
    [anon_sym_PERCENT_EQ] = ACTIONS(5387),
    [anon_sym_PLUS_EQ] = ACTIONS(5387),
    [anon_sym_DASH_EQ] = ACTIONS(5387),
    [anon_sym_LT_LT_EQ] = ACTIONS(5387),
    [anon_sym_GT_GT_EQ] = ACTIONS(5387),
    [anon_sym_AMP_EQ] = ACTIONS(5387),
    [anon_sym_CARET_EQ] = ACTIONS(5387),
    [anon_sym_PIPE_EQ] = ACTIONS(5387),
    [anon_sym_and_eq] = ACTIONS(5389),
    [anon_sym_or_eq] = ACTIONS(5389),
    [anon_sym_xor_eq] = ACTIONS(5389),
    [anon_sym_LT_EQ_GT] = ACTIONS(5387),
    [anon_sym_or] = ACTIONS(5389),
    [anon_sym_and] = ACTIONS(5389),
    [anon_sym_bitor] = ACTIONS(5389),
    [anon_sym_xor] = ACTIONS(5389),
    [anon_sym_bitand] = ACTIONS(5389),
    [anon_sym_not_eq] = ACTIONS(5389),
    [anon_sym_DASH_DASH] = ACTIONS(5387),
    [anon_sym_PLUS_PLUS] = ACTIONS(5387),
    [anon_sym_DOT] = ACTIONS(5389),
    [anon_sym_DOT_STAR] = ACTIONS(5387),
    [anon_sym_DASH_GT] = ACTIONS(5389),
    [anon_sym_L_DQUOTE] = ACTIONS(5184),
    [anon_sym_u_DQUOTE] = ACTIONS(5184),
    [anon_sym_U_DQUOTE] = ACTIONS(5184),
    [anon_sym_u8_DQUOTE] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5186),
    [anon_sym_LR_DQUOTE] = ACTIONS(5186),
    [anon_sym_uR_DQUOTE] = ACTIONS(5186),
    [anon_sym_UR_DQUOTE] = ACTIONS(5186),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5186),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5387),
    [sym_literal_suffix] = ACTIONS(5389),
  },
  [2617] = {
    [sym_identifier] = ACTIONS(3455),
    [aux_sym_preproc_def_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token1] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3455),
    [sym_preproc_directive] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3457),
    [anon_sym_STAR] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym___extension__] = ACTIONS(3455),
    [anon_sym_typedef] = ACTIONS(3455),
    [anon_sym_extern] = ACTIONS(3455),
    [anon_sym___attribute__] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3457),
    [anon_sym___declspec] = ACTIONS(3455),
    [anon_sym___based] = ACTIONS(3455),
    [anon_sym_RBRACE] = ACTIONS(3457),
    [anon_sym_signed] = ACTIONS(3455),
    [anon_sym_unsigned] = ACTIONS(3455),
    [anon_sym_long] = ACTIONS(3455),
    [anon_sym_short] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_static] = ACTIONS(3455),
    [anon_sym_register] = ACTIONS(3455),
    [anon_sym_inline] = ACTIONS(3455),
    [anon_sym___inline] = ACTIONS(3455),
    [anon_sym___inline__] = ACTIONS(3455),
    [anon_sym___forceinline] = ACTIONS(3455),
    [anon_sym_thread_local] = ACTIONS(3455),
    [anon_sym___thread] = ACTIONS(3455),
    [anon_sym_const] = ACTIONS(3455),
    [anon_sym_constexpr] = ACTIONS(3455),
    [anon_sym_volatile] = ACTIONS(3455),
    [anon_sym_restrict] = ACTIONS(3455),
    [anon_sym___restrict__] = ACTIONS(3455),
    [anon_sym__Atomic] = ACTIONS(3455),
    [anon_sym__Noreturn] = ACTIONS(3455),
    [anon_sym_noreturn] = ACTIONS(3455),
    [anon_sym_mutable] = ACTIONS(3455),
    [anon_sym_constinit] = ACTIONS(3455),
    [anon_sym_consteval] = ACTIONS(3455),
    [anon_sym_PROGMEM] = ACTIONS(3455),
    [aux_sym_primitive_type_token1] = ACTIONS(3455),
    [anon_sym_byte] = ACTIONS(3455),
    [anon_sym_word] = ACTIONS(3455),
    [anon_sym_enum] = ACTIONS(3455),
    [anon_sym_class] = ACTIONS(3455),
    [anon_sym_struct] = ACTIONS(3455),
    [anon_sym_union] = ACTIONS(3455),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3455),
    [anon_sym_decltype] = ACTIONS(3455),
    [anon_sym_virtual] = ACTIONS(3455),
    [anon_sym_alignas] = ACTIONS(3455),
    [anon_sym_explicit] = ACTIONS(3455),
    [anon_sym_typename] = ACTIONS(3455),
    [anon_sym_template] = ACTIONS(3455),
    [anon_sym_operator] = ACTIONS(3455),
    [anon_sym_friend] = ACTIONS(3455),
    [anon_sym_public] = ACTIONS(3455),
    [anon_sym_private] = ACTIONS(3455),
    [anon_sym_protected] = ACTIONS(3455),
    [anon_sym_using] = ACTIONS(3455),
    [anon_sym_static_assert] = ACTIONS(3455),
  },
  [2618] = {
    [sym_identifier] = ACTIONS(5574),
    [aux_sym_preproc_def_token1] = ACTIONS(5574),
    [aux_sym_preproc_if_token1] = ACTIONS(5574),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5574),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5574),
    [sym_preproc_directive] = ACTIONS(5574),
    [anon_sym_LPAREN2] = ACTIONS(5576),
    [anon_sym_TILDE] = ACTIONS(5576),
    [anon_sym_STAR] = ACTIONS(5576),
    [anon_sym_AMP_AMP] = ACTIONS(5576),
    [anon_sym_AMP] = ACTIONS(5574),
    [anon_sym___extension__] = ACTIONS(5574),
    [anon_sym_typedef] = ACTIONS(5574),
    [anon_sym_extern] = ACTIONS(5574),
    [anon_sym___attribute__] = ACTIONS(5574),
    [anon_sym_COLON_COLON] = ACTIONS(5576),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5576),
    [anon_sym___declspec] = ACTIONS(5574),
    [anon_sym___based] = ACTIONS(5574),
    [anon_sym_RBRACE] = ACTIONS(5576),
    [anon_sym_signed] = ACTIONS(5574),
    [anon_sym_unsigned] = ACTIONS(5574),
    [anon_sym_long] = ACTIONS(5574),
    [anon_sym_short] = ACTIONS(5574),
    [anon_sym_LBRACK] = ACTIONS(5574),
    [anon_sym_static] = ACTIONS(5574),
    [anon_sym_register] = ACTIONS(5574),
    [anon_sym_inline] = ACTIONS(5574),
    [anon_sym___inline] = ACTIONS(5574),
    [anon_sym___inline__] = ACTIONS(5574),
    [anon_sym___forceinline] = ACTIONS(5574),
    [anon_sym_thread_local] = ACTIONS(5574),
    [anon_sym___thread] = ACTIONS(5574),
    [anon_sym_const] = ACTIONS(5574),
    [anon_sym_constexpr] = ACTIONS(5574),
    [anon_sym_volatile] = ACTIONS(5574),
    [anon_sym_restrict] = ACTIONS(5574),
    [anon_sym___restrict__] = ACTIONS(5574),
    [anon_sym__Atomic] = ACTIONS(5574),
    [anon_sym__Noreturn] = ACTIONS(5574),
    [anon_sym_noreturn] = ACTIONS(5574),
    [anon_sym_mutable] = ACTIONS(5574),
    [anon_sym_constinit] = ACTIONS(5574),
    [anon_sym_consteval] = ACTIONS(5574),
    [anon_sym_PROGMEM] = ACTIONS(5574),
    [aux_sym_primitive_type_token1] = ACTIONS(5574),
    [anon_sym_byte] = ACTIONS(5574),
    [anon_sym_word] = ACTIONS(5574),
    [anon_sym_enum] = ACTIONS(5574),
    [anon_sym_class] = ACTIONS(5574),
    [anon_sym_struct] = ACTIONS(5574),
    [anon_sym_union] = ACTIONS(5574),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5574),
    [anon_sym_decltype] = ACTIONS(5574),
    [anon_sym_virtual] = ACTIONS(5574),
    [anon_sym_alignas] = ACTIONS(5574),
    [anon_sym_explicit] = ACTIONS(5574),
    [anon_sym_typename] = ACTIONS(5574),
    [anon_sym_template] = ACTIONS(5574),
    [anon_sym_operator] = ACTIONS(5574),
    [anon_sym_friend] = ACTIONS(5574),
    [anon_sym_public] = ACTIONS(5574),
    [anon_sym_private] = ACTIONS(5574),
    [anon_sym_protected] = ACTIONS(5574),
    [anon_sym_using] = ACTIONS(5574),
    [anon_sym_static_assert] = ACTIONS(5574),
  },
  [2619] = {
    [sym_identifier] = ACTIONS(2970),
    [aux_sym_preproc_def_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token2] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2970),
    [sym_preproc_directive] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym___extension__] = ACTIONS(2970),
    [anon_sym_typedef] = ACTIONS(2970),
    [anon_sym_extern] = ACTIONS(2970),
    [anon_sym___attribute__] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2970),
    [anon_sym___based] = ACTIONS(2970),
    [anon_sym_signed] = ACTIONS(2970),
    [anon_sym_unsigned] = ACTIONS(2970),
    [anon_sym_long] = ACTIONS(2970),
    [anon_sym_short] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_register] = ACTIONS(2970),
    [anon_sym_inline] = ACTIONS(2970),
    [anon_sym___inline] = ACTIONS(2970),
    [anon_sym___inline__] = ACTIONS(2970),
    [anon_sym___forceinline] = ACTIONS(2970),
    [anon_sym_thread_local] = ACTIONS(2970),
    [anon_sym___thread] = ACTIONS(2970),
    [anon_sym_const] = ACTIONS(2970),
    [anon_sym_constexpr] = ACTIONS(2970),
    [anon_sym_volatile] = ACTIONS(2970),
    [anon_sym_restrict] = ACTIONS(2970),
    [anon_sym___restrict__] = ACTIONS(2970),
    [anon_sym__Atomic] = ACTIONS(2970),
    [anon_sym__Noreturn] = ACTIONS(2970),
    [anon_sym_noreturn] = ACTIONS(2970),
    [anon_sym_mutable] = ACTIONS(2970),
    [anon_sym_constinit] = ACTIONS(2970),
    [anon_sym_consteval] = ACTIONS(2970),
    [anon_sym_PROGMEM] = ACTIONS(2970),
    [aux_sym_primitive_type_token1] = ACTIONS(2970),
    [anon_sym_byte] = ACTIONS(2970),
    [anon_sym_word] = ACTIONS(2970),
    [anon_sym_enum] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_struct] = ACTIONS(2970),
    [anon_sym_union] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2970),
    [anon_sym_decltype] = ACTIONS(2970),
    [anon_sym_virtual] = ACTIONS(2970),
    [anon_sym_alignas] = ACTIONS(2970),
    [anon_sym_explicit] = ACTIONS(2970),
    [anon_sym_typename] = ACTIONS(2970),
    [anon_sym_template] = ACTIONS(2970),
    [anon_sym_operator] = ACTIONS(2970),
    [anon_sym_friend] = ACTIONS(2970),
    [anon_sym_public] = ACTIONS(2970),
    [anon_sym_private] = ACTIONS(2970),
    [anon_sym_protected] = ACTIONS(2970),
    [anon_sym_using] = ACTIONS(2970),
    [anon_sym_static_assert] = ACTIONS(2970),
  },
  [2620] = {
    [sym_identifier] = ACTIONS(3451),
    [aux_sym_preproc_def_token1] = ACTIONS(3451),
    [aux_sym_preproc_if_token1] = ACTIONS(3451),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3451),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3451),
    [sym_preproc_directive] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3453),
    [anon_sym_TILDE] = ACTIONS(3453),
    [anon_sym_STAR] = ACTIONS(3453),
    [anon_sym_AMP_AMP] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym___extension__] = ACTIONS(3451),
    [anon_sym_typedef] = ACTIONS(3451),
    [anon_sym_extern] = ACTIONS(3451),
    [anon_sym___attribute__] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3453),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3453),
    [anon_sym___declspec] = ACTIONS(3451),
    [anon_sym___based] = ACTIONS(3451),
    [anon_sym_RBRACE] = ACTIONS(3453),
    [anon_sym_signed] = ACTIONS(3451),
    [anon_sym_unsigned] = ACTIONS(3451),
    [anon_sym_long] = ACTIONS(3451),
    [anon_sym_short] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_register] = ACTIONS(3451),
    [anon_sym_inline] = ACTIONS(3451),
    [anon_sym___inline] = ACTIONS(3451),
    [anon_sym___inline__] = ACTIONS(3451),
    [anon_sym___forceinline] = ACTIONS(3451),
    [anon_sym_thread_local] = ACTIONS(3451),
    [anon_sym___thread] = ACTIONS(3451),
    [anon_sym_const] = ACTIONS(3451),
    [anon_sym_constexpr] = ACTIONS(3451),
    [anon_sym_volatile] = ACTIONS(3451),
    [anon_sym_restrict] = ACTIONS(3451),
    [anon_sym___restrict__] = ACTIONS(3451),
    [anon_sym__Atomic] = ACTIONS(3451),
    [anon_sym__Noreturn] = ACTIONS(3451),
    [anon_sym_noreturn] = ACTIONS(3451),
    [anon_sym_mutable] = ACTIONS(3451),
    [anon_sym_constinit] = ACTIONS(3451),
    [anon_sym_consteval] = ACTIONS(3451),
    [anon_sym_PROGMEM] = ACTIONS(3451),
    [aux_sym_primitive_type_token1] = ACTIONS(3451),
    [anon_sym_byte] = ACTIONS(3451),
    [anon_sym_word] = ACTIONS(3451),
    [anon_sym_enum] = ACTIONS(3451),
    [anon_sym_class] = ACTIONS(3451),
    [anon_sym_struct] = ACTIONS(3451),
    [anon_sym_union] = ACTIONS(3451),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3451),
    [anon_sym_decltype] = ACTIONS(3451),
    [anon_sym_virtual] = ACTIONS(3451),
    [anon_sym_alignas] = ACTIONS(3451),
    [anon_sym_explicit] = ACTIONS(3451),
    [anon_sym_typename] = ACTIONS(3451),
    [anon_sym_template] = ACTIONS(3451),
    [anon_sym_operator] = ACTIONS(3451),
    [anon_sym_friend] = ACTIONS(3451),
    [anon_sym_public] = ACTIONS(3451),
    [anon_sym_private] = ACTIONS(3451),
    [anon_sym_protected] = ACTIONS(3451),
    [anon_sym_using] = ACTIONS(3451),
    [anon_sym_static_assert] = ACTIONS(3451),
  },
  [2621] = {
    [sym_identifier] = ACTIONS(3314),
    [aux_sym_preproc_def_token1] = ACTIONS(3314),
    [aux_sym_preproc_if_token1] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3314),
    [sym_preproc_directive] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_STAR] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym___extension__] = ACTIONS(3314),
    [anon_sym_typedef] = ACTIONS(3314),
    [anon_sym_extern] = ACTIONS(3314),
    [anon_sym___attribute__] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3316),
    [anon_sym___declspec] = ACTIONS(3314),
    [anon_sym___based] = ACTIONS(3314),
    [anon_sym_RBRACE] = ACTIONS(3316),
    [anon_sym_signed] = ACTIONS(3314),
    [anon_sym_unsigned] = ACTIONS(3314),
    [anon_sym_long] = ACTIONS(3314),
    [anon_sym_short] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_static] = ACTIONS(3314),
    [anon_sym_register] = ACTIONS(3314),
    [anon_sym_inline] = ACTIONS(3314),
    [anon_sym___inline] = ACTIONS(3314),
    [anon_sym___inline__] = ACTIONS(3314),
    [anon_sym___forceinline] = ACTIONS(3314),
    [anon_sym_thread_local] = ACTIONS(3314),
    [anon_sym___thread] = ACTIONS(3314),
    [anon_sym_const] = ACTIONS(3314),
    [anon_sym_constexpr] = ACTIONS(3314),
    [anon_sym_volatile] = ACTIONS(3314),
    [anon_sym_restrict] = ACTIONS(3314),
    [anon_sym___restrict__] = ACTIONS(3314),
    [anon_sym__Atomic] = ACTIONS(3314),
    [anon_sym__Noreturn] = ACTIONS(3314),
    [anon_sym_noreturn] = ACTIONS(3314),
    [anon_sym_mutable] = ACTIONS(3314),
    [anon_sym_constinit] = ACTIONS(3314),
    [anon_sym_consteval] = ACTIONS(3314),
    [anon_sym_PROGMEM] = ACTIONS(3314),
    [aux_sym_primitive_type_token1] = ACTIONS(3314),
    [anon_sym_byte] = ACTIONS(3314),
    [anon_sym_word] = ACTIONS(3314),
    [anon_sym_enum] = ACTIONS(3314),
    [anon_sym_class] = ACTIONS(3314),
    [anon_sym_struct] = ACTIONS(3314),
    [anon_sym_union] = ACTIONS(3314),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3314),
    [anon_sym_decltype] = ACTIONS(3314),
    [anon_sym_virtual] = ACTIONS(3314),
    [anon_sym_alignas] = ACTIONS(3314),
    [anon_sym_explicit] = ACTIONS(3314),
    [anon_sym_typename] = ACTIONS(3314),
    [anon_sym_template] = ACTIONS(3314),
    [anon_sym_operator] = ACTIONS(3314),
    [anon_sym_friend] = ACTIONS(3314),
    [anon_sym_public] = ACTIONS(3314),
    [anon_sym_private] = ACTIONS(3314),
    [anon_sym_protected] = ACTIONS(3314),
    [anon_sym_using] = ACTIONS(3314),
    [anon_sym_static_assert] = ACTIONS(3314),
  },
  [2622] = {
    [sym_identifier] = ACTIONS(5578),
    [aux_sym_preproc_def_token1] = ACTIONS(5578),
    [aux_sym_preproc_if_token1] = ACTIONS(5578),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5578),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5578),
    [sym_preproc_directive] = ACTIONS(5578),
    [anon_sym_LPAREN2] = ACTIONS(5580),
    [anon_sym_TILDE] = ACTIONS(5580),
    [anon_sym_STAR] = ACTIONS(5580),
    [anon_sym_AMP_AMP] = ACTIONS(5580),
    [anon_sym_AMP] = ACTIONS(5578),
    [anon_sym___extension__] = ACTIONS(5578),
    [anon_sym_typedef] = ACTIONS(5578),
    [anon_sym_extern] = ACTIONS(5578),
    [anon_sym___attribute__] = ACTIONS(5578),
    [anon_sym_COLON_COLON] = ACTIONS(5580),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5580),
    [anon_sym___declspec] = ACTIONS(5578),
    [anon_sym___based] = ACTIONS(5578),
    [anon_sym_RBRACE] = ACTIONS(5580),
    [anon_sym_signed] = ACTIONS(5578),
    [anon_sym_unsigned] = ACTIONS(5578),
    [anon_sym_long] = ACTIONS(5578),
    [anon_sym_short] = ACTIONS(5578),
    [anon_sym_LBRACK] = ACTIONS(5578),
    [anon_sym_static] = ACTIONS(5578),
    [anon_sym_register] = ACTIONS(5578),
    [anon_sym_inline] = ACTIONS(5578),
    [anon_sym___inline] = ACTIONS(5578),
    [anon_sym___inline__] = ACTIONS(5578),
    [anon_sym___forceinline] = ACTIONS(5578),
    [anon_sym_thread_local] = ACTIONS(5578),
    [anon_sym___thread] = ACTIONS(5578),
    [anon_sym_const] = ACTIONS(5578),
    [anon_sym_constexpr] = ACTIONS(5578),
    [anon_sym_volatile] = ACTIONS(5578),
    [anon_sym_restrict] = ACTIONS(5578),
    [anon_sym___restrict__] = ACTIONS(5578),
    [anon_sym__Atomic] = ACTIONS(5578),
    [anon_sym__Noreturn] = ACTIONS(5578),
    [anon_sym_noreturn] = ACTIONS(5578),
    [anon_sym_mutable] = ACTIONS(5578),
    [anon_sym_constinit] = ACTIONS(5578),
    [anon_sym_consteval] = ACTIONS(5578),
    [anon_sym_PROGMEM] = ACTIONS(5578),
    [aux_sym_primitive_type_token1] = ACTIONS(5578),
    [anon_sym_byte] = ACTIONS(5578),
    [anon_sym_word] = ACTIONS(5578),
    [anon_sym_enum] = ACTIONS(5578),
    [anon_sym_class] = ACTIONS(5578),
    [anon_sym_struct] = ACTIONS(5578),
    [anon_sym_union] = ACTIONS(5578),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5578),
    [anon_sym_decltype] = ACTIONS(5578),
    [anon_sym_virtual] = ACTIONS(5578),
    [anon_sym_alignas] = ACTIONS(5578),
    [anon_sym_explicit] = ACTIONS(5578),
    [anon_sym_typename] = ACTIONS(5578),
    [anon_sym_template] = ACTIONS(5578),
    [anon_sym_operator] = ACTIONS(5578),
    [anon_sym_friend] = ACTIONS(5578),
    [anon_sym_public] = ACTIONS(5578),
    [anon_sym_private] = ACTIONS(5578),
    [anon_sym_protected] = ACTIONS(5578),
    [anon_sym_using] = ACTIONS(5578),
    [anon_sym_static_assert] = ACTIONS(5578),
  },
  [2623] = {
    [sym_identifier] = ACTIONS(3447),
    [aux_sym_preproc_def_token1] = ACTIONS(3447),
    [aux_sym_preproc_if_token1] = ACTIONS(3447),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3447),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3447),
    [sym_preproc_directive] = ACTIONS(3447),
    [anon_sym_LPAREN2] = ACTIONS(3449),
    [anon_sym_TILDE] = ACTIONS(3449),
    [anon_sym_STAR] = ACTIONS(3449),
    [anon_sym_AMP_AMP] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3447),
    [anon_sym___extension__] = ACTIONS(3447),
    [anon_sym_typedef] = ACTIONS(3447),
    [anon_sym_extern] = ACTIONS(3447),
    [anon_sym___attribute__] = ACTIONS(3447),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3449),
    [anon_sym___declspec] = ACTIONS(3447),
    [anon_sym___based] = ACTIONS(3447),
    [anon_sym_RBRACE] = ACTIONS(3449),
    [anon_sym_signed] = ACTIONS(3447),
    [anon_sym_unsigned] = ACTIONS(3447),
    [anon_sym_long] = ACTIONS(3447),
    [anon_sym_short] = ACTIONS(3447),
    [anon_sym_LBRACK] = ACTIONS(3447),
    [anon_sym_static] = ACTIONS(3447),
    [anon_sym_register] = ACTIONS(3447),
    [anon_sym_inline] = ACTIONS(3447),
    [anon_sym___inline] = ACTIONS(3447),
    [anon_sym___inline__] = ACTIONS(3447),
    [anon_sym___forceinline] = ACTIONS(3447),
    [anon_sym_thread_local] = ACTIONS(3447),
    [anon_sym___thread] = ACTIONS(3447),
    [anon_sym_const] = ACTIONS(3447),
    [anon_sym_constexpr] = ACTIONS(3447),
    [anon_sym_volatile] = ACTIONS(3447),
    [anon_sym_restrict] = ACTIONS(3447),
    [anon_sym___restrict__] = ACTIONS(3447),
    [anon_sym__Atomic] = ACTIONS(3447),
    [anon_sym__Noreturn] = ACTIONS(3447),
    [anon_sym_noreturn] = ACTIONS(3447),
    [anon_sym_mutable] = ACTIONS(3447),
    [anon_sym_constinit] = ACTIONS(3447),
    [anon_sym_consteval] = ACTIONS(3447),
    [anon_sym_PROGMEM] = ACTIONS(3447),
    [aux_sym_primitive_type_token1] = ACTIONS(3447),
    [anon_sym_byte] = ACTIONS(3447),
    [anon_sym_word] = ACTIONS(3447),
    [anon_sym_enum] = ACTIONS(3447),
    [anon_sym_class] = ACTIONS(3447),
    [anon_sym_struct] = ACTIONS(3447),
    [anon_sym_union] = ACTIONS(3447),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3447),
    [anon_sym_decltype] = ACTIONS(3447),
    [anon_sym_virtual] = ACTIONS(3447),
    [anon_sym_alignas] = ACTIONS(3447),
    [anon_sym_explicit] = ACTIONS(3447),
    [anon_sym_typename] = ACTIONS(3447),
    [anon_sym_template] = ACTIONS(3447),
    [anon_sym_operator] = ACTIONS(3447),
    [anon_sym_friend] = ACTIONS(3447),
    [anon_sym_public] = ACTIONS(3447),
    [anon_sym_private] = ACTIONS(3447),
    [anon_sym_protected] = ACTIONS(3447),
    [anon_sym_using] = ACTIONS(3447),
    [anon_sym_static_assert] = ACTIONS(3447),
  },
  [2624] = {
    [sym_identifier] = ACTIONS(5614),
    [aux_sym_preproc_def_token1] = ACTIONS(5614),
    [aux_sym_preproc_if_token1] = ACTIONS(5614),
    [aux_sym_preproc_if_token2] = ACTIONS(5614),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5614),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5614),
    [sym_preproc_directive] = ACTIONS(5614),
    [anon_sym_LPAREN2] = ACTIONS(5616),
    [anon_sym_TILDE] = ACTIONS(5616),
    [anon_sym_STAR] = ACTIONS(5616),
    [anon_sym_AMP_AMP] = ACTIONS(5616),
    [anon_sym_AMP] = ACTIONS(5614),
    [anon_sym___extension__] = ACTIONS(5614),
    [anon_sym_typedef] = ACTIONS(5614),
    [anon_sym_extern] = ACTIONS(5614),
    [anon_sym___attribute__] = ACTIONS(5614),
    [anon_sym_COLON_COLON] = ACTIONS(5616),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5616),
    [anon_sym___declspec] = ACTIONS(5614),
    [anon_sym___based] = ACTIONS(5614),
    [anon_sym_signed] = ACTIONS(5614),
    [anon_sym_unsigned] = ACTIONS(5614),
    [anon_sym_long] = ACTIONS(5614),
    [anon_sym_short] = ACTIONS(5614),
    [anon_sym_LBRACK] = ACTIONS(5614),
    [anon_sym_static] = ACTIONS(5614),
    [anon_sym_register] = ACTIONS(5614),
    [anon_sym_inline] = ACTIONS(5614),
    [anon_sym___inline] = ACTIONS(5614),
    [anon_sym___inline__] = ACTIONS(5614),
    [anon_sym___forceinline] = ACTIONS(5614),
    [anon_sym_thread_local] = ACTIONS(5614),
    [anon_sym___thread] = ACTIONS(5614),
    [anon_sym_const] = ACTIONS(5614),
    [anon_sym_constexpr] = ACTIONS(5614),
    [anon_sym_volatile] = ACTIONS(5614),
    [anon_sym_restrict] = ACTIONS(5614),
    [anon_sym___restrict__] = ACTIONS(5614),
    [anon_sym__Atomic] = ACTIONS(5614),
    [anon_sym__Noreturn] = ACTIONS(5614),
    [anon_sym_noreturn] = ACTIONS(5614),
    [anon_sym_mutable] = ACTIONS(5614),
    [anon_sym_constinit] = ACTIONS(5614),
    [anon_sym_consteval] = ACTIONS(5614),
    [anon_sym_PROGMEM] = ACTIONS(5614),
    [aux_sym_primitive_type_token1] = ACTIONS(5614),
    [anon_sym_byte] = ACTIONS(5614),
    [anon_sym_word] = ACTIONS(5614),
    [anon_sym_enum] = ACTIONS(5614),
    [anon_sym_class] = ACTIONS(5614),
    [anon_sym_struct] = ACTIONS(5614),
    [anon_sym_union] = ACTIONS(5614),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5614),
    [anon_sym_decltype] = ACTIONS(5614),
    [anon_sym_virtual] = ACTIONS(5614),
    [anon_sym_alignas] = ACTIONS(5614),
    [anon_sym_explicit] = ACTIONS(5614),
    [anon_sym_typename] = ACTIONS(5614),
    [anon_sym_template] = ACTIONS(5614),
    [anon_sym_operator] = ACTIONS(5614),
    [anon_sym_friend] = ACTIONS(5614),
    [anon_sym_public] = ACTIONS(5614),
    [anon_sym_private] = ACTIONS(5614),
    [anon_sym_protected] = ACTIONS(5614),
    [anon_sym_using] = ACTIONS(5614),
    [anon_sym_static_assert] = ACTIONS(5614),
  },
  [2625] = {
    [sym_identifier] = ACTIONS(5578),
    [aux_sym_preproc_def_token1] = ACTIONS(5578),
    [aux_sym_preproc_if_token1] = ACTIONS(5578),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5578),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5578),
    [sym_preproc_directive] = ACTIONS(5578),
    [anon_sym_LPAREN2] = ACTIONS(5580),
    [anon_sym_TILDE] = ACTIONS(5580),
    [anon_sym_STAR] = ACTIONS(5580),
    [anon_sym_AMP_AMP] = ACTIONS(5580),
    [anon_sym_AMP] = ACTIONS(5578),
    [anon_sym___extension__] = ACTIONS(5578),
    [anon_sym_typedef] = ACTIONS(5578),
    [anon_sym_extern] = ACTIONS(5578),
    [anon_sym___attribute__] = ACTIONS(5578),
    [anon_sym_COLON_COLON] = ACTIONS(5580),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5580),
    [anon_sym___declspec] = ACTIONS(5578),
    [anon_sym___based] = ACTIONS(5578),
    [anon_sym_RBRACE] = ACTIONS(5580),
    [anon_sym_signed] = ACTIONS(5578),
    [anon_sym_unsigned] = ACTIONS(5578),
    [anon_sym_long] = ACTIONS(5578),
    [anon_sym_short] = ACTIONS(5578),
    [anon_sym_LBRACK] = ACTIONS(5578),
    [anon_sym_static] = ACTIONS(5578),
    [anon_sym_register] = ACTIONS(5578),
    [anon_sym_inline] = ACTIONS(5578),
    [anon_sym___inline] = ACTIONS(5578),
    [anon_sym___inline__] = ACTIONS(5578),
    [anon_sym___forceinline] = ACTIONS(5578),
    [anon_sym_thread_local] = ACTIONS(5578),
    [anon_sym___thread] = ACTIONS(5578),
    [anon_sym_const] = ACTIONS(5578),
    [anon_sym_constexpr] = ACTIONS(5578),
    [anon_sym_volatile] = ACTIONS(5578),
    [anon_sym_restrict] = ACTIONS(5578),
    [anon_sym___restrict__] = ACTIONS(5578),
    [anon_sym__Atomic] = ACTIONS(5578),
    [anon_sym__Noreturn] = ACTIONS(5578),
    [anon_sym_noreturn] = ACTIONS(5578),
    [anon_sym_mutable] = ACTIONS(5578),
    [anon_sym_constinit] = ACTIONS(5578),
    [anon_sym_consteval] = ACTIONS(5578),
    [anon_sym_PROGMEM] = ACTIONS(5578),
    [aux_sym_primitive_type_token1] = ACTIONS(5578),
    [anon_sym_byte] = ACTIONS(5578),
    [anon_sym_word] = ACTIONS(5578),
    [anon_sym_enum] = ACTIONS(5578),
    [anon_sym_class] = ACTIONS(5578),
    [anon_sym_struct] = ACTIONS(5578),
    [anon_sym_union] = ACTIONS(5578),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5578),
    [anon_sym_decltype] = ACTIONS(5578),
    [anon_sym_virtual] = ACTIONS(5578),
    [anon_sym_alignas] = ACTIONS(5578),
    [anon_sym_explicit] = ACTIONS(5578),
    [anon_sym_typename] = ACTIONS(5578),
    [anon_sym_template] = ACTIONS(5578),
    [anon_sym_operator] = ACTIONS(5578),
    [anon_sym_friend] = ACTIONS(5578),
    [anon_sym_public] = ACTIONS(5578),
    [anon_sym_private] = ACTIONS(5578),
    [anon_sym_protected] = ACTIONS(5578),
    [anon_sym_using] = ACTIONS(5578),
    [anon_sym_static_assert] = ACTIONS(5578),
  },
  [2626] = {
    [sym_identifier] = ACTIONS(5594),
    [aux_sym_preproc_def_token1] = ACTIONS(5594),
    [aux_sym_preproc_if_token1] = ACTIONS(5594),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5594),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5594),
    [sym_preproc_directive] = ACTIONS(5594),
    [anon_sym_LPAREN2] = ACTIONS(5596),
    [anon_sym_TILDE] = ACTIONS(5596),
    [anon_sym_STAR] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5594),
    [anon_sym___extension__] = ACTIONS(5594),
    [anon_sym_typedef] = ACTIONS(5594),
    [anon_sym_extern] = ACTIONS(5594),
    [anon_sym___attribute__] = ACTIONS(5594),
    [anon_sym_COLON_COLON] = ACTIONS(5596),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5596),
    [anon_sym___declspec] = ACTIONS(5594),
    [anon_sym___based] = ACTIONS(5594),
    [anon_sym_RBRACE] = ACTIONS(5596),
    [anon_sym_signed] = ACTIONS(5594),
    [anon_sym_unsigned] = ACTIONS(5594),
    [anon_sym_long] = ACTIONS(5594),
    [anon_sym_short] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_static] = ACTIONS(5594),
    [anon_sym_register] = ACTIONS(5594),
    [anon_sym_inline] = ACTIONS(5594),
    [anon_sym___inline] = ACTIONS(5594),
    [anon_sym___inline__] = ACTIONS(5594),
    [anon_sym___forceinline] = ACTIONS(5594),
    [anon_sym_thread_local] = ACTIONS(5594),
    [anon_sym___thread] = ACTIONS(5594),
    [anon_sym_const] = ACTIONS(5594),
    [anon_sym_constexpr] = ACTIONS(5594),
    [anon_sym_volatile] = ACTIONS(5594),
    [anon_sym_restrict] = ACTIONS(5594),
    [anon_sym___restrict__] = ACTIONS(5594),
    [anon_sym__Atomic] = ACTIONS(5594),
    [anon_sym__Noreturn] = ACTIONS(5594),
    [anon_sym_noreturn] = ACTIONS(5594),
    [anon_sym_mutable] = ACTIONS(5594),
    [anon_sym_constinit] = ACTIONS(5594),
    [anon_sym_consteval] = ACTIONS(5594),
    [anon_sym_PROGMEM] = ACTIONS(5594),
    [aux_sym_primitive_type_token1] = ACTIONS(5594),
    [anon_sym_byte] = ACTIONS(5594),
    [anon_sym_word] = ACTIONS(5594),
    [anon_sym_enum] = ACTIONS(5594),
    [anon_sym_class] = ACTIONS(5594),
    [anon_sym_struct] = ACTIONS(5594),
    [anon_sym_union] = ACTIONS(5594),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5594),
    [anon_sym_decltype] = ACTIONS(5594),
    [anon_sym_virtual] = ACTIONS(5594),
    [anon_sym_alignas] = ACTIONS(5594),
    [anon_sym_explicit] = ACTIONS(5594),
    [anon_sym_typename] = ACTIONS(5594),
    [anon_sym_template] = ACTIONS(5594),
    [anon_sym_operator] = ACTIONS(5594),
    [anon_sym_friend] = ACTIONS(5594),
    [anon_sym_public] = ACTIONS(5594),
    [anon_sym_private] = ACTIONS(5594),
    [anon_sym_protected] = ACTIONS(5594),
    [anon_sym_using] = ACTIONS(5594),
    [anon_sym_static_assert] = ACTIONS(5594),
  },
  [2627] = {
    [sym_identifier] = ACTIONS(3310),
    [aux_sym_preproc_def_token1] = ACTIONS(3310),
    [aux_sym_preproc_if_token1] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3310),
    [sym_preproc_directive] = ACTIONS(3310),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_AMP_AMP] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3310),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_typedef] = ACTIONS(3310),
    [anon_sym_extern] = ACTIONS(3310),
    [anon_sym___attribute__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3312),
    [anon_sym___declspec] = ACTIONS(3310),
    [anon_sym___based] = ACTIONS(3310),
    [anon_sym_RBRACE] = ACTIONS(3312),
    [anon_sym_signed] = ACTIONS(3310),
    [anon_sym_unsigned] = ACTIONS(3310),
    [anon_sym_long] = ACTIONS(3310),
    [anon_sym_short] = ACTIONS(3310),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [anon_sym_static] = ACTIONS(3310),
    [anon_sym_register] = ACTIONS(3310),
    [anon_sym_inline] = ACTIONS(3310),
    [anon_sym___inline] = ACTIONS(3310),
    [anon_sym___inline__] = ACTIONS(3310),
    [anon_sym___forceinline] = ACTIONS(3310),
    [anon_sym_thread_local] = ACTIONS(3310),
    [anon_sym___thread] = ACTIONS(3310),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_constexpr] = ACTIONS(3310),
    [anon_sym_volatile] = ACTIONS(3310),
    [anon_sym_restrict] = ACTIONS(3310),
    [anon_sym___restrict__] = ACTIONS(3310),
    [anon_sym__Atomic] = ACTIONS(3310),
    [anon_sym__Noreturn] = ACTIONS(3310),
    [anon_sym_noreturn] = ACTIONS(3310),
    [anon_sym_mutable] = ACTIONS(3310),
    [anon_sym_constinit] = ACTIONS(3310),
    [anon_sym_consteval] = ACTIONS(3310),
    [anon_sym_PROGMEM] = ACTIONS(3310),
    [aux_sym_primitive_type_token1] = ACTIONS(3310),
    [anon_sym_byte] = ACTIONS(3310),
    [anon_sym_word] = ACTIONS(3310),
    [anon_sym_enum] = ACTIONS(3310),
    [anon_sym_class] = ACTIONS(3310),
    [anon_sym_struct] = ACTIONS(3310),
    [anon_sym_union] = ACTIONS(3310),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3310),
    [anon_sym_decltype] = ACTIONS(3310),
    [anon_sym_virtual] = ACTIONS(3310),
    [anon_sym_alignas] = ACTIONS(3310),
    [anon_sym_explicit] = ACTIONS(3310),
    [anon_sym_typename] = ACTIONS(3310),
    [anon_sym_template] = ACTIONS(3310),
    [anon_sym_operator] = ACTIONS(3310),
    [anon_sym_friend] = ACTIONS(3310),
    [anon_sym_public] = ACTIONS(3310),
    [anon_sym_private] = ACTIONS(3310),
    [anon_sym_protected] = ACTIONS(3310),
    [anon_sym_using] = ACTIONS(3310),
    [anon_sym_static_assert] = ACTIONS(3310),
  },
  [2628] = {
    [sym_identifier] = ACTIONS(5518),
    [aux_sym_preproc_def_token1] = ACTIONS(5518),
    [aux_sym_preproc_if_token1] = ACTIONS(5518),
    [aux_sym_preproc_if_token2] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5518),
    [sym_preproc_directive] = ACTIONS(5518),
    [anon_sym_LPAREN2] = ACTIONS(5520),
    [anon_sym_TILDE] = ACTIONS(5520),
    [anon_sym_STAR] = ACTIONS(5520),
    [anon_sym_AMP_AMP] = ACTIONS(5520),
    [anon_sym_AMP] = ACTIONS(5518),
    [anon_sym___extension__] = ACTIONS(5518),
    [anon_sym_typedef] = ACTIONS(5518),
    [anon_sym_extern] = ACTIONS(5518),
    [anon_sym___attribute__] = ACTIONS(5518),
    [anon_sym_COLON_COLON] = ACTIONS(5520),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5520),
    [anon_sym___declspec] = ACTIONS(5518),
    [anon_sym___based] = ACTIONS(5518),
    [anon_sym_signed] = ACTIONS(5518),
    [anon_sym_unsigned] = ACTIONS(5518),
    [anon_sym_long] = ACTIONS(5518),
    [anon_sym_short] = ACTIONS(5518),
    [anon_sym_LBRACK] = ACTIONS(5518),
    [anon_sym_static] = ACTIONS(5518),
    [anon_sym_register] = ACTIONS(5518),
    [anon_sym_inline] = ACTIONS(5518),
    [anon_sym___inline] = ACTIONS(5518),
    [anon_sym___inline__] = ACTIONS(5518),
    [anon_sym___forceinline] = ACTIONS(5518),
    [anon_sym_thread_local] = ACTIONS(5518),
    [anon_sym___thread] = ACTIONS(5518),
    [anon_sym_const] = ACTIONS(5518),
    [anon_sym_constexpr] = ACTIONS(5518),
    [anon_sym_volatile] = ACTIONS(5518),
    [anon_sym_restrict] = ACTIONS(5518),
    [anon_sym___restrict__] = ACTIONS(5518),
    [anon_sym__Atomic] = ACTIONS(5518),
    [anon_sym__Noreturn] = ACTIONS(5518),
    [anon_sym_noreturn] = ACTIONS(5518),
    [anon_sym_mutable] = ACTIONS(5518),
    [anon_sym_constinit] = ACTIONS(5518),
    [anon_sym_consteval] = ACTIONS(5518),
    [anon_sym_PROGMEM] = ACTIONS(5518),
    [aux_sym_primitive_type_token1] = ACTIONS(5518),
    [anon_sym_byte] = ACTIONS(5518),
    [anon_sym_word] = ACTIONS(5518),
    [anon_sym_enum] = ACTIONS(5518),
    [anon_sym_class] = ACTIONS(5518),
    [anon_sym_struct] = ACTIONS(5518),
    [anon_sym_union] = ACTIONS(5518),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5518),
    [anon_sym_decltype] = ACTIONS(5518),
    [anon_sym_virtual] = ACTIONS(5518),
    [anon_sym_alignas] = ACTIONS(5518),
    [anon_sym_explicit] = ACTIONS(5518),
    [anon_sym_typename] = ACTIONS(5518),
    [anon_sym_template] = ACTIONS(5518),
    [anon_sym_operator] = ACTIONS(5518),
    [anon_sym_friend] = ACTIONS(5518),
    [anon_sym_public] = ACTIONS(5518),
    [anon_sym_private] = ACTIONS(5518),
    [anon_sym_protected] = ACTIONS(5518),
    [anon_sym_using] = ACTIONS(5518),
    [anon_sym_static_assert] = ACTIONS(5518),
  },
  [2629] = {
    [sym_identifier] = ACTIONS(5614),
    [aux_sym_preproc_def_token1] = ACTIONS(5614),
    [aux_sym_preproc_if_token1] = ACTIONS(5614),
    [aux_sym_preproc_if_token2] = ACTIONS(5614),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5614),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5614),
    [sym_preproc_directive] = ACTIONS(5614),
    [anon_sym_LPAREN2] = ACTIONS(5616),
    [anon_sym_TILDE] = ACTIONS(5616),
    [anon_sym_STAR] = ACTIONS(5616),
    [anon_sym_AMP_AMP] = ACTIONS(5616),
    [anon_sym_AMP] = ACTIONS(5614),
    [anon_sym___extension__] = ACTIONS(5614),
    [anon_sym_typedef] = ACTIONS(5614),
    [anon_sym_extern] = ACTIONS(5614),
    [anon_sym___attribute__] = ACTIONS(5614),
    [anon_sym_COLON_COLON] = ACTIONS(5616),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5616),
    [anon_sym___declspec] = ACTIONS(5614),
    [anon_sym___based] = ACTIONS(5614),
    [anon_sym_signed] = ACTIONS(5614),
    [anon_sym_unsigned] = ACTIONS(5614),
    [anon_sym_long] = ACTIONS(5614),
    [anon_sym_short] = ACTIONS(5614),
    [anon_sym_LBRACK] = ACTIONS(5614),
    [anon_sym_static] = ACTIONS(5614),
    [anon_sym_register] = ACTIONS(5614),
    [anon_sym_inline] = ACTIONS(5614),
    [anon_sym___inline] = ACTIONS(5614),
    [anon_sym___inline__] = ACTIONS(5614),
    [anon_sym___forceinline] = ACTIONS(5614),
    [anon_sym_thread_local] = ACTIONS(5614),
    [anon_sym___thread] = ACTIONS(5614),
    [anon_sym_const] = ACTIONS(5614),
    [anon_sym_constexpr] = ACTIONS(5614),
    [anon_sym_volatile] = ACTIONS(5614),
    [anon_sym_restrict] = ACTIONS(5614),
    [anon_sym___restrict__] = ACTIONS(5614),
    [anon_sym__Atomic] = ACTIONS(5614),
    [anon_sym__Noreturn] = ACTIONS(5614),
    [anon_sym_noreturn] = ACTIONS(5614),
    [anon_sym_mutable] = ACTIONS(5614),
    [anon_sym_constinit] = ACTIONS(5614),
    [anon_sym_consteval] = ACTIONS(5614),
    [anon_sym_PROGMEM] = ACTIONS(5614),
    [aux_sym_primitive_type_token1] = ACTIONS(5614),
    [anon_sym_byte] = ACTIONS(5614),
    [anon_sym_word] = ACTIONS(5614),
    [anon_sym_enum] = ACTIONS(5614),
    [anon_sym_class] = ACTIONS(5614),
    [anon_sym_struct] = ACTIONS(5614),
    [anon_sym_union] = ACTIONS(5614),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5614),
    [anon_sym_decltype] = ACTIONS(5614),
    [anon_sym_virtual] = ACTIONS(5614),
    [anon_sym_alignas] = ACTIONS(5614),
    [anon_sym_explicit] = ACTIONS(5614),
    [anon_sym_typename] = ACTIONS(5614),
    [anon_sym_template] = ACTIONS(5614),
    [anon_sym_operator] = ACTIONS(5614),
    [anon_sym_friend] = ACTIONS(5614),
    [anon_sym_public] = ACTIONS(5614),
    [anon_sym_private] = ACTIONS(5614),
    [anon_sym_protected] = ACTIONS(5614),
    [anon_sym_using] = ACTIONS(5614),
    [anon_sym_static_assert] = ACTIONS(5614),
  },
  [2630] = {
    [sym_identifier] = ACTIONS(5610),
    [aux_sym_preproc_def_token1] = ACTIONS(5610),
    [aux_sym_preproc_if_token1] = ACTIONS(5610),
    [aux_sym_preproc_if_token2] = ACTIONS(5610),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5610),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5610),
    [sym_preproc_directive] = ACTIONS(5610),
    [anon_sym_LPAREN2] = ACTIONS(5612),
    [anon_sym_TILDE] = ACTIONS(5612),
    [anon_sym_STAR] = ACTIONS(5612),
    [anon_sym_AMP_AMP] = ACTIONS(5612),
    [anon_sym_AMP] = ACTIONS(5610),
    [anon_sym___extension__] = ACTIONS(5610),
    [anon_sym_typedef] = ACTIONS(5610),
    [anon_sym_extern] = ACTIONS(5610),
    [anon_sym___attribute__] = ACTIONS(5610),
    [anon_sym_COLON_COLON] = ACTIONS(5612),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5612),
    [anon_sym___declspec] = ACTIONS(5610),
    [anon_sym___based] = ACTIONS(5610),
    [anon_sym_signed] = ACTIONS(5610),
    [anon_sym_unsigned] = ACTIONS(5610),
    [anon_sym_long] = ACTIONS(5610),
    [anon_sym_short] = ACTIONS(5610),
    [anon_sym_LBRACK] = ACTIONS(5610),
    [anon_sym_static] = ACTIONS(5610),
    [anon_sym_register] = ACTIONS(5610),
    [anon_sym_inline] = ACTIONS(5610),
    [anon_sym___inline] = ACTIONS(5610),
    [anon_sym___inline__] = ACTIONS(5610),
    [anon_sym___forceinline] = ACTIONS(5610),
    [anon_sym_thread_local] = ACTIONS(5610),
    [anon_sym___thread] = ACTIONS(5610),
    [anon_sym_const] = ACTIONS(5610),
    [anon_sym_constexpr] = ACTIONS(5610),
    [anon_sym_volatile] = ACTIONS(5610),
    [anon_sym_restrict] = ACTIONS(5610),
    [anon_sym___restrict__] = ACTIONS(5610),
    [anon_sym__Atomic] = ACTIONS(5610),
    [anon_sym__Noreturn] = ACTIONS(5610),
    [anon_sym_noreturn] = ACTIONS(5610),
    [anon_sym_mutable] = ACTIONS(5610),
    [anon_sym_constinit] = ACTIONS(5610),
    [anon_sym_consteval] = ACTIONS(5610),
    [anon_sym_PROGMEM] = ACTIONS(5610),
    [aux_sym_primitive_type_token1] = ACTIONS(5610),
    [anon_sym_byte] = ACTIONS(5610),
    [anon_sym_word] = ACTIONS(5610),
    [anon_sym_enum] = ACTIONS(5610),
    [anon_sym_class] = ACTIONS(5610),
    [anon_sym_struct] = ACTIONS(5610),
    [anon_sym_union] = ACTIONS(5610),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5610),
    [anon_sym_decltype] = ACTIONS(5610),
    [anon_sym_virtual] = ACTIONS(5610),
    [anon_sym_alignas] = ACTIONS(5610),
    [anon_sym_explicit] = ACTIONS(5610),
    [anon_sym_typename] = ACTIONS(5610),
    [anon_sym_template] = ACTIONS(5610),
    [anon_sym_operator] = ACTIONS(5610),
    [anon_sym_friend] = ACTIONS(5610),
    [anon_sym_public] = ACTIONS(5610),
    [anon_sym_private] = ACTIONS(5610),
    [anon_sym_protected] = ACTIONS(5610),
    [anon_sym_using] = ACTIONS(5610),
    [anon_sym_static_assert] = ACTIONS(5610),
  },
  [2631] = {
    [sym_identifier] = ACTIONS(3521),
    [aux_sym_preproc_def_token1] = ACTIONS(3521),
    [aux_sym_preproc_if_token1] = ACTIONS(3521),
    [aux_sym_preproc_if_token2] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3521),
    [sym_preproc_directive] = ACTIONS(3521),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3521),
    [anon_sym___extension__] = ACTIONS(3521),
    [anon_sym_typedef] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym___attribute__] = ACTIONS(3521),
    [anon_sym_COLON_COLON] = ACTIONS(3523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3523),
    [anon_sym___declspec] = ACTIONS(3521),
    [anon_sym___based] = ACTIONS(3521),
    [anon_sym_signed] = ACTIONS(3521),
    [anon_sym_unsigned] = ACTIONS(3521),
    [anon_sym_long] = ACTIONS(3521),
    [anon_sym_short] = ACTIONS(3521),
    [anon_sym_LBRACK] = ACTIONS(3521),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_register] = ACTIONS(3521),
    [anon_sym_inline] = ACTIONS(3521),
    [anon_sym___inline] = ACTIONS(3521),
    [anon_sym___inline__] = ACTIONS(3521),
    [anon_sym___forceinline] = ACTIONS(3521),
    [anon_sym_thread_local] = ACTIONS(3521),
    [anon_sym___thread] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_constexpr] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym_restrict] = ACTIONS(3521),
    [anon_sym___restrict__] = ACTIONS(3521),
    [anon_sym__Atomic] = ACTIONS(3521),
    [anon_sym__Noreturn] = ACTIONS(3521),
    [anon_sym_noreturn] = ACTIONS(3521),
    [anon_sym_mutable] = ACTIONS(3521),
    [anon_sym_constinit] = ACTIONS(3521),
    [anon_sym_consteval] = ACTIONS(3521),
    [anon_sym_PROGMEM] = ACTIONS(3521),
    [aux_sym_primitive_type_token1] = ACTIONS(3521),
    [anon_sym_byte] = ACTIONS(3521),
    [anon_sym_word] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_class] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_union] = ACTIONS(3521),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3521),
    [anon_sym_decltype] = ACTIONS(3521),
    [anon_sym_virtual] = ACTIONS(3521),
    [anon_sym_alignas] = ACTIONS(3521),
    [anon_sym_explicit] = ACTIONS(3521),
    [anon_sym_typename] = ACTIONS(3521),
    [anon_sym_template] = ACTIONS(3521),
    [anon_sym_operator] = ACTIONS(3521),
    [anon_sym_friend] = ACTIONS(3521),
    [anon_sym_public] = ACTIONS(3521),
    [anon_sym_private] = ACTIONS(3521),
    [anon_sym_protected] = ACTIONS(3521),
    [anon_sym_using] = ACTIONS(3521),
    [anon_sym_static_assert] = ACTIONS(3521),
  },
  [2632] = {
    [sym_identifier] = ACTIONS(5594),
    [aux_sym_preproc_def_token1] = ACTIONS(5594),
    [aux_sym_preproc_if_token1] = ACTIONS(5594),
    [aux_sym_preproc_if_token2] = ACTIONS(5594),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5594),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5594),
    [sym_preproc_directive] = ACTIONS(5594),
    [anon_sym_LPAREN2] = ACTIONS(5596),
    [anon_sym_TILDE] = ACTIONS(5596),
    [anon_sym_STAR] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5594),
    [anon_sym___extension__] = ACTIONS(5594),
    [anon_sym_typedef] = ACTIONS(5594),
    [anon_sym_extern] = ACTIONS(5594),
    [anon_sym___attribute__] = ACTIONS(5594),
    [anon_sym_COLON_COLON] = ACTIONS(5596),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5596),
    [anon_sym___declspec] = ACTIONS(5594),
    [anon_sym___based] = ACTIONS(5594),
    [anon_sym_signed] = ACTIONS(5594),
    [anon_sym_unsigned] = ACTIONS(5594),
    [anon_sym_long] = ACTIONS(5594),
    [anon_sym_short] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_static] = ACTIONS(5594),
    [anon_sym_register] = ACTIONS(5594),
    [anon_sym_inline] = ACTIONS(5594),
    [anon_sym___inline] = ACTIONS(5594),
    [anon_sym___inline__] = ACTIONS(5594),
    [anon_sym___forceinline] = ACTIONS(5594),
    [anon_sym_thread_local] = ACTIONS(5594),
    [anon_sym___thread] = ACTIONS(5594),
    [anon_sym_const] = ACTIONS(5594),
    [anon_sym_constexpr] = ACTIONS(5594),
    [anon_sym_volatile] = ACTIONS(5594),
    [anon_sym_restrict] = ACTIONS(5594),
    [anon_sym___restrict__] = ACTIONS(5594),
    [anon_sym__Atomic] = ACTIONS(5594),
    [anon_sym__Noreturn] = ACTIONS(5594),
    [anon_sym_noreturn] = ACTIONS(5594),
    [anon_sym_mutable] = ACTIONS(5594),
    [anon_sym_constinit] = ACTIONS(5594),
    [anon_sym_consteval] = ACTIONS(5594),
    [anon_sym_PROGMEM] = ACTIONS(5594),
    [aux_sym_primitive_type_token1] = ACTIONS(5594),
    [anon_sym_byte] = ACTIONS(5594),
    [anon_sym_word] = ACTIONS(5594),
    [anon_sym_enum] = ACTIONS(5594),
    [anon_sym_class] = ACTIONS(5594),
    [anon_sym_struct] = ACTIONS(5594),
    [anon_sym_union] = ACTIONS(5594),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5594),
    [anon_sym_decltype] = ACTIONS(5594),
    [anon_sym_virtual] = ACTIONS(5594),
    [anon_sym_alignas] = ACTIONS(5594),
    [anon_sym_explicit] = ACTIONS(5594),
    [anon_sym_typename] = ACTIONS(5594),
    [anon_sym_template] = ACTIONS(5594),
    [anon_sym_operator] = ACTIONS(5594),
    [anon_sym_friend] = ACTIONS(5594),
    [anon_sym_public] = ACTIONS(5594),
    [anon_sym_private] = ACTIONS(5594),
    [anon_sym_protected] = ACTIONS(5594),
    [anon_sym_using] = ACTIONS(5594),
    [anon_sym_static_assert] = ACTIONS(5594),
  },
  [2633] = {
    [sym_identifier] = ACTIONS(5602),
    [aux_sym_preproc_def_token1] = ACTIONS(5602),
    [aux_sym_preproc_if_token1] = ACTIONS(5602),
    [aux_sym_preproc_if_token2] = ACTIONS(5602),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5602),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5602),
    [sym_preproc_directive] = ACTIONS(5602),
    [anon_sym_LPAREN2] = ACTIONS(5604),
    [anon_sym_TILDE] = ACTIONS(5604),
    [anon_sym_STAR] = ACTIONS(5604),
    [anon_sym_AMP_AMP] = ACTIONS(5604),
    [anon_sym_AMP] = ACTIONS(5602),
    [anon_sym___extension__] = ACTIONS(5602),
    [anon_sym_typedef] = ACTIONS(5602),
    [anon_sym_extern] = ACTIONS(5602),
    [anon_sym___attribute__] = ACTIONS(5602),
    [anon_sym_COLON_COLON] = ACTIONS(5604),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5604),
    [anon_sym___declspec] = ACTIONS(5602),
    [anon_sym___based] = ACTIONS(5602),
    [anon_sym_signed] = ACTIONS(5602),
    [anon_sym_unsigned] = ACTIONS(5602),
    [anon_sym_long] = ACTIONS(5602),
    [anon_sym_short] = ACTIONS(5602),
    [anon_sym_LBRACK] = ACTIONS(5602),
    [anon_sym_static] = ACTIONS(5602),
    [anon_sym_register] = ACTIONS(5602),
    [anon_sym_inline] = ACTIONS(5602),
    [anon_sym___inline] = ACTIONS(5602),
    [anon_sym___inline__] = ACTIONS(5602),
    [anon_sym___forceinline] = ACTIONS(5602),
    [anon_sym_thread_local] = ACTIONS(5602),
    [anon_sym___thread] = ACTIONS(5602),
    [anon_sym_const] = ACTIONS(5602),
    [anon_sym_constexpr] = ACTIONS(5602),
    [anon_sym_volatile] = ACTIONS(5602),
    [anon_sym_restrict] = ACTIONS(5602),
    [anon_sym___restrict__] = ACTIONS(5602),
    [anon_sym__Atomic] = ACTIONS(5602),
    [anon_sym__Noreturn] = ACTIONS(5602),
    [anon_sym_noreturn] = ACTIONS(5602),
    [anon_sym_mutable] = ACTIONS(5602),
    [anon_sym_constinit] = ACTIONS(5602),
    [anon_sym_consteval] = ACTIONS(5602),
    [anon_sym_PROGMEM] = ACTIONS(5602),
    [aux_sym_primitive_type_token1] = ACTIONS(5602),
    [anon_sym_byte] = ACTIONS(5602),
    [anon_sym_word] = ACTIONS(5602),
    [anon_sym_enum] = ACTIONS(5602),
    [anon_sym_class] = ACTIONS(5602),
    [anon_sym_struct] = ACTIONS(5602),
    [anon_sym_union] = ACTIONS(5602),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5602),
    [anon_sym_decltype] = ACTIONS(5602),
    [anon_sym_virtual] = ACTIONS(5602),
    [anon_sym_alignas] = ACTIONS(5602),
    [anon_sym_explicit] = ACTIONS(5602),
    [anon_sym_typename] = ACTIONS(5602),
    [anon_sym_template] = ACTIONS(5602),
    [anon_sym_operator] = ACTIONS(5602),
    [anon_sym_friend] = ACTIONS(5602),
    [anon_sym_public] = ACTIONS(5602),
    [anon_sym_private] = ACTIONS(5602),
    [anon_sym_protected] = ACTIONS(5602),
    [anon_sym_using] = ACTIONS(5602),
    [anon_sym_static_assert] = ACTIONS(5602),
  },
  [2634] = {
    [sym_string_literal] = STATE(2432),
    [sym_raw_string_literal] = STATE(2432),
    [sym_identifier] = ACTIONS(5797),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5799),
    [anon_sym_COMMA] = ACTIONS(5799),
    [aux_sym_preproc_if_token2] = ACTIONS(5799),
    [aux_sym_preproc_else_token1] = ACTIONS(5799),
    [aux_sym_preproc_elif_token1] = ACTIONS(5799),
    [anon_sym_LPAREN2] = ACTIONS(5799),
    [anon_sym_DASH] = ACTIONS(5797),
    [anon_sym_PLUS] = ACTIONS(5797),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_SLASH] = ACTIONS(5797),
    [anon_sym_PERCENT] = ACTIONS(5797),
    [anon_sym_PIPE_PIPE] = ACTIONS(5799),
    [anon_sym_AMP_AMP] = ACTIONS(5799),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_CARET] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_EQ_EQ] = ACTIONS(5799),
    [anon_sym_BANG_EQ] = ACTIONS(5799),
    [anon_sym_GT] = ACTIONS(5797),
    [anon_sym_GT_EQ] = ACTIONS(5799),
    [anon_sym_LT_EQ] = ACTIONS(5797),
    [anon_sym_LT] = ACTIONS(5797),
    [anon_sym_LT_LT] = ACTIONS(5797),
    [anon_sym_GT_GT] = ACTIONS(5797),
    [anon_sym_LBRACK] = ACTIONS(5799),
    [anon_sym_EQ] = ACTIONS(5797),
    [anon_sym_QMARK] = ACTIONS(5799),
    [anon_sym_STAR_EQ] = ACTIONS(5799),
    [anon_sym_SLASH_EQ] = ACTIONS(5799),
    [anon_sym_PERCENT_EQ] = ACTIONS(5799),
    [anon_sym_PLUS_EQ] = ACTIONS(5799),
    [anon_sym_DASH_EQ] = ACTIONS(5799),
    [anon_sym_LT_LT_EQ] = ACTIONS(5799),
    [anon_sym_GT_GT_EQ] = ACTIONS(5799),
    [anon_sym_AMP_EQ] = ACTIONS(5799),
    [anon_sym_CARET_EQ] = ACTIONS(5799),
    [anon_sym_PIPE_EQ] = ACTIONS(5799),
    [anon_sym_and_eq] = ACTIONS(5797),
    [anon_sym_or_eq] = ACTIONS(5797),
    [anon_sym_xor_eq] = ACTIONS(5797),
    [anon_sym_LT_EQ_GT] = ACTIONS(5799),
    [anon_sym_or] = ACTIONS(5797),
    [anon_sym_and] = ACTIONS(5797),
    [anon_sym_bitor] = ACTIONS(5797),
    [anon_sym_xor] = ACTIONS(5797),
    [anon_sym_bitand] = ACTIONS(5797),
    [anon_sym_not_eq] = ACTIONS(5797),
    [anon_sym_DASH_DASH] = ACTIONS(5799),
    [anon_sym_PLUS_PLUS] = ACTIONS(5799),
    [anon_sym_DOT] = ACTIONS(5797),
    [anon_sym_DOT_STAR] = ACTIONS(5799),
    [anon_sym_DASH_GT] = ACTIONS(5799),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [sym_literal_suffix] = ACTIONS(5986),
  },
  [2635] = {
    [sym_identifier] = ACTIONS(5598),
    [aux_sym_preproc_def_token1] = ACTIONS(5598),
    [aux_sym_preproc_if_token1] = ACTIONS(5598),
    [aux_sym_preproc_if_token2] = ACTIONS(5598),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5598),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5598),
    [sym_preproc_directive] = ACTIONS(5598),
    [anon_sym_LPAREN2] = ACTIONS(5600),
    [anon_sym_TILDE] = ACTIONS(5600),
    [anon_sym_STAR] = ACTIONS(5600),
    [anon_sym_AMP_AMP] = ACTIONS(5600),
    [anon_sym_AMP] = ACTIONS(5598),
    [anon_sym___extension__] = ACTIONS(5598),
    [anon_sym_typedef] = ACTIONS(5598),
    [anon_sym_extern] = ACTIONS(5598),
    [anon_sym___attribute__] = ACTIONS(5598),
    [anon_sym_COLON_COLON] = ACTIONS(5600),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5600),
    [anon_sym___declspec] = ACTIONS(5598),
    [anon_sym___based] = ACTIONS(5598),
    [anon_sym_signed] = ACTIONS(5598),
    [anon_sym_unsigned] = ACTIONS(5598),
    [anon_sym_long] = ACTIONS(5598),
    [anon_sym_short] = ACTIONS(5598),
    [anon_sym_LBRACK] = ACTIONS(5598),
    [anon_sym_static] = ACTIONS(5598),
    [anon_sym_register] = ACTIONS(5598),
    [anon_sym_inline] = ACTIONS(5598),
    [anon_sym___inline] = ACTIONS(5598),
    [anon_sym___inline__] = ACTIONS(5598),
    [anon_sym___forceinline] = ACTIONS(5598),
    [anon_sym_thread_local] = ACTIONS(5598),
    [anon_sym___thread] = ACTIONS(5598),
    [anon_sym_const] = ACTIONS(5598),
    [anon_sym_constexpr] = ACTIONS(5598),
    [anon_sym_volatile] = ACTIONS(5598),
    [anon_sym_restrict] = ACTIONS(5598),
    [anon_sym___restrict__] = ACTIONS(5598),
    [anon_sym__Atomic] = ACTIONS(5598),
    [anon_sym__Noreturn] = ACTIONS(5598),
    [anon_sym_noreturn] = ACTIONS(5598),
    [anon_sym_mutable] = ACTIONS(5598),
    [anon_sym_constinit] = ACTIONS(5598),
    [anon_sym_consteval] = ACTIONS(5598),
    [anon_sym_PROGMEM] = ACTIONS(5598),
    [aux_sym_primitive_type_token1] = ACTIONS(5598),
    [anon_sym_byte] = ACTIONS(5598),
    [anon_sym_word] = ACTIONS(5598),
    [anon_sym_enum] = ACTIONS(5598),
    [anon_sym_class] = ACTIONS(5598),
    [anon_sym_struct] = ACTIONS(5598),
    [anon_sym_union] = ACTIONS(5598),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5598),
    [anon_sym_decltype] = ACTIONS(5598),
    [anon_sym_virtual] = ACTIONS(5598),
    [anon_sym_alignas] = ACTIONS(5598),
    [anon_sym_explicit] = ACTIONS(5598),
    [anon_sym_typename] = ACTIONS(5598),
    [anon_sym_template] = ACTIONS(5598),
    [anon_sym_operator] = ACTIONS(5598),
    [anon_sym_friend] = ACTIONS(5598),
    [anon_sym_public] = ACTIONS(5598),
    [anon_sym_private] = ACTIONS(5598),
    [anon_sym_protected] = ACTIONS(5598),
    [anon_sym_using] = ACTIONS(5598),
    [anon_sym_static_assert] = ACTIONS(5598),
  },
  [2636] = {
    [sym_identifier] = ACTIONS(3509),
    [aux_sym_preproc_def_token1] = ACTIONS(3509),
    [aux_sym_preproc_if_token1] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3509),
    [sym_preproc_directive] = ACTIONS(3509),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3511),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym___extension__] = ACTIONS(3509),
    [anon_sym_typedef] = ACTIONS(3509),
    [anon_sym_extern] = ACTIONS(3509),
    [anon_sym___attribute__] = ACTIONS(3509),
    [anon_sym_COLON_COLON] = ACTIONS(3511),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3511),
    [anon_sym___declspec] = ACTIONS(3509),
    [anon_sym___based] = ACTIONS(3509),
    [anon_sym_RBRACE] = ACTIONS(3511),
    [anon_sym_signed] = ACTIONS(3509),
    [anon_sym_unsigned] = ACTIONS(3509),
    [anon_sym_long] = ACTIONS(3509),
    [anon_sym_short] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(3509),
    [anon_sym_static] = ACTIONS(3509),
    [anon_sym_register] = ACTIONS(3509),
    [anon_sym_inline] = ACTIONS(3509),
    [anon_sym___inline] = ACTIONS(3509),
    [anon_sym___inline__] = ACTIONS(3509),
    [anon_sym___forceinline] = ACTIONS(3509),
    [anon_sym_thread_local] = ACTIONS(3509),
    [anon_sym___thread] = ACTIONS(3509),
    [anon_sym_const] = ACTIONS(3509),
    [anon_sym_constexpr] = ACTIONS(3509),
    [anon_sym_volatile] = ACTIONS(3509),
    [anon_sym_restrict] = ACTIONS(3509),
    [anon_sym___restrict__] = ACTIONS(3509),
    [anon_sym__Atomic] = ACTIONS(3509),
    [anon_sym__Noreturn] = ACTIONS(3509),
    [anon_sym_noreturn] = ACTIONS(3509),
    [anon_sym_mutable] = ACTIONS(3509),
    [anon_sym_constinit] = ACTIONS(3509),
    [anon_sym_consteval] = ACTIONS(3509),
    [anon_sym_PROGMEM] = ACTIONS(3509),
    [aux_sym_primitive_type_token1] = ACTIONS(3509),
    [anon_sym_byte] = ACTIONS(3509),
    [anon_sym_word] = ACTIONS(3509),
    [anon_sym_enum] = ACTIONS(3509),
    [anon_sym_class] = ACTIONS(3509),
    [anon_sym_struct] = ACTIONS(3509),
    [anon_sym_union] = ACTIONS(3509),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3509),
    [anon_sym_decltype] = ACTIONS(3509),
    [anon_sym_virtual] = ACTIONS(3509),
    [anon_sym_alignas] = ACTIONS(3509),
    [anon_sym_explicit] = ACTIONS(3509),
    [anon_sym_typename] = ACTIONS(3509),
    [anon_sym_template] = ACTIONS(3509),
    [anon_sym_operator] = ACTIONS(3509),
    [anon_sym_friend] = ACTIONS(3509),
    [anon_sym_public] = ACTIONS(3509),
    [anon_sym_private] = ACTIONS(3509),
    [anon_sym_protected] = ACTIONS(3509),
    [anon_sym_using] = ACTIONS(3509),
    [anon_sym_static_assert] = ACTIONS(3509),
  },
  [2637] = {
    [sym_identifier] = ACTIONS(5538),
    [aux_sym_preproc_def_token1] = ACTIONS(5538),
    [aux_sym_preproc_if_token1] = ACTIONS(5538),
    [aux_sym_preproc_if_token2] = ACTIONS(5538),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5538),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5538),
    [sym_preproc_directive] = ACTIONS(5538),
    [anon_sym_LPAREN2] = ACTIONS(5540),
    [anon_sym_TILDE] = ACTIONS(5540),
    [anon_sym_STAR] = ACTIONS(5540),
    [anon_sym_AMP_AMP] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5538),
    [anon_sym_typedef] = ACTIONS(5538),
    [anon_sym_extern] = ACTIONS(5538),
    [anon_sym___attribute__] = ACTIONS(5538),
    [anon_sym_COLON_COLON] = ACTIONS(5540),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5540),
    [anon_sym___declspec] = ACTIONS(5538),
    [anon_sym___based] = ACTIONS(5538),
    [anon_sym_signed] = ACTIONS(5538),
    [anon_sym_unsigned] = ACTIONS(5538),
    [anon_sym_long] = ACTIONS(5538),
    [anon_sym_short] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(5538),
    [anon_sym_static] = ACTIONS(5538),
    [anon_sym_register] = ACTIONS(5538),
    [anon_sym_inline] = ACTIONS(5538),
    [anon_sym___inline] = ACTIONS(5538),
    [anon_sym___inline__] = ACTIONS(5538),
    [anon_sym___forceinline] = ACTIONS(5538),
    [anon_sym_thread_local] = ACTIONS(5538),
    [anon_sym___thread] = ACTIONS(5538),
    [anon_sym_const] = ACTIONS(5538),
    [anon_sym_constexpr] = ACTIONS(5538),
    [anon_sym_volatile] = ACTIONS(5538),
    [anon_sym_restrict] = ACTIONS(5538),
    [anon_sym___restrict__] = ACTIONS(5538),
    [anon_sym__Atomic] = ACTIONS(5538),
    [anon_sym__Noreturn] = ACTIONS(5538),
    [anon_sym_noreturn] = ACTIONS(5538),
    [anon_sym_mutable] = ACTIONS(5538),
    [anon_sym_constinit] = ACTIONS(5538),
    [anon_sym_consteval] = ACTIONS(5538),
    [anon_sym_PROGMEM] = ACTIONS(5538),
    [aux_sym_primitive_type_token1] = ACTIONS(5538),
    [anon_sym_byte] = ACTIONS(5538),
    [anon_sym_word] = ACTIONS(5538),
    [anon_sym_enum] = ACTIONS(5538),
    [anon_sym_class] = ACTIONS(5538),
    [anon_sym_struct] = ACTIONS(5538),
    [anon_sym_union] = ACTIONS(5538),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5538),
    [anon_sym_decltype] = ACTIONS(5538),
    [anon_sym_virtual] = ACTIONS(5538),
    [anon_sym_alignas] = ACTIONS(5538),
    [anon_sym_explicit] = ACTIONS(5538),
    [anon_sym_typename] = ACTIONS(5538),
    [anon_sym_template] = ACTIONS(5538),
    [anon_sym_operator] = ACTIONS(5538),
    [anon_sym_friend] = ACTIONS(5538),
    [anon_sym_public] = ACTIONS(5538),
    [anon_sym_private] = ACTIONS(5538),
    [anon_sym_protected] = ACTIONS(5538),
    [anon_sym_using] = ACTIONS(5538),
    [anon_sym_static_assert] = ACTIONS(5538),
  },
  [2638] = {
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym_RBRACE] = ACTIONS(3515),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_PROGMEM] = ACTIONS(3513),
    [aux_sym_primitive_type_token1] = ACTIONS(3513),
    [anon_sym_byte] = ACTIONS(3513),
    [anon_sym_word] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [anon_sym_virtual] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_friend] = ACTIONS(3513),
    [anon_sym_public] = ACTIONS(3513),
    [anon_sym_private] = ACTIONS(3513),
    [anon_sym_protected] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
  },
  [2639] = {
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym_RBRACE] = ACTIONS(3515),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_PROGMEM] = ACTIONS(3513),
    [aux_sym_primitive_type_token1] = ACTIONS(3513),
    [anon_sym_byte] = ACTIONS(3513),
    [anon_sym_word] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [anon_sym_virtual] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_friend] = ACTIONS(3513),
    [anon_sym_public] = ACTIONS(3513),
    [anon_sym_private] = ACTIONS(3513),
    [anon_sym_protected] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
  },
  [2640] = {
    [sym_identifier] = ACTIONS(5538),
    [aux_sym_preproc_def_token1] = ACTIONS(5538),
    [aux_sym_preproc_if_token1] = ACTIONS(5538),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5538),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5538),
    [sym_preproc_directive] = ACTIONS(5538),
    [anon_sym_LPAREN2] = ACTIONS(5540),
    [anon_sym_TILDE] = ACTIONS(5540),
    [anon_sym_STAR] = ACTIONS(5540),
    [anon_sym_AMP_AMP] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5538),
    [anon_sym_typedef] = ACTIONS(5538),
    [anon_sym_extern] = ACTIONS(5538),
    [anon_sym___attribute__] = ACTIONS(5538),
    [anon_sym_COLON_COLON] = ACTIONS(5540),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5540),
    [anon_sym___declspec] = ACTIONS(5538),
    [anon_sym___based] = ACTIONS(5538),
    [anon_sym_RBRACE] = ACTIONS(5540),
    [anon_sym_signed] = ACTIONS(5538),
    [anon_sym_unsigned] = ACTIONS(5538),
    [anon_sym_long] = ACTIONS(5538),
    [anon_sym_short] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(5538),
    [anon_sym_static] = ACTIONS(5538),
    [anon_sym_register] = ACTIONS(5538),
    [anon_sym_inline] = ACTIONS(5538),
    [anon_sym___inline] = ACTIONS(5538),
    [anon_sym___inline__] = ACTIONS(5538),
    [anon_sym___forceinline] = ACTIONS(5538),
    [anon_sym_thread_local] = ACTIONS(5538),
    [anon_sym___thread] = ACTIONS(5538),
    [anon_sym_const] = ACTIONS(5538),
    [anon_sym_constexpr] = ACTIONS(5538),
    [anon_sym_volatile] = ACTIONS(5538),
    [anon_sym_restrict] = ACTIONS(5538),
    [anon_sym___restrict__] = ACTIONS(5538),
    [anon_sym__Atomic] = ACTIONS(5538),
    [anon_sym__Noreturn] = ACTIONS(5538),
    [anon_sym_noreturn] = ACTIONS(5538),
    [anon_sym_mutable] = ACTIONS(5538),
    [anon_sym_constinit] = ACTIONS(5538),
    [anon_sym_consteval] = ACTIONS(5538),
    [anon_sym_PROGMEM] = ACTIONS(5538),
    [aux_sym_primitive_type_token1] = ACTIONS(5538),
    [anon_sym_byte] = ACTIONS(5538),
    [anon_sym_word] = ACTIONS(5538),
    [anon_sym_enum] = ACTIONS(5538),
    [anon_sym_class] = ACTIONS(5538),
    [anon_sym_struct] = ACTIONS(5538),
    [anon_sym_union] = ACTIONS(5538),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5538),
    [anon_sym_decltype] = ACTIONS(5538),
    [anon_sym_virtual] = ACTIONS(5538),
    [anon_sym_alignas] = ACTIONS(5538),
    [anon_sym_explicit] = ACTIONS(5538),
    [anon_sym_typename] = ACTIONS(5538),
    [anon_sym_template] = ACTIONS(5538),
    [anon_sym_operator] = ACTIONS(5538),
    [anon_sym_friend] = ACTIONS(5538),
    [anon_sym_public] = ACTIONS(5538),
    [anon_sym_private] = ACTIONS(5538),
    [anon_sym_protected] = ACTIONS(5538),
    [anon_sym_using] = ACTIONS(5538),
    [anon_sym_static_assert] = ACTIONS(5538),
  },
  [2641] = {
    [sym_identifier] = ACTIONS(3499),
    [aux_sym_preproc_def_token1] = ACTIONS(3499),
    [aux_sym_preproc_if_token1] = ACTIONS(3499),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3499),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3499),
    [sym_preproc_directive] = ACTIONS(3499),
    [anon_sym_LPAREN2] = ACTIONS(3501),
    [anon_sym_TILDE] = ACTIONS(3501),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_AMP_AMP] = ACTIONS(3501),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym___extension__] = ACTIONS(3499),
    [anon_sym_typedef] = ACTIONS(3499),
    [anon_sym_extern] = ACTIONS(3499),
    [anon_sym___attribute__] = ACTIONS(3499),
    [anon_sym_COLON_COLON] = ACTIONS(3501),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3501),
    [anon_sym___declspec] = ACTIONS(3499),
    [anon_sym___based] = ACTIONS(3499),
    [anon_sym_RBRACE] = ACTIONS(3501),
    [anon_sym_signed] = ACTIONS(3499),
    [anon_sym_unsigned] = ACTIONS(3499),
    [anon_sym_long] = ACTIONS(3499),
    [anon_sym_short] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(3499),
    [anon_sym_static] = ACTIONS(3499),
    [anon_sym_register] = ACTIONS(3499),
    [anon_sym_inline] = ACTIONS(3499),
    [anon_sym___inline] = ACTIONS(3499),
    [anon_sym___inline__] = ACTIONS(3499),
    [anon_sym___forceinline] = ACTIONS(3499),
    [anon_sym_thread_local] = ACTIONS(3499),
    [anon_sym___thread] = ACTIONS(3499),
    [anon_sym_const] = ACTIONS(3499),
    [anon_sym_constexpr] = ACTIONS(3499),
    [anon_sym_volatile] = ACTIONS(3499),
    [anon_sym_restrict] = ACTIONS(3499),
    [anon_sym___restrict__] = ACTIONS(3499),
    [anon_sym__Atomic] = ACTIONS(3499),
    [anon_sym__Noreturn] = ACTIONS(3499),
    [anon_sym_noreturn] = ACTIONS(3499),
    [anon_sym_mutable] = ACTIONS(3499),
    [anon_sym_constinit] = ACTIONS(3499),
    [anon_sym_consteval] = ACTIONS(3499),
    [anon_sym_PROGMEM] = ACTIONS(3499),
    [aux_sym_primitive_type_token1] = ACTIONS(3499),
    [anon_sym_byte] = ACTIONS(3499),
    [anon_sym_word] = ACTIONS(3499),
    [anon_sym_enum] = ACTIONS(3499),
    [anon_sym_class] = ACTIONS(3499),
    [anon_sym_struct] = ACTIONS(3499),
    [anon_sym_union] = ACTIONS(3499),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3499),
    [anon_sym_decltype] = ACTIONS(3499),
    [anon_sym_virtual] = ACTIONS(3499),
    [anon_sym_alignas] = ACTIONS(3499),
    [anon_sym_explicit] = ACTIONS(3499),
    [anon_sym_typename] = ACTIONS(3499),
    [anon_sym_template] = ACTIONS(3499),
    [anon_sym_operator] = ACTIONS(3499),
    [anon_sym_friend] = ACTIONS(3499),
    [anon_sym_public] = ACTIONS(3499),
    [anon_sym_private] = ACTIONS(3499),
    [anon_sym_protected] = ACTIONS(3499),
    [anon_sym_using] = ACTIONS(3499),
    [anon_sym_static_assert] = ACTIONS(3499),
  },
  [2642] = {
    [sym_identifier] = ACTIONS(3134),
    [aux_sym_preproc_def_token1] = ACTIONS(3134),
    [aux_sym_preproc_if_token1] = ACTIONS(3134),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3134),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3134),
    [sym_preproc_directive] = ACTIONS(3134),
    [anon_sym_LPAREN2] = ACTIONS(3136),
    [anon_sym_TILDE] = ACTIONS(3136),
    [anon_sym_STAR] = ACTIONS(3136),
    [anon_sym_AMP_AMP] = ACTIONS(3136),
    [anon_sym_AMP] = ACTIONS(3134),
    [anon_sym___extension__] = ACTIONS(3134),
    [anon_sym_typedef] = ACTIONS(3134),
    [anon_sym_extern] = ACTIONS(3134),
    [anon_sym___attribute__] = ACTIONS(3134),
    [anon_sym_COLON_COLON] = ACTIONS(3136),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3136),
    [anon_sym___declspec] = ACTIONS(3134),
    [anon_sym___based] = ACTIONS(3134),
    [anon_sym_RBRACE] = ACTIONS(3136),
    [anon_sym_signed] = ACTIONS(3134),
    [anon_sym_unsigned] = ACTIONS(3134),
    [anon_sym_long] = ACTIONS(3134),
    [anon_sym_short] = ACTIONS(3134),
    [anon_sym_LBRACK] = ACTIONS(3134),
    [anon_sym_static] = ACTIONS(3134),
    [anon_sym_register] = ACTIONS(3134),
    [anon_sym_inline] = ACTIONS(3134),
    [anon_sym___inline] = ACTIONS(3134),
    [anon_sym___inline__] = ACTIONS(3134),
    [anon_sym___forceinline] = ACTIONS(3134),
    [anon_sym_thread_local] = ACTIONS(3134),
    [anon_sym___thread] = ACTIONS(3134),
    [anon_sym_const] = ACTIONS(3134),
    [anon_sym_constexpr] = ACTIONS(3134),
    [anon_sym_volatile] = ACTIONS(3134),
    [anon_sym_restrict] = ACTIONS(3134),
    [anon_sym___restrict__] = ACTIONS(3134),
    [anon_sym__Atomic] = ACTIONS(3134),
    [anon_sym__Noreturn] = ACTIONS(3134),
    [anon_sym_noreturn] = ACTIONS(3134),
    [anon_sym_mutable] = ACTIONS(3134),
    [anon_sym_constinit] = ACTIONS(3134),
    [anon_sym_consteval] = ACTIONS(3134),
    [anon_sym_PROGMEM] = ACTIONS(3134),
    [aux_sym_primitive_type_token1] = ACTIONS(3134),
    [anon_sym_byte] = ACTIONS(3134),
    [anon_sym_word] = ACTIONS(3134),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3134),
    [anon_sym_struct] = ACTIONS(3134),
    [anon_sym_union] = ACTIONS(3134),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3134),
    [anon_sym_decltype] = ACTIONS(3134),
    [anon_sym_virtual] = ACTIONS(3134),
    [anon_sym_alignas] = ACTIONS(3134),
    [anon_sym_explicit] = ACTIONS(3134),
    [anon_sym_typename] = ACTIONS(3134),
    [anon_sym_template] = ACTIONS(3134),
    [anon_sym_operator] = ACTIONS(3134),
    [anon_sym_friend] = ACTIONS(3134),
    [anon_sym_public] = ACTIONS(3134),
    [anon_sym_private] = ACTIONS(3134),
    [anon_sym_protected] = ACTIONS(3134),
    [anon_sym_using] = ACTIONS(3134),
    [anon_sym_static_assert] = ACTIONS(3134),
  },
  [2643] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(4471),
    [sym_raw_string_literal] = STATE(3057),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5870),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4280),
    [anon_sym_COLON] = ACTIONS(4308),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_and_eq] = ACTIONS(4284),
    [anon_sym_or_eq] = ACTIONS(4284),
    [anon_sym_xor_eq] = ACTIONS(4284),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [2644] = {
    [sym_identifier] = ACTIONS(3503),
    [aux_sym_preproc_def_token1] = ACTIONS(3503),
    [aux_sym_preproc_if_token1] = ACTIONS(3503),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3503),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3503),
    [sym_preproc_directive] = ACTIONS(3503),
    [anon_sym_LPAREN2] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP] = ACTIONS(3503),
    [anon_sym___extension__] = ACTIONS(3503),
    [anon_sym_typedef] = ACTIONS(3503),
    [anon_sym_extern] = ACTIONS(3503),
    [anon_sym___attribute__] = ACTIONS(3503),
    [anon_sym_COLON_COLON] = ACTIONS(3505),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3505),
    [anon_sym___declspec] = ACTIONS(3503),
    [anon_sym___based] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(3505),
    [anon_sym_signed] = ACTIONS(3503),
    [anon_sym_unsigned] = ACTIONS(3503),
    [anon_sym_long] = ACTIONS(3503),
    [anon_sym_short] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3503),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_register] = ACTIONS(3503),
    [anon_sym_inline] = ACTIONS(3503),
    [anon_sym___inline] = ACTIONS(3503),
    [anon_sym___inline__] = ACTIONS(3503),
    [anon_sym___forceinline] = ACTIONS(3503),
    [anon_sym_thread_local] = ACTIONS(3503),
    [anon_sym___thread] = ACTIONS(3503),
    [anon_sym_const] = ACTIONS(3503),
    [anon_sym_constexpr] = ACTIONS(3503),
    [anon_sym_volatile] = ACTIONS(3503),
    [anon_sym_restrict] = ACTIONS(3503),
    [anon_sym___restrict__] = ACTIONS(3503),
    [anon_sym__Atomic] = ACTIONS(3503),
    [anon_sym__Noreturn] = ACTIONS(3503),
    [anon_sym_noreturn] = ACTIONS(3503),
    [anon_sym_mutable] = ACTIONS(3503),
    [anon_sym_constinit] = ACTIONS(3503),
    [anon_sym_consteval] = ACTIONS(3503),
    [anon_sym_PROGMEM] = ACTIONS(3503),
    [aux_sym_primitive_type_token1] = ACTIONS(3503),
    [anon_sym_byte] = ACTIONS(3503),
    [anon_sym_word] = ACTIONS(3503),
    [anon_sym_enum] = ACTIONS(3503),
    [anon_sym_class] = ACTIONS(3503),
    [anon_sym_struct] = ACTIONS(3503),
    [anon_sym_union] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3503),
    [anon_sym_decltype] = ACTIONS(3503),
    [anon_sym_virtual] = ACTIONS(3503),
    [anon_sym_alignas] = ACTIONS(3503),
    [anon_sym_explicit] = ACTIONS(3503),
    [anon_sym_typename] = ACTIONS(3503),
    [anon_sym_template] = ACTIONS(3503),
    [anon_sym_operator] = ACTIONS(3503),
    [anon_sym_friend] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_using] = ACTIONS(3503),
    [anon_sym_static_assert] = ACTIONS(3503),
  },
  [2645] = {
    [sym_string_literal] = STATE(2551),
    [sym_raw_string_literal] = STATE(2551),
    [aux_sym_concatenated_string_repeat1] = STATE(2551),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5393),
    [anon_sym_COMMA] = ACTIONS(5393),
    [anon_sym_RPAREN] = ACTIONS(5393),
    [anon_sym_LPAREN2] = ACTIONS(5393),
    [anon_sym_DASH] = ACTIONS(5395),
    [anon_sym_PLUS] = ACTIONS(5395),
    [anon_sym_STAR] = ACTIONS(5395),
    [anon_sym_SLASH] = ACTIONS(5395),
    [anon_sym_PERCENT] = ACTIONS(5395),
    [anon_sym_PIPE_PIPE] = ACTIONS(5393),
    [anon_sym_AMP_AMP] = ACTIONS(5393),
    [anon_sym_PIPE] = ACTIONS(5395),
    [anon_sym_CARET] = ACTIONS(5395),
    [anon_sym_AMP] = ACTIONS(5395),
    [anon_sym_EQ_EQ] = ACTIONS(5393),
    [anon_sym_BANG_EQ] = ACTIONS(5393),
    [anon_sym_GT] = ACTIONS(5395),
    [anon_sym_GT_EQ] = ACTIONS(5393),
    [anon_sym_LT_EQ] = ACTIONS(5395),
    [anon_sym_LT] = ACTIONS(5395),
    [anon_sym_LT_LT] = ACTIONS(5395),
    [anon_sym_GT_GT] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(5393),
    [anon_sym_EQ] = ACTIONS(5395),
    [anon_sym_QMARK] = ACTIONS(5393),
    [anon_sym_STAR_EQ] = ACTIONS(5393),
    [anon_sym_SLASH_EQ] = ACTIONS(5393),
    [anon_sym_PERCENT_EQ] = ACTIONS(5393),
    [anon_sym_PLUS_EQ] = ACTIONS(5393),
    [anon_sym_DASH_EQ] = ACTIONS(5393),
    [anon_sym_LT_LT_EQ] = ACTIONS(5393),
    [anon_sym_GT_GT_EQ] = ACTIONS(5393),
    [anon_sym_AMP_EQ] = ACTIONS(5393),
    [anon_sym_CARET_EQ] = ACTIONS(5393),
    [anon_sym_PIPE_EQ] = ACTIONS(5393),
    [anon_sym_and_eq] = ACTIONS(5395),
    [anon_sym_or_eq] = ACTIONS(5395),
    [anon_sym_xor_eq] = ACTIONS(5395),
    [anon_sym_LT_EQ_GT] = ACTIONS(5393),
    [anon_sym_or] = ACTIONS(5395),
    [anon_sym_and] = ACTIONS(5395),
    [anon_sym_bitor] = ACTIONS(5395),
    [anon_sym_xor] = ACTIONS(5395),
    [anon_sym_bitand] = ACTIONS(5395),
    [anon_sym_not_eq] = ACTIONS(5395),
    [anon_sym_DASH_DASH] = ACTIONS(5393),
    [anon_sym_PLUS_PLUS] = ACTIONS(5393),
    [anon_sym_DOT] = ACTIONS(5395),
    [anon_sym_DOT_STAR] = ACTIONS(5393),
    [anon_sym_DASH_GT] = ACTIONS(5395),
    [anon_sym_L_DQUOTE] = ACTIONS(5184),
    [anon_sym_u_DQUOTE] = ACTIONS(5184),
    [anon_sym_U_DQUOTE] = ACTIONS(5184),
    [anon_sym_u8_DQUOTE] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5186),
    [anon_sym_LR_DQUOTE] = ACTIONS(5186),
    [anon_sym_uR_DQUOTE] = ACTIONS(5186),
    [anon_sym_UR_DQUOTE] = ACTIONS(5186),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5186),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5393),
    [sym_literal_suffix] = ACTIONS(5395),
  },
  [2646] = {
    [sym_identifier] = ACTIONS(5582),
    [aux_sym_preproc_def_token1] = ACTIONS(5582),
    [aux_sym_preproc_if_token1] = ACTIONS(5582),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5582),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5582),
    [sym_preproc_directive] = ACTIONS(5582),
    [anon_sym_LPAREN2] = ACTIONS(5584),
    [anon_sym_TILDE] = ACTIONS(5584),
    [anon_sym_STAR] = ACTIONS(5584),
    [anon_sym_AMP_AMP] = ACTIONS(5584),
    [anon_sym_AMP] = ACTIONS(5582),
    [anon_sym___extension__] = ACTIONS(5582),
    [anon_sym_typedef] = ACTIONS(5582),
    [anon_sym_extern] = ACTIONS(5582),
    [anon_sym___attribute__] = ACTIONS(5582),
    [anon_sym_COLON_COLON] = ACTIONS(5584),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5584),
    [anon_sym___declspec] = ACTIONS(5582),
    [anon_sym___based] = ACTIONS(5582),
    [anon_sym_RBRACE] = ACTIONS(5584),
    [anon_sym_signed] = ACTIONS(5582),
    [anon_sym_unsigned] = ACTIONS(5582),
    [anon_sym_long] = ACTIONS(5582),
    [anon_sym_short] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(5582),
    [anon_sym_static] = ACTIONS(5582),
    [anon_sym_register] = ACTIONS(5582),
    [anon_sym_inline] = ACTIONS(5582),
    [anon_sym___inline] = ACTIONS(5582),
    [anon_sym___inline__] = ACTIONS(5582),
    [anon_sym___forceinline] = ACTIONS(5582),
    [anon_sym_thread_local] = ACTIONS(5582),
    [anon_sym___thread] = ACTIONS(5582),
    [anon_sym_const] = ACTIONS(5582),
    [anon_sym_constexpr] = ACTIONS(5582),
    [anon_sym_volatile] = ACTIONS(5582),
    [anon_sym_restrict] = ACTIONS(5582),
    [anon_sym___restrict__] = ACTIONS(5582),
    [anon_sym__Atomic] = ACTIONS(5582),
    [anon_sym__Noreturn] = ACTIONS(5582),
    [anon_sym_noreturn] = ACTIONS(5582),
    [anon_sym_mutable] = ACTIONS(5582),
    [anon_sym_constinit] = ACTIONS(5582),
    [anon_sym_consteval] = ACTIONS(5582),
    [anon_sym_PROGMEM] = ACTIONS(5582),
    [aux_sym_primitive_type_token1] = ACTIONS(5582),
    [anon_sym_byte] = ACTIONS(5582),
    [anon_sym_word] = ACTIONS(5582),
    [anon_sym_enum] = ACTIONS(5582),
    [anon_sym_class] = ACTIONS(5582),
    [anon_sym_struct] = ACTIONS(5582),
    [anon_sym_union] = ACTIONS(5582),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5582),
    [anon_sym_decltype] = ACTIONS(5582),
    [anon_sym_virtual] = ACTIONS(5582),
    [anon_sym_alignas] = ACTIONS(5582),
    [anon_sym_explicit] = ACTIONS(5582),
    [anon_sym_typename] = ACTIONS(5582),
    [anon_sym_template] = ACTIONS(5582),
    [anon_sym_operator] = ACTIONS(5582),
    [anon_sym_friend] = ACTIONS(5582),
    [anon_sym_public] = ACTIONS(5582),
    [anon_sym_private] = ACTIONS(5582),
    [anon_sym_protected] = ACTIONS(5582),
    [anon_sym_using] = ACTIONS(5582),
    [anon_sym_static_assert] = ACTIONS(5582),
  },
  [2647] = {
    [sym_string_literal] = STATE(2432),
    [sym_raw_string_literal] = STATE(2432),
    [sym_identifier] = ACTIONS(4256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [aux_sym_preproc_if_token2] = ACTIONS(4248),
    [aux_sym_preproc_else_token1] = ACTIONS(4248),
    [aux_sym_preproc_elif_token1] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(4256),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4256),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4248),
    [anon_sym_SLASH_EQ] = ACTIONS(4248),
    [anon_sym_PERCENT_EQ] = ACTIONS(4248),
    [anon_sym_PLUS_EQ] = ACTIONS(4248),
    [anon_sym_DASH_EQ] = ACTIONS(4248),
    [anon_sym_LT_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT_GT_EQ] = ACTIONS(4248),
    [anon_sym_AMP_EQ] = ACTIONS(4248),
    [anon_sym_CARET_EQ] = ACTIONS(4248),
    [anon_sym_PIPE_EQ] = ACTIONS(4248),
    [anon_sym_and_eq] = ACTIONS(4256),
    [anon_sym_or_eq] = ACTIONS(4256),
    [anon_sym_xor_eq] = ACTIONS(4256),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4256),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4256),
    [anon_sym_not_eq] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [sym_literal_suffix] = ACTIONS(5986),
  },
  [2648] = {
    [sym_identifier] = ACTIONS(3186),
    [aux_sym_preproc_def_token1] = ACTIONS(3186),
    [aux_sym_preproc_if_token1] = ACTIONS(3186),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3186),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3186),
    [sym_preproc_directive] = ACTIONS(3186),
    [anon_sym_LPAREN2] = ACTIONS(3188),
    [anon_sym_TILDE] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(3188),
    [anon_sym_AMP_AMP] = ACTIONS(3188),
    [anon_sym_AMP] = ACTIONS(3186),
    [anon_sym___extension__] = ACTIONS(3186),
    [anon_sym_typedef] = ACTIONS(3186),
    [anon_sym_extern] = ACTIONS(3186),
    [anon_sym___attribute__] = ACTIONS(3186),
    [anon_sym_COLON_COLON] = ACTIONS(3188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3188),
    [anon_sym___declspec] = ACTIONS(3186),
    [anon_sym___based] = ACTIONS(3186),
    [anon_sym_RBRACE] = ACTIONS(3188),
    [anon_sym_signed] = ACTIONS(3186),
    [anon_sym_unsigned] = ACTIONS(3186),
    [anon_sym_long] = ACTIONS(3186),
    [anon_sym_short] = ACTIONS(3186),
    [anon_sym_LBRACK] = ACTIONS(3186),
    [anon_sym_static] = ACTIONS(3186),
    [anon_sym_register] = ACTIONS(3186),
    [anon_sym_inline] = ACTIONS(3186),
    [anon_sym___inline] = ACTIONS(3186),
    [anon_sym___inline__] = ACTIONS(3186),
    [anon_sym___forceinline] = ACTIONS(3186),
    [anon_sym_thread_local] = ACTIONS(3186),
    [anon_sym___thread] = ACTIONS(3186),
    [anon_sym_const] = ACTIONS(3186),
    [anon_sym_constexpr] = ACTIONS(3186),
    [anon_sym_volatile] = ACTIONS(3186),
    [anon_sym_restrict] = ACTIONS(3186),
    [anon_sym___restrict__] = ACTIONS(3186),
    [anon_sym__Atomic] = ACTIONS(3186),
    [anon_sym__Noreturn] = ACTIONS(3186),
    [anon_sym_noreturn] = ACTIONS(3186),
    [anon_sym_mutable] = ACTIONS(3186),
    [anon_sym_constinit] = ACTIONS(3186),
    [anon_sym_consteval] = ACTIONS(3186),
    [anon_sym_PROGMEM] = ACTIONS(3186),
    [aux_sym_primitive_type_token1] = ACTIONS(3186),
    [anon_sym_byte] = ACTIONS(3186),
    [anon_sym_word] = ACTIONS(3186),
    [anon_sym_enum] = ACTIONS(3186),
    [anon_sym_class] = ACTIONS(3186),
    [anon_sym_struct] = ACTIONS(3186),
    [anon_sym_union] = ACTIONS(3186),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3186),
    [anon_sym_decltype] = ACTIONS(3186),
    [anon_sym_virtual] = ACTIONS(3186),
    [anon_sym_alignas] = ACTIONS(3186),
    [anon_sym_explicit] = ACTIONS(3186),
    [anon_sym_typename] = ACTIONS(3186),
    [anon_sym_template] = ACTIONS(3186),
    [anon_sym_operator] = ACTIONS(3186),
    [anon_sym_friend] = ACTIONS(3186),
    [anon_sym_public] = ACTIONS(3186),
    [anon_sym_private] = ACTIONS(3186),
    [anon_sym_protected] = ACTIONS(3186),
    [anon_sym_using] = ACTIONS(3186),
    [anon_sym_static_assert] = ACTIONS(3186),
  },
  [2649] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(4471),
    [sym_raw_string_literal] = STATE(3057),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5870),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4280),
    [anon_sym_COLON] = ACTIONS(5990),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_and_eq] = ACTIONS(4284),
    [anon_sym_or_eq] = ACTIONS(4284),
    [anon_sym_xor_eq] = ACTIONS(4284),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [2650] = {
    [sym_identifier] = ACTIONS(5586),
    [aux_sym_preproc_def_token1] = ACTIONS(5586),
    [aux_sym_preproc_if_token1] = ACTIONS(5586),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5586),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5586),
    [sym_preproc_directive] = ACTIONS(5586),
    [anon_sym_LPAREN2] = ACTIONS(5588),
    [anon_sym_TILDE] = ACTIONS(5588),
    [anon_sym_STAR] = ACTIONS(5588),
    [anon_sym_AMP_AMP] = ACTIONS(5588),
    [anon_sym_AMP] = ACTIONS(5586),
    [anon_sym___extension__] = ACTIONS(5586),
    [anon_sym_typedef] = ACTIONS(5586),
    [anon_sym_extern] = ACTIONS(5586),
    [anon_sym___attribute__] = ACTIONS(5586),
    [anon_sym_COLON_COLON] = ACTIONS(5588),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5588),
    [anon_sym___declspec] = ACTIONS(5586),
    [anon_sym___based] = ACTIONS(5586),
    [anon_sym_RBRACE] = ACTIONS(5588),
    [anon_sym_signed] = ACTIONS(5586),
    [anon_sym_unsigned] = ACTIONS(5586),
    [anon_sym_long] = ACTIONS(5586),
    [anon_sym_short] = ACTIONS(5586),
    [anon_sym_LBRACK] = ACTIONS(5586),
    [anon_sym_static] = ACTIONS(5586),
    [anon_sym_register] = ACTIONS(5586),
    [anon_sym_inline] = ACTIONS(5586),
    [anon_sym___inline] = ACTIONS(5586),
    [anon_sym___inline__] = ACTIONS(5586),
    [anon_sym___forceinline] = ACTIONS(5586),
    [anon_sym_thread_local] = ACTIONS(5586),
    [anon_sym___thread] = ACTIONS(5586),
    [anon_sym_const] = ACTIONS(5586),
    [anon_sym_constexpr] = ACTIONS(5586),
    [anon_sym_volatile] = ACTIONS(5586),
    [anon_sym_restrict] = ACTIONS(5586),
    [anon_sym___restrict__] = ACTIONS(5586),
    [anon_sym__Atomic] = ACTIONS(5586),
    [anon_sym__Noreturn] = ACTIONS(5586),
    [anon_sym_noreturn] = ACTIONS(5586),
    [anon_sym_mutable] = ACTIONS(5586),
    [anon_sym_constinit] = ACTIONS(5586),
    [anon_sym_consteval] = ACTIONS(5586),
    [anon_sym_PROGMEM] = ACTIONS(5586),
    [aux_sym_primitive_type_token1] = ACTIONS(5586),
    [anon_sym_byte] = ACTIONS(5586),
    [anon_sym_word] = ACTIONS(5586),
    [anon_sym_enum] = ACTIONS(5586),
    [anon_sym_class] = ACTIONS(5586),
    [anon_sym_struct] = ACTIONS(5586),
    [anon_sym_union] = ACTIONS(5586),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5586),
    [anon_sym_decltype] = ACTIONS(5586),
    [anon_sym_virtual] = ACTIONS(5586),
    [anon_sym_alignas] = ACTIONS(5586),
    [anon_sym_explicit] = ACTIONS(5586),
    [anon_sym_typename] = ACTIONS(5586),
    [anon_sym_template] = ACTIONS(5586),
    [anon_sym_operator] = ACTIONS(5586),
    [anon_sym_friend] = ACTIONS(5586),
    [anon_sym_public] = ACTIONS(5586),
    [anon_sym_private] = ACTIONS(5586),
    [anon_sym_protected] = ACTIONS(5586),
    [anon_sym_using] = ACTIONS(5586),
    [anon_sym_static_assert] = ACTIONS(5586),
  },
  [2651] = {
    [sym_primitive_type] = STATE(2957),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2685),
    [sym_identifier] = ACTIONS(5992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5489),
    [anon_sym_COMMA] = ACTIONS(5489),
    [anon_sym_LPAREN2] = ACTIONS(5489),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_PLUS] = ACTIONS(5491),
    [anon_sym_STAR] = ACTIONS(5489),
    [anon_sym_SLASH] = ACTIONS(5491),
    [anon_sym_PERCENT] = ACTIONS(5489),
    [anon_sym_PIPE_PIPE] = ACTIONS(5489),
    [anon_sym_AMP_AMP] = ACTIONS(5489),
    [anon_sym_PIPE] = ACTIONS(5491),
    [anon_sym_CARET] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_EQ_EQ] = ACTIONS(5489),
    [anon_sym_BANG_EQ] = ACTIONS(5489),
    [anon_sym_GT] = ACTIONS(5491),
    [anon_sym_GT_EQ] = ACTIONS(5491),
    [anon_sym_LT_EQ] = ACTIONS(5491),
    [anon_sym_LT] = ACTIONS(5491),
    [anon_sym_LT_LT] = ACTIONS(5489),
    [anon_sym_GT_GT] = ACTIONS(5491),
    [anon_sym___extension__] = ACTIONS(5491),
    [anon_sym___attribute__] = ACTIONS(5491),
    [anon_sym_LBRACE] = ACTIONS(5489),
    [anon_sym_signed] = ACTIONS(5994),
    [anon_sym_unsigned] = ACTIONS(5994),
    [anon_sym_long] = ACTIONS(5994),
    [anon_sym_short] = ACTIONS(5994),
    [anon_sym_LBRACK] = ACTIONS(5489),
    [anon_sym_const] = ACTIONS(5491),
    [anon_sym_constexpr] = ACTIONS(5491),
    [anon_sym_volatile] = ACTIONS(5491),
    [anon_sym_restrict] = ACTIONS(5491),
    [anon_sym___restrict__] = ACTIONS(5491),
    [anon_sym__Atomic] = ACTIONS(5491),
    [anon_sym__Noreturn] = ACTIONS(5491),
    [anon_sym_noreturn] = ACTIONS(5491),
    [anon_sym_mutable] = ACTIONS(5491),
    [anon_sym_constinit] = ACTIONS(5491),
    [anon_sym_consteval] = ACTIONS(5491),
    [anon_sym_PROGMEM] = ACTIONS(5491),
    [aux_sym_primitive_type_token1] = ACTIONS(2988),
    [anon_sym_byte] = ACTIONS(2988),
    [anon_sym_word] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(5489),
    [anon_sym_LT_EQ_GT] = ACTIONS(5489),
    [anon_sym_or] = ACTIONS(5491),
    [anon_sym_and] = ACTIONS(5491),
    [anon_sym_bitor] = ACTIONS(5491),
    [anon_sym_xor] = ACTIONS(5491),
    [anon_sym_bitand] = ACTIONS(5491),
    [anon_sym_not_eq] = ACTIONS(5491),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_DOT] = ACTIONS(5491),
    [anon_sym_DOT_STAR] = ACTIONS(5489),
    [anon_sym_DASH_GT] = ACTIONS(5489),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5491),
    [anon_sym_decltype] = ACTIONS(5491),
    [anon_sym_final] = ACTIONS(5491),
    [anon_sym_override] = ACTIONS(5491),
    [anon_sym_GT2] = ACTIONS(5489),
    [anon_sym_requires] = ACTIONS(5491),
  },
  [2652] = {
    [sym_identifier] = ACTIONS(5590),
    [aux_sym_preproc_def_token1] = ACTIONS(5590),
    [aux_sym_preproc_if_token1] = ACTIONS(5590),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5590),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5590),
    [sym_preproc_directive] = ACTIONS(5590),
    [anon_sym_LPAREN2] = ACTIONS(5592),
    [anon_sym_TILDE] = ACTIONS(5592),
    [anon_sym_STAR] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym___extension__] = ACTIONS(5590),
    [anon_sym_typedef] = ACTIONS(5590),
    [anon_sym_extern] = ACTIONS(5590),
    [anon_sym___attribute__] = ACTIONS(5590),
    [anon_sym_COLON_COLON] = ACTIONS(5592),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5592),
    [anon_sym___declspec] = ACTIONS(5590),
    [anon_sym___based] = ACTIONS(5590),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_signed] = ACTIONS(5590),
    [anon_sym_unsigned] = ACTIONS(5590),
    [anon_sym_long] = ACTIONS(5590),
    [anon_sym_short] = ACTIONS(5590),
    [anon_sym_LBRACK] = ACTIONS(5590),
    [anon_sym_static] = ACTIONS(5590),
    [anon_sym_register] = ACTIONS(5590),
    [anon_sym_inline] = ACTIONS(5590),
    [anon_sym___inline] = ACTIONS(5590),
    [anon_sym___inline__] = ACTIONS(5590),
    [anon_sym___forceinline] = ACTIONS(5590),
    [anon_sym_thread_local] = ACTIONS(5590),
    [anon_sym___thread] = ACTIONS(5590),
    [anon_sym_const] = ACTIONS(5590),
    [anon_sym_constexpr] = ACTIONS(5590),
    [anon_sym_volatile] = ACTIONS(5590),
    [anon_sym_restrict] = ACTIONS(5590),
    [anon_sym___restrict__] = ACTIONS(5590),
    [anon_sym__Atomic] = ACTIONS(5590),
    [anon_sym__Noreturn] = ACTIONS(5590),
    [anon_sym_noreturn] = ACTIONS(5590),
    [anon_sym_mutable] = ACTIONS(5590),
    [anon_sym_constinit] = ACTIONS(5590),
    [anon_sym_consteval] = ACTIONS(5590),
    [anon_sym_PROGMEM] = ACTIONS(5590),
    [aux_sym_primitive_type_token1] = ACTIONS(5590),
    [anon_sym_byte] = ACTIONS(5590),
    [anon_sym_word] = ACTIONS(5590),
    [anon_sym_enum] = ACTIONS(5590),
    [anon_sym_class] = ACTIONS(5590),
    [anon_sym_struct] = ACTIONS(5590),
    [anon_sym_union] = ACTIONS(5590),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5590),
    [anon_sym_decltype] = ACTIONS(5590),
    [anon_sym_virtual] = ACTIONS(5590),
    [anon_sym_alignas] = ACTIONS(5590),
    [anon_sym_explicit] = ACTIONS(5590),
    [anon_sym_typename] = ACTIONS(5590),
    [anon_sym_template] = ACTIONS(5590),
    [anon_sym_operator] = ACTIONS(5590),
    [anon_sym_friend] = ACTIONS(5590),
    [anon_sym_public] = ACTIONS(5590),
    [anon_sym_private] = ACTIONS(5590),
    [anon_sym_protected] = ACTIONS(5590),
    [anon_sym_using] = ACTIONS(5590),
    [anon_sym_static_assert] = ACTIONS(5590),
  },
  [2653] = {
    [sym_identifier] = ACTIONS(3371),
    [aux_sym_preproc_def_token1] = ACTIONS(3371),
    [aux_sym_preproc_if_token1] = ACTIONS(3371),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3371),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3371),
    [sym_preproc_directive] = ACTIONS(3371),
    [anon_sym_LPAREN2] = ACTIONS(3373),
    [anon_sym_TILDE] = ACTIONS(3373),
    [anon_sym_STAR] = ACTIONS(3373),
    [anon_sym_AMP_AMP] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3371),
    [anon_sym___extension__] = ACTIONS(3371),
    [anon_sym_typedef] = ACTIONS(3371),
    [anon_sym_extern] = ACTIONS(3371),
    [anon_sym___attribute__] = ACTIONS(3371),
    [anon_sym_COLON_COLON] = ACTIONS(3373),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3373),
    [anon_sym___declspec] = ACTIONS(3371),
    [anon_sym___based] = ACTIONS(3371),
    [anon_sym_RBRACE] = ACTIONS(3373),
    [anon_sym_signed] = ACTIONS(3371),
    [anon_sym_unsigned] = ACTIONS(3371),
    [anon_sym_long] = ACTIONS(3371),
    [anon_sym_short] = ACTIONS(3371),
    [anon_sym_LBRACK] = ACTIONS(3371),
    [anon_sym_static] = ACTIONS(3371),
    [anon_sym_register] = ACTIONS(3371),
    [anon_sym_inline] = ACTIONS(3371),
    [anon_sym___inline] = ACTIONS(3371),
    [anon_sym___inline__] = ACTIONS(3371),
    [anon_sym___forceinline] = ACTIONS(3371),
    [anon_sym_thread_local] = ACTIONS(3371),
    [anon_sym___thread] = ACTIONS(3371),
    [anon_sym_const] = ACTIONS(3371),
    [anon_sym_constexpr] = ACTIONS(3371),
    [anon_sym_volatile] = ACTIONS(3371),
    [anon_sym_restrict] = ACTIONS(3371),
    [anon_sym___restrict__] = ACTIONS(3371),
    [anon_sym__Atomic] = ACTIONS(3371),
    [anon_sym__Noreturn] = ACTIONS(3371),
    [anon_sym_noreturn] = ACTIONS(3371),
    [anon_sym_mutable] = ACTIONS(3371),
    [anon_sym_constinit] = ACTIONS(3371),
    [anon_sym_consteval] = ACTIONS(3371),
    [anon_sym_PROGMEM] = ACTIONS(3371),
    [aux_sym_primitive_type_token1] = ACTIONS(3371),
    [anon_sym_byte] = ACTIONS(3371),
    [anon_sym_word] = ACTIONS(3371),
    [anon_sym_enum] = ACTIONS(3371),
    [anon_sym_class] = ACTIONS(3371),
    [anon_sym_struct] = ACTIONS(3371),
    [anon_sym_union] = ACTIONS(3371),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3371),
    [anon_sym_decltype] = ACTIONS(3371),
    [anon_sym_virtual] = ACTIONS(3371),
    [anon_sym_alignas] = ACTIONS(3371),
    [anon_sym_explicit] = ACTIONS(3371),
    [anon_sym_typename] = ACTIONS(3371),
    [anon_sym_template] = ACTIONS(3371),
    [anon_sym_operator] = ACTIONS(3371),
    [anon_sym_friend] = ACTIONS(3371),
    [anon_sym_public] = ACTIONS(3371),
    [anon_sym_private] = ACTIONS(3371),
    [anon_sym_protected] = ACTIONS(3371),
    [anon_sym_using] = ACTIONS(3371),
    [anon_sym_static_assert] = ACTIONS(3371),
  },
  [2654] = {
    [sym_identifier] = ACTIONS(3993),
    [aux_sym_preproc_def_token1] = ACTIONS(3993),
    [aux_sym_preproc_if_token1] = ACTIONS(3993),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3993),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3993),
    [sym_preproc_directive] = ACTIONS(3993),
    [anon_sym_LPAREN2] = ACTIONS(3991),
    [anon_sym_TILDE] = ACTIONS(3991),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym___extension__] = ACTIONS(3993),
    [anon_sym_typedef] = ACTIONS(3993),
    [anon_sym_extern] = ACTIONS(3993),
    [anon_sym___attribute__] = ACTIONS(3993),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3991),
    [anon_sym___declspec] = ACTIONS(3993),
    [anon_sym___based] = ACTIONS(3993),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_signed] = ACTIONS(3993),
    [anon_sym_unsigned] = ACTIONS(3993),
    [anon_sym_long] = ACTIONS(3993),
    [anon_sym_short] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3993),
    [anon_sym_static] = ACTIONS(3993),
    [anon_sym_register] = ACTIONS(3993),
    [anon_sym_inline] = ACTIONS(3993),
    [anon_sym___inline] = ACTIONS(3993),
    [anon_sym___inline__] = ACTIONS(3993),
    [anon_sym___forceinline] = ACTIONS(3993),
    [anon_sym_thread_local] = ACTIONS(3993),
    [anon_sym___thread] = ACTIONS(3993),
    [anon_sym_const] = ACTIONS(3993),
    [anon_sym_constexpr] = ACTIONS(3993),
    [anon_sym_volatile] = ACTIONS(3993),
    [anon_sym_restrict] = ACTIONS(3993),
    [anon_sym___restrict__] = ACTIONS(3993),
    [anon_sym__Atomic] = ACTIONS(3993),
    [anon_sym__Noreturn] = ACTIONS(3993),
    [anon_sym_noreturn] = ACTIONS(3993),
    [anon_sym_mutable] = ACTIONS(3993),
    [anon_sym_constinit] = ACTIONS(3993),
    [anon_sym_consteval] = ACTIONS(3993),
    [anon_sym_PROGMEM] = ACTIONS(3993),
    [aux_sym_primitive_type_token1] = ACTIONS(3993),
    [anon_sym_byte] = ACTIONS(3993),
    [anon_sym_word] = ACTIONS(3993),
    [anon_sym_enum] = ACTIONS(3993),
    [anon_sym_class] = ACTIONS(3993),
    [anon_sym_struct] = ACTIONS(3993),
    [anon_sym_union] = ACTIONS(3993),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3993),
    [anon_sym_decltype] = ACTIONS(3993),
    [anon_sym_virtual] = ACTIONS(3993),
    [anon_sym_alignas] = ACTIONS(3993),
    [anon_sym_explicit] = ACTIONS(3993),
    [anon_sym_typename] = ACTIONS(3993),
    [anon_sym_template] = ACTIONS(3993),
    [anon_sym_operator] = ACTIONS(3993),
    [anon_sym_friend] = ACTIONS(3993),
    [anon_sym_public] = ACTIONS(3993),
    [anon_sym_private] = ACTIONS(3993),
    [anon_sym_protected] = ACTIONS(3993),
    [anon_sym_using] = ACTIONS(3993),
    [anon_sym_static_assert] = ACTIONS(3993),
  },
  [2655] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token2] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(3082),
    [anon_sym_private] = ACTIONS(3082),
    [anon_sym_protected] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
  },
  [2656] = {
    [sym_identifier] = ACTIONS(3435),
    [aux_sym_preproc_def_token1] = ACTIONS(3435),
    [aux_sym_preproc_if_token1] = ACTIONS(3435),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3435),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3435),
    [sym_preproc_directive] = ACTIONS(3435),
    [anon_sym_LPAREN2] = ACTIONS(3437),
    [anon_sym_TILDE] = ACTIONS(3437),
    [anon_sym_STAR] = ACTIONS(3437),
    [anon_sym_AMP_AMP] = ACTIONS(3437),
    [anon_sym_AMP] = ACTIONS(3435),
    [anon_sym___extension__] = ACTIONS(3435),
    [anon_sym_typedef] = ACTIONS(3435),
    [anon_sym_extern] = ACTIONS(3435),
    [anon_sym___attribute__] = ACTIONS(3435),
    [anon_sym_COLON_COLON] = ACTIONS(3437),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3437),
    [anon_sym___declspec] = ACTIONS(3435),
    [anon_sym___based] = ACTIONS(3435),
    [anon_sym_RBRACE] = ACTIONS(3437),
    [anon_sym_signed] = ACTIONS(3435),
    [anon_sym_unsigned] = ACTIONS(3435),
    [anon_sym_long] = ACTIONS(3435),
    [anon_sym_short] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3435),
    [anon_sym_static] = ACTIONS(3435),
    [anon_sym_register] = ACTIONS(3435),
    [anon_sym_inline] = ACTIONS(3435),
    [anon_sym___inline] = ACTIONS(3435),
    [anon_sym___inline__] = ACTIONS(3435),
    [anon_sym___forceinline] = ACTIONS(3435),
    [anon_sym_thread_local] = ACTIONS(3435),
    [anon_sym___thread] = ACTIONS(3435),
    [anon_sym_const] = ACTIONS(3435),
    [anon_sym_constexpr] = ACTIONS(3435),
    [anon_sym_volatile] = ACTIONS(3435),
    [anon_sym_restrict] = ACTIONS(3435),
    [anon_sym___restrict__] = ACTIONS(3435),
    [anon_sym__Atomic] = ACTIONS(3435),
    [anon_sym__Noreturn] = ACTIONS(3435),
    [anon_sym_noreturn] = ACTIONS(3435),
    [anon_sym_mutable] = ACTIONS(3435),
    [anon_sym_constinit] = ACTIONS(3435),
    [anon_sym_consteval] = ACTIONS(3435),
    [anon_sym_PROGMEM] = ACTIONS(3435),
    [aux_sym_primitive_type_token1] = ACTIONS(3435),
    [anon_sym_byte] = ACTIONS(3435),
    [anon_sym_word] = ACTIONS(3435),
    [anon_sym_enum] = ACTIONS(3435),
    [anon_sym_class] = ACTIONS(3435),
    [anon_sym_struct] = ACTIONS(3435),
    [anon_sym_union] = ACTIONS(3435),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3435),
    [anon_sym_decltype] = ACTIONS(3435),
    [anon_sym_virtual] = ACTIONS(3435),
    [anon_sym_alignas] = ACTIONS(3435),
    [anon_sym_explicit] = ACTIONS(3435),
    [anon_sym_typename] = ACTIONS(3435),
    [anon_sym_template] = ACTIONS(3435),
    [anon_sym_operator] = ACTIONS(3435),
    [anon_sym_friend] = ACTIONS(3435),
    [anon_sym_public] = ACTIONS(3435),
    [anon_sym_private] = ACTIONS(3435),
    [anon_sym_protected] = ACTIONS(3435),
    [anon_sym_using] = ACTIONS(3435),
    [anon_sym_static_assert] = ACTIONS(3435),
  },
  [2657] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token2] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(3082),
    [anon_sym_private] = ACTIONS(3082),
    [anon_sym_protected] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
  },
  [2658] = {
    [sym_identifier] = ACTIONS(2970),
    [aux_sym_preproc_def_token1] = ACTIONS(2970),
    [aux_sym_preproc_if_token1] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2970),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2970),
    [sym_preproc_directive] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym___extension__] = ACTIONS(2970),
    [anon_sym_typedef] = ACTIONS(2970),
    [anon_sym_extern] = ACTIONS(2970),
    [anon_sym___attribute__] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2970),
    [anon_sym___based] = ACTIONS(2970),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_signed] = ACTIONS(2970),
    [anon_sym_unsigned] = ACTIONS(2970),
    [anon_sym_long] = ACTIONS(2970),
    [anon_sym_short] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_register] = ACTIONS(2970),
    [anon_sym_inline] = ACTIONS(2970),
    [anon_sym___inline] = ACTIONS(2970),
    [anon_sym___inline__] = ACTIONS(2970),
    [anon_sym___forceinline] = ACTIONS(2970),
    [anon_sym_thread_local] = ACTIONS(2970),
    [anon_sym___thread] = ACTIONS(2970),
    [anon_sym_const] = ACTIONS(2970),
    [anon_sym_constexpr] = ACTIONS(2970),
    [anon_sym_volatile] = ACTIONS(2970),
    [anon_sym_restrict] = ACTIONS(2970),
    [anon_sym___restrict__] = ACTIONS(2970),
    [anon_sym__Atomic] = ACTIONS(2970),
    [anon_sym__Noreturn] = ACTIONS(2970),
    [anon_sym_noreturn] = ACTIONS(2970),
    [anon_sym_mutable] = ACTIONS(2970),
    [anon_sym_constinit] = ACTIONS(2970),
    [anon_sym_consteval] = ACTIONS(2970),
    [anon_sym_PROGMEM] = ACTIONS(2970),
    [aux_sym_primitive_type_token1] = ACTIONS(2970),
    [anon_sym_byte] = ACTIONS(2970),
    [anon_sym_word] = ACTIONS(2970),
    [anon_sym_enum] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_struct] = ACTIONS(2970),
    [anon_sym_union] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2970),
    [anon_sym_decltype] = ACTIONS(2970),
    [anon_sym_virtual] = ACTIONS(2970),
    [anon_sym_alignas] = ACTIONS(2970),
    [anon_sym_explicit] = ACTIONS(2970),
    [anon_sym_typename] = ACTIONS(2970),
    [anon_sym_template] = ACTIONS(2970),
    [anon_sym_operator] = ACTIONS(2970),
    [anon_sym_friend] = ACTIONS(2970),
    [anon_sym_public] = ACTIONS(2970),
    [anon_sym_private] = ACTIONS(2970),
    [anon_sym_protected] = ACTIONS(2970),
    [anon_sym_using] = ACTIONS(2970),
    [anon_sym_static_assert] = ACTIONS(2970),
  },
  [2659] = {
    [sym_identifier] = ACTIONS(5582),
    [aux_sym_preproc_def_token1] = ACTIONS(5582),
    [aux_sym_preproc_if_token1] = ACTIONS(5582),
    [aux_sym_preproc_if_token2] = ACTIONS(5582),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5582),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5582),
    [sym_preproc_directive] = ACTIONS(5582),
    [anon_sym_LPAREN2] = ACTIONS(5584),
    [anon_sym_TILDE] = ACTIONS(5584),
    [anon_sym_STAR] = ACTIONS(5584),
    [anon_sym_AMP_AMP] = ACTIONS(5584),
    [anon_sym_AMP] = ACTIONS(5582),
    [anon_sym___extension__] = ACTIONS(5582),
    [anon_sym_typedef] = ACTIONS(5582),
    [anon_sym_extern] = ACTIONS(5582),
    [anon_sym___attribute__] = ACTIONS(5582),
    [anon_sym_COLON_COLON] = ACTIONS(5584),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5584),
    [anon_sym___declspec] = ACTIONS(5582),
    [anon_sym___based] = ACTIONS(5582),
    [anon_sym_signed] = ACTIONS(5582),
    [anon_sym_unsigned] = ACTIONS(5582),
    [anon_sym_long] = ACTIONS(5582),
    [anon_sym_short] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(5582),
    [anon_sym_static] = ACTIONS(5582),
    [anon_sym_register] = ACTIONS(5582),
    [anon_sym_inline] = ACTIONS(5582),
    [anon_sym___inline] = ACTIONS(5582),
    [anon_sym___inline__] = ACTIONS(5582),
    [anon_sym___forceinline] = ACTIONS(5582),
    [anon_sym_thread_local] = ACTIONS(5582),
    [anon_sym___thread] = ACTIONS(5582),
    [anon_sym_const] = ACTIONS(5582),
    [anon_sym_constexpr] = ACTIONS(5582),
    [anon_sym_volatile] = ACTIONS(5582),
    [anon_sym_restrict] = ACTIONS(5582),
    [anon_sym___restrict__] = ACTIONS(5582),
    [anon_sym__Atomic] = ACTIONS(5582),
    [anon_sym__Noreturn] = ACTIONS(5582),
    [anon_sym_noreturn] = ACTIONS(5582),
    [anon_sym_mutable] = ACTIONS(5582),
    [anon_sym_constinit] = ACTIONS(5582),
    [anon_sym_consteval] = ACTIONS(5582),
    [anon_sym_PROGMEM] = ACTIONS(5582),
    [aux_sym_primitive_type_token1] = ACTIONS(5582),
    [anon_sym_byte] = ACTIONS(5582),
    [anon_sym_word] = ACTIONS(5582),
    [anon_sym_enum] = ACTIONS(5582),
    [anon_sym_class] = ACTIONS(5582),
    [anon_sym_struct] = ACTIONS(5582),
    [anon_sym_union] = ACTIONS(5582),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5582),
    [anon_sym_decltype] = ACTIONS(5582),
    [anon_sym_virtual] = ACTIONS(5582),
    [anon_sym_alignas] = ACTIONS(5582),
    [anon_sym_explicit] = ACTIONS(5582),
    [anon_sym_typename] = ACTIONS(5582),
    [anon_sym_template] = ACTIONS(5582),
    [anon_sym_operator] = ACTIONS(5582),
    [anon_sym_friend] = ACTIONS(5582),
    [anon_sym_public] = ACTIONS(5582),
    [anon_sym_private] = ACTIONS(5582),
    [anon_sym_protected] = ACTIONS(5582),
    [anon_sym_using] = ACTIONS(5582),
    [anon_sym_static_assert] = ACTIONS(5582),
  },
  [2660] = {
    [sym_identifier] = ACTIONS(3086),
    [aux_sym_preproc_def_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token2] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3086),
    [sym_preproc_directive] = ACTIONS(3086),
    [anon_sym_LPAREN2] = ACTIONS(3088),
    [anon_sym_TILDE] = ACTIONS(3088),
    [anon_sym_STAR] = ACTIONS(3088),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym___extension__] = ACTIONS(3086),
    [anon_sym_typedef] = ACTIONS(3086),
    [anon_sym_extern] = ACTIONS(3086),
    [anon_sym___attribute__] = ACTIONS(3086),
    [anon_sym_COLON_COLON] = ACTIONS(3088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3088),
    [anon_sym___declspec] = ACTIONS(3086),
    [anon_sym___based] = ACTIONS(3086),
    [anon_sym_signed] = ACTIONS(3086),
    [anon_sym_unsigned] = ACTIONS(3086),
    [anon_sym_long] = ACTIONS(3086),
    [anon_sym_short] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(3086),
    [anon_sym_static] = ACTIONS(3086),
    [anon_sym_register] = ACTIONS(3086),
    [anon_sym_inline] = ACTIONS(3086),
    [anon_sym___inline] = ACTIONS(3086),
    [anon_sym___inline__] = ACTIONS(3086),
    [anon_sym___forceinline] = ACTIONS(3086),
    [anon_sym_thread_local] = ACTIONS(3086),
    [anon_sym___thread] = ACTIONS(3086),
    [anon_sym_const] = ACTIONS(3086),
    [anon_sym_constexpr] = ACTIONS(3086),
    [anon_sym_volatile] = ACTIONS(3086),
    [anon_sym_restrict] = ACTIONS(3086),
    [anon_sym___restrict__] = ACTIONS(3086),
    [anon_sym__Atomic] = ACTIONS(3086),
    [anon_sym__Noreturn] = ACTIONS(3086),
    [anon_sym_noreturn] = ACTIONS(3086),
    [anon_sym_mutable] = ACTIONS(3086),
    [anon_sym_constinit] = ACTIONS(3086),
    [anon_sym_consteval] = ACTIONS(3086),
    [anon_sym_PROGMEM] = ACTIONS(3086),
    [aux_sym_primitive_type_token1] = ACTIONS(3086),
    [anon_sym_byte] = ACTIONS(3086),
    [anon_sym_word] = ACTIONS(3086),
    [anon_sym_enum] = ACTIONS(3086),
    [anon_sym_class] = ACTIONS(3086),
    [anon_sym_struct] = ACTIONS(3086),
    [anon_sym_union] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3086),
    [anon_sym_decltype] = ACTIONS(3086),
    [anon_sym_virtual] = ACTIONS(3086),
    [anon_sym_alignas] = ACTIONS(3086),
    [anon_sym_explicit] = ACTIONS(3086),
    [anon_sym_typename] = ACTIONS(3086),
    [anon_sym_template] = ACTIONS(3086),
    [anon_sym_operator] = ACTIONS(3086),
    [anon_sym_friend] = ACTIONS(3086),
    [anon_sym_public] = ACTIONS(3086),
    [anon_sym_private] = ACTIONS(3086),
    [anon_sym_protected] = ACTIONS(3086),
    [anon_sym_using] = ACTIONS(3086),
    [anon_sym_static_assert] = ACTIONS(3086),
  },
  [2661] = {
    [sym_identifier] = ACTIONS(5481),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5483),
    [anon_sym_COMMA] = ACTIONS(5483),
    [anon_sym_RPAREN] = ACTIONS(5483),
    [aux_sym_preproc_if_token2] = ACTIONS(5483),
    [aux_sym_preproc_else_token1] = ACTIONS(5483),
    [aux_sym_preproc_elif_token1] = ACTIONS(5481),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5483),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5483),
    [anon_sym_LPAREN2] = ACTIONS(5483),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_PLUS] = ACTIONS(5481),
    [anon_sym_STAR] = ACTIONS(5483),
    [anon_sym_SLASH] = ACTIONS(5481),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_PIPE_PIPE] = ACTIONS(5483),
    [anon_sym_AMP_AMP] = ACTIONS(5483),
    [anon_sym_PIPE] = ACTIONS(5481),
    [anon_sym_CARET] = ACTIONS(5483),
    [anon_sym_AMP] = ACTIONS(5481),
    [anon_sym_EQ_EQ] = ACTIONS(5483),
    [anon_sym_BANG_EQ] = ACTIONS(5483),
    [anon_sym_GT] = ACTIONS(5481),
    [anon_sym_GT_EQ] = ACTIONS(5483),
    [anon_sym_LT_EQ] = ACTIONS(5481),
    [anon_sym_LT] = ACTIONS(5481),
    [anon_sym_LT_LT] = ACTIONS(5483),
    [anon_sym_GT_GT] = ACTIONS(5483),
    [anon_sym_SEMI] = ACTIONS(5483),
    [anon_sym___extension__] = ACTIONS(5481),
    [anon_sym___attribute__] = ACTIONS(5481),
    [anon_sym_LBRACE] = ACTIONS(5483),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_LBRACK] = ACTIONS(5483),
    [anon_sym_RBRACK] = ACTIONS(5483),
    [anon_sym_const] = ACTIONS(5481),
    [anon_sym_constexpr] = ACTIONS(5481),
    [anon_sym_volatile] = ACTIONS(5481),
    [anon_sym_restrict] = ACTIONS(5481),
    [anon_sym___restrict__] = ACTIONS(5481),
    [anon_sym__Atomic] = ACTIONS(5481),
    [anon_sym__Noreturn] = ACTIONS(5481),
    [anon_sym_noreturn] = ACTIONS(5481),
    [anon_sym_mutable] = ACTIONS(5481),
    [anon_sym_constinit] = ACTIONS(5481),
    [anon_sym_consteval] = ACTIONS(5481),
    [anon_sym_PROGMEM] = ACTIONS(5481),
    [anon_sym_COLON] = ACTIONS(5483),
    [anon_sym_QMARK] = ACTIONS(5483),
    [anon_sym_LT_EQ_GT] = ACTIONS(5483),
    [anon_sym_or] = ACTIONS(5481),
    [anon_sym_and] = ACTIONS(5481),
    [anon_sym_bitor] = ACTIONS(5481),
    [anon_sym_xor] = ACTIONS(5481),
    [anon_sym_bitand] = ACTIONS(5481),
    [anon_sym_not_eq] = ACTIONS(5481),
    [anon_sym_DASH_DASH] = ACTIONS(5483),
    [anon_sym_PLUS_PLUS] = ACTIONS(5483),
    [anon_sym_DOT] = ACTIONS(5481),
    [anon_sym_DOT_STAR] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5481),
    [anon_sym_decltype] = ACTIONS(5481),
    [anon_sym_final] = ACTIONS(5481),
    [anon_sym_override] = ACTIONS(5481),
    [anon_sym_requires] = ACTIONS(5481),
  },
  [2662] = {
    [sym_attribute_declaration] = STATE(2729),
    [sym_parameter_list] = STATE(2784),
    [aux_sym_attributed_declarator_repeat1] = STATE(2729),
    [sym_identifier] = ACTIONS(5996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5998),
    [anon_sym_COMMA] = ACTIONS(5998),
    [anon_sym_RPAREN] = ACTIONS(5998),
    [aux_sym_preproc_if_token2] = ACTIONS(5998),
    [aux_sym_preproc_else_token1] = ACTIONS(5998),
    [aux_sym_preproc_elif_token1] = ACTIONS(5996),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5998),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5998),
    [anon_sym_LPAREN2] = ACTIONS(6000),
    [anon_sym_DASH] = ACTIONS(5996),
    [anon_sym_PLUS] = ACTIONS(5996),
    [anon_sym_STAR] = ACTIONS(5996),
    [anon_sym_SLASH] = ACTIONS(5996),
    [anon_sym_PERCENT] = ACTIONS(5996),
    [anon_sym_PIPE_PIPE] = ACTIONS(5998),
    [anon_sym_AMP_AMP] = ACTIONS(5998),
    [anon_sym_PIPE] = ACTIONS(5996),
    [anon_sym_CARET] = ACTIONS(5996),
    [anon_sym_AMP] = ACTIONS(5996),
    [anon_sym_EQ_EQ] = ACTIONS(5998),
    [anon_sym_BANG_EQ] = ACTIONS(5998),
    [anon_sym_GT] = ACTIONS(5996),
    [anon_sym_GT_EQ] = ACTIONS(5998),
    [anon_sym_LT_EQ] = ACTIONS(5996),
    [anon_sym_LT] = ACTIONS(5996),
    [anon_sym_LT_LT] = ACTIONS(5996),
    [anon_sym_GT_GT] = ACTIONS(5996),
    [anon_sym_SEMI] = ACTIONS(5998),
    [anon_sym___attribute__] = ACTIONS(5996),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6002),
    [anon_sym_RBRACE] = ACTIONS(5998),
    [anon_sym_LBRACK] = ACTIONS(6004),
    [anon_sym_RBRACK] = ACTIONS(5998),
    [anon_sym_EQ] = ACTIONS(5996),
    [anon_sym_COLON] = ACTIONS(5998),
    [anon_sym_QMARK] = ACTIONS(5998),
    [anon_sym_STAR_EQ] = ACTIONS(5998),
    [anon_sym_SLASH_EQ] = ACTIONS(5998),
    [anon_sym_PERCENT_EQ] = ACTIONS(5998),
    [anon_sym_PLUS_EQ] = ACTIONS(5998),
    [anon_sym_DASH_EQ] = ACTIONS(5998),
    [anon_sym_LT_LT_EQ] = ACTIONS(5998),
    [anon_sym_GT_GT_EQ] = ACTIONS(5998),
    [anon_sym_AMP_EQ] = ACTIONS(5998),
    [anon_sym_CARET_EQ] = ACTIONS(5998),
    [anon_sym_PIPE_EQ] = ACTIONS(5998),
    [anon_sym_and_eq] = ACTIONS(5996),
    [anon_sym_or_eq] = ACTIONS(5996),
    [anon_sym_xor_eq] = ACTIONS(5996),
    [anon_sym_LT_EQ_GT] = ACTIONS(5998),
    [anon_sym_or] = ACTIONS(5996),
    [anon_sym_and] = ACTIONS(5996),
    [anon_sym_bitor] = ACTIONS(5996),
    [anon_sym_xor] = ACTIONS(5996),
    [anon_sym_bitand] = ACTIONS(5996),
    [anon_sym_not_eq] = ACTIONS(5996),
    [anon_sym_DASH_DASH] = ACTIONS(5998),
    [anon_sym_PLUS_PLUS] = ACTIONS(5998),
    [anon_sym_DOT] = ACTIONS(5996),
    [anon_sym_DOT_STAR] = ACTIONS(5998),
    [anon_sym_DASH_GT] = ACTIONS(5998),
    [sym_comment] = ACTIONS(3),
  },
  [2663] = {
    [sym_identifier] = ACTIONS(6006),
    [anon_sym_LPAREN2] = ACTIONS(6008),
    [anon_sym_TILDE] = ACTIONS(6008),
    [anon_sym_STAR] = ACTIONS(6008),
    [anon_sym_PIPE_PIPE] = ACTIONS(6010),
    [anon_sym_AMP_AMP] = ACTIONS(6012),
    [anon_sym_AMP] = ACTIONS(6006),
    [anon_sym___extension__] = ACTIONS(6006),
    [anon_sym_extern] = ACTIONS(6006),
    [anon_sym___attribute__] = ACTIONS(6006),
    [anon_sym_COLON_COLON] = ACTIONS(6008),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6008),
    [anon_sym___declspec] = ACTIONS(6006),
    [anon_sym___based] = ACTIONS(6006),
    [anon_sym___cdecl] = ACTIONS(6006),
    [anon_sym___clrcall] = ACTIONS(6006),
    [anon_sym___stdcall] = ACTIONS(6006),
    [anon_sym___fastcall] = ACTIONS(6006),
    [anon_sym___thiscall] = ACTIONS(6006),
    [anon_sym___vectorcall] = ACTIONS(6006),
    [anon_sym_signed] = ACTIONS(6006),
    [anon_sym_unsigned] = ACTIONS(6006),
    [anon_sym_long] = ACTIONS(6006),
    [anon_sym_short] = ACTIONS(6006),
    [anon_sym_LBRACK] = ACTIONS(6006),
    [anon_sym_static] = ACTIONS(6006),
    [anon_sym_register] = ACTIONS(6006),
    [anon_sym_inline] = ACTIONS(6006),
    [anon_sym___inline] = ACTIONS(6006),
    [anon_sym___inline__] = ACTIONS(6006),
    [anon_sym___forceinline] = ACTIONS(6006),
    [anon_sym_thread_local] = ACTIONS(6006),
    [anon_sym___thread] = ACTIONS(6006),
    [anon_sym_const] = ACTIONS(6006),
    [anon_sym_constexpr] = ACTIONS(6006),
    [anon_sym_volatile] = ACTIONS(6006),
    [anon_sym_restrict] = ACTIONS(6006),
    [anon_sym___restrict__] = ACTIONS(6006),
    [anon_sym__Atomic] = ACTIONS(6006),
    [anon_sym__Noreturn] = ACTIONS(6006),
    [anon_sym_noreturn] = ACTIONS(6006),
    [anon_sym_mutable] = ACTIONS(6006),
    [anon_sym_constinit] = ACTIONS(6006),
    [anon_sym_consteval] = ACTIONS(6006),
    [anon_sym_PROGMEM] = ACTIONS(6006),
    [aux_sym_primitive_type_token1] = ACTIONS(6006),
    [anon_sym_byte] = ACTIONS(6006),
    [anon_sym_word] = ACTIONS(6006),
    [anon_sym_enum] = ACTIONS(6006),
    [anon_sym_class] = ACTIONS(6006),
    [anon_sym_struct] = ACTIONS(6006),
    [anon_sym_union] = ACTIONS(6006),
    [anon_sym_or] = ACTIONS(6014),
    [anon_sym_and] = ACTIONS(6016),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6006),
    [anon_sym_decltype] = ACTIONS(6006),
    [anon_sym_virtual] = ACTIONS(6006),
    [anon_sym_alignas] = ACTIONS(6006),
    [anon_sym_explicit] = ACTIONS(6006),
    [anon_sym_typename] = ACTIONS(6006),
    [anon_sym_template] = ACTIONS(6006),
    [anon_sym_operator] = ACTIONS(6006),
    [anon_sym_friend] = ACTIONS(6006),
    [anon_sym_using] = ACTIONS(6006),
    [anon_sym_concept] = ACTIONS(6006),
  },
  [2664] = {
    [sym_identifier] = ACTIONS(5626),
    [anon_sym_LPAREN2] = ACTIONS(5628),
    [anon_sym_TILDE] = ACTIONS(5628),
    [anon_sym_STAR] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE] = ACTIONS(5628),
    [anon_sym_AMP_AMP] = ACTIONS(5628),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym___extension__] = ACTIONS(5626),
    [anon_sym_extern] = ACTIONS(5626),
    [anon_sym___attribute__] = ACTIONS(5626),
    [anon_sym_COLON_COLON] = ACTIONS(5485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5628),
    [anon_sym___declspec] = ACTIONS(5626),
    [anon_sym___based] = ACTIONS(5626),
    [anon_sym___cdecl] = ACTIONS(5626),
    [anon_sym___clrcall] = ACTIONS(5626),
    [anon_sym___stdcall] = ACTIONS(5626),
    [anon_sym___fastcall] = ACTIONS(5626),
    [anon_sym___thiscall] = ACTIONS(5626),
    [anon_sym___vectorcall] = ACTIONS(5626),
    [anon_sym_signed] = ACTIONS(5626),
    [anon_sym_unsigned] = ACTIONS(5626),
    [anon_sym_long] = ACTIONS(5626),
    [anon_sym_short] = ACTIONS(5626),
    [anon_sym_LBRACK] = ACTIONS(5626),
    [anon_sym_static] = ACTIONS(5626),
    [anon_sym_register] = ACTIONS(5626),
    [anon_sym_inline] = ACTIONS(5626),
    [anon_sym___inline] = ACTIONS(5626),
    [anon_sym___inline__] = ACTIONS(5626),
    [anon_sym___forceinline] = ACTIONS(5626),
    [anon_sym_thread_local] = ACTIONS(5626),
    [anon_sym___thread] = ACTIONS(5626),
    [anon_sym_const] = ACTIONS(5626),
    [anon_sym_constexpr] = ACTIONS(5626),
    [anon_sym_volatile] = ACTIONS(5626),
    [anon_sym_restrict] = ACTIONS(5626),
    [anon_sym___restrict__] = ACTIONS(5626),
    [anon_sym__Atomic] = ACTIONS(5626),
    [anon_sym__Noreturn] = ACTIONS(5626),
    [anon_sym_noreturn] = ACTIONS(5626),
    [anon_sym_mutable] = ACTIONS(5626),
    [anon_sym_constinit] = ACTIONS(5626),
    [anon_sym_consteval] = ACTIONS(5626),
    [anon_sym_PROGMEM] = ACTIONS(5626),
    [aux_sym_primitive_type_token1] = ACTIONS(5626),
    [anon_sym_byte] = ACTIONS(5626),
    [anon_sym_word] = ACTIONS(5626),
    [anon_sym_enum] = ACTIONS(5626),
    [anon_sym_class] = ACTIONS(5626),
    [anon_sym_struct] = ACTIONS(5626),
    [anon_sym_union] = ACTIONS(5626),
    [anon_sym_or] = ACTIONS(5626),
    [anon_sym_and] = ACTIONS(5626),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5626),
    [anon_sym_decltype] = ACTIONS(5626),
    [anon_sym_virtual] = ACTIONS(5626),
    [anon_sym_alignas] = ACTIONS(5626),
    [anon_sym_explicit] = ACTIONS(5626),
    [anon_sym_typename] = ACTIONS(5626),
    [anon_sym_template] = ACTIONS(5626),
    [anon_sym_operator] = ACTIONS(5626),
    [anon_sym_friend] = ACTIONS(5626),
    [anon_sym_using] = ACTIONS(5626),
    [anon_sym_concept] = ACTIONS(5626),
  },
  [2665] = {
    [sym_identifier] = ACTIONS(5626),
    [anon_sym_LPAREN2] = ACTIONS(5628),
    [anon_sym_TILDE] = ACTIONS(5628),
    [anon_sym_STAR] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE] = ACTIONS(5628),
    [anon_sym_AMP_AMP] = ACTIONS(5628),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym___extension__] = ACTIONS(5626),
    [anon_sym_extern] = ACTIONS(5626),
    [anon_sym___attribute__] = ACTIONS(5626),
    [anon_sym_COLON_COLON] = ACTIONS(5485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5628),
    [anon_sym___declspec] = ACTIONS(5626),
    [anon_sym___based] = ACTIONS(5626),
    [anon_sym___cdecl] = ACTIONS(5626),
    [anon_sym___clrcall] = ACTIONS(5626),
    [anon_sym___stdcall] = ACTIONS(5626),
    [anon_sym___fastcall] = ACTIONS(5626),
    [anon_sym___thiscall] = ACTIONS(5626),
    [anon_sym___vectorcall] = ACTIONS(5626),
    [anon_sym_signed] = ACTIONS(5626),
    [anon_sym_unsigned] = ACTIONS(5626),
    [anon_sym_long] = ACTIONS(5626),
    [anon_sym_short] = ACTIONS(5626),
    [anon_sym_LBRACK] = ACTIONS(5626),
    [anon_sym_static] = ACTIONS(5626),
    [anon_sym_register] = ACTIONS(5626),
    [anon_sym_inline] = ACTIONS(5626),
    [anon_sym___inline] = ACTIONS(5626),
    [anon_sym___inline__] = ACTIONS(5626),
    [anon_sym___forceinline] = ACTIONS(5626),
    [anon_sym_thread_local] = ACTIONS(5626),
    [anon_sym___thread] = ACTIONS(5626),
    [anon_sym_const] = ACTIONS(5626),
    [anon_sym_constexpr] = ACTIONS(5626),
    [anon_sym_volatile] = ACTIONS(5626),
    [anon_sym_restrict] = ACTIONS(5626),
    [anon_sym___restrict__] = ACTIONS(5626),
    [anon_sym__Atomic] = ACTIONS(5626),
    [anon_sym__Noreturn] = ACTIONS(5626),
    [anon_sym_noreturn] = ACTIONS(5626),
    [anon_sym_mutable] = ACTIONS(5626),
    [anon_sym_constinit] = ACTIONS(5626),
    [anon_sym_consteval] = ACTIONS(5626),
    [anon_sym_PROGMEM] = ACTIONS(5626),
    [aux_sym_primitive_type_token1] = ACTIONS(5626),
    [anon_sym_byte] = ACTIONS(5626),
    [anon_sym_word] = ACTIONS(5626),
    [anon_sym_enum] = ACTIONS(5626),
    [anon_sym_class] = ACTIONS(5626),
    [anon_sym_struct] = ACTIONS(5626),
    [anon_sym_union] = ACTIONS(5626),
    [anon_sym_or] = ACTIONS(5626),
    [anon_sym_and] = ACTIONS(5626),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5626),
    [anon_sym_decltype] = ACTIONS(5626),
    [anon_sym_virtual] = ACTIONS(5626),
    [anon_sym_alignas] = ACTIONS(5626),
    [anon_sym_explicit] = ACTIONS(5626),
    [anon_sym_typename] = ACTIONS(5626),
    [anon_sym_template] = ACTIONS(5626),
    [anon_sym_operator] = ACTIONS(5626),
    [anon_sym_friend] = ACTIONS(5626),
    [anon_sym_using] = ACTIONS(5626),
    [anon_sym_concept] = ACTIONS(5626),
  },
  [2666] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2063),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6018),
    [anon_sym_COMMA] = ACTIONS(6018),
    [anon_sym_RPAREN] = ACTIONS(6018),
    [anon_sym_LPAREN2] = ACTIONS(6018),
    [anon_sym_DASH] = ACTIONS(6020),
    [anon_sym_PLUS] = ACTIONS(6020),
    [anon_sym_STAR] = ACTIONS(6018),
    [anon_sym_SLASH] = ACTIONS(6020),
    [anon_sym_PERCENT] = ACTIONS(6018),
    [anon_sym_PIPE_PIPE] = ACTIONS(6018),
    [anon_sym_AMP_AMP] = ACTIONS(6018),
    [anon_sym_PIPE] = ACTIONS(6020),
    [anon_sym_CARET] = ACTIONS(6018),
    [anon_sym_AMP] = ACTIONS(6020),
    [anon_sym_EQ_EQ] = ACTIONS(6018),
    [anon_sym_BANG_EQ] = ACTIONS(6018),
    [anon_sym_GT] = ACTIONS(6020),
    [anon_sym_GT_EQ] = ACTIONS(6018),
    [anon_sym_LT_EQ] = ACTIONS(6020),
    [anon_sym_LT] = ACTIONS(6020),
    [anon_sym_LT_LT] = ACTIONS(6018),
    [anon_sym_GT_GT] = ACTIONS(6018),
    [anon_sym_SEMI] = ACTIONS(6018),
    [anon_sym___extension__] = ACTIONS(6018),
    [anon_sym___attribute__] = ACTIONS(6018),
    [anon_sym_LBRACE] = ACTIONS(6018),
    [anon_sym_RBRACE] = ACTIONS(6018),
    [anon_sym_signed] = ACTIONS(6022),
    [anon_sym_unsigned] = ACTIONS(6022),
    [anon_sym_long] = ACTIONS(6022),
    [anon_sym_short] = ACTIONS(6022),
    [anon_sym_LBRACK] = ACTIONS(6018),
    [anon_sym_RBRACK] = ACTIONS(6018),
    [anon_sym_const] = ACTIONS(6020),
    [anon_sym_constexpr] = ACTIONS(6018),
    [anon_sym_volatile] = ACTIONS(6018),
    [anon_sym_restrict] = ACTIONS(6018),
    [anon_sym___restrict__] = ACTIONS(6018),
    [anon_sym__Atomic] = ACTIONS(6018),
    [anon_sym__Noreturn] = ACTIONS(6018),
    [anon_sym_noreturn] = ACTIONS(6018),
    [anon_sym_mutable] = ACTIONS(6018),
    [anon_sym_constinit] = ACTIONS(6018),
    [anon_sym_consteval] = ACTIONS(6018),
    [anon_sym_PROGMEM] = ACTIONS(6018),
    [anon_sym_COLON] = ACTIONS(6018),
    [anon_sym_QMARK] = ACTIONS(6018),
    [anon_sym_LT_EQ_GT] = ACTIONS(6018),
    [anon_sym_or] = ACTIONS(6018),
    [anon_sym_and] = ACTIONS(6018),
    [anon_sym_bitor] = ACTIONS(6018),
    [anon_sym_xor] = ACTIONS(6018),
    [anon_sym_bitand] = ACTIONS(6018),
    [anon_sym_not_eq] = ACTIONS(6018),
    [anon_sym_DASH_DASH] = ACTIONS(6018),
    [anon_sym_PLUS_PLUS] = ACTIONS(6018),
    [anon_sym_DOT] = ACTIONS(6020),
    [anon_sym_DOT_STAR] = ACTIONS(6018),
    [anon_sym_DASH_GT] = ACTIONS(6018),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6018),
    [anon_sym_decltype] = ACTIONS(6018),
    [anon_sym_final] = ACTIONS(6018),
    [anon_sym_override] = ACTIONS(6018),
    [anon_sym_requires] = ACTIONS(6018),
  },
  [2667] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5413),
    [anon_sym_COMMA] = ACTIONS(5413),
    [anon_sym_RPAREN] = ACTIONS(5413),
    [anon_sym_LPAREN2] = ACTIONS(5413),
    [anon_sym_DASH] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5411),
    [anon_sym_STAR] = ACTIONS(5411),
    [anon_sym_SLASH] = ACTIONS(5411),
    [anon_sym_PERCENT] = ACTIONS(5411),
    [anon_sym_PIPE_PIPE] = ACTIONS(5413),
    [anon_sym_AMP_AMP] = ACTIONS(5413),
    [anon_sym_PIPE] = ACTIONS(5411),
    [anon_sym_CARET] = ACTIONS(5411),
    [anon_sym_AMP] = ACTIONS(5411),
    [anon_sym_EQ_EQ] = ACTIONS(5413),
    [anon_sym_BANG_EQ] = ACTIONS(5413),
    [anon_sym_GT] = ACTIONS(5411),
    [anon_sym_GT_EQ] = ACTIONS(5413),
    [anon_sym_LT_EQ] = ACTIONS(5411),
    [anon_sym_LT] = ACTIONS(5411),
    [anon_sym_LT_LT] = ACTIONS(5411),
    [anon_sym_GT_GT] = ACTIONS(5411),
    [anon_sym_SEMI] = ACTIONS(5413),
    [anon_sym_RBRACE] = ACTIONS(5413),
    [anon_sym_LBRACK] = ACTIONS(5413),
    [anon_sym_RBRACK] = ACTIONS(5413),
    [anon_sym_EQ] = ACTIONS(5411),
    [anon_sym_COLON] = ACTIONS(5413),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_STAR_EQ] = ACTIONS(5413),
    [anon_sym_SLASH_EQ] = ACTIONS(5413),
    [anon_sym_PERCENT_EQ] = ACTIONS(5413),
    [anon_sym_PLUS_EQ] = ACTIONS(5413),
    [anon_sym_DASH_EQ] = ACTIONS(5413),
    [anon_sym_LT_LT_EQ] = ACTIONS(5413),
    [anon_sym_GT_GT_EQ] = ACTIONS(5413),
    [anon_sym_AMP_EQ] = ACTIONS(5413),
    [anon_sym_CARET_EQ] = ACTIONS(5413),
    [anon_sym_PIPE_EQ] = ACTIONS(5413),
    [anon_sym_and_eq] = ACTIONS(5411),
    [anon_sym_or_eq] = ACTIONS(5411),
    [anon_sym_xor_eq] = ACTIONS(5411),
    [anon_sym_LT_EQ_GT] = ACTIONS(5413),
    [anon_sym_or] = ACTIONS(5411),
    [anon_sym_and] = ACTIONS(5411),
    [anon_sym_bitor] = ACTIONS(5411),
    [anon_sym_xor] = ACTIONS(5411),
    [anon_sym_bitand] = ACTIONS(5411),
    [anon_sym_not_eq] = ACTIONS(5411),
    [anon_sym_DASH_DASH] = ACTIONS(5413),
    [anon_sym_PLUS_PLUS] = ACTIONS(5413),
    [anon_sym_DOT] = ACTIONS(5411),
    [anon_sym_DOT_STAR] = ACTIONS(5413),
    [anon_sym_DASH_GT] = ACTIONS(5413),
    [anon_sym_L_DQUOTE] = ACTIONS(5413),
    [anon_sym_u_DQUOTE] = ACTIONS(5413),
    [anon_sym_U_DQUOTE] = ACTIONS(5413),
    [anon_sym_u8_DQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5413),
    [anon_sym_LR_DQUOTE] = ACTIONS(5413),
    [anon_sym_uR_DQUOTE] = ACTIONS(5413),
    [anon_sym_UR_DQUOTE] = ACTIONS(5413),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5413),
    [sym_literal_suffix] = ACTIONS(5411),
  },
  [2668] = {
    [sym_identifier] = ACTIONS(5465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5467),
    [anon_sym_COMMA] = ACTIONS(5467),
    [anon_sym_RPAREN] = ACTIONS(5467),
    [aux_sym_preproc_if_token2] = ACTIONS(5467),
    [aux_sym_preproc_else_token1] = ACTIONS(5467),
    [aux_sym_preproc_elif_token1] = ACTIONS(5465),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5467),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5467),
    [anon_sym_LPAREN2] = ACTIONS(5467),
    [anon_sym_DASH] = ACTIONS(5465),
    [anon_sym_PLUS] = ACTIONS(5465),
    [anon_sym_STAR] = ACTIONS(5465),
    [anon_sym_SLASH] = ACTIONS(5465),
    [anon_sym_PERCENT] = ACTIONS(5465),
    [anon_sym_PIPE_PIPE] = ACTIONS(5467),
    [anon_sym_AMP_AMP] = ACTIONS(5467),
    [anon_sym_PIPE] = ACTIONS(5465),
    [anon_sym_CARET] = ACTIONS(5465),
    [anon_sym_AMP] = ACTIONS(5465),
    [anon_sym_EQ_EQ] = ACTIONS(5467),
    [anon_sym_BANG_EQ] = ACTIONS(5467),
    [anon_sym_GT] = ACTIONS(5465),
    [anon_sym_GT_EQ] = ACTIONS(5467),
    [anon_sym_LT_EQ] = ACTIONS(5465),
    [anon_sym_LT] = ACTIONS(5465),
    [anon_sym_LT_LT] = ACTIONS(5465),
    [anon_sym_GT_GT] = ACTIONS(5465),
    [anon_sym_SEMI] = ACTIONS(5467),
    [anon_sym___attribute__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACE] = ACTIONS(5467),
    [anon_sym_RBRACE] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(5467),
    [anon_sym_RBRACK] = ACTIONS(5467),
    [anon_sym_EQ] = ACTIONS(5465),
    [anon_sym_COLON] = ACTIONS(5465),
    [anon_sym_QMARK] = ACTIONS(5467),
    [anon_sym_STAR_EQ] = ACTIONS(5467),
    [anon_sym_SLASH_EQ] = ACTIONS(5467),
    [anon_sym_PERCENT_EQ] = ACTIONS(5467),
    [anon_sym_PLUS_EQ] = ACTIONS(5467),
    [anon_sym_DASH_EQ] = ACTIONS(5467),
    [anon_sym_LT_LT_EQ] = ACTIONS(5467),
    [anon_sym_GT_GT_EQ] = ACTIONS(5467),
    [anon_sym_AMP_EQ] = ACTIONS(5467),
    [anon_sym_CARET_EQ] = ACTIONS(5467),
    [anon_sym_PIPE_EQ] = ACTIONS(5467),
    [anon_sym_and_eq] = ACTIONS(5465),
    [anon_sym_or_eq] = ACTIONS(5465),
    [anon_sym_xor_eq] = ACTIONS(5465),
    [anon_sym_LT_EQ_GT] = ACTIONS(5467),
    [anon_sym_or] = ACTIONS(5465),
    [anon_sym_and] = ACTIONS(5465),
    [anon_sym_bitor] = ACTIONS(5465),
    [anon_sym_xor] = ACTIONS(5465),
    [anon_sym_bitand] = ACTIONS(5465),
    [anon_sym_not_eq] = ACTIONS(5465),
    [anon_sym_DASH_DASH] = ACTIONS(5467),
    [anon_sym_PLUS_PLUS] = ACTIONS(5467),
    [anon_sym_DOT] = ACTIONS(5465),
    [anon_sym_DOT_STAR] = ACTIONS(5467),
    [anon_sym_DASH_GT] = ACTIONS(5467),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5465),
    [anon_sym_decltype] = ACTIONS(5465),
  },
  [2669] = {
    [sym_attribute_specifier] = STATE(2754),
    [sym_identifier] = ACTIONS(6024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6026),
    [anon_sym_COMMA] = ACTIONS(6026),
    [anon_sym_RPAREN] = ACTIONS(6026),
    [aux_sym_preproc_if_token2] = ACTIONS(6026),
    [aux_sym_preproc_else_token1] = ACTIONS(6026),
    [aux_sym_preproc_elif_token1] = ACTIONS(6024),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6026),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6026),
    [anon_sym_LPAREN2] = ACTIONS(6026),
    [anon_sym_DASH] = ACTIONS(6024),
    [anon_sym_PLUS] = ACTIONS(6024),
    [anon_sym_STAR] = ACTIONS(6024),
    [anon_sym_SLASH] = ACTIONS(6024),
    [anon_sym_PERCENT] = ACTIONS(6024),
    [anon_sym_PIPE_PIPE] = ACTIONS(6026),
    [anon_sym_AMP_AMP] = ACTIONS(6026),
    [anon_sym_PIPE] = ACTIONS(6024),
    [anon_sym_CARET] = ACTIONS(6024),
    [anon_sym_AMP] = ACTIONS(6024),
    [anon_sym_EQ_EQ] = ACTIONS(6026),
    [anon_sym_BANG_EQ] = ACTIONS(6026),
    [anon_sym_GT] = ACTIONS(6024),
    [anon_sym_GT_EQ] = ACTIONS(6026),
    [anon_sym_LT_EQ] = ACTIONS(6024),
    [anon_sym_LT] = ACTIONS(6024),
    [anon_sym_LT_LT] = ACTIONS(6024),
    [anon_sym_GT_GT] = ACTIONS(6024),
    [anon_sym_SEMI] = ACTIONS(6026),
    [anon_sym___attribute__] = ACTIONS(5473),
    [anon_sym_LBRACE] = ACTIONS(6026),
    [anon_sym_RBRACE] = ACTIONS(6026),
    [anon_sym_LBRACK] = ACTIONS(6026),
    [anon_sym_RBRACK] = ACTIONS(6026),
    [anon_sym_EQ] = ACTIONS(6024),
    [anon_sym_COLON] = ACTIONS(6026),
    [anon_sym_QMARK] = ACTIONS(6026),
    [anon_sym_STAR_EQ] = ACTIONS(6026),
    [anon_sym_SLASH_EQ] = ACTIONS(6026),
    [anon_sym_PERCENT_EQ] = ACTIONS(6026),
    [anon_sym_PLUS_EQ] = ACTIONS(6026),
    [anon_sym_DASH_EQ] = ACTIONS(6026),
    [anon_sym_LT_LT_EQ] = ACTIONS(6026),
    [anon_sym_GT_GT_EQ] = ACTIONS(6026),
    [anon_sym_AMP_EQ] = ACTIONS(6026),
    [anon_sym_CARET_EQ] = ACTIONS(6026),
    [anon_sym_PIPE_EQ] = ACTIONS(6026),
    [anon_sym_and_eq] = ACTIONS(6024),
    [anon_sym_or_eq] = ACTIONS(6024),
    [anon_sym_xor_eq] = ACTIONS(6024),
    [anon_sym_LT_EQ_GT] = ACTIONS(6026),
    [anon_sym_or] = ACTIONS(6024),
    [anon_sym_and] = ACTIONS(6024),
    [anon_sym_bitor] = ACTIONS(6024),
    [anon_sym_xor] = ACTIONS(6024),
    [anon_sym_bitand] = ACTIONS(6024),
    [anon_sym_not_eq] = ACTIONS(6024),
    [anon_sym_DASH_DASH] = ACTIONS(6026),
    [anon_sym_PLUS_PLUS] = ACTIONS(6026),
    [anon_sym_DOT] = ACTIONS(6024),
    [anon_sym_DOT_STAR] = ACTIONS(6026),
    [anon_sym_DASH_GT] = ACTIONS(6026),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6024),
    [anon_sym_decltype] = ACTIONS(6024),
  },
  [2670] = {
    [sym_attribute_specifier] = STATE(2750),
    [sym_identifier] = ACTIONS(6028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6030),
    [anon_sym_COMMA] = ACTIONS(6030),
    [anon_sym_RPAREN] = ACTIONS(6030),
    [aux_sym_preproc_if_token2] = ACTIONS(6030),
    [aux_sym_preproc_else_token1] = ACTIONS(6030),
    [aux_sym_preproc_elif_token1] = ACTIONS(6028),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6030),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6030),
    [anon_sym_LPAREN2] = ACTIONS(6030),
    [anon_sym_DASH] = ACTIONS(6028),
    [anon_sym_PLUS] = ACTIONS(6028),
    [anon_sym_STAR] = ACTIONS(6028),
    [anon_sym_SLASH] = ACTIONS(6028),
    [anon_sym_PERCENT] = ACTIONS(6028),
    [anon_sym_PIPE_PIPE] = ACTIONS(6030),
    [anon_sym_AMP_AMP] = ACTIONS(6030),
    [anon_sym_PIPE] = ACTIONS(6028),
    [anon_sym_CARET] = ACTIONS(6028),
    [anon_sym_AMP] = ACTIONS(6028),
    [anon_sym_EQ_EQ] = ACTIONS(6030),
    [anon_sym_BANG_EQ] = ACTIONS(6030),
    [anon_sym_GT] = ACTIONS(6028),
    [anon_sym_GT_EQ] = ACTIONS(6030),
    [anon_sym_LT_EQ] = ACTIONS(6028),
    [anon_sym_LT] = ACTIONS(6028),
    [anon_sym_LT_LT] = ACTIONS(6028),
    [anon_sym_GT_GT] = ACTIONS(6028),
    [anon_sym_SEMI] = ACTIONS(6030),
    [anon_sym___attribute__] = ACTIONS(5473),
    [anon_sym_LBRACE] = ACTIONS(6030),
    [anon_sym_RBRACE] = ACTIONS(6030),
    [anon_sym_LBRACK] = ACTIONS(6030),
    [anon_sym_RBRACK] = ACTIONS(6030),
    [anon_sym_EQ] = ACTIONS(6028),
    [anon_sym_COLON] = ACTIONS(6030),
    [anon_sym_QMARK] = ACTIONS(6030),
    [anon_sym_STAR_EQ] = ACTIONS(6030),
    [anon_sym_SLASH_EQ] = ACTIONS(6030),
    [anon_sym_PERCENT_EQ] = ACTIONS(6030),
    [anon_sym_PLUS_EQ] = ACTIONS(6030),
    [anon_sym_DASH_EQ] = ACTIONS(6030),
    [anon_sym_LT_LT_EQ] = ACTIONS(6030),
    [anon_sym_GT_GT_EQ] = ACTIONS(6030),
    [anon_sym_AMP_EQ] = ACTIONS(6030),
    [anon_sym_CARET_EQ] = ACTIONS(6030),
    [anon_sym_PIPE_EQ] = ACTIONS(6030),
    [anon_sym_and_eq] = ACTIONS(6028),
    [anon_sym_or_eq] = ACTIONS(6028),
    [anon_sym_xor_eq] = ACTIONS(6028),
    [anon_sym_LT_EQ_GT] = ACTIONS(6030),
    [anon_sym_or] = ACTIONS(6028),
    [anon_sym_and] = ACTIONS(6028),
    [anon_sym_bitor] = ACTIONS(6028),
    [anon_sym_xor] = ACTIONS(6028),
    [anon_sym_bitand] = ACTIONS(6028),
    [anon_sym_not_eq] = ACTIONS(6028),
    [anon_sym_DASH_DASH] = ACTIONS(6030),
    [anon_sym_PLUS_PLUS] = ACTIONS(6030),
    [anon_sym_DOT] = ACTIONS(6028),
    [anon_sym_DOT_STAR] = ACTIONS(6030),
    [anon_sym_DASH_GT] = ACTIONS(6030),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6028),
    [anon_sym_decltype] = ACTIONS(6028),
  },
  [2671] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2063),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6032),
    [anon_sym_COMMA] = ACTIONS(6032),
    [anon_sym_RPAREN] = ACTIONS(6032),
    [anon_sym_LPAREN2] = ACTIONS(6032),
    [anon_sym_DASH] = ACTIONS(6034),
    [anon_sym_PLUS] = ACTIONS(6034),
    [anon_sym_STAR] = ACTIONS(6032),
    [anon_sym_SLASH] = ACTIONS(6034),
    [anon_sym_PERCENT] = ACTIONS(6032),
    [anon_sym_PIPE_PIPE] = ACTIONS(6032),
    [anon_sym_AMP_AMP] = ACTIONS(6032),
    [anon_sym_PIPE] = ACTIONS(6034),
    [anon_sym_CARET] = ACTIONS(6032),
    [anon_sym_AMP] = ACTIONS(6034),
    [anon_sym_EQ_EQ] = ACTIONS(6032),
    [anon_sym_BANG_EQ] = ACTIONS(6032),
    [anon_sym_GT] = ACTIONS(6034),
    [anon_sym_GT_EQ] = ACTIONS(6032),
    [anon_sym_LT_EQ] = ACTIONS(6034),
    [anon_sym_LT] = ACTIONS(6034),
    [anon_sym_LT_LT] = ACTIONS(6032),
    [anon_sym_GT_GT] = ACTIONS(6032),
    [anon_sym_SEMI] = ACTIONS(6032),
    [anon_sym___extension__] = ACTIONS(6032),
    [anon_sym___attribute__] = ACTIONS(6032),
    [anon_sym_LBRACE] = ACTIONS(6032),
    [anon_sym_RBRACE] = ACTIONS(6032),
    [anon_sym_signed] = ACTIONS(6022),
    [anon_sym_unsigned] = ACTIONS(6022),
    [anon_sym_long] = ACTIONS(6022),
    [anon_sym_short] = ACTIONS(6022),
    [anon_sym_LBRACK] = ACTIONS(6032),
    [anon_sym_RBRACK] = ACTIONS(6032),
    [anon_sym_const] = ACTIONS(6034),
    [anon_sym_constexpr] = ACTIONS(6032),
    [anon_sym_volatile] = ACTIONS(6032),
    [anon_sym_restrict] = ACTIONS(6032),
    [anon_sym___restrict__] = ACTIONS(6032),
    [anon_sym__Atomic] = ACTIONS(6032),
    [anon_sym__Noreturn] = ACTIONS(6032),
    [anon_sym_noreturn] = ACTIONS(6032),
    [anon_sym_mutable] = ACTIONS(6032),
    [anon_sym_constinit] = ACTIONS(6032),
    [anon_sym_consteval] = ACTIONS(6032),
    [anon_sym_PROGMEM] = ACTIONS(6032),
    [anon_sym_COLON] = ACTIONS(6032),
    [anon_sym_QMARK] = ACTIONS(6032),
    [anon_sym_LT_EQ_GT] = ACTIONS(6032),
    [anon_sym_or] = ACTIONS(6032),
    [anon_sym_and] = ACTIONS(6032),
    [anon_sym_bitor] = ACTIONS(6032),
    [anon_sym_xor] = ACTIONS(6032),
    [anon_sym_bitand] = ACTIONS(6032),
    [anon_sym_not_eq] = ACTIONS(6032),
    [anon_sym_DASH_DASH] = ACTIONS(6032),
    [anon_sym_PLUS_PLUS] = ACTIONS(6032),
    [anon_sym_DOT] = ACTIONS(6034),
    [anon_sym_DOT_STAR] = ACTIONS(6032),
    [anon_sym_DASH_GT] = ACTIONS(6032),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6032),
    [anon_sym_decltype] = ACTIONS(6032),
    [anon_sym_final] = ACTIONS(6032),
    [anon_sym_override] = ACTIONS(6032),
    [anon_sym_requires] = ACTIONS(6032),
  },
  [2672] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2672),
    [sym_identifier] = ACTIONS(5363),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5365),
    [anon_sym_COMMA] = ACTIONS(5365),
    [anon_sym_LPAREN2] = ACTIONS(5365),
    [anon_sym_DASH] = ACTIONS(5363),
    [anon_sym_PLUS] = ACTIONS(5363),
    [anon_sym_STAR] = ACTIONS(5365),
    [anon_sym_SLASH] = ACTIONS(5363),
    [anon_sym_PERCENT] = ACTIONS(5365),
    [anon_sym_PIPE_PIPE] = ACTIONS(5365),
    [anon_sym_AMP_AMP] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5363),
    [anon_sym_CARET] = ACTIONS(5365),
    [anon_sym_AMP] = ACTIONS(5363),
    [anon_sym_EQ_EQ] = ACTIONS(5365),
    [anon_sym_BANG_EQ] = ACTIONS(5365),
    [anon_sym_GT] = ACTIONS(5363),
    [anon_sym_GT_EQ] = ACTIONS(5363),
    [anon_sym_LT_EQ] = ACTIONS(5363),
    [anon_sym_LT] = ACTIONS(5363),
    [anon_sym_LT_LT] = ACTIONS(5365),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym___extension__] = ACTIONS(5363),
    [anon_sym___attribute__] = ACTIONS(5363),
    [anon_sym_LBRACE] = ACTIONS(5365),
    [anon_sym_signed] = ACTIONS(6036),
    [anon_sym_unsigned] = ACTIONS(6036),
    [anon_sym_long] = ACTIONS(6036),
    [anon_sym_short] = ACTIONS(6036),
    [anon_sym_LBRACK] = ACTIONS(5365),
    [anon_sym_const] = ACTIONS(5363),
    [anon_sym_constexpr] = ACTIONS(5363),
    [anon_sym_volatile] = ACTIONS(5363),
    [anon_sym_restrict] = ACTIONS(5363),
    [anon_sym___restrict__] = ACTIONS(5363),
    [anon_sym__Atomic] = ACTIONS(5363),
    [anon_sym__Noreturn] = ACTIONS(5363),
    [anon_sym_noreturn] = ACTIONS(5363),
    [anon_sym_mutable] = ACTIONS(5363),
    [anon_sym_constinit] = ACTIONS(5363),
    [anon_sym_consteval] = ACTIONS(5363),
    [anon_sym_PROGMEM] = ACTIONS(5363),
    [aux_sym_primitive_type_token1] = ACTIONS(5363),
    [anon_sym_byte] = ACTIONS(5363),
    [anon_sym_word] = ACTIONS(5363),
    [anon_sym_QMARK] = ACTIONS(5365),
    [anon_sym_LT_EQ_GT] = ACTIONS(5365),
    [anon_sym_or] = ACTIONS(5363),
    [anon_sym_and] = ACTIONS(5363),
    [anon_sym_bitor] = ACTIONS(5363),
    [anon_sym_xor] = ACTIONS(5363),
    [anon_sym_bitand] = ACTIONS(5363),
    [anon_sym_not_eq] = ACTIONS(5363),
    [anon_sym_DASH_DASH] = ACTIONS(5365),
    [anon_sym_PLUS_PLUS] = ACTIONS(5365),
    [anon_sym_DOT] = ACTIONS(5363),
    [anon_sym_DOT_STAR] = ACTIONS(5365),
    [anon_sym_DASH_GT] = ACTIONS(5365),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5363),
    [anon_sym_decltype] = ACTIONS(5363),
    [anon_sym_final] = ACTIONS(5363),
    [anon_sym_override] = ACTIONS(5363),
    [anon_sym_GT2] = ACTIONS(5365),
    [anon_sym_requires] = ACTIONS(5363),
  },
  [2673] = {
    [sym_identifier] = ACTIONS(5481),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5483),
    [anon_sym_COMMA] = ACTIONS(5483),
    [anon_sym_RPAREN] = ACTIONS(5483),
    [aux_sym_preproc_if_token2] = ACTIONS(5483),
    [aux_sym_preproc_else_token1] = ACTIONS(5483),
    [aux_sym_preproc_elif_token1] = ACTIONS(5481),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5483),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5483),
    [anon_sym_LPAREN2] = ACTIONS(5483),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_PLUS] = ACTIONS(5481),
    [anon_sym_STAR] = ACTIONS(5481),
    [anon_sym_SLASH] = ACTIONS(5481),
    [anon_sym_PERCENT] = ACTIONS(5481),
    [anon_sym_PIPE_PIPE] = ACTIONS(5483),
    [anon_sym_AMP_AMP] = ACTIONS(5483),
    [anon_sym_PIPE] = ACTIONS(5481),
    [anon_sym_CARET] = ACTIONS(5481),
    [anon_sym_AMP] = ACTIONS(5481),
    [anon_sym_EQ_EQ] = ACTIONS(5483),
    [anon_sym_BANG_EQ] = ACTIONS(5483),
    [anon_sym_GT] = ACTIONS(5481),
    [anon_sym_GT_EQ] = ACTIONS(5483),
    [anon_sym_LT_EQ] = ACTIONS(5481),
    [anon_sym_LT] = ACTIONS(5481),
    [anon_sym_LT_LT] = ACTIONS(5481),
    [anon_sym_GT_GT] = ACTIONS(5481),
    [anon_sym_SEMI] = ACTIONS(5483),
    [anon_sym___attribute__] = ACTIONS(5481),
    [anon_sym_COLON_COLON] = ACTIONS(5485),
    [anon_sym_LBRACE] = ACTIONS(5483),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_LBRACK] = ACTIONS(5483),
    [anon_sym_RBRACK] = ACTIONS(5483),
    [anon_sym_EQ] = ACTIONS(5481),
    [anon_sym_COLON] = ACTIONS(5481),
    [anon_sym_QMARK] = ACTIONS(5483),
    [anon_sym_STAR_EQ] = ACTIONS(5483),
    [anon_sym_SLASH_EQ] = ACTIONS(5483),
    [anon_sym_PERCENT_EQ] = ACTIONS(5483),
    [anon_sym_PLUS_EQ] = ACTIONS(5483),
    [anon_sym_DASH_EQ] = ACTIONS(5483),
    [anon_sym_LT_LT_EQ] = ACTIONS(5483),
    [anon_sym_GT_GT_EQ] = ACTIONS(5483),
    [anon_sym_AMP_EQ] = ACTIONS(5483),
    [anon_sym_CARET_EQ] = ACTIONS(5483),
    [anon_sym_PIPE_EQ] = ACTIONS(5483),
    [anon_sym_and_eq] = ACTIONS(5481),
    [anon_sym_or_eq] = ACTIONS(5481),
    [anon_sym_xor_eq] = ACTIONS(5481),
    [anon_sym_LT_EQ_GT] = ACTIONS(5483),
    [anon_sym_or] = ACTIONS(5481),
    [anon_sym_and] = ACTIONS(5481),
    [anon_sym_bitor] = ACTIONS(5481),
    [anon_sym_xor] = ACTIONS(5481),
    [anon_sym_bitand] = ACTIONS(5481),
    [anon_sym_not_eq] = ACTIONS(5481),
    [anon_sym_DASH_DASH] = ACTIONS(5483),
    [anon_sym_PLUS_PLUS] = ACTIONS(5483),
    [anon_sym_DOT] = ACTIONS(5481),
    [anon_sym_DOT_STAR] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5481),
    [anon_sym_decltype] = ACTIONS(5481),
  },
  [2674] = {
    [sym_string_literal] = STATE(2706),
    [sym_raw_string_literal] = STATE(2706),
    [aux_sym_concatenated_string_repeat1] = STATE(2706),
    [sym_identifier] = ACTIONS(6039),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5387),
    [anon_sym_COMMA] = ACTIONS(5387),
    [anon_sym_LPAREN2] = ACTIONS(5387),
    [anon_sym_DASH] = ACTIONS(5389),
    [anon_sym_PLUS] = ACTIONS(5389),
    [anon_sym_STAR] = ACTIONS(5389),
    [anon_sym_SLASH] = ACTIONS(5389),
    [anon_sym_PERCENT] = ACTIONS(5389),
    [anon_sym_PIPE_PIPE] = ACTIONS(5387),
    [anon_sym_AMP_AMP] = ACTIONS(5387),
    [anon_sym_PIPE] = ACTIONS(5389),
    [anon_sym_CARET] = ACTIONS(5389),
    [anon_sym_AMP] = ACTIONS(5389),
    [anon_sym_EQ_EQ] = ACTIONS(5387),
    [anon_sym_BANG_EQ] = ACTIONS(5387),
    [anon_sym_GT] = ACTIONS(5389),
    [anon_sym_GT_EQ] = ACTIONS(5389),
    [anon_sym_LT_EQ] = ACTIONS(5389),
    [anon_sym_LT] = ACTIONS(5389),
    [anon_sym_LT_LT] = ACTIONS(5389),
    [anon_sym_GT_GT] = ACTIONS(5389),
    [anon_sym_LBRACK] = ACTIONS(5387),
    [anon_sym_EQ] = ACTIONS(5389),
    [anon_sym_QMARK] = ACTIONS(5387),
    [anon_sym_STAR_EQ] = ACTIONS(5387),
    [anon_sym_SLASH_EQ] = ACTIONS(5387),
    [anon_sym_PERCENT_EQ] = ACTIONS(5387),
    [anon_sym_PLUS_EQ] = ACTIONS(5387),
    [anon_sym_DASH_EQ] = ACTIONS(5387),
    [anon_sym_LT_LT_EQ] = ACTIONS(5387),
    [anon_sym_GT_GT_EQ] = ACTIONS(5389),
    [anon_sym_AMP_EQ] = ACTIONS(5387),
    [anon_sym_CARET_EQ] = ACTIONS(5387),
    [anon_sym_PIPE_EQ] = ACTIONS(5387),
    [anon_sym_and_eq] = ACTIONS(5389),
    [anon_sym_or_eq] = ACTIONS(5389),
    [anon_sym_xor_eq] = ACTIONS(5389),
    [anon_sym_LT_EQ_GT] = ACTIONS(5387),
    [anon_sym_or] = ACTIONS(5389),
    [anon_sym_and] = ACTIONS(5389),
    [anon_sym_bitor] = ACTIONS(5389),
    [anon_sym_xor] = ACTIONS(5389),
    [anon_sym_bitand] = ACTIONS(5389),
    [anon_sym_not_eq] = ACTIONS(5389),
    [anon_sym_DASH_DASH] = ACTIONS(5387),
    [anon_sym_PLUS_PLUS] = ACTIONS(5387),
    [anon_sym_DOT] = ACTIONS(5389),
    [anon_sym_DOT_STAR] = ACTIONS(5387),
    [anon_sym_DASH_GT] = ACTIONS(5387),
    [anon_sym_L_DQUOTE] = ACTIONS(6041),
    [anon_sym_u_DQUOTE] = ACTIONS(6041),
    [anon_sym_U_DQUOTE] = ACTIONS(6041),
    [anon_sym_u8_DQUOTE] = ACTIONS(6041),
    [anon_sym_DQUOTE] = ACTIONS(6041),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(5387),
    [anon_sym_R_DQUOTE] = ACTIONS(6043),
    [anon_sym_LR_DQUOTE] = ACTIONS(6043),
    [anon_sym_uR_DQUOTE] = ACTIONS(6043),
    [anon_sym_UR_DQUOTE] = ACTIONS(6043),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6043),
    [sym_literal_suffix] = ACTIONS(5389),
  },
  [2675] = {
    [sym_template_argument_list] = STATE(2036),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5960),
    [anon_sym_COMMA] = ACTIONS(5960),
    [anon_sym_RPAREN] = ACTIONS(5960),
    [anon_sym_LPAREN2] = ACTIONS(5960),
    [anon_sym_DASH] = ACTIONS(5958),
    [anon_sym_PLUS] = ACTIONS(5958),
    [anon_sym_STAR] = ACTIONS(5958),
    [anon_sym_SLASH] = ACTIONS(5958),
    [anon_sym_PERCENT] = ACTIONS(5958),
    [anon_sym_PIPE_PIPE] = ACTIONS(5960),
    [anon_sym_AMP_AMP] = ACTIONS(5960),
    [anon_sym_PIPE] = ACTIONS(5958),
    [anon_sym_CARET] = ACTIONS(5958),
    [anon_sym_AMP] = ACTIONS(5958),
    [anon_sym_EQ_EQ] = ACTIONS(5960),
    [anon_sym_BANG_EQ] = ACTIONS(5960),
    [anon_sym_GT] = ACTIONS(5958),
    [anon_sym_GT_EQ] = ACTIONS(5960),
    [anon_sym_LT_EQ] = ACTIONS(5958),
    [anon_sym_LT] = ACTIONS(5958),
    [anon_sym_LT_LT] = ACTIONS(5958),
    [anon_sym_GT_GT] = ACTIONS(5958),
    [anon_sym_SEMI] = ACTIONS(5960),
    [anon_sym___attribute__] = ACTIONS(5960),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(5960),
    [anon_sym_RBRACE] = ACTIONS(5960),
    [anon_sym_signed] = ACTIONS(6045),
    [anon_sym_unsigned] = ACTIONS(6045),
    [anon_sym_long] = ACTIONS(6045),
    [anon_sym_short] = ACTIONS(6045),
    [anon_sym_LBRACK] = ACTIONS(5960),
    [anon_sym_RBRACK] = ACTIONS(5960),
    [anon_sym_EQ] = ACTIONS(5958),
    [anon_sym_COLON] = ACTIONS(5958),
    [anon_sym_QMARK] = ACTIONS(5960),
    [anon_sym_STAR_EQ] = ACTIONS(5960),
    [anon_sym_SLASH_EQ] = ACTIONS(5960),
    [anon_sym_PERCENT_EQ] = ACTIONS(5960),
    [anon_sym_PLUS_EQ] = ACTIONS(5960),
    [anon_sym_DASH_EQ] = ACTIONS(5960),
    [anon_sym_LT_LT_EQ] = ACTIONS(5960),
    [anon_sym_GT_GT_EQ] = ACTIONS(5960),
    [anon_sym_AMP_EQ] = ACTIONS(5960),
    [anon_sym_CARET_EQ] = ACTIONS(5960),
    [anon_sym_PIPE_EQ] = ACTIONS(5960),
    [anon_sym_and_eq] = ACTIONS(5960),
    [anon_sym_or_eq] = ACTIONS(5960),
    [anon_sym_xor_eq] = ACTIONS(5960),
    [anon_sym_LT_EQ_GT] = ACTIONS(5960),
    [anon_sym_or] = ACTIONS(5958),
    [anon_sym_and] = ACTIONS(5958),
    [anon_sym_bitor] = ACTIONS(5960),
    [anon_sym_xor] = ACTIONS(5958),
    [anon_sym_bitand] = ACTIONS(5960),
    [anon_sym_not_eq] = ACTIONS(5960),
    [anon_sym_DASH_DASH] = ACTIONS(5960),
    [anon_sym_PLUS_PLUS] = ACTIONS(5960),
    [anon_sym_DOT] = ACTIONS(5958),
    [anon_sym_DOT_STAR] = ACTIONS(5960),
    [anon_sym_DASH_GT] = ACTIONS(5960),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5960),
    [anon_sym_decltype] = ACTIONS(5960),
  },
  [2676] = {
    [sym_string_literal] = STATE(4043),
    [sym_template_argument_list] = STATE(5318),
    [sym_raw_string_literal] = STATE(4043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4256),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5191),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(5196),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(5198),
    [anon_sym_SLASH_EQ] = ACTIONS(5198),
    [anon_sym_PERCENT_EQ] = ACTIONS(5198),
    [anon_sym_PLUS_EQ] = ACTIONS(5198),
    [anon_sym_DASH_EQ] = ACTIONS(5198),
    [anon_sym_LT_LT_EQ] = ACTIONS(5198),
    [anon_sym_GT_GT_EQ] = ACTIONS(5196),
    [anon_sym_AMP_EQ] = ACTIONS(5198),
    [anon_sym_CARET_EQ] = ACTIONS(5198),
    [anon_sym_PIPE_EQ] = ACTIONS(5198),
    [anon_sym_and_eq] = ACTIONS(5198),
    [anon_sym_or_eq] = ACTIONS(5198),
    [anon_sym_xor_eq] = ACTIONS(5198),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(5200),
    [anon_sym_u_DQUOTE] = ACTIONS(5200),
    [anon_sym_U_DQUOTE] = ACTIONS(5200),
    [anon_sym_u8_DQUOTE] = ACTIONS(5200),
    [anon_sym_DQUOTE] = ACTIONS(5200),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(4248),
    [anon_sym_R_DQUOTE] = ACTIONS(5202),
    [anon_sym_LR_DQUOTE] = ACTIONS(5202),
    [anon_sym_uR_DQUOTE] = ACTIONS(5202),
    [anon_sym_UR_DQUOTE] = ACTIONS(5202),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5202),
  },
  [2677] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2666),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5726),
    [anon_sym_COMMA] = ACTIONS(5726),
    [anon_sym_RPAREN] = ACTIONS(5726),
    [anon_sym_LPAREN2] = ACTIONS(5726),
    [anon_sym_DASH] = ACTIONS(5724),
    [anon_sym_PLUS] = ACTIONS(5724),
    [anon_sym_STAR] = ACTIONS(5726),
    [anon_sym_SLASH] = ACTIONS(5724),
    [anon_sym_PERCENT] = ACTIONS(5726),
    [anon_sym_PIPE_PIPE] = ACTIONS(5726),
    [anon_sym_AMP_AMP] = ACTIONS(5726),
    [anon_sym_PIPE] = ACTIONS(5724),
    [anon_sym_CARET] = ACTIONS(5726),
    [anon_sym_AMP] = ACTIONS(5724),
    [anon_sym_EQ_EQ] = ACTIONS(5726),
    [anon_sym_BANG_EQ] = ACTIONS(5726),
    [anon_sym_GT] = ACTIONS(5724),
    [anon_sym_GT_EQ] = ACTIONS(5726),
    [anon_sym_LT_EQ] = ACTIONS(5724),
    [anon_sym_LT] = ACTIONS(5724),
    [anon_sym_LT_LT] = ACTIONS(5726),
    [anon_sym_GT_GT] = ACTIONS(5726),
    [anon_sym_SEMI] = ACTIONS(5726),
    [anon_sym___extension__] = ACTIONS(5726),
    [anon_sym___attribute__] = ACTIONS(5726),
    [anon_sym_LBRACE] = ACTIONS(5726),
    [anon_sym_RBRACE] = ACTIONS(5726),
    [anon_sym_signed] = ACTIONS(6047),
    [anon_sym_unsigned] = ACTIONS(6047),
    [anon_sym_long] = ACTIONS(6047),
    [anon_sym_short] = ACTIONS(6047),
    [anon_sym_LBRACK] = ACTIONS(5726),
    [anon_sym_RBRACK] = ACTIONS(5726),
    [anon_sym_const] = ACTIONS(5724),
    [anon_sym_constexpr] = ACTIONS(5726),
    [anon_sym_volatile] = ACTIONS(5726),
    [anon_sym_restrict] = ACTIONS(5726),
    [anon_sym___restrict__] = ACTIONS(5726),
    [anon_sym__Atomic] = ACTIONS(5726),
    [anon_sym__Noreturn] = ACTIONS(5726),
    [anon_sym_noreturn] = ACTIONS(5726),
    [anon_sym_mutable] = ACTIONS(5726),
    [anon_sym_constinit] = ACTIONS(5726),
    [anon_sym_consteval] = ACTIONS(5726),
    [anon_sym_PROGMEM] = ACTIONS(5726),
    [anon_sym_COLON] = ACTIONS(5726),
    [anon_sym_QMARK] = ACTIONS(5726),
    [anon_sym_LT_EQ_GT] = ACTIONS(5726),
    [anon_sym_or] = ACTIONS(5726),
    [anon_sym_and] = ACTIONS(5726),
    [anon_sym_bitor] = ACTIONS(5726),
    [anon_sym_xor] = ACTIONS(5726),
    [anon_sym_bitand] = ACTIONS(5726),
    [anon_sym_not_eq] = ACTIONS(5726),
    [anon_sym_DASH_DASH] = ACTIONS(5726),
    [anon_sym_PLUS_PLUS] = ACTIONS(5726),
    [anon_sym_DOT] = ACTIONS(5724),
    [anon_sym_DOT_STAR] = ACTIONS(5726),
    [anon_sym_DASH_GT] = ACTIONS(5726),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5726),
    [anon_sym_decltype] = ACTIONS(5726),
    [anon_sym_final] = ACTIONS(5726),
    [anon_sym_override] = ACTIONS(5726),
    [anon_sym_requires] = ACTIONS(5726),
  },
  [2678] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(4471),
    [sym_raw_string_literal] = STATE(3057),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5870),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_RBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(5939),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(5941),
    [anon_sym_SLASH_EQ] = ACTIONS(5941),
    [anon_sym_PERCENT_EQ] = ACTIONS(5941),
    [anon_sym_PLUS_EQ] = ACTIONS(5941),
    [anon_sym_DASH_EQ] = ACTIONS(5941),
    [anon_sym_LT_LT_EQ] = ACTIONS(5941),
    [anon_sym_GT_GT_EQ] = ACTIONS(5941),
    [anon_sym_AMP_EQ] = ACTIONS(5941),
    [anon_sym_CARET_EQ] = ACTIONS(5941),
    [anon_sym_PIPE_EQ] = ACTIONS(5941),
    [anon_sym_and_eq] = ACTIONS(5941),
    [anon_sym_or_eq] = ACTIONS(5941),
    [anon_sym_xor_eq] = ACTIONS(5941),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [2679] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2666),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5483),
    [anon_sym_COMMA] = ACTIONS(5483),
    [anon_sym_RPAREN] = ACTIONS(5483),
    [anon_sym_LPAREN2] = ACTIONS(5483),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_PLUS] = ACTIONS(5481),
    [anon_sym_STAR] = ACTIONS(5483),
    [anon_sym_SLASH] = ACTIONS(5481),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_PIPE_PIPE] = ACTIONS(5483),
    [anon_sym_AMP_AMP] = ACTIONS(5483),
    [anon_sym_PIPE] = ACTIONS(5481),
    [anon_sym_CARET] = ACTIONS(5483),
    [anon_sym_AMP] = ACTIONS(5481),
    [anon_sym_EQ_EQ] = ACTIONS(5483),
    [anon_sym_BANG_EQ] = ACTIONS(5483),
    [anon_sym_GT] = ACTIONS(5481),
    [anon_sym_GT_EQ] = ACTIONS(5483),
    [anon_sym_LT_EQ] = ACTIONS(5481),
    [anon_sym_LT] = ACTIONS(5481),
    [anon_sym_LT_LT] = ACTIONS(5483),
    [anon_sym_GT_GT] = ACTIONS(5483),
    [anon_sym_SEMI] = ACTIONS(5483),
    [anon_sym___extension__] = ACTIONS(5483),
    [anon_sym___attribute__] = ACTIONS(5483),
    [anon_sym_LBRACE] = ACTIONS(5483),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_signed] = ACTIONS(6047),
    [anon_sym_unsigned] = ACTIONS(6047),
    [anon_sym_long] = ACTIONS(6047),
    [anon_sym_short] = ACTIONS(6047),
    [anon_sym_LBRACK] = ACTIONS(5483),
    [anon_sym_RBRACK] = ACTIONS(5483),
    [anon_sym_const] = ACTIONS(5481),
    [anon_sym_constexpr] = ACTIONS(5483),
    [anon_sym_volatile] = ACTIONS(5483),
    [anon_sym_restrict] = ACTIONS(5483),
    [anon_sym___restrict__] = ACTIONS(5483),
    [anon_sym__Atomic] = ACTIONS(5483),
    [anon_sym__Noreturn] = ACTIONS(5483),
    [anon_sym_noreturn] = ACTIONS(5483),
    [anon_sym_mutable] = ACTIONS(5483),
    [anon_sym_constinit] = ACTIONS(5483),
    [anon_sym_consteval] = ACTIONS(5483),
    [anon_sym_PROGMEM] = ACTIONS(5483),
    [anon_sym_COLON] = ACTIONS(5483),
    [anon_sym_QMARK] = ACTIONS(5483),
    [anon_sym_LT_EQ_GT] = ACTIONS(5483),
    [anon_sym_or] = ACTIONS(5483),
    [anon_sym_and] = ACTIONS(5483),
    [anon_sym_bitor] = ACTIONS(5483),
    [anon_sym_xor] = ACTIONS(5483),
    [anon_sym_bitand] = ACTIONS(5483),
    [anon_sym_not_eq] = ACTIONS(5483),
    [anon_sym_DASH_DASH] = ACTIONS(5483),
    [anon_sym_PLUS_PLUS] = ACTIONS(5483),
    [anon_sym_DOT] = ACTIONS(5481),
    [anon_sym_DOT_STAR] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5483),
    [anon_sym_decltype] = ACTIONS(5483),
    [anon_sym_final] = ACTIONS(5483),
    [anon_sym_override] = ACTIONS(5483),
    [anon_sym_requires] = ACTIONS(5483),
  },
  [2680] = {
    [sym_attribute_specifier] = STATE(2788),
    [sym_identifier] = ACTIONS(6049),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6051),
    [anon_sym_COMMA] = ACTIONS(6051),
    [anon_sym_RPAREN] = ACTIONS(6051),
    [aux_sym_preproc_if_token2] = ACTIONS(6051),
    [aux_sym_preproc_else_token1] = ACTIONS(6051),
    [aux_sym_preproc_elif_token1] = ACTIONS(6049),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6051),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6051),
    [anon_sym_LPAREN2] = ACTIONS(6051),
    [anon_sym_DASH] = ACTIONS(6049),
    [anon_sym_PLUS] = ACTIONS(6049),
    [anon_sym_STAR] = ACTIONS(6049),
    [anon_sym_SLASH] = ACTIONS(6049),
    [anon_sym_PERCENT] = ACTIONS(6049),
    [anon_sym_PIPE_PIPE] = ACTIONS(6051),
    [anon_sym_AMP_AMP] = ACTIONS(6051),
    [anon_sym_PIPE] = ACTIONS(6049),
    [anon_sym_CARET] = ACTIONS(6049),
    [anon_sym_AMP] = ACTIONS(6049),
    [anon_sym_EQ_EQ] = ACTIONS(6051),
    [anon_sym_BANG_EQ] = ACTIONS(6051),
    [anon_sym_GT] = ACTIONS(6049),
    [anon_sym_GT_EQ] = ACTIONS(6051),
    [anon_sym_LT_EQ] = ACTIONS(6049),
    [anon_sym_LT] = ACTIONS(6049),
    [anon_sym_LT_LT] = ACTIONS(6049),
    [anon_sym_GT_GT] = ACTIONS(6049),
    [anon_sym_SEMI] = ACTIONS(6051),
    [anon_sym___attribute__] = ACTIONS(5473),
    [anon_sym_LBRACE] = ACTIONS(6051),
    [anon_sym_RBRACE] = ACTIONS(6051),
    [anon_sym_LBRACK] = ACTIONS(6051),
    [anon_sym_RBRACK] = ACTIONS(6051),
    [anon_sym_EQ] = ACTIONS(6049),
    [anon_sym_COLON] = ACTIONS(6051),
    [anon_sym_QMARK] = ACTIONS(6051),
    [anon_sym_STAR_EQ] = ACTIONS(6051),
    [anon_sym_SLASH_EQ] = ACTIONS(6051),
    [anon_sym_PERCENT_EQ] = ACTIONS(6051),
    [anon_sym_PLUS_EQ] = ACTIONS(6051),
    [anon_sym_DASH_EQ] = ACTIONS(6051),
    [anon_sym_LT_LT_EQ] = ACTIONS(6051),
    [anon_sym_GT_GT_EQ] = ACTIONS(6051),
    [anon_sym_AMP_EQ] = ACTIONS(6051),
    [anon_sym_CARET_EQ] = ACTIONS(6051),
    [anon_sym_PIPE_EQ] = ACTIONS(6051),
    [anon_sym_and_eq] = ACTIONS(6049),
    [anon_sym_or_eq] = ACTIONS(6049),
    [anon_sym_xor_eq] = ACTIONS(6049),
    [anon_sym_LT_EQ_GT] = ACTIONS(6051),
    [anon_sym_or] = ACTIONS(6049),
    [anon_sym_and] = ACTIONS(6049),
    [anon_sym_bitor] = ACTIONS(6049),
    [anon_sym_xor] = ACTIONS(6049),
    [anon_sym_bitand] = ACTIONS(6049),
    [anon_sym_not_eq] = ACTIONS(6049),
    [anon_sym_DASH_DASH] = ACTIONS(6051),
    [anon_sym_PLUS_PLUS] = ACTIONS(6051),
    [anon_sym_DOT] = ACTIONS(6049),
    [anon_sym_DOT_STAR] = ACTIONS(6051),
    [anon_sym_DASH_GT] = ACTIONS(6051),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6049),
    [anon_sym_decltype] = ACTIONS(6049),
  },
  [2681] = {
    [sym_attribute_specifier] = STATE(2757),
    [sym_identifier] = ACTIONS(6053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6055),
    [anon_sym_COMMA] = ACTIONS(6055),
    [anon_sym_RPAREN] = ACTIONS(6055),
    [aux_sym_preproc_if_token2] = ACTIONS(6055),
    [aux_sym_preproc_else_token1] = ACTIONS(6055),
    [aux_sym_preproc_elif_token1] = ACTIONS(6053),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6055),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6055),
    [anon_sym_LPAREN2] = ACTIONS(6055),
    [anon_sym_DASH] = ACTIONS(6053),
    [anon_sym_PLUS] = ACTIONS(6053),
    [anon_sym_STAR] = ACTIONS(6053),
    [anon_sym_SLASH] = ACTIONS(6053),
    [anon_sym_PERCENT] = ACTIONS(6053),
    [anon_sym_PIPE_PIPE] = ACTIONS(6055),
    [anon_sym_AMP_AMP] = ACTIONS(6055),
    [anon_sym_PIPE] = ACTIONS(6053),
    [anon_sym_CARET] = ACTIONS(6053),
    [anon_sym_AMP] = ACTIONS(6053),
    [anon_sym_EQ_EQ] = ACTIONS(6055),
    [anon_sym_BANG_EQ] = ACTIONS(6055),
    [anon_sym_GT] = ACTIONS(6053),
    [anon_sym_GT_EQ] = ACTIONS(6055),
    [anon_sym_LT_EQ] = ACTIONS(6053),
    [anon_sym_LT] = ACTIONS(6053),
    [anon_sym_LT_LT] = ACTIONS(6053),
    [anon_sym_GT_GT] = ACTIONS(6053),
    [anon_sym_SEMI] = ACTIONS(6055),
    [anon_sym___attribute__] = ACTIONS(5473),
    [anon_sym_LBRACE] = ACTIONS(6055),
    [anon_sym_RBRACE] = ACTIONS(6055),
    [anon_sym_LBRACK] = ACTIONS(6055),
    [anon_sym_RBRACK] = ACTIONS(6055),
    [anon_sym_EQ] = ACTIONS(6053),
    [anon_sym_COLON] = ACTIONS(6055),
    [anon_sym_QMARK] = ACTIONS(6055),
    [anon_sym_STAR_EQ] = ACTIONS(6055),
    [anon_sym_SLASH_EQ] = ACTIONS(6055),
    [anon_sym_PERCENT_EQ] = ACTIONS(6055),
    [anon_sym_PLUS_EQ] = ACTIONS(6055),
    [anon_sym_DASH_EQ] = ACTIONS(6055),
    [anon_sym_LT_LT_EQ] = ACTIONS(6055),
    [anon_sym_GT_GT_EQ] = ACTIONS(6055),
    [anon_sym_AMP_EQ] = ACTIONS(6055),
    [anon_sym_CARET_EQ] = ACTIONS(6055),
    [anon_sym_PIPE_EQ] = ACTIONS(6055),
    [anon_sym_and_eq] = ACTIONS(6053),
    [anon_sym_or_eq] = ACTIONS(6053),
    [anon_sym_xor_eq] = ACTIONS(6053),
    [anon_sym_LT_EQ_GT] = ACTIONS(6055),
    [anon_sym_or] = ACTIONS(6053),
    [anon_sym_and] = ACTIONS(6053),
    [anon_sym_bitor] = ACTIONS(6053),
    [anon_sym_xor] = ACTIONS(6053),
    [anon_sym_bitand] = ACTIONS(6053),
    [anon_sym_not_eq] = ACTIONS(6053),
    [anon_sym_DASH_DASH] = ACTIONS(6055),
    [anon_sym_PLUS_PLUS] = ACTIONS(6055),
    [anon_sym_DOT] = ACTIONS(6053),
    [anon_sym_DOT_STAR] = ACTIONS(6055),
    [anon_sym_DASH_GT] = ACTIONS(6055),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6053),
    [anon_sym_decltype] = ACTIONS(6053),
  },
  [2682] = {
    [sym_attribute_specifier] = STATE(2741),
    [sym_identifier] = ACTIONS(6057),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6059),
    [anon_sym_COMMA] = ACTIONS(6059),
    [anon_sym_RPAREN] = ACTIONS(6059),
    [aux_sym_preproc_if_token2] = ACTIONS(6059),
    [aux_sym_preproc_else_token1] = ACTIONS(6059),
    [aux_sym_preproc_elif_token1] = ACTIONS(6057),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6059),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6059),
    [anon_sym_LPAREN2] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6057),
    [anon_sym_PLUS] = ACTIONS(6057),
    [anon_sym_STAR] = ACTIONS(6057),
    [anon_sym_SLASH] = ACTIONS(6057),
    [anon_sym_PERCENT] = ACTIONS(6057),
    [anon_sym_PIPE_PIPE] = ACTIONS(6059),
    [anon_sym_AMP_AMP] = ACTIONS(6059),
    [anon_sym_PIPE] = ACTIONS(6057),
    [anon_sym_CARET] = ACTIONS(6057),
    [anon_sym_AMP] = ACTIONS(6057),
    [anon_sym_EQ_EQ] = ACTIONS(6059),
    [anon_sym_BANG_EQ] = ACTIONS(6059),
    [anon_sym_GT] = ACTIONS(6057),
    [anon_sym_GT_EQ] = ACTIONS(6059),
    [anon_sym_LT_EQ] = ACTIONS(6057),
    [anon_sym_LT] = ACTIONS(6057),
    [anon_sym_LT_LT] = ACTIONS(6057),
    [anon_sym_GT_GT] = ACTIONS(6057),
    [anon_sym_SEMI] = ACTIONS(6059),
    [anon_sym___attribute__] = ACTIONS(5473),
    [anon_sym_LBRACE] = ACTIONS(6059),
    [anon_sym_RBRACE] = ACTIONS(6059),
    [anon_sym_LBRACK] = ACTIONS(6059),
    [anon_sym_RBRACK] = ACTIONS(6059),
    [anon_sym_EQ] = ACTIONS(6057),
    [anon_sym_COLON] = ACTIONS(6059),
    [anon_sym_QMARK] = ACTIONS(6059),
    [anon_sym_STAR_EQ] = ACTIONS(6059),
    [anon_sym_SLASH_EQ] = ACTIONS(6059),
    [anon_sym_PERCENT_EQ] = ACTIONS(6059),
    [anon_sym_PLUS_EQ] = ACTIONS(6059),
    [anon_sym_DASH_EQ] = ACTIONS(6059),
    [anon_sym_LT_LT_EQ] = ACTIONS(6059),
    [anon_sym_GT_GT_EQ] = ACTIONS(6059),
    [anon_sym_AMP_EQ] = ACTIONS(6059),
    [anon_sym_CARET_EQ] = ACTIONS(6059),
    [anon_sym_PIPE_EQ] = ACTIONS(6059),
    [anon_sym_and_eq] = ACTIONS(6057),
    [anon_sym_or_eq] = ACTIONS(6057),
    [anon_sym_xor_eq] = ACTIONS(6057),
    [anon_sym_LT_EQ_GT] = ACTIONS(6059),
    [anon_sym_or] = ACTIONS(6057),
    [anon_sym_and] = ACTIONS(6057),
    [anon_sym_bitor] = ACTIONS(6057),
    [anon_sym_xor] = ACTIONS(6057),
    [anon_sym_bitand] = ACTIONS(6057),
    [anon_sym_not_eq] = ACTIONS(6057),
    [anon_sym_DASH_DASH] = ACTIONS(6059),
    [anon_sym_PLUS_PLUS] = ACTIONS(6059),
    [anon_sym_DOT] = ACTIONS(6057),
    [anon_sym_DOT_STAR] = ACTIONS(6059),
    [anon_sym_DASH_GT] = ACTIONS(6059),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6057),
    [anon_sym_decltype] = ACTIONS(6057),
  },
  [2683] = {
    [sym_attribute_specifier] = STATE(2790),
    [sym_identifier] = ACTIONS(6061),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6063),
    [anon_sym_COMMA] = ACTIONS(6063),
    [anon_sym_RPAREN] = ACTIONS(6063),
    [aux_sym_preproc_if_token2] = ACTIONS(6063),
    [aux_sym_preproc_else_token1] = ACTIONS(6063),
    [aux_sym_preproc_elif_token1] = ACTIONS(6061),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6063),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6063),
    [anon_sym_LPAREN2] = ACTIONS(6063),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_PLUS] = ACTIONS(6061),
    [anon_sym_STAR] = ACTIONS(6061),
    [anon_sym_SLASH] = ACTIONS(6061),
    [anon_sym_PERCENT] = ACTIONS(6061),
    [anon_sym_PIPE_PIPE] = ACTIONS(6063),
    [anon_sym_AMP_AMP] = ACTIONS(6063),
    [anon_sym_PIPE] = ACTIONS(6061),
    [anon_sym_CARET] = ACTIONS(6061),
    [anon_sym_AMP] = ACTIONS(6061),
    [anon_sym_EQ_EQ] = ACTIONS(6063),
    [anon_sym_BANG_EQ] = ACTIONS(6063),
    [anon_sym_GT] = ACTIONS(6061),
    [anon_sym_GT_EQ] = ACTIONS(6063),
    [anon_sym_LT_EQ] = ACTIONS(6061),
    [anon_sym_LT] = ACTIONS(6061),
    [anon_sym_LT_LT] = ACTIONS(6061),
    [anon_sym_GT_GT] = ACTIONS(6061),
    [anon_sym_SEMI] = ACTIONS(6063),
    [anon_sym___attribute__] = ACTIONS(5473),
    [anon_sym_LBRACE] = ACTIONS(6063),
    [anon_sym_RBRACE] = ACTIONS(6063),
    [anon_sym_LBRACK] = ACTIONS(6063),
    [anon_sym_RBRACK] = ACTIONS(6063),
    [anon_sym_EQ] = ACTIONS(6061),
    [anon_sym_COLON] = ACTIONS(6063),
    [anon_sym_QMARK] = ACTIONS(6063),
    [anon_sym_STAR_EQ] = ACTIONS(6063),
    [anon_sym_SLASH_EQ] = ACTIONS(6063),
    [anon_sym_PERCENT_EQ] = ACTIONS(6063),
    [anon_sym_PLUS_EQ] = ACTIONS(6063),
    [anon_sym_DASH_EQ] = ACTIONS(6063),
    [anon_sym_LT_LT_EQ] = ACTIONS(6063),
    [anon_sym_GT_GT_EQ] = ACTIONS(6063),
    [anon_sym_AMP_EQ] = ACTIONS(6063),
    [anon_sym_CARET_EQ] = ACTIONS(6063),
    [anon_sym_PIPE_EQ] = ACTIONS(6063),
    [anon_sym_and_eq] = ACTIONS(6061),
    [anon_sym_or_eq] = ACTIONS(6061),
    [anon_sym_xor_eq] = ACTIONS(6061),
    [anon_sym_LT_EQ_GT] = ACTIONS(6063),
    [anon_sym_or] = ACTIONS(6061),
    [anon_sym_and] = ACTIONS(6061),
    [anon_sym_bitor] = ACTIONS(6061),
    [anon_sym_xor] = ACTIONS(6061),
    [anon_sym_bitand] = ACTIONS(6061),
    [anon_sym_not_eq] = ACTIONS(6061),
    [anon_sym_DASH_DASH] = ACTIONS(6063),
    [anon_sym_PLUS_PLUS] = ACTIONS(6063),
    [anon_sym_DOT] = ACTIONS(6061),
    [anon_sym_DOT_STAR] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6063),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6061),
    [anon_sym_decltype] = ACTIONS(6061),
  },
  [2684] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5441),
    [anon_sym_COMMA] = ACTIONS(5441),
    [anon_sym_RPAREN] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(5441),
    [anon_sym_DASH] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(5439),
    [anon_sym_STAR] = ACTIONS(5439),
    [anon_sym_SLASH] = ACTIONS(5439),
    [anon_sym_PERCENT] = ACTIONS(5439),
    [anon_sym_PIPE_PIPE] = ACTIONS(5441),
    [anon_sym_AMP_AMP] = ACTIONS(5441),
    [anon_sym_PIPE] = ACTIONS(5439),
    [anon_sym_CARET] = ACTIONS(5439),
    [anon_sym_AMP] = ACTIONS(5439),
    [anon_sym_EQ_EQ] = ACTIONS(5441),
    [anon_sym_BANG_EQ] = ACTIONS(5441),
    [anon_sym_GT] = ACTIONS(5439),
    [anon_sym_GT_EQ] = ACTIONS(5441),
    [anon_sym_LT_EQ] = ACTIONS(5439),
    [anon_sym_LT] = ACTIONS(5439),
    [anon_sym_LT_LT] = ACTIONS(5439),
    [anon_sym_GT_GT] = ACTIONS(5439),
    [anon_sym_SEMI] = ACTIONS(5441),
    [anon_sym_RBRACE] = ACTIONS(5441),
    [anon_sym_LBRACK] = ACTIONS(5441),
    [anon_sym_RBRACK] = ACTIONS(5441),
    [anon_sym_EQ] = ACTIONS(5439),
    [anon_sym_COLON] = ACTIONS(5441),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_STAR_EQ] = ACTIONS(5441),
    [anon_sym_SLASH_EQ] = ACTIONS(5441),
    [anon_sym_PERCENT_EQ] = ACTIONS(5441),
    [anon_sym_PLUS_EQ] = ACTIONS(5441),
    [anon_sym_DASH_EQ] = ACTIONS(5441),
    [anon_sym_LT_LT_EQ] = ACTIONS(5441),
    [anon_sym_GT_GT_EQ] = ACTIONS(5441),
    [anon_sym_AMP_EQ] = ACTIONS(5441),
    [anon_sym_CARET_EQ] = ACTIONS(5441),
    [anon_sym_PIPE_EQ] = ACTIONS(5441),
    [anon_sym_and_eq] = ACTIONS(5439),
    [anon_sym_or_eq] = ACTIONS(5439),
    [anon_sym_xor_eq] = ACTIONS(5439),
    [anon_sym_LT_EQ_GT] = ACTIONS(5441),
    [anon_sym_or] = ACTIONS(5439),
    [anon_sym_and] = ACTIONS(5439),
    [anon_sym_bitor] = ACTIONS(5439),
    [anon_sym_xor] = ACTIONS(5439),
    [anon_sym_bitand] = ACTIONS(5439),
    [anon_sym_not_eq] = ACTIONS(5439),
    [anon_sym_DASH_DASH] = ACTIONS(5441),
    [anon_sym_PLUS_PLUS] = ACTIONS(5441),
    [anon_sym_DOT] = ACTIONS(5439),
    [anon_sym_DOT_STAR] = ACTIONS(5441),
    [anon_sym_DASH_GT] = ACTIONS(5441),
    [anon_sym_L_DQUOTE] = ACTIONS(5441),
    [anon_sym_u_DQUOTE] = ACTIONS(5441),
    [anon_sym_U_DQUOTE] = ACTIONS(5441),
    [anon_sym_u8_DQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5441),
    [anon_sym_LR_DQUOTE] = ACTIONS(5441),
    [anon_sym_uR_DQUOTE] = ACTIONS(5441),
    [anon_sym_UR_DQUOTE] = ACTIONS(5441),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5441),
    [sym_literal_suffix] = ACTIONS(5439),
  },
  [2685] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2672),
    [sym_identifier] = ACTIONS(5363),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5730),
    [anon_sym_COMMA] = ACTIONS(5730),
    [anon_sym_LPAREN2] = ACTIONS(5730),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_PLUS] = ACTIONS(5733),
    [anon_sym_STAR] = ACTIONS(5730),
    [anon_sym_SLASH] = ACTIONS(5733),
    [anon_sym_PERCENT] = ACTIONS(5730),
    [anon_sym_PIPE_PIPE] = ACTIONS(5730),
    [anon_sym_AMP_AMP] = ACTIONS(5730),
    [anon_sym_PIPE] = ACTIONS(5733),
    [anon_sym_CARET] = ACTIONS(5730),
    [anon_sym_AMP] = ACTIONS(5733),
    [anon_sym_EQ_EQ] = ACTIONS(5730),
    [anon_sym_BANG_EQ] = ACTIONS(5730),
    [anon_sym_GT] = ACTIONS(5733),
    [anon_sym_GT_EQ] = ACTIONS(5733),
    [anon_sym_LT_EQ] = ACTIONS(5733),
    [anon_sym_LT] = ACTIONS(5733),
    [anon_sym_LT_LT] = ACTIONS(5730),
    [anon_sym_GT_GT] = ACTIONS(5733),
    [anon_sym___extension__] = ACTIONS(5733),
    [anon_sym___attribute__] = ACTIONS(5733),
    [anon_sym_LBRACE] = ACTIONS(5730),
    [anon_sym_signed] = ACTIONS(6036),
    [anon_sym_unsigned] = ACTIONS(6036),
    [anon_sym_long] = ACTIONS(6036),
    [anon_sym_short] = ACTIONS(6036),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_const] = ACTIONS(5733),
    [anon_sym_constexpr] = ACTIONS(5733),
    [anon_sym_volatile] = ACTIONS(5733),
    [anon_sym_restrict] = ACTIONS(5733),
    [anon_sym___restrict__] = ACTIONS(5733),
    [anon_sym__Atomic] = ACTIONS(5733),
    [anon_sym__Noreturn] = ACTIONS(5733),
    [anon_sym_noreturn] = ACTIONS(5733),
    [anon_sym_mutable] = ACTIONS(5733),
    [anon_sym_constinit] = ACTIONS(5733),
    [anon_sym_consteval] = ACTIONS(5733),
    [anon_sym_PROGMEM] = ACTIONS(5733),
    [aux_sym_primitive_type_token1] = ACTIONS(5363),
    [anon_sym_byte] = ACTIONS(5363),
    [anon_sym_word] = ACTIONS(5363),
    [anon_sym_QMARK] = ACTIONS(5730),
    [anon_sym_LT_EQ_GT] = ACTIONS(5730),
    [anon_sym_or] = ACTIONS(5733),
    [anon_sym_and] = ACTIONS(5733),
    [anon_sym_bitor] = ACTIONS(5733),
    [anon_sym_xor] = ACTIONS(5733),
    [anon_sym_bitand] = ACTIONS(5733),
    [anon_sym_not_eq] = ACTIONS(5733),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_DOT] = ACTIONS(5733),
    [anon_sym_DOT_STAR] = ACTIONS(5730),
    [anon_sym_DASH_GT] = ACTIONS(5730),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5733),
    [anon_sym_decltype] = ACTIONS(5733),
    [anon_sym_final] = ACTIONS(5733),
    [anon_sym_override] = ACTIONS(5733),
    [anon_sym_GT2] = ACTIONS(5730),
    [anon_sym_requires] = ACTIONS(5733),
  },
  [2686] = {
    [sym_decltype_auto] = STATE(2728),
    [sym_identifier] = ACTIONS(5499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5501),
    [anon_sym_COMMA] = ACTIONS(5501),
    [anon_sym_RPAREN] = ACTIONS(5501),
    [aux_sym_preproc_if_token2] = ACTIONS(5501),
    [aux_sym_preproc_else_token1] = ACTIONS(5501),
    [aux_sym_preproc_elif_token1] = ACTIONS(5499),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5501),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5501),
    [anon_sym_LPAREN2] = ACTIONS(5501),
    [anon_sym_DASH] = ACTIONS(5499),
    [anon_sym_PLUS] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5499),
    [anon_sym_SLASH] = ACTIONS(5499),
    [anon_sym_PERCENT] = ACTIONS(5499),
    [anon_sym_PIPE_PIPE] = ACTIONS(5501),
    [anon_sym_AMP_AMP] = ACTIONS(5501),
    [anon_sym_PIPE] = ACTIONS(5499),
    [anon_sym_CARET] = ACTIONS(5499),
    [anon_sym_AMP] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5501),
    [anon_sym_BANG_EQ] = ACTIONS(5501),
    [anon_sym_GT] = ACTIONS(5499),
    [anon_sym_GT_EQ] = ACTIONS(5501),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_LT] = ACTIONS(5499),
    [anon_sym_LT_LT] = ACTIONS(5499),
    [anon_sym_GT_GT] = ACTIONS(5499),
    [anon_sym_SEMI] = ACTIONS(5501),
    [anon_sym___attribute__] = ACTIONS(5499),
    [anon_sym_LBRACE] = ACTIONS(5501),
    [anon_sym_RBRACE] = ACTIONS(5501),
    [anon_sym_LBRACK] = ACTIONS(5501),
    [anon_sym_RBRACK] = ACTIONS(5501),
    [anon_sym_EQ] = ACTIONS(5499),
    [anon_sym_COLON] = ACTIONS(5501),
    [anon_sym_QMARK] = ACTIONS(5501),
    [anon_sym_STAR_EQ] = ACTIONS(5501),
    [anon_sym_SLASH_EQ] = ACTIONS(5501),
    [anon_sym_PERCENT_EQ] = ACTIONS(5501),
    [anon_sym_PLUS_EQ] = ACTIONS(5501),
    [anon_sym_DASH_EQ] = ACTIONS(5501),
    [anon_sym_LT_LT_EQ] = ACTIONS(5501),
    [anon_sym_GT_GT_EQ] = ACTIONS(5501),
    [anon_sym_AMP_EQ] = ACTIONS(5501),
    [anon_sym_CARET_EQ] = ACTIONS(5501),
    [anon_sym_PIPE_EQ] = ACTIONS(5501),
    [anon_sym_and_eq] = ACTIONS(5499),
    [anon_sym_or_eq] = ACTIONS(5499),
    [anon_sym_xor_eq] = ACTIONS(5499),
    [anon_sym_LT_EQ_GT] = ACTIONS(5501),
    [anon_sym_or] = ACTIONS(5499),
    [anon_sym_and] = ACTIONS(5499),
    [anon_sym_bitor] = ACTIONS(5499),
    [anon_sym_xor] = ACTIONS(5499),
    [anon_sym_bitand] = ACTIONS(5499),
    [anon_sym_not_eq] = ACTIONS(5499),
    [anon_sym_DASH_DASH] = ACTIONS(5501),
    [anon_sym_PLUS_PLUS] = ACTIONS(5501),
    [anon_sym_DOT] = ACTIONS(5499),
    [anon_sym_DOT_STAR] = ACTIONS(5501),
    [anon_sym_DASH_GT] = ACTIONS(5501),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5817),
    [anon_sym_decltype] = ACTIONS(5819),
  },
  [2687] = {
    [sym_template_argument_list] = STATE(2436),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2730),
    [sym_identifier] = ACTIONS(4246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4254),
    [anon_sym_COMMA] = ACTIONS(4254),
    [aux_sym_preproc_if_token2] = ACTIONS(4254),
    [aux_sym_preproc_else_token1] = ACTIONS(4254),
    [aux_sym_preproc_elif_token1] = ACTIONS(4246),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4254),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4254),
    [anon_sym_LPAREN2] = ACTIONS(4254),
    [anon_sym_DASH] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_STAR] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4254),
    [anon_sym_AMP_AMP] = ACTIONS(4254),
    [anon_sym_PIPE] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4254),
    [anon_sym_BANG_EQ] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4246),
    [anon_sym_GT_EQ] = ACTIONS(4254),
    [anon_sym_LT_EQ] = ACTIONS(4246),
    [anon_sym_LT] = ACTIONS(5837),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4254),
    [anon_sym_signed] = ACTIONS(5962),
    [anon_sym_unsigned] = ACTIONS(5962),
    [anon_sym_long] = ACTIONS(5962),
    [anon_sym_short] = ACTIONS(5962),
    [anon_sym_LBRACK] = ACTIONS(4254),
    [anon_sym_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4254),
    [anon_sym_STAR_EQ] = ACTIONS(4254),
    [anon_sym_SLASH_EQ] = ACTIONS(4254),
    [anon_sym_PERCENT_EQ] = ACTIONS(4254),
    [anon_sym_PLUS_EQ] = ACTIONS(4254),
    [anon_sym_DASH_EQ] = ACTIONS(4254),
    [anon_sym_LT_LT_EQ] = ACTIONS(4254),
    [anon_sym_GT_GT_EQ] = ACTIONS(4254),
    [anon_sym_AMP_EQ] = ACTIONS(4254),
    [anon_sym_CARET_EQ] = ACTIONS(4254),
    [anon_sym_PIPE_EQ] = ACTIONS(4254),
    [anon_sym_and_eq] = ACTIONS(4246),
    [anon_sym_or_eq] = ACTIONS(4246),
    [anon_sym_xor_eq] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4254),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_bitor] = ACTIONS(4246),
    [anon_sym_xor] = ACTIONS(4246),
    [anon_sym_bitand] = ACTIONS(4246),
    [anon_sym_not_eq] = ACTIONS(4246),
    [anon_sym_DASH_DASH] = ACTIONS(4254),
    [anon_sym_PLUS_PLUS] = ACTIONS(4254),
    [anon_sym_DOT] = ACTIONS(4246),
    [anon_sym_DOT_STAR] = ACTIONS(4254),
    [anon_sym_DASH_GT] = ACTIONS(4254),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4246),
    [anon_sym_decltype] = ACTIONS(4246),
  },
  [2688] = {
    [sym_identifier] = ACTIONS(5495),
    [anon_sym_LPAREN2] = ACTIONS(5497),
    [anon_sym_TILDE] = ACTIONS(5497),
    [anon_sym_STAR] = ACTIONS(5497),
    [anon_sym_PIPE_PIPE] = ACTIONS(5497),
    [anon_sym_AMP_AMP] = ACTIONS(5497),
    [anon_sym_AMP] = ACTIONS(5495),
    [anon_sym___extension__] = ACTIONS(5495),
    [anon_sym_extern] = ACTIONS(5495),
    [anon_sym___attribute__] = ACTIONS(5495),
    [anon_sym_COLON_COLON] = ACTIONS(5485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5497),
    [anon_sym___declspec] = ACTIONS(5495),
    [anon_sym___based] = ACTIONS(5495),
    [anon_sym___cdecl] = ACTIONS(5495),
    [anon_sym___clrcall] = ACTIONS(5495),
    [anon_sym___stdcall] = ACTIONS(5495),
    [anon_sym___fastcall] = ACTIONS(5495),
    [anon_sym___thiscall] = ACTIONS(5495),
    [anon_sym___vectorcall] = ACTIONS(5495),
    [anon_sym_signed] = ACTIONS(5495),
    [anon_sym_unsigned] = ACTIONS(5495),
    [anon_sym_long] = ACTIONS(5495),
    [anon_sym_short] = ACTIONS(5495),
    [anon_sym_LBRACK] = ACTIONS(5495),
    [anon_sym_static] = ACTIONS(5495),
    [anon_sym_register] = ACTIONS(5495),
    [anon_sym_inline] = ACTIONS(5495),
    [anon_sym___inline] = ACTIONS(5495),
    [anon_sym___inline__] = ACTIONS(5495),
    [anon_sym___forceinline] = ACTIONS(5495),
    [anon_sym_thread_local] = ACTIONS(5495),
    [anon_sym___thread] = ACTIONS(5495),
    [anon_sym_const] = ACTIONS(5495),
    [anon_sym_constexpr] = ACTIONS(5495),
    [anon_sym_volatile] = ACTIONS(5495),
    [anon_sym_restrict] = ACTIONS(5495),
    [anon_sym___restrict__] = ACTIONS(5495),
    [anon_sym__Atomic] = ACTIONS(5495),
    [anon_sym__Noreturn] = ACTIONS(5495),
    [anon_sym_noreturn] = ACTIONS(5495),
    [anon_sym_mutable] = ACTIONS(5495),
    [anon_sym_constinit] = ACTIONS(5495),
    [anon_sym_consteval] = ACTIONS(5495),
    [anon_sym_PROGMEM] = ACTIONS(5495),
    [aux_sym_primitive_type_token1] = ACTIONS(5495),
    [anon_sym_byte] = ACTIONS(5495),
    [anon_sym_word] = ACTIONS(5495),
    [anon_sym_enum] = ACTIONS(5495),
    [anon_sym_class] = ACTIONS(5495),
    [anon_sym_struct] = ACTIONS(5495),
    [anon_sym_union] = ACTIONS(5495),
    [anon_sym_or] = ACTIONS(5495),
    [anon_sym_and] = ACTIONS(5495),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5495),
    [anon_sym_decltype] = ACTIONS(5495),
    [anon_sym_virtual] = ACTIONS(5495),
    [anon_sym_alignas] = ACTIONS(5495),
    [anon_sym_explicit] = ACTIONS(5495),
    [anon_sym_typename] = ACTIONS(5495),
    [anon_sym_template] = ACTIONS(5495),
    [anon_sym_operator] = ACTIONS(5495),
    [anon_sym_friend] = ACTIONS(5495),
    [anon_sym_using] = ACTIONS(5495),
    [anon_sym_concept] = ACTIONS(5495),
  },
  [2689] = {
    [sym_template_argument_list] = STATE(2436),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4254),
    [anon_sym_COMMA] = ACTIONS(4254),
    [anon_sym_RPAREN] = ACTIONS(4254),
    [anon_sym_LPAREN2] = ACTIONS(4254),
    [anon_sym_DASH] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_STAR] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4254),
    [anon_sym_AMP_AMP] = ACTIONS(4254),
    [anon_sym_PIPE] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4254),
    [anon_sym_BANG_EQ] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4246),
    [anon_sym_GT_EQ] = ACTIONS(4254),
    [anon_sym_LT_EQ] = ACTIONS(4246),
    [anon_sym_LT] = ACTIONS(5837),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_SEMI] = ACTIONS(4254),
    [anon_sym___attribute__] = ACTIONS(4254),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4254),
    [anon_sym_RBRACE] = ACTIONS(4254),
    [anon_sym_signed] = ACTIONS(6045),
    [anon_sym_unsigned] = ACTIONS(6045),
    [anon_sym_long] = ACTIONS(6045),
    [anon_sym_short] = ACTIONS(6045),
    [anon_sym_LBRACK] = ACTIONS(4254),
    [anon_sym_RBRACK] = ACTIONS(4254),
    [anon_sym_EQ] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4254),
    [anon_sym_STAR_EQ] = ACTIONS(4254),
    [anon_sym_SLASH_EQ] = ACTIONS(4254),
    [anon_sym_PERCENT_EQ] = ACTIONS(4254),
    [anon_sym_PLUS_EQ] = ACTIONS(4254),
    [anon_sym_DASH_EQ] = ACTIONS(4254),
    [anon_sym_LT_LT_EQ] = ACTIONS(4254),
    [anon_sym_GT_GT_EQ] = ACTIONS(4254),
    [anon_sym_AMP_EQ] = ACTIONS(4254),
    [anon_sym_CARET_EQ] = ACTIONS(4254),
    [anon_sym_PIPE_EQ] = ACTIONS(4254),
    [anon_sym_and_eq] = ACTIONS(4254),
    [anon_sym_or_eq] = ACTIONS(4254),
    [anon_sym_xor_eq] = ACTIONS(4254),
    [anon_sym_LT_EQ_GT] = ACTIONS(4254),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_bitor] = ACTIONS(4254),
    [anon_sym_xor] = ACTIONS(4246),
    [anon_sym_bitand] = ACTIONS(4254),
    [anon_sym_not_eq] = ACTIONS(4254),
    [anon_sym_DASH_DASH] = ACTIONS(4254),
    [anon_sym_PLUS_PLUS] = ACTIONS(4254),
    [anon_sym_DOT] = ACTIONS(4246),
    [anon_sym_DOT_STAR] = ACTIONS(4254),
    [anon_sym_DASH_GT] = ACTIONS(4254),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4254),
    [anon_sym_decltype] = ACTIONS(4254),
  },
  [2690] = {
    [sym_identifier] = ACTIONS(6065),
    [anon_sym_LPAREN2] = ACTIONS(6067),
    [anon_sym_TILDE] = ACTIONS(6067),
    [anon_sym_STAR] = ACTIONS(6067),
    [anon_sym_PIPE_PIPE] = ACTIONS(6067),
    [anon_sym_AMP_AMP] = ACTIONS(6012),
    [anon_sym_AMP] = ACTIONS(6065),
    [anon_sym___extension__] = ACTIONS(6065),
    [anon_sym_extern] = ACTIONS(6065),
    [anon_sym___attribute__] = ACTIONS(6065),
    [anon_sym_COLON_COLON] = ACTIONS(6067),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6067),
    [anon_sym___declspec] = ACTIONS(6065),
    [anon_sym___based] = ACTIONS(6065),
    [anon_sym___cdecl] = ACTIONS(6065),
    [anon_sym___clrcall] = ACTIONS(6065),
    [anon_sym___stdcall] = ACTIONS(6065),
    [anon_sym___fastcall] = ACTIONS(6065),
    [anon_sym___thiscall] = ACTIONS(6065),
    [anon_sym___vectorcall] = ACTIONS(6065),
    [anon_sym_signed] = ACTIONS(6065),
    [anon_sym_unsigned] = ACTIONS(6065),
    [anon_sym_long] = ACTIONS(6065),
    [anon_sym_short] = ACTIONS(6065),
    [anon_sym_LBRACK] = ACTIONS(6065),
    [anon_sym_static] = ACTIONS(6065),
    [anon_sym_register] = ACTIONS(6065),
    [anon_sym_inline] = ACTIONS(6065),
    [anon_sym___inline] = ACTIONS(6065),
    [anon_sym___inline__] = ACTIONS(6065),
    [anon_sym___forceinline] = ACTIONS(6065),
    [anon_sym_thread_local] = ACTIONS(6065),
    [anon_sym___thread] = ACTIONS(6065),
    [anon_sym_const] = ACTIONS(6065),
    [anon_sym_constexpr] = ACTIONS(6065),
    [anon_sym_volatile] = ACTIONS(6065),
    [anon_sym_restrict] = ACTIONS(6065),
    [anon_sym___restrict__] = ACTIONS(6065),
    [anon_sym__Atomic] = ACTIONS(6065),
    [anon_sym__Noreturn] = ACTIONS(6065),
    [anon_sym_noreturn] = ACTIONS(6065),
    [anon_sym_mutable] = ACTIONS(6065),
    [anon_sym_constinit] = ACTIONS(6065),
    [anon_sym_consteval] = ACTIONS(6065),
    [anon_sym_PROGMEM] = ACTIONS(6065),
    [aux_sym_primitive_type_token1] = ACTIONS(6065),
    [anon_sym_byte] = ACTIONS(6065),
    [anon_sym_word] = ACTIONS(6065),
    [anon_sym_enum] = ACTIONS(6065),
    [anon_sym_class] = ACTIONS(6065),
    [anon_sym_struct] = ACTIONS(6065),
    [anon_sym_union] = ACTIONS(6065),
    [anon_sym_or] = ACTIONS(6065),
    [anon_sym_and] = ACTIONS(6016),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6065),
    [anon_sym_decltype] = ACTIONS(6065),
    [anon_sym_virtual] = ACTIONS(6065),
    [anon_sym_alignas] = ACTIONS(6065),
    [anon_sym_explicit] = ACTIONS(6065),
    [anon_sym_typename] = ACTIONS(6065),
    [anon_sym_template] = ACTIONS(6065),
    [anon_sym_operator] = ACTIONS(6065),
    [anon_sym_friend] = ACTIONS(6065),
    [anon_sym_using] = ACTIONS(6065),
    [anon_sym_concept] = ACTIONS(6065),
  },
  [2691] = {
    [sym_attribute_declaration] = STATE(2729),
    [sym_parameter_list] = STATE(2784),
    [aux_sym_attributed_declarator_repeat1] = STATE(2729),
    [sym_identifier] = ACTIONS(6069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6071),
    [anon_sym_COMMA] = ACTIONS(6071),
    [anon_sym_RPAREN] = ACTIONS(6071),
    [aux_sym_preproc_if_token2] = ACTIONS(6071),
    [aux_sym_preproc_else_token1] = ACTIONS(6071),
    [aux_sym_preproc_elif_token1] = ACTIONS(6069),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6071),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6071),
    [anon_sym_LPAREN2] = ACTIONS(6000),
    [anon_sym_DASH] = ACTIONS(6069),
    [anon_sym_PLUS] = ACTIONS(6069),
    [anon_sym_STAR] = ACTIONS(6069),
    [anon_sym_SLASH] = ACTIONS(6069),
    [anon_sym_PERCENT] = ACTIONS(6069),
    [anon_sym_PIPE_PIPE] = ACTIONS(6071),
    [anon_sym_AMP_AMP] = ACTIONS(6071),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_CARET] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6069),
    [anon_sym_EQ_EQ] = ACTIONS(6071),
    [anon_sym_BANG_EQ] = ACTIONS(6071),
    [anon_sym_GT] = ACTIONS(6069),
    [anon_sym_GT_EQ] = ACTIONS(6071),
    [anon_sym_LT_EQ] = ACTIONS(6069),
    [anon_sym_LT] = ACTIONS(6069),
    [anon_sym_LT_LT] = ACTIONS(6069),
    [anon_sym_GT_GT] = ACTIONS(6069),
    [anon_sym_SEMI] = ACTIONS(6071),
    [anon_sym___attribute__] = ACTIONS(6069),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6002),
    [anon_sym_RBRACE] = ACTIONS(6071),
    [anon_sym_LBRACK] = ACTIONS(6004),
    [anon_sym_RBRACK] = ACTIONS(6071),
    [anon_sym_EQ] = ACTIONS(6069),
    [anon_sym_COLON] = ACTIONS(6071),
    [anon_sym_QMARK] = ACTIONS(6071),
    [anon_sym_STAR_EQ] = ACTIONS(6071),
    [anon_sym_SLASH_EQ] = ACTIONS(6071),
    [anon_sym_PERCENT_EQ] = ACTIONS(6071),
    [anon_sym_PLUS_EQ] = ACTIONS(6071),
    [anon_sym_DASH_EQ] = ACTIONS(6071),
    [anon_sym_LT_LT_EQ] = ACTIONS(6071),
    [anon_sym_GT_GT_EQ] = ACTIONS(6071),
    [anon_sym_AMP_EQ] = ACTIONS(6071),
    [anon_sym_CARET_EQ] = ACTIONS(6071),
    [anon_sym_PIPE_EQ] = ACTIONS(6071),
    [anon_sym_and_eq] = ACTIONS(6069),
    [anon_sym_or_eq] = ACTIONS(6069),
    [anon_sym_xor_eq] = ACTIONS(6069),
    [anon_sym_LT_EQ_GT] = ACTIONS(6071),
    [anon_sym_or] = ACTIONS(6069),
    [anon_sym_and] = ACTIONS(6069),
    [anon_sym_bitor] = ACTIONS(6069),
    [anon_sym_xor] = ACTIONS(6069),
    [anon_sym_bitand] = ACTIONS(6069),
    [anon_sym_not_eq] = ACTIONS(6069),
    [anon_sym_DASH_DASH] = ACTIONS(6071),
    [anon_sym_PLUS_PLUS] = ACTIONS(6071),
    [anon_sym_DOT] = ACTIONS(6069),
    [anon_sym_DOT_STAR] = ACTIONS(6071),
    [anon_sym_DASH_GT] = ACTIONS(6071),
    [sym_comment] = ACTIONS(3),
  },
  [2692] = {
    [sym_primitive_type] = STATE(3049),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2792),
    [sym_identifier] = ACTIONS(6073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5489),
    [anon_sym_COMMA] = ACTIONS(5489),
    [anon_sym_RPAREN] = ACTIONS(5489),
    [anon_sym_LPAREN2] = ACTIONS(5489),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_PLUS] = ACTIONS(5491),
    [anon_sym_STAR] = ACTIONS(5491),
    [anon_sym_SLASH] = ACTIONS(5491),
    [anon_sym_PERCENT] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5489),
    [anon_sym_AMP_AMP] = ACTIONS(5489),
    [anon_sym_PIPE] = ACTIONS(5491),
    [anon_sym_CARET] = ACTIONS(5491),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_EQ_EQ] = ACTIONS(5489),
    [anon_sym_BANG_EQ] = ACTIONS(5489),
    [anon_sym_GT] = ACTIONS(5491),
    [anon_sym_GT_EQ] = ACTIONS(5489),
    [anon_sym_LT_EQ] = ACTIONS(5491),
    [anon_sym_LT] = ACTIONS(5491),
    [anon_sym_LT_LT] = ACTIONS(5491),
    [anon_sym_GT_GT] = ACTIONS(5491),
    [anon_sym___attribute__] = ACTIONS(5491),
    [anon_sym_LBRACE] = ACTIONS(5489),
    [anon_sym_signed] = ACTIONS(6075),
    [anon_sym_unsigned] = ACTIONS(6075),
    [anon_sym_long] = ACTIONS(6075),
    [anon_sym_short] = ACTIONS(6075),
    [anon_sym_LBRACK] = ACTIONS(5489),
    [anon_sym_EQ] = ACTIONS(5491),
    [aux_sym_primitive_type_token1] = ACTIONS(6077),
    [anon_sym_byte] = ACTIONS(6077),
    [anon_sym_word] = ACTIONS(6077),
    [anon_sym_QMARK] = ACTIONS(5489),
    [anon_sym_STAR_EQ] = ACTIONS(5489),
    [anon_sym_SLASH_EQ] = ACTIONS(5489),
    [anon_sym_PERCENT_EQ] = ACTIONS(5489),
    [anon_sym_PLUS_EQ] = ACTIONS(5489),
    [anon_sym_DASH_EQ] = ACTIONS(5489),
    [anon_sym_LT_LT_EQ] = ACTIONS(5489),
    [anon_sym_GT_GT_EQ] = ACTIONS(5489),
    [anon_sym_AMP_EQ] = ACTIONS(5489),
    [anon_sym_CARET_EQ] = ACTIONS(5489),
    [anon_sym_PIPE_EQ] = ACTIONS(5489),
    [anon_sym_and_eq] = ACTIONS(5491),
    [anon_sym_or_eq] = ACTIONS(5491),
    [anon_sym_xor_eq] = ACTIONS(5491),
    [anon_sym_LT_EQ_GT] = ACTIONS(5489),
    [anon_sym_or] = ACTIONS(5491),
    [anon_sym_and] = ACTIONS(5491),
    [anon_sym_bitor] = ACTIONS(5491),
    [anon_sym_xor] = ACTIONS(5491),
    [anon_sym_bitand] = ACTIONS(5491),
    [anon_sym_not_eq] = ACTIONS(5491),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_DOT] = ACTIONS(5491),
    [anon_sym_DOT_STAR] = ACTIONS(5489),
    [anon_sym_DASH_GT] = ACTIONS(5491),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5491),
    [anon_sym_decltype] = ACTIONS(5491),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5489),
  },
  [2693] = {
    [sym_identifier] = ACTIONS(5606),
    [anon_sym_LPAREN2] = ACTIONS(5608),
    [anon_sym_TILDE] = ACTIONS(5608),
    [anon_sym_STAR] = ACTIONS(5608),
    [anon_sym_PIPE_PIPE] = ACTIONS(5608),
    [anon_sym_AMP_AMP] = ACTIONS(5608),
    [anon_sym_AMP] = ACTIONS(5606),
    [anon_sym___extension__] = ACTIONS(5606),
    [anon_sym_extern] = ACTIONS(5606),
    [anon_sym___attribute__] = ACTIONS(5606),
    [anon_sym_COLON_COLON] = ACTIONS(5608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5608),
    [anon_sym___declspec] = ACTIONS(5606),
    [anon_sym___based] = ACTIONS(5606),
    [anon_sym___cdecl] = ACTIONS(5606),
    [anon_sym___clrcall] = ACTIONS(5606),
    [anon_sym___stdcall] = ACTIONS(5606),
    [anon_sym___fastcall] = ACTIONS(5606),
    [anon_sym___thiscall] = ACTIONS(5606),
    [anon_sym___vectorcall] = ACTIONS(5606),
    [anon_sym_signed] = ACTIONS(5606),
    [anon_sym_unsigned] = ACTIONS(5606),
    [anon_sym_long] = ACTIONS(5606),
    [anon_sym_short] = ACTIONS(5606),
    [anon_sym_LBRACK] = ACTIONS(5606),
    [anon_sym_static] = ACTIONS(5606),
    [anon_sym_register] = ACTIONS(5606),
    [anon_sym_inline] = ACTIONS(5606),
    [anon_sym___inline] = ACTIONS(5606),
    [anon_sym___inline__] = ACTIONS(5606),
    [anon_sym___forceinline] = ACTIONS(5606),
    [anon_sym_thread_local] = ACTIONS(5606),
    [anon_sym___thread] = ACTIONS(5606),
    [anon_sym_const] = ACTIONS(5606),
    [anon_sym_constexpr] = ACTIONS(5606),
    [anon_sym_volatile] = ACTIONS(5606),
    [anon_sym_restrict] = ACTIONS(5606),
    [anon_sym___restrict__] = ACTIONS(5606),
    [anon_sym__Atomic] = ACTIONS(5606),
    [anon_sym__Noreturn] = ACTIONS(5606),
    [anon_sym_noreturn] = ACTIONS(5606),
    [anon_sym_mutable] = ACTIONS(5606),
    [anon_sym_constinit] = ACTIONS(5606),
    [anon_sym_consteval] = ACTIONS(5606),
    [anon_sym_PROGMEM] = ACTIONS(5606),
    [aux_sym_primitive_type_token1] = ACTIONS(5606),
    [anon_sym_byte] = ACTIONS(5606),
    [anon_sym_word] = ACTIONS(5606),
    [anon_sym_enum] = ACTIONS(5606),
    [anon_sym_class] = ACTIONS(5606),
    [anon_sym_struct] = ACTIONS(5606),
    [anon_sym_union] = ACTIONS(5606),
    [anon_sym_or] = ACTIONS(5606),
    [anon_sym_and] = ACTIONS(5606),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5606),
    [anon_sym_decltype] = ACTIONS(5606),
    [anon_sym_virtual] = ACTIONS(5606),
    [anon_sym_alignas] = ACTIONS(5606),
    [anon_sym_explicit] = ACTIONS(5606),
    [anon_sym_typename] = ACTIONS(5606),
    [anon_sym_template] = ACTIONS(5606),
    [anon_sym_operator] = ACTIONS(5606),
    [anon_sym_friend] = ACTIONS(5606),
    [anon_sym_using] = ACTIONS(5606),
    [anon_sym_concept] = ACTIONS(5606),
  },
  [2694] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5419),
    [anon_sym_COMMA] = ACTIONS(5419),
    [anon_sym_RPAREN] = ACTIONS(5419),
    [anon_sym_LPAREN2] = ACTIONS(5419),
    [anon_sym_DASH] = ACTIONS(5417),
    [anon_sym_PLUS] = ACTIONS(5417),
    [anon_sym_STAR] = ACTIONS(5417),
    [anon_sym_SLASH] = ACTIONS(5417),
    [anon_sym_PERCENT] = ACTIONS(5417),
    [anon_sym_PIPE_PIPE] = ACTIONS(5419),
    [anon_sym_AMP_AMP] = ACTIONS(5419),
    [anon_sym_PIPE] = ACTIONS(5417),
    [anon_sym_CARET] = ACTIONS(5417),
    [anon_sym_AMP] = ACTIONS(5417),
    [anon_sym_EQ_EQ] = ACTIONS(5419),
    [anon_sym_BANG_EQ] = ACTIONS(5419),
    [anon_sym_GT] = ACTIONS(5417),
    [anon_sym_GT_EQ] = ACTIONS(5419),
    [anon_sym_LT_EQ] = ACTIONS(5417),
    [anon_sym_LT] = ACTIONS(5417),
    [anon_sym_LT_LT] = ACTIONS(5417),
    [anon_sym_GT_GT] = ACTIONS(5417),
    [anon_sym_SEMI] = ACTIONS(5419),
    [anon_sym_RBRACE] = ACTIONS(5419),
    [anon_sym_LBRACK] = ACTIONS(5419),
    [anon_sym_RBRACK] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(5417),
    [anon_sym_COLON] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5419),
    [anon_sym_STAR_EQ] = ACTIONS(5419),
    [anon_sym_SLASH_EQ] = ACTIONS(5419),
    [anon_sym_PERCENT_EQ] = ACTIONS(5419),
    [anon_sym_PLUS_EQ] = ACTIONS(5419),
    [anon_sym_DASH_EQ] = ACTIONS(5419),
    [anon_sym_LT_LT_EQ] = ACTIONS(5419),
    [anon_sym_GT_GT_EQ] = ACTIONS(5419),
    [anon_sym_AMP_EQ] = ACTIONS(5419),
    [anon_sym_CARET_EQ] = ACTIONS(5419),
    [anon_sym_PIPE_EQ] = ACTIONS(5419),
    [anon_sym_and_eq] = ACTIONS(5417),
    [anon_sym_or_eq] = ACTIONS(5417),
    [anon_sym_xor_eq] = ACTIONS(5417),
    [anon_sym_LT_EQ_GT] = ACTIONS(5419),
    [anon_sym_or] = ACTIONS(5417),
    [anon_sym_and] = ACTIONS(5417),
    [anon_sym_bitor] = ACTIONS(5417),
    [anon_sym_xor] = ACTIONS(5417),
    [anon_sym_bitand] = ACTIONS(5417),
    [anon_sym_not_eq] = ACTIONS(5417),
    [anon_sym_DASH_DASH] = ACTIONS(5419),
    [anon_sym_PLUS_PLUS] = ACTIONS(5419),
    [anon_sym_DOT] = ACTIONS(5417),
    [anon_sym_DOT_STAR] = ACTIONS(5419),
    [anon_sym_DASH_GT] = ACTIONS(5419),
    [anon_sym_L_DQUOTE] = ACTIONS(5419),
    [anon_sym_u_DQUOTE] = ACTIONS(5419),
    [anon_sym_U_DQUOTE] = ACTIONS(5419),
    [anon_sym_u8_DQUOTE] = ACTIONS(5419),
    [anon_sym_DQUOTE] = ACTIONS(5419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5419),
    [anon_sym_LR_DQUOTE] = ACTIONS(5419),
    [anon_sym_uR_DQUOTE] = ACTIONS(5419),
    [anon_sym_UR_DQUOTE] = ACTIONS(5419),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5419),
    [sym_literal_suffix] = ACTIONS(5417),
  },
  [2695] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2699),
    [sym_identifier] = ACTIONS(5733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5730),
    [anon_sym_COMMA] = ACTIONS(5730),
    [aux_sym_preproc_if_token2] = ACTIONS(5730),
    [aux_sym_preproc_else_token1] = ACTIONS(5730),
    [aux_sym_preproc_elif_token1] = ACTIONS(5730),
    [anon_sym_LPAREN2] = ACTIONS(5730),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_PLUS] = ACTIONS(5733),
    [anon_sym_STAR] = ACTIONS(5733),
    [anon_sym_SLASH] = ACTIONS(5733),
    [anon_sym_PERCENT] = ACTIONS(5733),
    [anon_sym_PIPE_PIPE] = ACTIONS(5730),
    [anon_sym_AMP_AMP] = ACTIONS(5730),
    [anon_sym_PIPE] = ACTIONS(5733),
    [anon_sym_CARET] = ACTIONS(5733),
    [anon_sym_AMP] = ACTIONS(5733),
    [anon_sym_EQ_EQ] = ACTIONS(5730),
    [anon_sym_BANG_EQ] = ACTIONS(5730),
    [anon_sym_GT] = ACTIONS(5733),
    [anon_sym_GT_EQ] = ACTIONS(5730),
    [anon_sym_LT_EQ] = ACTIONS(5733),
    [anon_sym_LT] = ACTIONS(5733),
    [anon_sym_LT_LT] = ACTIONS(5733),
    [anon_sym_GT_GT] = ACTIONS(5733),
    [anon_sym___attribute__] = ACTIONS(5733),
    [anon_sym_LBRACE] = ACTIONS(5730),
    [anon_sym_signed] = ACTIONS(6079),
    [anon_sym_unsigned] = ACTIONS(6079),
    [anon_sym_long] = ACTIONS(6079),
    [anon_sym_short] = ACTIONS(6079),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_EQ] = ACTIONS(5733),
    [aux_sym_primitive_type_token1] = ACTIONS(5363),
    [anon_sym_byte] = ACTIONS(5363),
    [anon_sym_word] = ACTIONS(5363),
    [anon_sym_QMARK] = ACTIONS(5730),
    [anon_sym_STAR_EQ] = ACTIONS(5730),
    [anon_sym_SLASH_EQ] = ACTIONS(5730),
    [anon_sym_PERCENT_EQ] = ACTIONS(5730),
    [anon_sym_PLUS_EQ] = ACTIONS(5730),
    [anon_sym_DASH_EQ] = ACTIONS(5730),
    [anon_sym_LT_LT_EQ] = ACTIONS(5730),
    [anon_sym_GT_GT_EQ] = ACTIONS(5730),
    [anon_sym_AMP_EQ] = ACTIONS(5730),
    [anon_sym_CARET_EQ] = ACTIONS(5730),
    [anon_sym_PIPE_EQ] = ACTIONS(5730),
    [anon_sym_and_eq] = ACTIONS(5733),
    [anon_sym_or_eq] = ACTIONS(5733),
    [anon_sym_xor_eq] = ACTIONS(5733),
    [anon_sym_LT_EQ_GT] = ACTIONS(5730),
    [anon_sym_or] = ACTIONS(5733),
    [anon_sym_and] = ACTIONS(5733),
    [anon_sym_bitor] = ACTIONS(5733),
    [anon_sym_xor] = ACTIONS(5733),
    [anon_sym_bitand] = ACTIONS(5733),
    [anon_sym_not_eq] = ACTIONS(5733),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_DOT] = ACTIONS(5733),
    [anon_sym_DOT_STAR] = ACTIONS(5730),
    [anon_sym_DASH_GT] = ACTIONS(5730),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5733),
    [anon_sym_decltype] = ACTIONS(5733),
  },
  [2696] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5423),
    [anon_sym_COMMA] = ACTIONS(5423),
    [anon_sym_RPAREN] = ACTIONS(5423),
    [anon_sym_LPAREN2] = ACTIONS(5423),
    [anon_sym_DASH] = ACTIONS(5421),
    [anon_sym_PLUS] = ACTIONS(5421),
    [anon_sym_STAR] = ACTIONS(5421),
    [anon_sym_SLASH] = ACTIONS(5421),
    [anon_sym_PERCENT] = ACTIONS(5421),
    [anon_sym_PIPE_PIPE] = ACTIONS(5423),
    [anon_sym_AMP_AMP] = ACTIONS(5423),
    [anon_sym_PIPE] = ACTIONS(5421),
    [anon_sym_CARET] = ACTIONS(5421),
    [anon_sym_AMP] = ACTIONS(5421),
    [anon_sym_EQ_EQ] = ACTIONS(5423),
    [anon_sym_BANG_EQ] = ACTIONS(5423),
    [anon_sym_GT] = ACTIONS(5421),
    [anon_sym_GT_EQ] = ACTIONS(5423),
    [anon_sym_LT_EQ] = ACTIONS(5421),
    [anon_sym_LT] = ACTIONS(5421),
    [anon_sym_LT_LT] = ACTIONS(5421),
    [anon_sym_GT_GT] = ACTIONS(5421),
    [anon_sym_SEMI] = ACTIONS(5423),
    [anon_sym_RBRACE] = ACTIONS(5423),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_RBRACK] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(5421),
    [anon_sym_COLON] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5423),
    [anon_sym_STAR_EQ] = ACTIONS(5423),
    [anon_sym_SLASH_EQ] = ACTIONS(5423),
    [anon_sym_PERCENT_EQ] = ACTIONS(5423),
    [anon_sym_PLUS_EQ] = ACTIONS(5423),
    [anon_sym_DASH_EQ] = ACTIONS(5423),
    [anon_sym_LT_LT_EQ] = ACTIONS(5423),
    [anon_sym_GT_GT_EQ] = ACTIONS(5423),
    [anon_sym_AMP_EQ] = ACTIONS(5423),
    [anon_sym_CARET_EQ] = ACTIONS(5423),
    [anon_sym_PIPE_EQ] = ACTIONS(5423),
    [anon_sym_and_eq] = ACTIONS(5421),
    [anon_sym_or_eq] = ACTIONS(5421),
    [anon_sym_xor_eq] = ACTIONS(5421),
    [anon_sym_LT_EQ_GT] = ACTIONS(5423),
    [anon_sym_or] = ACTIONS(5421),
    [anon_sym_and] = ACTIONS(5421),
    [anon_sym_bitor] = ACTIONS(5421),
    [anon_sym_xor] = ACTIONS(5421),
    [anon_sym_bitand] = ACTIONS(5421),
    [anon_sym_not_eq] = ACTIONS(5421),
    [anon_sym_DASH_DASH] = ACTIONS(5423),
    [anon_sym_PLUS_PLUS] = ACTIONS(5423),
    [anon_sym_DOT] = ACTIONS(5421),
    [anon_sym_DOT_STAR] = ACTIONS(5423),
    [anon_sym_DASH_GT] = ACTIONS(5423),
    [anon_sym_L_DQUOTE] = ACTIONS(5423),
    [anon_sym_u_DQUOTE] = ACTIONS(5423),
    [anon_sym_U_DQUOTE] = ACTIONS(5423),
    [anon_sym_u8_DQUOTE] = ACTIONS(5423),
    [anon_sym_DQUOTE] = ACTIONS(5423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5423),
    [anon_sym_LR_DQUOTE] = ACTIONS(5423),
    [anon_sym_uR_DQUOTE] = ACTIONS(5423),
    [anon_sym_UR_DQUOTE] = ACTIONS(5423),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5423),
    [sym_literal_suffix] = ACTIONS(5421),
  },
  [2697] = {
    [sym_identifier] = ACTIONS(2223),
    [anon_sym_LPAREN2] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2221),
    [anon_sym_PIPE_PIPE] = ACTIONS(2221),
    [anon_sym_AMP_AMP] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym___extension__] = ACTIONS(2223),
    [anon_sym_extern] = ACTIONS(2223),
    [anon_sym___attribute__] = ACTIONS(2223),
    [anon_sym_COLON_COLON] = ACTIONS(2221),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym___declspec] = ACTIONS(2223),
    [anon_sym___based] = ACTIONS(2223),
    [anon_sym___cdecl] = ACTIONS(2223),
    [anon_sym___clrcall] = ACTIONS(2223),
    [anon_sym___stdcall] = ACTIONS(2223),
    [anon_sym___fastcall] = ACTIONS(2223),
    [anon_sym___thiscall] = ACTIONS(2223),
    [anon_sym___vectorcall] = ACTIONS(2223),
    [anon_sym_signed] = ACTIONS(2223),
    [anon_sym_unsigned] = ACTIONS(2223),
    [anon_sym_long] = ACTIONS(2223),
    [anon_sym_short] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(2223),
    [anon_sym_static] = ACTIONS(2223),
    [anon_sym_register] = ACTIONS(2223),
    [anon_sym_inline] = ACTIONS(2223),
    [anon_sym___inline] = ACTIONS(2223),
    [anon_sym___inline__] = ACTIONS(2223),
    [anon_sym___forceinline] = ACTIONS(2223),
    [anon_sym_thread_local] = ACTIONS(2223),
    [anon_sym___thread] = ACTIONS(2223),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_constexpr] = ACTIONS(2223),
    [anon_sym_volatile] = ACTIONS(2223),
    [anon_sym_restrict] = ACTIONS(2223),
    [anon_sym___restrict__] = ACTIONS(2223),
    [anon_sym__Atomic] = ACTIONS(2223),
    [anon_sym__Noreturn] = ACTIONS(2223),
    [anon_sym_noreturn] = ACTIONS(2223),
    [anon_sym_mutable] = ACTIONS(2223),
    [anon_sym_constinit] = ACTIONS(2223),
    [anon_sym_consteval] = ACTIONS(2223),
    [anon_sym_PROGMEM] = ACTIONS(2223),
    [aux_sym_primitive_type_token1] = ACTIONS(2223),
    [anon_sym_byte] = ACTIONS(2223),
    [anon_sym_word] = ACTIONS(2223),
    [anon_sym_enum] = ACTIONS(2223),
    [anon_sym_class] = ACTIONS(2223),
    [anon_sym_struct] = ACTIONS(2223),
    [anon_sym_union] = ACTIONS(2223),
    [anon_sym_or] = ACTIONS(2223),
    [anon_sym_and] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2223),
    [anon_sym_decltype] = ACTIONS(2223),
    [anon_sym_virtual] = ACTIONS(2223),
    [anon_sym_alignas] = ACTIONS(2223),
    [anon_sym_explicit] = ACTIONS(2223),
    [anon_sym_typename] = ACTIONS(2223),
    [anon_sym_template] = ACTIONS(2223),
    [anon_sym_operator] = ACTIONS(2223),
    [anon_sym_friend] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_concept] = ACTIONS(2223),
  },
  [2698] = {
    [sym_identifier] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_PIPE_PIPE] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym___cdecl] = ACTIONS(2267),
    [anon_sym___clrcall] = ACTIONS(2267),
    [anon_sym___stdcall] = ACTIONS(2267),
    [anon_sym___fastcall] = ACTIONS(2267),
    [anon_sym___thiscall] = ACTIONS(2267),
    [anon_sym___vectorcall] = ACTIONS(2267),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym_PROGMEM] = ACTIONS(2267),
    [aux_sym_primitive_type_token1] = ACTIONS(2267),
    [anon_sym_byte] = ACTIONS(2267),
    [anon_sym_word] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [anon_sym_or] = ACTIONS(2267),
    [anon_sym_and] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [anon_sym_virtual] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_friend] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_concept] = ACTIONS(2267),
  },
  [2699] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2699),
    [sym_identifier] = ACTIONS(5363),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5365),
    [anon_sym_COMMA] = ACTIONS(5365),
    [aux_sym_preproc_if_token2] = ACTIONS(5365),
    [aux_sym_preproc_else_token1] = ACTIONS(5365),
    [aux_sym_preproc_elif_token1] = ACTIONS(5365),
    [anon_sym_LPAREN2] = ACTIONS(5365),
    [anon_sym_DASH] = ACTIONS(5363),
    [anon_sym_PLUS] = ACTIONS(5363),
    [anon_sym_STAR] = ACTIONS(5363),
    [anon_sym_SLASH] = ACTIONS(5363),
    [anon_sym_PERCENT] = ACTIONS(5363),
    [anon_sym_PIPE_PIPE] = ACTIONS(5365),
    [anon_sym_AMP_AMP] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5363),
    [anon_sym_CARET] = ACTIONS(5363),
    [anon_sym_AMP] = ACTIONS(5363),
    [anon_sym_EQ_EQ] = ACTIONS(5365),
    [anon_sym_BANG_EQ] = ACTIONS(5365),
    [anon_sym_GT] = ACTIONS(5363),
    [anon_sym_GT_EQ] = ACTIONS(5365),
    [anon_sym_LT_EQ] = ACTIONS(5363),
    [anon_sym_LT] = ACTIONS(5363),
    [anon_sym_LT_LT] = ACTIONS(5363),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym___attribute__] = ACTIONS(5363),
    [anon_sym_LBRACE] = ACTIONS(5365),
    [anon_sym_signed] = ACTIONS(6079),
    [anon_sym_unsigned] = ACTIONS(6079),
    [anon_sym_long] = ACTIONS(6079),
    [anon_sym_short] = ACTIONS(6079),
    [anon_sym_LBRACK] = ACTIONS(5365),
    [anon_sym_EQ] = ACTIONS(5363),
    [aux_sym_primitive_type_token1] = ACTIONS(5363),
    [anon_sym_byte] = ACTIONS(5363),
    [anon_sym_word] = ACTIONS(5363),
    [anon_sym_QMARK] = ACTIONS(5365),
    [anon_sym_STAR_EQ] = ACTIONS(5365),
    [anon_sym_SLASH_EQ] = ACTIONS(5365),
    [anon_sym_PERCENT_EQ] = ACTIONS(5365),
    [anon_sym_PLUS_EQ] = ACTIONS(5365),
    [anon_sym_DASH_EQ] = ACTIONS(5365),
    [anon_sym_LT_LT_EQ] = ACTIONS(5365),
    [anon_sym_GT_GT_EQ] = ACTIONS(5365),
    [anon_sym_AMP_EQ] = ACTIONS(5365),
    [anon_sym_CARET_EQ] = ACTIONS(5365),
    [anon_sym_PIPE_EQ] = ACTIONS(5365),
    [anon_sym_and_eq] = ACTIONS(5363),
    [anon_sym_or_eq] = ACTIONS(5363),
    [anon_sym_xor_eq] = ACTIONS(5363),
    [anon_sym_LT_EQ_GT] = ACTIONS(5365),
    [anon_sym_or] = ACTIONS(5363),
    [anon_sym_and] = ACTIONS(5363),
    [anon_sym_bitor] = ACTIONS(5363),
    [anon_sym_xor] = ACTIONS(5363),
    [anon_sym_bitand] = ACTIONS(5363),
    [anon_sym_not_eq] = ACTIONS(5363),
    [anon_sym_DASH_DASH] = ACTIONS(5365),
    [anon_sym_PLUS_PLUS] = ACTIONS(5365),
    [anon_sym_DOT] = ACTIONS(5363),
    [anon_sym_DOT_STAR] = ACTIONS(5365),
    [anon_sym_DASH_GT] = ACTIONS(5365),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5363),
    [anon_sym_decltype] = ACTIONS(5363),
  },
  [2700] = {
    [sym_attribute_specifier] = STATE(2799),
    [sym_identifier] = ACTIONS(6082),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6084),
    [anon_sym_COMMA] = ACTIONS(6084),
    [anon_sym_RPAREN] = ACTIONS(6084),
    [aux_sym_preproc_if_token2] = ACTIONS(6084),
    [aux_sym_preproc_else_token1] = ACTIONS(6084),
    [aux_sym_preproc_elif_token1] = ACTIONS(6082),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6084),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6084),
    [anon_sym_LPAREN2] = ACTIONS(6084),
    [anon_sym_DASH] = ACTIONS(6082),
    [anon_sym_PLUS] = ACTIONS(6082),
    [anon_sym_STAR] = ACTIONS(6082),
    [anon_sym_SLASH] = ACTIONS(6082),
    [anon_sym_PERCENT] = ACTIONS(6082),
    [anon_sym_PIPE_PIPE] = ACTIONS(6084),
    [anon_sym_AMP_AMP] = ACTIONS(6084),
    [anon_sym_PIPE] = ACTIONS(6082),
    [anon_sym_CARET] = ACTIONS(6082),
    [anon_sym_AMP] = ACTIONS(6082),
    [anon_sym_EQ_EQ] = ACTIONS(6084),
    [anon_sym_BANG_EQ] = ACTIONS(6084),
    [anon_sym_GT] = ACTIONS(6082),
    [anon_sym_GT_EQ] = ACTIONS(6084),
    [anon_sym_LT_EQ] = ACTIONS(6082),
    [anon_sym_LT] = ACTIONS(6082),
    [anon_sym_LT_LT] = ACTIONS(6082),
    [anon_sym_GT_GT] = ACTIONS(6082),
    [anon_sym_SEMI] = ACTIONS(6084),
    [anon_sym___attribute__] = ACTIONS(5473),
    [anon_sym_LBRACE] = ACTIONS(6084),
    [anon_sym_RBRACE] = ACTIONS(6084),
    [anon_sym_LBRACK] = ACTIONS(6084),
    [anon_sym_RBRACK] = ACTIONS(6084),
    [anon_sym_EQ] = ACTIONS(6082),
    [anon_sym_COLON] = ACTIONS(6084),
    [anon_sym_QMARK] = ACTIONS(6084),
    [anon_sym_STAR_EQ] = ACTIONS(6084),
    [anon_sym_SLASH_EQ] = ACTIONS(6084),
    [anon_sym_PERCENT_EQ] = ACTIONS(6084),
    [anon_sym_PLUS_EQ] = ACTIONS(6084),
    [anon_sym_DASH_EQ] = ACTIONS(6084),
    [anon_sym_LT_LT_EQ] = ACTIONS(6084),
    [anon_sym_GT_GT_EQ] = ACTIONS(6084),
    [anon_sym_AMP_EQ] = ACTIONS(6084),
    [anon_sym_CARET_EQ] = ACTIONS(6084),
    [anon_sym_PIPE_EQ] = ACTIONS(6084),
    [anon_sym_and_eq] = ACTIONS(6082),
    [anon_sym_or_eq] = ACTIONS(6082),
    [anon_sym_xor_eq] = ACTIONS(6082),
    [anon_sym_LT_EQ_GT] = ACTIONS(6084),
    [anon_sym_or] = ACTIONS(6082),
    [anon_sym_and] = ACTIONS(6082),
    [anon_sym_bitor] = ACTIONS(6082),
    [anon_sym_xor] = ACTIONS(6082),
    [anon_sym_bitand] = ACTIONS(6082),
    [anon_sym_not_eq] = ACTIONS(6082),
    [anon_sym_DASH_DASH] = ACTIONS(6084),
    [anon_sym_PLUS_PLUS] = ACTIONS(6084),
    [anon_sym_DOT] = ACTIONS(6082),
    [anon_sym_DOT_STAR] = ACTIONS(6084),
    [anon_sym_DASH_GT] = ACTIONS(6084),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6082),
    [anon_sym_decltype] = ACTIONS(6082),
  },
  [2701] = {
    [sym_string_literal] = STATE(3057),
    [sym_template_argument_list] = STATE(4471),
    [sym_raw_string_literal] = STATE(3057),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5870),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(6086),
    [anon_sym_COLON] = ACTIONS(4256),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(6088),
    [anon_sym_SLASH_EQ] = ACTIONS(6088),
    [anon_sym_PERCENT_EQ] = ACTIONS(6088),
    [anon_sym_PLUS_EQ] = ACTIONS(6088),
    [anon_sym_DASH_EQ] = ACTIONS(6088),
    [anon_sym_LT_LT_EQ] = ACTIONS(6088),
    [anon_sym_GT_GT_EQ] = ACTIONS(6088),
    [anon_sym_AMP_EQ] = ACTIONS(6088),
    [anon_sym_CARET_EQ] = ACTIONS(6088),
    [anon_sym_PIPE_EQ] = ACTIONS(6088),
    [anon_sym_and_eq] = ACTIONS(6088),
    [anon_sym_or_eq] = ACTIONS(6088),
    [anon_sym_xor_eq] = ACTIONS(6088),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(3551),
    [anon_sym_u_DQUOTE] = ACTIONS(3551),
    [anon_sym_U_DQUOTE] = ACTIONS(3551),
    [anon_sym_u8_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3555),
    [anon_sym_LR_DQUOTE] = ACTIONS(3555),
    [anon_sym_uR_DQUOTE] = ACTIONS(3555),
    [anon_sym_UR_DQUOTE] = ACTIONS(3555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3555),
  },
  [2702] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2063),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6090),
    [anon_sym_COMMA] = ACTIONS(6090),
    [anon_sym_RPAREN] = ACTIONS(6090),
    [anon_sym_LPAREN2] = ACTIONS(6090),
    [anon_sym_DASH] = ACTIONS(6092),
    [anon_sym_PLUS] = ACTIONS(6092),
    [anon_sym_STAR] = ACTIONS(6090),
    [anon_sym_SLASH] = ACTIONS(6092),
    [anon_sym_PERCENT] = ACTIONS(6090),
    [anon_sym_PIPE_PIPE] = ACTIONS(6090),
    [anon_sym_AMP_AMP] = ACTIONS(6090),
    [anon_sym_PIPE] = ACTIONS(6092),
    [anon_sym_CARET] = ACTIONS(6090),
    [anon_sym_AMP] = ACTIONS(6092),
    [anon_sym_EQ_EQ] = ACTIONS(6090),
    [anon_sym_BANG_EQ] = ACTIONS(6090),
    [anon_sym_GT] = ACTIONS(6092),
    [anon_sym_GT_EQ] = ACTIONS(6090),
    [anon_sym_LT_EQ] = ACTIONS(6092),
    [anon_sym_LT] = ACTIONS(6092),
    [anon_sym_LT_LT] = ACTIONS(6090),
    [anon_sym_GT_GT] = ACTIONS(6090),
    [anon_sym_SEMI] = ACTIONS(6090),
    [anon_sym___extension__] = ACTIONS(6090),
    [anon_sym___attribute__] = ACTIONS(6090),
    [anon_sym_LBRACE] = ACTIONS(6090),
    [anon_sym_RBRACE] = ACTIONS(6090),
    [anon_sym_signed] = ACTIONS(6022),
    [anon_sym_unsigned] = ACTIONS(6022),
    [anon_sym_long] = ACTIONS(6022),
    [anon_sym_short] = ACTIONS(6022),
    [anon_sym_LBRACK] = ACTIONS(6090),
    [anon_sym_RBRACK] = ACTIONS(6090),
    [anon_sym_const] = ACTIONS(6092),
    [anon_sym_constexpr] = ACTIONS(6090),
    [anon_sym_volatile] = ACTIONS(6090),
    [anon_sym_restrict] = ACTIONS(6090),
    [anon_sym___restrict__] = ACTIONS(6090),
    [anon_sym__Atomic] = ACTIONS(6090),
    [anon_sym__Noreturn] = ACTIONS(6090),
    [anon_sym_noreturn] = ACTIONS(6090),
    [anon_sym_mutable] = ACTIONS(6090),
    [anon_sym_constinit] = ACTIONS(6090),
    [anon_sym_consteval] = ACTIONS(6090),
    [anon_sym_PROGMEM] = ACTIONS(6090),
    [anon_sym_COLON] = ACTIONS(6090),
    [anon_sym_QMARK] = ACTIONS(6090),
    [anon_sym_LT_EQ_GT] = ACTIONS(6090),
    [anon_sym_or] = ACTIONS(6090),
    [anon_sym_and] = ACTIONS(6090),
    [anon_sym_bitor] = ACTIONS(6090),
    [anon_sym_xor] = ACTIONS(6090),
    [anon_sym_bitand] = ACTIONS(6090),
    [anon_sym_not_eq] = ACTIONS(6090),
    [anon_sym_DASH_DASH] = ACTIONS(6090),
    [anon_sym_PLUS_PLUS] = ACTIONS(6090),
    [anon_sym_DOT] = ACTIONS(6092),
    [anon_sym_DOT_STAR] = ACTIONS(6090),
    [anon_sym_DASH_GT] = ACTIONS(6090),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6090),
    [anon_sym_decltype] = ACTIONS(6090),
    [anon_sym_final] = ACTIONS(6090),
    [anon_sym_override] = ACTIONS(6090),
    [anon_sym_requires] = ACTIONS(6090),
  },
  [2703] = {
    [sym_attribute_specifier] = STATE(2775),
    [sym_identifier] = ACTIONS(6094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6096),
    [anon_sym_COMMA] = ACTIONS(6096),
    [anon_sym_RPAREN] = ACTIONS(6096),
    [aux_sym_preproc_if_token2] = ACTIONS(6096),
    [aux_sym_preproc_else_token1] = ACTIONS(6096),
    [aux_sym_preproc_elif_token1] = ACTIONS(6094),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6096),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6096),
    [anon_sym_LPAREN2] = ACTIONS(6096),
    [anon_sym_DASH] = ACTIONS(6094),
    [anon_sym_PLUS] = ACTIONS(6094),
    [anon_sym_STAR] = ACTIONS(6094),
    [anon_sym_SLASH] = ACTIONS(6094),
    [anon_sym_PERCENT] = ACTIONS(6094),
    [anon_sym_PIPE_PIPE] = ACTIONS(6096),
    [anon_sym_AMP_AMP] = ACTIONS(6096),
    [anon_sym_PIPE] = ACTIONS(6094),
    [anon_sym_CARET] = ACTIONS(6094),
    [anon_sym_AMP] = ACTIONS(6094),
    [anon_sym_EQ_EQ] = ACTIONS(6096),
    [anon_sym_BANG_EQ] = ACTIONS(6096),
    [anon_sym_GT] = ACTIONS(6094),
    [anon_sym_GT_EQ] = ACTIONS(6096),
    [anon_sym_LT_EQ] = ACTIONS(6094),
    [anon_sym_LT] = ACTIONS(6094),
    [anon_sym_LT_LT] = ACTIONS(6094),
    [anon_sym_GT_GT] = ACTIONS(6094),
    [anon_sym_SEMI] = ACTIONS(6096),
    [anon_sym___attribute__] = ACTIONS(5473),
    [anon_sym_LBRACE] = ACTIONS(6096),
    [anon_sym_RBRACE] = ACTIONS(6096),
    [anon_sym_LBRACK] = ACTIONS(6096),
    [anon_sym_RBRACK] = ACTIONS(6096),
    [anon_sym_EQ] = ACTIONS(6094),
    [anon_sym_COLON] = ACTIONS(6096),
    [anon_sym_QMARK] = ACTIONS(6096),
    [anon_sym_STAR_EQ] = ACTIONS(6096),
    [anon_sym_SLASH_EQ] = ACTIONS(6096),
    [anon_sym_PERCENT_EQ] = ACTIONS(6096),
    [anon_sym_PLUS_EQ] = ACTIONS(6096),
    [anon_sym_DASH_EQ] = ACTIONS(6096),
    [anon_sym_LT_LT_EQ] = ACTIONS(6096),
    [anon_sym_GT_GT_EQ] = ACTIONS(6096),
    [anon_sym_AMP_EQ] = ACTIONS(6096),
    [anon_sym_CARET_EQ] = ACTIONS(6096),
    [anon_sym_PIPE_EQ] = ACTIONS(6096),
    [anon_sym_and_eq] = ACTIONS(6094),
    [anon_sym_or_eq] = ACTIONS(6094),
    [anon_sym_xor_eq] = ACTIONS(6094),
    [anon_sym_LT_EQ_GT] = ACTIONS(6096),
    [anon_sym_or] = ACTIONS(6094),
    [anon_sym_and] = ACTIONS(6094),
    [anon_sym_bitor] = ACTIONS(6094),
    [anon_sym_xor] = ACTIONS(6094),
    [anon_sym_bitand] = ACTIONS(6094),
    [anon_sym_not_eq] = ACTIONS(6094),
    [anon_sym_DASH_DASH] = ACTIONS(6096),
    [anon_sym_PLUS_PLUS] = ACTIONS(6096),
    [anon_sym_DOT] = ACTIONS(6094),
    [anon_sym_DOT_STAR] = ACTIONS(6096),
    [anon_sym_DASH_GT] = ACTIONS(6096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6094),
    [anon_sym_decltype] = ACTIONS(6094),
  },
  [2704] = {
    [sym_string_literal] = STATE(2674),
    [sym_template_argument_list] = STATE(3973),
    [sym_raw_string_literal] = STATE(2674),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4256),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(6098),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4256),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4248),
    [anon_sym_SLASH_EQ] = ACTIONS(4248),
    [anon_sym_PERCENT_EQ] = ACTIONS(4248),
    [anon_sym_PLUS_EQ] = ACTIONS(4248),
    [anon_sym_DASH_EQ] = ACTIONS(4248),
    [anon_sym_LT_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT_GT_EQ] = ACTIONS(4256),
    [anon_sym_AMP_EQ] = ACTIONS(4248),
    [anon_sym_CARET_EQ] = ACTIONS(4248),
    [anon_sym_PIPE_EQ] = ACTIONS(4248),
    [anon_sym_and_eq] = ACTIONS(4248),
    [anon_sym_or_eq] = ACTIONS(4248),
    [anon_sym_xor_eq] = ACTIONS(4248),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(6041),
    [anon_sym_u_DQUOTE] = ACTIONS(6041),
    [anon_sym_U_DQUOTE] = ACTIONS(6041),
    [anon_sym_u8_DQUOTE] = ACTIONS(6041),
    [anon_sym_DQUOTE] = ACTIONS(6041),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(4248),
    [anon_sym_R_DQUOTE] = ACTIONS(6043),
    [anon_sym_LR_DQUOTE] = ACTIONS(6043),
    [anon_sym_uR_DQUOTE] = ACTIONS(6043),
    [anon_sym_UR_DQUOTE] = ACTIONS(6043),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6043),
  },
  [2705] = {
    [sym_identifier] = ACTIONS(5626),
    [anon_sym_LPAREN2] = ACTIONS(5628),
    [anon_sym_TILDE] = ACTIONS(5628),
    [anon_sym_STAR] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE] = ACTIONS(5628),
    [anon_sym_AMP_AMP] = ACTIONS(5628),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym___extension__] = ACTIONS(5626),
    [anon_sym_extern] = ACTIONS(5626),
    [anon_sym___attribute__] = ACTIONS(5626),
    [anon_sym_COLON_COLON] = ACTIONS(5628),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5628),
    [anon_sym___declspec] = ACTIONS(5626),
    [anon_sym___based] = ACTIONS(5626),
    [anon_sym___cdecl] = ACTIONS(5626),
    [anon_sym___clrcall] = ACTIONS(5626),
    [anon_sym___stdcall] = ACTIONS(5626),
    [anon_sym___fastcall] = ACTIONS(5626),
    [anon_sym___thiscall] = ACTIONS(5626),
    [anon_sym___vectorcall] = ACTIONS(5626),
    [anon_sym_signed] = ACTIONS(5626),
    [anon_sym_unsigned] = ACTIONS(5626),
    [anon_sym_long] = ACTIONS(5626),
    [anon_sym_short] = ACTIONS(5626),
    [anon_sym_LBRACK] = ACTIONS(5626),
    [anon_sym_static] = ACTIONS(5626),
    [anon_sym_register] = ACTIONS(5626),
    [anon_sym_inline] = ACTIONS(5626),
    [anon_sym___inline] = ACTIONS(5626),
    [anon_sym___inline__] = ACTIONS(5626),
    [anon_sym___forceinline] = ACTIONS(5626),
    [anon_sym_thread_local] = ACTIONS(5626),
    [anon_sym___thread] = ACTIONS(5626),
    [anon_sym_const] = ACTIONS(5626),
    [anon_sym_constexpr] = ACTIONS(5626),
    [anon_sym_volatile] = ACTIONS(5626),
    [anon_sym_restrict] = ACTIONS(5626),
    [anon_sym___restrict__] = ACTIONS(5626),
    [anon_sym__Atomic] = ACTIONS(5626),
    [anon_sym__Noreturn] = ACTIONS(5626),
    [anon_sym_noreturn] = ACTIONS(5626),
    [anon_sym_mutable] = ACTIONS(5626),
    [anon_sym_constinit] = ACTIONS(5626),
    [anon_sym_consteval] = ACTIONS(5626),
    [anon_sym_PROGMEM] = ACTIONS(5626),
    [aux_sym_primitive_type_token1] = ACTIONS(5626),
    [anon_sym_byte] = ACTIONS(5626),
    [anon_sym_word] = ACTIONS(5626),
    [anon_sym_enum] = ACTIONS(5626),
    [anon_sym_class] = ACTIONS(5626),
    [anon_sym_struct] = ACTIONS(5626),
    [anon_sym_union] = ACTIONS(5626),
    [anon_sym_or] = ACTIONS(5626),
    [anon_sym_and] = ACTIONS(5626),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5626),
    [anon_sym_decltype] = ACTIONS(5626),
    [anon_sym_virtual] = ACTIONS(5626),
    [anon_sym_alignas] = ACTIONS(5626),
    [anon_sym_explicit] = ACTIONS(5626),
    [anon_sym_typename] = ACTIONS(5626),
    [anon_sym_template] = ACTIONS(5626),
    [anon_sym_operator] = ACTIONS(5626),
    [anon_sym_friend] = ACTIONS(5626),
    [anon_sym_using] = ACTIONS(5626),
    [anon_sym_concept] = ACTIONS(5626),
  },
  [2706] = {
    [sym_string_literal] = STATE(2712),
    [sym_raw_string_literal] = STATE(2712),
    [aux_sym_concatenated_string_repeat1] = STATE(2712),
    [sym_identifier] = ACTIONS(6101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5393),
    [anon_sym_COMMA] = ACTIONS(5393),
    [anon_sym_LPAREN2] = ACTIONS(5393),
    [anon_sym_DASH] = ACTIONS(5395),
    [anon_sym_PLUS] = ACTIONS(5395),
    [anon_sym_STAR] = ACTIONS(5395),
    [anon_sym_SLASH] = ACTIONS(5395),
    [anon_sym_PERCENT] = ACTIONS(5395),
    [anon_sym_PIPE_PIPE] = ACTIONS(5393),
    [anon_sym_AMP_AMP] = ACTIONS(5393),
    [anon_sym_PIPE] = ACTIONS(5395),
    [anon_sym_CARET] = ACTIONS(5395),
    [anon_sym_AMP] = ACTIONS(5395),
    [anon_sym_EQ_EQ] = ACTIONS(5393),
    [anon_sym_BANG_EQ] = ACTIONS(5393),
    [anon_sym_GT] = ACTIONS(5395),
    [anon_sym_GT_EQ] = ACTIONS(5395),
    [anon_sym_LT_EQ] = ACTIONS(5395),
    [anon_sym_LT] = ACTIONS(5395),
    [anon_sym_LT_LT] = ACTIONS(5395),
    [anon_sym_GT_GT] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(5393),
    [anon_sym_EQ] = ACTIONS(5395),
    [anon_sym_QMARK] = ACTIONS(5393),
    [anon_sym_STAR_EQ] = ACTIONS(5393),
    [anon_sym_SLASH_EQ] = ACTIONS(5393),
    [anon_sym_PERCENT_EQ] = ACTIONS(5393),
    [anon_sym_PLUS_EQ] = ACTIONS(5393),
    [anon_sym_DASH_EQ] = ACTIONS(5393),
    [anon_sym_LT_LT_EQ] = ACTIONS(5393),
    [anon_sym_GT_GT_EQ] = ACTIONS(5395),
    [anon_sym_AMP_EQ] = ACTIONS(5393),
    [anon_sym_CARET_EQ] = ACTIONS(5393),
    [anon_sym_PIPE_EQ] = ACTIONS(5393),
    [anon_sym_and_eq] = ACTIONS(5395),
    [anon_sym_or_eq] = ACTIONS(5395),
    [anon_sym_xor_eq] = ACTIONS(5395),
    [anon_sym_LT_EQ_GT] = ACTIONS(5393),
    [anon_sym_or] = ACTIONS(5395),
    [anon_sym_and] = ACTIONS(5395),
    [anon_sym_bitor] = ACTIONS(5395),
    [anon_sym_xor] = ACTIONS(5395),
    [anon_sym_bitand] = ACTIONS(5395),
    [anon_sym_not_eq] = ACTIONS(5395),
    [anon_sym_DASH_DASH] = ACTIONS(5393),
    [anon_sym_PLUS_PLUS] = ACTIONS(5393),
    [anon_sym_DOT] = ACTIONS(5395),
    [anon_sym_DOT_STAR] = ACTIONS(5393),
    [anon_sym_DASH_GT] = ACTIONS(5393),
    [anon_sym_L_DQUOTE] = ACTIONS(6041),
    [anon_sym_u_DQUOTE] = ACTIONS(6041),
    [anon_sym_U_DQUOTE] = ACTIONS(6041),
    [anon_sym_u8_DQUOTE] = ACTIONS(6041),
    [anon_sym_DQUOTE] = ACTIONS(6041),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(5393),
    [anon_sym_R_DQUOTE] = ACTIONS(6043),
    [anon_sym_LR_DQUOTE] = ACTIONS(6043),
    [anon_sym_uR_DQUOTE] = ACTIONS(6043),
    [anon_sym_UR_DQUOTE] = ACTIONS(6043),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6043),
    [sym_literal_suffix] = ACTIONS(5395),
  },
  [2707] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2063),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6103),
    [anon_sym_COMMA] = ACTIONS(6103),
    [anon_sym_RPAREN] = ACTIONS(6103),
    [anon_sym_LPAREN2] = ACTIONS(6103),
    [anon_sym_DASH] = ACTIONS(6105),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_STAR] = ACTIONS(6103),
    [anon_sym_SLASH] = ACTIONS(6105),
    [anon_sym_PERCENT] = ACTIONS(6103),
    [anon_sym_PIPE_PIPE] = ACTIONS(6103),
    [anon_sym_AMP_AMP] = ACTIONS(6103),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_CARET] = ACTIONS(6103),
    [anon_sym_AMP] = ACTIONS(6105),
    [anon_sym_EQ_EQ] = ACTIONS(6103),
    [anon_sym_BANG_EQ] = ACTIONS(6103),
    [anon_sym_GT] = ACTIONS(6105),
    [anon_sym_GT_EQ] = ACTIONS(6103),
    [anon_sym_LT_EQ] = ACTIONS(6105),
    [anon_sym_LT] = ACTIONS(6105),
    [anon_sym_LT_LT] = ACTIONS(6103),
    [anon_sym_GT_GT] = ACTIONS(6103),
    [anon_sym_SEMI] = ACTIONS(6103),
    [anon_sym___extension__] = ACTIONS(6103),
    [anon_sym___attribute__] = ACTIONS(6103),
    [anon_sym_LBRACE] = ACTIONS(6103),
    [anon_sym_RBRACE] = ACTIONS(6103),
    [anon_sym_signed] = ACTIONS(6022),
    [anon_sym_unsigned] = ACTIONS(6022),
    [anon_sym_long] = ACTIONS(6022),
    [anon_sym_short] = ACTIONS(6022),
    [anon_sym_LBRACK] = ACTIONS(6103),
    [anon_sym_RBRACK] = ACTIONS(6103),
    [anon_sym_const] = ACTIONS(6105),
    [anon_sym_constexpr] = ACTIONS(6103),
    [anon_sym_volatile] = ACTIONS(6103),
    [anon_sym_restrict] = ACTIONS(6103),
    [anon_sym___restrict__] = ACTIONS(6103),
    [anon_sym__Atomic] = ACTIONS(6103),
    [anon_sym__Noreturn] = ACTIONS(6103),
    [anon_sym_noreturn] = ACTIONS(6103),
    [anon_sym_mutable] = ACTIONS(6103),
    [anon_sym_constinit] = ACTIONS(6103),
    [anon_sym_consteval] = ACTIONS(6103),
    [anon_sym_PROGMEM] = ACTIONS(6103),
    [anon_sym_COLON] = ACTIONS(6103),
    [anon_sym_QMARK] = ACTIONS(6103),
    [anon_sym_LT_EQ_GT] = ACTIONS(6103),
    [anon_sym_or] = ACTIONS(6103),
    [anon_sym_and] = ACTIONS(6103),
    [anon_sym_bitor] = ACTIONS(6103),
    [anon_sym_xor] = ACTIONS(6103),
    [anon_sym_bitand] = ACTIONS(6103),
    [anon_sym_not_eq] = ACTIONS(6103),
    [anon_sym_DASH_DASH] = ACTIONS(6103),
    [anon_sym_PLUS_PLUS] = ACTIONS(6103),
    [anon_sym_DOT] = ACTIONS(6105),
    [anon_sym_DOT_STAR] = ACTIONS(6103),
    [anon_sym_DASH_GT] = ACTIONS(6103),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6103),
    [anon_sym_decltype] = ACTIONS(6103),
    [anon_sym_final] = ACTIONS(6103),
    [anon_sym_override] = ACTIONS(6103),
    [anon_sym_requires] = ACTIONS(6103),
  },
  [2708] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6107),
    [anon_sym_COMMA] = ACTIONS(6107),
    [anon_sym_RPAREN] = ACTIONS(6107),
    [anon_sym_LPAREN2] = ACTIONS(6107),
    [anon_sym_DASH] = ACTIONS(6109),
    [anon_sym_PLUS] = ACTIONS(6109),
    [anon_sym_STAR] = ACTIONS(6107),
    [anon_sym_SLASH] = ACTIONS(6109),
    [anon_sym_PERCENT] = ACTIONS(6107),
    [anon_sym_PIPE_PIPE] = ACTIONS(6107),
    [anon_sym_AMP_AMP] = ACTIONS(6107),
    [anon_sym_PIPE] = ACTIONS(6109),
    [anon_sym_CARET] = ACTIONS(6107),
    [anon_sym_AMP] = ACTIONS(6109),
    [anon_sym_EQ_EQ] = ACTIONS(6107),
    [anon_sym_BANG_EQ] = ACTIONS(6107),
    [anon_sym_GT] = ACTIONS(6109),
    [anon_sym_GT_EQ] = ACTIONS(6107),
    [anon_sym_LT_EQ] = ACTIONS(6109),
    [anon_sym_LT] = ACTIONS(6109),
    [anon_sym_LT_LT] = ACTIONS(6107),
    [anon_sym_GT_GT] = ACTIONS(6107),
    [anon_sym_SEMI] = ACTIONS(6107),
    [anon_sym___extension__] = ACTIONS(6107),
    [anon_sym___attribute__] = ACTIONS(6107),
    [anon_sym_LBRACE] = ACTIONS(6107),
    [anon_sym_RBRACE] = ACTIONS(6107),
    [anon_sym_signed] = ACTIONS(6111),
    [anon_sym_unsigned] = ACTIONS(6111),
    [anon_sym_long] = ACTIONS(6111),
    [anon_sym_short] = ACTIONS(6111),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_RBRACK] = ACTIONS(6107),
    [anon_sym_const] = ACTIONS(6109),
    [anon_sym_constexpr] = ACTIONS(6107),
    [anon_sym_volatile] = ACTIONS(6107),
    [anon_sym_restrict] = ACTIONS(6107),
    [anon_sym___restrict__] = ACTIONS(6107),
    [anon_sym__Atomic] = ACTIONS(6107),
    [anon_sym__Noreturn] = ACTIONS(6107),
    [anon_sym_noreturn] = ACTIONS(6107),
    [anon_sym_mutable] = ACTIONS(6107),
    [anon_sym_constinit] = ACTIONS(6107),
    [anon_sym_consteval] = ACTIONS(6107),
    [anon_sym_PROGMEM] = ACTIONS(6107),
    [anon_sym_COLON] = ACTIONS(6107),
    [anon_sym_QMARK] = ACTIONS(6107),
    [anon_sym_LT_EQ_GT] = ACTIONS(6107),
    [anon_sym_or] = ACTIONS(6107),
    [anon_sym_and] = ACTIONS(6107),
    [anon_sym_bitor] = ACTIONS(6107),
    [anon_sym_xor] = ACTIONS(6107),
    [anon_sym_bitand] = ACTIONS(6107),
    [anon_sym_not_eq] = ACTIONS(6107),
    [anon_sym_DASH_DASH] = ACTIONS(6107),
    [anon_sym_PLUS_PLUS] = ACTIONS(6107),
    [anon_sym_DOT] = ACTIONS(6109),
    [anon_sym_DOT_STAR] = ACTIONS(6107),
    [anon_sym_DASH_GT] = ACTIONS(6107),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6107),
    [anon_sym_decltype] = ACTIONS(6107),
    [anon_sym_final] = ACTIONS(6107),
    [anon_sym_override] = ACTIONS(6107),
    [anon_sym_requires] = ACTIONS(6107),
  },
  [2709] = {
    [sym_attribute_specifier] = STATE(2772),
    [sym_identifier] = ACTIONS(6113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6115),
    [anon_sym_COMMA] = ACTIONS(6115),
    [anon_sym_RPAREN] = ACTIONS(6115),
    [aux_sym_preproc_if_token2] = ACTIONS(6115),
    [aux_sym_preproc_else_token1] = ACTIONS(6115),
    [aux_sym_preproc_elif_token1] = ACTIONS(6113),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6115),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6115),
    [anon_sym_LPAREN2] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6113),
    [anon_sym_PLUS] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6113),
    [anon_sym_SLASH] = ACTIONS(6113),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_PIPE_PIPE] = ACTIONS(6115),
    [anon_sym_AMP_AMP] = ACTIONS(6115),
    [anon_sym_PIPE] = ACTIONS(6113),
    [anon_sym_CARET] = ACTIONS(6113),
    [anon_sym_AMP] = ACTIONS(6113),
    [anon_sym_EQ_EQ] = ACTIONS(6115),
    [anon_sym_BANG_EQ] = ACTIONS(6115),
    [anon_sym_GT] = ACTIONS(6113),
    [anon_sym_GT_EQ] = ACTIONS(6115),
    [anon_sym_LT_EQ] = ACTIONS(6113),
    [anon_sym_LT] = ACTIONS(6113),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_GT_GT] = ACTIONS(6113),
    [anon_sym_SEMI] = ACTIONS(6115),
    [anon_sym___attribute__] = ACTIONS(5473),
    [anon_sym_LBRACE] = ACTIONS(6115),
    [anon_sym_RBRACE] = ACTIONS(6115),
    [anon_sym_LBRACK] = ACTIONS(6115),
    [anon_sym_RBRACK] = ACTIONS(6115),
    [anon_sym_EQ] = ACTIONS(6113),
    [anon_sym_COLON] = ACTIONS(6115),
    [anon_sym_QMARK] = ACTIONS(6115),
    [anon_sym_STAR_EQ] = ACTIONS(6115),
    [anon_sym_SLASH_EQ] = ACTIONS(6115),
    [anon_sym_PERCENT_EQ] = ACTIONS(6115),
    [anon_sym_PLUS_EQ] = ACTIONS(6115),
    [anon_sym_DASH_EQ] = ACTIONS(6115),
    [anon_sym_LT_LT_EQ] = ACTIONS(6115),
    [anon_sym_GT_GT_EQ] = ACTIONS(6115),
    [anon_sym_AMP_EQ] = ACTIONS(6115),
    [anon_sym_CARET_EQ] = ACTIONS(6115),
    [anon_sym_PIPE_EQ] = ACTIONS(6115),
    [anon_sym_and_eq] = ACTIONS(6113),
    [anon_sym_or_eq] = ACTIONS(6113),
    [anon_sym_xor_eq] = ACTIONS(6113),
    [anon_sym_LT_EQ_GT] = ACTIONS(6115),
    [anon_sym_or] = ACTIONS(6113),
    [anon_sym_and] = ACTIONS(6113),
    [anon_sym_bitor] = ACTIONS(6113),
    [anon_sym_xor] = ACTIONS(6113),
    [anon_sym_bitand] = ACTIONS(6113),
    [anon_sym_not_eq] = ACTIONS(6113),
    [anon_sym_DASH_DASH] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(6115),
    [anon_sym_DOT] = ACTIONS(6113),
    [anon_sym_DOT_STAR] = ACTIONS(6115),
    [anon_sym_DASH_GT] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6113),
    [anon_sym_decltype] = ACTIONS(6113),
  },
  [2710] = {
    [sym_attribute_specifier] = STATE(2755),
    [sym_identifier] = ACTIONS(6117),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6119),
    [anon_sym_COMMA] = ACTIONS(6119),
    [anon_sym_RPAREN] = ACTIONS(6119),
    [aux_sym_preproc_if_token2] = ACTIONS(6119),
    [aux_sym_preproc_else_token1] = ACTIONS(6119),
    [aux_sym_preproc_elif_token1] = ACTIONS(6117),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6119),
    [anon_sym_LPAREN2] = ACTIONS(6119),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_STAR] = ACTIONS(6117),
    [anon_sym_SLASH] = ACTIONS(6117),
    [anon_sym_PERCENT] = ACTIONS(6117),
    [anon_sym_PIPE_PIPE] = ACTIONS(6119),
    [anon_sym_AMP_AMP] = ACTIONS(6119),
    [anon_sym_PIPE] = ACTIONS(6117),
    [anon_sym_CARET] = ACTIONS(6117),
    [anon_sym_AMP] = ACTIONS(6117),
    [anon_sym_EQ_EQ] = ACTIONS(6119),
    [anon_sym_BANG_EQ] = ACTIONS(6119),
    [anon_sym_GT] = ACTIONS(6117),
    [anon_sym_GT_EQ] = ACTIONS(6119),
    [anon_sym_LT_EQ] = ACTIONS(6117),
    [anon_sym_LT] = ACTIONS(6117),
    [anon_sym_LT_LT] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6117),
    [anon_sym_SEMI] = ACTIONS(6119),
    [anon_sym___attribute__] = ACTIONS(5473),
    [anon_sym_LBRACE] = ACTIONS(6119),
    [anon_sym_RBRACE] = ACTIONS(6119),
    [anon_sym_LBRACK] = ACTIONS(6119),
    [anon_sym_RBRACK] = ACTIONS(6119),
    [anon_sym_EQ] = ACTIONS(6117),
    [anon_sym_COLON] = ACTIONS(6119),
    [anon_sym_QMARK] = ACTIONS(6119),
    [anon_sym_STAR_EQ] = ACTIONS(6119),
    [anon_sym_SLASH_EQ] = ACTIONS(6119),
    [anon_sym_PERCENT_EQ] = ACTIONS(6119),
    [anon_sym_PLUS_EQ] = ACTIONS(6119),
    [anon_sym_DASH_EQ] = ACTIONS(6119),
    [anon_sym_LT_LT_EQ] = ACTIONS(6119),
    [anon_sym_GT_GT_EQ] = ACTIONS(6119),
    [anon_sym_AMP_EQ] = ACTIONS(6119),
    [anon_sym_CARET_EQ] = ACTIONS(6119),
    [anon_sym_PIPE_EQ] = ACTIONS(6119),
    [anon_sym_and_eq] = ACTIONS(6117),
    [anon_sym_or_eq] = ACTIONS(6117),
    [anon_sym_xor_eq] = ACTIONS(6117),
    [anon_sym_LT_EQ_GT] = ACTIONS(6119),
    [anon_sym_or] = ACTIONS(6117),
    [anon_sym_and] = ACTIONS(6117),
    [anon_sym_bitor] = ACTIONS(6117),
    [anon_sym_xor] = ACTIONS(6117),
    [anon_sym_bitand] = ACTIONS(6117),
    [anon_sym_not_eq] = ACTIONS(6117),
    [anon_sym_DASH_DASH] = ACTIONS(6119),
    [anon_sym_PLUS_PLUS] = ACTIONS(6119),
    [anon_sym_DOT] = ACTIONS(6117),
    [anon_sym_DOT_STAR] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6117),
    [anon_sym_decltype] = ACTIONS(6117),
  },
  [2711] = {
    [sym_attribute_specifier] = STATE(2753),
    [sym_identifier] = ACTIONS(6121),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6123),
    [anon_sym_COMMA] = ACTIONS(6123),
    [anon_sym_RPAREN] = ACTIONS(6123),
    [aux_sym_preproc_if_token2] = ACTIONS(6123),
    [aux_sym_preproc_else_token1] = ACTIONS(6123),
    [aux_sym_preproc_elif_token1] = ACTIONS(6121),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6123),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6123),
    [anon_sym_LPAREN2] = ACTIONS(6123),
    [anon_sym_DASH] = ACTIONS(6121),
    [anon_sym_PLUS] = ACTIONS(6121),
    [anon_sym_STAR] = ACTIONS(6121),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6121),
    [anon_sym_PIPE_PIPE] = ACTIONS(6123),
    [anon_sym_AMP_AMP] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6121),
    [anon_sym_CARET] = ACTIONS(6121),
    [anon_sym_AMP] = ACTIONS(6121),
    [anon_sym_EQ_EQ] = ACTIONS(6123),
    [anon_sym_BANG_EQ] = ACTIONS(6123),
    [anon_sym_GT] = ACTIONS(6121),
    [anon_sym_GT_EQ] = ACTIONS(6123),
    [anon_sym_LT_EQ] = ACTIONS(6121),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_LT_LT] = ACTIONS(6121),
    [anon_sym_GT_GT] = ACTIONS(6121),
    [anon_sym_SEMI] = ACTIONS(6123),
    [anon_sym___attribute__] = ACTIONS(5473),
    [anon_sym_LBRACE] = ACTIONS(6123),
    [anon_sym_RBRACE] = ACTIONS(6123),
    [anon_sym_LBRACK] = ACTIONS(6123),
    [anon_sym_RBRACK] = ACTIONS(6123),
    [anon_sym_EQ] = ACTIONS(6121),
    [anon_sym_COLON] = ACTIONS(6123),
    [anon_sym_QMARK] = ACTIONS(6123),
    [anon_sym_STAR_EQ] = ACTIONS(6123),
    [anon_sym_SLASH_EQ] = ACTIONS(6123),
    [anon_sym_PERCENT_EQ] = ACTIONS(6123),
    [anon_sym_PLUS_EQ] = ACTIONS(6123),
    [anon_sym_DASH_EQ] = ACTIONS(6123),
    [anon_sym_LT_LT_EQ] = ACTIONS(6123),
    [anon_sym_GT_GT_EQ] = ACTIONS(6123),
    [anon_sym_AMP_EQ] = ACTIONS(6123),
    [anon_sym_CARET_EQ] = ACTIONS(6123),
    [anon_sym_PIPE_EQ] = ACTIONS(6123),
    [anon_sym_and_eq] = ACTIONS(6121),
    [anon_sym_or_eq] = ACTIONS(6121),
    [anon_sym_xor_eq] = ACTIONS(6121),
    [anon_sym_LT_EQ_GT] = ACTIONS(6123),
    [anon_sym_or] = ACTIONS(6121),
    [anon_sym_and] = ACTIONS(6121),
    [anon_sym_bitor] = ACTIONS(6121),
    [anon_sym_xor] = ACTIONS(6121),
    [anon_sym_bitand] = ACTIONS(6121),
    [anon_sym_not_eq] = ACTIONS(6121),
    [anon_sym_DASH_DASH] = ACTIONS(6123),
    [anon_sym_PLUS_PLUS] = ACTIONS(6123),
    [anon_sym_DOT] = ACTIONS(6121),
    [anon_sym_DOT_STAR] = ACTIONS(6123),
    [anon_sym_DASH_GT] = ACTIONS(6123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6121),
    [anon_sym_decltype] = ACTIONS(6121),
  },
  [2712] = {
    [sym_string_literal] = STATE(2712),
    [sym_raw_string_literal] = STATE(2712),
    [aux_sym_concatenated_string_repeat1] = STATE(2712),
    [sym_identifier] = ACTIONS(6125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5373),
    [anon_sym_COMMA] = ACTIONS(5373),
    [anon_sym_LPAREN2] = ACTIONS(5373),
    [anon_sym_DASH] = ACTIONS(5375),
    [anon_sym_PLUS] = ACTIONS(5375),
    [anon_sym_STAR] = ACTIONS(5375),
    [anon_sym_SLASH] = ACTIONS(5375),
    [anon_sym_PERCENT] = ACTIONS(5375),
    [anon_sym_PIPE_PIPE] = ACTIONS(5373),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_PIPE] = ACTIONS(5375),
    [anon_sym_CARET] = ACTIONS(5375),
    [anon_sym_AMP] = ACTIONS(5375),
    [anon_sym_EQ_EQ] = ACTIONS(5373),
    [anon_sym_BANG_EQ] = ACTIONS(5373),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5375),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_LT] = ACTIONS(5375),
    [anon_sym_GT_GT] = ACTIONS(5375),
    [anon_sym_LBRACK] = ACTIONS(5373),
    [anon_sym_EQ] = ACTIONS(5375),
    [anon_sym_QMARK] = ACTIONS(5373),
    [anon_sym_STAR_EQ] = ACTIONS(5373),
    [anon_sym_SLASH_EQ] = ACTIONS(5373),
    [anon_sym_PERCENT_EQ] = ACTIONS(5373),
    [anon_sym_PLUS_EQ] = ACTIONS(5373),
    [anon_sym_DASH_EQ] = ACTIONS(5373),
    [anon_sym_LT_LT_EQ] = ACTIONS(5373),
    [anon_sym_GT_GT_EQ] = ACTIONS(5375),
    [anon_sym_AMP_EQ] = ACTIONS(5373),
    [anon_sym_CARET_EQ] = ACTIONS(5373),
    [anon_sym_PIPE_EQ] = ACTIONS(5373),
    [anon_sym_and_eq] = ACTIONS(5375),
    [anon_sym_or_eq] = ACTIONS(5375),
    [anon_sym_xor_eq] = ACTIONS(5375),
    [anon_sym_LT_EQ_GT] = ACTIONS(5373),
    [anon_sym_or] = ACTIONS(5375),
    [anon_sym_and] = ACTIONS(5375),
    [anon_sym_bitor] = ACTIONS(5375),
    [anon_sym_xor] = ACTIONS(5375),
    [anon_sym_bitand] = ACTIONS(5375),
    [anon_sym_not_eq] = ACTIONS(5375),
    [anon_sym_DASH_DASH] = ACTIONS(5373),
    [anon_sym_PLUS_PLUS] = ACTIONS(5373),
    [anon_sym_DOT] = ACTIONS(5375),
    [anon_sym_DOT_STAR] = ACTIONS(5373),
    [anon_sym_DASH_GT] = ACTIONS(5373),
    [anon_sym_L_DQUOTE] = ACTIONS(6128),
    [anon_sym_u_DQUOTE] = ACTIONS(6128),
    [anon_sym_U_DQUOTE] = ACTIONS(6128),
    [anon_sym_u8_DQUOTE] = ACTIONS(6128),
    [anon_sym_DQUOTE] = ACTIONS(6128),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(5373),
    [anon_sym_R_DQUOTE] = ACTIONS(6131),
    [anon_sym_LR_DQUOTE] = ACTIONS(6131),
    [anon_sym_uR_DQUOTE] = ACTIONS(6131),
    [anon_sym_UR_DQUOTE] = ACTIONS(6131),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6131),
    [sym_literal_suffix] = ACTIONS(5375),
  },
  [2713] = {
    [sym_identifier] = ACTIONS(5146),
    [anon_sym_LPAREN2] = ACTIONS(5148),
    [anon_sym_TILDE] = ACTIONS(5148),
    [anon_sym_STAR] = ACTIONS(5148),
    [anon_sym_PIPE_PIPE] = ACTIONS(5148),
    [anon_sym_AMP_AMP] = ACTIONS(5148),
    [anon_sym_AMP] = ACTIONS(5146),
    [anon_sym___extension__] = ACTIONS(5146),
    [anon_sym_extern] = ACTIONS(5146),
    [anon_sym___attribute__] = ACTIONS(5146),
    [anon_sym_COLON_COLON] = ACTIONS(5148),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5148),
    [anon_sym___declspec] = ACTIONS(5146),
    [anon_sym___based] = ACTIONS(5146),
    [anon_sym___cdecl] = ACTIONS(5146),
    [anon_sym___clrcall] = ACTIONS(5146),
    [anon_sym___stdcall] = ACTIONS(5146),
    [anon_sym___fastcall] = ACTIONS(5146),
    [anon_sym___thiscall] = ACTIONS(5146),
    [anon_sym___vectorcall] = ACTIONS(5146),
    [anon_sym_signed] = ACTIONS(5146),
    [anon_sym_unsigned] = ACTIONS(5146),
    [anon_sym_long] = ACTIONS(5146),
    [anon_sym_short] = ACTIONS(5146),
    [anon_sym_LBRACK] = ACTIONS(5146),
    [anon_sym_static] = ACTIONS(5146),
    [anon_sym_register] = ACTIONS(5146),
    [anon_sym_inline] = ACTIONS(5146),
    [anon_sym___inline] = ACTIONS(5146),
    [anon_sym___inline__] = ACTIONS(5146),
    [anon_sym___forceinline] = ACTIONS(5146),
    [anon_sym_thread_local] = ACTIONS(5146),
    [anon_sym___thread] = ACTIONS(5146),
    [anon_sym_const] = ACTIONS(5146),
    [anon_sym_constexpr] = ACTIONS(5146),
    [anon_sym_volatile] = ACTIONS(5146),
    [anon_sym_restrict] = ACTIONS(5146),
    [anon_sym___restrict__] = ACTIONS(5146),
    [anon_sym__Atomic] = ACTIONS(5146),
    [anon_sym__Noreturn] = ACTIONS(5146),
    [anon_sym_noreturn] = ACTIONS(5146),
    [anon_sym_mutable] = ACTIONS(5146),
    [anon_sym_constinit] = ACTIONS(5146),
    [anon_sym_consteval] = ACTIONS(5146),
    [anon_sym_PROGMEM] = ACTIONS(5146),
    [aux_sym_primitive_type_token1] = ACTIONS(5146),
    [anon_sym_byte] = ACTIONS(5146),
    [anon_sym_word] = ACTIONS(5146),
    [anon_sym_enum] = ACTIONS(5146),
    [anon_sym_class] = ACTIONS(5146),
    [anon_sym_struct] = ACTIONS(5146),
    [anon_sym_union] = ACTIONS(5146),
    [anon_sym_or] = ACTIONS(5146),
    [anon_sym_and] = ACTIONS(5146),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5146),
    [anon_sym_decltype] = ACTIONS(5146),
    [anon_sym_virtual] = ACTIONS(5146),
    [anon_sym_alignas] = ACTIONS(5146),
    [anon_sym_explicit] = ACTIONS(5146),
    [anon_sym_typename] = ACTIONS(5146),
    [anon_sym_template] = ACTIONS(5146),
    [anon_sym_operator] = ACTIONS(5146),
    [anon_sym_friend] = ACTIONS(5146),
    [anon_sym_using] = ACTIONS(5146),
    [anon_sym_concept] = ACTIONS(5146),
  },
  [2714] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6134),
    [anon_sym_COMMA] = ACTIONS(6134),
    [anon_sym_RPAREN] = ACTIONS(6134),
    [anon_sym_LPAREN2] = ACTIONS(6134),
    [anon_sym_DASH] = ACTIONS(6136),
    [anon_sym_PLUS] = ACTIONS(6136),
    [anon_sym_STAR] = ACTIONS(6134),
    [anon_sym_SLASH] = ACTIONS(6136),
    [anon_sym_PERCENT] = ACTIONS(6134),
    [anon_sym_PIPE_PIPE] = ACTIONS(6134),
    [anon_sym_AMP_AMP] = ACTIONS(6134),
    [anon_sym_PIPE] = ACTIONS(6136),
    [anon_sym_CARET] = ACTIONS(6134),
    [anon_sym_AMP] = ACTIONS(6136),
    [anon_sym_EQ_EQ] = ACTIONS(6134),
    [anon_sym_BANG_EQ] = ACTIONS(6134),
    [anon_sym_GT] = ACTIONS(6136),
    [anon_sym_GT_EQ] = ACTIONS(6134),
    [anon_sym_LT_EQ] = ACTIONS(6136),
    [anon_sym_LT] = ACTIONS(6136),
    [anon_sym_LT_LT] = ACTIONS(6134),
    [anon_sym_GT_GT] = ACTIONS(6134),
    [anon_sym_SEMI] = ACTIONS(6134),
    [anon_sym___extension__] = ACTIONS(6134),
    [anon_sym___attribute__] = ACTIONS(6134),
    [anon_sym_LBRACE] = ACTIONS(6134),
    [anon_sym_RBRACE] = ACTIONS(6134),
    [anon_sym_signed] = ACTIONS(6138),
    [anon_sym_unsigned] = ACTIONS(6138),
    [anon_sym_long] = ACTIONS(6138),
    [anon_sym_short] = ACTIONS(6138),
    [anon_sym_LBRACK] = ACTIONS(6134),
    [anon_sym_RBRACK] = ACTIONS(6134),
    [anon_sym_const] = ACTIONS(6136),
    [anon_sym_constexpr] = ACTIONS(6134),
    [anon_sym_volatile] = ACTIONS(6134),
    [anon_sym_restrict] = ACTIONS(6134),
    [anon_sym___restrict__] = ACTIONS(6134),
    [anon_sym__Atomic] = ACTIONS(6134),
    [anon_sym__Noreturn] = ACTIONS(6134),
    [anon_sym_noreturn] = ACTIONS(6134),
    [anon_sym_mutable] = ACTIONS(6134),
    [anon_sym_constinit] = ACTIONS(6134),
    [anon_sym_consteval] = ACTIONS(6134),
    [anon_sym_PROGMEM] = ACTIONS(6134),
    [anon_sym_COLON] = ACTIONS(6134),
    [anon_sym_QMARK] = ACTIONS(6134),
    [anon_sym_LT_EQ_GT] = ACTIONS(6134),
    [anon_sym_or] = ACTIONS(6134),
    [anon_sym_and] = ACTIONS(6134),
    [anon_sym_bitor] = ACTIONS(6134),
    [anon_sym_xor] = ACTIONS(6134),
    [anon_sym_bitand] = ACTIONS(6134),
    [anon_sym_not_eq] = ACTIONS(6134),
    [anon_sym_DASH_DASH] = ACTIONS(6134),
    [anon_sym_PLUS_PLUS] = ACTIONS(6134),
    [anon_sym_DOT] = ACTIONS(6136),
    [anon_sym_DOT_STAR] = ACTIONS(6134),
    [anon_sym_DASH_GT] = ACTIONS(6134),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6134),
    [anon_sym_decltype] = ACTIONS(6134),
    [anon_sym_final] = ACTIONS(6134),
    [anon_sym_override] = ACTIONS(6134),
    [anon_sym_requires] = ACTIONS(6134),
  },
  [2715] = {
    [sym_identifier] = ACTIONS(5109),
    [anon_sym_LPAREN2] = ACTIONS(5111),
    [anon_sym_TILDE] = ACTIONS(5111),
    [anon_sym_STAR] = ACTIONS(5111),
    [anon_sym_PIPE_PIPE] = ACTIONS(5111),
    [anon_sym_AMP_AMP] = ACTIONS(5111),
    [anon_sym_AMP] = ACTIONS(5109),
    [anon_sym___extension__] = ACTIONS(5109),
    [anon_sym_extern] = ACTIONS(5109),
    [anon_sym___attribute__] = ACTIONS(5109),
    [anon_sym_COLON_COLON] = ACTIONS(5111),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5111),
    [anon_sym___declspec] = ACTIONS(5109),
    [anon_sym___based] = ACTIONS(5109),
    [anon_sym___cdecl] = ACTIONS(5109),
    [anon_sym___clrcall] = ACTIONS(5109),
    [anon_sym___stdcall] = ACTIONS(5109),
    [anon_sym___fastcall] = ACTIONS(5109),
    [anon_sym___thiscall] = ACTIONS(5109),
    [anon_sym___vectorcall] = ACTIONS(5109),
    [anon_sym_signed] = ACTIONS(5109),
    [anon_sym_unsigned] = ACTIONS(5109),
    [anon_sym_long] = ACTIONS(5109),
    [anon_sym_short] = ACTIONS(5109),
    [anon_sym_LBRACK] = ACTIONS(5109),
    [anon_sym_static] = ACTIONS(5109),
    [anon_sym_register] = ACTIONS(5109),
    [anon_sym_inline] = ACTIONS(5109),
    [anon_sym___inline] = ACTIONS(5109),
    [anon_sym___inline__] = ACTIONS(5109),
    [anon_sym___forceinline] = ACTIONS(5109),
    [anon_sym_thread_local] = ACTIONS(5109),
    [anon_sym___thread] = ACTIONS(5109),
    [anon_sym_const] = ACTIONS(5109),
    [anon_sym_constexpr] = ACTIONS(5109),
    [anon_sym_volatile] = ACTIONS(5109),
    [anon_sym_restrict] = ACTIONS(5109),
    [anon_sym___restrict__] = ACTIONS(5109),
    [anon_sym__Atomic] = ACTIONS(5109),
    [anon_sym__Noreturn] = ACTIONS(5109),
    [anon_sym_noreturn] = ACTIONS(5109),
    [anon_sym_mutable] = ACTIONS(5109),
    [anon_sym_constinit] = ACTIONS(5109),
    [anon_sym_consteval] = ACTIONS(5109),
    [anon_sym_PROGMEM] = ACTIONS(5109),
    [aux_sym_primitive_type_token1] = ACTIONS(5109),
    [anon_sym_byte] = ACTIONS(5109),
    [anon_sym_word] = ACTIONS(5109),
    [anon_sym_enum] = ACTIONS(5109),
    [anon_sym_class] = ACTIONS(5109),
    [anon_sym_struct] = ACTIONS(5109),
    [anon_sym_union] = ACTIONS(5109),
    [anon_sym_or] = ACTIONS(5109),
    [anon_sym_and] = ACTIONS(5109),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5109),
    [anon_sym_decltype] = ACTIONS(5109),
    [anon_sym_virtual] = ACTIONS(5109),
    [anon_sym_alignas] = ACTIONS(5109),
    [anon_sym_explicit] = ACTIONS(5109),
    [anon_sym_typename] = ACTIONS(5109),
    [anon_sym_template] = ACTIONS(5109),
    [anon_sym_operator] = ACTIONS(5109),
    [anon_sym_friend] = ACTIONS(5109),
    [anon_sym_using] = ACTIONS(5109),
    [anon_sym_concept] = ACTIONS(5109),
  },
  [2716] = {
    [sym_attribute_declaration] = STATE(2729),
    [sym_parameter_list] = STATE(2784),
    [aux_sym_attributed_declarator_repeat1] = STATE(2729),
    [sym_identifier] = ACTIONS(6140),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6142),
    [anon_sym_COMMA] = ACTIONS(6142),
    [anon_sym_RPAREN] = ACTIONS(6142),
    [aux_sym_preproc_if_token2] = ACTIONS(6142),
    [aux_sym_preproc_else_token1] = ACTIONS(6142),
    [aux_sym_preproc_elif_token1] = ACTIONS(6140),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6142),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6142),
    [anon_sym_LPAREN2] = ACTIONS(6000),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_PLUS] = ACTIONS(6140),
    [anon_sym_STAR] = ACTIONS(6140),
    [anon_sym_SLASH] = ACTIONS(6140),
    [anon_sym_PERCENT] = ACTIONS(6140),
    [anon_sym_PIPE_PIPE] = ACTIONS(6142),
    [anon_sym_AMP_AMP] = ACTIONS(6142),
    [anon_sym_PIPE] = ACTIONS(6140),
    [anon_sym_CARET] = ACTIONS(6140),
    [anon_sym_AMP] = ACTIONS(6140),
    [anon_sym_EQ_EQ] = ACTIONS(6142),
    [anon_sym_BANG_EQ] = ACTIONS(6142),
    [anon_sym_GT] = ACTIONS(6140),
    [anon_sym_GT_EQ] = ACTIONS(6142),
    [anon_sym_LT_EQ] = ACTIONS(6140),
    [anon_sym_LT] = ACTIONS(6140),
    [anon_sym_LT_LT] = ACTIONS(6140),
    [anon_sym_GT_GT] = ACTIONS(6140),
    [anon_sym_SEMI] = ACTIONS(6142),
    [anon_sym___attribute__] = ACTIONS(6140),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6002),
    [anon_sym_RBRACE] = ACTIONS(6142),
    [anon_sym_LBRACK] = ACTIONS(6004),
    [anon_sym_RBRACK] = ACTIONS(6142),
    [anon_sym_EQ] = ACTIONS(6140),
    [anon_sym_COLON] = ACTIONS(6142),
    [anon_sym_QMARK] = ACTIONS(6142),
    [anon_sym_STAR_EQ] = ACTIONS(6142),
    [anon_sym_SLASH_EQ] = ACTIONS(6142),
    [anon_sym_PERCENT_EQ] = ACTIONS(6142),
    [anon_sym_PLUS_EQ] = ACTIONS(6142),
    [anon_sym_DASH_EQ] = ACTIONS(6142),
    [anon_sym_LT_LT_EQ] = ACTIONS(6142),
    [anon_sym_GT_GT_EQ] = ACTIONS(6142),
    [anon_sym_AMP_EQ] = ACTIONS(6142),
    [anon_sym_CARET_EQ] = ACTIONS(6142),
    [anon_sym_PIPE_EQ] = ACTIONS(6142),
    [anon_sym_and_eq] = ACTIONS(6140),
    [anon_sym_or_eq] = ACTIONS(6140),
    [anon_sym_xor_eq] = ACTIONS(6140),
    [anon_sym_LT_EQ_GT] = ACTIONS(6142),
    [anon_sym_or] = ACTIONS(6140),
    [anon_sym_and] = ACTIONS(6140),
    [anon_sym_bitor] = ACTIONS(6140),
    [anon_sym_xor] = ACTIONS(6140),
    [anon_sym_bitand] = ACTIONS(6140),
    [anon_sym_not_eq] = ACTIONS(6140),
    [anon_sym_DASH_DASH] = ACTIONS(6142),
    [anon_sym_PLUS_PLUS] = ACTIONS(6142),
    [anon_sym_DOT] = ACTIONS(6140),
    [anon_sym_DOT_STAR] = ACTIONS(6142),
    [anon_sym_DASH_GT] = ACTIONS(6142),
    [sym_comment] = ACTIONS(3),
  },
  [2717] = {
    [sym_identifier] = ACTIONS(5121),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_TILDE] = ACTIONS(5123),
    [anon_sym_STAR] = ACTIONS(5123),
    [anon_sym_PIPE_PIPE] = ACTIONS(5123),
    [anon_sym_AMP_AMP] = ACTIONS(5123),
    [anon_sym_AMP] = ACTIONS(5121),
    [anon_sym___extension__] = ACTIONS(5121),
    [anon_sym_extern] = ACTIONS(5121),
    [anon_sym___attribute__] = ACTIONS(5121),
    [anon_sym_COLON_COLON] = ACTIONS(5123),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5123),
    [anon_sym___declspec] = ACTIONS(5121),
    [anon_sym___based] = ACTIONS(5121),
    [anon_sym___cdecl] = ACTIONS(5121),
    [anon_sym___clrcall] = ACTIONS(5121),
    [anon_sym___stdcall] = ACTIONS(5121),
    [anon_sym___fastcall] = ACTIONS(5121),
    [anon_sym___thiscall] = ACTIONS(5121),
    [anon_sym___vectorcall] = ACTIONS(5121),
    [anon_sym_signed] = ACTIONS(5121),
    [anon_sym_unsigned] = ACTIONS(5121),
    [anon_sym_long] = ACTIONS(5121),
    [anon_sym_short] = ACTIONS(5121),
    [anon_sym_LBRACK] = ACTIONS(5121),
    [anon_sym_static] = ACTIONS(5121),
    [anon_sym_register] = ACTIONS(5121),
    [anon_sym_inline] = ACTIONS(5121),
    [anon_sym___inline] = ACTIONS(5121),
    [anon_sym___inline__] = ACTIONS(5121),
    [anon_sym___forceinline] = ACTIONS(5121),
    [anon_sym_thread_local] = ACTIONS(5121),
    [anon_sym___thread] = ACTIONS(5121),
    [anon_sym_const] = ACTIONS(5121),
    [anon_sym_constexpr] = ACTIONS(5121),
    [anon_sym_volatile] = ACTIONS(5121),
    [anon_sym_restrict] = ACTIONS(5121),
    [anon_sym___restrict__] = ACTIONS(5121),
    [anon_sym__Atomic] = ACTIONS(5121),
    [anon_sym__Noreturn] = ACTIONS(5121),
    [anon_sym_noreturn] = ACTIONS(5121),
    [anon_sym_mutable] = ACTIONS(5121),
    [anon_sym_constinit] = ACTIONS(5121),
    [anon_sym_consteval] = ACTIONS(5121),
    [anon_sym_PROGMEM] = ACTIONS(5121),
    [aux_sym_primitive_type_token1] = ACTIONS(5121),
    [anon_sym_byte] = ACTIONS(5121),
    [anon_sym_word] = ACTIONS(5121),
    [anon_sym_enum] = ACTIONS(5121),
    [anon_sym_class] = ACTIONS(5121),
    [anon_sym_struct] = ACTIONS(5121),
    [anon_sym_union] = ACTIONS(5121),
    [anon_sym_or] = ACTIONS(5121),
    [anon_sym_and] = ACTIONS(5121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5121),
    [anon_sym_decltype] = ACTIONS(5121),
    [anon_sym_virtual] = ACTIONS(5121),
    [anon_sym_alignas] = ACTIONS(5121),
    [anon_sym_explicit] = ACTIONS(5121),
    [anon_sym_typename] = ACTIONS(5121),
    [anon_sym_template] = ACTIONS(5121),
    [anon_sym_operator] = ACTIONS(5121),
    [anon_sym_friend] = ACTIONS(5121),
    [anon_sym_using] = ACTIONS(5121),
    [anon_sym_concept] = ACTIONS(5121),
  },
  [2718] = {
    [sym_identifier] = ACTIONS(5125),
    [anon_sym_LPAREN2] = ACTIONS(5127),
    [anon_sym_TILDE] = ACTIONS(5127),
    [anon_sym_STAR] = ACTIONS(5127),
    [anon_sym_PIPE_PIPE] = ACTIONS(5127),
    [anon_sym_AMP_AMP] = ACTIONS(5127),
    [anon_sym_AMP] = ACTIONS(5125),
    [anon_sym___extension__] = ACTIONS(5125),
    [anon_sym_extern] = ACTIONS(5125),
    [anon_sym___attribute__] = ACTIONS(5125),
    [anon_sym_COLON_COLON] = ACTIONS(5127),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5127),
    [anon_sym___declspec] = ACTIONS(5125),
    [anon_sym___based] = ACTIONS(5125),
    [anon_sym___cdecl] = ACTIONS(5125),
    [anon_sym___clrcall] = ACTIONS(5125),
    [anon_sym___stdcall] = ACTIONS(5125),
    [anon_sym___fastcall] = ACTIONS(5125),
    [anon_sym___thiscall] = ACTIONS(5125),
    [anon_sym___vectorcall] = ACTIONS(5125),
    [anon_sym_signed] = ACTIONS(5125),
    [anon_sym_unsigned] = ACTIONS(5125),
    [anon_sym_long] = ACTIONS(5125),
    [anon_sym_short] = ACTIONS(5125),
    [anon_sym_LBRACK] = ACTIONS(5125),
    [anon_sym_static] = ACTIONS(5125),
    [anon_sym_register] = ACTIONS(5125),
    [anon_sym_inline] = ACTIONS(5125),
    [anon_sym___inline] = ACTIONS(5125),
    [anon_sym___inline__] = ACTIONS(5125),
    [anon_sym___forceinline] = ACTIONS(5125),
    [anon_sym_thread_local] = ACTIONS(5125),
    [anon_sym___thread] = ACTIONS(5125),
    [anon_sym_const] = ACTIONS(5125),
    [anon_sym_constexpr] = ACTIONS(5125),
    [anon_sym_volatile] = ACTIONS(5125),
    [anon_sym_restrict] = ACTIONS(5125),
    [anon_sym___restrict__] = ACTIONS(5125),
    [anon_sym__Atomic] = ACTIONS(5125),
    [anon_sym__Noreturn] = ACTIONS(5125),
    [anon_sym_noreturn] = ACTIONS(5125),
    [anon_sym_mutable] = ACTIONS(5125),
    [anon_sym_constinit] = ACTIONS(5125),
    [anon_sym_consteval] = ACTIONS(5125),
    [anon_sym_PROGMEM] = ACTIONS(5125),
    [aux_sym_primitive_type_token1] = ACTIONS(5125),
    [anon_sym_byte] = ACTIONS(5125),
    [anon_sym_word] = ACTIONS(5125),
    [anon_sym_enum] = ACTIONS(5125),
    [anon_sym_class] = ACTIONS(5125),
    [anon_sym_struct] = ACTIONS(5125),
    [anon_sym_union] = ACTIONS(5125),
    [anon_sym_or] = ACTIONS(5125),
    [anon_sym_and] = ACTIONS(5125),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5125),
    [anon_sym_decltype] = ACTIONS(5125),
    [anon_sym_virtual] = ACTIONS(5125),
    [anon_sym_alignas] = ACTIONS(5125),
    [anon_sym_explicit] = ACTIONS(5125),
    [anon_sym_typename] = ACTIONS(5125),
    [anon_sym_template] = ACTIONS(5125),
    [anon_sym_operator] = ACTIONS(5125),
    [anon_sym_friend] = ACTIONS(5125),
    [anon_sym_using] = ACTIONS(5125),
    [anon_sym_concept] = ACTIONS(5125),
  },
  [2719] = {
    [sym_identifier] = ACTIONS(5117),
    [anon_sym_LPAREN2] = ACTIONS(5119),
    [anon_sym_TILDE] = ACTIONS(5119),
    [anon_sym_STAR] = ACTIONS(5119),
    [anon_sym_PIPE_PIPE] = ACTIONS(5119),
    [anon_sym_AMP_AMP] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5117),
    [anon_sym___extension__] = ACTIONS(5117),
    [anon_sym_extern] = ACTIONS(5117),
    [anon_sym___attribute__] = ACTIONS(5117),
    [anon_sym_COLON_COLON] = ACTIONS(5119),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5119),
    [anon_sym___declspec] = ACTIONS(5117),
    [anon_sym___based] = ACTIONS(5117),
    [anon_sym___cdecl] = ACTIONS(5117),
    [anon_sym___clrcall] = ACTIONS(5117),
    [anon_sym___stdcall] = ACTIONS(5117),
    [anon_sym___fastcall] = ACTIONS(5117),
    [anon_sym___thiscall] = ACTIONS(5117),
    [anon_sym___vectorcall] = ACTIONS(5117),
    [anon_sym_signed] = ACTIONS(5117),
    [anon_sym_unsigned] = ACTIONS(5117),
    [anon_sym_long] = ACTIONS(5117),
    [anon_sym_short] = ACTIONS(5117),
    [anon_sym_LBRACK] = ACTIONS(5117),
    [anon_sym_static] = ACTIONS(5117),
    [anon_sym_register] = ACTIONS(5117),
    [anon_sym_inline] = ACTIONS(5117),
    [anon_sym___inline] = ACTIONS(5117),
    [anon_sym___inline__] = ACTIONS(5117),
    [anon_sym___forceinline] = ACTIONS(5117),
    [anon_sym_thread_local] = ACTIONS(5117),
    [anon_sym___thread] = ACTIONS(5117),
    [anon_sym_const] = ACTIONS(5117),
    [anon_sym_constexpr] = ACTIONS(5117),
    [anon_sym_volatile] = ACTIONS(5117),
    [anon_sym_restrict] = ACTIONS(5117),
    [anon_sym___restrict__] = ACTIONS(5117),
    [anon_sym__Atomic] = ACTIONS(5117),
    [anon_sym__Noreturn] = ACTIONS(5117),
    [anon_sym_noreturn] = ACTIONS(5117),
    [anon_sym_mutable] = ACTIONS(5117),
    [anon_sym_constinit] = ACTIONS(5117),
    [anon_sym_consteval] = ACTIONS(5117),
    [anon_sym_PROGMEM] = ACTIONS(5117),
    [aux_sym_primitive_type_token1] = ACTIONS(5117),
    [anon_sym_byte] = ACTIONS(5117),
    [anon_sym_word] = ACTIONS(5117),
    [anon_sym_enum] = ACTIONS(5117),
    [anon_sym_class] = ACTIONS(5117),
    [anon_sym_struct] = ACTIONS(5117),
    [anon_sym_union] = ACTIONS(5117),
    [anon_sym_or] = ACTIONS(5117),
    [anon_sym_and] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5117),
    [anon_sym_decltype] = ACTIONS(5117),
    [anon_sym_virtual] = ACTIONS(5117),
    [anon_sym_alignas] = ACTIONS(5117),
    [anon_sym_explicit] = ACTIONS(5117),
    [anon_sym_typename] = ACTIONS(5117),
    [anon_sym_template] = ACTIONS(5117),
    [anon_sym_operator] = ACTIONS(5117),
    [anon_sym_friend] = ACTIONS(5117),
    [anon_sym_using] = ACTIONS(5117),
    [anon_sym_concept] = ACTIONS(5117),
  },
  [2720] = {
    [sym_attribute_specifier] = STATE(2766),
    [sym_identifier] = ACTIONS(6144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6146),
    [anon_sym_COMMA] = ACTIONS(6146),
    [anon_sym_RPAREN] = ACTIONS(6146),
    [aux_sym_preproc_if_token2] = ACTIONS(6146),
    [aux_sym_preproc_else_token1] = ACTIONS(6146),
    [aux_sym_preproc_elif_token1] = ACTIONS(6144),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6146),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6146),
    [anon_sym_LPAREN2] = ACTIONS(6146),
    [anon_sym_DASH] = ACTIONS(6144),
    [anon_sym_PLUS] = ACTIONS(6144),
    [anon_sym_STAR] = ACTIONS(6144),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6144),
    [anon_sym_PIPE_PIPE] = ACTIONS(6146),
    [anon_sym_AMP_AMP] = ACTIONS(6146),
    [anon_sym_PIPE] = ACTIONS(6144),
    [anon_sym_CARET] = ACTIONS(6144),
    [anon_sym_AMP] = ACTIONS(6144),
    [anon_sym_EQ_EQ] = ACTIONS(6146),
    [anon_sym_BANG_EQ] = ACTIONS(6146),
    [anon_sym_GT] = ACTIONS(6144),
    [anon_sym_GT_EQ] = ACTIONS(6146),
    [anon_sym_LT_EQ] = ACTIONS(6144),
    [anon_sym_LT] = ACTIONS(6144),
    [anon_sym_LT_LT] = ACTIONS(6144),
    [anon_sym_GT_GT] = ACTIONS(6144),
    [anon_sym_SEMI] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(5473),
    [anon_sym_LBRACE] = ACTIONS(6146),
    [anon_sym_RBRACE] = ACTIONS(6146),
    [anon_sym_LBRACK] = ACTIONS(6146),
    [anon_sym_RBRACK] = ACTIONS(6146),
    [anon_sym_EQ] = ACTIONS(6144),
    [anon_sym_COLON] = ACTIONS(6146),
    [anon_sym_QMARK] = ACTIONS(6146),
    [anon_sym_STAR_EQ] = ACTIONS(6146),
    [anon_sym_SLASH_EQ] = ACTIONS(6146),
    [anon_sym_PERCENT_EQ] = ACTIONS(6146),
    [anon_sym_PLUS_EQ] = ACTIONS(6146),
    [anon_sym_DASH_EQ] = ACTIONS(6146),
    [anon_sym_LT_LT_EQ] = ACTIONS(6146),
    [anon_sym_GT_GT_EQ] = ACTIONS(6146),
    [anon_sym_AMP_EQ] = ACTIONS(6146),
    [anon_sym_CARET_EQ] = ACTIONS(6146),
    [anon_sym_PIPE_EQ] = ACTIONS(6146),
    [anon_sym_and_eq] = ACTIONS(6144),
    [anon_sym_or_eq] = ACTIONS(6144),
    [anon_sym_xor_eq] = ACTIONS(6144),
    [anon_sym_LT_EQ_GT] = ACTIONS(6146),
    [anon_sym_or] = ACTIONS(6144),
    [anon_sym_and] = ACTIONS(6144),
    [anon_sym_bitor] = ACTIONS(6144),
    [anon_sym_xor] = ACTIONS(6144),
    [anon_sym_bitand] = ACTIONS(6144),
    [anon_sym_not_eq] = ACTIONS(6144),
    [anon_sym_DASH_DASH] = ACTIONS(6146),
    [anon_sym_PLUS_PLUS] = ACTIONS(6146),
    [anon_sym_DOT] = ACTIONS(6144),
    [anon_sym_DOT_STAR] = ACTIONS(6146),
    [anon_sym_DASH_GT] = ACTIONS(6146),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6144),
    [anon_sym_decltype] = ACTIONS(6144),
  },
  [2721] = {
    [sym_identifier] = ACTIONS(5150),
    [anon_sym_LPAREN2] = ACTIONS(5152),
    [anon_sym_TILDE] = ACTIONS(5152),
    [anon_sym_STAR] = ACTIONS(5152),
    [anon_sym_PIPE_PIPE] = ACTIONS(5152),
    [anon_sym_AMP_AMP] = ACTIONS(5152),
    [anon_sym_AMP] = ACTIONS(5150),
    [anon_sym___extension__] = ACTIONS(5150),
    [anon_sym_extern] = ACTIONS(5150),
    [anon_sym___attribute__] = ACTIONS(5150),
    [anon_sym_COLON_COLON] = ACTIONS(5152),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5152),
    [anon_sym___declspec] = ACTIONS(5150),
    [anon_sym___based] = ACTIONS(5150),
    [anon_sym___cdecl] = ACTIONS(5150),
    [anon_sym___clrcall] = ACTIONS(5150),
    [anon_sym___stdcall] = ACTIONS(5150),
    [anon_sym___fastcall] = ACTIONS(5150),
    [anon_sym___thiscall] = ACTIONS(5150),
    [anon_sym___vectorcall] = ACTIONS(5150),
    [anon_sym_signed] = ACTIONS(5150),
    [anon_sym_unsigned] = ACTIONS(5150),
    [anon_sym_long] = ACTIONS(5150),
    [anon_sym_short] = ACTIONS(5150),
    [anon_sym_LBRACK] = ACTIONS(5150),
    [anon_sym_static] = ACTIONS(5150),
    [anon_sym_register] = ACTIONS(5150),
    [anon_sym_inline] = ACTIONS(5150),
    [anon_sym___inline] = ACTIONS(5150),
    [anon_sym___inline__] = ACTIONS(5150),
    [anon_sym___forceinline] = ACTIONS(5150),
    [anon_sym_thread_local] = ACTIONS(5150),
    [anon_sym___thread] = ACTIONS(5150),
    [anon_sym_const] = ACTIONS(5150),
    [anon_sym_constexpr] = ACTIONS(5150),
    [anon_sym_volatile] = ACTIONS(5150),
    [anon_sym_restrict] = ACTIONS(5150),
    [anon_sym___restrict__] = ACTIONS(5150),
    [anon_sym__Atomic] = ACTIONS(5150),
    [anon_sym__Noreturn] = ACTIONS(5150),
    [anon_sym_noreturn] = ACTIONS(5150),
    [anon_sym_mutable] = ACTIONS(5150),
    [anon_sym_constinit] = ACTIONS(5150),
    [anon_sym_consteval] = ACTIONS(5150),
    [anon_sym_PROGMEM] = ACTIONS(5150),
    [aux_sym_primitive_type_token1] = ACTIONS(5150),
    [anon_sym_byte] = ACTIONS(5150),
    [anon_sym_word] = ACTIONS(5150),
    [anon_sym_enum] = ACTIONS(5150),
    [anon_sym_class] = ACTIONS(5150),
    [anon_sym_struct] = ACTIONS(5150),
    [anon_sym_union] = ACTIONS(5150),
    [anon_sym_or] = ACTIONS(5150),
    [anon_sym_and] = ACTIONS(5150),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5150),
    [anon_sym_decltype] = ACTIONS(5150),
    [anon_sym_virtual] = ACTIONS(5150),
    [anon_sym_alignas] = ACTIONS(5150),
    [anon_sym_explicit] = ACTIONS(5150),
    [anon_sym_typename] = ACTIONS(5150),
    [anon_sym_template] = ACTIONS(5150),
    [anon_sym_operator] = ACTIONS(5150),
    [anon_sym_friend] = ACTIONS(5150),
    [anon_sym_using] = ACTIONS(5150),
    [anon_sym_concept] = ACTIONS(5150),
  },
  [2722] = {
    [sym_identifier] = ACTIONS(5113),
    [anon_sym_LPAREN2] = ACTIONS(5115),
    [anon_sym_TILDE] = ACTIONS(5115),
    [anon_sym_STAR] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(5115),
    [anon_sym_AMP_AMP] = ACTIONS(5115),
    [anon_sym_AMP] = ACTIONS(5113),
    [anon_sym___extension__] = ACTIONS(5113),
    [anon_sym_extern] = ACTIONS(5113),
    [anon_sym___attribute__] = ACTIONS(5113),
    [anon_sym_COLON_COLON] = ACTIONS(5115),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5115),
    [anon_sym___declspec] = ACTIONS(5113),
    [anon_sym___based] = ACTIONS(5113),
    [anon_sym___cdecl] = ACTIONS(5113),
    [anon_sym___clrcall] = ACTIONS(5113),
    [anon_sym___stdcall] = ACTIONS(5113),
    [anon_sym___fastcall] = ACTIONS(5113),
    [anon_sym___thiscall] = ACTIONS(5113),
    [anon_sym___vectorcall] = ACTIONS(5113),
    [anon_sym_signed] = ACTIONS(5113),
    [anon_sym_unsigned] = ACTIONS(5113),
    [anon_sym_long] = ACTIONS(5113),
    [anon_sym_short] = ACTIONS(5113),
    [anon_sym_LBRACK] = ACTIONS(5113),
    [anon_sym_static] = ACTIONS(5113),
    [anon_sym_register] = ACTIONS(5113),
    [anon_sym_inline] = ACTIONS(5113),
    [anon_sym___inline] = ACTIONS(5113),
    [anon_sym___inline__] = ACTIONS(5113),
    [anon_sym___forceinline] = ACTIONS(5113),
    [anon_sym_thread_local] = ACTIONS(5113),
    [anon_sym___thread] = ACTIONS(5113),
    [anon_sym_const] = ACTIONS(5113),
    [anon_sym_constexpr] = ACTIONS(5113),
    [anon_sym_volatile] = ACTIONS(5113),
    [anon_sym_restrict] = ACTIONS(5113),
    [anon_sym___restrict__] = ACTIONS(5113),
    [anon_sym__Atomic] = ACTIONS(5113),
    [anon_sym__Noreturn] = ACTIONS(5113),
    [anon_sym_noreturn] = ACTIONS(5113),
    [anon_sym_mutable] = ACTIONS(5113),
    [anon_sym_constinit] = ACTIONS(5113),
    [anon_sym_consteval] = ACTIONS(5113),
    [anon_sym_PROGMEM] = ACTIONS(5113),
    [aux_sym_primitive_type_token1] = ACTIONS(5113),
    [anon_sym_byte] = ACTIONS(5113),
    [anon_sym_word] = ACTIONS(5113),
    [anon_sym_enum] = ACTIONS(5113),
    [anon_sym_class] = ACTIONS(5113),
    [anon_sym_struct] = ACTIONS(5113),
    [anon_sym_union] = ACTIONS(5113),
    [anon_sym_or] = ACTIONS(5113),
    [anon_sym_and] = ACTIONS(5113),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5113),
    [anon_sym_decltype] = ACTIONS(5113),
    [anon_sym_virtual] = ACTIONS(5113),
    [anon_sym_alignas] = ACTIONS(5113),
    [anon_sym_explicit] = ACTIONS(5113),
    [anon_sym_typename] = ACTIONS(5113),
    [anon_sym_template] = ACTIONS(5113),
    [anon_sym_operator] = ACTIONS(5113),
    [anon_sym_friend] = ACTIONS(5113),
    [anon_sym_using] = ACTIONS(5113),
    [anon_sym_concept] = ACTIONS(5113),
  },
  [2723] = {
    [sym_attribute_declaration] = STATE(2729),
    [sym_parameter_list] = STATE(2784),
    [aux_sym_attributed_declarator_repeat1] = STATE(2729),
    [sym_identifier] = ACTIONS(6148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6150),
    [anon_sym_COMMA] = ACTIONS(6150),
    [anon_sym_RPAREN] = ACTIONS(6150),
    [aux_sym_preproc_if_token2] = ACTIONS(6150),
    [aux_sym_preproc_else_token1] = ACTIONS(6150),
    [aux_sym_preproc_elif_token1] = ACTIONS(6148),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6150),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6150),
    [anon_sym_LPAREN2] = ACTIONS(6000),
    [anon_sym_DASH] = ACTIONS(6148),
    [anon_sym_PLUS] = ACTIONS(6148),
    [anon_sym_STAR] = ACTIONS(6148),
    [anon_sym_SLASH] = ACTIONS(6148),
    [anon_sym_PERCENT] = ACTIONS(6148),
    [anon_sym_PIPE_PIPE] = ACTIONS(6150),
    [anon_sym_AMP_AMP] = ACTIONS(6150),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_CARET] = ACTIONS(6148),
    [anon_sym_AMP] = ACTIONS(6148),
    [anon_sym_EQ_EQ] = ACTIONS(6150),
    [anon_sym_BANG_EQ] = ACTIONS(6150),
    [anon_sym_GT] = ACTIONS(6148),
    [anon_sym_GT_EQ] = ACTIONS(6150),
    [anon_sym_LT_EQ] = ACTIONS(6148),
    [anon_sym_LT] = ACTIONS(6148),
    [anon_sym_LT_LT] = ACTIONS(6148),
    [anon_sym_GT_GT] = ACTIONS(6148),
    [anon_sym_SEMI] = ACTIONS(6150),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6002),
    [anon_sym_RBRACE] = ACTIONS(6150),
    [anon_sym_LBRACK] = ACTIONS(6004),
    [anon_sym_RBRACK] = ACTIONS(6150),
    [anon_sym_EQ] = ACTIONS(6148),
    [anon_sym_COLON] = ACTIONS(6150),
    [anon_sym_QMARK] = ACTIONS(6150),
    [anon_sym_STAR_EQ] = ACTIONS(6150),
    [anon_sym_SLASH_EQ] = ACTIONS(6150),
    [anon_sym_PERCENT_EQ] = ACTIONS(6150),
    [anon_sym_PLUS_EQ] = ACTIONS(6150),
    [anon_sym_DASH_EQ] = ACTIONS(6150),
    [anon_sym_LT_LT_EQ] = ACTIONS(6150),
    [anon_sym_GT_GT_EQ] = ACTIONS(6150),
    [anon_sym_AMP_EQ] = ACTIONS(6150),
    [anon_sym_CARET_EQ] = ACTIONS(6150),
    [anon_sym_PIPE_EQ] = ACTIONS(6150),
    [anon_sym_and_eq] = ACTIONS(6148),
    [anon_sym_or_eq] = ACTIONS(6148),
    [anon_sym_xor_eq] = ACTIONS(6148),
    [anon_sym_LT_EQ_GT] = ACTIONS(6150),
    [anon_sym_or] = ACTIONS(6148),
    [anon_sym_and] = ACTIONS(6148),
    [anon_sym_bitor] = ACTIONS(6148),
    [anon_sym_xor] = ACTIONS(6148),
    [anon_sym_bitand] = ACTIONS(6148),
    [anon_sym_not_eq] = ACTIONS(6148),
    [anon_sym_DASH_DASH] = ACTIONS(6150),
    [anon_sym_PLUS_PLUS] = ACTIONS(6150),
    [anon_sym_DOT] = ACTIONS(6148),
    [anon_sym_DOT_STAR] = ACTIONS(6150),
    [anon_sym_DASH_GT] = ACTIONS(6150),
    [sym_comment] = ACTIONS(3),
  },
  [2724] = {
    [sym_argument_list] = STATE(2980),
    [sym_initializer_list] = STATE(2980),
    [sym_identifier] = ACTIONS(6152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6154),
    [anon_sym_COMMA] = ACTIONS(6154),
    [anon_sym_RPAREN] = ACTIONS(6154),
    [aux_sym_preproc_if_token2] = ACTIONS(6154),
    [aux_sym_preproc_else_token1] = ACTIONS(6154),
    [aux_sym_preproc_elif_token1] = ACTIONS(6152),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6154),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6154),
    [anon_sym_LPAREN2] = ACTIONS(5813),
    [anon_sym_DASH] = ACTIONS(6152),
    [anon_sym_PLUS] = ACTIONS(6152),
    [anon_sym_STAR] = ACTIONS(6152),
    [anon_sym_SLASH] = ACTIONS(6152),
    [anon_sym_PERCENT] = ACTIONS(6152),
    [anon_sym_PIPE_PIPE] = ACTIONS(6154),
    [anon_sym_AMP_AMP] = ACTIONS(6154),
    [anon_sym_PIPE] = ACTIONS(6152),
    [anon_sym_CARET] = ACTIONS(6152),
    [anon_sym_AMP] = ACTIONS(6152),
    [anon_sym_EQ_EQ] = ACTIONS(6154),
    [anon_sym_BANG_EQ] = ACTIONS(6154),
    [anon_sym_GT] = ACTIONS(6152),
    [anon_sym_GT_EQ] = ACTIONS(6154),
    [anon_sym_LT_EQ] = ACTIONS(6152),
    [anon_sym_LT] = ACTIONS(6152),
    [anon_sym_LT_LT] = ACTIONS(6152),
    [anon_sym_GT_GT] = ACTIONS(6152),
    [anon_sym_SEMI] = ACTIONS(6154),
    [anon_sym___attribute__] = ACTIONS(6152),
    [anon_sym_LBRACE] = ACTIONS(2159),
    [anon_sym_RBRACE] = ACTIONS(6154),
    [anon_sym_LBRACK] = ACTIONS(6154),
    [anon_sym_RBRACK] = ACTIONS(6154),
    [anon_sym_EQ] = ACTIONS(6152),
    [anon_sym_COLON] = ACTIONS(6154),
    [anon_sym_QMARK] = ACTIONS(6154),
    [anon_sym_STAR_EQ] = ACTIONS(6154),
    [anon_sym_SLASH_EQ] = ACTIONS(6154),
    [anon_sym_PERCENT_EQ] = ACTIONS(6154),
    [anon_sym_PLUS_EQ] = ACTIONS(6154),
    [anon_sym_DASH_EQ] = ACTIONS(6154),
    [anon_sym_LT_LT_EQ] = ACTIONS(6154),
    [anon_sym_GT_GT_EQ] = ACTIONS(6154),
    [anon_sym_AMP_EQ] = ACTIONS(6154),
    [anon_sym_CARET_EQ] = ACTIONS(6154),
    [anon_sym_PIPE_EQ] = ACTIONS(6154),
    [anon_sym_and_eq] = ACTIONS(6152),
    [anon_sym_or_eq] = ACTIONS(6152),
    [anon_sym_xor_eq] = ACTIONS(6152),
    [anon_sym_LT_EQ_GT] = ACTIONS(6154),
    [anon_sym_or] = ACTIONS(6152),
    [anon_sym_and] = ACTIONS(6152),
    [anon_sym_bitor] = ACTIONS(6152),
    [anon_sym_xor] = ACTIONS(6152),
    [anon_sym_bitand] = ACTIONS(6152),
    [anon_sym_not_eq] = ACTIONS(6152),
    [anon_sym_DASH_DASH] = ACTIONS(6154),
    [anon_sym_PLUS_PLUS] = ACTIONS(6154),
    [anon_sym_DOT] = ACTIONS(6152),
    [anon_sym_DOT_STAR] = ACTIONS(6154),
    [anon_sym_DASH_GT] = ACTIONS(6154),
    [sym_comment] = ACTIONS(3),
  },
  [2725] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2761),
    [sym_identifier] = ACTIONS(6092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6090),
    [anon_sym_COMMA] = ACTIONS(6090),
    [aux_sym_preproc_if_token2] = ACTIONS(6090),
    [aux_sym_preproc_else_token1] = ACTIONS(6090),
    [aux_sym_preproc_elif_token1] = ACTIONS(6092),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6090),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6090),
    [anon_sym_LPAREN2] = ACTIONS(6090),
    [anon_sym_DASH] = ACTIONS(6092),
    [anon_sym_PLUS] = ACTIONS(6092),
    [anon_sym_STAR] = ACTIONS(6092),
    [anon_sym_SLASH] = ACTIONS(6092),
    [anon_sym_PERCENT] = ACTIONS(6092),
    [anon_sym_PIPE_PIPE] = ACTIONS(6090),
    [anon_sym_AMP_AMP] = ACTIONS(6090),
    [anon_sym_PIPE] = ACTIONS(6092),
    [anon_sym_CARET] = ACTIONS(6092),
    [anon_sym_AMP] = ACTIONS(6092),
    [anon_sym_EQ_EQ] = ACTIONS(6090),
    [anon_sym_BANG_EQ] = ACTIONS(6090),
    [anon_sym_GT] = ACTIONS(6092),
    [anon_sym_GT_EQ] = ACTIONS(6090),
    [anon_sym_LT_EQ] = ACTIONS(6092),
    [anon_sym_LT] = ACTIONS(6092),
    [anon_sym_LT_LT] = ACTIONS(6092),
    [anon_sym_GT_GT] = ACTIONS(6092),
    [anon_sym___attribute__] = ACTIONS(6092),
    [anon_sym_LBRACE] = ACTIONS(6090),
    [anon_sym_signed] = ACTIONS(6156),
    [anon_sym_unsigned] = ACTIONS(6156),
    [anon_sym_long] = ACTIONS(6156),
    [anon_sym_short] = ACTIONS(6156),
    [anon_sym_LBRACK] = ACTIONS(6090),
    [anon_sym_EQ] = ACTIONS(6092),
    [anon_sym_QMARK] = ACTIONS(6090),
    [anon_sym_STAR_EQ] = ACTIONS(6090),
    [anon_sym_SLASH_EQ] = ACTIONS(6090),
    [anon_sym_PERCENT_EQ] = ACTIONS(6090),
    [anon_sym_PLUS_EQ] = ACTIONS(6090),
    [anon_sym_DASH_EQ] = ACTIONS(6090),
    [anon_sym_LT_LT_EQ] = ACTIONS(6090),
    [anon_sym_GT_GT_EQ] = ACTIONS(6090),
    [anon_sym_AMP_EQ] = ACTIONS(6090),
    [anon_sym_CARET_EQ] = ACTIONS(6090),
    [anon_sym_PIPE_EQ] = ACTIONS(6090),
    [anon_sym_and_eq] = ACTIONS(6092),
    [anon_sym_or_eq] = ACTIONS(6092),
    [anon_sym_xor_eq] = ACTIONS(6092),
    [anon_sym_LT_EQ_GT] = ACTIONS(6090),
    [anon_sym_or] = ACTIONS(6092),
    [anon_sym_and] = ACTIONS(6092),
    [anon_sym_bitor] = ACTIONS(6092),
    [anon_sym_xor] = ACTIONS(6092),
    [anon_sym_bitand] = ACTIONS(6092),
    [anon_sym_not_eq] = ACTIONS(6092),
    [anon_sym_DASH_DASH] = ACTIONS(6090),
    [anon_sym_PLUS_PLUS] = ACTIONS(6090),
    [anon_sym_DOT] = ACTIONS(6092),
    [anon_sym_DOT_STAR] = ACTIONS(6090),
    [anon_sym_DASH_GT] = ACTIONS(6090),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6092),
    [anon_sym_decltype] = ACTIONS(6092),
  },
  [2726] = {
    [sym_identifier] = ACTIONS(6158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6160),
    [anon_sym_COMMA] = ACTIONS(6160),
    [anon_sym_RPAREN] = ACTIONS(6160),
    [aux_sym_preproc_if_token2] = ACTIONS(6160),
    [aux_sym_preproc_else_token1] = ACTIONS(6160),
    [aux_sym_preproc_elif_token1] = ACTIONS(6158),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6160),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6160),
    [anon_sym_LPAREN2] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6158),
    [anon_sym_PLUS] = ACTIONS(6158),
    [anon_sym_STAR] = ACTIONS(6158),
    [anon_sym_SLASH] = ACTIONS(6158),
    [anon_sym_PERCENT] = ACTIONS(6158),
    [anon_sym_PIPE_PIPE] = ACTIONS(6160),
    [anon_sym_AMP_AMP] = ACTIONS(6160),
    [anon_sym_PIPE] = ACTIONS(6158),
    [anon_sym_CARET] = ACTIONS(6158),
    [anon_sym_AMP] = ACTIONS(6158),
    [anon_sym_EQ_EQ] = ACTIONS(6160),
    [anon_sym_BANG_EQ] = ACTIONS(6160),
    [anon_sym_GT] = ACTIONS(6158),
    [anon_sym_GT_EQ] = ACTIONS(6160),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_LT] = ACTIONS(6158),
    [anon_sym_LT_LT] = ACTIONS(6158),
    [anon_sym_GT_GT] = ACTIONS(6158),
    [anon_sym_SEMI] = ACTIONS(6160),
    [anon_sym___attribute__] = ACTIONS(6158),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6160),
    [anon_sym_LBRACE] = ACTIONS(6160),
    [anon_sym_RBRACE] = ACTIONS(6160),
    [anon_sym_LBRACK] = ACTIONS(6158),
    [anon_sym_RBRACK] = ACTIONS(6160),
    [anon_sym_EQ] = ACTIONS(6158),
    [anon_sym_COLON] = ACTIONS(6160),
    [anon_sym_QMARK] = ACTIONS(6160),
    [anon_sym_STAR_EQ] = ACTIONS(6160),
    [anon_sym_SLASH_EQ] = ACTIONS(6160),
    [anon_sym_PERCENT_EQ] = ACTIONS(6160),
    [anon_sym_PLUS_EQ] = ACTIONS(6160),
    [anon_sym_DASH_EQ] = ACTIONS(6160),
    [anon_sym_LT_LT_EQ] = ACTIONS(6160),
    [anon_sym_GT_GT_EQ] = ACTIONS(6160),
    [anon_sym_AMP_EQ] = ACTIONS(6160),
    [anon_sym_CARET_EQ] = ACTIONS(6160),
    [anon_sym_PIPE_EQ] = ACTIONS(6160),
    [anon_sym_and_eq] = ACTIONS(6158),
    [anon_sym_or_eq] = ACTIONS(6158),
    [anon_sym_xor_eq] = ACTIONS(6158),
    [anon_sym_LT_EQ_GT] = ACTIONS(6160),
    [anon_sym_or] = ACTIONS(6158),
    [anon_sym_and] = ACTIONS(6158),
    [anon_sym_bitor] = ACTIONS(6158),
    [anon_sym_xor] = ACTIONS(6158),
    [anon_sym_bitand] = ACTIONS(6158),
    [anon_sym_not_eq] = ACTIONS(6158),
    [anon_sym_DASH_DASH] = ACTIONS(6160),
    [anon_sym_PLUS_PLUS] = ACTIONS(6160),
    [anon_sym_DOT] = ACTIONS(6158),
    [anon_sym_DOT_STAR] = ACTIONS(6160),
    [anon_sym_DASH_GT] = ACTIONS(6160),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6158),
  },
  [2727] = {
    [sym_identifier] = ACTIONS(4129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4131),
    [anon_sym_COMMA] = ACTIONS(4131),
    [anon_sym_RPAREN] = ACTIONS(4131),
    [anon_sym_LPAREN2] = ACTIONS(4131),
    [anon_sym_TILDE] = ACTIONS(4131),
    [anon_sym_STAR] = ACTIONS(4131),
    [anon_sym_AMP_AMP] = ACTIONS(4131),
    [anon_sym_AMP] = ACTIONS(4129),
    [anon_sym_SEMI] = ACTIONS(4131),
    [anon_sym___extension__] = ACTIONS(4129),
    [anon_sym_extern] = ACTIONS(4129),
    [anon_sym___attribute__] = ACTIONS(4129),
    [anon_sym_COLON_COLON] = ACTIONS(4131),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4131),
    [anon_sym___declspec] = ACTIONS(4129),
    [anon_sym___based] = ACTIONS(4129),
    [anon_sym___cdecl] = ACTIONS(4129),
    [anon_sym___clrcall] = ACTIONS(4129),
    [anon_sym___stdcall] = ACTIONS(4129),
    [anon_sym___fastcall] = ACTIONS(4129),
    [anon_sym___thiscall] = ACTIONS(4129),
    [anon_sym___vectorcall] = ACTIONS(4129),
    [anon_sym_LBRACE] = ACTIONS(4131),
    [anon_sym_LBRACK] = ACTIONS(4129),
    [anon_sym_EQ] = ACTIONS(4131),
    [anon_sym_static] = ACTIONS(4129),
    [anon_sym_register] = ACTIONS(4129),
    [anon_sym_inline] = ACTIONS(4129),
    [anon_sym___inline] = ACTIONS(4129),
    [anon_sym___inline__] = ACTIONS(4129),
    [anon_sym___forceinline] = ACTIONS(4129),
    [anon_sym_thread_local] = ACTIONS(4129),
    [anon_sym___thread] = ACTIONS(4129),
    [anon_sym_const] = ACTIONS(4129),
    [anon_sym_constexpr] = ACTIONS(4129),
    [anon_sym_volatile] = ACTIONS(4129),
    [anon_sym_restrict] = ACTIONS(4129),
    [anon_sym___restrict__] = ACTIONS(4129),
    [anon_sym__Atomic] = ACTIONS(4129),
    [anon_sym__Noreturn] = ACTIONS(4129),
    [anon_sym_noreturn] = ACTIONS(4129),
    [anon_sym_mutable] = ACTIONS(4129),
    [anon_sym_constinit] = ACTIONS(4129),
    [anon_sym_consteval] = ACTIONS(4129),
    [anon_sym_PROGMEM] = ACTIONS(4129),
    [anon_sym_COLON] = ACTIONS(4129),
    [anon_sym_asm] = ACTIONS(4129),
    [anon_sym___asm__] = ACTIONS(4129),
    [anon_sym_DASH_GT] = ACTIONS(4131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4129),
    [anon_sym_final] = ACTIONS(4129),
    [anon_sym_override] = ACTIONS(4129),
    [anon_sym_virtual] = ACTIONS(4129),
    [anon_sym_alignas] = ACTIONS(4129),
    [anon_sym_explicit] = ACTIONS(4129),
    [anon_sym_template] = ACTIONS(4129),
    [anon_sym_GT2] = ACTIONS(4131),
    [anon_sym_operator] = ACTIONS(4129),
    [anon_sym_try] = ACTIONS(4129),
    [anon_sym_public] = ACTIONS(4129),
    [anon_sym_private] = ACTIONS(4129),
    [anon_sym_protected] = ACTIONS(4129),
    [anon_sym_requires] = ACTIONS(4129),
  },
  [2728] = {
    [sym_identifier] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5742),
    [anon_sym_COMMA] = ACTIONS(5742),
    [anon_sym_RPAREN] = ACTIONS(5742),
    [aux_sym_preproc_if_token2] = ACTIONS(5742),
    [aux_sym_preproc_else_token1] = ACTIONS(5742),
    [aux_sym_preproc_elif_token1] = ACTIONS(5740),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5742),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5742),
    [anon_sym_LPAREN2] = ACTIONS(5742),
    [anon_sym_DASH] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5740),
    [anon_sym_STAR] = ACTIONS(5740),
    [anon_sym_SLASH] = ACTIONS(5740),
    [anon_sym_PERCENT] = ACTIONS(5740),
    [anon_sym_PIPE_PIPE] = ACTIONS(5742),
    [anon_sym_AMP_AMP] = ACTIONS(5742),
    [anon_sym_PIPE] = ACTIONS(5740),
    [anon_sym_CARET] = ACTIONS(5740),
    [anon_sym_AMP] = ACTIONS(5740),
    [anon_sym_EQ_EQ] = ACTIONS(5742),
    [anon_sym_BANG_EQ] = ACTIONS(5742),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5742),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_LT_LT] = ACTIONS(5740),
    [anon_sym_GT_GT] = ACTIONS(5740),
    [anon_sym_SEMI] = ACTIONS(5742),
    [anon_sym___attribute__] = ACTIONS(5740),
    [anon_sym_LBRACE] = ACTIONS(5742),
    [anon_sym_RBRACE] = ACTIONS(5742),
    [anon_sym_LBRACK] = ACTIONS(5742),
    [anon_sym_RBRACK] = ACTIONS(5742),
    [anon_sym_EQ] = ACTIONS(5740),
    [anon_sym_COLON] = ACTIONS(5742),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_STAR_EQ] = ACTIONS(5742),
    [anon_sym_SLASH_EQ] = ACTIONS(5742),
    [anon_sym_PERCENT_EQ] = ACTIONS(5742),
    [anon_sym_PLUS_EQ] = ACTIONS(5742),
    [anon_sym_DASH_EQ] = ACTIONS(5742),
    [anon_sym_LT_LT_EQ] = ACTIONS(5742),
    [anon_sym_GT_GT_EQ] = ACTIONS(5742),
    [anon_sym_AMP_EQ] = ACTIONS(5742),
    [anon_sym_CARET_EQ] = ACTIONS(5742),
    [anon_sym_PIPE_EQ] = ACTIONS(5742),
    [anon_sym_and_eq] = ACTIONS(5740),
    [anon_sym_or_eq] = ACTIONS(5740),
    [anon_sym_xor_eq] = ACTIONS(5740),
    [anon_sym_LT_EQ_GT] = ACTIONS(5742),
    [anon_sym_or] = ACTIONS(5740),
    [anon_sym_and] = ACTIONS(5740),
    [anon_sym_bitor] = ACTIONS(5740),
    [anon_sym_xor] = ACTIONS(5740),
    [anon_sym_bitand] = ACTIONS(5740),
    [anon_sym_not_eq] = ACTIONS(5740),
    [anon_sym_DASH_DASH] = ACTIONS(5742),
    [anon_sym_PLUS_PLUS] = ACTIONS(5742),
    [anon_sym_DOT] = ACTIONS(5740),
    [anon_sym_DOT_STAR] = ACTIONS(5742),
    [anon_sym_DASH_GT] = ACTIONS(5742),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5740),
    [anon_sym_decltype] = ACTIONS(5740),
  },
  [2729] = {
    [sym_attribute_declaration] = STATE(2764),
    [aux_sym_attributed_declarator_repeat1] = STATE(2764),
    [sym_identifier] = ACTIONS(6162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6164),
    [anon_sym_COMMA] = ACTIONS(6164),
    [anon_sym_RPAREN] = ACTIONS(6164),
    [aux_sym_preproc_if_token2] = ACTIONS(6164),
    [aux_sym_preproc_else_token1] = ACTIONS(6164),
    [aux_sym_preproc_elif_token1] = ACTIONS(6162),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6164),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6164),
    [anon_sym_LPAREN2] = ACTIONS(6164),
    [anon_sym_DASH] = ACTIONS(6162),
    [anon_sym_PLUS] = ACTIONS(6162),
    [anon_sym_STAR] = ACTIONS(6162),
    [anon_sym_SLASH] = ACTIONS(6162),
    [anon_sym_PERCENT] = ACTIONS(6162),
    [anon_sym_PIPE_PIPE] = ACTIONS(6164),
    [anon_sym_AMP_AMP] = ACTIONS(6164),
    [anon_sym_PIPE] = ACTIONS(6162),
    [anon_sym_CARET] = ACTIONS(6162),
    [anon_sym_AMP] = ACTIONS(6162),
    [anon_sym_EQ_EQ] = ACTIONS(6164),
    [anon_sym_BANG_EQ] = ACTIONS(6164),
    [anon_sym_GT] = ACTIONS(6162),
    [anon_sym_GT_EQ] = ACTIONS(6164),
    [anon_sym_LT_EQ] = ACTIONS(6162),
    [anon_sym_LT] = ACTIONS(6162),
    [anon_sym_LT_LT] = ACTIONS(6162),
    [anon_sym_GT_GT] = ACTIONS(6162),
    [anon_sym_SEMI] = ACTIONS(6164),
    [anon_sym___attribute__] = ACTIONS(6162),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6002),
    [anon_sym_RBRACE] = ACTIONS(6164),
    [anon_sym_LBRACK] = ACTIONS(6162),
    [anon_sym_RBRACK] = ACTIONS(6164),
    [anon_sym_EQ] = ACTIONS(6162),
    [anon_sym_COLON] = ACTIONS(6164),
    [anon_sym_QMARK] = ACTIONS(6164),
    [anon_sym_STAR_EQ] = ACTIONS(6164),
    [anon_sym_SLASH_EQ] = ACTIONS(6164),
    [anon_sym_PERCENT_EQ] = ACTIONS(6164),
    [anon_sym_PLUS_EQ] = ACTIONS(6164),
    [anon_sym_DASH_EQ] = ACTIONS(6164),
    [anon_sym_LT_LT_EQ] = ACTIONS(6164),
    [anon_sym_GT_GT_EQ] = ACTIONS(6164),
    [anon_sym_AMP_EQ] = ACTIONS(6164),
    [anon_sym_CARET_EQ] = ACTIONS(6164),
    [anon_sym_PIPE_EQ] = ACTIONS(6164),
    [anon_sym_and_eq] = ACTIONS(6162),
    [anon_sym_or_eq] = ACTIONS(6162),
    [anon_sym_xor_eq] = ACTIONS(6162),
    [anon_sym_LT_EQ_GT] = ACTIONS(6164),
    [anon_sym_or] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(6162),
    [anon_sym_bitor] = ACTIONS(6162),
    [anon_sym_xor] = ACTIONS(6162),
    [anon_sym_bitand] = ACTIONS(6162),
    [anon_sym_not_eq] = ACTIONS(6162),
    [anon_sym_DASH_DASH] = ACTIONS(6164),
    [anon_sym_PLUS_PLUS] = ACTIONS(6164),
    [anon_sym_DOT] = ACTIONS(6162),
    [anon_sym_DOT_STAR] = ACTIONS(6164),
    [anon_sym_DASH_GT] = ACTIONS(6164),
    [sym_comment] = ACTIONS(3),
  },
  [2730] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2761),
    [sym_identifier] = ACTIONS(6034),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6032),
    [anon_sym_COMMA] = ACTIONS(6032),
    [aux_sym_preproc_if_token2] = ACTIONS(6032),
    [aux_sym_preproc_else_token1] = ACTIONS(6032),
    [aux_sym_preproc_elif_token1] = ACTIONS(6034),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6032),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6032),
    [anon_sym_LPAREN2] = ACTIONS(6032),
    [anon_sym_DASH] = ACTIONS(6034),
    [anon_sym_PLUS] = ACTIONS(6034),
    [anon_sym_STAR] = ACTIONS(6034),
    [anon_sym_SLASH] = ACTIONS(6034),
    [anon_sym_PERCENT] = ACTIONS(6034),
    [anon_sym_PIPE_PIPE] = ACTIONS(6032),
    [anon_sym_AMP_AMP] = ACTIONS(6032),
    [anon_sym_PIPE] = ACTIONS(6034),
    [anon_sym_CARET] = ACTIONS(6034),
    [anon_sym_AMP] = ACTIONS(6034),
    [anon_sym_EQ_EQ] = ACTIONS(6032),
    [anon_sym_BANG_EQ] = ACTIONS(6032),
    [anon_sym_GT] = ACTIONS(6034),
    [anon_sym_GT_EQ] = ACTIONS(6032),
    [anon_sym_LT_EQ] = ACTIONS(6034),
    [anon_sym_LT] = ACTIONS(6034),
    [anon_sym_LT_LT] = ACTIONS(6034),
    [anon_sym_GT_GT] = ACTIONS(6034),
    [anon_sym___attribute__] = ACTIONS(6034),
    [anon_sym_LBRACE] = ACTIONS(6032),
    [anon_sym_signed] = ACTIONS(6156),
    [anon_sym_unsigned] = ACTIONS(6156),
    [anon_sym_long] = ACTIONS(6156),
    [anon_sym_short] = ACTIONS(6156),
    [anon_sym_LBRACK] = ACTIONS(6032),
    [anon_sym_EQ] = ACTIONS(6034),
    [anon_sym_QMARK] = ACTIONS(6032),
    [anon_sym_STAR_EQ] = ACTIONS(6032),
    [anon_sym_SLASH_EQ] = ACTIONS(6032),
    [anon_sym_PERCENT_EQ] = ACTIONS(6032),
    [anon_sym_PLUS_EQ] = ACTIONS(6032),
    [anon_sym_DASH_EQ] = ACTIONS(6032),
    [anon_sym_LT_LT_EQ] = ACTIONS(6032),
    [anon_sym_GT_GT_EQ] = ACTIONS(6032),
    [anon_sym_AMP_EQ] = ACTIONS(6032),
    [anon_sym_CARET_EQ] = ACTIONS(6032),
    [anon_sym_PIPE_EQ] = ACTIONS(6032),
    [anon_sym_and_eq] = ACTIONS(6034),
    [anon_sym_or_eq] = ACTIONS(6034),
    [anon_sym_xor_eq] = ACTIONS(6034),
    [anon_sym_LT_EQ_GT] = ACTIONS(6032),
    [anon_sym_or] = ACTIONS(6034),
    [anon_sym_and] = ACTIONS(6034),
    [anon_sym_bitor] = ACTIONS(6034),
    [anon_sym_xor] = ACTIONS(6034),
    [anon_sym_bitand] = ACTIONS(6034),
    [anon_sym_not_eq] = ACTIONS(6034),
    [anon_sym_DASH_DASH] = ACTIONS(6032),
    [anon_sym_PLUS_PLUS] = ACTIONS(6032),
    [anon_sym_DOT] = ACTIONS(6034),
    [anon_sym_DOT_STAR] = ACTIONS(6032),
    [anon_sym_DASH_GT] = ACTIONS(6032),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6034),
    [anon_sym_decltype] = ACTIONS(6034),
  },
  [2731] = {
    [sym_identifier] = ACTIONS(6166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6168),
    [anon_sym_COMMA] = ACTIONS(6168),
    [anon_sym_RPAREN] = ACTIONS(6168),
    [aux_sym_preproc_if_token2] = ACTIONS(6168),
    [aux_sym_preproc_else_token1] = ACTIONS(6168),
    [aux_sym_preproc_elif_token1] = ACTIONS(6166),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6168),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6168),
    [anon_sym_LPAREN2] = ACTIONS(6168),
    [anon_sym_DASH] = ACTIONS(6166),
    [anon_sym_PLUS] = ACTIONS(6166),
    [anon_sym_STAR] = ACTIONS(6166),
    [anon_sym_SLASH] = ACTIONS(6166),
    [anon_sym_PERCENT] = ACTIONS(6166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6168),
    [anon_sym_AMP_AMP] = ACTIONS(6168),
    [anon_sym_PIPE] = ACTIONS(6166),
    [anon_sym_CARET] = ACTIONS(6166),
    [anon_sym_AMP] = ACTIONS(6166),
    [anon_sym_EQ_EQ] = ACTIONS(6168),
    [anon_sym_BANG_EQ] = ACTIONS(6168),
    [anon_sym_GT] = ACTIONS(6166),
    [anon_sym_GT_EQ] = ACTIONS(6168),
    [anon_sym_LT_EQ] = ACTIONS(6166),
    [anon_sym_LT] = ACTIONS(6166),
    [anon_sym_LT_LT] = ACTIONS(6166),
    [anon_sym_GT_GT] = ACTIONS(6166),
    [anon_sym_SEMI] = ACTIONS(6168),
    [anon_sym___attribute__] = ACTIONS(6166),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6168),
    [anon_sym_LBRACE] = ACTIONS(6168),
    [anon_sym_RBRACE] = ACTIONS(6168),
    [anon_sym_LBRACK] = ACTIONS(6166),
    [anon_sym_RBRACK] = ACTIONS(6168),
    [anon_sym_EQ] = ACTIONS(6166),
    [anon_sym_COLON] = ACTIONS(6168),
    [anon_sym_QMARK] = ACTIONS(6168),
    [anon_sym_STAR_EQ] = ACTIONS(6168),
    [anon_sym_SLASH_EQ] = ACTIONS(6168),
    [anon_sym_PERCENT_EQ] = ACTIONS(6168),
    [anon_sym_PLUS_EQ] = ACTIONS(6168),
    [anon_sym_DASH_EQ] = ACTIONS(6168),
    [anon_sym_LT_LT_EQ] = ACTIONS(6168),
    [anon_sym_GT_GT_EQ] = ACTIONS(6168),
    [anon_sym_AMP_EQ] = ACTIONS(6168),
    [anon_sym_CARET_EQ] = ACTIONS(6168),
    [anon_sym_PIPE_EQ] = ACTIONS(6168),
    [anon_sym_and_eq] = ACTIONS(6166),
    [anon_sym_or_eq] = ACTIONS(6166),
    [anon_sym_xor_eq] = ACTIONS(6166),
    [anon_sym_LT_EQ_GT] = ACTIONS(6168),
    [anon_sym_or] = ACTIONS(6166),
    [anon_sym_and] = ACTIONS(6166),
    [anon_sym_bitor] = ACTIONS(6166),
    [anon_sym_xor] = ACTIONS(6166),
    [anon_sym_bitand] = ACTIONS(6166),
    [anon_sym_not_eq] = ACTIONS(6166),
    [anon_sym_DASH_DASH] = ACTIONS(6168),
    [anon_sym_PLUS_PLUS] = ACTIONS(6168),
    [anon_sym_DOT] = ACTIONS(6166),
    [anon_sym_DOT_STAR] = ACTIONS(6168),
    [anon_sym_DASH_GT] = ACTIONS(6168),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6166),
  },
  [2732] = {
    [sym_identifier] = ACTIONS(5700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5702),
    [anon_sym_COMMA] = ACTIONS(5702),
    [anon_sym_RPAREN] = ACTIONS(5702),
    [aux_sym_preproc_if_token2] = ACTIONS(5702),
    [aux_sym_preproc_else_token1] = ACTIONS(5702),
    [aux_sym_preproc_elif_token1] = ACTIONS(5700),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5702),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5702),
    [anon_sym_LPAREN2] = ACTIONS(5702),
    [anon_sym_DASH] = ACTIONS(5700),
    [anon_sym_PLUS] = ACTIONS(5700),
    [anon_sym_STAR] = ACTIONS(5700),
    [anon_sym_SLASH] = ACTIONS(5700),
    [anon_sym_PERCENT] = ACTIONS(5700),
    [anon_sym_PIPE_PIPE] = ACTIONS(5702),
    [anon_sym_AMP_AMP] = ACTIONS(5702),
    [anon_sym_PIPE] = ACTIONS(5700),
    [anon_sym_CARET] = ACTIONS(5700),
    [anon_sym_AMP] = ACTIONS(5700),
    [anon_sym_EQ_EQ] = ACTIONS(5702),
    [anon_sym_BANG_EQ] = ACTIONS(5702),
    [anon_sym_GT] = ACTIONS(5700),
    [anon_sym_GT_EQ] = ACTIONS(5702),
    [anon_sym_LT_EQ] = ACTIONS(5700),
    [anon_sym_LT] = ACTIONS(5700),
    [anon_sym_LT_LT] = ACTIONS(5700),
    [anon_sym_GT_GT] = ACTIONS(5700),
    [anon_sym_SEMI] = ACTIONS(5702),
    [anon_sym___attribute__] = ACTIONS(5700),
    [anon_sym_LBRACE] = ACTIONS(5702),
    [anon_sym_RBRACE] = ACTIONS(5702),
    [anon_sym_LBRACK] = ACTIONS(5702),
    [anon_sym_RBRACK] = ACTIONS(5702),
    [anon_sym_EQ] = ACTIONS(5700),
    [anon_sym_COLON] = ACTIONS(5702),
    [anon_sym_QMARK] = ACTIONS(5702),
    [anon_sym_STAR_EQ] = ACTIONS(5702),
    [anon_sym_SLASH_EQ] = ACTIONS(5702),
    [anon_sym_PERCENT_EQ] = ACTIONS(5702),
    [anon_sym_PLUS_EQ] = ACTIONS(5702),
    [anon_sym_DASH_EQ] = ACTIONS(5702),
    [anon_sym_LT_LT_EQ] = ACTIONS(5702),
    [anon_sym_GT_GT_EQ] = ACTIONS(5702),
    [anon_sym_AMP_EQ] = ACTIONS(5702),
    [anon_sym_CARET_EQ] = ACTIONS(5702),
    [anon_sym_PIPE_EQ] = ACTIONS(5702),
    [anon_sym_and_eq] = ACTIONS(5700),
    [anon_sym_or_eq] = ACTIONS(5700),
    [anon_sym_xor_eq] = ACTIONS(5700),
    [anon_sym_LT_EQ_GT] = ACTIONS(5702),
    [anon_sym_or] = ACTIONS(5700),
    [anon_sym_and] = ACTIONS(5700),
    [anon_sym_bitor] = ACTIONS(5700),
    [anon_sym_xor] = ACTIONS(5700),
    [anon_sym_bitand] = ACTIONS(5700),
    [anon_sym_not_eq] = ACTIONS(5700),
    [anon_sym_DASH_DASH] = ACTIONS(5702),
    [anon_sym_PLUS_PLUS] = ACTIONS(5702),
    [anon_sym_DOT] = ACTIONS(5700),
    [anon_sym_DOT_STAR] = ACTIONS(5702),
    [anon_sym_DASH_GT] = ACTIONS(5702),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5700),
    [anon_sym_decltype] = ACTIONS(5700),
  },
  [2733] = {
    [sym_identifier] = ACTIONS(6170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6172),
    [anon_sym_COMMA] = ACTIONS(6172),
    [anon_sym_RPAREN] = ACTIONS(6172),
    [aux_sym_preproc_if_token2] = ACTIONS(6172),
    [aux_sym_preproc_else_token1] = ACTIONS(6172),
    [aux_sym_preproc_elif_token1] = ACTIONS(6170),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6172),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6172),
    [anon_sym_LPAREN2] = ACTIONS(6172),
    [anon_sym_DASH] = ACTIONS(6170),
    [anon_sym_PLUS] = ACTIONS(6170),
    [anon_sym_STAR] = ACTIONS(6170),
    [anon_sym_SLASH] = ACTIONS(6170),
    [anon_sym_PERCENT] = ACTIONS(6170),
    [anon_sym_PIPE_PIPE] = ACTIONS(6172),
    [anon_sym_AMP_AMP] = ACTIONS(6172),
    [anon_sym_PIPE] = ACTIONS(6170),
    [anon_sym_CARET] = ACTIONS(6170),
    [anon_sym_AMP] = ACTIONS(6170),
    [anon_sym_EQ_EQ] = ACTIONS(6172),
    [anon_sym_BANG_EQ] = ACTIONS(6172),
    [anon_sym_GT] = ACTIONS(6170),
    [anon_sym_GT_EQ] = ACTIONS(6172),
    [anon_sym_LT_EQ] = ACTIONS(6170),
    [anon_sym_LT] = ACTIONS(6170),
    [anon_sym_LT_LT] = ACTIONS(6170),
    [anon_sym_GT_GT] = ACTIONS(6170),
    [anon_sym_SEMI] = ACTIONS(6172),
    [anon_sym___attribute__] = ACTIONS(6170),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6172),
    [anon_sym_LBRACE] = ACTIONS(6172),
    [anon_sym_RBRACE] = ACTIONS(6172),
    [anon_sym_LBRACK] = ACTIONS(6170),
    [anon_sym_RBRACK] = ACTIONS(6172),
    [anon_sym_EQ] = ACTIONS(6170),
    [anon_sym_COLON] = ACTIONS(6172),
    [anon_sym_QMARK] = ACTIONS(6172),
    [anon_sym_STAR_EQ] = ACTIONS(6172),
    [anon_sym_SLASH_EQ] = ACTIONS(6172),
    [anon_sym_PERCENT_EQ] = ACTIONS(6172),
    [anon_sym_PLUS_EQ] = ACTIONS(6172),
    [anon_sym_DASH_EQ] = ACTIONS(6172),
    [anon_sym_LT_LT_EQ] = ACTIONS(6172),
    [anon_sym_GT_GT_EQ] = ACTIONS(6172),
    [anon_sym_AMP_EQ] = ACTIONS(6172),
    [anon_sym_CARET_EQ] = ACTIONS(6172),
    [anon_sym_PIPE_EQ] = ACTIONS(6172),
    [anon_sym_and_eq] = ACTIONS(6170),
    [anon_sym_or_eq] = ACTIONS(6170),
    [anon_sym_xor_eq] = ACTIONS(6170),
    [anon_sym_LT_EQ_GT] = ACTIONS(6172),
    [anon_sym_or] = ACTIONS(6170),
    [anon_sym_and] = ACTIONS(6170),
    [anon_sym_bitor] = ACTIONS(6170),
    [anon_sym_xor] = ACTIONS(6170),
    [anon_sym_bitand] = ACTIONS(6170),
    [anon_sym_not_eq] = ACTIONS(6170),
    [anon_sym_DASH_DASH] = ACTIONS(6172),
    [anon_sym_PLUS_PLUS] = ACTIONS(6172),
    [anon_sym_DOT] = ACTIONS(6170),
    [anon_sym_DOT_STAR] = ACTIONS(6172),
    [anon_sym_DASH_GT] = ACTIONS(6172),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6170),
  },
  [2734] = {
    [sym_identifier] = ACTIONS(6174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6176),
    [anon_sym_COMMA] = ACTIONS(6176),
    [anon_sym_RPAREN] = ACTIONS(6176),
    [aux_sym_preproc_if_token2] = ACTIONS(6176),
    [aux_sym_preproc_else_token1] = ACTIONS(6176),
    [aux_sym_preproc_elif_token1] = ACTIONS(6174),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6176),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6176),
    [anon_sym_LPAREN2] = ACTIONS(6176),
    [anon_sym_DASH] = ACTIONS(6174),
    [anon_sym_PLUS] = ACTIONS(6174),
    [anon_sym_STAR] = ACTIONS(6174),
    [anon_sym_SLASH] = ACTIONS(6174),
    [anon_sym_PERCENT] = ACTIONS(6174),
    [anon_sym_PIPE_PIPE] = ACTIONS(6176),
    [anon_sym_AMP_AMP] = ACTIONS(6176),
    [anon_sym_PIPE] = ACTIONS(6174),
    [anon_sym_CARET] = ACTIONS(6174),
    [anon_sym_AMP] = ACTIONS(6174),
    [anon_sym_EQ_EQ] = ACTIONS(6176),
    [anon_sym_BANG_EQ] = ACTIONS(6176),
    [anon_sym_GT] = ACTIONS(6174),
    [anon_sym_GT_EQ] = ACTIONS(6176),
    [anon_sym_LT_EQ] = ACTIONS(6174),
    [anon_sym_LT] = ACTIONS(6174),
    [anon_sym_LT_LT] = ACTIONS(6174),
    [anon_sym_GT_GT] = ACTIONS(6174),
    [anon_sym_SEMI] = ACTIONS(6176),
    [anon_sym___attribute__] = ACTIONS(6174),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6176),
    [anon_sym_LBRACE] = ACTIONS(6176),
    [anon_sym_RBRACE] = ACTIONS(6176),
    [anon_sym_LBRACK] = ACTIONS(6174),
    [anon_sym_RBRACK] = ACTIONS(6176),
    [anon_sym_EQ] = ACTIONS(6174),
    [anon_sym_COLON] = ACTIONS(6176),
    [anon_sym_QMARK] = ACTIONS(6176),
    [anon_sym_STAR_EQ] = ACTIONS(6176),
    [anon_sym_SLASH_EQ] = ACTIONS(6176),
    [anon_sym_PERCENT_EQ] = ACTIONS(6176),
    [anon_sym_PLUS_EQ] = ACTIONS(6176),
    [anon_sym_DASH_EQ] = ACTIONS(6176),
    [anon_sym_LT_LT_EQ] = ACTIONS(6176),
    [anon_sym_GT_GT_EQ] = ACTIONS(6176),
    [anon_sym_AMP_EQ] = ACTIONS(6176),
    [anon_sym_CARET_EQ] = ACTIONS(6176),
    [anon_sym_PIPE_EQ] = ACTIONS(6176),
    [anon_sym_and_eq] = ACTIONS(6174),
    [anon_sym_or_eq] = ACTIONS(6174),
    [anon_sym_xor_eq] = ACTIONS(6174),
    [anon_sym_LT_EQ_GT] = ACTIONS(6176),
    [anon_sym_or] = ACTIONS(6174),
    [anon_sym_and] = ACTIONS(6174),
    [anon_sym_bitor] = ACTIONS(6174),
    [anon_sym_xor] = ACTIONS(6174),
    [anon_sym_bitand] = ACTIONS(6174),
    [anon_sym_not_eq] = ACTIONS(6174),
    [anon_sym_DASH_DASH] = ACTIONS(6176),
    [anon_sym_PLUS_PLUS] = ACTIONS(6176),
    [anon_sym_DOT] = ACTIONS(6174),
    [anon_sym_DOT_STAR] = ACTIONS(6176),
    [anon_sym_DASH_GT] = ACTIONS(6176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6174),
  },
  [2735] = {
    [sym_identifier] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5706),
    [anon_sym_COMMA] = ACTIONS(5706),
    [anon_sym_RPAREN] = ACTIONS(5706),
    [aux_sym_preproc_if_token2] = ACTIONS(5706),
    [aux_sym_preproc_else_token1] = ACTIONS(5706),
    [aux_sym_preproc_elif_token1] = ACTIONS(5704),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5706),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5706),
    [anon_sym_LPAREN2] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5704),
    [anon_sym_STAR] = ACTIONS(5704),
    [anon_sym_SLASH] = ACTIONS(5704),
    [anon_sym_PERCENT] = ACTIONS(5704),
    [anon_sym_PIPE_PIPE] = ACTIONS(5706),
    [anon_sym_AMP_AMP] = ACTIONS(5706),
    [anon_sym_PIPE] = ACTIONS(5704),
    [anon_sym_CARET] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(5704),
    [anon_sym_EQ_EQ] = ACTIONS(5706),
    [anon_sym_BANG_EQ] = ACTIONS(5706),
    [anon_sym_GT] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5704),
    [anon_sym_LT_LT] = ACTIONS(5704),
    [anon_sym_GT_GT] = ACTIONS(5704),
    [anon_sym_SEMI] = ACTIONS(5706),
    [anon_sym___attribute__] = ACTIONS(5704),
    [anon_sym_LBRACE] = ACTIONS(5706),
    [anon_sym_RBRACE] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_RBRACK] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5704),
    [anon_sym_COLON] = ACTIONS(5706),
    [anon_sym_QMARK] = ACTIONS(5706),
    [anon_sym_STAR_EQ] = ACTIONS(5706),
    [anon_sym_SLASH_EQ] = ACTIONS(5706),
    [anon_sym_PERCENT_EQ] = ACTIONS(5706),
    [anon_sym_PLUS_EQ] = ACTIONS(5706),
    [anon_sym_DASH_EQ] = ACTIONS(5706),
    [anon_sym_LT_LT_EQ] = ACTIONS(5706),
    [anon_sym_GT_GT_EQ] = ACTIONS(5706),
    [anon_sym_AMP_EQ] = ACTIONS(5706),
    [anon_sym_CARET_EQ] = ACTIONS(5706),
    [anon_sym_PIPE_EQ] = ACTIONS(5706),
    [anon_sym_and_eq] = ACTIONS(5704),
    [anon_sym_or_eq] = ACTIONS(5704),
    [anon_sym_xor_eq] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5706),
    [anon_sym_or] = ACTIONS(5704),
    [anon_sym_and] = ACTIONS(5704),
    [anon_sym_bitor] = ACTIONS(5704),
    [anon_sym_xor] = ACTIONS(5704),
    [anon_sym_bitand] = ACTIONS(5704),
    [anon_sym_not_eq] = ACTIONS(5704),
    [anon_sym_DASH_DASH] = ACTIONS(5706),
    [anon_sym_PLUS_PLUS] = ACTIONS(5706),
    [anon_sym_DOT] = ACTIONS(5704),
    [anon_sym_DOT_STAR] = ACTIONS(5706),
    [anon_sym_DASH_GT] = ACTIONS(5706),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5704),
    [anon_sym_decltype] = ACTIONS(5704),
  },
  [2736] = {
    [sym_argument_list] = STATE(2945),
    [sym_initializer_list] = STATE(2945),
    [sym_identifier] = ACTIONS(6178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6180),
    [anon_sym_COMMA] = ACTIONS(6180),
    [anon_sym_RPAREN] = ACTIONS(6180),
    [aux_sym_preproc_if_token2] = ACTIONS(6180),
    [aux_sym_preproc_else_token1] = ACTIONS(6180),
    [aux_sym_preproc_elif_token1] = ACTIONS(6178),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6180),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6180),
    [anon_sym_LPAREN2] = ACTIONS(5813),
    [anon_sym_DASH] = ACTIONS(6178),
    [anon_sym_PLUS] = ACTIONS(6178),
    [anon_sym_STAR] = ACTIONS(6178),
    [anon_sym_SLASH] = ACTIONS(6178),
    [anon_sym_PERCENT] = ACTIONS(6178),
    [anon_sym_PIPE_PIPE] = ACTIONS(6180),
    [anon_sym_AMP_AMP] = ACTIONS(6180),
    [anon_sym_PIPE] = ACTIONS(6178),
    [anon_sym_CARET] = ACTIONS(6178),
    [anon_sym_AMP] = ACTIONS(6178),
    [anon_sym_EQ_EQ] = ACTIONS(6180),
    [anon_sym_BANG_EQ] = ACTIONS(6180),
    [anon_sym_GT] = ACTIONS(6178),
    [anon_sym_GT_EQ] = ACTIONS(6180),
    [anon_sym_LT_EQ] = ACTIONS(6178),
    [anon_sym_LT] = ACTIONS(6178),
    [anon_sym_LT_LT] = ACTIONS(6178),
    [anon_sym_GT_GT] = ACTIONS(6178),
    [anon_sym_SEMI] = ACTIONS(6180),
    [anon_sym___attribute__] = ACTIONS(6178),
    [anon_sym_LBRACE] = ACTIONS(2159),
    [anon_sym_RBRACE] = ACTIONS(6180),
    [anon_sym_LBRACK] = ACTIONS(6180),
    [anon_sym_RBRACK] = ACTIONS(6180),
    [anon_sym_EQ] = ACTIONS(6178),
    [anon_sym_COLON] = ACTIONS(6180),
    [anon_sym_QMARK] = ACTIONS(6180),
    [anon_sym_STAR_EQ] = ACTIONS(6180),
    [anon_sym_SLASH_EQ] = ACTIONS(6180),
    [anon_sym_PERCENT_EQ] = ACTIONS(6180),
    [anon_sym_PLUS_EQ] = ACTIONS(6180),
    [anon_sym_DASH_EQ] = ACTIONS(6180),
    [anon_sym_LT_LT_EQ] = ACTIONS(6180),
    [anon_sym_GT_GT_EQ] = ACTIONS(6180),
    [anon_sym_AMP_EQ] = ACTIONS(6180),
    [anon_sym_CARET_EQ] = ACTIONS(6180),
    [anon_sym_PIPE_EQ] = ACTIONS(6180),
    [anon_sym_and_eq] = ACTIONS(6178),
    [anon_sym_or_eq] = ACTIONS(6178),
    [anon_sym_xor_eq] = ACTIONS(6178),
    [anon_sym_LT_EQ_GT] = ACTIONS(6180),
    [anon_sym_or] = ACTIONS(6178),
    [anon_sym_and] = ACTIONS(6178),
    [anon_sym_bitor] = ACTIONS(6178),
    [anon_sym_xor] = ACTIONS(6178),
    [anon_sym_bitand] = ACTIONS(6178),
    [anon_sym_not_eq] = ACTIONS(6178),
    [anon_sym_DASH_DASH] = ACTIONS(6180),
    [anon_sym_PLUS_PLUS] = ACTIONS(6180),
    [anon_sym_DOT] = ACTIONS(6178),
    [anon_sym_DOT_STAR] = ACTIONS(6180),
    [anon_sym_DASH_GT] = ACTIONS(6180),
    [sym_comment] = ACTIONS(3),
  },
  [2737] = {
    [sym_identifier] = ACTIONS(5638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5640),
    [anon_sym_COMMA] = ACTIONS(5640),
    [anon_sym_RPAREN] = ACTIONS(5640),
    [aux_sym_preproc_if_token2] = ACTIONS(5640),
    [aux_sym_preproc_else_token1] = ACTIONS(5640),
    [aux_sym_preproc_elif_token1] = ACTIONS(5638),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5640),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5640),
    [anon_sym_LPAREN2] = ACTIONS(5640),
    [anon_sym_DASH] = ACTIONS(5638),
    [anon_sym_PLUS] = ACTIONS(5638),
    [anon_sym_STAR] = ACTIONS(5638),
    [anon_sym_SLASH] = ACTIONS(5638),
    [anon_sym_PERCENT] = ACTIONS(5638),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE] = ACTIONS(5638),
    [anon_sym_CARET] = ACTIONS(5638),
    [anon_sym_AMP] = ACTIONS(5638),
    [anon_sym_EQ_EQ] = ACTIONS(5640),
    [anon_sym_BANG_EQ] = ACTIONS(5640),
    [anon_sym_GT] = ACTIONS(5638),
    [anon_sym_GT_EQ] = ACTIONS(5640),
    [anon_sym_LT_EQ] = ACTIONS(5638),
    [anon_sym_LT] = ACTIONS(5638),
    [anon_sym_LT_LT] = ACTIONS(5638),
    [anon_sym_GT_GT] = ACTIONS(5638),
    [anon_sym_SEMI] = ACTIONS(5640),
    [anon_sym___attribute__] = ACTIONS(5638),
    [anon_sym_LBRACE] = ACTIONS(5640),
    [anon_sym_RBRACE] = ACTIONS(5640),
    [anon_sym_LBRACK] = ACTIONS(5640),
    [anon_sym_RBRACK] = ACTIONS(5640),
    [anon_sym_EQ] = ACTIONS(5638),
    [anon_sym_COLON] = ACTIONS(5640),
    [anon_sym_QMARK] = ACTIONS(5640),
    [anon_sym_STAR_EQ] = ACTIONS(5640),
    [anon_sym_SLASH_EQ] = ACTIONS(5640),
    [anon_sym_PERCENT_EQ] = ACTIONS(5640),
    [anon_sym_PLUS_EQ] = ACTIONS(5640),
    [anon_sym_DASH_EQ] = ACTIONS(5640),
    [anon_sym_LT_LT_EQ] = ACTIONS(5640),
    [anon_sym_GT_GT_EQ] = ACTIONS(5640),
    [anon_sym_AMP_EQ] = ACTIONS(5640),
    [anon_sym_CARET_EQ] = ACTIONS(5640),
    [anon_sym_PIPE_EQ] = ACTIONS(5640),
    [anon_sym_and_eq] = ACTIONS(5638),
    [anon_sym_or_eq] = ACTIONS(5638),
    [anon_sym_xor_eq] = ACTIONS(5638),
    [anon_sym_LT_EQ_GT] = ACTIONS(5640),
    [anon_sym_or] = ACTIONS(5638),
    [anon_sym_and] = ACTIONS(5638),
    [anon_sym_bitor] = ACTIONS(5638),
    [anon_sym_xor] = ACTIONS(5638),
    [anon_sym_bitand] = ACTIONS(5638),
    [anon_sym_not_eq] = ACTIONS(5638),
    [anon_sym_DASH_DASH] = ACTIONS(5640),
    [anon_sym_PLUS_PLUS] = ACTIONS(5640),
    [anon_sym_DOT] = ACTIONS(5638),
    [anon_sym_DOT_STAR] = ACTIONS(5640),
    [anon_sym_DASH_GT] = ACTIONS(5640),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5638),
    [anon_sym_decltype] = ACTIONS(5638),
  },
  [2738] = {
    [sym_identifier] = ACTIONS(5638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5640),
    [anon_sym_COMMA] = ACTIONS(5640),
    [anon_sym_RPAREN] = ACTIONS(5640),
    [aux_sym_preproc_if_token2] = ACTIONS(5640),
    [aux_sym_preproc_else_token1] = ACTIONS(5640),
    [aux_sym_preproc_elif_token1] = ACTIONS(5638),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5640),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5640),
    [anon_sym_LPAREN2] = ACTIONS(5640),
    [anon_sym_DASH] = ACTIONS(5638),
    [anon_sym_PLUS] = ACTIONS(5638),
    [anon_sym_STAR] = ACTIONS(5638),
    [anon_sym_SLASH] = ACTIONS(5638),
    [anon_sym_PERCENT] = ACTIONS(5638),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE] = ACTIONS(5638),
    [anon_sym_CARET] = ACTIONS(5638),
    [anon_sym_AMP] = ACTIONS(5638),
    [anon_sym_EQ_EQ] = ACTIONS(5640),
    [anon_sym_BANG_EQ] = ACTIONS(5640),
    [anon_sym_GT] = ACTIONS(5638),
    [anon_sym_GT_EQ] = ACTIONS(5640),
    [anon_sym_LT_EQ] = ACTIONS(5638),
    [anon_sym_LT] = ACTIONS(5638),
    [anon_sym_LT_LT] = ACTIONS(5638),
    [anon_sym_GT_GT] = ACTIONS(5638),
    [anon_sym_SEMI] = ACTIONS(5640),
    [anon_sym___attribute__] = ACTIONS(5638),
    [anon_sym_LBRACE] = ACTIONS(5640),
    [anon_sym_RBRACE] = ACTIONS(5640),
    [anon_sym_LBRACK] = ACTIONS(5640),
    [anon_sym_RBRACK] = ACTIONS(5640),
    [anon_sym_EQ] = ACTIONS(5638),
    [anon_sym_COLON] = ACTIONS(5640),
    [anon_sym_QMARK] = ACTIONS(5640),
    [anon_sym_STAR_EQ] = ACTIONS(5640),
    [anon_sym_SLASH_EQ] = ACTIONS(5640),
    [anon_sym_PERCENT_EQ] = ACTIONS(5640),
    [anon_sym_PLUS_EQ] = ACTIONS(5640),
    [anon_sym_DASH_EQ] = ACTIONS(5640),
    [anon_sym_LT_LT_EQ] = ACTIONS(5640),
    [anon_sym_GT_GT_EQ] = ACTIONS(5640),
    [anon_sym_AMP_EQ] = ACTIONS(5640),
    [anon_sym_CARET_EQ] = ACTIONS(5640),
    [anon_sym_PIPE_EQ] = ACTIONS(5640),
    [anon_sym_and_eq] = ACTIONS(5638),
    [anon_sym_or_eq] = ACTIONS(5638),
    [anon_sym_xor_eq] = ACTIONS(5638),
    [anon_sym_LT_EQ_GT] = ACTIONS(5640),
    [anon_sym_or] = ACTIONS(5638),
    [anon_sym_and] = ACTIONS(5638),
    [anon_sym_bitor] = ACTIONS(5638),
    [anon_sym_xor] = ACTIONS(5638),
    [anon_sym_bitand] = ACTIONS(5638),
    [anon_sym_not_eq] = ACTIONS(5638),
    [anon_sym_DASH_DASH] = ACTIONS(5640),
    [anon_sym_PLUS_PLUS] = ACTIONS(5640),
    [anon_sym_DOT] = ACTIONS(5638),
    [anon_sym_DOT_STAR] = ACTIONS(5640),
    [anon_sym_DASH_GT] = ACTIONS(5640),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5638),
    [anon_sym_decltype] = ACTIONS(5638),
  },
  [2739] = {
    [sym_identifier] = ACTIONS(5642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5644),
    [anon_sym_COMMA] = ACTIONS(5644),
    [anon_sym_RPAREN] = ACTIONS(5644),
    [aux_sym_preproc_if_token2] = ACTIONS(5644),
    [aux_sym_preproc_else_token1] = ACTIONS(5644),
    [aux_sym_preproc_elif_token1] = ACTIONS(5642),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5644),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5644),
    [anon_sym_LPAREN2] = ACTIONS(5644),
    [anon_sym_DASH] = ACTIONS(5642),
    [anon_sym_PLUS] = ACTIONS(5642),
    [anon_sym_STAR] = ACTIONS(5642),
    [anon_sym_SLASH] = ACTIONS(5642),
    [anon_sym_PERCENT] = ACTIONS(5642),
    [anon_sym_PIPE_PIPE] = ACTIONS(5644),
    [anon_sym_AMP_AMP] = ACTIONS(5644),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_CARET] = ACTIONS(5642),
    [anon_sym_AMP] = ACTIONS(5642),
    [anon_sym_EQ_EQ] = ACTIONS(5644),
    [anon_sym_BANG_EQ] = ACTIONS(5644),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_EQ] = ACTIONS(5644),
    [anon_sym_LT_EQ] = ACTIONS(5642),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5642),
    [anon_sym_SEMI] = ACTIONS(5644),
    [anon_sym___attribute__] = ACTIONS(5642),
    [anon_sym_LBRACE] = ACTIONS(5644),
    [anon_sym_RBRACE] = ACTIONS(5644),
    [anon_sym_LBRACK] = ACTIONS(5644),
    [anon_sym_RBRACK] = ACTIONS(5644),
    [anon_sym_EQ] = ACTIONS(5642),
    [anon_sym_COLON] = ACTIONS(5644),
    [anon_sym_QMARK] = ACTIONS(5644),
    [anon_sym_STAR_EQ] = ACTIONS(5644),
    [anon_sym_SLASH_EQ] = ACTIONS(5644),
    [anon_sym_PERCENT_EQ] = ACTIONS(5644),
    [anon_sym_PLUS_EQ] = ACTIONS(5644),
    [anon_sym_DASH_EQ] = ACTIONS(5644),
    [anon_sym_LT_LT_EQ] = ACTIONS(5644),
    [anon_sym_GT_GT_EQ] = ACTIONS(5644),
    [anon_sym_AMP_EQ] = ACTIONS(5644),
    [anon_sym_CARET_EQ] = ACTIONS(5644),
    [anon_sym_PIPE_EQ] = ACTIONS(5644),
    [anon_sym_and_eq] = ACTIONS(5642),
    [anon_sym_or_eq] = ACTIONS(5642),
    [anon_sym_xor_eq] = ACTIONS(5642),
    [anon_sym_LT_EQ_GT] = ACTIONS(5644),
    [anon_sym_or] = ACTIONS(5642),
    [anon_sym_and] = ACTIONS(5642),
    [anon_sym_bitor] = ACTIONS(5642),
    [anon_sym_xor] = ACTIONS(5642),
    [anon_sym_bitand] = ACTIONS(5642),
    [anon_sym_not_eq] = ACTIONS(5642),
    [anon_sym_DASH_DASH] = ACTIONS(5644),
    [anon_sym_PLUS_PLUS] = ACTIONS(5644),
    [anon_sym_DOT] = ACTIONS(5642),
    [anon_sym_DOT_STAR] = ACTIONS(5644),
    [anon_sym_DASH_GT] = ACTIONS(5644),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5642),
    [anon_sym_decltype] = ACTIONS(5642),
  },
  [2740] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2761),
    [sym_identifier] = ACTIONS(6020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6018),
    [anon_sym_COMMA] = ACTIONS(6018),
    [aux_sym_preproc_if_token2] = ACTIONS(6018),
    [aux_sym_preproc_else_token1] = ACTIONS(6018),
    [aux_sym_preproc_elif_token1] = ACTIONS(6020),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6018),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6018),
    [anon_sym_LPAREN2] = ACTIONS(6018),
    [anon_sym_DASH] = ACTIONS(6020),
    [anon_sym_PLUS] = ACTIONS(6020),
    [anon_sym_STAR] = ACTIONS(6020),
    [anon_sym_SLASH] = ACTIONS(6020),
    [anon_sym_PERCENT] = ACTIONS(6020),
    [anon_sym_PIPE_PIPE] = ACTIONS(6018),
    [anon_sym_AMP_AMP] = ACTIONS(6018),
    [anon_sym_PIPE] = ACTIONS(6020),
    [anon_sym_CARET] = ACTIONS(6020),
    [anon_sym_AMP] = ACTIONS(6020),
    [anon_sym_EQ_EQ] = ACTIONS(6018),
    [anon_sym_BANG_EQ] = ACTIONS(6018),
    [anon_sym_GT] = ACTIONS(6020),
    [anon_sym_GT_EQ] = ACTIONS(6018),
    [anon_sym_LT_EQ] = ACTIONS(6020),
    [anon_sym_LT] = ACTIONS(6020),
    [anon_sym_LT_LT] = ACTIONS(6020),
    [anon_sym_GT_GT] = ACTIONS(6020),
    [anon_sym___attribute__] = ACTIONS(6020),
    [anon_sym_LBRACE] = ACTIONS(6018),
    [anon_sym_signed] = ACTIONS(6156),
    [anon_sym_unsigned] = ACTIONS(6156),
    [anon_sym_long] = ACTIONS(6156),
    [anon_sym_short] = ACTIONS(6156),
    [anon_sym_LBRACK] = ACTIONS(6018),
    [anon_sym_EQ] = ACTIONS(6020),
    [anon_sym_QMARK] = ACTIONS(6018),
    [anon_sym_STAR_EQ] = ACTIONS(6018),
    [anon_sym_SLASH_EQ] = ACTIONS(6018),
    [anon_sym_PERCENT_EQ] = ACTIONS(6018),
    [anon_sym_PLUS_EQ] = ACTIONS(6018),
    [anon_sym_DASH_EQ] = ACTIONS(6018),
    [anon_sym_LT_LT_EQ] = ACTIONS(6018),
    [anon_sym_GT_GT_EQ] = ACTIONS(6018),
    [anon_sym_AMP_EQ] = ACTIONS(6018),
    [anon_sym_CARET_EQ] = ACTIONS(6018),
    [anon_sym_PIPE_EQ] = ACTIONS(6018),
    [anon_sym_and_eq] = ACTIONS(6020),
    [anon_sym_or_eq] = ACTIONS(6020),
    [anon_sym_xor_eq] = ACTIONS(6020),
    [anon_sym_LT_EQ_GT] = ACTIONS(6018),
    [anon_sym_or] = ACTIONS(6020),
    [anon_sym_and] = ACTIONS(6020),
    [anon_sym_bitor] = ACTIONS(6020),
    [anon_sym_xor] = ACTIONS(6020),
    [anon_sym_bitand] = ACTIONS(6020),
    [anon_sym_not_eq] = ACTIONS(6020),
    [anon_sym_DASH_DASH] = ACTIONS(6018),
    [anon_sym_PLUS_PLUS] = ACTIONS(6018),
    [anon_sym_DOT] = ACTIONS(6020),
    [anon_sym_DOT_STAR] = ACTIONS(6018),
    [anon_sym_DASH_GT] = ACTIONS(6018),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6020),
    [anon_sym_decltype] = ACTIONS(6020),
  },
  [2741] = {
    [sym_identifier] = ACTIONS(5646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5648),
    [anon_sym_COMMA] = ACTIONS(5648),
    [anon_sym_RPAREN] = ACTIONS(5648),
    [aux_sym_preproc_if_token2] = ACTIONS(5648),
    [aux_sym_preproc_else_token1] = ACTIONS(5648),
    [aux_sym_preproc_elif_token1] = ACTIONS(5646),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5648),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5648),
    [anon_sym_LPAREN2] = ACTIONS(5648),
    [anon_sym_DASH] = ACTIONS(5646),
    [anon_sym_PLUS] = ACTIONS(5646),
    [anon_sym_STAR] = ACTIONS(5646),
    [anon_sym_SLASH] = ACTIONS(5646),
    [anon_sym_PERCENT] = ACTIONS(5646),
    [anon_sym_PIPE_PIPE] = ACTIONS(5648),
    [anon_sym_AMP_AMP] = ACTIONS(5648),
    [anon_sym_PIPE] = ACTIONS(5646),
    [anon_sym_CARET] = ACTIONS(5646),
    [anon_sym_AMP] = ACTIONS(5646),
    [anon_sym_EQ_EQ] = ACTIONS(5648),
    [anon_sym_BANG_EQ] = ACTIONS(5648),
    [anon_sym_GT] = ACTIONS(5646),
    [anon_sym_GT_EQ] = ACTIONS(5648),
    [anon_sym_LT_EQ] = ACTIONS(5646),
    [anon_sym_LT] = ACTIONS(5646),
    [anon_sym_LT_LT] = ACTIONS(5646),
    [anon_sym_GT_GT] = ACTIONS(5646),
    [anon_sym_SEMI] = ACTIONS(5648),
    [anon_sym___attribute__] = ACTIONS(5646),
    [anon_sym_LBRACE] = ACTIONS(5648),
    [anon_sym_RBRACE] = ACTIONS(5648),
    [anon_sym_LBRACK] = ACTIONS(5648),
    [anon_sym_RBRACK] = ACTIONS(5648),
    [anon_sym_EQ] = ACTIONS(5646),
    [anon_sym_COLON] = ACTIONS(5648),
    [anon_sym_QMARK] = ACTIONS(5648),
    [anon_sym_STAR_EQ] = ACTIONS(5648),
    [anon_sym_SLASH_EQ] = ACTIONS(5648),
    [anon_sym_PERCENT_EQ] = ACTIONS(5648),
    [anon_sym_PLUS_EQ] = ACTIONS(5648),
    [anon_sym_DASH_EQ] = ACTIONS(5648),
    [anon_sym_LT_LT_EQ] = ACTIONS(5648),
    [anon_sym_GT_GT_EQ] = ACTIONS(5648),
    [anon_sym_AMP_EQ] = ACTIONS(5648),
    [anon_sym_CARET_EQ] = ACTIONS(5648),
    [anon_sym_PIPE_EQ] = ACTIONS(5648),
    [anon_sym_and_eq] = ACTIONS(5646),
    [anon_sym_or_eq] = ACTIONS(5646),
    [anon_sym_xor_eq] = ACTIONS(5646),
    [anon_sym_LT_EQ_GT] = ACTIONS(5648),
    [anon_sym_or] = ACTIONS(5646),
    [anon_sym_and] = ACTIONS(5646),
    [anon_sym_bitor] = ACTIONS(5646),
    [anon_sym_xor] = ACTIONS(5646),
    [anon_sym_bitand] = ACTIONS(5646),
    [anon_sym_not_eq] = ACTIONS(5646),
    [anon_sym_DASH_DASH] = ACTIONS(5648),
    [anon_sym_PLUS_PLUS] = ACTIONS(5648),
    [anon_sym_DOT] = ACTIONS(5646),
    [anon_sym_DOT_STAR] = ACTIONS(5648),
    [anon_sym_DASH_GT] = ACTIONS(5648),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5646),
    [anon_sym_decltype] = ACTIONS(5646),
  },
  [2742] = {
    [sym_template_argument_list] = STATE(2840),
    [sym_identifier] = ACTIONS(5138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5131),
    [anon_sym_COMMA] = ACTIONS(5131),
    [anon_sym_RPAREN] = ACTIONS(5131),
    [aux_sym_preproc_if_token2] = ACTIONS(5131),
    [aux_sym_preproc_else_token1] = ACTIONS(5131),
    [aux_sym_preproc_elif_token1] = ACTIONS(5138),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5131),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5131),
    [anon_sym_LPAREN2] = ACTIONS(5131),
    [anon_sym_DASH] = ACTIONS(5138),
    [anon_sym_PLUS] = ACTIONS(5138),
    [anon_sym_STAR] = ACTIONS(5138),
    [anon_sym_SLASH] = ACTIONS(5138),
    [anon_sym_PERCENT] = ACTIONS(5138),
    [anon_sym_PIPE_PIPE] = ACTIONS(5131),
    [anon_sym_AMP_AMP] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5138),
    [anon_sym_CARET] = ACTIONS(5138),
    [anon_sym_AMP] = ACTIONS(5138),
    [anon_sym_EQ_EQ] = ACTIONS(5131),
    [anon_sym_BANG_EQ] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5138),
    [anon_sym_GT_EQ] = ACTIONS(5131),
    [anon_sym_LT_EQ] = ACTIONS(5138),
    [anon_sym_LT] = ACTIONS(6182),
    [anon_sym_LT_LT] = ACTIONS(5138),
    [anon_sym_GT_GT] = ACTIONS(5138),
    [anon_sym_SEMI] = ACTIONS(5131),
    [anon_sym___attribute__] = ACTIONS(5138),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_RBRACE] = ACTIONS(5131),
    [anon_sym_LBRACK] = ACTIONS(5131),
    [anon_sym_RBRACK] = ACTIONS(5131),
    [anon_sym_EQ] = ACTIONS(5138),
    [anon_sym_COLON] = ACTIONS(5138),
    [anon_sym_QMARK] = ACTIONS(5131),
    [anon_sym_STAR_EQ] = ACTIONS(5131),
    [anon_sym_SLASH_EQ] = ACTIONS(5131),
    [anon_sym_PERCENT_EQ] = ACTIONS(5131),
    [anon_sym_PLUS_EQ] = ACTIONS(5131),
    [anon_sym_DASH_EQ] = ACTIONS(5131),
    [anon_sym_LT_LT_EQ] = ACTIONS(5131),
    [anon_sym_GT_GT_EQ] = ACTIONS(5131),
    [anon_sym_AMP_EQ] = ACTIONS(5131),
    [anon_sym_CARET_EQ] = ACTIONS(5131),
    [anon_sym_PIPE_EQ] = ACTIONS(5131),
    [anon_sym_and_eq] = ACTIONS(5138),
    [anon_sym_or_eq] = ACTIONS(5138),
    [anon_sym_xor_eq] = ACTIONS(5138),
    [anon_sym_LT_EQ_GT] = ACTIONS(5131),
    [anon_sym_or] = ACTIONS(5138),
    [anon_sym_and] = ACTIONS(5138),
    [anon_sym_bitor] = ACTIONS(5138),
    [anon_sym_xor] = ACTIONS(5138),
    [anon_sym_bitand] = ACTIONS(5138),
    [anon_sym_not_eq] = ACTIONS(5138),
    [anon_sym_DASH_DASH] = ACTIONS(5131),
    [anon_sym_PLUS_PLUS] = ACTIONS(5131),
    [anon_sym_DOT] = ACTIONS(5138),
    [anon_sym_DOT_STAR] = ACTIONS(5131),
    [anon_sym_DASH_GT] = ACTIONS(5131),
    [sym_comment] = ACTIONS(3),
  },
  [2743] = {
    [sym_identifier] = ACTIONS(5481),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5483),
    [anon_sym_COMMA] = ACTIONS(5483),
    [anon_sym_RPAREN] = ACTIONS(5483),
    [aux_sym_preproc_if_token2] = ACTIONS(5483),
    [aux_sym_preproc_else_token1] = ACTIONS(5483),
    [aux_sym_preproc_elif_token1] = ACTIONS(5481),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5483),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5483),
    [anon_sym_LPAREN2] = ACTIONS(5483),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_PLUS] = ACTIONS(5481),
    [anon_sym_STAR] = ACTIONS(5481),
    [anon_sym_SLASH] = ACTIONS(5481),
    [anon_sym_PERCENT] = ACTIONS(5481),
    [anon_sym_PIPE_PIPE] = ACTIONS(5483),
    [anon_sym_AMP_AMP] = ACTIONS(5483),
    [anon_sym_PIPE] = ACTIONS(5481),
    [anon_sym_CARET] = ACTIONS(5481),
    [anon_sym_AMP] = ACTIONS(5481),
    [anon_sym_EQ_EQ] = ACTIONS(5483),
    [anon_sym_BANG_EQ] = ACTIONS(5483),
    [anon_sym_GT] = ACTIONS(5481),
    [anon_sym_GT_EQ] = ACTIONS(5483),
    [anon_sym_LT_EQ] = ACTIONS(5481),
    [anon_sym_LT] = ACTIONS(5481),
    [anon_sym_LT_LT] = ACTIONS(5481),
    [anon_sym_GT_GT] = ACTIONS(5481),
    [anon_sym_SEMI] = ACTIONS(5483),
    [anon_sym___attribute__] = ACTIONS(5481),
    [anon_sym_LBRACE] = ACTIONS(5483),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_LBRACK] = ACTIONS(5483),
    [anon_sym_RBRACK] = ACTIONS(5483),
    [anon_sym_EQ] = ACTIONS(5481),
    [anon_sym_COLON] = ACTIONS(5483),
    [anon_sym_QMARK] = ACTIONS(5483),
    [anon_sym_STAR_EQ] = ACTIONS(5483),
    [anon_sym_SLASH_EQ] = ACTIONS(5483),
    [anon_sym_PERCENT_EQ] = ACTIONS(5483),
    [anon_sym_PLUS_EQ] = ACTIONS(5483),
    [anon_sym_DASH_EQ] = ACTIONS(5483),
    [anon_sym_LT_LT_EQ] = ACTIONS(5483),
    [anon_sym_GT_GT_EQ] = ACTIONS(5483),
    [anon_sym_AMP_EQ] = ACTIONS(5483),
    [anon_sym_CARET_EQ] = ACTIONS(5483),
    [anon_sym_PIPE_EQ] = ACTIONS(5483),
    [anon_sym_and_eq] = ACTIONS(5481),
    [anon_sym_or_eq] = ACTIONS(5481),
    [anon_sym_xor_eq] = ACTIONS(5481),
    [anon_sym_LT_EQ_GT] = ACTIONS(5483),
    [anon_sym_or] = ACTIONS(5481),
    [anon_sym_and] = ACTIONS(5481),
    [anon_sym_bitor] = ACTIONS(5481),
    [anon_sym_xor] = ACTIONS(5481),
    [anon_sym_bitand] = ACTIONS(5481),
    [anon_sym_not_eq] = ACTIONS(5481),
    [anon_sym_DASH_DASH] = ACTIONS(5483),
    [anon_sym_PLUS_PLUS] = ACTIONS(5483),
    [anon_sym_DOT] = ACTIONS(5481),
    [anon_sym_DOT_STAR] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5481),
    [anon_sym_decltype] = ACTIONS(5481),
  },
  [2744] = {
    [sym_argument_list] = STATE(3032),
    [sym_initializer_list] = STATE(3032),
    [sym_identifier] = ACTIONS(6185),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6187),
    [anon_sym_COMMA] = ACTIONS(6187),
    [anon_sym_RPAREN] = ACTIONS(6187),
    [aux_sym_preproc_if_token2] = ACTIONS(6187),
    [aux_sym_preproc_else_token1] = ACTIONS(6187),
    [aux_sym_preproc_elif_token1] = ACTIONS(6185),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6187),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6187),
    [anon_sym_LPAREN2] = ACTIONS(5813),
    [anon_sym_DASH] = ACTIONS(6185),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_STAR] = ACTIONS(6185),
    [anon_sym_SLASH] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6185),
    [anon_sym_PIPE_PIPE] = ACTIONS(6187),
    [anon_sym_AMP_AMP] = ACTIONS(6187),
    [anon_sym_PIPE] = ACTIONS(6185),
    [anon_sym_CARET] = ACTIONS(6185),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_EQ_EQ] = ACTIONS(6187),
    [anon_sym_BANG_EQ] = ACTIONS(6187),
    [anon_sym_GT] = ACTIONS(6185),
    [anon_sym_GT_EQ] = ACTIONS(6187),
    [anon_sym_LT_EQ] = ACTIONS(6185),
    [anon_sym_LT] = ACTIONS(6185),
    [anon_sym_LT_LT] = ACTIONS(6185),
    [anon_sym_GT_GT] = ACTIONS(6185),
    [anon_sym_SEMI] = ACTIONS(6187),
    [anon_sym___attribute__] = ACTIONS(6185),
    [anon_sym_LBRACE] = ACTIONS(2159),
    [anon_sym_RBRACE] = ACTIONS(6187),
    [anon_sym_LBRACK] = ACTIONS(6187),
    [anon_sym_RBRACK] = ACTIONS(6187),
    [anon_sym_EQ] = ACTIONS(6185),
    [anon_sym_COLON] = ACTIONS(6187),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_STAR_EQ] = ACTIONS(6187),
    [anon_sym_SLASH_EQ] = ACTIONS(6187),
    [anon_sym_PERCENT_EQ] = ACTIONS(6187),
    [anon_sym_PLUS_EQ] = ACTIONS(6187),
    [anon_sym_DASH_EQ] = ACTIONS(6187),
    [anon_sym_LT_LT_EQ] = ACTIONS(6187),
    [anon_sym_GT_GT_EQ] = ACTIONS(6187),
    [anon_sym_AMP_EQ] = ACTIONS(6187),
    [anon_sym_CARET_EQ] = ACTIONS(6187),
    [anon_sym_PIPE_EQ] = ACTIONS(6187),
    [anon_sym_and_eq] = ACTIONS(6185),
    [anon_sym_or_eq] = ACTIONS(6185),
    [anon_sym_xor_eq] = ACTIONS(6185),
    [anon_sym_LT_EQ_GT] = ACTIONS(6187),
    [anon_sym_or] = ACTIONS(6185),
    [anon_sym_and] = ACTIONS(6185),
    [anon_sym_bitor] = ACTIONS(6185),
    [anon_sym_xor] = ACTIONS(6185),
    [anon_sym_bitand] = ACTIONS(6185),
    [anon_sym_not_eq] = ACTIONS(6185),
    [anon_sym_DASH_DASH] = ACTIONS(6187),
    [anon_sym_PLUS_PLUS] = ACTIONS(6187),
    [anon_sym_DOT] = ACTIONS(6185),
    [anon_sym_DOT_STAR] = ACTIONS(6187),
    [anon_sym_DASH_GT] = ACTIONS(6187),
    [sym_comment] = ACTIONS(3),
  },
  [2745] = {
    [sym_identifier] = ACTIONS(5638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5640),
    [anon_sym_COMMA] = ACTIONS(5640),
    [anon_sym_RPAREN] = ACTIONS(5640),
    [aux_sym_preproc_if_token2] = ACTIONS(5640),
    [aux_sym_preproc_else_token1] = ACTIONS(5640),
    [aux_sym_preproc_elif_token1] = ACTIONS(5638),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5640),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5640),
    [anon_sym_LPAREN2] = ACTIONS(5640),
    [anon_sym_DASH] = ACTIONS(5638),
    [anon_sym_PLUS] = ACTIONS(5638),
    [anon_sym_STAR] = ACTIONS(5638),
    [anon_sym_SLASH] = ACTIONS(5638),
    [anon_sym_PERCENT] = ACTIONS(5638),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE] = ACTIONS(5638),
    [anon_sym_CARET] = ACTIONS(5638),
    [anon_sym_AMP] = ACTIONS(5638),
    [anon_sym_EQ_EQ] = ACTIONS(5640),
    [anon_sym_BANG_EQ] = ACTIONS(5640),
    [anon_sym_GT] = ACTIONS(5638),
    [anon_sym_GT_EQ] = ACTIONS(5640),
    [anon_sym_LT_EQ] = ACTIONS(5638),
    [anon_sym_LT] = ACTIONS(5638),
    [anon_sym_LT_LT] = ACTIONS(5638),
    [anon_sym_GT_GT] = ACTIONS(5638),
    [anon_sym_SEMI] = ACTIONS(5640),
    [anon_sym___attribute__] = ACTIONS(5638),
    [anon_sym_LBRACE] = ACTIONS(5640),
    [anon_sym_RBRACE] = ACTIONS(5640),
    [anon_sym_LBRACK] = ACTIONS(5640),
    [anon_sym_RBRACK] = ACTIONS(5640),
    [anon_sym_EQ] = ACTIONS(5638),
    [anon_sym_COLON] = ACTIONS(5640),
    [anon_sym_QMARK] = ACTIONS(5640),
    [anon_sym_STAR_EQ] = ACTIONS(5640),
    [anon_sym_SLASH_EQ] = ACTIONS(5640),
    [anon_sym_PERCENT_EQ] = ACTIONS(5640),
    [anon_sym_PLUS_EQ] = ACTIONS(5640),
    [anon_sym_DASH_EQ] = ACTIONS(5640),
    [anon_sym_LT_LT_EQ] = ACTIONS(5640),
    [anon_sym_GT_GT_EQ] = ACTIONS(5640),
    [anon_sym_AMP_EQ] = ACTIONS(5640),
    [anon_sym_CARET_EQ] = ACTIONS(5640),
    [anon_sym_PIPE_EQ] = ACTIONS(5640),
    [anon_sym_and_eq] = ACTIONS(5638),
    [anon_sym_or_eq] = ACTIONS(5638),
    [anon_sym_xor_eq] = ACTIONS(5638),
    [anon_sym_LT_EQ_GT] = ACTIONS(5640),
    [anon_sym_or] = ACTIONS(5638),
    [anon_sym_and] = ACTIONS(5638),
    [anon_sym_bitor] = ACTIONS(5638),
    [anon_sym_xor] = ACTIONS(5638),
    [anon_sym_bitand] = ACTIONS(5638),
    [anon_sym_not_eq] = ACTIONS(5638),
    [anon_sym_DASH_DASH] = ACTIONS(5640),
    [anon_sym_PLUS_PLUS] = ACTIONS(5640),
    [anon_sym_DOT] = ACTIONS(5638),
    [anon_sym_DOT_STAR] = ACTIONS(5640),
    [anon_sym_DASH_GT] = ACTIONS(5640),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5638),
    [anon_sym_decltype] = ACTIONS(5638),
  },
  [2746] = {
    [sym_identifier] = ACTIONS(5657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5659),
    [anon_sym_COMMA] = ACTIONS(5659),
    [anon_sym_RPAREN] = ACTIONS(5659),
    [aux_sym_preproc_if_token2] = ACTIONS(5659),
    [aux_sym_preproc_else_token1] = ACTIONS(5659),
    [aux_sym_preproc_elif_token1] = ACTIONS(5657),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5659),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5659),
    [anon_sym_LPAREN2] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5657),
    [anon_sym_PLUS] = ACTIONS(5657),
    [anon_sym_STAR] = ACTIONS(5657),
    [anon_sym_SLASH] = ACTIONS(5657),
    [anon_sym_PERCENT] = ACTIONS(5657),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5657),
    [anon_sym_CARET] = ACTIONS(5657),
    [anon_sym_AMP] = ACTIONS(5657),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5657),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_LT_EQ] = ACTIONS(5657),
    [anon_sym_LT] = ACTIONS(5657),
    [anon_sym_LT_LT] = ACTIONS(5657),
    [anon_sym_GT_GT] = ACTIONS(5657),
    [anon_sym_SEMI] = ACTIONS(5659),
    [anon_sym___attribute__] = ACTIONS(5657),
    [anon_sym_LBRACE] = ACTIONS(5659),
    [anon_sym_RBRACE] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5659),
    [anon_sym_RBRACK] = ACTIONS(5659),
    [anon_sym_EQ] = ACTIONS(5657),
    [anon_sym_COLON] = ACTIONS(5659),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_STAR_EQ] = ACTIONS(5659),
    [anon_sym_SLASH_EQ] = ACTIONS(5659),
    [anon_sym_PERCENT_EQ] = ACTIONS(5659),
    [anon_sym_PLUS_EQ] = ACTIONS(5659),
    [anon_sym_DASH_EQ] = ACTIONS(5659),
    [anon_sym_LT_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT_GT_EQ] = ACTIONS(5659),
    [anon_sym_AMP_EQ] = ACTIONS(5659),
    [anon_sym_CARET_EQ] = ACTIONS(5659),
    [anon_sym_PIPE_EQ] = ACTIONS(5659),
    [anon_sym_and_eq] = ACTIONS(5657),
    [anon_sym_or_eq] = ACTIONS(5657),
    [anon_sym_xor_eq] = ACTIONS(5657),
    [anon_sym_LT_EQ_GT] = ACTIONS(5659),
    [anon_sym_or] = ACTIONS(5657),
    [anon_sym_and] = ACTIONS(5657),
    [anon_sym_bitor] = ACTIONS(5657),
    [anon_sym_xor] = ACTIONS(5657),
    [anon_sym_bitand] = ACTIONS(5657),
    [anon_sym_not_eq] = ACTIONS(5657),
    [anon_sym_DASH_DASH] = ACTIONS(5659),
    [anon_sym_PLUS_PLUS] = ACTIONS(5659),
    [anon_sym_DOT] = ACTIONS(5657),
    [anon_sym_DOT_STAR] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5657),
    [anon_sym_decltype] = ACTIONS(5657),
  },
  [2747] = {
    [sym_identifier] = ACTIONS(5630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5632),
    [anon_sym_COMMA] = ACTIONS(5632),
    [anon_sym_RPAREN] = ACTIONS(5632),
    [aux_sym_preproc_if_token2] = ACTIONS(5632),
    [aux_sym_preproc_else_token1] = ACTIONS(5632),
    [aux_sym_preproc_elif_token1] = ACTIONS(5630),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5632),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5632),
    [anon_sym_LPAREN2] = ACTIONS(5632),
    [anon_sym_DASH] = ACTIONS(5630),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_STAR] = ACTIONS(5630),
    [anon_sym_SLASH] = ACTIONS(5630),
    [anon_sym_PERCENT] = ACTIONS(5630),
    [anon_sym_PIPE_PIPE] = ACTIONS(5632),
    [anon_sym_AMP_AMP] = ACTIONS(5632),
    [anon_sym_PIPE] = ACTIONS(5630),
    [anon_sym_CARET] = ACTIONS(5630),
    [anon_sym_AMP] = ACTIONS(5630),
    [anon_sym_EQ_EQ] = ACTIONS(5632),
    [anon_sym_BANG_EQ] = ACTIONS(5632),
    [anon_sym_GT] = ACTIONS(5630),
    [anon_sym_GT_EQ] = ACTIONS(5632),
    [anon_sym_LT_EQ] = ACTIONS(5630),
    [anon_sym_LT] = ACTIONS(5630),
    [anon_sym_LT_LT] = ACTIONS(5630),
    [anon_sym_GT_GT] = ACTIONS(5630),
    [anon_sym_SEMI] = ACTIONS(5632),
    [anon_sym___attribute__] = ACTIONS(5630),
    [anon_sym_LBRACE] = ACTIONS(5632),
    [anon_sym_RBRACE] = ACTIONS(5632),
    [anon_sym_LBRACK] = ACTIONS(5632),
    [anon_sym_RBRACK] = ACTIONS(5632),
    [anon_sym_EQ] = ACTIONS(5630),
    [anon_sym_COLON] = ACTIONS(5632),
    [anon_sym_QMARK] = ACTIONS(5632),
    [anon_sym_STAR_EQ] = ACTIONS(5632),
    [anon_sym_SLASH_EQ] = ACTIONS(5632),
    [anon_sym_PERCENT_EQ] = ACTIONS(5632),
    [anon_sym_PLUS_EQ] = ACTIONS(5632),
    [anon_sym_DASH_EQ] = ACTIONS(5632),
    [anon_sym_LT_LT_EQ] = ACTIONS(5632),
    [anon_sym_GT_GT_EQ] = ACTIONS(5632),
    [anon_sym_AMP_EQ] = ACTIONS(5632),
    [anon_sym_CARET_EQ] = ACTIONS(5632),
    [anon_sym_PIPE_EQ] = ACTIONS(5632),
    [anon_sym_and_eq] = ACTIONS(5630),
    [anon_sym_or_eq] = ACTIONS(5630),
    [anon_sym_xor_eq] = ACTIONS(5630),
    [anon_sym_LT_EQ_GT] = ACTIONS(5632),
    [anon_sym_or] = ACTIONS(5630),
    [anon_sym_and] = ACTIONS(5630),
    [anon_sym_bitor] = ACTIONS(5630),
    [anon_sym_xor] = ACTIONS(5630),
    [anon_sym_bitand] = ACTIONS(5630),
    [anon_sym_not_eq] = ACTIONS(5630),
    [anon_sym_DASH_DASH] = ACTIONS(5632),
    [anon_sym_PLUS_PLUS] = ACTIONS(5632),
    [anon_sym_DOT] = ACTIONS(5630),
    [anon_sym_DOT_STAR] = ACTIONS(5632),
    [anon_sym_DASH_GT] = ACTIONS(5632),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5630),
    [anon_sym_decltype] = ACTIONS(5630),
  },
  [2748] = {
    [sym_argument_list] = STATE(2995),
    [sym_initializer_list] = STATE(2995),
    [sym_identifier] = ACTIONS(6189),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [aux_sym_preproc_if_token2] = ACTIONS(6191),
    [aux_sym_preproc_else_token1] = ACTIONS(6191),
    [aux_sym_preproc_elif_token1] = ACTIONS(6189),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6191),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6191),
    [anon_sym_LPAREN2] = ACTIONS(5813),
    [anon_sym_DASH] = ACTIONS(6189),
    [anon_sym_PLUS] = ACTIONS(6189),
    [anon_sym_STAR] = ACTIONS(6189),
    [anon_sym_SLASH] = ACTIONS(6189),
    [anon_sym_PERCENT] = ACTIONS(6189),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6189),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_AMP] = ACTIONS(6189),
    [anon_sym_EQ_EQ] = ACTIONS(6191),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_GT] = ACTIONS(6189),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6189),
    [anon_sym_LT] = ACTIONS(6189),
    [anon_sym_LT_LT] = ACTIONS(6189),
    [anon_sym_GT_GT] = ACTIONS(6189),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym___attribute__] = ACTIONS(6189),
    [anon_sym_LBRACE] = ACTIONS(2159),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_RBRACK] = ACTIONS(6191),
    [anon_sym_EQ] = ACTIONS(6189),
    [anon_sym_COLON] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_and_eq] = ACTIONS(6189),
    [anon_sym_or_eq] = ACTIONS(6189),
    [anon_sym_xor_eq] = ACTIONS(6189),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6189),
    [anon_sym_and] = ACTIONS(6189),
    [anon_sym_bitor] = ACTIONS(6189),
    [anon_sym_xor] = ACTIONS(6189),
    [anon_sym_bitand] = ACTIONS(6189),
    [anon_sym_not_eq] = ACTIONS(6189),
    [anon_sym_DASH_DASH] = ACTIONS(6191),
    [anon_sym_PLUS_PLUS] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6189),
    [anon_sym_DOT_STAR] = ACTIONS(6191),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(3),
  },
  [2749] = {
    [sym_identifier] = ACTIONS(5716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5718),
    [anon_sym_COMMA] = ACTIONS(5718),
    [anon_sym_RPAREN] = ACTIONS(5718),
    [aux_sym_preproc_if_token2] = ACTIONS(5718),
    [aux_sym_preproc_else_token1] = ACTIONS(5718),
    [aux_sym_preproc_elif_token1] = ACTIONS(5716),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5718),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5718),
    [anon_sym_LPAREN2] = ACTIONS(5718),
    [anon_sym_DASH] = ACTIONS(5716),
    [anon_sym_PLUS] = ACTIONS(5716),
    [anon_sym_STAR] = ACTIONS(5716),
    [anon_sym_SLASH] = ACTIONS(5716),
    [anon_sym_PERCENT] = ACTIONS(5716),
    [anon_sym_PIPE_PIPE] = ACTIONS(5718),
    [anon_sym_AMP_AMP] = ACTIONS(5718),
    [anon_sym_PIPE] = ACTIONS(5716),
    [anon_sym_CARET] = ACTIONS(5716),
    [anon_sym_AMP] = ACTIONS(5716),
    [anon_sym_EQ_EQ] = ACTIONS(5718),
    [anon_sym_BANG_EQ] = ACTIONS(5718),
    [anon_sym_GT] = ACTIONS(5716),
    [anon_sym_GT_EQ] = ACTIONS(5718),
    [anon_sym_LT_EQ] = ACTIONS(5716),
    [anon_sym_LT] = ACTIONS(5716),
    [anon_sym_LT_LT] = ACTIONS(5716),
    [anon_sym_GT_GT] = ACTIONS(5716),
    [anon_sym_SEMI] = ACTIONS(5718),
    [anon_sym___attribute__] = ACTIONS(5716),
    [anon_sym_LBRACE] = ACTIONS(5718),
    [anon_sym_RBRACE] = ACTIONS(5718),
    [anon_sym_LBRACK] = ACTIONS(5718),
    [anon_sym_RBRACK] = ACTIONS(5718),
    [anon_sym_EQ] = ACTIONS(5716),
    [anon_sym_COLON] = ACTIONS(5718),
    [anon_sym_QMARK] = ACTIONS(5718),
    [anon_sym_STAR_EQ] = ACTIONS(5718),
    [anon_sym_SLASH_EQ] = ACTIONS(5718),
    [anon_sym_PERCENT_EQ] = ACTIONS(5718),
    [anon_sym_PLUS_EQ] = ACTIONS(5718),
    [anon_sym_DASH_EQ] = ACTIONS(5718),
    [anon_sym_LT_LT_EQ] = ACTIONS(5718),
    [anon_sym_GT_GT_EQ] = ACTIONS(5718),
    [anon_sym_AMP_EQ] = ACTIONS(5718),
    [anon_sym_CARET_EQ] = ACTIONS(5718),
    [anon_sym_PIPE_EQ] = ACTIONS(5718),
    [anon_sym_and_eq] = ACTIONS(5716),
    [anon_sym_or_eq] = ACTIONS(5716),
    [anon_sym_xor_eq] = ACTIONS(5716),
    [anon_sym_LT_EQ_GT] = ACTIONS(5718),
    [anon_sym_or] = ACTIONS(5716),
    [anon_sym_and] = ACTIONS(5716),
    [anon_sym_bitor] = ACTIONS(5716),
    [anon_sym_xor] = ACTIONS(5716),
    [anon_sym_bitand] = ACTIONS(5716),
    [anon_sym_not_eq] = ACTIONS(5716),
    [anon_sym_DASH_DASH] = ACTIONS(5718),
    [anon_sym_PLUS_PLUS] = ACTIONS(5718),
    [anon_sym_DOT] = ACTIONS(5716),
    [anon_sym_DOT_STAR] = ACTIONS(5718),
    [anon_sym_DASH_GT] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5716),
    [anon_sym_decltype] = ACTIONS(5716),
  },
  [2750] = {
    [sym_identifier] = ACTIONS(5789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5791),
    [anon_sym_COMMA] = ACTIONS(5791),
    [anon_sym_RPAREN] = ACTIONS(5791),
    [aux_sym_preproc_if_token2] = ACTIONS(5791),
    [aux_sym_preproc_else_token1] = ACTIONS(5791),
    [aux_sym_preproc_elif_token1] = ACTIONS(5789),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5791),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5791),
    [anon_sym_LPAREN2] = ACTIONS(5791),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_PLUS] = ACTIONS(5789),
    [anon_sym_STAR] = ACTIONS(5789),
    [anon_sym_SLASH] = ACTIONS(5789),
    [anon_sym_PERCENT] = ACTIONS(5789),
    [anon_sym_PIPE_PIPE] = ACTIONS(5791),
    [anon_sym_AMP_AMP] = ACTIONS(5791),
    [anon_sym_PIPE] = ACTIONS(5789),
    [anon_sym_CARET] = ACTIONS(5789),
    [anon_sym_AMP] = ACTIONS(5789),
    [anon_sym_EQ_EQ] = ACTIONS(5791),
    [anon_sym_BANG_EQ] = ACTIONS(5791),
    [anon_sym_GT] = ACTIONS(5789),
    [anon_sym_GT_EQ] = ACTIONS(5791),
    [anon_sym_LT_EQ] = ACTIONS(5789),
    [anon_sym_LT] = ACTIONS(5789),
    [anon_sym_LT_LT] = ACTIONS(5789),
    [anon_sym_GT_GT] = ACTIONS(5789),
    [anon_sym_SEMI] = ACTIONS(5791),
    [anon_sym___attribute__] = ACTIONS(5789),
    [anon_sym_LBRACE] = ACTIONS(5791),
    [anon_sym_RBRACE] = ACTIONS(5791),
    [anon_sym_LBRACK] = ACTIONS(5791),
    [anon_sym_RBRACK] = ACTIONS(5791),
    [anon_sym_EQ] = ACTIONS(5789),
    [anon_sym_COLON] = ACTIONS(5791),
    [anon_sym_QMARK] = ACTIONS(5791),
    [anon_sym_STAR_EQ] = ACTIONS(5791),
    [anon_sym_SLASH_EQ] = ACTIONS(5791),
    [anon_sym_PERCENT_EQ] = ACTIONS(5791),
    [anon_sym_PLUS_EQ] = ACTIONS(5791),
    [anon_sym_DASH_EQ] = ACTIONS(5791),
    [anon_sym_LT_LT_EQ] = ACTIONS(5791),
    [anon_sym_GT_GT_EQ] = ACTIONS(5791),
    [anon_sym_AMP_EQ] = ACTIONS(5791),
    [anon_sym_CARET_EQ] = ACTIONS(5791),
    [anon_sym_PIPE_EQ] = ACTIONS(5791),
    [anon_sym_and_eq] = ACTIONS(5789),
    [anon_sym_or_eq] = ACTIONS(5789),
    [anon_sym_xor_eq] = ACTIONS(5789),
    [anon_sym_LT_EQ_GT] = ACTIONS(5791),
    [anon_sym_or] = ACTIONS(5789),
    [anon_sym_and] = ACTIONS(5789),
    [anon_sym_bitor] = ACTIONS(5789),
    [anon_sym_xor] = ACTIONS(5789),
    [anon_sym_bitand] = ACTIONS(5789),
    [anon_sym_not_eq] = ACTIONS(5789),
    [anon_sym_DASH_DASH] = ACTIONS(5791),
    [anon_sym_PLUS_PLUS] = ACTIONS(5791),
    [anon_sym_DOT] = ACTIONS(5789),
    [anon_sym_DOT_STAR] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5791),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5789),
    [anon_sym_decltype] = ACTIONS(5789),
  },
  [2751] = {
    [sym_primitive_type] = STATE(3090),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2809),
    [sym_identifier] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5489),
    [anon_sym_COMMA] = ACTIONS(5489),
    [anon_sym_LPAREN2] = ACTIONS(5489),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_PLUS] = ACTIONS(5491),
    [anon_sym_STAR] = ACTIONS(5491),
    [anon_sym_SLASH] = ACTIONS(5491),
    [anon_sym_PERCENT] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5489),
    [anon_sym_AMP_AMP] = ACTIONS(5489),
    [anon_sym_PIPE] = ACTIONS(5491),
    [anon_sym_CARET] = ACTIONS(5491),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_EQ_EQ] = ACTIONS(5489),
    [anon_sym_BANG_EQ] = ACTIONS(5489),
    [anon_sym_GT] = ACTIONS(5491),
    [anon_sym_GT_EQ] = ACTIONS(5491),
    [anon_sym_LT_EQ] = ACTIONS(5491),
    [anon_sym_LT] = ACTIONS(5491),
    [anon_sym_LT_LT] = ACTIONS(5491),
    [anon_sym_GT_GT] = ACTIONS(5491),
    [anon_sym___attribute__] = ACTIONS(5491),
    [anon_sym_LBRACE] = ACTIONS(5489),
    [anon_sym_signed] = ACTIONS(6195),
    [anon_sym_unsigned] = ACTIONS(6195),
    [anon_sym_long] = ACTIONS(6195),
    [anon_sym_short] = ACTIONS(6195),
    [anon_sym_LBRACK] = ACTIONS(5489),
    [anon_sym_EQ] = ACTIONS(5491),
    [aux_sym_primitive_type_token1] = ACTIONS(6197),
    [anon_sym_byte] = ACTIONS(6197),
    [anon_sym_word] = ACTIONS(6197),
    [anon_sym_QMARK] = ACTIONS(5489),
    [anon_sym_STAR_EQ] = ACTIONS(5489),
    [anon_sym_SLASH_EQ] = ACTIONS(5489),
    [anon_sym_PERCENT_EQ] = ACTIONS(5489),
    [anon_sym_PLUS_EQ] = ACTIONS(5489),
    [anon_sym_DASH_EQ] = ACTIONS(5489),
    [anon_sym_LT_LT_EQ] = ACTIONS(5489),
    [anon_sym_GT_GT_EQ] = ACTIONS(5491),
    [anon_sym_AMP_EQ] = ACTIONS(5489),
    [anon_sym_CARET_EQ] = ACTIONS(5489),
    [anon_sym_PIPE_EQ] = ACTIONS(5489),
    [anon_sym_and_eq] = ACTIONS(5491),
    [anon_sym_or_eq] = ACTIONS(5491),
    [anon_sym_xor_eq] = ACTIONS(5491),
    [anon_sym_LT_EQ_GT] = ACTIONS(5489),
    [anon_sym_or] = ACTIONS(5491),
    [anon_sym_and] = ACTIONS(5491),
    [anon_sym_bitor] = ACTIONS(5491),
    [anon_sym_xor] = ACTIONS(5491),
    [anon_sym_bitand] = ACTIONS(5491),
    [anon_sym_not_eq] = ACTIONS(5491),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_DOT] = ACTIONS(5491),
    [anon_sym_DOT_STAR] = ACTIONS(5489),
    [anon_sym_DASH_GT] = ACTIONS(5489),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5491),
    [anon_sym_decltype] = ACTIONS(5491),
    [anon_sym_GT2] = ACTIONS(5489),
  },
  [2752] = {
    [sym_identifier] = ACTIONS(5688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_RPAREN] = ACTIONS(5690),
    [aux_sym_preproc_if_token2] = ACTIONS(5690),
    [aux_sym_preproc_else_token1] = ACTIONS(5690),
    [aux_sym_preproc_elif_token1] = ACTIONS(5688),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5690),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5690),
    [anon_sym_LPAREN2] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5688),
    [anon_sym_STAR] = ACTIONS(5688),
    [anon_sym_SLASH] = ACTIONS(5688),
    [anon_sym_PERCENT] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_AMP_AMP] = ACTIONS(5690),
    [anon_sym_PIPE] = ACTIONS(5688),
    [anon_sym_CARET] = ACTIONS(5688),
    [anon_sym_AMP] = ACTIONS(5688),
    [anon_sym_EQ_EQ] = ACTIONS(5690),
    [anon_sym_BANG_EQ] = ACTIONS(5690),
    [anon_sym_GT] = ACTIONS(5688),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_LT] = ACTIONS(5688),
    [anon_sym_LT_LT] = ACTIONS(5688),
    [anon_sym_GT_GT] = ACTIONS(5688),
    [anon_sym_SEMI] = ACTIONS(5690),
    [anon_sym___attribute__] = ACTIONS(5688),
    [anon_sym_LBRACE] = ACTIONS(5690),
    [anon_sym_RBRACE] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5690),
    [anon_sym_RBRACK] = ACTIONS(5690),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_COLON] = ACTIONS(5690),
    [anon_sym_QMARK] = ACTIONS(5690),
    [anon_sym_STAR_EQ] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_PERCENT_EQ] = ACTIONS(5690),
    [anon_sym_PLUS_EQ] = ACTIONS(5690),
    [anon_sym_DASH_EQ] = ACTIONS(5690),
    [anon_sym_LT_LT_EQ] = ACTIONS(5690),
    [anon_sym_GT_GT_EQ] = ACTIONS(5690),
    [anon_sym_AMP_EQ] = ACTIONS(5690),
    [anon_sym_CARET_EQ] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_and_eq] = ACTIONS(5688),
    [anon_sym_or_eq] = ACTIONS(5688),
    [anon_sym_xor_eq] = ACTIONS(5688),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_or] = ACTIONS(5688),
    [anon_sym_and] = ACTIONS(5688),
    [anon_sym_bitor] = ACTIONS(5688),
    [anon_sym_xor] = ACTIONS(5688),
    [anon_sym_bitand] = ACTIONS(5688),
    [anon_sym_not_eq] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5690),
    [anon_sym_PLUS_PLUS] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_DOT_STAR] = ACTIONS(5690),
    [anon_sym_DASH_GT] = ACTIONS(5690),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5688),
    [anon_sym_decltype] = ACTIONS(5688),
  },
  [2753] = {
    [sym_identifier] = ACTIONS(5692),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5694),
    [anon_sym_COMMA] = ACTIONS(5694),
    [anon_sym_RPAREN] = ACTIONS(5694),
    [aux_sym_preproc_if_token2] = ACTIONS(5694),
    [aux_sym_preproc_else_token1] = ACTIONS(5694),
    [aux_sym_preproc_elif_token1] = ACTIONS(5692),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5694),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5694),
    [anon_sym_LPAREN2] = ACTIONS(5694),
    [anon_sym_DASH] = ACTIONS(5692),
    [anon_sym_PLUS] = ACTIONS(5692),
    [anon_sym_STAR] = ACTIONS(5692),
    [anon_sym_SLASH] = ACTIONS(5692),
    [anon_sym_PERCENT] = ACTIONS(5692),
    [anon_sym_PIPE_PIPE] = ACTIONS(5694),
    [anon_sym_AMP_AMP] = ACTIONS(5694),
    [anon_sym_PIPE] = ACTIONS(5692),
    [anon_sym_CARET] = ACTIONS(5692),
    [anon_sym_AMP] = ACTIONS(5692),
    [anon_sym_EQ_EQ] = ACTIONS(5694),
    [anon_sym_BANG_EQ] = ACTIONS(5694),
    [anon_sym_GT] = ACTIONS(5692),
    [anon_sym_GT_EQ] = ACTIONS(5694),
    [anon_sym_LT_EQ] = ACTIONS(5692),
    [anon_sym_LT] = ACTIONS(5692),
    [anon_sym_LT_LT] = ACTIONS(5692),
    [anon_sym_GT_GT] = ACTIONS(5692),
    [anon_sym_SEMI] = ACTIONS(5694),
    [anon_sym___attribute__] = ACTIONS(5692),
    [anon_sym_LBRACE] = ACTIONS(5694),
    [anon_sym_RBRACE] = ACTIONS(5694),
    [anon_sym_LBRACK] = ACTIONS(5694),
    [anon_sym_RBRACK] = ACTIONS(5694),
    [anon_sym_EQ] = ACTIONS(5692),
    [anon_sym_COLON] = ACTIONS(5694),
    [anon_sym_QMARK] = ACTIONS(5694),
    [anon_sym_STAR_EQ] = ACTIONS(5694),
    [anon_sym_SLASH_EQ] = ACTIONS(5694),
    [anon_sym_PERCENT_EQ] = ACTIONS(5694),
    [anon_sym_PLUS_EQ] = ACTIONS(5694),
    [anon_sym_DASH_EQ] = ACTIONS(5694),
    [anon_sym_LT_LT_EQ] = ACTIONS(5694),
    [anon_sym_GT_GT_EQ] = ACTIONS(5694),
    [anon_sym_AMP_EQ] = ACTIONS(5694),
    [anon_sym_CARET_EQ] = ACTIONS(5694),
    [anon_sym_PIPE_EQ] = ACTIONS(5694),
    [anon_sym_and_eq] = ACTIONS(5692),
    [anon_sym_or_eq] = ACTIONS(5692),
    [anon_sym_xor_eq] = ACTIONS(5692),
    [anon_sym_LT_EQ_GT] = ACTIONS(5694),
    [anon_sym_or] = ACTIONS(5692),
    [anon_sym_and] = ACTIONS(5692),
    [anon_sym_bitor] = ACTIONS(5692),
    [anon_sym_xor] = ACTIONS(5692),
    [anon_sym_bitand] = ACTIONS(5692),
    [anon_sym_not_eq] = ACTIONS(5692),
    [anon_sym_DASH_DASH] = ACTIONS(5694),
    [anon_sym_PLUS_PLUS] = ACTIONS(5694),
    [anon_sym_DOT] = ACTIONS(5692),
    [anon_sym_DOT_STAR] = ACTIONS(5694),
    [anon_sym_DASH_GT] = ACTIONS(5694),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5692),
    [anon_sym_decltype] = ACTIONS(5692),
  },
  [2754] = {
    [sym_identifier] = ACTIONS(5785),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5787),
    [anon_sym_COMMA] = ACTIONS(5787),
    [anon_sym_RPAREN] = ACTIONS(5787),
    [aux_sym_preproc_if_token2] = ACTIONS(5787),
    [aux_sym_preproc_else_token1] = ACTIONS(5787),
    [aux_sym_preproc_elif_token1] = ACTIONS(5785),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5787),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5787),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5785),
    [anon_sym_PLUS] = ACTIONS(5785),
    [anon_sym_STAR] = ACTIONS(5785),
    [anon_sym_SLASH] = ACTIONS(5785),
    [anon_sym_PERCENT] = ACTIONS(5785),
    [anon_sym_PIPE_PIPE] = ACTIONS(5787),
    [anon_sym_AMP_AMP] = ACTIONS(5787),
    [anon_sym_PIPE] = ACTIONS(5785),
    [anon_sym_CARET] = ACTIONS(5785),
    [anon_sym_AMP] = ACTIONS(5785),
    [anon_sym_EQ_EQ] = ACTIONS(5787),
    [anon_sym_BANG_EQ] = ACTIONS(5787),
    [anon_sym_GT] = ACTIONS(5785),
    [anon_sym_GT_EQ] = ACTIONS(5787),
    [anon_sym_LT_EQ] = ACTIONS(5785),
    [anon_sym_LT] = ACTIONS(5785),
    [anon_sym_LT_LT] = ACTIONS(5785),
    [anon_sym_GT_GT] = ACTIONS(5785),
    [anon_sym_SEMI] = ACTIONS(5787),
    [anon_sym___attribute__] = ACTIONS(5785),
    [anon_sym_LBRACE] = ACTIONS(5787),
    [anon_sym_RBRACE] = ACTIONS(5787),
    [anon_sym_LBRACK] = ACTIONS(5787),
    [anon_sym_RBRACK] = ACTIONS(5787),
    [anon_sym_EQ] = ACTIONS(5785),
    [anon_sym_COLON] = ACTIONS(5787),
    [anon_sym_QMARK] = ACTIONS(5787),
    [anon_sym_STAR_EQ] = ACTIONS(5787),
    [anon_sym_SLASH_EQ] = ACTIONS(5787),
    [anon_sym_PERCENT_EQ] = ACTIONS(5787),
    [anon_sym_PLUS_EQ] = ACTIONS(5787),
    [anon_sym_DASH_EQ] = ACTIONS(5787),
    [anon_sym_LT_LT_EQ] = ACTIONS(5787),
    [anon_sym_GT_GT_EQ] = ACTIONS(5787),
    [anon_sym_AMP_EQ] = ACTIONS(5787),
    [anon_sym_CARET_EQ] = ACTIONS(5787),
    [anon_sym_PIPE_EQ] = ACTIONS(5787),
    [anon_sym_and_eq] = ACTIONS(5785),
    [anon_sym_or_eq] = ACTIONS(5785),
    [anon_sym_xor_eq] = ACTIONS(5785),
    [anon_sym_LT_EQ_GT] = ACTIONS(5787),
    [anon_sym_or] = ACTIONS(5785),
    [anon_sym_and] = ACTIONS(5785),
    [anon_sym_bitor] = ACTIONS(5785),
    [anon_sym_xor] = ACTIONS(5785),
    [anon_sym_bitand] = ACTIONS(5785),
    [anon_sym_not_eq] = ACTIONS(5785),
    [anon_sym_DASH_DASH] = ACTIONS(5787),
    [anon_sym_PLUS_PLUS] = ACTIONS(5787),
    [anon_sym_DOT] = ACTIONS(5785),
    [anon_sym_DOT_STAR] = ACTIONS(5787),
    [anon_sym_DASH_GT] = ACTIONS(5787),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5785),
    [anon_sym_decltype] = ACTIONS(5785),
  },
  [2755] = {
    [sym_identifier] = ACTIONS(5696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5698),
    [anon_sym_RPAREN] = ACTIONS(5698),
    [aux_sym_preproc_if_token2] = ACTIONS(5698),
    [aux_sym_preproc_else_token1] = ACTIONS(5698),
    [aux_sym_preproc_elif_token1] = ACTIONS(5696),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5698),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5698),
    [anon_sym_LPAREN2] = ACTIONS(5698),
    [anon_sym_DASH] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_STAR] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_PIPE] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_AMP] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5696),
    [anon_sym_GT_EQ] = ACTIONS(5698),
    [anon_sym_LT_EQ] = ACTIONS(5696),
    [anon_sym_LT] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_SEMI] = ACTIONS(5698),
    [anon_sym___attribute__] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5698),
    [anon_sym_RBRACE] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5698),
    [anon_sym_RBRACK] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5696),
    [anon_sym_COLON] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5698),
    [anon_sym_STAR_EQ] = ACTIONS(5698),
    [anon_sym_SLASH_EQ] = ACTIONS(5698),
    [anon_sym_PERCENT_EQ] = ACTIONS(5698),
    [anon_sym_PLUS_EQ] = ACTIONS(5698),
    [anon_sym_DASH_EQ] = ACTIONS(5698),
    [anon_sym_LT_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT_GT_EQ] = ACTIONS(5698),
    [anon_sym_AMP_EQ] = ACTIONS(5698),
    [anon_sym_CARET_EQ] = ACTIONS(5698),
    [anon_sym_PIPE_EQ] = ACTIONS(5698),
    [anon_sym_and_eq] = ACTIONS(5696),
    [anon_sym_or_eq] = ACTIONS(5696),
    [anon_sym_xor_eq] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5698),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_bitor] = ACTIONS(5696),
    [anon_sym_xor] = ACTIONS(5696),
    [anon_sym_bitand] = ACTIONS(5696),
    [anon_sym_not_eq] = ACTIONS(5696),
    [anon_sym_DASH_DASH] = ACTIONS(5698),
    [anon_sym_PLUS_PLUS] = ACTIONS(5698),
    [anon_sym_DOT] = ACTIONS(5696),
    [anon_sym_DOT_STAR] = ACTIONS(5698),
    [anon_sym_DASH_GT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5696),
    [anon_sym_decltype] = ACTIONS(5696),
  },
  [2756] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2763),
    [sym_identifier] = ACTIONS(6109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6107),
    [anon_sym_COMMA] = ACTIONS(6107),
    [aux_sym_preproc_if_token2] = ACTIONS(6107),
    [aux_sym_preproc_else_token1] = ACTIONS(6107),
    [aux_sym_preproc_elif_token1] = ACTIONS(6109),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6107),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6107),
    [anon_sym_LPAREN2] = ACTIONS(6107),
    [anon_sym_DASH] = ACTIONS(6109),
    [anon_sym_PLUS] = ACTIONS(6109),
    [anon_sym_STAR] = ACTIONS(6109),
    [anon_sym_SLASH] = ACTIONS(6109),
    [anon_sym_PERCENT] = ACTIONS(6109),
    [anon_sym_PIPE_PIPE] = ACTIONS(6107),
    [anon_sym_AMP_AMP] = ACTIONS(6107),
    [anon_sym_PIPE] = ACTIONS(6109),
    [anon_sym_CARET] = ACTIONS(6109),
    [anon_sym_AMP] = ACTIONS(6109),
    [anon_sym_EQ_EQ] = ACTIONS(6107),
    [anon_sym_BANG_EQ] = ACTIONS(6107),
    [anon_sym_GT] = ACTIONS(6109),
    [anon_sym_GT_EQ] = ACTIONS(6107),
    [anon_sym_LT_EQ] = ACTIONS(6109),
    [anon_sym_LT] = ACTIONS(6109),
    [anon_sym_LT_LT] = ACTIONS(6109),
    [anon_sym_GT_GT] = ACTIONS(6109),
    [anon_sym___attribute__] = ACTIONS(6109),
    [anon_sym_LBRACE] = ACTIONS(6107),
    [anon_sym_signed] = ACTIONS(6199),
    [anon_sym_unsigned] = ACTIONS(6199),
    [anon_sym_long] = ACTIONS(6199),
    [anon_sym_short] = ACTIONS(6199),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_EQ] = ACTIONS(6109),
    [anon_sym_QMARK] = ACTIONS(6107),
    [anon_sym_STAR_EQ] = ACTIONS(6107),
    [anon_sym_SLASH_EQ] = ACTIONS(6107),
    [anon_sym_PERCENT_EQ] = ACTIONS(6107),
    [anon_sym_PLUS_EQ] = ACTIONS(6107),
    [anon_sym_DASH_EQ] = ACTIONS(6107),
    [anon_sym_LT_LT_EQ] = ACTIONS(6107),
    [anon_sym_GT_GT_EQ] = ACTIONS(6107),
    [anon_sym_AMP_EQ] = ACTIONS(6107),
    [anon_sym_CARET_EQ] = ACTIONS(6107),
    [anon_sym_PIPE_EQ] = ACTIONS(6107),
    [anon_sym_and_eq] = ACTIONS(6109),
    [anon_sym_or_eq] = ACTIONS(6109),
    [anon_sym_xor_eq] = ACTIONS(6109),
    [anon_sym_LT_EQ_GT] = ACTIONS(6107),
    [anon_sym_or] = ACTIONS(6109),
    [anon_sym_and] = ACTIONS(6109),
    [anon_sym_bitor] = ACTIONS(6109),
    [anon_sym_xor] = ACTIONS(6109),
    [anon_sym_bitand] = ACTIONS(6109),
    [anon_sym_not_eq] = ACTIONS(6109),
    [anon_sym_DASH_DASH] = ACTIONS(6107),
    [anon_sym_PLUS_PLUS] = ACTIONS(6107),
    [anon_sym_DOT] = ACTIONS(6109),
    [anon_sym_DOT_STAR] = ACTIONS(6107),
    [anon_sym_DASH_GT] = ACTIONS(6107),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6109),
    [anon_sym_decltype] = ACTIONS(6109),
  },
  [2757] = {
    [sym_identifier] = ACTIONS(5669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5671),
    [anon_sym_COMMA] = ACTIONS(5671),
    [anon_sym_RPAREN] = ACTIONS(5671),
    [aux_sym_preproc_if_token2] = ACTIONS(5671),
    [aux_sym_preproc_else_token1] = ACTIONS(5671),
    [aux_sym_preproc_elif_token1] = ACTIONS(5669),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5671),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5671),
    [anon_sym_LPAREN2] = ACTIONS(5671),
    [anon_sym_DASH] = ACTIONS(5669),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5669),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_PERCENT] = ACTIONS(5669),
    [anon_sym_PIPE_PIPE] = ACTIONS(5671),
    [anon_sym_AMP_AMP] = ACTIONS(5671),
    [anon_sym_PIPE] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [anon_sym_AMP] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5671),
    [anon_sym_BANG_EQ] = ACTIONS(5671),
    [anon_sym_GT] = ACTIONS(5669),
    [anon_sym_GT_EQ] = ACTIONS(5671),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5669),
    [anon_sym_LT_LT] = ACTIONS(5669),
    [anon_sym_GT_GT] = ACTIONS(5669),
    [anon_sym_SEMI] = ACTIONS(5671),
    [anon_sym___attribute__] = ACTIONS(5669),
    [anon_sym_LBRACE] = ACTIONS(5671),
    [anon_sym_RBRACE] = ACTIONS(5671),
    [anon_sym_LBRACK] = ACTIONS(5671),
    [anon_sym_RBRACK] = ACTIONS(5671),
    [anon_sym_EQ] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5671),
    [anon_sym_QMARK] = ACTIONS(5671),
    [anon_sym_STAR_EQ] = ACTIONS(5671),
    [anon_sym_SLASH_EQ] = ACTIONS(5671),
    [anon_sym_PERCENT_EQ] = ACTIONS(5671),
    [anon_sym_PLUS_EQ] = ACTIONS(5671),
    [anon_sym_DASH_EQ] = ACTIONS(5671),
    [anon_sym_LT_LT_EQ] = ACTIONS(5671),
    [anon_sym_GT_GT_EQ] = ACTIONS(5671),
    [anon_sym_AMP_EQ] = ACTIONS(5671),
    [anon_sym_CARET_EQ] = ACTIONS(5671),
    [anon_sym_PIPE_EQ] = ACTIONS(5671),
    [anon_sym_and_eq] = ACTIONS(5669),
    [anon_sym_or_eq] = ACTIONS(5669),
    [anon_sym_xor_eq] = ACTIONS(5669),
    [anon_sym_LT_EQ_GT] = ACTIONS(5671),
    [anon_sym_or] = ACTIONS(5669),
    [anon_sym_and] = ACTIONS(5669),
    [anon_sym_bitor] = ACTIONS(5669),
    [anon_sym_xor] = ACTIONS(5669),
    [anon_sym_bitand] = ACTIONS(5669),
    [anon_sym_not_eq] = ACTIONS(5669),
    [anon_sym_DASH_DASH] = ACTIONS(5671),
    [anon_sym_PLUS_PLUS] = ACTIONS(5671),
    [anon_sym_DOT] = ACTIONS(5669),
    [anon_sym_DOT_STAR] = ACTIONS(5671),
    [anon_sym_DASH_GT] = ACTIONS(5671),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5669),
    [anon_sym_decltype] = ACTIONS(5669),
  },
  [2758] = {
    [sym_identifier] = ACTIONS(5781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5783),
    [anon_sym_COMMA] = ACTIONS(5783),
    [anon_sym_RPAREN] = ACTIONS(5783),
    [aux_sym_preproc_if_token2] = ACTIONS(5783),
    [aux_sym_preproc_else_token1] = ACTIONS(5783),
    [aux_sym_preproc_elif_token1] = ACTIONS(5781),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5783),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5783),
    [anon_sym_LPAREN2] = ACTIONS(5783),
    [anon_sym_DASH] = ACTIONS(5781),
    [anon_sym_PLUS] = ACTIONS(5781),
    [anon_sym_STAR] = ACTIONS(5781),
    [anon_sym_SLASH] = ACTIONS(5781),
    [anon_sym_PERCENT] = ACTIONS(5781),
    [anon_sym_PIPE_PIPE] = ACTIONS(5783),
    [anon_sym_AMP_AMP] = ACTIONS(5783),
    [anon_sym_PIPE] = ACTIONS(5781),
    [anon_sym_CARET] = ACTIONS(5781),
    [anon_sym_AMP] = ACTIONS(5781),
    [anon_sym_EQ_EQ] = ACTIONS(5783),
    [anon_sym_BANG_EQ] = ACTIONS(5783),
    [anon_sym_GT] = ACTIONS(5781),
    [anon_sym_GT_EQ] = ACTIONS(5783),
    [anon_sym_LT_EQ] = ACTIONS(5781),
    [anon_sym_LT] = ACTIONS(5781),
    [anon_sym_LT_LT] = ACTIONS(5781),
    [anon_sym_GT_GT] = ACTIONS(5781),
    [anon_sym_SEMI] = ACTIONS(5783),
    [anon_sym___attribute__] = ACTIONS(5781),
    [anon_sym_LBRACE] = ACTIONS(5783),
    [anon_sym_RBRACE] = ACTIONS(5783),
    [anon_sym_LBRACK] = ACTIONS(5783),
    [anon_sym_RBRACK] = ACTIONS(5783),
    [anon_sym_EQ] = ACTIONS(5781),
    [anon_sym_COLON] = ACTIONS(5783),
    [anon_sym_QMARK] = ACTIONS(5783),
    [anon_sym_STAR_EQ] = ACTIONS(5783),
    [anon_sym_SLASH_EQ] = ACTIONS(5783),
    [anon_sym_PERCENT_EQ] = ACTIONS(5783),
    [anon_sym_PLUS_EQ] = ACTIONS(5783),
    [anon_sym_DASH_EQ] = ACTIONS(5783),
    [anon_sym_LT_LT_EQ] = ACTIONS(5783),
    [anon_sym_GT_GT_EQ] = ACTIONS(5783),
    [anon_sym_AMP_EQ] = ACTIONS(5783),
    [anon_sym_CARET_EQ] = ACTIONS(5783),
    [anon_sym_PIPE_EQ] = ACTIONS(5783),
    [anon_sym_and_eq] = ACTIONS(5781),
    [anon_sym_or_eq] = ACTIONS(5781),
    [anon_sym_xor_eq] = ACTIONS(5781),
    [anon_sym_LT_EQ_GT] = ACTIONS(5783),
    [anon_sym_or] = ACTIONS(5781),
    [anon_sym_and] = ACTIONS(5781),
    [anon_sym_bitor] = ACTIONS(5781),
    [anon_sym_xor] = ACTIONS(5781),
    [anon_sym_bitand] = ACTIONS(5781),
    [anon_sym_not_eq] = ACTIONS(5781),
    [anon_sym_DASH_DASH] = ACTIONS(5783),
    [anon_sym_PLUS_PLUS] = ACTIONS(5783),
    [anon_sym_DOT] = ACTIONS(5781),
    [anon_sym_DOT_STAR] = ACTIONS(5783),
    [anon_sym_DASH_GT] = ACTIONS(5783),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5781),
    [anon_sym_decltype] = ACTIONS(5781),
  },
  [2759] = {
    [sym_identifier] = ACTIONS(5688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_RPAREN] = ACTIONS(5690),
    [aux_sym_preproc_if_token2] = ACTIONS(5690),
    [aux_sym_preproc_else_token1] = ACTIONS(5690),
    [aux_sym_preproc_elif_token1] = ACTIONS(5688),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5690),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5690),
    [anon_sym_LPAREN2] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5688),
    [anon_sym_STAR] = ACTIONS(5688),
    [anon_sym_SLASH] = ACTIONS(5688),
    [anon_sym_PERCENT] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_AMP_AMP] = ACTIONS(5690),
    [anon_sym_PIPE] = ACTIONS(5688),
    [anon_sym_CARET] = ACTIONS(5688),
    [anon_sym_AMP] = ACTIONS(5688),
    [anon_sym_EQ_EQ] = ACTIONS(5690),
    [anon_sym_BANG_EQ] = ACTIONS(5690),
    [anon_sym_GT] = ACTIONS(5688),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_LT] = ACTIONS(5688),
    [anon_sym_LT_LT] = ACTIONS(5688),
    [anon_sym_GT_GT] = ACTIONS(5688),
    [anon_sym_SEMI] = ACTIONS(5690),
    [anon_sym___attribute__] = ACTIONS(5688),
    [anon_sym_LBRACE] = ACTIONS(5690),
    [anon_sym_RBRACE] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5690),
    [anon_sym_RBRACK] = ACTIONS(5690),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_COLON] = ACTIONS(5690),
    [anon_sym_QMARK] = ACTIONS(5690),
    [anon_sym_STAR_EQ] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_PERCENT_EQ] = ACTIONS(5690),
    [anon_sym_PLUS_EQ] = ACTIONS(5690),
    [anon_sym_DASH_EQ] = ACTIONS(5690),
    [anon_sym_LT_LT_EQ] = ACTIONS(5690),
    [anon_sym_GT_GT_EQ] = ACTIONS(5690),
    [anon_sym_AMP_EQ] = ACTIONS(5690),
    [anon_sym_CARET_EQ] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_and_eq] = ACTIONS(5688),
    [anon_sym_or_eq] = ACTIONS(5688),
    [anon_sym_xor_eq] = ACTIONS(5688),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_or] = ACTIONS(5688),
    [anon_sym_and] = ACTIONS(5688),
    [anon_sym_bitor] = ACTIONS(5688),
    [anon_sym_xor] = ACTIONS(5688),
    [anon_sym_bitand] = ACTIONS(5688),
    [anon_sym_not_eq] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5690),
    [anon_sym_PLUS_PLUS] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_DOT_STAR] = ACTIONS(5690),
    [anon_sym_DASH_GT] = ACTIONS(5690),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5688),
    [anon_sym_decltype] = ACTIONS(5688),
  },
  [2760] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2725),
    [sym_identifier] = ACTIONS(6136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6134),
    [anon_sym_COMMA] = ACTIONS(6134),
    [aux_sym_preproc_if_token2] = ACTIONS(6134),
    [aux_sym_preproc_else_token1] = ACTIONS(6134),
    [aux_sym_preproc_elif_token1] = ACTIONS(6136),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6134),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6134),
    [anon_sym_LPAREN2] = ACTIONS(6134),
    [anon_sym_DASH] = ACTIONS(6136),
    [anon_sym_PLUS] = ACTIONS(6136),
    [anon_sym_STAR] = ACTIONS(6136),
    [anon_sym_SLASH] = ACTIONS(6136),
    [anon_sym_PERCENT] = ACTIONS(6136),
    [anon_sym_PIPE_PIPE] = ACTIONS(6134),
    [anon_sym_AMP_AMP] = ACTIONS(6134),
    [anon_sym_PIPE] = ACTIONS(6136),
    [anon_sym_CARET] = ACTIONS(6136),
    [anon_sym_AMP] = ACTIONS(6136),
    [anon_sym_EQ_EQ] = ACTIONS(6134),
    [anon_sym_BANG_EQ] = ACTIONS(6134),
    [anon_sym_GT] = ACTIONS(6136),
    [anon_sym_GT_EQ] = ACTIONS(6134),
    [anon_sym_LT_EQ] = ACTIONS(6136),
    [anon_sym_LT] = ACTIONS(6136),
    [anon_sym_LT_LT] = ACTIONS(6136),
    [anon_sym_GT_GT] = ACTIONS(6136),
    [anon_sym___attribute__] = ACTIONS(6136),
    [anon_sym_LBRACE] = ACTIONS(6134),
    [anon_sym_signed] = ACTIONS(6201),
    [anon_sym_unsigned] = ACTIONS(6201),
    [anon_sym_long] = ACTIONS(6201),
    [anon_sym_short] = ACTIONS(6201),
    [anon_sym_LBRACK] = ACTIONS(6134),
    [anon_sym_EQ] = ACTIONS(6136),
    [anon_sym_QMARK] = ACTIONS(6134),
    [anon_sym_STAR_EQ] = ACTIONS(6134),
    [anon_sym_SLASH_EQ] = ACTIONS(6134),
    [anon_sym_PERCENT_EQ] = ACTIONS(6134),
    [anon_sym_PLUS_EQ] = ACTIONS(6134),
    [anon_sym_DASH_EQ] = ACTIONS(6134),
    [anon_sym_LT_LT_EQ] = ACTIONS(6134),
    [anon_sym_GT_GT_EQ] = ACTIONS(6134),
    [anon_sym_AMP_EQ] = ACTIONS(6134),
    [anon_sym_CARET_EQ] = ACTIONS(6134),
    [anon_sym_PIPE_EQ] = ACTIONS(6134),
    [anon_sym_and_eq] = ACTIONS(6136),
    [anon_sym_or_eq] = ACTIONS(6136),
    [anon_sym_xor_eq] = ACTIONS(6136),
    [anon_sym_LT_EQ_GT] = ACTIONS(6134),
    [anon_sym_or] = ACTIONS(6136),
    [anon_sym_and] = ACTIONS(6136),
    [anon_sym_bitor] = ACTIONS(6136),
    [anon_sym_xor] = ACTIONS(6136),
    [anon_sym_bitand] = ACTIONS(6136),
    [anon_sym_not_eq] = ACTIONS(6136),
    [anon_sym_DASH_DASH] = ACTIONS(6134),
    [anon_sym_PLUS_PLUS] = ACTIONS(6134),
    [anon_sym_DOT] = ACTIONS(6136),
    [anon_sym_DOT_STAR] = ACTIONS(6134),
    [anon_sym_DASH_GT] = ACTIONS(6134),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6136),
    [anon_sym_decltype] = ACTIONS(6136),
  },
  [2761] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2761),
    [sym_identifier] = ACTIONS(5363),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5365),
    [anon_sym_COMMA] = ACTIONS(5365),
    [aux_sym_preproc_if_token2] = ACTIONS(5365),
    [aux_sym_preproc_else_token1] = ACTIONS(5365),
    [aux_sym_preproc_elif_token1] = ACTIONS(5363),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5365),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5365),
    [anon_sym_LPAREN2] = ACTIONS(5365),
    [anon_sym_DASH] = ACTIONS(5363),
    [anon_sym_PLUS] = ACTIONS(5363),
    [anon_sym_STAR] = ACTIONS(5363),
    [anon_sym_SLASH] = ACTIONS(5363),
    [anon_sym_PERCENT] = ACTIONS(5363),
    [anon_sym_PIPE_PIPE] = ACTIONS(5365),
    [anon_sym_AMP_AMP] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5363),
    [anon_sym_CARET] = ACTIONS(5363),
    [anon_sym_AMP] = ACTIONS(5363),
    [anon_sym_EQ_EQ] = ACTIONS(5365),
    [anon_sym_BANG_EQ] = ACTIONS(5365),
    [anon_sym_GT] = ACTIONS(5363),
    [anon_sym_GT_EQ] = ACTIONS(5365),
    [anon_sym_LT_EQ] = ACTIONS(5363),
    [anon_sym_LT] = ACTIONS(5363),
    [anon_sym_LT_LT] = ACTIONS(5363),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym___attribute__] = ACTIONS(5363),
    [anon_sym_LBRACE] = ACTIONS(5365),
    [anon_sym_signed] = ACTIONS(6203),
    [anon_sym_unsigned] = ACTIONS(6203),
    [anon_sym_long] = ACTIONS(6203),
    [anon_sym_short] = ACTIONS(6203),
    [anon_sym_LBRACK] = ACTIONS(5365),
    [anon_sym_EQ] = ACTIONS(5363),
    [anon_sym_QMARK] = ACTIONS(5365),
    [anon_sym_STAR_EQ] = ACTIONS(5365),
    [anon_sym_SLASH_EQ] = ACTIONS(5365),
    [anon_sym_PERCENT_EQ] = ACTIONS(5365),
    [anon_sym_PLUS_EQ] = ACTIONS(5365),
    [anon_sym_DASH_EQ] = ACTIONS(5365),
    [anon_sym_LT_LT_EQ] = ACTIONS(5365),
    [anon_sym_GT_GT_EQ] = ACTIONS(5365),
    [anon_sym_AMP_EQ] = ACTIONS(5365),
    [anon_sym_CARET_EQ] = ACTIONS(5365),
    [anon_sym_PIPE_EQ] = ACTIONS(5365),
    [anon_sym_and_eq] = ACTIONS(5363),
    [anon_sym_or_eq] = ACTIONS(5363),
    [anon_sym_xor_eq] = ACTIONS(5363),
    [anon_sym_LT_EQ_GT] = ACTIONS(5365),
    [anon_sym_or] = ACTIONS(5363),
    [anon_sym_and] = ACTIONS(5363),
    [anon_sym_bitor] = ACTIONS(5363),
    [anon_sym_xor] = ACTIONS(5363),
    [anon_sym_bitand] = ACTIONS(5363),
    [anon_sym_not_eq] = ACTIONS(5363),
    [anon_sym_DASH_DASH] = ACTIONS(5365),
    [anon_sym_PLUS_PLUS] = ACTIONS(5365),
    [anon_sym_DOT] = ACTIONS(5363),
    [anon_sym_DOT_STAR] = ACTIONS(5365),
    [anon_sym_DASH_GT] = ACTIONS(5365),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5363),
    [anon_sym_decltype] = ACTIONS(5363),
  },
  [2762] = {
    [sym_attribute_specifier] = STATE(3352),
    [sym_field_declaration_list] = STATE(3181),
    [sym_virtual_specifier] = STATE(7634),
    [sym_base_class_clause] = STATE(8548),
    [sym_identifier] = ACTIONS(5469),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5471),
    [anon_sym_COMMA] = ACTIONS(5471),
    [aux_sym_preproc_if_token2] = ACTIONS(5471),
    [aux_sym_preproc_else_token1] = ACTIONS(5471),
    [aux_sym_preproc_elif_token1] = ACTIONS(5471),
    [anon_sym_LPAREN2] = ACTIONS(5471),
    [anon_sym_DASH] = ACTIONS(5469),
    [anon_sym_PLUS] = ACTIONS(5469),
    [anon_sym_STAR] = ACTIONS(5469),
    [anon_sym_SLASH] = ACTIONS(5469),
    [anon_sym_PERCENT] = ACTIONS(5469),
    [anon_sym_PIPE_PIPE] = ACTIONS(5471),
    [anon_sym_AMP_AMP] = ACTIONS(5471),
    [anon_sym_PIPE] = ACTIONS(5469),
    [anon_sym_CARET] = ACTIONS(5469),
    [anon_sym_AMP] = ACTIONS(5469),
    [anon_sym_EQ_EQ] = ACTIONS(5471),
    [anon_sym_BANG_EQ] = ACTIONS(5471),
    [anon_sym_GT] = ACTIONS(5469),
    [anon_sym_GT_EQ] = ACTIONS(5471),
    [anon_sym_LT_EQ] = ACTIONS(5469),
    [anon_sym_LT] = ACTIONS(5469),
    [anon_sym_LT_LT] = ACTIONS(5469),
    [anon_sym_GT_GT] = ACTIONS(5469),
    [anon_sym___attribute__] = ACTIONS(6206),
    [anon_sym_LBRACE] = ACTIONS(6208),
    [anon_sym_LBRACK] = ACTIONS(5471),
    [anon_sym_EQ] = ACTIONS(5469),
    [anon_sym_COLON] = ACTIONS(5477),
    [anon_sym_QMARK] = ACTIONS(5471),
    [anon_sym_STAR_EQ] = ACTIONS(5471),
    [anon_sym_SLASH_EQ] = ACTIONS(5471),
    [anon_sym_PERCENT_EQ] = ACTIONS(5471),
    [anon_sym_PLUS_EQ] = ACTIONS(5471),
    [anon_sym_DASH_EQ] = ACTIONS(5471),
    [anon_sym_LT_LT_EQ] = ACTIONS(5471),
    [anon_sym_GT_GT_EQ] = ACTIONS(5471),
    [anon_sym_AMP_EQ] = ACTIONS(5471),
    [anon_sym_CARET_EQ] = ACTIONS(5471),
    [anon_sym_PIPE_EQ] = ACTIONS(5471),
    [anon_sym_and_eq] = ACTIONS(5469),
    [anon_sym_or_eq] = ACTIONS(5469),
    [anon_sym_xor_eq] = ACTIONS(5469),
    [anon_sym_LT_EQ_GT] = ACTIONS(5471),
    [anon_sym_or] = ACTIONS(5469),
    [anon_sym_and] = ACTIONS(5469),
    [anon_sym_bitor] = ACTIONS(5469),
    [anon_sym_xor] = ACTIONS(5469),
    [anon_sym_bitand] = ACTIONS(5469),
    [anon_sym_not_eq] = ACTIONS(5469),
    [anon_sym_DASH_DASH] = ACTIONS(5471),
    [anon_sym_PLUS_PLUS] = ACTIONS(5471),
    [anon_sym_DOT] = ACTIONS(5469),
    [anon_sym_DOT_STAR] = ACTIONS(5471),
    [anon_sym_DASH_GT] = ACTIONS(5471),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5469),
    [anon_sym_decltype] = ACTIONS(5469),
    [anon_sym_final] = ACTIONS(5479),
    [anon_sym_override] = ACTIONS(5479),
  },
  [2763] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2761),
    [sym_identifier] = ACTIONS(6105),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6103),
    [anon_sym_COMMA] = ACTIONS(6103),
    [aux_sym_preproc_if_token2] = ACTIONS(6103),
    [aux_sym_preproc_else_token1] = ACTIONS(6103),
    [aux_sym_preproc_elif_token1] = ACTIONS(6105),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6103),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6103),
    [anon_sym_LPAREN2] = ACTIONS(6103),
    [anon_sym_DASH] = ACTIONS(6105),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_STAR] = ACTIONS(6105),
    [anon_sym_SLASH] = ACTIONS(6105),
    [anon_sym_PERCENT] = ACTIONS(6105),
    [anon_sym_PIPE_PIPE] = ACTIONS(6103),
    [anon_sym_AMP_AMP] = ACTIONS(6103),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_CARET] = ACTIONS(6105),
    [anon_sym_AMP] = ACTIONS(6105),
    [anon_sym_EQ_EQ] = ACTIONS(6103),
    [anon_sym_BANG_EQ] = ACTIONS(6103),
    [anon_sym_GT] = ACTIONS(6105),
    [anon_sym_GT_EQ] = ACTIONS(6103),
    [anon_sym_LT_EQ] = ACTIONS(6105),
    [anon_sym_LT] = ACTIONS(6105),
    [anon_sym_LT_LT] = ACTIONS(6105),
    [anon_sym_GT_GT] = ACTIONS(6105),
    [anon_sym___attribute__] = ACTIONS(6105),
    [anon_sym_LBRACE] = ACTIONS(6103),
    [anon_sym_signed] = ACTIONS(6156),
    [anon_sym_unsigned] = ACTIONS(6156),
    [anon_sym_long] = ACTIONS(6156),
    [anon_sym_short] = ACTIONS(6156),
    [anon_sym_LBRACK] = ACTIONS(6103),
    [anon_sym_EQ] = ACTIONS(6105),
    [anon_sym_QMARK] = ACTIONS(6103),
    [anon_sym_STAR_EQ] = ACTIONS(6103),
    [anon_sym_SLASH_EQ] = ACTIONS(6103),
    [anon_sym_PERCENT_EQ] = ACTIONS(6103),
    [anon_sym_PLUS_EQ] = ACTIONS(6103),
    [anon_sym_DASH_EQ] = ACTIONS(6103),
    [anon_sym_LT_LT_EQ] = ACTIONS(6103),
    [anon_sym_GT_GT_EQ] = ACTIONS(6103),
    [anon_sym_AMP_EQ] = ACTIONS(6103),
    [anon_sym_CARET_EQ] = ACTIONS(6103),
    [anon_sym_PIPE_EQ] = ACTIONS(6103),
    [anon_sym_and_eq] = ACTIONS(6105),
    [anon_sym_or_eq] = ACTIONS(6105),
    [anon_sym_xor_eq] = ACTIONS(6105),
    [anon_sym_LT_EQ_GT] = ACTIONS(6103),
    [anon_sym_or] = ACTIONS(6105),
    [anon_sym_and] = ACTIONS(6105),
    [anon_sym_bitor] = ACTIONS(6105),
    [anon_sym_xor] = ACTIONS(6105),
    [anon_sym_bitand] = ACTIONS(6105),
    [anon_sym_not_eq] = ACTIONS(6105),
    [anon_sym_DASH_DASH] = ACTIONS(6103),
    [anon_sym_PLUS_PLUS] = ACTIONS(6103),
    [anon_sym_DOT] = ACTIONS(6105),
    [anon_sym_DOT_STAR] = ACTIONS(6103),
    [anon_sym_DASH_GT] = ACTIONS(6103),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6105),
    [anon_sym_decltype] = ACTIONS(6105),
  },
  [2764] = {
    [sym_attribute_declaration] = STATE(2764),
    [aux_sym_attributed_declarator_repeat1] = STATE(2764),
    [sym_identifier] = ACTIONS(6210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_RPAREN] = ACTIONS(6212),
    [aux_sym_preproc_if_token2] = ACTIONS(6212),
    [aux_sym_preproc_else_token1] = ACTIONS(6212),
    [aux_sym_preproc_elif_token1] = ACTIONS(6210),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6212),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6212),
    [anon_sym_LPAREN2] = ACTIONS(6212),
    [anon_sym_DASH] = ACTIONS(6210),
    [anon_sym_PLUS] = ACTIONS(6210),
    [anon_sym_STAR] = ACTIONS(6210),
    [anon_sym_SLASH] = ACTIONS(6210),
    [anon_sym_PERCENT] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6210),
    [anon_sym_CARET] = ACTIONS(6210),
    [anon_sym_AMP] = ACTIONS(6210),
    [anon_sym_EQ_EQ] = ACTIONS(6212),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_GT] = ACTIONS(6210),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6210),
    [anon_sym_LT] = ACTIONS(6210),
    [anon_sym_LT_LT] = ACTIONS(6210),
    [anon_sym_GT_GT] = ACTIONS(6210),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym___attribute__] = ACTIONS(6210),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6214),
    [anon_sym_RBRACE] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_RBRACK] = ACTIONS(6212),
    [anon_sym_EQ] = ACTIONS(6210),
    [anon_sym_COLON] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_and_eq] = ACTIONS(6210),
    [anon_sym_or_eq] = ACTIONS(6210),
    [anon_sym_xor_eq] = ACTIONS(6210),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_bitor] = ACTIONS(6210),
    [anon_sym_xor] = ACTIONS(6210),
    [anon_sym_bitand] = ACTIONS(6210),
    [anon_sym_not_eq] = ACTIONS(6210),
    [anon_sym_DASH_DASH] = ACTIONS(6212),
    [anon_sym_PLUS_PLUS] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6210),
    [anon_sym_DOT_STAR] = ACTIONS(6212),
    [anon_sym_DASH_GT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(3),
  },
  [2765] = {
    [sym_identifier] = ACTIONS(5421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5423),
    [anon_sym_COMMA] = ACTIONS(5423),
    [aux_sym_preproc_if_token2] = ACTIONS(5423),
    [aux_sym_preproc_else_token1] = ACTIONS(5423),
    [aux_sym_preproc_elif_token1] = ACTIONS(5423),
    [anon_sym_LPAREN2] = ACTIONS(5423),
    [anon_sym_DASH] = ACTIONS(5421),
    [anon_sym_PLUS] = ACTIONS(5421),
    [anon_sym_STAR] = ACTIONS(5421),
    [anon_sym_SLASH] = ACTIONS(5421),
    [anon_sym_PERCENT] = ACTIONS(5421),
    [anon_sym_PIPE_PIPE] = ACTIONS(5423),
    [anon_sym_AMP_AMP] = ACTIONS(5423),
    [anon_sym_PIPE] = ACTIONS(5421),
    [anon_sym_CARET] = ACTIONS(5421),
    [anon_sym_AMP] = ACTIONS(5421),
    [anon_sym_EQ_EQ] = ACTIONS(5423),
    [anon_sym_BANG_EQ] = ACTIONS(5423),
    [anon_sym_GT] = ACTIONS(5421),
    [anon_sym_GT_EQ] = ACTIONS(5423),
    [anon_sym_LT_EQ] = ACTIONS(5421),
    [anon_sym_LT] = ACTIONS(5421),
    [anon_sym_LT_LT] = ACTIONS(5421),
    [anon_sym_GT_GT] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(5421),
    [anon_sym_QMARK] = ACTIONS(5423),
    [anon_sym_STAR_EQ] = ACTIONS(5423),
    [anon_sym_SLASH_EQ] = ACTIONS(5423),
    [anon_sym_PERCENT_EQ] = ACTIONS(5423),
    [anon_sym_PLUS_EQ] = ACTIONS(5423),
    [anon_sym_DASH_EQ] = ACTIONS(5423),
    [anon_sym_LT_LT_EQ] = ACTIONS(5423),
    [anon_sym_GT_GT_EQ] = ACTIONS(5423),
    [anon_sym_AMP_EQ] = ACTIONS(5423),
    [anon_sym_CARET_EQ] = ACTIONS(5423),
    [anon_sym_PIPE_EQ] = ACTIONS(5423),
    [anon_sym_and_eq] = ACTIONS(5421),
    [anon_sym_or_eq] = ACTIONS(5421),
    [anon_sym_xor_eq] = ACTIONS(5421),
    [anon_sym_LT_EQ_GT] = ACTIONS(5423),
    [anon_sym_or] = ACTIONS(5421),
    [anon_sym_and] = ACTIONS(5421),
    [anon_sym_bitor] = ACTIONS(5421),
    [anon_sym_xor] = ACTIONS(5421),
    [anon_sym_bitand] = ACTIONS(5421),
    [anon_sym_not_eq] = ACTIONS(5421),
    [anon_sym_DASH_DASH] = ACTIONS(5423),
    [anon_sym_PLUS_PLUS] = ACTIONS(5423),
    [anon_sym_DOT] = ACTIONS(5421),
    [anon_sym_DOT_STAR] = ACTIONS(5423),
    [anon_sym_DASH_GT] = ACTIONS(5423),
    [anon_sym_L_DQUOTE] = ACTIONS(5423),
    [anon_sym_u_DQUOTE] = ACTIONS(5423),
    [anon_sym_U_DQUOTE] = ACTIONS(5423),
    [anon_sym_u8_DQUOTE] = ACTIONS(5423),
    [anon_sym_DQUOTE] = ACTIONS(5423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5423),
    [anon_sym_LR_DQUOTE] = ACTIONS(5423),
    [anon_sym_uR_DQUOTE] = ACTIONS(5423),
    [anon_sym_UR_DQUOTE] = ACTIONS(5423),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5423),
    [sym_literal_suffix] = ACTIONS(5421),
  },
  [2766] = {
    [sym_identifier] = ACTIONS(5763),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5765),
    [anon_sym_COMMA] = ACTIONS(5765),
    [anon_sym_RPAREN] = ACTIONS(5765),
    [aux_sym_preproc_if_token2] = ACTIONS(5765),
    [aux_sym_preproc_else_token1] = ACTIONS(5765),
    [aux_sym_preproc_elif_token1] = ACTIONS(5763),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5765),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5765),
    [anon_sym_LPAREN2] = ACTIONS(5765),
    [anon_sym_DASH] = ACTIONS(5763),
    [anon_sym_PLUS] = ACTIONS(5763),
    [anon_sym_STAR] = ACTIONS(5763),
    [anon_sym_SLASH] = ACTIONS(5763),
    [anon_sym_PERCENT] = ACTIONS(5763),
    [anon_sym_PIPE_PIPE] = ACTIONS(5765),
    [anon_sym_AMP_AMP] = ACTIONS(5765),
    [anon_sym_PIPE] = ACTIONS(5763),
    [anon_sym_CARET] = ACTIONS(5763),
    [anon_sym_AMP] = ACTIONS(5763),
    [anon_sym_EQ_EQ] = ACTIONS(5765),
    [anon_sym_BANG_EQ] = ACTIONS(5765),
    [anon_sym_GT] = ACTIONS(5763),
    [anon_sym_GT_EQ] = ACTIONS(5765),
    [anon_sym_LT_EQ] = ACTIONS(5763),
    [anon_sym_LT] = ACTIONS(5763),
    [anon_sym_LT_LT] = ACTIONS(5763),
    [anon_sym_GT_GT] = ACTIONS(5763),
    [anon_sym_SEMI] = ACTIONS(5765),
    [anon_sym___attribute__] = ACTIONS(5763),
    [anon_sym_LBRACE] = ACTIONS(5765),
    [anon_sym_RBRACE] = ACTIONS(5765),
    [anon_sym_LBRACK] = ACTIONS(5765),
    [anon_sym_RBRACK] = ACTIONS(5765),
    [anon_sym_EQ] = ACTIONS(5763),
    [anon_sym_COLON] = ACTIONS(5765),
    [anon_sym_QMARK] = ACTIONS(5765),
    [anon_sym_STAR_EQ] = ACTIONS(5765),
    [anon_sym_SLASH_EQ] = ACTIONS(5765),
    [anon_sym_PERCENT_EQ] = ACTIONS(5765),
    [anon_sym_PLUS_EQ] = ACTIONS(5765),
    [anon_sym_DASH_EQ] = ACTIONS(5765),
    [anon_sym_LT_LT_EQ] = ACTIONS(5765),
    [anon_sym_GT_GT_EQ] = ACTIONS(5765),
    [anon_sym_AMP_EQ] = ACTIONS(5765),
    [anon_sym_CARET_EQ] = ACTIONS(5765),
    [anon_sym_PIPE_EQ] = ACTIONS(5765),
    [anon_sym_and_eq] = ACTIONS(5763),
    [anon_sym_or_eq] = ACTIONS(5763),
    [anon_sym_xor_eq] = ACTIONS(5763),
    [anon_sym_LT_EQ_GT] = ACTIONS(5765),
    [anon_sym_or] = ACTIONS(5763),
    [anon_sym_and] = ACTIONS(5763),
    [anon_sym_bitor] = ACTIONS(5763),
    [anon_sym_xor] = ACTIONS(5763),
    [anon_sym_bitand] = ACTIONS(5763),
    [anon_sym_not_eq] = ACTIONS(5763),
    [anon_sym_DASH_DASH] = ACTIONS(5765),
    [anon_sym_PLUS_PLUS] = ACTIONS(5765),
    [anon_sym_DOT] = ACTIONS(5763),
    [anon_sym_DOT_STAR] = ACTIONS(5765),
    [anon_sym_DASH_GT] = ACTIONS(5765),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5763),
    [anon_sym_decltype] = ACTIONS(5763),
  },
  [2767] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2740),
    [sym_identifier] = ACTIONS(5724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5726),
    [anon_sym_COMMA] = ACTIONS(5726),
    [aux_sym_preproc_if_token2] = ACTIONS(5726),
    [aux_sym_preproc_else_token1] = ACTIONS(5726),
    [aux_sym_preproc_elif_token1] = ACTIONS(5724),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5726),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5726),
    [anon_sym_LPAREN2] = ACTIONS(5726),
    [anon_sym_DASH] = ACTIONS(5724),
    [anon_sym_PLUS] = ACTIONS(5724),
    [anon_sym_STAR] = ACTIONS(5724),
    [anon_sym_SLASH] = ACTIONS(5724),
    [anon_sym_PERCENT] = ACTIONS(5724),
    [anon_sym_PIPE_PIPE] = ACTIONS(5726),
    [anon_sym_AMP_AMP] = ACTIONS(5726),
    [anon_sym_PIPE] = ACTIONS(5724),
    [anon_sym_CARET] = ACTIONS(5724),
    [anon_sym_AMP] = ACTIONS(5724),
    [anon_sym_EQ_EQ] = ACTIONS(5726),
    [anon_sym_BANG_EQ] = ACTIONS(5726),
    [anon_sym_GT] = ACTIONS(5724),
    [anon_sym_GT_EQ] = ACTIONS(5726),
    [anon_sym_LT_EQ] = ACTIONS(5724),
    [anon_sym_LT] = ACTIONS(5724),
    [anon_sym_LT_LT] = ACTIONS(5724),
    [anon_sym_GT_GT] = ACTIONS(5724),
    [anon_sym___attribute__] = ACTIONS(5724),
    [anon_sym_LBRACE] = ACTIONS(5726),
    [anon_sym_signed] = ACTIONS(6217),
    [anon_sym_unsigned] = ACTIONS(6217),
    [anon_sym_long] = ACTIONS(6217),
    [anon_sym_short] = ACTIONS(6217),
    [anon_sym_LBRACK] = ACTIONS(5726),
    [anon_sym_EQ] = ACTIONS(5724),
    [anon_sym_QMARK] = ACTIONS(5726),
    [anon_sym_STAR_EQ] = ACTIONS(5726),
    [anon_sym_SLASH_EQ] = ACTIONS(5726),
    [anon_sym_PERCENT_EQ] = ACTIONS(5726),
    [anon_sym_PLUS_EQ] = ACTIONS(5726),
    [anon_sym_DASH_EQ] = ACTIONS(5726),
    [anon_sym_LT_LT_EQ] = ACTIONS(5726),
    [anon_sym_GT_GT_EQ] = ACTIONS(5726),
    [anon_sym_AMP_EQ] = ACTIONS(5726),
    [anon_sym_CARET_EQ] = ACTIONS(5726),
    [anon_sym_PIPE_EQ] = ACTIONS(5726),
    [anon_sym_and_eq] = ACTIONS(5724),
    [anon_sym_or_eq] = ACTIONS(5724),
    [anon_sym_xor_eq] = ACTIONS(5724),
    [anon_sym_LT_EQ_GT] = ACTIONS(5726),
    [anon_sym_or] = ACTIONS(5724),
    [anon_sym_and] = ACTIONS(5724),
    [anon_sym_bitor] = ACTIONS(5724),
    [anon_sym_xor] = ACTIONS(5724),
    [anon_sym_bitand] = ACTIONS(5724),
    [anon_sym_not_eq] = ACTIONS(5724),
    [anon_sym_DASH_DASH] = ACTIONS(5726),
    [anon_sym_PLUS_PLUS] = ACTIONS(5726),
    [anon_sym_DOT] = ACTIONS(5724),
    [anon_sym_DOT_STAR] = ACTIONS(5726),
    [anon_sym_DASH_GT] = ACTIONS(5726),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5724),
    [anon_sym_decltype] = ACTIONS(5724),
  },
  [2768] = {
    [sym_identifier] = ACTIONS(5675),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5677),
    [anon_sym_COMMA] = ACTIONS(5677),
    [anon_sym_RPAREN] = ACTIONS(5677),
    [aux_sym_preproc_if_token2] = ACTIONS(5677),
    [aux_sym_preproc_else_token1] = ACTIONS(5677),
    [aux_sym_preproc_elif_token1] = ACTIONS(5675),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5677),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5677),
    [anon_sym_LPAREN2] = ACTIONS(5677),
    [anon_sym_DASH] = ACTIONS(5675),
    [anon_sym_PLUS] = ACTIONS(5675),
    [anon_sym_STAR] = ACTIONS(5675),
    [anon_sym_SLASH] = ACTIONS(5675),
    [anon_sym_PERCENT] = ACTIONS(5675),
    [anon_sym_PIPE_PIPE] = ACTIONS(5677),
    [anon_sym_AMP_AMP] = ACTIONS(5677),
    [anon_sym_PIPE] = ACTIONS(5675),
    [anon_sym_CARET] = ACTIONS(5675),
    [anon_sym_AMP] = ACTIONS(5675),
    [anon_sym_EQ_EQ] = ACTIONS(5677),
    [anon_sym_BANG_EQ] = ACTIONS(5677),
    [anon_sym_GT] = ACTIONS(5675),
    [anon_sym_GT_EQ] = ACTIONS(5677),
    [anon_sym_LT_EQ] = ACTIONS(5675),
    [anon_sym_LT] = ACTIONS(5675),
    [anon_sym_LT_LT] = ACTIONS(5675),
    [anon_sym_GT_GT] = ACTIONS(5675),
    [anon_sym_SEMI] = ACTIONS(5677),
    [anon_sym___attribute__] = ACTIONS(5675),
    [anon_sym_LBRACE] = ACTIONS(5677),
    [anon_sym_RBRACE] = ACTIONS(5677),
    [anon_sym_LBRACK] = ACTIONS(5677),
    [anon_sym_RBRACK] = ACTIONS(5677),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_COLON] = ACTIONS(5677),
    [anon_sym_QMARK] = ACTIONS(5677),
    [anon_sym_STAR_EQ] = ACTIONS(5677),
    [anon_sym_SLASH_EQ] = ACTIONS(5677),
    [anon_sym_PERCENT_EQ] = ACTIONS(5677),
    [anon_sym_PLUS_EQ] = ACTIONS(5677),
    [anon_sym_DASH_EQ] = ACTIONS(5677),
    [anon_sym_LT_LT_EQ] = ACTIONS(5677),
    [anon_sym_GT_GT_EQ] = ACTIONS(5677),
    [anon_sym_AMP_EQ] = ACTIONS(5677),
    [anon_sym_CARET_EQ] = ACTIONS(5677),
    [anon_sym_PIPE_EQ] = ACTIONS(5677),
    [anon_sym_and_eq] = ACTIONS(5675),
    [anon_sym_or_eq] = ACTIONS(5675),
    [anon_sym_xor_eq] = ACTIONS(5675),
    [anon_sym_LT_EQ_GT] = ACTIONS(5677),
    [anon_sym_or] = ACTIONS(5675),
    [anon_sym_and] = ACTIONS(5675),
    [anon_sym_bitor] = ACTIONS(5675),
    [anon_sym_xor] = ACTIONS(5675),
    [anon_sym_bitand] = ACTIONS(5675),
    [anon_sym_not_eq] = ACTIONS(5675),
    [anon_sym_DASH_DASH] = ACTIONS(5677),
    [anon_sym_PLUS_PLUS] = ACTIONS(5677),
    [anon_sym_DOT] = ACTIONS(5675),
    [anon_sym_DOT_STAR] = ACTIONS(5677),
    [anon_sym_DASH_GT] = ACTIONS(5677),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5675),
    [anon_sym_decltype] = ACTIONS(5675),
  },
  [2769] = {
    [sym_identifier] = ACTIONS(5708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5710),
    [anon_sym_COMMA] = ACTIONS(5710),
    [anon_sym_RPAREN] = ACTIONS(5710),
    [aux_sym_preproc_if_token2] = ACTIONS(5710),
    [aux_sym_preproc_else_token1] = ACTIONS(5710),
    [aux_sym_preproc_elif_token1] = ACTIONS(5708),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5710),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5710),
    [anon_sym_LPAREN2] = ACTIONS(5710),
    [anon_sym_DASH] = ACTIONS(5708),
    [anon_sym_PLUS] = ACTIONS(5708),
    [anon_sym_STAR] = ACTIONS(5708),
    [anon_sym_SLASH] = ACTIONS(5708),
    [anon_sym_PERCENT] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5710),
    [anon_sym_AMP_AMP] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5708),
    [anon_sym_CARET] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5708),
    [anon_sym_EQ_EQ] = ACTIONS(5710),
    [anon_sym_BANG_EQ] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5710),
    [anon_sym_LT_EQ] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5708),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym___attribute__] = ACTIONS(5708),
    [anon_sym_LBRACE] = ACTIONS(5710),
    [anon_sym_RBRACE] = ACTIONS(5710),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_RBRACK] = ACTIONS(5710),
    [anon_sym_EQ] = ACTIONS(5708),
    [anon_sym_COLON] = ACTIONS(5710),
    [anon_sym_QMARK] = ACTIONS(5710),
    [anon_sym_STAR_EQ] = ACTIONS(5710),
    [anon_sym_SLASH_EQ] = ACTIONS(5710),
    [anon_sym_PERCENT_EQ] = ACTIONS(5710),
    [anon_sym_PLUS_EQ] = ACTIONS(5710),
    [anon_sym_DASH_EQ] = ACTIONS(5710),
    [anon_sym_LT_LT_EQ] = ACTIONS(5710),
    [anon_sym_GT_GT_EQ] = ACTIONS(5710),
    [anon_sym_AMP_EQ] = ACTIONS(5710),
    [anon_sym_CARET_EQ] = ACTIONS(5710),
    [anon_sym_PIPE_EQ] = ACTIONS(5710),
    [anon_sym_and_eq] = ACTIONS(5708),
    [anon_sym_or_eq] = ACTIONS(5708),
    [anon_sym_xor_eq] = ACTIONS(5708),
    [anon_sym_LT_EQ_GT] = ACTIONS(5710),
    [anon_sym_or] = ACTIONS(5708),
    [anon_sym_and] = ACTIONS(5708),
    [anon_sym_bitor] = ACTIONS(5708),
    [anon_sym_xor] = ACTIONS(5708),
    [anon_sym_bitand] = ACTIONS(5708),
    [anon_sym_not_eq] = ACTIONS(5708),
    [anon_sym_DASH_DASH] = ACTIONS(5710),
    [anon_sym_PLUS_PLUS] = ACTIONS(5710),
    [anon_sym_DOT] = ACTIONS(5708),
    [anon_sym_DOT_STAR] = ACTIONS(5710),
    [anon_sym_DASH_GT] = ACTIONS(5710),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5708),
    [anon_sym_decltype] = ACTIONS(5708),
  },
  [2770] = {
    [sym_identifier] = ACTIONS(5665),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5667),
    [anon_sym_COMMA] = ACTIONS(5667),
    [anon_sym_RPAREN] = ACTIONS(5667),
    [aux_sym_preproc_if_token2] = ACTIONS(5667),
    [aux_sym_preproc_else_token1] = ACTIONS(5667),
    [aux_sym_preproc_elif_token1] = ACTIONS(5665),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5667),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5667),
    [anon_sym_LPAREN2] = ACTIONS(5667),
    [anon_sym_DASH] = ACTIONS(5665),
    [anon_sym_PLUS] = ACTIONS(5665),
    [anon_sym_STAR] = ACTIONS(5665),
    [anon_sym_SLASH] = ACTIONS(5665),
    [anon_sym_PERCENT] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5667),
    [anon_sym_AMP_AMP] = ACTIONS(5667),
    [anon_sym_PIPE] = ACTIONS(5665),
    [anon_sym_CARET] = ACTIONS(5665),
    [anon_sym_AMP] = ACTIONS(5665),
    [anon_sym_EQ_EQ] = ACTIONS(5667),
    [anon_sym_BANG_EQ] = ACTIONS(5667),
    [anon_sym_GT] = ACTIONS(5665),
    [anon_sym_GT_EQ] = ACTIONS(5667),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_LT] = ACTIONS(5665),
    [anon_sym_LT_LT] = ACTIONS(5665),
    [anon_sym_GT_GT] = ACTIONS(5665),
    [anon_sym_SEMI] = ACTIONS(5667),
    [anon_sym___attribute__] = ACTIONS(5665),
    [anon_sym_LBRACE] = ACTIONS(5667),
    [anon_sym_RBRACE] = ACTIONS(5667),
    [anon_sym_LBRACK] = ACTIONS(5667),
    [anon_sym_RBRACK] = ACTIONS(5667),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_COLON] = ACTIONS(5667),
    [anon_sym_QMARK] = ACTIONS(5667),
    [anon_sym_STAR_EQ] = ACTIONS(5667),
    [anon_sym_SLASH_EQ] = ACTIONS(5667),
    [anon_sym_PERCENT_EQ] = ACTIONS(5667),
    [anon_sym_PLUS_EQ] = ACTIONS(5667),
    [anon_sym_DASH_EQ] = ACTIONS(5667),
    [anon_sym_LT_LT_EQ] = ACTIONS(5667),
    [anon_sym_GT_GT_EQ] = ACTIONS(5667),
    [anon_sym_AMP_EQ] = ACTIONS(5667),
    [anon_sym_CARET_EQ] = ACTIONS(5667),
    [anon_sym_PIPE_EQ] = ACTIONS(5667),
    [anon_sym_and_eq] = ACTIONS(5665),
    [anon_sym_or_eq] = ACTIONS(5665),
    [anon_sym_xor_eq] = ACTIONS(5665),
    [anon_sym_LT_EQ_GT] = ACTIONS(5667),
    [anon_sym_or] = ACTIONS(5665),
    [anon_sym_and] = ACTIONS(5665),
    [anon_sym_bitor] = ACTIONS(5665),
    [anon_sym_xor] = ACTIONS(5665),
    [anon_sym_bitand] = ACTIONS(5665),
    [anon_sym_not_eq] = ACTIONS(5665),
    [anon_sym_DASH_DASH] = ACTIONS(5667),
    [anon_sym_PLUS_PLUS] = ACTIONS(5667),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_DOT_STAR] = ACTIONS(5667),
    [anon_sym_DASH_GT] = ACTIONS(5667),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5665),
    [anon_sym_decltype] = ACTIONS(5665),
  },
  [2771] = {
    [sym_identifier] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5714),
    [anon_sym_COMMA] = ACTIONS(5714),
    [anon_sym_RPAREN] = ACTIONS(5714),
    [aux_sym_preproc_if_token2] = ACTIONS(5714),
    [aux_sym_preproc_else_token1] = ACTIONS(5714),
    [aux_sym_preproc_elif_token1] = ACTIONS(5712),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5714),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5714),
    [anon_sym_LPAREN2] = ACTIONS(5714),
    [anon_sym_DASH] = ACTIONS(5712),
    [anon_sym_PLUS] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5712),
    [anon_sym_SLASH] = ACTIONS(5712),
    [anon_sym_PERCENT] = ACTIONS(5712),
    [anon_sym_PIPE_PIPE] = ACTIONS(5714),
    [anon_sym_AMP_AMP] = ACTIONS(5714),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_CARET] = ACTIONS(5712),
    [anon_sym_AMP] = ACTIONS(5712),
    [anon_sym_EQ_EQ] = ACTIONS(5714),
    [anon_sym_BANG_EQ] = ACTIONS(5714),
    [anon_sym_GT] = ACTIONS(5712),
    [anon_sym_GT_EQ] = ACTIONS(5714),
    [anon_sym_LT_EQ] = ACTIONS(5712),
    [anon_sym_LT] = ACTIONS(5712),
    [anon_sym_LT_LT] = ACTIONS(5712),
    [anon_sym_GT_GT] = ACTIONS(5712),
    [anon_sym_SEMI] = ACTIONS(5714),
    [anon_sym___attribute__] = ACTIONS(5712),
    [anon_sym_LBRACE] = ACTIONS(5714),
    [anon_sym_RBRACE] = ACTIONS(5714),
    [anon_sym_LBRACK] = ACTIONS(5714),
    [anon_sym_RBRACK] = ACTIONS(5714),
    [anon_sym_EQ] = ACTIONS(5712),
    [anon_sym_COLON] = ACTIONS(5714),
    [anon_sym_QMARK] = ACTIONS(5714),
    [anon_sym_STAR_EQ] = ACTIONS(5714),
    [anon_sym_SLASH_EQ] = ACTIONS(5714),
    [anon_sym_PERCENT_EQ] = ACTIONS(5714),
    [anon_sym_PLUS_EQ] = ACTIONS(5714),
    [anon_sym_DASH_EQ] = ACTIONS(5714),
    [anon_sym_LT_LT_EQ] = ACTIONS(5714),
    [anon_sym_GT_GT_EQ] = ACTIONS(5714),
    [anon_sym_AMP_EQ] = ACTIONS(5714),
    [anon_sym_CARET_EQ] = ACTIONS(5714),
    [anon_sym_PIPE_EQ] = ACTIONS(5714),
    [anon_sym_and_eq] = ACTIONS(5712),
    [anon_sym_or_eq] = ACTIONS(5712),
    [anon_sym_xor_eq] = ACTIONS(5712),
    [anon_sym_LT_EQ_GT] = ACTIONS(5714),
    [anon_sym_or] = ACTIONS(5712),
    [anon_sym_and] = ACTIONS(5712),
    [anon_sym_bitor] = ACTIONS(5712),
    [anon_sym_xor] = ACTIONS(5712),
    [anon_sym_bitand] = ACTIONS(5712),
    [anon_sym_not_eq] = ACTIONS(5712),
    [anon_sym_DASH_DASH] = ACTIONS(5714),
    [anon_sym_PLUS_PLUS] = ACTIONS(5714),
    [anon_sym_DOT] = ACTIONS(5712),
    [anon_sym_DOT_STAR] = ACTIONS(5714),
    [anon_sym_DASH_GT] = ACTIONS(5714),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5712),
    [anon_sym_decltype] = ACTIONS(5712),
  },
  [2772] = {
    [sym_identifier] = ACTIONS(5720),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5722),
    [anon_sym_COMMA] = ACTIONS(5722),
    [anon_sym_RPAREN] = ACTIONS(5722),
    [aux_sym_preproc_if_token2] = ACTIONS(5722),
    [aux_sym_preproc_else_token1] = ACTIONS(5722),
    [aux_sym_preproc_elif_token1] = ACTIONS(5720),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5722),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5722),
    [anon_sym_LPAREN2] = ACTIONS(5722),
    [anon_sym_DASH] = ACTIONS(5720),
    [anon_sym_PLUS] = ACTIONS(5720),
    [anon_sym_STAR] = ACTIONS(5720),
    [anon_sym_SLASH] = ACTIONS(5720),
    [anon_sym_PERCENT] = ACTIONS(5720),
    [anon_sym_PIPE_PIPE] = ACTIONS(5722),
    [anon_sym_AMP_AMP] = ACTIONS(5722),
    [anon_sym_PIPE] = ACTIONS(5720),
    [anon_sym_CARET] = ACTIONS(5720),
    [anon_sym_AMP] = ACTIONS(5720),
    [anon_sym_EQ_EQ] = ACTIONS(5722),
    [anon_sym_BANG_EQ] = ACTIONS(5722),
    [anon_sym_GT] = ACTIONS(5720),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_LT_EQ] = ACTIONS(5720),
    [anon_sym_LT] = ACTIONS(5720),
    [anon_sym_LT_LT] = ACTIONS(5720),
    [anon_sym_GT_GT] = ACTIONS(5720),
    [anon_sym_SEMI] = ACTIONS(5722),
    [anon_sym___attribute__] = ACTIONS(5720),
    [anon_sym_LBRACE] = ACTIONS(5722),
    [anon_sym_RBRACE] = ACTIONS(5722),
    [anon_sym_LBRACK] = ACTIONS(5722),
    [anon_sym_RBRACK] = ACTIONS(5722),
    [anon_sym_EQ] = ACTIONS(5720),
    [anon_sym_COLON] = ACTIONS(5722),
    [anon_sym_QMARK] = ACTIONS(5722),
    [anon_sym_STAR_EQ] = ACTIONS(5722),
    [anon_sym_SLASH_EQ] = ACTIONS(5722),
    [anon_sym_PERCENT_EQ] = ACTIONS(5722),
    [anon_sym_PLUS_EQ] = ACTIONS(5722),
    [anon_sym_DASH_EQ] = ACTIONS(5722),
    [anon_sym_LT_LT_EQ] = ACTIONS(5722),
    [anon_sym_GT_GT_EQ] = ACTIONS(5722),
    [anon_sym_AMP_EQ] = ACTIONS(5722),
    [anon_sym_CARET_EQ] = ACTIONS(5722),
    [anon_sym_PIPE_EQ] = ACTIONS(5722),
    [anon_sym_and_eq] = ACTIONS(5720),
    [anon_sym_or_eq] = ACTIONS(5720),
    [anon_sym_xor_eq] = ACTIONS(5720),
    [anon_sym_LT_EQ_GT] = ACTIONS(5722),
    [anon_sym_or] = ACTIONS(5720),
    [anon_sym_and] = ACTIONS(5720),
    [anon_sym_bitor] = ACTIONS(5720),
    [anon_sym_xor] = ACTIONS(5720),
    [anon_sym_bitand] = ACTIONS(5720),
    [anon_sym_not_eq] = ACTIONS(5720),
    [anon_sym_DASH_DASH] = ACTIONS(5722),
    [anon_sym_PLUS_PLUS] = ACTIONS(5722),
    [anon_sym_DOT] = ACTIONS(5720),
    [anon_sym_DOT_STAR] = ACTIONS(5722),
    [anon_sym_DASH_GT] = ACTIONS(5722),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5720),
    [anon_sym_decltype] = ACTIONS(5720),
  },
  [2773] = {
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5419),
    [anon_sym_COMMA] = ACTIONS(5419),
    [aux_sym_preproc_if_token2] = ACTIONS(5419),
    [aux_sym_preproc_else_token1] = ACTIONS(5419),
    [aux_sym_preproc_elif_token1] = ACTIONS(5419),
    [anon_sym_LPAREN2] = ACTIONS(5419),
    [anon_sym_DASH] = ACTIONS(5417),
    [anon_sym_PLUS] = ACTIONS(5417),
    [anon_sym_STAR] = ACTIONS(5417),
    [anon_sym_SLASH] = ACTIONS(5417),
    [anon_sym_PERCENT] = ACTIONS(5417),
    [anon_sym_PIPE_PIPE] = ACTIONS(5419),
    [anon_sym_AMP_AMP] = ACTIONS(5419),
    [anon_sym_PIPE] = ACTIONS(5417),
    [anon_sym_CARET] = ACTIONS(5417),
    [anon_sym_AMP] = ACTIONS(5417),
    [anon_sym_EQ_EQ] = ACTIONS(5419),
    [anon_sym_BANG_EQ] = ACTIONS(5419),
    [anon_sym_GT] = ACTIONS(5417),
    [anon_sym_GT_EQ] = ACTIONS(5419),
    [anon_sym_LT_EQ] = ACTIONS(5417),
    [anon_sym_LT] = ACTIONS(5417),
    [anon_sym_LT_LT] = ACTIONS(5417),
    [anon_sym_GT_GT] = ACTIONS(5417),
    [anon_sym_LBRACK] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(5417),
    [anon_sym_QMARK] = ACTIONS(5419),
    [anon_sym_STAR_EQ] = ACTIONS(5419),
    [anon_sym_SLASH_EQ] = ACTIONS(5419),
    [anon_sym_PERCENT_EQ] = ACTIONS(5419),
    [anon_sym_PLUS_EQ] = ACTIONS(5419),
    [anon_sym_DASH_EQ] = ACTIONS(5419),
    [anon_sym_LT_LT_EQ] = ACTIONS(5419),
    [anon_sym_GT_GT_EQ] = ACTIONS(5419),
    [anon_sym_AMP_EQ] = ACTIONS(5419),
    [anon_sym_CARET_EQ] = ACTIONS(5419),
    [anon_sym_PIPE_EQ] = ACTIONS(5419),
    [anon_sym_and_eq] = ACTIONS(5417),
    [anon_sym_or_eq] = ACTIONS(5417),
    [anon_sym_xor_eq] = ACTIONS(5417),
    [anon_sym_LT_EQ_GT] = ACTIONS(5419),
    [anon_sym_or] = ACTIONS(5417),
    [anon_sym_and] = ACTIONS(5417),
    [anon_sym_bitor] = ACTIONS(5417),
    [anon_sym_xor] = ACTIONS(5417),
    [anon_sym_bitand] = ACTIONS(5417),
    [anon_sym_not_eq] = ACTIONS(5417),
    [anon_sym_DASH_DASH] = ACTIONS(5419),
    [anon_sym_PLUS_PLUS] = ACTIONS(5419),
    [anon_sym_DOT] = ACTIONS(5417),
    [anon_sym_DOT_STAR] = ACTIONS(5419),
    [anon_sym_DASH_GT] = ACTIONS(5419),
    [anon_sym_L_DQUOTE] = ACTIONS(5419),
    [anon_sym_u_DQUOTE] = ACTIONS(5419),
    [anon_sym_U_DQUOTE] = ACTIONS(5419),
    [anon_sym_u8_DQUOTE] = ACTIONS(5419),
    [anon_sym_DQUOTE] = ACTIONS(5419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5419),
    [anon_sym_LR_DQUOTE] = ACTIONS(5419),
    [anon_sym_uR_DQUOTE] = ACTIONS(5419),
    [anon_sym_UR_DQUOTE] = ACTIONS(5419),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5419),
    [sym_literal_suffix] = ACTIONS(5417),
  },
  [2774] = {
    [sym_string_literal] = STATE(2616),
    [sym_raw_string_literal] = STATE(2616),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_RPAREN] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(4256),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4256),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4248),
    [anon_sym_SLASH_EQ] = ACTIONS(4248),
    [anon_sym_PERCENT_EQ] = ACTIONS(4248),
    [anon_sym_PLUS_EQ] = ACTIONS(4248),
    [anon_sym_DASH_EQ] = ACTIONS(4248),
    [anon_sym_LT_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT_GT_EQ] = ACTIONS(4248),
    [anon_sym_AMP_EQ] = ACTIONS(4248),
    [anon_sym_CARET_EQ] = ACTIONS(4248),
    [anon_sym_PIPE_EQ] = ACTIONS(4248),
    [anon_sym_and_eq] = ACTIONS(4256),
    [anon_sym_or_eq] = ACTIONS(4256),
    [anon_sym_xor_eq] = ACTIONS(4256),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4256),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4256),
    [anon_sym_not_eq] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4256),
    [anon_sym_L_DQUOTE] = ACTIONS(5184),
    [anon_sym_u_DQUOTE] = ACTIONS(5184),
    [anon_sym_U_DQUOTE] = ACTIONS(5184),
    [anon_sym_u8_DQUOTE] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5186),
    [anon_sym_LR_DQUOTE] = ACTIONS(5186),
    [anon_sym_uR_DQUOTE] = ACTIONS(5186),
    [anon_sym_UR_DQUOTE] = ACTIONS(5186),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5186),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4248),
    [sym_literal_suffix] = ACTIONS(6219),
  },
  [2775] = {
    [sym_identifier] = ACTIONS(5751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5753),
    [anon_sym_COMMA] = ACTIONS(5753),
    [anon_sym_RPAREN] = ACTIONS(5753),
    [aux_sym_preproc_if_token2] = ACTIONS(5753),
    [aux_sym_preproc_else_token1] = ACTIONS(5753),
    [aux_sym_preproc_elif_token1] = ACTIONS(5751),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5753),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5753),
    [anon_sym_LPAREN2] = ACTIONS(5753),
    [anon_sym_DASH] = ACTIONS(5751),
    [anon_sym_PLUS] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5751),
    [anon_sym_SLASH] = ACTIONS(5751),
    [anon_sym_PERCENT] = ACTIONS(5751),
    [anon_sym_PIPE_PIPE] = ACTIONS(5753),
    [anon_sym_AMP_AMP] = ACTIONS(5753),
    [anon_sym_PIPE] = ACTIONS(5751),
    [anon_sym_CARET] = ACTIONS(5751),
    [anon_sym_AMP] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5753),
    [anon_sym_BANG_EQ] = ACTIONS(5753),
    [anon_sym_GT] = ACTIONS(5751),
    [anon_sym_GT_EQ] = ACTIONS(5753),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_LT] = ACTIONS(5751),
    [anon_sym_LT_LT] = ACTIONS(5751),
    [anon_sym_GT_GT] = ACTIONS(5751),
    [anon_sym_SEMI] = ACTIONS(5753),
    [anon_sym___attribute__] = ACTIONS(5751),
    [anon_sym_LBRACE] = ACTIONS(5753),
    [anon_sym_RBRACE] = ACTIONS(5753),
    [anon_sym_LBRACK] = ACTIONS(5753),
    [anon_sym_RBRACK] = ACTIONS(5753),
    [anon_sym_EQ] = ACTIONS(5751),
    [anon_sym_COLON] = ACTIONS(5753),
    [anon_sym_QMARK] = ACTIONS(5753),
    [anon_sym_STAR_EQ] = ACTIONS(5753),
    [anon_sym_SLASH_EQ] = ACTIONS(5753),
    [anon_sym_PERCENT_EQ] = ACTIONS(5753),
    [anon_sym_PLUS_EQ] = ACTIONS(5753),
    [anon_sym_DASH_EQ] = ACTIONS(5753),
    [anon_sym_LT_LT_EQ] = ACTIONS(5753),
    [anon_sym_GT_GT_EQ] = ACTIONS(5753),
    [anon_sym_AMP_EQ] = ACTIONS(5753),
    [anon_sym_CARET_EQ] = ACTIONS(5753),
    [anon_sym_PIPE_EQ] = ACTIONS(5753),
    [anon_sym_and_eq] = ACTIONS(5751),
    [anon_sym_or_eq] = ACTIONS(5751),
    [anon_sym_xor_eq] = ACTIONS(5751),
    [anon_sym_LT_EQ_GT] = ACTIONS(5753),
    [anon_sym_or] = ACTIONS(5751),
    [anon_sym_and] = ACTIONS(5751),
    [anon_sym_bitor] = ACTIONS(5751),
    [anon_sym_xor] = ACTIONS(5751),
    [anon_sym_bitand] = ACTIONS(5751),
    [anon_sym_not_eq] = ACTIONS(5751),
    [anon_sym_DASH_DASH] = ACTIONS(5753),
    [anon_sym_PLUS_PLUS] = ACTIONS(5753),
    [anon_sym_DOT] = ACTIONS(5751),
    [anon_sym_DOT_STAR] = ACTIONS(5753),
    [anon_sym_DASH_GT] = ACTIONS(5753),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5751),
    [anon_sym_decltype] = ACTIONS(5751),
  },
  [2776] = {
    [sym_identifier] = ACTIONS(5481),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5483),
    [anon_sym_COMMA] = ACTIONS(5483),
    [anon_sym_RPAREN] = ACTIONS(5483),
    [aux_sym_preproc_if_token2] = ACTIONS(5483),
    [aux_sym_preproc_else_token1] = ACTIONS(5483),
    [aux_sym_preproc_elif_token1] = ACTIONS(5481),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5483),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5483),
    [anon_sym_LPAREN2] = ACTIONS(5483),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_PLUS] = ACTIONS(5481),
    [anon_sym_STAR] = ACTIONS(5481),
    [anon_sym_SLASH] = ACTIONS(5481),
    [anon_sym_PERCENT] = ACTIONS(5481),
    [anon_sym_PIPE_PIPE] = ACTIONS(5483),
    [anon_sym_AMP_AMP] = ACTIONS(5483),
    [anon_sym_PIPE] = ACTIONS(5481),
    [anon_sym_CARET] = ACTIONS(5481),
    [anon_sym_AMP] = ACTIONS(5481),
    [anon_sym_EQ_EQ] = ACTIONS(5483),
    [anon_sym_BANG_EQ] = ACTIONS(5483),
    [anon_sym_GT] = ACTIONS(5481),
    [anon_sym_GT_EQ] = ACTIONS(5483),
    [anon_sym_LT_EQ] = ACTIONS(5481),
    [anon_sym_LT] = ACTIONS(5481),
    [anon_sym_LT_LT] = ACTIONS(5481),
    [anon_sym_GT_GT] = ACTIONS(5481),
    [anon_sym_SEMI] = ACTIONS(5483),
    [anon_sym___attribute__] = ACTIONS(5481),
    [anon_sym_LBRACE] = ACTIONS(5483),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_LBRACK] = ACTIONS(5483),
    [anon_sym_RBRACK] = ACTIONS(5483),
    [anon_sym_EQ] = ACTIONS(5481),
    [anon_sym_COLON] = ACTIONS(5483),
    [anon_sym_QMARK] = ACTIONS(5483),
    [anon_sym_STAR_EQ] = ACTIONS(5483),
    [anon_sym_SLASH_EQ] = ACTIONS(5483),
    [anon_sym_PERCENT_EQ] = ACTIONS(5483),
    [anon_sym_PLUS_EQ] = ACTIONS(5483),
    [anon_sym_DASH_EQ] = ACTIONS(5483),
    [anon_sym_LT_LT_EQ] = ACTIONS(5483),
    [anon_sym_GT_GT_EQ] = ACTIONS(5483),
    [anon_sym_AMP_EQ] = ACTIONS(5483),
    [anon_sym_CARET_EQ] = ACTIONS(5483),
    [anon_sym_PIPE_EQ] = ACTIONS(5483),
    [anon_sym_and_eq] = ACTIONS(5481),
    [anon_sym_or_eq] = ACTIONS(5481),
    [anon_sym_xor_eq] = ACTIONS(5481),
    [anon_sym_LT_EQ_GT] = ACTIONS(5483),
    [anon_sym_or] = ACTIONS(5481),
    [anon_sym_and] = ACTIONS(5481),
    [anon_sym_bitor] = ACTIONS(5481),
    [anon_sym_xor] = ACTIONS(5481),
    [anon_sym_bitand] = ACTIONS(5481),
    [anon_sym_not_eq] = ACTIONS(5481),
    [anon_sym_DASH_DASH] = ACTIONS(5483),
    [anon_sym_PLUS_PLUS] = ACTIONS(5483),
    [anon_sym_DOT] = ACTIONS(5481),
    [anon_sym_DOT_STAR] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5481),
    [anon_sym_decltype] = ACTIONS(5481),
  },
  [2777] = {
    [sym_ms_based_modifier] = STATE(8936),
    [sym_ms_unaligned_ptr_modifier] = STATE(4993),
    [sym_ms_pointer_modifier] = STATE(2781),
    [sym__declarator] = STATE(7173),
    [sym__abstract_declarator] = STATE(7201),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_abstract_parenthesized_declarator] = STATE(6944),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_abstract_pointer_declarator] = STATE(6944),
    [sym_function_declarator] = STATE(7008),
    [sym_abstract_function_declarator] = STATE(6944),
    [sym_array_declarator] = STATE(7008),
    [sym_abstract_array_declarator] = STATE(6944),
    [sym_type_qualifier] = STATE(3380),
    [sym_parameter_list] = STATE(4001),
    [sym_decltype] = STATE(9504),
    [sym_reference_declarator] = STATE(7008),
    [sym_abstract_reference_declarator] = STATE(6944),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym__function_declarator_seq] = STATE(6967),
    [sym_template_type] = STATE(9504),
    [sym_template_function] = STATE(7008),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6642),
    [sym_qualified_identifier] = STATE(7008),
    [sym_operator_name] = STATE(7008),
    [aux_sym__type_definition_type_repeat1] = STATE(3380),
    [aux_sym_pointer_declarator_repeat1] = STATE(2781),
    [sym_identifier] = ACTIONS(6221),
    [anon_sym_COMMA] = ACTIONS(6223),
    [anon_sym_RPAREN] = ACTIONS(6223),
    [anon_sym_LPAREN2] = ACTIONS(4296),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(6225),
    [anon_sym_AMP_AMP] = ACTIONS(6227),
    [anon_sym_AMP] = ACTIONS(6229),
    [anon_sym___extension__] = ACTIONS(3397),
    [anon_sym_COLON_COLON] = ACTIONS(6231),
    [anon_sym___based] = ACTIONS(47),
    [sym_ms_restrict_modifier] = ACTIONS(3399),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3399),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3399),
    [anon_sym__unaligned] = ACTIONS(3401),
    [anon_sym___unaligned] = ACTIONS(3401),
    [anon_sym_LBRACK] = ACTIONS(6233),
    [anon_sym_EQ] = ACTIONS(6223),
    [anon_sym_const] = ACTIONS(3397),
    [anon_sym_constexpr] = ACTIONS(3397),
    [anon_sym_volatile] = ACTIONS(3397),
    [anon_sym_restrict] = ACTIONS(3397),
    [anon_sym___restrict__] = ACTIONS(3397),
    [anon_sym__Atomic] = ACTIONS(3397),
    [anon_sym__Noreturn] = ACTIONS(3397),
    [anon_sym_noreturn] = ACTIONS(3397),
    [anon_sym_mutable] = ACTIONS(3397),
    [anon_sym_constinit] = ACTIONS(3397),
    [anon_sym_consteval] = ACTIONS(3397),
    [anon_sym_PROGMEM] = ACTIONS(3397),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_GT2] = ACTIONS(6223),
    [anon_sym_operator] = ACTIONS(2137),
  },
  [2778] = {
    [sym_identifier] = ACTIONS(5724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5726),
    [anon_sym_COMMA] = ACTIONS(5726),
    [anon_sym_RPAREN] = ACTIONS(5726),
    [aux_sym_preproc_if_token2] = ACTIONS(5726),
    [aux_sym_preproc_else_token1] = ACTIONS(5726),
    [aux_sym_preproc_elif_token1] = ACTIONS(5724),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5726),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5726),
    [anon_sym_LPAREN2] = ACTIONS(5726),
    [anon_sym_DASH] = ACTIONS(5724),
    [anon_sym_PLUS] = ACTIONS(5724),
    [anon_sym_STAR] = ACTIONS(5724),
    [anon_sym_SLASH] = ACTIONS(5724),
    [anon_sym_PERCENT] = ACTIONS(5724),
    [anon_sym_PIPE_PIPE] = ACTIONS(5726),
    [anon_sym_AMP_AMP] = ACTIONS(5726),
    [anon_sym_PIPE] = ACTIONS(5724),
    [anon_sym_CARET] = ACTIONS(5724),
    [anon_sym_AMP] = ACTIONS(5724),
    [anon_sym_EQ_EQ] = ACTIONS(5726),
    [anon_sym_BANG_EQ] = ACTIONS(5726),
    [anon_sym_GT] = ACTIONS(5724),
    [anon_sym_GT_EQ] = ACTIONS(5726),
    [anon_sym_LT_EQ] = ACTIONS(5724),
    [anon_sym_LT] = ACTIONS(5724),
    [anon_sym_LT_LT] = ACTIONS(5724),
    [anon_sym_GT_GT] = ACTIONS(5724),
    [anon_sym_SEMI] = ACTIONS(5726),
    [anon_sym___attribute__] = ACTIONS(5724),
    [anon_sym_LBRACE] = ACTIONS(5726),
    [anon_sym_RBRACE] = ACTIONS(5726),
    [anon_sym_LBRACK] = ACTIONS(5726),
    [anon_sym_RBRACK] = ACTIONS(5726),
    [anon_sym_EQ] = ACTIONS(5724),
    [anon_sym_COLON] = ACTIONS(5726),
    [anon_sym_QMARK] = ACTIONS(5726),
    [anon_sym_STAR_EQ] = ACTIONS(5726),
    [anon_sym_SLASH_EQ] = ACTIONS(5726),
    [anon_sym_PERCENT_EQ] = ACTIONS(5726),
    [anon_sym_PLUS_EQ] = ACTIONS(5726),
    [anon_sym_DASH_EQ] = ACTIONS(5726),
    [anon_sym_LT_LT_EQ] = ACTIONS(5726),
    [anon_sym_GT_GT_EQ] = ACTIONS(5726),
    [anon_sym_AMP_EQ] = ACTIONS(5726),
    [anon_sym_CARET_EQ] = ACTIONS(5726),
    [anon_sym_PIPE_EQ] = ACTIONS(5726),
    [anon_sym_and_eq] = ACTIONS(5724),
    [anon_sym_or_eq] = ACTIONS(5724),
    [anon_sym_xor_eq] = ACTIONS(5724),
    [anon_sym_LT_EQ_GT] = ACTIONS(5726),
    [anon_sym_or] = ACTIONS(5724),
    [anon_sym_and] = ACTIONS(5724),
    [anon_sym_bitor] = ACTIONS(5724),
    [anon_sym_xor] = ACTIONS(5724),
    [anon_sym_bitand] = ACTIONS(5724),
    [anon_sym_not_eq] = ACTIONS(5724),
    [anon_sym_DASH_DASH] = ACTIONS(5726),
    [anon_sym_PLUS_PLUS] = ACTIONS(5726),
    [anon_sym_DOT] = ACTIONS(5724),
    [anon_sym_DOT_STAR] = ACTIONS(5726),
    [anon_sym_DASH_GT] = ACTIONS(5726),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5724),
    [anon_sym_decltype] = ACTIONS(5724),
  },
  [2779] = {
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5441),
    [anon_sym_COMMA] = ACTIONS(5441),
    [aux_sym_preproc_if_token2] = ACTIONS(5441),
    [aux_sym_preproc_else_token1] = ACTIONS(5441),
    [aux_sym_preproc_elif_token1] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(5441),
    [anon_sym_DASH] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(5439),
    [anon_sym_STAR] = ACTIONS(5439),
    [anon_sym_SLASH] = ACTIONS(5439),
    [anon_sym_PERCENT] = ACTIONS(5439),
    [anon_sym_PIPE_PIPE] = ACTIONS(5441),
    [anon_sym_AMP_AMP] = ACTIONS(5441),
    [anon_sym_PIPE] = ACTIONS(5439),
    [anon_sym_CARET] = ACTIONS(5439),
    [anon_sym_AMP] = ACTIONS(5439),
    [anon_sym_EQ_EQ] = ACTIONS(5441),
    [anon_sym_BANG_EQ] = ACTIONS(5441),
    [anon_sym_GT] = ACTIONS(5439),
    [anon_sym_GT_EQ] = ACTIONS(5441),
    [anon_sym_LT_EQ] = ACTIONS(5439),
    [anon_sym_LT] = ACTIONS(5439),
    [anon_sym_LT_LT] = ACTIONS(5439),
    [anon_sym_GT_GT] = ACTIONS(5439),
    [anon_sym_LBRACK] = ACTIONS(5441),
    [anon_sym_EQ] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_STAR_EQ] = ACTIONS(5441),
    [anon_sym_SLASH_EQ] = ACTIONS(5441),
    [anon_sym_PERCENT_EQ] = ACTIONS(5441),
    [anon_sym_PLUS_EQ] = ACTIONS(5441),
    [anon_sym_DASH_EQ] = ACTIONS(5441),
    [anon_sym_LT_LT_EQ] = ACTIONS(5441),
    [anon_sym_GT_GT_EQ] = ACTIONS(5441),
    [anon_sym_AMP_EQ] = ACTIONS(5441),
    [anon_sym_CARET_EQ] = ACTIONS(5441),
    [anon_sym_PIPE_EQ] = ACTIONS(5441),
    [anon_sym_and_eq] = ACTIONS(5439),
    [anon_sym_or_eq] = ACTIONS(5439),
    [anon_sym_xor_eq] = ACTIONS(5439),
    [anon_sym_LT_EQ_GT] = ACTIONS(5441),
    [anon_sym_or] = ACTIONS(5439),
    [anon_sym_and] = ACTIONS(5439),
    [anon_sym_bitor] = ACTIONS(5439),
    [anon_sym_xor] = ACTIONS(5439),
    [anon_sym_bitand] = ACTIONS(5439),
    [anon_sym_not_eq] = ACTIONS(5439),
    [anon_sym_DASH_DASH] = ACTIONS(5441),
    [anon_sym_PLUS_PLUS] = ACTIONS(5441),
    [anon_sym_DOT] = ACTIONS(5439),
    [anon_sym_DOT_STAR] = ACTIONS(5441),
    [anon_sym_DASH_GT] = ACTIONS(5441),
    [anon_sym_L_DQUOTE] = ACTIONS(5441),
    [anon_sym_u_DQUOTE] = ACTIONS(5441),
    [anon_sym_U_DQUOTE] = ACTIONS(5441),
    [anon_sym_u8_DQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5441),
    [anon_sym_LR_DQUOTE] = ACTIONS(5441),
    [anon_sym_uR_DQUOTE] = ACTIONS(5441),
    [anon_sym_UR_DQUOTE] = ACTIONS(5441),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5441),
    [sym_literal_suffix] = ACTIONS(5439),
  },
  [2780] = {
    [sym_identifier] = ACTIONS(5661),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_COMMA] = ACTIONS(5663),
    [anon_sym_RPAREN] = ACTIONS(5663),
    [aux_sym_preproc_if_token2] = ACTIONS(5663),
    [aux_sym_preproc_else_token1] = ACTIONS(5663),
    [aux_sym_preproc_elif_token1] = ACTIONS(5661),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5663),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5663),
    [anon_sym_LPAREN2] = ACTIONS(5663),
    [anon_sym_DASH] = ACTIONS(5661),
    [anon_sym_PLUS] = ACTIONS(5661),
    [anon_sym_STAR] = ACTIONS(5661),
    [anon_sym_SLASH] = ACTIONS(5661),
    [anon_sym_PERCENT] = ACTIONS(5661),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_AMP_AMP] = ACTIONS(5663),
    [anon_sym_PIPE] = ACTIONS(5661),
    [anon_sym_CARET] = ACTIONS(5661),
    [anon_sym_AMP] = ACTIONS(5661),
    [anon_sym_EQ_EQ] = ACTIONS(5663),
    [anon_sym_BANG_EQ] = ACTIONS(5663),
    [anon_sym_GT] = ACTIONS(5661),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5661),
    [anon_sym_LT] = ACTIONS(5661),
    [anon_sym_LT_LT] = ACTIONS(5661),
    [anon_sym_GT_GT] = ACTIONS(5661),
    [anon_sym_SEMI] = ACTIONS(5663),
    [anon_sym___attribute__] = ACTIONS(5661),
    [anon_sym_LBRACE] = ACTIONS(5663),
    [anon_sym_RBRACE] = ACTIONS(5663),
    [anon_sym_LBRACK] = ACTIONS(5663),
    [anon_sym_RBRACK] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5661),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5663),
    [anon_sym_STAR_EQ] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_PERCENT_EQ] = ACTIONS(5663),
    [anon_sym_PLUS_EQ] = ACTIONS(5663),
    [anon_sym_DASH_EQ] = ACTIONS(5663),
    [anon_sym_LT_LT_EQ] = ACTIONS(5663),
    [anon_sym_GT_GT_EQ] = ACTIONS(5663),
    [anon_sym_AMP_EQ] = ACTIONS(5663),
    [anon_sym_CARET_EQ] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_and_eq] = ACTIONS(5661),
    [anon_sym_or_eq] = ACTIONS(5661),
    [anon_sym_xor_eq] = ACTIONS(5661),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_or] = ACTIONS(5661),
    [anon_sym_and] = ACTIONS(5661),
    [anon_sym_bitor] = ACTIONS(5661),
    [anon_sym_xor] = ACTIONS(5661),
    [anon_sym_bitand] = ACTIONS(5661),
    [anon_sym_not_eq] = ACTIONS(5661),
    [anon_sym_DASH_DASH] = ACTIONS(5663),
    [anon_sym_PLUS_PLUS] = ACTIONS(5663),
    [anon_sym_DOT] = ACTIONS(5661),
    [anon_sym_DOT_STAR] = ACTIONS(5663),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5661),
    [anon_sym_decltype] = ACTIONS(5661),
  },
  [2781] = {
    [sym_ms_based_modifier] = STATE(8936),
    [sym_ms_unaligned_ptr_modifier] = STATE(4993),
    [sym_ms_pointer_modifier] = STATE(4770),
    [sym__declarator] = STATE(7191),
    [sym__abstract_declarator] = STATE(7253),
    [sym_parenthesized_declarator] = STATE(7008),
    [sym_abstract_parenthesized_declarator] = STATE(6944),
    [sym_attributed_declarator] = STATE(7008),
    [sym_pointer_declarator] = STATE(7008),
    [sym_abstract_pointer_declarator] = STATE(6944),
    [sym_function_declarator] = STATE(7008),
    [sym_abstract_function_declarator] = STATE(6944),
    [sym_array_declarator] = STATE(7008),
    [sym_abstract_array_declarator] = STATE(6944),
    [sym_type_qualifier] = STATE(3307),
    [sym_parameter_list] = STATE(4001),
    [sym_decltype] = STATE(9504),
    [sym_reference_declarator] = STATE(7008),
    [sym_abstract_reference_declarator] = STATE(6944),
    [sym_structured_binding_declarator] = STATE(7008),
    [sym__function_declarator_seq] = STATE(6967),
    [sym_template_type] = STATE(9504),
    [sym_template_function] = STATE(7008),
    [sym_destructor_name] = STATE(7008),
    [sym_dependent_type_identifier] = STATE(9504),
    [sym__scope_resolution] = STATE(6642),
    [sym_qualified_identifier] = STATE(7008),
    [sym_operator_name] = STATE(7008),
    [aux_sym__type_definition_type_repeat1] = STATE(3307),
    [aux_sym_pointer_declarator_repeat1] = STATE(4770),
    [sym_identifier] = ACTIONS(6221),
    [anon_sym_COMMA] = ACTIONS(6235),
    [anon_sym_RPAREN] = ACTIONS(6235),
    [anon_sym_LPAREN2] = ACTIONS(4296),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(6225),
    [anon_sym_AMP_AMP] = ACTIONS(6227),
    [anon_sym_AMP] = ACTIONS(6229),
    [anon_sym___extension__] = ACTIONS(3397),
    [anon_sym_COLON_COLON] = ACTIONS(6231),
    [anon_sym___based] = ACTIONS(47),
    [sym_ms_restrict_modifier] = ACTIONS(3399),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3399),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3399),
    [anon_sym__unaligned] = ACTIONS(3401),
    [anon_sym___unaligned] = ACTIONS(3401),
    [anon_sym_LBRACK] = ACTIONS(6233),
    [anon_sym_EQ] = ACTIONS(6235),
    [anon_sym_const] = ACTIONS(3397),
    [anon_sym_constexpr] = ACTIONS(3397),
    [anon_sym_volatile] = ACTIONS(3397),
    [anon_sym_restrict] = ACTIONS(3397),
    [anon_sym___restrict__] = ACTIONS(3397),
    [anon_sym__Atomic] = ACTIONS(3397),
    [anon_sym__Noreturn] = ACTIONS(3397),
    [anon_sym_noreturn] = ACTIONS(3397),
    [anon_sym_mutable] = ACTIONS(3397),
    [anon_sym_constinit] = ACTIONS(3397),
    [anon_sym_consteval] = ACTIONS(3397),
    [anon_sym_PROGMEM] = ACTIONS(3397),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2183),
    [anon_sym_template] = ACTIONS(1436),
    [anon_sym_GT2] = ACTIONS(6235),
    [anon_sym_operator] = ACTIONS(2137),
  },
  [2782] = {
    [sym_string_literal] = STATE(2575),
    [sym_raw_string_literal] = STATE(2575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(4256),
    [anon_sym_SLASH] = ACTIONS(4256),
    [anon_sym_PERCENT] = ACTIONS(4256),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4256),
    [anon_sym_CARET] = ACTIONS(4256),
    [anon_sym_AMP] = ACTIONS(4256),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4256),
    [anon_sym_GT_EQ] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(4256),
    [anon_sym_LT_LT] = ACTIONS(4256),
    [anon_sym_GT_GT] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym___attribute__] = ACTIONS(4256),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4256),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_STAR_EQ] = ACTIONS(4248),
    [anon_sym_SLASH_EQ] = ACTIONS(4248),
    [anon_sym_PERCENT_EQ] = ACTIONS(4248),
    [anon_sym_PLUS_EQ] = ACTIONS(4248),
    [anon_sym_DASH_EQ] = ACTIONS(4248),
    [anon_sym_LT_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT_GT_EQ] = ACTIONS(4248),
    [anon_sym_AMP_EQ] = ACTIONS(4248),
    [anon_sym_CARET_EQ] = ACTIONS(4248),
    [anon_sym_PIPE_EQ] = ACTIONS(4248),
    [anon_sym_and_eq] = ACTIONS(4256),
    [anon_sym_or_eq] = ACTIONS(4256),
    [anon_sym_xor_eq] = ACTIONS(4256),
    [anon_sym_LT_EQ_GT] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4256),
    [anon_sym_and] = ACTIONS(4256),
    [anon_sym_bitor] = ACTIONS(4256),
    [anon_sym_xor] = ACTIONS(4256),
    [anon_sym_bitand] = ACTIONS(4256),
    [anon_sym_not_eq] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4256),
    [anon_sym_DOT_STAR] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_L_DQUOTE] = ACTIONS(5912),
    [anon_sym_u_DQUOTE] = ACTIONS(5912),
    [anon_sym_U_DQUOTE] = ACTIONS(5912),
    [anon_sym_u8_DQUOTE] = ACTIONS(5912),
    [anon_sym_DQUOTE] = ACTIONS(5912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5914),
    [anon_sym_LR_DQUOTE] = ACTIONS(5914),
    [anon_sym_uR_DQUOTE] = ACTIONS(5914),
    [anon_sym_UR_DQUOTE] = ACTIONS(5914),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5914),
    [sym_literal_suffix] = ACTIONS(5801),
  },
  [2783] = {
    [sym_template_argument_list] = STATE(2036),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2863),
    [sym_identifier] = ACTIONS(5958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5960),
    [anon_sym_COMMA] = ACTIONS(5960),
    [aux_sym_preproc_if_token2] = ACTIONS(5960),
    [aux_sym_preproc_else_token1] = ACTIONS(5960),
    [aux_sym_preproc_elif_token1] = ACTIONS(5960),
    [anon_sym_LPAREN2] = ACTIONS(5960),
    [anon_sym_DASH] = ACTIONS(5958),
    [anon_sym_PLUS] = ACTIONS(5958),
    [anon_sym_STAR] = ACTIONS(5958),
    [anon_sym_SLASH] = ACTIONS(5958),
    [anon_sym_PERCENT] = ACTIONS(5958),
    [anon_sym_PIPE_PIPE] = ACTIONS(5960),
    [anon_sym_AMP_AMP] = ACTIONS(5960),
    [anon_sym_PIPE] = ACTIONS(5958),
    [anon_sym_CARET] = ACTIONS(5958),
    [anon_sym_AMP] = ACTIONS(5958),
    [anon_sym_EQ_EQ] = ACTIONS(5960),
    [anon_sym_BANG_EQ] = ACTIONS(5960),
    [anon_sym_GT] = ACTIONS(5958),
    [anon_sym_GT_EQ] = ACTIONS(5960),
    [anon_sym_LT_EQ] = ACTIONS(5958),
    [anon_sym_LT] = ACTIONS(5958),
    [anon_sym_LT_LT] = ACTIONS(5958),
    [anon_sym_GT_GT] = ACTIONS(5958),
    [anon_sym___attribute__] = ACTIONS(5958),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(5960),
    [anon_sym_signed] = ACTIONS(6237),
    [anon_sym_unsigned] = ACTIONS(6237),
    [anon_sym_long] = ACTIONS(6237),
    [anon_sym_short] = ACTIONS(6237),
    [anon_sym_LBRACK] = ACTIONS(5960),
    [anon_sym_EQ] = ACTIONS(5958),
    [anon_sym_QMARK] = ACTIONS(5960),
    [anon_sym_STAR_EQ] = ACTIONS(5960),
    [anon_sym_SLASH_EQ] = ACTIONS(5960),
    [anon_sym_PERCENT_EQ] = ACTIONS(5960),
    [anon_sym_PLUS_EQ] = ACTIONS(5960),
    [anon_sym_DASH_EQ] = ACTIONS(5960),
    [anon_sym_LT_LT_EQ] = ACTIONS(5960),
    [anon_sym_GT_GT_EQ] = ACTIONS(5960),
    [anon_sym_AMP_EQ] = ACTIONS(5960),
    [anon_sym_CARET_EQ] = ACTIONS(5960),
    [anon_sym_PIPE_EQ] = ACTIONS(5960),
    [anon_sym_and_eq] = ACTIONS(5958),
    [anon_sym_or_eq] = ACTIONS(5958),
    [anon_sym_xor_eq] = ACTIONS(5958),
    [anon_sym_LT_EQ_GT] = ACTIONS(5960),
    [anon_sym_or] = ACTIONS(5958),
    [anon_sym_and] = ACTIONS(5958),
    [anon_sym_bitor] = ACTIONS(5958),
    [anon_sym_xor] = ACTIONS(5958),
    [anon_sym_bitand] = ACTIONS(5958),
    [anon_sym_not_eq] = ACTIONS(5958),
    [anon_sym_DASH_DASH] = ACTIONS(5960),
    [anon_sym_PLUS_PLUS] = ACTIONS(5960),
    [anon_sym_DOT] = ACTIONS(5958),
    [anon_sym_DOT_STAR] = ACTIONS(5960),
    [anon_sym_DASH_GT] = ACTIONS(5960),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5958),
    [anon_sym_decltype] = ACTIONS(5958),
  },
  [2784] = {
    [sym_identifier] = ACTIONS(6239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6241),
    [anon_sym_COMMA] = ACTIONS(6241),
    [anon_sym_RPAREN] = ACTIONS(6241),
    [aux_sym_preproc_if_token2] = ACTIONS(6241),
    [aux_sym_preproc_else_token1] = ACTIONS(6241),
    [aux_sym_preproc_elif_token1] = ACTIONS(6239),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6241),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6241),
    [anon_sym_LPAREN2] = ACTIONS(6241),
    [anon_sym_DASH] = ACTIONS(6239),
    [anon_sym_PLUS] = ACTIONS(6239),
    [anon_sym_STAR] = ACTIONS(6239),
    [anon_sym_SLASH] = ACTIONS(6239),
    [anon_sym_PERCENT] = ACTIONS(6239),
    [anon_sym_PIPE_PIPE] = ACTIONS(6241),
    [anon_sym_AMP_AMP] = ACTIONS(6241),
    [anon_sym_PIPE] = ACTIONS(6239),
    [anon_sym_CARET] = ACTIONS(6239),
    [anon_sym_AMP] = ACTIONS(6239),
    [anon_sym_EQ_EQ] = ACTIONS(6241),
    [anon_sym_BANG_EQ] = ACTIONS(6241),
    [anon_sym_GT] = ACTIONS(6239),
    [anon_sym_GT_EQ] = ACTIONS(6241),
    [anon_sym_LT_EQ] = ACTIONS(6239),
    [anon_sym_LT] = ACTIONS(6239),
    [anon_sym_LT_LT] = ACTIONS(6239),
    [anon_sym_GT_GT] = ACTIONS(6239),
    [anon_sym_SEMI] = ACTIONS(6241),
    [anon_sym___attribute__] = ACTIONS(6239),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6241),
    [anon_sym_LBRACE] = ACTIONS(6241),
    [anon_sym_RBRACE] = ACTIONS(6241),
    [anon_sym_LBRACK] = ACTIONS(6239),
    [anon_sym_RBRACK] = ACTIONS(6241),
    [anon_sym_EQ] = ACTIONS(6239),
    [anon_sym_COLON] = ACTIONS(6241),
    [anon_sym_QMARK] = ACTIONS(6241),
    [anon_sym_STAR_EQ] = ACTIONS(6241),
    [anon_sym_SLASH_EQ] = ACTIONS(6241),
    [anon_sym_PERCENT_EQ] = ACTIONS(6241),
    [anon_sym_PLUS_EQ] = ACTIONS(6241),
    [anon_sym_DASH_EQ] = ACTIONS(6241),
    [anon_sym_LT_LT_EQ] = ACTIONS(6241),
    [anon_sym_GT_GT_EQ] = ACTIONS(6241),
    [anon_sym_AMP_EQ] = ACTIONS(6241),
    [anon_sym_CARET_EQ] = ACTIONS(6241),
    [anon_sym_PIPE_EQ] = ACTIONS(6241),
    [anon_sym_and_eq] = ACTIONS(6239),
    [anon_sym_or_eq] = ACTIONS(6239),
    [anon_sym_xor_eq] = ACTIONS(6239),
    [anon_sym_LT_EQ_GT] = ACTIONS(6241),
    [anon_sym_or] = ACTIONS(6239),
    [anon_sym_and] = ACTIONS(6239),
    [anon_sym_bitor] = ACTIONS(6239),
    [anon_sym_xor] = ACTIONS(6239),
    [anon_sym_bitand] = ACTIONS(6239),
    [anon_sym_not_eq] = ACTIONS(6239),
    [anon_sym_DASH_DASH] = ACTIONS(6241),
    [anon_sym_PLUS_PLUS] = ACTIONS(6241),
    [anon_sym_DOT] = ACTIONS(6239),
    [anon_sym_DOT_STAR] = ACTIONS(6241),
    [anon_sym_DASH_GT] = ACTIONS(6241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6239),
  },
  [2785] = {
    [sym_identifier] = ACTIONS(6243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6245),
    [anon_sym_COMMA] = ACTIONS(6245),
    [anon_sym_RPAREN] = ACTIONS(6245),
    [aux_sym_preproc_if_token2] = ACTIONS(6245),
    [aux_sym_preproc_else_token1] = ACTIONS(6245),
    [aux_sym_preproc_elif_token1] = ACTIONS(6243),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6245),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6245),
    [anon_sym_LPAREN2] = ACTIONS(6245),
    [anon_sym_DASH] = ACTIONS(6243),
    [anon_sym_PLUS] = ACTIONS(6243),
    [anon_sym_STAR] = ACTIONS(6243),
    [anon_sym_SLASH] = ACTIONS(6243),
    [anon_sym_PERCENT] = ACTIONS(6243),
    [anon_sym_PIPE_PIPE] = ACTIONS(6245),
    [anon_sym_AMP_AMP] = ACTIONS(6245),
    [anon_sym_PIPE] = ACTIONS(6243),
    [anon_sym_CARET] = ACTIONS(6243),
    [anon_sym_AMP] = ACTIONS(6243),
    [anon_sym_EQ_EQ] = ACTIONS(6245),
    [anon_sym_BANG_EQ] = ACTIONS(6245),
    [anon_sym_GT] = ACTIONS(6243),
    [anon_sym_GT_EQ] = ACTIONS(6245),
    [anon_sym_LT_EQ] = ACTIONS(6243),
    [anon_sym_LT] = ACTIONS(6243),
    [anon_sym_LT_LT] = ACTIONS(6243),
    [anon_sym_GT_GT] = ACTIONS(6243),
    [anon_sym_SEMI] = ACTIONS(6245),
    [anon_sym___attribute__] = ACTIONS(6243),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6245),
    [anon_sym_LBRACE] = ACTIONS(6245),
    [anon_sym_RBRACE] = ACTIONS(6245),
    [anon_sym_LBRACK] = ACTIONS(6243),
    [anon_sym_RBRACK] = ACTIONS(6245),
    [anon_sym_EQ] = ACTIONS(6243),
    [anon_sym_COLON] = ACTIONS(6245),
    [anon_sym_QMARK] = ACTIONS(6245),
    [anon_sym_STAR_EQ] = ACTIONS(6245),
    [anon_sym_SLASH_EQ] = ACTIONS(6245),
    [anon_sym_PERCENT_EQ] = ACTIONS(6245),
    [anon_sym_PLUS_EQ] = ACTIONS(6245),
    [anon_sym_DASH_EQ] = ACTIONS(6245),
    [anon_sym_LT_LT_EQ] = ACTIONS(6245),
    [anon_sym_GT_GT_EQ] = ACTIONS(6245),
    [anon_sym_AMP_EQ] = ACTIONS(6245),
    [anon_sym_CARET_EQ] = ACTIONS(6245),
    [anon_sym_PIPE_EQ] = ACTIONS(6245),
    [anon_sym_and_eq] = ACTIONS(6243),
    [anon_sym_or_eq] = ACTIONS(6243),
    [anon_sym_xor_eq] = ACTIONS(6243),
    [anon_sym_LT_EQ_GT] = ACTIONS(6245),
    [anon_sym_or] = ACTIONS(6243),
    [anon_sym_and] = ACTIONS(6243),
    [anon_sym_bitor] = ACTIONS(6243),
    [anon_sym_xor] = ACTIONS(6243),
    [anon_sym_bitand] = ACTIONS(6243),
    [anon_sym_not_eq] = ACTIONS(6243),
    [anon_sym_DASH_DASH] = ACTIONS(6245),
    [anon_sym_PLUS_PLUS] = ACTIONS(6245),
    [anon_sym_DOT] = ACTIONS(6243),
    [anon_sym_DOT_STAR] = ACTIONS(6245),
    [anon_sym_DASH_GT] = ACTIONS(6245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6243),
  },
  [2786] = {
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5413),
    [anon_sym_COMMA] = ACTIONS(5413),
    [aux_sym_preproc_if_token2] = ACTIONS(5413),
    [aux_sym_preproc_else_token1] = ACTIONS(5413),
    [aux_sym_preproc_elif_token1] = ACTIONS(5413),
    [anon_sym_LPAREN2] = ACTIONS(5413),
    [anon_sym_DASH] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5411),
    [anon_sym_STAR] = ACTIONS(5411),
    [anon_sym_SLASH] = ACTIONS(5411),
    [anon_sym_PERCENT] = ACTIONS(5411),
    [anon_sym_PIPE_PIPE] = ACTIONS(5413),
    [anon_sym_AMP_AMP] = ACTIONS(5413),
    [anon_sym_PIPE] = ACTIONS(5411),
    [anon_sym_CARET] = ACTIONS(5411),
    [anon_sym_AMP] = ACTIONS(5411),
    [anon_sym_EQ_EQ] = ACTIONS(5413),
    [anon_sym_BANG_EQ] = ACTIONS(5413),
    [anon_sym_GT] = ACTIONS(5411),
    [anon_sym_GT_EQ] = ACTIONS(5413),
    [anon_sym_LT_EQ] = ACTIONS(5411),
    [anon_sym_LT] = ACTIONS(5411),
    [anon_sym_LT_LT] = ACTIONS(5411),
    [anon_sym_GT_GT] = ACTIONS(5411),
    [anon_sym_LBRACK] = ACTIONS(5413),
    [anon_sym_EQ] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_STAR_EQ] = ACTIONS(5413),
    [anon_sym_SLASH_EQ] = ACTIONS(5413),
    [anon_sym_PERCENT_EQ] = ACTIONS(5413),
    [anon_sym_PLUS_EQ] = ACTIONS(5413),
    [anon_sym_DASH_EQ] = ACTIONS(5413),
    [anon_sym_LT_LT_EQ] = ACTIONS(5413),
    [anon_sym_GT_GT_EQ] = ACTIONS(5413),
    [anon_sym_AMP_EQ] = ACTIONS(5413),
    [anon_sym_CARET_EQ] = ACTIONS(5413),
    [anon_sym_PIPE_EQ] = ACTIONS(5413),
    [anon_sym_and_eq] = ACTIONS(5411),
    [anon_sym_or_eq] = ACTIONS(5411),
    [anon_sym_xor_eq] = ACTIONS(5411),
    [anon_sym_LT_EQ_GT] = ACTIONS(5413),
    [anon_sym_or] = ACTIONS(5411),
    [anon_sym_and] = ACTIONS(5411),
    [anon_sym_bitor] = ACTIONS(5411),
    [anon_sym_xor] = ACTIONS(5411),
    [anon_sym_bitand] = ACTIONS(5411),
    [anon_sym_not_eq] = ACTIONS(5411),
    [anon_sym_DASH_DASH] = ACTIONS(5413),
    [anon_sym_PLUS_PLUS] = ACTIONS(5413),
    [anon_sym_DOT] = ACTIONS(5411),
    [anon_sym_DOT_STAR] = ACTIONS(5413),
    [anon_sym_DASH_GT] = ACTIONS(5413),
    [anon_sym_L_DQUOTE] = ACTIONS(5413),
    [anon_sym_u_DQUOTE] = ACTIONS(5413),
    [anon_sym_U_DQUOTE] = ACTIONS(5413),
    [anon_sym_u8_DQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5413),
    [anon_sym_LR_DQUOTE] = ACTIONS(5413),
    [anon_sym_uR_DQUOTE] = ACTIONS(5413),
    [anon_sym_UR_DQUOTE] = ACTIONS(5413),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5413),
    [sym_literal_suffix] = ACTIONS(5411),
  },
  [2787] = {
    [sym_identifier] = ACTIONS(5736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5738),
    [anon_sym_COMMA] = ACTIONS(5738),
    [anon_sym_RPAREN] = ACTIONS(5738),
    [aux_sym_preproc_if_token2] = ACTIONS(5738),
    [aux_sym_preproc_else_token1] = ACTIONS(5738),
    [aux_sym_preproc_elif_token1] = ACTIONS(5736),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5738),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5738),
    [anon_sym_LPAREN2] = ACTIONS(5738),
    [anon_sym_DASH] = ACTIONS(5736),
    [anon_sym_PLUS] = ACTIONS(5736),
    [anon_sym_STAR] = ACTIONS(5736),
    [anon_sym_SLASH] = ACTIONS(5736),
    [anon_sym_PERCENT] = ACTIONS(5736),
    [anon_sym_PIPE_PIPE] = ACTIONS(5738),
    [anon_sym_AMP_AMP] = ACTIONS(5738),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_CARET] = ACTIONS(5736),
    [anon_sym_AMP] = ACTIONS(5736),
    [anon_sym_EQ_EQ] = ACTIONS(5738),
    [anon_sym_BANG_EQ] = ACTIONS(5738),
    [anon_sym_GT] = ACTIONS(5736),
    [anon_sym_GT_EQ] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5736),
    [anon_sym_LT] = ACTIONS(5736),
    [anon_sym_LT_LT] = ACTIONS(5736),
    [anon_sym_GT_GT] = ACTIONS(5736),
    [anon_sym_SEMI] = ACTIONS(5738),
    [anon_sym___attribute__] = ACTIONS(5736),
    [anon_sym_LBRACE] = ACTIONS(5738),
    [anon_sym_RBRACE] = ACTIONS(5738),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_RBRACK] = ACTIONS(5738),
    [anon_sym_EQ] = ACTIONS(5736),
    [anon_sym_COLON] = ACTIONS(5738),
    [anon_sym_QMARK] = ACTIONS(5738),
    [anon_sym_STAR_EQ] = ACTIONS(5738),
    [anon_sym_SLASH_EQ] = ACTIONS(5738),
    [anon_sym_PERCENT_EQ] = ACTIONS(5738),
    [anon_sym_PLUS_EQ] = ACTIONS(5738),
    [anon_sym_DASH_EQ] = ACTIONS(5738),
    [anon_sym_LT_LT_EQ] = ACTIONS(5738),
    [anon_sym_GT_GT_EQ] = ACTIONS(5738),
    [anon_sym_AMP_EQ] = ACTIONS(5738),
    [anon_sym_CARET_EQ] = ACTIONS(5738),
    [anon_sym_PIPE_EQ] = ACTIONS(5738),
    [anon_sym_and_eq] = ACTIONS(5736),
    [anon_sym_or_eq] = ACTIONS(5736),
    [anon_sym_xor_eq] = ACTIONS(5736),
    [anon_sym_LT_EQ_GT] = ACTIONS(5738),
    [anon_sym_or] = ACTIONS(5736),
    [anon_sym_and] = ACTIONS(5736),
    [anon_sym_bitor] = ACTIONS(5736),
    [anon_sym_xor] = ACTIONS(5736),
    [anon_sym_bitand] = ACTIONS(5736),
    [anon_sym_not_eq] = ACTIONS(5736),
    [anon_sym_DASH_DASH] = ACTIONS(5738),
    [anon_sym_PLUS_PLUS] = ACTIONS(5738),
    [anon_sym_DOT] = ACTIONS(5736),
    [anon_sym_DOT_STAR] = ACTIONS(5738),
    [anon_sym_DASH_GT] = ACTIONS(5738),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5736),
    [anon_sym_decltype] = ACTIONS(5736),
  },
  [2788] = {
    [sym_identifier] = ACTIONS(5771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5773),
    [anon_sym_COMMA] = ACTIONS(5773),
    [anon_sym_RPAREN] = ACTIONS(5773),
    [aux_sym_preproc_if_token2] = ACTIONS(5773),
    [aux_sym_preproc_else_token1] = ACTIONS(5773),
    [aux_sym_preproc_elif_token1] = ACTIONS(5771),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5773),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5773),
    [anon_sym_LPAREN2] = ACTIONS(5773),
    [anon_sym_DASH] = ACTIONS(5771),
    [anon_sym_PLUS] = ACTIONS(5771),
    [anon_sym_STAR] = ACTIONS(5771),
    [anon_sym_SLASH] = ACTIONS(5771),
    [anon_sym_PERCENT] = ACTIONS(5771),
    [anon_sym_PIPE_PIPE] = ACTIONS(5773),
    [anon_sym_AMP_AMP] = ACTIONS(5773),
    [anon_sym_PIPE] = ACTIONS(5771),
    [anon_sym_CARET] = ACTIONS(5771),
    [anon_sym_AMP] = ACTIONS(5771),
    [anon_sym_EQ_EQ] = ACTIONS(5773),
    [anon_sym_BANG_EQ] = ACTIONS(5773),
    [anon_sym_GT] = ACTIONS(5771),
    [anon_sym_GT_EQ] = ACTIONS(5773),
    [anon_sym_LT_EQ] = ACTIONS(5771),
    [anon_sym_LT] = ACTIONS(5771),
    [anon_sym_LT_LT] = ACTIONS(5771),
    [anon_sym_GT_GT] = ACTIONS(5771),
    [anon_sym_SEMI] = ACTIONS(5773),
    [anon_sym___attribute__] = ACTIONS(5771),
    [anon_sym_LBRACE] = ACTIONS(5773),
    [anon_sym_RBRACE] = ACTIONS(5773),
    [anon_sym_LBRACK] = ACTIONS(5773),
    [anon_sym_RBRACK] = ACTIONS(5773),
    [anon_sym_EQ] = ACTIONS(5771),
    [anon_sym_COLON] = ACTIONS(5773),
    [anon_sym_QMARK] = ACTIONS(5773),
    [anon_sym_STAR_EQ] = ACTIONS(5773),
    [anon_sym_SLASH_EQ] = ACTIONS(5773),
    [anon_sym_PERCENT_EQ] = ACTIONS(5773),
    [anon_sym_PLUS_EQ] = ACTIONS(5773),
    [anon_sym_DASH_EQ] = ACTIONS(5773),
    [anon_sym_LT_LT_EQ] = ACTIONS(5773),
    [anon_sym_GT_GT_EQ] = ACTIONS(5773),
    [anon_sym_AMP_EQ] = ACTIONS(5773),
    [anon_sym_CARET_EQ] = ACTIONS(5773),
    [anon_sym_PIPE_EQ] = ACTIONS(5773),
    [anon_sym_and_eq] = ACTIONS(5771),
    [anon_sym_or_eq] = ACTIONS(5771),
    [anon_sym_xor_eq] = ACTIONS(5771),
    [anon_sym_LT_EQ_GT] = ACTIONS(5773),
    [anon_sym_or] = ACTIONS(5771),
    [anon_sym_and] = ACTIONS(5771),
    [anon_sym_bitor] = ACTIONS(5771),
    [anon_sym_xor] = ACTIONS(5771),
    [anon_sym_bitand] = ACTIONS(5771),
    [anon_sym_not_eq] = ACTIONS(5771),
    [anon_sym_DASH_DASH] = ACTIONS(5773),
    [anon_sym_PLUS_PLUS] = ACTIONS(5773),
    [anon_sym_DOT] = ACTIONS(5771),
    [anon_sym_DOT_STAR] = ACTIONS(5773),
    [anon_sym_DASH_GT] = ACTIONS(5773),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5771),
    [anon_sym_decltype] = ACTIONS(5771),
  },
  [2789] = {
    [sym_identifier] = ACTIONS(5793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5795),
    [anon_sym_COMMA] = ACTIONS(5795),
    [anon_sym_RPAREN] = ACTIONS(5795),
    [aux_sym_preproc_if_token2] = ACTIONS(5795),
    [aux_sym_preproc_else_token1] = ACTIONS(5795),
    [aux_sym_preproc_elif_token1] = ACTIONS(5793),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5795),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5795),
    [anon_sym_LPAREN2] = ACTIONS(5795),
    [anon_sym_DASH] = ACTIONS(5793),
    [anon_sym_PLUS] = ACTIONS(5793),
    [anon_sym_STAR] = ACTIONS(5793),
    [anon_sym_SLASH] = ACTIONS(5793),
    [anon_sym_PERCENT] = ACTIONS(5793),
    [anon_sym_PIPE_PIPE] = ACTIONS(5795),
    [anon_sym_AMP_AMP] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5793),
    [anon_sym_CARET] = ACTIONS(5793),
    [anon_sym_AMP] = ACTIONS(5793),
    [anon_sym_EQ_EQ] = ACTIONS(5795),
    [anon_sym_BANG_EQ] = ACTIONS(5795),
    [anon_sym_GT] = ACTIONS(5793),
    [anon_sym_GT_EQ] = ACTIONS(5795),
    [anon_sym_LT_EQ] = ACTIONS(5793),
    [anon_sym_LT] = ACTIONS(5793),
    [anon_sym_LT_LT] = ACTIONS(5793),
    [anon_sym_GT_GT] = ACTIONS(5793),
    [anon_sym_SEMI] = ACTIONS(5795),
    [anon_sym___attribute__] = ACTIONS(5793),
    [anon_sym_LBRACE] = ACTIONS(5795),
    [anon_sym_RBRACE] = ACTIONS(5795),
    [anon_sym_LBRACK] = ACTIONS(5795),
    [anon_sym_RBRACK] = ACTIONS(5795),
    [anon_sym_EQ] = ACTIONS(5793),
    [anon_sym_COLON] = ACTIONS(5795),
    [anon_sym_QMARK] = ACTIONS(5795),
    [anon_sym_STAR_EQ] = ACTIONS(5795),
    [anon_sym_SLASH_EQ] = ACTIONS(5795),
    [anon_sym_PERCENT_EQ] = ACTIONS(5795),
    [anon_sym_PLUS_EQ] = ACTIONS(5795),
    [anon_sym_DASH_EQ] = ACTIONS(5795),
    [anon_sym_LT_LT_EQ] = ACTIONS(5795),
    [anon_sym_GT_GT_EQ] = ACTIONS(5795),
    [anon_sym_AMP_EQ] = ACTIONS(5795),
    [anon_sym_CARET_EQ] = ACTIONS(5795),
    [anon_sym_PIPE_EQ] = ACTIONS(5795),
    [anon_sym_and_eq] = ACTIONS(5793),
    [anon_sym_or_eq] = ACTIONS(5793),
    [anon_sym_xor_eq] = ACTIONS(5793),
    [anon_sym_LT_EQ_GT] = ACTIONS(5795),
    [anon_sym_or] = ACTIONS(5793),
    [anon_sym_and] = ACTIONS(5793),
    [anon_sym_bitor] = ACTIONS(5793),
    [anon_sym_xor] = ACTIONS(5793),
    [anon_sym_bitand] = ACTIONS(5793),
    [anon_sym_not_eq] = ACTIONS(5793),
    [anon_sym_DASH_DASH] = ACTIONS(5795),
    [anon_sym_PLUS_PLUS] = ACTIONS(5795),
    [anon_sym_DOT] = ACTIONS(5793),
    [anon_sym_DOT_STAR] = ACTIONS(5795),
    [anon_sym_DASH_GT] = ACTIONS(5795),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5793),
    [anon_sym_decltype] = ACTIONS(5793),
  },
  [2790] = {
    [sym_identifier] = ACTIONS(5755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5757),
    [anon_sym_COMMA] = ACTIONS(5757),
    [anon_sym_RPAREN] = ACTIONS(5757),
    [aux_sym_preproc_if_token2] = ACTIONS(5757),
    [aux_sym_preproc_else_token1] = ACTIONS(5757),
    [aux_sym_preproc_elif_token1] = ACTIONS(5755),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5757),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5757),
    [anon_sym_LPAREN2] = ACTIONS(5757),
    [anon_sym_DASH] = ACTIONS(5755),
    [anon_sym_PLUS] = ACTIONS(5755),
    [anon_sym_STAR] = ACTIONS(5755),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_PERCENT] = ACTIONS(5755),
    [anon_sym_PIPE_PIPE] = ACTIONS(5757),
    [anon_sym_AMP_AMP] = ACTIONS(5757),
    [anon_sym_PIPE] = ACTIONS(5755),
    [anon_sym_CARET] = ACTIONS(5755),
    [anon_sym_AMP] = ACTIONS(5755),
    [anon_sym_EQ_EQ] = ACTIONS(5757),
    [anon_sym_BANG_EQ] = ACTIONS(5757),
    [anon_sym_GT] = ACTIONS(5755),
    [anon_sym_GT_EQ] = ACTIONS(5757),
    [anon_sym_LT_EQ] = ACTIONS(5755),
    [anon_sym_LT] = ACTIONS(5755),
    [anon_sym_LT_LT] = ACTIONS(5755),
    [anon_sym_GT_GT] = ACTIONS(5755),
    [anon_sym_SEMI] = ACTIONS(5757),
    [anon_sym___attribute__] = ACTIONS(5755),
    [anon_sym_LBRACE] = ACTIONS(5757),
    [anon_sym_RBRACE] = ACTIONS(5757),
    [anon_sym_LBRACK] = ACTIONS(5757),
    [anon_sym_RBRACK] = ACTIONS(5757),
    [anon_sym_EQ] = ACTIONS(5755),
    [anon_sym_COLON] = ACTIONS(5757),
    [anon_sym_QMARK] = ACTIONS(5757),
    [anon_sym_STAR_EQ] = ACTIONS(5757),
    [anon_sym_SLASH_EQ] = ACTIONS(5757),
    [anon_sym_PERCENT_EQ] = ACTIONS(5757),
    [anon_sym_PLUS_EQ] = ACTIONS(5757),
    [anon_sym_DASH_EQ] = ACTIONS(5757),
    [anon_sym_LT_LT_EQ] = ACTIONS(5757),
    [anon_sym_GT_GT_EQ] = ACTIONS(5757),
    [anon_sym_AMP_EQ] = ACTIONS(5757),
    [anon_sym_CARET_EQ] = ACTIONS(5757),
    [anon_sym_PIPE_EQ] = ACTIONS(5757),
    [anon_sym_and_eq] = ACTIONS(5755),
    [anon_sym_or_eq] = ACTIONS(5755),
    [anon_sym_xor_eq] = ACTIONS(5755),
    [anon_sym_LT_EQ_GT] = ACTIONS(5757),
    [anon_sym_or] = ACTIONS(5755),
    [anon_sym_and] = ACTIONS(5755),
    [anon_sym_bitor] = ACTIONS(5755),
    [anon_sym_xor] = ACTIONS(5755),
    [anon_sym_bitand] = ACTIONS(5755),
    [anon_sym_not_eq] = ACTIONS(5755),
    [anon_sym_DASH_DASH] = ACTIONS(5757),
    [anon_sym_PLUS_PLUS] = ACTIONS(5757),
    [anon_sym_DOT] = ACTIONS(5755),
    [anon_sym_DOT_STAR] = ACTIONS(5757),
    [anon_sym_DASH_GT] = ACTIONS(5757),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5755),
    [anon_sym_decltype] = ACTIONS(5755),
  },
  [2791] = {
    [sym_identifier] = ACTIONS(4125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4127),
    [anon_sym_COMMA] = ACTIONS(4127),
    [anon_sym_RPAREN] = ACTIONS(4127),
    [anon_sym_LPAREN2] = ACTIONS(4127),
    [anon_sym_TILDE] = ACTIONS(4127),
    [anon_sym_STAR] = ACTIONS(4127),
    [anon_sym_AMP_AMP] = ACTIONS(4127),
    [anon_sym_AMP] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym___extension__] = ACTIONS(4125),
    [anon_sym_extern] = ACTIONS(4125),
    [anon_sym___attribute__] = ACTIONS(4125),
    [anon_sym_COLON_COLON] = ACTIONS(4127),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4127),
    [anon_sym___declspec] = ACTIONS(4125),
    [anon_sym___based] = ACTIONS(4125),
    [anon_sym___cdecl] = ACTIONS(4125),
    [anon_sym___clrcall] = ACTIONS(4125),
    [anon_sym___stdcall] = ACTIONS(4125),
    [anon_sym___fastcall] = ACTIONS(4125),
    [anon_sym___thiscall] = ACTIONS(4125),
    [anon_sym___vectorcall] = ACTIONS(4125),
    [anon_sym_LBRACE] = ACTIONS(4127),
    [anon_sym_LBRACK] = ACTIONS(4125),
    [anon_sym_EQ] = ACTIONS(4127),
    [anon_sym_static] = ACTIONS(4125),
    [anon_sym_register] = ACTIONS(4125),
    [anon_sym_inline] = ACTIONS(4125),
    [anon_sym___inline] = ACTIONS(4125),
    [anon_sym___inline__] = ACTIONS(4125),
    [anon_sym___forceinline] = ACTIONS(4125),
    [anon_sym_thread_local] = ACTIONS(4125),
    [anon_sym___thread] = ACTIONS(4125),
    [anon_sym_const] = ACTIONS(4125),
    [anon_sym_constexpr] = ACTIONS(4125),
    [anon_sym_volatile] = ACTIONS(4125),
    [anon_sym_restrict] = ACTIONS(4125),
    [anon_sym___restrict__] = ACTIONS(4125),
    [anon_sym__Atomic] = ACTIONS(4125),
    [anon_sym__Noreturn] = ACTIONS(4125),
    [anon_sym_noreturn] = ACTIONS(4125),
    [anon_sym_mutable] = ACTIONS(4125),
    [anon_sym_constinit] = ACTIONS(4125),
    [anon_sym_consteval] = ACTIONS(4125),
    [anon_sym_PROGMEM] = ACTIONS(4125),
    [anon_sym_COLON] = ACTIONS(4125),
    [anon_sym_asm] = ACTIONS(4125),
    [anon_sym___asm__] = ACTIONS(4125),
    [anon_sym_DASH_GT] = ACTIONS(4127),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4125),
    [anon_sym_final] = ACTIONS(4125),
    [anon_sym_override] = ACTIONS(4125),
    [anon_sym_virtual] = ACTIONS(4125),
    [anon_sym_alignas] = ACTIONS(4125),
    [anon_sym_explicit] = ACTIONS(4125),
    [anon_sym_template] = ACTIONS(4125),
    [anon_sym_GT2] = ACTIONS(4127),
    [anon_sym_operator] = ACTIONS(4125),
    [anon_sym_try] = ACTIONS(4125),
    [anon_sym_public] = ACTIONS(4125),
    [anon_sym_private] = ACTIONS(4125),
    [anon_sym_protected] = ACTIONS(4125),
    [anon_sym_requires] = ACTIONS(4125),
  },
  [2792] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2793),
    [sym_identifier] = ACTIONS(5363),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5730),
    [anon_sym_COMMA] = ACTIONS(5730),
    [anon_sym_RPAREN] = ACTIONS(5730),
    [anon_sym_LPAREN2] = ACTIONS(5730),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_PLUS] = ACTIONS(5733),
    [anon_sym_STAR] = ACTIONS(5733),
    [anon_sym_SLASH] = ACTIONS(5733),
    [anon_sym_PERCENT] = ACTIONS(5733),
    [anon_sym_PIPE_PIPE] = ACTIONS(5730),
    [anon_sym_AMP_AMP] = ACTIONS(5730),
    [anon_sym_PIPE] = ACTIONS(5733),
    [anon_sym_CARET] = ACTIONS(5733),
    [anon_sym_AMP] = ACTIONS(5733),
    [anon_sym_EQ_EQ] = ACTIONS(5730),
    [anon_sym_BANG_EQ] = ACTIONS(5730),
    [anon_sym_GT] = ACTIONS(5733),
    [anon_sym_GT_EQ] = ACTIONS(5730),
    [anon_sym_LT_EQ] = ACTIONS(5733),
    [anon_sym_LT] = ACTIONS(5733),
    [anon_sym_LT_LT] = ACTIONS(5733),
    [anon_sym_GT_GT] = ACTIONS(5733),
    [anon_sym___attribute__] = ACTIONS(5733),
    [anon_sym_LBRACE] = ACTIONS(5730),
    [anon_sym_signed] = ACTIONS(6247),
    [anon_sym_unsigned] = ACTIONS(6247),
    [anon_sym_long] = ACTIONS(6247),
    [anon_sym_short] = ACTIONS(6247),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_EQ] = ACTIONS(5733),
    [aux_sym_primitive_type_token1] = ACTIONS(5363),
    [anon_sym_byte] = ACTIONS(5363),
    [anon_sym_word] = ACTIONS(5363),
    [anon_sym_QMARK] = ACTIONS(5730),
    [anon_sym_STAR_EQ] = ACTIONS(5730),
    [anon_sym_SLASH_EQ] = ACTIONS(5730),
    [anon_sym_PERCENT_EQ] = ACTIONS(5730),
    [anon_sym_PLUS_EQ] = ACTIONS(5730),
    [anon_sym_DASH_EQ] = ACTIONS(5730),
    [anon_sym_LT_LT_EQ] = ACTIONS(5730),
    [anon_sym_GT_GT_EQ] = ACTIONS(5730),
    [anon_sym_AMP_EQ] = ACTIONS(5730),
    [anon_sym_CARET_EQ] = ACTIONS(5730),
    [anon_sym_PIPE_EQ] = ACTIONS(5730),
    [anon_sym_and_eq] = ACTIONS(5733),
    [anon_sym_or_eq] = ACTIONS(5733),
    [anon_sym_xor_eq] = ACTIONS(5733),
    [anon_sym_LT_EQ_GT] = ACTIONS(5730),
    [anon_sym_or] = ACTIONS(5733),
    [anon_sym_and] = ACTIONS(5733),
    [anon_sym_bitor] = ACTIONS(5733),
    [anon_sym_xor] = ACTIONS(5733),
    [anon_sym_bitand] = ACTIONS(5733),
    [anon_sym_not_eq] = ACTIONS(5733),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_DOT] = ACTIONS(5733),
    [anon_sym_DOT_STAR] = ACTIONS(5730),
    [anon_sym_DASH_GT] = ACTIONS(5733),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5733),
    [anon_sym_decltype] = ACTIONS(5733),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5730),
  },
  [2793] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2793),
    [sym_identifier] = ACTIONS(5363),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5365),
    [anon_sym_COMMA] = ACTIONS(5365),
    [anon_sym_RPAREN] = ACTIONS(5365),
    [anon_sym_LPAREN2] = ACTIONS(5365),
    [anon_sym_DASH] = ACTIONS(5363),
    [anon_sym_PLUS] = ACTIONS(5363),
    [anon_sym_STAR] = ACTIONS(5363),
    [anon_sym_SLASH] = ACTIONS(5363),
    [anon_sym_PERCENT] = ACTIONS(5363),
    [anon_sym_PIPE_PIPE] = ACTIONS(5365),
    [anon_sym_AMP_AMP] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5363),
    [anon_sym_CARET] = ACTIONS(5363),
    [anon_sym_AMP] = ACTIONS(5363),
    [anon_sym_EQ_EQ] = ACTIONS(5365),
    [anon_sym_BANG_EQ] = ACTIONS(5365),
    [anon_sym_GT] = ACTIONS(5363),
    [anon_sym_GT_EQ] = ACTIONS(5365),
    [anon_sym_LT_EQ] = ACTIONS(5363),
    [anon_sym_LT] = ACTIONS(5363),
    [anon_sym_LT_LT] = ACTIONS(5363),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym___attribute__] = ACTIONS(5363),
    [anon_sym_LBRACE] = ACTIONS(5365),
    [anon_sym_signed] = ACTIONS(6247),
    [anon_sym_unsigned] = ACTIONS(6247),
    [anon_sym_long] = ACTIONS(6247),
    [anon_sym_short] = ACTIONS(6247),
    [anon_sym_LBRACK] = ACTIONS(5365),
    [anon_sym_EQ] = ACTIONS(5363),
    [aux_sym_primitive_type_token1] = ACTIONS(5363),
    [anon_sym_byte] = ACTIONS(5363),
    [anon_sym_word] = ACTIONS(5363),
    [anon_sym_QMARK] = ACTIONS(5365),
    [anon_sym_STAR_EQ] = ACTIONS(5365),
    [anon_sym_SLASH_EQ] = ACTIONS(5365),
    [anon_sym_PERCENT_EQ] = ACTIONS(5365),
    [anon_sym_PLUS_EQ] = ACTIONS(5365),
    [anon_sym_DASH_EQ] = ACTIONS(5365),
    [anon_sym_LT_LT_EQ] = ACTIONS(5365),
    [anon_sym_GT_GT_EQ] = ACTIONS(5365),
    [anon_sym_AMP_EQ] = ACTIONS(5365),
    [anon_sym_CARET_EQ] = ACTIONS(5365),
    [anon_sym_PIPE_EQ] = ACTIONS(5365),
    [anon_sym_and_eq] = ACTIONS(5363),
    [anon_sym_or_eq] = ACTIONS(5363),
    [anon_sym_xor_eq] = ACTIONS(5363),
    [anon_sym_LT_EQ_GT] = ACTIONS(5365),
    [anon_sym_or] = ACTIONS(5363),
    [anon_sym_and] = ACTIONS(5363),
    [anon_sym_bitor] = ACTIONS(5363),
    [anon_sym_xor] = ACTIONS(5363),
    [anon_sym_bitand] = ACTIONS(5363),
    [anon_sym_not_eq] = ACTIONS(5363),
    [anon_sym_DASH_DASH] = ACTIONS(5365),
    [anon_sym_PLUS_PLUS] = ACTIONS(5365),
    [anon_sym_DOT] = ACTIONS(5363),
    [anon_sym_DOT_STAR] = ACTIONS(5365),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5363),
    [anon_sym_decltype] = ACTIONS(5363),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5365),
  },
  [2794] = {
    [sym_identifier] = ACTIONS(6250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(6252),
    [aux_sym_preproc_if_token2] = ACTIONS(6252),
    [aux_sym_preproc_else_token1] = ACTIONS(6252),
    [aux_sym_preproc_elif_token1] = ACTIONS(6250),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6252),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6252),
    [anon_sym_LPAREN2] = ACTIONS(6252),
    [anon_sym_DASH] = ACTIONS(6250),
    [anon_sym_PLUS] = ACTIONS(6250),
    [anon_sym_STAR] = ACTIONS(6250),
    [anon_sym_SLASH] = ACTIONS(6250),
    [anon_sym_PERCENT] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6250),
    [anon_sym_CARET] = ACTIONS(6250),
    [anon_sym_AMP] = ACTIONS(6250),
    [anon_sym_EQ_EQ] = ACTIONS(6252),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_GT] = ACTIONS(6250),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6250),
    [anon_sym_LT] = ACTIONS(6250),
    [anon_sym_LT_LT] = ACTIONS(6250),
    [anon_sym_GT_GT] = ACTIONS(6250),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym___attribute__] = ACTIONS(6250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_RBRACE] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_RBRACK] = ACTIONS(6252),
    [anon_sym_EQ] = ACTIONS(6250),
    [anon_sym_COLON] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_and_eq] = ACTIONS(6250),
    [anon_sym_or_eq] = ACTIONS(6250),
    [anon_sym_xor_eq] = ACTIONS(6250),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_bitor] = ACTIONS(6250),
    [anon_sym_xor] = ACTIONS(6250),
    [anon_sym_bitand] = ACTIONS(6250),
    [anon_sym_not_eq] = ACTIONS(6250),
    [anon_sym_DASH_DASH] = ACTIONS(6252),
    [anon_sym_PLUS_PLUS] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6250),
    [anon_sym_DOT_STAR] = ACTIONS(6252),
    [anon_sym_DASH_GT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6250),
  },
  [2795] = {
    [sym_identifier] = ACTIONS(6254),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6256),
    [anon_sym_COMMA] = ACTIONS(6256),
    [anon_sym_RPAREN] = ACTIONS(6256),
    [aux_sym_preproc_if_token2] = ACTIONS(6256),
    [aux_sym_preproc_else_token1] = ACTIONS(6256),
    [aux_sym_preproc_elif_token1] = ACTIONS(6254),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6256),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6256),
    [anon_sym_LPAREN2] = ACTIONS(6256),
    [anon_sym_DASH] = ACTIONS(6254),
    [anon_sym_PLUS] = ACTIONS(6254),
    [anon_sym_STAR] = ACTIONS(6254),
    [anon_sym_SLASH] = ACTIONS(6254),
    [anon_sym_PERCENT] = ACTIONS(6254),
    [anon_sym_PIPE_PIPE] = ACTIONS(6256),
    [anon_sym_AMP_AMP] = ACTIONS(6256),
    [anon_sym_PIPE] = ACTIONS(6254),
    [anon_sym_CARET] = ACTIONS(6254),
    [anon_sym_AMP] = ACTIONS(6254),
    [anon_sym_EQ_EQ] = ACTIONS(6256),
    [anon_sym_BANG_EQ] = ACTIONS(6256),
    [anon_sym_GT] = ACTIONS(6254),
    [anon_sym_GT_EQ] = ACTIONS(6256),
    [anon_sym_LT_EQ] = ACTIONS(6254),
    [anon_sym_LT] = ACTIONS(6254),
    [anon_sym_LT_LT] = ACTIONS(6254),
    [anon_sym_GT_GT] = ACTIONS(6254),
    [anon_sym_SEMI] = ACTIONS(6256),
    [anon_sym___attribute__] = ACTIONS(6254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6256),
    [anon_sym_LBRACE] = ACTIONS(6256),
    [anon_sym_RBRACE] = ACTIONS(6256),
    [anon_sym_LBRACK] = ACTIONS(6254),
    [anon_sym_RBRACK] = ACTIONS(6256),
    [anon_sym_EQ] = ACTIONS(6254),
    [anon_sym_COLON] = ACTIONS(6256),
    [anon_sym_QMARK] = ACTIONS(6256),
    [anon_sym_STAR_EQ] = ACTIONS(6256),
    [anon_sym_SLASH_EQ] = ACTIONS(6256),
    [anon_sym_PERCENT_EQ] = ACTIONS(6256),
    [anon_sym_PLUS_EQ] = ACTIONS(6256),
    [anon_sym_DASH_EQ] = ACTIONS(6256),
    [anon_sym_LT_LT_EQ] = ACTIONS(6256),
    [anon_sym_GT_GT_EQ] = ACTIONS(6256),
    [anon_sym_AMP_EQ] = ACTIONS(6256),
    [anon_sym_CARET_EQ] = ACTIONS(6256),
    [anon_sym_PIPE_EQ] = ACTIONS(6256),
    [anon_sym_and_eq] = ACTIONS(6254),
    [anon_sym_or_eq] = ACTIONS(6254),
    [anon_sym_xor_eq] = ACTIONS(6254),
    [anon_sym_LT_EQ_GT] = ACTIONS(6256),
    [anon_sym_or] = ACTIONS(6254),
    [anon_sym_and] = ACTIONS(6254),
    [anon_sym_bitor] = ACTIONS(6254),
    [anon_sym_xor] = ACTIONS(6254),
    [anon_sym_bitand] = ACTIONS(6254),
    [anon_sym_not_eq] = ACTIONS(6254),
    [anon_sym_DASH_DASH] = ACTIONS(6256),
    [anon_sym_PLUS_PLUS] = ACTIONS(6256),
    [anon_sym_DOT] = ACTIONS(6254),
    [anon_sym_DOT_STAR] = ACTIONS(6256),
    [anon_sym_DASH_GT] = ACTIONS(6256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6254),
  },
  [2796] = {
    [sym_identifier] = ACTIONS(6258),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6260),
    [anon_sym_COMMA] = ACTIONS(6260),
    [anon_sym_RPAREN] = ACTIONS(6260),
    [aux_sym_preproc_if_token2] = ACTIONS(6260),
    [aux_sym_preproc_else_token1] = ACTIONS(6260),
    [aux_sym_preproc_elif_token1] = ACTIONS(6258),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6260),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6260),
    [anon_sym_LPAREN2] = ACTIONS(6260),
    [anon_sym_DASH] = ACTIONS(6258),
    [anon_sym_PLUS] = ACTIONS(6258),
    [anon_sym_STAR] = ACTIONS(6258),
    [anon_sym_SLASH] = ACTIONS(6258),
    [anon_sym_PERCENT] = ACTIONS(6258),
    [anon_sym_PIPE_PIPE] = ACTIONS(6260),
    [anon_sym_AMP_AMP] = ACTIONS(6260),
    [anon_sym_PIPE] = ACTIONS(6258),
    [anon_sym_CARET] = ACTIONS(6258),
    [anon_sym_AMP] = ACTIONS(6258),
    [anon_sym_EQ_EQ] = ACTIONS(6260),
    [anon_sym_BANG_EQ] = ACTIONS(6260),
    [anon_sym_GT] = ACTIONS(6258),
    [anon_sym_GT_EQ] = ACTIONS(6260),
    [anon_sym_LT_EQ] = ACTIONS(6258),
    [anon_sym_LT] = ACTIONS(6258),
    [anon_sym_LT_LT] = ACTIONS(6258),
    [anon_sym_GT_GT] = ACTIONS(6258),
    [anon_sym_SEMI] = ACTIONS(6260),
    [anon_sym___attribute__] = ACTIONS(6258),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6260),
    [anon_sym_LBRACE] = ACTIONS(6260),
    [anon_sym_RBRACE] = ACTIONS(6260),
    [anon_sym_LBRACK] = ACTIONS(6258),
    [anon_sym_RBRACK] = ACTIONS(6260),
    [anon_sym_EQ] = ACTIONS(6258),
    [anon_sym_COLON] = ACTIONS(6260),
    [anon_sym_QMARK] = ACTIONS(6260),
    [anon_sym_STAR_EQ] = ACTIONS(6260),
    [anon_sym_SLASH_EQ] = ACTIONS(6260),
    [anon_sym_PERCENT_EQ] = ACTIONS(6260),
    [anon_sym_PLUS_EQ] = ACTIONS(6260),
    [anon_sym_DASH_EQ] = ACTIONS(6260),
    [anon_sym_LT_LT_EQ] = ACTIONS(6260),
    [anon_sym_GT_GT_EQ] = ACTIONS(6260),
    [anon_sym_AMP_EQ] = ACTIONS(6260),
    [anon_sym_CARET_EQ] = ACTIONS(6260),
    [anon_sym_PIPE_EQ] = ACTIONS(6260),
    [anon_sym_and_eq] = ACTIONS(6258),
    [anon_sym_or_eq] = ACTIONS(6258),
    [anon_sym_xor_eq] = ACTIONS(6258),
    [anon_sym_LT_EQ_GT] = ACTIONS(6260),
    [anon_sym_or] = ACTIONS(6258),
    [anon_sym_and] = ACTIONS(6258),
    [anon_sym_bitor] = ACTIONS(6258),
    [anon_sym_xor] = ACTIONS(6258),
    [anon_sym_bitand] = ACTIONS(6258),
    [anon_sym_not_eq] = ACTIONS(6258),
    [anon_sym_DASH_DASH] = ACTIONS(6260),
    [anon_sym_PLUS_PLUS] = ACTIONS(6260),
    [anon_sym_DOT] = ACTIONS(6258),
    [anon_sym_DOT_STAR] = ACTIONS(6260),
    [anon_sym_DASH_GT] = ACTIONS(6260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6258),
  },
  [2797] = {
    [sym_string_literal] = STATE(2616),
    [sym_raw_string_literal] = STATE(2616),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5799),
    [anon_sym_COMMA] = ACTIONS(5799),
    [anon_sym_RPAREN] = ACTIONS(5799),
    [anon_sym_LPAREN2] = ACTIONS(5799),
    [anon_sym_DASH] = ACTIONS(5797),
    [anon_sym_PLUS] = ACTIONS(5797),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_SLASH] = ACTIONS(5797),
    [anon_sym_PERCENT] = ACTIONS(5797),
    [anon_sym_PIPE_PIPE] = ACTIONS(5799),
    [anon_sym_AMP_AMP] = ACTIONS(5799),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_CARET] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_EQ_EQ] = ACTIONS(5799),
    [anon_sym_BANG_EQ] = ACTIONS(5799),
    [anon_sym_GT] = ACTIONS(5797),
    [anon_sym_GT_EQ] = ACTIONS(5799),
    [anon_sym_LT_EQ] = ACTIONS(5797),
    [anon_sym_LT] = ACTIONS(5797),
    [anon_sym_LT_LT] = ACTIONS(5797),
    [anon_sym_GT_GT] = ACTIONS(5797),
    [anon_sym_LBRACK] = ACTIONS(5799),
    [anon_sym_EQ] = ACTIONS(5797),
    [anon_sym_QMARK] = ACTIONS(5799),
    [anon_sym_STAR_EQ] = ACTIONS(5799),
    [anon_sym_SLASH_EQ] = ACTIONS(5799),
    [anon_sym_PERCENT_EQ] = ACTIONS(5799),
    [anon_sym_PLUS_EQ] = ACTIONS(5799),
    [anon_sym_DASH_EQ] = ACTIONS(5799),
    [anon_sym_LT_LT_EQ] = ACTIONS(5799),
    [anon_sym_GT_GT_EQ] = ACTIONS(5799),
    [anon_sym_AMP_EQ] = ACTIONS(5799),
    [anon_sym_CARET_EQ] = ACTIONS(5799),
    [anon_sym_PIPE_EQ] = ACTIONS(5799),
    [anon_sym_and_eq] = ACTIONS(5797),
    [anon_sym_or_eq] = ACTIONS(5797),
    [anon_sym_xor_eq] = ACTIONS(5797),
    [anon_sym_LT_EQ_GT] = ACTIONS(5799),
    [anon_sym_or] = ACTIONS(5797),
    [anon_sym_and] = ACTIONS(5797),
    [anon_sym_bitor] = ACTIONS(5797),
    [anon_sym_xor] = ACTIONS(5797),
    [anon_sym_bitand] = ACTIONS(5797),
    [anon_sym_not_eq] = ACTIONS(5797),
    [anon_sym_DASH_DASH] = ACTIONS(5799),
    [anon_sym_PLUS_PLUS] = ACTIONS(5799),
    [anon_sym_DOT] = ACTIONS(5797),
    [anon_sym_DOT_STAR] = ACTIONS(5799),
    [anon_sym_DASH_GT] = ACTIONS(5797),
    [anon_sym_L_DQUOTE] = ACTIONS(5184),
    [anon_sym_u_DQUOTE] = ACTIONS(5184),
    [anon_sym_U_DQUOTE] = ACTIONS(5184),
    [anon_sym_u8_DQUOTE] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5186),
    [anon_sym_LR_DQUOTE] = ACTIONS(5186),
    [anon_sym_uR_DQUOTE] = ACTIONS(5186),
    [anon_sym_UR_DQUOTE] = ACTIONS(5186),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5186),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5799),
    [sym_literal_suffix] = ACTIONS(6219),
  },
  [2798] = {
    [sym_attribute_specifier] = STATE(2247),
    [sym_field_declaration_list] = STATE(2983),
    [sym_virtual_specifier] = STATE(7849),
    [sym_base_class_clause] = STATE(8662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5471),
    [anon_sym_COMMA] = ACTIONS(5471),
    [anon_sym_RPAREN] = ACTIONS(5471),
    [anon_sym_LPAREN2] = ACTIONS(5471),
    [anon_sym_DASH] = ACTIONS(5469),
    [anon_sym_PLUS] = ACTIONS(5469),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_SLASH] = ACTIONS(5469),
    [anon_sym_PERCENT] = ACTIONS(5471),
    [anon_sym_PIPE_PIPE] = ACTIONS(5471),
    [anon_sym_AMP_AMP] = ACTIONS(5471),
    [anon_sym_PIPE] = ACTIONS(5469),
    [anon_sym_CARET] = ACTIONS(5471),
    [anon_sym_AMP] = ACTIONS(5469),
    [anon_sym_EQ_EQ] = ACTIONS(5471),
    [anon_sym_BANG_EQ] = ACTIONS(5471),
    [anon_sym_GT] = ACTIONS(5469),
    [anon_sym_GT_EQ] = ACTIONS(5471),
    [anon_sym_LT_EQ] = ACTIONS(5469),
    [anon_sym_LT] = ACTIONS(5469),
    [anon_sym_LT_LT] = ACTIONS(5471),
    [anon_sym_GT_GT] = ACTIONS(5471),
    [anon_sym_SEMI] = ACTIONS(5471),
    [anon_sym___extension__] = ACTIONS(5471),
    [anon_sym___attribute__] = ACTIONS(6262),
    [anon_sym_LBRACE] = ACTIONS(6264),
    [anon_sym_RBRACE] = ACTIONS(5471),
    [anon_sym_LBRACK] = ACTIONS(5471),
    [anon_sym_RBRACK] = ACTIONS(5471),
    [anon_sym_const] = ACTIONS(5469),
    [anon_sym_constexpr] = ACTIONS(5471),
    [anon_sym_volatile] = ACTIONS(5471),
    [anon_sym_restrict] = ACTIONS(5471),
    [anon_sym___restrict__] = ACTIONS(5471),
    [anon_sym__Atomic] = ACTIONS(5471),
    [anon_sym__Noreturn] = ACTIONS(5471),
    [anon_sym_noreturn] = ACTIONS(5471),
    [anon_sym_mutable] = ACTIONS(5471),
    [anon_sym_constinit] = ACTIONS(5471),
    [anon_sym_consteval] = ACTIONS(5471),
    [anon_sym_PROGMEM] = ACTIONS(5471),
    [anon_sym_COLON] = ACTIONS(5477),
    [anon_sym_QMARK] = ACTIONS(5471),
    [anon_sym_LT_EQ_GT] = ACTIONS(5471),
    [anon_sym_or] = ACTIONS(5471),
    [anon_sym_and] = ACTIONS(5471),
    [anon_sym_bitor] = ACTIONS(5471),
    [anon_sym_xor] = ACTIONS(5471),
    [anon_sym_bitand] = ACTIONS(5471),
    [anon_sym_not_eq] = ACTIONS(5471),
    [anon_sym_DASH_DASH] = ACTIONS(5471),
    [anon_sym_PLUS_PLUS] = ACTIONS(5471),
    [anon_sym_DOT] = ACTIONS(5469),
    [anon_sym_DOT_STAR] = ACTIONS(5471),
    [anon_sym_DASH_GT] = ACTIONS(5471),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5471),
    [anon_sym_decltype] = ACTIONS(5471),
    [anon_sym_final] = ACTIONS(6266),
    [anon_sym_override] = ACTIONS(6266),
    [anon_sym_requires] = ACTIONS(5471),
  },
  [2799] = {
    [sym_identifier] = ACTIONS(5777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5779),
    [anon_sym_COMMA] = ACTIONS(5779),
    [anon_sym_RPAREN] = ACTIONS(5779),
    [aux_sym_preproc_if_token2] = ACTIONS(5779),
    [aux_sym_preproc_else_token1] = ACTIONS(5779),
    [aux_sym_preproc_elif_token1] = ACTIONS(5777),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5779),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5779),
    [anon_sym_LPAREN2] = ACTIONS(5779),
    [anon_sym_DASH] = ACTIONS(5777),
    [anon_sym_PLUS] = ACTIONS(5777),
    [anon_sym_STAR] = ACTIONS(5777),
    [anon_sym_SLASH] = ACTIONS(5777),
    [anon_sym_PERCENT] = ACTIONS(5777),
    [anon_sym_PIPE_PIPE] = ACTIONS(5779),
    [anon_sym_AMP_AMP] = ACTIONS(5779),
    [anon_sym_PIPE] = ACTIONS(5777),
    [anon_sym_CARET] = ACTIONS(5777),
    [anon_sym_AMP] = ACTIONS(5777),
    [anon_sym_EQ_EQ] = ACTIONS(5779),
    [anon_sym_BANG_EQ] = ACTIONS(5779),
    [anon_sym_GT] = ACTIONS(5777),
    [anon_sym_GT_EQ] = ACTIONS(5779),
    [anon_sym_LT_EQ] = ACTIONS(5777),
    [anon_sym_LT] = ACTIONS(5777),
    [anon_sym_LT_LT] = ACTIONS(5777),
    [anon_sym_GT_GT] = ACTIONS(5777),
    [anon_sym_SEMI] = ACTIONS(5779),
    [anon_sym___attribute__] = ACTIONS(5777),
    [anon_sym_LBRACE] = ACTIONS(5779),
    [anon_sym_RBRACE] = ACTIONS(5779),
    [anon_sym_LBRACK] = ACTIONS(5779),
    [anon_sym_RBRACK] = ACTIONS(5779),
    [anon_sym_EQ] = ACTIONS(5777),
    [anon_sym_COLON] = ACTIONS(5779),
    [anon_sym_QMARK] = ACTIONS(5779),
    [anon_sym_STAR_EQ] = ACTIONS(5779),
    [anon_sym_SLASH_EQ] = ACTIONS(5779),
    [anon_sym_PERCENT_EQ] = ACTIONS(5779),
    [anon_sym_PLUS_EQ] = ACTIONS(5779),
    [anon_sym_DASH_EQ] = ACTIONS(5779),
    [anon_sym_LT_LT_EQ] = ACTIONS(5779),
    [anon_sym_GT_GT_EQ] = ACTIONS(5779),
    [anon_sym_AMP_EQ] = ACTIONS(5779),
    [anon_sym_CARET_EQ] = ACTIONS(5779),
    [anon_sym_PIPE_EQ] = ACTIONS(5779),
    [anon_sym_and_eq] = ACTIONS(5777),
    [anon_sym_or_eq] = ACTIONS(5777),
    [anon_sym_xor_eq] = ACTIONS(5777),
    [anon_sym_LT_EQ_GT] = ACTIONS(5779),
    [anon_sym_or] = ACTIONS(5777),
    [anon_sym_and] = ACTIONS(5777),
    [anon_sym_bitor] = ACTIONS(5777),
    [anon_sym_xor] = ACTIONS(5777),
    [anon_sym_bitand] = ACTIONS(5777),
    [anon_sym_not_eq] = ACTIONS(5777),
    [anon_sym_DASH_DASH] = ACTIONS(5779),
    [anon_sym_PLUS_PLUS] = ACTIONS(5779),
    [anon_sym_DOT] = ACTIONS(5777),
    [anon_sym_DOT_STAR] = ACTIONS(5779),
    [anon_sym_DASH_GT] = ACTIONS(5779),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5777),
    [anon_sym_decltype] = ACTIONS(5777),
  },
  [2800] = {
    [sym_identifier] = ACTIONS(5634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5636),
    [anon_sym_COMMA] = ACTIONS(5636),
    [anon_sym_RPAREN] = ACTIONS(5636),
    [aux_sym_preproc_if_token2] = ACTIONS(5636),
    [aux_sym_preproc_else_token1] = ACTIONS(5636),
    [aux_sym_preproc_elif_token1] = ACTIONS(5634),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5636),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5636),
    [anon_sym_LPAREN2] = ACTIONS(5636),
    [anon_sym_DASH] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(5634),
    [anon_sym_STAR] = ACTIONS(5634),
    [anon_sym_SLASH] = ACTIONS(5634),
    [anon_sym_PERCENT] = ACTIONS(5634),
    [anon_sym_PIPE_PIPE] = ACTIONS(5636),
    [anon_sym_AMP_AMP] = ACTIONS(5636),
    [anon_sym_PIPE] = ACTIONS(5634),
    [anon_sym_CARET] = ACTIONS(5634),
    [anon_sym_AMP] = ACTIONS(5634),
    [anon_sym_EQ_EQ] = ACTIONS(5636),
    [anon_sym_BANG_EQ] = ACTIONS(5636),
    [anon_sym_GT] = ACTIONS(5634),
    [anon_sym_GT_EQ] = ACTIONS(5636),
    [anon_sym_LT_EQ] = ACTIONS(5634),
    [anon_sym_LT] = ACTIONS(5634),
    [anon_sym_LT_LT] = ACTIONS(5634),
    [anon_sym_GT_GT] = ACTIONS(5634),
    [anon_sym_SEMI] = ACTIONS(5636),
    [anon_sym___attribute__] = ACTIONS(5634),
    [anon_sym_LBRACE] = ACTIONS(5636),
    [anon_sym_RBRACE] = ACTIONS(5636),
    [anon_sym_LBRACK] = ACTIONS(5636),
    [anon_sym_RBRACK] = ACTIONS(5636),
    [anon_sym_EQ] = ACTIONS(5634),
    [anon_sym_COLON] = ACTIONS(5636),
    [anon_sym_QMARK] = ACTIONS(5636),
    [anon_sym_STAR_EQ] = ACTIONS(5636),
    [anon_sym_SLASH_EQ] = ACTIONS(5636),
    [anon_sym_PERCENT_EQ] = ACTIONS(5636),
    [anon_sym_PLUS_EQ] = ACTIONS(5636),
    [anon_sym_DASH_EQ] = ACTIONS(5636),
    [anon_sym_LT_LT_EQ] = ACTIONS(5636),
    [anon_sym_GT_GT_EQ] = ACTIONS(5636),
    [anon_sym_AMP_EQ] = ACTIONS(5636),
    [anon_sym_CARET_EQ] = ACTIONS(5636),
    [anon_sym_PIPE_EQ] = ACTIONS(5636),
    [anon_sym_and_eq] = ACTIONS(5634),
    [anon_sym_or_eq] = ACTIONS(5634),
    [anon_sym_xor_eq] = ACTIONS(5634),
    [anon_sym_LT_EQ_GT] = ACTIONS(5636),
    [anon_sym_or] = ACTIONS(5634),
    [anon_sym_and] = ACTIONS(5634),
    [anon_sym_bitor] = ACTIONS(5634),
    [anon_sym_xor] = ACTIONS(5634),
    [anon_sym_bitand] = ACTIONS(5634),
    [anon_sym_not_eq] = ACTIONS(5634),
    [anon_sym_DASH_DASH] = ACTIONS(5636),
    [anon_sym_PLUS_PLUS] = ACTIONS(5636),
    [anon_sym_DOT] = ACTIONS(5634),
    [anon_sym_DOT_STAR] = ACTIONS(5636),
    [anon_sym_DASH_GT] = ACTIONS(5636),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5634),
    [anon_sym_decltype] = ACTIONS(5634),
  },
  [2801] = {
    [sym_identifier] = ACTIONS(5747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5749),
    [anon_sym_COMMA] = ACTIONS(5749),
    [anon_sym_RPAREN] = ACTIONS(5749),
    [aux_sym_preproc_if_token2] = ACTIONS(5749),
    [aux_sym_preproc_else_token1] = ACTIONS(5749),
    [aux_sym_preproc_elif_token1] = ACTIONS(5747),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5749),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5749),
    [anon_sym_LPAREN2] = ACTIONS(5749),
    [anon_sym_DASH] = ACTIONS(5747),
    [anon_sym_PLUS] = ACTIONS(5747),
    [anon_sym_STAR] = ACTIONS(5747),
    [anon_sym_SLASH] = ACTIONS(5747),
    [anon_sym_PERCENT] = ACTIONS(5747),
    [anon_sym_PIPE_PIPE] = ACTIONS(5749),
    [anon_sym_AMP_AMP] = ACTIONS(5749),
    [anon_sym_PIPE] = ACTIONS(5747),
    [anon_sym_CARET] = ACTIONS(5747),
    [anon_sym_AMP] = ACTIONS(5747),
    [anon_sym_EQ_EQ] = ACTIONS(5749),
    [anon_sym_BANG_EQ] = ACTIONS(5749),
    [anon_sym_GT] = ACTIONS(5747),
    [anon_sym_GT_EQ] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5747),
    [anon_sym_LT_LT] = ACTIONS(5747),
    [anon_sym_GT_GT] = ACTIONS(5747),
    [anon_sym_SEMI] = ACTIONS(5749),
    [anon_sym___attribute__] = ACTIONS(5747),
    [anon_sym_LBRACE] = ACTIONS(5749),
    [anon_sym_RBRACE] = ACTIONS(5749),
    [anon_sym_LBRACK] = ACTIONS(5749),
    [anon_sym_RBRACK] = ACTIONS(5749),
    [anon_sym_EQ] = ACTIONS(5747),
    [anon_sym_COLON] = ACTIONS(5749),
    [anon_sym_QMARK] = ACTIONS(5749),
    [anon_sym_STAR_EQ] = ACTIONS(5749),
    [anon_sym_SLASH_EQ] = ACTIONS(5749),
    [anon_sym_PERCENT_EQ] = ACTIONS(5749),
    [anon_sym_PLUS_EQ] = ACTIONS(5749),
    [anon_sym_DASH_EQ] = ACTIONS(5749),
    [anon_sym_LT_LT_EQ] = ACTIONS(5749),
    [anon_sym_GT_GT_EQ] = ACTIONS(5749),
    [anon_sym_AMP_EQ] = ACTIONS(5749),
    [anon_sym_CARET_EQ] = ACTIONS(5749),
    [anon_sym_PIPE_EQ] = ACTIONS(5749),
    [anon_sym_and_eq] = ACTIONS(5747),
    [anon_sym_or_eq] = ACTIONS(5747),
    [anon_sym_xor_eq] = ACTIONS(5747),
    [anon_sym_LT_EQ_GT] = ACTIONS(5749),
    [anon_sym_or] = ACTIONS(5747),
    [anon_sym_and] = ACTIONS(5747),
    [anon_sym_bitor] = ACTIONS(5747),
    [anon_sym_xor] = ACTIONS(5747),
    [anon_sym_bitand] = ACTIONS(5747),
    [anon_sym_not_eq] = ACTIONS(5747),
    [anon_sym_DASH_DASH] = ACTIONS(5749),
    [anon_sym_PLUS_PLUS] = ACTIONS(5749),
    [anon_sym_DOT] = ACTIONS(5747),
    [anon_sym_DOT_STAR] = ACTIONS(5749),
    [anon_sym_DASH_GT] = ACTIONS(5749),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5747),
    [anon_sym_decltype] = ACTIONS(5747),
  },
  [2802] = {
    [sym_identifier] = ACTIONS(5684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5686),
    [anon_sym_COMMA] = ACTIONS(5686),
    [anon_sym_RPAREN] = ACTIONS(5686),
    [aux_sym_preproc_if_token2] = ACTIONS(5686),
    [aux_sym_preproc_else_token1] = ACTIONS(5686),
    [aux_sym_preproc_elif_token1] = ACTIONS(5684),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5686),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5686),
    [anon_sym_LPAREN2] = ACTIONS(5686),
    [anon_sym_DASH] = ACTIONS(5684),
    [anon_sym_PLUS] = ACTIONS(5684),
    [anon_sym_STAR] = ACTIONS(5684),
    [anon_sym_SLASH] = ACTIONS(5684),
    [anon_sym_PERCENT] = ACTIONS(5684),
    [anon_sym_PIPE_PIPE] = ACTIONS(5686),
    [anon_sym_AMP_AMP] = ACTIONS(5686),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_CARET] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_EQ_EQ] = ACTIONS(5686),
    [anon_sym_BANG_EQ] = ACTIONS(5686),
    [anon_sym_GT] = ACTIONS(5684),
    [anon_sym_GT_EQ] = ACTIONS(5686),
    [anon_sym_LT_EQ] = ACTIONS(5684),
    [anon_sym_LT] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(5684),
    [anon_sym_GT_GT] = ACTIONS(5684),
    [anon_sym_SEMI] = ACTIONS(5686),
    [anon_sym___attribute__] = ACTIONS(5684),
    [anon_sym_LBRACE] = ACTIONS(5686),
    [anon_sym_RBRACE] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(5686),
    [anon_sym_RBRACK] = ACTIONS(5686),
    [anon_sym_EQ] = ACTIONS(5684),
    [anon_sym_COLON] = ACTIONS(5686),
    [anon_sym_QMARK] = ACTIONS(5686),
    [anon_sym_STAR_EQ] = ACTIONS(5686),
    [anon_sym_SLASH_EQ] = ACTIONS(5686),
    [anon_sym_PERCENT_EQ] = ACTIONS(5686),
    [anon_sym_PLUS_EQ] = ACTIONS(5686),
    [anon_sym_DASH_EQ] = ACTIONS(5686),
    [anon_sym_LT_LT_EQ] = ACTIONS(5686),
    [anon_sym_GT_GT_EQ] = ACTIONS(5686),
    [anon_sym_AMP_EQ] = ACTIONS(5686),
    [anon_sym_CARET_EQ] = ACTIONS(5686),
    [anon_sym_PIPE_EQ] = ACTIONS(5686),
    [anon_sym_and_eq] = ACTIONS(5684),
    [anon_sym_or_eq] = ACTIONS(5684),
    [anon_sym_xor_eq] = ACTIONS(5684),
    [anon_sym_LT_EQ_GT] = ACTIONS(5686),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_and] = ACTIONS(5684),
    [anon_sym_bitor] = ACTIONS(5684),
    [anon_sym_xor] = ACTIONS(5684),
    [anon_sym_bitand] = ACTIONS(5684),
    [anon_sym_not_eq] = ACTIONS(5684),
    [anon_sym_DASH_DASH] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5686),
    [anon_sym_DOT] = ACTIONS(5684),
    [anon_sym_DOT_STAR] = ACTIONS(5686),
    [anon_sym_DASH_GT] = ACTIONS(5686),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5684),
    [anon_sym_decltype] = ACTIONS(5684),
  },
  [2803] = {
    [sym_string_literal] = STATE(2575),
    [sym_raw_string_literal] = STATE(2575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5799),
    [anon_sym_COMMA] = ACTIONS(5799),
    [anon_sym_LPAREN2] = ACTIONS(5799),
    [anon_sym_DASH] = ACTIONS(5797),
    [anon_sym_PLUS] = ACTIONS(5797),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_SLASH] = ACTIONS(5797),
    [anon_sym_PERCENT] = ACTIONS(5797),
    [anon_sym_PIPE_PIPE] = ACTIONS(5799),
    [anon_sym_AMP_AMP] = ACTIONS(5799),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_CARET] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_EQ_EQ] = ACTIONS(5799),
    [anon_sym_BANG_EQ] = ACTIONS(5799),
    [anon_sym_GT] = ACTIONS(5797),
    [anon_sym_GT_EQ] = ACTIONS(5799),
    [anon_sym_LT_EQ] = ACTIONS(5797),
    [anon_sym_LT] = ACTIONS(5797),
    [anon_sym_LT_LT] = ACTIONS(5797),
    [anon_sym_GT_GT] = ACTIONS(5797),
    [anon_sym_SEMI] = ACTIONS(5799),
    [anon_sym___attribute__] = ACTIONS(5797),
    [anon_sym_LBRACK] = ACTIONS(5799),
    [anon_sym_EQ] = ACTIONS(5797),
    [anon_sym_QMARK] = ACTIONS(5799),
    [anon_sym_STAR_EQ] = ACTIONS(5799),
    [anon_sym_SLASH_EQ] = ACTIONS(5799),
    [anon_sym_PERCENT_EQ] = ACTIONS(5799),
    [anon_sym_PLUS_EQ] = ACTIONS(5799),
    [anon_sym_DASH_EQ] = ACTIONS(5799),
    [anon_sym_LT_LT_EQ] = ACTIONS(5799),
    [anon_sym_GT_GT_EQ] = ACTIONS(5799),
    [anon_sym_AMP_EQ] = ACTIONS(5799),
    [anon_sym_CARET_EQ] = ACTIONS(5799),
    [anon_sym_PIPE_EQ] = ACTIONS(5799),
    [anon_sym_and_eq] = ACTIONS(5797),
    [anon_sym_or_eq] = ACTIONS(5797),
    [anon_sym_xor_eq] = ACTIONS(5797),
    [anon_sym_LT_EQ_GT] = ACTIONS(5799),
    [anon_sym_or] = ACTIONS(5797),
    [anon_sym_and] = ACTIONS(5797),
    [anon_sym_bitor] = ACTIONS(5797),
    [anon_sym_xor] = ACTIONS(5797),
    [anon_sym_bitand] = ACTIONS(5797),
    [anon_sym_not_eq] = ACTIONS(5797),
    [anon_sym_DASH_DASH] = ACTIONS(5799),
    [anon_sym_PLUS_PLUS] = ACTIONS(5799),
    [anon_sym_DOT] = ACTIONS(5797),
    [anon_sym_DOT_STAR] = ACTIONS(5799),
    [anon_sym_DASH_GT] = ACTIONS(5799),
    [anon_sym_L_DQUOTE] = ACTIONS(5912),
    [anon_sym_u_DQUOTE] = ACTIONS(5912),
    [anon_sym_U_DQUOTE] = ACTIONS(5912),
    [anon_sym_u8_DQUOTE] = ACTIONS(5912),
    [anon_sym_DQUOTE] = ACTIONS(5912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5914),
    [anon_sym_LR_DQUOTE] = ACTIONS(5914),
    [anon_sym_uR_DQUOTE] = ACTIONS(5914),
    [anon_sym_UR_DQUOTE] = ACTIONS(5914),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5914),
    [sym_literal_suffix] = ACTIONS(5801),
  },
  [2804] = {
    [sym_identifier] = ACTIONS(6268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6270),
    [anon_sym_COMMA] = ACTIONS(6270),
    [anon_sym_RPAREN] = ACTIONS(6270),
    [aux_sym_preproc_if_token2] = ACTIONS(6270),
    [aux_sym_preproc_else_token1] = ACTIONS(6270),
    [aux_sym_preproc_elif_token1] = ACTIONS(6268),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6270),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6270),
    [anon_sym_LPAREN2] = ACTIONS(6270),
    [anon_sym_DASH] = ACTIONS(6268),
    [anon_sym_PLUS] = ACTIONS(6268),
    [anon_sym_STAR] = ACTIONS(6268),
    [anon_sym_SLASH] = ACTIONS(6268),
    [anon_sym_PERCENT] = ACTIONS(6268),
    [anon_sym_PIPE_PIPE] = ACTIONS(6270),
    [anon_sym_AMP_AMP] = ACTIONS(6270),
    [anon_sym_PIPE] = ACTIONS(6268),
    [anon_sym_CARET] = ACTIONS(6268),
    [anon_sym_AMP] = ACTIONS(6268),
    [anon_sym_EQ_EQ] = ACTIONS(6270),
    [anon_sym_BANG_EQ] = ACTIONS(6270),
    [anon_sym_GT] = ACTIONS(6268),
    [anon_sym_GT_EQ] = ACTIONS(6270),
    [anon_sym_LT_EQ] = ACTIONS(6268),
    [anon_sym_LT] = ACTIONS(6268),
    [anon_sym_LT_LT] = ACTIONS(6268),
    [anon_sym_GT_GT] = ACTIONS(6268),
    [anon_sym_SEMI] = ACTIONS(6270),
    [anon_sym___attribute__] = ACTIONS(6268),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6270),
    [anon_sym_LBRACE] = ACTIONS(6270),
    [anon_sym_RBRACE] = ACTIONS(6270),
    [anon_sym_LBRACK] = ACTIONS(6268),
    [anon_sym_RBRACK] = ACTIONS(6270),
    [anon_sym_EQ] = ACTIONS(6268),
    [anon_sym_COLON] = ACTIONS(6270),
    [anon_sym_QMARK] = ACTIONS(6270),
    [anon_sym_STAR_EQ] = ACTIONS(6270),
    [anon_sym_SLASH_EQ] = ACTIONS(6270),
    [anon_sym_PERCENT_EQ] = ACTIONS(6270),
    [anon_sym_PLUS_EQ] = ACTIONS(6270),
    [anon_sym_DASH_EQ] = ACTIONS(6270),
    [anon_sym_LT_LT_EQ] = ACTIONS(6270),
    [anon_sym_GT_GT_EQ] = ACTIONS(6270),
    [anon_sym_AMP_EQ] = ACTIONS(6270),
    [anon_sym_CARET_EQ] = ACTIONS(6270),
    [anon_sym_PIPE_EQ] = ACTIONS(6270),
    [anon_sym_and_eq] = ACTIONS(6268),
    [anon_sym_or_eq] = ACTIONS(6268),
    [anon_sym_xor_eq] = ACTIONS(6268),
    [anon_sym_LT_EQ_GT] = ACTIONS(6270),
    [anon_sym_or] = ACTIONS(6268),
    [anon_sym_and] = ACTIONS(6268),
    [anon_sym_bitor] = ACTIONS(6268),
    [anon_sym_xor] = ACTIONS(6268),
    [anon_sym_bitand] = ACTIONS(6268),
    [anon_sym_not_eq] = ACTIONS(6268),
    [anon_sym_DASH_DASH] = ACTIONS(6270),
    [anon_sym_PLUS_PLUS] = ACTIONS(6270),
    [anon_sym_DOT] = ACTIONS(6268),
    [anon_sym_DOT_STAR] = ACTIONS(6270),
    [anon_sym_DASH_GT] = ACTIONS(6270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6268),
  },
  [2805] = {
    [sym_identifier] = ACTIONS(6272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6274),
    [anon_sym_COMMA] = ACTIONS(6274),
    [anon_sym_RPAREN] = ACTIONS(6274),
    [aux_sym_preproc_if_token2] = ACTIONS(6274),
    [aux_sym_preproc_else_token1] = ACTIONS(6274),
    [aux_sym_preproc_elif_token1] = ACTIONS(6272),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6274),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6274),
    [anon_sym_LPAREN2] = ACTIONS(6274),
    [anon_sym_DASH] = ACTIONS(6272),
    [anon_sym_PLUS] = ACTIONS(6272),
    [anon_sym_STAR] = ACTIONS(6272),
    [anon_sym_SLASH] = ACTIONS(6272),
    [anon_sym_PERCENT] = ACTIONS(6272),
    [anon_sym_PIPE_PIPE] = ACTIONS(6274),
    [anon_sym_AMP_AMP] = ACTIONS(6274),
    [anon_sym_PIPE] = ACTIONS(6272),
    [anon_sym_CARET] = ACTIONS(6272),
    [anon_sym_AMP] = ACTIONS(6272),
    [anon_sym_EQ_EQ] = ACTIONS(6274),
    [anon_sym_BANG_EQ] = ACTIONS(6274),
    [anon_sym_GT] = ACTIONS(6272),
    [anon_sym_GT_EQ] = ACTIONS(6274),
    [anon_sym_LT_EQ] = ACTIONS(6272),
    [anon_sym_LT] = ACTIONS(6272),
    [anon_sym_LT_LT] = ACTIONS(6272),
    [anon_sym_GT_GT] = ACTIONS(6272),
    [anon_sym_SEMI] = ACTIONS(6274),
    [anon_sym___attribute__] = ACTIONS(6272),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6274),
    [anon_sym_LBRACE] = ACTIONS(6274),
    [anon_sym_RBRACE] = ACTIONS(6274),
    [anon_sym_LBRACK] = ACTIONS(6272),
    [anon_sym_RBRACK] = ACTIONS(6274),
    [anon_sym_EQ] = ACTIONS(6272),
    [anon_sym_COLON] = ACTIONS(6274),
    [anon_sym_QMARK] = ACTIONS(6274),
    [anon_sym_STAR_EQ] = ACTIONS(6274),
    [anon_sym_SLASH_EQ] = ACTIONS(6274),
    [anon_sym_PERCENT_EQ] = ACTIONS(6274),
    [anon_sym_PLUS_EQ] = ACTIONS(6274),
    [anon_sym_DASH_EQ] = ACTIONS(6274),
    [anon_sym_LT_LT_EQ] = ACTIONS(6274),
    [anon_sym_GT_GT_EQ] = ACTIONS(6274),
    [anon_sym_AMP_EQ] = ACTIONS(6274),
    [anon_sym_CARET_EQ] = ACTIONS(6274),
    [anon_sym_PIPE_EQ] = ACTIONS(6274),
    [anon_sym_and_eq] = ACTIONS(6272),
    [anon_sym_or_eq] = ACTIONS(6272),
    [anon_sym_xor_eq] = ACTIONS(6272),
    [anon_sym_LT_EQ_GT] = ACTIONS(6274),
    [anon_sym_or] = ACTIONS(6272),
    [anon_sym_and] = ACTIONS(6272),
    [anon_sym_bitor] = ACTIONS(6272),
    [anon_sym_xor] = ACTIONS(6272),
    [anon_sym_bitand] = ACTIONS(6272),
    [anon_sym_not_eq] = ACTIONS(6272),
    [anon_sym_DASH_DASH] = ACTIONS(6274),
    [anon_sym_PLUS_PLUS] = ACTIONS(6274),
    [anon_sym_DOT] = ACTIONS(6272),
    [anon_sym_DOT_STAR] = ACTIONS(6274),
    [anon_sym_DASH_GT] = ACTIONS(6274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6272),
  },
  [2806] = {
    [sym_identifier] = ACTIONS(5759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5761),
    [anon_sym_COMMA] = ACTIONS(5761),
    [anon_sym_RPAREN] = ACTIONS(5761),
    [aux_sym_preproc_if_token2] = ACTIONS(5761),
    [aux_sym_preproc_else_token1] = ACTIONS(5761),
    [aux_sym_preproc_elif_token1] = ACTIONS(5759),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5761),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5761),
    [anon_sym_LPAREN2] = ACTIONS(5761),
    [anon_sym_DASH] = ACTIONS(5759),
    [anon_sym_PLUS] = ACTIONS(5759),
    [anon_sym_STAR] = ACTIONS(5759),
    [anon_sym_SLASH] = ACTIONS(5759),
    [anon_sym_PERCENT] = ACTIONS(5759),
    [anon_sym_PIPE_PIPE] = ACTIONS(5761),
    [anon_sym_AMP_AMP] = ACTIONS(5761),
    [anon_sym_PIPE] = ACTIONS(5759),
    [anon_sym_CARET] = ACTIONS(5759),
    [anon_sym_AMP] = ACTIONS(5759),
    [anon_sym_EQ_EQ] = ACTIONS(5761),
    [anon_sym_BANG_EQ] = ACTIONS(5761),
    [anon_sym_GT] = ACTIONS(5759),
    [anon_sym_GT_EQ] = ACTIONS(5761),
    [anon_sym_LT_EQ] = ACTIONS(5759),
    [anon_sym_LT] = ACTIONS(5759),
    [anon_sym_LT_LT] = ACTIONS(5759),
    [anon_sym_GT_GT] = ACTIONS(5759),
    [anon_sym_SEMI] = ACTIONS(5761),
    [anon_sym___attribute__] = ACTIONS(5759),
    [anon_sym_LBRACE] = ACTIONS(5761),
    [anon_sym_RBRACE] = ACTIONS(5761),
    [anon_sym_LBRACK] = ACTIONS(5761),
    [anon_sym_RBRACK] = ACTIONS(5761),
    [anon_sym_EQ] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_QMARK] = ACTIONS(5761),
    [anon_sym_STAR_EQ] = ACTIONS(5761),
    [anon_sym_SLASH_EQ] = ACTIONS(5761),
    [anon_sym_PERCENT_EQ] = ACTIONS(5761),
    [anon_sym_PLUS_EQ] = ACTIONS(5761),
    [anon_sym_DASH_EQ] = ACTIONS(5761),
    [anon_sym_LT_LT_EQ] = ACTIONS(5761),
    [anon_sym_GT_GT_EQ] = ACTIONS(5761),
    [anon_sym_AMP_EQ] = ACTIONS(5761),
    [anon_sym_CARET_EQ] = ACTIONS(5761),
    [anon_sym_PIPE_EQ] = ACTIONS(5761),
    [anon_sym_and_eq] = ACTIONS(5759),
    [anon_sym_or_eq] = ACTIONS(5759),
    [anon_sym_xor_eq] = ACTIONS(5759),
    [anon_sym_LT_EQ_GT] = ACTIONS(5761),
    [anon_sym_or] = ACTIONS(5759),
    [anon_sym_and] = ACTIONS(5759),
    [anon_sym_bitor] = ACTIONS(5759),
    [anon_sym_xor] = ACTIONS(5759),
    [anon_sym_bitand] = ACTIONS(5759),
    [anon_sym_not_eq] = ACTIONS(5759),
    [anon_sym_DASH_DASH] = ACTIONS(5761),
    [anon_sym_PLUS_PLUS] = ACTIONS(5761),
    [anon_sym_DOT] = ACTIONS(5759),
    [anon_sym_DOT_STAR] = ACTIONS(5761),
    [anon_sym_DASH_GT] = ACTIONS(5761),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5759),
    [anon_sym_decltype] = ACTIONS(5759),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6278), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6276), 57,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_friend,
      anon_sym_using,
      anon_sym_concept,
      anon_sym_requires,
  [71] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5473), 1,
      anon_sym___attribute__,
    ACTIONS(5956), 1,
      anon_sym_LBRACE,
    ACTIONS(6284), 1,
      anon_sym_COLON,
    STATE(2557), 1,
      sym__enum_base_clause,
    STATE(2709), 1,
      sym_enumerator_list,
    STATE(2770), 1,
      sym_attribute_specifier,
    ACTIONS(6280), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6282), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [154] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2822), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5363), 4,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
    ACTIONS(6286), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5730), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(5733), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_auto,
      anon_sym_decltype,
  [231] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5815), 1,
      anon_sym_LBRACK,
    STATE(2855), 1,
      sym_new_declarator,
    ACTIONS(6289), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6291), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5439), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5441), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [377] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6293), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6295), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [450] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2740), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6217), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5481), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5483), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [525] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5837), 1,
      anon_sym_LT,
    STATE(2812), 1,
      sym_template_argument_list,
    ACTIONS(6297), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6299), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [602] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2844), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6301), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5724), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5726), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [677] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2844), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6301), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5481), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5483), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [752] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2845), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6303), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6109), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6107), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [827] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6305), 1,
      sym_identifier,
    STATE(2821), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(4525), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4527), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5395), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5393), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [906] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6307), 1,
      anon_sym_LT,
    STATE(2863), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2912), 1,
      sym_template_argument_list,
    ACTIONS(6237), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4246), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(4254), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5417), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5419), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [1058] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6309), 1,
      sym_identifier,
    STATE(2821), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(6312), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6315), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5375), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5373), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [1137] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2822), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6286), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5365), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(5363), 33,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [1212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5417), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5419), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [1283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6318), 57,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_friend,
      anon_sym_using,
      anon_sym_concept,
      anon_sym_requires,
  [1354] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5628), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5626), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [1427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5421), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5423), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [1498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5439), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5441), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [1569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5628), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5626), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [1642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5608), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5606), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [1713] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2079), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6322), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6092), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6090), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [1788] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6324), 1,
      sym_literal_suffix,
    STATE(2674), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(6041), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6043), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4248), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(4256), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
  [1867] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6324), 1,
      sym_literal_suffix,
    STATE(2674), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(6041), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6043), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5799), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(5797), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
  [1946] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2830), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6326), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6136), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6134), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [2021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5628), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5626), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [2092] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5837), 1,
      anon_sym_LT,
    STATE(2812), 1,
      sym_template_argument_list,
    ACTIONS(6328), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6330), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2169] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5497), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5495), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [2242] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 1,
      sym_identifier,
    STATE(2818), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(4525), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4527), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5389), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5387), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [2321] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5473), 1,
      anon_sym___attribute__,
    ACTIONS(5956), 1,
      anon_sym_LBRACE,
    ACTIONS(6284), 1,
      anon_sym_COLON,
    STATE(2604), 1,
      sym__enum_base_clause,
    STATE(2683), 1,
      sym_enumerator_list,
    STATE(2787), 1,
      sym_attribute_specifier,
    ACTIONS(6334), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6336), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2404] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2079), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6322), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6034), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6032), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [2479] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5167), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(5169), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5162), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6340), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6338), 57,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_friend,
      anon_sym_using,
      anon_sym_concept,
      anon_sym_requires,
  [2623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5421), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5423), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [2694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5411), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5413), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [2765] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2079), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6322), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6020), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6018), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [2840] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2079), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6322), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6105), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6103), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [2915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5411), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5413), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [2986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5655), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5653), 50,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [3057] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2871), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6342), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6136), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6134), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6344), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6346), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6344), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6346), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3271] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(4296), 1,
      anon_sym_LPAREN2,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6233), 1,
      anon_sym_LBRACK,
    ACTIONS(6348), 1,
      anon_sym_STAR,
    ACTIONS(6350), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6352), 1,
      anon_sym_AMP,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7173), 1,
      sym__declarator,
    STATE(7448), 1,
      sym__abstract_declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(6223), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(2869), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3533), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [3393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6356), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6344), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6346), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6360), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6364), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5421), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5423), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [3743] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2870), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6366), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6109), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6107), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4125), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4127), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3887] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6368), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6370), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [3971] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6384), 1,
      anon_sym_LT,
    STATE(2840), 1,
      sym_template_argument_list,
    ACTIONS(6380), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6382), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4045] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2867), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6387), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6020), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6018), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4119] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6389), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6391), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [4203] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2867), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6387), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6034), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6032), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4129), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4131), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4347] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6393), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6395), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [4431] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6401), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6397), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6399), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4503] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2867), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6403), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5363), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5365), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5439), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5441), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [4647] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(4296), 1,
      anon_sym_LPAREN2,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6233), 1,
      anon_sym_LBRACK,
    ACTIONS(6348), 1,
      anon_sym_STAR,
    ACTIONS(6350), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6352), 1,
      anon_sym_AMP,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7191), 1,
      sym__declarator,
    STATE(7443), 1,
      sym__abstract_declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(6235), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(3529), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [4769] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2867), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6387), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6105), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6103), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4843] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2867), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6387), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6092), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6090), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4917] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(3044), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6406), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5958), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5960), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [4995] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2861), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6408), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5724), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5726), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5417), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5419), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [5139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5411), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5413), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [5209] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6410), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6412), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [5293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5439), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5441), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [5363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5411), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5413), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [5433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5417), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5419), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [5503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5421), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5423), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [5573] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6307), 1,
      anon_sym_LT,
    STATE(2912), 1,
      sym_template_argument_list,
    ACTIONS(4272), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5835), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [5649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5411), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5413), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [5719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6414), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6416), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6418), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6420), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6422), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6424), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6426), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6428), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5421), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5423), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [6069] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5461), 1,
      anon_sym_virtual,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6434), 1,
      sym_auto,
    ACTIONS(6436), 1,
      anon_sym_decltype,
    STATE(3115), 1,
      sym_decltype_auto,
    ACTIONS(5451), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(3051), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6432), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6430), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5449), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [6161] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(4296), 1,
      anon_sym_LPAREN2,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6233), 1,
      anon_sym_LBRACK,
    ACTIONS(6438), 1,
      anon_sym_STAR,
    ACTIONS(6440), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6442), 1,
      anon_sym_AMP,
    STATE(4540), 1,
      sym_parameter_list,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7191), 1,
      sym__declarator,
    STATE(7467), 1,
      sym__abstract_declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(6235), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(3588), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [6283] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6444), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6446), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [6365] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6448), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6450), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [6447] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5461), 1,
      anon_sym_virtual,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6434), 1,
      sym_auto,
    ACTIONS(6436), 1,
      anon_sym_decltype,
    STATE(3115), 1,
      sym_decltype_auto,
    ACTIONS(5451), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(3053), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6454), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6452), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5449), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [6539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6456), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6458), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6609] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6460), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6462), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [6693] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym___attribute__,
    ACTIONS(6464), 1,
      anon_sym_LBRACE,
    STATE(2273), 1,
      sym_attribute_specifier,
    STATE(3020), 1,
      sym_enumerator_list,
    ACTIONS(5952), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5954), 48,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [6771] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6466), 1,
      sym_identifier,
    STATE(3013), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3221), 1,
      sym_primitive_type,
    ACTIONS(6470), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(6468), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5491), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5489), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [6851] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6472), 1,
      anon_sym_LT,
    STATE(2912), 1,
      sym_template_argument_list,
    ACTIONS(5136), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5129), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [6927] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6475), 1,
      anon_sym___attribute__,
    ACTIONS(6477), 1,
      anon_sym_LBRACE,
    STATE(3370), 1,
      sym_field_declaration_list,
    STATE(3537), 1,
      sym_attribute_specifier,
    STATE(7685), 1,
      sym_virtual_specifier,
    STATE(8639), 1,
      sym_base_class_clause,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5469), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5471), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [7013] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6479), 1,
      sym_identifier,
    STATE(3027), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3208), 1,
      sym_primitive_type,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(6482), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5489), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5491), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [7093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5653), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5655), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7163] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym___attribute__,
    ACTIONS(6464), 1,
      anon_sym_LBRACE,
    STATE(2304), 1,
      sym_attribute_specifier,
    STATE(2927), 1,
      sym_enumerator_list,
    ACTIONS(5980), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5982), 48,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [7241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5439), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5441), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [7311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5417), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5419), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [7381] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(4296), 1,
      anon_sym_LPAREN2,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6233), 1,
      anon_sym_LBRACK,
    ACTIONS(6438), 1,
      anon_sym_STAR,
    ACTIONS(6440), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6442), 1,
      anon_sym_AMP,
    STATE(4540), 1,
      sym_parameter_list,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7173), 1,
      sym__declarator,
    STATE(7474), 1,
      sym__abstract_declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(6223), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(2889), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3621), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [7503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6484), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6486), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6488), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6490), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6492), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6494), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6496), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6498), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6500), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6502), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5417), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5419), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [7917] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      anon_sym___attribute__,
    ACTIONS(6504), 1,
      anon_sym_LBRACE,
    ACTIONS(6506), 1,
      anon_sym_COLON,
    STATE(3138), 1,
      sym__enum_base_clause,
    STATE(3193), 1,
      sym_enumerator_list,
    STATE(3337), 1,
      sym_attribute_specifier,
    ACTIONS(6334), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6336), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5167), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5160), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [8067] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6512), 1,
      anon_sym_or,
    ACTIONS(6514), 1,
      anon_sym_and,
    ACTIONS(6006), 25,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6008), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8144] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(4296), 1,
      anon_sym_LPAREN2,
    ACTIONS(4298), 1,
      anon_sym_STAR,
    ACTIONS(4300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4302), 1,
      anon_sym_AMP,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(6223), 1,
      anon_sym_RPAREN,
    ACTIONS(6233), 1,
      anon_sym_LBRACK,
    ACTIONS(6516), 1,
      anon_sym_COLON_COLON,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6657), 1,
      sym__scope_resolution,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7255), 1,
      sym__declarator,
    STATE(7448), 1,
      sym__abstract_declarator,
    STATE(9597), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(2933), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3738), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [8265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5284), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5286), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5608), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5606), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [8403] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2917), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6518), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5365), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
    ACTIONS(5363), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [8476] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5628), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5626), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [8547] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5628), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5626), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [8618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5879), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5877), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5439), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5441), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [8756] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      anon_sym___attribute__,
    ACTIONS(6504), 1,
      anon_sym_LBRACE,
    ACTIONS(6506), 1,
      anon_sym_COLON,
    STATE(3145), 1,
      sym__enum_base_clause,
    STATE(3187), 1,
      sym_enumerator_list,
    STATE(3368), 1,
      sym_attribute_specifier,
    ACTIONS(6280), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6282), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8837] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6521), 1,
      anon_sym_LT,
    STATE(3118), 1,
      sym_template_argument_list,
    ACTIONS(4272), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5835), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [8912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6523), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6525), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4037), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4033), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6527), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6529), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9119] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym___attribute__,
    STATE(2289), 1,
      sym_attribute_specifier,
    ACTIONS(6094), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6096), 49,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [9192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6531), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6533), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6535), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6537), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6539), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6541), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6543), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6545), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6547), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6549), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9537] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(4296), 1,
      anon_sym_LPAREN2,
    ACTIONS(4298), 1,
      anon_sym_STAR,
    ACTIONS(4300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4302), 1,
      anon_sym_AMP,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(6233), 1,
      anon_sym_LBRACK,
    ACTIONS(6235), 1,
      anon_sym_RPAREN,
    ACTIONS(6516), 1,
      anon_sym_COLON_COLON,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6657), 1,
      sym__scope_resolution,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7272), 1,
      sym__declarator,
    STATE(7443), 1,
      sym__abstract_declarator,
    STATE(9597), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3729), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [9658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5316), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5318), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9727] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5956), 1,
      anon_sym_LBRACE,
    ACTIONS(6551), 1,
      anon_sym___attribute__,
    ACTIONS(6553), 1,
      anon_sym_COLON,
    STATE(2604), 1,
      sym__enum_base_clause,
    STATE(2683), 1,
      sym_enumerator_list,
    STATE(2787), 1,
      sym_attribute_specifier,
    ACTIONS(6334), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6336), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [9808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6555), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6557), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6559), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6561), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6565), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6567), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6569), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6571), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6573), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10153] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5956), 1,
      anon_sym_LBRACE,
    ACTIONS(6551), 1,
      anon_sym___attribute__,
    ACTIONS(6553), 1,
      anon_sym_COLON,
    STATE(2557), 1,
      sym__enum_base_clause,
    STATE(2709), 1,
      sym_enumerator_list,
    STATE(2770), 1,
      sym_attribute_specifier,
    ACTIONS(6280), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6282), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [10234] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym___attribute__,
    STATE(2298), 1,
      sym_attribute_specifier,
    ACTIONS(6082), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6084), 49,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [10307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6575), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6577), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6579), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6581), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6583), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6585), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6587), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6589), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5328), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5330), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5288), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5290), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5131), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5131), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6591), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6593), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5131), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6595), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6597), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6599), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6601), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5324), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5326), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6603), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6605), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11273] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3009), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6607), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6136), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6134), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [11346] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3008), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6609), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6109), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6107), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [11419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5332), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5334), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5131), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5131), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6611), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6613), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5131), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6615), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6617), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11833] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6514), 1,
      anon_sym_and,
    ACTIONS(6065), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6067), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5308), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5310), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6619), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6621), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [12044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5314), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [12113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5655), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5653), 32,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [12182] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym___attribute__,
    STATE(2277), 1,
      sym_attribute_specifier,
    ACTIONS(6113), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6115), 49,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [12255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5421), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5423), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [12324] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6623), 1,
      anon_sym___attribute__,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    STATE(3237), 1,
      sym_field_declaration_list,
    STATE(3417), 1,
      sym_attribute_specifier,
    STATE(7753), 1,
      sym_virtual_specifier,
    STATE(8577), 1,
      sym_base_class_clause,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5469), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5471), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      anon_sym_requires,
  [12409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6627), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6629), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [12478] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2861), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6408), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5481), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5483), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [12551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2223), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2221), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [12620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5115), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5113), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [12689] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym___attribute__,
    STATE(2256), 1,
      sym_attribute_specifier,
    ACTIONS(6053), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6055), 49,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [12762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5411), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5413), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [12831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5150), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [12900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6631), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6633), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [12969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5119), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5117), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [13038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6635), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6637), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [13107] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym___attribute__,
    STATE(2268), 1,
      sym_attribute_specifier,
    ACTIONS(6117), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6119), 49,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [13180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5127), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5125), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [13249] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5121), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [13318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5314), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [13387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5111), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5109), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [13456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2265), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [13525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5304), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5306), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [13594] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym___attribute__,
    STATE(2267), 1,
      sym_attribute_specifier,
    ACTIONS(6121), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6123), 49,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [13667] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym___attribute__,
    STATE(2248), 1,
      sym_attribute_specifier,
    ACTIONS(6057), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6059), 49,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [13740] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym___attribute__,
    STATE(2292), 1,
      sym_attribute_specifier,
    ACTIONS(6144), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6146), 49,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [13813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6635), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6637), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [13882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5148), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5146), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [13951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6639), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6641), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [14020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5314), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [14089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6643), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6645), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [14158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5320), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5322), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [14227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5300), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5302), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [14296] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6647), 1,
      anon_sym___attribute__,
    ACTIONS(6649), 1,
      anon_sym_LBRACE,
    STATE(3448), 1,
      sym_field_declaration_list,
    STATE(3684), 1,
      sym_attribute_specifier,
    STATE(7760), 1,
      sym_virtual_specifier,
    STATE(8611), 1,
      sym_base_class_clause,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5469), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5471), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [14381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6651), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6653), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [14450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6655), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6657), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [14519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6659), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6661), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [14588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6663), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6665), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [14657] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2672), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6667), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6034), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6032), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [14730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6669), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6671), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [14799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6673), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6675), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [14868] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2672), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6667), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6105), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6103), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [14941] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2672), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6667), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6092), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6090), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [15014] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(3069), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6677), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5958), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5960), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [15091] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3016), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6679), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5724), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5726), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [15164] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6521), 1,
      anon_sym_LT,
    STATE(3118), 1,
      sym_template_argument_list,
    ACTIONS(5136), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5129), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [15239] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2917), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5363), 4,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
    ACTIONS(6518), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5733), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5730), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [15314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3176), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [15383] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5497), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5495), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [15454] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2672), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6667), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6020), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6018), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [15527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6397), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6399), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [15596] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym___attribute__,
    STATE(2300), 1,
      sym_attribute_specifier,
    ACTIONS(6024), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6026), 49,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [15669] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym___attribute__,
    STATE(2302), 1,
      sym_attribute_specifier,
    ACTIONS(6028), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6030), 49,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [15742] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym___attribute__,
    STATE(2296), 1,
      sym_attribute_specifier,
    ACTIONS(6049), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6051), 49,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [15815] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym___attribute__,
    STATE(2290), 1,
      sym_attribute_specifier,
    ACTIONS(6061), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6063), 49,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [15888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5292), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5294), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [15957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5296), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5298), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [16026] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6219), 1,
      sym_literal_suffix,
    STATE(2837), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(4525), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4527), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5797), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5799), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [16103] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6219), 1,
      sym_literal_suffix,
    STATE(2837), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(4525), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4527), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4256), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4248), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [16180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6681), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6683), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [16249] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2450), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5363), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(5903), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5730), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5733), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [16324] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6685), 1,
      anon_sym_LT,
    STATE(3044), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3135), 1,
      sym_template_argument_list,
    ACTIONS(6406), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4246), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4254), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [16403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6687), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6689), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [16472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6691), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6693), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [16541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6695), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6697), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [16610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6699), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6701), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [16679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6703), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6705), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [16748] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6707), 1,
      sym_identifier,
    STATE(3050), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3551), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3555), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5395), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5393), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [16824] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2793), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6709), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6105), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6103), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [16896] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6711), 1,
      anon_sym_LT,
    STATE(3069), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3197), 1,
      sym_template_argument_list,
    ACTIONS(6677), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4246), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4254), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [16974] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6713), 1,
      anon_sym_LT,
    STATE(3135), 1,
      sym_template_argument_list,
    ACTIONS(5129), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5136), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [17048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5417), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5419), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [17116] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5483), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5481), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [17186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5439), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5441), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [17254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5467), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5465), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [17322] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    STATE(3122), 1,
      sym_attribute_specifier,
    STATE(3748), 1,
      sym_field_declaration_list,
    STATE(7912), 1,
      sym_virtual_specifier,
    STATE(8737), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5471), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5469), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [17406] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2231), 1,
      anon_sym_LBRACE,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(6722), 1,
      anon_sym_LBRACK,
    ACTIONS(6724), 1,
      sym_auto,
    ACTIONS(6726), 1,
      anon_sym_decltype,
    STATE(3320), 1,
      sym_new_declarator,
    STATE(3378), 1,
      sym_decltype_auto,
    STATE(3751), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5854), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5856), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [17490] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2793), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6709), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6034), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6032), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [17562] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2231), 1,
      anon_sym_LBRACE,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(6722), 1,
      anon_sym_LBRACK,
    ACTIONS(6724), 1,
      sym_auto,
    ACTIONS(6726), 1,
      anon_sym_decltype,
    STATE(3316), 1,
      sym_new_declarator,
    STATE(3378), 1,
      sym_decltype_auto,
    STATE(3757), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5809), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5811), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [17646] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2793), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6709), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6020), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6018), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [17718] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2231), 1,
      anon_sym_LBRACE,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(6722), 1,
      anon_sym_LBRACK,
    ACTIONS(6724), 1,
      sym_auto,
    ACTIONS(6726), 1,
      anon_sym_decltype,
    STATE(3334), 1,
      sym_new_declarator,
    STATE(3378), 1,
      sym_decltype_auto,
    STATE(3763), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5847), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5849), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [17802] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3035), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6728), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6109), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6107), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [17874] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3056), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6730), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6136), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6134), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [17946] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6732), 1,
      sym_identifier,
    STATE(3050), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(6735), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6738), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5375), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5373), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [18022] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5461), 1,
      anon_sym_virtual,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(5451), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(3063), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6743), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5449), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(6741), 13,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [18106] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3046), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6745), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5724), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5726), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [18178] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5461), 1,
      anon_sym_virtual,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(5451), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(3063), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6749), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5449), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(6747), 13,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [18262] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6434), 1,
      sym_auto,
    ACTIONS(6436), 1,
      anon_sym_decltype,
    STATE(3115), 1,
      sym_decltype_auto,
    ACTIONS(5501), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5499), 44,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [18336] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6685), 1,
      anon_sym_LT,
    STATE(3135), 1,
      sym_template_argument_list,
    ACTIONS(5835), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4272), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [18410] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2793), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6709), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6092), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6090), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [18482] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6751), 1,
      sym_identifier,
    STATE(3034), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3551), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3555), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5389), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5387), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [18558] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2231), 1,
      anon_sym_LBRACE,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(6722), 1,
      anon_sym_LBRACK,
    ACTIONS(6724), 1,
      sym_auto,
    ACTIONS(6726), 1,
      anon_sym_decltype,
    STATE(3355), 1,
      sym_new_declarator,
    STATE(3378), 1,
      sym_decltype_auto,
    STATE(3769), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5831), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5833), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [18642] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3016), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6679), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5481), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5483), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [18714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5653), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5655), 48,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [18782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5411), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5413), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [18850] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(3184), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4274), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5960), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5958), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [18928] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6765), 1,
      anon_sym___attribute__,
    ACTIONS(6768), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6771), 1,
      anon_sym___declspec,
    ACTIONS(6774), 1,
      anon_sym_virtual,
    ACTIONS(6777), 1,
      anon_sym_alignas,
    ACTIONS(6762), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(3063), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6757), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6755), 13,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(6759), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [19012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5628), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [19080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5421), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5423), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [19148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5417), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5419), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [19215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6780), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [19282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5439), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5441), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [19349] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2822), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6784), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6034), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6032), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [19420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5115), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5113), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [19487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5606), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5608), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [19554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5738), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5736), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [19621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5783), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5781), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [19688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5787), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5785), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [19755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5698), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5696), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [19822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5791), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5789), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [19889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5694), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5692), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [19956] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2021), 1,
      sym_string_literal,
    ACTIONS(6790), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6788), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6786), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [20027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5690), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5688), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [20094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5779), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5777), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [20161] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5626), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5628), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [20230] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5628), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5626), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [20299] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2822), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6784), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6020), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6018), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [20370] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3101), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6792), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6109), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6107), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [20441] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5626), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5628), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [20510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5608), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5606), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [20577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5483), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5481), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [20644] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2024), 1,
      sym_string_literal,
    ACTIONS(6790), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6788), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6786), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [20715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2874), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2869), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [20782] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3102), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6794), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6136), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6134), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [20853] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6796), 1,
      anon_sym_LT,
    STATE(3197), 1,
      sym_template_argument_list,
    ACTIONS(5129), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5136), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [20926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5773), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5771), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [20993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5795), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5793), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [21060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5757), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5755), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [21127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5749), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5747), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [21194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5653), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5655), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [21261] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6475), 1,
      anon_sym___attribute__,
    ACTIONS(6799), 1,
      anon_sym_LBRACE,
    ACTIONS(6801), 1,
      anon_sym_COLON,
    STATE(3247), 1,
      sym__enum_base_clause,
    STATE(3371), 1,
      sym_enumerator_list,
    STATE(3523), 1,
      sym_attribute_specifier,
    ACTIONS(6280), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6282), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [21340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5722), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5720), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [21407] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5628), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5626), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [21476] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6711), 1,
      anon_sym_LT,
    STATE(3197), 1,
      sym_template_argument_list,
    ACTIONS(5835), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4272), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [21549] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2822), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6784), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6105), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6103), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [21620] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2822), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6784), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6092), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6090), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [21691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5148), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5146), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [21758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5718), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5716), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [21825] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2022), 1,
      sym_string_literal,
    ACTIONS(6790), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6788), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6786), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [21896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5714), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5712), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [21963] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(3215), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6803), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5958), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5960), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [22038] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3083), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6805), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5724), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5726), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [22109] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2023), 1,
      sym_string_literal,
    ACTIONS(6790), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6788), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6786), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [22180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5111), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5109), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [22247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5726), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5724), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [22314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6809), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6807), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [22381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5675), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [22448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5686), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5684), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [22515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5742), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5740), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [22582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5121), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [22649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5753), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5751), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [22716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5167), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5160), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [22783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5632), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5630), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [22850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5638), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [22917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5638), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [22984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5642), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [23051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5648), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5646), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [23118] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6811), 1,
      anon_sym___attribute__,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    STATE(3809), 1,
      sym_field_declaration_list,
    STATE(4068), 1,
      sym_attribute_specifier,
    STATE(7920), 1,
      sym_virtual_specifier,
    STATE(8425), 1,
      sym_base_class_clause,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5469), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5471), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [23201] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(6815), 1,
      anon_sym_LPAREN2,
    STATE(2982), 1,
      sym_argument_list,
    STATE(3160), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4660), 1,
      sym_initializer_list,
    ACTIONS(6818), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5483), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
    ACTIONS(5481), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [23280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5638), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [23347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5659), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5657), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [23414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5667), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5665), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [23481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5671), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5669), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [23548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5127), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5125), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [23615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5119), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5117), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [23682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5690), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5688), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [23749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6822), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6820), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [23816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6826), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6824), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [23883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5160), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5167), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [23950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5765), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5763), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [24017] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5495), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5497), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [24086] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      anon_sym___attribute__,
    ACTIONS(6504), 1,
      anon_sym_LBRACE,
    STATE(3189), 1,
      sym_enumerator_list,
    STATE(3305), 1,
      sym_attribute_specifier,
    ACTIONS(5980), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5982), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [24161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5710), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5708), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [24228] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5661), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [24295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5150), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [24362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5628), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5626), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [24429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5411), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5413), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [24496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6830), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6828), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [24563] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      anon_sym___attribute__,
    ACTIONS(6504), 1,
      anon_sym_LBRACE,
    STATE(3185), 1,
      sym_enumerator_list,
    STATE(3329), 1,
      sym_attribute_specifier,
    ACTIONS(5952), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5954), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [24638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5636), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5634), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [24705] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2025), 1,
      sym_string_literal,
    ACTIONS(6790), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6788), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6786), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [24776] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5497), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5495), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [24845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5702), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5700), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [24912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5706), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5704), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [24979] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3046), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6745), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5481), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5483), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [25050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2927), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [25117] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6475), 1,
      anon_sym___attribute__,
    ACTIONS(6799), 1,
      anon_sym_LBRACE,
    ACTIONS(6801), 1,
      anon_sym_COLON,
    STATE(3249), 1,
      sym__enum_base_clause,
    STATE(3332), 1,
      sym_enumerator_list,
    STATE(3574), 1,
      sym_attribute_specifier,
    ACTIONS(6334), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6336), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [25196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5421), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5423), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [25263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6689), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6687), 32,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [25329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5653), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5655), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [25395] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2297), 1,
      anon_sym_LBRACE,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(6834), 1,
      anon_sym_LBRACK,
    ACTIONS(6836), 1,
      sym_auto,
    ACTIONS(6838), 1,
      anon_sym_decltype,
    STATE(3535), 1,
      sym_decltype_auto,
    STATE(3614), 1,
      sym_new_declarator,
    STATE(4195), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5831), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5833), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [25477] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      anon_sym___attribute__,
    STATE(3300), 1,
      sym_attribute_specifier,
    ACTIONS(6144), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6146), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [25547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5160), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5167), 41,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_DASH_GT_STAR,
  [25613] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3166), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6840), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6018), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6020), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [25683] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2297), 1,
      anon_sym_LBRACE,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(6834), 1,
      anon_sym_LBRACK,
    ACTIONS(6836), 1,
      sym_auto,
    ACTIONS(6838), 1,
      anon_sym_decltype,
    STATE(3535), 1,
      sym_decltype_auto,
    STATE(3628), 1,
      sym_new_declarator,
    STATE(4144), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5809), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5811), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [25765] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2297), 1,
      anon_sym_LBRACE,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(6834), 1,
      anon_sym_LBRACK,
    ACTIONS(6836), 1,
      sym_auto,
    ACTIONS(6838), 1,
      anon_sym_decltype,
    STATE(3535), 1,
      sym_decltype_auto,
    STATE(3564), 1,
      sym_new_declarator,
    STATE(4104), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5854), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5856), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [25847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5495), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5497), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [25915] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5495), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5497), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [25983] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6842), 1,
      anon_sym_LT,
    STATE(3159), 1,
      sym_template_argument_list,
    STATE(3215), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6803), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4246), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4254), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [26059] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3166), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6844), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5365), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5363), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [26129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6565), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6563), 32,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [26195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5626), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5628), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [26263] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      anon_sym___attribute__,
    STATE(3369), 1,
      sym_attribute_specifier,
    ACTIONS(6053), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6055), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [26333] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      anon_sym___attribute__,
    STATE(3354), 1,
      sym_attribute_specifier,
    ACTIONS(6057), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6059), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [26403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6671), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6669), 32,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [26469] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      anon_sym___attribute__,
    STATE(3296), 1,
      sym_attribute_specifier,
    ACTIONS(6024), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6026), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [26539] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5626), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5628), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [26607] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3083), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6805), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5481), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5483), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [26677] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3166), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6840), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6103), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6105), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [26747] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3166), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6840), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6090), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6092), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [26817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5606), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5608), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [26883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5628), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [26949] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2297), 1,
      anon_sym_LBRACE,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(6834), 1,
      anon_sym_LBRACK,
    ACTIONS(6836), 1,
      sym_auto,
    ACTIONS(6838), 1,
      anon_sym_decltype,
    STATE(3535), 1,
      sym_decltype_auto,
    STATE(3636), 1,
      sym_new_declarator,
    STATE(4155), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5847), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5849), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [27031] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      anon_sym___attribute__,
    STATE(3298), 1,
      sym_attribute_specifier,
    ACTIONS(6028), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6030), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [27101] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      anon_sym___attribute__,
    STATE(3324), 1,
      sym_attribute_specifier,
    ACTIONS(6117), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6119), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [27171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5111), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [27237] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      anon_sym___attribute__,
    STATE(3340), 1,
      sym_attribute_specifier,
    ACTIONS(6082), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6084), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [27307] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3166), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6840), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6032), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6034), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [27377] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      anon_sym___attribute__,
    STATE(3299), 1,
      sym_attribute_specifier,
    ACTIONS(6049), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6051), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [27447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5146), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5148), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [27513] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      anon_sym___attribute__,
    STATE(3330), 1,
      sym_attribute_specifier,
    ACTIONS(6113), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6115), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [27583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5123), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [27649] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      anon_sym___attribute__,
    STATE(3291), 1,
      sym_attribute_specifier,
    ACTIONS(6094), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6096), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [27719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5125), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5127), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [27785] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6647), 1,
      anon_sym___attribute__,
    ACTIONS(6847), 1,
      anon_sym_LBRACE,
    ACTIONS(6849), 1,
      anon_sym_COLON,
    STATE(3335), 1,
      sym__enum_base_clause,
    STATE(3407), 1,
      sym_enumerator_list,
    STATE(3659), 1,
      sym_attribute_specifier,
    ACTIONS(6334), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6336), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [27863] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym___attribute__,
    ACTIONS(6851), 1,
      anon_sym_LBRACE,
    STATE(3266), 1,
      sym_enumerator_list,
    STATE(3431), 1,
      sym_attribute_specifier,
    ACTIONS(5952), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5954), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [27937] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      anon_sym___attribute__,
    STATE(3306), 1,
      sym_attribute_specifier,
    ACTIONS(6061), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6063), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [28007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5606), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5608), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [28073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5160), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5167), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [28139] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      anon_sym___attribute__,
    STATE(3322), 1,
      sym_attribute_specifier,
    ACTIONS(6121), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6123), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [28209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5160), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5167), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [28275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5115), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [28341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5150), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5152), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [28407] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3160), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6818), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5726), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5724), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [28477] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym___attribute__,
    ACTIONS(6851), 1,
      anon_sym_LBRACE,
    STATE(3278), 1,
      sym_enumerator_list,
    STATE(3441), 1,
      sym_attribute_specifier,
    ACTIONS(5980), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5982), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [28551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6611), 32,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [28617] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5626), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5628), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [28685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5117), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5119), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [28751] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3175), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6853), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6107), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6109), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [28821] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5626), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5628), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [28889] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6647), 1,
      anon_sym___attribute__,
    ACTIONS(6847), 1,
      anon_sym_LBRACE,
    ACTIONS(6849), 1,
      anon_sym_COLON,
    STATE(3349), 1,
      sym__enum_base_clause,
    STATE(3462), 1,
      sym_enumerator_list,
    STATE(3689), 1,
      sym_attribute_specifier,
    ACTIONS(6280), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6282), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [28967] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3176), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6855), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6134), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6136), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [29037] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6871), 1,
      anon_sym_GT_EQ,
    ACTIONS(6875), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6877), 1,
      anon_sym_not_eq,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6857), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6861), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6863), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6865), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6867), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6873), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6859), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6869), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 8,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
    ACTIONS(6412), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [29138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5628), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [29203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5148), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5146), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [29268] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6875), 1,
      anon_sym_LT_EQ_GT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6857), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6873), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6859), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6412), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [29355] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6871), 1,
      anon_sym_GT_EQ,
    ACTIONS(6875), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6877), 1,
      anon_sym_not_eq,
    ACTIONS(6883), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6885), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6887), 1,
      anon_sym_or,
    ACTIONS(6889), 1,
      anon_sym_and,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6857), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6861), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6863), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6865), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6867), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6873), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6859), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6869), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6879), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6881), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [29464] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6871), 1,
      anon_sym_GT_EQ,
    ACTIONS(6875), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6877), 1,
      anon_sym_not_eq,
    ACTIONS(6883), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6885), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6887), 1,
      anon_sym_or,
    ACTIONS(6889), 1,
      anon_sym_and,
    ACTIONS(6893), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6897), 1,
      anon_sym_QMARK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6857), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6861), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6863), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6865), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6867), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6873), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6859), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6869), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6891), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6895), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [29577] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2917), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6899), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6034), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6032), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [29646] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2917), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6899), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6020), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6018), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [29715] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6871), 1,
      anon_sym_GT_EQ,
    ACTIONS(6875), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6877), 1,
      anon_sym_not_eq,
    ACTIONS(6883), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6885), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6887), 1,
      anon_sym_or,
    ACTIONS(6889), 1,
      anon_sym_and,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6857), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6861), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6863), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6865), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6867), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6873), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6859), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6869), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6901), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6903), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [29824] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6871), 1,
      anon_sym_GT_EQ,
    ACTIONS(6875), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6877), 1,
      anon_sym_not_eq,
    ACTIONS(6883), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6885), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6887), 1,
      anon_sym_or,
    ACTIONS(6889), 1,
      anon_sym_and,
    ACTIONS(6893), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6897), 1,
      anon_sym_QMARK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6857), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6861), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6863), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6865), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6867), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6873), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6859), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6869), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6905), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6907), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [29937] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5461), 1,
      anon_sym_virtual,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6434), 1,
      sym_auto,
    ACTIONS(6436), 1,
      anon_sym_decltype,
    ACTIONS(6909), 1,
      anon_sym_SEMI,
    STATE(3115), 1,
      sym_decltype_auto,
    ACTIONS(6432), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(5451), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(3051), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6430), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5449), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [30026] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3288), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6911), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6109), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6107), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [30095] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3287), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6913), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6136), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6134), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [30164] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5461), 1,
      anon_sym_virtual,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6434), 1,
      sym_auto,
    ACTIONS(6436), 1,
      anon_sym_decltype,
    ACTIONS(6915), 1,
      anon_sym_SEMI,
    STATE(3115), 1,
      sym_decltype_auto,
    ACTIONS(6432), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(5451), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(3051), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6430), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5449), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [30253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5119), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5117), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [30318] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2739), 1,
      anon_sym_LBRACE,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6921), 1,
      sym_auto,
    ACTIONS(6923), 1,
      anon_sym_decltype,
    STATE(3721), 1,
      sym_decltype_auto,
    STATE(3773), 1,
      sym_new_declarator,
    STATE(4280), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5831), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5833), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [30399] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6925), 1,
      anon_sym_LT,
    STATE(3159), 1,
      sym_template_argument_list,
    ACTIONS(5129), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5136), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [30470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5150), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [30535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5115), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5113), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [30600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5411), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5413), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [30665] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5481), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5483), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [30732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5634), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5636), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [30797] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6871), 1,
      anon_sym_GT_EQ,
    ACTIONS(6875), 1,
      anon_sym_LT_EQ_GT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6857), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6873), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6859), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6869), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6412), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30888] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6871), 1,
      anon_sym_GT_EQ,
    ACTIONS(6875), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6877), 1,
      anon_sym_not_eq,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6857), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6867), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6873), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6859), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6869), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 14,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      sym_identifier,
    ACTIONS(6412), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30983] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym___attribute__,
    STATE(3428), 1,
      sym_attribute_specifier,
    ACTIONS(6082), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6084), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [31052] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym___attribute__,
    STATE(3430), 1,
      sym_attribute_specifier,
    ACTIONS(6113), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6115), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [31121] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6871), 1,
      anon_sym_GT_EQ,
    ACTIONS(6875), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6877), 1,
      anon_sym_not_eq,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6857), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6865), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6867), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6873), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6859), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6869), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 12,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      sym_identifier,
    ACTIONS(6412), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5724), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5726), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [31283] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym___attribute__,
    STATE(3434), 1,
      sym_attribute_specifier,
    ACTIONS(6117), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6119), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [31352] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6871), 1,
      anon_sym_GT_EQ,
    ACTIONS(6875), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6877), 1,
      anon_sym_not_eq,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6857), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6863), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6865), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6867), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6873), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6859), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6869), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 10,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      sym_identifier,
    ACTIONS(6412), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5657), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5659), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [31516] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym___attribute__,
    STATE(3435), 1,
      sym_attribute_specifier,
    ACTIONS(6121), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6123), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [31585] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2739), 1,
      anon_sym_LBRACE,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6921), 1,
      sym_auto,
    ACTIONS(6923), 1,
      anon_sym_decltype,
    STATE(3721), 1,
      sym_decltype_auto,
    STATE(3788), 1,
      sym_new_declarator,
    STATE(4241), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5847), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5849), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [31666] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6842), 1,
      anon_sym_LT,
    STATE(3159), 1,
      sym_template_argument_list,
    ACTIONS(5835), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4272), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [31737] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6871), 1,
      anon_sym_GT_EQ,
    ACTIONS(6875), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6877), 1,
      anon_sym_not_eq,
    ACTIONS(6885), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6889), 1,
      anon_sym_and,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6857), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6861), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6863), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6865), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6867), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6873), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6859), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6869), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 7,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      sym_identifier,
    ACTIONS(6412), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31842] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6871), 1,
      anon_sym_GT_EQ,
    ACTIONS(6875), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6877), 1,
      anon_sym_not_eq,
    ACTIONS(6883), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6885), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6887), 1,
      anon_sym_or,
    ACTIONS(6889), 1,
      anon_sym_and,
    ACTIONS(6893), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6897), 1,
      anon_sym_QMARK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6857), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6861), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6863), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6865), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6867), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6873), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6859), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6869), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6703), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6705), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31955] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6871), 1,
      anon_sym_GT_EQ,
    ACTIONS(6875), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6877), 1,
      anon_sym_not_eq,
    ACTIONS(6883), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6885), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6887), 1,
      anon_sym_or,
    ACTIONS(6889), 1,
      anon_sym_and,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6857), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6861), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6863), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6865), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6867), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6873), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6859), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6869), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6928), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6930), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32064] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6932), 1,
      anon_sym_LPAREN2,
    ACTIONS(6934), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6936), 1,
      anon_sym_LBRACK,
    STATE(3587), 1,
      sym_parameter_list,
    STATE(3381), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5996), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5998), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [32139] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6475), 1,
      anon_sym___attribute__,
    ACTIONS(6799), 1,
      anon_sym_LBRACE,
    STATE(3321), 1,
      sym_enumerator_list,
    STATE(3592), 1,
      sym_attribute_specifier,
    ACTIONS(5952), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5954), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [32212] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5461), 1,
      anon_sym_virtual,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6434), 1,
      sym_auto,
    ACTIONS(6436), 1,
      anon_sym_decltype,
    ACTIONS(6938), 1,
      anon_sym_SEMI,
    STATE(3115), 1,
      sym_decltype_auto,
    ACTIONS(6432), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(5451), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(3051), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6430), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5449), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [32301] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6475), 1,
      anon_sym___attribute__,
    ACTIONS(6799), 1,
      anon_sym_LBRACE,
    STATE(3379), 1,
      sym_enumerator_list,
    STATE(3639), 1,
      sym_attribute_specifier,
    ACTIONS(5980), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5982), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [32374] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym___attribute__,
    STATE(3415), 1,
      sym_attribute_specifier,
    ACTIONS(6057), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6059), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [32443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5710), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [32508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5675), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5677), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [32573] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6932), 1,
      anon_sym_LPAREN2,
    ACTIONS(6934), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6936), 1,
      anon_sym_LBRACK,
    STATE(3587), 1,
      sym_parameter_list,
    STATE(3381), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6069), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6071), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [32648] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5461), 1,
      anon_sym_virtual,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6434), 1,
      sym_auto,
    ACTIONS(6436), 1,
      anon_sym_decltype,
    ACTIONS(6940), 1,
      anon_sym_SEMI,
    STATE(3115), 1,
      sym_decltype_auto,
    ACTIONS(6432), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(5451), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(3051), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6430), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5449), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [32737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5127), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5125), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [32802] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6932), 1,
      anon_sym_LPAREN2,
    ACTIONS(6934), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6936), 1,
      anon_sym_LBRACK,
    STATE(3587), 1,
      sym_parameter_list,
    STATE(3381), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6140), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6142), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [32877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5121), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [32942] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3216), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6942), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5724), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5726), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [33011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5111), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5109), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [33076] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym___attribute__,
    STATE(3445), 1,
      sym_attribute_specifier,
    ACTIONS(6028), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6030), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [33145] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6932), 1,
      anon_sym_LPAREN2,
    ACTIONS(6934), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6936), 1,
      anon_sym_LBRACK,
    STATE(3587), 1,
      sym_parameter_list,
    STATE(3381), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6148), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6150), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [33220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5417), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5419), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [33285] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5461), 1,
      anon_sym_virtual,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6434), 1,
      sym_auto,
    ACTIONS(6436), 1,
      anon_sym_decltype,
    ACTIONS(6944), 1,
      anon_sym_SEMI,
    STATE(3115), 1,
      sym_decltype_auto,
    ACTIONS(6432), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(5451), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(3051), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6430), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5449), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [33374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5628), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [33439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5747), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5749), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [33504] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym___attribute__,
    STATE(3442), 1,
      sym_attribute_specifier,
    ACTIONS(6049), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6051), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [33573] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym___attribute__,
    STATE(3440), 1,
      sym_attribute_specifier,
    ACTIONS(6061), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6063), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [33642] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6857), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6859), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6412), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [33725] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5461), 1,
      anon_sym_virtual,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6434), 1,
      sym_auto,
    ACTIONS(6436), 1,
      anon_sym_decltype,
    ACTIONS(6946), 1,
      anon_sym_SEMI,
    STATE(3115), 1,
      sym_decltype_auto,
    ACTIONS(6432), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(5451), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(3051), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6430), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5449), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [33814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5439), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5441), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [33879] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5461), 1,
      anon_sym_virtual,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6434), 1,
      sym_auto,
    ACTIONS(6436), 1,
      anon_sym_decltype,
    ACTIONS(6948), 1,
      anon_sym_SEMI,
    STATE(3115), 1,
      sym_decltype_auto,
    ACTIONS(6432), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(5451), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(3051), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6430), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5449), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [33968] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym___attribute__,
    STATE(3446), 1,
      sym_attribute_specifier,
    ACTIONS(6024), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6026), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [34037] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6859), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6412), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [34118] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6871), 1,
      anon_sym_GT_EQ,
    ACTIONS(6875), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6877), 1,
      anon_sym_not_eq,
    ACTIONS(6883), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6885), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6887), 1,
      anon_sym_or,
    ACTIONS(6889), 1,
      anon_sym_and,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6857), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6861), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6863), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6865), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6867), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6873), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6859), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6869), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6950), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6952), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [34227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5465), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5467), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [34292] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5461), 1,
      anon_sym_virtual,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6434), 1,
      sym_auto,
    ACTIONS(6436), 1,
      anon_sym_decltype,
    ACTIONS(6954), 1,
      anon_sym_SEMI,
    STATE(3115), 1,
      sym_decltype_auto,
    ACTIONS(6432), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(5451), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(3051), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6430), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5449), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [34381] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym___attribute__,
    STATE(3410), 1,
      sym_attribute_specifier,
    ACTIONS(6053), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6055), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [34450] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym___attribute__,
    STATE(3452), 1,
      sym_attribute_specifier,
    ACTIONS(6094), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6096), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [34519] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym___attribute__,
    STATE(3389), 1,
      sym_attribute_specifier,
    ACTIONS(6144), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6146), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [34588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5761), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5759), 44,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [34653] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5461), 1,
      anon_sym_virtual,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6434), 1,
      sym_auto,
    ACTIONS(6436), 1,
      anon_sym_decltype,
    ACTIONS(6956), 1,
      anon_sym_SEMI,
    STATE(3115), 1,
      sym_decltype_auto,
    ACTIONS(6432), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(5451), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(3051), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6430), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5449), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [34742] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3160), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6818), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5483), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5481), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [34811] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2739), 1,
      anon_sym_LBRACE,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6921), 1,
      sym_auto,
    ACTIONS(6923), 1,
      anon_sym_decltype,
    STATE(3721), 1,
      sym_decltype_auto,
    STATE(3817), 1,
      sym_new_declarator,
    STATE(4307), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5809), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5811), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [34892] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      sym_auto,
    ACTIONS(6726), 1,
      anon_sym_decltype,
    STATE(3378), 1,
      sym_decltype_auto,
    ACTIONS(5499), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5501), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [34963] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6857), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6873), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6859), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6412), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [35048] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2739), 1,
      anon_sym_LBRACE,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6921), 1,
      sym_auto,
    ACTIONS(6923), 1,
      anon_sym_decltype,
    STATE(3721), 1,
      sym_decltype_auto,
    STATE(3823), 1,
      sym_new_declarator,
    STATE(4309), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5854), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5856), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [35129] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2917), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6899), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6092), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6090), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [35198] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2917), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6899), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6105), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6103), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [35267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5421), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5423), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [35332] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5125), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5127), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [35396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5751), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5753), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [35460] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym___attribute__,
    ACTIONS(6958), 1,
      anon_sym_LBRACE,
    ACTIONS(6960), 1,
      anon_sym_COLON,
    STATE(3604), 1,
      sym__enum_base_clause,
    STATE(3683), 1,
      sym_enumerator_list,
    STATE(4120), 1,
      sym_attribute_specifier,
    ACTIONS(6334), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6336), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [35536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5481), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5483), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [35600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5781), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5783), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [35664] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym___attribute__,
    ACTIONS(6958), 1,
      anon_sym_LBRACE,
    ACTIONS(6960), 1,
      anon_sym_COLON,
    STATE(3561), 1,
      sym__enum_base_clause,
    STATE(3816), 1,
      sym_enumerator_list,
    STATE(4066), 1,
      sym_attribute_specifier,
    ACTIONS(6280), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6282), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [35740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5787), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [35804] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6962), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3297), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6210), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6212), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [35872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5789), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5791), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [35936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5771), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5773), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [36000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5763), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5765), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [36064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5747), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5749), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [36128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5131), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [36192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5661), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5663), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [36256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5606), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5608), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [36320] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5793), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5795), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [36384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5755), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5757), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [36448] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(4296), 1,
      anon_sym_LPAREN2,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6225), 1,
      anon_sym_STAR,
    ACTIONS(6227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6229), 1,
      anon_sym_AMP,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6233), 1,
      anon_sym_LBRACK,
    STATE(4001), 1,
      sym_parameter_list,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7178), 1,
      sym__declarator,
    STATE(7232), 1,
      sym__abstract_declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(6965), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [36556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5710), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [36620] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6475), 1,
      anon_sym___attribute__,
    STATE(3631), 1,
      sym_attribute_specifier,
    ACTIONS(6024), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6026), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [36688] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 1,
      sym_literal_suffix,
    ACTIONS(4256), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4248), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [36754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5686), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [36818] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 1,
      sym_literal_suffix,
    ACTIONS(5797), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5799), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [36884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5626), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5628), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [36950] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5626), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5628), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [37016] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6475), 1,
      anon_sym___attribute__,
    STATE(3637), 1,
      sym_attribute_specifier,
    ACTIONS(6028), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6030), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [37084] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2231), 1,
      anon_sym_LBRACE,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    STATE(3768), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6185), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6187), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [37154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5690), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [37218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5724), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5726), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [37282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5702), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [37346] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2231), 1,
      anon_sym_LBRACE,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    STATE(3762), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6178), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6180), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [37416] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6475), 1,
      anon_sym___attribute__,
    STATE(3638), 1,
      sym_attribute_specifier,
    ACTIONS(6049), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6051), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [37484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5694), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [37548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6555), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6557), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [37612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5696), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5698), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [37676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5131), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [37740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5690), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [37804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5634), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5636), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [37868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5167), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5160), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [37932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5712), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5714), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [37996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5722), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [38060] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6967), 1,
      sym_identifier,
    STATE(3478), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4216), 1,
      sym_primitive_type,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(6969), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5489), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5491), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_try,
      anon_sym_requires,
  [38134] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6475), 1,
      anon_sym___attribute__,
    STATE(3616), 1,
      sym_attribute_specifier,
    ACTIONS(6061), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6063), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [38202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5131), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [38266] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2231), 1,
      anon_sym_LBRACE,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    STATE(3731), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6189), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6191), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [38336] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6647), 1,
      anon_sym___attribute__,
    ACTIONS(6847), 1,
      anon_sym_LBRACE,
    STATE(3405), 1,
      sym_enumerator_list,
    STATE(3654), 1,
      sym_attribute_specifier,
    ACTIONS(5980), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5982), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [38408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5657), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5659), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [38472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5738), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [38536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6973), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6971), 50,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [38600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5131), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [38664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5777), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5779), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [38728] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5167), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(5169), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5162), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [38794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5131), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [38858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5675), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5677), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [38922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5704), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5706), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [38986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5759), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5761), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [39050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5640), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [39114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5131), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [39178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5640), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [39242] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6647), 1,
      anon_sym___attribute__,
    ACTIONS(6847), 1,
      anon_sym_LBRACE,
    STATE(3401), 1,
      sym_enumerator_list,
    STATE(3655), 1,
      sym_attribute_specifier,
    ACTIONS(5952), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5954), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [39314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6975), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6977), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [39378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6981), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [39442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5642), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5644), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [39506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5146), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5148), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [39570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5648), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [39634] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2231), 1,
      anon_sym_LBRACE,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    STATE(3783), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6152), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6154), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [39704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5111), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [39768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5640), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [39832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5123), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [39896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5117), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5119), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [39960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5150), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5152), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [40024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5115), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [40088] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6983), 1,
      sym_auto,
    ACTIONS(6985), 1,
      anon_sym_decltype,
    STATE(3402), 1,
      sym_decltype_auto,
    ACTIONS(5499), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5501), 41,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [40158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5481), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5483), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [40222] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5136), 1,
      anon_sym_LBRACE,
    ACTIONS(6987), 1,
      anon_sym_LT,
    STATE(3450), 1,
      sym_template_argument_list,
    ACTIONS(5138), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5131), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [40294] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3216), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6942), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5481), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5483), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [40362] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6475), 1,
      anon_sym___attribute__,
    STATE(3603), 1,
      sym_attribute_specifier,
    ACTIONS(6121), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6123), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [40430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6990), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [40494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5665), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5667), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [40558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5669), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5671), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [40622] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6475), 1,
      anon_sym___attribute__,
    STATE(3596), 1,
      sym_attribute_specifier,
    ACTIONS(6117), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6119), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [40690] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6475), 1,
      anon_sym___attribute__,
    STATE(3590), 1,
      sym_attribute_specifier,
    ACTIONS(6113), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6115), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [40758] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6475), 1,
      anon_sym___attribute__,
    STATE(3573), 1,
      sym_attribute_specifier,
    ACTIONS(6082), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6084), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [40826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5465), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5467), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [40890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5483), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(5481), 45,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_try,
      anon_sym_requires,
  [40954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5495), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5497), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [41020] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6475), 1,
      anon_sym___attribute__,
    STATE(3570), 1,
      sym_attribute_specifier,
    ACTIONS(6144), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6146), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [41088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5653), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5655), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [41152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5742), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [41216] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6475), 1,
      anon_sym___attribute__,
    STATE(3571), 1,
      sym_attribute_specifier,
    ACTIONS(6094), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6096), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [41284] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(4296), 1,
      anon_sym_LPAREN2,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6225), 1,
      anon_sym_STAR,
    ACTIONS(6227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6229), 1,
      anon_sym_AMP,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6233), 1,
      anon_sym_LBRACK,
    STATE(4001), 1,
      sym_parameter_list,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7191), 1,
      sym__declarator,
    STATE(7253), 1,
      sym__abstract_declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(6235), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [41392] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6934), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3297), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6162), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6164), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [41460] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6475), 1,
      anon_sym___attribute__,
    STATE(3536), 1,
      sym_attribute_specifier,
    ACTIONS(6057), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6059), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [41528] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5481), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5483), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [41594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5716), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5718), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [41658] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6475), 1,
      anon_sym___attribute__,
    STATE(3524), 1,
      sym_attribute_specifier,
    ACTIONS(6053), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6055), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [41726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6996), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6994), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [41790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5632), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [41854] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(6998), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7004), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7000), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 19,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6412), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [41935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5763), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5765), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [41998] = 52,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7010), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7012), 1,
      anon_sym_COMMA,
    ACTIONS(7014), 1,
      anon_sym_RPAREN,
    ACTIONS(7016), 1,
      anon_sym_DASH,
    ACTIONS(7018), 1,
      anon_sym_PLUS,
    ACTIONS(7020), 1,
      anon_sym_STAR,
    ACTIONS(7022), 1,
      anon_sym_SLASH,
    ACTIONS(7024), 1,
      anon_sym_PERCENT,
    ACTIONS(7026), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7028), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7030), 1,
      anon_sym_PIPE,
    ACTIONS(7032), 1,
      anon_sym_CARET,
    ACTIONS(7034), 1,
      anon_sym_AMP,
    ACTIONS(7036), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7038), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7040), 1,
      anon_sym_GT,
    ACTIONS(7042), 1,
      anon_sym_GT_EQ,
    ACTIONS(7044), 1,
      anon_sym_LT_EQ,
    ACTIONS(7046), 1,
      anon_sym_LT,
    ACTIONS(7048), 1,
      anon_sym_LT_LT,
    ACTIONS(7050), 1,
      anon_sym_GT_GT,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7054), 1,
      anon_sym_EQ,
    ACTIONS(7056), 1,
      anon_sym_QMARK,
    ACTIONS(7058), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7060), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7062), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7064), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7066), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7068), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7070), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7072), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7074), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7076), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7080), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7082), 1,
      anon_sym_or,
    ACTIONS(7084), 1,
      anon_sym_and,
    ACTIONS(7086), 1,
      anon_sym_bitor,
    ACTIONS(7088), 1,
      anon_sym_xor,
    ACTIONS(7090), 1,
      anon_sym_bitand,
    ACTIONS(7092), 1,
      anon_sym_not_eq,
    ACTIONS(7098), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT_STAR,
    STATE(1907), 1,
      sym__binary_fold_operator,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    STATE(9711), 1,
      sym__fold_operator,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7078), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [42159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5716), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5718), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [42222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5632), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [42285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5704), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5706), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [42348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5702), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [42411] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6307), 1,
      anon_sym_LT,
    STATE(3531), 1,
      sym_template_argument_list,
    ACTIONS(6297), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6299), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [42480] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6647), 1,
      anon_sym___attribute__,
    STATE(3661), 1,
      sym_attribute_specifier,
    ACTIONS(6024), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6026), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [42547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5481), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5483), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [42610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5661), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5663), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [42673] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6901), 1,
      anon_sym_EQ,
    ACTIONS(7106), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7110), 1,
      anon_sym_PIPE,
    ACTIONS(7114), 1,
      anon_sym_AMP,
    ACTIONS(7120), 1,
      anon_sym_GT_EQ,
    ACTIONS(7124), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7126), 1,
      anon_sym_or,
    ACTIONS(7128), 1,
      anon_sym_and,
    ACTIONS(7130), 1,
      anon_sym_bitor,
    ACTIONS(7132), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7112), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7116), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7118), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6903), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [42782] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6647), 1,
      anon_sym___attribute__,
    STATE(3658), 1,
      sym_attribute_specifier,
    ACTIONS(6028), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6030), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [42849] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6647), 1,
      anon_sym___attribute__,
    STATE(3657), 1,
      sym_attribute_specifier,
    ACTIONS(6049), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6051), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [42916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5742), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [42979] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7134), 1,
      anon_sym_SEMI,
    STATE(3122), 1,
      sym_attribute_specifier,
    STATE(3748), 1,
      sym_field_declaration_list,
    STATE(7912), 1,
      sym_virtual_specifier,
    STATE(8737), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5471), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5469), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [43060] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 4,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(5516), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(4248), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(4256), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
  [43127] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6647), 1,
      anon_sym___attribute__,
    STATE(3667), 1,
      sym_attribute_specifier,
    ACTIONS(6094), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6096), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [43194] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6647), 1,
      anon_sym___attribute__,
    STATE(3669), 1,
      sym_attribute_specifier,
    ACTIONS(6144), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6146), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [43261] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6647), 1,
      anon_sym___attribute__,
    STATE(3653), 1,
      sym_attribute_specifier,
    ACTIONS(6061), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6063), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [43328] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6307), 1,
      anon_sym_LT,
    STATE(3531), 1,
      sym_template_argument_list,
    ACTIONS(6328), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6330), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [43397] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7136), 1,
      anon_sym_LPAREN2,
    ACTIONS(7138), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    STATE(3974), 1,
      sym_parameter_list,
    STATE(3623), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6069), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6071), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [43470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5669), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5671), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [43533] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(7142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7144), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7146), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7158), 1,
      anon_sym_GT_EQ,
    ACTIONS(7162), 1,
      anon_sym_QMARK,
    ACTIONS(7164), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7166), 1,
      anon_sym_or,
    ACTIONS(7168), 1,
      anon_sym_and,
    ACTIONS(7170), 1,
      anon_sym_not_eq,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(6998), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7004), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7148), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7150), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7152), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7160), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7000), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7156), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6905), 5,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6907), 14,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [43644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5665), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5667), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [43707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5640), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [43770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5747), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5749), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [43833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5648), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [43896] = 52,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7010), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7012), 1,
      anon_sym_COMMA,
    ACTIONS(7016), 1,
      anon_sym_DASH,
    ACTIONS(7018), 1,
      anon_sym_PLUS,
    ACTIONS(7020), 1,
      anon_sym_STAR,
    ACTIONS(7022), 1,
      anon_sym_SLASH,
    ACTIONS(7024), 1,
      anon_sym_PERCENT,
    ACTIONS(7026), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7028), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7030), 1,
      anon_sym_PIPE,
    ACTIONS(7032), 1,
      anon_sym_CARET,
    ACTIONS(7034), 1,
      anon_sym_AMP,
    ACTIONS(7036), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7038), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7040), 1,
      anon_sym_GT,
    ACTIONS(7042), 1,
      anon_sym_GT_EQ,
    ACTIONS(7044), 1,
      anon_sym_LT_EQ,
    ACTIONS(7046), 1,
      anon_sym_LT,
    ACTIONS(7048), 1,
      anon_sym_LT_LT,
    ACTIONS(7050), 1,
      anon_sym_GT_GT,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7054), 1,
      anon_sym_EQ,
    ACTIONS(7056), 1,
      anon_sym_QMARK,
    ACTIONS(7058), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7060), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7062), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7064), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7066), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7068), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7070), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7072), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7074), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7076), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7080), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7082), 1,
      anon_sym_or,
    ACTIONS(7084), 1,
      anon_sym_and,
    ACTIONS(7086), 1,
      anon_sym_bitor,
    ACTIONS(7088), 1,
      anon_sym_xor,
    ACTIONS(7090), 1,
      anon_sym_bitand,
    ACTIONS(7092), 1,
      anon_sym_not_eq,
    ACTIONS(7098), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7172), 1,
      anon_sym_RPAREN,
    STATE(1907), 1,
      sym__binary_fold_operator,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    STATE(9711), 1,
      sym__fold_operator,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7078), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [44057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5642), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5644), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [44120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5640), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [44183] = 52,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7010), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7012), 1,
      anon_sym_COMMA,
    ACTIONS(7016), 1,
      anon_sym_DASH,
    ACTIONS(7018), 1,
      anon_sym_PLUS,
    ACTIONS(7020), 1,
      anon_sym_STAR,
    ACTIONS(7022), 1,
      anon_sym_SLASH,
    ACTIONS(7024), 1,
      anon_sym_PERCENT,
    ACTIONS(7026), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7028), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7030), 1,
      anon_sym_PIPE,
    ACTIONS(7032), 1,
      anon_sym_CARET,
    ACTIONS(7034), 1,
      anon_sym_AMP,
    ACTIONS(7036), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7038), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7040), 1,
      anon_sym_GT,
    ACTIONS(7042), 1,
      anon_sym_GT_EQ,
    ACTIONS(7044), 1,
      anon_sym_LT_EQ,
    ACTIONS(7046), 1,
      anon_sym_LT,
    ACTIONS(7048), 1,
      anon_sym_LT_LT,
    ACTIONS(7050), 1,
      anon_sym_GT_GT,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7054), 1,
      anon_sym_EQ,
    ACTIONS(7056), 1,
      anon_sym_QMARK,
    ACTIONS(7058), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7060), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7062), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7064), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7066), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7068), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7070), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7072), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7074), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7076), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7080), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7082), 1,
      anon_sym_or,
    ACTIONS(7084), 1,
      anon_sym_and,
    ACTIONS(7086), 1,
      anon_sym_bitor,
    ACTIONS(7088), 1,
      anon_sym_xor,
    ACTIONS(7090), 1,
      anon_sym_bitand,
    ACTIONS(7092), 1,
      anon_sym_not_eq,
    ACTIONS(7098), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7174), 1,
      anon_sym_RPAREN,
    STATE(1907), 1,
      sym__binary_fold_operator,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    STATE(9711), 1,
      sym__fold_operator,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7078), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [44344] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6891), 1,
      anon_sym_EQ,
    ACTIONS(6893), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7106), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7110), 1,
      anon_sym_PIPE,
    ACTIONS(7114), 1,
      anon_sym_AMP,
    ACTIONS(7120), 1,
      anon_sym_GT_EQ,
    ACTIONS(7124), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7126), 1,
      anon_sym_or,
    ACTIONS(7128), 1,
      anon_sym_and,
    ACTIONS(7130), 1,
      anon_sym_bitor,
    ACTIONS(7132), 1,
      anon_sym_bitand,
    ACTIONS(7176), 1,
      anon_sym_QMARK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7112), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7116), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7118), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6895), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [44457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5640), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [44520] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(7144), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7146), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7158), 1,
      anon_sym_GT_EQ,
    ACTIONS(7164), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7166), 1,
      anon_sym_or,
    ACTIONS(7168), 1,
      anon_sym_and,
    ACTIONS(7170), 1,
      anon_sym_not_eq,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(6998), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7004), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7148), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7150), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7152), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7160), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7000), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7156), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6901), 5,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6903), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [44627] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6879), 1,
      anon_sym_EQ,
    ACTIONS(7106), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7110), 1,
      anon_sym_PIPE,
    ACTIONS(7114), 1,
      anon_sym_AMP,
    ACTIONS(7120), 1,
      anon_sym_GT_EQ,
    ACTIONS(7124), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7126), 1,
      anon_sym_or,
    ACTIONS(7128), 1,
      anon_sym_and,
    ACTIONS(7130), 1,
      anon_sym_bitor,
    ACTIONS(7132), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7112), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7116), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7118), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6881), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [44736] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6448), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6450), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [44811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5465), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5467), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [44874] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(7142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7144), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7146), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7158), 1,
      anon_sym_GT_EQ,
    ACTIONS(7162), 1,
      anon_sym_QMARK,
    ACTIONS(7164), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7166), 1,
      anon_sym_or,
    ACTIONS(7168), 1,
      anon_sym_and,
    ACTIONS(7170), 1,
      anon_sym_not_eq,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(6998), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7004), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7148), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7150), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7152), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7160), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7000), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7156), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6891), 5,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6895), 14,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [44985] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7136), 1,
      anon_sym_LPAREN2,
    ACTIONS(7138), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    STATE(3974), 1,
      sym_parameter_list,
    STATE(3623), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6148), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6150), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [45058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5777), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5779), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [45121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5738), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [45184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5722), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [45247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5712), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5714), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [45310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5690), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [45373] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2841), 1,
      anon_sym_LBRACE,
    ACTIONS(7178), 1,
      anon_sym_LPAREN2,
    ACTIONS(7180), 1,
      anon_sym_LBRACK,
    ACTIONS(7182), 1,
      sym_auto,
    ACTIONS(7184), 1,
      anon_sym_decltype,
    STATE(4045), 1,
      sym_decltype_auto,
    STATE(4091), 1,
      sym_new_declarator,
    STATE(4484), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5854), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5856), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [45452] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5696), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5698), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [45515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5694), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [45578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5690), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [45641] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6647), 1,
      anon_sym___attribute__,
    STATE(3647), 1,
      sym_attribute_specifier,
    ACTIONS(6121), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6123), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [45708] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(7144), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7146), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7158), 1,
      anon_sym_GT_EQ,
    ACTIONS(7164), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7166), 1,
      anon_sym_or,
    ACTIONS(7168), 1,
      anon_sym_and,
    ACTIONS(7170), 1,
      anon_sym_not_eq,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(6998), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7004), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7148), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7150), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7152), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7160), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7000), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7156), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6879), 5,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6881), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5686), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [45878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5755), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5757), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [45941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5793), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5795), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [46004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5771), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5773), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [46067] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7004), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6391), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(6389), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
  [46144] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7004), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6395), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(6393), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
  [46221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5789), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5791), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [46284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5787), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [46347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5781), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5783), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [46410] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6647), 1,
      anon_sym___attribute__,
    STATE(3649), 1,
      sym_attribute_specifier,
    ACTIONS(6117), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6119), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [46477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5759), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5761), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [46540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5167), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(5169), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5162), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [46605] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(7144), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7146), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7158), 1,
      anon_sym_GT_EQ,
    ACTIONS(7164), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7166), 1,
      anon_sym_or,
    ACTIONS(7168), 1,
      anon_sym_and,
    ACTIONS(7170), 1,
      anon_sym_not_eq,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(6998), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7004), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7148), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7150), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7152), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7160), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7000), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7156), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6950), 5,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6952), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5751), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5753), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [46775] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6928), 1,
      anon_sym_EQ,
    ACTIONS(7106), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7110), 1,
      anon_sym_PIPE,
    ACTIONS(7114), 1,
      anon_sym_AMP,
    ACTIONS(7120), 1,
      anon_sym_GT_EQ,
    ACTIONS(7124), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7126), 1,
      anon_sym_or,
    ACTIONS(7128), 1,
      anon_sym_and,
    ACTIONS(7130), 1,
      anon_sym_bitor,
    ACTIONS(7132), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7112), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7116), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7118), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6930), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [46884] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(6998), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7004), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7160), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7000), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 17,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6412), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [46967] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(7164), 1,
      anon_sym_LT_EQ_GT,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(6998), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7004), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7160), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7000), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 17,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6412), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [47052] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(7158), 1,
      anon_sym_GT_EQ,
    ACTIONS(7164), 1,
      anon_sym_LT_EQ_GT,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(6998), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7004), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7160), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7000), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7156), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 14,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6412), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [47141] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6893), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6905), 1,
      anon_sym_EQ,
    ACTIONS(7106), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7110), 1,
      anon_sym_PIPE,
    ACTIONS(7114), 1,
      anon_sym_AMP,
    ACTIONS(7120), 1,
      anon_sym_GT_EQ,
    ACTIONS(7124), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7126), 1,
      anon_sym_or,
    ACTIONS(7128), 1,
      anon_sym_and,
    ACTIONS(7130), 1,
      anon_sym_bitor,
    ACTIONS(7132), 1,
      anon_sym_bitand,
    ACTIONS(7176), 1,
      anon_sym_QMARK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7112), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7116), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7118), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6907), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [47254] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(7158), 1,
      anon_sym_GT_EQ,
    ACTIONS(7164), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7170), 1,
      anon_sym_not_eq,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(6998), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7004), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7160), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7000), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7156), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 13,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      sym_identifier,
    ACTIONS(6412), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [47347] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6444), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6446), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [47422] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(7158), 1,
      anon_sym_GT_EQ,
    ACTIONS(7164), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7170), 1,
      anon_sym_not_eq,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(6998), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7004), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7152), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7160), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7000), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7156), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 11,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      sym_identifier,
    ACTIONS(6412), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [47517] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(7158), 1,
      anon_sym_GT_EQ,
    ACTIONS(7164), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7170), 1,
      anon_sym_not_eq,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(6998), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7004), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7150), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7152), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7160), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7000), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7156), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 9,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      sym_identifier,
    ACTIONS(6412), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [47614] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6647), 1,
      anon_sym___attribute__,
    STATE(3656), 1,
      sym_attribute_specifier,
    ACTIONS(6113), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6115), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [47681] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7186), 1,
      anon_sym_SEMI,
    STATE(3122), 1,
      sym_attribute_specifier,
    STATE(3748), 1,
      sym_field_declaration_list,
    STATE(7912), 1,
      sym_virtual_specifier,
    STATE(8737), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5471), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5469), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [47762] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(7158), 1,
      anon_sym_GT_EQ,
    ACTIONS(7164), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7170), 1,
      anon_sym_not_eq,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(6998), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7004), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7148), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7150), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7152), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7160), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7000), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7156), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 7,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
    ACTIONS(6412), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [47861] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(7146), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7158), 1,
      anon_sym_GT_EQ,
    ACTIONS(7164), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7168), 1,
      anon_sym_and,
    ACTIONS(7170), 1,
      anon_sym_not_eq,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(6998), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7004), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7148), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7150), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7152), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7160), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7000), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7156), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 6,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      sym_identifier,
    ACTIONS(6412), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [47964] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7004), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7000), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6412), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [48043] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2841), 1,
      anon_sym_LBRACE,
    ACTIONS(7178), 1,
      anon_sym_LPAREN2,
    ACTIONS(7180), 1,
      anon_sym_LBRACK,
    ACTIONS(7182), 1,
      sym_auto,
    ACTIONS(7184), 1,
      anon_sym_decltype,
    STATE(4045), 1,
      sym_decltype_auto,
    STATE(4187), 1,
      sym_new_declarator,
    STATE(4499), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5831), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5833), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [48122] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6647), 1,
      anon_sym___attribute__,
    STATE(3660), 1,
      sym_attribute_specifier,
    ACTIONS(6082), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6084), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [48189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5710), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [48252] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7136), 1,
      anon_sym_LPAREN2,
    ACTIONS(7138), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    STATE(3974), 1,
      sym_parameter_list,
    STATE(3623), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5996), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5998), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [48325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6981), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [48388] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7188), 1,
      anon_sym_SEMI,
    STATE(3122), 1,
      sym_attribute_specifier,
    STATE(3748), 1,
      sym_field_declaration_list,
    STATE(7912), 1,
      sym_virtual_specifier,
    STATE(8737), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5471), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5469), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [48469] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(7142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7144), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7146), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7158), 1,
      anon_sym_GT_EQ,
    ACTIONS(7162), 1,
      anon_sym_QMARK,
    ACTIONS(7164), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7166), 1,
      anon_sym_or,
    ACTIONS(7168), 1,
      anon_sym_and,
    ACTIONS(7170), 1,
      anon_sym_not_eq,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(6998), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7004), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7148), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7150), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7152), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7160), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7000), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7156), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6703), 5,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6705), 14,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [48580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5628), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [48643] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(7190), 1,
      anon_sym_LBRACE,
    STATE(3093), 1,
      sym_attribute_specifier,
    STATE(3697), 1,
      sym_enumerator_list,
    ACTIONS(5982), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5980), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [48714] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7192), 1,
      anon_sym_SEMI,
    STATE(3122), 1,
      sym_attribute_specifier,
    STATE(3748), 1,
      sym_field_declaration_list,
    STATE(7912), 1,
      sym_virtual_specifier,
    STATE(8737), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5471), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5469), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [48795] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5136), 1,
      anon_sym_LBRACE,
    ACTIONS(5174), 1,
      anon_sym_LT,
    STATE(3568), 1,
      sym_template_argument_list,
    ACTIONS(5138), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5131), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [48866] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2450), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5363), 4,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
    ACTIONS(5903), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5730), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5733), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_try,
      anon_sym_requires,
  [48935] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(7190), 1,
      anon_sym_LBRACE,
    STATE(3106), 1,
      sym_attribute_specifier,
    STATE(3714), 1,
      sym_enumerator_list,
    ACTIONS(5954), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5952), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [49006] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(7144), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7146), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7158), 1,
      anon_sym_GT_EQ,
    ACTIONS(7164), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7166), 1,
      anon_sym_or,
    ACTIONS(7168), 1,
      anon_sym_and,
    ACTIONS(7170), 1,
      anon_sym_not_eq,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(6998), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7004), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7148), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7150), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7152), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7160), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7000), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7156), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6928), 5,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6930), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [49113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5724), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5726), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [49176] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7194), 1,
      anon_sym_SEMI,
    STATE(3122), 1,
      sym_attribute_specifier,
    STATE(3748), 1,
      sym_field_declaration_list,
    STATE(7912), 1,
      sym_virtual_specifier,
    STATE(8737), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5471), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5469), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [49257] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2841), 1,
      anon_sym_LBRACE,
    ACTIONS(7178), 1,
      anon_sym_LPAREN2,
    ACTIONS(7180), 1,
      anon_sym_LBRACK,
    ACTIONS(7182), 1,
      sym_auto,
    ACTIONS(7184), 1,
      anon_sym_decltype,
    STATE(4045), 1,
      sym_decltype_auto,
    STATE(4115), 1,
      sym_new_declarator,
    STATE(4541), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5809), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5811), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [49336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7198), 25,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(7196), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [49399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5634), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5636), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [49462] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7136), 1,
      anon_sym_LPAREN2,
    ACTIONS(7138), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    STATE(3974), 1,
      sym_parameter_list,
    STATE(3623), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6140), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6142), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [49535] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7200), 1,
      anon_sym_SEMI,
    STATE(3122), 1,
      sym_attribute_specifier,
    STATE(3748), 1,
      sym_field_declaration_list,
    STATE(7912), 1,
      sym_virtual_specifier,
    STATE(8737), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5471), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5469), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [49616] = 52,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7010), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7012), 1,
      anon_sym_COMMA,
    ACTIONS(7016), 1,
      anon_sym_DASH,
    ACTIONS(7018), 1,
      anon_sym_PLUS,
    ACTIONS(7020), 1,
      anon_sym_STAR,
    ACTIONS(7022), 1,
      anon_sym_SLASH,
    ACTIONS(7024), 1,
      anon_sym_PERCENT,
    ACTIONS(7026), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7028), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7030), 1,
      anon_sym_PIPE,
    ACTIONS(7032), 1,
      anon_sym_CARET,
    ACTIONS(7034), 1,
      anon_sym_AMP,
    ACTIONS(7036), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7038), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7040), 1,
      anon_sym_GT,
    ACTIONS(7042), 1,
      anon_sym_GT_EQ,
    ACTIONS(7044), 1,
      anon_sym_LT_EQ,
    ACTIONS(7046), 1,
      anon_sym_LT,
    ACTIONS(7048), 1,
      anon_sym_LT_LT,
    ACTIONS(7050), 1,
      anon_sym_GT_GT,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7054), 1,
      anon_sym_EQ,
    ACTIONS(7056), 1,
      anon_sym_QMARK,
    ACTIONS(7058), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7060), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7062), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7064), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7066), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7068), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7070), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7072), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7074), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7076), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7080), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7082), 1,
      anon_sym_or,
    ACTIONS(7084), 1,
      anon_sym_and,
    ACTIONS(7086), 1,
      anon_sym_bitor,
    ACTIONS(7088), 1,
      anon_sym_xor,
    ACTIONS(7090), 1,
      anon_sym_bitand,
    ACTIONS(7092), 1,
      anon_sym_not_eq,
    ACTIONS(7098), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7202), 1,
      anon_sym_RPAREN,
    STATE(1907), 1,
      sym__binary_fold_operator,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    STATE(9711), 1,
      sym__fold_operator,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7078), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [49777] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5136), 1,
      anon_sym_LBRACE,
    ACTIONS(5143), 1,
      anon_sym_LT,
    STATE(3341), 1,
      sym_template_argument_list,
    ACTIONS(5138), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5131), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [49848] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6647), 1,
      anon_sym___attribute__,
    STATE(3685), 1,
      sym_attribute_specifier,
    ACTIONS(6057), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6059), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [49915] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [49998] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6647), 1,
      anon_sym___attribute__,
    STATE(3692), 1,
      sym_attribute_specifier,
    ACTIONS(6053), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6055), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [50065] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7204), 1,
      anon_sym_SEMI,
    STATE(3122), 1,
      sym_attribute_specifier,
    STATE(3748), 1,
      sym_field_declaration_list,
    STATE(7912), 1,
      sym_virtual_specifier,
    STATE(8737), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5471), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5469), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [50146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5481), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5483), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [50209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 1,
      sym_literal_suffix,
    ACTIONS(4256), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(4248), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [50274] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [50355] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7004), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6412), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(6410), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
  [50432] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7124), 1,
      anon_sym_LT_EQ_GT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [50517] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7120), 1,
      anon_sym_GT_EQ,
    ACTIONS(7124), 1,
      anon_sym_LT_EQ_GT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7118), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [50606] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7120), 1,
      anon_sym_GT_EQ,
    ACTIONS(7124), 1,
      anon_sym_LT_EQ_GT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7116), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7118), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
  [50697] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7114), 1,
      anon_sym_AMP,
    ACTIONS(7120), 1,
      anon_sym_GT_EQ,
    ACTIONS(7124), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7132), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7116), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7118), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [50792] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7114), 1,
      anon_sym_AMP,
    ACTIONS(7120), 1,
      anon_sym_GT_EQ,
    ACTIONS(7124), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7132), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7112), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7116), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7118), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6412), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [50889] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7110), 1,
      anon_sym_PIPE,
    ACTIONS(7114), 1,
      anon_sym_AMP,
    ACTIONS(7120), 1,
      anon_sym_GT_EQ,
    ACTIONS(7124), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7128), 1,
      anon_sym_and,
    ACTIONS(7130), 1,
      anon_sym_bitor,
    ACTIONS(7132), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6410), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(7102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7112), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7116), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7118), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [50994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6975), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6977), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [51057] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [51136] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7110), 1,
      anon_sym_PIPE,
    ACTIONS(7114), 1,
      anon_sym_AMP,
    ACTIONS(7120), 1,
      anon_sym_GT_EQ,
    ACTIONS(7124), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7130), 1,
      anon_sym_bitor,
    ACTIONS(7132), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7112), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6410), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7116), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7118), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [51237] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7004), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6462), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(6460), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
  [51314] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 1,
      sym_literal_suffix,
    ACTIONS(5797), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5799), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [51379] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6703), 1,
      anon_sym_EQ,
    ACTIONS(6893), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7106), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7110), 1,
      anon_sym_PIPE,
    ACTIONS(7114), 1,
      anon_sym_AMP,
    ACTIONS(7120), 1,
      anon_sym_GT_EQ,
    ACTIONS(7124), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7126), 1,
      anon_sym_or,
    ACTIONS(7128), 1,
      anon_sym_and,
    ACTIONS(7130), 1,
      anon_sym_bitor,
    ACTIONS(7132), 1,
      anon_sym_bitand,
    ACTIONS(7176), 1,
      anon_sym_QMARK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7112), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7116), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7118), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6705), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [51492] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5481), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5483), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [51557] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7206), 1,
      anon_sym_SEMI,
    STATE(3122), 1,
      sym_attribute_specifier,
    STATE(3748), 1,
      sym_field_declaration_list,
    STATE(7912), 1,
      sym_virtual_specifier,
    STATE(8737), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5471), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5469), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [51638] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6836), 1,
      sym_auto,
    ACTIONS(6838), 1,
      anon_sym_decltype,
    STATE(3535), 1,
      sym_decltype_auto,
    ACTIONS(5499), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5501), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [51707] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6950), 1,
      anon_sym_EQ,
    ACTIONS(7106), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7110), 1,
      anon_sym_PIPE,
    ACTIONS(7114), 1,
      anon_sym_AMP,
    ACTIONS(7120), 1,
      anon_sym_GT_EQ,
    ACTIONS(7124), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7126), 1,
      anon_sym_or,
    ACTIONS(7128), 1,
      anon_sym_and,
    ACTIONS(7130), 1,
      anon_sym_bitor,
    ACTIONS(7132), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7112), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7116), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7118), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6952), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [51816] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2841), 1,
      anon_sym_LBRACE,
    ACTIONS(7178), 1,
      anon_sym_LPAREN2,
    ACTIONS(7180), 1,
      anon_sym_LBRACK,
    ACTIONS(7182), 1,
      sym_auto,
    ACTIONS(7184), 1,
      anon_sym_decltype,
    STATE(4045), 1,
      sym_decltype_auto,
    STATE(4165), 1,
      sym_new_declarator,
    STATE(4536), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5847), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5849), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [51895] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7004), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6370), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(6368), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
  [51972] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7208), 1,
      anon_sym_SEMI,
    STATE(3122), 1,
      sym_attribute_specifier,
    STATE(3748), 1,
      sym_field_declaration_list,
    STATE(7912), 1,
      sym_virtual_specifier,
    STATE(8737), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5471), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5469), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [52053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5657), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5659), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [52116] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6722), 1,
      anon_sym_LBRACK,
    STATE(3548), 1,
      sym_new_declarator,
    ACTIONS(6289), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6291), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [52183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5675), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5677), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [52246] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7210), 1,
      anon_sym_typedef,
    ACTIONS(3322), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3320), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [52310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5640), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [52372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5111), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [52434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5665), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5667), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [52496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5669), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5671), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [52558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5123), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [52620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6166), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6168), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [52682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6170), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6172), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [52744] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6174), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6176), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [52806] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(4296), 1,
      anon_sym_LPAREN2,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6233), 1,
      anon_sym_LBRACK,
    ACTIONS(6348), 1,
      anon_sym_STAR,
    ACTIONS(6350), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6352), 1,
      anon_sym_AMP,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7178), 1,
      sym__declarator,
    STATE(7483), 1,
      sym__abstract_declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    ACTIONS(6965), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [52912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5125), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5127), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [52974] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6293), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6295), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [53038] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7212), 1,
      anon_sym_namespace,
    ACTIONS(6788), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6786), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [53102] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(4296), 1,
      anon_sym_LPAREN2,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6233), 1,
      anon_sym_LBRACK,
    ACTIONS(6348), 1,
      anon_sym_STAR,
    ACTIONS(6350), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6352), 1,
      anon_sym_AMP,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7191), 1,
      sym__declarator,
    STATE(7443), 1,
      sym__abstract_declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    ACTIONS(6235), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [53208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7214), 1,
      anon_sym_typedef,
    ACTIONS(3322), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3320), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [53272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5742), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [53334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5648), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [53396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5642), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5644), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [53458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5640), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [53520] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(7216), 1,
      anon_sym_LBRACK,
    STATE(3184), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4634), 1,
      sym_template_argument_list,
    ACTIONS(4269), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4254), 4,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
    ACTIONS(4274), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4246), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [53596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5117), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5119), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [53658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5150), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5152), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [53720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5115), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [53782] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7219), 1,
      anon_sym_LPAREN2,
    ACTIONS(7221), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    STATE(4118), 1,
      sym_parameter_list,
    STATE(3688), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6069), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6071), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [53854] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5986), 1,
      sym_literal_suffix,
    ACTIONS(4256), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4248), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [53918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5986), 1,
      sym_literal_suffix,
    ACTIONS(5797), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5799), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [53982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6426), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6428), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [54044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6414), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6416), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [54106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6364), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [54168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5716), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5718), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [54230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5632), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [54292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5704), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5706), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [54354] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7229), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(7227), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(7225), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [54420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5702), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [54482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7233), 1,
      anon_sym_namespace,
    ACTIONS(6788), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6786), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [54546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5481), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5483), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [54608] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7235), 1,
      anon_sym_typedef,
    ACTIONS(3322), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3320), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [54672] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4071), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7237), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(4067), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(4065), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [54738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5640), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [54800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5465), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5467), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [54862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6272), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6274), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [54924] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym___attribute__,
    ACTIONS(6958), 1,
      anon_sym_LBRACE,
    STATE(3680), 1,
      sym_enumerator_list,
    STATE(4129), 1,
      sym_attribute_specifier,
    ACTIONS(5952), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5954), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [54994] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7239), 1,
      anon_sym_typedef,
    ACTIONS(3322), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3320), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [55058] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5481), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5483), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [55122] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2297), 1,
      anon_sym_LBRACE,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    STATE(4154), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6178), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6180), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [55190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5481), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5483), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [55252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5661), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5663), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [55314] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(3184), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3328), 1,
      sym_template_argument_list,
    ACTIONS(4274), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4254), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4246), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [55386] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5167), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(5169), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5162), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [55450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5146), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5148), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [55512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5763), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5765), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [55574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5751), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5753), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [55636] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 1,
      sym_auto,
    ACTIONS(6923), 1,
      anon_sym_decltype,
    STATE(3721), 1,
      sym_decltype_auto,
    ACTIONS(5499), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5501), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [55704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5777), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5779), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [55766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5738), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [55828] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7241), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6397), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6399), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [55892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6258), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6260), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [55954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7243), 1,
      anon_sym_typedef,
    ACTIONS(3322), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3320), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [56018] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7245), 1,
      anon_sym_typedef,
    ACTIONS(3322), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3320), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [56082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6254), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6256), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [56144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6250), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6252), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [56206] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4272), 1,
      anon_sym_SEMI,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(3184), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3328), 1,
      sym_template_argument_list,
    ACTIONS(4274), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4254), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4246), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [56280] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(4075), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5958), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(7247), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5960), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [56352] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7249), 1,
      anon_sym_typedef,
    ACTIONS(3322), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3320), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [56416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6243), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6245), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [56478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4129), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4131), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [56540] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7251), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3586), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6210), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6212), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [56606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6239), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6241), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [56668] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(4296), 1,
      anon_sym_LPAREN2,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6233), 1,
      anon_sym_LBRACK,
    ACTIONS(6438), 1,
      anon_sym_STAR,
    ACTIONS(6440), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6442), 1,
      anon_sym_AMP,
    STATE(4540), 1,
      sym_parameter_list,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7178), 1,
      sym__declarator,
    STATE(7464), 1,
      sym__abstract_declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    ACTIONS(6965), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [56774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5759), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5761), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [56836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5722), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [56898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5675), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5677), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [56960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5712), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5714), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [57022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5690), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [57084] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7254), 1,
      sym_identifier,
    STATE(3830), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4257), 1,
      sym_primitive_type,
    ACTIONS(7259), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7257), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5491), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5489), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [57156] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7267), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7265), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(7263), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(7261), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [57222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5696), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5698), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [57284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5657), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5659), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [57346] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7219), 1,
      anon_sym_LPAREN2,
    ACTIONS(7221), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    STATE(4118), 1,
      sym_parameter_list,
    STATE(3688), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5996), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5998), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [57418] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7269), 1,
      anon_sym_typedef,
    ACTIONS(3322), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3320), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [57482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6975), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6977), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [57544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4125), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4127), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [57606] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7271), 1,
      anon_sym_namespace,
    ACTIONS(6788), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6786), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [57670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5694), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [57732] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym___attribute__,
    ACTIONS(6958), 1,
      anon_sym_LBRACE,
    STATE(3690), 1,
      sym_enumerator_list,
    STATE(4190), 1,
      sym_attribute_specifier,
    ACTIONS(5980), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5982), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [57802] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5690), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [57864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6268), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6270), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [57926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5686), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [57988] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 1,
      sym_literal_suffix,
    STATE(3057), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(3551), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3555), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4256), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4248), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [58058] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 1,
      sym_literal_suffix,
    STATE(3057), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(3551), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3555), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5797), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5799), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [58128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6158), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6160), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [58190] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4063), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7273), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(4045), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(4043), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [58256] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7275), 1,
      anon_sym_typedef,
    ACTIONS(3322), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3320), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [58320] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7219), 1,
      anon_sym_LPAREN2,
    ACTIONS(7221), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    STATE(4118), 1,
      sym_parameter_list,
    STATE(3688), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6140), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6142), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [58392] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2297), 1,
      anon_sym_LBRACE,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    STATE(4208), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6152), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6154), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [58460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6981), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [58522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5755), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5757), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [58584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5653), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5655), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [58646] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7283), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7281), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(7279), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(7277), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [58712] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7285), 1,
      anon_sym_LT,
    STATE(3450), 1,
      sym_template_argument_list,
    ACTIONS(6380), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6382), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [58778] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7294), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7292), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(7290), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(7288), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [58844] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(4296), 1,
      anon_sym_LPAREN2,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6233), 1,
      anon_sym_LBRACK,
    ACTIONS(6438), 1,
      anon_sym_STAR,
    ACTIONS(6440), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6442), 1,
      anon_sym_AMP,
    STATE(4540), 1,
      sym_parameter_list,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7191), 1,
      sym__declarator,
    STATE(7467), 1,
      sym__abstract_declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    ACTIONS(6235), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [58950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5634), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5636), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [59012] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3586), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6162), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6164), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [59078] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7296), 1,
      anon_sym_namespace,
    ACTIONS(6788), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6786), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [59142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5781), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5783), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [59204] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5136), 1,
      anon_sym_LBRACE,
    ACTIONS(5650), 1,
      anon_sym_LT,
    STATE(3687), 1,
      sym_template_argument_list,
    ACTIONS(5138), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5131), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [59274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5724), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5726), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [59336] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2297), 1,
      anon_sym_LBRACE,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    STATE(4178), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6185), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6187), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [59404] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7219), 1,
      anon_sym_LPAREN2,
    ACTIONS(7221), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    STATE(4118), 1,
      sym_parameter_list,
    STATE(3688), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6148), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6150), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [59476] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6456), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6458), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [59538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5787), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [59600] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7304), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7302), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(7300), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(7298), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [59666] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7306), 1,
      anon_sym_namespace,
    ACTIONS(6788), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6786), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [59730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5747), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5749), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [59792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5710), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [59854] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2297), 1,
      anon_sym_LBRACE,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    STATE(4185), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6189), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6191), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [59922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5789), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5791), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [59984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5771), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5773), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [60046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5793), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5795), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [60108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6527), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6529), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [60169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2223), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2221), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [60230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5686), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [60291] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(6891), 1,
      anon_sym_EQ,
    ACTIONS(7010), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7056), 1,
      anon_sym_QMARK,
    ACTIONS(7080), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7312), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7314), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7316), 1,
      anon_sym_PIPE,
    ACTIONS(7320), 1,
      anon_sym_AMP,
    ACTIONS(7326), 1,
      anon_sym_GT_EQ,
    ACTIONS(7330), 1,
      anon_sym_or,
    ACTIONS(7332), 1,
      anon_sym_and,
    ACTIONS(7334), 1,
      anon_sym_bitor,
    ACTIONS(7336), 1,
      anon_sym_bitand,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7318), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7310), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7322), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7324), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6895), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [60402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5690), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [60463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6559), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6561), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [60524] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7310), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [60601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5694), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [60662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6547), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6549), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [60723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5696), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5698), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [60784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5690), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [60845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2265), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [60906] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(6879), 1,
      anon_sym_EQ,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7080), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7312), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7314), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7316), 1,
      anon_sym_PIPE,
    ACTIONS(7320), 1,
      anon_sym_AMP,
    ACTIONS(7326), 1,
      anon_sym_GT_EQ,
    ACTIONS(7330), 1,
      anon_sym_or,
    ACTIONS(7332), 1,
      anon_sym_and,
    ACTIONS(7334), 1,
      anon_sym_bitor,
    ACTIONS(7336), 1,
      anon_sym_bitand,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7318), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7310), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7322), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7324), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6881), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [61013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5755), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5757), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [61074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5793), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5795), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [61135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5712), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5714), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [61196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5722), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [61257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5771), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5773), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [61318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5789), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5791), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [61379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5738), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [61440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5777), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5779), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [61501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5787), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [61562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6356), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [61623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5781), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5783), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [61684] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    STATE(3136), 1,
      sym_attribute_specifier,
    ACTIONS(6146), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6144), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [61749] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6460), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6462), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [61824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6555), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6557), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [61885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5751), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5753), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [61946] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(6901), 1,
      anon_sym_EQ,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7080), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7312), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7314), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7316), 1,
      anon_sym_PIPE,
    ACTIONS(7320), 1,
      anon_sym_AMP,
    ACTIONS(7326), 1,
      anon_sym_GT_EQ,
    ACTIONS(7330), 1,
      anon_sym_or,
    ACTIONS(7332), 1,
      anon_sym_and,
    ACTIONS(7334), 1,
      anon_sym_bitor,
    ACTIONS(7336), 1,
      anon_sym_bitand,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7318), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7310), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7322), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7324), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6903), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [62053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5763), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5765), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [62114] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym___attribute__,
    STATE(4193), 1,
      sym_attribute_specifier,
    ACTIONS(6024), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6026), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [62179] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym___attribute__,
    STATE(4192), 1,
      sym_attribute_specifier,
    ACTIONS(6028), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6030), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [62244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6627), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6629), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [62305] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5136), 1,
      anon_sym_LBRACE,
    ACTIONS(5844), 1,
      anon_sym_LT,
    STATE(3973), 1,
      sym_template_argument_list,
    ACTIONS(5138), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5131), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [62374] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5160), 1,
      anon_sym_const,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5164), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_GT2,
    ACTIONS(5169), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5167), 16,
      anon_sym___extension__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5162), 18,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [62443] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6834), 1,
      anon_sym_LBRACK,
    STATE(3998), 1,
      sym_new_declarator,
    ACTIONS(6289), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6291), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [62508] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6757), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7346), 1,
      anon_sym___attribute__,
    ACTIONS(7349), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7352), 1,
      anon_sym___declspec,
    ACTIONS(7355), 1,
      anon_sym_virtual,
    ACTIONS(7358), 1,
      anon_sym_alignas,
    ACTIONS(7343), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(3676), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(7340), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(6755), 16,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [62585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6673), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6675), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [62646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6681), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6683), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [62707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5640), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [62768] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym___attribute__,
    STATE(4191), 1,
      sym_attribute_specifier,
    ACTIONS(6049), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6051), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [62833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5640), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [62894] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7361), 1,
      anon_sym_LT,
    STATE(2153), 1,
      sym_template_argument_list,
    ACTIONS(6380), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6382), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [62959] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym___attribute__,
    STATE(4188), 1,
      sym_attribute_specifier,
    ACTIONS(6061), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6063), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [63024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5642), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5644), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [63085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5648), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [63146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5640), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [63207] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5167), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(5169), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5162), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [63270] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7221), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3796), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6162), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6164), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [63335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5665), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5667), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [63396] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym___attribute__,
    STATE(4064), 1,
      sym_attribute_specifier,
    ACTIONS(6094), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6096), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [63461] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7366), 1,
      anon_sym_and,
    ACTIONS(6065), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6067), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [63526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5669), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5671), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [63587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6488), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6490), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [63648] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6685), 1,
      anon_sym_LT,
    STATE(3975), 1,
      sym_template_argument_list,
    ACTIONS(6297), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6299), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [63715] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym___attribute__,
    STATE(4062), 1,
      sym_attribute_specifier,
    ACTIONS(6144), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6146), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [63780] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(6905), 1,
      anon_sym_EQ,
    ACTIONS(7010), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7056), 1,
      anon_sym_QMARK,
    ACTIONS(7080), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7312), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7314), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7316), 1,
      anon_sym_PIPE,
    ACTIONS(7320), 1,
      anon_sym_AMP,
    ACTIONS(7326), 1,
      anon_sym_GT_EQ,
    ACTIONS(7330), 1,
      anon_sym_or,
    ACTIONS(7332), 1,
      anon_sym_and,
    ACTIONS(7334), 1,
      anon_sym_bitor,
    ACTIONS(7336), 1,
      anon_sym_bitand,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7318), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7310), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7322), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7324), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6907), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [63891] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    STATE(3117), 1,
      sym_attribute_specifier,
    ACTIONS(6096), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6094), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [63956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5879), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5877), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [64017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6996), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6994), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [64078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4037), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4033), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [64139] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7310), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [64220] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    STATE(3094), 1,
      sym_attribute_specifier,
    ACTIONS(6063), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6061), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [64285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6539), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6541), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [64346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5131), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [64407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4127), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4125), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [64468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4131), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4129), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [64529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5131), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [64590] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7310), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [64669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5131), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [64730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5131), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [64791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5131), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [64852] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7080), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7310), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [64935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5131), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [64996] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    STATE(3092), 1,
      sym_attribute_specifier,
    ACTIONS(6051), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6049), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [65061] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7080), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7326), 1,
      anon_sym_GT_EQ,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7310), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7324), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [65148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6418), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6420), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [65209] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7080), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7326), 1,
      anon_sym_GT_EQ,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7310), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7322), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7324), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_DASH_GT_STAR,
  [65298] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    STATE(3080), 1,
      sym_attribute_specifier,
    ACTIONS(6084), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6082), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [65363] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7080), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7320), 1,
      anon_sym_AMP,
    ACTIONS(7326), 1,
      anon_sym_GT_EQ,
    ACTIONS(7336), 1,
      anon_sym_bitand,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7310), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7322), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7324), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_DASH_GT_STAR,
  [65456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6422), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6424), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [65517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5742), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [65578] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7080), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7320), 1,
      anon_sym_AMP,
    ACTIONS(7326), 1,
      anon_sym_GT_EQ,
    ACTIONS(7336), 1,
      anon_sym_bitand,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7318), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7310), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7322), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7324), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6412), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_DASH_GT_STAR,
  [65673] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7080), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7316), 1,
      anon_sym_PIPE,
    ACTIONS(7320), 1,
      anon_sym_AMP,
    ACTIONS(7326), 1,
      anon_sym_GT_EQ,
    ACTIONS(7334), 1,
      anon_sym_bitor,
    ACTIONS(7336), 1,
      anon_sym_bitand,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7318), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6410), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7310), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7322), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7324), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [65772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6397), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6399), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [65833] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    STATE(3098), 1,
      sym_attribute_specifier,
    ACTIONS(6115), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6113), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [65898] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7080), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7314), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7316), 1,
      anon_sym_PIPE,
    ACTIONS(7320), 1,
      anon_sym_AMP,
    ACTIONS(7326), 1,
      anon_sym_GT_EQ,
    ACTIONS(7332), 1,
      anon_sym_and,
    ACTIONS(7334), 1,
      anon_sym_bitor,
    ACTIONS(7336), 1,
      anon_sym_bitand,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(6410), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7318), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7310), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7322), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7324), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [66001] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(3328), 1,
      sym_template_argument_list,
    ACTIONS(4272), 7,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(5835), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [66068] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6410), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [66143] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(4296), 1,
      anon_sym_LPAREN2,
    ACTIONS(4298), 1,
      anon_sym_STAR,
    ACTIONS(4300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4302), 1,
      anon_sym_AMP,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(6233), 1,
      anon_sym_LBRACK,
    ACTIONS(6516), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6965), 1,
      anon_sym_RPAREN,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6657), 1,
      sym__scope_resolution,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7237), 1,
      sym__declarator,
    STATE(7483), 1,
      sym__abstract_declarator,
    STATE(9597), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [66248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5716), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5718), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [66309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6639), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6641), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [66370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5632), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [66431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5704), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5706), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [66492] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    STATE(3074), 1,
      sym_attribute_specifier,
    ACTIONS(6026), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6024), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [66557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6643), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6645), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [66618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6484), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6486), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [66679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6635), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6637), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [66740] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(4296), 1,
      anon_sym_LPAREN2,
    ACTIONS(4298), 1,
      anon_sym_STAR,
    ACTIONS(4300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4302), 1,
      anon_sym_AMP,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(6233), 1,
      anon_sym_LBRACK,
    ACTIONS(6235), 1,
      anon_sym_RPAREN,
    ACTIONS(6516), 1,
      anon_sym_COLON_COLON,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6657), 1,
      sym__scope_resolution,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7272), 1,
      sym__declarator,
    STATE(7443), 1,
      sym__abstract_declarator,
    STATE(9597), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [66845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5702), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [66906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6565), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [66967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3176), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [67028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6635), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6637), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [67089] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    STATE(3129), 1,
      sym_attribute_specifier,
    ACTIONS(6055), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6053), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [67154] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    STATE(3123), 1,
      sym_attribute_specifier,
    ACTIONS(6059), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6057), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [67219] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5824), 4,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(5826), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(4248), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(4256), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
  [67284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5481), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5483), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [67345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5661), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5663), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [67406] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    STATE(3075), 1,
      sym_attribute_specifier,
    ACTIONS(6119), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6117), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [67471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6703), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6705), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [67532] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7368), 1,
      anon_sym_LT,
    STATE(3341), 1,
      sym_template_argument_list,
    ACTIONS(6380), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6382), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [67597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6695), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6697), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [67658] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    STATE(3077), 1,
      sym_attribute_specifier,
    ACTIONS(6123), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6121), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [67723] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6703), 1,
      anon_sym_EQ,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7010), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7056), 1,
      anon_sym_QMARK,
    ACTIONS(7080), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7312), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7314), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7316), 1,
      anon_sym_PIPE,
    ACTIONS(7320), 1,
      anon_sym_AMP,
    ACTIONS(7326), 1,
      anon_sym_GT_EQ,
    ACTIONS(7330), 1,
      anon_sym_or,
    ACTIONS(7332), 1,
      anon_sym_and,
    ACTIONS(7334), 1,
      anon_sym_bitor,
    ACTIONS(7336), 1,
      anon_sym_bitand,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7318), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7310), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7322), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7324), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6705), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [67834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6492), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6494), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [67895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5759), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5761), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [67956] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(6928), 1,
      anon_sym_EQ,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7080), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7312), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7314), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7316), 1,
      anon_sym_PIPE,
    ACTIONS(7320), 1,
      anon_sym_AMP,
    ACTIONS(7326), 1,
      anon_sym_GT_EQ,
    ACTIONS(7330), 1,
      anon_sym_or,
    ACTIONS(7332), 1,
      anon_sym_and,
    ACTIONS(7334), 1,
      anon_sym_bitor,
    ACTIONS(7336), 1,
      anon_sym_bitand,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7318), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7310), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7322), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7324), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6930), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [68063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6500), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6502), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68124] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(3328), 1,
      sym_template_argument_list,
    ACTIONS(5136), 7,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(5129), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [68191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6687), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6689), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6496), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6498), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6575), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6577), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6583), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6585), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6587), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6589), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5304), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5306), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68557] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7368), 1,
      anon_sym_LT,
    STATE(1983), 1,
      sym_template_argument_list,
    ACTIONS(6380), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6382), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5300), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5302), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5320), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5322), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68744] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6699), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6701), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6691), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6693), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6669), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6671), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6663), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6665), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6659), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6661), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [69049] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2739), 1,
      anon_sym_LBRACE,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    STATE(4351), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6152), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6154), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [69116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6344), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6346), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [69177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6344), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6346), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [69238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6344), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6346), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [69299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5308), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5310), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [69360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5288), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5290), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [69421] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    STATE(3076), 1,
      sym_attribute_specifier,
    ACTIONS(6030), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6028), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [69486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6619), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6621), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [69547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5328), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5330), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [69608] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7371), 1,
      sym_identifier,
    STATE(3841), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3747), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3755), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5389), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5387), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [69677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6631), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6633), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [69738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6611), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6613), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [69799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6603), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6605), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [69860] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7361), 1,
      anon_sym_LT,
    STATE(3568), 1,
      sym_template_argument_list,
    ACTIONS(6380), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6382), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [69925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6599), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6601), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [69986] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2739), 1,
      anon_sym_LBRACE,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    STATE(4343), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6189), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6191), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [70053] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6444), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6446), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [70126] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(6950), 1,
      anon_sym_EQ,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7080), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7312), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7314), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7316), 1,
      anon_sym_PIPE,
    ACTIONS(7320), 1,
      anon_sym_AMP,
    ACTIONS(7326), 1,
      anon_sym_GT_EQ,
    ACTIONS(7330), 1,
      anon_sym_or,
    ACTIONS(7332), 1,
      anon_sym_and,
    ACTIONS(7334), 1,
      anon_sym_bitor,
    ACTIONS(7336), 1,
      anon_sym_bitand,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7318), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7310), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7322), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7324), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6952), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [70233] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6950), 1,
      anon_sym_EQ,
    ACTIONS(7377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7381), 1,
      anon_sym_PIPE,
    ACTIONS(7385), 1,
      anon_sym_AMP,
    ACTIONS(7391), 1,
      anon_sym_GT_EQ,
    ACTIONS(7395), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7397), 1,
      anon_sym_or,
    ACTIONS(7399), 1,
      anon_sym_and,
    ACTIONS(7401), 1,
      anon_sym_bitor,
    ACTIONS(7403), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7373), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7383), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7393), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7375), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7387), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7389), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6952), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [70340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6543), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6545), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [70401] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6928), 1,
      anon_sym_EQ,
    ACTIONS(7377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7381), 1,
      anon_sym_PIPE,
    ACTIONS(7385), 1,
      anon_sym_AMP,
    ACTIONS(7391), 1,
      anon_sym_GT_EQ,
    ACTIONS(7395), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7397), 1,
      anon_sym_or,
    ACTIONS(7399), 1,
      anon_sym_and,
    ACTIONS(7401), 1,
      anon_sym_bitor,
    ACTIONS(7403), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7373), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7383), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7393), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7375), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7387), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7389), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6930), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [70508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6360), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [70569] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6703), 1,
      anon_sym_EQ,
    ACTIONS(6893), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7381), 1,
      anon_sym_PIPE,
    ACTIONS(7385), 1,
      anon_sym_AMP,
    ACTIONS(7391), 1,
      anon_sym_GT_EQ,
    ACTIONS(7395), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7397), 1,
      anon_sym_or,
    ACTIONS(7399), 1,
      anon_sym_and,
    ACTIONS(7401), 1,
      anon_sym_bitor,
    ACTIONS(7403), 1,
      anon_sym_bitand,
    ACTIONS(7405), 1,
      anon_sym_QMARK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7373), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7383), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7393), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7375), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7387), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7389), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6705), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [70680] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7407), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3796), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6210), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6212), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [70745] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7375), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [70822] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7381), 1,
      anon_sym_PIPE,
    ACTIONS(7385), 1,
      anon_sym_AMP,
    ACTIONS(7391), 1,
      anon_sym_GT_EQ,
    ACTIONS(7395), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7399), 1,
      anon_sym_and,
    ACTIONS(7401), 1,
      anon_sym_bitor,
    ACTIONS(7403), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6410), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(7373), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7383), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7393), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7375), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7387), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7389), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [70925] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7381), 1,
      anon_sym_PIPE,
    ACTIONS(7385), 1,
      anon_sym_AMP,
    ACTIONS(7391), 1,
      anon_sym_GT_EQ,
    ACTIONS(7395), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7401), 1,
      anon_sym_bitor,
    ACTIONS(7403), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7373), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7383), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7393), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6410), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7375), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7387), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7389), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [71024] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7385), 1,
      anon_sym_AMP,
    ACTIONS(7391), 1,
      anon_sym_GT_EQ,
    ACTIONS(7395), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7403), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7373), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7383), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7393), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7375), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7387), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7389), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6412), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [71119] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7385), 1,
      anon_sym_AMP,
    ACTIONS(7391), 1,
      anon_sym_GT_EQ,
    ACTIONS(7395), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7403), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7373), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7393), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7375), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7387), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7389), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [71212] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7391), 1,
      anon_sym_GT_EQ,
    ACTIONS(7395), 1,
      anon_sym_LT_EQ_GT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7373), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7393), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7375), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7387), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7389), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
  [71301] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6389), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6391), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [71376] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7391), 1,
      anon_sym_GT_EQ,
    ACTIONS(7395), 1,
      anon_sym_LT_EQ_GT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7373), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7393), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7375), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7389), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [71463] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7395), 1,
      anon_sym_LT_EQ_GT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7373), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7393), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7375), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [71546] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7373), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7375), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [71625] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym___attribute__,
    STATE(4139), 1,
      sym_attribute_specifier,
    ACTIONS(6121), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6123), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [71690] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7373), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7393), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7375), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [71771] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym___attribute__,
    STATE(4134), 1,
      sym_attribute_specifier,
    ACTIONS(6117), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6119), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [71836] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6879), 1,
      anon_sym_EQ,
    ACTIONS(7377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7381), 1,
      anon_sym_PIPE,
    ACTIONS(7385), 1,
      anon_sym_AMP,
    ACTIONS(7391), 1,
      anon_sym_GT_EQ,
    ACTIONS(7395), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7397), 1,
      anon_sym_or,
    ACTIONS(7399), 1,
      anon_sym_and,
    ACTIONS(7401), 1,
      anon_sym_bitor,
    ACTIONS(7403), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7373), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7383), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7393), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7375), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7387), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7389), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6881), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [71943] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6891), 1,
      anon_sym_EQ,
    ACTIONS(6893), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7381), 1,
      anon_sym_PIPE,
    ACTIONS(7385), 1,
      anon_sym_AMP,
    ACTIONS(7391), 1,
      anon_sym_GT_EQ,
    ACTIONS(7395), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7397), 1,
      anon_sym_or,
    ACTIONS(7399), 1,
      anon_sym_and,
    ACTIONS(7401), 1,
      anon_sym_bitor,
    ACTIONS(7403), 1,
      anon_sym_bitand,
    ACTIONS(7405), 1,
      anon_sym_QMARK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7373), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7383), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7393), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7375), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7387), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7389), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6895), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [72054] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6393), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6395), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [72129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5324), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5326), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [72190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5332), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5334), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [72251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5292), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5294), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [72312] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym___attribute__,
    STATE(4127), 1,
      sym_attribute_specifier,
    ACTIONS(6113), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6115), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [72377] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2739), 1,
      anon_sym_LBRACE,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    STATE(4279), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6185), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6187), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [72444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5296), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5298), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [72505] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym___attribute__,
    STATE(4119), 1,
      sym_attribute_specifier,
    ACTIONS(6082), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6084), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [72570] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7094), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6368), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6370), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [72645] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6901), 1,
      anon_sym_EQ,
    ACTIONS(7377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7381), 1,
      anon_sym_PIPE,
    ACTIONS(7385), 1,
      anon_sym_AMP,
    ACTIONS(7391), 1,
      anon_sym_GT_EQ,
    ACTIONS(7395), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7397), 1,
      anon_sym_or,
    ACTIONS(7399), 1,
      anon_sym_and,
    ACTIONS(7401), 1,
      anon_sym_bitor,
    ACTIONS(7403), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7373), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7383), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7393), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7375), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7387), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7389), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6903), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [72752] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6893), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6905), 1,
      anon_sym_EQ,
    ACTIONS(7377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7381), 1,
      anon_sym_PIPE,
    ACTIONS(7385), 1,
      anon_sym_AMP,
    ACTIONS(7391), 1,
      anon_sym_GT_EQ,
    ACTIONS(7395), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7397), 1,
      anon_sym_or,
    ACTIONS(7399), 1,
      anon_sym_and,
    ACTIONS(7401), 1,
      anon_sym_bitor,
    ACTIONS(7403), 1,
      anon_sym_bitand,
    ACTIONS(7405), 1,
      anon_sym_QMARK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7373), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7383), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7393), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7375), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7387), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7389), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6907), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [72863] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2739), 1,
      anon_sym_LBRACE,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    STATE(4240), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6178), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6180), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [72930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6990), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [72991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5481), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5483), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [73052] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6448), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6450), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [73125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5314), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5314), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5314), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73308] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2063), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5363), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(5367), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5733), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5730), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5316), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5318), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73436] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7366), 1,
      anon_sym_and,
    ACTIONS(7410), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7412), 1,
      anon_sym_or,
    ACTIONS(6006), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6008), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5284), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5286), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73566] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 1,
      sym_literal_suffix,
    STATE(3057), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(3551), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3555), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4256), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(4248), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6615), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6617), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5628), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(5626), 41,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [73757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6579), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6581), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73818] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7414), 1,
      sym_identifier,
    STATE(3838), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(7417), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(7420), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5375), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5373), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73887] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7423), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6397), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6399), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73950] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7432), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7428), 4,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(7430), 5,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_explicit,
      anon_sym_operator,
    ACTIONS(7435), 13,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_auto,
      anon_sym_typename,
    ACTIONS(7425), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
  [74017] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      sym_identifier,
    STATE(3838), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3747), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3755), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5395), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5393), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [74086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6655), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6657), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [74147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6651), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6653), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [74208] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 1,
      sym_literal_suffix,
    STATE(3057), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(3551), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3555), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5797), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5799), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [74277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6595), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6597), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [74338] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym___attribute__,
    STATE(4026), 1,
      sym_attribute_specifier,
    ACTIONS(6057), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6059), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [74403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6591), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6593), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [74464] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym___attribute__,
    STATE(4065), 1,
      sym_attribute_specifier,
    ACTIONS(6053), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6055), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [74529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6571), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6573), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [74590] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7439), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6397), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6399), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [74653] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6685), 1,
      anon_sym_LT,
    STATE(3975), 1,
      sym_template_argument_list,
    ACTIONS(6328), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6330), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [74720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6567), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6569), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [74781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6535), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6537), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [74842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6531), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6533), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [74903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6523), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6525), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [74964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6788), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6786), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [75025] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6703), 1,
      anon_sym_EQ,
    ACTIONS(6893), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7449), 1,
      anon_sym_PIPE,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_EQ,
    ACTIONS(7463), 1,
      anon_sym_QMARK,
    ACTIONS(7465), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7467), 1,
      anon_sym_or,
    ACTIONS(7469), 1,
      anon_sym_and,
    ACTIONS(7471), 1,
      anon_sym_bitor,
    ACTIONS(7473), 1,
      anon_sym_bitand,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7441), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7451), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7461), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7443), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7455), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7457), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6705), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [75135] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7483), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7485), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7487), 1,
      anon_sym_PIPE,
    ACTIONS(7491), 1,
      anon_sym_AMP,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7503), 1,
      anon_sym_or,
    ACTIONS(7505), 1,
      anon_sym_and,
    ACTIONS(7507), 1,
      anon_sym_bitor,
    ACTIONS(7509), 1,
      anon_sym_bitand,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(6901), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7479), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7489), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7511), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7481), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6903), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [75239] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7511), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6389), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6391), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [75313] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7511), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6393), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6395), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [75387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6414), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6416), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [75447] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5481), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5483), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [75509] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(3218), 1,
      anon_sym_STAR,
    ACTIONS(3220), 1,
      anon_sym_AMP,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(6516), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6657), 1,
      sym__scope_resolution,
    STATE(7272), 1,
      sym__declarator,
    STATE(9597), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3875), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4750), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [75611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6397), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6399), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [75671] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7483), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7485), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7487), 1,
      anon_sym_PIPE,
    ACTIONS(7491), 1,
      anon_sym_AMP,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7503), 1,
      anon_sym_or,
    ACTIONS(7505), 1,
      anon_sym_and,
    ACTIONS(7507), 1,
      anon_sym_bitor,
    ACTIONS(7509), 1,
      anon_sym_bitand,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(6950), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7479), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7489), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7511), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7481), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6952), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [75775] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6444), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6446), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [75847] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7519), 1,
      anon_sym_STAR,
    ACTIONS(7521), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7523), 1,
      anon_sym_AMP,
    ACTIONS(7525), 1,
      anon_sym_COLON_COLON,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(7384), 1,
      sym__declarator,
    STATE(8999), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4788), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [75949] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7098), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7527), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7529), 1,
      anon_sym_COMMA,
    ACTIONS(7531), 1,
      anon_sym_RPAREN,
    ACTIONS(7533), 1,
      anon_sym_DASH,
    ACTIONS(7535), 1,
      anon_sym_PLUS,
    ACTIONS(7537), 1,
      anon_sym_STAR,
    ACTIONS(7539), 1,
      anon_sym_SLASH,
    ACTIONS(7541), 1,
      anon_sym_PERCENT,
    ACTIONS(7543), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7545), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7547), 1,
      anon_sym_PIPE,
    ACTIONS(7549), 1,
      anon_sym_CARET,
    ACTIONS(7551), 1,
      anon_sym_AMP,
    ACTIONS(7553), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7555), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7557), 1,
      anon_sym_GT,
    ACTIONS(7559), 1,
      anon_sym_GT_EQ,
    ACTIONS(7561), 1,
      anon_sym_LT_EQ,
    ACTIONS(7563), 1,
      anon_sym_LT,
    ACTIONS(7565), 1,
      anon_sym_LT_LT,
    ACTIONS(7567), 1,
      anon_sym_GT_GT,
    ACTIONS(7569), 1,
      anon_sym_EQ,
    ACTIONS(7571), 1,
      anon_sym_QMARK,
    ACTIONS(7573), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7575), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7577), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7579), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7581), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7583), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7585), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7587), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7589), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7591), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7595), 1,
      anon_sym_or,
    ACTIONS(7597), 1,
      anon_sym_and,
    ACTIONS(7599), 1,
      anon_sym_bitor,
    ACTIONS(7601), 1,
      anon_sym_xor,
    ACTIONS(7603), 1,
      anon_sym_bitand,
    ACTIONS(7605), 1,
      anon_sym_not_eq,
    STATE(1907), 1,
      sym__binary_fold_operator,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    STATE(9711), 1,
      sym__fold_operator,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [76105] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7519), 1,
      anon_sym_STAR,
    ACTIONS(7521), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7523), 1,
      anon_sym_AMP,
    ACTIONS(7525), 1,
      anon_sym_COLON_COLON,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(7406), 1,
      sym__declarator,
    STATE(8999), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3867), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4757), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [76207] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5497), 1,
      anon_sym_LBRACE,
    ACTIONS(5483), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
    ACTIONS(5481), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [76271] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7609), 1,
      anon_sym_STAR,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7613), 1,
      anon_sym_AMP,
    ACTIONS(7615), 1,
      anon_sym_COLON_COLON,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6577), 1,
      sym__scope_resolution,
    STATE(6948), 1,
      sym__declarator,
    STATE(8852), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4017), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4738), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [76373] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5986), 1,
      sym_literal_suffix,
    STATE(3782), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(3747), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3755), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4256), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4248), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [76441] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5986), 1,
      sym_literal_suffix,
    STATE(3782), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(3747), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3755), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5797), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5799), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [76509] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6368), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6370), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [76583] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(3218), 1,
      anon_sym_STAR,
    ACTIONS(3220), 1,
      anon_sym_AMP,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(6516), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6657), 1,
      sym__scope_resolution,
    STATE(7237), 1,
      sym__declarator,
    STATE(9597), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4745), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [76685] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4284), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4256), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4248), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [76749] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(5180), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5862), 1,
      anon_sym_LPAREN2,
    ACTIONS(5865), 1,
      anon_sym_LBRACK,
    ACTIONS(4284), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4256), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4248), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [76819] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7182), 1,
      sym_auto,
    ACTIONS(7184), 1,
      anon_sym_decltype,
    STATE(4045), 1,
      sym_decltype_auto,
    ACTIONS(5499), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5501), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [76885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6397), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6399), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [76945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5497), 1,
      anon_sym_LBRACE,
    ACTIONS(5483), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
    ACTIONS(5481), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [77007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6975), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6977), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [77067] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7098), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7527), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7529), 1,
      anon_sym_COMMA,
    ACTIONS(7533), 1,
      anon_sym_DASH,
    ACTIONS(7535), 1,
      anon_sym_PLUS,
    ACTIONS(7537), 1,
      anon_sym_STAR,
    ACTIONS(7539), 1,
      anon_sym_SLASH,
    ACTIONS(7541), 1,
      anon_sym_PERCENT,
    ACTIONS(7543), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7545), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7547), 1,
      anon_sym_PIPE,
    ACTIONS(7549), 1,
      anon_sym_CARET,
    ACTIONS(7551), 1,
      anon_sym_AMP,
    ACTIONS(7553), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7555), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7557), 1,
      anon_sym_GT,
    ACTIONS(7559), 1,
      anon_sym_GT_EQ,
    ACTIONS(7561), 1,
      anon_sym_LT_EQ,
    ACTIONS(7563), 1,
      anon_sym_LT,
    ACTIONS(7565), 1,
      anon_sym_LT_LT,
    ACTIONS(7567), 1,
      anon_sym_GT_GT,
    ACTIONS(7569), 1,
      anon_sym_EQ,
    ACTIONS(7571), 1,
      anon_sym_QMARK,
    ACTIONS(7573), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7575), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7577), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7579), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7581), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7583), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7585), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7587), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7589), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7591), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7595), 1,
      anon_sym_or,
    ACTIONS(7597), 1,
      anon_sym_and,
    ACTIONS(7599), 1,
      anon_sym_bitor,
    ACTIONS(7601), 1,
      anon_sym_xor,
    ACTIONS(7603), 1,
      anon_sym_bitand,
    ACTIONS(7605), 1,
      anon_sym_not_eq,
    ACTIONS(7617), 1,
      anon_sym_RPAREN,
    STATE(1907), 1,
      sym__binary_fold_operator,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    STATE(9711), 1,
      sym__fold_operator,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [77223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6788), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6786), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [77283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6973), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6971), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [77343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5879), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5877), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [77403] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6219), 1,
      sym_literal_suffix,
    ACTIONS(4256), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4248), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77465] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6219), 1,
      sym_literal_suffix,
    ACTIONS(5797), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5799), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77527] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7098), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7527), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7529), 1,
      anon_sym_COMMA,
    ACTIONS(7533), 1,
      anon_sym_DASH,
    ACTIONS(7535), 1,
      anon_sym_PLUS,
    ACTIONS(7537), 1,
      anon_sym_STAR,
    ACTIONS(7539), 1,
      anon_sym_SLASH,
    ACTIONS(7541), 1,
      anon_sym_PERCENT,
    ACTIONS(7543), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7545), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7547), 1,
      anon_sym_PIPE,
    ACTIONS(7549), 1,
      anon_sym_CARET,
    ACTIONS(7551), 1,
      anon_sym_AMP,
    ACTIONS(7553), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7555), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7557), 1,
      anon_sym_GT,
    ACTIONS(7559), 1,
      anon_sym_GT_EQ,
    ACTIONS(7561), 1,
      anon_sym_LT_EQ,
    ACTIONS(7563), 1,
      anon_sym_LT,
    ACTIONS(7565), 1,
      anon_sym_LT_LT,
    ACTIONS(7567), 1,
      anon_sym_GT_GT,
    ACTIONS(7569), 1,
      anon_sym_EQ,
    ACTIONS(7571), 1,
      anon_sym_QMARK,
    ACTIONS(7573), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7575), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7577), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7579), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7581), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7583), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7585), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7587), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7589), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7591), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7595), 1,
      anon_sym_or,
    ACTIONS(7597), 1,
      anon_sym_and,
    ACTIONS(7599), 1,
      anon_sym_bitor,
    ACTIONS(7601), 1,
      anon_sym_xor,
    ACTIONS(7603), 1,
      anon_sym_bitand,
    ACTIONS(7605), 1,
      anon_sym_not_eq,
    ACTIONS(7619), 1,
      anon_sym_RPAREN,
    STATE(1907), 1,
      sym__binary_fold_operator,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    STATE(9711), 1,
      sym__fold_operator,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [77683] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5180), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5865), 1,
      anon_sym_LBRACK,
    ACTIONS(5862), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    ACTIONS(4256), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4248), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77749] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5180), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5865), 1,
      anon_sym_LBRACK,
    ACTIONS(5862), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    ACTIONS(4256), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4248), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5675), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5677), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [77875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6981), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [77935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5483), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5481), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [77995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5657), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5659), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [78055] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 1,
      sym_literal_suffix,
    ACTIONS(5797), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5799), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [78117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5879), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5877), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [78177] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 1,
      sym_literal_suffix,
    ACTIONS(4256), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(4248), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [78239] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6893), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6905), 1,
      anon_sym_EQ,
    ACTIONS(7445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7449), 1,
      anon_sym_PIPE,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_EQ,
    ACTIONS(7463), 1,
      anon_sym_QMARK,
    ACTIONS(7465), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7467), 1,
      anon_sym_or,
    ACTIONS(7469), 1,
      anon_sym_and,
    ACTIONS(7471), 1,
      anon_sym_bitor,
    ACTIONS(7473), 1,
      anon_sym_bitand,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7441), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7451), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7461), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7443), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7455), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7457), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6907), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [78349] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7483), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7485), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7487), 1,
      anon_sym_PIPE,
    ACTIONS(7491), 1,
      anon_sym_AMP,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7503), 1,
      anon_sym_or,
    ACTIONS(7505), 1,
      anon_sym_and,
    ACTIONS(7507), 1,
      anon_sym_bitor,
    ACTIONS(7509), 1,
      anon_sym_bitand,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(6928), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7479), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7489), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7511), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7481), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6930), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [78453] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6901), 1,
      anon_sym_EQ,
    ACTIONS(7445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7449), 1,
      anon_sym_PIPE,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_EQ,
    ACTIONS(7465), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7467), 1,
      anon_sym_or,
    ACTIONS(7469), 1,
      anon_sym_and,
    ACTIONS(7471), 1,
      anon_sym_bitor,
    ACTIONS(7473), 1,
      anon_sym_bitand,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7441), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7451), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7461), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7443), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7455), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7457), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6903), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [78559] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6891), 1,
      anon_sym_EQ,
    ACTIONS(6893), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7449), 1,
      anon_sym_PIPE,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_EQ,
    ACTIONS(7463), 1,
      anon_sym_QMARK,
    ACTIONS(7465), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7467), 1,
      anon_sym_or,
    ACTIONS(7469), 1,
      anon_sym_and,
    ACTIONS(7471), 1,
      anon_sym_bitor,
    ACTIONS(7473), 1,
      anon_sym_bitand,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7441), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7451), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7461), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7443), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7455), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7457), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6895), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [78669] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7621), 1,
      anon_sym_STAR,
    ACTIONS(7623), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7625), 1,
      anon_sym_AMP,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(7178), 1,
      sym__declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4751), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [78771] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6879), 1,
      anon_sym_EQ,
    ACTIONS(7445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7449), 1,
      anon_sym_PIPE,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_EQ,
    ACTIONS(7465), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7467), 1,
      anon_sym_or,
    ACTIONS(7469), 1,
      anon_sym_and,
    ACTIONS(7471), 1,
      anon_sym_bitor,
    ACTIONS(7473), 1,
      anon_sym_bitand,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7441), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7451), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7461), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7443), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7455), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7457), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6881), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [78877] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6460), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6462), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [78951] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7272), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4744), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [79053] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7441), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7461), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7443), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [79133] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7621), 1,
      anon_sym_STAR,
    ACTIONS(7623), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7625), 1,
      anon_sym_AMP,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(7173), 1,
      sym__declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4008), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4748), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [79235] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7098), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7527), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7529), 1,
      anon_sym_COMMA,
    ACTIONS(7533), 1,
      anon_sym_DASH,
    ACTIONS(7535), 1,
      anon_sym_PLUS,
    ACTIONS(7537), 1,
      anon_sym_STAR,
    ACTIONS(7539), 1,
      anon_sym_SLASH,
    ACTIONS(7541), 1,
      anon_sym_PERCENT,
    ACTIONS(7543), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7545), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7547), 1,
      anon_sym_PIPE,
    ACTIONS(7549), 1,
      anon_sym_CARET,
    ACTIONS(7551), 1,
      anon_sym_AMP,
    ACTIONS(7553), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7555), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7557), 1,
      anon_sym_GT,
    ACTIONS(7559), 1,
      anon_sym_GT_EQ,
    ACTIONS(7561), 1,
      anon_sym_LT_EQ,
    ACTIONS(7563), 1,
      anon_sym_LT,
    ACTIONS(7565), 1,
      anon_sym_LT_LT,
    ACTIONS(7567), 1,
      anon_sym_GT_GT,
    ACTIONS(7569), 1,
      anon_sym_EQ,
    ACTIONS(7571), 1,
      anon_sym_QMARK,
    ACTIONS(7573), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7575), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7577), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7579), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7581), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7583), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7585), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7587), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7589), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7591), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7595), 1,
      anon_sym_or,
    ACTIONS(7597), 1,
      anon_sym_and,
    ACTIONS(7599), 1,
      anon_sym_bitor,
    ACTIONS(7601), 1,
      anon_sym_xor,
    ACTIONS(7603), 1,
      anon_sym_bitand,
    ACTIONS(7605), 1,
      anon_sym_not_eq,
    ACTIONS(7637), 1,
      anon_sym_RPAREN,
    STATE(1907), 1,
      sym__binary_fold_operator,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    STATE(9711), 1,
      sym__fold_operator,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [79391] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7441), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7443), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [79469] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7465), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7441), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7461), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7443), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [79551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6673), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6675), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [79611] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6711), 1,
      anon_sym_LT,
    STATE(4060), 1,
      sym_template_argument_list,
    ACTIONS(6328), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6330), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [79677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5131), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5131), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5131), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5131), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6456), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6458), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5131), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5131), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80097] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_GT_EQ,
    ACTIONS(7465), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7441), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7461), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7443), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7457), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [80183] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_GT_EQ,
    ACTIONS(7465), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7441), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7461), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7443), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7455), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7457), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
  [80271] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7098), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7527), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7529), 1,
      anon_sym_COMMA,
    ACTIONS(7533), 1,
      anon_sym_DASH,
    ACTIONS(7535), 1,
      anon_sym_PLUS,
    ACTIONS(7537), 1,
      anon_sym_STAR,
    ACTIONS(7539), 1,
      anon_sym_SLASH,
    ACTIONS(7541), 1,
      anon_sym_PERCENT,
    ACTIONS(7543), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7545), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7547), 1,
      anon_sym_PIPE,
    ACTIONS(7549), 1,
      anon_sym_CARET,
    ACTIONS(7551), 1,
      anon_sym_AMP,
    ACTIONS(7553), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7555), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7557), 1,
      anon_sym_GT,
    ACTIONS(7559), 1,
      anon_sym_GT_EQ,
    ACTIONS(7561), 1,
      anon_sym_LT_EQ,
    ACTIONS(7563), 1,
      anon_sym_LT,
    ACTIONS(7565), 1,
      anon_sym_LT_LT,
    ACTIONS(7567), 1,
      anon_sym_GT_GT,
    ACTIONS(7569), 1,
      anon_sym_EQ,
    ACTIONS(7571), 1,
      anon_sym_QMARK,
    ACTIONS(7573), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7575), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7577), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7579), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7581), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7583), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7585), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7587), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7589), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7591), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7595), 1,
      anon_sym_or,
    ACTIONS(7597), 1,
      anon_sym_and,
    ACTIONS(7599), 1,
      anon_sym_bitor,
    ACTIONS(7601), 1,
      anon_sym_xor,
    ACTIONS(7603), 1,
      anon_sym_bitand,
    ACTIONS(7605), 1,
      anon_sym_not_eq,
    ACTIONS(7639), 1,
      anon_sym_RPAREN,
    STATE(1907), 1,
      sym__binary_fold_operator,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    STATE(9711), 1,
      sym__fold_operator,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [80427] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_EQ,
    ACTIONS(7465), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7473), 1,
      anon_sym_bitand,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7441), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7461), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7443), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7455), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7457), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [80519] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7621), 1,
      anon_sym_STAR,
    ACTIONS(7623), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7625), 1,
      anon_sym_AMP,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(7191), 1,
      sym__declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3902), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4752), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [80621] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_EQ,
    ACTIONS(7465), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7473), 1,
      anon_sym_bitand,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7441), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7451), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7461), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7443), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7455), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7457), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6412), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [80715] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7449), 1,
      anon_sym_PIPE,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_EQ,
    ACTIONS(7465), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7471), 1,
      anon_sym_bitor,
    ACTIONS(7473), 1,
      anon_sym_bitand,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7441), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7451), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7461), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6410), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7443), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7455), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7457), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [80813] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7641), 1,
      sym_identifier,
    STATE(4102), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4570), 1,
      sym_primitive_type,
    ACTIONS(7646), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7644), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5491), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5489), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [80883] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7449), 1,
      anon_sym_PIPE,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_EQ,
    ACTIONS(7465), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7469), 1,
      anon_sym_and,
    ACTIONS(7471), 1,
      anon_sym_bitor,
    ACTIONS(7473), 1,
      anon_sym_bitand,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6410), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(7441), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7451), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7461), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7443), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7455), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7457), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [80985] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7648), 1,
      sym_identifier,
    STATE(3929), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(7651), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(7654), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5375), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5373), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [81053] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7483), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7485), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7487), 1,
      anon_sym_PIPE,
    ACTIONS(7491), 1,
      anon_sym_AMP,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7503), 1,
      anon_sym_or,
    ACTIONS(7505), 1,
      anon_sym_and,
    ACTIONS(7507), 1,
      anon_sym_bitor,
    ACTIONS(7509), 1,
      anon_sym_bitand,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(7657), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7659), 1,
      anon_sym_QMARK,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(6703), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7479), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7489), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7511), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7481), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6705), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [81161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6243), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6245), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81221] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6410), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [81295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6254), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6256), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6258), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6260), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81415] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7443), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [81491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6673), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6675), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6250), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6252), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81611] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7671), 1,
      anon_sym_LBRACK,
    ACTIONS(7675), 1,
      anon_sym_DASH_GT,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7684), 1,
      anon_sym_requires,
    STATE(5577), 1,
      sym__function_attributes_start,
    STATE(5770), 1,
      sym_ref_qualifier,
    STATE(6672), 1,
      sym__function_attributes_end,
    STATE(6789), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7677), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4948), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5428), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6945), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6102), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7661), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [81717] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6928), 1,
      anon_sym_EQ,
    ACTIONS(7445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7449), 1,
      anon_sym_PIPE,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_EQ,
    ACTIONS(7465), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7467), 1,
      anon_sym_or,
    ACTIONS(7469), 1,
      anon_sym_and,
    ACTIONS(7471), 1,
      anon_sym_bitor,
    ACTIONS(7473), 1,
      anon_sym_bitand,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7441), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7451), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7461), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7443), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7455), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7457), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6930), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [81823] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6444), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6446), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [81895] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(4250), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7687), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5958), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5960), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [81963] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7689), 1,
      sym_identifier,
    STATE(3929), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(5920), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5922), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5395), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5393), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [82031] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7098), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7527), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7529), 1,
      anon_sym_COMMA,
    ACTIONS(7533), 1,
      anon_sym_DASH,
    ACTIONS(7535), 1,
      anon_sym_PLUS,
    ACTIONS(7537), 1,
      anon_sym_STAR,
    ACTIONS(7539), 1,
      anon_sym_SLASH,
    ACTIONS(7541), 1,
      anon_sym_PERCENT,
    ACTIONS(7543), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7545), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7547), 1,
      anon_sym_PIPE,
    ACTIONS(7549), 1,
      anon_sym_CARET,
    ACTIONS(7551), 1,
      anon_sym_AMP,
    ACTIONS(7553), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7555), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7557), 1,
      anon_sym_GT,
    ACTIONS(7559), 1,
      anon_sym_GT_EQ,
    ACTIONS(7561), 1,
      anon_sym_LT_EQ,
    ACTIONS(7563), 1,
      anon_sym_LT,
    ACTIONS(7565), 1,
      anon_sym_LT_LT,
    ACTIONS(7567), 1,
      anon_sym_GT_GT,
    ACTIONS(7569), 1,
      anon_sym_EQ,
    ACTIONS(7571), 1,
      anon_sym_QMARK,
    ACTIONS(7573), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7575), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7577), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7579), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7581), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7583), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7585), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7587), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7589), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7591), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7595), 1,
      anon_sym_or,
    ACTIONS(7597), 1,
      anon_sym_and,
    ACTIONS(7599), 1,
      anon_sym_bitor,
    ACTIONS(7601), 1,
      anon_sym_xor,
    ACTIONS(7603), 1,
      anon_sym_bitand,
    ACTIONS(7605), 1,
      anon_sym_not_eq,
    ACTIONS(7691), 1,
      anon_sym_RPAREN,
    STATE(1907), 1,
      sym__binary_fold_operator,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    STATE(9711), 1,
      sym__fold_operator,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [82187] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6950), 1,
      anon_sym_EQ,
    ACTIONS(7445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7449), 1,
      anon_sym_PIPE,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_EQ,
    ACTIONS(7465), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7467), 1,
      anon_sym_or,
    ACTIONS(7469), 1,
      anon_sym_and,
    ACTIONS(7471), 1,
      anon_sym_bitor,
    ACTIONS(7473), 1,
      anon_sym_bitand,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7441), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7451), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7461), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7443), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7455), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7457), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6952), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [82293] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6393), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6395), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [82367] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6389), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6391), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [82441] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7693), 1,
      anon_sym_LT,
    STATE(3687), 1,
      sym_template_argument_list,
    ACTIONS(6380), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6382), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [82505] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6448), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6450), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [82577] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7098), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7527), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7529), 1,
      anon_sym_COMMA,
    ACTIONS(7533), 1,
      anon_sym_DASH,
    ACTIONS(7535), 1,
      anon_sym_PLUS,
    ACTIONS(7537), 1,
      anon_sym_STAR,
    ACTIONS(7539), 1,
      anon_sym_SLASH,
    ACTIONS(7541), 1,
      anon_sym_PERCENT,
    ACTIONS(7543), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7545), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7547), 1,
      anon_sym_PIPE,
    ACTIONS(7549), 1,
      anon_sym_CARET,
    ACTIONS(7551), 1,
      anon_sym_AMP,
    ACTIONS(7553), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7555), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7557), 1,
      anon_sym_GT,
    ACTIONS(7559), 1,
      anon_sym_GT_EQ,
    ACTIONS(7561), 1,
      anon_sym_LT_EQ,
    ACTIONS(7563), 1,
      anon_sym_LT,
    ACTIONS(7565), 1,
      anon_sym_LT_LT,
    ACTIONS(7567), 1,
      anon_sym_GT_GT,
    ACTIONS(7569), 1,
      anon_sym_EQ,
    ACTIONS(7571), 1,
      anon_sym_QMARK,
    ACTIONS(7573), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7575), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7577), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7579), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7581), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7583), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7585), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7587), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7589), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7591), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7595), 1,
      anon_sym_or,
    ACTIONS(7597), 1,
      anon_sym_and,
    ACTIONS(7599), 1,
      anon_sym_bitor,
    ACTIONS(7601), 1,
      anon_sym_xor,
    ACTIONS(7603), 1,
      anon_sym_bitand,
    ACTIONS(7605), 1,
      anon_sym_not_eq,
    ACTIONS(7696), 1,
      anon_sym_RPAREN,
    STATE(1907), 1,
      sym__binary_fold_operator,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    STATE(9711), 1,
      sym__fold_operator,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [82733] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(7190), 1,
      anon_sym_LBRACE,
    ACTIONS(7698), 1,
      anon_sym_COLON,
    STATE(3072), 1,
      sym_attribute_specifier,
    STATE(3475), 1,
      sym__enum_base_clause,
    STATE(3702), 1,
      sym_enumerator_list,
    ACTIONS(6336), 7,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6334), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [82805] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7098), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7527), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7529), 1,
      anon_sym_COMMA,
    ACTIONS(7533), 1,
      anon_sym_DASH,
    ACTIONS(7535), 1,
      anon_sym_PLUS,
    ACTIONS(7537), 1,
      anon_sym_STAR,
    ACTIONS(7539), 1,
      anon_sym_SLASH,
    ACTIONS(7541), 1,
      anon_sym_PERCENT,
    ACTIONS(7543), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7545), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7547), 1,
      anon_sym_PIPE,
    ACTIONS(7549), 1,
      anon_sym_CARET,
    ACTIONS(7551), 1,
      anon_sym_AMP,
    ACTIONS(7553), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7555), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7557), 1,
      anon_sym_GT,
    ACTIONS(7559), 1,
      anon_sym_GT_EQ,
    ACTIONS(7561), 1,
      anon_sym_LT_EQ,
    ACTIONS(7563), 1,
      anon_sym_LT,
    ACTIONS(7565), 1,
      anon_sym_LT_LT,
    ACTIONS(7567), 1,
      anon_sym_GT_GT,
    ACTIONS(7569), 1,
      anon_sym_EQ,
    ACTIONS(7571), 1,
      anon_sym_QMARK,
    ACTIONS(7573), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7575), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7577), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7579), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7581), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7583), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7585), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7587), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7589), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7591), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7595), 1,
      anon_sym_or,
    ACTIONS(7597), 1,
      anon_sym_and,
    ACTIONS(7599), 1,
      anon_sym_bitor,
    ACTIONS(7601), 1,
      anon_sym_xor,
    ACTIONS(7603), 1,
      anon_sym_bitand,
    ACTIONS(7605), 1,
      anon_sym_not_eq,
    ACTIONS(7700), 1,
      anon_sym_RPAREN,
    STATE(1907), 1,
      sym__binary_fold_operator,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    STATE(9711), 1,
      sym__fold_operator,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [82961] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 1,
      sym_identifier,
    STATE(3942), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(5920), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5922), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5389), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5387), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [83029] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(7704), 1,
      anon_sym___attribute__,
    ACTIONS(7706), 1,
      anon_sym_LBRACE,
    STATE(4698), 1,
      sym_field_declaration_list,
    STATE(4803), 1,
      sym_attribute_specifier,
    STATE(7802), 1,
      sym_virtual_specifier,
    STATE(8722), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5469), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5471), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [83105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5724), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5726), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [83165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6555), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6557), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [83225] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7693), 1,
      anon_sym_LT,
    STATE(2408), 1,
      sym_template_argument_list,
    ACTIONS(6380), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6382), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [83289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5710), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [83349] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7609), 1,
      anon_sym_STAR,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7613), 1,
      anon_sym_AMP,
    ACTIONS(7615), 1,
      anon_sym_COLON_COLON,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6577), 1,
      sym__scope_resolution,
    STATE(6901), 1,
      sym__declarator,
    STATE(8852), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4782), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [83451] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7098), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7527), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7529), 1,
      anon_sym_COMMA,
    ACTIONS(7533), 1,
      anon_sym_DASH,
    ACTIONS(7535), 1,
      anon_sym_PLUS,
    ACTIONS(7537), 1,
      anon_sym_STAR,
    ACTIONS(7539), 1,
      anon_sym_SLASH,
    ACTIONS(7541), 1,
      anon_sym_PERCENT,
    ACTIONS(7543), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7545), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7547), 1,
      anon_sym_PIPE,
    ACTIONS(7549), 1,
      anon_sym_CARET,
    ACTIONS(7551), 1,
      anon_sym_AMP,
    ACTIONS(7553), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7555), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7557), 1,
      anon_sym_GT,
    ACTIONS(7559), 1,
      anon_sym_GT_EQ,
    ACTIONS(7561), 1,
      anon_sym_LT_EQ,
    ACTIONS(7563), 1,
      anon_sym_LT,
    ACTIONS(7565), 1,
      anon_sym_LT_LT,
    ACTIONS(7567), 1,
      anon_sym_GT_GT,
    ACTIONS(7569), 1,
      anon_sym_EQ,
    ACTIONS(7571), 1,
      anon_sym_QMARK,
    ACTIONS(7573), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7575), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7577), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7579), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7581), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7583), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7585), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7587), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7589), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7591), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7595), 1,
      anon_sym_or,
    ACTIONS(7597), 1,
      anon_sym_and,
    ACTIONS(7599), 1,
      anon_sym_bitor,
    ACTIONS(7601), 1,
      anon_sym_xor,
    ACTIONS(7603), 1,
      anon_sym_bitand,
    ACTIONS(7605), 1,
      anon_sym_not_eq,
    ACTIONS(7708), 1,
      anon_sym_RPAREN,
    STATE(1907), 1,
      sym__binary_fold_operator,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    STATE(9711), 1,
      sym__fold_operator,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [83607] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7511), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7481), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [83683] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7511), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6410), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [83757] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7485), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7487), 1,
      anon_sym_PIPE,
    ACTIONS(7491), 1,
      anon_sym_AMP,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7505), 1,
      anon_sym_and,
    ACTIONS(7507), 1,
      anon_sym_bitor,
    ACTIONS(7509), 1,
      anon_sym_bitand,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7479), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7489), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7511), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6410), 3,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
    ACTIONS(7481), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [83857] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7487), 1,
      anon_sym_PIPE,
    ACTIONS(7491), 1,
      anon_sym_AMP,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7507), 1,
      anon_sym_bitor,
    ACTIONS(7509), 1,
      anon_sym_bitand,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7479), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7489), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7511), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7481), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6410), 4,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7495), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [83953] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7491), 1,
      anon_sym_AMP,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7509), 1,
      anon_sym_bitand,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7479), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7489), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7511), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7481), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 5,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6412), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_GT2,
  [84045] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7491), 1,
      anon_sym_AMP,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7509), 1,
      anon_sym_bitand,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7479), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7511), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7481), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_GT2,
  [84135] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7479), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7511), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7481), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_GT2,
  [84221] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7479), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7511), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7481), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7495), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [84305] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7479), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7511), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7481), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [84387] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7479), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7511), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7481), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 14,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [84465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5465), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5467), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [84525] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7479), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7511), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7481), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6412), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [84605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5634), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5636), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [84665] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5167), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(5169), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5162), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [84727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6239), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6241), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [84787] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6293), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6295), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [84849] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7609), 1,
      anon_sym_STAR,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7613), 1,
      anon_sym_AMP,
    ACTIONS(7615), 1,
      anon_sym_COLON_COLON,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6577), 1,
      sym__scope_resolution,
    STATE(6925), 1,
      sym__declarator,
    STATE(8852), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3958), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4742), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [84951] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6932), 1,
      sym__declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4732), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [85053] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7255), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3905), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4772), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [85155] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7519), 1,
      anon_sym_STAR,
    ACTIONS(7521), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7523), 1,
      anon_sym_AMP,
    ACTIONS(7525), 1,
      anon_sym_COLON_COLON,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(7413), 1,
      sym__declarator,
    STATE(8999), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4006), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4746), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [85257] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6893), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7106), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7110), 1,
      anon_sym_PIPE,
    ACTIONS(7114), 1,
      anon_sym_AMP,
    ACTIONS(7120), 1,
      anon_sym_GT_EQ,
    ACTIONS(7124), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7126), 1,
      anon_sym_or,
    ACTIONS(7128), 1,
      anon_sym_and,
    ACTIONS(7130), 1,
      anon_sym_bitor,
    ACTIONS(7132), 1,
      anon_sym_bitand,
    ACTIONS(7176), 1,
      anon_sym_QMARK,
    ACTIONS(7202), 1,
      anon_sym_RPAREN,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(7718), 1,
      anon_sym_EQ,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6374), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7112), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7116), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7118), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7078), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [85371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4125), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4127), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [85431] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7272), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4744), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [85533] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2841), 1,
      anon_sym_LBRACE,
    ACTIONS(7720), 1,
      anon_sym_LPAREN2,
    STATE(3160), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4081), 1,
      sym_argument_list,
    STATE(4560), 1,
      sym_initializer_list,
    ACTIONS(6818), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5483), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
    ACTIONS(5481), 34,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [85605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6158), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6160), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [85665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6268), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6270), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [85725] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6711), 1,
      anon_sym_LT,
    STATE(4060), 1,
      sym_template_argument_list,
    ACTIONS(6297), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6299), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [85791] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7511), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6460), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6462), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [85865] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(3218), 1,
      anon_sym_STAR,
    ACTIONS(3220), 1,
      anon_sym_AMP,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(6516), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6657), 1,
      sym__scope_resolution,
    STATE(7272), 1,
      sym__declarator,
    STATE(9597), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4750), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [85967] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(3218), 1,
      anon_sym_STAR,
    ACTIONS(3220), 1,
      anon_sym_AMP,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(6516), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6657), 1,
      sym__scope_resolution,
    STATE(7255), 1,
      sym__declarator,
    STATE(9597), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3988), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4764), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [86069] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6448), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6450), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [86141] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6989), 1,
      sym__declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3977), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4753), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [86243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5747), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5749), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [86303] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6932), 1,
      sym__declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4007), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4732), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [86405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4129), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4131), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6174), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6176), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6170), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6172), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6166), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6168), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6364), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6272), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6274), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86765] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(7190), 1,
      anon_sym_LBRACE,
    ACTIONS(7698), 1,
      anon_sym_COLON,
    STATE(3128), 1,
      sym_attribute_specifier,
    STATE(3479), 1,
      sym__enum_base_clause,
    STATE(3725), 1,
      sym_enumerator_list,
    ACTIONS(6282), 7,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6280), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [86837] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7671), 1,
      anon_sym_LBRACK,
    ACTIONS(7675), 1,
      anon_sym_DASH_GT,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7725), 1,
      anon_sym_requires,
    STATE(5580), 1,
      sym__function_attributes_start,
    STATE(5748), 1,
      sym_ref_qualifier,
    STATE(6677), 1,
      sym__function_attributes_end,
    STATE(6771), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4948), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5428), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6945), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6132), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7661), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [86943] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7368), 1,
      anon_sym_LT,
    STATE(2001), 1,
      sym_template_argument_list,
    ACTIONS(6380), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6382), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [87007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3322), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3320), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [87067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6975), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6977), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [87127] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7098), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7527), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7529), 1,
      anon_sym_COMMA,
    ACTIONS(7533), 1,
      anon_sym_DASH,
    ACTIONS(7535), 1,
      anon_sym_PLUS,
    ACTIONS(7537), 1,
      anon_sym_STAR,
    ACTIONS(7539), 1,
      anon_sym_SLASH,
    ACTIONS(7541), 1,
      anon_sym_PERCENT,
    ACTIONS(7543), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7545), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7547), 1,
      anon_sym_PIPE,
    ACTIONS(7549), 1,
      anon_sym_CARET,
    ACTIONS(7551), 1,
      anon_sym_AMP,
    ACTIONS(7553), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7555), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7557), 1,
      anon_sym_GT,
    ACTIONS(7559), 1,
      anon_sym_GT_EQ,
    ACTIONS(7561), 1,
      anon_sym_LT_EQ,
    ACTIONS(7563), 1,
      anon_sym_LT,
    ACTIONS(7565), 1,
      anon_sym_LT_LT,
    ACTIONS(7567), 1,
      anon_sym_GT_GT,
    ACTIONS(7569), 1,
      anon_sym_EQ,
    ACTIONS(7571), 1,
      anon_sym_QMARK,
    ACTIONS(7573), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7575), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7577), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7579), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7581), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7583), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7585), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7587), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7589), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7591), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7595), 1,
      anon_sym_or,
    ACTIONS(7597), 1,
      anon_sym_and,
    ACTIONS(7599), 1,
      anon_sym_bitor,
    ACTIONS(7601), 1,
      anon_sym_xor,
    ACTIONS(7603), 1,
      anon_sym_bitand,
    ACTIONS(7605), 1,
      anon_sym_not_eq,
    ACTIONS(7727), 1,
      anon_sym_RPAREN,
    STATE(1907), 1,
      sym__binary_fold_operator,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    STATE(9711), 1,
      sym__fold_operator,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [87283] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7519), 1,
      anon_sym_STAR,
    ACTIONS(7521), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7523), 1,
      anon_sym_AMP,
    ACTIONS(7525), 1,
      anon_sym_COLON_COLON,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(7406), 1,
      sym__declarator,
    STATE(8999), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4757), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [87385] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6976), 1,
      sym__declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4791), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [87487] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7621), 1,
      anon_sym_STAR,
    ACTIONS(7623), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7625), 1,
      anon_sym_AMP,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(7191), 1,
      sym__declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4752), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [87589] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7483), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7485), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7487), 1,
      anon_sym_PIPE,
    ACTIONS(7491), 1,
      anon_sym_AMP,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7503), 1,
      anon_sym_or,
    ACTIONS(7505), 1,
      anon_sym_and,
    ACTIONS(7507), 1,
      anon_sym_bitor,
    ACTIONS(7509), 1,
      anon_sym_bitand,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(7657), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7659), 1,
      anon_sym_QMARK,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(6905), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7479), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7489), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7511), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7481), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6907), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [87697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6426), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6428), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [87757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5653), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5655), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [87817] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7361), 1,
      anon_sym_LT,
    STATE(2002), 1,
      sym_template_argument_list,
    ACTIONS(6380), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6382), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [87881] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5180), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5862), 1,
      anon_sym_LPAREN2,
    ACTIONS(5865), 1,
      anon_sym_LBRACK,
    ACTIONS(4256), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4248), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [87947] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5180), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5862), 1,
      anon_sym_LPAREN2,
    ACTIONS(5865), 1,
      anon_sym_LBRACK,
    ACTIONS(4256), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4248), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [88013] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    STATE(4168), 1,
      sym_new_declarator,
    ACTIONS(6289), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6291), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88077] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7483), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7485), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7487), 1,
      anon_sym_PIPE,
    ACTIONS(7491), 1,
      anon_sym_AMP,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7503), 1,
      anon_sym_or,
    ACTIONS(7505), 1,
      anon_sym_and,
    ACTIONS(7507), 1,
      anon_sym_bitor,
    ACTIONS(7509), 1,
      anon_sym_bitand,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(6879), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7479), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7489), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7511), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7481), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6881), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [88181] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7609), 1,
      anon_sym_STAR,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7613), 1,
      anon_sym_AMP,
    ACTIONS(7615), 1,
      anon_sym_COLON_COLON,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6577), 1,
      sym__scope_resolution,
    STATE(6925), 1,
      sym__declarator,
    STATE(8852), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4742), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [88283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6981), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [88343] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7098), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7527), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7529), 1,
      anon_sym_COMMA,
    ACTIONS(7533), 1,
      anon_sym_DASH,
    ACTIONS(7535), 1,
      anon_sym_PLUS,
    ACTIONS(7537), 1,
      anon_sym_STAR,
    ACTIONS(7539), 1,
      anon_sym_SLASH,
    ACTIONS(7541), 1,
      anon_sym_PERCENT,
    ACTIONS(7543), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7545), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7547), 1,
      anon_sym_PIPE,
    ACTIONS(7549), 1,
      anon_sym_CARET,
    ACTIONS(7551), 1,
      anon_sym_AMP,
    ACTIONS(7553), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7555), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7557), 1,
      anon_sym_GT,
    ACTIONS(7559), 1,
      anon_sym_GT_EQ,
    ACTIONS(7561), 1,
      anon_sym_LT_EQ,
    ACTIONS(7563), 1,
      anon_sym_LT,
    ACTIONS(7565), 1,
      anon_sym_LT_LT,
    ACTIONS(7567), 1,
      anon_sym_GT_GT,
    ACTIONS(7569), 1,
      anon_sym_EQ,
    ACTIONS(7571), 1,
      anon_sym_QMARK,
    ACTIONS(7573), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7575), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7577), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7579), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7581), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7583), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7585), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7587), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7589), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7591), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7595), 1,
      anon_sym_or,
    ACTIONS(7597), 1,
      anon_sym_and,
    ACTIONS(7599), 1,
      anon_sym_bitor,
    ACTIONS(7601), 1,
      anon_sym_xor,
    ACTIONS(7603), 1,
      anon_sym_bitand,
    ACTIONS(7605), 1,
      anon_sym_not_eq,
    ACTIONS(7729), 1,
      anon_sym_RPAREN,
    STATE(1907), 1,
      sym__binary_fold_operator,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    STATE(9711), 1,
      sym__fold_operator,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [88499] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7731), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6397), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6399), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [88561] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7483), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7485), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7487), 1,
      anon_sym_PIPE,
    ACTIONS(7491), 1,
      anon_sym_AMP,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7503), 1,
      anon_sym_or,
    ACTIONS(7505), 1,
      anon_sym_and,
    ACTIONS(7507), 1,
      anon_sym_bitor,
    ACTIONS(7509), 1,
      anon_sym_bitand,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(7657), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7659), 1,
      anon_sym_QMARK,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(6891), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7479), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7489), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7511), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7481), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6895), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [88669] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7733), 1,
      anon_sym_LT,
    STATE(3184), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3328), 1,
      sym_template_argument_list,
    ACTIONS(4274), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4254), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4246), 34,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [88739] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7237), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4797), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [88841] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7511), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6368), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6370), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [88915] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7735), 1,
      sym_identifier,
    STATE(4145), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(5200), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5202), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5395), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5393), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5648), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [89041] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7671), 1,
      anon_sym_LBRACK,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7739), 1,
      anon_sym___attribute__,
    ACTIONS(7742), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(7749), 1,
      anon_sym_requires,
    STATE(5657), 1,
      sym__function_attributes_start,
    STATE(5830), 1,
      sym_ref_qualifier,
    STATE(6566), 1,
      sym__function_attributes_end,
    STATE(6594), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5094), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5642), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6727), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6140), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7661), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [89146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5411), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5413), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [89205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6669), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6671), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [89264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5661), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5663), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [89323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5653), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5655), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [89382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5481), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5483), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [89441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2265), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [89500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5481), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5483), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [89559] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5976), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4256), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4248), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [89620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5702), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [89679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5704), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5706), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [89738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5632), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [89797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5716), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5718), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [89856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5441), 3,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(5439), 48,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_typename,
      anon_sym_template,
  [89915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6673), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6675), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [89974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6272), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6274), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90033] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7751), 1,
      sym_identifier,
    STATE(4025), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(5200), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5202), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5389), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5387), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5292), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5294), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [90159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5742), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [90218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6166), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6168), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5131), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [90336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6174), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6176), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5131), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [90454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5131), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [90513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5131), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [90572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5131), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [90631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5131), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [90690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5296), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5298), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [90749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6414), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6416), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90808] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7753), 1,
      anon_sym_LT,
    STATE(2431), 1,
      sym_template_argument_list,
    STATE(4250), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7687), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4246), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(4254), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [90877] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7733), 1,
      anon_sym_LT,
    STATE(3328), 1,
      sym_template_argument_list,
    ACTIONS(5136), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5129), 37,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [90942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6627), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6629), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6681), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6683), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91060] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6293), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6295), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2223), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2221), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5763), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5765), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [91239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5332), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5334), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [91298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5751), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5753), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [91357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5669), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5671), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [91416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5665), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5667), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [91475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5640), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [91534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5642), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5644), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [91593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6170), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6172), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5640), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [91711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6268), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6270), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6158), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6160), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5284), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5286), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [91888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5284), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5286), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91947] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2450), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6034), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(7755), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6032), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [92010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 3,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(5417), 48,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_typename,
      anon_sym_template,
  [92069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2223), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(2221), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [92128] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7759), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7761), 1,
      anon_sym_or,
    ACTIONS(7763), 1,
      anon_sym_and,
    ACTIONS(6006), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6008), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92195] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5324), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5326), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [92254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5640), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [92313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6635), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6637), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6488), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6490), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6565), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4037), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4033), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6539), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6541), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6635), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6637), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6484), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6486), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6643), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6645), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5316), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5318), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5417), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5419), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [92903] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2841), 1,
      anon_sym_LBRACE,
    ACTIONS(7178), 1,
      anon_sym_LPAREN2,
    STATE(4481), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6178), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6180), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6456), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6458), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [93027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5879), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5877), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6422), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6424), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93145] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5314), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5314), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5314), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6418), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6420), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93381] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7733), 1,
      anon_sym_LT,
    ACTIONS(7767), 1,
      anon_sym_EQ,
    STATE(3184), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3328), 1,
      sym_template_argument_list,
    ACTIONS(7765), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(4274), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4254), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4246), 34,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [93454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4125), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4127), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [93513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3176), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93572] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4105), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5363), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7769), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5733), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5730), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [93637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6703), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6705), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6695), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6697), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93755] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4105), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7769), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5363), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5365), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [93818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5296), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5298), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6687), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6689), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5292), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5294), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6981), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(6979), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
  [94054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4129), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4131), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6555), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6557), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94172] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4211), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5724), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(7772), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5726), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [94235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6397), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6399), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6559), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6561), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94353] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2841), 1,
      anon_sym_LBRACE,
    ACTIONS(7178), 1,
      anon_sym_LPAREN2,
    STATE(4502), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6185), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6187), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6547), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6549), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5304), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5306), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [94536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6239), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6241), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5777), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5779), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [94654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5738), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [94713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5439), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5441), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [94772] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    STATE(3122), 1,
      sym_attribute_specifier,
    STATE(4608), 1,
      sym_field_declaration_list,
    STATE(7785), 1,
      sym_virtual_specifier,
    STATE(8467), 1,
      sym_base_class_clause,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5469), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(5471), 38,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [94847] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(2671), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5182), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5958), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5960), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [94914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5332), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5334), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5324), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5326), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95032] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7774), 1,
      anon_sym_LT,
    STATE(3973), 1,
      sym_template_argument_list,
    ACTIONS(6380), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6382), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [95095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5722), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [95154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(2265), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [95213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5712), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5714), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [95272] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4211), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5481), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(7772), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5483), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [95335] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2450), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6092), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(7755), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6090), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [95398] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7671), 1,
      anon_sym_LBRACK,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7739), 1,
      anon_sym___attribute__,
    ACTIONS(7742), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(7780), 1,
      anon_sym_requires,
    STATE(5633), 1,
      sym__function_attributes_start,
    STATE(5849), 1,
      sym_ref_qualifier,
    STATE(6612), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7777), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5094), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5642), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6727), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6141), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7661), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [95503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5690), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [95562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5696), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5698), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [95621] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7783), 1,
      anon_sym_LT,
    STATE(2431), 1,
      sym_template_argument_list,
    STATE(2671), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5182), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4246), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4254), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [95690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6603), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6605), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5320), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5322), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [95808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(6975), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
  [95867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5694), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [95926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5421), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5423), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [95985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5690), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [96044] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2450), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6105), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(7755), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6103), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [96107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6492), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6494), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96166] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6500), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6502), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96225] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7785), 1,
      sym_identifier,
    STATE(4145), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(7788), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(7791), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5375), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5373), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [96292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5686), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [96351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5314), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [96410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5314), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [96469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5300), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5302), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [96528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6496), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6498), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6575), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6577), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6579), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6581), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5314), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [96764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6583), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6585), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6587), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6589), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5328), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5330), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5288), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5290), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97000] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7759), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7763), 1,
      anon_sym_and,
    ACTIONS(6065), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6067), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97063] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7794), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6397), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6399), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [97124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5308), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5310), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5288), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5290), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [97242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5328), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5330), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [97301] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7774), 1,
      anon_sym_LT,
    STATE(2417), 1,
      sym_template_argument_list,
    ACTIONS(6380), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6382), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [97364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6344), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6346), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97423] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2841), 1,
      anon_sym_LBRACE,
    ACTIONS(7178), 1,
      anon_sym_LPAREN2,
    STATE(4504), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6189), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6191), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6344), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6346), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6344), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6346), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6364), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [97665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6356), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6619), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6621), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6360), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5759), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5761), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [97901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5320), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5322), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97960] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7733), 1,
      anon_sym_LT,
    STATE(3328), 1,
      sym_template_argument_list,
    ACTIONS(4272), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5835), 37,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [98025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5300), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5302), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6611), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6613), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98143] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5916), 1,
      anon_sym_EQ,
    ACTIONS(5918), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4256), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4248), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [98206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6699), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6701), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6426), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6428), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [98324] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7806), 1,
      anon_sym___attribute__,
    ACTIONS(7809), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7812), 1,
      anon_sym___declspec,
    ACTIONS(7815), 1,
      anon_sym_virtual,
    ACTIONS(7818), 1,
      anon_sym_alignas,
    ACTIONS(7821), 1,
      anon_sym_explicit,
    ACTIONS(7798), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(7796), 7,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(7803), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(4180), 11,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      sym_explicit_function_specifier,
      sym__constructor_specifiers,
      aux_sym_operator_cast_definition_repeat1,
    ACTIONS(7800), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [98401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6663), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6665), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6659), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6661), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6655), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6657), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6651), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6653), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6639), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6641), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98696] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7216), 1,
      anon_sym_LBRACK,
    ACTIONS(7733), 1,
      anon_sym_LT,
    STATE(3184), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4711), 1,
      sym_template_argument_list,
    ACTIONS(4269), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4274), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4254), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_EQ,
    ACTIONS(4246), 33,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [98769] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2841), 1,
      anon_sym_LBRACE,
    ACTIONS(7178), 1,
      anon_sym_LPAREN2,
    STATE(4561), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6152), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6154), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5755), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5757), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [98893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6615), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6617), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5793), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5795), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [99011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5771), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5773), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [99070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5789), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5791), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [99129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5787), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [99188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5781), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5783), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [99247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6691), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6693), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [99306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6523), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6525), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [99365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6527), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6529), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [99424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5316), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5318), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [99483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5304), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5306), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [99542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6531), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6533), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [99601] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7368), 1,
      anon_sym_LT,
    STATE(2010), 1,
      sym_template_argument_list,
    ACTIONS(6380), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6382), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [99664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6535), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6537), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [99723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6543), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6545), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [99782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6324), 1,
      sym_literal_suffix,
    ACTIONS(5799), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(5797), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
  [99843] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6324), 1,
      sym_literal_suffix,
    ACTIONS(4248), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(4256), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
  [99904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6567), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6569), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [99963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6571), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6573), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [100022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6631), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6633), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [100081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6258), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6260), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [100140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6254), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6256), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [100199] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2450), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6020), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(7755), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6018), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [100262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6250), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6252), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [100321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6243), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6245), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [100380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6599), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6601), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [100439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6595), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6597), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [100498] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4131), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6136), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(7824), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6134), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [100561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6591), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6593), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [100620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5308), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5310), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [100679] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6109), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(7826), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6107), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [100742] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5167), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(5169), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5162), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [100802] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5284), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5286), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [100860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6488), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6490), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [100918] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6448), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6450), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [100988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4037), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4033), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [101046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6496), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6498), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [101104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6575), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6577), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [101162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6635), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6637), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [101220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6539), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6541), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [101278] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6389), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6391), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [101350] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6393), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6395), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [101422] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7671), 1,
      anon_sym_LBRACK,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7833), 1,
      anon_sym_DASH_GT,
    STATE(5685), 1,
      sym__function_attributes_start,
    STATE(5884), 1,
      sym_ref_qualifier,
    STATE(6564), 1,
      sym__function_attributes_end,
    STATE(6594), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7830), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5094), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5642), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6727), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6179), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7661), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [101526] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(2036), 1,
      sym_template_argument_list,
    ACTIONS(5129), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5136), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_try,
      anon_sym_requires,
  [101590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5316), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5318), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [101648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5131), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [101706] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4235), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5363), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5365), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [101768] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(6950), 1,
      anon_sym_EQ,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7846), 1,
      anon_sym_PIPE,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_AMP,
    ACTIONS(7856), 1,
      anon_sym_GT_EQ,
    ACTIONS(7860), 1,
      anon_sym_bitor,
    ACTIONS(7862), 1,
      anon_sym_xor,
    ACTIONS(7864), 1,
      anon_sym_bitand,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7842), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7844), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7852), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7854), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6952), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [101870] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6444), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6446), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [101940] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7671), 1,
      anon_sym_LBRACK,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7866), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7869), 1,
      anon_sym_DASH_GT,
    ACTIONS(7871), 1,
      anon_sym_requires,
    STATE(5699), 1,
      sym__function_attributes_start,
    STATE(5871), 1,
      sym_ref_qualifier,
    STATE(6591), 1,
      sym_trailing_return_type,
    STATE(6643), 1,
      sym__function_attributes_end,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7830), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4948), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5428), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6727), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6168), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7661), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [102044] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7873), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7875), 1,
      anon_sym_and,
    ACTIONS(6065), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6067), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6583), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6585), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6587), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6589), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6611), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6613), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102280] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6086), 1,
      anon_sym_EQ,
    ACTIONS(6088), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4256), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4248), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [102342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5288), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5290), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5131), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5879), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5877), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6681), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6683), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102574] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5196), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(5198), 12,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4248), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(4256), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
  [102636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5131), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102694] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4235), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7877), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6034), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6032), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [102756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5131), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102814] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4235), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7877), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6020), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6018), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [102876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6565), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5131), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102992] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7881), 1,
      anon_sym_RPAREN,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(8154), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [103096] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4272), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7885), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6109), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6107), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [103158] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4277), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7887), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6136), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6134), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [103220] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(6928), 1,
      anon_sym_EQ,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7846), 1,
      anon_sym_PIPE,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_AMP,
    ACTIONS(7856), 1,
      anon_sym_GT_EQ,
    ACTIONS(7860), 1,
      anon_sym_bitor,
    ACTIONS(7862), 1,
      anon_sym_xor,
    ACTIONS(7864), 1,
      anon_sym_bitand,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7842), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7844), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7852), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7854), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6930), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [103322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6360), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6619), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6621), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6344), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6346), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6669), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6671), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6344), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6346), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5314), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103670] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 1,
      sym_literal_suffix,
    STATE(3952), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(5920), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5922), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4256), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(4248), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [103736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5320), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5322), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103794] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(7889), 1,
      anon_sym___attribute__,
    ACTIONS(7891), 1,
      anon_sym_LBRACE,
    STATE(4740), 1,
      sym_field_declaration_list,
    STATE(4883), 1,
      sym_attribute_specifier,
    STATE(7677), 1,
      sym_virtual_specifier,
    STATE(8629), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5469), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5471), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [103868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5314), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6559), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6561), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5300), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5302), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [104042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5314), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [104100] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4235), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7877), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6105), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6103), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [104162] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 1,
      sym_literal_suffix,
    STATE(3952), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(5920), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5922), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5797), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5799), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [104228] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6344), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6346), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [104286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5131), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [104344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6673), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6675), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [104402] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4235), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7877), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6092), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6090), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [104464] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4252), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7893), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5724), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5726), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [104526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6699), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6701), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [104584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6691), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6693), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [104642] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7895), 1,
      anon_sym_LT,
    STATE(2431), 1,
      sym_template_argument_list,
    ACTIONS(5129), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5136), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [104706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6356), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [104764] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7671), 1,
      anon_sym_LBRACK,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7898), 1,
      anon_sym_DASH_GT,
    STATE(5680), 1,
      sym__function_attributes_start,
    STATE(5872), 1,
      sym_ref_qualifier,
    STATE(6594), 1,
      sym_trailing_return_type,
    STATE(6733), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5094), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5642), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6727), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6169), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7661), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [104868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3176), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [104926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6615), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6617), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [104984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5308), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5310), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5328), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5330), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105100] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(6901), 1,
      anon_sym_EQ,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7846), 1,
      anon_sym_PIPE,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_AMP,
    ACTIONS(7856), 1,
      anon_sym_GT_EQ,
    ACTIONS(7860), 1,
      anon_sym_bitor,
    ACTIONS(7862), 1,
      anon_sym_xor,
    ACTIONS(7864), 1,
      anon_sym_bitand,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7842), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7844), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7852), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7854), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6903), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [105202] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7671), 1,
      anon_sym_LBRACK,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7866), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(7900), 1,
      anon_sym_DASH_GT,
    STATE(5697), 1,
      sym__function_attributes_start,
    STATE(5883), 1,
      sym_ref_qualifier,
    STATE(6591), 1,
      sym_trailing_return_type,
    STATE(6753), 1,
      sym__function_attributes_end,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4948), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5428), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6727), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6175), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7661), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [105306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6418), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6420), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6703), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6705), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6422), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6424), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105480] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6703), 1,
      anon_sym_EQ,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7527), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7571), 1,
      anon_sym_QMARK,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7846), 1,
      anon_sym_PIPE,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_AMP,
    ACTIONS(7856), 1,
      anon_sym_GT_EQ,
    ACTIONS(7860), 1,
      anon_sym_bitor,
    ACTIONS(7862), 1,
      anon_sym_xor,
    ACTIONS(7864), 1,
      anon_sym_bitand,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7842), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7844), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7852), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7854), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6705), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [105586] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(7909), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4294), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(7906), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7904), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(7902), 31,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [105652] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6410), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6412), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [105724] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(2036), 1,
      sym_template_argument_list,
    ACTIONS(5835), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4272), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_try,
      anon_sym_requires,
  [105788] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6410), 1,
      anon_sym_EQ,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7846), 1,
      anon_sym_PIPE,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_AMP,
    ACTIONS(7856), 1,
      anon_sym_GT_EQ,
    ACTIONS(7860), 1,
      anon_sym_bitor,
    ACTIONS(7862), 1,
      anon_sym_xor,
    ACTIONS(7864), 1,
      anon_sym_bitand,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7844), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7852), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7854), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_DASH_GT_STAR,
  [105888] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6410), 1,
      anon_sym_EQ,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7846), 1,
      anon_sym_PIPE,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_AMP,
    ACTIONS(7856), 1,
      anon_sym_GT_EQ,
    ACTIONS(7860), 1,
      anon_sym_bitor,
    ACTIONS(7862), 1,
      anon_sym_xor,
    ACTIONS(7864), 1,
      anon_sym_bitand,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7852), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7854), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH_GT_STAR,
  [105986] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_AMP,
    ACTIONS(7856), 1,
      anon_sym_GT_EQ,
    ACTIONS(7862), 1,
      anon_sym_xor,
    ACTIONS(7864), 1,
      anon_sym_bitand,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(6410), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7852), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7854), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_DASH_GT_STAR,
  [106080] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7850), 1,
      anon_sym_AMP,
    ACTIONS(7856), 1,
      anon_sym_GT_EQ,
    ACTIONS(7864), 1,
      anon_sym_bitand,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6410), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
    ACTIONS(7840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7852), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7854), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_DASH_GT_STAR,
  [106170] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7856), 1,
      anon_sym_GT_EQ,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7852), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7854), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(6412), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_DASH_GT_STAR,
  [106256] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7856), 1,
      anon_sym_GT_EQ,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7854), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(6412), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [106340] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(6412), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [106420] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 9,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6412), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [106496] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(6412), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [106574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6643), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6645), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [106632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6500), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6502), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [106690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6484), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6486), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [106748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6695), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6697), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [106806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6635), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6637), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [106864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5296), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5298), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [106922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5292), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5294), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [106980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2265), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [107038] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7671), 1,
      anon_sym_LBRACK,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7866), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7869), 1,
      anon_sym_DASH_GT,
    ACTIONS(7912), 1,
      anon_sym_requires,
    STATE(5704), 1,
      sym__function_attributes_start,
    STATE(5878), 1,
      sym_ref_qualifier,
    STATE(6588), 1,
      sym__function_attributes_end,
    STATE(6633), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7777), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7830), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4948), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5428), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6727), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6172), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7661), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [107142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2223), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2221), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [107200] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(6905), 1,
      anon_sym_EQ,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7527), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7571), 1,
      anon_sym_QMARK,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7846), 1,
      anon_sym_PIPE,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_AMP,
    ACTIONS(7856), 1,
      anon_sym_GT_EQ,
    ACTIONS(7860), 1,
      anon_sym_bitor,
    ACTIONS(7862), 1,
      anon_sym_xor,
    ACTIONS(7864), 1,
      anon_sym_bitand,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7842), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7844), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7852), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7854), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6907), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [107306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6527), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6529), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [107364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6687), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6689), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [107422] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6460), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6462), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [107494] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(4554), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7915), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5958), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5960), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107560] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7671), 1,
      anon_sym_LBRACK,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(7780), 1,
      anon_sym_requires,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7898), 1,
      anon_sym_DASH_GT,
    STATE(5679), 1,
      sym__function_attributes_start,
    STATE(5879), 1,
      sym_ref_qualifier,
    STATE(6612), 1,
      sym_trailing_return_type,
    STATE(6712), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7777), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5094), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5642), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6727), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6154), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7661), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [107664] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7873), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7875), 1,
      anon_sym_and,
    ACTIONS(7917), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7919), 1,
      anon_sym_or,
    ACTIONS(6006), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6008), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [107730] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6410), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6412), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [107804] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5939), 1,
      anon_sym_EQ,
    ACTIONS(5941), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4256), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4248), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107866] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7733), 1,
      anon_sym_LT,
    ACTIONS(7767), 1,
      anon_sym_EQ,
    STATE(3328), 1,
      sym_template_argument_list,
    ACTIONS(7765), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(4272), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(5835), 37,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [107934] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7753), 1,
      anon_sym_LT,
    STATE(2431), 1,
      sym_template_argument_list,
    ACTIONS(5835), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4272), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107998] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 1,
      anon_sym_LBRACK,
    STATE(4406), 1,
      sym_new_declarator,
    ACTIONS(6289), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6291), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [108060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6663), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6665), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [108118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6659), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6661), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [108176] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(7190), 1,
      anon_sym_LBRACE,
    ACTIONS(7921), 1,
      anon_sym_COLON,
    STATE(3128), 1,
      sym_attribute_specifier,
    STATE(3479), 1,
      sym__enum_base_clause,
    STATE(3725), 1,
      sym_enumerator_list,
    ACTIONS(6282), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6280), 33,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [108246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6523), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6525), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [108304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6492), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6494), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [108362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6531), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6533), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [108420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6535), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6537), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [108478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6567), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6569), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [108536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6571), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6573), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [108594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6591), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6593), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [108652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6547), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6549), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [108710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6543), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6545), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [108768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6595), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6597), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [108826] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7671), 1,
      anon_sym_LBRACK,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(7780), 1,
      anon_sym_requires,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7833), 1,
      anon_sym_DASH_GT,
    STATE(5702), 1,
      sym__function_attributes_start,
    STATE(5864), 1,
      sym_ref_qualifier,
    STATE(6596), 1,
      sym__function_attributes_end,
    STATE(6612), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7777), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7830), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5094), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5642), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6727), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6155), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7661), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [108930] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7671), 1,
      anon_sym_LBRACK,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7866), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_DASH_GT,
    ACTIONS(7912), 1,
      anon_sym_requires,
    STATE(5683), 1,
      sym__function_attributes_start,
    STATE(5896), 1,
      sym_ref_qualifier,
    STATE(6633), 1,
      sym_trailing_return_type,
    STATE(6698), 1,
      sym__function_attributes_end,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7777), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4948), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5428), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6727), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6158), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7661), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [109034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6639), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6641), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [109092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6651), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6653), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [109150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6627), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6629), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [109208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6655), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6657), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [109266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5332), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5334), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [109324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5304), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5306), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [109382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6397), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6399), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [109440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5324), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5326), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [109498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6631), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6633), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [109556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5421), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5423), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [109614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5411), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5413), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [109672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5439), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5441), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [109730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6555), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6557), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [109788] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(7190), 1,
      anon_sym_LBRACE,
    ACTIONS(7921), 1,
      anon_sym_COLON,
    STATE(3072), 1,
      sym_attribute_specifier,
    STATE(3475), 1,
      sym__enum_base_clause,
    STATE(3702), 1,
      sym_enumerator_list,
    ACTIONS(6336), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6334), 33,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [109858] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(6891), 1,
      anon_sym_EQ,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7527), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7571), 1,
      anon_sym_QMARK,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7846), 1,
      anon_sym_PIPE,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_AMP,
    ACTIONS(7856), 1,
      anon_sym_GT_EQ,
    ACTIONS(7860), 1,
      anon_sym_bitor,
    ACTIONS(7862), 1,
      anon_sym_xor,
    ACTIONS(7864), 1,
      anon_sym_bitand,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7842), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7844), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7852), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7854), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6895), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [109964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6599), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6601), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [110022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6603), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6605), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [110080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6579), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6581), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [110138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5417), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5419), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [110196] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    ACTIONS(6879), 1,
      anon_sym_EQ,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7338), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7593), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7846), 1,
      anon_sym_PIPE,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_AMP,
    ACTIONS(7856), 1,
      anon_sym_GT_EQ,
    ACTIONS(7860), 1,
      anon_sym_bitor,
    ACTIONS(7862), 1,
      anon_sym_xor,
    ACTIONS(7864), 1,
      anon_sym_bitand,
    STATE(4086), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym_subscript_argument_list,
    ACTIONS(7096), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7607), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7842), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7844), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7852), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7854), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6881), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [110298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5439), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5441), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [110355] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9057), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [110456] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_enum,
    ACTIONS(7931), 1,
      anon_sym_class,
    ACTIONS(7933), 1,
      anon_sym_struct,
    ACTIONS(7935), 1,
      anon_sym_union,
    ACTIONS(7937), 1,
      anon_sym_typename,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6061), 1,
      sym__type_specifier,
    STATE(6136), 1,
      sym_primitive_type,
    STATE(6466), 1,
      sym__type_definition_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4523), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [110557] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_enum,
    ACTIONS(7931), 1,
      anon_sym_class,
    ACTIONS(7933), 1,
      anon_sym_struct,
    ACTIONS(7935), 1,
      anon_sym_union,
    ACTIONS(7937), 1,
      anon_sym_typename,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6061), 1,
      sym__type_specifier,
    STATE(6136), 1,
      sym_primitive_type,
    STATE(6461), 1,
      sym__type_definition_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4523), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [110658] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5636), 1,
      sym__type_specifier,
    STATE(6978), 1,
      sym_type_descriptor,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4514), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [110759] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_enum,
    ACTIONS(7931), 1,
      anon_sym_class,
    ACTIONS(7933), 1,
      anon_sym_struct,
    ACTIONS(7935), 1,
      anon_sym_union,
    ACTIONS(7937), 1,
      anon_sym_typename,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6061), 1,
      sym__type_specifier,
    STATE(6136), 1,
      sym_primitive_type,
    STATE(6463), 1,
      sym__type_definition_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4523), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [110860] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9332), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [110961] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_enum,
    ACTIONS(7931), 1,
      anon_sym_class,
    ACTIONS(7933), 1,
      anon_sym_struct,
    ACTIONS(7935), 1,
      anon_sym_union,
    ACTIONS(7937), 1,
      anon_sym_typename,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6061), 1,
      sym__type_specifier,
    STATE(6136), 1,
      sym_primitive_type,
    STATE(6469), 1,
      sym__type_definition_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4523), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [111062] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_enum,
    ACTIONS(7931), 1,
      anon_sym_class,
    ACTIONS(7933), 1,
      anon_sym_struct,
    ACTIONS(7935), 1,
      anon_sym_union,
    ACTIONS(7937), 1,
      anon_sym_typename,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6061), 1,
      sym__type_specifier,
    STATE(6136), 1,
      sym_primitive_type,
    STATE(6470), 1,
      sym__type_definition_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4523), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [111163] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_enum,
    ACTIONS(7931), 1,
      anon_sym_class,
    ACTIONS(7933), 1,
      anon_sym_struct,
    ACTIONS(7935), 1,
      anon_sym_union,
    ACTIONS(7937), 1,
      anon_sym_typename,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6061), 1,
      sym__type_specifier,
    STATE(6136), 1,
      sym_primitive_type,
    STATE(6472), 1,
      sym__type_definition_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4523), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [111264] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5495), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5497), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [111323] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(8904), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [111424] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(7939), 1,
      sym_identifier,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7947), 1,
      anon_sym_enum,
    ACTIONS(7949), 1,
      anon_sym_class,
    ACTIONS(7951), 1,
      anon_sym_struct,
    ACTIONS(7953), 1,
      anon_sym_union,
    ACTIONS(7955), 1,
      sym_auto,
    ACTIONS(7957), 1,
      anon_sym_decltype,
    ACTIONS(7959), 1,
      anon_sym_typename,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(4811), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4900), 1,
      sym__type_specifier,
    STATE(5230), 1,
      sym_primitive_type,
    STATE(5753), 1,
      sym_decltype_auto,
    STATE(6717), 1,
      sym_type_descriptor,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3039), 2,
      sym_decltype,
      sym_template_type,
    STATE(4527), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7945), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7943), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5793), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [111525] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(7939), 1,
      sym_identifier,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7947), 1,
      anon_sym_enum,
    ACTIONS(7949), 1,
      anon_sym_class,
    ACTIONS(7951), 1,
      anon_sym_struct,
    ACTIONS(7953), 1,
      anon_sym_union,
    ACTIONS(7955), 1,
      sym_auto,
    ACTIONS(7957), 1,
      anon_sym_decltype,
    ACTIONS(7959), 1,
      anon_sym_typename,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(4811), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5002), 1,
      sym__type_specifier,
    STATE(5230), 1,
      sym_primitive_type,
    STATE(5753), 1,
      sym_decltype_auto,
    STATE(6717), 1,
      sym_type_descriptor,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3039), 2,
      sym_decltype,
      sym_template_type,
    STATE(4534), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7945), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7943), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5793), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [111626] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9188), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [111727] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7671), 1,
      anon_sym_LBRACK,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7866), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7961), 1,
      anon_sym_DASH_GT,
    ACTIONS(7963), 1,
      anon_sym_requires,
    STATE(5808), 1,
      sym__function_attributes_start,
    STATE(5925), 1,
      sym_ref_qualifier,
    STATE(6760), 1,
      sym__function_attributes_end,
    STATE(6886), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7777), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4948), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5428), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6727), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6186), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7661), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [111830] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_enum,
    ACTIONS(7931), 1,
      anon_sym_class,
    ACTIONS(7933), 1,
      anon_sym_struct,
    ACTIONS(7935), 1,
      anon_sym_union,
    ACTIONS(7937), 1,
      anon_sym_typename,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6061), 1,
      sym__type_specifier,
    STATE(6136), 1,
      sym_primitive_type,
    STATE(6458), 1,
      sym__type_definition_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4523), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [111931] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_enum,
    ACTIONS(7931), 1,
      anon_sym_class,
    ACTIONS(7933), 1,
      anon_sym_struct,
    ACTIONS(7935), 1,
      anon_sym_union,
    ACTIONS(7937), 1,
      anon_sym_typename,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6061), 1,
      sym__type_specifier,
    STATE(6136), 1,
      sym_primitive_type,
    STATE(6454), 1,
      sym__type_definition_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4523), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [112032] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9261), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [112133] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5850), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9283), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4492), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [112234] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6219), 1,
      sym_literal_suffix,
    ACTIONS(4256), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4248), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [112293] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_enum,
    ACTIONS(7931), 1,
      anon_sym_class,
    ACTIONS(7933), 1,
      anon_sym_struct,
    ACTIONS(7935), 1,
      anon_sym_union,
    ACTIONS(7937), 1,
      anon_sym_typename,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6061), 1,
      sym__type_specifier,
    STATE(6136), 1,
      sym_primitive_type,
    STATE(6450), 1,
      sym__type_definition_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4523), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [112394] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(7939), 1,
      sym_identifier,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7947), 1,
      anon_sym_enum,
    ACTIONS(7949), 1,
      anon_sym_class,
    ACTIONS(7951), 1,
      anon_sym_struct,
    ACTIONS(7953), 1,
      anon_sym_union,
    ACTIONS(7955), 1,
      sym_auto,
    ACTIONS(7957), 1,
      anon_sym_decltype,
    ACTIONS(7959), 1,
      anon_sym_typename,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(4811), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4886), 1,
      sym__type_specifier,
    STATE(5230), 1,
      sym_primitive_type,
    STATE(5753), 1,
      sym_decltype_auto,
    STATE(6717), 1,
      sym_type_descriptor,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3039), 2,
      sym_decltype,
      sym_template_type,
    STATE(4585), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7945), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7943), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5793), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [112495] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9362), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [112596] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(7966), 1,
      sym_identifier,
    ACTIONS(7968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7974), 1,
      anon_sym_enum,
    ACTIONS(7976), 1,
      anon_sym_class,
    ACTIONS(7978), 1,
      anon_sym_struct,
    ACTIONS(7980), 1,
      anon_sym_union,
    ACTIONS(7982), 1,
      sym_auto,
    ACTIONS(7984), 1,
      anon_sym_decltype,
    ACTIONS(7986), 1,
      anon_sym_typename,
    STATE(4950), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4962), 1,
      sym__type_specifier,
    STATE(5635), 1,
      sym_primitive_type,
    STATE(5921), 1,
      sym_qualified_type_identifier,
    STATE(5957), 1,
      sym_decltype_auto,
    STATE(6978), 1,
      sym_type_descriptor,
    STATE(7328), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(4510), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5890), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7972), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7970), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5956), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [112697] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_enum,
    ACTIONS(7931), 1,
      anon_sym_class,
    ACTIONS(7933), 1,
      anon_sym_struct,
    ACTIONS(7935), 1,
      anon_sym_union,
    ACTIONS(7937), 1,
      anon_sym_typename,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6061), 1,
      sym__type_specifier,
    STATE(6136), 1,
      sym_primitive_type,
    STATE(6487), 1,
      sym__type_definition_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4523), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [112798] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_enum,
    ACTIONS(7931), 1,
      anon_sym_class,
    ACTIONS(7933), 1,
      anon_sym_struct,
    ACTIONS(7935), 1,
      anon_sym_union,
    ACTIONS(7937), 1,
      anon_sym_typename,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6061), 1,
      sym__type_specifier,
    STATE(6136), 1,
      sym_primitive_type,
    STATE(6444), 1,
      sym__type_definition_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4523), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [112899] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_enum,
    ACTIONS(7931), 1,
      anon_sym_class,
    ACTIONS(7933), 1,
      anon_sym_struct,
    ACTIONS(7935), 1,
      anon_sym_union,
    ACTIONS(7937), 1,
      anon_sym_typename,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6061), 1,
      sym__type_specifier,
    STATE(6136), 1,
      sym_primitive_type,
    STATE(6445), 1,
      sym__type_definition_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4523), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [113000] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5850), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(9534), 1,
      sym_type_descriptor,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4492), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [113101] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_enum,
    ACTIONS(7931), 1,
      anon_sym_class,
    ACTIONS(7933), 1,
      anon_sym_struct,
    ACTIONS(7935), 1,
      anon_sym_union,
    ACTIONS(7937), 1,
      anon_sym_typename,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6061), 1,
      sym__type_specifier,
    STATE(6136), 1,
      sym_primitive_type,
    STATE(6447), 1,
      sym__type_definition_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4523), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [113202] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_enum,
    ACTIONS(7931), 1,
      anon_sym_class,
    ACTIONS(7933), 1,
      anon_sym_struct,
    ACTIONS(7935), 1,
      anon_sym_union,
    ACTIONS(7937), 1,
      anon_sym_typename,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6061), 1,
      sym__type_specifier,
    STATE(6136), 1,
      sym_primitive_type,
    STATE(6448), 1,
      sym__type_definition_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4523), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [113303] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_enum,
    ACTIONS(7931), 1,
      anon_sym_class,
    ACTIONS(7933), 1,
      anon_sym_struct,
    ACTIONS(7935), 1,
      anon_sym_union,
    ACTIONS(7937), 1,
      anon_sym_typename,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6061), 1,
      sym__type_specifier,
    STATE(6136), 1,
      sym_primitive_type,
    STATE(6462), 1,
      sym__type_definition_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4523), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [113404] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_enum,
    ACTIONS(7931), 1,
      anon_sym_class,
    ACTIONS(7933), 1,
      anon_sym_struct,
    ACTIONS(7935), 1,
      anon_sym_union,
    ACTIONS(7937), 1,
      anon_sym_typename,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6061), 1,
      sym__type_specifier,
    STATE(6136), 1,
      sym_primitive_type,
    STATE(6465), 1,
      sym__type_definition_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4523), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [113505] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9445), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [113606] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9376), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [113707] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6219), 1,
      sym_literal_suffix,
    ACTIONS(5797), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5799), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113766] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_enum,
    ACTIONS(7931), 1,
      anon_sym_class,
    ACTIONS(7933), 1,
      anon_sym_struct,
    ACTIONS(7935), 1,
      anon_sym_union,
    ACTIONS(7937), 1,
      anon_sym_typename,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6061), 1,
      sym__type_specifier,
    STATE(6136), 1,
      sym_primitive_type,
    STATE(6483), 1,
      sym__type_definition_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4523), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [113867] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9413), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [113968] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5850), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9418), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4492), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [114069] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9435), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [114170] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5850), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9440), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4492), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [114271] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9235), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [114372] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_enum,
    ACTIONS(7931), 1,
      anon_sym_class,
    ACTIONS(7933), 1,
      anon_sym_struct,
    ACTIONS(7935), 1,
      anon_sym_union,
    ACTIONS(7937), 1,
      anon_sym_typename,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6061), 1,
      sym__type_specifier,
    STATE(6136), 1,
      sym_primitive_type,
    STATE(6494), 1,
      sym__type_definition_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4523), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [114473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6364), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5653), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5655), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [114587] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5850), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(9516), 1,
      sym_type_descriptor,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4492), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [114688] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4252), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7893), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5481), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5483), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [114749] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9456), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [114850] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(8476), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [114951] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(9564), 1,
      sym_type_descriptor,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [115052] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7704), 1,
      anon_sym___attribute__,
    ACTIONS(7988), 1,
      anon_sym_LBRACE,
    ACTIONS(7990), 1,
      anon_sym_COLON,
    STATE(4649), 1,
      sym__enum_base_clause,
    STATE(4684), 1,
      sym_enumerator_list,
    STATE(4784), 1,
      sym_attribute_specifier,
    ACTIONS(6334), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6336), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [115121] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(8928), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [115222] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_enum,
    ACTIONS(7931), 1,
      anon_sym_class,
    ACTIONS(7933), 1,
      anon_sym_struct,
    ACTIONS(7935), 1,
      anon_sym_union,
    ACTIONS(7937), 1,
      anon_sym_typename,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6061), 1,
      sym__type_specifier,
    STATE(6136), 1,
      sym_primitive_type,
    STATE(6491), 1,
      sym__type_definition_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4523), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [115323] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5850), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9498), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4492), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [115424] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9318), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [115525] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9154), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [115626] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(9594), 1,
      sym_type_descriptor,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [115727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5606), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5608), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [115784] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9094), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [115885] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5626), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5628), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [115944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5417), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5419), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [116001] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5626), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5628), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116060] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7671), 1,
      anon_sym_LBRACK,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7992), 1,
      anon_sym_DASH_GT,
    ACTIONS(7994), 1,
      anon_sym_requires,
    STATE(5780), 1,
      sym__function_attributes_start,
    STATE(5932), 1,
      sym_ref_qualifier,
    STATE(6847), 1,
      sym__function_attributes_end,
    STATE(6991), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7677), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4948), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5428), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6945), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6192), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7661), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [116163] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9074), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [116264] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(6717), 1,
      sym_type_descriptor,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [116365] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7704), 1,
      anon_sym___attribute__,
    ACTIONS(7988), 1,
      anon_sym_LBRACE,
    ACTIONS(7990), 1,
      anon_sym_COLON,
    STATE(4607), 1,
      sym__enum_base_clause,
    STATE(4697), 1,
      sym_enumerator_list,
    STATE(4793), 1,
      sym_attribute_specifier,
    ACTIONS(6280), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6282), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116434] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5850), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9461), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4492), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [116535] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9296), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [116636] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(9680), 1,
      sym_type_descriptor,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [116737] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9294), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [116838] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(7997), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8001), 1,
      anon_sym_enum,
    ACTIONS(8003), 1,
      anon_sym_class,
    ACTIONS(8005), 1,
      anon_sym_struct,
    ACTIONS(8007), 1,
      anon_sym_union,
    ACTIONS(8009), 1,
      anon_sym_typename,
    STATE(3140), 1,
      sym_decltype_auto,
    STATE(3331), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(4130), 1,
      sym_primitive_type,
    STATE(5038), 1,
      sym__type_specifier,
    STATE(6717), 1,
      sym_type_descriptor,
    STATE(7322), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3039), 2,
      sym_decltype,
      sym_template_type,
    STATE(4503), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(4049), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3087), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [116939] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7671), 1,
      anon_sym_LBRACK,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7992), 1,
      anon_sym_DASH_GT,
    ACTIONS(8011), 1,
      anon_sym_requires,
    STATE(5813), 1,
      sym__function_attributes_start,
    STATE(5914), 1,
      sym_ref_qualifier,
    STATE(6842), 1,
      sym__function_attributes_end,
    STATE(6946), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4948), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5428), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6945), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6204), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7661), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [117042] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6324), 1,
      sym_literal_suffix,
    STATE(4043), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(5200), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5202), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5797), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5799), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [117107] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6324), 1,
      sym_literal_suffix,
    STATE(4043), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(5200), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5202), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4256), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(4248), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [117172] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(9609), 1,
      sym_type_descriptor,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [117273] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(8864), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [117374] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8013), 1,
      anon_sym_LT,
    STATE(4554), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4623), 1,
      sym_template_argument_list,
    ACTIONS(7915), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4246), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(4254), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6981), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [117498] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_enum,
    ACTIONS(7931), 1,
      anon_sym_class,
    ACTIONS(7933), 1,
      anon_sym_struct,
    ACTIONS(7935), 1,
      anon_sym_union,
    ACTIONS(7937), 1,
      anon_sym_typename,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6061), 1,
      sym__type_specifier,
    STATE(6136), 1,
      sym_primitive_type,
    STATE(6452), 1,
      sym__type_definition_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4523), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [117599] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5325), 1,
      sym__type_specifier,
    STATE(6978), 1,
      sym_type_descriptor,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4496), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [117700] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(9511), 1,
      sym_type_descriptor,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [117801] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(8991), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [117902] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9475), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [118003] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9003), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [118104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5411), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5413), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [118161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5421), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5423), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [118218] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5140), 1,
      anon_sym_LBRACK,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(4634), 1,
      sym_template_argument_list,
    ACTIONS(5133), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5136), 4,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
    ACTIONS(5129), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [118285] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2990), 1,
      anon_sym_enum,
    ACTIONS(2992), 1,
      anon_sym_class,
    ACTIONS(2994), 1,
      anon_sym_struct,
    ACTIONS(2996), 1,
      anon_sym_union,
    ACTIONS(3022), 1,
      sym_auto,
    ACTIONS(3024), 1,
      anon_sym_decltype,
    ACTIONS(3026), 1,
      anon_sym_typename,
    ACTIONS(8015), 1,
      sym_identifier,
    ACTIONS(8017), 1,
      anon_sym_COLON_COLON,
    STATE(2651), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3059), 1,
      sym_primitive_type,
    STATE(3398), 1,
      sym_decltype_auto,
    STATE(3494), 1,
      sym_qualified_type_identifier,
    STATE(5469), 1,
      sym__type_specifier,
    STATE(6978), 1,
      sym_type_descriptor,
    STATE(7325), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3383), 2,
      sym_decltype,
      sym_template_type,
    STATE(4549), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2988), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2986), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3397), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [118386] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5850), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9480), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4492), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [118487] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9148), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [118588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5115), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5150), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5152), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5117), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5119), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5125), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5127), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5123), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5111), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118930] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(4075), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4246), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(7247), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4254), 37,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_try,
      anon_sym_requires,
  [118997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5146), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5148), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6975), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6977), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [119111] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(7955), 1,
      sym_auto,
    ACTIONS(7957), 1,
      anon_sym_decltype,
    ACTIONS(8019), 1,
      sym_identifier,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8023), 1,
      anon_sym_enum,
    ACTIONS(8025), 1,
      anon_sym_class,
    ACTIONS(8027), 1,
      anon_sym_struct,
    ACTIONS(8029), 1,
      anon_sym_union,
    ACTIONS(8031), 1,
      anon_sym_typename,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(4811), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5230), 1,
      sym_primitive_type,
    STATE(5549), 1,
      sym__type_specifier,
    STATE(5753), 1,
      sym_decltype_auto,
    STATE(6717), 1,
      sym_type_descriptor,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3039), 2,
      sym_decltype,
      sym_template_type,
    STATE(4495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7945), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7943), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5793), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [119212] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(4041), 1,
      sym_identifier,
    ACTIONS(4047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4051), 1,
      anon_sym_enum,
    ACTIONS(4053), 1,
      anon_sym_class,
    ACTIONS(4055), 1,
      anon_sym_struct,
    ACTIONS(4057), 1,
      anon_sym_union,
    ACTIONS(4059), 1,
      anon_sym_typename,
    STATE(3140), 1,
      sym_decltype_auto,
    STATE(3331), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(4130), 1,
      sym_primitive_type,
    STATE(5091), 1,
      sym__type_specifier,
    STATE(6717), 1,
      sym_type_descriptor,
    STATE(7352), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3039), 2,
      sym_decltype,
      sym_template_type,
    STATE(4551), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(4049), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3087), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [119313] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(8839), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [119414] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5850), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9273), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4492), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [119515] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9484), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [119616] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9130), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [119717] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7671), 1,
      anon_sym_LBRACK,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7866), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7961), 1,
      anon_sym_DASH_GT,
    ACTIONS(8033), 1,
      anon_sym_requires,
    STATE(5820), 1,
      sym__function_attributes_start,
    STATE(5908), 1,
      sym_ref_qualifier,
    STATE(6770), 1,
      sym__function_attributes_end,
    STATE(6938), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4948), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5428), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6727), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6188), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7661), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [119820] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_enum,
    ACTIONS(7931), 1,
      anon_sym_class,
    ACTIONS(7933), 1,
      anon_sym_struct,
    ACTIONS(7935), 1,
      anon_sym_union,
    ACTIONS(7937), 1,
      anon_sym_typename,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6061), 1,
      sym__type_specifier,
    STATE(6136), 1,
      sym_primitive_type,
    STATE(6481), 1,
      sym__type_definition_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4523), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [119921] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(7997), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8001), 1,
      anon_sym_enum,
    ACTIONS(8003), 1,
      anon_sym_class,
    ACTIONS(8005), 1,
      anon_sym_struct,
    ACTIONS(8007), 1,
      anon_sym_union,
    ACTIONS(8009), 1,
      anon_sym_typename,
    STATE(3140), 1,
      sym_decltype_auto,
    STATE(3331), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(4130), 1,
      sym_primitive_type,
    STATE(4858), 1,
      sym__type_specifier,
    STATE(6717), 1,
      sym_type_descriptor,
    STATE(7322), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3039), 2,
      sym_decltype,
      sym_template_type,
    STATE(4520), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(4049), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3087), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [120022] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5167), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(5169), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5162), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120081] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9025), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [120182] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(8849), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [120283] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9493), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [120384] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9095), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [120485] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9009), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [120586] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5671), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9077), 1,
      sym_type_descriptor,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4573), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [120687] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8035), 1,
      anon_sym_LBRACK,
    STATE(4575), 1,
      sym_new_declarator,
    ACTIONS(6289), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6291), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120748] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_enum,
    ACTIONS(7931), 1,
      anon_sym_class,
    ACTIONS(7933), 1,
      anon_sym_struct,
    ACTIONS(7935), 1,
      anon_sym_union,
    ACTIONS(7937), 1,
      anon_sym_typename,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6061), 1,
      sym__type_specifier,
    STATE(6136), 1,
      sym_primitive_type,
    STATE(6467), 1,
      sym__type_definition_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(4523), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [120849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5314), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [120905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6583), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6585), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [120961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5296), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5298), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [121017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5320), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5322), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [121073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6695), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6697), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [121129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5300), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5302), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [121185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6669), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6671), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [121241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5292), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5294), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [121297] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7190), 1,
      anon_sym_LBRACE,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    STATE(3106), 1,
      sym_attribute_specifier,
    STATE(4611), 1,
      sym_enumerator_list,
    ACTIONS(5952), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(5954), 40,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [121361] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8037), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8039), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6006), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6008), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [121421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6579), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6581), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [121477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6543), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6545), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [121533] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5860), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [121631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6575), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6577), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [121687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5421), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5423), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [121743] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(7955), 1,
      sym_auto,
    ACTIONS(7957), 1,
      anon_sym_decltype,
    ACTIONS(8019), 1,
      sym_identifier,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8023), 1,
      anon_sym_enum,
    ACTIONS(8025), 1,
      anon_sym_class,
    ACTIONS(8027), 1,
      anon_sym_struct,
    ACTIONS(8029), 1,
      anon_sym_union,
    ACTIONS(8031), 1,
      anon_sym_typename,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(4811), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5230), 1,
      sym_primitive_type,
    STATE(5535), 1,
      sym__type_specifier,
    STATE(5753), 1,
      sym_decltype_auto,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3039), 2,
      sym_decltype,
      sym_template_type,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7945), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7943), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5793), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [121841] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5284), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [121939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5411), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5413), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [121995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6703), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6705), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [122051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6691), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6693), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [122107] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(8035), 1,
      anon_sym_LBRACK,
    ACTIONS(8041), 1,
      anon_sym_LPAREN2,
    ACTIONS(8043), 1,
      sym_auto,
    ACTIONS(8045), 1,
      anon_sym_decltype,
    STATE(4690), 1,
      sym_new_declarator,
    STATE(4774), 1,
      sym_decltype_auto,
    STATE(4642), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5831), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5833), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [122179] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(8035), 1,
      anon_sym_LBRACK,
    ACTIONS(8041), 1,
      anon_sym_LPAREN2,
    ACTIONS(8043), 1,
      sym_auto,
    ACTIONS(8045), 1,
      anon_sym_decltype,
    STATE(4672), 1,
      sym_new_declarator,
    STATE(4774), 1,
      sym_decltype_auto,
    STATE(4602), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5847), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5849), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [122251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6699), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6701), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [122307] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(7997), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8001), 1,
      anon_sym_enum,
    ACTIONS(8003), 1,
      anon_sym_class,
    ACTIONS(8005), 1,
      anon_sym_struct,
    ACTIONS(8007), 1,
      anon_sym_union,
    ACTIONS(8009), 1,
      anon_sym_typename,
    STATE(3140), 1,
      sym_decltype_auto,
    STATE(3331), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(4130), 1,
      sym_primitive_type,
    STATE(5000), 1,
      sym__type_specifier,
    STATE(7322), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3039), 2,
      sym_decltype,
      sym_template_type,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(4049), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3087), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [122405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6639), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6641), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [122461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6496), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6498), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [122517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6531), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6533), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [122573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6627), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6629), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [122629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6567), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6569), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [122685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3176), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [122741] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(7966), 1,
      sym_identifier,
    ACTIONS(7968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7974), 1,
      anon_sym_enum,
    ACTIONS(7976), 1,
      anon_sym_class,
    ACTIONS(7978), 1,
      anon_sym_struct,
    ACTIONS(7980), 1,
      anon_sym_union,
    ACTIONS(7982), 1,
      sym_auto,
    ACTIONS(7984), 1,
      anon_sym_decltype,
    ACTIONS(7986), 1,
      anon_sym_typename,
    STATE(4950), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4967), 1,
      sym__type_specifier,
    STATE(5635), 1,
      sym_primitive_type,
    STATE(5921), 1,
      sym_qualified_type_identifier,
    STATE(5957), 1,
      sym_decltype_auto,
    STATE(7328), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5890), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7972), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7970), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5956), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [122839] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6448), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6450), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [122907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5421), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5423), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [122963] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(8035), 1,
      anon_sym_LBRACK,
    ACTIONS(8041), 1,
      anon_sym_LPAREN2,
    ACTIONS(8043), 1,
      sym_auto,
    ACTIONS(8045), 1,
      anon_sym_decltype,
    STATE(4688), 1,
      sym_new_declarator,
    STATE(4774), 1,
      sym_decltype_auto,
    STATE(4652), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5809), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5811), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [123035] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5639), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [123133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5628), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [123189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6571), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6573), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [123245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3176), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [123301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6651), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6653), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [123357] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6460), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6462), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [123427] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(7997), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8001), 1,
      anon_sym_enum,
    ACTIONS(8003), 1,
      anon_sym_class,
    ACTIONS(8005), 1,
      anon_sym_struct,
    ACTIONS(8007), 1,
      anon_sym_union,
    ACTIONS(8009), 1,
      anon_sym_typename,
    STATE(3140), 1,
      sym_decltype_auto,
    STATE(3331), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(4130), 1,
      sym_primitive_type,
    STATE(4902), 1,
      sym__type_specifier,
    STATE(7322), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3039), 2,
      sym_decltype,
      sym_template_type,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(4049), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3087), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [123525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6527), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6529), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [123581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5411), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5413), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [123637] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_enum,
    ACTIONS(7931), 1,
      anon_sym_class,
    ACTIONS(7933), 1,
      anon_sym_struct,
    ACTIONS(7935), 1,
      anon_sym_union,
    ACTIONS(7937), 1,
      anon_sym_typename,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6043), 1,
      sym__type_specifier,
    STATE(6136), 1,
      sym_primitive_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [123735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6611), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6613), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [123791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5288), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5290), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [123847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6681), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6683), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [123903] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(7939), 1,
      sym_identifier,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7947), 1,
      anon_sym_enum,
    ACTIONS(7949), 1,
      anon_sym_class,
    ACTIONS(7951), 1,
      anon_sym_struct,
    ACTIONS(7953), 1,
      anon_sym_union,
    ACTIONS(7955), 1,
      sym_auto,
    ACTIONS(7957), 1,
      anon_sym_decltype,
    ACTIONS(7959), 1,
      anon_sym_typename,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(4811), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4862), 1,
      sym__type_specifier,
    STATE(5230), 1,
      sym_primitive_type,
    STATE(5753), 1,
      sym_decltype_auto,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3039), 2,
      sym_decltype,
      sym_template_type,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7945), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7943), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5793), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [124001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2265), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [124057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6535), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6537), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [124113] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4530), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8049), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5363), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5365), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [124173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6687), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6689), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [124229] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7783), 1,
      anon_sym_LT,
    STATE(2431), 1,
      sym_template_argument_list,
    ACTIONS(5835), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4272), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [124291] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6389), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6391), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [124361] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(7939), 1,
      sym_identifier,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7947), 1,
      anon_sym_enum,
    ACTIONS(7949), 1,
      anon_sym_class,
    ACTIONS(7951), 1,
      anon_sym_struct,
    ACTIONS(7953), 1,
      anon_sym_union,
    ACTIONS(7955), 1,
      sym_auto,
    ACTIONS(7957), 1,
      anon_sym_decltype,
    ACTIONS(7959), 1,
      anon_sym_typename,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(4811), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5013), 1,
      sym__type_specifier,
    STATE(5230), 1,
      sym_primitive_type,
    STATE(5753), 1,
      sym_decltype_auto,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3039), 2,
      sym_decltype,
      sym_template_type,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7945), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7943), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5793), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [124459] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6393), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6395), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [124529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6587), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6589), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [124585] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7671), 1,
      anon_sym_LBRACK,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(8052), 1,
      anon_sym_DASH_GT,
    ACTIONS(8054), 1,
      anon_sym_requires,
    STATE(5829), 1,
      sym__function_attributes_start,
    STATE(5974), 1,
      sym_ref_qualifier,
    STATE(6922), 1,
      sym__function_attributes_end,
    STATE(7146), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7677), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4948), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5428), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6945), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6213), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7661), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [124687] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7190), 1,
      anon_sym_LBRACE,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    STATE(3093), 1,
      sym_attribute_specifier,
    STATE(4621), 1,
      sym_enumerator_list,
    ACTIONS(5980), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(5982), 40,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [124751] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6410), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6412), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [124821] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7671), 1,
      anon_sym_LBRACK,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(8052), 1,
      anon_sym_DASH_GT,
    ACTIONS(8057), 1,
      anon_sym_requires,
    STATE(5828), 1,
      sym__function_attributes_start,
    STATE(6093), 1,
      sym_ref_qualifier,
    STATE(6889), 1,
      sym__function_attributes_end,
    STATE(7141), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4948), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5428), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6945), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6210), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7661), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [124923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6500), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6502), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [124979] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6444), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6446), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [125047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6663), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6665), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6603), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6605), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5417), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5419), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [125215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6492), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6494), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [125271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5284), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5286), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [125327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6655), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6657), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [125383] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2990), 1,
      anon_sym_enum,
    ACTIONS(2992), 1,
      anon_sym_class,
    ACTIONS(2994), 1,
      anon_sym_struct,
    ACTIONS(2996), 1,
      anon_sym_union,
    ACTIONS(3022), 1,
      sym_auto,
    ACTIONS(3024), 1,
      anon_sym_decltype,
    ACTIONS(3026), 1,
      anon_sym_typename,
    ACTIONS(8015), 1,
      sym_identifier,
    ACTIONS(8017), 1,
      anon_sym_COLON_COLON,
    STATE(2651), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3059), 1,
      sym_primitive_type,
    STATE(3398), 1,
      sym_decltype_auto,
    STATE(3494), 1,
      sym_qualified_type_identifier,
    STATE(5523), 1,
      sym__type_specifier,
    STATE(7325), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3383), 2,
      sym_decltype,
      sym_template_type,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2988), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2986), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3397), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [125481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6603), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6605), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [125537] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(4041), 1,
      sym_identifier,
    ACTIONS(4047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4051), 1,
      anon_sym_enum,
    ACTIONS(4053), 1,
      anon_sym_class,
    ACTIONS(4055), 1,
      anon_sym_struct,
    ACTIONS(4057), 1,
      anon_sym_union,
    ACTIONS(4059), 1,
      anon_sym_typename,
    STATE(3140), 1,
      sym_decltype_auto,
    STATE(3331), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(4130), 1,
      sym_primitive_type,
    STATE(5142), 1,
      sym__type_specifier,
    STATE(7352), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3039), 2,
      sym_decltype,
      sym_template_type,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(4049), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3087), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [125635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6496), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6498), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [125691] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8059), 1,
      anon_sym_LT,
    STATE(4623), 1,
      sym_template_argument_list,
    ACTIONS(5129), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5136), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125753] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4530), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6034), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6032), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6565), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [125869] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2990), 1,
      anon_sym_enum,
    ACTIONS(2992), 1,
      anon_sym_class,
    ACTIONS(2994), 1,
      anon_sym_struct,
    ACTIONS(2996), 1,
      anon_sym_union,
    ACTIONS(3022), 1,
      sym_auto,
    ACTIONS(3024), 1,
      anon_sym_decltype,
    ACTIONS(3026), 1,
      anon_sym_typename,
    ACTIONS(8015), 1,
      sym_identifier,
    ACTIONS(8017), 1,
      anon_sym_COLON_COLON,
    STATE(2651), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3059), 1,
      sym_primitive_type,
    STATE(3398), 1,
      sym_decltype_auto,
    STATE(3494), 1,
      sym_qualified_type_identifier,
    STATE(5667), 1,
      sym__type_specifier,
    STATE(7325), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3383), 2,
      sym_decltype,
      sym_template_type,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2988), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2986), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3397), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [125967] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4530), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6020), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6018), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5439), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5441), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [126083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6523), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6525), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [126139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6488), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6490), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [126195] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6631), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6633), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [126251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4037), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4033), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [126307] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4580), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8064), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6109), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6107), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5304), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5306), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [126423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6539), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6541), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [126479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6659), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6661), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [126535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5316), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5318), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [126591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6663), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6665), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [126647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5314), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [126703] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4582), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8066), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6136), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6134), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5328), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5330), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [126819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5314), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [126875] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(5723), 1,
      sym__type_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [126973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2223), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2221), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [127029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6364), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127085] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8039), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6065), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6067), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [127143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5417), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5419), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [127199] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5180), 1,
      anon_sym_SEMI,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(7216), 1,
      anon_sym_LBRACK,
    STATE(3184), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4711), 1,
      sym_template_argument_list,
    ACTIONS(4269), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4254), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(4274), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4246), 33,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [127271] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8013), 1,
      anon_sym_LT,
    STATE(4623), 1,
      sym_template_argument_list,
    ACTIONS(5835), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4272), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127333] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4530), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6105), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6103), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5308), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5310), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [127449] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4530), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6092), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6090), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5332), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5334), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [127565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6591), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6593), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [127621] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(7939), 1,
      sym_identifier,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7947), 1,
      anon_sym_enum,
    ACTIONS(7949), 1,
      anon_sym_class,
    ACTIONS(7951), 1,
      anon_sym_struct,
    ACTIONS(7953), 1,
      anon_sym_union,
    ACTIONS(7955), 1,
      sym_auto,
    ACTIONS(7957), 1,
      anon_sym_decltype,
    ACTIONS(7959), 1,
      anon_sym_typename,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(4811), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4926), 1,
      sym__type_specifier,
    STATE(5230), 1,
      sym_primitive_type,
    STATE(5753), 1,
      sym_decltype_auto,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3039), 2,
      sym_decltype,
      sym_template_type,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7945), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7943), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5793), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [127719] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4557), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8068), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5724), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5726), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6595), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6597), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [127835] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(8035), 1,
      anon_sym_LBRACK,
    ACTIONS(8041), 1,
      anon_sym_LPAREN2,
    ACTIONS(8043), 1,
      sym_auto,
    ACTIONS(8045), 1,
      anon_sym_decltype,
    STATE(4686), 1,
      sym_new_declarator,
    STATE(4774), 1,
      sym_decltype_auto,
    STATE(4618), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5854), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5856), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6599), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6601), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [127963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5324), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5326), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [128019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5439), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5441), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [128075] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8070), 1,
      anon_sym_LT,
    STATE(2431), 1,
      sym_template_argument_list,
    ACTIONS(5129), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5136), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [128137] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5495), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5497), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [128194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5150), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5152), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [128249] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8075), 1,
      anon_sym_STAR,
    ACTIONS(8077), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8079), 1,
      anon_sym_AMP,
    ACTIONS(8081), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    STATE(4132), 1,
      sym_parameter_list,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6816), 1,
      sym__abstract_declarator,
    ACTIONS(8083), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8085), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4294), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5040), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6235), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [128336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6539), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6541), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [128391] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    STATE(3080), 1,
      sym_attribute_specifier,
    ACTIONS(6082), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6084), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [128450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6651), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6653), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [128505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6655), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6657), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [128560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5411), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5413), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [128615] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    STATE(3098), 1,
      sym_attribute_specifier,
    ACTIONS(6113), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6115), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [128674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6587), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6589), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [128729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6639), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6641), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [128784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6571), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6573), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [128839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6523), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6525), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [128894] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    STATE(3074), 1,
      sym_attribute_specifier,
    ACTIONS(6024), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6026), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [128953] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7704), 1,
      anon_sym___attribute__,
    ACTIONS(7988), 1,
      anon_sym_LBRACE,
    STATE(4681), 1,
      sym_enumerator_list,
    STATE(4768), 1,
      sym_attribute_specifier,
    ACTIONS(5952), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5954), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [129016] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    STATE(3075), 1,
      sym_attribute_specifier,
    ACTIONS(6117), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6119), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [129075] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    STATE(3076), 1,
      sym_attribute_specifier,
    ACTIONS(6028), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6030), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [129134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4037), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4033), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [129189] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    STATE(3092), 1,
      sym_attribute_specifier,
    ACTIONS(6049), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6051), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [129248] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7889), 1,
      anon_sym___attribute__,
    ACTIONS(8089), 1,
      anon_sym_LBRACE,
    ACTIONS(8091), 1,
      anon_sym_COLON,
    STATE(4720), 1,
      sym__enum_base_clause,
    STATE(4741), 1,
      sym_enumerator_list,
    STATE(4856), 1,
      sym_attribute_specifier,
    ACTIONS(6280), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6282), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [129315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6567), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6569), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [129370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8095), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8093), 43,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_typename,
      anon_sym_template,
  [129425] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8075), 1,
      anon_sym_STAR,
    ACTIONS(8077), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8079), 1,
      anon_sym_AMP,
    ACTIONS(8081), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    STATE(4132), 1,
      sym_parameter_list,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6820), 1,
      sym__abstract_declarator,
    ACTIONS(8083), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8085), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4595), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5194), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6223), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [129512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6579), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6581), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [129567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5417), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5419), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [129622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6695), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6697), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [129677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5653), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5655), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [129732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6575), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6577), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [129787] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    STATE(3117), 1,
      sym_attribute_specifier,
    ACTIONS(6094), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6096), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [129846] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(3005), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5194), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5958), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5960), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [129909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5160), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5167), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [129964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6527), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6529), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [130019] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5626), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5628), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [130076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6703), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6705), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [130131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6659), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6661), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [130186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5421), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5423), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [130241] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    STATE(3094), 1,
      sym_attribute_specifier,
    ACTIONS(6061), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6063), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [130300] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6631), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6633), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [130355] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    STATE(3136), 1,
      sym_attribute_specifier,
    ACTIONS(6144), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6146), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [130414] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    STATE(3129), 1,
      sym_attribute_specifier,
    ACTIONS(6053), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6055), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [130473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6591), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6593), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [130528] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_LBRACK,
    ACTIONS(5164), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5167), 5,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
    ACTIONS(5160), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [130587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5606), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5608), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [130642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5146), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5148), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [130697] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8081), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8097), 1,
      anon_sym_STAR,
    ACTIONS(8099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8101), 1,
      anon_sym_AMP,
    STATE(4341), 1,
      sym_parameter_list,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6871), 1,
      sym__abstract_declarator,
    ACTIONS(8083), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8085), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4665), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5143), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6223), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [130784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6595), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6597), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [130839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5115), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [130894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6599), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6601), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [130949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6531), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6533), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [131004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6691), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6693), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [131059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6535), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6537), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [131114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5125), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5127), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [131169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8105), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(8103), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [131224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8109), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(8107), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [131279] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5497), 1,
      anon_sym_SEMI,
    ACTIONS(5483), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5481), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [131336] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    STATE(3077), 1,
      sym_attribute_specifier,
    ACTIONS(6121), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6123), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [131395] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7704), 1,
      anon_sym___attribute__,
    ACTIONS(7988), 1,
      anon_sym_LBRACE,
    STATE(4701), 1,
      sym_enumerator_list,
    STATE(4794), 1,
      sym_attribute_specifier,
    ACTIONS(5980), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5982), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [131458] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5626), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5628), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [131515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6627), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6629), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [131570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6500), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6502), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [131625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6699), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6701), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [131680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5117), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5119), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [131735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5123), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [131790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5439), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5441), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [131845] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8081), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8111), 1,
      anon_sym_STAR,
    ACTIONS(8113), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8115), 1,
      anon_sym_AMP,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6835), 1,
      sym__abstract_declarator,
    ACTIONS(8083), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8085), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4661), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5085), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6223), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [131932] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym___attribute__,
    ACTIONS(6464), 1,
      anon_sym_LBRACE,
    ACTIONS(8117), 1,
      anon_sym_COLON,
    STATE(2284), 1,
      sym_attribute_specifier,
    STATE(2901), 1,
      sym__enum_base_clause,
    STATE(3021), 1,
      sym_enumerator_list,
    ACTIONS(6334), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6336), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [131999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6543), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6545), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [132054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6488), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6490), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [132109] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8081), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8111), 1,
      anon_sym_STAR,
    ACTIONS(8113), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8115), 1,
      anon_sym_AMP,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6829), 1,
      sym__abstract_declarator,
    ACTIONS(8083), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8085), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4294), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5075), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6235), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [132196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6681), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6683), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [132251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5111), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [132306] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5497), 1,
      anon_sym_SEMI,
    ACTIONS(5483), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5481), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [132365] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8081), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8097), 1,
      anon_sym_STAR,
    ACTIONS(8099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8101), 1,
      anon_sym_AMP,
    STATE(4341), 1,
      sym_parameter_list,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6883), 1,
      sym__abstract_declarator,
    ACTIONS(8083), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8085), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4294), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5120), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6235), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [132452] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym___attribute__,
    ACTIONS(6464), 1,
      anon_sym_LBRACE,
    ACTIONS(8117), 1,
      anon_sym_COLON,
    STATE(2254), 1,
      sym_attribute_specifier,
    STATE(2895), 1,
      sym__enum_base_clause,
    STATE(2970), 1,
      sym_enumerator_list,
    ACTIONS(6280), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6282), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [132519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6583), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6585), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [132574] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4557), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8068), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5481), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5483), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [132633] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7889), 1,
      anon_sym___attribute__,
    ACTIONS(8089), 1,
      anon_sym_LBRACE,
    ACTIONS(8091), 1,
      anon_sym_COLON,
    STATE(4714), 1,
      sym__enum_base_clause,
    STATE(4776), 1,
      sym_enumerator_list,
    STATE(4906), 1,
      sym_attribute_specifier,
    ACTIONS(6334), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6336), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [132700] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    STATE(3123), 1,
      sym_attribute_specifier,
    ACTIONS(6057), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6059), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [132759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6492), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6494), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [132814] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(8041), 1,
      anon_sym_LPAREN2,
    STATE(4603), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6189), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6191), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [132874] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(8035), 1,
      anon_sym_LBRACK,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(8121), 1,
      sym_auto,
    ACTIONS(8123), 1,
      anon_sym_decltype,
    STATE(2285), 1,
      sym_decltype_auto,
    STATE(4910), 1,
      sym_new_declarator,
    STATE(4652), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5809), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5811), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [132944] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3729), 1,
      anon_sym_LBRACE,
    ACTIONS(8125), 1,
      anon_sym_LPAREN2,
    ACTIONS(8127), 1,
      anon_sym_LBRACK,
    ACTIONS(8129), 1,
      sym_auto,
    ACTIONS(8131), 1,
      anon_sym_decltype,
    STATE(4875), 1,
      sym_new_declarator,
    STATE(4890), 1,
      sym_decltype_auto,
    STATE(5203), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5854), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5856), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [133014] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7704), 1,
      anon_sym___attribute__,
    STATE(4802), 1,
      sym_attribute_specifier,
    ACTIONS(6057), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6059), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [133072] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7704), 1,
      anon_sym___attribute__,
    STATE(4735), 1,
      sym_attribute_specifier,
    ACTIONS(6024), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6026), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [133130] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7704), 1,
      anon_sym___attribute__,
    STATE(4734), 1,
      sym_attribute_specifier,
    ACTIONS(6028), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6030), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [133188] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3729), 1,
      anon_sym_LBRACE,
    ACTIONS(8125), 1,
      anon_sym_LPAREN2,
    ACTIONS(8127), 1,
      anon_sym_LBRACK,
    ACTIONS(8129), 1,
      sym_auto,
    ACTIONS(8131), 1,
      anon_sym_decltype,
    STATE(4877), 1,
      sym_new_declarator,
    STATE(4890), 1,
      sym_decltype_auto,
    STATE(5204), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5809), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5811), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [133258] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7704), 1,
      anon_sym___attribute__,
    STATE(4785), 1,
      sym_attribute_specifier,
    ACTIONS(6053), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6055), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [133316] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(3399), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8133), 1,
      anon_sym_STAR,
    ACTIONS(8135), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8137), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    STATE(3938), 1,
      sym_parameter_list,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6959), 1,
      sym__abstract_declarator,
    STATE(6967), 1,
      sym__function_declarator_seq,
    ACTIONS(8141), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8143), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4692), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5355), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6223), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [133402] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7704), 1,
      anon_sym___attribute__,
    STATE(4731), 1,
      sym_attribute_specifier,
    ACTIONS(6049), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6051), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [133460] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    STATE(3184), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5147), 1,
      sym_template_argument_list,
    ACTIONS(4269), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4254), 3,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
    ACTIONS(4274), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4246), 32,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_operator,
  [133528] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8149), 1,
      anon_sym_LT,
    STATE(3005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3195), 1,
      sym_template_argument_list,
    ACTIONS(5194), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4246), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4254), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [133592] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7704), 1,
      anon_sym___attribute__,
    STATE(4756), 1,
      sym_attribute_specifier,
    ACTIONS(6061), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6063), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [133650] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5140), 1,
      anon_sym_LBRACK,
    ACTIONS(7733), 1,
      anon_sym_LT,
    STATE(4711), 1,
      sym_template_argument_list,
    ACTIONS(5133), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5136), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_EQ,
    ACTIONS(5129), 33,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [133714] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(8041), 1,
      anon_sym_LPAREN2,
    STATE(4667), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6178), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6180), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [133774] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7671), 1,
      anon_sym_LBRACK,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8151), 1,
      anon_sym_DASH_GT,
    ACTIONS(8153), 1,
      anon_sym_requires,
    STATE(5953), 1,
      sym__function_attributes_start,
    STATE(6137), 1,
      sym_ref_qualifier,
    STATE(7098), 1,
      sym__function_attributes_end,
    STATE(7210), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7661), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5094), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5642), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6727), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6292), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [133874] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(8041), 1,
      anon_sym_LPAREN2,
    STATE(4653), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6185), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6187), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [133934] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(8035), 1,
      anon_sym_LBRACK,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(8121), 1,
      sym_auto,
    ACTIONS(8123), 1,
      anon_sym_decltype,
    STATE(2285), 1,
      sym_decltype_auto,
    STATE(4930), 1,
      sym_new_declarator,
    STATE(4642), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5831), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5833), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [134004] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(8041), 1,
      anon_sym_LPAREN2,
    STATE(4630), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6152), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6154), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [134064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5628), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [134118] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(3399), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8133), 1,
      anon_sym_STAR,
    ACTIONS(8135), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8137), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    STATE(3938), 1,
      sym_parameter_list,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6942), 1,
      sym__abstract_declarator,
    STATE(6967), 1,
      sym__function_declarator_seq,
    ACTIONS(8141), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8143), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5358), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6235), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [134204] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7704), 1,
      anon_sym___attribute__,
    STATE(4783), 1,
      sym_attribute_specifier,
    ACTIONS(6082), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6084), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [134262] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3729), 1,
      anon_sym_LBRACE,
    ACTIONS(8125), 1,
      anon_sym_LPAREN2,
    ACTIONS(8127), 1,
      anon_sym_LBRACK,
    ACTIONS(8129), 1,
      sym_auto,
    ACTIONS(8131), 1,
      anon_sym_decltype,
    STATE(4890), 1,
      sym_decltype_auto,
    STATE(4936), 1,
      sym_new_declarator,
    STATE(5168), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5847), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5849), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [134332] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7671), 1,
      anon_sym_LBRACK,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8151), 1,
      anon_sym_DASH_GT,
    ACTIONS(8155), 1,
      anon_sym_requires,
    STATE(5916), 1,
      sym__function_attributes_start,
    STATE(6152), 1,
      sym_ref_qualifier,
    STATE(7094), 1,
      sym__function_attributes_end,
    STATE(7202), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7661), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7777), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5094), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5642), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6727), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6271), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [134432] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7671), 1,
      anon_sym_LBRACK,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8011), 1,
      anon_sym_requires,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8160), 1,
      anon_sym_DASH_GT,
    STATE(5898), 1,
      sym__function_attributes_start,
    STATE(6143), 1,
      sym_ref_qualifier,
    STATE(6946), 1,
      sym_trailing_return_type,
    STATE(7155), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7661), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5094), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5642), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6945), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6231), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [134532] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7704), 1,
      anon_sym___attribute__,
    STATE(4786), 1,
      sym_attribute_specifier,
    ACTIONS(6113), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6115), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [134590] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7704), 1,
      anon_sym___attribute__,
    STATE(4796), 1,
      sym_attribute_specifier,
    ACTIONS(6117), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6119), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [134648] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7704), 1,
      anon_sym___attribute__,
    STATE(4795), 1,
      sym_attribute_specifier,
    ACTIONS(6121), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6123), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [134706] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(8035), 1,
      anon_sym_LBRACK,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(8121), 1,
      sym_auto,
    ACTIONS(8123), 1,
      anon_sym_decltype,
    STATE(2285), 1,
      sym_decltype_auto,
    STATE(4859), 1,
      sym_new_declarator,
    STATE(4618), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5854), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5856), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [134776] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7704), 1,
      anon_sym___attribute__,
    STATE(4761), 1,
      sym_attribute_specifier,
    ACTIONS(6094), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6096), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [134834] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3729), 1,
      anon_sym_LBRACE,
    ACTIONS(8125), 1,
      anon_sym_LPAREN2,
    ACTIONS(8127), 1,
      anon_sym_LBRACK,
    ACTIONS(8129), 1,
      sym_auto,
    ACTIONS(8131), 1,
      anon_sym_decltype,
    STATE(4890), 1,
      sym_decltype_auto,
    STATE(4891), 1,
      sym_new_declarator,
    STATE(5138), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5831), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5833), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [134904] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7704), 1,
      anon_sym___attribute__,
    STATE(4763), 1,
      sym_attribute_specifier,
    ACTIONS(6144), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6146), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [134962] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(8035), 1,
      anon_sym_LBRACK,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(8121), 1,
      sym_auto,
    ACTIONS(8123), 1,
      anon_sym_decltype,
    STATE(2285), 1,
      sym_decltype_auto,
    STATE(4861), 1,
      sym_new_declarator,
    STATE(4602), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5847), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5849), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [135032] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7671), 1,
      anon_sym_LBRACK,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7994), 1,
      anon_sym_requires,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8160), 1,
      anon_sym_DASH_GT,
    STATE(5924), 1,
      sym__function_attributes_start,
    STATE(6149), 1,
      sym_ref_qualifier,
    STATE(6991), 1,
      sym_trailing_return_type,
    STATE(7145), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7661), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7677), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5094), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5642), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6945), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6225), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [135132] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8081), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8162), 1,
      anon_sym_STAR,
    ACTIONS(8164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8166), 1,
      anon_sym_AMP,
    STATE(4342), 1,
      sym_parameter_list,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7056), 1,
      sym__abstract_declarator,
    ACTIONS(8083), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8085), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4294), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5500), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6235), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [135217] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8168), 1,
      anon_sym_LT,
    STATE(3195), 1,
      sym_template_argument_list,
    ACTIONS(5129), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5136), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [135276] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7190), 1,
      anon_sym_LBRACE,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8171), 1,
      anon_sym_COLON,
    STATE(3128), 1,
      sym_attribute_specifier,
    STATE(4488), 1,
      sym__enum_base_clause,
    STATE(4601), 1,
      sym_enumerator_list,
    ACTIONS(6280), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6282), 35,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_try,
      anon_sym_requires,
  [135341] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8043), 1,
      sym_auto,
    ACTIONS(8045), 1,
      anon_sym_decltype,
    STATE(4774), 1,
      sym_decltype_auto,
    ACTIONS(5499), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5501), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [135400] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8081), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8173), 1,
      anon_sym_STAR,
    ACTIONS(8175), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8177), 1,
      anon_sym_AMP,
    STATE(4321), 1,
      sym_parameter_list,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7078), 1,
      sym__abstract_declarator,
    ACTIONS(8083), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8085), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4294), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5507), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6235), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [135485] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5162), 1,
      anon_sym_SEMI,
    ACTIONS(5171), 1,
      anon_sym_LBRACK,
    ACTIONS(5164), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5167), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
    ACTIONS(5160), 33,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [135544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5465), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5467), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [135597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5675), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5677), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [135650] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7889), 1,
      anon_sym___attribute__,
    ACTIONS(8089), 1,
      anon_sym_LBRACE,
    STATE(4773), 1,
      sym_enumerator_list,
    STATE(4881), 1,
      sym_attribute_specifier,
    ACTIONS(5980), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5982), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [135711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5657), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5659), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [135764] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8179), 1,
      anon_sym_typedef,
    ACTIONS(3322), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3320), 42,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_typename,
      anon_sym_template,
  [135819] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8081), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8162), 1,
      anon_sym_STAR,
    ACTIONS(8164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8166), 1,
      anon_sym_AMP,
    STATE(4342), 1,
      sym_parameter_list,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7052), 1,
      sym__abstract_declarator,
    ACTIONS(8083), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8085), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4706), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5511), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6223), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [135904] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    STATE(3122), 1,
      sym_attribute_specifier,
    STATE(3748), 1,
      sym_field_declaration_list,
    STATE(7912), 1,
      sym_virtual_specifier,
    STATE(8737), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5471), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5469), 31,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_operator,
  [135973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5747), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5749), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [136026] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7889), 1,
      anon_sym___attribute__,
    ACTIONS(8089), 1,
      anon_sym_LBRACE,
    STATE(4767), 1,
      sym_enumerator_list,
    STATE(4913), 1,
      sym_attribute_specifier,
    ACTIONS(5952), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5954), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [136087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5634), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5636), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [136140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5710), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [136193] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7190), 1,
      anon_sym_LBRACE,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8171), 1,
      anon_sym_COLON,
    STATE(3072), 1,
      sym_attribute_specifier,
    STATE(4538), 1,
      sym__enum_base_clause,
    STATE(4629), 1,
      sym_enumerator_list,
    ACTIONS(6334), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6336), 35,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_try,
      anon_sym_requires,
  [136258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5481), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5483), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [136313] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8149), 1,
      anon_sym_LT,
    STATE(3195), 1,
      sym_template_argument_list,
    ACTIONS(5835), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4272), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [136372] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8081), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8173), 1,
      anon_sym_STAR,
    ACTIONS(8175), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8177), 1,
      anon_sym_AMP,
    STATE(4321), 1,
      sym_parameter_list,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7087), 1,
      sym__abstract_declarator,
    ACTIONS(8083), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8085), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4710), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5447), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6223), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [136457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5724), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5726), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [136510] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8181), 1,
      anon_sym_typedef,
    ACTIONS(3322), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3320), 42,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_typename,
      anon_sym_template,
  [136565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3136), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3134), 42,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_typename,
      anon_sym_template,
  [136617] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8081), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8183), 1,
      anon_sym_STAR,
    ACTIONS(8185), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8187), 1,
      anon_sym_AMP,
    STATE(4378), 1,
      sym_parameter_list,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7176), 1,
      sym__abstract_declarator,
    ACTIONS(8083), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8085), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4806), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5616), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6223), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [136701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5771), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5773), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [136753] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6976), 1,
      sym__declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [136839] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(8035), 1,
      anon_sym_LBRACK,
    ACTIONS(8041), 1,
      anon_sym_LPAREN2,
    ACTIONS(8121), 1,
      sym_auto,
    ACTIONS(8123), 1,
      anon_sym_decltype,
    STATE(2285), 1,
      sym_decltype_auto,
    STATE(4688), 1,
      sym_new_declarator,
    STATE(4652), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5809), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5811), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [136907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5789), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5791), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [136959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5787), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [137011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5781), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5783), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [137063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3164), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3162), 42,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_typename,
      anon_sym_template,
  [137115] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7609), 1,
      anon_sym_STAR,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7613), 1,
      anon_sym_AMP,
    ACTIONS(7615), 1,
      anon_sym_COLON_COLON,
    STATE(6577), 1,
      sym__scope_resolution,
    STATE(6925), 1,
      sym__declarator,
    STATE(8852), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [137201] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7889), 1,
      anon_sym___attribute__,
    STATE(4921), 1,
      sym_attribute_specifier,
    ACTIONS(6121), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6123), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [137257] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7889), 1,
      anon_sym___attribute__,
    STATE(4919), 1,
      sym_attribute_specifier,
    ACTIONS(6117), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6119), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [137313] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7889), 1,
      anon_sym___attribute__,
    STATE(4912), 1,
      sym_attribute_specifier,
    ACTIONS(6113), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6115), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [137369] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7609), 1,
      anon_sym_STAR,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7613), 1,
      anon_sym_AMP,
    ACTIONS(7615), 1,
      anon_sym_COLON_COLON,
    STATE(6577), 1,
      sym__scope_resolution,
    STATE(6901), 1,
      sym__declarator,
    STATE(8852), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [137455] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7889), 1,
      anon_sym___attribute__,
    STATE(4885), 1,
      sym_attribute_specifier,
    ACTIONS(6082), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6084), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [137511] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7237), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [137597] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(3218), 1,
      anon_sym_STAR,
    ACTIONS(3220), 1,
      anon_sym_AMP,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(6516), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    STATE(6657), 1,
      sym__scope_resolution,
    STATE(7270), 1,
      sym__declarator,
    STATE(9597), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [137683] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7519), 1,
      anon_sym_STAR,
    ACTIONS(7521), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7523), 1,
      anon_sym_AMP,
    ACTIONS(7525), 1,
      anon_sym_COLON_COLON,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(7406), 1,
      sym__declarator,
    STATE(8999), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [137769] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7889), 1,
      anon_sym___attribute__,
    STATE(4864), 1,
      sym_attribute_specifier,
    ACTIONS(6024), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6026), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [137825] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7621), 1,
      anon_sym_STAR,
    ACTIONS(7623), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7625), 1,
      anon_sym_AMP,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(7191), 1,
      sym__declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [137911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3501), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3499), 42,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_typename,
      anon_sym_template,
  [137963] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(3218), 1,
      anon_sym_STAR,
    ACTIONS(3220), 1,
      anon_sym_AMP,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(6516), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    STATE(6657), 1,
      sym__scope_resolution,
    STATE(7237), 1,
      sym__declarator,
    STATE(9597), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [138049] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7621), 1,
      anon_sym_STAR,
    ACTIONS(7623), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7625), 1,
      anon_sym_AMP,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(7126), 1,
      sym__declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [138135] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7621), 1,
      anon_sym_STAR,
    ACTIONS(7623), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7625), 1,
      anon_sym_AMP,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(7178), 1,
      sym__declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [138221] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6932), 1,
      sym__declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [138307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5661), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5663), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [138359] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7889), 1,
      anon_sym___attribute__,
    STATE(4867), 1,
      sym_attribute_specifier,
    ACTIONS(6028), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6030), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [138415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5755), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5757), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [138467] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7519), 1,
      anon_sym_STAR,
    ACTIONS(7521), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7523), 1,
      anon_sym_AMP,
    ACTIONS(7525), 1,
      anon_sym_COLON_COLON,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(7384), 1,
      sym__declarator,
    STATE(8999), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [138553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5481), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5483), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [138605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2907), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2902), 42,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_typename,
      anon_sym_template,
  [138657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5716), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5718), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [138709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5751), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5753), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [138761] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7889), 1,
      anon_sym___attribute__,
    STATE(4888), 1,
      sym_attribute_specifier,
    ACTIONS(6144), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6146), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [138817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5763), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5765), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [138869] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(3218), 1,
      anon_sym_STAR,
    ACTIONS(3220), 1,
      anon_sym_AMP,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(6516), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    STATE(6657), 1,
      sym__scope_resolution,
    STATE(7272), 1,
      sym__declarator,
    STATE(9597), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [138955] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym___attribute__,
    ACTIONS(6851), 1,
      anon_sym_LBRACE,
    ACTIONS(8189), 1,
      anon_sym_COLON,
    STATE(3192), 1,
      sym__enum_base_clause,
    STATE(3234), 1,
      sym_enumerator_list,
    STATE(3412), 1,
      sym_attribute_specifier,
    ACTIONS(6280), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6282), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [139019] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym___attribute__,
    ACTIONS(6851), 1,
      anon_sym_LBRACE,
    ACTIONS(8189), 1,
      anon_sym_COLON,
    STATE(3201), 1,
      sym__enum_base_clause,
    STATE(3267), 1,
      sym_enumerator_list,
    STATE(3429), 1,
      sym_attribute_specifier,
    ACTIONS(6334), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6336), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [139083] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7889), 1,
      anon_sym___attribute__,
    STATE(4879), 1,
      sym_attribute_specifier,
    ACTIONS(6049), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6051), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [139139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5712), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5714), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [139191] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(8035), 1,
      anon_sym_LBRACK,
    ACTIONS(8041), 1,
      anon_sym_LPAREN2,
    ACTIONS(8121), 1,
      sym_auto,
    ACTIONS(8123), 1,
      anon_sym_decltype,
    STATE(2285), 1,
      sym_decltype_auto,
    STATE(4672), 1,
      sym_new_declarator,
    STATE(4602), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5847), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5849), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [139259] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(8194), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(8191), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7904), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(7902), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [139319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5686), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [139371] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7272), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [139457] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7889), 1,
      anon_sym___attribute__,
    STATE(4868), 1,
      sym_attribute_specifier,
    ACTIONS(6094), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6096), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [139513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5742), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [139565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3130), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3128), 42,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_typename,
      anon_sym_template,
  [139617] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7889), 1,
      anon_sym___attribute__,
    STATE(4882), 1,
      sym_attribute_specifier,
    ACTIONS(6061), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6063), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [139673] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym___inline,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8199), 1,
      anon_sym___declspec,
    ACTIONS(8201), 1,
      sym_auto,
    ACTIONS(8203), 1,
      anon_sym_decltype,
    ACTIONS(8205), 1,
      anon_sym_virtual,
    ACTIONS(8207), 1,
      anon_sym_alignas,
    STATE(3115), 1,
      sym_decltype_auto,
    ACTIONS(6452), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(6454), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(8197), 8,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(4956), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [139751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3146), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3144), 42,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_typename,
      anon_sym_template,
  [139803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5632), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [139855] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym___inline,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8199), 1,
      anon_sym___declspec,
    ACTIONS(8201), 1,
      sym_auto,
    ACTIONS(8203), 1,
      anon_sym_decltype,
    ACTIONS(8205), 1,
      anon_sym_virtual,
    ACTIONS(8207), 1,
      anon_sym_alignas,
    STATE(3115), 1,
      sym_decltype_auto,
    ACTIONS(6430), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(6432), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(8197), 8,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(4947), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [139933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5704), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5706), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [139985] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7609), 1,
      anon_sym_STAR,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7613), 1,
      anon_sym_AMP,
    ACTIONS(7615), 1,
      anon_sym_COLON_COLON,
    STATE(6577), 1,
      sym__scope_resolution,
    STATE(6929), 1,
      sym__declarator,
    STATE(8852), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [140071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5777), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5779), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [140123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5738), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [140175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5669), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5671), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [140227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5722), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [140279] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(8035), 1,
      anon_sym_LBRACK,
    ACTIONS(8041), 1,
      anon_sym_LPAREN2,
    ACTIONS(8121), 1,
      sym_auto,
    ACTIONS(8123), 1,
      anon_sym_decltype,
    STATE(2285), 1,
      sym_decltype_auto,
    STATE(4686), 1,
      sym_new_declarator,
    STATE(4618), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5854), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5856), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [140347] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7519), 1,
      anon_sym_STAR,
    ACTIONS(7521), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7523), 1,
      anon_sym_AMP,
    ACTIONS(7525), 1,
      anon_sym_COLON_COLON,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(7409), 1,
      sym__declarator,
    STATE(8999), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [140433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3521), 42,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_typename,
      anon_sym_template,
  [140485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5640), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [140537] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6993), 1,
      sym__declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [140623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5690), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [140675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5665), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5667), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [140727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5793), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5795), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [140779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5694), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [140831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5696), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5698), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [140883] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7270), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [140969] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7889), 1,
      anon_sym___attribute__,
    STATE(4884), 1,
      sym_attribute_specifier,
    ACTIONS(6053), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6055), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [141025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5690), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [141077] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7889), 1,
      anon_sym___attribute__,
    STATE(4854), 1,
      sym_attribute_specifier,
    ACTIONS(6057), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6059), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [141133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5640), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [141185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5648), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [141237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5642), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5644), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [141289] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(8035), 1,
      anon_sym_LBRACK,
    ACTIONS(8041), 1,
      anon_sym_LPAREN2,
    ACTIONS(8121), 1,
      sym_auto,
    ACTIONS(8123), 1,
      anon_sym_decltype,
    STATE(2285), 1,
      sym_decltype_auto,
    STATE(4690), 1,
      sym_new_declarator,
    STATE(4642), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5831), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5833), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [141357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5640), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [141409] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8081), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8183), 1,
      anon_sym_STAR,
    ACTIONS(8185), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8187), 1,
      anon_sym_AMP,
    STATE(4378), 1,
      sym_parameter_list,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7197), 1,
      sym__abstract_declarator,
    ACTIONS(8083), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8085), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4294), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5564), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6235), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [141493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5702), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [141545] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(4296), 1,
      anon_sym_LPAREN2,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6233), 1,
      anon_sym_LBRACK,
    ACTIONS(6348), 1,
      anon_sym_STAR,
    ACTIONS(8209), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8215), 1,
      anon_sym_AMP,
    ACTIONS(8217), 1,
      anon_sym_EQ,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7287), 1,
      sym__declarator,
    STATE(7532), 1,
      sym__abstract_declarator,
    STATE(7560), 1,
      sym_abstract_reference_declarator,
    STATE(8072), 1,
      sym_variadic_reference_declarator,
    STATE(8076), 1,
      sym_variadic_declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    ACTIONS(8211), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [141646] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8129), 1,
      sym_auto,
    ACTIONS(8131), 1,
      anon_sym_decltype,
    STATE(4890), 1,
      sym_decltype_auto,
    ACTIONS(5499), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5501), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [141703] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 1,
      anon_sym_LBRACE,
    ACTIONS(6983), 1,
      sym_auto,
    ACTIONS(6985), 1,
      anon_sym_decltype,
    ACTIONS(8219), 1,
      anon_sym_LPAREN2,
    ACTIONS(8221), 1,
      anon_sym_LBRACK,
    STATE(3402), 1,
      sym_decltype_auto,
    STATE(5061), 1,
      sym_new_declarator,
    STATE(5607), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5831), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5833), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [141770] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8223), 1,
      sym_identifier,
    STATE(4874), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5248), 1,
      sym_primitive_type,
    ACTIONS(7945), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8225), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5489), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(5491), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [141831] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5131), 1,
      anon_sym_SEMI,
    ACTIONS(5140), 1,
      anon_sym_LBRACK,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(4711), 1,
      sym_template_argument_list,
    ACTIONS(5133), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5136), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5129), 33,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [141894] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8231), 1,
      anon_sym_SLASH,
    ACTIONS(8233), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8237), 1,
      anon_sym_CARET,
    ACTIONS(8245), 1,
      anon_sym_GT_EQ,
    ACTIONS(8249), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8251), 1,
      anon_sym_and,
    ACTIONS(8253), 1,
      anon_sym_xor,
    ACTIONS(8255), 1,
      anon_sym_not_eq,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8227), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8229), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8235), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8239), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8241), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8247), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6410), 3,
      aux_sym_preproc_elif_token1,
      anon_sym_or,
      sym_identifier,
    ACTIONS(8243), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
  [141989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6611), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6613), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [142040] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(4296), 1,
      anon_sym_LPAREN2,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6233), 1,
      anon_sym_LBRACK,
    ACTIONS(6438), 1,
      anon_sym_STAR,
    ACTIONS(8209), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8215), 1,
      anon_sym_AMP,
    ACTIONS(8257), 1,
      anon_sym_EQ,
    STATE(4540), 1,
      sym_parameter_list,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7304), 1,
      sym__declarator,
    STATE(7523), 1,
      sym__abstract_declarator,
    STATE(7589), 1,
      sym_abstract_reference_declarator,
    STATE(8072), 1,
      sym_variadic_reference_declarator,
    STATE(8076), 1,
      sym_variadic_declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    ACTIONS(8211), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [142141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5634), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5636), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [142192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6565), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [142243] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8231), 1,
      anon_sym_SLASH,
    ACTIONS(8245), 1,
      anon_sym_GT_EQ,
    ACTIONS(8249), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8255), 1,
      anon_sym_not_eq,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8227), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8229), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8239), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8241), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8247), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8243), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 7,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      sym_identifier,
    ACTIONS(6412), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
  [142328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5747), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5749), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [142379] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 1,
      anon_sym_LBRACE,
    ACTIONS(6983), 1,
      sym_auto,
    ACTIONS(6985), 1,
      anon_sym_decltype,
    ACTIONS(8219), 1,
      anon_sym_LPAREN2,
    ACTIONS(8221), 1,
      anon_sym_LBRACK,
    STATE(3402), 1,
      sym_decltype_auto,
    STATE(5202), 1,
      sym_new_declarator,
    STATE(5534), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5847), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5849), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [142446] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 1,
      anon_sym_LBRACE,
    ACTIONS(6983), 1,
      sym_auto,
    ACTIONS(6985), 1,
      anon_sym_decltype,
    ACTIONS(8219), 1,
      anon_sym_LPAREN2,
    ACTIONS(8221), 1,
      anon_sym_LBRACK,
    STATE(3402), 1,
      sym_decltype_auto,
    STATE(5064), 1,
      sym_new_declarator,
    STATE(5557), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5854), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5856), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [142513] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8231), 1,
      anon_sym_SLASH,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8227), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8229), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6410), 13,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6412), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [142584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5465), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5467), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [142635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5724), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5726), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [142686] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8231), 1,
      anon_sym_SLASH,
    ACTIONS(8249), 1,
      anon_sym_LT_EQ_GT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8227), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8229), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8247), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6410), 13,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6412), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
  [142761] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5481), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5483), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [142814] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8231), 1,
      anon_sym_SLASH,
    ACTIONS(8233), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8237), 1,
      anon_sym_CARET,
    ACTIONS(8245), 1,
      anon_sym_GT_EQ,
    ACTIONS(8249), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8251), 1,
      anon_sym_and,
    ACTIONS(8253), 1,
      anon_sym_xor,
    ACTIONS(8255), 1,
      anon_sym_not_eq,
    ACTIONS(8259), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8261), 1,
      anon_sym_or,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6950), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8227), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8229), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8235), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8239), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8241), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8247), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8243), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6952), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [142913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6669), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6671), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [142964] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(3399), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8263), 1,
      anon_sym_STAR,
    ACTIONS(8265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8267), 1,
      anon_sym_AMP,
    STATE(4425), 1,
      sym_parameter_list,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7276), 1,
      sym__abstract_declarator,
    ACTIONS(8141), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8143), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5621), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6235), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [143047] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8231), 1,
      anon_sym_SLASH,
    ACTIONS(8237), 1,
      anon_sym_CARET,
    ACTIONS(8245), 1,
      anon_sym_GT_EQ,
    ACTIONS(8249), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8253), 1,
      anon_sym_xor,
    ACTIONS(8255), 1,
      anon_sym_not_eq,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8227), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8229), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8239), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8241), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8247), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8243), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      sym_identifier,
    ACTIONS(6412), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
  [143136] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8231), 1,
      anon_sym_SLASH,
    ACTIONS(8245), 1,
      anon_sym_GT_EQ,
    ACTIONS(8249), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8255), 1,
      anon_sym_not_eq,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8227), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8229), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8241), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8247), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8243), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 9,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      sym_identifier,
    ACTIONS(6412), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
  [143219] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(4296), 1,
      anon_sym_LPAREN2,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6225), 1,
      anon_sym_STAR,
    ACTIONS(6227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6229), 1,
      anon_sym_AMP,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6233), 1,
      anon_sym_LBRACK,
    ACTIONS(8209), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(4001), 1,
      sym_parameter_list,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7175), 1,
      sym__declarator,
    STATE(7250), 1,
      sym__abstract_declarator,
    STATE(8143), 1,
      sym_variadic_declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8269), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [143314] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 1,
      anon_sym_LBRACE,
    ACTIONS(6983), 1,
      sym_auto,
    ACTIONS(6985), 1,
      anon_sym_decltype,
    ACTIONS(8219), 1,
      anon_sym_LPAREN2,
    ACTIONS(8221), 1,
      anon_sym_LBRACK,
    STATE(3402), 1,
      sym_decltype_auto,
    STATE(5092), 1,
      sym_new_declarator,
    STATE(5554), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5809), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5811), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [143381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5710), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [143432] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8231), 1,
      anon_sym_SLASH,
    ACTIONS(8245), 1,
      anon_sym_GT_EQ,
    ACTIONS(8249), 1,
      anon_sym_LT_EQ_GT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8227), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8229), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8247), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8243), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 10,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6412), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
  [143511] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(3399), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8263), 1,
      anon_sym_STAR,
    ACTIONS(8265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8267), 1,
      anon_sym_AMP,
    STATE(4425), 1,
      sym_parameter_list,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7205), 1,
      sym__abstract_declarator,
    ACTIONS(8141), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8143), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4829), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5660), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6223), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [143594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6687), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6689), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [143645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5675), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5677), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [143696] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8231), 1,
      anon_sym_SLASH,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8229), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6410), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6412), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [143765] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8231), 1,
      anon_sym_SLASH,
    ACTIONS(8233), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8237), 1,
      anon_sym_CARET,
    ACTIONS(8245), 1,
      anon_sym_GT_EQ,
    ACTIONS(8249), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8251), 1,
      anon_sym_and,
    ACTIONS(8253), 1,
      anon_sym_xor,
    ACTIONS(8255), 1,
      anon_sym_not_eq,
    ACTIONS(8259), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8261), 1,
      anon_sym_or,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8273), 1,
      anon_sym_QMARK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6905), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8227), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8229), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8235), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8239), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8241), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8247), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8243), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6907), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [143868] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8231), 1,
      anon_sym_SLASH,
    ACTIONS(8233), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8237), 1,
      anon_sym_CARET,
    ACTIONS(8245), 1,
      anon_sym_GT_EQ,
    ACTIONS(8249), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8251), 1,
      anon_sym_and,
    ACTIONS(8253), 1,
      anon_sym_xor,
    ACTIONS(8255), 1,
      anon_sym_not_eq,
    ACTIONS(8259), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8261), 1,
      anon_sym_or,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8273), 1,
      anon_sym_QMARK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8227), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8229), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8235), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8239), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8241), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8247), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8275), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8243), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8277), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [143971] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8231), 1,
      anon_sym_SLASH,
    ACTIONS(8233), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8237), 1,
      anon_sym_CARET,
    ACTIONS(8245), 1,
      anon_sym_GT_EQ,
    ACTIONS(8249), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8251), 1,
      anon_sym_and,
    ACTIONS(8253), 1,
      anon_sym_xor,
    ACTIONS(8255), 1,
      anon_sym_not_eq,
    ACTIONS(8259), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8261), 1,
      anon_sym_or,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6901), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8227), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8229), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8235), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8239), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8241), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8247), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8243), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6903), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [144070] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8231), 1,
      anon_sym_SLASH,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8227), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8229), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8247), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6410), 13,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6412), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [144143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5657), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5659), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [144194] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8231), 1,
      anon_sym_SLASH,
    ACTIONS(8237), 1,
      anon_sym_CARET,
    ACTIONS(8245), 1,
      anon_sym_GT_EQ,
    ACTIONS(8249), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8253), 1,
      anon_sym_xor,
    ACTIONS(8255), 1,
      anon_sym_not_eq,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8227), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8229), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8235), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8239), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8241), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8247), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8243), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 4,
      aux_sym_preproc_elif_token1,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
    ACTIONS(6412), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
  [144285] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8231), 1,
      anon_sym_SLASH,
    ACTIONS(8233), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8237), 1,
      anon_sym_CARET,
    ACTIONS(8245), 1,
      anon_sym_GT_EQ,
    ACTIONS(8249), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8251), 1,
      anon_sym_and,
    ACTIONS(8253), 1,
      anon_sym_xor,
    ACTIONS(8255), 1,
      anon_sym_not_eq,
    ACTIONS(8259), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8261), 1,
      anon_sym_or,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8273), 1,
      anon_sym_QMARK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6703), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8227), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8229), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8235), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8239), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8241), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8247), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8243), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6705), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [144388] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8231), 1,
      anon_sym_SLASH,
    ACTIONS(8233), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8237), 1,
      anon_sym_CARET,
    ACTIONS(8245), 1,
      anon_sym_GT_EQ,
    ACTIONS(8249), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8251), 1,
      anon_sym_and,
    ACTIONS(8253), 1,
      anon_sym_xor,
    ACTIONS(8255), 1,
      anon_sym_not_eq,
    ACTIONS(8259), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8261), 1,
      anon_sym_or,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6928), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8227), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8229), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8235), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8239), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8241), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8247), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8243), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6930), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [144487] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8231), 1,
      anon_sym_SLASH,
    ACTIONS(8233), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8237), 1,
      anon_sym_CARET,
    ACTIONS(8245), 1,
      anon_sym_GT_EQ,
    ACTIONS(8249), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8251), 1,
      anon_sym_and,
    ACTIONS(8253), 1,
      anon_sym_xor,
    ACTIONS(8255), 1,
      anon_sym_not_eq,
    ACTIONS(8259), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8261), 1,
      anon_sym_or,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8273), 1,
      anon_sym_QMARK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6891), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8227), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8229), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8235), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8239), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8241), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8247), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8243), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6895), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [144590] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8231), 1,
      anon_sym_SLASH,
    ACTIONS(8233), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8237), 1,
      anon_sym_CARET,
    ACTIONS(8245), 1,
      anon_sym_GT_EQ,
    ACTIONS(8249), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8251), 1,
      anon_sym_and,
    ACTIONS(8253), 1,
      anon_sym_xor,
    ACTIONS(8255), 1,
      anon_sym_not_eq,
    ACTIONS(8259), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8261), 1,
      anon_sym_or,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6879), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8227), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8229), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8235), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8239), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8241), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8247), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8243), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6881), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [144689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5661), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5663), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [144739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5640), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [144789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5640), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [144839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5640), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [144889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5648), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [144939] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8279), 1,
      sym_identifier,
    ACTIONS(8281), 1,
      anon_sym_LPAREN2,
    ACTIONS(8283), 1,
      anon_sym_STAR,
    STATE(3598), 1,
      sym__type_declarator,
    STATE(4209), 1,
      sym_pointer_type_declarator,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(9101), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4294), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5710), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8289), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8287), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4210), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [145017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5665), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5667), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [145067] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(3399), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8291), 1,
      anon_sym_STAR,
    ACTIONS(8293), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    STATE(4537), 1,
      sym_parameter_list,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7300), 1,
      sym__abstract_declarator,
    ACTIONS(8141), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8143), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5681), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6235), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [145149] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8111), 1,
      anon_sym_STAR,
    ACTIONS(8113), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8115), 1,
      anon_sym_AMP,
    ACTIONS(8201), 1,
      sym_auto,
    ACTIONS(8203), 1,
      anon_sym_decltype,
    STATE(3115), 1,
      sym_decltype_auto,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6839), 1,
      sym__abstract_declarator,
    STATE(5154), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8297), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [145227] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    STATE(4667), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6178), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6180), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [145283] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(3399), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8291), 1,
      anon_sym_STAR,
    ACTIONS(8293), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    STATE(4537), 1,
      sym_parameter_list,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7314), 1,
      sym__abstract_declarator,
    ACTIONS(8141), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8143), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4857), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5690), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6223), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [145365] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    STATE(4603), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6189), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6191), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [145421] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8075), 1,
      anon_sym_STAR,
    ACTIONS(8077), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8079), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8301), 1,
      sym_auto,
    ACTIONS(8303), 1,
      anon_sym_decltype,
    STATE(4132), 1,
      sym_parameter_list,
    STATE(5784), 1,
      sym_decltype_auto,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6817), 1,
      sym__abstract_declarator,
    STATE(5192), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8299), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [145499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5781), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5783), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [145549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5787), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [145599] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8305), 1,
      sym_identifier,
    ACTIONS(8307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8309), 1,
      anon_sym_STAR,
    STATE(3246), 1,
      sym__type_declarator,
    STATE(3576), 1,
      sym_pointer_type_declarator,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(9416), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4294), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5673), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8313), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8311), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3579), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [145677] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(7190), 1,
      anon_sym_LBRACE,
    ACTIONS(8315), 1,
      anon_sym_COLON,
    STATE(3128), 1,
      sym_attribute_specifier,
    STATE(3479), 1,
      sym__enum_base_clause,
    STATE(3725), 1,
      sym_enumerator_list,
    ACTIONS(6282), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6280), 31,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_operator,
  [145739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5789), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5791), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [145789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5751), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5753), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [145839] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7142), 1,
      sym__type_declarator,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4294), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5688), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [145917] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8325), 1,
      sym_identifier,
    ACTIONS(8327), 1,
      anon_sym_LPAREN2,
    ACTIONS(8329), 1,
      anon_sym_STAR,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6855), 1,
      sym__type_declarator,
    STATE(7020), 1,
      sym_pointer_type_declarator,
    STATE(9762), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4924), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5694), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8331), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7002), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [145995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6981), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [146045] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8333), 1,
      anon_sym_STAR,
    STATE(2691), 1,
      sym__type_declarator,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(9571), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4294), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5682), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8335), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [146123] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8337), 1,
      sym_identifier,
    ACTIONS(8339), 1,
      anon_sym_LPAREN2,
    ACTIONS(8341), 1,
      anon_sym_STAR,
    STATE(3427), 1,
      sym__type_declarator,
    STATE(3934), 1,
      sym_pointer_type_declarator,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(9121), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4907), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5718), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8345), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8343), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3933), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [146201] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4878), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5363), 4,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
    ACTIONS(8347), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5730), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(5733), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [146257] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3729), 1,
      anon_sym_LBRACE,
    ACTIONS(8125), 1,
      anon_sym_LPAREN2,
    STATE(5173), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6178), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6180), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [146313] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8350), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7472), 1,
      sym__type_declarator,
    STATE(9249), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4294), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5715), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8335), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [146391] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3729), 1,
      anon_sym_LBRACE,
    ACTIONS(8125), 1,
      anon_sym_LPAREN2,
    STATE(5148), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6185), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6187), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [146447] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4878), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8347), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5365), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(5363), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [146501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5771), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5773), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [146551] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8350), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7482), 1,
      sym__type_declarator,
    STATE(9249), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4876), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5701), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8335), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [146629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5793), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5795), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [146679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5755), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5757), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [146729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5642), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5644), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [146779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5669), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5671), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [146829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5777), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5779), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [146879] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8097), 1,
      anon_sym_STAR,
    ACTIONS(8099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8101), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      sym_auto,
    ACTIONS(8303), 1,
      anon_sym_decltype,
    STATE(4341), 1,
      sym_parameter_list,
    STATE(5784), 1,
      sym_decltype_auto,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6869), 1,
      sym__abstract_declarator,
    STATE(5161), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8297), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [146957] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8333), 1,
      anon_sym_STAR,
    STATE(2691), 1,
      sym__type_declarator,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(9571), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4898), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5682), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8335), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [147035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5763), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5765), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [147085] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8279), 1,
      sym_identifier,
    ACTIONS(8281), 1,
      anon_sym_LPAREN2,
    ACTIONS(8283), 1,
      anon_sym_STAR,
    STATE(3543), 1,
      sym__type_declarator,
    STATE(4209), 1,
      sym_pointer_type_declarator,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(9101), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4294), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5717), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8289), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8287), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4210), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [147163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5742), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [147213] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3729), 1,
      anon_sym_LBRACE,
    ACTIONS(8125), 1,
      anon_sym_LPAREN2,
    STATE(5104), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6152), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6154), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [147269] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8325), 1,
      sym_identifier,
    ACTIONS(8327), 1,
      anon_sym_LPAREN2,
    ACTIONS(8352), 1,
      anon_sym_STAR,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7020), 1,
      sym_pointer_type_declarator,
    STATE(7095), 1,
      sym__type_declarator,
    STATE(9674), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4929), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5721), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7945), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8331), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7002), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [147347] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8333), 1,
      anon_sym_STAR,
    STATE(2723), 1,
      sym__type_declarator,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(9571), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4872), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5677), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8335), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [147425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5716), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5718), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [147475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5632), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [147525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5704), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5706), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [147575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5702), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [147625] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8333), 1,
      anon_sym_STAR,
    STATE(2662), 1,
      sym__type_declarator,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(9571), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4294), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5705), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8335), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [147703] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8279), 1,
      sym_identifier,
    ACTIONS(8281), 1,
      anon_sym_LPAREN2,
    ACTIONS(8283), 1,
      anon_sym_STAR,
    STATE(3629), 1,
      sym__type_declarator,
    STATE(4209), 1,
      sym_pointer_type_declarator,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(9101), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4889), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5693), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8289), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8287), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4210), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [147781] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8075), 1,
      anon_sym_STAR,
    ACTIONS(8077), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8079), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8301), 1,
      sym_auto,
    ACTIONS(8303), 1,
      anon_sym_decltype,
    STATE(4132), 1,
      sym_parameter_list,
    STATE(5784), 1,
      sym_decltype_auto,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6806), 1,
      sym__abstract_declarator,
    STATE(5195), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8297), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [147859] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8325), 1,
      sym_identifier,
    ACTIONS(8327), 1,
      anon_sym_LPAREN2,
    ACTIONS(8352), 1,
      anon_sym_STAR,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7020), 1,
      sym_pointer_type_declarator,
    STATE(7113), 1,
      sym__type_declarator,
    STATE(9674), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4294), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5687), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7945), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8331), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7002), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [147937] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8111), 1,
      anon_sym_STAR,
    ACTIONS(8113), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8115), 1,
      anon_sym_AMP,
    ACTIONS(8201), 1,
      sym_auto,
    ACTIONS(8203), 1,
      anon_sym_decltype,
    STATE(3115), 1,
      sym_decltype_auto,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6831), 1,
      sym__abstract_declarator,
    STATE(5084), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8299), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [148015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5481), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5483), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [148065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6975), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6977), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [148115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5481), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5483), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [148165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5738), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [148215] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8337), 1,
      sym_identifier,
    ACTIONS(8339), 1,
      anon_sym_LPAREN2,
    ACTIONS(8341), 1,
      anon_sym_STAR,
    STATE(3409), 1,
      sym__type_declarator,
    STATE(3934), 1,
      sym_pointer_type_declarator,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(9121), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4294), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5719), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8345), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8343), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3933), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [148293] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(7190), 1,
      anon_sym_LBRACE,
    ACTIONS(8315), 1,
      anon_sym_COLON,
    STATE(3072), 1,
      sym_attribute_specifier,
    STATE(3475), 1,
      sym__enum_base_clause,
    STATE(3702), 1,
      sym_enumerator_list,
    ACTIONS(6336), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6334), 31,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_operator,
  [148355] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8325), 1,
      sym_identifier,
    ACTIONS(8327), 1,
      anon_sym_LPAREN2,
    ACTIONS(8329), 1,
      anon_sym_STAR,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6854), 1,
      sym__type_declarator,
    STATE(7020), 1,
      sym_pointer_type_declarator,
    STATE(9762), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4294), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5706), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8331), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7002), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [148433] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    STATE(4653), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6185), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6187), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [148489] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7177), 1,
      sym__type_declarator,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4294), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5689), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [148567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5722), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [148617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5712), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5714), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [148667] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8337), 1,
      sym_identifier,
    ACTIONS(8339), 1,
      anon_sym_LPAREN2,
    ACTIONS(8341), 1,
      anon_sym_STAR,
    STATE(3409), 1,
      sym__type_declarator,
    STATE(3934), 1,
      sym_pointer_type_declarator,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(9121), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4925), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5719), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8345), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8343), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3933), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [148745] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 1,
      sym_literal_suffix,
    ACTIONS(5797), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5799), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [148797] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8305), 1,
      sym_identifier,
    ACTIONS(8307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8309), 1,
      anon_sym_STAR,
    STATE(3253), 1,
      sym__type_declarator,
    STATE(3576), 1,
      sym_pointer_type_declarator,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(9416), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4865), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5716), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8313), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8311), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3579), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [148875] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 1,
      sym_literal_suffix,
    ACTIONS(4256), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4248), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [148927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5690), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [148977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5696), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5698), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [149027] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8305), 1,
      sym_identifier,
    ACTIONS(8307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8309), 1,
      anon_sym_STAR,
    STATE(3261), 1,
      sym__type_declarator,
    STATE(3576), 1,
      sym_pointer_type_declarator,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(9416), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4934), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5668), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8313), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8311), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3579), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [149105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5694), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [149155] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8350), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7466), 1,
      sym__type_declarator,
    STATE(9249), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4294), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5711), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8335), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [149233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5690), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [149283] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8325), 1,
      sym_identifier,
    ACTIONS(8327), 1,
      anon_sym_LPAREN2,
    ACTIONS(8329), 1,
      anon_sym_STAR,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6856), 1,
      sym__type_declarator,
    STATE(7020), 1,
      sym_pointer_type_declarator,
    STATE(9762), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4294), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5692), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8331), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7002), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [149361] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8337), 1,
      sym_identifier,
    ACTIONS(8339), 1,
      anon_sym_LPAREN2,
    ACTIONS(8341), 1,
      anon_sym_STAR,
    STATE(3470), 1,
      sym__type_declarator,
    STATE(3934), 1,
      sym_pointer_type_declarator,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(9121), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4294), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5708), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8345), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8343), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3933), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [149439] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8097), 1,
      anon_sym_STAR,
    ACTIONS(8099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8101), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      sym_auto,
    ACTIONS(8303), 1,
      anon_sym_decltype,
    STATE(4341), 1,
      sym_parameter_list,
    STATE(5784), 1,
      sym_decltype_auto,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6881), 1,
      sym__abstract_declarator,
    STATE(5134), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8299), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [149517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5686), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [149567] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8325), 1,
      sym_identifier,
    ACTIONS(8327), 1,
      anon_sym_LPAREN2,
    ACTIONS(8329), 1,
      anon_sym_STAR,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6856), 1,
      sym__type_declarator,
    STATE(7020), 1,
      sym_pointer_type_declarator,
    STATE(9762), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4909), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5692), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8331), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7002), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [149645] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8325), 1,
      sym_identifier,
    ACTIONS(8327), 1,
      anon_sym_LPAREN2,
    ACTIONS(8352), 1,
      anon_sym_STAR,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7020), 1,
      sym_pointer_type_declarator,
    STATE(7112), 1,
      sym__type_declarator,
    STATE(9674), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4294), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5712), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7945), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8331), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7002), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [149723] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    STATE(4630), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6152), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6154), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [149779] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8279), 1,
      sym_identifier,
    ACTIONS(8281), 1,
      anon_sym_LPAREN2,
    ACTIONS(8283), 1,
      anon_sym_STAR,
    STATE(3543), 1,
      sym__type_declarator,
    STATE(4209), 1,
      sym_pointer_type_declarator,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(9101), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4855), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5717), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8289), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8287), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4210), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [149857] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8325), 1,
      sym_identifier,
    ACTIONS(8327), 1,
      anon_sym_LPAREN2,
    ACTIONS(8352), 1,
      anon_sym_STAR,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7020), 1,
      sym_pointer_type_declarator,
    STATE(7112), 1,
      sym__type_declarator,
    STATE(9674), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4901), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5712), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7945), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8331), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7002), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [149935] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7149), 1,
      sym__type_declarator,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4911), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5714), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [150013] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8305), 1,
      sym_identifier,
    ACTIONS(8307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8309), 1,
      anon_sym_STAR,
    STATE(3253), 1,
      sym__type_declarator,
    STATE(3576), 1,
      sym_pointer_type_declarator,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(9416), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4294), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5716), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8313), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8311), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3579), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [150091] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7177), 1,
      sym__type_declarator,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4869), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5689), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [150169] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3729), 1,
      anon_sym_LBRACE,
    ACTIONS(8125), 1,
      anon_sym_LPAREN2,
    STATE(5118), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6189), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6191), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [150225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5759), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5761), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [150275] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8350), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7472), 1,
      sym__type_declarator,
    STATE(9249), 1,
      sym_ms_based_modifier,
    ACTIONS(8285), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4922), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5715), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8081), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8335), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [150353] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8354), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6389), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6391), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [150416] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8081), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8356), 1,
      anon_sym_STAR,
    ACTIONS(8358), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4695), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7363), 1,
      sym__abstract_declarator,
    ACTIONS(8083), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8085), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4294), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5796), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6235), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [150497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6975), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6977), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [150546] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7340), 1,
      anon_sym_const,
    ACTIONS(7343), 1,
      anon_sym___inline,
    ACTIONS(8368), 1,
      anon_sym___attribute__,
    ACTIONS(8371), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8374), 1,
      anon_sym___declspec,
    ACTIONS(8377), 1,
      anon_sym_virtual,
    ACTIONS(8380), 1,
      anon_sym_alignas,
    ACTIONS(6755), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(6757), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(8365), 8,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(4942), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(8362), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [150615] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_SLASH,
    ACTIONS(8395), 1,
      anon_sym_PIPE,
    ACTIONS(8399), 1,
      anon_sym_AMP,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8409), 1,
      anon_sym_SEMI,
    ACTIONS(8411), 1,
      anon_sym_QMARK,
    ACTIONS(8413), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8415), 1,
      anon_sym_bitor,
    ACTIONS(8417), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(7576), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8813), 1,
      sym_attribute_specifier,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8387), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8391), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8393), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8397), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8401), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150718] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(6928), 1,
      sym_identifier,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_SLASH,
    ACTIONS(8425), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8431), 1,
      anon_sym_CARET,
    ACTIONS(8439), 1,
      anon_sym_GT_EQ,
    ACTIONS(8443), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8445), 1,
      anon_sym_or,
    ACTIONS(8447), 1,
      anon_sym_and,
    ACTIONS(8449), 1,
      anon_sym_xor,
    ACTIONS(8451), 1,
      anon_sym_not_eq,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8354), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8419), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8421), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8429), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8433), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8435), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8437), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6930), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_QMARK,
  [150815] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8354), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6410), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6412), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [150878] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(6905), 1,
      sym_identifier,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_SLASH,
    ACTIONS(8425), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8431), 1,
      anon_sym_CARET,
    ACTIONS(8439), 1,
      anon_sym_GT_EQ,
    ACTIONS(8443), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8445), 1,
      anon_sym_or,
    ACTIONS(8447), 1,
      anon_sym_and,
    ACTIONS(8449), 1,
      anon_sym_xor,
    ACTIONS(8451), 1,
      anon_sym_not_eq,
    ACTIONS(8453), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8455), 1,
      anon_sym_QMARK,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8354), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8419), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8421), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8429), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8433), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8435), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8437), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6907), 4,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [150979] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym___inline,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8199), 1,
      anon_sym___declspec,
    ACTIONS(8205), 1,
      anon_sym_virtual,
    ACTIONS(8207), 1,
      anon_sym_alignas,
    ACTIONS(6741), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(6743), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(8197), 8,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(4942), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [151048] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8459), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(5382), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6621), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(8457), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [151107] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7733), 1,
      anon_sym_LT,
    STATE(2036), 1,
      sym_template_argument_list,
    ACTIONS(5129), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5136), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [151162] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8461), 1,
      sym_identifier,
    STATE(5021), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5613), 1,
      sym_primitive_type,
    ACTIONS(7972), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8463), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5489), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5491), 21,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [151221] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(4296), 1,
      anon_sym_LPAREN2,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6225), 1,
      anon_sym_STAR,
    ACTIONS(6227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6229), 1,
      anon_sym_AMP,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6233), 1,
      anon_sym_LBRACK,
    STATE(4001), 1,
      sym_parameter_list,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7175), 1,
      sym__declarator,
    STATE(7250), 1,
      sym__abstract_declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8269), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [151310] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(6879), 1,
      sym_identifier,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_SLASH,
    ACTIONS(8425), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8431), 1,
      anon_sym_CARET,
    ACTIONS(8439), 1,
      anon_sym_GT_EQ,
    ACTIONS(8443), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8445), 1,
      anon_sym_or,
    ACTIONS(8447), 1,
      anon_sym_and,
    ACTIONS(8449), 1,
      anon_sym_xor,
    ACTIONS(8451), 1,
      anon_sym_not_eq,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8354), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8419), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8421), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8429), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8433), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8435), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8437), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6881), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_QMARK,
  [151407] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_SLASH,
    ACTIONS(8395), 1,
      anon_sym_PIPE,
    ACTIONS(8399), 1,
      anon_sym_AMP,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8411), 1,
      anon_sym_QMARK,
    ACTIONS(8413), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8415), 1,
      anon_sym_bitor,
    ACTIONS(8417), 1,
      anon_sym_bitand,
    ACTIONS(8465), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(7581), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8788), 1,
      sym_attribute_specifier,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8387), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8391), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8393), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8397), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8401), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151510] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_SLASH,
    ACTIONS(8395), 1,
      anon_sym_PIPE,
    ACTIONS(8399), 1,
      anon_sym_AMP,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8411), 1,
      anon_sym_QMARK,
    ACTIONS(8413), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8415), 1,
      anon_sym_bitor,
    ACTIONS(8417), 1,
      anon_sym_bitand,
    ACTIONS(8467), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(7599), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9327), 1,
      sym_attribute_specifier,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8387), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8391), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8393), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8397), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8401), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151613] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8469), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8471), 1,
      anon_sym_and,
    ACTIONS(6065), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6067), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [151666] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym___inline,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8199), 1,
      anon_sym___declspec,
    ACTIONS(8205), 1,
      anon_sym_virtual,
    ACTIONS(8207), 1,
      anon_sym_alignas,
    ACTIONS(6747), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(6749), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(8197), 8,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(4942), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [151735] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(6901), 1,
      sym_identifier,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_SLASH,
    ACTIONS(8425), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8431), 1,
      anon_sym_CARET,
    ACTIONS(8439), 1,
      anon_sym_GT_EQ,
    ACTIONS(8443), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8445), 1,
      anon_sym_or,
    ACTIONS(8447), 1,
      anon_sym_and,
    ACTIONS(8449), 1,
      anon_sym_xor,
    ACTIONS(8451), 1,
      anon_sym_not_eq,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8354), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8419), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8421), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8429), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8433), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8435), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8437), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6903), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_QMARK,
  [151832] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7733), 1,
      anon_sym_LT,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(4075), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4246), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(7247), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4254), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [151891] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(8275), 1,
      sym_identifier,
    ACTIONS(8423), 1,
      anon_sym_SLASH,
    ACTIONS(8425), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8431), 1,
      anon_sym_CARET,
    ACTIONS(8439), 1,
      anon_sym_GT_EQ,
    ACTIONS(8443), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8445), 1,
      anon_sym_or,
    ACTIONS(8447), 1,
      anon_sym_and,
    ACTIONS(8449), 1,
      anon_sym_xor,
    ACTIONS(8451), 1,
      anon_sym_not_eq,
    ACTIONS(8453), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8455), 1,
      anon_sym_QMARK,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8354), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8419), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8421), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8429), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8433), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8435), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8437), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8277), 4,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [151992] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7733), 1,
      anon_sym_LT,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(5258), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4246), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(8473), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4254), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [152051] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8475), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8477), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6006), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6008), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [152104] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8133), 1,
      anon_sym_STAR,
    ACTIONS(8135), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8137), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8479), 1,
      sym_auto,
    ACTIONS(8481), 1,
      anon_sym_decltype,
    STATE(3938), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym_decltype_auto,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(6977), 1,
      sym__abstract_declarator,
    STATE(5276), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8297), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [152181] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym_LBRACK,
    STATE(5001), 1,
      sym_new_declarator,
    ACTIONS(6289), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6291), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [152234] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8354), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6393), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6395), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [152297] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(6950), 1,
      sym_identifier,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_SLASH,
    ACTIONS(8425), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8431), 1,
      anon_sym_CARET,
    ACTIONS(8439), 1,
      anon_sym_GT_EQ,
    ACTIONS(8443), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8445), 1,
      anon_sym_or,
    ACTIONS(8447), 1,
      anon_sym_and,
    ACTIONS(8449), 1,
      anon_sym_xor,
    ACTIONS(8451), 1,
      anon_sym_not_eq,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8354), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8419), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8421), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8429), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8433), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8435), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8437), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6952), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_QMARK,
  [152394] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(6891), 1,
      sym_identifier,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_SLASH,
    ACTIONS(8425), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8431), 1,
      anon_sym_CARET,
    ACTIONS(8439), 1,
      anon_sym_GT_EQ,
    ACTIONS(8443), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8445), 1,
      anon_sym_or,
    ACTIONS(8447), 1,
      anon_sym_and,
    ACTIONS(8449), 1,
      anon_sym_xor,
    ACTIONS(8451), 1,
      anon_sym_not_eq,
    ACTIONS(8453), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8455), 1,
      anon_sym_QMARK,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8354), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8419), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8421), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8429), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8433), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8435), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8437), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6895), 4,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [152495] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8133), 1,
      anon_sym_STAR,
    ACTIONS(8135), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8137), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8479), 1,
      sym_auto,
    ACTIONS(8481), 1,
      anon_sym_decltype,
    STATE(3938), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym_decltype_auto,
    STATE(6954), 1,
      sym__abstract_declarator,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(5357), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8299), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [152572] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6444), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6446), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [152633] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6703), 1,
      sym_identifier,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_SLASH,
    ACTIONS(8425), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8431), 1,
      anon_sym_CARET,
    ACTIONS(8439), 1,
      anon_sym_GT_EQ,
    ACTIONS(8443), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8445), 1,
      anon_sym_or,
    ACTIONS(8447), 1,
      anon_sym_and,
    ACTIONS(8449), 1,
      anon_sym_xor,
    ACTIONS(8451), 1,
      anon_sym_not_eq,
    ACTIONS(8453), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8455), 1,
      anon_sym_QMARK,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8354), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8419), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8421), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8429), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8433), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8435), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8437), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6705), 4,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [152734] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8081), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8356), 1,
      anon_sym_STAR,
    ACTIONS(8358), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    STATE(4645), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4695), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7353), 1,
      sym__abstract_declarator,
    ACTIONS(8083), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8085), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4940), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5739), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6223), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [152815] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8469), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8471), 1,
      anon_sym_and,
    ACTIONS(8483), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8485), 1,
      anon_sym_or,
    ACTIONS(6006), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6008), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [152872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8477), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6065), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6067), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [152923] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5138), 1,
      anon_sym_LBRACK,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(5147), 1,
      sym_template_argument_list,
    ACTIONS(5133), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5136), 3,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
    ACTIONS(5129), 32,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_operator,
  [152982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6981), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [153031] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_SLASH,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8354), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8421), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6410), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6412), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [153098] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_SLASH,
    ACTIONS(8427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8431), 1,
      anon_sym_CARET,
    ACTIONS(8439), 1,
      anon_sym_GT_EQ,
    ACTIONS(8443), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8447), 1,
      anon_sym_and,
    ACTIONS(8449), 1,
      anon_sym_xor,
    ACTIONS(8451), 1,
      anon_sym_not_eq,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(6410), 2,
      anon_sym_or,
      sym_identifier,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8354), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8419), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8421), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8429), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8433), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8435), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8437), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
  [153191] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_SLASH,
    ACTIONS(8431), 1,
      anon_sym_CARET,
    ACTIONS(8439), 1,
      anon_sym_GT_EQ,
    ACTIONS(8443), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8449), 1,
      anon_sym_xor,
    ACTIONS(8451), 1,
      anon_sym_not_eq,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8354), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8419), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8421), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8429), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8433), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8435), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6410), 3,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
    ACTIONS(8437), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
  [153280] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_SLASH,
    ACTIONS(8431), 1,
      anon_sym_CARET,
    ACTIONS(8439), 1,
      anon_sym_GT_EQ,
    ACTIONS(8443), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8449), 1,
      anon_sym_xor,
    ACTIONS(8451), 1,
      anon_sym_not_eq,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8354), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8419), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8421), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8433), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8435), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8437), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 5,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      sym_identifier,
    ACTIONS(6412), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
  [153367] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_SLASH,
    ACTIONS(8439), 1,
      anon_sym_GT_EQ,
    ACTIONS(8443), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8451), 1,
      anon_sym_not_eq,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8354), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8419), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8421), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8433), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8435), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8437), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 6,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      sym_identifier,
    ACTIONS(6412), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
  [153450] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_SLASH,
    ACTIONS(8439), 1,
      anon_sym_GT_EQ,
    ACTIONS(8443), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8451), 1,
      anon_sym_not_eq,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8354), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8419), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8421), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8435), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8437), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 8,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      sym_identifier,
    ACTIONS(6412), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
  [153531] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(5258), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5958), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(8473), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5960), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [153590] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8354), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6460), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6462), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [153653] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 1,
      sym_literal_suffix,
    ACTIONS(4256), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(4248), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [153704] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5167), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(5169), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5162), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [153755] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6448), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6450), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [153816] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 1,
      sym_literal_suffix,
    ACTIONS(5797), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5799), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [153867] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_SLASH,
    ACTIONS(8439), 1,
      anon_sym_GT_EQ,
    ACTIONS(8443), 1,
      anon_sym_LT_EQ_GT,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8354), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8419), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8421), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8441), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8437), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6410), 9,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6412), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
  [153944] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_SLASH,
    ACTIONS(8443), 1,
      anon_sym_LT_EQ_GT,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8354), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8419), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8421), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8441), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6410), 12,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6412), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
  [154017] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7733), 1,
      anon_sym_LT,
    STATE(2036), 1,
      sym_template_argument_list,
    ACTIONS(5835), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4272), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [154072] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_SLASH,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8354), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8419), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8421), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6410), 12,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6412), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [154141] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    ACTIONS(7002), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_SLASH,
    STATE(3736), 1,
      sym_subscript_argument_list,
    STATE(3737), 1,
      sym_argument_list,
    ACTIONS(7008), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8354), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8419), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8421), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8441), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6410), 12,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6412), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [154212] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_SLASH,
    ACTIONS(8395), 1,
      anon_sym_PIPE,
    ACTIONS(8399), 1,
      anon_sym_AMP,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8411), 1,
      anon_sym_QMARK,
    ACTIONS(8413), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8415), 1,
      anon_sym_bitor,
    ACTIONS(8417), 1,
      anon_sym_bitand,
    ACTIONS(8487), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(7625), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9459), 1,
      sym_attribute_specifier,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8387), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8391), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8393), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8397), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8401), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8105), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8103), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [154364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8109), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8107), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [154413] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6907), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [154507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8523), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8521), 34,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [154555] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6410), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [154621] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6881), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [154711] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8525), 1,
      anon_sym_COMMA,
    ACTIONS(8527), 1,
      anon_sym_SEMI,
    ACTIONS(8529), 1,
      anon_sym_RBRACE,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8147), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154811] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8162), 1,
      anon_sym_STAR,
    ACTIONS(8164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8166), 1,
      anon_sym_AMP,
    ACTIONS(8201), 1,
      sym_auto,
    ACTIONS(8203), 1,
      anon_sym_decltype,
    STATE(3115), 1,
      sym_decltype_auto,
    STATE(4342), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7055), 1,
      sym__abstract_declarator,
    STATE(5504), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8299), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [154887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6364), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [154935] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8173), 1,
      anon_sym_STAR,
    ACTIONS(8175), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8177), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      sym_auto,
    ACTIONS(8303), 1,
      anon_sym_decltype,
    STATE(4321), 1,
      sym_parameter_list,
    STATE(5784), 1,
      sym_decltype_auto,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7085), 1,
      sym__abstract_declarator,
    STATE(5492), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8297), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [155011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6981), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [155059] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6410), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [155129] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(3399), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8531), 1,
      anon_sym_STAR,
    ACTIONS(8533), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP,
    STATE(4001), 1,
      sym_parameter_list,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7201), 1,
      sym__abstract_declarator,
    ACTIONS(8141), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8143), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5016), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5853), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6223), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [155209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5483), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5481), 34,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [155259] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6410), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [155327] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6410), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [155399] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(8537), 1,
      sym_identifier,
    ACTIONS(8539), 1,
      anon_sym_LPAREN2,
    ACTIONS(8541), 1,
      anon_sym_STAR,
    ACTIONS(8543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8545), 1,
      anon_sym_AMP,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6902), 1,
      sym__field_declarator,
    STATE(7119), 1,
      sym_operator_name,
    STATE(9391), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5839), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(7265), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [155477] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(8539), 1,
      anon_sym_LPAREN2,
    ACTIONS(8547), 1,
      sym_identifier,
    ACTIONS(8549), 1,
      anon_sym_STAR,
    ACTIONS(8551), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8553), 1,
      anon_sym_AMP,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7415), 1,
      sym__field_declarator,
    STATE(7503), 1,
      sym_operator_name,
    STATE(9291), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5035), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5837), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(7265), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [155555] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(8537), 1,
      sym_identifier,
    ACTIONS(8539), 1,
      anon_sym_LPAREN2,
    ACTIONS(8541), 1,
      anon_sym_STAR,
    ACTIONS(8543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8545), 1,
      anon_sym_AMP,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6998), 1,
      sym__field_declarator,
    STATE(7119), 1,
      sym_operator_name,
    STATE(9391), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5848), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(7265), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [155633] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6410), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [155709] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8173), 1,
      anon_sym_STAR,
    ACTIONS(8175), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8177), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      sym_auto,
    ACTIONS(8303), 1,
      anon_sym_decltype,
    STATE(4321), 1,
      sym_parameter_list,
    STATE(5784), 1,
      sym_decltype_auto,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7111), 1,
      sym__abstract_declarator,
    STATE(5528), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8299), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [155785] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5986), 1,
      sym_literal_suffix,
    ACTIONS(4256), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4248), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [155835] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5986), 1,
      sym_literal_suffix,
    ACTIONS(5797), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5799), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [155885] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(3399), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8531), 1,
      anon_sym_STAR,
    ACTIONS(8533), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP,
    STATE(4001), 1,
      sym_parameter_list,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7253), 1,
      sym__abstract_declarator,
    ACTIONS(8141), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8143), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5856), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6235), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [155965] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6895), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [156059] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(8537), 1,
      sym_identifier,
    ACTIONS(8539), 1,
      anon_sym_LPAREN2,
    ACTIONS(8541), 1,
      anon_sym_STAR,
    ACTIONS(8543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8545), 1,
      anon_sym_AMP,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6935), 1,
      sym__field_declarator,
    STATE(7119), 1,
      sym_operator_name,
    STATE(9391), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5009), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5844), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(7265), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [156137] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6930), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [156227] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6903), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [156317] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5024), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5363), 4,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
    ACTIONS(8555), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5730), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5733), 21,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [156371] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(8539), 1,
      anon_sym_LPAREN2,
    ACTIONS(8547), 1,
      sym_identifier,
    ACTIONS(8549), 1,
      anon_sym_STAR,
    ACTIONS(8551), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8553), 1,
      anon_sym_AMP,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7404), 1,
      sym__field_declarator,
    STATE(7503), 1,
      sym_operator_name,
    STATE(9291), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5026), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5858), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(7265), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [156449] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(8537), 1,
      sym_identifier,
    ACTIONS(8539), 1,
      anon_sym_LPAREN2,
    ACTIONS(8541), 1,
      anon_sym_STAR,
    ACTIONS(8543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8545), 1,
      anon_sym_AMP,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6935), 1,
      sym__field_declarator,
    STATE(7119), 1,
      sym_operator_name,
    STATE(9391), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5844), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(7265), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [156527] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5024), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8555), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5365), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5363), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [156579] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6410), 1,
      anon_sym_PIPE,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [156661] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(8539), 1,
      anon_sym_LPAREN2,
    ACTIONS(8547), 1,
      sym_identifier,
    ACTIONS(8549), 1,
      anon_sym_STAR,
    ACTIONS(8551), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8553), 1,
      anon_sym_AMP,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7415), 1,
      sym__field_declarator,
    STATE(7503), 1,
      sym_operator_name,
    STATE(9291), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5837), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(7265), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [156739] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8558), 1,
      anon_sym_STAR,
    ACTIONS(8560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8562), 1,
      anon_sym_AMP,
    ACTIONS(8566), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8572), 1,
      anon_sym_const,
    STATE(4705), 1,
      sym_parameter_list,
    STATE(6148), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7419), 1,
      sym__abstract_declarator,
    ACTIONS(8568), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8570), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5030), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5840), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6223), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8564), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [156819] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6410), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [156897] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
  [156985] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8558), 1,
      anon_sym_STAR,
    ACTIONS(8560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8562), 1,
      anon_sym_AMP,
    ACTIONS(8566), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8572), 1,
      anon_sym_const,
    STATE(4705), 1,
      sym_parameter_list,
    STATE(6148), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7436), 1,
      sym__abstract_declarator,
    ACTIONS(8568), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8570), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5832), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(6235), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8564), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [157065] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [157151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6975), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6977), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [157199] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8576), 1,
      anon_sym_LPAREN2,
    ACTIONS(8578), 5,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8574), 34,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [157249] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6410), 1,
      anon_sym_PIPE,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [157333] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(8539), 1,
      anon_sym_LPAREN2,
    ACTIONS(8547), 1,
      sym_identifier,
    ACTIONS(8549), 1,
      anon_sym_STAR,
    ACTIONS(8551), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8553), 1,
      anon_sym_AMP,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7421), 1,
      sym__field_declarator,
    STATE(7503), 1,
      sym_operator_name,
    STATE(9291), 1,
      sym_ms_based_modifier,
    ACTIONS(3401), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5826), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3399), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(7265), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [157411] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6705), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [157505] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6952), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [157595] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8162), 1,
      anon_sym_STAR,
    ACTIONS(8164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8166), 1,
      anon_sym_AMP,
    ACTIONS(8201), 1,
      sym_auto,
    ACTIONS(8203), 1,
      anon_sym_decltype,
    STATE(3115), 1,
      sym_decltype_auto,
    STATE(4342), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7051), 1,
      sym__abstract_declarator,
    STATE(5383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8297), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [157671] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8582), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8177), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157768] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8075), 1,
      anon_sym_STAR,
    ACTIONS(8077), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8079), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    STATE(4132), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6814), 1,
      sym__abstract_declarator,
    STATE(5571), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6965), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [157837] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8584), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8327), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157934] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    ACTIONS(8624), 1,
      anon_sym_GT2,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    STATE(8206), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158031] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8626), 1,
      anon_sym_COMMA,
    ACTIONS(8629), 1,
      anon_sym_SEMI,
    ACTIONS(8631), 1,
      anon_sym_RBRACE,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5296), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5298), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [158175] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8633), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8185), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158272] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(3399), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7443), 1,
      sym__abstract_declarator,
    ACTIONS(8141), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8143), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5889), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6235), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [158351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5284), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5286), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [158398] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8635), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8637), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8639), 1,
      anon_sym_or,
    ACTIONS(8641), 1,
      anon_sym_and,
    ACTIONS(6006), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6008), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [158453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5316), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5318), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [158500] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(5619), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5958), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8643), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5960), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [158557] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8645), 1,
      anon_sym_COMMA,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8671), 1,
      anon_sym_RBRACK,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(7949), 1,
      aux_sym_subscript_argument_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158654] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8681), 1,
      anon_sym_COMMA,
    ACTIONS(8683), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8347), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5314), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [158798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5314), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [158845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5314), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [158892] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8637), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8641), 1,
      anon_sym_and,
    ACTIONS(6065), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6067), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [158943] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8685), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8314), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6611), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6613), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [159087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6627), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6629), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [159134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6681), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6683), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [159181] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 1,
      anon_sym_LBRACE,
    ACTIONS(8219), 1,
      anon_sym_LPAREN2,
    STATE(5555), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6152), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6154), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [159234] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8687), 1,
      anon_sym_COMMA,
    ACTIONS(8689), 1,
      anon_sym_RBRACE,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8210), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159331] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    ACTIONS(8691), 1,
      anon_sym_GT2,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    STATE(8333), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159428] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 1,
      anon_sym_LBRACE,
    ACTIONS(8219), 1,
      anon_sym_LPAREN2,
    STATE(5598), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6178), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6180), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [159481] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    ACTIONS(8693), 1,
      anon_sym_COMMA,
    ACTIONS(8695), 1,
      anon_sym_RBRACK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8042), 1,
      aux_sym_lambda_capture_specifier_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159578] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8681), 1,
      anon_sym_COMMA,
    ACTIONS(8697), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8156), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159675] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8699), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8214), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159772] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8645), 1,
      anon_sym_COMMA,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    ACTIONS(8701), 1,
      anon_sym_RBRACK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8200), 1,
      aux_sym_subscript_argument_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159869] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8703), 1,
      anon_sym_COMMA,
    ACTIONS(8705), 1,
      anon_sym_RBRACE,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8336), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159966] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    ACTIONS(8707), 1,
      anon_sym_GT2,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    STATE(8230), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5292), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5294), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [160110] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    ACTIONS(8709), 1,
      anon_sym_GT2,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    STATE(7952), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160207] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8389), 1,
      anon_sym_SLASH,
    ACTIONS(8395), 1,
      anon_sym_PIPE,
    ACTIONS(8399), 1,
      anon_sym_AMP,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8411), 1,
      anon_sym_QMARK,
    ACTIONS(8413), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8415), 1,
      anon_sym_bitor,
    ACTIONS(8417), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8387), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8391), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8393), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8397), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8401), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8711), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [160300] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8713), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8254), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160397] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8111), 1,
      anon_sym_STAR,
    ACTIONS(8113), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8115), 1,
      anon_sym_AMP,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6825), 1,
      sym__abstract_declarator,
    STATE(5344), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6965), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [160466] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8715), 1,
      anon_sym_COMMA,
    ACTIONS(8717), 1,
      anon_sym_RBRACE,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(7959), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6669), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6671), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [160610] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8719), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8115), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160707] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8721), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8352), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5296), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5298), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [160851] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    ACTIONS(8723), 1,
      anon_sym_GT2,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    STATE(8161), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160948] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8725), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(7968), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5292), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5294), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [161092] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8111), 1,
      anon_sym_STAR,
    ACTIONS(8113), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8115), 1,
      anon_sym_AMP,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6826), 1,
      sym__abstract_declarator,
    STATE(5344), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8727), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [161161] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8111), 1,
      anon_sym_STAR,
    ACTIONS(8113), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8115), 1,
      anon_sym_AMP,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6829), 1,
      sym__abstract_declarator,
    STATE(5344), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6235), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [161230] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8729), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8208), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161327] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    ACTIONS(8731), 1,
      anon_sym_GT2,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    STATE(8256), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161424] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    ACTIONS(8693), 1,
      anon_sym_COMMA,
    ACTIONS(8733), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8735), 1,
      anon_sym_RBRACK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8124), 1,
      aux_sym_lambda_capture_specifier_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5332), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5334), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [161568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5324), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5326), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [161615] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8183), 1,
      anon_sym_STAR,
    ACTIONS(8185), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8187), 1,
      anon_sym_AMP,
    ACTIONS(8201), 1,
      sym_auto,
    ACTIONS(8203), 1,
      anon_sym_decltype,
    STATE(3115), 1,
      sym_decltype_auto,
    STATE(4378), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7192), 1,
      sym__abstract_declarator,
    STATE(5611), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8297), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [161690] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 1,
      anon_sym_LBRACE,
    ACTIONS(8219), 1,
      anon_sym_LPAREN2,
    STATE(5606), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6185), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6187), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [161743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6527), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6529), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [161790] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8459), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(5630), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5631), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6670), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(8457), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [161847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6543), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6545), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [161894] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8645), 1,
      anon_sym_COMMA,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    ACTIONS(8737), 1,
      anon_sym_RBRACK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8152), 1,
      aux_sym_subscript_argument_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161991] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    ACTIONS(8739), 1,
      anon_sym_GT2,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    STATE(8280), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5300), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5302), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [162135] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8741), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(7957), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6599), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6601), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [162279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5320), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5322), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [162326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6603), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6605), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [162373] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    ACTIONS(8693), 1,
      anon_sym_COMMA,
    ACTIONS(8743), 1,
      anon_sym_RBRACK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8124), 1,
      aux_sym_lambda_capture_specifier_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6631), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6633), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [162517] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    ACTIONS(8745), 1,
      anon_sym_GT2,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    STATE(8216), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6488), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6490), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [162661] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8529), 1,
      anon_sym_RBRACE,
    ACTIONS(8747), 1,
      anon_sym_COMMA,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8147), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162758] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    ACTIONS(8749), 1,
      anon_sym_GT2,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    STATE(8110), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4037), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4033), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [162902] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    ACTIONS(8751), 1,
      anon_sym_GT2,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    STATE(8189), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6539), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6541), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [163046] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8389), 1,
      anon_sym_SLASH,
    ACTIONS(8395), 1,
      anon_sym_PIPE,
    ACTIONS(8399), 1,
      anon_sym_AMP,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8411), 1,
      anon_sym_QMARK,
    ACTIONS(8413), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8415), 1,
      anon_sym_bitor,
    ACTIONS(8417), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8387), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8391), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8393), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8397), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6907), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
    ACTIONS(8401), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5324), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5326), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [163186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5314), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [163233] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    ACTIONS(8753), 1,
      anon_sym_GT2,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    STATE(8078), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5314), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [163377] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8755), 1,
      anon_sym_COMMA,
    ACTIONS(8757), 1,
      anon_sym_RBRACE,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8198), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6639), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6641), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [163521] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8759), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8034), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163618] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8097), 1,
      anon_sym_STAR,
    ACTIONS(8099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8101), 1,
      anon_sym_AMP,
    STATE(4341), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6845), 1,
      sym__abstract_declarator,
    STATE(5571), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6965), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [163687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5332), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5334), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [163734] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5328), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5330), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [163781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5288), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5290), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [163828] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8761), 1,
      anon_sym_COMMA,
    ACTIONS(8763), 1,
      anon_sym_RBRACE,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8183), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5308), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5310), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [163972] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    ACTIONS(8765), 1,
      anon_sym_GT2,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    STATE(8301), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164069] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8681), 1,
      anon_sym_COMMA,
    ACTIONS(8767), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8309), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164166] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8681), 1,
      anon_sym_COMMA,
    ACTIONS(8769), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8008), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164263] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8771), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8058), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164360] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8773), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8141), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5320), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5322), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [164504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5300), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5302), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [164551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6659), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6661), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [164598] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8097), 1,
      anon_sym_STAR,
    ACTIONS(8099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8101), 1,
      anon_sym_AMP,
    STATE(4341), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6884), 1,
      sym__abstract_declarator,
    STATE(5571), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8727), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [164667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6663), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6665), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [164714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5314), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [164761] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    ACTIONS(8775), 1,
      anon_sym_GT2,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    STATE(8181), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6691), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6693), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [164905] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8777), 1,
      anon_sym_COMMA,
    ACTIONS(8779), 1,
      anon_sym_RBRACE,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8191), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165002] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    ACTIONS(8781), 1,
      anon_sym_GT2,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    STATE(8322), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165099] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8389), 1,
      anon_sym_SLASH,
    ACTIONS(8395), 1,
      anon_sym_PIPE,
    ACTIONS(8399), 1,
      anon_sym_AMP,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8413), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8415), 1,
      anon_sym_bitor,
    ACTIONS(8417), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8387), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8391), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8393), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8397), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8401), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6930), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [165188] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8183), 1,
      anon_sym_STAR,
    ACTIONS(8185), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8187), 1,
      anon_sym_AMP,
    ACTIONS(8201), 1,
      sym_auto,
    ACTIONS(8203), 1,
      anon_sym_decltype,
    STATE(3115), 1,
      sym_decltype_auto,
    STATE(4378), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7182), 1,
      sym__abstract_declarator,
    STATE(5544), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8299), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [165263] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8097), 1,
      anon_sym_STAR,
    ACTIONS(8099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8101), 1,
      anon_sym_AMP,
    STATE(4341), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6883), 1,
      sym__abstract_declarator,
    STATE(5571), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6235), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [165332] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8783), 1,
      anon_sym_COMMA,
    ACTIONS(8785), 1,
      anon_sym_RBRACE,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8054), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165429] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    ACTIONS(8787), 1,
      anon_sym_GT2,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    STATE(8342), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165526] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(4296), 1,
      anon_sym_LPAREN2,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6233), 1,
      anon_sym_LBRACK,
    ACTIONS(6438), 1,
      anon_sym_STAR,
    ACTIONS(6440), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6442), 1,
      anon_sym_AMP,
    STATE(4540), 1,
      sym_parameter_list,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7175), 1,
      sym__declarator,
    STATE(7469), 1,
      sym__abstract_declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    ACTIONS(8269), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [165613] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5169), 1,
      anon_sym_LBRACK,
    ACTIONS(5164), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5167), 4,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
    ACTIONS(5160), 32,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_operator,
  [165664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6699), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6701), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [165711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6687), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6689), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [165758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1966), 1,
      sym__fold_operator,
    ACTIONS(8791), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(8789), 25,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [165807] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    ACTIONS(8793), 1,
      anon_sym_GT2,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    STATE(8049), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5304), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5306), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [165951] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8389), 1,
      anon_sym_SLASH,
    ACTIONS(8395), 1,
      anon_sym_PIPE,
    ACTIONS(8399), 1,
      anon_sym_AMP,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8413), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8415), 1,
      anon_sym_bitor,
    ACTIONS(8417), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8387), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8391), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8393), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8397), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8401), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6903), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [166040] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8111), 1,
      anon_sym_STAR,
    ACTIONS(8113), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8115), 1,
      anon_sym_AMP,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6833), 1,
      sym__abstract_declarator,
    STATE(5344), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8795), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [166109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5308), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5310), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [166156] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8797), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8105), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166253] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8389), 1,
      anon_sym_SLASH,
    ACTIONS(8395), 1,
      anon_sym_PIPE,
    ACTIONS(8399), 1,
      anon_sym_AMP,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8411), 1,
      anon_sym_QMARK,
    ACTIONS(8413), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8415), 1,
      anon_sym_bitor,
    ACTIONS(8417), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8387), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8391), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8393), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8397), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6895), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
    ACTIONS(8401), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166346] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    ACTIONS(8799), 1,
      anon_sym_GT2,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    STATE(8362), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166443] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8389), 1,
      anon_sym_SLASH,
    ACTIONS(8395), 1,
      anon_sym_PIPE,
    ACTIONS(8399), 1,
      anon_sym_AMP,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8413), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8415), 1,
      anon_sym_bitor,
    ACTIONS(8417), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8387), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8391), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8393), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8397), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8401), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6952), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [166532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6579), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6581), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [166579] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8097), 1,
      anon_sym_STAR,
    ACTIONS(8099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8101), 1,
      anon_sym_AMP,
    STATE(4341), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6879), 1,
      sym__abstract_declarator,
    STATE(5571), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8795), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [166648] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8801), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8031), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166745] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8803), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(7985), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2265), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [166889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3176), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [166936] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8681), 1,
      anon_sym_COMMA,
    ACTIONS(8805), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8235), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2223), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2221), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [167080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6587), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6589), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [167127] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8527), 1,
      anon_sym_SEMI,
    ACTIONS(8807), 1,
      anon_sym_COMMA,
    ACTIONS(8810), 1,
      anon_sym_RBRACE,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167224] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8681), 1,
      anon_sym_COMMA,
    ACTIONS(8812), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8275), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167321] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8389), 1,
      anon_sym_SLASH,
    ACTIONS(8395), 1,
      anon_sym_PIPE,
    ACTIONS(8399), 1,
      anon_sym_AMP,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8411), 1,
      anon_sym_QMARK,
    ACTIONS(8413), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8415), 1,
      anon_sym_bitor,
    ACTIONS(8417), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8387), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8391), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8393), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8397), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6705), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
    ACTIONS(8401), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2265), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [167461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6583), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6585), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [167508] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(3399), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7448), 1,
      sym__abstract_declarator,
    ACTIONS(8141), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8143), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5046), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5868), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6223), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [167587] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8389), 1,
      anon_sym_SLASH,
    ACTIONS(8395), 1,
      anon_sym_PIPE,
    ACTIONS(8399), 1,
      anon_sym_AMP,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8413), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8415), 1,
      anon_sym_bitor,
    ACTIONS(8417), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8387), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8391), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8393), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8397), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8401), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6881), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [167676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6575), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6577), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [167723] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8389), 1,
      anon_sym_SLASH,
    ACTIONS(8395), 1,
      anon_sym_PIPE,
    ACTIONS(8399), 1,
      anon_sym_AMP,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8411), 1,
      anon_sym_QMARK,
    ACTIONS(8413), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8415), 1,
      anon_sym_bitor,
    ACTIONS(8417), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8387), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8391), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8393), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8397), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8401), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8814), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [167816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5284), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5286), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [167863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6655), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6657), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [167910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6496), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6498), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [167957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6703), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6705), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [168004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6651), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6653), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [168051] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8645), 1,
      anon_sym_COMMA,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    ACTIONS(8816), 1,
      anon_sym_RBRACK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(7983), 1,
      aux_sym_subscript_argument_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168148] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8681), 1,
      anon_sym_COMMA,
    ACTIONS(8818), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8018), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168245] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(3399), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8820), 1,
      anon_sym_STAR,
    ACTIONS(8822), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8824), 1,
      anon_sym_AMP,
    STATE(4540), 1,
      sym_parameter_list,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7467), 1,
      sym__abstract_declarator,
    ACTIONS(8141), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8143), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4770), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5894), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6235), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [168324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5304), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5306), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [168371] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    ACTIONS(8826), 1,
      anon_sym_GT2,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    STATE(8382), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168468] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(4296), 1,
      anon_sym_LPAREN2,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6233), 1,
      anon_sym_LBRACK,
    ACTIONS(6348), 1,
      anon_sym_STAR,
    ACTIONS(6350), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6352), 1,
      anon_sym_AMP,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7175), 1,
      sym__declarator,
    STATE(7473), 1,
      sym__abstract_declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    ACTIONS(8269), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [168555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6595), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6597), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [168602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6591), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6593), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [168649] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    ACTIONS(8828), 1,
      anon_sym_GT2,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    STATE(7971), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168746] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8075), 1,
      anon_sym_STAR,
    ACTIONS(8077), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8079), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    STATE(4132), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6815), 1,
      sym__abstract_declarator,
    STATE(5571), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8727), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [168815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6571), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6573), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [168862] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8075), 1,
      anon_sym_STAR,
    ACTIONS(8077), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8079), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    STATE(4132), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6816), 1,
      sym__abstract_declarator,
    STATE(5571), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6235), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [168931] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8075), 1,
      anon_sym_STAR,
    ACTIONS(8077), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8079), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    STATE(4132), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6818), 1,
      sym__abstract_declarator,
    STATE(5571), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8795), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [169000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6567), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6569), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [169047] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8629), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6565), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [169189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6535), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6537), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [169236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6531), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6533), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [169283] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8830), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(7963), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169380] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 1,
      anon_sym_LBRACE,
    ACTIONS(8219), 1,
      anon_sym_LPAREN2,
    STATE(5588), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6189), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6191), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [169433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6695), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6697), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [169480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6500), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6502), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [169527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6523), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6525), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [169574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2223), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2221), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [169621] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8834), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8832), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6492), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6494), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [169763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5328), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5330), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [169810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5316), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5318), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [169857] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(3399), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8820), 1,
      anon_sym_STAR,
    ACTIONS(8822), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8824), 1,
      anon_sym_AMP,
    STATE(4540), 1,
      sym_parameter_list,
    STATE(4993), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7474), 1,
      sym__abstract_declarator,
    ACTIONS(8141), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8143), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5185), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5892), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6223), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [169936] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8389), 1,
      anon_sym_SLASH,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8387), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6410), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [170005] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8389), 1,
      anon_sym_SLASH,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8387), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6410), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [170072] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8389), 1,
      anon_sym_SLASH,
    ACTIONS(8413), 1,
      anon_sym_LT_EQ_GT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8387), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6410), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [170143] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8389), 1,
      anon_sym_SLASH,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8413), 1,
      anon_sym_LT_EQ_GT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6410), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8387), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [170218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5288), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5290), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [170265] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8389), 1,
      anon_sym_SLASH,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8413), 1,
      anon_sym_LT_EQ_GT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6410), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8387), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8401), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [170342] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8836), 1,
      anon_sym_RPAREN,
    ACTIONS(8838), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [170439] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8681), 1,
      anon_sym_COMMA,
    ACTIONS(8840), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    STATE(8019), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [170536] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6410), 1,
      anon_sym_PIPE,
    ACTIONS(8389), 1,
      anon_sym_SLASH,
    ACTIONS(8399), 1,
      anon_sym_AMP,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8413), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8417), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8387), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8401), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [170617] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6410), 1,
      anon_sym_PIPE,
    ACTIONS(8389), 1,
      anon_sym_SLASH,
    ACTIONS(8399), 1,
      anon_sym_AMP,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8413), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8417), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8387), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8397), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8401), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [170700] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8389), 1,
      anon_sym_SLASH,
    ACTIONS(8395), 1,
      anon_sym_PIPE,
    ACTIONS(8399), 1,
      anon_sym_AMP,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8413), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8415), 1,
      anon_sym_bitor,
    ACTIONS(8417), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8387), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8397), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8401), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [170785] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8389), 1,
      anon_sym_SLASH,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8387), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6410), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [170850] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8389), 1,
      anon_sym_SLASH,
    ACTIONS(8395), 1,
      anon_sym_PIPE,
    ACTIONS(8399), 1,
      anon_sym_AMP,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8413), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8415), 1,
      anon_sym_bitor,
    ACTIONS(8417), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8387), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8393), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8397), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8401), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
  [170937] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6410), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [171009] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6903), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [171097] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8842), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [171191] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4878), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6020), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8844), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6018), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [171241] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT2,
  [171325] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5228), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5481), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8846), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5483), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [171375] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6930), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [171463] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6705), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [171555] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6410), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [171619] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8880), 1,
      anon_sym_LT,
    STATE(5551), 1,
      sym_template_argument_list,
    ACTIONS(5835), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4272), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [171671] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8882), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [171765] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
  [171851] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [171935] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8884), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172029] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8629), 1,
      anon_sym_COLON,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    ACTIONS(8886), 1,
      anon_sym_COMMA,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172123] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8888), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172217] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6952), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [172305] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8890), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172399] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5313), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6109), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8892), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6107), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [172449] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8894), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172543] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6952), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172631] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6410), 1,
      anon_sym_PIPE,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [172713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6975), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6977), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [172759] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5315), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6136), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8896), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6134), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [172809] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8898), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172903] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6410), 1,
      anon_sym_PIPE,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [172983] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8900), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [173077] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8902), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [173169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6981), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [173215] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6410), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [173291] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6410), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [173365] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6410), 1,
      anon_sym_PIPE,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_GT2,
  [173447] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8904), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [173541] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4878), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6034), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8844), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6032), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [173591] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8906), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [173683] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6410), 1,
      anon_sym_PIPE,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_GT2,
  [173763] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8906), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [173855] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(6410), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_GT2,
  [173931] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(6907), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [174023] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8908), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [174117] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6410), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [174187] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6410), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [174253] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    ACTIONS(8886), 1,
      anon_sym_COMMA,
    ACTIONS(8910), 1,
      anon_sym_COLON,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [174347] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8912), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [174441] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(6410), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [174515] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6410), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6412), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [174575] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6410), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [174643] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8914), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [174737] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6410), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [174805] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6881), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [174893] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6444), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6446), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [174951] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8133), 1,
      anon_sym_STAR,
    ACTIONS(8135), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8137), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    STATE(3938), 1,
      sym_parameter_list,
    STATE(6955), 1,
      sym__abstract_declarator,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(5876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8795), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [175019] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6410), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [175079] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6881), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [175167] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6410), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [175233] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8810), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [175325] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6460), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6462), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [175385] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    ACTIONS(8886), 1,
      anon_sym_COMMA,
    ACTIONS(8916), 1,
      anon_sym_COLON,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [175479] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6410), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [175549] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8121), 1,
      sym_auto,
    ACTIONS(8123), 1,
      anon_sym_decltype,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8263), 1,
      anon_sym_STAR,
    ACTIONS(8265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8267), 1,
      anon_sym_AMP,
    STATE(2285), 1,
      sym_decltype_auto,
    STATE(4425), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7229), 1,
      sym__abstract_declarator,
    STATE(5652), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8299), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [175623] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6410), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [175697] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6410), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [175773] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6410), 1,
      anon_sym_PIPE,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [175853] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    ACTIONS(8886), 1,
      anon_sym_COMMA,
    ACTIONS(8918), 1,
      anon_sym_COLON,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [175947] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(6410), 1,
      anon_sym_PIPE,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [176029] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [176113] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
  [176199] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8920), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176293] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8838), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176387] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8922), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176479] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6930), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [176567] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6410), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [176631] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8924), 1,
      anon_sym_COMMA,
    ACTIONS(8926), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176725] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8928), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176819] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6895), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176911] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8631), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177003] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6460), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6462), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [177063] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6410), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6412), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [177129] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8930), 1,
      anon_sym_COMMA,
    ACTIONS(8932), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177223] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6705), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177315] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8221), 1,
      anon_sym_LBRACK,
    STATE(5481), 1,
      sym_new_declarator,
    ACTIONS(6289), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6291), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [177365] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6895), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177457] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8934), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177549] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    ACTIONS(8886), 1,
      anon_sym_COMMA,
    ACTIONS(8936), 1,
      anon_sym_COLON,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177643] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6903), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [177731] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8938), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177825] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8940), 1,
      anon_sym_COMMA,
    ACTIONS(8942), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177919] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6907), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [178011] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4878), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6105), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8844), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6103), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [178061] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [178153] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4878), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6092), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8844), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6090), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [178203] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    ACTIONS(8886), 1,
      anon_sym_COMMA,
    ACTIONS(8946), 1,
      anon_sym_COLON,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [178297] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6393), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6395), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [178357] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5167), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(5169), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5162), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [178405] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8880), 1,
      anon_sym_LT,
    STATE(5551), 1,
      sym_template_argument_list,
    ACTIONS(5129), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5136), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [178457] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6952), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [178545] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6410), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [178615] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5228), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5724), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8846), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5726), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [178665] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6903), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [178753] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6907), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [178845] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8121), 1,
      sym_auto,
    ACTIONS(8123), 1,
      anon_sym_decltype,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8263), 1,
      anon_sym_STAR,
    ACTIONS(8265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8267), 1,
      anon_sym_AMP,
    STATE(2285), 1,
      sym_decltype_auto,
    STATE(4425), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7262), 1,
      sym__abstract_declarator,
    STATE(5632), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8297), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [178919] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8948), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [179013] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6389), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6391), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [179073] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7190), 1,
      anon_sym_LBRACE,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8950), 1,
      anon_sym_COLON,
    STATE(3072), 1,
      sym_attribute_specifier,
    STATE(4538), 1,
      sym__enum_base_clause,
    STATE(4629), 1,
      sym_enumerator_list,
    ACTIONS(6334), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6336), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [179131] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8952), 1,
      anon_sym_COMMA,
    ACTIONS(8954), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [179225] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8956), 1,
      anon_sym_COMMA,
    ACTIONS(8958), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [179319] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8277), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [179411] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [179505] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6448), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6450), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [179563] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8964), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [179657] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6881), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [179745] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8832), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [179837] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6412), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_GT2,
  [179923] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8527), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [180017] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8966), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [180111] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8968), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [180203] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8970), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [180297] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(4296), 1,
      anon_sym_LPAREN2,
    ACTIONS(4298), 1,
      anon_sym_STAR,
    ACTIONS(4300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4302), 1,
      anon_sym_AMP,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(6233), 1,
      anon_sym_LBRACK,
    ACTIONS(6516), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8269), 1,
      anon_sym_RPAREN,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6657), 1,
      sym__scope_resolution,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7224), 1,
      sym__declarator,
    STATE(7473), 1,
      sym__abstract_declarator,
    STATE(9597), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [180383] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    ACTIONS(8886), 1,
      anon_sym_COMMA,
    ACTIONS(8972), 1,
      anon_sym_COLON,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [180477] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8977), 1,
      anon_sym_const,
    ACTIONS(5430), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(5344), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8974), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(5432), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [180529] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8980), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [180623] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8902), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [180715] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8906), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [180807] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(6895), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [180899] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8982), 1,
      anon_sym_COMMA,
    ACTIONS(8984), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [180993] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8906), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [181085] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6930), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [181173] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    ACTIONS(8886), 1,
      anon_sym_COMMA,
    ACTIONS(8986), 1,
      anon_sym_COLON,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [181267] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6410), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6412), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [181331] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    ACTIONS(8886), 1,
      anon_sym_COMMA,
    ACTIONS(8988), 1,
      anon_sym_COLON,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [181425] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8133), 1,
      anon_sym_STAR,
    ACTIONS(8135), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8137), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    STATE(3938), 1,
      sym_parameter_list,
    STATE(6942), 1,
      sym__abstract_declarator,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(5876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6235), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [181493] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    ACTIONS(7499), 1,
      anon_sym_LBRACK,
    ACTIONS(7513), 1,
      anon_sym_DOT,
    ACTIONS(8586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8594), 1,
      anon_sym_SLASH,
    ACTIONS(8600), 1,
      anon_sym_PIPE,
    ACTIONS(8604), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_LT_LT,
    ACTIONS(8612), 1,
      anon_sym_GT_GT,
    ACTIONS(8614), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8618), 1,
      anon_sym_bitor,
    ACTIONS(8620), 1,
      anon_sym_bitand,
    STATE(4227), 1,
      sym_argument_list,
    STATE(4308), 1,
      sym_subscript_argument_list,
    ACTIONS(6705), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(7515), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8590), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8596), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8598), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8602), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8622), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8606), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8608), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [181585] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8133), 1,
      anon_sym_STAR,
    ACTIONS(8135), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8137), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    STATE(3938), 1,
      sym_parameter_list,
    STATE(6940), 1,
      sym__abstract_declarator,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(5876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8727), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [181653] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8133), 1,
      anon_sym_STAR,
    ACTIONS(8135), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8137), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    STATE(3938), 1,
      sym_parameter_list,
    STATE(6934), 1,
      sym__abstract_declarator,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(5876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6965), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [181721] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    ACTIONS(8886), 1,
      anon_sym_COMMA,
    ACTIONS(8990), 1,
      anon_sym_COLON,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [181815] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    ACTIONS(8886), 1,
      anon_sym_COMMA,
    ACTIONS(8992), 1,
      anon_sym_COLON,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [181909] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8994), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [182001] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8996), 1,
      anon_sym_COMMA,
    ACTIONS(8998), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [182095] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    ACTIONS(8886), 1,
      anon_sym_COMMA,
    ACTIONS(9000), 1,
      anon_sym_COLON,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [182189] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    ACTIONS(8886), 1,
      anon_sym_COMMA,
    ACTIONS(9002), 1,
      anon_sym_COLON,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [182283] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 1,
      sym_literal_suffix,
    ACTIONS(5797), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5799), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [182331] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 1,
      sym_literal_suffix,
    ACTIONS(4256), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(4248), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [182379] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9004), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [182473] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6393), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6395), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [182533] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6389), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6391), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [182593] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6444), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6446), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [182651] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    ACTIONS(8886), 1,
      anon_sym_COMMA,
    ACTIONS(9006), 1,
      anon_sym_COLON,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [182745] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5180), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5862), 1,
      anon_sym_LPAREN2,
    ACTIONS(5865), 1,
      anon_sym_LBRACK,
    ACTIONS(4256), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(4248), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [182797] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9008), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [182891] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7190), 1,
      anon_sym_LBRACE,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8950), 1,
      anon_sym_COLON,
    STATE(3128), 1,
      sym_attribute_specifier,
    STATE(4488), 1,
      sym__enum_base_clause,
    STATE(4601), 1,
      sym_enumerator_list,
    ACTIONS(6280), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6282), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [182949] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    ACTIONS(8886), 1,
      anon_sym_COMMA,
    ACTIONS(9010), 1,
      anon_sym_COLON,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [183043] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9012), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [183135] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6448), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6450), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [183193] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9014), 1,
      anon_sym_COMMA,
    ACTIONS(9016), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [183287] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8880), 1,
      anon_sym_LT,
    STATE(5551), 1,
      sym_template_argument_list,
    STATE(5619), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4246), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8643), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4254), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [183343] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    ACTIONS(8886), 1,
      anon_sym_COMMA,
    ACTIONS(9018), 1,
      anon_sym_COLON,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [183437] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9020), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [183529] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(9024), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(5344), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(9022), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [183580] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8162), 1,
      anon_sym_STAR,
    ACTIONS(8164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8166), 1,
      anon_sym_AMP,
    STATE(4342), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7054), 1,
      sym__abstract_declarator,
    STATE(5344), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8795), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [183647] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9026), 1,
      anon_sym_COMMA,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [183738] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4873), 1,
      anon_sym_RBRACK,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [183829] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5025), 1,
      anon_sym_RBRACK,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [183920] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9028), 1,
      anon_sym_COMMA,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [184011] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    ACTIONS(9030), 1,
      anon_sym_COLON,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [184102] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9032), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [184193] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9034), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [184284] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9036), 1,
      anon_sym_COMMA,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [184375] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(6007), 1,
      sym_ms_call_modifier,
    STATE(6456), 1,
      sym__declarator,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(8253), 1,
      sym_init_declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2091), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [184456] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9038), 1,
      anon_sym_COMMA,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [184547] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9040), 1,
      anon_sym_COMMA,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [184638] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9042), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [184729] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(8834), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [184820] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9044), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [184911] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    ACTIONS(9046), 1,
      anon_sym_RBRACK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [185002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6981), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [185047] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9048), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [185138] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    ACTIONS(9050), 1,
      anon_sym_RBRACK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [185229] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9052), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [185320] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9054), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [185411] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9056), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [185502] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9058), 1,
      anon_sym_COMMA,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [185593] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9060), 1,
      anon_sym_COMMA,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [185684] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6324), 1,
      sym_literal_suffix,
    ACTIONS(5797), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5799), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [185731] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(6047), 1,
      sym_ms_call_modifier,
    STATE(6499), 1,
      sym__declarator,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(8055), 1,
      sym_init_declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2091), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [185812] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9062), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [185903] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9064), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [185994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6975), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6977), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [186039] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4941), 1,
      anon_sym_RBRACK,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [186130] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9066), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [186221] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(6020), 1,
      sym_ms_call_modifier,
    STATE(6480), 1,
      sym__declarator,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(8289), 1,
      sym_init_declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2091), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [186302] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(6059), 1,
      sym_ms_call_modifier,
    STATE(6506), 1,
      sym__declarator,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(8102), 1,
      sym_init_declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2091), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [186383] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4877), 1,
      anon_sym_RBRACK,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [186474] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9068), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [186565] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9070), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [186656] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9072), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [186747] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4892), 1,
      anon_sym_RBRACK,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [186838] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    ACTIONS(9074), 1,
      anon_sym_RBRACK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [186929] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5018), 1,
      anon_sym_RBRACK,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [187020] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9076), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [187111] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9078), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [187202] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9080), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [187293] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9082), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [187384] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4875), 1,
      anon_sym_RBRACK,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [187475] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8459), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(5344), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(8457), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [187526] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9084), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [187617] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9086), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [187708] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9088), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [187799] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9090), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [187890] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4958), 1,
      anon_sym_RBRACK,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [187981] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_RBRACK,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [188072] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    ACTIONS(9092), 1,
      anon_sym_RBRACK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [188163] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9094), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [188254] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    ACTIONS(9096), 1,
      anon_sym_RBRACK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [188345] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9098), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [188436] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9100), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [188527] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    ACTIONS(9102), 1,
      anon_sym_COLON,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [188618] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4956), 1,
      anon_sym_RBRACK,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [188709] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9104), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [188800] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(5963), 1,
      sym_ms_call_modifier,
    STATE(6486), 1,
      sym__declarator,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(7960), 1,
      sym_init_declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2091), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [188881] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9106), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [188972] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9108), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [189063] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9110), 1,
      anon_sym_RBRACE,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [189154] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8173), 1,
      anon_sym_STAR,
    ACTIONS(8175), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8177), 1,
      anon_sym_AMP,
    STATE(4321), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7078), 1,
      sym__abstract_declarator,
    STATE(5571), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6235), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [189221] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    ACTIONS(9112), 1,
      anon_sym_RBRACK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [189312] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9114), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [189403] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_RBRACK,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [189494] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4849), 1,
      anon_sym_RBRACK,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [189585] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9116), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [189676] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(6235), 1,
      anon_sym_COLON,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8566), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8572), 1,
      anon_sym_const,
    ACTIONS(9118), 1,
      anon_sym_STAR,
    ACTIONS(9120), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9122), 1,
      anon_sym_AMP,
    STATE(4696), 1,
      sym_parameter_list,
    STATE(6148), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7622), 1,
      sym__abstract_declarator,
    ACTIONS(8568), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8570), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6046), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8564), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [189753] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym_RBRACK,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [189844] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    ACTIONS(9124), 1,
      anon_sym_RBRACK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [189935] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9126), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [190026] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(5984), 1,
      sym_ms_call_modifier,
    STATE(6476), 1,
      sym__declarator,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(8024), 1,
      sym_init_declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2091), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [190107] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9128), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [190198] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9130), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [190289] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(6005), 1,
      sym_ms_call_modifier,
    STATE(6468), 1,
      sym__declarator,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(8039), 1,
      sym_init_declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2091), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [190370] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9132), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [190461] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9134), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [190552] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9136), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [190643] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2021), 1,
      anon_sym_enum,
    ACTIONS(2023), 1,
      anon_sym_class,
    ACTIONS(2025), 1,
      anon_sym_struct,
    ACTIONS(2027), 1,
      anon_sym_union,
    ACTIONS(2053), 1,
      anon_sym_typename,
    ACTIONS(5105), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9138), 1,
      sym_identifier,
    ACTIONS(9140), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9144), 1,
      anon_sym_EQ,
    STATE(2899), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3054), 1,
      sym__type_specifier,
    STATE(3140), 1,
      sym_decltype_auto,
    STATE(3282), 1,
      sym_primitive_type,
    STATE(3893), 1,
      sym_qualified_type_identifier,
    STATE(7326), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    ACTIONS(9142), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(3039), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(53), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3087), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [190732] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9146), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [190823] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9148), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [190914] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4925), 1,
      anon_sym_RBRACK,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [191005] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9150), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [191096] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(6983), 1,
      sym_auto,
    ACTIONS(6985), 1,
      anon_sym_decltype,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8291), 1,
      anon_sym_STAR,
    ACTIONS(8293), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    STATE(3402), 1,
      sym_decltype_auto,
    STATE(4537), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7284), 1,
      sym__abstract_declarator,
    STATE(5695), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8297), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [191169] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_RBRACK,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [191260] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4943), 1,
      anon_sym_RBRACK,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [191351] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9152), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [191442] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9154), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [191533] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9156), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [191624] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9158), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [191715] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9160), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [191806] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4970), 1,
      anon_sym_RBRACK,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [191897] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9162), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [191988] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    ACTIONS(9164), 1,
      anon_sym_COLON,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [192079] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9166), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [192170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6364), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [192215] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6324), 1,
      sym_literal_suffix,
    ACTIONS(4256), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(4248), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [192262] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 1,
      anon_sym_RBRACK,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [192353] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9168), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [192444] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9170), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [192535] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9172), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [192626] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9174), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [192717] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9176), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [192808] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    ACTIONS(9178), 1,
      anon_sym_RBRACK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [192899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5653), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5655), 34,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [192944] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9180), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [193035] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8173), 1,
      anon_sym_STAR,
    ACTIONS(8175), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8177), 1,
      anon_sym_AMP,
    STATE(4321), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7110), 1,
      sym__abstract_declarator,
    STATE(5571), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8795), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [193102] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9182), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [193193] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(6223), 1,
      anon_sym_COLON,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8566), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8572), 1,
      anon_sym_const,
    ACTIONS(9118), 1,
      anon_sym_STAR,
    ACTIONS(9120), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9122), 1,
      anon_sym_AMP,
    STATE(4696), 1,
      sym_parameter_list,
    STATE(6148), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7593), 1,
      sym__abstract_declarator,
    ACTIONS(8568), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8570), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5453), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8564), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [193270] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    ACTIONS(9184), 1,
      anon_sym_COLON,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [193361] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9186), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [193452] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(6000), 1,
      sym_ms_call_modifier,
    STATE(6508), 1,
      sym__declarator,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(8108), 1,
      sym_init_declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2091), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [193533] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9188), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [193624] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9190), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [193715] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8162), 1,
      anon_sym_STAR,
    ACTIONS(8164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8166), 1,
      anon_sym_AMP,
    STATE(4342), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7066), 1,
      sym__abstract_declarator,
    STATE(5344), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6965), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [193782] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9192), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [193873] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9194), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [193964] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(5982), 1,
      sym_ms_call_modifier,
    STATE(6460), 1,
      sym__declarator,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(8070), 1,
      sym_init_declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2091), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [194045] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8162), 1,
      anon_sym_STAR,
    ACTIONS(8164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8166), 1,
      anon_sym_AMP,
    STATE(4342), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7063), 1,
      sym__abstract_declarator,
    STATE(5344), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8727), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [194112] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9196), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [194203] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9198), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [194294] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8173), 1,
      anon_sym_STAR,
    ACTIONS(8175), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8177), 1,
      anon_sym_AMP,
    STATE(4321), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7102), 1,
      sym__abstract_declarator,
    STATE(5571), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6965), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [194361] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    ACTIONS(9200), 1,
      anon_sym_COLON,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [194452] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9202), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [194543] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4900), 1,
      anon_sym_RBRACK,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [194634] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8162), 1,
      anon_sym_STAR,
    ACTIONS(8164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8166), 1,
      anon_sym_AMP,
    STATE(4342), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7056), 1,
      sym__abstract_declarator,
    STATE(5344), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6235), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [194701] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9204), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [194792] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8852), 1,
      anon_sym_SLASH,
    ACTIONS(8858), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_AMP,
    ACTIONS(8868), 1,
      anon_sym_GT_EQ,
    ACTIONS(8872), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8874), 1,
      anon_sym_bitor,
    ACTIONS(8876), 1,
      anon_sym_bitand,
    ACTIONS(8878), 1,
      anon_sym_QMARK,
    ACTIONS(9206), 1,
      anon_sym_COLON,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(7477), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8848), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8854), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8856), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8860), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8864), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8866), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [194883] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4879), 1,
      anon_sym_RBRACK,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [194974] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9208), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [195065] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    ACTIONS(9210), 1,
      anon_sym_RBRACK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [195156] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4821), 1,
      anon_sym_RBRACK,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [195247] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9212), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [195338] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9214), 1,
      anon_sym_COMMA,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [195429] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    ACTIONS(8733), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9216), 1,
      anon_sym_RBRACK,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [195520] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9218), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [195611] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    STATE(5674), 1,
      sym_field_declaration_list,
    STATE(5771), 1,
      sym_attribute_specifier,
    STATE(7686), 1,
      sym_virtual_specifier,
    STATE(8521), 1,
      sym_base_class_clause,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5469), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5471), 25,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_try,
      anon_sym_requires,
  [195672] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(6983), 1,
      sym_auto,
    ACTIONS(6985), 1,
      anon_sym_decltype,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8291), 1,
      anon_sym_STAR,
    ACTIONS(8293), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    STATE(3402), 1,
      sym_decltype_auto,
    STATE(4537), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7282), 1,
      sym__abstract_declarator,
    STATE(5684), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8299), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [195745] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9222), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [195836] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9228), 1,
      anon_sym___attribute__,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(9226), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9224), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [195885] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    ACTIONS(9231), 1,
      anon_sym_SEMI,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [195976] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4996), 1,
      anon_sym_RBRACK,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8651), 1,
      anon_sym_SLASH,
    ACTIONS(8657), 1,
      anon_sym_PIPE,
    ACTIONS(8661), 1,
      anon_sym_AMP,
    ACTIONS(8667), 1,
      anon_sym_GT_EQ,
    ACTIONS(8673), 1,
      anon_sym_QMARK,
    ACTIONS(8675), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8677), 1,
      anon_sym_bitor,
    ACTIONS(8679), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8649), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8653), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8659), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8663), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8665), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [196067] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8173), 1,
      anon_sym_STAR,
    ACTIONS(8175), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8177), 1,
      anon_sym_AMP,
    STATE(4321), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7058), 1,
      sym__abstract_declarator,
    STATE(5571), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8727), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [196134] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(2671), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5958), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5182), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5960), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [196189] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(4296), 1,
      anon_sym_LPAREN2,
    ACTIONS(4298), 1,
      anon_sym_STAR,
    ACTIONS(4300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4302), 1,
      anon_sym_AMP,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(6233), 1,
      anon_sym_LBRACK,
    ACTIONS(6516), 1,
      anon_sym_COLON_COLON,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6657), 1,
      sym__scope_resolution,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7394), 1,
      sym__declarator,
    STATE(7621), 1,
      sym__abstract_declarator,
    STATE(9597), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [196272] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(5967), 1,
      sym_ms_call_modifier,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7256), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2091), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [196350] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5024), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6092), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(9233), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6090), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [196398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6523), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6525), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [196442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6587), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6589), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [196486] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8301), 1,
      sym_auto,
    ACTIONS(8303), 1,
      anon_sym_decltype,
    ACTIONS(8356), 1,
      anon_sym_STAR,
    ACTIONS(8358), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    STATE(4695), 1,
      sym_parameter_list,
    STATE(5784), 1,
      sym_decltype_auto,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7370), 1,
      sym__abstract_declarator,
    STATE(5755), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8299), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [196558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6492), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6494), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [196602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6531), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6533), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [196646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6599), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6601), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [196690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6595), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6597), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [196734] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4037), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4033), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [196778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6591), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6593), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [196822] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6056), 1,
      sym_ms_call_modifier,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7204), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2091), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [196900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5759), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5761), 33,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [196944] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8183), 1,
      anon_sym_STAR,
    ACTIONS(8185), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8187), 1,
      anon_sym_AMP,
    STATE(4378), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7186), 1,
      sym__abstract_declarator,
    STATE(5344), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8727), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [197010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6488), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6490), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [197054] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(6372), 1,
      anon_sym_LBRACK,
    ACTIONS(6376), 1,
      anon_sym_DOT,
    ACTIONS(8271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8493), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8509), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_QMARK,
    ACTIONS(8515), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitor,
    ACTIONS(8519), 1,
      anon_sym_bitand,
    STATE(2905), 1,
      sym_subscript_argument_list,
    STATE(2993), 1,
      sym_argument_list,
    ACTIONS(6378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8047), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8491), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8495), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8497), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8501), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8511), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8505), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8507), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [197142] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6089), 1,
      sym_ms_call_modifier,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7267), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2091), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [197220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6663), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6665), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [197264] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8301), 1,
      sym_auto,
    ACTIONS(8303), 1,
      anon_sym_decltype,
    ACTIONS(8356), 1,
      anon_sym_STAR,
    ACTIONS(8358), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    STATE(4695), 1,
      sym_parameter_list,
    STATE(5784), 1,
      sym_decltype_auto,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7331), 1,
      sym__abstract_declarator,
    STATE(5821), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8297), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [197336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6414), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6416), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [197380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5160), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5167), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [197424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6681), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6683), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [197468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6669), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6671), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [197512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6500), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6502), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [197556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6631), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6633), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [197600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6659), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6661), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [197644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6695), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6697), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [197688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6655), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6657), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [197732] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(3005), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5958), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5194), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5960), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [197786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6627), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6629), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [197830] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(9235), 1,
      anon_sym_LBRACE,
    ACTIONS(9237), 1,
      anon_sym_COLON,
    STATE(5624), 1,
      sym__enum_base_clause,
    STATE(5713), 1,
      sym_enumerator_list,
    STATE(5749), 1,
      sym_attribute_specifier,
    ACTIONS(6280), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6282), 27,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [197886] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(9239), 1,
      anon_sym___attribute__,
    ACTIONS(9241), 1,
      anon_sym_LBRACE,
    STATE(5825), 1,
      sym_field_declaration_list,
    STATE(5934), 1,
      sym_attribute_specifier,
    STATE(7913), 1,
      sym_virtual_specifier,
    STATE(8740), 1,
      sym_base_class_clause,
    ACTIONS(5469), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5471), 25,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [197946] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(3218), 1,
      anon_sym_STAR,
    ACTIONS(3220), 1,
      anon_sym_AMP,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(6516), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    STATE(5979), 1,
      sym_ms_call_modifier,
    STATE(6657), 1,
      sym__scope_resolution,
    STATE(7386), 1,
      sym__declarator,
    STATE(9597), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2091), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [198024] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8183), 1,
      anon_sym_STAR,
    ACTIONS(8185), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8187), 1,
      anon_sym_AMP,
    STATE(4378), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7184), 1,
      sym__abstract_declarator,
    STATE(5344), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6965), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [198090] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6022), 1,
      sym_ms_call_modifier,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7279), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2091), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [198168] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9243), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9245), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6006), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6008), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [198216] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5495), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5497), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [198262] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9245), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6065), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6067), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [198308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3322), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3320), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [198352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6571), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6573), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [198396] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9250), 1,
      anon_sym_const,
    ACTIONS(5430), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(5571), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9247), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(5432), 19,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [198446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5626), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5628), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [198492] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5626), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5628), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [198538] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6035), 1,
      sym_ms_call_modifier,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7215), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2091), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [198616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6456), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6458), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [198660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5606), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5608), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [198704] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7675), 1,
      anon_sym_DASH_GT,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9260), 1,
      anon_sym_requires,
    STATE(5777), 1,
      sym_ref_qualifier,
    STATE(6668), 1,
      sym__function_attributes_end,
    STATE(6765), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9257), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6110), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [198786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5115), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [198830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6539), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6541), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [198874] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7675), 1,
      anon_sym_DASH_GT,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7725), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    STATE(5724), 1,
      sym_ref_qualifier,
    STATE(6671), 1,
      sym__function_attributes_end,
    STATE(6799), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6118), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [198956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5150), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5152), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [199000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6651), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6653), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [199044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6703), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6705), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [199088] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6014), 1,
      sym_ms_call_modifier,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7200), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2091), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [199166] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(9235), 1,
      anon_sym_LBRACE,
    ACTIONS(9237), 1,
      anon_sym_COLON,
    STATE(5646), 1,
      sym__enum_base_clause,
    STATE(5709), 1,
      sym_enumerator_list,
    STATE(5729), 1,
      sym_attribute_specifier,
    ACTIONS(6334), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6336), 27,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [199222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5117), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5119), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [199266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6543), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6545), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [199310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6639), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6641), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [199354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5125), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5127), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [199398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5123), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [199442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6567), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6569), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [199486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6527), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6529), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [199530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5111), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [199574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6496), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6498), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [199618] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5618), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5724), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(9263), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5726), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [199666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3176), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [199710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6575), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6577), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [199754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6583), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6585), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [199798] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6082), 1,
      sym_ms_call_modifier,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7198), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2091), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [199876] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5024), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6105), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(9233), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6103), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [199924] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6085), 1,
      sym_ms_call_modifier,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7240), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2091), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [200002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6426), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6428), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [200046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6579), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6581), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [200090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6535), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6537), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [200134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6565), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [200178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6699), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6701), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [200222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6691), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6693), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [200266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5146), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5148), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [200310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6603), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6605), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [200354] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9265), 1,
      anon_sym_LT,
    STATE(2431), 1,
      sym_template_argument_list,
    STATE(2671), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4246), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5182), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4254), 25,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [200408] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8183), 1,
      anon_sym_STAR,
    ACTIONS(8185), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8187), 1,
      anon_sym_AMP,
    STATE(4378), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7188), 1,
      sym__abstract_declarator,
    STATE(5344), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8795), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [200474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6611), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6613), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [200518] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5532), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6136), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(9267), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6134), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [200566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6687), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6689), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [200610] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5600), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6109), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(9269), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6107), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [200658] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8183), 1,
      anon_sym_STAR,
    ACTIONS(8185), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8187), 1,
      anon_sym_AMP,
    STATE(4378), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7197), 1,
      sym__abstract_declarator,
    STATE(5344), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6235), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7667), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [200724] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(5976), 1,
      sym_ms_call_modifier,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7274), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2091), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [200802] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5024), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6020), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(9233), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6018), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [200850] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5024), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6034), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(9233), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6032), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [200898] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(9271), 1,
      sym_identifier,
    ACTIONS(9273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9277), 1,
      anon_sym_enum,
    ACTIONS(9279), 1,
      anon_sym_class,
    ACTIONS(9281), 1,
      anon_sym_struct,
    ACTIONS(9283), 1,
      anon_sym_union,
    ACTIONS(9285), 1,
      sym_auto,
    ACTIONS(9287), 1,
      anon_sym_decltype,
    ACTIONS(9289), 1,
      anon_sym_typename,
    STATE(3927), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4668), 1,
      sym_primitive_type,
    STATE(4678), 1,
      sym__type_specifier,
    STATE(4850), 1,
      sym_decltype_auto,
    STATE(4905), 1,
      sym_qualified_type_identifier,
    STATE(5805), 1,
      sym_argument_list,
    STATE(7337), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(4826), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7646), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9275), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4903), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [200983] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8263), 1,
      anon_sym_STAR,
    ACTIONS(8265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8267), 1,
      anon_sym_AMP,
    STATE(4425), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7254), 1,
      sym__abstract_declarator,
    STATE(5876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6965), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [201048] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(9291), 1,
      sym_identifier,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9295), 1,
      anon_sym_enum,
    ACTIONS(9297), 1,
      anon_sym_class,
    ACTIONS(9299), 1,
      anon_sym_struct,
    ACTIONS(9301), 1,
      anon_sym_union,
    ACTIONS(9303), 1,
      anon_sym_typename,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(4673), 1,
      sym__type_specifier,
    STATE(5775), 1,
      sym_argument_list,
    STATE(7347), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [201133] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(9305), 1,
      sym_identifier,
    ACTIONS(9307), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9311), 1,
      anon_sym_enum,
    ACTIONS(9313), 1,
      anon_sym_class,
    ACTIONS(9315), 1,
      anon_sym_struct,
    ACTIONS(9317), 1,
      anon_sym_union,
    ACTIONS(9319), 1,
      sym_auto,
    ACTIONS(9321), 1,
      anon_sym_decltype,
    ACTIONS(9323), 1,
      anon_sym_typename,
    STATE(2580), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2974), 1,
      sym_primitive_type,
    STATE(3043), 1,
      sym__type_specifier,
    STATE(3303), 1,
      sym_decltype_auto,
    STATE(3363), 1,
      sym_qualified_type_identifier,
    STATE(5762), 1,
      sym_argument_list,
    STATE(7340), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3229), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5971), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9309), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3293), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [201218] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(9235), 1,
      anon_sym_LBRACE,
    STATE(5686), 1,
      sym_enumerator_list,
    STATE(5817), 1,
      sym_attribute_specifier,
    ACTIONS(5952), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5954), 28,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [201269] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5432), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(8977), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(5430), 17,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [201316] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(9325), 1,
      sym_identifier,
    ACTIONS(9327), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9331), 1,
      anon_sym_enum,
    ACTIONS(9333), 1,
      anon_sym_class,
    ACTIONS(9335), 1,
      anon_sym_struct,
    ACTIONS(9337), 1,
      anon_sym_union,
    ACTIONS(9339), 1,
      sym_auto,
    ACTIONS(9341), 1,
      anon_sym_decltype,
    ACTIONS(9343), 1,
      anon_sym_typename,
    STATE(2692), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3151), 1,
      sym_primitive_type,
    STATE(3162), 1,
      sym__type_specifier,
    STATE(3555), 1,
      sym_qualified_type_identifier,
    STATE(3566), 1,
      sym_decltype_auto,
    STATE(5731), 1,
      sym_argument_list,
    STATE(7329), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3510), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(6077), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9329), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3565), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [201401] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(9291), 1,
      sym_identifier,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9295), 1,
      anon_sym_enum,
    ACTIONS(9297), 1,
      anon_sym_class,
    ACTIONS(9299), 1,
      anon_sym_struct,
    ACTIONS(9301), 1,
      anon_sym_union,
    ACTIONS(9303), 1,
      anon_sym_typename,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(4787), 1,
      sym__type_specifier,
    STATE(5725), 1,
      sym_argument_list,
    STATE(7347), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [201486] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(9305), 1,
      sym_identifier,
    ACTIONS(9307), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9311), 1,
      anon_sym_enum,
    ACTIONS(9313), 1,
      anon_sym_class,
    ACTIONS(9315), 1,
      anon_sym_struct,
    ACTIONS(9317), 1,
      anon_sym_union,
    ACTIONS(9319), 1,
      sym_auto,
    ACTIONS(9321), 1,
      anon_sym_decltype,
    ACTIONS(9323), 1,
      anon_sym_typename,
    STATE(2580), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2974), 1,
      sym_primitive_type,
    STATE(3045), 1,
      sym__type_specifier,
    STATE(3303), 1,
      sym_decltype_auto,
    STATE(3363), 1,
      sym_qualified_type_identifier,
    STATE(5765), 1,
      sym_argument_list,
    STATE(7340), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3229), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5971), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9309), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3293), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [201571] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(9345), 1,
      sym_identifier,
    ACTIONS(9347), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9351), 1,
      anon_sym_enum,
    ACTIONS(9353), 1,
      anon_sym_class,
    ACTIONS(9355), 1,
      anon_sym_struct,
    ACTIONS(9357), 1,
      anon_sym_union,
    ACTIONS(9359), 1,
      sym_auto,
    ACTIONS(9361), 1,
      anon_sym_decltype,
    ACTIONS(9363), 1,
      anon_sym_typename,
    STATE(2751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3174), 1,
      sym_primitive_type,
    STATE(3283), 1,
      sym__type_specifier,
    STATE(3747), 1,
      sym_decltype_auto,
    STATE(3825), 1,
      sym_qualified_type_identifier,
    STATE(5804), 1,
      sym_argument_list,
    STATE(7346), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3563), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(6197), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9349), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3746), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [201656] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9365), 1,
      anon_sym___attribute__,
    STATE(5630), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(9226), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9224), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [201703] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(9024), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(5571), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(9022), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [201752] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8263), 1,
      anon_sym_STAR,
    ACTIONS(8265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8267), 1,
      anon_sym_AMP,
    STATE(4425), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7226), 1,
      sym__abstract_declarator,
    STATE(5876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8795), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [201817] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9368), 1,
      anon_sym___attribute__,
    ACTIONS(9371), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9377), 1,
      anon_sym_requires,
    STATE(5855), 1,
      sym_ref_qualifier,
    STATE(6513), 1,
      sym_trailing_return_type,
    STATE(6548), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6139), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [201898] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    STATE(2247), 1,
      sym_attribute_specifier,
    STATE(6130), 1,
      sym_field_declaration_list,
    STATE(7750), 1,
      sym_virtual_specifier,
    STATE(8509), 1,
      sym_base_class_clause,
    ACTIONS(5471), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5469), 24,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [201957] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5618), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5481), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(9263), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5483), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [202004] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8121), 1,
      sym_auto,
    ACTIONS(8123), 1,
      anon_sym_decltype,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8558), 1,
      anon_sym_STAR,
    ACTIONS(8560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8562), 1,
      anon_sym_AMP,
    ACTIONS(8572), 1,
      anon_sym_const,
    STATE(2285), 1,
      sym_decltype_auto,
    STATE(4705), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7410), 1,
      sym__abstract_declarator,
    STATE(5843), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8297), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8564), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [202075] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(9380), 1,
      sym_identifier,
    ACTIONS(9382), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9386), 1,
      anon_sym_enum,
    ACTIONS(9388), 1,
      anon_sym_class,
    ACTIONS(9390), 1,
      anon_sym_struct,
    ACTIONS(9392), 1,
      anon_sym_union,
    ACTIONS(9394), 1,
      sym_auto,
    ACTIONS(9396), 1,
      anon_sym_decltype,
    ACTIONS(9398), 1,
      anon_sym_typename,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(3594), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4409), 1,
      sym_primitive_type,
    STATE(4513), 1,
      sym__type_specifier,
    STATE(4754), 1,
      sym_decltype_auto,
    STATE(5810), 1,
      sym_argument_list,
    STATE(7334), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(4724), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7259), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9384), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4758), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [202160] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(9400), 1,
      sym_identifier,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9406), 1,
      anon_sym_enum,
    ACTIONS(9408), 1,
      anon_sym_class,
    ACTIONS(9410), 1,
      anon_sym_struct,
    ACTIONS(9412), 1,
      anon_sym_union,
    ACTIONS(9414), 1,
      sym_auto,
    ACTIONS(9416), 1,
      anon_sym_decltype,
    ACTIONS(9418), 1,
      anon_sym_typename,
    STATE(2332), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2345), 1,
      sym__type_specifier,
    STATE(2743), 1,
      sym_qualified_type_identifier,
    STATE(2780), 1,
      sym_decltype_auto,
    STATE(2816), 1,
      sym_primitive_type,
    STATE(5732), 1,
      sym_argument_list,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2673), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5807), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9404), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2776), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [202245] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8121), 1,
      sym_auto,
    ACTIONS(8123), 1,
      anon_sym_decltype,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8558), 1,
      anon_sym_STAR,
    ACTIONS(8560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8562), 1,
      anon_sym_AMP,
    ACTIONS(8572), 1,
      anon_sym_const,
    STATE(2285), 1,
      sym_decltype_auto,
    STATE(4705), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7426), 1,
      sym__abstract_declarator,
    STATE(5834), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8299), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8564), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [202316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5628), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [202359] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9265), 1,
      anon_sym_LT,
    STATE(2431), 1,
      sym_template_argument_list,
    ACTIONS(5835), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4272), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [202408] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8459), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(5571), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(8457), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [202457] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9239), 1,
      anon_sym___attribute__,
    ACTIONS(9420), 1,
      anon_sym_LBRACE,
    ACTIONS(9422), 1,
      anon_sym_COLON,
    STATE(5756), 1,
      sym__enum_base_clause,
    STATE(5859), 1,
      sym_enumerator_list,
    STATE(5926), 1,
      sym_attribute_specifier,
    ACTIONS(6334), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6336), 27,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [202512] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(9291), 1,
      sym_identifier,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9295), 1,
      anon_sym_enum,
    ACTIONS(9297), 1,
      anon_sym_class,
    ACTIONS(9299), 1,
      anon_sym_struct,
    ACTIONS(9301), 1,
      anon_sym_union,
    ACTIONS(9303), 1,
      anon_sym_typename,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(4700), 1,
      sym__type_specifier,
    STATE(5818), 1,
      sym_argument_list,
    STATE(7347), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [202597] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9408), 1,
      anon_sym_class,
    ACTIONS(9410), 1,
      anon_sym_struct,
    ACTIONS(9412), 1,
      anon_sym_union,
    ACTIONS(9414), 1,
      sym_auto,
    ACTIONS(9416), 1,
      anon_sym_decltype,
    ACTIONS(9424), 1,
      sym_identifier,
    ACTIONS(9428), 1,
      anon_sym_enum,
    ACTIONS(9430), 1,
      anon_sym_typename,
    STATE(2401), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2411), 1,
      sym__type_specifier,
    STATE(2743), 1,
      sym_qualified_type_identifier,
    STATE(2780), 1,
      sym_decltype_auto,
    STATE(2813), 1,
      sym_primitive_type,
    STATE(5764), 1,
      sym_argument_list,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2673), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5807), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9426), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2776), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [202682] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(9235), 1,
      anon_sym_LBRACE,
    STATE(5672), 1,
      sym_enumerator_list,
    STATE(5767), 1,
      sym_attribute_specifier,
    ACTIONS(5980), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5982), 28,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [202733] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(9345), 1,
      sym_identifier,
    ACTIONS(9347), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9351), 1,
      anon_sym_enum,
    ACTIONS(9353), 1,
      anon_sym_class,
    ACTIONS(9355), 1,
      anon_sym_struct,
    ACTIONS(9357), 1,
      anon_sym_union,
    ACTIONS(9359), 1,
      sym_auto,
    ACTIONS(9361), 1,
      anon_sym_decltype,
    ACTIONS(9363), 1,
      anon_sym_typename,
    STATE(2751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3174), 1,
      sym_primitive_type,
    STATE(3286), 1,
      sym__type_specifier,
    STATE(3747), 1,
      sym_decltype_auto,
    STATE(3825), 1,
      sym_qualified_type_identifier,
    STATE(5797), 1,
      sym_argument_list,
    STATE(7346), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3563), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(6197), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9349), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3746), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [202818] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9239), 1,
      anon_sym___attribute__,
    ACTIONS(9420), 1,
      anon_sym_LBRACE,
    ACTIONS(9422), 1,
      anon_sym_COLON,
    STATE(5760), 1,
      sym__enum_base_clause,
    STATE(5847), 1,
      sym_enumerator_list,
    STATE(5939), 1,
      sym_attribute_specifier,
    ACTIONS(6280), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6282), 27,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [202873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5653), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5655), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [202916] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(9291), 1,
      sym_identifier,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9295), 1,
      anon_sym_enum,
    ACTIONS(9297), 1,
      anon_sym_class,
    ACTIONS(9299), 1,
      anon_sym_struct,
    ACTIONS(9301), 1,
      anon_sym_union,
    ACTIONS(9303), 1,
      anon_sym_typename,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(4733), 1,
      sym__type_specifier,
    STATE(5766), 1,
      sym_argument_list,
    STATE(7347), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [203001] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(3022), 1,
      sym_auto,
    ACTIONS(3024), 1,
      anon_sym_decltype,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(9432), 1,
      sym_identifier,
    ACTIONS(9434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9436), 1,
      anon_sym_enum,
    ACTIONS(9438), 1,
      anon_sym_class,
    ACTIONS(9440), 1,
      anon_sym_struct,
    ACTIONS(9442), 1,
      anon_sym_union,
    ACTIONS(9444), 1,
      anon_sym_typename,
    STATE(2651), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3059), 1,
      sym_primitive_type,
    STATE(3398), 1,
      sym_decltype_auto,
    STATE(3494), 1,
      sym_qualified_type_identifier,
    STATE(4821), 1,
      sym__type_specifier,
    STATE(5740), 1,
      sym_argument_list,
    STATE(7361), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3383), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2988), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2986), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3397), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [203086] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8263), 1,
      anon_sym_STAR,
    ACTIONS(8265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8267), 1,
      anon_sym_AMP,
    STATE(4425), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7268), 1,
      sym__abstract_declarator,
    STATE(5876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8727), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [203151] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(3022), 1,
      sym_auto,
    ACTIONS(3024), 1,
      anon_sym_decltype,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(9432), 1,
      sym_identifier,
    ACTIONS(9434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9436), 1,
      anon_sym_enum,
    ACTIONS(9438), 1,
      anon_sym_class,
    ACTIONS(9440), 1,
      anon_sym_struct,
    ACTIONS(9442), 1,
      anon_sym_union,
    ACTIONS(9444), 1,
      anon_sym_typename,
    STATE(2651), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3059), 1,
      sym_primitive_type,
    STATE(3398), 1,
      sym_decltype_auto,
    STATE(3494), 1,
      sym_qualified_type_identifier,
    STATE(4833), 1,
      sym__type_specifier,
    STATE(5727), 1,
      sym_argument_list,
    STATE(7361), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3383), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2988), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2986), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3397), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [203236] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(9271), 1,
      sym_identifier,
    ACTIONS(9273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9277), 1,
      anon_sym_enum,
    ACTIONS(9279), 1,
      anon_sym_class,
    ACTIONS(9281), 1,
      anon_sym_struct,
    ACTIONS(9283), 1,
      anon_sym_union,
    ACTIONS(9285), 1,
      sym_auto,
    ACTIONS(9287), 1,
      anon_sym_decltype,
    ACTIONS(9289), 1,
      anon_sym_typename,
    STATE(3927), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4668), 1,
      sym_primitive_type,
    STATE(4674), 1,
      sym__type_specifier,
    STATE(4850), 1,
      sym_decltype_auto,
    STATE(4905), 1,
      sym_qualified_type_identifier,
    STATE(5778), 1,
      sym_argument_list,
    STATE(7337), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(4826), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7646), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9275), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4903), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [203321] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9446), 1,
      anon_sym_LT,
    STATE(3195), 1,
      sym_template_argument_list,
    ACTIONS(5835), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4272), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [203370] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(9448), 1,
      sym_identifier,
    ACTIONS(9450), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9454), 1,
      anon_sym_enum,
    ACTIONS(9456), 1,
      anon_sym_class,
    ACTIONS(9458), 1,
      anon_sym_struct,
    ACTIONS(9460), 1,
      anon_sym_union,
    ACTIONS(9462), 1,
      sym_auto,
    ACTIONS(9464), 1,
      anon_sym_decltype,
    ACTIONS(9466), 1,
      anon_sym_typename,
    STATE(2896), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3365), 1,
      sym_primitive_type,
    STATE(3433), 1,
      sym__type_specifier,
    STATE(4030), 1,
      sym_decltype_auto,
    STATE(4032), 1,
      sym_qualified_type_identifier,
    STATE(5763), 1,
      sym_argument_list,
    STATE(7350), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3862), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(6470), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9452), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4034), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [203455] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9368), 1,
      anon_sym___attribute__,
    ACTIONS(9371), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5857), 1,
      sym_ref_qualifier,
    STATE(6527), 1,
      sym__function_attributes_end,
    STATE(6601), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6146), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [203536] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9468), 1,
      anon_sym_SEMI,
    ACTIONS(6681), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6683), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [203581] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(9400), 1,
      sym_identifier,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9406), 1,
      anon_sym_enum,
    ACTIONS(9408), 1,
      anon_sym_class,
    ACTIONS(9410), 1,
      anon_sym_struct,
    ACTIONS(9412), 1,
      anon_sym_union,
    ACTIONS(9414), 1,
      sym_auto,
    ACTIONS(9416), 1,
      anon_sym_decltype,
    ACTIONS(9418), 1,
      anon_sym_typename,
    STATE(2332), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2411), 1,
      sym__type_specifier,
    STATE(2743), 1,
      sym_qualified_type_identifier,
    STATE(2780), 1,
      sym_decltype_auto,
    STATE(2816), 1,
      sym_primitive_type,
    STATE(5781), 1,
      sym_argument_list,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2673), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5807), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9404), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2776), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [203666] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8263), 1,
      anon_sym_STAR,
    ACTIONS(8265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8267), 1,
      anon_sym_AMP,
    STATE(4425), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7276), 1,
      sym__abstract_declarator,
    STATE(5876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6235), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [203731] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9408), 1,
      anon_sym_class,
    ACTIONS(9410), 1,
      anon_sym_struct,
    ACTIONS(9412), 1,
      anon_sym_union,
    ACTIONS(9414), 1,
      sym_auto,
    ACTIONS(9416), 1,
      anon_sym_decltype,
    ACTIONS(9424), 1,
      sym_identifier,
    ACTIONS(9428), 1,
      anon_sym_enum,
    ACTIONS(9430), 1,
      anon_sym_typename,
    STATE(2345), 1,
      sym__type_specifier,
    STATE(2401), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2743), 1,
      sym_qualified_type_identifier,
    STATE(2780), 1,
      sym_decltype_auto,
    STATE(2813), 1,
      sym_primitive_type,
    STATE(5794), 1,
      sym_argument_list,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2673), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5807), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9426), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2776), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [203816] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(9448), 1,
      sym_identifier,
    ACTIONS(9450), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9454), 1,
      anon_sym_enum,
    ACTIONS(9456), 1,
      anon_sym_class,
    ACTIONS(9458), 1,
      anon_sym_struct,
    ACTIONS(9460), 1,
      anon_sym_union,
    ACTIONS(9462), 1,
      sym_auto,
    ACTIONS(9464), 1,
      anon_sym_decltype,
    ACTIONS(9466), 1,
      anon_sym_typename,
    STATE(2896), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3365), 1,
      sym_primitive_type,
    STATE(3483), 1,
      sym__type_specifier,
    STATE(4030), 1,
      sym_decltype_auto,
    STATE(4032), 1,
      sym_qualified_type_identifier,
    STATE(5812), 1,
      sym_argument_list,
    STATE(7350), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3862), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(6470), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9452), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4034), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [203901] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9265), 1,
      anon_sym_LT,
    STATE(2431), 1,
      sym_template_argument_list,
    ACTIONS(5129), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5136), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [203950] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9446), 1,
      anon_sym_LT,
    STATE(3195), 1,
      sym_template_argument_list,
    ACTIONS(5129), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5136), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [203999] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(9325), 1,
      sym_identifier,
    ACTIONS(9327), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9331), 1,
      anon_sym_enum,
    ACTIONS(9333), 1,
      anon_sym_class,
    ACTIONS(9335), 1,
      anon_sym_struct,
    ACTIONS(9337), 1,
      anon_sym_union,
    ACTIONS(9339), 1,
      sym_auto,
    ACTIONS(9341), 1,
      anon_sym_decltype,
    ACTIONS(9343), 1,
      anon_sym_typename,
    STATE(2692), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3151), 1,
      sym_primitive_type,
    STATE(3161), 1,
      sym__type_specifier,
    STATE(3555), 1,
      sym_qualified_type_identifier,
    STATE(3566), 1,
      sym_decltype_auto,
    STATE(5788), 1,
      sym_argument_list,
    STATE(7329), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3510), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(6077), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9329), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3565), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [204084] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(9380), 1,
      sym_identifier,
    ACTIONS(9382), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9386), 1,
      anon_sym_enum,
    ACTIONS(9388), 1,
      anon_sym_class,
    ACTIONS(9390), 1,
      anon_sym_struct,
    ACTIONS(9392), 1,
      anon_sym_union,
    ACTIONS(9394), 1,
      sym_auto,
    ACTIONS(9396), 1,
      anon_sym_decltype,
    ACTIONS(9398), 1,
      anon_sym_typename,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(3594), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4409), 1,
      sym_primitive_type,
    STATE(4588), 1,
      sym__type_specifier,
    STATE(4754), 1,
      sym_decltype_auto,
    STATE(5815), 1,
      sym_argument_list,
    STATE(7334), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(4724), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7259), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9384), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4758), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [204169] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(6983), 1,
      sym_auto,
    ACTIONS(6985), 1,
      anon_sym_decltype,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8820), 1,
      anon_sym_STAR,
    ACTIONS(8822), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8824), 1,
      anon_sym_AMP,
    STATE(3402), 1,
      sym_decltype_auto,
    STATE(4540), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7481), 1,
      sym__abstract_declarator,
    STATE(5891), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8299), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [204239] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8305), 1,
      sym_identifier,
    ACTIONS(8307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8309), 1,
      anon_sym_STAR,
    STATE(3253), 1,
      sym__type_declarator,
    STATE(3576), 1,
      sym_pointer_type_declarator,
    STATE(9416), 1,
      sym_ms_based_modifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8313), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8311), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3579), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [204301] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9265), 1,
      anon_sym_LT,
    STATE(2036), 1,
      sym_template_argument_list,
    ACTIONS(5136), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACE,
    ACTIONS(5129), 28,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [204349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3320), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3322), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [204391] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8121), 1,
      sym_auto,
    ACTIONS(8123), 1,
      anon_sym_decltype,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    STATE(2285), 1,
      sym_decltype_auto,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7460), 1,
      sym__abstract_declarator,
    STATE(5888), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8297), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [204461] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    STATE(5799), 1,
      sym_attribute_specifier,
    ACTIONS(6094), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6096), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [204507] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8305), 1,
      sym_identifier,
    ACTIONS(8307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8309), 1,
      anon_sym_STAR,
    STATE(3256), 1,
      sym__type_declarator,
    STATE(3576), 1,
      sym_pointer_type_declarator,
    STATE(9416), 1,
      sym_ms_based_modifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8313), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8311), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3579), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [204569] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    STATE(5801), 1,
      sym_attribute_specifier,
    ACTIONS(6117), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6119), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [204615] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    STATE(5791), 1,
      sym_attribute_specifier,
    ACTIONS(6121), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6123), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [204661] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    STATE(5735), 1,
      sym_attribute_specifier,
    ACTIONS(6024), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6026), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [204707] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8333), 1,
      anon_sym_STAR,
    STATE(2691), 1,
      sym__type_declarator,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(9571), 1,
      sym_ms_based_modifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8335), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [204769] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9446), 1,
      anon_sym_LT,
    STATE(3005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3195), 1,
      sym_template_argument_list,
    ACTIONS(4246), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5194), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4254), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [204821] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7898), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9371), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9377), 1,
      anon_sym_requires,
    STATE(5887), 1,
      sym_ref_qualifier,
    STATE(6513), 1,
      sym_trailing_return_type,
    STATE(6716), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6153), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [204901] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7898), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9371), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5881), 1,
      sym_ref_qualifier,
    STATE(6601), 1,
      sym_trailing_return_type,
    STATE(6726), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6167), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [204981] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8291), 1,
      anon_sym_STAR,
    ACTIONS(8293), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    STATE(4537), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7289), 1,
      sym__abstract_declarator,
    STATE(5876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6965), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [205045] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8333), 1,
      anon_sym_STAR,
    STATE(2662), 1,
      sym__type_declarator,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(9571), 1,
      sym_ms_based_modifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8335), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [205107] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7900), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9470), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9473), 1,
      anon_sym_requires,
    STATE(5863), 1,
      sym_ref_qualifier,
    STATE(6635), 1,
      sym_trailing_return_type,
    STATE(6697), 1,
      sym__function_attributes_end,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6162), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [205187] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8291), 1,
      anon_sym_STAR,
    ACTIONS(8293), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    STATE(4537), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7295), 1,
      sym__abstract_declarator,
    STATE(5876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8727), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [205251] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7833), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9371), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5867), 1,
      sym_ref_qualifier,
    STATE(6541), 1,
      sym__function_attributes_end,
    STATE(6601), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9476), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6183), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [205331] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    STATE(5783), 1,
      sym_attribute_specifier,
    ACTIONS(6049), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6051), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [205377] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8325), 1,
      sym_identifier,
    ACTIONS(8327), 1,
      anon_sym_LPAREN2,
    ACTIONS(8352), 1,
      anon_sym_STAR,
    STATE(7020), 1,
      sym_pointer_type_declarator,
    STATE(7093), 1,
      sym__type_declarator,
    STATE(9674), 1,
      sym_ms_based_modifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7945), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8331), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7002), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [205439] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7183), 1,
      sym__type_declarator,
    STATE(9045), 1,
      sym_ms_based_modifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [205501] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7142), 1,
      sym__type_declarator,
    STATE(9045), 1,
      sym_ms_based_modifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [205563] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8291), 1,
      anon_sym_STAR,
    ACTIONS(8293), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    STATE(4537), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7300), 1,
      sym__abstract_declarator,
    STATE(5876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6235), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [205627] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9265), 1,
      anon_sym_LT,
    STATE(2036), 1,
      sym_template_argument_list,
    ACTIONS(4272), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACE,
    ACTIONS(5835), 28,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [205675] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8325), 1,
      sym_identifier,
    ACTIONS(8327), 1,
      anon_sym_LPAREN2,
    ACTIONS(8329), 1,
      anon_sym_STAR,
    STATE(6854), 1,
      sym__type_declarator,
    STATE(7020), 1,
      sym_pointer_type_declarator,
    STATE(9762), 1,
      sym_ms_based_modifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8331), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7002), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [205737] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8279), 1,
      sym_identifier,
    ACTIONS(8281), 1,
      anon_sym_LPAREN2,
    ACTIONS(8283), 1,
      anon_sym_STAR,
    STATE(3543), 1,
      sym__type_declarator,
    STATE(4209), 1,
      sym_pointer_type_declarator,
    STATE(9101), 1,
      sym_ms_based_modifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8289), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8287), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4210), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [205799] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8325), 1,
      sym_identifier,
    ACTIONS(8327), 1,
      anon_sym_LPAREN2,
    ACTIONS(8329), 1,
      anon_sym_STAR,
    STATE(6856), 1,
      sym__type_declarator,
    STATE(7020), 1,
      sym_pointer_type_declarator,
    STATE(9762), 1,
      sym_ms_based_modifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8331), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7002), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [205861] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8291), 1,
      anon_sym_STAR,
    ACTIONS(8293), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    STATE(4537), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7303), 1,
      sym__abstract_declarator,
    STATE(5876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8795), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [205925] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    STATE(5814), 1,
      sym_attribute_specifier,
    ACTIONS(6144), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6146), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [205971] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(7900), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9470), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5877), 1,
      sym_ref_qualifier,
    STATE(6540), 1,
      sym_trailing_return_type,
    STATE(6756), 1,
      sym__function_attributes_end,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6181), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [206051] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8301), 1,
      sym_auto,
    ACTIONS(8303), 1,
      anon_sym_decltype,
    STATE(5784), 1,
      sym_decltype_auto,
    ACTIONS(5499), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5501), 28,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [206099] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7869), 1,
      anon_sym_DASH_GT,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9470), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5862), 1,
      sym_ref_qualifier,
    STATE(6540), 1,
      sym_trailing_return_type,
    STATE(6659), 1,
      sym__function_attributes_end,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9476), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6166), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [206179] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    STATE(5792), 1,
      sym_attribute_specifier,
    ACTIONS(6028), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6030), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [206225] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8350), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7472), 1,
      sym__type_declarator,
    STATE(9249), 1,
      sym_ms_based_modifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8335), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [206287] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7833), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9371), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9377), 1,
      anon_sym_requires,
    STATE(5865), 1,
      sym_ref_qualifier,
    STATE(6513), 1,
      sym_trailing_return_type,
    STATE(6599), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9476), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6165), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [206367] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(6983), 1,
      sym_auto,
    ACTIONS(6985), 1,
      anon_sym_decltype,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8820), 1,
      anon_sym_STAR,
    ACTIONS(8822), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8824), 1,
      anon_sym_AMP,
    STATE(3402), 1,
      sym_decltype_auto,
    STATE(4540), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7455), 1,
      sym__abstract_declarator,
    STATE(5897), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8297), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [206437] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7869), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9470), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9473), 1,
      anon_sym_requires,
    STATE(5870), 1,
      sym_ref_qualifier,
    STATE(6617), 1,
      sym__function_attributes_end,
    STATE(6635), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9476), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6176), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [206517] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8333), 1,
      anon_sym_STAR,
    STATE(2716), 1,
      sym__type_declarator,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(9571), 1,
      sym_ms_based_modifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8335), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [206579] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8325), 1,
      sym_identifier,
    ACTIONS(8327), 1,
      anon_sym_LPAREN2,
    ACTIONS(8329), 1,
      anon_sym_STAR,
    STATE(6878), 1,
      sym__type_declarator,
    STATE(7020), 1,
      sym_pointer_type_declarator,
    STATE(9762), 1,
      sym_ms_based_modifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8331), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7002), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [206641] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    STATE(5816), 1,
      sym_attribute_specifier,
    ACTIONS(6053), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6055), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [206687] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8337), 1,
      sym_identifier,
    ACTIONS(8339), 1,
      anon_sym_LPAREN2,
    ACTIONS(8341), 1,
      anon_sym_STAR,
    STATE(3486), 1,
      sym__type_declarator,
    STATE(3934), 1,
      sym_pointer_type_declarator,
    STATE(9121), 1,
      sym_ms_based_modifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8345), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8343), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3933), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [206749] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    STATE(5806), 1,
      sym_attribute_specifier,
    ACTIONS(6061), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6063), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [206795] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8279), 1,
      sym_identifier,
    ACTIONS(8281), 1,
      anon_sym_LPAREN2,
    ACTIONS(8283), 1,
      anon_sym_STAR,
    STATE(3613), 1,
      sym__type_declarator,
    STATE(4209), 1,
      sym_pointer_type_declarator,
    STATE(9101), 1,
      sym_ms_based_modifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8289), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8287), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4210), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [206857] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8350), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7463), 1,
      sym__type_declarator,
    STATE(9249), 1,
      sym_ms_based_modifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8335), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [206919] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8325), 1,
      sym_identifier,
    ACTIONS(8327), 1,
      anon_sym_LPAREN2,
    ACTIONS(8352), 1,
      anon_sym_STAR,
    STATE(7020), 1,
      sym_pointer_type_declarator,
    STATE(7113), 1,
      sym__type_declarator,
    STATE(9674), 1,
      sym_ms_based_modifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7945), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8331), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7002), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [206981] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    STATE(5795), 1,
      sym_attribute_specifier,
    ACTIONS(6113), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6115), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [207027] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7177), 1,
      sym__type_declarator,
    STATE(9045), 1,
      sym_ms_based_modifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [207089] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8350), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7466), 1,
      sym__type_declarator,
    STATE(9249), 1,
      sym_ms_based_modifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8335), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [207151] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8305), 1,
      sym_identifier,
    ACTIONS(8307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8309), 1,
      anon_sym_STAR,
    STATE(3246), 1,
      sym__type_declarator,
    STATE(3576), 1,
      sym_pointer_type_declarator,
    STATE(9416), 1,
      sym_ms_based_modifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8313), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8311), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3579), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [207213] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8279), 1,
      sym_identifier,
    ACTIONS(8281), 1,
      anon_sym_LPAREN2,
    ACTIONS(8283), 1,
      anon_sym_STAR,
    STATE(3598), 1,
      sym__type_declarator,
    STATE(4209), 1,
      sym_pointer_type_declarator,
    STATE(9101), 1,
      sym_ms_based_modifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8289), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8287), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4210), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [207275] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8337), 1,
      sym_identifier,
    ACTIONS(8339), 1,
      anon_sym_LPAREN2,
    ACTIONS(8341), 1,
      anon_sym_STAR,
    STATE(3409), 1,
      sym__type_declarator,
    STATE(3934), 1,
      sym_pointer_type_declarator,
    STATE(9121), 1,
      sym_ms_based_modifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8345), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8343), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3933), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [207337] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8337), 1,
      sym_identifier,
    ACTIONS(8339), 1,
      anon_sym_LPAREN2,
    ACTIONS(8341), 1,
      anon_sym_STAR,
    STATE(3470), 1,
      sym__type_declarator,
    STATE(3934), 1,
      sym_pointer_type_declarator,
    STATE(9121), 1,
      sym_ms_based_modifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8345), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8343), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3933), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [207399] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    STATE(5768), 1,
      sym_attribute_specifier,
    ACTIONS(6057), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6059), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [207445] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8325), 1,
      sym_identifier,
    ACTIONS(8327), 1,
      anon_sym_LPAREN2,
    ACTIONS(8352), 1,
      anon_sym_STAR,
    STATE(7020), 1,
      sym_pointer_type_declarator,
    STATE(7112), 1,
      sym__type_declarator,
    STATE(9674), 1,
      sym_ms_based_modifier,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7945), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8331), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7002), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [207507] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    STATE(5734), 1,
      sym_attribute_specifier,
    ACTIONS(6082), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6084), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [207553] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8121), 1,
      sym_auto,
    ACTIONS(8123), 1,
      anon_sym_decltype,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    STATE(2285), 1,
      sym_decltype_auto,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7470), 1,
      sym__abstract_declarator,
    STATE(5885), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8299), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [207623] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7675), 1,
      anon_sym_DASH_GT,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7725), 1,
      anon_sym_requires,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    STATE(6676), 1,
      sym__function_attributes_end,
    STATE(6782), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6098), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9479), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [207696] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(9291), 1,
      sym_identifier,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9295), 1,
      anon_sym_enum,
    ACTIONS(9297), 1,
      anon_sym_class,
    ACTIONS(9299), 1,
      anon_sym_struct,
    ACTIONS(9301), 1,
      anon_sym_union,
    ACTIONS(9303), 1,
      anon_sym_typename,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(4769), 1,
      sym__type_specifier,
    STATE(7347), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [207775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5710), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [207816] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(3022), 1,
      sym_auto,
    ACTIONS(3024), 1,
      anon_sym_decltype,
    ACTIONS(9432), 1,
      sym_identifier,
    ACTIONS(9434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9436), 1,
      anon_sym_enum,
    ACTIONS(9438), 1,
      anon_sym_class,
    ACTIONS(9440), 1,
      anon_sym_struct,
    ACTIONS(9442), 1,
      anon_sym_union,
    ACTIONS(9444), 1,
      anon_sym_typename,
    STATE(2651), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3059), 1,
      sym_primitive_type,
    STATE(3398), 1,
      sym_decltype_auto,
    STATE(3494), 1,
      sym_qualified_type_identifier,
    STATE(4810), 1,
      sym__type_specifier,
    STATE(7361), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3383), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2988), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2986), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3397), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [207895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5747), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5749), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [207936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5738), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [207977] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5105), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9140), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9144), 1,
      anon_sym_EQ,
    ACTIONS(9483), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3149), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6429), 1,
      sym_ms_declspec_modifier,
    STATE(7326), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9142), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(3042), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6427), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6126), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [208066] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(9325), 1,
      sym_identifier,
    ACTIONS(9327), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9331), 1,
      anon_sym_enum,
    ACTIONS(9333), 1,
      anon_sym_class,
    ACTIONS(9335), 1,
      anon_sym_struct,
    ACTIONS(9337), 1,
      anon_sym_union,
    ACTIONS(9339), 1,
      sym_auto,
    ACTIONS(9341), 1,
      anon_sym_decltype,
    ACTIONS(9343), 1,
      anon_sym_typename,
    STATE(2692), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3151), 1,
      sym_primitive_type,
    STATE(3179), 1,
      sym__type_specifier,
    STATE(3555), 1,
      sym_qualified_type_identifier,
    STATE(3566), 1,
      sym_decltype_auto,
    STATE(7329), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3510), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(6077), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9329), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3565), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [208145] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(9400), 1,
      sym_identifier,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9406), 1,
      anon_sym_enum,
    ACTIONS(9408), 1,
      anon_sym_class,
    ACTIONS(9410), 1,
      anon_sym_struct,
    ACTIONS(9412), 1,
      anon_sym_union,
    ACTIONS(9414), 1,
      sym_auto,
    ACTIONS(9416), 1,
      anon_sym_decltype,
    ACTIONS(9418), 1,
      anon_sym_typename,
    STATE(2332), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2385), 1,
      sym__type_specifier,
    STATE(2743), 1,
      sym_qualified_type_identifier,
    STATE(2780), 1,
      sym_decltype_auto,
    STATE(2816), 1,
      sym_primitive_type,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2673), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5807), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9404), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2776), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [208224] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(7966), 1,
      sym_identifier,
    ACTIONS(7968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7974), 1,
      anon_sym_enum,
    ACTIONS(7976), 1,
      anon_sym_class,
    ACTIONS(7978), 1,
      anon_sym_struct,
    ACTIONS(7980), 1,
      anon_sym_union,
    ACTIONS(7982), 1,
      sym_auto,
    ACTIONS(7984), 1,
      anon_sym_decltype,
    ACTIONS(7986), 1,
      anon_sym_typename,
    STATE(4950), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5635), 1,
      sym_primitive_type,
    STATE(5866), 1,
      sym__type_specifier,
    STATE(5921), 1,
      sym_qualified_type_identifier,
    STATE(5957), 1,
      sym_decltype_auto,
    STATE(7328), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(5890), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7972), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7970), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5956), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [208303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5777), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5779), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [208344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5787), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [208385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5781), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5783), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [208426] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(9345), 1,
      sym_identifier,
    ACTIONS(9347), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9351), 1,
      anon_sym_enum,
    ACTIONS(9353), 1,
      anon_sym_class,
    ACTIONS(9355), 1,
      anon_sym_struct,
    ACTIONS(9357), 1,
      anon_sym_union,
    ACTIONS(9359), 1,
      sym_auto,
    ACTIONS(9361), 1,
      anon_sym_decltype,
    ACTIONS(9363), 1,
      anon_sym_typename,
    STATE(2751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3174), 1,
      sym_primitive_type,
    STATE(3572), 1,
      sym__type_specifier,
    STATE(3747), 1,
      sym_decltype_auto,
    STATE(3825), 1,
      sym_qualified_type_identifier,
    STATE(7346), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3563), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(6197), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9349), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3746), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [208505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5690), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [208546] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8356), 1,
      anon_sym_STAR,
    ACTIONS(8358), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    STATE(4695), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7363), 1,
      sym__abstract_declarator,
    STATE(5571), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6235), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [208609] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(3022), 1,
      sym_auto,
    ACTIONS(3024), 1,
      anon_sym_decltype,
    ACTIONS(9432), 1,
      sym_identifier,
    ACTIONS(9434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9436), 1,
      anon_sym_enum,
    ACTIONS(9438), 1,
      anon_sym_class,
    ACTIONS(9440), 1,
      anon_sym_struct,
    ACTIONS(9442), 1,
      anon_sym_union,
    ACTIONS(9444), 1,
      anon_sym_typename,
    STATE(2651), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3059), 1,
      sym_primitive_type,
    STATE(3398), 1,
      sym_decltype_auto,
    STATE(3494), 1,
      sym_qualified_type_identifier,
    STATE(4820), 1,
      sym__type_specifier,
    STATE(7361), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3383), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2988), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2986), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3397), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [208688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5634), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5636), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [208729] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(3230), 1,
      anon_sym_enum,
    ACTIONS(3232), 1,
      anon_sym_class,
    ACTIONS(3234), 1,
      anon_sym_struct,
    ACTIONS(3236), 1,
      anon_sym_union,
    ACTIONS(3238), 1,
      anon_sym_typename,
    ACTIONS(5204), 1,
      sym_identifier,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    STATE(2899), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3054), 1,
      sym__type_specifier,
    STATE(3140), 1,
      sym_decltype_auto,
    STATE(3282), 1,
      sym_primitive_type,
    STATE(3893), 1,
      sym_qualified_type_identifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3039), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(53), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3087), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [208808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5675), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5677), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [208849] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2021), 1,
      anon_sym_enum,
    ACTIONS(2023), 1,
      anon_sym_class,
    ACTIONS(2025), 1,
      anon_sym_struct,
    ACTIONS(2027), 1,
      anon_sym_union,
    ACTIONS(2053), 1,
      anon_sym_typename,
    ACTIONS(5095), 1,
      sym_identifier,
    ACTIONS(5105), 1,
      anon_sym_COLON_COLON,
    STATE(2899), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3054), 1,
      sym__type_specifier,
    STATE(3140), 1,
      sym_decltype_auto,
    STATE(3282), 1,
      sym_primitive_type,
    STATE(3893), 1,
      sym_qualified_type_identifier,
    STATE(7326), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3039), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(53), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3087), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [208928] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2990), 1,
      anon_sym_enum,
    ACTIONS(2992), 1,
      anon_sym_class,
    ACTIONS(2994), 1,
      anon_sym_struct,
    ACTIONS(2996), 1,
      anon_sym_union,
    ACTIONS(3022), 1,
      sym_auto,
    ACTIONS(3024), 1,
      anon_sym_decltype,
    ACTIONS(3026), 1,
      anon_sym_typename,
    ACTIONS(8015), 1,
      sym_identifier,
    ACTIONS(8017), 1,
      anon_sym_COLON_COLON,
    STATE(2651), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3059), 1,
      sym_primitive_type,
    STATE(3362), 1,
      sym__type_specifier,
    STATE(3398), 1,
      sym_decltype_auto,
    STATE(3494), 1,
      sym_qualified_type_identifier,
    STATE(7325), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3383), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2988), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2986), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3397), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [209007] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(7997), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8001), 1,
      anon_sym_enum,
    ACTIONS(8003), 1,
      anon_sym_class,
    ACTIONS(8005), 1,
      anon_sym_struct,
    ACTIONS(8007), 1,
      anon_sym_union,
    ACTIONS(8009), 1,
      anon_sym_typename,
    STATE(3140), 1,
      sym_decltype_auto,
    STATE(3331), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(4130), 1,
      sym_primitive_type,
    STATE(7322), 1,
      sym__scope_resolution,
    STATE(7626), 1,
      sym__type_specifier,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3039), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(4049), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3087), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [209086] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(7955), 1,
      sym_auto,
    ACTIONS(7957), 1,
      anon_sym_decltype,
    ACTIONS(8019), 1,
      sym_identifier,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8023), 1,
      anon_sym_enum,
    ACTIONS(8025), 1,
      anon_sym_class,
    ACTIONS(8027), 1,
      anon_sym_struct,
    ACTIONS(8029), 1,
      anon_sym_union,
    ACTIONS(8031), 1,
      anon_sym_typename,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(4811), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5230), 1,
      sym_primitive_type,
    STATE(5698), 1,
      sym__type_specifier,
    STATE(5753), 1,
      sym_decltype_auto,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3039), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7945), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7943), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5793), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [209165] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7675), 1,
      anon_sym_DASH_GT,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7725), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    STATE(6671), 1,
      sym__function_attributes_end,
    STATE(6799), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6118), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [209238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5665), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5667), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [209279] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(9380), 1,
      sym_identifier,
    ACTIONS(9382), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9386), 1,
      anon_sym_enum,
    ACTIONS(9388), 1,
      anon_sym_class,
    ACTIONS(9390), 1,
      anon_sym_struct,
    ACTIONS(9392), 1,
      anon_sym_union,
    ACTIONS(9394), 1,
      sym_auto,
    ACTIONS(9396), 1,
      anon_sym_decltype,
    ACTIONS(9398), 1,
      anon_sym_typename,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(3594), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4409), 1,
      sym_primitive_type,
    STATE(4709), 1,
      sym__type_specifier,
    STATE(4754), 1,
      sym_decltype_auto,
    STATE(7334), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(4724), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7259), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9384), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4758), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [209358] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2099), 1,
      anon_sym_enum,
    ACTIONS(2101), 1,
      anon_sym_class,
    ACTIONS(2103), 1,
      anon_sym_struct,
    ACTIONS(2105), 1,
      anon_sym_union,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(2135), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2157), 1,
      sym__type_specifier,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [209437] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9485), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(6426), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6428), 28,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [209480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5661), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5663), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [209521] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(5258), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4246), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(8473), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4254), 21,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [209572] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8356), 1,
      anon_sym_STAR,
    ACTIONS(8358), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    STATE(4695), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7362), 1,
      sym__abstract_declarator,
    STATE(5571), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8727), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [209635] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9239), 1,
      anon_sym___attribute__,
    ACTIONS(9420), 1,
      anon_sym_LBRACE,
    STATE(5842), 1,
      sym_enumerator_list,
    STATE(5911), 1,
      sym_attribute_specifier,
    ACTIONS(5980), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5982), 27,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [209684] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(4041), 1,
      sym_identifier,
    ACTIONS(4047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4051), 1,
      anon_sym_enum,
    ACTIONS(4053), 1,
      anon_sym_class,
    ACTIONS(4055), 1,
      anon_sym_struct,
    ACTIONS(4057), 1,
      anon_sym_union,
    ACTIONS(4059), 1,
      anon_sym_typename,
    STATE(3054), 1,
      sym__type_specifier,
    STATE(3140), 1,
      sym_decltype_auto,
    STATE(3331), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(4130), 1,
      sym_primitive_type,
    STATE(7352), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3039), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(4049), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3087), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [209763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5702), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [209804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5704), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5706), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [209845] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9239), 1,
      anon_sym___attribute__,
    ACTIONS(9420), 1,
      anon_sym_LBRACE,
    STATE(5845), 1,
      sym_enumerator_list,
    STATE(5922), 1,
      sym_attribute_specifier,
    ACTIONS(5952), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5954), 27,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [209894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5640), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [209935] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(9305), 1,
      sym_identifier,
    ACTIONS(9307), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9311), 1,
      anon_sym_enum,
    ACTIONS(9313), 1,
      anon_sym_class,
    ACTIONS(9315), 1,
      anon_sym_struct,
    ACTIONS(9317), 1,
      anon_sym_union,
    ACTIONS(9319), 1,
      sym_auto,
    ACTIONS(9321), 1,
      anon_sym_decltype,
    ACTIONS(9323), 1,
      anon_sym_typename,
    STATE(2580), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2974), 1,
      sym_primitive_type,
    STATE(3047), 1,
      sym__type_specifier,
    STATE(3303), 1,
      sym_decltype_auto,
    STATE(3363), 1,
      sym_qualified_type_identifier,
    STATE(7340), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3229), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5971), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9309), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3293), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [210014] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(9448), 1,
      sym_identifier,
    ACTIONS(9450), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9454), 1,
      anon_sym_enum,
    ACTIONS(9456), 1,
      anon_sym_class,
    ACTIONS(9458), 1,
      anon_sym_struct,
    ACTIONS(9460), 1,
      anon_sym_union,
    ACTIONS(9462), 1,
      sym_auto,
    ACTIONS(9464), 1,
      anon_sym_decltype,
    ACTIONS(9466), 1,
      anon_sym_typename,
    STATE(2896), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3365), 1,
      sym_primitive_type,
    STATE(3514), 1,
      sym__type_specifier,
    STATE(4030), 1,
      sym_decltype_auto,
    STATE(4032), 1,
      sym_qualified_type_identifier,
    STATE(7350), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3862), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(6470), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9452), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4034), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [210093] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9408), 1,
      anon_sym_class,
    ACTIONS(9410), 1,
      anon_sym_struct,
    ACTIONS(9412), 1,
      anon_sym_union,
    ACTIONS(9414), 1,
      sym_auto,
    ACTIONS(9416), 1,
      anon_sym_decltype,
    ACTIONS(9424), 1,
      sym_identifier,
    ACTIONS(9428), 1,
      anon_sym_enum,
    ACTIONS(9430), 1,
      anon_sym_typename,
    STATE(2401), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2407), 1,
      sym__type_specifier,
    STATE(2743), 1,
      sym_qualified_type_identifier,
    STATE(2780), 1,
      sym_decltype_auto,
    STATE(2813), 1,
      sym_primitive_type,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2673), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5807), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9426), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2776), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [210172] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(9305), 1,
      sym_identifier,
    ACTIONS(9307), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9311), 1,
      anon_sym_enum,
    ACTIONS(9313), 1,
      anon_sym_class,
    ACTIONS(9315), 1,
      anon_sym_struct,
    ACTIONS(9317), 1,
      anon_sym_union,
    ACTIONS(9319), 1,
      sym_auto,
    ACTIONS(9321), 1,
      anon_sym_decltype,
    ACTIONS(9323), 1,
      anon_sym_typename,
    STATE(2580), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2974), 1,
      sym_primitive_type,
    STATE(3058), 1,
      sym__type_specifier,
    STATE(3303), 1,
      sym_decltype_auto,
    STATE(3363), 1,
      sym_qualified_type_identifier,
    STATE(7340), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3229), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5971), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9309), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3293), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [210251] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(9291), 1,
      sym_identifier,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9295), 1,
      anon_sym_enum,
    ACTIONS(9297), 1,
      anon_sym_class,
    ACTIONS(9299), 1,
      anon_sym_struct,
    ACTIONS(9301), 1,
      anon_sym_union,
    ACTIONS(9303), 1,
      anon_sym_typename,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(4804), 1,
      sym__type_specifier,
    STATE(7347), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [210330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5793), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5795), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [210371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5648), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [210412] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(9291), 1,
      sym_identifier,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9295), 1,
      anon_sym_enum,
    ACTIONS(9297), 1,
      anon_sym_class,
    ACTIONS(9299), 1,
      anon_sym_struct,
    ACTIONS(9301), 1,
      anon_sym_union,
    ACTIONS(9303), 1,
      anon_sym_typename,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2157), 1,
      sym__type_specifier,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(7347), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [210491] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7675), 1,
      anon_sym_DASH_GT,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9260), 1,
      anon_sym_requires,
    STATE(6668), 1,
      sym__function_attributes_end,
    STATE(6765), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9257), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6110), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [210564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5642), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5644), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [210605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5686), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [210646] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(7939), 1,
      sym_identifier,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7947), 1,
      anon_sym_enum,
    ACTIONS(7949), 1,
      anon_sym_class,
    ACTIONS(7951), 1,
      anon_sym_struct,
    ACTIONS(7953), 1,
      anon_sym_union,
    ACTIONS(7955), 1,
      sym_auto,
    ACTIONS(7957), 1,
      anon_sym_decltype,
    ACTIONS(7959), 1,
      anon_sym_typename,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(4811), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5230), 1,
      sym_primitive_type,
    STATE(5698), 1,
      sym__type_specifier,
    STATE(5753), 1,
      sym_decltype_auto,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3039), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7945), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7943), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5793), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [210725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5716), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5718), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [210766] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(9291), 1,
      sym_identifier,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9295), 1,
      anon_sym_enum,
    ACTIONS(9297), 1,
      anon_sym_class,
    ACTIONS(9299), 1,
      anon_sym_struct,
    ACTIONS(9301), 1,
      anon_sym_union,
    ACTIONS(9303), 1,
      anon_sym_typename,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(4689), 1,
      sym__type_specifier,
    STATE(7347), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [210845] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(9305), 1,
      sym_identifier,
    ACTIONS(9307), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9311), 1,
      anon_sym_enum,
    ACTIONS(9313), 1,
      anon_sym_class,
    ACTIONS(9315), 1,
      anon_sym_struct,
    ACTIONS(9317), 1,
      anon_sym_union,
    ACTIONS(9319), 1,
      sym_auto,
    ACTIONS(9321), 1,
      anon_sym_decltype,
    ACTIONS(9323), 1,
      anon_sym_typename,
    STATE(2580), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2974), 1,
      sym_primitive_type,
    STATE(3284), 1,
      sym__type_specifier,
    STATE(3303), 1,
      sym_decltype_auto,
    STATE(3363), 1,
      sym_qualified_type_identifier,
    STATE(7340), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3229), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5971), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9309), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3293), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [210924] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7675), 1,
      anon_sym_DASH_GT,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9491), 1,
      anon_sym_requires,
    STATE(6667), 1,
      sym__function_attributes_end,
    STATE(6781), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9488), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6134), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9479), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [210997] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(9271), 1,
      sym_identifier,
    ACTIONS(9273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9277), 1,
      anon_sym_enum,
    ACTIONS(9279), 1,
      anon_sym_class,
    ACTIONS(9281), 1,
      anon_sym_struct,
    ACTIONS(9283), 1,
      anon_sym_union,
    ACTIONS(9285), 1,
      sym_auto,
    ACTIONS(9287), 1,
      anon_sym_decltype,
    ACTIONS(9289), 1,
      anon_sym_typename,
    STATE(3927), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4668), 1,
      sym_primitive_type,
    STATE(4694), 1,
      sym__type_specifier,
    STATE(4850), 1,
      sym_decltype_auto,
    STATE(4905), 1,
      sym_qualified_type_identifier,
    STATE(7337), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(4826), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7646), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9275), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4903), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [211076] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_enum,
    ACTIONS(7931), 1,
      anon_sym_class,
    ACTIONS(7933), 1,
      anon_sym_struct,
    ACTIONS(7935), 1,
      anon_sym_union,
    ACTIONS(7937), 1,
      anon_sym_typename,
    STATE(2157), 1,
      sym__type_specifier,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6136), 1,
      sym_primitive_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [211155] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7992), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9494), 1,
      anon_sym_requires,
    STATE(5930), 1,
      sym_ref_qualifier,
    STATE(6885), 1,
      sym__function_attributes_end,
    STATE(6984), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9257), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6199), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [211234] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(9400), 1,
      sym_identifier,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9406), 1,
      anon_sym_enum,
    ACTIONS(9408), 1,
      anon_sym_class,
    ACTIONS(9410), 1,
      anon_sym_struct,
    ACTIONS(9412), 1,
      anon_sym_union,
    ACTIONS(9414), 1,
      sym_auto,
    ACTIONS(9416), 1,
      anon_sym_decltype,
    ACTIONS(9418), 1,
      anon_sym_typename,
    STATE(2332), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2407), 1,
      sym__type_specifier,
    STATE(2743), 1,
      sym_qualified_type_identifier,
    STATE(2780), 1,
      sym_decltype_auto,
    STATE(2816), 1,
      sym_primitive_type,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2673), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5807), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9404), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2776), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [211313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5632), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [211354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5771), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5773), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [211395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5742), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [211436] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(7997), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8001), 1,
      anon_sym_enum,
    ACTIONS(8003), 1,
      anon_sym_class,
    ACTIONS(8005), 1,
      anon_sym_struct,
    ACTIONS(8007), 1,
      anon_sym_union,
    ACTIONS(8009), 1,
      anon_sym_typename,
    STATE(3054), 1,
      sym__type_specifier,
    STATE(3140), 1,
      sym_decltype_auto,
    STATE(3331), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(4130), 1,
      sym_primitive_type,
    STATE(7322), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3039), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(4049), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3087), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [211515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5640), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [211556] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_enum,
    ACTIONS(67), 1,
      anon_sym_class,
    ACTIONS(69), 1,
      anon_sym_struct,
    ACTIONS(71), 1,
      anon_sym_union,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(129), 1,
      anon_sym_typename,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(5204), 1,
      sym_identifier,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    STATE(2899), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3054), 1,
      sym__type_specifier,
    STATE(3140), 1,
      sym_decltype_auto,
    STATE(3282), 1,
      sym_primitive_type,
    STATE(3893), 1,
      sym_qualified_type_identifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3039), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(53), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3087), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [211635] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(9325), 1,
      sym_identifier,
    ACTIONS(9327), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9331), 1,
      anon_sym_enum,
    ACTIONS(9333), 1,
      anon_sym_class,
    ACTIONS(9335), 1,
      anon_sym_struct,
    ACTIONS(9337), 1,
      anon_sym_union,
    ACTIONS(9339), 1,
      sym_auto,
    ACTIONS(9341), 1,
      anon_sym_decltype,
    ACTIONS(9343), 1,
      anon_sym_typename,
    STATE(2692), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3151), 1,
      sym_primitive_type,
    STATE(3157), 1,
      sym__type_specifier,
    STATE(3555), 1,
      sym_qualified_type_identifier,
    STATE(3566), 1,
      sym_decltype_auto,
    STATE(7329), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3510), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(6077), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9329), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3565), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [211714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5640), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [211755] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(9448), 1,
      sym_identifier,
    ACTIONS(9450), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9454), 1,
      anon_sym_enum,
    ACTIONS(9456), 1,
      anon_sym_class,
    ACTIONS(9458), 1,
      anon_sym_struct,
    ACTIONS(9460), 1,
      anon_sym_union,
    ACTIONS(9462), 1,
      sym_auto,
    ACTIONS(9464), 1,
      anon_sym_decltype,
    ACTIONS(9466), 1,
      anon_sym_typename,
    STATE(2896), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3365), 1,
      sym_primitive_type,
    STATE(3878), 1,
      sym__type_specifier,
    STATE(4030), 1,
      sym_decltype_auto,
    STATE(4032), 1,
      sym_qualified_type_identifier,
    STATE(7350), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3862), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(6470), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9452), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4034), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [211834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5694), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [211875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5789), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5791), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [211916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5481), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5483), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [211957] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9408), 1,
      anon_sym_class,
    ACTIONS(9410), 1,
      anon_sym_struct,
    ACTIONS(9412), 1,
      anon_sym_union,
    ACTIONS(9414), 1,
      sym_auto,
    ACTIONS(9416), 1,
      anon_sym_decltype,
    ACTIONS(9424), 1,
      sym_identifier,
    ACTIONS(9428), 1,
      anon_sym_enum,
    ACTIONS(9430), 1,
      anon_sym_typename,
    STATE(2385), 1,
      sym__type_specifier,
    STATE(2401), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2743), 1,
      sym_qualified_type_identifier,
    STATE(2780), 1,
      sym_decltype_auto,
    STATE(2813), 1,
      sym_primitive_type,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2673), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5807), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9426), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2776), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [212036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5722), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [212077] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8356), 1,
      anon_sym_STAR,
    ACTIONS(8358), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    STATE(4695), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7356), 1,
      sym__abstract_declarator,
    STATE(5571), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6965), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [212140] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(9345), 1,
      sym_identifier,
    ACTIONS(9347), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9351), 1,
      anon_sym_enum,
    ACTIONS(9353), 1,
      anon_sym_class,
    ACTIONS(9355), 1,
      anon_sym_struct,
    ACTIONS(9357), 1,
      anon_sym_union,
    ACTIONS(9359), 1,
      sym_auto,
    ACTIONS(9361), 1,
      anon_sym_decltype,
    ACTIONS(9363), 1,
      anon_sym_typename,
    STATE(2751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3174), 1,
      sym_primitive_type,
    STATE(3241), 1,
      sym__type_specifier,
    STATE(3747), 1,
      sym_decltype_auto,
    STATE(3825), 1,
      sym_qualified_type_identifier,
    STATE(7346), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3563), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(6197), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9349), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3746), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [212219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5657), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5659), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [212260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5751), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5753), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [212301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5690), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [212342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5696), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5698), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [212383] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(9400), 1,
      sym_identifier,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9406), 1,
      anon_sym_enum,
    ACTIONS(9408), 1,
      anon_sym_class,
    ACTIONS(9410), 1,
      anon_sym_struct,
    ACTIONS(9412), 1,
      anon_sym_union,
    ACTIONS(9414), 1,
      sym_auto,
    ACTIONS(9416), 1,
      anon_sym_decltype,
    ACTIONS(9418), 1,
      anon_sym_typename,
    STATE(2332), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2686), 1,
      sym__type_specifier,
    STATE(2743), 1,
      sym_qualified_type_identifier,
    STATE(2780), 1,
      sym_decltype_auto,
    STATE(2816), 1,
      sym_primitive_type,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2673), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5807), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9404), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2776), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [212462] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(9271), 1,
      sym_identifier,
    ACTIONS(9273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9277), 1,
      anon_sym_enum,
    ACTIONS(9279), 1,
      anon_sym_class,
    ACTIONS(9281), 1,
      anon_sym_struct,
    ACTIONS(9283), 1,
      anon_sym_union,
    ACTIONS(9285), 1,
      sym_auto,
    ACTIONS(9287), 1,
      anon_sym_decltype,
    ACTIONS(9289), 1,
      anon_sym_typename,
    STATE(3927), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4668), 1,
      sym_primitive_type,
    STATE(4809), 1,
      sym__type_specifier,
    STATE(4850), 1,
      sym_decltype_auto,
    STATE(4905), 1,
      sym_qualified_type_identifier,
    STATE(7337), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(4826), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7646), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9275), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4903), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [212541] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(9345), 1,
      sym_identifier,
    ACTIONS(9347), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9351), 1,
      anon_sym_enum,
    ACTIONS(9353), 1,
      anon_sym_class,
    ACTIONS(9355), 1,
      anon_sym_struct,
    ACTIONS(9357), 1,
      anon_sym_union,
    ACTIONS(9359), 1,
      sym_auto,
    ACTIONS(9361), 1,
      anon_sym_decltype,
    ACTIONS(9363), 1,
      anon_sym_typename,
    STATE(2751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3174), 1,
      sym_primitive_type,
    STATE(3224), 1,
      sym__type_specifier,
    STATE(3747), 1,
      sym_decltype_auto,
    STATE(3825), 1,
      sym_qualified_type_identifier,
    STATE(7346), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3563), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(6197), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9349), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3746), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [212620] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(9271), 1,
      sym_identifier,
    ACTIONS(9273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9277), 1,
      anon_sym_enum,
    ACTIONS(9279), 1,
      anon_sym_class,
    ACTIONS(9281), 1,
      anon_sym_struct,
    ACTIONS(9283), 1,
      anon_sym_union,
    ACTIONS(9285), 1,
      sym_auto,
    ACTIONS(9287), 1,
      anon_sym_decltype,
    ACTIONS(9289), 1,
      anon_sym_typename,
    STATE(3927), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4668), 1,
      sym_primitive_type,
    STATE(4702), 1,
      sym__type_specifier,
    STATE(4850), 1,
      sym_decltype_auto,
    STATE(4905), 1,
      sym_qualified_type_identifier,
    STATE(7337), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(4826), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7646), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9275), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4903), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [212699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5755), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5757), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [212740] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9408), 1,
      anon_sym_class,
    ACTIONS(9410), 1,
      anon_sym_struct,
    ACTIONS(9412), 1,
      anon_sym_union,
    ACTIONS(9414), 1,
      sym_auto,
    ACTIONS(9416), 1,
      anon_sym_decltype,
    ACTIONS(9424), 1,
      sym_identifier,
    ACTIONS(9428), 1,
      anon_sym_enum,
    ACTIONS(9430), 1,
      anon_sym_typename,
    STATE(2401), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2686), 1,
      sym__type_specifier,
    STATE(2743), 1,
      sym_qualified_type_identifier,
    STATE(2780), 1,
      sym_decltype_auto,
    STATE(2813), 1,
      sym_primitive_type,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2673), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5807), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9426), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2776), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [212819] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7961), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9470), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_requires,
    STATE(5952), 1,
      sym_ref_qualifier,
    STATE(6773), 1,
      sym__function_attributes_end,
    STATE(6974), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6201), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [212898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5724), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5726), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [212939] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(9380), 1,
      sym_identifier,
    ACTIONS(9382), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9386), 1,
      anon_sym_enum,
    ACTIONS(9388), 1,
      anon_sym_class,
    ACTIONS(9390), 1,
      anon_sym_struct,
    ACTIONS(9392), 1,
      anon_sym_union,
    ACTIONS(9394), 1,
      sym_auto,
    ACTIONS(9396), 1,
      anon_sym_decltype,
    ACTIONS(9398), 1,
      anon_sym_typename,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(3594), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4409), 1,
      sym_primitive_type,
    STATE(4500), 1,
      sym__type_specifier,
    STATE(4754), 1,
      sym_decltype_auto,
    STATE(7334), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(4724), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7259), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9384), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4758), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [213018] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(3022), 1,
      sym_auto,
    ACTIONS(3024), 1,
      anon_sym_decltype,
    ACTIONS(9432), 1,
      sym_identifier,
    ACTIONS(9434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9436), 1,
      anon_sym_enum,
    ACTIONS(9438), 1,
      anon_sym_class,
    ACTIONS(9440), 1,
      anon_sym_struct,
    ACTIONS(9442), 1,
      anon_sym_union,
    ACTIONS(9444), 1,
      anon_sym_typename,
    STATE(2651), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3059), 1,
      sym_primitive_type,
    STATE(3362), 1,
      sym__type_specifier,
    STATE(3398), 1,
      sym_decltype_auto,
    STATE(3494), 1,
      sym_qualified_type_identifier,
    STATE(7361), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3383), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2988), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2986), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3397), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [213097] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(9448), 1,
      sym_identifier,
    ACTIONS(9450), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9454), 1,
      anon_sym_enum,
    ACTIONS(9456), 1,
      anon_sym_class,
    ACTIONS(9458), 1,
      anon_sym_struct,
    ACTIONS(9460), 1,
      anon_sym_union,
    ACTIONS(9462), 1,
      sym_auto,
    ACTIONS(9464), 1,
      anon_sym_decltype,
    ACTIONS(9466), 1,
      anon_sym_typename,
    STATE(2896), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3365), 1,
      sym_primitive_type,
    STATE(3467), 1,
      sym__type_specifier,
    STATE(4030), 1,
      sym_decltype_auto,
    STATE(4032), 1,
      sym_qualified_type_identifier,
    STATE(7350), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3862), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(6470), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9452), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4034), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [213176] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7992), 1,
      anon_sym_DASH_GT,
    ACTIONS(8011), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    STATE(5937), 1,
      sym_ref_qualifier,
    STATE(6870), 1,
      sym__function_attributes_end,
    STATE(6981), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6200), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [213255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5763), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5765), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [213296] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(9380), 1,
      sym_identifier,
    ACTIONS(9382), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9386), 1,
      anon_sym_enum,
    ACTIONS(9388), 1,
      anon_sym_class,
    ACTIONS(9390), 1,
      anon_sym_struct,
    ACTIONS(9392), 1,
      anon_sym_union,
    ACTIONS(9394), 1,
      sym_auto,
    ACTIONS(9396), 1,
      anon_sym_decltype,
    ACTIONS(9398), 1,
      anon_sym_typename,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(3594), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4409), 1,
      sym_primitive_type,
    STATE(4501), 1,
      sym__type_specifier,
    STATE(4754), 1,
      sym_decltype_auto,
    STATE(7334), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(4724), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7259), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9384), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4758), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [213375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5669), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5671), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [213416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5712), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5714), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [213457] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2131), 1,
      sym_auto,
    ACTIONS(2133), 1,
      anon_sym_decltype,
    ACTIONS(9291), 1,
      sym_identifier,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9295), 1,
      anon_sym_enum,
    ACTIONS(9297), 1,
      anon_sym_class,
    ACTIONS(9299), 1,
      anon_sym_struct,
    ACTIONS(9301), 1,
      anon_sym_union,
    ACTIONS(9303), 1,
      anon_sym_typename,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2253), 1,
      sym_decltype_auto,
    STATE(2661), 1,
      sym_qualified_type_identifier,
    STATE(2679), 1,
      sym_primitive_type,
    STATE(4704), 1,
      sym__type_specifier,
    STATE(7347), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(2142), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2258), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [213536] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(7997), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8001), 1,
      anon_sym_enum,
    ACTIONS(8003), 1,
      anon_sym_class,
    ACTIONS(8005), 1,
      anon_sym_struct,
    ACTIONS(8007), 1,
      anon_sym_union,
    ACTIONS(8009), 1,
      anon_sym_typename,
    STATE(3140), 1,
      sym_decltype_auto,
    STATE(3331), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3374), 1,
      sym_qualified_type_identifier,
    STATE(4130), 1,
      sym_primitive_type,
    STATE(7322), 1,
      sym__scope_resolution,
    STATE(7624), 1,
      sym__type_specifier,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3039), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(4049), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3087), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [213615] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7961), 1,
      anon_sym_DASH_GT,
    ACTIONS(8033), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9470), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5942), 1,
      sym_ref_qualifier,
    STATE(6805), 1,
      sym__function_attributes_end,
    STATE(6924), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6196), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [213694] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_const,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8356), 1,
      anon_sym_STAR,
    ACTIONS(8358), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    STATE(4695), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7372), 1,
      sym__abstract_declarator,
    STATE(5571), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8795), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7737), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [213757] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(9325), 1,
      sym_identifier,
    ACTIONS(9327), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9331), 1,
      anon_sym_enum,
    ACTIONS(9333), 1,
      anon_sym_class,
    ACTIONS(9335), 1,
      anon_sym_struct,
    ACTIONS(9337), 1,
      anon_sym_union,
    ACTIONS(9339), 1,
      sym_auto,
    ACTIONS(9341), 1,
      anon_sym_decltype,
    ACTIONS(9343), 1,
      anon_sym_typename,
    STATE(2692), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3151), 1,
      sym_primitive_type,
    STATE(3512), 1,
      sym__type_specifier,
    STATE(3555), 1,
      sym_qualified_type_identifier,
    STATE(3566), 1,
      sym_decltype_auto,
    STATE(7329), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_dependent_type_identifier,
    STATE(3510), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(6077), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9329), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3565), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [213836] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9239), 1,
      anon_sym___attribute__,
    STATE(5909), 1,
      sym_attribute_specifier,
    ACTIONS(6028), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6030), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [213880] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym___attribute__,
    ACTIONS(6464), 1,
      anon_sym_LBRACE,
    ACTIONS(9500), 1,
      anon_sym_COLON,
    STATE(2284), 1,
      sym_attribute_specifier,
    STATE(2901), 1,
      sym__enum_base_clause,
    STATE(3021), 1,
      sym_enumerator_list,
    ACTIONS(6334), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6336), 24,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [213932] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9239), 1,
      anon_sym___attribute__,
    STATE(5918), 1,
      sym_attribute_specifier,
    ACTIONS(6117), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6119), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [213976] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(8539), 1,
      anon_sym_LPAREN2,
    ACTIONS(8547), 1,
      sym_identifier,
    ACTIONS(8549), 1,
      anon_sym_STAR,
    ACTIONS(8551), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8553), 1,
      anon_sym_AMP,
    STATE(7428), 1,
      sym__field_declarator,
    STATE(7503), 1,
      sym_operator_name,
    STATE(9291), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7265), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [214038] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9239), 1,
      anon_sym___attribute__,
    STATE(5928), 1,
      sym_attribute_specifier,
    ACTIONS(6082), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6084), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [214082] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(8052), 1,
      anon_sym_DASH_GT,
    ACTIONS(8057), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    STATE(6092), 1,
      sym_ref_qualifier,
    STATE(6933), 1,
      sym__function_attributes_end,
    STATE(7136), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6217), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [214160] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(8052), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9502), 1,
      anon_sym_requires,
    STATE(5981), 1,
      sym_ref_qualifier,
    STATE(6926), 1,
      sym__function_attributes_end,
    STATE(7150), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9257), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6207), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [214238] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9368), 1,
      anon_sym___attribute__,
    ACTIONS(9371), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6527), 1,
      sym__function_attributes_end,
    STATE(6601), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6146), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [214310] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9239), 1,
      anon_sym___attribute__,
    STATE(5935), 1,
      sym_attribute_specifier,
    ACTIONS(6057), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6059), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [214354] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8558), 1,
      anon_sym_STAR,
    ACTIONS(8560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8562), 1,
      anon_sym_AMP,
    ACTIONS(8572), 1,
      anon_sym_const,
    STATE(4705), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7411), 1,
      sym__abstract_declarator,
    STATE(6214), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6965), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8564), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [214416] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym___attribute__,
    ACTIONS(6464), 1,
      anon_sym_LBRACE,
    ACTIONS(9500), 1,
      anon_sym_COLON,
    STATE(2254), 1,
      sym_attribute_specifier,
    STATE(2895), 1,
      sym__enum_base_clause,
    STATE(2970), 1,
      sym_enumerator_list,
    ACTIONS(6280), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6282), 24,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [214468] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8558), 1,
      anon_sym_STAR,
    ACTIONS(8560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8562), 1,
      anon_sym_AMP,
    ACTIONS(8572), 1,
      anon_sym_const,
    STATE(4705), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7433), 1,
      sym__abstract_declarator,
    STATE(6214), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8727), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8564), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [214530] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9239), 1,
      anon_sym___attribute__,
    STATE(5940), 1,
      sym_attribute_specifier,
    ACTIONS(6053), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6055), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [214574] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(5966), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5960), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACE,
    ACTIONS(5958), 25,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [214622] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(8539), 1,
      anon_sym_LPAREN2,
    ACTIONS(8547), 1,
      sym_identifier,
    ACTIONS(8549), 1,
      anon_sym_STAR,
    ACTIONS(8551), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8553), 1,
      anon_sym_AMP,
    STATE(7421), 1,
      sym__field_declarator,
    STATE(7503), 1,
      sym_operator_name,
    STATE(9291), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7265), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [214684] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9239), 1,
      anon_sym___attribute__,
    STATE(5906), 1,
      sym_attribute_specifier,
    ACTIONS(6024), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6026), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [214728] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(8537), 1,
      sym_identifier,
    ACTIONS(8539), 1,
      anon_sym_LPAREN2,
    ACTIONS(8541), 1,
      anon_sym_STAR,
    ACTIONS(8543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8545), 1,
      anon_sym_AMP,
    STATE(6895), 1,
      sym__field_declarator,
    STATE(7119), 1,
      sym_operator_name,
    STATE(9391), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7265), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [214790] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8558), 1,
      anon_sym_STAR,
    ACTIONS(8560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8562), 1,
      anon_sym_AMP,
    ACTIONS(8572), 1,
      anon_sym_const,
    STATE(4705), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7436), 1,
      sym__abstract_declarator,
    STATE(6214), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6235), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8564), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [214852] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9239), 1,
      anon_sym___attribute__,
    STATE(5927), 1,
      sym_attribute_specifier,
    ACTIONS(6144), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6146), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [214896] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9239), 1,
      anon_sym___attribute__,
    STATE(5903), 1,
      sym_attribute_specifier,
    ACTIONS(6094), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6096), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [214940] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8558), 1,
      anon_sym_STAR,
    ACTIONS(8560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8562), 1,
      anon_sym_AMP,
    ACTIONS(8572), 1,
      anon_sym_const,
    STATE(4705), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7425), 1,
      sym__abstract_declarator,
    STATE(6214), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8795), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8564), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [215002] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(8537), 1,
      sym_identifier,
    ACTIONS(8539), 1,
      anon_sym_LPAREN2,
    ACTIONS(8541), 1,
      anon_sym_STAR,
    ACTIONS(8543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8545), 1,
      anon_sym_AMP,
    STATE(6902), 1,
      sym__field_declarator,
    STATE(7119), 1,
      sym_operator_name,
    STATE(9391), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7265), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [215064] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9239), 1,
      anon_sym___attribute__,
    STATE(5910), 1,
      sym_attribute_specifier,
    ACTIONS(6049), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6051), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [215108] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym___attribute__,
    ACTIONS(6851), 1,
      anon_sym_LBRACE,
    ACTIONS(9505), 1,
      anon_sym_COLON,
    STATE(3192), 1,
      sym__enum_base_clause,
    STATE(3234), 1,
      sym_enumerator_list,
    STATE(3412), 1,
      sym_attribute_specifier,
    ACTIONS(6280), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6282), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [215160] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9239), 1,
      anon_sym___attribute__,
    STATE(5923), 1,
      sym_attribute_specifier,
    ACTIONS(6113), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6115), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [215204] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(8537), 1,
      sym_identifier,
    ACTIONS(8539), 1,
      anon_sym_LPAREN2,
    ACTIONS(8541), 1,
      anon_sym_STAR,
    ACTIONS(8543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8545), 1,
      anon_sym_AMP,
    STATE(6935), 1,
      sym__field_declarator,
    STATE(7119), 1,
      sym_operator_name,
    STATE(9391), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7265), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [215266] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9368), 1,
      anon_sym___attribute__,
    ACTIONS(9371), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9377), 1,
      anon_sym_requires,
    STATE(6513), 1,
      sym_trailing_return_type,
    STATE(6548), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6139), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [215338] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8121), 1,
      sym_auto,
    ACTIONS(8123), 1,
      anon_sym_decltype,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8297), 1,
      anon_sym_COLON,
    ACTIONS(8572), 1,
      anon_sym_const,
    ACTIONS(9118), 1,
      anon_sym_STAR,
    ACTIONS(9120), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9122), 1,
      anon_sym_AMP,
    STATE(2285), 1,
      sym_decltype_auto,
    STATE(4696), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7564), 1,
      sym__abstract_declarator,
    STATE(6027), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8564), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [215406] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(6464), 1,
      anon_sym_LBRACE,
    ACTIONS(9507), 1,
      anon_sym_COLON,
    STATE(2284), 1,
      sym_attribute_specifier,
    STATE(5900), 1,
      sym__enum_base_clause,
    STATE(6119), 1,
      sym_enumerator_list,
    ACTIONS(6336), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(6334), 24,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [215458] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym___attribute__,
    ACTIONS(6851), 1,
      anon_sym_LBRACE,
    ACTIONS(9505), 1,
      anon_sym_COLON,
    STATE(3201), 1,
      sym__enum_base_clause,
    STATE(3267), 1,
      sym_enumerator_list,
    STATE(3429), 1,
      sym_attribute_specifier,
    ACTIONS(6334), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6336), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [215510] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8531), 1,
      anon_sym_STAR,
    ACTIONS(8533), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP,
    STATE(4001), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7253), 1,
      sym__abstract_declarator,
    STATE(5876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6235), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [215572] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9239), 1,
      anon_sym___attribute__,
    STATE(5917), 1,
      sym_attribute_specifier,
    ACTIONS(6121), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6123), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [215616] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9509), 1,
      anon_sym___attribute__,
    ACTIONS(9512), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9518), 1,
      anon_sym_requires,
    STATE(6535), 1,
      sym__function_attributes_end,
    STATE(6552), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6138), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9479), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [215688] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8531), 1,
      anon_sym_STAR,
    ACTIONS(8533), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP,
    STATE(4001), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7232), 1,
      sym__abstract_declarator,
    STATE(5876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6965), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [215750] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9509), 1,
      anon_sym___attribute__,
    ACTIONS(9512), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6593), 1,
      sym__function_attributes_end,
    STATE(6597), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6145), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9479), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [215822] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(8539), 1,
      anon_sym_LPAREN2,
    ACTIONS(8547), 1,
      sym_identifier,
    ACTIONS(8549), 1,
      anon_sym_STAR,
    ACTIONS(8551), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8553), 1,
      anon_sym_AMP,
    STATE(7415), 1,
      sym__field_declarator,
    STATE(7503), 1,
      sym_operator_name,
    STATE(9291), 1,
      sym_ms_based_modifier,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7265), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3397), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [215884] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9239), 1,
      anon_sym___attribute__,
    STATE(5912), 1,
      sym_attribute_specifier,
    ACTIONS(6061), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6063), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [215928] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8121), 1,
      sym_auto,
    ACTIONS(8123), 1,
      anon_sym_decltype,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8299), 1,
      anon_sym_COLON,
    ACTIONS(8572), 1,
      anon_sym_const,
    ACTIONS(9118), 1,
      anon_sym_STAR,
    ACTIONS(9120), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9122), 1,
      anon_sym_AMP,
    STATE(2285), 1,
      sym_decltype_auto,
    STATE(4696), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7580), 1,
      sym__abstract_declarator,
    STATE(6024), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8564), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [215996] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(6464), 1,
      anon_sym_LBRACE,
    ACTIONS(9507), 1,
      anon_sym_COLON,
    STATE(2254), 1,
      sym_attribute_specifier,
    STATE(5901), 1,
      sym__enum_base_clause,
    STATE(6128), 1,
      sym_enumerator_list,
    ACTIONS(6282), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(6280), 24,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [216048] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7869), 1,
      anon_sym_DASH_GT,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9521), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6536), 1,
      sym_trailing_return_type,
    STATE(6628), 1,
      sym__function_attributes_end,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9524), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6163), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9479), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [216119] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7900), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9527), 1,
      anon_sym_requires,
    STATE(6514), 1,
      sym_trailing_return_type,
    STATE(6693), 1,
      sym__function_attributes_end,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6164), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9479), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [216190] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7833), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9371), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9377), 1,
      anon_sym_requires,
    STATE(6513), 1,
      sym_trailing_return_type,
    STATE(6599), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9476), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6165), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [216261] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7833), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9512), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9518), 1,
      anon_sym_requires,
    STATE(6552), 1,
      sym_trailing_return_type,
    STATE(6602), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9524), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6157), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9479), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [216332] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8479), 1,
      sym_auto,
    ACTIONS(8481), 1,
      anon_sym_decltype,
    STATE(5943), 1,
      sym_decltype_auto,
    ACTIONS(5499), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5501), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [216377] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7833), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9512), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6537), 1,
      sym__function_attributes_end,
    STATE(6597), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9524), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6170), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9479), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [216448] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7443), 1,
      sym__abstract_declarator,
    STATE(5876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6235), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [216509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5747), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5749), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [216548] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7869), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9527), 1,
      anon_sym_requires,
    STATE(6514), 1,
      sym_trailing_return_type,
    STATE(6610), 1,
      sym__function_attributes_end,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9524), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6156), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9479), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [216619] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7869), 1,
      anon_sym_DASH_GT,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9470), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6540), 1,
      sym_trailing_return_type,
    STATE(6659), 1,
      sym__function_attributes_end,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9476), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6166), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [216690] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7898), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9371), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6601), 1,
      sym_trailing_return_type,
    STATE(6726), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6167), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [216761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5710), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [216800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5724), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5726), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [216839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5634), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5636), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [216878] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5430), 1,
      anon_sym_AMP,
    ACTIONS(9533), 1,
      anon_sym_const,
    STATE(5876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9530), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(5432), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [216923] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(7900), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9521), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6536), 1,
      sym_trailing_return_type,
    STATE(6692), 1,
      sym__function_attributes_end,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6171), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9479), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [216994] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7869), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9470), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9473), 1,
      anon_sym_requires,
    STATE(6617), 1,
      sym__function_attributes_end,
    STATE(6635), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9476), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6176), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [217065] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7898), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9371), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9377), 1,
      anon_sym_requires,
    STATE(6513), 1,
      sym_trailing_return_type,
    STATE(6716), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6153), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [217136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5657), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5659), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [217175] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7898), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9512), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6597), 1,
      sym_trailing_return_type,
    STATE(6704), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6174), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9479), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [217246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5675), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5677), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [217285] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(7900), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9470), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6540), 1,
      sym_trailing_return_type,
    STATE(6756), 1,
      sym__function_attributes_end,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6181), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [217356] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7833), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9371), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6541), 1,
      sym__function_attributes_end,
    STATE(6601), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9476), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6183), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [217427] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7468), 1,
      sym__abstract_declarator,
    STATE(5876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8727), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [217488] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5430), 6,
      anon_sym_AMP,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5432), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(9533), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [217531] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7898), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9512), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9518), 1,
      anon_sym_requires,
    STATE(6552), 1,
      sym_trailing_return_type,
    STATE(6723), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6180), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9479), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [217602] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7478), 1,
      sym__abstract_declarator,
    STATE(5876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8795), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [217663] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7483), 1,
      sym__abstract_declarator,
    STATE(5876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6965), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [217724] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5481), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5483), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [217765] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8820), 1,
      anon_sym_STAR,
    ACTIONS(8822), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8824), 1,
      anon_sym_AMP,
    STATE(4540), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7439), 1,
      sym__abstract_declarator,
    STATE(5876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8727), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [217826] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8820), 1,
      anon_sym_STAR,
    ACTIONS(8822), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8824), 1,
      anon_sym_AMP,
    STATE(4540), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7467), 1,
      sym__abstract_declarator,
    STATE(5876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6235), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [217887] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 1,
      anon_sym_LBRACE,
    ACTIONS(9536), 1,
      anon_sym_LPAREN2,
    STATE(3016), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4310), 1,
      sym_argument_list,
    STATE(5545), 1,
      sym_initializer_list,
    ACTIONS(5481), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6679), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5483), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [217938] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8820), 1,
      anon_sym_STAR,
    ACTIONS(8822), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8824), 1,
      anon_sym_AMP,
    STATE(4540), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7464), 1,
      sym__abstract_declarator,
    STATE(5876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6965), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [217999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5465), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5467), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [218038] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7900), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9470), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9473), 1,
      anon_sym_requires,
    STATE(6635), 1,
      sym_trailing_return_type,
    STATE(6697), 1,
      sym__function_attributes_end,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6162), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [218109] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_const,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8820), 1,
      anon_sym_STAR,
    ACTIONS(8822), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8824), 1,
      anon_sym_AMP,
    STATE(4540), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7479), 1,
      sym__abstract_declarator,
    STATE(5876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8795), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8139), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [218170] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8011), 1,
      anon_sym_requires,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    STATE(6151), 1,
      sym_ref_qualifier,
    STATE(6981), 1,
      sym_trailing_return_type,
    STATE(7153), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9253), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6258), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [218246] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9539), 1,
      sym_ms_restrict_modifier,
    STATE(6148), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(7902), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(9542), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9545), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(7904), 20,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [218294] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(6464), 1,
      anon_sym_LBRACE,
    STATE(2304), 1,
      sym_attribute_specifier,
    STATE(6100), 1,
      sym_enumerator_list,
    ACTIONS(5982), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(5980), 24,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [218340] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(6464), 1,
      anon_sym_LBRACE,
    STATE(2273), 1,
      sym_attribute_specifier,
    STATE(6104), 1,
      sym_enumerator_list,
    ACTIONS(5954), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(5952), 24,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [218386] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6690), 1,
      sym__declarator,
    STATE(8024), 1,
      sym_init_declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [218456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5751), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5753), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [218494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5781), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5783), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [218532] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6694), 1,
      sym__declarator,
    STATE(8289), 1,
      sym_init_declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [218602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5787), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [218640] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6688), 1,
      sym__declarator,
    STATE(8070), 1,
      sym_init_declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [218710] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7961), 1,
      anon_sym_DASH_GT,
    ACTIONS(8033), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9470), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6805), 1,
      sym__function_attributes_end,
    STATE(6924), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6196), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [218780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5789), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5791), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [218818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5771), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5773), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [218856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5793), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5795), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [218894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5755), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5757), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [218932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5686), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [218970] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7992), 1,
      anon_sym_DASH_GT,
    ACTIONS(8011), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    STATE(6870), 1,
      sym__function_attributes_end,
    STATE(6981), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6200), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [219040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5690), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [219078] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8151), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9371), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9548), 1,
      anon_sym_requires,
    STATE(6142), 1,
      sym_ref_qualifier,
    STATE(7001), 1,
      sym__function_attributes_end,
    STATE(7246), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9253), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6297), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [219154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5694), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [219192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5696), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5698), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [219230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5690), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [219268] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9551), 1,
      sym_identifier,
    STATE(5986), 1,
      sym_primitive_type,
    STATE(5989), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5489), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACE,
    ACTIONS(9557), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(9554), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5491), 17,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
  [219316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5481), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5483), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [219354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5712), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5714), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [219392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5722), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [219430] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9494), 1,
      anon_sym_requires,
    STATE(6147), 1,
      sym_ref_qualifier,
    STATE(6984), 1,
      sym_trailing_return_type,
    STATE(7147), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9253), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9257), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6226), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [219506] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7961), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9470), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_requires,
    STATE(6773), 1,
      sym__function_attributes_end,
    STATE(6974), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6201), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [219576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5738), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [219614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5763), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5765), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [219652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5777), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5779), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [219690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5759), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5761), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [219728] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7992), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9560), 1,
      anon_sym_requires,
    STATE(6849), 1,
      sym__function_attributes_end,
    STATE(6913), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9488), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6189), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9479), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [219798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5640), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [219836] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7992), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9494), 1,
      anon_sym_requires,
    STATE(6885), 1,
      sym__function_attributes_end,
    STATE(6984), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9257), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6199), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [219906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5640), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [219944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5642), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5644), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [219982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5648), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [220020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5640), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [220058] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7992), 1,
      anon_sym_DASH_GT,
    ACTIONS(8011), 1,
      anon_sym_requires,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    STATE(6850), 1,
      sym__function_attributes_end,
    STATE(6999), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6190), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9479), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [220128] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7609), 1,
      anon_sym_STAR,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7613), 1,
      anon_sym_AMP,
    ACTIONS(7615), 1,
      anon_sym_COLON_COLON,
    STATE(6577), 1,
      sym__scope_resolution,
    STATE(6664), 1,
      sym__declarator,
    STATE(8365), 1,
      sym_init_declarator,
    STATE(8852), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [220198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5665), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5667), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [220236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5669), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5671), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [220274] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6777), 1,
      sym__declarator,
    STATE(8776), 1,
      sym_init_declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [220344] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7961), 1,
      anon_sym_DASH_GT,
    ACTIONS(8033), 1,
      anon_sym_requires,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9521), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6783), 1,
      sym__function_attributes_end,
    STATE(6916), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6194), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9479), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [220414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5742), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [220452] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5716), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5718), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [220490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5632), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [220528] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6749), 1,
      sym__declarator,
    STATE(8055), 1,
      sym_init_declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [220598] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6744), 1,
      sym__declarator,
    STATE(8365), 1,
      sym_init_declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [220668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5704), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5706), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [220706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5702), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [220744] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6684), 1,
      sym__declarator,
    STATE(8365), 1,
      sym_init_declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [220814] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(9235), 1,
      anon_sym_LBRACE,
    ACTIONS(9563), 1,
      anon_sym_COLON,
    STATE(5624), 1,
      sym__enum_base_clause,
    STATE(5713), 1,
      sym_enumerator_list,
    STATE(5749), 1,
      sym_attribute_specifier,
    ACTIONS(6280), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6282), 21,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [220864] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7961), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9565), 1,
      anon_sym_requires,
    STATE(6788), 1,
      sym__function_attributes_end,
    STATE(6972), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6205), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9479), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [220934] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7665), 1,
      anon_sym_AMP,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8151), 1,
      anon_sym_DASH_GT,
    ACTIONS(8153), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9371), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6150), 1,
      sym_ref_qualifier,
    STATE(7019), 1,
      sym__function_attributes_end,
    STATE(7241), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9253), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6288), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [221010] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6734), 1,
      sym__declarator,
    STATE(8108), 1,
      sym_init_declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [221080] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9265), 1,
      anon_sym_LT,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(5966), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4254), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(9568), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4246), 20,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [221128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5481), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5483), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [221166] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5661), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5663), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [221204] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(9235), 1,
      anon_sym_LBRACE,
    ACTIONS(9563), 1,
      anon_sym_COLON,
    STATE(5646), 1,
      sym__enum_base_clause,
    STATE(5709), 1,
      sym_enumerator_list,
    STATE(5729), 1,
      sym_attribute_specifier,
    ACTIONS(6334), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6336), 21,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [221254] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7706), 1,
      anon_sym_LBRACE,
    ACTIONS(9382), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9570), 1,
      sym_identifier,
    STATE(4373), 1,
      sym_template_type,
    STATE(4675), 1,
      sym_field_declaration_list,
    STATE(4760), 1,
      sym__class_declaration,
    STATE(4781), 1,
      sym__class_declaration_item,
    STATE(6416), 1,
      sym_ms_declspec_modifier,
    STATE(7334), 1,
      sym__scope_resolution,
    STATE(7829), 1,
      sym_virtual_specifier,
    STATE(8778), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3953), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6417), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6109), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [221333] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    ACTIONS(9572), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(5720), 1,
      sym_field_declaration_list,
    STATE(5759), 1,
      sym__class_declaration_item,
    STATE(5782), 1,
      sym__class_declaration,
    STATE(6412), 1,
      sym_ms_declspec_modifier,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(7859), 1,
      sym_virtual_specifier,
    STATE(8491), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5522), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6407), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6105), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [221412] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6477), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9327), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9574), 1,
      sym_identifier,
    STATE(3137), 1,
      sym_template_type,
    STATE(3382), 1,
      sym_field_declaration_list,
    STATE(3549), 1,
      sym__class_declaration,
    STATE(3551), 1,
      sym__class_declaration_item,
    STATE(6369), 1,
      sym_ms_declspec_modifier,
    STATE(7329), 1,
      sym__scope_resolution,
    STATE(7773), 1,
      sym_virtual_specifier,
    STATE(8694), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2898), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6370), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6114), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [221491] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3119), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3516), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [221570] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7266), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [221637] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3149), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3516), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [221716] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7706), 1,
      anon_sym_LBRACE,
    ACTIONS(9382), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9570), 1,
      sym_identifier,
    STATE(4373), 1,
      sym_template_type,
    STATE(4675), 1,
      sym_field_declaration_list,
    STATE(4781), 1,
      sym__class_declaration_item,
    STATE(4807), 1,
      sym__class_declaration,
    STATE(6416), 1,
      sym_ms_declspec_modifier,
    STATE(7334), 1,
      sym__scope_resolution,
    STATE(7829), 1,
      sym_virtual_specifier,
    STATE(8778), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3953), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6417), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6109), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [221795] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2450), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6032), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACE,
    ACTIONS(9578), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6034), 21,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [221836] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7208), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [221903] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2450), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6018), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACE,
    ACTIONS(9581), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6020), 21,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [221944] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7706), 1,
      anon_sym_LBRACE,
    ACTIONS(9382), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9570), 1,
      sym_identifier,
    STATE(4373), 1,
      sym_template_type,
    STATE(4675), 1,
      sym_field_declaration_list,
    STATE(4779), 1,
      sym__class_declaration,
    STATE(4781), 1,
      sym__class_declaration_item,
    STATE(6416), 1,
      sym_ms_declspec_modifier,
    STATE(7334), 1,
      sym__scope_resolution,
    STATE(7829), 1,
      sym_virtual_specifier,
    STATE(8778), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3953), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6417), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6109), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [222023] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9584), 1,
      sym_identifier,
    STATE(3163), 1,
      sym_template_type,
    STATE(3250), 1,
      sym_field_declaration_list,
    STATE(3391), 1,
      sym__class_declaration,
    STATE(3393), 1,
      sym__class_declaration_item,
    STATE(6398), 1,
      sym_ms_declspec_modifier,
    STATE(7361), 1,
      sym__scope_resolution,
    STATE(7872), 1,
      sym_virtual_specifier,
    STATE(8682), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2972), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6107), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [222102] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3104), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3042), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [222181] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9584), 1,
      sym_identifier,
    STATE(3163), 1,
      sym_template_type,
    STATE(3250), 1,
      sym_field_declaration_list,
    STATE(3392), 1,
      sym__class_declaration,
    STATE(3393), 1,
      sym__class_declaration_item,
    STATE(6398), 1,
      sym_ms_declspec_modifier,
    STATE(7361), 1,
      sym__scope_resolution,
    STATE(7872), 1,
      sym_virtual_specifier,
    STATE(8682), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2972), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6107), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [222260] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3104), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3472), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [222339] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(8052), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9502), 1,
      anon_sym_requires,
    STATE(6926), 1,
      sym__function_attributes_end,
    STATE(7150), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9257), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6207), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [222408] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6477), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9327), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9574), 1,
      sym_identifier,
    STATE(3137), 1,
      sym_template_type,
    STATE(3382), 1,
      sym_field_declaration_list,
    STATE(3550), 1,
      sym__class_declaration,
    STATE(3551), 1,
      sym__class_declaration_item,
    STATE(6369), 1,
      sym_ms_declspec_modifier,
    STATE(7329), 1,
      sym__scope_resolution,
    STATE(7773), 1,
      sym_virtual_specifier,
    STATE(8694), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2898), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6370), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6114), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [222487] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7207), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [222554] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6477), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9327), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9574), 1,
      sym_identifier,
    STATE(3137), 1,
      sym_template_type,
    STATE(3382), 1,
      sym_field_declaration_list,
    STATE(3551), 1,
      sym__class_declaration_item,
    STATE(3553), 1,
      sym__class_declaration,
    STATE(6369), 1,
      sym_ms_declspec_modifier,
    STATE(7329), 1,
      sym__scope_resolution,
    STATE(7773), 1,
      sym_virtual_specifier,
    STATE(8694), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2898), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6370), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6114), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [222633] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(3218), 1,
      anon_sym_STAR,
    ACTIONS(3220), 1,
      anon_sym_AMP,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(6516), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    STATE(6657), 1,
      sym__scope_resolution,
    STATE(7396), 1,
      sym__declarator,
    STATE(9597), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [222700] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(3218), 1,
      anon_sym_STAR,
    ACTIONS(3220), 1,
      anon_sym_AMP,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(6516), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    STATE(6657), 1,
      sym__scope_resolution,
    STATE(7394), 1,
      sym__declarator,
    STATE(9597), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [222767] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3149), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3511), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [222846] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(8052), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9586), 1,
      anon_sym_requires,
    STATE(6927), 1,
      sym__function_attributes_end,
    STATE(7157), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9488), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6211), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9479), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [222915] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7251), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [222982] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3119), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3511), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [223061] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7223), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [223128] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5999), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6107), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACE,
    ACTIONS(9589), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6109), 21,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [223169] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5990), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6134), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACE,
    ACTIONS(9592), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6136), 21,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [223210] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3104), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3511), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [223289] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(3218), 1,
      anon_sym_STAR,
    ACTIONS(3220), 1,
      anon_sym_AMP,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(6516), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    STATE(6657), 1,
      sym__scope_resolution,
    STATE(7402), 1,
      sym__declarator,
    STATE(9597), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [223356] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2450), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5730), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACE,
    ACTIONS(9595), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5733), 21,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [223397] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2450), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6090), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACE,
    ACTIONS(9599), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6092), 21,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [223438] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(6235), 1,
      anon_sym_COLON,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8572), 1,
      anon_sym_const,
    ACTIONS(9118), 1,
      anon_sym_STAR,
    ACTIONS(9120), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9122), 1,
      anon_sym_AMP,
    STATE(4696), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7622), 1,
      sym__abstract_declarator,
    STATE(6214), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8564), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [223497] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3119), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3042), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [223576] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(5720), 1,
      sym_field_declaration_list,
    STATE(5758), 1,
      sym__class_declaration,
    STATE(5759), 1,
      sym__class_declaration_item,
    STATE(6402), 1,
      sym_ms_declspec_modifier,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(7859), 1,
      sym_virtual_specifier,
    STATE(8491), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5522), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6404), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6122), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [223655] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(5720), 1,
      sym_field_declaration_list,
    STATE(5759), 1,
      sym__class_declaration_item,
    STATE(5782), 1,
      sym__class_declaration,
    STATE(6402), 1,
      sym_ms_declspec_modifier,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(7859), 1,
      sym_virtual_specifier,
    STATE(8491), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5522), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6404), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6122), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [223734] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(5720), 1,
      sym_field_declaration_list,
    STATE(5759), 1,
      sym__class_declaration_item,
    STATE(5774), 1,
      sym__class_declaration,
    STATE(6402), 1,
      sym_ms_declspec_modifier,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(7859), 1,
      sym_virtual_specifier,
    STATE(8491), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5522), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6404), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6122), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [223813] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(3218), 1,
      anon_sym_STAR,
    ACTIONS(3220), 1,
      anon_sym_AMP,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(6516), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    STATE(6657), 1,
      sym__scope_resolution,
    STATE(7414), 1,
      sym__declarator,
    STATE(9597), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [223880] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7891), 1,
      anon_sym_LBRACE,
    ACTIONS(9273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9604), 1,
      sym_identifier,
    STATE(4593), 1,
      sym_template_type,
    STATE(4800), 1,
      sym_field_declaration_list,
    STATE(4896), 1,
      sym__class_declaration_item,
    STATE(4897), 1,
      sym__class_declaration,
    STATE(6352), 1,
      sym_ms_declspec_modifier,
    STATE(7337), 1,
      sym__scope_resolution,
    STATE(7709), 1,
      sym_virtual_specifier,
    STATE(8651), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4267), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6397), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6115), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [223959] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7891), 1,
      anon_sym_LBRACE,
    ACTIONS(9273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9604), 1,
      sym_identifier,
    STATE(4593), 1,
      sym_template_type,
    STATE(4800), 1,
      sym_field_declaration_list,
    STATE(4895), 1,
      sym__class_declaration,
    STATE(4896), 1,
      sym__class_declaration_item,
    STATE(6352), 1,
      sym_ms_declspec_modifier,
    STATE(7337), 1,
      sym__scope_resolution,
    STATE(7709), 1,
      sym_virtual_specifier,
    STATE(8651), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4267), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6397), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6115), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [224038] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2450), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6103), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACE,
    ACTIONS(9606), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(6105), 21,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [224079] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7249), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [224146] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    ACTIONS(9609), 1,
      anon_sym_COLON_COLON,
    STATE(2836), 1,
      sym_template_type,
    STATE(3149), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6361), 1,
      sym_ms_declspec_modifier,
    STATE(7365), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4718), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6360), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6135), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [224225] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    ACTIONS(9609), 1,
      anon_sym_COLON_COLON,
    STATE(2836), 1,
      sym_template_type,
    STATE(3119), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6361), 1,
      sym_ms_declspec_modifier,
    STATE(7365), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4718), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6360), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6135), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [224304] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    ACTIONS(9609), 1,
      anon_sym_COLON_COLON,
    STATE(2836), 1,
      sym_template_type,
    STATE(3104), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6361), 1,
      sym_ms_declspec_modifier,
    STATE(7365), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4718), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6360), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6135), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [224383] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7891), 1,
      anon_sym_LBRACE,
    ACTIONS(9273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9604), 1,
      sym_identifier,
    STATE(4593), 1,
      sym_template_type,
    STATE(4800), 1,
      sym_field_declaration_list,
    STATE(4894), 1,
      sym__class_declaration,
    STATE(4896), 1,
      sym__class_declaration_item,
    STATE(6352), 1,
      sym_ms_declspec_modifier,
    STATE(7337), 1,
      sym__scope_resolution,
    STATE(7709), 1,
      sym_virtual_specifier,
    STATE(8651), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4267), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6397), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6115), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [224462] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7203), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [224529] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7609), 1,
      anon_sym_STAR,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7613), 1,
      anon_sym_AMP,
    ACTIONS(7615), 1,
      anon_sym_COLON_COLON,
    STATE(6577), 1,
      sym__scope_resolution,
    STATE(6943), 1,
      sym__declarator,
    STATE(8852), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [224596] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7206), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [224663] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9611), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2269), 1,
      sym__class_declaration,
    STATE(2270), 1,
      sym__class_declaration_item,
    STATE(2991), 1,
      sym_field_declaration_list,
    STATE(6351), 1,
      sym_ms_declspec_modifier,
    STATE(7347), 1,
      sym__scope_resolution,
    STATE(7761), 1,
      sym_virtual_specifier,
    STATE(8591), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2798), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6350), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6117), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [224742] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9611), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2244), 1,
      sym__class_declaration,
    STATE(2270), 1,
      sym__class_declaration_item,
    STATE(2991), 1,
      sym_field_declaration_list,
    STATE(6351), 1,
      sym_ms_declspec_modifier,
    STATE(7347), 1,
      sym__scope_resolution,
    STATE(7761), 1,
      sym_virtual_specifier,
    STATE(8591), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2798), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6350), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6117), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [224821] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9611), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2270), 1,
      sym__class_declaration_item,
    STATE(2276), 1,
      sym__class_declaration,
    STATE(2991), 1,
      sym_field_declaration_list,
    STATE(6351), 1,
      sym_ms_declspec_modifier,
    STATE(7347), 1,
      sym__scope_resolution,
    STATE(7761), 1,
      sym_virtual_specifier,
    STATE(8591), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2798), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6350), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6117), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [224900] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8017), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(3163), 1,
      sym_template_type,
    STATE(3250), 1,
      sym_field_declaration_list,
    STATE(3392), 1,
      sym__class_declaration,
    STATE(3393), 1,
      sym__class_declaration_item,
    STATE(6358), 1,
      sym_ms_declspec_modifier,
    STATE(7325), 1,
      sym__scope_resolution,
    STATE(7872), 1,
      sym_virtual_specifier,
    STATE(8682), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2972), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6131), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [224979] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3119), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3472), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [225058] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6208), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9307), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(3015), 1,
      sym_template_type,
    STATE(3170), 1,
      sym_field_declaration_list,
    STATE(3319), 1,
      sym__class_declaration,
    STATE(3344), 1,
      sym__class_declaration_item,
    STATE(6388), 1,
      sym_ms_declspec_modifier,
    STATE(7340), 1,
      sym__scope_resolution,
    STATE(7650), 1,
      sym_virtual_specifier,
    STATE(8572), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2762), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6439), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6111), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [225137] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7234), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [225204] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6208), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9307), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(3015), 1,
      sym_template_type,
    STATE(3170), 1,
      sym_field_declaration_list,
    STATE(3344), 1,
      sym__class_declaration_item,
    STATE(3387), 1,
      sym__class_declaration,
    STATE(6388), 1,
      sym_ms_declspec_modifier,
    STATE(7340), 1,
      sym__scope_resolution,
    STATE(7650), 1,
      sym_virtual_specifier,
    STATE(8572), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2762), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6439), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6111), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [225283] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3149), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3482), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [225362] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6208), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9307), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(3015), 1,
      sym_template_type,
    STATE(3170), 1,
      sym_field_declaration_list,
    STATE(3344), 1,
      sym__class_declaration_item,
    STATE(3384), 1,
      sym__class_declaration,
    STATE(6388), 1,
      sym_ms_declspec_modifier,
    STATE(7340), 1,
      sym__scope_resolution,
    STATE(7650), 1,
      sym_virtual_specifier,
    STATE(8572), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2762), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6439), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6111), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [225441] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3119), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3482), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [225520] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3104), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3482), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [225599] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7261), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [225666] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3149), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3472), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [225745] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7258), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [225812] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6649), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9347), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    STATE(3164), 1,
      sym_template_type,
    STATE(3490), 1,
      sym_field_declaration_list,
    STATE(3733), 1,
      sym__class_declaration_item,
    STATE(3739), 1,
      sym__class_declaration,
    STATE(6413), 1,
      sym_ms_declspec_modifier,
    STATE(7346), 1,
      sym__scope_resolution,
    STATE(7720), 1,
      sym_virtual_specifier,
    STATE(8562), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3000), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6408), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6112), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [225891] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8572), 1,
      anon_sym_const,
    ACTIONS(8727), 1,
      anon_sym_COLON,
    ACTIONS(9118), 1,
      anon_sym_STAR,
    ACTIONS(9120), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9122), 1,
      anon_sym_AMP,
    STATE(4696), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7612), 1,
      sym__abstract_declarator,
    STATE(6214), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8564), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [225950] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9584), 1,
      sym_identifier,
    STATE(3163), 1,
      sym_template_type,
    STATE(3250), 1,
      sym_field_declaration_list,
    STATE(3393), 1,
      sym__class_declaration_item,
    STATE(3394), 1,
      sym__class_declaration,
    STATE(6398), 1,
      sym_ms_declspec_modifier,
    STATE(7361), 1,
      sym__scope_resolution,
    STATE(7872), 1,
      sym_virtual_specifier,
    STATE(8682), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2972), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6107), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [226029] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3149), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3403), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [226108] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8572), 1,
      anon_sym_const,
    ACTIONS(8795), 1,
      anon_sym_COLON,
    ACTIONS(9118), 1,
      anon_sym_STAR,
    ACTIONS(9120), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9122), 1,
      anon_sym_AMP,
    STATE(4696), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7579), 1,
      sym__abstract_declarator,
    STATE(6214), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8564), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [226167] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3104), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3487), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [226246] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3119), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3487), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [226325] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      anon_sym_STAR,
    ACTIONS(7712), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7714), 1,
      anon_sym_AMP,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(6990), 1,
      sym__declarator,
    STATE(9696), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [226392] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3104), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3516), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [226471] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(3218), 1,
      anon_sym_STAR,
    ACTIONS(3220), 1,
      anon_sym_AMP,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(6516), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    STATE(6657), 1,
      sym__scope_resolution,
    STATE(7399), 1,
      sym__declarator,
    STATE(9597), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [226538] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3149), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3487), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [226617] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3149), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3476), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [226696] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7209), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [226763] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3119), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3476), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [226842] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3104), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3493), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [226921] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3119), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3493), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [227000] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3149), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3493), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [227079] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3104), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3476), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [227158] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5105), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9619), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3149), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6429), 1,
      sym_ms_declspec_modifier,
    STATE(7326), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3042), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6427), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6126), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [227237] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5105), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9619), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3119), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6429), 1,
      sym_ms_declspec_modifier,
    STATE(7326), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3042), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6427), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6126), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [227316] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 1,
      sym_auto,
    ACTIONS(5505), 1,
      anon_sym_decltype,
    STATE(2285), 1,
      sym_decltype_auto,
    ACTIONS(9623), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(6161), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9621), 9,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [227363] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2297), 1,
      anon_sym_LBRACE,
    ACTIONS(7720), 1,
      anon_sym_LPAREN2,
    STATE(2666), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4081), 1,
      sym_argument_list,
    STATE(4082), 1,
      sym_initializer_list,
    ACTIONS(5481), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6047), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5483), 18,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
  [227412] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(5475), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9625), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2682), 1,
      sym_field_declaration_list,
    STATE(2735), 1,
      sym__class_declaration_item,
    STATE(2749), 1,
      sym__class_declaration,
    STATE(6340), 1,
      sym_ms_declspec_modifier,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(7778), 1,
      sym_virtual_specifier,
    STATE(8430), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2121), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6349), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6106), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [227491] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(6965), 1,
      anon_sym_COLON,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8572), 1,
      anon_sym_const,
    ACTIONS(9118), 1,
      anon_sym_STAR,
    ACTIONS(9120), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9122), 1,
      anon_sym_AMP,
    STATE(4696), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7595), 1,
      sym__abstract_declarator,
    STATE(6214), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8564), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [227550] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7278), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [227617] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3104), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3463), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [227696] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3149), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3042), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [227775] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9241), 1,
      anon_sym_LBRACE,
    ACTIONS(9627), 1,
      sym_identifier,
    STATE(5567), 1,
      sym_template_type,
    STATE(5831), 1,
      sym_field_declaration_list,
    STATE(5944), 1,
      sym__class_declaration,
    STATE(5948), 1,
      sym__class_declaration_item,
    STATE(6343), 1,
      sym_ms_declspec_modifier,
    STATE(7328), 1,
      sym__scope_resolution,
    STATE(7890), 1,
      sym_virtual_specifier,
    STATE(8705), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5562), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6345), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6108), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [227854] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5105), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9619), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3104), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6429), 1,
      sym_ms_declspec_modifier,
    STATE(7326), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3042), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6427), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6126), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [227933] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7224), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [228000] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8017), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(3163), 1,
      sym_template_type,
    STATE(3250), 1,
      sym_field_declaration_list,
    STATE(3391), 1,
      sym__class_declaration,
    STATE(3393), 1,
      sym__class_declaration_item,
    STATE(6358), 1,
      sym_ms_declspec_modifier,
    STATE(7325), 1,
      sym__scope_resolution,
    STATE(7872), 1,
      sym_virtual_specifier,
    STATE(8682), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2972), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6131), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [228079] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    ACTIONS(9572), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(5720), 1,
      sym_field_declaration_list,
    STATE(5759), 1,
      sym__class_declaration_item,
    STATE(5774), 1,
      sym__class_declaration,
    STATE(6412), 1,
      sym_ms_declspec_modifier,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(7859), 1,
      sym_virtual_specifier,
    STATE(8491), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5522), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6407), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6105), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [228158] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3119), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3463), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [228237] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7245), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [228304] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9241), 1,
      anon_sym_LBRACE,
    ACTIONS(9627), 1,
      sym_identifier,
    STATE(5567), 1,
      sym_template_type,
    STATE(5831), 1,
      sym_field_declaration_list,
    STATE(5945), 1,
      sym__class_declaration,
    STATE(5948), 1,
      sym__class_declaration_item,
    STATE(6343), 1,
      sym_ms_declspec_modifier,
    STATE(7328), 1,
      sym__scope_resolution,
    STATE(7890), 1,
      sym_virtual_specifier,
    STATE(8705), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5562), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6345), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6108), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [228383] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3149), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3463), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [228462] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7216), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [228529] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9241), 1,
      anon_sym_LBRACE,
    ACTIONS(9627), 1,
      sym_identifier,
    STATE(5567), 1,
      sym_template_type,
    STATE(5831), 1,
      sym_field_declaration_list,
    STATE(5948), 1,
      sym__class_declaration_item,
    STATE(5949), 1,
      sym__class_declaration,
    STATE(6343), 1,
      sym_ms_declspec_modifier,
    STATE(7328), 1,
      sym__scope_resolution,
    STATE(7890), 1,
      sym_virtual_specifier,
    STATE(8705), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5562), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6345), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6108), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [228608] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 1,
      sym_auto,
    ACTIONS(5505), 1,
      anon_sym_decltype,
    STATE(2285), 1,
      sym_decltype_auto,
    ACTIONS(9631), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(6178), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9629), 9,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [228655] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8017), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(3163), 1,
      sym_template_type,
    STATE(3250), 1,
      sym_field_declaration_list,
    STATE(3393), 1,
      sym__class_declaration_item,
    STATE(3394), 1,
      sym__class_declaration,
    STATE(6358), 1,
      sym_ms_declspec_modifier,
    STATE(7325), 1,
      sym__scope_resolution,
    STATE(7872), 1,
      sym_virtual_specifier,
    STATE(8682), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2972), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6131), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [228734] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(3218), 1,
      anon_sym_STAR,
    ACTIONS(3220), 1,
      anon_sym_AMP,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(6516), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    STATE(6657), 1,
      sym__scope_resolution,
    STATE(7393), 1,
      sym__declarator,
    STATE(9597), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [228801] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(3218), 1,
      anon_sym_STAR,
    ACTIONS(3220), 1,
      anon_sym_AMP,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(6516), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    STATE(6657), 1,
      sym__scope_resolution,
    STATE(7224), 1,
      sym__declarator,
    STATE(9597), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [228868] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7621), 1,
      anon_sym_STAR,
    ACTIONS(7623), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7625), 1,
      anon_sym_AMP,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(7291), 1,
      sym__declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [228935] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7519), 1,
      anon_sym_STAR,
    ACTIONS(7521), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7523), 1,
      anon_sym_AMP,
    ACTIONS(7525), 1,
      anon_sym_COLON_COLON,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(7435), 1,
      sym__declarator,
    STATE(8999), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [229002] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9633), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2270), 1,
      sym__class_declaration_item,
    STATE(2276), 1,
      sym__class_declaration,
    STATE(6097), 1,
      sym_field_declaration_list,
    STATE(6393), 1,
      sym_ms_declspec_modifier,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(7746), 1,
      sym_virtual_specifier,
    STATE(8511), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6395), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6120), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [229081] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9633), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2244), 1,
      sym__class_declaration,
    STATE(2270), 1,
      sym__class_declaration_item,
    STATE(6097), 1,
      sym_field_declaration_list,
    STATE(6393), 1,
      sym_ms_declspec_modifier,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(7746), 1,
      sym_virtual_specifier,
    STATE(8511), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6395), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6120), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [229160] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3119), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3403), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [229239] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3104), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6392), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3403), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6433), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6113), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [229318] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9635), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2270), 1,
      sym__class_declaration_item,
    STATE(2276), 1,
      sym__class_declaration,
    STATE(2991), 1,
      sym_field_declaration_list,
    STATE(6338), 1,
      sym_ms_declspec_modifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(7761), 1,
      sym_virtual_specifier,
    STATE(8591), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2798), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6337), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6125), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [229397] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9633), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2269), 1,
      sym__class_declaration,
    STATE(2270), 1,
      sym__class_declaration_item,
    STATE(6097), 1,
      sym_field_declaration_list,
    STATE(6393), 1,
      sym_ms_declspec_modifier,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(7746), 1,
      sym_virtual_specifier,
    STATE(8511), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6395), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6120), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [229476] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(5475), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9625), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2682), 1,
      sym_field_declaration_list,
    STATE(2735), 1,
      sym__class_declaration_item,
    STATE(2747), 1,
      sym__class_declaration,
    STATE(6340), 1,
      sym_ms_declspec_modifier,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(7778), 1,
      sym_virtual_specifier,
    STATE(8430), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2121), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6349), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6106), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [229555] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    ACTIONS(9572), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(5720), 1,
      sym_field_declaration_list,
    STATE(5758), 1,
      sym__class_declaration,
    STATE(5759), 1,
      sym__class_declaration_item,
    STATE(6412), 1,
      sym_ms_declspec_modifier,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(7859), 1,
      sym_virtual_specifier,
    STATE(8491), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5522), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6407), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6105), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [229634] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9635), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2244), 1,
      sym__class_declaration,
    STATE(2270), 1,
      sym__class_declaration_item,
    STATE(2991), 1,
      sym_field_declaration_list,
    STATE(6338), 1,
      sym_ms_declspec_modifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(7761), 1,
      sym_virtual_specifier,
    STATE(8591), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2798), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6337), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6125), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [229713] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6221), 1,
      sym_identifier,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7621), 1,
      anon_sym_STAR,
    ACTIONS(7623), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7625), 1,
      anon_sym_AMP,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(7175), 1,
      sym__declarator,
    STATE(8936), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [229780] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6649), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9347), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    STATE(3164), 1,
      sym_template_type,
    STATE(3490), 1,
      sym_field_declaration_list,
    STATE(3732), 1,
      sym__class_declaration,
    STATE(3733), 1,
      sym__class_declaration_item,
    STATE(6413), 1,
      sym_ms_declspec_modifier,
    STATE(7346), 1,
      sym__scope_resolution,
    STATE(7720), 1,
      sym_virtual_specifier,
    STATE(8562), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3000), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6408), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6112), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [229859] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6649), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9347), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    STATE(3164), 1,
      sym_template_type,
    STATE(3490), 1,
      sym_field_declaration_list,
    STATE(3730), 1,
      sym__class_declaration,
    STATE(3733), 1,
      sym__class_declaration_item,
    STATE(6413), 1,
      sym_ms_declspec_modifier,
    STATE(7346), 1,
      sym__scope_resolution,
    STATE(7720), 1,
      sym_virtual_specifier,
    STATE(8562), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3000), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6408), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6112), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [229938] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9572), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3104), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(4670), 1,
      sym_field_declaration_list,
    STATE(6377), 1,
      sym_ms_declspec_modifier,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(7772), 1,
      sym_virtual_specifier,
    STATE(8472), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4122), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6386), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6121), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [230017] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    ACTIONS(9450), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9637), 1,
      sym_identifier,
    STATE(3375), 1,
      sym_template_type,
    STATE(3846), 1,
      sym_field_declaration_list,
    STATE(4036), 1,
      sym__class_declaration,
    STATE(4037), 1,
      sym__class_declaration_item,
    STATE(6438), 1,
      sym_ms_declspec_modifier,
    STATE(7350), 1,
      sym__scope_resolution,
    STATE(7743), 1,
      sym_virtual_specifier,
    STATE(8461), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3124), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6367), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6123), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [230096] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9635), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2269), 1,
      sym__class_declaration,
    STATE(2270), 1,
      sym__class_declaration_item,
    STATE(2991), 1,
      sym_field_declaration_list,
    STATE(6338), 1,
      sym_ms_declspec_modifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(7761), 1,
      sym_virtual_specifier,
    STATE(8591), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2798), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6337), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6125), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [230175] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7273), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [230242] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3104), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(4670), 1,
      sym_field_declaration_list,
    STATE(6353), 1,
      sym_ms_declspec_modifier,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(7772), 1,
      sym_virtual_specifier,
    STATE(8472), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4122), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6364), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6129), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [230321] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3119), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(4670), 1,
      sym_field_declaration_list,
    STATE(6353), 1,
      sym_ms_declspec_modifier,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(7772), 1,
      sym_virtual_specifier,
    STATE(8472), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4122), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6364), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6129), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [230400] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7280), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [230467] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3149), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(4670), 1,
      sym_field_declaration_list,
    STATE(6353), 1,
      sym_ms_declspec_modifier,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(7772), 1,
      sym_virtual_specifier,
    STATE(8472), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4122), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6364), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6129), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [230546] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    ACTIONS(9450), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9637), 1,
      sym_identifier,
    STATE(3375), 1,
      sym_template_type,
    STATE(3846), 1,
      sym_field_declaration_list,
    STATE(4037), 1,
      sym__class_declaration_item,
    STATE(4038), 1,
      sym__class_declaration,
    STATE(6438), 1,
      sym_ms_declspec_modifier,
    STATE(7350), 1,
      sym__scope_resolution,
    STATE(7743), 1,
      sym_virtual_specifier,
    STATE(8461), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3124), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6367), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6123), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [230625] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    ACTIONS(9450), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9637), 1,
      sym_identifier,
    STATE(3375), 1,
      sym_template_type,
    STATE(3846), 1,
      sym_field_declaration_list,
    STATE(4037), 1,
      sym__class_declaration_item,
    STATE(4039), 1,
      sym__class_declaration,
    STATE(6438), 1,
      sym_ms_declspec_modifier,
    STATE(7350), 1,
      sym__scope_resolution,
    STATE(7743), 1,
      sym_virtual_specifier,
    STATE(8461), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3124), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6367), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6123), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [230704] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_STAR,
    ACTIONS(7631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(7220), 1,
      sym__declarator,
    STATE(8912), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [230771] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9572), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3119), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(4670), 1,
      sym_field_declaration_list,
    STATE(6377), 1,
      sym_ms_declspec_modifier,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(7772), 1,
      sym_virtual_specifier,
    STATE(8472), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4122), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6386), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6121), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [230850] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9572), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3149), 1,
      sym__class_declaration,
    STATE(3150), 1,
      sym__class_declaration_item,
    STATE(4670), 1,
      sym_field_declaration_list,
    STATE(6377), 1,
      sym_ms_declspec_modifier,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(7772), 1,
      sym_virtual_specifier,
    STATE(8472), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4122), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6386), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6121), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [230929] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(8052), 1,
      anon_sym_DASH_GT,
    ACTIONS(8057), 1,
      anon_sym_requires,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    STATE(6900), 1,
      sym__function_attributes_end,
    STATE(7135), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6216), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9479), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [230998] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(8052), 1,
      anon_sym_DASH_GT,
    ACTIONS(8057), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    STATE(6933), 1,
      sym__function_attributes_end,
    STATE(7136), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6217), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9253), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [231067] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(5475), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9625), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2682), 1,
      sym_field_declaration_list,
    STATE(2732), 1,
      sym__class_declaration,
    STATE(2735), 1,
      sym__class_declaration_item,
    STATE(6340), 1,
      sym_ms_declspec_modifier,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(7778), 1,
      sym_virtual_specifier,
    STATE(8430), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2121), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6349), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6106), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [231146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5968), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5726), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACE,
    ACTIONS(5724), 25,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [231185] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(7517), 1,
      anon_sym_LBRACK,
    ACTIONS(7519), 1,
      anon_sym_STAR,
    ACTIONS(7521), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7523), 1,
      anon_sym_AMP,
    ACTIONS(7525), 1,
      anon_sym_COLON_COLON,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(7397), 1,
      sym__declarator,
    STATE(8999), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7008), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [231252] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(2248), 1,
      sym_attribute_specifier,
    ACTIONS(6059), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(6057), 24,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [231292] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7675), 1,
      anon_sym_DASH_GT,
    ACTIONS(7725), 1,
      anon_sym_requires,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    STATE(6666), 1,
      sym__function_attributes_end,
    STATE(6776), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6923), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [231354] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(2292), 1,
      sym_attribute_specifier,
    ACTIONS(6146), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(6144), 24,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [231394] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(2289), 1,
      sym_attribute_specifier,
    ACTIONS(6096), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(6094), 24,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [231434] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(2300), 1,
      sym_attribute_specifier,
    ACTIONS(6026), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(6024), 24,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [231474] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7675), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9260), 1,
      anon_sym_requires,
    STATE(6668), 1,
      sym__function_attributes_end,
    STATE(6765), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9257), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [231536] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(2302), 1,
      sym_attribute_specifier,
    ACTIONS(6030), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(6028), 24,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [231576] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(2296), 1,
      sym_attribute_specifier,
    ACTIONS(6051), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(6049), 24,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [231616] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    ACTIONS(9572), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(5720), 1,
      sym_field_declaration_list,
    STATE(5789), 1,
      sym__class_declaration_item,
    STATE(6335), 1,
      sym_ms_declspec_modifier,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(7859), 1,
      sym_virtual_specifier,
    STATE(8491), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5522), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6348), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6867), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [231692] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(5475), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9625), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2682), 1,
      sym_field_declaration_list,
    STATE(2737), 1,
      sym__class_declaration_item,
    STATE(6356), 1,
      sym_ms_declspec_modifier,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(7778), 1,
      sym_virtual_specifier,
    STATE(8430), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2121), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6355), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6867), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [231768] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9584), 1,
      sym_identifier,
    STATE(3163), 1,
      sym_template_type,
    STATE(3250), 1,
      sym_field_declaration_list,
    STATE(3421), 1,
      sym__class_declaration_item,
    STATE(6373), 1,
      sym_ms_declspec_modifier,
    STATE(7361), 1,
      sym__scope_resolution,
    STATE(7872), 1,
      sym_virtual_specifier,
    STATE(8682), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2972), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6374), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6867), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [231844] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9241), 1,
      anon_sym_LBRACE,
    ACTIONS(9627), 1,
      sym_identifier,
    STATE(5567), 1,
      sym_template_type,
    STATE(5831), 1,
      sym_field_declaration_list,
    STATE(5931), 1,
      sym__class_declaration_item,
    STATE(6336), 1,
      sym_ms_declspec_modifier,
    STATE(7328), 1,
      sym__scope_resolution,
    STATE(7890), 1,
      sym_virtual_specifier,
    STATE(8705), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5562), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6344), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6867), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [231920] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7706), 1,
      anon_sym_LBRACE,
    ACTIONS(9382), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9570), 1,
      sym_identifier,
    STATE(4373), 1,
      sym_template_type,
    STATE(4675), 1,
      sym_field_declaration_list,
    STATE(4790), 1,
      sym__class_declaration_item,
    STATE(6420), 1,
      sym_ms_declspec_modifier,
    STATE(7334), 1,
      sym__scope_resolution,
    STATE(7829), 1,
      sym_virtual_specifier,
    STATE(8778), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3953), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6867), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [231996] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7675), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9491), 1,
      anon_sym_requires,
    STATE(6667), 1,
      sym__function_attributes_end,
    STATE(6781), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9488), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [232058] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6208), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9307), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(3015), 1,
      sym_template_type,
    STATE(3170), 1,
      sym_field_declaration_list,
    STATE(3346), 1,
      sym__class_declaration_item,
    STATE(6436), 1,
      sym_ms_declspec_modifier,
    STATE(7340), 1,
      sym__scope_resolution,
    STATE(7650), 1,
      sym_virtual_specifier,
    STATE(8572), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2762), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6333), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6867), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [232134] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6649), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9347), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    STATE(3164), 1,
      sym_template_type,
    STATE(3490), 1,
      sym_field_declaration_list,
    STATE(3679), 1,
      sym__class_declaration_item,
    STATE(6399), 1,
      sym_ms_declspec_modifier,
    STATE(7346), 1,
      sym__scope_resolution,
    STATE(7720), 1,
      sym_virtual_specifier,
    STATE(8562), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3000), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6400), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6867), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [232210] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3120), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6371), 1,
      sym_ms_declspec_modifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3042), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6362), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6867), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [232286] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6477), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9327), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9574), 1,
      sym_identifier,
    STATE(3137), 1,
      sym_template_type,
    STATE(3382), 1,
      sym_field_declaration_list,
    STATE(3558), 1,
      sym__class_declaration_item,
    STATE(6376), 1,
      sym_ms_declspec_modifier,
    STATE(7329), 1,
      sym__scope_resolution,
    STATE(7773), 1,
      sym_virtual_specifier,
    STATE(8694), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2898), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6375), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6867), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [232362] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7891), 1,
      anon_sym_LBRACE,
    ACTIONS(9273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9604), 1,
      sym_identifier,
    STATE(4593), 1,
      sym_template_type,
    STATE(4800), 1,
      sym_field_declaration_list,
    STATE(4853), 1,
      sym__class_declaration_item,
    STATE(6365), 1,
      sym_ms_declspec_modifier,
    STATE(7337), 1,
      sym__scope_resolution,
    STATE(7709), 1,
      sym_virtual_specifier,
    STATE(8651), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4267), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6363), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6867), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [232438] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(2256), 1,
      sym_attribute_specifier,
    ACTIONS(6055), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(6053), 24,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [232478] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9611), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2303), 1,
      sym__class_declaration_item,
    STATE(2991), 1,
      sym_field_declaration_list,
    STATE(6341), 1,
      sym_ms_declspec_modifier,
    STATE(7347), 1,
      sym__scope_resolution,
    STATE(7761), 1,
      sym_virtual_specifier,
    STATE(8591), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2798), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6406), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6867), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [232554] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7675), 1,
      anon_sym_DASH_GT,
    ACTIONS(7725), 1,
      anon_sym_requires,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    STATE(6676), 1,
      sym__function_attributes_end,
    STATE(6782), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [232616] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(2290), 1,
      sym_attribute_specifier,
    ACTIONS(6063), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(6061), 24,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [232656] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9633), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2303), 1,
      sym__class_declaration_item,
    STATE(6097), 1,
      sym_field_declaration_list,
    STATE(6405), 1,
      sym_ms_declspec_modifier,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(7746), 1,
      sym_virtual_specifier,
    STATE(8511), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6403), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6867), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [232732] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9572), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3120), 1,
      sym__class_declaration_item,
    STATE(4670), 1,
      sym_field_declaration_list,
    STATE(6425), 1,
      sym_ms_declspec_modifier,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(7772), 1,
      sym_virtual_specifier,
    STATE(8472), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4122), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6426), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6867), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [232808] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(5720), 1,
      sym_field_declaration_list,
    STATE(5789), 1,
      sym__class_declaration_item,
    STATE(6435), 1,
      sym_ms_declspec_modifier,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(7859), 1,
      sym_virtual_specifier,
    STATE(8491), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5522), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6434), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6867), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [232884] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    ACTIONS(9450), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9637), 1,
      sym_identifier,
    STATE(3375), 1,
      sym_template_type,
    STATE(3846), 1,
      sym_field_declaration_list,
    STATE(4070), 1,
      sym__class_declaration_item,
    STATE(6423), 1,
      sym_ms_declspec_modifier,
    STATE(7350), 1,
      sym__scope_resolution,
    STATE(7743), 1,
      sym_virtual_specifier,
    STATE(8461), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3124), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6422), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6867), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [232960] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9643), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6212), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(6210), 15,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_template,
      anon_sym_try,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_requires,
  [233000] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9635), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2303), 1,
      sym__class_declaration_item,
    STATE(2991), 1,
      sym_field_declaration_list,
    STATE(6380), 1,
      sym_ms_declspec_modifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(7761), 1,
      sym_virtual_specifier,
    STATE(8591), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2798), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6379), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6867), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [233076] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5105), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9619), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3120), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6385), 1,
      sym_ms_declspec_modifier,
    STATE(7326), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3042), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6391), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6867), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [233152] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(2298), 1,
      sym_attribute_specifier,
    ACTIONS(6084), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(6082), 24,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [233192] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(2277), 1,
      sym_attribute_specifier,
    ACTIONS(6115), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(6113), 24,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [233232] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3120), 1,
      sym__class_declaration_item,
    STATE(4670), 1,
      sym_field_declaration_list,
    STATE(6384), 1,
      sym_ms_declspec_modifier,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(7772), 1,
      sym_virtual_specifier,
    STATE(8472), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4122), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6382), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6867), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [233308] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(2268), 1,
      sym_attribute_specifier,
    ACTIONS(6119), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(6117), 24,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [233348] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8017), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(3163), 1,
      sym_template_type,
    STATE(3250), 1,
      sym_field_declaration_list,
    STATE(3421), 1,
      sym__class_declaration_item,
    STATE(6347), 1,
      sym_ms_declspec_modifier,
    STATE(7325), 1,
      sym__scope_resolution,
    STATE(7872), 1,
      sym_virtual_specifier,
    STATE(8682), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2972), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6346), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6867), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [233424] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7675), 1,
      anon_sym_DASH_GT,
    ACTIONS(7725), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    STATE(6671), 1,
      sym__function_attributes_end,
    STATE(6799), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [233486] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(2267), 1,
      sym_attribute_specifier,
    ACTIONS(6123), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(6121), 24,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [233526] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7675), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9649), 1,
      anon_sym_requires,
    STATE(6665), 1,
      sym__function_attributes_end,
    STATE(6780), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9646), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6923), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [233588] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5453), 1,
      anon_sym___attribute__,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5459), 1,
      anon_sym___declspec,
    ACTIONS(5463), 1,
      anon_sym_alignas,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    ACTIONS(9609), 1,
      anon_sym_COLON_COLON,
    STATE(2836), 1,
      sym_template_type,
    STATE(3120), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(6394), 1,
      sym_ms_declspec_modifier,
    STATE(7365), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4718), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6390), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6867), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [233664] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5968), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5483), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(9652), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5481), 20,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [233703] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8151), 1,
      anon_sym_DASH_GT,
    ACTIONS(8153), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9371), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7019), 1,
      sym__function_attributes_end,
    STATE(7241), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9253), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6288), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [233770] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9655), 1,
      anon_sym___attribute__,
    ACTIONS(9658), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9664), 1,
      anon_sym_requires,
    STATE(6544), 1,
      sym__function_attributes_end,
    STATE(6660), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9661), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [233831] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9509), 1,
      anon_sym___attribute__,
    ACTIONS(9512), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9518), 1,
      anon_sym_requires,
    STATE(6535), 1,
      sym__function_attributes_end,
    STATE(6552), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [233892] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9368), 1,
      anon_sym___attribute__,
    ACTIONS(9371), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6527), 1,
      sym__function_attributes_end,
    STATE(6601), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [233953] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9368), 1,
      anon_sym___attribute__,
    ACTIONS(9371), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9377), 1,
      anon_sym_requires,
    STATE(6513), 1,
      sym_trailing_return_type,
    STATE(6548), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [234014] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8151), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9512), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9667), 1,
      anon_sym_requires,
    STATE(7072), 1,
      sym__function_attributes_end,
    STATE(7231), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9479), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6307), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [234081] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8011), 1,
      anon_sym_requires,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    STATE(6981), 1,
      sym_trailing_return_type,
    STATE(7153), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9253), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6258), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [234148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8107), 3,
      anon_sym_AMP,
      sym_ms_restrict_modifier,
      anon_sym_const,
    ACTIONS(8109), 24,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [234183] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9655), 1,
      anon_sym___attribute__,
    ACTIONS(9658), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6618), 1,
      sym_trailing_return_type,
    STATE(6651), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [234244] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9509), 1,
      anon_sym___attribute__,
    ACTIONS(9512), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6593), 1,
      sym__function_attributes_end,
    STATE(6597), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [234305] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9560), 1,
      anon_sym_requires,
    STATE(6913), 1,
      sym_trailing_return_type,
    STATE(7156), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9479), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9488), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6228), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [234372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8103), 3,
      anon_sym_AMP,
      sym_ms_restrict_modifier,
      anon_sym_const,
    ACTIONS(8105), 24,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [234407] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9494), 1,
      anon_sym_requires,
    STATE(6984), 1,
      sym_trailing_return_type,
    STATE(7147), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9253), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9257), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6226), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [234474] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8151), 1,
      anon_sym_DASH_GT,
    ACTIONS(8153), 1,
      anon_sym_requires,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9512), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7105), 1,
      sym__function_attributes_end,
    STATE(7214), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9479), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6253), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [234541] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8011), 1,
      anon_sym_requires,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    STATE(6999), 1,
      sym_trailing_return_type,
    STATE(7152), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9479), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6263), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [234608] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7680), 1,
      anon_sym_noexcept,
    ACTIONS(7682), 1,
      anon_sym_throw,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8151), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9371), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9548), 1,
      anon_sym_requires,
    STATE(7001), 1,
      sym__function_attributes_end,
    STATE(7246), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9253), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6297), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [234675] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7898), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9512), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9518), 1,
      anon_sym_requires,
    STATE(6552), 1,
      sym_trailing_return_type,
    STATE(6723), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [234735] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7898), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9371), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9377), 1,
      anon_sym_requires,
    STATE(6513), 1,
      sym_trailing_return_type,
    STATE(6716), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [234795] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7833), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9371), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9377), 1,
      anon_sym_requires,
    STATE(6513), 1,
      sym_trailing_return_type,
    STATE(6599), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9476), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [234855] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7869), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9670), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9676), 1,
      anon_sym_requires,
    STATE(6516), 1,
      sym__function_attributes_end,
    STATE(6637), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(9661), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [234915] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7833), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9658), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9664), 1,
      anon_sym_requires,
    STATE(6609), 1,
      sym__function_attributes_end,
    STATE(6660), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(9661), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [234975] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7900), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9470), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9473), 1,
      anon_sym_requires,
    STATE(6635), 1,
      sym_trailing_return_type,
    STATE(6697), 1,
      sym__function_attributes_end,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [235035] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(6533), 1,
      sym_ms_call_modifier,
    STATE(7438), 1,
      sym__type_declarator,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(49), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [235089] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(6543), 1,
      sym_ms_call_modifier,
    STATE(7480), 1,
      sym__type_declarator,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(49), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [235143] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9681), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9679), 9,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [235181] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7900), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9527), 1,
      anon_sym_requires,
    STATE(6514), 1,
      sym_trailing_return_type,
    STATE(6693), 1,
      sym__function_attributes_end,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [235241] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7869), 1,
      anon_sym_DASH_GT,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9670), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6529), 1,
      sym_trailing_return_type,
    STATE(6590), 1,
      sym__function_attributes_end,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [235301] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7900), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9670), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9676), 1,
      anon_sym_requires,
    STATE(6637), 1,
      sym_trailing_return_type,
    STATE(6691), 1,
      sym__function_attributes_end,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9661), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [235361] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7833), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9512), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9518), 1,
      anon_sym_requires,
    STATE(6552), 1,
      sym_trailing_return_type,
    STATE(6602), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9524), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [235421] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7869), 1,
      anon_sym_DASH_GT,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9521), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6536), 1,
      sym_trailing_return_type,
    STATE(6628), 1,
      sym__function_attributes_end,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9524), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [235481] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7898), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9512), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6597), 1,
      sym_trailing_return_type,
    STATE(6704), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [235541] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7869), 1,
      anon_sym_DASH_GT,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9470), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6540), 1,
      sym_trailing_return_type,
    STATE(6659), 1,
      sym__function_attributes_end,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9476), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [235601] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7898), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9371), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6601), 1,
      sym_trailing_return_type,
    STATE(6726), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [235661] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7833), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9658), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6523), 1,
      sym__function_attributes_end,
    STATE(6618), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [235721] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(7900), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9670), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6529), 1,
      sym_trailing_return_type,
    STATE(6757), 1,
      sym__function_attributes_end,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [235781] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7869), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9470), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9473), 1,
      anon_sym_requires,
    STATE(6617), 1,
      sym__function_attributes_end,
    STATE(6635), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9476), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [235841] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(6620), 1,
      sym_ms_call_modifier,
    STATE(7457), 1,
      sym__type_declarator,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(49), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [235895] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7898), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9658), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6618), 1,
      sym_trailing_return_type,
    STATE(6706), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [235955] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(7900), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9470), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6540), 1,
      sym_trailing_return_type,
    STATE(6756), 1,
      sym__function_attributes_end,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [236015] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7869), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9527), 1,
      anon_sym_requires,
    STATE(6514), 1,
      sym_trailing_return_type,
    STATE(6610), 1,
      sym__function_attributes_end,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9524), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [236075] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(6538), 1,
      sym_ms_call_modifier,
    STATE(7446), 1,
      sym__type_declarator,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(49), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [236129] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9685), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9683), 9,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [236167] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7833), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9371), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6541), 1,
      sym__function_attributes_end,
    STATE(6601), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9476), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [236227] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7898), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9658), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9664), 1,
      anon_sym_requires,
    STATE(6660), 1,
      sym_trailing_return_type,
    STATE(6746), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9661), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [236287] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(7900), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9521), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6536), 1,
      sym_trailing_return_type,
    STATE(6692), 1,
      sym__function_attributes_end,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [236347] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5497), 1,
      anon_sym_LBRACE,
    ACTIONS(5481), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5483), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [236385] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(7833), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9512), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6537), 1,
      sym__function_attributes_end,
    STATE(6597), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9524), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [236445] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(6549), 1,
      sym_ms_call_modifier,
    STATE(7484), 1,
      sym__type_declarator,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
    ACTIONS(49), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [236499] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9382), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9570), 1,
      sym_identifier,
    ACTIONS(9687), 1,
      anon_sym_LPAREN2,
    ACTIONS(9689), 1,
      anon_sym_LBRACE,
    ACTIONS(9693), 1,
      anon_sym_requires,
    STATE(4073), 1,
      sym_requirement_seq,
    STATE(4373), 1,
      sym_template_type,
    STATE(6752), 1,
      sym_lambda_capture_specifier,
    STATE(7334), 1,
      sym__scope_resolution,
    STATE(8728), 1,
      sym_requires_parameter_list,
    ACTIONS(9691), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4971), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [236560] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7961), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9470), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_requires,
    STATE(6773), 1,
      sym__function_attributes_end,
    STATE(6974), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [236619] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9347), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    ACTIONS(9695), 1,
      anon_sym_LPAREN2,
    ACTIONS(9697), 1,
      anon_sym_LBRACE,
    ACTIONS(9701), 1,
      anon_sym_requires,
    STATE(3164), 1,
      sym_template_type,
    STATE(4221), 1,
      sym_requirement_seq,
    STATE(6732), 1,
      sym_lambda_capture_specifier,
    STATE(7346), 1,
      sym__scope_resolution,
    STATE(8447), 1,
      sym_requires_parameter_list,
    ACTIONS(9699), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4322), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [236680] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7961), 1,
      anon_sym_DASH_GT,
    ACTIONS(8033), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9470), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6805), 1,
      sym__function_attributes_end,
    STATE(6924), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [236739] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7992), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9703), 1,
      anon_sym_requires,
    STATE(6864), 1,
      sym__function_attributes_end,
    STATE(6898), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9646), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6923), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [236798] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7992), 1,
      anon_sym_DASH_GT,
    ACTIONS(8011), 1,
      anon_sym_requires,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    STATE(6882), 1,
      sym__function_attributes_end,
    STATE(6908), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6923), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [236857] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9450), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9637), 1,
      sym_identifier,
    ACTIONS(9706), 1,
      anon_sym_LPAREN2,
    ACTIONS(9708), 1,
      anon_sym_LBRACE,
    ACTIONS(9712), 1,
      anon_sym_requires,
    STATE(3375), 1,
      sym_template_type,
    STATE(4547), 1,
      sym_requirement_seq,
    STATE(6679), 1,
      sym_lambda_capture_specifier,
    STATE(7350), 1,
      sym__scope_resolution,
    STATE(8650), 1,
      sym_requires_parameter_list,
    ACTIONS(9710), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4489), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [236918] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7992), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9494), 1,
      anon_sym_requires,
    STATE(6885), 1,
      sym__function_attributes_end,
    STATE(6984), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9257), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [236977] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9327), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9574), 1,
      sym_identifier,
    ACTIONS(9714), 1,
      anon_sym_LPAREN2,
    ACTIONS(9716), 1,
      anon_sym_LBRACE,
    ACTIONS(9720), 1,
      anon_sym_requires,
    STATE(3137), 1,
      sym_template_type,
    STATE(4074), 1,
      sym_requirement_seq,
    STATE(6743), 1,
      sym_lambda_capture_specifier,
    STATE(7329), 1,
      sym__scope_resolution,
    STATE(8605), 1,
      sym_requires_parameter_list,
    ACTIONS(9718), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4078), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [237038] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7961), 1,
      anon_sym_DASH_GT,
    ACTIONS(8033), 1,
      anon_sym_requires,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9670), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6774), 1,
      sym__function_attributes_end,
    STATE(6915), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [237097] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9584), 1,
      sym_identifier,
    ACTIONS(9722), 1,
      anon_sym_LPAREN2,
    ACTIONS(9724), 1,
      anon_sym_LBRACE,
    ACTIONS(9728), 1,
      anon_sym_requires,
    STATE(3163), 1,
      sym_template_type,
    STATE(5178), 1,
      sym_requirement_seq,
    STATE(6745), 1,
      sym_lambda_capture_specifier,
    STATE(7361), 1,
      sym__scope_resolution,
    STATE(8403), 1,
      sym_requires_parameter_list,
    ACTIONS(9726), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5566), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [237158] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7961), 1,
      anon_sym_DASH_GT,
    ACTIONS(8033), 1,
      anon_sym_requires,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9521), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6783), 1,
      sym__function_attributes_end,
    STATE(6916), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [237217] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9625), 1,
      sym_identifier,
    ACTIONS(9730), 1,
      anon_sym_LPAREN2,
    ACTIONS(9732), 1,
      anon_sym_LBRACE,
    ACTIONS(9736), 1,
      anon_sym_requires,
    STATE(2433), 1,
      sym_template_type,
    STATE(2915), 1,
      sym_requirement_seq,
    STATE(6699), 1,
      sym_lambda_capture_specifier,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(8667), 1,
      sym_requires_parameter_list,
    ACTIONS(9734), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2913), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [237278] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9604), 1,
      sym_identifier,
    ACTIONS(9738), 1,
      anon_sym_LPAREN2,
    ACTIONS(9740), 1,
      anon_sym_LBRACE,
    ACTIONS(9744), 1,
      anon_sym_requires,
    STATE(4593), 1,
      sym_template_type,
    STATE(5047), 1,
      sym_requirement_seq,
    STATE(6754), 1,
      sym_lambda_capture_specifier,
    STATE(7337), 1,
      sym__scope_resolution,
    STATE(8763), 1,
      sym_requires_parameter_list,
    ACTIONS(9742), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5048), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [237339] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7992), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9560), 1,
      anon_sym_requires,
    STATE(6849), 1,
      sym__function_attributes_end,
    STATE(6913), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9488), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [237398] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7992), 1,
      anon_sym_DASH_GT,
    ACTIONS(8011), 1,
      anon_sym_requires,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    STATE(6850), 1,
      sym__function_attributes_end,
    STATE(6999), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [237457] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7961), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9565), 1,
      anon_sym_requires,
    STATE(6788), 1,
      sym__function_attributes_end,
    STATE(6972), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [237516] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9307), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    ACTIONS(9746), 1,
      anon_sym_LPAREN2,
    ACTIONS(9748), 1,
      anon_sym_LBRACE,
    ACTIONS(9752), 1,
      anon_sym_requires,
    STATE(3015), 1,
      sym_template_type,
    STATE(3833), 1,
      sym_requirement_seq,
    STATE(6739), 1,
      sym_lambda_capture_specifier,
    STATE(7340), 1,
      sym__scope_resolution,
    STATE(8649), 1,
      sym_requires_parameter_list,
    ACTIONS(9750), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3832), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [237577] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9611), 1,
      sym_identifier,
    ACTIONS(9687), 1,
      anon_sym_LPAREN2,
    ACTIONS(9689), 1,
      anon_sym_LBRACE,
    ACTIONS(9693), 1,
      anon_sym_requires,
    STATE(2148), 1,
      sym_template_type,
    STATE(4073), 1,
      sym_requirement_seq,
    STATE(6752), 1,
      sym_lambda_capture_specifier,
    STATE(7347), 1,
      sym__scope_resolution,
    STATE(8728), 1,
      sym_requires_parameter_list,
    ACTIONS(9754), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4961), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [237638] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7992), 1,
      anon_sym_DASH_GT,
    ACTIONS(8011), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    STATE(6870), 1,
      sym__function_attributes_end,
    STATE(6981), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [237697] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(7961), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9670), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9756), 1,
      anon_sym_requires,
    STATE(6802), 1,
      sym__function_attributes_end,
    STATE(6971), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9661), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [237756] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5497), 1,
      anon_sym_LBRACE,
    ACTIONS(5481), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5483), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [237791] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8052), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9586), 1,
      anon_sym_requires,
    STATE(6927), 1,
      sym__function_attributes_end,
    STATE(7157), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9488), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [237849] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8111), 1,
      anon_sym_STAR,
    ACTIONS(8113), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8115), 1,
      anon_sym_AMP,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6834), 1,
      sym__abstract_declarator,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8269), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [237897] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(8539), 1,
      anon_sym_LPAREN2,
    ACTIONS(8547), 1,
      sym_identifier,
    ACTIONS(8549), 1,
      anon_sym_STAR,
    ACTIONS(8551), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8553), 1,
      anon_sym_AMP,
    STATE(6682), 1,
      sym_ms_call_modifier,
    STATE(7374), 1,
      sym__field_declarator,
    STATE(7503), 1,
      sym_operator_name,
    STATE(9291), 1,
      sym_ms_based_modifier,
    ACTIONS(2091), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7265), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [237951] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8052), 1,
      anon_sym_DASH_GT,
    ACTIONS(8057), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    STATE(6933), 1,
      sym__function_attributes_end,
    STATE(7136), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [238009] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8052), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9759), 1,
      anon_sym_requires,
    STATE(6928), 1,
      sym__function_attributes_end,
    STATE(7161), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9646), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6923), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [238067] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8097), 1,
      anon_sym_STAR,
    ACTIONS(8099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8101), 1,
      anon_sym_AMP,
    STATE(4341), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6876), 1,
      sym__abstract_declarator,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8269), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [238115] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8052), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9502), 1,
      anon_sym_requires,
    STATE(6926), 1,
      sym__function_attributes_end,
    STATE(7150), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9257), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [238173] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5430), 1,
      anon_sym_AMP,
    ACTIONS(9765), 1,
      anon_sym_const,
    STATE(6214), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5432), 8,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(9762), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [238211] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8075), 1,
      anon_sym_STAR,
    ACTIONS(8077), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8079), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    STATE(4132), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(6819), 1,
      sym__abstract_declarator,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8269), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [238259] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8052), 1,
      anon_sym_DASH_GT,
    ACTIONS(8057), 1,
      anon_sym_requires,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    STATE(6905), 1,
      sym__function_attributes_end,
    STATE(7130), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6923), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [238317] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8052), 1,
      anon_sym_DASH_GT,
    ACTIONS(8057), 1,
      anon_sym_requires,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    STATE(6900), 1,
      sym__function_attributes_end,
    STATE(7135), 1,
      sym_trailing_return_type,
    STATE(7522), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6327), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [238375] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9768), 1,
      sym_identifier,
    ACTIONS(9770), 1,
      anon_sym_RPAREN,
    ACTIONS(9772), 1,
      anon_sym_LPAREN2,
    ACTIONS(9774), 1,
      anon_sym_defined,
    ACTIONS(9780), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9782), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9784), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6415), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [238422] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9768), 1,
      sym_identifier,
    ACTIONS(9772), 1,
      anon_sym_LPAREN2,
    ACTIONS(9774), 1,
      anon_sym_defined,
    ACTIONS(9780), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9782), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9786), 1,
      anon_sym_RPAREN,
    ACTIONS(9776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9784), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6410), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [238469] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9768), 1,
      sym_identifier,
    ACTIONS(9772), 1,
      anon_sym_LPAREN2,
    ACTIONS(9774), 1,
      anon_sym_defined,
    ACTIONS(9780), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9782), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9788), 1,
      anon_sym_RPAREN,
    ACTIONS(9776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9784), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6431), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [238516] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8133), 1,
      anon_sym_STAR,
    ACTIONS(8135), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8137), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    STATE(3938), 1,
      sym_parameter_list,
    STATE(6956), 1,
      sym__abstract_declarator,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8269), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [238563] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9450), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9637), 1,
      sym_identifier,
    ACTIONS(9712), 1,
      anon_sym_requires,
    ACTIONS(9790), 1,
      anon_sym_LPAREN2,
    STATE(3375), 1,
      sym_template_type,
    STATE(6679), 1,
      sym_lambda_capture_specifier,
    STATE(7350), 1,
      sym__scope_resolution,
    ACTIONS(9792), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4581), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [238615] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6639), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [238659] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9768), 1,
      sym_identifier,
    ACTIONS(9772), 1,
      anon_sym_LPAREN2,
    ACTIONS(9774), 1,
      anon_sym_defined,
    ACTIONS(9780), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9782), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9784), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6605), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [238703] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9494), 1,
      anon_sym_requires,
    STATE(6984), 1,
      sym_trailing_return_type,
    STATE(7147), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9253), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9257), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
  [238759] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9560), 1,
      anon_sym_requires,
    STATE(6913), 1,
      sym_trailing_return_type,
    STATE(7156), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9479), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9488), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
  [238815] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6619), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [238859] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9703), 1,
      anon_sym_requires,
    STATE(6898), 1,
      sym_trailing_return_type,
    STATE(7164), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9639), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9646), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6923), 2,
      sym__function_postfix,
      sym_requires_clause,
  [238915] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9327), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9574), 1,
      sym_identifier,
    ACTIONS(9720), 1,
      anon_sym_requires,
    ACTIONS(9810), 1,
      anon_sym_LPAREN2,
    STATE(3137), 1,
      sym_template_type,
    STATE(6743), 1,
      sym_lambda_capture_specifier,
    STATE(7329), 1,
      sym__scope_resolution,
    ACTIONS(9812), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4158), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [238967] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6558), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [239011] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8011), 1,
      anon_sym_requires,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    STATE(6981), 1,
      sym_trailing_return_type,
    STATE(7153), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9253), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
  [239067] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9814), 1,
      anon_sym_LPAREN2,
    ACTIONS(9818), 1,
      anon_sym_requires,
    STATE(2836), 1,
      sym_template_type,
    STATE(6730), 1,
      sym_lambda_capture_specifier,
    STATE(7352), 1,
      sym__scope_resolution,
    ACTIONS(9816), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6968), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [239119] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6648), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [239163] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9814), 1,
      anon_sym_LPAREN2,
    ACTIONS(9818), 1,
      anon_sym_requires,
    STATE(2836), 1,
      sym_template_type,
    STATE(6730), 1,
      sym_lambda_capture_specifier,
    STATE(7352), 1,
      sym__scope_resolution,
    ACTIONS(9820), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6937), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [239215] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9814), 1,
      anon_sym_LPAREN2,
    ACTIONS(9818), 1,
      anon_sym_requires,
    STATE(2836), 1,
      sym_template_type,
    STATE(6730), 1,
      sym_lambda_capture_specifier,
    STATE(7352), 1,
      sym__scope_resolution,
    ACTIONS(9822), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2045), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [239267] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9824), 1,
      anon_sym_LPAREN2,
    ACTIONS(9828), 1,
      anon_sym_requires,
    STATE(2836), 1,
      sym_template_type,
    STATE(6695), 1,
      sym_lambda_capture_specifier,
    STATE(7371), 1,
      sym__scope_resolution,
    ACTIONS(9826), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7269), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [239319] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6550), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [239363] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9604), 1,
      sym_identifier,
    ACTIONS(9744), 1,
      anon_sym_requires,
    ACTIONS(9830), 1,
      anon_sym_LPAREN2,
    STATE(4593), 1,
      sym_template_type,
    STATE(6754), 1,
      sym_lambda_capture_specifier,
    STATE(7337), 1,
      sym__scope_resolution,
    ACTIONS(9832), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5125), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [239415] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9604), 1,
      sym_identifier,
    ACTIONS(9744), 1,
      anon_sym_requires,
    ACTIONS(9830), 1,
      anon_sym_LPAREN2,
    STATE(4593), 1,
      sym_template_type,
    STATE(6754), 1,
      sym_lambda_capture_specifier,
    STATE(7337), 1,
      sym__scope_resolution,
    ACTIONS(9834), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5056), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [239467] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9572), 1,
      sym_identifier,
    ACTIONS(9824), 1,
      anon_sym_LPAREN2,
    ACTIONS(9828), 1,
      anon_sym_requires,
    STATE(2836), 1,
      sym_template_type,
    STATE(6695), 1,
      sym_lambda_capture_specifier,
    STATE(7349), 1,
      sym__scope_resolution,
    ACTIONS(9836), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6572), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [239519] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8162), 1,
      anon_sym_STAR,
    ACTIONS(8164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8166), 1,
      anon_sym_AMP,
    STATE(4342), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7053), 1,
      sym__abstract_declarator,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8269), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [239565] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9824), 1,
      anon_sym_LPAREN2,
    ACTIONS(9828), 1,
      anon_sym_requires,
    STATE(2836), 1,
      sym_template_type,
    STATE(6695), 1,
      sym_lambda_capture_specifier,
    STATE(7371), 1,
      sym__scope_resolution,
    ACTIONS(9838), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7199), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [239617] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9824), 1,
      anon_sym_LPAREN2,
    ACTIONS(9828), 1,
      anon_sym_requires,
    STATE(2836), 1,
      sym_template_type,
    STATE(6695), 1,
      sym_lambda_capture_specifier,
    STATE(7371), 1,
      sym__scope_resolution,
    ACTIONS(9840), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6623), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [239669] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6539), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [239713] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9814), 1,
      anon_sym_LPAREN2,
    ACTIONS(9818), 1,
      anon_sym_requires,
    ACTIONS(9842), 1,
      sym_identifier,
    ACTIONS(9844), 1,
      anon_sym_COLON_COLON,
    STATE(2688), 1,
      sym_template_type,
    STATE(6735), 1,
      sym_lambda_capture_specifier,
    STATE(7339), 1,
      sym__scope_resolution,
    ACTIONS(9846), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2690), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [239765] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6528), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [239809] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9327), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9574), 1,
      sym_identifier,
    ACTIONS(9720), 1,
      anon_sym_requires,
    ACTIONS(9810), 1,
      anon_sym_LPAREN2,
    STATE(3137), 1,
      sym_template_type,
    STATE(6743), 1,
      sym_lambda_capture_specifier,
    STATE(7329), 1,
      sym__scope_resolution,
    ACTIONS(9848), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4160), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [239861] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6524), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [239905] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6520), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [239949] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(133), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(3226), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    ACTIONS(9850), 1,
      sym_identifier,
    ACTIONS(9852), 1,
      anon_sym_template,
    STATE(2825), 1,
      sym_template_type,
    STATE(2828), 1,
      sym_dependent_type_identifier,
    STATE(2834), 1,
      sym_qualified_type_identifier,
    STATE(3302), 1,
      sym_template_function,
    STATE(3325), 1,
      sym_pointer_type_declarator,
    STATE(3333), 1,
      sym_destructor_name,
    STATE(3339), 1,
      sym_dependent_identifier,
    STATE(3342), 1,
      sym_qualified_identifier,
    STATE(3347), 1,
      sym_operator_name,
    STATE(6250), 1,
      sym__scope_resolution,
    STATE(7674), 1,
      sym_qualified_operator_cast_identifier,
    STATE(7675), 1,
      sym_operator_cast,
    STATE(9045), 1,
      sym_ms_based_modifier,
    STATE(9504), 1,
      sym_decltype,
  [240019] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9693), 1,
      anon_sym_requires,
    ACTIONS(9854), 1,
      sym_identifier,
    ACTIONS(9856), 1,
      anon_sym_LPAREN2,
    ACTIONS(9858), 1,
      anon_sym_COLON_COLON,
    STATE(2148), 1,
      sym_template_type,
    STATE(6752), 1,
      sym_lambda_capture_specifier,
    STATE(7359), 1,
      sym__scope_resolution,
    ACTIONS(9860), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4218), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [240071] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6656), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [240115] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8151), 1,
      anon_sym_DASH_GT,
    ACTIONS(8153), 1,
      anon_sym_requires,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9658), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7038), 1,
      sym__function_attributes_end,
    STATE(7219), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9639), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
  [240171] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(133), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(4075), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    ACTIONS(9862), 1,
      sym_identifier,
    ACTIONS(9864), 1,
      anon_sym_template,
    STATE(2825), 1,
      sym_template_type,
    STATE(2828), 1,
      sym_dependent_type_identifier,
    STATE(2834), 1,
      sym_qualified_type_identifier,
    STATE(3302), 1,
      sym_template_function,
    STATE(3325), 1,
      sym_pointer_type_declarator,
    STATE(3333), 1,
      sym_destructor_name,
    STATE(3339), 1,
      sym_dependent_identifier,
    STATE(3342), 1,
      sym_qualified_identifier,
    STATE(3347), 1,
      sym_operator_name,
    STATE(6254), 1,
      sym__scope_resolution,
    STATE(7674), 1,
      sym_qualified_operator_cast_identifier,
    STATE(7675), 1,
      sym_operator_cast,
    STATE(9045), 1,
      sym_ms_based_modifier,
    STATE(9504), 1,
      sym_decltype,
  [240241] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(8017), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9613), 1,
      sym_identifier,
    ACTIONS(9728), 1,
      anon_sym_requires,
    ACTIONS(9866), 1,
      anon_sym_LPAREN2,
    STATE(3163), 1,
      sym_template_type,
    STATE(6745), 1,
      sym_lambda_capture_specifier,
    STATE(7325), 1,
      sym__scope_resolution,
    ACTIONS(9868), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7120), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [240293] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6542), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [240337] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9768), 1,
      sym_identifier,
    ACTIONS(9772), 1,
      anon_sym_LPAREN2,
    ACTIONS(9774), 1,
      anon_sym_defined,
    ACTIONS(9780), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9782), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9784), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6512), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [240381] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8011), 1,
      anon_sym_requires,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    STATE(6999), 1,
      sym_trailing_return_type,
    STATE(7152), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9479), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
  [240437] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9872), 1,
      anon_sym_SEMI,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(9876), 1,
      anon_sym_LBRACK,
    ACTIONS(9878), 1,
      anon_sym_EQ,
    ACTIONS(9880), 1,
      anon_sym_COLON,
    ACTIONS(9882), 1,
      anon_sym_try,
    STATE(2469), 1,
      sym_compound_statement,
    STATE(2470), 1,
      sym_default_method_clause,
    STATE(2471), 1,
      sym_delete_method_clause,
    STATE(2472), 1,
      sym_try_statement,
    STATE(4027), 1,
      sym_parameter_list,
    STATE(7213), 1,
      sym__function_declarator_seq,
    STATE(7592), 1,
      sym_bitfield_clause,
    STATE(7594), 1,
      sym_initializer_list,
    STATE(7598), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9160), 1,
      sym_attribute_specifier,
    STATE(7129), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [240505] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6654), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [240549] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9572), 1,
      sym_identifier,
    ACTIONS(9814), 1,
      anon_sym_LPAREN2,
    ACTIONS(9818), 1,
      anon_sym_requires,
    STATE(2836), 1,
      sym_template_type,
    STATE(6730), 1,
      sym_lambda_capture_specifier,
    STATE(7322), 1,
      sym__scope_resolution,
    ACTIONS(9884), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6531), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [240601] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6546), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [240645] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8011), 1,
      anon_sym_requires,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    STATE(6908), 1,
      sym_trailing_return_type,
    STATE(7151), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9639), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6923), 2,
      sym__function_postfix,
      sym_requires_clause,
  [240701] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9572), 1,
      sym_identifier,
    ACTIONS(9814), 1,
      anon_sym_LPAREN2,
    ACTIONS(9818), 1,
      anon_sym_requires,
    STATE(2836), 1,
      sym_template_type,
    STATE(6730), 1,
      sym_lambda_capture_specifier,
    STATE(7322), 1,
      sym__scope_resolution,
    ACTIONS(9822), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2045), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [240753] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6574), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [240797] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6634), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [240841] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9572), 1,
      sym_identifier,
    ACTIONS(9814), 1,
      anon_sym_LPAREN2,
    ACTIONS(9818), 1,
      anon_sym_requires,
    STATE(2836), 1,
      sym_template_type,
    STATE(6730), 1,
      sym_lambda_capture_specifier,
    STATE(7322), 1,
      sym__scope_resolution,
    ACTIONS(9886), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6571), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [240893] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9693), 1,
      anon_sym_requires,
    ACTIONS(9854), 1,
      sym_identifier,
    ACTIONS(9856), 1,
      anon_sym_LPAREN2,
    ACTIONS(9858), 1,
      anon_sym_COLON_COLON,
    STATE(2148), 1,
      sym_template_type,
    STATE(6752), 1,
      sym_lambda_capture_specifier,
    STATE(7359), 1,
      sym__scope_resolution,
    ACTIONS(9888), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6973), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [240945] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9611), 1,
      sym_identifier,
    ACTIONS(9693), 1,
      anon_sym_requires,
    ACTIONS(9856), 1,
      anon_sym_LPAREN2,
    STATE(2148), 1,
      sym_template_type,
    STATE(6752), 1,
      sym_lambda_capture_specifier,
    STATE(7347), 1,
      sym__scope_resolution,
    ACTIONS(9860), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4218), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [240997] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6606), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [241041] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8151), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9371), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9548), 1,
      anon_sym_requires,
    STATE(7001), 1,
      sym__function_attributes_end,
    STATE(7246), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9253), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
  [241097] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9450), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9637), 1,
      sym_identifier,
    ACTIONS(9712), 1,
      anon_sym_requires,
    ACTIONS(9790), 1,
      anon_sym_LPAREN2,
    STATE(3375), 1,
      sym_template_type,
    STATE(6679), 1,
      sym_lambda_capture_specifier,
    STATE(7350), 1,
      sym__scope_resolution,
    ACTIONS(9890), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4576), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [241149] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6519), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [241193] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6521), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [241237] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9572), 1,
      sym_identifier,
    ACTIONS(9824), 1,
      anon_sym_LPAREN2,
    ACTIONS(9828), 1,
      anon_sym_requires,
    STATE(2836), 1,
      sym_template_type,
    STATE(6695), 1,
      sym_lambda_capture_specifier,
    STATE(7349), 1,
      sym__scope_resolution,
    ACTIONS(9840), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6623), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [241289] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9876), 1,
      anon_sym_LBRACK,
    ACTIONS(9880), 1,
      anon_sym_COLON,
    ACTIONS(9892), 1,
      anon_sym_SEMI,
    ACTIONS(9894), 1,
      anon_sym_LBRACE,
    ACTIONS(9896), 1,
      anon_sym_EQ,
    ACTIONS(9898), 1,
      anon_sym_try,
    STATE(2159), 1,
      sym_compound_statement,
    STATE(2194), 1,
      sym_default_method_clause,
    STATE(2195), 1,
      sym_delete_method_clause,
    STATE(2196), 1,
      sym_try_statement,
    STATE(4027), 1,
      sym_parameter_list,
    STATE(7213), 1,
      sym__function_declarator_seq,
    STATE(7565), 1,
      sym_bitfield_clause,
    STATE(7568), 1,
      sym_initializer_list,
    STATE(7569), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8862), 1,
      sym_attribute_specifier,
    STATE(7129), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [241357] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6551), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [241401] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(8333), 1,
      anon_sym_STAR,
    ACTIONS(9900), 1,
      sym_identifier,
    ACTIONS(9902), 1,
      anon_sym_TILDE,
    ACTIONS(9904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9906), 1,
      anon_sym_template,
    ACTIONS(9908), 1,
      anon_sym_operator,
    STATE(2825), 1,
      sym_template_type,
    STATE(2828), 1,
      sym_dependent_type_identifier,
    STATE(2834), 1,
      sym_qualified_type_identifier,
    STATE(3302), 1,
      sym_template_function,
    STATE(3325), 1,
      sym_pointer_type_declarator,
    STATE(3333), 1,
      sym_destructor_name,
    STATE(3339), 1,
      sym_dependent_identifier,
    STATE(3342), 1,
      sym_qualified_identifier,
    STATE(3347), 1,
      sym_operator_name,
    STATE(6278), 1,
      sym__scope_resolution,
    STATE(7674), 1,
      sym_qualified_operator_cast_identifier,
    STATE(7675), 1,
      sym_operator_cast,
    STATE(9504), 1,
      sym_decltype,
    STATE(9571), 1,
      sym_ms_based_modifier,
  [241471] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9876), 1,
      anon_sym_LBRACK,
    ACTIONS(9880), 1,
      anon_sym_COLON,
    ACTIONS(9910), 1,
      anon_sym_SEMI,
    ACTIONS(9912), 1,
      anon_sym_LBRACE,
    ACTIONS(9914), 1,
      anon_sym_EQ,
    ACTIONS(9916), 1,
      anon_sym_try,
    STATE(2393), 1,
      sym_compound_statement,
    STATE(2394), 1,
      sym_default_method_clause,
    STATE(2396), 1,
      sym_delete_method_clause,
    STATE(2399), 1,
      sym_try_statement,
    STATE(4027), 1,
      sym_parameter_list,
    STATE(7213), 1,
      sym__function_declarator_seq,
    STATE(7615), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7617), 1,
      sym_initializer_list,
    STATE(7619), 1,
      sym_bitfield_clause,
    STATE(9269), 1,
      sym_attribute_specifier,
    STATE(7129), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [241539] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9768), 1,
      sym_identifier,
    ACTIONS(9772), 1,
      anon_sym_LPAREN2,
    ACTIONS(9774), 1,
      anon_sym_defined,
    ACTIONS(9780), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9782), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9784), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6484), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [241583] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9768), 1,
      sym_identifier,
    ACTIONS(9772), 1,
      anon_sym_LPAREN2,
    ACTIONS(9774), 1,
      anon_sym_defined,
    ACTIONS(9780), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9782), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9784), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6485), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [241627] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6578), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [241671] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6644), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [241715] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9768), 1,
      sym_identifier,
    ACTIONS(9772), 1,
      anon_sym_LPAREN2,
    ACTIONS(9774), 1,
      anon_sym_defined,
    ACTIONS(9780), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9782), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9784), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6488), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [241759] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9625), 1,
      sym_identifier,
    ACTIONS(9736), 1,
      anon_sym_requires,
    ACTIONS(9918), 1,
      anon_sym_LPAREN2,
    STATE(2433), 1,
      sym_template_type,
    STATE(6699), 1,
      sym_lambda_capture_specifier,
    STATE(7335), 1,
      sym__scope_resolution,
    ACTIONS(9920), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2965), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [241811] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9572), 1,
      sym_identifier,
    ACTIONS(9824), 1,
      anon_sym_LPAREN2,
    ACTIONS(9828), 1,
      anon_sym_requires,
    STATE(2836), 1,
      sym_template_type,
    STATE(6695), 1,
      sym_lambda_capture_specifier,
    STATE(7349), 1,
      sym__scope_resolution,
    ACTIONS(9922), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6614), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [241863] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9768), 1,
      sym_identifier,
    ACTIONS(9772), 1,
      anon_sym_LPAREN2,
    ACTIONS(9774), 1,
      anon_sym_defined,
    ACTIONS(9780), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9782), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9784), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6489), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [241907] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8151), 1,
      anon_sym_DASH_GT,
    ACTIONS(8153), 1,
      anon_sym_requires,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9512), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7105), 1,
      sym__function_attributes_end,
    STATE(7214), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9479), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
  [241963] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9768), 1,
      sym_identifier,
    ACTIONS(9772), 1,
      anon_sym_LPAREN2,
    ACTIONS(9774), 1,
      anon_sym_defined,
    ACTIONS(9780), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9782), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9784), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6655), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [242007] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9625), 1,
      sym_identifier,
    ACTIONS(9736), 1,
      anon_sym_requires,
    ACTIONS(9918), 1,
      anon_sym_LPAREN2,
    STATE(2433), 1,
      sym_template_type,
    STATE(6699), 1,
      sym_lambda_capture_specifier,
    STATE(7335), 1,
      sym__scope_resolution,
    ACTIONS(9924), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2966), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [242059] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6645), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [242103] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8151), 1,
      anon_sym_DASH_GT,
    ACTIONS(8153), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9371), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7019), 1,
      sym__function_attributes_end,
    STATE(7241), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9253), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
  [242159] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9768), 1,
      sym_identifier,
    ACTIONS(9772), 1,
      anon_sym_LPAREN2,
    ACTIONS(9774), 1,
      anon_sym_defined,
    ACTIONS(9780), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9782), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9784), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6490), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [242203] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9768), 1,
      sym_identifier,
    ACTIONS(9772), 1,
      anon_sym_LPAREN2,
    ACTIONS(9774), 1,
      anon_sym_defined,
    ACTIONS(9780), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9782), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9784), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6492), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [242247] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9814), 1,
      anon_sym_LPAREN2,
    ACTIONS(9818), 1,
      anon_sym_requires,
    ACTIONS(9842), 1,
      sym_identifier,
    ACTIONS(9844), 1,
      anon_sym_COLON_COLON,
    STATE(2688), 1,
      sym_template_type,
    STATE(6735), 1,
      sym_lambda_capture_specifier,
    STATE(7339), 1,
      sym__scope_resolution,
    ACTIONS(9926), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2663), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [242299] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9814), 1,
      anon_sym_LPAREN2,
    ACTIONS(9818), 1,
      anon_sym_requires,
    ACTIONS(9842), 1,
      sym_identifier,
    ACTIONS(9844), 1,
      anon_sym_COLON_COLON,
    STATE(2688), 1,
      sym_template_type,
    STATE(6735), 1,
      sym_lambda_capture_specifier,
    STATE(7339), 1,
      sym__scope_resolution,
    ACTIONS(9822), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2045), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [242351] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8151), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9512), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9667), 1,
      anon_sym_requires,
    STATE(7072), 1,
      sym__function_attributes_end,
    STATE(7231), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9479), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
  [242407] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9768), 1,
      sym_identifier,
    ACTIONS(9772), 1,
      anon_sym_LPAREN2,
    ACTIONS(9774), 1,
      anon_sym_defined,
    ACTIONS(9780), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9782), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9784), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6493), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [242451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3320), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(3322), 20,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [242481] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9768), 1,
      sym_identifier,
    ACTIONS(9772), 1,
      anon_sym_LPAREN2,
    ACTIONS(9774), 1,
      anon_sym_defined,
    ACTIONS(9780), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9782), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9784), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6495), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [242525] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9768), 1,
      sym_identifier,
    ACTIONS(9772), 1,
      anon_sym_LPAREN2,
    ACTIONS(9774), 1,
      anon_sym_defined,
    ACTIONS(9780), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9782), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9784), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6498), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [242569] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9382), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9570), 1,
      sym_identifier,
    ACTIONS(9693), 1,
      anon_sym_requires,
    ACTIONS(9856), 1,
      anon_sym_LPAREN2,
    STATE(4373), 1,
      sym_template_type,
    STATE(6752), 1,
      sym_lambda_capture_specifier,
    STATE(7334), 1,
      sym__scope_resolution,
    ACTIONS(9860), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4218), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [242621] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9382), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9570), 1,
      sym_identifier,
    ACTIONS(9693), 1,
      anon_sym_requires,
    ACTIONS(9856), 1,
      anon_sym_LPAREN2,
    STATE(4373), 1,
      sym_template_type,
    STATE(6752), 1,
      sym_lambda_capture_specifier,
    STATE(7334), 1,
      sym__scope_resolution,
    ACTIONS(9928), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4955), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [242673] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9768), 1,
      sym_identifier,
    ACTIONS(9772), 1,
      anon_sym_LPAREN2,
    ACTIONS(9774), 1,
      anon_sym_defined,
    ACTIONS(9780), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9782), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9784), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6500), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [242717] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9611), 1,
      sym_identifier,
    ACTIONS(9693), 1,
      anon_sym_requires,
    ACTIONS(9856), 1,
      anon_sym_LPAREN2,
    STATE(2148), 1,
      sym_template_type,
    STATE(6752), 1,
      sym_lambda_capture_specifier,
    STATE(7347), 1,
      sym__scope_resolution,
    ACTIONS(9930), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4972), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [242769] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9876), 1,
      anon_sym_LBRACK,
    ACTIONS(9880), 1,
      anon_sym_COLON,
    ACTIONS(9932), 1,
      anon_sym_SEMI,
    ACTIONS(9934), 1,
      anon_sym_LBRACE,
    ACTIONS(9936), 1,
      anon_sym_EQ,
    ACTIONS(9938), 1,
      anon_sym_try,
    STATE(2511), 1,
      sym_try_statement,
    STATE(2516), 1,
      sym_delete_method_clause,
    STATE(2519), 1,
      sym_default_method_clause,
    STATE(2527), 1,
      sym_compound_statement,
    STATE(4027), 1,
      sym_parameter_list,
    STATE(7213), 1,
      sym__function_declarator_seq,
    STATE(7601), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7602), 1,
      sym_initializer_list,
    STATE(7604), 1,
      sym_bitfield_clause,
    STATE(9012), 1,
      sym_attribute_specifier,
    STATE(7129), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [242837] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8151), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9658), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9940), 1,
      anon_sym_requires,
    STATE(7070), 1,
      sym__function_attributes_end,
    STATE(7242), 1,
      sym_trailing_return_type,
    STATE(7505), 1,
      sym_gnu_asm_expression,
    ACTIONS(7673), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9639), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9661), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6478), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
  [242893] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9347), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    ACTIONS(9701), 1,
      anon_sym_requires,
    ACTIONS(9943), 1,
      anon_sym_LPAREN2,
    STATE(3164), 1,
      sym_template_type,
    STATE(6732), 1,
      sym_lambda_capture_specifier,
    STATE(7346), 1,
      sym__scope_resolution,
    ACTIONS(9945), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4286), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [242945] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6557), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [242989] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9347), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    ACTIONS(9701), 1,
      anon_sym_requires,
    ACTIONS(9943), 1,
      anon_sym_LPAREN2,
    STATE(3164), 1,
      sym_template_type,
    STATE(6732), 1,
      sym_lambda_capture_specifier,
    STATE(7346), 1,
      sym__scope_resolution,
    ACTIONS(9947), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4239), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [243041] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9635), 1,
      sym_identifier,
    ACTIONS(9693), 1,
      anon_sym_requires,
    ACTIONS(9856), 1,
      anon_sym_LPAREN2,
    STATE(2148), 1,
      sym_template_type,
    STATE(6752), 1,
      sym_lambda_capture_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    ACTIONS(9949), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7368), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [243093] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(7968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9627), 1,
      sym_identifier,
    ACTIONS(9951), 1,
      anon_sym_LPAREN2,
    ACTIONS(9955), 1,
      anon_sym_requires,
    STATE(5567), 1,
      sym_template_type,
    STATE(6714), 1,
      sym_lambda_capture_specifier,
    STATE(7328), 1,
      sym__scope_resolution,
    ACTIONS(9953), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6791), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [243145] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8173), 1,
      anon_sym_STAR,
    ACTIONS(8175), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8177), 1,
      anon_sym_AMP,
    STATE(4321), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7096), 1,
      sym__abstract_declarator,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8269), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [243191] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6595), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [243235] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(8017), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9613), 1,
      sym_identifier,
    ACTIONS(9728), 1,
      anon_sym_requires,
    ACTIONS(9866), 1,
      anon_sym_LPAREN2,
    STATE(3163), 1,
      sym_template_type,
    STATE(6745), 1,
      sym_lambda_capture_specifier,
    STATE(7325), 1,
      sym__scope_resolution,
    ACTIONS(9957), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5155), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [243287] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(8017), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9613), 1,
      sym_identifier,
    ACTIONS(9728), 1,
      anon_sym_requires,
    ACTIONS(9866), 1,
      anon_sym_LPAREN2,
    STATE(3163), 1,
      sym_template_type,
    STATE(6745), 1,
      sym_lambda_capture_specifier,
    STATE(7325), 1,
      sym__scope_resolution,
    ACTIONS(9959), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7174), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [243339] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9635), 1,
      sym_identifier,
    ACTIONS(9693), 1,
      anon_sym_requires,
    ACTIONS(9856), 1,
      anon_sym_LPAREN2,
    STATE(2148), 1,
      sym_template_type,
    STATE(6752), 1,
      sym_lambda_capture_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    ACTIONS(9961), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7360), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [243391] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6559), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [243435] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9584), 1,
      sym_identifier,
    ACTIONS(9728), 1,
      anon_sym_requires,
    ACTIONS(9866), 1,
      anon_sym_LPAREN2,
    STATE(3163), 1,
      sym_template_type,
    STATE(6745), 1,
      sym_lambda_capture_specifier,
    STATE(7361), 1,
      sym__scope_resolution,
    ACTIONS(9963), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5568), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [243487] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_LPAREN2,
    STATE(6464), 1,
      sym_preproc_argument_list,
    ACTIONS(9969), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9965), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [243521] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9635), 1,
      sym_identifier,
    ACTIONS(9693), 1,
      anon_sym_requires,
    ACTIONS(9856), 1,
      anon_sym_LPAREN2,
    STATE(2148), 1,
      sym_template_type,
    STATE(6752), 1,
      sym_lambda_capture_specifier,
    STATE(7330), 1,
      sym__scope_resolution,
    ACTIONS(9860), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4218), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [243573] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9768), 1,
      sym_identifier,
    ACTIONS(9772), 1,
      anon_sym_LPAREN2,
    ACTIONS(9774), 1,
      anon_sym_defined,
    ACTIONS(9780), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9782), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9784), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6505), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [243617] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9693), 1,
      anon_sym_requires,
    ACTIONS(9854), 1,
      sym_identifier,
    ACTIONS(9856), 1,
      anon_sym_LPAREN2,
    ACTIONS(9858), 1,
      anon_sym_COLON_COLON,
    STATE(2148), 1,
      sym_template_type,
    STATE(6752), 1,
      sym_lambda_capture_specifier,
    STATE(7359), 1,
      sym__scope_resolution,
    ACTIONS(9971), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6985), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [243669] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9307), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    ACTIONS(9752), 1,
      anon_sym_requires,
    ACTIONS(9973), 1,
      anon_sym_LPAREN2,
    STATE(3015), 1,
      sym_template_type,
    STATE(6739), 1,
      sym_lambda_capture_specifier,
    STATE(7340), 1,
      sym__scope_resolution,
    ACTIONS(9975), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3691), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [243721] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9307), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    ACTIONS(9752), 1,
      anon_sym_requires,
    ACTIONS(9973), 1,
      anon_sym_LPAREN2,
    STATE(3015), 1,
      sym_template_type,
    STATE(6739), 1,
      sym_lambda_capture_specifier,
    STATE(7340), 1,
      sym__scope_resolution,
    ACTIONS(9977), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3777), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [243773] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(9434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9584), 1,
      sym_identifier,
    ACTIONS(9728), 1,
      anon_sym_requires,
    ACTIONS(9866), 1,
      anon_sym_LPAREN2,
    STATE(3163), 1,
      sym_template_type,
    STATE(6745), 1,
      sym_lambda_capture_specifier,
    STATE(7361), 1,
      sym__scope_resolution,
    ACTIONS(9957), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5155), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [243825] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(9981), 1,
      anon_sym_LBRACK,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6621), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9979), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [243863] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(7968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9627), 1,
      sym_identifier,
    ACTIONS(9951), 1,
      anon_sym_LPAREN2,
    ACTIONS(9955), 1,
      anon_sym_requires,
    STATE(5567), 1,
      sym_template_type,
    STATE(6714), 1,
      sym_lambda_capture_specifier,
    STATE(7328), 1,
      sym__scope_resolution,
    ACTIONS(9983), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6803), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [243915] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(2837), 1,
      anon_sym_LBRACK,
    ACTIONS(7968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9627), 1,
      sym_identifier,
    ACTIONS(9951), 1,
      anon_sym_LPAREN2,
    ACTIONS(9955), 1,
      anon_sym_requires,
    STATE(5567), 1,
      sym_template_type,
    STATE(6714), 1,
      sym_lambda_capture_specifier,
    STATE(7328), 1,
      sym__scope_resolution,
    ACTIONS(9985), 2,
      sym_true,
      sym_false,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6800), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [243967] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(9989), 1,
      anon_sym_LBRACK,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6649), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9987), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [244005] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6579), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [244049] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      sym_identifier,
    ACTIONS(9796), 1,
      anon_sym_LPAREN2,
    ACTIONS(9798), 1,
      anon_sym_defined,
    ACTIONS(9804), 1,
      aux_sym_number_literal_token1,
    ACTIONS(9806), 1,
      aux_sym_number_literal_token2,
    ACTIONS(9800), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9802), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9808), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6622), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [244093] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6208), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9307), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(3015), 1,
      sym_template_type,
    STATE(3170), 1,
      sym_field_declaration_list,
    STATE(3326), 1,
      sym__class_declaration_item,
    STATE(7340), 1,
      sym__scope_resolution,
    STATE(7650), 1,
      sym_virtual_specifier,
    STATE(8572), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2762), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [244152] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8017), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(3163), 1,
      sym_template_type,
    STATE(3250), 1,
      sym_field_declaration_list,
    STATE(3447), 1,
      sym__class_declaration_item,
    STATE(7325), 1,
      sym__scope_resolution,
    STATE(7872), 1,
      sym_virtual_specifier,
    STATE(8682), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2972), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [244211] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    ACTIONS(9572), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(5720), 1,
      sym_field_declaration_list,
    STATE(5800), 1,
      sym__class_declaration_item,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(7859), 1,
      sym_virtual_specifier,
    STATE(8491), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5522), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6430), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [244270] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9241), 1,
      anon_sym_LBRACE,
    ACTIONS(9627), 1,
      sym_identifier,
    STATE(5567), 1,
      sym_template_type,
    STATE(5831), 1,
      sym_field_declaration_list,
    STATE(5915), 1,
      sym__class_declaration_item,
    STATE(7328), 1,
      sym__scope_resolution,
    STATE(7890), 1,
      sym_virtual_specifier,
    STATE(8705), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5562), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6342), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [244329] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9635), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2246), 1,
      sym__class_declaration_item,
    STATE(2991), 1,
      sym_field_declaration_list,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(7761), 1,
      sym_virtual_specifier,
    STATE(8591), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2798), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [244388] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9635), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2250), 1,
      sym__class_declaration_item,
    STATE(2991), 1,
      sym_field_declaration_list,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(7761), 1,
      sym_virtual_specifier,
    STATE(8591), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2798), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6379), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [244447] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3073), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3042), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [244506] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5475), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9625), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2682), 1,
      sym_field_declaration_list,
    STATE(2745), 1,
      sym__class_declaration_item,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(7778), 1,
      sym_virtual_specifier,
    STATE(8430), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2121), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6355), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [244565] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9611), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2266), 1,
      sym__class_declaration_item,
    STATE(2991), 1,
      sym_field_declaration_list,
    STATE(7347), 1,
      sym__scope_resolution,
    STATE(7761), 1,
      sym_virtual_specifier,
    STATE(8591), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2798), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6414), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [244624] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9241), 1,
      anon_sym_LBRACE,
    ACTIONS(9627), 1,
      sym_identifier,
    STATE(5567), 1,
      sym_template_type,
    STATE(5831), 1,
      sym_field_declaration_list,
    STATE(5904), 1,
      sym__class_declaration_item,
    STATE(7328), 1,
      sym__scope_resolution,
    STATE(7890), 1,
      sym_virtual_specifier,
    STATE(8705), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5562), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [244683] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9241), 1,
      anon_sym_LBRACE,
    ACTIONS(9627), 1,
      sym_identifier,
    STATE(5567), 1,
      sym_template_type,
    STATE(5831), 1,
      sym_field_declaration_list,
    STATE(5936), 1,
      sym__class_declaration_item,
    STATE(7328), 1,
      sym__scope_resolution,
    STATE(7890), 1,
      sym_virtual_specifier,
    STATE(8705), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5562), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6344), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [244742] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9241), 1,
      anon_sym_LBRACE,
    ACTIONS(9627), 1,
      sym_identifier,
    STATE(5567), 1,
      sym_template_type,
    STATE(5831), 1,
      sym_field_declaration_list,
    STATE(5919), 1,
      sym__class_declaration_item,
    STATE(7328), 1,
      sym__scope_resolution,
    STATE(7890), 1,
      sym_virtual_specifier,
    STATE(8705), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5562), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [244801] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9241), 1,
      anon_sym_LBRACE,
    ACTIONS(9627), 1,
      sym_identifier,
    STATE(5567), 1,
      sym_template_type,
    STATE(5831), 1,
      sym_field_declaration_list,
    STATE(5933), 1,
      sym__class_declaration_item,
    STATE(7328), 1,
      sym__scope_resolution,
    STATE(7890), 1,
      sym_virtual_specifier,
    STATE(8705), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5562), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [244860] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8017), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(3163), 1,
      sym_template_type,
    STATE(3250), 1,
      sym_field_declaration_list,
    STATE(3432), 1,
      sym__class_declaration_item,
    STATE(7325), 1,
      sym__scope_resolution,
    STATE(7872), 1,
      sym_virtual_specifier,
    STATE(8682), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2972), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [244919] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8017), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(3163), 1,
      sym_template_type,
    STATE(3250), 1,
      sym_field_declaration_list,
    STATE(3436), 1,
      sym__class_declaration_item,
    STATE(7325), 1,
      sym__scope_resolution,
    STATE(7872), 1,
      sym_virtual_specifier,
    STATE(8682), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2972), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6334), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [244978] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    ACTIONS(9572), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(5720), 1,
      sym_field_declaration_list,
    STATE(5738), 1,
      sym__class_declaration_item,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(7859), 1,
      sym_virtual_specifier,
    STATE(8491), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5522), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [245037] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5475), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9625), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2682), 1,
      sym_field_declaration_list,
    STATE(2738), 1,
      sym__class_declaration_item,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(7778), 1,
      sym_virtual_specifier,
    STATE(8430), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2121), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [245096] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9611), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2246), 1,
      sym__class_declaration_item,
    STATE(2991), 1,
      sym_field_declaration_list,
    STATE(7347), 1,
      sym__scope_resolution,
    STATE(7761), 1,
      sym_virtual_specifier,
    STATE(8591), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2798), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [245155] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9611), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2250), 1,
      sym__class_declaration_item,
    STATE(2991), 1,
      sym_field_declaration_list,
    STATE(7347), 1,
      sym__scope_resolution,
    STATE(7761), 1,
      sym_virtual_specifier,
    STATE(8591), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2798), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6406), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [245214] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7891), 1,
      anon_sym_LBRACE,
    ACTIONS(9273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9604), 1,
      sym_identifier,
    STATE(4593), 1,
      sym_template_type,
    STATE(4800), 1,
      sym_field_declaration_list,
    STATE(4851), 1,
      sym__class_declaration_item,
    STATE(7337), 1,
      sym__scope_resolution,
    STATE(7709), 1,
      sym_virtual_specifier,
    STATE(8651), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4267), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6363), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [245273] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3126), 1,
      sym__class_declaration_item,
    STATE(4670), 1,
      sym_field_declaration_list,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(7772), 1,
      sym_virtual_specifier,
    STATE(8472), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4122), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6382), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [245332] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5105), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9619), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3073), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(7326), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3042), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [245391] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5475), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9625), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2682), 1,
      sym_field_declaration_list,
    STATE(2759), 1,
      sym__class_declaration_item,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(7778), 1,
      sym_virtual_specifier,
    STATE(8430), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2121), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [245450] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5475), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9625), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2682), 1,
      sym_field_declaration_list,
    STATE(2752), 1,
      sym__class_declaration_item,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(7778), 1,
      sym_virtual_specifier,
    STATE(8430), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2121), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6359), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [245509] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8017), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(3163), 1,
      sym_template_type,
    STATE(3250), 1,
      sym_field_declaration_list,
    STATE(3418), 1,
      sym__class_declaration_item,
    STATE(7325), 1,
      sym__scope_resolution,
    STATE(7872), 1,
      sym_virtual_specifier,
    STATE(8682), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2972), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [245568] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8017), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(3163), 1,
      sym_template_type,
    STATE(3250), 1,
      sym_field_declaration_list,
    STATE(3413), 1,
      sym__class_declaration_item,
    STATE(7325), 1,
      sym__scope_resolution,
    STATE(7872), 1,
      sym_virtual_specifier,
    STATE(8682), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2972), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6346), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [245627] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5475), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9625), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2682), 1,
      sym_field_declaration_list,
    STATE(2758), 1,
      sym__class_declaration_item,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(7778), 1,
      sym_virtual_specifier,
    STATE(8430), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2121), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [245686] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    ACTIONS(9609), 1,
      anon_sym_COLON_COLON,
    STATE(2836), 1,
      sym_template_type,
    STATE(3121), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(7365), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4718), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [245745] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    ACTIONS(9609), 1,
      anon_sym_COLON_COLON,
    STATE(2836), 1,
      sym_template_type,
    STATE(3126), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(7365), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4718), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6390), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [245804] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3132), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3042), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [245863] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7891), 1,
      anon_sym_LBRACE,
    ACTIONS(9273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9604), 1,
      sym_identifier,
    STATE(4593), 1,
      sym_template_type,
    STATE(4800), 1,
      sym_field_declaration_list,
    STATE(4918), 1,
      sym__class_declaration_item,
    STATE(7337), 1,
      sym__scope_resolution,
    STATE(7709), 1,
      sym_virtual_specifier,
    STATE(8651), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4267), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [245922] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3121), 1,
      sym__class_declaration_item,
    STATE(4670), 1,
      sym_field_declaration_list,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(7772), 1,
      sym_virtual_specifier,
    STATE(8472), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4122), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [245981] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7891), 1,
      anon_sym_LBRACE,
    ACTIONS(9273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9604), 1,
      sym_identifier,
    STATE(4593), 1,
      sym_template_type,
    STATE(4800), 1,
      sym_field_declaration_list,
    STATE(4923), 1,
      sym__class_declaration_item,
    STATE(7337), 1,
      sym__scope_resolution,
    STATE(7709), 1,
      sym_virtual_specifier,
    STATE(8651), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4267), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6366), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [246040] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7891), 1,
      anon_sym_LBRACE,
    ACTIONS(9273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9604), 1,
      sym_identifier,
    STATE(4593), 1,
      sym_template_type,
    STATE(4800), 1,
      sym_field_declaration_list,
    STATE(4863), 1,
      sym__class_declaration_item,
    STATE(7337), 1,
      sym__scope_resolution,
    STATE(7709), 1,
      sym_virtual_specifier,
    STATE(8651), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4267), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [246099] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    ACTIONS(9450), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9637), 1,
      sym_identifier,
    STATE(3375), 1,
      sym_template_type,
    STATE(3846), 1,
      sym_field_declaration_list,
    STATE(4080), 1,
      sym__class_declaration_item,
    STATE(7350), 1,
      sym__scope_resolution,
    STATE(7743), 1,
      sym_virtual_specifier,
    STATE(8461), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3124), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [246158] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3073), 1,
      sym__class_declaration_item,
    STATE(4670), 1,
      sym_field_declaration_list,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(7772), 1,
      sym_virtual_specifier,
    STATE(8472), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4122), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [246217] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6477), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9327), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9574), 1,
      sym_identifier,
    STATE(3137), 1,
      sym_template_type,
    STATE(3382), 1,
      sym_field_declaration_list,
    STATE(3521), 1,
      sym__class_declaration_item,
    STATE(7329), 1,
      sym__scope_resolution,
    STATE(7773), 1,
      sym_virtual_specifier,
    STATE(8694), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2898), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6375), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [246276] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6477), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9327), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9574), 1,
      sym_identifier,
    STATE(3137), 1,
      sym_template_type,
    STATE(3382), 1,
      sym_field_declaration_list,
    STATE(3538), 1,
      sym__class_declaration_item,
    STATE(7329), 1,
      sym__scope_resolution,
    STATE(7773), 1,
      sym_virtual_specifier,
    STATE(8694), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2898), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [246335] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3079), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3042), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6339), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [246394] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9584), 1,
      sym_identifier,
    STATE(3163), 1,
      sym_template_type,
    STATE(3250), 1,
      sym_field_declaration_list,
    STATE(3447), 1,
      sym__class_declaration_item,
    STATE(7361), 1,
      sym__scope_resolution,
    STATE(7872), 1,
      sym_virtual_specifier,
    STATE(8682), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2972), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [246453] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9584), 1,
      sym_identifier,
    STATE(3163), 1,
      sym_template_type,
    STATE(3250), 1,
      sym_field_declaration_list,
    STATE(3436), 1,
      sym__class_declaration_item,
    STATE(7361), 1,
      sym__scope_resolution,
    STATE(7872), 1,
      sym_virtual_specifier,
    STATE(8682), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2972), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6372), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [246512] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9584), 1,
      sym_identifier,
    STATE(3163), 1,
      sym_template_type,
    STATE(3250), 1,
      sym_field_declaration_list,
    STATE(3432), 1,
      sym__class_declaration_item,
    STATE(7361), 1,
      sym__scope_resolution,
    STATE(7872), 1,
      sym_virtual_specifier,
    STATE(8682), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2972), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [246571] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6477), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9327), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9574), 1,
      sym_identifier,
    STATE(3137), 1,
      sym_template_type,
    STATE(3382), 1,
      sym_field_declaration_list,
    STATE(3593), 1,
      sym__class_declaration_item,
    STATE(7329), 1,
      sym__scope_resolution,
    STATE(7773), 1,
      sym_virtual_specifier,
    STATE(8694), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2898), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [246630] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6477), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9327), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9574), 1,
      sym_identifier,
    STATE(3137), 1,
      sym_template_type,
    STATE(3382), 1,
      sym_field_declaration_list,
    STATE(3605), 1,
      sym__class_declaration_item,
    STATE(7329), 1,
      sym__scope_resolution,
    STATE(7773), 1,
      sym_virtual_specifier,
    STATE(8694), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2898), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6381), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [246689] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9572), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3126), 1,
      sym__class_declaration_item,
    STATE(4670), 1,
      sym_field_declaration_list,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(7772), 1,
      sym_virtual_specifier,
    STATE(8472), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4122), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6426), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [246748] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(5720), 1,
      sym_field_declaration_list,
    STATE(5736), 1,
      sym__class_declaration_item,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(7859), 1,
      sym_virtual_specifier,
    STATE(8491), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5522), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [246807] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9635), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2271), 1,
      sym__class_declaration_item,
    STATE(2991), 1,
      sym_field_declaration_list,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(7761), 1,
      sym_virtual_specifier,
    STATE(8591), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2798), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [246866] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9635), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2266), 1,
      sym__class_declaration_item,
    STATE(2991), 1,
      sym_field_declaration_list,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(7761), 1,
      sym_virtual_specifier,
    STATE(8591), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2798), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6418), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [246925] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6477), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9327), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9574), 1,
      sym_identifier,
    STATE(3137), 1,
      sym_template_type,
    STATE(3382), 1,
      sym_field_declaration_list,
    STATE(3625), 1,
      sym__class_declaration_item,
    STATE(7329), 1,
      sym__scope_resolution,
    STATE(7773), 1,
      sym_virtual_specifier,
    STATE(8694), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2898), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [246984] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3132), 1,
      sym__class_declaration_item,
    STATE(4670), 1,
      sym_field_declaration_list,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(7772), 1,
      sym_virtual_specifier,
    STATE(8472), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4122), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [247043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9993), 1,
      anon_sym_LBRACK,
    ACTIONS(9991), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [247072] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3079), 1,
      sym__class_declaration_item,
    STATE(4670), 1,
      sym_field_declaration_list,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(7772), 1,
      sym_virtual_specifier,
    STATE(8472), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4122), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6368), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [247131] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5105), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9619), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3079), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(7326), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3042), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6354), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [247190] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9572), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3121), 1,
      sym__class_declaration_item,
    STATE(4670), 1,
      sym_field_declaration_list,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(7772), 1,
      sym_virtual_specifier,
    STATE(8472), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4122), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [247249] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8183), 1,
      anon_sym_STAR,
    ACTIONS(8185), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8187), 1,
      anon_sym_AMP,
    STATE(4378), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7195), 1,
      sym__abstract_declarator,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8269), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [247294] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6208), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9307), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(3015), 1,
      sym_template_type,
    STATE(3170), 1,
      sym_field_declaration_list,
    STATE(3357), 1,
      sym__class_declaration_item,
    STATE(7340), 1,
      sym__scope_resolution,
    STATE(7650), 1,
      sym_virtual_specifier,
    STATE(8572), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2762), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6333), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [247353] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9584), 1,
      sym_identifier,
    STATE(3163), 1,
      sym_template_type,
    STATE(3250), 1,
      sym_field_declaration_list,
    STATE(3418), 1,
      sym__class_declaration_item,
    STATE(7361), 1,
      sym__scope_resolution,
    STATE(7872), 1,
      sym_virtual_specifier,
    STATE(8682), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2972), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [247412] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    ACTIONS(9609), 1,
      anon_sym_COLON_COLON,
    STATE(2836), 1,
      sym_template_type,
    STATE(3132), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(7365), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4718), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [247471] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5105), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9619), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3132), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(7326), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3042), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [247530] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3126), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3042), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6362), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [247589] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9633), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2250), 1,
      sym__class_declaration_item,
    STATE(6097), 1,
      sym_field_declaration_list,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(7746), 1,
      sym_virtual_specifier,
    STATE(8511), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6403), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [247648] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    ACTIONS(9609), 1,
      anon_sym_COLON_COLON,
    STATE(2836), 1,
      sym_template_type,
    STATE(3079), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(7365), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4718), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6411), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [247707] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9633), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2246), 1,
      sym__class_declaration_item,
    STATE(6097), 1,
      sym_field_declaration_list,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(7746), 1,
      sym_virtual_specifier,
    STATE(8511), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [247766] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6649), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9347), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    STATE(3164), 1,
      sym_template_type,
    STATE(3490), 1,
      sym_field_declaration_list,
    STATE(3663), 1,
      sym__class_declaration_item,
    STATE(7346), 1,
      sym__scope_resolution,
    STATE(7720), 1,
      sym_virtual_specifier,
    STATE(8562), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3000), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [247825] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7891), 1,
      anon_sym_LBRACE,
    ACTIONS(9273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9604), 1,
      sym_identifier,
    STATE(4593), 1,
      sym_template_type,
    STATE(4800), 1,
      sym_field_declaration_list,
    STATE(4852), 1,
      sym__class_declaration_item,
    STATE(7337), 1,
      sym__scope_resolution,
    STATE(7709), 1,
      sym_virtual_specifier,
    STATE(8651), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4267), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [247884] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9584), 1,
      sym_identifier,
    STATE(3163), 1,
      sym_template_type,
    STATE(3250), 1,
      sym_field_declaration_list,
    STATE(3413), 1,
      sym__class_declaration_item,
    STATE(7361), 1,
      sym__scope_resolution,
    STATE(7872), 1,
      sym_virtual_specifier,
    STATE(8682), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2972), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6374), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [247943] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6649), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9347), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    STATE(3164), 1,
      sym_template_type,
    STATE(3490), 1,
      sym_field_declaration_list,
    STATE(3644), 1,
      sym__class_declaration_item,
    STATE(7346), 1,
      sym__scope_resolution,
    STATE(7720), 1,
      sym_virtual_specifier,
    STATE(8562), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3000), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6396), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [248002] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6649), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9347), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    STATE(3164), 1,
      sym_template_type,
    STATE(3490), 1,
      sym_field_declaration_list,
    STATE(3650), 1,
      sym__class_declaration_item,
    STATE(7346), 1,
      sym__scope_resolution,
    STATE(7720), 1,
      sym_virtual_specifier,
    STATE(8562), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3000), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [248061] = 5,
    ACTIONS(9965), 1,
      anon_sym_LF,
    ACTIONS(9995), 1,
      anon_sym_LPAREN2,
    ACTIONS(9997), 1,
      sym_comment,
    STATE(6545), 1,
      sym_preproc_argument_list,
    ACTIONS(9969), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [248094] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(5720), 1,
      sym_field_declaration_list,
    STATE(5761), 1,
      sym__class_declaration_item,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(7859), 1,
      sym_virtual_specifier,
    STATE(8491), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5522), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6434), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [248153] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9633), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2271), 1,
      sym__class_declaration_item,
    STATE(6097), 1,
      sym_field_declaration_list,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(7746), 1,
      sym_virtual_specifier,
    STATE(8511), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [248212] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(5720), 1,
      sym_field_declaration_list,
    STATE(5786), 1,
      sym__class_declaration_item,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(7859), 1,
      sym_virtual_specifier,
    STATE(8491), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5522), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [248271] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9633), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2266), 1,
      sym__class_declaration_item,
    STATE(6097), 1,
      sym_field_declaration_list,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(7746), 1,
      sym_virtual_specifier,
    STATE(8511), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6409), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [248330] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9611), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2271), 1,
      sym__class_declaration_item,
    STATE(2991), 1,
      sym_field_declaration_list,
    STATE(7347), 1,
      sym__scope_resolution,
    STATE(7761), 1,
      sym_virtual_specifier,
    STATE(8591), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2798), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [248389] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    ACTIONS(9572), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(5720), 1,
      sym_field_declaration_list,
    STATE(5786), 1,
      sym__class_declaration_item,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(7859), 1,
      sym_virtual_specifier,
    STATE(8491), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5522), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [248448] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6649), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9347), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    STATE(3164), 1,
      sym_template_type,
    STATE(3490), 1,
      sym_field_declaration_list,
    STATE(3681), 1,
      sym__class_declaration_item,
    STATE(7346), 1,
      sym__scope_resolution,
    STATE(7720), 1,
      sym_virtual_specifier,
    STATE(8562), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3000), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [248507] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9633), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2299), 1,
      sym__class_declaration_item,
    STATE(6097), 1,
      sym_field_declaration_list,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(7746), 1,
      sym_virtual_specifier,
    STATE(8511), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [248566] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9999), 1,
      anon_sym_COMMA,
    ACTIONS(10001), 1,
      anon_sym_RPAREN,
    ACTIONS(10007), 1,
      anon_sym_SLASH,
    ACTIONS(10009), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10011), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10013), 1,
      anon_sym_PIPE,
    ACTIONS(10015), 1,
      anon_sym_CARET,
    ACTIONS(10017), 1,
      anon_sym_AMP,
    STATE(7955), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(10003), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10005), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10019), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10021), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10023), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10025), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [248621] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    ACTIONS(9609), 1,
      anon_sym_COLON_COLON,
    STATE(2836), 1,
      sym_template_type,
    STATE(3073), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(7365), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4718), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [248680] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    ACTIONS(9572), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(5720), 1,
      sym_field_declaration_list,
    STATE(5761), 1,
      sym__class_declaration_item,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(7859), 1,
      sym_virtual_specifier,
    STATE(8491), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5522), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6348), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [248739] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6649), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9347), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    STATE(3164), 1,
      sym_template_type,
    STATE(3490), 1,
      sym_field_declaration_list,
    STATE(3686), 1,
      sym__class_declaration_item,
    STATE(7346), 1,
      sym__scope_resolution,
    STATE(7720), 1,
      sym_virtual_specifier,
    STATE(8562), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3000), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6400), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [248798] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9611), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2299), 1,
      sym__class_declaration_item,
    STATE(2991), 1,
      sym_field_declaration_list,
    STATE(7347), 1,
      sym__scope_resolution,
    STATE(7761), 1,
      sym_virtual_specifier,
    STATE(8591), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2798), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [248857] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9999), 1,
      anon_sym_COMMA,
    ACTIONS(10007), 1,
      anon_sym_SLASH,
    ACTIONS(10009), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10011), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10013), 1,
      anon_sym_PIPE,
    ACTIONS(10015), 1,
      anon_sym_CARET,
    ACTIONS(10017), 1,
      anon_sym_AMP,
    ACTIONS(10027), 1,
      anon_sym_RPAREN,
    STATE(7976), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(10003), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10005), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10019), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10021), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10023), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10025), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [248912] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7706), 1,
      anon_sym_LBRACE,
    ACTIONS(9382), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9570), 1,
      sym_identifier,
    STATE(4373), 1,
      sym_template_type,
    STATE(4675), 1,
      sym_field_declaration_list,
    STATE(4801), 1,
      sym__class_declaration_item,
    STATE(7334), 1,
      sym__scope_resolution,
    STATE(7829), 1,
      sym_virtual_specifier,
    STATE(8778), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3953), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [248971] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7706), 1,
      anon_sym_LBRACE,
    ACTIONS(9382), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9570), 1,
      sym_identifier,
    STATE(4373), 1,
      sym_template_type,
    STATE(4675), 1,
      sym_field_declaration_list,
    STATE(4805), 1,
      sym__class_declaration_item,
    STATE(7334), 1,
      sym__scope_resolution,
    STATE(7829), 1,
      sym_virtual_specifier,
    STATE(8778), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3953), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [249030] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9635), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2299), 1,
      sym__class_declaration_item,
    STATE(2991), 1,
      sym_field_declaration_list,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(7761), 1,
      sym_virtual_specifier,
    STATE(8591), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2798), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [249089] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7706), 1,
      anon_sym_LBRACE,
    ACTIONS(9382), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9570), 1,
      sym_identifier,
    STATE(4373), 1,
      sym_template_type,
    STATE(4675), 1,
      sym_field_declaration_list,
    STATE(4799), 1,
      sym__class_declaration_item,
    STATE(7334), 1,
      sym__scope_resolution,
    STATE(7829), 1,
      sym_virtual_specifier,
    STATE(8778), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3953), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [249148] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7706), 1,
      anon_sym_LBRACE,
    ACTIONS(9382), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9570), 1,
      sym_identifier,
    STATE(4373), 1,
      sym_template_type,
    STATE(4675), 1,
      sym_field_declaration_list,
    STATE(4792), 1,
      sym__class_declaration_item,
    STATE(7334), 1,
      sym__scope_resolution,
    STATE(7829), 1,
      sym_virtual_specifier,
    STATE(8778), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3953), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6428), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [249207] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(133), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(5455), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    ACTIONS(10029), 1,
      sym_identifier,
    ACTIONS(10031), 1,
      anon_sym_template,
    STATE(3302), 1,
      sym_template_function,
    STATE(3325), 1,
      sym_pointer_type_declarator,
    STATE(3333), 1,
      sym_destructor_name,
    STATE(3339), 1,
      sym_dependent_identifier,
    STATE(3342), 1,
      sym_qualified_identifier,
    STATE(3347), 1,
      sym_operator_name,
    STATE(6421), 1,
      sym__scope_resolution,
    STATE(7674), 1,
      sym_qualified_operator_cast_identifier,
    STATE(7675), 1,
      sym_operator_cast,
    STATE(9045), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [249270] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    ACTIONS(9450), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9637), 1,
      sym_identifier,
    STATE(3375), 1,
      sym_template_type,
    STATE(3846), 1,
      sym_field_declaration_list,
    STATE(4133), 1,
      sym__class_declaration_item,
    STATE(7350), 1,
      sym__scope_resolution,
    STATE(7743), 1,
      sym_virtual_specifier,
    STATE(8461), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3124), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [249329] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    ACTIONS(9450), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9637), 1,
      sym_identifier,
    STATE(3375), 1,
      sym_template_type,
    STATE(3846), 1,
      sym_field_declaration_list,
    STATE(4141), 1,
      sym__class_declaration_item,
    STATE(7350), 1,
      sym__scope_resolution,
    STATE(7743), 1,
      sym_virtual_specifier,
    STATE(8461), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3124), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6424), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [249388] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    ACTIONS(9450), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9637), 1,
      sym_identifier,
    STATE(3375), 1,
      sym_template_type,
    STATE(3846), 1,
      sym_field_declaration_list,
    STATE(4194), 1,
      sym__class_declaration_item,
    STATE(7350), 1,
      sym__scope_resolution,
    STATE(7743), 1,
      sym_virtual_specifier,
    STATE(8461), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3124), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [249447] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9572), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3079), 1,
      sym__class_declaration_item,
    STATE(4670), 1,
      sym_field_declaration_list,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(7772), 1,
      sym_virtual_specifier,
    STATE(8472), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4122), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6437), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [249506] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9572), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3132), 1,
      sym__class_declaration_item,
    STATE(4670), 1,
      sym_field_declaration_list,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(7772), 1,
      sym_virtual_specifier,
    STATE(8472), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4122), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [249565] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5105), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9619), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3121), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(7326), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3042), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [249624] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7706), 1,
      anon_sym_LBRACE,
    ACTIONS(9382), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9570), 1,
      sym_identifier,
    STATE(4373), 1,
      sym_template_type,
    STATE(4675), 1,
      sym_field_declaration_list,
    STATE(4736), 1,
      sym__class_declaration_item,
    STATE(7334), 1,
      sym__scope_resolution,
    STATE(7829), 1,
      sym_virtual_specifier,
    STATE(8778), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3953), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [249683] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5105), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9619), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3126), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(7326), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3042), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6391), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [249742] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    ACTIONS(9572), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(5720), 1,
      sym_field_declaration_list,
    STATE(5736), 1,
      sym__class_declaration_item,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(7859), 1,
      sym_virtual_specifier,
    STATE(8491), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5522), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [249801] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9999), 1,
      anon_sym_COMMA,
    ACTIONS(10007), 1,
      anon_sym_SLASH,
    ACTIONS(10009), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10011), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10013), 1,
      anon_sym_PIPE,
    ACTIONS(10015), 1,
      anon_sym_CARET,
    ACTIONS(10017), 1,
      anon_sym_AMP,
    ACTIONS(10033), 1,
      anon_sym_RPAREN,
    STATE(8204), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(10003), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10005), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10019), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10021), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10023), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10025), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [249856] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6208), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9307), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(3015), 1,
      sym_template_type,
    STATE(3170), 1,
      sym_field_declaration_list,
    STATE(3294), 1,
      sym__class_declaration_item,
    STATE(7340), 1,
      sym__scope_resolution,
    STATE(7650), 1,
      sym_virtual_specifier,
    STATE(8572), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2762), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [249915] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3121), 1,
      sym__class_declaration_item,
    STATE(3744), 1,
      sym_field_declaration_list,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym_virtual_specifier,
    STATE(8760), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3042), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [249974] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(5720), 1,
      sym_field_declaration_list,
    STATE(5738), 1,
      sym__class_declaration_item,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(7859), 1,
      sym_virtual_specifier,
    STATE(8491), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5522), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [250033] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(5720), 1,
      sym_field_declaration_list,
    STATE(5800), 1,
      sym__class_declaration_item,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(7859), 1,
      sym_virtual_specifier,
    STATE(8491), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5522), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6378), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [250092] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6208), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9307), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(3015), 1,
      sym_template_type,
    STATE(3170), 1,
      sym_field_declaration_list,
    STATE(3317), 1,
      sym__class_declaration_item,
    STATE(7340), 1,
      sym__scope_resolution,
    STATE(7650), 1,
      sym_virtual_specifier,
    STATE(8572), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2762), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6432), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [250151] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9572), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3073), 1,
      sym__class_declaration_item,
    STATE(4670), 1,
      sym_field_declaration_list,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(7772), 1,
      sym_virtual_specifier,
    STATE(8472), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4122), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [250210] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    ACTIONS(9450), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9637), 1,
      sym_identifier,
    STATE(3375), 1,
      sym_template_type,
    STATE(3846), 1,
      sym_field_declaration_list,
    STATE(4067), 1,
      sym__class_declaration_item,
    STATE(7350), 1,
      sym__scope_resolution,
    STATE(7743), 1,
      sym_virtual_specifier,
    STATE(8461), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3124), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6422), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [250269] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6208), 1,
      anon_sym_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_COLON,
    ACTIONS(9307), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(3015), 1,
      sym_template_type,
    STATE(3170), 1,
      sym_field_declaration_list,
    STATE(3348), 1,
      sym__class_declaration_item,
    STATE(7340), 1,
      sym__scope_resolution,
    STATE(7650), 1,
      sym_virtual_specifier,
    STATE(8572), 1,
      sym_base_class_clause,
    ACTIONS(5479), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2762), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [250328] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(8537), 1,
      sym_identifier,
    ACTIONS(8539), 1,
      anon_sym_LPAREN2,
    ACTIONS(8541), 1,
      anon_sym_STAR,
    ACTIONS(8543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8545), 1,
      anon_sym_AMP,
    ACTIONS(10035), 1,
      anon_sym_SEMI,
    STATE(6306), 1,
      sym__field_declarator,
    STATE(7119), 1,
      sym_operator_name,
    STATE(9267), 1,
      sym_attribute_specifier,
    STATE(9391), 1,
      sym_ms_based_modifier,
    STATE(7265), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [250380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10039), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10037), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [250408] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(8537), 1,
      sym_identifier,
    ACTIONS(8539), 1,
      anon_sym_LPAREN2,
    ACTIONS(8541), 1,
      anon_sym_STAR,
    ACTIONS(8543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8545), 1,
      anon_sym_AMP,
    ACTIONS(10041), 1,
      anon_sym_SEMI,
    STATE(6276), 1,
      sym__field_declarator,
    STATE(7119), 1,
      sym_operator_name,
    STATE(8938), 1,
      sym_attribute_specifier,
    STATE(9391), 1,
      sym_ms_based_modifier,
    STATE(7265), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [250460] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(8283), 1,
      anon_sym_STAR,
    ACTIONS(10043), 1,
      sym_identifier,
    ACTIONS(10045), 1,
      anon_sym_TILDE,
    ACTIONS(10047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10049), 1,
      anon_sym_template,
    ACTIONS(10051), 1,
      anon_sym_operator,
    STATE(2825), 1,
      sym_template_type,
    STATE(2828), 1,
      sym_dependent_type_identifier,
    STATE(2834), 1,
      sym_qualified_type_identifier,
    STATE(4234), 1,
      sym_pointer_type_declarator,
    STATE(4245), 1,
      sym_destructor_name,
    STATE(4249), 1,
      sym_dependent_identifier,
    STATE(4251), 1,
      sym_qualified_identifier,
    STATE(4254), 1,
      sym_operator_name,
    STATE(4275), 1,
      sym_template_function,
    STATE(6443), 1,
      sym__scope_resolution,
    STATE(9101), 1,
      sym_ms_based_modifier,
    STATE(9504), 1,
      sym_decltype,
  [250524] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7321), 1,
      sym__type_declarator,
    STATE(7844), 1,
      sym__type_definition_declarators,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [250570] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7321), 1,
      sym__type_declarator,
    STATE(7864), 1,
      sym__type_definition_declarators,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [250616] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(8333), 1,
      anon_sym_STAR,
    ACTIONS(10053), 1,
      sym_identifier,
    ACTIONS(10055), 1,
      anon_sym_TILDE,
    ACTIONS(10057), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10059), 1,
      anon_sym_template,
    ACTIONS(10061), 1,
      anon_sym_operator,
    STATE(2825), 1,
      sym_template_type,
    STATE(2828), 1,
      sym_dependent_type_identifier,
    STATE(2834), 1,
      sym_qualified_type_identifier,
    STATE(2949), 1,
      sym_pointer_type_declarator,
    STATE(2950), 1,
      sym_template_function,
    STATE(2952), 1,
      sym_destructor_name,
    STATE(2960), 1,
      sym_dependent_identifier,
    STATE(2961), 1,
      sym_qualified_identifier,
    STATE(2963), 1,
      sym_operator_name,
    STATE(6446), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
    STATE(9571), 1,
      sym_ms_based_modifier,
  [250680] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7321), 1,
      sym__type_declarator,
    STATE(7683), 1,
      sym__type_definition_declarators,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [250726] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7321), 1,
      sym__type_declarator,
    STATE(7779), 1,
      sym__type_definition_declarators,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [250772] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(4304), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    ACTIONS(10063), 1,
      sym_identifier,
    ACTIONS(10065), 1,
      anon_sym_template,
    STATE(2825), 1,
      sym_template_type,
    STATE(2828), 1,
      sym_dependent_type_identifier,
    STATE(2834), 1,
      sym_qualified_type_identifier,
    STATE(3302), 1,
      sym_template_function,
    STATE(3325), 1,
      sym_pointer_type_declarator,
    STATE(3333), 1,
      sym_destructor_name,
    STATE(3339), 1,
      sym_dependent_identifier,
    STATE(3342), 1,
      sym_qualified_identifier,
    STATE(3347), 1,
      sym_operator_name,
    STATE(6449), 1,
      sym__scope_resolution,
    STATE(9045), 1,
      sym_ms_based_modifier,
    STATE(9504), 1,
      sym_decltype,
  [250836] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7321), 1,
      sym__type_declarator,
    STATE(7632), 1,
      sym__type_definition_declarators,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [250882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6975), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6977), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [250910] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7321), 1,
      sym__type_declarator,
    STATE(7868), 1,
      sym__type_definition_declarators,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [250956] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(8309), 1,
      anon_sym_STAR,
    ACTIONS(10067), 1,
      sym_identifier,
    ACTIONS(10069), 1,
      anon_sym_TILDE,
    ACTIONS(10071), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10073), 1,
      anon_sym_template,
    ACTIONS(10075), 1,
      anon_sym_operator,
    STATE(2825), 1,
      sym_template_type,
    STATE(2828), 1,
      sym_dependent_type_identifier,
    STATE(2834), 1,
      sym_qualified_type_identifier,
    STATE(3704), 1,
      sym_operator_name,
    STATE(3707), 1,
      sym_qualified_identifier,
    STATE(3709), 1,
      sym_dependent_identifier,
    STATE(3710), 1,
      sym_destructor_name,
    STATE(3711), 1,
      sym_template_function,
    STATE(3713), 1,
      sym_pointer_type_declarator,
    STATE(6453), 1,
      sym__scope_resolution,
    STATE(9416), 1,
      sym_ms_based_modifier,
    STATE(9504), 1,
      sym_decltype,
  [251020] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7321), 1,
      sym__type_declarator,
    STATE(7627), 1,
      sym__type_definition_declarators,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [251066] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(8537), 1,
      sym_identifier,
    ACTIONS(8539), 1,
      anon_sym_LPAREN2,
    ACTIONS(8541), 1,
      anon_sym_STAR,
    ACTIONS(8543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8545), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_SEMI,
    STATE(6259), 1,
      sym__field_declarator,
    STATE(7119), 1,
      sym_operator_name,
    STATE(9391), 1,
      sym_ms_based_modifier,
    STATE(9419), 1,
      sym_attribute_specifier,
    STATE(7265), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [251118] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9882), 1,
      anon_sym_try,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(10081), 1,
      anon_sym_LPAREN2,
    ACTIONS(10083), 1,
      anon_sym_SEMI,
    ACTIONS(10085), 1,
      anon_sym_LBRACE,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10089), 1,
      anon_sym_EQ,
    STATE(2600), 1,
      sym_try_statement,
    STATE(2608), 1,
      sym_compound_statement,
    STATE(4238), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(8225), 1,
      aux_sym_declaration_repeat1,
    STATE(8227), 1,
      sym_gnu_asm_expression,
    ACTIONS(10091), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8483), 2,
      sym_argument_list,
      sym_initializer_list,
  [251176] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(8341), 1,
      anon_sym_STAR,
    ACTIONS(10093), 1,
      sym_identifier,
    ACTIONS(10095), 1,
      anon_sym_TILDE,
    ACTIONS(10097), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10099), 1,
      anon_sym_template,
    ACTIONS(10101), 1,
      anon_sym_operator,
    STATE(2825), 1,
      sym_template_type,
    STATE(2828), 1,
      sym_dependent_type_identifier,
    STATE(2834), 1,
      sym_qualified_type_identifier,
    STATE(4047), 1,
      sym_pointer_type_declarator,
    STATE(4049), 1,
      sym_template_function,
    STATE(4050), 1,
      sym_destructor_name,
    STATE(4051), 1,
      sym_dependent_identifier,
    STATE(4052), 1,
      sym_qualified_identifier,
    STATE(4053), 1,
      sym_operator_name,
    STATE(6457), 1,
      sym__scope_resolution,
    STATE(9121), 1,
      sym_ms_based_modifier,
    STATE(9504), 1,
      sym_decltype,
  [251240] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7321), 1,
      sym__type_declarator,
    STATE(7795), 1,
      sym__type_definition_declarators,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [251286] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(8341), 1,
      anon_sym_STAR,
    ACTIONS(10103), 1,
      sym_identifier,
    ACTIONS(10105), 1,
      anon_sym_TILDE,
    ACTIONS(10107), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10109), 1,
      anon_sym_template,
    ACTIONS(10111), 1,
      anon_sym_operator,
    STATE(2235), 1,
      sym_dependent_type_identifier,
    STATE(2237), 1,
      sym_template_type,
    STATE(2294), 1,
      sym_qualified_type_identifier,
    STATE(3913), 1,
      sym_pointer_type_declarator,
    STATE(3914), 1,
      sym_template_function,
    STATE(3915), 1,
      sym_destructor_name,
    STATE(3916), 1,
      sym_dependent_identifier,
    STATE(3918), 1,
      sym_qualified_identifier,
    STATE(3919), 1,
      sym_operator_name,
    STATE(6459), 1,
      sym__scope_resolution,
    STATE(9121), 1,
      sym_ms_based_modifier,
    STATE(9504), 1,
      sym_decltype,
  [251350] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(10081), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10089), 1,
      anon_sym_EQ,
    ACTIONS(10113), 1,
      anon_sym_SEMI,
    ACTIONS(10115), 1,
      anon_sym_LBRACE,
    ACTIONS(10117), 1,
      anon_sym_try,
    STATE(914), 1,
      sym_try_statement,
    STATE(917), 1,
      sym_compound_statement,
    STATE(4238), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(7997), 1,
      aux_sym_declaration_repeat1,
    STATE(7999), 1,
      sym_gnu_asm_expression,
    ACTIONS(10091), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8483), 2,
      sym_argument_list,
      sym_initializer_list,
  [251408] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7321), 1,
      sym__type_declarator,
    STATE(7908), 1,
      sym__type_definition_declarators,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [251454] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7321), 1,
      sym__type_declarator,
    STATE(7832), 1,
      sym__type_definition_declarators,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [251500] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7321), 1,
      sym__type_declarator,
    STATE(7809), 1,
      sym__type_definition_declarators,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [251546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10121), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10119), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [251574] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7321), 1,
      sym__type_declarator,
    STATE(7885), 1,
      sym__type_definition_declarators,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [251620] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7321), 1,
      sym__type_declarator,
    STATE(7931), 1,
      sym__type_definition_declarators,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [251666] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7321), 1,
      sym__type_declarator,
    STATE(7857), 1,
      sym__type_definition_declarators,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [251712] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9938), 1,
      anon_sym_try,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(10081), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10089), 1,
      anon_sym_EQ,
    ACTIONS(10123), 1,
      anon_sym_SEMI,
    ACTIONS(10125), 1,
      anon_sym_LBRACE,
    STATE(2466), 1,
      sym_compound_statement,
    STATE(2467), 1,
      sym_try_statement,
    STATE(4238), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(8065), 1,
      sym_gnu_asm_expression,
    STATE(8066), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(10091), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8483), 2,
      sym_argument_list,
      sym_initializer_list,
  [251770] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7321), 1,
      sym__type_declarator,
    STATE(7780), 1,
      sym__type_definition_declarators,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [251816] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7321), 1,
      sym__type_declarator,
    STATE(7687), 1,
      sym__type_definition_declarators,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [251862] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(8341), 1,
      anon_sym_STAR,
    ACTIONS(10095), 1,
      anon_sym_TILDE,
    ACTIONS(10101), 1,
      anon_sym_operator,
    ACTIONS(10127), 1,
      sym_identifier,
    ACTIONS(10129), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10131), 1,
      anon_sym_template,
    STATE(2825), 1,
      sym_template_type,
    STATE(2828), 1,
      sym_dependent_type_identifier,
    STATE(2834), 1,
      sym_qualified_type_identifier,
    STATE(4047), 1,
      sym_pointer_type_declarator,
    STATE(4049), 1,
      sym_template_function,
    STATE(4050), 1,
      sym_destructor_name,
    STATE(4051), 1,
      sym_dependent_identifier,
    STATE(4052), 1,
      sym_qualified_identifier,
    STATE(4053), 1,
      sym_operator_name,
    STATE(6471), 1,
      sym__scope_resolution,
    STATE(9121), 1,
      sym_ms_based_modifier,
    STATE(9504), 1,
      sym_decltype,
  [251926] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7321), 1,
      sym__type_declarator,
    STATE(7667), 1,
      sym__type_definition_declarators,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [251972] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(8283), 1,
      anon_sym_STAR,
    ACTIONS(10045), 1,
      anon_sym_TILDE,
    ACTIONS(10051), 1,
      anon_sym_operator,
    ACTIONS(10133), 1,
      sym_identifier,
    ACTIONS(10135), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10137), 1,
      anon_sym_template,
    STATE(3168), 1,
      sym_template_type,
    STATE(3173), 1,
      sym_dependent_type_identifier,
    STATE(3210), 1,
      sym_qualified_type_identifier,
    STATE(4234), 1,
      sym_pointer_type_declarator,
    STATE(4245), 1,
      sym_destructor_name,
    STATE(4249), 1,
      sym_dependent_identifier,
    STATE(4251), 1,
      sym_qualified_identifier,
    STATE(4254), 1,
      sym_operator_name,
    STATE(4275), 1,
      sym_template_function,
    STATE(6473), 1,
      sym__scope_resolution,
    STATE(9101), 1,
      sym_ms_based_modifier,
    STATE(9504), 1,
      sym_decltype,
  [252036] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(8341), 1,
      anon_sym_STAR,
    ACTIONS(10105), 1,
      anon_sym_TILDE,
    ACTIONS(10111), 1,
      anon_sym_operator,
    ACTIONS(10139), 1,
      sym_identifier,
    ACTIONS(10141), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10143), 1,
      anon_sym_template,
    STATE(2825), 1,
      sym_template_type,
    STATE(2828), 1,
      sym_dependent_type_identifier,
    STATE(2834), 1,
      sym_qualified_type_identifier,
    STATE(3913), 1,
      sym_pointer_type_declarator,
    STATE(3914), 1,
      sym_template_function,
    STATE(3915), 1,
      sym_destructor_name,
    STATE(3916), 1,
      sym_dependent_identifier,
    STATE(3918), 1,
      sym_qualified_identifier,
    STATE(3919), 1,
      sym_operator_name,
    STATE(6474), 1,
      sym__scope_resolution,
    STATE(9121), 1,
      sym_ms_based_modifier,
    STATE(9504), 1,
      sym_decltype,
  [252100] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(8333), 1,
      anon_sym_STAR,
    ACTIONS(10055), 1,
      anon_sym_TILDE,
    ACTIONS(10061), 1,
      anon_sym_operator,
    ACTIONS(10145), 1,
      sym_identifier,
    ACTIONS(10147), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10149), 1,
      anon_sym_template,
    STATE(2825), 1,
      sym_template_type,
    STATE(2828), 1,
      sym_dependent_type_identifier,
    STATE(2834), 1,
      sym_qualified_type_identifier,
    STATE(2949), 1,
      sym_pointer_type_declarator,
    STATE(2950), 1,
      sym_template_function,
    STATE(2952), 1,
      sym_destructor_name,
    STATE(2960), 1,
      sym_dependent_identifier,
    STATE(2961), 1,
      sym_qualified_identifier,
    STATE(2963), 1,
      sym_operator_name,
    STATE(6475), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
    STATE(9571), 1,
      sym_ms_based_modifier,
  [252164] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(10081), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10089), 1,
      anon_sym_EQ,
    ACTIONS(10151), 1,
      anon_sym_SEMI,
    ACTIONS(10153), 1,
      anon_sym_LBRACE,
    ACTIONS(10155), 1,
      anon_sym_try,
    STATE(598), 1,
      sym_try_statement,
    STATE(599), 1,
      sym_compound_statement,
    STATE(4238), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(8118), 1,
      sym_gnu_asm_expression,
    STATE(8120), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(10091), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8483), 2,
      sym_argument_list,
      sym_initializer_list,
  [252222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10159), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10157), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [252250] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9981), 1,
      anon_sym_LBRACK,
    STATE(5630), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6670), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9979), 13,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [252286] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9989), 1,
      anon_sym_LBRACK,
    STATE(5630), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6675), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9987), 13,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [252322] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(10081), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10089), 1,
      anon_sym_EQ,
    ACTIONS(10161), 1,
      anon_sym_SEMI,
    ACTIONS(10163), 1,
      anon_sym_LBRACE,
    ACTIONS(10165), 1,
      anon_sym_try,
    STATE(947), 1,
      sym_compound_statement,
    STATE(949), 1,
      sym_try_statement,
    STATE(4238), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(8369), 1,
      aux_sym_declaration_repeat1,
    STATE(8370), 1,
      sym_gnu_asm_expression,
    ACTIONS(10091), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8483), 2,
      sym_argument_list,
      sym_initializer_list,
  [252380] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7321), 1,
      sym__type_declarator,
    STATE(7826), 1,
      sym__type_definition_declarators,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [252426] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(5158), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    ACTIONS(10167), 1,
      sym_identifier,
    ACTIONS(10169), 1,
      anon_sym_template,
    STATE(2825), 1,
      sym_template_type,
    STATE(2828), 1,
      sym_dependent_type_identifier,
    STATE(2834), 1,
      sym_qualified_type_identifier,
    STATE(3302), 1,
      sym_template_function,
    STATE(3325), 1,
      sym_pointer_type_declarator,
    STATE(3333), 1,
      sym_destructor_name,
    STATE(3339), 1,
      sym_dependent_identifier,
    STATE(3342), 1,
      sym_qualified_identifier,
    STATE(3347), 1,
      sym_operator_name,
    STATE(6482), 1,
      sym__scope_resolution,
    STATE(9045), 1,
      sym_ms_based_modifier,
    STATE(9504), 1,
      sym_decltype,
  [252490] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7321), 1,
      sym__type_declarator,
    STATE(7660), 1,
      sym__type_definition_declarators,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [252536] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10007), 1,
      anon_sym_SLASH,
    ACTIONS(10003), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10005), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10173), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10171), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [252570] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10007), 1,
      anon_sym_SLASH,
    ACTIONS(10003), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10005), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10025), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10173), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10171), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [252606] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9916), 1,
      anon_sym_try,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(10081), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10089), 1,
      anon_sym_EQ,
    ACTIONS(10175), 1,
      anon_sym_SEMI,
    ACTIONS(10177), 1,
      anon_sym_LBRACE,
    STATE(2339), 1,
      sym_try_statement,
    STATE(2346), 1,
      sym_compound_statement,
    STATE(4238), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(7945), 1,
      sym_gnu_asm_expression,
    STATE(7946), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(10091), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8483), 2,
      sym_argument_list,
      sym_initializer_list,
  [252664] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7321), 1,
      sym__type_declarator,
    STATE(7874), 1,
      sym__type_definition_declarators,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [252710] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10007), 1,
      anon_sym_SLASH,
    ACTIONS(10003), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10005), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10021), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10023), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10025), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10173), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(10171), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [252750] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10007), 1,
      anon_sym_SLASH,
    ACTIONS(10003), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10005), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10019), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10021), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10023), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10025), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10173), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(10171), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [252792] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10007), 1,
      anon_sym_SLASH,
    ACTIONS(10017), 1,
      anon_sym_AMP,
    ACTIONS(10173), 1,
      anon_sym_PIPE,
    ACTIONS(10003), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10005), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10019), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10021), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10023), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10025), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10171), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [252836] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7321), 1,
      sym__type_declarator,
    STATE(7899), 1,
      sym__type_definition_declarators,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [252882] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10007), 1,
      anon_sym_SLASH,
    ACTIONS(10015), 1,
      anon_sym_CARET,
    ACTIONS(10017), 1,
      anon_sym_AMP,
    ACTIONS(10173), 1,
      anon_sym_PIPE,
    ACTIONS(10003), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10005), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10019), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10021), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10023), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10025), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10171), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [252928] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10007), 1,
      anon_sym_SLASH,
    ACTIONS(10013), 1,
      anon_sym_PIPE,
    ACTIONS(10015), 1,
      anon_sym_CARET,
    ACTIONS(10017), 1,
      anon_sym_AMP,
    ACTIONS(10003), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10005), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10019), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10021), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10023), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10025), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10171), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [252974] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7321), 1,
      sym__type_declarator,
    STATE(7710), 1,
      sym__type_definition_declarators,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [253020] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10007), 1,
      anon_sym_SLASH,
    ACTIONS(10011), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10013), 1,
      anon_sym_PIPE,
    ACTIONS(10015), 1,
      anon_sym_CARET,
    ACTIONS(10017), 1,
      anon_sym_AMP,
    ACTIONS(10003), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10005), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10019), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10021), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10023), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10025), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10171), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
  [253068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6981), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [253096] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(8333), 1,
      anon_sym_STAR,
    ACTIONS(10055), 1,
      anon_sym_TILDE,
    ACTIONS(10061), 1,
      anon_sym_operator,
    ACTIONS(10179), 1,
      sym_identifier,
    ACTIONS(10181), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10183), 1,
      anon_sym_template,
    STATE(2825), 1,
      sym_template_type,
    STATE(2828), 1,
      sym_dependent_type_identifier,
    STATE(2834), 1,
      sym_qualified_type_identifier,
    STATE(2949), 1,
      sym_pointer_type_declarator,
    STATE(2950), 1,
      sym_template_function,
    STATE(2952), 1,
      sym_destructor_name,
    STATE(2960), 1,
      sym_dependent_identifier,
    STATE(2961), 1,
      sym_qualified_identifier,
    STATE(2963), 1,
      sym_operator_name,
    STATE(6497), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
    STATE(9571), 1,
      sym_ms_based_modifier,
  [253160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10173), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10171), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [253188] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2073), 1,
      anon_sym_LBRACE,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(10081), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10089), 1,
      anon_sym_EQ,
    ACTIONS(10185), 1,
      anon_sym_SEMI,
    ACTIONS(10187), 1,
      anon_sym_try,
    STATE(1092), 1,
      sym_compound_statement,
    STATE(1093), 1,
      sym_try_statement,
    STATE(4238), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(8293), 1,
      sym_gnu_asm_expression,
    STATE(8297), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(10091), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8483), 2,
      sym_argument_list,
      sym_initializer_list,
  [253246] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10007), 1,
      anon_sym_SLASH,
    ACTIONS(10005), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10173), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10171), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [253278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10191), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10189), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [253306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10195), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10193), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [253334] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(8333), 1,
      anon_sym_STAR,
    ACTIONS(9902), 1,
      anon_sym_TILDE,
    ACTIONS(10197), 1,
      sym_identifier,
    ACTIONS(10199), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10201), 1,
      anon_sym_template,
    ACTIONS(10203), 1,
      anon_sym_operator,
    STATE(2825), 1,
      sym_template_type,
    STATE(2828), 1,
      sym_dependent_type_identifier,
    STATE(2834), 1,
      sym_qualified_type_identifier,
    STATE(3302), 1,
      sym_template_function,
    STATE(3325), 1,
      sym_pointer_type_declarator,
    STATE(3333), 1,
      sym_destructor_name,
    STATE(3339), 1,
      sym_dependent_identifier,
    STATE(3342), 1,
      sym_qualified_identifier,
    STATE(3347), 1,
      sym_operator_name,
    STATE(6503), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
    STATE(9571), 1,
      sym_ms_based_modifier,
  [253398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10207), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10205), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [253426] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10007), 1,
      anon_sym_SLASH,
    ACTIONS(10009), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10011), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10013), 1,
      anon_sym_PIPE,
    ACTIONS(10015), 1,
      anon_sym_CARET,
    ACTIONS(10017), 1,
      anon_sym_AMP,
    ACTIONS(10003), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10005), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10019), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10021), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10023), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10025), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10209), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [253476] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9898), 1,
      anon_sym_try,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(10081), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10089), 1,
      anon_sym_EQ,
    ACTIONS(10211), 1,
      anon_sym_SEMI,
    ACTIONS(10213), 1,
      anon_sym_LBRACE,
    STATE(2182), 1,
      sym_try_statement,
    STATE(2183), 1,
      sym_compound_statement,
    STATE(4238), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(8073), 1,
      aux_sym_declaration_repeat1,
    STATE(8074), 1,
      sym_gnu_asm_expression,
    ACTIONS(10091), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8483), 2,
      sym_argument_list,
      sym_initializer_list,
  [253534] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(8537), 1,
      sym_identifier,
    ACTIONS(8539), 1,
      anon_sym_LPAREN2,
    ACTIONS(8541), 1,
      anon_sym_STAR,
    ACTIONS(8543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8545), 1,
      anon_sym_AMP,
    ACTIONS(10215), 1,
      anon_sym_SEMI,
    STATE(6279), 1,
      sym__field_declarator,
    STATE(7119), 1,
      sym_operator_name,
    STATE(9163), 1,
      sym_attribute_specifier,
    STATE(9391), 1,
      sym_ms_based_modifier,
    STATE(7265), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [253586] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(10081), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10089), 1,
      anon_sym_EQ,
    ACTIONS(10217), 1,
      anon_sym_SEMI,
    ACTIONS(10219), 1,
      anon_sym_LBRACE,
    ACTIONS(10221), 1,
      anon_sym_try,
    STATE(404), 1,
      sym_try_statement,
    STATE(408), 1,
      sym_compound_statement,
    STATE(4238), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(8153), 1,
      sym_gnu_asm_expression,
    STATE(8158), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(10091), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8483), 2,
      sym_argument_list,
      sym_initializer_list,
  [253644] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8263), 1,
      anon_sym_STAR,
    ACTIONS(8265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8267), 1,
      anon_sym_AMP,
    STATE(4425), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7211), 1,
      sym__abstract_declarator,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8269), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [253688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10225), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10223), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [253716] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(8341), 1,
      anon_sym_STAR,
    ACTIONS(10095), 1,
      anon_sym_TILDE,
    ACTIONS(10101), 1,
      anon_sym_operator,
    ACTIONS(10227), 1,
      sym_identifier,
    ACTIONS(10229), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10231), 1,
      anon_sym_template,
    STATE(2235), 1,
      sym_dependent_type_identifier,
    STATE(2237), 1,
      sym_template_type,
    STATE(2294), 1,
      sym_qualified_type_identifier,
    STATE(4047), 1,
      sym_pointer_type_declarator,
    STATE(4049), 1,
      sym_template_function,
    STATE(4050), 1,
      sym_destructor_name,
    STATE(4051), 1,
      sym_dependent_identifier,
    STATE(4052), 1,
      sym_qualified_identifier,
    STATE(4053), 1,
      sym_operator_name,
    STATE(6511), 1,
      sym__scope_resolution,
    STATE(9121), 1,
      sym_ms_based_modifier,
    STATE(9504), 1,
      sym_decltype,
  [253780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10235), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10233), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [253808] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9518), 1,
      anon_sym_requires,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [253843] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9676), 1,
      anon_sym_requires,
    ACTIONS(9661), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [253878] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(9273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10237), 1,
      sym_identifier,
    STATE(3927), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4586), 1,
      sym_primitive_type,
    STATE(7337), 1,
      sym__scope_resolution,
    STATE(4824), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(7646), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9275), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [253923] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7869), 1,
      anon_sym_DASH_GT,
    ACTIONS(10241), 1,
      anon_sym_LBRACK,
    ACTIONS(10246), 1,
      anon_sym_requires,
    STATE(6638), 1,
      sym_trailing_return_type,
    ACTIONS(10243), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6742), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [253962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10251), 1,
      anon_sym_LBRACK,
    ACTIONS(10249), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [253989] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10253), 1,
      sym_identifier,
    STATE(4811), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5322), 1,
      sym_primitive_type,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(5809), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(7945), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7943), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [254034] = 6,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10171), 1,
      anon_sym_LF,
    ACTIONS(10255), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10173), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [254067] = 7,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10171), 1,
      anon_sym_LF,
    ACTIONS(10255), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10261), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10173), 7,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [254102] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10171), 1,
      anon_sym_LF,
    ACTIONS(10255), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10173), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [254133] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(10265), 1,
      anon_sym_LBRACK,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6685), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10263), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [254168] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(7833), 1,
      anon_sym_DASH_GT,
    ACTIONS(10241), 1,
      anon_sym_LBRACK,
    STATE(6661), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6742), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [254207] = 8,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10171), 1,
      anon_sym_LF,
    ACTIONS(10255), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10267), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10261), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10173), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
  [254244] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10157), 1,
      anon_sym_LF,
    ACTIONS(10159), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [254271] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_virtual,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(4047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(7160), 1,
      sym_access_specifier,
    STATE(7352), 1,
      sym__scope_resolution,
    STATE(7851), 1,
      sym_virtual,
    STATE(6604), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7848), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10269), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [254322] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    STATE(6597), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [254361] = 9,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10171), 1,
      anon_sym_LF,
    ACTIONS(10271), 1,
      anon_sym_AMP,
    ACTIONS(10255), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10267), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10173), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(10261), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [254400] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(10241), 1,
      anon_sym_LBRACK,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6742), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [254435] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9981), 1,
      anon_sym_LBRACK,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9979), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [254466] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6065), 1,
      anon_sym_LBRACK,
    ACTIONS(10273), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6067), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [254495] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_virtual,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(4047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(7169), 1,
      sym_access_specifier,
    STATE(7352), 1,
      sym__scope_resolution,
    STATE(7697), 1,
      sym_virtual,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8221), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10269), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [254546] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7453), 1,
      sym__type_declarator,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [254589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5304), 1,
      anon_sym_LBRACK,
    ACTIONS(5306), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [254616] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9664), 1,
      anon_sym_requires,
    STATE(6660), 1,
      sym_trailing_return_type,
    ACTIONS(9661), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [254655] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [254690] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(7833), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    STATE(6618), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [254729] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7444), 1,
      sym__type_declarator,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [254772] = 10,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10171), 1,
      anon_sym_LF,
    ACTIONS(10271), 1,
      anon_sym_AMP,
    ACTIONS(10275), 1,
      anon_sym_CARET,
    ACTIONS(10255), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10267), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10173), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10261), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [254813] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [254848] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(7833), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    STATE(6597), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [254887] = 12,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10271), 1,
      anon_sym_AMP,
    ACTIONS(10275), 1,
      anon_sym_CARET,
    ACTIONS(10277), 1,
      anon_sym_LF,
    ACTIONS(10279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10281), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10283), 1,
      anon_sym_PIPE,
    ACTIONS(10255), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10267), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10261), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [254932] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7471), 1,
      sym__type_declarator,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [254975] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(10241), 1,
      anon_sym_LBRACK,
    ACTIONS(10285), 1,
      anon_sym_requires,
    STATE(6625), 1,
      sym_trailing_return_type,
    ACTIONS(10243), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6742), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [255014] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10119), 1,
      anon_sym_LF,
    ACTIONS(10121), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [255041] = 12,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10271), 1,
      anon_sym_AMP,
    ACTIONS(10275), 1,
      anon_sym_CARET,
    ACTIONS(10279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10281), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10283), 1,
      anon_sym_PIPE,
    ACTIONS(10288), 1,
      anon_sym_LF,
    ACTIONS(10255), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10267), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10261), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [255086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5300), 1,
      anon_sym_LBRACK,
    ACTIONS(5302), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [255113] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9518), 1,
      anon_sym_requires,
    STATE(6552), 1,
      sym_trailing_return_type,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [255152] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7442), 1,
      sym__type_declarator,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [255195] = 11,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10171), 1,
      anon_sym_LF,
    ACTIONS(10271), 1,
      anon_sym_AMP,
    ACTIONS(10275), 1,
      anon_sym_CARET,
    ACTIONS(10283), 1,
      anon_sym_PIPE,
    ACTIONS(10173), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(10255), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10267), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10261), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [255238] = 12,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10271), 1,
      anon_sym_AMP,
    ACTIONS(10275), 1,
      anon_sym_CARET,
    ACTIONS(10279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10281), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10283), 1,
      anon_sym_PIPE,
    ACTIONS(10290), 1,
      anon_sym_LF,
    ACTIONS(10255), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10267), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10261), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [255283] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9664), 1,
      anon_sym_requires,
    ACTIONS(9661), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [255318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5320), 1,
      anon_sym_LBRACK,
    ACTIONS(5322), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [255345] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10292), 1,
      sym_identifier,
    STATE(3331), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4112), 1,
      sym_primitive_type,
    STATE(7322), 1,
      sym__scope_resolution,
    STATE(3111), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(4049), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [255390] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(4047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10292), 1,
      sym_identifier,
    STATE(3331), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4112), 1,
      sym_primitive_type,
    STATE(7352), 1,
      sym__scope_resolution,
    STATE(3111), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(4049), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [255435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10296), 1,
      anon_sym_LBRACK,
    ACTIONS(10294), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [255462] = 12,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10271), 1,
      anon_sym_AMP,
    ACTIONS(10275), 1,
      anon_sym_CARET,
    ACTIONS(10279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10281), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10283), 1,
      anon_sym_PIPE,
    ACTIONS(10298), 1,
      anon_sym_LF,
    ACTIONS(10255), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10267), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10261), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [255507] = 12,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10171), 1,
      anon_sym_LF,
    ACTIONS(10173), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10271), 1,
      anon_sym_AMP,
    ACTIONS(10275), 1,
      anon_sym_CARET,
    ACTIONS(10281), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10283), 1,
      anon_sym_PIPE,
    ACTIONS(10255), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10267), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10261), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [255552] = 12,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10271), 1,
      anon_sym_AMP,
    ACTIONS(10275), 1,
      anon_sym_CARET,
    ACTIONS(10279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10281), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10283), 1,
      anon_sym_PIPE,
    ACTIONS(10300), 1,
      anon_sym_LF,
    ACTIONS(10255), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10267), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10261), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [255597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5288), 1,
      anon_sym_LBRACK,
    ACTIONS(5290), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [255624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5316), 1,
      anon_sym_LBRACK,
    ACTIONS(5318), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [255651] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10304), 1,
      anon_sym_LBRACK,
    ACTIONS(10306), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6562), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(10302), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [255682] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10309), 1,
      sym_identifier,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2677), 1,
      sym_primitive_type,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(2278), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [255727] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(7833), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    STATE(6601), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [255766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5324), 1,
      anon_sym_LBRACK,
    ACTIONS(5326), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [255793] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    STATE(6601), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [255832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5332), 1,
      anon_sym_LBRACK,
    ACTIONS(5334), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [255859] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10313), 1,
      anon_sym_LBRACK,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6562), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(10311), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [255890] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7351), 1,
      sym__type_declarator,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [255933] = 3,
    ACTIONS(6981), 1,
      anon_sym_LF,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(6979), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [255960] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6006), 1,
      anon_sym_LBRACK,
    ACTIONS(10273), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10315), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(6008), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [255991] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6006), 1,
      anon_sym_LBRACK,
    ACTIONS(10317), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10319), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6008), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [256022] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10205), 1,
      anon_sym_LF,
    ACTIONS(10207), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [256049] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10171), 1,
      anon_sym_LF,
    ACTIONS(10173), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [256076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5292), 1,
      anon_sym_LBRACK,
    ACTIONS(5294), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [256103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5296), 1,
      anon_sym_LBRACK,
    ACTIONS(5298), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [256130] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7615), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8352), 1,
      anon_sym_STAR,
    ACTIONS(10321), 1,
      sym_identifier,
    ACTIONS(10323), 1,
      anon_sym_template,
    STATE(6577), 1,
      sym__scope_resolution,
    STATE(7068), 1,
      sym_pointer_type_declarator,
    STATE(7069), 1,
      sym_destructor_name,
    STATE(7071), 1,
      sym_dependent_identifier,
    STATE(7075), 1,
      sym_qualified_identifier,
    STATE(7083), 1,
      sym_operator_name,
    STATE(7115), 1,
      sym_template_function,
    STATE(9674), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [256187] = 12,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10271), 1,
      anon_sym_AMP,
    ACTIONS(10275), 1,
      anon_sym_CARET,
    ACTIONS(10279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10281), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10283), 1,
      anon_sym_PIPE,
    ACTIONS(10325), 1,
      anon_sym_LF,
    ACTIONS(10255), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10267), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10261), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [256232] = 12,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10271), 1,
      anon_sym_AMP,
    ACTIONS(10275), 1,
      anon_sym_CARET,
    ACTIONS(10279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10281), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10283), 1,
      anon_sym_PIPE,
    ACTIONS(10327), 1,
      anon_sym_LF,
    ACTIONS(10255), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10267), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10261), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [256277] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10253), 1,
      sym_identifier,
    STATE(4811), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5322), 1,
      sym_primitive_type,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(5809), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(7945), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7943), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [256322] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10223), 1,
      anon_sym_LF,
    ACTIONS(10225), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [256349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 1,
      anon_sym_LBRACK,
    ACTIONS(5314), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [256376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 1,
      anon_sym_LBRACK,
    ACTIONS(5314), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [256403] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_virtual,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(4047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(7181), 1,
      sym_access_specifier,
    STATE(7352), 1,
      sym__scope_resolution,
    STATE(7734), 1,
      sym_virtual,
    STATE(6532), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8099), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10269), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [256454] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10329), 1,
      sym_identifier,
    STATE(2899), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3200), 1,
      sym_primitive_type,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(3111), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(53), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [256499] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10331), 1,
      sym_identifier,
    STATE(5920), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6095), 1,
      sym_primitive_type,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(2278), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7927), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [256544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 1,
      anon_sym_LBRACK,
    ACTIONS(5314), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [256571] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7869), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9473), 1,
      anon_sym_requires,
    STATE(6635), 1,
      sym_trailing_return_type,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [256610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5286), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [256637] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7869), 1,
      anon_sym_DASH_GT,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(10241), 1,
      anon_sym_LBRACK,
    STATE(6522), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6742), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [256676] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [256711] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8291), 1,
      anon_sym_STAR,
    ACTIONS(8293), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    STATE(4537), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7318), 1,
      sym__abstract_declarator,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8269), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [256754] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    STATE(6618), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [256793] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [256828] = 4,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10171), 1,
      anon_sym_LF,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10173), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [256857] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7833), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9377), 1,
      anon_sym_requires,
    STATE(6513), 1,
      sym_trailing_return_type,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [256896] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [256931] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10333), 1,
      sym_identifier,
    STATE(2332), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2815), 1,
      sym_primitive_type,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(2778), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(5807), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9404), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [256976] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7833), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9518), 1,
      anon_sym_requires,
    STATE(6552), 1,
      sym_trailing_return_type,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [257015] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10335), 1,
      sym_identifier,
    STATE(2145), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2677), 1,
      sym_primitive_type,
    STATE(7347), 1,
      sym__scope_resolution,
    STATE(2278), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(2097), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [257060] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [257095] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7833), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9664), 1,
      anon_sym_requires,
    STATE(6660), 1,
      sym_trailing_return_type,
    ACTIONS(9661), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [257134] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10193), 1,
      anon_sym_LF,
    ACTIONS(10195), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [257161] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_virtual,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(4047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(7193), 1,
      sym_access_specifier,
    STATE(7352), 1,
      sym__scope_resolution,
    STATE(7887), 1,
      sym_virtual,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7923), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10269), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [257212] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10007), 1,
      anon_sym_SLASH,
    ACTIONS(10009), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10011), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10013), 1,
      anon_sym_PIPE,
    ACTIONS(10015), 1,
      anon_sym_CARET,
    ACTIONS(10017), 1,
      anon_sym_AMP,
    ACTIONS(10337), 1,
      anon_sym_RPAREN,
    ACTIONS(10003), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10005), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10019), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10021), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10023), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10025), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [257261] = 12,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10271), 1,
      anon_sym_AMP,
    ACTIONS(10275), 1,
      anon_sym_CARET,
    ACTIONS(10279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10281), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10283), 1,
      anon_sym_PIPE,
    ACTIONS(10339), 1,
      anon_sym_LF,
    ACTIONS(10255), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10267), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10261), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [257306] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10189), 1,
      anon_sym_LF,
    ACTIONS(10191), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [257333] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10343), 1,
      anon_sym_LPAREN2,
    ACTIONS(10345), 1,
      anon_sym_LBRACK,
    ACTIONS(10341), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [257362] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7833), 1,
      anon_sym_DASH_GT,
    ACTIONS(10241), 1,
      anon_sym_LBRACK,
    ACTIONS(10285), 1,
      anon_sym_requires,
    STATE(6625), 1,
      sym_trailing_return_type,
    ACTIONS(10243), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6742), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [257401] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7869), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9676), 1,
      anon_sym_requires,
    STATE(6637), 1,
      sym_trailing_return_type,
    ACTIONS(9661), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [257440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5328), 1,
      anon_sym_LBRACK,
    ACTIONS(5330), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [257467] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9377), 1,
      anon_sym_requires,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [257502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10349), 1,
      anon_sym_LBRACK,
    ACTIONS(10347), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [257529] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6065), 1,
      anon_sym_LBRACK,
    ACTIONS(10319), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6067), 16,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [257558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10353), 1,
      anon_sym_LBRACK,
    ACTIONS(10351), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [257585] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    ACTIONS(10355), 1,
      sym_identifier,
    ACTIONS(10357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10359), 1,
      anon_sym_template,
    STATE(3302), 1,
      sym_template_function,
    STATE(3325), 1,
      sym_pointer_type_declarator,
    STATE(3333), 1,
      sym_destructor_name,
    STATE(3339), 1,
      sym_dependent_identifier,
    STATE(3342), 1,
      sym_qualified_identifier,
    STATE(3347), 1,
      sym_operator_name,
    STATE(6616), 1,
      sym__scope_resolution,
    STATE(9045), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [257642] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7869), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9527), 1,
      anon_sym_requires,
    STATE(6514), 1,
      sym_trailing_return_type,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [257681] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(10241), 1,
      anon_sym_LBRACK,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6742), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [257716] = 12,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10271), 1,
      anon_sym_AMP,
    ACTIONS(10275), 1,
      anon_sym_CARET,
    ACTIONS(10279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10281), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10283), 1,
      anon_sym_PIPE,
    ACTIONS(10361), 1,
      anon_sym_LF,
    ACTIONS(10255), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10267), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10261), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [257761] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(8317), 1,
      sym_identifier,
    ACTIONS(8319), 1,
      anon_sym_LPAREN2,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    STATE(2796), 1,
      sym_pointer_type_declarator,
    STATE(7488), 1,
      sym__type_declarator,
    STATE(9045), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2795), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
  [257804] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9989), 1,
      anon_sym_LBRACK,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9987), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [257835] = 12,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10271), 1,
      anon_sym_AMP,
    ACTIONS(10275), 1,
      anon_sym_CARET,
    ACTIONS(10279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10281), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10283), 1,
      anon_sym_PIPE,
    ACTIONS(10363), 1,
      anon_sym_LF,
    ACTIONS(10255), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10267), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10261), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [257880] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5308), 1,
      anon_sym_LBRACK,
    ACTIONS(5310), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [257907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 1,
      anon_sym_LBRACK,
    ACTIONS(2265), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [257934] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10265), 1,
      anon_sym_LBRACK,
    ACTIONS(10368), 1,
      anon_sym_requires,
    ACTIONS(10365), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6685), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10263), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [257969] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(9327), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10371), 1,
      sym_identifier,
    STATE(2692), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3052), 1,
      sym_primitive_type,
    STATE(7329), 1,
      sym__scope_resolution,
    STATE(3481), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(6077), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9329), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [258014] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8350), 1,
      anon_sym_STAR,
    ACTIONS(10029), 1,
      sym_identifier,
    ACTIONS(10031), 1,
      anon_sym_template,
    STATE(3302), 1,
      sym_template_function,
    STATE(3325), 1,
      sym_pointer_type_declarator,
    STATE(3333), 1,
      sym_destructor_name,
    STATE(3339), 1,
      sym_dependent_identifier,
    STATE(3342), 1,
      sym_qualified_identifier,
    STATE(3347), 1,
      sym_operator_name,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(9249), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [258071] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7869), 1,
      anon_sym_DASH_GT,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    STATE(6529), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [258110] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5105), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10329), 1,
      sym_identifier,
    STATE(2899), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3200), 1,
      sym_primitive_type,
    STATE(7326), 1,
      sym__scope_resolution,
    STATE(3111), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(53), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [258155] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9377), 1,
      anon_sym_requires,
    STATE(6513), 1,
      sym_trailing_return_type,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [258194] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(7968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10373), 1,
      sym_identifier,
    STATE(4950), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5595), 1,
      sym_primitive_type,
    STATE(7328), 1,
      sym__scope_resolution,
    STATE(5874), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(7972), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7970), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [258239] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(9450), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10375), 1,
      sym_identifier,
    STATE(2896), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3258), 1,
      sym_primitive_type,
    STATE(7350), 1,
      sym__scope_resolution,
    STATE(3954), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(6470), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9452), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [258284] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9473), 1,
      anon_sym_requires,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [258319] = 12,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10271), 1,
      anon_sym_AMP,
    ACTIONS(10275), 1,
      anon_sym_CARET,
    ACTIONS(10279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10281), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10283), 1,
      anon_sym_PIPE,
    ACTIONS(10377), 1,
      anon_sym_LF,
    ACTIONS(10255), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10267), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10261), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [258364] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9527), 1,
      anon_sym_requires,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [258399] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10037), 1,
      anon_sym_LF,
    ACTIONS(10039), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [258426] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10241), 1,
      anon_sym_LBRACK,
    ACTIONS(10246), 1,
      anon_sym_requires,
    ACTIONS(10243), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6742), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [258461] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10265), 1,
      anon_sym_LBRACK,
    ACTIONS(10379), 1,
      anon_sym_requires,
    ACTIONS(10365), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6685), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10263), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [258496] = 12,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10271), 1,
      anon_sym_AMP,
    ACTIONS(10275), 1,
      anon_sym_CARET,
    ACTIONS(10279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10281), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10283), 1,
      anon_sym_PIPE,
    ACTIONS(10382), 1,
      anon_sym_LF,
    ACTIONS(10255), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10267), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10261), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [258541] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(8017), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10384), 1,
      sym_identifier,
    STATE(2651), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3011), 1,
      sym_primitive_type,
    STATE(7325), 1,
      sym__scope_resolution,
    STATE(3318), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(2988), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2986), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [258586] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(9347), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10386), 1,
      sym_identifier,
    STATE(2751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3108), 1,
      sym_primitive_type,
    STATE(7346), 1,
      sym__scope_resolution,
    STATE(3627), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(6197), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9349), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [258631] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6231), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8329), 1,
      anon_sym_STAR,
    ACTIONS(10321), 1,
      sym_identifier,
    ACTIONS(10323), 1,
      anon_sym_template,
    STATE(6642), 1,
      sym__scope_resolution,
    STATE(7068), 1,
      sym_pointer_type_declarator,
    STATE(7069), 1,
      sym_destructor_name,
    STATE(7071), 1,
      sym_dependent_identifier,
    STATE(7075), 1,
      sym_qualified_identifier,
    STATE(7083), 1,
      sym_operator_name,
    STATE(7115), 1,
      sym_template_function,
    STATE(9762), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [258688] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7869), 1,
      anon_sym_DASH_GT,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    STATE(6540), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [258727] = 12,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10271), 1,
      anon_sym_AMP,
    ACTIONS(10275), 1,
      anon_sym_CARET,
    ACTIONS(10279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10281), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10283), 1,
      anon_sym_PIPE,
    ACTIONS(10388), 1,
      anon_sym_LF,
    ACTIONS(10255), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10267), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10261), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [258772] = 12,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10271), 1,
      anon_sym_AMP,
    ACTIONS(10275), 1,
      anon_sym_CARET,
    ACTIONS(10279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10281), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10283), 1,
      anon_sym_PIPE,
    ACTIONS(10390), 1,
      anon_sym_LF,
    ACTIONS(10255), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10267), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10261), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [258817] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(7635), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(10394), 1,
      anon_sym_template,
    STATE(3302), 1,
      sym_template_function,
    STATE(3325), 1,
      sym_pointer_type_declarator,
    STATE(3333), 1,
      sym_destructor_name,
    STATE(3339), 1,
      sym_dependent_identifier,
    STATE(3342), 1,
      sym_qualified_identifier,
    STATE(3347), 1,
      sym_operator_name,
    STATE(6646), 1,
      sym__scope_resolution,
    STATE(9045), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [258874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LBRACK,
    ACTIONS(2221), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [258901] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10233), 1,
      anon_sym_LF,
    ACTIONS(10235), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [258928] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10398), 1,
      anon_sym_LBRACK,
    STATE(6124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10396), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [258959] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(9382), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10400), 1,
      sym_identifier,
    STATE(3594), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4278), 1,
      sym_primitive_type,
    STATE(7334), 1,
      sym__scope_resolution,
    STATE(4727), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(7259), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9384), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [259004] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(10241), 1,
      anon_sym_LBRACK,
    STATE(6661), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6742), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [259043] = 3,
    ACTIONS(6977), 1,
      anon_sym_LF,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(6975), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [259070] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(9307), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10402), 1,
      sym_identifier,
    STATE(2580), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2873), 1,
      sym_primitive_type,
    STATE(7340), 1,
      sym__scope_resolution,
    STATE(3236), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(5971), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9309), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [259115] = 12,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10271), 1,
      anon_sym_AMP,
    ACTIONS(10275), 1,
      anon_sym_CARET,
    ACTIONS(10279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10281), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10283), 1,
      anon_sym_PIPE,
    ACTIONS(10404), 1,
      anon_sym_LF,
    ACTIONS(10255), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10267), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10261), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [259160] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10007), 1,
      anon_sym_SLASH,
    ACTIONS(10009), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10011), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10013), 1,
      anon_sym_PIPE,
    ACTIONS(10015), 1,
      anon_sym_CARET,
    ACTIONS(10017), 1,
      anon_sym_AMP,
    ACTIONS(10406), 1,
      anon_sym_RPAREN,
    ACTIONS(10003), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10005), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10019), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10021), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10023), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10025), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [259209] = 12,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10271), 1,
      anon_sym_AMP,
    ACTIONS(10275), 1,
      anon_sym_CARET,
    ACTIONS(10279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10281), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10283), 1,
      anon_sym_PIPE,
    ACTIONS(10408), 1,
      anon_sym_LF,
    ACTIONS(10255), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10267), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10257), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10261), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [259254] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(3216), 1,
      anon_sym_TILDE,
    ACTIONS(6516), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8321), 1,
      anon_sym_STAR,
    ACTIONS(10029), 1,
      sym_identifier,
    ACTIONS(10031), 1,
      anon_sym_template,
    STATE(3302), 1,
      sym_template_function,
    STATE(3325), 1,
      sym_pointer_type_declarator,
    STATE(3333), 1,
      sym_destructor_name,
    STATE(3339), 1,
      sym_dependent_identifier,
    STATE(3342), 1,
      sym_qualified_identifier,
    STATE(3347), 1,
      sym_operator_name,
    STATE(6657), 1,
      sym__scope_resolution,
    STATE(9045), 1,
      sym_ms_based_modifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [259311] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(9434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10410), 1,
      sym_identifier,
    STATE(2651), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3011), 1,
      sym_primitive_type,
    STATE(7361), 1,
      sym__scope_resolution,
    STATE(3318), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(2988), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2986), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [259356] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7869), 1,
      anon_sym_DASH_GT,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    STATE(6536), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [259395] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10241), 1,
      anon_sym_LBRACK,
    ACTIONS(10285), 1,
      anon_sym_requires,
    ACTIONS(10243), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6742), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [259430] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(10265), 1,
      anon_sym_LBRACK,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6685), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10263), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [259465] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10412), 1,
      sym_identifier,
    STATE(2401), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2767), 1,
      sym_primitive_type,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(2778), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(5807), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9426), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [259510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10416), 1,
      anon_sym_LBRACK,
    ACTIONS(10414), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [259537] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(10081), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10089), 1,
      anon_sym_EQ,
    ACTIONS(10418), 1,
      anon_sym_SEMI,
    ACTIONS(10420), 1,
      anon_sym_COLON,
    STATE(4231), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(8291), 1,
      aux_sym_declaration_repeat1,
    STATE(8292), 1,
      sym_gnu_asm_expression,
    ACTIONS(10091), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(7128), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8483), 2,
      sym_argument_list,
      sym_initializer_list,
  [259589] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7675), 1,
      anon_sym_DASH_GT,
    ACTIONS(10425), 1,
      anon_sym_requires,
    STATE(6772), 1,
      sym_trailing_return_type,
    ACTIONS(10422), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6899), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [259625] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7675), 1,
      anon_sym_DASH_GT,
    ACTIONS(7725), 1,
      anon_sym_requires,
    STATE(6762), 1,
      sym_trailing_return_type,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6899), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [259661] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7675), 1,
      anon_sym_DASH_GT,
    ACTIONS(9649), 1,
      anon_sym_requires,
    STATE(6780), 1,
      sym_trailing_return_type,
    ACTIONS(9646), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6923), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [259697] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7675), 1,
      anon_sym_DASH_GT,
    ACTIONS(9491), 1,
      anon_sym_requires,
    STATE(6781), 1,
      sym_trailing_return_type,
    ACTIONS(9488), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [259733] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6210), 1,
      anon_sym_LBRACK,
    ACTIONS(10428), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6669), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6212), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [259763] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9989), 1,
      anon_sym_LBRACK,
    STATE(6669), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9987), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [259793] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7675), 1,
      anon_sym_DASH_GT,
    ACTIONS(7725), 1,
      anon_sym_requires,
    STATE(6782), 1,
      sym_trailing_return_type,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [259829] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7675), 1,
      anon_sym_DASH_GT,
    ACTIONS(9260), 1,
      anon_sym_requires,
    STATE(6765), 1,
      sym_trailing_return_type,
    ACTIONS(9257), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [259865] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9981), 1,
      anon_sym_LBRACK,
    STATE(6669), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9979), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [259895] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8073), 1,
      anon_sym_LPAREN2,
    ACTIONS(8087), 1,
      anon_sym_LBRACK,
    ACTIONS(8356), 1,
      anon_sym_STAR,
    ACTIONS(8358), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    STATE(4695), 1,
      sym_parameter_list,
    STATE(6736), 1,
      sym__function_declarator_seq,
    STATE(7355), 1,
      sym__abstract_declarator,
    ACTIONS(8269), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6740), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [259937] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10398), 1,
      anon_sym_LBRACK,
    STATE(6669), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10396), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [259967] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7675), 1,
      anon_sym_DASH_GT,
    ACTIONS(7725), 1,
      anon_sym_requires,
    STATE(6776), 1,
      sym_trailing_return_type,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6923), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [260003] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7675), 1,
      anon_sym_DASH_GT,
    ACTIONS(7725), 1,
      anon_sym_requires,
    STATE(6799), 1,
      sym_trailing_return_type,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [260039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10433), 1,
      anon_sym_LBRACK,
    ACTIONS(10431), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [260064] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10435), 1,
      anon_sym_LT,
    ACTIONS(10437), 1,
      anon_sym_LBRACE,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(4567), 1,
      sym_compound_statement,
    STATE(6703), 1,
      sym_template_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7817), 1,
      sym_abstract_function_declarator,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [260113] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10439), 1,
      sym_identifier,
    ACTIONS(5393), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(6721), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(10441), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10443), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [260144] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8558), 1,
      anon_sym_STAR,
    ACTIONS(8560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8562), 1,
      anon_sym_AMP,
    STATE(4705), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7420), 1,
      sym__abstract_declarator,
    ACTIONS(8269), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [260185] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(8539), 1,
      anon_sym_LPAREN2,
    ACTIONS(8547), 1,
      sym_identifier,
    ACTIONS(8549), 1,
      anon_sym_STAR,
    ACTIONS(8551), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8553), 1,
      anon_sym_AMP,
    STATE(7388), 1,
      sym__field_declarator,
    STATE(7503), 1,
      sym_operator_name,
    STATE(9291), 1,
      sym_ms_based_modifier,
    STATE(7265), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [260228] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10445), 1,
      anon_sym_LBRACE,
    ACTIONS(10447), 1,
      anon_sym_requires,
    STATE(4079), 1,
      sym_compound_statement,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6821), 1,
      sym_requires_clause,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7712), 1,
      sym_abstract_function_declarator,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [260277] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(10081), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10089), 1,
      anon_sym_EQ,
    ACTIONS(10418), 1,
      anon_sym_SEMI,
    STATE(4238), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(8291), 1,
      aux_sym_declaration_repeat1,
    STATE(8292), 1,
      sym_gnu_asm_expression,
    ACTIONS(10091), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8483), 2,
      sym_argument_list,
      sym_initializer_list,
  [260326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10451), 1,
      anon_sym_LBRACK,
    ACTIONS(10449), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [260351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10241), 1,
      anon_sym_LBRACK,
    ACTIONS(10239), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [260376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10455), 1,
      anon_sym_LBRACK,
    ACTIONS(10453), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [260401] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(10081), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10089), 1,
      anon_sym_EQ,
    ACTIONS(10113), 1,
      anon_sym_SEMI,
    STATE(4238), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(7997), 1,
      aux_sym_declaration_repeat1,
    STATE(7999), 1,
      sym_gnu_asm_expression,
    ACTIONS(10091), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8483), 2,
      sym_argument_list,
      sym_initializer_list,
  [260450] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5129), 1,
      anon_sym_COLON,
    ACTIONS(9265), 1,
      anon_sym_LT,
    STATE(3159), 1,
      sym_template_argument_list,
    ACTIONS(5136), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [260481] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(10081), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10089), 1,
      anon_sym_EQ,
    ACTIONS(10151), 1,
      anon_sym_SEMI,
    STATE(4238), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(8118), 1,
      sym_gnu_asm_expression,
    STATE(8120), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(10091), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8483), 2,
      sym_argument_list,
      sym_initializer_list,
  [260530] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7900), 1,
      anon_sym_DASH_GT,
    ACTIONS(10241), 1,
      anon_sym_LBRACK,
    ACTIONS(10246), 1,
      anon_sym_requires,
    STATE(6638), 1,
      sym_trailing_return_type,
    ACTIONS(10243), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6742), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [260567] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(7900), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    STATE(6529), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [260604] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7900), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9676), 1,
      anon_sym_requires,
    STATE(6637), 1,
      sym_trailing_return_type,
    ACTIONS(9661), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [260641] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(10081), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10089), 1,
      anon_sym_EQ,
    ACTIONS(10161), 1,
      anon_sym_SEMI,
    STATE(4238), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(8369), 1,
      aux_sym_declaration_repeat1,
    STATE(8370), 1,
      sym_gnu_asm_expression,
    ACTIONS(10091), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8483), 2,
      sym_argument_list,
      sym_initializer_list,
  [260690] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10435), 1,
      anon_sym_LT,
    ACTIONS(10457), 1,
      anon_sym_LBRACE,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6561), 1,
      sym_compound_statement,
    STATE(6729), 1,
      sym_template_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7739), 1,
      sym_abstract_function_declarator,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [260739] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5835), 1,
      anon_sym_COLON,
    ACTIONS(9265), 1,
      anon_sym_LT,
    STATE(3159), 1,
      sym_template_argument_list,
    ACTIONS(4272), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [260770] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7900), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9527), 1,
      anon_sym_requires,
    STATE(6514), 1,
      sym_trailing_return_type,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [260807] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7900), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9473), 1,
      anon_sym_requires,
    STATE(6635), 1,
      sym_trailing_return_type,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [260844] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10435), 1,
      anon_sym_LT,
    ACTIONS(10459), 1,
      anon_sym_LBRACE,
    STATE(2934), 1,
      sym_compound_statement,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6737), 1,
      sym_template_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7721), 1,
      sym_abstract_function_declarator,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [260893] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(6866), 1,
      sym_string_literal,
    STATE(7139), 1,
      sym_raw_string_literal,
    ACTIONS(10463), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(7792), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [260928] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(8537), 1,
      sym_identifier,
    ACTIONS(8539), 1,
      anon_sym_LPAREN2,
    ACTIONS(8541), 1,
      anon_sym_STAR,
    ACTIONS(8543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8545), 1,
      anon_sym_AMP,
    STATE(6997), 1,
      sym__field_declarator,
    STATE(7119), 1,
      sym_operator_name,
    STATE(9391), 1,
      sym_ms_based_modifier,
    STATE(7265), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [260971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10467), 1,
      anon_sym_LBRACK,
    ACTIONS(10465), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [260996] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10437), 1,
      anon_sym_LBRACE,
    ACTIONS(10447), 1,
      anon_sym_requires,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(4590), 1,
      sym_compound_statement,
    STATE(6824), 1,
      sym_requires_clause,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7688), 1,
      sym_abstract_function_declarator,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [261045] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(7898), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    STATE(6618), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [261082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10471), 1,
      anon_sym_LBRACK,
    ACTIONS(10469), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [261107] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(7898), 1,
      anon_sym_DASH_GT,
    ACTIONS(10241), 1,
      anon_sym_LBRACK,
    STATE(6661), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6742), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [261144] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8531), 1,
      anon_sym_STAR,
    ACTIONS(8533), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP,
    STATE(4001), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7250), 1,
      sym__abstract_declarator,
    ACTIONS(8269), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [261185] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10447), 1,
      anon_sym_requires,
    ACTIONS(10473), 1,
      anon_sym_LBRACE,
    STATE(4125), 1,
      sym_compound_statement,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6865), 1,
      sym_requires_clause,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(7886), 1,
      sym_abstract_function_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [261234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10477), 1,
      anon_sym_LBRACK,
    ACTIONS(10475), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [261259] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(8537), 1,
      sym_identifier,
    ACTIONS(8539), 1,
      anon_sym_LPAREN2,
    ACTIONS(8541), 1,
      anon_sym_STAR,
    ACTIONS(8543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8545), 1,
      anon_sym_AMP,
    STATE(6853), 1,
      sym__field_declarator,
    STATE(7119), 1,
      sym_operator_name,
    STATE(9391), 1,
      sym_ms_based_modifier,
    STATE(7265), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [261302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10481), 1,
      anon_sym_LBRACK,
    ACTIONS(10479), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [261327] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7898), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9377), 1,
      anon_sym_requires,
    STATE(6513), 1,
      sym_trailing_return_type,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [261364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9639), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [261389] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10435), 1,
      anon_sym_LT,
    ACTIONS(10483), 1,
      anon_sym_LBRACE,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6720), 1,
      sym_template_parameter_list,
    STATE(6795), 1,
      sym_compound_statement,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7812), 1,
      sym_abstract_function_declarator,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [261438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10487), 1,
      anon_sym_LBRACK,
    ACTIONS(10485), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [261463] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7898), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9518), 1,
      anon_sym_requires,
    STATE(6552), 1,
      sym_trailing_return_type,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [261500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10491), 1,
      anon_sym_LBRACK,
    ACTIONS(10489), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [261525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10495), 1,
      anon_sym_LBRACK,
    ACTIONS(10493), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [261550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10499), 1,
      anon_sym_LBRACK,
    ACTIONS(10497), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [261575] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10447), 1,
      anon_sym_requires,
    ACTIONS(10483), 1,
      anon_sym_LBRACE,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6763), 1,
      sym_compound_statement,
    STATE(6848), 1,
      sym_requires_clause,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7781), 1,
      sym_abstract_function_declarator,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [261624] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10501), 1,
      sym_identifier,
    ACTIONS(5373), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(6721), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(10504), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10507), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [261655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10512), 1,
      anon_sym_LBRACK,
    ACTIONS(10510), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [261680] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7898), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9664), 1,
      anon_sym_requires,
    STATE(6660), 1,
      sym_trailing_return_type,
    ACTIONS(9661), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [261717] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10447), 1,
      anon_sym_requires,
    ACTIONS(10514), 1,
      anon_sym_LBRACE,
    STATE(2051), 1,
      sym_compound_statement,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6840), 1,
      sym_requires_clause,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7629), 1,
      sym_abstract_function_declarator,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [261766] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10447), 1,
      anon_sym_requires,
    STATE(2051), 1,
      sym_compound_statement,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6837), 1,
      sym_requires_clause,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(7927), 1,
      sym_abstract_function_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [261815] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(7898), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    STATE(6597), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [261852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9253), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [261877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9479), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [261902] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10447), 1,
      anon_sym_requires,
    ACTIONS(10457), 1,
      anon_sym_LBRACE,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6565), 1,
      sym_compound_statement,
    STATE(6873), 1,
      sym_requires_clause,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7791), 1,
      sym_abstract_function_declarator,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [261951] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10435), 1,
      anon_sym_LT,
    STATE(2049), 1,
      sym_compound_statement,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_template_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(7905), 1,
      sym_abstract_function_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [262000] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10447), 1,
      anon_sym_requires,
    ACTIONS(10516), 1,
      anon_sym_LBRACE,
    STATE(4350), 1,
      sym_compound_statement,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6877), 1,
      sym_requires_clause,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(7856), 1,
      sym_abstract_function_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [262049] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10435), 1,
      anon_sym_LT,
    ACTIONS(10516), 1,
      anon_sym_LBRACE,
    STATE(4233), 1,
      sym_compound_statement,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6731), 1,
      sym_template_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(7916), 1,
      sym_abstract_function_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [262098] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(7898), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    STATE(6601), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [262135] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(10081), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10089), 1,
      anon_sym_EQ,
    ACTIONS(10217), 1,
      anon_sym_SEMI,
    STATE(4238), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(8153), 1,
      sym_gnu_asm_expression,
    STATE(8158), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(10091), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8483), 2,
      sym_argument_list,
      sym_initializer_list,
  [262184] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10435), 1,
      anon_sym_LT,
    ACTIONS(10514), 1,
      anon_sym_LBRACE,
    STATE(2049), 1,
      sym_compound_statement,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6724), 1,
      sym_template_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(7911), 1,
      sym_abstract_function_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [262233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10520), 1,
      anon_sym_LBRACK,
    ACTIONS(10518), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [262258] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10447), 1,
      anon_sym_requires,
    ACTIONS(10459), 1,
      anon_sym_LBRACE,
    STATE(2955), 1,
      sym_compound_statement,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6861), 1,
      sym_requires_clause,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7662), 1,
      sym_abstract_function_declarator,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [262307] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10447), 1,
      anon_sym_requires,
    ACTIONS(10522), 1,
      anon_sym_LBRACE,
    STATE(3813), 1,
      sym_compound_statement,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6859), 1,
      sym_requires_clause,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7736), 1,
      sym_abstract_function_declarator,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [262356] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10435), 1,
      anon_sym_LT,
    ACTIONS(10522), 1,
      anon_sym_LBRACE,
    STATE(3831), 1,
      sym_compound_statement,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6738), 1,
      sym_template_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7643), 1,
      sym_abstract_function_declarator,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [262405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10526), 1,
      anon_sym_LBRACK,
    ACTIONS(10524), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [262430] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(8539), 1,
      anon_sym_LPAREN2,
    ACTIONS(8547), 1,
      sym_identifier,
    ACTIONS(8549), 1,
      anon_sym_STAR,
    ACTIONS(8551), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8553), 1,
      anon_sym_AMP,
    STATE(7405), 1,
      sym__field_declarator,
    STATE(7503), 1,
      sym_operator_name,
    STATE(9291), 1,
      sym_ms_based_modifier,
    STATE(7265), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [262473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10265), 1,
      anon_sym_LBRACK,
    ACTIONS(10263), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [262498] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10435), 1,
      anon_sym_LT,
    ACTIONS(10473), 1,
      anon_sym_LBRACE,
    STATE(4089), 1,
      sym_compound_statement,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6708), 1,
      sym_template_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7789), 1,
      sym_abstract_function_declarator,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [262547] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(10081), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10418), 1,
      anon_sym_SEMI,
    ACTIONS(10528), 1,
      anon_sym_EQ,
    STATE(4238), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(8125), 1,
      sym_initializer_list,
    STATE(8291), 1,
      aux_sym_declaration_repeat1,
    STATE(8292), 1,
      sym_gnu_asm_expression,
    STATE(8483), 1,
      sym_argument_list,
    ACTIONS(10091), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [262598] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10435), 1,
      anon_sym_LT,
    ACTIONS(10530), 1,
      anon_sym_LBRACE,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(5210), 1,
      sym_compound_statement,
    STATE(6755), 1,
      sym_template_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(7894), 1,
      sym_abstract_function_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [262647] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7898), 1,
      anon_sym_DASH_GT,
    ACTIONS(10241), 1,
      anon_sym_LBRACK,
    ACTIONS(10285), 1,
      anon_sym_requires,
    STATE(6625), 1,
      sym_trailing_return_type,
    ACTIONS(10243), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6742), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [262684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10534), 1,
      anon_sym_LBRACK,
    ACTIONS(10532), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [262709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10538), 1,
      anon_sym_LBRACK,
    ACTIONS(10536), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [262734] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(10081), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10089), 1,
      anon_sym_EQ,
    ACTIONS(10185), 1,
      anon_sym_SEMI,
    STATE(4238), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(8293), 1,
      sym_gnu_asm_expression,
    STATE(8297), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(10091), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8483), 2,
      sym_argument_list,
      sym_initializer_list,
  [262783] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10447), 1,
      anon_sym_requires,
    ACTIONS(10540), 1,
      anon_sym_LBRACE,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(5090), 1,
      sym_compound_statement,
    STATE(6875), 1,
      sym_requires_clause,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7668), 1,
      sym_abstract_function_declarator,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [262832] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10542), 1,
      sym_identifier,
    ACTIONS(5387), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(6680), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(10441), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10443), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [262863] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10435), 1,
      anon_sym_LT,
    ACTIONS(10445), 1,
      anon_sym_LBRACE,
    STATE(4198), 1,
      sym_compound_statement,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6683), 1,
      sym_template_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(7878), 1,
      sym_abstract_function_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [262912] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(7900), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    STATE(6540), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [262949] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10435), 1,
      anon_sym_LT,
    ACTIONS(10540), 1,
      anon_sym_LBRACE,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(5049), 1,
      sym_compound_statement,
    STATE(6750), 1,
      sym_template_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7695), 1,
      sym_abstract_function_declarator,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [262998] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10447), 1,
      anon_sym_requires,
    ACTIONS(10530), 1,
      anon_sym_LBRACE,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(5113), 1,
      sym_compound_statement,
    STATE(6807), 1,
      sym_requires_clause,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7793), 1,
      sym_abstract_function_declarator,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [263047] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(7900), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    STATE(6536), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [263084] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7871), 1,
      anon_sym_requires,
    ACTIONS(7900), 1,
      anon_sym_DASH_GT,
    ACTIONS(10241), 1,
      anon_sym_LBRACK,
    STATE(6522), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6742), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [263121] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6397), 1,
      anon_sym_LBRACK,
    ACTIONS(10544), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6399), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [263147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5314), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [263169] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7961), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_requires,
    STATE(6974), 1,
      sym_trailing_return_type,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [263205] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8820), 1,
      anon_sym_STAR,
    ACTIONS(8822), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8824), 1,
      anon_sym_AMP,
    STATE(4540), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7469), 1,
      sym__abstract_declarator,
    ACTIONS(8269), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [263245] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7725), 1,
      anon_sym_requires,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10263), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [263275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5326), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [263297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5334), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [263319] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9491), 1,
      anon_sym_requires,
    ACTIONS(9488), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [263349] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7733), 1,
      anon_sym_LT,
    STATE(6941), 1,
      sym_template_argument_list,
    ACTIONS(5138), 2,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(5131), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [263379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4125), 1,
      anon_sym_LBRACK,
    ACTIONS(4127), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [263403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5306), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [263425] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10546), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6769), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(10302), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [263451] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7961), 1,
      anon_sym_DASH_GT,
    ACTIONS(8033), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    STATE(6924), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [263487] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7725), 1,
      anon_sym_requires,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [263517] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10552), 1,
      anon_sym_requires,
    ACTIONS(10549), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10263), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [263547] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7961), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9565), 1,
      anon_sym_requires,
    STATE(6972), 1,
      sym_trailing_return_type,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [263583] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7961), 1,
      anon_sym_DASH_GT,
    ACTIONS(8033), 1,
      anon_sym_requires,
    ACTIONS(10241), 1,
      anon_sym_LBRACK,
    STATE(6914), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6742), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [263619] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7733), 1,
      anon_sym_LT,
    STATE(6941), 1,
      sym_template_argument_list,
    ACTIONS(8147), 2,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(5180), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [263649] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7725), 1,
      anon_sym_requires,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6899), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [263679] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(10081), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10089), 1,
      anon_sym_EQ,
    STATE(4238), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(8536), 1,
      sym_gnu_asm_expression,
    ACTIONS(10091), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10555), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8483), 2,
      sym_argument_list,
      sym_initializer_list,
  [263723] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10095), 1,
      anon_sym_TILDE,
    ACTIONS(10557), 1,
      sym_identifier,
    ACTIONS(10559), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10564), 1,
      anon_sym_template,
    STATE(7015), 1,
      sym__scope_resolution,
    STATE(8614), 1,
      sym_operator_name,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(4116), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [263765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5302), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [263787] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10425), 1,
      anon_sym_requires,
    ACTIONS(10422), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6899), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [263817] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9649), 1,
      anon_sym_requires,
    ACTIONS(9646), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6923), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [263847] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7725), 1,
      anon_sym_requires,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6923), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [263877] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7961), 1,
      anon_sym_DASH_GT,
    ACTIONS(8033), 1,
      anon_sym_requires,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    STATE(6915), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [263913] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6769), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(10311), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [263939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2221), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [263961] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2265), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [263983] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7473), 1,
      sym__abstract_declarator,
    ACTIONS(8269), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [264023] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7961), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9756), 1,
      anon_sym_requires,
    STATE(6971), 1,
      sym_trailing_return_type,
    ACTIONS(9661), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [264059] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9260), 1,
      anon_sym_requires,
    ACTIONS(9257), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [264089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4131), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [264113] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10566), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10568), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6008), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [264139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [264161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5294), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [264183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5322), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [264205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5318), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [264227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5298), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [264249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5314), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [264271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5314), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [264293] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7725), 1,
      anon_sym_requires,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [264323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10568), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6067), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [264347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5330), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [264369] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7961), 1,
      anon_sym_DASH_GT,
    ACTIONS(10241), 1,
      anon_sym_LBRACK,
    ACTIONS(10570), 1,
      anon_sym_requires,
    STATE(6969), 1,
      sym_trailing_return_type,
    ACTIONS(10243), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6742), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [264405] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5310), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [264427] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5290), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [264449] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7961), 1,
      anon_sym_DASH_GT,
    ACTIONS(8033), 1,
      anon_sym_requires,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    STATE(6916), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [264485] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4132), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10573), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [264514] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10530), 1,
      anon_sym_LBRACE,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(5098), 1,
      sym_compound_statement,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7673), 1,
      sym_abstract_function_declarator,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [264557] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(6866), 1,
      sym_string_literal,
    STATE(7139), 1,
      sym_raw_string_literal,
    STATE(8313), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [264588] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10577), 1,
      sym_identifier,
    ACTIONS(10579), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10581), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10583), 1,
      aux_sym_preproc_elif_token1,
    STATE(7252), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(7277), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(7454), 1,
      sym_enumerator,
    ACTIONS(10585), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(9099), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(9104), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [264627] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(6866), 1,
      sym_string_literal,
    STATE(7139), 1,
      sym_raw_string_literal,
    STATE(7962), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [264658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6397), 1,
      anon_sym_LBRACK,
    ACTIONS(6399), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [264681] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6380), 1,
      anon_sym_LBRACK,
    ACTIONS(7733), 1,
      anon_sym_LT,
    STATE(6941), 1,
      sym_template_argument_list,
    ACTIONS(6382), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [264708] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(6866), 1,
      sym_string_literal,
    STATE(7139), 1,
      sym_raw_string_literal,
    STATE(8182), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [264739] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4132), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10587), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [264768] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4132), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10589), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [264797] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4132), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10591), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [264826] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4132), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10593), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [264855] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4132), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10595), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [264884] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4132), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10597), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [264913] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4132), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10599), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [264942] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10445), 1,
      anon_sym_LBRACE,
    STATE(4149), 1,
      sym_compound_statement,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(7907), 1,
      sym_abstract_function_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [264985] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6210), 1,
      anon_sym_LBRACK,
    ACTIONS(10601), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6822), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6212), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [265012] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10095), 1,
      anon_sym_TILDE,
    ACTIONS(10557), 1,
      sym_identifier,
    ACTIONS(10562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10564), 1,
      anon_sym_template,
    STATE(7015), 1,
      sym__scope_resolution,
    STATE(8614), 1,
      sym_operator_name,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(4116), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [265051] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10437), 1,
      anon_sym_LBRACE,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(4485), 1,
      sym_compound_statement,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(7853), 1,
      sym_abstract_function_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [265094] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10587), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [265123] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10589), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [265152] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10069), 1,
      anon_sym_TILDE,
    ACTIONS(10604), 1,
      sym_identifier,
    ACTIONS(10606), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10608), 1,
      anon_sym_template,
    STATE(7100), 1,
      sym__scope_resolution,
    STATE(8551), 1,
      sym_operator_name,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(3648), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [265191] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(6866), 1,
      sym_string_literal,
    STATE(7139), 1,
      sym_raw_string_literal,
    STATE(8051), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [265222] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10591), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [265251] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(6866), 1,
      sym_string_literal,
    STATE(7139), 1,
      sym_raw_string_literal,
    STATE(8372), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [265282] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10593), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [265311] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(6866), 1,
      sym_string_literal,
    STATE(7139), 1,
      sym_raw_string_literal,
    STATE(8085), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [265342] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10595), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [265371] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10597), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [265400] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10599), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [265429] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(6866), 1,
      sym_string_literal,
    STATE(7139), 1,
      sym_raw_string_literal,
    STATE(8139), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [265460] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    STATE(2043), 1,
      sym_compound_statement,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(7876), 1,
      sym_abstract_function_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [265503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6673), 1,
      anon_sym_LBRACK,
    ACTIONS(6675), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [265526] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10573), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [265555] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10514), 1,
      anon_sym_LBRACE,
    STATE(2043), 1,
      sym_compound_statement,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7652), 1,
      sym_abstract_function_declarator,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [265598] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(6866), 1,
      sym_string_literal,
    STATE(7139), 1,
      sym_raw_string_literal,
    STATE(7950), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [265629] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7992), 1,
      anon_sym_DASH_GT,
    ACTIONS(8011), 1,
      anon_sym_requires,
    STATE(6981), 1,
      sym_trailing_return_type,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [265662] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(6866), 1,
      sym_string_literal,
    STATE(7139), 1,
      sym_raw_string_literal,
    STATE(8077), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [265693] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(6866), 1,
      sym_string_literal,
    STATE(7139), 1,
      sym_raw_string_literal,
    STATE(7970), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [265724] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4341), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10587), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [265753] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(6866), 1,
      sym_string_literal,
    STATE(7139), 1,
      sym_raw_string_literal,
    STATE(8207), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [265784] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7992), 1,
      anon_sym_DASH_GT,
    ACTIONS(9494), 1,
      anon_sym_requires,
    STATE(6984), 1,
      sym_trailing_return_type,
    ACTIONS(9257), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [265817] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10483), 1,
      anon_sym_LBRACE,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6779), 1,
      sym_compound_statement,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7765), 1,
      sym_abstract_function_declarator,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [265860] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7992), 1,
      anon_sym_DASH_GT,
    ACTIONS(9703), 1,
      anon_sym_requires,
    STATE(6898), 1,
      sym_trailing_return_type,
    ACTIONS(9646), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6923), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [265893] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7992), 1,
      anon_sym_DASH_GT,
    ACTIONS(8011), 1,
      anon_sym_requires,
    STATE(6908), 1,
      sym_trailing_return_type,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6923), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [265926] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(6866), 1,
      sym_string_literal,
    STATE(7139), 1,
      sym_raw_string_literal,
    STATE(8238), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [265957] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(6866), 1,
      sym_string_literal,
    STATE(7139), 1,
      sym_raw_string_literal,
    STATE(8009), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [265988] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9876), 1,
      anon_sym_LBRACK,
    ACTIONS(9880), 1,
      anon_sym_COLON,
    ACTIONS(10612), 1,
      anon_sym_EQ,
    STATE(4027), 1,
      sym_parameter_list,
    STATE(7213), 1,
      sym__function_declarator_seq,
    STATE(8268), 1,
      sym_bitfield_clause,
    STATE(8271), 1,
      sym_initializer_list,
    STATE(7129), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10610), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [266031] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10614), 1,
      anon_sym_LBRACK,
    STATE(7107), 1,
      sym_parameter_list,
    STATE(6966), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5998), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [266062] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10614), 1,
      anon_sym_LBRACK,
    STATE(7107), 1,
      sym_parameter_list,
    STATE(6966), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6150), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [266093] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10614), 1,
      anon_sym_LBRACK,
    STATE(7107), 1,
      sym_parameter_list,
    STATE(6966), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6071), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [266124] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(6866), 1,
      sym_string_literal,
    STATE(7139), 1,
      sym_raw_string_literal,
    STATE(8111), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [266155] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10055), 1,
      anon_sym_TILDE,
    ACTIONS(10616), 1,
      sym_identifier,
    ACTIONS(10618), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10620), 1,
      anon_sym_template,
    STATE(7024), 1,
      sym__scope_resolution,
    STATE(8697), 1,
      sym_operator_name,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(2932), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [266194] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10522), 1,
      anon_sym_LBRACE,
    STATE(3766), 1,
      sym_compound_statement,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7758), 1,
      sym_abstract_function_declarator,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [266237] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(6866), 1,
      sym_string_literal,
    STATE(7139), 1,
      sym_raw_string_literal,
    STATE(8113), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [266268] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10459), 1,
      anon_sym_LBRACE,
    STATE(2999), 1,
      sym_compound_statement,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7644), 1,
      sym_abstract_function_declarator,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [266311] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(6866), 1,
      sym_string_literal,
    STATE(7139), 1,
      sym_raw_string_literal,
    STATE(8212), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [266342] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10045), 1,
      anon_sym_TILDE,
    ACTIONS(10622), 1,
      sym_identifier,
    ACTIONS(10624), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10626), 1,
      anon_sym_template,
    STATE(7097), 1,
      sym__scope_resolution,
    STATE(8481), 1,
      sym_operator_name,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(4338), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [266381] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7992), 1,
      anon_sym_DASH_GT,
    ACTIONS(10628), 1,
      anon_sym_requires,
    STATE(6906), 1,
      sym_trailing_return_type,
    ACTIONS(10422), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6899), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [266414] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10473), 1,
      anon_sym_LBRACE,
    STATE(4175), 1,
      sym_compound_statement,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(7926), 1,
      sym_abstract_function_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [266457] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6751), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(5799), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(10441), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10443), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [266484] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10633), 1,
      anon_sym___attribute__,
    ACTIONS(10638), 1,
      anon_sym_alignas,
    ACTIONS(10636), 3,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    STATE(6867), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
    ACTIONS(10631), 7,
      anon_sym___declspec,
      anon_sym_COLON,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
  [266513] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(6866), 1,
      sym_string_literal,
    STATE(7139), 1,
      sym_raw_string_literal,
    STATE(8188), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [266544] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4341), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10573), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [266573] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7992), 1,
      anon_sym_DASH_GT,
    ACTIONS(8011), 1,
      anon_sym_requires,
    STATE(6999), 1,
      sym_trailing_return_type,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [266606] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4341), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10599), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [266635] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(6866), 1,
      sym_string_literal,
    STATE(7139), 1,
      sym_raw_string_literal,
    STATE(8379), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [266666] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10457), 1,
      anon_sym_LBRACE,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6547), 1,
      sym_compound_statement,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7821), 1,
      sym_abstract_function_declarator,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [266709] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(6866), 1,
      sym_string_literal,
    STATE(7139), 1,
      sym_raw_string_literal,
    STATE(8334), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [266740] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10540), 1,
      anon_sym_LBRACE,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(5132), 1,
      sym_compound_statement,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7665), 1,
      sym_abstract_function_declarator,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [266783] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4341), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10597), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [266812] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(10516), 1,
      anon_sym_LBRACE,
    STATE(4270), 1,
      sym_compound_statement,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7774), 1,
      sym_abstract_function_declarator,
    STATE(7828), 1,
      sym__abstract_declarator,
    STATE(6944), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [266855] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10614), 1,
      anon_sym_LBRACK,
    STATE(7107), 1,
      sym_parameter_list,
    STATE(6966), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6142), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [266886] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4341), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10595), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [266915] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10055), 1,
      anon_sym_TILDE,
    ACTIONS(10616), 1,
      sym_identifier,
    ACTIONS(10641), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10643), 1,
      anon_sym_template,
    STATE(7043), 1,
      sym__scope_resolution,
    STATE(8680), 1,
      sym_operator_name,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(2932), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [266954] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4341), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10593), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [266983] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7992), 1,
      anon_sym_DASH_GT,
    ACTIONS(8011), 1,
      anon_sym_requires,
    STATE(6893), 1,
      sym_trailing_return_type,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6899), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [267016] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4341), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10591), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [267045] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4341), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10589), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [267074] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7992), 1,
      anon_sym_DASH_GT,
    ACTIONS(9560), 1,
      anon_sym_requires,
    STATE(6913), 1,
      sym_trailing_return_type,
    ACTIONS(9488), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [267107] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_requires,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [267137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9639), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [267157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5411), 1,
      sym_identifier,
    ACTIONS(5413), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [267179] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8052), 1,
      anon_sym_DASH_GT,
    ACTIONS(8057), 1,
      anon_sym_requires,
    STATE(7136), 1,
      sym_trailing_return_type,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [267211] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(9162), 1,
      sym_concatenated_string,
    STATE(7013), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [267239] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(9125), 1,
      sym_concatenated_string,
    STATE(7104), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [267267] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(9082), 1,
      sym_concatenated_string,
    STATE(7065), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [267295] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym_requires,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10263), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [267323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5421), 1,
      sym_identifier,
    ACTIONS(5423), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [267345] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9876), 1,
      anon_sym_LBRACK,
    STATE(4027), 1,
      sym_parameter_list,
    STATE(7213), 1,
      sym__function_declarator_seq,
    STATE(7129), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10645), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [267377] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(9038), 1,
      sym_concatenated_string,
    STATE(7005), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [267405] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(8984), 1,
      sym_concatenated_string,
    STATE(7021), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [267433] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10628), 1,
      anon_sym_requires,
    ACTIONS(10422), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6899), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [267461] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10263), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [267481] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8052), 1,
      anon_sym_DASH_GT,
    ACTIONS(8057), 1,
      anon_sym_requires,
    STATE(7130), 1,
      sym_trailing_return_type,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6923), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [267513] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    STATE(4231), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(7128), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10647), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [267545] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9876), 1,
      anon_sym_LBRACK,
    STATE(4027), 1,
      sym_parameter_list,
    STATE(7213), 1,
      sym__function_declarator_seq,
    STATE(7129), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10649), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [267577] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(8908), 1,
      sym_concatenated_string,
    STATE(7109), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [267605] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9235), 1,
      anon_sym_LBRACE,
    ACTIONS(9572), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(5707), 1,
      sym_enumerator_list,
    STATE(7349), 1,
      sym__scope_resolution,
    ACTIONS(10651), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5561), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [267645] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8052), 1,
      anon_sym_DASH_GT,
    ACTIONS(8057), 1,
      anon_sym_requires,
    STATE(7127), 1,
      sym_trailing_return_type,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6899), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [267677] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10653), 1,
      anon_sym_requires,
    ACTIONS(10549), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10263), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [267705] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(8806), 1,
      sym_concatenated_string,
    STATE(7060), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [267733] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym_requires,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6899), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [267761] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7190), 1,
      anon_sym_LBRACE,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3743), 1,
      sym_enumerator_list,
    STATE(7338), 1,
      sym__scope_resolution,
    ACTIONS(10656), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4000), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [267801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10536), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [267821] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5956), 1,
      anon_sym_LBRACE,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9625), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2681), 1,
      sym_enumerator_list,
    STATE(7335), 1,
      sym__scope_resolution,
    ACTIONS(10658), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2941), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [267861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5439), 1,
      sym_identifier,
    ACTIONS(5441), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [267883] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9703), 1,
      anon_sym_requires,
    ACTIONS(9646), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6923), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [267911] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8033), 1,
      anon_sym_requires,
    ACTIONS(10265), 1,
      anon_sym_LBRACK,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6685), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10263), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [267941] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8033), 1,
      anon_sym_requires,
    ACTIONS(10241), 1,
      anon_sym_LBRACK,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6742), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [267971] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8033), 1,
      anon_sym_requires,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [268001] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(6958), 1,
      anon_sym_LBRACE,
    ACTIONS(9450), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9637), 1,
      sym_identifier,
    STATE(3375), 1,
      sym_template_type,
    STATE(3848), 1,
      sym_enumerator_list,
    STATE(7350), 1,
      sym__scope_resolution,
    ACTIONS(10660), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3295), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [268041] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(6799), 1,
      anon_sym_LBRACE,
    ACTIONS(9327), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9574), 1,
      sym_identifier,
    STATE(3137), 1,
      sym_template_type,
    STATE(3385), 1,
      sym_enumerator_list,
    STATE(7329), 1,
      sym__scope_resolution,
    ACTIONS(10662), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3097), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [268081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5417), 1,
      sym_identifier,
    ACTIONS(5419), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [268103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10532), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [268123] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(6847), 1,
      anon_sym_LBRACE,
    ACTIONS(9347), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    STATE(3164), 1,
      sym_template_type,
    STATE(3492), 1,
      sym_enumerator_list,
    STATE(7346), 1,
      sym__scope_resolution,
    ACTIONS(10664), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3207), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [268163] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8052), 1,
      anon_sym_DASH_GT,
    ACTIONS(9502), 1,
      anon_sym_requires,
    STATE(7150), 1,
      sym_trailing_return_type,
    ACTIONS(9257), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [268195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10239), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [268215] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8033), 1,
      anon_sym_requires,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [268245] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    STATE(4231), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(7128), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10666), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [268277] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8052), 1,
      anon_sym_DASH_GT,
    ACTIONS(9586), 1,
      anon_sym_requires,
    STATE(7157), 1,
      sym_trailing_return_type,
    ACTIONS(9488), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [268309] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8052), 1,
      anon_sym_DASH_GT,
    ACTIONS(9759), 1,
      anon_sym_requires,
    STATE(7161), 1,
      sym_trailing_return_type,
    ACTIONS(9646), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6923), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [268341] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8052), 1,
      anon_sym_DASH_GT,
    ACTIONS(10668), 1,
      anon_sym_requires,
    STATE(7165), 1,
      sym_trailing_return_type,
    ACTIONS(10422), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6899), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [268373] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    STATE(4231), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(7128), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10671), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [268405] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8269), 1,
      anon_sym_COLON,
    ACTIONS(9118), 1,
      anon_sym_STAR,
    ACTIONS(9120), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9122), 1,
      anon_sym_AMP,
    STATE(4696), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7590), 1,
      sym__abstract_declarator,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [268443] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(7190), 1,
      anon_sym_LBRACE,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9572), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(4632), 1,
      sym_enumerator_list,
    STATE(7349), 1,
      sym__scope_resolution,
    ACTIONS(10673), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5374), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [268483] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    STATE(4238), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10666), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [268515] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8052), 1,
      anon_sym_DASH_GT,
    ACTIONS(8057), 1,
      anon_sym_requires,
    STATE(7135), 1,
      sym_trailing_return_type,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [268547] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(3938), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10587), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [268575] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9876), 1,
      anon_sym_LBRACK,
    STATE(4027), 1,
      sym_parameter_list,
    STATE(7213), 1,
      sym__function_declarator_seq,
    STATE(7129), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10677), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [268607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10485), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [268627] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6065), 1,
      anon_sym_LBRACK,
    ACTIONS(10679), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6067), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [268651] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8033), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [268681] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10683), 1,
      anon_sym_LBRACK,
    STATE(6822), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10681), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [268707] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(3938), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10589), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [268735] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5169), 2,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(5162), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [268759] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(3938), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10591), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [268787] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    STATE(4231), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(7128), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10685), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [268819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10524), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [268839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9253), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [268859] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym_requires,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [268887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10497), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [268907] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    STATE(4231), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(7128), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10687), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [268939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10493), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [268959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10479), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [268979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10510), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [268999] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10465), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [269019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10453), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [269039] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(3938), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10593), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [269067] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(3938), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10595), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [269095] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(3938), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10597), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [269123] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(6851), 1,
      anon_sym_LBRACE,
    ACTIONS(9434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9584), 1,
      sym_identifier,
    STATE(3163), 1,
      sym_template_type,
    STATE(3277), 1,
      sym_enumerator_list,
    STATE(7361), 1,
      sym__scope_resolution,
    ACTIONS(10689), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4765), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [269163] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(7968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9420), 1,
      anon_sym_LBRACE,
    ACTIONS(9627), 1,
      sym_identifier,
    STATE(5567), 1,
      sym_template_type,
    STATE(5835), 1,
      sym_enumerator_list,
    STATE(7328), 1,
      sym__scope_resolution,
    ACTIONS(10691), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5648), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [269203] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(3938), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10599), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [269231] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(7190), 1,
      anon_sym_LBRACE,
    ACTIONS(9576), 1,
      sym_identifier,
    ACTIONS(9609), 1,
      anon_sym_COLON_COLON,
    STATE(2836), 1,
      sym_template_type,
    STATE(3743), 1,
      sym_enumerator_list,
    STATE(7365), 1,
      sym__scope_resolution,
    ACTIONS(10693), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4866), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [269271] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5956), 1,
      anon_sym_LBRACE,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9625), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2681), 1,
      sym_enumerator_list,
    STATE(7335), 1,
      sym__scope_resolution,
    ACTIONS(10695), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2808), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [269311] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(9297), 1,
      sym_concatenated_string,
    STATE(7103), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [269339] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(6464), 1,
      anon_sym_LBRACE,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9633), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(6116), 1,
      sym_enumerator_list,
    STATE(7343), 1,
      sym__scope_resolution,
    ACTIONS(10697), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5861), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [269379] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(7190), 1,
      anon_sym_LBRACE,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(4632), 1,
      sym_enumerator_list,
    STATE(7371), 1,
      sym__scope_resolution,
    ACTIONS(10699), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4708), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [269419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10469), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [269439] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6162), 1,
      anon_sym_LBRACK,
    STATE(6822), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6164), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [269465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10518), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [269485] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6006), 1,
      anon_sym_LBRACK,
    ACTIONS(10679), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10701), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(6008), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [269511] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10265), 1,
      anon_sym_LBRACK,
    ACTIONS(10703), 1,
      anon_sym_requires,
    ACTIONS(10365), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6685), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10263), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [269541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10431), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [269561] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10241), 1,
      anon_sym_LBRACK,
    ACTIONS(10570), 1,
      anon_sym_requires,
    ACTIONS(10243), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6742), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [269591] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9756), 1,
      anon_sym_requires,
    ACTIONS(9661), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [269621] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10706), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10708), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6008), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [269645] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9565), 1,
      anon_sym_requires,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [269675] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10461), 1,
      sym_identifier,
    STATE(9236), 1,
      sym_concatenated_string,
    STATE(7039), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [269703] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    STATE(4238), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10647), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [269735] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(3938), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10573), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [269763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10489), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [269783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9479), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [269803] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(7988), 1,
      anon_sym_LBRACE,
    ACTIONS(9382), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9570), 1,
      sym_identifier,
    STATE(4373), 1,
      sym_template_type,
    STATE(4679), 1,
      sym_enumerator_list,
    STATE(7334), 1,
      sym__scope_resolution,
    ACTIONS(10710), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4428), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [269843] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym_requires,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [269871] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(6464), 1,
      anon_sym_LBRACE,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9635), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2977), 1,
      sym_enumerator_list,
    STATE(7330), 1,
      sym__scope_resolution,
    ACTIONS(10712), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5833), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [269911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10475), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [269931] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9560), 1,
      anon_sym_requires,
    ACTIONS(9488), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [269959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10708), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6067), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [269981] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5105), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7190), 1,
      anon_sym_LBRACE,
    ACTIONS(9619), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3743), 1,
      sym_enumerator_list,
    STATE(7326), 1,
      sym__scope_resolution,
    ACTIONS(10714), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4330), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [270021] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(6851), 1,
      anon_sym_LBRACE,
    ACTIONS(8017), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(3163), 1,
      sym_template_type,
    STATE(3277), 1,
      sym_enumerator_list,
    STATE(7325), 1,
      sym__scope_resolution,
    ACTIONS(10716), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5846), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [270061] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(6504), 1,
      anon_sym_LBRACE,
    ACTIONS(9307), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(3015), 1,
      sym_template_type,
    STATE(3169), 1,
      sym_enumerator_list,
    STATE(7340), 1,
      sym__scope_resolution,
    ACTIONS(10718), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2922), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [270101] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    STATE(4238), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10687), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [270133] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    STATE(4238), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10685), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [270165] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9494), 1,
      anon_sym_requires,
    ACTIONS(9257), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [270193] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(6464), 1,
      anon_sym_LBRACE,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9611), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2977), 1,
      sym_enumerator_list,
    STATE(7347), 1,
      sym__scope_resolution,
    ACTIONS(10720), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4666), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [270233] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    STATE(4238), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10671), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [270265] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(8089), 1,
      anon_sym_LBRACE,
    ACTIONS(9273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9604), 1,
      sym_identifier,
    STATE(4593), 1,
      sym_template_type,
    STATE(4798), 1,
      sym_enumerator_list,
    STATE(7337), 1,
      sym__scope_resolution,
    ACTIONS(10722), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4612), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [270305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10449), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [270325] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9235), 1,
      anon_sym_LBRACE,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(5707), 1,
      sym_enumerator_list,
    STATE(7371), 1,
      sym__scope_resolution,
    ACTIONS(10724), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5951), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [270365] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9876), 1,
      anon_sym_LBRACK,
    STATE(4027), 1,
      sym_parameter_list,
    STATE(7213), 1,
      sym__function_declarator_seq,
    STATE(7129), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10726), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [270397] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9876), 1,
      anon_sym_LBRACK,
    STATE(4027), 1,
      sym_parameter_list,
    STATE(7213), 1,
      sym__function_declarator_seq,
    STATE(7129), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10728), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [270429] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym_requires,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6923), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [270457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6174), 1,
      anon_sym_LBRACK,
    ACTIONS(6176), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [270478] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8151), 1,
      anon_sym_DASH_GT,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9667), 1,
      anon_sym_requires,
    STATE(7231), 1,
      sym_trailing_return_type,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [270511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6254), 1,
      anon_sym_LBRACK,
    ACTIONS(6256), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [270532] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10730), 1,
      anon_sym_SEMI,
    ACTIONS(10732), 1,
      anon_sym_EQ,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10736), 1,
      anon_sym_try,
    STATE(575), 1,
      sym_compound_statement,
    STATE(8550), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(576), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [270569] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10744), 1,
      anon_sym_RBRACE,
    ACTIONS(10742), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8554), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(9271), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7014), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [270602] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10746), 1,
      anon_sym_RPAREN,
    STATE(6751), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(10441), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10443), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [270627] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10732), 1,
      anon_sym_EQ,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10736), 1,
      anon_sym_try,
    ACTIONS(10748), 1,
      anon_sym_SEMI,
    STATE(585), 1,
      sym_compound_statement,
    STATE(8636), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(590), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [270664] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10750), 1,
      anon_sym_SEMI,
    ACTIONS(10752), 1,
      anon_sym_EQ,
    ACTIONS(10754), 1,
      anon_sym_try,
    STATE(430), 1,
      sym_compound_statement,
    STATE(8664), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(429), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [270701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(5180), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [270722] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10756), 1,
      anon_sym_RBRACE,
    ACTIONS(10742), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8454), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(9612), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7264), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [270755] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10758), 1,
      anon_sym_SEMI,
    ACTIONS(10760), 1,
      anon_sym_LBRACE,
    ACTIONS(10762), 1,
      anon_sym_EQ,
    ACTIONS(10764), 1,
      anon_sym_try,
    STATE(2419), 1,
      sym_compound_statement,
    STATE(8711), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2572), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [270792] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10766), 1,
      anon_sym_RBRACE,
    ACTIONS(10742), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8759), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8875), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7264), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [270825] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10768), 1,
      anon_sym_RBRACE,
    ACTIONS(10742), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8535), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(9295), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7264), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [270858] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10770), 1,
      anon_sym_RPAREN,
    STATE(6751), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(10441), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10443), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [270883] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10772), 1,
      anon_sym_RBRACE,
    ACTIONS(10742), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8530), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(9317), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7264), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [270916] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10564), 1,
      anon_sym_template,
    ACTIONS(10774), 1,
      sym_identifier,
    STATE(4164), 1,
      sym_template_method,
    STATE(4166), 1,
      sym_dependent_field_identifier,
    STATE(4167), 1,
      sym_qualified_field_identifier,
    STATE(7015), 1,
      sym__scope_resolution,
    STATE(8614), 1,
      sym_operator_name,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [270955] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10776), 1,
      anon_sym_RBRACE,
    ACTIONS(10742), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8656), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(9000), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7045), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [270988] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10752), 1,
      anon_sym_EQ,
    ACTIONS(10754), 1,
      anon_sym_try,
    ACTIONS(10778), 1,
      anon_sym_SEMI,
    STATE(402), 1,
      sym_compound_statement,
    STATE(8606), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(401), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [271025] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    ACTIONS(8531), 1,
      anon_sym_STAR,
    ACTIONS(8533), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP,
    STATE(4001), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7395), 1,
      sym__abstract_declarator,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [271060] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8151), 1,
      anon_sym_DASH_GT,
    ACTIONS(8153), 1,
      anon_sym_requires,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    STATE(7214), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [271093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6258), 1,
      anon_sym_LBRACK,
    ACTIONS(6260), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [271114] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10780), 1,
      anon_sym_RPAREN,
    STATE(6751), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(10441), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10443), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [271139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6243), 1,
      anon_sym_LBRACK,
    ACTIONS(6245), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [271160] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10782), 1,
      anon_sym_RBRACE,
    ACTIONS(10742), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8620), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(9117), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7264), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [271193] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10618), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10620), 1,
      anon_sym_template,
    ACTIONS(10784), 1,
      sym_identifier,
    STATE(2849), 1,
      sym_dependent_field_identifier,
    STATE(2850), 1,
      sym_qualified_field_identifier,
    STATE(2853), 1,
      sym_template_method,
    STATE(7024), 1,
      sym__scope_resolution,
    STATE(8697), 1,
      sym_operator_name,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [271232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10788), 1,
      anon_sym_LBRACK,
    ACTIONS(10786), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [271253] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10790), 1,
      anon_sym_RBRACE,
    ACTIONS(10742), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8390), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(9731), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7009), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [271286] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10792), 1,
      anon_sym_RBRACE,
    ACTIONS(10742), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8646), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(9081), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7023), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [271319] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10794), 1,
      sym_identifier,
    ACTIONS(10796), 1,
      anon_sym_COLON_COLON,
    STATE(7030), 1,
      sym__scope_resolution,
    STATE(8308), 1,
      sym_field_initializer,
    STATE(8479), 1,
      sym_operator_name,
    STATE(7730), 2,
      sym_template_method,
      sym_qualified_field_identifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [271356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10800), 1,
      anon_sym_LBRACK,
    ACTIONS(10798), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [271377] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10796), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10802), 1,
      sym_identifier,
    ACTIONS(10804), 1,
      anon_sym_template,
    STATE(2849), 1,
      sym_dependent_field_identifier,
    STATE(2850), 1,
      sym_qualified_field_identifier,
    STATE(2853), 1,
      sym_template_method,
    STATE(7030), 1,
      sym__scope_resolution,
    STATE(8479), 1,
      sym_operator_name,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [271416] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10806), 1,
      anon_sym_RBRACE,
    ACTIONS(10742), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8736), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8918), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7011), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [271449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10810), 1,
      anon_sym_LBRACK,
    ACTIONS(10808), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [271470] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10760), 1,
      anon_sym_LBRACE,
    ACTIONS(10762), 1,
      anon_sym_EQ,
    ACTIONS(10764), 1,
      anon_sym_try,
    ACTIONS(10812), 1,
      anon_sym_SEMI,
    STATE(2447), 1,
      sym_compound_statement,
    STATE(8756), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2478), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [271507] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(801), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10814), 1,
      anon_sym_SEMI,
    ACTIONS(10816), 1,
      anon_sym_EQ,
    ACTIONS(10818), 1,
      anon_sym_try,
    STATE(889), 1,
      sym_compound_statement,
    STATE(8704), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(888), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [271544] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10820), 1,
      anon_sym_SEMI,
    ACTIONS(10822), 1,
      anon_sym_EQ,
    ACTIONS(10824), 1,
      anon_sym_try,
    STATE(1007), 1,
      sym_compound_statement,
    STATE(8387), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1062), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [271581] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(801), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10816), 1,
      anon_sym_EQ,
    ACTIONS(10818), 1,
      anon_sym_try,
    ACTIONS(10826), 1,
      anon_sym_SEMI,
    STATE(974), 1,
      sym_compound_statement,
    STATE(8608), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(973), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [271618] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10828), 1,
      anon_sym_RBRACE,
    ACTIONS(10742), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8492), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(9430), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7264), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [271651] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8151), 1,
      anon_sym_DASH_GT,
    ACTIONS(8153), 1,
      anon_sym_requires,
    ACTIONS(10241), 1,
      anon_sym_LBRACK,
    STATE(7259), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6742), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [271684] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10830), 1,
      anon_sym_RPAREN,
    STATE(6751), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(10441), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10443), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [271709] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10794), 1,
      sym_identifier,
    ACTIONS(10796), 1,
      anon_sym_COLON_COLON,
    STATE(7030), 1,
      sym__scope_resolution,
    STATE(8479), 1,
      sym_operator_name,
    STATE(8532), 1,
      sym_field_initializer,
    STATE(7730), 2,
      sym_template_method,
      sym_qualified_field_identifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [271746] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10832), 1,
      anon_sym_RBRACE,
    ACTIONS(10742), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8596), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(9159), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7264), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [271779] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10834), 1,
      anon_sym_RBRACE,
    ACTIONS(10742), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8582), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(9178), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7118), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [271812] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10641), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10643), 1,
      anon_sym_template,
    ACTIONS(10784), 1,
      sym_identifier,
    STATE(2849), 1,
      sym_dependent_field_identifier,
    STATE(2850), 1,
      sym_qualified_field_identifier,
    STATE(2853), 1,
      sym_template_method,
    STATE(7043), 1,
      sym__scope_resolution,
    STATE(8680), 1,
      sym_operator_name,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [271851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10838), 1,
      anon_sym_LBRACK,
    ACTIONS(10836), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [271872] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10840), 1,
      anon_sym_RBRACE,
    ACTIONS(10742), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8713), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8941), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7264), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [271905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6272), 1,
      anon_sym_LBRACK,
    ACTIONS(6274), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [271926] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10842), 1,
      anon_sym_RBRACE,
    ACTIONS(10742), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8674), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(9023), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7037), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [271959] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10822), 1,
      anon_sym_EQ,
    ACTIONS(10824), 1,
      anon_sym_try,
    ACTIONS(10844), 1,
      anon_sym_SEMI,
    STATE(1004), 1,
      sym_compound_statement,
    STATE(8601), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1055), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [271996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6170), 1,
      anon_sym_LBRACK,
    ACTIONS(6172), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [272017] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7559), 1,
      sym__abstract_declarator,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [272052] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4342), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10573), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [272079] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4342), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10599), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [272106] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4342), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10597), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [272133] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4342), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10595), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [272160] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4342), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10593), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [272187] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4342), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10591), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [272214] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LPAREN2,
    ACTIONS(5099), 1,
      anon_sym_STAR,
    ACTIONS(5101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5103), 1,
      anon_sym_AMP,
    ACTIONS(8145), 1,
      anon_sym_LBRACK,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6967), 1,
      sym__function_declarator_seq,
    STATE(7621), 1,
      sym__abstract_declarator,
    STATE(6944), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [272249] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4321), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10589), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [272276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6555), 1,
      anon_sym_LBRACK,
    ACTIONS(6557), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [272297] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10846), 1,
      anon_sym_RPAREN,
    STATE(6751), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(10441), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10443), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [272322] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10848), 1,
      anon_sym_RBRACE,
    ACTIONS(10742), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8698), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8990), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7264), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [272355] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10850), 1,
      anon_sym_RBRACE,
    ACTIONS(10742), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8503), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(9387), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7073), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [272388] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4342), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10589), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [272415] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10852), 1,
      anon_sym_RBRACE,
    ACTIONS(10742), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8644), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(9071), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7041), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [272448] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10854), 1,
      anon_sym_RPAREN,
    STATE(6751), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(10441), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10443), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [272473] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4342), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10587), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [272500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10858), 1,
      anon_sym_LBRACK,
    ACTIONS(10856), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [272521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 1,
      anon_sym_LBRACK,
    ACTIONS(5131), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [272542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 1,
      anon_sym_LBRACK,
    ACTIONS(5131), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [272563] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8151), 1,
      anon_sym_DASH_GT,
    ACTIONS(10241), 1,
      anon_sym_LBRACK,
    ACTIONS(10860), 1,
      anon_sym_requires,
    STATE(7248), 1,
      sym_trailing_return_type,
    ACTIONS(10243), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6742), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [272596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 1,
      anon_sym_LBRACK,
    ACTIONS(5131), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [272617] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8151), 1,
      anon_sym_DASH_GT,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9940), 1,
      anon_sym_requires,
    STATE(7242), 1,
      sym_trailing_return_type,
    ACTIONS(9661), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [272650] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10863), 1,
      anon_sym_RBRACE,
    ACTIONS(10742), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8518), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(9343), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7264), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [272683] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1117), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10865), 1,
      anon_sym_SEMI,
    ACTIONS(10867), 1,
      anon_sym_EQ,
    ACTIONS(10869), 1,
      anon_sym_try,
    STATE(959), 1,
      sym_compound_statement,
    STATE(8423), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(960), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [272720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 1,
      anon_sym_LBRACK,
    ACTIONS(5131), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [272741] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10871), 1,
      anon_sym_RBRACE,
    ACTIONS(10742), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8733), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8926), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7061), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [272774] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10873), 1,
      anon_sym_SEMI,
    ACTIONS(10875), 1,
      anon_sym_LBRACE,
    ACTIONS(10877), 1,
      anon_sym_EQ,
    ACTIONS(10879), 1,
      anon_sym_try,
    STATE(2430), 1,
      sym_compound_statement,
    STATE(8399), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2590), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [272811] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4321), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10591), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [272838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10883), 1,
      anon_sym_LBRACK,
    ACTIONS(10881), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [272859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6268), 1,
      anon_sym_LBRACK,
    ACTIONS(6270), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [272880] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10875), 1,
      anon_sym_LBRACE,
    ACTIONS(10877), 1,
      anon_sym_EQ,
    ACTIONS(10879), 1,
      anon_sym_try,
    ACTIONS(10885), 1,
      anon_sym_SEMI,
    STATE(2421), 1,
      sym_compound_statement,
    STATE(8494), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2561), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [272917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10889), 1,
      anon_sym_LBRACK,
    ACTIONS(10887), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [272938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 1,
      anon_sym_LBRACK,
    ACTIONS(5131), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [272959] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1117), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10867), 1,
      anon_sym_EQ,
    ACTIONS(10869), 1,
      anon_sym_try,
    ACTIONS(10891), 1,
      anon_sym_SEMI,
    STATE(985), 1,
      sym_compound_statement,
    STATE(8452), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(986), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [272996] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4321), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10573), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [273023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6158), 1,
      anon_sym_LBRACK,
    ACTIONS(6160), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [273044] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4321), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10599), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [273071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6250), 1,
      anon_sym_LBRACK,
    ACTIONS(6252), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [273092] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10893), 1,
      anon_sym_RBRACE,
    ACTIONS(10742), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8411), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(9715), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7012), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [273125] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10895), 1,
      anon_sym_SEMI,
    ACTIONS(10897), 1,
      anon_sym_LBRACE,
    ACTIONS(10899), 1,
      anon_sym_EQ,
    ACTIONS(10901), 1,
      anon_sym_try,
    STATE(2088), 1,
      sym_compound_statement,
    STATE(8516), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2163), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [273162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5879), 1,
      anon_sym_LBRACK,
    ACTIONS(5877), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [273183] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10903), 1,
      anon_sym_SEMI,
    ACTIONS(10905), 1,
      anon_sym_LBRACE,
    ACTIONS(10907), 1,
      anon_sym_EQ,
    ACTIONS(10909), 1,
      anon_sym_try,
    STATE(2297), 1,
      sym_compound_statement,
    STATE(8615), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2308), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [273220] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10614), 1,
      anon_sym_LBRACK,
    STATE(7107), 1,
      sym_parameter_list,
    STATE(7133), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6142), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [273249] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8151), 1,
      anon_sym_DASH_GT,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9548), 1,
      anon_sym_requires,
    STATE(7246), 1,
      sym_trailing_return_type,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [273282] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10614), 1,
      anon_sym_LBRACK,
    STATE(7107), 1,
      sym_parameter_list,
    STATE(7133), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6150), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [273311] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4321), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10597), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [273338] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10624), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10626), 1,
      anon_sym_template,
    ACTIONS(10911), 1,
      sym_identifier,
    STATE(4261), 1,
      sym_qualified_field_identifier,
    STATE(4263), 1,
      sym_dependent_field_identifier,
    STATE(4274), 1,
      sym_template_method,
    STATE(7097), 1,
      sym__scope_resolution,
    STATE(8481), 1,
      sym_operator_name,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [273377] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8151), 1,
      anon_sym_DASH_GT,
    ACTIONS(8153), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    STATE(7241), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [273410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10915), 1,
      anon_sym_LBRACK,
    ACTIONS(10913), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [273431] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10606), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10608), 1,
      anon_sym_template,
    ACTIONS(10917), 1,
      sym_identifier,
    STATE(3774), 1,
      sym_template_method,
    STATE(3775), 1,
      sym_dependent_field_identifier,
    STATE(3776), 1,
      sym_qualified_field_identifier,
    STATE(7100), 1,
      sym__scope_resolution,
    STATE(8551), 1,
      sym_operator_name,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [273470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6166), 1,
      anon_sym_LBRACK,
    ACTIONS(6168), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [273491] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4321), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10587), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [273518] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10919), 1,
      anon_sym_RPAREN,
    STATE(6751), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(10441), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10443), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [273543] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10921), 1,
      anon_sym_RPAREN,
    STATE(6751), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(10441), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10443), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [273568] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8151), 1,
      anon_sym_DASH_GT,
    ACTIONS(8153), 1,
      anon_sym_requires,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    STATE(7219), 1,
      sym_trailing_return_type,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [273601] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10923), 1,
      anon_sym_RBRACE,
    ACTIONS(10742), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8578), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(9179), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7116), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [273634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6239), 1,
      anon_sym_LBRACK,
    ACTIONS(6241), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [273655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10927), 1,
      anon_sym_LBRACK,
    ACTIONS(10925), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [273676] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10929), 1,
      anon_sym_RPAREN,
    STATE(6751), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(10441), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10443), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [273701] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4321), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10595), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [273728] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4321), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10593), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [273755] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10614), 1,
      anon_sym_LBRACK,
    STATE(7107), 1,
      sym_parameter_list,
    STATE(7133), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6071), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [273784] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10614), 1,
      anon_sym_LBRACK,
    STATE(7107), 1,
      sym_parameter_list,
    STATE(7133), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5998), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [273813] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10905), 1,
      anon_sym_LBRACE,
    ACTIONS(10907), 1,
      anon_sym_EQ,
    ACTIONS(10909), 1,
      anon_sym_try,
    ACTIONS(10931), 1,
      anon_sym_SEMI,
    STATE(2262), 1,
      sym_compound_statement,
    STATE(8570), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2386), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [273850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 1,
      anon_sym_LBRACK,
    ACTIONS(5131), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [273871] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10933), 1,
      anon_sym_RBRACE,
    ACTIONS(10742), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8619), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(9111), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7264), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [273904] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10897), 1,
      anon_sym_LBRACE,
    ACTIONS(10899), 1,
      anon_sym_EQ,
    ACTIONS(10901), 1,
      anon_sym_try,
    ACTIONS(10935), 1,
      anon_sym_SEMI,
    STATE(2099), 1,
      sym_compound_statement,
    STATE(8497), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2211), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [273941] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10937), 1,
      anon_sym_RBRACE,
    ACTIONS(10742), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8537), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(9305), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7264), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [273974] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10941), 1,
      anon_sym_LT,
    ACTIONS(10943), 1,
      anon_sym_LBRACK,
    STATE(7257), 1,
      sym_template_argument_list,
    ACTIONS(10939), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [273998] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10945), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10947), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6008), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [274020] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9235), 1,
      anon_sym_LBRACE,
    ACTIONS(9572), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(5722), 1,
      sym_enumerator_list,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(5585), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [274056] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10822), 1,
      anon_sym_EQ,
    ACTIONS(10824), 1,
      anon_sym_try,
    STATE(1007), 1,
      sym_compound_statement,
    STATE(8387), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1062), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [274090] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1117), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10867), 1,
      anon_sym_EQ,
    ACTIONS(10869), 1,
      anon_sym_try,
    STATE(959), 1,
      sym_compound_statement,
    STATE(8423), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(960), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [274124] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(6464), 1,
      anon_sym_LBRACE,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9635), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2942), 1,
      sym_enumerator_list,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(5824), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [274160] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9235), 1,
      anon_sym_LBRACE,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(5722), 1,
      sym_enumerator_list,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(5958), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [274196] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    STATE(4289), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10671), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [274226] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8057), 1,
      anon_sym_requires,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10263), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [274252] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10683), 1,
      anon_sym_LBRACK,
    STATE(6669), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10681), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [274276] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10951), 1,
      anon_sym_LBRACK,
    STATE(6669), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10949), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [274300] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8057), 1,
      anon_sym_requires,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6899), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [274326] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5105), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7190), 1,
      anon_sym_LBRACE,
    ACTIONS(9619), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3718), 1,
      sym_enumerator_list,
    STATE(7326), 1,
      sym__scope_resolution,
    STATE(4356), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [274362] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10732), 1,
      anon_sym_EQ,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10736), 1,
      anon_sym_try,
    STATE(585), 1,
      sym_compound_statement,
    STATE(8636), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(590), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [274396] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6162), 1,
      anon_sym_LBRACK,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6669), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6164), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [274420] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10822), 1,
      anon_sym_EQ,
    ACTIONS(10824), 1,
      anon_sym_try,
    STATE(1004), 1,
      sym_compound_statement,
    STATE(8601), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1055), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [274454] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8057), 1,
      anon_sym_requires,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6923), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [274480] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8057), 1,
      anon_sym_requires,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [274506] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(7190), 1,
      anon_sym_LBRACE,
    ACTIONS(9576), 1,
      sym_identifier,
    ACTIONS(9609), 1,
      anon_sym_COLON_COLON,
    STATE(2836), 1,
      sym_template_type,
    STATE(3718), 1,
      sym_enumerator_list,
    STATE(7365), 1,
      sym__scope_resolution,
    STATE(4908), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [274542] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(6958), 1,
      anon_sym_LBRACE,
    ACTIONS(9450), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9637), 1,
      sym_identifier,
    STATE(3375), 1,
      sym_template_type,
    STATE(3819), 1,
      sym_enumerator_list,
    STATE(7350), 1,
      sym__scope_resolution,
    STATE(3292), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [274578] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6751), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(10441), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10443), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [274600] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(6799), 1,
      anon_sym_LBRACE,
    ACTIONS(9327), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9574), 1,
      sym_identifier,
    STATE(3137), 1,
      sym_template_type,
    STATE(3372), 1,
      sym_enumerator_list,
    STATE(7329), 1,
      sym__scope_resolution,
    STATE(3153), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [274636] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8057), 1,
      anon_sym_requires,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [274662] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6004), 1,
      anon_sym_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    STATE(2784), 1,
      sym_parameter_list,
    STATE(7230), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5998), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_try,
  [274690] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(6851), 1,
      anon_sym_LBRACE,
    ACTIONS(8017), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(3163), 1,
      sym_template_type,
    STATE(3233), 1,
      sym_enumerator_list,
    STATE(7325), 1,
      sym__scope_resolution,
    STATE(5852), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [274726] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(8089), 1,
      anon_sym_LBRACE,
    ACTIONS(9273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9604), 1,
      sym_identifier,
    STATE(4593), 1,
      sym_template_type,
    STATE(4743), 1,
      sym_enumerator_list,
    STATE(7337), 1,
      sym__scope_resolution,
    STATE(4669), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [274762] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9494), 1,
      anon_sym_requires,
    STATE(6984), 1,
      sym_trailing_return_type,
    ACTIONS(9257), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [274792] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9502), 1,
      anon_sym_requires,
    ACTIONS(9257), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [274818] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9560), 1,
      anon_sym_requires,
    STATE(6913), 1,
      sym_trailing_return_type,
    ACTIONS(9488), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [274848] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(7968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9420), 1,
      anon_sym_LBRACE,
    ACTIONS(9627), 1,
      sym_identifier,
    STATE(5567), 1,
      sym_template_type,
    STATE(5827), 1,
      sym_enumerator_list,
    STATE(7328), 1,
      sym__scope_resolution,
    STATE(5643), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [274884] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6004), 1,
      anon_sym_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    STATE(2784), 1,
      sym_parameter_list,
    STATE(7230), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6150), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_try,
  [274912] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9586), 1,
      anon_sym_requires,
    ACTIONS(9488), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [274938] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym_requires,
    ACTIONS(8160), 1,
      anon_sym_DASH_GT,
    STATE(6893), 1,
      sym_trailing_return_type,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6899), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [274968] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym_requires,
    ACTIONS(8160), 1,
      anon_sym_DASH_GT,
    STATE(6908), 1,
      sym_trailing_return_type,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6923), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [274998] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym_requires,
    ACTIONS(8160), 1,
      anon_sym_DASH_GT,
    STATE(6999), 1,
      sym_trailing_return_type,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6887), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [275028] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10752), 1,
      anon_sym_EQ,
    ACTIONS(10754), 1,
      anon_sym_try,
    STATE(430), 1,
      sym_compound_statement,
    STATE(8664), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(429), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [275062] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym_requires,
    ACTIONS(8160), 1,
      anon_sym_DASH_GT,
    STATE(6981), 1,
      sym_trailing_return_type,
    ACTIONS(7723), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6979), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [275092] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9703), 1,
      anon_sym_requires,
    STATE(6898), 1,
      sym_trailing_return_type,
    ACTIONS(9646), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6923), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [275122] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9759), 1,
      anon_sym_requires,
    ACTIONS(9646), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6923), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [275148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8093), 6,
      anon_sym_AMP,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(8095), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
  [275168] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5956), 1,
      anon_sym_LBRACE,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9625), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2700), 1,
      sym_enumerator_list,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(2838), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [275204] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(4047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5461), 1,
      anon_sym_virtual,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(7290), 1,
      sym_virtual,
    STATE(7352), 1,
      sym__scope_resolution,
    STATE(7923), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [275240] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10668), 1,
      anon_sym_requires,
    ACTIONS(10422), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6899), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [275266] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10941), 1,
      anon_sym_LT,
    ACTIONS(10955), 1,
      anon_sym_LBRACK,
    STATE(7217), 1,
      sym_template_argument_list,
    ACTIONS(10953), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [275290] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(801), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10816), 1,
      anon_sym_EQ,
    ACTIONS(10818), 1,
      anon_sym_try,
    STATE(889), 1,
      sym_compound_statement,
    STATE(8704), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(888), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [275324] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8160), 1,
      anon_sym_DASH_GT,
    ACTIONS(10628), 1,
      anon_sym_requires,
    STATE(6906), 1,
      sym_trailing_return_type,
    ACTIONS(10422), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6899), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [275354] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10957), 1,
      anon_sym_requires,
    ACTIONS(10549), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6784), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10263), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [275380] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(6464), 1,
      anon_sym_LBRACE,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9611), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(2942), 1,
      sym_enumerator_list,
    STATE(7347), 1,
      sym__scope_resolution,
    STATE(4658), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [275416] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(6504), 1,
      anon_sym_LBRACE,
    ACTIONS(9307), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(3015), 1,
      sym_template_type,
    STATE(3183), 1,
      sym_enumerator_list,
    STATE(7340), 1,
      sym__scope_resolution,
    STATE(2911), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [275452] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10732), 1,
      anon_sym_EQ,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10736), 1,
      anon_sym_try,
    STATE(575), 1,
      sym_compound_statement,
    STATE(8550), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(576), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [275486] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(4047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5461), 1,
      anon_sym_virtual,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(7285), 1,
      sym_virtual,
    STATE(7352), 1,
      sym__scope_resolution,
    STATE(8284), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [275522] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7190), 1,
      anon_sym_LBRACE,
    ACTIONS(9576), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(3718), 1,
      sym_enumerator_list,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(3950), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [275558] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10752), 1,
      anon_sym_EQ,
    ACTIONS(10754), 1,
      anon_sym_try,
    STATE(402), 1,
      sym_compound_statement,
    STATE(8606), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(401), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [275592] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(6847), 1,
      anon_sym_LBRACE,
    ACTIONS(9347), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    STATE(3164), 1,
      sym_template_type,
    STATE(3468), 1,
      sym_enumerator_list,
    STATE(7346), 1,
      sym__scope_resolution,
    STATE(3191), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [275628] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    STATE(4289), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10687), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [275658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10947), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6067), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [275678] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    STATE(4289), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10685), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [275708] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4378), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10599), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [275734] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6004), 1,
      anon_sym_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    STATE(2784), 1,
      sym_parameter_list,
    STATE(7230), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6071), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_try,
  [275762] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    STATE(4289), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10647), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [275792] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1117), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10867), 1,
      anon_sym_EQ,
    ACTIONS(10869), 1,
      anon_sym_try,
    STATE(985), 1,
      sym_compound_statement,
    STATE(8452), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(986), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [275826] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(801), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    ACTIONS(10816), 1,
      anon_sym_EQ,
    ACTIONS(10818), 1,
      anon_sym_try,
    STATE(974), 1,
      sym_compound_statement,
    STATE(8608), 1,
      sym_field_initializer_list,
    ACTIONS(5180), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(973), 3,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
  [275860] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(4047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5461), 1,
      anon_sym_virtual,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(7308), 1,
      sym_virtual,
    STATE(7352), 1,
      sym__scope_resolution,
    STATE(8221), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [275896] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4378), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10593), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [275922] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6004), 1,
      anon_sym_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    STATE(2784), 1,
      sym_parameter_list,
    STATE(7230), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6142), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_try,
  [275950] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4378), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10587), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [275976] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(7190), 1,
      anon_sym_LBRACE,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9572), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(4597), 1,
      sym_enumerator_list,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(5328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [276012] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4378), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10589), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [276038] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(7190), 1,
      anon_sym_LBRACE,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(4597), 1,
      sym_enumerator_list,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(4723), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [276074] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4378), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10595), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [276100] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5956), 1,
      anon_sym_LBRACE,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9625), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2700), 1,
      sym_enumerator_list,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(2935), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [276136] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(6851), 1,
      anon_sym_LBRACE,
    ACTIONS(9434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9584), 1,
      sym_identifier,
    STATE(3163), 1,
      sym_template_type,
    STATE(3233), 1,
      sym_enumerator_list,
    STATE(7361), 1,
      sym__scope_resolution,
    STATE(4766), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [276172] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    STATE(4289), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10666), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [276202] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4378), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10573), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [276228] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(4047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5461), 1,
      anon_sym_virtual,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(7293), 1,
      sym_virtual,
    STATE(7352), 1,
      sym__scope_resolution,
    STATE(7713), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [276264] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(7988), 1,
      anon_sym_LBRACE,
    ACTIONS(9382), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9570), 1,
      sym_identifier,
    STATE(4373), 1,
      sym_template_type,
    STATE(4693), 1,
      sym_enumerator_list,
    STATE(7334), 1,
      sym__scope_resolution,
    STATE(4413), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [276300] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4378), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10597), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [276326] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(6464), 1,
      anon_sym_LBRACE,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9633), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_type,
    STATE(6127), 1,
      sym_enumerator_list,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(5851), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [276362] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4378), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10591), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [276388] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10187), 1,
      anon_sym_try,
    STATE(1086), 1,
      sym_compound_statement,
    STATE(1087), 1,
      sym_try_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [276423] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6065), 1,
      anon_sym_LBRACK,
    ACTIONS(10960), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6067), 8,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [276444] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9938), 1,
      anon_sym_try,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10760), 1,
      anon_sym_LBRACE,
    STATE(2499), 1,
      sym_compound_statement,
    STATE(2500), 1,
      sym_try_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [276479] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4001), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10599), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [276504] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(9548), 1,
      anon_sym_requires,
    ACTIONS(9374), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [276531] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9938), 1,
      anon_sym_try,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10760), 1,
      anon_sym_LBRACE,
    STATE(2498), 1,
      sym_try_statement,
    STATE(2615), 1,
      sym_compound_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [276566] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9882), 1,
      anon_sym_try,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10875), 1,
      anon_sym_LBRACE,
    STATE(2513), 1,
      sym_try_statement,
    STATE(2514), 1,
      sym_compound_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [276601] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4425), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10599), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [276626] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9882), 1,
      anon_sym_try,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10875), 1,
      anon_sym_LBRACE,
    STATE(2520), 1,
      sym_try_statement,
    STATE(2521), 1,
      sym_compound_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [276661] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9916), 1,
      anon_sym_try,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10905), 1,
      anon_sym_LBRACE,
    STATE(2342), 1,
      sym_compound_statement,
    STATE(2343), 1,
      sym_try_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [276696] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(381), 1,
      anon_sym_LBRACE,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10155), 1,
      anon_sym_try,
    STATE(571), 1,
      sym_compound_statement,
    STATE(584), 1,
      sym_try_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [276731] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9898), 1,
      anon_sym_try,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10897), 1,
      anon_sym_LBRACE,
    STATE(2165), 1,
      sym_try_statement,
    STATE(2179), 1,
      sym_compound_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [276766] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8153), 1,
      anon_sym_requires,
    ACTIONS(9255), 1,
      anon_sym_LBRACK,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9253), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [276793] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4425), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10597), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [276818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10964), 1,
      anon_sym_LBRACK,
    ACTIONS(10962), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [276837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10968), 1,
      anon_sym_LBRACK,
    ACTIONS(10966), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [276856] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8153), 1,
      anon_sym_requires,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [276883] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9898), 1,
      anon_sym_try,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10897), 1,
      anon_sym_LBRACE,
    STATE(2129), 1,
      sym_try_statement,
    STATE(2130), 1,
      sym_compound_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [276918] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9898), 1,
      anon_sym_try,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10897), 1,
      anon_sym_LBRACE,
    STATE(2139), 1,
      sym_try_statement,
    STATE(2140), 1,
      sym_compound_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [276953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_LBRACK,
    ACTIONS(6295), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [276972] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10970), 1,
      sym_identifier,
    STATE(6616), 1,
      sym__scope_resolution,
    STATE(9727), 1,
      sym_qualified_identifier,
    ACTIONS(10972), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [277003] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8153), 1,
      anon_sym_requires,
    ACTIONS(10241), 1,
      anon_sym_LBRACK,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6742), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [277030] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1117), 1,
      anon_sym_LBRACE,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10165), 1,
      anon_sym_try,
    STATE(937), 1,
      sym_compound_statement,
    STATE(941), 1,
      sym_try_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [277065] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10581), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10974), 1,
      sym_identifier,
    ACTIONS(10976), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10978), 1,
      aux_sym_preproc_elif_token1,
    STATE(7383), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(7434), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(7558), 1,
      sym_enumerator,
    STATE(9408), 2,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
    STATE(9411), 2,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
  [277098] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10581), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10974), 1,
      sym_identifier,
    ACTIONS(10978), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10980), 1,
      aux_sym_preproc_if_token2,
    STATE(7391), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(7392), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(7558), 1,
      sym_enumerator,
    STATE(9324), 2,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
    STATE(9325), 2,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
  [277131] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(381), 1,
      anon_sym_LBRACE,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10155), 1,
      anon_sym_try,
    STATE(562), 1,
      sym_try_statement,
    STATE(564), 1,
      sym_compound_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [277166] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10685), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [277195] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10982), 1,
      sym_identifier,
    STATE(6616), 1,
      sym__scope_resolution,
    STATE(8955), 1,
      sym_qualified_identifier,
    ACTIONS(10984), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [277226] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4425), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10595), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [277251] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10986), 1,
      sym_identifier,
    STATE(6616), 1,
      sym__scope_resolution,
    STATE(9141), 1,
      sym_qualified_identifier,
    ACTIONS(10988), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [277282] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10990), 1,
      sym_identifier,
    STATE(6616), 1,
      sym__scope_resolution,
    STATE(9238), 1,
      sym_qualified_identifier,
    ACTIONS(10992), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [277313] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4425), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10593), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [277338] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6162), 1,
      anon_sym_LBRACK,
    STATE(6822), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6164), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_try,
  [277361] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9641), 1,
      anon_sym_LBRACK,
    ACTIONS(9940), 1,
      anon_sym_requires,
    ACTIONS(9661), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6686), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9639), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [277388] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4001), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10587), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [277413] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10994), 1,
      sym_identifier,
    STATE(6616), 1,
      sym__scope_resolution,
    STATE(8841), 1,
      sym_qualified_identifier,
    ACTIONS(10996), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [277444] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9938), 1,
      anon_sym_try,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10760), 1,
      anon_sym_LBRACE,
    STATE(2497), 1,
      sym_compound_statement,
    STATE(2543), 1,
      sym_try_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [277479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11000), 1,
      anon_sym_LBRACK,
    ACTIONS(10998), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [277498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11004), 1,
      anon_sym_LBRACK,
    ACTIONS(11002), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [277517] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10647), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [277546] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(11006), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11008), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11010), 1,
      aux_sym_preproc_elif_token1,
    STATE(7252), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(9337), 1,
      sym_enumerator,
    ACTIONS(11012), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(9099), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [277577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11016), 1,
      anon_sym_LBRACK,
    ACTIONS(11014), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [277596] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10221), 1,
      anon_sym_try,
    STATE(435), 1,
      sym_compound_statement,
    STATE(436), 1,
      sym_try_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [277631] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8153), 1,
      anon_sym_requires,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [277658] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10241), 1,
      anon_sym_LBRACK,
    ACTIONS(10860), 1,
      anon_sym_requires,
    ACTIONS(10243), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6742), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10239), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [277685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11020), 1,
      anon_sym_LBRACK,
    ACTIONS(11018), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [277704] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11022), 1,
      sym_identifier,
    STATE(6616), 1,
      sym__scope_resolution,
    STATE(9060), 1,
      sym_qualified_identifier,
    ACTIONS(11024), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [277735] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9882), 1,
      anon_sym_try,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10875), 1,
      anon_sym_LBRACE,
    STATE(2638), 1,
      sym_compound_statement,
    STATE(2639), 1,
      sym_try_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [277770] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9481), 1,
      anon_sym_LBRACK,
    ACTIONS(9667), 1,
      anon_sym_requires,
    ACTIONS(9515), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9479), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [277797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11028), 1,
      anon_sym_LBRACK,
    ACTIONS(11026), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [277816] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10265), 1,
      anon_sym_LBRACK,
    ACTIONS(11030), 1,
      anon_sym_requires,
    ACTIONS(10365), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6685), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10263), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [277843] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10221), 1,
      anon_sym_try,
    STATE(433), 1,
      sym_compound_statement,
    STATE(434), 1,
      sym_try_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [277878] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4001), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10597), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [277903] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(801), 1,
      anon_sym_LBRACE,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10117), 1,
      anon_sym_try,
    STATE(898), 1,
      sym_compound_statement,
    STATE(899), 1,
      sym_try_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [277938] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(11008), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11010), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11033), 1,
      aux_sym_preproc_if_token2,
    STATE(7390), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(9337), 1,
      sym_enumerator,
    ACTIONS(11012), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(9336), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [277969] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4001), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10591), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [277994] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4425), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10587), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [278019] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10687), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [278048] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(381), 1,
      anon_sym_LBRACE,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10155), 1,
      anon_sym_try,
    STATE(559), 1,
      sym_try_statement,
    STATE(561), 1,
      sym_compound_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [278083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 1,
      anon_sym_LBRACK,
    ACTIONS(6356), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [278102] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(801), 1,
      anon_sym_LBRACE,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10117), 1,
      anon_sym_try,
    STATE(957), 1,
      sym_compound_statement,
    STATE(958), 1,
      sym_try_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [278137] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8153), 1,
      anon_sym_requires,
    ACTIONS(10265), 1,
      anon_sym_LBRACK,
    ACTIONS(6266), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6568), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6685), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10263), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [278164] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10581), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10974), 1,
      sym_identifier,
    ACTIONS(10978), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11035), 1,
      aux_sym_preproc_if_token2,
    STATE(7412), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(7427), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(7558), 1,
      sym_enumerator,
    STATE(9578), 2,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
    STATE(9579), 2,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
  [278197] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1117), 1,
      anon_sym_LBRACE,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10165), 1,
      anon_sym_try,
    STATE(874), 1,
      sym_compound_statement,
    STATE(875), 1,
      sym_try_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [278232] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4425), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10573), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [278257] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11037), 1,
      sym_identifier,
    STATE(6616), 1,
      sym__scope_resolution,
    STATE(9028), 1,
      sym_qualified_identifier,
    ACTIONS(11039), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [278288] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11041), 1,
      sym_identifier,
    ACTIONS(11044), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11050), 1,
      sym_preproc_directive,
    ACTIONS(11053), 1,
      anon_sym_RBRACE,
    ACTIONS(11047), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(9133), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(7264), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [278317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10943), 1,
      anon_sym_LBRACK,
    ACTIONS(10939), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [278336] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9916), 1,
      anon_sym_try,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10905), 1,
      anon_sym_LBRACE,
    STATE(2316), 1,
      sym_compound_statement,
    STATE(2379), 1,
      sym_try_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [278371] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1117), 1,
      anon_sym_LBRACE,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10165), 1,
      anon_sym_try,
    STATE(880), 1,
      sym_compound_statement,
    STATE(881), 1,
      sym_try_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [278406] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4425), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10589), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [278431] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6006), 1,
      anon_sym_LBRACK,
    ACTIONS(10960), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(11055), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(6008), 6,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [278454] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10671), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [278483] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11057), 1,
      sym_identifier,
    STATE(6616), 1,
      sym__scope_resolution,
    STATE(9710), 1,
      sym_qualified_identifier,
    ACTIONS(11059), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [278514] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10666), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [278543] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10187), 1,
      anon_sym_try,
    STATE(1079), 1,
      sym_try_statement,
    STATE(1080), 1,
      sym_compound_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [278578] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9916), 1,
      anon_sym_try,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10905), 1,
      anon_sym_LBRACE,
    STATE(2389), 1,
      sym_try_statement,
    STATE(2391), 1,
      sym_compound_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [278613] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11061), 1,
      sym_identifier,
    STATE(6616), 1,
      sym__scope_resolution,
    STATE(9426), 1,
      sym_qualified_identifier,
    ACTIONS(11063), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [278644] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4425), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10591), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [278669] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10577), 1,
      sym_identifier,
    ACTIONS(11065), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11067), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11069), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11071), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(7389), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(9342), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [278698] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10187), 1,
      anon_sym_try,
    STATE(1071), 1,
      sym_compound_statement,
    STATE(1072), 1,
      sym_try_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [278733] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(801), 1,
      anon_sym_LBRACE,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10117), 1,
      anon_sym_try,
    STATE(900), 1,
      sym_compound_statement,
    STATE(901), 1,
      sym_try_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [278768] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10221), 1,
      anon_sym_try,
    STATE(456), 1,
      sym_compound_statement,
    STATE(457), 1,
      sym_try_statement,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [278803] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11077), 1,
      anon_sym_delete,
    ACTIONS(11079), 1,
      anon_sym_new,
    ACTIONS(11075), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11073), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [278825] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4537), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10593), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [278849] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11081), 1,
      anon_sym_delete,
    ACTIONS(11083), 1,
      anon_sym_new,
    ACTIONS(11075), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11073), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [278871] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4537), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10573), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [278895] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(4047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(7352), 1,
      sym__scope_resolution,
    STATE(8340), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [278925] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11085), 1,
      anon_sym_delete,
    ACTIONS(11087), 1,
      anon_sym_new,
    ACTIONS(11075), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11073), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [278947] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(11091), 1,
      anon_sym_EQ,
    STATE(4289), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    ACTIONS(11089), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [278977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5146), 1,
      anon_sym_LBRACK,
    ACTIONS(5148), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [278995] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4537), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10587), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [279019] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(4047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(7352), 1,
      sym__scope_resolution,
    STATE(7713), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [279049] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(11093), 1,
      anon_sym_EQ,
    STATE(4289), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(9359), 1,
      sym_initializer_list,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [279081] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11095), 1,
      anon_sym_delete,
    ACTIONS(11097), 1,
      anon_sym_new,
    ACTIONS(11075), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11073), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [279103] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(4047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(7352), 1,
      sym__scope_resolution,
    STATE(7741), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [279133] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11099), 1,
      anon_sym_delete,
    ACTIONS(11101), 1,
      anon_sym_new,
    ACTIONS(11075), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11073), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [279155] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4537), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10589), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [279179] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11103), 1,
      anon_sym_delete,
    ACTIONS(11105), 1,
      anon_sym_new,
    ACTIONS(11075), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11073), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [279201] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11101), 1,
      anon_sym_new,
    ACTIONS(11107), 1,
      anon_sym_delete,
    ACTIONS(11075), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11073), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [279223] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11105), 1,
      anon_sym_new,
    ACTIONS(11109), 1,
      anon_sym_delete,
    ACTIONS(11075), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11073), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [279245] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11111), 1,
      anon_sym_delete,
    ACTIONS(11113), 1,
      anon_sym_new,
    ACTIONS(11075), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11073), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [279267] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4537), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10591), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [279291] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11115), 1,
      anon_sym_delete,
    ACTIONS(11117), 1,
      anon_sym_new,
    ACTIONS(11075), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11073), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [279313] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(11119), 1,
      sym_identifier,
    ACTIONS(11121), 1,
      anon_sym_COLON_COLON,
    STATE(3148), 1,
      sym_template_type,
    STATE(7357), 1,
      sym__scope_resolution,
    STATE(3134), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [279343] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4537), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10595), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [279367] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(11123), 1,
      anon_sym_EQ,
    STATE(4289), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    ACTIONS(11089), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [279397] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11127), 1,
      anon_sym_LBRACK,
    STATE(7691), 1,
      sym_gnu_asm_output_operand,
    STATE(9279), 1,
      sym_string_literal,
    ACTIONS(11125), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [279421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 1,
      anon_sym_LBRACK,
    ACTIONS(5111), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [279439] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11101), 1,
      anon_sym_new,
    ACTIONS(11129), 1,
      anon_sym_delete,
    ACTIONS(11075), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11073), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [279461] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(4047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9602), 1,
      sym_identifier,
    STATE(2836), 1,
      sym_template_type,
    STATE(7352), 1,
      sym__scope_resolution,
    STATE(8284), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(9504), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [279491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 1,
      anon_sym_LBRACK,
    ACTIONS(5115), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [279509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 1,
      anon_sym_LBRACK,
    ACTIONS(5123), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [279527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5150), 1,
      anon_sym_LBRACK,
    ACTIONS(5152), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [279545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5125), 1,
      anon_sym_LBRACK,
    ACTIONS(5127), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [279563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5117), 1,
      anon_sym_LBRACK,
    ACTIONS(5119), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [279581] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4537), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10599), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [279605] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11131), 1,
      anon_sym_delete,
    ACTIONS(11133), 1,
      anon_sym_new,
    ACTIONS(11075), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11073), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [279627] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11135), 1,
      anon_sym_delete,
    ACTIONS(11137), 1,
      anon_sym_new,
    ACTIONS(11075), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11073), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [279649] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11137), 1,
      anon_sym_new,
    ACTIONS(11139), 1,
      anon_sym_delete,
    ACTIONS(11075), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11073), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [279671] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4537), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10597), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [279695] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11141), 1,
      anon_sym_delete,
    ACTIONS(11143), 1,
      anon_sym_new,
    ACTIONS(11075), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11073), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [279717] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11147), 1,
      anon_sym_LBRACK,
    STATE(7788), 1,
      sym_gnu_asm_input_operand,
    STATE(9380), 1,
      sym_string_literal,
    ACTIONS(11145), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [279741] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6004), 1,
      anon_sym_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(11149), 1,
      anon_sym_COMMA,
    STATE(2784), 1,
      sym_parameter_list,
    STATE(7808), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(11151), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
    STATE(7230), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [279771] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11153), 1,
      sym_identifier,
    ACTIONS(11155), 1,
      anon_sym_template,
    STATE(2825), 1,
      sym_template_type,
    STATE(2828), 1,
      sym_dependent_type_identifier,
    STATE(2834), 1,
      sym_qualified_type_identifier,
    STATE(7322), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
  [279802] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11159), 1,
      anon_sym_AMP,
    ACTIONS(11161), 2,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(11157), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [279821] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11163), 1,
      sym_identifier,
    STATE(6616), 1,
      sym__scope_resolution,
    STATE(9574), 1,
      sym_qualified_identifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [279848] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(8017), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11165), 1,
      sym_identifier,
    ACTIONS(11167), 1,
      anon_sym_template,
    STATE(3168), 1,
      sym_template_type,
    STATE(3173), 1,
      sym_dependent_type_identifier,
    STATE(3210), 1,
      sym_qualified_type_identifier,
    STATE(7325), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
  [279879] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5105), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11169), 1,
      sym_identifier,
    ACTIONS(11171), 1,
      anon_sym_template,
    STATE(2825), 1,
      sym_template_type,
    STATE(2828), 1,
      sym_dependent_type_identifier,
    STATE(2834), 1,
      sym_qualified_type_identifier,
    STATE(7326), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
  [279910] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11173), 1,
      sym_identifier,
    ACTIONS(11177), 1,
      sym_system_lib_string,
    STATE(9467), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(11175), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [279931] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(7968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11179), 1,
      sym_identifier,
    ACTIONS(11181), 1,
      anon_sym_template,
    STATE(5572), 1,
      sym_template_type,
    STATE(5573), 1,
      sym_dependent_type_identifier,
    STATE(5640), 1,
      sym_qualified_type_identifier,
    STATE(7328), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
  [279962] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(9327), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11183), 1,
      sym_identifier,
    ACTIONS(11185), 1,
      anon_sym_template,
    STATE(3081), 1,
      sym_dependent_type_identifier,
    STATE(3085), 1,
      sym_template_type,
    STATE(3178), 1,
      sym_qualified_type_identifier,
    STATE(7329), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
  [279993] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(7883), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11187), 1,
      sym_identifier,
    ACTIONS(11189), 1,
      anon_sym_template,
    STATE(2235), 1,
      sym_dependent_type_identifier,
    STATE(2237), 1,
      sym_template_type,
    STATE(2294), 1,
      sym_qualified_type_identifier,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
  [280024] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4695), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10573), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [280047] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11191), 1,
      sym_identifier,
    STATE(6616), 1,
      sym__scope_resolution,
    STATE(9364), 1,
      sym_qualified_identifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [280074] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11193), 1,
      sym_identifier,
    STATE(6616), 1,
      sym__scope_resolution,
    STATE(8900), 1,
      sym_qualified_identifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [280101] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(9382), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11195), 1,
      sym_identifier,
    ACTIONS(11197), 1,
      anon_sym_template,
    STATE(4422), 1,
      sym_dependent_type_identifier,
    STATE(4424), 1,
      sym_template_type,
    STATE(4515), 1,
      sym_qualified_type_identifier,
    STATE(7334), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
  [280132] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(9402), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11199), 1,
      sym_identifier,
    ACTIONS(11201), 1,
      anon_sym_template,
    STATE(2425), 1,
      sym_dependent_type_identifier,
    STATE(2426), 1,
      sym_template_type,
    STATE(2579), 1,
      sym_qualified_type_identifier,
    STATE(7335), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
  [280163] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11203), 1,
      sym_identifier,
    STATE(6616), 1,
      sym__scope_resolution,
    STATE(9113), 1,
      sym_qualified_identifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [280190] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(9273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11205), 1,
      sym_identifier,
    ACTIONS(11207), 1,
      anon_sym_template,
    STATE(4625), 1,
      sym_dependent_type_identifier,
    STATE(4650), 1,
      sym_template_type,
    STATE(4691), 1,
      sym_qualified_type_identifier,
    STATE(7337), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
  [280221] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(5206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11209), 1,
      sym_identifier,
    ACTIONS(11211), 1,
      anon_sym_template,
    STATE(2825), 1,
      sym_template_type,
    STATE(2828), 1,
      sym_dependent_type_identifier,
    STATE(2834), 1,
      sym_qualified_type_identifier,
    STATE(7338), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
  [280252] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(9844), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11213), 1,
      sym_identifier,
    ACTIONS(11215), 1,
      anon_sym_template,
    STATE(2664), 1,
      sym_dependent_type_identifier,
    STATE(2665), 1,
      sym_template_type,
    STATE(2705), 1,
      sym_qualified_type_identifier,
    STATE(7339), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
  [280283] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(9307), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11217), 1,
      sym_identifier,
    ACTIONS(11219), 1,
      anon_sym_template,
    STATE(2918), 1,
      sym_dependent_type_identifier,
    STATE(2919), 1,
      sym_template_type,
    STATE(3064), 1,
      sym_qualified_type_identifier,
    STATE(7340), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
  [280314] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11221), 1,
      sym_identifier,
    ACTIONS(11223), 1,
      sym_system_lib_string,
    STATE(9234), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(11175), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [280335] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11225), 1,
      sym_identifier,
    ACTIONS(11227), 1,
      sym_system_lib_string,
    STATE(8935), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(11175), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [280356] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(7925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11229), 1,
      sym_identifier,
    ACTIONS(11231), 1,
      anon_sym_template,
    STATE(2235), 1,
      sym_dependent_type_identifier,
    STATE(2237), 1,
      sym_template_type,
    STATE(2294), 1,
      sym_qualified_type_identifier,
    STATE(7343), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
  [280387] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11233), 1,
      sym_identifier,
    ACTIONS(11235), 1,
      sym_system_lib_string,
    STATE(8917), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(11175), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [280408] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11237), 1,
      sym_identifier,
    STATE(6616), 1,
      sym__scope_resolution,
    STATE(9384), 1,
      sym_qualified_identifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [280435] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(9347), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11239), 1,
      sym_identifier,
    ACTIONS(11241), 1,
      anon_sym_template,
    STATE(3203), 1,
      sym_dependent_type_identifier,
    STATE(3206), 1,
      sym_template_type,
    STATE(3264), 1,
      sym_qualified_type_identifier,
    STATE(7346), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
  [280466] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(9293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11189), 1,
      anon_sym_template,
    ACTIONS(11243), 1,
      sym_identifier,
    STATE(2235), 1,
      sym_dependent_type_identifier,
    STATE(2237), 1,
      sym_template_type,
    STATE(2294), 1,
      sym_qualified_type_identifier,
    STATE(7347), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
  [280497] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(3341), 1,
      sym_template_argument_list,
    ACTIONS(8147), 2,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(5180), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [280520] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(7941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11153), 1,
      sym_identifier,
    ACTIONS(11155), 1,
      anon_sym_template,
    STATE(2825), 1,
      sym_template_type,
    STATE(2828), 1,
      sym_dependent_type_identifier,
    STATE(3836), 1,
      sym_qualified_type_identifier,
    STATE(7349), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
  [280551] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(9450), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11245), 1,
      sym_identifier,
    ACTIONS(11247), 1,
      anon_sym_template,
    STATE(3313), 1,
      sym_dependent_type_identifier,
    STATE(3314), 1,
      sym_template_type,
    STATE(3474), 1,
      sym_qualified_type_identifier,
    STATE(7350), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
  [280582] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6004), 1,
      anon_sym_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    STATE(2784), 1,
      sym_parameter_list,
    STATE(7230), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11249), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [280607] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(4047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11251), 1,
      sym_identifier,
    STATE(2825), 1,
      sym_template_type,
    STATE(2828), 1,
      sym_dependent_type_identifier,
    STATE(2834), 1,
      sym_qualified_type_identifier,
    STATE(7352), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
  [280638] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4695), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10599), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [280661] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11253), 1,
      sym_identifier,
    STATE(6616), 1,
      sym__scope_resolution,
    STATE(9006), 1,
      sym_qualified_identifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [280688] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4695), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10597), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [280711] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4695), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10587), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [280734] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(11121), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11255), 1,
      sym_identifier,
    ACTIONS(11257), 1,
      anon_sym_template,
    STATE(3082), 1,
      sym_dependent_type_identifier,
    STATE(3099), 1,
      sym_template_type,
    STATE(3142), 1,
      sym_qualified_type_identifier,
    STATE(7357), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
  [280765] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11259), 1,
      sym_identifier,
    STATE(6616), 1,
      sym__scope_resolution,
    STATE(9246), 1,
      sym_qualified_identifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [280792] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(9858), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11261), 1,
      sym_identifier,
    ACTIONS(11263), 1,
      anon_sym_template,
    STATE(2235), 1,
      sym_dependent_type_identifier,
    STATE(2237), 1,
      sym_template_type,
    STATE(2294), 1,
      sym_qualified_type_identifier,
    STATE(7359), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
  [280823] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6065), 1,
      anon_sym_AMP,
    ACTIONS(11265), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6067), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_or,
  [280842] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(9434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11167), 1,
      anon_sym_template,
    ACTIONS(11267), 1,
      sym_identifier,
    STATE(3168), 1,
      sym_template_type,
    STATE(3173), 1,
      sym_dependent_type_identifier,
    STATE(3210), 1,
      sym_qualified_type_identifier,
    STATE(7361), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
  [280873] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4695), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10589), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [280896] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4695), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10591), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [280919] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(3341), 1,
      sym_template_argument_list,
    ACTIONS(5138), 2,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(5131), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [280942] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(9609), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11209), 1,
      sym_identifier,
    ACTIONS(11211), 1,
      anon_sym_template,
    STATE(2825), 1,
      sym_template_type,
    STATE(2828), 1,
      sym_dependent_type_identifier,
    STATE(3836), 1,
      sym_qualified_type_identifier,
    STATE(7365), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
  [280973] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11269), 1,
      sym_identifier,
    ACTIONS(11271), 1,
      sym_system_lib_string,
    STATE(9602), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(11175), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [280994] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11273), 1,
      sym_identifier,
    STATE(6616), 1,
      sym__scope_resolution,
    STATE(9151), 1,
      sym_qualified_identifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [281021] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6006), 1,
      anon_sym_AMP,
    ACTIONS(11265), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(11275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(6008), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [281042] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(10357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11277), 1,
      sym_identifier,
    STATE(6616), 1,
      sym__scope_resolution,
    STATE(9666), 1,
      sym_qualified_identifier,
    STATE(9504), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [281069] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4695), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10593), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [281092] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 1,
      anon_sym_template,
    ACTIONS(2183), 1,
      anon_sym_decltype,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11251), 1,
      sym_identifier,
    STATE(2825), 1,
      sym_template_type,
    STATE(2828), 1,
      sym_dependent_type_identifier,
    STATE(3836), 1,
      sym_qualified_type_identifier,
    STATE(7371), 1,
      sym__scope_resolution,
    STATE(9504), 1,
      sym_decltype,
  [281123] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    STATE(4695), 1,
      sym_parameter_list,
    STATE(6687), 1,
      sym__function_declarator_seq,
    ACTIONS(10595), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [281146] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(11008), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11035), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11279), 1,
      aux_sym_preproc_elif_token1,
    STATE(7427), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(9706), 1,
      sym_enumerator,
    STATE(9578), 2,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
  [281172] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9876), 1,
      anon_sym_LBRACK,
    ACTIONS(11281), 1,
      anon_sym_RPAREN,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7213), 1,
      sym__function_declarator_seq,
    STATE(7516), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281198] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6380), 1,
      anon_sym_LBRACK,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(3341), 1,
      sym_template_argument_list,
    ACTIONS(6382), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [281218] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(11283), 1,
      anon_sym_SEMI,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281244] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10976), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11008), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11279), 1,
      aux_sym_preproc_elif_token1,
    STATE(7383), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(9706), 1,
      sym_enumerator,
    STATE(9408), 2,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
  [281270] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(11285), 1,
      anon_sym_SEMI,
    ACTIONS(11287), 1,
      anon_sym_EQ,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(7718), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281296] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(11289), 1,
      anon_sym_SEMI,
    ACTIONS(11291), 1,
      anon_sym_EQ,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(7684), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281322] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10974), 1,
      sym_identifier,
    ACTIONS(11067), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11293), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11295), 1,
      aux_sym_preproc_elif_token1,
    STATE(7434), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(9411), 2,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
  [281346] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(11008), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11279), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11297), 1,
      aux_sym_preproc_if_token2,
    STATE(7392), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(9706), 1,
      sym_enumerator,
    STATE(9324), 2,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
  [281372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11301), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11299), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [281388] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(11008), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11279), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11303), 1,
      aux_sym_preproc_if_token2,
    STATE(7554), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(9706), 1,
      sym_enumerator,
    STATE(9588), 2,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
  [281414] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10647), 1,
      anon_sym_COLON,
    STATE(4687), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(7128), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281440] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11127), 1,
      anon_sym_LBRACK,
    STATE(8295), 1,
      sym_gnu_asm_output_operand,
    STATE(9279), 1,
      sym_string_literal,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [281460] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(11305), 1,
      anon_sym_RPAREN,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11309), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11307), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [281502] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9876), 1,
      anon_sym_LBRACK,
    ACTIONS(11311), 1,
      anon_sym_RPAREN,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7213), 1,
      sym__function_declarator_seq,
    STATE(7516), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281528] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11313), 1,
      sym_identifier,
    ACTIONS(11318), 1,
      aux_sym_preproc_elif_token1,
    STATE(7389), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    ACTIONS(11316), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [281548] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11320), 1,
      sym_identifier,
    ACTIONS(11325), 1,
      aux_sym_preproc_elif_token1,
    STATE(7390), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(9337), 1,
      sym_enumerator,
    ACTIONS(11323), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [281570] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10974), 1,
      sym_identifier,
    ACTIONS(11067), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11295), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11327), 1,
      aux_sym_preproc_if_token2,
    STATE(7528), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(9407), 2,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
  [281594] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(11008), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11279), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11329), 1,
      aux_sym_preproc_if_token2,
    STATE(7554), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(9706), 1,
      sym_enumerator,
    STATE(9401), 2,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
  [281620] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(11331), 1,
      anon_sym_SEMI,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281646] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(11333), 1,
      anon_sym_RPAREN,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281672] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4001), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(11335), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [281694] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(11337), 1,
      anon_sym_SEMI,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281720] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(11339), 1,
      anon_sym_COLON,
    STATE(4687), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(7128), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281746] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(11341), 1,
      anon_sym_SEMI,
    ACTIONS(11343), 1,
      anon_sym_EQ,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(7754), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281772] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(11345), 1,
      anon_sym_SEMI,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281798] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(11347), 1,
      anon_sym_SEMI,
    ACTIONS(11349), 1,
      anon_sym_EQ,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(7744), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281824] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11147), 1,
      anon_sym_LBRACK,
    STATE(8351), 1,
      sym_gnu_asm_input_operand,
    STATE(9380), 1,
      sym_string_literal,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [281844] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(11351), 1,
      anon_sym_SEMI,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281870] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(11353), 1,
      anon_sym_SEMI,
    ACTIONS(11355), 1,
      anon_sym_EQ,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(7882), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281896] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9876), 1,
      anon_sym_LBRACK,
    ACTIONS(10728), 1,
      anon_sym_RPAREN,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7213), 1,
      sym__function_declarator_seq,
    STATE(7516), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281922] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9876), 1,
      anon_sym_LBRACK,
    ACTIONS(10726), 1,
      anon_sym_RPAREN,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7213), 1,
      sym__function_declarator_seq,
    STATE(7516), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281948] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10666), 1,
      anon_sym_COLON,
    STATE(4687), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(7128), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281974] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5138), 1,
      anon_sym_LBRACK,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(6941), 1,
      sym_template_argument_list,
    ACTIONS(5131), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [281996] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(11357), 1,
      anon_sym_SEMI,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [282022] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10671), 1,
      anon_sym_COLON,
    STATE(4687), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(7128), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [282048] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4705), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10573), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [282070] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4705), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10587), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [282092] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10974), 1,
      sym_identifier,
    ACTIONS(11067), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11295), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11359), 1,
      aux_sym_preproc_if_token2,
    STATE(7528), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(9636), 2,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
  [282116] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10687), 1,
      anon_sym_COLON,
    STATE(4687), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(7128), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [282142] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(11361), 1,
      anon_sym_SEMI,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [282168] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9876), 1,
      anon_sym_LBRACK,
    ACTIONS(10677), 1,
      anon_sym_RPAREN,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7213), 1,
      sym__function_declarator_seq,
    STATE(7516), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [282194] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(11363), 1,
      anon_sym_SEMI,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [282220] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10974), 1,
      sym_identifier,
    ACTIONS(11067), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11295), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11365), 1,
      aux_sym_preproc_if_token2,
    STATE(7412), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(9579), 2,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
  [282244] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(8147), 1,
      anon_sym_LBRACK,
    STATE(6941), 1,
      sym_template_argument_list,
    ACTIONS(5180), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [282266] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4705), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10599), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [282288] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4705), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10597), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [282310] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9876), 1,
      anon_sym_LBRACK,
    ACTIONS(10649), 1,
      anon_sym_RPAREN,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7213), 1,
      sym__function_declarator_seq,
    STATE(7516), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [282336] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(11367), 1,
      anon_sym_SEMI,
    ACTIONS(11369), 1,
      anon_sym_EQ,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(7663), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [282362] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(11371), 1,
      anon_sym_SEMI,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [282388] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11375), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11377), 1,
      anon_sym_EQ,
    ACTIONS(11373), 6,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [282406] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4705), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10595), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [282428] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4705), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10593), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [282450] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(11008), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11279), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11379), 1,
      aux_sym_preproc_if_token2,
    STATE(7554), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(9706), 1,
      sym_enumerator,
    STATE(9635), 2,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
  [282476] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(9876), 1,
      anon_sym_LBRACK,
    ACTIONS(10645), 1,
      anon_sym_RPAREN,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7213), 1,
      sym__function_declarator_seq,
    STATE(7516), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [282502] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(11381), 1,
      anon_sym_SEMI,
    ACTIONS(11383), 1,
      anon_sym_EQ,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(7702), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [282528] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(11385), 1,
      anon_sym_SEMI,
    ACTIONS(11387), 1,
      anon_sym_EQ,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(7860), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [282554] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(11389), 1,
      anon_sym_SEMI,
    ACTIONS(11391), 1,
      anon_sym_EQ,
    STATE(2036), 1,
      sym_template_argument_list,
    STATE(7881), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [282580] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(11393), 1,
      anon_sym_SEMI,
    STATE(4468), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [282606] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4705), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10589), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [282628] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10974), 1,
      sym_identifier,
    ACTIONS(11067), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11295), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11395), 1,
      aux_sym_preproc_if_token2,
    STATE(7528), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(9589), 2,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
  [282652] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    ACTIONS(10685), 1,
      anon_sym_COLON,
    STATE(4687), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(7128), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [282678] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4705), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10591), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [282700] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5216), 1,
      anon_sym_LBRACE,
    ACTIONS(11397), 1,
      sym_identifier,
    ACTIONS(11399), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11401), 1,
      anon_sym_inline,
    STATE(935), 1,
      sym_declaration_list,
    STATE(8654), 1,
      sym_nested_namespace_specifier,
    STATE(8805), 1,
      sym__namespace_specifier,
  [282725] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6004), 1,
      anon_sym_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(11403), 1,
      anon_sym_RPAREN,
    STATE(2784), 1,
      sym_parameter_list,
    STATE(7230), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [282748] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4540), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10589), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [282769] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11405), 1,
      anon_sym_LBRACK,
    ACTIONS(11407), 1,
      anon_sym_EQ,
    ACTIONS(11409), 1,
      anon_sym_DOT,
    STATE(7485), 4,
      sym_subscript_designator,
      sym_subscript_range_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [282788] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5208), 1,
      anon_sym_LBRACE,
    ACTIONS(11399), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11401), 1,
      anon_sym_inline,
    ACTIONS(11411), 1,
      sym_identifier,
    STATE(1013), 1,
      sym_declaration_list,
    STATE(8661), 1,
      sym_nested_namespace_specifier,
    STATE(8805), 1,
      sym__namespace_specifier,
  [282813] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6004), 1,
      anon_sym_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(11413), 1,
      anon_sym_RPAREN,
    STATE(2784), 1,
      sym_parameter_list,
    STATE(7230), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [282836] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10591), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [282857] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6004), 1,
      anon_sym_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(11415), 1,
      anon_sym_RPAREN,
    STATE(2784), 1,
      sym_parameter_list,
    STATE(7230), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [282880] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5208), 1,
      anon_sym_LBRACE,
    ACTIONS(11399), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11401), 1,
      anon_sym_inline,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(1049), 1,
      sym_declaration_list,
    STATE(8781), 1,
      sym_nested_namespace_specifier,
    STATE(8805), 1,
      sym__namespace_specifier,
  [282905] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6004), 1,
      anon_sym_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(11419), 1,
      anon_sym_RPAREN,
    STATE(2784), 1,
      sym_parameter_list,
    STATE(7230), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [282928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4585), 1,
      anon_sym_AMP,
    ACTIONS(4583), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [282943] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10599), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [282964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11423), 1,
      anon_sym_AMP,
    ACTIONS(11421), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [282979] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LBRACE,
    ACTIONS(11399), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11401), 1,
      anon_sym_inline,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(431), 1,
      sym_declaration_list,
    STATE(8672), 1,
      sym_nested_namespace_specifier,
    STATE(8805), 1,
      sym__namespace_specifier,
  [283004] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10087), 1,
      anon_sym_LBRACK,
    STATE(4283), 1,
      sym_parameter_list,
    STATE(7067), 1,
      sym__function_declarator_seq,
    STATE(6939), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [283027] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5214), 1,
      anon_sym_LBRACE,
    ACTIONS(11399), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11401), 1,
      anon_sym_inline,
    ACTIONS(11427), 1,
      sym_identifier,
    STATE(928), 1,
      sym_declaration_list,
    STATE(8669), 1,
      sym_nested_namespace_specifier,
    STATE(8805), 1,
      sym__namespace_specifier,
  [283052] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6004), 1,
      anon_sym_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(11429), 1,
      anon_sym_RPAREN,
    STATE(2784), 1,
      sym_parameter_list,
    STATE(7230), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [283075] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11433), 1,
      anon_sym_COMMA,
    ACTIONS(11435), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11431), 5,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [283092] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4540), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10573), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [283113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6276), 1,
      anon_sym_AMP,
    ACTIONS(6278), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [283128] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6004), 1,
      anon_sym_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(11437), 1,
      anon_sym_RPAREN,
    STATE(2784), 1,
      sym_parameter_list,
    STATE(7230), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [283151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [283166] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LBRACE,
    ACTIONS(11399), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11401), 1,
      anon_sym_inline,
    ACTIONS(11439), 1,
      sym_identifier,
    STATE(419), 1,
      sym_declaration_list,
    STATE(8645), 1,
      sym_nested_namespace_specifier,
    STATE(8805), 1,
      sym__namespace_specifier,
  [283191] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10573), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [283212] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    STATE(2812), 1,
      sym_template_argument_list,
    STATE(8020), 2,
      sym_argument_list,
      sym_initializer_list,
  [283235] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5210), 1,
      anon_sym_LBRACE,
    ACTIONS(11399), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11401), 1,
      anon_sym_inline,
    ACTIONS(11441), 1,
      sym_identifier,
    STATE(612), 1,
      sym_declaration_list,
    STATE(8410), 1,
      sym_nested_namespace_specifier,
    STATE(8805), 1,
      sym__namespace_specifier,
  [283260] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 1,
      anon_sym_LBRACK,
    ACTIONS(6142), 1,
      anon_sym_COLON,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    STATE(2784), 1,
      sym_parameter_list,
    STATE(7515), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [283283] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4540), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10587), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [283304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6318), 1,
      anon_sym_AMP,
    ACTIONS(6320), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [283319] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5998), 1,
      anon_sym_COLON,
    ACTIONS(6004), 1,
      anon_sym_LBRACK,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    STATE(2784), 1,
      sym_parameter_list,
    STATE(7515), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [283342] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4540), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10591), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [283363] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10589), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [283384] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4540), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10597), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [283405] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10593), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [283426] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6004), 1,
      anon_sym_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(11443), 1,
      anon_sym_RPAREN,
    STATE(2784), 1,
      sym_parameter_list,
    STATE(7230), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [283449] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 1,
      anon_sym_LBRACK,
    ACTIONS(6071), 1,
      anon_sym_COLON,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    STATE(2784), 1,
      sym_parameter_list,
    STATE(7515), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [283472] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10597), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [283493] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4540), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10599), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [283514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11447), 1,
      anon_sym_AMP,
    ACTIONS(11445), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [283529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11451), 1,
      anon_sym_AMP,
    ACTIONS(11449), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [283544] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5214), 1,
      anon_sym_LBRACE,
    ACTIONS(11399), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11401), 1,
      anon_sym_inline,
    ACTIONS(11453), 1,
      sym_identifier,
    STATE(871), 1,
      sym_declaration_list,
    STATE(8586), 1,
      sym_nested_namespace_specifier,
    STATE(8805), 1,
      sym__namespace_specifier,
  [283569] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10595), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [283590] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4540), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10595), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [283611] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6004), 1,
      anon_sym_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(11455), 1,
      anon_sym_RPAREN,
    STATE(2784), 1,
      sym_parameter_list,
    STATE(7230), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [283634] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4540), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10593), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [283655] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 1,
      anon_sym_LBRACK,
    ACTIONS(6150), 1,
      anon_sym_COLON,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    STATE(2784), 1,
      sym_parameter_list,
    STATE(7515), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [283678] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(10587), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [283699] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6004), 1,
      anon_sym_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(11457), 1,
      anon_sym_RPAREN,
    STATE(2784), 1,
      sym_parameter_list,
    STATE(7230), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [283722] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11459), 1,
      anon_sym_LBRACK,
    ACTIONS(11462), 1,
      anon_sym_EQ,
    ACTIONS(11464), 1,
      anon_sym_DOT,
    STATE(7485), 4,
      sym_subscript_designator,
      sym_subscript_range_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [283741] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6380), 1,
      anon_sym_LBRACK,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(6941), 1,
      sym_template_argument_list,
    ACTIONS(6382), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [283760] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5216), 1,
      anon_sym_LBRACE,
    ACTIONS(11399), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11401), 1,
      anon_sym_inline,
    ACTIONS(11467), 1,
      sym_identifier,
    STATE(979), 1,
      sym_declaration_list,
    STATE(8602), 1,
      sym_nested_namespace_specifier,
    STATE(8805), 1,
      sym__namespace_specifier,
  [283785] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6004), 1,
      anon_sym_LBRACK,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(11469), 1,
      anon_sym_RPAREN,
    STATE(2784), 1,
      sym_parameter_list,
    STATE(7230), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [283808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11159), 1,
      anon_sym_AMP,
    ACTIONS(11157), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [283823] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5210), 1,
      anon_sym_LBRACE,
    ACTIONS(11399), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11401), 1,
      anon_sym_inline,
    ACTIONS(11471), 1,
      sym_identifier,
    STATE(611), 1,
      sym_declaration_list,
    STATE(8409), 1,
      sym_nested_namespace_specifier,
    STATE(8805), 1,
      sym__namespace_specifier,
  [283848] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11473), 1,
      anon_sym_LPAREN2,
    STATE(7491), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11475), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [283864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11478), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11480), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [283878] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9916), 1,
      anon_sym_try,
    ACTIONS(10905), 1,
      anon_sym_LBRACE,
    ACTIONS(11482), 1,
      anon_sym_SEMI,
    ACTIONS(11484), 1,
      anon_sym_EQ,
    STATE(2312), 2,
      sym_compound_statement,
      sym_try_statement,
  [283898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11486), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11488), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [283912] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1117), 1,
      anon_sym_LBRACE,
    ACTIONS(10165), 1,
      anon_sym_try,
    ACTIONS(11490), 1,
      anon_sym_SEMI,
    ACTIONS(11492), 1,
      anon_sym_EQ,
    STATE(988), 2,
      sym_compound_statement,
      sym_try_statement,
  [283932] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(10221), 1,
      anon_sym_try,
    ACTIONS(11494), 1,
      anon_sym_SEMI,
    ACTIONS(11496), 1,
      anon_sym_EQ,
    STATE(394), 2,
      sym_compound_statement,
      sym_try_statement,
  [283952] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11498), 1,
      anon_sym_LPAREN2,
    STATE(7546), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11500), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [283968] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11502), 1,
      anon_sym_LPAREN2,
    STATE(7491), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11500), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [283984] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11504), 1,
      anon_sym_LPAREN2,
    STATE(7491), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11500), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [284000] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11506), 1,
      anon_sym_LPAREN2,
    STATE(7499), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11500), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [284016] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9882), 1,
      anon_sym_try,
    ACTIONS(10875), 1,
      anon_sym_LBRACE,
    ACTIONS(11508), 1,
      anon_sym_SEMI,
    ACTIONS(11510), 1,
      anon_sym_EQ,
    STATE(2584), 2,
      sym_compound_statement,
      sym_try_statement,
  [284036] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(10955), 1,
      anon_sym_LBRACK,
    STATE(7217), 1,
      sym_template_argument_list,
    ACTIONS(10953), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [284054] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(10943), 1,
      anon_sym_LBRACK,
    STATE(7257), 1,
      sym_template_argument_list,
    ACTIONS(10939), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [284072] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1117), 1,
      anon_sym_LBRACE,
    ACTIONS(10165), 1,
      anon_sym_try,
    ACTIONS(11512), 1,
      anon_sym_SEMI,
    ACTIONS(11514), 1,
      anon_sym_EQ,
    STATE(964), 2,
      sym_compound_statement,
      sym_try_statement,
  [284092] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym___attribute__,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6479), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6670), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [284110] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11516), 1,
      anon_sym_LPAREN2,
    STATE(7491), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11500), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [284126] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(801), 1,
      anon_sym_LBRACE,
    ACTIONS(10117), 1,
      anon_sym_try,
    ACTIONS(11518), 1,
      anon_sym_SEMI,
    ACTIONS(11520), 1,
      anon_sym_EQ,
    STATE(966), 2,
      sym_compound_statement,
      sym_try_statement,
  [284146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11522), 1,
      anon_sym_LPAREN2,
    STATE(7506), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11500), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [284162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11524), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11526), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [284176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11528), 1,
      anon_sym_LPAREN2,
    STATE(7491), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11500), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [284192] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9916), 1,
      anon_sym_try,
    ACTIONS(10905), 1,
      anon_sym_LBRACE,
    ACTIONS(11530), 1,
      anon_sym_SEMI,
    ACTIONS(11532), 1,
      anon_sym_EQ,
    STATE(2356), 2,
      sym_compound_statement,
      sym_try_statement,
  [284212] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11534), 1,
      anon_sym_LPAREN2,
    STATE(7510), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11500), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [284228] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9882), 1,
      anon_sym_try,
    ACTIONS(10875), 1,
      anon_sym_LBRACE,
    ACTIONS(11536), 1,
      anon_sym_SEMI,
    ACTIONS(11538), 1,
      anon_sym_EQ,
    STATE(2581), 2,
      sym_compound_statement,
      sym_try_statement,
  [284248] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9898), 1,
      anon_sym_try,
    ACTIONS(10897), 1,
      anon_sym_LBRACE,
    ACTIONS(11540), 1,
      anon_sym_SEMI,
    ACTIONS(11542), 1,
      anon_sym_EQ,
    STATE(2236), 2,
      sym_compound_statement,
      sym_try_statement,
  [284268] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6162), 1,
      anon_sym_LBRACK,
    ACTIONS(8158), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6164), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(6669), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [284286] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10951), 1,
      anon_sym_LBRACK,
    ACTIONS(10949), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(6822), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [284304] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9938), 1,
      anon_sym_try,
    ACTIONS(10760), 1,
      anon_sym_LBRACE,
    ACTIONS(11544), 1,
      anon_sym_SEMI,
    ACTIONS(11546), 1,
      anon_sym_EQ,
    STATE(2480), 2,
      sym_compound_statement,
      sym_try_statement,
  [284324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11548), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11550), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [284338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11325), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11323), 5,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [284352] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11552), 1,
      anon_sym_LPAREN2,
    STATE(7491), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11500), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [284368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11554), 1,
      anon_sym_LPAREN2,
    STATE(7498), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11500), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [284384] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    STATE(6330), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6621), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [284402] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4540), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(11089), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [284422] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11556), 1,
      anon_sym_LPAREN2,
    STATE(7520), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11500), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [284438] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_LBRACE,
    ACTIONS(10155), 1,
      anon_sym_try,
    ACTIONS(11558), 1,
      anon_sym_SEMI,
    ACTIONS(11560), 1,
      anon_sym_EQ,
    STATE(614), 2,
      sym_compound_statement,
      sym_try_statement,
  [284458] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9938), 1,
      anon_sym_try,
    ACTIONS(10760), 1,
      anon_sym_LBRACE,
    ACTIONS(11562), 1,
      anon_sym_SEMI,
    ACTIONS(11564), 1,
      anon_sym_EQ,
    STATE(2553), 2,
      sym_compound_statement,
      sym_try_statement,
  [284478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11566), 1,
      anon_sym_EQ,
    ACTIONS(11373), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_identifier,
  [284492] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11568), 1,
      sym_identifier,
    STATE(7528), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    ACTIONS(11316), 3,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [284508] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(10187), 1,
      anon_sym_try,
    ACTIONS(11571), 1,
      anon_sym_SEMI,
    ACTIONS(11573), 1,
      anon_sym_EQ,
    STATE(1042), 2,
      sym_compound_statement,
      sym_try_statement,
  [284528] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11575), 1,
      anon_sym_LPAREN2,
    STATE(7491), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11500), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [284544] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(10187), 1,
      anon_sym_try,
    ACTIONS(11577), 1,
      anon_sym_SEMI,
    ACTIONS(11579), 1,
      anon_sym_EQ,
    STATE(1009), 2,
      sym_compound_statement,
      sym_try_statement,
  [284564] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
    ACTIONS(11089), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [284584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11581), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11583), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [284598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11524), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11526), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [284612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11053), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11585), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [284626] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11587), 1,
      anon_sym_LPAREN2,
    STATE(7530), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11500), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [284642] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(801), 1,
      anon_sym_LBRACE,
    ACTIONS(10117), 1,
      anon_sym_try,
    ACTIONS(11589), 1,
      anon_sym_SEMI,
    ACTIONS(11591), 1,
      anon_sym_EQ,
    STATE(886), 2,
      sym_compound_statement,
      sym_try_statement,
  [284662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11593), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11595), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [284676] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_LBRACE,
    ACTIONS(10155), 1,
      anon_sym_try,
    ACTIONS(11597), 1,
      anon_sym_SEMI,
    ACTIONS(11599), 1,
      anon_sym_EQ,
    STATE(578), 2,
      sym_compound_statement,
      sym_try_statement,
  [284696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(9608), 1,
      sym_string_literal,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [284710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11601), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11603), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [284724] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11605), 1,
      anon_sym_LPAREN2,
    STATE(7543), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11500), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [284740] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11607), 1,
      anon_sym_LPAREN2,
    STATE(7491), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11500), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [284756] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9898), 1,
      anon_sym_try,
    ACTIONS(10897), 1,
      anon_sym_LBRACE,
    ACTIONS(11609), 1,
      anon_sym_SEMI,
    ACTIONS(11611), 1,
      anon_sym_EQ,
    STATE(2161), 2,
      sym_compound_statement,
      sym_try_statement,
  [284776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11593), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11595), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [284790] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11613), 1,
      anon_sym_LPAREN2,
    STATE(7491), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11500), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [284806] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(10221), 1,
      anon_sym_try,
    ACTIONS(11615), 1,
      anon_sym_SEMI,
    ACTIONS(11617), 1,
      anon_sym_EQ,
    STATE(426), 2,
      sym_compound_statement,
      sym_try_statement,
  [284826] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6380), 1,
      anon_sym_LBRACK,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(4711), 1,
      sym_template_argument_list,
    ACTIONS(6382), 3,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [284844] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11619), 1,
      anon_sym_LPAREN2,
    STATE(7491), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11500), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [284860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(9642), 1,
      sym_string_literal,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [284874] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6380), 1,
      anon_sym_LBRACK,
    ACTIONS(7733), 1,
      anon_sym_LT,
    STATE(4711), 1,
      sym_template_argument_list,
    ACTIONS(6382), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [284892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11621), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11623), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [284906] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11625), 1,
      anon_sym_LPAREN2,
    STATE(7549), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11500), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [284922] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11320), 1,
      sym_identifier,
    STATE(7554), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(9706), 1,
      sym_enumerator,
    ACTIONS(11323), 3,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [284940] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6380), 1,
      anon_sym_LBRACK,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(5147), 1,
      sym_template_argument_list,
    ACTIONS(6382), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [284957] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(11627), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(2854), 1,
      sym_template_method,
    STATE(8697), 1,
      sym_operator_name,
  [284976] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11399), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11401), 1,
      anon_sym_inline,
    ACTIONS(11629), 1,
      sym_identifier,
    STATE(8805), 1,
      sym__namespace_specifier,
    STATE(9149), 1,
      sym_nested_namespace_specifier,
  [284995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11631), 1,
      anon_sym_COMMA,
    ACTIONS(11431), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_identifier,
  [285008] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    ACTIONS(11633), 1,
      anon_sym_RPAREN,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
  [285027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11635), 1,
      anon_sym_EQ,
    ACTIONS(10524), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [285040] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    ACTIONS(11637), 1,
      anon_sym_RPAREN,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
  [285059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11641), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11639), 4,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_template,
  [285072] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11399), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11401), 1,
      anon_sym_inline,
    ACTIONS(11643), 1,
      sym_identifier,
    STATE(8805), 1,
      sym__namespace_specifier,
    STATE(9358), 1,
      sym_nested_namespace_specifier,
  [285091] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10573), 1,
      anon_sym_COLON,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4696), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
  [285110] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11645), 1,
      anon_sym_SEMI,
    STATE(7574), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8824), 1,
      sym_attribute_specifier,
  [285129] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    ACTIONS(11647), 1,
      anon_sym_RPAREN,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
  [285148] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(11649), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(4171), 1,
      sym_template_method,
    STATE(8614), 1,
      sym_operator_name,
  [285167] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11651), 1,
      anon_sym_SEMI,
    STATE(7575), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8822), 1,
      sym_attribute_specifier,
  [285186] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11653), 1,
      anon_sym_SEMI,
    STATE(7689), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8820), 1,
      sym_attribute_specifier,
  [285205] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(2812), 1,
      sym_template_argument_list,
    ACTIONS(6330), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
  [285222] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11399), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11401), 1,
      anon_sym_inline,
    ACTIONS(11655), 1,
      sym_identifier,
    STATE(8148), 1,
      sym__namespace_specifier,
    STATE(8525), 1,
      sym_nested_namespace_specifier,
  [285241] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(9048), 1,
      anon_sym_RPAREN,
    STATE(2982), 1,
      sym_argument_list,
    STATE(4660), 1,
      sym_initializer_list,
  [285260] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11657), 1,
      anon_sym_SEMI,
    STATE(7577), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8810), 1,
      sym_attribute_specifier,
  [285279] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11659), 1,
      anon_sym_SEMI,
    STATE(7689), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8807), 1,
      sym_attribute_specifier,
  [285298] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11661), 1,
      anon_sym_SEMI,
    STATE(7689), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8804), 1,
      sym_attribute_specifier,
  [285317] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11663), 1,
      anon_sym_SEMI,
    STATE(7689), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8798), 1,
      sym_attribute_specifier,
  [285336] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11665), 1,
      anon_sym_SEMI,
    STATE(7689), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8797), 1,
      sym_attribute_specifier,
  [285355] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11667), 1,
      anon_sym_SEMI,
    STATE(7689), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8818), 1,
      sym_attribute_specifier,
  [285374] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10595), 1,
      anon_sym_COLON,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4696), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
  [285393] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10593), 1,
      anon_sym_COLON,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4696), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
  [285412] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11669), 1,
      anon_sym_SEMI,
    STATE(7689), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8814), 1,
      sym_attribute_specifier,
  [285431] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11399), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11401), 1,
      anon_sym_inline,
    ACTIONS(11671), 1,
      sym_identifier,
    STATE(8805), 1,
      sym__namespace_specifier,
    STATE(9186), 1,
      sym_nested_namespace_specifier,
  [285450] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11673), 1,
      anon_sym_SEMI,
    STATE(7689), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8791), 1,
      sym_attribute_specifier,
  [285469] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10577), 1,
      sym_identifier,
    ACTIONS(11675), 1,
      aux_sym_preproc_if_token2,
    STATE(7454), 1,
      sym_enumerator,
    STATE(7645), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(7647), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
  [285488] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11677), 1,
      anon_sym_SEMI,
    STATE(7689), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8790), 1,
      sym_attribute_specifier,
  [285507] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    ACTIONS(11681), 1,
      anon_sym_COLON_COLON,
    STATE(8583), 1,
      sym_argument_list,
    ACTIONS(11679), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [285524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11683), 2,
      anon_sym_class,
      anon_sym_typename,
    STATE(8560), 3,
      sym_type_parameter_declaration,
      sym_variadic_type_parameter_declaration,
      sym_optional_type_parameter_declaration,
  [285537] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11685), 1,
      anon_sym_SEMI,
    STATE(7578), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8789), 1,
      sym_attribute_specifier,
  [285556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11687), 1,
      anon_sym_EQ,
    ACTIONS(10524), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [285569] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10597), 1,
      anon_sym_COLON,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4696), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
  [285588] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11399), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11401), 1,
      anon_sym_inline,
    ACTIONS(11655), 1,
      sym_identifier,
    STATE(8053), 1,
      sym__namespace_specifier,
    STATE(8723), 1,
      sym_nested_namespace_specifier,
  [285607] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11689), 1,
      anon_sym_SEMI,
    STATE(7614), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9347), 1,
      sym_attribute_specifier,
  [285626] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10599), 1,
      anon_sym_COLON,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4696), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
  [285645] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11691), 1,
      anon_sym_SEMI,
    STATE(7613), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9349), 1,
      sym_attribute_specifier,
  [285664] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10587), 1,
      anon_sym_COLON,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4696), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
  [285683] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11693), 1,
      anon_sym_SEMI,
    STATE(7689), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9353), 1,
      sym_attribute_specifier,
  [285702] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(11695), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(4259), 1,
      sym_template_method,
    STATE(8481), 1,
      sym_operator_name,
  [285721] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11697), 1,
      anon_sym_SEMI,
    STATE(7689), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9351), 1,
      sym_attribute_specifier,
  [285740] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11699), 1,
      anon_sym_SEMI,
    STATE(7689), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9352), 1,
      sym_attribute_specifier,
  [285759] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11399), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11401), 1,
      anon_sym_inline,
    ACTIONS(11701), 1,
      sym_identifier,
    STATE(8805), 1,
      sym__namespace_specifier,
    STATE(8905), 1,
      sym_nested_namespace_specifier,
  [285778] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11703), 1,
      anon_sym_SEMI,
    STATE(7689), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8923), 1,
      sym_attribute_specifier,
  [285797] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11705), 1,
      anon_sym_SEMI,
    STATE(7583), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8930), 1,
      sym_attribute_specifier,
  [285816] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11399), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11401), 1,
      anon_sym_inline,
    ACTIONS(11707), 1,
      sym_identifier,
    STATE(8805), 1,
      sym__namespace_specifier,
    STATE(8943), 1,
      sym_nested_namespace_specifier,
  [285835] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11709), 1,
      anon_sym_SEMI,
    STATE(7585), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8966), 1,
      sym_attribute_specifier,
  [285854] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6380), 1,
      anon_sym_LBRACK,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(4634), 1,
      sym_template_argument_list,
    ACTIONS(6382), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [285871] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11711), 1,
      anon_sym_SEMI,
    STATE(7689), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9344), 1,
      sym_attribute_specifier,
  [285890] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11713), 1,
      anon_sym_SEMI,
    STATE(7689), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9338), 1,
      sym_attribute_specifier,
  [285909] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    ACTIONS(9158), 1,
      anon_sym_RPAREN,
    STATE(2982), 1,
      sym_argument_list,
    STATE(4660), 1,
      sym_initializer_list,
  [285928] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(11627), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(2854), 1,
      sym_template_method,
    STATE(8680), 1,
      sym_operator_name,
  [285947] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(11715), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(3794), 1,
      sym_template_method,
    STATE(8551), 1,
      sym_operator_name,
  [285966] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11717), 1,
      anon_sym_SEMI,
    STATE(7596), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9333), 1,
      sym_attribute_specifier,
  [285985] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10589), 1,
      anon_sym_COLON,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4696), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
  [286004] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11719), 1,
      anon_sym_SEMI,
    STATE(7689), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9481), 1,
      sym_attribute_specifier,
  [286023] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11721), 1,
      anon_sym_SEMI,
    STATE(7689), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9478), 1,
      sym_attribute_specifier,
  [286042] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11723), 1,
      anon_sym_SEMI,
    STATE(7689), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9311), 1,
      sym_attribute_specifier,
  [286061] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11725), 1,
      anon_sym_SEMI,
    STATE(7689), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9598), 1,
      sym_attribute_specifier,
  [286080] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11727), 1,
      anon_sym_SEMI,
    STATE(7606), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9307), 1,
      sym_attribute_specifier,
  [286099] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11729), 1,
      anon_sym_SEMI,
    STATE(7616), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9468), 1,
      sym_attribute_specifier,
  [286118] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11731), 1,
      anon_sym_SEMI,
    STATE(7607), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9303), 1,
      sym_attribute_specifier,
  [286137] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_operator,
    ACTIONS(11733), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(2854), 1,
      sym_template_method,
    STATE(8479), 1,
      sym_operator_name,
  [286156] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    ACTIONS(11735), 1,
      anon_sym_RPAREN,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
  [286175] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10591), 1,
      anon_sym_COLON,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4696), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
  [286194] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9140), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9144), 1,
      anon_sym_EQ,
    ACTIONS(11737), 1,
      sym_identifier,
    ACTIONS(9142), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [286211] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8201), 1,
      sym_auto,
    ACTIONS(8203), 1,
      anon_sym_decltype,
    STATE(3115), 1,
      sym_decltype_auto,
    ACTIONS(11739), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [286228] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    ACTIONS(11741), 1,
      anon_sym_SEMI,
    STATE(7689), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9595), 1,
      sym_attribute_specifier,
  [286247] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8201), 1,
      sym_auto,
    ACTIONS(8203), 1,
      anon_sym_decltype,
    STATE(3115), 1,
      sym_decltype_auto,
    ACTIONS(11743), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [286264] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(11745), 1,
      anon_sym_SEMI,
    STATE(7796), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [286278] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11747), 1,
      anon_sym_COMMA,
    STATE(7707), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(11749), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [286292] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10514), 1,
      anon_sym_LBRACE,
    STATE(2050), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [286306] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11751), 1,
      anon_sym_EQ,
    STATE(7640), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [286320] = 4,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11753), 1,
      anon_sym_SQUOTE,
    STATE(7738), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11755), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [286334] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(11757), 1,
      anon_sym_SEMI,
    STATE(7654), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [286348] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(11759), 1,
      anon_sym_SEMI,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [286362] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6208), 1,
      anon_sym_LBRACE,
    STATE(3180), 1,
      sym_field_declaration_list,
    STATE(8524), 1,
      sym_base_class_clause,
  [286378] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11387), 1,
      anon_sym_EQ,
    STATE(7860), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [286392] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11761), 1,
      anon_sym_DQUOTE,
    ACTIONS(11763), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11765), 1,
      sym_escape_sequence,
    STATE(7728), 1,
      aux_sym_string_literal_repeat1,
  [286408] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10577), 1,
      sym_identifier,
    ACTIONS(11767), 1,
      aux_sym_preproc_if_token2,
    STATE(7645), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [286422] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    STATE(8299), 1,
      sym_compound_statement,
    STATE(8504), 1,
      sym_field_initializer_list,
  [286438] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(11675), 1,
      aux_sym_preproc_if_token2,
    STATE(7647), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(9337), 1,
      sym_enumerator,
  [286454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11769), 1,
      anon_sym_EQ,
    STATE(6822), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [286468] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11391), 1,
      anon_sym_EQ,
    STATE(7881), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [286482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(11771), 1,
      anon_sym_SEMI,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [286496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10522), 1,
      anon_sym_LBRACE,
    STATE(3814), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [286510] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10459), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [286524] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10577), 1,
      sym_identifier,
    ACTIONS(11773), 1,
      aux_sym_preproc_if_token2,
    STATE(7389), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [286538] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11763), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11765), 1,
      sym_escape_sequence,
    ACTIONS(11775), 1,
      anon_sym_DQUOTE,
    STATE(7728), 1,
      aux_sym_string_literal_repeat1,
  [286554] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(11777), 1,
      aux_sym_preproc_if_token2,
    STATE(7390), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(9337), 1,
      sym_enumerator,
  [286570] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11779), 1,
      anon_sym_EQ,
    STATE(6822), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [286584] = 4,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11781), 1,
      anon_sym_SQUOTE,
    STATE(7738), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11755), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [286598] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6208), 1,
      anon_sym_LBRACE,
    STATE(3196), 1,
      sym_field_declaration_list,
    STATE(8546), 1,
      sym_base_class_clause,
  [286614] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11783), 1,
      anon_sym_DQUOTE,
    ACTIONS(11785), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11787), 1,
      sym_escape_sequence,
    STATE(7646), 1,
      aux_sym_string_literal_repeat1,
  [286630] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10514), 1,
      anon_sym_LBRACE,
    STATE(2044), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [286644] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11789), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11791), 1,
      anon_sym_LPAREN,
    ACTIONS(11793), 1,
      sym_preproc_arg,
    STATE(8498), 1,
      sym_preproc_params,
  [286660] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(11795), 1,
      anon_sym_SEMI,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [286674] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11799), 1,
      anon_sym_GT2,
    STATE(8281), 1,
      aux_sym_template_argument_list_repeat1,
  [286690] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11369), 1,
      anon_sym_EQ,
    STATE(7663), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [286704] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11801), 1,
      anon_sym_DQUOTE,
    ACTIONS(11803), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11805), 1,
      sym_escape_sequence,
    STATE(7915), 1,
      aux_sym_string_literal_repeat1,
  [286720] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(11807), 1,
      anon_sym_SEMI,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [286734] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11809), 1,
      anon_sym_DQUOTE,
    ACTIONS(11811), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11813), 1,
      sym_escape_sequence,
    STATE(7807), 1,
      aux_sym_string_literal_repeat1,
  [286750] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(11815), 1,
      anon_sym_SEMI,
    STATE(7642), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [286764] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11817), 1,
      anon_sym_DQUOTE,
    ACTIONS(11819), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11821), 1,
      sym_escape_sequence,
    STATE(7852), 1,
      aux_sym_string_literal_repeat1,
  [286780] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10459), 1,
      anon_sym_LBRACE,
    STATE(2998), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [286794] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11823), 1,
      anon_sym_EQ,
    STATE(6822), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [286808] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(11825), 1,
      anon_sym_SEMI,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [286822] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10540), 1,
      anon_sym_LBRACE,
    STATE(5152), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [286836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(11827), 1,
      anon_sym_SEMI,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [286850] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(11829), 1,
      anon_sym_SEMI,
    STATE(7664), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [286864] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10540), 1,
      anon_sym_LBRACE,
    STATE(5131), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [286878] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(11831), 1,
      anon_sym_SEMI,
    STATE(2036), 1,
      sym_template_argument_list,
  [286894] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11833), 1,
      anon_sym___except,
    ACTIONS(11835), 1,
      anon_sym___finally,
    STATE(861), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [286908] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11837), 1,
      anon_sym_SEMI,
    ACTIONS(11839), 1,
      anon_sym_DASH_GT,
    ACTIONS(11841), 1,
      anon_sym_noexcept,
    STATE(9388), 1,
      sym_trailing_return_type,
  [286924] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11843), 1,
      anon_sym_GT2,
    STATE(8162), 1,
      aux_sym_template_argument_list_repeat1,
  [286940] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10530), 1,
      anon_sym_LBRACE,
    STATE(5186), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [286954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [286964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [286974] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11847), 1,
      anon_sym_GT2,
    STATE(8190), 1,
      aux_sym_template_argument_list_repeat1,
  [286990] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(7891), 1,
      anon_sym_LBRACE,
    STATE(4755), 1,
      sym_field_declaration_list,
    STATE(8618), 1,
      sym_base_class_clause,
  [287006] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11849), 1,
      anon_sym_DQUOTE,
    ACTIONS(11851), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11853), 1,
      sym_escape_sequence,
    STATE(7700), 1,
      aux_sym_string_literal_repeat1,
  [287022] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11791), 1,
      anon_sym_LPAREN,
    ACTIONS(11855), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11857), 1,
      sym_preproc_arg,
    STATE(8441), 1,
      sym_preproc_params,
  [287038] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(11859), 1,
      anon_sym_SEMI,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [287052] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 1,
      anon_sym_LT,
    ACTIONS(11861), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(7587), 1,
      sym_template_parameter_list,
  [287068] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11863), 1,
      anon_sym_DQUOTE,
    ACTIONS(11865), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11867), 1,
      sym_escape_sequence,
    STATE(7813), 1,
      aux_sym_string_literal_repeat1,
  [287084] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(11869), 1,
      anon_sym_SEMI,
    STATE(7888), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [287098] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11871), 1,
      anon_sym_EQ,
    STATE(6822), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [287112] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6477), 1,
      anon_sym_LBRACE,
    STATE(3315), 1,
      sym_field_declaration_list,
    STATE(8592), 1,
      sym_base_class_clause,
  [287128] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    STATE(5700), 1,
      sym_field_declaration_list,
    STATE(8519), 1,
      sym_base_class_clause,
  [287144] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(11873), 1,
      anon_sym_SEMI,
    STATE(7666), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [287158] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10437), 1,
      anon_sym_LBRACE,
    STATE(4483), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [287172] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      anon_sym_COMMA,
    STATE(7689), 1,
      aux_sym_field_declaration_repeat1,
    ACTIONS(11878), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [287186] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11880), 1,
      anon_sym___except,
    ACTIONS(11882), 1,
      anon_sym___finally,
    STATE(282), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [287200] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11747), 1,
      anon_sym_COMMA,
    STATE(7628), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(11884), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [287214] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(11886), 1,
      anon_sym_SEMI,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [287228] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11888), 1,
      anon_sym_EQ,
    STATE(7648), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [287242] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11890), 1,
      anon_sym_DQUOTE,
    ACTIONS(11892), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11894), 1,
      sym_escape_sequence,
    STATE(7724), 1,
      aux_sym_string_literal_repeat1,
  [287258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10540), 1,
      anon_sym_LBRACE,
    STATE(5089), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [287272] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11896), 1,
      anon_sym_GT2,
    STATE(8231), 1,
      aux_sym_template_argument_list_repeat1,
  [287288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(7285), 1,
      sym_access_specifier,
    ACTIONS(11898), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [287300] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11791), 1,
      anon_sym_LPAREN,
    ACTIONS(11900), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11902), 1,
      sym_preproc_arg,
    STATE(8456), 1,
      sym_preproc_params,
  [287316] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11287), 1,
      anon_sym_EQ,
    STATE(7718), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [287330] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11763), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11765), 1,
      sym_escape_sequence,
    ACTIONS(11904), 1,
      anon_sym_DQUOTE,
    STATE(7728), 1,
      aux_sym_string_literal_repeat1,
  [287346] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11791), 1,
      anon_sym_LPAREN,
    ACTIONS(11906), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11908), 1,
      sym_preproc_arg,
    STATE(8573), 1,
      sym_preproc_params,
  [287362] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11910), 1,
      anon_sym_EQ,
    STATE(6822), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [287376] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9748), 1,
      anon_sym_LBRACE,
    ACTIONS(11912), 1,
      anon_sym_LPAREN2,
    STATE(3833), 1,
      sym_requirement_seq,
    STATE(8649), 1,
      sym_requires_parameter_list,
  [287392] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(11914), 1,
      anon_sym_SEMI,
    STATE(2036), 1,
      sym_template_argument_list,
  [287408] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11916), 1,
      anon_sym_DQUOTE,
    ACTIONS(11918), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11920), 1,
      sym_escape_sequence,
    STATE(7766), 1,
      aux_sym_string_literal_repeat1,
  [287424] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11763), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11765), 1,
      sym_escape_sequence,
    ACTIONS(11922), 1,
      anon_sym_DQUOTE,
    STATE(7728), 1,
      aux_sym_string_literal_repeat1,
  [287440] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11924), 1,
      anon_sym_COMMA,
    STATE(7707), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(11927), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [287454] = 4,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11929), 1,
      anon_sym_SQUOTE,
    STATE(7738), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11755), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [287468] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(7891), 1,
      anon_sym_LBRACE,
    STATE(4739), 1,
      sym_field_declaration_list,
    STATE(8628), 1,
      sym_base_class_clause,
  [287484] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(11931), 1,
      anon_sym_SEMI,
    STATE(7658), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [287498] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2231), 1,
      anon_sym_LBRACE,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    STATE(3693), 1,
      sym_initializer_list,
    STATE(3742), 1,
      sym_argument_list,
  [287514] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10445), 1,
      anon_sym_LBRACE,
    STATE(4137), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [287528] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11933), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11935), 1,
      anon_sym_COMMA,
    ACTIONS(11937), 1,
      anon_sym_LBRACE,
    STATE(8228), 1,
      aux_sym_base_class_clause_repeat1,
  [287544] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11939), 1,
      anon_sym_GT2,
    STATE(8302), 1,
      aux_sym_template_argument_list_repeat1,
  [287560] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    STATE(2982), 1,
      sym_argument_list,
    STATE(4660), 1,
      sym_initializer_list,
  [287576] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(11941), 1,
      anon_sym_SEMI,
    STATE(2036), 1,
      sym_template_argument_list,
  [287592] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2841), 1,
      anon_sym_LBRACE,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    STATE(4081), 1,
      sym_argument_list,
    STATE(4560), 1,
      sym_initializer_list,
  [287608] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11943), 1,
      anon_sym_EQ,
    STATE(6822), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [287622] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11912), 1,
      anon_sym_LPAREN2,
    ACTIONS(11945), 1,
      anon_sym_LBRACE,
    STATE(2039), 1,
      sym_requirement_seq,
    STATE(8496), 1,
      sym_requires_parameter_list,
  [287638] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6649), 1,
      anon_sym_LBRACE,
    STATE(3437), 1,
      sym_field_declaration_list,
    STATE(8589), 1,
      sym_base_class_clause,
  [287654] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10459), 1,
      anon_sym_LBRACE,
    STATE(2959), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [287668] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11947), 1,
      anon_sym_GT2,
    STATE(8217), 1,
      aux_sym_template_argument_list_repeat1,
  [287684] = 4,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11949), 1,
      anon_sym_SQUOTE,
    STATE(7738), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11755), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [287698] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11763), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11765), 1,
      sym_escape_sequence,
    ACTIONS(11951), 1,
      anon_sym_DQUOTE,
    STATE(7728), 1,
      aux_sym_string_literal_repeat1,
  [287714] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11953), 1,
      anon_sym_GT2,
    STATE(8109), 1,
      aux_sym_template_argument_list_repeat1,
  [287730] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9732), 1,
      anon_sym_LBRACE,
    ACTIONS(11912), 1,
      anon_sym_LPAREN2,
    STATE(2915), 1,
      sym_requirement_seq,
    STATE(8667), 1,
      sym_requires_parameter_list,
  [287746] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11955), 1,
      anon_sym_DQUOTE,
    ACTIONS(11957), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11959), 1,
      sym_escape_sequence,
    STATE(7706), 1,
      aux_sym_string_literal_repeat1,
  [287762] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11961), 1,
      anon_sym_DQUOTE,
    ACTIONS(11963), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11966), 1,
      sym_escape_sequence,
    STATE(7728), 1,
      aux_sym_string_literal_repeat1,
  [287778] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11349), 1,
      anon_sym_EQ,
    STATE(7744), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [287792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    STATE(7998), 2,
      sym_argument_list,
      sym_initializer_list,
  [287806] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    STATE(7936), 1,
      sym_compound_statement,
    STATE(8520), 1,
      sym_field_initializer_list,
  [287822] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11791), 1,
      anon_sym_LPAREN,
    ACTIONS(11969), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11971), 1,
      sym_preproc_arg,
    STATE(8616), 1,
      sym_preproc_params,
  [287838] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9697), 1,
      anon_sym_LBRACE,
    ACTIONS(11912), 1,
      anon_sym_LPAREN2,
    STATE(4221), 1,
      sym_requirement_seq,
    STATE(8447), 1,
      sym_requires_parameter_list,
  [287854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(7308), 1,
      sym_access_specifier,
    ACTIONS(11898), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [287866] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LBRACE,
    ACTIONS(11973), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11975), 1,
      anon_sym_EQ,
    STATE(413), 1,
      sym_declaration_list,
  [287882] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10522), 1,
      anon_sym_LBRACE,
    STATE(3767), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [287896] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11791), 1,
      anon_sym_LPAREN,
    ACTIONS(11977), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11979), 1,
      sym_preproc_arg,
    STATE(8391), 1,
      sym_preproc_params,
  [287912] = 4,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11981), 1,
      anon_sym_SQUOTE,
    STATE(7738), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11983), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [287926] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10457), 1,
      anon_sym_LBRACE,
    STATE(6567), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [287940] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11986), 1,
      anon_sym___except,
    ACTIONS(11988), 1,
      anon_sym___finally,
    STATE(861), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [287954] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11935), 1,
      anon_sym_COMMA,
    ACTIONS(11990), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11992), 1,
      anon_sym_LBRACE,
    STATE(8261), 1,
      aux_sym_base_class_clause_repeat1,
  [287970] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11994), 1,
      anon_sym_COMMA,
    STATE(7837), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(11996), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [287984] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    STATE(3807), 1,
      sym_field_declaration_list,
    STATE(8427), 1,
      sym_base_class_clause,
  [288000] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11998), 1,
      anon_sym_EQ,
    STATE(6822), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [288014] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11763), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11765), 1,
      sym_escape_sequence,
    ACTIONS(12000), 1,
      anon_sym_DQUOTE,
    STATE(7728), 1,
      aux_sym_string_literal_repeat1,
  [288030] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    STATE(6133), 1,
      sym_field_declaration_list,
    STATE(8508), 1,
      sym_base_class_clause,
  [288046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11343), 1,
      anon_sym_EQ,
    STATE(7754), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [288060] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(12002), 1,
      anon_sym_SEMI,
    STATE(2036), 1,
      sym_template_argument_list,
  [288076] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2159), 1,
      anon_sym_LBRACE,
    ACTIONS(5813), 1,
      anon_sym_LPAREN2,
    STATE(2906), 1,
      sym_initializer_list,
    STATE(2982), 1,
      sym_argument_list,
  [288092] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    STATE(6103), 1,
      sym_field_declaration_list,
    STATE(8507), 1,
      sym_base_class_clause,
  [288108] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12004), 1,
      anon_sym_DQUOTE,
    ACTIONS(12006), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12008), 1,
      sym_escape_sequence,
    STATE(7755), 1,
      aux_sym_string_literal_repeat1,
  [288124] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12010), 1,
      anon_sym_GT2,
    STATE(8180), 1,
      aux_sym_template_argument_list_repeat1,
  [288140] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    STATE(3260), 1,
      sym_field_declaration_list,
    STATE(8528), 1,
      sym_base_class_clause,
  [288156] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12012), 1,
      anon_sym_EQ,
    STATE(6822), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [288170] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11763), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11765), 1,
      sym_escape_sequence,
    ACTIONS(12014), 1,
      anon_sym_DQUOTE,
    STATE(7728), 1,
      aux_sym_string_literal_repeat1,
  [288186] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12016), 1,
      anon_sym_GT2,
    STATE(8131), 1,
      aux_sym_template_argument_list_repeat1,
  [288202] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 1,
      anon_sym_LBRACE,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    STATE(4310), 1,
      sym_argument_list,
    STATE(5545), 1,
      sym_initializer_list,
  [288218] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10522), 1,
      anon_sym_LBRACE,
    STATE(3764), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [288232] = 4,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12018), 1,
      anon_sym_SQUOTE,
    STATE(7738), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11755), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [288246] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6649), 1,
      anon_sym_LBRACE,
    STATE(3400), 1,
      sym_field_declaration_list,
    STATE(8623), 1,
      sym_base_class_clause,
  [288262] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    STATE(2990), 1,
      sym_field_declaration_list,
    STATE(8665), 1,
      sym_base_class_clause,
  [288278] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12020), 1,
      anon_sym_SEMI,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [288292] = 4,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12022), 1,
      anon_sym_SQUOTE,
    STATE(7738), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11755), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [288306] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12024), 1,
      anon_sym___except,
    ACTIONS(12026), 1,
      anon_sym___finally,
    STATE(796), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [288320] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10483), 1,
      anon_sym_LBRACE,
    STATE(6768), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [288334] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11763), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11765), 1,
      sym_escape_sequence,
    ACTIONS(12028), 1,
      anon_sym_DQUOTE,
    STATE(7728), 1,
      aux_sym_string_literal_repeat1,
  [288350] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12030), 1,
      anon_sym_DQUOTE,
    ACTIONS(12032), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12034), 1,
      sym_escape_sequence,
    STATE(7636), 1,
      aux_sym_string_literal_repeat1,
  [288366] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12036), 1,
      anon_sym_GT2,
    STATE(8323), 1,
      aux_sym_template_argument_list_repeat1,
  [288382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12038), 1,
      sym_identifier,
    ACTIONS(12040), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [288394] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12042), 1,
      anon_sym_GT2,
    STATE(8045), 1,
      aux_sym_template_argument_list_repeat1,
  [288410] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12044), 1,
      anon_sym_SEMI,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [288424] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    STATE(4648), 1,
      sym_field_declaration_list,
    STATE(8466), 1,
      sym_base_class_clause,
  [288440] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6477), 1,
      anon_sym_LBRACE,
    STATE(3366), 1,
      sym_field_declaration_list,
    STATE(8638), 1,
      sym_base_class_clause,
  [288456] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10516), 1,
      anon_sym_LBRACE,
    STATE(4348), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [288470] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(12046), 1,
      anon_sym_SEMI,
    STATE(2036), 1,
      sym_template_argument_list,
  [288486] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12048), 1,
      anon_sym_SEMI,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [288500] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5216), 1,
      anon_sym_LBRACE,
    ACTIONS(11973), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12050), 1,
      anon_sym_EQ,
    STATE(926), 1,
      sym_declaration_list,
  [288516] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5475), 1,
      anon_sym_LBRACE,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    STATE(2711), 1,
      sym_field_declaration_list,
    STATE(8432), 1,
      sym_base_class_clause,
  [288532] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12052), 1,
      anon_sym_SEMI,
    STATE(7680), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [288546] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12054), 1,
      anon_sym_SEMI,
    STATE(7762), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [288560] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10483), 1,
      anon_sym_LBRACE,
    STATE(6794), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [288574] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3729), 1,
      anon_sym_LBRACE,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    STATE(3742), 1,
      sym_argument_list,
    STATE(5106), 1,
      sym_initializer_list,
  [288590] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    STATE(7951), 1,
      sym_compound_statement,
    STATE(8595), 1,
      sym_field_initializer_list,
  [288606] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9716), 1,
      anon_sym_LBRACE,
    ACTIONS(11912), 1,
      anon_sym_LPAREN2,
    STATE(4074), 1,
      sym_requirement_seq,
    STATE(8605), 1,
      sym_requires_parameter_list,
  [288622] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    STATE(4609), 1,
      sym_field_declaration_list,
    STATE(8465), 1,
      sym_base_class_clause,
  [288638] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12056), 1,
      anon_sym_SEMI,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [288652] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2297), 1,
      anon_sym_LBRACE,
    ACTIONS(6832), 1,
      anon_sym_LPAREN2,
    STATE(4081), 1,
      sym_argument_list,
    STATE(4082), 1,
      sym_initializer_list,
  [288668] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11994), 1,
      anon_sym_COMMA,
    STATE(7742), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(12058), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [288682] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10473), 1,
      anon_sym_LBRACE,
    STATE(4124), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [288696] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12060), 1,
      anon_sym_GT2,
    STATE(8079), 1,
      aux_sym_template_argument_list_repeat1,
  [288712] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10457), 1,
      anon_sym_LBRACE,
    STATE(6553), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [288726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12062), 1,
      anon_sym_COMMA,
    STATE(7861), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(12064), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [288740] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10530), 1,
      anon_sym_LBRACE,
    STATE(5101), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [288754] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12066), 1,
      anon_sym_DQUOTE,
    ACTIONS(12068), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12070), 1,
      sym_escape_sequence,
    STATE(7843), 1,
      aux_sym_string_literal_repeat1,
  [288770] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12072), 1,
      anon_sym_SEMI,
    STATE(7823), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [288784] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12074), 1,
      anon_sym_SEMI,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [288798] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    STATE(8637), 1,
      sym_argument_list,
    ACTIONS(12076), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [288812] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11791), 1,
      anon_sym_LPAREN,
    ACTIONS(12078), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12080), 1,
      sym_preproc_arg,
    STATE(8655), 1,
      sym_preproc_params,
  [288828] = 4,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12082), 1,
      anon_sym_SQUOTE,
    STATE(7738), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11755), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [288842] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5475), 1,
      anon_sym_LBRACE,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    STATE(2670), 1,
      sym_field_declaration_list,
    STATE(8566), 1,
      sym_base_class_clause,
  [288858] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 1,
      anon_sym_LT,
    ACTIONS(11861), 1,
      sym_identifier,
    STATE(1113), 1,
      sym_template_parameter_list,
    STATE(2829), 1,
      sym_template_type,
  [288874] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(7706), 1,
      anon_sym_LBRACE,
    STATE(4677), 1,
      sym_field_declaration_list,
    STATE(8696), 1,
      sym_base_class_clause,
  [288890] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    STATE(8064), 1,
      sym_compound_statement,
    STATE(8617), 1,
      sym_field_initializer_list,
  [288906] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11912), 1,
      anon_sym_LPAREN2,
    ACTIONS(12084), 1,
      anon_sym_LBRACE,
    STATE(6589), 1,
      sym_requirement_seq,
    STATE(8567), 1,
      sym_requires_parameter_list,
  [288922] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(12086), 1,
      anon_sym_SEMI,
    STATE(2036), 1,
      sym_template_argument_list,
  [288938] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12088), 1,
      anon_sym___except,
    ACTIONS(12090), 1,
      anon_sym___finally,
    STATE(1196), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [288952] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11763), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11765), 1,
      sym_escape_sequence,
    ACTIONS(12092), 1,
      anon_sym_DQUOTE,
    STATE(7728), 1,
      aux_sym_string_literal_repeat1,
  [288968] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11149), 1,
      anon_sym_COMMA,
    STATE(7822), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(12094), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [288982] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12096), 1,
      anon_sym_SEMI,
    STATE(7776), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [288996] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12098), 1,
      anon_sym_DQUOTE,
    ACTIONS(12100), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12102), 1,
      sym_escape_sequence,
    STATE(7745), 1,
      aux_sym_string_literal_repeat1,
  [289012] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9689), 1,
      anon_sym_LBRACE,
    ACTIONS(11912), 1,
      anon_sym_LPAREN2,
    STATE(4073), 1,
      sym_requirement_seq,
    STATE(8728), 1,
      sym_requires_parameter_list,
  [289028] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10483), 1,
      anon_sym_LBRACE,
    STATE(6764), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [289042] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11763), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11765), 1,
      sym_escape_sequence,
    ACTIONS(12104), 1,
      anon_sym_DQUOTE,
    STATE(7728), 1,
      aux_sym_string_literal_repeat1,
  [289058] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9740), 1,
      anon_sym_LBRACE,
    ACTIONS(11912), 1,
      anon_sym_LPAREN2,
    STATE(5047), 1,
      sym_requirement_seq,
    STATE(8763), 1,
      sym_requires_parameter_list,
  [289074] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12106), 1,
      anon_sym_GT2,
    STATE(8343), 1,
      aux_sym_template_argument_list_repeat1,
  [289090] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    STATE(8164), 1,
      sym_compound_statement,
    STATE(8779), 1,
      sym_field_initializer_list,
  [289106] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10437), 1,
      anon_sym_LBRACE,
    STATE(4583), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [289120] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 1,
      anon_sym_LT,
    ACTIONS(11861), 1,
      sym_identifier,
    STATE(1110), 1,
      sym_template_parameter_list,
    STATE(2829), 1,
      sym_template_type,
  [289136] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 1,
      anon_sym_LT,
    ACTIONS(11861), 1,
      sym_identifier,
    STATE(1108), 1,
      sym_template_parameter_list,
    STATE(2829), 1,
      sym_template_type,
  [289152] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11763), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11765), 1,
      sym_escape_sequence,
    ACTIONS(12108), 1,
      anon_sym_DQUOTE,
    STATE(7728), 1,
      aux_sym_string_literal_repeat1,
  [289168] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10457), 1,
      anon_sym_LBRACE,
    STATE(6534), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [289182] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12110), 1,
      anon_sym_COMMA,
    STATE(7822), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(12113), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [289196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12115), 1,
      anon_sym_SEMI,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [289210] = 4,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12117), 1,
      anon_sym_SQUOTE,
    STATE(7738), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11755), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [289224] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5131), 1,
      anon_sym_SEMI,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(2153), 1,
      sym_template_argument_list,
  [289240] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12119), 1,
      anon_sym_SEMI,
    STATE(7902), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [289254] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9708), 1,
      anon_sym_LBRACE,
    ACTIONS(11912), 1,
      anon_sym_LPAREN2,
    STATE(4547), 1,
      sym_requirement_seq,
    STATE(8650), 1,
      sym_requires_parameter_list,
  [289270] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    STATE(4434), 1,
      sym_parameter_list,
    STATE(6953), 1,
      sym__function_declarator_seq,
  [289286] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(7706), 1,
      anon_sym_LBRACE,
    STATE(4699), 1,
      sym_field_declaration_list,
    STATE(8721), 1,
      sym_base_class_clause,
  [289302] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12121), 1,
      anon_sym_SEMI,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [289316] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5210), 1,
      anon_sym_LBRACE,
    ACTIONS(11973), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12123), 1,
      anon_sym_EQ,
    STATE(607), 1,
      sym_declaration_list,
  [289332] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12125), 1,
      anon_sym_SEMI,
    STATE(7692), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [289346] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 1,
      anon_sym_LT,
    ACTIONS(11861), 1,
      sym_identifier,
    STATE(1106), 1,
      sym_template_parameter_list,
    STATE(2829), 1,
      sym_template_type,
  [289362] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12127), 1,
      anon_sym_SEMI,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [289376] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12129), 1,
      anon_sym___except,
    ACTIONS(12131), 1,
      anon_sym___finally,
    STATE(524), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [289390] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 1,
      anon_sym_LT,
    ACTIONS(11861), 1,
      sym_identifier,
    STATE(1109), 1,
      sym_template_parameter_list,
    STATE(2829), 1,
      sym_template_type,
  [289406] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12133), 1,
      anon_sym_COMMA,
    STATE(7837), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(12136), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [289420] = 4,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12138), 1,
      anon_sym_SQUOTE,
    STATE(7738), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11755), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [289434] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12140), 1,
      anon_sym_SEMI,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [289448] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5208), 1,
      anon_sym_LBRACE,
    ACTIONS(11973), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12142), 1,
      anon_sym_EQ,
    STATE(1075), 1,
      sym_declaration_list,
  [289464] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12144), 1,
      anon_sym___except,
    ACTIONS(12146), 1,
      anon_sym___finally,
    STATE(732), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [289478] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    STATE(8219), 1,
      sym_compound_statement,
    STATE(8641), 1,
      sym_field_initializer_list,
  [289494] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11763), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11765), 1,
      sym_escape_sequence,
    ACTIONS(12148), 1,
      anon_sym_DQUOTE,
    STATE(7728), 1,
      aux_sym_string_literal_repeat1,
  [289510] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12150), 1,
      anon_sym_SEMI,
    STATE(7771), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [289524] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 1,
      anon_sym_LT,
    ACTIONS(11861), 1,
      sym_identifier,
    STATE(1114), 1,
      sym_template_parameter_list,
    STATE(2829), 1,
      sym_template_type,
  [289540] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12152), 1,
      anon_sym_DQUOTE,
    ACTIONS(12154), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12156), 1,
      sym_escape_sequence,
    STATE(7922), 1,
      aux_sym_string_literal_repeat1,
  [289556] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12158), 1,
      anon_sym_DQUOTE,
    ACTIONS(12160), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12162), 1,
      sym_escape_sequence,
    STATE(7820), 1,
      aux_sym_string_literal_repeat1,
  [289572] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11935), 1,
      anon_sym_COMMA,
    ACTIONS(12164), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12166), 1,
      anon_sym_LBRACE,
    STATE(8259), 1,
      aux_sym_base_class_clause_repeat1,
  [289588] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    STATE(3019), 1,
      sym_field_declaration_list,
    STATE(8719), 1,
      sym_base_class_clause,
  [289604] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12168), 1,
      anon_sym_DQUOTE,
    ACTIONS(12170), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12172), 1,
      sym_escape_sequence,
    STATE(7871), 1,
      aux_sym_string_literal_repeat1,
  [289620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(7290), 1,
      sym_access_specifier,
    ACTIONS(11898), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [289632] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11763), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11765), 1,
      sym_escape_sequence,
    ACTIONS(12174), 1,
      anon_sym_DQUOTE,
    STATE(7728), 1,
      aux_sym_string_literal_repeat1,
  [289648] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10437), 1,
      anon_sym_LBRACE,
    STATE(4564), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [289662] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5214), 1,
      anon_sym_LBRACE,
    ACTIONS(11973), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12176), 1,
      anon_sym_EQ,
    STATE(915), 1,
      sym_declaration_list,
  [289678] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12178), 1,
      anon_sym_GT2,
    STATE(7953), 1,
      aux_sym_template_argument_list_repeat1,
  [289694] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10516), 1,
      anon_sym_LBRACE,
    STATE(4266), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [289708] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12180), 1,
      anon_sym_SEMI,
    STATE(7830), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [289722] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 1,
      anon_sym_LT,
    ACTIONS(11861), 1,
      sym_identifier,
    STATE(1111), 1,
      sym_template_parameter_list,
    STATE(2829), 1,
      sym_template_type,
  [289738] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    STATE(5675), 1,
      sym_field_declaration_list,
    STATE(8506), 1,
      sym_base_class_clause,
  [289754] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12182), 1,
      anon_sym_EQ,
    STATE(6822), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [289768] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12062), 1,
      anon_sym_COMMA,
    STATE(7895), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(12184), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [289782] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11763), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11765), 1,
      sym_escape_sequence,
    ACTIONS(12186), 1,
      anon_sym_DQUOTE,
    STATE(7728), 1,
      aux_sym_string_literal_repeat1,
  [289798] = 4,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12188), 1,
      anon_sym_SQUOTE,
    STATE(7738), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11755), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [289812] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12190), 1,
      anon_sym_SEMI,
    STATE(7839), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [289826] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    STATE(3752), 1,
      sym_field_declaration_list,
    STATE(8731), 1,
      sym_base_class_clause,
  [289842] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    STATE(8357), 1,
      sym_compound_statement,
    STATE(8668), 1,
      sym_field_initializer_list,
  [289858] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12192), 1,
      anon_sym_DQUOTE,
    ACTIONS(12194), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12196), 1,
      sym_escape_sequence,
    STATE(7893), 1,
      aux_sym_string_literal_repeat1,
  [289874] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12198), 1,
      anon_sym_SEMI,
    STATE(7834), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [289888] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11355), 1,
      anon_sym_EQ,
    STATE(7882), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [289902] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(12200), 1,
      anon_sym_SEMI,
    STATE(2036), 1,
      sym_template_argument_list,
  [289918] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11763), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11765), 1,
      sym_escape_sequence,
    ACTIONS(12202), 1,
      anon_sym_DQUOTE,
    STATE(7728), 1,
      aux_sym_string_literal_repeat1,
  [289934] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    STATE(3240), 1,
      sym_field_declaration_list,
    STATE(8576), 1,
      sym_base_class_clause,
  [289950] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11791), 1,
      anon_sym_LPAREN,
    ACTIONS(12204), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12206), 1,
      sym_preproc_arg,
    STATE(8720), 1,
      sym_preproc_params,
  [289966] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12208), 1,
      anon_sym_SEMI,
    STATE(7633), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [289980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12210), 1,
      anon_sym_SEMI,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [289994] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(2044), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [290008] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9724), 1,
      anon_sym_LBRACE,
    ACTIONS(11912), 1,
      anon_sym_LPAREN2,
    STATE(5178), 1,
      sym_requirement_seq,
    STATE(8403), 1,
      sym_requires_parameter_list,
  [290024] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10445), 1,
      anon_sym_LBRACE,
    STATE(4063), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [290038] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12212), 1,
      anon_sym_GT2,
    STATE(8363), 1,
      aux_sym_template_argument_list_repeat1,
  [290054] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12214), 1,
      anon_sym_DQUOTE,
    ACTIONS(12216), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12218), 1,
      sym_escape_sequence,
    STATE(7903), 1,
      aux_sym_string_literal_repeat1,
  [290070] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12220), 1,
      anon_sym_EQ,
    STATE(6822), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [290084] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12222), 1,
      anon_sym_EQ,
    STATE(6822), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [290098] = 4,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12224), 1,
      anon_sym_SQUOTE,
    STATE(7738), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11755), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [290112] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11383), 1,
      anon_sym_EQ,
    STATE(7702), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [290126] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12226), 1,
      anon_sym_SEMI,
    STATE(7786), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [290140] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10473), 1,
      anon_sym_LBRACE,
    STATE(4173), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [290154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(7293), 1,
      sym_access_specifier,
    ACTIONS(11898), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [290166] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12228), 1,
      anon_sym_SEMI,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [290180] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2739), 1,
      anon_sym_LBRACE,
    ACTIONS(6917), 1,
      anon_sym_LPAREN2,
    STATE(4222), 1,
      sym_initializer_list,
    STATE(4310), 1,
      sym_argument_list,
  [290196] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(9241), 1,
      anon_sym_LBRACE,
    STATE(5854), 1,
      sym_field_declaration_list,
    STATE(8741), 1,
      sym_base_class_clause,
  [290212] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 1,
      anon_sym_LT,
    ACTIONS(11861), 1,
      sym_identifier,
    STATE(1112), 1,
      sym_template_parameter_list,
    STATE(2829), 1,
      sym_template_type,
  [290228] = 4,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12230), 1,
      anon_sym_SQUOTE,
    STATE(7738), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11755), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [290242] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11763), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11765), 1,
      sym_escape_sequence,
    ACTIONS(12232), 1,
      anon_sym_DQUOTE,
    STATE(7728), 1,
      aux_sym_string_literal_repeat1,
  [290258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10530), 1,
      anon_sym_LBRACE,
    STATE(5121), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [290272] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12234), 1,
      anon_sym_COMMA,
    STATE(7895), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(12237), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [290286] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12239), 1,
      anon_sym_DQUOTE,
    ACTIONS(12241), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12243), 1,
      sym_escape_sequence,
    STATE(7906), 1,
      aux_sym_string_literal_repeat1,
  [290302] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(12245), 1,
      anon_sym_SEMI,
    STATE(2036), 1,
      sym_template_argument_list,
  [290318] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    STATE(8086), 1,
      sym_compound_statement,
    STATE(8703), 1,
      sym_field_initializer_list,
  [290334] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12247), 1,
      anon_sym_SEMI,
    STATE(7934), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [290348] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11763), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11765), 1,
      sym_escape_sequence,
    ACTIONS(12249), 1,
      anon_sym_DQUOTE,
    STATE(7728), 1,
      aux_sym_string_literal_repeat1,
  [290364] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11912), 1,
      anon_sym_LPAREN2,
    ACTIONS(12251), 1,
      anon_sym_LBRACE,
    STATE(6792), 1,
      sym_requirement_seq,
    STATE(8710), 1,
      sym_requires_parameter_list,
  [290380] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12253), 1,
      anon_sym_SEMI,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [290394] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11763), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11765), 1,
      sym_escape_sequence,
    ACTIONS(12255), 1,
      anon_sym_DQUOTE,
    STATE(7728), 1,
      aux_sym_string_literal_repeat1,
  [290410] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12257), 1,
      anon_sym_GT2,
    STATE(8332), 1,
      aux_sym_template_argument_list_repeat1,
  [290426] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(2054), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [290440] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11763), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11765), 1,
      sym_escape_sequence,
    ACTIONS(12259), 1,
      anon_sym_DQUOTE,
    STATE(7728), 1,
      aux_sym_string_literal_repeat1,
  [290456] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10445), 1,
      anon_sym_LBRACE,
    STATE(4117), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [290470] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12261), 1,
      anon_sym_SEMI,
    STATE(7932), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [290484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12263), 4,
      anon_sym_LPAREN2,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [290494] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11791), 1,
      anon_sym_LPAREN,
    ACTIONS(12265), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12267), 1,
      sym_preproc_arg,
    STATE(8612), 1,
      sym_preproc_params,
  [290510] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10514), 1,
      anon_sym_LBRACE,
    STATE(2054), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [290524] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    STATE(3779), 1,
      sym_field_declaration_list,
    STATE(8539), 1,
      sym_base_class_clause,
  [290540] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(9241), 1,
      anon_sym_LBRACE,
    STATE(5823), 1,
      sym_field_declaration_list,
    STATE(8762), 1,
      sym_base_class_clause,
  [290556] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12269), 1,
      anon_sym_GT2,
    STATE(8383), 1,
      aux_sym_template_argument_list_repeat1,
  [290572] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11763), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11765), 1,
      sym_escape_sequence,
    ACTIONS(12271), 1,
      anon_sym_DQUOTE,
    STATE(7728), 1,
      aux_sym_string_literal_repeat1,
  [290588] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10516), 1,
      anon_sym_LBRACE,
    STATE(4347), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [290602] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12273), 1,
      anon_sym_GT2,
    STATE(7972), 1,
      aux_sym_template_argument_list_repeat1,
  [290618] = 4,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12275), 1,
      anon_sym_SQUOTE,
    STATE(7738), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11755), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [290632] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6753), 1,
      anon_sym_LT,
    ACTIONS(12277), 1,
      anon_sym_SEMI,
    STATE(2036), 1,
      sym_template_argument_list,
  [290648] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_COLON,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    STATE(3671), 1,
      sym_field_declaration_list,
    STATE(8458), 1,
      sym_base_class_clause,
  [290664] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12279), 1,
      anon_sym_DQUOTE,
    ACTIONS(12281), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12283), 1,
      sym_escape_sequence,
    STATE(7862), 1,
      aux_sym_string_literal_repeat1,
  [290680] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(11763), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11765), 1,
      sym_escape_sequence,
    ACTIONS(12285), 1,
      anon_sym_DQUOTE,
    STATE(7728), 1,
      aux_sym_string_literal_repeat1,
  [290696] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11935), 1,
      anon_sym_COMMA,
    ACTIONS(12287), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12289), 1,
      anon_sym_LBRACE,
    STATE(8097), 1,
      aux_sym_base_class_clause_repeat1,
  [290712] = 4,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_SQUOTE,
    STATE(7738), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11755), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [290726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11291), 1,
      anon_sym_EQ,
    STATE(7684), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [290740] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10473), 1,
      anon_sym_LBRACE,
    STATE(4199), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [290754] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(2050), 1,
      sym_compound_statement,
    ACTIONS(10524), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [290768] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12293), 1,
      anon_sym_GT2,
    STATE(8257), 1,
      aux_sym_template_argument_list_repeat1,
  [290784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11323), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_identifier,
  [290794] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 1,
      anon_sym_LT,
    ACTIONS(11861), 1,
      sym_identifier,
    STATE(1107), 1,
      sym_template_parameter_list,
    STATE(2829), 1,
      sym_template_type,
  [290810] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12295), 1,
      anon_sym_SEMI,
    STATE(7875), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [290824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12297), 1,
      anon_sym_SEMI,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [290838] = 5,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12299), 1,
      anon_sym_DQUOTE,
    ACTIONS(12301), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12303), 1,
      sym_escape_sequence,
    STATE(7900), 1,
      aux_sym_string_literal_repeat1,
  [290854] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym___attribute__,
    ACTIONS(12305), 1,
      anon_sym_SEMI,
    STATE(5525), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [290868] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(10734), 1,
      anon_sym_COLON,
    STATE(8277), 1,
      sym_compound_statement,
    STATE(8751), 1,
      sym_field_initializer_list,
  [290884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12307), 1,
      anon_sym_catch,
    STATE(531), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [290895] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12309), 1,
      anon_sym_RPAREN,
    ACTIONS(12311), 1,
      anon_sym_COLON,
    STATE(7986), 1,
      sym_gnu_asm_input_operand_list,
  [290908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8629), 3,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
  [290917] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12313), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [290930] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12315), 1,
      anon_sym_COMMA,
    ACTIONS(12317), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(8326), 1,
      aux_sym_attribute_declaration_repeat1,
  [290943] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12319), 1,
      anon_sym_COMMA,
    ACTIONS(12321), 1,
      anon_sym_RPAREN,
    STATE(8151), 1,
      aux_sym_parameter_list_repeat1,
  [290956] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12323), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(3955), 1,
      sym_template_function,
  [290969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12307), 1,
      anon_sym_catch,
    STATE(480), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [290980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8830), 1,
      anon_sym_RPAREN,
    STATE(7963), 1,
      aux_sym_argument_list_repeat1,
  [290993] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12325), 1,
      anon_sym_SEMI,
    STATE(7979), 1,
      aux_sym_declaration_repeat1,
  [291006] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12327), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [291019] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12329), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [291032] = 4,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12331), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12333), 1,
      anon_sym_LPAREN2,
    STATE(9581), 1,
      sym_preproc_argument_list,
  [291045] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8645), 1,
      anon_sym_COMMA,
    ACTIONS(12335), 1,
      anon_sym_RBRACK,
    STATE(8168), 1,
      aux_sym_subscript_argument_list_repeat1,
  [291058] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12337), 1,
      anon_sym_RPAREN,
    ACTIONS(12339), 1,
      anon_sym_COLON,
    STATE(7989), 1,
      sym_gnu_asm_output_operand_list,
  [291071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12341), 1,
      anon_sym_catch,
    STATE(2257), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [291082] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12343), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [291095] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12345), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [291108] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12347), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [291121] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9999), 1,
      anon_sym_COMMA,
    ACTIONS(12349), 1,
      anon_sym_RPAREN,
    STATE(8173), 1,
      aux_sym_preproc_argument_list_repeat1,
  [291134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12351), 1,
      anon_sym_catch,
    STATE(2102), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [291145] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8725), 1,
      anon_sym_RPAREN,
    STATE(8041), 1,
      aux_sym_argument_list_repeat1,
  [291158] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    STATE(7863), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12353), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [291169] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4502), 1,
      anon_sym_RBRACE,
    ACTIONS(12355), 1,
      anon_sym_COMMA,
    STATE(8129), 1,
      aux_sym_initializer_list_repeat1,
  [291182] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12357), 1,
      anon_sym_SEMI,
    STATE(7947), 1,
      aux_sym_declaration_repeat1,
  [291195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    ACTIONS(12361), 1,
      anon_sym_constexpr,
    STATE(166), 1,
      sym_condition_clause,
  [291208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12339), 1,
      anon_sym_COLON,
    ACTIONS(12363), 1,
      anon_sym_RPAREN,
    STATE(7969), 1,
      sym_gnu_asm_output_operand_list,
  [291221] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8803), 1,
      anon_sym_RPAREN,
    STATE(8041), 1,
      aux_sym_argument_list_repeat1,
  [291234] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12367), 1,
      anon_sym_GT2,
    STATE(8144), 1,
      aux_sym_template_parameter_list_repeat1,
  [291247] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12369), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [291260] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2920), 1,
      anon_sym_while,
    ACTIONS(12371), 1,
      anon_sym_else,
    STATE(761), 1,
      sym_else_clause,
  [291273] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12373), 1,
      anon_sym_GT2,
    STATE(7973), 1,
      aux_sym_template_argument_list_repeat1,
  [291286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(12375), 1,
      anon_sym_RPAREN,
    STATE(8041), 1,
      aux_sym_argument_list_repeat1,
  [291299] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12311), 1,
      anon_sym_COLON,
    ACTIONS(12377), 1,
      anon_sym_RPAREN,
    STATE(7987), 1,
      sym_gnu_asm_input_operand_list,
  [291312] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12339), 1,
      anon_sym_COLON,
    ACTIONS(12379), 1,
      anon_sym_RPAREN,
    STATE(7988), 1,
      sym_gnu_asm_output_operand_list,
  [291325] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12381), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [291338] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12383), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [291351] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12385), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [291364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12387), 1,
      anon_sym_catch,
    STATE(376), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [291375] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12315), 1,
      anon_sym_COMMA,
    ACTIONS(12389), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(8081), 1,
      aux_sym_attribute_declaration_repeat1,
  [291388] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9999), 1,
      anon_sym_COMMA,
    ACTIONS(12391), 1,
      anon_sym_RPAREN,
    STATE(8173), 1,
      aux_sym_preproc_argument_list_repeat1,
  [291401] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12315), 1,
      anon_sym_COMMA,
    ACTIONS(12393), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7940), 1,
      aux_sym_attribute_declaration_repeat1,
  [291414] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8645), 1,
      anon_sym_COMMA,
    ACTIONS(8671), 1,
      anon_sym_RBRACK,
    STATE(7949), 1,
      aux_sym_subscript_argument_list_repeat1,
  [291427] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12395), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [291440] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12397), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(3323), 1,
      sym_template_function,
  [291453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12341), 1,
      anon_sym_catch,
    STATE(2263), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [291464] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    STATE(7924), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12399), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [291475] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8645), 1,
      anon_sym_COMMA,
    ACTIONS(12401), 1,
      anon_sym_RBRACK,
    STATE(8168), 1,
      aux_sym_subscript_argument_list_repeat1,
  [291488] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12319), 1,
      anon_sym_COMMA,
    ACTIONS(12403), 1,
      anon_sym_RPAREN,
    STATE(7941), 1,
      aux_sym_parameter_list_repeat1,
  [291501] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(12405), 1,
      anon_sym_RPAREN,
    STATE(8041), 1,
      aux_sym_argument_list_repeat1,
  [291514] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12407), 1,
      anon_sym_RPAREN,
    ACTIONS(12409), 1,
      anon_sym_COLON,
    STATE(8006), 1,
      sym_gnu_asm_clobber_list,
  [291527] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12409), 1,
      anon_sym_COLON,
    ACTIONS(12411), 1,
      anon_sym_RPAREN,
    STATE(7990), 1,
      sym_gnu_asm_clobber_list,
  [291540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12311), 1,
      anon_sym_COLON,
    ACTIONS(12413), 1,
      anon_sym_RPAREN,
    STATE(7991), 1,
      sym_gnu_asm_input_operand_list,
  [291553] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12311), 1,
      anon_sym_COLON,
    ACTIONS(12415), 1,
      anon_sym_RPAREN,
    STATE(8007), 1,
      sym_gnu_asm_input_operand_list,
  [291566] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12417), 1,
      anon_sym_RPAREN,
    ACTIONS(12419), 1,
      anon_sym_COLON,
    STATE(8845), 1,
      sym_gnu_asm_goto_list,
  [291579] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12409), 1,
      anon_sym_COLON,
    ACTIONS(12421), 1,
      anon_sym_RPAREN,
    STATE(7995), 1,
      sym_gnu_asm_clobber_list,
  [291592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12423), 1,
      anon_sym_catch,
    STATE(454), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [291603] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    STATE(7799), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12425), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [291614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12423), 1,
      anon_sym_catch,
    STATE(911), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [291625] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12419), 1,
      anon_sym_COLON,
    ACTIONS(12427), 1,
      anon_sym_RPAREN,
    STATE(8842), 1,
      sym_gnu_asm_goto_list,
  [291638] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    ACTIONS(12429), 1,
      anon_sym_constexpr,
    STATE(226), 1,
      sym_condition_clause,
  [291651] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12431), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [291664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12433), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12435), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [291675] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12437), 1,
      anon_sym_SEMI,
    STATE(7939), 1,
      aux_sym_declaration_repeat1,
  [291688] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12439), 1,
      anon_sym_COMMA,
    ACTIONS(12441), 1,
      anon_sym_LBRACE,
    STATE(8166), 1,
      aux_sym_field_initializer_list_repeat1,
  [291701] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12443), 1,
      anon_sym_COMMA,
    ACTIONS(12445), 1,
      anon_sym_RPAREN,
    STATE(8176), 1,
      aux_sym_preproc_params_repeat1,
  [291714] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12447), 1,
      anon_sym_GT2,
    STATE(7964), 1,
      aux_sym_template_parameter_list_repeat1,
  [291727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12449), 1,
      anon_sym_EQ,
    ACTIONS(11373), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [291738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8783), 1,
      anon_sym_COMMA,
    ACTIONS(8785), 1,
      anon_sym_RBRACE,
    STATE(8054), 1,
      aux_sym_initializer_list_repeat1,
  [291751] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12451), 1,
      anon_sym_GT2,
    STATE(7965), 1,
      aux_sym_template_argument_list_repeat1,
  [291764] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12419), 1,
      anon_sym_COLON,
    ACTIONS(12453), 1,
      anon_sym_RPAREN,
    STATE(8803), 1,
      sym_gnu_asm_goto_list,
  [291777] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12409), 1,
      anon_sym_COLON,
    ACTIONS(12455), 1,
      anon_sym_RPAREN,
    STATE(8017), 1,
      sym_gnu_asm_clobber_list,
  [291790] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8681), 1,
      anon_sym_COMMA,
    ACTIONS(12457), 1,
      anon_sym_RPAREN,
    STATE(8367), 1,
      aux_sym_generic_expression_repeat1,
  [291803] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12339), 1,
      anon_sym_COLON,
    ACTIONS(12459), 1,
      anon_sym_RPAREN,
    STATE(7937), 1,
      sym_gnu_asm_output_operand_list,
  [291816] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8715), 1,
      anon_sym_COMMA,
    ACTIONS(8717), 1,
      anon_sym_RBRACE,
    STATE(7959), 1,
      aux_sym_initializer_list_repeat1,
  [291829] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2893), 1,
      anon_sym_while,
    ACTIONS(12371), 1,
      anon_sym_else,
    STATE(827), 1,
      sym_else_clause,
  [291842] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    STATE(7883), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12461), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [291853] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8529), 1,
      anon_sym_RBRACE,
    ACTIONS(8747), 1,
      anon_sym_COMMA,
    STATE(8147), 1,
      aux_sym_initializer_list_repeat1,
  [291866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12419), 1,
      anon_sym_COLON,
    ACTIONS(12463), 1,
      anon_sym_RPAREN,
    STATE(8819), 1,
      sym_gnu_asm_goto_list,
  [291879] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5216), 1,
      anon_sym_LBRACE,
    ACTIONS(11973), 1,
      anon_sym_COLON_COLON,
    STATE(866), 1,
      sym_declaration_list,
  [291892] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8741), 1,
      anon_sym_RPAREN,
    STATE(7957), 1,
      aux_sym_argument_list_repeat1,
  [291905] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12419), 1,
      anon_sym_COLON,
    ACTIONS(12465), 1,
      anon_sym_RPAREN,
    STATE(8794), 1,
      sym_gnu_asm_goto_list,
  [291918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8681), 1,
      anon_sym_COMMA,
    ACTIONS(12467), 1,
      anon_sym_RPAREN,
    STATE(8367), 1,
      aux_sym_generic_expression_repeat1,
  [291931] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8681), 1,
      anon_sym_COMMA,
    ACTIONS(12469), 1,
      anon_sym_RPAREN,
    STATE(8367), 1,
      aux_sym_generic_expression_repeat1,
  [291944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12471), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12473), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [291955] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12419), 1,
      anon_sym_COLON,
    ACTIONS(12475), 1,
      anon_sym_RPAREN,
    STATE(9062), 1,
      sym_gnu_asm_goto_list,
  [291968] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12319), 1,
      anon_sym_COMMA,
    ACTIONS(12477), 1,
      anon_sym_RPAREN,
    STATE(8151), 1,
      aux_sym_parameter_list_repeat1,
  [291981] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12479), 1,
      anon_sym_COMMA,
    ACTIONS(12482), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [291994] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12484), 1,
      anon_sym_SEMI,
    STATE(8121), 1,
      aux_sym_declaration_repeat1,
  [292007] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12486), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [292020] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12315), 1,
      anon_sym_COMMA,
    ACTIONS(12488), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(8326), 1,
      aux_sym_attribute_declaration_repeat1,
  [292033] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12409), 1,
      anon_sym_COLON,
    ACTIONS(12490), 1,
      anon_sym_RPAREN,
    STATE(8021), 1,
      sym_gnu_asm_clobber_list,
  [292046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12419), 1,
      anon_sym_COLON,
    ACTIONS(12492), 1,
      anon_sym_RPAREN,
    STATE(9065), 1,
      sym_gnu_asm_goto_list,
  [292059] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12311), 1,
      anon_sym_COLON,
    ACTIONS(12494), 1,
      anon_sym_RPAREN,
    STATE(8027), 1,
      sym_gnu_asm_input_operand_list,
  [292072] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12409), 1,
      anon_sym_COLON,
    ACTIONS(12496), 1,
      anon_sym_RPAREN,
    STATE(8028), 1,
      sym_gnu_asm_clobber_list,
  [292085] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(12498), 1,
      anon_sym_RPAREN,
    STATE(8041), 1,
      aux_sym_argument_list_repeat1,
  [292098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12351), 1,
      anon_sym_catch,
    STATE(2098), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [292109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12341), 1,
      anon_sym_catch,
    STATE(2275), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [292120] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(12500), 1,
      anon_sym_RPAREN,
    STATE(8041), 1,
      aux_sym_argument_list_repeat1,
  [292133] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12502), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [292146] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    STATE(7723), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12504), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [292157] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12506), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(3323), 1,
      sym_template_function,
  [292170] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12508), 1,
      anon_sym_COMMA,
    ACTIONS(12510), 1,
      anon_sym_RPAREN,
    STATE(8150), 1,
      aux_sym_requires_parameter_list_repeat1,
  [292183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12512), 1,
      anon_sym_SEMI,
    STATE(8067), 1,
      aux_sym_declaration_repeat1,
  [292196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    ACTIONS(12514), 1,
      anon_sym_constexpr,
    STATE(159), 1,
      sym_condition_clause,
  [292209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8968), 1,
      anon_sym_RPAREN,
    ACTIONS(12516), 1,
      anon_sym_COMMA,
    STATE(8041), 1,
      aux_sym_argument_list_repeat1,
  [292222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8693), 1,
      anon_sym_COMMA,
    ACTIONS(12519), 1,
      anon_sym_RBRACK,
    STATE(8276), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [292235] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12521), 1,
      sym_identifier,
    STATE(2219), 1,
      sym_template_type,
    STATE(4111), 1,
      sym_template_function,
  [292248] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12523), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [292261] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12525), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [292274] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    STATE(7759), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12527), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [292285] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12409), 1,
      anon_sym_COLON,
    ACTIONS(12529), 1,
      anon_sym_RPAREN,
    STATE(8014), 1,
      sym_gnu_asm_clobber_list,
  [292298] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12419), 1,
      anon_sym_COLON,
    ACTIONS(12531), 1,
      anon_sym_RPAREN,
    STATE(8858), 1,
      sym_gnu_asm_goto_list,
  [292311] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12533), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [292324] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    ACTIONS(12535), 1,
      anon_sym_constexpr,
    STATE(200), 1,
      sym_condition_clause,
  [292337] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12339), 1,
      anon_sym_COLON,
    ACTIONS(12537), 1,
      anon_sym_RPAREN,
    STATE(8029), 1,
      sym_gnu_asm_output_operand_list,
  [292350] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12311), 1,
      anon_sym_COLON,
    ACTIONS(12539), 1,
      anon_sym_RPAREN,
    STATE(8030), 1,
      sym_gnu_asm_input_operand_list,
  [292363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12543), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12541), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [292374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4510), 1,
      anon_sym_RBRACE,
    ACTIONS(12545), 1,
      anon_sym_COMMA,
    STATE(8129), 1,
      aux_sym_initializer_list_repeat1,
  [292387] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12547), 1,
      anon_sym_SEMI,
    STATE(8298), 1,
      aux_sym_declaration_repeat1,
  [292400] = 4,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12333), 1,
      anon_sym_LPAREN2,
    ACTIONS(12549), 1,
      aux_sym_preproc_include_token2,
    STATE(9581), 1,
      sym_preproc_argument_list,
  [292413] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12443), 1,
      anon_sym_COMMA,
    ACTIONS(12551), 1,
      anon_sym_RPAREN,
    STATE(8001), 1,
      aux_sym_preproc_params_repeat1,
  [292426] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8801), 1,
      anon_sym_RPAREN,
    STATE(8041), 1,
      aux_sym_argument_list_repeat1,
  [292439] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12315), 1,
      anon_sym_COMMA,
    ACTIONS(12553), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(8184), 1,
      aux_sym_attribute_declaration_repeat1,
  [292452] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12555), 1,
      anon_sym_GT2,
    STATE(8080), 1,
      aux_sym_template_argument_list_repeat1,
  [292465] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12557), 1,
      sym_identifier,
    STATE(2219), 1,
      sym_template_type,
    STATE(3955), 1,
      sym_template_function,
  [292478] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12315), 1,
      anon_sym_COMMA,
    ACTIONS(12559), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(8026), 1,
      aux_sym_attribute_declaration_repeat1,
  [292491] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    STATE(7892), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12561), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [292502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12351), 1,
      anon_sym_catch,
    STATE(2093), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [292513] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12563), 1,
      anon_sym_SEMI,
    STATE(8084), 1,
      aux_sym_declaration_repeat1,
  [292526] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12565), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [292539] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12567), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [292552] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12569), 1,
      anon_sym_GT2,
    STATE(8144), 1,
      aux_sym_template_parameter_list_repeat1,
  [292565] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12315), 1,
      anon_sym_COMMA,
    ACTIONS(12571), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(8119), 1,
      aux_sym_attribute_declaration_repeat1,
  [292578] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12573), 1,
      anon_sym_SEMI,
    STATE(7954), 1,
      aux_sym_declaration_repeat1,
  [292591] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12575), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [292604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12577), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [292613] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12579), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [292626] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12581), 1,
      anon_sym_SEMI,
    STATE(8035), 1,
      aux_sym_declaration_repeat1,
  [292639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12307), 1,
      anon_sym_catch,
    STATE(407), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [292650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12577), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [292659] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12339), 1,
      anon_sym_COLON,
    ACTIONS(12583), 1,
      anon_sym_RPAREN,
    STATE(8116), 1,
      sym_gnu_asm_output_operand_list,
  [292672] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12585), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [292685] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12587), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [292698] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12589), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [292711] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12315), 1,
      anon_sym_COMMA,
    ACTIONS(12591), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(8326), 1,
      aux_sym_attribute_declaration_repeat1,
  [292724] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12593), 1,
      anon_sym_GT2,
    STATE(8044), 1,
      aux_sym_template_argument_list_repeat1,
  [292737] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8773), 1,
      anon_sym_RPAREN,
    STATE(8141), 1,
      aux_sym_argument_list_repeat1,
  [292750] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12595), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [292763] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12339), 1,
      anon_sym_COLON,
    ACTIONS(12597), 1,
      anon_sym_RPAREN,
    STATE(8052), 1,
      sym_gnu_asm_output_operand_list,
  [292776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12599), 1,
      anon_sym_catch,
    STATE(370), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [292787] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    STATE(7824), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12601), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [292798] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5214), 1,
      anon_sym_LBRACE,
    ACTIONS(11973), 1,
      anon_sym_COLON_COLON,
    STATE(878), 1,
      sym_declaration_list,
  [292811] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    STATE(7708), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12603), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [292822] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8771), 1,
      anon_sym_RPAREN,
    STATE(8058), 1,
      aux_sym_argument_list_repeat1,
  [292835] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12315), 1,
      anon_sym_COMMA,
    ACTIONS(12605), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(8326), 1,
      aux_sym_attribute_declaration_repeat1,
  [292848] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    STATE(7649), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12607), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [292859] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12311), 1,
      anon_sym_COLON,
    ACTIONS(12609), 1,
      anon_sym_RPAREN,
    STATE(8047), 1,
      sym_gnu_asm_input_operand_list,
  [292872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12409), 1,
      anon_sym_COLON,
    ACTIONS(12611), 1,
      anon_sym_RPAREN,
    STATE(8048), 1,
      sym_gnu_asm_clobber_list,
  [292885] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    STATE(7838), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12613), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [292896] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    STATE(7631), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12615), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [292907] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11935), 1,
      anon_sym_COMMA,
    ACTIONS(11937), 1,
      anon_sym_LBRACE,
    STATE(8114), 1,
      aux_sym_base_class_clause_repeat1,
  [292920] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12617), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(4111), 1,
      sym_template_function,
  [292933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12619), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12621), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [292944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12623), 1,
      anon_sym_catch,
    STATE(262), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [292955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12625), 1,
      sym_identifier,
    ACTIONS(12627), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [292966] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12629), 1,
      anon_sym_SEMI,
    STATE(8071), 1,
      aux_sym_declaration_repeat1,
  [292979] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8755), 1,
      anon_sym_COMMA,
    ACTIONS(8757), 1,
      anon_sym_RBRACE,
    STATE(8198), 1,
      aux_sym_initializer_list_repeat1,
  [292992] = 4,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12333), 1,
      anon_sym_LPAREN2,
    ACTIONS(12631), 1,
      aux_sym_preproc_include_token2,
    STATE(9581), 1,
      sym_preproc_argument_list,
  [293005] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8719), 1,
      anon_sym_RPAREN,
    STATE(8041), 1,
      aux_sym_argument_list_repeat1,
  [293018] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12633), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [293031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12635), 1,
      anon_sym_catch,
    STATE(2070), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [293042] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12637), 1,
      anon_sym_SEMI,
    STATE(8159), 1,
      aux_sym_declaration_repeat1,
  [293055] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12639), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [293068] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12641), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [293081] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12339), 1,
      anon_sym_COLON,
    ACTIONS(12643), 1,
      anon_sym_RPAREN,
    STATE(8201), 1,
      sym_gnu_asm_output_operand_list,
  [293094] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(2936), 1,
      sym_template_function,
  [293107] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12339), 1,
      anon_sym_COLON,
    ACTIONS(12647), 1,
      anon_sym_RPAREN,
    STATE(8135), 1,
      sym_gnu_asm_output_operand_list,
  [293120] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12621), 1,
      anon_sym_LBRACE,
    ACTIONS(12649), 1,
      anon_sym_COMMA,
    STATE(8114), 1,
      aux_sym_base_class_clause_repeat1,
  [293133] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(12652), 1,
      anon_sym_RPAREN,
    STATE(8041), 1,
      aux_sym_argument_list_repeat1,
  [293146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12311), 1,
      anon_sym_COLON,
    ACTIONS(12654), 1,
      anon_sym_RPAREN,
    STATE(8132), 1,
      sym_gnu_asm_input_operand_list,
  [293159] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12315), 1,
      anon_sym_COMMA,
    ACTIONS(12656), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(8091), 1,
      aux_sym_attribute_declaration_repeat1,
  [293172] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12658), 1,
      anon_sym_SEMI,
    STATE(8240), 1,
      aux_sym_declaration_repeat1,
  [293185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12315), 1,
      anon_sym_COMMA,
    ACTIONS(12660), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(8326), 1,
      aux_sym_attribute_declaration_repeat1,
  [293198] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12662), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [293211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12664), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [293224] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11935), 1,
      anon_sym_COMMA,
    ACTIONS(11937), 1,
      anon_sym_LBRACE,
    STATE(8228), 1,
      aux_sym_base_class_clause_repeat1,
  [293237] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5208), 1,
      anon_sym_LBRACE,
    ACTIONS(11973), 1,
      anon_sym_COLON_COLON,
    STATE(1081), 1,
      sym_declaration_list,
  [293250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8693), 1,
      anon_sym_COMMA,
    ACTIONS(12666), 1,
      anon_sym_RBRACK,
    STATE(8276), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [293263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12670), 1,
      anon_sym_RPAREN,
    ACTIONS(12668), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [293274] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8582), 1,
      anon_sym_RPAREN,
    STATE(8177), 1,
      aux_sym_argument_list_repeat1,
  [293287] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    ACTIONS(12672), 1,
      anon_sym_constexpr,
    STATE(175), 1,
      sym_condition_clause,
  [293300] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12319), 1,
      anon_sym_COMMA,
    ACTIONS(12674), 1,
      anon_sym_RPAREN,
    STATE(8243), 1,
      aux_sym_parameter_list_repeat1,
  [293313] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8631), 1,
      anon_sym_RBRACE,
    ACTIONS(12676), 1,
      anon_sym_COMMA,
    STATE(8129), 1,
      aux_sym_initializer_list_repeat1,
  [293326] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12679), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(3323), 1,
      sym_template_function,
  [293339] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12681), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [293352] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12409), 1,
      anon_sym_COLON,
    ACTIONS(12683), 1,
      anon_sym_RPAREN,
    STATE(8241), 1,
      sym_gnu_asm_clobber_list,
  [293365] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LBRACE,
    ACTIONS(11973), 1,
      anon_sym_COLON_COLON,
    STATE(382), 1,
      sym_declaration_list,
  [293378] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5978), 1,
      anon_sym_COMMA,
    ACTIONS(12685), 1,
      anon_sym_RBRACK,
    STATE(8286), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [293391] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12311), 1,
      anon_sym_COLON,
    ACTIONS(12687), 1,
      anon_sym_RPAREN,
    STATE(8242), 1,
      sym_gnu_asm_input_operand_list,
  [293404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12689), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [293415] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12691), 1,
      anon_sym_COMMA,
    ACTIONS(12694), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [293428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8761), 1,
      anon_sym_COMMA,
    ACTIONS(8763), 1,
      anon_sym_RBRACE,
    STATE(8183), 1,
      aux_sym_initializer_list_repeat1,
  [293441] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12339), 1,
      anon_sym_COLON,
    ACTIONS(12696), 1,
      anon_sym_RPAREN,
    STATE(8187), 1,
      sym_gnu_asm_output_operand_list,
  [293454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12698), 1,
      anon_sym_GT2,
    STATE(8068), 1,
      aux_sym_template_parameter_list_repeat1,
  [293467] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8713), 1,
      anon_sym_RPAREN,
    STATE(8041), 1,
      aux_sym_argument_list_repeat1,
  [293480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12700), 1,
      anon_sym_GT2,
    STATE(8192), 1,
      aux_sym_template_argument_list_repeat1,
  [293493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12702), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [293502] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12704), 1,
      anon_sym_COMMA,
    ACTIONS(12707), 1,
      anon_sym_GT2,
    STATE(8144), 1,
      aux_sym_template_parameter_list_repeat1,
  [293515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11973), 3,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
  [293524] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12709), 1,
      anon_sym_GT2,
    STATE(8163), 1,
      aux_sym_template_argument_list_repeat1,
  [293537] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4484), 1,
      anon_sym_RBRACE,
    ACTIONS(12711), 1,
      anon_sym_COMMA,
    STATE(8129), 1,
      aux_sym_initializer_list_repeat1,
  [293550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12543), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12713), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [293561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12715), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [293570] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12717), 1,
      anon_sym_COMMA,
    ACTIONS(12720), 1,
      anon_sym_RPAREN,
    STATE(8150), 1,
      aux_sym_requires_parameter_list_repeat1,
  [293583] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12722), 1,
      anon_sym_COMMA,
    ACTIONS(12725), 1,
      anon_sym_RPAREN,
    STATE(8151), 1,
      aux_sym_parameter_list_repeat1,
  [293596] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8645), 1,
      anon_sym_COMMA,
    ACTIONS(12727), 1,
      anon_sym_RBRACK,
    STATE(8168), 1,
      aux_sym_subscript_argument_list_repeat1,
  [293609] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12729), 1,
      anon_sym_SEMI,
    STATE(8193), 1,
      aux_sym_declaration_repeat1,
  [293622] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12731), 1,
      anon_sym_COMMA,
    ACTIONS(12733), 1,
      anon_sym_RPAREN,
    STATE(8248), 1,
      aux_sym_throw_specifier_repeat1,
  [293635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12735), 1,
      anon_sym_catch,
    STATE(2301), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [293646] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8681), 1,
      anon_sym_COMMA,
    ACTIONS(12737), 1,
      anon_sym_RPAREN,
    STATE(8367), 1,
      aux_sym_generic_expression_repeat1,
  [293659] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12419), 1,
      anon_sym_COLON,
    ACTIONS(12739), 1,
      anon_sym_RPAREN,
    STATE(9309), 1,
      sym_gnu_asm_goto_list,
  [293672] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12741), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [293685] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12743), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [293698] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12319), 1,
      anon_sym_COMMA,
    ACTIONS(12745), 1,
      anon_sym_RPAREN,
    STATE(8195), 1,
      aux_sym_parameter_list_repeat1,
  [293711] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12747), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [293724] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12749), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [293737] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12751), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [293750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12623), 1,
      anon_sym_catch,
    STATE(263), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [293761] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8645), 1,
      anon_sym_COMMA,
    ACTIONS(8701), 1,
      anon_sym_RBRACK,
    STATE(8200), 1,
      aux_sym_subscript_argument_list_repeat1,
  [293774] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12753), 1,
      anon_sym_COMMA,
    ACTIONS(12756), 1,
      anon_sym_LBRACE,
    STATE(8166), 1,
      aux_sym_field_initializer_list_repeat1,
  [293787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12758), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [293796] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8994), 1,
      anon_sym_RBRACK,
    ACTIONS(12760), 1,
      anon_sym_COMMA,
    STATE(8168), 1,
      aux_sym_subscript_argument_list_repeat1,
  [293809] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12409), 1,
      anon_sym_COLON,
    ACTIONS(12763), 1,
      anon_sym_RPAREN,
    STATE(8157), 1,
      sym_gnu_asm_clobber_list,
  [293822] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12319), 1,
      anon_sym_COMMA,
    ACTIONS(12765), 1,
      anon_sym_RPAREN,
    STATE(8151), 1,
      aux_sym_parameter_list_repeat1,
  [293835] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12767), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [293848] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12419), 1,
      anon_sym_COLON,
    ACTIONS(12769), 1,
      anon_sym_RPAREN,
    STATE(9310), 1,
      sym_gnu_asm_goto_list,
  [293861] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10209), 1,
      anon_sym_RPAREN,
    ACTIONS(12771), 1,
      anon_sym_COMMA,
    STATE(8173), 1,
      aux_sym_preproc_argument_list_repeat1,
  [293874] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12311), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_RPAREN,
    STATE(8169), 1,
      sym_gnu_asm_input_operand_list,
  [293887] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12409), 1,
      anon_sym_COLON,
    ACTIONS(12776), 1,
      anon_sym_RPAREN,
    STATE(8172), 1,
      sym_gnu_asm_clobber_list,
  [293900] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12778), 1,
      anon_sym_COMMA,
    ACTIONS(12781), 1,
      anon_sym_RPAREN,
    STATE(8176), 1,
      aux_sym_preproc_params_repeat1,
  [293913] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8729), 1,
      anon_sym_RPAREN,
    STATE(8041), 1,
      aux_sym_argument_list_repeat1,
  [293926] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8685), 1,
      anon_sym_RPAREN,
    STATE(8314), 1,
      aux_sym_argument_list_repeat1,
  [293939] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12783), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [293952] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12785), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [293965] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12787), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [293978] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12339), 1,
      anon_sym_COLON,
    ACTIONS(12789), 1,
      anon_sym_RPAREN,
    STATE(8093), 1,
      sym_gnu_asm_output_operand_list,
  [293991] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4496), 1,
      anon_sym_RBRACE,
    ACTIONS(12791), 1,
      anon_sym_COMMA,
    STATE(8129), 1,
      aux_sym_initializer_list_repeat1,
  [294004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12315), 1,
      anon_sym_COMMA,
    ACTIONS(12793), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(8326), 1,
      aux_sym_attribute_declaration_repeat1,
  [294017] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(12795), 1,
      anon_sym_RPAREN,
    STATE(8041), 1,
      aux_sym_argument_list_repeat1,
  [294030] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12311), 1,
      anon_sym_COLON,
    ACTIONS(12797), 1,
      anon_sym_RPAREN,
    STATE(8094), 1,
      sym_gnu_asm_input_operand_list,
  [294043] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12311), 1,
      anon_sym_COLON,
    ACTIONS(12799), 1,
      anon_sym_RPAREN,
    STATE(8213), 1,
      sym_gnu_asm_input_operand_list,
  [294056] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12339), 1,
      anon_sym_COLON,
    ACTIONS(12801), 1,
      anon_sym_RPAREN,
    STATE(8215), 1,
      sym_gnu_asm_output_operand_list,
  [294069] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12803), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [294082] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12805), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [294095] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4494), 1,
      anon_sym_RBRACE,
    ACTIONS(12807), 1,
      anon_sym_COMMA,
    STATE(8129), 1,
      aux_sym_initializer_list_repeat1,
  [294108] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12809), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [294121] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12811), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [294134] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8721), 1,
      anon_sym_RPAREN,
    STATE(8352), 1,
      aux_sym_argument_list_repeat1,
  [294147] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12319), 1,
      anon_sym_COMMA,
    ACTIONS(12813), 1,
      anon_sym_RPAREN,
    STATE(8151), 1,
      aux_sym_parameter_list_repeat1,
  [294160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12635), 1,
      anon_sym_catch,
    STATE(2074), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [294171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12623), 1,
      anon_sym_catch,
    STATE(264), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [294182] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4508), 1,
      anon_sym_RBRACE,
    ACTIONS(12815), 1,
      anon_sym_COMMA,
    STATE(8129), 1,
      aux_sym_initializer_list_repeat1,
  [294195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12817), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [294208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8645), 1,
      anon_sym_COMMA,
    ACTIONS(12819), 1,
      anon_sym_RBRACK,
    STATE(8168), 1,
      aux_sym_subscript_argument_list_repeat1,
  [294221] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12311), 1,
      anon_sym_COLON,
    ACTIONS(12821), 1,
      anon_sym_RPAREN,
    STATE(8264), 1,
      sym_gnu_asm_input_operand_list,
  [294234] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12823), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [294247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12825), 1,
      anon_sym_catch,
    STATE(1153), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [294258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9999), 1,
      anon_sym_COMMA,
    ACTIONS(12827), 1,
      anon_sym_RPAREN,
    STATE(8173), 1,
      aux_sym_preproc_argument_list_repeat1,
  [294271] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12829), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(2936), 1,
      sym_template_function,
  [294284] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12831), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [294297] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12339), 1,
      anon_sym_COLON,
    ACTIONS(12833), 1,
      anon_sym_RPAREN,
    STATE(8174), 1,
      sym_gnu_asm_output_operand_list,
  [294310] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(12835), 1,
      anon_sym_RPAREN,
    STATE(8041), 1,
      aux_sym_argument_list_repeat1,
  [294323] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12311), 1,
      anon_sym_COLON,
    ACTIONS(12837), 1,
      anon_sym_RPAREN,
    STATE(8175), 1,
      sym_gnu_asm_input_operand_list,
  [294336] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4516), 1,
      anon_sym_RBRACE,
    ACTIONS(12839), 1,
      anon_sym_COMMA,
    STATE(8129), 1,
      aux_sym_initializer_list_repeat1,
  [294349] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12841), 1,
      anon_sym_GT2,
    STATE(8106), 1,
      aux_sym_template_argument_list_repeat1,
  [294362] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12339), 1,
      anon_sym_COLON,
    ACTIONS(12843), 1,
      anon_sym_RPAREN,
    STATE(8265), 1,
      sym_gnu_asm_output_operand_list,
  [294375] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12409), 1,
      anon_sym_COLON,
    ACTIONS(12845), 1,
      anon_sym_RPAREN,
    STATE(8224), 1,
      sym_gnu_asm_clobber_list,
  [294388] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8633), 1,
      anon_sym_RPAREN,
    STATE(8041), 1,
      aux_sym_argument_list_repeat1,
  [294401] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12311), 1,
      anon_sym_COLON,
    ACTIONS(12847), 1,
      anon_sym_RPAREN,
    STATE(8226), 1,
      sym_gnu_asm_input_operand_list,
  [294414] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12849), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [294427] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12851), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [294440] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12853), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [294453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12635), 1,
      anon_sym_catch,
    STATE(2073), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [294464] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12855), 1,
      anon_sym_GT2,
    STATE(8232), 1,
      aux_sym_template_argument_list_repeat1,
  [294477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12857), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12859), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [294488] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11935), 1,
      anon_sym_COMMA,
    ACTIONS(11992), 1,
      anon_sym_LBRACE,
    STATE(8261), 1,
      aux_sym_base_class_clause_repeat1,
  [294501] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12861), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [294514] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12419), 1,
      anon_sym_COLON,
    ACTIONS(12863), 1,
      anon_sym_RPAREN,
    STATE(9486), 1,
      sym_gnu_asm_goto_list,
  [294527] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12865), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [294540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12409), 1,
      anon_sym_COLON,
    ACTIONS(12867), 1,
      anon_sym_RPAREN,
    STATE(8233), 1,
      sym_gnu_asm_clobber_list,
  [294553] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12869), 1,
      anon_sym_SEMI,
    STATE(8199), 1,
      aux_sym_declaration_repeat1,
  [294566] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11935), 1,
      anon_sym_COMMA,
    ACTIONS(11992), 1,
      anon_sym_LBRACE,
    STATE(8114), 1,
      aux_sym_base_class_clause_repeat1,
  [294579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12871), 3,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
  [294588] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12873), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [294601] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12875), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [294614] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12877), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [294627] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12419), 1,
      anon_sym_COLON,
    ACTIONS(12879), 1,
      anon_sym_RPAREN,
    STATE(9363), 1,
      sym_gnu_asm_goto_list,
  [294640] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12881), 1,
      anon_sym_GT2,
    STATE(8202), 1,
      aux_sym_template_argument_list_repeat1,
  [294653] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8681), 1,
      anon_sym_COMMA,
    ACTIONS(12883), 1,
      anon_sym_RPAREN,
    STATE(8367), 1,
      aux_sym_generic_expression_repeat1,
  [294666] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12885), 1,
      anon_sym_GT2,
    STATE(8218), 1,
      aux_sym_template_argument_list_repeat1,
  [294679] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12887), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [294692] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12339), 1,
      anon_sym_COLON,
    ACTIONS(12889), 1,
      anon_sym_RPAREN,
    STATE(8209), 1,
      sym_gnu_asm_output_operand_list,
  [294705] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8687), 1,
      anon_sym_COMMA,
    ACTIONS(8689), 1,
      anon_sym_RBRACE,
    STATE(8210), 1,
      aux_sym_initializer_list_repeat1,
  [294718] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12891), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [294731] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12419), 1,
      anon_sym_COLON,
    ACTIONS(12893), 1,
      anon_sym_RPAREN,
    STATE(9542), 1,
      sym_gnu_asm_goto_list,
  [294744] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12409), 1,
      anon_sym_COLON,
    ACTIONS(12895), 1,
      anon_sym_RPAREN,
    STATE(8320), 1,
      sym_gnu_asm_clobber_list,
  [294757] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12319), 1,
      anon_sym_COMMA,
    ACTIONS(12897), 1,
      anon_sym_RPAREN,
    STATE(8151), 1,
      aux_sym_parameter_list_repeat1,
  [294770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11161), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [294779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12599), 1,
      anon_sym_catch,
    STATE(359), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [294790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7767), 1,
      anon_sym_EQ,
    ACTIONS(7765), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [294801] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11839), 1,
      anon_sym_DASH_GT,
    ACTIONS(12899), 1,
      anon_sym_SEMI,
    STATE(9565), 1,
      sym_trailing_return_type,
  [294814] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12731), 1,
      anon_sym_COMMA,
    ACTIONS(12901), 1,
      anon_sym_RPAREN,
    STATE(8325), 1,
      aux_sym_throw_specifier_repeat1,
  [294827] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8699), 1,
      anon_sym_RPAREN,
    STATE(8214), 1,
      aux_sym_argument_list_repeat1,
  [294840] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12903), 1,
      sym_identifier,
    STATE(3177), 1,
      sym_template_type,
    STATE(4355), 1,
      sym_template_function,
  [294853] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12315), 1,
      anon_sym_COMMA,
    ACTIONS(12905), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(8326), 1,
      aux_sym_attribute_declaration_repeat1,
  [294866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12907), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(7059), 1,
      sym_template_function,
  [294879] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12909), 1,
      anon_sym_SEMI,
    STATE(8223), 1,
      aux_sym_declaration_repeat1,
  [294892] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(12911), 1,
      anon_sym_RPAREN,
    STATE(8041), 1,
      aux_sym_argument_list_repeat1,
  [294905] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12913), 1,
      anon_sym_GT2,
    STATE(8258), 1,
      aux_sym_template_argument_list_repeat1,
  [294918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12915), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [294931] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12917), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [294944] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12919), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [294957] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11935), 1,
      anon_sym_COMMA,
    ACTIONS(12289), 1,
      anon_sym_LBRACE,
    STATE(8114), 1,
      aux_sym_base_class_clause_repeat1,
  [294970] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11935), 1,
      anon_sym_COMMA,
    ACTIONS(12289), 1,
      anon_sym_LBRACE,
    STATE(8097), 1,
      aux_sym_base_class_clause_repeat1,
  [294983] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11935), 1,
      anon_sym_COMMA,
    ACTIONS(12921), 1,
      anon_sym_LBRACE,
    STATE(8114), 1,
      aux_sym_base_class_clause_repeat1,
  [294996] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12508), 1,
      anon_sym_COMMA,
    ACTIONS(12923), 1,
      anon_sym_RPAREN,
    STATE(8038), 1,
      aux_sym_requires_parameter_list_repeat1,
  [295009] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6382), 1,
      anon_sym_SEMI,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(2153), 1,
      sym_template_argument_list,
  [295022] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12409), 1,
      anon_sym_COLON,
    ACTIONS(12925), 1,
      anon_sym_RPAREN,
    STATE(8266), 1,
      sym_gnu_asm_clobber_list,
  [295035] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12311), 1,
      anon_sym_COLON,
    ACTIONS(12927), 1,
      anon_sym_RPAREN,
    STATE(8267), 1,
      sym_gnu_asm_input_operand_list,
  [295048] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12419), 1,
      anon_sym_COLON,
    ACTIONS(12929), 1,
      anon_sym_RPAREN,
    STATE(9452), 1,
      sym_gnu_asm_goto_list,
  [295061] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12409), 1,
      anon_sym_COLON,
    ACTIONS(12931), 1,
      anon_sym_RPAREN,
    STATE(8272), 1,
      sym_gnu_asm_clobber_list,
  [295074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12933), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [295083] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12315), 1,
      anon_sym_COMMA,
    ACTIONS(12935), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(8251), 1,
      aux_sym_attribute_declaration_repeat1,
  [295096] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8645), 1,
      anon_sym_COMMA,
    ACTIONS(8737), 1,
      anon_sym_RBRACK,
    STATE(8152), 1,
      aux_sym_subscript_argument_list_repeat1,
  [295109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12937), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [295118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12419), 1,
      anon_sym_COLON,
    ACTIONS(12939), 1,
      anon_sym_RPAREN,
    STATE(9457), 1,
      sym_gnu_asm_goto_list,
  [295131] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5978), 1,
      anon_sym_COMMA,
    ACTIONS(12941), 1,
      anon_sym_RBRACK,
    STATE(8134), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [295144] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12943), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(3323), 1,
      sym_template_function,
  [295157] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8681), 1,
      anon_sym_COMMA,
    ACTIONS(12945), 1,
      anon_sym_RPAREN,
    STATE(8367), 1,
      aux_sym_generic_expression_repeat1,
  [295170] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9020), 1,
      anon_sym_RBRACK,
    ACTIONS(12947), 1,
      anon_sym_COMMA,
    STATE(8276), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [295183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12735), 1,
      anon_sym_catch,
    STATE(2288), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [295194] = 4,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12333), 1,
      anon_sym_LPAREN2,
    ACTIONS(12950), 1,
      aux_sym_preproc_include_token2,
    STATE(9581), 1,
      sym_preproc_argument_list,
  [295207] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12952), 1,
      anon_sym_GT2,
    STATE(8282), 1,
      aux_sym_template_argument_list_repeat1,
  [295220] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12954), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [295233] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12956), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [295246] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12958), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [295259] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8645), 1,
      anon_sym_COMMA,
    ACTIONS(8816), 1,
      anon_sym_RBRACK,
    STATE(7983), 1,
      aux_sym_subscript_argument_list_repeat1,
  [295272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12960), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12962), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [295283] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12964), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(3323), 1,
      sym_template_function,
  [295296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12966), 1,
      anon_sym_COMMA,
    ACTIONS(12969), 1,
      anon_sym_RBRACK,
    STATE(8286), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [295309] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12971), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(3323), 1,
      sym_template_function,
  [295322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12319), 1,
      anon_sym_COMMA,
    ACTIONS(12973), 1,
      anon_sym_RPAREN,
    STATE(8170), 1,
      aux_sym_parameter_list_repeat1,
  [295335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12975), 1,
      anon_sym_SEMI,
    STATE(8368), 1,
      aux_sym_declaration_repeat1,
  [295348] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11935), 1,
      anon_sym_COMMA,
    ACTIONS(12921), 1,
      anon_sym_LBRACE,
    STATE(8345), 1,
      aux_sym_base_class_clause_repeat1,
  [295361] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12977), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [295374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12979), 1,
      anon_sym_SEMI,
    STATE(8171), 1,
      aux_sym_declaration_repeat1,
  [295387] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12981), 1,
      anon_sym_SEMI,
    STATE(8025), 1,
      aux_sym_declaration_repeat1,
  [295400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12983), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [295409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12985), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [295418] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12987), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(4111), 1,
      sym_template_function,
  [295431] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12989), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [295444] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(12991), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [295457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12423), 1,
      anon_sym_catch,
    STATE(893), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [295468] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12993), 1,
      anon_sym_GT2,
    STATE(8303), 1,
      aux_sym_template_argument_list_repeat1,
  [295481] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12995), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [295494] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12997), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [295507] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(12999), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [295520] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12319), 1,
      anon_sym_COMMA,
    ACTIONS(13001), 1,
      anon_sym_RPAREN,
    STATE(8022), 1,
      aux_sym_parameter_list_repeat1,
  [295533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13005), 1,
      anon_sym_RPAREN,
    ACTIONS(13003), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [295544] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12315), 1,
      anon_sym_COMMA,
    ACTIONS(13007), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(8348), 1,
      aux_sym_attribute_declaration_repeat1,
  [295557] = 4,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12333), 1,
      anon_sym_LPAREN2,
    ACTIONS(13009), 1,
      aux_sym_preproc_include_token2,
    STATE(9581), 1,
      sym_preproc_argument_list,
  [295570] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12439), 1,
      anon_sym_COMMA,
    ACTIONS(13011), 1,
      anon_sym_LBRACE,
    STATE(8000), 1,
      aux_sym_field_initializer_list_repeat1,
  [295583] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8681), 1,
      anon_sym_COMMA,
    ACTIONS(13013), 1,
      anon_sym_RPAREN,
    STATE(8367), 1,
      aux_sym_generic_expression_repeat1,
  [295596] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(13015), 1,
      anon_sym_GT2,
    STATE(8179), 1,
      aux_sym_template_argument_list_repeat1,
  [295609] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12419), 1,
      anon_sym_COLON,
    ACTIONS(13017), 1,
      anon_sym_RPAREN,
    STATE(9531), 1,
      sym_gnu_asm_goto_list,
  [295622] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12409), 1,
      anon_sym_COLON,
    ACTIONS(13019), 1,
      anon_sym_RPAREN,
    STATE(8311), 1,
      sym_gnu_asm_clobber_list,
  [295635] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12339), 1,
      anon_sym_COLON,
    ACTIONS(13021), 1,
      anon_sym_RPAREN,
    STATE(8186), 1,
      sym_gnu_asm_output_operand_list,
  [295648] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8759), 1,
      anon_sym_RPAREN,
    STATE(8041), 1,
      aux_sym_argument_list_repeat1,
  [295661] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12419), 1,
      anon_sym_COLON,
    ACTIONS(13023), 1,
      anon_sym_RPAREN,
    STATE(9536), 1,
      sym_gnu_asm_goto_list,
  [295674] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12311), 1,
      anon_sym_COLON,
    ACTIONS(13025), 1,
      anon_sym_RPAREN,
    STATE(8312), 1,
      sym_gnu_asm_input_operand_list,
  [295687] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13027), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(3323), 1,
      sym_template_function,
  [295700] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12409), 1,
      anon_sym_COLON,
    ACTIONS(13029), 1,
      anon_sym_RPAREN,
    STATE(8315), 1,
      sym_gnu_asm_clobber_list,
  [295713] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8777), 1,
      anon_sym_COMMA,
    ACTIONS(8779), 1,
      anon_sym_RBRACE,
    STATE(8191), 1,
      aux_sym_initializer_list_repeat1,
  [295726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12419), 1,
      anon_sym_COLON,
    ACTIONS(13031), 1,
      anon_sym_RPAREN,
    STATE(9634), 1,
      sym_gnu_asm_goto_list,
  [295739] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(13033), 1,
      anon_sym_GT2,
    STATE(8324), 1,
      aux_sym_template_argument_list_repeat1,
  [295752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(13035), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [295765] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(13037), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [295778] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(13039), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [295791] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13041), 1,
      anon_sym_COMMA,
    ACTIONS(13044), 1,
      anon_sym_RPAREN,
    STATE(8325), 1,
      aux_sym_throw_specifier_repeat1,
  [295804] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13046), 1,
      anon_sym_COMMA,
    ACTIONS(13049), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(8326), 1,
      aux_sym_attribute_declaration_repeat1,
  [295817] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(13051), 1,
      anon_sym_RPAREN,
    STATE(8041), 1,
      aux_sym_argument_list_repeat1,
  [295830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12387), 1,
      anon_sym_catch,
    STATE(494), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [295841] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(13053), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [295854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8711), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [295863] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(13055), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [295876] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(13057), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [295889] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(13059), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [295902] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12339), 1,
      anon_sym_COLON,
    ACTIONS(13061), 1,
      anon_sym_RPAREN,
    STATE(8316), 1,
      sym_gnu_asm_output_operand_list,
  [295915] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12311), 1,
      anon_sym_COLON,
    ACTIONS(13063), 1,
      anon_sym_RPAREN,
    STATE(8318), 1,
      sym_gnu_asm_input_operand_list,
  [295928] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4490), 1,
      anon_sym_RBRACE,
    ACTIONS(13065), 1,
      anon_sym_COMMA,
    STATE(8129), 1,
      aux_sym_initializer_list_repeat1,
  [295941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12599), 1,
      anon_sym_catch,
    STATE(266), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [295952] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13067), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(4355), 1,
      sym_template_function,
  [295965] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    STATE(7763), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13069), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [295976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(13073), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [295987] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(13075), 1,
      anon_sym_GT2,
    STATE(8344), 1,
      aux_sym_template_argument_list_repeat1,
  [296000] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(13077), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [296013] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(13079), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [296026] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(13081), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [296039] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11935), 1,
      anon_sym_COMMA,
    ACTIONS(13083), 1,
      anon_sym_LBRACE,
    STATE(8114), 1,
      aux_sym_base_class_clause_repeat1,
  [296052] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    ACTIONS(13085), 1,
      anon_sym_constexpr,
    STATE(164), 1,
      sym_condition_clause,
  [296065] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8681), 1,
      anon_sym_COMMA,
    ACTIONS(13087), 1,
      anon_sym_RPAREN,
    STATE(8367), 1,
      aux_sym_generic_expression_repeat1,
  [296078] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12315), 1,
      anon_sym_COMMA,
    ACTIONS(13089), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(8326), 1,
      aux_sym_attribute_declaration_repeat1,
  [296091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13091), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [296100] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5210), 1,
      anon_sym_LBRACE,
    ACTIONS(11973), 1,
      anon_sym_COLON_COLON,
    STATE(582), 1,
      sym_declaration_list,
  [296113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13093), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [296122] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8584), 1,
      anon_sym_RPAREN,
    STATE(8041), 1,
      aux_sym_argument_list_repeat1,
  [296135] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_COMMA,
    ACTIONS(8797), 1,
      anon_sym_RPAREN,
    STATE(8105), 1,
      aux_sym_argument_list_repeat1,
  [296148] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    STATE(7918), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13095), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [296159] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12315), 1,
      anon_sym_COMMA,
    ACTIONS(13097), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(8326), 1,
      aux_sym_attribute_declaration_repeat1,
  [296172] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13099), 1,
      anon_sym_COMMA,
    ACTIONS(13101), 1,
      anon_sym_RPAREN,
    STATE(8373), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [296185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12387), 1,
      anon_sym_catch,
    STATE(515), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [296196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13103), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(2936), 1,
      sym_template_function,
  [296209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12315), 1,
      anon_sym_COMMA,
    ACTIONS(13105), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(8355), 1,
      aux_sym_attribute_declaration_repeat1,
  [296222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    ACTIONS(13107), 1,
      anon_sym_constexpr,
    STATE(212), 1,
      sym_condition_clause,
  [296235] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(13109), 1,
      anon_sym_GT2,
    STATE(8364), 1,
      aux_sym_template_argument_list_repeat1,
  [296248] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(13111), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [296261] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(13113), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [296274] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(13115), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [296287] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(13117), 1,
      anon_sym_SEMI,
    STATE(8237), 1,
      aux_sym_declaration_repeat1,
  [296300] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12735), 1,
      anon_sym_catch,
    STATE(2279), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [296311] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13119), 1,
      anon_sym_COMMA,
    ACTIONS(13122), 1,
      anon_sym_RPAREN,
    STATE(8367), 1,
      aux_sym_generic_expression_repeat1,
  [296324] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(13124), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [296337] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(13126), 1,
      anon_sym_SEMI,
    STATE(8023), 1,
      aux_sym_declaration_repeat1,
  [296350] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10079), 1,
      anon_sym_COMMA,
    ACTIONS(13128), 1,
      anon_sym_SEMI,
    STATE(8329), 1,
      aux_sym_declaration_repeat1,
  [296363] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13130), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [296372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13132), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [296381] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13099), 1,
      anon_sym_COMMA,
    ACTIONS(13134), 1,
      anon_sym_RPAREN,
    STATE(8374), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [296394] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13136), 1,
      anon_sym_COMMA,
    ACTIONS(13139), 1,
      anon_sym_RPAREN,
    STATE(8374), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [296407] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13141), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(3666), 1,
      sym_template_function,
  [296420] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(13143), 1,
      anon_sym_GT2,
    STATE(8331), 1,
      aux_sym_template_argument_list_repeat1,
  [296433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13145), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [296442] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13147), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(3323), 1,
      sym_template_function,
  [296455] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12339), 1,
      anon_sym_COLON,
    ACTIONS(13149), 1,
      anon_sym_RPAREN,
    STATE(8335), 1,
      sym_gnu_asm_output_operand_list,
  [296468] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13151), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [296477] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(13153), 1,
      anon_sym_GT2,
    STATE(8384), 1,
      aux_sym_template_argument_list_repeat1,
  [296490] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(13155), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [296503] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(13157), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [296516] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_COMMA,
    ACTIONS(13159), 1,
      anon_sym_GT2,
    STATE(8137), 1,
      aux_sym_template_argument_list_repeat1,
  [296529] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8703), 1,
      anon_sym_COMMA,
    ACTIONS(8705), 1,
      anon_sym_RBRACE,
    STATE(8336), 1,
      aux_sym_initializer_list_repeat1,
  [296542] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13161), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
    STATE(3323), 1,
      sym_template_function,
  [296555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(1005), 1,
      sym_compound_statement,
  [296565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    STATE(160), 1,
      sym_condition_clause,
  [296575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9265), 1,
      anon_sym_LT,
    STATE(2431), 1,
      sym_template_argument_list,
  [296585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10756), 1,
      anon_sym_RBRACE,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
  [296595] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13165), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13167), 1,
      sym_preproc_arg,
  [296605] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13169), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13171), 1,
      sym_preproc_arg,
  [296615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6657), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [296623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6653), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [296631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(2036), 1,
      sym_template_argument_list,
  [296641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6581), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [296649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6593), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [296657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6573), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [296665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10875), 1,
      anon_sym_LBRACE,
    STATE(2439), 1,
      sym_compound_statement,
  [296675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6569), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [296683] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6537), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [296691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6533), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [296699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9724), 1,
      anon_sym_LBRACE,
    STATE(5071), 1,
      sym_requirement_seq,
  [296709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6525), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [296717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13173), 1,
      anon_sym_LPAREN2,
    ACTIONS(13175), 1,
      sym_raw_string_delimiter,
  [296727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13177), 1,
      sym_identifier,
    STATE(8062), 1,
      sym_attribute,
  [296737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13179), 1,
      anon_sym_LPAREN2,
    ACTIONS(13181), 1,
      sym_raw_string_delimiter,
  [296747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13183), 1,
      anon_sym_LPAREN2,
    ACTIONS(13185), 1,
      sym_raw_string_delimiter,
  [296757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5210), 1,
      anon_sym_LBRACE,
    STATE(606), 1,
      sym_declaration_list,
  [296767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5210), 1,
      anon_sym_LBRACE,
    STATE(581), 1,
      sym_declaration_list,
  [296777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10768), 1,
      anon_sym_RBRACE,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
  [296787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13187), 1,
      anon_sym_LPAREN2,
    ACTIONS(13189), 1,
      sym_raw_string_delimiter,
  [296797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    STATE(8594), 1,
      sym_condition_clause,
  [296807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13191), 1,
      anon_sym_LPAREN2,
    ACTIONS(13193), 1,
      sym_raw_string_delimiter,
  [296817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    STATE(165), 1,
      sym_condition_clause,
  [296827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13195), 1,
      anon_sym_LPAREN2,
    ACTIONS(13197), 1,
      sym_raw_string_delimiter,
  [296837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13199), 1,
      anon_sym_LPAREN2,
    ACTIONS(13201), 1,
      sym_raw_string_delimiter,
  [296847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13203), 1,
      anon_sym_LPAREN2,
    ACTIONS(13205), 1,
      sym_raw_string_delimiter,
  [296857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13207), 1,
      anon_sym_LPAREN2,
    ACTIONS(13209), 1,
      sym_raw_string_delimiter,
  [296867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13211), 1,
      anon_sym_LPAREN2,
    ACTIONS(13213), 1,
      sym_raw_string_delimiter,
  [296877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(8075), 1,
      sym_compound_statement,
  [296887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13215), 1,
      anon_sym_LPAREN2,
    ACTIONS(13217), 1,
      sym_raw_string_delimiter,
  [296897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1117), 1,
      anon_sym_LBRACE,
    STATE(865), 1,
      sym_compound_statement,
  [296907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6597), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [296915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    STATE(3671), 1,
      sym_field_declaration_list,
  [296925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13219), 1,
      anon_sym_LPAREN2,
    ACTIONS(13221), 1,
      sym_raw_string_delimiter,
  [296935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    STATE(3670), 1,
      sym_field_declaration_list,
  [296945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_LBRACE,
    STATE(492), 1,
      sym_compound_statement,
  [296955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5475), 1,
      anon_sym_LBRACE,
    STATE(2670), 1,
      sym_field_declaration_list,
  [296965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5475), 1,
      anon_sym_LBRACE,
    STATE(2711), 1,
      sym_field_declaration_list,
  [296975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13223), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
  [296985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5475), 1,
      anon_sym_LBRACE,
    STATE(2669), 1,
      sym_field_declaration_list,
  [296995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13049), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [297003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13225), 1,
      anon_sym_LPAREN2,
    ACTIONS(13227), 1,
      sym_raw_string_delimiter,
  [297013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13229), 1,
      anon_sym_LPAREN2,
    ACTIONS(13231), 1,
      sym_raw_string_delimiter,
  [297023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13233), 1,
      anon_sym_LPAREN2,
    ACTIONS(13235), 1,
      sym_raw_string_delimiter,
  [297033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13237), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [297041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    STATE(9072), 1,
      sym_argument_list,
  [297051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13239), 1,
      anon_sym_LPAREN2,
    ACTIONS(13241), 1,
      sym_raw_string_delimiter,
  [297061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13177), 1,
      sym_identifier,
    STATE(8059), 1,
      sym_attribute,
  [297071] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13243), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13245), 1,
      sym_preproc_arg,
  [297081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(7841), 1,
      sym_compound_statement,
  [297091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13247), 1,
      anon_sym_LPAREN2,
    ACTIONS(13249), 1,
      sym_raw_string_delimiter,
  [297101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    STATE(9105), 1,
      sym_argument_list,
  [297111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13251), 1,
      anon_sym_LT,
    STATE(2436), 1,
      sym_template_argument_list,
  [297121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13253), 1,
      anon_sym_LT,
    STATE(2912), 1,
      sym_template_argument_list,
  [297131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9697), 1,
      anon_sym_LBRACE,
    STATE(4312), 1,
      sym_requirement_seq,
  [297141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    STATE(179), 1,
      sym_condition_clause,
  [297151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13255), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [297159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    STATE(8700), 1,
      sym_condition_clause,
  [297169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    STATE(216), 1,
      sym_condition_clause,
  [297179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1117), 1,
      anon_sym_LBRACE,
    STATE(991), 1,
      sym_compound_statement,
  [297189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1117), 1,
      anon_sym_LBRACE,
    STATE(705), 1,
      sym_compound_statement,
  [297199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
    ACTIONS(13257), 1,
      anon_sym_RBRACE,
  [297209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(7992), 1,
      sym_compound_statement,
  [297219] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13259), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13261), 1,
      sym_preproc_arg,
  [297229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13263), 1,
      sym_identifier,
    STATE(2422), 1,
      sym_template_type,
  [297239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    STATE(3695), 1,
      sym_field_declaration_list,
  [297249] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13265), 1,
      anon_sym_LPAREN2,
    STATE(8631), 1,
      sym_parenthesized_expression,
  [297259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13267), 1,
      anon_sym_LPAREN2,
    ACTIONS(13269), 1,
      sym_raw_string_delimiter,
  [297269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    STATE(3807), 1,
      sym_field_declaration_list,
  [297279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13073), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [297287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13271), 1,
      anon_sym_default,
    ACTIONS(13273), 1,
      anon_sym_delete,
  [297297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10875), 1,
      anon_sym_LBRACE,
    STATE(2418), 1,
      sym_compound_statement,
  [297307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    STATE(4631), 1,
      sym_field_declaration_list,
  [297317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    STATE(4606), 1,
      sym_field_declaration_list,
  [297327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    STATE(4609), 1,
      sym_field_declaration_list,
  [297337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LBRACE,
    STATE(4660), 1,
      sym_initializer_list,
  [297347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(801), 1,
      anon_sym_LBRACE,
    STATE(781), 1,
      sym_compound_statement,
  [297357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1899), 1,
      anon_sym_LBRACE,
    STATE(1180), 1,
      sym_compound_statement,
  [297367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 1,
      anon_sym_LBRACE,
    STATE(5545), 1,
      sym_initializer_list,
  [297377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    STATE(4648), 1,
      sym_field_declaration_list,
  [297387] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12969), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [297395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13275), 1,
      anon_sym_LT,
    STATE(4623), 1,
      sym_template_argument_list,
  [297405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1117), 1,
      anon_sym_LBRACE,
    STATE(678), 1,
      sym_compound_statement,
  [297415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13044), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [297423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13277), 1,
      anon_sym_LPAREN2,
    ACTIONS(13279), 1,
      sym_raw_string_delimiter,
  [297433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13281), 1,
      sym_identifier,
    ACTIONS(13283), 1,
      anon_sym_RPAREN,
  [297443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(2852), 1,
      sym_template_argument_list,
  [297453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13285), 1,
      sym_identifier,
    STATE(2693), 1,
      sym_template_type,
  [297463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13287), 1,
      anon_sym_LT,
    STATE(4282), 1,
      sym_template_argument_list,
  [297473] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13289), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13291), 1,
      sym_preproc_arg,
  [297483] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12668), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [297491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2739), 1,
      anon_sym_LBRACE,
    STATE(4222), 1,
      sym_initializer_list,
  [297501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12962), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [297509] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13293), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13295), 1,
      sym_preproc_arg,
  [297519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3729), 1,
      anon_sym_LBRACE,
    STATE(5106), 1,
      sym_initializer_list,
  [297529] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13297), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13299), 1,
      sym_preproc_arg,
  [297539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13301), 1,
      anon_sym_LT,
    STATE(2431), 1,
      sym_template_argument_list,
  [297549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13303), 1,
      sym_identifier,
    STATE(3304), 1,
      sym_template_type,
  [297559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    STATE(5675), 1,
      sym_field_declaration_list,
  [297569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
    ACTIONS(13305), 1,
      anon_sym_RBRACE,
  [297579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13307), 1,
      sym_identifier,
    ACTIONS(13309), 1,
      anon_sym_LPAREN2,
  [297589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10875), 1,
      anon_sym_LBRACE,
    STATE(2452), 1,
      sym_compound_statement,
  [297599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_LBRACE,
    STATE(521), 1,
      sym_compound_statement,
  [297609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11945), 1,
      anon_sym_LBRACE,
    STATE(2041), 1,
      sym_requirement_seq,
  [297619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10897), 1,
      anon_sym_LBRACE,
    STATE(2090), 1,
      sym_compound_statement,
  [297629] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13311), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13313), 1,
      sym_preproc_arg,
  [297639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13265), 1,
      anon_sym_LPAREN2,
    STATE(8931), 1,
      sym_parenthesized_expression,
  [297649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7733), 1,
      anon_sym_LT,
    STATE(3328), 1,
      sym_template_argument_list,
  [297659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11861), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
  [297669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13253), 1,
      anon_sym_LT,
    STATE(3531), 1,
      sym_template_argument_list,
  [297679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10863), 1,
      anon_sym_RBRACE,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
  [297689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(7994), 1,
      sym_compound_statement,
  [297699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    STATE(8743), 1,
      sym_parameter_list,
  [297709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    STATE(5676), 1,
      sym_field_declaration_list,
  [297719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    STATE(6099), 1,
      sym_field_declaration_list,
  [297729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    STATE(6101), 1,
      sym_field_declaration_list,
  [297739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    STATE(6103), 1,
      sym_field_declaration_list,
  [297749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8880), 1,
      anon_sym_LT,
    STATE(5551), 1,
      sym_template_argument_list,
  [297759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    STATE(6133), 1,
      sym_field_declaration_list,
  [297769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13315), 1,
      sym_identifier,
    STATE(2916), 1,
      sym_template_type,
  [297779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11973), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13317), 1,
      anon_sym_SEMI,
  [297789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12859), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [297797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1117), 1,
      anon_sym_LBRACE,
    STATE(617), 1,
      sym_compound_statement,
  [297807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10897), 1,
      anon_sym_LBRACE,
    STATE(2103), 1,
      sym_compound_statement,
  [297817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1899), 1,
      anon_sym_LBRACE,
    STATE(1202), 1,
      sym_compound_statement,
  [297827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
    ACTIONS(13319), 1,
      anon_sym_RBRACE,
  [297837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    STATE(5696), 1,
      sym_field_declaration_list,
  [297847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(7943), 1,
      sym_compound_statement,
  [297857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    STATE(5700), 1,
      sym_field_declaration_list,
  [297867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1899), 1,
      anon_sym_LBRACE,
    STATE(1156), 1,
      sym_compound_statement,
  [297877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1899), 1,
      anon_sym_LBRACE,
    STATE(1169), 1,
      sym_compound_statement,
  [297887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6208), 1,
      anon_sym_LBRACE,
    STATE(3158), 1,
      sym_field_declaration_list,
  [297897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12713), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [297905] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13321), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13323), 1,
      sym_preproc_arg,
  [297915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12781), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [297923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    STATE(3279), 1,
      sym_field_declaration_list,
  [297933] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8994), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [297941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
    ACTIONS(13325), 1,
      anon_sym_RBRACE,
  [297951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    STATE(324), 1,
      sym_compound_statement,
  [297961] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12756), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [297969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13327), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [297977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12725), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [297985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
    ACTIONS(13329), 1,
      anon_sym_RBRACE,
  [297995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13331), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [298003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
    ACTIONS(13333), 1,
      anon_sym_RBRACE,
  [298013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    STATE(8744), 1,
      sym_parameter_list,
  [298023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    STATE(3664), 1,
      sym_field_declaration_list,
  [298033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13265), 1,
      anon_sym_LPAREN2,
    STATE(8766), 1,
      sym_parenthesized_expression,
  [298043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12720), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [298051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_LBRACE,
    STATE(471), 1,
      sym_compound_statement,
  [298061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12707), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [298069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13335), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [298077] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13337), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13339), 1,
      sym_preproc_arg,
  [298087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6208), 1,
      anon_sym_LBRACE,
    STATE(3172), 1,
      sym_field_declaration_list,
  [298097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13341), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [298105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6208), 1,
      anon_sym_LBRACE,
    STATE(3180), 1,
      sym_field_declaration_list,
  [298115] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13343), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [298123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_LBRACE,
    STATE(597), 1,
      sym_compound_statement,
  [298133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13345), 1,
      anon_sym_LT,
    STATE(3662), 1,
      sym_template_argument_list,
  [298143] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8934), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [298151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8631), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [298159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10772), 1,
      anon_sym_RBRACE,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
  [298169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8810), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [298177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2231), 1,
      anon_sym_LBRACE,
    STATE(3693), 1,
      sym_initializer_list,
  [298187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(816), 1,
      sym_compound_statement,
  [298197] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13347), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13349), 1,
      sym_preproc_arg,
  [298207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13351), 1,
      sym_identifier,
    STATE(3086), 1,
      sym_template_type,
  [298217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13353), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [298225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    STATE(173), 1,
      sym_condition_clause,
  [298235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6649), 1,
      anon_sym_LBRACE,
    STATE(3437), 1,
      sym_field_declaration_list,
  [298245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13287), 1,
      anon_sym_LT,
    STATE(3197), 1,
      sym_template_argument_list,
  [298255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2297), 1,
      anon_sym_LBRACE,
    STATE(4082), 1,
      sym_initializer_list,
  [298265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(7740), 1,
      sym_compound_statement,
  [298275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5475), 1,
      anon_sym_LBRACE,
    STATE(2720), 1,
      sym_field_declaration_list,
  [298285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12084), 1,
      anon_sym_LBRACE,
    STATE(6575), 1,
      sym_requirement_seq,
  [298295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13355), 1,
      sym_identifier,
    ACTIONS(13357), 1,
      anon_sym_LPAREN2,
  [298305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(2812), 1,
      sym_template_argument_list,
  [298315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10905), 1,
      anon_sym_LBRACE,
    STATE(2295), 1,
      sym_compound_statement,
  [298325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13359), 1,
      sym_identifier,
    STATE(2219), 1,
      sym_template_type,
  [298335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6208), 1,
      anon_sym_LBRACE,
    STATE(3196), 1,
      sym_field_declaration_list,
  [298345] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13361), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13363), 1,
      sym_preproc_arg,
  [298355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9446), 1,
      anon_sym_LT,
    STATE(3195), 1,
      sym_template_argument_list,
  [298365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    STATE(9128), 1,
      sym_argument_list,
  [298375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    STATE(3272), 1,
      sym_field_declaration_list,
  [298385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    STATE(3260), 1,
      sym_field_declaration_list,
  [298395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10933), 1,
      anon_sym_RBRACE,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
  [298405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11973), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13365), 1,
      anon_sym_SEMI,
  [298415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    STATE(269), 1,
      sym_compound_statement,
  [298425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    STATE(9002), 1,
      sym_argument_list,
  [298435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10937), 1,
      anon_sym_RBRACE,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
  [298445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13367), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [298453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13177), 1,
      sym_identifier,
    STATE(8433), 1,
      sym_attribute,
  [298463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    STATE(8695), 1,
      sym_parameter_list,
  [298473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5214), 1,
      anon_sym_LBRACE,
    STATE(877), 1,
      sym_declaration_list,
  [298483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    STATE(8921), 1,
      sym_argument_list,
  [298493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13369), 1,
      sym_identifier,
    STATE(4635), 1,
      sym_template_type,
  [298503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6649), 1,
      anon_sym_LBRACE,
    STATE(3396), 1,
      sym_field_declaration_list,
  [298513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(8033), 1,
      sym_compound_statement,
  [298523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    STATE(2990), 1,
      sym_field_declaration_list,
  [298533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 1,
      anon_sym_LBRACE,
    STATE(3376), 1,
      sym_field_declaration_list,
  [298543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    STATE(163), 1,
      sym_condition_clause,
  [298553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(801), 1,
      anon_sym_LBRACE,
    STATE(757), 1,
      sym_compound_statement,
  [298563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(7981), 1,
      sym_compound_statement,
  [298573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
    ACTIONS(13371), 1,
      anon_sym_RBRACE,
  [298583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(777), 1,
      sym_compound_statement,
  [298593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    STATE(8764), 1,
      sym_parameter_list,
  [298603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_LBRACE,
    STATE(418), 1,
      sym_compound_statement,
  [298613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11973), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13373), 1,
      anon_sym_SEMI,
  [298623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(1003), 1,
      sym_compound_statement,
  [298633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5216), 1,
      anon_sym_LBRACE,
    STATE(925), 1,
      sym_declaration_list,
  [298643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13375), 1,
      anon_sym_LT,
    STATE(3135), 1,
      sym_template_argument_list,
  [298653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13377), 1,
      anon_sym_default,
    ACTIONS(13379), 1,
      anon_sym_delete,
  [298663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9716), 1,
      anon_sym_LBRACE,
    STATE(4108), 1,
      sym_requirement_seq,
  [298673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    STATE(444), 1,
      sym_compound_statement,
  [298683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    STATE(8927), 1,
      sym_argument_list,
  [298693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(801), 1,
      anon_sym_LBRACE,
    STATE(905), 1,
      sym_compound_statement,
  [298703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(7956), 1,
      sym_compound_statement,
  [298713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13177), 1,
      sym_identifier,
    STATE(7977), 1,
      sym_attribute,
  [298723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6649), 1,
      anon_sym_LBRACE,
    STATE(3400), 1,
      sym_field_declaration_list,
  [298733] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13381), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13383), 1,
      sym_preproc_arg,
  [298743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    STATE(9262), 1,
      sym_argument_list,
  [298753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13375), 1,
      anon_sym_LT,
    STATE(4169), 1,
      sym_template_argument_list,
  [298763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10905), 1,
      anon_sym_LBRACE,
    STATE(2293), 1,
      sym_compound_statement,
  [298773] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13385), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13387), 1,
      sym_preproc_arg,
  [298783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(8032), 1,
      sym_compound_statement,
  [298793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7891), 1,
      anon_sym_LBRACE,
    STATE(4762), 1,
      sym_field_declaration_list,
  [298803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
    ACTIONS(13389), 1,
      anon_sym_RBRACE,
  [298813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
    ACTIONS(13391), 1,
      anon_sym_RBRACE,
  [298823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9265), 1,
      anon_sym_LT,
    STATE(2036), 1,
      sym_template_argument_list,
  [298833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    STATE(8627), 1,
      sym_parameter_list,
  [298843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6649), 1,
      anon_sym_LBRACE,
    STATE(3406), 1,
      sym_field_declaration_list,
  [298853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13287), 1,
      anon_sym_LT,
    STATE(4060), 1,
      sym_template_argument_list,
  [298863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(7670), 1,
      sym_compound_statement,
  [298873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13393), 1,
      anon_sym_default,
    ACTIONS(13395), 1,
      anon_sym_delete,
  [298883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10897), 1,
      anon_sym_LBRACE,
    STATE(2108), 1,
      sym_compound_statement,
  [298893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7891), 1,
      anon_sym_LBRACE,
    STATE(4747), 1,
      sym_field_declaration_list,
  [298903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7891), 1,
      anon_sym_LBRACE,
    STATE(4755), 1,
      sym_field_declaration_list,
  [298913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    STATE(9194), 1,
      sym_argument_list,
  [298923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(801), 1,
      anon_sym_LBRACE,
    STATE(700), 1,
      sym_compound_statement,
  [298933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(8107), 1,
      sym_compound_statement,
  [298943] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13397), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13399), 1,
      sym_preproc_arg,
  [298953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13177), 1,
      sym_identifier,
    STATE(8117), 1,
      sym_attribute,
  [298963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8968), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [298971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_LBRACE,
    STATE(568), 1,
      sym_compound_statement,
  [298981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13401), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [298989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 1,
      anon_sym_LBRACE,
    STATE(3309), 1,
      sym_field_declaration_list,
  [298999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 1,
      anon_sym_LBRACE,
    STATE(3315), 1,
      sym_field_declaration_list,
  [299009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13265), 1,
      anon_sym_LPAREN2,
    STATE(8523), 1,
      sym_parenthesized_expression,
  [299019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(8196), 1,
      sym_compound_statement,
  [299029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4772), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [299037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    STATE(8522), 1,
      sym_parameter_list,
  [299047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10832), 1,
      anon_sym_RBRACE,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
  [299057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LBRACE,
    STATE(381), 1,
      sym_declaration_list,
  [299067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10782), 1,
      anon_sym_RBRACE,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
  [299077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8743), 1,
      anon_sym_RBRACK,
    ACTIONS(13403), 1,
      anon_sym_COMMA,
  [299087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9265), 1,
      anon_sym_LT,
    STATE(3159), 1,
      sym_template_argument_list,
  [299097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9748), 1,
      anon_sym_LBRACE,
    STATE(3815), 1,
      sym_requirement_seq,
  [299107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9708), 1,
      anon_sym_LBRACE,
    STATE(4487), 1,
      sym_requirement_seq,
  [299117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7891), 1,
      anon_sym_LBRACE,
    STATE(4739), 1,
      sym_field_declaration_list,
  [299127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6753), 1,
      anon_sym_LT,
    STATE(3328), 1,
      sym_template_argument_list,
  [299137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13405), 1,
      anon_sym_default,
    ACTIONS(13407), 1,
      anon_sym_delete,
  [299147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5216), 1,
      anon_sym_LBRACE,
    STATE(870), 1,
      sym_declaration_list,
  [299157] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13409), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13411), 1,
      sym_preproc_arg,
  [299167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10840), 1,
      anon_sym_RBRACE,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
  [299177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    STATE(9397), 1,
      sym_argument_list,
  [299187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(8203), 1,
      sym_compound_statement,
  [299197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13177), 1,
      sym_identifier,
    STATE(8269), 1,
      sym_attribute,
  [299207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    STATE(357), 1,
      sym_compound_statement,
  [299217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5208), 1,
      anon_sym_LBRACE,
    STATE(1102), 1,
      sym_declaration_list,
  [299227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    STATE(3019), 1,
      sym_field_declaration_list,
  [299237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13413), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [299245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    STATE(403), 1,
      sym_compound_statement,
  [299255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    STATE(3018), 1,
      sym_field_declaration_list,
  [299265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13265), 1,
      anon_sym_LPAREN2,
    STATE(8475), 1,
      sym_parenthesized_expression,
  [299275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9732), 1,
      anon_sym_LBRACE,
    STATE(3022), 1,
      sym_requirement_seq,
  [299285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(8328), 1,
      sym_compound_statement,
  [299295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5214), 1,
      anon_sym_LBRACE,
    STATE(916), 1,
      sym_declaration_list,
  [299305] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13415), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13417), 1,
      sym_preproc_arg,
  [299315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13419), 1,
      sym_identifier,
    STATE(4420), 1,
      sym_template_type,
  [299325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LBRACE,
    STATE(412), 1,
      sym_declaration_list,
  [299335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13421), 1,
      sym_identifier,
    STATE(2219), 1,
      sym_template_type,
  [299345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10828), 1,
      anon_sym_RBRACE,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
  [299355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    STATE(8464), 1,
      sym_parameter_list,
  [299365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13265), 1,
      anon_sym_LPAREN2,
    STATE(9606), 1,
      sym_parenthesized_expression,
  [299375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_LT,
    STATE(2036), 1,
      sym_template_argument_list,
  [299385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1117), 1,
      anon_sym_LBRACE,
    STATE(863), 1,
      sym_compound_statement,
  [299395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13423), 1,
      anon_sym_default,
    ACTIONS(13425), 1,
      anon_sym_delete,
  [299405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13345), 1,
      anon_sym_LT,
    STATE(2852), 1,
      sym_template_argument_list,
  [299415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13427), 1,
      anon_sym_default,
    ACTIONS(13429), 1,
      anon_sym_delete,
  [299425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6625), 1,
      anon_sym_LBRACE,
    STATE(3240), 1,
      sym_field_declaration_list,
  [299435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13265), 1,
      anon_sym_LPAREN2,
    STATE(9184), 1,
      sym_parenthesized_expression,
  [299445] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13431), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13433), 1,
      sym_preproc_arg,
  [299455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13435), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [299463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(7806), 1,
      sym_compound_statement,
  [299473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    STATE(9621), 1,
      sym_argument_list,
  [299483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13437), 1,
      sym_identifier,
    STATE(3194), 1,
      sym_template_type,
  [299493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(8366), 1,
      sym_compound_statement,
  [299503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    STATE(8470), 1,
      sym_condition_clause,
  [299513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    STATE(315), 1,
      sym_compound_statement,
  [299523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13177), 1,
      sym_identifier,
    STATE(8306), 1,
      sym_attribute,
  [299533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    STATE(190), 1,
      sym_condition_clause,
  [299543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 1,
      anon_sym_LBRACE,
    STATE(3366), 1,
      sym_field_declaration_list,
  [299553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10760), 1,
      anon_sym_LBRACE,
    STATE(2451), 1,
      sym_compound_statement,
  [299563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7706), 1,
      anon_sym_LBRACE,
    STATE(4703), 1,
      sym_field_declaration_list,
  [299573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13251), 1,
      anon_sym_LT,
    STATE(2852), 1,
      sym_template_argument_list,
  [299583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
    ACTIONS(13439), 1,
      anon_sym_RBRACE,
  [299593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    STATE(209), 1,
      sym_condition_clause,
  [299603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(836), 1,
      sym_compound_statement,
  [299613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13265), 1,
      anon_sym_LPAREN2,
    STATE(8495), 1,
      sym_parenthesized_expression,
  [299623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8836), 1,
      anon_sym_RPAREN,
    ACTIONS(8838), 1,
      anon_sym_SEMI,
  [299633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(8245), 1,
      sym_compound_statement,
  [299643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(801), 1,
      anon_sym_LBRACE,
    STATE(912), 1,
      sym_compound_statement,
  [299653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9241), 1,
      anon_sym_LBRACE,
    STATE(5854), 1,
      sym_field_declaration_list,
  [299663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    STATE(8515), 1,
      sym_parameter_list,
  [299673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13265), 1,
      anon_sym_LPAREN2,
    STATE(9326), 1,
      sym_parenthesized_expression,
  [299683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11973), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13441), 1,
      anon_sym_SEMI,
  [299693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13443), 1,
      anon_sym_default,
    ACTIONS(13445), 1,
      anon_sym_delete,
  [299703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12251), 1,
      anon_sym_LBRACE,
    STATE(6793), 1,
      sym_requirement_seq,
  [299713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10760), 1,
      anon_sym_LBRACE,
    STATE(2454), 1,
      sym_compound_statement,
  [299723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(781), 1,
      sym_compound_statement,
  [299733] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
    ACTIONS(13447), 1,
      anon_sym_RBRACE,
  [299743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    STATE(205), 1,
      sym_condition_clause,
  [299753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13449), 1,
      sym_identifier,
    STATE(3071), 1,
      sym_template_type,
  [299763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(7764), 1,
      sym_compound_statement,
  [299773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    STATE(9147), 1,
      sym_argument_list,
  [299783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13451), 1,
      sym_identifier,
    STATE(3177), 1,
      sym_template_type,
  [299793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6264), 1,
      anon_sym_LBRACE,
    STATE(2992), 1,
      sym_field_declaration_list,
  [299803] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13453), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13455), 1,
      sym_preproc_arg,
  [299813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7706), 1,
      anon_sym_LBRACE,
    STATE(4676), 1,
      sym_field_declaration_list,
  [299823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7706), 1,
      anon_sym_LBRACE,
    STATE(4677), 1,
      sym_field_declaration_list,
  [299833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12541), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [299841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(7974), 1,
      sym_compound_statement,
  [299851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13457), 1,
      anon_sym_LT,
    STATE(3159), 1,
      sym_template_argument_list,
  [299861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    STATE(162), 1,
      sym_condition_clause,
  [299871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2159), 1,
      anon_sym_LBRACE,
    STATE(2906), 1,
      sym_initializer_list,
  [299881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9689), 1,
      anon_sym_LBRACE,
    STATE(4044), 1,
      sym_requirement_seq,
  [299891] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13177), 1,
      sym_identifier,
    STATE(8069), 1,
      sym_attribute,
  [299901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    STATE(8678), 1,
      sym_condition_clause,
  [299911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    STATE(3734), 1,
      sym_field_declaration_list,
  [299921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    STATE(8691), 1,
      sym_condition_clause,
  [299931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10848), 1,
      anon_sym_RBRACE,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
  [299941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    STATE(201), 1,
      sym_condition_clause,
  [299951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13177), 1,
      sym_identifier,
    STATE(7975), 1,
      sym_attribute,
  [299961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10766), 1,
      anon_sym_RBRACE,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
  [299971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    STATE(3779), 1,
      sym_field_declaration_list,
  [299981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6521), 1,
      anon_sym_LT,
    STATE(3118), 1,
      sym_template_argument_list,
  [299991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(8100), 1,
      sym_compound_statement,
  [300001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9241), 1,
      anon_sym_LBRACE,
    STATE(5823), 1,
      sym_field_declaration_list,
  [300011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9241), 1,
      anon_sym_LBRACE,
    STATE(5838), 1,
      sym_field_declaration_list,
  [300021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2841), 1,
      anon_sym_LBRACE,
    STATE(4560), 1,
      sym_initializer_list,
  [300031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(801), 1,
      anon_sym_LBRACE,
    STATE(586), 1,
      sym_compound_statement,
  [300041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(613), 1,
      sym_compound_statement,
  [300051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    STATE(187), 1,
      sym_condition_clause,
  [300061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13459), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
  [300071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11973), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13461), 1,
      anon_sym_SEMI,
  [300081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13463), 1,
      sym_identifier,
    STATE(5576), 1,
      sym_template_type,
  [300091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13265), 1,
      anon_sym_LPAREN2,
    STATE(8660), 1,
      sym_parenthesized_expression,
  [300101] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13465), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13467), 1,
      sym_preproc_arg,
  [300111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(8155), 1,
      sym_compound_statement,
  [300121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    STATE(9063), 1,
      sym_argument_list,
  [300131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(7690), 1,
      sym_compound_statement,
  [300141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    STATE(213), 1,
      sym_condition_clause,
  [300151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13375), 1,
      anon_sym_LT,
    STATE(3975), 1,
      sym_template_argument_list,
  [300161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10760), 1,
      anon_sym_LBRACE,
    STATE(2445), 1,
      sym_compound_statement,
  [300171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    STATE(8599), 1,
      sym_parameter_list,
  [300181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13265), 1,
      anon_sym_LPAREN2,
    STATE(9230), 1,
      sym_parenthesized_expression,
  [300191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
    ACTIONS(13469), 1,
      anon_sym_RBRACE,
  [300201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6716), 1,
      anon_sym_LBRACE,
    STATE(3752), 1,
      sym_field_declaration_list,
  [300211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13471), 1,
      anon_sym_default,
    ACTIONS(13473), 1,
      anon_sym_delete,
  [300221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9241), 1,
      anon_sym_LBRACE,
    STATE(5841), 1,
      sym_field_declaration_list,
  [300231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9740), 1,
      anon_sym_LBRACE,
    STATE(5083), 1,
      sym_requirement_seq,
  [300241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10905), 1,
      anon_sym_LBRACE,
    STATE(2260), 1,
      sym_compound_statement,
  [300251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13475), 1,
      anon_sym_default,
    ACTIONS(13477), 1,
      anon_sym_delete,
  [300261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(700), 1,
      sym_compound_statement,
  [300271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13251), 1,
      anon_sym_LT,
    STATE(2812), 1,
      sym_template_argument_list,
  [300281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    STATE(206), 1,
      sym_condition_clause,
  [300291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(7835), 1,
      sym_compound_statement,
  [300301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8119), 1,
      anon_sym_LPAREN2,
    STATE(9569), 1,
      sym_argument_list,
  [300311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13479), 1,
      sym_identifier,
    STATE(2829), 1,
      sym_template_type,
  [300321] = 3,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13481), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13483), 1,
      sym_preproc_arg,
  [300331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(8337), 1,
      sym_compound_statement,
  [300341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13265), 1,
      anon_sym_LPAREN2,
    STATE(9167), 1,
      sym_parenthesized_expression,
  [300351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9870), 1,
      anon_sym_LPAREN2,
    STATE(8580), 1,
      sym_parameter_list,
  [300361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10555), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [300369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8832), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [300377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7706), 1,
      anon_sym_LBRACE,
    STATE(4699), 1,
      sym_field_declaration_list,
  [300387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(8197), 1,
      sym_compound_statement,
  [300397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13265), 1,
      anon_sym_LPAREN2,
    STATE(8557), 1,
      sym_parenthesized_expression,
  [300407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5208), 1,
      anon_sym_LBRACE,
    STATE(1077), 1,
      sym_declaration_list,
  [300417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13485), 1,
      sym_identifier,
    STATE(2219), 1,
      sym_template_type,
  [300427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7733), 1,
      anon_sym_LT,
    STATE(2036), 1,
      sym_template_argument_list,
  [300437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13177), 1,
      sym_identifier,
    STATE(8359), 1,
      sym_attribute,
  [300447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_LPAREN2,
    STATE(8428), 1,
      sym_condition_clause,
  [300457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13487), 1,
      sym_identifier,
  [300464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8990), 1,
      anon_sym_COLON,
  [300471] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13489), 1,
      anon_sym_SEMI,
  [300478] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13491), 1,
      anon_sym_SEMI,
  [300485] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13493), 1,
      anon_sym_SEMI,
  [300492] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13495), 1,
      anon_sym_SEMI,
  [300499] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13497), 1,
      sym_identifier,
  [300506] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13499), 1,
      anon_sym_COLON,
  [300513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13501), 1,
      anon_sym_RPAREN,
  [300520] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4633), 1,
      anon_sym_DOT_DOT_DOT,
  [300527] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13503), 1,
      aux_sym_preproc_if_token2,
  [300534] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13505), 1,
      anon_sym_SEMI,
  [300541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13507), 1,
      anon_sym_SEMI,
  [300548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13509), 1,
      anon_sym_RPAREN,
  [300555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13511), 1,
      sym_identifier,
  [300562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_EQ,
  [300569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13515), 1,
      anon_sym_RPAREN,
  [300576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13517), 1,
      anon_sym_RPAREN,
  [300583] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13519), 1,
      anon_sym_SEMI,
  [300590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12543), 1,
      anon_sym_COLON_COLON,
  [300597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10846), 1,
      anon_sym_RPAREN,
  [300604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13521), 1,
      anon_sym_SEMI,
  [300611] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13523), 1,
      sym_raw_string_delimiter,
  [300618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13525), 1,
      anon_sym_RPAREN,
  [300625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13527), 1,
      anon_sym_SEMI,
  [300632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13529), 1,
      anon_sym_RPAREN,
  [300639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13531), 1,
      anon_sym_COLON,
  [300646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13533), 1,
      anon_sym_SEMI,
  [300653] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13535), 1,
      anon_sym_SEMI,
  [300660] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13537), 1,
      aux_sym_preproc_if_token2,
  [300667] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13539), 1,
      anon_sym_DQUOTE,
  [300674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13541), 1,
      anon_sym_SEMI,
  [300681] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13543), 1,
      anon_sym_SEMI,
  [300688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13545), 1,
      anon_sym_RPAREN,
  [300695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13547), 1,
      anon_sym_SEMI,
  [300702] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13549), 1,
      aux_sym_preproc_include_token2,
  [300709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13551), 1,
      anon_sym_SEMI,
  [300716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_LT,
  [300723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13555), 1,
      anon_sym_SEMI,
  [300730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_LT_EQ,
  [300737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_GT_EQ,
  [300744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13557), 1,
      aux_sym_preproc_if_token2,
  [300751] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_GT,
  [300758] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11641), 1,
      anon_sym_COLON,
  [300765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13559), 1,
      aux_sym_preproc_if_token2,
  [300772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13561), 1,
      sym_identifier,
  [300779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_BANG_EQ,
  [300786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13563), 1,
      aux_sym_preproc_if_token2,
  [300793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13565), 1,
      sym_identifier,
  [300800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13567), 1,
      sym_identifier,
  [300807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_EQ_EQ,
  [300814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_AMP,
  [300821] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13569), 1,
      anon_sym_RPAREN,
  [300828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13571), 1,
      anon_sym_SEMI,
  [300835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_CARET,
  [300842] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11385), 1,
      anon_sym_SEMI,
  [300849] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13573), 1,
      anon_sym_RPAREN,
  [300856] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13575), 1,
      anon_sym_RPAREN,
  [300863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13577), 1,
      sym_identifier,
  [300870] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13579), 1,
      anon_sym_RPAREN,
  [300877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13581), 1,
      anon_sym_DQUOTE,
  [300884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13583), 1,
      anon_sym_SEMI,
  [300891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4729), 1,
      anon_sym_DOT_DOT_DOT,
  [300898] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13585), 1,
      anon_sym_SEMI,
  [300905] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10544), 1,
      sym_identifier,
  [300912] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13587), 1,
      anon_sym_RPAREN,
  [300919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13589), 1,
      anon_sym_STAR,
  [300926] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_PIPE,
  [300933] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13591), 1,
      sym_identifier,
  [300940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4638), 1,
      anon_sym_DOT_DOT_DOT,
  [300947] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_AMP_AMP,
  [300954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13593), 1,
      anon_sym_DQUOTE,
  [300961] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13595), 1,
      anon_sym_RPAREN,
  [300968] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4641), 1,
      anon_sym_DOT_DOT_DOT,
  [300975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4656), 1,
      anon_sym_DOT_DOT_DOT,
  [300982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4667), 1,
      anon_sym_DOT_DOT_DOT,
  [300989] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13597), 1,
      anon_sym_SEMI,
  [300996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13599), 1,
      anon_sym_SEMI,
  [301003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13601), 1,
      anon_sym_SEMI,
  [301010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13603), 1,
      aux_sym_preproc_if_token2,
  [301017] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4672), 1,
      anon_sym_DOT_DOT_DOT,
  [301024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13605), 1,
      anon_sym_LPAREN2,
  [301031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13607), 1,
      sym_identifier,
  [301038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4693), 1,
      anon_sym_DOT_DOT_DOT,
  [301045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4698), 1,
      anon_sym_DOT_DOT_DOT,
  [301052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13609), 1,
      sym_identifier,
  [301059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13611), 1,
      anon_sym_LPAREN2,
  [301066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13613), 1,
      anon_sym_RPAREN,
  [301073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13615), 1,
      anon_sym_SEMI,
  [301080] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13469), 1,
      anon_sym_RBRACE,
  [301087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4701), 1,
      anon_sym_DOT_DOT_DOT,
  [301094] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13617), 1,
      sym_identifier,
  [301101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_PERCENT,
  [301108] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13619), 1,
      aux_sym_preproc_include_token2,
  [301115] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13621), 1,
      anon_sym_LPAREN2,
  [301122] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13623), 1,
      anon_sym_RPAREN,
  [301129] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13625), 1,
      anon_sym_RPAREN,
  [301136] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13627), 1,
      sym_identifier,
  [301143] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13629), 1,
      aux_sym_preproc_if_token2,
  [301150] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4704), 1,
      anon_sym_DOT_DOT_DOT,
  [301157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4784), 1,
      anon_sym_DOT_DOT_DOT,
  [301164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13631), 1,
      anon_sym_SEMI,
  [301171] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13633), 1,
      anon_sym_SEMI,
  [301178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COLON,
  [301185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13635), 1,
      anon_sym_RPAREN,
  [301192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13637), 1,
      anon_sym_SLASH,
  [301199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13639), 1,
      sym_auto,
  [301206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13641), 1,
      sym_raw_string_content,
  [301213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4861), 1,
      anon_sym_SEMI,
  [301220] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13643), 1,
      anon_sym_DQUOTE,
  [301227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13645), 1,
      anon_sym_SEMI,
  [301234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_STAR,
  [301241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13647), 1,
      anon_sym_LBRACE,
  [301248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_PLUS,
  [301255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12277), 1,
      anon_sym_SEMI,
  [301262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13649), 1,
      anon_sym_DQUOTE,
  [301269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13651), 1,
      anon_sym_SEMI,
  [301276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13653), 1,
      sym_identifier,
  [301283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13655), 1,
      anon_sym_SEMI,
  [301290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13657), 1,
      anon_sym_SEMI,
  [301297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13659), 1,
      anon_sym_DQUOTE,
  [301304] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_DASH,
  [301311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10929), 1,
      anon_sym_RPAREN,
  [301318] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13661), 1,
      anon_sym_COLON,
  [301325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13663), 1,
      sym_raw_string_delimiter,
  [301332] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13665), 1,
      anon_sym_RPAREN,
  [301339] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13667), 1,
      anon_sym_STAR,
  [301346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13669), 1,
      anon_sym_RPAREN,
  [301353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13671), 1,
      anon_sym_SEMI,
  [301360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13673), 1,
      anon_sym_SEMI,
  [301367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13675), 1,
      anon_sym_SEMI,
  [301374] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12331), 1,
      aux_sym_preproc_include_token2,
  [301381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10766), 1,
      anon_sym_RBRACE,
  [301388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13677), 1,
      sym_identifier,
  [301395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13679), 1,
      sym_identifier,
  [301402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13681), 1,
      anon_sym_RPAREN,
  [301409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_COMMA,
  [301416] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13683), 1,
      anon_sym_SEMI,
  [301423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13685), 1,
      anon_sym_RPAREN,
  [301430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13687), 1,
      sym_identifier,
  [301437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10848), 1,
      anon_sym_RBRACE,
  [301444] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13689), 1,
      anon_sym_RPAREN,
  [301451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13691), 1,
      anon_sym_SEMI,
  [301458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13693), 1,
      sym_identifier,
  [301465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13695), 1,
      anon_sym_SEMI,
  [301472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13697), 1,
      anon_sym_SEMI,
  [301479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13699), 1,
      sym_identifier,
  [301486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13701), 1,
      sym_identifier,
  [301493] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13703), 1,
      aux_sym_preproc_include_token2,
  [301500] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12549), 1,
      aux_sym_preproc_include_token2,
  [301507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13705), 1,
      anon_sym_STAR,
  [301514] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13707), 1,
      aux_sym_preproc_include_token2,
  [301521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13709), 1,
      anon_sym_SEMI,
  [301528] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13711), 1,
      anon_sym_RPAREN,
  [301535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13713), 1,
      anon_sym_SEMI,
  [301542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13447), 1,
      anon_sym_RBRACE,
  [301549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13715), 1,
      anon_sym_RPAREN,
  [301556] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13717), 1,
      anon_sym_SEMI,
  [301563] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13719), 1,
      aux_sym_preproc_include_token2,
  [301570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7014), 1,
      anon_sym_RPAREN,
  [301577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13721), 1,
      anon_sym_RPAREN,
  [301584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13723), 1,
      anon_sym_LPAREN2,
  [301591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13725), 1,
      anon_sym_RPAREN,
  [301598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13727), 1,
      anon_sym_RPAREN,
  [301605] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13729), 1,
      anon_sym_RPAREN,
  [301612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13731), 1,
      anon_sym_RPAREN,
  [301619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13733), 1,
      anon_sym_RPAREN,
  [301626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13735), 1,
      anon_sym_RPAREN,
  [301633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13737), 1,
      anon_sym_LPAREN2,
  [301640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11341), 1,
      anon_sym_SEMI,
  [301647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13739), 1,
      anon_sym_RPAREN,
  [301654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13741), 1,
      aux_sym_preproc_if_token2,
  [301661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13743), 1,
      anon_sym_SEMI,
  [301668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13745), 1,
      sym_identifier,
  [301675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9008), 1,
      anon_sym_SEMI,
  [301682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13747), 1,
      anon_sym_RPAREN,
  [301689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13749), 1,
      anon_sym_RPAREN,
  [301696] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13751), 1,
      anon_sym_RPAREN,
  [301703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13753), 1,
      sym_identifier,
  [301710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13755), 1,
      aux_sym_preproc_if_token2,
  [301717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13757), 1,
      anon_sym_SEMI,
  [301724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_GT_GT,
  [301731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13759), 1,
      anon_sym_RPAREN,
  [301738] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13761), 1,
      aux_sym_preproc_include_token2,
  [301745] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13763), 1,
      sym_identifier,
  [301752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13765), 1,
      anon_sym_RPAREN,
  [301759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13767), 1,
      anon_sym_while,
  [301766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13769), 1,
      anon_sym_RPAREN,
  [301773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13771), 1,
      sym_auto,
  [301780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13773), 1,
      aux_sym_preproc_if_token2,
  [301787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8836), 1,
      anon_sym_RPAREN,
  [301794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8986), 1,
      anon_sym_COLON,
  [301801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13775), 1,
      aux_sym_preproc_if_token2,
  [301808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9006), 1,
      anon_sym_COLON,
  [301815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13777), 1,
      anon_sym_SEMI,
  [301822] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13779), 1,
      sym_identifier,
  [301829] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_EQ,
  [301836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13781), 1,
      sym_auto,
  [301843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10780), 1,
      anon_sym_RPAREN,
  [301850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8842), 1,
      anon_sym_SEMI,
  [301857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13783), 1,
      sym_raw_string_delimiter,
  [301864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13785), 1,
      anon_sym_SEMI,
  [301871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13787), 1,
      sym_identifier,
  [301878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8928), 1,
      anon_sym_SEMI,
  [301885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13439), 1,
      anon_sym_RBRACE,
  [301892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13789), 1,
      anon_sym_SEMI,
  [301899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13791), 1,
      anon_sym_SEMI,
  [301906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13793), 1,
      sym_identifier,
  [301913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13795), 1,
      anon_sym_RPAREN,
  [301920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13797), 1,
      anon_sym_DQUOTE,
  [301927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13799), 1,
      anon_sym_SEMI,
  [301934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13801), 1,
      anon_sym_RPAREN,
  [301941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13803), 1,
      anon_sym_RPAREN,
  [301948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13805), 1,
      anon_sym_STAR,
  [301955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10840), 1,
      anon_sym_RBRACE,
  [301962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8936), 1,
      anon_sym_COLON,
  [301969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13807), 1,
      anon_sym_RPAREN,
  [301976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13809), 1,
      anon_sym_SEMI,
  [301983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13811), 1,
      anon_sym_SEMI,
  [301990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13813), 1,
      anon_sym_DQUOTE,
  [301997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12200), 1,
      anon_sym_SEMI,
  [302004] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13815), 1,
      aux_sym_preproc_include_token2,
  [302011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13817), 1,
      aux_sym_preproc_if_token2,
  [302018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13819), 1,
      anon_sym_SEMI,
  [302025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13821), 1,
      anon_sym_RPAREN,
  [302032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9082), 1,
      anon_sym_RPAREN,
  [302039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13823), 1,
      anon_sym_SEMI,
  [302046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13825), 1,
      anon_sym_LPAREN2,
  [302053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8882), 1,
      anon_sym_SEMI,
  [302060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13827), 1,
      anon_sym_RPAREN,
  [302067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13829), 1,
      anon_sym_SEMI,
  [302074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7731), 1,
      sym_identifier,
  [302081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13831), 1,
      anon_sym_RPAREN,
  [302088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7439), 1,
      sym_identifier,
  [302095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13833), 1,
      sym_identifier,
  [302102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8888), 1,
      anon_sym_SEMI,
  [302109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_STAR_EQ,
  [302116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10828), 1,
      anon_sym_RBRACE,
  [302123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13835), 1,
      aux_sym_preproc_if_token2,
  [302130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13837), 1,
      anon_sym_RPAREN,
  [302137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13839), 1,
      anon_sym_RPAREN,
  [302144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13841), 1,
      anon_sym_RPAREN,
  [302151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11353), 1,
      anon_sym_SEMI,
  [302158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13843), 1,
      anon_sym_RPAREN,
  [302165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8717), 1,
      anon_sym_RBRACE,
  [302172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13845), 1,
      anon_sym_RPAREN,
  [302179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13847), 1,
      anon_sym_RPAREN,
  [302186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13849), 1,
      anon_sym_RPAREN,
  [302193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13851), 1,
      anon_sym_RPAREN,
  [302200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13853), 1,
      sym_identifier,
  [302207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13855), 1,
      aux_sym_preproc_if_token2,
  [302214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13857), 1,
      anon_sym_RPAREN,
  [302221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10746), 1,
      anon_sym_RPAREN,
  [302228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13859), 1,
      anon_sym_RPAREN,
  [302235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13861), 1,
      sym_raw_string_delimiter,
  [302242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8529), 1,
      anon_sym_RBRACE,
  [302249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13863), 1,
      sym_identifier,
  [302256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_SLASH_EQ,
  [302263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13865), 1,
      sym_identifier,
  [302270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13867), 1,
      anon_sym_STAR,
  [302277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13869), 1,
      aux_sym_preproc_if_token2,
  [302284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13871), 1,
      anon_sym_COLON,
  [302291] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10205), 1,
      aux_sym_preproc_include_token2,
  [302298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13873), 1,
      sym_identifier,
  [302305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_PIPE_PIPE,
  [302312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13875), 1,
      sym_identifier,
  [302319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_PERCENT_EQ,
  [302326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13877), 1,
      sym_identifier,
  [302333] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13879), 1,
      aux_sym_preproc_include_token2,
  [302340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13881), 1,
      anon_sym_RPAREN,
  [302347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_PLUS_EQ,
  [302354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13883), 1,
      anon_sym_RPAREN,
  [302361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13885), 1,
      anon_sym_LPAREN2,
  [302368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13887), 1,
      anon_sym_RPAREN,
  [302375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11367), 1,
      anon_sym_SEMI,
  [302382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13889), 1,
      aux_sym_preproc_if_token2,
  [302389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13891), 1,
      anon_sym_RPAREN,
  [302396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13893), 1,
      anon_sym_RPAREN,
  [302403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13895), 1,
      sym_identifier,
  [302410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13897), 1,
      anon_sym_RPAREN,
  [302417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13899), 1,
      sym_auto,
  [302424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13901), 1,
      anon_sym_RPAREN,
  [302431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13903), 1,
      anon_sym_DQUOTE,
  [302438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13905), 1,
      anon_sym_SEMI,
  [302445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13907), 1,
      anon_sym_RPAREN,
  [302452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10832), 1,
      anon_sym_RBRACE,
  [302459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13909), 1,
      anon_sym_RPAREN,
  [302466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13911), 1,
      sym_identifier,
  [302473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13913), 1,
      anon_sym_SEMI,
  [302480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13915), 1,
      anon_sym_COLON,
  [302487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13917), 1,
      anon_sym_RPAREN,
  [302494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13919), 1,
      anon_sym_COMMA,
  [302501] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10193), 1,
      aux_sym_preproc_include_token2,
  [302508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13921), 1,
      anon_sym_DQUOTE,
  [302515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8527), 1,
      anon_sym_SEMI,
  [302522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10782), 1,
      anon_sym_RBRACE,
  [302529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10854), 1,
      anon_sym_RPAREN,
  [302536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13923), 1,
      anon_sym_RPAREN,
  [302543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13925), 1,
      sym_raw_string_delimiter,
  [302550] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13927), 1,
      aux_sym_preproc_if_token2,
  [302557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13929), 1,
      sym_identifier,
  [302564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13931), 1,
      anon_sym_RPAREN,
  [302571] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13933), 1,
      anon_sym_RPAREN,
  [302578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8763), 1,
      anon_sym_RBRACE,
  [302585] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13935), 1,
      anon_sym_DQUOTE,
  [302592] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13937), 1,
      sym_identifier,
  [302599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13939), 1,
      anon_sym_SEMI,
  [302606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13941), 1,
      anon_sym_RPAREN,
  [302613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13943), 1,
      anon_sym_SEMI,
  [302620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13945), 1,
      anon_sym_RPAREN,
  [302627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13947), 1,
      anon_sym_SEMI,
  [302634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13949), 1,
      anon_sym_RPAREN,
  [302641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13951), 1,
      sym_identifier,
  [302648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13953), 1,
      aux_sym_preproc_if_token2,
  [302655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13955), 1,
      anon_sym_SEMI,
  [302662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13957), 1,
      anon_sym_STAR,
  [302669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13959), 1,
      anon_sym_LPAREN2,
  [302676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13961), 1,
      anon_sym_RPAREN,
  [302683] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13963), 1,
      aux_sym_preproc_if_token2,
  [302690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13965), 1,
      anon_sym_STAR,
  [302697] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13967), 1,
      anon_sym_RPAREN,
  [302704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13969), 1,
      sym_identifier,
  [302711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13971), 1,
      sym_identifier,
  [302718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13973), 1,
      anon_sym_SEMI,
  [302725] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13975), 1,
      sym_auto,
  [302732] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13389), 1,
      anon_sym_RBRACE,
  [302739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8992), 1,
      anon_sym_COLON,
  [302746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11831), 1,
      anon_sym_SEMI,
  [302753] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13977), 1,
      anon_sym_RPAREN,
  [302760] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13979), 1,
      aux_sym_preproc_include_token2,
  [302767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13981), 1,
      aux_sym_preproc_if_token2,
  [302774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13391), 1,
      anon_sym_RBRACE,
  [302781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13983), 1,
      anon_sym_RPAREN,
  [302788] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13985), 1,
      aux_sym_preproc_include_token2,
  [302795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13987), 1,
      anon_sym_SEMI,
  [302802] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13989), 1,
      anon_sym_STAR,
  [302809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13991), 1,
      sym_identifier,
  [302816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8912), 1,
      anon_sym_SEMI,
  [302823] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13993), 1,
      aux_sym_preproc_include_token2,
  [302830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10921), 1,
      anon_sym_RPAREN,
  [302837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13995), 1,
      anon_sym_DQUOTE,
  [302844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13997), 1,
      sym_raw_string_delimiter,
  [302851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13999), 1,
      anon_sym_RPAREN,
  [302858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14001), 1,
      sym_identifier,
  [302865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14003), 1,
      anon_sym_SEMI,
  [302872] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14005), 1,
      aux_sym_preproc_if_token2,
  [302879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14007), 1,
      anon_sym_SEMI,
  [302886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
  [302893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14009), 1,
      anon_sym_DQUOTE,
  [302900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14011), 1,
      sym_auto,
  [302907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14013), 1,
      anon_sym_DQUOTE,
  [302914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14015), 1,
      anon_sym_SEMI,
  [302921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4968), 1,
      anon_sym_SEMI,
  [302928] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14017), 1,
      sym_identifier,
  [302935] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14019), 1,
      aux_sym_preproc_if_token2,
  [302942] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11381), 1,
      anon_sym_SEMI,
  [302949] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(14021), 1,
      aux_sym_preproc_include_token2,
  [302956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14023), 1,
      anon_sym_SEMI,
  [302963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14025), 1,
      anon_sym_LPAREN2,
  [302970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14027), 1,
      aux_sym_preproc_if_token2,
  [302977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14029), 1,
      aux_sym_preproc_if_token2,
  [302984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14031), 1,
      anon_sym_RPAREN,
  [302991] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14033), 1,
      anon_sym_SEMI,
  [302998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14035), 1,
      anon_sym_SEMI,
  [303005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7423), 1,
      sym_identifier,
  [303012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12046), 1,
      anon_sym_SEMI,
  [303019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14037), 1,
      anon_sym_RPAREN,
  [303026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14039), 1,
      anon_sym_RPAREN,
  [303033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14041), 1,
      anon_sym_RPAREN,
  [303040] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14043), 1,
      anon_sym_RPAREN,
  [303047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14045), 1,
      anon_sym_RPAREN,
  [303054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14047), 1,
      anon_sym_SEMI,
  [303061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8914), 1,
      anon_sym_SEMI,
  [303068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13371), 1,
      anon_sym_RBRACE,
  [303075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14049), 1,
      anon_sym_SEMI,
  [303082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14051), 1,
      anon_sym_SEMI,
  [303089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10770), 1,
      anon_sym_RPAREN,
  [303096] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14053), 1,
      anon_sym_SEMI,
  [303103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14055), 1,
      sym_raw_string_delimiter,
  [303110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8785), 1,
      anon_sym_RBRACE,
  [303117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8980), 1,
      anon_sym_SEMI,
  [303124] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14057), 1,
      anon_sym_SEMI,
  [303131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8966), 1,
      anon_sym_SEMI,
  [303138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14059), 1,
      anon_sym_RPAREN,
  [303145] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14061), 1,
      anon_sym_LPAREN2,
  [303152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14063), 1,
      anon_sym_RPAREN,
  [303159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14065), 1,
      anon_sym_RPAREN,
  [303166] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14067), 1,
      anon_sym_RPAREN,
  [303173] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14069), 1,
      anon_sym_RPAREN,
  [303180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8898), 1,
      anon_sym_SEMI,
  [303187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14071), 1,
      anon_sym_SEMI,
  [303194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14073), 1,
      sym_raw_string_delimiter,
  [303201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10937), 1,
      anon_sym_RBRACE,
  [303208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10933), 1,
      anon_sym_RBRACE,
  [303215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_DASH_EQ,
  [303222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14075), 1,
      anon_sym_COLON,
  [303229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14077), 1,
      anon_sym_LPAREN2,
  [303236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14079), 1,
      sym_identifier,
  [303243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14081), 1,
      anon_sym_SEMI,
  [303250] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14083), 1,
      anon_sym_RPAREN,
  [303257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14085), 1,
      anon_sym_SEMI,
  [303264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14087), 1,
      sym_raw_string_delimiter,
  [303271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14089), 1,
      anon_sym_SEMI,
  [303278] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14091), 1,
      anon_sym_SEMI,
  [303285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14093), 1,
      sym_identifier,
  [303292] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14095), 1,
      anon_sym_LPAREN2,
  [303299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14097), 1,
      anon_sym_RPAREN,
  [303306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14099), 1,
      sym_raw_string_delimiter,
  [303313] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14101), 1,
      anon_sym_RPAREN,
  [303320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14103), 1,
      anon_sym_RPAREN,
  [303327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14105), 1,
      sym_raw_string_delimiter,
  [303334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14107), 1,
      anon_sym_DQUOTE,
  [303341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14109), 1,
      anon_sym_RPAREN,
  [303348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14111), 1,
      sym_raw_string_delimiter,
  [303355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14113), 1,
      anon_sym_RPAREN,
  [303362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14115), 1,
      sym_raw_string_delimiter,
  [303369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14117), 1,
      anon_sym_RPAREN,
  [303376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14119), 1,
      sym_raw_string_delimiter,
  [303383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14121), 1,
      anon_sym_RPAREN,
  [303390] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14123), 1,
      sym_raw_string_delimiter,
  [303397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14125), 1,
      anon_sym_RPAREN,
  [303404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14127), 1,
      sym_raw_string_delimiter,
  [303411] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14129), 1,
      anon_sym_RPAREN,
  [303418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14131), 1,
      sym_raw_string_delimiter,
  [303425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_LT_LT_EQ,
  [303432] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(14133), 1,
      aux_sym_preproc_include_token2,
  [303439] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14135), 1,
      anon_sym_RPAREN,
  [303446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14137), 1,
      anon_sym_LPAREN2,
  [303453] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14139), 1,
      anon_sym_RPAREN,
  [303460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14141), 1,
      anon_sym_LPAREN2,
  [303467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14143), 1,
      anon_sym_LPAREN2,
  [303474] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14145), 1,
      sym_identifier,
  [303481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14147), 1,
      anon_sym_RPAREN,
  [303488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14149), 1,
      anon_sym_LPAREN2,
  [303495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8757), 1,
      anon_sym_RBRACE,
  [303502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14151), 1,
      anon_sym_LPAREN2,
  [303509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14153), 1,
      anon_sym_LPAREN2,
  [303516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14155), 1,
      anon_sym_RPAREN,
  [303523] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14157), 1,
      anon_sym_RPAREN,
  [303530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7172), 1,
      anon_sym_RPAREN,
  [303537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14159), 1,
      sym_identifier,
  [303544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14161), 1,
      anon_sym_RPAREN,
  [303551] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(14163), 1,
      aux_sym_preproc_include_token2,
  [303558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_GT_GT_EQ,
  [303565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14165), 1,
      anon_sym_SEMI,
  [303572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_AMP_EQ,
  [303579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14167), 1,
      anon_sym_RPAREN,
  [303586] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14169), 1,
      sym_raw_string_delimiter,
  [303593] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12631), 1,
      aux_sym_preproc_include_token2,
  [303600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14171), 1,
      anon_sym_RPAREN,
  [303607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10830), 1,
      anon_sym_RPAREN,
  [303614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14173), 1,
      anon_sym_while,
  [303621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11347), 1,
      anon_sym_SEMI,
  [303628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14175), 1,
      anon_sym_LPAREN2,
  [303635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14177), 1,
      anon_sym_LPAREN2,
  [303642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14179), 1,
      anon_sym_RPAREN,
  [303649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14181), 1,
      anon_sym_RPAREN,
  [303656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14183), 1,
      anon_sym_LPAREN2,
  [303663] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14185), 1,
      anon_sym_EQ,
  [303670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14187), 1,
      sym_raw_string_content,
  [303677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11941), 1,
      anon_sym_SEMI,
  [303684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14189), 1,
      anon_sym_RPAREN,
  [303691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14191), 1,
      anon_sym_RPAREN,
  [303698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14193), 1,
      anon_sym_STAR,
  [303705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14195), 1,
      anon_sym_RPAREN,
  [303712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14197), 1,
      anon_sym_RPAREN,
  [303719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14199), 1,
      anon_sym_SEMI,
  [303726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14201), 1,
      anon_sym_SEMI,
  [303733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14203), 1,
      aux_sym_preproc_if_token2,
  [303740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9002), 1,
      anon_sym_COLON,
  [303747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14205), 1,
      anon_sym_RPAREN,
  [303754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8904), 1,
      anon_sym_RPAREN,
  [303761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_RPAREN,
  [303768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14207), 1,
      sym_identifier,
  [303775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14209), 1,
      anon_sym_RPAREN,
  [303782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14211), 1,
      anon_sym_COMMA,
  [303789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14213), 1,
      anon_sym_RPAREN,
  [303796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8920), 1,
      anon_sym_RPAREN,
  [303803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8964), 1,
      anon_sym_SEMI,
  [303810] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(14215), 1,
      aux_sym_preproc_include_token2,
  [303817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8916), 1,
      anon_sym_COLON,
  [303824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14217), 1,
      anon_sym_SEMI,
  [303831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14219), 1,
      aux_sym_preproc_if_token2,
  [303838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14221), 1,
      anon_sym_SEMI,
  [303845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14223), 1,
      anon_sym_SEMI,
  [303852] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10772), 1,
      anon_sym_RBRACE,
  [303859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14225), 1,
      anon_sym_RPAREN,
  [303866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14227), 1,
      anon_sym_COLON,
  [303873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14229), 1,
      sym_identifier,
  [303880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14231), 1,
      anon_sym_SEMI,
  [303887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14233), 1,
      anon_sym_RPAREN,
  [303894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14235), 1,
      anon_sym_SEMI,
  [303901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14237), 1,
      anon_sym_RPAREN,
  [303908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14239), 1,
      anon_sym_LPAREN2,
  [303915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14241), 1,
      sym_auto,
  [303922] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14243), 1,
      anon_sym_RPAREN,
  [303929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14245), 1,
      sym_identifier,
  [303936] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14247), 1,
      anon_sym_COLON,
  [303943] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14249), 1,
      anon_sym_RPAREN,
  [303950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14251), 1,
      anon_sym_RPAREN,
  [303957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14253), 1,
      anon_sym_RPAREN,
  [303964] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(14255), 1,
      aux_sym_preproc_include_token2,
  [303971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14257), 1,
      anon_sym_RPAREN,
  [303978] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_CARET_EQ,
  [303985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14259), 1,
      aux_sym_preproc_if_token2,
  [303992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14261), 1,
      anon_sym_STAR,
  [303999] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14263), 1,
      anon_sym_RPAREN,
  [304006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14265), 1,
      aux_sym_preproc_if_token2,
  [304013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14267), 1,
      anon_sym_SEMI,
  [304020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13329), 1,
      anon_sym_RBRACE,
  [304027] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14269), 1,
      anon_sym_SEMI,
  [304034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10919), 1,
      anon_sym_RPAREN,
  [304041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      sym_raw_string_delimiter,
  [304048] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14273), 1,
      aux_sym_preproc_if_token2,
  [304055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14275), 1,
      anon_sym_LBRACE,
  [304062] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14277), 1,
      aux_sym_preproc_if_token2,
  [304069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14279), 1,
      anon_sym_RPAREN,
  [304076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14281), 1,
      anon_sym_SEMI,
  [304083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14283), 1,
      sym_auto,
  [304090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13333), 1,
      anon_sym_RBRACE,
  [304097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14285), 1,
      anon_sym_SEMI,
  [304104] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14287), 1,
      anon_sym_SEMI,
  [304111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9000), 1,
      anon_sym_COLON,
  [304118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14289), 1,
      anon_sym_RPAREN,
  [304125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14291), 1,
      anon_sym_RPAREN,
  [304132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14293), 1,
      anon_sym_SEMI,
  [304139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14295), 1,
      anon_sym_SEMI,
  [304146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14297), 1,
      anon_sym_DQUOTE,
  [304153] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10223), 1,
      aux_sym_preproc_include_token2,
  [304160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14299), 1,
      anon_sym_SEMI,
  [304167] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14301), 1,
      anon_sym_DQUOTE,
  [304174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13325), 1,
      anon_sym_RBRACE,
  [304181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14303), 1,
      anon_sym_SEMI,
  [304188] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14305), 1,
      aux_sym_preproc_if_token2,
  [304195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14307), 1,
      aux_sym_preproc_if_token2,
  [304202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14309), 1,
      aux_sym_preproc_if_token2,
  [304209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14311), 1,
      anon_sym_RPAREN,
  [304216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14313), 1,
      aux_sym_preproc_if_token2,
  [304223] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14315), 1,
      aux_sym_preproc_if_token2,
  [304230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14317), 1,
      aux_sym_preproc_if_token2,
  [304237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_SEMI,
  [304244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14321), 1,
      anon_sym_SEMI,
  [304251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14323), 1,
      anon_sym_RPAREN,
  [304258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14325), 1,
      anon_sym_DQUOTE,
  [304265] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14327), 1,
      anon_sym_SEMI,
  [304272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14329), 1,
      anon_sym_RBRACE,
  [304279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14331), 1,
      anon_sym_SEMI,
  [304286] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14333), 1,
      anon_sym_SEMI,
  [304293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14335), 1,
      anon_sym_DQUOTE,
  [304300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14337), 1,
      sym_identifier,
  [304307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14339), 1,
      aux_sym_preproc_if_token2,
  [304314] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11433), 1,
      anon_sym_COMMA,
  [304321] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14341), 1,
      anon_sym_SEMI,
  [304328] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14343), 1,
      anon_sym_RBRACE,
  [304335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14345), 1,
      anon_sym_SEMI,
  [304342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14347), 1,
      sym_identifier,
  [304349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14349), 1,
      aux_sym_preproc_if_token2,
  [304356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13319), 1,
      anon_sym_RBRACE,
  [304363] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14351), 1,
      anon_sym_SEMI,
  [304370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14353), 1,
      anon_sym_DQUOTE,
  [304377] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(14355), 1,
      aux_sym_preproc_include_token2,
  [304384] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14357), 1,
      anon_sym_SEMI,
  [304391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14359), 1,
      anon_sym_DQUOTE,
  [304398] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14361), 1,
      anon_sym_SEMI,
  [304405] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9018), 1,
      anon_sym_COLON,
  [304412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14363), 1,
      anon_sym_SEMI,
  [304419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14365), 1,
      anon_sym_SEMI,
  [304426] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14367), 1,
      anon_sym_SEMI,
  [304433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14369), 1,
      sym_auto,
  [304440] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4939), 1,
      anon_sym_SEMI,
  [304447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14371), 1,
      anon_sym_SEMI,
  [304454] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_PIPE_EQ,
  [304461] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14373), 1,
      anon_sym_SEMI,
  [304468] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12670), 1,
      anon_sym_RPAREN,
  [304475] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8894), 1,
      anon_sym_RPAREN,
  [304482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8890), 1,
      anon_sym_RPAREN,
  [304489] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14375), 1,
      anon_sym_SEMI,
  [304496] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14377), 1,
      anon_sym_RPAREN,
  [304503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12002), 1,
      anon_sym_SEMI,
  [304510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14379), 1,
      anon_sym_RPAREN,
  [304517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14381), 1,
      aux_sym_preproc_if_token2,
  [304524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9188), 1,
      anon_sym_RPAREN,
  [304531] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_LT_LT,
  [304538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7202), 1,
      anon_sym_RPAREN,
  [304545] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8884), 1,
      anon_sym_RPAREN,
  [304552] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14383), 1,
      aux_sym_preproc_if_token2,
  [304559] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14385), 1,
      anon_sym_RPAREN,
  [304566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14387), 1,
      anon_sym_SEMI,
  [304573] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14389), 1,
      anon_sym_RBRACK,
  [304580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14391), 1,
      anon_sym_RPAREN,
  [304587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14393), 1,
      anon_sym_RPAREN,
  [304594] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14395), 1,
      sym_identifier,
  [304601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14397), 1,
      sym_identifier,
  [304608] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14399), 1,
      anon_sym_RPAREN,
  [304615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14401), 1,
      anon_sym_LPAREN2,
  [304622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8689), 1,
      anon_sym_RBRACE,
  [304629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14403), 1,
      anon_sym_DQUOTE,
  [304636] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14405), 1,
      sym_identifier,
  [304643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12086), 1,
      anon_sym_SEMI,
  [304650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14407), 1,
      anon_sym_SEMI,
  [304657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14409), 1,
      anon_sym_DQUOTE,
  [304664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10863), 1,
      anon_sym_RBRACE,
  [304671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12899), 1,
      anon_sym_SEMI,
  [304678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14411), 1,
      aux_sym_preproc_if_token2,
  [304685] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14413), 1,
      aux_sym_preproc_if_token2,
  [304692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14415), 1,
      anon_sym_STAR,
  [304699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14417), 1,
      anon_sym_RBRACE,
  [304706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14419), 1,
      aux_sym_preproc_if_token2,
  [304713] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14421), 1,
      anon_sym_LPAREN2,
  [304720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14423), 1,
      anon_sym_LPAREN2,
  [304727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14425), 1,
      anon_sym_LPAREN2,
  [304734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14427), 1,
      anon_sym_RPAREN,
  [304741] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14429), 1,
      anon_sym_LPAREN2,
  [304748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14431), 1,
      sym_identifier,
  [304755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14433), 1,
      anon_sym_RPAREN,
  [304762] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14435), 1,
      aux_sym_preproc_if_token2,
  [304769] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14437), 1,
      anon_sym_RBRACE,
  [304776] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14439), 1,
      anon_sym_while,
  [304783] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(14441), 1,
      aux_sym_preproc_include_token2,
  [304790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14443), 1,
      anon_sym_LPAREN2,
  [304797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14445), 1,
      anon_sym_RPAREN,
  [304804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14447), 1,
      aux_sym_preproc_if_token2,
  [304811] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14449), 1,
      aux_sym_preproc_if_token2,
  [304818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14451), 1,
      anon_sym_EQ,
  [304825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14453), 1,
      sym_raw_string_content,
  [304832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14455), 1,
      aux_sym_preproc_if_token2,
  [304839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14457), 1,
      anon_sym_RPAREN,
  [304846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14459), 1,
      anon_sym_COMMA,
  [304853] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14461), 1,
      anon_sym_RPAREN,
  [304860] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(14463), 1,
      aux_sym_preproc_include_token2,
  [304867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14465), 1,
      anon_sym_STAR,
  [304874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14467), 1,
      anon_sym_RPAREN,
  [304881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14469), 1,
      anon_sym_COLON,
  [304888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14471), 1,
      anon_sym_SEMI,
  [304895] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14473), 1,
      anon_sym_SEMI,
  [304902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14475), 1,
      anon_sym_LPAREN2,
  [304909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14477), 1,
      anon_sym_LPAREN2,
  [304916] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14479), 1,
      sym_raw_string_content,
  [304923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14481), 1,
      anon_sym_LPAREN2,
  [304930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14483), 1,
      anon_sym_RPAREN,
  [304937] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11285), 1,
      anon_sym_SEMI,
  [304944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14485), 1,
      anon_sym_while,
  [304951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14487), 1,
      anon_sym_RBRACE,
  [304958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14489), 1,
      anon_sym_LPAREN2,
  [304965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13305), 1,
      anon_sym_RBRACE,
  [304972] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(14491), 1,
      aux_sym_preproc_include_token2,
  [304979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14493), 1,
      anon_sym_EQ,
  [304986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14495), 1,
      sym_raw_string_content,
  [304993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7241), 1,
      sym_identifier,
  [305000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14497), 1,
      anon_sym_COMMA,
  [305007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14499), 1,
      anon_sym_RPAREN,
  [305014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14501), 1,
      anon_sym_LBRACE,
  [305021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14503), 1,
      sym_identifier,
  [305028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14505), 1,
      anon_sym_RPAREN,
  [305035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14507), 1,
      anon_sym_COLON,
  [305042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14509), 1,
      aux_sym_preproc_if_token2,
  [305049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14511), 1,
      aux_sym_preproc_if_token2,
  [305056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14513), 1,
      anon_sym_LPAREN2,
  [305063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14515), 1,
      anon_sym_LPAREN2,
  [305070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14517), 1,
      anon_sym_SEMI,
  [305077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14519), 1,
      anon_sym_LPAREN2,
  [305084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8838), 1,
      anon_sym_SEMI,
  [305091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14521), 1,
      anon_sym_SEMI,
  [305098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14523), 1,
      anon_sym_while,
  [305105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14525), 1,
      anon_sym_DQUOTE,
  [305112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14527), 1,
      anon_sym_LPAREN2,
  [305119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14529), 1,
      anon_sym_RPAREN,
  [305126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14531), 1,
      sym_identifier,
  [305133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14533), 1,
      anon_sym_EQ,
  [305140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14535), 1,
      sym_raw_string_content,
  [305147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14537), 1,
      anon_sym_COMMA,
  [305154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14539), 1,
      anon_sym_RPAREN,
  [305161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14541), 1,
      anon_sym_RPAREN,
  [305168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14543), 1,
      anon_sym_SEMI,
  [305175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14545), 1,
      anon_sym_RPAREN,
  [305182] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14547), 1,
      anon_sym_COLON,
  [305189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14549), 1,
      anon_sym_RPAREN,
  [305196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14551), 1,
      anon_sym_LPAREN2,
  [305203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14553), 1,
      anon_sym_LPAREN2,
  [305210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14555), 1,
      anon_sym_RPAREN,
  [305217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14557), 1,
      anon_sym_LPAREN2,
  [305224] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(12950), 1,
      aux_sym_preproc_include_token2,
  [305231] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14559), 1,
      anon_sym_SEMI,
  [305238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14561), 1,
      anon_sym_while,
  [305245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14563), 1,
      anon_sym_LPAREN2,
  [305252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14565), 1,
      anon_sym_RPAREN,
  [305259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8910), 1,
      anon_sym_COLON,
  [305266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14567), 1,
      anon_sym_EQ,
  [305273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14569), 1,
      sym_raw_string_content,
  [305280] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14571), 1,
      anon_sym_COMMA,
  [305287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8988), 1,
      anon_sym_COLON,
  [305294] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(14573), 1,
      aux_sym_preproc_include_token2,
  [305301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14575), 1,
      anon_sym_SEMI,
  [305308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14577), 1,
      anon_sym_RPAREN,
  [305315] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14579), 1,
      anon_sym_COLON,
  [305322] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14581), 1,
      anon_sym_SEMI,
  [305329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14583), 1,
      anon_sym_LPAREN2,
  [305336] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14585), 1,
      anon_sym_LPAREN2,
  [305343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14587), 1,
      anon_sym_SEMI,
  [305350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14589), 1,
      anon_sym_LPAREN2,
  [305357] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14591), 1,
      anon_sym_RPAREN,
  [305364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14593), 1,
      anon_sym_DQUOTE,
  [305371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14595), 1,
      anon_sym_LPAREN2,
  [305378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14597), 1,
      anon_sym_COLON,
  [305385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14599), 1,
      anon_sym_SEMI,
  [305392] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14601), 1,
      anon_sym_EQ,
  [305399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14603), 1,
      sym_raw_string_content,
  [305406] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14605), 1,
      anon_sym_COMMA,
  [305413] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14607), 1,
      anon_sym_SEMI,
  [305420] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14609), 1,
      sym_auto,
  [305427] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14611), 1,
      anon_sym_SEMI,
  [305434] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14613), 1,
      anon_sym_RPAREN,
  [305441] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14615), 1,
      anon_sym_COLON,
  [305448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9004), 1,
      anon_sym_RPAREN,
  [305455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14617), 1,
      anon_sym_LPAREN2,
  [305462] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14619), 1,
      anon_sym_LPAREN2,
  [305469] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(14621), 1,
      aux_sym_preproc_include_token2,
  [305476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14623), 1,
      anon_sym_LPAREN2,
  [305483] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON_COLON,
  [305490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9034), 1,
      anon_sym_RPAREN,
  [305497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14625), 1,
      anon_sym_LPAREN2,
  [305504] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14627), 1,
      anon_sym_SEMI,
  [305511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14629), 1,
      anon_sym_DQUOTE,
  [305518] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14631), 1,
      anon_sym_EQ,
  [305525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14633), 1,
      sym_raw_string_content,
  [305532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14635), 1,
      anon_sym_COMMA,
  [305539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14637), 1,
      anon_sym_SEMI,
  [305546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14639), 1,
      anon_sym_RPAREN,
  [305553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14641), 1,
      anon_sym_RPAREN,
  [305560] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14643), 1,
      anon_sym_RPAREN,
  [305567] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14645), 1,
      anon_sym_COLON,
  [305574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14647), 1,
      anon_sym_RPAREN,
  [305581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14649), 1,
      anon_sym_LPAREN2,
  [305588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14651), 1,
      anon_sym_RPAREN,
  [305595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14653), 1,
      anon_sym_LPAREN2,
  [305602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14655), 1,
      anon_sym_RPAREN,
  [305609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14657), 1,
      anon_sym_RPAREN,
  [305616] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4887), 1,
      anon_sym_SEMI,
  [305623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14659), 1,
      anon_sym_RBRACK,
  [305630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14661), 1,
      anon_sym_EQ,
  [305637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14663), 1,
      sym_raw_string_content,
  [305644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14665), 1,
      sym_identifier,
  [305651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14667), 1,
      anon_sym_SEMI,
  [305658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8948), 1,
      anon_sym_SEMI,
  [305665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14669), 1,
      anon_sym_RPAREN,
  [305672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14671), 1,
      anon_sym_RPAREN,
  [305679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14673), 1,
      anon_sym_LPAREN2,
  [305686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14675), 1,
      anon_sym_LPAREN2,
  [305693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14677), 1,
      anon_sym_COLON,
  [305700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14679), 1,
      sym_raw_string_content,
  [305707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14681), 1,
      anon_sym_RPAREN,
  [305714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14683), 1,
      anon_sym_DQUOTE,
  [305721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14685), 1,
      anon_sym_RPAREN,
  [305728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14687), 1,
      anon_sym_SEMI,
  [305735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14689), 1,
      anon_sym_LPAREN2,
  [305742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14691), 1,
      anon_sym_LPAREN2,
  [305749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14693), 1,
      anon_sym_RPAREN,
  [305756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14695), 1,
      sym_raw_string_content,
  [305763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14697), 1,
      anon_sym_SEMI,
  [305770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14699), 1,
      anon_sym_RPAREN,
  [305777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14701), 1,
      anon_sym_LPAREN2,
  [305784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14703), 1,
      anon_sym_LPAREN2,
  [305791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14705), 1,
      sym_raw_string_content,
  [305798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14707), 1,
      anon_sym_RPAREN,
  [305805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14709), 1,
      sym_raw_string_content,
  [305812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14711), 1,
      anon_sym_RPAREN,
  [305819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14713), 1,
      sym_raw_string_content,
  [305826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14715), 1,
      anon_sym_RPAREN,
  [305833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14717), 1,
      sym_raw_string_content,
  [305840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14719), 1,
      anon_sym_RPAREN,
  [305847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14721), 1,
      sym_raw_string_content,
  [305854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14723), 1,
      anon_sym_RPAREN,
  [305861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14725), 1,
      sym_raw_string_content,
  [305868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14727), 1,
      anon_sym_RPAREN,
  [305875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14729), 1,
      sym_raw_string_content,
  [305882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14731), 1,
      anon_sym_RPAREN,
  [305889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14733), 1,
      sym_raw_string_content,
  [305896] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14735), 1,
      anon_sym_RPAREN,
  [305903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14737), 1,
      anon_sym_SEMI,
  [305910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14739), 1,
      anon_sym_SEMI,
  [305917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14741), 1,
      anon_sym_LPAREN2,
  [305924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14743), 1,
      anon_sym_LPAREN2,
  [305931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14745), 1,
      sym_identifier,
  [305938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14747), 1,
      anon_sym_RPAREN,
  [305945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14749), 1,
      anon_sym_RPAREN,
  [305952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14751), 1,
      anon_sym_STAR,
  [305959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14753), 1,
      anon_sym_DQUOTE,
  [305966] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_and,
  [305973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11914), 1,
      anon_sym_SEMI,
  [305980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14755), 1,
      anon_sym_DQUOTE,
  [305987] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14757), 1,
      anon_sym_DQUOTE,
  [305994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14759), 1,
      anon_sym_RBRACE,
  [306001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14761), 1,
      aux_sym_preproc_if_token2,
  [306008] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14763), 1,
      aux_sym_preproc_if_token2,
  [306015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14765), 1,
      anon_sym_SEMI,
  [306022] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(10119), 1,
      aux_sym_preproc_include_token2,
  [306029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_bitor,
  [306036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14767), 1,
      sym_identifier,
  [306043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14769), 1,
      sym_raw_string_content,
  [306050] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(14771), 1,
      aux_sym_preproc_include_token2,
  [306057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8970), 1,
      anon_sym_SEMI,
  [306064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14773), 1,
      anon_sym_DQUOTE,
  [306071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14775), 1,
      aux_sym_preproc_if_token2,
  [306078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14777), 1,
      aux_sym_preproc_if_token2,
  [306085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14779), 1,
      anon_sym_SEMI,
  [306092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14781), 1,
      anon_sym_SEMI,
  [306099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14783), 1,
      aux_sym_preproc_if_token2,
  [306106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14785), 1,
      aux_sym_preproc_if_token2,
  [306113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14787), 1,
      anon_sym_SEMI,
  [306120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14789), 1,
      anon_sym_SEMI,
  [306127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14791), 1,
      anon_sym_LPAREN2,
  [306134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14793), 1,
      anon_sym_STAR,
  [306141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14795), 1,
      anon_sym_SEMI,
  [306148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_xor,
  [306155] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14797), 1,
      ts_builtin_sym_end,
  [306162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14799), 1,
      anon_sym_RPAREN,
  [306169] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(13009), 1,
      aux_sym_preproc_include_token2,
  [306176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14801), 1,
      anon_sym_RPAREN,
  [306183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14803), 1,
      sym_identifier,
  [306190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14805), 1,
      anon_sym_LPAREN2,
  [306197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14807), 1,
      anon_sym_SEMI,
  [306204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14809), 1,
      anon_sym_RPAREN,
  [306211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14811), 1,
      anon_sym_LPAREN2,
  [306218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14813), 1,
      anon_sym_RPAREN,
  [306225] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(14815), 1,
      aux_sym_preproc_include_token2,
  [306232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14817), 1,
      anon_sym_SEMI,
  [306239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13257), 1,
      anon_sym_RBRACE,
  [306246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7174), 1,
      anon_sym_RPAREN,
  [306253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8972), 1,
      anon_sym_COLON,
  [306260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14819), 1,
      anon_sym_LPAREN2,
  [306267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14821), 1,
      anon_sym_LPAREN2,
  [306274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14823), 1,
      sym_identifier,
  [306281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14825), 1,
      anon_sym_SEMI,
  [306288] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(14827), 1,
      aux_sym_preproc_include_token2,
  [306295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14829), 1,
      anon_sym_RPAREN,
  [306302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14831), 1,
      anon_sym_RPAREN,
  [306309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14833), 1,
      anon_sym_LPAREN2,
  [306316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14835), 1,
      anon_sym_LPAREN2,
  [306323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14837), 1,
      anon_sym_LPAREN2,
  [306330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14839), 1,
      sym_identifier,
  [306337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14841), 1,
      anon_sym_SEMI,
  [306344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14843), 1,
      anon_sym_SEMI,
  [306351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14845), 1,
      anon_sym_LPAREN2,
  [306358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14847), 1,
      anon_sym_RPAREN,
  [306365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14849), 1,
      anon_sym_COLON,
  [306372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14851), 1,
      anon_sym_RPAREN,
  [306379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9010), 1,
      anon_sym_COLON,
  [306386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14853), 1,
      sym_auto,
  [306393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14855), 1,
      anon_sym_RPAREN,
  [306400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14857), 1,
      aux_sym_preproc_if_token2,
  [306407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14859), 1,
      aux_sym_preproc_if_token2,
  [306414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14861), 1,
      aux_sym_preproc_if_token2,
  [306421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14863), 1,
      anon_sym_RPAREN,
  [306428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14865), 1,
      aux_sym_preproc_if_token2,
  [306435] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14867), 1,
      anon_sym_SEMI,
  [306442] = 2,
    ACTIONS(5441), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(9997), 1,
      sym_comment,
  [306449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14869), 1,
      anon_sym_LPAREN2,
  [306456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8946), 1,
      anon_sym_COLON,
  [306463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14871), 1,
      anon_sym_RPAREN,
  [306470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14873), 1,
      anon_sym_DQUOTE,
  [306477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14875), 1,
      anon_sym_LPAREN2,
  [306484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14877), 1,
      anon_sym_LPAREN2,
  [306491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14879), 1,
      sym_identifier,
  [306498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14881), 1,
      sym_identifier,
  [306505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14883), 1,
      anon_sym_LPAREN2,
  [306512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14885), 1,
      anon_sym_DQUOTE,
  [306519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14887), 1,
      sym_identifier,
  [306526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14889), 1,
      sym_raw_string_content,
  [306533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14891), 1,
      anon_sym_LPAREN2,
  [306540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14893), 1,
      sym_identifier,
  [306547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14895), 1,
      sym_identifier,
  [306554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14897), 1,
      anon_sym_LPAREN2,
  [306561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14899), 1,
      anon_sym_LPAREN2,
  [306568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14901), 1,
      sym_identifier,
  [306575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14903), 1,
      anon_sym_COLON,
  [306582] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(14905), 1,
      aux_sym_preproc_include_token2,
  [306589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14907), 1,
      sym_identifier,
  [306596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14909), 1,
      sym_raw_string_content,
  [306603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14911), 1,
      anon_sym_RPAREN,
  [306610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_or,
  [306617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12245), 1,
      anon_sym_SEMI,
  [306624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14913), 1,
      anon_sym_LPAREN2,
  [306631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14915), 1,
      anon_sym_LPAREN2,
  [306638] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14917), 1,
      sym_identifier,
  [306645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14919), 1,
      anon_sym_SEMI,
  [306652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14921), 1,
      anon_sym_RPAREN,
  [306659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14923), 1,
      sym_identifier,
  [306666] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14925), 1,
      sym_raw_string_content,
  [306673] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14927), 1,
      anon_sym_STAR,
  [306680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14929), 1,
      sym_identifier,
  [306687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14931), 1,
      anon_sym_LPAREN2,
  [306694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14933), 1,
      anon_sym_LPAREN2,
  [306701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14935), 1,
      sym_identifier,
  [306708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8938), 1,
      anon_sym_SEMI,
  [306715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14937), 1,
      anon_sym_RPAREN,
  [306722] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14939), 1,
      sym_identifier,
  [306729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14941), 1,
      sym_raw_string_content,
  [306736] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14943), 1,
      anon_sym_RPAREN,
  [306743] = 2,
    ACTIONS(5419), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(9997), 1,
      sym_comment,
  [306750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14945), 1,
      anon_sym_LPAREN2,
  [306757] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14947), 1,
      sym_identifier,
  [306764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8779), 1,
      anon_sym_RBRACE,
  [306771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8705), 1,
      anon_sym_RBRACE,
  [306778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14949), 1,
      sym_identifier,
  [306785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14951), 1,
      sym_raw_string_content,
  [306792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7794), 1,
      sym_identifier,
  [306799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_bitand,
  [306806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14953), 1,
      anon_sym_LPAREN2,
  [306813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14955), 1,
      sym_identifier,
  [306820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8900), 1,
      anon_sym_SEMI,
  [306827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14957), 1,
      anon_sym_STAR,
  [306834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14959), 1,
      sym_identifier,
  [306841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14961), 1,
      sym_raw_string_content,
  [306848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14963), 1,
      anon_sym_SEMI,
  [306855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_not_eq,
  [306862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14965), 1,
      anon_sym_LPAREN2,
  [306869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14967), 1,
      sym_identifier,
  [306876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14969), 1,
      anon_sym_COLON,
  [306883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14971), 1,
      sym_identifier,
  [306890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14973), 1,
      sym_raw_string_content,
  [306897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11631), 1,
      anon_sym_COMMA,
  [306904] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_DOT_STAR,
  [306911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14975), 1,
      sym_identifier,
  [306918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14977), 1,
      sym_raw_string_content,
  [306925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11289), 1,
      anon_sym_SEMI,
  [306932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14979), 1,
      anon_sym_DOT_DOT_DOT,
  [306939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14981), 1,
      sym_raw_string_content,
  [306946] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6401), 1,
      sym_identifier,
  [306953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14983), 1,
      sym_raw_string_content,
  [306960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10768), 1,
      anon_sym_RBRACE,
  [306967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14985), 1,
      sym_raw_string_content,
  [306974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14987), 1,
      anon_sym_DQUOTE,
  [306981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14989), 1,
      sym_raw_string_content,
  [306988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14991), 1,
      sym_identifier,
  [306995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14993), 1,
      sym_raw_string_content,
  [307002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14995), 1,
      anon_sym_DQUOTE,
  [307009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14997), 1,
      sym_raw_string_content,
  [307016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14999), 1,
      anon_sym_DOT_DOT_DOT,
  [307023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15002), 1,
      sym_raw_string_content,
  [307030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_DASH_GT_STAR,
  [307037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15004), 1,
      sym_raw_string_content,
  [307044] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11389), 1,
      anon_sym_SEMI,
  [307051] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15006), 1,
      sym_raw_string_content,
  [307058] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15008), 1,
      anon_sym_LPAREN2,
  [307065] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15010), 1,
      anon_sym_LPAREN2,
  [307072] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10756), 1,
      anon_sym_RBRACE,
  [307079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15012), 1,
      anon_sym_LPAREN2,
  [307086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15014), 1,
      anon_sym_LPAREN2,
  [307093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15016), 1,
      anon_sym_RPAREN,
  [307100] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15018), 1,
      anon_sym_LPAREN2,
  [307107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15020), 1,
      anon_sym_LPAREN2,
  [307114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15022), 1,
      anon_sym_DQUOTE,
  [307121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15024), 1,
      anon_sym_LPAREN2,
  [307128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15026), 1,
      anon_sym_LPAREN2,
  [307135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15028), 1,
      sym_identifier,
  [307142] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15030), 1,
      anon_sym_LPAREN2,
  [307149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15032), 1,
      anon_sym_LPAREN2,
  [307156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15034), 1,
      sym_identifier,
  [307163] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15036), 1,
      anon_sym_LPAREN2,
  [307170] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15038), 1,
      anon_sym_LPAREN2,
  [307177] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15040), 1,
      sym_auto,
  [307184] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15042), 1,
      anon_sym_LPAREN2,
  [307191] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15044), 1,
      anon_sym_LPAREN2,
  [307198] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15046), 1,
      sym_identifier,
  [307205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15048), 1,
      anon_sym_LPAREN2,
  [307212] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15050), 1,
      anon_sym_LPAREN2,
  [307219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15052), 1,
      anon_sym_LPAREN2,
  [307226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15054), 1,
      anon_sym_LPAREN2,
  [307233] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15056), 1,
      anon_sym_LPAREN2,
  [307240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15058), 1,
      anon_sym_LPAREN2,
  [307247] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15060), 1,
      anon_sym_LPAREN2,
  [307254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15062), 1,
      anon_sym_LPAREN2,
  [307261] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15064), 1,
      anon_sym_LPAREN2,
  [307268] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15066), 1,
      anon_sym_LPAREN2,
  [307275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15068), 1,
      anon_sym_LPAREN2,
  [307282] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15070), 1,
      aux_sym_preproc_if_token2,
  [307289] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15072), 1,
      anon_sym_STAR,
  [307296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15074), 1,
      anon_sym_DQUOTE,
  [307303] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15076), 1,
      anon_sym_DQUOTE,
  [307310] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15078), 1,
      sym_identifier,
  [307317] = 2,
    ACTIONS(9997), 1,
      sym_comment,
    ACTIONS(15080), 1,
      aux_sym_preproc_include_token2,
  [307324] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15082), 1,
      sym_identifier,
  [307331] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15084), 1,
      anon_sym_LPAREN2,
  [307338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15086), 1,
      anon_sym_LPAREN2,
  [307345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15088), 1,
      anon_sym_LPAREN2,
  [307352] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15090), 1,
      anon_sym_LPAREN2,
  [307359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15092), 1,
      anon_sym_LPAREN2,
  [307366] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15094), 1,
      anon_sym_LPAREN2,
  [307373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15096), 1,
      anon_sym_LPAREN2,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2807)] = 0,
  [SMALL_STATE(2808)] = 71,
  [SMALL_STATE(2809)] = 154,
  [SMALL_STATE(2810)] = 231,
  [SMALL_STATE(2811)] = 306,
  [SMALL_STATE(2812)] = 377,
  [SMALL_STATE(2813)] = 450,
  [SMALL_STATE(2814)] = 525,
  [SMALL_STATE(2815)] = 602,
  [SMALL_STATE(2816)] = 677,
  [SMALL_STATE(2817)] = 752,
  [SMALL_STATE(2818)] = 827,
  [SMALL_STATE(2819)] = 906,
  [SMALL_STATE(2820)] = 987,
  [SMALL_STATE(2821)] = 1058,
  [SMALL_STATE(2822)] = 1137,
  [SMALL_STATE(2823)] = 1212,
  [SMALL_STATE(2824)] = 1283,
  [SMALL_STATE(2825)] = 1354,
  [SMALL_STATE(2826)] = 1427,
  [SMALL_STATE(2827)] = 1498,
  [SMALL_STATE(2828)] = 1569,
  [SMALL_STATE(2829)] = 1642,
  [SMALL_STATE(2830)] = 1713,
  [SMALL_STATE(2831)] = 1788,
  [SMALL_STATE(2832)] = 1867,
  [SMALL_STATE(2833)] = 1946,
  [SMALL_STATE(2834)] = 2021,
  [SMALL_STATE(2835)] = 2092,
  [SMALL_STATE(2836)] = 2169,
  [SMALL_STATE(2837)] = 2242,
  [SMALL_STATE(2838)] = 2321,
  [SMALL_STATE(2839)] = 2404,
  [SMALL_STATE(2840)] = 2479,
  [SMALL_STATE(2841)] = 2552,
  [SMALL_STATE(2842)] = 2623,
  [SMALL_STATE(2843)] = 2694,
  [SMALL_STATE(2844)] = 2765,
  [SMALL_STATE(2845)] = 2840,
  [SMALL_STATE(2846)] = 2915,
  [SMALL_STATE(2847)] = 2986,
  [SMALL_STATE(2848)] = 3057,
  [SMALL_STATE(2849)] = 3131,
  [SMALL_STATE(2850)] = 3201,
  [SMALL_STATE(2851)] = 3271,
  [SMALL_STATE(2852)] = 3393,
  [SMALL_STATE(2853)] = 3463,
  [SMALL_STATE(2854)] = 3533,
  [SMALL_STATE(2855)] = 3603,
  [SMALL_STATE(2856)] = 3673,
  [SMALL_STATE(2857)] = 3743,
  [SMALL_STATE(2858)] = 3817,
  [SMALL_STATE(2859)] = 3887,
  [SMALL_STATE(2860)] = 3971,
  [SMALL_STATE(2861)] = 4045,
  [SMALL_STATE(2862)] = 4119,
  [SMALL_STATE(2863)] = 4203,
  [SMALL_STATE(2864)] = 4277,
  [SMALL_STATE(2865)] = 4347,
  [SMALL_STATE(2866)] = 4431,
  [SMALL_STATE(2867)] = 4503,
  [SMALL_STATE(2868)] = 4577,
  [SMALL_STATE(2869)] = 4647,
  [SMALL_STATE(2870)] = 4769,
  [SMALL_STATE(2871)] = 4843,
  [SMALL_STATE(2872)] = 4917,
  [SMALL_STATE(2873)] = 4995,
  [SMALL_STATE(2874)] = 5069,
  [SMALL_STATE(2875)] = 5139,
  [SMALL_STATE(2876)] = 5209,
  [SMALL_STATE(2877)] = 5293,
  [SMALL_STATE(2878)] = 5363,
  [SMALL_STATE(2879)] = 5433,
  [SMALL_STATE(2880)] = 5503,
  [SMALL_STATE(2881)] = 5573,
  [SMALL_STATE(2882)] = 5649,
  [SMALL_STATE(2883)] = 5719,
  [SMALL_STATE(2884)] = 5789,
  [SMALL_STATE(2885)] = 5859,
  [SMALL_STATE(2886)] = 5929,
  [SMALL_STATE(2887)] = 5999,
  [SMALL_STATE(2888)] = 6069,
  [SMALL_STATE(2889)] = 6161,
  [SMALL_STATE(2890)] = 6283,
  [SMALL_STATE(2891)] = 6365,
  [SMALL_STATE(2892)] = 6447,
  [SMALL_STATE(2893)] = 6539,
  [SMALL_STATE(2894)] = 6609,
  [SMALL_STATE(2895)] = 6693,
  [SMALL_STATE(2896)] = 6771,
  [SMALL_STATE(2897)] = 6851,
  [SMALL_STATE(2898)] = 6927,
  [SMALL_STATE(2899)] = 7013,
  [SMALL_STATE(2900)] = 7093,
  [SMALL_STATE(2901)] = 7163,
  [SMALL_STATE(2902)] = 7241,
  [SMALL_STATE(2903)] = 7311,
  [SMALL_STATE(2904)] = 7381,
  [SMALL_STATE(2905)] = 7503,
  [SMALL_STATE(2906)] = 7572,
  [SMALL_STATE(2907)] = 7641,
  [SMALL_STATE(2908)] = 7710,
  [SMALL_STATE(2909)] = 7779,
  [SMALL_STATE(2910)] = 7848,
  [SMALL_STATE(2911)] = 7917,
  [SMALL_STATE(2912)] = 7998,
  [SMALL_STATE(2913)] = 8067,
  [SMALL_STATE(2914)] = 8144,
  [SMALL_STATE(2915)] = 8265,
  [SMALL_STATE(2916)] = 8334,
  [SMALL_STATE(2917)] = 8403,
  [SMALL_STATE(2918)] = 8476,
  [SMALL_STATE(2919)] = 8547,
  [SMALL_STATE(2920)] = 8618,
  [SMALL_STATE(2921)] = 8687,
  [SMALL_STATE(2922)] = 8756,
  [SMALL_STATE(2923)] = 8837,
  [SMALL_STATE(2924)] = 8912,
  [SMALL_STATE(2925)] = 8981,
  [SMALL_STATE(2926)] = 9050,
  [SMALL_STATE(2927)] = 9119,
  [SMALL_STATE(2928)] = 9192,
  [SMALL_STATE(2929)] = 9261,
  [SMALL_STATE(2930)] = 9330,
  [SMALL_STATE(2931)] = 9399,
  [SMALL_STATE(2932)] = 9468,
  [SMALL_STATE(2933)] = 9537,
  [SMALL_STATE(2934)] = 9658,
  [SMALL_STATE(2935)] = 9727,
  [SMALL_STATE(2936)] = 9808,
  [SMALL_STATE(2937)] = 9877,
  [SMALL_STATE(2938)] = 9946,
  [SMALL_STATE(2939)] = 10015,
  [SMALL_STATE(2940)] = 10084,
  [SMALL_STATE(2941)] = 10153,
  [SMALL_STATE(2942)] = 10234,
  [SMALL_STATE(2943)] = 10307,
  [SMALL_STATE(2944)] = 10376,
  [SMALL_STATE(2945)] = 10445,
  [SMALL_STATE(2946)] = 10514,
  [SMALL_STATE(2947)] = 10583,
  [SMALL_STATE(2948)] = 10652,
  [SMALL_STATE(2949)] = 10721,
  [SMALL_STATE(2950)] = 10790,
  [SMALL_STATE(2951)] = 10859,
  [SMALL_STATE(2952)] = 10928,
  [SMALL_STATE(2953)] = 10997,
  [SMALL_STATE(2954)] = 11066,
  [SMALL_STATE(2955)] = 11135,
  [SMALL_STATE(2956)] = 11204,
  [SMALL_STATE(2957)] = 11273,
  [SMALL_STATE(2958)] = 11346,
  [SMALL_STATE(2959)] = 11419,
  [SMALL_STATE(2960)] = 11488,
  [SMALL_STATE(2961)] = 11557,
  [SMALL_STATE(2962)] = 11626,
  [SMALL_STATE(2963)] = 11695,
  [SMALL_STATE(2964)] = 11764,
  [SMALL_STATE(2965)] = 11833,
  [SMALL_STATE(2966)] = 11906,
  [SMALL_STATE(2967)] = 11975,
  [SMALL_STATE(2968)] = 12044,
  [SMALL_STATE(2969)] = 12113,
  [SMALL_STATE(2970)] = 12182,
  [SMALL_STATE(2971)] = 12255,
  [SMALL_STATE(2972)] = 12324,
  [SMALL_STATE(2973)] = 12409,
  [SMALL_STATE(2974)] = 12478,
  [SMALL_STATE(2975)] = 12551,
  [SMALL_STATE(2976)] = 12620,
  [SMALL_STATE(2977)] = 12689,
  [SMALL_STATE(2978)] = 12762,
  [SMALL_STATE(2979)] = 12831,
  [SMALL_STATE(2980)] = 12900,
  [SMALL_STATE(2981)] = 12969,
  [SMALL_STATE(2982)] = 13038,
  [SMALL_STATE(2983)] = 13107,
  [SMALL_STATE(2984)] = 13180,
  [SMALL_STATE(2985)] = 13249,
  [SMALL_STATE(2986)] = 13318,
  [SMALL_STATE(2987)] = 13387,
  [SMALL_STATE(2988)] = 13456,
  [SMALL_STATE(2989)] = 13525,
  [SMALL_STATE(2990)] = 13594,
  [SMALL_STATE(2991)] = 13667,
  [SMALL_STATE(2992)] = 13740,
  [SMALL_STATE(2993)] = 13813,
  [SMALL_STATE(2994)] = 13882,
  [SMALL_STATE(2995)] = 13951,
  [SMALL_STATE(2996)] = 14020,
  [SMALL_STATE(2997)] = 14089,
  [SMALL_STATE(2998)] = 14158,
  [SMALL_STATE(2999)] = 14227,
  [SMALL_STATE(3000)] = 14296,
  [SMALL_STATE(3001)] = 14381,
  [SMALL_STATE(3002)] = 14450,
  [SMALL_STATE(3003)] = 14519,
  [SMALL_STATE(3004)] = 14588,
  [SMALL_STATE(3005)] = 14657,
  [SMALL_STATE(3006)] = 14730,
  [SMALL_STATE(3007)] = 14799,
  [SMALL_STATE(3008)] = 14868,
  [SMALL_STATE(3009)] = 14941,
  [SMALL_STATE(3010)] = 15014,
  [SMALL_STATE(3011)] = 15091,
  [SMALL_STATE(3012)] = 15164,
  [SMALL_STATE(3013)] = 15239,
  [SMALL_STATE(3014)] = 15314,
  [SMALL_STATE(3015)] = 15383,
  [SMALL_STATE(3016)] = 15454,
  [SMALL_STATE(3017)] = 15527,
  [SMALL_STATE(3018)] = 15596,
  [SMALL_STATE(3019)] = 15669,
  [SMALL_STATE(3020)] = 15742,
  [SMALL_STATE(3021)] = 15815,
  [SMALL_STATE(3022)] = 15888,
  [SMALL_STATE(3023)] = 15957,
  [SMALL_STATE(3024)] = 16026,
  [SMALL_STATE(3025)] = 16103,
  [SMALL_STATE(3026)] = 16180,
  [SMALL_STATE(3027)] = 16249,
  [SMALL_STATE(3028)] = 16324,
  [SMALL_STATE(3029)] = 16403,
  [SMALL_STATE(3030)] = 16472,
  [SMALL_STATE(3031)] = 16541,
  [SMALL_STATE(3032)] = 16610,
  [SMALL_STATE(3033)] = 16679,
  [SMALL_STATE(3034)] = 16748,
  [SMALL_STATE(3035)] = 16824,
  [SMALL_STATE(3036)] = 16896,
  [SMALL_STATE(3037)] = 16974,
  [SMALL_STATE(3038)] = 17048,
  [SMALL_STATE(3039)] = 17116,
  [SMALL_STATE(3040)] = 17186,
  [SMALL_STATE(3041)] = 17254,
  [SMALL_STATE(3042)] = 17322,
  [SMALL_STATE(3043)] = 17406,
  [SMALL_STATE(3044)] = 17490,
  [SMALL_STATE(3045)] = 17562,
  [SMALL_STATE(3046)] = 17646,
  [SMALL_STATE(3047)] = 17718,
  [SMALL_STATE(3048)] = 17802,
  [SMALL_STATE(3049)] = 17874,
  [SMALL_STATE(3050)] = 17946,
  [SMALL_STATE(3051)] = 18022,
  [SMALL_STATE(3052)] = 18106,
  [SMALL_STATE(3053)] = 18178,
  [SMALL_STATE(3054)] = 18262,
  [SMALL_STATE(3055)] = 18336,
  [SMALL_STATE(3056)] = 18410,
  [SMALL_STATE(3057)] = 18482,
  [SMALL_STATE(3058)] = 18558,
  [SMALL_STATE(3059)] = 18642,
  [SMALL_STATE(3060)] = 18714,
  [SMALL_STATE(3061)] = 18782,
  [SMALL_STATE(3062)] = 18850,
  [SMALL_STATE(3063)] = 18928,
  [SMALL_STATE(3064)] = 19012,
  [SMALL_STATE(3065)] = 19080,
  [SMALL_STATE(3066)] = 19148,
  [SMALL_STATE(3067)] = 19215,
  [SMALL_STATE(3068)] = 19282,
  [SMALL_STATE(3069)] = 19349,
  [SMALL_STATE(3070)] = 19420,
  [SMALL_STATE(3071)] = 19487,
  [SMALL_STATE(3072)] = 19554,
  [SMALL_STATE(3073)] = 19621,
  [SMALL_STATE(3074)] = 19688,
  [SMALL_STATE(3075)] = 19755,
  [SMALL_STATE(3076)] = 19822,
  [SMALL_STATE(3077)] = 19889,
  [SMALL_STATE(3078)] = 19956,
  [SMALL_STATE(3079)] = 20027,
  [SMALL_STATE(3080)] = 20094,
  [SMALL_STATE(3081)] = 20161,
  [SMALL_STATE(3082)] = 20230,
  [SMALL_STATE(3083)] = 20299,
  [SMALL_STATE(3084)] = 20370,
  [SMALL_STATE(3085)] = 20441,
  [SMALL_STATE(3086)] = 20510,
  [SMALL_STATE(3087)] = 20577,
  [SMALL_STATE(3088)] = 20644,
  [SMALL_STATE(3089)] = 20715,
  [SMALL_STATE(3090)] = 20782,
  [SMALL_STATE(3091)] = 20853,
  [SMALL_STATE(3092)] = 20926,
  [SMALL_STATE(3093)] = 20993,
  [SMALL_STATE(3094)] = 21060,
  [SMALL_STATE(3095)] = 21127,
  [SMALL_STATE(3096)] = 21194,
  [SMALL_STATE(3097)] = 21261,
  [SMALL_STATE(3098)] = 21340,
  [SMALL_STATE(3099)] = 21407,
  [SMALL_STATE(3100)] = 21476,
  [SMALL_STATE(3101)] = 21549,
  [SMALL_STATE(3102)] = 21620,
  [SMALL_STATE(3103)] = 21691,
  [SMALL_STATE(3104)] = 21758,
  [SMALL_STATE(3105)] = 21825,
  [SMALL_STATE(3106)] = 21896,
  [SMALL_STATE(3107)] = 21963,
  [SMALL_STATE(3108)] = 22038,
  [SMALL_STATE(3109)] = 22109,
  [SMALL_STATE(3110)] = 22180,
  [SMALL_STATE(3111)] = 22247,
  [SMALL_STATE(3112)] = 22314,
  [SMALL_STATE(3113)] = 22381,
  [SMALL_STATE(3114)] = 22448,
  [SMALL_STATE(3115)] = 22515,
  [SMALL_STATE(3116)] = 22582,
  [SMALL_STATE(3117)] = 22649,
  [SMALL_STATE(3118)] = 22716,
  [SMALL_STATE(3119)] = 22783,
  [SMALL_STATE(3120)] = 22850,
  [SMALL_STATE(3121)] = 22917,
  [SMALL_STATE(3122)] = 22984,
  [SMALL_STATE(3123)] = 23051,
  [SMALL_STATE(3124)] = 23118,
  [SMALL_STATE(3125)] = 23201,
  [SMALL_STATE(3126)] = 23280,
  [SMALL_STATE(3127)] = 23347,
  [SMALL_STATE(3128)] = 23414,
  [SMALL_STATE(3129)] = 23481,
  [SMALL_STATE(3130)] = 23548,
  [SMALL_STATE(3131)] = 23615,
  [SMALL_STATE(3132)] = 23682,
  [SMALL_STATE(3133)] = 23749,
  [SMALL_STATE(3134)] = 23816,
  [SMALL_STATE(3135)] = 23883,
  [SMALL_STATE(3136)] = 23950,
  [SMALL_STATE(3137)] = 24017,
  [SMALL_STATE(3138)] = 24086,
  [SMALL_STATE(3139)] = 24161,
  [SMALL_STATE(3140)] = 24228,
  [SMALL_STATE(3141)] = 24295,
  [SMALL_STATE(3142)] = 24362,
  [SMALL_STATE(3143)] = 24429,
  [SMALL_STATE(3144)] = 24496,
  [SMALL_STATE(3145)] = 24563,
  [SMALL_STATE(3146)] = 24638,
  [SMALL_STATE(3147)] = 24705,
  [SMALL_STATE(3148)] = 24776,
  [SMALL_STATE(3149)] = 24845,
  [SMALL_STATE(3150)] = 24912,
  [SMALL_STATE(3151)] = 24979,
  [SMALL_STATE(3152)] = 25050,
  [SMALL_STATE(3153)] = 25117,
  [SMALL_STATE(3154)] = 25196,
  [SMALL_STATE(3155)] = 25263,
  [SMALL_STATE(3156)] = 25329,
  [SMALL_STATE(3157)] = 25395,
  [SMALL_STATE(3158)] = 25477,
  [SMALL_STATE(3159)] = 25547,
  [SMALL_STATE(3160)] = 25613,
  [SMALL_STATE(3161)] = 25683,
  [SMALL_STATE(3162)] = 25765,
  [SMALL_STATE(3163)] = 25847,
  [SMALL_STATE(3164)] = 25915,
  [SMALL_STATE(3165)] = 25983,
  [SMALL_STATE(3166)] = 26059,
  [SMALL_STATE(3167)] = 26129,
  [SMALL_STATE(3168)] = 26195,
  [SMALL_STATE(3169)] = 26263,
  [SMALL_STATE(3170)] = 26333,
  [SMALL_STATE(3171)] = 26403,
  [SMALL_STATE(3172)] = 26469,
  [SMALL_STATE(3173)] = 26539,
  [SMALL_STATE(3174)] = 26607,
  [SMALL_STATE(3175)] = 26677,
  [SMALL_STATE(3176)] = 26747,
  [SMALL_STATE(3177)] = 26817,
  [SMALL_STATE(3178)] = 26883,
  [SMALL_STATE(3179)] = 26949,
  [SMALL_STATE(3180)] = 27031,
  [SMALL_STATE(3181)] = 27101,
  [SMALL_STATE(3182)] = 27171,
  [SMALL_STATE(3183)] = 27237,
  [SMALL_STATE(3184)] = 27307,
  [SMALL_STATE(3185)] = 27377,
  [SMALL_STATE(3186)] = 27447,
  [SMALL_STATE(3187)] = 27513,
  [SMALL_STATE(3188)] = 27583,
  [SMALL_STATE(3189)] = 27649,
  [SMALL_STATE(3190)] = 27719,
  [SMALL_STATE(3191)] = 27785,
  [SMALL_STATE(3192)] = 27863,
  [SMALL_STATE(3193)] = 27937,
  [SMALL_STATE(3194)] = 28007,
  [SMALL_STATE(3195)] = 28073,
  [SMALL_STATE(3196)] = 28139,
  [SMALL_STATE(3197)] = 28209,
  [SMALL_STATE(3198)] = 28275,
  [SMALL_STATE(3199)] = 28341,
  [SMALL_STATE(3200)] = 28407,
  [SMALL_STATE(3201)] = 28477,
  [SMALL_STATE(3202)] = 28551,
  [SMALL_STATE(3203)] = 28617,
  [SMALL_STATE(3204)] = 28685,
  [SMALL_STATE(3205)] = 28751,
  [SMALL_STATE(3206)] = 28821,
  [SMALL_STATE(3207)] = 28889,
  [SMALL_STATE(3208)] = 28967,
  [SMALL_STATE(3209)] = 29037,
  [SMALL_STATE(3210)] = 29138,
  [SMALL_STATE(3211)] = 29203,
  [SMALL_STATE(3212)] = 29268,
  [SMALL_STATE(3213)] = 29355,
  [SMALL_STATE(3214)] = 29464,
  [SMALL_STATE(3215)] = 29577,
  [SMALL_STATE(3216)] = 29646,
  [SMALL_STATE(3217)] = 29715,
  [SMALL_STATE(3218)] = 29824,
  [SMALL_STATE(3219)] = 29937,
  [SMALL_STATE(3220)] = 30026,
  [SMALL_STATE(3221)] = 30095,
  [SMALL_STATE(3222)] = 30164,
  [SMALL_STATE(3223)] = 30253,
  [SMALL_STATE(3224)] = 30318,
  [SMALL_STATE(3225)] = 30399,
  [SMALL_STATE(3226)] = 30470,
  [SMALL_STATE(3227)] = 30535,
  [SMALL_STATE(3228)] = 30600,
  [SMALL_STATE(3229)] = 30665,
  [SMALL_STATE(3230)] = 30732,
  [SMALL_STATE(3231)] = 30797,
  [SMALL_STATE(3232)] = 30888,
  [SMALL_STATE(3233)] = 30983,
  [SMALL_STATE(3234)] = 31052,
  [SMALL_STATE(3235)] = 31121,
  [SMALL_STATE(3236)] = 31218,
  [SMALL_STATE(3237)] = 31283,
  [SMALL_STATE(3238)] = 31352,
  [SMALL_STATE(3239)] = 31451,
  [SMALL_STATE(3240)] = 31516,
  [SMALL_STATE(3241)] = 31585,
  [SMALL_STATE(3242)] = 31666,
  [SMALL_STATE(3243)] = 31737,
  [SMALL_STATE(3244)] = 31842,
  [SMALL_STATE(3245)] = 31955,
  [SMALL_STATE(3246)] = 32064,
  [SMALL_STATE(3247)] = 32139,
  [SMALL_STATE(3248)] = 32212,
  [SMALL_STATE(3249)] = 32301,
  [SMALL_STATE(3250)] = 32374,
  [SMALL_STATE(3251)] = 32443,
  [SMALL_STATE(3252)] = 32508,
  [SMALL_STATE(3253)] = 32573,
  [SMALL_STATE(3254)] = 32648,
  [SMALL_STATE(3255)] = 32737,
  [SMALL_STATE(3256)] = 32802,
  [SMALL_STATE(3257)] = 32877,
  [SMALL_STATE(3258)] = 32942,
  [SMALL_STATE(3259)] = 33011,
  [SMALL_STATE(3260)] = 33076,
  [SMALL_STATE(3261)] = 33145,
  [SMALL_STATE(3262)] = 33220,
  [SMALL_STATE(3263)] = 33285,
  [SMALL_STATE(3264)] = 33374,
  [SMALL_STATE(3265)] = 33439,
  [SMALL_STATE(3266)] = 33504,
  [SMALL_STATE(3267)] = 33573,
  [SMALL_STATE(3268)] = 33642,
  [SMALL_STATE(3269)] = 33725,
  [SMALL_STATE(3270)] = 33814,
  [SMALL_STATE(3271)] = 33879,
  [SMALL_STATE(3272)] = 33968,
  [SMALL_STATE(3273)] = 34037,
  [SMALL_STATE(3274)] = 34118,
  [SMALL_STATE(3275)] = 34227,
  [SMALL_STATE(3276)] = 34292,
  [SMALL_STATE(3277)] = 34381,
  [SMALL_STATE(3278)] = 34450,
  [SMALL_STATE(3279)] = 34519,
  [SMALL_STATE(3280)] = 34588,
  [SMALL_STATE(3281)] = 34653,
  [SMALL_STATE(3282)] = 34742,
  [SMALL_STATE(3283)] = 34811,
  [SMALL_STATE(3284)] = 34892,
  [SMALL_STATE(3285)] = 34963,
  [SMALL_STATE(3286)] = 35048,
  [SMALL_STATE(3287)] = 35129,
  [SMALL_STATE(3288)] = 35198,
  [SMALL_STATE(3289)] = 35267,
  [SMALL_STATE(3290)] = 35332,
  [SMALL_STATE(3291)] = 35396,
  [SMALL_STATE(3292)] = 35460,
  [SMALL_STATE(3293)] = 35536,
  [SMALL_STATE(3294)] = 35600,
  [SMALL_STATE(3295)] = 35664,
  [SMALL_STATE(3296)] = 35740,
  [SMALL_STATE(3297)] = 35804,
  [SMALL_STATE(3298)] = 35872,
  [SMALL_STATE(3299)] = 35936,
  [SMALL_STATE(3300)] = 36000,
  [SMALL_STATE(3301)] = 36064,
  [SMALL_STATE(3302)] = 36128,
  [SMALL_STATE(3303)] = 36192,
  [SMALL_STATE(3304)] = 36256,
  [SMALL_STATE(3305)] = 36320,
  [SMALL_STATE(3306)] = 36384,
  [SMALL_STATE(3307)] = 36448,
  [SMALL_STATE(3308)] = 36556,
  [SMALL_STATE(3309)] = 36620,
  [SMALL_STATE(3310)] = 36688,
  [SMALL_STATE(3311)] = 36754,
  [SMALL_STATE(3312)] = 36818,
  [SMALL_STATE(3313)] = 36884,
  [SMALL_STATE(3314)] = 36950,
  [SMALL_STATE(3315)] = 37016,
  [SMALL_STATE(3316)] = 37084,
  [SMALL_STATE(3317)] = 37154,
  [SMALL_STATE(3318)] = 37218,
  [SMALL_STATE(3319)] = 37282,
  [SMALL_STATE(3320)] = 37346,
  [SMALL_STATE(3321)] = 37416,
  [SMALL_STATE(3322)] = 37484,
  [SMALL_STATE(3323)] = 37548,
  [SMALL_STATE(3324)] = 37612,
  [SMALL_STATE(3325)] = 37676,
  [SMALL_STATE(3326)] = 37740,
  [SMALL_STATE(3327)] = 37804,
  [SMALL_STATE(3328)] = 37868,
  [SMALL_STATE(3329)] = 37932,
  [SMALL_STATE(3330)] = 37996,
  [SMALL_STATE(3331)] = 38060,
  [SMALL_STATE(3332)] = 38134,
  [SMALL_STATE(3333)] = 38202,
  [SMALL_STATE(3334)] = 38266,
  [SMALL_STATE(3335)] = 38336,
  [SMALL_STATE(3336)] = 38408,
  [SMALL_STATE(3337)] = 38472,
  [SMALL_STATE(3338)] = 38536,
  [SMALL_STATE(3339)] = 38600,
  [SMALL_STATE(3340)] = 38664,
  [SMALL_STATE(3341)] = 38728,
  [SMALL_STATE(3342)] = 38794,
  [SMALL_STATE(3343)] = 38858,
  [SMALL_STATE(3344)] = 38922,
  [SMALL_STATE(3345)] = 38986,
  [SMALL_STATE(3346)] = 39050,
  [SMALL_STATE(3347)] = 39114,
  [SMALL_STATE(3348)] = 39178,
  [SMALL_STATE(3349)] = 39242,
  [SMALL_STATE(3350)] = 39314,
  [SMALL_STATE(3351)] = 39378,
  [SMALL_STATE(3352)] = 39442,
  [SMALL_STATE(3353)] = 39506,
  [SMALL_STATE(3354)] = 39570,
  [SMALL_STATE(3355)] = 39634,
  [SMALL_STATE(3356)] = 39704,
  [SMALL_STATE(3357)] = 39768,
  [SMALL_STATE(3358)] = 39832,
  [SMALL_STATE(3359)] = 39896,
  [SMALL_STATE(3360)] = 39960,
  [SMALL_STATE(3361)] = 40024,
  [SMALL_STATE(3362)] = 40088,
  [SMALL_STATE(3363)] = 40158,
  [SMALL_STATE(3364)] = 40222,
  [SMALL_STATE(3365)] = 40294,
  [SMALL_STATE(3366)] = 40362,
  [SMALL_STATE(3367)] = 40430,
  [SMALL_STATE(3368)] = 40494,
  [SMALL_STATE(3369)] = 40558,
  [SMALL_STATE(3370)] = 40622,
  [SMALL_STATE(3371)] = 40690,
  [SMALL_STATE(3372)] = 40758,
  [SMALL_STATE(3373)] = 40826,
  [SMALL_STATE(3374)] = 40890,
  [SMALL_STATE(3375)] = 40954,
  [SMALL_STATE(3376)] = 41020,
  [SMALL_STATE(3377)] = 41088,
  [SMALL_STATE(3378)] = 41152,
  [SMALL_STATE(3379)] = 41216,
  [SMALL_STATE(3380)] = 41284,
  [SMALL_STATE(3381)] = 41392,
  [SMALL_STATE(3382)] = 41460,
  [SMALL_STATE(3383)] = 41528,
  [SMALL_STATE(3384)] = 41594,
  [SMALL_STATE(3385)] = 41658,
  [SMALL_STATE(3386)] = 41726,
  [SMALL_STATE(3387)] = 41790,
  [SMALL_STATE(3388)] = 41854,
  [SMALL_STATE(3389)] = 41935,
  [SMALL_STATE(3390)] = 41998,
  [SMALL_STATE(3391)] = 42159,
  [SMALL_STATE(3392)] = 42222,
  [SMALL_STATE(3393)] = 42285,
  [SMALL_STATE(3394)] = 42348,
  [SMALL_STATE(3395)] = 42411,
  [SMALL_STATE(3396)] = 42480,
  [SMALL_STATE(3397)] = 42547,
  [SMALL_STATE(3398)] = 42610,
  [SMALL_STATE(3399)] = 42673,
  [SMALL_STATE(3400)] = 42782,
  [SMALL_STATE(3401)] = 42849,
  [SMALL_STATE(3402)] = 42916,
  [SMALL_STATE(3403)] = 42979,
  [SMALL_STATE(3404)] = 43060,
  [SMALL_STATE(3405)] = 43127,
  [SMALL_STATE(3406)] = 43194,
  [SMALL_STATE(3407)] = 43261,
  [SMALL_STATE(3408)] = 43328,
  [SMALL_STATE(3409)] = 43397,
  [SMALL_STATE(3410)] = 43470,
  [SMALL_STATE(3411)] = 43533,
  [SMALL_STATE(3412)] = 43644,
  [SMALL_STATE(3413)] = 43707,
  [SMALL_STATE(3414)] = 43770,
  [SMALL_STATE(3415)] = 43833,
  [SMALL_STATE(3416)] = 43896,
  [SMALL_STATE(3417)] = 44057,
  [SMALL_STATE(3418)] = 44120,
  [SMALL_STATE(3419)] = 44183,
  [SMALL_STATE(3420)] = 44344,
  [SMALL_STATE(3421)] = 44457,
  [SMALL_STATE(3422)] = 44520,
  [SMALL_STATE(3423)] = 44627,
  [SMALL_STATE(3424)] = 44736,
  [SMALL_STATE(3425)] = 44811,
  [SMALL_STATE(3426)] = 44874,
  [SMALL_STATE(3427)] = 44985,
  [SMALL_STATE(3428)] = 45058,
  [SMALL_STATE(3429)] = 45121,
  [SMALL_STATE(3430)] = 45184,
  [SMALL_STATE(3431)] = 45247,
  [SMALL_STATE(3432)] = 45310,
  [SMALL_STATE(3433)] = 45373,
  [SMALL_STATE(3434)] = 45452,
  [SMALL_STATE(3435)] = 45515,
  [SMALL_STATE(3436)] = 45578,
  [SMALL_STATE(3437)] = 45641,
  [SMALL_STATE(3438)] = 45708,
  [SMALL_STATE(3439)] = 45815,
  [SMALL_STATE(3440)] = 45878,
  [SMALL_STATE(3441)] = 45941,
  [SMALL_STATE(3442)] = 46004,
  [SMALL_STATE(3443)] = 46067,
  [SMALL_STATE(3444)] = 46144,
  [SMALL_STATE(3445)] = 46221,
  [SMALL_STATE(3446)] = 46284,
  [SMALL_STATE(3447)] = 46347,
  [SMALL_STATE(3448)] = 46410,
  [SMALL_STATE(3449)] = 46477,
  [SMALL_STATE(3450)] = 46540,
  [SMALL_STATE(3451)] = 46605,
  [SMALL_STATE(3452)] = 46712,
  [SMALL_STATE(3453)] = 46775,
  [SMALL_STATE(3454)] = 46884,
  [SMALL_STATE(3455)] = 46967,
  [SMALL_STATE(3456)] = 47052,
  [SMALL_STATE(3457)] = 47141,
  [SMALL_STATE(3458)] = 47254,
  [SMALL_STATE(3459)] = 47347,
  [SMALL_STATE(3460)] = 47422,
  [SMALL_STATE(3461)] = 47517,
  [SMALL_STATE(3462)] = 47614,
  [SMALL_STATE(3463)] = 47681,
  [SMALL_STATE(3464)] = 47762,
  [SMALL_STATE(3465)] = 47861,
  [SMALL_STATE(3466)] = 47964,
  [SMALL_STATE(3467)] = 48043,
  [SMALL_STATE(3468)] = 48122,
  [SMALL_STATE(3469)] = 48189,
  [SMALL_STATE(3470)] = 48252,
  [SMALL_STATE(3471)] = 48325,
  [SMALL_STATE(3472)] = 48388,
  [SMALL_STATE(3473)] = 48469,
  [SMALL_STATE(3474)] = 48580,
  [SMALL_STATE(3475)] = 48643,
  [SMALL_STATE(3476)] = 48714,
  [SMALL_STATE(3477)] = 48795,
  [SMALL_STATE(3478)] = 48866,
  [SMALL_STATE(3479)] = 48935,
  [SMALL_STATE(3480)] = 49006,
  [SMALL_STATE(3481)] = 49113,
  [SMALL_STATE(3482)] = 49176,
  [SMALL_STATE(3483)] = 49257,
  [SMALL_STATE(3484)] = 49336,
  [SMALL_STATE(3485)] = 49399,
  [SMALL_STATE(3486)] = 49462,
  [SMALL_STATE(3487)] = 49535,
  [SMALL_STATE(3488)] = 49616,
  [SMALL_STATE(3489)] = 49777,
  [SMALL_STATE(3490)] = 49848,
  [SMALL_STATE(3491)] = 49915,
  [SMALL_STATE(3492)] = 49998,
  [SMALL_STATE(3493)] = 50065,
  [SMALL_STATE(3494)] = 50146,
  [SMALL_STATE(3495)] = 50209,
  [SMALL_STATE(3496)] = 50274,
  [SMALL_STATE(3497)] = 50355,
  [SMALL_STATE(3498)] = 50432,
  [SMALL_STATE(3499)] = 50517,
  [SMALL_STATE(3500)] = 50606,
  [SMALL_STATE(3501)] = 50697,
  [SMALL_STATE(3502)] = 50792,
  [SMALL_STATE(3503)] = 50889,
  [SMALL_STATE(3504)] = 50994,
  [SMALL_STATE(3505)] = 51057,
  [SMALL_STATE(3506)] = 51136,
  [SMALL_STATE(3507)] = 51237,
  [SMALL_STATE(3508)] = 51314,
  [SMALL_STATE(3509)] = 51379,
  [SMALL_STATE(3510)] = 51492,
  [SMALL_STATE(3511)] = 51557,
  [SMALL_STATE(3512)] = 51638,
  [SMALL_STATE(3513)] = 51707,
  [SMALL_STATE(3514)] = 51816,
  [SMALL_STATE(3515)] = 51895,
  [SMALL_STATE(3516)] = 51972,
  [SMALL_STATE(3517)] = 52053,
  [SMALL_STATE(3518)] = 52116,
  [SMALL_STATE(3519)] = 52183,
  [SMALL_STATE(3520)] = 52246,
  [SMALL_STATE(3521)] = 52310,
  [SMALL_STATE(3522)] = 52372,
  [SMALL_STATE(3523)] = 52434,
  [SMALL_STATE(3524)] = 52496,
  [SMALL_STATE(3525)] = 52558,
  [SMALL_STATE(3526)] = 52620,
  [SMALL_STATE(3527)] = 52682,
  [SMALL_STATE(3528)] = 52744,
  [SMALL_STATE(3529)] = 52806,
  [SMALL_STATE(3530)] = 52912,
  [SMALL_STATE(3531)] = 52974,
  [SMALL_STATE(3532)] = 53038,
  [SMALL_STATE(3533)] = 53102,
  [SMALL_STATE(3534)] = 53208,
  [SMALL_STATE(3535)] = 53272,
  [SMALL_STATE(3536)] = 53334,
  [SMALL_STATE(3537)] = 53396,
  [SMALL_STATE(3538)] = 53458,
  [SMALL_STATE(3539)] = 53520,
  [SMALL_STATE(3540)] = 53596,
  [SMALL_STATE(3541)] = 53658,
  [SMALL_STATE(3542)] = 53720,
  [SMALL_STATE(3543)] = 53782,
  [SMALL_STATE(3544)] = 53854,
  [SMALL_STATE(3545)] = 53918,
  [SMALL_STATE(3546)] = 53982,
  [SMALL_STATE(3547)] = 54044,
  [SMALL_STATE(3548)] = 54106,
  [SMALL_STATE(3549)] = 54168,
  [SMALL_STATE(3550)] = 54230,
  [SMALL_STATE(3551)] = 54292,
  [SMALL_STATE(3552)] = 54354,
  [SMALL_STATE(3553)] = 54420,
  [SMALL_STATE(3554)] = 54482,
  [SMALL_STATE(3555)] = 54546,
  [SMALL_STATE(3556)] = 54608,
  [SMALL_STATE(3557)] = 54672,
  [SMALL_STATE(3558)] = 54738,
  [SMALL_STATE(3559)] = 54800,
  [SMALL_STATE(3560)] = 54862,
  [SMALL_STATE(3561)] = 54924,
  [SMALL_STATE(3562)] = 54994,
  [SMALL_STATE(3563)] = 55058,
  [SMALL_STATE(3564)] = 55122,
  [SMALL_STATE(3565)] = 55190,
  [SMALL_STATE(3566)] = 55252,
  [SMALL_STATE(3567)] = 55314,
  [SMALL_STATE(3568)] = 55386,
  [SMALL_STATE(3569)] = 55450,
  [SMALL_STATE(3570)] = 55512,
  [SMALL_STATE(3571)] = 55574,
  [SMALL_STATE(3572)] = 55636,
  [SMALL_STATE(3573)] = 55704,
  [SMALL_STATE(3574)] = 55766,
  [SMALL_STATE(3575)] = 55828,
  [SMALL_STATE(3576)] = 55892,
  [SMALL_STATE(3577)] = 55954,
  [SMALL_STATE(3578)] = 56018,
  [SMALL_STATE(3579)] = 56082,
  [SMALL_STATE(3580)] = 56144,
  [SMALL_STATE(3581)] = 56206,
  [SMALL_STATE(3582)] = 56280,
  [SMALL_STATE(3583)] = 56352,
  [SMALL_STATE(3584)] = 56416,
  [SMALL_STATE(3585)] = 56478,
  [SMALL_STATE(3586)] = 56540,
  [SMALL_STATE(3587)] = 56606,
  [SMALL_STATE(3588)] = 56668,
  [SMALL_STATE(3589)] = 56774,
  [SMALL_STATE(3590)] = 56836,
  [SMALL_STATE(3591)] = 56898,
  [SMALL_STATE(3592)] = 56960,
  [SMALL_STATE(3593)] = 57022,
  [SMALL_STATE(3594)] = 57084,
  [SMALL_STATE(3595)] = 57156,
  [SMALL_STATE(3596)] = 57222,
  [SMALL_STATE(3597)] = 57284,
  [SMALL_STATE(3598)] = 57346,
  [SMALL_STATE(3599)] = 57418,
  [SMALL_STATE(3600)] = 57482,
  [SMALL_STATE(3601)] = 57544,
  [SMALL_STATE(3602)] = 57606,
  [SMALL_STATE(3603)] = 57670,
  [SMALL_STATE(3604)] = 57732,
  [SMALL_STATE(3605)] = 57802,
  [SMALL_STATE(3606)] = 57864,
  [SMALL_STATE(3607)] = 57926,
  [SMALL_STATE(3608)] = 57988,
  [SMALL_STATE(3609)] = 58058,
  [SMALL_STATE(3610)] = 58128,
  [SMALL_STATE(3611)] = 58190,
  [SMALL_STATE(3612)] = 58256,
  [SMALL_STATE(3613)] = 58320,
  [SMALL_STATE(3614)] = 58392,
  [SMALL_STATE(3615)] = 58460,
  [SMALL_STATE(3616)] = 58522,
  [SMALL_STATE(3617)] = 58584,
  [SMALL_STATE(3618)] = 58646,
  [SMALL_STATE(3619)] = 58712,
  [SMALL_STATE(3620)] = 58778,
  [SMALL_STATE(3621)] = 58844,
  [SMALL_STATE(3622)] = 58950,
  [SMALL_STATE(3623)] = 59012,
  [SMALL_STATE(3624)] = 59078,
  [SMALL_STATE(3625)] = 59142,
  [SMALL_STATE(3626)] = 59204,
  [SMALL_STATE(3627)] = 59274,
  [SMALL_STATE(3628)] = 59336,
  [SMALL_STATE(3629)] = 59404,
  [SMALL_STATE(3630)] = 59476,
  [SMALL_STATE(3631)] = 59538,
  [SMALL_STATE(3632)] = 59600,
  [SMALL_STATE(3633)] = 59666,
  [SMALL_STATE(3634)] = 59730,
  [SMALL_STATE(3635)] = 59792,
  [SMALL_STATE(3636)] = 59854,
  [SMALL_STATE(3637)] = 59922,
  [SMALL_STATE(3638)] = 59984,
  [SMALL_STATE(3639)] = 60046,
  [SMALL_STATE(3640)] = 60108,
  [SMALL_STATE(3641)] = 60169,
  [SMALL_STATE(3642)] = 60230,
  [SMALL_STATE(3643)] = 60291,
  [SMALL_STATE(3644)] = 60402,
  [SMALL_STATE(3645)] = 60463,
  [SMALL_STATE(3646)] = 60524,
  [SMALL_STATE(3647)] = 60601,
  [SMALL_STATE(3648)] = 60662,
  [SMALL_STATE(3649)] = 60723,
  [SMALL_STATE(3650)] = 60784,
  [SMALL_STATE(3651)] = 60845,
  [SMALL_STATE(3652)] = 60906,
  [SMALL_STATE(3653)] = 61013,
  [SMALL_STATE(3654)] = 61074,
  [SMALL_STATE(3655)] = 61135,
  [SMALL_STATE(3656)] = 61196,
  [SMALL_STATE(3657)] = 61257,
  [SMALL_STATE(3658)] = 61318,
  [SMALL_STATE(3659)] = 61379,
  [SMALL_STATE(3660)] = 61440,
  [SMALL_STATE(3661)] = 61501,
  [SMALL_STATE(3662)] = 61562,
  [SMALL_STATE(3663)] = 61623,
  [SMALL_STATE(3664)] = 61684,
  [SMALL_STATE(3665)] = 61749,
  [SMALL_STATE(3666)] = 61824,
  [SMALL_STATE(3667)] = 61885,
  [SMALL_STATE(3668)] = 61946,
  [SMALL_STATE(3669)] = 62053,
  [SMALL_STATE(3670)] = 62114,
  [SMALL_STATE(3671)] = 62179,
  [SMALL_STATE(3672)] = 62244,
  [SMALL_STATE(3673)] = 62305,
  [SMALL_STATE(3674)] = 62374,
  [SMALL_STATE(3675)] = 62443,
  [SMALL_STATE(3676)] = 62508,
  [SMALL_STATE(3677)] = 62585,
  [SMALL_STATE(3678)] = 62646,
  [SMALL_STATE(3679)] = 62707,
  [SMALL_STATE(3680)] = 62768,
  [SMALL_STATE(3681)] = 62833,
  [SMALL_STATE(3682)] = 62894,
  [SMALL_STATE(3683)] = 62959,
  [SMALL_STATE(3684)] = 63024,
  [SMALL_STATE(3685)] = 63085,
  [SMALL_STATE(3686)] = 63146,
  [SMALL_STATE(3687)] = 63207,
  [SMALL_STATE(3688)] = 63270,
  [SMALL_STATE(3689)] = 63335,
  [SMALL_STATE(3690)] = 63396,
  [SMALL_STATE(3691)] = 63461,
  [SMALL_STATE(3692)] = 63526,
  [SMALL_STATE(3693)] = 63587,
  [SMALL_STATE(3694)] = 63648,
  [SMALL_STATE(3695)] = 63715,
  [SMALL_STATE(3696)] = 63780,
  [SMALL_STATE(3697)] = 63891,
  [SMALL_STATE(3698)] = 63956,
  [SMALL_STATE(3699)] = 64017,
  [SMALL_STATE(3700)] = 64078,
  [SMALL_STATE(3701)] = 64139,
  [SMALL_STATE(3702)] = 64220,
  [SMALL_STATE(3703)] = 64285,
  [SMALL_STATE(3704)] = 64346,
  [SMALL_STATE(3705)] = 64407,
  [SMALL_STATE(3706)] = 64468,
  [SMALL_STATE(3707)] = 64529,
  [SMALL_STATE(3708)] = 64590,
  [SMALL_STATE(3709)] = 64669,
  [SMALL_STATE(3710)] = 64730,
  [SMALL_STATE(3711)] = 64791,
  [SMALL_STATE(3712)] = 64852,
  [SMALL_STATE(3713)] = 64935,
  [SMALL_STATE(3714)] = 64996,
  [SMALL_STATE(3715)] = 65061,
  [SMALL_STATE(3716)] = 65148,
  [SMALL_STATE(3717)] = 65209,
  [SMALL_STATE(3718)] = 65298,
  [SMALL_STATE(3719)] = 65363,
  [SMALL_STATE(3720)] = 65456,
  [SMALL_STATE(3721)] = 65517,
  [SMALL_STATE(3722)] = 65578,
  [SMALL_STATE(3723)] = 65673,
  [SMALL_STATE(3724)] = 65772,
  [SMALL_STATE(3725)] = 65833,
  [SMALL_STATE(3726)] = 65898,
  [SMALL_STATE(3727)] = 66001,
  [SMALL_STATE(3728)] = 66068,
  [SMALL_STATE(3729)] = 66143,
  [SMALL_STATE(3730)] = 66248,
  [SMALL_STATE(3731)] = 66309,
  [SMALL_STATE(3732)] = 66370,
  [SMALL_STATE(3733)] = 66431,
  [SMALL_STATE(3734)] = 66492,
  [SMALL_STATE(3735)] = 66557,
  [SMALL_STATE(3736)] = 66618,
  [SMALL_STATE(3737)] = 66679,
  [SMALL_STATE(3738)] = 66740,
  [SMALL_STATE(3739)] = 66845,
  [SMALL_STATE(3740)] = 66906,
  [SMALL_STATE(3741)] = 66967,
  [SMALL_STATE(3742)] = 67028,
  [SMALL_STATE(3743)] = 67089,
  [SMALL_STATE(3744)] = 67154,
  [SMALL_STATE(3745)] = 67219,
  [SMALL_STATE(3746)] = 67284,
  [SMALL_STATE(3747)] = 67345,
  [SMALL_STATE(3748)] = 67406,
  [SMALL_STATE(3749)] = 67471,
  [SMALL_STATE(3750)] = 67532,
  [SMALL_STATE(3751)] = 67597,
  [SMALL_STATE(3752)] = 67658,
  [SMALL_STATE(3753)] = 67723,
  [SMALL_STATE(3754)] = 67834,
  [SMALL_STATE(3755)] = 67895,
  [SMALL_STATE(3756)] = 67956,
  [SMALL_STATE(3757)] = 68063,
  [SMALL_STATE(3758)] = 68124,
  [SMALL_STATE(3759)] = 68191,
  [SMALL_STATE(3760)] = 68252,
  [SMALL_STATE(3761)] = 68313,
  [SMALL_STATE(3762)] = 68374,
  [SMALL_STATE(3763)] = 68435,
  [SMALL_STATE(3764)] = 68496,
  [SMALL_STATE(3765)] = 68557,
  [SMALL_STATE(3766)] = 68622,
  [SMALL_STATE(3767)] = 68683,
  [SMALL_STATE(3768)] = 68744,
  [SMALL_STATE(3769)] = 68805,
  [SMALL_STATE(3770)] = 68866,
  [SMALL_STATE(3771)] = 68927,
  [SMALL_STATE(3772)] = 68988,
  [SMALL_STATE(3773)] = 69049,
  [SMALL_STATE(3774)] = 69116,
  [SMALL_STATE(3775)] = 69177,
  [SMALL_STATE(3776)] = 69238,
  [SMALL_STATE(3777)] = 69299,
  [SMALL_STATE(3778)] = 69360,
  [SMALL_STATE(3779)] = 69421,
  [SMALL_STATE(3780)] = 69486,
  [SMALL_STATE(3781)] = 69547,
  [SMALL_STATE(3782)] = 69608,
  [SMALL_STATE(3783)] = 69677,
  [SMALL_STATE(3784)] = 69738,
  [SMALL_STATE(3785)] = 69799,
  [SMALL_STATE(3786)] = 69860,
  [SMALL_STATE(3787)] = 69925,
  [SMALL_STATE(3788)] = 69986,
  [SMALL_STATE(3789)] = 70053,
  [SMALL_STATE(3790)] = 70126,
  [SMALL_STATE(3791)] = 70233,
  [SMALL_STATE(3792)] = 70340,
  [SMALL_STATE(3793)] = 70401,
  [SMALL_STATE(3794)] = 70508,
  [SMALL_STATE(3795)] = 70569,
  [SMALL_STATE(3796)] = 70680,
  [SMALL_STATE(3797)] = 70745,
  [SMALL_STATE(3798)] = 70822,
  [SMALL_STATE(3799)] = 70925,
  [SMALL_STATE(3800)] = 71024,
  [SMALL_STATE(3801)] = 71119,
  [SMALL_STATE(3802)] = 71212,
  [SMALL_STATE(3803)] = 71301,
  [SMALL_STATE(3804)] = 71376,
  [SMALL_STATE(3805)] = 71463,
  [SMALL_STATE(3806)] = 71546,
  [SMALL_STATE(3807)] = 71625,
  [SMALL_STATE(3808)] = 71690,
  [SMALL_STATE(3809)] = 71771,
  [SMALL_STATE(3810)] = 71836,
  [SMALL_STATE(3811)] = 71943,
  [SMALL_STATE(3812)] = 72054,
  [SMALL_STATE(3813)] = 72129,
  [SMALL_STATE(3814)] = 72190,
  [SMALL_STATE(3815)] = 72251,
  [SMALL_STATE(3816)] = 72312,
  [SMALL_STATE(3817)] = 72377,
  [SMALL_STATE(3818)] = 72444,
  [SMALL_STATE(3819)] = 72505,
  [SMALL_STATE(3820)] = 72570,
  [SMALL_STATE(3821)] = 72645,
  [SMALL_STATE(3822)] = 72752,
  [SMALL_STATE(3823)] = 72863,
  [SMALL_STATE(3824)] = 72930,
  [SMALL_STATE(3825)] = 72991,
  [SMALL_STATE(3826)] = 73052,
  [SMALL_STATE(3827)] = 73125,
  [SMALL_STATE(3828)] = 73186,
  [SMALL_STATE(3829)] = 73247,
  [SMALL_STATE(3830)] = 73308,
  [SMALL_STATE(3831)] = 73375,
  [SMALL_STATE(3832)] = 73436,
  [SMALL_STATE(3833)] = 73505,
  [SMALL_STATE(3834)] = 73566,
  [SMALL_STATE(3835)] = 73635,
  [SMALL_STATE(3836)] = 73696,
  [SMALL_STATE(3837)] = 73757,
  [SMALL_STATE(3838)] = 73818,
  [SMALL_STATE(3839)] = 73887,
  [SMALL_STATE(3840)] = 73950,
  [SMALL_STATE(3841)] = 74017,
  [SMALL_STATE(3842)] = 74086,
  [SMALL_STATE(3843)] = 74147,
  [SMALL_STATE(3844)] = 74208,
  [SMALL_STATE(3845)] = 74277,
  [SMALL_STATE(3846)] = 74338,
  [SMALL_STATE(3847)] = 74403,
  [SMALL_STATE(3848)] = 74464,
  [SMALL_STATE(3849)] = 74529,
  [SMALL_STATE(3850)] = 74590,
  [SMALL_STATE(3851)] = 74653,
  [SMALL_STATE(3852)] = 74720,
  [SMALL_STATE(3853)] = 74781,
  [SMALL_STATE(3854)] = 74842,
  [SMALL_STATE(3855)] = 74903,
  [SMALL_STATE(3856)] = 74964,
  [SMALL_STATE(3857)] = 75025,
  [SMALL_STATE(3858)] = 75135,
  [SMALL_STATE(3859)] = 75239,
  [SMALL_STATE(3860)] = 75313,
  [SMALL_STATE(3861)] = 75387,
  [SMALL_STATE(3862)] = 75447,
  [SMALL_STATE(3863)] = 75509,
  [SMALL_STATE(3864)] = 75611,
  [SMALL_STATE(3865)] = 75671,
  [SMALL_STATE(3866)] = 75775,
  [SMALL_STATE(3867)] = 75847,
  [SMALL_STATE(3868)] = 75949,
  [SMALL_STATE(3869)] = 76105,
  [SMALL_STATE(3870)] = 76207,
  [SMALL_STATE(3871)] = 76271,
  [SMALL_STATE(3872)] = 76373,
  [SMALL_STATE(3873)] = 76441,
  [SMALL_STATE(3874)] = 76509,
  [SMALL_STATE(3875)] = 76583,
  [SMALL_STATE(3876)] = 76685,
  [SMALL_STATE(3877)] = 76749,
  [SMALL_STATE(3878)] = 76819,
  [SMALL_STATE(3879)] = 76885,
  [SMALL_STATE(3880)] = 76945,
  [SMALL_STATE(3881)] = 77007,
  [SMALL_STATE(3882)] = 77067,
  [SMALL_STATE(3883)] = 77223,
  [SMALL_STATE(3884)] = 77283,
  [SMALL_STATE(3885)] = 77343,
  [SMALL_STATE(3886)] = 77403,
  [SMALL_STATE(3887)] = 77465,
  [SMALL_STATE(3888)] = 77527,
  [SMALL_STATE(3889)] = 77683,
  [SMALL_STATE(3890)] = 77749,
  [SMALL_STATE(3891)] = 77815,
  [SMALL_STATE(3892)] = 77875,
  [SMALL_STATE(3893)] = 77935,
  [SMALL_STATE(3894)] = 77995,
  [SMALL_STATE(3895)] = 78055,
  [SMALL_STATE(3896)] = 78117,
  [SMALL_STATE(3897)] = 78177,
  [SMALL_STATE(3898)] = 78239,
  [SMALL_STATE(3899)] = 78349,
  [SMALL_STATE(3900)] = 78453,
  [SMALL_STATE(3901)] = 78559,
  [SMALL_STATE(3902)] = 78669,
  [SMALL_STATE(3903)] = 78771,
  [SMALL_STATE(3904)] = 78877,
  [SMALL_STATE(3905)] = 78951,
  [SMALL_STATE(3906)] = 79053,
  [SMALL_STATE(3907)] = 79133,
  [SMALL_STATE(3908)] = 79235,
  [SMALL_STATE(3909)] = 79391,
  [SMALL_STATE(3910)] = 79469,
  [SMALL_STATE(3911)] = 79551,
  [SMALL_STATE(3912)] = 79611,
  [SMALL_STATE(3913)] = 79677,
  [SMALL_STATE(3914)] = 79737,
  [SMALL_STATE(3915)] = 79797,
  [SMALL_STATE(3916)] = 79857,
  [SMALL_STATE(3917)] = 79917,
  [SMALL_STATE(3918)] = 79977,
  [SMALL_STATE(3919)] = 80037,
  [SMALL_STATE(3920)] = 80097,
  [SMALL_STATE(3921)] = 80183,
  [SMALL_STATE(3922)] = 80271,
  [SMALL_STATE(3923)] = 80427,
  [SMALL_STATE(3924)] = 80519,
  [SMALL_STATE(3925)] = 80621,
  [SMALL_STATE(3926)] = 80715,
  [SMALL_STATE(3927)] = 80813,
  [SMALL_STATE(3928)] = 80883,
  [SMALL_STATE(3929)] = 80985,
  [SMALL_STATE(3930)] = 81053,
  [SMALL_STATE(3931)] = 81161,
  [SMALL_STATE(3932)] = 81221,
  [SMALL_STATE(3933)] = 81295,
  [SMALL_STATE(3934)] = 81355,
  [SMALL_STATE(3935)] = 81415,
  [SMALL_STATE(3936)] = 81491,
  [SMALL_STATE(3937)] = 81551,
  [SMALL_STATE(3938)] = 81611,
  [SMALL_STATE(3939)] = 81717,
  [SMALL_STATE(3940)] = 81823,
  [SMALL_STATE(3941)] = 81895,
  [SMALL_STATE(3942)] = 81963,
  [SMALL_STATE(3943)] = 82031,
  [SMALL_STATE(3944)] = 82187,
  [SMALL_STATE(3945)] = 82293,
  [SMALL_STATE(3946)] = 82367,
  [SMALL_STATE(3947)] = 82441,
  [SMALL_STATE(3948)] = 82505,
  [SMALL_STATE(3949)] = 82577,
  [SMALL_STATE(3950)] = 82733,
  [SMALL_STATE(3951)] = 82805,
  [SMALL_STATE(3952)] = 82961,
  [SMALL_STATE(3953)] = 83029,
  [SMALL_STATE(3954)] = 83105,
  [SMALL_STATE(3955)] = 83165,
  [SMALL_STATE(3956)] = 83225,
  [SMALL_STATE(3957)] = 83289,
  [SMALL_STATE(3958)] = 83349,
  [SMALL_STATE(3959)] = 83451,
  [SMALL_STATE(3960)] = 83607,
  [SMALL_STATE(3961)] = 83683,
  [SMALL_STATE(3962)] = 83757,
  [SMALL_STATE(3963)] = 83857,
  [SMALL_STATE(3964)] = 83953,
  [SMALL_STATE(3965)] = 84045,
  [SMALL_STATE(3966)] = 84135,
  [SMALL_STATE(3967)] = 84221,
  [SMALL_STATE(3968)] = 84305,
  [SMALL_STATE(3969)] = 84387,
  [SMALL_STATE(3970)] = 84465,
  [SMALL_STATE(3971)] = 84525,
  [SMALL_STATE(3972)] = 84605,
  [SMALL_STATE(3973)] = 84665,
  [SMALL_STATE(3974)] = 84727,
  [SMALL_STATE(3975)] = 84787,
  [SMALL_STATE(3976)] = 84849,
  [SMALL_STATE(3977)] = 84951,
  [SMALL_STATE(3978)] = 85053,
  [SMALL_STATE(3979)] = 85155,
  [SMALL_STATE(3980)] = 85257,
  [SMALL_STATE(3981)] = 85371,
  [SMALL_STATE(3982)] = 85431,
  [SMALL_STATE(3983)] = 85533,
  [SMALL_STATE(3984)] = 85605,
  [SMALL_STATE(3985)] = 85665,
  [SMALL_STATE(3986)] = 85725,
  [SMALL_STATE(3987)] = 85791,
  [SMALL_STATE(3988)] = 85865,
  [SMALL_STATE(3989)] = 85967,
  [SMALL_STATE(3990)] = 86069,
  [SMALL_STATE(3991)] = 86141,
  [SMALL_STATE(3992)] = 86243,
  [SMALL_STATE(3993)] = 86303,
  [SMALL_STATE(3994)] = 86405,
  [SMALL_STATE(3995)] = 86465,
  [SMALL_STATE(3996)] = 86525,
  [SMALL_STATE(3997)] = 86585,
  [SMALL_STATE(3998)] = 86645,
  [SMALL_STATE(3999)] = 86705,
  [SMALL_STATE(4000)] = 86765,
  [SMALL_STATE(4001)] = 86837,
  [SMALL_STATE(4002)] = 86943,
  [SMALL_STATE(4003)] = 87007,
  [SMALL_STATE(4004)] = 87067,
  [SMALL_STATE(4005)] = 87127,
  [SMALL_STATE(4006)] = 87283,
  [SMALL_STATE(4007)] = 87385,
  [SMALL_STATE(4008)] = 87487,
  [SMALL_STATE(4009)] = 87589,
  [SMALL_STATE(4010)] = 87697,
  [SMALL_STATE(4011)] = 87757,
  [SMALL_STATE(4012)] = 87817,
  [SMALL_STATE(4013)] = 87881,
  [SMALL_STATE(4014)] = 87947,
  [SMALL_STATE(4015)] = 88013,
  [SMALL_STATE(4016)] = 88077,
  [SMALL_STATE(4017)] = 88181,
  [SMALL_STATE(4018)] = 88283,
  [SMALL_STATE(4019)] = 88343,
  [SMALL_STATE(4020)] = 88499,
  [SMALL_STATE(4021)] = 88561,
  [SMALL_STATE(4022)] = 88669,
  [SMALL_STATE(4023)] = 88739,
  [SMALL_STATE(4024)] = 88841,
  [SMALL_STATE(4025)] = 88915,
  [SMALL_STATE(4026)] = 88982,
  [SMALL_STATE(4027)] = 89041,
  [SMALL_STATE(4028)] = 89146,
  [SMALL_STATE(4029)] = 89205,
  [SMALL_STATE(4030)] = 89264,
  [SMALL_STATE(4031)] = 89323,
  [SMALL_STATE(4032)] = 89382,
  [SMALL_STATE(4033)] = 89441,
  [SMALL_STATE(4034)] = 89500,
  [SMALL_STATE(4035)] = 89559,
  [SMALL_STATE(4036)] = 89620,
  [SMALL_STATE(4037)] = 89679,
  [SMALL_STATE(4038)] = 89738,
  [SMALL_STATE(4039)] = 89797,
  [SMALL_STATE(4040)] = 89856,
  [SMALL_STATE(4041)] = 89915,
  [SMALL_STATE(4042)] = 89974,
  [SMALL_STATE(4043)] = 90033,
  [SMALL_STATE(4044)] = 90100,
  [SMALL_STATE(4045)] = 90159,
  [SMALL_STATE(4046)] = 90218,
  [SMALL_STATE(4047)] = 90277,
  [SMALL_STATE(4048)] = 90336,
  [SMALL_STATE(4049)] = 90395,
  [SMALL_STATE(4050)] = 90454,
  [SMALL_STATE(4051)] = 90513,
  [SMALL_STATE(4052)] = 90572,
  [SMALL_STATE(4053)] = 90631,
  [SMALL_STATE(4054)] = 90690,
  [SMALL_STATE(4055)] = 90749,
  [SMALL_STATE(4056)] = 90808,
  [SMALL_STATE(4057)] = 90877,
  [SMALL_STATE(4058)] = 90942,
  [SMALL_STATE(4059)] = 91001,
  [SMALL_STATE(4060)] = 91060,
  [SMALL_STATE(4061)] = 91121,
  [SMALL_STATE(4062)] = 91180,
  [SMALL_STATE(4063)] = 91239,
  [SMALL_STATE(4064)] = 91298,
  [SMALL_STATE(4065)] = 91357,
  [SMALL_STATE(4066)] = 91416,
  [SMALL_STATE(4067)] = 91475,
  [SMALL_STATE(4068)] = 91534,
  [SMALL_STATE(4069)] = 91593,
  [SMALL_STATE(4070)] = 91652,
  [SMALL_STATE(4071)] = 91711,
  [SMALL_STATE(4072)] = 91770,
  [SMALL_STATE(4073)] = 91829,
  [SMALL_STATE(4074)] = 91888,
  [SMALL_STATE(4075)] = 91947,
  [SMALL_STATE(4076)] = 92010,
  [SMALL_STATE(4077)] = 92069,
  [SMALL_STATE(4078)] = 92128,
  [SMALL_STATE(4079)] = 92195,
  [SMALL_STATE(4080)] = 92254,
  [SMALL_STATE(4081)] = 92313,
  [SMALL_STATE(4082)] = 92372,
  [SMALL_STATE(4083)] = 92431,
  [SMALL_STATE(4084)] = 92490,
  [SMALL_STATE(4085)] = 92549,
  [SMALL_STATE(4086)] = 92608,
  [SMALL_STATE(4087)] = 92667,
  [SMALL_STATE(4088)] = 92726,
  [SMALL_STATE(4089)] = 92785,
  [SMALL_STATE(4090)] = 92844,
  [SMALL_STATE(4091)] = 92903,
  [SMALL_STATE(4092)] = 92968,
  [SMALL_STATE(4093)] = 93027,
  [SMALL_STATE(4094)] = 93086,
  [SMALL_STATE(4095)] = 93145,
  [SMALL_STATE(4096)] = 93204,
  [SMALL_STATE(4097)] = 93263,
  [SMALL_STATE(4098)] = 93322,
  [SMALL_STATE(4099)] = 93381,
  [SMALL_STATE(4100)] = 93454,
  [SMALL_STATE(4101)] = 93513,
  [SMALL_STATE(4102)] = 93572,
  [SMALL_STATE(4103)] = 93637,
  [SMALL_STATE(4104)] = 93696,
  [SMALL_STATE(4105)] = 93755,
  [SMALL_STATE(4106)] = 93818,
  [SMALL_STATE(4107)] = 93877,
  [SMALL_STATE(4108)] = 93936,
  [SMALL_STATE(4109)] = 93995,
  [SMALL_STATE(4110)] = 94054,
  [SMALL_STATE(4111)] = 94113,
  [SMALL_STATE(4112)] = 94172,
  [SMALL_STATE(4113)] = 94235,
  [SMALL_STATE(4114)] = 94294,
  [SMALL_STATE(4115)] = 94353,
  [SMALL_STATE(4116)] = 94418,
  [SMALL_STATE(4117)] = 94477,
  [SMALL_STATE(4118)] = 94536,
  [SMALL_STATE(4119)] = 94595,
  [SMALL_STATE(4120)] = 94654,
  [SMALL_STATE(4121)] = 94713,
  [SMALL_STATE(4122)] = 94772,
  [SMALL_STATE(4123)] = 94847,
  [SMALL_STATE(4124)] = 94914,
  [SMALL_STATE(4125)] = 94973,
  [SMALL_STATE(4126)] = 95032,
  [SMALL_STATE(4127)] = 95095,
  [SMALL_STATE(4128)] = 95154,
  [SMALL_STATE(4129)] = 95213,
  [SMALL_STATE(4130)] = 95272,
  [SMALL_STATE(4131)] = 95335,
  [SMALL_STATE(4132)] = 95398,
  [SMALL_STATE(4133)] = 95503,
  [SMALL_STATE(4134)] = 95562,
  [SMALL_STATE(4135)] = 95621,
  [SMALL_STATE(4136)] = 95690,
  [SMALL_STATE(4137)] = 95749,
  [SMALL_STATE(4138)] = 95808,
  [SMALL_STATE(4139)] = 95867,
  [SMALL_STATE(4140)] = 95926,
  [SMALL_STATE(4141)] = 95985,
  [SMALL_STATE(4142)] = 96044,
  [SMALL_STATE(4143)] = 96107,
  [SMALL_STATE(4144)] = 96166,
  [SMALL_STATE(4145)] = 96225,
  [SMALL_STATE(4146)] = 96292,
  [SMALL_STATE(4147)] = 96351,
  [SMALL_STATE(4148)] = 96410,
  [SMALL_STATE(4149)] = 96469,
  [SMALL_STATE(4150)] = 96528,
  [SMALL_STATE(4151)] = 96587,
  [SMALL_STATE(4152)] = 96646,
  [SMALL_STATE(4153)] = 96705,
  [SMALL_STATE(4154)] = 96764,
  [SMALL_STATE(4155)] = 96823,
  [SMALL_STATE(4156)] = 96882,
  [SMALL_STATE(4157)] = 96941,
  [SMALL_STATE(4158)] = 97000,
  [SMALL_STATE(4159)] = 97063,
  [SMALL_STATE(4160)] = 97124,
  [SMALL_STATE(4161)] = 97183,
  [SMALL_STATE(4162)] = 97242,
  [SMALL_STATE(4163)] = 97301,
  [SMALL_STATE(4164)] = 97364,
  [SMALL_STATE(4165)] = 97423,
  [SMALL_STATE(4166)] = 97488,
  [SMALL_STATE(4167)] = 97547,
  [SMALL_STATE(4168)] = 97606,
  [SMALL_STATE(4169)] = 97665,
  [SMALL_STATE(4170)] = 97724,
  [SMALL_STATE(4171)] = 97783,
  [SMALL_STATE(4172)] = 97842,
  [SMALL_STATE(4173)] = 97901,
  [SMALL_STATE(4174)] = 97960,
  [SMALL_STATE(4175)] = 98025,
  [SMALL_STATE(4176)] = 98084,
  [SMALL_STATE(4177)] = 98143,
  [SMALL_STATE(4178)] = 98206,
  [SMALL_STATE(4179)] = 98265,
  [SMALL_STATE(4180)] = 98324,
  [SMALL_STATE(4181)] = 98401,
  [SMALL_STATE(4182)] = 98460,
  [SMALL_STATE(4183)] = 98519,
  [SMALL_STATE(4184)] = 98578,
  [SMALL_STATE(4185)] = 98637,
  [SMALL_STATE(4186)] = 98696,
  [SMALL_STATE(4187)] = 98769,
  [SMALL_STATE(4188)] = 98834,
  [SMALL_STATE(4189)] = 98893,
  [SMALL_STATE(4190)] = 98952,
  [SMALL_STATE(4191)] = 99011,
  [SMALL_STATE(4192)] = 99070,
  [SMALL_STATE(4193)] = 99129,
  [SMALL_STATE(4194)] = 99188,
  [SMALL_STATE(4195)] = 99247,
  [SMALL_STATE(4196)] = 99306,
  [SMALL_STATE(4197)] = 99365,
  [SMALL_STATE(4198)] = 99424,
  [SMALL_STATE(4199)] = 99483,
  [SMALL_STATE(4200)] = 99542,
  [SMALL_STATE(4201)] = 99601,
  [SMALL_STATE(4202)] = 99664,
  [SMALL_STATE(4203)] = 99723,
  [SMALL_STATE(4204)] = 99782,
  [SMALL_STATE(4205)] = 99843,
  [SMALL_STATE(4206)] = 99904,
  [SMALL_STATE(4207)] = 99963,
  [SMALL_STATE(4208)] = 100022,
  [SMALL_STATE(4209)] = 100081,
  [SMALL_STATE(4210)] = 100140,
  [SMALL_STATE(4211)] = 100199,
  [SMALL_STATE(4212)] = 100262,
  [SMALL_STATE(4213)] = 100321,
  [SMALL_STATE(4214)] = 100380,
  [SMALL_STATE(4215)] = 100439,
  [SMALL_STATE(4216)] = 100498,
  [SMALL_STATE(4217)] = 100561,
  [SMALL_STATE(4218)] = 100620,
  [SMALL_STATE(4219)] = 100679,
  [SMALL_STATE(4220)] = 100742,
  [SMALL_STATE(4221)] = 100802,
  [SMALL_STATE(4222)] = 100860,
  [SMALL_STATE(4223)] = 100918,
  [SMALL_STATE(4224)] = 100988,
  [SMALL_STATE(4225)] = 101046,
  [SMALL_STATE(4226)] = 101104,
  [SMALL_STATE(4227)] = 101162,
  [SMALL_STATE(4228)] = 101220,
  [SMALL_STATE(4229)] = 101278,
  [SMALL_STATE(4230)] = 101350,
  [SMALL_STATE(4231)] = 101422,
  [SMALL_STATE(4232)] = 101526,
  [SMALL_STATE(4233)] = 101590,
  [SMALL_STATE(4234)] = 101648,
  [SMALL_STATE(4235)] = 101706,
  [SMALL_STATE(4236)] = 101768,
  [SMALL_STATE(4237)] = 101870,
  [SMALL_STATE(4238)] = 101940,
  [SMALL_STATE(4239)] = 102044,
  [SMALL_STATE(4240)] = 102106,
  [SMALL_STATE(4241)] = 102164,
  [SMALL_STATE(4242)] = 102222,
  [SMALL_STATE(4243)] = 102280,
  [SMALL_STATE(4244)] = 102342,
  [SMALL_STATE(4245)] = 102400,
  [SMALL_STATE(4246)] = 102458,
  [SMALL_STATE(4247)] = 102516,
  [SMALL_STATE(4248)] = 102574,
  [SMALL_STATE(4249)] = 102636,
  [SMALL_STATE(4250)] = 102694,
  [SMALL_STATE(4251)] = 102756,
  [SMALL_STATE(4252)] = 102814,
  [SMALL_STATE(4253)] = 102876,
  [SMALL_STATE(4254)] = 102934,
  [SMALL_STATE(4255)] = 102992,
  [SMALL_STATE(4256)] = 103096,
  [SMALL_STATE(4257)] = 103158,
  [SMALL_STATE(4258)] = 103220,
  [SMALL_STATE(4259)] = 103322,
  [SMALL_STATE(4260)] = 103380,
  [SMALL_STATE(4261)] = 103438,
  [SMALL_STATE(4262)] = 103496,
  [SMALL_STATE(4263)] = 103554,
  [SMALL_STATE(4264)] = 103612,
  [SMALL_STATE(4265)] = 103670,
  [SMALL_STATE(4266)] = 103736,
  [SMALL_STATE(4267)] = 103794,
  [SMALL_STATE(4268)] = 103868,
  [SMALL_STATE(4269)] = 103926,
  [SMALL_STATE(4270)] = 103984,
  [SMALL_STATE(4271)] = 104042,
  [SMALL_STATE(4272)] = 104100,
  [SMALL_STATE(4273)] = 104162,
  [SMALL_STATE(4274)] = 104228,
  [SMALL_STATE(4275)] = 104286,
  [SMALL_STATE(4276)] = 104344,
  [SMALL_STATE(4277)] = 104402,
  [SMALL_STATE(4278)] = 104464,
  [SMALL_STATE(4279)] = 104526,
  [SMALL_STATE(4280)] = 104584,
  [SMALL_STATE(4281)] = 104642,
  [SMALL_STATE(4282)] = 104706,
  [SMALL_STATE(4283)] = 104764,
  [SMALL_STATE(4284)] = 104868,
  [SMALL_STATE(4285)] = 104926,
  [SMALL_STATE(4286)] = 104984,
  [SMALL_STATE(4287)] = 105042,
  [SMALL_STATE(4288)] = 105100,
  [SMALL_STATE(4289)] = 105202,
  [SMALL_STATE(4290)] = 105306,
  [SMALL_STATE(4291)] = 105364,
  [SMALL_STATE(4292)] = 105422,
  [SMALL_STATE(4293)] = 105480,
  [SMALL_STATE(4294)] = 105586,
  [SMALL_STATE(4295)] = 105652,
  [SMALL_STATE(4296)] = 105724,
  [SMALL_STATE(4297)] = 105788,
  [SMALL_STATE(4298)] = 105888,
  [SMALL_STATE(4299)] = 105986,
  [SMALL_STATE(4300)] = 106080,
  [SMALL_STATE(4301)] = 106170,
  [SMALL_STATE(4302)] = 106256,
  [SMALL_STATE(4303)] = 106340,
  [SMALL_STATE(4304)] = 106420,
  [SMALL_STATE(4305)] = 106496,
  [SMALL_STATE(4306)] = 106574,
  [SMALL_STATE(4307)] = 106632,
  [SMALL_STATE(4308)] = 106690,
  [SMALL_STATE(4309)] = 106748,
  [SMALL_STATE(4310)] = 106806,
  [SMALL_STATE(4311)] = 106864,
  [SMALL_STATE(4312)] = 106922,
  [SMALL_STATE(4313)] = 106980,
  [SMALL_STATE(4314)] = 107038,
  [SMALL_STATE(4315)] = 107142,
  [SMALL_STATE(4316)] = 107200,
  [SMALL_STATE(4317)] = 107306,
  [SMALL_STATE(4318)] = 107364,
  [SMALL_STATE(4319)] = 107422,
  [SMALL_STATE(4320)] = 107494,
  [SMALL_STATE(4321)] = 107560,
  [SMALL_STATE(4322)] = 107664,
  [SMALL_STATE(4323)] = 107730,
  [SMALL_STATE(4324)] = 107804,
  [SMALL_STATE(4325)] = 107866,
  [SMALL_STATE(4326)] = 107934,
  [SMALL_STATE(4327)] = 107998,
  [SMALL_STATE(4328)] = 108060,
  [SMALL_STATE(4329)] = 108118,
  [SMALL_STATE(4330)] = 108176,
  [SMALL_STATE(4331)] = 108246,
  [SMALL_STATE(4332)] = 108304,
  [SMALL_STATE(4333)] = 108362,
  [SMALL_STATE(4334)] = 108420,
  [SMALL_STATE(4335)] = 108478,
  [SMALL_STATE(4336)] = 108536,
  [SMALL_STATE(4337)] = 108594,
  [SMALL_STATE(4338)] = 108652,
  [SMALL_STATE(4339)] = 108710,
  [SMALL_STATE(4340)] = 108768,
  [SMALL_STATE(4341)] = 108826,
  [SMALL_STATE(4342)] = 108930,
  [SMALL_STATE(4343)] = 109034,
  [SMALL_STATE(4344)] = 109092,
  [SMALL_STATE(4345)] = 109150,
  [SMALL_STATE(4346)] = 109208,
  [SMALL_STATE(4347)] = 109266,
  [SMALL_STATE(4348)] = 109324,
  [SMALL_STATE(4349)] = 109382,
  [SMALL_STATE(4350)] = 109440,
  [SMALL_STATE(4351)] = 109498,
  [SMALL_STATE(4352)] = 109556,
  [SMALL_STATE(4353)] = 109614,
  [SMALL_STATE(4354)] = 109672,
  [SMALL_STATE(4355)] = 109730,
  [SMALL_STATE(4356)] = 109788,
  [SMALL_STATE(4357)] = 109858,
  [SMALL_STATE(4358)] = 109964,
  [SMALL_STATE(4359)] = 110022,
  [SMALL_STATE(4360)] = 110080,
  [SMALL_STATE(4361)] = 110138,
  [SMALL_STATE(4362)] = 110196,
  [SMALL_STATE(4363)] = 110298,
  [SMALL_STATE(4364)] = 110355,
  [SMALL_STATE(4365)] = 110456,
  [SMALL_STATE(4366)] = 110557,
  [SMALL_STATE(4367)] = 110658,
  [SMALL_STATE(4368)] = 110759,
  [SMALL_STATE(4369)] = 110860,
  [SMALL_STATE(4370)] = 110961,
  [SMALL_STATE(4371)] = 111062,
  [SMALL_STATE(4372)] = 111163,
  [SMALL_STATE(4373)] = 111264,
  [SMALL_STATE(4374)] = 111323,
  [SMALL_STATE(4375)] = 111424,
  [SMALL_STATE(4376)] = 111525,
  [SMALL_STATE(4377)] = 111626,
  [SMALL_STATE(4378)] = 111727,
  [SMALL_STATE(4379)] = 111830,
  [SMALL_STATE(4380)] = 111931,
  [SMALL_STATE(4381)] = 112032,
  [SMALL_STATE(4382)] = 112133,
  [SMALL_STATE(4383)] = 112234,
  [SMALL_STATE(4384)] = 112293,
  [SMALL_STATE(4385)] = 112394,
  [SMALL_STATE(4386)] = 112495,
  [SMALL_STATE(4387)] = 112596,
  [SMALL_STATE(4388)] = 112697,
  [SMALL_STATE(4389)] = 112798,
  [SMALL_STATE(4390)] = 112899,
  [SMALL_STATE(4391)] = 113000,
  [SMALL_STATE(4392)] = 113101,
  [SMALL_STATE(4393)] = 113202,
  [SMALL_STATE(4394)] = 113303,
  [SMALL_STATE(4395)] = 113404,
  [SMALL_STATE(4396)] = 113505,
  [SMALL_STATE(4397)] = 113606,
  [SMALL_STATE(4398)] = 113707,
  [SMALL_STATE(4399)] = 113766,
  [SMALL_STATE(4400)] = 113867,
  [SMALL_STATE(4401)] = 113968,
  [SMALL_STATE(4402)] = 114069,
  [SMALL_STATE(4403)] = 114170,
  [SMALL_STATE(4404)] = 114271,
  [SMALL_STATE(4405)] = 114372,
  [SMALL_STATE(4406)] = 114473,
  [SMALL_STATE(4407)] = 114530,
  [SMALL_STATE(4408)] = 114587,
  [SMALL_STATE(4409)] = 114688,
  [SMALL_STATE(4410)] = 114749,
  [SMALL_STATE(4411)] = 114850,
  [SMALL_STATE(4412)] = 114951,
  [SMALL_STATE(4413)] = 115052,
  [SMALL_STATE(4414)] = 115121,
  [SMALL_STATE(4415)] = 115222,
  [SMALL_STATE(4416)] = 115323,
  [SMALL_STATE(4417)] = 115424,
  [SMALL_STATE(4418)] = 115525,
  [SMALL_STATE(4419)] = 115626,
  [SMALL_STATE(4420)] = 115727,
  [SMALL_STATE(4421)] = 115784,
  [SMALL_STATE(4422)] = 115885,
  [SMALL_STATE(4423)] = 115944,
  [SMALL_STATE(4424)] = 116001,
  [SMALL_STATE(4425)] = 116060,
  [SMALL_STATE(4426)] = 116163,
  [SMALL_STATE(4427)] = 116264,
  [SMALL_STATE(4428)] = 116365,
  [SMALL_STATE(4429)] = 116434,
  [SMALL_STATE(4430)] = 116535,
  [SMALL_STATE(4431)] = 116636,
  [SMALL_STATE(4432)] = 116737,
  [SMALL_STATE(4433)] = 116838,
  [SMALL_STATE(4434)] = 116939,
  [SMALL_STATE(4435)] = 117042,
  [SMALL_STATE(4436)] = 117107,
  [SMALL_STATE(4437)] = 117172,
  [SMALL_STATE(4438)] = 117273,
  [SMALL_STATE(4439)] = 117374,
  [SMALL_STATE(4440)] = 117441,
  [SMALL_STATE(4441)] = 117498,
  [SMALL_STATE(4442)] = 117599,
  [SMALL_STATE(4443)] = 117700,
  [SMALL_STATE(4444)] = 117801,
  [SMALL_STATE(4445)] = 117902,
  [SMALL_STATE(4446)] = 118003,
  [SMALL_STATE(4447)] = 118104,
  [SMALL_STATE(4448)] = 118161,
  [SMALL_STATE(4449)] = 118218,
  [SMALL_STATE(4450)] = 118285,
  [SMALL_STATE(4451)] = 118386,
  [SMALL_STATE(4452)] = 118487,
  [SMALL_STATE(4453)] = 118588,
  [SMALL_STATE(4454)] = 118645,
  [SMALL_STATE(4455)] = 118702,
  [SMALL_STATE(4456)] = 118759,
  [SMALL_STATE(4457)] = 118816,
  [SMALL_STATE(4458)] = 118873,
  [SMALL_STATE(4459)] = 118930,
  [SMALL_STATE(4460)] = 118997,
  [SMALL_STATE(4461)] = 119054,
  [SMALL_STATE(4462)] = 119111,
  [SMALL_STATE(4463)] = 119212,
  [SMALL_STATE(4464)] = 119313,
  [SMALL_STATE(4465)] = 119414,
  [SMALL_STATE(4466)] = 119515,
  [SMALL_STATE(4467)] = 119616,
  [SMALL_STATE(4468)] = 119717,
  [SMALL_STATE(4469)] = 119820,
  [SMALL_STATE(4470)] = 119921,
  [SMALL_STATE(4471)] = 120022,
  [SMALL_STATE(4472)] = 120081,
  [SMALL_STATE(4473)] = 120182,
  [SMALL_STATE(4474)] = 120283,
  [SMALL_STATE(4475)] = 120384,
  [SMALL_STATE(4476)] = 120485,
  [SMALL_STATE(4477)] = 120586,
  [SMALL_STATE(4478)] = 120687,
  [SMALL_STATE(4479)] = 120748,
  [SMALL_STATE(4480)] = 120849,
  [SMALL_STATE(4481)] = 120905,
  [SMALL_STATE(4482)] = 120961,
  [SMALL_STATE(4483)] = 121017,
  [SMALL_STATE(4484)] = 121073,
  [SMALL_STATE(4485)] = 121129,
  [SMALL_STATE(4486)] = 121185,
  [SMALL_STATE(4487)] = 121241,
  [SMALL_STATE(4488)] = 121297,
  [SMALL_STATE(4489)] = 121361,
  [SMALL_STATE(4490)] = 121421,
  [SMALL_STATE(4491)] = 121477,
  [SMALL_STATE(4492)] = 121533,
  [SMALL_STATE(4493)] = 121631,
  [SMALL_STATE(4494)] = 121687,
  [SMALL_STATE(4495)] = 121743,
  [SMALL_STATE(4496)] = 121841,
  [SMALL_STATE(4497)] = 121939,
  [SMALL_STATE(4498)] = 121995,
  [SMALL_STATE(4499)] = 122051,
  [SMALL_STATE(4500)] = 122107,
  [SMALL_STATE(4501)] = 122179,
  [SMALL_STATE(4502)] = 122251,
  [SMALL_STATE(4503)] = 122307,
  [SMALL_STATE(4504)] = 122405,
  [SMALL_STATE(4505)] = 122461,
  [SMALL_STATE(4506)] = 122517,
  [SMALL_STATE(4507)] = 122573,
  [SMALL_STATE(4508)] = 122629,
  [SMALL_STATE(4509)] = 122685,
  [SMALL_STATE(4510)] = 122741,
  [SMALL_STATE(4511)] = 122839,
  [SMALL_STATE(4512)] = 122907,
  [SMALL_STATE(4513)] = 122963,
  [SMALL_STATE(4514)] = 123035,
  [SMALL_STATE(4515)] = 123133,
  [SMALL_STATE(4516)] = 123189,
  [SMALL_STATE(4517)] = 123245,
  [SMALL_STATE(4518)] = 123301,
  [SMALL_STATE(4519)] = 123357,
  [SMALL_STATE(4520)] = 123427,
  [SMALL_STATE(4521)] = 123525,
  [SMALL_STATE(4522)] = 123581,
  [SMALL_STATE(4523)] = 123637,
  [SMALL_STATE(4524)] = 123735,
  [SMALL_STATE(4525)] = 123791,
  [SMALL_STATE(4526)] = 123847,
  [SMALL_STATE(4527)] = 123903,
  [SMALL_STATE(4528)] = 124001,
  [SMALL_STATE(4529)] = 124057,
  [SMALL_STATE(4530)] = 124113,
  [SMALL_STATE(4531)] = 124173,
  [SMALL_STATE(4532)] = 124229,
  [SMALL_STATE(4533)] = 124291,
  [SMALL_STATE(4534)] = 124361,
  [SMALL_STATE(4535)] = 124459,
  [SMALL_STATE(4536)] = 124529,
  [SMALL_STATE(4537)] = 124585,
  [SMALL_STATE(4538)] = 124687,
  [SMALL_STATE(4539)] = 124751,
  [SMALL_STATE(4540)] = 124821,
  [SMALL_STATE(4541)] = 124923,
  [SMALL_STATE(4542)] = 124979,
  [SMALL_STATE(4543)] = 125047,
  [SMALL_STATE(4544)] = 125103,
  [SMALL_STATE(4545)] = 125159,
  [SMALL_STATE(4546)] = 125215,
  [SMALL_STATE(4547)] = 125271,
  [SMALL_STATE(4548)] = 125327,
  [SMALL_STATE(4549)] = 125383,
  [SMALL_STATE(4550)] = 125481,
  [SMALL_STATE(4551)] = 125537,
  [SMALL_STATE(4552)] = 125635,
  [SMALL_STATE(4553)] = 125691,
  [SMALL_STATE(4554)] = 125753,
  [SMALL_STATE(4555)] = 125813,
  [SMALL_STATE(4556)] = 125869,
  [SMALL_STATE(4557)] = 125967,
  [SMALL_STATE(4558)] = 126027,
  [SMALL_STATE(4559)] = 126083,
  [SMALL_STATE(4560)] = 126139,
  [SMALL_STATE(4561)] = 126195,
  [SMALL_STATE(4562)] = 126251,
  [SMALL_STATE(4563)] = 126307,
  [SMALL_STATE(4564)] = 126367,
  [SMALL_STATE(4565)] = 126423,
  [SMALL_STATE(4566)] = 126479,
  [SMALL_STATE(4567)] = 126535,
  [SMALL_STATE(4568)] = 126591,
  [SMALL_STATE(4569)] = 126647,
  [SMALL_STATE(4570)] = 126703,
  [SMALL_STATE(4571)] = 126763,
  [SMALL_STATE(4572)] = 126819,
  [SMALL_STATE(4573)] = 126875,
  [SMALL_STATE(4574)] = 126973,
  [SMALL_STATE(4575)] = 127029,
  [SMALL_STATE(4576)] = 127085,
  [SMALL_STATE(4577)] = 127143,
  [SMALL_STATE(4578)] = 127199,
  [SMALL_STATE(4579)] = 127271,
  [SMALL_STATE(4580)] = 127333,
  [SMALL_STATE(4581)] = 127393,
  [SMALL_STATE(4582)] = 127449,
  [SMALL_STATE(4583)] = 127509,
  [SMALL_STATE(4584)] = 127565,
  [SMALL_STATE(4585)] = 127621,
  [SMALL_STATE(4586)] = 127719,
  [SMALL_STATE(4587)] = 127779,
  [SMALL_STATE(4588)] = 127835,
  [SMALL_STATE(4589)] = 127907,
  [SMALL_STATE(4590)] = 127963,
  [SMALL_STATE(4591)] = 128019,
  [SMALL_STATE(4592)] = 128075,
  [SMALL_STATE(4593)] = 128137,
  [SMALL_STATE(4594)] = 128194,
  [SMALL_STATE(4595)] = 128249,
  [SMALL_STATE(4596)] = 128336,
  [SMALL_STATE(4597)] = 128391,
  [SMALL_STATE(4598)] = 128450,
  [SMALL_STATE(4599)] = 128505,
  [SMALL_STATE(4600)] = 128560,
  [SMALL_STATE(4601)] = 128615,
  [SMALL_STATE(4602)] = 128674,
  [SMALL_STATE(4603)] = 128729,
  [SMALL_STATE(4604)] = 128784,
  [SMALL_STATE(4605)] = 128839,
  [SMALL_STATE(4606)] = 128894,
  [SMALL_STATE(4607)] = 128953,
  [SMALL_STATE(4608)] = 129016,
  [SMALL_STATE(4609)] = 129075,
  [SMALL_STATE(4610)] = 129134,
  [SMALL_STATE(4611)] = 129189,
  [SMALL_STATE(4612)] = 129248,
  [SMALL_STATE(4613)] = 129315,
  [SMALL_STATE(4614)] = 129370,
  [SMALL_STATE(4615)] = 129425,
  [SMALL_STATE(4616)] = 129512,
  [SMALL_STATE(4617)] = 129567,
  [SMALL_STATE(4618)] = 129622,
  [SMALL_STATE(4619)] = 129677,
  [SMALL_STATE(4620)] = 129732,
  [SMALL_STATE(4621)] = 129787,
  [SMALL_STATE(4622)] = 129846,
  [SMALL_STATE(4623)] = 129909,
  [SMALL_STATE(4624)] = 129964,
  [SMALL_STATE(4625)] = 130019,
  [SMALL_STATE(4626)] = 130076,
  [SMALL_STATE(4627)] = 130131,
  [SMALL_STATE(4628)] = 130186,
  [SMALL_STATE(4629)] = 130241,
  [SMALL_STATE(4630)] = 130300,
  [SMALL_STATE(4631)] = 130355,
  [SMALL_STATE(4632)] = 130414,
  [SMALL_STATE(4633)] = 130473,
  [SMALL_STATE(4634)] = 130528,
  [SMALL_STATE(4635)] = 130587,
  [SMALL_STATE(4636)] = 130642,
  [SMALL_STATE(4637)] = 130697,
  [SMALL_STATE(4638)] = 130784,
  [SMALL_STATE(4639)] = 130839,
  [SMALL_STATE(4640)] = 130894,
  [SMALL_STATE(4641)] = 130949,
  [SMALL_STATE(4642)] = 131004,
  [SMALL_STATE(4643)] = 131059,
  [SMALL_STATE(4644)] = 131114,
  [SMALL_STATE(4645)] = 131169,
  [SMALL_STATE(4646)] = 131224,
  [SMALL_STATE(4647)] = 131279,
  [SMALL_STATE(4648)] = 131336,
  [SMALL_STATE(4649)] = 131395,
  [SMALL_STATE(4650)] = 131458,
  [SMALL_STATE(4651)] = 131515,
  [SMALL_STATE(4652)] = 131570,
  [SMALL_STATE(4653)] = 131625,
  [SMALL_STATE(4654)] = 131680,
  [SMALL_STATE(4655)] = 131735,
  [SMALL_STATE(4656)] = 131790,
  [SMALL_STATE(4657)] = 131845,
  [SMALL_STATE(4658)] = 131932,
  [SMALL_STATE(4659)] = 131999,
  [SMALL_STATE(4660)] = 132054,
  [SMALL_STATE(4661)] = 132109,
  [SMALL_STATE(4662)] = 132196,
  [SMALL_STATE(4663)] = 132251,
  [SMALL_STATE(4664)] = 132306,
  [SMALL_STATE(4665)] = 132365,
  [SMALL_STATE(4666)] = 132452,
  [SMALL_STATE(4667)] = 132519,
  [SMALL_STATE(4668)] = 132574,
  [SMALL_STATE(4669)] = 132633,
  [SMALL_STATE(4670)] = 132700,
  [SMALL_STATE(4671)] = 132759,
  [SMALL_STATE(4672)] = 132814,
  [SMALL_STATE(4673)] = 132874,
  [SMALL_STATE(4674)] = 132944,
  [SMALL_STATE(4675)] = 133014,
  [SMALL_STATE(4676)] = 133072,
  [SMALL_STATE(4677)] = 133130,
  [SMALL_STATE(4678)] = 133188,
  [SMALL_STATE(4679)] = 133258,
  [SMALL_STATE(4680)] = 133316,
  [SMALL_STATE(4681)] = 133402,
  [SMALL_STATE(4682)] = 133460,
  [SMALL_STATE(4683)] = 133528,
  [SMALL_STATE(4684)] = 133592,
  [SMALL_STATE(4685)] = 133650,
  [SMALL_STATE(4686)] = 133714,
  [SMALL_STATE(4687)] = 133774,
  [SMALL_STATE(4688)] = 133874,
  [SMALL_STATE(4689)] = 133934,
  [SMALL_STATE(4690)] = 134004,
  [SMALL_STATE(4691)] = 134064,
  [SMALL_STATE(4692)] = 134118,
  [SMALL_STATE(4693)] = 134204,
  [SMALL_STATE(4694)] = 134262,
  [SMALL_STATE(4695)] = 134332,
  [SMALL_STATE(4696)] = 134432,
  [SMALL_STATE(4697)] = 134532,
  [SMALL_STATE(4698)] = 134590,
  [SMALL_STATE(4699)] = 134648,
  [SMALL_STATE(4700)] = 134706,
  [SMALL_STATE(4701)] = 134776,
  [SMALL_STATE(4702)] = 134834,
  [SMALL_STATE(4703)] = 134904,
  [SMALL_STATE(4704)] = 134962,
  [SMALL_STATE(4705)] = 135032,
  [SMALL_STATE(4706)] = 135132,
  [SMALL_STATE(4707)] = 135217,
  [SMALL_STATE(4708)] = 135276,
  [SMALL_STATE(4709)] = 135341,
  [SMALL_STATE(4710)] = 135400,
  [SMALL_STATE(4711)] = 135485,
  [SMALL_STATE(4712)] = 135544,
  [SMALL_STATE(4713)] = 135597,
  [SMALL_STATE(4714)] = 135650,
  [SMALL_STATE(4715)] = 135711,
  [SMALL_STATE(4716)] = 135764,
  [SMALL_STATE(4717)] = 135819,
  [SMALL_STATE(4718)] = 135904,
  [SMALL_STATE(4719)] = 135973,
  [SMALL_STATE(4720)] = 136026,
  [SMALL_STATE(4721)] = 136087,
  [SMALL_STATE(4722)] = 136140,
  [SMALL_STATE(4723)] = 136193,
  [SMALL_STATE(4724)] = 136258,
  [SMALL_STATE(4725)] = 136313,
  [SMALL_STATE(4726)] = 136372,
  [SMALL_STATE(4727)] = 136457,
  [SMALL_STATE(4728)] = 136510,
  [SMALL_STATE(4729)] = 136565,
  [SMALL_STATE(4730)] = 136617,
  [SMALL_STATE(4731)] = 136701,
  [SMALL_STATE(4732)] = 136753,
  [SMALL_STATE(4733)] = 136839,
  [SMALL_STATE(4734)] = 136907,
  [SMALL_STATE(4735)] = 136959,
  [SMALL_STATE(4736)] = 137011,
  [SMALL_STATE(4737)] = 137063,
  [SMALL_STATE(4738)] = 137115,
  [SMALL_STATE(4739)] = 137201,
  [SMALL_STATE(4740)] = 137257,
  [SMALL_STATE(4741)] = 137313,
  [SMALL_STATE(4742)] = 137369,
  [SMALL_STATE(4743)] = 137455,
  [SMALL_STATE(4744)] = 137511,
  [SMALL_STATE(4745)] = 137597,
  [SMALL_STATE(4746)] = 137683,
  [SMALL_STATE(4747)] = 137769,
  [SMALL_STATE(4748)] = 137825,
  [SMALL_STATE(4749)] = 137911,
  [SMALL_STATE(4750)] = 137963,
  [SMALL_STATE(4751)] = 138049,
  [SMALL_STATE(4752)] = 138135,
  [SMALL_STATE(4753)] = 138221,
  [SMALL_STATE(4754)] = 138307,
  [SMALL_STATE(4755)] = 138359,
  [SMALL_STATE(4756)] = 138415,
  [SMALL_STATE(4757)] = 138467,
  [SMALL_STATE(4758)] = 138553,
  [SMALL_STATE(4759)] = 138605,
  [SMALL_STATE(4760)] = 138657,
  [SMALL_STATE(4761)] = 138709,
  [SMALL_STATE(4762)] = 138761,
  [SMALL_STATE(4763)] = 138817,
  [SMALL_STATE(4764)] = 138869,
  [SMALL_STATE(4765)] = 138955,
  [SMALL_STATE(4766)] = 139019,
  [SMALL_STATE(4767)] = 139083,
  [SMALL_STATE(4768)] = 139139,
  [SMALL_STATE(4769)] = 139191,
  [SMALL_STATE(4770)] = 139259,
  [SMALL_STATE(4771)] = 139319,
  [SMALL_STATE(4772)] = 139371,
  [SMALL_STATE(4773)] = 139457,
  [SMALL_STATE(4774)] = 139513,
  [SMALL_STATE(4775)] = 139565,
  [SMALL_STATE(4776)] = 139617,
  [SMALL_STATE(4777)] = 139673,
  [SMALL_STATE(4778)] = 139751,
  [SMALL_STATE(4779)] = 139803,
  [SMALL_STATE(4780)] = 139855,
  [SMALL_STATE(4781)] = 139933,
  [SMALL_STATE(4782)] = 139985,
  [SMALL_STATE(4783)] = 140071,
  [SMALL_STATE(4784)] = 140123,
  [SMALL_STATE(4785)] = 140175,
  [SMALL_STATE(4786)] = 140227,
  [SMALL_STATE(4787)] = 140279,
  [SMALL_STATE(4788)] = 140347,
  [SMALL_STATE(4789)] = 140433,
  [SMALL_STATE(4790)] = 140485,
  [SMALL_STATE(4791)] = 140537,
  [SMALL_STATE(4792)] = 140623,
  [SMALL_STATE(4793)] = 140675,
  [SMALL_STATE(4794)] = 140727,
  [SMALL_STATE(4795)] = 140779,
  [SMALL_STATE(4796)] = 140831,
  [SMALL_STATE(4797)] = 140883,
  [SMALL_STATE(4798)] = 140969,
  [SMALL_STATE(4799)] = 141025,
  [SMALL_STATE(4800)] = 141077,
  [SMALL_STATE(4801)] = 141133,
  [SMALL_STATE(4802)] = 141185,
  [SMALL_STATE(4803)] = 141237,
  [SMALL_STATE(4804)] = 141289,
  [SMALL_STATE(4805)] = 141357,
  [SMALL_STATE(4806)] = 141409,
  [SMALL_STATE(4807)] = 141493,
  [SMALL_STATE(4808)] = 141545,
  [SMALL_STATE(4809)] = 141646,
  [SMALL_STATE(4810)] = 141703,
  [SMALL_STATE(4811)] = 141770,
  [SMALL_STATE(4812)] = 141831,
  [SMALL_STATE(4813)] = 141894,
  [SMALL_STATE(4814)] = 141989,
  [SMALL_STATE(4815)] = 142040,
  [SMALL_STATE(4816)] = 142141,
  [SMALL_STATE(4817)] = 142192,
  [SMALL_STATE(4818)] = 142243,
  [SMALL_STATE(4819)] = 142328,
  [SMALL_STATE(4820)] = 142379,
  [SMALL_STATE(4821)] = 142446,
  [SMALL_STATE(4822)] = 142513,
  [SMALL_STATE(4823)] = 142584,
  [SMALL_STATE(4824)] = 142635,
  [SMALL_STATE(4825)] = 142686,
  [SMALL_STATE(4826)] = 142761,
  [SMALL_STATE(4827)] = 142814,
  [SMALL_STATE(4828)] = 142913,
  [SMALL_STATE(4829)] = 142964,
  [SMALL_STATE(4830)] = 143047,
  [SMALL_STATE(4831)] = 143136,
  [SMALL_STATE(4832)] = 143219,
  [SMALL_STATE(4833)] = 143314,
  [SMALL_STATE(4834)] = 143381,
  [SMALL_STATE(4835)] = 143432,
  [SMALL_STATE(4836)] = 143511,
  [SMALL_STATE(4837)] = 143594,
  [SMALL_STATE(4838)] = 143645,
  [SMALL_STATE(4839)] = 143696,
  [SMALL_STATE(4840)] = 143765,
  [SMALL_STATE(4841)] = 143868,
  [SMALL_STATE(4842)] = 143971,
  [SMALL_STATE(4843)] = 144070,
  [SMALL_STATE(4844)] = 144143,
  [SMALL_STATE(4845)] = 144194,
  [SMALL_STATE(4846)] = 144285,
  [SMALL_STATE(4847)] = 144388,
  [SMALL_STATE(4848)] = 144487,
  [SMALL_STATE(4849)] = 144590,
  [SMALL_STATE(4850)] = 144689,
  [SMALL_STATE(4851)] = 144739,
  [SMALL_STATE(4852)] = 144789,
  [SMALL_STATE(4853)] = 144839,
  [SMALL_STATE(4854)] = 144889,
  [SMALL_STATE(4855)] = 144939,
  [SMALL_STATE(4856)] = 145017,
  [SMALL_STATE(4857)] = 145067,
  [SMALL_STATE(4858)] = 145149,
  [SMALL_STATE(4859)] = 145227,
  [SMALL_STATE(4860)] = 145283,
  [SMALL_STATE(4861)] = 145365,
  [SMALL_STATE(4862)] = 145421,
  [SMALL_STATE(4863)] = 145499,
  [SMALL_STATE(4864)] = 145549,
  [SMALL_STATE(4865)] = 145599,
  [SMALL_STATE(4866)] = 145677,
  [SMALL_STATE(4867)] = 145739,
  [SMALL_STATE(4868)] = 145789,
  [SMALL_STATE(4869)] = 145839,
  [SMALL_STATE(4870)] = 145917,
  [SMALL_STATE(4871)] = 145995,
  [SMALL_STATE(4872)] = 146045,
  [SMALL_STATE(4873)] = 146123,
  [SMALL_STATE(4874)] = 146201,
  [SMALL_STATE(4875)] = 146257,
  [SMALL_STATE(4876)] = 146313,
  [SMALL_STATE(4877)] = 146391,
  [SMALL_STATE(4878)] = 146447,
  [SMALL_STATE(4879)] = 146501,
  [SMALL_STATE(4880)] = 146551,
  [SMALL_STATE(4881)] = 146629,
  [SMALL_STATE(4882)] = 146679,
  [SMALL_STATE(4883)] = 146729,
  [SMALL_STATE(4884)] = 146779,
  [SMALL_STATE(4885)] = 146829,
  [SMALL_STATE(4886)] = 146879,
  [SMALL_STATE(4887)] = 146957,
  [SMALL_STATE(4888)] = 147035,
  [SMALL_STATE(4889)] = 147085,
  [SMALL_STATE(4890)] = 147163,
  [SMALL_STATE(4891)] = 147213,
  [SMALL_STATE(4892)] = 147269,
  [SMALL_STATE(4893)] = 147347,
  [SMALL_STATE(4894)] = 147425,
  [SMALL_STATE(4895)] = 147475,
  [SMALL_STATE(4896)] = 147525,
  [SMALL_STATE(4897)] = 147575,
  [SMALL_STATE(4898)] = 147625,
  [SMALL_STATE(4899)] = 147703,
  [SMALL_STATE(4900)] = 147781,
  [SMALL_STATE(4901)] = 147859,
  [SMALL_STATE(4902)] = 147937,
  [SMALL_STATE(4903)] = 148015,
  [SMALL_STATE(4904)] = 148065,
  [SMALL_STATE(4905)] = 148115,
  [SMALL_STATE(4906)] = 148165,
  [SMALL_STATE(4907)] = 148215,
  [SMALL_STATE(4908)] = 148293,
  [SMALL_STATE(4909)] = 148355,
  [SMALL_STATE(4910)] = 148433,
  [SMALL_STATE(4911)] = 148489,
  [SMALL_STATE(4912)] = 148567,
  [SMALL_STATE(4913)] = 148617,
  [SMALL_STATE(4914)] = 148667,
  [SMALL_STATE(4915)] = 148745,
  [SMALL_STATE(4916)] = 148797,
  [SMALL_STATE(4917)] = 148875,
  [SMALL_STATE(4918)] = 148927,
  [SMALL_STATE(4919)] = 148977,
  [SMALL_STATE(4920)] = 149027,
  [SMALL_STATE(4921)] = 149105,
  [SMALL_STATE(4922)] = 149155,
  [SMALL_STATE(4923)] = 149233,
  [SMALL_STATE(4924)] = 149283,
  [SMALL_STATE(4925)] = 149361,
  [SMALL_STATE(4926)] = 149439,
  [SMALL_STATE(4927)] = 149517,
  [SMALL_STATE(4928)] = 149567,
  [SMALL_STATE(4929)] = 149645,
  [SMALL_STATE(4930)] = 149723,
  [SMALL_STATE(4931)] = 149779,
  [SMALL_STATE(4932)] = 149857,
  [SMALL_STATE(4933)] = 149935,
  [SMALL_STATE(4934)] = 150013,
  [SMALL_STATE(4935)] = 150091,
  [SMALL_STATE(4936)] = 150169,
  [SMALL_STATE(4937)] = 150225,
  [SMALL_STATE(4938)] = 150275,
  [SMALL_STATE(4939)] = 150353,
  [SMALL_STATE(4940)] = 150416,
  [SMALL_STATE(4941)] = 150497,
  [SMALL_STATE(4942)] = 150546,
  [SMALL_STATE(4943)] = 150615,
  [SMALL_STATE(4944)] = 150718,
  [SMALL_STATE(4945)] = 150815,
  [SMALL_STATE(4946)] = 150878,
  [SMALL_STATE(4947)] = 150979,
  [SMALL_STATE(4948)] = 151048,
  [SMALL_STATE(4949)] = 151107,
  [SMALL_STATE(4950)] = 151162,
  [SMALL_STATE(4951)] = 151221,
  [SMALL_STATE(4952)] = 151310,
  [SMALL_STATE(4953)] = 151407,
  [SMALL_STATE(4954)] = 151510,
  [SMALL_STATE(4955)] = 151613,
  [SMALL_STATE(4956)] = 151666,
  [SMALL_STATE(4957)] = 151735,
  [SMALL_STATE(4958)] = 151832,
  [SMALL_STATE(4959)] = 151891,
  [SMALL_STATE(4960)] = 151992,
  [SMALL_STATE(4961)] = 152051,
  [SMALL_STATE(4962)] = 152104,
  [SMALL_STATE(4963)] = 152181,
  [SMALL_STATE(4964)] = 152234,
  [SMALL_STATE(4965)] = 152297,
  [SMALL_STATE(4966)] = 152394,
  [SMALL_STATE(4967)] = 152495,
  [SMALL_STATE(4968)] = 152572,
  [SMALL_STATE(4969)] = 152633,
  [SMALL_STATE(4970)] = 152734,
  [SMALL_STATE(4971)] = 152815,
  [SMALL_STATE(4972)] = 152872,
  [SMALL_STATE(4973)] = 152923,
  [SMALL_STATE(4974)] = 152982,
  [SMALL_STATE(4975)] = 153031,
  [SMALL_STATE(4976)] = 153098,
  [SMALL_STATE(4977)] = 153191,
  [SMALL_STATE(4978)] = 153280,
  [SMALL_STATE(4979)] = 153367,
  [SMALL_STATE(4980)] = 153450,
  [SMALL_STATE(4981)] = 153531,
  [SMALL_STATE(4982)] = 153590,
  [SMALL_STATE(4983)] = 153653,
  [SMALL_STATE(4984)] = 153704,
  [SMALL_STATE(4985)] = 153755,
  [SMALL_STATE(4986)] = 153816,
  [SMALL_STATE(4987)] = 153867,
  [SMALL_STATE(4988)] = 153944,
  [SMALL_STATE(4989)] = 154017,
  [SMALL_STATE(4990)] = 154072,
  [SMALL_STATE(4991)] = 154141,
  [SMALL_STATE(4992)] = 154212,
  [SMALL_STATE(4993)] = 154315,
  [SMALL_STATE(4994)] = 154364,
  [SMALL_STATE(4995)] = 154413,
  [SMALL_STATE(4996)] = 154507,
  [SMALL_STATE(4997)] = 154555,
  [SMALL_STATE(4998)] = 154621,
  [SMALL_STATE(4999)] = 154711,
  [SMALL_STATE(5000)] = 154811,
  [SMALL_STATE(5001)] = 154887,
  [SMALL_STATE(5002)] = 154935,
  [SMALL_STATE(5003)] = 155011,
  [SMALL_STATE(5004)] = 155059,
  [SMALL_STATE(5005)] = 155129,
  [SMALL_STATE(5006)] = 155209,
  [SMALL_STATE(5007)] = 155259,
  [SMALL_STATE(5008)] = 155327,
  [SMALL_STATE(5009)] = 155399,
  [SMALL_STATE(5010)] = 155477,
  [SMALL_STATE(5011)] = 155555,
  [SMALL_STATE(5012)] = 155633,
  [SMALL_STATE(5013)] = 155709,
  [SMALL_STATE(5014)] = 155785,
  [SMALL_STATE(5015)] = 155835,
  [SMALL_STATE(5016)] = 155885,
  [SMALL_STATE(5017)] = 155965,
  [SMALL_STATE(5018)] = 156059,
  [SMALL_STATE(5019)] = 156137,
  [SMALL_STATE(5020)] = 156227,
  [SMALL_STATE(5021)] = 156317,
  [SMALL_STATE(5022)] = 156371,
  [SMALL_STATE(5023)] = 156449,
  [SMALL_STATE(5024)] = 156527,
  [SMALL_STATE(5025)] = 156579,
  [SMALL_STATE(5026)] = 156661,
  [SMALL_STATE(5027)] = 156739,
  [SMALL_STATE(5028)] = 156819,
  [SMALL_STATE(5029)] = 156897,
  [SMALL_STATE(5030)] = 156985,
  [SMALL_STATE(5031)] = 157065,
  [SMALL_STATE(5032)] = 157151,
  [SMALL_STATE(5033)] = 157199,
  [SMALL_STATE(5034)] = 157249,
  [SMALL_STATE(5035)] = 157333,
  [SMALL_STATE(5036)] = 157411,
  [SMALL_STATE(5037)] = 157505,
  [SMALL_STATE(5038)] = 157595,
  [SMALL_STATE(5039)] = 157671,
  [SMALL_STATE(5040)] = 157768,
  [SMALL_STATE(5041)] = 157837,
  [SMALL_STATE(5042)] = 157934,
  [SMALL_STATE(5043)] = 158031,
  [SMALL_STATE(5044)] = 158128,
  [SMALL_STATE(5045)] = 158175,
  [SMALL_STATE(5046)] = 158272,
  [SMALL_STATE(5047)] = 158351,
  [SMALL_STATE(5048)] = 158398,
  [SMALL_STATE(5049)] = 158453,
  [SMALL_STATE(5050)] = 158500,
  [SMALL_STATE(5051)] = 158557,
  [SMALL_STATE(5052)] = 158654,
  [SMALL_STATE(5053)] = 158751,
  [SMALL_STATE(5054)] = 158798,
  [SMALL_STATE(5055)] = 158845,
  [SMALL_STATE(5056)] = 158892,
  [SMALL_STATE(5057)] = 158943,
  [SMALL_STATE(5058)] = 159040,
  [SMALL_STATE(5059)] = 159087,
  [SMALL_STATE(5060)] = 159134,
  [SMALL_STATE(5061)] = 159181,
  [SMALL_STATE(5062)] = 159234,
  [SMALL_STATE(5063)] = 159331,
  [SMALL_STATE(5064)] = 159428,
  [SMALL_STATE(5065)] = 159481,
  [SMALL_STATE(5066)] = 159578,
  [SMALL_STATE(5067)] = 159675,
  [SMALL_STATE(5068)] = 159772,
  [SMALL_STATE(5069)] = 159869,
  [SMALL_STATE(5070)] = 159966,
  [SMALL_STATE(5071)] = 160063,
  [SMALL_STATE(5072)] = 160110,
  [SMALL_STATE(5073)] = 160207,
  [SMALL_STATE(5074)] = 160300,
  [SMALL_STATE(5075)] = 160397,
  [SMALL_STATE(5076)] = 160466,
  [SMALL_STATE(5077)] = 160563,
  [SMALL_STATE(5078)] = 160610,
  [SMALL_STATE(5079)] = 160707,
  [SMALL_STATE(5080)] = 160804,
  [SMALL_STATE(5081)] = 160851,
  [SMALL_STATE(5082)] = 160948,
  [SMALL_STATE(5083)] = 161045,
  [SMALL_STATE(5084)] = 161092,
  [SMALL_STATE(5085)] = 161161,
  [SMALL_STATE(5086)] = 161230,
  [SMALL_STATE(5087)] = 161327,
  [SMALL_STATE(5088)] = 161424,
  [SMALL_STATE(5089)] = 161521,
  [SMALL_STATE(5090)] = 161568,
  [SMALL_STATE(5091)] = 161615,
  [SMALL_STATE(5092)] = 161690,
  [SMALL_STATE(5093)] = 161743,
  [SMALL_STATE(5094)] = 161790,
  [SMALL_STATE(5095)] = 161847,
  [SMALL_STATE(5096)] = 161894,
  [SMALL_STATE(5097)] = 161991,
  [SMALL_STATE(5098)] = 162088,
  [SMALL_STATE(5099)] = 162135,
  [SMALL_STATE(5100)] = 162232,
  [SMALL_STATE(5101)] = 162279,
  [SMALL_STATE(5102)] = 162326,
  [SMALL_STATE(5103)] = 162373,
  [SMALL_STATE(5104)] = 162470,
  [SMALL_STATE(5105)] = 162517,
  [SMALL_STATE(5106)] = 162614,
  [SMALL_STATE(5107)] = 162661,
  [SMALL_STATE(5108)] = 162758,
  [SMALL_STATE(5109)] = 162855,
  [SMALL_STATE(5110)] = 162902,
  [SMALL_STATE(5111)] = 162999,
  [SMALL_STATE(5112)] = 163046,
  [SMALL_STATE(5113)] = 163139,
  [SMALL_STATE(5114)] = 163186,
  [SMALL_STATE(5115)] = 163233,
  [SMALL_STATE(5116)] = 163330,
  [SMALL_STATE(5117)] = 163377,
  [SMALL_STATE(5118)] = 163474,
  [SMALL_STATE(5119)] = 163521,
  [SMALL_STATE(5120)] = 163618,
  [SMALL_STATE(5121)] = 163687,
  [SMALL_STATE(5122)] = 163734,
  [SMALL_STATE(5123)] = 163781,
  [SMALL_STATE(5124)] = 163828,
  [SMALL_STATE(5125)] = 163925,
  [SMALL_STATE(5126)] = 163972,
  [SMALL_STATE(5127)] = 164069,
  [SMALL_STATE(5128)] = 164166,
  [SMALL_STATE(5129)] = 164263,
  [SMALL_STATE(5130)] = 164360,
  [SMALL_STATE(5131)] = 164457,
  [SMALL_STATE(5132)] = 164504,
  [SMALL_STATE(5133)] = 164551,
  [SMALL_STATE(5134)] = 164598,
  [SMALL_STATE(5135)] = 164667,
  [SMALL_STATE(5136)] = 164714,
  [SMALL_STATE(5137)] = 164761,
  [SMALL_STATE(5138)] = 164858,
  [SMALL_STATE(5139)] = 164905,
  [SMALL_STATE(5140)] = 165002,
  [SMALL_STATE(5141)] = 165099,
  [SMALL_STATE(5142)] = 165188,
  [SMALL_STATE(5143)] = 165263,
  [SMALL_STATE(5144)] = 165332,
  [SMALL_STATE(5145)] = 165429,
  [SMALL_STATE(5146)] = 165526,
  [SMALL_STATE(5147)] = 165613,
  [SMALL_STATE(5148)] = 165664,
  [SMALL_STATE(5149)] = 165711,
  [SMALL_STATE(5150)] = 165758,
  [SMALL_STATE(5151)] = 165807,
  [SMALL_STATE(5152)] = 165904,
  [SMALL_STATE(5153)] = 165951,
  [SMALL_STATE(5154)] = 166040,
  [SMALL_STATE(5155)] = 166109,
  [SMALL_STATE(5156)] = 166156,
  [SMALL_STATE(5157)] = 166253,
  [SMALL_STATE(5158)] = 166346,
  [SMALL_STATE(5159)] = 166443,
  [SMALL_STATE(5160)] = 166532,
  [SMALL_STATE(5161)] = 166579,
  [SMALL_STATE(5162)] = 166648,
  [SMALL_STATE(5163)] = 166745,
  [SMALL_STATE(5164)] = 166842,
  [SMALL_STATE(5165)] = 166889,
  [SMALL_STATE(5166)] = 166936,
  [SMALL_STATE(5167)] = 167033,
  [SMALL_STATE(5168)] = 167080,
  [SMALL_STATE(5169)] = 167127,
  [SMALL_STATE(5170)] = 167224,
  [SMALL_STATE(5171)] = 167321,
  [SMALL_STATE(5172)] = 167414,
  [SMALL_STATE(5173)] = 167461,
  [SMALL_STATE(5174)] = 167508,
  [SMALL_STATE(5175)] = 167587,
  [SMALL_STATE(5176)] = 167676,
  [SMALL_STATE(5177)] = 167723,
  [SMALL_STATE(5178)] = 167816,
  [SMALL_STATE(5179)] = 167863,
  [SMALL_STATE(5180)] = 167910,
  [SMALL_STATE(5181)] = 167957,
  [SMALL_STATE(5182)] = 168004,
  [SMALL_STATE(5183)] = 168051,
  [SMALL_STATE(5184)] = 168148,
  [SMALL_STATE(5185)] = 168245,
  [SMALL_STATE(5186)] = 168324,
  [SMALL_STATE(5187)] = 168371,
  [SMALL_STATE(5188)] = 168468,
  [SMALL_STATE(5189)] = 168555,
  [SMALL_STATE(5190)] = 168602,
  [SMALL_STATE(5191)] = 168649,
  [SMALL_STATE(5192)] = 168746,
  [SMALL_STATE(5193)] = 168815,
  [SMALL_STATE(5194)] = 168862,
  [SMALL_STATE(5195)] = 168931,
  [SMALL_STATE(5196)] = 169000,
  [SMALL_STATE(5197)] = 169047,
  [SMALL_STATE(5198)] = 169142,
  [SMALL_STATE(5199)] = 169189,
  [SMALL_STATE(5200)] = 169236,
  [SMALL_STATE(5201)] = 169283,
  [SMALL_STATE(5202)] = 169380,
  [SMALL_STATE(5203)] = 169433,
  [SMALL_STATE(5204)] = 169480,
  [SMALL_STATE(5205)] = 169527,
  [SMALL_STATE(5206)] = 169574,
  [SMALL_STATE(5207)] = 169621,
  [SMALL_STATE(5208)] = 169716,
  [SMALL_STATE(5209)] = 169763,
  [SMALL_STATE(5210)] = 169810,
  [SMALL_STATE(5211)] = 169857,
  [SMALL_STATE(5212)] = 169936,
  [SMALL_STATE(5213)] = 170005,
  [SMALL_STATE(5214)] = 170072,
  [SMALL_STATE(5215)] = 170143,
  [SMALL_STATE(5216)] = 170218,
  [SMALL_STATE(5217)] = 170265,
  [SMALL_STATE(5218)] = 170342,
  [SMALL_STATE(5219)] = 170439,
  [SMALL_STATE(5220)] = 170536,
  [SMALL_STATE(5221)] = 170617,
  [SMALL_STATE(5222)] = 170700,
  [SMALL_STATE(5223)] = 170785,
  [SMALL_STATE(5224)] = 170850,
  [SMALL_STATE(5225)] = 170937,
  [SMALL_STATE(5226)] = 171009,
  [SMALL_STATE(5227)] = 171097,
  [SMALL_STATE(5228)] = 171191,
  [SMALL_STATE(5229)] = 171241,
  [SMALL_STATE(5230)] = 171325,
  [SMALL_STATE(5231)] = 171375,
  [SMALL_STATE(5232)] = 171463,
  [SMALL_STATE(5233)] = 171555,
  [SMALL_STATE(5234)] = 171619,
  [SMALL_STATE(5235)] = 171671,
  [SMALL_STATE(5236)] = 171765,
  [SMALL_STATE(5237)] = 171851,
  [SMALL_STATE(5238)] = 171935,
  [SMALL_STATE(5239)] = 172029,
  [SMALL_STATE(5240)] = 172123,
  [SMALL_STATE(5241)] = 172217,
  [SMALL_STATE(5242)] = 172305,
  [SMALL_STATE(5243)] = 172399,
  [SMALL_STATE(5244)] = 172449,
  [SMALL_STATE(5245)] = 172543,
  [SMALL_STATE(5246)] = 172631,
  [SMALL_STATE(5247)] = 172713,
  [SMALL_STATE(5248)] = 172759,
  [SMALL_STATE(5249)] = 172809,
  [SMALL_STATE(5250)] = 172903,
  [SMALL_STATE(5251)] = 172983,
  [SMALL_STATE(5252)] = 173077,
  [SMALL_STATE(5253)] = 173169,
  [SMALL_STATE(5254)] = 173215,
  [SMALL_STATE(5255)] = 173291,
  [SMALL_STATE(5256)] = 173365,
  [SMALL_STATE(5257)] = 173447,
  [SMALL_STATE(5258)] = 173541,
  [SMALL_STATE(5259)] = 173591,
  [SMALL_STATE(5260)] = 173683,
  [SMALL_STATE(5261)] = 173763,
  [SMALL_STATE(5262)] = 173855,
  [SMALL_STATE(5263)] = 173931,
  [SMALL_STATE(5264)] = 174023,
  [SMALL_STATE(5265)] = 174117,
  [SMALL_STATE(5266)] = 174187,
  [SMALL_STATE(5267)] = 174253,
  [SMALL_STATE(5268)] = 174347,
  [SMALL_STATE(5269)] = 174441,
  [SMALL_STATE(5270)] = 174515,
  [SMALL_STATE(5271)] = 174575,
  [SMALL_STATE(5272)] = 174643,
  [SMALL_STATE(5273)] = 174737,
  [SMALL_STATE(5274)] = 174805,
  [SMALL_STATE(5275)] = 174893,
  [SMALL_STATE(5276)] = 174951,
  [SMALL_STATE(5277)] = 175019,
  [SMALL_STATE(5278)] = 175079,
  [SMALL_STATE(5279)] = 175167,
  [SMALL_STATE(5280)] = 175233,
  [SMALL_STATE(5281)] = 175325,
  [SMALL_STATE(5282)] = 175385,
  [SMALL_STATE(5283)] = 175479,
  [SMALL_STATE(5284)] = 175549,
  [SMALL_STATE(5285)] = 175623,
  [SMALL_STATE(5286)] = 175697,
  [SMALL_STATE(5287)] = 175773,
  [SMALL_STATE(5288)] = 175853,
  [SMALL_STATE(5289)] = 175947,
  [SMALL_STATE(5290)] = 176029,
  [SMALL_STATE(5291)] = 176113,
  [SMALL_STATE(5292)] = 176199,
  [SMALL_STATE(5293)] = 176293,
  [SMALL_STATE(5294)] = 176387,
  [SMALL_STATE(5295)] = 176479,
  [SMALL_STATE(5296)] = 176567,
  [SMALL_STATE(5297)] = 176631,
  [SMALL_STATE(5298)] = 176725,
  [SMALL_STATE(5299)] = 176819,
  [SMALL_STATE(5300)] = 176911,
  [SMALL_STATE(5301)] = 177003,
  [SMALL_STATE(5302)] = 177063,
  [SMALL_STATE(5303)] = 177129,
  [SMALL_STATE(5304)] = 177223,
  [SMALL_STATE(5305)] = 177315,
  [SMALL_STATE(5306)] = 177365,
  [SMALL_STATE(5307)] = 177457,
  [SMALL_STATE(5308)] = 177549,
  [SMALL_STATE(5309)] = 177643,
  [SMALL_STATE(5310)] = 177731,
  [SMALL_STATE(5311)] = 177825,
  [SMALL_STATE(5312)] = 177919,
  [SMALL_STATE(5313)] = 178011,
  [SMALL_STATE(5314)] = 178061,
  [SMALL_STATE(5315)] = 178153,
  [SMALL_STATE(5316)] = 178203,
  [SMALL_STATE(5317)] = 178297,
  [SMALL_STATE(5318)] = 178357,
  [SMALL_STATE(5319)] = 178405,
  [SMALL_STATE(5320)] = 178457,
  [SMALL_STATE(5321)] = 178545,
  [SMALL_STATE(5322)] = 178615,
  [SMALL_STATE(5323)] = 178665,
  [SMALL_STATE(5324)] = 178753,
  [SMALL_STATE(5325)] = 178845,
  [SMALL_STATE(5326)] = 178919,
  [SMALL_STATE(5327)] = 179013,
  [SMALL_STATE(5328)] = 179073,
  [SMALL_STATE(5329)] = 179131,
  [SMALL_STATE(5330)] = 179225,
  [SMALL_STATE(5331)] = 179319,
  [SMALL_STATE(5332)] = 179411,
  [SMALL_STATE(5333)] = 179505,
  [SMALL_STATE(5334)] = 179563,
  [SMALL_STATE(5335)] = 179657,
  [SMALL_STATE(5336)] = 179745,
  [SMALL_STATE(5337)] = 179837,
  [SMALL_STATE(5338)] = 179923,
  [SMALL_STATE(5339)] = 180017,
  [SMALL_STATE(5340)] = 180111,
  [SMALL_STATE(5341)] = 180203,
  [SMALL_STATE(5342)] = 180297,
  [SMALL_STATE(5343)] = 180383,
  [SMALL_STATE(5344)] = 180477,
  [SMALL_STATE(5345)] = 180529,
  [SMALL_STATE(5346)] = 180623,
  [SMALL_STATE(5347)] = 180715,
  [SMALL_STATE(5348)] = 180807,
  [SMALL_STATE(5349)] = 180899,
  [SMALL_STATE(5350)] = 180993,
  [SMALL_STATE(5351)] = 181085,
  [SMALL_STATE(5352)] = 181173,
  [SMALL_STATE(5353)] = 181267,
  [SMALL_STATE(5354)] = 181331,
  [SMALL_STATE(5355)] = 181425,
  [SMALL_STATE(5356)] = 181493,
  [SMALL_STATE(5357)] = 181585,
  [SMALL_STATE(5358)] = 181653,
  [SMALL_STATE(5359)] = 181721,
  [SMALL_STATE(5360)] = 181815,
  [SMALL_STATE(5361)] = 181909,
  [SMALL_STATE(5362)] = 182001,
  [SMALL_STATE(5363)] = 182095,
  [SMALL_STATE(5364)] = 182189,
  [SMALL_STATE(5365)] = 182283,
  [SMALL_STATE(5366)] = 182331,
  [SMALL_STATE(5367)] = 182379,
  [SMALL_STATE(5368)] = 182473,
  [SMALL_STATE(5369)] = 182533,
  [SMALL_STATE(5370)] = 182593,
  [SMALL_STATE(5371)] = 182651,
  [SMALL_STATE(5372)] = 182745,
  [SMALL_STATE(5373)] = 182797,
  [SMALL_STATE(5374)] = 182891,
  [SMALL_STATE(5375)] = 182949,
  [SMALL_STATE(5376)] = 183043,
  [SMALL_STATE(5377)] = 183135,
  [SMALL_STATE(5378)] = 183193,
  [SMALL_STATE(5379)] = 183287,
  [SMALL_STATE(5380)] = 183343,
  [SMALL_STATE(5381)] = 183437,
  [SMALL_STATE(5382)] = 183529,
  [SMALL_STATE(5383)] = 183580,
  [SMALL_STATE(5384)] = 183647,
  [SMALL_STATE(5385)] = 183738,
  [SMALL_STATE(5386)] = 183829,
  [SMALL_STATE(5387)] = 183920,
  [SMALL_STATE(5388)] = 184011,
  [SMALL_STATE(5389)] = 184102,
  [SMALL_STATE(5390)] = 184193,
  [SMALL_STATE(5391)] = 184284,
  [SMALL_STATE(5392)] = 184375,
  [SMALL_STATE(5393)] = 184456,
  [SMALL_STATE(5394)] = 184547,
  [SMALL_STATE(5395)] = 184638,
  [SMALL_STATE(5396)] = 184729,
  [SMALL_STATE(5397)] = 184820,
  [SMALL_STATE(5398)] = 184911,
  [SMALL_STATE(5399)] = 185002,
  [SMALL_STATE(5400)] = 185047,
  [SMALL_STATE(5401)] = 185138,
  [SMALL_STATE(5402)] = 185229,
  [SMALL_STATE(5403)] = 185320,
  [SMALL_STATE(5404)] = 185411,
  [SMALL_STATE(5405)] = 185502,
  [SMALL_STATE(5406)] = 185593,
  [SMALL_STATE(5407)] = 185684,
  [SMALL_STATE(5408)] = 185731,
  [SMALL_STATE(5409)] = 185812,
  [SMALL_STATE(5410)] = 185903,
  [SMALL_STATE(5411)] = 185994,
  [SMALL_STATE(5412)] = 186039,
  [SMALL_STATE(5413)] = 186130,
  [SMALL_STATE(5414)] = 186221,
  [SMALL_STATE(5415)] = 186302,
  [SMALL_STATE(5416)] = 186383,
  [SMALL_STATE(5417)] = 186474,
  [SMALL_STATE(5418)] = 186565,
  [SMALL_STATE(5419)] = 186656,
  [SMALL_STATE(5420)] = 186747,
  [SMALL_STATE(5421)] = 186838,
  [SMALL_STATE(5422)] = 186929,
  [SMALL_STATE(5423)] = 187020,
  [SMALL_STATE(5424)] = 187111,
  [SMALL_STATE(5425)] = 187202,
  [SMALL_STATE(5426)] = 187293,
  [SMALL_STATE(5427)] = 187384,
  [SMALL_STATE(5428)] = 187475,
  [SMALL_STATE(5429)] = 187526,
  [SMALL_STATE(5430)] = 187617,
  [SMALL_STATE(5431)] = 187708,
  [SMALL_STATE(5432)] = 187799,
  [SMALL_STATE(5433)] = 187890,
  [SMALL_STATE(5434)] = 187981,
  [SMALL_STATE(5435)] = 188072,
  [SMALL_STATE(5436)] = 188163,
  [SMALL_STATE(5437)] = 188254,
  [SMALL_STATE(5438)] = 188345,
  [SMALL_STATE(5439)] = 188436,
  [SMALL_STATE(5440)] = 188527,
  [SMALL_STATE(5441)] = 188618,
  [SMALL_STATE(5442)] = 188709,
  [SMALL_STATE(5443)] = 188800,
  [SMALL_STATE(5444)] = 188881,
  [SMALL_STATE(5445)] = 188972,
  [SMALL_STATE(5446)] = 189063,
  [SMALL_STATE(5447)] = 189154,
  [SMALL_STATE(5448)] = 189221,
  [SMALL_STATE(5449)] = 189312,
  [SMALL_STATE(5450)] = 189403,
  [SMALL_STATE(5451)] = 189494,
  [SMALL_STATE(5452)] = 189585,
  [SMALL_STATE(5453)] = 189676,
  [SMALL_STATE(5454)] = 189753,
  [SMALL_STATE(5455)] = 189844,
  [SMALL_STATE(5456)] = 189935,
  [SMALL_STATE(5457)] = 190026,
  [SMALL_STATE(5458)] = 190107,
  [SMALL_STATE(5459)] = 190198,
  [SMALL_STATE(5460)] = 190289,
  [SMALL_STATE(5461)] = 190370,
  [SMALL_STATE(5462)] = 190461,
  [SMALL_STATE(5463)] = 190552,
  [SMALL_STATE(5464)] = 190643,
  [SMALL_STATE(5465)] = 190732,
  [SMALL_STATE(5466)] = 190823,
  [SMALL_STATE(5467)] = 190914,
  [SMALL_STATE(5468)] = 191005,
  [SMALL_STATE(5469)] = 191096,
  [SMALL_STATE(5470)] = 191169,
  [SMALL_STATE(5471)] = 191260,
  [SMALL_STATE(5472)] = 191351,
  [SMALL_STATE(5473)] = 191442,
  [SMALL_STATE(5474)] = 191533,
  [SMALL_STATE(5475)] = 191624,
  [SMALL_STATE(5476)] = 191715,
  [SMALL_STATE(5477)] = 191806,
  [SMALL_STATE(5478)] = 191897,
  [SMALL_STATE(5479)] = 191988,
  [SMALL_STATE(5480)] = 192079,
  [SMALL_STATE(5481)] = 192170,
  [SMALL_STATE(5482)] = 192215,
  [SMALL_STATE(5483)] = 192262,
  [SMALL_STATE(5484)] = 192353,
  [SMALL_STATE(5485)] = 192444,
  [SMALL_STATE(5486)] = 192535,
  [SMALL_STATE(5487)] = 192626,
  [SMALL_STATE(5488)] = 192717,
  [SMALL_STATE(5489)] = 192808,
  [SMALL_STATE(5490)] = 192899,
  [SMALL_STATE(5491)] = 192944,
  [SMALL_STATE(5492)] = 193035,
  [SMALL_STATE(5493)] = 193102,
  [SMALL_STATE(5494)] = 193193,
  [SMALL_STATE(5495)] = 193270,
  [SMALL_STATE(5496)] = 193361,
  [SMALL_STATE(5497)] = 193452,
  [SMALL_STATE(5498)] = 193533,
  [SMALL_STATE(5499)] = 193624,
  [SMALL_STATE(5500)] = 193715,
  [SMALL_STATE(5501)] = 193782,
  [SMALL_STATE(5502)] = 193873,
  [SMALL_STATE(5503)] = 193964,
  [SMALL_STATE(5504)] = 194045,
  [SMALL_STATE(5505)] = 194112,
  [SMALL_STATE(5506)] = 194203,
  [SMALL_STATE(5507)] = 194294,
  [SMALL_STATE(5508)] = 194361,
  [SMALL_STATE(5509)] = 194452,
  [SMALL_STATE(5510)] = 194543,
  [SMALL_STATE(5511)] = 194634,
  [SMALL_STATE(5512)] = 194701,
  [SMALL_STATE(5513)] = 194792,
  [SMALL_STATE(5514)] = 194883,
  [SMALL_STATE(5515)] = 194974,
  [SMALL_STATE(5516)] = 195065,
  [SMALL_STATE(5517)] = 195156,
  [SMALL_STATE(5518)] = 195247,
  [SMALL_STATE(5519)] = 195338,
  [SMALL_STATE(5520)] = 195429,
  [SMALL_STATE(5521)] = 195520,
  [SMALL_STATE(5522)] = 195611,
  [SMALL_STATE(5523)] = 195672,
  [SMALL_STATE(5524)] = 195745,
  [SMALL_STATE(5525)] = 195836,
  [SMALL_STATE(5526)] = 195885,
  [SMALL_STATE(5527)] = 195976,
  [SMALL_STATE(5528)] = 196067,
  [SMALL_STATE(5529)] = 196134,
  [SMALL_STATE(5530)] = 196189,
  [SMALL_STATE(5531)] = 196272,
  [SMALL_STATE(5532)] = 196350,
  [SMALL_STATE(5533)] = 196398,
  [SMALL_STATE(5534)] = 196442,
  [SMALL_STATE(5535)] = 196486,
  [SMALL_STATE(5536)] = 196558,
  [SMALL_STATE(5537)] = 196602,
  [SMALL_STATE(5538)] = 196646,
  [SMALL_STATE(5539)] = 196690,
  [SMALL_STATE(5540)] = 196734,
  [SMALL_STATE(5541)] = 196778,
  [SMALL_STATE(5542)] = 196822,
  [SMALL_STATE(5543)] = 196900,
  [SMALL_STATE(5544)] = 196944,
  [SMALL_STATE(5545)] = 197010,
  [SMALL_STATE(5546)] = 197054,
  [SMALL_STATE(5547)] = 197142,
  [SMALL_STATE(5548)] = 197220,
  [SMALL_STATE(5549)] = 197264,
  [SMALL_STATE(5550)] = 197336,
  [SMALL_STATE(5551)] = 197380,
  [SMALL_STATE(5552)] = 197424,
  [SMALL_STATE(5553)] = 197468,
  [SMALL_STATE(5554)] = 197512,
  [SMALL_STATE(5555)] = 197556,
  [SMALL_STATE(5556)] = 197600,
  [SMALL_STATE(5557)] = 197644,
  [SMALL_STATE(5558)] = 197688,
  [SMALL_STATE(5559)] = 197732,
  [SMALL_STATE(5560)] = 197786,
  [SMALL_STATE(5561)] = 197830,
  [SMALL_STATE(5562)] = 197886,
  [SMALL_STATE(5563)] = 197946,
  [SMALL_STATE(5564)] = 198024,
  [SMALL_STATE(5565)] = 198090,
  [SMALL_STATE(5566)] = 198168,
  [SMALL_STATE(5567)] = 198216,
  [SMALL_STATE(5568)] = 198262,
  [SMALL_STATE(5569)] = 198308,
  [SMALL_STATE(5570)] = 198352,
  [SMALL_STATE(5571)] = 198396,
  [SMALL_STATE(5572)] = 198446,
  [SMALL_STATE(5573)] = 198492,
  [SMALL_STATE(5574)] = 198538,
  [SMALL_STATE(5575)] = 198616,
  [SMALL_STATE(5576)] = 198660,
  [SMALL_STATE(5577)] = 198704,
  [SMALL_STATE(5578)] = 198786,
  [SMALL_STATE(5579)] = 198830,
  [SMALL_STATE(5580)] = 198874,
  [SMALL_STATE(5581)] = 198956,
  [SMALL_STATE(5582)] = 199000,
  [SMALL_STATE(5583)] = 199044,
  [SMALL_STATE(5584)] = 199088,
  [SMALL_STATE(5585)] = 199166,
  [SMALL_STATE(5586)] = 199222,
  [SMALL_STATE(5587)] = 199266,
  [SMALL_STATE(5588)] = 199310,
  [SMALL_STATE(5589)] = 199354,
  [SMALL_STATE(5590)] = 199398,
  [SMALL_STATE(5591)] = 199442,
  [SMALL_STATE(5592)] = 199486,
  [SMALL_STATE(5593)] = 199530,
  [SMALL_STATE(5594)] = 199574,
  [SMALL_STATE(5595)] = 199618,
  [SMALL_STATE(5596)] = 199666,
  [SMALL_STATE(5597)] = 199710,
  [SMALL_STATE(5598)] = 199754,
  [SMALL_STATE(5599)] = 199798,
  [SMALL_STATE(5600)] = 199876,
  [SMALL_STATE(5601)] = 199924,
  [SMALL_STATE(5602)] = 200002,
  [SMALL_STATE(5603)] = 200046,
  [SMALL_STATE(5604)] = 200090,
  [SMALL_STATE(5605)] = 200134,
  [SMALL_STATE(5606)] = 200178,
  [SMALL_STATE(5607)] = 200222,
  [SMALL_STATE(5608)] = 200266,
  [SMALL_STATE(5609)] = 200310,
  [SMALL_STATE(5610)] = 200354,
  [SMALL_STATE(5611)] = 200408,
  [SMALL_STATE(5612)] = 200474,
  [SMALL_STATE(5613)] = 200518,
  [SMALL_STATE(5614)] = 200566,
  [SMALL_STATE(5615)] = 200610,
  [SMALL_STATE(5616)] = 200658,
  [SMALL_STATE(5617)] = 200724,
  [SMALL_STATE(5618)] = 200802,
  [SMALL_STATE(5619)] = 200850,
  [SMALL_STATE(5620)] = 200898,
  [SMALL_STATE(5621)] = 200983,
  [SMALL_STATE(5622)] = 201048,
  [SMALL_STATE(5623)] = 201133,
  [SMALL_STATE(5624)] = 201218,
  [SMALL_STATE(5625)] = 201269,
  [SMALL_STATE(5626)] = 201316,
  [SMALL_STATE(5627)] = 201401,
  [SMALL_STATE(5628)] = 201486,
  [SMALL_STATE(5629)] = 201571,
  [SMALL_STATE(5630)] = 201656,
  [SMALL_STATE(5631)] = 201703,
  [SMALL_STATE(5632)] = 201752,
  [SMALL_STATE(5633)] = 201817,
  [SMALL_STATE(5634)] = 201898,
  [SMALL_STATE(5635)] = 201957,
  [SMALL_STATE(5636)] = 202004,
  [SMALL_STATE(5637)] = 202075,
  [SMALL_STATE(5638)] = 202160,
  [SMALL_STATE(5639)] = 202245,
  [SMALL_STATE(5640)] = 202316,
  [SMALL_STATE(5641)] = 202359,
  [SMALL_STATE(5642)] = 202408,
  [SMALL_STATE(5643)] = 202457,
  [SMALL_STATE(5644)] = 202512,
  [SMALL_STATE(5645)] = 202597,
  [SMALL_STATE(5646)] = 202682,
  [SMALL_STATE(5647)] = 202733,
  [SMALL_STATE(5648)] = 202818,
  [SMALL_STATE(5649)] = 202873,
  [SMALL_STATE(5650)] = 202916,
  [SMALL_STATE(5651)] = 203001,
  [SMALL_STATE(5652)] = 203086,
  [SMALL_STATE(5653)] = 203151,
  [SMALL_STATE(5654)] = 203236,
  [SMALL_STATE(5655)] = 203321,
  [SMALL_STATE(5656)] = 203370,
  [SMALL_STATE(5657)] = 203455,
  [SMALL_STATE(5658)] = 203536,
  [SMALL_STATE(5659)] = 203581,
  [SMALL_STATE(5660)] = 203666,
  [SMALL_STATE(5661)] = 203731,
  [SMALL_STATE(5662)] = 203816,
  [SMALL_STATE(5663)] = 203901,
  [SMALL_STATE(5664)] = 203950,
  [SMALL_STATE(5665)] = 203999,
  [SMALL_STATE(5666)] = 204084,
  [SMALL_STATE(5667)] = 204169,
  [SMALL_STATE(5668)] = 204239,
  [SMALL_STATE(5669)] = 204301,
  [SMALL_STATE(5670)] = 204349,
  [SMALL_STATE(5671)] = 204391,
  [SMALL_STATE(5672)] = 204461,
  [SMALL_STATE(5673)] = 204507,
  [SMALL_STATE(5674)] = 204569,
  [SMALL_STATE(5675)] = 204615,
  [SMALL_STATE(5676)] = 204661,
  [SMALL_STATE(5677)] = 204707,
  [SMALL_STATE(5678)] = 204769,
  [SMALL_STATE(5679)] = 204821,
  [SMALL_STATE(5680)] = 204901,
  [SMALL_STATE(5681)] = 204981,
  [SMALL_STATE(5682)] = 205045,
  [SMALL_STATE(5683)] = 205107,
  [SMALL_STATE(5684)] = 205187,
  [SMALL_STATE(5685)] = 205251,
  [SMALL_STATE(5686)] = 205331,
  [SMALL_STATE(5687)] = 205377,
  [SMALL_STATE(5688)] = 205439,
  [SMALL_STATE(5689)] = 205501,
  [SMALL_STATE(5690)] = 205563,
  [SMALL_STATE(5691)] = 205627,
  [SMALL_STATE(5692)] = 205675,
  [SMALL_STATE(5693)] = 205737,
  [SMALL_STATE(5694)] = 205799,
  [SMALL_STATE(5695)] = 205861,
  [SMALL_STATE(5696)] = 205925,
  [SMALL_STATE(5697)] = 205971,
  [SMALL_STATE(5698)] = 206051,
  [SMALL_STATE(5699)] = 206099,
  [SMALL_STATE(5700)] = 206179,
  [SMALL_STATE(5701)] = 206225,
  [SMALL_STATE(5702)] = 206287,
  [SMALL_STATE(5703)] = 206367,
  [SMALL_STATE(5704)] = 206437,
  [SMALL_STATE(5705)] = 206517,
  [SMALL_STATE(5706)] = 206579,
  [SMALL_STATE(5707)] = 206641,
  [SMALL_STATE(5708)] = 206687,
  [SMALL_STATE(5709)] = 206749,
  [SMALL_STATE(5710)] = 206795,
  [SMALL_STATE(5711)] = 206857,
  [SMALL_STATE(5712)] = 206919,
  [SMALL_STATE(5713)] = 206981,
  [SMALL_STATE(5714)] = 207027,
  [SMALL_STATE(5715)] = 207089,
  [SMALL_STATE(5716)] = 207151,
  [SMALL_STATE(5717)] = 207213,
  [SMALL_STATE(5718)] = 207275,
  [SMALL_STATE(5719)] = 207337,
  [SMALL_STATE(5720)] = 207399,
  [SMALL_STATE(5721)] = 207445,
  [SMALL_STATE(5722)] = 207507,
  [SMALL_STATE(5723)] = 207553,
  [SMALL_STATE(5724)] = 207623,
  [SMALL_STATE(5725)] = 207696,
  [SMALL_STATE(5726)] = 207775,
  [SMALL_STATE(5727)] = 207816,
  [SMALL_STATE(5728)] = 207895,
  [SMALL_STATE(5729)] = 207936,
  [SMALL_STATE(5730)] = 207977,
  [SMALL_STATE(5731)] = 208066,
  [SMALL_STATE(5732)] = 208145,
  [SMALL_STATE(5733)] = 208224,
  [SMALL_STATE(5734)] = 208303,
  [SMALL_STATE(5735)] = 208344,
  [SMALL_STATE(5736)] = 208385,
  [SMALL_STATE(5737)] = 208426,
  [SMALL_STATE(5738)] = 208505,
  [SMALL_STATE(5739)] = 208546,
  [SMALL_STATE(5740)] = 208609,
  [SMALL_STATE(5741)] = 208688,
  [SMALL_STATE(5742)] = 208729,
  [SMALL_STATE(5743)] = 208808,
  [SMALL_STATE(5744)] = 208849,
  [SMALL_STATE(5745)] = 208928,
  [SMALL_STATE(5746)] = 209007,
  [SMALL_STATE(5747)] = 209086,
  [SMALL_STATE(5748)] = 209165,
  [SMALL_STATE(5749)] = 209238,
  [SMALL_STATE(5750)] = 209279,
  [SMALL_STATE(5751)] = 209358,
  [SMALL_STATE(5752)] = 209437,
  [SMALL_STATE(5753)] = 209480,
  [SMALL_STATE(5754)] = 209521,
  [SMALL_STATE(5755)] = 209572,
  [SMALL_STATE(5756)] = 209635,
  [SMALL_STATE(5757)] = 209684,
  [SMALL_STATE(5758)] = 209763,
  [SMALL_STATE(5759)] = 209804,
  [SMALL_STATE(5760)] = 209845,
  [SMALL_STATE(5761)] = 209894,
  [SMALL_STATE(5762)] = 209935,
  [SMALL_STATE(5763)] = 210014,
  [SMALL_STATE(5764)] = 210093,
  [SMALL_STATE(5765)] = 210172,
  [SMALL_STATE(5766)] = 210251,
  [SMALL_STATE(5767)] = 210330,
  [SMALL_STATE(5768)] = 210371,
  [SMALL_STATE(5769)] = 210412,
  [SMALL_STATE(5770)] = 210491,
  [SMALL_STATE(5771)] = 210564,
  [SMALL_STATE(5772)] = 210605,
  [SMALL_STATE(5773)] = 210646,
  [SMALL_STATE(5774)] = 210725,
  [SMALL_STATE(5775)] = 210766,
  [SMALL_STATE(5776)] = 210845,
  [SMALL_STATE(5777)] = 210924,
  [SMALL_STATE(5778)] = 210997,
  [SMALL_STATE(5779)] = 211076,
  [SMALL_STATE(5780)] = 211155,
  [SMALL_STATE(5781)] = 211234,
  [SMALL_STATE(5782)] = 211313,
  [SMALL_STATE(5783)] = 211354,
  [SMALL_STATE(5784)] = 211395,
  [SMALL_STATE(5785)] = 211436,
  [SMALL_STATE(5786)] = 211515,
  [SMALL_STATE(5787)] = 211556,
  [SMALL_STATE(5788)] = 211635,
  [SMALL_STATE(5789)] = 211714,
  [SMALL_STATE(5790)] = 211755,
  [SMALL_STATE(5791)] = 211834,
  [SMALL_STATE(5792)] = 211875,
  [SMALL_STATE(5793)] = 211916,
  [SMALL_STATE(5794)] = 211957,
  [SMALL_STATE(5795)] = 212036,
  [SMALL_STATE(5796)] = 212077,
  [SMALL_STATE(5797)] = 212140,
  [SMALL_STATE(5798)] = 212219,
  [SMALL_STATE(5799)] = 212260,
  [SMALL_STATE(5800)] = 212301,
  [SMALL_STATE(5801)] = 212342,
  [SMALL_STATE(5802)] = 212383,
  [SMALL_STATE(5803)] = 212462,
  [SMALL_STATE(5804)] = 212541,
  [SMALL_STATE(5805)] = 212620,
  [SMALL_STATE(5806)] = 212699,
  [SMALL_STATE(5807)] = 212740,
  [SMALL_STATE(5808)] = 212819,
  [SMALL_STATE(5809)] = 212898,
  [SMALL_STATE(5810)] = 212939,
  [SMALL_STATE(5811)] = 213018,
  [SMALL_STATE(5812)] = 213097,
  [SMALL_STATE(5813)] = 213176,
  [SMALL_STATE(5814)] = 213255,
  [SMALL_STATE(5815)] = 213296,
  [SMALL_STATE(5816)] = 213375,
  [SMALL_STATE(5817)] = 213416,
  [SMALL_STATE(5818)] = 213457,
  [SMALL_STATE(5819)] = 213536,
  [SMALL_STATE(5820)] = 213615,
  [SMALL_STATE(5821)] = 213694,
  [SMALL_STATE(5822)] = 213757,
  [SMALL_STATE(5823)] = 213836,
  [SMALL_STATE(5824)] = 213880,
  [SMALL_STATE(5825)] = 213932,
  [SMALL_STATE(5826)] = 213976,
  [SMALL_STATE(5827)] = 214038,
  [SMALL_STATE(5828)] = 214082,
  [SMALL_STATE(5829)] = 214160,
  [SMALL_STATE(5830)] = 214238,
  [SMALL_STATE(5831)] = 214310,
  [SMALL_STATE(5832)] = 214354,
  [SMALL_STATE(5833)] = 214416,
  [SMALL_STATE(5834)] = 214468,
  [SMALL_STATE(5835)] = 214530,
  [SMALL_STATE(5836)] = 214574,
  [SMALL_STATE(5837)] = 214622,
  [SMALL_STATE(5838)] = 214684,
  [SMALL_STATE(5839)] = 214728,
  [SMALL_STATE(5840)] = 214790,
  [SMALL_STATE(5841)] = 214852,
  [SMALL_STATE(5842)] = 214896,
  [SMALL_STATE(5843)] = 214940,
  [SMALL_STATE(5844)] = 215002,
  [SMALL_STATE(5845)] = 215064,
  [SMALL_STATE(5846)] = 215108,
  [SMALL_STATE(5847)] = 215160,
  [SMALL_STATE(5848)] = 215204,
  [SMALL_STATE(5849)] = 215266,
  [SMALL_STATE(5850)] = 215338,
  [SMALL_STATE(5851)] = 215406,
  [SMALL_STATE(5852)] = 215458,
  [SMALL_STATE(5853)] = 215510,
  [SMALL_STATE(5854)] = 215572,
  [SMALL_STATE(5855)] = 215616,
  [SMALL_STATE(5856)] = 215688,
  [SMALL_STATE(5857)] = 215750,
  [SMALL_STATE(5858)] = 215822,
  [SMALL_STATE(5859)] = 215884,
  [SMALL_STATE(5860)] = 215928,
  [SMALL_STATE(5861)] = 215996,
  [SMALL_STATE(5862)] = 216048,
  [SMALL_STATE(5863)] = 216119,
  [SMALL_STATE(5864)] = 216190,
  [SMALL_STATE(5865)] = 216261,
  [SMALL_STATE(5866)] = 216332,
  [SMALL_STATE(5867)] = 216377,
  [SMALL_STATE(5868)] = 216448,
  [SMALL_STATE(5869)] = 216509,
  [SMALL_STATE(5870)] = 216548,
  [SMALL_STATE(5871)] = 216619,
  [SMALL_STATE(5872)] = 216690,
  [SMALL_STATE(5873)] = 216761,
  [SMALL_STATE(5874)] = 216800,
  [SMALL_STATE(5875)] = 216839,
  [SMALL_STATE(5876)] = 216878,
  [SMALL_STATE(5877)] = 216923,
  [SMALL_STATE(5878)] = 216994,
  [SMALL_STATE(5879)] = 217065,
  [SMALL_STATE(5880)] = 217136,
  [SMALL_STATE(5881)] = 217175,
  [SMALL_STATE(5882)] = 217246,
  [SMALL_STATE(5883)] = 217285,
  [SMALL_STATE(5884)] = 217356,
  [SMALL_STATE(5885)] = 217427,
  [SMALL_STATE(5886)] = 217488,
  [SMALL_STATE(5887)] = 217531,
  [SMALL_STATE(5888)] = 217602,
  [SMALL_STATE(5889)] = 217663,
  [SMALL_STATE(5890)] = 217724,
  [SMALL_STATE(5891)] = 217765,
  [SMALL_STATE(5892)] = 217826,
  [SMALL_STATE(5893)] = 217887,
  [SMALL_STATE(5894)] = 217938,
  [SMALL_STATE(5895)] = 217999,
  [SMALL_STATE(5896)] = 218038,
  [SMALL_STATE(5897)] = 218109,
  [SMALL_STATE(5898)] = 218170,
  [SMALL_STATE(5899)] = 218246,
  [SMALL_STATE(5900)] = 218294,
  [SMALL_STATE(5901)] = 218340,
  [SMALL_STATE(5902)] = 218386,
  [SMALL_STATE(5903)] = 218456,
  [SMALL_STATE(5904)] = 218494,
  [SMALL_STATE(5905)] = 218532,
  [SMALL_STATE(5906)] = 218602,
  [SMALL_STATE(5907)] = 218640,
  [SMALL_STATE(5908)] = 218710,
  [SMALL_STATE(5909)] = 218780,
  [SMALL_STATE(5910)] = 218818,
  [SMALL_STATE(5911)] = 218856,
  [SMALL_STATE(5912)] = 218894,
  [SMALL_STATE(5913)] = 218932,
  [SMALL_STATE(5914)] = 218970,
  [SMALL_STATE(5915)] = 219040,
  [SMALL_STATE(5916)] = 219078,
  [SMALL_STATE(5917)] = 219154,
  [SMALL_STATE(5918)] = 219192,
  [SMALL_STATE(5919)] = 219230,
  [SMALL_STATE(5920)] = 219268,
  [SMALL_STATE(5921)] = 219316,
  [SMALL_STATE(5922)] = 219354,
  [SMALL_STATE(5923)] = 219392,
  [SMALL_STATE(5924)] = 219430,
  [SMALL_STATE(5925)] = 219506,
  [SMALL_STATE(5926)] = 219576,
  [SMALL_STATE(5927)] = 219614,
  [SMALL_STATE(5928)] = 219652,
  [SMALL_STATE(5929)] = 219690,
  [SMALL_STATE(5930)] = 219728,
  [SMALL_STATE(5931)] = 219798,
  [SMALL_STATE(5932)] = 219836,
  [SMALL_STATE(5933)] = 219906,
  [SMALL_STATE(5934)] = 219944,
  [SMALL_STATE(5935)] = 219982,
  [SMALL_STATE(5936)] = 220020,
  [SMALL_STATE(5937)] = 220058,
  [SMALL_STATE(5938)] = 220128,
  [SMALL_STATE(5939)] = 220198,
  [SMALL_STATE(5940)] = 220236,
  [SMALL_STATE(5941)] = 220274,
  [SMALL_STATE(5942)] = 220344,
  [SMALL_STATE(5943)] = 220414,
  [SMALL_STATE(5944)] = 220452,
  [SMALL_STATE(5945)] = 220490,
  [SMALL_STATE(5946)] = 220528,
  [SMALL_STATE(5947)] = 220598,
  [SMALL_STATE(5948)] = 220668,
  [SMALL_STATE(5949)] = 220706,
  [SMALL_STATE(5950)] = 220744,
  [SMALL_STATE(5951)] = 220814,
  [SMALL_STATE(5952)] = 220864,
  [SMALL_STATE(5953)] = 220934,
  [SMALL_STATE(5954)] = 221010,
  [SMALL_STATE(5955)] = 221080,
  [SMALL_STATE(5956)] = 221128,
  [SMALL_STATE(5957)] = 221166,
  [SMALL_STATE(5958)] = 221204,
  [SMALL_STATE(5959)] = 221254,
  [SMALL_STATE(5960)] = 221333,
  [SMALL_STATE(5961)] = 221412,
  [SMALL_STATE(5962)] = 221491,
  [SMALL_STATE(5963)] = 221570,
  [SMALL_STATE(5964)] = 221637,
  [SMALL_STATE(5965)] = 221716,
  [SMALL_STATE(5966)] = 221795,
  [SMALL_STATE(5967)] = 221836,
  [SMALL_STATE(5968)] = 221903,
  [SMALL_STATE(5969)] = 221944,
  [SMALL_STATE(5970)] = 222023,
  [SMALL_STATE(5971)] = 222102,
  [SMALL_STATE(5972)] = 222181,
  [SMALL_STATE(5973)] = 222260,
  [SMALL_STATE(5974)] = 222339,
  [SMALL_STATE(5975)] = 222408,
  [SMALL_STATE(5976)] = 222487,
  [SMALL_STATE(5977)] = 222554,
  [SMALL_STATE(5978)] = 222633,
  [SMALL_STATE(5979)] = 222700,
  [SMALL_STATE(5980)] = 222767,
  [SMALL_STATE(5981)] = 222846,
  [SMALL_STATE(5982)] = 222915,
  [SMALL_STATE(5983)] = 222982,
  [SMALL_STATE(5984)] = 223061,
  [SMALL_STATE(5985)] = 223128,
  [SMALL_STATE(5986)] = 223169,
  [SMALL_STATE(5987)] = 223210,
  [SMALL_STATE(5988)] = 223289,
  [SMALL_STATE(5989)] = 223356,
  [SMALL_STATE(5990)] = 223397,
  [SMALL_STATE(5991)] = 223438,
  [SMALL_STATE(5992)] = 223497,
  [SMALL_STATE(5993)] = 223576,
  [SMALL_STATE(5994)] = 223655,
  [SMALL_STATE(5995)] = 223734,
  [SMALL_STATE(5996)] = 223813,
  [SMALL_STATE(5997)] = 223880,
  [SMALL_STATE(5998)] = 223959,
  [SMALL_STATE(5999)] = 224038,
  [SMALL_STATE(6000)] = 224079,
  [SMALL_STATE(6001)] = 224146,
  [SMALL_STATE(6002)] = 224225,
  [SMALL_STATE(6003)] = 224304,
  [SMALL_STATE(6004)] = 224383,
  [SMALL_STATE(6005)] = 224462,
  [SMALL_STATE(6006)] = 224529,
  [SMALL_STATE(6007)] = 224596,
  [SMALL_STATE(6008)] = 224663,
  [SMALL_STATE(6009)] = 224742,
  [SMALL_STATE(6010)] = 224821,
  [SMALL_STATE(6011)] = 224900,
  [SMALL_STATE(6012)] = 224979,
  [SMALL_STATE(6013)] = 225058,
  [SMALL_STATE(6014)] = 225137,
  [SMALL_STATE(6015)] = 225204,
  [SMALL_STATE(6016)] = 225283,
  [SMALL_STATE(6017)] = 225362,
  [SMALL_STATE(6018)] = 225441,
  [SMALL_STATE(6019)] = 225520,
  [SMALL_STATE(6020)] = 225599,
  [SMALL_STATE(6021)] = 225666,
  [SMALL_STATE(6022)] = 225745,
  [SMALL_STATE(6023)] = 225812,
  [SMALL_STATE(6024)] = 225891,
  [SMALL_STATE(6025)] = 225950,
  [SMALL_STATE(6026)] = 226029,
  [SMALL_STATE(6027)] = 226108,
  [SMALL_STATE(6028)] = 226167,
  [SMALL_STATE(6029)] = 226246,
  [SMALL_STATE(6030)] = 226325,
  [SMALL_STATE(6031)] = 226392,
  [SMALL_STATE(6032)] = 226471,
  [SMALL_STATE(6033)] = 226538,
  [SMALL_STATE(6034)] = 226617,
  [SMALL_STATE(6035)] = 226696,
  [SMALL_STATE(6036)] = 226763,
  [SMALL_STATE(6037)] = 226842,
  [SMALL_STATE(6038)] = 226921,
  [SMALL_STATE(6039)] = 227000,
  [SMALL_STATE(6040)] = 227079,
  [SMALL_STATE(6041)] = 227158,
  [SMALL_STATE(6042)] = 227237,
  [SMALL_STATE(6043)] = 227316,
  [SMALL_STATE(6044)] = 227363,
  [SMALL_STATE(6045)] = 227412,
  [SMALL_STATE(6046)] = 227491,
  [SMALL_STATE(6047)] = 227550,
  [SMALL_STATE(6048)] = 227617,
  [SMALL_STATE(6049)] = 227696,
  [SMALL_STATE(6050)] = 227775,
  [SMALL_STATE(6051)] = 227854,
  [SMALL_STATE(6052)] = 227933,
  [SMALL_STATE(6053)] = 228000,
  [SMALL_STATE(6054)] = 228079,
  [SMALL_STATE(6055)] = 228158,
  [SMALL_STATE(6056)] = 228237,
  [SMALL_STATE(6057)] = 228304,
  [SMALL_STATE(6058)] = 228383,
  [SMALL_STATE(6059)] = 228462,
  [SMALL_STATE(6060)] = 228529,
  [SMALL_STATE(6061)] = 228608,
  [SMALL_STATE(6062)] = 228655,
  [SMALL_STATE(6063)] = 228734,
  [SMALL_STATE(6064)] = 228801,
  [SMALL_STATE(6065)] = 228868,
  [SMALL_STATE(6066)] = 228935,
  [SMALL_STATE(6067)] = 229002,
  [SMALL_STATE(6068)] = 229081,
  [SMALL_STATE(6069)] = 229160,
  [SMALL_STATE(6070)] = 229239,
  [SMALL_STATE(6071)] = 229318,
  [SMALL_STATE(6072)] = 229397,
  [SMALL_STATE(6073)] = 229476,
  [SMALL_STATE(6074)] = 229555,
  [SMALL_STATE(6075)] = 229634,
  [SMALL_STATE(6076)] = 229713,
  [SMALL_STATE(6077)] = 229780,
  [SMALL_STATE(6078)] = 229859,
  [SMALL_STATE(6079)] = 229938,
  [SMALL_STATE(6080)] = 230017,
  [SMALL_STATE(6081)] = 230096,
  [SMALL_STATE(6082)] = 230175,
  [SMALL_STATE(6083)] = 230242,
  [SMALL_STATE(6084)] = 230321,
  [SMALL_STATE(6085)] = 230400,
  [SMALL_STATE(6086)] = 230467,
  [SMALL_STATE(6087)] = 230546,
  [SMALL_STATE(6088)] = 230625,
  [SMALL_STATE(6089)] = 230704,
  [SMALL_STATE(6090)] = 230771,
  [SMALL_STATE(6091)] = 230850,
  [SMALL_STATE(6092)] = 230929,
  [SMALL_STATE(6093)] = 230998,
  [SMALL_STATE(6094)] = 231067,
  [SMALL_STATE(6095)] = 231146,
  [SMALL_STATE(6096)] = 231185,
  [SMALL_STATE(6097)] = 231252,
  [SMALL_STATE(6098)] = 231292,
  [SMALL_STATE(6099)] = 231354,
  [SMALL_STATE(6100)] = 231394,
  [SMALL_STATE(6101)] = 231434,
  [SMALL_STATE(6102)] = 231474,
  [SMALL_STATE(6103)] = 231536,
  [SMALL_STATE(6104)] = 231576,
  [SMALL_STATE(6105)] = 231616,
  [SMALL_STATE(6106)] = 231692,
  [SMALL_STATE(6107)] = 231768,
  [SMALL_STATE(6108)] = 231844,
  [SMALL_STATE(6109)] = 231920,
  [SMALL_STATE(6110)] = 231996,
  [SMALL_STATE(6111)] = 232058,
  [SMALL_STATE(6112)] = 232134,
  [SMALL_STATE(6113)] = 232210,
  [SMALL_STATE(6114)] = 232286,
  [SMALL_STATE(6115)] = 232362,
  [SMALL_STATE(6116)] = 232438,
  [SMALL_STATE(6117)] = 232478,
  [SMALL_STATE(6118)] = 232554,
  [SMALL_STATE(6119)] = 232616,
  [SMALL_STATE(6120)] = 232656,
  [SMALL_STATE(6121)] = 232732,
  [SMALL_STATE(6122)] = 232808,
  [SMALL_STATE(6123)] = 232884,
  [SMALL_STATE(6124)] = 232960,
  [SMALL_STATE(6125)] = 233000,
  [SMALL_STATE(6126)] = 233076,
  [SMALL_STATE(6127)] = 233152,
  [SMALL_STATE(6128)] = 233192,
  [SMALL_STATE(6129)] = 233232,
  [SMALL_STATE(6130)] = 233308,
  [SMALL_STATE(6131)] = 233348,
  [SMALL_STATE(6132)] = 233424,
  [SMALL_STATE(6133)] = 233486,
  [SMALL_STATE(6134)] = 233526,
  [SMALL_STATE(6135)] = 233588,
  [SMALL_STATE(6136)] = 233664,
  [SMALL_STATE(6137)] = 233703,
  [SMALL_STATE(6138)] = 233770,
  [SMALL_STATE(6139)] = 233831,
  [SMALL_STATE(6140)] = 233892,
  [SMALL_STATE(6141)] = 233953,
  [SMALL_STATE(6142)] = 234014,
  [SMALL_STATE(6143)] = 234081,
  [SMALL_STATE(6144)] = 234148,
  [SMALL_STATE(6145)] = 234183,
  [SMALL_STATE(6146)] = 234244,
  [SMALL_STATE(6147)] = 234305,
  [SMALL_STATE(6148)] = 234372,
  [SMALL_STATE(6149)] = 234407,
  [SMALL_STATE(6150)] = 234474,
  [SMALL_STATE(6151)] = 234541,
  [SMALL_STATE(6152)] = 234608,
  [SMALL_STATE(6153)] = 234675,
  [SMALL_STATE(6154)] = 234735,
  [SMALL_STATE(6155)] = 234795,
  [SMALL_STATE(6156)] = 234855,
  [SMALL_STATE(6157)] = 234915,
  [SMALL_STATE(6158)] = 234975,
  [SMALL_STATE(6159)] = 235035,
  [SMALL_STATE(6160)] = 235089,
  [SMALL_STATE(6161)] = 235143,
  [SMALL_STATE(6162)] = 235181,
  [SMALL_STATE(6163)] = 235241,
  [SMALL_STATE(6164)] = 235301,
  [SMALL_STATE(6165)] = 235361,
  [SMALL_STATE(6166)] = 235421,
  [SMALL_STATE(6167)] = 235481,
  [SMALL_STATE(6168)] = 235541,
  [SMALL_STATE(6169)] = 235601,
  [SMALL_STATE(6170)] = 235661,
  [SMALL_STATE(6171)] = 235721,
  [SMALL_STATE(6172)] = 235781,
  [SMALL_STATE(6173)] = 235841,
  [SMALL_STATE(6174)] = 235895,
  [SMALL_STATE(6175)] = 235955,
  [SMALL_STATE(6176)] = 236015,
  [SMALL_STATE(6177)] = 236075,
  [SMALL_STATE(6178)] = 236129,
  [SMALL_STATE(6179)] = 236167,
  [SMALL_STATE(6180)] = 236227,
  [SMALL_STATE(6181)] = 236287,
  [SMALL_STATE(6182)] = 236347,
  [SMALL_STATE(6183)] = 236385,
  [SMALL_STATE(6184)] = 236445,
  [SMALL_STATE(6185)] = 236499,
  [SMALL_STATE(6186)] = 236560,
  [SMALL_STATE(6187)] = 236619,
  [SMALL_STATE(6188)] = 236680,
  [SMALL_STATE(6189)] = 236739,
  [SMALL_STATE(6190)] = 236798,
  [SMALL_STATE(6191)] = 236857,
  [SMALL_STATE(6192)] = 236918,
  [SMALL_STATE(6193)] = 236977,
  [SMALL_STATE(6194)] = 237038,
  [SMALL_STATE(6195)] = 237097,
  [SMALL_STATE(6196)] = 237158,
  [SMALL_STATE(6197)] = 237217,
  [SMALL_STATE(6198)] = 237278,
  [SMALL_STATE(6199)] = 237339,
  [SMALL_STATE(6200)] = 237398,
  [SMALL_STATE(6201)] = 237457,
  [SMALL_STATE(6202)] = 237516,
  [SMALL_STATE(6203)] = 237577,
  [SMALL_STATE(6204)] = 237638,
  [SMALL_STATE(6205)] = 237697,
  [SMALL_STATE(6206)] = 237756,
  [SMALL_STATE(6207)] = 237791,
  [SMALL_STATE(6208)] = 237849,
  [SMALL_STATE(6209)] = 237897,
  [SMALL_STATE(6210)] = 237951,
  [SMALL_STATE(6211)] = 238009,
  [SMALL_STATE(6212)] = 238067,
  [SMALL_STATE(6213)] = 238115,
  [SMALL_STATE(6214)] = 238173,
  [SMALL_STATE(6215)] = 238211,
  [SMALL_STATE(6216)] = 238259,
  [SMALL_STATE(6217)] = 238317,
  [SMALL_STATE(6218)] = 238375,
  [SMALL_STATE(6219)] = 238422,
  [SMALL_STATE(6220)] = 238469,
  [SMALL_STATE(6221)] = 238516,
  [SMALL_STATE(6222)] = 238563,
  [SMALL_STATE(6223)] = 238615,
  [SMALL_STATE(6224)] = 238659,
  [SMALL_STATE(6225)] = 238703,
  [SMALL_STATE(6226)] = 238759,
  [SMALL_STATE(6227)] = 238815,
  [SMALL_STATE(6228)] = 238859,
  [SMALL_STATE(6229)] = 238915,
  [SMALL_STATE(6230)] = 238967,
  [SMALL_STATE(6231)] = 239011,
  [SMALL_STATE(6232)] = 239067,
  [SMALL_STATE(6233)] = 239119,
  [SMALL_STATE(6234)] = 239163,
  [SMALL_STATE(6235)] = 239215,
  [SMALL_STATE(6236)] = 239267,
  [SMALL_STATE(6237)] = 239319,
  [SMALL_STATE(6238)] = 239363,
  [SMALL_STATE(6239)] = 239415,
  [SMALL_STATE(6240)] = 239467,
  [SMALL_STATE(6241)] = 239519,
  [SMALL_STATE(6242)] = 239565,
  [SMALL_STATE(6243)] = 239617,
  [SMALL_STATE(6244)] = 239669,
  [SMALL_STATE(6245)] = 239713,
  [SMALL_STATE(6246)] = 239765,
  [SMALL_STATE(6247)] = 239809,
  [SMALL_STATE(6248)] = 239861,
  [SMALL_STATE(6249)] = 239905,
  [SMALL_STATE(6250)] = 239949,
  [SMALL_STATE(6251)] = 240019,
  [SMALL_STATE(6252)] = 240071,
  [SMALL_STATE(6253)] = 240115,
  [SMALL_STATE(6254)] = 240171,
  [SMALL_STATE(6255)] = 240241,
  [SMALL_STATE(6256)] = 240293,
  [SMALL_STATE(6257)] = 240337,
  [SMALL_STATE(6258)] = 240381,
  [SMALL_STATE(6259)] = 240437,
  [SMALL_STATE(6260)] = 240505,
  [SMALL_STATE(6261)] = 240549,
  [SMALL_STATE(6262)] = 240601,
  [SMALL_STATE(6263)] = 240645,
  [SMALL_STATE(6264)] = 240701,
  [SMALL_STATE(6265)] = 240753,
  [SMALL_STATE(6266)] = 240797,
  [SMALL_STATE(6267)] = 240841,
  [SMALL_STATE(6268)] = 240893,
  [SMALL_STATE(6269)] = 240945,
  [SMALL_STATE(6270)] = 240997,
  [SMALL_STATE(6271)] = 241041,
  [SMALL_STATE(6272)] = 241097,
  [SMALL_STATE(6273)] = 241149,
  [SMALL_STATE(6274)] = 241193,
  [SMALL_STATE(6275)] = 241237,
  [SMALL_STATE(6276)] = 241289,
  [SMALL_STATE(6277)] = 241357,
  [SMALL_STATE(6278)] = 241401,
  [SMALL_STATE(6279)] = 241471,
  [SMALL_STATE(6280)] = 241539,
  [SMALL_STATE(6281)] = 241583,
  [SMALL_STATE(6282)] = 241627,
  [SMALL_STATE(6283)] = 241671,
  [SMALL_STATE(6284)] = 241715,
  [SMALL_STATE(6285)] = 241759,
  [SMALL_STATE(6286)] = 241811,
  [SMALL_STATE(6287)] = 241863,
  [SMALL_STATE(6288)] = 241907,
  [SMALL_STATE(6289)] = 241963,
  [SMALL_STATE(6290)] = 242007,
  [SMALL_STATE(6291)] = 242059,
  [SMALL_STATE(6292)] = 242103,
  [SMALL_STATE(6293)] = 242159,
  [SMALL_STATE(6294)] = 242203,
  [SMALL_STATE(6295)] = 242247,
  [SMALL_STATE(6296)] = 242299,
  [SMALL_STATE(6297)] = 242351,
  [SMALL_STATE(6298)] = 242407,
  [SMALL_STATE(6299)] = 242451,
  [SMALL_STATE(6300)] = 242481,
  [SMALL_STATE(6301)] = 242525,
  [SMALL_STATE(6302)] = 242569,
  [SMALL_STATE(6303)] = 242621,
  [SMALL_STATE(6304)] = 242673,
  [SMALL_STATE(6305)] = 242717,
  [SMALL_STATE(6306)] = 242769,
  [SMALL_STATE(6307)] = 242837,
  [SMALL_STATE(6308)] = 242893,
  [SMALL_STATE(6309)] = 242945,
  [SMALL_STATE(6310)] = 242989,
  [SMALL_STATE(6311)] = 243041,
  [SMALL_STATE(6312)] = 243093,
  [SMALL_STATE(6313)] = 243145,
  [SMALL_STATE(6314)] = 243191,
  [SMALL_STATE(6315)] = 243235,
  [SMALL_STATE(6316)] = 243287,
  [SMALL_STATE(6317)] = 243339,
  [SMALL_STATE(6318)] = 243391,
  [SMALL_STATE(6319)] = 243435,
  [SMALL_STATE(6320)] = 243487,
  [SMALL_STATE(6321)] = 243521,
  [SMALL_STATE(6322)] = 243573,
  [SMALL_STATE(6323)] = 243617,
  [SMALL_STATE(6324)] = 243669,
  [SMALL_STATE(6325)] = 243721,
  [SMALL_STATE(6326)] = 243773,
  [SMALL_STATE(6327)] = 243825,
  [SMALL_STATE(6328)] = 243863,
  [SMALL_STATE(6329)] = 243915,
  [SMALL_STATE(6330)] = 243967,
  [SMALL_STATE(6331)] = 244005,
  [SMALL_STATE(6332)] = 244049,
  [SMALL_STATE(6333)] = 244093,
  [SMALL_STATE(6334)] = 244152,
  [SMALL_STATE(6335)] = 244211,
  [SMALL_STATE(6336)] = 244270,
  [SMALL_STATE(6337)] = 244329,
  [SMALL_STATE(6338)] = 244388,
  [SMALL_STATE(6339)] = 244447,
  [SMALL_STATE(6340)] = 244506,
  [SMALL_STATE(6341)] = 244565,
  [SMALL_STATE(6342)] = 244624,
  [SMALL_STATE(6343)] = 244683,
  [SMALL_STATE(6344)] = 244742,
  [SMALL_STATE(6345)] = 244801,
  [SMALL_STATE(6346)] = 244860,
  [SMALL_STATE(6347)] = 244919,
  [SMALL_STATE(6348)] = 244978,
  [SMALL_STATE(6349)] = 245037,
  [SMALL_STATE(6350)] = 245096,
  [SMALL_STATE(6351)] = 245155,
  [SMALL_STATE(6352)] = 245214,
  [SMALL_STATE(6353)] = 245273,
  [SMALL_STATE(6354)] = 245332,
  [SMALL_STATE(6355)] = 245391,
  [SMALL_STATE(6356)] = 245450,
  [SMALL_STATE(6357)] = 245509,
  [SMALL_STATE(6358)] = 245568,
  [SMALL_STATE(6359)] = 245627,
  [SMALL_STATE(6360)] = 245686,
  [SMALL_STATE(6361)] = 245745,
  [SMALL_STATE(6362)] = 245804,
  [SMALL_STATE(6363)] = 245863,
  [SMALL_STATE(6364)] = 245922,
  [SMALL_STATE(6365)] = 245981,
  [SMALL_STATE(6366)] = 246040,
  [SMALL_STATE(6367)] = 246099,
  [SMALL_STATE(6368)] = 246158,
  [SMALL_STATE(6369)] = 246217,
  [SMALL_STATE(6370)] = 246276,
  [SMALL_STATE(6371)] = 246335,
  [SMALL_STATE(6372)] = 246394,
  [SMALL_STATE(6373)] = 246453,
  [SMALL_STATE(6374)] = 246512,
  [SMALL_STATE(6375)] = 246571,
  [SMALL_STATE(6376)] = 246630,
  [SMALL_STATE(6377)] = 246689,
  [SMALL_STATE(6378)] = 246748,
  [SMALL_STATE(6379)] = 246807,
  [SMALL_STATE(6380)] = 246866,
  [SMALL_STATE(6381)] = 246925,
  [SMALL_STATE(6382)] = 246984,
  [SMALL_STATE(6383)] = 247043,
  [SMALL_STATE(6384)] = 247072,
  [SMALL_STATE(6385)] = 247131,
  [SMALL_STATE(6386)] = 247190,
  [SMALL_STATE(6387)] = 247249,
  [SMALL_STATE(6388)] = 247294,
  [SMALL_STATE(6389)] = 247353,
  [SMALL_STATE(6390)] = 247412,
  [SMALL_STATE(6391)] = 247471,
  [SMALL_STATE(6392)] = 247530,
  [SMALL_STATE(6393)] = 247589,
  [SMALL_STATE(6394)] = 247648,
  [SMALL_STATE(6395)] = 247707,
  [SMALL_STATE(6396)] = 247766,
  [SMALL_STATE(6397)] = 247825,
  [SMALL_STATE(6398)] = 247884,
  [SMALL_STATE(6399)] = 247943,
  [SMALL_STATE(6400)] = 248002,
  [SMALL_STATE(6401)] = 248061,
  [SMALL_STATE(6402)] = 248094,
  [SMALL_STATE(6403)] = 248153,
  [SMALL_STATE(6404)] = 248212,
  [SMALL_STATE(6405)] = 248271,
  [SMALL_STATE(6406)] = 248330,
  [SMALL_STATE(6407)] = 248389,
  [SMALL_STATE(6408)] = 248448,
  [SMALL_STATE(6409)] = 248507,
  [SMALL_STATE(6410)] = 248566,
  [SMALL_STATE(6411)] = 248621,
  [SMALL_STATE(6412)] = 248680,
  [SMALL_STATE(6413)] = 248739,
  [SMALL_STATE(6414)] = 248798,
  [SMALL_STATE(6415)] = 248857,
  [SMALL_STATE(6416)] = 248912,
  [SMALL_STATE(6417)] = 248971,
  [SMALL_STATE(6418)] = 249030,
  [SMALL_STATE(6419)] = 249089,
  [SMALL_STATE(6420)] = 249148,
  [SMALL_STATE(6421)] = 249207,
  [SMALL_STATE(6422)] = 249270,
  [SMALL_STATE(6423)] = 249329,
  [SMALL_STATE(6424)] = 249388,
  [SMALL_STATE(6425)] = 249447,
  [SMALL_STATE(6426)] = 249506,
  [SMALL_STATE(6427)] = 249565,
  [SMALL_STATE(6428)] = 249624,
  [SMALL_STATE(6429)] = 249683,
  [SMALL_STATE(6430)] = 249742,
  [SMALL_STATE(6431)] = 249801,
  [SMALL_STATE(6432)] = 249856,
  [SMALL_STATE(6433)] = 249915,
  [SMALL_STATE(6434)] = 249974,
  [SMALL_STATE(6435)] = 250033,
  [SMALL_STATE(6436)] = 250092,
  [SMALL_STATE(6437)] = 250151,
  [SMALL_STATE(6438)] = 250210,
  [SMALL_STATE(6439)] = 250269,
  [SMALL_STATE(6440)] = 250328,
  [SMALL_STATE(6441)] = 250380,
  [SMALL_STATE(6442)] = 250408,
  [SMALL_STATE(6443)] = 250460,
  [SMALL_STATE(6444)] = 250524,
  [SMALL_STATE(6445)] = 250570,
  [SMALL_STATE(6446)] = 250616,
  [SMALL_STATE(6447)] = 250680,
  [SMALL_STATE(6448)] = 250726,
  [SMALL_STATE(6449)] = 250772,
  [SMALL_STATE(6450)] = 250836,
  [SMALL_STATE(6451)] = 250882,
  [SMALL_STATE(6452)] = 250910,
  [SMALL_STATE(6453)] = 250956,
  [SMALL_STATE(6454)] = 251020,
  [SMALL_STATE(6455)] = 251066,
  [SMALL_STATE(6456)] = 251118,
  [SMALL_STATE(6457)] = 251176,
  [SMALL_STATE(6458)] = 251240,
  [SMALL_STATE(6459)] = 251286,
  [SMALL_STATE(6460)] = 251350,
  [SMALL_STATE(6461)] = 251408,
  [SMALL_STATE(6462)] = 251454,
  [SMALL_STATE(6463)] = 251500,
  [SMALL_STATE(6464)] = 251546,
  [SMALL_STATE(6465)] = 251574,
  [SMALL_STATE(6466)] = 251620,
  [SMALL_STATE(6467)] = 251666,
  [SMALL_STATE(6468)] = 251712,
  [SMALL_STATE(6469)] = 251770,
  [SMALL_STATE(6470)] = 251816,
  [SMALL_STATE(6471)] = 251862,
  [SMALL_STATE(6472)] = 251926,
  [SMALL_STATE(6473)] = 251972,
  [SMALL_STATE(6474)] = 252036,
  [SMALL_STATE(6475)] = 252100,
  [SMALL_STATE(6476)] = 252164,
  [SMALL_STATE(6477)] = 252222,
  [SMALL_STATE(6478)] = 252250,
  [SMALL_STATE(6479)] = 252286,
  [SMALL_STATE(6480)] = 252322,
  [SMALL_STATE(6481)] = 252380,
  [SMALL_STATE(6482)] = 252426,
  [SMALL_STATE(6483)] = 252490,
  [SMALL_STATE(6484)] = 252536,
  [SMALL_STATE(6485)] = 252570,
  [SMALL_STATE(6486)] = 252606,
  [SMALL_STATE(6487)] = 252664,
  [SMALL_STATE(6488)] = 252710,
  [SMALL_STATE(6489)] = 252750,
  [SMALL_STATE(6490)] = 252792,
  [SMALL_STATE(6491)] = 252836,
  [SMALL_STATE(6492)] = 252882,
  [SMALL_STATE(6493)] = 252928,
  [SMALL_STATE(6494)] = 252974,
  [SMALL_STATE(6495)] = 253020,
  [SMALL_STATE(6496)] = 253068,
  [SMALL_STATE(6497)] = 253096,
  [SMALL_STATE(6498)] = 253160,
  [SMALL_STATE(6499)] = 253188,
  [SMALL_STATE(6500)] = 253246,
  [SMALL_STATE(6501)] = 253278,
  [SMALL_STATE(6502)] = 253306,
  [SMALL_STATE(6503)] = 253334,
  [SMALL_STATE(6504)] = 253398,
  [SMALL_STATE(6505)] = 253426,
  [SMALL_STATE(6506)] = 253476,
  [SMALL_STATE(6507)] = 253534,
  [SMALL_STATE(6508)] = 253586,
  [SMALL_STATE(6509)] = 253644,
  [SMALL_STATE(6510)] = 253688,
  [SMALL_STATE(6511)] = 253716,
  [SMALL_STATE(6512)] = 253780,
  [SMALL_STATE(6513)] = 253808,
  [SMALL_STATE(6514)] = 253843,
  [SMALL_STATE(6515)] = 253878,
  [SMALL_STATE(6516)] = 253923,
  [SMALL_STATE(6517)] = 253962,
  [SMALL_STATE(6518)] = 253989,
  [SMALL_STATE(6519)] = 254034,
  [SMALL_STATE(6520)] = 254067,
  [SMALL_STATE(6521)] = 254102,
  [SMALL_STATE(6522)] = 254133,
  [SMALL_STATE(6523)] = 254168,
  [SMALL_STATE(6524)] = 254207,
  [SMALL_STATE(6525)] = 254244,
  [SMALL_STATE(6526)] = 254271,
  [SMALL_STATE(6527)] = 254322,
  [SMALL_STATE(6528)] = 254361,
  [SMALL_STATE(6529)] = 254400,
  [SMALL_STATE(6530)] = 254435,
  [SMALL_STATE(6531)] = 254466,
  [SMALL_STATE(6532)] = 254495,
  [SMALL_STATE(6533)] = 254546,
  [SMALL_STATE(6534)] = 254589,
  [SMALL_STATE(6535)] = 254616,
  [SMALL_STATE(6536)] = 254655,
  [SMALL_STATE(6537)] = 254690,
  [SMALL_STATE(6538)] = 254729,
  [SMALL_STATE(6539)] = 254772,
  [SMALL_STATE(6540)] = 254813,
  [SMALL_STATE(6541)] = 254848,
  [SMALL_STATE(6542)] = 254887,
  [SMALL_STATE(6543)] = 254932,
  [SMALL_STATE(6544)] = 254975,
  [SMALL_STATE(6545)] = 255014,
  [SMALL_STATE(6546)] = 255041,
  [SMALL_STATE(6547)] = 255086,
  [SMALL_STATE(6548)] = 255113,
  [SMALL_STATE(6549)] = 255152,
  [SMALL_STATE(6550)] = 255195,
  [SMALL_STATE(6551)] = 255238,
  [SMALL_STATE(6552)] = 255283,
  [SMALL_STATE(6553)] = 255318,
  [SMALL_STATE(6554)] = 255345,
  [SMALL_STATE(6555)] = 255390,
  [SMALL_STATE(6556)] = 255435,
  [SMALL_STATE(6557)] = 255462,
  [SMALL_STATE(6558)] = 255507,
  [SMALL_STATE(6559)] = 255552,
  [SMALL_STATE(6560)] = 255597,
  [SMALL_STATE(6561)] = 255624,
  [SMALL_STATE(6562)] = 255651,
  [SMALL_STATE(6563)] = 255682,
  [SMALL_STATE(6564)] = 255727,
  [SMALL_STATE(6565)] = 255766,
  [SMALL_STATE(6566)] = 255793,
  [SMALL_STATE(6567)] = 255832,
  [SMALL_STATE(6568)] = 255859,
  [SMALL_STATE(6569)] = 255890,
  [SMALL_STATE(6570)] = 255933,
  [SMALL_STATE(6571)] = 255960,
  [SMALL_STATE(6572)] = 255991,
  [SMALL_STATE(6573)] = 256022,
  [SMALL_STATE(6574)] = 256049,
  [SMALL_STATE(6575)] = 256076,
  [SMALL_STATE(6576)] = 256103,
  [SMALL_STATE(6577)] = 256130,
  [SMALL_STATE(6578)] = 256187,
  [SMALL_STATE(6579)] = 256232,
  [SMALL_STATE(6580)] = 256277,
  [SMALL_STATE(6581)] = 256322,
  [SMALL_STATE(6582)] = 256349,
  [SMALL_STATE(6583)] = 256376,
  [SMALL_STATE(6584)] = 256403,
  [SMALL_STATE(6585)] = 256454,
  [SMALL_STATE(6586)] = 256499,
  [SMALL_STATE(6587)] = 256544,
  [SMALL_STATE(6588)] = 256571,
  [SMALL_STATE(6589)] = 256610,
  [SMALL_STATE(6590)] = 256637,
  [SMALL_STATE(6591)] = 256676,
  [SMALL_STATE(6592)] = 256711,
  [SMALL_STATE(6593)] = 256754,
  [SMALL_STATE(6594)] = 256793,
  [SMALL_STATE(6595)] = 256828,
  [SMALL_STATE(6596)] = 256857,
  [SMALL_STATE(6597)] = 256896,
  [SMALL_STATE(6598)] = 256931,
  [SMALL_STATE(6599)] = 256976,
  [SMALL_STATE(6600)] = 257015,
  [SMALL_STATE(6601)] = 257060,
  [SMALL_STATE(6602)] = 257095,
  [SMALL_STATE(6603)] = 257134,
  [SMALL_STATE(6604)] = 257161,
  [SMALL_STATE(6605)] = 257212,
  [SMALL_STATE(6606)] = 257261,
  [SMALL_STATE(6607)] = 257306,
  [SMALL_STATE(6608)] = 257333,
  [SMALL_STATE(6609)] = 257362,
  [SMALL_STATE(6610)] = 257401,
  [SMALL_STATE(6611)] = 257440,
  [SMALL_STATE(6612)] = 257467,
  [SMALL_STATE(6613)] = 257502,
  [SMALL_STATE(6614)] = 257529,
  [SMALL_STATE(6615)] = 257558,
  [SMALL_STATE(6616)] = 257585,
  [SMALL_STATE(6617)] = 257642,
  [SMALL_STATE(6618)] = 257681,
  [SMALL_STATE(6619)] = 257716,
  [SMALL_STATE(6620)] = 257761,
  [SMALL_STATE(6621)] = 257804,
  [SMALL_STATE(6622)] = 257835,
  [SMALL_STATE(6623)] = 257880,
  [SMALL_STATE(6624)] = 257907,
  [SMALL_STATE(6625)] = 257934,
  [SMALL_STATE(6626)] = 257969,
  [SMALL_STATE(6627)] = 258014,
  [SMALL_STATE(6628)] = 258071,
  [SMALL_STATE(6629)] = 258110,
  [SMALL_STATE(6630)] = 258155,
  [SMALL_STATE(6631)] = 258194,
  [SMALL_STATE(6632)] = 258239,
  [SMALL_STATE(6633)] = 258284,
  [SMALL_STATE(6634)] = 258319,
  [SMALL_STATE(6635)] = 258364,
  [SMALL_STATE(6636)] = 258399,
  [SMALL_STATE(6637)] = 258426,
  [SMALL_STATE(6638)] = 258461,
  [SMALL_STATE(6639)] = 258496,
  [SMALL_STATE(6640)] = 258541,
  [SMALL_STATE(6641)] = 258586,
  [SMALL_STATE(6642)] = 258631,
  [SMALL_STATE(6643)] = 258688,
  [SMALL_STATE(6644)] = 258727,
  [SMALL_STATE(6645)] = 258772,
  [SMALL_STATE(6646)] = 258817,
  [SMALL_STATE(6647)] = 258874,
  [SMALL_STATE(6648)] = 258901,
  [SMALL_STATE(6649)] = 258928,
  [SMALL_STATE(6650)] = 258959,
  [SMALL_STATE(6651)] = 259004,
  [SMALL_STATE(6652)] = 259043,
  [SMALL_STATE(6653)] = 259070,
  [SMALL_STATE(6654)] = 259115,
  [SMALL_STATE(6655)] = 259160,
  [SMALL_STATE(6656)] = 259209,
  [SMALL_STATE(6657)] = 259254,
  [SMALL_STATE(6658)] = 259311,
  [SMALL_STATE(6659)] = 259356,
  [SMALL_STATE(6660)] = 259395,
  [SMALL_STATE(6661)] = 259430,
  [SMALL_STATE(6662)] = 259465,
  [SMALL_STATE(6663)] = 259510,
  [SMALL_STATE(6664)] = 259537,
  [SMALL_STATE(6665)] = 259589,
  [SMALL_STATE(6666)] = 259625,
  [SMALL_STATE(6667)] = 259661,
  [SMALL_STATE(6668)] = 259697,
  [SMALL_STATE(6669)] = 259733,
  [SMALL_STATE(6670)] = 259763,
  [SMALL_STATE(6671)] = 259793,
  [SMALL_STATE(6672)] = 259829,
  [SMALL_STATE(6673)] = 259865,
  [SMALL_STATE(6674)] = 259895,
  [SMALL_STATE(6675)] = 259937,
  [SMALL_STATE(6676)] = 259967,
  [SMALL_STATE(6677)] = 260003,
  [SMALL_STATE(6678)] = 260039,
  [SMALL_STATE(6679)] = 260064,
  [SMALL_STATE(6680)] = 260113,
  [SMALL_STATE(6681)] = 260144,
  [SMALL_STATE(6682)] = 260185,
  [SMALL_STATE(6683)] = 260228,
  [SMALL_STATE(6684)] = 260277,
  [SMALL_STATE(6685)] = 260326,
  [SMALL_STATE(6686)] = 260351,
  [SMALL_STATE(6687)] = 260376,
  [SMALL_STATE(6688)] = 260401,
  [SMALL_STATE(6689)] = 260450,
  [SMALL_STATE(6690)] = 260481,
  [SMALL_STATE(6691)] = 260530,
  [SMALL_STATE(6692)] = 260567,
  [SMALL_STATE(6693)] = 260604,
  [SMALL_STATE(6694)] = 260641,
  [SMALL_STATE(6695)] = 260690,
  [SMALL_STATE(6696)] = 260739,
  [SMALL_STATE(6697)] = 260770,
  [SMALL_STATE(6698)] = 260807,
  [SMALL_STATE(6699)] = 260844,
  [SMALL_STATE(6700)] = 260893,
  [SMALL_STATE(6701)] = 260928,
  [SMALL_STATE(6702)] = 260971,
  [SMALL_STATE(6703)] = 260996,
  [SMALL_STATE(6704)] = 261045,
  [SMALL_STATE(6705)] = 261082,
  [SMALL_STATE(6706)] = 261107,
  [SMALL_STATE(6707)] = 261144,
  [SMALL_STATE(6708)] = 261185,
  [SMALL_STATE(6709)] = 261234,
  [SMALL_STATE(6710)] = 261259,
  [SMALL_STATE(6711)] = 261302,
  [SMALL_STATE(6712)] = 261327,
  [SMALL_STATE(6713)] = 261364,
  [SMALL_STATE(6714)] = 261389,
  [SMALL_STATE(6715)] = 261438,
  [SMALL_STATE(6716)] = 261463,
  [SMALL_STATE(6717)] = 261500,
  [SMALL_STATE(6718)] = 261525,
  [SMALL_STATE(6719)] = 261550,
  [SMALL_STATE(6720)] = 261575,
  [SMALL_STATE(6721)] = 261624,
  [SMALL_STATE(6722)] = 261655,
  [SMALL_STATE(6723)] = 261680,
  [SMALL_STATE(6724)] = 261717,
  [SMALL_STATE(6725)] = 261766,
  [SMALL_STATE(6726)] = 261815,
  [SMALL_STATE(6727)] = 261852,
  [SMALL_STATE(6728)] = 261877,
  [SMALL_STATE(6729)] = 261902,
  [SMALL_STATE(6730)] = 261951,
  [SMALL_STATE(6731)] = 262000,
  [SMALL_STATE(6732)] = 262049,
  [SMALL_STATE(6733)] = 262098,
  [SMALL_STATE(6734)] = 262135,
  [SMALL_STATE(6735)] = 262184,
  [SMALL_STATE(6736)] = 262233,
  [SMALL_STATE(6737)] = 262258,
  [SMALL_STATE(6738)] = 262307,
  [SMALL_STATE(6739)] = 262356,
  [SMALL_STATE(6740)] = 262405,
  [SMALL_STATE(6741)] = 262430,
  [SMALL_STATE(6742)] = 262473,
  [SMALL_STATE(6743)] = 262498,
  [SMALL_STATE(6744)] = 262547,
  [SMALL_STATE(6745)] = 262598,
  [SMALL_STATE(6746)] = 262647,
  [SMALL_STATE(6747)] = 262684,
  [SMALL_STATE(6748)] = 262709,
  [SMALL_STATE(6749)] = 262734,
  [SMALL_STATE(6750)] = 262783,
  [SMALL_STATE(6751)] = 262832,
  [SMALL_STATE(6752)] = 262863,
  [SMALL_STATE(6753)] = 262912,
  [SMALL_STATE(6754)] = 262949,
  [SMALL_STATE(6755)] = 262998,
  [SMALL_STATE(6756)] = 263047,
  [SMALL_STATE(6757)] = 263084,
  [SMALL_STATE(6758)] = 263121,
  [SMALL_STATE(6759)] = 263147,
  [SMALL_STATE(6760)] = 263169,
  [SMALL_STATE(6761)] = 263205,
  [SMALL_STATE(6762)] = 263245,
  [SMALL_STATE(6763)] = 263275,
  [SMALL_STATE(6764)] = 263297,
  [SMALL_STATE(6765)] = 263319,
  [SMALL_STATE(6766)] = 263349,
  [SMALL_STATE(6767)] = 263379,
  [SMALL_STATE(6768)] = 263403,
  [SMALL_STATE(6769)] = 263425,
  [SMALL_STATE(6770)] = 263451,
  [SMALL_STATE(6771)] = 263487,
  [SMALL_STATE(6772)] = 263517,
  [SMALL_STATE(6773)] = 263547,
  [SMALL_STATE(6774)] = 263583,
  [SMALL_STATE(6775)] = 263619,
  [SMALL_STATE(6776)] = 263649,
  [SMALL_STATE(6777)] = 263679,
  [SMALL_STATE(6778)] = 263723,
  [SMALL_STATE(6779)] = 263765,
  [SMALL_STATE(6780)] = 263787,
  [SMALL_STATE(6781)] = 263817,
  [SMALL_STATE(6782)] = 263847,
  [SMALL_STATE(6783)] = 263877,
  [SMALL_STATE(6784)] = 263913,
  [SMALL_STATE(6785)] = 263939,
  [SMALL_STATE(6786)] = 263961,
  [SMALL_STATE(6787)] = 263983,
  [SMALL_STATE(6788)] = 264023,
  [SMALL_STATE(6789)] = 264059,
  [SMALL_STATE(6790)] = 264089,
  [SMALL_STATE(6791)] = 264113,
  [SMALL_STATE(6792)] = 264139,
  [SMALL_STATE(6793)] = 264161,
  [SMALL_STATE(6794)] = 264183,
  [SMALL_STATE(6795)] = 264205,
  [SMALL_STATE(6796)] = 264227,
  [SMALL_STATE(6797)] = 264249,
  [SMALL_STATE(6798)] = 264271,
  [SMALL_STATE(6799)] = 264293,
  [SMALL_STATE(6800)] = 264323,
  [SMALL_STATE(6801)] = 264347,
  [SMALL_STATE(6802)] = 264369,
  [SMALL_STATE(6803)] = 264405,
  [SMALL_STATE(6804)] = 264427,
  [SMALL_STATE(6805)] = 264449,
  [SMALL_STATE(6806)] = 264485,
  [SMALL_STATE(6807)] = 264514,
  [SMALL_STATE(6808)] = 264557,
  [SMALL_STATE(6809)] = 264588,
  [SMALL_STATE(6810)] = 264627,
  [SMALL_STATE(6811)] = 264658,
  [SMALL_STATE(6812)] = 264681,
  [SMALL_STATE(6813)] = 264708,
  [SMALL_STATE(6814)] = 264739,
  [SMALL_STATE(6815)] = 264768,
  [SMALL_STATE(6816)] = 264797,
  [SMALL_STATE(6817)] = 264826,
  [SMALL_STATE(6818)] = 264855,
  [SMALL_STATE(6819)] = 264884,
  [SMALL_STATE(6820)] = 264913,
  [SMALL_STATE(6821)] = 264942,
  [SMALL_STATE(6822)] = 264985,
  [SMALL_STATE(6823)] = 265012,
  [SMALL_STATE(6824)] = 265051,
  [SMALL_STATE(6825)] = 265094,
  [SMALL_STATE(6826)] = 265123,
  [SMALL_STATE(6827)] = 265152,
  [SMALL_STATE(6828)] = 265191,
  [SMALL_STATE(6829)] = 265222,
  [SMALL_STATE(6830)] = 265251,
  [SMALL_STATE(6831)] = 265282,
  [SMALL_STATE(6832)] = 265311,
  [SMALL_STATE(6833)] = 265342,
  [SMALL_STATE(6834)] = 265371,
  [SMALL_STATE(6835)] = 265400,
  [SMALL_STATE(6836)] = 265429,
  [SMALL_STATE(6837)] = 265460,
  [SMALL_STATE(6838)] = 265503,
  [SMALL_STATE(6839)] = 265526,
  [SMALL_STATE(6840)] = 265555,
  [SMALL_STATE(6841)] = 265598,
  [SMALL_STATE(6842)] = 265629,
  [SMALL_STATE(6843)] = 265662,
  [SMALL_STATE(6844)] = 265693,
  [SMALL_STATE(6845)] = 265724,
  [SMALL_STATE(6846)] = 265753,
  [SMALL_STATE(6847)] = 265784,
  [SMALL_STATE(6848)] = 265817,
  [SMALL_STATE(6849)] = 265860,
  [SMALL_STATE(6850)] = 265893,
  [SMALL_STATE(6851)] = 265926,
  [SMALL_STATE(6852)] = 265957,
  [SMALL_STATE(6853)] = 265988,
  [SMALL_STATE(6854)] = 266031,
  [SMALL_STATE(6855)] = 266062,
  [SMALL_STATE(6856)] = 266093,
  [SMALL_STATE(6857)] = 266124,
  [SMALL_STATE(6858)] = 266155,
  [SMALL_STATE(6859)] = 266194,
  [SMALL_STATE(6860)] = 266237,
  [SMALL_STATE(6861)] = 266268,
  [SMALL_STATE(6862)] = 266311,
  [SMALL_STATE(6863)] = 266342,
  [SMALL_STATE(6864)] = 266381,
  [SMALL_STATE(6865)] = 266414,
  [SMALL_STATE(6866)] = 266457,
  [SMALL_STATE(6867)] = 266484,
  [SMALL_STATE(6868)] = 266513,
  [SMALL_STATE(6869)] = 266544,
  [SMALL_STATE(6870)] = 266573,
  [SMALL_STATE(6871)] = 266606,
  [SMALL_STATE(6872)] = 266635,
  [SMALL_STATE(6873)] = 266666,
  [SMALL_STATE(6874)] = 266709,
  [SMALL_STATE(6875)] = 266740,
  [SMALL_STATE(6876)] = 266783,
  [SMALL_STATE(6877)] = 266812,
  [SMALL_STATE(6878)] = 266855,
  [SMALL_STATE(6879)] = 266886,
  [SMALL_STATE(6880)] = 266915,
  [SMALL_STATE(6881)] = 266954,
  [SMALL_STATE(6882)] = 266983,
  [SMALL_STATE(6883)] = 267016,
  [SMALL_STATE(6884)] = 267045,
  [SMALL_STATE(6885)] = 267074,
  [SMALL_STATE(6886)] = 267107,
  [SMALL_STATE(6887)] = 267137,
  [SMALL_STATE(6888)] = 267157,
  [SMALL_STATE(6889)] = 267179,
  [SMALL_STATE(6890)] = 267211,
  [SMALL_STATE(6891)] = 267239,
  [SMALL_STATE(6892)] = 267267,
  [SMALL_STATE(6893)] = 267295,
  [SMALL_STATE(6894)] = 267323,
  [SMALL_STATE(6895)] = 267345,
  [SMALL_STATE(6896)] = 267377,
  [SMALL_STATE(6897)] = 267405,
  [SMALL_STATE(6898)] = 267433,
  [SMALL_STATE(6899)] = 267461,
  [SMALL_STATE(6900)] = 267481,
  [SMALL_STATE(6901)] = 267513,
  [SMALL_STATE(6902)] = 267545,
  [SMALL_STATE(6903)] = 267577,
  [SMALL_STATE(6904)] = 267605,
  [SMALL_STATE(6905)] = 267645,
  [SMALL_STATE(6906)] = 267677,
  [SMALL_STATE(6907)] = 267705,
  [SMALL_STATE(6908)] = 267733,
  [SMALL_STATE(6909)] = 267761,
  [SMALL_STATE(6910)] = 267801,
  [SMALL_STATE(6911)] = 267821,
  [SMALL_STATE(6912)] = 267861,
  [SMALL_STATE(6913)] = 267883,
  [SMALL_STATE(6914)] = 267911,
  [SMALL_STATE(6915)] = 267941,
  [SMALL_STATE(6916)] = 267971,
  [SMALL_STATE(6917)] = 268001,
  [SMALL_STATE(6918)] = 268041,
  [SMALL_STATE(6919)] = 268081,
  [SMALL_STATE(6920)] = 268103,
  [SMALL_STATE(6921)] = 268123,
  [SMALL_STATE(6922)] = 268163,
  [SMALL_STATE(6923)] = 268195,
  [SMALL_STATE(6924)] = 268215,
  [SMALL_STATE(6925)] = 268245,
  [SMALL_STATE(6926)] = 268277,
  [SMALL_STATE(6927)] = 268309,
  [SMALL_STATE(6928)] = 268341,
  [SMALL_STATE(6929)] = 268373,
  [SMALL_STATE(6930)] = 268405,
  [SMALL_STATE(6931)] = 268443,
  [SMALL_STATE(6932)] = 268483,
  [SMALL_STATE(6933)] = 268515,
  [SMALL_STATE(6934)] = 268547,
  [SMALL_STATE(6935)] = 268575,
  [SMALL_STATE(6936)] = 268607,
  [SMALL_STATE(6937)] = 268627,
  [SMALL_STATE(6938)] = 268651,
  [SMALL_STATE(6939)] = 268681,
  [SMALL_STATE(6940)] = 268707,
  [SMALL_STATE(6941)] = 268735,
  [SMALL_STATE(6942)] = 268759,
  [SMALL_STATE(6943)] = 268787,
  [SMALL_STATE(6944)] = 268819,
  [SMALL_STATE(6945)] = 268839,
  [SMALL_STATE(6946)] = 268859,
  [SMALL_STATE(6947)] = 268887,
  [SMALL_STATE(6948)] = 268907,
  [SMALL_STATE(6949)] = 268939,
  [SMALL_STATE(6950)] = 268959,
  [SMALL_STATE(6951)] = 268979,
  [SMALL_STATE(6952)] = 268999,
  [SMALL_STATE(6953)] = 269019,
  [SMALL_STATE(6954)] = 269039,
  [SMALL_STATE(6955)] = 269067,
  [SMALL_STATE(6956)] = 269095,
  [SMALL_STATE(6957)] = 269123,
  [SMALL_STATE(6958)] = 269163,
  [SMALL_STATE(6959)] = 269203,
  [SMALL_STATE(6960)] = 269231,
  [SMALL_STATE(6961)] = 269271,
  [SMALL_STATE(6962)] = 269311,
  [SMALL_STATE(6963)] = 269339,
  [SMALL_STATE(6964)] = 269379,
  [SMALL_STATE(6965)] = 269419,
  [SMALL_STATE(6966)] = 269439,
  [SMALL_STATE(6967)] = 269465,
  [SMALL_STATE(6968)] = 269485,
  [SMALL_STATE(6969)] = 269511,
  [SMALL_STATE(6970)] = 269541,
  [SMALL_STATE(6971)] = 269561,
  [SMALL_STATE(6972)] = 269591,
  [SMALL_STATE(6973)] = 269621,
  [SMALL_STATE(6974)] = 269645,
  [SMALL_STATE(6975)] = 269675,
  [SMALL_STATE(6976)] = 269703,
  [SMALL_STATE(6977)] = 269735,
  [SMALL_STATE(6978)] = 269763,
  [SMALL_STATE(6979)] = 269783,
  [SMALL_STATE(6980)] = 269803,
  [SMALL_STATE(6981)] = 269843,
  [SMALL_STATE(6982)] = 269871,
  [SMALL_STATE(6983)] = 269911,
  [SMALL_STATE(6984)] = 269931,
  [SMALL_STATE(6985)] = 269959,
  [SMALL_STATE(6986)] = 269981,
  [SMALL_STATE(6987)] = 270021,
  [SMALL_STATE(6988)] = 270061,
  [SMALL_STATE(6989)] = 270101,
  [SMALL_STATE(6990)] = 270133,
  [SMALL_STATE(6991)] = 270165,
  [SMALL_STATE(6992)] = 270193,
  [SMALL_STATE(6993)] = 270233,
  [SMALL_STATE(6994)] = 270265,
  [SMALL_STATE(6995)] = 270305,
  [SMALL_STATE(6996)] = 270325,
  [SMALL_STATE(6997)] = 270365,
  [SMALL_STATE(6998)] = 270397,
  [SMALL_STATE(6999)] = 270429,
  [SMALL_STATE(7000)] = 270457,
  [SMALL_STATE(7001)] = 270478,
  [SMALL_STATE(7002)] = 270511,
  [SMALL_STATE(7003)] = 270532,
  [SMALL_STATE(7004)] = 270569,
  [SMALL_STATE(7005)] = 270602,
  [SMALL_STATE(7006)] = 270627,
  [SMALL_STATE(7007)] = 270664,
  [SMALL_STATE(7008)] = 270701,
  [SMALL_STATE(7009)] = 270722,
  [SMALL_STATE(7010)] = 270755,
  [SMALL_STATE(7011)] = 270792,
  [SMALL_STATE(7012)] = 270825,
  [SMALL_STATE(7013)] = 270858,
  [SMALL_STATE(7014)] = 270883,
  [SMALL_STATE(7015)] = 270916,
  [SMALL_STATE(7016)] = 270955,
  [SMALL_STATE(7017)] = 270988,
  [SMALL_STATE(7018)] = 271025,
  [SMALL_STATE(7019)] = 271060,
  [SMALL_STATE(7020)] = 271093,
  [SMALL_STATE(7021)] = 271114,
  [SMALL_STATE(7022)] = 271139,
  [SMALL_STATE(7023)] = 271160,
  [SMALL_STATE(7024)] = 271193,
  [SMALL_STATE(7025)] = 271232,
  [SMALL_STATE(7026)] = 271253,
  [SMALL_STATE(7027)] = 271286,
  [SMALL_STATE(7028)] = 271319,
  [SMALL_STATE(7029)] = 271356,
  [SMALL_STATE(7030)] = 271377,
  [SMALL_STATE(7031)] = 271416,
  [SMALL_STATE(7032)] = 271449,
  [SMALL_STATE(7033)] = 271470,
  [SMALL_STATE(7034)] = 271507,
  [SMALL_STATE(7035)] = 271544,
  [SMALL_STATE(7036)] = 271581,
  [SMALL_STATE(7037)] = 271618,
  [SMALL_STATE(7038)] = 271651,
  [SMALL_STATE(7039)] = 271684,
  [SMALL_STATE(7040)] = 271709,
  [SMALL_STATE(7041)] = 271746,
  [SMALL_STATE(7042)] = 271779,
  [SMALL_STATE(7043)] = 271812,
  [SMALL_STATE(7044)] = 271851,
  [SMALL_STATE(7045)] = 271872,
  [SMALL_STATE(7046)] = 271905,
  [SMALL_STATE(7047)] = 271926,
  [SMALL_STATE(7048)] = 271959,
  [SMALL_STATE(7049)] = 271996,
  [SMALL_STATE(7050)] = 272017,
  [SMALL_STATE(7051)] = 272052,
  [SMALL_STATE(7052)] = 272079,
  [SMALL_STATE(7053)] = 272106,
  [SMALL_STATE(7054)] = 272133,
  [SMALL_STATE(7055)] = 272160,
  [SMALL_STATE(7056)] = 272187,
  [SMALL_STATE(7057)] = 272214,
  [SMALL_STATE(7058)] = 272249,
  [SMALL_STATE(7059)] = 272276,
  [SMALL_STATE(7060)] = 272297,
  [SMALL_STATE(7061)] = 272322,
  [SMALL_STATE(7062)] = 272355,
  [SMALL_STATE(7063)] = 272388,
  [SMALL_STATE(7064)] = 272415,
  [SMALL_STATE(7065)] = 272448,
  [SMALL_STATE(7066)] = 272473,
  [SMALL_STATE(7067)] = 272500,
  [SMALL_STATE(7068)] = 272521,
  [SMALL_STATE(7069)] = 272542,
  [SMALL_STATE(7070)] = 272563,
  [SMALL_STATE(7071)] = 272596,
  [SMALL_STATE(7072)] = 272617,
  [SMALL_STATE(7073)] = 272650,
  [SMALL_STATE(7074)] = 272683,
  [SMALL_STATE(7075)] = 272720,
  [SMALL_STATE(7076)] = 272741,
  [SMALL_STATE(7077)] = 272774,
  [SMALL_STATE(7078)] = 272811,
  [SMALL_STATE(7079)] = 272838,
  [SMALL_STATE(7080)] = 272859,
  [SMALL_STATE(7081)] = 272880,
  [SMALL_STATE(7082)] = 272917,
  [SMALL_STATE(7083)] = 272938,
  [SMALL_STATE(7084)] = 272959,
  [SMALL_STATE(7085)] = 272996,
  [SMALL_STATE(7086)] = 273023,
  [SMALL_STATE(7087)] = 273044,
  [SMALL_STATE(7088)] = 273071,
  [SMALL_STATE(7089)] = 273092,
  [SMALL_STATE(7090)] = 273125,
  [SMALL_STATE(7091)] = 273162,
  [SMALL_STATE(7092)] = 273183,
  [SMALL_STATE(7093)] = 273220,
  [SMALL_STATE(7094)] = 273249,
  [SMALL_STATE(7095)] = 273282,
  [SMALL_STATE(7096)] = 273311,
  [SMALL_STATE(7097)] = 273338,
  [SMALL_STATE(7098)] = 273377,
  [SMALL_STATE(7099)] = 273410,
  [SMALL_STATE(7100)] = 273431,
  [SMALL_STATE(7101)] = 273470,
  [SMALL_STATE(7102)] = 273491,
  [SMALL_STATE(7103)] = 273518,
  [SMALL_STATE(7104)] = 273543,
  [SMALL_STATE(7105)] = 273568,
  [SMALL_STATE(7106)] = 273601,
  [SMALL_STATE(7107)] = 273634,
  [SMALL_STATE(7108)] = 273655,
  [SMALL_STATE(7109)] = 273676,
  [SMALL_STATE(7110)] = 273701,
  [SMALL_STATE(7111)] = 273728,
  [SMALL_STATE(7112)] = 273755,
  [SMALL_STATE(7113)] = 273784,
  [SMALL_STATE(7114)] = 273813,
  [SMALL_STATE(7115)] = 273850,
  [SMALL_STATE(7116)] = 273871,
  [SMALL_STATE(7117)] = 273904,
  [SMALL_STATE(7118)] = 273941,
  [SMALL_STATE(7119)] = 273974,
  [SMALL_STATE(7120)] = 273998,
  [SMALL_STATE(7121)] = 274020,
  [SMALL_STATE(7122)] = 274056,
  [SMALL_STATE(7123)] = 274090,
  [SMALL_STATE(7124)] = 274124,
  [SMALL_STATE(7125)] = 274160,
  [SMALL_STATE(7126)] = 274196,
  [SMALL_STATE(7127)] = 274226,
  [SMALL_STATE(7128)] = 274252,
  [SMALL_STATE(7129)] = 274276,
  [SMALL_STATE(7130)] = 274300,
  [SMALL_STATE(7131)] = 274326,
  [SMALL_STATE(7132)] = 274362,
  [SMALL_STATE(7133)] = 274396,
  [SMALL_STATE(7134)] = 274420,
  [SMALL_STATE(7135)] = 274454,
  [SMALL_STATE(7136)] = 274480,
  [SMALL_STATE(7137)] = 274506,
  [SMALL_STATE(7138)] = 274542,
  [SMALL_STATE(7139)] = 274578,
  [SMALL_STATE(7140)] = 274600,
  [SMALL_STATE(7141)] = 274636,
  [SMALL_STATE(7142)] = 274662,
  [SMALL_STATE(7143)] = 274690,
  [SMALL_STATE(7144)] = 274726,
  [SMALL_STATE(7145)] = 274762,
  [SMALL_STATE(7146)] = 274792,
  [SMALL_STATE(7147)] = 274818,
  [SMALL_STATE(7148)] = 274848,
  [SMALL_STATE(7149)] = 274884,
  [SMALL_STATE(7150)] = 274912,
  [SMALL_STATE(7151)] = 274938,
  [SMALL_STATE(7152)] = 274968,
  [SMALL_STATE(7153)] = 274998,
  [SMALL_STATE(7154)] = 275028,
  [SMALL_STATE(7155)] = 275062,
  [SMALL_STATE(7156)] = 275092,
  [SMALL_STATE(7157)] = 275122,
  [SMALL_STATE(7158)] = 275148,
  [SMALL_STATE(7159)] = 275168,
  [SMALL_STATE(7160)] = 275204,
  [SMALL_STATE(7161)] = 275240,
  [SMALL_STATE(7162)] = 275266,
  [SMALL_STATE(7163)] = 275290,
  [SMALL_STATE(7164)] = 275324,
  [SMALL_STATE(7165)] = 275354,
  [SMALL_STATE(7166)] = 275380,
  [SMALL_STATE(7167)] = 275416,
  [SMALL_STATE(7168)] = 275452,
  [SMALL_STATE(7169)] = 275486,
  [SMALL_STATE(7170)] = 275522,
  [SMALL_STATE(7171)] = 275558,
  [SMALL_STATE(7172)] = 275592,
  [SMALL_STATE(7173)] = 275628,
  [SMALL_STATE(7174)] = 275658,
  [SMALL_STATE(7175)] = 275678,
  [SMALL_STATE(7176)] = 275708,
  [SMALL_STATE(7177)] = 275734,
  [SMALL_STATE(7178)] = 275762,
  [SMALL_STATE(7179)] = 275792,
  [SMALL_STATE(7180)] = 275826,
  [SMALL_STATE(7181)] = 275860,
  [SMALL_STATE(7182)] = 275896,
  [SMALL_STATE(7183)] = 275922,
  [SMALL_STATE(7184)] = 275950,
  [SMALL_STATE(7185)] = 275976,
  [SMALL_STATE(7186)] = 276012,
  [SMALL_STATE(7187)] = 276038,
  [SMALL_STATE(7188)] = 276074,
  [SMALL_STATE(7189)] = 276100,
  [SMALL_STATE(7190)] = 276136,
  [SMALL_STATE(7191)] = 276172,
  [SMALL_STATE(7192)] = 276202,
  [SMALL_STATE(7193)] = 276228,
  [SMALL_STATE(7194)] = 276264,
  [SMALL_STATE(7195)] = 276300,
  [SMALL_STATE(7196)] = 276326,
  [SMALL_STATE(7197)] = 276362,
  [SMALL_STATE(7198)] = 276388,
  [SMALL_STATE(7199)] = 276423,
  [SMALL_STATE(7200)] = 276444,
  [SMALL_STATE(7201)] = 276479,
  [SMALL_STATE(7202)] = 276504,
  [SMALL_STATE(7203)] = 276531,
  [SMALL_STATE(7204)] = 276566,
  [SMALL_STATE(7205)] = 276601,
  [SMALL_STATE(7206)] = 276626,
  [SMALL_STATE(7207)] = 276661,
  [SMALL_STATE(7208)] = 276696,
  [SMALL_STATE(7209)] = 276731,
  [SMALL_STATE(7210)] = 276766,
  [SMALL_STATE(7211)] = 276793,
  [SMALL_STATE(7212)] = 276818,
  [SMALL_STATE(7213)] = 276837,
  [SMALL_STATE(7214)] = 276856,
  [SMALL_STATE(7215)] = 276883,
  [SMALL_STATE(7216)] = 276918,
  [SMALL_STATE(7217)] = 276953,
  [SMALL_STATE(7218)] = 276972,
  [SMALL_STATE(7219)] = 277003,
  [SMALL_STATE(7220)] = 277030,
  [SMALL_STATE(7221)] = 277065,
  [SMALL_STATE(7222)] = 277098,
  [SMALL_STATE(7223)] = 277131,
  [SMALL_STATE(7224)] = 277166,
  [SMALL_STATE(7225)] = 277195,
  [SMALL_STATE(7226)] = 277226,
  [SMALL_STATE(7227)] = 277251,
  [SMALL_STATE(7228)] = 277282,
  [SMALL_STATE(7229)] = 277313,
  [SMALL_STATE(7230)] = 277338,
  [SMALL_STATE(7231)] = 277361,
  [SMALL_STATE(7232)] = 277388,
  [SMALL_STATE(7233)] = 277413,
  [SMALL_STATE(7234)] = 277444,
  [SMALL_STATE(7235)] = 277479,
  [SMALL_STATE(7236)] = 277498,
  [SMALL_STATE(7237)] = 277517,
  [SMALL_STATE(7238)] = 277546,
  [SMALL_STATE(7239)] = 277577,
  [SMALL_STATE(7240)] = 277596,
  [SMALL_STATE(7241)] = 277631,
  [SMALL_STATE(7242)] = 277658,
  [SMALL_STATE(7243)] = 277685,
  [SMALL_STATE(7244)] = 277704,
  [SMALL_STATE(7245)] = 277735,
  [SMALL_STATE(7246)] = 277770,
  [SMALL_STATE(7247)] = 277797,
  [SMALL_STATE(7248)] = 277816,
  [SMALL_STATE(7249)] = 277843,
  [SMALL_STATE(7250)] = 277878,
  [SMALL_STATE(7251)] = 277903,
  [SMALL_STATE(7252)] = 277938,
  [SMALL_STATE(7253)] = 277969,
  [SMALL_STATE(7254)] = 277994,
  [SMALL_STATE(7255)] = 278019,
  [SMALL_STATE(7256)] = 278048,
  [SMALL_STATE(7257)] = 278083,
  [SMALL_STATE(7258)] = 278102,
  [SMALL_STATE(7259)] = 278137,
  [SMALL_STATE(7260)] = 278164,
  [SMALL_STATE(7261)] = 278197,
  [SMALL_STATE(7262)] = 278232,
  [SMALL_STATE(7263)] = 278257,
  [SMALL_STATE(7264)] = 278288,
  [SMALL_STATE(7265)] = 278317,
  [SMALL_STATE(7266)] = 278336,
  [SMALL_STATE(7267)] = 278371,
  [SMALL_STATE(7268)] = 278406,
  [SMALL_STATE(7269)] = 278431,
  [SMALL_STATE(7270)] = 278454,
  [SMALL_STATE(7271)] = 278483,
  [SMALL_STATE(7272)] = 278514,
  [SMALL_STATE(7273)] = 278543,
  [SMALL_STATE(7274)] = 278578,
  [SMALL_STATE(7275)] = 278613,
  [SMALL_STATE(7276)] = 278644,
  [SMALL_STATE(7277)] = 278669,
  [SMALL_STATE(7278)] = 278698,
  [SMALL_STATE(7279)] = 278733,
  [SMALL_STATE(7280)] = 278768,
  [SMALL_STATE(7281)] = 278803,
  [SMALL_STATE(7282)] = 278825,
  [SMALL_STATE(7283)] = 278849,
  [SMALL_STATE(7284)] = 278871,
  [SMALL_STATE(7285)] = 278895,
  [SMALL_STATE(7286)] = 278925,
  [SMALL_STATE(7287)] = 278947,
  [SMALL_STATE(7288)] = 278977,
  [SMALL_STATE(7289)] = 278995,
  [SMALL_STATE(7290)] = 279019,
  [SMALL_STATE(7291)] = 279049,
  [SMALL_STATE(7292)] = 279081,
  [SMALL_STATE(7293)] = 279103,
  [SMALL_STATE(7294)] = 279133,
  [SMALL_STATE(7295)] = 279155,
  [SMALL_STATE(7296)] = 279179,
  [SMALL_STATE(7297)] = 279201,
  [SMALL_STATE(7298)] = 279223,
  [SMALL_STATE(7299)] = 279245,
  [SMALL_STATE(7300)] = 279267,
  [SMALL_STATE(7301)] = 279291,
  [SMALL_STATE(7302)] = 279313,
  [SMALL_STATE(7303)] = 279343,
  [SMALL_STATE(7304)] = 279367,
  [SMALL_STATE(7305)] = 279397,
  [SMALL_STATE(7306)] = 279421,
  [SMALL_STATE(7307)] = 279439,
  [SMALL_STATE(7308)] = 279461,
  [SMALL_STATE(7309)] = 279491,
  [SMALL_STATE(7310)] = 279509,
  [SMALL_STATE(7311)] = 279527,
  [SMALL_STATE(7312)] = 279545,
  [SMALL_STATE(7313)] = 279563,
  [SMALL_STATE(7314)] = 279581,
  [SMALL_STATE(7315)] = 279605,
  [SMALL_STATE(7316)] = 279627,
  [SMALL_STATE(7317)] = 279649,
  [SMALL_STATE(7318)] = 279671,
  [SMALL_STATE(7319)] = 279695,
  [SMALL_STATE(7320)] = 279717,
  [SMALL_STATE(7321)] = 279741,
  [SMALL_STATE(7322)] = 279771,
  [SMALL_STATE(7323)] = 279802,
  [SMALL_STATE(7324)] = 279821,
  [SMALL_STATE(7325)] = 279848,
  [SMALL_STATE(7326)] = 279879,
  [SMALL_STATE(7327)] = 279910,
  [SMALL_STATE(7328)] = 279931,
  [SMALL_STATE(7329)] = 279962,
  [SMALL_STATE(7330)] = 279993,
  [SMALL_STATE(7331)] = 280024,
  [SMALL_STATE(7332)] = 280047,
  [SMALL_STATE(7333)] = 280074,
  [SMALL_STATE(7334)] = 280101,
  [SMALL_STATE(7335)] = 280132,
  [SMALL_STATE(7336)] = 280163,
  [SMALL_STATE(7337)] = 280190,
  [SMALL_STATE(7338)] = 280221,
  [SMALL_STATE(7339)] = 280252,
  [SMALL_STATE(7340)] = 280283,
  [SMALL_STATE(7341)] = 280314,
  [SMALL_STATE(7342)] = 280335,
  [SMALL_STATE(7343)] = 280356,
  [SMALL_STATE(7344)] = 280387,
  [SMALL_STATE(7345)] = 280408,
  [SMALL_STATE(7346)] = 280435,
  [SMALL_STATE(7347)] = 280466,
  [SMALL_STATE(7348)] = 280497,
  [SMALL_STATE(7349)] = 280520,
  [SMALL_STATE(7350)] = 280551,
  [SMALL_STATE(7351)] = 280582,
  [SMALL_STATE(7352)] = 280607,
  [SMALL_STATE(7353)] = 280638,
  [SMALL_STATE(7354)] = 280661,
  [SMALL_STATE(7355)] = 280688,
  [SMALL_STATE(7356)] = 280711,
  [SMALL_STATE(7357)] = 280734,
  [SMALL_STATE(7358)] = 280765,
  [SMALL_STATE(7359)] = 280792,
  [SMALL_STATE(7360)] = 280823,
  [SMALL_STATE(7361)] = 280842,
  [SMALL_STATE(7362)] = 280873,
  [SMALL_STATE(7363)] = 280896,
  [SMALL_STATE(7364)] = 280919,
  [SMALL_STATE(7365)] = 280942,
  [SMALL_STATE(7366)] = 280973,
  [SMALL_STATE(7367)] = 280994,
  [SMALL_STATE(7368)] = 281021,
  [SMALL_STATE(7369)] = 281042,
  [SMALL_STATE(7370)] = 281069,
  [SMALL_STATE(7371)] = 281092,
  [SMALL_STATE(7372)] = 281123,
  [SMALL_STATE(7373)] = 281146,
  [SMALL_STATE(7374)] = 281172,
  [SMALL_STATE(7375)] = 281198,
  [SMALL_STATE(7376)] = 281218,
  [SMALL_STATE(7377)] = 281244,
  [SMALL_STATE(7378)] = 281270,
  [SMALL_STATE(7379)] = 281296,
  [SMALL_STATE(7380)] = 281322,
  [SMALL_STATE(7381)] = 281346,
  [SMALL_STATE(7382)] = 281372,
  [SMALL_STATE(7383)] = 281388,
  [SMALL_STATE(7384)] = 281414,
  [SMALL_STATE(7385)] = 281440,
  [SMALL_STATE(7386)] = 281460,
  [SMALL_STATE(7387)] = 281486,
  [SMALL_STATE(7388)] = 281502,
  [SMALL_STATE(7389)] = 281528,
  [SMALL_STATE(7390)] = 281548,
  [SMALL_STATE(7391)] = 281570,
  [SMALL_STATE(7392)] = 281594,
  [SMALL_STATE(7393)] = 281620,
  [SMALL_STATE(7394)] = 281646,
  [SMALL_STATE(7395)] = 281672,
  [SMALL_STATE(7396)] = 281694,
  [SMALL_STATE(7397)] = 281720,
  [SMALL_STATE(7398)] = 281746,
  [SMALL_STATE(7399)] = 281772,
  [SMALL_STATE(7400)] = 281798,
  [SMALL_STATE(7401)] = 281824,
  [SMALL_STATE(7402)] = 281844,
  [SMALL_STATE(7403)] = 281870,
  [SMALL_STATE(7404)] = 281896,
  [SMALL_STATE(7405)] = 281922,
  [SMALL_STATE(7406)] = 281948,
  [SMALL_STATE(7407)] = 281974,
  [SMALL_STATE(7408)] = 281996,
  [SMALL_STATE(7409)] = 282022,
  [SMALL_STATE(7410)] = 282048,
  [SMALL_STATE(7411)] = 282070,
  [SMALL_STATE(7412)] = 282092,
  [SMALL_STATE(7413)] = 282116,
  [SMALL_STATE(7414)] = 282142,
  [SMALL_STATE(7415)] = 282168,
  [SMALL_STATE(7416)] = 282194,
  [SMALL_STATE(7417)] = 282220,
  [SMALL_STATE(7418)] = 282244,
  [SMALL_STATE(7419)] = 282266,
  [SMALL_STATE(7420)] = 282288,
  [SMALL_STATE(7421)] = 282310,
  [SMALL_STATE(7422)] = 282336,
  [SMALL_STATE(7423)] = 282362,
  [SMALL_STATE(7424)] = 282388,
  [SMALL_STATE(7425)] = 282406,
  [SMALL_STATE(7426)] = 282428,
  [SMALL_STATE(7427)] = 282450,
  [SMALL_STATE(7428)] = 282476,
  [SMALL_STATE(7429)] = 282502,
  [SMALL_STATE(7430)] = 282528,
  [SMALL_STATE(7431)] = 282554,
  [SMALL_STATE(7432)] = 282580,
  [SMALL_STATE(7433)] = 282606,
  [SMALL_STATE(7434)] = 282628,
  [SMALL_STATE(7435)] = 282652,
  [SMALL_STATE(7436)] = 282678,
  [SMALL_STATE(7437)] = 282700,
  [SMALL_STATE(7438)] = 282725,
  [SMALL_STATE(7439)] = 282748,
  [SMALL_STATE(7440)] = 282769,
  [SMALL_STATE(7441)] = 282788,
  [SMALL_STATE(7442)] = 282813,
  [SMALL_STATE(7443)] = 282836,
  [SMALL_STATE(7444)] = 282857,
  [SMALL_STATE(7445)] = 282880,
  [SMALL_STATE(7446)] = 282905,
  [SMALL_STATE(7447)] = 282928,
  [SMALL_STATE(7448)] = 282943,
  [SMALL_STATE(7449)] = 282964,
  [SMALL_STATE(7450)] = 282979,
  [SMALL_STATE(7451)] = 283004,
  [SMALL_STATE(7452)] = 283027,
  [SMALL_STATE(7453)] = 283052,
  [SMALL_STATE(7454)] = 283075,
  [SMALL_STATE(7455)] = 283092,
  [SMALL_STATE(7456)] = 283113,
  [SMALL_STATE(7457)] = 283128,
  [SMALL_STATE(7458)] = 283151,
  [SMALL_STATE(7459)] = 283166,
  [SMALL_STATE(7460)] = 283191,
  [SMALL_STATE(7461)] = 283212,
  [SMALL_STATE(7462)] = 283235,
  [SMALL_STATE(7463)] = 283260,
  [SMALL_STATE(7464)] = 283283,
  [SMALL_STATE(7465)] = 283304,
  [SMALL_STATE(7466)] = 283319,
  [SMALL_STATE(7467)] = 283342,
  [SMALL_STATE(7468)] = 283363,
  [SMALL_STATE(7469)] = 283384,
  [SMALL_STATE(7470)] = 283405,
  [SMALL_STATE(7471)] = 283426,
  [SMALL_STATE(7472)] = 283449,
  [SMALL_STATE(7473)] = 283472,
  [SMALL_STATE(7474)] = 283493,
  [SMALL_STATE(7475)] = 283514,
  [SMALL_STATE(7476)] = 283529,
  [SMALL_STATE(7477)] = 283544,
  [SMALL_STATE(7478)] = 283569,
  [SMALL_STATE(7479)] = 283590,
  [SMALL_STATE(7480)] = 283611,
  [SMALL_STATE(7481)] = 283634,
  [SMALL_STATE(7482)] = 283655,
  [SMALL_STATE(7483)] = 283678,
  [SMALL_STATE(7484)] = 283699,
  [SMALL_STATE(7485)] = 283722,
  [SMALL_STATE(7486)] = 283741,
  [SMALL_STATE(7487)] = 283760,
  [SMALL_STATE(7488)] = 283785,
  [SMALL_STATE(7489)] = 283808,
  [SMALL_STATE(7490)] = 283823,
  [SMALL_STATE(7491)] = 283848,
  [SMALL_STATE(7492)] = 283864,
  [SMALL_STATE(7493)] = 283878,
  [SMALL_STATE(7494)] = 283898,
  [SMALL_STATE(7495)] = 283912,
  [SMALL_STATE(7496)] = 283932,
  [SMALL_STATE(7497)] = 283952,
  [SMALL_STATE(7498)] = 283968,
  [SMALL_STATE(7499)] = 283984,
  [SMALL_STATE(7500)] = 284000,
  [SMALL_STATE(7501)] = 284016,
  [SMALL_STATE(7502)] = 284036,
  [SMALL_STATE(7503)] = 284054,
  [SMALL_STATE(7504)] = 284072,
  [SMALL_STATE(7505)] = 284092,
  [SMALL_STATE(7506)] = 284110,
  [SMALL_STATE(7507)] = 284126,
  [SMALL_STATE(7508)] = 284146,
  [SMALL_STATE(7509)] = 284162,
  [SMALL_STATE(7510)] = 284176,
  [SMALL_STATE(7511)] = 284192,
  [SMALL_STATE(7512)] = 284212,
  [SMALL_STATE(7513)] = 284228,
  [SMALL_STATE(7514)] = 284248,
  [SMALL_STATE(7515)] = 284268,
  [SMALL_STATE(7516)] = 284286,
  [SMALL_STATE(7517)] = 284304,
  [SMALL_STATE(7518)] = 284324,
  [SMALL_STATE(7519)] = 284338,
  [SMALL_STATE(7520)] = 284352,
  [SMALL_STATE(7521)] = 284368,
  [SMALL_STATE(7522)] = 284384,
  [SMALL_STATE(7523)] = 284402,
  [SMALL_STATE(7524)] = 284422,
  [SMALL_STATE(7525)] = 284438,
  [SMALL_STATE(7526)] = 284458,
  [SMALL_STATE(7527)] = 284478,
  [SMALL_STATE(7528)] = 284492,
  [SMALL_STATE(7529)] = 284508,
  [SMALL_STATE(7530)] = 284528,
  [SMALL_STATE(7531)] = 284544,
  [SMALL_STATE(7532)] = 284564,
  [SMALL_STATE(7533)] = 284584,
  [SMALL_STATE(7534)] = 284598,
  [SMALL_STATE(7535)] = 284612,
  [SMALL_STATE(7536)] = 284626,
  [SMALL_STATE(7537)] = 284642,
  [SMALL_STATE(7538)] = 284662,
  [SMALL_STATE(7539)] = 284676,
  [SMALL_STATE(7540)] = 284696,
  [SMALL_STATE(7541)] = 284710,
  [SMALL_STATE(7542)] = 284724,
  [SMALL_STATE(7543)] = 284740,
  [SMALL_STATE(7544)] = 284756,
  [SMALL_STATE(7545)] = 284776,
  [SMALL_STATE(7546)] = 284790,
  [SMALL_STATE(7547)] = 284806,
  [SMALL_STATE(7548)] = 284826,
  [SMALL_STATE(7549)] = 284844,
  [SMALL_STATE(7550)] = 284860,
  [SMALL_STATE(7551)] = 284874,
  [SMALL_STATE(7552)] = 284892,
  [SMALL_STATE(7553)] = 284906,
  [SMALL_STATE(7554)] = 284922,
  [SMALL_STATE(7555)] = 284940,
  [SMALL_STATE(7556)] = 284957,
  [SMALL_STATE(7557)] = 284976,
  [SMALL_STATE(7558)] = 284995,
  [SMALL_STATE(7559)] = 285008,
  [SMALL_STATE(7560)] = 285027,
  [SMALL_STATE(7561)] = 285040,
  [SMALL_STATE(7562)] = 285059,
  [SMALL_STATE(7563)] = 285072,
  [SMALL_STATE(7564)] = 285091,
  [SMALL_STATE(7565)] = 285110,
  [SMALL_STATE(7566)] = 285129,
  [SMALL_STATE(7567)] = 285148,
  [SMALL_STATE(7568)] = 285167,
  [SMALL_STATE(7569)] = 285186,
  [SMALL_STATE(7570)] = 285205,
  [SMALL_STATE(7571)] = 285222,
  [SMALL_STATE(7572)] = 285241,
  [SMALL_STATE(7573)] = 285260,
  [SMALL_STATE(7574)] = 285279,
  [SMALL_STATE(7575)] = 285298,
  [SMALL_STATE(7576)] = 285317,
  [SMALL_STATE(7577)] = 285336,
  [SMALL_STATE(7578)] = 285355,
  [SMALL_STATE(7579)] = 285374,
  [SMALL_STATE(7580)] = 285393,
  [SMALL_STATE(7581)] = 285412,
  [SMALL_STATE(7582)] = 285431,
  [SMALL_STATE(7583)] = 285450,
  [SMALL_STATE(7584)] = 285469,
  [SMALL_STATE(7585)] = 285488,
  [SMALL_STATE(7586)] = 285507,
  [SMALL_STATE(7587)] = 285524,
  [SMALL_STATE(7588)] = 285537,
  [SMALL_STATE(7589)] = 285556,
  [SMALL_STATE(7590)] = 285569,
  [SMALL_STATE(7591)] = 285588,
  [SMALL_STATE(7592)] = 285607,
  [SMALL_STATE(7593)] = 285626,
  [SMALL_STATE(7594)] = 285645,
  [SMALL_STATE(7595)] = 285664,
  [SMALL_STATE(7596)] = 285683,
  [SMALL_STATE(7597)] = 285702,
  [SMALL_STATE(7598)] = 285721,
  [SMALL_STATE(7599)] = 285740,
  [SMALL_STATE(7600)] = 285759,
  [SMALL_STATE(7601)] = 285778,
  [SMALL_STATE(7602)] = 285797,
  [SMALL_STATE(7603)] = 285816,
  [SMALL_STATE(7604)] = 285835,
  [SMALL_STATE(7605)] = 285854,
  [SMALL_STATE(7606)] = 285871,
  [SMALL_STATE(7607)] = 285890,
  [SMALL_STATE(7608)] = 285909,
  [SMALL_STATE(7609)] = 285928,
  [SMALL_STATE(7610)] = 285947,
  [SMALL_STATE(7611)] = 285966,
  [SMALL_STATE(7612)] = 285985,
  [SMALL_STATE(7613)] = 286004,
  [SMALL_STATE(7614)] = 286023,
  [SMALL_STATE(7615)] = 286042,
  [SMALL_STATE(7616)] = 286061,
  [SMALL_STATE(7617)] = 286080,
  [SMALL_STATE(7618)] = 286099,
  [SMALL_STATE(7619)] = 286118,
  [SMALL_STATE(7620)] = 286137,
  [SMALL_STATE(7621)] = 286156,
  [SMALL_STATE(7622)] = 286175,
  [SMALL_STATE(7623)] = 286194,
  [SMALL_STATE(7624)] = 286211,
  [SMALL_STATE(7625)] = 286228,
  [SMALL_STATE(7626)] = 286247,
  [SMALL_STATE(7627)] = 286264,
  [SMALL_STATE(7628)] = 286278,
  [SMALL_STATE(7629)] = 286292,
  [SMALL_STATE(7630)] = 286306,
  [SMALL_STATE(7631)] = 286320,
  [SMALL_STATE(7632)] = 286334,
  [SMALL_STATE(7633)] = 286348,
  [SMALL_STATE(7634)] = 286362,
  [SMALL_STATE(7635)] = 286378,
  [SMALL_STATE(7636)] = 286392,
  [SMALL_STATE(7637)] = 286408,
  [SMALL_STATE(7638)] = 286422,
  [SMALL_STATE(7639)] = 286438,
  [SMALL_STATE(7640)] = 286454,
  [SMALL_STATE(7641)] = 286468,
  [SMALL_STATE(7642)] = 286482,
  [SMALL_STATE(7643)] = 286496,
  [SMALL_STATE(7644)] = 286510,
  [SMALL_STATE(7645)] = 286524,
  [SMALL_STATE(7646)] = 286538,
  [SMALL_STATE(7647)] = 286554,
  [SMALL_STATE(7648)] = 286570,
  [SMALL_STATE(7649)] = 286584,
  [SMALL_STATE(7650)] = 286598,
  [SMALL_STATE(7651)] = 286614,
  [SMALL_STATE(7652)] = 286630,
  [SMALL_STATE(7653)] = 286644,
  [SMALL_STATE(7654)] = 286660,
  [SMALL_STATE(7655)] = 286674,
  [SMALL_STATE(7656)] = 286690,
  [SMALL_STATE(7657)] = 286704,
  [SMALL_STATE(7658)] = 286720,
  [SMALL_STATE(7659)] = 286734,
  [SMALL_STATE(7660)] = 286750,
  [SMALL_STATE(7661)] = 286764,
  [SMALL_STATE(7662)] = 286780,
  [SMALL_STATE(7663)] = 286794,
  [SMALL_STATE(7664)] = 286808,
  [SMALL_STATE(7665)] = 286822,
  [SMALL_STATE(7666)] = 286836,
  [SMALL_STATE(7667)] = 286850,
  [SMALL_STATE(7668)] = 286864,
  [SMALL_STATE(7669)] = 286878,
  [SMALL_STATE(7670)] = 286894,
  [SMALL_STATE(7671)] = 286908,
  [SMALL_STATE(7672)] = 286924,
  [SMALL_STATE(7673)] = 286940,
  [SMALL_STATE(7674)] = 286954,
  [SMALL_STATE(7675)] = 286964,
  [SMALL_STATE(7676)] = 286974,
  [SMALL_STATE(7677)] = 286990,
  [SMALL_STATE(7678)] = 287006,
  [SMALL_STATE(7679)] = 287022,
  [SMALL_STATE(7680)] = 287038,
  [SMALL_STATE(7681)] = 287052,
  [SMALL_STATE(7682)] = 287068,
  [SMALL_STATE(7683)] = 287084,
  [SMALL_STATE(7684)] = 287098,
  [SMALL_STATE(7685)] = 287112,
  [SMALL_STATE(7686)] = 287128,
  [SMALL_STATE(7687)] = 287144,
  [SMALL_STATE(7688)] = 287158,
  [SMALL_STATE(7689)] = 287172,
  [SMALL_STATE(7690)] = 287186,
  [SMALL_STATE(7691)] = 287200,
  [SMALL_STATE(7692)] = 287214,
  [SMALL_STATE(7693)] = 287228,
  [SMALL_STATE(7694)] = 287242,
  [SMALL_STATE(7695)] = 287258,
  [SMALL_STATE(7696)] = 287272,
  [SMALL_STATE(7697)] = 287288,
  [SMALL_STATE(7698)] = 287300,
  [SMALL_STATE(7699)] = 287316,
  [SMALL_STATE(7700)] = 287330,
  [SMALL_STATE(7701)] = 287346,
  [SMALL_STATE(7702)] = 287362,
  [SMALL_STATE(7703)] = 287376,
  [SMALL_STATE(7704)] = 287392,
  [SMALL_STATE(7705)] = 287408,
  [SMALL_STATE(7706)] = 287424,
  [SMALL_STATE(7707)] = 287440,
  [SMALL_STATE(7708)] = 287454,
  [SMALL_STATE(7709)] = 287468,
  [SMALL_STATE(7710)] = 287484,
  [SMALL_STATE(7711)] = 287498,
  [SMALL_STATE(7712)] = 287514,
  [SMALL_STATE(7713)] = 287528,
  [SMALL_STATE(7714)] = 287544,
  [SMALL_STATE(7715)] = 287560,
  [SMALL_STATE(7716)] = 287576,
  [SMALL_STATE(7717)] = 287592,
  [SMALL_STATE(7718)] = 287608,
  [SMALL_STATE(7719)] = 287622,
  [SMALL_STATE(7720)] = 287638,
  [SMALL_STATE(7721)] = 287654,
  [SMALL_STATE(7722)] = 287668,
  [SMALL_STATE(7723)] = 287684,
  [SMALL_STATE(7724)] = 287698,
  [SMALL_STATE(7725)] = 287714,
  [SMALL_STATE(7726)] = 287730,
  [SMALL_STATE(7727)] = 287746,
  [SMALL_STATE(7728)] = 287762,
  [SMALL_STATE(7729)] = 287778,
  [SMALL_STATE(7730)] = 287792,
  [SMALL_STATE(7731)] = 287806,
  [SMALL_STATE(7732)] = 287822,
  [SMALL_STATE(7733)] = 287838,
  [SMALL_STATE(7734)] = 287854,
  [SMALL_STATE(7735)] = 287866,
  [SMALL_STATE(7736)] = 287882,
  [SMALL_STATE(7737)] = 287896,
  [SMALL_STATE(7738)] = 287912,
  [SMALL_STATE(7739)] = 287926,
  [SMALL_STATE(7740)] = 287940,
  [SMALL_STATE(7741)] = 287954,
  [SMALL_STATE(7742)] = 287970,
  [SMALL_STATE(7743)] = 287984,
  [SMALL_STATE(7744)] = 288000,
  [SMALL_STATE(7745)] = 288014,
  [SMALL_STATE(7746)] = 288030,
  [SMALL_STATE(7747)] = 288046,
  [SMALL_STATE(7748)] = 288060,
  [SMALL_STATE(7749)] = 288076,
  [SMALL_STATE(7750)] = 288092,
  [SMALL_STATE(7751)] = 288108,
  [SMALL_STATE(7752)] = 288124,
  [SMALL_STATE(7753)] = 288140,
  [SMALL_STATE(7754)] = 288156,
  [SMALL_STATE(7755)] = 288170,
  [SMALL_STATE(7756)] = 288186,
  [SMALL_STATE(7757)] = 288202,
  [SMALL_STATE(7758)] = 288218,
  [SMALL_STATE(7759)] = 288232,
  [SMALL_STATE(7760)] = 288246,
  [SMALL_STATE(7761)] = 288262,
  [SMALL_STATE(7762)] = 288278,
  [SMALL_STATE(7763)] = 288292,
  [SMALL_STATE(7764)] = 288306,
  [SMALL_STATE(7765)] = 288320,
  [SMALL_STATE(7766)] = 288334,
  [SMALL_STATE(7767)] = 288350,
  [SMALL_STATE(7768)] = 288366,
  [SMALL_STATE(7769)] = 288382,
  [SMALL_STATE(7770)] = 288394,
  [SMALL_STATE(7771)] = 288410,
  [SMALL_STATE(7772)] = 288424,
  [SMALL_STATE(7773)] = 288440,
  [SMALL_STATE(7774)] = 288456,
  [SMALL_STATE(7775)] = 288470,
  [SMALL_STATE(7776)] = 288486,
  [SMALL_STATE(7777)] = 288500,
  [SMALL_STATE(7778)] = 288516,
  [SMALL_STATE(7779)] = 288532,
  [SMALL_STATE(7780)] = 288546,
  [SMALL_STATE(7781)] = 288560,
  [SMALL_STATE(7782)] = 288574,
  [SMALL_STATE(7783)] = 288590,
  [SMALL_STATE(7784)] = 288606,
  [SMALL_STATE(7785)] = 288622,
  [SMALL_STATE(7786)] = 288638,
  [SMALL_STATE(7787)] = 288652,
  [SMALL_STATE(7788)] = 288668,
  [SMALL_STATE(7789)] = 288682,
  [SMALL_STATE(7790)] = 288696,
  [SMALL_STATE(7791)] = 288712,
  [SMALL_STATE(7792)] = 288726,
  [SMALL_STATE(7793)] = 288740,
  [SMALL_STATE(7794)] = 288754,
  [SMALL_STATE(7795)] = 288770,
  [SMALL_STATE(7796)] = 288784,
  [SMALL_STATE(7797)] = 288798,
  [SMALL_STATE(7798)] = 288812,
  [SMALL_STATE(7799)] = 288828,
  [SMALL_STATE(7800)] = 288842,
  [SMALL_STATE(7801)] = 288858,
  [SMALL_STATE(7802)] = 288874,
  [SMALL_STATE(7803)] = 288890,
  [SMALL_STATE(7804)] = 288906,
  [SMALL_STATE(7805)] = 288922,
  [SMALL_STATE(7806)] = 288938,
  [SMALL_STATE(7807)] = 288952,
  [SMALL_STATE(7808)] = 288968,
  [SMALL_STATE(7809)] = 288982,
  [SMALL_STATE(7810)] = 288996,
  [SMALL_STATE(7811)] = 289012,
  [SMALL_STATE(7812)] = 289028,
  [SMALL_STATE(7813)] = 289042,
  [SMALL_STATE(7814)] = 289058,
  [SMALL_STATE(7815)] = 289074,
  [SMALL_STATE(7816)] = 289090,
  [SMALL_STATE(7817)] = 289106,
  [SMALL_STATE(7818)] = 289120,
  [SMALL_STATE(7819)] = 289136,
  [SMALL_STATE(7820)] = 289152,
  [SMALL_STATE(7821)] = 289168,
  [SMALL_STATE(7822)] = 289182,
  [SMALL_STATE(7823)] = 289196,
  [SMALL_STATE(7824)] = 289210,
  [SMALL_STATE(7825)] = 289224,
  [SMALL_STATE(7826)] = 289240,
  [SMALL_STATE(7827)] = 289254,
  [SMALL_STATE(7828)] = 289270,
  [SMALL_STATE(7829)] = 289286,
  [SMALL_STATE(7830)] = 289302,
  [SMALL_STATE(7831)] = 289316,
  [SMALL_STATE(7832)] = 289332,
  [SMALL_STATE(7833)] = 289346,
  [SMALL_STATE(7834)] = 289362,
  [SMALL_STATE(7835)] = 289376,
  [SMALL_STATE(7836)] = 289390,
  [SMALL_STATE(7837)] = 289406,
  [SMALL_STATE(7838)] = 289420,
  [SMALL_STATE(7839)] = 289434,
  [SMALL_STATE(7840)] = 289448,
  [SMALL_STATE(7841)] = 289464,
  [SMALL_STATE(7842)] = 289478,
  [SMALL_STATE(7843)] = 289494,
  [SMALL_STATE(7844)] = 289510,
  [SMALL_STATE(7845)] = 289524,
  [SMALL_STATE(7846)] = 289540,
  [SMALL_STATE(7847)] = 289556,
  [SMALL_STATE(7848)] = 289572,
  [SMALL_STATE(7849)] = 289588,
  [SMALL_STATE(7850)] = 289604,
  [SMALL_STATE(7851)] = 289620,
  [SMALL_STATE(7852)] = 289632,
  [SMALL_STATE(7853)] = 289648,
  [SMALL_STATE(7854)] = 289662,
  [SMALL_STATE(7855)] = 289678,
  [SMALL_STATE(7856)] = 289694,
  [SMALL_STATE(7857)] = 289708,
  [SMALL_STATE(7858)] = 289722,
  [SMALL_STATE(7859)] = 289738,
  [SMALL_STATE(7860)] = 289754,
  [SMALL_STATE(7861)] = 289768,
  [SMALL_STATE(7862)] = 289782,
  [SMALL_STATE(7863)] = 289798,
  [SMALL_STATE(7864)] = 289812,
  [SMALL_STATE(7865)] = 289826,
  [SMALL_STATE(7866)] = 289842,
  [SMALL_STATE(7867)] = 289858,
  [SMALL_STATE(7868)] = 289874,
  [SMALL_STATE(7869)] = 289888,
  [SMALL_STATE(7870)] = 289902,
  [SMALL_STATE(7871)] = 289918,
  [SMALL_STATE(7872)] = 289934,
  [SMALL_STATE(7873)] = 289950,
  [SMALL_STATE(7874)] = 289966,
  [SMALL_STATE(7875)] = 289980,
  [SMALL_STATE(7876)] = 289994,
  [SMALL_STATE(7877)] = 290008,
  [SMALL_STATE(7878)] = 290024,
  [SMALL_STATE(7879)] = 290038,
  [SMALL_STATE(7880)] = 290054,
  [SMALL_STATE(7881)] = 290070,
  [SMALL_STATE(7882)] = 290084,
  [SMALL_STATE(7883)] = 290098,
  [SMALL_STATE(7884)] = 290112,
  [SMALL_STATE(7885)] = 290126,
  [SMALL_STATE(7886)] = 290140,
  [SMALL_STATE(7887)] = 290154,
  [SMALL_STATE(7888)] = 290166,
  [SMALL_STATE(7889)] = 290180,
  [SMALL_STATE(7890)] = 290196,
  [SMALL_STATE(7891)] = 290212,
  [SMALL_STATE(7892)] = 290228,
  [SMALL_STATE(7893)] = 290242,
  [SMALL_STATE(7894)] = 290258,
  [SMALL_STATE(7895)] = 290272,
  [SMALL_STATE(7896)] = 290286,
  [SMALL_STATE(7897)] = 290302,
  [SMALL_STATE(7898)] = 290318,
  [SMALL_STATE(7899)] = 290334,
  [SMALL_STATE(7900)] = 290348,
  [SMALL_STATE(7901)] = 290364,
  [SMALL_STATE(7902)] = 290380,
  [SMALL_STATE(7903)] = 290394,
  [SMALL_STATE(7904)] = 290410,
  [SMALL_STATE(7905)] = 290426,
  [SMALL_STATE(7906)] = 290440,
  [SMALL_STATE(7907)] = 290456,
  [SMALL_STATE(7908)] = 290470,
  [SMALL_STATE(7909)] = 290484,
  [SMALL_STATE(7910)] = 290494,
  [SMALL_STATE(7911)] = 290510,
  [SMALL_STATE(7912)] = 290524,
  [SMALL_STATE(7913)] = 290540,
  [SMALL_STATE(7914)] = 290556,
  [SMALL_STATE(7915)] = 290572,
  [SMALL_STATE(7916)] = 290588,
  [SMALL_STATE(7917)] = 290602,
  [SMALL_STATE(7918)] = 290618,
  [SMALL_STATE(7919)] = 290632,
  [SMALL_STATE(7920)] = 290648,
  [SMALL_STATE(7921)] = 290664,
  [SMALL_STATE(7922)] = 290680,
  [SMALL_STATE(7923)] = 290696,
  [SMALL_STATE(7924)] = 290712,
  [SMALL_STATE(7925)] = 290726,
  [SMALL_STATE(7926)] = 290740,
  [SMALL_STATE(7927)] = 290754,
  [SMALL_STATE(7928)] = 290768,
  [SMALL_STATE(7929)] = 290784,
  [SMALL_STATE(7930)] = 290794,
  [SMALL_STATE(7931)] = 290810,
  [SMALL_STATE(7932)] = 290824,
  [SMALL_STATE(7933)] = 290838,
  [SMALL_STATE(7934)] = 290854,
  [SMALL_STATE(7935)] = 290868,
  [SMALL_STATE(7936)] = 290884,
  [SMALL_STATE(7937)] = 290895,
  [SMALL_STATE(7938)] = 290908,
  [SMALL_STATE(7939)] = 290917,
  [SMALL_STATE(7940)] = 290930,
  [SMALL_STATE(7941)] = 290943,
  [SMALL_STATE(7942)] = 290956,
  [SMALL_STATE(7943)] = 290969,
  [SMALL_STATE(7944)] = 290980,
  [SMALL_STATE(7945)] = 290993,
  [SMALL_STATE(7946)] = 291006,
  [SMALL_STATE(7947)] = 291019,
  [SMALL_STATE(7948)] = 291032,
  [SMALL_STATE(7949)] = 291045,
  [SMALL_STATE(7950)] = 291058,
  [SMALL_STATE(7951)] = 291071,
  [SMALL_STATE(7952)] = 291082,
  [SMALL_STATE(7953)] = 291095,
  [SMALL_STATE(7954)] = 291108,
  [SMALL_STATE(7955)] = 291121,
  [SMALL_STATE(7956)] = 291134,
  [SMALL_STATE(7957)] = 291145,
  [SMALL_STATE(7958)] = 291158,
  [SMALL_STATE(7959)] = 291169,
  [SMALL_STATE(7960)] = 291182,
  [SMALL_STATE(7961)] = 291195,
  [SMALL_STATE(7962)] = 291208,
  [SMALL_STATE(7963)] = 291221,
  [SMALL_STATE(7964)] = 291234,
  [SMALL_STATE(7965)] = 291247,
  [SMALL_STATE(7966)] = 291260,
  [SMALL_STATE(7967)] = 291273,
  [SMALL_STATE(7968)] = 291286,
  [SMALL_STATE(7969)] = 291299,
  [SMALL_STATE(7970)] = 291312,
  [SMALL_STATE(7971)] = 291325,
  [SMALL_STATE(7972)] = 291338,
  [SMALL_STATE(7973)] = 291351,
  [SMALL_STATE(7974)] = 291364,
  [SMALL_STATE(7975)] = 291375,
  [SMALL_STATE(7976)] = 291388,
  [SMALL_STATE(7977)] = 291401,
  [SMALL_STATE(7978)] = 291414,
  [SMALL_STATE(7979)] = 291427,
  [SMALL_STATE(7980)] = 291440,
  [SMALL_STATE(7981)] = 291453,
  [SMALL_STATE(7982)] = 291464,
  [SMALL_STATE(7983)] = 291475,
  [SMALL_STATE(7984)] = 291488,
  [SMALL_STATE(7985)] = 291501,
  [SMALL_STATE(7986)] = 291514,
  [SMALL_STATE(7987)] = 291527,
  [SMALL_STATE(7988)] = 291540,
  [SMALL_STATE(7989)] = 291553,
  [SMALL_STATE(7990)] = 291566,
  [SMALL_STATE(7991)] = 291579,
  [SMALL_STATE(7992)] = 291592,
  [SMALL_STATE(7993)] = 291603,
  [SMALL_STATE(7994)] = 291614,
  [SMALL_STATE(7995)] = 291625,
  [SMALL_STATE(7996)] = 291638,
  [SMALL_STATE(7997)] = 291651,
  [SMALL_STATE(7998)] = 291664,
  [SMALL_STATE(7999)] = 291675,
  [SMALL_STATE(8000)] = 291688,
  [SMALL_STATE(8001)] = 291701,
  [SMALL_STATE(8002)] = 291714,
  [SMALL_STATE(8003)] = 291727,
  [SMALL_STATE(8004)] = 291738,
  [SMALL_STATE(8005)] = 291751,
  [SMALL_STATE(8006)] = 291764,
  [SMALL_STATE(8007)] = 291777,
  [SMALL_STATE(8008)] = 291790,
  [SMALL_STATE(8009)] = 291803,
  [SMALL_STATE(8010)] = 291816,
  [SMALL_STATE(8011)] = 291829,
  [SMALL_STATE(8012)] = 291842,
  [SMALL_STATE(8013)] = 291853,
  [SMALL_STATE(8014)] = 291866,
  [SMALL_STATE(8015)] = 291879,
  [SMALL_STATE(8016)] = 291892,
  [SMALL_STATE(8017)] = 291905,
  [SMALL_STATE(8018)] = 291918,
  [SMALL_STATE(8019)] = 291931,
  [SMALL_STATE(8020)] = 291944,
  [SMALL_STATE(8021)] = 291955,
  [SMALL_STATE(8022)] = 291968,
  [SMALL_STATE(8023)] = 291981,
  [SMALL_STATE(8024)] = 291994,
  [SMALL_STATE(8025)] = 292007,
  [SMALL_STATE(8026)] = 292020,
  [SMALL_STATE(8027)] = 292033,
  [SMALL_STATE(8028)] = 292046,
  [SMALL_STATE(8029)] = 292059,
  [SMALL_STATE(8030)] = 292072,
  [SMALL_STATE(8031)] = 292085,
  [SMALL_STATE(8032)] = 292098,
  [SMALL_STATE(8033)] = 292109,
  [SMALL_STATE(8034)] = 292120,
  [SMALL_STATE(8035)] = 292133,
  [SMALL_STATE(8036)] = 292146,
  [SMALL_STATE(8037)] = 292157,
  [SMALL_STATE(8038)] = 292170,
  [SMALL_STATE(8039)] = 292183,
  [SMALL_STATE(8040)] = 292196,
  [SMALL_STATE(8041)] = 292209,
  [SMALL_STATE(8042)] = 292222,
  [SMALL_STATE(8043)] = 292235,
  [SMALL_STATE(8044)] = 292248,
  [SMALL_STATE(8045)] = 292261,
  [SMALL_STATE(8046)] = 292274,
  [SMALL_STATE(8047)] = 292285,
  [SMALL_STATE(8048)] = 292298,
  [SMALL_STATE(8049)] = 292311,
  [SMALL_STATE(8050)] = 292324,
  [SMALL_STATE(8051)] = 292337,
  [SMALL_STATE(8052)] = 292350,
  [SMALL_STATE(8053)] = 292363,
  [SMALL_STATE(8054)] = 292374,
  [SMALL_STATE(8055)] = 292387,
  [SMALL_STATE(8056)] = 292400,
  [SMALL_STATE(8057)] = 292413,
  [SMALL_STATE(8058)] = 292426,
  [SMALL_STATE(8059)] = 292439,
  [SMALL_STATE(8060)] = 292452,
  [SMALL_STATE(8061)] = 292465,
  [SMALL_STATE(8062)] = 292478,
  [SMALL_STATE(8063)] = 292491,
  [SMALL_STATE(8064)] = 292502,
  [SMALL_STATE(8065)] = 292513,
  [SMALL_STATE(8066)] = 292526,
  [SMALL_STATE(8067)] = 292539,
  [SMALL_STATE(8068)] = 292552,
  [SMALL_STATE(8069)] = 292565,
  [SMALL_STATE(8070)] = 292578,
  [SMALL_STATE(8071)] = 292591,
  [SMALL_STATE(8072)] = 292604,
  [SMALL_STATE(8073)] = 292613,
  [SMALL_STATE(8074)] = 292626,
  [SMALL_STATE(8075)] = 292639,
  [SMALL_STATE(8076)] = 292650,
  [SMALL_STATE(8077)] = 292659,
  [SMALL_STATE(8078)] = 292672,
  [SMALL_STATE(8079)] = 292685,
  [SMALL_STATE(8080)] = 292698,
  [SMALL_STATE(8081)] = 292711,
  [SMALL_STATE(8082)] = 292724,
  [SMALL_STATE(8083)] = 292737,
  [SMALL_STATE(8084)] = 292750,
  [SMALL_STATE(8085)] = 292763,
  [SMALL_STATE(8086)] = 292776,
  [SMALL_STATE(8087)] = 292787,
  [SMALL_STATE(8088)] = 292798,
  [SMALL_STATE(8089)] = 292811,
  [SMALL_STATE(8090)] = 292822,
  [SMALL_STATE(8091)] = 292835,
  [SMALL_STATE(8092)] = 292848,
  [SMALL_STATE(8093)] = 292859,
  [SMALL_STATE(8094)] = 292872,
  [SMALL_STATE(8095)] = 292885,
  [SMALL_STATE(8096)] = 292896,
  [SMALL_STATE(8097)] = 292907,
  [SMALL_STATE(8098)] = 292920,
  [SMALL_STATE(8099)] = 292933,
  [SMALL_STATE(8100)] = 292944,
  [SMALL_STATE(8101)] = 292955,
  [SMALL_STATE(8102)] = 292966,
  [SMALL_STATE(8103)] = 292979,
  [SMALL_STATE(8104)] = 292992,
  [SMALL_STATE(8105)] = 293005,
  [SMALL_STATE(8106)] = 293018,
  [SMALL_STATE(8107)] = 293031,
  [SMALL_STATE(8108)] = 293042,
  [SMALL_STATE(8109)] = 293055,
  [SMALL_STATE(8110)] = 293068,
  [SMALL_STATE(8111)] = 293081,
  [SMALL_STATE(8112)] = 293094,
  [SMALL_STATE(8113)] = 293107,
  [SMALL_STATE(8114)] = 293120,
  [SMALL_STATE(8115)] = 293133,
  [SMALL_STATE(8116)] = 293146,
  [SMALL_STATE(8117)] = 293159,
  [SMALL_STATE(8118)] = 293172,
  [SMALL_STATE(8119)] = 293185,
  [SMALL_STATE(8120)] = 293198,
  [SMALL_STATE(8121)] = 293211,
  [SMALL_STATE(8122)] = 293224,
  [SMALL_STATE(8123)] = 293237,
  [SMALL_STATE(8124)] = 293250,
  [SMALL_STATE(8125)] = 293263,
  [SMALL_STATE(8126)] = 293274,
  [SMALL_STATE(8127)] = 293287,
  [SMALL_STATE(8128)] = 293300,
  [SMALL_STATE(8129)] = 293313,
  [SMALL_STATE(8130)] = 293326,
  [SMALL_STATE(8131)] = 293339,
  [SMALL_STATE(8132)] = 293352,
  [SMALL_STATE(8133)] = 293365,
  [SMALL_STATE(8134)] = 293378,
  [SMALL_STATE(8135)] = 293391,
  [SMALL_STATE(8136)] = 293404,
  [SMALL_STATE(8137)] = 293415,
  [SMALL_STATE(8138)] = 293428,
  [SMALL_STATE(8139)] = 293441,
  [SMALL_STATE(8140)] = 293454,
  [SMALL_STATE(8141)] = 293467,
  [SMALL_STATE(8142)] = 293480,
  [SMALL_STATE(8143)] = 293493,
  [SMALL_STATE(8144)] = 293502,
  [SMALL_STATE(8145)] = 293515,
  [SMALL_STATE(8146)] = 293524,
  [SMALL_STATE(8147)] = 293537,
  [SMALL_STATE(8148)] = 293550,
  [SMALL_STATE(8149)] = 293561,
  [SMALL_STATE(8150)] = 293570,
  [SMALL_STATE(8151)] = 293583,
  [SMALL_STATE(8152)] = 293596,
  [SMALL_STATE(8153)] = 293609,
  [SMALL_STATE(8154)] = 293622,
  [SMALL_STATE(8155)] = 293635,
  [SMALL_STATE(8156)] = 293646,
  [SMALL_STATE(8157)] = 293659,
  [SMALL_STATE(8158)] = 293672,
  [SMALL_STATE(8159)] = 293685,
  [SMALL_STATE(8160)] = 293698,
  [SMALL_STATE(8161)] = 293711,
  [SMALL_STATE(8162)] = 293724,
  [SMALL_STATE(8163)] = 293737,
  [SMALL_STATE(8164)] = 293750,
  [SMALL_STATE(8165)] = 293761,
  [SMALL_STATE(8166)] = 293774,
  [SMALL_STATE(8167)] = 293787,
  [SMALL_STATE(8168)] = 293796,
  [SMALL_STATE(8169)] = 293809,
  [SMALL_STATE(8170)] = 293822,
  [SMALL_STATE(8171)] = 293835,
  [SMALL_STATE(8172)] = 293848,
  [SMALL_STATE(8173)] = 293861,
  [SMALL_STATE(8174)] = 293874,
  [SMALL_STATE(8175)] = 293887,
  [SMALL_STATE(8176)] = 293900,
  [SMALL_STATE(8177)] = 293913,
  [SMALL_STATE(8178)] = 293926,
  [SMALL_STATE(8179)] = 293939,
  [SMALL_STATE(8180)] = 293952,
  [SMALL_STATE(8181)] = 293965,
  [SMALL_STATE(8182)] = 293978,
  [SMALL_STATE(8183)] = 293991,
  [SMALL_STATE(8184)] = 294004,
  [SMALL_STATE(8185)] = 294017,
  [SMALL_STATE(8186)] = 294030,
  [SMALL_STATE(8187)] = 294043,
  [SMALL_STATE(8188)] = 294056,
  [SMALL_STATE(8189)] = 294069,
  [SMALL_STATE(8190)] = 294082,
  [SMALL_STATE(8191)] = 294095,
  [SMALL_STATE(8192)] = 294108,
  [SMALL_STATE(8193)] = 294121,
  [SMALL_STATE(8194)] = 294134,
  [SMALL_STATE(8195)] = 294147,
  [SMALL_STATE(8196)] = 294160,
  [SMALL_STATE(8197)] = 294171,
  [SMALL_STATE(8198)] = 294182,
  [SMALL_STATE(8199)] = 294195,
  [SMALL_STATE(8200)] = 294208,
  [SMALL_STATE(8201)] = 294221,
  [SMALL_STATE(8202)] = 294234,
  [SMALL_STATE(8203)] = 294247,
  [SMALL_STATE(8204)] = 294258,
  [SMALL_STATE(8205)] = 294271,
  [SMALL_STATE(8206)] = 294284,
  [SMALL_STATE(8207)] = 294297,
  [SMALL_STATE(8208)] = 294310,
  [SMALL_STATE(8209)] = 294323,
  [SMALL_STATE(8210)] = 294336,
  [SMALL_STATE(8211)] = 294349,
  [SMALL_STATE(8212)] = 294362,
  [SMALL_STATE(8213)] = 294375,
  [SMALL_STATE(8214)] = 294388,
  [SMALL_STATE(8215)] = 294401,
  [SMALL_STATE(8216)] = 294414,
  [SMALL_STATE(8217)] = 294427,
  [SMALL_STATE(8218)] = 294440,
  [SMALL_STATE(8219)] = 294453,
  [SMALL_STATE(8220)] = 294464,
  [SMALL_STATE(8221)] = 294477,
  [SMALL_STATE(8222)] = 294488,
  [SMALL_STATE(8223)] = 294501,
  [SMALL_STATE(8224)] = 294514,
  [SMALL_STATE(8225)] = 294527,
  [SMALL_STATE(8226)] = 294540,
  [SMALL_STATE(8227)] = 294553,
  [SMALL_STATE(8228)] = 294566,
  [SMALL_STATE(8229)] = 294579,
  [SMALL_STATE(8230)] = 294588,
  [SMALL_STATE(8231)] = 294601,
  [SMALL_STATE(8232)] = 294614,
  [SMALL_STATE(8233)] = 294627,
  [SMALL_STATE(8234)] = 294640,
  [SMALL_STATE(8235)] = 294653,
  [SMALL_STATE(8236)] = 294666,
  [SMALL_STATE(8237)] = 294679,
  [SMALL_STATE(8238)] = 294692,
  [SMALL_STATE(8239)] = 294705,
  [SMALL_STATE(8240)] = 294718,
  [SMALL_STATE(8241)] = 294731,
  [SMALL_STATE(8242)] = 294744,
  [SMALL_STATE(8243)] = 294757,
  [SMALL_STATE(8244)] = 294770,
  [SMALL_STATE(8245)] = 294779,
  [SMALL_STATE(8246)] = 294790,
  [SMALL_STATE(8247)] = 294801,
  [SMALL_STATE(8248)] = 294814,
  [SMALL_STATE(8249)] = 294827,
  [SMALL_STATE(8250)] = 294840,
  [SMALL_STATE(8251)] = 294853,
  [SMALL_STATE(8252)] = 294866,
  [SMALL_STATE(8253)] = 294879,
  [SMALL_STATE(8254)] = 294892,
  [SMALL_STATE(8255)] = 294905,
  [SMALL_STATE(8256)] = 294918,
  [SMALL_STATE(8257)] = 294931,
  [SMALL_STATE(8258)] = 294944,
  [SMALL_STATE(8259)] = 294957,
  [SMALL_STATE(8260)] = 294970,
  [SMALL_STATE(8261)] = 294983,
  [SMALL_STATE(8262)] = 294996,
  [SMALL_STATE(8263)] = 295009,
  [SMALL_STATE(8264)] = 295022,
  [SMALL_STATE(8265)] = 295035,
  [SMALL_STATE(8266)] = 295048,
  [SMALL_STATE(8267)] = 295061,
  [SMALL_STATE(8268)] = 295074,
  [SMALL_STATE(8269)] = 295083,
  [SMALL_STATE(8270)] = 295096,
  [SMALL_STATE(8271)] = 295109,
  [SMALL_STATE(8272)] = 295118,
  [SMALL_STATE(8273)] = 295131,
  [SMALL_STATE(8274)] = 295144,
  [SMALL_STATE(8275)] = 295157,
  [SMALL_STATE(8276)] = 295170,
  [SMALL_STATE(8277)] = 295183,
  [SMALL_STATE(8278)] = 295194,
  [SMALL_STATE(8279)] = 295207,
  [SMALL_STATE(8280)] = 295220,
  [SMALL_STATE(8281)] = 295233,
  [SMALL_STATE(8282)] = 295246,
  [SMALL_STATE(8283)] = 295259,
  [SMALL_STATE(8284)] = 295272,
  [SMALL_STATE(8285)] = 295283,
  [SMALL_STATE(8286)] = 295296,
  [SMALL_STATE(8287)] = 295309,
  [SMALL_STATE(8288)] = 295322,
  [SMALL_STATE(8289)] = 295335,
  [SMALL_STATE(8290)] = 295348,
  [SMALL_STATE(8291)] = 295361,
  [SMALL_STATE(8292)] = 295374,
  [SMALL_STATE(8293)] = 295387,
  [SMALL_STATE(8294)] = 295400,
  [SMALL_STATE(8295)] = 295409,
  [SMALL_STATE(8296)] = 295418,
  [SMALL_STATE(8297)] = 295431,
  [SMALL_STATE(8298)] = 295444,
  [SMALL_STATE(8299)] = 295457,
  [SMALL_STATE(8300)] = 295468,
  [SMALL_STATE(8301)] = 295481,
  [SMALL_STATE(8302)] = 295494,
  [SMALL_STATE(8303)] = 295507,
  [SMALL_STATE(8304)] = 295520,
  [SMALL_STATE(8305)] = 295533,
  [SMALL_STATE(8306)] = 295544,
  [SMALL_STATE(8307)] = 295557,
  [SMALL_STATE(8308)] = 295570,
  [SMALL_STATE(8309)] = 295583,
  [SMALL_STATE(8310)] = 295596,
  [SMALL_STATE(8311)] = 295609,
  [SMALL_STATE(8312)] = 295622,
  [SMALL_STATE(8313)] = 295635,
  [SMALL_STATE(8314)] = 295648,
  [SMALL_STATE(8315)] = 295661,
  [SMALL_STATE(8316)] = 295674,
  [SMALL_STATE(8317)] = 295687,
  [SMALL_STATE(8318)] = 295700,
  [SMALL_STATE(8319)] = 295713,
  [SMALL_STATE(8320)] = 295726,
  [SMALL_STATE(8321)] = 295739,
  [SMALL_STATE(8322)] = 295752,
  [SMALL_STATE(8323)] = 295765,
  [SMALL_STATE(8324)] = 295778,
  [SMALL_STATE(8325)] = 295791,
  [SMALL_STATE(8326)] = 295804,
  [SMALL_STATE(8327)] = 295817,
  [SMALL_STATE(8328)] = 295830,
  [SMALL_STATE(8329)] = 295841,
  [SMALL_STATE(8330)] = 295854,
  [SMALL_STATE(8331)] = 295863,
  [SMALL_STATE(8332)] = 295876,
  [SMALL_STATE(8333)] = 295889,
  [SMALL_STATE(8334)] = 295902,
  [SMALL_STATE(8335)] = 295915,
  [SMALL_STATE(8336)] = 295928,
  [SMALL_STATE(8337)] = 295941,
  [SMALL_STATE(8338)] = 295952,
  [SMALL_STATE(8339)] = 295965,
  [SMALL_STATE(8340)] = 295976,
  [SMALL_STATE(8341)] = 295987,
  [SMALL_STATE(8342)] = 296000,
  [SMALL_STATE(8343)] = 296013,
  [SMALL_STATE(8344)] = 296026,
  [SMALL_STATE(8345)] = 296039,
  [SMALL_STATE(8346)] = 296052,
  [SMALL_STATE(8347)] = 296065,
  [SMALL_STATE(8348)] = 296078,
  [SMALL_STATE(8349)] = 296091,
  [SMALL_STATE(8350)] = 296100,
  [SMALL_STATE(8351)] = 296113,
  [SMALL_STATE(8352)] = 296122,
  [SMALL_STATE(8353)] = 296135,
  [SMALL_STATE(8354)] = 296148,
  [SMALL_STATE(8355)] = 296159,
  [SMALL_STATE(8356)] = 296172,
  [SMALL_STATE(8357)] = 296185,
  [SMALL_STATE(8358)] = 296196,
  [SMALL_STATE(8359)] = 296209,
  [SMALL_STATE(8360)] = 296222,
  [SMALL_STATE(8361)] = 296235,
  [SMALL_STATE(8362)] = 296248,
  [SMALL_STATE(8363)] = 296261,
  [SMALL_STATE(8364)] = 296274,
  [SMALL_STATE(8365)] = 296287,
  [SMALL_STATE(8366)] = 296300,
  [SMALL_STATE(8367)] = 296311,
  [SMALL_STATE(8368)] = 296324,
  [SMALL_STATE(8369)] = 296337,
  [SMALL_STATE(8370)] = 296350,
  [SMALL_STATE(8371)] = 296363,
  [SMALL_STATE(8372)] = 296372,
  [SMALL_STATE(8373)] = 296381,
  [SMALL_STATE(8374)] = 296394,
  [SMALL_STATE(8375)] = 296407,
  [SMALL_STATE(8376)] = 296420,
  [SMALL_STATE(8377)] = 296433,
  [SMALL_STATE(8378)] = 296442,
  [SMALL_STATE(8379)] = 296455,
  [SMALL_STATE(8380)] = 296468,
  [SMALL_STATE(8381)] = 296477,
  [SMALL_STATE(8382)] = 296490,
  [SMALL_STATE(8383)] = 296503,
  [SMALL_STATE(8384)] = 296516,
  [SMALL_STATE(8385)] = 296529,
  [SMALL_STATE(8386)] = 296542,
  [SMALL_STATE(8387)] = 296555,
  [SMALL_STATE(8388)] = 296565,
  [SMALL_STATE(8389)] = 296575,
  [SMALL_STATE(8390)] = 296585,
  [SMALL_STATE(8391)] = 296595,
  [SMALL_STATE(8392)] = 296605,
  [SMALL_STATE(8393)] = 296615,
  [SMALL_STATE(8394)] = 296623,
  [SMALL_STATE(8395)] = 296631,
  [SMALL_STATE(8396)] = 296641,
  [SMALL_STATE(8397)] = 296649,
  [SMALL_STATE(8398)] = 296657,
  [SMALL_STATE(8399)] = 296665,
  [SMALL_STATE(8400)] = 296675,
  [SMALL_STATE(8401)] = 296683,
  [SMALL_STATE(8402)] = 296691,
  [SMALL_STATE(8403)] = 296699,
  [SMALL_STATE(8404)] = 296709,
  [SMALL_STATE(8405)] = 296717,
  [SMALL_STATE(8406)] = 296727,
  [SMALL_STATE(8407)] = 296737,
  [SMALL_STATE(8408)] = 296747,
  [SMALL_STATE(8409)] = 296757,
  [SMALL_STATE(8410)] = 296767,
  [SMALL_STATE(8411)] = 296777,
  [SMALL_STATE(8412)] = 296787,
  [SMALL_STATE(8413)] = 296797,
  [SMALL_STATE(8414)] = 296807,
  [SMALL_STATE(8415)] = 296817,
  [SMALL_STATE(8416)] = 296827,
  [SMALL_STATE(8417)] = 296837,
  [SMALL_STATE(8418)] = 296847,
  [SMALL_STATE(8419)] = 296857,
  [SMALL_STATE(8420)] = 296867,
  [SMALL_STATE(8421)] = 296877,
  [SMALL_STATE(8422)] = 296887,
  [SMALL_STATE(8423)] = 296897,
  [SMALL_STATE(8424)] = 296907,
  [SMALL_STATE(8425)] = 296915,
  [SMALL_STATE(8426)] = 296925,
  [SMALL_STATE(8427)] = 296935,
  [SMALL_STATE(8428)] = 296945,
  [SMALL_STATE(8429)] = 296955,
  [SMALL_STATE(8430)] = 296965,
  [SMALL_STATE(8431)] = 296975,
  [SMALL_STATE(8432)] = 296985,
  [SMALL_STATE(8433)] = 296995,
  [SMALL_STATE(8434)] = 297003,
  [SMALL_STATE(8435)] = 297013,
  [SMALL_STATE(8436)] = 297023,
  [SMALL_STATE(8437)] = 297033,
  [SMALL_STATE(8438)] = 297041,
  [SMALL_STATE(8439)] = 297051,
  [SMALL_STATE(8440)] = 297061,
  [SMALL_STATE(8441)] = 297071,
  [SMALL_STATE(8442)] = 297081,
  [SMALL_STATE(8443)] = 297091,
  [SMALL_STATE(8444)] = 297101,
  [SMALL_STATE(8445)] = 297111,
  [SMALL_STATE(8446)] = 297121,
  [SMALL_STATE(8447)] = 297131,
  [SMALL_STATE(8448)] = 297141,
  [SMALL_STATE(8449)] = 297151,
  [SMALL_STATE(8450)] = 297159,
  [SMALL_STATE(8451)] = 297169,
  [SMALL_STATE(8452)] = 297179,
  [SMALL_STATE(8453)] = 297189,
  [SMALL_STATE(8454)] = 297199,
  [SMALL_STATE(8455)] = 297209,
  [SMALL_STATE(8456)] = 297219,
  [SMALL_STATE(8457)] = 297229,
  [SMALL_STATE(8458)] = 297239,
  [SMALL_STATE(8459)] = 297249,
  [SMALL_STATE(8460)] = 297259,
  [SMALL_STATE(8461)] = 297269,
  [SMALL_STATE(8462)] = 297279,
  [SMALL_STATE(8463)] = 297287,
  [SMALL_STATE(8464)] = 297297,
  [SMALL_STATE(8465)] = 297307,
  [SMALL_STATE(8466)] = 297317,
  [SMALL_STATE(8467)] = 297327,
  [SMALL_STATE(8468)] = 297337,
  [SMALL_STATE(8469)] = 297347,
  [SMALL_STATE(8470)] = 297357,
  [SMALL_STATE(8471)] = 297367,
  [SMALL_STATE(8472)] = 297377,
  [SMALL_STATE(8473)] = 297387,
  [SMALL_STATE(8474)] = 297395,
  [SMALL_STATE(8475)] = 297405,
  [SMALL_STATE(8476)] = 297415,
  [SMALL_STATE(8477)] = 297423,
  [SMALL_STATE(8478)] = 297433,
  [SMALL_STATE(8479)] = 297443,
  [SMALL_STATE(8480)] = 297453,
  [SMALL_STATE(8481)] = 297463,
  [SMALL_STATE(8482)] = 297473,
  [SMALL_STATE(8483)] = 297483,
  [SMALL_STATE(8484)] = 297491,
  [SMALL_STATE(8485)] = 297501,
  [SMALL_STATE(8486)] = 297509,
  [SMALL_STATE(8487)] = 297519,
  [SMALL_STATE(8488)] = 297529,
  [SMALL_STATE(8489)] = 297539,
  [SMALL_STATE(8490)] = 297549,
  [SMALL_STATE(8491)] = 297559,
  [SMALL_STATE(8492)] = 297569,
  [SMALL_STATE(8493)] = 297579,
  [SMALL_STATE(8494)] = 297589,
  [SMALL_STATE(8495)] = 297599,
  [SMALL_STATE(8496)] = 297609,
  [SMALL_STATE(8497)] = 297619,
  [SMALL_STATE(8498)] = 297629,
  [SMALL_STATE(8499)] = 297639,
  [SMALL_STATE(8500)] = 297649,
  [SMALL_STATE(8501)] = 297659,
  [SMALL_STATE(8502)] = 297669,
  [SMALL_STATE(8503)] = 297679,
  [SMALL_STATE(8504)] = 297689,
  [SMALL_STATE(8505)] = 297699,
  [SMALL_STATE(8506)] = 297709,
  [SMALL_STATE(8507)] = 297719,
  [SMALL_STATE(8508)] = 297729,
  [SMALL_STATE(8509)] = 297739,
  [SMALL_STATE(8510)] = 297749,
  [SMALL_STATE(8511)] = 297759,
  [SMALL_STATE(8512)] = 297769,
  [SMALL_STATE(8513)] = 297779,
  [SMALL_STATE(8514)] = 297789,
  [SMALL_STATE(8515)] = 297797,
  [SMALL_STATE(8516)] = 297807,
  [SMALL_STATE(8517)] = 297817,
  [SMALL_STATE(8518)] = 297827,
  [SMALL_STATE(8519)] = 297837,
  [SMALL_STATE(8520)] = 297847,
  [SMALL_STATE(8521)] = 297857,
  [SMALL_STATE(8522)] = 297867,
  [SMALL_STATE(8523)] = 297877,
  [SMALL_STATE(8524)] = 297887,
  [SMALL_STATE(8525)] = 297897,
  [SMALL_STATE(8526)] = 297905,
  [SMALL_STATE(8527)] = 297915,
  [SMALL_STATE(8528)] = 297923,
  [SMALL_STATE(8529)] = 297933,
  [SMALL_STATE(8530)] = 297941,
  [SMALL_STATE(8531)] = 297951,
  [SMALL_STATE(8532)] = 297961,
  [SMALL_STATE(8533)] = 297969,
  [SMALL_STATE(8534)] = 297977,
  [SMALL_STATE(8535)] = 297985,
  [SMALL_STATE(8536)] = 297995,
  [SMALL_STATE(8537)] = 298003,
  [SMALL_STATE(8538)] = 298013,
  [SMALL_STATE(8539)] = 298023,
  [SMALL_STATE(8540)] = 298033,
  [SMALL_STATE(8541)] = 298043,
  [SMALL_STATE(8542)] = 298051,
  [SMALL_STATE(8543)] = 298061,
  [SMALL_STATE(8544)] = 298069,
  [SMALL_STATE(8545)] = 298077,
  [SMALL_STATE(8546)] = 298087,
  [SMALL_STATE(8547)] = 298097,
  [SMALL_STATE(8548)] = 298105,
  [SMALL_STATE(8549)] = 298115,
  [SMALL_STATE(8550)] = 298123,
  [SMALL_STATE(8551)] = 298133,
  [SMALL_STATE(8552)] = 298143,
  [SMALL_STATE(8553)] = 298151,
  [SMALL_STATE(8554)] = 298159,
  [SMALL_STATE(8555)] = 298169,
  [SMALL_STATE(8556)] = 298177,
  [SMALL_STATE(8557)] = 298187,
  [SMALL_STATE(8558)] = 298197,
  [SMALL_STATE(8559)] = 298207,
  [SMALL_STATE(8560)] = 298217,
  [SMALL_STATE(8561)] = 298225,
  [SMALL_STATE(8562)] = 298235,
  [SMALL_STATE(8563)] = 298245,
  [SMALL_STATE(8564)] = 298255,
  [SMALL_STATE(8565)] = 298265,
  [SMALL_STATE(8566)] = 298275,
  [SMALL_STATE(8567)] = 298285,
  [SMALL_STATE(8568)] = 298295,
  [SMALL_STATE(8569)] = 298305,
  [SMALL_STATE(8570)] = 298315,
  [SMALL_STATE(8571)] = 298325,
  [SMALL_STATE(8572)] = 298335,
  [SMALL_STATE(8573)] = 298345,
  [SMALL_STATE(8574)] = 298355,
  [SMALL_STATE(8575)] = 298365,
  [SMALL_STATE(8576)] = 298375,
  [SMALL_STATE(8577)] = 298385,
  [SMALL_STATE(8578)] = 298395,
  [SMALL_STATE(8579)] = 298405,
  [SMALL_STATE(8580)] = 298415,
  [SMALL_STATE(8581)] = 298425,
  [SMALL_STATE(8582)] = 298435,
  [SMALL_STATE(8583)] = 298445,
  [SMALL_STATE(8584)] = 298453,
  [SMALL_STATE(8585)] = 298463,
  [SMALL_STATE(8586)] = 298473,
  [SMALL_STATE(8587)] = 298483,
  [SMALL_STATE(8588)] = 298493,
  [SMALL_STATE(8589)] = 298503,
  [SMALL_STATE(8590)] = 298513,
  [SMALL_STATE(8591)] = 298523,
  [SMALL_STATE(8592)] = 298533,
  [SMALL_STATE(8593)] = 298543,
  [SMALL_STATE(8594)] = 298553,
  [SMALL_STATE(8595)] = 298563,
  [SMALL_STATE(8596)] = 298573,
  [SMALL_STATE(8597)] = 298583,
  [SMALL_STATE(8598)] = 298593,
  [SMALL_STATE(8599)] = 298603,
  [SMALL_STATE(8600)] = 298613,
  [SMALL_STATE(8601)] = 298623,
  [SMALL_STATE(8602)] = 298633,
  [SMALL_STATE(8603)] = 298643,
  [SMALL_STATE(8604)] = 298653,
  [SMALL_STATE(8605)] = 298663,
  [SMALL_STATE(8606)] = 298673,
  [SMALL_STATE(8607)] = 298683,
  [SMALL_STATE(8608)] = 298693,
  [SMALL_STATE(8609)] = 298703,
  [SMALL_STATE(8610)] = 298713,
  [SMALL_STATE(8611)] = 298723,
  [SMALL_STATE(8612)] = 298733,
  [SMALL_STATE(8613)] = 298743,
  [SMALL_STATE(8614)] = 298753,
  [SMALL_STATE(8615)] = 298763,
  [SMALL_STATE(8616)] = 298773,
  [SMALL_STATE(8617)] = 298783,
  [SMALL_STATE(8618)] = 298793,
  [SMALL_STATE(8619)] = 298803,
  [SMALL_STATE(8620)] = 298813,
  [SMALL_STATE(8621)] = 298823,
  [SMALL_STATE(8622)] = 298833,
  [SMALL_STATE(8623)] = 298843,
  [SMALL_STATE(8624)] = 298853,
  [SMALL_STATE(8625)] = 298863,
  [SMALL_STATE(8626)] = 298873,
  [SMALL_STATE(8627)] = 298883,
  [SMALL_STATE(8628)] = 298893,
  [SMALL_STATE(8629)] = 298903,
  [SMALL_STATE(8630)] = 298913,
  [SMALL_STATE(8631)] = 298923,
  [SMALL_STATE(8632)] = 298933,
  [SMALL_STATE(8633)] = 298943,
  [SMALL_STATE(8634)] = 298953,
  [SMALL_STATE(8635)] = 298963,
  [SMALL_STATE(8636)] = 298971,
  [SMALL_STATE(8637)] = 298981,
  [SMALL_STATE(8638)] = 298989,
  [SMALL_STATE(8639)] = 298999,
  [SMALL_STATE(8640)] = 299009,
  [SMALL_STATE(8641)] = 299019,
  [SMALL_STATE(8642)] = 299029,
  [SMALL_STATE(8643)] = 299037,
  [SMALL_STATE(8644)] = 299047,
  [SMALL_STATE(8645)] = 299057,
  [SMALL_STATE(8646)] = 299067,
  [SMALL_STATE(8647)] = 299077,
  [SMALL_STATE(8648)] = 299087,
  [SMALL_STATE(8649)] = 299097,
  [SMALL_STATE(8650)] = 299107,
  [SMALL_STATE(8651)] = 299117,
  [SMALL_STATE(8652)] = 299127,
  [SMALL_STATE(8653)] = 299137,
  [SMALL_STATE(8654)] = 299147,
  [SMALL_STATE(8655)] = 299157,
  [SMALL_STATE(8656)] = 299167,
  [SMALL_STATE(8657)] = 299177,
  [SMALL_STATE(8658)] = 299187,
  [SMALL_STATE(8659)] = 299197,
  [SMALL_STATE(8660)] = 299207,
  [SMALL_STATE(8661)] = 299217,
  [SMALL_STATE(8662)] = 299227,
  [SMALL_STATE(8663)] = 299237,
  [SMALL_STATE(8664)] = 299245,
  [SMALL_STATE(8665)] = 299255,
  [SMALL_STATE(8666)] = 299265,
  [SMALL_STATE(8667)] = 299275,
  [SMALL_STATE(8668)] = 299285,
  [SMALL_STATE(8669)] = 299295,
  [SMALL_STATE(8670)] = 299305,
  [SMALL_STATE(8671)] = 299315,
  [SMALL_STATE(8672)] = 299325,
  [SMALL_STATE(8673)] = 299335,
  [SMALL_STATE(8674)] = 299345,
  [SMALL_STATE(8675)] = 299355,
  [SMALL_STATE(8676)] = 299365,
  [SMALL_STATE(8677)] = 299375,
  [SMALL_STATE(8678)] = 299385,
  [SMALL_STATE(8679)] = 299395,
  [SMALL_STATE(8680)] = 299405,
  [SMALL_STATE(8681)] = 299415,
  [SMALL_STATE(8682)] = 299425,
  [SMALL_STATE(8683)] = 299435,
  [SMALL_STATE(8684)] = 299445,
  [SMALL_STATE(8685)] = 299455,
  [SMALL_STATE(8686)] = 299463,
  [SMALL_STATE(8687)] = 299473,
  [SMALL_STATE(8688)] = 299483,
  [SMALL_STATE(8689)] = 299493,
  [SMALL_STATE(8690)] = 299503,
  [SMALL_STATE(8691)] = 299513,
  [SMALL_STATE(8692)] = 299523,
  [SMALL_STATE(8693)] = 299533,
  [SMALL_STATE(8694)] = 299543,
  [SMALL_STATE(8695)] = 299553,
  [SMALL_STATE(8696)] = 299563,
  [SMALL_STATE(8697)] = 299573,
  [SMALL_STATE(8698)] = 299583,
  [SMALL_STATE(8699)] = 299593,
  [SMALL_STATE(8700)] = 299603,
  [SMALL_STATE(8701)] = 299613,
  [SMALL_STATE(8702)] = 299623,
  [SMALL_STATE(8703)] = 299633,
  [SMALL_STATE(8704)] = 299643,
  [SMALL_STATE(8705)] = 299653,
  [SMALL_STATE(8706)] = 299663,
  [SMALL_STATE(8707)] = 299673,
  [SMALL_STATE(8708)] = 299683,
  [SMALL_STATE(8709)] = 299693,
  [SMALL_STATE(8710)] = 299703,
  [SMALL_STATE(8711)] = 299713,
  [SMALL_STATE(8712)] = 299723,
  [SMALL_STATE(8713)] = 299733,
  [SMALL_STATE(8714)] = 299743,
  [SMALL_STATE(8715)] = 299753,
  [SMALL_STATE(8716)] = 299763,
  [SMALL_STATE(8717)] = 299773,
  [SMALL_STATE(8718)] = 299783,
  [SMALL_STATE(8719)] = 299793,
  [SMALL_STATE(8720)] = 299803,
  [SMALL_STATE(8721)] = 299813,
  [SMALL_STATE(8722)] = 299823,
  [SMALL_STATE(8723)] = 299833,
  [SMALL_STATE(8724)] = 299841,
  [SMALL_STATE(8725)] = 299851,
  [SMALL_STATE(8726)] = 299861,
  [SMALL_STATE(8727)] = 299871,
  [SMALL_STATE(8728)] = 299881,
  [SMALL_STATE(8729)] = 299891,
  [SMALL_STATE(8730)] = 299901,
  [SMALL_STATE(8731)] = 299911,
  [SMALL_STATE(8732)] = 299921,
  [SMALL_STATE(8733)] = 299931,
  [SMALL_STATE(8734)] = 299941,
  [SMALL_STATE(8735)] = 299951,
  [SMALL_STATE(8736)] = 299961,
  [SMALL_STATE(8737)] = 299971,
  [SMALL_STATE(8738)] = 299981,
  [SMALL_STATE(8739)] = 299991,
  [SMALL_STATE(8740)] = 300001,
  [SMALL_STATE(8741)] = 300011,
  [SMALL_STATE(8742)] = 300021,
  [SMALL_STATE(8743)] = 300031,
  [SMALL_STATE(8744)] = 300041,
  [SMALL_STATE(8745)] = 300051,
  [SMALL_STATE(8746)] = 300061,
  [SMALL_STATE(8747)] = 300071,
  [SMALL_STATE(8748)] = 300081,
  [SMALL_STATE(8749)] = 300091,
  [SMALL_STATE(8750)] = 300101,
  [SMALL_STATE(8751)] = 300111,
  [SMALL_STATE(8752)] = 300121,
  [SMALL_STATE(8753)] = 300131,
  [SMALL_STATE(8754)] = 300141,
  [SMALL_STATE(8755)] = 300151,
  [SMALL_STATE(8756)] = 300161,
  [SMALL_STATE(8757)] = 300171,
  [SMALL_STATE(8758)] = 300181,
  [SMALL_STATE(8759)] = 300191,
  [SMALL_STATE(8760)] = 300201,
  [SMALL_STATE(8761)] = 300211,
  [SMALL_STATE(8762)] = 300221,
  [SMALL_STATE(8763)] = 300231,
  [SMALL_STATE(8764)] = 300241,
  [SMALL_STATE(8765)] = 300251,
  [SMALL_STATE(8766)] = 300261,
  [SMALL_STATE(8767)] = 300271,
  [SMALL_STATE(8768)] = 300281,
  [SMALL_STATE(8769)] = 300291,
  [SMALL_STATE(8770)] = 300301,
  [SMALL_STATE(8771)] = 300311,
  [SMALL_STATE(8772)] = 300321,
  [SMALL_STATE(8773)] = 300331,
  [SMALL_STATE(8774)] = 300341,
  [SMALL_STATE(8775)] = 300351,
  [SMALL_STATE(8776)] = 300361,
  [SMALL_STATE(8777)] = 300369,
  [SMALL_STATE(8778)] = 300377,
  [SMALL_STATE(8779)] = 300387,
  [SMALL_STATE(8780)] = 300397,
  [SMALL_STATE(8781)] = 300407,
  [SMALL_STATE(8782)] = 300417,
  [SMALL_STATE(8783)] = 300427,
  [SMALL_STATE(8784)] = 300437,
  [SMALL_STATE(8785)] = 300447,
  [SMALL_STATE(8786)] = 300457,
  [SMALL_STATE(8787)] = 300464,
  [SMALL_STATE(8788)] = 300471,
  [SMALL_STATE(8789)] = 300478,
  [SMALL_STATE(8790)] = 300485,
  [SMALL_STATE(8791)] = 300492,
  [SMALL_STATE(8792)] = 300499,
  [SMALL_STATE(8793)] = 300506,
  [SMALL_STATE(8794)] = 300513,
  [SMALL_STATE(8795)] = 300520,
  [SMALL_STATE(8796)] = 300527,
  [SMALL_STATE(8797)] = 300534,
  [SMALL_STATE(8798)] = 300541,
  [SMALL_STATE(8799)] = 300548,
  [SMALL_STATE(8800)] = 300555,
  [SMALL_STATE(8801)] = 300562,
  [SMALL_STATE(8802)] = 300569,
  [SMALL_STATE(8803)] = 300576,
  [SMALL_STATE(8804)] = 300583,
  [SMALL_STATE(8805)] = 300590,
  [SMALL_STATE(8806)] = 300597,
  [SMALL_STATE(8807)] = 300604,
  [SMALL_STATE(8808)] = 300611,
  [SMALL_STATE(8809)] = 300618,
  [SMALL_STATE(8810)] = 300625,
  [SMALL_STATE(8811)] = 300632,
  [SMALL_STATE(8812)] = 300639,
  [SMALL_STATE(8813)] = 300646,
  [SMALL_STATE(8814)] = 300653,
  [SMALL_STATE(8815)] = 300660,
  [SMALL_STATE(8816)] = 300667,
  [SMALL_STATE(8817)] = 300674,
  [SMALL_STATE(8818)] = 300681,
  [SMALL_STATE(8819)] = 300688,
  [SMALL_STATE(8820)] = 300695,
  [SMALL_STATE(8821)] = 300702,
  [SMALL_STATE(8822)] = 300709,
  [SMALL_STATE(8823)] = 300716,
  [SMALL_STATE(8824)] = 300723,
  [SMALL_STATE(8825)] = 300730,
  [SMALL_STATE(8826)] = 300737,
  [SMALL_STATE(8827)] = 300744,
  [SMALL_STATE(8828)] = 300751,
  [SMALL_STATE(8829)] = 300758,
  [SMALL_STATE(8830)] = 300765,
  [SMALL_STATE(8831)] = 300772,
  [SMALL_STATE(8832)] = 300779,
  [SMALL_STATE(8833)] = 300786,
  [SMALL_STATE(8834)] = 300793,
  [SMALL_STATE(8835)] = 300800,
  [SMALL_STATE(8836)] = 300807,
  [SMALL_STATE(8837)] = 300814,
  [SMALL_STATE(8838)] = 300821,
  [SMALL_STATE(8839)] = 300828,
  [SMALL_STATE(8840)] = 300835,
  [SMALL_STATE(8841)] = 300842,
  [SMALL_STATE(8842)] = 300849,
  [SMALL_STATE(8843)] = 300856,
  [SMALL_STATE(8844)] = 300863,
  [SMALL_STATE(8845)] = 300870,
  [SMALL_STATE(8846)] = 300877,
  [SMALL_STATE(8847)] = 300884,
  [SMALL_STATE(8848)] = 300891,
  [SMALL_STATE(8849)] = 300898,
  [SMALL_STATE(8850)] = 300905,
  [SMALL_STATE(8851)] = 300912,
  [SMALL_STATE(8852)] = 300919,
  [SMALL_STATE(8853)] = 300926,
  [SMALL_STATE(8854)] = 300933,
  [SMALL_STATE(8855)] = 300940,
  [SMALL_STATE(8856)] = 300947,
  [SMALL_STATE(8857)] = 300954,
  [SMALL_STATE(8858)] = 300961,
  [SMALL_STATE(8859)] = 300968,
  [SMALL_STATE(8860)] = 300975,
  [SMALL_STATE(8861)] = 300982,
  [SMALL_STATE(8862)] = 300989,
  [SMALL_STATE(8863)] = 300996,
  [SMALL_STATE(8864)] = 301003,
  [SMALL_STATE(8865)] = 301010,
  [SMALL_STATE(8866)] = 301017,
  [SMALL_STATE(8867)] = 301024,
  [SMALL_STATE(8868)] = 301031,
  [SMALL_STATE(8869)] = 301038,
  [SMALL_STATE(8870)] = 301045,
  [SMALL_STATE(8871)] = 301052,
  [SMALL_STATE(8872)] = 301059,
  [SMALL_STATE(8873)] = 301066,
  [SMALL_STATE(8874)] = 301073,
  [SMALL_STATE(8875)] = 301080,
  [SMALL_STATE(8876)] = 301087,
  [SMALL_STATE(8877)] = 301094,
  [SMALL_STATE(8878)] = 301101,
  [SMALL_STATE(8879)] = 301108,
  [SMALL_STATE(8880)] = 301115,
  [SMALL_STATE(8881)] = 301122,
  [SMALL_STATE(8882)] = 301129,
  [SMALL_STATE(8883)] = 301136,
  [SMALL_STATE(8884)] = 301143,
  [SMALL_STATE(8885)] = 301150,
  [SMALL_STATE(8886)] = 301157,
  [SMALL_STATE(8887)] = 301164,
  [SMALL_STATE(8888)] = 301171,
  [SMALL_STATE(8889)] = 301178,
  [SMALL_STATE(8890)] = 301185,
  [SMALL_STATE(8891)] = 301192,
  [SMALL_STATE(8892)] = 301199,
  [SMALL_STATE(8893)] = 301206,
  [SMALL_STATE(8894)] = 301213,
  [SMALL_STATE(8895)] = 301220,
  [SMALL_STATE(8896)] = 301227,
  [SMALL_STATE(8897)] = 301234,
  [SMALL_STATE(8898)] = 301241,
  [SMALL_STATE(8899)] = 301248,
  [SMALL_STATE(8900)] = 301255,
  [SMALL_STATE(8901)] = 301262,
  [SMALL_STATE(8902)] = 301269,
  [SMALL_STATE(8903)] = 301276,
  [SMALL_STATE(8904)] = 301283,
  [SMALL_STATE(8905)] = 301290,
  [SMALL_STATE(8906)] = 301297,
  [SMALL_STATE(8907)] = 301304,
  [SMALL_STATE(8908)] = 301311,
  [SMALL_STATE(8909)] = 301318,
  [SMALL_STATE(8910)] = 301325,
  [SMALL_STATE(8911)] = 301332,
  [SMALL_STATE(8912)] = 301339,
  [SMALL_STATE(8913)] = 301346,
  [SMALL_STATE(8914)] = 301353,
  [SMALL_STATE(8915)] = 301360,
  [SMALL_STATE(8916)] = 301367,
  [SMALL_STATE(8917)] = 301374,
  [SMALL_STATE(8918)] = 301381,
  [SMALL_STATE(8919)] = 301388,
  [SMALL_STATE(8920)] = 301395,
  [SMALL_STATE(8921)] = 301402,
  [SMALL_STATE(8922)] = 301409,
  [SMALL_STATE(8923)] = 301416,
  [SMALL_STATE(8924)] = 301423,
  [SMALL_STATE(8925)] = 301430,
  [SMALL_STATE(8926)] = 301437,
  [SMALL_STATE(8927)] = 301444,
  [SMALL_STATE(8928)] = 301451,
  [SMALL_STATE(8929)] = 301458,
  [SMALL_STATE(8930)] = 301465,
  [SMALL_STATE(8931)] = 301472,
  [SMALL_STATE(8932)] = 301479,
  [SMALL_STATE(8933)] = 301486,
  [SMALL_STATE(8934)] = 301493,
  [SMALL_STATE(8935)] = 301500,
  [SMALL_STATE(8936)] = 301507,
  [SMALL_STATE(8937)] = 301514,
  [SMALL_STATE(8938)] = 301521,
  [SMALL_STATE(8939)] = 301528,
  [SMALL_STATE(8940)] = 301535,
  [SMALL_STATE(8941)] = 301542,
  [SMALL_STATE(8942)] = 301549,
  [SMALL_STATE(8943)] = 301556,
  [SMALL_STATE(8944)] = 301563,
  [SMALL_STATE(8945)] = 301570,
  [SMALL_STATE(8946)] = 301577,
  [SMALL_STATE(8947)] = 301584,
  [SMALL_STATE(8948)] = 301591,
  [SMALL_STATE(8949)] = 301598,
  [SMALL_STATE(8950)] = 301605,
  [SMALL_STATE(8951)] = 301612,
  [SMALL_STATE(8952)] = 301619,
  [SMALL_STATE(8953)] = 301626,
  [SMALL_STATE(8954)] = 301633,
  [SMALL_STATE(8955)] = 301640,
  [SMALL_STATE(8956)] = 301647,
  [SMALL_STATE(8957)] = 301654,
  [SMALL_STATE(8958)] = 301661,
  [SMALL_STATE(8959)] = 301668,
  [SMALL_STATE(8960)] = 301675,
  [SMALL_STATE(8961)] = 301682,
  [SMALL_STATE(8962)] = 301689,
  [SMALL_STATE(8963)] = 301696,
  [SMALL_STATE(8964)] = 301703,
  [SMALL_STATE(8965)] = 301710,
  [SMALL_STATE(8966)] = 301717,
  [SMALL_STATE(8967)] = 301724,
  [SMALL_STATE(8968)] = 301731,
  [SMALL_STATE(8969)] = 301738,
  [SMALL_STATE(8970)] = 301745,
  [SMALL_STATE(8971)] = 301752,
  [SMALL_STATE(8972)] = 301759,
  [SMALL_STATE(8973)] = 301766,
  [SMALL_STATE(8974)] = 301773,
  [SMALL_STATE(8975)] = 301780,
  [SMALL_STATE(8976)] = 301787,
  [SMALL_STATE(8977)] = 301794,
  [SMALL_STATE(8978)] = 301801,
  [SMALL_STATE(8979)] = 301808,
  [SMALL_STATE(8980)] = 301815,
  [SMALL_STATE(8981)] = 301822,
  [SMALL_STATE(8982)] = 301829,
  [SMALL_STATE(8983)] = 301836,
  [SMALL_STATE(8984)] = 301843,
  [SMALL_STATE(8985)] = 301850,
  [SMALL_STATE(8986)] = 301857,
  [SMALL_STATE(8987)] = 301864,
  [SMALL_STATE(8988)] = 301871,
  [SMALL_STATE(8989)] = 301878,
  [SMALL_STATE(8990)] = 301885,
  [SMALL_STATE(8991)] = 301892,
  [SMALL_STATE(8992)] = 301899,
  [SMALL_STATE(8993)] = 301906,
  [SMALL_STATE(8994)] = 301913,
  [SMALL_STATE(8995)] = 301920,
  [SMALL_STATE(8996)] = 301927,
  [SMALL_STATE(8997)] = 301934,
  [SMALL_STATE(8998)] = 301941,
  [SMALL_STATE(8999)] = 301948,
  [SMALL_STATE(9000)] = 301955,
  [SMALL_STATE(9001)] = 301962,
  [SMALL_STATE(9002)] = 301969,
  [SMALL_STATE(9003)] = 301976,
  [SMALL_STATE(9004)] = 301983,
  [SMALL_STATE(9005)] = 301990,
  [SMALL_STATE(9006)] = 301997,
  [SMALL_STATE(9007)] = 302004,
  [SMALL_STATE(9008)] = 302011,
  [SMALL_STATE(9009)] = 302018,
  [SMALL_STATE(9010)] = 302025,
  [SMALL_STATE(9011)] = 302032,
  [SMALL_STATE(9012)] = 302039,
  [SMALL_STATE(9013)] = 302046,
  [SMALL_STATE(9014)] = 302053,
  [SMALL_STATE(9015)] = 302060,
  [SMALL_STATE(9016)] = 302067,
  [SMALL_STATE(9017)] = 302074,
  [SMALL_STATE(9018)] = 302081,
  [SMALL_STATE(9019)] = 302088,
  [SMALL_STATE(9020)] = 302095,
  [SMALL_STATE(9021)] = 302102,
  [SMALL_STATE(9022)] = 302109,
  [SMALL_STATE(9023)] = 302116,
  [SMALL_STATE(9024)] = 302123,
  [SMALL_STATE(9025)] = 302130,
  [SMALL_STATE(9026)] = 302137,
  [SMALL_STATE(9027)] = 302144,
  [SMALL_STATE(9028)] = 302151,
  [SMALL_STATE(9029)] = 302158,
  [SMALL_STATE(9030)] = 302165,
  [SMALL_STATE(9031)] = 302172,
  [SMALL_STATE(9032)] = 302179,
  [SMALL_STATE(9033)] = 302186,
  [SMALL_STATE(9034)] = 302193,
  [SMALL_STATE(9035)] = 302200,
  [SMALL_STATE(9036)] = 302207,
  [SMALL_STATE(9037)] = 302214,
  [SMALL_STATE(9038)] = 302221,
  [SMALL_STATE(9039)] = 302228,
  [SMALL_STATE(9040)] = 302235,
  [SMALL_STATE(9041)] = 302242,
  [SMALL_STATE(9042)] = 302249,
  [SMALL_STATE(9043)] = 302256,
  [SMALL_STATE(9044)] = 302263,
  [SMALL_STATE(9045)] = 302270,
  [SMALL_STATE(9046)] = 302277,
  [SMALL_STATE(9047)] = 302284,
  [SMALL_STATE(9048)] = 302291,
  [SMALL_STATE(9049)] = 302298,
  [SMALL_STATE(9050)] = 302305,
  [SMALL_STATE(9051)] = 302312,
  [SMALL_STATE(9052)] = 302319,
  [SMALL_STATE(9053)] = 302326,
  [SMALL_STATE(9054)] = 302333,
  [SMALL_STATE(9055)] = 302340,
  [SMALL_STATE(9056)] = 302347,
  [SMALL_STATE(9057)] = 302354,
  [SMALL_STATE(9058)] = 302361,
  [SMALL_STATE(9059)] = 302368,
  [SMALL_STATE(9060)] = 302375,
  [SMALL_STATE(9061)] = 302382,
  [SMALL_STATE(9062)] = 302389,
  [SMALL_STATE(9063)] = 302396,
  [SMALL_STATE(9064)] = 302403,
  [SMALL_STATE(9065)] = 302410,
  [SMALL_STATE(9066)] = 302417,
  [SMALL_STATE(9067)] = 302424,
  [SMALL_STATE(9068)] = 302431,
  [SMALL_STATE(9069)] = 302438,
  [SMALL_STATE(9070)] = 302445,
  [SMALL_STATE(9071)] = 302452,
  [SMALL_STATE(9072)] = 302459,
  [SMALL_STATE(9073)] = 302466,
  [SMALL_STATE(9074)] = 302473,
  [SMALL_STATE(9075)] = 302480,
  [SMALL_STATE(9076)] = 302487,
  [SMALL_STATE(9077)] = 302494,
  [SMALL_STATE(9078)] = 302501,
  [SMALL_STATE(9079)] = 302508,
  [SMALL_STATE(9080)] = 302515,
  [SMALL_STATE(9081)] = 302522,
  [SMALL_STATE(9082)] = 302529,
  [SMALL_STATE(9083)] = 302536,
  [SMALL_STATE(9084)] = 302543,
  [SMALL_STATE(9085)] = 302550,
  [SMALL_STATE(9086)] = 302557,
  [SMALL_STATE(9087)] = 302564,
  [SMALL_STATE(9088)] = 302571,
  [SMALL_STATE(9089)] = 302578,
  [SMALL_STATE(9090)] = 302585,
  [SMALL_STATE(9091)] = 302592,
  [SMALL_STATE(9092)] = 302599,
  [SMALL_STATE(9093)] = 302606,
  [SMALL_STATE(9094)] = 302613,
  [SMALL_STATE(9095)] = 302620,
  [SMALL_STATE(9096)] = 302627,
  [SMALL_STATE(9097)] = 302634,
  [SMALL_STATE(9098)] = 302641,
  [SMALL_STATE(9099)] = 302648,
  [SMALL_STATE(9100)] = 302655,
  [SMALL_STATE(9101)] = 302662,
  [SMALL_STATE(9102)] = 302669,
  [SMALL_STATE(9103)] = 302676,
  [SMALL_STATE(9104)] = 302683,
  [SMALL_STATE(9105)] = 302690,
  [SMALL_STATE(9106)] = 302697,
  [SMALL_STATE(9107)] = 302704,
  [SMALL_STATE(9108)] = 302711,
  [SMALL_STATE(9109)] = 302718,
  [SMALL_STATE(9110)] = 302725,
  [SMALL_STATE(9111)] = 302732,
  [SMALL_STATE(9112)] = 302739,
  [SMALL_STATE(9113)] = 302746,
  [SMALL_STATE(9114)] = 302753,
  [SMALL_STATE(9115)] = 302760,
  [SMALL_STATE(9116)] = 302767,
  [SMALL_STATE(9117)] = 302774,
  [SMALL_STATE(9118)] = 302781,
  [SMALL_STATE(9119)] = 302788,
  [SMALL_STATE(9120)] = 302795,
  [SMALL_STATE(9121)] = 302802,
  [SMALL_STATE(9122)] = 302809,
  [SMALL_STATE(9123)] = 302816,
  [SMALL_STATE(9124)] = 302823,
  [SMALL_STATE(9125)] = 302830,
  [SMALL_STATE(9126)] = 302837,
  [SMALL_STATE(9127)] = 302844,
  [SMALL_STATE(9128)] = 302851,
  [SMALL_STATE(9129)] = 302858,
  [SMALL_STATE(9130)] = 302865,
  [SMALL_STATE(9131)] = 302872,
  [SMALL_STATE(9132)] = 302879,
  [SMALL_STATE(9133)] = 302886,
  [SMALL_STATE(9134)] = 302893,
  [SMALL_STATE(9135)] = 302900,
  [SMALL_STATE(9136)] = 302907,
  [SMALL_STATE(9137)] = 302914,
  [SMALL_STATE(9138)] = 302921,
  [SMALL_STATE(9139)] = 302928,
  [SMALL_STATE(9140)] = 302935,
  [SMALL_STATE(9141)] = 302942,
  [SMALL_STATE(9142)] = 302949,
  [SMALL_STATE(9143)] = 302956,
  [SMALL_STATE(9144)] = 302963,
  [SMALL_STATE(9145)] = 302970,
  [SMALL_STATE(9146)] = 302977,
  [SMALL_STATE(9147)] = 302984,
  [SMALL_STATE(9148)] = 302991,
  [SMALL_STATE(9149)] = 302998,
  [SMALL_STATE(9150)] = 303005,
  [SMALL_STATE(9151)] = 303012,
  [SMALL_STATE(9152)] = 303019,
  [SMALL_STATE(9153)] = 303026,
  [SMALL_STATE(9154)] = 303033,
  [SMALL_STATE(9155)] = 303040,
  [SMALL_STATE(9156)] = 303047,
  [SMALL_STATE(9157)] = 303054,
  [SMALL_STATE(9158)] = 303061,
  [SMALL_STATE(9159)] = 303068,
  [SMALL_STATE(9160)] = 303075,
  [SMALL_STATE(9161)] = 303082,
  [SMALL_STATE(9162)] = 303089,
  [SMALL_STATE(9163)] = 303096,
  [SMALL_STATE(9164)] = 303103,
  [SMALL_STATE(9165)] = 303110,
  [SMALL_STATE(9166)] = 303117,
  [SMALL_STATE(9167)] = 303124,
  [SMALL_STATE(9168)] = 303131,
  [SMALL_STATE(9169)] = 303138,
  [SMALL_STATE(9170)] = 303145,
  [SMALL_STATE(9171)] = 303152,
  [SMALL_STATE(9172)] = 303159,
  [SMALL_STATE(9173)] = 303166,
  [SMALL_STATE(9174)] = 303173,
  [SMALL_STATE(9175)] = 303180,
  [SMALL_STATE(9176)] = 303187,
  [SMALL_STATE(9177)] = 303194,
  [SMALL_STATE(9178)] = 303201,
  [SMALL_STATE(9179)] = 303208,
  [SMALL_STATE(9180)] = 303215,
  [SMALL_STATE(9181)] = 303222,
  [SMALL_STATE(9182)] = 303229,
  [SMALL_STATE(9183)] = 303236,
  [SMALL_STATE(9184)] = 303243,
  [SMALL_STATE(9185)] = 303250,
  [SMALL_STATE(9186)] = 303257,
  [SMALL_STATE(9187)] = 303264,
  [SMALL_STATE(9188)] = 303271,
  [SMALL_STATE(9189)] = 303278,
  [SMALL_STATE(9190)] = 303285,
  [SMALL_STATE(9191)] = 303292,
  [SMALL_STATE(9192)] = 303299,
  [SMALL_STATE(9193)] = 303306,
  [SMALL_STATE(9194)] = 303313,
  [SMALL_STATE(9195)] = 303320,
  [SMALL_STATE(9196)] = 303327,
  [SMALL_STATE(9197)] = 303334,
  [SMALL_STATE(9198)] = 303341,
  [SMALL_STATE(9199)] = 303348,
  [SMALL_STATE(9200)] = 303355,
  [SMALL_STATE(9201)] = 303362,
  [SMALL_STATE(9202)] = 303369,
  [SMALL_STATE(9203)] = 303376,
  [SMALL_STATE(9204)] = 303383,
  [SMALL_STATE(9205)] = 303390,
  [SMALL_STATE(9206)] = 303397,
  [SMALL_STATE(9207)] = 303404,
  [SMALL_STATE(9208)] = 303411,
  [SMALL_STATE(9209)] = 303418,
  [SMALL_STATE(9210)] = 303425,
  [SMALL_STATE(9211)] = 303432,
  [SMALL_STATE(9212)] = 303439,
  [SMALL_STATE(9213)] = 303446,
  [SMALL_STATE(9214)] = 303453,
  [SMALL_STATE(9215)] = 303460,
  [SMALL_STATE(9216)] = 303467,
  [SMALL_STATE(9217)] = 303474,
  [SMALL_STATE(9218)] = 303481,
  [SMALL_STATE(9219)] = 303488,
  [SMALL_STATE(9220)] = 303495,
  [SMALL_STATE(9221)] = 303502,
  [SMALL_STATE(9222)] = 303509,
  [SMALL_STATE(9223)] = 303516,
  [SMALL_STATE(9224)] = 303523,
  [SMALL_STATE(9225)] = 303530,
  [SMALL_STATE(9226)] = 303537,
  [SMALL_STATE(9227)] = 303544,
  [SMALL_STATE(9228)] = 303551,
  [SMALL_STATE(9229)] = 303558,
  [SMALL_STATE(9230)] = 303565,
  [SMALL_STATE(9231)] = 303572,
  [SMALL_STATE(9232)] = 303579,
  [SMALL_STATE(9233)] = 303586,
  [SMALL_STATE(9234)] = 303593,
  [SMALL_STATE(9235)] = 303600,
  [SMALL_STATE(9236)] = 303607,
  [SMALL_STATE(9237)] = 303614,
  [SMALL_STATE(9238)] = 303621,
  [SMALL_STATE(9239)] = 303628,
  [SMALL_STATE(9240)] = 303635,
  [SMALL_STATE(9241)] = 303642,
  [SMALL_STATE(9242)] = 303649,
  [SMALL_STATE(9243)] = 303656,
  [SMALL_STATE(9244)] = 303663,
  [SMALL_STATE(9245)] = 303670,
  [SMALL_STATE(9246)] = 303677,
  [SMALL_STATE(9247)] = 303684,
  [SMALL_STATE(9248)] = 303691,
  [SMALL_STATE(9249)] = 303698,
  [SMALL_STATE(9250)] = 303705,
  [SMALL_STATE(9251)] = 303712,
  [SMALL_STATE(9252)] = 303719,
  [SMALL_STATE(9253)] = 303726,
  [SMALL_STATE(9254)] = 303733,
  [SMALL_STATE(9255)] = 303740,
  [SMALL_STATE(9256)] = 303747,
  [SMALL_STATE(9257)] = 303754,
  [SMALL_STATE(9258)] = 303761,
  [SMALL_STATE(9259)] = 303768,
  [SMALL_STATE(9260)] = 303775,
  [SMALL_STATE(9261)] = 303782,
  [SMALL_STATE(9262)] = 303789,
  [SMALL_STATE(9263)] = 303796,
  [SMALL_STATE(9264)] = 303803,
  [SMALL_STATE(9265)] = 303810,
  [SMALL_STATE(9266)] = 303817,
  [SMALL_STATE(9267)] = 303824,
  [SMALL_STATE(9268)] = 303831,
  [SMALL_STATE(9269)] = 303838,
  [SMALL_STATE(9270)] = 303845,
  [SMALL_STATE(9271)] = 303852,
  [SMALL_STATE(9272)] = 303859,
  [SMALL_STATE(9273)] = 303866,
  [SMALL_STATE(9274)] = 303873,
  [SMALL_STATE(9275)] = 303880,
  [SMALL_STATE(9276)] = 303887,
  [SMALL_STATE(9277)] = 303894,
  [SMALL_STATE(9278)] = 303901,
  [SMALL_STATE(9279)] = 303908,
  [SMALL_STATE(9280)] = 303915,
  [SMALL_STATE(9281)] = 303922,
  [SMALL_STATE(9282)] = 303929,
  [SMALL_STATE(9283)] = 303936,
  [SMALL_STATE(9284)] = 303943,
  [SMALL_STATE(9285)] = 303950,
  [SMALL_STATE(9286)] = 303957,
  [SMALL_STATE(9287)] = 303964,
  [SMALL_STATE(9288)] = 303971,
  [SMALL_STATE(9289)] = 303978,
  [SMALL_STATE(9290)] = 303985,
  [SMALL_STATE(9291)] = 303992,
  [SMALL_STATE(9292)] = 303999,
  [SMALL_STATE(9293)] = 304006,
  [SMALL_STATE(9294)] = 304013,
  [SMALL_STATE(9295)] = 304020,
  [SMALL_STATE(9296)] = 304027,
  [SMALL_STATE(9297)] = 304034,
  [SMALL_STATE(9298)] = 304041,
  [SMALL_STATE(9299)] = 304048,
  [SMALL_STATE(9300)] = 304055,
  [SMALL_STATE(9301)] = 304062,
  [SMALL_STATE(9302)] = 304069,
  [SMALL_STATE(9303)] = 304076,
  [SMALL_STATE(9304)] = 304083,
  [SMALL_STATE(9305)] = 304090,
  [SMALL_STATE(9306)] = 304097,
  [SMALL_STATE(9307)] = 304104,
  [SMALL_STATE(9308)] = 304111,
  [SMALL_STATE(9309)] = 304118,
  [SMALL_STATE(9310)] = 304125,
  [SMALL_STATE(9311)] = 304132,
  [SMALL_STATE(9312)] = 304139,
  [SMALL_STATE(9313)] = 304146,
  [SMALL_STATE(9314)] = 304153,
  [SMALL_STATE(9315)] = 304160,
  [SMALL_STATE(9316)] = 304167,
  [SMALL_STATE(9317)] = 304174,
  [SMALL_STATE(9318)] = 304181,
  [SMALL_STATE(9319)] = 304188,
  [SMALL_STATE(9320)] = 304195,
  [SMALL_STATE(9321)] = 304202,
  [SMALL_STATE(9322)] = 304209,
  [SMALL_STATE(9323)] = 304216,
  [SMALL_STATE(9324)] = 304223,
  [SMALL_STATE(9325)] = 304230,
  [SMALL_STATE(9326)] = 304237,
  [SMALL_STATE(9327)] = 304244,
  [SMALL_STATE(9328)] = 304251,
  [SMALL_STATE(9329)] = 304258,
  [SMALL_STATE(9330)] = 304265,
  [SMALL_STATE(9331)] = 304272,
  [SMALL_STATE(9332)] = 304279,
  [SMALL_STATE(9333)] = 304286,
  [SMALL_STATE(9334)] = 304293,
  [SMALL_STATE(9335)] = 304300,
  [SMALL_STATE(9336)] = 304307,
  [SMALL_STATE(9337)] = 304314,
  [SMALL_STATE(9338)] = 304321,
  [SMALL_STATE(9339)] = 304328,
  [SMALL_STATE(9340)] = 304335,
  [SMALL_STATE(9341)] = 304342,
  [SMALL_STATE(9342)] = 304349,
  [SMALL_STATE(9343)] = 304356,
  [SMALL_STATE(9344)] = 304363,
  [SMALL_STATE(9345)] = 304370,
  [SMALL_STATE(9346)] = 304377,
  [SMALL_STATE(9347)] = 304384,
  [SMALL_STATE(9348)] = 304391,
  [SMALL_STATE(9349)] = 304398,
  [SMALL_STATE(9350)] = 304405,
  [SMALL_STATE(9351)] = 304412,
  [SMALL_STATE(9352)] = 304419,
  [SMALL_STATE(9353)] = 304426,
  [SMALL_STATE(9354)] = 304433,
  [SMALL_STATE(9355)] = 304440,
  [SMALL_STATE(9356)] = 304447,
  [SMALL_STATE(9357)] = 304454,
  [SMALL_STATE(9358)] = 304461,
  [SMALL_STATE(9359)] = 304468,
  [SMALL_STATE(9360)] = 304475,
  [SMALL_STATE(9361)] = 304482,
  [SMALL_STATE(9362)] = 304489,
  [SMALL_STATE(9363)] = 304496,
  [SMALL_STATE(9364)] = 304503,
  [SMALL_STATE(9365)] = 304510,
  [SMALL_STATE(9366)] = 304517,
  [SMALL_STATE(9367)] = 304524,
  [SMALL_STATE(9368)] = 304531,
  [SMALL_STATE(9369)] = 304538,
  [SMALL_STATE(9370)] = 304545,
  [SMALL_STATE(9371)] = 304552,
  [SMALL_STATE(9372)] = 304559,
  [SMALL_STATE(9373)] = 304566,
  [SMALL_STATE(9374)] = 304573,
  [SMALL_STATE(9375)] = 304580,
  [SMALL_STATE(9376)] = 304587,
  [SMALL_STATE(9377)] = 304594,
  [SMALL_STATE(9378)] = 304601,
  [SMALL_STATE(9379)] = 304608,
  [SMALL_STATE(9380)] = 304615,
  [SMALL_STATE(9381)] = 304622,
  [SMALL_STATE(9382)] = 304629,
  [SMALL_STATE(9383)] = 304636,
  [SMALL_STATE(9384)] = 304643,
  [SMALL_STATE(9385)] = 304650,
  [SMALL_STATE(9386)] = 304657,
  [SMALL_STATE(9387)] = 304664,
  [SMALL_STATE(9388)] = 304671,
  [SMALL_STATE(9389)] = 304678,
  [SMALL_STATE(9390)] = 304685,
  [SMALL_STATE(9391)] = 304692,
  [SMALL_STATE(9392)] = 304699,
  [SMALL_STATE(9393)] = 304706,
  [SMALL_STATE(9394)] = 304713,
  [SMALL_STATE(9395)] = 304720,
  [SMALL_STATE(9396)] = 304727,
  [SMALL_STATE(9397)] = 304734,
  [SMALL_STATE(9398)] = 304741,
  [SMALL_STATE(9399)] = 304748,
  [SMALL_STATE(9400)] = 304755,
  [SMALL_STATE(9401)] = 304762,
  [SMALL_STATE(9402)] = 304769,
  [SMALL_STATE(9403)] = 304776,
  [SMALL_STATE(9404)] = 304783,
  [SMALL_STATE(9405)] = 304790,
  [SMALL_STATE(9406)] = 304797,
  [SMALL_STATE(9407)] = 304804,
  [SMALL_STATE(9408)] = 304811,
  [SMALL_STATE(9409)] = 304818,
  [SMALL_STATE(9410)] = 304825,
  [SMALL_STATE(9411)] = 304832,
  [SMALL_STATE(9412)] = 304839,
  [SMALL_STATE(9413)] = 304846,
  [SMALL_STATE(9414)] = 304853,
  [SMALL_STATE(9415)] = 304860,
  [SMALL_STATE(9416)] = 304867,
  [SMALL_STATE(9417)] = 304874,
  [SMALL_STATE(9418)] = 304881,
  [SMALL_STATE(9419)] = 304888,
  [SMALL_STATE(9420)] = 304895,
  [SMALL_STATE(9421)] = 304902,
  [SMALL_STATE(9422)] = 304909,
  [SMALL_STATE(9423)] = 304916,
  [SMALL_STATE(9424)] = 304923,
  [SMALL_STATE(9425)] = 304930,
  [SMALL_STATE(9426)] = 304937,
  [SMALL_STATE(9427)] = 304944,
  [SMALL_STATE(9428)] = 304951,
  [SMALL_STATE(9429)] = 304958,
  [SMALL_STATE(9430)] = 304965,
  [SMALL_STATE(9431)] = 304972,
  [SMALL_STATE(9432)] = 304979,
  [SMALL_STATE(9433)] = 304986,
  [SMALL_STATE(9434)] = 304993,
  [SMALL_STATE(9435)] = 305000,
  [SMALL_STATE(9436)] = 305007,
  [SMALL_STATE(9437)] = 305014,
  [SMALL_STATE(9438)] = 305021,
  [SMALL_STATE(9439)] = 305028,
  [SMALL_STATE(9440)] = 305035,
  [SMALL_STATE(9441)] = 305042,
  [SMALL_STATE(9442)] = 305049,
  [SMALL_STATE(9443)] = 305056,
  [SMALL_STATE(9444)] = 305063,
  [SMALL_STATE(9445)] = 305070,
  [SMALL_STATE(9446)] = 305077,
  [SMALL_STATE(9447)] = 305084,
  [SMALL_STATE(9448)] = 305091,
  [SMALL_STATE(9449)] = 305098,
  [SMALL_STATE(9450)] = 305105,
  [SMALL_STATE(9451)] = 305112,
  [SMALL_STATE(9452)] = 305119,
  [SMALL_STATE(9453)] = 305126,
  [SMALL_STATE(9454)] = 305133,
  [SMALL_STATE(9455)] = 305140,
  [SMALL_STATE(9456)] = 305147,
  [SMALL_STATE(9457)] = 305154,
  [SMALL_STATE(9458)] = 305161,
  [SMALL_STATE(9459)] = 305168,
  [SMALL_STATE(9460)] = 305175,
  [SMALL_STATE(9461)] = 305182,
  [SMALL_STATE(9462)] = 305189,
  [SMALL_STATE(9463)] = 305196,
  [SMALL_STATE(9464)] = 305203,
  [SMALL_STATE(9465)] = 305210,
  [SMALL_STATE(9466)] = 305217,
  [SMALL_STATE(9467)] = 305224,
  [SMALL_STATE(9468)] = 305231,
  [SMALL_STATE(9469)] = 305238,
  [SMALL_STATE(9470)] = 305245,
  [SMALL_STATE(9471)] = 305252,
  [SMALL_STATE(9472)] = 305259,
  [SMALL_STATE(9473)] = 305266,
  [SMALL_STATE(9474)] = 305273,
  [SMALL_STATE(9475)] = 305280,
  [SMALL_STATE(9476)] = 305287,
  [SMALL_STATE(9477)] = 305294,
  [SMALL_STATE(9478)] = 305301,
  [SMALL_STATE(9479)] = 305308,
  [SMALL_STATE(9480)] = 305315,
  [SMALL_STATE(9481)] = 305322,
  [SMALL_STATE(9482)] = 305329,
  [SMALL_STATE(9483)] = 305336,
  [SMALL_STATE(9484)] = 305343,
  [SMALL_STATE(9485)] = 305350,
  [SMALL_STATE(9486)] = 305357,
  [SMALL_STATE(9487)] = 305364,
  [SMALL_STATE(9488)] = 305371,
  [SMALL_STATE(9489)] = 305378,
  [SMALL_STATE(9490)] = 305385,
  [SMALL_STATE(9491)] = 305392,
  [SMALL_STATE(9492)] = 305399,
  [SMALL_STATE(9493)] = 305406,
  [SMALL_STATE(9494)] = 305413,
  [SMALL_STATE(9495)] = 305420,
  [SMALL_STATE(9496)] = 305427,
  [SMALL_STATE(9497)] = 305434,
  [SMALL_STATE(9498)] = 305441,
  [SMALL_STATE(9499)] = 305448,
  [SMALL_STATE(9500)] = 305455,
  [SMALL_STATE(9501)] = 305462,
  [SMALL_STATE(9502)] = 305469,
  [SMALL_STATE(9503)] = 305476,
  [SMALL_STATE(9504)] = 305483,
  [SMALL_STATE(9505)] = 305490,
  [SMALL_STATE(9506)] = 305497,
  [SMALL_STATE(9507)] = 305504,
  [SMALL_STATE(9508)] = 305511,
  [SMALL_STATE(9509)] = 305518,
  [SMALL_STATE(9510)] = 305525,
  [SMALL_STATE(9511)] = 305532,
  [SMALL_STATE(9512)] = 305539,
  [SMALL_STATE(9513)] = 305546,
  [SMALL_STATE(9514)] = 305553,
  [SMALL_STATE(9515)] = 305560,
  [SMALL_STATE(9516)] = 305567,
  [SMALL_STATE(9517)] = 305574,
  [SMALL_STATE(9518)] = 305581,
  [SMALL_STATE(9519)] = 305588,
  [SMALL_STATE(9520)] = 305595,
  [SMALL_STATE(9521)] = 305602,
  [SMALL_STATE(9522)] = 305609,
  [SMALL_STATE(9523)] = 305616,
  [SMALL_STATE(9524)] = 305623,
  [SMALL_STATE(9525)] = 305630,
  [SMALL_STATE(9526)] = 305637,
  [SMALL_STATE(9527)] = 305644,
  [SMALL_STATE(9528)] = 305651,
  [SMALL_STATE(9529)] = 305658,
  [SMALL_STATE(9530)] = 305665,
  [SMALL_STATE(9531)] = 305672,
  [SMALL_STATE(9532)] = 305679,
  [SMALL_STATE(9533)] = 305686,
  [SMALL_STATE(9534)] = 305693,
  [SMALL_STATE(9535)] = 305700,
  [SMALL_STATE(9536)] = 305707,
  [SMALL_STATE(9537)] = 305714,
  [SMALL_STATE(9538)] = 305721,
  [SMALL_STATE(9539)] = 305728,
  [SMALL_STATE(9540)] = 305735,
  [SMALL_STATE(9541)] = 305742,
  [SMALL_STATE(9542)] = 305749,
  [SMALL_STATE(9543)] = 305756,
  [SMALL_STATE(9544)] = 305763,
  [SMALL_STATE(9545)] = 305770,
  [SMALL_STATE(9546)] = 305777,
  [SMALL_STATE(9547)] = 305784,
  [SMALL_STATE(9548)] = 305791,
  [SMALL_STATE(9549)] = 305798,
  [SMALL_STATE(9550)] = 305805,
  [SMALL_STATE(9551)] = 305812,
  [SMALL_STATE(9552)] = 305819,
  [SMALL_STATE(9553)] = 305826,
  [SMALL_STATE(9554)] = 305833,
  [SMALL_STATE(9555)] = 305840,
  [SMALL_STATE(9556)] = 305847,
  [SMALL_STATE(9557)] = 305854,
  [SMALL_STATE(9558)] = 305861,
  [SMALL_STATE(9559)] = 305868,
  [SMALL_STATE(9560)] = 305875,
  [SMALL_STATE(9561)] = 305882,
  [SMALL_STATE(9562)] = 305889,
  [SMALL_STATE(9563)] = 305896,
  [SMALL_STATE(9564)] = 305903,
  [SMALL_STATE(9565)] = 305910,
  [SMALL_STATE(9566)] = 305917,
  [SMALL_STATE(9567)] = 305924,
  [SMALL_STATE(9568)] = 305931,
  [SMALL_STATE(9569)] = 305938,
  [SMALL_STATE(9570)] = 305945,
  [SMALL_STATE(9571)] = 305952,
  [SMALL_STATE(9572)] = 305959,
  [SMALL_STATE(9573)] = 305966,
  [SMALL_STATE(9574)] = 305973,
  [SMALL_STATE(9575)] = 305980,
  [SMALL_STATE(9576)] = 305987,
  [SMALL_STATE(9577)] = 305994,
  [SMALL_STATE(9578)] = 306001,
  [SMALL_STATE(9579)] = 306008,
  [SMALL_STATE(9580)] = 306015,
  [SMALL_STATE(9581)] = 306022,
  [SMALL_STATE(9582)] = 306029,
  [SMALL_STATE(9583)] = 306036,
  [SMALL_STATE(9584)] = 306043,
  [SMALL_STATE(9585)] = 306050,
  [SMALL_STATE(9586)] = 306057,
  [SMALL_STATE(9587)] = 306064,
  [SMALL_STATE(9588)] = 306071,
  [SMALL_STATE(9589)] = 306078,
  [SMALL_STATE(9590)] = 306085,
  [SMALL_STATE(9591)] = 306092,
  [SMALL_STATE(9592)] = 306099,
  [SMALL_STATE(9593)] = 306106,
  [SMALL_STATE(9594)] = 306113,
  [SMALL_STATE(9595)] = 306120,
  [SMALL_STATE(9596)] = 306127,
  [SMALL_STATE(9597)] = 306134,
  [SMALL_STATE(9598)] = 306141,
  [SMALL_STATE(9599)] = 306148,
  [SMALL_STATE(9600)] = 306155,
  [SMALL_STATE(9601)] = 306162,
  [SMALL_STATE(9602)] = 306169,
  [SMALL_STATE(9603)] = 306176,
  [SMALL_STATE(9604)] = 306183,
  [SMALL_STATE(9605)] = 306190,
  [SMALL_STATE(9606)] = 306197,
  [SMALL_STATE(9607)] = 306204,
  [SMALL_STATE(9608)] = 306211,
  [SMALL_STATE(9609)] = 306218,
  [SMALL_STATE(9610)] = 306225,
  [SMALL_STATE(9611)] = 306232,
  [SMALL_STATE(9612)] = 306239,
  [SMALL_STATE(9613)] = 306246,
  [SMALL_STATE(9614)] = 306253,
  [SMALL_STATE(9615)] = 306260,
  [SMALL_STATE(9616)] = 306267,
  [SMALL_STATE(9617)] = 306274,
  [SMALL_STATE(9618)] = 306281,
  [SMALL_STATE(9619)] = 306288,
  [SMALL_STATE(9620)] = 306295,
  [SMALL_STATE(9621)] = 306302,
  [SMALL_STATE(9622)] = 306309,
  [SMALL_STATE(9623)] = 306316,
  [SMALL_STATE(9624)] = 306323,
  [SMALL_STATE(9625)] = 306330,
  [SMALL_STATE(9626)] = 306337,
  [SMALL_STATE(9627)] = 306344,
  [SMALL_STATE(9628)] = 306351,
  [SMALL_STATE(9629)] = 306358,
  [SMALL_STATE(9630)] = 306365,
  [SMALL_STATE(9631)] = 306372,
  [SMALL_STATE(9632)] = 306379,
  [SMALL_STATE(9633)] = 306386,
  [SMALL_STATE(9634)] = 306393,
  [SMALL_STATE(9635)] = 306400,
  [SMALL_STATE(9636)] = 306407,
  [SMALL_STATE(9637)] = 306414,
  [SMALL_STATE(9638)] = 306421,
  [SMALL_STATE(9639)] = 306428,
  [SMALL_STATE(9640)] = 306435,
  [SMALL_STATE(9641)] = 306442,
  [SMALL_STATE(9642)] = 306449,
  [SMALL_STATE(9643)] = 306456,
  [SMALL_STATE(9644)] = 306463,
  [SMALL_STATE(9645)] = 306470,
  [SMALL_STATE(9646)] = 306477,
  [SMALL_STATE(9647)] = 306484,
  [SMALL_STATE(9648)] = 306491,
  [SMALL_STATE(9649)] = 306498,
  [SMALL_STATE(9650)] = 306505,
  [SMALL_STATE(9651)] = 306512,
  [SMALL_STATE(9652)] = 306519,
  [SMALL_STATE(9653)] = 306526,
  [SMALL_STATE(9654)] = 306533,
  [SMALL_STATE(9655)] = 306540,
  [SMALL_STATE(9656)] = 306547,
  [SMALL_STATE(9657)] = 306554,
  [SMALL_STATE(9658)] = 306561,
  [SMALL_STATE(9659)] = 306568,
  [SMALL_STATE(9660)] = 306575,
  [SMALL_STATE(9661)] = 306582,
  [SMALL_STATE(9662)] = 306589,
  [SMALL_STATE(9663)] = 306596,
  [SMALL_STATE(9664)] = 306603,
  [SMALL_STATE(9665)] = 306610,
  [SMALL_STATE(9666)] = 306617,
  [SMALL_STATE(9667)] = 306624,
  [SMALL_STATE(9668)] = 306631,
  [SMALL_STATE(9669)] = 306638,
  [SMALL_STATE(9670)] = 306645,
  [SMALL_STATE(9671)] = 306652,
  [SMALL_STATE(9672)] = 306659,
  [SMALL_STATE(9673)] = 306666,
  [SMALL_STATE(9674)] = 306673,
  [SMALL_STATE(9675)] = 306680,
  [SMALL_STATE(9676)] = 306687,
  [SMALL_STATE(9677)] = 306694,
  [SMALL_STATE(9678)] = 306701,
  [SMALL_STATE(9679)] = 306708,
  [SMALL_STATE(9680)] = 306715,
  [SMALL_STATE(9681)] = 306722,
  [SMALL_STATE(9682)] = 306729,
  [SMALL_STATE(9683)] = 306736,
  [SMALL_STATE(9684)] = 306743,
  [SMALL_STATE(9685)] = 306750,
  [SMALL_STATE(9686)] = 306757,
  [SMALL_STATE(9687)] = 306764,
  [SMALL_STATE(9688)] = 306771,
  [SMALL_STATE(9689)] = 306778,
  [SMALL_STATE(9690)] = 306785,
  [SMALL_STATE(9691)] = 306792,
  [SMALL_STATE(9692)] = 306799,
  [SMALL_STATE(9693)] = 306806,
  [SMALL_STATE(9694)] = 306813,
  [SMALL_STATE(9695)] = 306820,
  [SMALL_STATE(9696)] = 306827,
  [SMALL_STATE(9697)] = 306834,
  [SMALL_STATE(9698)] = 306841,
  [SMALL_STATE(9699)] = 306848,
  [SMALL_STATE(9700)] = 306855,
  [SMALL_STATE(9701)] = 306862,
  [SMALL_STATE(9702)] = 306869,
  [SMALL_STATE(9703)] = 306876,
  [SMALL_STATE(9704)] = 306883,
  [SMALL_STATE(9705)] = 306890,
  [SMALL_STATE(9706)] = 306897,
  [SMALL_STATE(9707)] = 306904,
  [SMALL_STATE(9708)] = 306911,
  [SMALL_STATE(9709)] = 306918,
  [SMALL_STATE(9710)] = 306925,
  [SMALL_STATE(9711)] = 306932,
  [SMALL_STATE(9712)] = 306939,
  [SMALL_STATE(9713)] = 306946,
  [SMALL_STATE(9714)] = 306953,
  [SMALL_STATE(9715)] = 306960,
  [SMALL_STATE(9716)] = 306967,
  [SMALL_STATE(9717)] = 306974,
  [SMALL_STATE(9718)] = 306981,
  [SMALL_STATE(9719)] = 306988,
  [SMALL_STATE(9720)] = 306995,
  [SMALL_STATE(9721)] = 307002,
  [SMALL_STATE(9722)] = 307009,
  [SMALL_STATE(9723)] = 307016,
  [SMALL_STATE(9724)] = 307023,
  [SMALL_STATE(9725)] = 307030,
  [SMALL_STATE(9726)] = 307037,
  [SMALL_STATE(9727)] = 307044,
  [SMALL_STATE(9728)] = 307051,
  [SMALL_STATE(9729)] = 307058,
  [SMALL_STATE(9730)] = 307065,
  [SMALL_STATE(9731)] = 307072,
  [SMALL_STATE(9732)] = 307079,
  [SMALL_STATE(9733)] = 307086,
  [SMALL_STATE(9734)] = 307093,
  [SMALL_STATE(9735)] = 307100,
  [SMALL_STATE(9736)] = 307107,
  [SMALL_STATE(9737)] = 307114,
  [SMALL_STATE(9738)] = 307121,
  [SMALL_STATE(9739)] = 307128,
  [SMALL_STATE(9740)] = 307135,
  [SMALL_STATE(9741)] = 307142,
  [SMALL_STATE(9742)] = 307149,
  [SMALL_STATE(9743)] = 307156,
  [SMALL_STATE(9744)] = 307163,
  [SMALL_STATE(9745)] = 307170,
  [SMALL_STATE(9746)] = 307177,
  [SMALL_STATE(9747)] = 307184,
  [SMALL_STATE(9748)] = 307191,
  [SMALL_STATE(9749)] = 307198,
  [SMALL_STATE(9750)] = 307205,
  [SMALL_STATE(9751)] = 307212,
  [SMALL_STATE(9752)] = 307219,
  [SMALL_STATE(9753)] = 307226,
  [SMALL_STATE(9754)] = 307233,
  [SMALL_STATE(9755)] = 307240,
  [SMALL_STATE(9756)] = 307247,
  [SMALL_STATE(9757)] = 307254,
  [SMALL_STATE(9758)] = 307261,
  [SMALL_STATE(9759)] = 307268,
  [SMALL_STATE(9760)] = 307275,
  [SMALL_STATE(9761)] = 307282,
  [SMALL_STATE(9762)] = 307289,
  [SMALL_STATE(9763)] = 307296,
  [SMALL_STATE(9764)] = 307303,
  [SMALL_STATE(9765)] = 307310,
  [SMALL_STATE(9766)] = 307317,
  [SMALL_STATE(9767)] = 307324,
  [SMALL_STATE(9768)] = 307331,
  [SMALL_STATE(9769)] = 307338,
  [SMALL_STATE(9770)] = 307345,
  [SMALL_STATE(9771)] = 307352,
  [SMALL_STATE(9772)] = 307359,
  [SMALL_STATE(9773)] = 307366,
  [SMALL_STATE(9774)] = 307373,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1244),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7327),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9767),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6291),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9765),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8392),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1634),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6064),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3556),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4479),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3078),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9676),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7298),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8440),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9650),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8444),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4614),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2899),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1356),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3856),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3602),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2274),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2847),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6909),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6049),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5992),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5971),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8360),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8450),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1701),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9630),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8451),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9628),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9627),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9626),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9625),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9624),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9623),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9622),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7497),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4941),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4941),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8354),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7846),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5658),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4651),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3140),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9616),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3338),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9615),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5033),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5787),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1985),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1105),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8455),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1663),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1532),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7445),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7233),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9605),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9604),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1539),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1648),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8460),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1643),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5644),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6203),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7341),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9743),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9041),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6270),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9740),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8558),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3534),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4469),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3147),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1347),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3633),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8127),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8413),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1903),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9181),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8561),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9216),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1321),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9253),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9252),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9719),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8625),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9096),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9044),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4662),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1986),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8421),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1472),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7487),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7227),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9567),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9568),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1877),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7342),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8933),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6266),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8932),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6282),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9749),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8750),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3520),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4405),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3109),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3624),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8346),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8732),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1629),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9660),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8415),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9566),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8914),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8915),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8925),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8753),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8987),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1984),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8739),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1550),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7450),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7263),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9647),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9648),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1551),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1923),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(942),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7366),
  [363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8919),
  [365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6252),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8835),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8772),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3562),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4388),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3105),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3532),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8050),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8785),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1705),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8812),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8734),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9646),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1324),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9496),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9507),
  [405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8844),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8769),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9670),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1982),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8773),
  [415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1469),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7490),
  [419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7244),
  [421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9668),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9659),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(589),
  [433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef, 2, .production_id = 8),
  [435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1240),
  [442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(7342),
  [445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8933),
  [448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(6266),
  [451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2),
  [453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8932),
  [456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8750),
  [459] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(149),
  [462] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1634),
  [465] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1604),
  [468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1634),
  [471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(441),
  [474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(6064),
  [477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1152),
  [480] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(369),
  [483] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(3520),
  [486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(4405),
  [489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(3109),
  [492] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9676),
  [495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(7298),
  [498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8440),
  [501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9650),
  [504] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8444),
  [507] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(4614),
  [510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(60),
  [513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2899),
  [516] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1356),
  [519] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(3856),
  [522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(3624),
  [525] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2274),
  [528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2847),
  [531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(6909),
  [534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(6049),
  [537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(5992),
  [540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(5971),
  [543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8346),
  [546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8732),
  [549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1629),
  [552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9660),
  [555] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8415),
  [558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(195),
  [561] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9566),
  [564] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1317),
  [567] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8914),
  [570] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8915),
  [573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8925),
  [576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8753),
  [579] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8987),
  [582] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1695),
  [585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1514),
  [588] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9624),
  [591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9623),
  [594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9622),
  [597] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(7497),
  [600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(4941),
  [603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(4941),
  [606] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8354),
  [609] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(7846),
  [612] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(4662),
  [615] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(4651),
  [618] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(3140),
  [621] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9616),
  [624] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(3338),
  [627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9615),
  [630] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(5033),
  [633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(5787),
  [636] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1984),
  [639] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1105),
  [642] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8739),
  [645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1663),
  [648] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1550),
  [651] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(7450),
  [654] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(7263),
  [657] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9647),
  [660] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9648),
  [663] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1551),
  [666] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1923),
  [669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8460),
  [672] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1643),
  [675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(5644),
  [678] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(6203),
  [681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 3, .production_id = 78),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 4, .production_id = 78),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(902),
  [695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef, 3, .production_id = 8),
  [697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1165),
  [700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(7366),
  [703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8919),
  [706] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(6252),
  [709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8835),
  [712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8772),
  [715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(470),
  [718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(3562),
  [721] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(4388),
  [724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(3105),
  [727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(69),
  [730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(3532),
  [733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8050),
  [736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8785),
  [739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1705),
  [742] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8812),
  [745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8734),
  [748] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(183),
  [751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9646),
  [754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1324),
  [757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9496),
  [760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9507),
  [763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8844),
  [766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8769),
  [769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9670),
  [772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1982),
  [775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8773),
  [778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1469),
  [781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(7490),
  [784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(7244),
  [787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9668),
  [790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9659),
  [793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1506),
  [796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1911),
  [799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2698),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6647),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6624),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4315),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4313),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4574),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4528),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1225),
  [830] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(7341),
  [833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9743),
  [836] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(6270),
  [839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9740),
  [842] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8558),
  [845] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(785),
  [848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(3534),
  [851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(4469),
  [854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(3147),
  [857] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(72),
  [860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2),
  [862] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(3633),
  [865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8127),
  [868] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8413),
  [871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1903),
  [874] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9181),
  [877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8561),
  [880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(203),
  [883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9216),
  [886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1321),
  [889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9253),
  [892] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9252),
  [895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9719),
  [898] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8625),
  [901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9096),
  [904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1986),
  [907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8421),
  [910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1472),
  [913] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(7487),
  [916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(7227),
  [919] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9567),
  [922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9568),
  [925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1473),
  [928] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1877),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5206),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5172),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5164),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5167),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [979] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1209),
  [982] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(7344),
  [985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8988),
  [988] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(6277),
  [991] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8920),
  [994] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8486),
  [997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(817),
  [1000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(3612),
  [1003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(4380),
  [1006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(3088),
  [1009] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(65),
  [1012] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(3554),
  [1015] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(7996),
  [1018] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8730),
  [1021] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1649),
  [1024] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9489),
  [1027] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8388),
  [1030] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(180),
  [1033] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9657),
  [1036] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1316),
  [1039] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8887),
  [1042] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8888),
  [1045] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8929),
  [1048] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8716),
  [1051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8980),
  [1054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1981),
  [1057] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(8724),
  [1060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1583),
  [1063] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(7452),
  [1066] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(7271),
  [1069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9677),
  [1072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(9669),
  [1075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1475),
  [1078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1838),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6786),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6785),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4128),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4061),
  [1095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7344),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8988),
  [1101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6277),
  [1103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 2),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8920),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8486),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [1111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3612),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4380),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3088),
  [1117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3554),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7996),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8730),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1649),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9489),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8388),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9657),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1316),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8887),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8888),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8929),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8716),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8980),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1981),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8724),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1583),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7452),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7271),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9677),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9669),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1475),
  [1163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1838),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3641),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4077),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4033),
  [1177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 1),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3651),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [1185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2),
  [1187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1244),
  [1190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(7327),
  [1193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(9767),
  [1196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(6291),
  [1199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(9765),
  [1202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(8392),
  [1205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(149),
  [1208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1634),
  [1211] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1604),
  [1214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1634),
  [1217] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(441),
  [1220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(6064),
  [1223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1152),
  [1226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(3556),
  [1229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(4479),
  [1232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(3078),
  [1235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(9676),
  [1238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(7298),
  [1241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(8440),
  [1244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(9650),
  [1247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(8444),
  [1250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(4614),
  [1253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(74),
  [1256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2899),
  [1259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1356),
  [1262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(3856),
  [1265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(3602),
  [1268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2274),
  [1271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2847),
  [1274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(6909),
  [1277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(6049),
  [1280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(5992),
  [1283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(5971),
  [1286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(8360),
  [1289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(8450),
  [1292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1701),
  [1295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(9630),
  [1298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(8451),
  [1301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(197),
  [1304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(9628),
  [1307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1319),
  [1310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(9627),
  [1313] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(9626),
  [1316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(9625),
  [1319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1695),
  [1322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1514),
  [1325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(9624),
  [1328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(9623),
  [1331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(9622),
  [1334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(7497),
  [1337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(4941),
  [1340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(4941),
  [1343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(8354),
  [1346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(7846),
  [1349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(5658),
  [1352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(4651),
  [1355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(3140),
  [1358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(9616),
  [1361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(3338),
  [1364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(9615),
  [1367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(5033),
  [1370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(5787),
  [1373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1985),
  [1376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1105),
  [1379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(8455),
  [1382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1663),
  [1385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1532),
  [1388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(7445),
  [1391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(7233),
  [1394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(9605),
  [1397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(9604),
  [1400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1539),
  [1403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1648),
  [1406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(8460),
  [1409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1643),
  [1412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(5644),
  [1415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(6203),
  [1418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 1),
  [1420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [1422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 2),
  [1424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [1426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [1428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 2),
  [1430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [1432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8729),
  [1434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1378),
  [1436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8501),
  [1438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 4, .production_id = 12),
  [1440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 4, .production_id = 12),
  [1442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1296),
  [1445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2),
  [1447] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(258),
  [1450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1634),
  [1453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1634),
  [1456] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1672),
  [1459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2),
  [1461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1672),
  [1464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(369),
  [1467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(3520),
  [1470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4405),
  [1473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(3856),
  [1476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9676),
  [1479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(7298),
  [1482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8729),
  [1485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9650),
  [1488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(60),
  [1491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2899),
  [1494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1378),
  [1497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2274),
  [1500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2847),
  [1503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6909),
  [1506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6049),
  [1509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5992),
  [1512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5971),
  [1515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8346),
  [1518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8732),
  [1521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8415),
  [1524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(195),
  [1527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9566),
  [1530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1317),
  [1533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8914),
  [1536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8915),
  [1539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8925),
  [1542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8753),
  [1545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8987),
  [1548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1695),
  [1551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1514),
  [1554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9624),
  [1557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9623),
  [1560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9622),
  [1563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(7497),
  [1566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4941),
  [1569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4941),
  [1572] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8354),
  [1575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(7846),
  [1578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4662),
  [1581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4651),
  [1584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(3140),
  [1587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9616),
  [1590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(3338),
  [1593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9615),
  [1596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5787),
  [1599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8501),
  [1602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8739),
  [1605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1663),
  [1608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1550),
  [1611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1551),
  [1614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1923),
  [1617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8460),
  [1620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1643),
  [1623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5644),
  [1626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6203),
  [1629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, .production_id = 12),
  [1631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, .production_id = 12),
  [1633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3),
  [1635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3),
  [1637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1304),
  [1639] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1304),
  [1642] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(470),
  [1645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(3562),
  [1648] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4388),
  [1651] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(69),
  [1654] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8050),
  [1657] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8785),
  [1660] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8734),
  [1663] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(183),
  [1666] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9646),
  [1669] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1324),
  [1672] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9496),
  [1675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9507),
  [1678] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8844),
  [1681] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8769),
  [1684] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9670),
  [1687] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8773),
  [1690] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1469),
  [1693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1506),
  [1696] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1911),
  [1699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [1701] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1297),
  [1704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(785),
  [1707] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(3534),
  [1710] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4469),
  [1713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(72),
  [1716] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8127),
  [1719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8413),
  [1722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8561),
  [1725] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(203),
  [1728] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9216),
  [1731] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1321),
  [1734] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9253),
  [1737] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9252),
  [1740] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9719),
  [1743] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8625),
  [1746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9096),
  [1749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8421),
  [1752] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1472),
  [1755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1473),
  [1758] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1877),
  [1761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [1763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [1765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8442),
  [1767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9176),
  [1769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1295),
  [1772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(756),
  [1775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(3556),
  [1778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4479),
  [1781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(74),
  [1784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8360),
  [1787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8450),
  [1790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8451),
  [1793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(197),
  [1796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9628),
  [1799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1319),
  [1802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9627),
  [1805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9626),
  [1808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9625),
  [1811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8442),
  [1814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9176),
  [1817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8455),
  [1820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1532),
  [1823] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1539),
  [1826] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1648),
  [1829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [1831] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1309),
  [1834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(817),
  [1837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(3612),
  [1840] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4380),
  [1843] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(65),
  [1846] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(7996),
  [1849] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8730),
  [1852] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8388),
  [1855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(180),
  [1858] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9657),
  [1861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1316),
  [1864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8887),
  [1867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8888),
  [1870] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8929),
  [1873] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8716),
  [1876] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8980),
  [1879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8724),
  [1882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1583),
  [1885] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1475),
  [1888] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1838),
  [1891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [1893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [1895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4716),
  [1897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4393),
  [1899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [1901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7961),
  [1903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8690),
  [1905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8726),
  [1907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [1909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9667),
  [1911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [1913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9490),
  [1915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9494),
  [1917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8993),
  [1919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8686),
  [1921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9528),
  [1923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8658),
  [1925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [1927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1499),
  [1929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1642),
  [1931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1310),
  [1934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1160),
  [1937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4716),
  [1940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4393),
  [1943] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(58),
  [1946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(7961),
  [1949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8690),
  [1952] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8726),
  [1955] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(176),
  [1958] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9667),
  [1961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1311),
  [1964] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9490),
  [1967] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9494),
  [1970] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8993),
  [1973] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8686),
  [1976] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(9528),
  [1979] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(8658),
  [1982] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1492),
  [1985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1499),
  [1988] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1642),
  [1991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1301),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [1995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4728),
  [1997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4390),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8784),
  [2001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9583),
  [2003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8959),
  [2005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [2007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5150),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9437),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [2013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [2015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1621),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7283),
  [2021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6986),
  [2023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6041),
  [2025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6042),
  [2027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6051),
  [2029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [2031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [2033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9444),
  [2035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9738),
  [2037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9771),
  [2039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7536),
  [2041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4461),
  [2043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4461),
  [2045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8012),
  [2047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7847),
  [2049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4526),
  [2051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4507),
  [2053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5744),
  [2055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1871),
  [2057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8426),
  [2059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1825),
  [2061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5656),
  [2063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6191),
  [2065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1326),
  [2067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8304),
  [2069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5752),
  [2071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [2073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [2075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1995),
  [2077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [2079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [2081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [2083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1947),
  [2085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [2087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1150),
  [2089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7286),
  [2091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7158),
  [2093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2145),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [2097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2251),
  [2099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6982),
  [2101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6081),
  [2103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6075),
  [2105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6071),
  [2107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [2109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1526),
  [2111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9219),
  [2113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9729),
  [2115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9768),
  [2117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7508),
  [2119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4004),
  [2121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4004),
  [2123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8046),
  [2125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7810),
  [2127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4059),
  [2129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4058),
  [2131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2253),
  [2133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9221),
  [2135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5751),
  [2137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3557),
  [2139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1743),
  [2141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8477),
  [2143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1744),
  [2145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5626),
  [2147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6193),
  [2149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 4, .production_id = 45),
  [2151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 4, .production_id = 45),
  [2153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1688),
  [2155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [2157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7315),
  [2159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [2161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [2163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9396),
  [2165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9732),
  [2167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9769),
  [2169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7542),
  [2171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [2173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3350),
  [2175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8095),
  [2177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7694),
  [2179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3026),
  [2181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2973),
  [2183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9243),
  [2185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [2187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8435),
  [2189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1963),
  [2191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5645),
  [2193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6197),
  [2195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [2197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1880),
  [2199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [2201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7307),
  [2203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1549),
  [2205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3504),
  [2207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3504),
  [2209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7993),
  [2211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7659),
  [2213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1814),
  [2215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8443),
  [2217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1809),
  [2219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5659),
  [2221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 3),
  [2223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 3),
  [2225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1776),
  [2227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [2229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7281),
  [2231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [2233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [2235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9501),
  [2237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9747),
  [2239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9774),
  [2241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7521),
  [2243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3600),
  [2245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3600),
  [2247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8096),
  [2249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7933),
  [2251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3678),
  [2253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3672),
  [2255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1799),
  [2257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8405),
  [2259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1798),
  [2261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5623),
  [2263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6202),
  [2265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 2),
  [2267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 2),
  [2269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2429),
  [2271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2588),
  [2273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1606),
  [2275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [2277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7294),
  [2279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [2283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3881),
  [2285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8089),
  [2287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7682),
  [2289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1842),
  [2291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8414),
  [2293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1585),
  [2295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2556),
  [2297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [2299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2649),
  [2301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8040),
  [2303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1912),
  [2305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8909),
  [2307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8745),
  [2309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9395),
  [2311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8565),
  [2313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2510),
  [2315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2611),
  [2317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2643),
  [2319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2429),
  [2322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(258),
  [2325] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1634),
  [2328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1634),
  [2331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1672),
  [2334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(785),
  [2337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(7298),
  [2340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8729),
  [2343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(72),
  [2346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1378),
  [2349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2847),
  [2352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8127),
  [2355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8413),
  [2358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1903),
  [2361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9181),
  [2364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8561),
  [2367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(203),
  [2370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9216),
  [2373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1321),
  [2376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9253),
  [2379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9252),
  [2382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9719),
  [2385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8625),
  [2388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9096),
  [2391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1695),
  [2394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1514),
  [2397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9624),
  [2400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9623),
  [2403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9622),
  [2406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(7497),
  [2409] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(4941),
  [2412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(4941),
  [2415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8354),
  [2418] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(7846),
  [2421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(4662),
  [2424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(4651),
  [2427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9243),
  [2430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8501),
  [2433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8421),
  [2436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1663),
  [2439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1472),
  [2442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1473),
  [2445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1877),
  [2448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8460),
  [2451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1643),
  [2454] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(5644),
  [2457] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(6203),
  [2460] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2643),
  [2463] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(369),
  [2466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(60),
  [2469] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8346),
  [2472] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8732),
  [2475] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1629),
  [2478] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9660),
  [2481] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8415),
  [2484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(195),
  [2487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9566),
  [2490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1317),
  [2493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8914),
  [2496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8915),
  [2499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8925),
  [2502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8753),
  [2505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8987),
  [2508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8739),
  [2511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1550),
  [2514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1551),
  [2517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1923),
  [2520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2528),
  [2523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(756),
  [2526] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(74),
  [2529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8360),
  [2532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8450),
  [2535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1701),
  [2538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9630),
  [2541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8451),
  [2544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(197),
  [2547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9628),
  [2550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1319),
  [2553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9627),
  [2556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9626),
  [2559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9625),
  [2562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8442),
  [2565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9176),
  [2568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8455),
  [2571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1532),
  [2574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1539),
  [2577] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1648),
  [2580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2563),
  [2582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2611),
  [2585] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1160),
  [2588] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(58),
  [2591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(7961),
  [2594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8690),
  [2597] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1912),
  [2600] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8909),
  [2603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8726),
  [2606] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(176),
  [2609] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9667),
  [2612] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1311),
  [2615] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9490),
  [2618] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9494),
  [2621] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8993),
  [2624] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8686),
  [2627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9528),
  [2630] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8658),
  [2633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1492),
  [2636] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1499),
  [2639] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1642),
  [2642] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2649),
  [2645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8040),
  [2648] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8745),
  [2651] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9395),
  [2654] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8565),
  [2657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1724),
  [2659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7297),
  [2663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1515),
  [2665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1615),
  [2667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1611),
  [2669] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2563),
  [2672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(470),
  [2675] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(69),
  [2678] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8050),
  [2681] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8785),
  [2684] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1705),
  [2687] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8812),
  [2690] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8734),
  [2693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(183),
  [2696] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9646),
  [2699] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1324),
  [2702] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9496),
  [2705] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9507),
  [2708] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8844),
  [2711] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8769),
  [2714] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9670),
  [2717] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8773),
  [2720] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1469),
  [2723] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1506),
  [2726] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1911),
  [2729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2528),
  [2731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2704),
  [2733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1928),
  [2735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [2737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7292),
  [2739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [2741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [2743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9464),
  [2745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9741),
  [2747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9772),
  [2749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7512),
  [2751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4138),
  [2753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4138),
  [2755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8036),
  [2757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7651),
  [2759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4247),
  [2761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4345),
  [2763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1723),
  [2765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8420),
  [2767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1722),
  [2769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5647),
  [2771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6187),
  [2773] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2510),
  [2776] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(817),
  [2779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(65),
  [2782] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(7996),
  [2785] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8730),
  [2788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1649),
  [2791] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9489),
  [2794] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8388),
  [2797] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(180),
  [2800] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(9657),
  [2803] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1316),
  [2806] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8887),
  [2809] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8888),
  [2812] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8929),
  [2815] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8716),
  [2818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8980),
  [2821] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(8724),
  [2824] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1583),
  [2827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1475),
  [2830] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1838),
  [2833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2006),
  [2835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [2839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2592),
  [2841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [2843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2),
  [2845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2),
  [2847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2), SHIFT_REPEAT(8775),
  [2850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 7),
  [2852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 7),
  [2854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8775),
  [2856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_try_statement, 3, .production_id = 7),
  [2858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_try_statement, 3, .production_id = 7),
  [2860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_try_statement, 4, .production_id = 46),
  [2862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_try_statement, 4, .production_id = 46),
  [2864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2), SHIFT(2438),
  [2867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [2869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [2871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2), SHIFT(7298),
  [2874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [2876] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2), SHIFT(2847),
  [2879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2), SHIFT(9243),
  [2882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2), SHIFT(8501),
  [2885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8757),
  [2887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 3, .production_id = 156),
  [2889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 3, .production_id = 156),
  [2891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 51),
  [2893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 51),
  [2895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [2897] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1), SHIFT(2438),
  [2900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [2902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_init_statement, 1),
  [2904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_init_statement, 1), SHIFT(7298),
  [2907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_statement, 1),
  [2909] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1), SHIFT(2847),
  [2912] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1), SHIFT(9243),
  [2915] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1), SHIFT(8501),
  [2918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 101),
  [2920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 101),
  [2922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1), SHIFT(2438),
  [2925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [2927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 1),
  [2929] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 1), SHIFT(7298),
  [2932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1),
  [2934] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1), SHIFT(2847),
  [2937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1), SHIFT(9243),
  [2940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1), SHIFT(8501),
  [2943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2), SHIFT_REPEAT(8757),
  [2946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, .production_id = 145),
  [2948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, .production_id = 145),
  [2950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 140),
  [2952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 140),
  [2954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2),
  [2956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2),
  [2958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 102),
  [2960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 102),
  [2962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 141),
  [2964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 141),
  [2966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_try_statement, 3, .production_id = 7),
  [2968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_try_statement, 3, .production_id = 7),
  [2970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 3, .production_id = 66),
  [2972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 3, .production_id = 66),
  [2974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2012),
  [2976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [2978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [2980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1840),
  [2982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [2984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7319),
  [2986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2651),
  [2988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3060),
  [2990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6987),
  [2992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6062),
  [2994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6011),
  [2996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6053),
  [2998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [3000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [3002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9422),
  [3004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9735),
  [3006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9770),
  [3008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7553),
  [3010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5411),
  [3012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5411),
  [3014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7982),
  [3016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7867),
  [3018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5552),
  [3020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5560),
  [3022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3398),
  [3024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9446),
  [3026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5745),
  [3028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [3030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1730),
  [3032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8434),
  [3034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1731),
  [3036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5651),
  [3038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6195),
  [3040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [3042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [3044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7288),
  [3046] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_yield_statement, 3),
  [3048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_yield_statement, 3),
  [3050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_return_statement, 3),
  [3052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_return_statement, 3),
  [3054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [3056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [3058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .production_id = 55),
  [3060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .production_id = 55),
  [3062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [3064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 3, .production_id = 53),
  [3066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 3, .production_id = 53),
  [3068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [3070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [3072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_range_loop, 5, .production_id = 146),
  [3074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_range_loop, 5, .production_id = 146),
  [3076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3186),
  [3078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 52),
  [3080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 52),
  [3082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4, .production_id = 113),
  [3084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, .production_id = 113),
  [3086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4, .production_id = 112),
  [3088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, .production_id = 112),
  [3090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [3092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 52),
  [3094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 52),
  [3096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_finally_clause, 2, .production_id = 7),
  [3098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_finally_clause, 2, .production_id = 7),
  [3100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3103),
  [3102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_leave_statement, 2),
  [3104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_leave_statement, 2),
  [3106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3569),
  [3108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_statement, 2),
  [3110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_statement, 2),
  [3112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [3114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2713),
  [3116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3353),
  [3118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [3120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [3122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5608),
  [3124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 5, .production_id = 164),
  [3126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 5, .production_id = 164),
  [3128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, .production_id = 85),
  [3130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, .production_id = 85),
  [3132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4460),
  [3134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 6, .production_id = 130),
  [3136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 6, .production_id = 130),
  [3138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_except_clause, 3, .production_id = 174),
  [3140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_except_clause, 3, .production_id = 174),
  [3142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4636),
  [3144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, .production_id = 130),
  [3146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, .production_id = 130),
  [3148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [3150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_return_statement, 2),
  [3152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_return_statement, 2),
  [3154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 2),
  [3156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 2),
  [3158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [3160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [3162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 4, .production_id = 85),
  [3164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 4, .production_id = 85),
  [3166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [3168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [3170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [3172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [3174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [3176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 2),
  [3178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_declaration, 3, .production_id = 57),
  [3180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_declaration, 3, .production_id = 57),
  [3182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 3),
  [3184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3),
  [3186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_declaration, 4, .production_id = 57),
  [3188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_declaration, 4, .production_id = 57),
  [3190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8706),
  [3192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 3),
  [3194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 3),
  [3196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4682),
  [3198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9042),
  [3200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6262),
  [3202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2534),
  [3204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9438),
  [3206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [3208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6309),
  [3210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9139),
  [3212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8482),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5563),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9217),
  [3218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3989),
  [3220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6064),
  [3222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3583),
  [3224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4366),
  [3226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6250),
  [3228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9190),
  [3230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6960),
  [3232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6001),
  [3234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6002),
  [3236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6003),
  [3238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5742),
  [3240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7930),
  [3242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2030),
  [3244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8829),
  [3246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7275),
  [3248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9685),
  [3250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_instantiation, 4, .production_id = 58),
  [3252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_instantiation, 4, .production_id = 58),
  [3254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_declaration, 3, .production_id = 5),
  [3256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_declaration, 3, .production_id = 5),
  [3258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 4, .production_id = 93),
  [3260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 4, .production_id = 93),
  [3262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 4, .production_id = 92),
  [3264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 4, .production_id = 92),
  [3266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, .production_id = 8),
  [3268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, .production_id = 8),
  [3270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, .production_id = 79),
  [3272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, .production_id = 79),
  [3274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2562),
  [3276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 4, .production_id = 78),
  [3278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 4, .production_id = 78),
  [3280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 4, .production_id = 77),
  [3282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 4, .production_id = 77),
  [3284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2), SHIFT_REPEAT(8505),
  [3287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2324),
  [3289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2630),
  [3291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2415),
  [3293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 4, .production_id = 76),
  [3295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 4, .production_id = 76),
  [3297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_definition, 3, .production_id = 75),
  [3299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_definition, 3, .production_id = 75),
  [3301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 3, .production_id = 5),
  [3303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 3, .production_id = 5),
  [3305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2), SHIFT_REPEAT(8538),
  [3308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [3310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_declaration, 2, .production_id = 24),
  [3312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_declaration, 2, .production_id = 24),
  [3314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 2),
  [3316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 2),
  [3318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2438),
  [3320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_qualifier, 1),
  [3322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_qualifier, 1),
  [3324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, .production_id = 5),
  [3326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, .production_id = 5),
  [3328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, .production_id = 75),
  [3330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, .production_id = 75),
  [3332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, .production_id = 69),
  [3334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, .production_id = 69),
  [3336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 3, .production_id = 67),
  [3338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 3, .production_id = 67),
  [3340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2220),
  [3342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2189),
  [3344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8505),
  [3346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_declaration, 3),
  [3348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_declaration, 3),
  [3350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2), SHIFT_REPEAT(8706),
  [3353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 4),
  [3355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 4),
  [3357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, .production_id = 48),
  [3359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, .production_id = 48),
  [3361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, .production_id = 60),
  [3363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, .production_id = 60),
  [3365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2578),
  [3367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 2),
  [3369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2),
  [3371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 5, .production_id = 171),
  [3373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 5, .production_id = 171),
  [3375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_instantiation, 3, .production_id = 5),
  [3377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_instantiation, 3, .production_id = 5),
  [3379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, .production_id = 46),
  [3381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, .production_id = 46),
  [3383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_linkage_specification, 3, .production_id = 44),
  [3385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_linkage_specification, 3, .production_id = 44),
  [3387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 3, .production_id = 38),
  [3389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 3, .production_id = 38),
  [3391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 3, .production_id = 8),
  [3393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 3, .production_id = 8),
  [3395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2420),
  [3397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5569),
  [3399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4993),
  [3401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4994),
  [3403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 3, .production_id = 8),
  [3405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 3, .production_id = 8),
  [3407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_include, 3, .production_id = 37),
  [3409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_include, 3, .production_id = 37),
  [3411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_definition, 2, .production_id = 23),
  [3413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_definition, 2, .production_id = 23),
  [3415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 2, .production_id = 24),
  [3417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 2, .production_id = 24),
  [3419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__empty_declaration, 2),
  [3421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__empty_declaration, 2),
  [3423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 2, .production_id = 24),
  [3425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 2, .production_id = 24),
  [3427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 2, .production_id = 23),
  [3429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 2, .production_id = 23),
  [3431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 2, .production_id = 7),
  [3433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 2, .production_id = 7),
  [3435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_declaration, 4),
  [3437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_declaration, 4),
  [3439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, .production_id = 110),
  [3441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, .production_id = 110),
  [3443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, .production_id = 115),
  [3445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, .production_id = 115),
  [3447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 2, .production_id = 3),
  [3449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 2, .production_id = 3),
  [3451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_method_clause, 3),
  [3453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_method_clause, 3),
  [3455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_method_clause, 3),
  [3457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_method_clause, 3),
  [3459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2448),
  [3461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [3463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [3465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [3467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 4, .production_id = 120),
  [3469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 4, .production_id = 120),
  [3471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 4, .production_id = 124),
  [3473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 4, .production_id = 124),
  [3475] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 5, .production_id = 125),
  [3477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 5, .production_id = 125),
  [3479] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, .production_id = 126),
  [3481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, .production_id = 126),
  [3483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, .production_id = 78),
  [3485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, .production_id = 78),
  [3487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 5, .production_id = 127),
  [3489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 5, .production_id = 127),
  [3491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_alias_definition, 5, .production_id = 157),
  [3493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_alias_definition, 5, .production_id = 157),
  [3495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_alias_definition, 5, .production_id = 158),
  [3497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_alias_definition, 5, .production_id = 158),
  [3499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_declaration, 5, .production_id = 159),
  [3501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_declaration, 5, .production_id = 159),
  [3503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_assert_declaration, 5, .production_id = 160),
  [3505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_assert_declaration, 5, .production_id = 160),
  [3507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8538),
  [3509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concept_definition, 5, .production_id = 8),
  [3511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concept_definition, 5, .production_id = 8),
  [3513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, .production_id = 166),
  [3515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, .production_id = 166),
  [3517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_assert_declaration, 7, .production_id = 201),
  [3519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_assert_declaration, 7, .production_id = 201),
  [3521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_declaration, 6, .production_id = 190),
  [3523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_declaration, 6, .production_id = 190),
  [3525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 6, .production_id = 172),
  [3527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 6, .production_id = 172),
  [3529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [3531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [3533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [3535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1765),
  [3537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [3539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7301),
  [3541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [3543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1471),
  [3545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4904),
  [3547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4904),
  [3549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8087),
  [3551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7661),
  [3553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [3555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8439),
  [3557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1736),
  [3559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5666),
  [3561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6185),
  [3563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9086),
  [3565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6256),
  [3567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2650),
  [3569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8854),
  [3571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8545),
  [3573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3578),
  [3575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4368),
  [3577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7836),
  [3579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2029),
  [3581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7228),
  [3583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9693),
  [3585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 2, .production_id = 8),
  [3587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2598),
  [3589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2216),
  [3591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2205),
  [3593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2463),
  [3595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2635),
  [3597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2319),
  [3599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2334),
  [3601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, .production_id = 78),
  [3603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3, .production_id = 78),
  [3605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(4682),
  [3608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(9042),
  [3611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(6262),
  [3614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2),
  [3616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(9438),
  [3619] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(8482),
  [3622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(5563),
  [3625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(9217),
  [3628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(3989),
  [3631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(6064),
  [3634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(6064),
  [3637] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(3583),
  [3640] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(4366),
  [3643] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(3856),
  [3646] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(9676),
  [3649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(6250),
  [3652] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(8784),
  [3655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(9650),
  [3658] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(8444),
  [3661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2899),
  [3664] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(9190),
  [3667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2274),
  [3670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2847),
  [3673] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(6960),
  [3676] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(6001),
  [3679] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(6002),
  [3682] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(6003),
  [3685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(3140),
  [3688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(9616),
  [3691] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(3338),
  [3694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(9615),
  [3697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(5033),
  [3700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(5742),
  [3703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(7930),
  [3706] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1105),
  [3709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2030),
  [3712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(8829),
  [3715] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(7275),
  [3718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(9685),
  [3721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 3, .production_id = 8),
  [3723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1631),
  [3725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [3727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7299),
  [3729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [3731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1533),
  [3733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9483),
  [3735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9744),
  [3737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9773),
  [3739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7500),
  [3741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5032),
  [3743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5032),
  [3745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8092),
  [3747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7896),
  [3749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5060),
  [3751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5059),
  [3753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1713),
  [3755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8408),
  [3757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1760),
  [3759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5654),
  [3761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6198),
  [3763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(9086),
  [3766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(6256),
  [3769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(8854),
  [3772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(8545),
  [3775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(3578),
  [3778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(4368),
  [3781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(7836),
  [3784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2029),
  [3787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(7228),
  [3790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(9693),
  [3793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [3795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [3797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [3799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2473),
  [3801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1849),
  [3803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [3805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7296),
  [3807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1493),
  [3809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5247),
  [3811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5247),
  [3813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8063),
  [3815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7751),
  [3817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1817),
  [3819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8416),
  [3821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1821),
  [3823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [3825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8834),
  [3827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6332),
  [3829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8868),
  [3831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8488),
  [3833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3599),
  [3835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4395),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4722),
  [3839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7818),
  [3841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2033),
  [3843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7218),
  [3845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9658),
  [3847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4844),
  [3849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3469),
  [3851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [3853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [3855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5873),
  [3857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4834),
  [3859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3517),
  [3861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_expression_statement, 2),
  [3863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_expression_statement, 2),
  [3865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4715),
  [3867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 4, .production_id = 75),
  [3869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 4, .production_id = 75),
  [3871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5880),
  [3873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2678),
  [3875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [3877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [3879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7316),
  [3881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1556),
  [3883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1729),
  [3885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1936),
  [3887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5627),
  [3889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3239),
  [3891] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(9129),
  [3894] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(6227),
  [3897] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(8877),
  [3900] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(8670),
  [3903] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(3577),
  [3906] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(4371),
  [3909] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(7801),
  [3912] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2031),
  [3915] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(7225),
  [3918] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(9701),
  [3921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [3923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [3925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9129),
  [3927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6227),
  [3929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 1),
  [3931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8877),
  [3933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8670),
  [3935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3577),
  [3937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4371),
  [3939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7801),
  [3941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2031),
  [3943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7225),
  [3945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9701),
  [3947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2746),
  [3949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 2),
  [3951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3635),
  [3953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [3955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [3957] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(8834),
  [3960] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(6332),
  [3963] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(8868),
  [3966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(8488),
  [3969] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(3599),
  [3972] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(4395),
  [3975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2),
  [3977] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(7818),
  [3980] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2033),
  [3983] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(7218),
  [3986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(9658),
  [3989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3597),
  [3991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 5, .production_id = 124),
  [3993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 5, .production_id = 124),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2769),
  [3997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 4, .production_id = 69),
  [3999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 4, .production_id = 69),
  [4001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5726),
  [4003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2701),
  [4005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1714),
  [4007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [4009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7317),
  [4011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [4013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1719),
  [4015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1591),
  [4017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [4019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2676),
  [4021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [4023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5798),
  [4025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [4027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3894),
  [4029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, .production_id = 23),
  [4031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, .production_id = 23),
  [4033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_pack_expansion, 2, .production_id = 28),
  [4035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [4037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_pack_expansion, 2, .production_id = 28),
  [4039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [4041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4459),
  [4043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3879),
  [4045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3879),
  [4047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7352),
  [4049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3331),
  [4051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6964),
  [4053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6086),
  [4055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6084),
  [4057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6083),
  [4059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5757),
  [4061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3839),
  [4063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9150),
  [4065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6811),
  [4067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6811),
  [4069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6758),
  [4071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8850),
  [4073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3539),
  [4075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6254),
  [4077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7833),
  [4079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2028),
  [4081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9652),
  [4083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6295),
  [4085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9697),
  [4087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9686),
  [4089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7819),
  [4091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2034),
  [4093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9662),
  [4095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9704),
  [4097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9694),
  [4099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9672),
  [4101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9678),
  [4103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7858),
  [4105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2026),
  [4107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9689),
  [4109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7891),
  [4111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2032),
  [4113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9681),
  [4115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9708),
  [4117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9702),
  [4119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7845),
  [4121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2027),
  [4123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9259),
  [4125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 4),
  [4127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 4),
  [4129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 3),
  [4131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 3),
  [4133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [4135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2280),
  [4137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7080),
  [4139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [4141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6936),
  [4143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [4145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6947),
  [4147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [4149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7247),
  [4151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [4153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3997),
  [4155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [4157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3606),
  [4159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [4161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4071),
  [4163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [4165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6718),
  [4167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3526),
  [4171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [4173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2804),
  [4175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2593),
  [4177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [4179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7235),
  [4181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [4183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7079),
  [4185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [4187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7032),
  [4189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [4191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7101),
  [4193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [4195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6970),
  [4197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [4199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6719),
  [4201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [4203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6949),
  [4205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [4207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4046),
  [4209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6678),
  [4213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [4215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2731),
  [4217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [4219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6715),
  [4221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [4223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3985),
  [4225] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1), REDUCE(aux_sym_attributed_declarator_repeat1, 1),
  [4228] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration_modifiers, 1), REDUCE(aux_sym_attributed_declarator_repeat1, 1),
  [4231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1),
  [4233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1),
  [4235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_modifiers, 1),
  [4237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1),
  [4239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2), SHIFT_REPEAT(8643),
  [4242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8643),
  [4244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [4246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_specifier, 1, .production_id = 1),
  [4248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_not_binary, 1),
  [4250] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__declarator, 1), REDUCE(sym__type_specifier, 1, .production_id = 1), REDUCE(sym__expression_not_binary, 1),
  [4254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1),
  [4256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_not_binary, 1),
  [4258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_specifier, 1, .production_id = 1), REDUCE(sym__expression_not_binary, 1),
  [4261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1), REDUCE(sym__expression_not_binary, 1),
  [4264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_not_binary, 1), SHIFT(285),
  [4267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7382),
  [4269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declarator, 1), REDUCE(sym__type_specifier, 1, .production_id = 1),
  [4272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_name, 1, .production_id = 1),
  [4274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3184),
  [4276] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__declarator, 1), REDUCE(sym__type_specifier, 1, .production_id = 1), REDUCE(sym__expression_not_binary, 1),
  [4280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [4282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [4284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [4286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [4288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [4290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [4292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4186),
  [4294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5602),
  [4296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [4298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [4300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5342),
  [4302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5342),
  [4304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6449),
  [4306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [4308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [4310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [4312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2446),
  [4314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9220),
  [4316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4517),
  [4318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [4320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3152),
  [4322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [4324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6804),
  [4326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7302),
  [4328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5044),
  [4330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [4332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9030),
  [4334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4101),
  [4336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6796),
  [4338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9165),
  [4340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3741),
  [4342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4311),
  [4344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6560),
  [4346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3778),
  [4348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4244),
  [4350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3818),
  [4352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5123),
  [4354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [4356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(2438),
  [4359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(258),
  [4362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(1634),
  [4365] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(1634),
  [4368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(1672),
  [4371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(3152),
  [4374] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(7298),
  [4377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(1826),
  [4380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2),
  [4382] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(1378),
  [4385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(2847),
  [4388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(1695),
  [4391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(1514),
  [4394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(9624),
  [4397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(9623),
  [4400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(9622),
  [4403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(7497),
  [4406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(4941),
  [4409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(4941),
  [4412] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(8354),
  [4415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(7846),
  [4418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(4662),
  [4421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(4651),
  [4424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(9243),
  [4427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(7302),
  [4430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(8501),
  [4433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(1663),
  [4436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(8460),
  [4439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(1643),
  [4442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(5644),
  [4445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2), SHIFT_REPEAT(6203),
  [4448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4106),
  [4450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4509),
  [4452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4157),
  [4454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4482),
  [4456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4054),
  [4458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9688),
  [4460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4284),
  [4462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5216),
  [4464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2948),
  [4466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6576),
  [4468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9381),
  [4470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5165),
  [4472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [4474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5080),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9089),
  [4478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3014),
  [4480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9687),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5596),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4543),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4161),
  [4488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4525),
  [4490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4328),
  [4492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5609),
  [4494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5548),
  [4496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4544),
  [4500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [4502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4181),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4359),
  [4506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3785),
  [4508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4568),
  [4510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3771),
  [4512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4550),
  [4514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5102),
  [4516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5135),
  [4518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4136),
  [4520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_not_binary, 1), SHIFT(319),
  [4523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1461),
  [4525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7767),
  [4527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8418),
  [4529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4253),
  [4531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1839),
  [4533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3740),
  [4535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1673),
  [4537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [4539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1805),
  [4541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5605),
  [4543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1612),
  [4545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4083),
  [4547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [4549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4817),
  [4551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1865),
  [4553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2938),
  [4555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [4557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5198),
  [4559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1956),
  [4561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4555),
  [4563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1919),
  [4565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [4567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [4569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [4571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [4573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [4575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [4577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1660),
  [4579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [4581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2409),
  [4583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 2),
  [4585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 2),
  [4587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [4589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [4593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8642),
  [4595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [4599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [4601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [4603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2349),
  [4605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [4607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [4609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [4611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [4613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [4615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [4617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8896),
  [4619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [4621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [4623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [4625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2522),
  [4627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7447),
  [4629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [4631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [4633] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(9357),
  [4636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [4638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(9289),
  [4641] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(9231),
  [4644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [4646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [4648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [4650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [4652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4269),
  [4656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(9229),
  [4659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [4661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [4663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2937),
  [4665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [4667] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(9210),
  [4670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4114),
  [4672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(9180),
  [4675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9143),
  [4677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1540),
  [4679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [4681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [4683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [4685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [4687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2166),
  [4689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [4691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [4693] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(9056),
  [4696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [4698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(9052),
  [4701] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(9022),
  [4704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(8982),
  [4707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9539),
  [4709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [4711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3645),
  [4713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [4715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [4717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [4721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [4723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [4725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [4727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [4729] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(9043),
  [4732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [4734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9356),
  [4736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1527),
  [4738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [4740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [4742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [4744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [4746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1636),
  [4748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1806),
  [4750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [4752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1943),
  [4754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [4756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1700),
  [4758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, .dynamic_precedence = 1, .production_id = 183),
  [4760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1651),
  [4762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1728),
  [4764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, .dynamic_precedence = 1, .production_id = 144),
  [4766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1644),
  [4768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, .dynamic_precedence = 1, .production_id = 78),
  [4770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1824),
  [4772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_default_capture, 1),
  [4774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 2, .dynamic_precedence = 1),
  [4776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1866),
  [4778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [4780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [4782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1885),
  [4784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(8922),
  [4787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1718),
  [4789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1858),
  [4791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [4793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [4795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [4797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1937),
  [4799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 2, .dynamic_precedence = 1, .production_id = 103),
  [4801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1954),
  [4803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [4805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1726),
  [4807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, .dynamic_precedence = 1, .production_id = 103),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [4811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9241),
  [4813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8947),
  [4815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [4817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [4819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [4821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3560),
  [4823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [4825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9242),
  [4827] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(8823),
  [4830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(9368),
  [4833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(9692),
  [4836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8911),
  [4838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9603),
  [4840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(8967),
  [4843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9506),
  [4845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [4847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3996),
  [4849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6711),
  [4851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6722),
  [4853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9103),
  [4855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [4857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9451),
  [4859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [4861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2502),
  [4863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [4865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9470),
  [4867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [4869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [4871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [4873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6951),
  [4875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4042),
  [4877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6950),
  [4879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7236),
  [4881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9429),
  [4883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [4885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [4887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [4889] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(8825),
  [4892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2805),
  [4894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(8907),
  [4897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(8899),
  [4900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7099),
  [4902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [4904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8942),
  [4906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9375),
  [4908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9405),
  [4910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [4912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(8897),
  [4915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [4917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [4919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(8891),
  [4922] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(8878),
  [4925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6748),
  [4927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(9050),
  [4930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3999),
  [4932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(8856),
  [4935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9239),
  [4937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [4939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4069),
  [4943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7049),
  [4945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7046),
  [4947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(8853),
  [4950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [4952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9488),
  [4954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [4956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6910),
  [4958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6983),
  [4960] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(8840),
  [4963] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(8837),
  [4966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [4968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [4970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7082),
  [4972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9671),
  [4974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9302),
  [4976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9018),
  [4978] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(8836),
  [4981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(8832),
  [4984] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(8828),
  [4987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [4989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [4991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [4993] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(8826),
  [4996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3527),
  [4998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [5000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [5002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(9665),
  [5005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(9573),
  [5008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9106),
  [5010] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(9582),
  [5013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(9599),
  [5016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [5018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7212),
  [5020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6615),
  [5022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(9700),
  [5025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6709),
  [5027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [5029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9152),
  [5031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [5033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2434),
  [5035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [5037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [5039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [5041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [5043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [5045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [5047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [5049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [5051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [5053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [5055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [5057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [5059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [5061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [5063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [5065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [5067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [5069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [5071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2435),
  [5073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [5075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [5077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [5079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [5081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [5083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [5085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [5087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [5089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2437),
  [5091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [5093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [5095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4022),
  [5097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [5099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5174),
  [5101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6787),
  [5103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6787),
  [5105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7326),
  [5107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1128),
  [5109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 3, .dynamic_precedence = 1),
  [5111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 3, .dynamic_precedence = 1),
  [5113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, .dynamic_precedence = 2),
  [5115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, .dynamic_precedence = 2),
  [5117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, .dynamic_precedence = 1),
  [5119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, .dynamic_precedence = 1),
  [5121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 3, .dynamic_precedence = 3),
  [5123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 3, .dynamic_precedence = 3),
  [5125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 3, .dynamic_precedence = 2),
  [5127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 3, .dynamic_precedence = 2),
  [5129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, .production_id = 35),
  [5131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_identifier, 2, .production_id = 34),
  [5133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_qualified_identifier, 2, .production_id = 34), REDUCE(sym_qualified_type_identifier, 2, .production_id = 35),
  [5136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type_identifier, 2, .production_id = 35),
  [5138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, .production_id = 34),
  [5140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, .production_id = 34), REDUCE(sym_qualified_type_identifier, 2, .production_id = 35),
  [5143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, .production_id = 34), SHIFT(289),
  [5146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 2),
  [5148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 2),
  [5150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, .dynamic_precedence = 3),
  [5152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, .dynamic_precedence = 3),
  [5154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4578),
  [5156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [5158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6482),
  [5160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_type, 2, .production_id = 14),
  [5162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_function, 2, .production_id = 15),
  [5164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_template_type, 2, .production_id = 14), REDUCE(sym_template_function, 2, .production_id = 15),
  [5167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_type, 2, .production_id = 14),
  [5169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_function, 2, .production_id = 15),
  [5171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_template_type, 2, .production_id = 14), REDUCE(sym_template_function, 2, .production_id = 15),
  [5174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, .production_id = 34), SHIFT(351),
  [5177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_not_binary, 1), SHIFT(351),
  [5180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declarator, 1),
  [5182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [5184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7657),
  [5186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8436),
  [5188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_not_binary, 1), SHIFT(291),
  [5191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_not_binary, 1), SHIFT(310),
  [5194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [5196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1456),
  [5198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [5200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7794),
  [5202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8419),
  [5204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3567),
  [5206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7338),
  [5208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [5210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [5212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [5214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [5216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [5218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3581),
  [5220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6033),
  [5222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6029),
  [5224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6028),
  [5226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5964),
  [5228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5962),
  [5230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6031),
  [5232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6039),
  [5234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6038),
  [5236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6037),
  [5238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5980),
  [5240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5983),
  [5242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5987),
  [5244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6021),
  [5246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6012),
  [5248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5973),
  [5250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6016),
  [5252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6018),
  [5254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6019),
  [5256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6026),
  [5258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6069),
  [5260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6070),
  [5262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6058),
  [5264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6055),
  [5266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6048),
  [5268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6034),
  [5270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6036),
  [5272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6040),
  [5274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5730),
  [5276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5464),
  [5278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7681),
  [5280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7465),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2824),
  [5284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_expression, 2, .production_id = 19),
  [5286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_expression, 2, .production_id = 19),
  [5288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requirement_seq, 3),
  [5290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requirement_seq, 3),
  [5292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_expression, 3, .production_id = 65),
  [5294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_expression, 3, .production_id = 65),
  [5296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requirement_seq, 2),
  [5298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requirement_seq, 2),
  [5300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 4, .production_id = 123),
  [5302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 4, .production_id = 123),
  [5304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 5, .production_id = 170),
  [5306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 5, .production_id = 170),
  [5308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint_conjunction, 3, .production_id = 54),
  [5310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_conjunction, 3, .production_id = 54),
  [5312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fold_expression, 3, .production_id = 40),
  [5314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fold_expression, 3, .production_id = 40),
  [5316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 2, .production_id = 32),
  [5318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 2, .production_id = 32),
  [5320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 4, .production_id = 122),
  [5322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 4, .production_id = 122),
  [5324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, .production_id = 73),
  [5326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, .production_id = 73),
  [5328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__requirement_clause_constraint, 3),
  [5330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__requirement_clause_constraint, 3),
  [5332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, .production_id = 72),
  [5334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, .production_id = 72),
  [5336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8128),
  [5338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3546),
  [5340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_clause, 3, .production_id = 12),
  [5342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_clause, 3, .production_id = 12),
  [5344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8160),
  [5346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4010),
  [5348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_not_binary, 1), SHIFT(303),
  [5351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7984),
  [5353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2886),
  [5355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8288),
  [5357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4179),
  [5359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_clause, 4, .production_id = 139),
  [5361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_clause, 4, .production_id = 139),
  [5363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2),
  [5365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2),
  [5367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2063),
  [5370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(2065),
  [5373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [5375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [5377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(7694),
  [5380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(8435),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8534),
  [5385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2068),
  [5387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 2),
  [5389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 2),
  [5391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [5393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 3),
  [5395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 3),
  [5397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2), SHIFT_REPEAT(8622),
  [5400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8622),
  [5402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2079),
  [5405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 2),
  [5407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [5409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [5411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 7, .production_id = 202),
  [5413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 7, .production_id = 202),
  [5415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8598),
  [5417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3),
  [5419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3),
  [5421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 5),
  [5423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 5),
  [5425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [5427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2), SHIFT_REPEAT(8598),
  [5430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2),
  [5432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2),
  [5434] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2), SHIFT_REPEAT(2280),
  [5437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [5439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2),
  [5441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2),
  [5443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, .production_id = 192),
  [5445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, .production_id = 192),
  [5447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7348),
  [5449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4003),
  [5451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3883),
  [5453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9213),
  [5455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6421),
  [5457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8406),
  [5459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9215),
  [5461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3884),
  [5463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9222),
  [5465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decltype, 4),
  [5467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decltype, 4),
  [5469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 1, .production_id = 6),
  [5471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 1, .production_id = 6),
  [5473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9463),
  [5475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [5477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6526),
  [5479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6747),
  [5481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_specifier, 1),
  [5483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_specifier, 1),
  [5485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7387),
  [5487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2708),
  [5489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 1),
  [5491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1),
  [5493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2281),
  [5495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_name, 1),
  [5497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_name, 1),
  [5499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_type, 2, .dynamic_precedence = -1),
  [5501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_type, 2, .dynamic_precedence = -1),
  [5503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2285),
  [5505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9596),
  [5507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_method_definition, 3, .production_id = 67),
  [5509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_method_definition, 3, .production_id = 67),
  [5511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_not_binary, 1), SHIFT(355),
  [5514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1464),
  [5516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [5518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 7, .production_id = 203),
  [5520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 7, .production_id = 203),
  [5522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, .production_id = 193),
  [5524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, .production_id = 193),
  [5526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, .production_id = 203),
  [5528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, .production_id = 203),
  [5530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, .production_id = 189),
  [5532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, .production_id = 189),
  [5534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, .production_id = 172),
  [5536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, .production_id = 172),
  [5538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declaration_list_item, 2),
  [5540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_list_item, 2),
  [5542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, .production_id = 8),
  [5544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, .production_id = 8),
  [5546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, .production_id = 176),
  [5548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, .production_id = 176),
  [5550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 56),
  [5552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 56),
  [5554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 66),
  [5556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 66),
  [5558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_method_definition, 3, .production_id = 66),
  [5560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_method_definition, 3, .production_id = 66),
  [5562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, .production_id = 193),
  [5564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, .production_id = 193),
  [5566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, .production_id = 175),
  [5568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, .production_id = 175),
  [5570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, .production_id = 192),
  [5572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, .production_id = 192),
  [5574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, .production_id = 66),
  [5576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, .production_id = 66),
  [5578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, .production_id = 189),
  [5580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, .production_id = 189),
  [5582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .production_id = 127),
  [5584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .production_id = 127),
  [5586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .production_id = 78),
  [5588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .production_id = 78),
  [5590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .production_id = 126),
  [5592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .production_id = 126),
  [5594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 56),
  [5596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 56),
  [5598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .production_id = 78),
  [5600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .production_id = 78),
  [5602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .production_id = 79),
  [5604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .production_id = 79),
  [5606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_type_identifier, 2),
  [5608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_type_identifier, 2),
  [5610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .production_id = 8),
  [5612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .production_id = 8),
  [5614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, .production_id = 66),
  [5616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, .production_id = 66),
  [5618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, .production_id = 175),
  [5620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, .production_id = 175),
  [5622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, .production_id = 176),
  [5624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, .production_id = 176),
  [5626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, .production_id = 34),
  [5628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type_identifier, 2, .production_id = 34),
  [5630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 2, .production_id = 10),
  [5632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 2, .production_id = 10),
  [5634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 3),
  [5636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 3),
  [5638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 2, .production_id = 10),
  [5640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 2, .production_id = 10),
  [5642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, .production_id = 6),
  [5644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, .production_id = 6),
  [5646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, .production_id = 9),
  [5648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, .production_id = 9),
  [5650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, .production_id = 34), SHIFT(291),
  [5653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive_type, 1),
  [5655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_type, 1),
  [5657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 2),
  [5659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 2),
  [5661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_placeholder_type_specifier, 1),
  [5663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_placeholder_type_specifier, 1),
  [5665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, .production_id = 8),
  [5667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, .production_id = 8),
  [5669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, .production_id = 7),
  [5671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, .production_id = 7),
  [5673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8585),
  [5675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 2),
  [5677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 2),
  [5679] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2), SHIFT_REPEAT(8675),
  [5682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [5684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decltype_auto, 4),
  [5686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decltype_auto, 4),
  [5688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 3, .production_id = 99),
  [5690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 3, .production_id = 99),
  [5692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, .production_id = 7),
  [5694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, .production_id = 7),
  [5696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, .production_id = 50),
  [5698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, .production_id = 50),
  [5700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_specifier, 2, .production_id = 10),
  [5702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_specifier, 2, .production_id = 10),
  [5704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 1, .production_id = 11),
  [5706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 1, .production_id = 11),
  [5708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 3),
  [5710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 3),
  [5712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, .production_id = 49),
  [5714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, .production_id = 49),
  [5716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 2, .production_id = 10),
  [5718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 2, .production_id = 10),
  [5720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, .production_id = 48),
  [5722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, .production_id = 48),
  [5724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__enum_base_clause, 2, .production_id = 96),
  [5726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_base_clause, 2, .production_id = 96),
  [5728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8675),
  [5730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2), REDUCE(aux_sym_sized_type_specifier_repeat1, 2),
  [5733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2), REDUCE(aux_sym_sized_type_specifier_repeat1, 2),
  [5736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, .production_id = 47),
  [5738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, .production_id = 47),
  [5740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_placeholder_type_specifier, 2, .production_id = 25),
  [5742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_placeholder_type_specifier, 2, .production_id = 25),
  [5744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2), SHIFT_REPEAT(8585),
  [5747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 4),
  [5749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 4),
  [5751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 6, .production_id = 135),
  [5753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 6, .production_id = 135),
  [5755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, .production_id = 93),
  [5757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, .production_id = 93),
  [5759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_specifier, 4),
  [5761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_specifier, 4),
  [5763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 5, .production_id = 136),
  [5765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 5, .production_id = 136),
  [5767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [5769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [5771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, .production_id = 97),
  [5773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, .production_id = 97),
  [5775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [5777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, .production_id = 46),
  [5779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, .production_id = 46),
  [5781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 4, .production_id = 137),
  [5783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 4, .production_id = 137),
  [5785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 4, .production_id = 46),
  [5787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 4, .production_id = 46),
  [5789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 4, .production_id = 100),
  [5791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 4, .production_id = 100),
  [5793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, .production_id = 94),
  [5795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, .production_id = 94),
  [5797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string, 1),
  [5799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string, 1),
  [5801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2997),
  [5803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2817),
  [5805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2453),
  [5807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2380),
  [5809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 45),
  [5811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 45),
  [5813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [5815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [5817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2728),
  [5819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8872),
  [5821] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_not_binary, 1), SHIFT(358),
  [5824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [5826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [5828] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, .production_id = 35), SHIFT(303),
  [5831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 90),
  [5833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 90),
  [5835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_name, 1, .production_id = 1),
  [5837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [5839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1), SHIFT(2756),
  [5842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2427),
  [5844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, .production_id = 34), SHIFT(337),
  [5847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 63),
  [5849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 63),
  [5851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_not_binary, 1), SHIFT(361),
  [5854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 18),
  [5856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 18),
  [5858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2443),
  [5860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [5862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declarator, 1), REDUCE(sym__expression_not_binary, 1),
  [5865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declarator, 1), REDUCE(sym__expression_not_binary, 1),
  [5868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [5870] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_not_binary, 1), SHIFT(346),
  [5873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [5875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2416),
  [5877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructor_name, 2),
  [5879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructor_name, 2),
  [5881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [5883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [5885] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(2443),
  [5888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(7933),
  [5891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(8405),
  [5894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [5896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1413),
  [5898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [5900] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_not_binary, 1), SHIFT(289),
  [5903] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2450),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2654),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [5910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2490),
  [5912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7880),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8407),
  [5916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1451),
  [5918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7850),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8412),
  [5924] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(2490),
  [5927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(7880),
  [5930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(8407),
  [5933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_not_binary, 1), SHIFT(9091),
  [5936] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_not_binary, 1), SHIFT(7025),
  [5939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1442),
  [5941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [5943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(2551),
  [5946] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(7657),
  [5949] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(8436),
  [5952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, .production_id = 49),
  [5954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, .production_id = 49),
  [5956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7089),
  [5958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__enum_base_clause, 2, .production_id = 95),
  [5960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_base_clause, 2, .production_id = 95),
  [5962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2730),
  [5964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2460),
  [5966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1), SHIFT(2857),
  [5969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2695),
  [5971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2969),
  [5973] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_not_binary, 1), SHIFT(345),
  [5976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [5978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9091),
  [5980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, .production_id = 94),
  [5982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, .production_id = 94),
  [5984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2645),
  [5986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3735),
  [5988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2551),
  [5990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [5992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2958),
  [5994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2685),
  [5996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 4, .dynamic_precedence = 1, .production_id = 84),
  [5998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 4, .dynamic_precedence = 1, .production_id = 84),
  [6000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [6002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8692),
  [6004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [6006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_clause, 2, .production_id = 20),
  [6008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_clause, 2, .production_id = 20),
  [6010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6245),
  [6012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6296),
  [6014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6245),
  [6016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6296),
  [6018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, .production_id = 2),
  [6020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, .production_id = 2),
  [6022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [6024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, .production_id = 46),
  [6026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, .production_id = 46),
  [6028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, .production_id = 100),
  [6030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, .production_id = 100),
  [6032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .production_id = 16),
  [6034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .production_id = 16),
  [6036] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2672),
  [6039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2706),
  [6041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7678),
  [6043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8417),
  [6045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2839),
  [6047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [6049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, .production_id = 97),
  [6051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, .production_id = 97),
  [6053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, .production_id = 7),
  [6055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, .production_id = 7),
  [6057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 1, .production_id = 9),
  [6059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 1, .production_id = 9),
  [6061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, .production_id = 93),
  [6063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, .production_id = 93),
  [6065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint_disjunction, 3, .production_id = 54),
  [6067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_disjunction, 3, .production_id = 54),
  [6069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 3, .dynamic_precedence = 1, .production_id = 41),
  [6071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 3, .dynamic_precedence = 1, .production_id = 41),
  [6073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3048),
  [6075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2792),
  [6077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3096),
  [6079] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2699),
  [6082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, .production_id = 46),
  [6084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, .production_id = 46),
  [6086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [6088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [6090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, .production_id = 18),
  [6092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, .production_id = 18),
  [6094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, .production_id = 135),
  [6096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, .production_id = 135),
  [6098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_not_binary, 1), SHIFT(337),
  [6101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2712),
  [6103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, .dynamic_precedence = -1, .production_id = 36),
  [6105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, .dynamic_precedence = -1, .production_id = 36),
  [6107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .production_id = 36),
  [6109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .production_id = 36),
  [6111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [6113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, .production_id = 48),
  [6115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, .production_id = 48),
  [6117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, .production_id = 50),
  [6119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, .production_id = 50),
  [6121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, .production_id = 7),
  [6123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, .production_id = 7),
  [6125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(2712),
  [6128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(7678),
  [6131] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(8417),
  [6134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, .production_id = 18),
  [6136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, .production_id = 18),
  [6138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [6140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 5, .dynamic_precedence = 1, .production_id = 165),
  [6142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 5, .dynamic_precedence = 1, .production_id = 165),
  [6144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 4, .production_id = 136),
  [6146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 4, .production_id = 136),
  [6148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 2, .dynamic_precedence = 1, .production_id = 5),
  [6150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 2, .dynamic_precedence = 1, .production_id = 5),
  [6152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, .production_id = 133),
  [6154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, .production_id = 133),
  [6156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2761),
  [6158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type_declarator, 3, .dynamic_precedence = -10),
  [6160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 3, .dynamic_precedence = -10),
  [6162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_type_declarator, 2),
  [6164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_type_declarator, 2),
  [6166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, .production_id = 24),
  [6168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, .production_id = 24),
  [6170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, .production_id = 116),
  [6172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, .production_id = 116),
  [6174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type_declarator, 4, .dynamic_precedence = -10),
  [6176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 4, .dynamic_precedence = -10),
  [6178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 62),
  [6180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 62),
  [6182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, .production_id = 34), SHIFT(303),
  [6185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 89),
  [6187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 89),
  [6189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 109),
  [6191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 109),
  [6193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3084),
  [6195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2809),
  [6197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3156),
  [6199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2763),
  [6201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2725),
  [6203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2761),
  [6206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9546),
  [6208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [6210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2),
  [6212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2),
  [6214] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT_REPEAT(8692),
  [6217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2740),
  [6219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4088),
  [6221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6775),
  [6223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 1, .dynamic_precedence = 1),
  [6225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2777),
  [6227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4951),
  [6229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4951),
  [6231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6642),
  [6233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [6235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, .dynamic_precedence = 1),
  [6237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2863),
  [6239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type_declarator, 2, .production_id = 86),
  [6241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type_declarator, 2, .production_id = 86),
  [6243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, .production_id = 42),
  [6245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, .production_id = 42),
  [6247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2793),
  [6250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, .production_id = 1),
  [6252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, .production_id = 1),
  [6254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1),
  [6256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1),
  [6258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, .production_id = 43),
  [6260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, .production_id = 43),
  [6262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9421),
  [6264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [6266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6747),
  [6268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 3, .production_id = 24),
  [6270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 3, .production_id = 24),
  [6272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 5, .production_id = 167),
  [6274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 5, .production_id = 167),
  [6276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameter_list, 4),
  [6278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter_list, 4),
  [6280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, .production_id = 8),
  [6282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, .production_id = 8),
  [6284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6662),
  [6286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2822),
  [6289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_declarator, 3, .production_id = 161),
  [6291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_declarator, 3, .production_id = 161),
  [6293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_method, 2, .production_id = 117),
  [6295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_method, 2, .production_id = 117),
  [6297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, .production_id = 70),
  [6299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, .production_id = 70),
  [6301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2844),
  [6303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2845),
  [6305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2821),
  [6307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [6309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(2821),
  [6312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(7767),
  [6315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(8418),
  [6318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameter_list, 2),
  [6320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter_list, 2),
  [6322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [6324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4306),
  [6326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [6328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, .production_id = 118),
  [6330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_field_identifier, 2, .production_id = 118),
  [6332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2818),
  [6334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, .production_id = 47),
  [6336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, .production_id = 47),
  [6338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameter_list, 3),
  [6340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter_list, 3),
  [6342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2871),
  [6344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, .production_id = 34),
  [6346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_field_identifier, 2, .production_id = 34),
  [6348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2851),
  [6350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5188),
  [6352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5188),
  [6354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_method, 2, .production_id = 15),
  [6356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_method, 2, .production_id = 15),
  [6358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_field_identifier, 2),
  [6360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_field_identifier, 2),
  [6362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_declarator, 4, .production_id = 161),
  [6364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_declarator, 4, .production_id = 161),
  [6366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2870),
  [6368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_expression, 2, .production_id = 4),
  [6370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_expression, 2, .production_id = 4),
  [6372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [6374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2930),
  [6376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6858),
  [6378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6858),
  [6380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, .production_id = 74),
  [6382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_identifier, 3, .production_id = 74),
  [6384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, .production_id = 74), SHIFT(303),
  [6387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2867),
  [6389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 4),
  [6391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 4),
  [6393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 2, .production_id = 12),
  [6395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 2, .production_id = 12),
  [6397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_name, 2),
  [6399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_name, 2),
  [6401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [6403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2867),
  [6406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [6408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2861),
  [6410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 54),
  [6412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 54),
  [6414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 4),
  [6416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4),
  [6418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, .production_id = 40),
  [6420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, .production_id = 40),
  [6422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [6424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [6426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 2),
  [6428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2),
  [6430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 1, .production_id = 2),
  [6432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 1, .production_id = 2),
  [6434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3115),
  [6436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9240),
  [6438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2904),
  [6440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5146),
  [6442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5146),
  [6444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_await_expression, 2, .production_id = 4),
  [6446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_await_expression, 2, .production_id = 4),
  [6448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 4),
  [6450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 4),
  [6452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, .production_id = 18),
  [6454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, .production_id = 18),
  [6456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 3),
  [6458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3),
  [6460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, .production_id = 83),
  [6462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, .production_id = 83),
  [6464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7016),
  [6466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3220),
  [6468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3013),
  [6470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3377),
  [6472] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, .production_id = 35), SHIFT(361),
  [6475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9443),
  [6477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [6479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1), SHIFT(3205),
  [6482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3027),
  [6484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 2, .production_id = 30),
  [6486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 2, .production_id = 30),
  [6488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_literal_expression, 2, .production_id = 27),
  [6490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_literal_expression, 2, .production_id = 27),
  [6492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_literal_expression, 4, .production_id = 83),
  [6494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_literal_expression, 4, .production_id = 83),
  [6496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 3),
  [6498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 3),
  [6500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 88),
  [6502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 88),
  [6504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7004),
  [6506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6653),
  [6508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6285),
  [6510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6290),
  [6512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6285),
  [6514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6290),
  [6516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6657),
  [6518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2917),
  [6521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [6523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 9, .production_id = 211),
  [6525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 9, .production_id = 211),
  [6527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 9),
  [6529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 9),
  [6531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 8, .production_id = 208),
  [6533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 8, .production_id = 208),
  [6535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 8, .production_id = 207),
  [6537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 8, .production_id = 207),
  [6539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 29),
  [6541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 29),
  [6543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 8),
  [6545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 8),
  [6547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, .production_id = 71),
  [6549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, .production_id = 71),
  [6551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9463),
  [6553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6598),
  [6555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_identifier, 2),
  [6557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_identifier, 2),
  [6559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_argument_list, 2),
  [6561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_argument_list, 2),
  [6563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2),
  [6565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2),
  [6567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 7, .production_id = 200),
  [6569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 7, .production_id = 200),
  [6571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 7, .production_id = 199),
  [6573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 7, .production_id = 199),
  [6575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alignof_expression, 4, .production_id = 45),
  [6577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alignof_expression, 4, .production_id = 45),
  [6579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 4, .production_id = 105),
  [6581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 4, .production_id = 105),
  [6583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 107),
  [6585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 107),
  [6587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 108),
  [6589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 108),
  [6591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 6, .production_id = 187),
  [6593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 6, .production_id = 187),
  [6595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 6, .production_id = 186),
  [6597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 6, .production_id = 186),
  [6599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_offsetof_expression, 6, .production_id = 184),
  [6601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_offsetof_expression, 6, .production_id = 184),
  [6603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 5),
  [6605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 5),
  [6607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3009),
  [6609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [6611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5),
  [6613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5),
  [6615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_argument_list, 4),
  [6617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_argument_list, 4),
  [6619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_argument_list, 3),
  [6621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_argument_list, 3),
  [6623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9482),
  [6625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [6627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_null, 1),
  [6629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_null, 1),
  [6631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 6, .production_id = 173),
  [6633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 6, .production_id = 173),
  [6635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 26),
  [6637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 26),
  [6639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, .production_id = 162),
  [6641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, .production_id = 162),
  [6643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_user_defined_literal, 2),
  [6645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_user_defined_literal, 2),
  [6647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9518),
  [6649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [6651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 5, .production_id = 152),
  [6653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 5, .production_id = 152),
  [6655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 5, .production_id = 151),
  [6657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 5, .production_id = 151),
  [6659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 5, .production_id = 149),
  [6661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 5, .production_id = 149),
  [6663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 4),
  [6665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 4),
  [6667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2672),
  [6669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4),
  [6671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4),
  [6673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_name, 3),
  [6675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_name, 3),
  [6677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3069),
  [6679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3016),
  [6681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [6683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [6685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [6687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3),
  [6689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3),
  [6691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, .production_id = 132),
  [6693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, .production_id = 132),
  [6695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 61),
  [6697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 61),
  [6699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, .production_id = 131),
  [6701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, .production_id = 131),
  [6703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 54),
  [6705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 54),
  [6707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3050),
  [6709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2793),
  [6711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [6713] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, .production_id = 35), SHIFT(291),
  [6716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [6718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6526),
  [6720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [6722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [6724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3378),
  [6726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9191),
  [6728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3035),
  [6730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3056),
  [6732] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(3050),
  [6735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(7661),
  [6738] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(8439),
  [6741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, .production_id = 2),
  [6743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, .production_id = 2),
  [6745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3046),
  [6747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 3, .production_id = 18),
  [6749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 3, .production_id = 18),
  [6751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3034),
  [6753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [6755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2),
  [6757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2),
  [6759] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(4003),
  [6762] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(3883),
  [6765] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(9213),
  [6768] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(8406),
  [6771] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(9215),
  [6774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(3884),
  [6777] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(9222),
  [6780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_requirement, 4),
  [6782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_requirement, 4),
  [6784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2822),
  [6786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_class_specifier, 1),
  [6788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_class_specifier, 1),
  [6790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7921),
  [6792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [6794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [6796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, .production_id = 35), SHIFT(337),
  [6799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7064),
  [6801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6626),
  [6803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3215),
  [6805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3083),
  [6807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__requirement, 1, .production_id = 64),
  [6809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__requirement, 1, .production_id = 64),
  [6811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9500),
  [6813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [6815] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_specifier, 1), SHIFT(1306),
  [6818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3160),
  [6820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_requirement, 6),
  [6822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_requirement, 6),
  [6824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_requirement, 2),
  [6826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_requirement, 2),
  [6828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_requirement, 5),
  [6830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_requirement, 5),
  [6832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [6834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [6836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3535),
  [6838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8867),
  [6840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3166),
  [6842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [6844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(3166),
  [6847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7106),
  [6849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6641),
  [6851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7042),
  [6853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3175),
  [6855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3176),
  [6857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1802),
  [6859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1801),
  [6861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1791),
  [6863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [6865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1769),
  [6867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [6869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1767),
  [6871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [6873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1766),
  [6875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [6877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1768),
  [6879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 4),
  [6881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 4),
  [6883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [6885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [6887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1942),
  [6889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1800),
  [6891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 4, .production_id = 119),
  [6893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2925),
  [6895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 4, .production_id = 119),
  [6897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [6899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2917),
  [6901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 5),
  [6903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 5),
  [6905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, .production_id = 168),
  [6907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, .production_id = 168),
  [6909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [6911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [6913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3287),
  [6915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [6917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [6919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [6921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3721),
  [6923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9102),
  [6925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, .production_id = 35), SHIFT(345),
  [6928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 3),
  [6930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 3),
  [6932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [6934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8610),
  [6936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [6938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [6940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [6942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3216),
  [6944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [6946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [6948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [6950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 2),
  [6952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 2),
  [6954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [6956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [6958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7026),
  [6960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6632),
  [6962] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT_REPEAT(8610),
  [6965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, .dynamic_precedence = 1),
  [6967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4219),
  [6969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3478),
  [6971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_virtual, 1),
  [6973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_virtual, 1),
  [6975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_number_literal, 1),
  [6977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_number_literal, 1),
  [6979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char_literal, 3),
  [6981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char_literal, 3),
  [6983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3402),
  [6985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8954),
  [6987] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, .production_id = 34), SHIFT(361),
  [6990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alignas_specifier, 4),
  [6992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alignas_specifier, 4),
  [6994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_declspec_modifier, 4),
  [6996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_declspec_modifier, 4),
  [6998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1712),
  [7000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1711),
  [7002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [7004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3703),
  [7006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6827),
  [7008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6827),
  [7010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4084),
  [7012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [7014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4292),
  [7016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1503),
  [7018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1504),
  [7020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [7022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [7024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1518),
  [7026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [7028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [7030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1534),
  [7032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1541),
  [7034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1567),
  [7036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [7038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [7040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1578),
  [7042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [7044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1501),
  [7046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1477),
  [7048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1478),
  [7050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [7052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [7054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1389),
  [7056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [7058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [7060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [7062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [7064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [7066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [7068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [7070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [7072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [7074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [7076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [7078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [7080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [7082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1572),
  [7084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1573),
  [7086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [7088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1580),
  [7090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [7092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [7094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4085),
  [7096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6823),
  [7098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6778),
  [7100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9723),
  [7102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1827),
  [7104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1828),
  [7106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [7108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [7110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1831),
  [7112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1832),
  [7114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1833),
  [7116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [7118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1835),
  [7120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [7122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1836),
  [7124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [7126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1829),
  [7128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1830),
  [7130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [7132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [7134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [7136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [7138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8659),
  [7140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [7142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3700),
  [7144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [7146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [7148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1703),
  [7150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1702),
  [7152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1794),
  [7154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [7156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1600),
  [7158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [7160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1602),
  [7162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [7164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [7166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1707),
  [7168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1706),
  [7170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1594),
  [7172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4094),
  [7174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3720),
  [7176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [7178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [7180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [7182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4045),
  [7184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9013),
  [7186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [7188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [7190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7047),
  [7192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [7194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [7196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__binary_fold_operator, 3, .production_id = 128),
  [7198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binary_fold_operator, 3, .production_id = 128),
  [7200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [7202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2885),
  [7204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [7206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [7208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [7210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4399),
  [7212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7462),
  [7214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4415),
  [7216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declarator, 1), REDUCE(sym__type_specifier, 1, .production_id = 1),
  [7219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [7221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8634),
  [7223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [7225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4113),
  [7227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4113),
  [7229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4020),
  [7231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9017),
  [7233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7477),
  [7235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4441),
  [7237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6758),
  [7239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4384),
  [7241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [7243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4372),
  [7245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4370),
  [7247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4075),
  [7249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4365),
  [7251] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT_REPEAT(8659),
  [7254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1), SHIFT(4256),
  [7257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3830),
  [7259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4407),
  [7261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3724),
  [7263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3724),
  [7265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3575),
  [7267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9434),
  [7269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4394),
  [7271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7441),
  [7273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3839),
  [7275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4379),
  [7277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3864),
  [7279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3864),
  [7281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3850),
  [7283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9019),
  [7285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, .production_id = 74), SHIFT(361),
  [7288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4349),
  [7290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4349),
  [7292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4159),
  [7294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9691),
  [7296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7459),
  [7298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3017),
  [7300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3017),
  [7302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2866),
  [7304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9713),
  [7306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7437),
  [7308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [7310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1751),
  [7312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [7314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [7316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1747),
  [7318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1746),
  [7320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [7322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [7324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1740),
  [7326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [7328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1739),
  [7330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1750),
  [7332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1749),
  [7334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [7336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [7338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6823),
  [7340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(2274),
  [7343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(3856),
  [7346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(9676),
  [7349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(8784),
  [7352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(9650),
  [7355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(3338),
  [7358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(9615),
  [7361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, .production_id = 74), SHIFT(351),
  [7364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6325),
  [7366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6325),
  [7368] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, .production_id = 74), SHIFT(289),
  [7371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3841),
  [7373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1925),
  [7375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1940),
  [7377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [7379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [7381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1935),
  [7383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1934),
  [7385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1932),
  [7387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [7389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [7391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [7393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1929),
  [7395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [7397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1939),
  [7399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1938),
  [7401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [7403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [7405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [7407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT_REPEAT(8634),
  [7410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6324),
  [7412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6324),
  [7414] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(3838),
  [7417] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(7896),
  [7420] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(8408),
  [7423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3911),
  [7425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__constructor_specifiers, 1), REDUCE(aux_sym__declaration_specifiers_repeat1, 1),
  [7428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constructor_specifiers, 1),
  [7430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__constructor_specifiers, 1),
  [7432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__constructor_specifiers, 1), REDUCE(aux_sym__declaration_specifiers_repeat1, 1),
  [7435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 1),
  [7437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3838),
  [7439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3936),
  [7441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1595),
  [7443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1593),
  [7445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [7447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [7449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1626),
  [7451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1622),
  [7453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1620),
  [7455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [7457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [7459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [7461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1618),
  [7463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [7465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [7467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1588),
  [7469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1627),
  [7471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [7473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [7475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6880),
  [7477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6880),
  [7479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1873),
  [7481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1882),
  [7483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [7485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [7487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1892),
  [7489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1904),
  [7491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [7493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [7495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1958),
  [7497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1961),
  [7499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [7501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [7503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1883),
  [7505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1889),
  [7507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [7509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [7511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4228),
  [7513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6863),
  [7515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6863),
  [7517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9190),
  [7519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3979),
  [7521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6066),
  [7523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6066),
  [7525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6627),
  [7527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4562),
  [7529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8886),
  [7531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4571),
  [7533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1509),
  [7535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1512),
  [7537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1513),
  [7539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1517),
  [7541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1523),
  [7543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [7545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [7547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1531),
  [7549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1537),
  [7551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1538),
  [7553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [7555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [7557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1548),
  [7559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [7561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1558),
  [7563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1559),
  [7565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1560),
  [7567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1561),
  [7569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8885),
  [7571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [7573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8876),
  [7575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8848),
  [7577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8870),
  [7579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8869),
  [7581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8866),
  [7583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8861),
  [7585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8860),
  [7587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8859),
  [7589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8855),
  [7591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8795),
  [7593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [7595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [7597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [7599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [7601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [7603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [7605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [7607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4565),
  [7609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3871),
  [7611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6006),
  [7613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6006),
  [7615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6577),
  [7617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4162),
  [7619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6611),
  [7621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3907),
  [7623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6076),
  [7625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6076),
  [7627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7418),
  [7629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3978),
  [7631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6052),
  [7633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6052),
  [7635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6646),
  [7637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [7639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4287),
  [7641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1), SHIFT(4563),
  [7644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4102),
  [7646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4619),
  [7648] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(3929),
  [7651] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(7850),
  [7654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(8412),
  [7657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4224),
  [7659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [7661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, .production_id = 21),
  [7663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6383),
  [7665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6383),
  [7667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [7669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9676),
  [7671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, .production_id = 21),
  [7673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7524),
  [7675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4387),
  [7677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, .production_id = 21), SHIFT(6920),
  [7680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6608),
  [7682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9654),
  [7684] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, .production_id = 21), SHIFT(6312),
  [7687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4250),
  [7689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3929),
  [7691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6801),
  [7693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, .production_id = 74), SHIFT(291),
  [7696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5122),
  [7698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6585),
  [7700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3781),
  [7702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3942),
  [7704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9421),
  [7706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [7708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5209),
  [7710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3991),
  [7712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6030),
  [7714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6030),
  [7716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [7718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [7720] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_specifier, 1), SHIFT(1303),
  [7723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6920),
  [7725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6312),
  [7727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4156),
  [7729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2947),
  [7731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4041),
  [7733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [7735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4145),
  [7737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5670),
  [7739] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, .production_id = 21), SHIFT(9394),
  [7742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, .production_id = 21), SHIFT(8735),
  [7745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5670),
  [7747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4375),
  [7749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6240),
  [7751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4025),
  [7753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [7755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [7757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6229),
  [7759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6247),
  [7761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6229),
  [7763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6247),
  [7765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_declaration, 2, .production_id = 106),
  [7767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5819),
  [7769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(4105),
  [7772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4211),
  [7774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, .production_id = 74), SHIFT(337),
  [7777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, .production_id = 21), SHIFT(6747),
  [7780] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, .production_id = 21), SHIFT(6240),
  [7783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [7785] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(4145),
  [7788] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(7794),
  [7791] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(8419),
  [7794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4276),
  [7796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2),
  [7798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2),
  [7800] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2), SHIFT_REPEAT(4003),
  [7803] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2), SHIFT_REPEAT(3883),
  [7806] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2), SHIFT_REPEAT(9213),
  [7809] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2), SHIFT_REPEAT(8406),
  [7812] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2), SHIFT_REPEAT(9215),
  [7815] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2), SHIFT_REPEAT(3884),
  [7818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2), SHIFT_REPEAT(9222),
  [7821] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2), SHIFT_REPEAT(5033),
  [7824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4131),
  [7826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4142),
  [7828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9394),
  [7830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, .production_id = 21), SHIFT(7524),
  [7833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4385),
  [7835] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(4235),
  [7838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1823),
  [7840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1819),
  [7842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [7844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [7846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1683),
  [7848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1650),
  [7850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1640),
  [7852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [7854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1625),
  [7856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [7858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1601),
  [7860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [7862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [7864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [7866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, .production_id = 21), SHIFT(8406),
  [7869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4470),
  [7871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6267),
  [7873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6308),
  [7875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6308),
  [7877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4235),
  [7879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5610),
  [7881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6613),
  [7883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7330),
  [7885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4272),
  [7887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4277),
  [7889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9540),
  [7891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [7893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4252),
  [7895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, .production_id = 35), SHIFT(355),
  [7898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4376),
  [7900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4433),
  [7902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2),
  [7904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2),
  [7906] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2), SHIFT_REPEAT(4645),
  [7909] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2), SHIFT_REPEAT(4646),
  [7912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, .production_id = 21), SHIFT(6267),
  [7915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4554),
  [7917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6310),
  [7919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6310),
  [7921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6629),
  [7923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5955),
  [7925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7343),
  [7927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5920),
  [7929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6963),
  [7931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6072),
  [7933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6068),
  [7935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6067),
  [7937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5779),
  [7939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4960),
  [7941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7349),
  [7943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4811),
  [7945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5490),
  [7947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6904),
  [7949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6074),
  [7951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5960),
  [7953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6054),
  [7955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5753),
  [7957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9485),
  [7959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5773),
  [7961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4463),
  [7963] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, .production_id = 21), SHIFT(6232),
  [7966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5379),
  [7968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7328),
  [7970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4950),
  [7972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5649),
  [7974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6958),
  [7976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6060),
  [7978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6057),
  [7980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6050),
  [7982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5957),
  [7984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9520),
  [7986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5733),
  [7988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7076),
  [7990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6650),
  [7992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4442),
  [7994] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, .production_id = 21), SHIFT(6268),
  [7997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4958),
  [7999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7322),
  [8001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6931),
  [8003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6091),
  [8005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6090),
  [8007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6079),
  [8009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5785),
  [8011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6268),
  [8013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [8015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5678),
  [8017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7325),
  [8019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5754),
  [8021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7371),
  [8023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6996),
  [8025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5993),
  [8027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5994),
  [8029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5995),
  [8031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5747),
  [8033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6232),
  [8035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [8037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6272),
  [8039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6222),
  [8041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [8043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4774),
  [8045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9170),
  [8047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4596),
  [8049] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(4530),
  [8052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4450),
  [8054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, .production_id = 21), SHIFT(6255),
  [8057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6255),
  [8059] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, .production_id = 35), SHIFT(358),
  [8062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4530),
  [8064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4580),
  [8066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4582),
  [8068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4557),
  [8070] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, .production_id = 35), SHIFT(346),
  [8073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [8075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4615),
  [8077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6215),
  [8079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6215),
  [8081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4645),
  [8083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4645),
  [8085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4646),
  [8087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [8089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7027),
  [8091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6515),
  [8093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_call_modifier, 1),
  [8095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_call_modifier, 1),
  [8097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4637),
  [8099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6212),
  [8101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6212),
  [8103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_pointer_modifier, 1),
  [8105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_pointer_modifier, 1),
  [8107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1),
  [8109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1),
  [8111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4657),
  [8113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6208),
  [8115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6208),
  [8117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6600),
  [8119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [8121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [8123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9596),
  [8125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [8127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [8129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4890),
  [8131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9182),
  [8133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4680),
  [8135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6221),
  [8137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6221),
  [8139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5569),
  [8141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4993),
  [8143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4994),
  [8145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [8147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declarator, 1),
  [8149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [8151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4462),
  [8153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6236),
  [8155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, .production_id = 21), SHIFT(6236),
  [8158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8735),
  [8160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4367),
  [8162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4717),
  [8164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6241),
  [8166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6241),
  [8168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, .production_id = 35), SHIFT(310),
  [8171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6555),
  [8173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4726),
  [8175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6313),
  [8177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6313),
  [8179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4392),
  [8181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4389),
  [8183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4730),
  [8185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6387),
  [8187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6387),
  [8189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6658),
  [8191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2), SHIFT_REPEAT(4993),
  [8194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2), SHIFT_REPEAT(4994),
  [8197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3856),
  [8199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9650),
  [8201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3115),
  [8203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9240),
  [8205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [8207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9615),
  [8209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7769),
  [8211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 1, .production_id = 56),
  [8213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4832),
  [8215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4832),
  [8217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [8219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [8221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [8223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5243),
  [8225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4874),
  [8227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1784),
  [8229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [8231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1783),
  [8233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [8235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1761),
  [8237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [8239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1757),
  [8241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [8243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [8245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [8247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [8249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [8251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1764),
  [8253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [8255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [8257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [8259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [8261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1772),
  [8263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4836),
  [8265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6509),
  [8267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6509),
  [8269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_reference_declarator, 1),
  [8271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4610),
  [8273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [8275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator, 3, .production_id = 134),
  [8277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 3, .production_id = 134),
  [8279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4212),
  [8281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6173),
  [8283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4899),
  [8285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4646),
  [8287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4213),
  [8289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4031),
  [8291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4860),
  [8293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6592),
  [8295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6592),
  [8297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 1, .production_id = 2),
  [8299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, .production_id = 18),
  [8301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5784),
  [8303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9058),
  [8305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3580),
  [8307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6159),
  [8309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4920),
  [8311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3584),
  [8313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3617),
  [8315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6585),
  [8317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2794),
  [8319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6177),
  [8321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4933),
  [8323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2785),
  [8325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7088),
  [8327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6160),
  [8329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4870),
  [8331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7022),
  [8333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4893),
  [8335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2900),
  [8337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3937),
  [8339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6184),
  [8341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4873),
  [8343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3931),
  [8345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4011),
  [8347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(4878),
  [8350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4880),
  [8352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4892),
  [8354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5111),
  [8356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4970),
  [8358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6674),
  [8360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6674),
  [8362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(2274),
  [8365] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(3856),
  [8368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(9676),
  [8371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(8440),
  [8374] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(9650),
  [8377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(3338),
  [8380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(9615),
  [8383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6710),
  [8385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1775),
  [8387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [8389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1777),
  [8391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [8393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [8395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1781),
  [8397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [8399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1785),
  [8401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [8403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1787),
  [8405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [8407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [8409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [8411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [8413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [8415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [8417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [8419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1895),
  [8421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [8423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1894),
  [8425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [8427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [8429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1867),
  [8431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [8433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1863),
  [8435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [8437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [8439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [8441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [8443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [8445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1888),
  [8447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1869),
  [8449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1864),
  [8451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [8453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5109),
  [8455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [8457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_start, 1),
  [8459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_start, 1),
  [8461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5615),
  [8463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5021),
  [8465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2477),
  [8467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [8469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6302),
  [8471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6302),
  [8473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5258),
  [8475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6305),
  [8477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6269),
  [8479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5943),
  [8481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9144),
  [8483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6303),
  [8485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6303),
  [8487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [8489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1630),
  [8491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [8493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1637),
  [8495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [8497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [8499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [8501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [8503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1653),
  [8505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [8507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1661),
  [8509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [8511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [8513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [8515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [8517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [8519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [8521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_function_specifier, 4),
  [8523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_function_specifier, 4),
  [8525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [8527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [8529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4505),
  [8531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5005),
  [8533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6707),
  [8535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6707),
  [8537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7162),
  [8539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6209),
  [8541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5011),
  [8543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6701),
  [8545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6701),
  [8547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7502),
  [8549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5022),
  [8551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6741),
  [8553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6741),
  [8555] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(5024),
  [8558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5027),
  [8560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6681),
  [8562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6681),
  [8564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6299),
  [8566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6148),
  [8568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6148),
  [8570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6144),
  [8572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6299),
  [8574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_function_specifier, 1),
  [8576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [8578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_function_specifier, 1),
  [8580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [8582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4107),
  [8584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5553),
  [8586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5540),
  [8588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [8590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1797),
  [8592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [8594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1924),
  [8596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [8598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [8600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [8602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [8604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1915),
  [8606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [8608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [8610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [8612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [8614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [8616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [8618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [8620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [8622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5579),
  [8624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [8626] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2), SHIFT(1553),
  [8629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comma_expression, 3, .production_id = 81),
  [8631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2),
  [8633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4486),
  [8635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6239),
  [8637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6238),
  [8639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6239),
  [8641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6238),
  [8643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5619),
  [8645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [8647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1670),
  [8649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [8651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1654),
  [8653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [8655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [8657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1590),
  [8659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [8661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1881),
  [8663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [8665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1969),
  [8667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [8669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [8671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4170),
  [8673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [8675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [8677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [8679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [8681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4391),
  [8683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4659),
  [8685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [8687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [8689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5180),
  [8691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [8693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [8695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7449),
  [8697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5095),
  [8699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4531),
  [8701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4260),
  [8703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [8705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4225),
  [8707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [8709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [8711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 4, .production_id = 171),
  [8713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4262),
  [8715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [8717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4150),
  [8719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4828),
  [8721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5614),
  [8723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3522),
  [8725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [8727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, .production_id = 18),
  [8729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4029),
  [8731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2715),
  [8733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [8735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7323),
  [8737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [8739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [8741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [8743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7489),
  [8745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3259),
  [8747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [8749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [8751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [8753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7306),
  [8755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [8757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4552),
  [8759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [8761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [8763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2908),
  [8765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [8767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4339),
  [8769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5587),
  [8771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3759),
  [8773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4318),
  [8775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [8777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [8779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5594),
  [8781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5593),
  [8783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [8785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3760),
  [8787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4458),
  [8789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [8791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1966),
  [8793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3182),
  [8795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, .production_id = 2),
  [8797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4837),
  [8799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4663),
  [8801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3770),
  [8803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5077),
  [8805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [8807] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_initializer_pair, 3, .production_id = 147), SHIFT(1553),
  [8810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, .production_id = 147),
  [8812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4491),
  [8814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitfield_clause, 2),
  [8816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2967),
  [8818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3792),
  [8820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5211),
  [8822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6761),
  [8824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6761),
  [8826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2987),
  [8828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [8830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5149),
  [8832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_declarator, 3, .production_id = 111),
  [8834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_declaration, 4, .production_id = 178),
  [8836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [8838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [8840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4203),
  [8842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [8844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4878),
  [8846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5228),
  [8848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [8850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [8852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1678),
  [8854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [8856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [8858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1684),
  [8860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [8862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1689),
  [8864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [8866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1696),
  [8868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [8870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [8872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [8874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [8876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [8878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [8880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [8882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [8884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, .dynamic_precedence = 1, .production_id = 182),
  [8886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [8888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [8890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, .dynamic_precedence = 1, .production_id = 180),
  [8892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5313),
  [8894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, .dynamic_precedence = 1, .production_id = 179),
  [8896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5315),
  [8898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [8900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [8902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter_declaration, 3, .production_id = 155),
  [8904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, .dynamic_precedence = 1, .production_id = 142),
  [8906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter_declaration, 4, .production_id = 189),
  [8908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, .dynamic_precedence = 1, .production_id = 143),
  [8910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [8912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [8914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [8916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [8918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [8920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [8922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 4),
  [8924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6890),
  [8926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8863),
  [8928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [8930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6975),
  [8932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8902),
  [8934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, .production_id = 148),
  [8936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [8938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3089),
  [8940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6907),
  [8942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9189),
  [8944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, .dynamic_precedence = 1),
  [8946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [8948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [8950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6554),
  [8952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6903),
  [8954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9137),
  [8956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6962),
  [8958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8916),
  [8960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6891),
  [8962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9092),
  [8964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [8966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [8968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [8970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [8972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [8974] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2), SHIFT_REPEAT(2274),
  [8977] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2), SHIFT_REPEAT(2274),
  [8980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [8982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6892),
  [8984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9330),
  [8986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [8988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [8990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [8992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [8994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_argument_list_repeat1, 2),
  [8996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6896),
  [8998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9591),
  [9000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [9002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [9004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 5, .dynamic_precedence = 1, .production_id = 194),
  [9006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [9008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [9010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [9012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 3),
  [9014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6897),
  [9016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9373),
  [9018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [9020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_lambda_capture_specifier_repeat1, 2),
  [9022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_start, 2),
  [9024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_start, 2),
  [9026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4451),
  [9028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4429),
  [9030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [9032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [9034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_range_loop_body, 5, .production_id = 195),
  [9036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4403),
  [9038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4401),
  [9040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4382),
  [9042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3970),
  [9044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [9046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4327),
  [9048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3367),
  [9050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5305),
  [9052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [9054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [9056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [9058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4416),
  [9060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4408),
  [9062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [9064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [9066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3559),
  [9068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [9070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [9072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [9074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4963),
  [9076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [9078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [9080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [9082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assignment_expression_lhs, 3, .production_id = 54),
  [9084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [9086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [9088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [9090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8371),
  [9092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3675),
  [9094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [9096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4015),
  [9098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [9100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4823),
  [9102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [9104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [9106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [9108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [9110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7671),
  [9112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2810),
  [9114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [9116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [9118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5494),
  [9120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6930),
  [9122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6930),
  [9124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4478),
  [9126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [9128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [9130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [9132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [9134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [9136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [9138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4099),
  [9140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8101),
  [9142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_declaration, 1),
  [9144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5746),
  [9146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [9148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [9150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [9152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6663),
  [9154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8380),
  [9156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4996),
  [9158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3824),
  [9160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [9162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4712),
  [9164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [9166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binary_fold, 3, .production_id = 82),
  [9168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [9170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [9172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_left_fold, 3, .production_id = 54),
  [9174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [9176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [9178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8294),
  [9180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [9182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [9184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [9186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [9188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_range_loop_body, 4, .production_id = 181),
  [9190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [9192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [9194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [9196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [9198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [9200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [9202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [9204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [9206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [9208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [9210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3518),
  [9212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [9214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4465),
  [9216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8244),
  [9218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [9220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [9222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5895),
  [9224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2),
  [9226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2),
  [9228] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(9676),
  [9231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [9233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5024),
  [9235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7062),
  [9237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6580),
  [9239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9532),
  [9241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [9243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6319),
  [9245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6326),
  [9247] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2), SHIFT_REPEAT(5670),
  [9250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2), SHIFT_REPEAT(5670),
  [9253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, .production_id = 21),
  [9255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, .production_id = 21),
  [9257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, .production_id = 21), SHIFT(6920),
  [9260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, .production_id = 21), SHIFT(6312),
  [9263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5618),
  [9265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [9267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5532),
  [9269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5600),
  [9271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4439),
  [9273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7337),
  [9275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3927),
  [9277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6994),
  [9279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5997),
  [9281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5998),
  [9283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6004),
  [9285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4850),
  [9287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9541),
  [9289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5803),
  [9291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4135),
  [9293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7347),
  [9295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6992),
  [9297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6008),
  [9299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6009),
  [9301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6010),
  [9303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5769),
  [9305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2819),
  [9307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7340),
  [9309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2580),
  [9311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6988),
  [9313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6013),
  [9315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6015),
  [9317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6017),
  [9319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3303),
  [9321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9547),
  [9323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5776),
  [9325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3028),
  [9327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7329),
  [9329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2692),
  [9331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6918),
  [9333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5977),
  [9335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5975),
  [9337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5961),
  [9339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3566),
  [9341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9398),
  [9343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5822),
  [9345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3036),
  [9347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7346),
  [9349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2751),
  [9351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6921),
  [9353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6023),
  [9355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6077),
  [9357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6078),
  [9359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3747),
  [9361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9503),
  [9363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5737),
  [9365] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(9394),
  [9368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, .production_id = 21), SHIFT(9394),
  [9371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, .production_id = 21), SHIFT(8735),
  [9374] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, .production_id = 21), SHIFT(6747),
  [9377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, .production_id = 21), SHIFT(6240),
  [9380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4056),
  [9382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7334),
  [9384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3594),
  [9386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6980),
  [9388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5965),
  [9390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5969),
  [9392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5959),
  [9394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4754),
  [9396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9533),
  [9398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5750),
  [9400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2689),
  [9402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7335),
  [9404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2332),
  [9406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6911),
  [9408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6094),
  [9410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6073),
  [9412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6045),
  [9414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2780),
  [9416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9424),
  [9418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5802),
  [9420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7031),
  [9422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6631),
  [9424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2687),
  [9426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2401),
  [9428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6961),
  [9430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5807),
  [9432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4683),
  [9434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7361),
  [9436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6957),
  [9438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6025),
  [9440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5972),
  [9442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5970),
  [9444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5811),
  [9446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [9448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3165),
  [9450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7350),
  [9452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2896),
  [9454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6917),
  [9456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6080),
  [9458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6087),
  [9460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6088),
  [9462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4030),
  [9464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9466),
  [9466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5790),
  [9468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [9470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, .production_id = 21), SHIFT(8406),
  [9473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, .production_id = 21), SHIFT(6267),
  [9476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, .production_id = 21), SHIFT(7524),
  [9479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, .production_id = 21),
  [9481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, .production_id = 21),
  [9483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4325),
  [9485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter_list, 2), REDUCE(sym_argument_list, 2),
  [9488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, .production_id = 21), SHIFT(6920),
  [9491] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, .production_id = 21), SHIFT(6312),
  [9494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, .production_id = 21), SHIFT(6268),
  [9497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, .production_id = 21), SHIFT(6232),
  [9500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6563),
  [9502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, .production_id = 21), SHIFT(6255),
  [9505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6640),
  [9507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6586),
  [9509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, .production_id = 21), SHIFT(9394),
  [9512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, .production_id = 21), SHIFT(8735),
  [9515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, .production_id = 21), SHIFT(6747),
  [9518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, .production_id = 21), SHIFT(6240),
  [9521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, .production_id = 21), SHIFT(8406),
  [9524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, .production_id = 21), SHIFT(7524),
  [9527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, .production_id = 21), SHIFT(6267),
  [9530] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2), SHIFT_REPEAT(5569),
  [9533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2), SHIFT_REPEAT(5569),
  [9536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_specifier, 1), SHIFT(1298),
  [9539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2), SHIFT_REPEAT(6148),
  [9542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2), SHIFT_REPEAT(6148),
  [9545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2), SHIFT_REPEAT(6144),
  [9548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, .production_id = 21), SHIFT(6236),
  [9551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1), SHIFT(5985),
  [9554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1), SHIFT(5989),
  [9557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1), SHIFT(2251),
  [9560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, .production_id = 21), SHIFT(6268),
  [9563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6518),
  [9565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, .production_id = 21), SHIFT(6232),
  [9568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5966),
  [9570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4326),
  [9572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4989),
  [9574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3055),
  [9576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3727),
  [9578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .production_id = 16), SHIFT(2450),
  [9581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, .production_id = 2), SHIFT(2450),
  [9584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4725),
  [9586] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, .production_id = 21), SHIFT(6255),
  [9589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .production_id = 36), SHIFT(5999),
  [9592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, .production_id = 18), SHIFT(5990),
  [9595] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2), REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT(2450),
  [9599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, .production_id = 18), SHIFT(2450),
  [9602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4296),
  [9604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4579),
  [9606] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, .dynamic_precedence = -1, .production_id = 36), SHIFT(2450),
  [9609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7365),
  [9611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4532),
  [9613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5655),
  [9615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2881),
  [9617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3100),
  [9619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4174),
  [9621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 2, .production_id = 18),
  [9623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 2, .production_id = 18),
  [9625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2400),
  [9627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5234),
  [9629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 1, .production_id = 2),
  [9631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 1, .production_id = 2),
  [9633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5691),
  [9635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5641),
  [9637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3242),
  [9639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, .production_id = 21),
  [9641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, .production_id = 21),
  [9643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT_REPEAT(8406),
  [9646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, .production_id = 21), SHIFT(6920),
  [9649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, .production_id = 21), SHIFT(6312),
  [9652] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_specifier, 1), SHIFT(5968),
  [9655] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, .production_id = 21), SHIFT(9394),
  [9658] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, .production_id = 21), SHIFT(8735),
  [9661] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, .production_id = 21), SHIFT(6747),
  [9664] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, .production_id = 21), SHIFT(6240),
  [9667] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, .production_id = 21), SHIFT(6236),
  [9670] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, .production_id = 21), SHIFT(8406),
  [9673] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, .production_id = 21), SHIFT(7524),
  [9676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, .production_id = 21), SHIFT(6267),
  [9679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 3, .production_id = 18),
  [9681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 3, .production_id = 18),
  [9683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 2, .production_id = 2),
  [9685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 2, .production_id = 2),
  [9687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [9689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [9691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4971),
  [9693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7811),
  [9695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [9697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [9699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4322),
  [9701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7733),
  [9703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, .production_id = 21), SHIFT(6268),
  [9706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [9708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [9710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4489),
  [9712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7827),
  [9714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [9716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [9718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4078),
  [9720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7784),
  [9722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [9724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [9726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5566),
  [9728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7877),
  [9730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [9732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [9734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2913),
  [9736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7726),
  [9738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [9740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [9742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5048),
  [9744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7814),
  [9746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [9748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [9750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3832),
  [9752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7703),
  [9754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4961),
  [9756] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, .production_id = 21), SHIFT(6232),
  [9759] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, .production_id = 21), SHIFT(6255),
  [9762] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2), SHIFT_REPEAT(6299),
  [9765] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2), SHIFT_REPEAT(6299),
  [9768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6320),
  [9770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9078),
  [9772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6224),
  [9774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8568),
  [9776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6257),
  [9778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6257),
  [9780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6451),
  [9782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6451),
  [9784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7958),
  [9786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6603),
  [9788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6502),
  [9790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [9792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4581),
  [9794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6401),
  [9796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6289),
  [9798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8493),
  [9800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6233),
  [9802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6233),
  [9804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6652),
  [9806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6652),
  [9808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8339),
  [9810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [9812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4158),
  [9814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [9816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6968),
  [9818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7719),
  [9820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6937),
  [9822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2045),
  [9824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [9826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7269),
  [9828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7804),
  [9830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [9832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5125),
  [9834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5056),
  [9836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6572),
  [9838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7199),
  [9840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6623),
  [9842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2449),
  [9844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7339),
  [9846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2690),
  [9848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4160),
  [9850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4973),
  [9852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8130),
  [9854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6696),
  [9856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [9858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7359),
  [9860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4218),
  [9862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4449),
  [9864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8274),
  [9866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [9868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7120),
  [9870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [9872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [9874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [9876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [9878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [9880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [9882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8689),
  [9884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6531),
  [9886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6571),
  [9888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6973),
  [9890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4576),
  [9892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [9894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [9896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [9898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8632),
  [9900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [9902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9183),
  [9904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6278),
  [9906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8287),
  [9908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1104),
  [9910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [9912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [9914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [9916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8609),
  [9918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [9920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2965),
  [9922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6614),
  [9924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2966),
  [9926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2663),
  [9928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4955),
  [9930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4972),
  [9932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [9934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [9936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [9938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8590),
  [9940] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, .production_id = 21), SHIFT(6236),
  [9943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [9945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4286),
  [9947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4239),
  [9949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7368),
  [9951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [9953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6791),
  [9955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7901),
  [9957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5155),
  [9959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7174),
  [9961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7360),
  [9963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5568),
  [9965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__preproc_expression, 1),
  [9967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6220),
  [9969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__preproc_expression, 1),
  [9971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6985),
  [9973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [9975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3691),
  [9977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3777),
  [9979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_end, 1),
  [9981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_end, 1),
  [9983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6803),
  [9985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6800),
  [9987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_end, 2),
  [9989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_end, 2),
  [9991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_qualifier, 1),
  [9993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_qualifier, 1),
  [9995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6219),
  [9997] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [9999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6322),
  [10001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6573),
  [10003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6304),
  [10005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6301),
  [10007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6301),
  [10009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6300),
  [10011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6298),
  [10013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6294),
  [10015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6293),
  [10017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6287),
  [10019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6284),
  [10021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6281),
  [10023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6281),
  [10025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6280),
  [10027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9048),
  [10029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7364),
  [10031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7980),
  [10033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6504),
  [10035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [10037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 2),
  [10039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 2),
  [10041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [10043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3673),
  [10045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9527),
  [10047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6443),
  [10049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8338),
  [10051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3620),
  [10053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1993),
  [10055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9649),
  [10057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6446),
  [10059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8358),
  [10061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3632),
  [10063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4685),
  [10065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8378),
  [10067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3364),
  [10069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9453),
  [10071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6453),
  [10073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8375),
  [10075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3595),
  [10077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [10079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5941),
  [10081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [10083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [10085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [10087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [10089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [10091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7497),
  [10093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1991),
  [10095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8871),
  [10097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6457),
  [10099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8296),
  [10101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3552),
  [10103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2215),
  [10105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8970),
  [10107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6459),
  [10109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8061),
  [10111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3618),
  [10113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [10115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [10117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8421),
  [10119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call_expression, 2, .production_id = 26),
  [10121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call_expression, 2, .production_id = 26),
  [10123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [10125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [10127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3626),
  [10129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6471),
  [10131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8098),
  [10133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2405),
  [10135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6473),
  [10137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8250),
  [10139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3477),
  [10141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6474),
  [10143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7942),
  [10145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2742),
  [10147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6475),
  [10149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8112),
  [10151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [10153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [10155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8773),
  [10157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 4),
  [10159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 4),
  [10161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [10163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [10165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8724),
  [10167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4812),
  [10169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8037),
  [10171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_binary_expression, 3, .production_id = 54),
  [10173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_binary_expression, 3, .production_id = 54),
  [10175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [10177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [10179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1990),
  [10181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6497),
  [10183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8205),
  [10185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [10187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8455),
  [10189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_parenthesized_expression, 3),
  [10191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_parenthesized_expression, 3),
  [10193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 2),
  [10195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 2),
  [10197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3489),
  [10199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6503),
  [10201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8285),
  [10203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3611),
  [10205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 3),
  [10207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 3),
  [10209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2),
  [10211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [10213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [10215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [10217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [10219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [10221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8739),
  [10223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 4),
  [10225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 4),
  [10227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2249),
  [10229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6511),
  [10231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8043),
  [10233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_unary_expression, 2, .production_id = 4),
  [10235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_unary_expression, 2, .production_id = 4),
  [10237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4320),
  [10239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, .production_id = 21),
  [10241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 5, .production_id = 21),
  [10243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, .production_id = 21), SHIFT(6747),
  [10246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, .production_id = 21), SHIFT(6267),
  [10249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_specifier, 5),
  [10251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_specifier, 5),
  [10253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4981),
  [10255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6314),
  [10257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6265),
  [10259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6274),
  [10261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6273),
  [10263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, .production_id = 21),
  [10265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 6, .production_id = 21),
  [10267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6249),
  [10269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7562),
  [10271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6248),
  [10273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6264),
  [10275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6246),
  [10277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [10279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6230),
  [10281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6237),
  [10283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6244),
  [10285] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, .production_id = 21), SHIFT(6240),
  [10288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [10290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [10292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3582),
  [10294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_specifier, 4),
  [10296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_specifier, 4),
  [10298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [10300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7381),
  [10302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_postfix_repeat1, 2),
  [10304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__function_postfix_repeat1, 2),
  [10306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_postfix_repeat1, 2), SHIFT_REPEAT(6747),
  [10309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5529),
  [10311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_postfix, 1),
  [10313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_postfix, 1),
  [10315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6261),
  [10317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6286),
  [10319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6275),
  [10321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6766),
  [10323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8252),
  [10325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [10327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7260),
  [10329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3062),
  [10331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5836),
  [10333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2675),
  [10335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4123),
  [10337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6501),
  [10339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [10341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_noexcept, 1),
  [10343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [10345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_noexcept, 1),
  [10347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_specifier, 3),
  [10349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_specifier, 3),
  [10351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_noexcept, 3),
  [10353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_noexcept, 3),
  [10355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7825),
  [10357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6616),
  [10359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8386),
  [10361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [10363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [10365] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, .production_id = 21), SHIFT(6747),
  [10368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, .production_id = 21), SHIFT(6240),
  [10371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2872),
  [10373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5050),
  [10375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3107),
  [10377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [10379] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, .production_id = 21), SHIFT(6267),
  [10382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7417),
  [10384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5559),
  [10386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3010),
  [10388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7222),
  [10390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [10392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7407),
  [10394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8317),
  [10396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_end, 3),
  [10398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_end, 3),
  [10400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3941),
  [10402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2783),
  [10404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7373),
  [10406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6607),
  [10408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [10410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4622),
  [10412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2571),
  [10414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_noexcept, 4),
  [10416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_noexcept, 4),
  [10418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [10420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [10422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, .production_id = 21), SHIFT(6920),
  [10425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, .production_id = 21), SHIFT(6312),
  [10428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT_REPEAT(8735),
  [10431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3),
  [10433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 3),
  [10435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [10437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [10439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6721),
  [10441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7727),
  [10443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8422),
  [10445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [10447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6311),
  [10449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, .production_id = 21),
  [10451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 7, .production_id = 21),
  [10453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 2, .production_id = 22),
  [10455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_function_declarator, 2, .production_id = 22),
  [10457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [10459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [10461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7139),
  [10463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 1),
  [10465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 4),
  [10467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_parenthesized_declarator, 4),
  [10469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 3),
  [10471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_parenthesized_declarator, 3),
  [10473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [10475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, .production_id = 121),
  [10477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 3, .production_id = 121),
  [10479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, .production_id = 116),
  [10481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 4, .production_id = 116),
  [10483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [10485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, .production_id = 24),
  [10487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 3, .production_id = 24),
  [10489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trailing_return_type, 2),
  [10491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trailing_return_type, 2),
  [10493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, .production_id = 24),
  [10495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 4, .production_id = 24),
  [10497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 2),
  [10499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 2),
  [10501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(6721),
  [10504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(7727),
  [10507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(8422),
  [10510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, .production_id = 169),
  [10512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 4, .production_id = 169),
  [10514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [10516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [10518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 1, .production_id = 33),
  [10520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_function_declarator, 1, .production_id = 33),
  [10522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [10524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__abstract_declarator, 1),
  [10526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__abstract_declarator, 1),
  [10528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [10530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [10532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_virtual_specifier, 1),
  [10534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_virtual_specifier, 1),
  [10536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 5, .production_id = 167),
  [10538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 5, .production_id = 167),
  [10540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [10542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6680),
  [10544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6838),
  [10546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_postfix_repeat1, 2), SHIFT_REPEAT(6920),
  [10549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, .production_id = 21), SHIFT(6920),
  [10552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, .production_id = 21), SHIFT(6312),
  [10555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, .production_id = 5),
  [10557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3694),
  [10559] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(9707),
  [10562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7015),
  [10564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7567),
  [10566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6329),
  [10568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6328),
  [10570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, .production_id = 21), SHIFT(6232),
  [10573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, .production_id = 39),
  [10575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [10577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7424),
  [10579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7545),
  [10581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7584),
  [10583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6331),
  [10585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9098),
  [10587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 4, .dynamic_precedence = 1, .production_id = 84),
  [10589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 4, .production_id = 129),
  [10591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, .dynamic_precedence = 1, .production_id = 41),
  [10593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, .production_id = 62),
  [10595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, .production_id = 80),
  [10597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_reference_declarator, 2),
  [10599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, .dynamic_precedence = 1, .production_id = 5),
  [10601] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT_REPEAT(8440),
  [10604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3395),
  [10606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7100),
  [10608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7610),
  [10610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, .production_id = 5),
  [10612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [10614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [10616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2814),
  [10618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7024),
  [10620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7556),
  [10622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3986),
  [10624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7097),
  [10626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7597),
  [10628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, .production_id = 21), SHIFT(6268),
  [10631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__class_declaration_repeat1, 2),
  [10633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__class_declaration_repeat1, 2), SHIFT_REPEAT(9213),
  [10636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__class_declaration_repeat1, 2),
  [10638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__class_declaration_repeat1, 2), SHIFT_REPEAT(9222),
  [10641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7043),
  [10643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7609),
  [10645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 5, .dynamic_precedence = 1, .production_id = 165),
  [10647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 4, .dynamic_precedence = 1, .production_id = 84),
  [10649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 4, .dynamic_precedence = 1, .production_id = 84),
  [10651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7121),
  [10653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, .production_id = 21), SHIFT(6268),
  [10656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7170),
  [10658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7189),
  [10660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7138),
  [10662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7140),
  [10664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7172),
  [10666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 3, .dynamic_precedence = 1, .production_id = 41),
  [10668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, .production_id = 21), SHIFT(6255),
  [10671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 5, .dynamic_precedence = 1, .production_id = 165),
  [10673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7185),
  [10675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [10677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 3, .dynamic_precedence = 1, .production_id = 41),
  [10679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6235),
  [10681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_declarator, 2),
  [10683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_declarator, 2),
  [10685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_declarator, 2, .dynamic_precedence = 1),
  [10687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 2, .dynamic_precedence = 1, .production_id = 5),
  [10689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7190),
  [10691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7148),
  [10693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7137),
  [10695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7159),
  [10697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7196),
  [10699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7187),
  [10701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6234),
  [10703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, .production_id = 21), SHIFT(6232),
  [10706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6323),
  [10708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6251),
  [10710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7194),
  [10712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7124),
  [10714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7131),
  [10716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7143),
  [10718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7167),
  [10720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7166),
  [10722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7144),
  [10724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7125),
  [10726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_field_declarator, 2, .dynamic_precedence = 1),
  [10728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 2, .dynamic_precedence = 1, .production_id = 5),
  [10730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [10732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8709),
  [10734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7028),
  [10736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7898),
  [10738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8003),
  [10740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6283),
  [10742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9049),
  [10744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [10746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9544),
  [10748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [10750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [10752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8765),
  [10754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7816),
  [10756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3972),
  [10758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [10760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [10762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8604),
  [10764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7783),
  [10766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5875),
  [10768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [10770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8847),
  [10772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3230),
  [10774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3851),
  [10776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [10778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [10780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9448),
  [10782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4816),
  [10784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2835),
  [10786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structured_binding_declarator, 3, .dynamic_precedence = -1),
  [10788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_structured_binding_declarator, 3, .dynamic_precedence = -1),
  [10790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3891),
  [10792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4838),
  [10794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7461),
  [10796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7030),
  [10798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 4, .dynamic_precedence = -10),
  [10800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_declarator, 4, .dynamic_precedence = -10),
  [10802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7570),
  [10804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7620),
  [10806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5882),
  [10808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 3, .production_id = 24),
  [10810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 3, .production_id = 24),
  [10812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [10814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [10816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8463),
  [10818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7731),
  [10820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [10822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8679),
  [10824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7638),
  [10826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [10828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [10830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8817),
  [10832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [10834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3343),
  [10836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 3, .dynamic_precedence = -10),
  [10838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_declarator, 3, .dynamic_precedence = -10),
  [10840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [10842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3113),
  [10844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [10846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9312),
  [10848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4721),
  [10850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5743),
  [10852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3519),
  [10854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9315),
  [10856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 2, .dynamic_precedence = 1, .production_id = 22),
  [10858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 2, .dynamic_precedence = 1, .production_id = 22),
  [10860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, .production_id = 21), SHIFT(6236),
  [10863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5741),
  [10865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [10867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8681),
  [10869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7866),
  [10871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4713),
  [10873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [10875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [10877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8761),
  [10879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7935),
  [10881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, .production_id = 24),
  [10883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, .production_id = 24),
  [10885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [10887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, .production_id = 116),
  [10889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, .production_id = 116),
  [10891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [10893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [10895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [10897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [10899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8653),
  [10901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7842),
  [10903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [10905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [10907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8626),
  [10909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7803),
  [10911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3912),
  [10913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 5, .production_id = 167),
  [10915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 5, .production_id = 167),
  [10917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3408),
  [10919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9385),
  [10921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9069),
  [10923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3591),
  [10925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structured_binding_declarator, 4, .dynamic_precedence = -1),
  [10927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_structured_binding_declarator, 4, .dynamic_precedence = -1),
  [10929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9100),
  [10931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [10933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3622),
  [10935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [10937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [10939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1),
  [10941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [10943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1),
  [10945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6316),
  [10947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6315),
  [10949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_field_declarator, 2),
  [10951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_field_declarator, 2),
  [10953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1, .production_id = 98),
  [10955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1, .production_id = 98),
  [10957] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, .production_id = 21), SHIFT(6255),
  [10960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6243),
  [10962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 5, .production_id = 167),
  [10964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 5, .production_id = 167),
  [10966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_field_declarator, 2, .dynamic_precedence = 1, .production_id = 22),
  [10968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_field_declarator, 2, .dynamic_precedence = 1, .production_id = 22),
  [10970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7431),
  [10972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7324),
  [10974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7527),
  [10976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 2, .production_id = 8),
  [10978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6331),
  [10980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7509),
  [10982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7398),
  [10984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7333),
  [10986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7429),
  [10988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7354),
  [10990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7400),
  [10992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7367),
  [10994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7430),
  [10996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7345),
  [10998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, .production_id = 24),
  [11000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, .production_id = 24),
  [11002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, .production_id = 116),
  [11004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, .production_id = 116),
  [11006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7538),
  [11008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7639),
  [11010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6260),
  [11012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9335),
  [11014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 4, .dynamic_precedence = -10),
  [11016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_field_declarator, 4, .dynamic_precedence = -10),
  [11018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 3, .dynamic_precedence = -10),
  [11020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_field_declarator, 3, .dynamic_precedence = -10),
  [11022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7422),
  [11024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7358),
  [11026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 3, .production_id = 24),
  [11028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 3, .production_id = 24),
  [11030] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, .production_id = 21), SHIFT(6236),
  [11033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7492),
  [11035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 3, .production_id = 78),
  [11037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7403),
  [11039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7336),
  [11041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2), SHIFT_REPEAT(8003),
  [11044] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2), SHIFT_REPEAT(6318),
  [11047] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2), SHIFT_REPEAT(9051),
  [11050] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2), SHIFT_REPEAT(8392),
  [11053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2),
  [11055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6242),
  [11057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7379),
  [11059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7369),
  [11061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7378),
  [11063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7332),
  [11065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9339),
  [11067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7637),
  [11069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6223),
  [11071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9341),
  [11073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scope_resolution, 1),
  [11075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution, 1),
  [11077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1778),
  [11079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5628),
  [11081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1709),
  [11083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5662),
  [11085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1774),
  [11087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5665),
  [11089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, .production_id = 66),
  [11091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [11093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [11095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1717),
  [11097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5629),
  [11099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1815),
  [11101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5638),
  [11103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1822),
  [11105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5622),
  [11107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1592),
  [11109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1756),
  [11111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1811),
  [11113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5620),
  [11115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1734),
  [11117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5637),
  [11119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2923),
  [11121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7357),
  [11123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [11125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 1),
  [11127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9274),
  [11129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1789),
  [11131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1964),
  [11133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5661),
  [11135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1845),
  [11137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5650),
  [11139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1668),
  [11141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1735),
  [11143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5653),
  [11145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 1),
  [11147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9378),
  [11149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6569),
  [11151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_declarators, 1, .production_id = 24),
  [11153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4949),
  [11155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8771),
  [11157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 3),
  [11159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 3),
  [11161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_designator, 3),
  [11163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7704),
  [11165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5664),
  [11167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8718),
  [11169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4057),
  [11171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8746),
  [11173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8278),
  [11175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7705),
  [11177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9467),
  [11179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5319),
  [11181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8748),
  [11183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3037),
  [11185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8715),
  [11187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5663),
  [11189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8673),
  [11191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7748),
  [11193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7919),
  [11195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4281),
  [11197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8671),
  [11199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2355),
  [11201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8457),
  [11203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7669),
  [11205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4553),
  [11207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8588),
  [11209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3758),
  [11211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8431),
  [11213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2440),
  [11215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8480),
  [11217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2897),
  [11219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8512),
  [11221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8104),
  [11223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9234),
  [11225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8056),
  [11227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8935),
  [11229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5669),
  [11231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8571),
  [11233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7948),
  [11235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8917),
  [11237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7805),
  [11239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3091),
  [11241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8688),
  [11243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4592),
  [11245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3225),
  [11247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8490),
  [11249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, .production_id = 5),
  [11251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4232),
  [11253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7870),
  [11255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3012),
  [11257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8559),
  [11259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7716),
  [11261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6689),
  [11263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8782),
  [11265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6321),
  [11267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4707),
  [11269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8307),
  [11271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9602),
  [11273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7775),
  [11275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6317),
  [11277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7897),
  [11279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6260),
  [11281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7243),
  [11283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [11285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [11287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4438),
  [11289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [11291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4421),
  [11293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 2, .production_id = 8),
  [11295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6223),
  [11297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7534),
  [11299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scope_resolution, 2, .production_id = 13),
  [11301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution, 2, .production_id = 13),
  [11303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 3, .production_id = 8),
  [11305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7044),
  [11307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scope_resolution, 2, .production_id = 31),
  [11309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution, 2, .production_id = 31),
  [11311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7239),
  [11313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2), SHIFT_REPEAT(7424),
  [11316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2),
  [11318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2),
  [11320] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2), SHIFT_REPEAT(8003),
  [11323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2),
  [11325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2),
  [11327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9402),
  [11329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7541),
  [11331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [11333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7029),
  [11335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast, 3, .production_id = 58),
  [11337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [11339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [11341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [11343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4466),
  [11345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [11347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [11349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4444),
  [11351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [11353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [11355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4377),
  [11357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [11359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 4, .production_id = 78),
  [11361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [11363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [11365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 3, .production_id = 78),
  [11367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [11369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4369),
  [11371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [11373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 1, .production_id = 6),
  [11375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator, 1, .production_id = 6),
  [11377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [11379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 4, .production_id = 78),
  [11381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [11383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4374),
  [11385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [11387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4414),
  [11389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [11391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4452),
  [11393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [11395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 3, .production_id = 8),
  [11397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8015),
  [11399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7571),
  [11401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8831),
  [11403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3610),
  [11405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [11407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [11409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9044),
  [11411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8123),
  [11413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3995),
  [11415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [11417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7840),
  [11419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2726),
  [11421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 5),
  [11423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 5),
  [11425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7735),
  [11427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7854),
  [11429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [11431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 1),
  [11433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7519),
  [11435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 1),
  [11437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4072),
  [11439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8133),
  [11441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8350),
  [11443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7000),
  [11445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 4),
  [11447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 4),
  [11449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 6),
  [11451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 6),
  [11453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8088),
  [11455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7086),
  [11457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3984),
  [11459] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2), SHIFT_REPEAT(1804),
  [11462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2),
  [11464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2), SHIFT_REPEAT(9044),
  [11467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7777),
  [11469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4048),
  [11471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7831),
  [11473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_expression_repeat1, 2),
  [11475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_expression_repeat1, 2), SHIFT_REPEAT(7909),
  [11478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, .production_id = 8),
  [11480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, .production_id = 8),
  [11482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [11484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [11486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, .production_id = 126),
  [11488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, .production_id = 126),
  [11490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [11492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [11494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [11496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [11498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6843),
  [11500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7909),
  [11502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6844),
  [11504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6828),
  [11506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6832),
  [11508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [11510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [11512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [11514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [11516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6841),
  [11518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [11520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [11522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6852),
  [11524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 4, .production_id = 78),
  [11526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 4, .production_id = 78),
  [11528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6846),
  [11530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [11532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [11534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6851),
  [11536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [11538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [11540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [11542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [11544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [11546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [11548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, .production_id = 79),
  [11550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, .production_id = 79),
  [11552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6874),
  [11554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6810),
  [11556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6872),
  [11558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [11560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [11562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [11564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [11566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [11568] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2), SHIFT_REPEAT(7527),
  [11571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [11573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [11575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6862),
  [11577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [11579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [11581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 6, .production_id = 172),
  [11583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 6, .production_id = 172),
  [11585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2),
  [11587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6857),
  [11589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [11591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [11593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 3, .production_id = 8),
  [11595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 3, .production_id = 8),
  [11597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [11599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [11601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, .production_id = 78),
  [11603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, .production_id = 78),
  [11605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6836),
  [11607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6868),
  [11609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [11611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [11613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6860),
  [11615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [11617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [11619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6813),
  [11621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 5, .production_id = 127),
  [11623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 5, .production_id = 127),
  [11625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6808),
  [11627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8767),
  [11629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8600),
  [11631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7929),
  [11633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6702),
  [11635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [11637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6965),
  [11639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_access_specifier, 1),
  [11641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_access_specifier, 1),
  [11643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8513),
  [11645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [11647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6705),
  [11649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8755),
  [11651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [11653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [11655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8145),
  [11657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [11659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [11661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [11663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [11665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [11667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [11669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [11671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8579),
  [11673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [11675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list, 1),
  [11677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [11679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, .production_id = 6),
  [11681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9226),
  [11683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7623),
  [11685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2458),
  [11687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [11689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [11691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [11693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [11695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8624),
  [11697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [11699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [11701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8747),
  [11703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2599),
  [11705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [11707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8708),
  [11709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [11711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [11713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [11715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8502),
  [11717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [11719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [11721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [11723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [11725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [11727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [11729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [11731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [11733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8569),
  [11735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6952),
  [11737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8246),
  [11739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter_declaration, 4, .production_id = 188),
  [11741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [11743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter_declaration, 3, .production_id = 154),
  [11745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [11747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7385),
  [11749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 3, .production_id = 185),
  [11751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4386),
  [11753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3615),
  [11755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7738),
  [11757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [11759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [11761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3038),
  [11763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7728),
  [11765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7728),
  [11767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list_no_comma, 1),
  [11769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4396),
  [11771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [11773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list_no_comma, 2),
  [11775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2910),
  [11777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list, 2),
  [11779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4412),
  [11781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5003),
  [11783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2921),
  [11785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7646),
  [11787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7646),
  [11789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [11791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8305),
  [11793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9415),
  [11795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [11797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8663),
  [11799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [11801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2827),
  [11803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7915),
  [11805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7915),
  [11807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [11809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2684),
  [11811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7807),
  [11813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7807),
  [11815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [11817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3270),
  [11819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7852),
  [11821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7852),
  [11823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4417),
  [11825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [11827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [11829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [11831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [11833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8459),
  [11835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8469),
  [11837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [11839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4427),
  [11841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8247),
  [11843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3525),
  [11845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_operator_cast_identifier, 2, .production_id = 34),
  [11847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [11849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2877),
  [11851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7700),
  [11853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7700),
  [11855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [11857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9661),
  [11859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [11861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8395),
  [11863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2902),
  [11865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7813),
  [11867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7813),
  [11869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [11871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4426),
  [11873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [11875] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, .production_id = 177), SHIFT_REPEAT(6710),
  [11878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, .production_id = 177),
  [11880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8749),
  [11882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8531),
  [11884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 2, .production_id = 150),
  [11886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2642),
  [11888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4419),
  [11890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [11892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7724),
  [11894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7724),
  [11896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [11898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7562),
  [11900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [11902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9585),
  [11904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2879),
  [11906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [11908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9211),
  [11910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4464),
  [11912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [11914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2656),
  [11916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9641),
  [11918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7766),
  [11920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7766),
  [11922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6919),
  [11924] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, .production_id = 197), SHIFT_REPEAT(7385),
  [11927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, .production_id = 197),
  [11929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3892),
  [11931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [11933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8222),
  [11935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6584),
  [11937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 4),
  [11939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [11941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [11943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4473),
  [11945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [11947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3257),
  [11949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4109),
  [11951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2094),
  [11953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [11955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6912),
  [11957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7706),
  [11959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7706),
  [11961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2),
  [11963] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(7728),
  [11966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(7728),
  [11969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [11971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9119),
  [11973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__namespace_specifier, 1, .production_id = 17),
  [11975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7582),
  [11977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [11979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9766),
  [11981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_char_literal_repeat1, 2),
  [11983] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_char_literal_repeat1, 2), SHIFT_REPEAT(7738),
  [11986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8540),
  [11988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8712),
  [11990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8290),
  [11992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 5),
  [11994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7401),
  [11996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 3, .production_id = 185),
  [11998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4446),
  [12000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2874),
  [12002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [12004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4591),
  [12006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7755),
  [12008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7755),
  [12010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [12012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4467),
  [12014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4577),
  [12016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [12018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4018),
  [12020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [12022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6570),
  [12024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8666),
  [12026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8453),
  [12028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9684),
  [12030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3040),
  [12032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7636),
  [12034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7636),
  [12036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5590),
  [12038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8167),
  [12040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_declarator, 1),
  [12042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [12044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4729),
  [12046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [12048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [12050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7600),
  [12052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [12054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [12056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [12058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 2, .production_id = 150),
  [12060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7310),
  [12062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6830),
  [12064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 2, .production_id = 198),
  [12066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4558),
  [12068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7843),
  [12070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7843),
  [12072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [12074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [12076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, .production_id = 91),
  [12078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [12080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9054),
  [12082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3471),
  [12084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [12086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [12088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8640),
  [12090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8517),
  [12092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2694),
  [12094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_declarators, 2, .production_id = 87),
  [12096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [12098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2868),
  [12100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7745),
  [12102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7745),
  [12104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2903),
  [12106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4457),
  [12108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3066),
  [12110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, .production_id = 114), SHIFT_REPEAT(6569),
  [12113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, .production_id = 114),
  [12115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [12117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4871),
  [12119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [12121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [12123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7557),
  [12125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2594),
  [12127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [12129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8701),
  [12131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8542),
  [12133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, .production_id = 197), SHIFT_REPEAT(7401),
  [12136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, .production_id = 197),
  [12138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3351),
  [12140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4775),
  [12142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7603),
  [12144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8780),
  [12146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8597),
  [12148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4545),
  [12150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4778),
  [12152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4121),
  [12154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7922),
  [12156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7922),
  [12158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3068),
  [12160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7820),
  [12162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7820),
  [12164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8260),
  [12166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 2),
  [12168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4363),
  [12170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7871),
  [12172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7871),
  [12174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3262),
  [12176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7563),
  [12178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [12180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [12182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4430),
  [12184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 3, .production_id = 205),
  [12186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4076),
  [12188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6496),
  [12190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4737),
  [12192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4656),
  [12194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7893),
  [12196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7893),
  [12198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [12200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [12202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4423),
  [12204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [12206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8934),
  [12208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [12210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [12212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4655),
  [12214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2811),
  [12216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7903),
  [12218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7903),
  [12220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4476),
  [12222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4432),
  [12224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4440),
  [12226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [12228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [12230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5253),
  [12232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4617),
  [12234] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, .production_id = 209), SHIFT_REPEAT(6830),
  [12237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, .production_id = 209),
  [12239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4354),
  [12241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7906),
  [12243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7906),
  [12245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [12247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [12249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2773),
  [12251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [12253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [12255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2820),
  [12257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [12259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4361),
  [12261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [12263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_qualifier, 1),
  [12265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [12267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9124),
  [12269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2985),
  [12271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2823),
  [12273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [12275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4974),
  [12277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [12279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4040),
  [12281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7862),
  [12283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7862),
  [12285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4090),
  [12287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8122),
  [12289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 3),
  [12291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5399),
  [12293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [12295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [12297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [12299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2779),
  [12301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7900),
  [12303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7900),
  [12305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [12307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8505),
  [12309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4183),
  [12311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7320),
  [12313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [12315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8584),
  [12317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3601),
  [12319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [12321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2883),
  [12323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3786),
  [12325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [12327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [12329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [12331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [12333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6218),
  [12335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4189),
  [12337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4184),
  [12339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7305),
  [12341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8585),
  [12343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [12345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [12347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [12349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6581),
  [12351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8598),
  [12353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7863),
  [12355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [12357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [12359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [12361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8714),
  [12363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3837),
  [12365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [12367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7456),
  [12369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [12371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [12373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [12375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [12377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3842),
  [12379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3843),
  [12381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [12383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [12385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [12387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8706),
  [12389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6790),
  [12391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9314),
  [12393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [12395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [12397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7375),
  [12399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7924),
  [12401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2964),
  [12403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2893),
  [12405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5058),
  [12407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4215),
  [12409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6700),
  [12411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3845),
  [12413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3847),
  [12415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4217),
  [12417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3849),
  [12419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8478),
  [12421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3852),
  [12423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8538),
  [12425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7799),
  [12427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3854),
  [12429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8768),
  [12431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [12433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8544),
  [12435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 2),
  [12437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [12439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7040),
  [12441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 3),
  [12443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8685),
  [12445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8526),
  [12447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7458),
  [12449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [12451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [12453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4207),
  [12455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4206),
  [12457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5592),
  [12459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4152),
  [12461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7883),
  [12463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5537),
  [12465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4200),
  [12467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3640),
  [12469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4197),
  [12471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8533),
  [12473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 2, .production_id = 98),
  [12475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5200),
  [12477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5550),
  [12479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, .production_id = 114), SHIFT_REPEAT(5941),
  [12482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, .production_id = 114),
  [12484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [12486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [12488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2791),
  [12490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5196),
  [12492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5193),
  [12494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5190),
  [12496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5189),
  [12498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3784),
  [12500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [12502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [12504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7723),
  [12506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7548),
  [12508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [12510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9300),
  [12512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [12514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8693),
  [12516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(1323),
  [12519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7476),
  [12521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3956),
  [12523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3198),
  [12525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [12527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7759),
  [12529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5591),
  [12531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5570),
  [12533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3204),
  [12535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8754),
  [12537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5182),
  [12539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5179),
  [12541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_namespace_specifier, 3),
  [12543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7591),
  [12545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [12547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [12549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [12551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8684),
  [12553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [12555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7312),
  [12557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [12559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [12561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7892),
  [12563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2660),
  [12565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [12567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2655),
  [12569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2807),
  [12571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [12573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [12575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [12577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter_declaration, 2, .production_id = 66),
  [12579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [12581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [12583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4616),
  [12585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7313),
  [12587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7311),
  [12589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7309),
  [12591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6767),
  [12593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [12595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [12597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5160),
  [12599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8757),
  [12601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7824),
  [12603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7708),
  [12605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4100),
  [12607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7649),
  [12609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5541),
  [12611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5539),
  [12613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7838),
  [12615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7631),
  [12617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3947),
  [12619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8514),
  [12621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 2),
  [12623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8775),
  [12625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8547),
  [12627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_type_parameter_declaration, 2),
  [12629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [12631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [12633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [12635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8622),
  [12637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [12639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [12641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [12643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4490),
  [12645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2860),
  [12647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4598),
  [12649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 2), SHIFT_REPEAT(6584),
  [12652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4814),
  [12654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4599),
  [12656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4110),
  [12658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [12660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [12662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [12664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [12666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7475),
  [12668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_declarator, 2, .production_id = 68),
  [12670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_declaration, 3, .production_id = 138),
  [12672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8593),
  [12674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3630),
  [12676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2), SHIFT_REPEAT(1293),
  [12679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7555),
  [12681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [12683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4638),
  [12685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7108),
  [12687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4633),
  [12689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, .dynamic_precedence = 3),
  [12691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2), SHIFT_REPEAT(393),
  [12694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2),
  [12696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2944),
  [12698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2841),
  [12700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [12702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_reference_declarator, 2),
  [12704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_parameter_list_repeat1, 2), SHIFT_REPEAT(2053),
  [12707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_parameter_list_repeat1, 2),
  [12709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3530),
  [12711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [12713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_namespace_specifier, 2),
  [12715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_designator, 2, .production_id = 104),
  [12717] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requires_parameter_list_repeat1, 2), SHIFT_REPEAT(2071),
  [12720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_requires_parameter_list_repeat1, 2),
  [12722] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2), SHIFT_REPEAT(2066),
  [12725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2),
  [12727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3835),
  [12729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [12731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4411),
  [12733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6556),
  [12735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8675),
  [12737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5093),
  [12739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4333),
  [12741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [12743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [12745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3917),
  [12747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3540),
  [12749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3541),
  [12751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3542),
  [12753] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2), SHIFT_REPEAT(7040),
  [12756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2),
  [12758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_declarator, 2),
  [12760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subscript_argument_list_repeat1, 2), SHIFT_REPEAT(1457),
  [12763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4335),
  [12765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4055),
  [12767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [12769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4336),
  [12771] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2), SHIFT_REPEAT(6322),
  [12774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4337),
  [12776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4340),
  [12778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2), SHIFT_REPEAT(8685),
  [12781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2),
  [12783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [12785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [12787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [12789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5582),
  [12791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [12793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [12795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4524),
  [12797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5558),
  [12799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [12801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [12803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [12805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [12807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [12809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [12811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [12813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3861),
  [12815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [12817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [12819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4285),
  [12821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4548),
  [12823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [12825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8643),
  [12827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6510),
  [12829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4002),
  [12831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [12833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4344),
  [12835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4176),
  [12837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4346),
  [12839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [12841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [12843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4518),
  [12845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2953),
  [12847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [12849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [12851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [12853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3227),
  [12855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [12857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8485),
  [12859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 3),
  [12861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [12863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2940),
  [12865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2484),
  [12867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2939),
  [12869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [12871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__namespace_specifier, 2, .production_id = 59),
  [12873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [12875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [12877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [12879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2928),
  [12881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [12883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [12885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [12887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [12889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4360),
  [12891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [12893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4604),
  [12895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4613),
  [12897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3547),
  [12899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3144),
  [12901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6517),
  [12903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4163),
  [12905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3981),
  [12907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6812),
  [12909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [12911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4242),
  [12913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [12915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2719),
  [12917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [12919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [12921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 6),
  [12923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8898),
  [12925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4587),
  [12927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4584),
  [12929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4516),
  [12931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4508),
  [12933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 3, .production_id = 5),
  [12935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3994),
  [12937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 3, .production_id = 191),
  [12939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4506),
  [12941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7025),
  [12943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7605),
  [12945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4521),
  [12947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_lambda_capture_specifier_repeat1, 2), SHIFT_REPEAT(1759),
  [12950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [12952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3290),
  [12954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [12956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [12958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [12960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8462),
  [12962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 4),
  [12964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3750),
  [12966] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_structured_binding_declarator_repeat1, 2), SHIFT_REPEAT(9091),
  [12969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_structured_binding_declarator_repeat1, 2),
  [12971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3765),
  [12973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4092),
  [12975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [12977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [12979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [12981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [12983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_range_designator, 5, .production_id = 196),
  [12985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, .production_id = 150),
  [12987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4012),
  [12989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [12991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [12993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [12995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [12997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3141),
  [12999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3070),
  [13001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5575),
  [13003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8057),
  [13005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8633),
  [13007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2864),
  [13009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [13011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 2),
  [13013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4317),
  [13015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [13017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8402),
  [13019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8400),
  [13021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5603),
  [13023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8398),
  [13025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8397),
  [13027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7486),
  [13029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8424),
  [13031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4641),
  [13033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5589),
  [13035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5586),
  [13037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5581),
  [13039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5578),
  [13041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_throw_specifier_repeat1, 2), SHIFT_REPEAT(4411),
  [13044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_throw_specifier_repeat1, 2),
  [13046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2), SHIFT_REPEAT(8584),
  [13049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2),
  [13051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5612),
  [13053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [13055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [13057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [13059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [13061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8394),
  [13063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8393),
  [13065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [13067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4126),
  [13069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7763),
  [13071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8449),
  [13073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 5),
  [13075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4456),
  [13077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4455),
  [13079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4454),
  [13081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4453),
  [13083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 7),
  [13085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8448),
  [13087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4624),
  [13089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2858),
  [13091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand, 4, .production_id = 204),
  [13093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, .production_id = 150),
  [13095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7918),
  [13097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3705),
  [13099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9655),
  [13101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 2, .production_id = 206),
  [13103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4201),
  [13105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3706),
  [13107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8699),
  [13109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4644),
  [13111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4654),
  [13113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4594),
  [13115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4639),
  [13117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [13119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 2), SHIFT_REPEAT(4391),
  [13122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 2),
  [13124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [13126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [13128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [13130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand, 4, .production_id = 204),
  [13132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, .production_id = 198),
  [13134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 3, .production_id = 210),
  [13136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, .production_id = 212), SHIFT_REPEAT(9655),
  [13139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, .production_id = 212),
  [13141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3619),
  [13143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [13145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand, 7, .production_id = 213),
  [13147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7551),
  [13149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8396),
  [13151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand, 7, .production_id = 213),
  [13153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [13155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [13157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2979),
  [13159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [13161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8263),
  [13163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7535),
  [13165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [13167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9431),
  [13169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [13171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9404),
  [13173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9562),
  [13175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9760),
  [13177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7586),
  [13179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9560),
  [13181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9759),
  [13183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9558),
  [13185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9758),
  [13187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9556),
  [13189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9757),
  [13191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9554),
  [13193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9756),
  [13195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9552),
  [13197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9755),
  [13199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9550),
  [13201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9754),
  [13203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9548),
  [13205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9753),
  [13207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9543),
  [13209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9752),
  [13211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9535),
  [13213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9751),
  [13215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9526),
  [13217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9750),
  [13219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9510),
  [13221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9748),
  [13223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8652),
  [13225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9492),
  [13227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9745),
  [13229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9474),
  [13231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9742),
  [13233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9455),
  [13235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9739),
  [13237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, .production_id = 206),
  [13239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9433),
  [13241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9736),
  [13243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [13245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9619),
  [13247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9410),
  [13249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9733),
  [13251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [13253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [13255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 6),
  [13257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3992),
  [13259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [13261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8821),
  [13263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8445),
  [13265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [13267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8893),
  [13269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8880),
  [13271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8996),
  [13273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8992),
  [13275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [13277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9245),
  [13279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9730),
  [13281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8356),
  [13283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 1),
  [13285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8677),
  [13287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [13289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [13291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9477),
  [13293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [13295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9502),
  [13297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [13299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9610),
  [13301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [13303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8725),
  [13305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3095),
  [13307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6636),
  [13309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9617),
  [13311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [13313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9346),
  [13315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8446),
  [13317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [13319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5728),
  [13321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 4),
  [13323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 4),
  [13325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [13327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, .production_id = 98),
  [13329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2801),
  [13331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 3, .production_id = 163),
  [13333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3301),
  [13335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3),
  [13337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [13339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9265),
  [13341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_type_parameter_declaration, 3, .production_id = 153),
  [13343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, .dynamic_precedence = 2),
  [13345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [13347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [13349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9228),
  [13351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8738),
  [13353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_template_parameter_declaration, 3, .production_id = 57),
  [13355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6441),
  [13357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9383),
  [13359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8621),
  [13361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [13363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9115),
  [13365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [13367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, .production_id = 6),
  [13369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8474),
  [13371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [13373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [13375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [13377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8896),
  [13379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8894),
  [13381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [13383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9287),
  [13385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [13387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8969),
  [13389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3634),
  [13391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4819),
  [13393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9143),
  [13395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9138),
  [13397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 2),
  [13399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 2),
  [13401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 4, .production_id = 91),
  [13403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [13405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9356),
  [13407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9355),
  [13409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [13411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9142),
  [13413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_pack_expansion, 2, .production_id = 28),
  [13415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [13417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9007),
  [13419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8489),
  [13421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8389),
  [13423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9618),
  [13425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9580),
  [13427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9640),
  [13429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9512),
  [13431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 3),
  [13433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 3),
  [13435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8527),
  [13437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8563),
  [13439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4719),
  [13441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [13443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9270),
  [13445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9275),
  [13447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [13449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8603),
  [13451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8574),
  [13453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [13455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8879),
  [13457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [13459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8500),
  [13461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [13463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8510),
  [13465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [13467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8944),
  [13469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5869),
  [13471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9539),
  [13473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9523),
  [13475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9120),
  [13477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9132),
  [13479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8783),
  [13481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [13483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8937),
  [13485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8648),
  [13487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9322),
  [13489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [13491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [13493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [13495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [13497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9171),
  [13499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [13501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4196),
  [13503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [13505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [13507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [13509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5055),
  [13511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9286),
  [13513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [13515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5054),
  [13517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4202),
  [13519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2175),
  [13521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [13523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9316),
  [13525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5053),
  [13527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [13529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [13531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [13533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [13535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2602),
  [13537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [13539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2875),
  [13541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [13543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2628),
  [13545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5533),
  [13547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [13549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [13551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [13553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [13555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [13557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [13559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [13561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8229),
  [13563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [13565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7737),
  [13567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [13569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [13571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [13573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3855),
  [13575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9197),
  [13577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9699),
  [13579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3853),
  [13581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6888),
  [13583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [13585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [13587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4214),
  [13589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3976),
  [13591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [13593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6894),
  [13595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5604),
  [13597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [13599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [13601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [13603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [13605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9066),
  [13607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [13609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4093),
  [13611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9746),
  [13613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9298),
  [13615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [13617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [13619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [13621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9423),
  [13623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [13625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [13627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9173),
  [13629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [13631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [13633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [13635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9136),
  [13637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3484),
  [13639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8911),
  [13641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9425),
  [13643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [13645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [13647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_parameter_list, 3),
  [13649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2887),
  [13651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [13653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9010),
  [13655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [13657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [13659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4140),
  [13661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [13663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8895),
  [13665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5913),
  [13667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3982),
  [13669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [13671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [13673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [13675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [13677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7910),
  [13679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [13681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5929),
  [13683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [13685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4182),
  [13687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9004),
  [13689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3755),
  [13691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [13693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9016),
  [13695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [13697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [13699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [13701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7798),
  [13703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [13705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3924),
  [13707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [13709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [13711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [13713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [13715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4771),
  [13717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [13719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [13721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [13723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9053),
  [13725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [13727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [13729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2986),
  [13731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4480),
  [13733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [13735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4572),
  [13737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9280),
  [13739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4569),
  [13741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [13743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [13745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7630),
  [13747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4290),
  [13749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [13751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [13753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9328),
  [13755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [13757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [13759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6477),
  [13761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [13763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3896),
  [13765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9572),
  [13767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8683),
  [13769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [13771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8942),
  [13773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [13775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [13777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [13779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9436),
  [13781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9018),
  [13783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9450),
  [13785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [13787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7679),
  [13789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [13791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [13793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9590),
  [13795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6798),
  [13797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2971),
  [13799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [13801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6797),
  [13803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6759),
  [13805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3869),
  [13807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4937),
  [13809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [13811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [13813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2978),
  [13815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [13817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [13819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [13821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5538),
  [13823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [13825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9633),
  [13827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [13829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [13831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [13833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9601),
  [13835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [13837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4151),
  [13839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9587),
  [13841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [13843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [13845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3829),
  [13847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [13849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [13851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [13853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9570),
  [13855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [13857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3828),
  [13859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3827),
  [13861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9537),
  [13863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7653),
  [13865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8149),
  [13867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4935),
  [13869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef, 3, .production_id = 79),
  [13871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [13873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6809),
  [13875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7238),
  [13877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9083),
  [13879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [13881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [13883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4620),
  [13885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9354),
  [13887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6525),
  [13889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [13891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5205),
  [13893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5543),
  [13895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9256),
  [13897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5199),
  [13899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9103),
  [13901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3386),
  [13903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [13905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [13907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9329),
  [13909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3280),
  [13911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9272),
  [13913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [13915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [13917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3787),
  [13919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9073),
  [13921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2843),
  [13923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4627),
  [13925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9313),
  [13927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [13929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7701),
  [13931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [13933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [13935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [13937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8473),
  [13939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [13941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [13943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [13945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2943),
  [13947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [13949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3772),
  [13951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7221),
  [13953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7518),
  [13955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [13957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4931),
  [13959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9135),
  [13961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3607),
  [13963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9331),
  [13965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_based_modifier, 2),
  [13967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4927),
  [13969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9155),
  [13971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9097),
  [13973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [13975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9106),
  [13977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9090),
  [13979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [13981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [13983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [13985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [13987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [13989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4914),
  [13991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9076),
  [13993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [13995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4494),
  [13997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9068),
  [13999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [14001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7873),
  [14003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [14005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [14007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [14009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4497),
  [14011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9152),
  [14013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [14015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [14017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [14019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [14021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [14023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [14025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8892),
  [14027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [14029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [14031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3589),
  [14033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2641),
  [14035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [14037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3642),
  [14039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8857),
  [14041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3761),
  [14043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3699),
  [14045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [14047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [14049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [14051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [14053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [14055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8846),
  [14057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [14059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [14061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8974),
  [14063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3003),
  [14065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [14067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5556),
  [14069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8995),
  [14071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [14073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9005),
  [14075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [14077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9110),
  [14079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3885),
  [14081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [14083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9126),
  [14085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [14087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9134),
  [14089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [14091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [14093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8273),
  [14095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9304),
  [14097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9334),
  [14099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9348),
  [14101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4172),
  [14103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9382),
  [14105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9345),
  [14107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2696),
  [14109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9487),
  [14111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9508),
  [14113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9575),
  [14115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9576),
  [14117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9645),
  [14119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9651),
  [14121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9717),
  [14123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9721),
  [14125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9737),
  [14127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9079),
  [14129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9764),
  [14131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9763),
  [14133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [14135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4098),
  [14137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8438),
  [14139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4097),
  [14141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9656),
  [14143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [14145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7091),
  [14147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4096),
  [14149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4472),
  [14151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [14153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [14155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4095),
  [14157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [14159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7797),
  [14161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [14163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [14165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [14167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [14169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8816),
  [14171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4493),
  [14173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8499),
  [14175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9399),
  [14177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9495),
  [14179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3439),
  [14181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3114),
  [14183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [14185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [14187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9365),
  [14189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6582),
  [14191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6583),
  [14193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4938),
  [14195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6587),
  [14197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2884),
  [14199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [14201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [14203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [14205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5133),
  [14207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7635),
  [14209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [14211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9282),
  [14213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [14215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [14217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [14219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [14221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [14223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [14225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4640),
  [14227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [14229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9374),
  [14231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [14233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [14235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [14237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9233),
  [14239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9377),
  [14241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9241),
  [14243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [14245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8851),
  [14247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [14249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4147),
  [14251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4148),
  [14253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2954),
  [14255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [14257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4153),
  [14259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [14261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5010),
  [14263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [14265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [14267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [14269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [14271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9386),
  [14273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [14275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_parameter_list, 4),
  [14277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [14279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3311),
  [14281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [14283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9302),
  [14285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [14287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [14289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4331),
  [14291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4334),
  [14293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [14295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [14297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4600),
  [14299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [14301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2667),
  [14303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [14305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 4, .production_id = 126),
  [14307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef, 4, .production_id = 127),
  [14309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2652),
  [14311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5100),
  [14313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [14315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7494),
  [14317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9392),
  [14319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [14321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [14323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4566),
  [14325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4628),
  [14327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [14329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 4, .production_id = 79),
  [14331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [14333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [14335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3065),
  [14337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7377),
  [14339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7552),
  [14341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [14343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 4, .production_id = 8),
  [14345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [14347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7380),
  [14349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9428),
  [14351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [14353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2878),
  [14355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [14357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2618),
  [14359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [14361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [14363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [14365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [14367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [14369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9375),
  [14371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [14373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [14375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [14377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2924),
  [14379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8901),
  [14381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [14383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [14385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [14387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [14389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7540),
  [14391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5772),
  [14393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5176),
  [14395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9522),
  [14397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9524),
  [14399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [14401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [14403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [14405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8968),
  [14407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [14409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4028),
  [14411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [14413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 5, .production_id = 172),
  [14415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5018),
  [14417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 5, .production_id = 126),
  [14419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [14421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8752),
  [14423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [14425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4475),
  [14427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [14429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [14431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8924),
  [14433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [14435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7533),
  [14437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 5, .production_id = 78),
  [14439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8774),
  [14441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [14443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8792),
  [14445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [14447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9577),
  [14449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 3, .production_id = 79),
  [14451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [14453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8843),
  [14455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 3, .production_id = 79),
  [14457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [14459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8800),
  [14461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [14463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [14465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4916),
  [14467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8808),
  [14469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [14471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [14473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [14475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8770),
  [14477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4437),
  [14479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8873),
  [14481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [14483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8906),
  [14485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8758),
  [14487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 5, .production_id = 127),
  [14489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8883),
  [14491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [14493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [14495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8890),
  [14497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8903),
  [14499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4589),
  [14501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_parameter_list, 2),
  [14503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [14505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8910),
  [14507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [14509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [14511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 3, .production_id = 79),
  [14513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8717),
  [14515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4404),
  [14517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [14519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [14521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [14523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8707),
  [14525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [14527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8964),
  [14529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4529),
  [14531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3698),
  [14533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [14535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8971),
  [14537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8981),
  [14539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4559),
  [14541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [14543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [14545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8986),
  [14547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [14549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [14551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8687),
  [14553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4431),
  [14555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [14557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [14559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [14561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8676),
  [14563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9020),
  [14565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [14567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [14569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9026),
  [14571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9035),
  [14573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [14575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [14577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9040),
  [14579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [14581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [14583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8657),
  [14585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4397),
  [14587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [14589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [14591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2929),
  [14593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4512),
  [14595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9064),
  [14597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [14599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [14601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [14603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9070),
  [14605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8786),
  [14607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [14609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9242),
  [14611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [14613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9084),
  [14615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [14617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8630),
  [14619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4418),
  [14621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [14623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [14625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9108),
  [14627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [14629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4522),
  [14631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [14633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9114),
  [14635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9122),
  [14637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [14639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3716),
  [14641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [14643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9127),
  [14645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [14647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4264),
  [14649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8607),
  [14651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4268),
  [14653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [14655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4271),
  [14657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8349),
  [14659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7550),
  [14661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [14663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9153),
  [14665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4246),
  [14667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [14669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9164),
  [14671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8404),
  [14673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8587),
  [14675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [14677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [14679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9174),
  [14681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8401),
  [14683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2092),
  [14685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9177),
  [14687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [14689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8581),
  [14691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [14693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4643),
  [14695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9185),
  [14697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [14699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9187),
  [14701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8575),
  [14703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [14705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9192),
  [14707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9193),
  [14709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9195),
  [14711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9196),
  [14713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9198),
  [14715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9199),
  [14717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9200),
  [14719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9201),
  [14721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9202),
  [14723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9203),
  [14725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9204),
  [14727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9205),
  [14729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9206),
  [14731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9207),
  [14733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9208),
  [14735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9209),
  [14737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4789),
  [14739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3133),
  [14741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [14743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [14745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9244),
  [14747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [14749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4358),
  [14751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4887),
  [14753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [14755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2880),
  [14757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2882),
  [14759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 6, .production_id = 172),
  [14761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 4, .production_id = 126),
  [14763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 4, .production_id = 126),
  [14765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [14767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7693),
  [14769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9278),
  [14771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [14773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [14775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 4, .production_id = 127),
  [14777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 4, .production_id = 127),
  [14779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [14781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [14783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, .production_id = 126),
  [14785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 4, .production_id = 127),
  [14787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4749),
  [14789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [14791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8983),
  [14793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3863),
  [14795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [14797] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [14799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4329),
  [14801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [14803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8801),
  [14805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [14807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [14809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [14811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9675),
  [14813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5597),
  [14815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [14817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [14819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [14821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [14823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9059),
  [14825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [14827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [14829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [14831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2806),
  [14833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [14835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4477),
  [14837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4364),
  [14839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8958),
  [14841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [14843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [14845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [14847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5136),
  [14849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [14851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5114),
  [14853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9671),
  [14855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4605),
  [14857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 5, .production_id = 172),
  [14859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 5, .production_id = 172),
  [14861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 5, .production_id = 172),
  [14863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5116),
  [14865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [14867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [14869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [14871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [14873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4448),
  [14875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [14877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [14879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9409),
  [14881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2920),
  [14883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9107),
  [14885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4447),
  [14887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7884),
  [14889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9417),
  [14891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4255),
  [14893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8437),
  [14895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9067),
  [14897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [14899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [14901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9432),
  [14903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [14905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [14907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7869),
  [14909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9439),
  [14911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8377),
  [14913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [14915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [14917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9454),
  [14919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [14921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4146),
  [14923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7641),
  [14925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9460),
  [14927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4932),
  [14929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9664),
  [14931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8613),
  [14933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [14935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9473),
  [14937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4226),
  [14939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7656),
  [14941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9479),
  [14943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [14945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [14947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9491),
  [14949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7925),
  [14951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9497),
  [14953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [14955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9509),
  [14957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3993),
  [14959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7699),
  [14961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9515),
  [14963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [14965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [14967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9525),
  [14969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2637),
  [14971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7729),
  [14973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9530),
  [14975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7747),
  [14977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9538),
  [14979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9734),
  [14981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9545),
  [14983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9549),
  [14985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9551),
  [14987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4352),
  [14989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9553),
  [14991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9157),
  [14993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9555),
  [14995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4353),
  [14997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9557),
  [14999] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1), SHIFT(9725),
  [15002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9559),
  [15004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9561),
  [15006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9563),
  [15008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4381),
  [15010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9584),
  [15012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4400),
  [15014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9653),
  [15016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_right_fold, 3, .production_id = 54),
  [15018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4402),
  [15020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9663),
  [15022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2842),
  [15024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4410),
  [15026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9673),
  [15028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [15030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4445),
  [15032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9682),
  [15034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7732),
  [15036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4474),
  [15038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9690),
  [15040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9603),
  [15042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4443),
  [15044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9698),
  [15046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [15048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9705),
  [15050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9709),
  [15052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9712),
  [15054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9714),
  [15056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9716),
  [15058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9718),
  [15060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9720),
  [15062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9722),
  [15064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9724),
  [15066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9726),
  [15068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9728),
  [15070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [15072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4928),
  [15074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2786),
  [15076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2765),
  [15078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [15080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [15082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7698),
  [15084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [15086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [15088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [15090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [15092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [15094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [15096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token_raw_string_delimiter = 0,
  ts_external_token_raw_string_content = 1,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_raw_string_delimiter] = sym_raw_string_delimiter,
  [ts_external_token_raw_string_content] = sym_raw_string_content,
};

static const bool ts_external_scanner_states[4][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_raw_string_delimiter] = true,
    [ts_external_token_raw_string_content] = true,
  },
  [2] = {
    [ts_external_token_raw_string_delimiter] = true,
  },
  [3] = {
    [ts_external_token_raw_string_content] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_arduino_external_scanner_create(void);
void tree_sitter_arduino_external_scanner_destroy(void *);
bool tree_sitter_arduino_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_arduino_external_scanner_serialize(void *, char *);
void tree_sitter_arduino_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_arduino() {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_arduino_external_scanner_create,
      tree_sitter_arduino_external_scanner_destroy,
      tree_sitter_arduino_external_scanner_scan,
      tree_sitter_arduino_external_scanner_serialize,
      tree_sitter_arduino_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
